(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}(g.jsTraverse || (g.jsTraverse = {})).traverse = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var traverse = module.exports = function (obj) {
    return new Traverse(obj);
};

function Traverse (obj) {
    this.value = obj;
}

Traverse.prototype.get = function (ps) {
    var node = this.value;
    for (var i = 0; i < ps.length; i ++) {
        var key = ps[i];
        if (!node || !hasOwnProperty.call(node, key)) {
            node = undefined;
            break;
        }
        node = node[key];
    }
    return node;
};

Traverse.prototype.has = function (ps) {
    var node = this.value;
    for (var i = 0; i < ps.length; i ++) {
        var key = ps[i];
        if (!node || !hasOwnProperty.call(node, key)) {
            return false;
        }
        node = node[key];
    }
    return true;
};

Traverse.prototype.set = function (ps, value) {
    var node = this.value;
    for (var i = 0; i < ps.length - 1; i ++) {
        var key = ps[i];
        if (!hasOwnProperty.call(node, key)) node[key] = {};
        node = node[key];
    }
    node[ps[i]] = value;
    return value;
};

Traverse.prototype.map = function (cb) {
    return walk(this.value, cb, true);
};

Traverse.prototype.forEach = function (cb) {
    this.value = walk(this.value, cb, false);
    return this.value;
};

Traverse.prototype.reduce = function (cb, init) {
    var skip = arguments.length === 1;
    var acc = skip ? this.value : init;
    this.forEach(function (x) {
        if (!this.isRoot || !skip) {
            acc = cb.call(this, acc, x);
        }
    });
    return acc;
};

Traverse.prototype.paths = function () {
    var acc = [];
    this.forEach(function (x) {
        acc.push(this.path); 
    });
    return acc;
};

Traverse.prototype.nodes = function () {
    var acc = [];
    this.forEach(function (x) {
        acc.push(this.node);
    });
    return acc;
};

Traverse.prototype.clone = function () {
    var parents = [], nodes = [];
    
    return (function clone (src) {
        for (var i = 0; i < parents.length; i++) {
            if (parents[i] === src) {
                return nodes[i];
            }
        }
        
        if (typeof src === 'object' && src !== null) {
            var dst = copy(src);
            
            parents.push(src);
            nodes.push(dst);
            
            forEach(objectKeys(src), function (key) {
                dst[key] = clone(src[key]);
            });
            
            parents.pop();
            nodes.pop();
            return dst;
        }
        else {
            return src;
        }
    })(this.value);
};

function walk (root, cb, immutable) {
    var path = [];
    var parents = [];
    var alive = true;
    
    return (function walker (node_) {
        var node = immutable ? copy(node_) : node_;
        var modifiers = {};
        
        var keepGoing = true;
        
        var state = {
            node : node,
            node_ : node_,
            path : [].concat(path),
            parent : parents[parents.length - 1],
            parents : parents,
            key : path.slice(-1)[0],
            isRoot : path.length === 0,
            level : path.length,
            circular : null,
            update : function (x, stopHere) {
                if (!state.isRoot) {
                    state.parent.node[state.key] = x;
                }
                state.node = x;
                if (stopHere) keepGoing = false;
            },
            'delete' : function (stopHere) {
                delete state.parent.node[state.key];
                if (stopHere) keepGoing = false;
            },
            remove : function (stopHere) {
                if (isArray(state.parent.node)) {
                    state.parent.node.splice(state.key, 1);
                }
                else {
                    delete state.parent.node[state.key];
                }
                if (stopHere) keepGoing = false;
            },
            keys : null,
            before : function (f) { modifiers.before = f },
            after : function (f) { modifiers.after = f },
            pre : function (f) { modifiers.pre = f },
            post : function (f) { modifiers.post = f },
            stop : function () { alive = false },
            block : function () { keepGoing = false }
        };
        
        if (!alive) return state;
        
        function updateState() {
            if (typeof state.node === 'object' && state.node !== null) {
                if (!state.keys || state.node_ !== state.node) {
                    state.keys = objectKeys(state.node)
                }
                
                state.isLeaf = state.keys.length == 0;
                
                for (var i = 0; i < parents.length; i++) {
                    if (parents[i].node_ === node_) {
                        state.circular = parents[i];
                        break;
                    }
                }
            }
            else {
                state.isLeaf = true;
                state.keys = null;
            }
            
            state.notLeaf = !state.isLeaf;
            state.notRoot = !state.isRoot;
        }
        
        updateState();
        
        // use return values to update if defined
        var ret = cb.call(state, state.node);
        if (ret !== undefined && state.update) state.update(ret);
        
        if (modifiers.before) modifiers.before.call(state, state.node);
        
        if (!keepGoing) return state;
        
        if (typeof state.node == 'object'
        && state.node !== null && !state.circular) {
            parents.push(state);
            
            updateState();
            
            forEach(state.keys, function (key, i) {
                path.push(key);
                
                if (modifiers.pre) modifiers.pre.call(state, state.node[key], key);
                
                var child = walker(state.node[key]);
                if (immutable && hasOwnProperty.call(state.node, key)) {
                    state.node[key] = child.node;
                }
                
                child.isLast = i == state.keys.length - 1;
                child.isFirst = i == 0;
                
                if (modifiers.post) modifiers.post.call(state, child);
                
                path.pop();
            });
            parents.pop();
        }
        
        if (modifiers.after) modifiers.after.call(state, state.node);
        
        return state;
    })(root).node;
}

function copy (src) {
    if (typeof src === 'object' && src !== null) {
        var dst;
        
        if (isArray(src)) {
            dst = [];
        }
        else if (isDate(src)) {
            dst = new Date(src.getTime ? src.getTime() : src);
        }
        else if (isRegExp(src)) {
            dst = new RegExp(src);
        }
        else if (isError(src)) {
            dst = { message: src.message };
        }
        else if (isBoolean(src)) {
            dst = new Boolean(src);
        }
        else if (isNumber(src)) {
            dst = new Number(src);
        }
        else if (isString(src)) {
            dst = new String(src);
        }
        else if (Object.create && Object.getPrototypeOf) {
            dst = Object.create(Object.getPrototypeOf(src));
        }
        else if (src.constructor === Object) {
            dst = {};
        }
        else {
            var proto =
                (src.constructor && src.constructor.prototype)
                || src.__proto__
                || {}
            ;
            var T = function () {};
            T.prototype = proto;
            dst = new T;
        }
        
        forEach(objectKeys(src), function (key) {
            dst[key] = src[key];
        });
        return dst;
    }
    else return src;
}

var objectKeys = Object.keys || function keys (obj) {
    var res = [];
    for (var key in obj) res.push(key)
    return res;
};

function toS (obj) { return Object.prototype.toString.call(obj) }
function isDate (obj) { return toS(obj) === '[object Date]' }
function isRegExp (obj) { return toS(obj) === '[object RegExp]' }
function isError (obj) { return toS(obj) === '[object Error]' }
function isBoolean (obj) { return toS(obj) === '[object Boolean]' }
function isNumber (obj) { return toS(obj) === '[object Number]' }
function isString (obj) { return toS(obj) === '[object String]' }

var isArray = Array.isArray || function isArray (xs) {
    return Object.prototype.toString.call(xs) === '[object Array]';
};

var forEach = function (xs, fn) {
    if (xs.forEach) return xs.forEach(fn)
    else for (var i = 0; i < xs.length; i++) {
        fn(xs[i], i, xs);
    }
};

forEach(objectKeys(Traverse.prototype), function (key) {
    traverse[key] = function (obj) {
        var args = [].slice.call(arguments, 1);
        var t = new Traverse(obj);
        return t[key].apply(t, args);
    };
});

var hasOwnProperty = Object.hasOwnProperty || function (obj, key) {
    return key in obj;
};

},{}]},{},[1])(1)
});
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):"object"==typeof exports?exports["RAML.JsonValidation"]=t():e["RAML.JsonValidation"]=t()}(this,function(){return function(e){function t(n){if(r[n])return r[n].exports;var i=r[n]={exports:{},id:n,loaded:!1};return e[n].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var r={};return t.m=e,t.c=r,t.p="",t(0)}([function(e,t,r){"use strict";var n=r(1),i=function(){function e(){this.validator=new n({ignoreUnknownFormats:!0})}return e.prototype.setRemoteReference=function(e,t){this.validator.setRemoteReference(e,t)},e.prototype.validateSchema=function(e){this.validator.validateSchema(e)},e.prototype.getMissingRemoteReferences=function(){return this.validator.getMissingRemoteReferences()},e.prototype.isResourceLoaded=function(e){return null==this.validator.cache[e]?!1:!0},e.prototype.validate=function(e,t){this.validator.validate(e,t)},e.prototype.getLastErrors=function(){return this.validator.getLastErrors()},e}();t.JSONValidator=i},function(e,t,r){(function(t){"use strict";function n(e){if(this.cache={},this.referenceCache=[],this.setRemoteReference("http://json-schema.org/draft-04/schema",c),this.setRemoteReference("http://json-schema.org/draft-04/hyper-schema",p),"object"==typeof e){for(var t,r=Object.keys(e),n=r.length;n--;)if(t=r[n],void 0===h[t])throw new Error("Unexpected option passed to constructor: "+t);for(r=Object.keys(h),n=r.length;n--;)t=r[n],void 0===e[t]&&(e[t]=d.clone(h[t]));this.options=e}else this.options=d.clone(h);this.options.strictMode===!0&&(this.options.forceAdditional=!0,this.options.forceItems=!0,this.options.forceMaxLength=!0,this.options.forceProperties=!0,this.options.noExtraKeywords=!0,this.options.noTypeless=!0,this.options.noEmptyStrings=!0,this.options.noEmptyArrays=!0)}r(2);var i=r(11),o=r(3),a=r(4),s=r(5),u=r(6),l=r(7),f=r(8),d=r(9),c=r(13),p=r(14),h={asyncTimeout:2e3,forceAdditional:!1,assumeAdditional:!1,forceItems:!1,forceMinItems:!1,forceMaxItems:!1,forceMinLength:!1,forceMaxLength:!1,forceProperties:!1,ignoreUnresolvableReferences:!1,noExtraKeywords:!1,noTypeless:!1,noEmptyStrings:!1,noEmptyArrays:!1,strictUris:!1,strictMode:!1,reportPathAsArray:!1,breakOnFirstError:!0,pedanticCheck:!1,ignoreUnknownFormats:!1,customValidator:null};n.prototype.compileSchema=function(e){var t=new o(this.options);return e=u.getSchema.call(this,t,e),l.compileSchema.call(this,t,e),this.lastReport=t,t.isValid()},n.prototype.validateSchema=function(e){if(Array.isArray(e)&&0===e.length)throw new Error(".validateSchema was called with an empty array");var t=new o(this.options);e=u.getSchema.call(this,t,e);var r=l.compileSchema.call(this,t,e);return r&&f.validateSchema.call(this,t,e),this.lastReport=t,t.isValid()},n.prototype.validate=function(e,r,n,a){"function"===d.whatIs(n)&&(a=n,n={}),n||(n={});var c=d.whatIs(r);if("string"!==c&&"object"!==c){var p=new Error("Invalid .validate call - schema must be an string or object but "+c+" was passed!");if(a)return void t.nextTick(function(){a(p,!1)});throw p}var h=!1,m=new o(this.options);if("string"==typeof r){var _=r;if(r=u.getSchema.call(this,m,_),!r)throw new Error("Schema with id '"+_+"' wasn't found in the validator cache!")}else r=u.getSchema.call(this,m,r);var y=!1;h||(y=l.compileSchema.call(this,m,r)),y||(this.lastReport=m,h=!0);var E=!1;if(h||(E=f.validateSchema.call(this,m,r)),E||(this.lastReport=m,h=!0),n.schemaPath&&(m.rootSchema=r,r=i(r,n.schemaPath),!r))throw new Error("Schema path '"+n.schemaPath+"' wasn't found in the schema!");if(h||s.validate.call(this,m,r,e),a)return void m.processAsyncTasks(this.options.asyncTimeout,a);if(m.asyncTasks.length>0)throw new Error("This validation has async tasks and cannot be done in sync mode, please provide callback argument.");return this.lastReport=m,m.isValid()},n.prototype.getLastError=function(){if(0===this.lastReport.errors.length)return null;var e=new Error;return e.name="z-schema validation error",e.message=this.lastReport.commonErrorMessage,e.details=this.lastReport.errors,e},n.prototype.getLastErrors=function(){return this.lastReport&&this.lastReport.errors.length>0?this.lastReport.errors:void 0},n.prototype.getMissingReferences=function(e){e=e||this.lastReport.errors;for(var t=[],r=e.length;r--;){var n=e[r];if("UNRESOLVABLE_REFERENCE"===n.code){var i=n.params[0];-1===t.indexOf(i)&&t.push(i)}n.inner&&(t=t.concat(this.getMissingReferences(n.inner)))}return t},n.prototype.getMissingRemoteReferences=function(){for(var e=this.getMissingReferences(),t=[],r=e.length;r--;){var n=u.getRemotePath(e[r]);n&&-1===t.indexOf(n)&&t.push(n)}return t},n.prototype.setRemoteReference=function(e,t){t="string"==typeof t?JSON.parse(t):d.cloneDeep(t),u.cacheSchemaByUri.call(this,e,t)},n.prototype.getResolvedSchema=function(e){var t=new o(this.options);e=u.getSchema.call(this,t,e),e=d.cloneDeep(e);var r=[],n=function(e){var t,i=d.whatIs(e);if(("object"===i||"array"===i)&&!e.___$visited){if(e.___$visited=!0,r.push(e),e.$ref&&e.__$refResolved){var o=e.__$refResolved,a=e;delete e.$ref,delete e.__$refResolved;for(t in o)o.hasOwnProperty(t)&&(a[t]=o[t])}for(t in e)e.hasOwnProperty(t)&&(0===t.indexOf("__$")?delete e[t]:n(e[t]))}};if(n(e),r.forEach(function(e){delete e.___$visited}),this.lastReport=t,t.isValid())return e;throw this.getLastError()},n.prototype.setSchemaReader=function(e){return n.setSchemaReader(e)},n.prototype.getSchemaReader=function(){return n.schemaReader},n.setSchemaReader=function(e){n.schemaReader=e},n.registerFormat=function(e,t){a[e]=t},n.unregisterFormat=function(e){delete a[e]},n.getRegisteredFormats=function(){return Object.keys(a)},n.getDefaultOptions=function(){return d.cloneDeep(h)},e.exports=n}).call(t,r(10))},function(e,t,r){"function"!=typeof Number.isFinite&&(Number.isFinite=function(e){return"number"!=typeof e?!1:e!==e||e===1/0||e===-(1/0)?!1:!0})},function(e,t,r){(function(t){"use strict";function n(e,t){this.parentReport=e instanceof n?e:void 0,this.options=e instanceof n?e.options:e||{},this.reportOptions=t||{},this.errors=[],this.path=[],this.asyncTasks=[]}var i=r(11),o=r(12),a=r(9);n.prototype.isValid=function(){if(this.asyncTasks.length>0)throw new Error("Async tasks pending, can't answer isValid");return 0===this.errors.length},n.prototype.addAsyncTask=function(e,t,r){this.asyncTasks.push([e,t,r])},n.prototype.processAsyncTasks=function(e,r){function n(){t.nextTick(function(){var e=0===l.errors.length,t=e?void 0:l.errors;r(t,e)})}function i(e){return function(t){u||(e(t),0===--a&&n())}}var o=e||2e3,a=this.asyncTasks.length,s=a,u=!1,l=this;if(0===a||this.errors.length>0)return void n();for(;s--;){var f=this.asyncTasks[s];f[0].apply(null,f[1].concat(i(f[2])))}setTimeout(function(){a>0&&(u=!0,l.addError("ASYNC_TIMEOUT",[a,o]),r(l.errors,!1))},o)},n.prototype.getPath=function(e){var t=[];return this.parentReport&&(t=t.concat(this.parentReport.path)),t=t.concat(this.path),e!==!0&&(t="#/"+t.map(function(e){return a.isAbsoluteUri(e)?"uri("+e+")":e.replace(/\~/g,"~0").replace(/\//g,"~1")}).join("/")),t},n.prototype.getSchemaId=function(){if(!this.rootSchema)return null;var e=[];for(this.parentReport&&(e=e.concat(this.parentReport.path)),e=e.concat(this.path);e.length>0;){var t=i(this.rootSchema,e);if(t&&t.id)return t.id;e.pop()}return this.rootSchema.id},n.prototype.hasError=function(e,t){for(var r=this.errors.length;r--;)if(this.errors[r].code===e){for(var n=!0,i=this.errors[r].params.length;i--;)this.errors[r].params[i]!==t[i]&&(n=!1);if(n)return n}return!1},n.prototype.addError=function(e,t,r,n){if(!e)throw new Error("No errorCode passed into addError()");this.addCustomError(e,o[e],t,r,n)},n.prototype.addCustomError=function(e,t,r,n,i){if(!(this.errors.length>=this.reportOptions.maxErrors)){if(!t)throw new Error("No errorMessage known for code "+e);r=r||[];for(var o=r.length;o--;){var s=a.whatIs(r[o]),u="object"===s||"null"===s?JSON.stringify(r[o]):r[o];t=t.replace("{"+o+"}",u)}var l={code:e,params:r,message:t,path:this.getPath(this.options.reportPathAsArray),schemaId:this.getSchemaId()};if(i&&(l.description=i),null!=n){for(Array.isArray(n)||(n=[n]),l.inner=[],o=n.length;o--;)for(var f=n[o],d=f.errors.length;d--;)l.inner.push(f.errors[d]);0===l.inner.length&&(l.inner=void 0)}this.errors.push(l)}},e.exports=n}).call(t,r(10))},function(e,t,r){var n=r(15),i={date:function(e){if("string"!=typeof e)return!0;var t=/^([0-9]{4})-([0-9]{2})-([0-9]{2})$/.exec(e);return null===t?!1:t[2]<"01"||t[2]>"12"||t[3]<"01"||t[3]>"31"?!1:!0},"date-time":function(e){if("string"!=typeof e)return!0;var t=e.toLowerCase().split("t");if(!i.date(t[0]))return!1;var r=/^([0-9]{2}):([0-9]{2}):([0-9]{2})(.[0-9]+)?(z|([+-][0-9]{2}:[0-9]{2}))$/.exec(t[1]);return null===r?!1:r[1]>"23"||r[2]>"59"||r[3]>"59"?!1:!0},email:function(e){return"string"!=typeof e?!0:n.isEmail(e,{require_tld:!0})},hostname:function(e){if("string"!=typeof e)return!0;var t=/^[a-zA-Z](([-0-9a-zA-Z]+)?[0-9a-zA-Z])?(\.[a-zA-Z](([-0-9a-zA-Z]+)?[0-9a-zA-Z])?)*$/.test(e);if(t){if(e.length>255)return!1;for(var r=e.split("."),n=0;n<r.length;n++)if(r[n].length>63)return!1}return t},"host-name":function(e){return i.hostname.call(this,e)},ipv4:function(e){return"string"!=typeof e?!0:n.isIP(e,4)},ipv6:function(e){return"string"!=typeof e?!0:n.isIP(e,6)},regex:function(e){try{return RegExp(e),!0}catch(t){return!1}},uri:function(e){return this.options.strictUris?i["strict-uri"].apply(this,arguments):"string"!=typeof e||RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?").test(e)},"strict-uri":function(e){return"string"!=typeof e||n.isURL(e)}};e.exports=i},function(e,t,r){"use strict";var n=r(4),i=r(3),o=r(9),a={multipleOf:function(e,t,r){"number"==typeof r&&"integer"!==o.whatIs(r/t.multipleOf)&&e.addError("MULTIPLE_OF",[r,t.multipleOf],null,t.description)},maximum:function(e,t,r){"number"==typeof r&&(t.exclusiveMaximum!==!0?r>t.maximum&&e.addError("MAXIMUM",[r,t.maximum],null,t.description):r>=t.maximum&&e.addError("MAXIMUM_EXCLUSIVE",[r,t.maximum],null,t.description))},exclusiveMaximum:function(){},minimum:function(e,t,r){"number"==typeof r&&(t.exclusiveMinimum!==!0?r<t.minimum&&e.addError("MINIMUM",[r,t.minimum],null,t.description):r<=t.minimum&&e.addError("MINIMUM_EXCLUSIVE",[r,t.minimum],null,t.description))},exclusiveMinimum:function(){},maxLength:function(e,t,r){"string"==typeof r&&o.ucs2decode(r).length>t.maxLength&&e.addError("MAX_LENGTH",[r.length,t.maxLength],null,t.description)},minLength:function(e,t,r){"string"==typeof r&&o.ucs2decode(r).length<t.minLength&&e.addError("MIN_LENGTH",[r.length,t.minLength],null,t.description)},pattern:function(e,t,r){"string"==typeof r&&RegExp(t.pattern).test(r)===!1&&e.addError("PATTERN",[t.pattern,r],null,t.description)},additionalItems:function(e,t,r){Array.isArray(r)&&t.additionalItems===!1&&Array.isArray(t.items)&&r.length>t.items.length&&e.addError("ARRAY_ADDITIONAL_ITEMS",null,null,t.description)},items:function(){},maxItems:function(e,t,r){Array.isArray(r)&&r.length>t.maxItems&&e.addError("ARRAY_LENGTH_LONG",[r.length,t.maxItems],null,t.description)},minItems:function(e,t,r){Array.isArray(r)&&r.length<t.minItems&&e.addError("ARRAY_LENGTH_SHORT",[r.length,t.minItems],null,t.description)},uniqueItems:function(e,t,r){if(Array.isArray(r)&&t.uniqueItems===!0){var n=[];o.isUniqueArray(r,n)===!1&&e.addError("ARRAY_UNIQUE",n,null,t.description)}},maxProperties:function(e,t,r){if("object"===o.whatIs(r)){var n=Object.keys(r).length;n>t.maxProperties&&e.addError("OBJECT_PROPERTIES_MAXIMUM",[n,t.maxProperties],null,t.description)}},minProperties:function(e,t,r){if("object"===o.whatIs(r)){var n=Object.keys(r).length;n<t.minProperties&&e.addError("OBJECT_PROPERTIES_MINIMUM",[n,t.minProperties],null,t.description)}},required:function(e,t,r){if("object"===o.whatIs(r))for(var n=t.required.length;n--;){var i=t.required[n];void 0===r[i]&&e.addError("OBJECT_MISSING_REQUIRED_PROPERTY",[i],null,t.description)}},additionalProperties:function(e,t,r){return void 0===t.properties&&void 0===t.patternProperties?a.properties.call(this,e,t,r):void 0},patternProperties:function(e,t,r){return void 0===t.properties?a.properties.call(this,e,t,r):void 0},properties:function(e,t,r){if("object"===o.whatIs(r)){var n=void 0!==t.properties?t.properties:{},i=void 0!==t.patternProperties?t.patternProperties:{};if(t.additionalProperties===!1){var a=Object.keys(r),s=Object.keys(n),u=Object.keys(i);a=o.difference(a,s);for(var l=u.length;l--;)for(var f=RegExp(u[l]),d=a.length;d--;)f.test(a[d])===!0&&a.splice(d,1);if(a.length>0){var c=this.options.assumeAdditional.length;if(c)for(;c--;){var p=a.indexOf(this.options.assumeAdditional[c]);-1!==p&&a.splice(p,1)}a.length>0&&e.addError("OBJECT_ADDITIONAL_PROPERTIES",[a],null,t.description)}}}},dependencies:function(e,r,n){if("object"===o.whatIs(n))for(var i=Object.keys(r.dependencies),a=i.length;a--;){var s=i[a];if(n[s]){var u=r.dependencies[s];if("object"===o.whatIs(u))t.validate.call(this,e,u,n);else for(var l=u.length;l--;){var f=u[l];void 0===n[f]&&e.addError("OBJECT_DEPENDENCY_KEY",[f,s],null,r.description)}}}},"enum":function(e,t,r){for(var n=!1,i=t["enum"].length;i--;)if(o.areEqual(r,t["enum"][i])){n=!0;break}n===!1&&e.addError("ENUM_MISMATCH",[r],null,t.description)},allOf:function(e,r,n){for(var i=r.allOf.length;i--;){var o=t.validate.call(this,e,r.allOf[i],n);if(this.options.breakOnFirstError&&o===!1)break}},anyOf:function(e,r,n){for(var o=[],a=!1,s=r.anyOf.length;s--&&a===!1;){var u=new i(e);o.push(u),a=t.validate.call(this,u,r.anyOf[s],n)}a===!1&&e.addError("ANY_OF_MISSING",void 0,o,r.description)},oneOf:function(e,r,n){for(var o=0,a=[],s=r.oneOf.length;s--;){var u=new i(e,{maxErrors:1});a.push(u),t.validate.call(this,u,r.oneOf[s],n)===!0&&o++}0===o?e.addError("ONE_OF_MISSING",void 0,a,r.description):o>1&&e.addError("ONE_OF_MULTIPLE",null,null,r.description)},not:function(e,r,n){var o=new i(e);t.validate.call(this,o,r.not,n)===!0&&e.addError("NOT_PASSED",null,null,r.description)},definitions:function(){},format:function(e,t,r){var i=n[t.format];"function"==typeof i?2===i.length?e.addAsyncTask(i,[r],function(n){n!==!0&&e.addError("INVALID_FORMAT",[t.format,r],null,t.description)}):i.call(this,r)!==!0&&e.addError("INVALID_FORMAT",[t.format,r],null,t.description):this.options.ignoreUnknownFormats!==!0&&e.addError("UNKNOWN_FORMAT",[t.format],null,t.description)}},s=function(e,r,n){var i=n.length;if(Array.isArray(r.items))for(;i--;)i<r.items.length?(e.path.push(i.toString()),t.validate.call(this,e,r.items[i],n[i]),e.path.pop()):"object"==typeof r.additionalItems&&(e.path.push(i.toString()),t.validate.call(this,e,r.additionalItems,n[i]),e.path.pop());else if("object"==typeof r.items)for(;i--;)e.path.push(i.toString()),t.validate.call(this,e,r.items,n[i]),e.path.pop()},u=function(e,r,n){var i=r.additionalProperties;(i===!0||void 0===i)&&(i={});for(var o=r.properties?Object.keys(r.properties):[],a=r.patternProperties?Object.keys(r.patternProperties):[],s=Object.keys(n),u=s.length;u--;){var l=s[u],f=n[l],d=[];-1!==o.indexOf(l)&&d.push(r.properties[l]);for(var c=a.length;c--;){var p=a[c];RegExp(p).test(l)===!0&&d.push(r.patternProperties[p])}for(0===d.length&&i!==!1&&d.push(i),c=d.length;c--;)e.path.push(l),t.validate.call(this,e,d[c],f),e.path.pop()}};t.validate=function(e,t,r){e.commonErrorMessage="JSON_OBJECT_VALIDATION_FAILED";var n=o.whatIs(t);if("object"!==n)return e.addError("SCHEMA_NOT_AN_OBJECT",[n],null,t.description),!1;var i=Object.keys(t);if(0===i.length)return!0;var l=!1;if(e.rootSchema||(e.rootSchema=t,l=!0),void 0!==t.$ref){for(var f=99;t.$ref&&f>0;){if(!t.__$refResolved){e.addError("REF_UNRESOLVED",[t.$ref],null,t.description);break}if(t.__$refResolved===t)break;t=t.__$refResolved,i=Object.keys(t),f--}if(0===f)throw new Error("Circular dependency by $ref references!")}var d=o.whatIs(r);if(t.type)if("string"==typeof t.type){if(d!==t.type&&("integer"!==d||"number"!==t.type)&&(e.addError("INVALID_TYPE",[t.type,d],null,t.description),this.options.breakOnFirstError))return!1}else if(-1===t.type.indexOf(d)&&("integer"!==d||-1===t.type.indexOf("number"))&&(e.addError("INVALID_TYPE",[t.type,d],null,t.description),this.options.breakOnFirstError))return!1;for(var c=i.length;c--&&!(a[i[c]]&&(a[i[c]].call(this,e,t,r),e.errors.length&&this.options.breakOnFirstError)););return(0===e.errors.length||this.options.breakOnFirstError===!1)&&("array"===d?s.call(this,e,t,r):"object"===d&&u.call(this,e,t,r)),"function"==typeof this.options.customValidator&&this.options.customValidator(e,t,r),l&&(e.rootSchema=void 0),0===e.errors.length}},function(e,t,r){"use strict";function n(e){return decodeURIComponent(e).replace(/~[0-1]/g,function(e){return"~1"===e?"/":"~"})}function i(e){var t=e.indexOf("#");return-1===t?e:e.slice(0,t)}function o(e){var t=e.indexOf("#"),r=-1===t?void 0:e.slice(t+1);return r}function a(e,t){if("object"==typeof e&&null!==e){if(!t)return e;if(e.id&&(e.id===t||"#"===e.id[0]&&e.id.substring(1)===t))return e;var r,n;if(Array.isArray(e)){for(r=e.length;r--;)if(n=a(e[r],t))return n}else{var i=Object.keys(e);for(r=i.length;r--;){var o=i[r];if(0!==o.indexOf("__$")&&(n=a(e[o],t)))return n}}}}var s=r(3),u=r(7),l=r(8),f=r(9);t.cacheSchemaByUri=function(e,t){var r=i(e);r&&(this.cache[r]=t)},t.removeFromCacheByUri=function(e){var t=i(e);t&&delete this.cache[t]},t.checkCacheForUri=function(e){var t=i(e);return t?null!=this.cache[t]:!1},t.getSchema=function(e,r){return"object"==typeof r&&(r=t.getSchemaByReference.call(this,e,r)),"string"==typeof r&&(r=t.getSchemaByUri.call(this,e,r)),r},t.getSchemaByReference=function(e,t){for(var r=this.referenceCache.length;r--;)if(this.referenceCache[r][0]===t)return this.referenceCache[r][1];var n=f.cloneDeep(t);return this.referenceCache.push([t,n]),n},t.getSchemaByUri=function(e,t,r){var f=i(t),d=o(t),c=f?this.cache[f]:r;if(c&&f){var p=c!==r;if(p){e.path.push(f);var h=new s(e);u.compileSchema.call(this,h,c)&&l.validateSchema.call(this,h,c);var m=h.isValid();if(m||e.addError("REMOTE_NOT_VALID",[t],h),e.path.pop(),!m)return void 0}}if(c&&d)for(var _=d.split("/"),y=0,E=_.length;c&&E>y;y++){var v=n(_[y]);c=0===y?a(c,v):c[v]}return c},t.getRemotePath=i},function(e,t,r){"use strict";function n(e,t){if(u.isAbsoluteUri(t))return t;var r,n=e.join(""),i=u.isAbsoluteUri(n),o=u.isRelativeUri(n),a=u.isRelativeUri(t);i&&a?(r=n.match(/\/[^\/]*$/),r&&(n=n.slice(0,r.index+1))):o&&a?n="":(r=n.match(/[^#\/]+$/),r&&(n=n.slice(0,r.index)));var s=n+t;return s=s.replace(/##/,"#")}function i(e,t,r,o){if(t=t||[],r=r||[],o=o||[],"object"!=typeof e||null===e)return t;"string"==typeof e.id&&r.push(e.id),"string"==typeof e.$ref&&"undefined"==typeof e.__$refResolved&&t.push({ref:n(r,e.$ref),key:"$ref",obj:e,path:o.slice(0)}),"string"==typeof e.$schema&&"undefined"==typeof e.__$schemaResolved&&t.push({ref:n(r,e.$schema),key:"$schema",obj:e,path:o.slice(0)});var a;if(Array.isArray(e))for(a=e.length;a--;)o.push(a.toString()),i(e[a],t,r,o),o.pop();else{var s=Object.keys(e);for(a=s.length;a--;)0!==s[a].indexOf("__$")&&(o.push(s[a]),i(e[s[a]],t,r,o),o.pop())}return"string"==typeof e.id&&r.pop(),t}function o(e,t){for(var r=e.length;r--;)if(e[r].id===t)return e[r];return null}var a=r(3),s=r(6),u=r(9),l=function(e,r){for(var n=r.length,i=0;n--;){var o=new a(e),s=t.compileSchema.call(this,o,r[n]);s&&i++,e.errors=e.errors.concat(o.errors)}return i},f=function(e,t){var r,n=0;do{for(var i=e.errors.length;i--;)"UNRESOLVABLE_REFERENCE"===e.errors[i].code&&e.errors.splice(i,1);for(r=n,n=l.call(this,e,t),i=t.length;i--;){var a=t[i];if(a.__$missingReferences){for(var s=a.__$missingReferences.length;s--;){var u=a.__$missingReferences[s],f=o(t,u.ref);f&&(u.obj["__"+u.key+"Resolved"]=f,a.__$missingReferences.splice(s,1))}0===a.__$missingReferences.length&&delete a.__$missingReferences}}}while(n!==t.length&&n!==r);return e.isValid()};t.compileSchema=function(e,r){if(e.commonErrorMessage="SCHEMA_COMPILATION_FAILED","string"==typeof r){var n=s.getSchemaByUri.call(this,e,r);if(!n)return e.addError("SCHEMA_NOT_REACHABLE",[r]),!1;r=n}if(Array.isArray(r))return f.call(this,e,r);if(r.__$compiled&&r.id&&s.checkCacheForUri.call(this,r.id)===!1&&(r.__$compiled=void 0),r.__$compiled)return!0;r.id&&"string"==typeof r.id&&s.cacheSchemaByUri.call(this,r.id,r);var o=!1;e.rootSchema||(e.rootSchema=r,o=!0);var l=e.isValid();delete r.__$missingReferences;for(var d=i.call(this,r),c=d.length;c--;){var p=d[c],h=s.getSchemaByUri.call(this,e,p.ref,r);if(!h){var m=this.getSchemaReader();if(m){var _=m(p.ref);if(_){_.id=p.ref;var y=new a(e);t.compileSchema.call(this,y,_)?h=s.getSchemaByUri.call(this,e,p.ref,r):e.errors=e.errors.concat(y.errors)}}}if(!h){var E=e.hasError("REMOTE_NOT_VALID",[p.ref]),v=u.isAbsoluteUri(p.ref),g=!1,O=this.options.ignoreUnresolvableReferences===!0;v&&(g=s.checkCacheForUri.call(this,p.ref)),E||O&&v||g||(Array.prototype.push.apply(e.path,p.path),e.addError("UNRESOLVABLE_REFERENCE",[p.ref]),e.path=e.path.slice(0,-p.path.length),l&&(r.__$missingReferences=r.__$missingReferences||[],r.__$missingReferences.push(p)))}p.obj["__"+p.key+"Resolved"]=h}var b=e.isValid();return b?r.__$compiled=!0:r.id&&"string"==typeof r.id&&s.removeFromCacheByUri.call(this,r.id),o&&(e.rootSchema=void 0),b}},function(e,t,r){"use strict";var n=r(4),i=r(5),o=r(3),a=r(9),s={$ref:function(e,t){"string"!=typeof t.$ref&&e.addError("KEYWORD_TYPE_EXPECTED",["$ref","string"])},$schema:function(e,t){"string"!=typeof t.$schema&&e.addError("KEYWORD_TYPE_EXPECTED",["$schema","string"])},multipleOf:function(e,t){"number"!=typeof t.multipleOf?e.addError("KEYWORD_TYPE_EXPECTED",["multipleOf","number"]):t.multipleOf<=0&&e.addError("KEYWORD_MUST_BE",["multipleOf","strictly greater than 0"])},maximum:function(e,t){"number"!=typeof t.maximum&&e.addError("KEYWORD_TYPE_EXPECTED",["maximum","number"])},exclusiveMaximum:function(e,t){"boolean"!=typeof t.exclusiveMaximum?e.addError("KEYWORD_TYPE_EXPECTED",["exclusiveMaximum","boolean"]):void 0===t.maximum&&e.addError("KEYWORD_DEPENDENCY",["exclusiveMaximum","maximum"])},minimum:function(e,t){"number"!=typeof t.minimum&&e.addError("KEYWORD_TYPE_EXPECTED",["minimum","number"])},exclusiveMinimum:function(e,t){"boolean"!=typeof t.exclusiveMinimum?e.addError("KEYWORD_TYPE_EXPECTED",["exclusiveMinimum","boolean"]):void 0===t.minimum&&e.addError("KEYWORD_DEPENDENCY",["exclusiveMinimum","minimum"])},maxLength:function(e,t){"integer"!==a.whatIs(t.maxLength)?e.addError("KEYWORD_TYPE_EXPECTED",["maxLength","integer"]):t.maxLength<0&&e.addError("KEYWORD_MUST_BE",["maxLength","greater than, or equal to 0"])},minLength:function(e,t){"integer"!==a.whatIs(t.minLength)?e.addError("KEYWORD_TYPE_EXPECTED",["minLength","integer"]):t.minLength<0&&e.addError("KEYWORD_MUST_BE",["minLength","greater than, or equal to 0"])},pattern:function(e,t){if("string"!=typeof t.pattern)e.addError("KEYWORD_TYPE_EXPECTED",["pattern","string"]);else try{RegExp(t.pattern)}catch(r){e.addError("KEYWORD_PATTERN",["pattern",t.pattern])}},additionalItems:function(e,r){var n=a.whatIs(r.additionalItems);"boolean"!==n&&"object"!==n?e.addError("KEYWORD_TYPE_EXPECTED",["additionalItems",["boolean","object"]]):"object"===n&&(e.path.push("additionalItems"),t.validateSchema.call(this,e,r.additionalItems),e.path.pop())},items:function(e,r){var n=a.whatIs(r.items);if("object"===n)e.path.push("items"),t.validateSchema.call(this,e,r.items),e.path.pop();else if("array"===n)for(var i=r.items.length;i--;)e.path.push("items"),e.path.push(i.toString()),t.validateSchema.call(this,e,r.items[i]),e.path.pop(),e.path.pop();else e.addError("KEYWORD_TYPE_EXPECTED",["items",["array","object"]]);this.options.forceAdditional===!0&&void 0===r.additionalItems&&Array.isArray(r.items)&&e.addError("KEYWORD_UNDEFINED_STRICT",["additionalItems"]),this.options.assumeAdditional&&void 0===r.additionalItems&&Array.isArray(r.items)&&(r.additionalItems=!1)},maxItems:function(e,t){"number"!=typeof t.maxItems?e.addError("KEYWORD_TYPE_EXPECTED",["maxItems","integer"]):t.maxItems<0&&e.addError("KEYWORD_MUST_BE",["maxItems","greater than, or equal to 0"])},minItems:function(e,t){"integer"!==a.whatIs(t.minItems)?e.addError("KEYWORD_TYPE_EXPECTED",["minItems","integer"]):t.minItems<0&&e.addError("KEYWORD_MUST_BE",["minItems","greater than, or equal to 0"])},uniqueItems:function(e,t){"boolean"!=typeof t.uniqueItems&&e.addError("KEYWORD_TYPE_EXPECTED",["uniqueItems","boolean"])},maxProperties:function(e,t){"integer"!==a.whatIs(t.maxProperties)?e.addError("KEYWORD_TYPE_EXPECTED",["maxProperties","integer"]):t.maxProperties<0&&e.addError("KEYWORD_MUST_BE",["maxProperties","greater than, or equal to 0"])},minProperties:function(e,t){"integer"!==a.whatIs(t.minProperties)?e.addError("KEYWORD_TYPE_EXPECTED",["minProperties","integer"]):t.minProperties<0&&e.addError("KEYWORD_MUST_BE",["minProperties","greater than, or equal to 0"])},required:function(e,t){if("array"!==a.whatIs(t.required))e.addError("KEYWORD_TYPE_EXPECTED",["required","array"]);else if(0===t.required.length)e.addError("KEYWORD_MUST_BE",["required","an array with at least one element"]);else{for(var r=t.required.length;r--;)"string"!=typeof t.required[r]&&e.addError("KEYWORD_VALUE_TYPE",["required","string"]);a.isUniqueArray(t.required)===!1&&e.addError("KEYWORD_MUST_BE",["required","an array with unique items"])}},additionalProperties:function(e,r){var n=a.whatIs(r.additionalProperties);"boolean"!==n&&"object"!==n?e.addError("KEYWORD_TYPE_EXPECTED",["additionalProperties",["boolean","object"]]):"object"===n&&(e.path.push("additionalProperties"),t.validateSchema.call(this,e,r.additionalProperties),e.path.pop())},properties:function(e,r){if("object"!==a.whatIs(r.properties))return void e.addError("KEYWORD_TYPE_EXPECTED",["properties","object"]);for(var n=Object.keys(r.properties),i=n.length;i--;){var o=n[i],s=r.properties[o];e.path.push("properties"),e.path.push(o),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop()}this.options.forceAdditional===!0&&void 0===r.additionalProperties&&e.addError("KEYWORD_UNDEFINED_STRICT",["additionalProperties"]),this.options.assumeAdditional&&void 0===r.additionalProperties&&(r.additionalProperties=!1),this.options.forceProperties===!0&&0===n.length&&e.addError("CUSTOM_MODE_FORCE_PROPERTIES",["properties"])},patternProperties:function(e,r){if("object"!==a.whatIs(r.patternProperties))return void e.addError("KEYWORD_TYPE_EXPECTED",["patternProperties","object"]);for(var n=Object.keys(r.patternProperties),i=n.length;i--;){var o=n[i],s=r.patternProperties[o];try{RegExp(o)}catch(u){e.addError("KEYWORD_PATTERN",["patternProperties",o])}e.path.push("patternProperties"),e.path.push(o.toString()),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop()}this.options.forceProperties===!0&&0===n.length&&e.addError("CUSTOM_MODE_FORCE_PROPERTIES",["patternProperties"])},dependencies:function(e,r){if("object"!==a.whatIs(r.dependencies))e.addError("KEYWORD_TYPE_EXPECTED",["dependencies","object"]);else for(var n=Object.keys(r.dependencies),i=n.length;i--;){var o=n[i],s=r.dependencies[o],u=a.whatIs(s);if("object"===u)e.path.push("dependencies"),e.path.push(o),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop();else if("array"===u){var l=s.length;for(0===l&&e.addError("KEYWORD_MUST_BE",["dependencies","not empty array"]);l--;)"string"!=typeof s[l]&&e.addError("KEYWORD_VALUE_TYPE",["dependensices","string"]);a.isUniqueArray(s)===!1&&e.addError("KEYWORD_MUST_BE",["dependencies","an array with unique items"])}else e.addError("KEYWORD_VALUE_TYPE",["dependencies","object or array"])}},"enum":function(e,t){Array.isArray(t["enum"])===!1?e.addError("KEYWORD_TYPE_EXPECTED",["enum","array"]):0===t["enum"].length?e.addError("KEYWORD_MUST_BE",["enum","an array with at least one element"]):a.isUniqueArray(t["enum"])===!1&&e.addError("KEYWORD_MUST_BE",["enum","an array with unique elements"])},type:function(e,t){var r=["array","boolean","integer","number","null","object","string"],n=r.join(","),i=Array.isArray(t.type);if(i){for(var o=t.type.length;o--;)-1===r.indexOf(t.type[o])&&e.addError("KEYWORD_TYPE_EXPECTED",["type",n]);a.isUniqueArray(t.type)===!1&&e.addError("KEYWORD_MUST_BE",["type","an object with unique properties"])}else"string"==typeof t.type?-1===r.indexOf(t.type)&&e.addError("KEYWORD_TYPE_EXPECTED",["type",n]):e.addError("KEYWORD_TYPE_EXPECTED",["type",["string","array"]]);this.options.noEmptyStrings===!0&&("string"===t.type||i&&-1!==t.type.indexOf("string"))&&void 0===t.minLength&&void 0===t["enum"]&&void 0===t.format&&(t.minLength=1),this.options.noEmptyArrays===!0&&("array"===t.type||i&&-1!==t.type.indexOf("array"))&&void 0===t.minItems&&(t.minItems=1),this.options.forceProperties===!0&&("object"===t.type||i&&-1!==t.type.indexOf("object"))&&void 0===t.properties&&void 0===t.patternProperties&&e.addError("KEYWORD_UNDEFINED_STRICT",["properties"]),this.options.forceItems===!0&&("array"===t.type||i&&-1!==t.type.indexOf("array"))&&void 0===t.items&&e.addError("KEYWORD_UNDEFINED_STRICT",["items"]),this.options.forceMinItems===!0&&("array"===t.type||i&&-1!==t.type.indexOf("array"))&&void 0===t.minItems&&e.addError("KEYWORD_UNDEFINED_STRICT",["minItems"]),this.options.forceMaxItems===!0&&("array"===t.type||i&&-1!==t.type.indexOf("array"))&&void 0===t.maxItems&&e.addError("KEYWORD_UNDEFINED_STRICT",["maxItems"]),this.options.forceMinLength===!0&&("string"===t.type||i&&-1!==t.type.indexOf("string"))&&void 0===t.minLength&&void 0===t.format&&void 0===t["enum"]&&void 0===t.pattern&&e.addError("KEYWORD_UNDEFINED_STRICT",["minLength"]),this.options.forceMaxLength===!0&&("string"===t.type||i&&-1!==t.type.indexOf("string"))&&void 0===t.maxLength&&void 0===t.format&&void 0===t["enum"]&&void 0===t.pattern&&e.addError("KEYWORD_UNDEFINED_STRICT",["maxLength"])},allOf:function(e,r){if(Array.isArray(r.allOf)===!1)e.addError("KEYWORD_TYPE_EXPECTED",["allOf","array"]);else if(0===r.allOf.length)e.addError("KEYWORD_MUST_BE",["allOf","an array with at least one element"]);else for(var n=r.allOf.length;n--;)e.path.push("allOf"),e.path.push(n.toString()),t.validateSchema.call(this,e,r.allOf[n]),e.path.pop(),e.path.pop()},anyOf:function(e,r){if(Array.isArray(r.anyOf)===!1)e.addError("KEYWORD_TYPE_EXPECTED",["anyOf","array"]);else if(0===r.anyOf.length)e.addError("KEYWORD_MUST_BE",["anyOf","an array with at least one element"]);else for(var n=r.anyOf.length;n--;)e.path.push("anyOf"),e.path.push(n.toString()),t.validateSchema.call(this,e,r.anyOf[n]),e.path.pop(),e.path.pop()},oneOf:function(e,r){if(Array.isArray(r.oneOf)===!1)e.addError("KEYWORD_TYPE_EXPECTED",["oneOf","array"]);else if(0===r.oneOf.length)e.addError("KEYWORD_MUST_BE",["oneOf","an array with at least one element"]);else for(var n=r.oneOf.length;n--;)e.path.push("oneOf"),e.path.push(n.toString()),t.validateSchema.call(this,e,r.oneOf[n]),e.path.pop(),e.path.pop()},not:function(e,r){"object"!==a.whatIs(r.not)?e.addError("KEYWORD_TYPE_EXPECTED",["not","object"]):(e.path.push("not"),t.validateSchema.call(this,e,r.not),e.path.pop())},definitions:function(e,r){if("object"!==a.whatIs(r.definitions))e.addError("KEYWORD_TYPE_EXPECTED",["definitions","object"]);else for(var n=Object.keys(r.definitions),i=n.length;i--;){var o=n[i],s=r.definitions[o];e.path.push("definitions"),e.path.push(o),t.validateSchema.call(this,e,s),e.path.pop(),e.path.pop()}},format:function(e,t){"string"!=typeof t.format?e.addError("KEYWORD_TYPE_EXPECTED",["format","string"]):void 0===n[t.format]&&this.options.ignoreUnknownFormats!==!0&&e.addError("UNKNOWN_FORMAT",[t.format])},id:function(e,t){"string"!=typeof t.id&&e.addError("KEYWORD_TYPE_EXPECTED",["id","string"])},title:function(e,t){"string"!=typeof t.title&&e.addError("KEYWORD_TYPE_EXPECTED",["title","string"])},description:function(e,t){"string"!=typeof t.description&&e.addError("KEYWORD_TYPE_EXPECTED",["description","string"])},"default":function(){}},u=function(e,r){for(var n=r.length;n--;)t.validateSchema.call(this,e,r[n]);return e.isValid()};t.validateSchema=function(e,t){if(e.commonErrorMessage="SCHEMA_VALIDATION_FAILED",
Array.isArray(t))return u.call(this,e,t);if(t.__$validated)return!0;var r=t.$schema&&t.id!==t.$schema;if(r)if(t.__$schemaResolved&&t.__$schemaResolved!==t){var n=new o(e),l=i.validate.call(this,n,t.__$schemaResolved,t);l===!1&&e.addError("PARENT_SCHEMA_VALIDATION_FAILED",null,n)}else this.options.ignoreUnresolvableReferences!==!0&&e.addError("REF_UNRESOLVED",[t.$schema]);if(this.options.noTypeless===!0){if(void 0!==t.type){var f=[];Array.isArray(t.anyOf)&&(f=f.concat(t.anyOf)),Array.isArray(t.oneOf)&&(f=f.concat(t.oneOf)),Array.isArray(t.allOf)&&(f=f.concat(t.allOf)),f.forEach(function(e){e.type||(e.type=t.type)})}void 0===t["enum"]&&void 0===t.type&&void 0===t.anyOf&&void 0===t.oneOf&&void 0===t.not&&void 0===t.$ref&&e.addError("KEYWORD_UNDEFINED_STRICT",["type"])}for(var d=Object.keys(t),c=d.length;c--;){var p=d[c];0!==p.indexOf("__")&&(void 0!==s[p]?s[p].call(this,e,t):r||this.options.noExtraKeywords===!0&&e.addError("KEYWORD_UNEXPECTED",[p]))}if(this.options.pedanticCheck===!0){if(t["enum"]){var h=a.clone(t);for(delete h["enum"],delete h["default"],e.path.push("enum"),c=t["enum"].length;c--;)e.path.push(c.toString()),i.validate.call(this,e,h,t["enum"][c]),e.path.pop();e.path.pop()}t["default"]&&(e.path.push("default"),i.validate.call(this,e,t,t["default"]),e.path.pop())}var m=e.isValid();return m&&(t.__$validated=!0),m}},function(e,t,r){"use strict";t.isAbsoluteUri=function(e){return/^https?:\/\//.test(e)},t.isRelativeUri=function(e){return/.+#/.test(e)},t.whatIs=function(e){var t=typeof e;return"object"===t?null===e?"null":Array.isArray(e)?"array":"object":"number"===t?Number.isFinite(e)?e%1===0?"integer":"number":Number.isNaN(e)?"not-a-number":"unknown-number":t},t.areEqual=function n(e,r){if(e===r)return!0;var i,o;if(Array.isArray(e)&&Array.isArray(r)){if(e.length!==r.length)return!1;for(o=e.length,i=0;o>i;i++)if(!n(e[i],r[i]))return!1;return!0}if("object"===t.whatIs(e)&&"object"===t.whatIs(r)){var a=Object.keys(e),s=Object.keys(r);if(!n(a,s))return!1;for(o=a.length,i=0;o>i;i++)if(!n(e[a[i]],r[a[i]]))return!1;return!0}return!1},t.isUniqueArray=function(e,r){var n,i,o=e.length;for(n=0;o>n;n++)for(i=n+1;o>i;i++)if(t.areEqual(e[n],e[i]))return r&&r.push(n,i),!1;return!0},t.difference=function(e,t){for(var r=[],n=e.length;n--;)-1===t.indexOf(e[n])&&r.push(e[n]);return r},t.clone=function(e){if("undefined"==typeof e)return void 0;if("object"!=typeof e||null===e)return e;var t,r;if(Array.isArray(e))for(t=[],r=e.length;r--;)t[r]=e[r];else{t={};var n=Object.keys(e);for(r=n.length;r--;){var i=n[r];t[i]=e[i]}}return t},t.cloneDeep=function(e){function t(e){if("object"!=typeof e||null===e)return e;var i,o,a;if(a=r.indexOf(e),-1!==a)return n[a];if(r.push(e),Array.isArray(e))for(i=[],n.push(i),o=e.length;o--;)i[o]=t(e[o]);else{i={},n.push(i);var s=Object.keys(e);for(o=s.length;o--;){var u=s[o];i[u]=t(e[u])}}return i}var r=[],n=[];return t(e)},t.ucs2decode=function(e){for(var t,r,n=[],i=0,o=e.length;o>i;)t=e.charCodeAt(i++),t>=55296&&56319>=t&&o>i?(r=e.charCodeAt(i++),56320==(64512&r)?n.push(((1023&t)<<10)+(1023&r)+65536):(n.push(t),i--)):n.push(t);return n}},function(e,t,r){function n(){if(!s){s=!0;for(var e,t=a.length;t;){e=a,a=[];for(var r=-1;++r<t;)e[r]();t=a.length}s=!1}}function i(){}var o=e.exports={},a=[],s=!1;o.nextTick=function(e){a.push(e),s||setTimeout(n,0)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=i,o.addListener=i,o.once=i,o.off=i,o.removeListener=i,o.removeAllListeners=i,o.emit=i,o.binding=function(e){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(e){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}},function(e,t,r){(function(t){function r(e,t){return null==e?void 0:e[t]}function n(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(r){}return t}function i(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function o(){this.__data__=_e?_e(null):{}}function a(e){return this.has(e)&&delete this.__data__[e]}function s(e){var t=this.__data__;if(_e){var r=t[e];return r===k?void 0:r}return fe.call(t,e)?t[e]:void 0}function u(e){var t=this.__data__;return _e?void 0!==t[e]:fe.call(t,e)}function l(e,t){var r=this.__data__;return r[e]=_e&&void 0===t?k:t,this}function f(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function d(){this.__data__=[]}function c(e){var t=this.__data__,r=b(t,e);if(0>r)return!1;var n=t.length-1;return r==n?t.pop():he.call(t,r,1),!0}function p(e){var t=this.__data__,r=b(t,e);return 0>r?void 0:t[r][1]}function h(e){return b(this.__data__,e)>-1}function m(e,t){var r=this.__data__,n=b(r,e);return 0>n?r.push([e,t]):r[n][1]=t,this}function _(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function y(){this.__data__={hash:new i,map:new(me||f),string:new i}}function E(e){return M(this,e)["delete"](e)}function v(e){return M(this,e).get(e)}function g(e){return M(this,e).has(e)}function O(e,t){return M(this,e).set(e,t),this}function b(e,t){for(var r=e.length;r--;)if(w(e[r][0],t))return r;return-1}function A(e,t){t=I(t,e)?[t]:P(t);for(var r=0,n=t.length;null!=e&&n>r;)e=e[$(t[r++])];return r&&r==n?e:void 0}function x(e){if(!C(e)||S(e))return!1;var t=N(e)||n(e)?ce:ee;return t.test(j(e))}function R(e){if("string"==typeof e)return e;if(U(e))return Ee?Ee.call(e):"";var t=e+"";return"0"==t&&1/e==-B?"-0":t}function P(e){return ge(e)?e:ve(e)}function M(e,t){var r=e.__data__;return D(t)?r["string"==typeof t?"string":"hash"]:r.map}function T(e,t){var n=r(e,t);return x(n)?n:void 0}function I(e,t){if(ge(e))return!1;var r=typeof e;return"number"==r||"symbol"==r||"boolean"==r||null==e||U(e)?!0:H.test(e)||!Z.test(e)||null!=t&&e in Object(t)}function D(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}function S(e){return!!ue&&ue in e}function $(e){if("string"==typeof e||U(e))return e;var t=e+"";return"0"==t&&1/e==-B?"-0":t}function j(e){if(null!=e){try{return le.call(e)}catch(t){}try{return e+""}catch(t){}}return""}function F(e,t){if("function"!=typeof e||t&&"function"!=typeof t)throw new TypeError(W);var r=function(){var n=arguments,i=t?t.apply(this,n):n[0],o=r.cache;if(o.has(i))return o.get(i);var a=e.apply(this,n);return r.cache=o.set(i,a),a};return r.cache=new(F.Cache||_),r}function w(e,t){return e===t||e!==e&&t!==t}function N(e){var t=C(e)?de.call(e):"";return t==q||t==V}function C(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}function Y(e){return!!e&&"object"==typeof e}function U(e){return"symbol"==typeof e||Y(e)&&de.call(e)==X}function L(e){return null==e?"":R(e)}function K(e,t,r){var n=null==e?void 0:A(e,t);return void 0===n?r:n}var W="Expected a function",k="__lodash_hash_undefined__",B=1/0,q="[object Function]",V="[object GeneratorFunction]",X="[object Symbol]",Z=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,H=/^\w*$/,z=/^\./,J=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,G=/[\\^$.*+?()[\]{}|]/g,Q=/\\(\\)?/g,ee=/^\[object .+?Constructor\]$/,te="object"==typeof t&&t&&t.Object===Object&&t,re="object"==typeof self&&self&&self.Object===Object&&self,ne=te||re||Function("return this")(),ie=Array.prototype,oe=Function.prototype,ae=Object.prototype,se=ne["__core-js_shared__"],ue=function(){var e=/[^.]+$/.exec(se&&se.keys&&se.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),le=oe.toString,fe=ae.hasOwnProperty,de=ae.toString,ce=RegExp("^"+le.call(fe).replace(G,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),pe=ne.Symbol,he=ie.splice,me=T(ne,"Map"),_e=T(Object,"create"),ye=pe?pe.prototype:void 0,Ee=ye?ye.toString:void 0;i.prototype.clear=o,i.prototype["delete"]=a,i.prototype.get=s,i.prototype.has=u,i.prototype.set=l,f.prototype.clear=d,f.prototype["delete"]=c,f.prototype.get=p,f.prototype.has=h,f.prototype.set=m,_.prototype.clear=y,_.prototype["delete"]=E,_.prototype.get=v,_.prototype.has=g,_.prototype.set=O;var ve=F(function(e){e=L(e);var t=[];return z.test(e)&&t.push(""),e.replace(J,function(e,r,n,i){t.push(n?i.replace(Q,"$1"):r||e)}),t});F.Cache=_;var ge=Array.isArray;e.exports=K}).call(t,function(){return this}())},function(e,t,r){"use strict";e.exports={INVALID_TYPE:"Expected type {0} but found type {1}",INVALID_FORMAT:"Object didn't pass validation for format {0}: {1}",ENUM_MISMATCH:"No enum match for: {0}",ANY_OF_MISSING:"Data does not match any schemas from 'anyOf'",ONE_OF_MISSING:"Data does not match any schemas from 'oneOf'",ONE_OF_MULTIPLE:"Data is valid against more than one schema from 'oneOf'",NOT_PASSED:"Data matches schema from 'not'",ARRAY_LENGTH_SHORT:"Array is too short ({0}), minimum {1}",ARRAY_LENGTH_LONG:"Array is too long ({0}), maximum {1}",ARRAY_UNIQUE:"Array items are not unique (indexes {0} and {1})",ARRAY_ADDITIONAL_ITEMS:"Additional items not allowed",MULTIPLE_OF:"Value {0} is not a multiple of {1}",MINIMUM:"Value {0} is less than minimum {1}",MINIMUM_EXCLUSIVE:"Value {0} is equal or less than exclusive minimum {1}",MAXIMUM:"Value {0} is greater than maximum {1}",MAXIMUM_EXCLUSIVE:"Value {0} is equal or greater than exclusive maximum {1}",OBJECT_PROPERTIES_MINIMUM:"Too few properties defined ({0}), minimum {1}",OBJECT_PROPERTIES_MAXIMUM:"Too many properties defined ({0}), maximum {1}",OBJECT_MISSING_REQUIRED_PROPERTY:"Missing required property: {0}",OBJECT_ADDITIONAL_PROPERTIES:"Additional properties not allowed: {0}",OBJECT_DEPENDENCY_KEY:"Dependency failed - key must exist: {0} (due to key: {1})",MIN_LENGTH:"String is too short ({0} chars), minimum {1}",MAX_LENGTH:"String is too long ({0} chars), maximum {1}",PATTERN:"String does not match pattern {0}: {1}",KEYWORD_TYPE_EXPECTED:"Keyword '{0}' is expected to be of type '{1}'",KEYWORD_UNDEFINED_STRICT:"Keyword '{0}' must be defined in strict mode",KEYWORD_UNEXPECTED:"Keyword '{0}' is not expected to appear in the schema",KEYWORD_MUST_BE:"Keyword '{0}' must be {1}",KEYWORD_DEPENDENCY:"Keyword '{0}' requires keyword '{1}'",KEYWORD_PATTERN:"Keyword '{0}' is not a valid RegExp pattern: {1}",KEYWORD_VALUE_TYPE:"Each element of keyword '{0}' array must be a '{1}'",UNKNOWN_FORMAT:"There is no validation function for format '{0}'",CUSTOM_MODE_FORCE_PROPERTIES:"{0} must define at least one property if present",REF_UNRESOLVED:"Reference has not been resolved during compilation: {0}",UNRESOLVABLE_REFERENCE:"Reference could not be resolved: {0}",SCHEMA_NOT_REACHABLE:"Validator was not able to read schema with uri: {0}",SCHEMA_TYPE_EXPECTED:"Schema is expected to be of type 'object'",SCHEMA_NOT_AN_OBJECT:"Schema is not an object: {0}",ASYNC_TIMEOUT:"{0} asynchronous task(s) have timed out after {1} ms",PARENT_SCHEMA_VALIDATION_FAILED:"Schema failed to validate against its parent schema, see inner errors for details.",REMOTE_NOT_VALID:"Remote reference didn't compile successfully: {0}"}},function(e,t,r){e.exports={id:"http://json-schema.org/draft-04/schema#",$schema:"http://json-schema.org/draft-04/schema#",description:"Core schema meta-schema",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},positiveInteger:{type:"integer",minimum:0},positiveIntegerDefault0:{allOf:[{$ref:"#/definitions/positiveInteger"},{"default":0}]},simpleTypes:{"enum":["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},minItems:1,uniqueItems:!0}},type:"object",properties:{id:{type:"string",format:"uri"},$schema:{type:"string",format:"uri"},title:{type:"string"},description:{type:"string"},"default":{},multipleOf:{type:"number",minimum:0,exclusiveMinimum:!0},maximum:{type:"number"},exclusiveMaximum:{type:"boolean","default":!1},minimum:{type:"number"},exclusiveMinimum:{type:"boolean","default":!1},maxLength:{$ref:"#/definitions/positiveInteger"},minLength:{$ref:"#/definitions/positiveIntegerDefault0"},pattern:{type:"string",format:"regex"},additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}],"default":{}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],"default":{}},maxItems:{$ref:"#/definitions/positiveInteger"},minItems:{$ref:"#/definitions/positiveIntegerDefault0"},uniqueItems:{type:"boolean","default":!1},maxProperties:{$ref:"#/definitions/positiveInteger"},minProperties:{$ref:"#/definitions/positiveIntegerDefault0"},required:{$ref:"#/definitions/stringArray"},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}],"default":{}},definitions:{type:"object",additionalProperties:{$ref:"#"},"default":{}},properties:{type:"object",additionalProperties:{$ref:"#"},"default":{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},"default":{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},"enum":{type:"array",minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{type:"string"},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"}},dependencies:{exclusiveMaximum:["maximum"],exclusiveMinimum:["minimum"]},"default":{}}},function(e,t,r){e.exports={$schema:"http://json-schema.org/draft-04/hyper-schema#",id:"http://json-schema.org/draft-04/hyper-schema#",title:"JSON Hyper-Schema",allOf:[{$ref:"http://json-schema.org/draft-04/schema#"}],properties:{additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}]},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}]},dependencies:{additionalProperties:{anyOf:[{$ref:"#"},{type:"array"}]}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}]},definitions:{additionalProperties:{$ref:"#"}},patternProperties:{additionalProperties:{$ref:"#"}},properties:{additionalProperties:{$ref:"#"}},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"},links:{type:"array",items:{$ref:"#/definitions/linkDescription"}},fragmentResolution:{type:"string"},media:{type:"object",properties:{type:{description:"A media type, as described in RFC 2046",type:"string"},binaryEncoding:{description:"A content encoding scheme, as described in RFC 2045",type:"string"}}},pathStart:{description:"Instances' URIs must start with this value for this schema to apply to them",type:"string",format:"uri"}},definitions:{schemaArray:{type:"array",items:{$ref:"#"}},linkDescription:{title:"Link Description Object",type:"object",required:["href","rel"],properties:{href:{description:"a URI template, as defined by RFC 6570, with the addition of the $, ( and ) characters for pre-processing",type:"string"},rel:{description:"relation to the target resource of the link",type:"string"},title:{description:"a title for the link",type:"string"},targetSchema:{description:"JSON Schema describing the link target",$ref:"#"},mediaType:{description:"media type (as defined by RFC 2046) describing the link target",type:"string"},method:{description:'method for requesting the target of the link (e.g. for HTTP this might be "GET" or "DELETE")',type:"string"},encType:{description:"The media type in which to submit data along with the request",type:"string","default":"application/json"},schema:{description:"Schema describing the data to submit along with the request",$ref:"#"}}}}}},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}Object.defineProperty(t,"__esModule",{value:!0});var i=r(16),o=n(i),a=r(17),s=n(a),u=r(18),l=n(u),f=r(19),d=n(f),c=r(20),p=n(c),h=r(21),m=n(h),_=r(22),y=n(_),E=r(23),v=n(E),g=r(24),O=n(g),b=r(25),A=n(b),x=r(26),R=n(x),P=r(27),M=n(P),T=r(28),I=n(T),D=r(29),S=n(D),$=r(30),j=n($),F=r(31),w=n(F),N=r(32),C=n(N),Y=r(33),U=n(Y),L=r(34),K=n(L),W=r(35),k=n(W),B=r(36),q=n(B),V=r(37),X=n(V),Z=r(38),H=n(Z),z=r(39),J=n(z),G=r(40),Q=n(G),ee=r(41),te=n(ee),re=r(42),ne=n(re),ie=r(43),oe=n(ie),ae=r(44),se=n(ae),ue=r(45),le=n(ue),fe=r(46),de=n(fe),ce=r(47),pe=n(ce),he=r(48),me=n(he),_e=r(49),ye=n(_e),Ee=r(50),ve=n(Ee),ge=r(51),Oe=n(ge),be=r(52),Ae=n(be),xe=r(53),Re=n(xe),Pe=r(54),Me=n(Pe),Te=r(55),Ie=n(Te),De=r(56),Se=n(De),$e=r(57),je=n($e),Fe=r(58),we=n(Fe),Ne=r(59),Ce=n(Ne),Ye=r(60),Ue=n(Ye),Le=r(61),Ke=n(Le),We=r(62),ke=n(We),Be=r(63),qe=n(Be),Ve=r(64),Xe=n(Ve),Ze=r(65),He=n(Ze),ze=r(66),Je=n(ze),Ge=r(67),Qe=n(Ge),et=r(68),tt=n(et),rt=r(69),nt=n(rt),it=r(70),ot=n(it),at=r(71),st=n(at),ut=r(72),lt=n(ut),ft=r(73),dt=n(ft),ct=r(74),pt=n(ct),ht=r(75),mt=n(ht),_t="5.7.0",yt={version:_t,toDate:o["default"],toFloat:s["default"],toInt:l["default"],toBoolean:d["default"],equals:p["default"],contains:m["default"],matches:y["default"],isEmail:v["default"],isURL:O["default"],isMACAddress:A["default"],isIP:R["default"],isFQDN:M["default"],isBoolean:I["default"],isAlpha:S["default"],isAlphanumeric:j["default"],isNumeric:w["default"],isLowercase:C["default"],isUppercase:U["default"],isAscii:K["default"],isFullWidth:k["default"],isHalfWidth:q["default"],isVariableWidth:X["default"],isMultibyte:H["default"],isSurrogatePair:J["default"],isInt:Q["default"],isFloat:te["default"],isDecimal:ne["default"],isHexadecimal:oe["default"],isDivisibleBy:se["default"],isHexColor:le["default"],isMD5:de["default"],isJSON:pe["default"],isNull:me["default"],isLength:ye["default"],isByteLength:ve["default"],isUUID:Oe["default"],isMongoId:Ae["default"],isDate:Re["default"],isAfter:Me["default"],isBefore:Ie["default"],isIn:Se["default"],isCreditCard:je["default"],isISIN:we["default"],isISBN:Ce["default"],isMobilePhone:Ue["default"],isCurrency:Ke["default"],isISO8601:ke["default"],isBase64:qe["default"],isDataURI:Xe["default"],ltrim:He["default"],rtrim:Je["default"],trim:Qe["default"],escape:tt["default"],unescape:nt["default"],stripLow:ot["default"],whitelist:st["default"],blacklist:lt["default"],isWhitelisted:dt["default"],normalizeEmail:pt["default"],toString:mt["default"]};t["default"]=yt,e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),e=Date.parse(e),isNaN(e)?null:new Date(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),parseFloat(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),parseInt(e,t||10)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),t?"1"===e||"true"===e:"0"!==e&&"false"!==e&&""!==e}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),e===t}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),e.indexOf(u["default"](t))>=0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(75),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t,r){return a["default"](e),"[object RegExp]"!==Object.prototype.toString.call(t)&&(t=new RegExp(t,r)),t.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){if(a["default"](e),t=u["default"](t,p),t.allow_display_name){var r=e.match(h);r&&(e=r[1])}var n=e.split("@"),i=n.pop(),o=n.join("@"),s=i.toLowerCase();if(("gmail.com"===s||"googlemail.com"===s)&&(o=o.replace(/\./g,"").toLowerCase()),!f["default"](o,{max:64})||!f["default"](i,{max:256}))return!1;if(!c["default"](i,{require_tld:t.require_tld}))return!1;if('"'===o[0])return o=o.slice(1,o.length-1),t.allow_utf8_local_part?E.test(o):_.test(o);for(var l=t.allow_utf8_local_part?y:m,d=o.split("."),v=0;v<d.length;v++)if(!l.test(d[v]))return!1;return!0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(77),u=n(s),l=r(50),f=n(l),d=r(27),c=n(d),p={allow_display_name:!1,allow_utf8_local_part:!0,require_tld:!0},h=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i,m=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i,_=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i,y=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i,E=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function o(e,t){for(var r=0;r<t.length;r++){var n=t[r];if(e===n||i(n)&&n.test(e))return!0}return!1}function a(e,t){if(u["default"](e),!e||e.length>=2083||/\s/.test(e))return!1;if(0===e.indexOf("mailto:"))return!1;t=h["default"](t,m);var r=void 0,n=void 0,i=void 0,a=void 0,s=void 0,l=void 0,d=void 0,p=void 0;if(d=e.split("#"),e=d.shift(),d=e.split("?"),e=d.shift(),d=e.split("://"),d.length>1){if(r=d.shift(),t.require_valid_protocol&&-1===t.protocols.indexOf(r))return!1}else{if(t.require_protocol)return!1;t.allow_protocol_relative_urls&&"//"===e.substr(0,2)&&(d[0]=e.substr(2))}if(e=d.join("://"),d=e.split("/"),e=d.shift(),""===e&&!t.require_host)return!0;if(d=e.split("@"),d.length>1&&(n=d.shift(),n.indexOf(":")>=0&&n.split(":").length>2))return!1;a=d.join("@"),l=p=null;var y=a.match(_);return y?(i="",p=y[1],l=y[2]||null):(d=a.split(":"),i=d.shift(),d.length&&(l=d.join(":"))),null!==l&&(s=parseInt(l,10),!/^[0-9]+$/.test(l)||0>=s||s>65535)?!1:c["default"](i)||f["default"](i,t)||p&&c["default"](p,6)||"localhost"===i?(i=i||p,t.host_whitelist&&!o(i,t.host_whitelist)?!1:t.host_blacklist&&o(i,t.host_blacklist)?!1:!0):!1}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=a;var s=r(76),u=n(s),l=r(27),f=n(l),d=r(26),c=n(d),p=r(77),h=n(p),m={protocols:["http","https","ftp"],require_tld:!0,require_protocol:!1,require_host:!0,require_valid_protocol:!0,allow_underscores:!1,allow_trailing_dot:!1,allow_protocol_relative_urls:!1},_=/^\[([^\]]+)\](?::([0-9]+))?$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if(a["default"](e),t=String(t),!t)return i(e,4)||i(e,6);if("4"===t){if(!s.test(e))return!1;var r=e.split(".").sort(function(e,t){return e-t});return r[3]<=255}if("6"===t){var n=e.split(":"),o=!1,l=i(n[n.length-1],4),f=l?7:8;if(n.length>f)return!1;if("::"===e)return!0;"::"===e.substr(0,2)?(n.shift(),n.shift(),o=!0):"::"===e.substr(e.length-2)&&(n.pop(),n.pop(),o=!0);for(var d=0;d<n.length;++d)if(""===n[d]&&d>0&&d<n.length-1){if(o)return!1;o=!0}else if(l&&d===n.length-1);else if(!u.test(n[d]))return!1;return o?n.length>=1:n.length===f}return!1}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/,u=/^[0-9A-F]{1,4}$/i;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){a["default"](e),t=u["default"](t,l),t.allow_trailing_dot&&"."===e[e.length-1]&&(e=e.substring(0,e.length-1));var r=e.split(".");if(t.require_tld){var n=r.pop();if(!r.length||!/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(n))return!1}for(var i,o=0;o<r.length;o++){if(i=r[o],t.allow_underscores&&(i=i.replace(/_/g,"")),!/^[a-z\u00a1-\uffff0-9-]+$/i.test(i))return!1;if(/[\uff01-\uff5e]/.test(i))return!1;if("-"===i[0]||"-"===i[i.length-1])return!1}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(77),u=n(s),l={require_tld:!0,allow_underscores:!1,allow_trailing_dot:!1};e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),["true","false","1","0"].indexOf(e)>=0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if(a["default"](e),t in s.alpha)return s.alpha[t].test(e);throw new Error("Invalid locale '"+t+"'")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(78);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if(a["default"](e),t in s.alphanumeric)return s.alphanumeric[t].test(e);throw new Error("Invalid locale '"+t+"'")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(78);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^[-+]?[0-9]+$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),e===e.toLowerCase()}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),e===e.toUpperCase()}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^[\x00-\x7F]+$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.fullWidth=void 0,t["default"]=i;var o=r(76),a=n(o),s=t.fullWidth=/[^\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.halfWidth=void 0,t["default"]=i;var o=r(76),a=n(o),s=t.halfWidth=/[\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.fullWidth.test(e)&&u.halfWidth.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(35),u=r(36);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/[^\x00-\x7F]/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/[\uD800-\uDBFF][\uDC00-\uDFFF]/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){a["default"](e),t=t||{};var r=t.hasOwnProperty("allow_leading_zeroes")&&t.allow_leading_zeroes?u:s,n=!t.hasOwnProperty("min")||e>=t.min,i=!t.hasOwnProperty("max")||e<=t.max;return r.test(e)&&n&&i}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^(?:[-+]?(?:0|[1-9][0-9]*))$/,u=/^[-+]?[0-9]+$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),t=t||{},""===e||"."===e?!1:s.test(e)&&(!t.hasOwnProperty("min")||e>=t.min)&&(!t.hasOwnProperty("max")||e<=t.max)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^(?:[-+]?(?:[0-9]+))?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),""!==e&&s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^[-+]?([0-9]+|\.[0-9]+|[0-9]+\.[0-9]+)$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^[0-9A-F]+$/i;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),u["default"](e)%parseInt(t,10)===0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(17),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^[a-f0-9]{32}$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){s["default"](e);try{var t=JSON.parse(e);return!!t&&"object"===("undefined"==typeof t?"undefined":o(t))}catch(r){}return!1}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};t["default"]=i;var a=r(76),s=n(a);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),0===e.length}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){s["default"](e);var r=void 0,n=void 0;"object"===("undefined"==typeof t?"undefined":o(t))?(r=t.min||0,n=t.max):(r=arguments[1],n=arguments[2]);var i=e.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g)||[],a=e.length-i.length;return a>=r&&("undefined"==typeof n||n>=a)}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};t["default"]=i;var a=r(76),s=n(a);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){
return e&&e.__esModule?e:{"default":e}}function i(e,t){s["default"](e);var r=void 0,n=void 0;"object"===("undefined"==typeof t?"undefined":o(t))?(r=t.min||0,n=t.max):(r=arguments[1],n=arguments[2]);var i=encodeURI(e).split(/%..|./).length-1;return i>=r&&("undefined"==typeof n||n>=i)}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};t["default"]=i;var a=r(76),s=n(a);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?"all":arguments[1];a["default"](e);var r=s[t];return r&&r.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s={3:/^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,4:/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,5:/^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,all:/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i};e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),u["default"](e)&&24===e.length}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(43),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=e.match(u.iso8601),r=void 0,n=void 0,i=void 0,o=void 0;if(t){if(r=t[21],!r)return t[12]?null:0;if("z"===r||"Z"===r)return 0;n=t[22],-1!==r.indexOf(":")?(i=parseInt(t[23],10),o=parseInt(t[24],10)):(i=0,o=parseInt(t[23],10))}else{if(e=e.toLowerCase(),r=e.match(/(?:\s|gmt\s*)(-|\+)(\d{1,4})(\s|$)/),!r)return-1!==e.indexOf("gmt")?0:null;n=r[1];var a=r[2];3===a.length&&(a="0"+a),a.length<=2?(i=0,o=parseInt(a,10)):(i=parseInt(a.slice(0,2),10),o=parseInt(a.slice(2,4),10))}return(60*i+o)*("-"===n?1:-1)}function o(e){s["default"](e);var t=new Date(Date.parse(e));if(isNaN(t))return!1;var r=i(e);if(null!==r){var n=t.getTimezoneOffset()-r;t=new Date(t.getTime()+6e4*n)}var o=String(t.getDate()),a=void 0,u=void 0,l=void 0;return(u=e.match(/(^|[^:\d])[23]\d([^T:\d]|$)/g))?(a=u.map(function(e){return e.match(/\d+/g)[0]}).join("/"),l=String(t.getFullYear()).slice(-2),a===o||a===l?!0:a===""+o/l||a===""+l/o?!0:!1):!0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=o;var a=r(76),s=n(a),u=r(62);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];a["default"](e);var r=u["default"](t),n=u["default"](e);return!!(n&&r&&n>r)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(16),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];a["default"](e);var r=u["default"](t),n=u["default"](e);return!!(n&&r&&r>n)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(16),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){s["default"](e);var r=void 0;if("[object Array]"===Object.prototype.toString.call(t)){var n=[];for(r in t)({}).hasOwnProperty.call(t,r)&&(n[r]=l["default"](t[r]));return n.indexOf(e)>=0}return"object"===("undefined"==typeof t?"undefined":o(t))?t.hasOwnProperty(e):t&&"function"==typeof t.indexOf?t.indexOf(e)>=0:!1}Object.defineProperty(t,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};t["default"]=i;var a=r(76),s=n(a),u=r(75),l=n(u);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){a["default"](e);var t=e.replace(/[^0-9]+/g,"");if(!s.test(t))return!1;for(var r=0,n=void 0,i=void 0,o=void 0,u=t.length-1;u>=0;u--)n=t.substring(u,u+1),i=parseInt(n,10),o?(i*=2,r+=i>=10?i%10+1:i):r+=i,o=!o;return!!(r%10===0?t:!1)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})|62[0-9]{14}$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){if(a["default"](e),!s.test(e))return!1;for(var t=e.replace(/[A-Z]/g,function(e){return parseInt(e,36)}),r=0,n=void 0,i=void 0,o=!0,u=t.length-2;u>=0;u--)n=t.substring(u,u+1),i=parseInt(n,10),o?(i*=2,r+=i>=10?i+1:i):r+=i,o=!o;return parseInt(e.substr(e.length-1),10)===(1e4-r)%10}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^[A-Z]{2}[0-9A-Z]{9}[0-9]$/;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if(a["default"](e),t=String(t),!t)return i(e,10)||i(e,13);var r=e.replace(/[\s-]+/g,""),n=0,o=void 0;if("10"===t){if(!s.test(r))return!1;for(o=0;9>o;o++)n+=(o+1)*r.charAt(o);if(n+="X"===r.charAt(9)?100:10*r.charAt(9),n%11===0)return!!r}else if("13"===t){if(!u.test(r))return!1;for(o=0;12>o;o++)n+=l[o%2]*r.charAt(o);if(r.charAt(12)-(10-n%10)%10===0)return!!r}return!1}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^(?:[0-9]{9}X|[0-9]{10})$/,u=/^(?:[0-9]{13})$/,l=[1,3];e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),t in s?s[t].test(e):!1}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s={"ar-DZ":/^(\+?213|0)(5|6|7)\d{8}$/,"ar-SY":/^(!?(\+?963)|0)?9\d{8}$/,"ar-SA":/^(!?(\+?966)|0)?5\d{8}$/,"en-US":/^(\+?1)?[2-9]\d{2}[2-9](?!11)\d{6}$/,"cs-CZ":/^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"de-DE":/^(\+?49[ \.\-])?([\(]{1}[0-9]{1,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,"da-DK":/^(\+?45)?(\d{8})$/,"el-GR":/^(\+?30)?(69\d{8})$/,"en-AU":/^(\+?61|0)4\d{8}$/,"en-GB":/^(\+?44|0)7\d{9}$/,"en-HK":/^(\+?852\-?)?[569]\d{3}\-?\d{4}$/,"en-IN":/^(\+?91|0)?[789]\d{9}$/,"en-NZ":/^(\+?64|0)2\d{7,9}$/,"en-ZA":/^(\+?27|0)\d{9}$/,"en-ZM":/^(\+?26)?09[567]\d{7}$/,"es-ES":/^(\+?34)?(6\d{1}|7[1234])\d{7}$/,"fi-FI":/^(\+?358|0)\s?(4(0|1|2|4|5)?|50)\s?(\d\s?){4,8}\d$/,"fr-FR":/^(\+?33|0)[67]\d{8}$/,"hu-HU":/^(\+?36)(20|30|70)\d{7}$/,"it-IT":/^(\+?39)?\s?3\d{2} ?\d{6,7}$/,"ja-JP":/^(\+?81|0)\d{1,4}[ \-]?\d{1,4}[ \-]?\d{4}$/,"ms-MY":/^(\+?6?01){1}(([145]{1}(\-|\s)?\d{7,8})|([236789]{1}(\s|\-)?\d{7}))$/,"nb-NO":/^(\+?47)?[49]\d{7}$/,"nl-BE":/^(\+?32|0)4?\d{8}$/,"nn-NO":/^(\+?47)?[49]\d{7}$/,"pl-PL":/^(\+?48)? ?[5-8]\d ?\d{3} ?\d{2} ?\d{2}$/,"pt-BR":/^(\+?55|0)\-?[1-9]{2}\-?[2-9]{1}\d{3,4}\-?\d{4}$/,"pt-PT":/^(\+?351)?9[1236]\d{7}$/,"ru-RU":/^(\+?7|8)?9\d{9}$/,"sr-RS":/^(\+3816|06)[- \d]{5,9}$/,"tr-TR":/^(\+?90|0)?5\d{9}$/,"vi-VN":/^(\+?84|0)?((1(2([0-9])|6([2-9])|88|99))|(9((?!5)[0-9])))([0-9]{7})$/,"zh-CN":/^(\+?0?86\-?)?1[345789]\d{9}$/,"zh-TW":/^(\+?886\-?|0)?9\d{8}$/};s["en-CA"]=s["en-US"],s["fr-BE"]=s["nl-BE"],e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){var t="(\\"+e.symbol.replace(/\./g,"\\.")+")"+(e.require_symbol?"":"?"),r="-?",n="[1-9]\\d*",i="[1-9]\\d{0,2}(\\"+e.thousands_separator+"\\d{3})*",o=["0",n,i],a="("+o.join("|")+")?",s="(\\"+e.decimal_separator+"\\d{2})?",u=a+s;return e.allow_negatives&&!e.parens_for_negatives&&(e.negative_sign_after_digits?u+=r:e.negative_sign_before_digits&&(u=r+u)),e.allow_negative_sign_placeholder?u="( (?!\\-))?"+u:e.allow_space_after_symbol?u=" ?"+u:e.allow_space_after_digits&&(u+="( (?!$))?"),e.symbol_after_digits?u+=t:u=t+u,e.allow_negatives&&(e.parens_for_negatives?u="(\\("+u+"\\)|"+u+")":e.negative_sign_before_digits||e.negative_sign_after_digits||(u=r+u)),new RegExp("^(?!-? )(?=.*\\d)"+u+"$")}function o(e,t){return l["default"](e),t=s["default"](t,f),i(t).test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=o;var a=r(77),s=n(a),u=r(76),l=n(u),f={symbol:"$",require_symbol:!1,allow_space_after_symbol:!1,symbol_after_digits:!1,allow_negatives:!0,parens_for_negatives:!1,negative_sign_before_digits:!1,negative_sign_after_digits:!1,allow_negative_sign_placeholder:!1,thousands_separator:",",decimal_separator:".",allow_space_after_digits:!1};e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}Object.defineProperty(t,"__esModule",{value:!0}),t.iso8601=void 0,t["default"]=function(e){return o["default"](e),a.test(e)};var i=r(76),o=n(i),a=t.iso8601=/^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){a["default"](e);var t=e.length;if(!t||t%4!==0||s.test(e))return!1;var r=e.indexOf("=");return-1===r||r===t-1||r===t-2&&"="===e[t-1]}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/[^A-Z0-9+\/=]/i;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),s.test(e)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=/^\s*data:([a-z]+\/[a-z0-9\-\+]+(;[a-z\-]+=[a-z0-9\-]+)?)?(;base64)?,[a-z0-9!\$&',\(\)\*\+,;=\-\._~:@\/\?%\s]*\s*$/i;e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){a["default"](e);var r=t?new RegExp("^["+t+"]+","g"):/^\s+/g;return e.replace(r,"")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){a["default"](e);for(var r=t?new RegExp("["+t+"]"):/\s/,n=e.length-1;n>=0&&r.test(e[n]);)n--;return n<e.length?e.substr(0,n+1):e}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](u["default"](e,t),t)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(66),a=n(o),s=r(65),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),e.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\//g,"&#x2F;").replace(/`/g,"&#96;")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e){return a["default"](e),e.replace(/&amp;/g,"&").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#x2F;/g,"/").replace(/&#96;/g,"`")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){a["default"](e);var r=t?"\\x00-\\x09\\x0B\\x0C\\x0E-\\x1F\\x7F":"\\x00-\\x1F\\x7F";return u["default"](e,r)}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o),s=r(72),u=n(s);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),e.replace(new RegExp("[^"+t+"]+","g"),"")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){return a["default"](e),e.replace(new RegExp("["+t+"]+","g"),"")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){a["default"](e);for(var r=e.length-1;r>=0;r--)if(-1===t.indexOf(e[r]))return!1;return!0}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(76),a=n(o);e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){if(t=u["default"](t,l),!a["default"](e))return!1;var r=e.split("@",2);if(r[1]=r[1].toLowerCase(),"gmail.com"===r[1]||"googlemail.com"===r[1]){if(t.remove_extension&&(r[0]=r[0].split("+")[0]),t.remove_dots&&(r[0]=r[0].replace(/\./g,"")),!r[0].length)return!1;r[0]=r[0].toLowerCase(),r[1]="gmail.com"}else t.lowercase&&(r[0]=r[0].toLowerCase());return r.join("@")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=i;var o=r(23),a=n(o),s=r(77),u=n(s),l={lowercase:!0,remove_dots:!0,remove_extension:!0};e.exports=t["default"]},function(e,t,r){"use strict";function n(e){return"object"===("undefined"==typeof e?"undefined":i(e))&&null!==e?e="function"==typeof e.toString?e.toString():"[object Object]":(null===e||"undefined"==typeof e||isNaN(e)&&!e.length)&&(e=""),String(e)}Object.defineProperty(t,"__esModule",{value:!0});var i="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol?"symbol":typeof e};t["default"]=n,e.exports=t["default"]},function(e,t,r){"use strict";function n(e){if("string"!=typeof e)throw new TypeError("This library (validator.js) validates strings only")}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=n,e.exports=t["default"]},function(e,t,r){"use strict";function n(){var e=arguments.length<=0||void 0===arguments[0]?{}:arguments[0],t=arguments[1];for(var r in t)"undefined"==typeof e[r]&&(e[r]=t[r]);return e}Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=n,e.exports=t["default"]},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});for(var n,i=t.alpha={"en-US":/^[A-Z]+$/i,"cs-CZ":/^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[A-ZÄÖÜß]+$/i,"es-ES":/^[A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"nl-NL":/^[A-ZÉËÏÓÖÜ]+$/i,"hu-HU":/^[A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"pl-PL":/^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[А-ЯЁ]+$/i,"sr-RS@latin":/^[A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[A-ZÇĞİıÖŞÜ]+$/i,ar:/^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},o=t.alphanumeric={"en-US":/^[0-9A-Z]+$/i,"cs-CZ":/^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[0-9A-ZÄÖÜß]+$/i,"es-ES":/^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"hu-HU":/^[0-9A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"nl-NL":/^[0-9A-ZÉËÏÓÖÜ]+$/i,"pl-PL":/^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[0-9А-ЯЁ]+$/i,"sr-RS@latin":/^[0-9A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[0-9А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[0-9A-ZÇĞİıÖŞÜ]+$/i,ar:/^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},a=t.englishLocales=["AU","GB","HK","IN","NZ","ZA","ZM"],s=0;s<a.length;s++)n="en-"+a[s],i[n]=i["en-US"],o[n]=o["en-US"];i["pt-BR"]=i["pt-PT"],o["pt-BR"]=o["pt-PT"];for(var u,l=t.arabicLocales=["AE","BH","DZ","EG","IQ","JO","KW","LB","LY","MA","QM","QA","SA","SD","SY","TN","YE"],f=0;f<l.length;f++)u="ar-"+l[f],i[u]=i.ar,o[u]=o.ar}])});
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define(factory);
	else if(typeof exports === 'object')
		exports["RAML.XmlValidation"] = factory();
	else
		root["RAML.XmlValidation"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var validator = __webpack_require__(1);
	var XMLValidator = (function () {
	    function XMLValidator(schema) {
	        this.schema = schema;
	    }
	    XMLValidator.prototype.validate = function (xml, references) {
	        if (references === void 0) { references = []; }
	        if (references.length === 0) {
	            var result = validator.validateXML({ xml: xml, schema: this.schema });
	            return (result && result.errors && result.errors.map(function (error) { return new Error(error); })) || [];
	        }
	        var schemas = this.remoteSchemas(references);
	        schemas.push(this.schema);
	        var result = validator.validateXML({ xml: xml, schema: schemas });
	        return (result && result.errors && result.errors.map(function (error) {
	            return new Error(error);
	        })) || [];
	    };
	    XMLValidator.prototype.remoteSchemas = function (refs) {
	        return refs.map(function (ref) { return ref.patchedContent; });
	    };
	    return XMLValidator;
	}());
	exports.XMLValidator = XMLValidator;
	var XMLSchemaReference = (function () {
	    function XMLSchemaReference(originalPath, virtualIndex, patchedContent) {
	        this.originalPath = originalPath;
	        this.virtualIndex = virtualIndex;
	        this.patchedContent = patchedContent;
	    }
	    return XMLSchemaReference;
	}());
	exports.XMLSchemaReference = XMLSchemaReference;
	//# sourceMappingURL=index.js.map

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {var xmllint={},errrCount=0;!function(){var module=void 0,process=void 0,require=void 0;if("undefined"==typeof window)var window={};xmllint.validateXML=function(options){function globalEval(e){eval.call(null,e)}function assert(e,i){e||abort("Assertion failed: "+i)}function getCFunc(ident){var func=Module["_"+ident];if(!func)try{func=eval("_"+ident)}catch(e){}return assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)"),func}function setValue(e,i,r,n){switch(r=r||"i8","*"===r.charAt(r.length-1)&&(r="i32"),r){case"i1":HEAP8[e>>0]=i;break;case"i8":HEAP8[e>>0]=i;break;case"i16":HEAP16[e>>1]=i;break;case"i32":HEAP32[e>>2]=i;break;case"i64":tempI64=[i>>>0,(tempDouble=i,+Math_abs(tempDouble)>=1?tempDouble>0?(0|Math_min(+Math_floor(tempDouble/4294967296),4294967295))>>>0:~~+Math_ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[e>>2]=tempI64[0],HEAP32[e+4>>2]=tempI64[1];break;case"float":HEAPF32[e>>2]=i;break;case"double":HEAPF64[e>>3]=i;break;default:abort("invalid type for setValue: "+r)}}function getValue(e,i,r){switch(i=i||"i8","*"===i.charAt(i.length-1)&&(i="i32"),i){case"i1":return HEAP8[e>>0];case"i8":return HEAP8[e>>0];case"i16":return HEAP16[e>>1];case"i32":return HEAP32[e>>2];case"i64":return HEAP32[e>>2];case"float":return HEAPF32[e>>2];case"double":return HEAPF64[e>>3];default:abort("invalid type for setValue: "+i)}return null}function allocate(e,i,r,n){var f,t;"number"==typeof e?(f=!0,t=e):(f=!1,t=e.length);var u,a="string"==typeof i?i:null;if(u=r==ALLOC_NONE?n:[_malloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][void 0===r?ALLOC_STATIC:r](Math.max(t,a?1:i.length)),f){var o,n=u;for(assert(0==(3&u)),o=u+(t&-4);n<o;n+=4)HEAP32[n>>2]=0;for(o=u+t;n<o;)HEAP8[n++>>0]=0;return u}if("i8"===a)return e.subarray||e.slice?HEAPU8.set(e,u):HEAPU8.set(new Uint8Array(e),u),u;for(var c,l,s,b=0;b<t;){var k=e[b];"function"==typeof k&&(k=Runtime.getFunctionIndex(k)),c=a||i[b],0!==c?("i64"==c&&(c="i32"),setValue(u+b,k,c),s!==c&&(l=Runtime.getNativeTypeSize(c),s=c),b+=l):b++}return u}function Pointer_stringify(e,i){if(0===i||!e)return"";for(var r,n=!1,f=0;;){if(r=HEAPU8[e+f>>0],r>=128)n=!0;else if(0==r&&!i)break;if(f++,i&&f==i)break}i||(i=f);var t="";if(!n){for(var u,a=1024;i>0;)u=String.fromCharCode.apply(String,HEAPU8.subarray(e,e+Math.min(i,a))),t=t?t+u:u,e+=a,i-=a;return t}var o=new Runtime.UTF8Processor;for(f=0;f<i;f++)r=HEAPU8[e+f>>0],t+=o.processCChar(r);return t}function UTF16ToString(e){for(var i=0,r="";;){var n=HEAP16[e+2*i>>1];if(0==n)return r;++i,r+=String.fromCharCode(n)}}function stringToUTF16(e,i){for(var r=0;r<e.length;++r){var n=e.charCodeAt(r);HEAP16[i+2*r>>1]=n}HEAP16[i+2*e.length>>1]=0}function UTF32ToString(e){for(var i=0,r="";;){var n=HEAP32[e+4*i>>2];if(0==n)return r;if(++i,n>=65536){var f=n-65536;r+=String.fromCharCode(55296|f>>10,56320|1023&f)}else r+=String.fromCharCode(n)}}function stringToUTF32(e,i){for(var r=0,n=0;n<e.length;++n){var f=e.charCodeAt(n);if(f>=55296&&f<=57343){var t=e.charCodeAt(++n);f=65536+((1023&f)<<10)|1023&t}HEAP32[i+4*r>>2]=f,++r}HEAP32[i+4*r>>2]=0}function demangle(e){function i(){a++,"K"===e[a]&&a++;for(var i=[];"E"!==e[a];)if("S"!==e[a])if("C"!==e[a]){var r=parseInt(e.substr(a)),n=r.toString().length;if(!r||!n){a--;break}var f=e.substr(a+n,r);i.push(f),c.push(f),a+=n+r}else i.push(i[i.length-1]),a+=2;else{a++;var t=e.indexOf("_",a),u=e.substring(a,t)||0;i.push(c[u]||"?"),a=t+1}return a++,i}function r(n,f,t){function u(){return"("+b.join(", ")+")"}f=f||1/0;var c,s="",b=[];if("N"===e[a]){if(c=i().join("::"),f--,0===f)return n?[c]:c}else{("K"===e[a]||l&&"L"===e[a])&&a++;var k=parseInt(e.substr(a));if(k){var h=k.toString().length;c=e.substr(a+h,k),a+=h+k}}if(l=!1,"I"===e[a]){a++;var w=r(!0),d=r(!0,1,!0);s+=d[0]+" "+c+"<"+w.join(", ")+">"}else s=c;e:for(;a<e.length&&f-- >0;){var v=e[a++];if(v in o)b.push(o[v]);else switch(v){case"P":b.push(r(!0,1,!0)[0]+"*");break;case"R":b.push(r(!0,1,!0)[0]+"&");break;case"L":a++;var m=e.indexOf("E",a),k=m-a;b.push(e.substr(a,k)),a+=k+2;break;case"A":var k=parseInt(e.substr(a));if(a+=k.toString().length,"_"!==e[a])throw"?";a++,b.push(r(!0,1,!0)[0]+" ["+k+"]");break;case"E":break e;default:s+="?"+v;break e}}return t||1!==b.length||"void"!==b[0]||(b=[]),n?(s&&b.push(s+"?"),b):s+u()}var n=!!Module.___cxa_demangle;if(n)try{var f=_malloc(e.length);writeStringToMemory(e.substr(1),f);var t=_malloc(4),u=Module.___cxa_demangle(f,0,0,t);if(0===getValue(t,"i32")&&u)return Pointer_stringify(u)}catch(e){}finally{f&&_free(f),t&&_free(t),u&&_free(u)}var a=3,o={v:"void",b:"bool",c:"char",s:"short",i:"int",l:"long",f:"float",d:"double",w:"wchar_t",a:"signed char",h:"unsigned char",t:"unsigned short",j:"unsigned int",m:"unsigned long",x:"long long",y:"unsigned long long",z:"..."},c=[],l=!0,s=e;try{if("Object._main"==e||"_main"==e)return"main()";if("number"==typeof e&&(e=Pointer_stringify(e)),"_"!==e[0])return e;if("_"!==e[1])return e;if("Z"!==e[2])return e;switch(e[3]){case"n":return"operator new()";case"d":return"operator delete()"}s=r()}catch(e){s+="?"}return s.indexOf("?")>=0&&!n&&Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling"),s}function demangleAll(e){return e.replace(/__Z[\w\d_]+/g,function(e){var i=demangle(e);return e===i?e:e+" ["+i+"]"})}function jsStackTrace(){var e=new Error;if(!e.stack){try{throw new Error(0)}catch(i){e=i}if(!e.stack)return"(no stack trace available)"}return e.stack.toString()}function stackTrace(){return demangleAll(jsStackTrace())}function alignMemoryPage(e){return e+4095&-4096}function enlargeMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value "+TOTAL_MEMORY+", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.")}function callRuntimeCallbacks(e){for(;e.length>0;){var i=e.shift();if("function"!=typeof i){var r=i.func;"number"==typeof r?void 0===i.arg?Runtime.dynCall("v",r):Runtime.dynCall("vi",r,[i.arg]):r(void 0===i.arg?null:i.arg)}else i()}}function preRun(){if(Module.preRun)for("function"==typeof Module.preRun&&(Module.preRun=[Module.preRun]);Module.preRun.length;)addOnPreRun(Module.preRun.shift());callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){runtimeInitialized||(runtimeInitialized=!0,callRuntimeCallbacks(__ATINIT__))}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__),runtimeExited=!0}function postRun(){if(Module.postRun)for("function"==typeof Module.postRun&&(Module.postRun=[Module.postRun]);Module.postRun.length;)addOnPostRun(Module.postRun.shift());callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(e){__ATPRERUN__.unshift(e)}function addOnInit(e){__ATINIT__.unshift(e)}function addOnPreMain(e){__ATMAIN__.unshift(e)}function addOnExit(e){__ATEXIT__.unshift(e)}function addOnPostRun(e){__ATPOSTRUN__.unshift(e)}function intArrayFromString(e,i,r){var n=(new Runtime.UTF8Processor).processJSString(e);return r&&(n.length=r),i||n.push(0),n}function intArrayToString(e){for(var i=[],r=0;r<e.length;r++){var n=e[r];n>255&&(n&=255),i.push(String.fromCharCode(n))}return i.join("")}function writeStringToMemory(e,i,r){for(var n=intArrayFromString(e,r),f=0;f<n.length;){var t=n[f];HEAP8[i+f>>0]=t,f+=1}}function writeArrayToMemory(e,i){for(var r=0;r<e.length;r++)HEAP8[i+r>>0]=e[r]}function writeAsciiToMemory(e,i,r){for(var n=0;n<e.length;n++)HEAP8[i+n>>0]=e.charCodeAt(n);r||(HEAP8[i+e.length>>0]=0)}function unSign(e,i,r){return e>=0?e:i<=32?2*Math.abs(1<<i-1)+e:Math.pow(2,i)+e}function reSign(e,i,r){if(e<=0)return e;var n=i<=32?Math.abs(1<<i-1):Math.pow(2,i-1);return e>=n&&(i<=32||e>n)&&(e=-2*n+e),e}function addRunDependency(e){runDependencies++,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies)}function removeRunDependency(e){if(runDependencies--,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies),0==runDependencies&&(null!==runDependencyWatcher&&(clearInterval(runDependencyWatcher),runDependencyWatcher=null),dependenciesFulfilled)){var i=dependenciesFulfilled;dependenciesFulfilled=null,i()}}function copyTempFloat(e){HEAP8[tempDoublePtr]=HEAP8[e],HEAP8[tempDoublePtr+1]=HEAP8[e+1],HEAP8[tempDoublePtr+2]=HEAP8[e+2],HEAP8[tempDoublePtr+3]=HEAP8[e+3]}function copyTempDouble(e){HEAP8[tempDoublePtr]=HEAP8[e],HEAP8[tempDoublePtr+1]=HEAP8[e+1],HEAP8[tempDoublePtr+2]=HEAP8[e+2],HEAP8[tempDoublePtr+3]=HEAP8[e+3],HEAP8[tempDoublePtr+4]=HEAP8[e+4],HEAP8[tempDoublePtr+5]=HEAP8[e+5],HEAP8[tempDoublePtr+6]=HEAP8[e+6],HEAP8[tempDoublePtr+7]=HEAP8[e+7]}function ___assert_fail(e,i,r,n){throw ABORT=!0,"Assertion failed: "+Pointer_stringify(e)+", at: "+[i?Pointer_stringify(i):"unknown filename",r,n?Pointer_stringify(n):"unknown function"]+" at "+stackTrace()}function ___setErrNo(e){return HEAP32[___errno_state>>2]=e,e}function _fflush(e){}function _mkport(){throw"TODO"}function _recv(e,i,r,n){var f=SOCKFS.getSocket(e);return f?_read(e,i,r):(___setErrNo(ERRNO_CODES.EBADF),-1)}function _pread(e,i,r,n){var f=FS.getStream(e);if(!f)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var t=HEAP8;return FS.read(f,t,i,r,n)}catch(e){return FS.handleFSError(e),-1}}function _read(e,i,r){var n=FS.getStream(e);if(!n)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var f=HEAP8;return FS.read(n,f,i,r)}catch(e){return FS.handleFSError(e),-1}}function _fread(e,i,r,n){var f=r*i;if(0==f)return 0;var t=0,u=FS.getStreamFromPtr(n);if(!u)return ___setErrNo(ERRNO_CODES.EBADF),0;for(;u.ungotten.length&&f>0;)HEAP8[e++>>0]=u.ungotten.pop(),f--,t++;var a=_read(u.fd,e,f);return a==-1?(u&&(u.error=!0),0):(t+=a,t<f&&(u.eof=!0),t/i|0)}function _close(e){var i=FS.getStream(e);if(!i)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{return FS.close(i),0}catch(e){return FS.handleFSError(e),-1}}function _fsync(e){var i=FS.getStream(e);return i?0:(___setErrNo(ERRNO_CODES.EBADF),-1)}function _fileno(e){return e=FS.getStreamFromPtr(e),e?e.fd:-1}function _fclose(e){var i=_fileno(e);return _fsync(i),_close(i)}function _strerror_r(e,i,r){if(e in ERRNO_MESSAGES){if(ERRNO_MESSAGES[e].length>r-1)return ___setErrNo(ERRNO_CODES.ERANGE);var n=ERRNO_MESSAGES[e];return writeAsciiToMemory(n,i),0}return ___setErrNo(ERRNO_CODES.EINVAL)}function _strerror(e){return _strerror.buffer||(_strerror.buffer=_malloc(256)),_strerror_r(e,_strerror.buffer,256),_strerror.buffer}function _send(e,i,r,n){var f=SOCKFS.getSocket(e);return f?_write(e,i,r):(___setErrNo(ERRNO_CODES.EBADF),-1)}function _pwrite(e,i,r,n){var f=FS.getStream(e);if(!f)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var t=HEAP8;return FS.write(f,t,i,r,n)}catch(e){return FS.handleFSError(e),-1}}function _write(e,i,r){var n=FS.getStream(e);if(!n)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var f=HEAP8;return FS.write(n,f,i,r)}catch(e){return FS.handleFSError(e),-1}}function _fwrite(e,i,r,n){var f=r*i;if(0==f)return 0;var t=_fileno(n),u=_write(t,e,f);if(u==-1){var a=FS.getStreamFromPtr(n);return a&&(a.error=!0),0}return u/i|0}function _abort(){Module.abort()}function __reallyNegative(e){return e<0||0===e&&1/e===-(1/0)}function __formatString(e,i){function r(e){var r;return"double"===e?(HEAP32[tempDoublePtr>>2]=HEAP32[i+a>>2],HEAP32[tempDoublePtr+4>>2]=HEAP32[i+(a+4)>>2],r=+HEAPF64[tempDoublePtr>>3]):"i64"==e?r=[HEAP32[i+a>>2],HEAP32[i+(a+4)>>2]]:(e="i32",r=HEAP32[i+a>>2]),a+=Runtime.getNativeFieldSize(e),r}for(var n,f,t,u=e,a=0,o=[];;){var c=u;if(n=HEAP8[u>>0],0===n)break;if(f=HEAP8[u+1>>0],37==n){var l=!1,s=!1,b=!1,k=!1,h=!1;e:for(;;){switch(f){case 43:l=!0;break;case 45:s=!0;break;case 35:b=!0;break;case 48:if(k)break e;k=!0;break;case 32:h=!0;break;default:break e}u++,f=HEAP8[u+1>>0]}var w=0;if(42==f)w=r("i32"),u++,f=HEAP8[u+1>>0];else for(;f>=48&&f<=57;)w=10*w+(f-48),u++,f=HEAP8[u+1>>0];var d=!1,v=-1;if(46==f){if(v=0,d=!0,u++,f=HEAP8[u+1>>0],42==f)v=r("i32"),u++;else for(;;){var m=HEAP8[u+1>>0];if(m<48||m>57)break;v=10*v+(m-48),u++}f=HEAP8[u+1>>0]}v<0&&(v=6,d=!1);var _;switch(String.fromCharCode(f)){case"h":var p=HEAP8[u+2>>0];104==p?(u++,_=1):_=2;break;case"l":var p=HEAP8[u+2>>0];108==p?(u++,_=8):_=4;break;case"L":case"q":case"j":_=8;break;case"z":case"t":case"I":_=4;break;default:_=null}switch(_&&u++,f=HEAP8[u+1>>0],String.fromCharCode(f)){case"d":case"i":case"u":case"o":case"x":case"X":case"p":var E=100==f||105==f;_=_||4;var S,t=r("i"+8*_),g=t;if(8==_&&(t=Runtime.makeBigInt(t[0],t[1],117==f)),_<=4){var y=Math.pow(256,_)-1;t=(E?reSign:unSign)(t&y,8*_)}var F=Math.abs(t),O="";if(100==f||105==f)S=8==_&&i64Math?i64Math.stringify(g[0],g[1],null):reSign(t,8*_,1).toString(10);else if(117==f)S=8==_&&i64Math?i64Math.stringify(g[0],g[1],!0):unSign(t,8*_,1).toString(10),t=Math.abs(t);else if(111==f)S=(b?"0":"")+F.toString(8);else if(120==f||88==f){if(O=b&&0!=t?"0x":"",8==_&&i64Math)if(g[1]){S=(g[1]>>>0).toString(16);for(var A=(g[0]>>>0).toString(16);A.length<8;)A="0"+A;S+=A}else S=(g[0]>>>0).toString(16);else if(t<0){t=-t,S=(F-1).toString(16);for(var M=[],R=0;R<S.length;R++)M.push((15-parseInt(S[R],16)).toString(16));for(S=M.join("");S.length<2*_;)S="f"+S}else S=F.toString(16);88==f&&(O=O.toUpperCase(),S=S.toUpperCase())}else 112==f&&(0===F?S="(nil)":(O="0x",S=F.toString(16)));if(d)for(;S.length<v;)S="0"+S;for(t>=0&&(l?O="+"+O:h&&(O=" "+O)),"-"==S.charAt(0)&&(O="-"+O,S=S.substr(1));O.length+S.length<w;)s?S+=" ":k?S="0"+S:O=" "+O;S=O+S,S.split("").forEach(function(e){o.push(e.charCodeAt(0))});break;case"f":case"F":case"e":case"E":case"g":case"G":var S,t=r("double");if(isNaN(t))S="nan",k=!1;else if(isFinite(t)){var N=!1,T=Math.min(v,20);if(103==f||71==f){N=!0,v=v||1;var L=parseInt(t.toExponential(T).split("e")[1],10);v>L&&L>=-4?(f=(103==f?"f":"F").charCodeAt(0),v-=L+1):(f=(103==f?"e":"E").charCodeAt(0),v--),T=Math.min(v,20)}101==f||69==f?(S=t.toExponential(T),/[eE][-+]\d$/.test(S)&&(S=S.slice(0,-1)+"0"+S.slice(-1))):102!=f&&70!=f||(S=t.toFixed(T),0===t&&__reallyNegative(t)&&(S="-"+S));var D=S.split("e");if(N&&!b)for(;D[0].length>1&&D[0].indexOf(".")!=-1&&("0"==D[0].slice(-1)||"."==D[0].slice(-1));)D[0]=D[0].slice(0,-1);else for(b&&S.indexOf(".")==-1&&(D[0]+=".");v>T++;)D[0]+="0";S=D[0]+(D.length>1?"e"+D[1]:""),69==f&&(S=S.toUpperCase()),t>=0&&(l?S="+"+S:h&&(S=" "+S))}else S=(t<0?"-":"")+"inf",k=!1;for(;S.length<w;)s?S+=" ":S=!k||"-"!=S[0]&&"+"!=S[0]?(k?"0":" ")+S:S[0]+"0"+S.slice(1);f<97&&(S=S.toUpperCase()),S.split("").forEach(function(e){o.push(e.charCodeAt(0))});break;case"s":var C=r("i8*"),P=C?_strlen(C):"(null)".length;if(d&&(P=Math.min(P,v)),!s)for(;P<w--;)o.push(32);if(C)for(var R=0;R<P;R++)o.push(HEAPU8[C++>>0]);else o=o.concat(intArrayFromString("(null)".substr(0,P),!0));if(s)for(;P<w--;)o.push(32);break;case"c":for(s&&o.push(r("i8"));--w>0;)o.push(32);s||o.push(r("i8"));break;case"n":var B=r("i32*");HEAP32[B>>2]=o.length;break;case"%":o.push(n);break;default:for(var R=c;R<u+2;R++)o.push(HEAP8[R>>0])}u+=2}else o.push(n),u+=1}return o}function _fprintf(e,i,r){var n=__formatString(i,r),f=Runtime.stackSave(),t=_fwrite(allocate(n,"i8",ALLOC_STACK),1,n.length,e);return Runtime.stackRestore(f),t}function _printf(e,i){var r=HEAP32[_stdout>>2];return _fprintf(r,e,i)}function _fgetc(e){var i=FS.getStreamFromPtr(e);if(!i)return-1;if(i.eof||i.error)return-1;var r=_fread(_fgetc.ret,1,1,e);return 0==r?-1:r==-1?(i.error=!0,-1):HEAPU8[_fgetc.ret>>0]}function _fgets(e,i,r){var n=FS.getStreamFromPtr(r);if(!n)return 0;if(n.error||n.eof)return 0;for(var f,t=0;t<i-1&&10!=f;t++){if(f=_fgetc(r),f==-1){if(n.error||n.eof&&0==t)return 0;if(n.eof)break}HEAP8[e+t>>0]=f}return HEAP8[e+t>>0]=0,e}function _open(e,i,r){var n=HEAP32[r>>2];e=Pointer_stringify(e);try{var f=FS.open(e,i,n);return f.fd}catch(e){return FS.handleFSError(e),-1}}function _fopen(e,i){var r;if(i=Pointer_stringify(i),"r"==i[0])r=i.indexOf("+")!=-1?2:0;else if("w"==i[0])r=i.indexOf("+")!=-1?2:1,r|=64,r|=512;else{if("a"!=i[0])return ___setErrNo(ERRNO_CODES.EINVAL),0;r=i.indexOf("+")!=-1?2:1,r|=64,r|=1024}var n=_open(e,r,allocate([511,0,0,0],"i32",ALLOC_STACK));return n===-1?0:FS.getPtrForStream(FS.getStream(n))}function _fputc(e,i){var r=unSign(255&e);HEAP8[_fputc.ret>>0]=r;var n=_fileno(i),f=_write(n,_fputc.ret,1);if(f==-1){var t=FS.getStreamFromPtr(i);return t&&(t.error=!0),-1}return r}function _mmap(e,i,r,n,f,t){var u,a=!1;if(_mmap.mappings||(_mmap.mappings={}),f==-1){if(u=_malloc(i),!u)return-1;_memset(u,0,i),a=!0}else{var o=FS.getStream(f);if(!o)return-1;try{var c=FS.mmap(o,HEAPU8,e,i,t,r,n);u=c.ptr,a=c.allocated}catch(e){return FS.handleFSError(e),-1}}return _mmap.mappings[u]={malloc:u,num:i,allocated:a},u}function __exit(e){Module.exit(e)}function _exit(e){__exit(e)}function _emscripten_set_main_loop_timing(e,i){return Browser.mainLoop.timingMode=e,Browser.mainLoop.timingValue=i,Browser.mainLoop.func?(0==e?(Browser.mainLoop.scheduler=function(){setTimeout(Browser.mainLoop.runner,i)},Browser.mainLoop.method="timeout"):1==e&&(Browser.mainLoop.scheduler=function(){Browser.requestAnimationFrame(Browser.mainLoop.runner)},Browser.mainLoop.method="rAF"),0):1}function _emscripten_set_main_loop(e,i,r,n){Module.noExitRuntime=!0,assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters."),Browser.mainLoop.func=e,Browser.mainLoop.arg=n;var f=Browser.mainLoop.currentlyRunningMainloop;if(Browser.mainLoop.runner=function(){if(!ABORT){if(Browser.mainLoop.queue.length>0){var i=Date.now(),r=Browser.mainLoop.queue.shift();if(r.func(r.arg),Browser.mainLoop.remainingBlockers){var t=Browser.mainLoop.remainingBlockers,u=t%1==0?t-1:Math.floor(t);r.counted?Browser.mainLoop.remainingBlockers=u:(u+=.5,Browser.mainLoop.remainingBlockers=(8*t+u)/9)}return console.log('main loop blocker "'+r.name+'" took '+(Date.now()-i)+" ms"),Browser.mainLoop.updateStatus(),void setTimeout(Browser.mainLoop.runner,0)}if(!(f<Browser.mainLoop.currentlyRunningMainloop)){if(Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0,1==Browser.mainLoop.timingMode&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0)return void Browser.mainLoop.scheduler();"timeout"===Browser.mainLoop.method&&Module.ctx&&(Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!"),Browser.mainLoop.method=""),Browser.mainLoop.runIter(function(){"undefined"!=typeof n?Runtime.dynCall("vi",e,[n]):Runtime.dynCall("v",e)}),f<Browser.mainLoop.currentlyRunningMainloop||("object"==typeof SDL&&SDL.audio&&SDL.audio.queueNewAudioData&&SDL.audio.queueNewAudioData(),Browser.mainLoop.scheduler())}}},i&&i>0?_emscripten_set_main_loop_timing(0,1e3/i):_emscripten_set_main_loop_timing(1,1),Browser.mainLoop.scheduler(),r)throw"SimulateInfiniteLoop"}function _munmap(e,i){_mmap.mappings||(_mmap.mappings={});var r=_mmap.mappings[e];return r?(i==r.num&&(_mmap.mappings[e]=null,r.allocated&&_free(r.malloc)),0):0}function _stat(e,i,r){e="string"!=typeof e?Pointer_stringify(e):e;try{var n=r?FS.lstat(e):FS.stat(e);return HEAP32[i>>2]=n.dev,HEAP32[i+4>>2]=0,HEAP32[i+8>>2]=n.ino,HEAP32[i+12>>2]=n.mode,HEAP32[i+16>>2]=n.nlink,HEAP32[i+20>>2]=n.uid,HEAP32[i+24>>2]=n.gid,HEAP32[i+28>>2]=n.rdev,HEAP32[i+32>>2]=0,HEAP32[i+36>>2]=n.size,HEAP32[i+40>>2]=4096,HEAP32[i+44>>2]=n.blocks,HEAP32[i+48>>2]=n.atime.getTime()/1e3|0,HEAP32[i+52>>2]=0,HEAP32[i+56>>2]=n.mtime.getTime()/1e3|0,HEAP32[i+60>>2]=0,HEAP32[i+64>>2]=n.ctime.getTime()/1e3|0,HEAP32[i+68>>2]=0,HEAP32[i+72>>2]=n.ino,0}catch(i){return i.node&&PATH.normalize(e)!==PATH.normalize(FS.getPath(i.node))&&i.setErrno(ERRNO_CODES.ENOTDIR),FS.handleFSError(i),-1}}function _sysconf(e){switch(e){case 30:return PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 79:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator?navigator.hardwareConcurrency||1:1}return ___setErrNo(ERRNO_CODES.EINVAL),-1}function _ferror(e){return e=FS.getStreamFromPtr(e),Number(e&&e.error)}function _getcwd(e,i){if(0==i)return ___setErrNo(ERRNO_CODES.EINVAL),0;var r=FS.cwd();return i<r.length+1?(___setErrNo(ERRNO_CODES.ERANGE),0):(writeAsciiToMemory(r,e),e)}function ___buildEnvironment(e){var i,r,n=64,f=1024;___buildEnvironment.called?(r=HEAP32[_environ>>2],i=HEAP32[r>>2]):(___buildEnvironment.called=!0,ENV.USER="web_user",ENV.PATH="/",ENV.PWD="/",ENV.HOME="/home/web_user",ENV.LANG="C",ENV._=Module.thisProgram,i=allocate(f,"i8",ALLOC_STATIC),r=allocate(4*n,"i8*",ALLOC_STATIC),HEAP32[r>>2]=i,HEAP32[_environ>>2]=r);var t=[],u=0;for(var a in e)if("string"==typeof e[a]){var o=a+"="+e[a];t.push(o),u+=o.length}if(u>f)throw new Error("Environment size exceeded TOTAL_ENV_SIZE!");for(var c=4,l=0;l<t.length;l++){var o=t[l];writeAsciiToMemory(o,i),HEAP32[r+l*c>>2]=i,i+=o.length+1}HEAP32[r+t.length*c>>2]=0}function _getenv(e){return 0===e?0:(e=Pointer_stringify(e),ENV.hasOwnProperty(e)?(_getenv.ret&&_free(_getenv.ret),_getenv.ret=allocate(intArrayFromString(ENV[e]),"i8",ALLOC_NORMAL),_getenv.ret):0)}function _gettimeofday(e){var i=Date.now();return HEAP32[e>>2]=i/1e3|0,HEAP32[e+4>>2]=i%1e3*1e3|0,0}function _vfprintf(e,i,r){return _fprintf(e,i,HEAP32[r>>2])}function _emscripten_memcpy_big(e,i,r){return HEAPU8.set(HEAPU8.subarray(i,i+r),e),e}function _sbrk(e){var i=_sbrk;i.called||(DYNAMICTOP=alignMemoryPage(DYNAMICTOP),i.called=!0,assert(Runtime.dynamicAlloc),i.alloc=Runtime.dynamicAlloc,Runtime.dynamicAlloc=function(){abort("cannot dynamically allocate, sbrk now has control")});var r=DYNAMICTOP;return 0!=e&&i.alloc(e),r}function ___errno_location(){return ___errno_state}function _time(e){var i=Date.now()/1e3|0;return e&&(HEAP32[e>>2]=i),i}function _llvm_ctlz_i64(e,i){var r=_llvm_ctlz_i32(i);return 32==r&&(r+=_llvm_ctlz_i32(e)),0|(asm.setTempRet0(0),r)}function invoke_iiiiiiii(e,i,r,n,f,t,u,a){try{return Module.dynCall_iiiiiiii(e,i,r,n,f,t,u,a)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiii(e,i,r,n){try{return Module.dynCall_iiii(e,i,r,n)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiiiii(e,i,r,n,f,t,u,a){try{Module.dynCall_viiiiiii(e,i,r,n,f,t,u,a)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiii(e,i,r,n,f,t){try{Module.dynCall_viiiii(e,i,r,n,f,t)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_i(e){try{return Module.dynCall_i(e)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_vi(e,i){try{Module.dynCall_vi(e,i)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_vii(e,i,r){try{Module.dynCall_vii(e,i,r)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiiiiii(e,i,r,n,f,t,u){try{return Module.dynCall_iiiiiii(e,i,r,n,f,t,u)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_ii(e,i){try{return Module.dynCall_ii(e,i)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viii(e,i,r,n){try{Module.dynCall_viii(e,i,r,n)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiiiiiii(e,i,r,n,f,t,u,a,o,c){try{Module.dynCall_viiiiiiiii(e,i,r,n,f,t,u,a,o,c)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiiii(e,i,r,n,f){try{return Module.dynCall_iiiii(e,i,r,n,f)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiiii(e,i,r,n,f,t,u){try{Module.dynCall_viiiiii(e,i,r,n,f,t,u)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iii(e,i,r){try{return Module.dynCall_iii(e,i,r)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiiiii(e,i,r,n,f,t){try{return Module.dynCall_iiiiii(e,i,r,n,f,t)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiii(e,i,r,n,f){try{Module.dynCall_viiii(e,i,r,n,f)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function ExitStatus(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function run(e){function i(){Module.calledRun||(Module.calledRun=!0,ABORT||(ensureInitRuntime(),preMain(),null!==preloadStartTime&&Date.now()-preloadStartTime>15&&Module.printErr("pre-main prep time: "+(Date.now()-preloadStartTime)+" ms"),Module.onRuntimeInitialized&&Module.onRuntimeInitialized(),Module._main&&shouldRunNow&&Module.callMain(e),postRun()))}e=e||Module.arguments,null===preloadStartTime&&(preloadStartTime=Date.now()),runDependencies>0||(preRun(),runDependencies>0||Module.calledRun||(Module.setStatus?(Module.setStatus("Running..."),setTimeout(function(){setTimeout(function(){Module.setStatus("")},1),i()},1)):i()))}function exit(e){if(!Module.noExitRuntime)throw ABORT=!0,EXITSTATUS=e,STACKTOP=initialStackTop,exitRuntime(),new ExitStatus(e)}function abort(e){e&&(Module.print(e),Module.printErr(e)),ABORT=!0,EXITSTATUS=1;var i="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";throw"abort() at "+stackTrace()+i}var Module={xml:options.xml,schema:options.schema};Module.preRun=function(){var e;for(e=0;e<1;e++)FS.createDataFile("/","file_"+e+".xml",Module.intArrayFromString(Module.xml[e]),!0,!0);for(e=0;e<Module.schema.length;e++)FS.createDataFile("/","file_"+e+".xsd",Module.intArrayFromString(Module.schema[e]),!0,!0)},Module.arguments=["--noout"],function(){var e;for("[object Array]"!==Object.prototype.toString.call(Module.schema)&&(Module.schema=[Module.schema]),"[object Array]"!==Object.prototype.toString.call(Module.xml)&&(Module.xml=[Module.xml]),e=0;e<Module.schema.length;e++)Module.arguments.push("--schema"),Module.arguments.push("file_"+e+".xsd");for(e=0;e<1;e++)Module.arguments.push("file_"+e+".xml")}(),Module.return="",Module.stdout=Module.stderr=function(e){Module.return+=String.fromCharCode(e)};var Module;Module||(Module=("undefined"!=typeof Module?Module:null)||{});var moduleOverrides={};for(var key in Module)Module.hasOwnProperty(key)&&(moduleOverrides[key]=Module[key]);if(Module.read=function(e){var i=new XMLHttpRequest;return i.open("GET",e,!1),i.send(null),i.responseText},"undefined"!=typeof arguments&&(Module.arguments=arguments),"undefined"!=typeof console)Module.print||(Module.print=function(e){console.log(e)}),Module.printErr||(Module.printErr=function(e){throw new Error("!_PERF_!")});else{var TRY_USE_DUMP=!1;Module.print||(Module.print=TRY_USE_DUMP&&"undefined"!=typeof dump?function(e){dump(e)}:function(e){})}window.Module=Module,!Module.load&&Module.read&&(Module.load=function(e){globalEval(Module.read(e))}),Module.print||(Module.print=function(){}),Module.printErr||(Module.printErr=Module.print),Module.arguments||(Module.arguments=[]),Module.thisProgram||(Module.thisProgram="./this.program"),Module.print=Module.print,Module.printErr=Module.printErr,Module.preRun=[],Module.postRun=[];for(var key in moduleOverrides)moduleOverrides.hasOwnProperty(key)&&(Module[key]=moduleOverrides[key]);var Runtime={setTempRet0:function(e){tempRet0=e},getTempRet0:function(){return tempRet0},stackSave:function(){return STACKTOP},stackRestore:function(e){STACKTOP=e},getNativeTypeSize:function(e){switch(e){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:if("*"===e[e.length-1])return Runtime.QUANTUM_SIZE;if("i"===e[0]){var i=parseInt(e.substr(1));return assert(i%8===0),i/8}return 0}},getNativeFieldSize:function(e){return Math.max(Runtime.getNativeTypeSize(e),Runtime.QUANTUM_SIZE)},STACK_ALIGN:16,getAlignSize:function(e,i,r){return r||"i64"!=e&&"double"!=e?e?Math.min(i||(e?Runtime.getNativeFieldSize(e):0),Runtime.QUANTUM_SIZE):Math.min(i,8):8},dynCall:function(e,i,r){return r&&r.length?(r.splice||(r=Array.prototype.slice.call(r)),r.splice(0,0,i),Module["dynCall_"+e].apply(null,r)):Module["dynCall_"+e].call(null,i)},functionPointers:[],addFunction:function(e){for(var i=0;i<Runtime.functionPointers.length;i++)if(!Runtime.functionPointers[i])return Runtime.functionPointers[i]=e,2*(1+i);throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."},removeFunction:function(e){Runtime.functionPointers[(e-2)/2]=null},getAsmConst:function(code,numArgs){Runtime.asmConstCache||(Runtime.asmConstCache={});var func=Runtime.asmConstCache[code];if(func)return func;for(var args=[],i=0;i<numArgs;i++)args.push(String.fromCharCode(36)+i);var source=Pointer_stringify(code);'"'===source[0]&&(source.indexOf('"',1)===source.length-1?source=source.substr(1,source.length-2):abort("invalid EM_ASM input |"+source+"|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)"));try{var evalled=eval("(function(Module, FS) { return function("+args.join(",")+"){ "+source+" } })")(Module,"undefined"!=typeof FS?FS:null)}catch(e){throw Module.printErr("error in executing inline EM_ASM code: "+e+" on: \n\n"+source+"\n\nwith args |"+args+"| (make sure to use the right one out of EM_ASM, EM_ASM_ARGS, etc.)"),e}return Runtime.asmConstCache[code]=evalled},warnOnce:function(e){Runtime.warnOnce.shown||(Runtime.warnOnce.shown={}),Runtime.warnOnce.shown[e]||(Runtime.warnOnce.shown[e]=1,Module.printErr(e))},funcWrappers:{},getFuncWrapper:function(e,i){assert(i),Runtime.funcWrappers[i]||(Runtime.funcWrappers[i]={});var r=Runtime.funcWrappers[i];return r[e]||(r[e]=function(){return Runtime.dynCall(i,e,arguments)}),r[e]},UTF8Processor:function(){var e=[],i=0;this.processCChar=function(r){if(r&=255,0==e.length)return 0==(128&r)?String.fromCharCode(r):(e.push(r),i=192==(224&r)?1:224==(240&r)?2:3,"");if(i&&(e.push(r),i--,i>0))return"";var n,f=e[0],t=e[1],u=e[2],a=e[3];if(2==e.length)n=String.fromCharCode((31&f)<<6|63&t);else if(3==e.length)n=String.fromCharCode((15&f)<<12|(63&t)<<6|63&u);else{var o=(7&f)<<18|(63&t)<<12|(63&u)<<6|63&a;n=String.fromCharCode(((o-65536)/1024|0)+55296,(o-65536)%1024+56320)}return e.length=0,n},this.processJSString=function(e){e=unescape(encodeURIComponent(e));for(var i=[],r=0;r<e.length;r++)i.push(e.charCodeAt(r));return i}},getCompilerSetting:function(e){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"},stackAlloc:function(e){var i=STACKTOP;return STACKTOP=STACKTOP+e|0,STACKTOP=STACKTOP+15&-16,i},staticAlloc:function(e){
	var i=STATICTOP;return STATICTOP=STATICTOP+e|0,STATICTOP=STATICTOP+15&-16,i},dynamicAlloc:function(e){var i=DYNAMICTOP;return DYNAMICTOP=DYNAMICTOP+e|0,DYNAMICTOP=DYNAMICTOP+15&-16,DYNAMICTOP>=TOTAL_MEMORY&&enlargeMemory(),i},alignMemory:function(e,i){var r=e=Math.ceil(e/(i?i:16))*(i?i:16);return r},makeBigInt:function(e,i,r){var n=r?+(e>>>0)+4294967296*+(i>>>0):+(e>>>0)+4294967296*+(0|i);return n},GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module.Runtime=Runtime;var __THREW__=0,ABORT=!1,EXITSTATUS=0,undef=0,tempValue,tempInt,tempBigInt,tempInt2,tempBigInt2,tempPair,tempBigIntI,tempBigIntR,tempBigIntS,tempBigIntP,tempBigIntD,tempDouble,tempFloat,tempI64,tempI64b,tempRet0,tempRet1,tempRet2,tempRet3,tempRet4,tempRet5,tempRet6,tempRet7,tempRet8,tempRet9,globalScope=this,cwrap,ccall;!function(){function parseJSFunc(e){var i=e.toString().match(sourceRegex).slice(1);return{arguments:i[0],body:i[1],returnValue:i[2]}}var JSfuncs={stackSave:function(){Runtime.stackSave()},stackRestore:function(){Runtime.stackRestore()},arrayToC:function(e){var i=Runtime.stackAlloc(e.length);return writeArrayToMemory(e,i),i},stringToC:function(e){var i=0;return null!==e&&void 0!==e&&0!==e&&(i=Runtime.stackAlloc((e.length<<2)+1),writeStringToMemory(e,i)),i}},toC={string:JSfuncs.stringToC,array:JSfuncs.arrayToC};ccall=function(e,i,r,n){var f=getCFunc(e),t=[],u=0;if(n)for(var a=0;a<n.length;a++){var o=toC[r[a]];o?(0===u&&(u=Runtime.stackSave()),t[a]=o(n[a])):t[a]=n[a]}var c=f.apply(null,t);return"string"===i&&(c=Pointer_stringify(c)),0!==u&&Runtime.stackRestore(u),c};var sourceRegex=/^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/,JSsource={};for(var fun in JSfuncs)JSfuncs.hasOwnProperty(fun)&&(JSsource[fun]=parseJSFunc(JSfuncs[fun]));cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident),numericArgs=argTypes.every(function(e){return"number"===e}),numericRet="string"!==returnType;if(numericRet&&numericArgs)return cfunc;var argNames=argTypes.map(function(e,i){return"$"+i}),funcstr="(function("+argNames.join(",")+") {",nargs=argTypes.length;if(!numericArgs){funcstr+="var stack = "+JSsource.stackSave.body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if("number"!==type){var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";",funcstr+=convertCode.body+";",funcstr+=arg+"="+convertCode.returnValue+";"}}}var cfuncname=parseJSFunc(function(){return cfunc}).returnValue;if(funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");",!numericRet){var strgfy=parseJSFunc(function(){return Pointer_stringify}).returnValue;funcstr+="ret = "+strgfy+"(ret);"}return numericArgs||(funcstr+=JSsource.stackRestore.body.replace("()","(stack)")+";"),funcstr+="return ret})",eval(funcstr)}}(),Module.cwrap=cwrap,Module.ccall=ccall,Module.setValue=setValue,Module.getValue=getValue;var ALLOC_NORMAL=0,ALLOC_STACK=1,ALLOC_STATIC=2,ALLOC_DYNAMIC=3,ALLOC_NONE=4;Module.ALLOC_NORMAL=ALLOC_NORMAL,Module.ALLOC_STACK=ALLOC_STACK,Module.ALLOC_STATIC=ALLOC_STATIC,Module.ALLOC_DYNAMIC=ALLOC_DYNAMIC,Module.ALLOC_NONE=ALLOC_NONE,Module.allocate=allocate,Module.Pointer_stringify=Pointer_stringify,Module.UTF16ToString=UTF16ToString,Module.stringToUTF16=stringToUTF16,Module.UTF32ToString=UTF32ToString,Module.stringToUTF32=stringToUTF32,Module.stackTrace=stackTrace;for(var PAGE_SIZE=4096,HEAP,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64,STATIC_BASE=0,STATICTOP=0,staticSealed=!1,STACK_BASE=0,STACKTOP=0,STACK_MAX=0,DYNAMIC_BASE=0,DYNAMICTOP=0,TOTAL_STACK=Module.TOTAL_STACK||5242880,TOTAL_MEMORY=Module.TOTAL_MEMORY||16777216,FAST_MEMORY=Module.FAST_MEMORY||2097152,totalMemory=65536;totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK;)totalMemory<16777216?totalMemory*=2:totalMemory+=16777216;totalMemory!==TOTAL_MEMORY&&(Module.printErr("increasing TOTAL_MEMORY to "+totalMemory+" to be compliant with the asm.js spec"),TOTAL_MEMORY=totalMemory),assert("undefined"!=typeof Int32Array&&"undefined"!=typeof Float64Array&&!!new Int32Array(1).subarray&&!!new Int32Array(1).set,"JS engine does not provide full typed array support");var buffer=new ArrayBuffer(TOTAL_MEMORY);HEAP8=new Int8Array(buffer),HEAP16=new Int16Array(buffer),HEAP32=new Int32Array(buffer),HEAPU8=new Uint8Array(buffer),HEAPU16=new Uint16Array(buffer),HEAPU32=new Uint32Array(buffer),HEAPF32=new Float32Array(buffer),HEAPF64=new Float64Array(buffer),HEAP32[0]=255,assert(255===HEAPU8[0]&&0===HEAPU8[3],"Typed arrays 2 must be run on a little-endian system"),Module.HEAP=HEAP,Module.buffer=buffer,Module.HEAP8=HEAP8,Module.HEAP16=HEAP16,Module.HEAP32=HEAP32,Module.HEAPU8=HEAPU8,Module.HEAPU16=HEAPU16,Module.HEAPU32=HEAPU32,Module.HEAPF32=HEAPF32,Module.HEAPF64=HEAPF64;var __ATPRERUN__=[],__ATINIT__=[],__ATMAIN__=[],__ATEXIT__=[],__ATPOSTRUN__=[],runtimeInitialized=!1,runtimeExited=!1;Module.addOnPreRun=Module.addOnPreRun=addOnPreRun,Module.addOnInit=Module.addOnInit=addOnInit,Module.addOnPreMain=Module.addOnPreMain=addOnPreMain,Module.addOnExit=Module.addOnExit=addOnExit,Module.addOnPostRun=Module.addOnPostRun=addOnPostRun,Module.intArrayFromString=intArrayFromString,Module.intArrayToString=intArrayToString,Module.writeStringToMemory=writeStringToMemory,Module.writeArrayToMemory=writeArrayToMemory,Module.writeAsciiToMemory=writeAsciiToMemory,Math.imul&&Math.imul(4294967295,5)===-5||(Math.imul=function(e,i){var r=e>>>16,n=65535&e,f=i>>>16,t=65535&i;return n*t+(r*t+n*f<<16)|0}),Math.imul=Math.imul;var Math_abs=Math.abs,Math_cos=Math.cos,Math_sin=Math.sin,Math_tan=Math.tan,Math_acos=Math.acos,Math_asin=Math.asin,Math_atan=Math.atan,Math_atan2=Math.atan2,Math_exp=Math.exp,Math_log=Math.log,Math_sqrt=Math.sqrt,Math_ceil=Math.ceil,Math_floor=Math.floor,Math_pow=Math.pow,Math_imul=Math.imul,Math_fround=Math.fround,Math_min=Math.min,runDependencies=0,runDependencyWatcher=null,dependenciesFulfilled=null;Module.addRunDependency=addRunDependency,Module.removeRunDependency=removeRunDependency,Module.preloadedImages={},Module.preloadedAudios={};var memoryInitializer=null;STATIC_BASE=8,STATICTOP=STATIC_BASE+329776,__ATINIT__.push(),allocate([1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,45,100,101,98,117,103,0,0,45,45,100,101,98,117,103,0,0,0,0,0,0,0,0,0,45,115,104,101,108,108,0,0,45,45,115,104,101,108,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,99,111,112,121,0,0,0,45,45,99,111,112,121,0,0,0,0,0,0,0,0,0,0,45,114,101,99,111,118,101,114,0,0,0,0,0,0,0,0,45,45,114,101,99,111,118,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,0,0,45,104,117,103,101,0,0,0,45,45,104,117,103,101,0,0,45,110,111,101,110,116,0,0,45,45,110,111,101,110,116,0,0,0,0,0,0,0,0,0,45,110,111,101,110,99,0,0,45,45,110,111,101,110,99,0,0,0,0,0,0,0,0,0,45,110,115,99,108,101,97,110,0,0,0,0,0,0,0,0,45,45,110,115,99,108,101,97,110,0,0,0,0,0,0,0,45,110,111,99,100,97,116,97,0,0,0,0,0,0,0,0,45,45,110,111,99,100,97,116,97,0,0,0,0,0,0,0,45,110,111,100,105,99,116,0,45,45,110,111,100,105,99,116,0,0,0,0,0,0,0,0,45,118,101,114,115,105,111,110,0,0,0,0,0,0,0,0,45,45,118,101,114,115,105,111,110,0,0,0,0,0,0,0,45,110,111,111,117,116,0,0,45,45,110,111,111,117,116,0,45,111,0,0,0,0,0,0,45,111,117,116,112,117,116,0,45,45,111,117,116,112,117,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,104,116,109,108,111,117,116,0,0,0,0,0,0,0,0,45,45,104,116,109,108,111,117,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,119,114,97,112,0,45,45,110,111,119,114,97,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,104,116,109,108,0,0,0,45,45,104,116,109,108,0,0,0,0,0,0,0,0,0,0,45,120,109,108,111,117,116,0,45,45,120,109,108,111,117,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,100,101,102,100,116,100,0,0,0,0,0,0,0,45,45,110,111,100,101,102,100,116,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,108,111,97,100,100,116,100,0,0,0,0,0,0,0,0,45,45,108,111,97,100,100,116,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,100,116,100,97,116,116,114,0,0,0,0,0,0,0,0,45,45,100,116,100,97,116,116,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,118,97,108,105,100,0,0,45,45,118,97,108,105,100,0,0,0,0,0,0,0,0,0,45,112,111,115,116,118,97,108,105,100,0,0,0,0,0,0,45,45,112,111,115,116,118,97,108,105,100,0,0,0,0,0,0,0,0,0,0,0,0,0,45,100,116,100,118,97,108,105,100,0,0,0,0,0,0,0,45,45,100,116,100,118,97,108,105,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,100,116,100,118,97,108,105,100,102,112,105,0,0,0,0,45,45,100,116,100,118,97,108,105,100,102,112,105,0,0,0,0,0,0,0,0,0,0,0,45,100,114,111,112,100,116,100,0,0,0,0,0,0,0,0,45,45,100,114,111,112,100,116,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,105,110,115,101,114,116,0,45,45,105,110,115,101,114,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,116,105,109,105,110,103,0,45,45,116,105,109,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,97,117,116,111,0,0,0,45,45,97,117,116,111,0,0,0,0,0,0,0,0,0,0,45,114,101,112,101,97,116,0,45,45,114,101,112,101,97,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,112,117,115,104,0,0,0,45,45,112,117,115,104,0,0,0,0,0,0,0,0,0,0,45,112,117,115,104,115,109,97,108,108,0,0,0,0,0,0,45,45,112,117,115,104,115,109,97,108,108,0,0,0,0,0,0,16,0,0,0,0,0,0,45,109,101,109,111,114,121,0,45,45,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,116,101,115,116,73,79,0,45,45,116,101,115,116,73,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,120,105,110,99,108,117,100,101,0,0,0,0,0,0,0,45,45,120,105,110,99,108,117,100,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,120,105,110,99,108,117,100,101,110,111,100,101,0,45,45,110,111,120,105,110,99,108,117,100,101,110,111,100,101,0,0,0,0,0,0,0,0,45,110,111,102,105,120,117,112,45,98,97,115,101,45,117,114,105,115,0,0,0,0,0,0,45,45,110,111,102,105,120,117,112,45,98,97,115,101,45,117,114,105,115,0,0,0,0,0,45,110,111,119,97,114,110,105,110,103,0,0,0,0,0,0,45,45,110,111,119,97,114,110,105,110,103,0,0,0,0,0,45,112,101,100,97,110,116,105,99,0,0,0,0,0,0,0,45,45,112,101,100,97,110,116,105,99,0,0,0,0,0,0,45,100,101,98,117,103,101,110,116,0,0,0,0,0,0,0,45,45,100,101,98,117,103,101,110,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,99,49,52,110,0,0,0,45,45,99,49,52,110,0,0,0,0,0,0,0,0,0,0,45,99,49,52,110,49,49,0,45,45,99,49,52,110,49,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,101,120,99,45,99,49,52,110,0,0,0,0,0,0,0,45,45,101,120,99,45,99,49,52,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,99,97,116,97,108,111,103,115,0,0,0,0,0,0,0,45,45,99,97,116,97,108,111,103,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,99,97,116,97,108,111,103,115,0,0,0,0,0,45,45,110,111,99,97,116,97,108,111,103,115,0,0,0,0,0,0,0,0,0,0,0,0,45,101,110,99,111,100,101,0,45,45,101,110,99,111,100,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,68,86,69,110,99,0,0,0,45,110,111,98,108,97,110,107,115,0,0,0,0,0,0,0,45,45,110,111,98,108,97,110,107,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,109,97,120,109,101,109,0,45,45,109,97,120,109,101,109,0,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,102,111,114,109,97,116,0,45,45,102,111,114,109,97,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,112,114,101,116,116,121,0,45,45,112,114,101,116,116,121,0,0,0,0,0,0,0,0,45,115,116,114,101,97,109,0,45,45,115,116,114,101,97,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,119,97,108,107,101,114,0,45,45,119,97,108,107,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,115,97,120,49,0,0,0,45,45,115,97,120,49,0,0,0,0,0,0,0,0,0,0,45,115,97,120,0,0,0,0,45,45,115,97,120,0,0,0,0,0,0,0,0,0,0,0,45,99,104,107,114,101,103,105,115,116,101,114,0,0,0,0,45,45,99,104,107,114,101,103,105,115,116,101,114,0,0,0,0,0,0,0,0,0,0,0,45,114,101,108,97,120,110,103,0,0,0,0,0,0,0,0,45,45,114,101,108,97,120,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,115,99,104,101,109,97,0,45,45,115,99,104,101,109,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,115,99,104,101,109,97,116,114,111,110,0,0,0,0,0,45,45,115,99,104,101,109,97,116,114,111,110,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,110,101,116,0,0,45,45,110,111,110,101,116,0,45,110,111,99,111,109,112,97,99,116,0,0,0,0,0,0,45,45,110,111,99,111,109,112,97,99,116,0,0,0,0,0,45,108,111,97,100,45,116,114,97,99,101,0,0,0,0,0,45,45,108,111,97,100,45,116,114,97,99,101,0,0,0,0,0,0,0,0,0,0,0,0,45,112,97,116,104,0,0,0,45,45,112,97,116,104,0,0,45,112,97,116,116,101,114,110,0,0,0,0,0,0,0,0,45,45,112,97,116,116,101,114,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,120,112,97,116,104,0,0,45,45,120,112,97,116,104,0,0,0,0,0,0,0,0,0,45,111,108,100,120,109,108,49,48,0,0,0,0,0,0,0,45,45,111,108,100,120,109,108,49,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,111,112,116,105,111,110,32,37,115,10,0,0,0,0,0,0,83,71,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,36,83,71,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,32,110,111,116,32,115,101,116,10,0,0,0,88,77,76,76,73,78,84,95,73,78,68,69,78,84,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,72,84,77,76,32,80,85,66,76,73,67,32,34,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,46,48,32,84,114,97,110,115,105,116,105,111,110,97,108,47,47,69,78,34,10,0,0,9,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,82,69,67,45,104,116,109,108,52,48,47,108,111,111,115,101,46,100,116,100,34,62,10,0,0,60,104,116,109,108,62,60,104,101,97,100,62,60,116,105,116,108,101,62,37,115,32,111,117,116,112,117,116,60,47,116,105,116,108,101,62,60,47,104,101,97,100,62,10,0,0,0,0,60,98,111,100,121,32,98,103,99,111,108,111,114,61,34,35,102,102,102,102,102,102,34,62,60,104,49,32,97,108,105,103,110,61,34,99,101,110,116,101,114,34,62,37,115,32,111,117,116,112,117,116,60,47,104,49,62,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,99,104,101,109,97,116,114,111,110,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,67,111,109,112,105,108,105,110,103,32,116,104,101,32,115,99,104,101,109,97,115,0,0,0,0,0,0,0,0,0,0,0,82,101,108,97,120,45,78,71,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,0,0,87,88,83,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,97,116,116,101,114,110,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,0,0,82,101,103,105,115,116,114,97,116,105,111,110,32,99,111,117,110,116,32,111,102,102,58,32,37,100,10,0,0,0,0,0,37,100,32,105,116,101,114,97,116,105,111,110,115,0,0,0,60,47,98,111,100,121,62,60,47,104,116,109,108,62,10,0,49,46,48,0,0,0,0,0,105,110,102,111,0,0,0,0,97,98,99,0,0,0,0,0,114,0,0,0,0,0,0,0,109,109,97,112,32,102,97,105,108,117,114,101,32,102,111,114,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,80,97,114,115,105,110,103,0,88,105,110,99,108,117,100,101,32,112,114,111,99,101,115,115,105,110,103,0,0,0,0,0,67,111,112,121,105,110,103,0,70,114,101,101,105,110,103,32,111,114,105,103,105,110,97,108,0,0,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,103,101,116,32,118,97,108,105,100,32,108,105,115,116,32,111,102,32,101,108,101,109,101,110,116,115,10,0,0,0,78,111,32,101,108,101,109,101,110,116,32,99,97,110,32,98,101,32,105,110,115,101,114,116,101,100,32,117,110,100,101,114,32,114,111,111,116,10,0,0,37,100,32,101,108,101,109,101,110,116,32,116,121,112,101,115,32,99,97,110,32,98,101,32,105,110,115,101,114,116,101,100,32,117,110,100,101,114,32,114,111,111,116,58,10,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,10,0,0,0,0,0,0,83,97,118,105,110,103,0,0,67,97,110,39,116,32,119,114,105,116,101,32,100,97,116,97,10,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,97,110,111,110,105,99,97,108,105,122,101,10,0,70,97,105,108,101,100,32,116,111,32,115,97,118,101,10,0,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,115,97,118,101,32,116,111,32,37,115,10,0,0,0,0,0,0,80,97,114,115,105,110,103,32,68,84,68,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,112,97,114,115,101,32,68,84,68,32,37,115,10,0,67,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,10,0,0,0,68,111,99,117,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,118,97,108,105,100,97,116,101,32,97,103,97,105,110,115,116,32,37,115,10,0,0,0,0,0,0,0,86,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,68,84,68,0,0,68,111,99,117,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,118,97,108,105,100,97,116,101,10,0,0,86,97,108,105,100,97,116,105,110,103,0,0,0,0,0,0,37,115,32,118,97,108,105,100,97,116,101,115,10,0,0,0,37,115,32,102,97,105,108,115,32,116,111,32,118,97,108,105,100,97,116,101,10,0,0,0,37,115,32,118,97,108,105,100,97,116,105,111,110,32,103,101,110,101,114,97,116,101,100,32,97,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,10,0,0,0,0,0,0,70,114,101,101,105,110,103,0,0,0,0,0,0,0,0,0,120,109,108,83,116,114,101,97,109,80,117,115,104,40,41,32,102,97,105,108,117,114,101,10,0,0,0,0,0,0,0,0,119,97,108,107,105,110,103,32,116,104,114,111,117,103,104,32,116,104,101,32,100,111,99,0,102,97,105,108,101,100,32,116,111,32,119,97,108,107,32,116,104,114,111,117,103,104,32,116,104,101,32,100,111,99,10,0,70,97,105,108,101,100,32,116,111,32,99,114,97,116,101,32,97,32,114,101,97,100,101,114,32,102,114,111,109,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,45,45,0,0,0,0,0,0,37,100,32,37,100,32,37,115,32,37,100,32,37,100,0,0,10,0,0,0,0,0,0,0,32,37,115,10,0,0,0,0,78,111,100,101,32,37,115,32,109,97,116,99,104,101,115,32,112,97,116,116,101,114,110,32,37,115,10,0,0,0,0,0,120,109,108,80,97,116,116,101,114,110,77,97,116,99,104,32,97,110,100,32,120,109,108,83,116,114,101,97,109,80,117,115,104,32,100,105,115,97,103,114,101,101,10,0,0,0,0,0,32,32,112,97,116,116,101,114,110,32,37,115,32,110,111,100,101,32,37,115,10,0,0,0,120,109,108,83,116,114,101,97,109,80,111,112,40,41,32,102,97,105,108,117,114,101,10,0,37,115,0,0,0,0,0,0,79,117,116,32,111,102,32,109,101,109,111,114,121,32,102,111,114,32,88,80,97,116,104,10,0,0,0,0,0,0,0,0,88,80,97,116,104,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,117,114,101,10,0,0,0,0,0,0,0,88,80,97,116,104,32,115,101,116,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,45,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,78,97,78,0,0,0,0,0,37,48,103,0,0,0,0,0,88,80,97,116,104,32,79,98,106,101,99,116,32,105,115,32,117,110,105,110,105,116,105,97,108,105,122,101,100,10,0,0,88,80,97,116,104,32,111,98,106,101,99,116,32,111,102,32,117,110,101,120,112,101,99,116,101,100,32,116,121,112,101,10],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE),allocate([60,98,62,118,97,108,105,100,105,116,121,32,119,97,114,110,105,110,103,60,47,98,62,58,32,0,0,0,0,0,0,0,60,47,112,62,10,0,0,0,60,112,114,101,62,10,0,0,37,99,0,0,0,0,0,0,32,0,0,0,0,0,0,0,94,10,0,0,0,0,0,0,60,47,112,114,101,62,0,0,60,112,62,0,0,0,0,0,37,115,58,37,100,58,32,0,69,110,116,105,116,121,58,32,108,105,110,101,32,37,100,58,32,0,0,0,0,0,0,0,60,98,62,118,97,108,105,100,105,116,121,32,101,114,114,111,114,60,47,98,62,58,32,0,60,98,62,119,97,114,110,105,110,103,60,47,98,62,58,32,0,0,0,0,0,0,0,0,60,98,62,101,114,114,111,114,60,47,98,62,58,32,0,0,117,115,101,114,95,100,97,116,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,217,0,0,0,0,0,0,112,212,0,0,0,0,0,0,83,65,88,32,103,101,110,101,114,97,116,101,100,32,97,32,100,111,99,32,33,10,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,175,190,237,222,0,0,0,0,28,0,0,0,29,0,0,0,0,0,0,0,83,65,88,46,101,110,100,69,108,101,109,101,110,116,78,115,40,37,115,0,0,0,0,0,44,32,78,85,76,76,0,0,44,32,37,115,0,0,0,0,44,32,78,85,76,76,41,10,0,0,0,0,0,0,0,0,44,32,39,37,115,39,41,10,0,0,0,0,0,0,0,0,83,65,88,46,115,116,97,114,116,69,108,101,109,101,110,116,78,115,40,37,115,0,0,0,44,32,39,37,115,39,0,0,44,32,37,100,0,0,0,0,44,32,120,109,108,110,115,0,58,37,115,0,0,0,0,0,61,39,37,115,39,0,0,0,44,32,37,100,44,32,37,100,0,0,0,0,0,0,0,0,44,32,37,115,58,37,115,61,39,0,0,0,0,0,0,0,44,32,37,115,61,39,0,0,37,46,52,115,46,46,46,39,44,32,37,100,0,0,0,0,41,10,0,0,0,0,0,0,83,65,88,46,101,120,116,101,114,110,97,108,83,117,98,115,101,116,40,37,115,44,0,0,32,44,0,0,0,0,0,0,32,37,115,44,0,0,0,0,32,41,10,0,0,0,0,0,32,37,115,41,10,0,0,0,83,65,88,46,112,99,100,97,116,97,40,37,46,50,48,115,44,32,37,100,41,10,0,0,83,65,88,46,103,101,116,80,97,114,97,109,101,116,101,114,69,110,116,105,116,121,40,37,115,41,10,0,0,0,0,0,83,65,88,46,102,97,116,97,108,69,114,114,111,114,58,32,0,0,0,0,0,0,0,0,83,65,88,46,101,114,114,111,114,58,32,0,0,0,0,0,83,65,88,46,119,97,114,110,105,110,103,58,32,0,0,0,83,65,88,46,99,111,109,109,101,110,116,40,37,115,41,10,0,0,0,0,0,0,0,0,83,65,88,46,112,114,111,99,101,115,115,105,110,103,73,110,115,116,114,117,99,116,105,111,110,40,37,115,44,32,37,115,41,10,0,0,0,0,0,0,83,65,88,46,112,114,111,99,101,115,115,105,110,103,73,110,115,116,114,117,99,116,105,111,110,40,37,115,44,32,78,85,76,76,41,10,0,0,0,0,83,65,88,46,105,103,110,111,114,97,98,108,101,87,104,105,116,101,115,112,97,99,101,40,37,115,44,32,37,100,41,10,0,0,0,0,0,0,0,0,83,65,88,46,99,104,97,114,97,99,116,101,114,115,40,37,115,44,32,37,100,41,10,0,83,65,88,46,114,101,102,101,114,101,110,99,101,40,37,115,41,10,0,0,0,0,0,0,83,65,88,46,101,110,100,68,111,99,117,109,101,110,116,40,41,10,0,0,0,0,0,0,83,65,88,46,115,116,97,114,116,68,111,99,117,109,101,110,116,40,41,10,0,0,0,0,83,65,88,46,115,101,116,68,111,99,117,109,101,110,116,76,111,99,97,116,111,114,40,41,10,0,0,0,0,0,0,0,40,110,117,108,108,41,0,0,83,65,88,46,117,110,112,97,114,115,101,100,69,110,116,105,116,121,68,101,99,108,40,37,115,44,32,37,115,44,32,37,115,44,32,37,115,41,10,0,83,65,88,46,101,108,101,109,101,110,116,68,101,99,108,40,37,115,44,32,37,100,44,32,46,46,46,41,10,0,0,0,83,65,88,46,97,116,116,114,105,98,117,116,101,68,101,99,108,40,37,115,44,32,37,115,44,32,37,100,44,32,37,100,44,32,78,85,76,76,44,32,46,46,46,41,10,0,0,0,83,65,88,46,97,116,116,114,105,98,117,116,101,68,101,99,108,40,37,115,44,32,37,115,44,32,37,100,44,32,37,100,44,32,37,115,44,32,46,46,46,41,10,0,0,0,0,0,83,65,88,46,110,111,116,97,116,105,111,110,68,101,99,108,40,37,115,44,32,37,115,44,32,37,115,41,10,0,0,0,83,65,88,46,101,110,116,105,116,121,68,101,99,108,40,37,115,44,32,37,100,44,32,37,115,44,32,37,115,44,32,37,115,41,10,0,0,0,0,0,83,65,88,46,103,101,116,69,110,116,105,116,121,40,37,115,41,10,0,0,0,0,0,0,83,65,88,46,114,101,115,111,108,118,101,69,110,116,105,116,121,40,0,0,0,0,0,0,44,32,37,115,41,10,0,0,44,32,41,10,0,0,0,0,83,65,88,46,104,97,115,69,120,116,101,114,110,97,108,83,117,98,115,101,116,40,41,10,0,0,0,0,0,0,0,0,83,65,88,46,104,97,115,73,110,116,101,114,110,97,108,83,117,98,115,101,116,40,41,10,0,0,0,0,0,0,0,0,83,65,88,46,105,115,83,116,97,110,100,97,108,111,110,101,40,41,10,0,0,0,0,0,83,65,88,46,105,110,116,101,114,110,97,108,83,117,98,115,101,116,40,37,115,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,175,190,237,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,83,68,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,80,97,114,115,105,110,103,32,97,110,100,32,118,97,108,105,100,97,116,105,110,103,0,0,37,115,32,58,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,10,0,0,0,85,110,97,98,108,101,32,116,111,32,111,112,101,110,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,116,111,111,107,32,37,108,100,32,109,115,10,0,0,0,0,0,0,0,0,0,0,0,76,111,97,100,101,100,32,85,82,76,61,34,37,115,34,32,73,68,61,34,37,115,34,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,0,110,111,100,101,45,62,95,112,114,105,118,97,116,101,32,33,61,32,78,85,76,76,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,108,105,110,116,46,99,0,0,0,0,100,101,114,101,103,105,115,116,101,114,78,111,100,101,0,0,42,40,108,111,110,103,42,41,110,111,100,101,45,62,95,112,114,105,118,97,116,101,32,61,61,32,40,108,111,110,103,41,32,48,120,56,49,55,50,54,51,53,52,0,0,0,0,0,79,117,116,32,111,102,32,109,101,109,111,114,121,32,105,110,32,120,109,108,108,105,110,116,58,114,101,103,105,115,116,101,114,78,111,100,101,40,41,10,0,0,0,0,0,0,0,0,77,65,88,95,80,65,84,72,83,32,114,101,97,99,104,101,100,58,32,116,111,111,32,109,97,110,121,32,112,97,116,104,115,10,0,0,0,0,0,0,82,97,110,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,110,101,101,100,115,32,62,32,37,100,32,98,121,116,101,115,10,0,0,0,0,0,37,115,58,32,117,115,105,110,103,32,108,105,98,120,109,108,32,118,101,114,115,105,111,110,32,37,115,10,0,0,0,0,32,32,32,99,111,109,112,105,108,101,100,32,119,105,116,104,58,32,0,0,0,0,0,0,84,104,114,101,97,100,115,32,0,0,0,0,0,0,0,0,84,114,101,101,32,0,0,0,79,117,116,112,117,116,32,0,80,117,115,104,32,0,0,0,82,101,97,100,101,114,32,0,80,97,116,116,101,114,110,115,32,0,0,0,0,0,0,0,87,114,105,116,101,114,32,0,83,65,88,118,49,32,0,0,70,84,80,32,0,0,0,0,72,84,84,80,32,0,0,0,68,84,68,86,97,108,105,100,32,0,0,0,0,0,0,0,72,84,77,76,32,0,0,0,76,101,103,97,99,121,32,0,67,49,52,78,32,0,0,0,67,97,116,97,108,111,103,32,0,0,0,0,0,0,0,0,88,80,97,116,104,32,0,0,88,80,111,105,110,116,101,114,32,0,0,0,0,0,0,0,88,73,110,99,108,117,100,101,32,0,0,0,0,0,0,0,73,99,111,110,118,32,0,0,73,83,79,56,56,53,57,88,32,0,0,0,0,0,0,0,85,110,105,99,111,100,101,32,0,0,0,0,0,0,0,0,82,101,103,101,120,112,115,32,0,0,0,0,0,0,0,0,65,117,116,111,109,97,116,97,32,0,0,0,0,0,0,0,69,120,112,114,32,0,0,0,83,99,104,101,109,97,115,32,0,0,0,0,0,0,0,0,83,99,104,101,109,97,116,114,111,110,32,0,0,0,0,0,77,111,100,117,108,101,115,32,0,0,0,0,0,0,0,0,68,101,98,117,103,32,0,0,77,101,109,68,101,98,117,103,32,0,0,0,0,0,0,0,82,117,110,68,101,98,117,103,32,0,0,0,0,0,0,0,90,108,105,98,32,0,0,0,76,122,109,97,32,0,0,0,85,115,97,103,101,32,58,32,37,115,32,91,111,112,116,105,111,110,115,93,32,88,77,76,102,105,108,101,115,32,46,46,46,10,0,0,0,0,0,0,9,80,97,114,115,101,32,116,104,101,32,88,77,76,32,102,105,108,101,115,32,97,110,100,32,111,117,116,112,117,116,32,116,104,101,32,114,101,115,117,108,116,32,111,102,32,116,104,101,32,112,97,114,115,105,110,103,10,0,0,0,0,0,0,9,45,45,118,101,114,115,105,111,110,32,58,32,100,105,115,112,108,97,121,32,116,104,101,32,118,101,114,115,105,111,110,32,111,102,32,116,104,101,32,88,77,76,32,108,105,98,114,97,114,121,32,117,115,101,100,10,0,0,0,0,0,0,0,9,45,45,100,101,98,117,103,32,58,32,100,117,109,112,32,97,32,100,101,98,117,103,32,116,114,101,101,32,111,102,32,116,104,101,32,105,110,45,109,101,109,111,114,121,32,100,111,99,117,109,101,110,116,10,0,9,45,45,115,104,101,108,108,32,58,32,114,117,110,32,97,32,110,97,118,105,103,97,116,105,110,103,32,115,104,101,108,108,10,0,0,0,0,0,0,9,45,45,100,101,98,117,103,101,110,116,32,58,32,100,101,98,117,103,32,116,104,101,32,101,110,116,105,116,105,101,115,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,0,0,9,45,45,99,111,112,121,32,58,32,117,115,101,100,32,116,111,32,116,101,115,116,32,116,104,101,32,105,110,116,101,114,110,97,108,32,99,111,112,121,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,10,0,0,0,0,0,0,0,0,9,45,45,114,101,99,111,118,101,114,32,58,32,111,117,116,112,117,116,32,119,104,97,116,32,119,97,115,32,112,97,114,115,97,98,108,101,32,111,110,32,98,114,111,107,101,110,32,88,77,76,32,100,111,99,117,109,101,110,116,115,10,0,0,9,45,45,104,117,103,101,32,58,32,114,101,109,111,118,101,32,97,110,121,32,105,110,116,101,114,110,97,108,32,97,114,98,105,116,114,97,114,121,32,112,97,114,115,101,114,32,108,105,109,105,116,115,10,0,0,9,45,45,110,111,101,110,116,32,58,32,115,117,98,115,116,105,116,117,116,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,115,32,98,121,32,116,104,101,105,114,32,118,97,108,117,101,10,0,9,45,45,110,111,101,110,99,32,58,32,105,103,110,111,114,101,32,97,110,121,32,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,115,105,100,101,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,9,45,45,110,111,111,117,116,32,58,32,100,111,110,39,116,32,111,117,116,112,117,116,32,116,104,101,32,114,101,115,117,108,116,32,116,114,101,101,10,0,0,0,0,0,0,0,0,9,45,45,112,97,116,104,32,39,112,97,116,104,115,39,58,32,112,114,111,118,105,100,101,32,97,32,115,101,116,32,111,102,32,112,97,116,104,115,32,102,111,114,32,114,101,115,111,117,114,99,101,115,10,0,0,9,45,45,108,111,97,100,45,116,114,97,99,101,32,58,32,112,114,105,110,116,32,116,114,97,99,101,32,111,102,32,97,108,108,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,105,101,115,32,108,111,97,100,101,100,10,0,0,0,0,9,45,45,110,111,110,101,116,32,58,32,114,101,102,117,115,101,32,116,111,32,102,101,116,99,104,32,68,84,68,115,32,111,114,32,101,110,116,105,116,105,101,115,32,111,118,101,114,32,110,101,116,119,111,114,107,10,0,0,0,0,0,0,0,9,45,45,110,111,99,111,109,112,97,99,116,32,58,32,100,111,32,110,111,116,32,103,101,110,101,114,97,116,101,32,99,111,109,112,97,99,116,32,116,101,120,116,32,110,111,100,101,115,10,0,0,0,0,0,0,9,45,45,104,116,109,108,111,117,116,32,58,32,111,117,116,112,117,116,32,114,101,115,117,108,116,115,32,97,115,32,72,84,77,76,10,0,0,0,0,9,45,45,110,111,119,114,97,112,32,58,32,100,111,32,110,111,116,32,112,117,116,32,72,84,77,76,32,100,111,99,32,119,114,97,112,112,101,114,10,0,0,0,0,0,0,0,0,9,45,45,118,97,108,105,100,32,58,32,118,97,108,105,100,97,116,101,32,116,104,101,32,100,111,99,117,109,101,110,116,32,105,110,32,97,100,100,105,116,105,111,110,32,116,111,32,115,116,100,32,119,101,108,108,45,102,111,114,109,101,100,32,99,104,101,99,107,10,0,0,9,45,45,112,111,115,116,118,97,108,105,100,32,58,32,100,111,32,97,32,112,111,115,116,101,114,105,111,114,105,32,118,97,108,105,100,97,116,105,111,110,44,32,105,46,101,32,97,102,116,101,114,32,112,97,114,115,105,110,103,10,0,0,0,9,45,45,100,116,100,118,97,108,105,100,32,85,82,76,32,58,32,100,111,32,97,32,112,111,115,116,101,114,105,111,114,105,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,97,32,103,105,118,101,110,32,68,84,68,10,0,0,0,0,0,0,0,9,45,45,100,116,100,118,97,108,105,100,102,112,105,32,70,80,73,32,58,32,115,97,109,101,32,98,117,116,32,110,97,109,101,32,116,104,101,32,68,84,68,32,119,105,116,104,32,97,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,10,0,0,0,0,9,45,45,116,105,109,105,110,103,32,58,32,112,114,105,110,116,32,115,111,109,101,32,116,105,109,105,110,103,115,10,0,9,45,45,111,117,116,112,117,116,32,102,105,108,101,32,111,114,32,45,111,32,102,105,108,101,58,32,115,97,118,101,32,116,111,32,97,32,103,105,118,101,110,32,102,105,108,101,10,0,0,0,0,0,0,0,0,9,45,45,114,101,112,101,97,116,32,58,32,114,101,112,101,97,116,32,49,48,48,32,116,105,109,101,115,44,32,102,111,114,32,116,105,109,105,110,103,32,111,114,32,112,114,111,102,105,108,105,110,103,10,0,0,9,45,45,105,110,115,101,114,116,32,58,32,97,100,45,104,111,99,32,116,101,115,116,32,102,111,114,32,118,97,108,105,100,32,105,110,115,101,114,116,105,111,110,115,10,0,0,0,9,45,45,104,116,109,108,32,58,32,117,115,101,32,116,104,101,32,72,84,77,76,32,112,97,114,115,101,114,10,0,0,9,45,45,120,109,108,111,117,116,32,58,32,102,111,114,99,101,32,116,111,32,117,115,101,32,116,104,101,32,88,77,76,32,115,101,114,105,97,108,105,122,101,114,32,119,104,101,110,32,117,115,105,110,103,32,45,45,104,116,109,108,10,0,0,9,45,45,110,111,100,101,102,100,116,100,32,58,32,100,111,32,110,111,116,32,100,101,102,97,117,108,116,32,72,84,77,76,32,100,111,99,116,121,112,101,10,0,0,0,0,0,0,9,45,45,112,117,115,104,32,58,32,117,115,101,32,116,104,101,32,112,117,115,104,32,109,111,100,101,32,111,102,32,116,104,101,32,112,97,114,115,101,114,10,0,0,0,0,0,0,9,45,45,112,117,115,104,115,109,97,108,108,32,58,32,117,115,101,32,116,104,101,32,112,117,115,104,32,109,111,100,101,32,111,102,32,116,104,101,32,112,97,114,115,101,114,32,117,115,105,110,103,32,116,105,110,121,32,105,110,99,114,101,109,101,110,116,115,10,0,0,0,9,45,45,109,101,109,111,114,121,32,58,32,112,97,114,115,101,32,102,114,111,109,32,109,101,109,111,114,121,10,0,0,9,45,45,109,97,120,109,101,109,32,110,98,98,121,116,101,115,32,58,32,108,105,109,105,116,115,32,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,116,111,32,110,98,98,121,116,101,115,32,98,121,116,101,115,10,0,0,9,45,45,110,111,119,97,114,110,105,110,103,32,58,32,100,111,32,110,111,116,32,101,109,105,116,32,119,97,114,110,105,110,103,115,32,102,114,111,109,32,112,97,114,115,101,114,47,118,97,108,105,100,97,116,111,114,10,0,0,0,0,0,0,9,45,45,110,111,98,108,97,110,107,115,32,58,32,100,114,111,112,32,40,105,103,110,111,114,97,98,108,101,63,41,32,98,108,97,110,107,115,32,115,112,97,99,101,115,10,0,0,9,45,45,110,111,99,100,97,116,97,32,58,32,114,101,112,108,97,99,101,32,99,100,97,116,97,32,115,101,99,116,105,111,110,32,119,105,116,104,32,116,101,120,116,32,110,111,100,101,115,10,0,0,0,0,0,9,45,45,102,111,114,109,97,116,32,58,32,114,101,102,111,114,109,97,116,47,114,101,105,110,100,101,110,116,32,116,104,101,32,105,110,112,117,116,10,0,0,0,0,0,0,0,0,9,45,45,101,110,99,111,100,101,32,101,110,99,111,100,105,110,103,32,58,32,111,117,116,112,117,116,32,105,110,32,116,104,101,32,103,105,118,101,110,32,101,110,99,111,100,105,110,103,10,0,0,0,0,0,0,9,45,45,100,114,111,112,100,116,100,32,58,32,114,101,109,111,118,101,32,116,104,101,32,68,79,67,84,89,80,69,32,111,102,32,116,104,101,32,105,110,112,117,116,32,100,111,99,115,10,0,0,0,0,0,0,9,45,45,112,114,101,116,116,121,32,83,84,89,76,69,32,58,32,112,114,101,116,116,121,45,112,114,105,110,116,32,105,110,32,97,32,112,97,114,116,105,99,117,108,97,114,32,115,116,121,108,101,10,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,48,32,68,111,32,110,111,116,32,112,114,101,116,116,121,32,112,114,105,110,116,10,0,0,0,0,0,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,49,32,70,111,114,109,97,116,32,116,104,101,32,88,77,76,32,99,111,110,116,101,110,116,44,32,97,115,32,45,45,102,111,114,109,97,116,10,0,0,0,0,0,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,50,32,65,100,100,32,119,104,105,116,101,115,112,97,99,101,32,105,110,115,105,100,101,32,116,97,103,115,44,32,112,114,101,115,101,114,118,105,110,103,32,99,111,110,116,101,110,116,10,0,0,0,0,0,9,45,45,99,49,52,110,32,58,32,115,97,118,101,32,105,110,32,87,51,67,32,99,97,110,111,110,105,99,97,108,32,102,111,114,109,97,116,32,118,49,46,48,32,40,119,105,116,104,32,99,111,109,109,101,110,116,115,41,10,0,0,0,0,9,45,45,99,49,52,110,49,49,32,58,32,115,97,118,101,32,105,110,32,87,51,67,32,99,97,110,111,110,105,99,97,108,32,102,111,114,109,97,116,32,118,49,46,49,32,40,119,105,116,104,32,99,111,109,109,101,110,116,115,41,10,0,0,9,45,45,101,120,99,45,99,49,52,110,32,58,32,115,97,118,101,32,105,110,32,87,51,67,32,101,120,99,108,117,115,105,118,101,32,99,97,110,111,110,105,99,97,108,32,102,111,114,109,97,116,32,40,119,105,116,104,32,99,111,109,109,101,110,116,115,41,10,0,0,0,9,45,45,110,115,99,108,101,97,110,32,58,32,114,101,109,111,118,101,32,114,101,100,117,110,100,97,110,116,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,115,10,0,0,0,9,45,45,116,101,115,116,73,79,32,58,32,116,101,115,116,32,117,115,101,114,32,73,47,79,32,115,117,112,112,111,114,116,10,0,0,0,0,0,0,9,45,45,99,97,116,97,108,111,103,115,32,58,32,117,115,101,32,83,71,77,76,32,99,97,116,97,108,111,103,115,32,102,114,111,109,32,36,83,71,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,10,0,0,0,0,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,111,116,104,101,114,119,105,115,101,32,88,77,76,32,67,97,116,97,108,111,103,115,32,115,116,97,114,116,105,110,103,32,102,114,111,109,32,10,0,0,0,0,9,32,32,32,32,32,32,32,32,32,37,115,32,97,114,101,32,97,99,116,105,118,97,116,101,100,32,98,121,32,100,101,102,97,117,108,116,10,0,0,102,105,108,101,58,47,47,47,101,116,99,47,120,109,108,47,99,97,116,97,108,111,103,0,9,45,45,110,111,99,97,116,97,108,111,103,115,58,32,100,101,97,99,116,105,118,97,116,101,32,97,108,108,32,99,97,116,97,108,111,103,115,10,0,9,45,45,97,117,116,111,32,58,32,103,101,110,101,114,97,116,101,32,97,32,115,109,97,108,108,32,100,111,99,32,111,110,32,116,104,101,32,102,108,121,10,0,0,0,0,0,0,9,45,45,120,105,110,99,108,117,100,101,32,58,32,100,111,32,88,73,110,99,108,117,100,101,32,112,114,111,99,101,115,115,105,110,103,10,0,0,0,9,45,45,110,111,120,105,110,99,108,117,100,101,110,111,100,101,32,58,32,115,97,109,101,32,98,117,116,32,100,111,32,110,111,116,32,103,101,110,101,114,97,116,101,32,88,73,110,99,108,117,100,101,32,110,111,100,101,115,10,0,0,0,0,9,45,45,110,111,102,105,120,117,112,45,98,97,115,101,45,117,114,105,115,32,58,32,100,111,32,110,111,116,32,102,105,120,117,112,32,120,109,108,58,98,97,115,101,32,117,114,105,115,10,0,0,0,0,0,0,9,45,45,108,111,97,100,100,116,100,32,58,32,102,101,116,99,104,32,101,120,116,101,114,110,97,108,32,68,84,68,10,0,0,0,0,0,0,0,0,9,45,45,100,116,100,97,116,116,114,32,58,32,108,111,97,100,100,116,100,32,43,32,112,111,112,117,108,97,116,101,32,116,104,101,32,116,114,101,101,32,119,105,116,104,32,105,110,104,101,114,105,116,101,100,32,97,116,116,114,105,98,117,116,101,115,32,10,0,0,0,0,9,45,45,115,116,114,101,97,109,32,58,32,117,115,101,32,116,104,101,32,115,116,114,101,97,109,105,110,103,32,105,110,116,101,114,102,97,99,101,32,116,111,32,112,114,111,99,101,115,115,32,118,101,114,121,32,108,97,114,103,101,32,102,105,108,101,115,10,0,0,0,0,9,45,45,119,97,108,107,101,114,32,58,32,99,114,101,97,116,101,32,97,32,114,101,97,100,101,114,32,97,110,100,32,119,97,108,107,32,116,104,111,117,103,104,32,116,104,101,32,114,101,115,117,108,116,105,110,103,32,100,111,99,10,0,0,9,45,45,112,97,116,116,101,114,110,32,112,97,116,116,101,114,110,95,118,97,108,117,101,32,58,32,116,101,115,116,32,116,104,101,32,112,97,116,116,101,114,110,32,115,117,112,112,111,114,116,10,0,0,0,0,9,45,45,99,104,107,114,101,103,105,115,116,101,114,32,58,32,118,101,114,105,102,121,32,116,104,101,32,110,111,100,101,32,114,101,103,105,115,116,114,97,116,105,111,110,32,99,111,100,101,10,0,0,0,0,0,9,45,45,114,101,108,97,120,110,103,32,115,99,104,101,109,97,32,58,32,100,111,32,82,101,108,97,120,78,71,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,116,104,101,32,115,99,104,101,109,97,10,0,0,0,9,45,45,115,99,104,101,109,97,32,115,99,104,101,109,97,32,58,32,100,111,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,116,104,101,32,87,88,83,32,115,99,104,101,109,97,10,0,0,0,0,0,0,0,0,9,45,45,115,99,104,101,109,97,116,114,111,110,32,115,99,104,101,109,97,32,58,32,100,111,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,97,32,115,99,104,101,109,97,116,114,111,110,10,0,0,0,0,0,0,9,45,45,115,97,120,49,58,32,117,115,101,32,116,104,101,32,111,108,100,32,83,65,88,49,32,105,110,116,101,114,102,97,99,101,115,32,102,111,114,32,112,114,111,99,101,115,115,105,110,103,10,0,0,0,0,9,45,45,115,97,120,58,32,100,111,32,110,111,116,32,98,117,105,108,100,32,97,32,116,114,101,101,32,98,117,116,32,119,111,114,107,32,106,117,115,116,32,97,116,32,116,104,101,32,83,65,88,32,108,101,118,101,108,10,0,0,0,0,0,9,45,45,111,108,100,120,109,108,49,48,58,32,117,115,101,32,88,77,76,45,49,46,48,32,112,97,114,115,105,110,103,32,114,117,108,101,115,32,98,101,102,111,114,101,32,116,104,101,32,53,116,104,32,101,100,105,116,105,111,110,10,0,0,9,45,45,120,112,97,116,104,32,101,120,112,114,58,32,101,118,97,108,117,97,116,101,32,116,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,44,32,105,109,112,108,121,32,45,45,110,111,111,117,116,10,0,0,0,0,10,76,105,98,120,109,108,32,112,114,111,106,101,99,116,32,104,111,109,101,32,112,97,103,101,58,32,104,116,116,112,58,47,47,120,109,108,115,111,102,116,46,111,114,103,47,10,0,84,111,32,114,101,112,111,114,116,32,98,117,103,115,32,111,114,32,103,101,116,32,115,111,109,101,32,104,101,108,112,32,99,104,101,99,107,58,32,104,116,116,112,58,47,47,120,109,108,115,111,102,116,46,111,114,103,47,98,117,103,115,46,104,116,109,108,10,0,0,0,0,83,65,88,46,101,110,100,69,108,101,109,101,110,116,40,37,115,41,10,0,0,0,0,0,83,65,88,46,115,116,97,114,116,69,108,101,109,101,110,116,40,37,115,0,0,0,0,0,37,115,39,0,0,0,0,0,108,116,0,0,0,0,0,0,0,0,0,0,17,0,0,0,56,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,242,0,0,120,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,103,116,0,0,0,0,0,0,0,0,0,0,17,0,0,0,144,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,242,0,0,112,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,97,109,112,0,0,0,0,0,0,0,0,0,17,0,0,0,232,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,242,0,0,104,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,97,112,111,115,0,0,0,0,0,0,0,0,17,0,0,0,64,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,242,0,0,96,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,113,117,111,116,0,0,0,0,0,0,0,0,17,0,0,0,152,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,241,0,0,64,241,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,120,109,108,65,100,100,68,116,100,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,120,109,108,65,100,100,68,116,100,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,119,105,116,104,111,117,116,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,120,109,108,65,100,100,68,111,99,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,120,109,108,65,100,100,68,111,99,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,60,33,69,78,84,73,84,89,32,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,62,10,0,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,32,78,68,65,84,65,32,0,60,33,69,78,84,73,84,89,32,37,32,0,0,0,0,0,120,109,108,68,117,109,112,69,110,116,105,116,105,101,115,68,101,99,108,58,32,105,110,116,101,114,110,97,108,58,32,117,110,107,110,111,119,110,32,116,121,112,101,32,101,110,116,105,116,121,32,116,121,112,101,0,34,0,0,0,0,0,0,0,38,113,117,111,116,59,0,0,38,35,120,50,53,59,0,0,120,109,108,67,111,112,121,69,110,116,105,116,121,58,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,0,0,0,0,0,45,45,62,0,0,0,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,105,110,112,117,116,32,110,111,116,32,85,84,70,45,56,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,38,35,37,100,59,0,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,99,104,97,114,32,111,117,116,32,111,102,32,114,97,110,103,101,10,0,0,0,38,35,120,37,88,59,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,114,101,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,0,0,0,0,120,109,108,67,114,101,97,116,101,69,110,116,105,116,121,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,39,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,56,0,0,0,0,85,84,70,45,49,54,0,0,85,84,70,49,54,0,0,0,73,83,79,45,49,48,54,52,54,45,85,67,83,45,50,0,85,67,83,45,50,0,0,0,85,67,83,50,0,0,0,0,73,83,79,45,49,48,54,52,54,45,85,67,83,45,52,0,85,67,83,45,52,0,0,0,85,67,83,52,0,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,73,83,79,45,76,65,84,73,78,45,49,0,0,0,0,0,73,83,79,32,76,65,84,73,78,32,49,0,0,0,0,0,73,83,79,45,56,56,53,57,45,50,0,0,0,0,0,0,73,83,79,45,76,65,84,73,78,45,50,0,0,0,0,0,73,83,79,32,76,65,84,73,78,32,50,0,0,0,0,0,73,83,79,45,56,56,53,57,45,51,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,52,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,53,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,54,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,55,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,56,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,57,0,0,0,0,0,0,73,83,79,45,50,48,50,50,45,74,80,0,0,0,0,0,83,72,73,70,84,95,74,73,83,0,0,0,0,0,0,0,69,85,67,45,74,80,0,0,69,66,67,68,73,67,0,0,83,104,105,102,116,45,74,73,83,0,0,0,0,0,0,0,120,109,108,78,101,119,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,32,58,32,110,111,32,110,97,109,101,32,33,10,0,0,120,109,108,78,101,119,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,32,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,33,10,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,79,100,100,32,112,114,111,98,108,101,109,32,97,116,32,101,110,100,105,97,110,110,101,115,115,32,100,101,116,101,99,116,105,111,110,10,0,0,0,0,120,109,108,73,110,105,116,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,115,32,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,33,10,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,83,67,73,73,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,72,84,77,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,82,101,103,105,115,116,101,114,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,58,32,78,85,76,76,32,104,97,110,100,108,101,114,32,33,10,0,120,109,108,82,101,103,105,115,116,101,114,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,58,32,84,111,111,32,109,97,110,121,32,104,97,110,100,108,101,114,32,114,101,103,105,115,116,101,114,101,100,44,32,115,101,101,32,37,115,10,0,0,0,0,77,65,88,95,69,78,67,79,68,73,78,71,95,72,65,78,68,76,69,82,83,0,0,0,101,98,99,100,105,99,0,0,69,66,67,68,73,67,45,85,83,0,0,0,0,0,0,0,73,66,77,45,48,51,55,0,83,72,73,70,84,45,74,73,83,0,0,0,0,0,0,0,83,104,105,102,116,95,74,73,83,0,0,0,0,0,0,0,105,99,111,110,118,32,58,32,112,114,111,98,108,101,109,115,32,119,105,116,104,32,102,105,108,116,101,114,115,32,102,111,114,32,39,37,115,39,10,0,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,0,0,0,0,0,105,110,112,117,116,32,99,111,110,118,101,114,115,105,111,110,32,102,97,105,108,101,100,32,100,117,101,32,116,111,32,105,110,112,117,116,32,101,114,114,111,114,44,32,98,121,116,101,115,32,37,115,10,0,0,0,120,109,108,67,104,97,114,69,110,99,79,117,116,70,117,110,99,58,32,110,111,32,111,117,116,112,117,116,32,102,117,110,99,116,105,111,110,32,33,10,0,0,0,0,0,0,0,0,38,35,37,100,59,0,0,0,111,117,116,112,117,116,32,99,111,110,118,101,114,115,105,111,110,32,102,97,105,108,101,100,32,100,117,101,32,116,111,32,99,111,110,118,32,101,114,114,111,114,44,32,98,121,116,101,115,32,37,115,10,0,0,0,37,115,58,37,100,58,32,0,69,110,116,105,116,121,58,32,108,105,110,101,32,37,100,58,32,0,0,0,0,0,0,0,78,111,32,101,114,114,111,114,32,109,101,115,115,97,103,101,32,112,114,111,118,105,100,101,100,0,0,0,0,0,0,0,104,114,101,102,0,0,0,0,37,115,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,101,114,114,111,114,58,32,0,10,0,0,0,0,0,0,0,119,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,97,108,105,100,105,116,121,32,101,114,114,111,114,58,32,0,0,0,0,0,0,0,0,118,97,108,105,100,105,116,121,32,119,97,114,110,105,110,103,58,32,0,0,0,0,0,0,101,108,101,109,101,110,116,32,37,115,58,32,0,0,0,0,112,97,114,115,101,114,32,0,110,97,109,101,115,112,97,99,101,32,0,0,0,0,0,0,118,97,108,105,100,105,116,121,32,0,0,0,0,0,0,0,72,84,77,76,32,112,97,114,115,101,114,32,0,0,0,0,109,101,109,111,114,121,32,0,111,117,116,112,117,116,32,0,73,47,79,32,0,0,0,0,88,73,110,99,108,117,100,101,32,0,0,0,0,0,0,0,88,80,97,116,104,32,0,0,114,101,103,101,120,112,32,0,109,111,100,117,108,101,32,0,83,99,104,101,109,97,115,32,118,97,108,105,100,105,116,121,32,0,0,0,0,0,0,0,83,99,104,101,109,97,115,32,112,97,114,115,101,114,32,0,82,101,108,97,120,45,78,71,32,112,97,114,115,101,114,32,0,0,0,0,0,0,0,0,82,101,108,97,120,45,78,71,32,118,97,108,105,100,105,116,121,32,0,0,0,0,0,0,67,97,116,97,108,111,103,32,0,0,0,0,0,0,0,0,67,49,52,78,32,0,0,0,88,83,76,84,32,0,0,0,101,110,99,111,100,105,110,103,32,0,0,0,0,0,0,0,115,99,104,101,109,97,116,114,111,110,32,0,0,0,0,0,105,110,116,101,114,110,97,108,32,98,117,102,102,101,114,32,0,0,0,0,0,0,0,0,85,82,73,32,0,0,0,0,58,32,0,0,0,0,0,0,119,97,114,110,105,110,103,32,58,32,0,0,0,0,0,0,101,114,114,111,114,32,58,32,0,0,0,0,0,0,0,0,37,115,10,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,32,101,114,114,111,114,0,0,0,0,0,37,115,58,37,100,58,32,10,0,0,0,0,0,0,0,0,69,110,116,105,116,121,58,32,108,105,110,101,32,37,100,58,32,10,0,0,0,0,0,0,70,97,116,97,108,58,32,112,114,111,103,114,97,109,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,108,105,98,120,109,108,32,37,100,32,117,115,105,110,103,32,108,105,98,120,109,108,32,37,100,10,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,112,114,111,103,114,97,109,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,108,105,98,120,109,108,32,37,100,32,117,115,105,110,103,32,111,108,100,101,114,32,37,100,10,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,67,104,97,114,32,48,120,37,88,32,111,117,116,32,111,102,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,0,66,121,116,101,115,58,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,10,0,0,0,0,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,37,115,0,0,0,0,0,0,0,67,104,97,114,32,48,120,48,32,111,117,116,32,111,102,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,120,109,108,67,111,112,121,67,104,97,114,77,117,108,116,105,66,121,116,101,32,48,120,37,88,32,111,117,116,32,111,102,32,98,111,117,110,100,10,0,101,110,99,111,100,105,110,103,32,117,110,107,110,111,119,110,10,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,110,111,116,32,115,117,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+54128),
	allocate([112,111,114,116,101,100,32,37,115,10,0,0,0,0,0,0,85,83,67,52,32,108,105,116,116,108,101,32,101,110,100,105,97,110,0,0,0,0,0,0,85,83,67,52,32,98,105,103,32,101,110,100,105,97,110,0,69,66,67,68,73,67,0,0,85,67,83,52,32,50,49,52,51,0,0,0,0,0,0,0,85,67,83,52,32,51,52,49,50,0,0,0,0,0,0,0,85,67,83,50,0,0,0,0,73,83,79,45,50,48,50,50,45,74,80,0,0,0,0,0,83,104,105,102,116,95,74,73,83,0,0,0,0,0,0,0,69,85,67,45,74,80,0,0,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,97,32,110,101,119,32,105,110,112,117,116,32,115,116,114,101,97,109,10,0,0,0,110,101,119,32,105,110,112,117,116,32,102,114,111,109,32,73,47,79,10,0,0,0,0,0,120,109,108,78,101,119,69,110,116,105,116,121,73,110,112,117,116,83,116,114,101,97,109,32,101,110,116,105,116,121,32,61,32,78,85,76,76,10,0,0,110,101,119,32,105,110,112,117,116,32,102,114,111,109,32,101,110,116,105,116,121,58,32,37,115,10,0,0,0,0,0,0,67,97,110,110,111,116,32,112,97,114,115,101,32,101,110,116,105,116,121,32,37,115,10,0,73,110,116,101,114,110,97,108,32,101,110,116,105,116,121,32,37,115,32,119,105,116,104,111,117,116,32,99,111,110,116,101,110,116,32,33,10,0,0,0,73,110,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,37,115,32,119,105,116,104,111,117,116,32,99,111,110,116,101,110,116,32,33,10,0,80,114,101,100,101,102,105,110,101,100,32,101,110,116,105,116,121,32,37,115,32,119,105,116,104,111,117,116,32,99,111,110,116,101,110,116,32,33,10,0,110,101,119,32,105,110,112,117,116,32,102,114,111,109,32,102,105,108,101,58,32,37,115,10,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,58,32,78,85,76,76,32,102,105,108,101,110,97,109,101,32,10,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,0,71,111,116,32,78,85,76,76,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,102,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,10,0,0,0,0,0,0,120,109,108,83,119,105,116,99,104,84,111,69,110,99,111,100,105,110,103,32,58,32,110,111,32,105,110,112,117,116,10,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,115,119,105,116,99,104,105,110,103,32,101,110,99,111,100,105,110,103,58,32,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,0,0,0,0,115,119,105,116,99,104,105,110,103,32,101,110,99,111,100,105,110,103,32,58,32,110,111,32,105,110,112,117,116,10,0,0,0,1,0,0,0,0,0,0,69,120,99,101,115,115,105,118,101,32,100,101,112,116,104,32,105,110,32,100,111,99,117,109,101,110,116,58,32,37,100,32,117,115,101,32,88,77,76,95,80,65,82,83,69,95,72,85,71,69,32,111,112,116,105,111,110,10,0,0,0,0,0,0,80,111,112,112,105,110,103,32,105,110,112,117,116,32,37,100,10,0,0,0,0,0,0,0,37,115,40,37,100,41,58,32,0,0,0,0,0,0,0,0,80,117,115,104,105,110,103,32,105,110,112,117,116,32,37,100,32,58,32,37,46,51,48,115,10,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,37,115,10,0,0,0,0,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,37,37,37,115,59,32,110,111,116,32,102,111,117,110,100,10,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,37,115,32,105,115,32,110,111,116,32,97,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,10,0,0,0,0,0,0,83,116,114,105,110,103,32,100,101,99,111,100,105,110,103,32,69,110,116,105,116,121,32,82,101,102,101,114,101,110,99,101,58,32,37,46,51,48,115,10,0,0,0,0,0,0,0,0,112,114,101,100,101,102,105,110,101,100,32,101,110,116,105,116,121,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,0,83,116,114,105,110,103,32,100,101,99,111,100,105,110,103,32,80,69,32,82,101,102,101,114,101,110,99,101,58,32,37,46,51,48,115,10,0,0,0,0,0,0,0,0,0,0,0,0,78,97,109,101,32,37,115,32,105,115,32,110,111,116,32,88,77,76,32,78,97,109,101,115,112,97,99,101,32,99,111,109,112,108,105,97,110,116,10,0,78,97,109,101,0,0,0,0,78,109,84,111,107,101,110,0,69,110,116,105,116,121,86,97,108,117,101,58,32,39,37,99,39,32,102,111,114,98,105,100,100,101,110,32,101,120,99,101,112,116,32,102,111,114,32,101,110,116,105,116,105,101,115,32,114,101,102,101,114,101,110,99,101,115,10,0,0,0,0,0,83,121,115,116,101,109,76,105,116,101,114,97,108,0,0,0,80,117,98,108,105,99,32,73,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,33,34,35,36,37,0,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,0,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,0,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,83,89,83,84,69,77,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,80,85,66,76,73,67,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,10,0,0,0,0,0,67,111,109,109,101,110,116,32,116,111,111,32,98,105,103,32,102,111,117,110,100,0,0,0,99,111,109,109,101,110,116,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,119,105,116,104,105,110,32,99,111,109,109,101,110,116,58,32,60,33,45,45,37,46,53,48,115,10,0,0,0,0,0,0,0,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,119,105,116,104,105,110,32,99,111,109,109,101,110,116,10,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,97,108,108,111,119,101,100,32,111,110,108,121,32,97,116,32,116,104,101,32,115,116,97,114,116,32,111,102,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,0,168,27,1,0,184,27,1,0,0,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,80,73,84,97,114,103,101,116,58,32,105,110,118,97,108,105,100,32,110,97,109,101,32,112,114,101,102,105,120,32,39,120,109,108,39,10,0,0,0,0,99,111,108,111,110,115,32,97,114,101,32,102,111,114,98,105,100,100,101,110,32,102,114,111,109,32,80,73,32,110,97,109,101,115,32,39,37,115,39,10,0,0,0,0,0,0,0,0,80,73,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,115,112,97,99,101,32,101,120,112,101,99,116,101,100,10,0,0,80,73,32,37,115,32,116,111,111,32,98,105,103,32,102,111,117,110,100,0,0,0,0,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,110,101,118,101,114,32,101,110,100,32,46,46,46,10,0,0,0,111,97,115,105,115,45,120,109,108,45,99,97,116,97,108,111,103,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,60,33,78,79,84,65,84,73,79,78,39,10,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,78,79,84,65,84,73,79,78,32,110,97,109,101,39,10,0,0,0,0,0,0,0,0,99,111,108,111,110,115,32,97,114,101,32,102,111,114,98,105,100,100,101,110,32,102,114,111,109,32,110,111,116,97,116,105,111,110,32,110,97,109,101,115,32,39,37,115,39,10,0,0,78,111,116,97,116,105,111,110,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,60,33,69,78,84,73,84,89,39,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,37,39,10,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,69,110,116,105,116,121,68,101,99,108,58,32,110,111,32,110,97,109,101,10,0,0,0,0,99,111,108,111,110,115,32,97,114,101,32,102,111,114,98,105,100,100,101,110,32,102,114,111,109,32,101,110,116,105,116,105,101,115,32,110,97,109,101,115,32,39,37,115,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,101,110,116,105,116,121,32,110,97,109,101,10,0,0,0,73,110,118,97,108,105,100,32,85,82,73,58,32,37,115,10,0,0,0,0,0,0,0,0,83,65,88,32,99,111,109,112,97,116,105,98,105,108,105,116,121,32,109,111,100,101,32,100,111,99,117,109,101,110,116,0,78,101,119,32,68,111,99,32,102,97,105,108,101,100,0,0,102,97,107,101,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,98,101,102,111,114,101,32,39,78,68,65,84,65,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,78,68,65,84,65,39,10,0,0,0,120,109,108,80,97,114,115,101,69,110,116,105,116,121,68,101,99,108,58,32,101,110,116,105,116,121,32,37,115,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,10,0,0,0,69,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,35,70,73,88,69,68,39,10,0,0,65,116,116,114,105,98,117,116,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,100,101,99,108,97,114,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,78,97,109,101,32,101,120,112,101,99,116,101,100,32,105,110,32,78,79,84,65,84,73,79,78,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,110,111,116,97,116,105,111,110,32,118,97,108,117,101,32,116,111,107,101,110,32,37,115,32,100,117,112,108,105,99,97,116,101,100,10,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,101,110,117,109,101,114,97,116,105,111,110,32,118,97,108,117,101,32,116,111,107,101,110,32,37,115,32,100,117,112,108,105,99,97,116,101,100,10,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,78,79,84,65,84,73,79,78,39,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,60,33,65,84,84,76,73,83,84,39,10,0,0,0,0,0,0,0,65,84,84,76,73,83,84,58,32,110,111,32,110,97,109,101,32,102,111,114,32,69,108,101,109,101,110,116,10,0,0,0,65,84,84,76,73,83,84,58,32,110,111,32,110,97,109,101,32,102,111,114,32,65,116,116,114,105,98,117,116,101,10,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,10,0,0,0,0,0,0,0,105,110,32,120,109,108,80,97,114,115,101,65,116,116,114,105,98,117,116,101,76,105,115,116,68,101,99,108,10,0,0,0,65,116,116,114,105,98,117,116,101,32,108,105,115,116,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,77,105,120,101,100,67,111,110,116,101,110,116,68,101,99,108,32,58,32,78,97,109,101,32,101,120,112,101,99,116,101,100,10,0,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,67,111,110,116,101,110,116,68,101,99,108,32,58,32,37,115,32,39,40,39,32,101,120,112,101,99,116,101,100,10,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,69,76,69,77,69,78,84,39,10,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,68,101,99,108,58,32,110,111,32,110,97,109,101,32,102,111,114,32,69,108,101,109,101,110,116,10,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,102,111,114,98,105,100,100,101,110,32,119,105,116,104,105,110,32,109,97,114,107,117,112,32,100,101,99,108,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,68,101,99,108,58,32,39,69,77,80,84,89,39,44,32,39,65,78,89,39,32,111,114,32,39,40,39,32,101,120,112,101,99,116,101,100,10,0,0,0,0,69,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,83,112,97,99,101,32,110,101,101,100,101,100,32,97,102,116,101,114,32,39,60,63,120,109,108,39,10,0,0,0,0,0,49,46,48,0,0,0,0,0,83,112,97,99,101,32,110,101,101,100,101,100,32,104,101,114,101,10,0,0,0,0,0,0,77,105,115,115,105,110,103,32,101,110,99,111,100,105,110,103,32,105,110,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,0,35,120,37,88,0,0,0,0,35,37,100,0,0,0,0,0,105,110,118,97,108,105,100,32,101,110,116,105,116,121,32,116,121,112,101,32,102,111,117,110,100,10,0,0,0,0,0,0,69,110,116,105,116,121,32,39,37,115,39,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,10,0,0,0,0,110,98,107,116,101,120,116,0,120,109,108,80,97,114,115,101,69,110,116,105,116,121,82,101,102,58,32,110,111,32,110,97,109,101,10,0,0,0,0,0,69,110,116,105,116,121,32,39,37,115,39,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,0,69,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,116,111,32,117,110,112,97,114,115,101,100,32,101,110,116,105,116,121,32,37,115,10,0,65,116,116,114,105,98,117,116,101,32,114,101,102,101,114,101,110,99,101,115,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,39,37,115,39,10,0,0,0,0,0,0,39,60,39,32,105,110,32,101,110,116,105,116,121,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,97,116,116,114,105,98,117,116,101,115,32,118,97,108,117,101,115,10,0,65,116,116,101,109,112,116,32,116,111,32,114,101,102,101,114,101,110,99,101,32,116,104,101,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,39,37,115,39,10,0,120,109,108,80,97,114,115,101,80,69,82,101,102,101,114,101,110,99,101,58,32,110,111,32,110,97,109,101,10,0,0,0,73,110,116,101,114,110,97,108,58,32,37,37,37,115,59,32,105,115,32,110,111,116,32,97,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,10,0,0,0,0,0,0,120,109,108,80,97,114,115,101,68,111,99,84,121,112,101,68,101,99,108,32,58,32,110,111,32,68,79,67,84,89,80,69,32,110,97,109,101,32,33,10,0,0,0,0,0,0,0,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,10,0,0,0,83,112,101,99,105,102,105,99,97,116,105,111,110,32,109,97,110,100,97,116,101,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,10,0,0,0,120,109,108,58,108,97,110,103,0,0,0,0,0,0,0,0,77,97,108,102,111,114,109,101,100,32,118,97,108,117,101,32,102,111,114,32,120,109,108,58,108,97,110,103,32,58,32,37,115,10,0,0,0,0,0,0,120,109,108,58,115,112,97,99,101,0,0,0,0,0,0,0,100,101,102,97,117,108,116,0,112,114,101,115,101,114,118,101,0,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,34,37,115,34,32,102,111,114,32,120,109,108,58,115,112,97,99,101,32,58,32,34,100,101,102,97,117,108,116,34,32,111,114,32,34,112,114,101,115,101,114,118,101,34,32,101,120,112,101,99,116,101,100,10,0,0,0,0,120,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,105,110,118,97,108,105,100,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,97,116,116,114,105,98,117,116,101,115,32,99,111,110,115,116,114,117,99,116,32,101,114,114,111,114,10,0,0,0,0,0,120,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,112,114,111,98,108,101,109,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,115,10,0,0,0,67,68,97,116,97,32,115,101,99,116,105,111,110,32,116,111,111,32,98,105,103,32,102,111,117,110,100,0,0,0,0,0,67,68,97,116,97,32,115,101,99,116,105,111,110,32,110,111,116,32,102,105,110,105,115,104,101,100,10,37,46,53,48,115,10,0,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,110,32,101,114,114,111,114,32,105,110,32,101,108,101,109,101,110,116,32,99,111,110,116,101,110,116,10,0,0,0,67,111,117,108,100,110,39,116,32,102,105,110,100,32,101,110,100,32,111,102,32,83,116,97,114,116,32,84,97,103,32,37,115,32,108,105,110,101,32,37,100,10,0,0,0,0,0,0,80,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,100,97,116,97,32,105,110,32,116,97,103,32,37,115,32,108,105,110,101,32,37,100,10,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,85,84,70,49,54,0,0,0,68,111,99,117,109,101,110,116,32,108,97,98,101,108,108,101,100,32,85,84,70,45,49,54,32,98,117,116,32,104,97,115,32,85,84,70,45,56,32,99,111,110,116,101,110,116,10,0,85,84,70,45,56,0,0,0,85,84,70,56,0,0,0,0,85,110,115,117,112,112,111,114,116,101,100,32,101,110,99,111,100,105,110,103,32,37,115,10,0,0,0,0,0,0,0,0,66,108,97,110,107,32,110,101,101,100,101,100,32,97,102,116,101,114,32,39,60,63,120,109,108,39,10,0,0,0,0,0,85,110,115,117,112,112,111,114,116,101,100,32,118,101,114,115,105,111,110,32,39,37,115,39,10,0,0,0,0,0,0,0,66,108,97,110,107,32,110,101,101,100,101,100,32,104,101,114,101,10,0,0,0,0,0,0,83,116,97,114,116,32,116,97,103,32,101,120,112,101,99,116,101,100,44,32,39,60,39,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,85,67,83,45,52,0,0,0,85,67,83,52,0,0,0,0,120,109,108,80,97,114,115,101,67,104,117,110,107,58,32,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,0,72,117,103,101,32,105,110,112,117,116,32,108,111,111,107,117,112,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,112,97,114,115,101,114,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,110,111,110,101,0,0,0,0,112,115,101,117,100,111,114,111,111,116,0,0,0,0,0,0,86,101,114,115,105,111,110,32,109,105,115,109,97,116,99,104,32,98,101,116,119,101,101,110,32,100,111,99,117,109,101,110,116,32,97,110,100,32,101,110,116,105,116,121,10,0,0,0,120,109,108,0,0,0,0,0,120,109,108,110,115,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,111,117,108,100,110,39,116,32,102,105,110,100,32,101,110,100,32,111,102,32,83,116,97,114,116,32,84,97,103,32,37,115,10,0,0,0,0,0,0,60,33,91,67,68,65,84,65,91,0,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,67,79,77,77,69,78,84,10,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,73,71,78,79,82,69,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,80,73,10,0,0,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,68,69,67,76,10,0,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,86,65,76,85,69,10,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,65,84,84,82,73,66,85,84,69,95,86,65,76,85,69,10,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,83,89,83,84,69,77,95,76,73,84,69,82,65,76,10,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,80,85,66,76,73,67,95,76,73,84,69,82,65,76,10,0,0,0,0,66,121,116,101,115,58,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,10,0,0,0,0,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,37,115,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,80,97,114,115,101,71,101,116,76,97,115,116,115,10,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,73,110,116,101,114,110,97,108,83,117,98,115,101,116,58,32,101,114,114,111,114,32,100,101,116,101,99,116,101,100,32,105,110,32,77,97,114,107,117,112,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,0,117,110,112,97,114,115,101,97,98,108,101,0,0,0,0,0,79,112,101,110,105,110,103,32,97,110,100,32,101,110,100,105,110,103,32,116,97,103,32,109,105,115,109,97,116,99,104,58,32,37,115,32,108,105,110,101,32,37,100,32,97,110,100,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,81,78,97,109,101,32,39,37,115,39,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,81,78,97,109,101,32,39,37,115,58,39,10,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,81,78,97,109,101,32,39,37,115,58,37,115,58,39,10,0,78,67,78,97,109,101,0,0,80,98,109,32,112,111,112,112,105,110,103,32,37,100,32,78,83,10,0,0,0,0,0,0,83,116,97,114,116,84,97,103,58,32,105,110,118,97,108,105,100,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,100,105,99,116,105,111,110,97,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,117,114,101,0,0,0,120,109,108,110,115,58,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,120,109,108,110,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,120,109,108,32,110,97,109,101,115,112,97,99,101,32,85,82,73,32,99,97,110,110,111,116,32,98,101,32,116,104,101,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,10,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,114,101,117,115,101,32,111,102,32,116,104,101,32,120,109,108,110,115,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,105,115,32,102,111,114,98,105,100,100,101,110,10,0,120,109,108,32,110,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,109,97,112,112,101,100,32,116,111,32,119,114,111,110,103,32,85,82,73,10,0,0,0,0,0,0,0,120,109,108,32,110,97,109,101,115,112,97,99,101,32,85,82,73,32,109,97,112,112,101,100,32,116,111,32,119,114,111,110,103,32,112,114,101,102,105,120,10,0,0,0,0,0,0,0,114,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,120,109,108,110,115,32,112,114,101,102,105,120,32,105,115,32,102,111,114,98,105,100,100,101,110,10,0,0,120,109,108,110,115,58,37,115,58,32,69,109,112,116,121,32,88,77,76,32,110,97,109,101,115,112,97,99,101,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,120,109,108,110,115,58,37,115,58,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,0,0,0,0,0,120,109,108,110,115,58,37,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,110,32,37,115,32,100,101,102,97,117,108,116,101,100,32,102,114,111,109,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,102,111,114,32,37,115,32,111,110,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,100,32,65,116,116,114,105,98,117,116,101,32,37,115,32,105,110,32,39,37,115,39,32,114,101,100,101,102,105,110,101,100,10,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,111,110,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,108,97,110,103,0,0,0,0,115,112,97,99,101,0,0,0,65,116,116,86,97,108,117,101,32,108,101,110,103,116,104,32,116,111,111,32,108,111,110,103,10,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,10,0,0,0,65,116,116,86,97,108,117,101,58,32,39,32,101,120,112,101,99,116,101,100,10,0,0,0,120,109,108,80,97,114,115,101,69,110,100,84,97,103,58,32,39,60,47,39,32,110,111,116,32,102,111,117,110,100,10,0,65,116,116,114,105,98,117,116,101,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,65,116,116,114,105,98,117,116,101,32,37,115,58,37,115,32,114,101,100,101,102,105,110,101,100,10,0,0,0,0,0,0,120,109,108,80,97,114,115,101,83,116,114,105,110,103,80,69,82,101,102,101,114,101,110,99,101,58,32,110,111,32,110,97,109,101,10,0,0,0,0,0,37,37,37,115,59,32,105,115,32,110,111,116,32,97,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,10,0,0,0,0,0,0,0,0,120,109,108,76,111,97,100,69,110,116,105,116,121,67,111,110,116,101,110,116,32,112,97,114,97,109,101,116,101,114,32,101,114,114,111,114,0,0,0,0,82,101,97,100,105,110,103,32,37,115,32,101,110,116,105,116,121,32,99,111,110,116,101,110,116,32,105,110,112,117,116,10,0,0,0,0,0,0,0,0,120,109,108,76,111,97,100,69,110,116,105,116,121,67,111,110,116,101,110,116,32,105,110,112,117,116,32,101,114,114,111,114,0,0,0,0,0,0,0,0,120,109,108,76,111,97,100,69,110,116,105,116,121,67,111,110,116,101,110,116,58,32,105,110,118,97,108,105,100,32,99,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,120,109,108,80,97,114,115,101,83,116,114,105,110,103,69,110,116,105,116,121,82,101,102,58,32,110,111,32,110,97,109,101,10,0,0,0,0,0,0,0,65,108,108,32,109,97,114,107,117,112,32,111,102,32,116,104,101,32,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,0,0,69,110,116,101,114,105,110,103,32,73,78,67,76,85,68,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,76,101,97,118,105,110,103,32,73,78,67,76,85,68,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,0,69,110,116,101,114,105,110,103,32,73,71,78,79,82,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,0,76,101,97,118,105,110,103,32,73,71,78,79,82,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,67,104,105,108,100,114,101,110,67,111,110,116,101,110,116,68,101,99,108,32,58,32,100,101,112,116,104,32,37,100,32,116,111,111,32,100,101,101,112,44,32,117,115,101,32,88,77,76,95,80,65,82,83,69,95,72,85,71,69,10,0,0,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,67,104,105,108,100,114,101,110,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,37,99,39,32,101,120,112,101,99,116,101,100,10,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,99,97,116,97,108,111,103,0,67,97,116,97,108,111,103,32,80,73,32,115,121,110,116,97,120,32,101,114,114,111,114,58,32,37,115,10,0,0,0,0,120,109,108,45,115,116,121,108,101,115,104,101,101,116,0,0,120,109,108,45,109,111,100,101,108,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,67,111,109,109,101,110,116,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,0,67,111,109,109,101,110,116,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,32,10,60,33,45,45,37,46,53,48,115,10,0,0,0,0,0,0,67,111,109,109,101,110,116,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,67,111,109,109,101,110,116,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,10,0,80,67,68,65,84,65,32,105,110,118,97,108,105,100,32,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,37,115,0,0,0,0,0,0,120,109,108,80,97,114,115,101,83,116,114,105,110,103,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,0,0,0,120,109,108,78,101,119,66,108,97,110,107,115,87,114,97,112,112,101,114,73,110,112,117,116,83,116,114,101,97,109,32,101,110,116,105,116,121,10,0,0,110,101,119,32,98,108,97,110,107,115,32,119,114,97,112,112,101,114,32,102,111,114,32,101,110,116,105,116,121,58,32,37,115,10,0,0,0,0,0,0,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,104,101,120,97,100,101,99,105,109,97,108,32,118,97,108,117,101,0,0,0,0,0,0,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,100,101,99,105,109,97,108,32,118,97,108,117,101,0,0,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,118,97,108,117,101,0,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,0,0,80,69,82,101,102,101,114,101,110,99,101,32,97,116,32,101,110,100,32,111,102,32,100,111,99,117,109,101,110,116,0,0,80,69,82,101,102,101,114,101,110,99,101,32,105,110,32,112,114,111,108,111,103,0,0,0,80,69,82,101,102,101,114,101,110,99,101,32,105,110,32,101,112,105,108,111,103,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,110,111,32,110,97,109,101,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,101,120,112,101,99,116,105,110,103,32,39,59,39,0,0,0,0,0,0,68,101,116,101,99,116,101,100,32,97,110,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,108,111,111,112,0,0,0,0,0,0,0,69,110,116,105,116,121,86,97,108,117,101,58,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,115,32,102,111,114,98,105,100,100,101,110,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,65,116,116,86,97,108,117,101,58,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,0,0,85,110,101,115,99,97,112,101,100,32,39,60,39,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,97,116,116,114,105,98,117,116,101,115,32,118,97,108,117,101,115,0,0,83,121,115,116,101,109,76,105,116,101,114,97,108,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,0,85,110,102,105,110,105,115,104,101,100,32,83,121,115,116,101,109,32,111,114,32,80,117,98,108,105,99,32,73,68,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,83,101,113,117,101,110,99,101,32,39,93,93,62,39,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,99,111,110,116,101,110,116,0,0,0,83,89,83,84,69,77,32,111,114,32,80,85,66,76,73,67,44,32,116,104,101,32,85,82,73,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,80,85,66,76,73,67,44,32,116,104,101,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,67,111,109,109,101,110,116,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,45,45,39,32,40,100,111,117,98,108,101,45,104,121,112,104,101,110,41,0,0,0,120,109,108,80,97,114,115,101,80,73,32,58,32,110,111,32,116,97,114,103,101,116,32,110,97,109,101,0,0,0,0,0,73,110,118,97,108,105,100,32,80,73,32,110,97,109,101,0,78,79,84,65,84,73,79,78,58,32,78,97,109,101,32,101,120,112,101,99,116,101,100,32,104,101,114,101,0,0,0,0,39,62,39,32,114,101,113,117,105,114,101,100,32,116,111,32,99,108,111,115,101,32,78,79,84,65,84,73,79,78,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,69,110,116,105,116,121,32,118,97,108,117,101,32,114,101,113,117,105,114,101,100,0,0,0,70,114,97,103,109,101,110,116,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,39,40,39,32,114,101,113,117,105,114,101,100,32,116,111,32,115,116,97,114,116,32,65,84,84,76,73,83,84,32,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,0,0,78,109,84,111,107,101,110,32,101,120,112,101,99,116,101,100,32,105,110,32,65,84,84,76,73,83,84,32,101,110,117,109,101,114,97,116,105,111,110,0,39,41,39,32,114,101,113,117,105,114,101,100,32,116,111,32,102,105,110,105,115,104,32,65,84,84,76,73,83,84,32,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,0,77,105,120,101,100,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,124,39,32,111,114,32,39,41,42,39,32,101,120,112,101,99,116,101,100,0,77,105,120,101,100,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,35,80,67,68,65,84,65,39,32,101,120,112,101,99,116,101,100,0,0,0,67,111,110,116,101,110,116,68,101,99,108,32,58,32,78,97,109,101,32,111,114,32,39,40,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,0,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,44,39,32,39,124,39,32,111,114,32,39,41,39,32,101,120,112,101,99,116,101,100,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,102,111,114,98,105,100,100,101,110,32,119,105,116,104,105,110,32,109,97,114,107,117,112,32,100,101,99,108,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,101,120,112,101,99,116,101,100,32,39,62,39,0,0,0,0,88,77,76,32,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,39,91,39,32,101,120,112,101,99,116,101,100,0,0,0,0,67,111,110,116,101,110,116,32,101,114,114,111,114,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,73,78,67,76,85,68,69,32,111,114,32,73,71,78,79,82,69,32,107,101,121,119,111,114,100,32,101,120,112,101,99,116,101,100,0,0,88,77,76,32,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,110,111,116,32,99,108,111,115,101,100,0,0,0,0,0,0,84,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,39,60,63,120,109,108,39,32,114,101,113,117,105,114,101,100,0,0,0,0,0,0,0,112,97,114,115,105,110,103,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,58,32,39,63,62,39,32,101,120,112,101,99,116,101,100,0,0,101,120,116,101,114,110,97,108,32,112,97,114,115,101,100,32,101,110,116,105,116,105,101,115,32,99,97,110,110,111,116,32,98,101,32,115,116,97,110,100,97,108,111,110,101,0,0,0,69,110,116,105,116,121,82,101,102,58,32,101,120,112,101,99,116,105,110,103,32,39,59,39,0,0,0,0,0,0,0,0,68,79,67,84,89,80,69,32,105,109,112,114,111,112,101,114,108,121,32,116,101,114,109,105,110,97,116,101,100],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+64368),
	allocate([69,110,100,84,97,103,58,32,39,60,47,39,32,110,111,116,32,102,111,117,110,100,0,0,101,120,112,101,99,116,101,100,32,39,61,39,0,0,0,0,83,116,114,105,110,103,32,110,111,116,32,99,108,111,115,101,100,32,101,120,112,101,99,116,105,110,103,32,34,32,111,114,32,39,0,0,0,0,0,0,83,116,114,105,110,103,32,110,111,116,32,115,116,97,114,116,101,100,32,101,120,112,101,99,116,105,110,103,32,39,32,111,114,32,34,0,0,0,0,0,73,110,118,97,108,105,100,32,88,77,76,32,101,110,99,111,100,105,110,103,32,110,97,109,101,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,39,121,101,115,39,32,111,114,32,39,110,111,39,0,0,0,68,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,0,0,0,0,0,0,0,69,120,116,114,97,32,99,111,110,116,101,110,116,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,100,111,99,117,109,101,110,116,0,0,0,0,0,0,0,0,99,104,117,110,107,32,105,115,32,110,111,116,32,119,101,108,108,32,98,97,108,97,110,99,101,100,0,0,0,0,0,0,101,120,116,114,97,32,99,111,110,116,101,110,116,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,119,101,108,108,32,98,97,108,97,110,99,101,100,32,99,104,117,110,107,0,77,97,108,102,111,114,109,101,100,32,100,101,99,108,97,114,97,116,105,111,110,32,101,120,112,101,99,116,105,110,103,32,118,101,114,115,105,111,110,0,78,97,109,101,32,116,111,111,32,108,111,110,103,32,117,115,101,32,88,77,76,95,80,65,82,83,69,95,72,85,71,69,32,111,112,116,105,111,110,0,85,110,114,101,103,105,115,116,101,114,101,100,32,101,114,114,111,114,32,109,101,115,115,97,103,101,0,0,0,0,0,0,37,115,10,0,0,0,0,0,37,115,58,32,37,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,101,120,116,0,0,0,0,116,101,120,116,110,111,101,110,99,0,0,0,0,0,0,0,99,111,109,109,101,110,116,0,98,117,105,108,100,105,110,103,32,81,78,97,109,101,0,0,81,78,97,109,101,32,115,112,108,105,116,0,0,0,0,0,120,109,108,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,98,117,105,108,100,105,110,103,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,68,84,68,0,0,0,0,98,117,105,108,100,105,110,103,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,0,49,46,48,0,0,0,0,0,98,117,105,108,100,105,110,103,32,100,111,99,0,0,0,0,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,80,73,0,0,0,0,0,98,117,105,108,100,105,110,103,32,110,111,100,101,0,0,0,98,117,105,108,100,105,110,103,32,116,101,120,116,0,0,0,98,117,105,108,100,105,110,103,32,99,104,97,114,97,99,116,101,114,32,114,101,102,101,114,101,110,99,101,0,0,0,0,98,117,105,108,100,105,110,103,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,99,111,109,109,101,110,116,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,67,68,65,84,65,0,0,103,101,116,116,105,110,103,32,110,111,100,101,32,112,97,116,104,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,37,115,58,37,115,0,0,0,42,0,0,0,0,0,0,0,99,111,109,109,101,110,116,40,41,0,0,0,0,0,0,0,116,101,120,116,40,41,0,0,112,114,111,99,101,115,115,105,110,103,45,105,110,115,116,114,117,99,116,105,111,110,40,39,37,115,39,41,0,0,0,0,47,64,0,0,0,0,0,0,37,115,0,0,0,0,0,0,37,115,37,115,37,115,0,0,37,115,37,115,91,37,100,93,37,115,0,0,0,0,0,0,108,97,110,103,0,0,0,0,115,112,97,99,101,0,0,0,100,101,102,97,117,108,116,0,112,114,101,115,101,114,118,101,0,0,0,0,0,0,0,0,98,97,115,101,0,0,0,0,104,116,109,108,0,0,0,0,104,101,97,100,0,0,0,0,104,114,101,102,0,0,0,0,104,116,116,112,58,47,47,0,102,116,112,58,47,47,0,0,117,114,110,58,0,0,0,0,103,101,116,116,105,110,103,32,110,97,109,101,115,112,97,99,101,32,108,105,115,116,0,0,115,101,97,114,99,104,105,110,103,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,1,0,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,98,117,102,102,101,114,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,0,0,34,0,0,0,0,0,0,0,38,113,117,111,116,59,0,0,39,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,37,46,50,48,115,0,0,0,100,101,102,97,117,108,116,37,100,0,0,0,0,0,0,0,37,46,50,48,115,37,100,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,88,77,76,32,110,97,109,101,115,112,97,99,101,0,0,0,0,99,111,112,121,105,110,103,32,110,111,100,101,0,0,0,0,105,110,118,97,108,105,100,32,104,101,120,97,100,101,99,105,109,97,108,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,105,110,118,97,108,105,100,32,100,101,99,105,109,97,108,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,37,49,53,115,10,0,0,0,0,0,115,116,114,105,110,103,32,105,115,32,110,111,116,32,105,110,32,85,84,70,45,56,10,0,117,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,32,110,117,109,98,101,114,10,0,0,0,0,0,0,0,0,152,45,1,0,176,45,1,0,200,45,1,0,240,45,1,0,8,46,1,0,24,46,1,0,40,46,1,0,64,46,1,0,88,46,1,0,120,46,1,0,136,46,1,0,152,46,1,0,168,46,1,0,184,46,1,0,208,46,1,0,240,46,1,0,8,47,1,0,32,47,1,0,48,47,1,0,72,47,1,0,88,47,1,0,128,47,1,0,152,47,1,0,184,47,1,0,200,47,1,0,232,47,1,0,0,48,1,0,24,48,1,0,48,48,1,0,72,48,1,0,104,48,1,0,120,48,1,0,144,48,1,0,160,48,1,0,200,48,1,0,232,48,1,0,0,49,1,0,16,49,1,0,40,49,1,0,64,49,1,0,80,49,1,0,96,49,1,0,120,49,1,0,136,49,1,0,176,49,1,0,192,49,1,0,208,49,1,0,224,49,1,0,240,49,1,0,0,50,1,0,16,50,1,0,32,50,1,0,56,50,1,0,80,50,1,0,104,50,1,0,120,50,1,0,136,50,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,114,101,97,100,40,41,0,102,102,108,117,115,104,40,41,0,0,0,0,0,0,0,0,102,99,108,111,115,101,40,41,0,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,105,110,112,117,116,32,98,117,102,102,101,114,0,0,0,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,102,105,108,101,0,0,0,0,103,114,111,119,105,110,103,32,105,110,112,117,116,32,98,117,102,102,101,114,0,0,0,0,30,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,99,97,110,111,110,105,99,97,108,32,112,97,116,104,10,0,0,0,0,0,0,0,0,102,116,112,58,47,47,0,0,104,116,116,112,58,47,47,0,78,85,76,76,0,0,0,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,0,102,105,108,101,58,47,47,108,111,99,97,108,104,111,115,116,47,0,0,0,0,0,0,0,102,105,108,101,58,47,47,47,0,0,0,0,0,0,0,0,119,114,105,116,101,40,41,0,99,108,111,115,101,40,41,0,114,101,97,100,40,41,0,0,102,119,114,105,116,101,40,41,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,102,105,108,101,58,47,0,0,114,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,73,79,32,101,114,114,111,114,0,0,0,0,0,0,0,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,0,0,0,0,0,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,0,0,0,0,0,0,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,0,0,0,0,66,97,100,32,109,101,115,115,97,103,101,0,0,0,0,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,0,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,0,0,0,0,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,101,115,0,0,0,0,0,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,97,118,111,105,100,101,100,0,0,0,0,0,0,0,68,111,109,97,105,110,32,101,114,114,111,114,0,0,0,0,70,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,66,97,100,32,97,100,100,114,101,115,115,0,0,0,0,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,0,0,73,110,116,101,114,114,117,112,116,101,100,32,102,117,110,99,116,105,111,110,32,99,97,108,108,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,0,0,73,110,112,117,116,47,111,117,116,112,117,116,32,101,114,114,111,114,0,0,0,0,0,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,0,0,0,0,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,0,73,110,97,112,112,114,111,112,114,105,97,116,101,32,109,101,115,115,97,103,101,32,98,117,102,102,101,114,32,108,101,110,103,116,104,0,0,0,0,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,0,0,0,0,0,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,0,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,0,0,0,0,0,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,0,0,0,0,0,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,0,0,0,0,0,78,111,116,32,101,110,111,117,103,104,32,115,112,97,99,101,0,0,0,0,0,0,0,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,0,0,0,0,0,0,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,0,0,0,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,73,110,97,112,112,114,111,112,114,105,97,116,101,32,73,47,79,32,99,111,110,116,114,111,108,32,111,112,101,114,97,116,105,111,110,0,0,0,0,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,0,0,0,0,0,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,66,114,111,107,101,110,32,112,105,112,101,0,0,0,0,0,82,101,115,117,108,116,32,116,111,111,32,108,97,114,103,101,0,0,0,0,0,0,0,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,0,0,73,110,118,97,108,105,100,32,115,101,101,107,0,0,0,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,0,0,0,0,73,109,112,114,111,112,101,114,32,108,105,110,107,0,0,0,65,116,116,101,109,112,116,32,116,111,32,108,111,97,100,32,110,101,116,119,111,114,107,32,101,110,116,105,116,121,32,37,115,0,0,0,0,0,0,0,101,110,99,111,100,101,114,32,101,114,114,111,114,0,0,0,102,108,117,115,104,32,101,114,114,111,114,0,0,0,0,0,119,114,105,116,101,32,101,114,114,111,114,0,0,0,0,0,110,111,32,105,110,112,117,116,0,0,0,0,0,0,0,0,98,117,102,102,101,114,32,102,117,108,108,0,0,0,0,0,108,111,97,100,105,110,103,32,101,114,114,111,114,0,0,0,110,111,116,32,97,32,115,111,99,107,101,116,0,0,0,0,97,108,114,101,97,100,121,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,0,99,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,0,0,0,0,0,117,110,114,101,97,99,104,97,98,108,101,32,110,101,116,119,111,114,107,0,0,0,0,0,97,100,100,100,114,101,115,115,32,105,110,32,117,115,101,0,97,108,114,101,97,100,121,32,105,110,32,117,115,101,0,0,117,110,107,110,111,119,110,32,97,100,100,114,101,115,115,32,102,97,109,105,108,108,121,0,120,109,108,77,97,108,108,111,99,66,114,101,97,107,112,111,105,110,116,32,114,101,97,99,104,101,100,32,111,110,32,98,108,111,99,107,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,77,97,108,108,111,99,76,111,99,32,58,32,79,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,112,32,58,32,77,97,108,108,111,99,40,37,108,117,41,32,79,107,10,0,0,0,0,110,111,110,101,0,0,0,0,37,112,32,58,32,82,101,97,108,108,111,99,101,100,40,37,108,117,32,45,62,32,37,108,117,41,32,79,107,10,0,0,116,114,121,105,110,103,32,116,111,32,102,114,101,101,32,112,111,105,110,116,101,114,32,102,114,111,109,32,102,114,101,101,100,32,97,114,101,97,10,0,37,112,32,58,32,70,114,101,101,100,40,41,10,0,0,0,120,109,108,77,101,109,70,114,101,101,40,37,108,88,41,32,101,114,114,111,114,10,0,0,37,112,32,58,32,83,116,114,100,117,112,40,41,32,79,107,10,0,0,0,0,0,0,0,32,32,32,32,32,32,77,69,77,79,82,89,32,65,76,76,79,67,65,84,69,68,32,58,32,37,108,117,44,32,77,65,88,32,119,97,115,32,37,108,117,10,0,0,0,0,0,0,88,77,76,95,77,69,77,95,66,82,69,65,75,80,79,73,78,84,0,0,0,0,0,0,37,117,100,0,0,0,0,0,88,77,76,95,77,69,77,95,84,82,65,67,69,0,0,0,37,112,0,0,0,0,0,0,77,101,109,111,114,121,32,116,97,103,32,101,114,114,111,114,32,111,99,99,117,114,115,32,58,37,112,32,10,9,32,98,121,101,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,85,82,73,32,115,116,114,117,99,116,117,114,101,10,0,115,97,118,105,110,103,32,85,82,73,10,0,0,0,0,0,58,37,100,0,0,0,0,0,102,105,108,101,0,0,0,0,117,110,101,115,99,97,112,105,110,103,32,85,82,73,32,118,97,108,117,101,10,0,0,0,101,115,99,97,112,105,110,103,32,85,82,73,32,118,97,108,117,101,10,0,0,0,0,0,43,45,46,0,0,0,0,0,58,0,0,0,0,0,0,0,47,63,59,58,64,0,0,0,47,47,0,0,0,0,0,0,59,58,38,61,43,36,44,0,64,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,58,64,38,61,43,36,44,47,63,59,0,0,0,0,0,0,63,0,0,0,0,0,0,0,59,47,63,58,64,38,61,43,44,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,0,0,0,0,114,101,115,111,108,118,105,110,103,32,85,82,73,32,97,103,97,105,110,115,116,32,98,97,115,101,10,0,0,0,0,0,47,0,0,0,0,0,0,0,47,59,38,61,43,36,44,0,98,117,105,108,100,105,110,103,32,114,101,108,97,116,105,118,101,32,85,82,73,10,0,0,58,47,47,0,0,0,0,0,58,47,63,95,46,35,38,59,61,0,0,0,0,0,0,0,114,101,97,99,104,105,110,103,32,97,114,98,105,116,114,97,114,121,32,77,65,88,95,85,82,73,95,76,69,78,71,84,72,32,108,105,109,105,116,10,0,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,67,97,110,110,111,116,32,99,114,101,97,116,101,32,97,117,116,111,109,97,116,97,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,67,111,110,116,101,110,116,32,109,111,100,101,108,32,111,102,32,37,115,32,105,115,32,110,111,116,32,100,101,116,101,114,109,105,110,105,115,116,58,32,37,115,10,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,120,109,108,78,101,119,69,108,101,109,101,110,116,67,111,110,116,101,110,116,32,58,32,110,97,109,101,32,61,61,32,78,85,76,76,32,33,10,0,0,120,109,108,78,101,119,69,108,101,109,101,110,116,67,111,110,116,101,110,116,32,58,32,110,97,109,101,32,33,61,32,78,85,76,76,32,33,10,0,0,73,110,116,101,114,110,97,108,58,32,69,76,69,77,69,78,84,32,99,111,110,116,101,110,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,0,0,0,0,32,46,46,46,0,0,0,0,40,0,0,0,0,0,0,0,35,80,67,68,65,84,65,0,58,0,0,0,0,0,0,0,32,44,32,0,0,0,0,0,32,124,32,0,0,0,0,0,41,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,33,61,32,78,85,76,76,32,102,111,114,32,69,77,80,84,89,10,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,33,61,32,78,85,76,76,32,102,111,114,32,65,78,89,10,0,0,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,61,61,32,78,85,76,76,32,102,111,114,32,77,73,88,69,68,10,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,61,61,32,78,85,76,76,32,102,111,114,32,69,76,69,77,69,78,84,10,0,73,110,116,101,114,110,97,108,58,32,69,76,69,77,69,78,84,32,100,101,99,108,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,82,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,60,33,69,76,69,77,69,78,84,32,0,0,0,0,0,0,32,69,77,80,84,89,62,10,0,0,0,0,0,0,0,0,32,65,78,89,62,10,0,0,32,0,0,0,0,0,0,0,62,10,0,0,0,0,0,0,73,110,116,101,114,110,97,108,58,32,69,76,69,77,69,78,84,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,58,32,65,84,84,82,73,66,85,84,69,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,58,32,105,110,118,97,108,105,100,32,100,101,102,97,117,108,116,32,118,97,108,117,101,10,0,0,0,0,0,0,120,109,108,65,100,100,65,116,116,114,105,98,117,116,101,68,101,99,108,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,58,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,10,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,116,111,111,32,109,97,121,32,73,68,32,97,116,116,114,105,98,117,116,101,115,32,100,101,102,105,110,101,100,32,58,32,37,115,10,0,0,0,0,0,0,120,109,108,110,115,0,0,0,60,33,65,84,84,76,73,83,84,32,0,0,0,0,0,0,32,67,68,65,84,65,0,0,32,73,68,0,0,0,0,0,32,73,68,82,69,70,0,0,32,73,68,82,69,70,83,0,32,69,78,84,73,84,89,0,32,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,0,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,32,40,0,0,0,0,0,0,32,78,79,84,65,84,73,79,78,32,40,0,0,0,0,0,32,35,82,69,81,85,73,82,69,68,0,0,0,0,0,0,32,35,73,77,80,76,73,69,68,0,0,0,0,0,0,0,32,35,70,73,88,69,68,0,73,110,116,101,114,110,97,108,58,32,65,84,84,82,73,66,85,84,69,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,100,101,102,10,0,0,0,0,0,0,0,120,109,108,65,100,100,78,111,116,97,116,105,111,110,68,101,99,108,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,120,109,108,65,100,100,78,111,116,97,116,105,111,110,68,101,99,108,58,32,37,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,10,0,60,33,78,79,84,65,84,73,79,78,32,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,32,62,10,0,0,0,0,0,120,109,108,65,100,100,73,68,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,73,68,32,37,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,10,0,0,105,100,0,0,0,0,0,0,120,109,108,0,0,0,0,0,110,97,109,101,0,0,0,0,97,0,0,0,0,0,0,0,120,109,108,65,100,100,82,101,102,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,120,109,108,65,100,100,82,101,102,58,32,82,101,102,101,114,101,110,99,101,32,108,105,115,116,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,120,109,108,65,100,100,82,101,102,58,32,82,101,102,101,114,101,110,99,101,32,108,105,115,116,32,105,110,115,101,114,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,78,79,84,65,84,73,79,78,32,37,115,32,105,115,32,110,111,116,32,100,101,99,108,97,114,101,100,10,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,37,115,32,111,110,32,37,115,32,118,97,108,117,101,32,104,97,100,32,116,111,32,98,101,32,110,111,114,109,97,108,105,122,101,100,32,98,97,115,101,100,32,111,110,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,0,83,121,110,116,97,120,32,111,102,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,0,0,0,73,68,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,32,109,117,115,116,32,98,101,32,35,73,77,80,76,73,69,68,32,111,114,32,35,82,69,81,85,73,82,69,68,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,37,100,32,73,68,32,97,116,116,114,105,98,117,116,101,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,32,58,32,37,115,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,37,100,32,73,68,32,97,116,116,114,105,98,117,116,101,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,58,32,37,115,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,73,68,32,97,116,116,114,105,98,117,116,101,115,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,105,110,116,101,114,110,97,108,32,97,110,100,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,58,32,37,115,10,0,0,68,101,102,97,117,108,116,32,118,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,111,102,32,37,115,10,0,0,0,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,111,102,32,37,115,58,37,115,10,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,116,111,32,37,115,10,0,0,0,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,116,111,32,37,115,58,37,115,10,0,0,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,83,121,110,116,97,120,32,111,102,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,100,101,102,97,117,108,116,32,34,37,115,34,10,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,32,100,101,99,108,97,114,101,100,32,78,111,116,97,116,105,111,110,10,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,110,111,116,97,116,105,111,110,115,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,109,117,115,116,32,98,101,32,34,37,115,34,10,0,0,0,0,0,0,86,97,108,105,100,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,0,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,0,0,83,121,110,116,97,120,32,111,102,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,0,0,0,0,0,83,121,110,116,97,120,32,111,102,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,100,101,102,97,117,108,116,32,34,37,115,34,10,0,0,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,100,101,102,97,117,108,116,32,34,37,115,34,10,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,32,100,101,99,108,97,114,101,100,32,78,111,116,97,116,105,111,110,10,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,32,100,101,99,108,97,114,101,100,32,78,111,116,97,116,105,111,110,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,110,111,116,97,116,105,111,110,115,10,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,110,111,116,97,116,105,111,110,115,10,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,109,117,115,116,32,98,101,32,34,37,115,34,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,109,117,115,116,32,98,101,32,34,37,115,34,10,0,0,0,69,108,101,109,101,110,116,32,37,115,32,119,97,115,32,100,101,99,108,97,114,101,100,32,69,77,80,84,89,32,116,104,105,115,32,111,110,101,32,104,97,115,32,99,111,110,116,101,110,116,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,119,97,115,32,100,101,99,108,97,114,101,100,32,35,80,67,68,65,84,65,32,98,117,116,32,99,111,110,116,97,105,110,115,32,110,111,110,32,116,101,120,116,32,110,111,100,101,115,10,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,105,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,105,110,32,37,115,32,108,105,115,116,32,111,102,32,112,111,115,115,105,98,108,101,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,77,105,115,112,108,97,99,101,100,32,37,115,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,84,101,120,116,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,69,120,112,101,99,116,105,110,103,32,109,111,114,101,32,99,104,105,108,100,10,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,84,101,120,116,32,101,108,101,109,101,110,116,32,104,97,115,32,99,104,105,108,100,114,101,110,32,33,10,0,0,0,0,84,101,120,116,32,101,108,101,109,101,110,116,32,104,97,115,32,110,97,109,101,115,112,97,99,101,32,33,10,0,0,0,84,101,120,116,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,32,33,10,0,0,69,110,116,105,116,121,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,0,0,78,111,116,97,116,105,111,110,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,68,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,72,84,77,76,32,68,111,99,117,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,0,0,0,117,110,107,110,111,119,110,32,101,108,101,109,101,110,116,32,116,121,112,101,10,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,73,110,116,101,114,110,97,108,58,32,77,73,88,69,68,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,10,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,37,115,32,100,101,99,108,97,114,101,100,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,99,111,110,116,97,105,110,115,32,119,104,105,116,101,32,115,112,97,99,101,115,32,110,111,100,101,115,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,99,97,114,114,121,32,97,116,116,114,105,98,117,116,101,32,37,115,10,0,69,108,101,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,99,97,114,114,121,32,97,116,116,114,105,98,117,116,101,32,37,115,58,37,115,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,114,101,113,117,105,114,101,100,32,97,116,116,114,105,98,117,116,101,32,37,115,58,37,115,32,104,97,115,32,110,111,32,112,114,101,102,105,120,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,114,101,113,117,105,114,101,100,32,97,116,116,114,105,98,117,116,101,32,37,115,58,37,115,32,104,97,115,32,100,105,102,102,101,114,101,110,116,32,112,114,101,102,105,120,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,102,111,114,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,68,84,68,10,0,69,108,101,109,101,110,116,32,37,115,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,102,111,114,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,68,84,68,10,0,0,0,0,0,0,0,0,110,111,32,114,111,111,116,32,101,108,101,109,101,110,116,10,0,0,0,0,0,0,0,0,72,84,77,76,0,0,0,0,104,116,109,108,0,0,0,0,114,111,111,116,32,97,110,100,32,68,84,68,32,110,97,109,101,32,100,111,32,110,111,116,32,109,97,116,99,104,32,39,37,115,39,32,97,110,100,32,39,37,115,39,10,0,0,0,120,109,108,86,97,108,105,100,97,116,101,68,111,99,117,109,101,110,116,70,105,110,97,108,58,32,100,111,99,32,61,61,32,78,85,76,76,10,0,0,110,111,32,68,84,68,32,102,111,117,110,100,33,10,0,0,67,111,117,108,100,32,110,111,116,32,98,117,105,108,100,32,85,82,73,32,102,111,114,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,34,37,115,34,10,0,0,0,67,111,117,108,100,32,110,111,116,32,108,111,97,100,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,34,37,115,34,10,0,0,0,0,0,0,0,0,60,33,100,117,109,109,121,63,62,0,0,0,0,0,0,0,120,109,108,86,97,108,105,100,97,116,101,65,116,116,114,105,98,117,116,101,67,97,108,108,98,97,99,107,40,37,115,41,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,10,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,37,115,58,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,100,101,99,108,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,32,97,116,116,114,105,98,117,116,101,32,37,115,32,100,101,99,108,97,114,101,100,32,102,111,114,32,69,77,80,84,89,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,97,116,116,114,105,98,117,116,101,32,37,115,32,108,105,110,101,32,37,100,32,114,101,102,101,114,101,110,99,101,115,32,97,110,32,117,110,107,110,111,119,110,32,73,68,32,34,37,115,34,10,0,0,0,0,0,73,68,82,69,70,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,115,32,97,110,32,117,110,107,110,111,119,110,32,73,68,32,34,37,115,34],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+74608),
	allocate([10,0,0,0,0,0,0,0,73,68,82,69,70,83,32,115,112,108,105,116,0,0,0,0,73,68,82,69,70,83,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,115,32,97,110,32,117,110,107,110,111,119,110,32,73,68,32,34,37,115,34,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,101,120,112,101,99,116,105,110,103,32,37,115,44,32,103,111,116,32,37,115,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,101,120,112,101,99,116,105,110,103,32,37,115,44,32,103,111,116,32,37,115,10,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,10,0,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,10,0,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,63,63,63,0,0,0,0,0,114,101,97,108,108,111,99,32,102,97,105,108,101,100,0,0,70,97,105,108,101,100,32,116,111,32,98,117,105,108,100,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,114,101,103,101,120,112,32,102,111,114,32,37,115,10,0,0,0,0,69,78,84,73,84,89,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,117,110,107,110,111,119,110,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,69,78,84,73,84,89,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,101,110,116,105,116,121,32,34,37,115,34,32,111,102,32,119,114,111,110,103,32,116,121,112,101,10,0,0,0,0,0,69,78,84,73,84,73,69,83,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,117,110,107,110,111,119,110,32,101,110,116,105,116,121,32,34,37,115,34,10,0,69,78,84,73,84,73,69,83,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,101,110,116,105,116,121,32,34,37,115,34,32,111,102,32,119,114,111,110,103,32,116,121,112,101,10,0,0,0,78,79,84,65,84,73,79,78,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,117,110,107,110,111,119,110,32,110,111,116,97,116,105,111,110,32,34,37,115,34,10,0,0,0,0,0,0,0,101,108,101,109,101,110,116,32,116,97,98,108,101,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,116,111,111,32,109,97,110,121,32,73,68,32,97,116,116,114,105,98,117,116,101,115,32,100,101,102,105,110,101,100,32,58,32,37,115,10,0,0,0,0,0,37,115,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,70,111,117,110,100,32,78,85,76,76,32,99,111,110,116,101,110,116,32,105,110,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,111,102,32,37,115,10,0,0,0,0,0,0,70,111,117,110,100,32,80,67,68,65,84,65,32,105,110,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,111,102,32,37,115,10,0,0,0,0,66,117,105,108,100,105,110,103,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,67,111,110,116,101,110,116,77,111,100,101,108,32,98,114,111,107,101,110,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,121,1,0,200,121,1,0,176,119,1,0,136,197,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,208,192,1,0,24,212,1,0,112,205,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,0,0,0,0,168,117,1,0,176,119,1,0,0,0,0,0,216,119,1,0,176,119,1,0,0,0,0,0,160,117,1,0,168,117,1,0,24,115,1,0,208,119,1,0,216,119,1,0,176,119,1,0,0,0,0,0,0,120,1,0,168,117,1,0,24,115,1,0,208,119,1,0,216,119,1,0,176,119,1,0,0,0,0,0,48,122,1,0,176,119,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,208,192,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,48,122,1,0,0,0,0,0,136,197,1,0,176,119,1,0,168,117,1,0,0,0,0,0,208,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,216,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,224,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,232,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,240,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,248,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,216,191,1,0,176,119,1,0,168,117,1,0,0,0,0,0,56,121,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,80,122,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,40,216,1,0,176,119,1,0,168,117,1,0,0,0,0,0,48,216,1,0,176,119,1,0,168,117,1,0,0,0,0,0,96,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,208,192,1,0,176,119,1,0,176,121,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,0,0,0,0,176,121,1,0,176,119,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,152,121,1,0,0,0,0,0,152,121,1,0,176,119,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,176,121,1,0,0,0,0,0,24,212,1,0,176,119,1,0,168,117,1,0,112,205,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,0,0,0,0,112,205,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,240,201,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,176,119,1,0,176,119,1,0,168,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,0,0,0,0,96,118,1,0,176,119,1,0,168,117,1,0,0,0,0,0,56,122,1,0,176,119,1,0,0,0,0,0,128,121,1,0,192,121,1,0,72,121,1,0,0,122,1,0,176,119,1,0,168,117,1,0,0,0,0,0,32,121,1,0,32,121,1,0,168,117,1,0,0,0,0,0,120,121,1,0,176,119,1,0,0,0,0,0,32,191,1,0,120,121,1,0,32,191,1,0,176,190,1,0,176,119,1,0,0,0,0,0,176,190,1,0,120,121,1,0,176,190,1,0,176,119,1,0,0,0,0,0,152,118,1,0,176,119,1,0,168,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,32,121,1,0,0,0,0,0,112,118,1,0,112,118,1,0,104,118,1,0,176,119,1,0,120,122,1,0,192,121,1,0,32,121,1,0,72,121,1,0,0,122,1,0,152,122,1,0,0,0,0,0,104,118,1,0,112,118,1,0,104,118,1,0,176,119,1,0,120,122,1,0,192,121,1,0,32,121,1,0,72,121,1,0,0,122,1,0,152,122,1,0,0,0,0,0,120,118,1,0,112,118,1,0,104,118,1,0,120,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,176,119,1,0,0,0,0,0,128,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,0,0,0,0,144,118,1,0,112,118,1,0,104,118,1,0,120,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,128,118,1,0,136,118,1,0,176,119,1,0,0,0,0,0,136,118,1,0,112,118,1,0,104,118,1,0,120,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,128,118,1,0,144,118,1,0,136,118,1,0,176,119,1,0,0,0,0,0,160,205,1,0,200,205,1,0,0,0,0,0,200,205,1,0,200,205,1,0,0,0,0,0,184,193,1,0,40,122,1,0,176,119,1,0,168,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,32,121,1,0,0,0,0,0,144,122,1,0,168,117,1,0,0,0,0,0,0,122,1,0,168,117,1,0,0,0,0,0,72,121,1,0,168,117,1,0,0,0,0,0,152,122,1,0,168,117,1,0,0,0,0,0,96,122,1,0,168,117,1,0,0,0,0,0,128,122,1,0,168,117,1,0,0,0,0,0,88,121,1,0,168,117,1,0,0,0,0,0,112,122,1,0,168,117,1,0,0,0,0,0,184,121,1,0,168,117,1,0,0,0,0,0,136,122,1,0,168,117,1,0,0,0,0,0,168,121,1,0,168,117,1,0,0,0,0,0,144,121,1,0,168,117,1,0,0,0,0,0,104,122,1,0,168,117,1,0,0,0,0,0,24,122,1,0,168,117,1,0,0,0,0,0,160,122,1,0,168,117,1,0,0,0,0,0,136,121,1,0,168,117,1,0,0,0,0,0,40,121,1,0,168,117,1,0,0,0,0,0,48,121,1,0,168,117,1,0,0,0,0,0,112,198,1,0,168,117,1,0,0,0,0,0,192,121,1,0,168,117,1,0,0,0,0,0,168,189,1,0,168,117,1,0,0,0,0,0,96,201,1,0,168,117,1,0,0,0,0,0,88,122,1,0,168,117,1,0,0,0,0,0,104,177,1,0,168,117,1,0,0,0,0,0,144,177,1,0,168,117,1,0,0,0,0,0,120,122,1,0,168,117,1,0,0,0,0,0,80,121,1,0,168,117,1,0,0,0,0,0,8,122,1,0,168,117,1,0,0,0,0,0,0,0,0,0,32,121,1,0,0,0,0,0,0,0,1,0,32,182,1,0,40,182,1,0,0,0,0,0,200,182,1,0,64,183,1,0,0,0,0,0,40,121,1,0,0,0,0,0,0,0,1,0,72,183,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,48,121,1,0,0,0,0,0,0,0,1,0,160,183,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,56,121,1,0,0,0,0,0,0,0,0,0,168,183,1,0,192,183,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,64,121,1,0,0,0,0,0,1,1,2,0,104,184,1,0,120,184,1,0,0,0,0,0,0,0,0,0,128,185,1,0,0,0,0,0,184,185,1,0,0,2,2,1,0,0,0,0,192,185,1,0,0,0,0,0,0,0,0,0,224,185,1,0,64,183,1,0,8,186,1,0,72,121,1,0,0,3,0,0,0,0,1,0,16,186,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,224,119,1,0,0,2,2,1,0,0,0,0,32,186,1,0,0,0,0,0,0,0,0,0,0,0,0,0,64,183,1,0,56,186,1,0,64,186,1,0,0,2,2,1,1,1,1,0,80,186,1,0,0,0,0,0,0,0,0,0,0,0,0,0,96,186,1,0,0,0,0,0,80,121,1,0,0,0,0,0,0,0,1,0,120,186,1,0,40,182,1,0,0,0,0,0,144,186,1,0,0,0,0,0,176,186,1,0,88,121,1,0,0,3,0,0,0,0,1,0,184,186,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,96,121,1,0,0,0,0,0,0,0,0,0,208,186,1,0,224,186,1,0,0,0,0,0,224,187,1,0,0,0,0,0,0,0,0,0,160,117,1,0,1,1,0,0,0,0,0,0,40,188,1,0,56,188,1,0,96,118,1,0,64,189,1,0,136,189,1,0,0,0,0,0,168,189,1,0,0,2,2,1,0,0,1,0,176,189,1,0,0,0,0,0,0,0,0,0,200,189,1,0,224,189,1,0,0,0,0,0,112,121,1,0,0,0,0,0,0,0,2,0,232,189,1,0,224,186,1,0,0,0,0,0,248,189,1,0,0,0,0,0,0,0,0,0,120,121,1,0,0,0,0,0,0,0,0,0,88,190,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,128,121,1,0,0,3,0,0,1,1,0,0,104,190,1,0,224,186,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,136,121,1,0,0,0,0,0,0,0,1,0,136,190,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,144,121,1,0,0,0,0,0,0,0,1,0,152,190,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,176,190,1,0,0,2,2,1,0,0,0,0,184,190,1,0,0,0,0,0,0,0,0,0,200,190,1,0,0,0,0,0,0,0,0,0,32,191,1,0,0,1,0,0,0,0,0,0,48,191,1,0,72,191,1,0,176,190,1,0,200,190,1,0,0,0,0,0,0,0,0,0,152,121,1,0,0,1,0,0,0,0,0,0,80,191,1,0,224,186,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,160,121,1,0,0,0,0,0,0,0,2,0,104,191,1,0,224,186,1,0,0,0,0,0,120,191,1,0,0,0,0,0,0,0,0,0,168,121,1,0,0,0,0,0,0,0,1,0,192,191,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,216,191,1,0,0,0,0,0,1,1,0,0,224,191,1,0,240,191,1,0,48,122,1,0,0,0,0,0,88,192,1,0,0,0,0,0,96,118,1,0,0,0,0,0,0,0,0,0,160,192,1,0,224,186,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,208,192,1,0,0,0,0,0,0,0,0,0,216,192,1,0,240,192,1,0,152,121,1,0,96,183,1,0,0,193,1,0,0,0,0,0,176,121,1,0,0,1,0,0,0,0,0,0,8,193,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,184,121,1,0,0,3,0,0,0,0,1,0,32,193,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,48,193,1,0,0,1,0,0,1,1,1,0,56,193,1,0,0,0,0,0,0,0,0,0,88,193,1,0,0,0,0,0,0,0,0,0,184,193,1,0,0,0,0,0,0,0,0,0,200,193,1,0,224,193,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,192,121,1,0,0,3,0,0,1,1,1,0,224,194,1,0,40,182,1,0,0,0,0,0,0,0,0,0,248,194,1,0,0,0,0,0,200,121,1,0,0,0,0,0,0,0,0,0,32,195,1,0,56,195,1,0,184,193,1,0,48,196,1,0,64,183,1,0,144,196,1,0,248,119,1,0,0,2,2,1,0,2,0,0,152,196,1,0,0,0,0,0,0,0,0,0,0,0,0,0,168,196,1,0,0,0,0,0,0,120,1,0,0,0,0,0,0,2,0,0,224,196,1,0,248,196,1,0,232,119,1,0,0,0,0,0,8,197,1,0,0,0,0,0,208,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,216,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,224,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,232,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,240,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,248,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,168,117,1,0,1,1,0,0,0,0,0,0,64,197,1,0,80,197,1,0,0,0,0,0,120,197,1,0,0,0,0,0,0,0,0,0,136,197,1,0,0,2,2,1,0,0,0,0,144,197,1,0,0,0,0,0,0,0,0,0,96,183,1,0,168,197,1,0,0,0,0,0,32,112,1,0,1,1,0,0,0,0,0,0,192,197,1,0,216,197,1,0,0,0,0,0,232,197,1,0,248,197,1,0,0,0,0,0,0,122,1,0,0,3,0,0,0,0,1,0,0,198,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,8,122,1,0,0,0,0,0,0,1,2,0,24,198,1,0,224,186,1,0,0,0,0,0,0,0,0,0,48,198,1,0,0,0,0,0,112,198,1,0,0,2,2,1,0,0,1,0,120,198,1,0,0,0,0,0,0,0,0,0,136,198,1,0,200,192,1,0,224,198,1,0,240,198,1,0,0,2,2,1,0,0,1,0,248,198,1,0,0,0,0,0,0,0,0,0,8,199,1,0,200,192,1,0,0,0,0,0,16,122,1,0,0,0,0,0,0,0,2,0,152,199,1,0,224,186,1,0,0,0,0,0,120,191,1,0,0,0,0,0,0,0,0,0,168,199,1,0,0,2,2,1,1,1,0,0,176,199,1,0,0,0,0,0,0,0,0,0,0,0,0,0,200,199,1,0,0,0,0,0,24,122,1,0,0,0,0,0,0,0,1,0,232,199,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,32,122,1,0,0,0,0,0,0,0,1,0,8,200,1,0,40,182,1,0,0,0,0,0,32,200,1,0,0,0,0,0,0,0,0,0,40,122,1,0,0,0,0,0,0,0,0,0,112,200,1,0,40,182,1,0,0,0,0,0,136,200,1,0,200,192,1,0,0,0,0,0,48,122,1,0,0,1,1,0,0,0,0,0,208,200,1,0,224,186,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,208,119,1,0,0,2,2,1,0,0,0,0,224,200,1,0,0,0,0,0,0,0,0,0,0,201,1,0,64,183,1,0,0,0,0,0,96,201,1,0,0,0,0,0,0,0,2,0,104,201,1,0,128,201,1,0,0,0,0,0,96,183,1,0,0,0,0,0,232,201,1,0,240,201,1,0,0,0,0,0,1,1,0,0,248,201,1,0,240,191,1,0,0,0,0,0,0,0,0,0,88,192,1,0,0,0,0,0,200,119,1,0,0,2,2,1,0,0,0,0,8,202,1,0,0,0,0,0,0,0,0,0,40,202,1,0,0,0,0,0,72,202,1,0,232,119,1,0,0,0,0,0,0,2,0,0,80,202,1,0,144,202,1,0,160,117,1,0,96,183,1,0,0,0,0,0,0,0,0,0,56,122,1,0,0,0,0,0,0,0,0,0,152,203,1,0,224,186,1,0,96,118,1,0,96,183,1,0,0,0,0,0,0,0,0,0,72,122,1,0,0,0,0,0,0,0,2,0,56,193,1,0,216,203,1,0,96,118,1,0,224,204,1,0,88,205,1,0,0,0,0,0,112,205,1,0,0,0,0,0,0,0,0,0,120,205,1,0,136,205,1,0,48,122,1,0,96,183,1,0,144,205,1,0,0,0,0,0,160,205,1,0,0,0,0,0,0,0,0,0,176,205,1,0,192,205,1,0,200,205,1,0,208,205,1,0,0,0,0,0,24,206,1,0,200,205,1,0,0,1,0,0,0,0,0,0,32,206,1,0,56,206,1,0,0,0,0,0,64,206,1,0,0,0,0,0,0,0,0,0,176,119,1,0,0,1,0,0,0,0,0,0,144,206,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,160,206,1,0,0,2,2,1,0,0,0,0,168,206,1,0,0,0,0,0,0,0,0,0,192,206,1,0,0,0,0,0,232,201,1,0,80,122,1,0,0,0,0,0,0,0,0,0,216,206,1,0,240,206,1,0,0,0,0,0,96,183,1,0,88,207,1,0,0,0,0,0,88,122,1,0,0,0,0,0,0,0,1,0,96,207,1,0,40,182,1,0,0,0,0,0,224,187,1,0,0,0,0,0,0,0,0,0,96,122,1,0,0,3,0,0,1,1,1,0,120,207,1,0,40,182,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,104,122,1,0,0,0,0,0,0,0,1,0,152,207,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,16,115,1,0,0,0,0,0,0,0,2,0,192,207,1,0,56,206,1,0,0,0,0,0,216,207,1,0,240,207,1,0,248,207,1,0,0,208,1,0,0,0,0,0,0,0,1,0,8,208,1,0,32,208,1,0,0,0,0,0,48,208,1,0,0,0,0,0,0,0,0,0,112,122,1,0,0,3,0,0,0,0,1,0,144,208,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,120,122,1,0,0,0,0,0,0,0,1,0,168,208,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,128,122,1,0,0,3,0,0,1,1,1,0,208,208,1,0,40,182,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,136,122,1,0,0,3,0,0,0,0,1,0,232,208,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,24,115,1,0,0,0,0,0,0,0,0,0,248,208,1,0,56,206,1,0,0,0,0,0,8,209,1,0,0,0,0,0,248,207,1,0,104,177,1,0,0,3,0,0,0,0,1,0,32,209,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,144,177,1,0,0,3,0,0,0,0,1,0,48,209,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,152,118,1,0,0,0,0,0,0,0,0,0,160,183,1,0,64,209,1,0,120,118,1,0,96,209,1,0,192,209,1,0,0,0,0,0,136,118,1,0,1,0,0,0,0,0,0,0,208,209,1,0,224,209,1,0,120,118,1,0,232,209,1,0,0,0,0,0,0,0,0,0,104,118,1,0,0,0,0,0,0,0,0,0,56,210,1,0,224,186,1,0,0,0,0,0,72,210,1,0,176,210,1,0,0,0,0,0,200,210,1,0,0,0,0,0,0,0,1,0,216,210,1,0,56,206,1,0,0,0,0,0,240,210,1,0,0,0,0,0,88,211,1,0,144,118,1,0,0,1,0,0,0,0,0,0,104,211,1,0,224,209,1,0,120,118,1,0,232,209,1,0,0,0,0,0,0,0,0,0,112,118,1,0,0,1,0,0,0,0,0,0,120,211,1,0,224,186,1,0,0,0,0,0,72,210,1,0,176,210,1,0,0,0,0,0,128,118,1,0,0,1,0,0,0,0,0,0,144,211,1,0,224,209,1,0,120,118,1,0,232,209,1,0,0,0,0,0,0,0,0,0,216,119,1,0,0,0,0,0,0,0,0,0,160,211,1,0,56,206,1,0,0,0,0,0,232,197,1,0,0,0,0,0,0,0,0,0,120,118,1,0,0,0,0,0,0,0,0,0,176,211,1,0,192,211,1,0,104,118,1,0,232,209,1,0,208,211,1,0,0,0,0,0,144,122,1,0,0,3,0,0,0,0,1,0,216,211,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,152,122,1,0,0,3,0,0,1,1,1,0,0,212,1,0,40,182,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,24,212,1,0,0,0,0,0,0,0,0,0,32,212,1,0,136,205,1,0,48,122,1,0,96,183,1,0,48,212,1,0,0,0,0,0,160,122,1,0,0,0,0,0,0,0,1,0,64,212,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,34,0,0,0,56,127,1,0,64,127,1,0,38,0,0,0,112,127,1,0,120,127,1,0,39,0,0,0,152,127,1,0,160,127,1,0,60,0,0,0,176,127,1,0,184,127,1,0,62,0,0,0,216,127,1,0,224,127,1,0,160,0,0,0,8,128,1,0,16,128,1,0,161,0,0,0,72,128,1,0,80,128,1,0,162,0,0,0,128,128,1,0,136,128,1,0,163,0,0,0,168,128,1,0,176,128,1,0,164,0,0,0,208,128,1,0,216,128,1,0,165,0,0,0,248,128,1,0,0,129,1,0,166,0,0,0,40,129,1,0,48,129,1,0,167,0,0,0,96,129,1,0,104,129,1,0,168,0,0,0,136,129,1,0,144,129,1,0,169,0,0,0,192,129,1,0,200,129,1,0,170,0,0,0,232,129,1,0,240,129,1,0,171,0,0,0,32,130,1,0,40,130,1,0,172,0,0,0,128,130,1,0,136,130,1,0,173,0,0,0,160,130,1,0,168,130,1,0,174,0,0,0,224,130,1,0,232,130,1,0,175,0,0,0,40,131,1,0,48,131,1,0,176,0,0,0,112,131,1,0,120,131,1,0,177,0,0,0,152,131,1,0,160,131,1,0,178,0,0,0,216,131,1,0,224,131,1,0,179,0,0,0,40,132,1,0,48,132,1,0,180,0,0,0,120,132,1,0,128,132,1,0,181,0,0,0,176,132,1,0,184,132,1,0,182,0,0,0,216,132,1,0,224,132,1,0,183,0,0,0,16,133,1,0,24,133,1,0,184,0,0,0,88,133,1,0,96,133,1,0,185,0,0,0,144,133,1,0,152,133,1,0,186,0,0,0,208,133,1,0,216,133,1,0,187,0,0,0,8,134,1,0,16,134,1,0,188,0,0,0,104,134,1,0,112,134,1,0,189,0,0,0,184,134,1,0,192,134,1,0,190,0,0,0,0,135,1,0,8,135,1,0,191,0,0,0,80,135,1,0,88,135,1,0,192,0,0,0,152,135,1,0,160,135,1,0,193,0,0,0,248,135,1,0,0,136,1,0,194,0,0,0,56,136,1,0,64,136,1,0,195,0,0,0,120,136,1,0,128,136,1,0,196,0,0,0,184,136,1,0,192,136,1,0,197,0,0,0,248,136,1,0,0,137,1,0,198,0,0,0,88,137,1,0,96,137,1,0,199,0,0,0,168,137,1,0,176,137,1,0,200,0,0,0,232,137,1,0,240,137,1,0,201,0,0,0,40,138,1,0,48,138,1,0,202,0,0,0,104,138,1,0,112,138,1,0,203,0,0,0,168,138,1,0,176,138,1,0,204,0,0,0,232,138,1,0,240,138,1,0,205,0,0,0,40,139,1,0,48,139,1,0,206,0,0,0,104,139,1,0,112,139,1,0,207,0,0,0,168,139,1,0,176,139,1,0,208,0,0,0,232,139,1,0,240,139,1,0,209,0,0,0,32,140,1,0,40,140,1,0,210,0,0,0,96,140,1,0,104,140,1,0,211,0,0,0,160,140,1,0,168,140,1,0,212,0,0,0,224,140,1,0,232,140,1,0,213,0,0,0,32,141,1,0,40,141,1,0,214,0,0,0,96,141,1,0,104,141,1,0,215,0,0,0,160,141,1,0,168,141,1,0,216,0,0,0,208,141,1,0,216,141,1,0,217,0,0,0,40,142,1,0,48,142,1,0,218,0,0,0,104,142,1,0,112,142,1,0,219,0,0,0,168,142,1,0,176,142,1,0,220,0,0,0,232,142,1,0,240,142,1,0,221,0,0,0,40,143,1,0,48,143,1,0,222,0,0,0,104,143,1,0,112,143,1,0,223,0,0,0,160,143,1,0,168,143,1,0,224,0,0,0,224,143,1,0,232,143,1,0,225,0,0,0,56,144,1,0,64,144,1,0,226,0,0,0,112,144,1,0,120,144,1,0,227,0,0,0,176,144,1,0,184,144,1,0,228,0,0,0,232,144,1,0,240,144,1,0,229,0,0,0,40,145,1,0,48,145,1,0,230,0,0,0,136,145,1,0,144,145,1,0,231,0,0,0,208,145,1,0,216,145,1,0,232,0,0,0,16,146,1,0,24,146,1,0,233,0,0,0,72,146,1,0,80,146,1,0,234,0,0,0,128,146,1,0,136,146,1,0,235,0,0,0,192,146,1,0,200,146,1,0,236,0,0,0,0,147,1,0,8,147,1,0,237,0,0,0,56,147,1,0,64,147,1,0,238,0,0,0,112,147,1,0,120,147,1,0,239,0,0,0,176,147,1,0,184,147,1,0,240,0,0,0,240,147,1,0,248,147,1,0,241,0,0,0,32,148,1,0,40,148,1,0,242,0,0,0,88,148,1,0,96,148,1,0,243,0,0,0,144,148,1,0,152,148,1,0,244,0,0,0,200,148,1,0,208,148,1,0,245,0,0,0,8,149,1,0,16,149,1,0,246,0,0,0,64,149,1,0,72,149,1,0,247,0,0,0,128,149,1,0,136,149,1,0,248,0,0,0,168,149,1,0,176,149,1,0,249,0,0,0,0,150,1,0,8,150,1,0,250,0,0,0,56,150,1,0,64,150,1,0,251,0,0,0,112,150,1,0,120,150,1,0,252,0,0,0,176,150,1,0,184,150,1,0,253,0,0,0,240,150,1,0,248,150,1,0,254,0,0,0,40,151,1,0,48,151,1,0,255,0,0,0,96,151,1,0,104,151,1,0,82,1,0,0,160,151,1,0,168,151,1,0,83,1,0,0,216,151,1,0,224,151,1,0,96,1,0,0,8,152,1,0,16,152,1,0,97,1,0,0,72,152,1,0,80,152,1,0,120,1,0,0,128,152,1,0,136,152,1,0,146,1,0,0,192,152,1,0,200,152,1,0,198,2,0,0,8,153,1,0,16,153,1,0,220,2,0,0,72,153,1,0,80,153,1,0,145,3,0,0,112,153,1,0,120,153,1,0,146,3,0,0,160,153,1,0,168,153,1,0,147,3,0,0,208,153,1,0,216,153,1,0,148,3,0,0,8,154,1,0,16,154,1,0,149,3,0,0,64,154,1,0,72,154,1,0,150,3,0,0,112,154,1,0,120,154,1,0,151,3,0,0,160,154,1,0,168,154,1,0,152,3,0,0,208,154,1,0,216,154,1,0,153,3,0,0,8,155,1,0,16,155,1,0,154,3,0,0,56,155,1,0,64,155,1,0,155,3,0,0,104,155,1,0,112,155,1,0,156,3,0,0,160,155,1,0,168,155,1,0,157,3,0,0,200,155,1,0,208,155,1,0,158,3,0,0,240,155,1,0,248,155,1,0,159,3,0,0,32,156,1,0,40,156,1,0,160,3,0,0,80,156,1,0,88,156,1,0,161,3,0,0,128,156,1,0,136,156,1,0,163,3,0,0,176,156,1,0,184,156,1,0,164,3,0,0,232,156,1,0,240,156,1,0,165,3,0,0,24,157,1,0,32,157,1,0,166,3,0,0,80,157,1,0,88,157,1,0,167,3,0,0,136,157,1,0,144,157,1,0,168,3,0,0,184,157,1,0,192,157,1,0,169,3,0,0,240,157,1,0,248,157,1,0,177,3,0,0,40,158,1,0,48,158,1,0,178,3,0,0,96,158,1,0,104,158,1,0,179,3,0,0,144,158,1,0,152,158,1,0,180,3,0,0,200,158,1,0,208,158,1,0,181,3,0,0,0,159,1,0,8,159,1,0,182,3,0,0,56,159,1,0,64,159,1,0,183,3,0,0,104,159,1,0,112,159,1,0,184,3,0,0,152,159,1,0,160,159,1,0,185,3,0,0,208,159,1,0,216,159,1,0,186,3,0,0,0,160,1,0,8,160,1,0,187,3,0,0,56,160,1,0,64,160,1,0,188,3,0,0,112,160,1,0,120,160,1,0,189,3,0,0,160,160,1,0,168,160,1,0,190,3,0,0,208,160,1,0,216,160,1,0,191,3,0,0,0,161,1,0,8,161,1,0,192,3,0,0,48,161,1,0,56,161,1,0,193,3,0,0,96,161,1,0,104,161,1,0,194,3,0,0,144,161,1,0,152,161,1,0,195,3,0,0,200,161,1,0,208,161,1,0,196,3,0,0,0,162,1,0,8,162,1,0,197,3,0,0,48,162,1,0,56,162,1,0,198,3,0,0,104,162,1,0,112,162,1,0,199,3,0,0,152,162,1,0,160,162,1,0,200,3,0,0,200,162,1,0,208,162,1,0,201,3,0,0,248,162,1,0,0,163,1,0,209,3,0,0,48,163,1,0,64,163,1,0,210,3,0,0,112,163,1,0,120,163,1,0,214,3,0,0,168,163,1,0,176,163,1,0,2,32,0,0,208,163,1,0,216,163,1,0,3,32,0,0,240,163,1,0,248,163,1,0,9,32,0,0,16,164,1,0,24,164,1,0,12,32,0,0,56,164,1,0,64,164,1,0,13,32,0,0,112,164,1,0,120,164,1,0,14,32,0,0,160,164,1,0,168,164,1,0,15,32,0,0,208,164,1,0,216,164,1,0,19,32,0,0,0,165,1,0,8,165,1,0,20,32,0,0,32,165,1,0,40,165,1,0,24,32,0,0,64,165,1,0,72,165,1,0,25,32,0,0,120,165,1,0,128,165,1,0,26,32,0,0,176,165,1,0,184,165,1,0,28,32,0,0,224,165,1,0,232,165,1,0,29,32,0,0,24,166,1,0,32,166,1,0,30,32,0,0,80,166,1,0,88,166,1,0,32,32,0,0,128,166,1,0,136,166,1,0,33,32,0,0,160,166,1,0,168,166,1,0,34,32,0,0,200,166,1,0,208,166,1,0,38,32,0,0,0,167,1,0,8,167,1,0,48,32,0,0,64,167,1,0,72,167,1,0,50,32,0,0,104,167,1,0,112,167,1,0,51,32,0,0,152,167,1,0,160,167,1,0,57,32,0,0,208,167,1,0,216,167,1,0,58,32,0,0,24,168,1,0,32,168,1,0,62,32,0,0,96,168,1,0,104,168,1,0,68,32,0,0,152,168,1,0,160,168,1,0,172,32,0,0,192,168,1,0,200,168,1,0,17,33,0,0,224,168,1,0,232,168,1,0,24,33,0,0,32,169,1,0,40,169,1,0,28,33,0,0,104,169,1,0,112,169,1,0,34,33,0,0,176,169,1,0,184,169,1,0,53,33,0,0,216,169,1,0,224,169,1,0,144,33,0,0,24,170,1,0,32,170,1,0,145,33,0,0,64,170,1,0,72,170,1,0,146,33,0,0,104,170,1,0,112,170,1,0,147,33,0,0,144,170,1,0,152,170,1,0,148,33,0,0,184,170,1,0,192,170,1,0,181,33,0,0,232,170,1,0,240,170,1,0,208,33,0,0,56,171,1,0,64,171,1,0,209,33,0,0,104,171,1,0,112,171,1,0,210,33,0,0,152,171,1,0,160,171,1,0,211,33,0,0,200,171,1,0,208,171,1,0,212,33,0,0,248,171,1,0,0,172,1,0,0,34,0,0,40,172,1,0,48,172,1,0,2,34,0,0,72,172,1,0,80,172,1,0,3,34,0,0,120,172,1,0,128,172,1,0,5,34,0,0,160,172,1,0,168,172,1,0,7,34,0,0,216,172,1,0,224,172,1,0,8,34,0,0,16,173,1,0,24,173,1,0,9,34,0,0,56,173,1,0,64,173,1,0,11,34,0,0,104,173,1,0,112,173,1,0,15,34,0,0,152,173,1,0,160,173,1,0,17,34,0,0,208,173,1,0,216,173,1,0,18,34,0,0,248,173,1,0,0,174,1,0,23,34,0,0,32,174,1,0,40,174,1,0,26,34,0,0,80,174,1,0,88,174,1,0,29,34,0,0,136,174,1,0,144,174,1,0,30,34,0,0,176,174,1,0,184,174,1,0,32,34,0,0,216,174,1,0,224,174,1,0,39,34,0,0,248,174,1,0,0,175,1,0,40,34,0,0,40,175,1,0,48,175,1,0,41,34,0,0,88,175,1,0,96,175,1,0,42,34,0,0,136,175,1,0,144,175,1,0,43,34,0,0,176,175,1,0,184,175,1,0,52,34,0,0,216,175,1,0,224,175,1,0,60,34,0,0,0,176,1,0,8,176,1,0,69,34,0,0,72,176,1,0,80,176,1,0,72,34,0,0,120,176,1,0,128,176,1,0,96,34,0,0,176,176,1,0,184,176,1,0,97,34,0,0,216,176,1,0,224,176,1,0,100,34,0,0,0,177,1,0,8,177,1,0,101,34,0,0,48,177,1,0,56,177,1,0,130,34,0,0,104,177,1,0,112,177,1,0,131,34,0,0,144,177,1,0,152,177,1,0,132,34,0,0,184,177,1,0,192,177,1,0,134,34,0,0,224,177,1,0,232,177,1,0,135,34,0,0,16,178,1,0,24,178,1,0,149,34,0,0,64,178,1,0,72,178,1,0,151,34,0,0,120,178,1,0,128,178,1,0,165,34,0,0,176,178,1,0,184,178,1,0,197,34,0,0,240,178,1,0,248,178,1,0,8,35,0,0,24,179,1,0,32,179,1,0,9,35,0,0,80,179,1,0,88,179,1,0,10,35,0,0,120,179,1,0,128,179,1,0,11,35,0,0,176,179,1,0,184,179,1,0,41,35,0,0,216,179,1,0,224,179,1,0,42,35,0,0,24,180,1,0,32,180,1,0,202,37,0,0,88,180,1,0,96,180,1,0,96,38,0,0,120,180,1,0,128,180,1,0,99,38,0,0,160,180,1,0,168,180,1,0,101,38,0,0,216,180,1,0,224,180,1,0,102,38,0,0,16,181,1,0,24,181,1,0,0,0,0,0,35,37,117,0,0,0,0,0,72,84,77,76,32,100,111,99,117,109,101,110,116,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,104,116,109,108,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,82,69,67,45,104,116,109,108,52,48,47,108,111,111,115,101,46,100,116,100,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,46,48,32,84,114,97,110,115,105,116,105,111,110,97,108,47,47,69,78,0,0,0,104,116,109,108,80,97,114,115,101,69,110,116,105,116,121,82,101,102,58,32,110,111,32,110,97,109,101,10,0,0,0,0,104,116,109,108,80,97,114,115,101,69,110,116,105,116,121,82,101,102,58,32,101,120,112,101,99,116,105,110,103,32,39,59,39,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,109,105,115,115,105,110,103,32,115,101,109,105,99,111,108,111,110,10,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,84,97,103,32,37,115,32,105,110,118,97,108,105,100,10,0,67,111,117,108,100,110,39,116,32,102,105,110,100,32,101,110,100,32,111,102,32,83,116,97,114,116,32,84,97,103,32,37,115,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,68,111,99,117,109,101,110,116,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,68,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,0,78,101,119,80,97,114,115,101,114,67,116,120,116,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,0,104,116,109,108,80,97,114,115,101,67,104,117,110,107,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,99,104,97,114,115,101,116,61,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,1,0,0,0,0,0,0,0,99,104,97,114,115,101,116,0,61,0,0,0,0,0,0,0,104,116,109,108,67,104,101,99,107,69,110,99,111,100,105,110,103,58,32,119,114,111,110,103,32,101,110,99,111,100,105,110,103,32,109,101,116,97,10,0,104,116,109,108,67,104,101,99,107,69,110,99,111,100,105,110,103,58,32,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,32,37,115,10,0,104,116,109,108,67,104,101,99,107,69,110,99,111,100,105,110,103,58,32,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,0,0,0,0,0,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,97,32,110,101,119,32,105,110,112,117,116,32,115,116,114,101,97,109,10,0,0,0,115,99,114,105,112,116,0,0,115,116,121,108,101,0,0,0,77,105,115,112,108,97,99,101,100,32,68,79,67,84,89,80,69,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,68,79,67,84,89,80,69,0,59,32,62,47,0,0,0,0,60,38,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,110,32,101,114,114,111,114,32,105,110,32,101,108,101,109,101,110,116,32,99,111,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+84848),allocate([116,101,110,116,10,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,67,68,65,84,65,10,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,68,84,68,10,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,67,79,77,77,69,78,84,10,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,80,73,10,0,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,68,69,67,76,10,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,86,65,76,85,69,10,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,65,84,84,82,73,66,85,84,69,95,86,65,76,85,69,10,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,88,77,76,95,80,65,82,83,69,82,95,83,89,83,84,69,77,95,76,73,84,69,82,65,76,10,0,0,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,88,77,76,95,80,65,82,83,69,82,95,73,71,78,79,82,69,10,0,0,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,88,77,76,95,80,65,82,83,69,82,95,76,73,84,69,82,65,76,10,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,69,110,100,84,97,103,58,32,39,60,47,39,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,0,0,69,110,100,32,116,97,103,32,58,32,101,120,112,101,99,116,101,100,32,39,62,39,10,0,98,111,100,121,0,0,0,0,104,101,97,100,0,0,0,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,116,97,103,32,58,32,37,115,10,0,0,0,0,0,0,0,0,79,112,101,110,105,110,103,32,97,110,100,32,101,110,100,105,110,103,32,116,97,103,32,109,105,115,109,97,116,99,104,58,32,37,115,32,97,110,100,32,37,115,10,0,0,0,0,0,96,118,1,0,150,0,0,0,104,118,1,0,160,0,0,0,112,118,1,0,160,0,0,0,120,118,1,0,170,0,0,0,128,118,1,0,180,0,0,0,136,118,1,0,180,0,0,0,144,118,1,0,180,0,0,0,152,118,1,0,190,0,0,0,168,117,1,0,200,0,0,0,160,117,1,0,200,0,0,0,32,112,1,0,220,0,0,0,0,0,0,0,100,0,0,0,100,105,118,0,0,0,0,0,116,100,0,0,0,0,0,0,116,104,0,0,0,0,0,0,116,114,0,0,0,0,0,0,116,104,101,97,100,0,0,0,116,98,111,100,121,0,0,0,116,102,111,111,116,0,0,0,116,97,98,108,101,0,0,0,38,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,101,109,98,101,100,115,32,99,108,111,115,101,32,116,97,103,10,0,0,0,0,73,110,118,97,108,105,100,32,99,104,97,114,32,105,110,32,67,68,65,84,65,32,48,120,37,88,10,0,0,0,0,0,67,104,97,114,32,48,120,37,88,32,111,117,116,32,111,102,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,0,85,110,115,117,112,112,111,114,116,101,100,32,101,110,99,111,100,105,110,103,32,37,115,0,66,121,116,101,115,58,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,10,0,0,0,0,0,66,121,116,101,115,58,32,48,120,37,48,50,88,10,0,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,0,72,84,84,80,45,69,81,85,73,86,0,0,0,0,0,0,67,79,78,84,69,78,84,0,67,72,65,82,83,69,84,61,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,32,112,1,0,168,117,1,0,0,0,0,0,0,0,0,0,109,101,116,97,0,0,0,0,108,105,110,107,0,0,0,0,116,105,116,108,101,0,0,0,98,97,115,101,0,0,0,0,110,111,102,114,97,109,101,115,0,0,0,0,0,0,0,0,102,114,97,109,101,0,0,0,102,114,97,109,101,115,101,116,0,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,46,48,49,47,47,69,78,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,47,47,69,78,0,0,32,121,1,0,40,121,1,0,48,121,1,0,56,121,1,0,64,121,1,0,72,121,1,0,80,121,1,0,88,121,1,0,96,121,1,0,160,117,1,0,112,121,1,0,120,121,1,0,128,121,1,0,136,121,1,0,144,121,1,0,152,121,1,0,160,121,1,0,168,121,1,0,96,118,1,0,176,121,1,0,184,121,1,0,192,121,1,0,200,121,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,0,122,1,0,8,122,1,0,16,122,1,0,24,122,1,0,32,122,1,0,40,122,1,0,48,122,1,0,232,119,1,0,56,122,1,0,72,122,1,0,176,119,1,0,80,122,1,0,88,122,1,0,96,122,1,0,104,122,1,0,112,122,1,0,120,122,1,0,128,122,1,0,136,122,1,0,104,118,1,0,112,118,1,0,144,122,1,0,152,122,1,0,160,122,1,0,0,0,0,0,97,0,0,0,0,0,0,0,97,98,98,114,0,0,0,0,97,99,114,111,110,121,109,0,97,100,100,114,101,115,115,0,97,112,112,108,101,116,0,0,98,0,0,0,0,0,0,0,98,100,111,0,0,0,0,0,98,105,103,0,0,0,0,0,98,108,111,99,107,113,117,111,116,101,0,0,0,0,0,0,98,117,116,116,111,110,0,0,99,97,112,116,105,111,110,0,99,101,110,116,101,114,0,0,99,105,116,101,0,0,0,0,99,111,100,101,0,0,0,0,100,100,0,0,0,0,0,0,100,101,108,0,0,0,0,0,100,102,110,0,0,0,0,0,100,116,0,0,0,0,0,0,101,109,0,0,0,0,0,0,102,111,110,116,0,0,0,0,102,111,114,109,0,0,0,0,104,49,0,0,0,0,0,0,104,50,0,0,0,0,0,0,104,51,0,0,0,0,0,0,104,52,0,0,0,0,0,0,104,53,0,0,0,0,0,0,104,54,0,0,0,0,0,0,105,0,0,0,0,0,0,0,105,102,114,97,109,101,0,0,105,110,115,0,0,0,0,0,107,98,100,0,0,0,0,0,108,97,98,101,108,0,0,0,108,101,103,101,110,100,0,0,108,105,0,0,0,0,0,0,110,111,115,99,114,105,112,116,0,0,0,0,0,0,0,0,111,98,106,101,99,116,0,0,112,114,101,0,0,0,0,0,113,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,115,97,109,112,0,0,0,0,115,109,97,108,108,0,0,0,115,112,97,110,0,0,0,0,115,116,114,105,107,101,0,0,115,116,114,111,110,103,0,0,116,116,0,0,0,0,0,0,117,0,0,0,0,0,0,0,118,97,114,0,0,0,0,0,104,116,109,108,73,110,105,116,80,97,114,115,101,114,67,116,120,116,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,68,111,99,84,121,112,101,68,101,99,108,32,58,32,110,111,32,68,79,67,84,89,80,69,32,110,97,109,101,32,33,10,0,0,0,0,0,0,0,68,79,67,84,89,80,69,32,105,109,112,114,111,112,101,114,108,121,32,116,101,114,109,105,110,97,116,101,100,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,83,89,83,84,69,77,39,10,0,0,104,116,109,108,80,97,114,115,101,69,120,116,101,114,110,97,108,73,68,58,32,83,89,83,84,69,77,44,32,110,111,32,85,82,73,10,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,80,85,66,76,73,67,39,10,0,0,104,116,109,108,80,97,114,115,101,69,120,116,101,114,110,97,108,73,68,58,32,80,85,66,76,73,67,44,32,110,111,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,10,0,0,0,0,0,0,85,110,102,105,110,105,115,104,101,100,32,80,117,98,105,100,76,105,116,101,114,97,108,10,0,0,0,0,0,0,0,0,80,117,98,105,100,76,105,116,101,114,97,108,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,10,0,0,0,85,110,102,105,110,105,115,104,101,100,32,83,121,115,116,101,109,76,105,116,101,114,97,108,10,0,0,0,0,0,0,0,32,111,114,32,39,32,101,120,112,101,99,116,101,100,10,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,115,112,97,99,101,32,101,120,112,101,99,116,101,100,10,0,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,110,101,118,101,114,32,101,110,100,32,46,46,46,10,0,0,0,80,73,32,105,115,32,110,111,116,32,115,116,97,114,116,101,100,32,99,111,114,114,101,99,116,108,121,0,0,0,0,0,98,117,102,102,101,114,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,32,102,97,105,108,101,100,10,0,0,67,111,109,109,101,110,116,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,32,10,60,33,45,45,37,46,53,48,115,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,105,110,118,97,108,105,100,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,69,108,101,109,101,110,116,73,110,116,101,114,110,97,108,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,109,105,115,112,108,97,99,101,100,32,60,104,116,109,108,62,32,116,97,103,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,109,105,115,112,108,97,99,101,100,32,60,104,101,97,100,62,32,116,97,103,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,109,105,115,112,108,97,99,101,100,32,60,98,111,100,121,62,32,116,97,103,10,0,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,112,114,111,98,108,101,109,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,115,10,0,0,104,116,116,112,45,101,113,117,105,118,0,0,0,0,0,0,67,111,110,116,101,110,116,45,84,121,112,101,0,0,0,0,99,111,110,116,101,110,116,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,10,0,0,0,65,116,116,86,97,108,117,101,58,32,34,32,101,120,112,101,99,116,101,100,10,0,0,0,65,116,116,86,97,108,117,101,58,32,39,32,101,120,112,101,99,116,101,100,10,0,0,0,65,116,116,86,97,108,117,101,58,32,110,111,32,118,97,108,117,101,32,102,111,117,110,100,10,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,10,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,113,117,111,116,0,0,0,0,113,117,111,116,97,116,105,111,110,32,109,97,114,107,32,61,32,65,80,76,32,113,117,111,116,101,44,32,85,43,48,48,50,50,32,73,83,79,110,117,109,0,0,0,0,0,0,0,97,109,112,0,0,0,0,0,97,109,112,101,114,115,97,110,100,44,32,85,43,48,48,50,54,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,97,112,111,115,0,0,0,0,115,105,110,103,108,101,32,113,117,111,116,101,0,0,0,0,108,116,0,0,0,0,0,0,108,101,115,115,45,116,104,97,110,32,115,105,103,110,44,32,85,43,48,48,51,67,32,73,83,79,110,117,109,0,0,0,103,116,0,0,0,0,0,0,103,114,101,97,116,101,114,45,116,104,97,110,32,115,105,103,110,44,32,85,43,48,48,51,69,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,110,98,115,112,0,0,0,0,110,111,45,98,114,101,97,107,32,115,112,97,99,101,32,61,32,110,111,110,45,98,114,101,97,107,105,110,103,32,115,112,97,99,101,44,32,85,43,48,48,65,48,32,73,83,79,110,117,109,0,0,0,0,0,0,105,101,120,99,108,0,0,0,105,110,118,101,114,116,101,100,32,101,120,99,108,97,109,97,116,105,111,110,32,109,97,114,107,44,32,85,43,48,48,65,49,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,99,101,110,116,0,0,0,0,99,101,110,116,32,115,105,103,110,44,32,85,43,48,48,65,50,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,112,111,117,110,100,0,0,0,112,111,117,110,100,32,115,105,103,110,44,32,85,43,48,48,65,51,32,73,83,79,110,117,109,0,0,0,0,0,0,0,99,117,114,114,101,110,0,0,99,117,114,114,101,110,99,121,32,115,105,103,110,44,32,85,43,48,48,65,52,32,73,83,79,110,117,109,0,0,0,0,121,101,110,0,0,0,0,0,121,101,110,32,115,105,103,110,32,61,32,121,117,97,110,32,115,105,103,110,44,32,85,43,48,48,65,53,32,73,83,79,110,117,109,0,0,0,0,0,98,114,118,98,97,114,0,0,98,114,111,107,101,110,32,98,97,114,32,61,32,98,114,111,107,101,110,32,118,101,114,116,105,99,97,108,32,98,97,114,44,32,85,43,48,48,65,54,32,73,83,79,110,117,109,0,115,101,99,116,0,0,0,0,115,101,99,116,105,111,110,32,115,105,103,110,44,32,85,43,48,48,65,55,32,73,83,79,110,117,109,0,0,0,0,0,117,109,108,0,0,0,0,0,100,105,97,101,114,101,115,105,115,32,61,32,115,112,97,99,105,110,103,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,65,56,32,73,83,79,100,105,97,0,0,0,0,99,111,112,121,0,0,0,0,99,111,112,121,114,105,103,104,116,32,115,105,103,110,44,32,85,43,48,48,65,57,32,73,83,79,110,117,109,0,0,0,111,114,100,102,0,0,0,0,102,101,109,105,110,105,110,101,32,111,114,100,105,110,97,108,32,105,110,100,105,99,97,116,111,114,44,32,85,43,48,48,65,65,32,73,83,79,110,117,109,0,0,0,0,0,0,0,108,97,113,117,111,0,0,0,108,101,102,116,45,112,111,105,110,116,105,110,103,32,100,111,117,98,108,101,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,32,61,32,108,101,102,116,32,112,111,105,110,116,105,110,103,32,103,117,105,108,108,101,109,101,116,44,32,85,43,48,48,65,66,32,73,83,79,110,117,109,0,0,0,0,0,0,110,111,116,0,0,0,0,0,110,111,116,32,115,105,103,110,44,32,85,43,48,48,65,67,32,73,83,79,110,117,109,0,115,104,121,0,0,0,0,0,115,111,102,116,32,104,121,112,104,101,110,32,61,32,100,105,115,99,114,101,116,105,111,110,97,114,121,32,104,121,112,104,101,110,44,32,85,43,48,48,65,68,32,73,83,79,110,117,109,0,0,0,0,0,0,0,114,101,103,0,0,0,0,0,114,101,103,105,115,116,101,114,101,100,32,115,105,103,110,32,61,32,114,101,103,105,115,116,101,114,101,100,32,116,114,97,100,101,32,109,97,114,107,32,115,105,103,110,44,32,85,43,48,48,65,69,32,73,83,79,110,117,109,0,0,0,0,0,109,97,99,114,0,0,0,0,109,97,99,114,111,110,32,61,32,115,112,97,99,105,110,103,32,109,97,99,114,111,110,32,61,32,111,118,101,114,108,105,110,101,32,61,32,65,80,76,32,111,118,101,114,98,97,114,44,32,85,43,48,48,65,70,32,73,83,79,100,105,97,0,100,101,103,0,0,0,0,0,100,101,103,114,101,101,32,115,105,103,110,44,32,85,43,48,48,66,48,32,73,83,79,110,117,109,0,0,0,0,0,0,112,108,117,115,109,110,0,0,112,108,117,115,45,109,105,110,117,115,32,115,105,103,110,32,61,32,112,108,117,115,45,111,114,45,109,105,110,117,115,32,115,105,103,110,44,32,85,43,48,48,66,49,32,73,83,79,110,117,109,0,0,0,0,0,115,117,112,50,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,116,119,111,32,61,32,115,117,112,101,114,115,99,114,105,112,116,32,100,105,103,105,116,32,116,119,111,32,61,32,115,113,117,97,114,101,100,44,32,85,43,48,48,66,50,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,115,117,112,51,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,116,104,114,101,101,32,61,32,115,117,112,101,114,115,99,114,105,112,116,32,100,105,103,105,116,32,116,104,114,101,101,32,61,32,99,117,98,101,100,44,32,85,43,48,48,66,51,32,73,83,79,110,117,109,0,0,0,0,0,0,97,99,117,116,101,0,0,0,97,99,117,116,101,32,97,99,99,101,110,116,32,61,32,115,112,97,99,105,110,103,32,97,99,117,116,101,44,32,85,43,48,48,66,52,32,73,83,79,100,105,97,0,0,0,0,0,109,105,99,114,111,0,0,0,109,105,99,114,111,32,115,105,103,110,44,32,85,43,48,48,66,53,32,73,83,79,110,117,109,0,0,0,0,0,0,0,112,97,114,97,0,0,0,0,112,105,108,99,114,111,119,32,115,105,103,110,32,61,32,112,97,114,97,103,114,97,112,104,32,115,105,103,110,44,32,85,43,48,48,66,54,32,73,83,79,110,117,109,0,0,0,0,109,105,100,100,111,116,0,0,109,105,100,100,108,101,32,100,111,116,32,61,32,71,101,111,114,103,105,97,110,32,99,111,109,109,97,32,71,114,101,101,107,32,109,105,100,100,108,101,32,100,111,116,44,32,85,43,48,48,66,55,32,73,83,79,110,117,109,0,0,0,0,0,99,101,100,105,108,0,0,0,99,101,100,105,108,108,97,32,61,32,115,112,97,99,105,110,103,32,99,101,100,105,108,108,97,44,32,85,43,48,48,66,56,32,73,83,79,100,105,97,0,0,0,0,0,0,0,0,115,117,112,49,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,111,110,101,32,61,32,115,117,112,101,114,115,99,114,105,112,116,32,100,105,103,105,116,32,111,110,101,44,32,85,43,48,48,66,57,32,73,83,79,110,117,109,0,0,111,114,100,109,0,0,0,0,109,97,115,99,117,108,105,110,101,32,111,114,100,105,110,97,108,32,105,110,100,105,99,97,116,111,114,44,32,85,43,48,48,66,65,32,73,83,79,110,117,109,0,0,0,0,0,0,114,97,113,117,111,0,0,0,114,105,103,104,116,45,112,111,105,110,116,105,110,103,32,100,111,117,98,108,101,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,32,114,105,103,104,116,32,112,111,105,110,116,105,110,103,32,103,117,105,108,108,101,109,101,116,44,32,85,43,48,48,66,66,32,73,83,79,110,117,109,0,0,0,0,0,0,102,114,97,99,49,52,0,0,118,117,108,103,97,114,32,102,114,97,99,116,105,111,110,32,111,110,101,32,113,117,97,114,116,101,114,32,61,32,102,114,97,99,116,105,111,110,32,111,110,101,32,113,117,97,114,116,101,114,44,32,85,43,48,48,66,67,32,73,83,79,110,117,109,0,0,0,0,0,0,0,102,114,97,99,49,50,0,0,118,117,108,103,97,114,32,102,114,97,99,116,105,111,110,32,111,110,101,32,104,97,108,102,32,61,32,102,114,97,99,116,105,111,110,32,111,110,101,32,104,97,108,102,44,32,85,43,48,48,66,68,32,73,83,79,110,117,109,0,0,0,0,0,102,114,97,99,51,52,0,0,118,117,108,103,97,114,32,102,114,97,99,116,105,111,110,32,116,104,114,101,101,32,113,117,97,114,116,101,114,115,32,61,32,102,114,97,99,116,105,111,110,32,116,104,114,101,101,32,113,117,97,114,116,101,114,115,44,32,85,43,48,48,66,69,32,73,83,79,110,117,109,0,105,113,117,101,115,116,0,0,105,110,118,101,114,116,101,100,32,113,117,101,115,116,105,111,110,32,109,97,114,107,32,61,32,116,117,114,110,101,100,32,113,117,101,115,116,105,111,110,32,109,97,114,107,44,32,85,43,48,48,66,70,32,73,83,79,110,117,109,0,0,0,0,65,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,103,114,97,118,101,32,61,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,103,114,97,118,101,44,32,85,43,48,48,67,48,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,0,65,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,67,49,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,65,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,67,50,32,73,83,79,108,97,116,49,0,0,65,116,105,108,100,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,67,51,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,65,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,67,52,32,73,83,79,108,97,116,49,0,0,0,65,114,105,110,103,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,114,105,110,103,32,97,98,111,118,101,32,61,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,114,105,110,103,44,32,85,43,48,48,67,53,32,73,83,79,108,97,116,49,0,0,0,0,65,69,108,105,103,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,69,32,61,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,105,103,97,116,117,114,101,32,65,69,44,32,85,43,48,48,67,54,32,73,83,79,108,97,116,49,0,0,0,0,0,67,99,101,100,105,108,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,67,32,119,105,116,104,32,99,101,100,105,108,108,97,44,32,85,43,48,48,67,55,32,73,83,79,108,97,116,49,0,0,0,0,0,69,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,67,56,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,69,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,67,57,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,69,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,67,65,32,73,83,79,108,97,116,49,0,0,69,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,67,66,32,73,83,79,108,97,116,49,0,0,0,73,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,67,67,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,73,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,67,68,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,73,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,67,69,32,73,83,79,108,97,116,49,0,0,73,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,67,70,32,73,83,79,108,97,116,49,0,0,0,69,84,72,0,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,84,72,44,32,85,43,48,48,68,48,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,0,78,116,105,108,100,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,78,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,68,49,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,68,50,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,68,51,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,68,52,32,73,83,79,108,97,116,49,0,0,79,116,105,108,100,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,68,53,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,68,54,32,73,83,79,108,97,116,49,0,0,0,116,105,109,101,115,0,0,0,109,117,108,116,105,112,108,105,99,97,116,105,111,110,32,115,105,103,110,44,32,85,43,48,48,68,55,32,73,83,79,110,117,109,0,0,0,0,0,0,79,115,108,97,115,104,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,115,116,114,111,107,101,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,115,108,97,115,104,44,32,85,43,48,48,68,56,32,73,83,79,108,97,116,49,0,85,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,68,57,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,85,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,68,65,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,85,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,68,66,32,73,83,79,108,97,116,49,0,0,85,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,68,67,32,73,83,79,108,97,116,49,0,0,0,89,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,89,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,68,68,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,84,72,79,82,78,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,84,72,79,82,78,44,32,85,43,48,48,68,69,32,73,83,79,108,97,116,49,0,0,0,0,0,0,115,122,108,105,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,115,104,97,114,112,32,115,32,61,32,101,115,115,45,122,101,100,44,32,85,43,48,48,68,70,32,73,83,79,108,97,116,49,0,0,0,0,97,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,103,114,97,118,101,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,103,114,97,118,101,44,32,85,43,48,48,69,48,32,73,83,79,108,97,116,49,0,0,0,0,97,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,69,49,32,73,83,79,108,97,116,49,0,97,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,69,50,32,73,83,79,108,97,116,49,0,0,0,0,97,116,105,108,100,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,69,51,32,73,83,79,108,97,116,49,0,97,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,69,52,32,73,83,79,108,97,116,49,0,0,0,0,0,97,114,105,110,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,114,105,110,103,32,97,98,111,118,101,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,114,105,110,103,44,32,85,43,48,48,69,53,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,0,97,101,108,105,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,101,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,105,103,97,116,117,114,101,32,97,101,44,32,85,43,48,48,69,54,32,73,83,79,108,97,116,49,0,99,99,101,100,105,108,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,99,32,119,105,116,104,32,99,101,100,105,108,108,97,44,32,85,43,48,48,69,55,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,101,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,69,56,32,73,83,79,108,97,116,49,0,101,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,69,57,32,73,83,79,108,97,116,49,0,101,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,69,65,32,73,83,79,108,97,116,49,0,0,0,0,101,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,69,66,32,73,83,79,108,97,116,49,0,0,0,0,0,105,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,69,67,32,73,83,79,108,97,116,49,0,105,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,69,68,32,73,83,79,108,97,116,49,0,105,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,69,69,32,73,83,79,108,97,116,49,0,0,0,0,105,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,69,70,32,73,83,79,108,97,116,49,0,0,0,0,0,101,116,104,0,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,116,104,44,32,85,43,48,48,70,48,32,73,83,79,108,97,116,49,0,0,110,116,105,108,100,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,110,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,70,49,32,73,83,79,108,97,116,49,0,111,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,70,50,32,73,83,79,108,97,116,49,0,111,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,70,51,32,73,83,79,108,97,116,49,0,111,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,70,52,32,73,83,79,108,97,116,49,0,0,0,0,111,116,105,108,100,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,70,53,32,73,83,79,108,97,116,49,0,111,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,70,54,32,73,83,79,108,97,116,49,0,0,0,0,0,100,105,118,105,100,101,0,0,100,105,118,105,115,105,111,110,32,115,105,103,110,44,32,85,43,48,48,70,55,32,73,83,79,110,117,109,0,0,0,0,111,115,108,97,115,104,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,115,116,114,111,107,101,44,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,115,108,97,115,104,44,32,85,43,48,48,70,56,32,73,83,79,108,97,116,49,0,0,117,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,70,57,32,73,83,79,108,97,116,49,0,117,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,70,65,32,73,83,79,108,97,116,49,0,117,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,70,66,32,73,83,79,108,97,116,49,0,0,0,0,117,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,70,67,32,73,83,79,108,97,116,49,0,0,0,0,0,121,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,121,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,70,68,32,73,83,79,108,97,116,49,0,116,104,111,114,110,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,104,111,114,110,32,119,105,116,104,44,32,85,43,48,48,70,69,32,73,83,79,108,97,116,49,0,0,0,121,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,121,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,70,70,32,73,83,79,108,97,116,49,0,0,0,0,0,79,69,108,105,103,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,105,103,97,116,117,114,101,32,79,69,44,32,85,43,48,49,53,50,32,73,83,79,108,97,116,50,0,0,0,0,0,0,0,111,101,108,105,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,105,103,97,116,117,114,101,32,111,101,44,32,85,43,48,49,53,51,32,73,83,79,108,97,116,50,0,83,99,97,114,111,110,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,83,32,119,105,116,104,32,99,97,114,111,110,44,32,85,43,48,49,54,48,32,73,83,79,108,97,116,50,0,0,0,0,0,0,0,115,99,97,114,111,110,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,115,32,119,105,116,104,32,99,97,114,111,110,44,32,85,43,48,49,54,49,32,73,83,79,108,97,116,50,0,89,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,89,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,49,55,56,32,73,83,79,108,97,116,50,0,0,0,102,110,111,102,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,102,32,119,105,116,104,32,104,111,111,107,32,61,32,102,117,110,99,116,105,111,110,32,61,32,102,108,111,114,105,110,44,32,85,43,48,49,57,50,32,73,83,79,116,101,99,104,0,0,0,0,0,99,105,114,99,0,0,0,0,109,111,100,105,102,105,101,114,32,108,101,116,116,101,114,32,99,105,114,99,117,109,102,108,101,120,32,97,99,99,101,110,116,44,32,85,43,48,50,67,54,32,73,83,79,112,117,98,0,0,0,0,0,0,0,0,116,105,108,100,101,0,0,0,115,109,97,108,108,32,116,105,108,100,101,44,32,85,43,48,50,68,67,32,73,83,79,100,105,97,0,0,0,0,0,0,65,108,112,104,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,97,108,112,104,97,44,32,85,43,48,51,57,49,0,0,0,0,0,0,66,101,116,97,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,98,101,116,97,44,32,85,43,48,51,57,50,0,0,0,0,0,0,0,71,97,109,109,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,103,97,109,109,97,44,32,85,43,48,51,57,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,68,101,108,116,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,100,101,108,116,97,44,32,85,43,48,51,57,52,32,73,83,79,103,114,107,51,0,0,0,0,0,0,69,112,115,105,108,111,110,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,101,112,115,105,108,111,110,44,32,85,43,48,51,57,53,0,0,0,0,90,101,116,97,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,122,101,116,97,44,32,85,43,48,51,57,54,0,0,0,0,0,0,0,69,116,97,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,101,116,97,44,32,85,43,48,51,57,55,0,0,0,0,0,0,0,0,84,104,101,116,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,116,104,101,116,97,44,32,85,43,48,51,57,56,32,73,83,79,103,114,107,51,0,0,0,0,0,0,73,111,116,97,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,105,111,116,97,44,32,85,43,48,51,57,57,0,0,0,0,0,0,0,75,97,112,112,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,107,97,112,112,97,44,32,85,43,48,51,57,65,0,0,0,0,0,0,76,97,109,98,100,97,0,0,103,114,101,101,107,32,99,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+95088),
	allocate([112,105,116,97,108,32,108,101,116,116,101,114,32,108,97,109,98,100,97,44,32,85,43,48,51,57,66,32,73,83,79,103,114,107,51,0,0,0,0,0,77,117,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,109,117,44,32,85,43,48,51,57,67,0,78,117,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,110,117,44,32,85,43,48,51,57,68,0,88,105,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,120,105,44,32,85,43,48,51,57,69,32,73,83,79,103,114,107,51,0,79,109,105,99,114,111,110,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,111,109,105,99,114,111,110,44,32,85,43,48,51,57,70,0,0,0,0,80,105,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,112,105,44,32,85,43,48,51,65,48,32,73,83,79,103,114,107,51,0,82,104,111,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,114,104,111,44,32,85,43,48,51,65,49,0,0,0,0,0,0,0,0,83,105,103,109,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,115,105,103,109,97,44,32,85,43,48,51,65,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,84,97,117,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,116,97,117,44,32,85,43,48,51,65,52,0,0,0,0,0,0,0,0,85,112,115,105,108,111,110,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,117,112,115,105,108,111,110,44,32,85,43,48,51,65,53,32,73,83,79,103,114,107,51,0,0,0,0,80,104,105,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,112,104,105,44,32,85,43,48,51,65,54,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,67,104,105,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,99,104,105,44,32,85,43,48,51,65,55,0,0,0,0,0,0,0,0,80,115,105,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,112,115,105,44,32,85,43,48,51,65,56,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,79,109,101,103,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,111,109,101,103,97,44,32,85,43,48,51,65,57,32,73,83,79,103,114,107,51,0,0,0,0,0,0,97,108,112,104,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,108,112,104,97,44,32,85,43,48,51,66,49,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,98,101,116,97,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,98,101,116,97,44,32,85,43,48,51,66,50,32,73,83,79,103,114,107,51,0,103,97,109,109,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,103,97,109,109,97,44,32,85,43,48,51,66,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,100,101,108,116,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,100,101,108,116,97,44,32,85,43,48,51,66,52,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,101,112,115,105,108,111,110,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,112,115,105,108,111,110,44,32,85,43,48,51,66,53,32,73,83,79,103,114,107,51,0,0,0,0,0,0,122,101,116,97,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,122,101,116,97,44,32,85,43,48,51,66,54,32,73,83,79,103,114,107,51,0,101,116,97,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,116,97,44,32,85,43,48,51,66,55,32,73,83,79,103,114,107,51,0,0,116,104,101,116,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,104,101,116,97,44,32,85,43,48,51,66,56,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,105,111,116,97,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,111,116,97,44,32,85,43,48,51,66,57,32,73,83,79,103,114,107,51,0,107,97,112,112,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,107,97,112,112,97,44,32,85,43,48,51,66,65,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,108,97,109,98,100,97,44,32,85,43,48,51,66,66,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,109,117,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,109,117,44,32,85,43,48,51,66,67,32,73,83,79,103,114,107,51,0,0,0,110,117,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,110,117,44,32,85,43,48,51,66,68,32,73,83,79,103,114,107,51,0,0,0,120,105,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,120,105,44,32,85,43,48,51,66,69,32,73,83,79,103,114,107,51,0,0,0,111,109,105,99,114,111,110,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,109,105,99,114,111,110,44,32,85,43,48,51,66,70,32,78,69,87,0,0,112,105,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,112,105,44,32,85,43,48,51,67,48,32,73,83,79,103,114,107,51,0,0,0,114,104,111,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,114,104,111,44,32,85,43,48,51,67,49,32,73,83,79,103,114,107,51,0,0,115,105,103,109,97,102,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,102,105,110,97,108,32,115,105,103,109,97,44,32,85,43,48,51,67,50,32,73,83,79,103,114,107,51,0,0,115,105,103,109,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,115,105,103,109,97,44,32,85,43,48,51,67,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,116,97,117,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,97,117,44,32,85,43,48,51,67,52,32,73,83,79,103,114,107,51,0,0,117,112,115,105,108,111,110,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,112,115,105,108,111,110,44,32,85,43,48,51,67,53,32,73,83,79,103,114,107,51,0,0,0,0,0,0,112,104,105,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,112,104,105,44,32,85,43,48,51,67,54,32,73,83,79,103,114,107,51,0,0,99,104,105,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,99,104,105,44,32,85,43,48,51,67,55,32,73,83,79,103,114,107,51,0,0,112,115,105,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,112,115,105,44,32,85,43,48,51,67,56,32,73,83,79,103,114,107,51,0,0,111,109,101,103,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,109,101,103,97,44,32,85,43,48,51,67,57,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,116,104,101,116,97,115,121,109,0,0,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,104,101,116,97,32,115,121,109,98,111,108,44,32,85,43,48,51,68,49,32,78,69,87,0,0,0,0,0,117,112,115,105,104,0,0,0,103,114,101,101,107,32,117,112,115,105,108,111,110,32,119,105,116,104,32,104,111,111,107,32,115,121,109,98,111,108,44,32,85,43,48,51,68,50,32,78,69,87,0,0,0,0,0,0,112,105,118,0,0,0,0,0,103,114,101,101,107,32,112,105,32,115,121,109,98,111,108,44,32,85,43,48,51,68,54,32,73,83,79,103,114,107,51,0,101,110,115,112,0,0,0,0,101,110,32,115,112,97,99,101,44,32,85,43,50,48,48,50,32,73,83,79,112,117,98,0,101,109,115,112,0,0,0,0,101,109,32,115,112,97,99,101,44,32,85,43,50,48,48,51,32,73,83,79,112,117,98,0,116,104,105,110,115,112,0,0,116,104,105,110,32,115,112,97,99,101,44,32,85,43,50,48,48,57,32,73,83,79,112,117,98,0,0,0,0,0,0,0,122,119,110,106,0,0,0,0,122,101,114,111,32,119,105,100,116,104,32,110,111,110,45,106,111,105,110,101,114,44,32,85,43,50,48,48,67,32,78,69,87,32,82,70,67,32,50,48,55,48,0,0,0,0,0,0,122,119,106,0,0,0,0,0,122,101,114,111,32,119,105,100,116,104,32,106,111,105,110,101,114,44,32,85,43,50,48,48,68,32,78,69,87,32,82,70,67,32,50,48,55,48,0,0,108,114,109,0,0,0,0,0,108,101,102,116,45,116,111,45,114,105,103,104,116,32,109,97,114,107,44,32,85,43,50,48,48,69,32,78,69,87,32,82,70,67,32,50,48,55,48,0,114,108,109,0,0,0,0,0,114,105,103,104,116,45,116,111,45,108,101,102,116,32,109,97,114,107,44,32,85,43,50,48,48,70,32,78,69,87,32,82,70,67,32,50,48,55,48,0,110,100,97,115,104,0,0,0,101,110,32,100,97,115,104,44,32,85,43,50,48,49,51,32,73,83,79,112,117,98,0,0,109,100,97,115,104,0,0,0,101,109,32,100,97,115,104,44,32,85,43,50,48,49,52,32,73,83,79,112,117,98,0,0,108,115,113,117,111,0,0,0,108,101,102,116,32,115,105,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,56,32,73,83,79,110,117,109,0,0,0,0,0,0,0,114,115,113,117,111,0,0,0,114,105,103,104,116,32,115,105,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,57,32,73,83,79,110,117,109,0,0,0,0,0,0,115,98,113,117,111,0,0,0,115,105,110,103,108,101,32,108,111,119,45,57,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,65,32,78,69,87,0,108,100,113,117,111,0,0,0,108,101,102,116,32,100,111,117,98,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,67,32,73,83,79,110,117,109,0,0,0,0,0,0,0,114,100,113,117,111,0,0,0,114,105,103,104,116,32,100,111,117,98,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,68,32,73,83,79,110,117,109,0,0,0,0,0,0,98,100,113,117,111,0,0,0,100,111,117,98,108,101,32,108,111,119,45,57,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,69,32,78,69,87,0,100,97,103,103,101,114,0,0,100,97,103,103,101,114,44,32,85,43,50,48,50,48,32,73,83,79,112,117,98,0,0,0,68,97,103,103,101,114,0,0,100,111,117,98,108,101,32,100,97,103,103,101,114,44,32,85,43,50,48,50,49,32,73,83,79,112,117,98,0,0,0,0,98,117,108,108,0,0,0,0,98,117,108,108,101,116,32,61,32,98,108,97,99,107,32,115,109,97,108,108,32,99,105,114,99,108,101,44,32,85,43,50,48,50,50,32,73,83,79,112,117,98,0,0,0,0,0,0,104,101,108,108,105,112,0,0,104,111,114,105,122,111,110,116,97,108,32,101,108,108,105,112,115,105,115,32,61,32,116,104,114,101,101,32,100,111,116,32,108,101,97,100,101,114,44,32,85,43,50,48,50,54,32,73,83,79,112,117,98,0,0,0,112,101,114,109,105,108,0,0,112,101,114,32,109,105,108,108,101,32,115,105,103,110,44,32,85,43,50,48,51,48,32,73,83,79,116,101,99,104,0,0,112,114,105,109,101,0,0,0,112,114,105,109,101,32,61,32,109,105,110,117,116,101,115,32,61,32,102,101,101,116,44,32,85,43,50,48,51,50,32,73,83,79,116,101,99,104,0,0,80,114,105,109,101,0,0,0,100,111,117,98,108,101,32,112,114,105,109,101,32,61,32,115,101,99,111,110,100,115,32,61,32,105,110,99,104,101,115,44,32,85,43,50,48,51,51,32,73,83,79,116,101,99,104,0,108,115,97,113,117,111,0,0,115,105,110,103,108,101,32,108,101,102,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,51,57,32,73,83,79,32,112,114,111,112,111,115,101,100,0,0,114,115,97,113,117,111,0,0,115,105,110,103,108,101,32,114,105,103,104,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,51,65,32,73,83,79,32,112,114,111,112,111,115,101,100,0,111,108,105,110,101,0,0,0,111,118,101,114,108,105,110,101,32,61,32,115,112,97,99,105,110,103,32,111,118,101,114,115,99,111,114,101,44,32,85,43,50,48,51,69,32,78,69,87,0,0,0,0,0,0,0,0,102,114,97,115,108,0,0,0,102,114,97,99,116,105,111,110,32,115,108,97,115,104,44,32,85,43,50,48,52,52,32,78,69,87,0,0,0,0,0,0,101,117,114,111,0,0,0,0,101,117,114,111,32,115,105,103,110,44,32,85,43,50,48,65,67,32,78,69,87,0,0,0,105,109,97,103,101,0,0,0,98,108,97,99,107,108,101,116,116,101,114,32,99,97,112,105,116,97,108,32,73,32,61,32,105,109,97,103,105,110,97,114,121,32,112,97,114,116,44,32,85,43,50,49,49,49,32,73,83,79,97,109,115,111,0,0,119,101,105,101,114,112,0,0,115,99,114,105,112,116,32,99,97,112,105,116,97,108,32,80,32,61,32,112,111,119,101,114,32,115,101,116,32,61,32,87,101,105,101,114,115,116,114,97,115,115,32,112,44,32,85,43,50,49,49,56,32,73,83,79,97,109,115,111,0,0,0,0,114,101,97,108,0,0,0,0,98,108,97,99,107,108,101,116,116,101,114,32,99,97,112,105,116,97,108,32,82,32,61,32,114,101,97,108,32,112,97,114,116,32,115,121,109,98,111,108,44,32,85,43,50,49,49,67,32,73,83,79,97,109,115,111,0,0,0,0,0,0,0,0,116,114,97,100,101,0,0,0,116,114,97,100,101,32,109,97,114,107,32,115,105,103,110,44,32,85,43,50,49,50,50,32,73,83,79,110,117,109,0,0,97,108,101,102,115,121,109,0,97,108,101,102,32,115,121,109,98,111,108,32,61,32,102,105,114,115,116,32,116,114,97,110,115,102,105,110,105,116,101,32,99,97,114,100,105,110,97,108,44,32,85,43,50,49,51,53,32,78,69,87,0,0,0,0,108,97,114,114,0,0,0,0,108,101,102,116,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,48,32,73,83,79,110,117,109,0,0,117,97,114,114,0,0,0,0,117,112,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,49,32,73,83,79,110,117,109,0,0,0,0,114,97,114,114,0,0,0,0,114,105,103,104,116,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,50,32,73,83,79,110,117,109,0,100,97,114,114,0,0,0,0,100,111,119,110,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,51,32,73,83,79,110,117,109,0,0,104,97,114,114,0,0,0,0,108,101,102,116,32,114,105,103,104,116,32,97,114,114,111,119,44,32,85,43,50,49,57,52,32,73,83,79,97,109,115,97,0,0,0,0,0,0,0,0,99,114,97,114,114,0,0,0,100,111,119,110,119,97,114,100,115,32,97,114,114,111,119,32,119,105,116,104,32,99,111,114,110,101,114,32,108,101,102,116,119,97,114,100,115,32,61,32,99,97,114,114,105,97,103,101,32,114,101,116,117,114,110,44,32,85,43,50,49,66,53,32,78,69,87,0,0,0,0,0,108,65,114,114,0,0,0,0,108,101,102,116,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,48,32,73,83,79,116,101,99,104,0,0,117,65,114,114,0,0,0,0,117,112,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,49,32,73,83,79,97,109,115,97,0,0,0,0,114,65,114,114,0,0,0,0,114,105,103,104,116,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,50,32,73,83,79,116,101,99,104,0,100,65,114,114,0,0,0,0,100,111,119,110,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,51,32,73,83,79,97,109,115,97,0,0,104,65,114,114,0,0,0,0,108,101,102,116,32,114,105,103,104,116,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,52,32,73,83,79,97,109,115,97,0,102,111,114,97,108,108,0,0,102,111,114,32,97,108,108,44,32,85,43,50,50,48,48,32,73,83,79,116,101,99,104,0,112,97,114,116,0,0,0,0,112,97,114,116,105,97,108,32,100,105,102,102,101,114,101,110,116,105,97,108,44,32,85,43,50,50,48,50,32,73,83,79,116,101,99,104,0,0,0,0,101,120,105,115,116,0,0,0,116,104,101,114,101,32,101,120,105,115,116,115,44,32,85,43,50,50,48,51,32,73,83,79,116,101,99,104,0,0,0,0,101,109,112,116,121,0,0,0,101,109,112,116,121,32,115,101,116,32,61,32,110,117,108,108,32,115,101,116,32,61,32,100,105,97,109,101,116,101,114,44,32,85,43,50,50,48,53,32,73,83,79,97,109,115,111,0,110,97,98,108,97,0,0,0,110,97,98,108,97,32,61,32,98,97,99,107,119,97,114,100,32,100,105,102,102,101,114,101,110,99,101,44,32,85,43,50,50,48,55,32,73,83,79,116,101,99,104,0,0,0,0,0,105,115,105,110,0,0,0,0,101,108,101,109,101,110,116,32,111,102,44,32,85,43,50,50,48,56,32,73,83,79,116,101,99,104,0,0,0,0,0,0,110,111,116,105,110,0,0,0,110,111,116,32,97,110,32,101,108,101,109,101,110,116,32,111,102,44,32,85,43,50,50,48,57,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,110,105,0,0,0,0,0,0,99,111,110,116,97,105,110,115,32,97,115,32,109,101,109,98,101,114,44,32,85,43,50,50,48,66,32,73,83,79,116,101,99,104,0,0,0,0,0,0,112,114,111,100,0,0,0,0,110,45,97,114,121,32,112,114,111,100,117,99,116,32,61,32,112,114,111,100,117,99,116,32,115,105,103,110,44,32,85,43,50,50,48,70,32,73,83,79,97,109,115,98,0,0,0,0,115,117,109,0,0,0,0,0,110,45,97,114,121,32,115,117,109,109,97,116,105,111,110,44,32,85,43,50,50,49,49,32,73,83,79,97,109,115,98,0,109,105,110,117,115,0,0,0,109,105,110,117,115,32,115,105,103,110,44,32,85,43,50,50,49,50,32,73,83,79,116,101,99,104,0,0,0,0,0,0,108,111,119,97,115,116,0,0,97,115,116,101,114,105,115,107,32,111,112,101,114,97,116,111,114,44,32,85,43,50,50,49,55,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,114,97,100,105,99,0,0,0,115,113,117,97,114,101,32,114,111,111,116,32,61,32,114,97,100,105,99,97,108,32,115,105,103,110,44,32,85,43,50,50,49,65,32,73,83,79,116,101,99,104,0,0,0,0,0,0,112,114,111,112,0,0,0,0,112,114,111,112,111,114,116,105,111,110,97,108,32,116,111,44,32,85,43,50,50,49,68,32,73,83,79,116,101,99,104,0,105,110,102,105,110,0,0,0,105,110,102,105,110,105,116,121,44,32,85,43,50,50,49,69,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,97,110,103,0,0,0,0,0,97,110,103,108,101,44,32,85,43,50,50,50,48,32,73,83,79,97,109,115,111,0,0,0,97,110,100,0,0,0,0,0,108,111,103,105,99,97,108,32,97,110,100,32,61,32,119,101,100,103,101,44,32,85,43,50,50,50,55,32,73,83,79,116,101,99,104,0,0,0,0,0,111,114,0,0,0,0,0,0,108,111,103,105,99,97,108,32,111,114,32,61,32,118,101,101,44,32,85,43,50,50,50,56,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,99,97,112,0,0,0,0,0,105,110,116,101,114,115,101,99,116,105,111,110,32,61,32,99,97,112,44,32,85,43,50,50,50,57,32,73,83,79,116,101,99,104,0,0,0,0,0,0,99,117,112,0,0,0,0,0,117,110,105,111,110,32,61,32,99,117,112,44,32,85,43,50,50,50,65,32,73,83,79,116,101,99,104,0,0,0,0,0,105,110,116,0,0,0,0,0,105,110,116,101,103,114,97,108,44,32,85,43,50,50,50,66,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,116,104,101,114,101,52,0,0,116,104,101,114,101,102,111,114,101,44,32,85,43,50,50,51,52,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,115,105,109,0,0,0,0,0,116,105,108,100,101,32,111,112,101,114,97,116,111,114,32,61,32,118,97,114,105,101,115,32,119,105,116,104,32,61,32,115,105,109,105,108,97,114,32,116,111,44,32,85,43,50,50,51,67,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,99,111,110,103,0,0,0,0,97,112,112,114,111,120,105,109,97,116,101,108,121,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,52,53,32,73,83,79,116,101,99,104,0,0,97,115,121,109,112,0,0,0,97,108,109,111,115,116,32,101,113,117,97,108,32,116,111,32,61,32,97,115,121,109,112,116,111,116,105,99,32,116,111,44,32,85,43,50,50,52,56,32,73,83,79,97,109,115,114,0,110,101,0,0,0,0,0,0,110,111,116,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,54,48,32,73,83,79,116,101,99,104,0,0,0,0,101,113,117,105,118,0,0,0,105,100,101,110,116,105,99,97,108,32,116,111,44,32,85,43,50,50,54,49,32,73,83,79,116,101,99,104,0,0,0,0,108,101,0,0,0,0,0,0,108,101,115,115,45,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,54,52,32,73,83,79,116,101,99,104,0,0,0,103,101,0,0,0,0,0,0,103,114,101,97,116,101,114,45,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,54,53,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,115,117,98,0,0,0,0,0,115,117,98,115,101,116,32,111,102,44,32,85,43,50,50,56,50,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,115,117,112,0,0,0,0,0,115,117,112,101,114,115,101,116,32,111,102,44,32,85,43,50,50,56,51,32,73,83,79,116,101,99,104,0,0,0,0,0,110,115,117,98,0,0,0,0,110,111,116,32,97,32,115,117,98,115,101,116,32,111,102,44,32,85,43,50,50,56,52,32,73,83,79,97,109,115,110,0,115,117,98,101,0,0,0,0,115,117,98,115,101,116,32,111,102,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,56,54,32,73,83,79,116,101,99,104,0,0,0,115,117,112,101,0,0,0,0,115,117,112,101,114,115,101,116,32,111,102,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,56,55,32,73,83,79,116,101,99,104,0,111,112,108,117,115,0,0,0,99,105,114,99,108,101,100,32,112,108,117,115,32,61,32,100,105,114,101,99,116,32,115,117,109,44,32,85,43,50,50,57,53,32,73,83,79,97,109,115,98,0,0,0,0,0,0,0,111,116,105,109,101,115,0,0,99,105,114,99,108,101,100,32,116,105,109,101,115,32,61,32,118,101,99,116,111,114,32,112,114,111,100,117,99,116,44,32,85,43,50,50,57,55,32,73,83,79,97,109,115,98,0,0,112,101,114,112,0,0,0,0,117,112,32,116,97,99,107,32,61,32,111,114,116,104,111,103,111,110,97,108,32,116,111,32,61,32,112,101,114,112,101,110,100,105,99,117,108,97,114,44,32,85,43,50,50,65,53,32,73,83,79,116,101,99,104,0,115,100,111,116,0,0,0,0,100,111,116,32,111,112,101,114,97,116,111,114,44,32,85,43,50,50,67,53,32,73,83,79,97,109,115,98,0,0,0,0,108,99,101,105,108,0,0,0,108,101,102,116,32,99,101,105,108,105,110,103,32,61,32,97,112,108,32,117,112,115,116,105,108,101,44,32,85,43,50,51,48,56,32,73,83,79,97,109,115,99,0,0,0,0,0,0,114,99,101,105,108,0,0,0,114,105,103,104,116,32,99,101,105,108,105,110,103,44,32,85,43,50,51,48,57,32,73,83,79,97,109,115,99,0,0,0,108,102,108,111,111,114,0,0,108,101,102,116,32,102,108,111,111,114,32,61,32,97,112,108,32,100,111,119,110,115,116,105,108,101,44,32,85,43,50,51,48,65,32,73,83,79,97,109,115,99,0,0,0,0,0,0,114,102,108,111,111,114,0,0,114,105,103,104,116,32,102,108,111,111,114,44,32,85,43,50,51,48,66,32,73,83,79,97,109,115,99,0,0,0,0,0,108,97,110,103,0,0,0,0,108,101,102,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,98,114,97,99,107,101,116,32,61,32,98,114,97,44,32,85,43,50,51,50,57,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,114,97,110,103,0,0,0,0,114,105,103,104,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,98,114,97,99,107,101,116,32,61,32,107,101,116,44,32,85,43,50,51,50,65,32,73,83,79,116,101,99,104,0,0,0,0,0,0,108,111,122,0,0,0,0,0,108,111,122,101,110,103,101,44,32,85,43,50,53,67,65,32,73,83,79,112,117,98,0,0,115,112,97,100,101,115,0,0,98,108,97,99,107,32,115,112,97,100,101,32,115,117,105,116,44,32,85,43,50,54,54,48,32,73,83,79,112,117,98,0,99,108,117,98,115,0,0,0,98,108,97,99,107,32,99,108,117,98,32,115,117,105,116,32,61,32,115,104,97,109,114,111,99,107,44,32,85,43,50,54,54,51,32,73,83,79,112,117,98,0,0,0,0,0,0,0,104,101,97,114,116,115,0,0,98,108,97,99,107,32,104,101,97,114,116,32,115,117,105,116,32,61,32,118,97,108,101,110,116,105,110,101,44,32,85,43,50,54,54,53,32,73,83,79,112,117,98,0,0,0,0,0,100,105,97,109,115,0,0,0,98,108,97,99,107,32,100,105,97,109,111,110,100,32,115,117,105,116,44,32,85,43,50,54,54,54,32,73,83,79,112,117,98,0,0,0,0,0,0,0,111,110,99,108,105,99,107,0,111,110,100,98,108,99,108,105,99,107,0,0,0,0,0,0,111,110,109,111,117,115,101,100,111,119,110,0,0,0,0,0,111,110,109,111,117,115,101,117,112,0,0,0,0,0,0,0,111,110,109,111,117,115,101,111,118,101,114,0,0,0,0,0,111,110,109,111,117,115,101,111,117,116,0,0,0,0,0,0,111,110,107,101,121,112,114,101,115,115,0,0,0,0,0,0,111,110,107,101,121,100,111,119,110,0,0,0,0,0,0,0,111,110,107,101,121,117,112,0,111,110,108,111,97,100,0,0,111,110,117,110,108,111,97,100,0,0,0,0,0,0,0,0,111,110,102,111,99,117,115,0,111,110,98,108,117,114,0,0,111,110,115,117,98,109,105,116,0,0,0,0,0,0,0,0,111,110,114,101,115,101,116,0,111,110,99,104,97,110,103,101,0,0,0,0,0,0,0,0,111,110,115,101,108,101,99,116,0,0,0,0,0,0,0,0,97,110,99,104,111,114,32,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,96,114,1,0,112,212,1,0,168,212,1,0,128,214,1,0,136,214,1,0,152,214,1,0,160,214,1,0,224,212,1,0,8,216,1,0,16,216,1,0,208,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,0,0,0,0,32,216,1,0,0,0,0,0,97,98,98,114,101,118,105,97,116,101,100,32,102,111,114,109,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,111,110,32,97,117,116,104,111,114,32,0,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,176,119,1,0,0,0,0,0,0,0,0,0,106,97,118,97,32,97,112,112,108,101,116,32,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,160,206,1,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,56,214,1,0,96,214,1,0,200,214,1,0,168,212,1,0,0,213,1,0,248,212,1,0,48,213,1,0,24,214,1,0,32,214,1,0,0,0,0,0,97,114,101,97,0,0,0,0,99,108,105,101,110,116,45,115,105,100,101,32,105,109,97,103,101,32,109,97,112,32,97,114,101,97,32,0,0,0,0,0,8,216,1,0,16,216,1,0,128,214,1,0,24,216,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,0,0,0,0,200,214,1,0,0,0,0,0,98,111,108,100,32,116,101,120,116,32,115,116,121,108,101,0,100,111,99,117,109,101,110,116,32,98,97,115,101,32,117,114,105,32,0,0,0,0,0,0,128,214,1,0,0,0,0,0,98,97,115,101,102,111,110,116,0,0,0,0,0,0,0,0,98,97,115,101,32,102,111,110,116,32,115,105,122,101,32,0,152,212,1,0,160,213,1,0,128,215,1,0,136,215,1,0,0,0,0,0,0,0,0,0,105,49,56,110,32,98,105,100,105,32,111,118,101,114,45,114,105,100,101,32,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,0,0,0,0,0,0,0,0,216,191,1,0,0,0,0,0,108,97,114,103,101,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,0,108,111,110,103,32,113,117,111,116,97,116,105,111,110,32,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,136,121,1,0,0,0,0,0,0,0,0,0,100,111,99,117,109,101,110,116,32,98,111,100,121,32,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,16,122,1,0,160,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,192,181,1,0,200,181,1,0,0,0,0,0,224,215,1,0,128,212,1,0,240,215,1,0,208,119,1,0,248,215,1,0,0,216,1,0,0,0,0,0,0,0,0,0,98,114,0,0,0,0,0,0,102,111,114,99,101,100,32,108,105,110,101,32,98,114,101,97,107,32,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,0,0,0,0,0,0,0,0,216,215,1,0,0,0,0,0,112,117,115,104,32,98,117,116,116,111,110,32,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,168,212,1,0,232,213,1,0,112,212,1,0,176,212,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,116,97,98,108,101,32,99,97,112,116,105,111,110,32,0,0,115,104,111,114,116,104,97,110,100,32,102,111,114,32,100,105,118,32,97,108,105,103,110,61,99,101,110,116,101,114,32,0,99,105,116,97,116,105,111,110,0,0,0,0,0,0,0,0,99,111,109,112,117,116,101,114,32,99,111,100,101,32,102,114,97,103,109,101,110,116,0,0,99,111,108,0,0,0,0,0,116,97,98,108,101,32,99,111,108,117,109,110,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,120,122,1,0,248,212,1,0,48,213,1,0,56,213,1,0,64,213,1,0,72,213,1,0,0,0,0,0,99,111,108,103,114,111,117,112,0,0,0,0,0,0,0,0,116,97,98,108,101,32,99,111,108,117,109,110,32,103,114,111,117,112,32,0,0,0,0,0,176,190,1,0,0,0,0,0,100,101,102,105,110,105,116,105,111,110,32,100,101,115,99,114,105,112,116,105,111,110,32,0,100,101,108,101,116,101,100,32,116,101,120,116,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,200,215,1,0,136,121,1,0,0,0,0,0,105,110,115,116,97,110,99,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,100,105,114,0,0,0,0,0,100,105,114,101,99,116,111,114,121,32,108,105,115,116,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,48,122,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,120,212,1,0,0,0,0,0,0,0,0,0,103,101,110,101,114,105,99,32,108,97,110,103,117,97,103,101,47,115,116,121,108,101,32,99,111,110,116,97,105,110,101,114,0,0,0,0,0,0,0,0,48,213,1,0,0,0,0,0,100,108,0,0,0,0,0,0,100,101,102,105,110,105,116,105,111,110,32,108,105,115,116,32,0,0,0,0,0,0,0,0,176,121,1,0,152,121,1,0,0,0,0,0,0,0,0,0,120,212,1,0,0,0,0,0,100,101,102,105,110,105,116,105,111,110,32,116,101,114,109,32,0,0,0,0,0,0,0,0,101,109,112,104,97,115,105,115,0,0,0,0,0,0,0,0,101,109,98,101,100,0,0,0,103,101,110,101,114,105,99,32,101,109,98,101,100,100,101,100,32,111,98,106,101,99,116,32,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,48,213,1,0,200,214,1,0,88,213,1,0,144,121,1,0,56,214,1,0,240,214,1,0,0,213,1,0,144,215,1,0,24,214,1,0,168,212,1,0,152,215,1,0,160,215,1,0,176,215,1,0,200,213,1,0,112,212,1,0,192,215,1,0,32,214,1,0,248,212,1,0,0,0,0,0,0,0,0,0,102,105,101,108,100,115,101,116,0,0,0,0,0,0,0,0,102,111,114,109,32,99,111,110,116,114,111,108,32,103,114,111,117,112,32,0,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,40,122,1,0,108,111,99,97,108,32,99,104,97,110,103,101,32,116,111,32,102,111,110,116,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,160,213,1,0,128,215,1,0,136,215,1,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,32,102,111,114,109,32,0,0,0,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+105328),
	allocate([88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,80,122,1,0,176,119,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,96,215,1,0,104,215,1,0,216,214,1,0,168,212,1,0,232,181,1,0,248,181,1,0,112,215,1,0,0,0,0,0,0,0,0,0,88,215,1,0,0,0,0,0,115,117,98,119,105,110,100,111,119,32,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,224,214,1,0,168,212,1,0,200,213,1,0,240,214,1,0,0,215,1,0,16,215,1,0,72,215,1,0,32,215,1,0,0,0,0,0,0,0,0,0,119,105,110,100,111,119,32,115,117,98,100,105,118,105,115,105,111,110,0,0,0,0,0,0,0,120,1,0,248,119,1,0,232,119,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,136,212,1,0,144,212,1,0,192,181,1,0,200,181,1,0,0,0,0,0,0,0,0,0,104,101,97,100,105,110,103,32,0,0,0,0,0,0,0,0,100,111,99,117,109,101,110,116,32,104,101,97,100,32,0,0,216,119,1,0,168,199,1,0,224,119,1,0,16,115,1,0,24,115,1,0,200,119,1,0,208,119,1,0,72,122,1,0,0,0,0,0,0,0,0,0,216,179,1,0,216,191,1,0,64,215,1,0,0,0,0,0,104,114,0,0,0,0,0,0,104,111,114,105,122,111,110,116,97,108,32,114,117,108,101,32,0,0,0,0,0,0,0,0,48,213,1,0,56,215,1,0,160,213,1,0,248,212,1,0,0,0,0,0,0,0,0,0,100,111,99,117,109,101,110,116,32,114,111,111,116,32,101,108,101,109,101,110,116,32,0,0,168,117,1,0,160,117,1,0,0,120,1,0,0,0,0,0,216,179,1,0,216,191,1,0,0,0,0,0,0,0,0,0,48,215,1,0,0,0,0,0,105,116,97,108,105,99,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,105,110,108,105,110,101,32,115,117,98,119,105,110,100,111,119,32,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,224,214,1,0,168,212,1,0,200,213,1,0,240,214,1,0,0,215,1,0,16,215,1,0,32,215,1,0,48,213,1,0,0,213,1,0,248,212,1,0,0,0,0,0,0,0,0,0,105,109,103,0,0,0,0,0,101,109,98,101,100,100,101,100,32,105,109,97,103,101,32,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,224,214,1,0,168,212,1,0,0,213,1,0,248,212,1,0,112,214,1,0,208,214,1,0,0,0,0,0,200,213,1,0,200,214,1,0,0,0,0,0,0,0,0,0,105,110,112,117,116,0,0,0,102,111,114,109,32,99,111,110,116,114,111,108,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,112,212,1,0,168,212,1,0,232,213,1,0,176,214,1,0,176,212,1,0,192,212,1,0,160,213,1,0,184,214,1,0,200,213,1,0,200,214,1,0,112,214,1,0,208,214,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,16,182,1,0,0,182,1,0,216,214,1,0,0,0,0,0,0,0,0,0,105,110,115,101,114,116,101,100,32,116,101,120,116,0,0,0,105,115,105,110,100,101,120,0,115,105,110,103,108,101,32,108,105,110,101,32,112,114,111,109,112,116,32,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,168,214,1,0,0,0,0,0,116,101,120,116,32,116,111,32,98,101,32,101,110,116,101,114,101,100,32,98,121,32,116,104,101,32,117,115,101,114,0,0,102,111,114,109,32,102,105,101,108,100,32,108,97,98,101,108,32,116,101,120,116,32,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,224,213,1,0,224,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,102,105,101,108,100,115,101,116,32,108,101,103,101,110,100,32,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,224,212,1,0,0,0,0,0,0,0,0,0,108,105,115,116,32,105,116,101,109,32,0,0,0,0,0,0,97,32,109,101,100,105,97,45,105,110,100,101,112,101,110,100,101,110,116,32,108,105,110,107,32,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,96,114,1,0,128,214,1,0,136,214,1,0,112,212,1,0,152,214,1,0,160,214,1,0,152,213,1,0,0,0,0,0,0,0,0,0,109,97,112,0,0,0,0,0,99,108,105,101,110,116,45,115,105,100,101,32,105,109,97,103,101,32,109,97,112,32,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,184,185,1,0,0,0,0,0,168,212,1,0,0,0,0,0,109,101,110,117,0,0,0,0,109,101,110,117,32,108,105,115,116,32,0,0,0,0,0,0,103,101,110,101,114,105,99,32,109,101,116,97,105,110,102,111,114,109,97,116,105,111,110,32,0,0,0,0,0,0,0,0,216,179,1,0,216,191,1,0,80,126,1,0,168,212,1,0,120,214,1,0,96,114,1,0,0,0,0,0,0,0,0,0,112,126,1,0,0,0,0,0,97,108,116,101,114,110,97,116,101,32,99,111,110,116,101,110,116,32,99,111,110,116,97,105,110,101,114,32,102,111,114,32,110,111,110,32,102,114,97,109,101,45,98,97,115,101,100,32,114,101,110,100,101,114,105,110,103,32,0,0,0,0,0,0,160,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,0,0,0,0,0,0,0,0,97,108,116,101,114,110,97,116,101,32,99,111,110,116,101,110,116,32,99,111,110,116,97,105,110,101,114,32,102,111,114,32,110,111,110,32,115,99,114,105,112,116,45,98,97,115,101,100,32,114,101,110,100,101,114,105,110,103,32,0,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,160,206,1,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,40,214,1,0,48,214,1,0,56,214,1,0,72,214,1,0,112,212,1,0,80,214,1,0,96,214,1,0,104,214,1,0,0,213,1,0,248,212,1,0,112,214,1,0,168,212,1,0,208,212,1,0,0,0,0,0,0,0,0,0,48,213,1,0,88,213,1,0,24,214,1,0,32,214,1,0,0,0,0,0,0,0,0,0,111,108,0,0,0,0,0,0,111,114,100,101,114,101,100,32,108,105,115,116,32,0,0,0,48,122,1,0,0,0,0,0,112,212,1,0,120,212,1,0,16,214,1,0,0,0,0,0,111,112,116,103,114,111,117,112,0,0,0,0,0,0,0,0,111,112,116,105,111,110,32,103,114,111,117,112,32,0,0,0,200,205,1,0,0,0,0,0,111,112,116,105,111,110,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,176,212,1,0,0,0,0,0,0,0,0,0,32,122,1,0,0,0,0,0,115,101,108,101,99,116,97,98,108,101,32,99,104,111,105,99,101,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,176,212,1,0,32,122,1,0,0,214,1,0,232,213,1,0,0,0,0,0,112,97,114,97,103,114,97,112,104,32,0,0,0,0,0,0,112,97,114,97,109,0,0,0,110,97,109,101,100,32,112,114,111,112,101,114,116,121,32,118,97,108,117,101,32,0,0,0,152,212,1,0,232,213,1,0,240,213,1,0,112,212,1,0,0,0,0,0,0,0,0,0,112,114,101,102,111,114,109,97,116,116,101,100,32,116,101,120,116,32,0,0,0,0,0,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,32,121,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,120,122,1,0,80,121,1,0,8,122,1,0,0,0,0,0,0,0,0,0,248,212,1,0,0,0,0,0,115,104,111,114,116,32,105,110,108,105,110,101,32,113,117,111,116,97,116,105,111,110,32,0,115,116,114,105,107,101,45,116,104,114,111,117,103,104,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,115,97,109,112,108,101,32,112,114,111,103,114,97,109,32,111,117,116,112,117,116,44,32,115,99,114,105,112,116,115,44,32,101,116,99,46,0,0,0,0,115,99,114,105,112,116,32,115,116,97,116,101,109,101,110,116,115,32,0,0,0,0,0,0,96,114,1,0,200,213,1,0,208,213,1,0,216,213,1,0,224,213,1,0,0,0,0,0,184,213,1,0,0,0,0,0,112,212,1,0,0,0,0,0,115,101,108,101,99,116,0,0,111,112,116,105,111,110,32,115,101,108,101,99,116,111,114,32,0,0,0,0,0,0,0,0,160,205,1,0,200,205,1,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,168,212,1,0,160,213,1,0,168,213,1,0,176,212,1,0,208,212,1,0,216,181,1,0,224,181,1,0,0,182,1,0,0,0,0,0,115,109,97,108,108,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,0,103,101,110,101,114,105,99,32,108,97,110,103,117,97,103,101,47,115,116,121,108,101,32,99,111,110,116,97,105,110,101,114,32,0,0,0,0,0,0,0,115,116,114,105,107,101,45,116,104,114,111,117,103,104,32,116,101,120,116,0,0,0,0,0,115,116,114,111,110,103,32,101,109,112,104,97,115,105,115,0,115,116,121,108,101,32,105,110,102,111,32,0,0,0,0,0,216,179,1,0,216,191,1,0,152,213,1,0,216,119,1,0,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,0,0,0,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,0,0,0,0,120,121,1,0,176,190,1,0,32,191,1,0,128,118,1,0,144,118,1,0,136,118,1,0,120,118,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,80,213,1,0,248,212,1,0,88,213,1,0,248,119,1,0,96,213,1,0,104,213,1,0,120,213,1,0,136,213,1,0,0,0,0,0,48,213,1,0,128,212,1,0,0,0,0,0,0,0,0,0,116,97,98,108,101,32,98,111,100,121,32,0,0,0,0,0,120,118,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,48,213,1,0,56,213,1,0,64,213,1,0,72,213,1,0,0,0,0,0,116,97,98,108,101,32,100,97,116,97,32,99,101,108,108,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,40,121,1,0,8,213,1,0,16,213,1,0,24,213,1,0,32,213,1,0,40,213,1,0,48,213,1,0,56,213,1,0,64,213,1,0,72,213,1,0,0,0,0,0,240,212,1,0,128,212,1,0,248,212,1,0,0,213,1,0,0,0,0,0,0,0,0,0,116,101,120,116,97,114,101,97,0,0,0,0,0,0,0,0,109,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,102,105,101,108,100,32,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,168,212,1,0,176,212,1,0,192,212,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,16,182,1,0,0,182,1,0,0,0,0,0,0,0,0,0,136,212,1,0,144,212,1,0,0,0,0,0,0,0,0,0,116,97,98,108,101,32,102,111,111,116,101,114,32,0,0,0,116,97,98,108,101,32,104,101,97,100,101,114,32,99,101,108,108,0,0,0,0,0,0,0,116,97,98,108,101,32,104,101,97,100,101,114,32,0,0,0,100,111,99,117,109,101,110,116,32,116,105,116,108,101,32,0,116,97,98,108,101,32,114,111,119,32,0,0,0,0,0,0,112,118,1,0,104,118,1,0,0,0,0,0,0,0,0,0,128,212,1,0,0,0,0,0,116,101,108,101,116,121,112,101,32,111,114,32,109,111,110,111,115,112,97,99,101,100,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,117,110,100,101,114,108,105,110,101,100,32,116,101,120,116,32,115,116,121,108,101,0,0,0,117,108,0,0,0,0,0,0,117,110,111,114,100,101,114,101,100,32,108,105,115,116,32,0,112,212,1,0,120,212,1,0,0,0,0,0,0,0,0,0,105,110,115,116,97,110,99,101,32,111,102,32,97,32,118,97,114,105,97,98,108,101,32,111,114,32,112,114,111,103,114,97,109,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,116,121,112,101,0,0,0,0,99,111,109,112,97,99,116,0,98,103,99,111,108,111,114,0,114,111,119,115,0,0,0,0,99,111,108,115,0,0,0,0,105,100,0,0,0,0,0,0,99,108,97,115,115,0,0,0,110,97,109,101,0,0,0,0,100,105,115,97,98,108,101,100,0,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,97,98,105,110,100,101,120,0,0,0,0,0,0,0,0,97,99,99,101,115,115,107,101,121,0,0,0,0,0,0,0,110,111,119,114,97,112,0,0,119,105,100,116,104,0,0,0,104,101,105,103,104,116,0,0,97,120,105,115,0,0,0,0,104,101,97,100,101,114,115,0,115,99,111,112,101,0,0,0,114,111,119,115,112,97,110,0,99,111,108,115,112,97,110,0,97,108,105,103,110,0,0,0,99,104,97,114,0,0,0,0,99,104,97,114,111,102,102,0,118,97,108,105,103,110,0,0,115,117,109,109,97,114,121,0,98,111,114,100,101,114,0,0,114,117,108,101,115,0,0,0,99,101,108,108,115,112,97,99,105,110,103,0,0,0,0,0,99,101,108,108,112,97,100,100,105,110,103,0,0,0,0,0,100,97,116,97,112,97,103,101,115,105,122,101,0,0,0,0,109,101,100,105,97,0,0,0,115,105,122,101,0,0,0,0,109,117,108,116,105,112,108,101,0,0,0,0,0,0,0,0,108,97,110,103,117,97,103,101,0,0,0,0,0,0,0,0,115,114,99,0,0,0,0,0,100,101,102,101,114,0,0,0,101,118,101,110,116,0,0,0,102,111,114,0,0,0,0,0,118,97,108,117,101,0,0,0,118,97,108,117,101,116,121,112,101,0,0,0,0,0,0,0,115,101,108,101,99,116,101,100,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,104,115,112,97,99,101,0,0,118,115,112,97,99,101,0,0,100,101,99,108,97,114,101,0,99,108,97,115,115,105,100,0,99,111,100,101,98,97,115,101,0,0,0,0,0,0,0,0,100,97,116,97,0,0,0,0,99,111,100,101,116,121,112,101,0,0,0,0,0,0,0,0,97,114,99,104,105,118,101,0,115,116,97,110,100,98,121,0,117,115,101,109,97,112,0,0,115,99,104,101,109,101,0,0,104,114,101,102,0,0,0,0,104,114,101,102,108,97,110,103,0,0,0,0,0,0,0,0,114,101,108,0,0,0,0,0,114,101,118,0,0,0,0,0,112,114,111,109,112,116,0,0,99,104,101,99,107,101,100,0,109,97,120,108,101,110,103,116,104,0,0,0,0,0,0,0,97,108,116,0,0,0,0,0,105,115,109,97,112,0,0,0,97,99,99,101,112,116,0,0,108,111,110,103,100,101,115,99,0,0,0,0,0,0,0,0,102,114,97,109,101,98,111,114,100,101,114,0,0,0,0,0,109,97,114,103,105,110,119,105,100,116,104,0,0,0,0,0,109,97,114,103,105,110,104,101,105,103,104,116,0,0,0,0,115,99,114,111,108,108,105,110,103,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,110,111,115,104,97,100,101,0,112,114,111,102,105,108,101,0,110,111,114,101,115,105,122,101,0,0,0,0,0,0,0,0,97,99,116,105,111,110,0,0,109,101,116,104,111,100,0,0,101,110,99,116,121,112,101,0,97,99,99,101,112,116,45,99,104,97,114,115,101,116,0,0,99,111,108,111,114,0,0,0,102,97,99,101,0,0,0,0,104,105,100,100,101,110,0,0,112,97,108,101,116,116,101,0,112,108,117,103,105,110,115,112,97,99,101,0,0,0,0,0,112,108,117,103,105,110,117,114,108,0,0,0,0,0,0,0,117,110,105,116,115,0,0,0,100,97,116,101,116,105,109,101,0,0,0,0,0,0,0,0,99,108,101,97,114,0,0,0,98,97,99,107,103,114,111,117,110,100,0,0,0,0,0,0,116,101,120,116,0,0,0,0,118,108,105,110,107,0,0,0,97,108,105,110,107,0,0,0,115,104,97,112,101,0,0,0,99,111,111,114,100,115,0,0,110,111,104,114,101,102,0,0,116,97,114,103,101,116,0,0,108,105,115,116,105,110,103,0,120,109,112,0,0,0,0,0,104,116,109,108,0,0,0,0,104,101,97,100,0,0,0,0,109,101,116,97,0,0,0,0,104,116,116,112,45,101,113,117,105,118,0,0,0,0,0,0,67,111,110,116,101,110,116,45,84,121,112,101,0,0,0,0,99,111,110,116,101,110,116,0,99,104,97,114,115,101,116,61,0,0,0,0,0,0,0,0,67,104,97,114,115,101,116,61,0,0,0,0,0,0,0,0,67,72,65,82,83,69,84,61,0,0,0,0,0,0,0,0,99,104,97,114,115,101,116,32,61,0,0,0,0,0,0,0,67,104,97,114,115,101,116,32,61,0,0,0,0,0,0,0,67,72,65,82,83,69,84,32,61,0,0,0,0,0,0,0,116,101,120,116,47,104,116,109,108,59,32,99,104,97,114,115,101,116,61,37,115,0,0,0,200,218,1,0,208,218,1,0,216,218,1,0,224,218,1,0,232,218,1,0,248,218,1,0,0,219,1,0,16,219,1,0,24,219,1,0,40,219,1,0,48,219,1,0,56,219,1,0,72,219,1,0,0,0,0,0,72,84,77,76,0,0,0,0,97,115,99,105,105,0,0,0,115,99,114,105,112,116,0,0,115,116,121,108,101,0,0,0,60,33,45,45,0,0,0,0,45,45,62,0,0,0,0,0,60,63,0,0,0,0,0,0,32,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,98,111,100,121,0,0,0,0,62,60,47,0,0,0,0,0,60,47,0,0,0,0,0,0,85,84,70,45,56,0,0,0,60,33,68,79,67,84,89,80,69,32,0,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,62,10,0,0,0,0,0,0,61,0,0,0,0,0,0,0,104,114,101,102,0,0,0,0,97,99,116,105,111,110,0,0,115,114,99,0,0,0,0,0,110,97,109,101,0,0,0,0,97,0,0,0,0,0,0,0,34,0,0,0,0,0,0,0,64,47,58,61,63,59,35,37,38,44,43,0,0,0,0,0,61,34,34,0,0,0,0,0,115,116,114,105,110,103,32,105,115,32,110,111,116,32,105,110,32,85,84,70,45,56,10,0,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,32,37,115,10,0,0,0,0,72,84,77,76,32,104,97,115,32,110,111,32,68,79,67,84,89,80,69,10,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,32,110,117,109,98,101,114,10,0,0,0,0,0,0,0,0,99,104,101,99,107,101,100,0,99,111,109,112,97,99,116,0,100,101,99,108,97,114,101,0,100,101,102,101,114,0,0,0,100,105,115,97,98,108,101,100,0,0,0,0,0,0,0,0,105,115,109,97,112,0,0,0,109,117,108,116,105,112,108,101,0,0,0,0,0,0,0,0,110,111,104,114,101,102,0,0,110,111,114,101,115,105,122,101,0,0,0,0,0,0,0,0,110,111,115,104,97,100,101,0,110,111,119,114,97,112,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,115,101,108,101,99,116,101,100,0,0,0,0,0,0,0,0,40,78,85,76,76,41,0,0,35,37,88,0,0,0,0,0,46,46,46,0,0,0,0,0,78,85,76,76,10,0,0,0,45,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,101,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,99,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,70,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,32,37,56,100,32,0,0,0,37,115,58,0,0,0,0,0,37,115,0,0,0,0,0,0,100,101,102,97,117,108,116,32,45,62,32,37,115,0,0,0,37,115,32,45,62,32,37,115,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,37,115,58,32,110,111,32,115,117,99,104,32,110,111,100,101,10,0,0,0,0,0,0,0,37,115,32,105,115,32,97,32,66,111,111,108,101,97,110,10,0,0,0,0,0,0,0,0,37,115,32,105,115,32,97,32,110,117,109,98,101,114,10,0,37,115,32,105,115,32,97,32,115,116,114,105,110,103,10,0,37,115,32,105,115,32,97,32,112,111,105,110,116,10,0,0,37,115,32,105,115,32,97,32,114,97,110,103,101,10,0,0,37,115,32,105,115,32,117,115,101,114,45,100,101,102,105,110,101,100,10,0,0,0,0,0,37,115,32,105,115,32,97,110,32,88,83,76,84,32,118,97,108,117,101,32,116,114,101,101,10,0,0,0,0,0,0,0,32,78,111,32,98,97,115,101,32,102,111,117,110,100,32,33,33,33,10,0,0,0,0,0,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,119,114,105,116,101,32,116,111,32,37,115,10,0,0,119,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,97,118,101,32,116,111,32,37,115,10,0,0,0,84,111,32,115,97,118,101,32,116,111,32,115,117,98,112,97,114,116,115,32,111,102,32,97,32,100,111,99,117,109,101,110,116,32,117,115,101,32,116,104,101,32,39,119,114,105,116,101,39,32,99,111,109,109,97,110,100,10,0,0,0,0,0,0,47,10,0,0,0,0,0,0,32,32,0,0,0,0,0,0,37,115,32,62,32,0,0,0,47,0,0,0,0,0,0,0,37,115,58,37,115,32,62,32,0,0,0,0,0,0,0,0,63,32,62,32,0,0,0,0,101,120,105,116,0,0,0,0,113,117,105,116,0,0,0,0,98,121,101,0,0,0,0,0,104,101,108,112,0,0,0,0,9,98,97,115,101,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,88,77,76,32,98,97,115,101,32,111,102,32,116,104,101,32,110,111,100,101,10,0,0,0,0,0,9,115,101,116,98,97,115,101,32,85,82,73,32,32,99,104,97,110,103,101,32,116,104,101,32,88,77,76,32,98,97,115,101,32,111,102,32,116,104,101,32,110,111,100,101,10,0,0,9,98,121,101,32,32,32,32,32,32,32,32,32,32,108,101,97,118,101,32,115,104,101,108,108,10,0,0,0,0,0,0,9,99,97,116,32,91,110,111,100,101,93,32,32,32,100,105,115,112,108,97,121,32,110,111,100,101,32,111,114,32,99,117,114,114,101,110,116,32,110,111,100,101,10,0,0,0,0,0,9,99,100,32,91,112,97,116,104,93,32,32,32,32,99,104,97,110,103,101,32,100,105,114,101,99,116,111,114,121,32,116,111,32,112,97,116,104,32,111,114,32,116,111,32,114,111,111,116,10,0,0,0,0,0,0,9,100,105,114,32,91,112,97,116,104,93,32,32,32,100,117,109,112,115,32,105,110,102,111,114,109,97,116,105,111,110,115,32,97,98,111,117,116,32,116,104,101,32,110,111,100,101,32,40,110,97,109,101,115,112,97,99,101,44,32,97,116,116,114,105,98,117,116,101,115,44,32,99,111,110,116,101,110,116,41,10,0,0,0,0,0,0,0,9,100,117,32,91,112,97,116,104,93,32,32,32,32,115,104,111,119,32,116,104,101,32,115,116,114,117,99,116,117,114,101,32,111,102,32,116,104,101,32,115,117,98,116,114,101,101,32,117,110,100,101,114,32,112,97,116,104,32,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,110,111,100,101,10,0,9,101,120,105,116,32,32,32,32,32,32,32,32,32,108,101,97,118,101,32,115,104,101,108,108,10,0,0,0,0,0,0,9,104,101,108,112,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,116,104,105,115,32,104,101,108,112,10,0,0,0,0,0,0,0,0,9,102,114,101,101,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,109,101,109,111,114,121,32,117,115,97,103,101,10,0,0,0,0,0,9,108,111,97,100,32,91,110,97,109,101,93,32,32,108,111,97,100,32,97,32,110,101,119,32,100,111,99,117,109,101,110,116,32,119,105,116,104,32,110,97,109,101,10,0,0,0,0,9,108,115,32,91,112,97,116,104,93,32,32,32,32,108,105,115,116,32,99,111,110,116,101,110,116,115,32,111,102,32,112,97,116,104,32,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,100,105,114,101,99,116,111,114,121,10,0,0,0,9,115,101,116,32,120,109,108,95,102,114,97,103,109,101,110,116,32,114,101,112,108,97,99,101,32,116,104,101,32,99,117,114,114,101,110,116,32,110,111,100,101,32,99,111,110,116,101,110,116,32,119,105,116,104,32,116,104,101,32,102,114,97,103,109,101,110,116,32,112,97,114,115,101,100,32,105,110,32,99,111,110,116,101,120,116,10,0,9,120,112,97,116,104,32,101,120,112,114,32,32,32,101,118,97,108,117,97,116,101,32,116,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,105,110,32,116,104,97,116,32,99,111,110,116,101,120,116,32,97,110,100,32,112,114,105,110,116,32,116,104,101,32,114,101,115,117,108,116,10,0,0,0,0,0,0,0,9,115,101,116,110,115,32,110,115,114,101,103,32,32,114,101,103,105,115,116,101,114,32,97,32,110,97,109,101,115,112,97,99,101,32,116,111,32,97,32,112,114,101,102,105,120,32,105,110,32,116,104,101,32,88,80,97,116,104,32,101,118,97,108,117,97,116,105,111,110,32,99,111,110,116,101,120,116,10,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,102,111,114,109,97,116,32,102,111,114,32,110,115,114,101,103,32,105,115,58,32,112,114,101,102,105,120,61,91,110,115,117,114,105,93,32,40,105,46,101,46,32,112,114,101,102,105,120,61,32,117,110,115,101,116,115,32,97,32,112,114,101,102,105,120,41,10,0,0,0,0,0,0,0,9,115,101,116,114,111,111,116,110,115,32,32,32,32,114,101,103,105,115,116,101,114,32,97,108,108,32,110,97,109,101,115,112,97,99,101,32,102,111,117,110,100,32,111,110,32,116,104,101,32,114,111,111,116,32,101,108,101,109,101,110,116,10,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,116,104,101,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,105,102,32,97,110,121,32,117,115,101,115,32,39,100,101,102,97,117,108,116,110,115,39,32,112,114,101,102,105,120,10,0,0,0,0,0,9,112,119,100,32,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,99,117,114,114,101,110,116,32,119,111,114,107,105,110,103,32,100,105,114,101,99,116,111,114,121,10,0,0,0,0,0,0,0,0,9,119,104,101,114,101,105,115,32,32,32,32,32,32,100,105,115,112,108,97,121,32,97,98,115,111,108,117,116,101,32,112,97,116,104,32,111,102,32,91,112,97,116,104,93,32,111,114,32,99,117,114,114,101,110,116,32,119,111,114,107,105,110,103,32,100,105,114,101,99,116,111,114,121,10,0,0,0,0,0,9,113,117,105,116,32,32,32,32,32,32,32,32,32,108,101,97,118,101,32,115,104,101,108,108,10,0,0,0,0,0,0,9,115,97,118,101,32,91,110,97,109,101,93,32,32,115,97,118,101,32,116,104,105,115,32,100,111,99,117,109,101,110,116,32,116,111,32,110,97,109,101,32,111,114,32,116,104,101,32,111,114,105,103,105,110,97,108,32,110,97,109,101,10,0,0,9,119,114,105,116,101,32,91,110,97,109,101,93,32,119,114,105,116,101,32,116,104,101,32,99,117,114,114,101,110,116,32,110,111,100,101,32,116,111,32,116,104,101,32,102,105,108,101,110,97,109,101,10,0,0,0,9,118,97,108,105,100,97,116,101,32,32,32,32,32,99,104,101,99,107,32,116,104,101,32,100,111,99,117,109,101,110,116,32,102,111,114,32,101,114,114,111,114,115,10,0,0,0,0,9,114,101,108,97,120,110,103,32,114,110,103,32,32,118,97,108,105,100,97,116,101,32,116,104,101,32,100,111,99,117,109,101,110,116,32,97,103,97,105,115,110,116,32,116,104,101,32,82,101,108,97,120,45,78,71,32,115,99,104,101,109,97,115,10,0,0,0,0,0,0,0,9,103,114,101,112,32,115,116,114,105,110,103,32,32,115,101,97,114,99,104,32,102,111,114,32,97,32,115,116,114,105,110,103,32,105,110,32,116,104,101,32,115,117,98,116,114,101,101,10,0,0,0,0,0,0,0,118,97,108,105,100,97,116,101,0,0,0,0,0,0,0,0,108,111,97,100,0,0,0,0,114,101,108,97,120,110,103,0,115,97,118,101,0,0,0,0,119,114,105,116,101,0,0,0,87,114,105,116,101,32,99,111,109,109,97,110,100,32,114,101,113,117,105,114,101,115,32,97,32,102,105,108,101,110,97,109,101,32,97,114,103,117,109,101,110,116,10,0,0,0,0,0,103,114,101,112,0,0,0,0,102,114,101,101,0,0,0,0,37,100,0,0,0,0,0,0,112,119,100,0,0,0,0,0,100,117,0,0,0,0,0,0,98,97,115,101,0,0,0,0,115,101,116,0,0,0,0,0,115,101,116,110,115,0,0,0,115,101,116,110,115,58,32,112,114,101,102,105,120,61,91,110,115,117,114,105,93,32,114,101,113,117,105,114,101,100,10,0,115,101,116,114,111,111,116,110,115,0,0,0,0,0,0,0,120,112,97,116,104,0,0,0,120,112,97,116,104,58,32,101,120,112,114,101,115,115,105,111,110,32,114,101,113,117,105,114,101,100,10,0,0,0,0,0,115,101,116,98,97,115,101,0,108,115,0,0,0,0,0,0,100,105,114,0,0,0,0,0,119,104,101,114,101,105,115,0,99,100,0,0,0,0,0,0,99,97,110,110,111,116,32,99,100,32,116,111,32,110,97,109,101,115,112,97,99,101,10,0,37,115,32,105,115,32,97,32,37,100,32,78,111,100,101,32,83,101,116,10,0,0,0,0,37,115,32,105,115,32,97,110,32,101,109,112,116,121,32,78,111,100,101,32,83,101,116,10,0,0,0,0,0,0,0,0,99,97,116,0,0,0,0,0,32,45,45,45,45,45,45,45,10,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,99,111,109,109,97,110,100,32,37,115,10,0,0,0,0,0,100,101,102,97,117,108,116,110,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,117,110,97,98,108,101,32,116,111,32,114,101,103,105,115,116,101,114,32,78,83,32,119,105,116,104,32,112,114,101,102,105,120,61,34,37,115,34,32,97,110,100,32,104,114,101,102,61,34,37,115,34,10,0,0,0,0,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,0,0,37,115,32,58,32,0,0,0,82,101,108,97,120,45,78,71,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,37,115,32,118,97,108,105,100,97,116,101,115,10,0,0,0,37,115,32,102,97,105,108,115,32,116,111,32,118,97,108,105,100,97,116,101,10,0,0,0,37,115,32,118,97,108,105,100,97,116,105,111,110,32,103,101,110,101,114,97,116,101,100,32,97,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,10,0,0,0,0,0,0,68,84,68,32,110,111,100,101,32,105,115,32,78,85,76,76,10,0,0,0,0,0,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,32,68,84,68,0,0,0,0,0,0,0,68,84,68,40,37,115,41,0,68,84,68,0,0,0,0,0,44,32,80,85,66,76,73,67,32,37,115,0,0,0,0,0,44,32,83,89,83,84,69,77,32,37,115,0,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,112,97,114,101,110,116,10,0,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,100,111,99,10,0,0,0,0,0,0,0,0,112,115,101,117,100,111,114,111,111,116,0,0,0,0,0,0,78,111,100,101,32,100,111,99,32,100,105,102,102,101,114,115,32,102,114,111,109,32,112,97,114,101,110,116,39,115,32,111,110,101,10,0,0,0,0,0,65,116,116,114,32,104,97,115,32,110,111,32,112,114,101,118,32,97,110,100,32,110,111,116,32,102,105,114,115,116,32,111,102,32,97,116,116,114,32,108,105,115,116,10,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,112,114,101,118,32,97,110,100,32,110,111,116,32,102,105,114,115,116,32,111,102,32,112,97,114,101,110,116,32,108,105,115,116,10,0,0,78,111,100,101,32,112,114,101,118,45,62,110,101,120,116,32,58,32,98,97,99,107,32,108,105,110,107,32,119,114,111,110,103,10,0,0,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,110,101,120,116,32,97,110,100,32,110,111,116,32,108,97,115,116,32,111,102,32,112,97,114,101,110,116,32,108,105,115,116,10,0,0,0,78,111,100,101,32,110,101,120,116,45,62,112,114,101,118,32,58,32,102,111,114,119,97,114,100,32,108,105,110,107,32,119,114,111,110,103,10,0,0,0,110,98,107,116,101,120,116,0,84,101,120,116,32,110,111,100,101,32,104,97,115,32,119,114,111,110,103,32,110,97,109,101,32,39,37,115,39,0,0,0,67,111,109,109,101,110,116,32,110,111,100,101,32,104,97,115,32,119,114,111,110,103,32,110,97,109,101,32,39,37,115,39,0,0,0,0,0,0,0,0,67,68,97,116,97,32,115,101,99,116,105,111,110,32,104,97,115,32,110,111,110,32,78,85,76,76,32,110,97,109,101,32,39,37,115,39,0,0,0,0,78,97,109,101,32,105,115,32,78,85,76,76,0,0,0,0,78,97,109,101,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,32,39,37,115,39,0,0,0,0,0,0,78,97,109,101,32,105,115,32,110,111,116,32,102,114,111,109,32,116,104,101,32,100,111,99,117,109,101,110,116,32,100,105,99,116,105,111,110,110,97,114,121,32,39,37,115,39,0,0,83,116,114,105,110,103,32,105,115,32,110,111,116,32,85,84,70,45,56,32,37,115,0,0,82,101,102,101,114,101,110,99,101,32,116,111,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,110,111,116,32,105,110,32,115,99,111,112,101,10,0,0,0,0,82,101,102,101,114,101,110,99,101,32,116,111,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,110,111,116,32,105,110,32,115,99,111,112,101,10,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,32,116,111,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,110,111,116,32,111,110,32,97,110,99,101,115,116,111,114,10,0,82,101,102,101,114,101,110,99,101,32,116,111,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,110,111,116,32,111,110,32,97,110,99,101,115,116,111,114,10,0,0,0,0,68,79,67,85,77,69,78,84,32,61,61,32,78,85,76,76,32,33,10,0,0,0,0,0,110,97,109,101,61,0,0,0,118,101,114,115,105,111,110,61,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,61,0,0,0,0,0,0,0,85,82,76,61,0,0,0,0,115,116,97,110,100,97,108,111,110,101,61,116,114,117,101,10,0,0,0,0,0,0,0,0,110,97,109,101,115,112,97,99,101,32,110,111,100,101,32,105,115,32,78,85,76,76,10,0,78,111,100,101,32,105,115,32,110,111,116,32,97,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,73,110,99,111,109,112,108,101,116,101,32,110,97,109,101,115,112,97,99,101,32,37,115,32,104,114,101,102,61,78,85,76,76,10,0,0,0,0,0,0,73,110,99,111,109,112,108,101,116,101,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,104,114,101,102,61,78,85,76,76,10,0,110,97,109,101,115,112,97,99,101,32,37,115,32,104,114,101,102,61,0,0,0,0,0,0,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,104,114,101,102,61,0,77,105,115,112,108,97,99,101,100,32,69,76,69,77,69,78,84,32,110,111,100,101,10,0,77,105,115,112,108,97,99,101,100,32,65,84,84,82,73,66,85,84,69,32,110,111,100,101,10,0,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,84,69,88,84,32,110,111,100,101,10,0,0,0,0,77,105,115,112,108,97,99,101,100,32,67,68,65,84,65,32,110,111,100,101,10,0,0,0,77,105,115,112,108,97,99,101,100,32,69,78,84,73,84,89,82,69,70,32,110,111,100,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+115568),
	allocate([10,0,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,69,78,84,73,84,89,32,110,111,100,101,10,0,0,77,105,115,112,108,97,99,101,100,32,80,73,32,110,111,100,101,10,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,67,79,77,77,69,78,84,32,110,111,100,101,10,0,68,79,67,85,77,69,78,84,10,0,0,0,0,0,0,0,72,84,77,76,32,68,79,67,85,77,69,78,84,10,0,0,77,105,115,112,108,97,99,101,100,32,68,79,67,84,89,80,69,32,110,111,100,101,10,0,77,105,115,112,108,97,99,101,100,32,70,82,65,71,77,69,78,84,32,110,111,100,101,10,0,0,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,78,79,84,65,84,73,79,78,32,110,111,100,101,10,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,110,111,100,101,32,116,121,112,101,32,37,100,10,0,0,0,110,111,100,101,32,105,115,32,78,85,76,76,10,0,0,0,69,76,69,77,69,78,84,32,0,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,69,114,114,111,114,44,32,65,84,84,82,73,66,85,84,69,32,102,111,117,110,100,32,104,101,114,101,10,0,0,0,0,84,69,88,84,32,110,111,32,101,110,99,0,0,0,0,0,84,69,88,84,0,0,0,0,32,99,111,109,112,97,99,116,10,0,0,0,0,0,0,0,32,105,110,116,101,114,110,101,100,10,0,0,0,0,0,0,67,68,65,84,65,95,83,69,67,84,73,79,78,10,0,0,69,78,84,73,84,89,95,82,69,70,40,37,115,41,10,0,69,78,84,73,84,89,10,0,80,73,32,37,115,10,0,0,67,79,77,77,69,78,84,10,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,68,79,67,85,77,69,78,84,32,102,111,117,110,100,32,104,101,114,101,10,0,0,0,0,0,68,79,67,85,77,69,78,84,95,84,89,80,69,10,0,0,68,79,67,85,77,69,78,84,95,70,82,65,71,10,0,0,78,79,84,65,84,73,79,78,10,0,0,0,0,0,0,0,73,78,67,76,85,68,69,32,83,84,65,82,84,10,0,0,73,78,67,76,85,68,69,32,69,78,68,10,0,0,0,0,80,66,77,58,32,100,111,99,32,61,61,32,78,85,76,76,32,33,33,33,10,0,0,0,99,111,110,116,101,110,116,61,0,0,0,0,0,0,0,0,69,110,116,105,116,121,32,105,115,32,78,85,76,76,10,0,73,78,84,69,82,78,65,76,95,71,69,78,69,82,65,76,95,69,78,84,73,84,89,32,0,0,0,0,0,0,0,0,69,88,84,69,82,78,65,76,95,71,69,78,69,82,65,76,95,80,65,82,83,69,68,95,69,78,84,73,84,89,32,0,69,88,84,69,82,78,65,76,95,71,69,78,69,82,65,76,95,85,78,80,65,82,83,69,68,95,69,78,84,73,84,89,32,0,0,0,0,0,0,0,73,78,84,69,82,78,65,76,95,80,65,82,65,77,69,84,69,82,95,69,78,84,73,84,89,32,0,0,0,0,0,0,69,88,84,69,82,78,65,76,95,80,65,82,65,77,69,84,69,82,95,69,78,84,73,84,89,32,0,0,0,0,0,0,69,78,84,73,84,89,95,37,100,32,33,32,0,0,0,0,69,120,116,101,114,110,97,108,73,68,61,37,115,10,0,0,83,121,115,116,101,109,73,68,61,37,115,10,0,0,0,0,85,82,73,61,37,115,10,0,69,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,78,85,76,76,10,0,0,0,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,110,32,101,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,0,69,78,84,73,84,89,68,69,67,76,40,0,0,0,0,0,41,0,0,0,0,0,0,0,69,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,0,0,44,32,105,110,116,101,114,110,97,108,10,0,0,0,0,0,44,32,101,120,116,101,114,110,97,108,32,112,97,114,115,101,100,10,0,0,0,0,0,0,44,32,117,110,112,97,114,115,101,100,10,0,0,0,0,0,44,32,112,97,114,97,109,101,116,101,114,10,0,0,0,0,44,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,10,0,0,0,44,32,112,114,101,100,101,102,105,110,101,100,10,0,0,0,32,69,120,116,101,114,110,97,108,73,68,61,37,115,10,0,32,83,121,115,116,101,109,73,68,61,37,115,10,0,0,0,32,85,82,73,61,37,115,10,0,0,0,0,0,0,0,0,32,99,111,110,116,101,110,116,61,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,78,85,76,76,10,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,110,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,65,84,84,82,68,69,67,76,40,37,115,41,0,0,0,0,78,111,100,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,0,0,32,102,111,114,32,37,115,0,78,111,100,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,101,108,101,109,101,110,116,32,110,97,109,101,0,0,32,67,68,65,84,65,0,0,32,73,68,0,0,0,0,0,32,73,68,82,69,70,0,0,32,73,68,82,69,70,83,0,32,69,78,84,73,84,89,0,32,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,0,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,32,69,78,85,77,69,82,65,84,73,79,78,0,0,0,0,32,78,79,84,65,84,73,79,78,32,0,0,0,0,0,0,124,37,115,0,0,0,0,0,32,40,37,115,0,0,0,0,46,46,46,41,0,0,0,0,32,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,32,73,77,80,76,73,69,68,0,0,0,0,0,0,0,0,32,70,73,88,69,68,0,0,34,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,78,85,76,76,10,0,0,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,110,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,69,76,69,77,68,69,67,76,40,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,0,44,32,85,78,68,69,70,73,78,69,68,0,0,0,0,0,44,32,69,77,80,84,89,0,44,32,65,78,89,0,0,0,44,32,77,73,88,69,68,32,0,0,0,0,0,0,0,0,69,110,116,105,116,105,101,115,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,78,111,32,101,110,116,105,116,105,101,115,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,69,110,116,105,116,105,101,115,32,105,110,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,78,111,32,101,110,116,105,116,105,101,115,32,105,110,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,69,110,116,105,116,121,32,105,115,32,78,85,76,76,0,0,73,78,84,69,82,78,65,76,32,71,69,78,69,82,65,76,44,32,0,0,0,0,0,0,69,88,84,69,82,78,65,76,32,80,65,82,83,69,68,44,32,0,0,0,0,0,0,0,69,88,84,69,82,78,65,76,32,85,78,80,65,82,83,69,68,44,32,0,0,0,0,0,73,78,84,69,82,78,65,76,32,80,65,82,65,77,69,84,69,82,44,32,0,0,0,0,69,88,84,69,82,78,65,76,32,80,65,82,65,77,69,84,69,82,44,32,0,0,0,0,85,110,107,110,111,119,110,32,101,110,116,105,116,121,32,116,121,112,101,32,37,100,10,0,73,68,32,34,37,115,34,0,83,89,83,84,69,77,32,34,37,115,34,0,0,0,0,0,10,32,111,114,105,103,32,34,37,115,34,0,0,0,0,0,10,32,99,111,110,116,101,110,116,32,34,37,115,34,0,0,65,116,116,114,32,105,115,32,78,85,76,76,0,0,0,0,65,84,84,82,73,66,85,84,69,32,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,104,97,115,32,110,111,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,115,0,0,0,0,0,0,96,0,2,0,104,0,2,0,128,0,2,0,152,0,2,0,176,0,2,0,216,0,2,0,240,0,2,0,8,1,2,0,32,1,2,0,64,1,2,0,88,1,2,0,112,1,2,0,128,1,2,0,160,1,2,0,184,1,2,0,216,1,2,0,248,1,2,0,8,2,2,0,24,2,2,0,48,2,2,0,80,2,2,0,96,2,2,0,120,2,2,0,152,2,2,0,176,2,2,0,200,2,2,0,79,98,106,101,99,116,32,105,115,32,101,109,112,116,121,32,40,78,85,76,76,41,10,0,79,98,106,101,99,116,32,105,115,32,117,110,105,110,105,116,105,97,108,105,122,101,100,10,0,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,78,111,100,101,32,83,101,116,32,58,10,0,79,98,106,101,99,116,32,105,115,32,97,110,32,88,83,76,84,32,118,97,108,117,101,32,116,114,101,101,32,58,10,0,79,98,106,101,99,116,32,105,115,32,97,32,66,111,111,108,101,97,110,32,58,32,0,0,116,114,117,101,10,0,0,0,102,97,108,115,101,10,0,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,73,110,102,105,110,105,116,121,10,0,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,45,73,110,102,105,110,105,116,121,10,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,78,97,78,10,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,48,10,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,37,48,103,10,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,115,116,114,105,110,103,32,58,32,0,0,0,10,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,112,111,105,110,116,32,58,32,105,110,100,101,120,32,37,100,32,105,110,32,110,111,100,101,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,99,111,108,108,97,112,115,101,100,32,114,97,110,103,101,32,58,10,0,0,105,110,100,101,120,32,37,100,32,105,110,32,0,0,0,0,110,111,100,101,10,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,114,97,110,103,101,32,58,10,0,0,0,0,70,114,111,109,32,0,0,0,84,111,32,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,76,111,99,97,116,105,111,110,32,83,101,116,58,10,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,117,115,101,114,32,100,101,102,105,110,101,100,10,0,46,46,47,108,105,98,120,109,108,50,47,120,112,97,116,104,46,99,0,0,0,0,0,0,88,80,97,116,104,32,115,116,97,99,107,32,100,101,112,116,104,32,108,105,109,105,116,32,114,101,97,99,104,101,100,10,0,0,0,0,0,0,0,0,112,117,115,104,105,110,103,32,118,97,108,117,101,10,0,0,99,114,101,97,116,105,110,103,32,110,111,100,101,115,101,116,10,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,110,111,100,101,115,101,116,10,0,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,110,111,100,101,115,101,116,32,104,105,116,32,108,105,109,105,116,10,0,0,0,0,0,0,109,101,114,103,105,110,103,32,110,111,100,101,115,101,116,10,0,0,0,0,0,0,0,0,109,101,114,103,105,110,103,32,110,111,100,101,115,101,116,32,104,105,116,32,108,105,109,105,116,10,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,111,100,101,32,115,101,116,32,111,98,106,101,99,116,10,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,99,114,101,97,116,105,110,103,32,102,108,111,97,116,32,111,98,106,101,99,116,10,0,0,99,114,101,97,116,105,110,103,32,98,111,111,108,101,97,110,32,111,98,106,101,99,116,10,0,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,115,116,114,105,110,103,32,111,98,106,101,99,116,10,0,0,0,0,0,0,0,0,0,99,111,112,121,105,110,103,32,111,98,106,101,99,116,10,0,120,109,108,88,80,97,116,104,79,98,106,101,99,116,67,111,112,121,58,32,117,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,32,37,100,10,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,45,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,78,97,78,0,0,0,0,0,48,0,0,0,0,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,99,114,101,97,116,105,110,103,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,0,102,97,107,101,32,110,111,100,101,32,108,105,98,120,115,108,116,0,0,0,0,0,0,0,184,254,1,0,0,0,0,0,120,109,108,88,80,97,116,104,84,114,97,110,115,108,97,116,101,70,117,110,99,116,105,111,110,58,32,73,110,118,97,108,105,100,32,85,84,70,56,32,115,116,114,105,110,103,10,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,36,64,0,0,0,0,0,0,89,64,0,0,0,0,0,64,143,64,0,0,0,0,0,136,195,64,0,0,0,0,0,106,248,64,0,0,0,0,128,132,46,65,0,0,0,0,208,18,99,65,0,0,0,0,132,215,151,65,0,0,0,0,101,205,205,65,0,0,0,32,95,160,2,66,0,0,0,232,118,72,55,66,0,0,0,162,148,26,109,66,0,0,64,229,156,48,162,66,0,0,144,30,196,188,214,66,0,0,52,38,245,107,12,67,0,128,224,55,121,195,65,67,0,160,216,133,87,52,118,67,0,200,78,103,109,193,171,67,0,61,145,96,228,88,225,67,64,140,181,120,29,175,21,68,110,111,100,101,0,0,0,0,116,101,120,116,0,0,0,0,99,111,109,109,101,110,116,0,112,114,111,99,101,115,115,105,110,103,45,105,110,115,116,114,117,99,116,105,111,110,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,97,116,32,37,115,58,37,100,10,0,0,0,0,0,0,0,0,78,85,76,76,32,99,111,110,116,101,120,116,32,112,111,105,110,116,101,114,10,0,0,0,120,109,108,88,80,97,116,104,69,118,97,108,58,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,69,118,97,108,58,32,37,100,32,111,98,106,101,99,116,32,108,101,102,116,32,111,110,32,116,104,101,32,115,116,97,99,107,10,0,0,0,0,0,0,98,111,111,108,101,97,110,0,99,101,105,108,105,110,103,0,99,111,117,110,116,0,0,0,99,111,110,99,97,116,0,0,99,111,110,116,97,105,110,115,0,0,0,0,0,0,0,0,105,100,0,0,0,0,0,0,102,108,111,111,114,0,0,0,108,97,115,116,0,0,0,0,108,97,110,103,0,0,0,0,108,111,99,97,108,45,110,97,109,101,0,0,0,0,0,0,110,111,116,0,0,0,0,0,110,97,109,101,0,0,0,0,110,97,109,101,115,112,97,99,101,45,117,114,105,0,0,0,110,111,114,109,97,108,105,122,101,45,115,112,97,99,101,0,110,117,109,98,101,114,0,0,112,111,115,105,116,105,111,110,0,0,0,0,0,0,0,0,114,111,117,110,100,0,0,0,115,116,114,105,110,103,0,0,115,116,114,105,110,103,45,108,101,110,103,116,104,0,0,0,115,116,97,114,116,115,45,119,105,116,104,0,0,0,0,0,115,117,98,115,116,114,105,110,103,0,0,0,0,0,0,0,115,117,98,115,116,114,105,110,103,45,98,101,102,111,114,101,0,0,0,0,0,0,0,0,115,117,98,115,116,114,105,110,103,45,97,102,116,101,114,0,115,117,109,0,0,0,0,0,116,114,97,110,115,108,97,116,101,0,0,0,0,0,0,0,101,115,99,97,112,101,45,117,114,105,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,50,47,48,56,47,120,113,117,101,114,121,45,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,101,118,97,108,117,97,116,105,111,110,32,99,111,110,116,101,120,116,10,0,0,0,0,120,109,108,88,80,97,116,104,82,117,110,69,118,97,108,58,32,108,97,115,116,32,105,115,32,108,101,115,115,32,116,104,97,110,32,122,101,114,111,10,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,118,97,114,105,97,98,108,101,32,37,115,32,98,111,117,110,100,32,116,111,32,117,110,100,101,102,105,110,101,100,32,112,114,101,102,105,120,32,37,115,10,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,112,97,114,97,109,101,116,101,114,32,101,114,114,111,114,10,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,102,117,110,99,116,105,111,110,32,37,115,32,98,111,117,110,100,32,116,111,32,117,110,100,101,102,105,110,101,100,32,112,114,101,102,105,120,32,37,115,10,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,102,117,110,99,116,105,111,110,32,37,115,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,88,80,97,116,104,58,32,117,110,107,110,111,119,110,32,112,114,101,99,111,109,112,105,108,101,100,32,111,112,101,114,97,116,105,111,110,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,105,108,101,100,69,118,97,108,58,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,105,108,101,100,69,118,97,108,58,32,37,100,32,111,98,106,101,99,116,115,32,108,101,102,116,32,111,110,32,116,104,101,32,115,116,97,99,107,46,10,0,0,0,0,97,100,100,105,110,103,32,115,116,101,112,10,0,0,0,0,58,58,0,0,0,0,0,0,114,97,110,103,101,45,116,111,0,0,0,0,0,0,0,0,97,110,99,101,115,116,111,114,0,0,0,0,0,0,0,0,97,110,99,101,115,116,111,114,45,111,114,45,115,101,108,102,0,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,99,104,105,108,100,0,0,0,100,101,115,99,101,110,100,97,110,116,0,0,0,0,0,0,100,101,115,99,101,110,100,97,110,116,45,111,114,45,115,101,108,102,0,0,0,0,0,0,102,111,108,108,111,119,105,110,103,0,0,0,0,0,0,0,102,111,108,108,111,119,105,110,103,45,115,105,98,108,105,110,103,0,0,0,0,0,0,0,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,112,97,114,101,110,116,0,0,112,114,101,99,101,100,105,110,103,0,0,0,0,0,0,0,112,114,101,99,101,100,105,110,103,45,115,105,98,108,105,110,103,0,0,0,0,0,0,0,115,101,108,102,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,114,114,97,121,10,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,114,101,97,109,97,98,108,101,32,101,120,112,114,101,115,115,105,111,110,10,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,40,247,1,0,32,247,1,0,0,0,0,0,0,0,0,0,99,111,109,112,97,114,105,110,103,32,110,111,100,101,115,101,116,115,10,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,111,109,112,111,110,101,110,116,10,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,101,112,115,10,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,37,42,46,42,101,0,0,0,37,48,46,42,102,0,0,0,120,109,108,80,111,105,110,116,101,114,76,105,115,116,67,114,101,97,116,101,58,32,97,108,108,111,99,97,116,105,110,103,32,105,116,101,109,10,0,0,120,109,108,80,111,105,110,116,101,114,76,105,115,116,65,100,100,83,105,122,101,58,32,114,101,45,97,108,108,111,99,97,116,105,110,103,32,105,116,101,109,10,0,0,0,0,0,0,100,117,112,108,105,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,76,111,99,97,116,105,111,110,83,101,116,32,105,115,32,78,85,76,76,32,33,10,0,0,37,100,32,58,32,0,0,0,78,111,100,101,32,105,115,32,78,85,76,76,32,33,10,0,32,47,10,0,0,0,0,0,86,97,108,117,101,32,84,114,101,101,32,105,115,32,78,85,76,76,32,33,10,0,0,0,78,111,100,101,83,101,116,32,105,115,32,78,85,76,76,32,33,10,0,0,0,0,0,0,83,101,116,32,99,111,110,116,97,105,110,115,32,37,100,32,110,111,100,101,115,58,10,0,79,107,10,0,0,0,0,0,78,117,109,98,101,114,32,101,110,99,111,100,105,110,103,10,0,0,0,0,0,0,0,0,85,110,102,105,110,105,115,104,101,100,32,108,105,116,101,114,97,108,10,0,0,0,0,0,83,116,97,114,116,32,111,102,32,108,105,116,101,114,97,108,10,0,0,0,0,0,0,0,69,120,112,101,99,116,101,100,32,36,32,102,111,114,32,118,97,114,105,97,98,108,101,32,114,101,102,101,114,101,110,99,101,10,0,0,0,0,0,0,85,110,100,101,102,105,110,101,100,32,118,97,114,105,97,98,108,101,10,0,0,0,0,0,73,110,118,97,108,105,100,32,112,114,101,100,105,99,97,116,101,10,0,0,0,0,0,0,73,110,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,10,0,0,0,0,0,77,105,115,115,105,110,103,32,99,108,111,115,105,110,103,32,99,117,114,108,121,32,98,114,97,99,101,10,0,0,0,0,85,110,114,101,103,105,115,116,101,114,101,100,32,102,117,110,99,116,105,111,110,10,0,0,73,110,118,97,108,105,100,32,111,112,101,114,97,110,100,10,0,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,97,114,103,117,109,101,110,116,115,10,0,0,0,0,73,110,118,97,108,105,100,32,99,111,110,116,101,120,116,32,115,105,122,101,10,0,0,0,73,110,118,97,108,105,100,32,99,111,110,116,101,120,116,32,112,111,115,105,116,105,111,110,10,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,83,121,110,116,97,120,32,101,114,114,111,114,10,0,0,0,82,101,115,111,117,114,99,101,32,101,114,114,111,114,10,0,83,117,98,32,114,101,115,111,117,114,99,101,32,101,114,114,111,114,10,0,0,0,0,0,85,110,100,101,102,105,110,101,100,32,110,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,10,0,0,0,0,0,69,110,99,111,100,105,110,103,32,101,114,114,111,114,10,0,67,104,97,114,32,111,117,116,32,111,102,32,88,77,76,32,114,97,110,103,101,10,0,0,73,110,118,97,108,105,100,32,111,114,32,105,110,99,111,109,112,108,101,116,101,32,99,111,110,116,101,120,116,10,0,0,83,116,97,99,107,32,117,115,97,103,101,32,101,114,114,111,114,10,0,0,0,0,0,0,70,111,114,98,105,100,100,101,110,32,118,97,114,105,97,98,108,101,10,0,0,0,0,0,63,63,32,85,110,107,110,111,119,110,32,101,114,114,111,114,32,63,63,10,0,0,0,0,128,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,240,0,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,116,101,109,112,111,114,97,114,121,32,115,116,111,114,97,103,101,32,102,111,114,32,116,105,109,32,115,111,114,116,58,32,110,101,101,100,32,37,108,117,32,98,121,116,101,115,0,97,108,108,111,99,97,116,105,110,103,32,114,97,110,103,101,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,97,116,32,37,115,58,37,100,10,0,0,0,0,0,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,112,111,105,110,116,101,114,46,99,0,0,0,97,108,108,111,99,97,116,105,110,103,32,108,111,99,97,116,105,111,110,115,101,116,0,0,97,100,100,105,110,103,32,108,111,99,97,116,105,111,110,32,116,111,32,115,101,116,0,0,114,97,110,103,101,45,116,111,0,0,0,0,0,0,0,0,114,97,110,103,101,0,0,0,114,97,110,103,101,45,105,110,115,105,100,101,0,0,0,0,115,116,114,105,110,103,45,114,97,110,103,101,0,0,0,0,115,116,97,114,116,45,112,111,105,110,116,0,0,0,0,0,101,110,100,45,112,111,105,110,116,0,0,0,0,0,0,0,104,101,114,101,0,0,0,0,32,111,114,105,103,105,110,0,120,109,108,88,80,116,114,69,118,97,108,58,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,32,116,111,32,114,101,116,117,114,110,32,97,32,110,111,100,101,32,115,101,116,10,0,0,0,0,120,109,108,88,80,116,114,69,118,97,108,58,32,111,98,106,101,99,116,40,115,41,32,108,101,102,116,32,111,110,32,116,104,101,32,101,118,97,108,32,115,116,97,99,107,10,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,111,105,110,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,101,118,97,108,117,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,97,108,108,111,99,97,116,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,120,112,111,105,110,116,101,114,0,0,0,0,0,0,0,0,101,108,101,109,101,110,116,0,120,109,108,110,115,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,115,99,104,101,109,101,32,39,37,115,39,10,0,0,0,0,0,0,0,0,119,97,114,110,105,110,103,58,32,67,104,105,108,100,83,101,113,32,110,111,116,32,115,116,97,114,116,105,110,103,32,98,121,32,47,49,10,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,99,114,101,97,116,105,110,103,32,88,73,110,99,108,117,100,101,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,88,73,110,99,108,117,100,101,32,101,114,114,111,114,58,32,119,111,117,108,100,32,114,101,115,117,108,116,32,105,110,32,109,117,108,116,105,112,108,101,32,114,111,111,116,32,110,111,100,101,115,10,0,0,0,0,102,97,105,108,101,100,32,116,111,32,98,117,105,108,100,32,110,111,100,101,10,0,0,0,104,114,101,102,0,0,0,0,0,0,0,0,0,0,0,0,112,97,114,115,101,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,118,97,108,117,101,32,37,115,32,102,111,114,32,39,112,97,114,115,101,39,10,0,0,0,102,97,105,108,101,100,32,98,117,105,108,100,32,85,82,76,10,0,0,0,0,0,0,0,102,97,108,108,98,97,99,107,0,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,51,47,88,73,110,99,108,117,100,101,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,73,110,99,108,117,100,101,0,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,37,115,44,32,97,110,100,32,110,111,32,102,97,108,108,98,97,99,107,32,119,97,115,32,102,111,117,110,100,10,0,0,0,105,110,118,97,108,105,100,32,118,97,108,117,101,32,85,82,73,32,37,115,10,0,0,0,102,114,97,103,109,101,110,116,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,98,105,100,100,101,110,32,102,111,114,32,116,101,120,116,58,32,37,115,10,0,0,0,0,0,116,101,120,116,32,115,101,114,105,97,108,105,122,97,116,105,111,110,32,111,102,32,100,111,99,117,109,101,110,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,10,0,0,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,37,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,10,0,0,0,0,0,0,37,115,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,99,104,97,114,10,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,116,101,120,116,0,99,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,88,80,111,105,110,116,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,88,80,111,105,110,116,101,114,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,58,32,35,37,115,10,0,0,0,0,0,0,0,0,88,80,111,105,110,116,101,114,32,105,115,32,110,111,116,32,97,32,114,97,110,103,101,58,32,35,37,115,10,0,0,0,88,80,111,105,110,116,101,114,32,115,101,108,101,99,116,115,32,97,110,32,97,116,116,114,105,98,117,116,101,58,32,35,37,115,10,0,0,0,0,0,88,80,111,105,110,116,101,114,32,115,101,108,101,99,116,115,32,97,32,110,97,109,101,115,112,97,99,101,58,32,35,37,115,10,0,0,0,0,0,0,88,80,111,105,110,116,101,114,32,115,101,108,101,99,116,115,32,117,110,101,120,112,101,99,116,101,100,32,110,111,100,101,115,58,32,35,37,115,10,0,98,97,115,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,116,114,121,105,110,103,32,116,111,32,98,117,105,108,100,32,114,101,108,97,116,105,118,101,32,85,82,73,32,102,114,111,109,32,37,115,10,0,0,0,116,114,121,105,110,103,32,116,111,32,114,101,98,117,105,108,100,32,98,97,115,101,32,102,114,111,109,32,37,115,10,0,112,114,111,99,101,115,115,105,110,103,32,100,111,99,0,0,109,105,115,109,97,116,99,104,32,105,110,32,114,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,101,110,116,105,116,121,32,37,115,10,0,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,120,112,111,105,110,116,101,114,0,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,102,114,97,103,109,101,110,116,32,105,100,101,110,116,105,102,105,101,114,32,105,110,32,85,82,73,32,37,115,32,117,115,101,32,116,104,101,32,120,112,111,105,110,116,101,114,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,32,108,111,99,97,108,32,114,101,99,117,114,115,105,111,110,32,119,105,116,104,32,110,111,32,120,112,111,105,110,116,101,114,32,105,110,32,37,115,10,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,32,114,101,99,117,114,115,105,111,110,32,105,110,32,37,115,10,0,0,0,0,0,103,114,111,119,105,110,103,32,88,73,110,99,108,117,100,101,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,105,110,99,108,117,100,101,0,37,115,32,104,97,115,32,97,110,32,39,105,110,99,108,117,100,101,39,32,99,104,105,108,100,10,0,0,0,0,0,0,37,115,32,104,97,115,32,109,117,108,116,105,112,108,101,32,102,97,108,108,98,97,99,107,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,37,115,32,105,115,32,110,111,116,32,116,104,101,32,99,104,105,108,100,32,111,102,32,97,110,32,39,105,110,99,108,117,100,101,39,10,0,0,0,0,97,100,100,105,110,103,32,85,82,76,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,1,0,0,0,0,0,0,0,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,10,0,0,0,0,0,0,82,101,115,111,108,118,101,58,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,0,82,101,115,111,108,118,101,32,85,82,73,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,77,76,95,68,69,66,85,71,95,67,65,84,65,76,79,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,0,0,0,0,0,0,0,102,105,108,101,58,47,47,47,101,116,99,47,120,109,108,47,99,97,116,97,108,111,103,0,67,97,116,97,108,111,103,115,32,99,108,101,97,110,117,112,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,97,116,97,108,111,103,0,3,0,0,0,0,0,0,0,65,100,100,105,110,103,32,100,111,99,117,109,101,110,116,32,99,97,116,97,108,111,103,32,37,115,10,0,0,0,0,0,76,111,99,97,108,32,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,0,0,76,111,99,97,108,32,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,10,0,0,0,0,0,0,0,0,76,111,99,97,108,32,82,101,115,111,108,118,101,58,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,37,115,32,105,110,32,102,105,108,101,32,104,97,115,104,10,0,0,37,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,104,97,115,104,10,0,0,0,0,0,0,37,115,32,97,100,100,101,100,32,116,111,32,102,105,108,101,32,104,97,115,104,10,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,97,116,97,108,111,103,32,37,115,10,0,0,0,0,0,37,100,32,80,97,114,115,105,110,103,32,99,97,116,97,108,111,103,32,37,115,10,0,0,117,114,110,58,111,97,115,105,115,58,110,97,109,101,115,58,116,99,58,101,110,116,105,116,121,58,120,109,108,110,115,58,120,109,108,58,99,97,116,97,108,111,103,0,0,0,0,0,112,114,101,102,101,114,0,0,115,121,115,116,101,109,0,0,112,117,98,108,105,99,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,112,114,101,102,101,114,58,32,39,37,115,39,10,0,70,105,108,101,32,37,115,32,105,115,32,110,111,116,32,97,110,32,88,77,76,32,67,97,116,97,108,111,103,10,0,0,103,114,111,117,112,0,0,0,105,100,0,0,0,0,0,0,98,97,115,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,112,117,98,108,105,99,73,100,0,0,0,0,0,0,0,0,117,114,105,0,0,0,0,0,115,121,115,116,101,109,73,100,0,0,0,0,0,0,0,0,114,101,119,114,105,116,101,83,121,115,116,101,109,0,0,0,115,121,115,116,101,109,73,100,83,116,97,114,116,83,116,114,105,110,103,0,0,0,0,0,114,101,119,114,105,116,101,80,114,101,102,105,120,0,0,0,100,101,108,101,103,97,116,101,80,117,98,108,105,99,0,0,112,117,98,108,105,99,73,100,83,116,97,114,116,83,116,114,105,110,103,0,0,0,0,0,100,101,108,101,103,97,116,101,83,121,115,116,101,109,0,0,110,97,109,101,0,0,0,0,114,101,119,114,105,116,101,85,82,73,0,0,0,0,0,0,117,114,105,83,116,97,114,116,83,116,114,105,110,103,0,0,100,101,108,101,103,97,116,101,85,82,73,0,0,0,0,0,110,101,120,116,67,97,116,97,108,111,103,0,0,0,0,0,37,115,32,101,110,116,114,121,32,108,97,99,107,115,32,39,37,115,39,10,0,0,0,0,70,111,117,110,100,32,37,115,58,32,39,37,115,39,32,39,37,115,39,10,0,0,0,0,70,111,117,110,100,32,37,115,58,32,39,37,115,39,10,0,37,115,32,101,110,116,114,121,32,39,37,115,39,32,98,114,111,107,101,110,32,63,58,32,37,115,10,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,68,69,76,69,71,65,84,69,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,68,79,67,84,89,80,69,0,76,73,78,75,84,89,80,69,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,71,77,76,68,69,67,76,0,0,0,0,0,0,0,0,68,79,67,85,77,69,78,84,0,0,0,0,0,0,0,0,67,65,84,65,76,79,71,0,66,65,83,69,0,0,0,0,117,114,110,58,112,117,98,108,105,99,105,100,58,0,0,0,85,82,78,32,73,68,32,37,115,32,101,120,112,97,110,100,101,100,32,116,111,32,78,85,76,76,10,0,0,0,0,0,85,82,78,32,73,68,32,101,120,112,97,110,100,101,100,32,116,111,32,37,115,10,0,0,68,101,116,101,99,116,101,100,32,114,101,99,117,114,115,105,111,110,32,105,110,32,99,97,116,97,108,111,103,32,37,115,10,0,0,0,0,0,0,0,70,111,117,110,100,32,85,82,73,32,109,97,116,99,104,32,37,115,10,0,0,0,0,0,85,115,105,110,103,32,114,101,119,114,105,116,105,110,103,32,114,117,108,101,32,37,115,10,0,0,0,0,0,0,0,0,84,114,121,105,110,103,32,85,82,73,32,100,101,108,101,103,97,116,101,32,37,115,10,0,80,117,98,108,105,99,32,85,82,78,32,73,68,32,37,115,32,101,120,112,97,110,100,101,100,32,116,111,32,78,85,76,76,10,0,0,0,0,0,0,80,117,98,108,105,99,32,85,82,78,32,73,68,32,101,120,112,97,110,100,101,100,32,116,111,32,37,115,10,0,0,0,83,121,115,116,101,109,32,85,82,78,32,73,68,32,37,115,32,101,120,112,97,110,100,101,100,32,116,111,32,78,85,76,76,10,0,0,0,0,0,0,83,121,115,116,101,109,32,85,82,78,32,73,68,32,101,120,112,97,110,100,101,100,32,116,111,32,37,115,10,0,0,0,70,111,117,110,100,32,115,121,115,116,101,109,32,109,97,116,99,104,32,37,115,44,32,117,115,105,110,103,32,37,115,10,0,0,0,0,0,0,0,0,84,114,121,105,110,103,32,115,121,115,116,101,109,32,100,101,108,101,103,97,116,101,32,37,115,10,0,0,0,0,0,0,70,111,117,110,100,32,112,117,98,108,105,99,32,109,97,116,99,104,32,37,115,10,0,0,84,114,121,105,110,103,32,112,117,98,108,105,99,32,100,101,108,101,103,97,116,101,32,37,115,10,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,97,116,97,108,111,103,32,101,110,116,114,121,0,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,79,86,69,82,82,73,68,69,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,117,98,108,105,99,32,73,68,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,97,116,97,108,111,103,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,97,116,97,108,111,103,32,100,97,116,97,0,70,114,101,101,32,99,97,116,97,108,111,103,32,101,110,116,114,121,32,37,115,10,0,0,70,114,101,101,32,99,97,116,97,108,111,103,32,101,110,116,114,121,10,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,0,0,0,0,50,48,57,48,50,0,0,0,96,18,2,0,0,0,0,0,1,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,8,19,2,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+125808),
	allocate([57,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,0,0,0,0,53,0,0,0,65,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,101,99,117,116,105,110,103,32,99,49,52,110,0,0,105,110,118,97,108,105,100,32,109,111,100,101,32,102,111,114,32,101,120,101,99,117,116,105,110,103,32,99,49,52,110,0,120,109,108,67,49,52,78,69,120,101,99,117,116,101,58,32,111,117,116,112,117,116,32,98,117,102,102,101,114,32,101,110,99,111,100,101,114,32,33,61,32,78,85,76,76,32,98,117,116,32,67,49,52,78,32,114,101,113,117,105,114,101,115,32,85,84,70,56,32,111,117,116,112,117,116,10,0,0,0,0,120,109,108,67,49,52,78,69,120,101,99,117,116,101,58,32,117,110,97,98,108,101,32,116,111,32,99,114,101,97,116,101,32,67,49,52,78,32,99,111,110,116,101,120,116,10,0,0,112,114,111,99,101,115,115,105,110,103,32,100,111,99,115,32,99,104,105,108,100,114,101,110,32,108,105,115,116,0,0,0,102,108,117,115,104,105,110,103,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,100,117,109,112,105,110,103,32,100,111,99,32,116,111,32,109,101,109,111,114,121,0,0,0,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,115,97,118,105,110,103,32,100,111,99,32,116,111,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,0,0,0,99,111,112,105,110,103,32,99,97,110,111,110,105,99,97,110,105,122,101,100,32,100,111,99,117,109,101,110,116,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,102,114,101,101,105,110,103,32,99,111,110,116,101,120,116,0,100,101,115,116,114,111,121,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,58,32,37,115,10,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,111,100,101,32,108,105,115,116,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,111,100,101,0,110,111,114,109,97,108,105,122,105,110,103,32,116,101,120,116,32,110,111,100,101,0,0,0,10,60,63,0,0,0,0,0,60,63,0,0,0,0,0,0,32,0,0,0,0,0,0,0,110,111,114,109,97,108,105,122,105,110,103,32,112,105,32,110,111,100,101,0,0,0,0,0,63,62,10,0,0,0,0,0,63,62,0,0,0,0,0,0,10,60,33,45,45,0,0,0,60,33,45,45,0,0,0,0,110,111,114,109,97,108,105,122,105,110,103,32,99,111,109,109,101,110,116,32,110,111,100,101,0,0,0,0,0,0,0,0,45,45,62,10,0,0,0,0,45,45,62,0,0,0,0,0,88,77,76,95,65,84,84,82,73,66,85,84,69,95,78,79,68,69,0,0,0,0,0,0,88,77,76,95,78,65,77,69,83,80,65,67,69,95,68,69,67,76,0,0,0,0,0,0,88,77,76,95,69,78,84,73,84,89,95,82,69,70,95,78,79,68,69,0,0,0,0,0,88,77,76,95,69,78,84,73,84,89,95,78,79,68,69,0,85,110,107,110,111,119,110,32,110,111,100,101,32,116,121,112,101,32,37,100,32,102,111,117,110,100,32,58,32,37,115,10,0,0,0,0,0,0,0,0,78,111,100,101,32,37,115,32,105,115,32,105,110,118,97,108,105,100,32,104,101,114,101,32,58,32,37,115,10,0,0,0,97,108,108,111,99,97,116,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,0,0,112,114,111,99,101,115,115,105,110,103,32,101,108,101,109,101,110,116,32,110,111,100,101,0,99,104,101,99,107,105,110,103,32,102,111,114,32,114,101,108,97,116,105,118,101,32,110,97,109,101,115,112,97,99,101,115,0,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,120,105,115,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,97,120,105,115,0,0,0,0,0,0,62,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,99,104,105,108,100,114,101,110,115,32,108,105,115,116,0,0,0,0,0,0,0,60,47,0,0,0,0,0,0,114,101,115,116,111,114,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,108,105,115,116,0,0,0,0,0,0,0,0,108,97,110,103,0,0,0,0,115,112,97,99,101,0,0,0,98,97,115,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,119,114,105,116,105,110,103,32,97,116,116,114,105,98,117,116,101,115,0,0,0,0,0,0,61,34,0,0,0,0,0,0,110,111,114,109,97,108,105,122,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,97,120,105,115,0,0,0,0,0,34,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,103,101,116,32,97,116,116,114,32,118,97,108,117,101,0,0,0,0,47,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,109,111,100,105,102,121,32,117,114,105,0,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,99,111,110,115,116,114,117,99,116,32,117,114,105,0,0,0,0,0,0,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,99,111,110,115,116,114,117,99,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,115,104,105,102,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,120,105,115,32,40,101,120,99,32,99,49,52,110,41,0,0,0,99,114,101,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,108,105,115,116,32,40,101,120,99,32,99,49,52,110,41,0,0,0,0,0,35,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,114,105,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,0,0,0,0,0,0,32,120,109,108,110,115,58,0,61,0,0,0,0,0,0,0,32,120,109,108,110,115,61,0,34,34,0,0,0,0,0,0,115,101,97,114,99,104,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,32,40,101,120,99,32,99,49,52,110,41,0,0,0,97,100,100,105,110,103,32,110,97,109,101,115,112,97,99,101,32,116,111,32,115,116,97,99,107,0,0,0,0,0,0,0,97,100,100,105,110,103,32,110,111,100,101,32,116,111,32,115,116,97,99,107,0,0,0,0,115,101,97,114,99,104,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,32,40,99,49,52,110,41,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,120,105,115,32,40,99,49,52,110,41,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,108,105,115,116,32,40,99,49,52,110,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,97,118,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,112,97,114,115,105,110,103,32,110,97,109,101,115,112,97,99,101,32,117,114,105,0,0,0,117,114,110,0,0,0,0,0,100,97,118,0,0,0,0,0,82,101,108,97,116,105,118,101,32,110,97,109,101,115,112,97,99,101,32,85,82,32,105,115,32,105,110,118,97,108,105,100,32,104,101,114,101,32,58,32,37,115,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,101,119,32,99,111,110,116,101,120,116,0,0,0,0,120,109,108,67,49,52,78,78,101,119,67,116,120,58,32,111,117,116,112,117,116,32,98,117,102,102,101,114,32,101,110,99,111,100,101,114,32,33,61,32,78,85,76,76,32,98,117,116,32,67,49,52,78,32,114,101,113,117,105,114,101,115,32,85,84,70,56,32,111,117,116,112,117,116,10,0,0,0,0,0,120,109,108,67,49,52,78,78,101,119,67,116,120,58,32,115,111,117,114,99,101,32,100,111,99,117,109,101,110,116,32,110,111,116,32,105,110,32,85,84,70,56,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,120,109,108,67,49,52,78,78,101,119,67,116,120,58,32,120,109,108,67,49,52,78,86,105,115,105,98,108,101,78,115,83,116,97,99,107,67,114,101,97,116,101,32,102,97,105,108,101,100,10,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,0,0,37,115,0,0,0,0,0,0,73,110,118,97,108,105,100,32,112,97,114,97,109,101,116,101,114,32,58,32,37,115,10,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,109,97,108,108,111,99,32,111,102,32,37,108,100,32,98,121,116,101,32,102,97,105,108,101,100,10,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,0,0,34,0,0,0,0,0,0,0,38,113,117,111,116,59,0,0,39,0,0,0,0,0,0,0,73,110,112,117,116,32,114,101,102,101,114,101,110,99,101,32,111,117,116,115,105,100,101,32,111,102,32,116,104,101,32,98,117,102,102,101,114,0,0,0,99,114,101,97,116,105,110,103,32,101,120,101,99,117,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,0,0,0,120,109,108,70,65,80,97,114,115,101,82,101,103,69,120,112,58,32,101,120,116,114,97,32,99,104,97,114,97,99,116,101,114,115,0,0,0,0,0,0,110,111,116,32,37,115,0,0,97,116,111,109,32,112,117,115,104,58,32,97,116,111,109,32,105,115,32,78,85,76,76,0,112,117,115,104,105,110,103,32,97,116,111,109,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,111,117,110,116,101,114,0,0,0,0,0,0,97,100,100,32,115,116,97,116,101,58,32,115,116,97,116,101,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,0,97,100,100,32,115,116,97,116,101,58,32,116,97,114,103,101,116,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,97,100,100,105,110,103,32,116,114,97,110,115,105,116,105,111,110,0,0,0,0,0,0,0,103,101,110,114,97,116,101,32,116,114,97,110,115,105,116,105,111,110,58,32,97,116,111,109,32,61,61,32,78,85,76,76,0,0,0,0,0,0,0,0,99,111,112,121,105,110,103,32,97,116,111,109,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,114,97,110,103,101,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,111,109,0,84,79,68,79,58,32,88,77,76,95,82,69,71,69,88,80,95,83,84,82,73,78,71,10,0,0,0,0,0,0,0,0,114,117,110,110,105,110,103,32,114,101,103,101,120,112,0,0,101,112,115,105,108,111,110,32,116,114,97,110,115,105,116,105,111,110,32,108,101,102,116,32,97,116,32,114,117,110,116,105,109,101,10,0,0,0,0,0,101,120,101,99,32,115,97,118,101,58,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,115,97,118,105,110,103,32,114,101,103,101,120,112,0,0,0,99,111,109,112,105,108,105,110,103,32,114,101,103,101,120,112,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,58,32,37,115,10,0,0,101,120,112,101,99,116,105,110,103,32,97,32,98,114,97,110,99,104,32,97,102,116,101,114,32,124,0,0,0,0,0,0,105,110,116,101,114,110,97,108,58,32,110,111,32,97,116,111,109,32,103,101,110,101,114,97,116,101,100,0,0,0,0,0,73,109,112,114,111,112,101,114,32,113,117,97,110,116,105,102,105,101,114,0,0,0,0,0,85,110,116,101,114,109,105,110,97,116,101,100,32,113,117,97,110,116,105,102,105,101,114,0,120,109,108,70,65,80,97,114,115,101,65,116,111,109,58,32,101,120,112,101,99,116,105,110,103,32,39,41,39,0,0,0,120,109,108,70,65,80,97,114,115,101,67,104,97,114,67,108,97,115,115,58,32,39,93,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,0,0,69,115,99,97,112,101,100,32,115,101,113,117,101,110,99,101,58,32,101,120,112,101,99,116,105,110,103,32,92,0,0,0,69,120,112,101,99,116,105,110,103,32,39,123,39,0,0,0,69,120,112,101,99,116,105,110,103,32,39,125,39,0,0,0,87,114,111,110,103,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,44,32,109,105,115,117,115,101,32,111,102,32,99,104,97,114,97,99,116,101,114,32,39,92,39,0,0,73,115,88,88,88,88,32,101,120,112,101,99,116,101,100,0,85,110,107,110,111,119,110,32,99,104,97,114,32,112,114,111,112,101,114,116,121,0,0,0,97,100,100,32,114,97,110,103,101,58,32,97,116,111,109,32,105,115,32,78,85,76,76,0,97,100,100,32,114,97,110,103,101,58,32,97,116,111,109,32,105,115,32,110,111,116,32,114,97,110,103,101,115,0,0,0,97,100,100,105,110,103,32,114,97,110,103,101,115,0,0,0,99,104,97,114,67,108,97,115,115,69,120,112,114,58,32,39,93,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,69,120,112,101,99,116,105,110,103,32,39,93,39,0,0,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,118,97,108,117,101,0,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,99,104,97,114,32,114,97,110,103,101,0,0,69,120,112,101,99,116,105,110,103,32,116,104,101,32,101,110,100,32,111,102,32,97,32,99,104,97,114,32,114,97,110,103,101,0,0,0,0,0,0,0,69,110,100,32,111,102,32,114,97,110,103,101,32,105,115,32,98,101,102,111,114,101,32,115,116,97,114,116,32,111,102,32,114,97,110,103,101,0,0,0,97,100,100,105,110,103,32,115,116,97,116,101,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,97,116,101,0,0,0,0,0,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,114,101,103,101,120,112,46,99,0,0,112,117,115,104,105,110,103,32,105,110,112,117,116,32,115,116,114,105,110,103,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,115,99,104,101,109,97,115,46,99,0,10,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,70,97,99,101,116,0,0,0,0,0,97,32,116,121,112,101,32,117,115,101,114,32,100,101,114,105,118,101,100,32,116,121,112,101,32,104,97,115,32,110,111,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,70,97,99,101,116,44,32,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,37,115,39,32,97,103,97,105,110,115,116,32,116,104,101,32,98,97,115,101,32,116,121,112,101,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,100,111,101,115,32,110,111,116,32,118,97,108,105,100,97,116,101,32,97,103,97,105,110,115,116,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,0,0,0,0,0,0,0,0,118,97,108,117,101,32,119,97,115,32,110,111,116,32,99,111,109,112,117,116,101,100,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,112,97,116,116,101,114,110,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,32,118,97,108,117,101,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,39,37,115,39,0,0,0,0,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,112,111,115,105,116,105,118,101,73,110,116,101,103,101,114,0,112,114,101,115,101,114,118,101,0,0,0,0,0,0,0,0,114,101,112,108,97,99,101,0,99,111,108,108,97,112,115,101,0,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,119,104,105,116,101,115,112,97,99,101,39,32,105,115,32,110,111,116,32,118,97,108,105,100,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,99,97,116,101,32,116,104,101,32,109,97,105,110,32,115,99,104,101,109,97,32,114,101,115,111,117,114,99,101,32,97,116,32,39,37,115,39,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,99,97,116,101,32,116,104,101,32,109,97,105,110,32,115,99,104,101,109,97,32,114,101,115,111,117,114,99,101,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,0,0,65,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,111,99,99,117,114,101,100,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,84,104,101,32,100,111,99,117,109,101,110,116,32,104,97,115,32,110,111,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,120,109,108,83,99,104,101,109,97,65,117,103,109,101,110,116,73,68,67,58,32,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,117,103,109,101,110,116,101,100,32,73,68,67,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,120,109,108,83,99,104,101,109,97,67,114,101,97,116,101,80,67,116,120,116,79,110,86,67,116,120,116,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,116,101,109,112,46,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,120,109,108,83,99,104,101,109,97,83,65,88,72,97,110,100,108,101,67,68,97,116,97,83,101,99,116,105,111,110,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,80,117,115,104,84,101,120,116,40,41,0,0,0,0,78,101,105,116,104,101,114,32,99,104,97,114,97,99,116,101,114,32,110,111,114,32,101,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,97,108,108,111,119,101,100,32,98,101,99,97,117,115,101,32,116,104,101,32,101,108,101,109,101,110,116,32,105,115,32,39,110,105,108,108,101,100,39,0,0,0,0,0,0,0,0,67,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,101,109,112,116,121,0,0,0,0,0,67,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,111,116,104,101,114,32,116,104,97,110,32,119,104,105,116,101,115,112,97,99,101,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,39,101,108,101,109,101,110,116,45,111,110,108,121,39,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,83,65,88,72,97,110,100,108,101,69,110,100,69,108,101,109,101,110,116,78,115,0,0,101,108,101,109,32,112,111,112,32,109,105,115,109,97,116,99,104,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,111,112,69,108,101,109,40,41,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,111,112,69,108,101,109,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,114,101,103,101,120,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,77,105,115,115,105,110,103,32,99,104,105,108,100,32,101,108,101,109,101,110,116,40,115,41,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,67,104,101,99,107,67,86,67,83,105,109,112,108,101,84,121,112,101,40,41,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,79,83,86,97,108,105,100,68,101,102,97,117,108,116,40,41,0,99,97,108,108,105,110,103,32,120,109,108,78,101,119,84,101,120,116,40,41,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,116,32,101,108,101,109,101,110,116,32,110,111,100,101,115,32,115,105,110,99,101,32,116,104,101,114,101,32,105,115,32,97,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,84,104,101,32,105,110,105,116,105,97,108,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,0,84,104,101,32,97,99,116,117,97,108,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,73,68,67,32,108,105,115,116,32,111,102,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,73,68,67,32,108,105,115,116,32,111,102,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,73,68,67,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,80,83,86,73,32,73,68,67,32,98,105,110,100,105,110,103,32,105,116,101,109,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,110,101,119,32,105,116,101,109,32,108,105,115,116,0,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,105,116,101,109,32,108,105,115,116,0,0,0,0,0,0,0,77,111,114,101,32,116,104,97,110,32,111,110,101,32,109,97,116,99,104,32,102,111,117,110,100,32,102,111,114,32,107,101,121,45,115,101,113,117,101,110,99,101,32,37,115,32,111,102,32,107,101,121,114,101,102,32,39,37,115,39,0,0,0,0,78,111,32,109,97,116,99,104,32,102,111,117,110,100,32,102,111,114,32,107,101,121,45,115,101,113,117,101,110,99,101,32,37,115,32,111,102,32,107,101,121,114,101,102,32,39,37,115,39,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,0,0,0,0,0,0,0,0,91,0,0,0,0,0,0,0,39,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,70,111,114,109,97,116,73,68,67,75,101,121,83,101,113,117,101,110,99,101,0,0,0,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,97,32,99,97,110,111,110,105,99,97,108,32,118,97,108,117,101,0,0,0,0,0,63,63,63,0,0,0,0,0,39,44,32,0,0,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,39,37,115,39,58,32,0,0,46,10,0,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,73,68,67,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,0,120,109,108,83,99,104,101,109,97,88,80,97,116,104,80,114,111,99,101,115,115,72,105,115,116,111,114,121,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,116,114,101,97,109,80,111,112,40,41,0,0,102,105,101,108,100,32,114,101,115,111,108,118,101,115,32,116,111,32,97,32,67,84,32,119,105,116,104,32,115,105,109,112,108,101,32,99,111,110,116,101,110,116,32,98,117,116,32,116,104,101,32,67,84,32,105,115,32,109,105,115,115,105,110,103,32,116,104,101,32,83,84,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,84,104,101,32,88,80,97,116,104,32,39,37,115,39,32,111,102,32,97,32,102,105,101,108,100,32,111,102,32,37,115,32,100,111,101,115,32,101,118,97,108,117,97,116,101,32,116,111,32,97,32,110,111,100,101,32,111,102,32,110,111,110,45,115,105,109,112,108,101,32,116,121,112,101,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,78,111,32,112,114,101,99,111,109,112,117,116,101,100,32,118,97,108,117,101,32,97,118,97,105,108,97,98,108,101,44,32,116,104,101,32,118,97,108,117,101,32,119,97,115,32,101,105,116,104,101,114,32,105,110,118,97,108,105,100,32,111,114,32,115,111,109,101,116,104,105,110,103,32,115,116,114,97,110,103,101,32,104,97,112,112,101,110,100,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,107,101,121,45,115,101,113,117,101,110,99,101,115,0,0,0,0,114,101,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,107,101,121,45,115,101,113,117,101,110,99,101,115,0,0,84,104,101,32,88,80,97,116,104,32,39,37,115,39,32,111,102,32,97,32,102,105,101,108,100,32,111,102,32,37,115,32,101,118,97,108,117,97,116,101,115,32,116,111,32,97,32,110,111,100,101,45,115,101,116,32,119,105,116,104,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,109,101,109,98,101,114,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,107,101,121,45,115,101,113,117,101,110,99,101,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,73,68,67,32,107,101,121,0,0,0,0,68,117,112,108,105,99,97,116,101,32,107,101,121,45,115,101,113,117,101,110,99,101,32,37,115,32,105,110,32,37,115,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,0,0,0,0,0,0,0,78,111,116,32,97,108,108,32,102,105,101,108,100,115,32,111,102,32,37,115,32,101,118,97,108,117,97,116,101,32,116,111,32,97,32,110,111,100,101,0,84,104,101,32,115,116,97,116,101,32,111,98,106,101,99,116,32,116,111,32,98,101,32,114,101,109,111,118,101,100,32,105,115,32,110,111,116,32,116,104,101,32,102,105,114,115,116,32,105,110,32,116,104,101,32,108,105,115,116,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,110,111,100,101,32,116,97,98,108,101,32,105,116,101,109,32,108,105,115,116,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,110,111,100,101,32,116,97,98,108,101,32,105,116,101,109,32,108,105,115,116,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,107,101,121,32,115,116,111,114,97,103,101,32,108,105,115,116,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,107,101,121,32,115,116,111,114,97,103,101,32,108,105,115,116,0,0,32,39,0,0,0,0,0,0,99,111,109,112,108,101,120,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,115,105,109,112,108,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,117,115,101,0,0,0,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,0,0,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,110,111,116,97,116,105,111,110,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,109,111,100,101,108,32,103,114,111,117,112,32,40,115,101,113,117,101,110,99,101,41,0,0,109,111,100,101,108,32,103,114,111,117,112,32,40,99,104,111,105,99,101,41,0,0,0,0,109,111,100,101,108,32,103,114,111,117,112,32,40,97,108,108,41,0,0,0,0,0,0,0,112,97,114,116,105,99,108,101,0,0,0,0,0,0,0,0,117,110,105,113,117,101,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,0,107,101,121,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,0,107,101,121,114,101,102,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,0,119,105,108,100,99,97,114,100,32,40,97,110,121,41,0,0,91,104,101,108,112,101,114,32,99,111,109,112,111,110,101,110,116,93,32,81,78,97,109,101,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,91,104,101,108,112,101,114,32,99,111,109,112,111,110,101,110,116,93,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,0,0,0,0,78,111,116,32,97,32,115,99,104,101,109,97,32,99,111,109,112,111,110,101,110,116,0,0,70,111,114,32,97,32,115,116,114,105,110,103,32,116,111,32,98,101,32,97,32,118,97,108,105,100,32,100,101,102,97,117,108,116,44,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,115,105,109,112,108,101,32,99,111,110,116,101,110,116,32,111,114,32,109,105,120,101,100,32,99,111,110,116,101,110,116,32,97,110,100,32,97,32,112,97,114,116,105,99,108,101,32,101,109,112,116,105,97,98,108,101,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,79,83,86,97,108,105,100,68,101,102,97,117,108,116,0,0,0,46,0,0,0,0,0,0,0,32,69,120,112,101,99,116,101,100,32,105,115,32,111,110,101,32,111,102,32,40,32,0,0,32,69,120,112,101,99,116,101,100,32,105,115,32,40,32,0,35,35,111,116,104,101,114,0,123,42,125,0,0,0,0,0,123,35,35,111,116,104,101,114,58,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,44,32,0,0,0,0,0,0,32,41,46,10,0,0,0,0,69,108,101,109,101,110,116,32,39,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,39,0,0,0,0,0,39,58,32,0,0,0,0,0,120,109,108,83,99,104,101,109,97,83,65,88,72,97,110,100,108,101,83,116,97,114,116,69,108,101,109,101,110,116,78,115,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,117,115,104,69,108,101,109,40,41,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,32,98,105,110,100,105,110,103,115,32,102,111,114,32,83,65,88,32,118,97,108,105,100,97,116,105,111,110,0,0,0,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,32,98,105,110,100,105,110,103,115,32,102,111,114,32,83,65,88,32,118,97,108,105,100,97,116,105,111,110,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,117,115,104,65,116,116,114,105,98,117,116,101,40,41,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,40,41,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,0,0,0,105,110,32,115,107,105,112,45,115,116,97,116,101,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,83,116,114,101,97,109,86,97,108,105,100,97,116,101,67,104,105,108,100,69,108,101,109,101,110,116,40,41,0,0,0,116,104,101,32,99,104,105,108,100,32,101,108,101,109,101,110,116,32,119,97,115,32,118,97,108,105,100,32,98,117,116,32,110,101,105,116,104,101,114,32,116,104,101,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,114,32,116,104,101,32,116,121,112,101,32,119,97,115,32,115,101,116,0,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,103,108,111,98,97,108,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,118,97,108,105,100,97,116,105,111,110,32,114,111,111,116,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,87,105,108,100,99,97,114,100,40,41,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,68,101,99,108,40,41,0,0,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,97,98,115,101,110,116,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,97,98,115,116,114,97,99,116,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,88,80,97,116,104,69,118,97,108,117,97,116,101,40,41,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,118,97,108,105,100,97,116,105,111,110,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,10,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,65,116,116,114,105,98,117,116,101,115,67,111,109,112,108,101,120,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,65,116,116,114,73,110,102,111,40,41,0,0,0,0,0,100,101,102,97,117,108,116,47,102,105,120,101,100,32,118,97,108,117,101,32,111,110,32,97,110,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,119,97,115,32,110,111,116,32,112,114,101,99,111,109,112,117,116,101,100,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,67,111,112,121,86,97,108,117,101,40,41,0,0,0,0,99,97,108,108,108,105,110,103,32,120,109,108,78,101,119,80,114,111,112,40,41,0,0,0,112,37,100,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,99,111,109,112,117,116,101,32,97,32,110,115,32,112,114,101,102,105,120,32,102,111,114,32,97,32,100,101,102,97,117,108,116,47,102,105,120,101,100,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,83,116,114,101,97,109,86,97,108,105,100,97,116,101,83,105,109,112,108,101,84,121,112,101,86,97,108,117,101,40,41,0,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,114,101,113,117,105,114,101,100,32,98,117,116,32,109,105,115,115,105,110,103,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,103,108,111,98,97,108,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,44,32,98,117,116,32,100,101,109,97,110,100,101,100,32,98,121,32,116,104,101,32,115,116,114,105,99,116,32,119,105,108,100,99,97,114,100,0,35,35,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,105,110,102,111,32,108,105,115,116,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,105,110,102,111,32,108,105,115,116,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,65,116,116,114,73,110,102,111,0,0,0,0,0,0,0,97,116,116,114,32,105,110,102,111,32,110,111,116,32,99,108,101,97,114,101,100,0,0,0,99,114,101,97,116,105,110,103,32,110,101,119,32,97,116,116,114,105,98,117,116,101,32,105,110,102,111,0,0,0,0,0,120,109,108,83,99,104,101,109,97,88,80,97,116,104,69,118,97,108,117,97,116,101,0,0,99,97,108,108,105,110,103,32,120,109,108,83,116,114,101,97,109,80,117,115,104,40,41,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,115,116,97,116,101,32,111,98,106,101,99,116,32,104,105,115,116,111,114,121,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,115,116,97,116,101,32,111,98,106,101,99,116,32,104,105,115,116,111,114,121,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,115,116,97,116,101,32,111,98,106,101,99,116,0,0,120,109,108,83,99,104,101,109,97,73,68,67,65,100,100,83,116,97,116,101,79,98,106,101,99,116,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,110,32,88,80,97,116,104,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,0,0,0,0,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,97,98,115,116,114,97,99,116,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+136048),
	allocate([101,69,108,101,109,68,101,99,108,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,67,104,101,99,107,67,86,67,83,105,109,112,108,101,84,121,112,101,40,41,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,110,105,108,39,0,0,0,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,39,110,105,108,108,97,98,108,101,39,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,99,97,110,110,111,116,32,98,101,32,39,110,105,108,108,101,100,39,32,98,101,99,97,117,115,101,32,116,104,101,114,101,32,105,115,32,97,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,100,101,102,105,110,101,100,32,102,111,114,32,105,116,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,80,114,111,99,101,115,115,88,83,73,84,121,112,101,40,41,32,116,111,32,112,114,111,99,101,115,115,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,116,121,112,101,39,0,0,0,120,109,108,83,99,104,101,109,97,73,68,67,82,101,103,105,115,116,101,114,77,97,116,99,104,101,114,115,0,0,0,0,84,104,101,32,99,104,97,105,110,32,111,102,32,73,68,67,32,109,97,116,99,104,101,114,115,32,105,115,32,101,120,112,101,99,116,101,100,32,116,111,32,98,101,32,101,109,112,116,121,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,97,110,32,97,117,103,109,101,110,116,101,100,32,73,68,67,32,105,116,101,109,32,102,111,114,32,97,110,32,73,68,67,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,109,97,116,99,104,101,114,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,101,110,116,66,121,68,101,99,108,97,114,97,116,105,111,110,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,81,78,97,109,101,69,120,112,97,110,100,40,41,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,116,121,112,101,39,0,0,0,0,0,84,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,120,115,105,58,116,121,112,101,32,97,116,116,114,105,98,117,116,101,32,100,111,101,115,32,110,111,116,32,114,101,115,111,108,118,101,32,116,111,32,97,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,44,32,115,112,101,99,105,102,105,101,100,32,98,121,32,120,115,105,58,116,121,112,101,44,32,105,115,32,98,108,111,99,107,101,100,32,111,114,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,0,0,0,0,0,0,116,104,105,115,32,102,117,110,99,116,105,111,110,32,110,101,101,100,115,32,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,83,105,109,112,108,101,84,121,112,101,83,116,97,103,101,84,119,111,0,0,0,0,0,0,0,0,109,105,115,115,105,110,103,32,98,97,115,101,84,121,112,101,0,0,0,0,0,0,0,0,73,116,32,105,115,32,97,110,32,101,114,114,111,114,32,102,111,114,32,98,111,116,104,32,39,108,101,110,103,116,104,39,32,97,110,100,32,101,105,116,104,101,114,32,111,102,32,39,109,105,110,76,101,110,103,116,104,39,32,111,114,32,39,109,97,120,76,101,110,103,116,104,39,32,116,111,32,98,101,32,115,112,101,99,105,102,105,101,100,32,111,110,32,116,104,101,32,115,97,109,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,73,116,32,105,115,32,97,110,32,101,114,114,111,114,32,102,111,114,32,98,111,116,104,32,39,37,115,39,32,97,110,100,32,39,37,115,39,32,116,111,32,98,101,32,115,112,101,99,105,102,105,101,100,32,111,110,32,116,104,101,32,115,97,109,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,39,115,32,102,97,99,101,116,32,105,115,32,39,102,105,120,101,100,39,44,32,116,104,117,115,32,116,104,101,32,118,97,108,117,101,32,109,117,115,116,32,110,111,116,32,100,105,102,102,101,114,0,0,0,0,0,0,0,0,84,104,101,32,39,119,104,105,116,101,115,112,97,99,101,39,32,118,97,108,117,101,32,104,97,115,32,116,111,32,98,101,32,101,113,117,97,108,32,116,111,32,111,114,32,115,116,114,111,110,103,101,114,32,116,104,97,110,32,116,104,101,32,39,119,104,105,116,101,115,112,97,99,101,39,32,118,97,108,117,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,0,100,101,114,105,118,105,110,103,32,102,97,99,101,116,115,44,32,99,114,101,97,116,105,110,103,32,97,32,102,97,99,101,116,32,108,105,110,107,0,0,120,109,108,83,99,104,101,109,97,68,101,114,105,118,101,65,110,100,86,97,108,105,100,97,116,101,70,97,99,101,116,115,0,0,0,0,0,0,0,0,97,110,32,101,114,114,111,114,32,111,99,99,117,114,101,100,0,0,0,0,0,0,0,0,39,32,104,97,115,32,116,111,32,98,101,0,0,0,0,0,32,101,113,117,97,108,32,116,111,0,0,0,0,0,0,0,32,103,114,101,97,116,101,114,32,116,104,97,110,0,0,0,32,108,101,115,115,32,116,104,97,110,0,0,0,0,0,0,32,111,114,32,101,113,117,97,108,32,116,111,0,0,0,0,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,0,37,115,58,32,0,0,0,0,97,116,111,109,105,99,32,116,121,112,101,32,39,120,115,58,0,0,0,0,0,0,0,0,108,105,115,116,32,116,121,112,101,32,39,120,115,58,0,0,117,110,105,111,110,32,116,121,112,101,32,39,120,115,58,0,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,0,0,0,0,0,0,0,0,108,111,99,97,108,32,0,0,97,116,111,109,105,99,32,116,121,112,101,0,0,0,0,0,108,105,115,116,32,116,121,112,101,0,0,0,0,0,0,0,117,110,105,111,110,32,116,121,112,101,0,0,0,0,0,0,115,105,109,112,108,101,32,116,121,112,101,0,0,0,0,0,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,0,97,116,116,114,105,98,117,116,101,32,117,115,101,32,0,0,40,117,110,107,110,111,119,110,41,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,100,101,99,108,46,0,101,108,101,109,101,110,116,32,100,101,99,108,46,0,0,0,117,110,105,113,117,101,32,39,0,0,0,0,0,0,0,0,107,101,121,32,39,0,0,0,107,101,121,82,101,102,32,39,0,0,0,0,0,0,0,0,32,119,105,108,100,99,97,114,100,0,0,0,0,0,0,0,102,97,99,101,116,32,39,0,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,46,0,0,0,0,0,0,0,0,44,32,97,116,116,114,105,98,117,116,101,32,39,0,0,0,115,107,105,112,0,0,0,0,108,97,120,0,0,0,0,0,115,116,114,105,99,116,0,0,105,110,118,97,108,105,100,32,112,114,111,99,101,115,115,32,99,111,110,116,101,110,116,115,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,114,101,97,116,101,86,67,116,120,116,79,110,80,67,116,120,116,44,32,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,116,101,109,112,46,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,46,10,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,79,83,83,84,82,101,115,116,114,105,99,116,115,0,0,0,0,103,105,118,101,110,32,116,121,112,101,32,105,115,32,110,111,116,32,97,32,117,115,101,114,45,100,101,114,105,118,101,100,32,115,105,109,112,108,101,84,121,112,101,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,97,116,111,109,105,99,32,115,105,109,112,108,101,32,116,121,112,101,0,84,104,101,32,102,105,110,97,108,32,111,102,32,105,116,115,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,102,97,105,108,101,100,32,116,111,32,103,101,116,32,112,114,105,109,105,116,105,118,101,32,116,121,112,101,0,0,0,0,102,97,105,108,101,100,32,116,111,32,101,118,97,108,117,97,116,101,32,116,104,101,32,105,116,101,109,32,116,121,112,101,0,0,0,0,0,0,0,0,84,104,101,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,32,118,97,114,105,101,116,121,32,111,102,32,97,116,111,109,105,99,32,111,114,32,117,110,105,111,110,0,0,0,84,104,101,32,105,116,101,109,32,116,121,112,101,32,105,115,32,97,32,117,110,105,111,110,32,116,121,112,101,44,32,98,117,116,32,116,104,101,32,109,101,109,98,101,114,32,116,121,112,101,32,39,37,115,39,32,111,102,32,116,104,105,115,32,105,116,101,109,32,116,121,112,101,32,105,115,32,110,111,116,32,97,116,111,109,105,99,0,84,104,101,32,102,105,110,97,108,32,111,102,32,105,116,115,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,108,105,115,116,39,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,98,101,32,97,32,108,105,115,116,32,116,121,112,101,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,101,118,97,108,32,116,104,101,32,105,116,101,109,32,116,121,112,101,32,111,102,32,97,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,84,104,101,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,0,84,104,101,32,109,101,109,98,101,114,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,116,111,109,105,99,44,32,110,111,114,32,97,32,108,105,115,116,32,116,121,112,101,0,0,0,0,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,109,101,109,98,101,114,32,116,121,112,101,32,39,37,115,39,32,99,111,110,116,97,105,110,115,32,39,117,110,105,111,110,39,0,0,0,0,0,0,0,0,78,111,32,102,97,99,101,116,115,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,117,110,105,111,110,32,116,121,112,101,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,105,116,115,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,0,0,0,0,0,0,100,105,102,102,101,114,101,110,116,32,110,117,109,98,101,114,32,111,102,32,109,101,109,98,101,114,32,116,121,112,101,115,32,105,110,32,98,97,115,101,0,0,0,0,0,0,0,0,84,104,101,32,109,101,109,98,101,114,32,116,121,112,101,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,105,116,115,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,109,101,109,98,101,114,32,116,121,112,101,32,37,115,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,37,115,0,0,0,0,0,37,115,58,32,84,104,101,32,102,97,99,101,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,10,0,0,0,0,0,37,115,58,32,84,104,101,32,102,97,99,101,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,116,121,112,101,115,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,116,121,112,101,32,37,115,46,10,0,0,0,78,111,32,98,97,115,101,32,116,121,112,101,32,101,120,105,115,116,101,110,116,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,115,105,109,112,108,101,32,116,121,112,101,0,65,32,116,121,112,101,44,32,100,101,114,105,118,101,100,32,98,121,32,108,105,115,116,32,111,114,32,117,110,105,111,110,44,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,105,109,112,108,101,32,117,114,45,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,97,115,32,98,97,115,101,32,116,121,112,101,44,32,110,111,116,32,39,37,115,39,0,0,0,0,0,0,0,0,84,104,101,32,118,97,114,105,101,116,121,32,105,115,32,97,98,115,101,110,116,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,116,121,112,101,32,108,105,110,107,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,67,111,109,112,108,101,120,84,121,112,101,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,44,32,99,111,109,112,108,101,120,32,116,121,112,101,32,39,37,115,39,58,32,116,104,101,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,60,114,101,115,116,114,105,99,116,105,111,110,62,32,105,115,32,109,105,115,115,105,110,103,32,97,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,44,32,98,117,116,32,119,97,115,32,110,111,116,32,99,97,116,99,104,101,100,32,98,121,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,83,82,67,67,84,40,41,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,44,32,99,111,109,112,108,101,120,32,116,121,112,101,32,39,37,115,39,58,32,116,104,101,32,60,101,120,116,101,110,115,105,111,110,62,101,100,32,98,97,115,101,32,116,121,112,101,32,105,115,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,110,111,32,115,105,109,112,108,101,32,99,111,110,116,101,110,116,32,116,121,112,101,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,44,32,99,111,109,112,108,101,120,32,116,121,112,101,32,39,37,115,39,32,119,105,116,104,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,58,32,117,110,104,97,110,100,108,101,100,32,100,101,114,105,118,97,116,105,111,110,32,99,97,115,101,0,0,0,84,104,101,32,116,121,112,101,32,104,97,115,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,32,105,110,32,105,116,115,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,32,97,110,100,32,116,104,117,115,32,99,97,110,110,111,116,32,98,101,32,100,101,114,105,118,101,100,32,102,114,111,109,32,97,32,110,111,110,45,101,109,112,116,121,32,116,121,112,101,44,32,115,105,110,99,101,32,116,104,105,115,32,119,111,117,108,100,32,112,114,111,100,117,99,101,32,97,32,39,115,101,113,117,101,110,99,101,39,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,110,116,97,105,110,105,110,103,32,116,104,101,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,59,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,116,111,32,97,112,112,101,97,114,32,105,110,115,105,100,101,32,111,116,104,101,114,32,109,111,100,101,108,32,103,114,111,117,112,115,0,0,0,0,65,32,116,121,112,101,32,99,97,110,110,111,116,32,98,101,32,100,101,114,105,118,101,100,32,98,121,32,101,120,116,101,110,115,105,111,110,32,102,114,111,109,32,97,32,116,121,112,101,32,119,104,105,99,104,32,104,97,115,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,32,105,110,32,105,116,115,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,44,32,115,105,110,99,101,32,116,104,105,115,32,119,111,117,108,100,32,112,114,111,100,117,99,101,32,97,32,39,115,101,113,117,101,110,99,101,39,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,110,116,97,105,110,105,110,103,32,116,104,101,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,59,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,116,111,32,97,112,112,101,97,114,32,105,110,115,105,100,101,32,111,116,104,101,114,32,109,111,100,101,108,32,103,114,111,117,112,115,0,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,99,111,110,116,97,105,110,115,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,84,104,101,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,98,97,115,101,32,116,121,112,101,39,115,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,32,37,115,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,105,116,104,101,114,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,39,109,105,120,101,100,39,32,97,110,100,32,97,110,32,101,109,112,116,105,97,98,108,101,32,112,97,114,116,105,99,108,101,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,105,116,104,101,114,32,101,109,112,116,121,32,111,114,32,39,109,105,120,101,100,39,32,40,111,114,32,39,101,108,101,109,101,110,116,115,45,111,110,108,121,39,41,32,97,110,100,32,97,110,32,101,109,112,116,105,97,98,108,101,32,112,97,114,116,105,99,108,101,0,0,0,0,0,0,0,0,73,102,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,39,109,105,120,101,100,39,44,32,116,104,101,110,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,97,108,115,111,32,98,101,32,39,109,105,120,101,100,39,0,0,0,0,0,84,104,101,32,116,121,112,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,114,101,115,116,114,105,99,116,105,111,110,32,111,102,32,105,116,115,32,98,97,115,101,32,116,121,112,101,0,0,0,0,84,104,101,32,39,111,112,116,105,111,110,97,108,39,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,39,114,101,113,117,105,114,101,100,39,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,111,102,32,116,104,101,32,37,115,32,37,115,0,0,0,0,0,0,0,98,97,115,101,0,0,0,0,114,101,100,101,102,105,110,101,100,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,39,115,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,37,115,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,110,32,116,104,101,32,37,115,32,37,115,0,0,0,0,0,0,0,84,104,101,32,101,102,102,101,99,116,105,118,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,105,116,115,32,99,111,114,114,101,115,112,111,110,100,101,110,116,32,105,110,32,116,104,101,32,37,115,32,37,115,0,78,101,105,116,104,101,114,32,97,32,109,97,116,99,104,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,44,32,110,111,114,32,97,32,109,97,116,99,104,105,110,103,32,119,105,108,100,99,97,114,100,32,101,120,105,115,116,115,32,105,110,32,116,104,101,32,37,115,32,37,115,0,0,0,65,32,109,97,116,99,104,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,102,111,114,32,116,104,101,32,39,114,101,113,117,105,114,101,100,39,32,37,115,32,111,102,32,116,104,101,32,37,115,32,37,115,32,105,115,32,109,105,115,115,105,110,103,0,0,84,104,101,32,37,115,32,104,97,115,32,97,110,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,44,32,98,117,116,32,116,104,101,32,37,115,32,37,115,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,111,110,101,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,117,98,115,101,116,32,111,102,32,116,104,101,32,119,105,108,100,99,97,114,100,32,105,110,32,116,104,101,32,37,115,32,37,115,32,39,37,115,39,0,0,84,104,101,32,123,112,114,111,99,101,115,115,32,99,111,110,116,101,110,116,115,125,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,32,105,115,32,119,101,97,107,101,114,32,116,104,97,110,32,116,104,101,32,111,110,101,32,105,110,32,116,104,101,32,37,115,32,37,115,32,39,37,115,39,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,99,111,110,116,97,105,110,115,32,39,101,120,116,101,110,115,105,111,110,39,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,109,117,115,116,32,115,112,101,99,105,102,121,32,97,32,112,97,114,116,105,99,108,101,0,0,0,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,98,111,116,104,44,32,116,104,101,32,116,121,112,101,32,97,110,100,32,105,116,115,32,98,97,115,101,32,116,121,112,101,44,32,109,117,115,116,32,101,105,116,104,101,114,32,39,109,105,120,101,100,39,32,111,114,32,39,101,108,101,109,101,110,116,45,111,110,108,121,39,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,109,117,115,116,32,98,101,32,116,104,101,32,115,105,109,112,108,101,32,98,97,115,101,32,116,121,112,101,0,0,0,73,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,44,32,116,104,101,32,100,101,114,105,118,97,116,105,111,110,32,109,101,116,104,111,100,32,109,117,115,116,32,98,101,32,39,101,120,116,101,110,115,105,111,110,39,0,0,0,0,68,117,112,108,105,99,97,116,101,32,37,115,0,0,0,0,84,104,101,114,101,32,109,117,115,116,32,110,111,116,32,101,120,105,115,116,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,111,102,32,116,121,112,101,32,39,120,115,58,73,68,39,32,40,111,114,32,100,101,114,105,118,101,100,32,102,114,111,109,32,39,120,115,58,73,68,39,41,46,32,84,104,101,32,37,115,32,118,105,111,108,97,116,101,115,32,116,104,105,115,32,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,73,116,101,109,76,105,115,116,82,101,109,111,118,101,44,32,105,110,100,101,120,32,101,114,114,111,114,46,10,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,84,121,112,101,65,116,116,114,105,98,117,116,101,85,115,101,115,0,110,111,32,98,97,115,101,32,116,121,112,101,0,0,0,0,102,97,105,108,101,100,32,116,111,32,101,120,112,97,110,100,32,97,116,116,114,105,98,117,116,101,115,0,0,0,0,0,84,104,101,32,117,110,105,111,110,32,111,102,32,116,104,101,32,119,105,108,99,97,114,100,32,105,115,32,110,111,116,32,101,120,112,114,101,115,115,105,98,108,101,46,10,0,0,0,99,114,101,97,116,105,110,103,32,119,105,108,100,99,97,114,100,32,110,97,109,101,115,112,97,99,101,32,99,111,110,115,116,114,97,105,110,116,0,0,120,109,108,83,99,104,101,109,97,69,120,112,97,110,100,65,116,116,114,105,98,117,116,101,71,114,111,117,112,82,101,102,115,0,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,97,116,116,114,32,112,114,111,104,105,98,105,116,105,111,110,32,102,111,117,110,100,0,0,0,0,0,0,0,83,107,105,112,112,105,110,103,32,112,111,105,110,116,108,101,115,115,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,32,39,37,115,39,44,32,115,105,110,99,101,32,97,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,101,120,105,115,116,115,32,97,108,114,101,97,100,121,32,105,110,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,84,104,101,32,105,110,116,101,114,115,101,99,116,105,111,110,32,111,102,32,116,104,101,32,119,105,108,99,97,114,100,32,105,115,32,110,111,116,32,101,120,112,114,101,115,115,105,98,108,101,46,10,0,0,0,0,97,100,100,105,110,103,32,119,105,108,100,99,97,114,100,0,97,108,108,111,99,97,116,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,109,112,111,110,101,110,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,97,114,116,105,99,108,101,32,99,111,109,112,111,110,101,110,116,0,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,83,105,109,112,108,101,84,121,112,101,83,116,97,103,101,79,110,101,0,0,0,0,0,0,0,0,108,105,115,116,32,116,121,112,101,32,104,97,115,32,110,111,32,105,116,101,109,45,116,121,112,101,32,97,115,115,105,103,110,101,100,0,0,0,0,0,117,110,105,111,110,32,116,121,112,101,32,104,97,115,32,110,111,32,109,101,109,98,101,114,45,116,121,112,101,115,32,97,115,115,105,103,110,101,100,0,116,121,112,101,32,104,97,115,32,110,111,32,98,97,115,101,45,116,121,112,101,32,97,115,115,105,103,110,101,100,0,0,97,108,108,111,99,97,116,105,110,103,32,116,121,112,101,0,97,108,108,111,99,97,116,105,110,103,32,114,101,100,101,102,105,110,105,116,105,111,110,32,105,110,102,111,0,0,0,0,73,102,32,117,115,105,110,103,32,60,99,111,109,112,108,101,120,67,111,110,116,101,110,116,62,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,105,115,32,101,120,112,101,99,116,101,100,32,116,111,32,98,101,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,0,0,73,102,32,117,115,105,110,103,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,97,110,100,32,60,114,101,115,116,114,105,99,116,105,111,110,62,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,83,82,67,67,84,44,32,39,37,115,39,44,32,98,97,115,101,32,116,121,112,101,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,32,116,121,112,101,0,0,0,0,0,0,0,0,65,32,60,115,105,109,112,108,101,84,121,112,101,62,32,105,115,32,101,120,112,101,99,116,101,100,32,97,109,111,110,103,32,116,104,101,32,99,104,105,108,100,114,101,110,32,111,102,32,60,114,101,115,116,114,105,99,116,105,111,110,62,44,32,105,102,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,105,115,32,117,115,101,100,32,97,110,100,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,0,0,73,102,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,97,110,100,32,60,114,101,115,116,114,105,99,116,105,111,110,62,32,105,115,32,117,115,101,100,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,109,105,120,101,100,32,99,111,110,116,101,110,116,32,97,110,100,32,112,97,114,116,105,99,108,101,32,101,109,112,116,105,97,98,108,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,110,101,32,111,102,32,116,104,111,115,101,0,0,0,0,0,0,73,102,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,97,110,100,32,60,101,120,116,101,110,115,105,111,110,62,32,105,115,32,117,115,101,100,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,184,44,2,0,0,0,0,0,84,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,110,111,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,110,32,115,99,111,112,101,0,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,76,111,111,107,117,112,78,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,110,111,32,110,111,100,101,32,111,114,32,110,111,100,101,39,115,32,100,111,99,32,97,118,97,108,105,97,98,108,101,0,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,118,97,108,117,101,32,111,102,32,0,0,0,84,104,101,32,99,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,118,97,108,117,101,32,111,102,32,0,0,116,104,101,32,108,111,99,97,108,32,0,0,0,0,0,0,116,104,101,32,0,0,0,0,120,115,58,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,87,105,108,100,99,97,114,100,0,0,0,98,97,100,32,97,114,103,117,109,101,110,116,115,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,103,108,111,98,97,108,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,44,32,98,117,116,32,100,101,109,97,110,100,101,100,32,98,121,32,116,104,101,32,115,116,114,105,99,116,32,119,105,108,100,99,97,114,100,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,80,114,111,99,101,115,115,88,83,73,84,121,112,101,40,41,32,116,111,32,112,114,111,99,101,115,115,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,110,105,108,39,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,67,104,105,108,100,69,108,101,109,0,0,0,0,0,0,110,111,116,32,105,110,116,101,110,100,101,100,32,102,111,114,32,116,104,101,32,118,97,108,105,100,97,116,105,111,110,32,114,111,111,116,0,0,0,0,78,101,105,116,104,101,114,32,99,104,97,114,97,99,116,101,114,32,110,111,114,32,101,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,101,108,101,109,101,110,116,32,119,97,115,32,39,110,105,108,108,101,100,39,0,0,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,101,109,112,116,121,0,0,0,0,0,0,0,116,121,112,101,32,104,97,115,32,101,108,101,109,32,99,111,110,116,101,110,116,32,98,117,116,32,110,111,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,105,100,97,116,105,110,103,32,101,108,101,109,44,32,98,117,116,32,101,108,101,109,32,99,111,110,116,101,110,116,32,105,115,32,97,108,114,101,97,100,121,32,105,110,118,97,108,105,100,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,82,101,103,69,120,101,99,80,117,115,104,83,116,114,105,110,103,50,40,41,0,84,104,105,115,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,101,120,112,101,99,116,101,100,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,115,105,109,112,108,101,0,0,0,84,104,101,32,118,97,108,117,101,32,109,117,115,116,32,99,111,110,115,105,115,116,32,111,102,32,116,117,112,108,101,115,58,32,116,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,97,110,100,32,116,104,101,32,100,111,99,117,109,101,110,116,39,115,32,85,82,73,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,115,115,101,109,98,108,101,66,121,88,83,73,0,0,97,115,115,101,109,98,108,105,110,103,32,115,99,104,101,109,97,116,97,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,115,115,101,109,98,108,101,66,121,76,111,99,97,116,105,111,110,0,0,0,0,0,110,111,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,32,97,118,97,105,108,97,98,108,101,0,0,0,0,0,110,111,32,99,111,110,115,116,114,117,99,116,111,114,0,0,84,104,101,32,100,111,99,117,109,101,110,116,32,97,116,32,108,111,99,97,116,105,111,110,32,39,37,115,39,32,99,111,117,108,100,32,110,111,116,32,98,101,32,97,99,113,117,105,114,101,100,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,117,115,104,65,116,116,114,105,98,117,116,101,0,0,110,105,108,0,0,0,0,0,152,95,2,0,0,0,0,0,116,121,112,101,0,0,0,0,115,99,104,101,109,97,76,111,99,97,116,105,111,110,0,0,110,111,78,97,109,101,115,112,97,99,101,83,99,104,101,109,97,76,111,99,97,116,105,111,110,0,0,0,0,0,0,0,120,95,2,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,45,105,110,115,116,97,110,99,101,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,117,115,104,69,108,101,109,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,69,108,101,109,73,110,102,111,40,41,0,0,0,0,0,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,69,108,101,109,73,110,102,111,0,0,0,0,0,0,0,105,110,99,111,110,115,105,115,116,101,110,116,32,100,101,112,116,104,32,101,110,99,111,117,110,116,101,114,101,100,0,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,101,108,101,109,101,110,116,32,105,110,102,111,32,97,114,114,97,121,0,0,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,101,108,101,109,101,110,116,32,105,110,102,111,32,97,114,114,97,121,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,101,108,101,109,101,110,116,32,105,110,102,111,0,0,0,0,0,0,101,108,101,109,32,105,110,102,111,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,108,101,97,114,101,100,0,0,120,109,108,83,99,104,101,109,97,86,83,116,97,114,116,0,110,111,32,105,110,115,116,97,110,99,101,32,116,111,32,118,97,108,105,100,97,116,101,0,120,109,108,83,99,104,101,109,97,68,111,99,87,97,108,107,0,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,68,111,99,87,97,108,107,0,0,0,0,0,0,0,116,104,101,114,101,32,105,115,32,97,116,32,108,101,97,115,116,32,111,110,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,105,110,32,116,104,101,32,110,111,100,101,45,116,114,101,101,32,99,117,114,114,101,110,116,108,121,32,98,101,105,110,103,32,118,97,108,105,100,97,116,101,100,46,32,80,114,111,99,101,115,115,105,110,103,32,111,102,32,101,110,116,105,116,105,101,115,32,119,105,116,104,32,116,104,105,115,32,88,77,76,32,83,99,104,101,109,97,32,112,114,111,99,101,115,115,111,114,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,40,121,101,116,41,46,32,80,108,101,97,115,101,32,115,117,98,115,116,105,116,117,116,101,32,101,110,116,105,116,105,101,115,32,98,101,102,111,114,101,32,118,97,108,105,100,97,116,105,111,110,46,0,0,101,108,101,109,101,110,116,32,112,111,115,105,116,105,111,110,32,109,105,115,109,97,116,99,104,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,105,116,101,109,32,108,105,115,116,32,115,116,114,117,99,116,117,114,101,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,67,104,101,99,107,67,86,67,83,105,109,112,108,101,84,121,112,101,0,0,0,0,99,111,117,108,100,32,110,111,116,32,103,101,116,32,116,104,101,32,98,117,105,108,116,45,105,110,32,116,121,112,101,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,98,117,105,108,116,45,105,110,32,116,121,112,101,0,0,0,0,0,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,115,32,111,102,32,97,116,111,109,105,99,32,115,105,109,112,108,101,32,116,121,112,101,0,118,97,108,105,100,97,116,105,110,103,32,97,110,32,105,116,101,109,32,111,102,32,108,105,115,116,32,115,105,109,112,108,101,32,116,121,112,101,0,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,115,32,111,102,32,108,105,115,116,32,115,105,109,112,108,101,32,116,121,112,101,0,0,0,117,110,105,111,110,32,115,105,109,112,108,101,32,116,121,112,101,32,104,97,115,32,110,111,32,109,101,109,98,101,114,32,116,121,112,101,115,0,0,0,118,97,108,105,100,97,116,105,110,103,32,109,101,109,98,101,114,115,32,111,102,32,117,110,105,111,110,32,115,105,109,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+146288),
	allocate([108,101,32,116,121,112,101,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,115,32,111,102,32,117,110,105,111,110,32,115,105,109,112,108,101,32,116,121,112,101,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,70,97,99,101,116,115,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,97,116,111,109,105,99,32,116,121,112,101,32,102,97,99,101,116,0,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,108,105,115,116,32,116,121,112,101,32,102,97,99,101,116,0,0,0,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,110,32,101,110,117,109,101,114,97,116,105,111,110,32,102,97,99,101,116,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,112,97,116,116,101,114,110,32,102,97,99,101,116,0,0,0,0,0,0,39,93,32,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,97,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,59,32,0,0,0,84,104,101,32,118,97,108,117,101,32,104,97,115,32,97,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,59,32,0,0,0,0,0,0,0,0,37,108,117,0,0,0,0,0,116,104,105,115,32,100,105,102,102,101,114,115,32,102,114,111,109,32,116,104,101,32,97,108,108,111,119,101,100,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,46,10,0,0,116,104,105,115,32,101,120,99,101,101,100,115,32,116,104,101,32,97,108,108,111,119,101,100,32,109,97,120,105,109,117,109,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,46,10,0,0,0,0,0,0,0,116,104,105,115,32,117,110,100,101,114,114,117,110,115,32,116,104,101,32,97,108,108,111,119,101,100,32,109,105,110,105,109,117,109,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,46,10,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,101,108,101,109,101,110,116,32,111,102,32,116,104,101,32,115,101,116,32,123,37,115,125,46,10,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,99,99,101,112,116,101,100,32,98,121,32,116,104,101,32,112,97,116,116,101,114,110,32,39,37,115,39,46,10,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,109,105,110,105,109,117,109,32,118,97,108,117,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,116,104,101,32,109,97,120,105,109,117,109,32,118,97,108,117,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,39,37,115,39,46,10,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,109,117,115,116,32,98,101,32,108,101,115,115,32,116,104,97,110,32,39,37,115,39,46,10,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,109,111,114,101,32,100,105,103,105,116,115,32,116,104,97,110,32,97,114,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,109,111,114,101,32,102,114,97,99,116,105,111,110,97,108,32,100,105,103,105,116,115,32,116,104,97,110,32,97,114,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,102,97,99,101,116,45,118,97,108,105,100,46,10,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,105,115,32,110,111,116,32,102,97,99,101,116,45,118,97,108,105,100,46,10,0,0,120,109,108,83,99,104,101,109,97,70,111,114,109,97,116,70,97,99,101,116,69,110,117,109,83,101,116,0,0,0,0,0,99,111,109,112,117,116,101,32,116,104,101,32,99,97,110,111,110,105,99,97,108,32,108,101,120,105,99,97,108,32,114,101,112,114,101,115,101,110,116,97,116,105,111,110,0,0,0,0,44,32,39,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,81,78,97,109,101,0,0,99,97,108,108,105,110,103,32,120,109,108,86,97,108,105,100,97,116,101,81,78,97,109,101,40,41,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,78,111,116,97,116,105,111,110,0,0,0,0,0,0,0,97,32,115,99,104,101,109,97,32,105,115,32,110,101,101,100,101,100,32,111,110,32,116,104,101,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,0,112,97,116,116,101,114,110,0,109,97,120,69,120,99,108,117,115,105,118,101,0,0,0,0,109,97,120,73,110,99,108,117,115,105,118,101,0,0,0,0,109,105,110,69,120,99,108,117,115,105,118,101,0,0,0,0,109,105,110,73,110,99,108,117,115,105,118,101,0,0,0,0,119,104,105,116,101,83,112,97,99,101,0,0,0,0,0,0,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,108,101,110,103,116,104,0,0,109,97,120,76,101,110,103,116,104,0,0,0,0,0,0,0,109,105,110,76,101,110,103,116,104,0,0,0,0,0,0,0,116,111,116,97,108,68,105,103,105,116,115,0,0,0,0,0,102,114,97,99,116,105,111,110,68,105,103,105,116,115,0,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,0,0,67,97,110,110,111,116,32,99,114,101,97,116,101,32,97,117,116,111,109,97,116,97,32,102,111,114,32,99,111,109,112,108,101,120,32,116,121,112,101,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,116,104,101,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,105,115,32,110,111,116,32,100,101,116,101,114,109,105,110,105,115,116,0,0,0,0,120,109,108,83,99,104,101,109,97,66,117,105,108,100,65,67,111,110,116,101,110,116,77,111,100,101,108,0,0,0,0,0,112,97,114,116,105,99,108,101,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,0,60,101,108,101,109,101,110,116,62,32,112,97,114,116,105,99,108,101,32,104,97,115,32,110,111,32,116,101,114,109,0,0,102,111,117,110,100,32,117,110,101,120,112,101,99,116,101,100,32,116,101,114,109,32,111,102,32,116,121,112,101,32,39,37,115,39,32,105,110,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,66,117,105,108,100,67,111,110,116,101,110,116,77,111,100,101,108,70,111,114,83,117,98,115,116,71,114,111,117,112,44,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,109,97,114,107,101,100,32,104,97,118,105,110,103,32,97,32,115,117,98,115,116,46,32,103,114,111,117,112,32,98,117,116,32,110,111,110,101,32,97,118,97,105,108,97,98,108,101,46,10,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,99,111,110,116,97,105,110,101,114,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,83,117,98,115,116,71,114,111,117,112,65,100,100,0,0,102,97,105,108,101,100,32,116,111,32,97,100,100,32,97,32,110,101,119,32,115,117,98,115,116,105,116,117,116,105,111,110,32,99,111,110,116,97,105,110,101,114,0,0,0,0,0,0,79,110,108,121,32,103,108,111,98,97,108,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,115,32,99,97,110,32,104,97,118,101,32,97,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,97,102,102,105,108,105,97,116,105,111,110,0,0,0,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,32,100,101,102,105,110,101,115,32,97,32,99,105,114,99,117,108,97,114,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,116,111,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,119,97,115,32,101,105,116,104,101,114,32,114,101,106,101,99,116,101,100,32,98,121,32,116,104,101,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,97,102,102,105,108,105,97,116,105,111,110,32,39,37,115,39,44,32,111,114,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,105,116,115,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,40,111,114,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,39,115,32,99,111,110,116,101,110,116,32,116,121,112,101,41,32,105,115,32,111,114,32,105,115,32,100,101,114,105,118,101,100,32,102,114,111,109,32,73,68,59,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,99,111,110,106,117,110,99,116,105,111,110,32,119,105,116,104,32,115,117,99,104,32,97,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,69,108,101,109,80,114,111,112,115,67,111,114,114,101,99,116,44,32,116,121,112,101,32,105,115,32,109,105,115,115,105,110,103,46,46,46,32,115,107,105,112,112,105,110,103,32,118,97,108,105,100,97,116,105,111,110,32,111,102,32,116,104,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,0,0,102,105,120,101,100,0,0,0,100,101,102,97,117,108,116,0,120,109,108,83,99,104,101,109,97,69,108,101,109,67,104,101,99,107,86,97,108,67,111,110,115,116,114,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,111,102,32,97,110,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,0,70,111,114,32,97,32,115,116,114,105,110,103,32,116,111,32,98,101,32,97,32,118,97,108,105,100,32,100,101,102,97,117,108,116,44,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,109,105,120,101,100,32,99,111,110,116,101,110,116,32,97,110,100,32,97,32,112,97,114,116,105,99,108,101,32,101,109,112,116,105,97,98,108,101,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,67,104,101,99,107,67,79,83,86,97,108,105,100,68,101,102,97,117,108,116,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,97,32,39,102,105,120,101,100,39,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,44,32,116,104,117,115,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,109,117,115,116,32,97,108,115,111,32,104,97,118,101,32,97,32,39,102,105,120,101,100,39,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,86,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,102,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,111,114,32,105,115,32,100,101,114,105,118,101,100,32,102,114,111,109,32,120,115,58,73,68,0,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,65,116,116,114,85,115,101,80,114,111,112,115,67,111,114,114,101,99,116,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,0,0,84,104,101,32,39,102,105,120,101,100,39,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,109,117,115,116,32,109,97,116,99,104,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,39,115,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,65,116,116,114,80,114,111,112,115,67,111,114,114,101,99,116,0,0,84,104,101,32,117,110,105,111,110,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,99,105,114,99,117,108,97,114,0,0,0,67,105,114,99,117,108,97,114,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,32,39,37,115,39,32,100,101,102,105,110,101,100,0,0,67,105,114,99,117,108,97,114,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,100,101,102,105,110,101,100,0,0,0,84,104,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,99,105,114,99,117,108,97,114,0,0,0,0,0,0,114,101,102,0,0,0,0,0,37,115,44,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,58,32,84,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,114,101,115,111,108,118,101,32,116,111,32,97,40,110,41,32,37,115,46,10,0,0,114,101,102,101,114,0,0,0,84,104,101,32,107,101,121,114,101,102,32,114,101,102,101,114,101,110,99,101,115,32,97,32,107,101,121,114,101,102,0,0,84,104,101,32,99,97,114,100,105,110,97,108,105,116,121,32,111,102,32,116,104,101,32,107,101,121,114,101,102,32,100,105,102,102,101,114,115,32,102,114,111,109,32,116,104,101,32,99,97,114,100,105,110,97,108,105,116,121,32,111,102,32,116,104,101,32,114,101,102,101,114,101,110,99,101,100,32,107,101,121,47,117,110,105,113,117,101,32,39,37,115,39,0,0,0,0,65,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,114,101,102,101,114,101,110,99,101,100,44,32,98,117,116,32,105,116,32,99,111,110,116,97,105,110,115,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,44,32,119,104,105,99,104,32,99,97,110,110,111,116,32,98,101,32,99,111,110,116,97,105,110,101,100,32,98,121,32,109,111,100,101,108,32,103,114,111,117,112,115,0,105,116,101,109,84,121,112,101,0,0,0,0,0,0,0,0,84,104,101,32,112,97,114,116,105,99,108,101,39,115,32,123,109,97,120,32,111,99,99,117,114,115,125,32,109,117,115,116,32,98,101,32,49,44,32,115,105,110,99,101,32,116,104,101,32,114,101,102,101,114,101,110,99,101,32,114,101,115,111,108,118,101,115,32,116,111,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,0,0,0,0,0,109,101,109,98,101,114,84,121,112,101,115,0,0,0,0,0,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,115,117,98,115,116,105,116,117,116,105,111,110,71,114,111,117,112,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,100,100,67,111,109,112,111,110,101,110,116,115,0,0,85,110,101,120,112,101,99,116,101,100,32,103,108,111,98,97,108,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,99,111,109,112,111,110,101,110,116,32,104,97,115,104,32,116,97,98,108,101,0,65,32,103,108,111,98,97,108,32,37,115,32,39,37,115,39,32,100,111,101,115,32,97,108,114,101,97,100,121,32,101,120,105,115,116,0,0,0,0,0,84,104,101,32,37,115,32,39,37,115,39,32,116,111,32,98,101,32,114,101,100,101,102,105,110,101,100,32,99,111,117,108,100,32,110,111,116,32,98,101,32,102,111,117,110,100,32,105,110,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,0,0,120,109,108,83,99,104,101,109,97,82,101,115,111,108,118,101,82,101,100,101,102,82,101,102,101,114,101,110,99,101,115,0,85,110,101,120,112,101,99,116,101,100,32,114,101,100,101,102,105,110,101,100,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,0,0,0,0,0,84,104,101,32,114,101,102,101,114,101,110,99,101,100,32,37,115,32,119,97,115,32,97,108,114,101,97,100,121,32,114,101,100,101,102,105,110,101,100,46,32,77,117,108,116,105,112,108,101,32,114,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,115,97,109,101,32,99,111,109,112,111,110,101,110,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,105,110,99,108,117,100,101,0,105,109,112,111,114,116,0,0,114,101,100,101,102,105,110,101,0,0,0,0,0,0,0,0,97,110,110,111,116,97,116,105,111,110,0,0,0,0,0,0,99,111,109,112,108,101,120,84,121,112,101,0,0,0,0,0,115,105,109,112,108,101,84,121,112,101,0,0,0,0,0,0,101,108,101,109,101,110,116,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,71,114,111,117,112,0,0,103,114,111,117,112,0,0,0,110,111,116,97,116,105,111,110,0,0,0,0,0,0,0,0,40,40,105,110,99,108,117,100,101,32,124,32,105,109,112,111,114,116,32,124,32,114,101,100,101,102,105,110,101,32,124,32,97,110,110,111,116,97,116,105,111,110,41,42,44,32,40,40,40,115,105,109,112,108,101,84,121,112,101,32,124,32,99,111,109,112,108,101,120,84,121,112,101,32,124,32,103,114,111,117,112,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,32,124,32,101,108,101,109,101,110,116,32,124,32,97,116,116,114,105,98,117,116,101,32,124,32,110,111,116,97,116,105,111,110,41,44,32,97,110,110,111,116,97,116,105,111,110,42,41,42,41,0,0,0,37,115,58,32,37,115,46,10,0,0,0,0,0,0,0,0,37,115,58,32,84,104,101,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,46,32,69,120,112,101,99,116,101,100,32,105,115,32,37,115,46,10,0,0,37,115,58,32,84,104,101,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,46,10,0,0,110,97,109,101,0,0,0,0,78,111,116,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,105,100,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,41,0,0,0,68,117,112,108,105,99,97,116,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,73,68,39,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,73,68,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,39,120,115,58,78,67,78,97,109,101,39,0,0,0,0,0,0,0,0,39,46,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,118,97,108,105,100,46,0,0,0,0,84,104,101,32,99,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,46,0,0,0,0,0,32,69,120,112,101,99,116,101,100,32,105,115,32,39,0,0,39,46,10,0,0,0,0,0,97,100,100,32,97,110,110,111,116,97,116,105,111,110,0,0,97,108,108,0,0,0,0,0,99,104,111,105,99,101,0,0,115,101,113,117,101,110,99,101,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,41,0,0,0,0,0,0,0,40,48,32,124,32,49,41,0,49,0,0,0,0,0,0,0,120,115,58,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,40,120,115,58,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,32,124,32,117,110,98,111,117,110,100,101,100,41,0,0,0,0,0,109,97,120,79,99,99,117,114,115,0,0,0,0,0,0,0,109,105,110,79,99,99,117,114,115,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,109,105,110,79,99,99,117,114,115,32,40,109,117,115,116,32,98,101,32,48,32,111,114,32,49,41,0,0,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,109,97,120,79,99,99,117,114,115,32,40,109,117,115,116,32,98,101,32,48,32,111,114,32,49,41,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,97,110,110,111,116,97,116,105,111,110,63,44,32,101,108,101,109,101,110,116,42,41,0,0,0,97,110,121,0,0,0,0,0,84,104,101,32,114,101,100,101,102,105,110,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,100,101,102,105,110,105,116,105,111,110,0,84,104,101,32,114,101,100,101,102,105,110,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,97,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,100,101,102,105,110,105,116,105,111,110,32,119,105,116,104,32,97,32,109,97,120,79,99,99,117,114,115,47,109,105,110,79,99,99,117,114,115,32,111,116,104,101,114,32,116,104,97,110,32,49,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,101,108,101,109,101,110,116,32,124,32,103,114,111,117,112,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,32,124,32,97,110,121,41,42,41,0,0,0,0,0,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,112,114,111,99,101,115,115,67,111,110,116,101,110,116,115,0,40,115,116,114,105,99,116,32,124,32,115,107,105,112,32,124,32,108,97,120,41,0,0,0,35,35,97,110,121,0,0,0,40,40,35,35,97,110,121,32,124,32,35,35,111,116,104,101,114,41,32,124,32,76,105,115,116,32,111,102,32,40,120,115,58,97,110,121,85,82,73,32,124,32,40,35,35,116,97,114,103,101,116,78,97,109,101,115,112,97,99,101,32,124,32,35,35,108,111,99,97,108,41,41,41,0,0,0,0,0,0,0,35,35,116,97,114,103,101,116,78,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,35,35,108,111,99,97,108,0,120,109,108,83,99,104,101,109,97,80,86,97,108,65,116,116,114,78,111,100,101,86,97,108,117,101,0,0,0,0,0,0,116,104,101,32,103,105,118,101,110,32,116,121,112,101,32,105,115,32,110,111,116,32,97,32,98,117,105,108,116,45,105,110,32,116,121,112,101,0,0,0,118,97,108,105,100,97,116,105,111,110,32,117,115,105,110,103,32,116,104,101,32,103,105,118,101,110,32,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,119,104,105,108,101,32,112,97,114,115,105,110,103,32,97,32,115,99,104,101,109,97,0,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,97,32,115,99,104,101,109,97,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,81,78,97,109,101,32,114,101,102,101,114,101,110,99,101,32,105,116,101,109,0,82,101,102,101,114,101,110,99,101,115,32,102,114,111,109,32,116,104,105,115,32,115,99,104,101,109,97,32,116,111,32,99,111,109,112,111,110,101,110,116,115,32,105,110,32,110,111,32,110,97,109,101,115,112,97,99,101,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,44,32,115,105,110,99,101,32,110,111,116,32,105,110,100,105,99,97,116,101,100,32,98,121,32,97,110,32,105,109,112,111,114,116,32,115,116,97,116,101,109,101,110,116,0,0,0,82,101,102,101,114,101,110,99,101,115,32,102,114,111,109,32,116,104,105,115,32,115,99,104,101,109,97,32,116,111,32,99,111,109,112,111,110,101,110,116,115,32,105,110,32,116,104,101,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,44,32,115,105,110,99,101,32,110,111,116,32,105,110,100,105,99,97,116,101,100,32,98,121,32,97,110,32,105,109,112,111,114,116,32,115,116,97,116,101,109,101,110,116,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,81,78,97,109,101,39,32,104,97,115,32,110,111,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,110,32,115,99,111,112,101,0,0,0,0,84,104,101,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,32,49,0,0,0,0,84,104,101,32,118,97,108,117,101,32,109,117,115,116,32,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,116,104,101,32,118,97,108,117,101,32,111,102,32,39,109,97,120,79,99,99,117,114,115,39,0,0,0,0,0,37,115,44,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,58,32,37,115,46,10,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,0,117,110,98,111,117,110,100,101,100,0,0,0,0,0,0,0,37,115,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,10,0,0,0,97,100,100,105,110,103,32,103,114,111,117,112,0,0,0,0,37,115,58,32,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,114,101,113,117,105,114,101,100,32,98,117,116,32,109,105,115,115,105,110,103,46,10,0,0,0,0,0,0,0,0,97,110,121,65,116,116,114,105,98,117,116,101,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,0,0,0,84,104,101,32,114,101,100,101,102,105,110,105,110,103,32,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,102,111,114,109,0,0,0,0,113,117,97,108,105,102,105,101,100,0,0,0,0,0,0,0,117,110,113,117,97,108,105,102,105,101,100,0,0,0,0,0,40,113,117,97,108,105,102,105,101,100,32,124,32,117,110,113,117,97,108,105,102,105,101,100,41,0,0,0,0,0,0,0,117,115,101,0,0,0,0,0,111,112,116,105,111,110,97,108,0,0,0,0,0,0,0,0,112,114,111,104,105,98,105,116,101,100,0,0,0,0,0,0,114,101,113,117,105,114,101,100,0,0,0,0,0,0,0,0,40,111,112,116,105,111,110,97,108,32,124,32,112,114,111,104,105,98,105,116,101,100,32,124,32,114,101,113,117,105,114,101,100,41,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,117,115,101,39,32,109,117,115,116,32,98,101,32,39,111,112,116,105,111,110,97,108,39,32,105,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,100,101,102,97,117,108,116,39,32,105,115,32,112,114,101,115,101,110,116,0,0,0,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,109,117,115,116,32,110,111,116,32,109,97,116,99,104,32,39,37,115,39,0,0,0,0,0,0,0,0,120,109,108,110,115,0,0,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,109,117,115,116,32,110,111,116,32,109,97,116,99,104,32,39,120,109,108,110,115,39,0,0,0,0,0,0,0,83,107,105,112,112,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,44,32,115,105,110,99,101,32,105,116,32,105,115,32,112,111,105,110,116,108,101,115,115,32,105,110,115,105,100,101,32,97,110,32,60,97,116,116,114,105,98,117,116,101,71,114,111,117,112,62,0,0,0,0,83,107,105,112,112,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,44,32,115,105,110,99,101,32,105,116,32,105,115,32,112,111,105,110,116,108,101,115,115,32,119,104,101,110,32,101,120,116,101,110,100,105,110,103,32,97,32,116,121,112,101,0,83,107,105,112,112,105,110,103,32,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,32,39,37,115,39,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,116,121,112,101,39,32,97,110,100,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,115,105,109,112,108,101,84,121,112,101,63,41,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,0,0,0,0,37,115,58,32,84,104,101,32,97,116,116,114,105,98,117,116,101,115,32,39,37,115,39,32,97,110,100,32,39,37,115,39,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,46,10,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,0,0,0,0,0,0,79,110,108,121,32,116,104,101,32,97,116,116,114,105,98,117,116,101,115,32,39,109,105,110,79,99,99,117,114,115,39,44,32,39,109,97,120,79,99,99,117,114,115,39,32,97,110,100,32,39,105,100,39,32,97,114,101,32,97,108,108,111,119,101,100,32,105,110,32,97,100,100,105,116,105,111,110,32,116,111,32,39,114,101,102,39,0,0,98,108,111,99,107,0,0,0,110,105,108,108,97,98,108,101,0,0,0,0,0,0,0,0,102,105,110,97,108,0,0,0,97,98,115,116,114,97,99,116,0,0,0,0,0,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,41,41,0,0,0,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,32,124,32,115,117,98,115,116,105,116,117,116,105,111,110,41,41,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,116,121,112,101,39,32,97,110,100,32,116,104,101,32,60,99,111,109,112,108,101,120,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,117,110,105,113,117,101,0,0,107,101,121,0,0,0,0,0,107,101,121,114,101,102,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,40,115,105,109,112,108,101,84,121,112,101,32,124,32,99,111,109,112,108,101,120,84,121,112,101,41,63,44,32,40,117,110,105,113,117,101,32,124,32,107,101,121,32,124,32,107,101,121,114,101,102,41,42,41,41,0,0,65,32,99,104,105,108,100,32,101,108,101,109,101,110,116,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,101,108,101,99,116,111,114,44,32,102,105,101,108,100,43,41,41,0,0,0,0,0,0,0,115,101,108,101,99,116,111,114,0,0,0,0,0,0,0,0,102,105,101,108,100,0,0,0,120,112,97,116,104,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,39,115,101,108,101,99,116,111,114,39,32,111,102,32,97,110,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,80,97,114,115,101,73,68,67,83,101,108,101,99,116,111,114,65,110,100,70,105,101,108,100,44,32,118,97,108,105,100,97,116,105,110,103,32,116,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,111,102,32,97,32,73,68,67,32,115,101,108,101,99,116,111,114,46,10,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,65,100,100,65,110,110,111,116,97,116,105,111,110,44,32,84,104,101,32,105,116,101,109,32,105,115,32,110,111,116,32,97,32,97,110,110,111,116,97,116,101,100,32,115,99,104,101,109,97,32,99,111,109,112,111,110,101,110,116,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,83,101,108,101,99,116,111,114,88,80,97,116,104,44,32,116,104,101,32,115,101,108,101,99,116,111,114,32,105,115,32,110,111,116,32,115,112,101,99,105,102,105,101,100,46,10,0,0,0,84,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,111,102,32,116,104,101,32,115,101,108,101,99,116,111,114,32,105,115,32,110,111,116,32,118,97,108,105,100,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,110,97,109,101,115,112,97,99,101,32,97,114,114,97,121,0,0,0,0,84,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,39,37,115,39,32,99,111,117,108,100,32,110,111,116,32,98,101,32,99,111,109,112,105,108,101,100,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,35,97,108,108,0,0,0,0,101,120,116,101,110,115,105,111,110,0,0,0,0,0,0,0,114,101,115,116,114,105,99,116,105,111,110,0,0,0,0,0,115,117,98,115,116,105,116,117,116,105,111,110,0,0,0,0,108,105,115,116,0,0,0,0,117,110,105,111,110,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,48,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,101,108,101,109,101,110,116,0,0,0,0,0,0,82,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,98,117,105,108,116,45,105,110,32,115,105,109,112,108,101,32,116,121,112,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,108,105,115,116,32,124,32,117,110,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,41,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,114,101,115,116,114,105,99,116,105,111,110,32,124,32,108,105,115,116,32,124,32,117,110,105,111,110,41,41,0,0,0,0,0,84,104,105,115,32,105,115,32,97,32,114,101,100,101,102,105,110,105,116,105,111,110,44,32,116,104,117,115,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,109,117,115,116,32,104,97,118,101,32,97,32,60,114,101,115,116,114,105,99,116,105,111,110,62,32,99,104,105,108,100,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,85,110,105,111,110,44,32,97,108,108,111,99,97,116,105,110,103,32,97,32,116,121,112,101,32,108,105,110,107,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,115,105,109,112,108,101,84,121,112,101,42,41,0,0,0,0,0,0,69,105,116,104,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,109,101,109,98,101,114,84,121,112,101,115,39,32,111,114,32,97,116,32,108,101,97,115,116,32,111,110,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,109,117,115,116,32,98,101,32,112,114,101,115,101,110,116,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,105,116,101,109,84,121,112,101,39,32,97,110,100,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,0,0,0,0,0,69,105,116,104,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,105,116,101,109,84,121,112,101,39,32,111,114,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,109,117,115,116,32,98,101,32,112,114,101,115,101,110,116,0,0,0,0,0,0,0,84,104,105,115,32,105,115,32,97,32,114,101,100,101,102,105,110,105,116,105,111,110,44,32,98,117,116,32,116,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,39,98,97,115,101,39,32,97,116,116,114,105,98,117,116,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,116,121,112,101,39,115,32,100,101,115,105,103,110,97,116,105,111,110,32,39,37,115,39,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,98,97,115,101,39,32,97,110,100,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,0,69,105,116,104,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,98,97,115,101,39,32,111,114,32,97,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,109,117,115,116,32,98,101,32,112,114,101,115,101,110,116,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,102,97,99,101,116,32,108,105,110,107,0,97,110,110,111,116,97,116,105,111,110,63,44,32,40,103,114,111,117,112,32,124,32,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,105,109,112,108,101,84,121,112,101,63,44,32,40,109,105,110,69,120,99,108,117,115,105,118,101,32,124,32,109,105,110,73,110,99,108,117,115,105,118,101,32,124,32,109,97,120,69,120,99,108,117,115,105,118,101,32,124,32,109,97,120,73,110,99,108,117,115,105,118,101,32,124,32,116,111,116,97,108,68,105,103,105,116,115,32,124,32,102,114,97,99,116,105,111,110,68,105,103,105,116,115,32,124,32,108,101,110,103,116,104,32,124,32,109,105,110,76,101,110,103,116,104,32,124,32,109,97,120,76,101,110,103,116,104,32,124,32,101,110,117,109,101,114,97,116,105,111,110,32,124,32,119,104,105,116,101,83,112,97,99,101,32,124,32,112,97,116,116,101,114,110,41,42,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,105,109,112,108,101,84,121,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+156528),
	allocate([101,63,44,32,40,109,105,110,69,120,99,108,117,115,105,118,101,32,124,32,109,105,110,73,110,99,108,117,115,105,118,101,32,124,32,109,97,120,69,120,99,108,117,115,105,118,101,32,124,32,109,97,120,73,110,99,108,117,115,105,118,101,32,124,32,116,111,116,97,108,68,105,103,105,116,115,32,124,32,102,114,97,99,116,105,111,110,68,105,103,105,116,115,32,124,32,108,101,110,103,116,104,32,124,32,109,105,110,76,101,110,103,116,104,32,124,32,109,97,120,76,101,110,103,116,104,32,124,32,101,110,117,109,101,114,97,116,105,111,110,32,124,32,119,104,105,116,101,83,112,97,99,101,32,124,32,112,97,116,116,101,114,110,41,42,41,41,0,97,108,108,111,99,97,116,105,110,103,32,102,97,99,101,116,0,0,0,0,0,0,0,0,118,97,108,117,101,0,0,0,70,97,99,101,116,32,37,115,32,104,97,115,32,110,111,32,118,97,108,117,101,10,0,0,85,110,107,110,111,119,110,32,102,97,99,101,116,32,116,121,112,101,32,37,115,10,0,0,70,97,99,101,116,32,37,115,32,104,97,115,32,117,110,101,120,112,101,99,116,101,100,32,99,104,105,108,100,32,99,111,110,116,101,110,116,10,0,0,109,105,120,101,100,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,41,41,32,0,0,0,0,0,115,105,109,112,108,101,67,111,110,116,101,110,116,0,0,0,99,111,109,112,108,101,120,67,111,110,116,101,110,116,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,105,109,112,108,101,67,111,110,116,101,110,116,32,124,32,99,111,109,112,108,101,120,67,111,110,116,101,110,116,32,124,32,40,40,103,114,111,117,112,32,124,32,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,41,41,0,0,84,104,105,115,32,105,115,32,97,32,114,101,100,101,102,105,110,105,116,105,111,110,44,32,116,104,117,115,32,116,104,101,32,60,99,111,109,112,108,101,120,84,121,112,101,62,32,109,117,115,116,32,104,97,118,101,32,97,32,60,114,101,115,116,114,105,99,116,105,111,110,62,32,111,114,32,60,101,120,116,101,110,115,105,111,110,62,32,103,114,97,110,100,45,99,104,105,108,100,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,114,101,115,116,114,105,99,116,105,111,110,32,124,32,101,120,116,101,110,115,105,111,110,41,41,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,40,103,114,111,117,112,32,124,32,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,41,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,116,104,101,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,102,111,114,32,105,110,99,108,117,115,105,111,110,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,116,104,101,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,102,111,114,32,114,101,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,111,102,32,116,104,101,32,105,110,99,108,117,100,101,100,47,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,32,39,37,115,39,32,104,97,115,32,116,111,32,98,101,32,97,98,115,101,110,116,44,32,115,105,110,99,101,32,116,104,101,32,105,110,99,108,117,100,105,110,103,47,114,101,100,101,102,105,110,105,110,103,32,115,99,104,101,109,97,32,104,97,115,32,110,111,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,111,102,32,116,104,101,32,105,110,99,108,117,100,101,100,47,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,32,39,37,115,39,32,100,105,102,102,101,114,115,32,102,114,111,109,32,39,37,115,39,32,111,102,32,116,104,101,32,105,110,99,108,117,100,105,110,103,47,114,101,100,101,102,105,110,105,110,103,32,115,99,104,101,109,97,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,111,102,32,116,104,101,32,105,110,99,108,117,100,101,100,47,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,32,39,37,115,39,32,104,97,115,32,116,111,32,98,101,32,97,98,115,101,110,116,32,111,114,32,116,104,101,32,115,97,109,101,32,97,115,32,116,104,101,32,105,110,99,108,117,100,105,110,103,47,114,101,100,101,102,105,110,105,110,103,32,115,99,104,101,109,97,39,115,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,0,0,0,40,97,110,110,111,116,97,116,105,111,110,32,124,32,40,115,105,109,112,108,101,84,121,112,101,32,124,32,99,111,109,112,108,101,120,84,121,112,101,32,124,32,103,114,111,117,112,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,41,42,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,78,101,119,68,111,99,0,0,0,0,114,101,112,97,114,115,105,110,103,32,97,32,115,99,104,101,109,97,32,100,111,99,0,0,112,97,114,115,105,110,103,32,97,32,115,99,104,101,109,97,32,100,111,99,44,32,98,117,116,32,116,104,101,114,101,39,115,32,110,111,32,100,111,99,0,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,73,110,99,108,117,100,101,79,114,82,101,100,101,102,105,110,101,0,99,111,117,108,100,32,110,111,116,32,98,117,105,108,100,32,97,110,32,85,82,73,32,102,114,111,109,32,116,104,101,32,115,99,104,101,109,97,76,111,99,97,116,105,111,110,0,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,114,101,100,101,102,105,110,101,32,105,116,115,101,108,102,46,0,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,105,110,99,108,117,100,101,32,105,116,115,101,108,102,46,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,110,97,109,101,115,112,97,99,101,39,32,109,117,115,116,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,111,102,32,116,104,101,32,105,109,112,111,114,116,105,110,103,32,115,99,104,101,109,97,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,110,97,109,101,115,112,97,99,101,39,32,109,117,115,116,32,98,101,32,101,120,105,115,116,101,110,116,32,105,102,32,116,104,101,32,105,109,112,111,114,116,105,110,103,32,115,99,104,101,109,97,32,104,97,115,32,110,111,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,99,97,116,101,32,97,32,115,99,104,101,109,97,32,97,116,32,108,111,99,97,116,105,111,110,32,39,37,115,39,46,32,83,107,105,112,112,105,110,103,32,116,104,101,32,105,109,112,111,114,116,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,80,86,97,108,65,116,116,114,44,32,116,104,101,32,103,105,118,101,110,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,98,117,105,108,116,45,105,110,32,116,121,112,101,46,10,0,97,112,112,105,110,102,111,0,115,111,117,114,99,101,0,0,100,111,99,117,109,101,110,116,97,116,105,111,110,0,0,0,108,97,110,103,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,40,97,112,112,105,110,102,111,32,124,32,100,111,99,117,109,101,110,116,97,116,105,111,110,41,42,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,110,111,116,97,116,105,111,110,0,0,0,116,97,114,103,101,116,78,97,109,101,115,112,97,99,101,0,101,108,101,109,101,110,116,70,111,114,109,68,101,102,97,117,108,116,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,70,111,114,109,68,101,102,97,117,108,116,0,0,0,0,102,105,110,97,108,68,101,102,97,117,108,116,0,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,32,124,32,108,105,115,116,32,124,32,117,110,105,111,110,41,41,0,0,0,0,0,0,0,98,108,111,99,107,68,101,102,97,117,108,116,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,109,117,115,116,32,110,111,116,32,105,109,112,111,114,116,47,105,110,99,108,117,100,101,47,114,101,100,101,102,105,110,101,32,105,116,115,101,108,102,0,0,0,0,0,0,105,110,95,109,101,109,111,114,121,95,98,117,102,102,101,114,0,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,98,101,32,105,109,112,111,114,116,101,100,44,32,115,105,110,99,101,32,105,116,32,119,97,115,32,97,108,114,101,97,100,121,32,105,110,99,108,117,100,101,100,32,111,114,32,114,101,100,101,102,105,110,101,100,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,98,101,32,105,110,99,108,117,100,101,100,32,111,114,32,114,101,100,101,102,105,110,101,100,44,32,115,105,110,99,101,32,105,116,32,119,97,115,32,97,108,114,101,97,100,121,32,105,109,112,111,114,116,101,100,0,83,107,105,112,112,105,110,103,32,105,109,112,111,114,116,32,111,102,32,115,99,104,101,109,97,32,108,111,99,97,116,101,100,32,97,116,32,39,37,115,39,32,102,111,114,32,116,104,101,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,44,32,115,105,110,99,101,32,116,104,105,115,32,110,97,109,101,115,112,97,99,101,32,119,97,115,32,97,108,114,101,97,100,121,32,105,109,112,111,114,116,101,100,32,119,105,116,104,32,116,104,101,32,115,99,104,101,109,97,32,108,111,99,97,116,101,100,32,97,116,32,39,37,115,39,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,100,100,83,99,104,101,109,97,68,111,99,0,0,0,116,114,121,105,110,103,32,116,111,32,108,111,97,100,32,97,32,115,99,104,101,109,97,32,100,111,99,44,32,98,117,116,32,97,32,100,111,99,32,105,115,32,97,108,114,101,97,100,121,32,97,115,115,105,103,110,101,100,32,116,111,32,116,104,101,32,115,99,104,101,109,97,32,98,117,99,107,101,116,0,120,109,108,83,99,104,101,109,97,71,101,116,68,111,99,44,32,97,108,108,111,99,97,116,105,110,103,32,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,116,104,101,32,88,77,76,32,114,101,115,111,117,114,99,101,32,39,37,115,39,0,0,0,78,111,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,112,97,114,115,105,110,103,32,119,97,115,32,112,114,111,118,105,100,101,100,32,119,105,116,104,32,116,104,101,32,103,105,118,101,110,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,46,10,0,0,84,104,101,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,104,97,115,32,110,111,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,0,0,115,99,104,101,109,97,0,0,84,104,101,32,88,77,76,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,0,0,120,109,108,83,99,104,101,109,97,66,117,99,107,101,116,67,114,101,97,116,101,0,0,0,110,111,32,109,97,105,110,32,115,99,104,101,109,97,32,111,110,32,99,111,110,115,116,114,117,99,116,111,114,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,98,117,99,107,101,116,0,0,0,0,0,0,0,0,102,105,114,115,116,32,98,117,99,107,101,116,32,98,117,116,32,105,116,39,115,32,97,110,32,105,110,99,108,117,100,101,32,111,114,32,114,101,100,101,102,105,110,101,0,0,0,0,109,97,105,110,32,98,117,99,107,101,116,32,98,117,116,32,105,116,39,115,32,110,111,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,0,102,97,105,108,101,100,32,116,111,32,97,100,100,32,116,104,101,32,115,99,104,101,109,97,32,98,117,99,107,101,116,32,116,111,32,116,104,101,32,104,97,115,104,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,114,101,108,97,116,105,111,110,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,99,111,110,115,116,114,117,99,116,105,111,110,32,99,111,110,116,101,120,116,0,0,97,108,108,111,99,97,116,105,110,103,32,108,105,115,116,32,111,102,32,115,99,104,101,109,97,32,98,117,99,107,101,116,115,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,108,105,115,116,32,111,102,32,112,101,110,100,105,110,103,32,103,108,111,98,97,108,32,99,111,109,112,111,110,101,110,116,115,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,0,0,0,0,0,0,0,40,78,85,76,76,41,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,111,109,112,111,110,101,110,116,76,105,115,116,70,114,101,101,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,32,39,37,115,39,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,110,121,84,121,112,101,0,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,109,112,111,110,101,110,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,119,105,108,100,99,97,114,100,32,99,111,109,112,111,110,101,110,116,0,0,0,99,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,97,110,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,32,111,110,32,97,110,121,84,121,112,101,0,0,0,0,0,0,0,97,110,121,83,105,109,112,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,115,116,114,105,110,103,0,0,0,0,0,0,0,0,0,0,100,101,99,105,109,97,108,0,0,0,0,0,0,0,0,0,100,97,116,101,0,0,0,0,0,0,0,0,0,0,0,0,100,97,116,101,84,105,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,0,0,0,0,0,0,0,0,103,89,101,97,114,0,0,0,0,0,0,0,0,0,0,0,103,89,101,97,114,77,111,110,116,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,77,111,110,116,104,0,0,0,0,0,0,0,0,0,0,103,77,111,110,116,104,68,97,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,68,97,121,0,0,0,0,0,0,0,0,0,0,0,0,100,117,114,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,108,111,97,116,0,0,0,0,0,0,0,0,0,0,0,100,111,117,98,108,101,0,0,0,0,0,0,0,0,0,0,98,111,111,108,101,97,110,0,0,0,0,0,0,0,0,0,97,110,121,85,82,73,0,0,0,0,0,0,0,0,0,0,104,101,120,66,105,110,97,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,101,54,52,66,105,110,97,114,121,0,0,0,0,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,81,78,97,109,101,0,0,0,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,110,111,110,80,111,115,105,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,108,111,110,103,0,0,0,0,0,0,0,0,0,0,0,0,105,110,116,0,0,0,0,0,0,0,0,0,0,0,0,0,115,104,111,114,116,0,0,0,0,0,0,0,0,0,0,0,98,121,116,101,0,0,0,0,0,0,0,0,0,0,0,0,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,76,111,110,103,0,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,73,110,116,0,0,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,83,104,111,114,116,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,66,121,116,101,0,0,0,0,0,0,0,0,0,0,0,0,112,111,115,105,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,110,111,114,109,97,108,105,122,101,100,83,116,114,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,111,107,101,110,0,0,0,0,0,0,0,0,0,0,0,108,97,110,103,117,97,103,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,0,0,0,0,0,0,0,0,78,67,78,97,109,101,0,0,0,0,0,0,0,0,0,0,73,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,68,82,69,70,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,68,82,69,70,83,0,0,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,48,46,48,0,0,0,0,0,37,108,117,37,108,117,37,108,117,0,0,0,0,0,0,0,37,108,117,37,108,117,0,0,37,108,117,0,0,0,0,0,48,0,0,0,0,0,0,0,45,37,108,117,37,108,117,37,108,117,0,0,0,0,0,0,45,37,108,117,37,108,117,0,45,37,108,117,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,80,37,108,117,89,37,108,117,77,37,108,117,68,84,37,108,117,72,37,108,117,77,37,46,49,52,103,83,0,0,0,0,45,80,37,108,117,89,37,108,117,77,37,108,117,68,84,37,108,117,72,37,108,117,77,37,46,49,52,103,83,0,0,0,37,48,52,108,100,0,0,0,45,45,37,48,50,117,0,0,45,45,45,37,48,50,117,0,45,45,37,48,50,117,45,37,48,50,117,0,0,0,0,0,45,37,48,52,108,100,45,37,48,50,117,0,0,0,0,0,37,48,52,108,100,45,37,48,50,117,0,0,0,0,0,0,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,90,0,0,0,0,0,0,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,0,0,0,0,0,0,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,90,0,0,0,0,0,0,0,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,84,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,90,0,0,0,0,0,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,84,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,0,0,0,0,0,0,0,37,48,49,46,49,52,101,0,63,63,63,0,0,0,0,0,31,0,0,0,29,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,28,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,115,99,104,101,109,97,115,116,121,112,101,115,46,99,0,0,0,0,0,0,0,0,31,0,0,0,60,0,0,0,91,0,0,0,121,0,0,0,152,0,0,0,182,0,0,0,213,0,0,0,244,0,0,0,18,1,0,0,49,1,0,0,79,1,0,0,0,0,0,0,31,0,0,0,59,0,0,0,90,0,0,0,120,0,0,0,151,0,0,0,181,0,0,0,212,0,0,0,243,0,0,0,17,1,0,0,48,1,0,0,78,1,0,0,0,0,0,0,28,0,0,0,59,0,0,0,89,0,0,0,120,0,0,0,150,0,0,0,181,0,0,0,212,0,0,0,242,0,0,0,17,1,0,0,47,1,0,0,78,1,0,0,0,0,0,0,31,0,0,0,62,0,0,0,92,0,0,0,123,0,0,0,153,0,0,0,184,0,0,0,215,0,0,0,245,0,0,0,20,1,0,0,50,1,0,0,81,1,0,0,37,102,0,0,0,0,0,0,37,108,102,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,104,101,120,98,105,110,32,100,97,116,97,0,0,97,108,108,111,99,97,116,105,110,103,32,98,97,115,101,54,52,32,100,97,116,97,0,0,89,77,68,72,77,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,245,64,0,0,0,0,0,32,172,64,0,0,0,0,0,0,78,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,97,114,116,105,99,108,101,32,99,111,109,112,111,110,101,110,116,0,0,0,99,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,98,97,115,105,99,32,116,121,112,101,115,0,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,0,0,0,0,0,0,0,0,16,206,2,0,128,0,0,0,18,0,0,0,7,0,0,0,144,205,2,0,216,205,2,0,11,0,0,0,3,0,0,0,72,205,2,0,120,205,2,0,23,1,0,0,50,0,0,0,88,199,2,0,184,203,2,0,140,1,0,0,28,0,0,0,72,192,2,0,120,198,2,0,20,0,0,0,0,0,0,0,248,191,2,0,0,0,0,0,211,0,0,0,20,0,0,0,8,188,2,0,88,191,2,0,10,0,0,0,0,0,0,0,224,187,2,0,0,0,0,0,134,1,0,0,31,0,0,0,208,180,2,0,232,186,2,0,113,0,0,0,6,0,0,0,216,178,2,0,160,180,2,0,55,0,0,0,2,0,0,0,232,177,2,0,200,178,2,0,108,0,0,0,5,0,0,0,16,176,2,0,192,177,2,0,42,0,0,0,5,0,0,0,64,175,2,0,232,175,2,0,21,0,0,0,2,0,0,0,216,174,2,0,48,175,2,0,20,0,0,0,2,0,0,0,120,174,2,0,200,174,2,0,84,0,0,0,2,0,0,0,24,173,2,0,104,174,2,0,11,0,0,0,0,0,0,0,232,172,2,0,0,0,0,0,63,0,0,0,0,0,0,0,232,171,2,0,0,0,0,0,72,0,0,0,2,0,0,0,184,170,2,0,216,171,2,0,65,0,0,0,0,0,0,0,176,169,2,0,0,0,0,0,133,0,0,0,20,0,0,0,248,166,2,0,16,169,2,0,13,0,0,0,0,0,0,0,192,166,2,0,0,0,0,0,22,0,0,0,0,0,0,0,104,166,2,0,0,0,0,0,48,0,0,0,10,0,0,0,88,165,2,0,24,166,2,0,103,0,0,0,10,0,0,0,104,163,2,0,8,165,2,0,9,0,0,0,0,0,0,0,64,163,2,0,0,0,0,0,32,0,32,0,160,0,160,0,128,22,128,22,14,24,14,24,0,32,10,32,40,32,41,32,47,32,47,32,95,32,95,32,0,48,0,48,0,0,0,0,166,0,167,0,169,0,169,0,174,0,174,0,176,0,176,0,182,0,182,0,130,4,130,4,14,6,15,6,233,6,233,6,253,6,254,6,250,9,250,9,112,11,112,11,243,11,248,11,250,11,250,11,1,15,3,15,19,15,23,15,26,15,31,15,52,15,52,15,54,15,54,15,56,15,56,15,190,15,197,15,199,15,204,15,207,15,207,15,64,25,64,25,224,25,255,25,0,33,1,33,3,33,6,33,8,33,9,33,20,33,20,33,22,33,24,33,30,33,35,33,37,33,37,33,39,33,39,33,41,33,41,33,46,33,46,33,50,33,50,33,58,33,59,33,74,33,74,33,149,33,153,33,156,33,159,33,161,33,162,33,164,33,165,33,167,33,173,33,175,33,205,33,208,33,209,33,211,33,211,33,213,33,243,33,0,35,7,35,12,35,31,35,34,35,40,35,43,35,123,35,125,35,154,35,183,35,208,35,0,36,38,36,64,36,74,36,156,36,233,36,0,37,182,37,184,37,192,37,194,37,247,37,0,38,23,38,25,38,110,38,112,38,125,38,128,38,145,38,160,38,161,38,1,39,4,39,6,39,9,39,12,39,39,39,41,39,75,39,77,39,77,39,79,39,82,39,86,39,86,39,88,39,94,39,97,39,103,39,148,39,148,39,152,39,175,39,177,39,190,39,0,40,255,40,0,43,13,43,128,46,153,46,155,46,243,46,0,47,213,47,240,47,251,47,4,48,4,48,18,48,19,48,32,48,32,48,54,48,55,48,62,48,63,48,144,49,145,49,150,49,159,49,0,50,30,50,42,50,67,50,80,50,80,50,96,50,125,50,127,50,127,50,138,50,176,50,192,50,254,50,0,51,255,51,192,77,255,77,144,164,198,164,253,253,253,253,228,255,228,255,232,255,232,255,237,255,238,255,252,255,253,255,0,0,0,0,2,1,1,0,2,1,1,0,55,1,1,0,63,1,1,0,0,208,1,0,245,208,1,0,0,209,1,0,38,209,1,0,42,209,1,0,100,209,1,0,106,209,1,0,108,209,1,0,131,209,1,0,132,209,1,0,140,209,1,0,169,209,1,0,174,209,1,0,221,209,1,0,0,211,1,0,86,211,1,0,43,0,43,0,60,0,62,0,124,0,124,0,126,0,126,0,172,0,172,0,177,0,177,0,215,0,215,0,247,0,247,0,246,3,246,3,68,32,68,32,82,32,82,32,122,32,124,32,138,32,140,32,64,33,68,33,75,33,75,33,144,33,148,33,154,33,155,33,160,33,160,33,163,33,163,33,166,33,166,33,174,33,174,33,206,33,207,33,210,33,210,33,212,33,212,33,244,33,255,34,8,35,11,35,32,35,33,35,124,35,124,35,155,35,179,35,183,37,183,37,193,37,193,37,248,37,255,37,111,38,111,38,208,39,229,39,240,39,255,39,0,41,130,41,153,41,215,41,220,41,251,41,254,41,255,42,41,251,41,251,98,254,98,254,100,254,102,254,11,255,11,255,28,255,30,255,92,255,92,255,94,255,94,255,226,255,226,255,233,255,236,255,193,214,1,0,193,214,1,0,219,214,1,0,219,214,1,0,251,214,1,0,251,214,1,0,21,215,1,0,21,215,1,0,53,215,1,0,53,215,1,0,79,215,1,0,79,215,1,0,111,215,1,0,111,215,1,0,137,215,1,0,137,215,1,0,169,215,1,0,169,215,1,0,195,215,1,0,195,215,1,0,94,0,94,0,96,0,96,0,168,0,168,0,175,0,175,0,180,0,180,0,184,0,184,0,194,2,197,2,210,2,223,2,229,2,237,2,239,2,255,2,116,3,117,3,132,3,133,3,189,31,189,31,191,31,193,31,205,31,207,31,221,31,223,31,237,31,239,31,253,31,254,31,155,48,156,48,62,255,62,255,64,255,64,255,227,255,227,255,36,0,36,0,162,0,165,0,242,9,243,9,241,10,241,10,249,11,249,11,63,14,63,14,219,23,219,23,160,32,177,32,252,253,252,253,105,254,105,254,4,255,4,255,224,255,225,255,229,255,230,255,0,0,0,0,36,0,36,0,43,0,43,0,60,0,62,0,94,0,94,0,96,0,96,0,124,0,124,0,126,0,126,0,162,0,169,0,172,0,172,0,174,0,177,0,180,0,180,0,182,0,182,0,184,0,184,0,215,0,215,0,247,0,247,0,194,2,197,2,210,2,223,2,229,2,237,2,239,2,255,2,116,3,117,3,132,3,133,3,246,3,246,3,130,4,130,4,14,6,15,6,233,6,233,6,253,6,254,6,242,9,243,9,250,9,250,9,241,10,241,10,112,11,112,11,243,11,250,11,63,14,63,14,1,15,3,15,19,15,23,15,26,15,31,15,52,15,52,15,54,15,54,15,56,15,56,15,190,15,197,15,199,15,204,15,207,15,207,15,219,23,219,23,64,25,64,25,224,25,255,25,189,31,189,31,191,31,193,31,205,31,207,31,221,31,223,31,237,31,239,31,253,31,254,31,68,32,68,32,82,32,82,32,122,32,124,32,138,32,140,32,160,32,177,32,0,33,1,33,3,33,6,33,8,33,9,33,20,33,20,33,22,33,24,33,30,33,35,33,37,33,37,33,39,33,39,33,41,33,41,33,46,33,46,33,50,33,50,33,58,33,59,33,64,33,68,33,74,33,75,33,144,33,40,35,43,35,179,35,183,35,208,35,0,36,38,36,64,36,74,36,156,36,233,36,0,37,23,38,25,38,125,38,128,38,145,38,160,38,161,38,1,39,4,39,6,39,9,39,12,39,39,39,41,39,75,39,77,39,77,39,79,39,82,39,86,39,86,39,88,39,94,39,97,39,103,39,148,39,148,39,152,39,175,39,177,39,190,39,208,39,229,39,240,39,130,41,153,41,215,41,220,41,251,41,254,41,13,43,128,46,153,46,155,46,243,46,0,47,213,47,240,47,251,47,4,48,4,48,18,48,19,48,32,48,32,48,54,48,55,48,62,48,63,48,155,48,156,48,144,49,145,49,150,49,159,49,0,50,30,50,42,50,67,50,80,50,80,50,96,50,125,50,127,50,127,50,138,50,176,50,192,50,254,50,0,51,255,51,192,77,255,77,144,164,198,164,41,251,41,251,252,253,253,253,98,254,98,254,100,254,102,254,105,254,105,254,4,255,4,255,11,255,11,255,28,255,30,255,62,255,62,255,64,255,64,255,92,255,92,255,94,255,94,255,224,255,230,255,232,255,238,255,252,255,253,255,0,0,0,0,2,1,1,0,2,1,1,0,55,1,1,0,63,1,1,0,0,208,1,0,245,208,1,0,0,209,1,0,38,209,1,0,42,209,1,0,100,209,1,0,106,209,1,0,108,209,1,0,131,209,1,0,132,209,1,0,140,209,1,0,169,209,1,0,174,209,1,0,221,209,1,0,0,211,1,0,86,211,1,0,193,214,1,0,193,214,1,0,219,214,1,0,219,214,1,0,251,214,1,0,251,214,1,0,21,215,1,0,21,215,1,0,53,215,1,0,53,215,1,0,79,215,1,0,79,215,1,0,111,215,1,0,111,215,1,0,137,215,1,0,137,215,1,0,169,215,1,0,169,215,1,0,195,215,1,0,195,215,1,0,40,0,40,0,91,0,91,0,123,0,123,0,58,15,58,15,60,15,60,15,155,22,155,22,26,32,26,32,30,32,30,32,69,32,69,32,125,32,125,32,141,32,141,32,41,35,41,35,180,35,180,35,104,39,104,39,106,39,106,39,108,39,108,39,110,39,110,39,112,39,112,39,114,39,114,39,116,39,116,39,230,39,230,39,232,39,232,39,234,39,234,39,131,41,131,41,133,41,133,41,135,41,135,41,137,41,137,41,139,41,139,41,141,41,141,41,143,41,143,41,145,41,145,41,147,41,147,41,149,41,149,41,151,41,151,41,216,41,216,41,218,41,218,41,252,41,252,41,8,48,8,48,10,48,10,48,12,48,12,48,14,48,14,48,16,48,16,48,20,48,20,48,22,48,22,48,24,48,24,48,26,48,26,48,29,48,29,48,62,253,62,253,53,254,53,254,55,254,55,254,57,254,57,254,59,254,59,254,61,254,61,254,63,254,63,254,65,254,65,254,67,254,67,254,71,254,71,254,89,254,89,254,91,254,91,254,93,254,93,254,8,255,8,255,59,255,59,255,91,255,91,255,95,255,95,255,98,255,98,255,0,0,0,0,33,0,35,0,37,0,39,0,42,0,42,0,44,0,44,0,46,0,47,0,58,0,59,0,63,0,64,0,92,0,92,0,161,0,161,0,183,0,183,0,191,0,191,0,126,3,126,3,135,3,135,3,90,5,95,5,137,5,137,5,190,5,190,5,192,5,192,5,195,5,195,5,243,5,244,5,12,6,13,6,27,6,27,6,31,6,31,6,106,6,109,6,212,6,212,6,0,7,13,7,100,9,101,9,112,9,112,9,244,13,244,13,79,14,79,14,90,14,91,14,4,15,18,15,133,15,133,15,74,16,79,16,251,16,251,16,97,19,104,19,109,22,110,22,235,22,237,22,53,23,54,23,212,23,214,23,216,23,218,23,0,24,5,24,7,24,10,24,68,25,69,25,22,32,23,32,32,32,39,32,48,32,56,32,59,32,62,32,65,32,67,32,71,32,81,32,83,32,83,32,87,32,87,32,182,35,182,35,1,48,3,48,61,48,61,48,48,254,48,254,69,254,70,254,73,254,76,254,80,254,82,254,84,254,87,254,95,254,97,254,104,254,104,254,106,254,107,254,1,255,3,255,5,255,7,255,10,255,10,255,12,255,12,255,14,255,15,255,26,255,27,255,31,255,32,255,60,255,60,255,97,255,97,255,100,255,100,255,0,1,1,0,1,1,1,0,159,3,1,0,159,3,1,0,41,0,41,0,93,0,93,0,125,0,125,0,59,15,59,15,61,15,61,15,156,22,156,22,70,32,70,32,126,32,126,32,142,32,142,32,42,35,42,35,181,35,181,35,105,39,105,39,107,39,107,39,109,39,109,39,111,39,111,39,113,39,113,39,115,39,115,39,117,39,117,39,231,39,231,39,233,39,233,39,235,39,235,39,132,41,132,41,134,41,134,41,136,41,136,41,138,41,138,41,140,41,140,41,142,41,142,41,144,41,144,41,146,41,146,41,148,41,148,41,150,41,150,41,152,41,152,41,217,41,217,41,219,41,219,41,253,41,253,41,9,48,9,48,11,48,11,48,13,48,13,48,15,48,15,48,17,48,17,48,21,48,21,48,23,48,23,48,25,48,25,48,27,48,27,48,30,48,31,48,63,253,63,253,54,254,54,254,56,254,56,254,58,254,58,254,60,254,60,254,62,254,62,254,64,254,64,254,66,254,66,254,68,254,68,254,72,254,72,254,90,254,90,254,92,254,92,254,94,254,94,254,9,255,9,255,61,255,61,255,93,255,93,255,96,255,96,255,99,255,99,255,0,0,0,0,45,0,45,0,138,5,138,5,6,24,6,24,16,32,21,32,28,48,28,48,48,48,48,48,160,48,160,48,49,254,50,254,88,254,88,254,99,254,99,254,13,255,13,255,0,0,0,0,33,0,35,0,37,0,42,0,44,0,47,0,58,0,59,0,63,0,64,0,91,0,93,0,95,0,95,0,123,0,123,0,125,0,125,0,161,0,161,0,171,0,171,0,183,0,183,0,187,0,187,0,191,0,191,0,126,3,126,3,135,3,135,3,90,5,95,5,137,5,138,5,190,5,190,5,192,5,192,5,195,5,195,5,243,5,244,5,12,6,13,6,27,6,27,6,31,6,31,6,106,6,109,6,212,6,212,6,0,7,13,7,100,9,101,9,112,9,112,9,244,13,244,13,79,14,79,14,90,14,91,14,4,15,18,15,58,15,61,15,133,15,133,15,74,16,79,16,251,16,251,16,97,19,104,19,109,22,110,22,155,22,156,22,235,22,237,22,53,23,54,23,212,23,214,23,216,23,218,23,0,24,10,24,68,25,69,25,16,32,39,32,48,32,67,32,69,32,81,32,83,32,84,32,87,32,87,32,125,32,126,32,141,32,142,32,41,35,42,35,180,35,182,35,104,39,117,39,230,39,235,39,131,41,152,41,216,41,219,41,252,41,253,41,1,48,3,48,8,48,17,48,20,48,31,48,48,48,48,48,61,48,61,48,160,48,160,48,251,48,251,48,62,253,63,253,48,254,82,254,84,254,97,254,99,254,99,254,104,254,104,254,106,254,107,254,1,255,3,255,5,255,10,255,12,255,15,255,26,255,27,255,31,255,32,255,59,255,61,255,63,255,63,255,91,255,91,255,93,255,93,255,95,255,101,255,0,1,1,0,1,1,1,0,159,3,1,0,159,3,1,0,178,0,179,0,185,0,185,0,188,0,190,0,244,9,249,9,240,11,242,11,42,15,51,15,114,19,124,19,240,23,249,23,112,32,112,32,116,32,121,32,128,32,137,32,83,33,95,33,96,36,155,36,234,36,255,36,118,39,147,39,146,49,149,49,32,50,41,50,81,50,95,50,128,50,137,50,177,50,191,50,7,1,1,0,51,1,1,0,32,3,1,0,35,3,1,0,48,0,57,0,96,6,105,6,240,6,249,6,102,9,111,9,230,9,239,9,102,10,111,10,230,10,239,10,102,11,111,11,231,11,239,11,102,12,111,12,230,12,239,12,102,13,111,13,80,14,89,14,208,14,217,14,32,15,41,15,64,16,73,16,105,19,113,19,224,23,233,23,16,24,25,24,70,25,79,25,16,255,25,255,0,0,0,0,160,4,1,0,169,4,1,0,206,215,1,0,255,215,1,0,48,0,57,0,178,0,179,0,185,0,185,0,188,0,190,0,96,6,105,6,240,6,249,6,102,9,111,9,230,9,239,9,244,9,249,9,102,10,111,10,230,10,239,10,102,11,111,11,231,11,242,11,102,12,111,12,230,12,239,12,102,13,111,13,80,14,89,14,208,14,217,14,32,15,51,15,64,16,73,16,105,19,124,19,238,22,240,22,224,23,233,23,240,23,249,23,16,24,25,24,70,25,79,25,112,32,112,32,116,32,121,32,128,32,137,32,83,33,131,33,96,36,155,36,234,36,255,36,118,39,147,39,7,48,7,48,33,48,41,48,56,48,58,48,146,49,149,49,32,50,41,50,81,50,95,50,128,50,137,50,177,50,191,50,16,255,25,255,7,1,1,0,51,1,1,0,32,3,1,0,35,3,1,0,74,3,1,0,74,3,1,0,160,4,1,0,169,4,1,0,206,215,1,0,255,215,1,0,0,3,87,3,93,3,111,3,131,4,134,4,145,5,161,5,163,5,185,5,187,5,189,5,191,5,191,5,193,5,194,5,196,5,196,5,16,6,21,6,75,6,88,6,112,6,112,6,214,6,220,6,223,6,228,6,231,6,232,6,234,6,237,6,17,7,17,7,48,7,74,7,166,7,176,7,1,9,2,9,60,9,60,9,65,9,72,9,77,9,77,9,81,9,84,9,98,9,99,9,129,9,129,9,188,9,188,9,193,9,196,9,205,9,205,9,226,9,227,9,1,10,2,10,60,10,60,10,65,10,66,10,71,10,72,10,75,10,77,10,112,10,113,10,129,10,130,10,188,10,188,10,193,10,197,10,199,10,200,10,205,10,205,10,226,10,227,10,1,11,1,11,60,11,60,11,63,11,63,11,65,11,67,11,77,11,77,11,86,11,86,11,130,11,130,11,192,11,192,11,205,11,205,11,62,12,64,12,70,12,72,12,74,12,77,12,85,12,86,12,188,12,188,12,191,12,191,12,198,12,198,12,204,12,205,12,65,13,67,13,77,13,77,13,202,13,202,13,210,13,212,13,214,13,214,13,49,14,49,14,52,14,58,14,71,14,78,14,177,14,177,14,180,14,185,14,187,14,188,14,200,14,205,14,24,15,25,15,53,15,53,15,55,15,55,15,57,15,57,15,113,15,126,15,128,15,132,15,134,15,135,15,144,15,151,15,153,15,188,15,198,15,198,15,45,16,48,16,50,16,50,16,54,16,55,16,57,16,57,16,88,16,89,16,18,23,20,23,50,23,52,23,82,23,83,23,114,23,115,23,183,23,189,23,198,23,198,23,201,23,211,23,221,23,221,23,11,24,13,24,169,24,169,24,32,25,34,25,39,25,40,25,50,25,50,25,57,25,59,25,208,32,220,32,225,32,225,32,229,32,234,32,42,48,47,48,153,48,154,48,30,251,30,251,0,254,15,254,32,254,35,254,103,209,1,0,105,209,1,0,123,209,1,0,130,209,1,0,133,209,1,0,139,209,1,0,170,209,1,0,173,209,1,0,0,1,14,0,239,1,14,0,3,9,3,9,62,9,64,9,73,9,76,9,130,9,131,9,190,9,192,9,199,9,200,9,203,9,204,9,215,9,215,9,3,10,3,10,62,10,64,10,131,10,131,10,190,10,192,10,201,10,201,10,203,10,204,10,2,11,3,11,62,11,62,11,64,11,64,11,71,11,72,11,75,11,76,11,87,11,87,11,190,11,191,11,193,11,194,11,198,11,200,11,202,11,204,11,215,11,215,11,1,12,3,12,65,12,68,12,130,12,131,12,190,12,190,12,192,12,196,12,199,12,200,12,202,12,203,12,213,12,214,12,2,13,3,13,62,13,64,13,70,13,72,13,74,13,76,13,87,13,87,13,130,13,131,13,207,13,209,13,216,13,223,13,242,13,243,13,62,15,63,15,127,15,127,15,44,16,44,16,49,16,49,16,56,16,56,16,86,16,87,16,182,23,182,23,190,23,197,23,199,23,200,23,35,25,38,25,41,25,43,25,48,25,49,25,51,25,56,25,0,0,0,0,101,209,1,0,102,209,1,0,109,209,1,0,114,209,1,0,0,3,87,3,93,3,111,3,131,4,134,4,136,4,137,4,145,5,161,5,163,5,185,5,187,5,189,5,191,5,191,5,193,5,194,5,196,5,196,5,16,6,21,6,75,6,88,6,112,6,112,6,214,6,220,6,222,6,228,6,231,6,232,6,234,6,237,6,17,7,17,7,48,7,74,7,166,7,176,7,1,9,3,9,60,9,60,9,62,9,77,9,81,9,84,9,98,9,99,9,129,9,131,9,188,9,188,9,190,9,196,9,199,9,200,9,203,9,205,9,215,9,215,9,226,9,227,9,1,10,3,10,60,10,60,10,62,10,66,10,71,10,72,10,75,10,77,10,112,10,113,10,129,10,131,10,188,10,188,10],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+166768),
	allocate([190,10,197,10,199,10,201,10,203,10,205,10,226,10,227,10,1,11,3,11,60,11,60,11,62,11,67,11,71,11,72,11,75,11,77,11,86,11,87,11,130,11,130,11,190,11,194,11,198,11,200,11,202,11,205,11,215,11,215,11,1,12,3,12,62,12,68,12,70,12,72,12,74,12,77,12,85,12,86,12,130,12,131,12,188,12,188,12,190,12,196,12,198,12,200,12,202,12,205,12,213,12,214,12,2,13,3,13,62,13,67,13,70,13,72,13,74,13,77,13,87,13,87,13,130,13,131,13,202,13,202,13,207,13,212,13,214,13,214,13,216,13,223,13,242,13,243,13,49,14,49,14,52,14,58,14,71,14,78,14,177,14,177,14,180,14,185,14,187,14,188,14,200,14,205,14,24,15,25,15,53,15,53,15,55,15,55,15,57,15,57,15,62,15,63,15,113,15,132,15,134,15,135,15,144,15,151,15,153,15,188,15,198,15,198,15,44,16,50,16,54,16,57,16,86,16,89,16,18,23,20,23,50,23,52,23,82,23,83,23,114,23,115,23,182,23,211,23,221,23,221,23,11,24,13,24,169,24,169,24,32,25,43,25,48,25,59,25,208,32,234,32,42,48,47,48,153,48,154,48,30,251,30,251,0,254,15,254,32,254,35,254,0,0,0,0,101,209,1,0,105,209,1,0,109,209,1,0,114,209,1,0,123,209,1,0,130,209,1,0,133,209,1,0,139,209,1,0,170,209,1,0,173,209,1,0,0,1,14,0,239,1,14,0,65,0,90,0,192,0,214,0,216,0,222,0,0,1,0,1,2,1,2,1,4,1,4,1,6,1,6,1,8,1,8,1,10,1,10,1,12,1,12,1,14,1,14,1,16,1,16,1,18,1,18,1,20,1,20,1,22,1,22,1,24,1,24,1,26,1,26,1,28,1,28,1,30,1,30,1,32,1,32,1,34,1,34,1,36,1,36,1,38,1,38,1,40,1,40,1,42,1,42,1,44,1,44,1,46,1,46,1,48,1,48,1,50,1,50,1,52,1,52,1,54,1,54,1,57,1,57,1,59,1,59,1,61,1,61,1,63,1,63,1,65,1,65,1,67,1,67,1,69,1,69,1,71,1,71,1,74,1,74,1,76,1,76,1,78,1,78,1,80,1,80,1,82,1,82,1,84,1,84,1,86,1,86,1,88,1,88,1,90,1,90,1,92,1,92,1,94,1,94,1,96,1,96,1,98,1,98,1,100,1,100,1,102,1,102,1,104,1,104,1,106,1,106,1,108,1,108,1,110,1,110,1,112,1,112,1,114,1,114,1,116,1,116,1,118,1,118,1,120,1,121,1,123,1,123,1,125,1,125,1,129,1,130,1,132,1,132,1,134,1,135,1,137,1,139,1,142,1,145,1,147,1,148,1,150,1,152,1,156,1,157,1,159,1,160,1,162,1,162,1,164,1,164,1,166,1,167,1,169,1,169,1,172,1,172,1,174,1,175,1,177,1,179,1,181,1,181,1,183,1,184,1,188,1,188,1,196,1,196,1,199,1,199,1,202,1,202,1,205,1,205,1,207,1,207,1,209,1,209,1,211,1,211,1,213,1,213,1,215,1,215,1,217,1,217,1,219,1,219,1,222,1,222,1,224,1,224,1,226,1,226,1,228,1,228,1,230,1,230,1,232,1,232,1,234,1,234,1,236,1,236,1,238,1,238,1,241,1,241,1,244,1,244,1,246,1,248,1,250,1,250,1,252,1,252,1,254,1,254,1,0,2,0,2,2,2,2,2,4,2,4,2,6,2,6,2,8,2,8,2,10,2,10,2,12,2,12,2,14,2,14,2,16,2,16,2,18,2,18,2,20,2,20,2,22,2,22,2,24,2,24,2,26,2,26,2,28,2,28,2,30,2,30,2,32,2,32,2,34,2,34,2,36,2,36,2,38,2,38,2,40,2,40,2,42,2,42,2,44,2,44,2,46,2,46,2,48,2,48,2,50,2,50,2,134,3,134,3,136,3,138,3,140,3,140,3,142,3,143,3,145,3,161,3,163,3,171,3,210,3,212,3,216,3,216,3,218,3,218,3,220,3,220,3,222,3,222,3,224,3,224,3,226,3,226,3,228,3,228,3,230,3,230,3,232,3,232,3,234,3,234,3,236,3,236,3,238,3,238,3,244,3,244,3,247,3,247,3,249,3,250,3,0,4,47,4,96,4,96,4,98,4,98,4,100,4,100,4,102,4,102,4,104,4,104,4,106,4,106,4,108,4,108,4,110,4,110,4,112,4,112,4,114,4,114,4,116,4,116,4,118,4,118,4,120,4,120,4,122,4,122,4,124,4,124,4,126,4,126,4,128,4,128,4,138,4,138,4,140,4,140,4,142,4,142,4,144,4,144,4,146,4,146,4,148,4,148,4,150,4,150,4,152,4,152,4,154,4,154,4,156,4,156,4,158,4,158,4,160,4,160,4,162,4,162,4,164,4,164,4,166,4,166,4,168,4,168,4,170,4,170,4,172,4,172,4,174,4,174,4,176,4,176,4,178,4,178,4,180,4,180,4,182,4,182,4,184,4,184,4,186,4,186,4,188,4,188,4,190,4,190,4,192,4,193,4,195,4,195,4,197,4,197,4,199,4,199,4,201,4,201,4,203,4,203,4,205,4,205,4,208,4,208,4,210,4,210,4,212,4,212,4,214,4,214,4,216,4,216,4,218,4,218,4,220,4,220,4,222,4,222,4,224,4,224,4,226,4,226,4,228,4,228,4,230,4,230,4,232,4,232,4,234,4,234,4,236,4,236,4,238,4,238,4,240,4,240,4,242,4,242,4,244,4,244,4,248,4,248,4,0,5,0,5,2,5,2,5,4,5,4,5,6,5,6,5,8,5,8,5,10,5,10,5,12,5,12,5,14,5,14,5,49,5,86,5,160,16,197,16,0,30,0,30,2,30,2,30,4,30,4,30,6,30,6,30,8,30,8,30,10,30,10,30,12,30,12,30,14,30,14,30,16,30,16,30,18,30,18,30,20,30,20,30,22,30,22,30,24,30,24,30,26,30,26,30,28,30,28,30,30,30,30,30,32,30,32,30,34,30,34,30,36,30,36,30,38,30,38,30,40,30,40,30,42,30,42,30,44,30,44,30,46,30,46,30,48,30,48,30,50,30,50,30,52,30,52,30,54,30,54,30,56,30,56,30,58,30,58,30,60,30,60,30,62,30,62,30,64,30,64,30,66,30,66,30,68,30,68,30,70,30,70,30,72,30,72,30,74,30,74,30,76,30,76,30,78,30,78,30,80,30,80,30,82,30,82,30,84,30,84,30,86,30,86,30,88,30,88,30,90,30,90,30,92,30,92,30,94,30,94,30,96,30,96,30,98,30,98,30,100,30,100,30,102,30,102,30,104,30,104,30,106,30,106,30,108,30,108,30,110,30,110,30,112,30,112,30,114,30,114,30,116,30,116,30,118,30,118,30,120,30,120,30,122,30,122,30,124,30,124,30,126,30,126,30,128,30,128,30,130,30,130,30,132,30,132,30,134,30,134,30,136,30,136,30,138,30,138,30,140,30,140,30,142,30,142,30,144,30,144,30,146,30,146,30,148,30,148,30,160,30,160,30,162,30,162,30,164,30,164,30,166,30,166,30,168,30,168,30,170,30,170,30,172,30,172,30,174,30,174,30,176,30,176,30,178,30,178,30,180,30,180,30,182,30,182,30,184,30,184,30,186,30,186,30,188,30,188,30,190,30,190,30,192,30,192,30,194,30,194,30,196,30,196,30,198,30,198,30,200,30,200,30,202,30,202,30,204,30,204,30,206,30,206,30,208,30,208,30,210,30,210,30,212,30,212,30,214,30,214,30,216,30,216,30,218,30,218,30,220,30,220,30,222,30,222,30,224,30,224,30,226,30,226,30,228,30,228,30,230,30,230,30,232,30,232,30,234,30,234,30,236,30,236,30,238,30,238,30,240,30,240,30,242,30,242,30,244,30,244,30,246,30,246,30,248,30,248,30,8,31,15,31,24,31,29,31,40,31,47,31,56,31,63,31,72,31,77,31,89,31,89,31,91,31,91,31,93,31,93,31,95,31,95,31,104,31,111,31,184,31,187,31,200,31,203,31,216,31,219,31,232,31,236,31,248,31,251,31,2,33,2,33,7,33,7,33,11,33,13,33,16,33,18,33,21,33,21,33,25,33,29,33,36,33,36,33,38,33,38,33,40,33,40,33,42,33,45,33,48,33,49,33,51,33,51,33,62,33,63,33,69,33,69,33,33,255,58,255,0,4,1,0,39,4,1,0,0,212,1,0,25,212,1,0,52,212,1,0,77,212,1,0,104,212,1,0,129,212,1,0,156,212,1,0,156,212,1,0,158,212,1,0,159,212,1,0,162,212,1,0,162,212,1,0,165,212,1,0,166,212,1,0,169,212,1,0,172,212,1,0,174,212,1,0,181,212,1,0,208,212,1,0,233,212,1,0,4,213,1,0,5,213,1,0,7,213,1,0,10,213,1,0,13,213,1,0,20,213,1,0,22,213,1,0,28,213,1,0,56,213,1,0,57,213,1,0,59,213,1,0,62,213,1,0,64,213,1,0,68,213,1,0,70,213,1,0,70,213,1,0,74,213,1,0,80,213,1,0,108,213,1,0,133,213,1,0,160,213,1,0,185,213,1,0,212,213,1,0,237,213,1,0,8,214,1,0,33,214,1,0,60,214,1,0,85,214,1,0,112,214,1,0,137,214,1,0,168,214,1,0,192,214,1,0,226,214,1,0,250,214,1,0,28,215,1,0,52,215,1,0,86,215,1,0,110,215,1,0,144,215,1,0,168,215,1,0,197,1,197,1,200,1,200,1,203,1,203,1,242,1,242,1,136,31,143,31,152,31,159,31,168,31,175,31,188,31,188,31,204,31,204,31,252,31,252,31,187,1,187,1,192,1,195,1,208,5,234,5,240,5,242,5,33,6,58,6,65,6,74,6,110,6,111,6,113,6,211,6,213,6,213,6,238,6,239,6,250,6,252,6,255,6,255,6,16,7,16,7,18,7,47,7,77,7,79,7,128,7,165,7,177,7,177,7,4,9,57,9,61,9,61,9,80,9,80,9,88,9,97,9,133,9,140,9,143,9,144,9,147,9,168,9,170,9,176,9,178,9,178,9,182,9,185,9,189,9,189,9,220,9,221,9,223,9,225,9,240,9,241,9,5,10,10,10,15,10,16,10,19,10,40,10,42,10,48,10,50,10,51,10,53,10,54,10,56,10,57,10,89,10,92,10,94,10,94,10,114,10,116,10,133,10,141,10,143,10,145,10,147,10,168,10,170,10,176,10,178,10,179,10,181,10,185,10,189,10,189,10,208,10,208,10,224,10,225,10,5,11,12,11,15,11,16,11,19,11,40,11,42,11,48,11,50,11,51,11,53,11,57,11,61,11,61,11,92,11,93,11,95,11,97,11,113,11,113,11,131,11,131,11,133,11,138,11,142,11,144,11,146,11,149,11,153,11,154,11,156,11,156,11,158,11,159,11,163,11,164,11,168,11,170,11,174,11,181,11,183,11,185,11,5,12,12,12,14,12,16,12,18,12,40,12,42,12,51,12,53,12,57,12,96,12,97,12,133,12,140,12,142,12,144,12,146,12,168,12,170,12,179,12,181,12,185,12,189,12,189,12,222,12,222,12,224,12,225,12,5,13,12,13,14,13,16,13,18,13,40,13,42,13,57,13,96,13,97,13,133,13,150,13,154,13,177,13,179,13,187,13,189,13,189,13,192,13,198,13,1,14,48,14,50,14,51,14,64,14,69,14,129,14,130,14,132,14,132,14,135,14,136,14,138,14,138,14,141,14,141,14,148,14,151,14,153,14,159,14,161,14,163,14,165,14,165,14,167,14,167,14,170,14,171,14,173,14,176,14,178,14,179,14,189,14,189,14,192,14,196,14,220,14,221,14,0,15,0,15,64,15,71,15,73,15,106,15,136,15,139,15,0,16,33,16,35,16,39,16,41,16,42,16,80,16,85,16,208,16,248,16,0,17,89,17,95,17,162,17,168,17,249,17,0,18,6,18,8,18,70,18,72,18,72,18,74,18,77,18,80,18,86,18,88,18,88,18,90,18,93,18,96,18,134,18,136,18,136,18,138,18,141,18,144,18,174,18,176,18,176,18,178,18,181,18,184,18,190,18,192,18,192,18,194,18,197,18,200,18,206,18,208,18,214,18,216,18,238,18,240,18,14,19,16,19,16,19,18,19,21,19,24,19,30,19,32,19,70,19,72,19,90,19,160,19,244,19,1,20,108,22,111,22,118,22,129,22,154,22,160,22,234,22,0,23,12,23,14,23,17,23,32,23,49,23,64,23,81,23,96,23,108,23,110,23,112,23,128,23,179,23,220,23,220,23,32,24,66,24,68,24,119,24,128,24,168,24,0,25,28,25,80,25,109,25,112,25,116,25,53,33,56,33,6,48,6,48,60,48,60,48,65,48,150,48,159,48,159,48,161,48,250,48,255,48,255,48,5,49,44,49,49,49,142,49,160,49,183,49,240,49,255,49,0,52,0,52,181,77,181,77,0,78,0,78,165,159,165,159,0,160,140,164,0,172,0,172,163,215,163,215,0,249,45,250,48,250,106,250,29,251,29,251,31,251,40,251,42,251,54,251,56,251,60,251,62,251,62,251,64,251,65,251,67,251,68,251,70,251,177,251,211,251,61,253,80,253,143,253,146,253,199,253,240,253,251,253,112,254,116,254,118,254,252,254,102,255,111,255,113,255,157,255,160,255,190,255,194,255,199,255,202,255,207,255,210,255,215,255,218,255,220,255,0,0,0,0,0,0,1,0,11,0,1,0,13,0,1,0,38,0,1,0,40,0,1,0,58,0,1,0,60,0,1,0,61,0,1,0,63,0,1,0,77,0,1,0,80,0,1,0,93,0,1,0,128,0,1,0,250,0,1,0,0,3,1,0,30,3,1,0,48,3,1,0,73,3,1,0,128,3,1,0,157,3,1,0,80,4,1,0,157,4,1,0,0,8,1,0,5,8,1,0,8,8,1,0,8,8,1,0,10,8,1,0,53,8,1,0,55,8,1,0,56,8,1,0,60,8,1,0,60,8,1,0,63,8,1,0,63,8,1,0,0,0,2,0,0,0,2,0,214,166,2,0,214,166,2,0,0,248,2,0,29,250,2,0,176,2,193,2,198,2,209,2,224,2,228,2,238,2,238,2,122,3,122,3,89,5,89,5,64,6,64,6,229,6,230,6,70,14,70,14,198,14,198,14,215,23,215,23,67,24,67,24,44,29,97,29,5,48,5,48,49,48,53,48,59,48,59,48,157,48,158,48,252,48,254,48,112,255,112,255,158,255,159,255,97,0,122,0,170,0,170,0,181,0,181,0,186,0,186,0,223,0,246,0,248,0,255,0,1,1,1,1,3,1,3,1,5,1,5,1,7,1,7,1,9,1,9,1,11,1,11,1,13,1,13,1,15,1,15,1,17,1,17,1,19,1,19,1,21,1,21,1,23,1,23,1,25,1,25,1,27,1,27,1,29,1,29,1,31,1,31,1,33,1,33,1,35,1,35,1,37,1,37,1,39,1,39,1,41,1,41,1,43,1,43,1,45,1,45,1,47,1,47,1,49,1,49,1,51,1,51,1,53,1,53,1,55,1,56,1,58,1,58,1,60,1,60,1,62,1,62,1,64,1,64,1,66,1,66,1,68,1,68,1,70,1,70,1,72,1,73,1,75,1,75,1,77,1,77,1,79,1,79,1,81,1,81,1,83,1,83,1,85,1,85,1,87,1,87,1,89,1,89,1,91,1,91,1,93,1,93,1,95,1,95,1,97,1,97,1,99,1,99,1,101,1,101,1,103,1,103,1,105,1,105,1,107,1,107,1,109,1,109,1,111,1,111,1,113,1,113,1,115,1,115,1,117,1,117,1,119,1,119,1,122,1,122,1,124,1,124,1,126,1,128,1,131,1,131,1,133,1,133,1,136,1,136,1,140,1,141,1,146,1,146,1,149,1,149,1,153,1,155,1,158,1,158,1,161,1,161,1,163,1,163,1,165,1,165,1,168,1,168,1,170,1,171,1,173,1,173,1,176,1,176,1,180,1,180,1,182,1,182,1,185,1,186,1,189,1,191,1,198,1,198,1,201,1,201,1,204,1,204,1,206,1,206,1,208,1,208,1,210,1,210,1,212,1,212,1,214,1,214,1,216,1,216,1,218,1,218,1,220,1,221,1,223,1,223,1,225,1,225,1,227,1,227,1,229,1,229,1,231,1,231,1,233,1,233,1,235,1,235,1,237,1,237,1,239,1,240,1,243,1,243,1,245,1,245,1,249,1,249,1,251,1,251,1,253,1,253,1,255,1,255,1,1,2,1,2,3,2,3,2,5,2,5,2,7,2,7,2,9,2,9,2,11,2,11,2,13,2,13,2,15,2,15,2,17,2,17,2,19,2,19,2,21,2,21,2,23,2,23,2,25,2,25,2,27,2,27,2,29,2,29,2,31,2,31,2,33,2,33,2,35,2,35,2,37,2,37,2,39,2,39,2,41,2,41,2,43,2,43,2,45,2,45,2,47,2,47,2,49,2,49,2,51,2,54,2,80,2,175,2,144,3,144,3,172,3,206,3,208,3,209,3,213,3,215,3,217,3,217,3,219,3,219,3,221,3,221,3,223,3,223,3,225,3,225,3,227,3,227,3,229,3,229,3,231,3,231,3,233,3,233,3,235,3,235,3,237,3,237,3,239,3,243,3,245,3,245,3,248,3,248,3,251,3,251,3,48,4,95,4,97,4,97,4,99,4,99,4,101,4,101,4,103,4,103,4,105,4,105,4,107,4,107,4,109,4,109,4,111,4,111,4,113,4,113,4,115,4,115,4,117,4,117,4,119,4,119,4,121,4,121,4,123,4,123,4,125,4,125,4,127,4,127,4,129,4,129,4,139,4,139,4,141,4,141,4,143,4,143,4,145,4,145,4,147,4,147,4,149,4,149,4,151,4,151,4,153,4,153,4,155,4,155,4,157,4,157,4,159,4,159,4,161,4,161,4,163,4,163,4,165,4,165,4,167,4,167,4,169,4,169,4,171,4,171,4,173,4,173,4,175,4,175,4,177,4,177,4,179,4,179,4,181,4,181,4,183,4,183,4,185,4,185,4,187,4,187,4,189,4,189,4,191,4,191,4,194,4,194,4,196,4,196,4,198,4,198,4,200,4,200,4,202,4,202,4,204,4,204,4,206,4,206,4,209,4,209,4,211,4,211,4,213,4,213,4,215,4,215,4,217,4,217,4,219,4,219,4,221,4,221,4,223,4,223,4,225,4,225,4,227,4,227,4,229,4,229,4,231,4,231,4,233,4,233,4,235,4,235,4,237,4,237,4,239,4,239,4,241,4,241,4,243,4,243,4,245,4,245,4,249,4,249,4,1,5,1,5,3,5,3,5,5,5,5,5,7,5,7,5,9,5,9,5,11,5,11,5,13,5,13,5,15,5,15,5,97,5,135,5,0,29,43,29,98,29,107,29,1,30,1,30,3,30,3,30,5,30,5,30,7,30,7,30,9,30,9,30,11,30,11,30,13,30,13,30,15,30,15,30,17,30,17,30,19,30,19,30,21,30,21,30,23,30,23,30,25,30,25,30,27,30,27,30,29,30,29,30,31,30,31,30,33,30,33,30,35,30,35,30,37,30,37,30,39,30,39,30,41,30,41,30,43,30,43,30,45,30,45,30,47,30,47,30,49,30,49,30,51,30,51,30,53,30,53,30,55,30,55,30,57,30,57,30,59,30,59,30,61,30,61,30,63,30,63,30,65,30,65,30,67,30,67,30,69,30,69,30,71,30,71,30,73,30,73,30,75,30,75,30,77,30,77,30,79,30,79,30,81,30,81,30,83,30,83,30,85,30,85,30,87,30,87,30,89,30,89,30,91,30,91,30,93,30,93,30,95,30,95,30,97,30,97,30,99,30,99,30,101,30,101,30,103,30,103,30,105,30,105,30,107,30,107,30,109,30,109,30,111,30,111,30,113,30,113,30,115,30,115,30,117,30,117,30,119,30,119,30,121,30,121,30,123,30,123,30,125,30,125,30,127,30,127,30,129,30,129,30,131,30,131,30,133,30,133,30,135,30,135,30,137,30,137,30,139,30,139,30,141,30,141,30,143,30,143,30,145,30,145,30,147,30,147,30,149,30,155,30,161,30,161,30,163,30,163,30,165,30,165,30,167,30,167,30,169,30,169,30,171,30,171,30,173,30,173,30,175,30,175,30,177,30,177,30,179,30,179,30,181,30,181,30,183,30,183,30,185,30,185,30,187,30,187,30,189,30,189,30,191,30,191,30,193,30,193,30,195,30,195,30,197,30,197,30,199,30,199,30,201,30,201,30,203,30,203,30,205,30,205,30,207,30,207,30,209,30,209,30,211,30,211,30,213,30,213,30,215,30,215,30,217,30,217,30,219,30,219,30,221,30,221,30,223,30,223,30,225,30,225,30,227,30,227,30,229,30,229,30,231,30,231,30,233,30,233,30,235,30,235,30,237,30,237,30,239,30,239,30,241,30,241,30,243,30,243,30,245,30,245,30,247,30,247,30,249,30,249,30,0,31,7,31,16,31,21,31,32,31,39,31,48,31,55,31,64,31,69,31,80,31,87,31,96,31,103,31,112,31,125,31,128,31,135,31,144,31,151,31,160,31,167,31,176,31,180,31,182,31,183,31,190,31,190,31,194,31,196,31,198,31,199,31,208,31,211,31,214,31,215,31,224,31,231,31,242,31,244,31,246,31,247,31,113,32,113,32,127,32,127,32,10,33,10,33,14,33,15,33,19,33,19,33,47,33,47,33,52,33,52,33,57,33,57,33,61,33,61,33,70,33,73,33,0,251,6,251,19,251,23,251,65,255,90,255,40,4,1,0,79,4,1,0,26,212,1,0,51,212,1,0,78,212,1,0,84,212,1,0,86,212,1,0,103,212,1,0,130,212,1,0,155,212,1,0,182,212,1,0,185,212,1,0,187,212,1,0,187,212,1,0,189,212,1,0,195,212,1,0,197,212,1,0,207,212,1,0,234,212,1,0,3,213,1,0,30,213,1,0,55,213,1,0,82,213,1,0,107,213,1,0,134,213,1,0,159,213,1,0,186,213,1,0,211,213,1,0,238,213,1,0,7,214,1,0,34,214,1,0,59,214,1,0,86,214,1,0,111,214,1,0,138,214,1,0,163,214,1,0,194,214,1,0,218,214,1,0,220,214,1,0,225,214,1,0,252,214,1,0,20,215,1,0,22,215,1,0,27,215,1,0,54,215,1,0,78,215,1,0,80,215,1,0,85,215,1,0,112,215,1,0,136,215,1,0,138,215,1,0,143,215,1,0,170,215,1,0,194,215,1,0,196,215,1,0,201,215,1,0,65,0,90,0,97,0,122,0,170,0,170,0,181,0,181,0,186,0,186,0,192,0,214,0,216,0,246,0,248,0,54,2,80,2,193,2,198,2,209,2,224,2,228,2,238,2,238,2,122,3,122,3,134,3,134,3,136,3,138,3,140,3,140,3,142,3,161,3,163,3,206,3,208,3,245,3,247,3,251,3,0,4,129,4,138,4,206,4,208,4,245,4,248,4,249,4,0,5,15,5,49,5,86,5,89,5,89,5,97,5,135,5,208,5,234,5,240,5,242,5,33,6,58,6,64,6,74,6,110,6,111,6,113,6,211,6,213,6,213,6,229,6,230,6,238,6,239,6,250,6,252,6,255,6,255,6,16,7,16,7,18,7,47,7,77,7,79,7,128,7,165,7,177,7,177,7,4,9,57,9,61,9,61,9,80,9,80,9,88,9,97,9,133,9,140,9,143,9,144,9,147,9,168,9,170,9,176,9,178,9,178,9,182,9,185,9,189,9,189,9,220,9,221,9,223,9,225,9,240,9,241,9,5,10,10,10,15,10,16,10,19,10,40,10,42,10,48,10,50,10,51,10,53,10,54,10,56,10,57,10,89,10,92,10,94,10,94,10,114,10,116,10,133,10,141,10,143,10,145,10,147,10,168,10,170,10,176,10,178,10,179,10,181,10,185,10,189,10,189,10,208,10,208,10,224,10,225,10,5,11,12,11,15,11,16,11,19,11,40,11,42,11,48,11,50,11,51,11,53,11,57,11,61,11,61,11,92,11,93,11,95,11,97,11,113,11,113,11,131,11,131,11,133,11,138,11,142,11,144,11,146,11,149,11,153,11,154,11,156,11,156,11,158,11,159,11,163,11,164,11,168,11,170,11,174,11,181,11,183,11,185,11,5,12,12,12,14,12,16,12,18,12,40,12,42,12,51,12,53,12,57,12,96,12,97,12,133,12,140,12,142,12,144,12,146,12,168,12,170,12,179,12,181,12,185,12,189,12,189,12,222,12,222,12,224,12,225,12,5,13,12,13,14,13,16,13,18,13,40,13,42,13,57,13,96,13,97,13,133,13,150,13,154,13,177,13,179,13,187,13,189,13,189,13,192,13,198,13,1,14,48,14,50,14,51,14,64,14,70,14,129,14,130,14,132,14,132,14,135,14,136,14,138,14,138,14,141,14,141,14,148,14,151,14,153,14,159,14,161,14,163,14,165,14,165,14,167,14,167,14,170,14,171,14,173,14,176,14,178,14,179,14,189,14,189,14,192,14,196,14,198,14,198,14,220,14,221,14,0,15,0,15,64,15,71,15,73,15,106,15,136,15,139,15,0,16,33,16,35,16,39,16,41,16,42,16,80,16,85,16,160,16,197,16,208,16,248,16,0,17,89,17,95,17,162,17,168,17,249,17,0,18,6,18,8,18,70,18,72,18,72,18,74,18,77,18,80,18,86,18,88,18,88,18,90,18,93,18,96,18,134,18,136,18,136,18,138,18,141,18,144,18,174,18,176,18,176,18,178,18,181,18,184,18,190,18,192,18,192,18,194,18,197,18,200,18,206,18,208,18,214,18,216,18,238,18,240,18,14,19,16,19,16,19,18,19,21,19,24,19,30,19,32,19,70,19,72,19,90,19,160,19,244,19,1,20,108,22,111,22,118,22,129,22,154,22,160,22,234,22,0,23,12,23,14,23,17,23,32,23,49,23,64,23,81,23,96,23,108,23,110,23,112,23,128,23,179,23,215,23,215,23,220,23,220,23,32,24,119,24,128,24,168,24,0,25,28,25,80,25,109,25,112,25,116,25,0,29,107,29,0,30,155,30,160,30,249,30,0,31,21,31,24,31,29,31,32,31,69,31,72,31,77,31,80,31,87,31,89,31,89,31,91,31,91,31,93,31,93,31,95,31,125,31,128,31,180,31,182,31,188,31,190,31,190,31,194,31,196,31,198,31,204,31,208,31,211,31,214,31,219,31,224,31,236,31,242,31,244,31,246,31,252,31,113,32,113,32,127,32,127,32,2,33,2,33,7,33,7,33,10,33,19,33,21,33,21,33,25,33,29,33,36,33,36,33,38,33,38,33,40,33,40,33,42,33,45,33,47,33,49,33,51,33,57,33,61,33,63,33,69,33,73,33,5,48,6,48,49,48,53,48,59,48,60,48,65,48,150,48,157,48,159,48,161,48,250,48,252,48,255,48,5,49,44,49,49,49,142,49,160,49,183,49,240,49,255,49,0,52,0,52,181,77,181,77,0,78,0,78,165,159,165,159,0,160,140,164,0,172,0,172,163,215,163,215,0,249,45,250,48,250,106,250,0,251,6,251,19,251,23,251,29,251,29,251,31,251,40,251,42,251,54,251,56,251,60,251,62,251,62,251,64,251,65,251,67,251,68,251,70,251,177,251,211,251,61,253,80,253,143,253,146,253,199,253,240,253,251,253,112,254,116,254,118,254,252,254,33,255,58,255,65,255,90,255,102,255,190,255,194,255,199,255,202,255,207,255,210,255,215,255,218,255,220,255,0,0,0,0,0,0,1,0,11,0,1,0,13,0,1,0,38,0,1,0,40,0,1,0,58,0,1,0,60,0,1,0,61,0,1,0,63,0,1,0,77,0,1,0,80,0,1,0,93,0,1,0,128,0,1,0,250,0,1,0,0,3,1,0,30,3,1,0,48,3,1,0,73,3,1,0,128,3,1,0,157,3,1,0,0,4,1,0,157,4,1,0,0,8,1,0,5,8,1,0,8,8,1,0,8,8,1,0,10,8,1,0,53,8,1,0,55,8,1,0,56,8,1,0,60,8,1,0,60,8,1,0,63,8,1,0,63,8,1,0,0,212,1,0,84,212,1,0,86,212,1,0,156,212,1,0,158,212,1,0,159,212,1,0,162,212,1,0,162,212,1,0,165,212,1,0,166,212,1,0,169,212,1,0,172,212,1,0,174,212,1,0,185,212,1,0,187,212,1,0,187,212,1,0,189,212,1,0,195,212,1,0,197,212,1,0,5,213,1,0,7,213,1,0,10,213,1,0,13,213,1,0,20,213,1,0,22,213,1,0,28,213,1,0,30,213,1,0,57,213,1,0,59,213,1,0,62,213,1,0,64,213,1,0,68,213,1,0,70,213,1,0,70,213,1,0,74,213,1,0,80,213,1,0,82,213,1,0,163,214,1,0,168,214,1,0,192,214,1,0,194,214,1,0,218,214,1,0,220,214,1,0,250,214,1,0,252,214,1,0,20,215,1,0,22,215,1,0,52,215,1,0,54,215,1,0,78,215,1,0,80,215,1,0,110,215,1,0,112,215,1,0,136,215,1,0,138,215,1,0,168,215,1,0,170,215,1,0,194,215,1,0,196,215,1,0,201,215,1,0,0,0,2,0,0,0,2,0,214,166,2,0,214,166,2,0,0,248,2,0,29,250,2,0,173,0,173,0,0,6,3,6,221,6,221,6,15,7,15,7,180,23,181,23,11,32,15,32,42,32,46,32,96,32,99,32,106,32,111,32,255,254,255,254,249,255,251,255,0,0,0,0,115,209,1,0,122,209,1,0,1,0,14,0,1,0,14,0,32,0,14,0,127,0,14,0,0,0,31,0,127,0,159,0,173,0,173,0,0,6,3,6,221,6,221,6,15,7,15,7,180,23,181,23,11,32,15,32,42,32,46,32,96,32,99,32,106,32,111,32,0,216,0,216,127,219,128,219,255,219,0,220,255,223,0,224,255,248,255,248,255,254,255,254,249,255,251,255,115,209,1,0,122,209,1,0,1,0,14,0,1,0,14,0,32,0,14,0,127,0,14,0,0,0,15,0,0,0,15,0,253,255,15,0,253,255,15,0,0,0,16,0,0,0,16,0,253,255,16,0,253,255,16,0,16,210,2,0,66,0,0,0,32,210,2,0,67,0,0,0,64,210,2,0,68,0,0,0,72,210,2,0,69,0,0,0,104,210,2,0,70,0,0,0,136,210,2,0,71,0,0,0,152,210,2,0,72,0,0,0,160,210,2,0,73,0,0,0,176,210,2,0,74,0,0,0,184,210,2,0,75,0,0,0,200,210,2,0,76,0,0,0,216,210,2,0,77,0,0,0,240,210,2,0,78,0,0,0,0,211,2,0,79,0,0,0,16,211,2,0,80,0,0,0,24,211,2,0,81,0,0,0,48,211,2,0,82,0,0,0,72,211,2,0,83,0,0,0,96,211,2,0,84,0,0,0,128,211,2,0,85,0,0,0,168,211,2,0,86,0,0,0,192,211,2,0,87,0,0,0,224,211,2,0,88,0,0,0,248,211,2,0,89,0,0,0,24,212,2,0,90,0,0,0,56,212,2,0,91,0,0,0,72,212,2,0,92,0,0,0,104,212,2,0,93,0,0,0,144,212,2,0,94,0,0,0,168,212,2,0,95,0,0,0,200,212,2,0,96,0,0,0,216,212,2,0,97,0,0,0,232,212,2,0,98,0,0,0,0,213,2,0,99,0,0,0,16,213,2,0,100,0,0,0,40,213,2,0,101,0,0,0,48,213,2,0,102,0,0,0,64,213,2,0,103,0,0,0,80,213,2,0,104,0,0,0,104,213,2,0,105,0,0,0,136,213,2,0,106,0,0,0,152,213,2,0,107,0,0,0,176,213,2,0,108,0,0,0,192,213,2,0,109,0,0,0,208,213,2,0,110,0,0,0,216,213,2,0,111,0,0,0,224,213,2,0,112,0,0,0,240,213,2,0,113,0,0,0,0,214,2,0,114,0,0,0,16,214,2,0,115,0,0,0,32,214,2,0,116,0,0,0,64,214,2,0,117,0,0,0,88,214,2,0,118,0,0,0,104,214,2,0,119,0,0,0,120,214,2,0,120,0,0,0,128,214,2,0,121,0,0,0,136,214,2,0,122,0,0,0,168,214,2,0,123,0,0,0,184,214,2,0,124,0,0,0,200,214,2,0,125,0,0,0,216,214,2,0,126,0,0,0,0,215,2,0,127,0,0,0,8,215,2,0,128,0,0,0,24,215,2,0,129,0,0,0,32,215,2,0,130,0,0,0,48,215,2,0,131,0,0,0,80,215,2,0,132,0,0,0,88,215,2,0,133,0,0,0,104,215,2,0,134,0,0,0,112,215,2,0,135,0,0,0,136,215,2,0,136,0,0,0,152,215,2,0,137,0,0,0,168,215,2,0,138,0,0,0,192,215,2,0,139,0,0,0,216,215,2,0,140,0,0,0,224,215,2,0,141,0,0,0,248,215,2,0,142,0,0,0,16,216,2,0,143,0,0,0,32,216,2,0,144,0,0,0,48,216,2,0,145,0,0,0,80,216,2,0,146,0,0,0,104,216,2,0,147,0,0,0,144,216,2,0,148,0,0,0,184,216,2,0,149,0,0,0,208,216,2,0,150,0,0,0,240,216,2,0,151,0,0,0,8,217,2,0,152,0,0,0,24,217,2,0,153,0,0,0,40,217,2,0,154,0,0,0,48,217,2,0,155,0,0,0,64,217,2,0,156,0,0,0,72,217,2,0,157,0,0,0,88,217,2,0,158,0,0,0,120,217,2,0,159,0,0,0,128,217,2,0,160,0,0,0,136,217,2,0,161,0,0,0,160,217,2,0,162,0,0,0,176,217,2,0,163,0,0,0,192,217,2,0,164,0,0,0,200,217,2,0,165,0,0,0,208,217,2,0,166,0,0,0,216,217,2,0,167,0,0,0,240,217,2,0,168,0,0,0,8,218,2,0,169,0,0,0,24,218,2,0,170,0,0,0,56,218,2,0,171,0,0,0,80,218,2,0,172,0,0,0,104,218,2,0,173,0,0,0,144,218,2,0,174,0,0,0,176,218,2,0,175,0,0,0,208,218,2,0,176,0,0,0,216,218,2,0,177,0,0,0,224,218,2,0,178,0,0,0,240,218,2,0,179,0,0,0,248,218,2,0,180,0,0,0,0,219,2,0,181,0,0,0,24,219,2,0,182,0,0,0,32,219,2,0,183,0,0,0,40,219,2,0,184,0,0,0,48,219,2,0,185,0,0,0,56,219,2,0,186,0,0,0,64,219,2,0,187,0,0,0,80,219,2,0,188,0,0,0,120,219,2,0,189,0,0,0,144,219,2,0,190,0,0,0,176,219,2,0,191,0,0,0,192,219,2,0,192,0,0,0,208,219,2,0,193,0,0,0,65,101,103,101,97,110,78,117,109,98,101,114,115,0,0,0,65,108,112,104,97,98,101,116,105,99,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,115,0,0,0,0,0,65,114,97,98,105,99,0,0,65,114,97,98,105,99,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,115,45,65,0,0,0,0,0,0,0,65,114,97,98,105,99,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,115,45,66,0,0,0,0,0,0,0,65,114,109,101,110,105,97,110,0,0,0,0,0,0,0,0,65,114,114,111,119,115,0,0,66,97,115,105,99,76,97,116,105,110,0,0,0,0,0,0,66,101,110,103,97,108,105,0,66,108,111,99,107,69,108,101,109,101,110,116,115,0,0,0,66,111,112,111,109,111,102,111,0,0,0,0,0,0,0,0,66,111,112,111,109,111,102,111,69,120,116,101,110,100,101,100,0,0,0,0,0,0,0,0,66,111,120,68,114,97,119,105,110,103,0,0,0,0,0,0,66,114,97,105,108,108,101,80,97,116,116,101,114,110,115,0,66,117,104,105,100,0,0,0,66,121,122,97,110,116,105,110,101,77,117,115,105,99,97,108,83,121,109,98,111,108,115,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,0,0,0,0,0,0,0,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,70,111,114,109,115,0,0,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,73,100,101,111,103,114,97,112,104,115,0,0,0,0,0,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,73,100,101,111,103,114,97,112,104,115,83,117,112,112,108,101,109,101,110,116,0,0,0,0,67,74,75,82,97,100,105,99,97,108,115,83,117,112,112,108,101,109,101,110,116,0,0,0,67,74,75,83,121,109,98,111,108,115,97,110,100,80,117,110,99,116,117,97,116,105,111,110,0,0,0,0,0,0,0,0,67,74,75,85,110,105,102,105,101,100,73,100,101,111,103,114,97,112,104,115,0,0,0,0,67,74,75,85,110,105,102,105,101,100,73,100,101,111,103,114,97,112,104,115,69,120,116,101,110,115,105,111,110,65,0,0,67,74,75,85,110,105,102,105,101,100,73,100,101,111,103,114,97,112,104,115,69,120,116,101,110,115,105,111,110,66,0,0,67,104,101,114,111,107,101,101,0,0,0,0,0,0,0,0,67,111,109,98,105,110,105,110,103,68,105,97,99,114,105,116,105,99,97,108,77,97,114,107,115,0,0,0,0,0,0,0,67,111,109,98,105,110,105,110,103,68,105,97,99,114,105,116,105,99,97,108,77,97,114,107,115,102,111,114,83,121,109,98,111,108,115,0,0,0,0,0,67,111,109,98,105,110,105,110,103,72,97,108,102,77,97,114,107,115,0,0,0,0,0,0,67,111,109,98,105,110,105,110,103,77,97,114,107,115,102,111,114,83,121,109,98,111,108,115,0,0,0,0,0,0,0,0,67,111,110,116,114,111,108,80,105,99,116,117,114,101,115,0,67,117,114,114,101,110,99,121,83,121,109,98,111,108,115,0,67,121,112,114,105,111,116,83,121,108,108,97,98,97,114,121,0,0,0,0,0,0,0,0,67,121,114,105,108,108,105,99,0,0,0,0,0,0,0,0,67,121,114,105,108,108,105,99,83,117,112,112,108,101,109,101,110,116,0,0,0,0,0,0,68,101,115,101,114,101,116,0,68,101,118,97,110,97,103,97,114,105,0,0,0,0,0,0,68,105,110,103,98,97,116,115,0,0,0,0,0,0,0,0,69,110,99,108,111,115,101,100,65,108,112,104,97,110,117,109,101,114,105,99,115,0,0,0,69,110,99,108,111,115,101,100,67,74,75,76,101,116,116,101,114,115,97,110,100,77,111,110,116,104,115,0,0,0,0,0,69,116,104,105,111,112,105,99,0,0,0,0,0,0,0,0,71,101,110,101,114,97,108,80,117,110,99,116,117,97,116,105,111,110,0,0,0,0,0,0,71,101,111,109,101,116,114,105,99,83,104,97,112,101,115,0,71,101,111,114,103,105,97,110,0,0,0,0,0,0,0,0,71,111,116,104,105,99,0,0,71,114,101,101,107,0,0,0,71,114,101,101,107,69,120,116,101,110,100,101,100,0,0,0,71,114,101,101,107,97,110,100,67,111,112,116,105,99,0,0,71,117,106,97,114,97,116,105,0,0,0,0,0,0,0,0,71,117,114,109,117,107,104,105,0,0,0,0,0,0,0,0,72,97,108,102,119,105,100,116,104,97,110,100,70,117,108,108,119,105,100,116,104,70,111,114,109,115,0,0,0,0,0,0,72,97,110,103,117,108,67,111,109,112,97,116,105,98,105,108,105,116,121,74,97,109,111,0,72,97,110,103,117,108,74,97,109,111,0,0,0,0,0,0,72,97,110,103,117,108,83,121,108,108,97,98,108,101,115,0,72,97,110,117,110,111,111,0,72,101,98,114,101,119,0,0,72,105,103,104,80,114,105,118,97,116,101,85,115,101,83,117,114,114,111,103,97,116,101,115,0,0,0,0,0,0,0,0,72,105,103,104,83,117,114,114,111,103,97,116,101,115,0,0,72,105,114,97,103,97,110,97,0,0,0,0,0,0,0,0,73,80,65,69,120,116,101,110,115,105,111,110,115,0,0,0,73,100,101,111,103,114,97,112,104,105,99,68,101,115,99,114,105,112,116,105,111,110,67,104,97,114,97,99,116,101,114,115,0,0,0,0,0,0,0,0,75,97,110,98,117,110,0,0,75,97,110,103,120,105,82,97,100,105,99,97,108,115,0,0,75,97,110,110,97,100,97,0,75,97,116,97,107,97,110,97,0,0,0,0,0,0,0,0,75,97,116,97,107,97,110,97,80,104,111,110,101,116,105,99,69,120,116,101,110,115,105,111,110,115,0,0,0,0,0,0,75,104,109,101,114,0,0,0,75,104,109,101,114,83,121,109,98,111,108,115,0,0,0,0,76,97,111,0,0,0,0,0,76,97,116,105,110,45,49,83,117,112,112,108,101,109,101,110,116,0,0,0,0,0,0,0,76,97,116,105,110,69,120,116,101,110,100,101,100,45,65,0,76,97,116,105,110,69,120,116,101,110,100,101,100,45,66,0,76,97,116,105,110,69,120,116,101,110,100,101,100,65,100,100,105,116,105,111,110,97,108,0,76,101,116,116,101,114,108,105,107,101,83,121,109,98,111,108,115,0,0,0,0,0,0,0,76,105,109,98,117,0,0,0,76,105,110,101,97,114,66,73,100,101,111,103,114,97,109,115,0,0,0,0,0,0,0,0,76,105,110,101,97,114,66,83,121,108,108,97,98,97,114,121,0,0,0,0,0,0,0,0,76,111,119,83,117,114,114,111,103,97,116,101,115,0,0,0,77,97,108,97,121,97,108,97,109,0,0,0,0,0,0,0,77,97,116,104,101,109,97,116,105,99,97,108,65,108,112,104,97,110,117,109,101,114,105,99,83,121,109,98,111,108,115,0,77,97,116,104,101,109,97,116,105,99,97,108,79,112,101,114,97,116,111,114,115,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,77,97,116,104,101,109,97,116,105,99,97,108,83,121,109,98,111,108,115,45,65,0,0,0,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,77,97,116,104,101,109,97,116,105,99,97,108,83,121,109,98,111,108,115,45,66,0,0,0,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,83,121,109,98,111,108,115,0,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,83,121,109,98,111,108,115,97,110,100,65,114,114,111,119,115,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,84,101,99,104,110,105,99,97,108,0,0,77,111,110,103,111,108,105,97,110,0,0,0,0,0,0,0,77,117,115,105,99,97,108,83,121,109,98,111,108,115,0,0,77,121,97,110,109,97,114,0,78,117,109,98,101,114,70,111,114,109,115,0,0,0,0,0,79,103,104,97,109,0,0,0,79,108,100,73,116,97,108,105,99,0,0,0,0,0,0,0,79,112,116,105,99,97,108,67,104,97,114,97,99,116,101,114,82,101,99,111,103,110,105,116,105,111,110,0,0,0,0,0,79,114,105,121,97,0,0,0,79,115,109,97,110,121,97,0,80,104,111,110,101,116,105,99,69,120,116,101,110,115,105,111,110,115,0,0,0,0,0,0,80,114,105,118,97,116,101,85,115,101,0,0,0,0,0,0,80,114,105,118,97,116,101,85,115,101,65,114,101,97,0,0,82,117,110,105,99,0,0,0,83,104,97,118,105,97,110,0,83,105,110,104,97,108,97,0,83,109,97,108,108,70,111,114,109,86,97,114,105,97,110,116,115,0,0,0,0,0,0,0,83,112,97,99,105,110,103,77,111,100,105,102,105,101,114,76,101,116,116,101,114,115,0,0,83,112,101,99,105,97,108,115,0,0,0,0,0,0,0,0,83,117,112,101,114,115,99,114,105,112,116,115,97,110,100,83,117,98,115,99,114,105,112,116,115,0,0,0,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,108,65,114,114,111,119,115,45,65,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,108,65,114,114,111,119,115,45,66,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,108,77,97,116,104,101,109,97,116,105,99,97,108,79,112,101,114,97,116,111,114,115,0,0,0,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,114,121,80,114,105,118,97,116,101,85,115,101,65,114,101,97,45,65,0,0,0,83,117,112,112,108,101,109,101,110,116,97,114,121,80,114,105,118,97,116,101,85,115,101,65,114,101,97,45,66,0,0,0,83,121,114,105,97,99,0,0,84,97,103,97,108,111,103,0,84,97,103,98,97,110,119,97,0,0,0,0,0,0,0,0,84,97,103,115,0,0,0,0,84,97,105,76,101,0,0,0,84,97,105,88,117,97,110,74,105,110,103,83,121,109,98,111,108,115,0,0,0,0,0,0,84,97,109,105,108,0,0,0,84,101,108,117,103,117,0,0,84,104,97,97,110,97,0,0,84,104,97,105,0,0,0,0,84,105,98,101,116,97,110,0,85,103,97,114,105,116,105,99,0,0,0,0,0,0,0,0,85,110,105,102,105,101,100,67,97,110,97,100,105,97,110,65,98,111,114,105,103,105,110,97,108,83,121,108,108,97,98,105,99,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+177008),allocate([86,97,114,105,97,116,105,111,110,83,101,108,101,99,116,111,114,115,0,0,0,0,0,0,86,97,114,105,97,116,105,111,110,83,101,108,101,99,116,111,114,115,83,117,112,112,108,101,109,101,110,116,0,0,0,0,89,105,82,97,100,105,99,97,108,115,0,0,0,0,0,0,89,105,83,121,108,108,97,98,108,101,115,0,0,0,0,0,89,105,106,105,110,103,72,101,120,97,103,114,97,109,83,121,109,98,111,108,115,0,0,0,0,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,51,47,88,73,110,99,108,117,100,101,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,73,110,99,108,117,100,101,0,120,109,108,78,101,119,84,101,120,116,82,101,97,100,101,114,32,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,120,109,108,110,115,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,58,0,0,0,0,0,0,0,35,116,101,120,116,0,0,0,35,99,100,97,116,97,45,115,101,99,116,105,111,110,0,0,35,99,111,109,109,101,110,116,0,0,0,0,0,0,0,0,35,100,111,99,117,109,101,110,116,0,0,0,0,0,0,0,35,100,111,99,117,109,101,110,116,45,102,114,97,103,109,101,110,116,0,0,0,0,0,0,120,109,108,84,101,120,116,82,101,97,100,101,114,83,101,116,117,112,32,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,10,0,0,0,0,0,120,109,108,77,97,108,108,111,99,32,102,97,105,108,101,100,32,33,10,0,0,0,0,0,120,109,108,82,101,97,108,108,111,99,32,102,97,105,108,101,100,32,33,10,0,0,0,0,105,110,99,108,117,100,101,0,118,115,110,112,114,105,110,116,102,32,102,97,105,108,101,100,32,33,10,0,0,0,0,0,37,115,0,0,0,0,0,0,69,120,112,97,110,100,32,102,97,105,108,101,100,32,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,115,104,32,116,97,98,108,101,32,102,111,114,32,82,101,108,97,120,45,78,71,32,116,121,112,101,115,10,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,45,100,97,116,97,116,121,112,101,115,0,0,0,0,0,0,64,241,2,0,0,0,0,0,98,117,105,108,100,105,110,103,32,112,97,114,115,101,114,10,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,37,115,10,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,112,97,114,115,101,32,115,99,104,101,109,97,115,10,0,0,0,0,0,0,0,105,110,95,109,101,109,111,114,121,95,98,117,102,102,101,114,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,110,111,116,104,105,110,103,32,116,111,32,112,97,114,115,101,10,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,37,115,32,105,115,32,101,109,112,116,121,10,0,0,0,115,99,104,101,109,97,115,0,35,116,101,120,116,0,0,0,32,84,79,68,79,32,0,0,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,116,121,112,101,32,37,115,10,0,0,0,0,0,84,121,112,101,32,37,115,32,100,111,101,115,110,39,116,32,97,108,108,111,119,32,118,97,108,117,101,32,39,37,115,39,10,0,0,0,0,0,0,0,73,68,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,111,109,112,97,114,101,32,116,121,112,101,32,37,115,10,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,110,111,32,115,116,97,116,101,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,110,111,32,100,101,102,105,110,101,10,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,37,115,10,0,0,0,0,0,69,120,116,114,97,32,100,97,116,97,32,105,110,32,108,105,115,116,58,32,37,115,10,0,73,110,116,101,114,110,97,108,58,32,105,110,116,101,114,108,101,97,118,101,32,98,108,111,99,107,32,104,97,115,32,110,111,32,100,97,116,97,10,0,73,110,118,97,108,105,100,32,115,101,113,117,101,110,99,101,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,69,120,116,114,97,32,101,108,101,109,101,110,116,32,37,115,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,69,120,112,101,99,116,105,110,103,32,101,108,101,109,101,110,116,32,37,115,44,32,103,111,116,32,37,115,10,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,110,97,109,101,115,112,97,99,101,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,119,114,111,110,103,32,110,97,109,101,115,112,97,99,101,58,32,101,120,112,101,99,116,105,110,103,32,37,115,10,0,0,0,68,105,100,32,110,111,116,32,101,120,112,101,99,116,32,101,108,101,109,101,110,116,32,37,115,32,116,104,101,114,101,10,0,0,0,0,0,0,0,0,68,105,100,32,110,111,116,32,101,120,112,101,99,116,32,116,101,120,116,32,105,110,32,101,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,69,120,112,101,99,116,105,110,103,32,110,111,32,110,97,109,101,115,112,97,99,101,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,69,120,112,101,99,116,105,110,103,32,101,108,101,109,101,110,116,32,37,115,32,116,111,32,98,101,32,101,109,112,116,121,10,0,0,0,0,0,0,0,69,120,112,101,99,116,105,110,103,32,97,110,32,101,108,101,109,101,110,116,32,37,115,44,32,103,111,116,32,110,111,116,104,105,110,103,10,0,0,0,69,120,112,101,99,116,105,110,103,32,97,110,32,101,108,101,109,101,110,116,32,103,111,116,32,116,101,120,116,10,0,0,69,108,101,109,101,110,116,32,37,115,32,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,97,116,116,114,105,98,117,116,101,115,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,99,111,110,116,101,110,116,10,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,101,120,116,114,97,32,99,111,110,116,101,110,116,58,32,37,115,10,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,97,116,116,114,105,98,117,116,101,32,37,115,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,68,97,116,97,116,121,112,101,32,101,108,101,109,101,110,116,32,37,115,32,99,111,110,116,97,105,110,115,32,110,111,32,100,97,116,97,10,0,0,0,68,97,116,97,116,121,112,101,32,101,108,101,109,101,110,116,32,37,115,32,104,97,115,32,99,104,105,108,100,32,101,108,101,109,101,110,116,115,10,0,86,97,108,117,101,32,101,108,101,109,101,110,116,32,37,115,32,104,97,115,32,99,104,105,108,100,32,101,108,101,109,101,110,116,115,10,0,0,0,0,76,105,115,116,32,101,108,101,109,101,110,116,32,37,115,32,104,97,115,32,99,104,105,108,100,32,101,108,101,109,101,110,116,115,10,0,0,0,0,0,69,114,114,111,114,32,118,97,108,105,100,97,116,105,110,103,32,100,97,116,97,116,121,112,101,32,37,115,10,0,0,0,69,114,114,111,114,32,118,97,108,105,100,97,116,105,110,103,32,118,97,108,117,101,32,37,115,10,0,0,0,0,0,0,69,114,114,111,114,32,118,97,108,105,100,97,116,105,110,103,32,108,105,115,116,10,0,0,78,111,32,116,111,112,32,103,114,97,109,109,97,114,32,100,101,102,105,110,101,100,10,0,69,120,116,114,97,32,100,97,116,97,32,105,110,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,32,33,10,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,32,99,111,100,101,32,37,100,10,0,0,115,116,111,114,105,110,103,32,115,116,97,116,101,115,10,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,114,101,108,97,120,110,103,46,99,0,0,0,0,97,100,100,105,110,103,32,115,116,97,116,101,115,10,0,0,35,97,110,121,0,0,0,0,118,97,108,105,100,97,116,105,110,103,10,0,0,0,0,0,110,111,110,97,109,101,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,97,116,101,115,10,0,0,0,0,0,0,78,85,76,76,32,100,101,102,105,110,105,116,105,111,110,32,108,105,115,116,0,0,0,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,109,105,115,115,105,110,103,32,99,111,110,116,101,120,116,10,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,109,105,115,115,105,110,103,32,100,101,102,105,110,101,10,0,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,109,105,115,115,105,110,103,32,105,110,102,111,10,0,0,0,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,100,101,102,105,110,101,32,105,115,32,110,111,116,32,101,108,101,109,101,110,116,10,0,0,0,112,117,115,104,105,110,103,32,101,114,114,111,114,10,0,0,82,78,71,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,116,114,121,105,110,103,32,116,111,32,99,111,109,112,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,101,109,112,116,121,0,0,0,110,111,116,65,108,108,111,119,101,100,0,0,0,0,0,0,101,120,99,101,112,116,0,0,116,101,120,116,0,0,0,0,101,108,101,109,101,110,116,0,100,97,116,97,116,121,112,101,0,0,0,0,0,0,0,0,118,97,108,117,101,0,0,0,108,105,115,116,0,0,0,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,100,101,102,0,0,0,0,0,114,101,102,0,0,0,0,0,101,120,116,101,114,110,97,108,82,101,102,0,0,0,0,0,112,97,114,101,110,116,82,101,102,0,0,0,0,0,0,0,111,112,116,105,111,110,97,108,0,0,0,0,0,0,0,0,122,101,114,111,79,114,77,111,114,101,0,0,0,0,0,0,111,110,101,79,114,77,111,114,101,0,0,0,0,0,0,0,99,104,111,105,99,101,0,0,103,114,111,117,112,0,0,0,105,110,116,101,114,108,101,97,118,101,0,0,0,0,0,0,115,116,97,114,116,0,0,0,110,111,111,112,0,0,0,0,112,97,114,97,109,0,0,0,117,110,107,110,111,119,110,0,97,108,108,111,99,97,116,105,110,103,32,100,101,102,105,110,101,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,111,114,32,116,101,120,116,32,99,111,110,102,108,105,99,116,115,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,115,32,99,111,110,102,108,105,99,116,115,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,105,110,32,105,110,116,101,114,108,101,97,118,101,32,99,111,109,112,117,116,97,116,105,111,110,10,0,0,0,0,0,0,24,231,2,0,0,0,0,0,1,0,0,0,0,0,0,0,103,101,116,116,105,110,103,32,101,108,101,109,101,110,116,32,108,105,115,116,10,0,0,0,103,114,97,109,109,97,114,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,114,101,102,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,102,111,117,110,100,32,110,111,32,100,101,102,105,110,101,32,102,111,114,32,112,97,114,101,110,116,32,114,101,102,115,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,102,111,117,110,100,32,110,111,32,100,101,102,105,110,101,32,102,111,114,32,114,101,102,32,37,115,10,0,0,0,0,110,117,108,108,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,101,108,101,109,101,110,116,40,114,101,102,41,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,101,108,101,109,101,110,116,40,114,101,102,41,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,97,116,116,114,105,98,117,116,101,47,47,101,108,101,109,101,110,116,40,114,101,102,41,10,0,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,97,116,116,114,105,98,117,116,101,115,32,104,97,118,101,32,97,32,99,111,110,116,101,110,116,32,116,121,112,101,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,97,32,99,111,110,116,101,110,116,32,116,121,112,101,32,101,114,114,111,114,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,97,116,116,114,105,98,117,116,101,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,111,110,101,79,114,77,111,114,101,47,47,103,114,111,117,112,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,111,110,101,79,114,77,111,114,101,47,47,105,110,116,101,114,108,101,97,118,101,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,97,116,116,114,105,98,117,116,101,10,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,97,110,121,78,97,109,101,32,97,116,116,114,105,98,117,116,101,32,119,105,116,104,111,117,116,32,111,110,101,79,114,77,111,114,101,32,97,110,99,101,115,116,111,114,10,0,0,0,0,0,70,111,117,110,100,32,110,115,78,97,109,101,32,97,116,116,114,105,98,117,116,101,32,119,105,116,104,111,117,116,32,111,110,101,79,114,77,111,114,101,32,97,110,99,101,115,116,111,114,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,111,110,101,79,114,77,111,114,101,10,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,111,110,101,79,114,77,111,114,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,108,105,115,116,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,108,105,115,116,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,108,105,115,116,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,103,114,111,117,112,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,103,114,111,117,112,10,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,100,97,116,97,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,118,97,108,117,101,10,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,116,101,120,116,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,116,101,120,116,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,116,101,120,116,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,101,109,112,116,121,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,101,109,112,116,121,10,0,0,0,98,117,105,108,100,105,110,103,32,99,104,111,105,99,101,10,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,103,114,111,117,112,10,0,65,116,116,114,105,98,117,116,101,115,32,99,111,110,102,108,105,99,116,115,32,105,110,32,103,114,111,117,112,10,0,0,68,101,116,101,99,116,101,100,32,97,32,99,121,99,108,101,32,105,110,32,37,115,32,114,101,102,101,114,101,110,99,101,115,10,0,0,0,0,0,0,115,116,97,114,116,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,101,108,101,109,101,110,116,32,101,109,112,116,121,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,101,108,101,109,101,110,116,32,110,111,116,65,108,108,111,119,101,100,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,0,0,0,115,116,97,114,116,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,99,104,105,108,100,114,101,110,10,0,0,0,101,109,112,116,121,58,32,104,97,100,32,97,32,99,104,105,108,100,32,110,111,100,101,10,0,0,0,0,0,0,0,0,116,101,120,116,58,32,104,97,100,32,97,32,99,104,105,108,100,32,110,111,100,101,10,0,69,108,101,109,101,110,116,32,37,115,32,105,115,32,101,109,112,116,121,10,0,0,0,0,110,97,109,101,0,0,0,0,114,101,102,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,0,0,0,0,0,114,101,102,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,114,101,102,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,104,97,115,104,10,0,0,0,0,0,0,0,69,114,114,111,114,32,114,101,102,115,32,100,101,102,105,110,105,116,105,111,110,115,32,39,37,115,39,10,0,0,0,0,69,114,114,111,114,32,114,101,102,115,32,100,101,102,105,110,105,116,105,111,110,115,10,0,100,97,116,97,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,110,111,116,65,108,108,111,119,101,100,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,0,0,85,115,101,32,111,102,32,112,97,114,101,110,116,82,101,102,32,119,105,116,104,111,117,116,32,97,32,112,97,114,101,110,116,32,103,114,97,109,109,97,114,10,0,0,0,0,0,0,112,97,114,101,110,116,82,101,102,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,112,97,114,101,110,116,82,101,102,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,112,97,114,101,110,116,82,101,102,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,112,97,114,101,110,116,82,101,102,32,100,101,102,105,110,105,116,105,111,110,115,32,39,37,115,39,10,0,0,0,0,0,0,109,105,120,101,100,0,0,0,77,105,120,101,100,32,105,115,32,101,109,112,116,121,10,0,85,110,101,120,112,101,99,116,101,100,32,110,111,100,101,32,37,115,32,105,115,32,110,111,116,32,97,32,112,97,116,116,101,114,110,10,0,0,0,0,110,115,0,0,0,0,0,0,99,114,101,97,116,101,32,105,110,116,101,114,108,101,97,118,101,115,10,0,0,0,0,0,105,110,116,101,114,108,101,97,118,101,37,100,0,0,0,0,70,97,105,108,101,100,32,116,111,32,97,100,100,32,37,115,32,116,111,32,104,97,115,104,32,116,97,98,108,101,10,0,69,108,101,109,101,110,116,32,105,110,116,101,114,108,101,97,118,101,32,105,115,32,101,109,112,116,121,10,0,0,0,0,116,121,112,101,0,0,0,0,118,97,108,117,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,0,0,104,116,116,112,58,47,47,114,101,108,97,120,110,103,46,111,114,103,47,110,115,47,115,116,114,117,99,116,117,114,101,47,49,46,48,0,0,0,0,0,85,115,101,32,111,102,32,117,110,114,101,103,105,115,116,101,114,101,100,32,116,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,10,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,119,105,116,104,32,116,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,58,32,110,111,32,39,104,97,118,101,39,10,0,0,0,0,0,0,0,69,114,114,111,114,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,101,120,112,111,114,116,101,100,32,98,121,32,116,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,10,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,115,105,110,103,108,101,32,116,101,120,116,32,118,97,108,117,101,32,102,111,114,32,60,118,97,108,117,101,62,99,111,110,116,101,110,116,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,60,118,97,108,117,101,62,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,86,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,99,99,101,112,116,97,98,108,101,32,102,111,114,32,116,121,112,101,32,39,37,115,39,10,0,0,0,0,0,100,97,116,97,116,121,112,101,76,105,98,114,97,114,121,0,58,47,35,63,0,0,0,0,100,97,116,97,32,104,97,115,32,110,111,32,116,121,112,101,10,0,0,0,0,0,0,0,100,97,116,97,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,84,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,97,108,108,111,119,32,116,121,112,101,32,112,97,114,97,109,101,116,101,114,115,10,0,0,0,0,0,0,0,112,97,114,97,109,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,0,0,0,101,120,99,101,112,116,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,0,69,108,101,109,101,110,116,32,100,97,116,97,32,104,97,115,32,117,110,101,120,112,101,99,116,101,100,32,99,111,110,116,101,110,116,32,37,115,10,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,97,116,116,114,105,98,117,116,101,58,32,97,116,116,114,105,98,117,116,101,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,0,0,97,116,116,114,105,98,117,116,101,32,104,97,115,32,105,110,118,97,108,105,100,32,99,111,110,116,101,110,116,10,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,110,111,111,112,32,102,111,117,110,100,32,105,110,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,97,116,116,114,105,98,117,116,101,32,104,97,115,32,109,117,108,116,105,112,108,101,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,0,0,97,110,121,78,97,109,101,0,110,115,78,97,109,101,0,0,69,108,101,109,101,110,116,32,37,115,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,0,0,0,0,65,116,116,114,105,98,117,116,101,32,119,105,116,104,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,120,109,108,110,115,0,0,0,65,116,116,114,105,98,117,116,101,32,119,105,116,104,32,81,78,97,109,101,32,39,120,109,108,110,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,0,110,115,78,97,109,101,32,104,97,115,32,110,111,32,110,115,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,69,108,101,109,101,110,116,32,99,104,111,105,99,101,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,0,0,0,101,120,112,101,99,116,105,110,103,32,110,97,109,101,44,32,97,110,121,78,97,109,101,44,32,110,115,78,97,109,101,32,111,114,32,99,104,111,105,99,101,32,58,32,103,111,116,32,37,115,10,0,0,0,0,0,110,111,116,104,105,110,103,0,69,120,112,101,99,116,105,110,103,32,97,110,32,101,120,99,101,112,116,32,110,111,100,101,10,0,0,0,0,0,0,0,101,120,99,101,112,116,78,97,109,101,67,108,97,115,115,32,97,108,108,111,119,115,32,111,110,108,121,32,97,32,115,105,110,103,108,101,32,101,120,99,101,112,116,32,110,111,100,101,10,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,69,108,101,109,101,110,116,58,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,69,108,101,109,101,110,116,58,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,114,116,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,112,97,114,97,109,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,101,120,99,101,112,116,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,110,111,111,112,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,60,103,114,97,109,109,97,114,62,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,60,103,114,97,109,109,97,114,62,32,104,97,115,32,110,111,32,60,115,116,97,114,116,62,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,110,111,32,103,114,97,109,109,97,114,32,105,110,32,67,104,101,99,107,82,101,102,101,114,101,110,99,101,32,37,115,10,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,114,101,102,101,114,101,110,99,101,32,104,97,115,32,99,111,110,116,101,110,116,32,105,110,32,67,104,101,99,107,82,101,102,101,114,101,110,99,101,32,37,115,10,0,0,0,0,0,82,101,102,101,114,101,110,99,101,32,37,115,32,104,97,115,32,110,111,32,109,97,116,99,104,105,110,103,32,100,101,102,105,110,105,116,105,111,110,10,0,0,0,0,0,0,0,0,99,111,109,98,105,110,101,0,68,101,102,105,110,101,115,32,102,111,114,32,37,115,32,117,115,101,32,98,111,116,104,32,39,99,104,111,105,99,101,39,32,97,110,100,32,39,105,110,116,101,114,108,101,97,118,101,39,10,0,0,0,0,0,0,68,101,102,105,110,101,115,32,102,111,114,32,37,115,32,117,115,101,32,117,110,107,110,111,119,110,32,99,111,109,98,105,110,101,32,118,97,108,117,101,32,39,37,115,39,39,10,0,83,111,109,101,32,100,101,102,105,110,101,115,32,102,111,114,32,37,115,32,110,101,101,100,115,32,116,104,101,32,99,111,109,98,105,110,101,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,105,110,116,101,114,108,101,97,118,101,115,32,104,97,115,104,32,116,97,98,108,101,10,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,115,116,97,114,116,32,101,108,101,109,101,110,116,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,0,0,60,115,116,97,114,116,62,32,117,115,101,32,98,111,116,104,32,39,99,104,111,105,99,101,39,32,97,110,100,32,39,105,110,116,101,114,108,101,97,118,101,39,10,0,0,0,0,0,60,115,116,97,114,116,62,32,117,115,101,115,32,117,110,107,110,111,119,110,32,99,111,109,98,105,110,101,32,118,97,108,117,101,32,39,37,115,39,39,10,0,0,0,0,0,0,0,83,111,109,101,32,60,115,116,97,114,116,62,32,101,108,101,109,101,110,116,32,109,105,115,115,32,116,104,101,32,99,111,109,98,105,110,101,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,0,103,114,97,109,109,97,114,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,0,0,100,101,102,105,110,101,0,0,105,110,99,108,117,100,101,0,103,114,97,109,109,97,114,32,104,97,115,32,117,110,101,120,112,101,99,116,101,100,32,99,104,105,108,100,32,37,115,10,0,0,0,0,0,0,0,0,73,110,99,108,117,100,101,32,110,111,100,101,32,104,97,115,32,110,111,32,100,97,116,97,10,0,0,0,0,0,0,0,73,110,99,108,117,100,101,32,100,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,0,73,110,99,108,117,100,101,32,100,111,99,117,109,101,110,116,32,114,111,111,116,32,105,115,32,110,111,116,32,97,32,103,114,97,109,109,97,114,10,0,100,101,102,105,110,101,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,0,0,100,101,102,105,110,101,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,0,100,101,102,105,110,101,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,100,101,102,105,110,105,116,105,111,110,32,104,97,115,104,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,111,110,32,100,101,102,105,110,101,32,97,103,103,114,101,103,97,116,105,111,110,32,111,102,32,37,115,10,0,0,0,0,0,101,108,101,109,101,110,116,32,37,115,32,100,111,101,115,110,39,116,32,97,108,108,111,119,32,102,111,114,101,105,103,110,32,101,108,101,109,101,110,116,115,10,0,0,0,0,0,0,104,114,101,102,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,101,120,116,101,114,110,97,108,82,101,102,32,104,97,115,32,110,111,32,104,114,101,102,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,73,110,99,111,114,114,101,99,116,32,85,82,73,32,102,111,114,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,0,0,0,0,0,70,114,97,103,109,101,110,116,32,102,111,114,98,105,100,100,101,110,32,105,110,32,85,82,73,32,102,111,114,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,85,82,76,32,102,111,114,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,105,110,99,108,117,100,101,32,104,97,115,32,110,111,32,104,114,101,102,32,97,116,116,114,105,98,117,116,101,10,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,85,82,76,32,102,111,114,32,105,110,99,108,117,100,101,32,37,115,10,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,105,110,99,108,117,100,101,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,110,97,109,101,32,37,115,32,101,108,101,109,101,110,116,10,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,110,111,32,110,97,109,101,115,112,97,99,101,32,102,111,114,32,112,114,101,102,105,120,32,37,115,10,0,0,0,0,70,111,117,110,100,32,110,115,78,97,109,101,47,101,120,99,101,112,116,47,47,110,115,78,97,109,101,32,102,111,114,98,105,100,100,101,110,32,99,111,110,115,116,114,117,99,116,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,97,110,121,78,97,109,101,47,101,120,99,101,112,116,47,47,97,110,121,78,97,109,101,32,102,111,114,98,105,100,100,101,110,32,99,111,110,115,116,114,117,99,116,10,0,0,0,0,0,0,70,111,117,110,100,32,110,115,78,97,109,101,47,101,120,99,101,112,116,47,47,97,110,121,78,97,109,101,32,102,111,114,98,105,100,100,101,110,32,99,111,110,115,116,114,117,99,116,10,0,0,0,0,0,0,0,100,105,118,0,0,0,0,0,68,101,116,101,99,116,101,100,32,97,110,32,73,110,99,108,117,100,101,32,114,101,99,117,114,115,105,111,110,32,102,111,114,32,37,115,10,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,37,115,10,0,0,97,108,108,111,99,97,116,105,110,103,32,105,110,99,108,117,100,101,10,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,100,32,100,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,32,37,115,10,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,100,32,100,111,99,117,109,101,110,116,32,37,115,32,114,111,111,116,32,105,115,32,110,111,116,32,97,32,103,114,97,109,109,97,114,10,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,32,37,115,32,104,97,115,32,97,32,115,116,97,114,116,32,98,117,116,32,110,111,116,32,116,104,101,32,105,110,99,108,117,100,101,100,32,103,114,97,109,109,97,114,10,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,32,37,115,32,104,97,115,32,100,101,102,105,110,101,32,119,105,116,104,111,117,116,32,110,97,109,101,10,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,32,37,115,32,104,97,115,32,97,32,100,101,102,105,110,101,32,37,115,32,98,117,116,32,110,111,116,32,116,104,101,32,105,110,99,108,117,100,101,100,32,103,114,97,109,109,97,114,10,0,0,0,0,68,101,116,101,99,116,101,100,32,97,110,32,101,120,116,101,114,110,97,108,82,101,102,32,114,101,99,117,114,115,105,111,110,32,102,111,114,32,37,115,10,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,100,111,99,32,37,115,10,0,97,100,100,105,110,103,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,37,115,10,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,85,82,73,32,37,115,10,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,85,82,73,32,37,115,32,104,97,115,32,97,32,102,114,97,103,109,101,110,116,32,73,68,10,0,0,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,110,32,37,115,10,0,0,0,0,0,115,116,114,105,110,103,0,0,116,111,107,101,110,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,0,0,0,0,0,0,0,0,109,105,110,73,110,99,108,117,115,105,118,101,0,0,0,0,109,105,110,69,120,99,108,117,115,105,118,101,0,0,0,0,109,97,120,73,110,99,108,117,115,105,118,101,0,0,0,0,109,97,120,69,120,99,108,117,115,105,118,101,0,0,0,0,116,111,116,97,108,68,105,103,105,116,115,0,0,0,0,0,102,114,97,99,116,105,111,110,68,105,103,105,116,115,0,0,112,97,116,116,101,114,110,0,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,119,104,105,116,101,83,112,97,99,101,0,0,0,0,0,0,108,101,110,103,116,104,0,0,109,97,120,76,101,110,103,116,104,0,0,0,0,0,0,0,109,105,110,76,101,110,103,116,104,0,0,0,0,0,0,0,82,101,108,97,120,45,78,71,32,116,121,112,101,115,32,108,105,98,114,97,114,121,32,39,37,115,39,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,10,0,97,100,100,105,110,103,32,116,121,112,101,115,32,108,105,98,114,97,114,121,10,0,0,0,82,101,108,97,120,45,78,71,32,116,121,112,101,115,32,108,105,98,114,97,114,121,32,102,97,105,108,101,100,32,116,111,32,114,101,103,105,115,116,101,114,32,39,37,115,39,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,83,65,88,50,73,110,116,101,114,110,97,108,83,117,98,115,101,116,0,0,0,120,109,108,83,65,88,50,69,120,116,101,114,110,97,108,83,117,98,115,101,116,0,0,0,69,110,116,105,116,121,40,37,115,41,32,100,111,99,117,109,101,110,116,32,109,97,114,107,101,100,32,115,116,97,110,100,97,108,111,110,101,32,98,117,116,32,114,101,113,117,105,114,101,115,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,0,70,97,105,108,117,114,101,32,116,111,32,112,114,111,99,101,115,115,32,101,110,116,105,116,121,32,37,115,10,0,0,0,69,110,116,105,116,121,40,37,115,41,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,0,0,69,110,116,105,116,121,40,37,115,41,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,0,0,83,65,88,46,120,109,108,83,65,88,50,69,110,116,105,116,121,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,0,120,109,108,58,105,100,0,0,120,109,108,58,105,100,32,58,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,32,115,104,111,117,108,100,32,98,101,32,73,68,10,0,0,0,83,65,88,46,120,109,108,83,65,88,50,65,116,116,114,105,98,117,116,101,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+187248),
	allocate([101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,0,0,0,0,0,0,83,65,88,46,120,109,108,83,65,88,50,69,108,101,109,101,110,116,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,83,65,88,46,120,109,108,83,65,88,50,78,111,116,97,116,105,111,110,68,101,99,108,40,37,115,41,32,101,120,116,101,114,110,97,108,73,68,32,111,114,32,80,117,98,108,105,99,73,68,32,109,105,115,115,105,110,103,10,0,0,0,0,0,83,65,88,46,120,109,108,83,65,88,50,78,111,116,97,116,105,111,110,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,83,65,88,46,120,109,108,83,65,88,50,85,110,112,97,114,115,101,100,69,110,116,105,116,121,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,0,120,109,108,83,65,88,50,83,116,97,114,116,68,111,99,117,109,101,110,116,0,0,0,0,86,97,108,105,100,97,116,105,111,110,32,102,97,105,108,101,100,58,32,110,111,32,68,84,68,32,102,111,117,110,100,32,33,0,0,0,0,0,0,0,120,109,108,83,65,88,50,83,116,97,114,116,69,108,101,109,101,110,116,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,120,109,108,83,65,88,50,83,116,97,114,116,69,108,101,109,101,110,116,78,115,0,0,0,120,109,108,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,119,97,115,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,100,101,102,97,117,108,116,32,112,114,101,102,105,120,32,119,97,115,32,110,111,116,32,102,111,117,110,100,10,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,0,0,0,0,0,0,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,58,32,120,109,108,83,116,114,100,117,112,32,114,101,116,117,114,110,101,100,32,78,85,76,76,0,0,0,0,0,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,58,32,104,117,103,101,32,116,101,120,116,32,110,111,100,101,0,0,0,0,0,0,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,32,111,118,101,114,102,108,111,119,32,112,114,101,118,101,110,116,101,100,0,0,0,0,2,0,0,0,0,0,0,0,120,109,108,83,65,88,50,84,101,120,116,78,111,100,101,0,120,109,108,83,65,88,50,65,116,116,114,105,98,117,116,101,78,115,0,0,0,0,0,0,120,109,108,58,105,100,32,58,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,37,115,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,120,109,108,110,115,0,0,0,105,110,118,97,108,105,100,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,10,0,0,0,0,0,65,118,111,105,100,32,97,116,116,114,105,98,117,116,101,32,101,110,100,105,110,103,32,119,105,116,104,32,39,58,39,32,108,105,107,101,32,39,37,115,39,10,0,0,0,0,0,0,120,109,108,110,115,58,32,37,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,0,0,0,0,0,120,109,108,110,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,69,109,112,116,121,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,102,111,114,32,112,114,101,102,105,120,32,37,115,10,0,0,0,0,0,120,109,108,110,115,58,37,115,58,32,37,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,0,0,120,109,108,110,115,58,37,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,111,102,32,97,116,116,114,105,98,117,116,101,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,105,110,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,0,0,58,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,110,32,37,115,32,100,101,102,97,117,108,116,101,100,32,102,114,111,109,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,49,1,52,1,62,1,65,1,72,1,74,1,126,1,128,1,195,1,205,1,240,1,244,1,245,1,250,1,23,2,80,2,168,2,187,2,193,2,134,3,134,3,136,3,138,3,140,3,140,3,142,3,161,3,163,3,206,3,208,3,214,3,218,3,218,3,220,3,220,3,222,3,222,3,224,3,224,3,226,3,243,3,1,4,12,4,14,4,79,4,81,4,92,4,94,4,129,4,144,4,196,4,199,4,200,4,203,4,204,4,208,4,235,4,238,4,245,4,248,4,249,4,49,5,86,5,89,5,89,5,97,5,134,5,208,5,234,5,240,5,242,5,33,6,58,6,65,6,74,6,113,6,183,6,186,6,190,6,192,6,206,6,208,6,211,6,213,6,213,6,229,6,230,6,5,9,57,9,61,9,61,9,88,9,97,9,133,9,140,9,143,9,144,9,147,9,168,9,170,9,176,9,178,9,178,9,182,9,185,9,220,9,221,9,223,9,225,9,240,9,241,9,5,10,10,10,15,10,16,10,19,10,40,10,42,10,48,10,50,10,51,10,53,10,54,10,56,10,57,10,89,10,92,10,94,10,94,10,114,10,116,10,133,10,139,10,141,10,141,10,143,10,145,10,147,10,168,10,170,10,176,10,178,10,179,10,181,10,185,10,189,10,189,10,224,10,224,10,5,11,12,11,15,11,16,11,19,11,40,11,42,11,48,11,50,11,51,11,54,11,57,11,61,11,61,11,92,11,93,11,95,11,97,11,133,11,138,11,142,11,144,11,146,11,149,11,153,11,154,11,156,11,156,11,158,11,159,11,163,11,164,11,168,11,170,11,174,11,181,11,183,11,185,11,5,12,12,12,14,12,16,12,18,12,40,12,42,12,51,12,53,12,57,12,96,12,97,12,133,12,140,12,142,12,144,12,146,12,168,12,170,12,179,12,181,12,185,12,222,12,222,12,224,12,225,12,5,13,12,13,14,13,16,13,18,13,40,13,42,13,57,13,96,13,97,13,1,14,46,14,48,14,48,14,50,14,51,14,64,14,69,14,129,14,130,14,132,14,132,14,135,14,136,14,138,14,138,14,141,14,141,14,148,14,151,14,153,14,159,14,161,14,163,14,165,14,165,14,167,14,167,14,170,14,171,14,173,14,174,14,176,14,176,14,178,14,179,14,189,14,189,14,192,14,196,14,64,15,71,15,73,15,105,15,160,16,197,16,208,16,246,16,0,17,0,17,2,17,3,17,5,17,7,17,9,17,9,17,11,17,12,17,14,17,18,17,60,17,60,17,62,17,62,17,64,17,64,17,76,17,76,17,78,17,78,17,80,17,80,17,84,17,85,17,89,17,89,17,95,17,97,17,99,17,99,17,101,17,101,17,103,17,103,17,105,17,105,17,109,17,110,17,114,17,115,17,117,17,117,17,158,17,158,17,168,17,168,17,171,17,171,17,174,17,175,17,183,17,184,17,186,17,186,17,188,17,194,17,235,17,235,17,240,17,240,17,249,17,249,17,0,30,155,30,160,30,249,30,0,31,21,31,24,31,29,31,32,31,69,31,72,31,77,31,80,31,87,31,89,31,89,31,91,31,91,31,93,31,93,31,95,31,125,31,128,31,180,31,182,31,188,31,190,31,190,31,194,31,196,31,198,31,204,31,208,31,211,31,214,31,219,31,224,31,236,31,242,31,244,31,246,31,252,31,38,33,38,33,42,33,43,33,46,33,46,33,128,33,130,33,65,48,148,48,161,48,250,48,5,49,44,49,0,172,163,215,0,0,0,0,197,0,0,0,0,0,0,0,40,9,3,0,0,0,0,0,0,3,69,3,96,3,97,3,131,4,134,4,145,5,161,5,163,5,185,5,187,5,189,5,191,5,191,5,193,5,194,5,196,5,196,5,75,6,82,6,112,6,112,6,214,6,220,6,221,6,223,6,224,6,228,6,231,6,232,6,234,6,237,6,1,9,3,9,60,9,60,9,62,9,76,9,77,9,77,9,81,9,84,9,98,9,99,9,129,9,131,9,188,9,188,9,190,9,190,9,191,9,191,9,192,9,196,9,199,9,200,9,203,9,205,9,215,9,215,9,226,9,227,9,2,10,2,10,60,10,60,10,62,10,62,10,63,10,63,10,64,10,66,10,71,10,72,10,75,10,77,10,112,10,113,10,129,10,131,10,188,10,188,10,190,10,197,10,199,10,201,10,203,10,205,10,1,11,3,11,60,11,60,11,62,11,67,11,71,11,72,11,75,11,77,11,86,11,87,11,130,11,131,11,190,11,194,11,198,11,200,11,202,11,205,11,215,11,215,11,1,12,3,12,62,12,68,12,70,12,72,12,74,12,77,12,85,12,86,12,130,12,131,12,190,12,196,12,198,12,200,12,202,12,205,12,213,12,214,12,2,13,3,13,62,13,67,13,70,13,72,13,74,13,77,13,87,13,87,13,49,14,49,14,52,14,58,14,71,14,78,14,177,14,177,14,180,14,185,14,187,14,188,14,200,14,205,14,24,15,25,15,53,15,53,15,55,15,55,15,57,15,57,15,62,15,62,15,63,15,63,15,113,15,132,15,134,15,139,15,144,15,149,15,151,15,151,15,153,15,173,15,177,15,183,15,185,15,185,15,208,32,220,32,225,32,225,32,42,48,47,48,153,48,153,48,154,48,154,48,0,0,0,0,95,0,0,0,0,0,0,0,80,12,3,0,0,0,0,0,96,6,105,6,240,6,249,6,102,9,111,9,230,9,239,9,102,10,111,10,230,10,239,10,102,11,111,11,231,11,239,11,102,12,111,12,230,12,239,12,102,13,111,13,80,14,89,14,208,14,217,14,32,15,41,15,14,0,0,0,0,0,0,0,224,13,3,0,0,0,0,0,208,2,208,2,209,2,209,2,135,3,135,3,64,6,64,6,70,14,70,14,198,14,198,14,5,48,5,48,49,48,53,48,157,48,158,48,252,48,254,48,10,0,0,0,0,0,0,0,40,14,3,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,99,104,105,108,100,0,0,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,88,72,84,77,76,32,49,46,48,32,83,116,114,105,99,116,47,47,69,78,0,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,88,72,84,77,76,32,49,46,48,32,70,114,97,109,101,115,101,116,47,47,69,78,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,88,72,84,77,76,32,49,46,48,32,84,114,97,110,115,105,116,105,111,110,97,108,47,47,69,78,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,120,104,116,109,108,49,47,68,84,68,47,120,104,116,109,108,49,45,115,116,114,105,99,116,46,100,116,100,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,120,104,116,109,108,49,47,68,84,68,47,120,104,116,109,108,49,45,102,114,97,109,101,115,101,116,46,100,116,100,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,120,104,116,109,108,49,47,68,84,68,47,120,104,116,109,108,49,45,116,114,97,110,115,105,116,105,111,110,97,108,46,100,116,100,0,38,35,49,48,59,0,0,0,38,35,49,51,59,0,0,0,38,35,57,59,0,0,0,0,38,113,117,111,116,59,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,109,112,59,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,98,117,102,102,101,114,0,85,84,70,45,56,0,0,0,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,0,60,63,0,0,0,0,0,0,32,0,0,0,0,0,0,0,63,62,0,0,0,0,0,0,60,33,45,45,0,0,0,0,45,45,62,0,0,0,0,0,38,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,60,33,91,67,68,65,84,65,91,93,93,62,0,0,0,0,60,33,91,67,68,65,84,65,91,0,0,0,0,0,0,0,93,93,62,0,0,0,0,0,60,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,104,116,109,108,0,0,0,0,32,120,109,108,110,115,61,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,49,57,57,57,47,120,104,116,109,108,34,0,0,0,104,101,97,100,0,0,0,0,109,101,116,97,0,0,0,0,104,116,116,112,45,101,113,117,105,118,0,0,0,0,0,0,67,111,110,116,101,110,116,45,84,121,112,101,0,0,0,0,32,47,62,0,0,0,0,0,62,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,60,109,101,116,97,32,104,116,116,112,45,101,113,117,105,118,61,34,67,111,110,116,101,110,116,45,84,121,112,101,34,32,99,111,110,116,101,110,116,61,34,116,101,120,116,47,104,116,109,108,59,32,99,104,97,114,115,101,116,61,0,0,0,0,34,32,47,62,0,0,0,0,60,47,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,49,57,57,57,47,120,104,116,109,108,0,0,0,0,97,114,101,97,0,0,0,0,98,114,0,0,0,0,0,0,98,97,115,101,0,0,0,0,98,97,115,101,102,111,110,116,0,0,0,0,0,0,0,0,99,111,108,0,0,0,0,0,102,114,97,109,101,0,0,0,104,114,0,0,0,0,0,0,105,109,103,0,0,0,0,0,105,110,112,117,116,0,0,0,105,115,105,110,100,101,120,0,108,105,110,107,0,0,0,0,112,97,114,97,109,0,0,0,105,100,0,0,0,0,0,0,110,97,109,101,0,0,0,0,108,97,110,103,0,0,0,0,120,109,108,0,0,0,0,0,97,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,100,105,118,0,0,0,0,0,109,97,112,0,0,0,0,0,97,112,112,108,101,116,0,0,102,111,114,109,0,0,0,0,105,102,114,97,109,101,0,0,32,105,100,61,34,0,0,0,34,0,0,0,0,0,0,0,32,120,109,108,58,108,97,110,103,61,34,0,0,0,0,0,32,108,97,110,103,61,34,0,61,34,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,0,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,32,91,10,0,0,0,0,0,93,62,0,0,0,0,0,0,120,109,108,69,115,99,97,112,101,69,110,116,105,116,105,101,115,32,58,32,99,104,97,114,32,111,117,116,32,111,102,32,114,97,110,103,101,10,0,0,115,116,114,105,110,103,32,105,115,32,110,111,116,32,105,110,32,85,84,70,45,56,10,0,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,32,37,115,10,0,0,0,0,100,111,99,117,109,101,110,116,32,104,97,115,32,110,111,32,68,79,67,84,89,80,69,10,0,0,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,32,110,117,109,98,101,114,10,0,0,0,0,0,0,0,0,47,62,0,0,0,0,0,0,72,84,77,76,0,0,0,0,99,114,101,97,116,105,110,103,32,101,110,99,111,100,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,0,0,34,49,46,48,34,0,0,0,32,101,110,99,111,100,105,110,103,61,0,0,0,0,0,0,32,115,116,97,110,100,97,108,111,110,101,61,34,110,111,34,0,0,0,0,0,0,0,0,32,115,116,97,110,100,97,108,111,110,101,61,34,121,101,115,34,0,0,0,0,0,0,0,63,62,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,115,97,118,105,110,103,32,99,111,110,116,101,120,116,0,120,109,108,110,115,58,0,0,120,109,108,110,115,0,0,0,61,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,88,80,97,116,104,32,99,111,110,116,101,120,116,0,0,120,109,108,83,99,104,101,109,97,116,114,111,110,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,39,37,115,39,46,10,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,116,114,111,110,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,112,97,114,115,101,46,10,0,0,0,105,110,95,109,101,109,111,114,121,95,98,117,102,102,101,114,0,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,104,97,115,32,110,111,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,46,10,0,0,0,0,115,99,104,101,109,97,0,0,96,25,3,0,0,0,0,0,56,25,3,0,0,0,0,0,84,104,101,32,88,77,76,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,88,77,76,32,115,99,104,101,109,97,116,114,111,110,32,100,111,99,117,109,101,110,116,0,0,116,105,116,108,101,0,0,0,110,115,0,0,0,0,0,0,112,114,101,102,105,120,0,0,117,114,105,0,0,0,0,0,110,115,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,117,114,105,0,0,0,110,115,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,112,114,101,102,105,120,0,0,0,0,0,0,0,0,112,97,116,116,101,114,110,0,69,120,112,101,99,116,105,110,103,32,97,32,112,97,116,116,101,114,110,32,101,108,101,109,101,110,116,32,105,110,115,116,101,97,100,32,111,102,32,37,115,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,116,114,111,110,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,104,97,115,32,110,111,32,112,97,116,116,101,114,110,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,115,99,104,101,109,97,116,114,111,110,46,99,0,80,97,116,116,101,114,110,58,32,37,115,10,0,0,0,0,37,115,0,0,0,0,0,0,110,111,100,101,32,102,97,105,108,101,100,32,97,115,115,101,114,116,0,0,0,0,0,0,110,111,100,101,32,102,97,105,108,101,100,32,114,101,112,111,114,116,0,0,0,0,0,0,37,115,32,108,105,110,101,32,37,108,100,58,32,37,115,10,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,112,97,116,104,0,0,0,0,58,0,0,0,0,0,0,0,105,100,0,0,0,0,0,0,114,117,108,101,0,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,114,117,108,101,32,101,108,101,109,101,110,116,32,105,110,115,116,101,97,100,32,111,102,32,37,115,0,0,80,97,116,116,101,114,110,32,104,97,115,32,110,111,32,114,117,108,101,32,101,108,101,109,101,110,116,0,0,0,0,0,99,111,110,116,101,120,116,0,114,117,108,101,32,104,97,115,32,110,111,32,99,111,110,116,101,120,116,32,97,116,116,114,105,98,117,116,101,0,0,0,114,117,108,101,32,104,97,115,32,97,110,32,101,109,112,116,121,32,99,111,110,116,101,120,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,97,115,115,101,114,116,0,0,116,101,115,116,0,0,0,0,97,115,115,101,114,116,32,104,97,115,32,110,111,32,116,101,115,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,97,115,115,101,114,116,32,104,97,115,32,97,110,32,101,109,112,116,121,32,116,101,115,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,114,101,112,111,114,116,0,0,69,120,112,101,99,116,105,110,103,32,97,110,32,97,115,115,101,114,116,32,111,114,32,97,32,114,101,112,111,114,116,32,101,108,101,109,101,110,116,32,105,110,115,116,101,97,100,32,111,102,32,37,115,0,0,0,114,117,108,101,32,104,97,115,32,110,111,32,97,115,115,101,114,116,32,110,111,114,32,114,101,112,111,114,116,32,101,108,101,109,101,110,116,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,116,101,115,116,32,101,120,112,114,101,115,115,105,111,110,32,37,115,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,116,101,115,116,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,99,111,110,116,101,120,116,32,101,120,112,114,101,115,115,105,111,110,32,37,115,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,114,117,108,101,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,116,116,101,114,110,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,97,114,115,101,114,32,110,97,109,101,115,112,97,99,101,115,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,97,115,99,99,46,110,101,116,47,120,109,108,47,115,99,104,101,109,97,116,114,111,110,0,0,0,0,0,0,104,116,116,112,58,47,47,112,117,114,108,46,111,99,108,99,46,111,114,103,47,100,115,100,108,47,115,99,104,101,109,97,116,114,111,110,0,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,109,101,109,111,114,121,32,102,111,114,32,108,105,115,116,0,0,0,0,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,109,101,109,111,114,121,32,102,111,114,32,115,101,110,116,105,110,101,108,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,109,101,109,111,114,121,32,102,111,114,32,110,101,119,32,108,105,110,107,0,0,0,117,116,102,56,0,0,200,119,99,104,97,114,116,0,0,198,117,99,115,50,0,117,99,115,50,98,101,0,0,196,117,99,115,50,108,101,0,0,197,117,116,102,49,54,0,117,116,102,49,54,98,101,0,0,194,117,116,102,49,54,108,101,0,0,193,117,99,115,52,0,117,99,115,52,98,101,0,117,116,102,51,50,0,117,116,102,51,50,98,101,0,0,192,117,99,115,52,108,101,0,117,116,102,51,50,108,101,0,0,195,97,115,99,105,105,0,117,115,97,115,99,105,105,0,105,115,111,54,52,54,0,105,115,111,54,52,54,117,115,0,0,199,101,117,99,106,112,0,0,208,115,104,105,102,116,106,105,115,0,115,106,105,115,0,0,209,103,98,49,56,48,51,48,0,0,216,103,98,107,0,0,217,103,98,50,51,49,50,0,0,218,98,105,103,53,0,98,105,103,102,105,118,101,0,99,112,57,53,48,0,98,105,103,53,104,107,115,99,115,0,0,224,101,117,99,107,114,0,107,115,99,53,54,48,49,0,107,115,120,49,48,48,49,0,99,112,57,52,57,0,0,232,105,115,111,56,56,53,57,49,0,108,97,116,105,110,49,0,0,128,105,115,111,56,56,53,57,50,0,0,32,0,84,0,137,18,0,32,1,6,0,0,152,65,134,26,127,0,48,72,32,0,88,32,201,18,0,36,17,198,35,0,156,81,198,26,128,80,66,136,32,90,0,0,192,4,0,16,113,1,0,29,0,112,2,0,41,0,0,192,7,33,48,1,5,0,0,88,1,0,0,94,208,1,128,29,0,0,128,6,0,91,0,0,0,5,0,20,129,1,0,30,0,128,2,0,42,0,0,0,8,34,52,17,5,0,0,92,1,0,0,95,212,1,192,29,0,0,144,70,36,105,115,111,56,56,53,57,51,0,0,32,0,212,0,9,0,0,4,48,3,0,0,244,64,70,11,63,0,16,64,32,0,216,0,0,0,0,0,64,3,0,0,248,80,134,11,64,0,16,128,32,0,0,0,64,0,0,108,144,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,188,0,0,0,43,0,0,0,0,0,200,33,6,0,0,0,0,64,0,0,112,160,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,192,0,0,0,44,0,0,0,0,0,204,49,70,36,105,115,111,56,56,53,57,52,0,0,32,0,84,48,4,23,0,220,96,4,0,0,152,49,66,12,108,0,48,8,0,0,88,32,73,23,0,224,112,196,35,0,156,65,130,12,109,72,65,200,20,17,0,0,0,0,0,0,0,192,14,29,0,112,2,0,37,0,0,64,14,33,56,65,69,16,0,0,0,0,0,0,224,1,0,0,0,184,1,7,0,18,0,0,0,0,0,0,0,0,15,30,0,128,2,0,38,0,0,128,14,34,60,81,133,16,0,0,0,0,0,0,228,1,0,0,0,188,17,71,36,105,115,111,56,56,53,57,53,0,0,32,0,136,51,14,57,229,152,115,14,58,233,168,179,14,59,237,0,224,206,59,240,196,35,207,60,244,212,99,207,61,248,228,163,207,62,252,244,227,207,63,0,5,36,208,64,4,21,100,208,65,8,37,164,208,66,12,53,228,208,67,16,69,36,209,68,20,85,100,209,69,24,101,164,209,70,28,117,228,209,71,32,133,36,210,72,36,149,100,210,73,40,165,164,210,74,44,181,228,210,75,53,194,20,147,76,51,209,84,147,77,55,225,148,147,78,59,13,192,83,79,105,115,111,56,56,53,57,54,0,0,32,0,4,16,64,0,0,4,16,64,0,1,4,16,64,0,115,1,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,0,93,1,4,16,64,93,1,216,117,23,94,121,233,181,23,95,125,249,245,23,96,129,9,54,24,97,133,25,118,24,98,137,41,182,24,99,141,57,246,88,0,1,4,16,64,0,144,69,38,217,100,148,85,102,217,101,152,101,166,217,102,156,117,230,217,103,160,133,38,90,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,105,115,111,56,56,53,57,55,0,0,32,0,144,88,34,0,51,210,8,0,0,0,0,160,9,0,0,0,16,128,136,0,0,0,0,0,155,112,210,9,0,158,124,2,10,0,161,0,32,202,40,164,148,98,202,41,168,164,162,202,42,172,180,226,202,43,176,196,34,203,44,180,212,18,128,45,183,224,146,139,46,187,240,210,139,47,191,0,19,140,48,195,16,83,140,49,199,32,147,140,50,203,48,211,140,51,207,64,19,141,52,211,80,83,141,53,215,96,147,141,54,219,112,211,141,55,223,128,19,78,0,105,115,111,56,56,53,57,56,0,0,32,0,4,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,192,136,83,81,85,149,85,87,97,149,149,86,91,113,213,149,87,95,129,21,150,88,99,145,85,150,89,103,161,149,150,90,107,177,213,86,0,1,120,248,97,0,105,115,111,56,56,53,57,57,0,0,80,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,244,64,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,80,6,0,105,115,111,56,56,53,57,49,48,0,0,32,0,84,48,66,12,57,220,16,4,0,70,132,96,6,27,131,0,0,135,20,0,88,64,130,12,58,224,32,4,0,71,136,112,70,27,132,136,24,199,20,17,0,0,0,0,0,0,0,192,14,29,0,112,2,0,37,0,0,0,0,0,56,65,5,0,0,0,0,128,27,0,224,1,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,15,30,0,128,2,0,38,0,0,0,0,0,60,81,5,0,0,0,0,192,27,0,228,1,0,0,0,0,0,192,16,105,115,111,56,56,53,57,49,49,0,116,105,115,54,50,48,0,0,32,0,188,6,91,108,178,205,70,91,109,182,221,134,91,110,186,237,198,91,111,190,253,6,92,112,194,13,71,92,113,198,29,135,92,114,202,45,199,92,115,206,61,7,93,116,210,77,71,93,117,214,93,135,93,118,218,109,199,93,119,222,125,7,94,120,226,141,71,94,121,230,157,135,94,0,1,4,16,64,122,234,173,199,94,123,238,189,7,95,124,242,205,71,95,125,246,221,135,95,126,250,237,199,95,127,254,253,7,96,128,2,14,72,96,129,1,4,16,64,0,105,115,111,56,56,53,57,49,51,0,0,32,0,160,8,0,0,0,164,8,0,0,13,0,192,5,0,0,0,0,192,2,0,0,0,0,0,39,2,0,0,0,16,0,208,5,0,0,0,0,128,3,21,236,16,193,5,0,0,112,194,8,29,0,240,71,9,49,4,145,131,17,102,48,225,4,0,84,0,0,0,0,120,40,1,6,28,0,4,50,8,0,22,240,32,1,6,0,0,128,2,9,30,0,0,136,9,50,8,161,195,17,103,52,241,4,0,85,0,0,0,0,121,44,17,70,28,0,8,66,72,137,105,115,111,56,56,53,57,49,52,0,0,32,0,24,120,32,0,27,112,128,32,0,20,2,96,97,130,26,2,0,128,31,10,46,248,2,12,12,54,8,128,131,21,62,120,33,132,27,98,152,97,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,122,0,0,0,0,0,0,0,128,132,0,0,0,0,0,0,0,192,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,192,132,0,0,0,0,0,0,0,208,7,0,105,115,111,56,56,53,57,49,53,0,108,97,116,105,110,57,0,0,36,51,2,96,6,0,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,0,0,0,0,132,0,0,0,0,88,100,225,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,105,115,111,56,56,53,57,49,54,0,0,32,0,84,96,129,18,51,166,104,6,0,103,0,160,8,0,127,0,0,72,32,0,0,208,193,18,131,160,8,0,0,132,120,176,8,0,88,100,225,135,32,0,0,0,192,4,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,33,48,1,0,0,0,88,1,0,24,118,0,0,0,0,0,156,192,8,0,0,0,0,0,5,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,34,52,1,0,0,0,92,1,64,24,119,0,0,0,0,0,160,208,8,0,99,112,49,50,53,48,0,119,105,110,100,111,119,115,49,50,53,48,0,0,0,51,6,96,98,0,41,182,168,226,138,1,184,104,198,139,96,168,49,200,31,1,144,88,226,137,40,178,8,98,136,1,216,120,6,140,97,172,65,8,32,0,60,2,137,18,0,84,0,0,0,0,0,64,6,0,0,0,0,64,32,0,0,32,201,18,0,0,0,0,0,0,88,80,6,0,72,80,146,132,32,90,0,0,192,4,0,16,113,1,0,29,0,112,2,0,41,0,0,192,7,33,48,1,5,0,0,88,1,0,0,94,208,1,128,29,0,0,128,6,0,91,0,0,0,5,0,20,129,1,0,30,0,128,2,0,42,0,0,0,8,34,52,17,5,0,0,92,1,0,0,95,212,1,192,29,0,0,144,70,36,99,112,49,50,53,49,0,119,105,110,100,111,119,115,49,50,53,49,0,0,0,227,144,99,162,76,41,182,168,226,138,51,186,168,206,139,235,180,195,206,59,49,145,88,226,137,40,178,8,98,136,1,216,136,19,140,57,237,164,83,79,0,184,195,83,58,0,248,4,0,0,226,0,80,14,0,0,0,0,0,58,0,0,112,78,77,63,1,0,0,0,48,213,56,19,0,55,153,67,147,77,240,196,35,207,60,244,212,99,207,61,248,228,163,207,62,252,244,227,207,63,0,5,36,208,64,4,21,100,208,65,8,37,164,208,66,12,53,228,208,67,16,69,36,209,68,20,85,100,209,69,24,101,164,209,70,28,117,228,209,71,32,133,36,210,72,36,149,100,210,73,40,165,164,210,74,44,181,228,210,75,99,112,49,50,53,50,0,119,105,110,100,111,119,115,49,50,53,50,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,104,198,139,88,4,48,72,0,1,144,88,226,137,40,178,8,98,136,147,216,120,6,140,89,4,64,136,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,112,49,50,53,51,0,119,105,110,100,111,119,115,49,50,53,51,0,0,0,51,6,96,98,33,41,182,168,226,138,1,184,24,192,139,1,4,16,64,0,1,144,88,226,137,40,178,8,98,136,1,216,24,0,140,1,4,16,64,0,0,112,210,9,0,0,0,0,0,0,0,0,16,0,0,0,0,0,128,136,0,0,0,0,0,155,0,0,0,0,158,124,2,10,0,161,0,32,202,40,164,148,98,202,41,168,164,162,202,42,172,180,226,202,43,176,196,34,203,44,180,212,18,128,45,183,224,146,139,46,187,240,210,139,47,191,0,19,140,48,195,16,83,140,49,199,32,147,140,50,203,48,211,140,51,207,64,19,141,52,211,80,83,141,53,215,96,147,141,54,219,112,211,141,55,223,128,19,78,0,99,112,49,50,53,52,0,119,105,110,100,111,119,115,49,50,53,52,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,104,198,139,88,4,16,64,0,1,144,88,226,137,40,178,8,98,136,147,216,120,6,140,89,4,16,128,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,244,64,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,80,6,0,99,112,49,50,53,53,0,119,105,110,100,111,119,115,49,50,53,53,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,24,192,139,1,4,16,64,0,1,144,88,226,137,40,178,8,98,136,147,216,24,0,140,1,4,16,64,0,0,0,0,0,0,49,2,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,64,5,37,212,80,68,21,101,212,81,72,37,21,128,82,75,49,213,148,83,79,65,21,149,84,110,189,5,87,92,114,5,16,64,0,1,4,16,64,0,83,81,85,149,85,87,97,149,149,86,91,113,213,149,87,95,129,21,150,88,99,145,85,150,89,103,161,149,150,90,107,177,213,86,0,1,120,248,97,0,99,112,49,50,53,54,0,119,105,110,100,111,119,115,49,50,53,54,0,0,0,51,146,102,98,33,41,182,168,226,138,142,184,56,218,139,88,148,134,154,105,170,145,88,226,137,40,178,8,98,136,169,217,120,26,140,89,112,216,225,106,0,204,5,0,0,0,0,0,0,0,0,0,192,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,23,0,0,0,0,64,93,173,217,117,23,94,121,233,181,23,95,125,249,245,23,96,129,9,54,24,97,133,25,118,24,98,137,41,182,24,0,140,53,230,216,99,144,69,38,217,100,0,80,6,64,101,150,93,134,25,0,0,0,0,0,0,153,105,6,0,0,155,113,214,153,103,0,124,6,26,0,161,1,32,26,0,0,120,248,161,107,99,112,49,50,53,55,0,119,105,110,100,111,119,115,49,50,53,55,0,0,0,51,6,96,98,0,41,182,168,226,138,1,184,24,192,139,1,16,240,136,2,1,144,88,226,137,40,178,8,98,136,1,216,24,0,140,1,24,32,73,0,0,4,0,0,0,0,4,0,0,0,13,0,192,5,0,0,0,0,192,2,0,0,0,0,0,0,0,0,0,0,16,0,208,5,0,0,0,0,128,3,21,236,16,193,5,0,0,112,194,8,29,0,240,71,9,49,4,145,131,17,102,48,225,4,0,84,0,0,0,0,120,40,1,6,28,0,4,50,8,0,22,240,32,1,6,0,0,128,2,9,30,0,0,136,9,50,8,161,195,17,103,52,241,4,0,85,0,0,0,0,121,44,17,70,28,0,8,66,72,36,99,112,49,50,53,56,0,119,105,110,100,111,119,115,49,50,53,56,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,24,192,139,88,4,16,64,0,1,144,88,226,137,40,178,8,98,136,147,216,24,0,140,89,4,16,128,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,4,0,0,0,0,0,0,0,0,0,0,149,0,0,0,0,33,0,128,9,0,0,24,2,0,0,0,0,0,0,0,0,32,114,9,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,150,0,0,0,0,34,0,144,9,0,0,28,2,0,0,0,0,0,0,0,0,36,34,35,0,107,111,105,56,114,0,0,0,62,254,8,100,144,66,14,73,100,145,70,30,137,164,153,103,162,153,166,154,107,178,217,38,143,110,222,136,99,142,58,238,40,64,143,7,32,144,192,3,73,42,185,36,76,76,54,233,228,147,80,70,41,229,148,84,86,105,229,149,88,102,169,165,56,91,114,217,165,151,95,130,25,166,152,99,146,89,102,1,46,65,20,145,73,20,85,68,210,68,37,97,148,145,70,27,113,212,145,71,31,189,4,82,72,34,141,100,145,68,44,173,116,17,74,45,165,116,146,74,14,193,19,143,65,244,212,67,208,60,5,225,147,143,62,251,240,211,143,63,255,60,4,80,64,2,13,100,143,60,12,45,116,15,66,13,37,116,144,66,107,111,105,56,117,0,0,0,62,254,8,100,144,66,14,73,100,145,70,30,137,164,153,103,162,153,166,154,107,178,217,38,143,110,222,136,99,142,58,238,40,64,143,7,32,144,192,3,73,42,185,36,76,51,53,89,147,77,80,70,41,229,148,84,254,100,229,149,88,102,169,165,56,229,112,121,14,58,95,130,25,166,152,99,250,84,102,1,46,65,20,145,73,20,85,68,210,68,37,97,148,145,70,27,113,212,145,71,31,189,4,82,72,34,141,100,145,68,44,173,116,17,74,45,165,116,146,74,14,193,19,143,65,244,212,67,208,60,5,225,147,143,62,251,240,211,143,63,255,60,4,80,64,2,13,100,143,60,12,45,116,15,66,13,37,116,144,66,0,0,0,0,0,0,0,0,0,48,1,48,2,48,12,255,14,255,251,48,26,255,27,255,31,255,1,255,155,48,156,48,180,0,64,255,168,0,62,255,227,255,63,255,253,48,254,48,157,48,158,48,3,48,221,78,5,48,6,48,7,48,252,48,21,32,16,32,15,255,92,0,28,48,22,32,92,255,38,32,37,32,24,32,25,32,28,32,29,32,8,255,9,255,20,48,21,48,59,255,61,255,91,255,93,255,8,48,9,48,10,48,11,48,12,48,13,48,14,48,15,48,16,48,17,48,11,255,18,34,177,0,215,0,247,0,29,255,96,34,28,255,30,255,102,34,103,34,30,34,52,34,66,38,64,38,176,0,50,32,51,32,3,33,229,255,4,255,162,0,163,0,5,255,3,255,6,255,10,255,32,255,167,0,6,38,5,38,203,37,207,37,206,37,199,37,198,37,161,37,160,37,179,37,178,37,189,37,188,37,59,32,18,48,146,33,144,33,145,33,147,33,19,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,34,11,34,134,34,135,34,130,34,131,34,42,34,41,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,34,40,34,172,0,210,33,212,33,0,34,3,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,34,165,34,18,35,2,34,7,34,97,34,82,34,106,34,107,34,26,34,61,34,29,34,53,34,43,34,44,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43,33,48,32,111,38,109,38,106,38,32,32,33,32,182,0,0,0,0,0,0,0,0,0,239,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255,24,255,25,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+197488),allocate([33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,0,0,0,0,0,0,0,0,0,0,0,0,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,0,0,0,0,0,0,0,0,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,2,37,12,37,16,37,24,37,20,37,28,37,44,37,36,37,52,37,60,37,1,37,3,37,15,37,19,37,27,37,23,37,35,37,51,37,43,37,59,37,75,37,32,37,47,37,40,37,55,37,63,37,29,37,48,37,37,37,56,37,66,37],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+207728),
	allocate([156,78,22,85,3,90,63,150,192,84,27,97,40,99,246,89,34,144,117,132,28,131,80,122,170,96,225,99,37,110,237,101,102,132,166,130,245,155,147,104,39,87,161,101,113,98,155,91,208,89,123,134,244,152,98,125,190,125,142,155,22,98,159,124,183,136,137,91,181,94,9,99,151,102,72,104,199,149,141,151,79,103,229,78,10,79,77,79,157,79,73,80,242,86,55,89,212,89,1,90,9,92,223,96,15,97,112,97,19,102,5,105,186,112,79,117,112,117,251,121,173,125,239,125,195,128,14,132,99,136,2,139,85,144,122,144,59,83,149,78,165,78,223,87,178,128,193,144,239,120,0,78,241,88,162,110,56,144,50,122,40,131,139,130,47,156,65,81,112,83,189,84,225,84,224,86,251,89,21,95,242,152,235,109,228,128,45,133,98,150,112,150,160,150,251,151,11,84,243,83,135,91,207,112,189,127,194,143,232,150,111,83,92,157,186,122,17,78,147,120,252,129,38,110,24,86,4,85,29,107,26,133,59,156,229,89,169,83,102,109,220,116,143,149,66,86,145,78,75,144,242,150,79,131,12,153,225,83,182,85,48,91,113,95,32,102,243,102,4,104,56,108,243,108,41,109,91,116,200,118,78,122,52,152,241,130,91,136,96,138,237,146,178,109,171,117,202,118,197,153,166,96,1,139,138,141,178,149,142,105,173,83,134,81,18,87,48,88,68,89,180,91,246,94,40,96,169,99,244,99,191,108,20,111,142,112,20,113,89,113,213,113,63,115,1,126,118,130,209,130,151,133,96,144,91,146,27,157,105,88,188,101,90,108,37,117,249,81,46,89,101,89,128,95,220,95,188,98,250,101,42,106,39,107,180,107,139,115,193,127,86,137,44,157,14,157,196,158,161,92,150,108,123,131,4,81,75,92,182,97,198,129,118,104,97,114,89,78,250,79,120,83,105,96,41,110,79,122,243,151,11,78,22,83,238,78,85,79,61,79,161,79,115,79,160,82,239,83,9,86,15,89,193,90,182,91,225,91,209,121,135,102,156,103,182,103,76,107,179,108,107,112,194,115,141,121,190,121,60,122,135,123,177,130,219,130,4,131,119,131,239,131,211,131,102,135,178,138,41,86,168,140,230,143,78,144,30,151,138,134,196,79,232,92,17,98,89,114,59,117,229,129,189,130,254,134,192,140,197,150,19,153,213,153,203,78,26,79,227,137,222,86,74,88,202,88,251,94,235,95,42,96,148,96,98,96,208,97,18,98,208,98,57,101,65,155,102,102,176,104,119,109,112,112,76,117,134,118,117,125,165,130,249,135,139,149,142,150,157,140,241,81,190,82,22,89,179,84,179,91,22,93,104,97,130,105,175,109,141,120,203,132,87,136,114,138,167,147,184,154,108,109,168,153,217,134,163,87,255,103,206,134,14,146,131,82,135,86,4,84,211,94,225,98,185,100,60,104,56,104,187,107,114,115,186,120,107,122,154,137,210,137,107,141,3,143,237,144,163,149,148,150,105,151,102,91,179,92,125,105,77,152,78,152,155,99,32,123,43,106,127,106,182,104,13,156,95,111,114,82,157,85,112,96,236,98,59,109,7,110,209,110,91,132,16,137,68,143,20,78,57,156,246,83,27,105,58,106,132,151,42,104,92,81,195,122,178,132,220,145,140,147,91,86,40,157,34,104,5,131,49,132,165,124,8,82,197,130,230,116,126,78,131,79,160,81,210,91,10,82,216,82,231,82,251,93,154,85,42,88,230,89,140,91,152,91,219,91,114,94,121,94,163,96,31,97,99,97,190,97,219,99,98,101,209,103,83,104,250,104,62,107,83,107,87,108,34,111,151,111,69,111,176,116,24,117,227,118,11,119,255,122,161,123,33,124,233,125,54,127,240,127,157,128,102,130,158,131,179,137,204,138,171,140,132,144,81,148,147,149,145,149,162,149,101,150,211,151,40,153,24,130,56,78,43,84,184,92,204,93,169,115,76,118,60,119,169,92,235,127,11,141,193,150,17,152,84,152,88,152,1,79,14,79,113,83,156,85,104,86,250,87,71,89,9,91,196,91,144,92,12,94,126,94,204,95,238,99,58,103,215,101,226,101,31,103,203,104,196,104,95,106,48,94,197,107,23,108,125,108,127,117,72,121,99,91,0,122,0,125,189,95,143,137,24,138,180,140,119,141,204,142,29,143,226,152,14,154,60,155,128,78,125,80,0,81,147,89,156,91,47,98,128,98,236,100,58,107,160,114,145,117,71,121,169,127,251,135,188,138,112,139,172,99,202,131,160,151,9,84,3,84,171,85,84,104,88,106,112,138,39,120,117,103,205,158,116,83,162,91,26,129,80,134,6,144,24,78,69,78,199,78,17,79,202,83,56,84,174,91,19,95,37,96,81,101,61,103,66,108,114,108,227,108,120,112,3,116,118,122,174,122,8,123,26,125,254,124,102,125,231,101,91,114,187,83,69,92,232,93,210,98,224,98,25,99,32,110,90,134,49,138,221,141,248,146,1,111,166,121,90,155,168,78,171,78,172,78,155,79,160,79,209,80,71,81,246,122,113,81,246,81,84,83,33,83,127,83,235,83,172,85,131,88,225,92,55,95,74,95,47,96,80,96,109,96,31,99,89,101,75,106,193,108,194,114,237,114,239,119,248,128,5,129,8,130,78,133,247,144,225,147,255,151,87,153,90,154,240,78,221,81,45,92,129,102,109,105,64,92,242,102,117,105,137,115,80,104,129,124,197,80,228,82,71,87,254,93,38,147,164,101,35,107,61,107,52,116,129,121,189,121,75,123,202,125,185,130,204,131,127,136,95,137,57,139,209,143,209,145,31,84,128,146,93,78,54,80,229,83,58,83,215,114,150,115,233,119,230,130,175,142,198,153,200,153,210,153,119,81,26,97,94,134,176,85,122,122,118,80,211,91,71,144,133,150,50,78,219,106,231,145,81,92,72,92,152,99,159,122,147,108,116,151,97,143,170,122,138,113,136,150,130,124,23,104,112,126,81,104,108,147,242,82,27,84,171,133,19,138,164,127,205,142,225,144,102,83,136,136,65,121,194,79,190,80,17,82,68,81,83,85,45,87,234,115,139,87,81,89,98,95,132,95,117,96,118,97,103,97,169,97,178,99,58,100,108,101,111,102,66,104,19,110,102,117,61,122,251,124,76,125,153,125,75,126,107,127,14,131,74,131,205,134,8,138,99,138,102,139,253,142,26,152,143,157,184,130,206,143,232,155,135,82,31,98,131,100,192,111,153,150,65,104,145,80,32,107,122,108,84,111,116,122,80,125,64,136,35,138,8,103,246,78,57,80,38,80,101,80,124,81,56,82,99,82,167,85,15,87,5,88,204,90,250,94,178,97,248,97,243,98,114,99,28,105,41,106,125,114,172,114,46,115,20,120,111,120,121,125,12,119,169,128,139,137,25,139,226,140,210,142,99,144,117,147,122,150,85,152,19,154,120,158,67,81,159,83,179,83,123,94,38,95,27,110,144,110,132,115,254,115,67,125,55,130,0,138,250,138,80,150,78,78,11,80,228,83,124,84,250,86,209,89,100,91,241,93,171,94,39,95,56,98,69,101,175,103,86,110,208,114,202,124,180,136,161,128,225,128,240,131,78,134,135,138,232,141,55,146,199,150,103,152,19,159,148,78,146,78,13,79,72,83,73,84,62,84,47,90,140,95,161,95,159,96,167,104,142,106,90,116,129,120,158,138,164,138,119,139,144,145,94,78,201,155,164,78,124,79,175,79,25,80,22,80,73,81,108,81,159,82,185,82,254,82,154,83,227,83,17,84,14,84,137,85,81,87,162,87,125,89,84,91,93,91,143,91,229,93,231,93,247,93,120,94,131,94,154,94,183,94,24,95,82,96,76,97,151,98,216,98,167,99,59,101,2,102,67,102,244,102,109,103,33,104,151,104,203,105,95,108,42,109,105,109,47,110,157,110,50,117,135,118,108,120,63,122,224,124,5,125,24,125,94,125,177,125,21,128,3,128,175,128,177,128,84,129,143,129,42,130,82,131,76,136,97,136,27,139,162,140,252,140,202,144,117,145,113,146,63,120,252,146,164,149,77,150,5,152,153,153,216,154,59,157,91,82,171,82,247,83,8,84,213,88,247,98,224,111,106,140,95,143,185,158,75,81,59,82,74,84,253,86,64,122,119,145,96,157,210,158,68,115,9,111,112,129,17,117,253,95,218,96,168,154,219,114,188,143,100,107,3,152,202,78,240,86,100,87,190,88,90,90,104,96,199,97,15,102,6,102,57,104,177,104,247,109,213,117,58,125,110,130,66,155,155,78,80,79,201,83,6,85,111,93,230,93,238,93,251,103,153,108,115,116,2,120,80,138,150,147,223,136,80,87,167,94,43,99,181,80,172,80,141,81,0,103,201,84,94,88,187,89,176,91,105,95,77,98,161,99,61,104,115,107,8,110,125,112,199,145,128,114,21,120,38,120,109,121,142,101,48,125,220,131,193,136,9,143,155,150,100,82,40,87,80,103,106,127,161,140,180,81,66,87,42,150,58,88,138,105,180,128,178,84,14,93,252,87,149,120,250,157,92,79,74,82,139,84,62,100,40,102,20,103,245,103,132,122,86,123,34,125,47,147,92,104,173,155,57,123,25,83,138,81,55,82,223,91,246,98,174,100,230,100,45,103,186,107,169,133,209,150,144,118,214,155,76,99,6,147,171,155,191,118,82,102,9,78,152,80,194,83,113,92,232,96,146,100,99,101,95,104,230,113,202,115,35,117,151,123,130,126,149,134,131,139,219,140,120,145,16,153,172,101,171,102,139,107,213,78,212,78,58,79,127,79,58,82,248,83,242,83,227,85,219,86,235,88,203,89,201,89,255,89,80,91,77,92,2,94,43,94,215,95,29,96,7,99,47,101,92,91,175,101,189,101,232,101,157,103,98,107,123,107,15,108,69,115,73,121,193,121,248,124,25,125,43,125,162,128,2,129,243,129,150,137,94,138,105,138,102,138,140,138,238,138,199,140,220,140,204,150,252,152,111,107,139,78,60,79,141,79,80,81,87,91,250,91,72,97,1,99,66,102,33,107,203,110,187,108,62,114,189,116,212,117,193,120,58,121,12,128,51,128,234,129,148,132,158,143,80,108,127,158,15,95,88,139,43,157,250,122,248,142,141,91,235,150,3,78,241,83,247,87,49,89,201,90,164,91,137,96,127,110,6,111,190,117,234,140,159,91,0,133,224,123,114,80,244,103,157,130,97,92,74,133,30,126,14,130,153,81,4,92,104,99,102,141,156,101,110,113,62,121,23,125,5,128,29,139,202,142,110,144,199,134,170,144,31,80,250,82,58,92,83,103,124,112,53,114,76,145,200,145,43,147,229,130,194,91,49,95,249,96,59,78,214,83,136,91,75,98,49,103,138,107,233,114,224,115,46,122,107,129,163,141,82,145,150,153,18,81,215,83,106,84,255,91,136,99,57,106,172,125,0,151,218,86,206,83,104,84,151,91,49,92,222,93,238,79,1,97,254,98,50,109,192,121,203,121,66,125,77,126,210,127,237,129,31,130,144,132,70,136,114,137,144,139,116,142,47,143,49,144,75,145,108,145,198,150,156,145,192,78,79,79,69,81,65,83,147,95,14,98,212,103,65,108,11,110,99,115,38,126,205,145,131,146,212,83,25,89,191,91,209,109,93,121,46,126,155,124,126,88,159,113,250,81,83,136,240,143,202,79,251,92,37,102,172,119,227,122,28,130,255,153,198,81,170,95,236,101,111,105,137,107,243,109,150,110,100,111,254,118,20,125,225,93,117,144,135,145,6,152,230,81,29,82,64,98,145,102,217,102,26,110,182,94,210,125,114,127,248,102,175,133,247,133,248,138,169,82,217,83,115,89,143,94,144,95,85,96,228,146,100,150,183,80,31,81,221,82,32,83,71,83,236,83,232,84,70,85,49,85,23,86,104,89,190,89,60,90,181,91,6,92,15,92,17,92,26,92,132,94,138,94,224,94,112,95,127,98,132,98,219,98,140,99,119,99,7,102,12,102,45,102,118,102,126,103,162,104,31,106,53,106,188,108,136,109,9,110,88,110,60,113,38,113,103,113,199,117,1,119,93,120,1,121,101,121,240,121,224,122,17,123,167,124,57,125,150,128,214,131,139,132,73,133,93,136,243,136,31,138,60,138,84,138,115,138,97,140,222,140,164,145,102,146,126,147,24,148,156,150,152,151,10,78,8,78,30,78,87,78,151,81,112,82,206,87,52,88,204,88,34,91,56,94,197,96,254,100,97,103,86,103,68,109,182,114,115,117,99,122,184,132,114,139,184,145,32,147,49,86,244,87,254,152,237,98,13,105,150,107,237,113,84,126,119,128,114,130,230,137,223,152,85,135,177,143,59,92,56,79,225,79,181,79,7,85,32,90,221,91,233,91,195,95,78,97,47,99,176,101,75,102,238,104,155,105,120,109,241,109,51,117,185,117,31,119,94,121,230,121,51,125,227,129,175,130,170,133,170,137,58,138,171,142,155,143,50,144,221,145,7,151,186,78,193,78,3,82,117,88,236,88,11,92,26,117,61,92,78,129,10,138,197,143,99,150,109,151,37,123,207,138,8,152,98,145,243,86,168,83,23,144,57,84,130,87,37,94,168,99,52,108,138,112,97,119,139,124,224,127,112,136,66,144,84,145,16,147,24,147,143,150,94,116,196,154,7,93,105,93,112,101,162,103,168,141,219,150,110,99,73,103,25,105,197,131,23,152,192,150,254,136,132,111,122,100,248,91,22,78,44,112,93,117,47,102,196,81,54,82,226,82,211,89,129,95,39,96,16,98,63,101,116,101,31,102,116,102,242,104,22,104,99,107,5,110,114,114,31,117,219,118,190,124,86,128,240,88,253,136,127,137,160,138,147,138,203,138,29,144,146,145,82,151,89,151,137,101,14,122,6,129,187,150,45,94,220,96,26,98,165,101,20,102,144,103,243,119,77,122,77,124,62,126,10,129,172,140,100,141,225,141,95,142,169,120,7,82,217,98,165,99,66,100,152,98,45,138,131,122,192,123,172,138,234,150,118,125,12,130,73,135,217,78,72,81,67,83,96,83,163,91,2,92,22,92,221,93,38,98,71,98,176,100,19,104,52,104,201,108,69,109,23,109,211,103,92,111,78,113,125,113,203,101,127,122,173,123,218,125,74,126,168,127,122,129,27,130,57,130,166,133,110,138,206,140,245,141,120,144,119,144,173,146,145,146,131,149,174,155,77,82,132,85,56,111,54,113,104,81,133,121,85,126,179,129,206,124,76,86,81,88,168,92,170,99,254,102,253,102,90,105,217,114,143,117,142,117,14,121,86,121,223,121,151,124,32,125,68,125,7,134,52,138,59,150,97,144,32,159,231,80,117,82,204,83,226,83,9,80,170,85,238,88,79,89,61,114,139,91,100,92,29,83,227,96,243,96,92,99,131,99,63,99,187,99,205,100,233,101,249,102,227,93,205,105,253,105,21,111,229,113,137,78,233,117,248,118,147,122,223,124,207,125,156,125,97,128,73,131,88,131,108,132,188,132,251,133,197,136,112,141,1,144,109,144,151,147,28,151,18,154,207,80,151,88,142,97,211,129,53,133,8,141,32,144,195,79,116,80,71,82,115,83,111,96,73,99,95,103,44,110,179,141,31,144,215,79,94,92,202,140,207,101,154,125,82,83,150,136,118,81,195,99,88,91,107,91,10,92,13,100,81,103,92,144,214,78,26,89,42,89,112,108,81,138,62,85,21,88,165,89,240,96,83,98,193,103,53,130,85,105,64,150,196,153,40,154,83,79,6,88,254,91,16,128,177,92,47,94,133,95,32,96,75,97,52,98,255,102,240,108,222,110,206,128,127,129,212,130,139,136,184,140,0,144,46,144,138,150,219,158,219,155,227,78,240,83,39,89,44,123,141,145,76,152,249,157,221,110,39,112,83,83,68,85,133,91,88,98,158,98,211,98,162,108,239,111,34,116,23,138,56,148,193,111,254,138,56,131,231,81,248,134,234,83,233,83,70,79,84,144,176,143,106,89,49,129,253,93,234,122,191,143,218,104,55,140,248,114,72,156,61,106,176,138,57,78,88,83,6,86,102,87,197,98,162,99,230,101,78,107,225,109,91,110,173,112,237,119,239,122,170,123,187,125,61,128,198,128,203,134,149,138,91,147,227,86,199,88,62,95,173,101,150,102,128,106,181,107,55,117,199,138,36,80,229,119,48,87,27,95,101,96,122,102,96,108,244,117,26,122,110,127,244,129,24,135,69,144,179,153,201,123,92,117,249,122,81,123,196,132,16,144,233,121,146,122,54,131,225,90,64,119,45,78,242,78,153,91,224,95,189,98,60,102,241,103,232,108,107,134,119,136,59,138,78,145,243,146,208,153,23,106,38,112,42,115,231,130,87,132,175,140,1,78,70,81,203,81,139,85,245,91,22,94,51,94,129,94,20,95,53,95,107,95,180,95,242,97,17,99,162,102,29,103,110,111,82,114,58,117,58,119,116,128,57,129,120,129,118,135,191,138,220,138,133,141,243,141,154,146,119,149,2,152,229,156,197,82,87,99,244,118,21,103,136,108,205,115,195,140,174,147,115,150,37,109,156,88,14,105,204,105,253,143,154,147,219,117,26,144,90,88,2,104,180,99,251,105,67,79,44,111,216,103,187,143,38,133,180,125,84,147,63,105,112,111,106,87,247,88,44,91,44,125,42,114,10,84,227,145,180,157,173,78,78,79,92,80,117,80,67,82,158,140,72,84,36,88,154,91,29,94,149,94,173,94,247,94,31,95,140,96,181,98,58,99,208,99,175,104,64,108,135,120,142,121,11,122,224,125,71,130,2,138,230,138,68,142,19,144,184,144,45,145,216,145,14,159,229,108,88,100,226,100,117,101,244,110,132,118,27,123,105,144,209,147,186,110,242,84,185,95,164,100,77,143,237,143,68,146,120,81,107,88,41,89,85,92,151,94,251,109,143,126,28,117,188,140,226,142,91,152,185,112,29,79,191,107,177,111,48,117,251,150,78,81,16,84,53,88,87,88,172,89,96,92,146,95,151,101,92,103,33,110,123,118,223,131,237,140,20,144,253,144,77,147,37,120,58,120,170,82,166,94,31,87,116,89,18,96,18,80,90,81,172,81,205,81,0,82,16,85,84,88,88,88,87,89,149,91,246,92,139,93,188,96,149,98,45,100,113,103,67,104,188,104,223,104,215,118,216,109,111,110,155,109,111,112,200,113,83,95,216,117,119,121,73,123,84,123,82,123,214,124,113,125,48,82,99,132,105,133,228,133,14,138,4,139,70,140,15,142,3,144,15,144,25,148,118,150,45,152,48,154,216,149,205,80,213,82,12,84,2,88,14,92,167,97,158,100,30,109,179,119,229,122,244,128,4,132,83,144,133,146,224,92,7,157,63,83,151,95,179,95,156,109,121,114,99,119,191,121,228,123,210,107,236,114,173,138,3,104,97,106,248,81,129,122,52,105,74,92,246,156,235,130,197,91,73,145,30,112,120,86,111,92,199,96,102,101,140,108,90,140,65,144,19,152,81,84,199,102,13,146,72,89,163,144,133,81,77,78,234,81,153,133,14,139,88,112,122,99,75,147,98,105,180,153,4,126,119,117,87,83,96,105,223,142,227,150,93,108,140,78,60,92,16,95,233,143,2,83,209,140,137,128,121,134,255,94,229,101,115,78,101,81,130,89,63,92,238,151,251,78,138,89,205,95,141,138,225,111,176,121,98,121,231,91,113,132,43,115,177,113,116,94,245,95,123,99,154,100,195,113,152,124,67,78,252,94,75,78,220,87,162,86,169,96,195,111,13,125,253,128,51,129,191,129,178,143,151,137,164,134,244,93,138,98,173,100,135,137,119,103,226,108,62,109,54,116,52,120,70,90,117,127,173,130,172,153,243,79,195,94,221,98,146,99,87,101,111,103,195,118,76,114,204,128,186,128,41,143,77,145,13,80,249,87,146,90,133,104,115,105,100,113,253,114,183,140,242,88,224,140,106,150,25,144,127,135,228,121,231,119,41,132,47,79,101,82,90,83,205,98,207,103,202,108,125,118,148,123,149,124,54,130,132,133,235,143,221,102,32,111,6,114,27,126,171,131,193,153,166,158,253,81,177,123,114,120,184,123,135,128,72,123,232,106,97,94,140,128,81,117,96,117,107,81,98,146,140,110,122,118,151,145,234,154,16,79,112,127,156,98,79,123,165,149,233,156,122,86,89,88,228,134,188,150,52,79,36,82,74,83,205,83,219,83,6,94,44,100,145,101,127,103,62,108,78,108,72,114,175,114,237,115,84,117,65,126,44,130,233,133,169,140,196,123,198,145,105,113,18,152,239,152,61,99,105,102,106,117,228,118,208,120,67,133,238,134,42,83,81,83,38,84,131,89,135,94,124,95,178,96,73,98,121,98,171,98,144,101,212,107,204,108,178,117,174,118,145,120,216,121,203,125,119,127,165,128,171,136,185,138,187,140,127,144,94,151,219,152,11,106,56,124,153,80,62,92,174,95,135,103,216,107,53,116,9,119,142,127,59,159,202,103,23,122,57,83,139,117,237,154,102,95,157,129,241,131,152,128,60,95,197,95,98,117,70,123,60,144,103,104,235,89,155,90,16,125,126,118,44,139,245,79,106,95,25,106,55,108,2,111,226,116,104,121,104,136,85,138,121,140,223,94,207,99,197,117,210,121,215,130,40,147,242,146,156,132,237,134,45,156,193,84,108,95,140,101,92,109,21,112,167,140,211,140,59,152,79,101,246,116,13,78,216,78,224,87,43,89,102,90,204,91,168,81,3,94,156,94,22,96,118,98,119,101,167,101,110,102,110,109,54,114,38,123,80,129,154,129,153,130,92,139,160,140,230,140,116,141,28,150,68,150,174,79,171,100,102,107,30,130,97,132,106,133,232,144,1,92,83,105,168,152,122,132,87,133,15,79,111,82,169,95,69,94,13,103,143,121,121,129,7,137,134,137,245,109,23,95,85,98,184,108,207,78,105,114,146,155,6,82,59,84,116,86,179,88,164,97,110,98,26,113,110,89,137,124,222,124,27,125,240,150,135,101,94,128,25,78,117,79,117,81,64,88,99,94,115,94,10,95,196,103,38,78,61,133,137,149,91,150,115,124,1,152,251,80,193,88,86,118,167,120,37,82,165,119,17,133,134,123,79,80,9,89,71,114,199,123,232,125,186,143,212,143,77,144,191,79,201,82,41,90,1,95,173,151,221,79,23,130,234,146,3,87,85,99,105,107,43,117,220,136,20,143,66,122,223,82,147,88,85,97,10,98,174,102,205,107,63,124,233,131,35,80,248,79,5,83,70,84,49,88,73,89,157,91,240,92,239,92,41,93,150,94,177,98,103,99,62,101,185,101,11,103,213,108,225,108,249,112,50,120,43,126,222,128,179,130,12,132,236,132,2,135,18,137,42,138,74,140,166,144,210,146,253,152,243,156,108,157,79,78,161,78,141,80,86,82,74,87,168,89,61,94,216,95,217,95,63,98,180,102,27,103,208,103,210,104,146,81,33,125,170,128,168,129,0,139,140,140,191,140,126,146,50,150,32,84,44,152,23,83,213,80,92,83,168,88,178,100,52,103,103,114,102,119,70,122,230,145,195,82,161,108,134,107,0,88,76,94,84,89,44,103,251,127,225,81,198,118,105,100,232,120,84,155,187,158,203,87,185,89,39,102,154,103,206,107,233,84,217,105,85,94,156,129,149,103,170,155,254,103,82,156,93,104,166,78,227,79,200,83,185,98,43,103,171,108,196,143,173,79,109,126,191,158,7,78,98,97,128,110,43,111,19,133,115,84,42,103,69,155,243,93,149,123,172,92,198,91,28,135,74,110,209,132,20,122,8,129,153,89,141,124,17,108,32,119,217,82,34,89,33,113,95,114,219,119,39,151,97,157,11,105,127,90,24,90,165,81,13,84,125,84,14,102,223,118,247,143,152,146,244,156,234,89,93,114,197,110,77,81,201,104,191,125,236,125,98,151,186,158,120,100,33,106,2,131,132,89,95,91,219,107,27,115,242,118,178,125,23,128,153,132,50,81,40,103,217,158,238,118,98,103,255,82,5,153,36,92,59,98,126,124,176,140,79,85,182,96,11,125,128,149,1,83,95,78,182,81,28,89,58,114,54,128,206,145,37,95,226,119,132,83,121,95,4,125,172,133,51,138,141,142,86,151,243,103,174,133,83,148,9,97,8,97,185,108,82,118,237,138,56,143,47,85,81,79,42,81,199,82,203,83,165,91,125,94,160,96,130,97,214,99,9,103,218,103,103,110,140,109,54,115,55,115,49,117,80,121,213,136,152,138,74,144,145,144,245,144,196,150,141,135,21,89,136,78,89,79,14,78,137,138,63,143,16,152,173,80,124,94,150,89,185,91,184,94,218,99,250,99,193,100,220,102,74,105,216,105,11,109,182,110,148,113,40,117,175,122,138,127,0,128,73,132,201,132,129,137,33,139,10,142,101,144,125,150,10,153,126,97,145,98,50,107,131,108,116,109,204,127,252,127,192,109,133,127,186,135,248,136,101,103,177,131,60,152,247,150,27,109,97,125,61,132,106,145,113,78,117,83,80,93,4,107,235,111,205,133,45,134,167,137,41,82,15,84,101,92,78,103,168,104,6,116,131,116,226,117,207,136,225,136,204,145,226,150,120,150,139,95,135,115,203,122,78,132,160,99,101,117,137,82,65,109,156,110,9,116,89,117,107,120,146,124,134,150,220,122,141,159,182,79,110,97,197,101,92,134,134,78,174,78,218,80,33,78,204,81,238,91,153,101,129,104,188,109,31,115,66,118,173,119,28,122,231,124,111,130,210,138,124,144,207,145,117,150,24,152,155,82,209,125,43,80,152,83,151,103,203,109,208,113,51,116,232,129,42,143,163,150,87,156,159,158,96,116,65,88,153,109,47,125,94,152,228,78,54,79,139,79,183,81,177,82,186,93,28,96,178,115,60,121,211,130,52,146,183,150,246,150,10,151,151,158,98,159,166,102,116,107,23,82,163,82,200,112,194,136,201,94,75,96,144,97,35,111,73,113,62,124,244,125,111,128,238,132,35,144,44,147,66,84,111,155,211,106,137,112,194,140,239,141,50,151,180,82,65,90,202,94,4,95,23,103,124,105,148,105,106,109,15,111,98,114,252,114,237,123,1,128,126,128,75,135,206,144,109,81,147,158,132,121,139,128,50,147,214,138,45,80,140,84,113,138,106,107,196,140,7,129,209,96,160,103,242,157,153,78,152,78,16,156,107,138,193,133,104,133,0,105,126,110,151,120,85,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,95,16,78,21,78,42,78,49,78,54,78,60,78,63,78,66,78,86,78,88,78,130,78,133,78,107,140,138,78,18,130,13,95,142,78,158,78,159,78,160,78,162,78,176,78,179,78,182,78,206,78,205,78,196,78,198,78,194,78,215,78,222,78,237,78,223,78,247,78,9,79,90,79,48,79,91,79,93,79,87,79,71,79,118,79,136,79,143,79,152,79,123,79,105,79,112,79,145,79,111,79,134,79,150,79,24,81,212,79,223,79,206,79,216,79,219,79,209,79,218,79,208,79,228,79,229,79,26,80,40,80,20,80,42,80,37,80,5,80,28,79,246,79,33,80,41,80,44,80,254,79,239,79,17,80,6,80,67,80,71,80,3,103,85,80,80,80,72,80,90,80,86,80,108,80,120,80,128,80,154,80,133,80,180,80,178,80,201,80,202,80,179,80,194,80,214,80,222,80,229,80,237,80,227,80,238,80,249,80,245,80,9,81,1,81,2,81,22,81,21,81,20,81,26,81,33,81,58,81,55,81,60,81,59,81,63,81,64,81,82,81,76,81,84,81,98,81,248,122,105,81,106,81,110,81,128,81,130,81,216,86,140,81,137,81,143,81,145,81,147,81,149,81,150,81,164,81,166,81,162,81,169,81,170,81,171,81,179,81,177,81,178,81,176,81,181,81,189,81,197,81,201,81,219,81,224,81,85,134,233,81,237,81,240,81,245,81,254,81,4,82,11,82,20,82,14,82,39,82,42,82,46,82,51,82,57,82,79,82,68,82,75,82,76,82,94,82,84,82,106,82,116,82,105,82,115,82,127,82,125,82,141,82,148,82,146,82,113,82,136,82,145,82,168,143,167,143,172,82,173,82,188,82,181,82,193,82,205,82,215,82,222,82,227,82,230,82,237,152,224,82,243,82,245,82,248,82,249,82,6,83,8,83,56,117,13,83,16,83,15,83,21,83,26,83,35,83,47,83,49,83,51,83,56,83,64,83,70,83,69,83,23,78,73,83,77,83,214,81,94,83,105,83,110,83,24,89,123,83,119,83,130,83,150,83,160,83,166,83,165,83,174,83,176,83,182,83,195,83,18,124,217,150,223,83,252,102,238,113,238,83,232,83,237,83,250,83,1,84,61,84,64,84,44,84,45,84,60,84,46,84,54,84,41,84,29,84,78,84,143,84,117,84,142,84,95,84,113,84,119,84,112,84,146,84,123,84,128,84,118,84,132,84,144,84,134,84,199,84,162,84,184,84,165,84,172,84,196,84,200,84,168,84,171,84,194,84,164,84,190,84,188,84,216,84,229,84,230,84,15,85,20,85,253,84,238,84,237,84,250,84,226,84,57,85,64,85,99,85,76,85,46,85,92,85,69,85,86,85,87,85,56,85,51,85,93,85,153,85,128,85,175,84,138,85,159,85,123,85,126,85,152,85,158,85,174,85,124,85,131,85,169,85,135,85,168,85,218,85,197,85,223,85,196,85,220,85,228,85,212,85,20,86,247,85,22,86,254,85,253,85,27,86,249,85,78,86,80,86,223,113,52,86,54,86,50,86,56,86,107,86,100,86,47,86,108,86,106,86,134,86,128,86,138,86,160,86,148,86,143,86,165,86,174,86,182,86,180,86,194,86,188,86,193,86,195,86,192,86,200,86,206,86,209,86,211,86,215,86,238,86,249,86,0,87,255,86,4,87,9,87,8,87,11,87,13,87,19,87,24,87,22,87,199,85,28,87,38,87,55,87,56,87,78,87,59,87,64,87,79,87,105,87,192,87,136,87,97,87,127,87,137,87,147,87,160,87,179,87,164,87,170,87,176,87,195,87,198,87,212,87,210,87,211,87,10,88,214,87,227,87,11,88,25,88,29,88,114,88,33,88,98,88,75,88,112,88,192,107,82,88,61,88,121,88,133,88,185,88,159,88,171,88,186,88,222,88,187,88,184,88,174,88,197,88,211,88,209,88,215,88,217,88,216,88,229,88,220,88,228,88,223,88,239,88,250,88,249,88,251,88,252,88,253,88,2,89,10,89,16,89,27,89,166,104,37,89,44,89,45,89,50,89,56,89,62,89,210,122,85,89,80,89,78,89,90,89,88,89,98,89,96,89,103,89,108,89,105,89,120,89,129,89,157,89,94,79,171,79,163,89,178,89,198,89,232,89,220,89,141,89,217,89,218,89,37,90,31,90,17,90,28,90,9,90,26,90,64,90,108,90,73,90,53,90,54,90,98,90,106,90,154,90,188,90,190,90,203,90,194,90,189,90,227,90,215,90,230,90,233,90,214,90,250,90,251,90,12,91,11,91,22,91,50,91,208,90,42,91,54,91,62,91,67,91,69,91,64,91,81,91,85,91,90,91,91,91,101,91,105,91,112,91,115,91,117,91,120,91,136,101,122,91,128,91,131,91,166,91,184,91,195,91,199,91,201,91,212,91,208,91,228,91,230,91,226,91,222,91,229,91,235,91,240,91,246,91,243,91,5,92,7,92,8,92,13,92,19,92,32,92,34,92,40,92,56,92,57,92,65,92,70,92,78,92,83,92,80,92,79,92,113,91,108,92,110,92,98,78,118,92,121,92,140,92,145,92,148,92,155,89,171,92,187,92,182,92,188,92,183,92,197,92,190,92,199,92,217,92,233,92,253,92,250,92,237,92,140,93,234,92,11,93,21,93,23,93,92,93,31,93,27,93,17,93,20,93,34,93,26,93,25,93,24,93,76,93,82,93,78,93,75,93,108,93,115,93,118,93,135,93,132,93,130,93,162,93,157,93,172,93,174,93,189,93,144,93,183,93,188,93,201,93,205,93,211,93,210,93,214,93,219,93,235,93,242,93,245,93,11,94,26,94,25,94,17,94,27,94,54,94,55,94,68,94,67,94,64,94,78,94,87,94,84,94,95,94,98,94,100,94,71,94,117,94,118,94,122,94,188,158,127,94,160,94,193,94,194,94,200,94,208,94,207,94,214,94,227,94,221,94,218,94,219,94,226,94,225,94,232,94,233,94,236,94,241,94,243,94,240,94,244,94,248,94,254,94,3,95,9,95,93,95,92,95,11,95,17,95,22,95,41,95,45,95,56,95,65,95,72,95,76,95,78,95,47,95,81,95,86,95,87,95,89,95,97,95,109,95,115,95,119,95,131,95,130,95,127,95,138,95,136,95,145,95,135,95,158,95,153,95,152,95,160,95,168,95,173,95,188,95,214,95,251,95,228,95,248,95,241,95,221,95,179,96,255,95,33,96,96,96,25,96,16,96,41,96,14,96,49,96,27,96,21,96,43,96,38,96,15,96,58,96,90,96,65,96,106,96,119,96,95,96,74,96,70,96,77,96,99,96,67,96,100,96,66,96,108,96,107,96,89,96,129,96,141,96,231,96,131,96,154,96,132,96,155,96,150,96,151,96,146,96,167,96,139,96,225,96,184,96,224,96,211,96,180,96,240,95,189,96,198,96,181,96,216,96,77,97,21,97,6,97,246,96,247,96,0,97,244,96,250,96,3,97,33,97,251,96,241,96,13,97,14,97,71,97,62,97,40,97,39,97,74,97,63,97,60,97,44,97,52,97,61,97,66,97,68,97,115,97,119,97,88,97,89,97,90,97,107,97,116,97,111,97,101,97,113,97,95,97,93,97,83,97,117,97,153,97,150,97,135,97,172,97,148,97,154,97,138,97,145,97,171,97,174,97,204,97,202,97,201,97,247,97,200,97,195,97,198,97,186,97,203,97,121,127,205,97,230,97,227,97,246,97,250,97,244,97,255,97,253,97,252,97,254,97,0,98,8,98,9,98,13,98,12,98,20,98,27,98,30,98,33,98,42,98,46,98,48,98,50,98,51,98,65,98,78,98,94,98,99,98,91,98,96,98,104,98,124,98,130,98,137,98,126,98,146,98,147,98,150,98,212,98,131,98,148,98,215,98,209,98,187,98,207,98,255,98,198,98,212,100,200,98,220,98,204,98,202,98,194,98,199,98,155,98,201,98,12,99,238,98,241,98,39,99,2,99,8,99,239,98,245,98,80,99,62,99,77,99,28,100,79,99,150,99,142,99,128,99,171,99,118,99,163,99,143,99,137,99,159,99,181,99,107,99,105,99,190,99,233,99,192,99,198,99,227,99,201,99,210,99,246,99,196,99,22,100,52,100,6,100,19,100,38,100,54,100,29,101,23,100,40,100,15,100,103,100,111,100,118,100,78,100,42,101,149,100,147,100,165,100,169,100,136,100,188,100,218,100,210,100,197,100,199,100,187,100,216,100,194,100,241,100,231,100,9,130,224,100,225,100,172,98,227,100,239,100,44,101,246,100,244,100,242,100,250,100,0,101,253,100,24,101,28,101,5,101,36,101,35,101,43,101,52,101,53,101,55,101,54,101,56,101,75,117,72,101,86,101,85,101,77,101,88,101,94,101,93,101,114,101,120,101,130,101,131,101,138,139,155,101,159,101,171,101,183,101,195,101,198,101,193,101,196,101,204,101,210,101,219,101,217,101,224,101,225,101,241,101,114,103,10,102,3,102,251,101,115,103,53,102,54,102,52,102,28,102,79,102,68,102,73,102,65,102,94,102,93,102,100,102,103,102,104,102,95,102,98,102,112,102,131,102,136,102,142,102,137,102,132,102,152,102,157,102,193,102,185,102,201,102,190,102,188,102,196,102,184,102,214,102,218,102,224,102,63,102,230,102,233,102,240,102,245,102,247,102,15,103,22,103,30,103,38,103,39,103,56,151,46,103,63,103,54,103,65,103,56,103,55,103,70,103,94,103,96,103,89,103,99,103,100,103,137,103,112,103,169,103,124,103,106,103,140,103,139,103,166,103,161,103,133,103,183,103,239,103,180,103,236,103,179,103,233,103,184,103,228,103,222,103,221,103,226,103,238,103,185,103,206,103,198,103,231,103,156,106,30,104,70,104,41,104,64,104,77,104,50,104,78,104,179,104,43,104,89,104,99,104,119,104,127,104,159,104,143,104,173,104,148,104,157,104,155,104,131,104,174,106,185,104,116,104,181,104,160,104,186,104,15,105,141,104,126,104,1,105,202,104,8,105,216,104,34,105,38,105,225,104,12,105,205,104,212,104,231,104,213,104,54,105,18,105,4,105,215,104,227,104,37,105,249,104,224,104,239,104,40,105,42,105,26,105,35,105,33,105,198,104,121,105,119,105,92,105,120,105,107,105,84,105,126,105,110,105,57,105,116,105,61,105,89,105,48,105,97,105,94,105,93,105,129,105,106,105,178,105,174,105,208,105,191,105,193,105,211,105,190,105,206,105,232,91,202,105,221,105,187,105,195,105,167,105,46,106,145,105,160,105,156,105,149,105,180,105,222,105,232,105,2,106,27,106,255,105,10,107,249,105,242,105,231,105,5,106,177,105,30,106,237,105,20,106,235,105,10,106,18,106,193,106,35,106,19,106,68,106,12,106,114,106,54,106,120,106,71,106,98,106,89,106,102,106,72,106,56,106,34,106,144,106,141,106,160,106,132,106,162,106,163,106,151,106,23,134,187,106,195,106,194,106,184,106,179,106,172,106,222,106,209,106,223,106,170,106,218,106,234,106,251,106,5,107,22,134,250,106,18,107,22,107,49,155,31,107,56,107,55,107,220,118,57,107,238,152,71,107,67,107,73,107,80,107,89,107,84,107,91,107,95,107,97,107,120,107,121,107,127,107,128,107,132,107,131,107,141,107,152,107,149,107,158,107,164,107,170,107,171,107,175,107,178,107,177,107,179,107,183,107,188,107,198,107,203,107,211,107,223,107,236,107,235,107,243,107,239,107,190,158,8,108,19,108,20,108,27,108,36,108,35,108,94,108,85,108,98,108,106,108,130,108,141,108,154,108,129,108,155,108,126,108,104,108,115,108,146,108,144,108,196,108,241,108,211,108,189,108,215,108,197,108,221,108,174,108,177,108,190,108,186,108,219,108,239,108,217,108,234,108,31,109,77,136,54,109,43,109,61,109,56,109,25,109,53,109,51,109,18,109,12,109,99,109,147,109,100,109,90,109,121,109,89,109,142,109,149,109,228,111,133,109,249,109,21,110,10,110,181,109,199,109,230,109,184,109,198,109,236,109,222,109,204,109,232,109,210,109,197,109,250,109,217,109,228,109,213,109,234,109,238,109,45,110,110,110,46,110,25,110,114,110,95,110,62,110,35,110,107,110,43,110,118,110,77,110,31,110,67,110,58,110,78,110,36,110,255,110,29,110,56,110,130,110,170,110,152,110,201,110,183,110,211,110,189,110,175,110,196,110,178,110,212,110,213,110,143,110,165,110,194,110,159,110,65,111,17,111,76,112,236,110,248,110,254,110,63,111,242,110,49,111,239,110,50,111,204,110,62,111,19,111,247,110,134,111,122,111,120,111,129,111,128,111,111,111,91,111,243,111,109,111,130,111,124,111,88,111,142,111,145,111,194,111,102,111,179,111,163,111,161,111,164,111,185,111,198,111,170,111,223,111,213,111,236,111,212,111,216,111,241,111,238,111,219,111,9,112,11,112,250,111,17,112,1,112,15,112,254,111,27,112,26,112,116,111,29,112,24,112,31,112,48,112,62,112,50,112,81,112,99,112,153,112,146,112,175,112,241,112,172,112,184,112,179,112,174,112,223,112,203,112,221,112,217,112,9,113,253,112,28,113,25,113,101,113,85,113,136,113,102,113,98,113,76,113,86,113,108,113,143,113,251,113,132,113,149,113,168,113,172,113,215,113,185,113,190,113,210,113,201,113,212,113,206,113,224,113,236,113,231,113,245,113,252,113,249,113,255,113,13,114,16,114,27,114,40,114,45,114,44,114,48,114,50,114,59,114,60,114,63,114,64,114,70,114,75,114,88,114,116,114,126,114,130,114,129,114,135,114,146,114,150,114,162,114,167,114,185,114,178,114,195,114,198,114,196,114,206,114,210,114,226,114,224,114,225,114,249,114,247,114,15,80,23,115,10,115,28,115,22,115,29,115,52,115,47,115,41,115,37,115,62,115,78,115,79,115,216,158,87,115,106,115,104,115,112,115,120,115,117,115,123,115,122,115,200,115,179,115,206,115,187,115,192,115,229,115,238,115,222,115,162,116,5,116,111,116,37,116,248,115,50,116,58,116,85,116,63,116,95,116,89,116,65,116,92,116,105,116,112,116,99,116,106,116,118,116,126,116,139,116,158,116,167,116,202,116,207,116,212,116,241,115,224,116,227,116,231,116,233,116,238,116,242,116,240,116,241,116,248,116,247,116,4,117,3,117,5,117,12,117,14,117,13,117,21,117,19,117,30,117,38,117,44,117,60,117,68,117,77,117,74,117,73,117,91,117,70,117,90,117,105,117,100,117,103,117,107,117,109,117,120,117,118,117,134,117,135,117,116,117,138,117,137,117,130,117,148,117,154,117,157,117,165,117,163,117,194,117,179,117,195,117,181,117,189,117,184,117,188,117,177,117,205,117,202,117,210,117,217,117,227,117,222,117,254,117,255,117,252,117,1,118,240,117,250,117,242,117,243,117,11,118,13,118,9,118,31,118,39,118,32,118,33,118,34,118,36,118,52,118,48,118,59,118,71,118,72,118,70,118,92,118,88,118,97,118,98,118,104,118,105,118,106,118,103,118,108,118,112,118,114,118,118,118,120,118,124,118,128,118,131,118,136,118,139,118,142,118,150,118,147,118,153,118,154,118,176,118,180,118,184,118,185,118,186,118,194,118,205,118,214,118,210,118,222,118,225,118,229,118,231,118,234,118,47,134,251,118,8,119,7,119,4,119,41,119,36,119,30,119,37,119,38,119,27,119,55,119,56,119,71,119,90,119,104,119,107,119,91,119,101,119,127,119,126,119,121,119,142,119,139,119,145,119,160,119,158,119,176,119,182,119,185,119,191,119,188,119,189,119,187,119,199,119,205,119,215,119,218,119,220,119,227,119,238,119,252,119,12,120,18,120,38,121,32,120,42,121,69,120,142,120,116,120,134,120,124,120,154,120,140,120,163,120,181,120,170,120,175,120,209,120,198,120,203,120,212,120,190,120,188,120,197,120,202,120,236,120,231,120,218,120,253,120,244,120,7,121,18,121,17,121,25,121,44,121,43,121,64,121,96,121,87,121,95,121,90,121,85,121,83,121,122,121,127,121,138,121,157,121,167,121,75,159,170,121,174,121,179,121,185,121,186,121,201,121,213,121,231,121,236,121,225,121,227,121,8,122,13,122,24,122,25,122,32,122,31,122,128,121,49,122,59,122,62,122,55,122,67,122,87,122,73,122,97,122,98,122,105,122,157,159,112,122,121,122,125,122,136,122,151,122,149,122,152,122,150,122,169,122,200,122,176,122,182,122,197,122,196,122,191,122,131,144,199,122,202,122,205,122,207,122,213,122,211,122,217,122,218,122,221,122,225,122,226,122,230,122,237,122,240,122,2,123,15,123,10,123,6,123,51,123,24,123,25,123,30,123,53,123,40,123,54,123,80,123,122,123,4,123,77,123,11,123,76,123,69,123,117,123,101,123,116,123,103,123,112,123,113,123,108,123,110,123,157,123,152,123,159,123,141,123,156,123,154,123,139,123,146,123,143,123,93,123,153,123,203,123,193,123,204,123,207,123,180,123,198,123,221,123,233,123,17,124,20,124,230,123,229,123,96,124,0,124,7,124,19,124,243,123,247,123,23,124,13,124,246,123,35,124,39,124,42,124,31,124,55,124,43,124,61,124,76,124,67,124,84,124,79,124,64,124,80,124,88,124,95,124,100,124,86,124,101,124,108,124,117,124,131,124,144,124,164,124,173,124,162,124,171,124,161,124,168,124,179,124,178,124,177,124,174,124,185,124,189,124,192,124,197,124,194,124,216,124,210,124,220,124,226,124,59,155,239,124,242,124,244,124,246,124,250,124,6,125,2,125,28,125,21,125,10,125,69,125,75,125,46,125,50,125,63,125,53,125,70,125,115,125,86,125,78,125,114,125,104,125,110,125,79,125,99,125,147,125,137,125,91,125,143,125,125,125,155,125,186,125,174,125,163,125,181,125,199,125,189,125,171,125,61,126,162,125,175,125,220,125,184,125,159,125,176,125,216,125,221,125,228,125,222,125,251,125,242,125,225,125,5,126,10,126,35,126,33,126,18,126,49,126,31,126,9,126,11,126,34,126,70,126,102,126,59,126,53,126,57,126,67,126,55,126,50,126,58,126,103,126,93,126,86,126,94,126,89,126,90,126,121,126,106,126,105,126,124,126,123,126,131,126,213,125,125,126,174,143,127,126,136,126,137,126,140,126,146,126,144,126,147,126,148,126,150,126,142,126,155,126,156,126,56,127,58,127,69,127,76,127,77,127,78,127,80,127,81,127,85,127,84,127,88,127,95,127,96,127,104,127,105,127,103,127,120,127,130,127,134,127,131,127,136,127,135,127,140,127,148,127,158,127,157,127,154,127,163,127,175,127,178,127,185,127,174,127,182,127,184,127,113,139,197,127,198,127,202,127,213,127,212,127,225,127,230,127,233,127,243,127,249,127,220,152],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+210108),
	allocate([6,128,4,128,11,128,18,128,24,128,25,128,28,128,33,128,40,128,63,128,59,128,74,128,70,128,82,128,88,128,90,128,95,128,98,128,104,128,115,128,114,128,112,128,118,128,121,128,125,128,127,128,132,128,134,128,133,128,155,128,147,128,154,128,173,128,144,81,172,128,219,128,229,128,217,128,221,128,196,128,218,128,214,128,9,129,239,128,241,128,27,129,41,129,35,129,47,129,75,129,139,150,70,129,62,129,83,129,81,129,252,128,113,129,110,129,101,129,102,129,116,129,131,129,136,129,138,129,128,129,130,129,160,129,149,129,164,129,163,129,95,129,147,129,169,129,176,129,181,129,190,129,184,129,189,129,192,129,194,129,186,129,201,129,205,129,209,129,217,129,216,129,200,129,218,129,223,129,224,129,231,129,250,129,251,129,254,129,1,130,2,130,5,130,7,130,10,130,13,130,16,130,22,130,41,130,43,130,56,130,51,130,64,130,89,130,88,130,93,130,90,130,95,130,100,130,98,130,104,130,106,130,107,130,46,130,113,130,119,130,120,130,126,130,141,130,146,130,171,130,159,130,187,130,172,130,225,130,227,130,223,130,210,130,244,130,243,130,250,130,147,131,3,131,251,130,249,130,222,130,6,131,220,130,9,131,217,130,53,131,52,131,22,131,50,131,49,131,64,131,57,131,80,131,69,131,47,131,43,131,23,131,24,131,133,131,154,131,170,131,159,131,162,131,150,131,35,131,142,131,135,131,138,131,124,131,181,131,115,131,117,131,160,131,137,131,168,131,244,131,19,132,235,131,206,131,253,131,3,132,216,131,11,132,193,131,247,131,7,132,224,131,242,131,13,132,34,132,32,132,189,131,56,132,6,133,251,131,109,132,42,132,60,132,90,133,132,132,119,132,107,132,173,132,110,132,130,132,105,132,70,132,44,132,111,132,121,132,53,132,202,132,98,132,185,132,191,132,159,132,217,132,205,132,187,132,218,132,208,132,193,132,198,132,214,132,161,132,33,133,255,132,244,132,23,133,24,133,44,133,31,133,21,133,20,133,252,132,64,133,99,133,88,133,72,133,65,133,2,134,75,133,85,133,128,133,164,133,136,133,145,133,138,133,168,133,109,133,148,133,155,133,234,133,135,133,156,133,119,133,126,133,144,133,201,133,186,133,207,133,185,133,208,133,213,133,221,133,229,133,220,133,249,133,10,134,19,134,11,134,254,133,250,133,6,134,34,134,26,134,48,134,63,134,77,134,85,78,84,134,95,134,103,134,113,134,147,134,163,134,169,134,170,134,139,134,140,134,182,134,175,134,196,134,198,134,176,134,201,134,35,136,171,134,212,134,222,134,233,134,236,134,223,134,219,134,239,134,18,135,6,135,8,135,0,135,3,135,251,134,17,135,9,135,13,135,249,134,10,135,52,135,63,135,55,135,59,135,37,135,41,135,26,135,96,135,95,135,120,135,76,135,78,135,116,135,87,135,104,135,110,135,89,135,83,135,99,135,106,135,5,136,162,135,159,135,130,135,175,135,203,135,189,135,192,135,208,135,214,150,171,135,196,135,179,135,199,135,198,135,187,135,239,135,242,135,224,135,15,136,13,136,254,135,246,135,247,135,14,136,210,135,17,136,22,136,21,136,34,136,33,136,49,136,54,136,57,136,39,136,59,136,68,136,66,136,82,136,89,136,94,136,98,136,107,136,129,136,126,136,158,136,117,136,125,136,181,136,114,136,130,136,151,136,146,136,174,136,153,136,162,136,141,136,164,136,176,136,191,136,177,136,195,136,196,136,212,136,216,136,217,136,221,136,249,136,2,137,252,136,244,136,232,136,242,136,4,137,12,137,10,137,19,137,67,137,30,137,37,137,42,137,43,137,65,137,68,137,59,137,54,137,56,137,76,137,29,137,96,137,94,137,102,137,100,137,109,137,106,137,111,137,116,137,119,137,126,137,131,137,136,137,138,137,147,137,152,137,161,137,169,137,166,137,172,137,175,137,178,137,186,137,189,137,191,137,192,137,218,137,220,137,221,137,231,137,244,137,248,137,3,138,22,138,16,138,12,138,27,138,29,138,37,138,54,138,65,138,91,138,82,138,70,138,72,138,124,138,109,138,108,138,98,138,133,138,130,138,132,138,168,138,161,138,145,138,165,138,166,138,154,138,163,138,196,138,205,138,194,138,218,138,235,138,243,138,231,138,228,138,241,138,20,139,224,138,226,138,247,138,222,138,219,138,12,139,7,139,26,139,225,138,22,139,16,139,23,139,32,139,51,139,171,151,38,139,43,139,62,139,40,139,65,139,76,139,79,139,78,139,73,139,86,139,91,139,90,139,107,139,95,139,108,139,111,139,116,139,125,139,128,139,140,139,142,139,146,139,147,139,150,139,153,139,154,139,58,140,65,140,63,140,72,140,76,140,78,140,80,140,85,140,98,140,108,140,120,140,122,140,130,140,137,140,133,140,138,140,141,140,142,140,148,140,124,140,152,140,29,98,173,140,170,140,189,140,178,140,179,140,174,140,182,140,200,140,193,140,228,140,227,140,218,140,253,140,250,140,251,140,4,141,5,141,10,141,7,141,15,141,13,141,16,141,78,159,19,141,205,140,20,141,22,141,103,141,109,141,113,141,115,141,129,141,153,141,194,141,190,141,186,141,207,141,218,141,214,141,204,141,219,141,203,141,234,141,235,141,223,141,227,141,252,141,8,142,9,142,255,141,29,142,30,142,16,142,31,142,66,142,53,142,48,142,52,142,74,142,71,142,73,142,76,142,80,142,72,142,89,142,100,142,96,142,42,142,99,142,85,142,118,142,114,142,124,142,129,142,135,142,133,142,132,142,139,142,138,142,147,142,145,142,148,142,153,142,170,142,161,142,172,142,176,142,198,142,177,142,190,142,197,142,200,142,203,142,219,142,227,142,252,142,251,142,235,142,254,142,10,143,5,143,21,143,18,143,25,143,19,143,28,143,31,143,27,143,12,143,38,143,51,143,59,143,57,143,69,143,66,143,62,143,76,143,73,143,70,143,78,143,87,143,92,143,98,143,99,143,100,143,156,143,159,143,163,143,173,143,175,143,183,143,218,143,229,143,226,143,234,143,239,143,135,144,244,143,5,144,249,143,250,143,17,144,21,144,33,144,13,144,30,144,22,144,11,144,39,144,54,144,53,144,57,144,248,143,79,144,80,144,81,144,82,144,14,144,73,144,62,144,86,144,88,144,94,144,104,144,111,144,118,144,168,150,114,144,130,144,125,144,129,144,128,144,138,144,137,144,143,144,168,144,175,144,177,144,181,144,226,144,228,144,72,98,219,144,2,145,18,145,25,145,50,145,48,145,74,145,86,145,88,145,99,145,101,145,105,145,115,145,114,145,139,145,137,145,130,145,162,145,171,145,175,145,170,145,181,145,180,145,186,145,192,145,193,145,201,145,203,145,208,145,214,145,223,145,225,145,219,145,252,145,245,145,246,145,30,146,255,145,20,146,44,146,21,146,17,146,94,146,87,146,69,146,73,146,100,146,72,146,149,146,63,146,75,146,80,146,156,146,150,146,147,146,155,146,90,146,207,146,185,146,183,146,233,146,15,147,250,146,68,147,46,147,25,147,34,147,26,147,35,147,58,147,53,147,59,147,92,147,96,147,124,147,110,147,86,147,176,147,172,147,173,147,148,147,185,147,214,147,215,147,232,147,229,147,216,147,195,147,221,147,208,147,200,147,228,147,26,148,20,148,19,148,3,148,7,148,16,148,54,148,43,148,53,148,33,148,58,148,65,148,82,148,68,148,91,148,96,148,98,148,94,148,106,148,41,146,112,148,117,148,119,148,125,148,90,148,124,148,126,148,129,148,127,148,130,149,135,149,138,149,148,149,150,149,152,149,153,149,160,149,168,149,167,149,173,149,188,149,187,149,185,149,190,149,202,149,246,111,195,149,205,149,204,149,213,149,212,149,214,149,220,149,225,149,229,149,226,149,33,150,40,150,46,150,47,150,66,150,76,150,79,150,75,150,119,150,92,150,94,150,93,150,95,150,102,150,114,150,108,150,141,150,152,150,149,150,151,150,170,150,167,150,177,150,178,150,176,150,180,150,182,150,184,150,185,150,206,150,203,150,201,150,205,150,77,137,220,150,13,151,213,150,249,150,4,151,6,151,8,151,19,151,14,151,17,151,15,151,22,151,25,151,36,151,42,151,48,151,57,151,61,151,62,151,68,151,70,151,72,151,66,151,73,151,92,151,96,151,100,151,102,151,104,151,210,82,107,151,113,151,121,151,133,151,124,151,129,151,122,151,134,151,139,151,143,151,144,151,156,151,168,151,166,151,163,151,179,151,180,151,195,151,198,151,200,151,203,151,220,151,237,151,79,159,242,151,223,122,246,151,245,151,15,152,12,152,56,152,36,152,33,152,55,152,61,152,70,152,79,152,75,152,107,152,111,152,112,152,113,152,116,152,115,152,170,152,175,152,177,152,182,152,196,152,195,152,198,152,233,152,235,152,3,153,9,153,18,153,20,153,24,153,33,153,29,153,30,153,36,153,32,153,44,153,46,153,61,153,62,153,66,153,73,153,69,153,80,153,75,153,81,153,82,153,76,153,85,153,151,153,152,153,165,153,173,153,174,153,188,153,223,153,219,153,221,153,216,153,209,153,237,153,238,153,241,153,242,153,251,153,248,153,1,154,15,154,5,154,226,153,25,154,43,154,55,154,69,154,66,154,64,154,67,154,62,154,85,154,77,154,91,154,87,154,95,154,98,154,101,154,100,154,105,154,107,154,106,154,173,154,176,154,188,154,192,154,207,154,209,154,211,154,212,154,222,154,223,154,226,154,227,154,230,154,239,154,235,154,238,154,244,154,241,154,247,154,251,154,6,155,24,155,26,155,31,155,34,155,35,155,37,155,39,155,40,155,41,155,42,155,46,155,47,155,50,155,68,155,67,155,79,155,77,155,78,155,81,155,88,155,116,155,147,155,131,155,145,155,150,155,151,155,159,155,160,155,168,155,180,155,192,155,202,155,185,155,198,155,207,155,209,155,210,155,227,155,226,155,228,155,212,155,225,155,58,156,242,155,241,155,240,155,21,156,20,156,9,156,19,156,12,156,6,156,8,156,18,156,10,156,4,156,46,156,27,156,37,156,36,156,33,156,48,156,71,156,50,156,70,156,62,156,90,156,96,156,103,156,118,156,120,156,231,156,236,156,240,156,9,157,8,157,235,156,3,157,6,157,42,157,38,157,175,157,35,157,31,157,68,157,21,157,18,157,65,157,63,157,62,157,70,157,72,157,93,157,94,157,100,157,81,157,80,157,89,157,114,157,137,157,135,157,171,157,111,157,122,157,154,157,164,157,169,157,178,157,196,157,193,157,187,157,184,157,186,157,198,157,207,157,194,157,217,157,211,157,248,157,230,157,237,157,239,157,253,157,26,158,27,158,30,158,117,158,121,158,125,158,129,158,136,158,139,158,140,158,146,158,149,158,145,158,157,158,165,158,169,158,184,158,170,158,173,158,97,151,204,158,206,158,207,158,208,158,212,158,220,158,222,158,221,158,224,158,229,158,232,158,239,158,244,158,246,158,247,158,249,158,251,158,252,158,253,158,7,159,8,159,183,118,21,159,33,159,44,159,62,159,74,159,82,159,84,159,99,159,95,159,96,159,97,159,102,159,103,159,108,159,106,159,119,159,114,159,118,159,149,159,156,159,160,159,47,88,199,105,89,144,100,116,220,81,153,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,78,4,78,5,78,6,78,15,78,18,78,23,78,31,78,32,78,33,78,35,78,38,78,41,78,46,78,47,78,49,78,51,78,53,78,55,78,60,78,64,78,65,78,66,78,68,78,70,78,74,78,81,78,85,78,87,78,90,78,91,78,98,78,99,78,100,78,101,78,103,78,104,78,106,78,107,78,108,78,109,78,110,78,111,78,114,78,116,78,117,78,118,78,119,78,120,78,121,78,122,78,123,78,124,78,125,78,127,78,128,78,129,78,130,78,131,78,132,78,133,78,135,78,138,78,144,78,150,78,151,78,153,78,156,78,157,78,158,78,163,78,170,78,175,78,176,78,177,78,180,78,182,78,183,78,184,78,185,78,188,78,189,78,190,78,200,78,204,78,207,78,208,78,210,78,218,78,219,78,220,78,224,78,226,78,230,78,231,78,233,78,237,78,238,78,239,78,241,78,244,78,248,78,249,78,250,78,252,78,254,78,0,79,2,79,3,79,4,79,5,79,6,79,7,79,8,79,11,79,12,79,18,79,19,79,20,79,21,79,22,79,28,79,29,79,33,79,35,79,40,79,41,79,44,79,45,79,46,79,49,79,51,79,53,79,55,79,57,79,59,79,62,79,63,79,64,79,65,79,66,79,68,79,69,79,71,79,72,79,73,79,74,79,75,79,76,79,82,79,84,79,86,79,97,79,98,79,102,79,104,79,106,79,107,79,109,79,110,79,113,79,114,79,117,79,119,79,120,79,121,79,122,79,125,79,128,79,129,79,130,79,133,79,134,79,135,79,138,79,140,79,142,79,144,79,146,79,147,79,149,79,150,79,152,79,153,79,154,79,156,79,158,79,159,79,161,79,162,79,164,79,171,79,173,79,176,79,177,79,178,79,179,79,180,79,182,79,183,79,184,79,185,79,186,79,187,79,188,79,189,79,190,79,192,79,193,79,194,79,198,79,199,79,200,79,201,79,203,79,204,79,205,79,210,79,211,79,212,79,213,79,214,79,217,79,219,79,224,79,226,79,228,79,229,79,231,79,235,79,236,79,240,79,242,79,244,79,245,79,246,79,247,79,249,79,251,79,252,79,253,79,255,79,0,80,1,80,2,80,3,80,4,80,5,80,6,80,7,80,8,80,9,80,10,80,11,80,14,80,16,80,17,80,19,80,21,80,22,80,23,80,27,80,29,80,30,80,32,80,34,80,35,80,36,80,39,80,43,80,47,80,48,80,49,80,50,80,51,80,52,80,53,80,54,80,55,80,56,80,57,80,59,80,61,80,63,80,64,80,65,80,66,80,68,80,69,80,70,80,73,80,74,80,75,80,77,80,80,80,81,80,82,80,83,80,84,80,86,80,87,80,88,80,89,80,91,80,93,80,94,80,95,80,96,80,97,80,98,80,99,80,100,80,102,80,103,80,104,80,105,80,106,80,107,80,109,80,110,80,111,80,112,80,113,80,114,80,115,80,116,80,117,80,120,80,121,80,122,80,124,80,125,80,129,80,130,80,131,80,132,80,134,80,135,80,137,80,138,80,139,80,140,80,142,80,143,80,144,80,145,80,146,80,147,80,148,80,149,80,150,80,151,80,152,80,153,80,154,80,155,80,156,80,157,80,158,80,159,80,160,80,161,80,162,80,164,80,166,80,170,80,171,80,173,80,174,80,175,80,176,80,177,80,179,80,180,80,181,80,182,80,183,80,184,80,185,80,188,80,189,80,190,80,191,80,192,80,193,80,194,80,195,80,196,80,197,80,198,80,199,80,200,80,201,80,202,80,203,80,204,80,205,80,206,80,208,80,209,80,210,80,211,80,212,80,213,80,215,80,216,80,217,80,219,80,220,80,221,80,222,80,223,80,224,80,225,80,226,80,227,80,228,80,229,80,232,80,233,80,234,80,235,80,239,80,240,80,241,80,242,80,244,80,246,80,247,80,248,80,249,80,250,80,252,80,253,80,254,80,255,80,0,81,1,81,2,81,3,81,4,81,5,81,8,81,9,81,10,81,12,81,13,81,14,81,15,81,16,81,17,81,19,81,20,81,21,81,22,81,23,81,24,81,25,81,26,81,27,81,28,81,29,81,30,81,31,81,32,81,34,81,35,81,36,81,37,81,38,81,39,81,40,81,41,81,42,81,43,81,44,81,45,81,46,81,47,81,48,81,49,81,50,81,51,81,52,81,53,81,54,81,55,81,56,81,57,81,58,81,59,81,60,81,61,81,62,81,66,81,71,81,74,81,76,81,78,81,79,81,80,81,82,81,83,81,87,81,88,81,89,81,91,81,93,81,94,81,95,81,96,81,97,81,99,81,100,81,102,81,103,81,105,81,106,81,111,81,114,81,122,81,126,81,127,81,131,81,132,81,134,81,135,81,138,81,139,81,142,81,143,81,144,81,145,81,147,81,148,81,152,81,154,81,157,81,158,81,159,81,161,81,163,81,166,81,167,81,168,81,169,81,170,81,173,81,174,81,180,81,184,81,185,81,186,81,190,81,191,81,193,81,194,81,195,81,197,81,200,81,202,81,205,81,206,81,208,81,210,81,211,81,212,81,213,81,214,81,215,81,216,81,217,81,218,81,220,81,222,81,223,81,226,81,227,81,229,81,230,81,231,81,232,81,233,81,234,81,236,81,238,81,241,81,242,81,244,81,247,81,254,81,4,82,5,82,9,82,11,82,12,82,15,82,16,82,19,82,20,82,21,82,28,82,30,82,31,82,33,82,34,82,35,82,37,82,38,82,39,82,42,82,44,82,47,82,49,82,50,82,52,82,53,82,60,82,62,82,68,82,69,82,70,82,71,82,72,82,73,82,75,82,78,82,79,82,82,82,83,82,85,82,87,82,88,82,89,82,90,82,91,82,93,82,95,82,96,82,98,82,99,82,100,82,102,82,104,82,107,82,108,82,109,82,110,82,112,82,113,82,115,82,116,82,117,82,118,82,119,82,120,82,121,82,122,82,123,82,124,82,126,82,128,82,131,82,132,82,133,82,134,82,135,82,137,82,138,82,139,82,140,82,141,82,142,82,143,82,145,82,146,82,148,82,149,82,150,82,151,82,152,82,153,82,154,82,156,82,164,82,165,82,166,82,167,82,174,82,175,82,176,82,180,82,181,82,182,82,183,82,184,82,185,82,186,82,187,82,188,82,189,82,192,82,193,82,194,82,196,82,197,82,198,82,200,82,202,82,204,82,205,82,206,82,207,82,209,82,211,82,212,82,213,82,215,82,217,82,218,82,219,82,220,82,221,82,222,82,224,82,225,82,226,82,227,82,229,82,230,82,231,82,232,82,233,82,234,82,235,82,236,82,237,82,238,82,239,82,241,82,242,82,243,82,244,82,245,82,246,82,247,82,248,82,251,82,252,82,253,82,1,83,2,83,3,83,4,83,7,83,9,83,10,83,11,83,12,83,14,83,17,83,18,83,19,83,20,83,24,83,27,83,28,83,30,83,31,83,34,83,36,83,37,83,39,83,40,83,41,83,43,83,44,83,45,83,47,83,48,83,49,83,50,83,51,83,52,83,53,83,54,83,55,83,56,83,60,83,61,83,64,83,66,83,68,83,70,83,75,83,76,83,77,83,80,83,84,83,88,83,89,83,91,83,93,83,101,83,104,83,106,83,108,83,109,83,114,83,118,83,121,83,123,83,124,83,125,83,126,83,128,83,129,83,131,83,135,83,136,83,138,83,142,83,143,83,144,83,145,83,146,83,147,83,148,83,150,83,151,83,153,83,155,83,156,83,158,83,160,83,161,83,164,83,167,83,170,83,171,83,172,83,173,83,175,83,176,83,177,83,178,83,179,83,180,83,181,83,183,83,184,83,185,83,186,83,188,83,189,83,190,83,192,83,195,83,196,83,197,83,198,83,199,83,206,83,207,83,208,83,210,83,211,83,213,83,218,83,220,83,221,83,222,83,225,83,226,83,231,83,244,83,250,83,254,83,255,83,0,84,2,84,5,84,7,84,11,84,20,84,24,84,25,84,26,84,28,84,34,84,36,84,37,84,42,84,48,84,51,84,54,84,55,84,58,84,61,84,63,84,65,84,66,84,68,84,69,84,71,84,73,84,76,84,77,84,78,84,79,84,81,84,90,84,93,84,94,84,95,84,96,84,97,84,99,84,101,84,103,84,105,84,106,84,107,84,108,84,109,84,110,84,111,84,112,84,116,84,121,84,122,84,126,84,127,84,129,84,131,84,133,84,135,84,136,84,137,84,138,84,141,84,145,84,147,84,151,84,152,84,156,84,158,84,159,84,160,84,161,84,162,84,165,84,174,84,176,84,178,84,181,84,182,84,183,84,185,84,186,84,188,84,190,84,195,84,197,84,202,84,203,84,214,84,216,84,219,84,224,84,225,84,226,84,227,84,228,84,235,84,236,84,239,84,240,84,241,84,244,84,245,84,246,84,247,84,248,84,249,84,251,84,254,84,0,85,2,85,3,85,4,85,5,85,8,85,10,85,11,85,12,85,13,85,14,85,18,85,19,85,21,85,22,85,23,85,24,85,25,85,26,85,28,85,29,85,30,85,31,85,33,85,37,85,38,85,40,85,41,85,43,85,45,85,50,85,52,85,53,85,54,85,56,85,57,85,58,85,59,85,61,85,64,85,66,85,69,85,71,85,72,85,75,85,76,85,77,85,78,85,79,85,81,85,82,85,83,85,84,85,87,85,88,85,89,85,90,85,91,85,93,85,94,85,95,85,96,85,98,85,99,85,104,85,105,85,107,85,111,85,112,85,113,85,114,85,115,85,116,85,121,85,122,85,125,85,127,85,133,85,134,85,140,85,141,85,142,85,144,85,146,85,147,85,149,85,150,85,151,85,154,85,155,85,158,85,160,85,161,85,162,85,163,85,164,85,165,85,166,85,168,85,169,85,170,85,171,85,172,85,173,85,174,85,175,85,176,85,178,85,180,85,182,85,184,85,186,85,188,85,191,85,192,85,193,85,194,85,195,85,198,85,199,85,200,85,202,85,203,85,206,85,207,85,208,85,213,85,215,85,216,85,217,85,218,85,219,85,222,85,224,85,226,85,231,85,233,85,237,85,238,85,240,85,241,85,244,85,246,85,248,85,249,85,250,85,251,85,252,85,255,85,2,86,3,86,4,86,5,86,6,86,7,86,10,86,11,86,13,86,16,86,17,86,18,86,19,86,20,86,21,86,22,86,23,86,25,86,26,86,28,86,29,86,32,86,33,86,34,86,37,86,38,86,40,86,41,86,42,86,43,86,46,86,47,86,48,86,51,86,53,86,55,86,56,86,58,86,60,86,61,86,62,86,64,86,65,86,66,86,67,86,68,86,69,86,70,86,71,86,72,86,73,86,74,86,75,86,79,86,80,86,81,86,82,86,83,86,85,86,86,86,90,86,91,86,93,86,94,86,95,86,96,86,97,86,99,86,101,86,102,86,103,86,109,86,110,86,111,86,112,86,114,86,115,86,116,86,117,86,119,86,120,86,121,86,122,86,125,86,126,86,127,86,128,86,129,86,130,86,131,86,132,86,135,86,136,86,137,86,138,86,139,86,140,86,141,86,144,86,145,86,146,86,148,86,149,86,150,86,151,86,152,86,153,86,154,86,155,86,156,86,157,86,158,86,159,86,160,86,161,86,162,86,164,86,165,86,166,86,167,86,168,86,169,86,170,86,171,86,172,86,173,86,174,86,176,86,177,86,178,86,179,86,180,86,181,86,182,86,184,86,185,86,186,86,187,86,189,86,190,86,191,86,192,86,193,86,194,86,195,86,196,86,197,86,198,86,199,86,200,86,201,86,203,86,204,86,205,86,206,86,207,86,208,86,209,86,210,86,211,86,213,86,214,86,216,86,217,86,220,86,227,86,229,86,230,86,231,86,232,86,233,86,234,86,236,86,238,86,239,86,242,86,243,86,246,86,247,86,248,86,251,86,252,86,0,87,1,87,2,87,5,87,7,87,11,87,12,87,13,87,14,87,15,87,16,87,17,87,18,87,19,87,20,87,21,87,22,87,23,87,24,87,25,87,26,87,27,87,29,87,30,87,32,87,33,87,34,87,36,87,37,87,38,87,39,87,43,87,49,87,50,87,52,87,53,87,54,87,55,87,56,87,60,87,61,87,63,87,65,87,67,87,68,87,69,87,70,87,72,87,73,87,75,87,82,87,83,87,84,87,85,87,86,87,88,87,89,87,98,87,99,87,101,87,103,87,108,87,110,87,112,87,113,87,114,87,116,87,117,87,120,87,121,87,122,87,125,87,126,87,127,87,128,87,129,87,135,87,136,87,137,87,138,87,141,87,142,87,143,87,144,87,145,87,148,87,149,87,150,87,151,87,152,87,153,87,154,87,156,87,157,87,158,87,159,87,165,87,168,87,170,87,172,87,175,87,176,87,177,87,179,87,181,87,182,87,183,87,185,87,186,87,187,87,188,87,189,87,190,87,191,87,192,87,193,87,196,87,197,87,198,87,199,87,200,87,201,87,202,87,204,87,205,87,208,87,209,87,211,87,214,87,215,87,219,87,220,87,222,87,225,87,226,87,227,87,229,87,230,87,231,87,232,87,233,87,234,87,235,87,236,87,238,87,240,87,241,87,242,87,243,87,245,87,246,87,247,87,251,87,252,87,254,87,255,87,1,88,3,88,4,88,5,88,8,88,9,88,10,88,12,88,14,88,15,88,16,88,18,88,19,88,20,88,22,88,23,88,24,88,26,88,27,88,28,88,29,88,31,88,34,88,35,88,37,88,38,88,39,88,40,88,41,88,43,88,44,88,45,88,46,88,47,88,49,88,50,88,51,88,52,88,54,88,55,88,56,88,57,88,58,88,59,88,60,88,61,88,62,88,63,88,64,88,65,88,66,88,67,88,69,88,70,88,71,88,72,88,73,88,74,88,75,88,78,88,79,88,80,88,82,88,83,88,85,88,86,88,87,88,89,88,90,88,91,88,92,88,93,88,95,88,96,88,97,88,98,88,99,88,100,88,102,88,103,88,104,88,105,88,106,88,109,88,110,88,111,88,112,88,113,88,114,88,115,88,116,88,117,88,118,88,119,88,120,88,121,88,122,88,123,88,124,88,125,88,127,88,130,88,132,88,134,88,135,88,136,88,138,88,139,88,140,88,141,88,142,88,143,88,144,88,145,88,148,88,149,88,150,88,151,88,152,88,155,88,156,88,157,88,160,88,161,88,162,88,163,88,164,88,165,88,166,88,167,88,170,88,171,88,172,88,173,88,174,88,175,88,176,88,177,88,178,88,179,88,180,88,181,88,182,88,183,88,184,88,185,88,186,88,187,88,189,88,190,88,191,88,192,88,194,88,195,88,196,88,198,88,199,88,200,88,201,88,202,88,203,88,204,88,205,88,206,88,207,88,208,88,210,88,211,88,212,88,214,88,215,88,216,88,217,88,218,88,219,88,220,88,221,88,222,88,223,88,224,88,225,88,226,88,227,88,229,88,230,88,231,88,232,88,233,88,234,88,237,88,239,88,241,88,242,88,244,88,245,88,247,88,248,88,250,88,251,88,252,88,253,88,254,88,255,88,0,89,1,89,3,89,5,89,6,89,8,89,9,89,10,89,11,89,12,89,14,89,16,89,17,89,18,89,19,89,23,89,24,89,27,89,29,89,30,89,32,89,33,89,34,89,35,89,38,89,40,89,44,89,48,89,50,89,51,89,53,89,54,89,59,89,61,89,62,89,63,89,64,89,67,89,69,89,70,89,74,89,76,89,77,89,80,89,82,89,83,89,89,89,91,89,92,89,93,89,94,89,95,89,97,89,99,89,100,89,102,89,103,89,104,89,105,89,106,89,107,89,108,89,109,89,110,89,111,89,112,89,113,89,114,89,117,89,119,89,122,89,123,89,124,89,126,89,127,89,128,89,133,89,137,89,139,89,140,89,142,89,143,89,144,89,145,89,148,89,149,89,152,89,154,89,155,89,156,89,157,89,159,89,160,89,161,89,162,89,166,89,167,89,172,89,173,89,176,89,177,89,179,89,180,89,181,89,182,89,183,89,184,89,186,89,188,89,189,89,191,89,192,89,193,89,194,89,195,89,196,89,197,89,199,89,200,89,201,89,204,89,205,89,206,89,207,89,213,89,214,89,217,89,219,89,222,89,223,89,224,89,225,89,226,89,228,89,230,89,231,89,233,89,234,89,235,89,237,89,238,89,239,89,240,89,241,89,242,89,243,89,244,89,245,89,246,89,247,89,248,89,250,89,252,89,253,89,254,89,0,90,2,90,10,90,11,90,13,90,14,90,15,90,16,90,18,90,20,90,21,90,22,90,23,90,25,90,26,90,27,90,29,90,30,90,33,90,34,90,36,90,38,90,39,90,40,90,42,90,43,90,44,90,45,90,46,90,47,90,48,90,51,90,53,90,55,90,56,90,57,90,58,90,59,90,61,90,62,90,63,90,65,90,66,90,67,90,68,90,69,90,71,90,72,90,75,90,76,90,77,90,78,90,79,90,80,90,81,90,82,90,83,90,84,90,86,90,87,90,88,90,89,90,91,90,92,90,93,90,94,90,95,90,96,90,97,90,99,90,100,90,101,90,102,90,104,90,105,90,107,90,108,90,109,90,110,90,111,90,112,90,113,90,114,90,115,90,120,90,121,90,123,90,124,90,125,90,126,90,128,90,129,90,130,90,131,90,132,90,133,90,134,90,135,90,136,90,137,90,138,90,139,90,140,90,141,90,142,90,143,90,144,90,145,90,147,90,148,90,149,90,150,90,151,90,152,90,153,90,156,90,157,90,158,90,159,90,160,90,161,90,162,90,163,90,164,90,165,90,166,90,167,90,168,90,169,90,171,90,172,90,173,90,174,90,175,90,176,90,177,90,180,90,182,90,183,90,185,90,186,90,187,90,188,90,189,90,191,90,192,90,195,90,196,90,197,90,198,90,199,90,200,90,202,90,203,90,205,90,206,90,207,90,208,90,209,90,211,90,213,90,215,90,217,90,218,90,219,90,221,90,222,90,223,90,226,90,228,90,229,90,231,90,232,90,234,90,236,90,237,90,238,90,239,90,240,90,242,90,243,90,244,90,245,90,246,90,247,90,248,90,249,90,250,90,251,90,252,90,253,90,254,90,255,90,0,91,1,91,2,91,3,91,4,91,5,91,6,91,7,91,8,91,10,91,11,91,12,91,13,91,14,91,15,91,16,91,17,91,18,91,19,91,20,91,21,91,24,91,25,91,26,91,27,91,28,91,29,91,30,91,31,91,32,91,33,91,34,91,35,91,36,91,37,91,38,91,39,91,40,91,41,91,42,91,43,91,44,91,45,91,46,91,47,91,48,91,49,91,51,91,53,91,54,91,56,91,57,91,58,91,59,91,60,91,61,91,62,91,63,91,65,91,66,91,67,91,68,91,69,91,70,91,71,91,72,91,73,91,74,91,75,91,76,91,77,91,78,91,79,91,82,91,86,91,94,91,96,91,97,91,103,91,104,91,107,91,109,91,110,91,111,91,114,91,116,91,118,91,119,91,120,91,121,91,123,91,124,91,126,91,127,91,130,91,134,91,138,91,141,91,142,91,144,91,145,91,146,91,148,91,150,91,159,91,167,91,168,91,169,91,172,91,173,91,174,91,175,91,177,91,178,91,183,91,186,91,187,91,188,91,192,91,193,91,195,91,200,91,201,91,202,91,203,91,205,91,206,91,207,91,209,91,212,91,213,91,214,91,215,91,216,91,217,91,218,91,219,91,220,91,224,91,226,91,227,91,230,91,231,91,233,91,234,91,235,91,236,91,237,91,239,91,241,91,242,91,243,91,244,91,245,91,246,91,247,91,253,91,254,91,0,92,2,92,3,92,5,92,7,92,8,92,11,92,12,92,13,92,14,92,16,92,18,92,19,92,23,92,25,92,27,92,30,92,31,92,32,92,33,92,35,92,38,92,40,92,41,92,42,92,43,92,45,92,46,92,47,92,48,92,50,92,51,92,53,92,54,92,55,92,67,92,68,92,70,92,71,92,76,92,77,92,82,92,83,92,84,92,86,92,87,92,88,92,90,92,91,92,92,92,93,92,95,92,98,92,100,92,103,92,104,92,105,92,106,92,107,92,108,92,109,92,112,92,114,92,115,92,116,92,117,92,118,92,119,92,120,92,123,92,124,92,125,92,126,92,128,92,131,92,132,92,133,92,134,92,135,92,137,92,138,92,139,92,142,92,143,92,146,92,147,92,149,92,157,92,158,92,159,92,160,92,161,92,164,92,165,92,166,92,167,92,168,92,170,92,174,92,175,92,176,92,178,92,180,92,182,92,185,92,186,92,187,92,188,92,190,92,192,92,194,92,195,92,197,92,198,92,199,92,200,92,201,92,202,92,204,92,205,92,206,92,207,92,208,92,209,92,211,92,212,92,213,92,214,92,215,92,216,92,218,92,219,92,220,92,221,92,222,92,223,92,224,92,226,92,227,92,231,92,233,92,235,92,236,92,238,92,239,92,241,92,242,92,243,92,244,92,245,92,246,92,247,92,248,92,249,92,250,92,252,92,253,92,254,92,255,92,0,93,1,93,4,93,5,93,8,93,9,93,10,93,11,93,12,93,13,93,15,93,16,93,17,93,18,93,19,93,21,93,23,93,24,93,25,93,26,93,28,93,29,93,31,93,32,93,33,93,34,93,35,93,37,93,40,93,42,93,43,93,44,93,47,93,48,93,49,93,50,93,51,93,53,93,54,93,55,93,56,93,57,93,58,93,59,93,60,93,63,93,64,93,65,93,66,93,67,93,68,93,69,93,70,93,72,93,73,93,77,93,78,93,79,93,80,93,81,93,82,93,83,93,84,93,85,93,86,93,87,93,89,93,90,93,92,93,94,93,95,93,96,93,97,93,98,93,99,93,100,93,101,93,102,93,103,93,104,93,106,93,109,93,110,93,112,93,113,93,114,93,115,93,117,93,118,93,119,93,120,93,121,93,122,93,123,93,124,93,125,93,126,93,127,93,128,93,129,93,131,93,132,93,133,93,134,93,135,93,136,93,137,93,138,93,139,93,140,93,141,93,142,93,143,93,144,93,145,93,146,93,147,93,148,93,149,93,150,93,151,93,152,93,154,93,155,93,156,93,158,93,159,93,160,93,161,93,162,93,163,93,164,93,165,93,166,93,167,93,168,93,169,93,170,93,171,93,172,93,173,93,174,93,175,93,176,93,177,93,178,93,179,93,180,93,181,93,182,93,184,93,185,93,186,93,187,93,188,93,189,93,190,93,191,93,192,93,193,93,194,93,195,93,196,93,198,93,199,93,200,93,201,93,202,93,203,93,204,93,206,93,207,93,208,93,209,93,210,93,211,93,212,93,213,93,214,93,215,93,216,93,217,93,218,93,220,93,223,93,224,93,227,93,228,93,234,93,236,93,237,93,240,93,245,93,246,93,248,93,249,93,250,93,251,93,252,93,255,93,0,94,4,94,7,94,9,94,10,94,11,94,13,94,14,94,18,94,19,94,23,94,30,94,31,94,32,94,33,94,34,94,35,94,36,94,37,94,40,94,41,94,42,94,43,94,44,94,47,94,48,94,50,94,51,94,52,94,53,94,54,94,57,94,58,94,62,94,63,94,64,94,65,94,67,94,70,94,71,94,72,94,73,94,74,94,75,94,77,94,78,94,79,94,80,94,81,94,82,94,83,94,86,94,87,94,88,94,89,94,90,94,92,94,93,94,95,94,96,94,99,94,100,94,101,94,102,94,103,94,104,94,105,94,106,94,107,94,108,94,109,94,110,94,111,94,112,94,113,94,117,94,119,94,121,94,126,94,129,94,130,94,131,94,133,94,136,94,137,94,140,94,141,94,142,94,146,94,152,94,155,94,157,94,161,94,162,94,163,94,164,94,168,94,169,94,170,94,171,94,172,94,174,94,175,94,176,94,177,94,178,94,180,94,186,94,187,94,188,94,189,94,191,94,192,94,193,94,194,94,195,94,196,94,197,94,198,94,199,94,200,94,203,94,204,94,205,94,206,94,207,94,208,94,212,94,213,94,215,94,216,94,217,94,218,94,220,94,221,94,222,94,223,94,224,94,225,94,226,94,227,94,228,94,229,94,230,94,231,94,233,94,235,94,236,94,237,94,238,94,239,94,240,94,241,94,242,94,243,94,245,94,248,94,249,94,251,94,252,94,253,94,5,95,6,95,7,95,9,95,12,95,13,95,14,95,16,95,18,95,20,95,22,95,25,95,26,95,28,95,29,95,30,95,33,95,34,95,35,95,36,95,40,95,43,95,44,95,46,95,48,95,50,95,51,95,52,95,53,95,54,95,55,95,56,95,59,95,61,95,62,95,63,95,65,95,66,95,67,95,68,95,69,95,70,95,71,95,72,95,73,95,74,95,75,95,76,95,77,95,78,95,79,95,81,95,84,95,89,95,90,95,91,95,92,95,94,95,95,95,96,95,99,95,101,95,103,95,104,95,107,95,110,95,111,95,114,95,116,95,117,95,118,95,120,95,122,95,125,95,126,95,127,95,131,95,134,95,141,95,142,95,143,95,145,95,147,95,148,95,150,95,154,95,155,95,157,95,158,95,159,95,160,95,162,95,163,95,164,95,165,95,166,95,167,95,169,95,171,95,172,95,175,95,176,95,177,95,178,95,179,95,180,95,182,95,184,95,185,95,186,95,187,95,190,95,191,95,192,95,193,95,194,95,199,95,200,95,202,95,203,95,206,95,211,95,212,95,213,95,218,95,219,95,220,95,222,95,223,95,226,95,227,95,229,95,230,95,232,95,233,95,236,95,239,95,240,95,242,95,243,95,244,95,246,95,247,95,249,95,250,95,252,95,7,96,8,96,9,96,11,96,12,96,16,96,17,96,19,96,23,96,24,96,26,96,30,96,31,96,34,96,35,96,36,96,44,96,45,96,46,96,48,96,49,96,50,96,51,96,52,96,54,96,55,96,56,96,57,96,58,96,61,96,62,96,64,96,68,96,69,96,70,96,71,96,72,96,73,96,74,96,76,96,78,96,79,96,81,96,83,96,84,96,86,96,87,96,88,96,91,96,92,96,94,96,95,96,96,96,97,96,101,96,102,96,110,96,113,96,114,96,116,96,117,96,119,96,126,96,128,96,129,96,130,96,133,96,134,96,135,96,136,96,138,96,139,96,142,96,143,96,144,96,145,96,147,96,149,96,151,96,152,96,153,96,156,96,158,96,161,96,162,96,164,96,165,96,167,96,169,96,170,96,174,96,176,96,179,96,181,96,182,96,183,96,185,96,186,96,189,96,190,96,191,96,192,96,193,96,194,96,195,96,196,96,199,96,200,96,201,96,204,96,205,96,206,96,207,96,208,96,210,96,211,96,212,96,214,96,215,96,217,96,219,96,222,96,225,96,226,96,227,96,228,96,229,96,234,96,241,96,242,96,245,96,247,96,248,96,251,96,252,96,253,96,254,96,255,96,2,97,3,97,4,97,5,97,7,97,10,97,11,97,12,97,16,97,17,97,18,97,19,97,20,97,22,97,23,97,24,97,25,97,27,97,28,97,29,97,30,97,33,97,34,97,37,97,40,97,41,97,42,97,44,97,45,97,46,97,47,97,48,97,49,97,50,97,51,97,52,97,53,97,54,97,55,97,56,97,57,97,58,97,59,97,60,97,61,97,62,97,64,97,65,97,66,97,67,97,68,97,69,97,70,97,71,97,73,97,75,97,77,97,79,97,80,97,82,97,83,97,84,97,86,97,87,97,88,97,89,97,90,97,91,97,92,97,94,97,95,97,96,97,97,97,99,97,100,97,101,97,102,97,105,97,106,97,107,97,108,97,109,97,110,97,111,97,113,97,114,97,115,97,116,97,118,97,120,97,121,97,122,97,123,97,124,97,125,97,126,97,127,97,128,97,129,97,130,97,131,97,132,97,133,97,134,97,135,97,136,97,137,97,138,97,140,97,141,97,143,97,144,97,145,97,146,97,147,97,149,97,150,97,151,97,152,97,153,97,154,97,155,97,156,97,158,97,159,97,160,97,161,97,162,97,163,97,164,97,165,97,166,97,170,97,171,97,173,97,174,97,175,97,176,97,177,97,178,97,179,97,180,97,181,97,182,97,184,97,185,97,186,97,187,97,188,97,189,97,191,97,192,97,193,97,195,97,196,97,197,97,198,97,199,97,201,97,204,97,205,97,206,97,207,97,208,97,211,97,213,97,214,97,215,97,216,97,217,97,218,97,219,97,220,97,221,97,222,97,223,97,224,97,225,97,226,97,227,97,228,97,229,97,231,97,232,97,233,97,234,97,235,97,236,97,237,97,238,97,239,97,240,97,241,97,242,97,243,97,244,97,246,97,247,97,248,97,249,97,250,97,251,97,252,97,253,97,254,97,0,98,1,98,2,98,3,98,4,98,5,98,7,98,9,98,19,98,20,98,25,98,28,98,29,98,30,98,32,98,35,98,38,98,39,98,40,98,41,98,43,98,45,98,47,98,48,98,49,98,50,98,53,98,54,98,56,98,57,98,58,98,59,98,60,98,66,98,68,98,69,98,70,98,74,98,79,98,80,98,85,98,86,98,87,98,89,98,90,98,92,98,93,98,94,98,95,98,96,98,97,98,98,98,100,98,101,98,104,98,113,98,114,98,116,98,117,98,119,98,120,98,122,98,123,98,125,98,129,98,130,98,131,98,133,98,134,98,135,98,136,98,139,98,140,98,141,98,142,98,143,98,144,98,148,98,153,98,156,98,157,98,158,98,163,98,166,98,167,98,169,98,170,98,173,98,174,98,175,98,176,98,178,98,179,98,180,98,182,98,183,98,184,98,186,98,190,98,192,98,193,98,195,98,203,98,207,98,209,98,213,98,221,98,222,98,224,98,225,98,228,98,234,98,235,98,240,98,242,98,245,98,248,98,249,98,250,98,251,98,0,99,3,99,4,99,5,99,6,99,10,99,11,99,12,99,13,99,15,99,16,99,18,99,19,99,20,99,21,99,23,99,24,99,25,99,28,99,38,99,39,99,41,99,44,99,45,99,46,99,48,99,49,99,51,99,52,99,53,99,54,99,55,99,56,99,59,99,60,99,62,99,63,99,64,99,65,99,68,99,71,99,72,99,74,99,81,99,82,99,83,99,84,99,86,99,87,99,88,99,89,99,90,99,91,99,92,99,93,99,96,99,100,99,101,99,102,99,104,99,106,99,107,99,108,99,111,99,112,99,114,99,115,99,116,99,117,99,120,99,121,99,124,99,125,99,126,99,127,99,129,99,131,99,132,99,133,99,134,99,139,99,141,99,145,99,147,99,148,99,149,99,151,99,153,99,154,99,155,99,156,99,157,99,158,99,159,99,161,99,164,99,166,99,171,99,175,99,177,99,178,99,181,99,182,99,185,99,187,99,189,99,191,99,192,99,193,99,194,99,195,99,197,99,199,99,200,99,202,99,203,99,204,99,209,99,211,99,212,99,213,99,215,99,216,99,217,99,218,99,219,99,220,99,221,99,223,99,226,99,228,99,229,99,230,99,231,99,232,99,235,99,236,99,238,99,239,99,240,99,241,99,243,99,245,99,247,99,249,99,250,99,251,99,252,99,254,99,3,100,4,100,6,100,7,100,8,100,9,100,10,100,13,100,14,100,17,100,18,100,21,100,22,100,23,100,24,100,25,100,26,100,29,100,31,100,34,100,35,100,36,100,37,100,39,100,40,100,41,100,43,100,46,100,47,100,48,100,49,100,50,100,51,100,53,100,54,100,55,100,56,100,57,100,59,100,60,100,62,100,64,100,66,100,67,100,73,100,75,100,76,100,77,100,78,100,79,100,80,100,81,100,83,100,85,100,86,100,87,100,89,100,90,100,91,100,92,100,93,100,95,100,96,100,97,100,98,100,99,100,100,100,101,100,102,100,104,100,106,100,107,100,108,100,110,100,111,100,112,100,113,100,114,100,115,100,116,100,117,100,118,100,119,100,123,100,124,100,125,100,126,100,127,100,128,100,129,100,131,100,134,100,136,100,137,100,138,100,139,100,140,100,141,100,142,100,143,100,144,100,147,100,148,100,151,100,152,100,154,100,155,100,156,100,157,100,159,100,160,100,161,100,162,100,163,100,165,100,166,100,167,100,168,100,170,100,171,100,175,100,177,100,178,100,179,100,180,100,182,100,185,100,187,100,189,100,190,100,191,100,193,100,195,100,196,100,198,100,199,100,200,100,201,100,202,100,203,100,204,100,207,100,209,100,211,100,212,100,213,100,214,100,217,100,218,100,219,100,220,100,221,100,223,100,224,100,225,100,227,100,229,100,231,100,232,100,233,100,234,100,235,100,236,100,237,100,238,100,239,100,240,100,241,100,242,100,243,100,244,100,245,100,246,100,247,100,248,100,249,100,250,100,251,100,252,100,253,100,254,100,255,100,1,101,2,101,3,101,4,101,5,101,6,101,7,101,8,101,10,101,11,101,12,101,13,101,14,101,15,101,16,101,17,101,19,101,20,101,21,101,22,101,23,101,25,101,26,101,27,101,28,101,29,101,30,101,31,101,32,101,33,101,34,101,35,101,36,101,38,101,39,101,40,101,41,101,42,101,44,101,45,101,48,101,49,101,50,101,51,101,55,101,58,101,60,101,61,101,64,101,65,101,66,101,67,101,68,101,70,101,71,101,74,101,75,101,77,101,78,101,80,101,82,101,83,101,84,101,87,101,88,101,90,101,92,101,95,101,96,101,97,101,100,101,101,101,103,101,104,101,105,101,106,101,109,101,110,101,111,101,113,101,115,101,117,101,118,101,120,101,121,101,122,101,123,101,124,101,125,101,126,101,127,101,128,101,129,101,130,101,131,101,132,101,133,101,134,101,136,101,137,101,138,101,141,101,142,101,143,101,146,101,148,101,149,101,150,101,152,101,154,101,157,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+220348),
	allocate([158,101,160,101,162,101,163,101,166,101,168,101,170,101,172,101,174,101,177,101,178,101,179,101,180,101,181,101,182,101,183,101,184,101,186,101,187,101,190,101,191,101,192,101,194,101,199,101,200,101,201,101,202,101,205,101,208,101,209,101,211,101,212,101,213,101,216,101,217,101,218,101,219,101,220,101,221,101,222,101,223,101,225,101,227,101,228,101,234,101,235,101,242,101,243,101,244,101,245,101,248,101,249,101,251,101,252,101,253,101,254,101,255,101,1,102,4,102,5,102,7,102,8,102,9,102,11,102,13,102,16,102,17,102,18,102,22,102,23,102,24,102,26,102,27,102,28,102,30,102,33,102,34,102,35,102,36,102,38,102,41,102,42,102,43,102,44,102,46,102,48,102,50,102,51,102,55,102,56,102,57,102,58,102,59,102,61,102,63,102,64,102,66,102,68,102,69,102,70,102,71,102,72,102,73,102,74,102,77,102,78,102,80,102,81,102,88,102,89,102,91,102,92,102,93,102,94,102,96,102,98,102,99,102,101,102,103,102,105,102,106,102,107,102,108,102,109,102,113,102,114,102,115,102,117,102,120,102,121,102,123,102,124,102,125,102,127,102,128,102,129,102,131,102,133,102,134,102,136,102,137,102,138,102,139,102,141,102,142,102,143,102,144,102,146,102,147,102,148,102,149,102,152,102,153,102,154,102,155,102,156,102,158,102,159,102,160,102,161,102,162,102,163,102,164,102,165,102,166,102,169,102,170,102,171,102,172,102,173,102,175,102,176,102,177,102,178,102,179,102,181,102,182,102,183,102,184,102,186,102,187,102,188,102,189,102,191,102,192,102,193,102,194,102,195,102,196,102,197,102,198,102,199,102,200,102,201,102,202,102,203,102,204,102,205,102,206,102,207,102,208,102,209,102,210,102,211,102,212,102,213,102,214,102,215,102,216,102,218,102,222,102,223,102,224,102,225,102,226,102,227,102,228,102,229,102,231,102,232,102,234,102,235,102,236,102,237,102,238,102,239,102,241,102,245,102,246,102,248,102,250,102,251,102,253,102,1,103,2,103,3,103,4,103,5,103,6,103,7,103,12,103,14,103,15,103,17,103,18,103,19,103,22,103,24,103,25,103,26,103,28,103,30,103,32,103,33,103,34,103,35,103,36,103,37,103,39,103,41,103,46,103,48,103,50,103,51,103,54,103,55,103,56,103,57,103,59,103,60,103,62,103,63,103,65,103,68,103,69,103,71,103,74,103,75,103,77,103,82,103,84,103,85,103,87,103,88,103,89,103,90,103,91,103,93,103,98,103,99,103,100,103,102,103,103,103,107,103,108,103,110,103,113,103,116,103,118,103,120,103,121,103,122,103,123,103,125,103,128,103,130,103,131,103,133,103,134,103,136,103,138,103,140,103,141,103,142,103,143,103,145,103,146,103,147,103,148,103,150,103,153,103,155,103,159,103,160,103,161,103,164,103,166,103,169,103,172,103,174,103,177,103,178,103,180,103,185,103,186,103,187,103,188,103,189,103,190,103,191,103,192,103,194,103,197,103,198,103,199,103,200,103,201,103,202,103,203,103,204,103,205,103,206,103,213,103,214,103,215,103,219,103,223,103,225,103,227,103,228,103,230,103,231,103,232,103,234,103,235,103,237,103,238,103,242,103,245,103,246,103,247,103,248,103,249,103,250,103,251,103,252,103,254,103,1,104,2,104,3,104,4,104,6,104,13,104,16,104,18,104,20,104,21,104,24,104,25,104,26,104,27,104,28,104,30,104,31,104,32,104,34,104,35,104,36,104,37,104,38,104,39,104,40,104,43,104,44,104,45,104,46,104,47,104,48,104,49,104,52,104,53,104,54,104,58,104,59,104,63,104,71,104,75,104,77,104,79,104,82,104,86,104,87,104,88,104,89,104,90,104,91,104,92,104,93,104,94,104,95,104,106,104,108,104,109,104,110,104,111,104,112,104,113,104,114,104,115,104,117,104,120,104,121,104,122,104,123,104,124,104,125,104,126,104,127,104,128,104,130,104,132,104,135,104,136,104,137,104,138,104,139,104,140,104,141,104,142,104,144,104,145,104,146,104,148,104,149,104,150,104,152,104,153,104,154,104,155,104,156,104,157,104,158,104,159,104,160,104,161,104,163,104,164,104,165,104,169,104,170,104,171,104,172,104,174,104,177,104,178,104,180,104,182,104,183,104,184,104,185,104,186,104,187,104,188,104,189,104,190,104,191,104,193,104,195,104,196,104,197,104,198,104,199,104,200,104,202,104,204,104,206,104,207,104,208,104,209,104,211,104,212,104,214,104,215,104,217,104,219,104,220,104,221,104,222,104,223,104,225,104,226,104,228,104,229,104,230,104,231,104,232,104,233,104,234,104,235,104,236,104,237,104,239,104,242,104,243,104,244,104,246,104,247,104,248,104,251,104,253,104,254,104,255,104,0,105,2,105,3,105,4,105,6,105,7,105,8,105,9,105,10,105,12,105,15,105,17,105,19,105,20,105,21,105,22,105,23,105,24,105,25,105,26,105,27,105,28,105,29,105,30,105,33,105,34,105,35,105,37,105,38,105,39,105,40,105,41,105,42,105,43,105,44,105,46,105,47,105,49,105,50,105,51,105,53,105,54,105,55,105,56,105,58,105,59,105,60,105,62,105,64,105,65,105,67,105,68,105,69,105,70,105,71,105,72,105,73,105,74,105,75,105,76,105,77,105,78,105,79,105,80,105,81,105,82,105,83,105,85,105,86,105,88,105,89,105,91,105,92,105,95,105,97,105,98,105,100,105,101,105,103,105,104,105,105,105,106,105,108,105,109,105,111,105,112,105,114,105,115,105,116,105,117,105,118,105,122,105,123,105,125,105,126,105,127,105,129,105,131,105,133,105,138,105,139,105,140,105,142,105,143,105,144,105,145,105,146,105,147,105,150,105,151,105,153,105,154,105,157,105,158,105,159,105,160,105,161,105,162,105,163,105,164,105,165,105,166,105,169,105,170,105,172,105,174,105,175,105,176,105,178,105,179,105,181,105,182,105,184,105,185,105,186,105,188,105,189,105,190,105,191,105,192,105,194,105,195,105,196,105,197,105,198,105,199,105,200,105,201,105,203,105,205,105,207,105,209,105,210,105,211,105,213,105,214,105,215,105,216,105,217,105,218,105,220,105,221,105,222,105,225,105,226,105,227,105,228,105,229,105,230,105,231,105,232,105,233,105,234,105,235,105,236,105,238,105,239,105,240,105,241,105,243,105,244,105,245,105,246,105,247,105,248,105,249,105,250,105,251,105,252,105,254,105,0,106,1,106,2,106,3,106,4,106,5,106,6,106,7,106,8,106,9,106,11,106,12,106,13,106,14,106,15,106,16,106,17,106,18,106,19,106,20,106,21,106,22,106,25,106,26,106,27,106,28,106,29,106,30,106,32,106,34,106,35,106,36,106,37,106,38,106,39,106,41,106,43,106,44,106,45,106,46,106,48,106,50,106,51,106,52,106,54,106,55,106,56,106,57,106,58,106,59,106,60,106,63,106,64,106,65,106,66,106,67,106,69,106,70,106,72,106,73,106,74,106,75,106,76,106,77,106,78,106,79,106,81,106,82,106,83,106,84,106,85,106,86,106,87,106,90,106,92,106,93,106,94,106,95,106,96,106,98,106,99,106,100,106,102,106,103,106,104,106,105,106,106,106,107,106,108,106,109,106,110,106,111,106,112,106,114,106,115,106,116,106,117,106,118,106,119,106,120,106,122,106,123,106,125,106,126,106,127,106,129,106,130,106,131,106,133,106,134,106,135,106,136,106,137,106,138,106,139,106,140,106,141,106,143,106,146,106,147,106,148,106,149,106,150,106,152,106,153,106,154,106,155,106,156,106,157,106,158,106,159,106,161,106,162,106,163,106,164,106,165,106,166,106,167,106,168,106,170,106,173,106,174,106,175,106,176,106,177,106,178,106,179,106,180,106,181,106,182,106,183,106,184,106,185,106,186,106,187,106,188,106,189,106,190,106,191,106,192,106,193,106,194,106,195,106,196,106,197,106,198,106,199,106,200,106,201,106,202,106,203,106,204,106,205,106,206,106,207,106,208,106,209,106,210,106,211,106,212,106,213,106,214,106,215,106,216,106,217,106,218,106,219,106,220,106,221,106,222,106,223,106,224,106,225,106,226,106,227,106,228,106,229,106,230,106,231,106,232,106,233,106,234,106,235,106,236,106,237,106,238,106,239,106,240,106,241,106,242,106,243,106,244,106,245,106,246,106,247,106,248,106,249,106,250,106,251,106,252,106,253,106,254,106,255,106,0,107,1,107,2,107,3,107,4,107,5,107,6,107,7,107,8,107,9,107,10,107,11,107,12,107,13,107,14,107,15,107,16,107,17,107,18,107,19,107,20,107,21,107,22,107,23,107,24,107,25,107,26,107,27,107,28,107,29,107,30,107,31,107,37,107,38,107,40,107,41,107,42,107,43,107,44,107,45,107,46,107,47,107,48,107,49,107,51,107,52,107,53,107,54,107,56,107,59,107,60,107,61,107,63,107,64,107,65,107,66,107,68,107,69,107,72,107,74,107,75,107,77,107,78,107,79,107,80,107,81,107,82,107,83,107,84,107,85,107,86,107,87,107,88,107,90,107,91,107,92,107,93,107,94,107,95,107,96,107,97,107,104,107,105,107,107,107,108,107,109,107,110,107,111,107,112,107,113,107,114,107,115,107,116,107,117,107,118,107,119,107,120,107,122,107,125,107,126,107,127,107,128,107,133,107,136,107,140,107,142,107,143,107,144,107,145,107,148,107,149,107,151,107,152,107,153,107,156,107,157,107,158,107,159,107,160,107,162,107,163,107,164,107,165,107,166,107,167,107,168,107,169,107,171,107,172,107,173,107,174,107,175,107,176,107,177,107,178,107,182,107,184,107,185,107,186,107,187,107,188,107,189,107,190,107,192,107,195,107,196,107,198,107,199,107,200,107,201,107,202,107,204,107,206,107,208,107,209,107,216,107,218,107,220,107,221,107,222,107,223,107,224,107,226,107,227,107,228,107,229,107,230,107,231,107,232,107,233,107,236,107,237,107,238,107,240,107,241,107,242,107,244,107,246,107,247,107,248,107,250,107,251,107,252,107,254,107,255,107,0,108,1,108,2,108,3,108,4,108,8,108,9,108,10,108,11,108,12,108,14,108,18,108,23,108,28,108,29,108,30,108,32,108,35,108,37,108,43,108,44,108,45,108,49,108,51,108,54,108,55,108,57,108,58,108,59,108,60,108,62,108,63,108,67,108,68,108,69,108,72,108,75,108,76,108,77,108,78,108,79,108,81,108,82,108,83,108,86,108,88,108,89,108,90,108,98,108,99,108,101,108,102,108,103,108,107,108,108,108,109,108,110,108,111,108,113,108,115,108,117,108,119,108,120,108,122,108,123,108,124,108,127,108,128,108,132,108,135,108,138,108,139,108,141,108,142,108,145,108,146,108,149,108,150,108,151,108,152,108,154,108,156,108,157,108,158,108,160,108,162,108,168,108,172,108,175,108,176,108,180,108,181,108,182,108,183,108,186,108,192,108,193,108,194,108,195,108,198,108,199,108,200,108,203,108,205,108,206,108,207,108,209,108,210,108,216,108,217,108,218,108,220,108,221,108,223,108,228,108,230,108,231,108,233,108,236,108,237,108,242,108,244,108,249,108,255,108,0,109,2,109,3,109,5,109,6,109,8,109,9,109,10,109,13,109,15,109,16,109,17,109,19,109,20,109,21,109,22,109,24,109,28,109,29,109,31,109,32,109,33,109,34,109,35,109,36,109,38,109,40,109,41,109,44,109,45,109,47,109,48,109,52,109,54,109,55,109,56,109,58,109,63,109,64,109,66,109,68,109,73,109,76,109,80,109,85,109,86,109,87,109,88,109,91,109,93,109,95,109,97,109,98,109,100,109,101,109,103,109,104,109,107,109,108,109,109,109,112,109,113,109,114,109,115,109,117,109,118,109,121,109,122,109,123,109,125,109,126,109,127,109,128,109,129,109,131,109,132,109,134,109,135,109,138,109,139,109,141,109,143,109,144,109,146,109,150,109,151,109,152,109,153,109,154,109,156,109,162,109,165,109,172,109,173,109,176,109,177,109,179,109,180,109,182,109,183,109,185,109,186,109,187,109,188,109,189,109,190,109,193,109,194,109,195,109,200,109,201,109,202,109,205,109,206,109,207,109,208,109,210,109,211,109,212,109,213,109,215,109,218,109,219,109,220,109,223,109,226,109,227,109,229,109,231,109,232,109,233,109,234,109,237,109,239,109,240,109,242,109,244,109,245,109,246,109,248,109,250,109,253,109,254,109,255,109,0,110,1,110,2,110,3,110,4,110,6,110,7,110,8,110,9,110,11,110,15,110,18,110,19,110,21,110,24,110,25,110,27,110,28,110,30,110,31,110,34,110,38,110,39,110,40,110,42,110,44,110,46,110,48,110,49,110,51,110,53,110,54,110,55,110,57,110,59,110,60,110,61,110,62,110,63,110,64,110,65,110,66,110,69,110,70,110,71,110,72,110,73,110,74,110,75,110,76,110,79,110,80,110,81,110,82,110,85,110,87,110,89,110,90,110,92,110,93,110,94,110,96,110,97,110,98,110,99,110,100,110,101,110,102,110,103,110,104,110,105,110,106,110,108,110,109,110,111,110,112,110,113,110,114,110,115,110,116,110,117,110,118,110,119,110,120,110,121,110,122,110,123,110,124,110,125,110,128,110,129,110,130,110,132,110,135,110,136,110,138,110,139,110,140,110,141,110,142,110,145,110,146,110,147,110,148,110,149,110,150,110,151,110,153,110,154,110,155,110,157,110,158,110,160,110,161,110,163,110,164,110,166,110,168,110,169,110,171,110,172,110,173,110,174,110,176,110,179,110,181,110,184,110,185,110,188,110,190,110,191,110,192,110,195,110,196,110,197,110,198,110,200,110,201,110,202,110,204,110,205,110,206,110,208,110,210,110,214,110,216,110,217,110,219,110,220,110,221,110,227,110,231,110,234,110,235,110,236,110,237,110,238,110,239,110,240,110,241,110,242,110,243,110,245,110,246,110,247,110,248,110,250,110,251,110,252,110,253,110,254,110,255,110,0,111,1,111,3,111,4,111,5,111,7,111,8,111,10,111,11,111,12,111,13,111,14,111,16,111,17,111,18,111,22,111,23,111,24,111,25,111,26,111,27,111,28,111,29,111,30,111,31,111,33,111,34,111,35,111,37,111,38,111,39,111,40,111,44,111,46,111,48,111,50,111,52,111,53,111,55,111,56,111,57,111,58,111,59,111,60,111,61,111,63,111,64,111,65,111,66,111,67,111,68,111,69,111,72,111,73,111,74,111,76,111,78,111,79,111,80,111,81,111,82,111,83,111,84,111,85,111,86,111,87,111,89,111,90,111,91,111,93,111,95,111,96,111,97,111,99,111,100,111,101,111,103,111,104,111,105,111,106,111,107,111,108,111,111,111,112,111,113,111,115,111,117,111,118,111,119,111,121,111,123,111,125,111,126,111,127,111,128,111,129,111,130,111,131,111,133,111,134,111,135,111,138,111,139,111,143,111,144,111,145,111,146,111,147,111,148,111,149,111,150,111,151,111,152,111,153,111,154,111,155,111,157,111,158,111,159,111,160,111,162,111,163,111,164,111,165,111,166,111,168,111,169,111,170,111,171,111,172,111,173,111,174,111,175,111,176,111,177,111,178,111,180,111,181,111,183,111,184,111,186,111,187,111,188,111,189,111,190,111,191,111,193,111,195,111,196,111,197,111,198,111,199,111,200,111,202,111,203,111,204,111,205,111,206,111,207,111,208,111,211,111,212,111,213,111,214,111,215,111,216,111,217,111,218,111,219,111,220,111,221,111,223,111,226,111,227,111,228,111,229,111,230,111,231,111,232,111,233,111,234,111,235,111,236,111,237,111,240,111,241,111,242,111,243,111,244,111,245,111,246,111,247,111,248,111,249,111,250,111,251,111,252,111,253,111,254,111,255,111,0,112,1,112,2,112,3,112,4,112,5,112,6,112,7,112,8,112,9,112,10,112,11,112,12,112,13,112,14,112,15,112,16,112,18,112,19,112,20,112,21,112,22,112,23,112,24,112,25,112,28,112,29,112,30,112,31,112,32,112,33,112,34,112,36,112,37,112,38,112,39,112,40,112,41,112,42,112,43,112,44,112,45,112,46,112,47,112,48,112,49,112,50,112,51,112,52,112,54,112,55,112,56,112,58,112,59,112,60,112,61,112,62,112,63,112,64,112,65,112,66,112,67,112,68,112,69,112,70,112,71,112,72,112,73,112,74,112,75,112,77,112,78,112,80,112,81,112,82,112,83,112,84,112,85,112,86,112,87,112,88,112,89,112,90,112,91,112,92,112,93,112,95,112,96,112,97,112,98,112,99,112,100,112,101,112,102,112,103,112,104,112,105,112,106,112,110,112,113,112,114,112,115,112,116,112,119,112,121,112,122,112,123,112,125,112,129,112,130,112,131,112,132,112,134,112,135,112,136,112,139,112,140,112,141,112,143,112,144,112,145,112,147,112,151,112,152,112,154,112,155,112,158,112,159,112,160,112,161,112,162,112,163,112,164,112,165,112,166,112,167,112,168,112,169,112,170,112,176,112,178,112,180,112,181,112,182,112,186,112,190,112,191,112,196,112,197,112,198,112,199,112,201,112,203,112,204,112,205,112,206,112,207,112,208,112,209,112,210,112,211,112,212,112,213,112,214,112,215,112,218,112,220,112,221,112,222,112,224,112,225,112,226,112,227,112,229,112,234,112,238,112,240,112,241,112,242,112,243,112,244,112,245,112,246,112,248,112,250,112,251,112,252,112,254,112,255,112,0,113,1,113,2,113,3,113,4,113,5,113,6,113,7,113,8,113,11,113,12,113,13,113,14,113,15,113,17,113,18,113,20,113,23,113,27,113,28,113,29,113,30,113,31,113,32,113,33,113,34,113,35,113,36,113,37,113,39,113,40,113,41,113,42,113,43,113,44,113,45,113,46,113,50,113,51,113,52,113,53,113,55,113,56,113,57,113,58,113,59,113,60,113,61,113,62,113,63,113,64,113,65,113,66,113,67,113,68,113,70,113,71,113,72,113,73,113,75,113,77,113,79,113,80,113,81,113,82,113,83,113,84,113,85,113,86,113,87,113,88,113,89,113,90,113,91,113,93,113,95,113,96,113,97,113,98,113,99,113,101,113,105,113,106,113,107,113,108,113,109,113,111,113,112,113,113,113,116,113,117,113,118,113,119,113,121,113,123,113,124,113,126,113,127,113,128,113,129,113,130,113,131,113,133,113,134,113,135,113,136,113,137,113,139,113,140,113,141,113,142,113,144,113,145,113,146,113,147,113,149,113,150,113,151,113,154,113,155,113,156,113,157,113,158,113,161,113,162,113,163,113,164,113,165,113,166,113,167,113,169,113,170,113,171,113,173,113,174,113,175,113,176,113,177,113,178,113,180,113,182,113,183,113,184,113,186,113,187,113,188,113,189,113,190,113,191,113,192,113,193,113,194,113,196,113,197,113,198,113,199,113,200,113,201,113,202,113,203,113,204,113,205,113,207,113,208,113,209,113,210,113,211,113,214,113,215,113,216,113,217,113,218,113,219,113,220,113,221,113,222,113,223,113,225,113,226,113,227,113,228,113,230,113,232,113,233,113,234,113,235,113,236,113,237,113,239,113,240,113,241,113,242,113,243,113,244,113,245,113,246,113,247,113,248,113,250,113,251,113,252,113,253,113,254,113,255,113,0,114,1,114,2,114,3,114,4,114,5,114,7,114,8,114,9,114,10,114,11,114,12,114,13,114,14,114,15,114,16,114,17,114,18,114,19,114,20,114,21,114,22,114,23,114,24,114,25,114,26,114,27,114,28,114,30,114,31,114,32,114,33,114,34,114,35,114,36,114,37,114,38,114,39,114,41,114,43,114,45,114,46,114,47,114,50,114,51,114,52,114,58,114,60,114,62,114,64,114,65,114,66,114,67,114,68,114,69,114,70,114,73,114,74,114,75,114,78,114,79,114,80,114,81,114,83,114,84,114,85,114,87,114,88,114,90,114,92,114,94,114,96,114,99,114,100,114,101,114,104,114,106,114,107,114,108,114,109,114,112,114,113,114,115,114,116,114,118,114,119,114,120,114,123,114,124,114,125,114,130,114,131,114,133,114,134,114,135,114,136,114,137,114,140,114,142,114,144,114,145,114,147,114,148,114,149,114,150,114,151,114,152,114,153,114,154,114,155,114,156,114,157,114,158,114,160,114,161,114,162,114,163,114,164,114,165,114,166,114,167,114,168,114,169,114,170,114,171,114,174,114,177,114,178,114,179,114,181,114,186,114,187,114,188,114,189,114,190,114,191,114,192,114,197,114,198,114,199,114,201,114,202,114,203,114,204,114,207,114,209,114,211,114,212,114,213,114,214,114,216,114,218,114,219,114,198,228,199,228,200,228,201,228,202,228,203,228,204,228,205,228,206,228,207,228,208,228,209,228,210,228,211,228,212,228,213,228,214,228,215,228,216,228,217,228,218,228,219,228,220,228,221,228,222,228,223,228,224,228,225,228,226,228,227,228,228,228,229,228,230,228,231,228,232,228,233,228,234,228,235,228,236,228,237,228,238,228,239,228,240,228,241,228,242,228,243,228,244,228,245,228,246,228,247,228,248,228,249,228,250,228,251,228,252,228,253,228,254,228,255,228,0,229,1,229,2,229,3,229,4,229,5,229,6,229,7,229,8,229,9,229,10,229,11,229,12,229,13,229,14,229,15,229,16,229,17,229,18,229,19,229,20,229,21,229,22,229,23,229,24,229,25,229,26,229,27,229,28,229,29,229,30,229,31,229,32,229,33,229,34,229,35,229,36,229,37,229,0,48,1,48,2,48,183,0,201,2,199,2,168,0,3,48,5,48,20,32,94,255,22,32,38,32,24,32,25,32,28,32,29,32,20,48,21,48,8,48,9,48,10,48,11,48,12,48,13,48,14,48,15,48,22,48,23,48,16,48,17,48,177,0,215,0,247,0,54,34,39,34,40,34,17,34,15,34,42,34,41,34,8,34,55,34,26,34,165,34,37,34,32,34,18,35,153,34,43,34,46,34,97,34,76,34,72,34,61,34,29,34,96,34,110,34,111,34,100,34,101,34,30,34,53,34,52,34,66,38,64,38,176,0,50,32,51,32,3,33,4,255,164,0,224,255,225,255,48,32,167,0,22,33,6,38,5,38,203,37,207,37,206,37,199,37,198,37,161,37,160,37,179,37,178,37,59,32,146,33,144,33,145,33,147,33,19,48,38,229,39,229,40,229,41,229,42,229,43,229,44,229,45,229,46,229,47,229,48,229,49,229,50,229,51,229,52,229,53,229,54,229,55,229,56,229,57,229,58,229,59,229,60,229,61,229,62,229,63,229,64,229,65,229,66,229,67,229,68,229,69,229,70,229,71,229,72,229,73,229,74,229,75,229,76,229,77,229,78,229,79,229,80,229,81,229,82,229,83,229,84,229,85,229,86,229,87,229,88,229,89,229,90,229,91,229,92,229,93,229,94,229,95,229,96,229,97,229,98,229,99,229,100,229,101,229,102,229,103,229,104,229,105,229,106,229,107,229,108,229,109,229,110,229,111,229,112,229,113,229,114,229,115,229,116,229,117,229,118,229,119,229,120,229,121,229,122,229,123,229,124,229,125,229,126,229,127,229,128,229,129,229,130,229,131,229,132,229,133,229,112,33,113,33,114,33,115,33,116,33,117,33,118,33,119,33,120,33,121,33,102,231,103,231,104,231,105,231,106,231,107,231,136,36,137,36,138,36,139,36,140,36,141,36,142,36,143,36,144,36,145,36,146,36,147,36,148,36,149,36,150,36,151,36,152,36,153,36,154,36,155,36,116,36,117,36,118,36,119,36,120,36,121,36,122,36,123,36,124,36,125,36,126,36,127,36,128,36,129,36,130,36,131,36,132,36,133,36,134,36,135,36,96,36,97,36,98,36,99,36,100,36,101,36,102,36,103,36,104,36,105,36,172,32,109,231,32,50,33,50,34,50,35,50,36,50,37,50,38,50,39,50,40,50,41,50,110,231,111,231,96,33,97,33,98,33,99,33,100,33,101,33,102,33,103,33,104,33,105,33,106,33,107,33,112,231,113,231,134,229,135,229,136,229,137,229,138,229,139,229,140,229,141,229,142,229,143,229,144,229,145,229,146,229,147,229,148,229,149,229,150,229,151,229,152,229,153,229,154,229,155,229,156,229,157,229,158,229,159,229,160,229,161,229,162,229,163,229,164,229,165,229,166,229,167,229,168,229,169,229,170,229,171,229,172,229,173,229,174,229,175,229,176,229,177,229,178,229,179,229,180,229,181,229,182,229,183,229,184,229,185,229,186,229,187,229,188,229,189,229,190,229,191,229,192,229,193,229,194,229,195,229,196,229,197,229,198,229,199,229,200,229,201,229,202,229,203,229,204,229,205,229,206,229,207,229,208,229,209,229,210,229,211,229,212,229,213,229,214,229,215,229,216,229,217,229,218,229,219,229,220,229,221,229,222,229,223,229,224,229,225,229,226,229,227,229,228,229,229,229,1,255,2,255,3,255,229,255,5,255,6,255,7,255,8,255,9,255,10,255,11,255,12,255,13,255,14,255,15,255,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255,24,255,25,255,26,255,27,255,28,255,29,255,30,255,31,255,32,255,33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,59,255,60,255,61,255,62,255,63,255,64,255,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,91,255,92,255,93,255,227,255,230,229,231,229,232,229,233,229,234,229,235,229,236,229,237,229,238,229,239,229,240,229,241,229,242,229,243,229,244,229,245,229,246,229,247,229,248,229,249,229,250,229,251,229,252,229,253,229,254,229,255,229,0,230,1,230,2,230,3,230,4,230,5,230,6,230,7,230,8,230,9,230,10,230,11,230,12,230,13,230,14,230,15,230,16,230,17,230,18,230,19,230,20,230,21,230,22,230,23,230,24,230,25,230,26,230,27,230,28,230,29,230,30,230,31,230,32,230,33,230,34,230,35,230,36,230,37,230,38,230,39,230,40,230,41,230,42,230,43,230,44,230,45,230,46,230,47,230,48,230,49,230,50,230,51,230,52,230,53,230,54,230,55,230,56,230,57,230,58,230,59,230,60,230,61,230,62,230,63,230,64,230,65,230,66,230,67,230,68,230,69,230,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,114,231,115,231,116,231,117,231,118,231,119,231,120,231,121,231,122,231,123,231,124,231,70,230,71,230,72,230,73,230,74,230,75,230,76,230,77,230,78,230,79,230,80,230,81,230,82,230,83,230,84,230,85,230,86,230,87,230,88,230,89,230,90,230,91,230,92,230,93,230,94,230,95,230,96,230,97,230,98,230,99,230,100,230,101,230,102,230,103,230,104,230,105,230,106,230,107,230,108,230,109,230,110,230,111,230,112,230,113,230,114,230,115,230,116,230,117,230,118,230,119,230,120,230,121,230,122,230,123,230,124,230,125,230,126,230,127,230,128,230,129,230,130,230,131,230,132,230,133,230,134,230,135,230,136,230,137,230,138,230,139,230,140,230,141,230,142,230,143,230,144,230,145,230,146,230,147,230,148,230,149,230,150,230,151,230,152,230,153,230,154,230,155,230,156,230,157,230,158,230,159,230,160,230,161,230,162,230,163,230,164,230,165,230,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,125,231,126,231,127,231,128,231,129,231,130,231,131,231,132,231,166,230,167,230,168,230,169,230,170,230,171,230,172,230,173,230,174,230,175,230,176,230,177,230,178,230,179,230,180,230,181,230,182,230,183,230,184,230,185,230,186,230,187,230,188,230,189,230,190,230,191,230,192,230,193,230,194,230,195,230,196,230,197,230,198,230,199,230,200,230,201,230,202,230,203,230,204,230,205,230,206,230,207,230,208,230,209,230,210,230,211,230,212,230,213,230,214,230,215,230,216,230,217,230,218,230,219,230,220,230,221,230,222,230,223,230,224,230,225,230,226,230,227,230,228,230,229,230,230,230,231,230,232,230,233,230,234,230,235,230,236,230,237,230,238,230,239,230,240,230,241,230,242,230,243,230,244,230,245,230,246,230,247,230,248,230,249,230,250,230,251,230,252,230,253,230,254,230,255,230,0,231,1,231,2,231,3,231,4,231,5,231,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,133,231,134,231,135,231,136,231,137,231,138,231,139,231,140,231,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,141,231,142,231,143,231,144,231,145,231,146,231,147,231,53,254,54,254,57,254,58,254,63,254,64,254,61,254,62,254,65,254,66,254,67,254,68,254,148,231,149,231,59,254,60,254,55,254,56,254,49,254,150,231,51,254,52,254,151,231,152,231,153,231,154,231,155,231,156,231,157,231,158,231,159,231,6,231,7,231,8,231,9,231,10,231,11,231,12,231,13,231,14,231,15,231,16,231,17,231,18,231,19,231,20,231,21,231,22,231,23,231,24,231,25,231,26,231,27,231,28,231,29,231,30,231,31,231,32,231,33,231,34,231,35,231,36,231,37,231,38,231,39,231,40,231,41,231,42,231,43,231,44,231,45,231,46,231,47,231,48,231,49,231,50,231,51,231,52,231,53,231,54,231,55,231,56,231,57,231,58,231,59,231,60,231,61,231,62,231,63,231,64,231,65,231,66,231,67,231,68,231,69,231,70,231,71,231,72,231,73,231,74,231,75,231,76,231,77,231,78,231,79,231,80,231,81,231,82,231,83,231,84,231,85,231,86,231,87,231,88,231,89,231,90,231,91,231,92,231,93,231,94,231,95,231,96,231,97,231,98,231,99,231,100,231,101,231,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,160,231,161,231,162,231,163,231,164,231,165,231,166,231,167,231,168,231,169,231,170,231,171,231,172,231,173,231,174,231,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,175,231,176,231,177,231,178,231,179,231,180,231,181,231,182,231,183,231,184,231,185,231,186,231,187,231,202,2,203,2,217,2,19,32,21,32,37,32,53,32,5,33,9,33,150,33,151,33,152,33,153,33,21,34,31,34,35,34,82,34,102,34,103,34,191,34,80,37,81,37,82,37,83,37,84,37,85,37,86,37,87,37,88,37,89,37,90,37,91,37,92,37,93,37,94,37,95,37,96,37,97,37,98,37,99,37,100,37,101,37,102,37,103,37,104,37,105,37,106,37,107,37,108,37,109,37,110,37,111,37,112,37,113,37,114,37,115,37,129,37,130,37,131,37,132,37,133,37,134,37,135,37,136,37,137,37,138,37,139,37,140,37,141,37,142,37,143,37,147,37,148,37,149,37,188,37,189,37,226,37,227,37,228,37,229,37,9,38,149,34,18,48,29,48,30,48,188,231,189,231,190,231,191,231,192,231,193,231,194,231,195,231,196,231,197,231,198,231,1,1,225,0,206,1,224,0,19,1,233,0,27,1,232,0,43,1,237,0,208,1,236,0,77,1,243,0,210,1,242,0,107,1,250,0,212,1,249,0,214,1,216,1,218,1,220,1,252,0,234,0,81,2,199,231,68,1,72,1,249,1,97,2,201,231,202,231,203,231,204,231,5,49,6,49,7,49,8,49,9,49,10,49,11,49,12,49,13,49,14,49,15,49,16,49,17,49,18,49,19,49,20,49,21,49,22,49,23,49,24,49,25,49,26,49,27,49,28,49,29,49,30,49,31,49,32,49,33,49,34,49,35,49,36,49,37,49,38,49,39,49,40,49,41,49,205,231,206,231,207,231,208,231,209,231,210,231,211,231,212,231,213,231,214,231,215,231,216,231,217,231,218,231,219,231,220,231,221,231,222,231,223,231,224,231,225,231,33,48,34,48,35,48,36,48,37,48,38,48,39,48,40,48,41,48,163,50,142,51,143,51,156,51,157,51,158,51,161,51,196,51,206,51,209,51,210,51,213,51,48,254,226,255,228,255,226,231,33,33,49,50,227,231,16,32,228,231,229,231,230,231,252,48,155,48,156,48,253,48,254,48,6,48,157,48,158,48,73,254,74,254,75,254,76,254,77,254,78,254,79,254,80,254,81,254,82,254,84,254,85,254,86,254,87,254,89,254,90,254,91,254,92,254,93,254,94,254,95,254,96,254,97,254,98,254,99,254,100,254,101,254,102,254,104,254,105,254,106,254,107,254,62,48,240,47,241,47,242,47,243,47,244,47,245,47,246,47,247,47,248,47,249,47,250,47,251,47,7,48,244,231,245,231,246,231,247,231,248,231,249,231,250,231,251,231,252,231,253,231,254,231,255,231,0,232,0,37,1,37,2,37,3,37,4,37,5,37,6,37,7,37,8,37,9,37,10,37,11,37,12,37,13,37,14,37,15,37,16,37,17,37,18,37,19,37,20,37,21,37,22,37,23,37,24,37,25,37,26,37,27,37,28,37,29,37,30,37,31,37,32,37,33,37,34,37,35,37,36,37,37,37,38,37,39,37,40,37,41,37,42,37,43,37,44,37,45,37,46,37,47,37,48,37,49,37,50,37,51,37,52,37,53,37,54,37,55,37,56,37,57,37,58,37,59,37,60,37,61,37,62,37,63,37,64,37,65,37,66,37,67,37,68,37,69,37,70,37,71,37,72,37,73,37,74,37,75,37,1,232,2,232,3,232,4,232,5,232,6,232,7,232,8,232,9,232,10,232,11,232,12,232,13,232,14,232,15,232,220,114,221,114,223,114,226,114,227,114,228,114,229,114,230,114,231,114,234,114,235,114,245,114,246,114,249,114,253,114,254,114,255,114,0,115,2,115,4,115,5,115,6,115,7,115,8,115,9,115,11,115,12,115,13,115,15,115,16,115,17,115,18,115,20,115,24,115,25,115,26,115,31,115,32,115,35,115,36,115,38,115,39,115,40,115,45,115,47,115,48,115,50,115,51,115,53,115,54,115,58,115,59,115,60,115,61,115,64,115,65,115,66,115,67,115,68,115,69,115,70,115,71,115,72,115,73,115,74,115,75,115,76,115,78,115,79,115,81,115,83,115,84,115,85,115,86,115,88,115,89,115,90,115,91,115,92,115,93,115,94,115,95,115,97,115,98,115,99,115,100,115,101,115,102,115,103,115,104,115,105,115,106,115,107,115,110,115,112,115,113,115,0,224,1,224,2,224,3,224,4,224,5,224,6,224,7,224,8,224,9,224,10,224,11,224,12,224,13,224,14,224,15,224,16,224,17,224,18,224,19,224,20,224,21,224,22,224,23,224,24,224,25,224,26,224,27,224,28,224,29,224,30,224,31,224,32,224,33,224,34,224,35,224,36,224,37,224,38,224,39,224,40,224,41,224,42,224,43,224,44,224,45,224,46,224,47,224,48,224,49,224,50,224,51,224,52,224,53,224,54,224,55,224,56,224,57,224,58,224,59,224,60,224,61,224,62,224,63,224,64,224,65,224,66,224,67,224,68,224,69,224,70,224,71,224,72,224,73,224,74,224,75,224,76,224,77,224,78,224,79,224,80,224,81,224,82,224,83,224,84,224,85,224,86,224,87,224,88,224,89,224,90,224,91,224,92,224,93,224,114,115,115,115,116,115,117,115,118,115,119,115,120,115,121,115,122,115,123,115,124,115,125,115,127,115,128,115,129,115,130,115,131,115,133,115,134,115,136,115,138,115,140,115,141,115,143,115,144,115,146,115,147,115,148,115,149,115,151,115,152,115,153,115,154,115,156,115,157,115,158,115,160,115,161,115,163,115,164,115,165,115,166,115,167,115,168,115,170,115,172,115,173,115,177,115,180,115,181,115,182,115,184,115,185,115,188,115,189,115,190,115,191,115,193,115,195,115,196,115,197,115,198,115,199,115,203,115,204,115,206,115,210,115,211,115,212,115,213,115,214,115,215,115,216,115,218,115,219,115,220,115,221,115,223,115,225,115,226,115,227,115,228,115,230,115,232,115,234,115,235,115,236,115,238,115,239,115,240,115,241,115,243,115,244,115,245,115,246,115,247,115,94,224,95,224,96,224,97,224,98,224,99,224,100,224,101,224,102,224,103,224,104,224,105,224,106,224,107,224,108,224,109,224,110,224,111,224,112,224,113,224,114,224,115,224,116,224,117,224,118,224,119,224,120,224,121,224,122,224,123,224,124,224,125,224,126,224,127,224,128,224,129,224,130,224,131,224,132,224,133,224,134,224,135,224,136,224,137,224,138,224,139,224,140,224,141,224,142,224,143,224,144,224,145,224,146,224,147,224,148,224,149,224,150,224,151,224,152,224,153,224,154,224,155,224,156,224,157,224,158,224,159,224,160,224,161,224,162,224,163,224,164,224,165,224,166,224,167,224,168,224,169,224,170,224,171,224,172,224,173,224,174,224,175,224,176,224,177,224,178,224,179,224,180,224,181,224,182,224,183,224,184,224,185,224,186,224,187,224,248,115,249,115,250,115,251,115,252,115,253,115,254,115,255,115,0,116,1,116,2,116,4,116,7,116,8,116,11,116,12,116,13,116,14,116,17,116,18,116,19,116,20,116,21,116,22,116,23,116,24,116,25,116,28,116,29,116,30,116,31,116,32,116,33,116,35,116,36,116,39,116,41,116,43,116,45,116,47,116,49,116,50,116,55,116,56,116,57,116,58,116,59,116,61,116,62,116,63,116,64,116,66,116,67,116,68,116,69,116,70,116,71,116,72,116,73,116,74,116,75,116,76,116,77,116,78,116,79,116,80,116,81,116,82,116,83,116,84,116,86,116,88,116,93,116,96,116,97,116,98,116,99,116,100,116,101,116,102,116,103,116,104,116,105,116,106,116,107,116,108,116,110,116,111,116,113,116,114,116,115,116,116,116,117,116,120,116,121,116,122,116,188,224,189,224,190,224,191,224,192,224,193,224,194,224,195,224,196,224,197,224,198,224,199,224,200,224,201,224,202,224,203,224,204,224,205,224,206,224,207,224,208,224,209,224,210,224,211,224,212,224,213,224,214,224,215,224,216,224,217,224,218,224,219,224,220,224,221,224,222,224,223,224,224,224,225,224,226,224,227,224,228,224,229,224,230,224,231,224,232,224,233,224,234,224,235,224,236,224,237,224,238,224,239,224,240,224,241,224,242,224,243,224,244,224,245,224,246,224,247,224,248,224,249,224,250,224,251,224,252,224,253,224,254,224,255,224,0,225,1,225,2,225,3,225,4,225,5,225,6,225,7,225,8,225,9,225,10,225,11,225,12,225,13,225,14,225,15,225,16,225,17,225,18,225,19,225,20,225,21,225,22,225,23,225,24,225,25,225,123,116,124,116,125,116,127,116,130,116,132,116,133,116,134,116,136,116,137,116,138,116,140,116,141,116,143,116,145,116,146,116,147,116,148,116,149,116,150,116,151,116,152,116,153,116,154,116,155,116,157,116,159,116,160,116,161,116,162,116,163,116,164,116,165,116,166,116,170,116,171,116,172,116,173,116,174,116,175,116,176,116,177,116,178,116,179,116,180,116,181,116,182,116,183,116,184,116,185,116,187,116,188,116,189,116,190,116,191,116,192,116,193,116,194,116,195,116,196,116,197,116,198,116,199,116,200,116,201,116,202,116,203,116,204,116,205,116,206,116,207,116,208,116,209,116,211,116,212,116,213,116,214,116,215,116,216,116,217,116,218,116,219,116,221,116,223,116,225,116,229,116,231,116,232,116,233,116,234,116,235,116,236,116,237,116,240,116,241,116,242,116,26,225,27,225,28,225,29,225,30,225,31,225,32,225,33,225,34,225,35,225,36,225,37,225,38,225,39,225,40,225,41,225,42,225,43,225,44,225,45,225,46,225,47,225,48,225,49,225,50,225,51,225,52,225,53,225,54,225,55,225,56,225,57,225,58,225,59,225,60,225,61,225,62,225,63,225,64,225,65,225,66,225,67,225,68,225,69,225,70,225,71,225,72,225,73,225,74,225,75,225,76,225,77,225,78,225,79,225,80,225,81,225,82,225,83,225,84,225,85,225,86,225,87,225,88,225,89,225,90,225,91,225,92,225,93,225,94,225,95,225,96,225,97,225,98,225,99,225,100,225,101,225,102,225,103,225,104,225,105,225,106,225,107,225,108,225,109,225,110,225,111,225,112,225,113,225,114,225,115,225,116,225,117,225,118,225,119,225,243,116,245,116,248,116,249,116,250,116,251,116,252,116,253,116,254,116,0,117,1,117,2,117,3,117,5,117,6,117,7,117,8,117,9,117,10,117,11,117,12,117,14,117,16,117,18,117,20,117,21,117,22,117,23,117,27,117,29,117,30,117,32,117,33,117,34,117,35,117,36,117,38,117,39,117,42,117,46,117,52,117,54,117,57,117,60,117,61,117,63,117,65,117,66,117,67,117,68,117,70,117,71,117,73,117,74,117,77,117,80,117,81,117,82,117,83,117,85,117,86,117,87,117,88,117,93,117,94,117,95,117,96,117,97,117,98,117,99,117,100,117,103,117,104,117,105,117,107,117,108,117,109,117,110,117,111,117,112,117,113,117,115,117,117,117,118,117,119,117,122,117,123,117,124,117,125,117,126,117,128,117,129,117,130,117,132,117,133,117,135,117,120,225,121,225,122,225,123,225,124,225,125,225,126,225,127,225,128,225,129,225,130,225,131,225,132,225,133,225,134,225,135,225,136,225,137,225,138,225,139,225,140,225,141,225,142,225,143,225,144,225,145,225,146,225,147,225,148,225,149,225,150,225,151,225,152,225,153,225,154,225,155,225,156,225,157,225,158,225,159,225,160,225,161,225,162,225,163,225,164,225,165,225,166,225,167,225,168,225,169,225,170,225,171,225,172,225,173,225,174,225,175,225,176,225,177,225,178,225,179,225,180,225,181,225,182,225,183,225,184,225,185,225,186,225,187,225,188,225,189,225,190,225,191,225,192,225,193,225,194,225,195,225,196,225,197,225,198,225,199,225,200,225,201,225,202,225,203,225,204,225,205,225,206,225,207,225,208,225,209,225,210,225,211,225,212,225,213,225,136,117,137,117,138,117,140,117,141,117,142,117,144,117,147,117,149,117,152,117,155,117,156,117,158,117,162,117,166,117,167,117,168,117,169,117,170,117,173,117,182,117,183,117,186,117,187,117,191,117,192,117,193,117,198,117,203,117,204,117,206,117,207,117,208,117,209,117,211,117,215,117,217,117,218,117,220,117,221,117,223,117,224,117,225,117,229,117,233,117,236,117,237,117,238,117,239,117,242,117,243,117,245,117,246,117,247,117,248,117,250,117,251,117,253,117,254,117,2,118,4,118,6,118,7,118,8,118,9,118,11,118,13,118,14,118,15,118,17,118,18,118,19,118,20,118,22,118,26,118,28,118,29,118,30,118,33,118,35,118,39,118,40,118,44,118,46,118,47,118,49,118,50,118,54,118,55,118,57,118,58,118,59,118,61,118,65,118,66,118,68,118,214,225,215,225,216,225,217,225,218,225,219,225,220,225,221,225,222,225,223,225,224,225,225,225,226,225,227,225,228,225,229,225,230,225,231,225,232,225,233,225,234,225,235,225,236,225,237,225,238,225,239,225,240,225,241,225,242,225,243,225,244,225,245,225,246,225,247,225,248,225,249,225,250,225,251,225],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+230588),
	allocate([252,225,253,225,254,225,255,225,0,226,1,226,2,226,3,226,4,226,5,226,6,226,7,226,8,226,9,226,10,226,11,226,12,226,13,226,14,226,15,226,16,226,17,226,18,226,19,226,20,226,21,226,22,226,23,226,24,226,25,226,26,226,27,226,28,226,29,226,30,226,31,226,32,226,33,226,34,226,35,226,36,226,37,226,38,226,39,226,40,226,41,226,42,226,43,226,44,226,45,226,46,226,47,226,48,226,49,226,50,226,51,226,69,118,70,118,71,118,72,118,73,118,74,118,75,118,78,118,79,118,80,118,81,118,82,118,83,118,85,118,87,118,88,118,89,118,90,118,91,118,93,118,95,118,96,118,97,118,98,118,100,118,101,118,102,118,103,118,104,118,105,118,106,118,108,118,109,118,110,118,112,118,113,118,114,118,115,118,116,118,117,118,118,118,119,118,121,118,122,118,124,118,127,118,128,118,129,118,131,118,133,118,137,118,138,118,140,118,141,118,143,118,144,118,146,118,148,118,149,118,151,118,152,118,154,118,155,118,156,118,157,118,158,118,159,118,160,118,161,118,162,118,163,118,165,118,166,118,167,118,168,118,169,118,170,118,171,118,172,118,173,118,175,118,176,118,179,118,181,118,182,118,183,118,184,118,185,118,186,118,187,118,188,118,189,118,190,118,192,118,193,118,195,118,74,85,63,150,195,87,40,99,206,84,9,85,192,84,145,118,76,118,60,133,238,119,126,130,141,120,49,114,152,150,141,151,40,108,137,91,250,79,9,99,151,102,184,92,250,128,72,104,174,128,2,102,206,118,249,81,86,101,172,113,241,127,132,136,178,80,101,89,202,97,179,111,173,130,76,99,82,98,237,83,39,84,6,123,107,81,164,117,244,93,212,98,203,141,118,151,138,98,25,128,93,87,56,151,98,127,56,114,125,118,207,103,126,118,70,100,112,79,37,141,220,98,23,122,145,101,237,115,44,100,115,98,44,130,129,152,127,103,72,114,110,98,204,98,52,79,227,116,74,83,158,82,202,126,166,144,46,94,134,104,156,105,128,129,209,126,210,104,197,120,140,134,81,149,141,80,36,140,222,130,222,128,5,83,18,137,101,82,196,118,199,118,201,118,203,118,204,118,211,118,213,118,217,118,218,118,220,118,221,118,222,118,224,118,225,118,226,118,227,118,228,118,230,118,231,118,232,118,233,118,234,118,235,118,236,118,237,118,240,118,243,118,245,118,246,118,247,118,250,118,251,118,253,118,255,118,0,119,2,119,3,119,5,119,6,119,10,119,12,119,14,119,15,119,16,119,17,119,18,119,19,119,20,119,21,119,22,119,23,119,24,119,27,119,28,119,29,119,30,119,33,119,35,119,36,119,37,119,39,119,42,119,43,119,44,119,46,119,48,119,49,119,50,119,51,119,52,119,57,119,59,119,61,119,62,119,63,119,66,119,68,119,69,119,70,119,72,119,73,119,74,119,75,119,76,119,77,119,78,119,79,119,82,119,83,119,84,119,85,119,86,119,87,119,88,119,89,119,92,119,132,133,249,150,221,79,33,88,113,153,157,91,177,98,165,98,180,102,121,140,141,156,6,114,111,103,145,120,178,96,81,83,23,83,136,143,204,128,29,141,161,148,13,80,200,114,7,89,235,96,25,113,171,136,84,89,239,130,44,103,40,123,41,93,247,126,45,117,245,108,102,142,248,143,60,144,59,159,212,107,25,145,20,123,124,95,167,120,214,132,61,133,213,107,217,107,214,107,1,94,135,94,249,117,237,149,93,101,10,95,197,95,159,143,193,88,194,129,127,144,91,150,173,151,185,143,22,127,44,141,65,98,191,79,216,83,94,83,168,143,169,143,171,143,77,144,7,104,106,95,152,129,104,136,214,156,139,97,43,82,42,118,108,95,140,101,210,111,232,110,190,91,72,100,117,81,176,81,196,103,25,78,201,121,124,153,179,112,93,119,94,119,95,119,96,119,100,119,103,119,105,119,106,119,109,119,110,119,111,119,112,119,113,119,114,119,115,119,116,119,117,119,118,119,119,119,120,119,122,119,123,119,124,119,129,119,130,119,131,119,134,119,135,119,136,119,137,119,138,119,139,119,143,119,144,119,147,119,148,119,149,119,150,119,151,119,152,119,153,119,154,119,155,119,156,119,157,119,158,119,161,119,163,119,164,119,166,119,168,119,171,119,173,119,174,119,175,119,177,119,178,119,180,119,182,119,183,119,184,119,185,119,186,119,188,119,190,119,192,119,193,119,194,119,195,119,196,119,197,119,198,119,199,119,200,119,201,119,202,119,203,119,204,119,206,119,207,119,208,119,209,119,210,119,211,119,212,119,213,119,214,119,216,119,217,119,218,119,221,119,222,119,223,119,224,119,225,119,228,119,197,117,118,94,187,115,224,131,173,100,232,98,181,148,226,108,90,83,195,82,15,100,194,148,148,123,47,79,27,94,54,130,22,129,138,129,36,110,202,108,115,154,85,99,92,83,250,84,101,136,224,87,13,78,3,94,101,107,63,124,232,144,22,96,230,100,28,115,193,136,80,103,77,98,34,141,108,119,41,142,199,145,105,95,220,131,33,133,16,153,194,83,149,134,139,107,237,96,232,96,127,112,205,130,49,130,211,78,167,108,207,133,205,100,217,124,253,105,249,102,73,131,149,83,86,123,167,79,140,81,75,109,66,92,109,142,210,99,201,83,44,131,54,131,229,103,180,120,61,100,223,91,148,92,238,93,231,139,198,98,244,103,122,140,0,100,186,99,73,135,139,153,23,140,32,127,242,148,167,78,16,150,164,152,12,102,22,115,230,119,232,119,234,119,239,119,240,119,241,119,242,119,244,119,245,119,247,119,249,119,250,119,251,119,252,119,3,120,4,120,5,120,6,120,7,120,8,120,10,120,11,120,14,120,15,120,16,120,19,120,21,120,25,120,27,120,30,120,32,120,33,120,34,120,36,120,40,120,42,120,43,120,46,120,47,120,49,120,50,120,51,120,53,120,54,120,61,120,63,120,65,120,66,120,67,120,68,120,70,120,72,120,73,120,74,120,75,120,77,120,79,120,81,120,83,120,84,120,88,120,89,120,90,120,91,120,92,120,94,120,95,120,96,120,97,120,98,120,99,120,100,120,101,120,102,120,103,120,104,120,105,120,111,120,112,120,113,120,114,120,115,120,116,120,117,120,118,120,120,120,121,120,122,120,123,120,125,120,126,120,127,120,128,120,129,120,130,120,131,120,58,87,29,92,56,94,127,149,127,80,160,128,130,83,94,101,69,117,49,85,33,80,133,141,132,98,158,148,29,103,50,86,110,111,226,93,53,84,146,112,102,143,111,98,164,100,163,99,123,95,136,111,244,144,227,129,176,143,24,92,104,102,241,95,137,108,72,150,129,141,108,136,145,100,240,121,206,87,89,106,16,98,72,84,88,78,11,122,233,96,132,111,218,139,127,98,30,144,139,154,228,121,3,84,244,117,1,99,25,83,96,108,223,143,27,95,112,154,59,128,127,159,136,79,58,92,100,141,197,127,165,101,189,112,69,81,178,81,107,134,7,93,160,91,189,98,108,145,116,117,12,142,32,122,1,97,121,123,199,78,248,126,133,119,17,78,237,129,29,82,250,81,113,106,168,83,135,142,4,149,207,150,193,110,100,150,90,105,132,120,133,120,134,120,136,120,138,120,139,120,143,120,144,120,146,120,148,120,149,120,150,120,153,120,157,120,158,120,160,120,162,120,164,120,166,120,168,120,169,120,170,120,171,120,172,120,173,120,174,120,175,120,181,120,182,120,183,120,184,120,186,120,187,120,188,120,189,120,191,120,192,120,194,120,195,120,196,120,198,120,199,120,200,120,204,120,205,120,206,120,207,120,209,120,210,120,211,120,214,120,215,120,216,120,218,120,219,120,220,120,221,120,222,120,223,120,224,120,225,120,226,120,227,120,228,120,229,120,230,120,231,120,233,120,234,120,235,120,237,120,238,120,239,120,240,120,241,120,243,120,245,120,246,120,248,120,249,120,251,120,252,120,253,120,254,120,255,120,0,121,2,121,3,121,4,121,6,121,7,121,8,121,9,121,10,121,11,121,12,121,64,120,168,80,215,119,16,100,230,137,4,89,227,99,221,93,127,122,61,105,32,79,57,130,152,85,50,78,174,117,151,122,98,94,138,94,239,149,27,82,57,84,138,112,118,99,36,149,130,87,37,102,63,105,135,145,7,85,243,109,175,126,34,136,51,98,240,126,181,117,40,131,193,120,204,150,158,143,72,97,247,116,205,139,100,107,58,82,80,141,33,107,106,128,113,132,241,86,6,83,206,78,27,78,209,81,151,124,139,145,7,124,195,79,127,142,225,123,156,122,103,100,20,93,172,80,6,129,1,118,185,124,236,109,224,127,81,103,88,91,248,91,203,120,174,100,19,100,170,99,43,99,25,149,45,100,190,143,84,123,41,118,83,98,39,89,70,84,121,107,163,80,52,98,38,94,134,107,227,78,55,141,139,136,133,95,46,144,13,121,14,121,15,121,16,121,17,121,18,121,20,121,21,121,22,121,23,121,24,121,25,121,26,121,27,121,28,121,29,121,31,121,32,121,33,121,34,121,35,121,37,121,38,121,39,121,40,121,41,121,42,121,43,121,44,121,45,121,46,121,47,121,48,121,49,121,50,121,51,121,53,121,54,121,55,121,56,121,57,121,61,121,63,121,66,121,67,121,68,121,69,121,71,121,74,121,75,121,76,121,77,121,78,121,79,121,80,121,81,121,82,121,84,121,85,121,88,121,89,121,97,121,99,121,100,121,102,121,105,121,106,121,107,121,108,121,110,121,112,121,113,121,114,121,115,121,116,121,117,121,118,121,121,121,123,121,124,121,125,121,126,121,127,121,130,121,131,121,134,121,135,121,136,121,137,121,139,121,140,121,141,121,142,121,144,121,145,121,146,121,32,96,61,128,197,98,57,78,85,83,248,144,184,99,198,128,230,101,46,108,70,79,238,96,225,109,222,139,57,95,203,134,83,95,33,99,90,81,97,131,99,104,0,82,99,99,72,142,18,80,155,92,119,121,252,91,48,82,59,122,188,96,83,144,215,118,183,95,151,95,132,118,108,142,111,112,123,118,73,123,170,119,243,81,147,144,36,88,78,79,244,110,234,143,76,101,27,123,196,114,164,109,223,127,225,90,181,98,149,94,48,87,130,132,44,123,29,94,31,95,18,144,20,127,160,152,130,99,199,110,152,120,185,112,120,81,91,151,171,87,53,117,67,79,56,117,151,94,230,96,96,89,192,109,191,107,137,120,252,83,213,150,203,81,1,82,137,99,10,84,147,148,3,140,204,141,57,114,159,120,118,135,237,143,13,140,224,83,147,121,148,121,149,121,150,121,151,121,152,121,153,121,155,121,156,121,157,121,158,121,159,121,160,121,161,121,162,121,163,121,164,121,165,121,166,121,168,121,169,121,170,121,171,121,172,121,173,121,174,121,175,121,176,121,177,121,178,121,180,121,181,121,182,121,183,121,184,121,188,121,191,121,194,121,196,121,197,121,199,121,200,121,202,121,204,121,206,121,207,121,208,121,211,121,212,121,214,121,215,121,217,121,218,121,219,121,220,121,221,121,222,121,224,121,225,121,226,121,229,121,232,121,234,121,236,121,238,121,241,121,242,121,243,121,244,121,245,121,246,121,247,121,249,121,250,121,252,121,254,121,255,121,1,122,4,122,5,122,7,122,8,122,9,122,10,122,12,122,15,122,16,122,17,122,18,122,19,122,21,122,22,122,24,122,25,122,27,122,28,122,1,78,239,118,238,83,137,148,118,152,14,159,45,149,154,91,162,139,34,78,28,78,172,81,99,132,194,97,168,82,11,104,151,79,107,96,187,81,30,109,92,81,150,98,151,101,97,150,70,140,23,144,216,117,253,144,99,119,210,107,138,114,236,114,251,139,53,88,121,119,76,141,92,103,64,149,154,128,166,94,33,110,146,89,239,122,237,119,59,149,181,107,173,101,14,127,6,88,81,81,31,150,249,91,169,88,40,84,114,142,102,101,127,152,228,86,157,148,254,118,65,144,135,99,198,84,26,89,58,89,155,87,178,142,53,103,250,141,53,130,65,82,240,96,21,88,254,134,232,92,69,158,196,79,157,152,185,139,37,90,118,96,132,83,124,98,79,144,2,145,127,153,105,96,12,128,63,81,51,128,20,92,117,153,49,109,140,78,29,122,31,122,33,122,34,122,36,122,37,122,38,122,39,122,40,122,41,122,42,122,43,122,44,122,45,122,46,122,47,122,48,122,49,122,50,122,52,122,53,122,54,122,56,122,58,122,62,122,64,122,65,122,66,122,67,122,68,122,69,122,71,122,72,122,73,122,74,122,75,122,76,122,77,122,78,122,79,122,80,122,82,122,83,122,84,122,85,122,86,122,88,122,89,122,90,122,91,122,92,122,93,122,94,122,95,122,96,122,97,122,98,122,99,122,100,122,101,122,102,122,103,122,104,122,105,122,106,122,107,122,108,122,109,122,110,122,111,122,113,122,114,122,115,122,117,122,123,122,124,122,125,122,126,122,130,122,133,122,135,122,137,122,138,122,139,122,140,122,142,122,143,122,144,122,147,122,148,122,153,122,154,122,155,122,158,122,161,122,162,122,48,141,209,83,90,127,79,123,16,79,79,78,0,150,213,108,208,115,233,133,6,94,106,117,251,127,10,106,254,119,146,148,65,126,225,81,230,112,205,83,212,143,3,131,41,141,175,114,109,153,219,108,74,87,179,130,185,101,170,128,63,98,50,150,168,89,255,78,191,139,186,126,62,101,242,131,94,151,97,85,222,152,165,128,42,83,253,139,32,84,186,128,159,94,184,108,57,141,172,130,90,145,41,84,27,108,6,82,183,126,95,87,26,113,126,108,137,124,75,89,253,78,255,95,36,97,170,124,48,78,1,92,171,103,2,135,240,92,11,149,206,152,175,117,253,112,34,144,175,81,29,127,189,139,73,89,228,81,91,79,38,84,43,89,119,101,164,128,117,91,118,98,194,98,144,143,69,94,31,108,38,123,15,79,216,79,13,103,163,122,164,122,167,122,169,122,170,122,171,122,174,122,175,122,176,122,177,122,178,122,180,122,181,122,182,122,183,122,184,122,185,122,186,122,187,122,188,122,189,122,190,122,192,122,193,122,194,122,195,122,196,122,197,122,198,122,199,122,200,122,201,122,202,122,204,122,205,122,206,122,207,122,208,122,209,122,210,122,211,122,212,122,213,122,215,122,216,122,218,122,219,122,220,122,221,122,225,122,226,122,228,122,231,122,232,122,233,122,234,122,235,122,236,122,238,122,240,122,241,122,242,122,243,122,244,122,245,122,246,122,247,122,248,122,251,122,252,122,254,122,0,123,1,123,2,123,5,123,7,123,9,123,12,123,13,123,14,123,16,123,18,123,19,123,22,123,23,123,24,123,26,123,28,123,29,123,31,123,33,123,34,123,35,123,39,123,41,123,45,123,110,109,170,109,143,121,177,136,23,95,43,117,154,98,133,143,239,79,220,145,167,101,47,129,81,129,156,94,80,129,116,141,111,82,134,137,75,141,13,89,133,80,216,78,28,150,54,114,121,129,31,141,204,91,163,139,68,150,135,89,26,127,144,84,118,86,14,86,229,139,57,101,130,105,153,148,214,118,137,110,114,94,24,117,70,103,209,103,255,122,157,128,118,141,31,97,198,121,98,101,99,141,136,81,26,82,162,148,56,127,155,128,178,126,151,92,47,110,96,103,217,123,139,118,216,154,143,129,148,127,213,124,30,100,80,149,63,122,74,84,229,84,76,107,1,100,8,98,61,158,243,128,153,117,114,82,105,151,91,132,60,104,228,134,1,150,148,150,236,148,42,78,4,84,217,126,57,104,223,141,21,128,244,102,154,94,185,127,47,123,48,123,50,123,52,123,53,123,54,123,55,123,57,123,59,123,61,123,63,123,64,123,65,123,66,123,67,123,68,123,70,123,72,123,74,123,77,123,78,123,83,123,85,123,87,123,89,123,92,123,94,123,95,123,97,123,99,123,100,123,101,123,102,123,103,123,104,123,105,123,106,123,107,123,108,123,109,123,111,123,112,123,115,123,116,123,118,123,120,123,122,123,124,123,125,123,127,123,129,123,130,123,131,123,132,123,134,123,135,123,136,123,137,123,138,123,139,123,140,123,142,123,143,123,145,123,146,123,147,123,150,123,152,123,153,123,154,123,155,123,158,123,159,123,160,123,163,123,164,123,165,123,174,123,175,123,176,123,178,123,179,123,181,123,182,123,183,123,185,123,186,123,187,123,188,123,189,123,190,123,191,123,192,123,194,123,195,123,196,123,194,87,63,128,151,104,229,93,59,101,159,82,109,96,154,159,155,79,172,142,108,81,171,91,19,95,233,93,94,108,241,98,33,141,113,81,169,148,254,82,159,108,223,130,215,114,162,87,132,103,45,141,31,89,156,143,199,131,149,84,141,123,48,79,189,108,100,91,209,89,19,159,228,83,202,134,168,154,55,140,161,128,69,101,126,152,250,86,199,150,46,82,220,116,80,82,225,91,2,99,2,137,86,78,208,98,42,96,250,104,115,81,152,91,160,81,194,137,161,123,134,153,80,127,239,96,76,112,47,141,73,81,127,94,27,144,112,116,196,137,45,87,69,120,82,95,159,159,250,149,104,143,60,155,225,139,120,118,66,104,220,103,234,141,53,141,61,82,138,143,218,110,205,104,5,149,237,144,253,86,156,103,249,136,199,143,200,84,197,123,200,123,201,123,202,123,203,123,205,123,206,123,207,123,208,123,210,123,212,123,213,123,214,123,215,123,216,123,219,123,220,123,222,123,223,123,224,123,226,123,227,123,228,123,231,123,232,123,233,123,235,123,236,123,237,123,239,123,240,123,242,123,243,123,244,123,245,123,246,123,248,123,249,123,250,123,251,123,253,123,255,123,0,124,1,124,2,124,3,124,4,124,5,124,6,124,8,124,9,124,10,124,13,124,14,124,16,124,17,124,18,124,19,124,20,124,21,124,23,124,24,124,25,124,26,124,27,124,28,124,29,124,30,124,32,124,33,124,34,124,35,124,36,124,37,124,40,124,41,124,43,124,44,124,45,124,46,124,47,124,48,124,49,124,50,124,51,124,52,124,53,124,54,124,55,124,57,124,58,124,59,124,60,124,61,124,62,124,66,124,184,154,105,91,119,109,38,108,165,78,179,91,135,154,99,145,168,97,175,144,233,151,43,84,181,109,210,91,253,81,138,85,85,127,240,127,188,100,77,99,241,101,190,97,141,96,10,113,87,108,73,108,47,89,109,103,42,130,213,88,142,86,106,140,235,107,221,144,125,89,23,128,247,83,105,109,117,84,157,85,119,131,207,131,56,104,190,121,140,84,85,79,8,84,210,118,137,140,2,150,179,108,184,109,107,141,16,137,100,158,58,141,63,86,209,158,213,117,136,95,224,114,104,96,252,84,168,78,42,106,97,136,82,96,112,143,196,84,216,112,121,134,63,158,42,109,143,91,24,95,162,126,137,85,175,79,52,115,60,84,154,83,25,80,14,84,124,84,78,78,253,95,90,116,246,88,107,132,225,128,116,135,208,114,202,124,86,110,67,124,68,124,69,124,70,124,71,124,72,124,73,124,74,124,75,124,76,124,78,124,79,124,80,124,81,124,82,124,83,124,84,124,85,124,86,124,87,124,88,124,89,124,90,124,91,124,92,124,93,124,94,124,95,124,96,124,97,124,98,124,99,124,100,124,101,124,102,124,103,124,104,124,105,124,106,124,107,124,108,124,109,124,110,124,111,124,112,124,113,124,114,124,117,124,118,124,119,124,120,124,121,124,122,124,126,124,127,124,128,124,129,124,130,124,131,124,132,124,133,124,134,124,135,124,136,124,138,124,139,124,140,124,141,124,142,124,143,124,144,124,147,124,148,124,150,124,153,124,154,124,155,124,160,124,161,124,163,124,166,124,167,124,168,124,169,124,171,124,172,124,173,124,175,124,176,124,180,124,181,124,182,124,183,124,184,124,186,124,187,124,39,95,78,134,44,85,164,98,146,78,170,108,55,98,177,130,215,84,78,83,62,115,209,110,59,117,18,82,22,83,221,139,208,105,138,95,0,96,238,109,79,87,34,107,175,115,83,104,216,143,19,127,98,99,163,96,36,85,234,117,98,140,21,113,163,109,166,91,123,94,82,131,76,97,196,158,250,120,87,135,39,124,135,118,240,81,246,96,76,113,67,102,76,94,77,96,14,140,112,112,37,99,137,143,189,95,98,96,212,134,222,86,193,107,148,96,103,97,73,83,224,96,102,102,63,141,253,121,26,79,233,112,71,108,179,139,242,139,216,126,100,131,15,102,90,90,66,155,81,109,247,109,65,140,59,109,25,79,107,112,183,131,22,98,209,96,13,151,39,141,120,121,251,81,62,87,250,87,58,103,120,117,61,122,239,121,149,123,191,124,192,124,194,124,195,124,196,124,198,124,201,124,203,124,206,124,207,124,208,124,209,124,210,124,211,124,212,124,216,124,218,124,219,124,221,124,222,124,225,124,226,124,227,124,228,124,229,124,230,124,231,124,233,124,234,124,235,124,236,124,237,124,238,124,240,124,241,124,242,124,243,124,244,124,245,124,246,124,247,124,249,124,250,124,252,124,253,124,254,124,255,124,0,125,1,125,2,125,3,125,4,125,5,125,6,125,7,125,8,125,9,125,11,125,12,125,13,125,14,125,15,125,16,125,17,125,18,125,19,125,20,125,21,125,22,125,23,125,24,125,25,125,26,125,27,125,28,125,29,125,30,125,31,125,33,125,35,125,36,125,37,125,38,125,40,125,41,125,42,125,44,125,45,125,46,125,48,125,49,125,50,125,51,125,52,125,53,125,54,125,140,128,101,153,249,143,192,111,165,139,33,158,236,89,233,126,9,127,9,84,129,103,216,104,145,143,77,124,198,150,202,83,37,96,190,117,114,108,115,83,201,90,167,126,36,99,224,81,10,129,241,93,223,132,128,98,128,81,99,91,14,79,109,121,66,82,184,96,78,109,196,91,194,91,161,139,176,139,226,101,204,95,69,150,147,89,231,126,170,126,9,86,183,103,57,89,115,79,182,91,160,82,90,131,138,152,62,141,50,117,190,148,71,80,60,122,247,78,182,103,126,154,193,90,124,107,209,118,90,87,22,92,58,123,244,149,78,113,124,81,169,128,112,130,120,89,4,127,39,131,192,104,236,103,177,120,119,120,227,98,97,99,128,123,237,79,106,82,207,81,80,131,219,105,116,146,245,141,49,141,193,137,46,149,173,123,246,78,55,125,56,125,57,125,58,125,59,125,60,125,61,125,62,125,63,125,64,125,65,125,66,125,67,125,68,125,69,125,70,125,71,125,72,125,73,125,74,125,75,125,76,125,77,125,78,125,79,125,80,125,81,125,82,125,83,125,84,125,85,125,86,125,87,125,88,125,89,125,90,125,91,125,92,125,93,125,94,125,95,125,96,125,97,125,98,125,99,125,100,125,101,125,102,125,103,125,104,125,105,125,106,125,107,125,108,125,109,125,111,125,112,125,113,125,114,125,115,125,116,125,117,125,118,125,120,125,121,125,122,125,123,125,124,125,125,125,126,125,127,125,128,125,129,125,130,125,131,125,132,125,133,125,134,125,135,125,136,125,137,125,138,125,139,125,140,125,141,125,142,125,143,125,144,125,145,125,146,125,147,125,148,125,149,125,150,125,151,125,152,125,101,80,48,130,81,82,111,153,16,110,133,110,167,109,250,94,245,80,220,89,6,92,70,109,95,108,134,117,139,132,104,104,86,89,178,139,32,83,113,145,77,150,73,133,18,105,1,121,38,113,246,128,164,78,202,144,71,109,132,154,7,90,188,86,5,100,240,148,235,119,165,79,26,129,225,114,210,137,122,153,52,127,222,126,127,82,89,101,117,145,127,143,131,143,235,83,150,122,237,99,165,99,134,118,248,121,87,136,54,150,42,98,171,82,130,130,84,104,112,103,119,99,107,119,237,122,1,109,211,126,227,137,208,89,18,98,201,133,165,130,76,117,31,80,203,78,165,117,235,139,74,92,254,93,75,123,164,101,209,145,202,78,37,109,95,137,39,125,38,149,197,78,40,140,219,143,115,151,75,102,129,121,209,143,236,112,120,109,153,125,154,125,155,125,156,125,157,125,158,125,159,125,160,125,161,125,162,125,163,125,164,125,165,125,167,125,168,125,169,125,170,125,171,125,172,125,173,125,175,125,176,125,177,125,178,125,179,125,180,125,181,125,182,125,183,125,184,125,185,125,186,125,187,125,188,125,189,125,190,125,191,125,192,125,193,125,194,125,195,125,196,125,197,125,198,125,199,125,200,125,201,125,202,125,203,125,204,125,205,125,206,125,207,125,208,125,209,125,210,125,211,125,212,125,213,125,214,125,215,125,216,125,217,125,218,125,219,125,220,125,221,125,222,125,223,125,224,125,225,125,226,125,227,125,228,125,229,125,230,125,231,125,232,125,233,125,234,125,235,125,236,125,237,125,238,125,239,125,240,125,241,125,242,125,243,125,244,125,245,125,246,125,247,125,248,125,249,125,250,125,61,92,178,82,70,131,98,81,14,131,91,119,118,102,184,156,172,78,202,96,190,124,179,124,207,126,149,78,102,139,111,102,136,152,89,151,131,88,108,101,92,149,132,95,201,117,86,151,223,122,222,122,192,81,175,112,152,122,234,99,118,122,160,126,150,115,237,151,69,78,120,112,93,78,82,145,169,83,81,101,231,101,252,129,5,130,142,84,49,92,154,117,160,151,216,98,217,114,189,117,69,92,121,154,202,131,64,92,128,84,233,119,62,78,174,108,90,128,210,98,110,99,232,93,119,81,221,141,30,142,47,149,241,79,229,83,231,96,172,112,103,82,80,99,67,158,31,90,38,80,55,119,119,83,226,126,133,100,43,101,137,98,152,99,20,80,53,114,201,137,179,81,192,139,221,126,71,87,204,131,167,148,155,81,27,84,251,92,251,125,252,125,253,125,254,125,255,125,0,126,1,126,2,126,3,126,4,126,5,126,6,126,7,126,8,126,9,126,10,126,11,126,12,126,13,126,14,126,15,126,16,126,17,126,18,126,19,126,20,126,21,126,22,126,23,126,24,126,25,126,26,126,27,126,28,126,29,126,30,126,31,126,32,126,33,126,34,126,35,126,36,126,37,126,38,126,39,126,40,126,41,126,42,126,43,126,44,126,45,126,46,126,47,126,48,126,49,126,50,126,51,126,52,126,53,126,54,126,55,126,56,126,57,126,58,126,60,126,61,126,62,126,63,126,64,126,66,126,67,126,68,126,69,126,70,126,72,126,73,126,74,126,75,126,76,126,77,126,78,126,79,126,80,126,81,126,82,126,83,126,84,126,85,126,86,126,87,126,88,126,89,126,90,126,91,126,92,126,93,126,202,79,227,122,90,109,225,144,143,154,128,85,150,84,97,83,175,84,0,95,233,99,119,105,239,81,104,97,10,82,42,88,216,82,78,87,13,120,11,119,183,94,119,97,224,124,91,98,151,98,162,78,149,112,3,128,247,98,228,112,96,151,119,87,219,130,239,103,245,104,213,120,151,152,209,121,243,88,179,84,239,83,52,110,75,81,59,82,162,91,254,139,175,128,67,85,166,87,115,96,81,87,45,84,122,122,80,96,84,91,167,99,160,98,227,83,99,98,199,91,175,103,237,84,159,122,230,130,119,145,147,94,228,136,56,89,174,87,14,99,232,141,239,128,87,87,119,123,169,79,235,95,189,91,62,107,33,83,80,123,194,114,70,104,255,119,54,119,247,101,181,81,143,78,212,118,191,92,165,122,117,132,78,89,65,155,128,80,94,126,95,126,96,126,97,126,98,126,99,126,100,126,101,126,102,126,103,126,104,126,105,126,106,126,107,126,108,126,109,126,110,126,111,126,112,126,113,126,114,126,115,126,116,126,117,126,118,126,119,126,120,126,121,126,122,126,123,126,124,126,125,126,126,126,127,126,128,126,129,126,131,126,132,126,133,126,134,126,135,126,136,126,137,126,138,126,139,126,140,126,141,126,142,126,143,126,144,126,145,126,146,126,147,126,148,126,149,126,150,126,151,126,152,126,153,126,154,126,156,126,157,126,158,126,174,126,180,126,187,126,188,126,214,126,228,126,236,126,249,126,10,127,16,127,30,127,55,127,57,127,59,127,60,127,61,127,62,127,63,127,64,127,65,127,67,127,70,127,71,127,72,127,73,127,74,127,75,127,76,127,77,127,78,127,79,127,82,127,83,127,136,153,39,97,131,110,100,87,6,102,70,99,240,86,236,98,105,98,211,94,20,150,131,87,201,98,135,85,33,135,74,129,163,143,102,85,177,131,101,103,86,141,221,132,106,90,15,104,230,98,238,123,17,150,112,81,156,111,48,140,253,99,200,137,210,97,6,127,194,112,229,110,5,116,148,105,252,114,202,94,206,144,23,103,106,109,94,99,179,82,98,114,1,128,108,79,229,89,106,145,217,112,157,109,210,82,80,78,247,150,109,149,126,133,202,120,47,125,33,81,146,87,194,100,139,128,123,124,234,108,241,104,94,105,183,81,152,83,168,104,129,114,206,158,241,123,248,114,187,121,19,111,6,116,78,103,204,145,164,156,60,121,137,131,84,131,15,84,23,104,61,78,137,83,177,82,62,120,134,83,41,82,136,80,139,79,208,79,86,127,89,127,91,127,92,127,93,127,94,127,96,127,99,127,100,127,101,127,102,127,103,127,107,127,108,127,109,127,111,127,112,127,115,127,117,127,118,127,119,127,120,127,122,127,123,127,124,127,125,127,127,127,128,127,130,127,131,127,132,127,133,127,134,127,135,127,136,127,137,127,139,127,141,127,143,127,144,127,145,127,146,127,147,127,149,127,150,127,151,127,152,127,153,127,155,127,156,127,160,127,162,127,163,127,165,127,166,127,168,127,169,127,170,127,171,127,172,127,173,127,174,127,177,127,179,127,180,127,181,127,182,127,183,127,186,127,187,127,190,127,192,127,194,127,195,127,196,127,198,127,199,127,200,127,201,127,203,127,205,127,207,127,208,127,209,127,210,127,211,127,214,127,215,127,217,127,218,127,219,127,220,127,221,127,222,127,226,127,227,127,226,117,203,122,146,124,165,108,182,150,155,82,131,116,233,84,233,79,84,128,178,131,222,143,112,149,201,94,28,96,159,109,24,94,91,101,56,129,254,148,75,96,188,112,195,126,174,124,201,81,129,104,177,124,111,130,36,78,134,143,207,145,126,102,174,78,5,140,169,100,74,128,218,80,151,117,206,113,229,91,189,143,102,111,134,78,130,100,99,149,214,94,153,101,23,82,194,136,200,112,163,82,14,115,51,116,151,103,247,120,22,151,52,78,187,144,222,156,203,109,219,81,65,141,29,84,206,98,178,115,241,131,246,150,132,159,195,148,54,79,154,127,204,81,117,112,117,150,173,92,134,152,230,83,228,78,156,110,9,116,180,105,107,120,143,153,89,117,24,82,36,118,65,109,243,103,109,81,153,159,75,128,153,84,60,123,191,122,228,127,231,127,232,127,234,127,235,127,236,127,237,127,239,127,242,127,244,127,245,127,246,127,247,127,248,127,249,127,250,127,253,127,254,127,255,127,2,128,7,128,8,128,9,128,10,128,14,128,15,128,17,128,19,128,26,128,27,128,29,128,30,128,31,128,33,128,35,128,36,128,43,128,44,128,45,128,46,128,47,128,48,128,50,128,52,128,57,128,58,128,60,128,62,128,64,128,65,128,68,128,69,128,71,128,72,128,73,128,78,128,79,128,80,128,81,128,83,128,85,128,86,128,87,128,89,128,91,128,92,128,93,128,94,128,95,128,96,128,97,128,98,128,99,128,100,128,101,128,102,128,103,128,104,128,107,128,108,128,109,128,110,128,111,128,112,128,114,128,115,128,116,128,117,128,118,128,119,128,120,128,121,128,122,128,123,128,124,128,125,128,134,150,132,87,226,98,71,150,124,105,4,90,2,100,211,123,15,111,75,150,166,130,98,83,133,152,144,94,137,112,179,99,100,83,79,134,129,156,147,158,140,120,50,151,239,141,66,141,127,158,94,111,132,121,85,95,70,150,46,98,116,154,21,84,221,148,163,79,197,101,101,92,97,92,21,127,81,134,47,108,139,95,135,115,228,110,255,126,230,92,27,99,106,91,230,110,117,83,113,78,160,99,101,117,161,98,110,143,38,79,209,78,166,108,182,126,186,139,29,132,186,135,87,127,59,144,35,149,169,123,161,154,248,136,61,132,27,109,134,154,220,126,136,89,187,158,155,115,1,120,130,134,108,154,130,154,27,86,23,84,203,87,112,78,166,158,86,83,200,143,9,129,146,119,146,153,238,134,225,110,19,133,252,102,98,97,43,111,126,128,129,128,130,128,133,128,136,128,138,128,141,128,142,128,143,128,144,128,145,128,146,128,148,128,149,128,151,128,153,128,158,128,163,128,166,128,167,128,168,128,172,128,176,128,179,128,181,128,182,128,184,128,185,128,187,128,197,128,199,128,200,128,201,128,202,128,203,128,207,128,208,128,209,128,210,128,211,128,212,128,213,128,216,128,223,128,224,128,226,128,227,128,230,128,238,128,245,128,247,128,249,128,251,128,254,128,255,128,0,129,1,129,3,129,4,129,5,129,7,129,8,129,11,129,12,129,21,129,23,129,25,129,27,129,28,129,29,129,31,129,32,129,33,129,34,129,35,129,36,129,37,129,38,129,39,129,40,129,41,129,42,129,43,129,45,129,46,129,48,129,51,129,52,129,53,129,55,129,57,129,58,129,59,129,60,129,61,129,63,129,41,140,146,130,43,131,242,118,19,108,217,95,189,131,43,115,5,131,26,149,219,107,219,119,198,148,111,83,2,131,146,81,61,94,140,140,56,141,72,78,171,115,154,103,133,104,118,145,9,151,100,113,161,108,9,119,146,90,65,149,207,107,142,127,39,102,208,91,185,89,154,90,232,149,247,149,236,78,12,132,153,132,172,106,223,118,48,149,27,115,166,104,95,91,47,119,154,145,97,151,220,124,247,143,28,140,37,95,115,124,216,121,197,137,204,108,28,135,198,91,66,94,201,104,32,119,245,126,149,81,77,81,201,82,41,90,5,127,98,151,215,130,207,99,132,119,208,133,210,121,58,110,153,94,153,89,17,133,109,112,17,108,191,98,191,118,79,101,175,96,253,149,14,102,159,135,35,158,237,148,13,84,125,84,44,140,120,100,64,129,65,129,66,129,67,129,68,129,69,129,71,129,73,129,77,129,78,129,79,129,82,129,86,129,87,129,88,129,91,129,92,129,93,129,94,129,95,129,97,129,98,129,99,129,100,129,102,129,104,129,106,129,107,129,108,129,111,129,114,129,115,129,117,129,118,129,119,129,120,129,129,129,131,129,132,129,133,129,134,129,135,129,137,129,139,129,140,129,141,129,142,129,144,129,146,129,147,129,148,129,149,129,150,129,151,129,153,129,154,129,158,129,159,129,160,129,161,129,162,129,164,129,165,129,167,129,169,129,171,129,172,129,173,129,174,129,175,129,176,129,177,129,178,129,180,129,181,129,182,129,183,129,184,129,185,129,188,129,189,129,190,129,191,129,196,129,197,129,199,129,200,129,201,129,203,129,205,129,206,129,207,129,208,129,209,129,210,129,211,129,121,100,17,134,33,106,156,129,232,120,105,100,84,155,185,98,43,103,171,131,168,88,216,158,171,108,32,111,222,91,76,150,11,140,95,114,208,103,199,98,97,114,169,78,198,89,205,107,147,88,174,102,85,94,223,82,85,97,40,103,238,118,102,119,103,114,70,122,255,98,234,84,80,84,160,148,163,144,28,90,179,126,22,108,67,78,118,89,16,128,72,89,87,83,55,117,190,150,202,86,32,99,17,129,124,96,249,149,214,109,98,84,129,153,133,81,233,90,253,128,174,89,19,151,42,80,229,108,60,92,223,98,96,79,63,83,123,129,6,144,186,110,43,133,200,98,116,94,190,120,181,100,123,99,245,95,24,90,127,145,31,158,63,92,79,99,66,128,125,91,110,85,74,149,77,149,133,109,168,96,224,103,222,114,221,81,129,91,212,129,213,129,214,129,215,129,216,129,217,129,218,129,219,129,220,129,221,129,222,129,223,129,224,129,225,129,226,129,228,129,229,129,230,129,232,129,233,129,235,129,238,129,239,129,240,129,241,129,242,129,245,129,246,129,247,129,248,129,249,129,250,129,253,129,255,129,3,130,7,130,8,130,9,130,10,130,11,130,14,130,15,130,17,130,19,130,21,130,22,130,23,130,24,130,25,130,26,130,29,130,32,130,36,130,37,130,38,130,39,130,41,130,46,130,50,130,58,130,60,130,61,130,63,130,64,130,65,130,66,130,67,130,69,130,70,130,72,130,74,130,76,130,77,130,78,130,80,130,81,130,82,130,83,130,84,130,85,130,86,130,87,130,89,130,91,130,92,130,93,130,94,130,96,130,97,130,98,130,99,130,100,130,101,130,102,130,103,130,105,130,231,98,222,108,91,114,109,98,174,148,189,126,19,129,83,109,156,81,4,95,116,89,170,82,18,96,115,89,150,102,80,134,159,117,42,99,230,97,239,124,250,139,230,84,39,107,37,158,180,107,213,133,85,84,118,80,164,108,106,85,180,141,44,114,21,94,21,96,54,116,205,98,146,99,76,114,152,95,67,110,62,109,0,101,88,111,216,118,208,120,252,118,84,117,36,82,219,83,83,78,158,94,193,101,42,128,214,128,155,98,134,84,40,82,174,112,141,136,209,141,225,108,120,84,218,128,249,87,244,136,84,141,106,150,77,145,105,79,155,108,183,85,198,118,48,120,168,98,249,112,142,111,109,95,236,132,218,104,124,120,247,123,168,129,11,103,79,158,103,99,176,120,111,87,18,120,57,151,121,98,171,98,136,82,53,116,215,107,106,130,107,130,108,130,109,130,113,130,117,130,118,130,119,130,120,130,123,130,124,130,128,130,129,130,131,130,133,130,134,130,135,130,137,130,140,130,144,130,147,130,148,130,149,130,150,130,154,130,155,130,158,130,160,130,162,130,163,130,167,130,178,130,181,130,182,130,186,130,187,130,188,130,191,130,192,130,194,130,195,130,197,130,198,130,201,130,208,130,214,130,217,130,218,130,221,130,226,130,231,130,232,130,233,130,234,130,236,130,237,130,238,130,240,130,242,130,243,130,245,130,246,130,248,130,250,130,252,130,253,130,254,130,255,130,0,131,10,131,11,131,13,131,16,131,18,131,19,131,22,131,24,131,25,131,29,131,30,131,31,131,32,131,33,131,34,131,35,131,36,131,37,131,38,131,41,131,42,131,46,131,48,131,50,131,55,131,59,131,61,131,100,85,62,129,178,117,174,118,57,83,222,117,251,80,65,92,108,139,199,123,79,80,71,114,151,154,216,152,2,111,226,116,104,121,135,100,165,119,252,98,145,152,43,141,193,84,88,128,82,78,106,87,249,130,13,132,115,94,237,81,246,116,196,139,79,92,97,87,252,108,135,152,70,90,52,120,68,155,235,143,149,124,86,82,81,98,250,148,198,78,134,131,97,132,233,131,178,132,212,87,52,103,3,87,110,102,102,109,49,140,221,102,17,112,31,103,58,107,22,104,26,98,187,89,3,78,196,81,6,111,210,103,143,108,118,81,203,104,71,89,103,107,102,117,14,93,16,129,80,159,215,101,72,121,65,121,145,154,119,141,130,92,94,78,1,79,47,84,81,89,12,120,104,86,20,108,196,143,3,95,125,108,227,108,171,139,144,99,62,131,63,131,65,131,66,131,68,131,69,131,72,131,74,131,75,131,76,131,77,131,78,131,83,131,85,131,86,131,87,131,88,131,89,131,93,131,98,131,112,131,113,131,114,131,115,131,116,131,117,131,118,131,121,131,122,131,126,131,127,131,128,131,129,131,130,131,131,131,132,131,135,131,136,131,138,131,139,131,140,131,141,131,143,131,144,131,145,131,148,131,149,131,150,131,151,131,153,131,154,131,157,131,159,131,161,131,162,131,163,131,164,131,165,131,166,131,167,131,172,131,173,131,174,131,175,131,181,131,187,131,190,131,191,131,194,131,195,131,196,131,198,131,200,131,201,131,203,131,205,131,206,131,208,131,209,131,210,131,211,131,213,131,215,131,217,131,218,131,219,131,222,131,226,131,227,131,228,131,230,131,231,131,232,131,235,131,236,131,237,131,112,96,61,109,117,114,102,98,142,148,197,148,67,83,193,143,126,123,223,78,38,140,126,78,212,158,177,148,179,148,77,82,92,111,99,144,69,109,52,140,17,88,76,93,32,107,73,107,170,103,91,84,84,129,140,127,153,88,55,133,58,95,162,98,71,106,57,149,114,101,132,96,101,104,167,119,84,78,168,79,231,93,152,151,172,100,216,127,237,92,207,79,141,122,7,82,4,131,20,78,47,96,131,122,166,148,181,79,178,78,230,121,52,116,228,82,185,130,210,100,189,121,221,91,129,108,82,151,123,143,34,108,62,80,127,83,5,110,206,100,116,102,48,108,197,96,119,152,247,139,134,94,60,116,119,122,203,121,24,78,177,144,3,116,66,108,218,86,75,145,197,108,139,141,58,83,198,134,242,102,175,142,72,92,113,154,32,110,238,131,239,131,243,131,244,131,245,131,246,131,247,131,250,131,251,131,252,131,254,131,255,131,0,132,2,132,5,132,7,132,8,132,9,132,10,132,16,132,18,132,19,132,20,132,21,132,22,132,23,132,25,132,26,132,27,132,30,132,31,132,32,132,33,132,34,132,35,132,41,132,42,132,43,132,44,132,45,132,46,132,47,132,48,132,50,132,51,132,52,132,53,132,54,132,55,132,57,132,58,132,59,132,62,132,63,132,64,132,65,132,66,132,67,132,68,132,69,132,71,132,72,132,73,132,74,132,75,132,76,132,77,132,78,132,79,132,80,132,82,132,83,132,84,132,85,132,86,132,88,132,93,132,94,132,95,132,96,132,98,132,100,132,101,132,102,132,103,132,104,132,106,132,110,132,111,132,112,132,114,132,116,132,119,132,121,132,123,132,124,132,214,83,54,90,139,159,163,141,187,83,8,87,167,152,67,103,155,145,201,108,104,81,202,117,243,98,172,114,56,82,157,82,58,127,148,112,56,118,116,83,74,158,183,105,110,120,192,150,217,136,164,127,54,113,195,113,137,81,211,103,228,116,228,88,24,101,183,86,169,139,118,153,112,98,213,126,249,96,237,112,236,88,193,78,186,78,205,95,231,151,251,78,164,139,3,82,138,89,171,126,84,98,205,78,229,101,14,98,56,131,201,132,99,131,141,135,148,113,182,110,185,91,210,126,151,81,201,99,212,103,137,128,57,131,21,136,18,81,122,91,130,89,177,143,115,78,93,108,101,81,37,137,111,143,46,150,74,133,94,116,16,149,240,149,166,109,229,130,49,95,146,100,18,109,40,132,110,129,195,156,94,88,91,141,9,78,193,83,125,132,126,132,127,132,128,132,129,132,131,132,132,132,133,132,134,132,138,132,141,132,143,132,144,132,145,132,146,132,147,132,148,132,149,132,150,132,152,132,154,132,155,132,157,132,158,132,159,132,160,132,162,132,163,132,164,132,165,132,166,132,167,132,168,132,169,132,170,132,171,132,172,132,173,132,174,132,176,132,177,132,179,132,181,132,182,132,183,132,187,132,188,132,190,132,192,132,194,132,195,132,197,132,198,132,199,132,200,132,203,132,204,132,206,132,207,132,210,132,212,132,213,132,215,132,216,132,217,132,218,132,219,132,220,132,222,132,225,132,226,132,228,132,231,132,232,132,233,132,234,132,235,132,237,132,238,132,239,132,241,132,242,132,243,132,244,132,245,132,246,132,247,132,248,132,249,132,250,132,251,132,253,132,254,132,0,133,1,133,2,133,30,79,99,101,81,104,211,85,39,78,20,100,154,154,107,98,194,90,95,116,114,130,169,109,238,104,231,80,142,131,2,120,64,103,57,82,153,108,177,126,187,80,101,85,94,113,91,123,82,102,202,115,235,130,73,103,113,92,32,82,125,113,107,136,234,149,85,150,197,100,97,141,179,129,132,85,85,108,71,98,46,127,146,88,36,79,70,85,79,141,76,102,10,78,26,92,243,136,162,104,78,99,13,122,231,112,141,130,250,82,246,151,17,92,232,84,181,144,205,126,98,89,74,141,199,134,12,130,13,130,102,141,68,100,4,92,81,97,137,109,62,121,190,139,55,120,51,117,123,84,56,79,171,142,241,109,32,90,197,126,94,121,136,108,161,91,118,90,26,117,190,128,78,97,23,110,240,88,31,117,37,117,114,114,71,83,243,126,3,133,4,133,5,133,6,133,7,133,8,133,9,133,10,133,11,133,13,133,14,133,15,133,16,133,18,133,20,133,21,133,22,133,24,133,25,133,27,133,28,133,29,133,30,133,32,133,34,133,35,133,36,133,37,133,38,133,39,133,40,133,41,133,42,133,45,133,46,133,47,133,48,133,49,133,50,133,51,133,52,133,53,133,54,133,62,133,63,133,64,133,65,133,66,133,68,133,69,133,70,133,71,133,75,133,76,133,77,133,78,133,79,133,80,133,81,133,82,133,83,133,84,133,85,133,87,133,88,133,90,133,91,133,92,133,93,133,95,133,96,133,97,133,98,133,99,133,101,133,102,133,103,133,105,133,106,133,107,133,108,133,109,133,110,133,111,133,112,133,113,133,115,133,117,133,118,133,119,133,120,133,124,133,125,133,127,133,128,133,129,133,1,119,219,118,105,82,220,128,35,87,8,94,49,89,238,114,189,101,127,110,215,139,56,92,113,134,65,83,243,119,254,98,246,101,192,78,223,152,128,134,158,91,198,139,242,83,226,119,127,79,78,92,118,154,203,89],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+240828),
	allocate([15,95,58,121,235,88,22,78,255,103,139,78,237,98,147,138,29,144,191,82,47,102,220,85,108,86,2,144,213,78,141,79,202,145,112,153,15,108,2,94,67,96,164,91,198,137,213,139,54,101,75,98,150,153,136,91,255,91,136,99,46,85,215,83,38,118,125,81,44,133,162,103,179,104,138,107,146,98,147,143,212,83,18,130,209,109,143,117,102,78,78,141,112,91,159,113,175,133,145,102,217,102,114,127,0,135,205,158,32,159,94,92,47,103,240,143,17,104,95,103,13,98,214,122,133,88,182,94,112,101,49,111,130,133,131,133,134,133,136,133,137,133,138,133,139,133,140,133,141,133,142,133,144,133,145,133,146,133,147,133,148,133,149,133,150,133,151,133,152,133,153,133,154,133,157,133,158,133,159,133,160,133,161,133,162,133,163,133,165,133,166,133,167,133,169,133,171,133,172,133,173,133,177,133,178,133,179,133,180,133,181,133,182,133,184,133,186,133,187,133,188,133,189,133,190,133,191,133,192,133,194,133,195,133,196,133,197,133,198,133,199,133,200,133,202,133,203,133,204,133,205,133,206,133,209,133,210,133,212,133,214,133,215,133,216,133,217,133,218,133,219,133,221,133,222,133,223,133,224,133,225,133,226,133,227,133,229,133,230,133,231,133,232,133,234,133,235,133,236,133,237,133,238,133,239,133,240,133,241,133,242,133,243,133,244,133,245,133,246,133,247,133,248,133,85,96,55,82,13,128,84,100,112,136,41,117,5,94,19,104,244,98,28,151,204,83,61,114,1,140,52,108,97,119,14,122,46,84,172,119,122,152,28,130,244,139,85,120,20,103,193,112,175,101,149,100,54,86,29,96,193,121,248,83,29,78,123,107,134,128,250,91,227,85,219,86,58,79,60,79,114,153,243,93,126,103,56,128,2,96,130,152,1,144,139,91,188,139,245,139,28,100,88,130,222,100,253,85,207,130,101,145,215,79,32,125,31,144,159,124,243,80,81,88,175,110,191,91,201,139,131,128,120,145,156,132,151,123,125,134,139,150,143,150,229,126,211,154,142,120,129,92,87,122,66,144,167,150,95,121,89,91,95,99,11,123,209,132,173,104,6,85,41,127,16,116,34,125,1,149,64,98,76,88,214,78,131,91,121,89,84,88,249,133,250,133,252,133,253,133,254,133,0,134,1,134,2,134,3,134,4,134,6,134,7,134,8,134,9,134,10,134,11,134,12,134,13,134,14,134,15,134,16,134,18,134,19,134,20,134,21,134,23,134,24,134,25,134,26,134,27,134,28,134,29,134,30,134,31,134,32,134,33,134,34,134,35,134,36,134,37,134,38,134,40,134,42,134,43,134,44,134,45,134,46,134,47,134,48,134,49,134,50,134,51,134,52,134,53,134,54,134,55,134,57,134,58,134,59,134,61,134,62,134,63,134,64,134,65,134,66,134,67,134,68,134,69,134,70,134,71,134,72,134,73,134,74,134,75,134,76,134,82,134,83,134,85,134,86,134,87,134,88,134,89,134,91,134,92,134,93,134,95,134,96,134,97,134,99,134,100,134,101,134,102,134,103,134,104,134,105,134,106,134,109,115,30,99,75,142,15,142,206,128,212,130,172,98,240,83,240,108,94,145,42,89,1,96,112,108,77,87,74,100,42,141,43,118,233,110,91,87,128,106,240,117,109,111,45,140,8,140,102,87,239,107,146,136,179,120,162,99,249,83,173,112,100,108,88,88,42,100,2,88,224,104,155,129,16,85,214,124,24,80,186,142,204,109,159,141,235,112,143,99,155,109,212,110,230,126,4,132,67,104,3,144,216,109,118,150,168,139,87,89,121,114,228,133,126,129,188,117,138,138,175,104,84,82,34,142,17,149,208,99,152,152,68,142,124,85,83,79,255,102,143,86,213,96,149,109,67,82,73,92,41,89,251,109,107,88,48,117,28,117,108,96,20,130,70,129,17,99,97,103,226,143,58,119,243,141,52,141,193,148,22,94,133,83,44,84,195,112,109,134,111,134,112,134,114,134,115,134,116,134,117,134,118,134,119,134,120,134,131,134,132,134,133,134,134,134,135,134,136,134,137,134,142,134,143,134,144,134,145,134,146,134,148,134,150,134,151,134,152,134,153,134,154,134,155,134,158,134,159,134,160,134,161,134,162,134,165,134,166,134,171,134,173,134,174,134,178,134,179,134,183,134,184,134,185,134,187,134,188,134,189,134,190,134,191,134,193,134,194,134,195,134,197,134,200,134,204,134,205,134,210,134,211,134,213,134,214,134,215,134,218,134,220,134,221,134,224,134,225,134,226,134,227,134,229,134,230,134,231,134,232,134,234,134,235,134,236,134,239,134,245,134,246,134,247,134,250,134,251,134,252,134,253,134,255,134,1,135,4,135,5,135,6,135,11,135,12,135,14,135,15,135,16,135,17,135,20,135,22,135,64,108,247,94,92,80,173,78,173,94,58,99,71,130,26,144,80,104,110,145,179,119,12,84,220,148,100,95,229,122,118,104,69,99,82,123,223,126,219,117,119,80,149,98,52,89,15,144,248,81,195,121,129,122,254,86,146,95,20,144,130,109,96,92,31,87,16,84,84,81,77,110,226,86,168,99,147,152,127,129,21,135,42,137,0,144,30,84,111,92,192,129,214,98,88,98,49,129,53,158,64,150,110,154,124,154,45,105,165,89,211,98,62,85,22,99,199,84,217,134,60,109,3,90,230,116,156,136,106,107,22,89,76,140,47,95,126,110,169,115,125,152,56,78,247,112,140,91,151,120,61,99,90,102,150,118,203,96,155,91,73,90,7,78,85,129,106,108,139,115,161,78,137,103,81,127,128,95,250,101,27,103,216,95,132,89,1,90,25,135,27,135,29,135,31,135,32,135,36,135,38,135,39,135,40,135,42,135,43,135,44,135,45,135,47,135,48,135,50,135,51,135,53,135,54,135,56,135,57,135,58,135,60,135,61,135,64,135,65,135,66,135,67,135,68,135,69,135,70,135,74,135,75,135,77,135,79,135,80,135,81,135,82,135,84,135,85,135,86,135,88,135,90,135,91,135,92,135,93,135,94,135,95,135,97,135,98,135,102,135,103,135,104,135,105,135,106,135,107,135,108,135,109,135,111,135,113,135,114,135,115,135,117,135,119,135,120,135,121,135,122,135,127,135,128,135,129,135,132,135,134,135,135,135,137,135,138,135,140,135,142,135,143,135,144,135,145,135,146,135,148,135,149,135,150,135,152,135,153,135,154,135,155,135,156,135,157,135,158,135,160,135,161,135,162,135,163,135,164,135,205,93,174,95,113,83,230,151,221,143,69,104,244,86,47,85,223,96,58,78,77,111,244,126,199,130,14,132,212,89,31,79,42,79,62,92,172,126,42,103,26,133,115,84,79,117,195,128,130,85,79,155,77,79,45,110,19,140,9,92,112,97,107,83,31,118,41,110,138,134,135,101,251,149,185,126,59,84,51,122,10,125,238,149,225,85,193,127,238,116,29,99,23,135,161,109,157,122,17,98,161,101,103,83,225,99,131,108,235,93,92,84,168,148,76,78,97,108,236,139,75,92,224,101,156,130,167,104,62,84,52,84,203,107,102,107,148,78,66,99,72,83,30,130,13,79,174,79,94,87,10,98,254,150,100,102,105,114,255,82,161,82,159,96,239,139,20,102,153,113,144,103,127,137,82,120,253,119,112,102,59,86,56,84,33,149,122,114,165,135,166,135,167,135,169,135,170,135,174,135,176,135,177,135,178,135,180,135,182,135,183,135,184,135,185,135,187,135,188,135,190,135,191,135,193,135,194,135,195,135,196,135,197,135,199,135,200,135,201,135,204,135,205,135,206,135,207,135,208,135,212,135,213,135,214,135,215,135,216,135,217,135,218,135,220,135,221,135,222,135,223,135,225,135,226,135,227,135,228,135,230,135,231,135,232,135,233,135,235,135,236,135,237,135,239,135,240,135,241,135,242,135,243,135,244,135,245,135,246,135,247,135,248,135,250,135,251,135,252,135,253,135,255,135,0,136,1,136,2,136,4,136,5,136,6,136,7,136,8,136,9,136,11,136,12,136,13,136,14,136,15,136,16,136,17,136,18,136,20,136,23,136,24,136,25,136,26,136,28,136,29,136,30,136,31,136,32,136,35,136,0,122,111,96,12,94,137,96,157,129,21,89,220,96,132,113,239,112,170,110,80,108,128,114,132,106,173,136,45,94,96,78,179,90,156,85,227,148,23,109,251,124,153,150,15,98,198,126,142,119,126,134,35,83,30,151,150,143,135,102,225,92,160,79,237,114,11,78,166,83,15,89,19,84,128,99,40,149,72,81,217,78,156,156,164,126,184,84,36,141,84,136,55,130,242,149,142,109,38,95,204,90,62,102,105,150,176,115,46,115,191,83,122,129,133,153,161,127,170,91,119,150,80,150,191,126,248,118,162,83,118,149,153,153,177,123,68,137,88,110,97,78,212,127,101,121,230,139,243,96,205,84,171,78,121,152,247,93,97,106,207,80,17,84,97,140,39,132,93,120,4,151,74,82,238,84,163,86,0,149,136,109,181,91,198,109,83,102,36,136,37,136,38,136,39,136,40,136,41,136,42,136,43,136,44,136,45,136,46,136,47,136,48,136,49,136,51,136,52,136,53,136,54,136,55,136,56,136,58,136,59,136,61,136,62,136,63,136,65,136,66,136,67,136,70,136,71,136,72,136,73,136,74,136,75,136,78,136,79,136,80,136,81,136,82,136,83,136,85,136,86,136,88,136,90,136,91,136,92,136,93,136,94,136,95,136,96,136,102,136,103,136,106,136,109,136,111,136,113,136,115,136,116,136,117,136,118,136,120,136,121,136,122,136,123,136,124,136,128,136,131,136,134,136,135,136,137,136,138,136,140,136,142,136,143,136,144,136,145,136,147,136,148,136,149,136,151,136,152,136,153,136,154,136,155,136,157,136,158,136,159,136,160,136,161,136,163,136,165,136,166,136,167,136,168,136,169,136,170,136,15,92,93,91,33,104,150,128,120,85,17,123,72,101,84,105,155,78,71,107,78,135,139,151,79,83,31,99,58,100,170,144,156,101,193,128,16,140,153,81,176,104,120,83,249,135,200,97,196,108,251,108,34,140,81,92,170,133,175,130,12,149,35,107,155,143,176,101,251,95,195,95,225,79,69,136,31,102,101,129,41,115,250,96,116,81,17,82,139,87,98,95,162,144,76,136,146,145,120,94,79,103,39,96,211,89,68,81,246,81,248,128,8,83,121,108,196,150,138,113,17,79,238,79,158,127,61,103,197,85,8,149,192,121,150,136,227,126,159,88,12,98,0,151,90,134,24,86,123,152,144,95,184,139,196,132,87,145,217,83,237,101,143,94,92,117,100,96,110,125,127,90,234,126,237,126,105,143,167,85,163,91,172,96,203,101,132,115,172,136,174,136,175,136,176,136,178,136,179,136,180,136,181,136,182,136,184,136,185,136,186,136,187,136,189,136,190,136,191,136,192,136,195,136,196,136,199,136,200,136,202,136,203,136,204,136,205,136,207,136,208,136,209,136,211,136,214,136,215,136,218,136,219,136,220,136,221,136,222,136,224,136,225,136,230,136,231,136,233,136,234,136,235,136,236,136,237,136,238,136,239,136,242,136,245,136,246,136,247,136,250,136,251,136,253,136,255,136,0,137,1,137,3,137,4,137,5,137,6,137,7,137,8,137,9,137,11,137,12,137,13,137,14,137,15,137,17,137,20,137,21,137,22,137,23,137,24,137,28,137,29,137,30,137,31,137,32,137,34,137,35,137,36,137,38,137,39,137,40,137,41,137,44,137,45,137,46,137,47,137,49,137,50,137,51,137,53,137,55,137,9,144,99,118,41,119,218,126,116,151,155,133,102,91,116,122,234,150,64,136,203,82,143,113,170,95,236,101,226,139,251,91,111,154,225,93,137,107,91,108,173,139,175,139,10,144,197,143,139,83,188,98,38,158,45,158,64,84,43,78,189,130,89,114,156,134,22,93,89,136,175,109,197,150,209,84,154,78,182,139,9,113,189,84,9,150,223,112,249,109,208,118,37,78,20,120,18,135,169,92,246,94,0,138,156,152,14,150,142,112,191,108,68,89,169,99,60,119,77,136,20,111,115,130,48,88,213,113,140,83,26,120,193,150,1,85,102,95,48,113,180,91,26,140,140,154,131,107,46,89,47,158,231,121,104,103,108,98,111,79,161,117,138,127,11,109,51,150,39,108,240,78,210,117,123,81,55,104,62,111,128,144,112,129,150,89,118,116,56,137,57,137,58,137,59,137,60,137,61,137,62,137,63,137,64,137,66,137,67,137,69,137,70,137,71,137,72,137,73,137,74,137,75,137,76,137,77,137,78,137,79,137,80,137,81,137,82,137,83,137,84,137,85,137,86,137,87,137,88,137,89,137,90,137,91,137,92,137,93,137,96,137,97,137,98,137,99,137,100,137,101,137,103,137,104,137,105,137,106,137,107,137,108,137,109,137,110,137,111,137,112,137,113,137,114,137,115,137,116,137,117,137,118,137,119,137,120,137,121,137,122,137,124,137,125,137,126,137,128,137,130,137,132,137,133,137,135,137,136,137,137,137,138,137,139,137,140,137,141,137,142,137,143,137,144,137,145,137,146,137,147,137,148,137,149,137,150,137,151,137,152,137,153,137,154,137,155,137,156,137,157,137,158,137,159,137,160,137,161,137,71,100,39,92,101,144,145,122,35,140,218,89,172,84,0,130,111,131,129,137,0,128,48,105,78,86,54,128,55,114,206,145,182,81,95,78,117,152,150,99,26,78,246,83,243,102,75,129,28,89,178,109,0,78,249,88,59,83,214,99,241,148,157,79,10,79,99,136,144,152,55,89,87,144,251,121,234,78,240,128,145,117,130,108,156,91,232,89,93,95,5,105,129,134,26,80,242,93,89,78,227,119,229,78,122,130,145,98,19,102,145,144,121,92,191,78,121,95,198,129,56,144,132,128,171,117,166,78,212,136,15,97,197,107,198,95,73,78,202,118,162,110,227,139,174,139,10,140,209,139,2,95,252,127,204,127,206,126,53,131,107,131,224,86,183,107,243,151,52,150,251,89,31,84,246,148,235,109,197,91,110,153,57,92,21,95,144,150,162,137,163,137,164,137,165,137,166,137,167,137,168,137,169,137,170,137,171,137,172,137,173,137,174,137,175,137,176,137,177,137,178,137,179,137,180,137,181,137,182,137,183,137,184,137,185,137,186,137,187,137,188,137,189,137,190,137,191,137,192,137,195,137,205,137,211,137,212,137,213,137,215,137,216,137,217,137,219,137,221,137,223,137,224,137,225,137,226,137,228,137,231,137,232,137,233,137,234,137,236,137,237,137,238,137,240,137,241,137,242,137,244,137,245,137,246,137,247,137,248,137,249,137,250,137,251,137,252,137,253,137,254,137,255,137,1,138,2,138,3,138,4,138,5,138,6,138,8,138,9,138,10,138,11,138,12,138,13,138,14,138,15,138,16,138,17,138,18,138,19,138,20,138,21,138,22,138,23,138,24,138,25,138,26,138,27,138,28,138,29,138,112,83,241,130,49,106,116,90,112,158,148,94,40,127,185,131,36,132,37,132,103,131,71,135,206,143,98,141,200,118,113,95,150,152,108,120,32,102,223,84,229,98,99,79,195,129,200,117,184,94,205,150,10,142,249,134,143,84,243,108,140,109,56,108,127,96,199,82,40,117,125,94,24,79,160,96,231,95,36,92,49,117,174,144,192,148,185,114,185,108,56,110,73,145,9,103,203,83,243,83,81,79,201,145,241,139,200,83,124,94,194,143,228,109,142,78,194,118,134,105,94,134,26,97,6,130,89,79,222,79,62,144,124,156,9,97,29,110,20,110,133,150,136,78,49,90,232,150,14,78,127,92,185,121,135,91,237,139,189,127,137,115,223,87,139,130,193,144,1,84,71,144,187,85,234,92,161,95,8,97,50,107,241,114,178,128,137,138,30,138,31,138,32,138,33,138,34,138,35,138,36,138,37,138,38,138,39,138,40,138,41,138,42,138,43,138,44,138,45,138,46,138,47,138,48,138,49,138,50,138,51,138,52,138,53,138,54,138,55,138,56,138,57,138,58,138,59,138,60,138,61,138,63,138,64,138,65,138,66,138,67,138,68,138,69,138,70,138,71,138,73,138,74,138,75,138,76,138,77,138,78,138,79,138,80,138,81,138,82,138,83,138,84,138,85,138,86,138,87,138,88,138,89,138,90,138,91,138,92,138,93,138,94,138,95,138,96,138,97,138,98,138,99,138,100,138,101,138,102,138,103,138,104,138,105,138,106,138,107,138,108,138,109,138,110,138,111,138,112,138,113,138,114,138,115,138,116,138,117,138,118,138,119,138,120,138,122,138,123,138,124,138,125,138,126,138,127,138,128,138,116,109,211,91,213,136,132,152,107,140,109,154,51,158,10,110,164,81,67,81,163,87,129,136,159,83,244,99,149,143,237,86,88,84,6,87,63,115,144,110,24,127,220,143,209,130,63,97,40,96,98,150,240,102,166,126,138,141,195,141,165,148,179,92,164,124,8,103,166,96,5,150,24,128,145,78,231,144,0,83,104,150,65,81,208,143,116,133,93,145,85,102,245,151,85,91,29,83,56,120,66,103,61,104,201,84,126,112,176,91,125,143,141,81,40,87,177,84,18,101,130,102,94,141,67,141,15,129,108,132,109,144,223,124,255,81,251,133,163,103,233,101,161,111,164,134,129,142,106,86,32,144,130,118,118,112,229,113,35,141,233,98,25,82,253,108,60,141,14,96,158,88,142,97,254,102,96,141,78,98,179,85,35,110,45,103,103,143,129,138,130,138,131,138,132,138,133,138,134,138,135,138,136,138,139,138,140,138,141,138,142,138,143,138,144,138,145,138,146,138,148,138,149,138,150,138,151,138,152,138,153,138,154,138,155,138,156,138,157,138,158,138,159,138,160,138,161,138,162,138,163,138,164,138,165,138,166,138,167,138,168,138,169,138,170,138,171,138,172,138,173,138,174,138,175,138,176,138,177,138,178,138,179,138,180,138,181,138,182,138,183,138,184,138,185,138,186,138,187,138,188,138,189,138,190,138,191,138,192,138,193,138,194,138,195,138,196,138,197,138,198,138,199,138,200,138,201,138,202,138,203,138,204,138,205,138,206,138,207,138,208,138,209,138,210,138,211,138,212,138,213,138,214,138,215,138,216,138,217,138,218,138,219,138,220,138,221,138,222,138,223,138,224,138,225,138,226,138,227,138,225,148,248,149,40,119,5,104,168,105,139,84,77,78,184,112,200,139,88,100,139,101,133,91,132,122,58,80,232,91,187,119,225,107,121,138,152,124,190,108,207,118,169,101,151,143,45,93,85,92,56,134,8,104,96,83,24,98,217,122,91,110,253,126,31,106,224,122,112,95,51,111,32,95,140,99,168,109,86,103,8,78,16,94,38,141,215,78,192,128,52,118,156,150,219,98,45,102,126,98,188,108,117,141,103,113,105,127,70,81,135,128,236,83,110,144,152,98,242,84,240,134,153,143,5,128,23,149,23,133,217,143,89,109,205,115,159,101,31,119,4,117,39,120,251,129,30,141,136,148,166,79,149,103,185,117,202,139,7,151,47,99,71,149,53,150,184,132,35,99,65,119,129,95,240,114,137,78,20,96,116,101,239,98,99,107,63,101,228,138,229,138,230,138,231,138,232,138,233,138,234,138,235,138,236,138,237,138,238,138,239,138,240,138,241,138,242,138,243,138,244,138,245,138,246,138,247,138,248,138,249,138,250,138,251,138,252,138,253,138,254,138,255,138,0,139,1,139,2,139,3,139,4,139,5,139,6,139,8,139,9,139,10,139,11,139,12,139,13,139,14,139,15,139,16,139,17,139,18,139,19,139,20,139,21,139,22,139,23,139,24,139,25,139,26,139,27,139,28,139,29,139,30,139,31,139,32,139,33,139,34,139,35,139,36,139,37,139,39,139,40,139,41,139,42,139,43,139,44,139,45,139,46,139,47,139,48,139,49,139,50,139,51,139,52,139,53,139,54,139,55,139,56,139,57,139,58,139,59,139,60,139,61,139,62,139,63,139,64,139,65,139,66,139,67,139,68,139,69,139,39,94,199,117,209,144,193,139,157,130,157,103,47,101,49,84,24,135,229,119,162,128,2,129,65,108,75,78,199,126,76,128,244,118,13,105,150,107,103,98,60,80,132,79,64,87,7,99,98,107,190,141,234,83,232,101,184,126,215,95,26,99,183,99,243,129,244,129,110,127,28,94,217,92,54,82,122,102,233,121,26,122,40,141,153,112,212,117,222,110,187,108,146,122,45,78,197,118,224,95,159,148,119,136,200,126,205,121,191,128,205,145,242,78,23,79,31,130,104,84,222,93,50,109,204,139,165,124,116,143,152,128,26,94,146,84,177,118,153,91,60,102,164,154,224,115,42,104,219,134,49,103,42,115,248,139,219,139,16,144,249,122,219,112,110,113,196,98,169,119,49,86,59,78,87,132,241,103,169,82,192,134,46,141,248,148,81,123,70,139,71,139,72,139,73,139,74,139,75,139,76,139,77,139,78,139,79,139,80,139,81,139,82,139,83,139,84,139,85,139,86,139,87,139,88,139,89,139,90,139,91,139,92,139,93,139,94,139,95,139,96,139,97,139,98,139,99,139,100,139,101,139,103,139,104,139,105,139,106,139,107,139,109,139,110,139,111,139,112,139,113,139,114,139,115,139,116,139,117,139,118,139,119,139,120,139,121,139,122,139,123,139,124,139,125,139,126,139,127,139,128,139,129,139,130,139,131,139,132,139,133,139,134,139,135,139,136,139,137,139,138,139,139,139,140,139,141,139,142,139,143,139,144,139,145,139,146,139,147,139,148,139,149,139,150,139,151,139,152,139,153,139,154,139,155,139,156,139,157,139,158,139,159,139,172,139,177,139,187,139,199,139,208,139,234,139,9,140,30,140,79,79,232,108,93,121,123,154,147,98,42,114,253,98,19,78,22,120,108,143,176,100,90,141,198,123,105,104,132,94,197,136,134,89,158,100,238,88,182,114,14,105,37,149,253,143,88,141,96,87,0,127,6,140,198,81,73,99,217,98,83,83,76,104,34,116,1,131,76,145,68,85,64,119,124,112,74,109,121,81,168,84,68,141,255,89,203,110,196,109,92,91,43,125,212,78,125,124,211,110,80,91,234,129,13,110,87,91,3,155,213,104,42,142,151,91,252,126,59,96,181,126,185,144,112,141,79,89,205,99,223,121,179,141,82,83,207,101,86,121,197,139,59,150,196,126,187,148,130,126,52,86,137,145,0,103,106,127,10,92,117,144,40,102,230,93,80,79,222,103,90,80,92,79,80,87,167,94,16,232,17,232,18,232,19,232,20,232,56,140,57,140,58,140,59,140,60,140,61,140,62,140,63,140,64,140,66,140,67,140,68,140,69,140,72,140,74,140,75,140,77,140,78,140,79,140,80,140,81,140,82,140,83,140,84,140,86,140,87,140,88,140,89,140,91,140,92,140,93,140,94,140,95,140,96,140,99,140,100,140,101,140,102,140,103,140,104,140,105,140,108,140,109,140,110,140,111,140,112,140,113,140,114,140,116,140,117,140,118,140,119,140,123,140,124,140,125,140,126,140,127,140,128,140,129,140,131,140,132,140,134,140,135,140,136,140,139,140,141,140,142,140,143,140,144,140,145,140,146,140,147,140,149,140,150,140,151,140,153,140,154,140,155,140,156,140,157,140,158,140,159,140,160,140,161,140,162,140,163,140,164,140,165,140,166,140,167,140,168,140,169,140,170,140,171,140,172,140,173,140,141,78,12,78,64,81,16,78,255,94,69,83,21,78,152,78,30,78,50,155,108,91,105,86,40,78,186,121,63,78,21,83,71,78,45,89,59,114,110,83,16,108,223,86,228,128,151,153,211,107,126,119,23,159,54,78,159,78,16,159,92,78,105,78,147,78,136,130,91,91,108,85,15,86,196,78,141,83,157,83,163,83,165,83,174,83,101,151,93,141,26,83,245,83,38,83,46,83,62,83,92,141,102,83,99,83,2,82,8,82,14,82,45,82,51,82,63,82,64,82,76,82,94,82,97,82,92,82,175,132,125,82,130,82,129,82,144,82,147,82,130,81,84,127,187,78,195,78,201,78,194,78,232,78,225,78,235,78,222,78,27,79,243,78,34,79,100,79,245,78,37,79,39,79,9,79,43,79,94,79,103,79,56,101,90,79,93,79,174,140,175,140,176,140,177,140,178,140,179,140,180,140,181,140,182,140,183,140,184,140,185,140,186,140,187,140,188,140,189,140,190,140,191,140,192,140,193,140,194,140,195,140,196,140,197,140,198,140,199,140,200,140,201,140,202,140,203,140,204,140,205,140,206,140,207,140,208,140,209,140,210,140,211,140,212,140,213,140,214,140,215,140,216,140,217,140,218,140,219,140,220,140,221,140,222,140,223,140,224,140,225,140,226,140,227,140,228,140,229,140,230,140,231,140,232,140,233,140,234,140,235,140,236,140,237,140,238,140,239,140,240,140,241,140,242,140,243,140,244,140,245,140,246,140,247,140,248,140,249,140,250,140,251,140,252,140,253,140,254,140,255,140,0,141,1,141,2,141,3,141,4,141,5,141,6,141,7,141,8,141,9,141,10,141,11,141,12,141,13,141,95,79,87,79,50,79,61,79,118,79,116,79,145,79,137,79,131,79,143,79,126,79,123,79,170,79,124,79,172,79,148,79,230,79,232,79,234,79,197,79,218,79,227,79,220,79,209,79,223,79,248,79,41,80,76,80,243,79,44,80,15,80,46,80,45,80,254,79,28,80,12,80,37,80,40,80,126,80,67,80,85,80,72,80,78,80,108,80,123,80,165,80,167,80,169,80,186,80,214,80,6,81,237,80,236,80,230,80,238,80,7,81,11,81,221,78,61,108,88,79,101,79,206,79,160,159,70,108,116,124,110,81,253,93,201,158,152,153,129,81,20,89,249,82,13,83,7,138,16,83,235,81,25,89,85,81,160,78,86,81,179,78,110,136,164,136,181,78,20,129,210,136,128,121,52,91,3,136,184,127,171,81,177,81,189,81,188,81,14,141,15,141,16,141,17,141,18,141,19,141,20,141,21,141,22,141,23,141,24,141,25,141,26,141,27,141,28,141,32,141,81,141,82,141,87,141,95,141,101,141,104,141,105,141,106,141,108,141,110,141,111,141,113,141,114,141,120,141,121,141,122,141,123,141,124,141,125,141,126,141,127,141,128,141,130,141,131,141,134,141,135,141,136,141,137,141,140,141,141,141,142,141,143,141,144,141,146,141,147,141,149,141,150,141,151,141,152,141,153,141,154,141,155,141,156,141,157,141,158,141,160,141,161,141,162,141,164,141,165,141,166,141,167,141,168,141,169,141,170,141,171,141,172,141,173,141,174,141,175,141,176,141,178,141,182,141,183,141,185,141,187,141,189,141,192,141,193,141,194,141,197,141,199,141,200,141,201,141,202,141,205,141,208,141,210,141,211,141,212,141,199,81,150,81,162,81,165,81,160,139,166,139,167,139,170,139,180,139,181,139,183,139,194,139,195,139,203,139,207,139,206,139,210,139,211,139,212,139,214,139,216,139,217,139,220,139,223,139,224,139,228,139,232,139,233,139,238,139,240,139,243,139,246,139,249,139,252,139,255,139,0,140,2,140,4,140,7,140,12,140,15,140,17,140,18,140,20,140,21,140,22,140,25,140,27,140,24,140,29,140,31,140,32,140,33,140,37,140,39,140,42,140,43,140,46,140,47,140,50,140,51,140,53,140,54,140,105,83,122,83,29,150,34,150,33,150,49,150,42,150,61,150,60,150,66,150,73,150,84,150,95,150,103,150,108,150,114,150,116,150,136,150,141,150,151,150,176,150,151,144,155,144,157,144,153,144,172,144,161,144,180,144,179,144,182,144,186,144,213,141,216,141,217,141,220,141,224,141,225,141,226,141,229,141,230,141,231,141,233,141,237,141,238,141,240,141,241,141,242,141,244,141,246,141,252,141,254,141,255,141,0,142,1,142,2,142,3,142,4,142,6,142,7,142,8,142,11,142,13,142,14,142,16,142,17,142,18,142,19,142,21,142,22,142,23,142,24,142,25,142,26,142,27,142,28,142,32,142,33,142,36,142,37,142,38,142,39,142,40,142,43,142,45,142,48,142,50,142,51,142,52,142,54,142,55,142,56,142,59,142,60,142,62,142,63,142,67,142,69,142,70,142,76,142,77,142,78,142,79,142,80,142,83,142,84,142,85,142,86,142,87,142,88,142,90,142,91,142,92,142,93,142,94,142,95,142,96,142,97,142,98,142,99,142,100,142,101,142,103,142,104,142,106,142,107,142,110,142,113,142,184,144,176,144,207,144,197,144,190,144,208,144,196,144,199,144,211,144,230,144,226,144,220,144,215,144,219,144,235,144,239,144,254,144,4,145,34,145,30,145,35,145,49,145,47,145,57,145,67,145,70,145,13,82,66,89,162,82,172,82,173,82,190,82,255,84,208,82,214,82,240,82,223,83,238,113,205,119,244,94,245,81,252,81,47,155,182,83,1,95,90,117,239,93,76,87,169,87,161,87,126,88,188,88,197,88,209,88,41,87,44,87,42,87,51,87,57,87,46,87,47,87,92,87,59,87,66,87,105,87,133,87,107,87,134,87,124,87,123,87,104,87,109,87,118,87,115,87,173,87,164,87,140,87,178,87,207,87,167,87,180,87,147,87,160,87,213,87,216,87,218,87,217,87,210,87,184,87,244,87,239,87,248,87,228,87,221,87,115,142,117,142,119,142,120,142,121,142,122,142,123,142,125,142,126,142,128,142,130,142,131,142,132,142,134,142,136,142,137,142,138,142,139,142,140,142,141,142,142,142,145,142,146,142,147,142,149,142,150,142,151,142,152,142,153,142,154,142,155,142,157,142,159,142,160,142,161,142,162,142,163,142,164,142,165,142,166,142,167,142,168,142,169,142,170,142,173,142,174,142,176,142,177,142,179,142,180,142,181,142,182,142,183,142,184,142,185,142,187,142,188,142,189,142,190,142,191,142,192,142,193,142,194,142,195,142,196,142,197,142,198,142,199,142,200,142,201,142,202,142,203,142,204,142,205,142,207,142,208,142,209,142,210,142,211,142,212,142,213,142,214,142,215,142,216,142,217,142,218,142,219,142,220,142,221,142,222,142,223,142,224,142,225,142,226,142,227,142,228,142,11,88,13,88,253,87,237,87,0,88,30,88,25,88,68,88,32,88,101,88,108,88,129,88,137,88,154,88,128,88,168,153,25,159,255,97,121,130,125,130,127,130,143,130,138,130,168,130,132,130,142,130,145,130,151,130,153,130,171,130,184,130,190,130,176,130,200,130,202,130,227,130,152,130,183,130,174,130,203,130,204,130,193,130,169,130,180,130,161,130,170,130,159,130,196,130,206,130,164,130,225,130,9,131,247,130,228,130,15,131,7,131,220,130,244,130,210,130,216,130,12,131,251,130,211,130,17,131,26,131,6,131,20,131,21,131,224,130,213,130,28,131,81,131,91,131,92,131,8,131,146,131,60,131,52,131,49,131,155,131,94,131,47,131,79,131,71,131,67,131,95,131,64,131,23,131,96,131,45,131,58,131,51,131,102,131,101,131,229,142,230,142,231,142,232,142,233,142,234,142,235,142,236,142,237,142,238,142,239,142,240,142,241,142,242,142,243,142,244,142,245,142,246,142,247,142,248,142,249,142,250,142,251,142,252,142,253,142,254,142,255,142,0,143,1,143,2,143,3,143,4,143,5,143,6,143,7,143,8,143,9,143,10,143,11,143,12,143,13,143,14,143,15,143,16,143,17,143,18,143,19,143,20,143,21,143,22,143,23,143,24,143,25,143,26,143,27,143,28,143,29,143,30,143,31,143,32,143,33,143,34,143,35,143,36,143,37,143,38,143,39,143,40,143,41,143,42,143,43,143,44,143,45,143,46,143,47,143,48,143,49,143,50,143,51,143,52,143,53,143,54,143,55,143,56,143,57,143,58,143,59,143,60,143,61,143,62,143,63,143,64,143,65,143,66,143,67,143,68,143,104,131,27,131,105,131,108,131,106,131,109,131,110,131,176,131,120,131,179,131,180,131,160,131,170,131,147,131,156,131,133,131,124,131,182,131,169,131,125,131,184,131,123,131,152,131,158,131,168,131,186,131,188,131,193,131,1,132,229,131,216,131,7,88,24,132,11,132,221,131,253,131,214,131,28,132,56,132,17,132,6,132,212,131,223,131,15,132,3,132,248,131,249,131,234,131,197,131,192,131,38,132,240,131,225,131,92,132,81,132,90,132,89,132,115,132,135,132,136,132,122,132,137,132,120,132,60,132,70,132,105,132,118,132,140,132,142,132,49,132,109,132,193,132,205,132,208,132,230,132,189,132,211,132,202,132,191,132,186,132,224,132,161,132,185,132,180,132,151,132,229,132,227,132,12,133,13,117,56,133,240,132,57,133,31,133,58,133,69,143,70,143,71,143,72,143,73,143,74,143,75,143,76,143,77,143,78,143,79,143,80,143,81,143,82,143,83,143,84,143,85,143,86,143,87,143,88,143,89,143,90,143,91,143,92,143,93,143,94,143,95,143,96,143,97,143,98,143,99,143,100,143,101,143,106,143,128,143,140,143,146,143,157,143,160,143,161,143,162,143,164,143,165,143,166,143,167,143,170,143,172,143,173,143,174,143,175,143,178,143,179,143,180,143,181,143,183,143,184,143,186,143,187,143,188,143,191,143,192,143,195,143,198,143,201,143,202,143,203,143,204,143,205,143,207,143,210,143,214,143,215,143,218,143,224,143,225,143,227,143,231,143,236,143,239,143,241,143,242,143,244,143,245,143,246,143,250,143,251,143,252,143,254,143,255,143,7,144,8,144,12,144,14,144,19,144,21,144,24,144,86,133,59,133,255,132,252,132,89,133,72,133,104,133,100,133,94,133,122,133,162,119,67,133,114,133,123,133,164,133,168,133,135,133,143,133,121,133,174,133,156,133,133,133,185,133,183,133,176,133,211,133,193,133,220,133,255,133,39,134,5,134,41,134,22,134,60,134,254,94,8,95,60,89,65,89,55,128,85,89,90,89,88,89,15,83,34,92,37,92,44,92,52,92,76,98,106,98,159,98,187,98,202,98,218,98,215,98,238,98,34,99,246,98,57,99,75,99,67,99,173,99,246,99,113,99,122,99,142,99,180,99,109,99,172,99,138,99,105,99,174,99,188,99,242,99,248,99,224,99,255,99,196,99,222,99,206,99,82,100,198,99,190,99,69,100,65,100,11,100,27,100,32,100,12,100,38,100,33,100,94,100,132,100,109,100,150,100,25,144,28,144,35,144,36,144,37,144,39,144,40,144,41,144,42,144,43,144,44,144,48,144,49,144,50,144,51,144,52,144,55,144,57,144,58,144,61,144,63,144,64,144,67,144,69,144,70,144,72,144,73,144,74,144,75,144,76,144,78,144,84,144,85,144,86,144,89,144,90,144,92,144,93,144,94,144,95,144,96,144,97,144,100,144,102,144,103,144,105,144,106,144,107,144,108,144,111,144,112,144,113,144,114,144,115,144,118,144,119,144,120,144,121,144,122,144,123,144,124,144,126,144,129,144,132,144,133,144,134,144,135,144,137,144,138,144,140,144,141,144,142,144,143,144,144,144,146,144,148,144,150,144,152,144,154,144,156,144,158,144,159,144,160,144,164,144,165,144,167,144,168,144,169,144,171,144,173,144,178,144,183,144,188,144,189,144,191,144,192,144,122,100,183,100,184,100,153,100,186,100,192,100,208,100,215,100,228,100,226,100,9,101,37,101,46,101,11,95,210,95,25,117,17,95,95,83,241,83,253,83,233,83,232,83,251,83,18,84,22,84,6,84,75,84,82,84,83,84,84,84,86,84,67,84,33,84,87,84,89,84,35,84,50,84,130,84,148,84,119,84,113,84,100,84,154,84,155,84,132,84,118,84,102,84,157,84,208,84,173,84,194,84,180,84,210,84,167,84,166,84,211,84,212,84,114,84,163,84,213,84,187,84,191,84,204,84,217,84,218,84,220,84,169,84,170,84,164,84,221,84,207,84,222,84,27,85,231,84,32,85,253,84,20,85,243,84,34,85,35,85,15,85,17,85,39,85,42,85,103,85,143,85,181,85,73,85,109,85,65,85,85,85,63,85,80,85,60,85,194,144,195,144,198,144,200,144,201,144,203,144,204,144,205,144,210,144,212,144,213,144,214,144,216,144,217,144,218,144,222,144,223,144,224,144,227,144,228,144,229,144,233,144,234,144,236,144,238,144,240,144,241,144,242,144,243,144,245,144,246,144,247,144,249,144,250,144,251,144,252,144,255,144,0,145,1,145,3,145,5,145,6,145,7,145,8,145,9,145,10,145,11,145,12,145,13,145,14,145,15,145,16,145,17,145,18,145,19,145,20,145,21,145,22,145,23,145,24,145,26,145,27,145,28,145,29,145,31,145,32,145,33,145,36,145,37,145,38,145,39,145,40,145,41,145,42,145,43,145,44,145,45,145,46,145,48,145,50,145,51,145,52,145,53,145,54,145,55,145,56,145,58,145,59,145,60,145,61,145,62,145,63,145,64,145,65,145,66,145,68,145,55,85,86,85,117,85,118,85,119,85,51,85,48,85,92,85,139,85,210,85,131,85,177,85,185,85,136,85,129,85,159,85,126,85,214,85,145,85,123,85,223,85,189,85,190,85,148,85,153,85,234,85,247,85,201,85,31,86,209,85,235,85,236,85,212,85,230,85,221,85,196,85,239,85,229,85,242,85,243,85,204,85,205,85,232,85,245,85,228,85,148,143,30,86,8,86,12,86,1,86,36,86,35,86,254,85,0,86,39,86,45,86,88,86,57,86,87,86,44,86,77,86,98,86,89,86,92,86,76,86,84,86,134,86,100,86,113,86,107,86,123,86,124,86,133,86,147,86,175,86,212,86,215,86,221,86,225,86,245,86,235,86,249,86,255,86,4,87,10,87,9,87,28,87,15,94,25,94,20,94,17,94,49,94,59,94,60,94,69,145,71,145,72,145,81,145,83,145,84,145,85,145,86,145,88,145,89,145,91,145,92,145,95,145,96,145,102,145,103,145,104,145,107,145,109,145,115,145,122,145,123,145,124,145,128,145,129,145,130,145,131,145,132,145,134,145,136,145,138,145,142,145,143,145,147,145,148,145,149,145,150,145,151,145,152,145,153,145,156,145,157,145,158,145,159,145,160,145,161,145,164,145,165,145,166,145,167,145,168,145,169,145,171,145,172,145,176,145,177,145,178,145,179,145,182,145,183,145,184,145,185,145,187,145,188,145,189,145,190,145,191,145,192,145,193,145,194,145,195,145,196,145,197,145,198,145,200,145,203,145,208,145,210,145,211,145,212,145,213,145,214,145,215,145,216,145,217,145,218,145,219,145,221,145,222,145,223,145,224,145,225,145,226,145,227,145,228,145,229,145,55,94,68,94,84,94,91,94,94,94,97,94,140,92,122,92,141,92,144,92,150,92,136,92,152,92,153,92,145,92,154,92,156,92,181,92,162,92,189,92,172,92,171,92,177,92,163,92,193,92,183,92,196,92,210,92,228,92,203,92,229,92,2,93,3,93,39,93,38,93,46,93,36,93,30,93,6,93,27,93,88,93,62,93,52,93,61,93,108,93,91,93,111,93,93,93,107,93,75,93,74,93,105,93,116,93,130,93,153,93,157,93,115,140,183,93,197,93,115,95,119,95,130,95,135,95,137,95,140,95,149,95,153,95,156,95,168,95,173,95,181,95,188,95,98,136,97,95,173,114,176,114,180,114,183,114,184,114,195,114,193,114,206,114,205,114,210,114,232,114,239,114,233,114,242,114,244,114,247,114,1,115,243,114,3,115,250,114,230,145,231,145,232,145,233,145,234,145,235,145,236,145,237,145,238,145,239,145,240,145,241,145,242,145,243,145,244,145,245,145,246,145,247,145,248,145,249,145,250,145,251,145,252,145,253,145,254,145,255,145,0,146,1,146,2,146,3,146,4,146,5,146,6,146,7,146,8,146,9,146,10,146,11,146,12,146,13,146,14,146,15,146,16,146,17,146,18,146,19,146,20,146,21,146,22,146,23,146,24,146,25,146,26,146,27,146,28,146,29,146,30,146,31,146,32,146,33,146,34,146,35,146,36,146,37,146,38,146,39,146,40,146,41,146,42,146,43,146,44,146,45,146,46,146,47,146,48,146,49,146,50,146,51,146,52,146,53,146,54,146,55,146,56,146,57,146,58,146,59,146,60,146,61,146,62,146,63,146,64,146,65,146,66,146,67,146,68,146,69,146,251,114,23,115,19,115,33,115,10,115,30,115,29,115,21,115,34,115,57,115,37,115,44,115,56,115,49,115,80,115,77,115,87,115,96,115,108,115,111,115,126,115,27,130,37,89,231,152,36,89,2,89,99,153,103,153,104,153,105,153,106,153,107,153,108,153,116,153,119,153,125,153,128,153,132,153,135,153,138,153,141,153,144,153,145,153,147,153,148,153,149,153,128,94,145,94,139,94,150,94,165,94,160,94,185,94,181,94,190,94,179,94,83,141,210,94,209,94,219,94,232,94,234,94,186,129,196,95,201,95,214,95,207,95,3,96,238,95,4,96,225,95,228,95,254,95,5,96,6,96,234,95,237,95,248,95,25,96,53,96,38,96,27,96,15,96,13,96,41,96,43,96,10,96,63,96,33,96,120,96,121,96,123,96,122,96,66,96,70,146,71,146,72,146,73,146,74,146,75,146,76,146,77,146,78,146,79,146,80,146,81,146,82,146,83,146,84,146,85,146,86,146,87,146,88,146,89,146,90,146,91,146,92,146,93,146,94,146,95,146,96,146,97,146,98,146,99,146,100,146,101,146,102,146,103,146,104,146,105,146,106,146,107,146,108,146,109,146,110,146,111,146,112,146,113,146,114,146,115,146,117,146,118,146,119,146,120,146,121,146,122,146,123,146,124,146,125,146,126,146,127,146,128,146,129,146,130,146,131,146,132,146,133,146,134,146,135,146,136,146,137,146,138,146,139,146,140,146,141,146,143,146,144,146,145,146,146,146,147,146,148,146,149,146,150,146,151,146,152,146,153,146,154,146,155,146,156,146,157,146,158,146,159,146,160,146,161,146,162,146,163,146,164,146,165,146,166,146,167,146,106,96,125,96,150,96,154,96,173,96,157,96,131,96,146,96,140,96,155,96,236,96,187,96,177,96,221,96,216,96,198,96,218,96,180,96,32,97,38,97,21,97,35,97,244,96,0,97,14,97,43,97,74,97,117,97,172,97,148,97,167,97,183,97,212,97,245,97,221,95,179,150,233,149,235,149,241,149,243,149,245,149,246,149,252,149,254,149,3,150,4,150,6,150,8,150,10,150,11,150,12,150,13,150,15,150,18,150,21,150,22,150,23,150,25,150,26,150,44,78,63,114,21,98,53,108,84,108,92,108,74,108,163,108,133,108,144,108,148,108,140,108,104,108,105,108,116,108,118,108,134,108,169,108,208,108,212,108,173,108,247,108,248,108,241,108,215,108,178,108,224,108,214,108,250,108,235,108,238,108,177,108,211,108,239,108,254,108,168,146,169,146,170,146,171,146,172,146,173,146,175,146,176,146,177,146,178,146,179,146,180,146,181,146,182,146,183,146,184,146,185,146,186,146,187,146,188,146,189,146,190,146,191,146,192,146,193,146,194,146,195,146,196,146,197,146,198,146,199,146,201,146,202,146,203,146,204,146,205,146,206,146,207,146,208,146,209,146,210,146,211,146,212,146,213,146,214,146,215,146,216,146,217,146,218,146,219,146,220,146,221,146,222,146,223,146,224,146,225,146,226,146,227,146,228,146,229,146,230,146,231,146,232,146,233,146,234,146,235,146,236,146,237,146,238,146,239,146,240,146,241,146,242,146,243,146,244,146,245,146,246,146,247,146,248,146,249,146,250,146,251,146,252,146,253,146,254,146,255,146,0,147,1,147,2,147,3,147,4,147,5,147,6,147,7,147,8,147,9,147,57,109,39,109,12,109,67,109,72,109,7,109,4,109,25,109,14,109,43,109,77,109,46,109,53,109,26,109,79,109,82,109,84,109,51,109,145,109,111,109,158,109,160,109,94,109,147,109,148,109,92,109,96,109,124,109,99,109,26,110,199,109,197,109,222,109,14,110,191,109,224,109,17,110,230,109,221,109,217,109,22,110,171,109,12,110,174,109,43,110,110,110,78,110,107,110,178,110,95,110,134,110,83,110,84,110,50,110,37,110,68,110,223,110,177,110,152,110,224,110,45,111,226,110,165,110,167,110,189,110,187,110,183,110,215,110,180,110,207,110,143,110,194,110,159,110,98,111,70,111,71,111,36,111,21,111,249,110,47,111,54,111,75,111,116,111,42,111,9,111,41,111,137,111,141,111,140,111,120,111,114,111,124,111,122,111,209,111,10,147,11,147,12,147,13,147,14,147,15,147,16,147,17,147,18,147,19,147,20,147,21,147,22,147,23,147,24,147,25,147,26,147,27,147,28,147,29,147,30,147,31,147,32,147,33,147,34,147,35,147,36,147,37,147,38,147,39,147,40,147,41,147,42,147,43,147,44,147,45,147,46,147,47,147,48,147,49,147,50,147,51,147,52,147,53,147,54,147,55,147,56,147,57,147,58,147,59,147,60,147,61,147,63,147,64,147,65,147,66,147,67,147,68,147,69,147,70,147,71,147,72,147,73,147,74,147,75,147,76,147,77,147,78,147,79,147,80,147,81,147,82,147,83,147,84,147,85,147,86,147,87,147,88,147,89,147,90,147,91,147,92,147,93,147,94,147,95,147,96,147,97,147,98,147,99,147,100,147,101,147,102,147,103,147,104,147,105,147,107,147,201,111,167,111,185,111,182,111,194,111,225,111,238,111,222,111,224,111,239,111,26,112,35,112,27,112,57,112,53,112,79,112,94,112,128,91],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+251068),
	allocate([132,91,149,91,147,91,165,91,184,91,47,117,158,154,52,100,228,91,238,91,48,137,240,91,71,142,7,139,182,143,211,143,213,143,229,143,238,143,228,143,233,143,230,143,243,143,232,143,5,144,4,144,11,144,38,144,17,144,13,144,22,144,33,144,53,144,54,144,45,144,47,144,68,144,81,144,82,144,80,144,104,144,88,144,98,144,91,144,185,102,116,144,125,144,130,144,136,144,131,144,139,144,80,95,87,95,86,95,88,95,59,92,171,84,80,92,89,92,113,91,99,92,102,92,188,127,42,95,41,95,45,95,116,130,60,95,59,155,110,92,129,89,131,89,141,89,169,89,170,89,163,89,108,147,109,147,110,147,111,147,112,147,113,147,114,147,115,147,116,147,117,147,118,147,119,147,120,147,121,147,122,147,123,147,124,147,125,147,126,147,127,147,128,147,129,147,130,147,131,147,132,147,133,147,134,147,135,147,136,147,137,147,138,147,139,147,140,147,141,147,142,147,144,147,145,147,146,147,147,147,148,147,149,147,150,147,151,147,152,147,153,147,154,147,155,147,156,147,157,147,158,147,159,147,160,147,161,147,162,147,163,147,164,147,165,147,166,147,167,147,168,147,169,147,170,147,171,147,172,147,173,147,174,147,175,147,176,147,177,147,178,147,179,147,180,147,181,147,182,147,183,147,184,147,185,147,186,147,187,147,188,147,189,147,190,147,191,147,192,147,193,147,194,147,195,147,196,147,197,147,198,147,199,147,200,147,201,147,203,147,204,147,205,147,151,89,202,89,171,89,158,89,164,89,210,89,178,89,175,89,215,89,190,89,5,90,6,90,221,89,8,90,227,89,216,89,249,89,12,90,9,90,50,90,52,90,17,90,35,90,19,90,64,90,103,90,74,90,85,90,60,90,98,90,117,90,236,128,170,90,155,90,119,90,122,90,190,90,235,90,178,90,210,90,212,90,184,90,224,90,227,90,241,90,214,90,230,90,216,90,220,90,9,91,23,91,22,91,50,91,55,91,64,91,21,92,28,92,90,91,101,91,115,91,81,91,83,91,98,91,117,154,119,154,120,154,122,154,127,154,125,154,128,154,129,154,133,154,136,154,138,154,144,154,146,154,147,154,150,154,152,154,155,154,156,154,157,154,159,154,160,154,162,154,163,154,165,154,167,154,159,126,161,126,163,126,165,126,168,126,169,126,206,147,207,147,208,147,209,147,210,147,211,147,212,147,213,147,215,147,216,147,217,147,218,147,219,147,220,147,221,147,222,147,223,147,224,147,225,147,226,147,227,147,228,147,229,147,230,147,231,147,232,147,233,147,234,147,235,147,236,147,237,147,238,147,239,147,240,147,241,147,242,147,243,147,244,147,245,147,246,147,247,147,248,147,249,147,250,147,251,147,252,147,253,147,254,147,255,147,0,148,1,148,2,148,3,148,4,148,5,148,6,148,7,148,8,148,9,148,10,148,11,148,12,148,13,148,14,148,15,148,16,148,17,148,18,148,19,148,20,148,21,148,22,148,23,148,24,148,25,148,26,148,27,148,28,148,29,148,30,148,31,148,32,148,33,148,34,148,35,148,36,148,37,148,38,148,39,148,40,148,41,148,42,148,43,148,44,148,45,148,46,148,173,126,176,126,190,126,192,126,193,126,194,126,201,126,203,126,204,126,208,126,212,126,215,126,219,126,224,126,225,126,232,126,235,126,238,126,239,126,241,126,242,126,13,127,246,126,250,126,251,126,254,126,1,127,2,127,3,127,7,127,8,127,11,127,12,127,15,127,17,127,18,127,23,127,25,127,28,127,27,127,31,127,33,127,34,127,35,127,36,127,37,127,38,127,39,127,42,127,43,127,44,127,45,127,47,127,48,127,49,127,50,127,51,127,53,127,122,94,127,117,219,93,62,117,149,144,142,115,145,115,174,115,162,115,159,115,207,115,194,115,209,115,183,115,179,115,192,115,201,115,200,115,229,115,217,115,124,152,10,116,233,115,231,115,222,115,186,115,242,115,15,116,42,116,91,116,38,116,37,116,40,116,48,116,46,116,44,116,47,148,48,148,49,148,50,148,51,148,52,148,53,148,54,148,55,148,56,148,57,148,58,148,59,148,60,148,61,148,63,148,64,148,65,148,66,148,67,148,68,148,69,148,70,148,71,148,72,148,73,148,74,148,75,148,76,148,77,148,78,148,79,148,80,148,81,148,82,148,83,148,84,148,85,148,86,148,87,148,88,148,89,148,90,148,91,148,92,148,93,148,94,148,95,148,96,148,97,148,98,148,99,148,100,148,101,148,102,148,103,148,104,148,105,148,106,148,108,148,109,148,110,148,111,148,112,148,113,148,114,148,115,148,116,148,117,148,118,148,119,148,120,148,121,148,122,148,123,148,124,148,125,148,126,148,127,148,128,148,129,148,130,148,131,148,132,148,145,148,150,148,152,148,199,148,207,148,211,148,212,148,218,148,230,148,251,148,28,149,32,149,27,116,26,116,65,116,92,116,87,116,85,116,89,116,119,116,109,116,126,116,156,116,142,116,128,116,129,116,135,116,139,116,158,116,168,116,169,116,144,116,167,116,210,116,186,116,234,151,235,151,236,151,76,103,83,103,94,103,72,103,105,103,165,103,135,103,106,103,115,103,152,103,167,103,117,103,168,103,158,103,173,103,139,103,119,103,124,103,240,103,9,104,216,103,10,104,233,103,176,103,12,104,217,103,181,103,218,103,179,103,221,103,0,104,195,103,184,103,226,103,14,104,193,103,253,103,50,104,51,104,96,104,97,104,78,104,98,104,68,104,100,104,131,104,29,104,85,104,102,104,65,104,103,104,64,104,62,104,74,104,73,104,41,104,181,104,143,104,116,104,119,104,147,104,107,104,194,104,110,105,252,104,31,105,32,105,249,104,39,149,51,149,61,149,67,149,72,149,75,149,85,149,90,149,96,149,110,149,116,149,117,149,119,149,120,149,121,149,122,149,123,149,124,149,125,149,126,149,128,149,129,149,130,149,131,149,132,149,133,149,134,149,135,149,136,149,137,149,138,149,139,149,140,149,141,149,142,149,143,149,144,149,145,149,146,149,147,149,148,149,149,149,150,149,151,149,152,149,153,149,154,149,155,149,156,149,157,149,158,149,159,149,160,149,161,149,162,149,163,149,164,149,165,149,166,149,167,149,168,149,169,149,170,149,171,149,172,149,173,149,174,149,175,149,176,149,177,149,178,149,179,149,180,149,181,149,182,149,183,149,184,149,185,149,186,149,187,149,188,149,189,149,190,149,191,149,192,149,193,149,194,149,195,149,196,149,197,149,198,149,199,149,200,149,201,149,202,149,203,149,36,105,240,104,11,105,1,105,87,105,227,104,16,105,113,105,57,105,96,105,66,105,93,105,132,105,107,105,128,105,152,105,120,105,52,105,204,105,135,105,136,105,206,105,137,105,102,105,99,105,121,105,155,105,167,105,187,105,171,105,173,105,212,105,177,105,193,105,202,105,223,105,149,105,224,105,141,105,255,105,47,106,237,105,23,106,24,106,101,106,242,105,68,106,62,106,160,106,80,106,91,106,53,106,142,106,121,106,61,106,40,106,88,106,124,106,145,106,144,106,169,106,151,106,171,106,55,115,82,115,129,107,130,107,135,107,132,107,146,107,147,107,141,107,154,107,155,107,161,107,170,107,107,143,109,143,113,143,114,143,115,143,117,143,118,143,120,143,119,143,121,143,122,143,124,143,126,143,129,143,130,143,132,143,135,143,139,143,204,149,205,149,206,149,207,149,208,149,209,149,210,149,211,149,212,149,213,149,214,149,215,149,216,149,217,149,218,149,219,149,220,149,221,149,222,149,223,149,224,149,225,149,226,149,227,149,228,149,229,149,230,149,231,149,236,149,255,149,7,150,19,150,24,150,27,150,30,150,32,150,35,150,36,150,37,150,38,150,39,150,40,150,41,150,43,150,44,150,45,150,47,150,48,150,55,150,56,150,57,150,58,150,62,150,65,150,67,150,74,150,78,150,79,150,81,150,82,150,83,150,86,150,87,150,88,150,89,150,90,150,92,150,93,150,94,150,96,150,99,150,101,150,102,150,107,150,109,150,110,150,111,150,112,150,113,150,115,150,120,150,121,150,122,150,123,150,124,150,125,150,126,150,127,150,128,150,129,150,130,150,131,150,132,150,135,150,137,150,138,150,141,143,142,143,143,143,152,143,154,143,206,142,11,98,23,98,27,98,31,98,34,98,33,98,37,98,36,98,44,98,231,129,239,116,244,116,255,116,15,117,17,117,19,117,52,101,238,101,239,101,240,101,10,102,25,102,114,103,3,102,21,102,0,102,133,112,247,102,29,102,52,102,49,102,54,102,53,102,6,128,95,102,84,102,65,102,79,102,86,102,97,102,87,102,119,102,132,102,140,102,167,102,157,102,190,102,219,102,220,102,230,102,233,102,50,141,51,141,54,141,59,141,61,141,64,141,69,141,70,141,72,141,73,141,71,141,77,141,85,141,89,141,199,137,202,137,203,137,204,137,206,137,207,137,208,137,209,137,110,114,159,114,93,114,102,114,111,114,126,114,127,114,132,114,139,114,141,114,143,114,146,114,8,99,50,99,176,99,140,150,142,150,145,150,146,150,147,150,149,150,150,150,154,150,155,150,157,150,158,150,159,150,160,150,161,150,162,150,163,150,164,150,165,150,166,150,168,150,169,150,170,150,171,150,172,150,173,150,174,150,175,150,177,150,178,150,180,150,181,150,183,150,184,150,186,150,187,150,191,150,194,150,195,150,200,150,202,150,203,150,208,150,209,150,211,150,212,150,214,150,215,150,216,150,217,150,218,150,219,150,220,150,221,150,222,150,223,150,225,150,226,150,227,150,228,150,229,150,230,150,231,150,235,150,236,150,237,150,238,150,240,150,241,150,242,150,244,150,245,150,248,150,250,150,251,150,252,150,253,150,255,150,2,151,3,151,5,151,10,151,11,151,12,151,16,151,17,151,18,151,20,151,21,151,23,151,24,151,25,151,26,151,27,151,29,151,31,151,32,151,63,100,216,100,4,128,234,107,243,107,253,107,245,107,249,107,5,108,7,108,6,108,13,108,21,108,24,108,25,108,26,108,33,108,41,108,36,108,42,108,50,108,53,101,85,101,107,101,77,114,82,114,86,114,48,114,98,134,22,82,159,128,156,128,147,128,188,128,10,103,189,128,177,128,171,128,173,128,180,128,183,128,231,128,232,128,233,128,234,128,219,128,194,128,196,128,217,128,205,128,215,128,16,103,221,128,235,128,241,128,244,128,237,128,13,129,14,129,242,128,252,128,21,103,18,129,90,140,54,129,30,129,44,129,24,129,50,129,72,129,76,129,83,129,116,129,89,129,90,129,113,129,96,129,105,129,124,129,125,129,109,129,103,129,77,88,181,90,136,129,130,129,145,129,213,110,163,129,170,129,204,129,38,103,202,129,187,129,33,151,34,151,35,151,36,151,37,151,38,151,39,151,40,151,41,151,43,151,44,151,46,151,47,151,49,151,51,151,52,151,53,151,54,151,55,151,58,151,59,151,60,151,61,151,63,151,64,151,65,151,66,151,67,151,68,151,69,151,70,151,71,151,72,151,73,151,74,151,75,151,76,151,77,151,78,151,79,151,80,151,81,151,84,151,85,151,87,151,88,151,90,151,92,151,93,151,95,151,99,151,100,151,102,151,103,151,104,151,106,151,107,151,108,151,109,151,110,151,111,151,112,151,113,151,114,151,117,151,119,151,120,151,121,151,122,151,123,151,125,151,126,151,127,151,128,151,129,151,130,151,131,151,132,151,134,151,135,151,136,151,137,151,138,151,140,151,142,151,143,151,144,151,147,151,149,151,150,151,151,151,153,151,154,151,155,151,156,151,157,151,193,129,166,129,36,107,55,107,57,107,67,107,70,107,89,107,209,152,210,152,211,152,213,152,217,152,218,152,179,107,64,95,194,107,243,137,144,101,81,159,147,101,188,101,198,101,196,101,195,101,204,101,206,101,210,101,214,101,128,112,156,112,150,112,157,112,187,112,192,112,183,112,171,112,177,112,232,112,202,112,16,113,19,113,22,113,47,113,49,113,115,113,92,113,104,113,69,113,114,113,74,113,120,113,122,113,152,113,179,113,181,113,168,113,160,113,224,113,212,113,231,113,249,113,29,114,40,114,108,112,24,113,102,113,185,113,62,98,61,98,67,98,72,98,73,98,59,121,64,121,70,121,73,121,91,121,92,121,83,121,90,121,98,121,87,121,96,121,111,121,103,121,122,121,133,121,138,121,154,121,167,121,179,121,209,95,208,95,158,151,159,151,161,151,162,151,164,151,165,151,166,151,167,151,168,151,169,151,170,151,172,151,174,151,176,151,177,151,179,151,181,151,182,151,183,151,184,151,185,151,186,151,187,151,188,151,189,151,190,151,191,151,192,151,193,151,194,151,195,151,196,151,197,151,198,151,199,151,200,151,201,151,202,151,203,151,204,151,205,151,206,151,207,151,208,151,209,151,210,151,211,151,212,151,213,151,214,151,215,151,216,151,217,151,218,151,219,151,220,151,221,151,222,151,223,151,224,151,225,151,226,151,227,151,228,151,229,151,232,151,238,151,239,151,240,151,241,151,242,151,244,151,247,151,248,151,249,151,250,151,251,151,252,151,253,151,254,151,255,151,0,152,1,152,2,152,3,152,4,152,5,152,6,152,7,152,8,152,9,152,10,152,11,152,12,152,13,152,14,152,60,96,93,96,90,96,103,96,65,96,89,96,99,96,171,96,6,97,13,97,93,97,169,97,157,97,203,97,209,97,6,98,128,128,127,128,147,108,246,108,252,109,246,119,248,119,0,120,9,120,23,120,24,120,17,120,171,101,45,120,28,120,29,120,57,120,58,120,59,120,31,120,60,120,37,120,44,120,35,120,41,120,78,120,109,120,86,120,87,120,38,120,80,120,71,120,76,120,106,120,155,120,147,120,154,120,135,120,156,120,161,120,163,120,178,120,185,120,165,120,212,120,217,120,201,120,236,120,242,120,5,121,244,120,19,121,36,121,30,121,52,121,155,159,249,158,251,158,252,158,241,118,4,119,13,119,249,118,7,119,8,119,26,119,34,119,25,119,45,119,38,119,53,119,56,119,80,119,81,119,71,119,67,119,90,119,104,119,15,152,16,152,17,152,18,152,19,152,20,152,21,152,22,152,23,152,24,152,25,152,26,152,27,152,28,152,29,152,30,152,31,152,32,152,33,152,34,152,35,152,36,152,37,152,38,152,39,152,40,152,41,152,42,152,43,152,44,152,45,152,46,152,47,152,48,152,49,152,50,152,51,152,52,152,53,152,54,152,55,152,56,152,57,152,58,152,59,152,60,152,61,152,62,152,63,152,64,152,65,152,66,152,67,152,68,152,69,152,70,152,71,152,72,152,73,152,74,152,75,152,76,152,77,152,78,152,79,152,80,152,81,152,82,152,83,152,84,152,85,152,86,152,87,152,88,152,89,152,90,152,91,152,92,152,93,152,94,152,95,152,96,152,97,152,98,152,99,152,100,152,101,152,102,152,103,152,104,152,105,152,106,152,107,152,108,152,109,152,110,152,98,119,101,119,127,119,141,119,125,119,128,119,140,119,145,119,159,119,160,119,176,119,181,119,189,119,58,117,64,117,78,117,75,117,72,117,91,117,114,117,121,117,131,117,88,127,97,127,95,127,72,138,104,127,116,127,113,127,121,127,129,127,126,127,205,118,229,118,50,136,133,148,134,148,135,148,139,148,138,148,140,148,141,148,143,148,144,148,148,148,151,148,149,148,154,148,155,148,156,148,163,148,164,148,171,148,170,148,173,148,172,148,175,148,176,148,178,148,180,148,182,148,183,148,184,148,185,148,186,148,188,148,189,148,191,148,196,148,200,148,201,148,202,148,203,148,204,148,205,148,206,148,208,148,209,148,210,148,213,148,214,148,215,148,217,148,216,148,219,148,222,148,223,148,224,148,226,148,228,148,229,148,231,148,232,148,234,148,111,152,112,152,113,152,114,152,115,152,116,152,139,152,142,152,146,152,149,152,153,152,163,152,168,152,169,152,170,152,171,152,172,152,173,152,174,152,175,152,176,152,177,152,178,152,179,152,180,152,181,152,182,152,183,152,184,152,185,152,186,152,187,152,188,152,189,152,190,152,191,152,192,152,193,152,194,152,195,152,196,152,197,152,198,152,199,152,200,152,201,152,202,152,203,152,204,152,205,152,207,152,208,152,212,152,214,152,215,152,219,152,220,152,221,152,224,152,225,152,226,152,227,152,228,152,229,152,230,152,233,152,234,152,235,152,236,152,237,152,238,152,239,152,240,152,241,152,242,152,243,152,244,152,245,152,246,152,247,152,248,152,249,152,250,152,251,152,252,152,253,152,254,152,255,152,0,153,1,153,2,153,3,153,4,153,5,153,6,153,7,153,233,148,235,148,238,148,239,148,243,148,244,148,245,148,247,148,249,148,252,148,253,148,255,148,3,149,2,149,6,149,7,149,9,149,10,149,13,149,14,149,15,149,18,149,19,149,20,149,21,149,22,149,24,149,27,149,29,149,30,149,31,149,34,149,42,149,43,149,41,149,44,149,49,149,50,149,52,149,54,149,55,149,56,149,60,149,62,149,63,149,66,149,53,149,68,149,69,149,70,149,73,149,76,149,78,149,79,149,82,149,83,149,84,149,86,149,87,149,88,149,89,149,91,149,94,149,95,149,93,149,97,149,98,149,100,149,101,149,102,149,103,149,104,149,105,149,106,149,107,149,108,149,111,149,113,149,114,149,115,149,58,149,231,119,236,119,201,150,213,121,237,121,227,121,235,121,6,122,71,93,3,122,2,122,30,122,20,122,8,153,9,153,10,153,11,153,12,153,14,153,15,153,17,153,18,153,19,153,20,153,21,153,22,153,23,153,24,153,25,153,26,153,27,153,28,153,29,153,30,153,31,153,32,153,33,153,34,153,35,153,36,153,37,153,38,153,39,153,40,153,41,153,42,153,43,153,44,153,45,153,47,153,48,153,49,153,50,153,51,153,52,153,53,153,54,153,55,153,56,153,57,153,58,153,59,153,60,153,61,153,62,153,63,153,64,153,65,153,66,153,67,153,68,153,69,153,70,153,71,153,72,153,73,153,74,153,75,153,76,153,77,153,78,153,79,153,80,153,81,153,82,153,83,153,86,153,87,153,88,153,89,153,90,153,91,153,92,153,93,153,94,153,95,153,96,153,97,153,98,153,100,153,102,153,115,153,120,153,121,153,123,153,126,153,130,153,131,153,137,153,57,122,55,122,81,122,207,158,165,153,112,122,136,118,142,118,147,118,153,118,164,118,222,116,224,116,44,117,32,158,34,158,40,158,41,158,42,158,43,158,44,158,50,158,49,158,54,158,56,158,55,158,57,158,58,158,62,158,65,158,66,158,68,158,70,158,71,158,72,158,73,158,75,158,76,158,78,158,81,158,85,158,87,158,90,158,91,158,92,158,94,158,99,158,102,158,103,158,104,158,105,158,106,158,107,158,108,158,113,158,109,158,115,158,146,117,148,117,150,117,160,117,157,117,172,117,163,117,179,117,180,117,184,117,196,117,177,117,176,117,195,117,194,117,214,117,205,117,227,117,232,117,230,117,228,117,235,117,231,117,3,118,241,117,252,117,255,117,16,118,0,118,5,118,12,118,23,118,10,118,37,118,24,118,21,118,25,118,140,153,142,153,154,153,155,153,156,153,157,153,158,153,159,153,160,153,161,153,162,153,163,153,164,153,166,153,167,153,169,153,170,153,171,153,172,153,173,153,174,153,175,153,176,153,177,153,178,153,179,153,180,153,181,153,182,153,183,153,184,153,185,153,186,153,187,153,188,153,189,153,190,153,191,153,192,153,193,153,194,153,195,153,196,153,197,153,198,153,199,153,200,153,201,153,202,153,203,153,204,153,205,153,206,153,207,153,208,153,209,153,210,153,211,153,212,153,213,153,214,153,215,153,216,153,217,153,218,153,219,153,220,153,221,153,222,153,223,153,224,153,225,153,226,153,227,153,228,153,229,153,230,153,231,153,232,153,233,153,234,153,235,153,236,153,237,153,238,153,239,153,240,153,241,153,242,153,243,153,244,153,245,153,246,153,247,153,248,153,249,153,27,118,60,118,34,118,32,118,64,118,45,118,48,118,63,118,53,118,67,118,62,118,51,118,77,118,94,118,84,118,92,118,86,118,107,118,111,118,202,127,230,122,120,122,121,122,128,122,134,122,136,122,149,122,166,122,160,122,172,122,168,122,173,122,179,122,100,136,105,136,114,136,125,136,127,136,130,136,162,136,198,136,183,136,188,136,201,136,226,136,206,136,227,136,229,136,241,136,26,137,252,136,232,136,254,136,240,136,33,137,25,137,19,137,27,137,10,137,52,137,43,137,54,137,65,137,102,137,123,137,139,117,229,128,178,118,180,118,220,119,18,128,20,128,22,128,28,128,32,128,34,128,37,128,38,128,39,128,41,128,40,128,49,128,11,128,53,128,67,128,70,128,77,128,82,128,105,128,113,128,131,137,120,152,128,152,131,152,250,153,251,153,252,153,253,153,254,153,255,153,0,154,1,154,2,154,3,154,4,154,5,154,6,154,7,154,8,154,9,154,10,154,11,154,12,154,13,154,14,154,15,154,16,154,17,154,18,154,19,154,20,154,21,154,22,154,23,154,24,154,25,154,26,154,27,154,28,154,29,154,30,154,31,154,32,154,33,154,34,154,35,154,36,154,37,154,38,154,39,154,40,154,41,154,42,154,43,154,44,154,45,154,46,154,47,154,48,154,49,154,50,154,51,154,52,154,53,154,54,154,55,154,56,154,57,154,58,154,59,154,60,154,61,154,62,154,63,154,64,154,65,154,66,154,67,154,68,154,69,154,70,154,71,154,72,154,73,154,74,154,75,154,76,154,77,154,78,154,79,154,80,154,81,154,82,154,83,154,84,154,85,154,86,154,87,154,88,154,89,154,137,152,140,152,141,152,143,152,148,152,154,152,155,152,158,152,159,152,161,152,162,152,165,152,166,152,77,134,84,134,108,134,110,134,127,134,122,134,124,134,123,134,168,134,141,134,139,134,172,134,157,134,167,134,163,134,170,134,147,134,169,134,182,134,196,134,181,134,206,134,176,134,186,134,177,134,175,134,201,134,207,134,180,134,233,134,241,134,242,134,237,134,243,134,208,134,19,135,222,134,244,134,223,134,216,134,209,134,3,135,7,135,248,134,8,135,10,135,13,135,9,135,35,135,59,135,30,135,37,135,46,135,26,135,62,135,72,135,52,135,49,135,41,135,55,135,63,135,130,135,34,135,125,135,126,135,123,135,96,135,112,135,76,135,110,135,139,135,83,135,99,135,124,135,100,135,89,135,101,135,147,135,175,135,168,135,210,135,90,154,91,154,92,154,93,154,94,154,95,154,96,154,97,154,98,154,99,154,100,154,101,154,102,154,103,154,104,154,105,154,106,154,107,154,114,154,131,154,137,154,141,154,142,154,148,154,149,154,153,154,166,154,169,154,170,154,171,154,172,154,173,154,174,154,175,154,178,154,179,154,180,154,181,154,185,154,187,154,189,154,190,154,191,154,195,154,196,154,198,154,199,154,200,154,201,154,202,154,205,154,206,154,207,154,208,154,210,154,212,154,213,154,214,154,215,154,217,154,218,154,219,154,220,154,221,154,222,154,224,154,226,154,227,154,228,154,229,154,231,154,232,154,233,154,234,154,236,154,238,154,240,154,241,154,242,154,243,154,244,154,245,154,246,154,247,154,248,154,250,154,252,154,253,154,254,154,255,154,0,155,1,155,2,155,4,155,5,155,6,155,198,135,136,135,133,135,173,135,151,135,131,135,171,135,229,135,172,135,181,135,179,135,203,135,211,135,189,135,209,135,192,135,202,135,219,135,234,135,224,135,238,135,22,136,19,136,254,135,10,136,27,136,33,136,57,136,60,136,54,127,66,127,68,127,69,127,16,130,250,122,253,122,8,123,3,123,4,123,21,123,10,123,43,123,15,123,71,123,56,123,42,123,25,123,46,123,49,123,32,123,37,123,36,123,51,123,62,123,30,123,88,123,90,123,69,123,117,123,76,123,93,123,96,123,110,123,123,123,98,123,114,123,113,123,144,123,166,123,167,123,184,123,172,123,157,123,168,123,133,123,170,123,156,123,162,123,171,123,180,123,209,123,193,123,204,123,221,123,218,123,229,123,230,123,234,123,12,124,254,123,252,123,15,124,22,124,11,124,7,155,9,155,10,155,11,155,12,155,13,155,14,155,16,155,17,155,18,155,20,155,21,155,22,155,23,155,24,155,25,155,26,155,27,155,28,155,29,155,30,155,32,155,33,155,34,155,36,155,37,155,38,155,39,155,40,155,41,155,42,155,43,155,44,155,45,155,46,155,48,155,49,155,51,155,52,155,53,155,54,155,55,155,56,155,57,155,58,155,61,155,62,155,63,155,64,155,70,155,74,155,75,155,76,155,78,155,80,155,82,155,83,155,85,155,86,155,87,155,88,155,89,155,90,155,91,155,92,155,93,155,94,155,95,155,96,155,97,155,98,155,99,155,100,155,101,155,102,155,103,155,104,155,105,155,106,155,107,155,108,155,109,155,110,155,111,155,112,155,113,155,114,155,115,155,116,155,117,155,118,155,119,155,120,155,121,155,122,155,123,155,31,124,42,124,38,124,56,124,65,124,64,124,254,129,1,130,2,130,4,130,236,129,68,136,33,130,34,130,35,130,45,130,47,130,40,130,43,130,56,130,59,130,51,130,52,130,62,130,68,130,73,130,75,130,79,130,90,130,95,130,104,130,126,136,133,136,136,136,216,136,223,136,94,137,157,127,159,127,167,127,175,127,176,127,178,127,124,124,73,101,145,124,157,124,156,124,158,124,162,124,178,124,188,124,189,124,193,124,199,124,204,124,205,124,200,124,197,124,215,124,232,124,110,130,168,102,191,127,206,127,213,127,229,127,225,127,230,127,233,127,238,127,243,127,248,124,119,125,166,125,174,125,71,126,155,126,184,158,180,158,115,141,132,141,148,141,145,141,177,141,103,141,109,141,71,140,73,140,74,145,80,145,78,145,79,145,100,145,124,155,125,155,126,155,127,155,128,155,129,155,130,155,131,155,132,155,133,155,134,155,135,155,136,155,137,155,138,155,139,155,140,155,141,155,142,155,143,155,144,155,145,155,146,155,147,155,148,155,149,155,150,155,151,155,152,155,153,155,154,155,155,155,156,155,157,155,158,155,159,155,160,155,161,155,162,155,163,155,164,155,165,155,166,155,167,155,168,155,169,155,170,155,171,155,172,155,173,155,174,155,175,155,176,155,177,155,178,155,179,155,180,155,181,155,182,155,183,155,184,155,185,155,186,155,187,155,188,155,189,155,190,155,191,155,192,155,193,155,194,155,195,155,196,155,197,155,198,155,199,155,200,155,201,155,202,155,203,155,204,155,205,155,206,155,207,155,208,155,209,155,210,155,211,155,212,155,213,155,214,155,215,155,216,155,217,155,218,155,219,155,98,145,97,145,112,145,105,145,111,145,125,145,126,145,114,145,116,145,121,145,140,145,133,145,144,145,141,145,145,145,162,145,163,145,170,145,173,145,174,145,175,145,181,145,180,145,186,145,85,140,126,158,184,141,235,141,5,142,89,142,105,142,181,141,191,141,188,141,186,141,196,141,214,141,215,141,218,141,222,141,206,141,207,141,219,141,198,141,236,141,247,141,248,141,227,141,249,141,251,141,228,141,9,142,253,141,20,142,29,142,31,142,44,142,46,142,35,142,47,142,58,142,64,142,57,142,53,142,61,142,49,142,73,142,65,142,66,142,81,142,82,142,74,142,112,142,118,142,124,142,111,142,116,142,133,142,143,142,148,142,144,142,156,142,158,142,120,140,130,140,138,140,133,140,152,140,148,140,155,101,214,137,222,137,218,137,220,137,220,155,221,155,222,155,223,155,224,155,225,155,226,155,227,155,228,155,229,155,230,155,231,155,232,155,233,155,234,155,235,155,236,155,237,155,238,155,239,155,240,155,241,155,242,155,243,155,244,155,245,155,246,155,247,155,248,155,249,155,250,155,251,155,252,155,253,155,254,155,255,155,0,156,1,156,2,156,3,156,4,156,5,156,6,156,7,156,8,156,9,156,10,156,11,156,12,156,13,156,14,156,15,156,16,156,17,156,18,156,19,156,20,156,21,156,22,156,23,156,24,156,25,156,26,156,27,156,28,156,29,156,30,156,31,156,32,156,33,156,34,156,35,156,36,156,37,156,38,156,39,156,40,156,41,156,42,156,43,156,44,156,45,156,46,156,47,156,48,156,49,156,50,156,51,156,52,156,53,156,54,156,55,156,56,156,57,156,58,156,59,156,229,137,235,137,239,137,62,138,38,139,83,151,233,150,243,150,239,150,6,151,1,151,8,151,15,151,14,151,42,151,45,151,48,151,62,151,128,159,131,159,133,159,134,159,135,159,136,159,137,159,138,159,140,159,254,158,11,159,13,159,185,150,188,150,189,150,206,150,210,150,191,119,224,150,142,146,174,146,200,146,62,147,106,147,202,147,143,147,62,148,107,148,127,156,130,156,133,156,134,156,135,156,136,156,35,122,139,156,142,156,144,156,145,156,146,156,148,156,149,156,154,156,155,156,158,156,159,156,160,156,161,156,162,156,163,156,165,156,166,156,167,156,168,156,169,156,171,156,173,156,174,156,176,156,177,156,178,156,179,156,180,156,181,156,182,156,183,156,186,156,187,156,188,156,189,156,196,156,197,156,198,156,199,156,202,156,203,156,60,156,61,156,62,156,63,156,64,156,65,156,66,156,67,156,68,156,69,156,70,156,71,156,72,156,73,156,74,156,75,156,76,156,77,156,78,156,79,156,80,156,81,156,82,156,83,156,84,156,85,156,86,156,87,156,88,156,89,156,90,156,91,156,92,156,93,156,94,156,95,156,96,156,97,156,98,156,99,156,100,156,101,156,102,156,103,156,104,156,105,156,106,156,107,156,108,156,109,156,110,156,111,156,112,156,113,156,114,156,115,156,116,156,117,156,118,156,119,156,120,156,121,156,122,156,123,156,125,156,126,156,128,156,131,156,132,156,137,156,138,156,140,156,143,156,147,156,150,156,151,156,152,156,153,156,157,156,170,156,172,156,175,156,185,156,190,156,191,156,192,156,193,156,194,156,200,156,201,156,209,156,210,156,218,156,219,156,224,156,225,156,204,156,205,156,206,156,207,156,208,156,211,156,212,156,213,156,215,156,216,156,217,156,220,156,221,156,223,156,226,156,124,151,133,151,145,151,146,151,148,151,175,151,171,151,163,151,178,151,180,151,177,154,176,154,183,154,88,158,182,154,186,154,188,154,193,154,192,154,197,154,194,154,203,154,204,154,209,154,69,155,67,155,71,155,73,155,72,155,77,155,81,155,232,152,13,153,46,153,85,153,84,153,223,154,225,154,230,154,239,154,235,154,251,154,237,154,249,154,8,155,15,155,19,155,31,155,35,155,189,158,190,158,59,126,130,158,135,158,136,158,139,158,146,158,214,147,157,158,159,158,219,158,220,158,221,158,224,158,223,158,226,158,233,158,231,158,229,158,234,158,239,158,34,159,44,159,47,159,57,159,55,159,61,159,62,159,68,159,227,156,228,156,229,156,230,156,231,156,232,156,233,156,234,156,235,156,236,156,237,156,238,156,239,156,240,156,241,156,242,156,243,156,244,156,245,156,246,156,247,156,248,156,249,156,250,156,251,156,252,156,253,156,254,156,255,156,0,157,1,157,2,157,3,157,4,157,5,157,6,157,7,157,8,157,9,157,10,157,11,157,12,157,13,157,14,157,15,157,16,157,17,157,18,157,19,157,20,157,21,157,22,157,23,157,24,157,25,157,26,157,27,157,28,157,29,157,30,157,31,157,32,157,33,157,34,157,35,157,36,157,37,157,38,157,39,157,40,157,41,157,42,157,43,157,44,157,45,157,46,157,47,157,48,157,49,157,50,157,51,157,52,157,53,157,54,157,55,157,56,157,57,157,58,157,59,157,60,157,61,157,62,157,63,157,64,157,65,157,66,157,52,226,53,226,54,226,55,226,56,226,57,226,58,226,59,226,60,226,61,226,62,226,63,226,64,226,65,226,66,226,67,226,68,226,69,226,70,226,71,226,72,226,73,226,74,226,75,226,76,226,77,226,78,226,79,226,80,226,81,226,82,226,83,226,84,226,85,226,86,226,87,226,88,226,89,226,90,226,91,226,92,226,93,226,94,226,95,226,96,226,97,226,98,226,99,226,100,226,101,226,102,226,103,226,104,226,105,226,106,226,107,226,108,226,109,226,110,226,111,226,112,226,113,226,114,226,115,226,116,226,117,226,118,226,119,226,120,226,121,226,122,226,123,226,124,226,125,226,126,226,127,226,128,226,129,226,130,226,131,226,132,226,133,226,134,226,135,226,136,226,137,226,138,226,139,226,140,226,141,226,142,226,143,226,144,226,145,226,67,157,68,157,69,157,70,157,71,157,72,157,73,157,74,157,75,157,76,157,77,157,78,157,79,157,80,157,81,157,82,157,83,157,84,157,85,157,86,157,87,157,88,157,89,157,90,157,91,157,92,157,93,157,94,157,95,157,96,157,97,157,98,157,99,157,100,157,101,157,102,157,103,157,104,157,105,157,106,157,107,157,108,157,109,157,110,157,111,157,112,157,113,157,114,157,115,157,116,157,117,157,118,157,119,157,120,157,121,157,122,157,123,157,124,157,125,157,126,157,127,157,128,157,129,157,130,157,131,157,132,157,133,157,134,157,135,157,136,157,137,157,138,157,139,157,140,157,141,157,142,157,143,157,144,157,145,157,146,157,147,157,148,157,149,157,150,157,151,157,152,157,153,157,154,157,155,157,156,157,157,157,158,157,159,157,160,157,161,157,162,157,146,226,147,226,148,226,149,226,150,226,151,226,152,226,153,226,154,226,155,226,156,226,157,226,158,226,159,226,160,226,161,226,162,226,163,226,164,226,165,226,166,226,167,226,168,226,169,226,170,226,171,226,172,226,173,226,174,226,175,226,176,226,177,226,178,226,179,226,180,226,181,226,182,226,183,226,184,226,185,226,186,226,187,226,188,226,189,226,190,226,191,226,192,226,193,226,194,226,195,226,196,226,197,226,198,226,199,226,200,226,201,226,202,226,203,226,204,226,205,226,206,226,207,226,208,226,209,226,210,226,211,226,212,226,213,226,214,226,215,226,216,226,217,226,218,226,219,226,220,226,221,226,222,226,223,226,224,226,225,226,226,226,227,226,228,226,229,226,230,226,231,226,232,226,233,226,234,226,235,226,236,226,237,226,238,226,239,226,163,157,164,157,165,157,166,157,167,157,168,157,169,157,170,157,171,157,172,157,173,157,174,157,175,157,176,157,177,157,178,157,179,157,180,157,181,157,182,157,183,157,184,157,185,157,186,157,187,157,188,157,189,157,190,157,191,157,192,157,193,157,194,157,195,157,196,157,197,157,198,157,199,157,200,157,201,157,202,157,203,157,204,157,205,157,206,157,207,157,208,157,209,157,210,157,211,157,212,157,213,157,214,157,215,157,216,157,217,157,218,157,219,157,220,157,221,157,222,157,223,157,224,157,225,157,226,157,227,157,228,157,229,157,230,157,231,157,232,157,233,157,234,157,235,157,236,157,237,157,238,157,239,157,240,157,241,157,242,157,243,157,244,157,245,157,246,157,247,157,248,157,249,157,250,157,251,157,252,157,253,157,254,157,255,157,0,158,1,158,2,158,240,226,241,226,242,226,243,226,244,226,245,226,246,226,247,226,248,226,249,226,250,226,251,226,252,226,253,226,254,226,255,226,0,227,1,227,2,227,3,227,4,227,5,227,6,227,7,227,8,227,9,227,10,227,11,227,12,227,13,227,14,227,15,227,16,227,17,227,18,227,19,227,20,227,21,227,22,227,23,227,24,227,25,227,26,227,27,227,28,227,29,227,30,227,31,227,32,227,33,227,34,227,35,227,36,227,37,227,38,227,39,227,40,227,41,227,42,227,43,227,44,227,45,227,46,227,47,227,48,227,49,227,50,227,51,227,52,227,53,227,54,227,55,227,56,227,57,227,58,227,59,227,60,227,61,227,62,227,63,227,64,227,65,227,66,227,67,227,68,227,69,227,70,227,71,227,72,227,73,227,74,227,75,227,76,227,77,227,3,158,4,158,5,158,6,158,7,158,8,158,9,158,10,158,11,158,12,158,13,158,14,158,15,158,16,158,17,158,18,158,19,158,20,158,21,158,22,158,23,158,24,158,25,158,26,158,27,158,28,158,29,158,30,158,36,158,39,158,46,158,48,158,52,158,59,158,60,158,64,158,77,158,80,158,82,158,83,158,84,158,86,158,89,158,93,158,95,158,96,158,97,158,98,158,101,158,110,158,111,158,114,158,116,158,117,158,118,158,119,158,120,158,121,158,122,158,123,158,124,158,125,158,128,158,129,158,131,158,132,158,133,158,134,158,137,158,138,158,140,158,141,158,142,158,143,158,144,158,145,158,148,158,149,158,150,158,151,158,152,158,153,158,154,158,155,158,156,158,158,158,160,158,161,158,162,158,163,158,164,158,165,158,167,158,168,158,169,158,170,158,78,227,79,227,80,227,81,227,82,227,83,227,84,227,85,227,86,227,87,227,88,227,89,227,90,227,91,227,92,227,93,227,94,227,95,227,96,227,97,227,98,227,99,227,100,227,101,227,102,227,103,227,104,227,105,227,106,227,107,227,108,227,109,227,110,227,111,227,112,227,113,227,114,227,115,227,116,227,117,227,118,227,119,227,120,227,121,227,122,227,123,227,124,227,125,227,126,227,127,227,128,227,129,227,130,227,131,227,132,227,133,227,134,227,135,227,136,227,137,227,138,227,139,227,140,227,141,227,142,227,143,227,144,227,145,227,146,227,147,227,148,227,149,227,150,227,151,227,152,227,153,227,154,227,155,227,156,227,157,227,158,227,159,227,160,227,161,227,162,227,163,227,164,227,165,227,166,227,167,227,168,227,169,227,170,227,171,227,171,158,172,158,173,158,174,158,175,158,176,158,177,158,178,158,179,158,181,158,182,158,183,158,185,158,186,158,188,158,191,158,192,158,193,158,194,158,195,158,197,158,198,158,199,158,200,158,202,158,203,158,204,158,208,158,210,158,211,158,213,158,214,158,215,158,217,158,218,158,222,158,225,158,227,158,228,158,230,158,232,158,235,158,236,158,237,158,238,158,240,158,241,158,242,158,243,158,244,158,245,158,246,158,247,158,248,158,250,158,253,158,255,158,0,159,1,159,2,159,3,159,4,159,5,159,6,159,7,159,8,159,9,159,10,159,12,159,15,159,17,159,18,159,20,159,21,159,22,159,24,159,26,159,27,159,28,159,29,159,30,159,31,159,33,159,35,159,36,159,37,159,38,159,39,159,40,159,41,159,42,159,43,159,45,159,46,159,48,159,49,159,172,227,173,227,174,227,175,227,176,227,177,227,178,227,179,227,180,227,181,227,182,227,183,227,184,227,185,227,186,227,187,227,188,227,189,227,190,227,191,227,192,227,193,227,194,227,195,227,196,227,197,227,198,227,199,227,200,227,201,227,202,227,203,227,204,227,205,227,206,227,207,227,208,227,209,227,210,227,211,227,212,227,213,227,214,227,215,227,216,227,217,227,218,227,219,227,220,227,221,227,222,227,223,227,224,227,225,227,226,227,227,227,228,227,229,227,230,227,231,227,232,227,233,227,234,227,235,227,236,227,237,227,238,227,239,227,240,227,241,227,242,227,243,227,244,227,245,227,246,227,247,227,248,227,249,227,250,227,251,227,252,227,253,227,254,227,255,227,0,228,1,228,2,228,3,228,4,228,5,228,6,228,7,228,8,228,9,228,50,159,51,159,52,159,53,159,54,159,56,159,58,159,60,159,63,159,64,159,65,159,66,159,67,159,69,159,70,159,71,159,72,159,73,159,74,159,75,159,76,159,77,159,78,159,79,159,82,159,83,159,84,159,85,159,86,159,87,159,88,159,89,159,90,159,91,159,92,159,93,159,94,159,95,159,96,159,97,159,98,159,99,159,100,159,101,159,102,159,103,159,104,159,105,159,106,159,107,159,108,159,109,159,110,159,111,159,112,159,113,159,114,159,115,159,116,159,117,159,118,159,119,159,120,159,121,159,122,159,123,159,124,159,125,159,126,159,129,159,130,159,141,159,142,159,143,159,144,159,145,159,146,159,147,159,148,159,149,159,150,159,151,159,152,159,156,159,157,159,158,159,161,159,162,159,163,159,164,159,165,159,44,249,121,249,149,249,231,249,241,249,10,228,11,228,12,228,13,228,14,228,15,228,16,228,17,228,18,228,19,228,20,228,21,228,22,228,23,228,24,228,25,228,26,228,27,228,28,228,29,228,30,228,31,228,32,228,33,228,34,228,35,228,36,228,37,228,38,228,39,228,40,228,41,228,42,228,43,228,44,228,45,228,46,228,47,228,48,228,49,228,50,228,51,228,52,228,53,228,54,228,55,228,56,228,57,228,58,228,59,228,60,228,61,228,62,228,63,228,64,228,65,228,66,228,67,228,68,228,69,228,70,228,71,228,72,228,73,228,74,228,75,228,76,228,77,228,78,228,79,228,80,228,81,228,82,228,83,228,84,228,85,228,86,228,87,228,88,228,89,228,90,228,91,228,92,228,93,228,94,228,95,228,96,228,97,228,98,228,99,228,100,228,101,228,102,228,103,228,12,250,13,250,14,250,15,250,17,250,19,250,20,250,24,250,31,250,32,250,33,250,35,250,36,250,39,250,40,250,41,250,129,46,22,232,23,232,24,232,132,46,115,52,71,52,136,46,139,46,30,232,158,53,26,54,14,54,140,46,151,46,110,57,24,57,38,232,207,57,223,57,115,58,208,57,43,232,44,232,78,59,110,60,224,60,167,46,49,232,50,232,170,46,86,64,95,65,174,46,55,67,179,46,182,46,183,46,59,232,177,67,172,67,187,46,221,67,214,68,97,70,76,70,67,232,35,71,41,71,124,71,141,71,202,46,71,73,122,73,125,73,130,73,131,73,133,73,134,73,159,73,155,73,183,73,182,73,84,232,85,232,163,76,159,76,160,76,161,76,119,76,162,76,19,77,20,77,21,77,22,77,23,77,24,77,25,77,174,77,100,232,104,228,105,228,106,228,107,228,108,228,109,228,110,228,111,228,112,228,113,228,114,228,115,228,116,228,117,228,118,228,119,228,120,228,121,228,122,228,123,228,124,228,125,228,126,228,127,228,128,228,129,228,130,228,131,228,132,228,133,228,134,228,135,228,136,228,137,228,138,228,139,228,140,228,141,228,142,228,143,228,144,228,145,228,146,228,147,228,148,228,149,228,150,228,151,228,152,228,153,228,154,228,155,228,156,228,157,228,158,228,159,228,160,228,161,228,162,228,163,228,164,228,165,228,166,228,167,228,168,228,169,228,170,228,171,228,172,228,173,228,174,228,175,228,176,228,177,228,178,228,179,228,180,228,181,228,182,228,183,228,184,228,185,228,186,228,187,228,188,228,189,228,190,228,191,228,192,228,193,228,194,228,195,228,196,228,197,228,240,67,50,76,3,70,166,69,120,69,103,114,119,77,179,69,177,124,226,76,197,124,149,59,54,71,68,71,71,76,64,76,191,66,23,54,82,115,139,110,210,112,87,76,81,163,79,71,218,69,133,76,108,124,7,77,164,74,161,70,35,107,37,114,84,90,99,26,6,62,97,63,77,102,251,86,0,0,149,125,29,89,185,139,244,61,52,151,239,123,219,91,94,29,164,90,37,54,176,158,209,90,183,91,252,92,110,103,147,133,69,153,97,116,157,116,117,56,83,29,158,54,33,96,236,62,222,88,245,58,252,122,151,159,97,65,13,137,234,49,138,10,94,50,10,67,132,132,150,159,47,148,48,73,19,134,150,88,74,151,24,146,208,121,50,122,96,102,41,106,157,136,76,116,197,123,130,103,44,122,79,82,70,144,230,52,196,115,185,93,198,116,199,159,179,87,47,73,76,84,49,65,142,54,24,88,114,122,101,123,143,139,174,70,136,110,129,65,153,93,174,123,188,36,200,159,193,36,201,36,204,36,201,159,4,133,187,53,180,64,202,159,225,68,255,173,193,98,110,112,203,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,49,193,49,194,49,195,49,196,49,12,1,197,49,209,0,205,0,198,49,199,49,203,0,232,31,200,49,202,0,201,49,202,49,203,49,204,49,14,1,205,49,206,49,0,1,193,0,205,1,192,0,18,1,201,0,26,1,200,0,76,1,211,0,209,1,210,0,0,220,190,30,4,220,192,30,202,0,1,1,225,0,206,1,224,0,81,2,19,1,233,0,27,1,232,0,43,1,237,0,208,1,236,0,77,1,243,0,210,1,242,0,107,1,250,0,212,1,249,0,214,1,216,1,218,1,220,1,252,0,8,220,191,30,12,220,193,30,234,0,97,2,218,35,219,35],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+261308),
	allocate([169,163,69,17,0,0,10,101,0,0,0,0,61,78,221,110,78,157,223,145,0,0,0,0,53,119,145,100,26,79,40,79,168,79,86,81,116,81,156,81,228,81,161,82,168,82,59,83,78,83,209,83,216,83,226,86,240,88,4,89,7,89,50,89,52,89,102,91,158,91,159,91,154,92,134,94,59,96,137,101,254,103,4,104,101,104,78,109,188,112,53,117,164,126,172,126,186,126,199,126,207,126,223,126,6,127,55,127,122,130,207,130,111,131,198,137,190,139,226,139,102,143,103,143,110,143,17,116,252,124,205,125,70,105,201,122,39,82,0,0,0,0,0,0,0,0,140,145,184,120,94,145,188,128,0,0,11,141,246,128,231,9,0,0,0,0,159,128,199,158,205,76,201,157,12,158,62,76,246,157,14,112,10,158,51,161,193,53,0,0,154,110,62,130,25,117,0,0,17,73,108,154,143,154,153,159,135,121,108,132,202,29,208,5,230,42,36,78,129,78,128,78,135,78,191,78,235,78,55,79,76,52,189,79,72,62,3,80,136,80,125,52,147,52,165,52,134,81,5,89,219,81,252,81,5,82,137,78,121,82,144,82,39,83,199,53,169,83,81,53,176,83,83,53,194,83,35,84,109,53,114,53,129,54,147,84,163,84,180,84,185,84,208,84,239,84,24,85,35,85,40,85,152,53,63,85,165,53,191,53,215,85,197,53,132,125,37,85,0,0,66,12,21,13,43,81,144,85,198,44,236,57,65,3,70,142,184,77,229,148,83,64,190,128,122,119,56,44,52,58,213,71,93,129,242,105,234,77,221,100,124,13,180,15,213,12,244,16,141,100,126,142,150,14,11,12,100,15,169,44,86,130,211,68,0,0,70,13,77,154,233,128,244,71,167,78,194,44,178,154,103,58,244,149,237,63,6,53,199,82,212,151,200,120,68,45,110,157,21,152,0,0,217,67,165,96,180,100,227,84,76,45,202,43,119,16,251,57,111,16,218,102,22,103,160,121,234,100,82,80,67,12,104,142,161,33,76,139,49,7,0,0,11,72,169,1,250,63,115,88,141,45,0,0,200,69,252,4,151,96,76,15,150,13,121,85,187,64,186,67,0,0,180,74,102,42,157,16,170,129,245,152,156,13,121,99,254,57,117,39,192,141,161,86,124,100,67,62,0,0,1,166,9,14,207,42,201,44,0,0,200,16,194,57,146,57,6,58,155,130,120,53,73,94,199,32,82,86,49,15,178,44,32,151,188,52,61,108,59,78,0,0,0,0,116,117,139,46,8,34,91,166,205,140,122,14,52,12,28,104,147,127,207,16,3,40,57,41,251,53,227,81,140,14,141,15,170,14,147,63,48,15,71,13,79,17,76,14,0,0,171,14,169,11,72,13,192,16,61,17,249,63,150,38,50,100,173,15,244,51,57,118,206,43,126,13,127,13,81,44,85,44,24,58,152,14,199,16,46,15,50,166,80,107,210,140,153,141,202,140,170,149,204,84,196,130,185,85,0,0,195,158,38,156,182,154,94,119,238,45,64,113,109,129,236,128,28,92,114,101,52,129,151,55,95,83,189,128,182,145,250,14,15,14,119,14,251,14,221,53,235,77,9,54,214,12,175,86,181,39,201,16,16,14,120,14,120,16,72,17,7,130,85,20,121,14,80,78,164,45,84,90,29,16,30,16,245,16,246,16,156,87,17,14,148,118,205,130,181,15,123,14,126,81,3,55,182,15,128,17,216,82,189,162,218,73,58,24,119,65,124,130,153,88,104,82,26,54,61,87,178,123,104,91,0,72,44,75,39,159,231,73,31,156,141,155,116,91,61,49,251,85,242,53,137,86,40,78,2,89,193,27,120,248,81,151,134,0,91,78,187,78,62,53,35,92,81,95,196,95,250,56,76,98,53,101,122,107,53,108,58,108,108,112,43,114,44,78,173,114,233,72,82,127,59,121,249,124,83,127,106,98,193,52,0,0,75,99,2,128,128,128,18,102,81,105,93,83,100,136,193,137,178,120,160,139,29,141,133,148,120,149,127,149,232,149,15,142,230,151,117,152,206,152,222,152,99,153,16,152,124,156,31,158,196,158,111,107,7,249,55,78,135,0,29,150,55,98,162,148,0,0,59,80,254,109,115,156,166,159,201,61,143,136,78,65,119,112,245,92,32,75,205,81,89,53,48,93,34,97,50,138,167,143,246,145,145,113,25,103,186,115,129,50,7,161,139,60,128,25,16,75,228,120,2,116,174,81,15,135,9,64,99,106,186,162,35,66,15,134,111,10,42,122,71,153,234,138,85,151,77,112,36,83,126,32,244,147,217,118,227,137,167,159,221,119,163,78,240,79,188,80,47,78,23,79,168,159,52,84,139,125,146,88,208,88,182,29,146,94,153,94,194,95,18,39,139,101,249,51,25,105,67,106,99,60,255,108,0,0,0,114,5,69,140,115,219,62,19,74,21,91,185,116,131,139,164,92,149,86,147,122,236,123,195,124,108,126,248,130,151,133,169,159,144,136,170,159,185,142,171,159,207,143,95,133,224,153,33,146,172,159,185,141,63,20,113,64,162,66,26,90,0,0,0,0,0,0,104,152,107,103,118,66,61,87,0,0,214,133,123,73,191,130,13,113,129,76,116,109,123,93,21,107,190,111,173,159,174,159,150,91,175,159,231,102,91,126,87,110,202,121,136,61,195,68,86,50,150,39,154,67,54,69,0,0,213,92,26,59,249,138,120,92,18,61,81,53,120,93,178,159,87,113,88,69,236,64,35,30,119,76,120,57,74,52,164,1,65,108,204,138,180,79,57,2,191,89,108,129,86,152,250,152,59,95,159,11,0,0,193,33,109,137,2,65,187,70,121,144,7,63,179,159,181,161,248,64,214,55,247,70,70,108,124,65,178,134,255,115,109,69,212,56,154,84,97,69,27,69,137,77,123,76,118,77,234,69,200,63,15,75,97,54,222,68,189,68,237,65,62,93,72,93,86,93,252,61,15,56,164,93,185,93,32,56,56,56,66,94,189,94,37,95,131,95,8,57,20,57,63,57,77,57,215,96,61,97,229,92,137,57,183,97,185,97,207,97,184,57,44,98,144,98,229,98,24,99,248,57,177,86,3,58,226,99,251,99,7,100,90,100,75,58,192,100,21,93,33,86,159,159,151,58,134,101,189,58,255,101,83,102,242,58,146,102,34,59,22,103,66,59,164,103,0,104,88,59,74,104,132,104,114,59,113,59,123,59,9,105,67,105,92,114,100,105,159,105,133,105,188,59,214,105,221,59,101,106,116,106,113,106,130,106,236,59,153,106,242,59,171,106,181,106,212,106,246,106,129,107,193,107,234,107,117,108,170,108,203,60,2,109,6,109,38,109,129,109,239,60,164,109,177,109,21,110,24,110,41,110,134,110,192,137,187,110,226,110,218,110,127,159,232,110,233,110,36,111,52,111,70,61,65,63,129,111,190,111,106,61,117,61,183,113,153,92,138,61,44,112,145,61,80,112,84,112,111,112,127,112,137,112,37,3,193,67,241,53,216,14,215,62,190,87,211,110,62,113,224,87,78,54,162,105,233,139,116,91,73,122,225,88,217,148,101,122,125,122,172,89,187,122,176,122,194,122,195,122,209,113,141,100,202,65,218,122,221,122,234,122,239,65,178,84,1,92,11,123,85,123,41,123,14,83,254,92,162,123,111,123,156,131,180,91,127,108,208,123,33,132,146,123,0,0,32,93,173,61,101,92,146,132,250,123,0,0,53,124,193,92,68,124,131,124,130,72,166,124,125,102,120,69,201,124,199,124,230,124,116,124,243,124,245,124,0,0,103,126,29,69,68,110,93,125,214,110,141,116,137,125,171,125,53,113,179,125,0,0,87,64,41,96,228,125,19,61,245,125,249,23,229,125,109,131,0,0,33,97,90,97,110,126,146,126,43,67,108,148,39,126,64,127,65,127,71,127,54,121,208,98,225,153,151,127,81,99,163,127,97,22,104,0,92,69,102,55,3,69,58,131,250,127,137,100,0,0,8,128,29,128,0,0,47,128,135,160,195,108,59,128,60,128,97,128,20,39,137,73,38,102,227,61,232,102,37,103,167,128,72,138,7,129,26,129,176,88,246,38,127,108,152,100,184,79,231,100,138,20,24,130,94,24,83,106,101,74,149,74,122,68,41,130,13,11,82,106,126,61,249,79,253,20,226,132,98,131,10,107,167,73,48,53,115,23,248,61,170,130,27,105,148,249,219,65,75,133,208,130,26,131,22,14,180,23,193,54,125,49,90,53,123,130,226,130,24,131,139,62,163,109,5,107,151,107,206,53,191,61,29,131,236,85,133,131,11,69,165,109,172,131,0,0,211,131,126,52,212,110,87,106,90,133,150,52,66,110,239,46,88,132,228,91,113,132,211,61,228,68,167,106,74,132,181,60,88,121,0,0,150,107,119,110,67,110,222,132,0,0,145,131,160,68,147,132,228,132,145,92,64,66,192,92,67,69,52,133,242,90,153,110,39,69,115,133,22,69,191,103,22,134,37,134,59,134,193,133,136,112,2,134,130,21,205,112,178,249,106,69,40,134,72,54,162,24,247,83,154,115,126,134,113,135,248,160,238,135,39,44,177,135,218,135,15,136,97,86,108,134,86,104,15,70,69,136,70,136,224,117,185,61,228,117,94,136,156,136,91,70,180,136,181,136,193,99,197,136,119,119,15,119,135,137,138,137,0,0,0,0,167,137,188,137,37,138,231,137,36,121,189,122,156,138,147,119,254,145,144,138,89,122,233,122,58,123,143,63,19,71,56,123,124,113,12,139,31,139,48,84,101,85,63,139,76,139,77,139,169,138,122,74,144,139,155,139,175,138,223,22,21,70,79,136,155,140,84,125,143,125,212,249,37,55,83,125,214,140,152,125,189,125,18,141,3,141,16,25,219,140,92,112,17,141,201,76,208,62,0,0,169,141,2,128,20,16,138,73,124,59,188,129,12,113,231,122,173,142,182,142,195,142,212,146,25,143,45,143,101,131,18,132,165,143,3,147,159,162,80,10,179,143,42,73,222,137,61,133,187,61,248,94,98,50,249,143,20,160,188,134,1,133,37,35,128,57,215,110,55,144,60,133,190,122,97,144,108,133,11,134,168,144,19,135,196,144,230,134,174,144,0,0,103,145,240,58,169,145,196,145,172,124,51,137,137,30,14,146,159,108,65,146,98,146,185,85,0,0,198,138,155,60,12,139,219,85,49,13,44,147,107,147,225,138,235,139,143,112,195,90,226,138,229,138,101,73,68,146,236,139,57,140,255,139,115,147,91,148,188,142,133,149,166,149,38,148,160,149,246,111,185,66,122,38,216,134,124,18,46,62,223,73,28,108,123,150,150,150,108,65,163,150,213,110,218,97,182,150,245,120,224,138,189,150,204,83,161,73,184,108,116,2,16,100,175,144,229,144,209,74,21,25,10,51,49,151,66,134,54,151,15,74,61,69,133,69,233,74,117,112,65,91,27,151,0,0,213,145,87,151,74,91,235,145,95,151,37,148,208,80,183,48,188,48,137,151,159,151,177,151,190,151,192,151,210,151,224,151,108,84,238,151,28,116,51,148,0,0,245,151,29,148,122,121,209,74,52,152,51,152,75,152,102,152,14,59,117,113,81,61,48,6,92,65,6,87,202,152,183,152,200,152,199,152,255,74,39,109,211,22,176,85,225,152,230,152,236,152,120,147,57,153,41,74,114,75,87,152,5,153,245,153,12,154,59,154,16,154,88,154,37,87,196,54,177,144,213,155,224,154,226,154,5,155,244,154,14,76,20,155,45,155,0,134,52,80,52,155,168,105,195,56,125,48,80,155,64,155,62,157,69,90,99,24,142,155,75,66,2,156,255,155,12,156,104,158,212,157,183,159,146,161,171,161,225,160,35,161,223,161,126,157,131,157,52,161,14,158,136,104,196,157,91,33,147,161,32,162,59,25,51,162,57,157,185,160,180,162,144,158,149,158,158,158,162,158,52,77,170,158,175,158,100,67,193,158,96,59,229,57,29,61,50,79,190,55,43,140,2,159,8,159,150,75,36,148,162,109,23,159,0,0,57,159,159,86,138,86,69,159,184,153,139,144,242,151,127,132,98,159,105,159,220,122,142,159,22,114,190,75,117,73,187,73,119,113,248,73,72,67,81,74,158,115,218,139,250,24,159,121,126,137,54,142,105,147,243,147,68,138,236,146,129,147,203,147,108,137,185,68,23,114,235,62,114,119,67,122,208,112,115,68,248,67,126,113,239,23,163,112,190,24,153,53,199,62,133,24,47,84,248,23,34,55,251,22,57,24,225,54,116,23,209,24,75,95,35,55,192,22,91,87,37,74,254,19,168,18,198,19,182,20,3,133,166,54,0,0,85,132,148,73,101,113,49,62,92,85,251,62,82,112,244,68,238,54,157,153,38,111,249,103,51,55,21,60,231,61,108,88,34,25,16,104,87,64,63,55,225,64,139,64,15,65,33,108,203,84,158,86,177,102,146,86,223,15,168,11,13,14,198,147,19,139,156,147,248,78,43,81,25,56,54,68,188,78,101,4,127,3,75,79,138,79,81,86,104,90,171,1,203,3,153,57,10,3,20,4,53,52,41,79,192,2,179,142,117,2,218,138,12,2,152,78,205,80,13,81,162,79,3,79,14,74,138,62,66,79,46,80,108,80,129,80,204,79,229,79,88,80,252,80,0,0,0,0,0,0,0,0,118,110,149,53,57,62,191,62,114,109,132,24,137,62,168,81,195,81,224,5,221,68,163,4,146,4,145,4,122,141,156,138,14,7,89,82,164,82,115,8,225,82,0,0,122,70,140,113,140,67,32,12,172,73,228,16,209,105,29,14,0,0,222,62,153,116,20,116,86,116,152,115,142,75,188,74,141,64,208,83,132,53,15,114,201,64,180,85,69,3,205,84,198,11,29,87,93,146,244,150,102,147,221,87,141,87,127,87,62,54,203,88,153,90,70,138,250,22,111,23,16,23,44,90,184,89,143,146,126,90,207,90,18,90,70,89,243,25,97,24,149,66,245,54,5,109,67,116,33,90,131,94,129,90,215,139,19,4,224,147,140,116,3,19,5,113,114,73,8,148,251,137,189,147,160,55,30,92,158,92,94,94,72,94,150,25,124,25,238,58,205,94,79,91,3,25,4,25,1,55,160,24,221,54,254,22,211,54,42,129,71,138,186,29,114,52,168,137,12,95,14,95,39,25,171,23,107,90,59,23,68,91,20,134,253,117,96,136,126,96,96,40,43,38,219,95,184,62,175,37,190,37,136,144,115,111,192,97,62,0,70,0,27,38,153,97,152,97,117,96,155,44,7,45,212,70,77,145,113,100,101,70,106,43,41,58,34,43,80,52,234,152,120,46,55,99,91,164,182,100,49,99,209,99,227,73,103,45,164,98,161,44,59,100,107,101,114,105,244,59,142,48,173,50,137,73,171,50,13,85,224,50,217,24,63,148,206,102,137,50,179,49,224,58,144,65,132,85,34,139,143,85,252,22,91,85,37,84,238,120,3,49,42,24,52,50,100,52,15,50,130,49,201,66,142,102,36,109,107,102,147,75,48,102,112,120,235,29,99,102,210,50,225,50,30,102,114,88,209,56,58,56,188,55,153,59,162,55,254,51,208,116,150,59,143,103,42,70,182,104,30,104,196,59,190,106,99,56,213,55,135,68,51,106,82,106,201,106,5,107,18,25,17,101,152,104,76,106,215,59,122,106,87,107,192,63,154,60,160,147,242,146,234,139,203,138,137,146,30,128,220,137,103,148,165,109,11,111,236,73,0,0,127,63,143,61,4,110,60,64,61,90,10,110,71,88,36,109,66,120,59,113,26,67,118,66,241,112,80,114,135,114,148,114,143,71,37,71,121,81,164,74,235,5,122,116,248,62,95,54,74,74,23,73,225,95,6,63,177,62,223,74,35,140,53,63,167,96,243,62,204,116,60,116,135,147,55,116,159,68,234,109,81,69,131,117,99,63,217,76,6,77,88,63,85,117,115,118,198,165,25,59,104,116,204,138,171,73,142,73,251,58,205,61,78,74,255,62,197,73,243,72,250,145,50,87,66,147,227,138,100,24,223,80,33,82,231,81,120,119,50,50,14,119,15,119,123,119,151,70,129,55,94,58,240,72,56,116,155,116,191,62,186,74,199,74,200,64,150,74,174,97,7,147,129,85,30,120,141,120,136,120,210,120,208,115,89,121,65,119,227,86,14,65,0,0,150,132,165,121,45,106,250,62,58,122,244,121,110,65,230,22,50,65,53,146,241,121,76,13,140,73,153,2,186,61,110,23,151,53,107,85,112,53,170,54,212,1,13,12,226,122,89,90,245,38,175,90,156,90,13,90,91,2,240,120,42,90,198,91,254,122,249,65,93,124,109,124,17,66,179,91,188,94,166,94,205,124,249,73,176,23,142,124,124,124,174,124,178,106,220,125,7,126,211,125,78,127,97,98,92,97,72,123,151,125,130,94,106,66,117,107,22,9,214,103,78,0,207,53,196,87,18,100,248,99,98,73,221,127,39,123,44,8,233,90,67,93,12,123,14,94,230,153,69,134,99,154,28,106,63,52,226,57,247,73,173,101,31,154,160,101,128,132,39,113,209,108,234,68,55,129,2,68,198,128,9,129,66,129,180,103,195,152,66,106,98,130,101,130,81,106,83,132,167,109,16,134,27,114,134,90,127,65,64,24,43,91,161,24,228,90,216,24,160,134,188,249,143,61,45,136,34,116,2,90,110,136,69,79,135,136,191,136,230,136,101,137,77,137,131,86,84,137,133,119,132,119,245,139,217,139,156,139,249,137,173,62,163,132,245,70,207,70,242,55,61,138,28,138,72,148,77,95,43,146,132,66,212,101,41,113,196,112,69,24,109,157,159,140,233,140,220,125,154,89,195,119,240,89,110,67,212,54,42,142,167,142,9,76,48,143,74,143,244,66,88,108,187,111,33,35,155,72,121,111,139,110,218,23,233,155,181,54,47,73,187,144,0,0,113,85,6,73,187,145,4,148,75,138,98,64,252,138,39,148,29,140,59,140,229,132,43,138,153,149,167,149,151,149,150,149,52,141,69,116,194,62,255,72,66,74,234,67,231,62,37,50,143,150,231,142,102,142,101,142,204,62,237,73,120,74,238,63,18,116,107,116,252,62,65,151,176,144,71,104,29,74,147,144,223,87,0,0,104,147,137,137,38,140,47,139,190,99,186,146,17,91,105,139,60,73,249,115,27,66,155,151,113,151,56,153,38,15,193,93,197,139,178,74,31,152,218,148,246,146,215,149,229,145,192,68,80,139,103,74,100,139,220,152,69,138,0,63,42,146,37,73,20,132,59,153,77,153,6,123,253,61,155,153,111,75,170,153,92,154,101,139,200,88,143,106,33,154,254,90,47,154,241,152,144,75,72,153,188,153,189,75,151,75,125,147,114,88,2,19,34,88,184,73,232,20,68,120,31,39,184,61,197,104,125,61,88,148,39,57,80,97,129,39,107,41,7,97,79,156,83,156,123,156,53,156,16,156,127,155,207,155,45,158,159,155,245,161,254,160,33,157,174,76,4,65,24,158,176,76,12,157,180,161,237,160,243,160,47,153,165,157,189,132,18,110,223,111,130,107,252,133,51,69,164,109,132,110,240,109,32,132,238,133,0,110,215,55,100,96,226,121,156,53,64,54,45,73,222,73,98,61,219,147,190,146,72,147,191,2,185,120,119,146,77,148,228,79,64,52,100,144,93,85,61,120,84,120,182,120,75,120,87,23,201,49,65,73,154,54,114,79,218,111,217,111,0,0,30,112,20,84,181,65,187,87,243,88,138,87,22,157,215,87,52,113,175,52,172,65,235,113,64,108,151,79,0,0,181,23,73,138,12,97,206,90,11,90,188,66,136,68,44,55,123,75,252,137,187,147,184,147,214,24,29,15,114,132,192,108,19,20,250,66,38,44,193,67,148,89,183,61,65,103,168,125,91,97,164,96,185,73,139,73,250,137,229,146,226,115,233,62,180,116,99,139,159,24,225,62,179,74,216,106,243,115,251,115,214,62,62,74,148,74,217,23,102,74,167,3,36,20,229,73,72,116,22,73,165,112,118,73,132,146,230,115,95,147,254,4,49,147,206,138,22,138,134,147,231,139,213,85,53,73,130,138,107,113,67,73,255,12,164,86,26,6,235,11,184,12,2,85,196,121,250,23,254,125,194,22,80,74,82,24,46,69,1,148,10,55,192,138,173,73,176,89,191,24,131,24,132,116,161,90,226,54,91,61,176,54,95,146,121,90,129,138,98,24,116,147,205,60,180,10,150,74,138,57,244,80,105,61,76,61,156,19,117,113,251,66,24,130,15,110,228,144,235,68,87,109,79,126,103,112,175,108,214,60,237,63,45,62,2,110,12,111,111,61,245,3,81,117,188,54,200,52,128,70,218,62,113,72,196,89,110,146,62,73,65,143,28,140,192,107,18,88,200,87,214,54,82,20,254,112,98,67,113,74,227,47,176,18,189,35,185,104,103,105,152,19,229,52,244,123,223,54,131,138,214,55,250,51,159,76,26,106,173,54,183,108,62,132,223,68,206,68,38,109,81,109,130,108,222,111,23,111,9,113,61,131,58,23,237,131,128,108,83,112,219,23,137,89,130,90,179,23,97,90,113,90,5,25,252,65,45,55,239,89,60,23,199,54,142,113,144,147,154,102,165,66,110,90,43,90,147,66,43,106,249,62,54,119,91,68,202,66,29,113,89,66,225,137,176,79,40,109,194,92,206,68,77,126,189,67,12,106,86,66,4,19,166,112,51,113,233,67,165,61,223,108,37,248,79,74,101,126,235,89,47,93,243,61,92,95,93,74,223,23,164,125,38,132,133,84,250,58,0,51,20,2,126,87,213,8,25,6,229,63,158,31,182,162,3,112,91,145,112,93,143,115,211,124,89,138,32,148,200,79,231,127,205,114,16,115,244,122,56,115,57,115,246,86,65,115,72,115,169,62,24,123,108,144,245,113,242,72,225,115,246,129,202,62,12,119,209,62,162,108,253,86,25,116,30,116,31,116,226,62,240,62,244,62,250,62,211,116,14,63,83,63,66,117,109,117,114,117,141,117,124,63,200,117,220,117,192,63,77,118,215,63,116,118,220,63,122,118,92,79,136,113,35,86,128,137,105,88,29,64,67,119,57,64,97,103,69,64,219,53,152,119,106,64,111,64,94,92,190,119,203,119,242,88,24,120,185,112,28,120,168,64,57,120,71,120,81,120,102,120,72,132,53,85,51,121,3,104,50,121,3,65,9,65,145,121,153,121,187,143,6,122,188,143,103,65,145,122,178,65,188,122,121,130,196,65,207,122,219,122,207,65,33,78,98,123,108,123,123,123,18,124,27,124,96,66,122,66,123,124,156,124,140,66,184,124,148,66,237,124,147,143,192,112,207,12,207,125,212,125,208,125,253,125,174,127,180,127,159,114,151,67,32,128,37,128,57,123,46,128,49,128,84,128,204,61,180,87,160,112,183,128,233,128,237,67,12,129,42,115,14,129,18,129,96,117,20,129,1,68,57,59,86,129,89,129,90,129,19,68,58,88,124,129,132,129,37,68,147,129,45,68,165,129,239,87,193,129,228,129,84,130,143,68,166,130,118,130,202,130,216,130,255,130,176,68,87,131,105,150,138,105,5,132,245,112,100,132,227,96,136,132,4,69,190,132,225,132,248,132,16,133,56,133,82,133,59,69,111,133,112,133,224,133,119,69,114,134,146,134,178,134,239,134,69,150,139,135,6,70,23,70,174,136,255,136,36,137,71,137,145,137,103,121,41,138,56,138,148,138,180,138,81,140,212,140,242,140,28,141,152,71,95,88,195,141,237,71,238,78,58,142,216,85,84,87,113,142,245,85,176,142,55,72,206,142,226,142,228,142,237,142,242,142,183,143,193,143,202,143,204,143,51,144,196,153,173,72,224,152,19,146,30,73,40,146,88,146,107,146,177,146,174,146,191,146,227,146,235,146,243,146,244,146,253,146,67,147,132,147,173,147,69,73,81,73,191,158,23,148,1,83,29,148,45,148,62,148,106,73,84,148,121,148,45,149,162,149,167,73,244,149,51,150,229,73,160,103,36,74,64,151,53,74,178,151,194,151,84,86,228,74,232,96,185,152,25,75,241,152,68,88,14,153,25,153,180,81,28,153,55,153,66,153,93,153,98,153,112,75,197,153,157,75,60,154,15,155,131,122,105,155,129,155,221,155,241,155,244,155,109,76,32,156,111,55,194,27,73,157,58,156,254,158,80,86,147,157,189,157,192,157,252,157,246,148,182,143,123,158,172,158,177,158,189,158,198,158,220,148,226,158,241,158,248,158,200,122,68,159,148,0,183,2,160,3,26,105,195,148,172,89,215,4,64,88,193,148,185,55,213,5,21,6,118,6,186,22,87,87,115,113,194,10,205,10,191,11,106,84,59,248,203,11,158,84,251,11,59,12,83,12,101,12,124,12,231,96,141,12,122,86,181,12,221,12,237,12,111,13,178,13,200,13,85,105,47,156,165,135,4,14,14,14,215,14,144,15,45,15,115,14,32,92,188,15,11,94,92,16,79,16,118,16,30,103,123,16,136,16,150,16,71,54,191,16,211,16,47,17,59,17,100,83,173,132,227,18,117,19,54,19,129,139,119,21,25,22,195,23,199,23,120,78,187,112,45,24,106,25,45,26,69,26,42,28,112,28,172,28,200,30,195,98,213,30,21,31,152,113,85,104,69,32,233,105,200,54,124,34,215,35,250,35,42,39,113,40,79,41,253,130,103,41,147,41,213,42,165,137,232,42,160,143,14,43,184,151,63,43,71,152,189,154,76,44,0,0,136,44,183,44,232,91,8,45,18,45,183,45,149,45,66,46,116,47,204,47,51,48,102,48,31,51,222,51,177,95,72,102,191,102,121,122,103,53,243,53,0,0,186,73,0,0,26,54,22,55,0,0,70,3,181,88,14,103,24,105,167,58,87,118,226,95,17,62,185,62,254,117,154,32,208,72,184,74,25,65,154,138,238,66,13,67,59,64,52,67,150,67,69,74,202,5,210,81,17,6,159,89,168,30,190,59,255,60,4,68,214,68,136,87,116,70,155,57,47,71,232,133,201,153,98,55,195,33,94,139,78,139,0,0,18,72,251,72,21,74,9,114,192,74,120,12,101,89,165,78,134,79,121,7,218,142,44,80,143,82,63,87,113,113,153,82,25,84,74,63,167,74,188,85,70,84,110,84,82,107,0,0,115,52,63,85,50,118,94,85,24,71,98,85,102,85,199,87,63,73,93,88,102,80,251,52,204,51,0,0,3,89,124,71,72,137,174,90,137,91,6,92,144,29,161,87,81,113,0,0,2,97,18,124,86,144,178,97,154,79,98,139,2,100,74,100,91,93,247,107,0,0,132,100,28,25,234,138,246,73,136,100,239,63,18,101,192,75,191,101,181,102,27,39,101,148,225,87,149,97,39,90,205,248,0,0,185,86,33,69,252,102,106,78,52,73,86,150,143,109,189,108,24,54,119,137,153,103,110,104,17,100,94,104,0,0,199,104,66,123,192,144,17,10,38,105,0,0,57,105,69,122,0,0,250,105,38,154,45,106,95,54,105,100,33,0,131,121,52,106,91,107,44,93,25,53,0,0,157,107,208,70,164,108,59,117,101,136,174,109,182,88,28,55,141,37,75,112,205,113,84,60,128,114,133,114,129,146,122,33,139,114,48,147,230,114,208,73,57,108,159,148,80,116,248,14,39,136,245,136,38,41,115,132,177,23,184,110,42,74,32,24,164,57,185,54,0,0,0,0,63,69,182,102,173,156,164,152,67,137,204,119,88,120,214,86,223,64,10,22,161,57,47,55,232,128,197,19,173,113,102,131,221,121,168,145,0,0,183,76,175,112,171,137,253,121,10,122,11,123,102,125,122,65,67,123,126,121,9,128,181,111,223,162,3,106,24,131,162,83,7,110,191,147,54,104,93,151,111,129,35,128,181,105,237,19,47,50,72,128,133,93,48,140,131,128,21,87,35,152,73,137,171,93,136,73,190,101,213,105,210,83,165,74,129,63,17,60,54,103,144,128,244,128,46,129,161,31,79,129,137,129,175,129,26,130,6,131,47,131,138,131,202,53,104,132,170,134,250,72,230,99,86,137,8,120,85,146,184,137,242,67,231,137,223,67,232,137,70,139,212,139,248,89,9,140,0,0,197,143,236,144,0,0,16,145,60,145,247,61,94,145,202,74,208,143,143,114,139,86,231,148,233,149,176,149,184,149,50,151,209,152,73,153,106,153,195,153,40,154,14,155,90,157,155,157,159,126,248,158,35,159,164,76,71,149,147,162,162,113,255,162,145,77,18,144,203,165,156,77,156,12,190,143,193,85,186,143,176,36,185,143,147,74,9,69,127,126,86,111,177,106,234,78,228,52,44,139,157,120,58,55,128,142,245,23,36,128,108,139,153,139,62,122,175,102,235,61,85,118,183,60,53,86,86,89,154,78,129,94,88,98,191,86,109,14,14,142,109,91,136,62,158,76,222,99,0,0,246,23,123,24,48,101,45,86,74,92,26,84,17,83,198,61,152,157,125,76,34,86,30,86,73,127,216,94,117,89,64,61,112,135,28,78,234,15,73,13,186,54,23,129,94,157,24,141,59,118,69,156,78,118,185,119,69,147,50,84,72,129,247,130,37,86,50,129,24,132,189,128,234,85,98,121,67,86,22,84,157,14,206,53,5,86,241,85,241,102,226,130,45,54,52,117,240,85,186,85,151,84,114,85,65,12,150,12,208,94,72,81,118,14,98,44,162,14,171,158,90,125,222,85,117,16,157,98,109,151,148,84,205,140,246,113,118,145,252,99,185,99,254,99,105,85,67,43,114,156,179,46,154,81,223,52,167,13,167,81,77,84,30,85,19,85,102,118,45,142,138,104,177,117,182,128,4,136,134,135,199,136,182,129,28,132,193,16,236,68,4,115,6,71,144,91,11,131,147,104,123,86,244,38,47,125,163,65,115,125,208,110,182,114,112,145,217,17,8,146,252,60,169,166,172,14,249,14,102,114,162,28,78,71,194,79,249,127,235,15,250,64,93,156,31,101,160,45,243,72,224,71,124,157,236,15,10,14,0,0,163,117,237,15,0,0,72,96,135,17,163,113,142,126,80,157,26,78,4,78,119,53,13,91,178,108,103,83,172,54,220,57,125,83,165,54,24,70,154,88,110,75,45,130,75,84,170,87,149,90,121,9,0,0,82,58,101,36,116,115,172,158,9,77,237,155,254,60,48,159,91,76,169,79,158,149,222,159,92,132,182,61,178,114,179,103,32,55,46,99,37,125,247,62,44,62,42,58,8,144,204,82,116,62,122,54,233,69,142,4,64,118,240,90,182,14,122,120,46,127,167,88,191,64,124,86,139,155,116,93,84,118,52,164,133,158,225,76,0,0,251,55,25,97,218,48,242,67,0,0,93,86,169,18,167,87,99,73,6,158,52,82,174,112,173,53,0,0,124,157,86,124,57,155,222,87,108,23,83,92,211,100,208,148,53,99,100,113,173,134,40,13,34,109,226,74,113,13,0,0,254,81,15,31,142,93,3,151,209,29,129,158,76,144,31,123,2,155,209,92,163,123,104,98,53,99,255,154,207,123,42,155,126,124,0,0,66,124,134,124,21,156,252,123,9,155,0,0,27,156,62,73,90,159,115,85,195,91,253,79,152,158,242,79,96,82,6,62,209,82,103,87,86,80,183,89,18,94,200,151,171,157,92,143,105,84,180,151,64,153,186,151,44,83,48,97,44,105,218,83,10,156,2,157,59,76,65,150,128,105,166,80,70,117,109,23,218,153,115,82,0,0,89,145,129,150,92,145,0,0,81,145,151,142,127,99,35,109,202,106,17,86,142,145,122,117,133,98,252,3,79,115,112,124,33,92,253,60,0,0,25,73,214,118,157,155,42,78,212,12,190,131,66,136,0,0,74,92,192,105,0,0,122,87,31,82,245,93,206,78,49,108,242,1,57,79,156,84,218,84,154,82,130,141,254,53,0,0,243,53,0,0,82,107,124,145,165,159,151,155,46,152,180,152,186,154,168,158,132,158,122,113,20,123,0,0,250,107,24,136,120,127,0,0,32,86,74,166,119,142,83,159,0,0,212,141,79,142,28,158,1,142,130,98,125,131,40,142,117,142,211,122,119,74,62,122,216,120,234,108,103,138,7,118,90,138,38,159,206,108,214,135,195,117,178,162,83,120,64,248,12,141,226,114,113,115,45,139,2,115,241,116,235,140,187,74,47,134,186,95,160,136,183,68,0,0,59,24,5,110,0,0,126,138,27,37,0,0,253,96,103,118,215,154,68,157,110,147,143,155,245,135,0,0,0,0,247,140,44,115,33,151,176,155,214,53,178,114,7,76,81,124,74,153,89,97,89,97,4,76,150,158,125,97,0,0,95,87,111,97,166,98,57,98,0,0,92,58,226,97,170,83,245,51,100,99,2,104,210,53,87,93,194,139,218,143,57,142,0,0,217,80,70,29,6,121,50,83,56,150,59,15,101,64,0,0,254,119,0,0,194,124,26,95,218,124,45,122,102,128,99,128,77,125,5,117,242,116,148,137,26,130,12,103,98,128,134,116,91,128,240,116,3,129,36,119,137,137,204,103,83,117,209,110,169,135,206,135,200,129,140,135,73,138,173,140,67,139,43,119,248,116,218,132,53,54,178,105,166,141,0,0,169,137,0,0,185,109,193,135,17,64,231,116,219,61,118,113,164,96,156,97,209,60,0,0,119,96,0,0,113,127,45,139,0,0,233,96,126,75,32,82,24,60,199,60,215,94,86,118,49,85,68,25,254,18,3,153,220,109,173,112,193,92,173,97,15,138,119,54,238,0,70,104,14,79,98,69,31,91,76,99,80,159,166,158,107,98,71,5,219,146,223,5,197,63,76,133,181,66,239,115,181,81,73,54,66,73,228,137,68,147,219,25,238,130,200,60,60,120,68,103,223,98,51,73,170,137,160,2,179,107,5,19,171,79,237,36,8,80,41,109,132,122,0,54,177,74,19,37,0,0,126,3,164,95,128,3,71,3,219,110,31,4,0,0,1,81,122,52,14,81,108,152,67,55,22,132,164,73,135,4,96,81,180,51,106,81,255,11,252,32,229,2,48,37,142,5,51,50,131,25,130,91,125,135,179,5,153,60,178,81,184,81,52,157,201,81,207,81,209,81,220,60,211,81,166,74,179,81,226,81,66,83,237,81,205,131,62,105,45,55,123,95,11,82,38,82,60,82,181,82,87,82,148,82,185,82,197,82,21,124,66,133,224,82,13,134,19,107,0,0,222,138,73,85,217,110,128,63,84,9,236,63,51,83,0,0,226,11,203,108,38,23,27,104,213,115,74,96,170,62,204,56,232,22,221,113,162,68,109,83,116,83,171,134,126,83,0,0,150,21,19,22,230,119,147,83,155,138,160,83,171,83,174,83,167,115,114,87,89,63,156,115,193,83,197,83,73,108,73,78,254,87,217,83,171,58,143,11,224,83,235,63,163,45,246,83,119,12,19,84,121,112,43,85,87,102,91,109,109,84,83,107,116,13,93,85,143,84,164,84,166,71,13,23,221,14,180,61,77,13,188,137,152,38,71,85,237,76,47,84,23,116,134,85,169,85,0,0,215,24,58,64,82,69,53,68,179,102,180,16,55,86,205,102,138,50,164,102,173,102,77,86,79,86,241,120,241,86,135,151,254,83,0,87,239,86,237,86,102,139,35,54,79,18,70,87,165,65,110,108,139,112,66,87,177,54,126,108,230,87,22,20,3,88,84,20,99,67,38,88,245,75,92,88,170,88,97,53,224,88,220,88,60,18,251,88,255,91,67,87,80,161,120,66,211,147,161,53,31,89,166,104,195,54,89,110,62,22,36,90,83,85,146,22,5,133,201,89,78,13,129,108,42,109,220,23,217,89,251,23,178,23,166,109,113,109,40,24,213,22,249,89,69,110,171,90,99,90,230,54,169,73,0,0,8,55,150,90,101,116,211,90,161,111,84,37,133,61,17,25,50,55,184,22,131,94,208,82,118,91,136,101,124,91,14,122,4,64,93,72,4,2,213,91,96,97,52,26,204,89,165,5,243,91,157,91,16,77,5,92,68,27,19,92,206,115,20,92,165,28,40,107,73,92,221,72,133,92,233,92,239,92,139,93,249,29,55,30,16,93,24,93,70,93,164,30,186,92,215,93,252,130,45,56,1,73,73,32,115,33,135,130,54,56,194,59,46,94,138,106,0,0,122,94,188,68,211,12,166,83,183,78,0,0,168,83,113,23,9,94,244,94,130,132,249,94,251,94,160,56,252,94,62,104,27,148,13,95,193,1,148,248,222,58,174,72,58,19,58,95,136,104,208,35,0,0,113,36,99,95,189,151,110,110,114,95,64,147,54,138,167,95,182,93,95,61,80,82,106,31,248,112,104,38,214,145,158,2,41,138,49,96,133,102,119,24,99,57,199,61,57,54,144,87,180,39,113,121,64,62,158,96,0,0,179,96,130,73,143,73,83,122,164,116,225,80,160,90,100,97,36,132,66,97,166,248,210,110,129,97,244,81,86,6,135,97,170,91,183,63,95,40,211,97,157,139,93,153,208,97,50,57,128,41,193,40,35,96,92,97,30,101,139,99,24,1,197,98,112,23,213,98,13,46,108,99,223,73,23,58,56,100,248,99,142,19,252,23,0,0,138,111,54,46,20,152,140,64,29,87,225,100,229,100,123,148,102,58,58,100,87,58,77,101,22,111,40,74,35,74,133,101,109,101,95,101,126,48,181,101,64,73,55,75,209,101,216,64,41,24,224,101,227,101,223,95,0,52,24,102,247,49,248,49,68,102,164,49,165,49,75,102,117,14,103,102,230,81,115,102,0,0,61,30,49,50,244,133,200,49,19,83,197,119,247,40,164,153,2,103,156,67,33,74,43,59,250,105,194,55,0,0,103,103,98,103,205,65,237,144,215,103,233,68,34,104,80,110,60,146,1,104,230,51,160,109,93,104,111,52,225,105,11,106,223,138,115,105,195,104,205,53,1,105,0,105,50,61,1,58,60,54,128,59,172,103,97,105,74,138,252,66,54,105,152,105,161,59,201,3,99,131,144,80,249,105,89,54,42,33,69,106,3,55,157,106,243,59,177,103,200,106,156,145,13,60,29,107,35,9,222,96,53,107,116,107,205,39,181,110,219,58,181,3,88,25,64,55,33,84,90,59,225,107,252,62,220,107,55,108,139,36,241,72,81,107,90,108,38,130,121,108,188,61,197,68,189,61,164,65,12,73,0,73,201,60,229,54,235,60,50,13,131,155,249,49,145,36,143,127,55,104,37,109,161,109,235,109,150,109,92,109,124,110,4,111,127,73,133,64,114,110,51,133,116,111,199,81,0,0,0,0,46,132,33,139,0,0,47,62,83,116,130,63,204,121,79,110,145,90,75,48,248,111,13,55,157,111,48,62,250,110,151,20,61,64,85,69,240,147,68,111,92,111,78,61,116,111,112,145,59,61,159,111,68,65,211,111,145,64,85,65,57,64,240,63,180,63,63,65,223,81,86,65,87,65,64,65,221,97,75,112,126,112,167,112,129,112,204,112,213,112,214,112,223,112,4,65,232,61,180,113,150,113,119,66,43,113,69,113,136,90,74,113,0,0,156,92,101,67,79,113,98,147,193,66,44,113,90,68,39,74,34,74,186,113,232,139,189,112,14,114,66,148,21,114,17,89,67,148,36,114,65,147,5,86,46,114,64,114,116,73,189,104,85,114,87,114,85,62,68,48,13,104,61,111,130,114,0,0,43,115,35,72,43,136,237,72,4,136,40,115,46,115,207,115,170,115,58,12,46,106,201,115,73,116,226,65,231,22,36,74,35,102,197,54,183,73,141,73,251,73,247,115,21,116,3,105,38,74,57,116,195,5,215,62,0,0,173,40,96,116,178,142,71,116,228,115,118,116,185,131,108,116,48,55,116,116,241,147,44,106,130,116,83,73,140,74,95,65,121,74,143,139,70,91,3,140,158,24,200,116,136,25,14,117,0,0,30,117,217,142,75,26,215,91,172,142,133,147,77,117,74,117,103,117,110,117,130,79,4,63,19,77,142,117,93,116,158,117,180,117,2,118,44,118,81,118,79,118,111,118,118,118,245,99,144,118,239,129,248,55,17,105,14,105,161,118,165,118,183,118,204,118,159,111,98,132,157,80,125,81,28,30,30,119,38,119,64,119,175,100,32,82,88,119,172,50,175,119,100,137,104,137,193,22,244,119,0,0,118,19,18,74,202,104,175,120,199,120,211,120,165,150,46,121,224,85,215,120,52,121,177,120,12,118,184,143,132,136,43,139,131,96,28,38,134,121,0,137,2,105,128,121,87,88,157,121,57,123,60,121,169,121,42,110,38,113,168,62,198,121,13,145,212,121,32,5,95,68,15,82,130,184,248,0,0,64,32,169,78,4,0,0,0,0,52,11,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,64,0,0,0,0,0,0,0,0,4,88,0,60,0,0,0,0,0,128,92,173,220,243,187,201,67,238,237,164,15,38,193,155,118,242,239,222,251,250,247,15,50,68,175,254,239,253,254,17,96,176,0,0,33,25,129,32,16,136,168,96,33,105,36,0,68,137,196,0,0,3,64,53,0,67,132,49,81,147,104,2,2,0,0,0,0,0,0,0,0,0,0,0,64,0,1,128,172,100,130,64,140,161,144,4,80,96,212,0,210,42,24,157,104,53,151,79,216,248,32,196,130,28,40,130,117,148,2,56,64,160,161,197,16,113,77,196,13,152,185,94,91,1,67,159,153,3,120,32,226,31,8,137,1,201,64,7,3,13,154,144,82,209,79,124,3,2,33,32,192,110,19,131,181,219,245,229,119,144,79,23,154,54,23,12,0,110,186,9,47,96,84,0,30,120,104,34,112,86,158,37,243,142,183,23,11,239,230,119,23,91,27,193,16,152,141,18,24,182,207,1,49,114,26,91,44,182,192,32,226,195,92,130,27,224,218,206,133,214,64,169,84,11,208,15,72,68,64,16,9,212,64,174,59,100,30,68,43,23,8,134,130,54,24,160,137,231,156,91,8,132,3,2,218,144,236,219,135,133,191,162,173,157,142,157,152,32,37,70,0,70,159,127,227,213,201,132,244,214,77,6,227,182,24,18,9,0,0,0,4,0,0,32,0,0,0,0,2,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,142,120,110,95,63,126,221,61,247,252,155,252,174,210,255,143,107,241,231,191,186,174,110,23,239,220,167,62,182,181,119,201,146,215,165,182,74,110,155,185,129,77,103,254,84,241,155,98,254,111,82,215,54,254,191,41,69,129,249,189,101,166,66,57,0,0,66,96,143,0,148,64,64,210,175,215,209,219,0,160,152,178,123,6,82,32,152,22,200,61,9,0,0,1,0,0,0,1,10,178,8,128,0,0,0,4,136,32,20,16,76,0,0,4,0,161,68,16,0,65,1,0,8,64,240,223,79,54,88,241,245,181,128,245,103,128,64,0,80,78,65,200,132,0,90,96,216,1,43,1,80,161,22,196,64,242,110,17,172,32,57,196,192,8,7,12,9,152,150,196,155,16,28,152,108,134,42,166,1,70,17,109,229,203,196,192,146,16,33,22,18,157,114,244,105,14,23,42,162,129,244,123,0,8,164,11,144,16,44,204,57,74,1,240,22,11,10,64,12,29,234,12,68,14,69,2,0,8,4,4,8,4,4,8,2,4,0,0,0,0,0,0,0,195,138,204,132,195,138,204,140,195,170,204,132,195,170,204,140,0,0,0,0,0,0,0,0,0,48,12,255,1,48,2,48,14,255,39,32,27,255,26,255,31,255,1,255,48,254,38,32,37,32,80,254,81,254,82,254,183,0,84,254,85,254,86,254,87,254,92,255,19,32,49,254,20,32,51,254,116,37,52,254,79,254,8,255,9,255,53,254,54,254,91,255,93,255,55,254,56,254,20,48,21,48,57,254,58,254,16,48,17,48,59,254,60,254,10,48,11,48,61,254,62,254,8,48,9,48,63,254,64,254,12,48,13,48,65,254,66,254,14,48,15,48,67,254,68,254,89,254,90,254,91,254,92,254,93,254,94,254,24,32,25,32,28,32,29,32,29,48,30,48,53,32,50,32,3,255,6,255,10,255,59,32,167,0,3,48,203,37,207,37,179,37,178,37,206,37,6,38,5,38,199,37,198,37,161,37,160,37,189,37,188,37,163,50,5,33,175,0,227,255,63,255,205,2,73,254,74,254,77,254,78,254,75,254,76,254,95,254,96,254,97,254,11,255,13,255,215,0,247,0,177,0,26,34,28,255,30,255,29,255,102,34,103,34,96,34,30,34,82,34,97,34,98,254,99,254,100,254,101,254,102,254,94,255,41,34,42,34,165,34,32,34,31,34,191,34,210,51,209,51,43,34,46,34,53,34,52,34,64,38,66,38,149,34,153,34,145,33,147,33,144,33,146,33,150,33,151,33,153,33,152,33,37,34,35,34,15,255,60,255,21,34,104,254,4,255,229,255,18,48,224,255,225,255,5,255,32,255,3,33,9,33,105,254,106,254,107,254,213,51,156,51,157,51,158,51,206,51,161,51,142,51,143,51,196,51,176,0,89,81,91,81,94,81,93,81,97,81,99,81,231,85,233,116,206,124,129,37,130,37,131,37,132,37,133,37,134,37,135,37,136,37,143,37,142,37,141,37,140,37,139,37,138,37,137,37,60,37,52,37,44,37,36,37,28,37,148,37,0,37,2,37,149,37,12,37,16,37,20,37,24,37,109,37,110,37,112,37,111,37,80,37,94,37,106,37,97,37,226,37,227,37,229,37,228,37,113,37,114,37,115,37,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+271588),
	allocate([24,255,25,255,96,33,97,33,98,33,99,33,100,33,101,33,102,33,103,33,104,33,105,33,33,48,34,48,35,48,36,48,37,48,38,48,39,48,40,48,41,48,65,83,68,83,69,83,33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,5,49,6,49,7,49,8,49,9,49,10,49,11,49,12,49,13,49,14,49,15,49,16,49,17,49,18,49,19,49,20,49,21,49,22,49,23,49,24,49,25,49,26,49,27,49,28,49,29,49,30,49,31,49,32,49,33,49,34,49,35,49,36,49,37,49,38,49,39,49,40,49,41,49,217,2,201,2,202,2,199,2,203,2,0,36,1,36,2,36,3,36,4,36,5,36,6,36,7,36,8,36,9,36,10,36,11,36,12,36,13,36,14,36,15,36,16,36,17,36,18,36,19,36,20,36,21,36,22,36,23,36,24,36,25,36,26,36,27,36,28,36,29,36,30,36,31,36,33,36,172,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,89,78,1,78,3,78,67,78,93,78,134,78,140,78,186,78,63,81,101,81,107,81,224,81,0,82,1,82,155,82,21,83,65,83,92,83,200,83,9,78,11,78,8,78,10,78,43,78,56,78,225,81,69,78,72,78,95,78,94,78,142,78,161,78,64,81,3,82,250,82,67,83,201,83,227,83,31,87,235,88,21,89,39,89,115,89,80,91,81,91,83,91,248,91,15,92,34,92,56,92,113,92,221,93,229,93,241,93,242,93,243,93,254,93,114,94,254,94,11,95,19,95,77,98,17,78,16,78,13,78,45,78,48,78,57,78,75,78,57,92,136,78,145,78,149,78,146,78,148,78,162,78,193,78,192,78,195,78,198,78,199,78,205,78,202,78,203,78,196,78,67,81,65,81,103,81,109,81,110,81,108,81,151,81,246,81,6,82,7,82,8,82,251,82,254,82,255,82,22,83,57,83,72,83,71,83,69,83,94,83,132,83,203,83,202,83,205,83,236,88,41,89,43,89,42,89,45,89,84,91,17,92,36,92,58,92,111,92,244,93,123,94,255,94,20,95,21,95,195,95,8,98,54,98,75,98,78,98,47,101,135,101,151,101,164,101,185,101,229,101,240,102,8,103,40,103,32,107,98,107,121,107,203,107,212,107,219,107,15,108,52,108,107,112,42,114,54,114,59,114,71,114,89,114,91,114,172,114,139,115,25,78,22,78,21,78,20,78,24,78,59,78,77,78,79,78,78,78,229,78,216,78,212,78,213,78,214,78,215,78,227,78,228,78,217,78,222,78,69,81,68,81,137,81,138,81,172,81,249,81,250,81,248,81,10,82,160,82,159,82,5,83,6,83,23,83,29,83,223,78,74,83,73,83,97,83,96,83,111,83,110,83,187,83,239,83,228,83,243,83,236,83,238,83,233,83,232,83,252,83,248,83,245,83,235,83,230,83,234,83,242,83,241,83,240,83,229,83,237,83,251,83,219,86,218,86,22,89,46,89,49,89,116,89,118,89,85,91,131,91,60,92,232,93,231,93,230,93,2,94,3,94,115,94,124,94,1,95,24,95,23,95,197,95,10,98,83,98,84,98,82,98,81,98,165,101,230,101,46,103,44,103,42,103,43,103,45,103,99,107,205,107,17,108,16,108,56,108,65,108,64,108,62,108,175,114,132,115,137,115,220,116,230,116,24,117,31,117,40,117,41,117,48,117,49,117,50,117,51,117,139,117,125,118,174,118,191,118,238,118,219,119,226,119,243,119,58,121,190,121,116,122,203,122,30,78,31,78,82,78,83,78,105,78,153,78,164,78,166,78,165,78,255,78,9,79,25,79,10,79,21,79,13,79,16,79,17,79,15,79,242,78,246,78,251,78,240,78,243,78,253,78,1,79,11,79,73,81,71,81,70,81,72,81,104,81,113,81,141,81,176,81,23,82,17,82,18,82,14,82,22,82,163,82,8,83,33,83,32,83,112,83,113,83,9,84,15,84,12,84,10,84,16,84,1,84,11,84,4,84,17,84,13,84,8,84,3,84,14,84,6,84,18,84,224,86,222,86,221,86,51,87,48,87,40,87,45,87,44,87,47,87,41,87,25,89,26,89,55,89,56,89,132,89,120,89,131,89,125,89,121,89,130,89,129,89,87,91,88,91,135,91,136,91,133,91,137,91,250,91,22,92,121,92,222,93,6,94,118,94,116,94,15,95,27,95,217,95,214,95,14,98,12,98,13,98,16,98,99,98,91,98,88,98,54,101,233,101,232,101,236,101,237,101,242,102,243,102,9,103,61,103,52,103,49,103,53,103,33,107,100,107,123,107,22,108,93,108,87,108,89,108,95,108,96,108,80,108,85,108,97,108,91,108,77,108,78,108,112,112,95,114,93,114,126,118,249,122,115,124,248,124,54,127,138,127,189,127,1,128,3,128,12,128,18,128,51,128,127,128,137,128,139,128,140,128,227,129,234,129,243,129,252,129,12,130,27,130,31,130,110,130,114,130,126,130,107,134,64,136,76,136,99,136,127,137,33,150,50,78,168,78,77,79,79,79,71,79,87,79,94,79,52,79,91,79,85,79,48,79,80,79,81,79,61,79,58,79,56,79,67,79,84,79,60,79,70,79,99,79,92,79,96,79,47,79,78,79,54,79,89,79,93,79,72,79,90,79,76,81,75,81,77,81,117,81,182,81,183,81,37,82,36,82,41,82,42,82,40,82,171,82,169,82,170,82,172,82,35,83,115,83,117,83,29,84,45,84,30,84,62,84,38,84,78,84,39,84,70,84,67,84,51,84,72,84,66,84,27,84,41,84,74,84,57,84,59,84,56,84,46,84,53,84,54,84,32,84,60,84,64,84,49,84,43,84,31,84,44,84,234,86,240,86,228,86,235,86,74,87,81,87,64,87,77,87,71,87,78,87,62,87,80,87,79,87,59,87,239,88,62,89,157,89,146,89,168,89,158,89,163,89,153,89,150,89,141,89,164,89,147,89,138,89,165,89,93,91,92,91,90,91,91,91,140,91,139,91,143,91,44,92,64,92,65,92,63,92,62,92,144,92,145,92,148,92,140,92,235,93,12,94,143,94,135,94,138,94,247,94,4,95,31,95,100,95,98,95,119,95,121,95,216,95,204,95,215,95,205,95,241,95,235,95,248,95,234,95,18,98,17,98,132,98,151,98,150,98,128,98,118,98,137,98,109,98,138,98,124,98,126,98,121,98,115,98,146,98,111,98,152,98,110,98,149,98,147,98,145,98,134,98,57,101,59,101,56,101,241,101,244,102,95,103,78,103,79,103,80,103,81,103,92,103,86,103,94,103,73,103,70,103,96,103,83,103,87,103,101,107,207,107,66,108,94,108,153,108,129,108,136,108,137,108,133,108,155,108,106,108,122,108,144,108,112,108,140,108,104,108,150,108,146,108,125,108,131,108,114,108,126,108,116,108,134,108,118,108,141,108,148,108,152,108,130,108,118,112,124,112,125,112,120,112,98,114,97,114,96,114,196,114,194,114,150,115,44,117,43,117,55,117,56,117,130,118,239,118,227,119,193,121,192,121,191,121,118,122,251,124,85,127,150,128,147,128,157,128,152,128,155,128,154,128,178,128,111,130,146,130,139,130,141,130,139,137,210,137,0,138,55,140,70,140,85,140,157,140,100,141,112,141,179,141,171,142,202,142,155,143,176,143,194,143,198,143,197,143,196,143,225,93,145,144,162,144,170,144,166,144,163,144,73,145,198,145,204,145,50,150,46,150,49,150,42,150,44,150,38,78,86,78,115,78,139,78,155,78,158,78,171,78,172,78,111,79,157,79,141,79,115,79,127,79,108,79,155,79,139,79,134,79,131,79,112,79,117,79,136,79,105,79,123,79,150,79,126,79,143,79,145,79,122,79,84,81,82,81,85,81,105,81,119,81,118,81,120,81,189,81,253,81,59,82,56,82,55,82,58,82,48,82,46,82,54,82,65,82,190,82,187,82,82,83,84,83,83,83,81,83,102,83,119,83,120,83,121,83,214,83,212,83,215,83,115,84,117,84,150,84,120,84,149,84,128,84,123,84,119,84,132,84,146,84,134,84,124,84,144,84,113,84,118,84,140,84,154,84,98,84,104,84,139,84,125,84,142,84,250,86,131,87,119,87,106,87,105,87,97,87,102,87,100,87,124,87,28,89,73,89,71,89,72,89,68,89,84,89,190,89,187,89,212,89,185,89,174,89,209,89,198,89,208,89,205,89,203,89,211,89,202,89,175,89,179,89,210,89,197,89,95,91,100,91,99,91,151,91,154,91,152,91,156,91,153,91,155,91,26,92,72,92,69,92,70,92,183,92,161,92,184,92,169,92,171,92,177,92,179,92,24,94,26,94,22,94,21,94,27,94,17,94,120,94,154,94,151,94,156,94,149,94,150,94,246,94,38,95,39,95,41,95,128,95,129,95,127,95,124,95,221,95,224,95,253,95,245,95,255,95,15,96,20,96,47,96,53,96,22,96,42,96,21,96,33,96,39,96,41,96,43,96,27,96,22,98,21,98,63,98,62,98,64,98,127,98,201,98,204,98,196,98,191,98,194,98,185,98,210,98,219,98,171,98,211,98,212,98,203,98,200,98,168,98,189,98,188,98,208,98,217,98,199,98,205,98,181,98,218,98,177,98,216,98,214,98,215,98,198,98,172,98,206,98,62,101,167,101,188,101,250,101,20,102,19,102,12,102,6,102,2,102,14,102,0,102,15,102,21,102,10,102,7,102,13,103,11,103,109,103,139,103,149,103,113,103,156,103,115,103,119,103,135,103,157,103,151,103,111,103,112,103,127,103,137,103,126,103,144,103,117,103,154,103,147,103,124,103,106,103,114,103,35,107,102,107,103,107,127,107,19,108,27,108,227,108,232,108,243,108,177,108,204,108,229,108,179,108,189,108,190,108,188,108,226,108,171,108,213,108,211,108,184,108,196,108,185,108,193,108,174,108,215,108,197,108,241,108,191,108,187,108,225,108,219,108,202,108,172,108,239,108,220,108,214,108,224,108,149,112,142,112,146,112,138,112,153,112,44,114,45,114,56,114,72,114,103,114,105,114,192,114,206,114,217,114,215,114,208,114,169,115,168,115,159,115,171,115,165,115,61,117,157,117,153,117,154,117,132,118,194,118,242,118,244,118,229,119,253,119,62,121,64,121,65,121,201,121,200,121,122,122,121,122,250,122,254,124,84,127,140,127,139,127,5,128,186,128,165,128,162,128,177,128,161,128,171,128,169,128,180,128,170,128,175,128,229,129,254,129,13,130,179,130,157,130,153,130,173,130,189,130,159,130,185,130,177,130,172,130,165,130,175,130,184,130,163,130,176,130,190,130,183,130,78,134,113,134,29,82,104,136,203,142,206,143,212,143,209,143,181,144,184,144,177,144,182,144,199,145,209,145,119,149,128,149,28,150,64,150,63,150,59,150,68,150,66,150,185,150,232,150,82,151,94,151,159,78,173,78,174,78,225,79,181,79,175,79,191,79,224,79,209,79,207,79,221,79,195,79,182,79,216,79,223,79,202,79,215,79,174,79,208,79,196,79,194,79,218,79,206,79,222,79,183,79,87,81,146,81,145,81,160,81,78,82,67,82,74,82,77,82,76,82,75,82,71,82,199,82,201,82,195,82,193,82,13,83,87,83,123,83,154,83,219,83,172,84,192,84,168,84,206,84,201,84,184,84,166,84,179,84,199,84,194,84,189,84,170,84,193,84,196,84,200,84,175,84,171,84,177,84,187,84,169,84,167,84,191,84,255,86,130,87,139,87,160,87,163,87,162,87,206,87,174,87,147,87,85,89,81,89,79,89,78,89,80,89,220,89,216,89,255,89,227,89,232,89,3,90,229,89,234,89,218,89,230,89,1,90,251,89,105,91,163,91,166,91,164,91,162,91,165,91,1,92,78,92,79,92,77,92,75,92,217,92,210,92,247,93,29,94,37,94,31,94,125,94,160,94,166,94,250,94,8,95,45,95,101,95,136,95,133,95,138,95,139,95,135,95,140,95,137,95,18,96,29,96,32,96,37,96,14,96,40,96,77,96,112,96,104,96,98,96,70,96,67,96,108,96,107,96,106,96,100,96,65,98,220,98,22,99,9,99,252,98,237,98,1,99,238,98,253,98,7,99,241,98,247,98,239,98,236,98,254,98,244,98,17,99,2,99,63,101,69,101,171,101,189,101,226,101,37,102,45,102,32,102,39,102,47,102,31,102,40,102,49,102,36,102,247,102,255,103,211,103,241,103,212,103,208,103,236,103,182,103,175,103,245,103,233,103,239,103,196,103,209,103,180,103,218,103,229,103,184,103,207,103,222,103,243,103,176,103,217,103,226,103,221,103,210,103,106,107,131,107,134,107,181,107,210,107,215,107,31,108,201,108,11,109,50,109,42,109,65,109,37,109,12,109,49,109,30,109,23,109,59,109,61,109,62,109,54,109,27,109,245,108,57,109,39,109,56,109,41,109,46,109,53,109,14,109,43,109,171,112,186,112,179,112,172,112,175,112,173,112,184,112,174,112,164,112,48,114,114,114,111,114,116,114,233,114,224,114,225,114,183,115,202,115,187,115,178,115,205,115,192,115,179,115,26,117,45,117,79,117,76,117,78,117,75,117,171,117,164,117,165,117,162,117,163,117,120,118,134,118,135,118,136,118,200,118,198,118,195,118,197,118,1,119,249,118,248,118,9,119,11,119,254,118,252,118,7,119,220,119,2,120,20,120,12,120,13,120,70,121,73,121,72,121,71,121,185,121,186,121,209,121,210,121,203,121,127,122,129,122,255,122,253,122,125,124,2,125,5,125,0,125,9,125,7,125,4,125,6,125,56,127,142,127,191,127,4,128,16,128,13,128,17,128,54,128,214,128,229,128,218,128,195,128,196,128,204,128,225,128,219,128,206,128,222,128,228,128,221,128,244,129,34,130,231,130,3,131,5,131,227,130,219,130,230,130,4,131,229,130,2,131,9,131,210,130,215,130,241,130,1,131,220,130,212,130,209,130,222,130,211,130,223,130,239,130,6,131,80,134,121,134,123,134,122,134,77,136,107,136,129,137,212,137,8,138,2,138,3,138,158,140,160,140,116,141,115,141,180,141,205,142,204,142,240,143,230,143,226,143,234,143,229,143,237,143,235,143,228,143,232,143,202,144,206,144,193,144,195,144,75,145,74,145,205,145,130,149,80,150,75,150,76,150,77,150,98,151,105,151,203,151,237,151,243,151,1,152,168,152,219,152,223,152,150,153,153,153,88,78,179,78,12,80,13,80,35,80,239,79,38,80,37,80,248,79,41,80,22,80,6,80,60,80,31,80,26,80,18,80,17,80,250,79,0,80,20,80,40,80,241,79,33,80,11,80,25,80,24,80,243,79,238,79,45,80,42,80,254,79,43,80,9,80,124,81,164,81,165,81,162,81,205,81,204,81,198,81,203,81,86,82,92,82,84,82,91,82,93,82,42,83,127,83,159,83,157,83,223,83,232,84,16,85,1,85,55,85,252,84,229,84,242,84,6,85,250,84,20,85,233,84,237,84,225,84,9,85,238,84,234,84,230,84,39,85,7,85,253,84,15,85,3,87,4,87,194,87,212,87,203,87,195,87,9,88,15,89,87,89,88,89,90,89,17,90,24,90,28,90,31,90,27,90,19,90,236,89,32,90,35,90,41,90,37,90,12,90,9,90,107,91,88,92,176,91,179,91,182,91,180,91,174,91,181,91,185,91,184,91,4,92,81,92,85,92,80,92,237,92,253,92,251,92,234,92,232,92,240,92,246,92,1,93,244,92,238,93,45,94,43,94,171,94,173,94,167,94,49,95,146,95,145,95,144,95,89,96,99,96,101,96,80,96,85,96,109,96,105,96,111,96,132,96,159,96,154,96,141,96,148,96,140,96,133,96,150,96,71,98,243,98,8,99,255,98,78,99,62,99,47,99,85,99,66,99,70,99,79,99,73,99,58,99,80,99,61,99,42,99,43,99,40,99,77,99,76,99,72,101,73,101,153,101,193,101,197,101,66,102,73,102,79,102,67,102,82,102,76,102,69,102,65,102,248,102,20,103,21,103,23,103,33,104,56,104,72,104,70,104,83,104,57,104,66,104,84,104,41,104,179,104,23,104,76,104,81,104,61,104,244,103,80,104,64,104,60,104,67,104,42,104,69,104,19,104,24,104,65,104,138,107,137,107,183,107,35,108,39,108,40,108,38,108,36,108,240,108,106,109,149,109,136,109,135,109,102,109,120,109,119,109,89,109,147,109,108,109,137,109,110,109,90,109,116,109,105,109,140,109,138,109,121,109,133,109,101,109,148,109,202,112,216,112,228,112,217,112,200,112,207,112,57,114,121,114,252,114,249,114,253,114,248,114,247,114,134,115,237,115,9,116,238,115,224,115,234,115,222,115,84,117,93,117,92,117,90,117,89,117,190,117,197,117,199,117,178,117,179,117,189,117,188,117,185,117,194,117,184,117,139,118,176,118,202,118,205,118,206,118,41,119,31,119,32,119,40,119,233,119,48,120,39,120,56,120,29,120,52,120,55,120,37,120,45,120,32,120,31,120,50,120,85,121,80,121,96,121,95,121,86,121,94,121,93,121,87,121,90,121,228,121,227,121,231,121,223,121,230,121,233,121,216,121,132,122,136,122,217,122,6,123,17,123,137,124,33,125,23,125,11,125,10,125,32,125,34,125,20,125,16,125,21,125,26,125,28,125,13,125,25,125,27,125,58,127,95,127,148,127,197,127,193,127,6,128,24,128,21,128,25,128,23,128,61,128,63,128,241,128,2,129,240,128,5,129,237,128,244,128,6,129,248,128,243,128,8,129,253,128,10,129,252,128,239,128,237,129,236,129,0,130,16,130,42,130,43,130,40,130,44,130,187,130,43,131,82,131,84,131,74,131,56,131,80,131,73,131,53,131,52,131,79,131,50,131,57,131,54,131,23,131,64,131,49,131,40,131,67,131,84,134,138,134,170,134,147,134,164,134,169,134,140,134,163,134,156,134,112,136,119,136,129,136,130,136,125,136,121,136,24,138,16,138,14,138,12,138,21,138,10,138,23,138,19,138,22,138,15,138,17,138,72,140,122,140,121,140,161,140,162,140,119,141,172,142,210,142,212,142,207,142,177,143,1,144,6,144,247,143,0,144,250,143,244,143,3,144,253,143,5,144,248,143,149,144,225,144,221,144,226,144,82,145,77,145,76,145,216,145,221,145,215,145,220,145,217,145,131,149,98,150,99,150,97,150,91,150,93,150,100,150,88,150,94,150,187,150,226,152,172,153,168,154,216,154,37,155,50,155,60,155,126,78,122,80,125,80,92,80,71,80,67,80,76,80,90,80,73,80,101,80,118,80,78,80,85,80,117,80,116,80,119,80,79,80,15,80,111,80,109,80,92,81,149,81,240,81,106,82,111,82,210,82,217,82,216,82,213,82,16,83,15,83,25,83,63,83,64,83,62,83,195,83,252,102,70,85,106,85,102,85,68,85,94,85,97,85,67,85,74,85,49,85,86,85,79,85,85,85,47,85,100,85,56,85,46,85,92,85,44,85,99,85,51,85,65,85,87,85,8,87,11,87,9,87,223,87,5,88,10,88,6,88,224,87,228,87,250,87,2,88,53,88,247,87,249,87,32,89,98,89,54,90,65,90,73,90,102,90,106,90,64,90,60,90,98,90,90,90,70,90,74,90,112,91,199,91,197,91,196,91,194,91,191,91,198,91,9,92,8,92,7,92,96,92,92,92,93,92,7,93,6,93,14,93,27,93,22,93,34,93,17,93,41,93,20,93,25,93,36,93,39,93,23,93,226,93,56,94,54,94,51,94,55,94,183,94,184,94,182,94,181,94,190,94,53,95,55,95,87,95,108,95,105,95,107,95,151,95,153,95,158,95,152,95,161,95,160,95,156,95,127,96,163,96,137,96,160,96,168,96,203,96,180,96,230,96,189,96,197,96,187,96,181,96,220,96,188,96,216,96,213,96,198,96,223,96,184,96,218,96,199,96,26,98,27,98,72,98,160,99,167,99,114,99,150,99,162,99,165,99,119,99,103,99,152,99,170,99,113,99,169,99,137,99,131,99,155,99,107,99,168,99,132,99,136,99,153,99,161,99,172,99,146,99,143,99,128,99,123,99,105,99,104,99,122,99,93,101,86,101,81,101,89,101,87,101,95,85,79,101,88,101,85,101,84,101,156,101,155,101,172,101,207,101,203,101,204,101,206,101,93,102,90,102,100,102,104,102,102,102,94,102,249,102,215,82,27,103,129,104,175,104,162,104,147,104,181,104,127,104,118,104,177,104,167,104,151,104,176,104,131,104,196,104,173,104,134,104,133,104,148,104,157,104,168,104,159,104,161,104,130,104,50,107,186,107,235,107,236,107,43,108,142,109,188,109,243,109,217,109,178,109,225,109,204,109,228,109,251,109,250,109,5,110,199,109,203,109,175,109,209,109,174,109,222,109,249,109,184,109,247,109,245,109,197,109,210,109,26,110,181,109,218,109,235,109,216,109,234,109,241,109,238,109,232,109,198,109,196,109,170,109,236,109,191,109,230,109,249,112,9,113,10,113,253,112,239,112,61,114,125,114,129,114,28,115,27,115,22,115,19,115,25,115,135,115,5,116,10,116,3,116,6,116,254,115,13,116,224,116,246,116,247,116,28,117,34,117,101,117,102,117,98,117,112,117,143,117,212,117,213,117,181,117,202,117,205,117,142,118,212,118,210,118,219,118,55,119,62,119,60,119,54,119,56,119,58,119,107,120,67,120,78,120,101,121,104,121,109,121,251,121,146,122,149,122,32,123,40,123,27,123,44,123,38,123,25,123,30,123,46,123,146,124,151,124,149,124,70,125,67,125,113,125,46,125,57,125,60,125,64,125,48,125,51,125,68,125,47,125,66,125,50,125,49,125,61,127,158,127,154,127,204,127,206,127,210,127,28,128,74,128,70,128,47,129,22,129,35,129,43,129,41,129,48,129,36,129,2,130,53,130,55,130,54,130,57,130,142,131,158,131,152,131,120,131,162,131,150,131,189,131,171,131,146,131,138,131,147,131,137,131,160,131,119,131,123,131,124,131,134,131,167,131,85,134,106,95,199,134,192,134,182,134,196,134,181,134,198,134,203,134,177,134,175,134,201,134,83,136,158,136,136,136,171,136,146,136,150,136,141,136,139,136,147,137,143,137,42,138,29,138,35,138,37,138,49,138,45,138,31,138,27,138,34,138,73,140,90,140,169,140,172,140,171,140,168,140,170,140,167,140,103,141,102,141,190,141,186,141,219,142,223,142,25,144,13,144,26,144,23,144,35,144,31,144,29,144,16,144,21,144,30,144,32,144,15,144,34,144,22,144,27,144,20,144,232,144,237,144,253,144,87,145,206,145,245,145,230,145,227,145,231,145,237,145,233,145,137,149,106,150,117,150,115,150,120,150,112,150,116,150,118,150,119,150,108,150,192,150,234,150,233,150,224,122,223,122,2,152,3,152,90,155,229,156,117,158,127,158,165,158,187,158,162,80,141,80,133,80,153,80,145,80,128,80,150,80,152,80,154,80,0,103,241,81,114,82,116,82,117,82,105,82,222,82,221,82,219,82,90,83,165,83,123,85,128,85,167,85,124,85,138,85,157,85,152,85,130,85,156,85,170,85,148,85,135,85,139,85,131,85,179,85,174,85,159,85,62,85,178,85,154,85,187,85,172,85,177,85,126,85,137,85,171,85,153,85,13,87,47,88,42,88,52,88,36,88,48,88,49,88,33,88,29,88,32,88,249,88,250,88,96,89,119,90,154,90,127,90,146,90,155,90,167,90,115,91,113,91,210,91,204,91,211,91,208,91,10,92,11,92,49,92,76,93,80,93,52,93,71,93,253,93,69,94,61,94,64,94,67,94,126,94,202,94,193,94,194,94,196,94,60,95,109,95,169,95,170,95,168,95,209,96,225,96,178,96,182,96,224,96,28,97,35,97,250,96,21,97,240,96,251,96,244,96,104,97,241,96,14,97,246,96,9,97,0,97,18,97,31,98,73,98,163,99,140,99,207,99,192,99,233,99,201,99,198,99,205,99,210,99,227,99,208,99,225,99,214,99,237,99,238,99,118,99,244,99,234,99,219,99,82,100,218,99,249,99,94,101,102,101,98,101,99,101,145,101,144,101,175,101,110,102,112,102,116,102,118,102,111,102,145,102,122,102,126,102,119,102,254,102,255,102,31,103,29,103,250,104,213,104,224,104,216,104,215,104,5,105,223,104,245,104,238,104,231,104,249,104,210,104,242,104,227,104,203,104,205,104,13,105,18,105,14,105,201,104,218,104,110,105,251,104,62,107,58,107,61,107,152,107,150,107,188,107,239,107,46,108,47,108,44,108,47,110,56,110,84,110,33,110,50,110,103,110,74,110,32,110,37,110,35,110,27,110,91,110,88,110,36,110,86,110,110,110,45,110,38,110,111,110,52,110,77,110,58,110,44,110,67,110,29,110,62,110,203,110,137,110,25,110,78,110,99,110,68,110,114,110,105,110,95,110,25,113,26,113,38,113,48,113,33,113,54,113,110,113,28,113,76,114,132,114,128,114,54,115,37,115,52,115,41,115,58,116,42,116,51,116,34,116,37,116,53,116,54,116,52,116,47,116,27,116,38,116,40,116,37,117,38,117,107,117,106,117,226,117,219,117,227,117,217,117,216,117,222,117,224,117,123,118,124,118,150,118,147,118,180,118,220,118,79,119,237,119,93,120,108,120,111,120,13,122,8,122,11,122,5,122,0,122,152,122,151,122,150,122,229,122,227,122,73,123,86,123,70,123,80,123,82,123,84,123,77,123,75,123,79,123,81,123,159,124,165,124,94,125,80,125,104,125,85,125,43,125,110,125,114,125,97,125,102,125,98,125,112,125,115,125,132,85,212,127,213,127,11,128,82,128,133,128,85,129,84,129,75,129,81,129,78,129,57,129,70,129,62,129,76,129,83,129,116,129,18,130,28,130,233,131,3,132,248,131,13,132,224,131,197,131,11,132,193,131,239,131,241,131,244,131,87,132,10,132,240,131,12,132,204,131,253,131,242,131,202,131,56,132,14,132,4,132,220,131,7,132,212,131,223,131,91,134,223,134,217,134,237,134,212,134,219,134,228,134,208,134,222,134,87,136,193,136,194,136,177,136,131,137,150,137,59,138,96,138,85,138,94,138,60,138,65,138,84,138,91,138,80,138,70,138,52,138,58,138,54,138,86,138,97,140,130,140,175,140,188,140,179,140,189,140,193,140,187,140,192,140,180,140,183,140,182,140,191,140,184,140,138,141,133,141,129,141,206,141,221,141,203,141,218,141,209,141,204,141,219,141,198,141,251,142,248,142,252,142,156,143,46,144,53,144,49,144,56,144,50,144,54,144,2,145,245,144,9,145,254,144,99,145,101,145,207,145,20,146,21,146,35,146,9,146,30,146,13,146,16,146,7,146,17,146,148,149,143,149,139,149,145,149,147,149,146,149,142,149,138,150,142,150,139,150,125,150,133,150,134,150,141,150,114,150,132,150,193,150,197,150,196,150,198,150,199,150,239,150,242,150,204,151,5,152,6,152,8,152,231,152,234,152,239,152,233,152,242,152,237,152,174,153,173,153,195,158,205,158,209,158,130,78,173,80,181,80,178,80,179,80,197,80,190,80,172,80,183,80,187,80,175,80,199,80,127,82,119,82,125,82,223,82,230,82,228,82,226,82,227,82,47,83,223,85,232,85,211,85,230,85,206,85,220,85,199,85,209,85,227,85,228,85,239,85,218,85,225,85,197,85,198,85,229,85,201,85,18,87,19,87,94,88,81,88,88,88,87,88,90,88,84,88,107,88,76,88,109,88,74,88,98,88,82,88,75,88,103,89,193,90,201,90,204,90,190,90,189,90,188,90,179,90,194,90,178,90,105,93,111,93,76,94,121,94,201,94,200,94,18,95,89,95,172,95,174,95,26,97,15,97,72,97,31,97,243,96,27,97,249,96,1,97,8,97,78,97,76,97,68,97,77,97,62,97,52,97,39,97,13,97,6,97,55,97,33,98,34,98,19,100,62,100,30,100,42,100,45,100,61,100,44,100,15,100,28,100,20,100,13,100,54,100,22,100,23,100,6,100,108,101,159,101,176,101,151,102,137,102,135,102,136,102,150,102,132,102,152,102,141,102,3,103,148,105,109,105,90,105,119,105,96,105,84,105,117,105,48,105,130,105,74,105,104,105,107,105,94,105,83,105,121,105,134,105,93,105,99,105,91,105,71,107,114,107,192,107,191,107,211,107,253,107,162,110,175,110,211,110,182,110,194,110,144,110,157,110,199,110,197,110,165,110,152,110,188,110,186,110,171,110,209,110,150,110,156,110,196,110,212,110,170,110,167,110,180,110,78,113,89,113,105,113,100,113,73,113,103,113,92,113,108,113,102,113,76,113,101,113,94,113,70,113,104,113,86,113,58,114,82,114,55,115,69,115,63,115,62,115,111,116,90,116,85,116,95,116,94,116,65,116,63,116,89,116,91,116,92,116,118,117,120,117,0,118,240,117,1,118,242,117,241,117,250,117,255,117,244,117,243,117,222,118,223,118,91,119,107,119,102,119,94,119,99,119,121,119,106,119,108,119,92,119,101,119,104,119,98,119,238,119,142,120,176,120,151,120,152,120,140,120,137,120,124,120,145,120,147,120,127,120,122,121,127,121,129,121,44,132,189,121,28,122,26,122,32,122,20,122,31,122,30,122,159,122,160,122,119,123,192,123,96,123,110,123,103,123,177,124,179,124,181,124,147,125,121,125,145,125,129,125,143,125,91,125,110,127,105,127,106,127,114,127,169,127,168,127,164,127,86,128,88,128,134,128,132,128,113,129,112,129,120,129,101,129,110,129,115,129,107,129,121,129,122,129,102,129,5,130,71,130,130,132,119,132,61,132,49,132,117,132,102,132,107,132,73,132,108,132,91,132,60,132,53,132,97,132,99,132,105,132,109,132,70,132,94,134,92,134,95,134,249,134,19,135,8,135,7,135,0,135,254,134,251,134,2,135,3,135,6,135,10,135,89,136,223,136,212,136,217,136,220,136,216,136,221,136,225,136,202,136,213,136,210,136,156,137,227,137,107,138,114,138,115,138,102,138,105,138,112,138,135,138,124,138,99,138,160,138,113,138,133,138,109,138,98,138,110,138,108,138,121,138,123,138,62,138,104,138,98,140,138,140,137,140,202,140,199,140,200,140,196,140,178,140,195,140,194,140,197,140,225,141,223,141,232,141,239,141,243,141,250,141,234,141,228,141,230,141,178,142,3,143,9,143,254,142,10,143,159,143,178,143,75,144,74,144,83,144,66,144,84,144,60,144,85,144,80,144,71,144,79,144,78,144,77,144,81,144,62,144,65,144,18,145,23,145,108,145,106,145,105,145,201,145,55,146,87,146,56,146,61,146,64,146,62,146,91,146,75,146,100,146,81,146,52,146,73,146,77,146,69,146,57,146,63,146,90,146,152,149,152,150,148,150,149,150,205,150,203,150,201,150,202,150,247,150,251,150,249,150,246,150,86,151,116,151,118,151,16,152,17,152,19,152,10,152,18,152,12,152,252,152,244,152,253,152,254,152,179,153,177,153,180,153,225,154,233,156,130,158,14,159,19,159,32,159,231,80,238,80,229,80,214,80,237,80,218,80,213,80,207,80,209,80,241,80,206,80,233,80,98,81,243,81,131,82,130,82,49,83,173,83,254,85,0,86,27,86,23,86,253,85,20,86,6,86,9,86,13,86,14,86,247,85,22,86,31,86,8,86,16,86,246,85,24,87,22,87,117,88,126,88,131,88,147,88,138,88,121,88,133,88,125,88,253,88,37,89,34,89,36,89,106,89,105,89,225,90,230,90,233,90,215,90,214,90,216,90,227,90,117,91,222,91,231,91,225,91,229,91,230,91,232,91,226,91,228,91,223,91,13,92,98,92,132,93,135,93,91,94,99,94,85,94,87,94,84,94,211,94,214,94,10,95,70,95,112,95,185,95,71,97,63,97,75,97,119,97,98,97,99,97,95,97,90,97,88,97,117,97,42,98,135,100,88,100,84,100,164,100,120,100,95,100,122,100,81,100,103,100,52,100,109,100,123,100,114,101,161,101,215,101,214,101,162,102,168,102,157,102,156,105,168,105,149,105,193,105,174,105,211,105,203,105,155,105,183,105,187,105,171,105,180,105,208,105,205,105,173,105,204,105,166,105,195,105,163,105,73,107,76,107,51,108,51,111,20,111,254,110,19,111,244,110,41,111,62,111,32,111,44,111,15,111,2,111,34,111,255,110,239,110,6,111,49,111,56,111,50,111,35,111,21,111,43,111,47,111,136,111,42,111,236,110,1,111,242,110,204,110,247,110,148,113,153,113,125,113,138,113,132,113,146,113,62,114,146,114,150,114,68,115,80,115,100,116,99,116,106,116,112,116,109,116,4,117,145,117,39,118,13,118,11,118,9,118,19,118,225,118,227,118,132,119,125,119,127,119,97,119,193,120,159,120,167,120,179,120,169,120,163,120,142,121,143,121,141,121,46,122,49,122,170,122,169,122,237,122,239,122,161,123,149,123,139,123,117,123,151,123,157,123,148,123,143,123,184,123,135,123,132,123,185,124,189,124,190,124,187,125,176,125,156,125,189,125,190,125,160,125,202,125,180,125,178,125,177,125,186,125,162,125,191,125,181,125,184,125,173,125,210,125,199,125,172,125,112,127,224,127,225,127,223,127,94,128,90,128,135,128,80,129,128,129,143,129,136,129,138,129,127,129,130,129,231,129,250,129,7,130,20,130,30,130,75,130,201,132,191,132,198,132,196,132,153,132,158,132,178,132,156,132,203,132,184,132,192,132,211,132,144,132,188,132,209,132,202,132,63,135,28,135,59,135,34,135,37,135,52,135,24,135,85,135,55,135,41,135,243,136,2,137,244,136,249,136,248,136,253,136,232,136,26,137,239,136,166,138,140,138,158,138,163,138,141,138,161,138,147,138,164,138,170,138,165,138,168,138,152,138,145,138,154,138,167,138,106,140,141,140,140,140,211,140,209,140,210,140,107,141,153,141,149,141,252,141,20,143,18,143,21,143,19,143,163,143,96,144,88,144,92,144,99,144,89,144,94,144,98,144,93,144,91,144,25,145,24,145,30,145,117,145,120,145,119,145,116,145,120,146,128,146,133,146,152,146,150,146,123,146,147,146,156,146,168,146,124,146,145,146,161,149,168,149,169,149,163,149,165,149,164,149,153,150,156,150,155,150,204,150,210,150,0,151,124,151,133,151,246,151,23,152,24,152,175,152,177,152,3,153,5,153,12,153,9,153,193,153,175,154,176,154,230,154,65,155,66,155,244,156,246,156,243,156,188,158,59,159,74,159,4,81,0,81,251,80,245,80,249,80,2,81,8,81,9,81,5,81,220,81,135,82,136,82,137,82,141,82,138,82,240,82,178,83,46,86,59,86,57,86,50,86,63,86,52,86,41,86,83,86,78,86,87,86,116,86,54,86,47,86,48,86,128,88,159,88,158,88,179,88,156,88,174,88,169,88,166,88,109,89,9,91,251,90,11,91,245,90,12,91,8,91,238,91,236,91,233,91,235,91,100,92,101,92,157,93,148,93,98,94,95,94,97,94,226,94,218,94,223,94,221,94,227,94,224,94,72,95,113,95,183,95,181,95,118,97,103,97,110,97,93,97,85,97,130,97,124,97,112,97,107,97,126,97,167,97,144,97,171,97,142,97,172,97,154,97,164,97,148,97,174,97,46,98,105,100,111,100,121,100,158,100,178,100,136,100,144,100,176,100,165,100,147,100,149,100,169,100,146,100,174,100,173,100,171,100,154,100,172,100,153,100,162,100,179,100,117,101,119,101,120,101,174,102,171,102,180,102,177,102,35,106,31,106,232,105,1,106,30,106,25,106,253,105,33,106,19,106,10,106,243,105,2,106,5,106,237,105,17,106,80,107,78,107,164,107,197,107,198,107,63,111,124,111,132,111,81,111,102,111,84,111,134,111,109,111,91,111,120,111,110,111,142,111,122,111,112,111,100,111,151,111,88,111,213,110,111,111,96,111,95,111,159,113,172,113,177,113,168,113,86,114,155,114,78,115,87,115,105,116,139,116,131,116,126,116,128,116,127,117,32,118,41,118,31,118,36,118,38,118,33,118,34,118,154,118,186,118,228,118,142,119,135,119,140,119,145,119,139,119,203,120,197,120,186,120,202,120,190,120,213,120,188,120,208,120,63,122,60,122,64,122,61,122,55,122,59,122,175,122,174,122,173,123,177,123,196,123,180,123,198,123,199,123,193,123,160,123,204,123,202,124,224,125,244,125,239,125,251,125,216,125,236,125,221,125,232,125,227,125,218,125,222,125,233,125,158,125,217,125,242,125,249,125,117,127,119,127,175,127,233,127,38,128,155,129,156,129,157,129,160,129,154,129,152,129,23,133,61,133,26,133,238,132,44,133,45,133,19,133,17,133,35,133,33,133,20,133,236,132,37,133,255,132,6,133,130,135,116,135,118,135,96,135,102,135,120,135,104,135,89,135,87,135,76,135,83,135,91,136,93,136,16,137,7,137,18,137,19,137,21,137,10,137,188,138,210,138,199,138,196,138,149,138,203,138,248,138,178,138,201,138,194,138,191,138,176,138,214,138,205,138,182,138,185,138,219,138,76,140,78,140,108,140,224,140,222,140,230,140,228,140,236,140,237,140,226,140,227,140,220,140,234,140,225,140,109,141,159,141,163,141,43,142,16,142,29,142,34,142,15,142,41,142,31,142,33,142,30,142,186,142,29,143,27,143,31,143,41,143,38,143,42,143,28,143,30,143,37,143,105,144,110,144,104,144,109,144,119,144,48,145,45,145,39,145,49,145,135,145,137,145,139,145,131,145,197,146,187,146,183,146,234,146,172,146,228,146,193,146,179,146,188,146,210,146,199,146,240,146,178,146,173,149,177,149,4,151,6,151,7,151,9,151,96,151,141,151,139,151,143,151,33,152,43,152,28,152,179,152,10,153,19,153,18,153,24,153,221,153,208,153,223,153,219,153,209,153,213,153,210,153,217,153,183,154,238,154,239,154,39,155,69,155,68,155,119,155,111,155,6,157,9,157,3,157,169,158,190,158,206,158,168,88,82,159,18,81,24,81,20,81,16,81,21,81,128,81,170,81,221,81,145,82,147,82,243,82,89,86,107,86,121,86,105,86,100,86,120,86,106,86,104,86,101,86,113,86,111,86,108,86,98,86,118,86,193,88,190,88,199,88,197,88,110,89,29,91,52,91,120,91,240,91,14,92,74,95,178,97,145,97,169,97,138,97,205,97,182,97,190,97,202,97,200,97,48,98,197,100,193,100,203,100,187,100,188,100,218,100,196,100,199,100,194,100,205,100,191,100,210,100,212,100,190,100,116,101,198,102,201,102,185,102,196,102,199,102,184,102,61,106,56,106,58,106,89,106,107,106,88,106,57,106,68,106,98,106,97,106,75,106,71,106,53,106,95,106,72,106,89,107,119,107,5,108,194,111,177,111,161,111,195,111,164,111,193,111,167,111,179,111,192,111,185,111,182,111,166,111,160,111,180,111,190,113,201,113,208,113,210,113,200,113,213,113,185,113,206,113,217,113,220,113,195,113,196,113,104,115,156,116,163,116,152,116,159,116,158,116,226,116,12,117,13,117,52,118,56,118,58,118,231,118,229,118,160,119,158,119,159,119,165,119,232,120,218,120,236,120,231,120,166,121,77,122,78,122,70,122,76,122,75,122,186,122,217,123,17,124,201,123,228,123,219,123,225,123,233,123,230,123,213,124,214,124,10,126,17,126,8,126,27,126,35,126,30,126,29,126,9,126,16,126,121,127,178,127,240,127,241,127,238,127,40,128,179,129,169,129,168,129,251,129,8,130,88,130,89,130,74,133,89,133,72,133,104,133,105,133,67,133,73,133,109,133,106,133,94,133,131,135,159,135,158,135,162,135,141,135,97,136,42,137,50,137,37,137,43,137,33,137,170,137,166,137,230,138,250,138,235,138,241,138,0,139,220,138,231,138,238,138,254,138,1,139,2,139,247,138,237,138,243,138,246,138,252,138,107,140,109,140,147,140,244,140,68,142,49,142,52,142,66,142,57,142,53,142,59,143,47,143,56,143,51,143,168,143,166,143,117,144,116,144,120,144,114,144,124,144,122,144,52,145,146,145,32,147,54,147,248,146,51,147,47,147,34,147,252,146,43,147,4,147,26,147,16,147,38,147,33,147,21,147,46,147,25,147,187,149,167,150,168,150,170,150,213,150,14,151,17,151,22,151,13,151,19,151,15,151,91,151,92,151,102,151,152,151,48,152,56,152,59,152,55,152,45,152,57,152,36,152,16,153,40,153,30,153,27,153,33,153,26,153,237,153,226,153,241,153,184,154,188,154,251,154,237,154,40,155,145,155,21,157,35,157,38,157,40,157,18,157,27,157,216,158,212,158,141,159,156,159,42,81,31,81,33,81,50,81,245,82,142,86,128,86,144,86,133,86,135,86,143,86,213,88,211,88,209,88,206,88,48,91,42,91,36,91,122,91,55,92,104,92,188,93,186,93,189,93,184,93,107,94,76,95,189,95,201,97,194,97,199,97,230,97,203,97,50,98,52,98,206,100,202,100,216,100,224,100,240,100,230,100,236,100,241,100,226,100,237,100,130,101,131,101,217,102,214,102,128,106,148,106,132,106,162,106,156,106,219,106,163,106,126,106,151,106,144,106,160,106,92,107,174,107,218,107,8,108,216,111,241,111,223,111,224,111,219,111,228,111,235,111,239,111,128,111,236,111,225,111,233,111,213,111,238,111,240,111,231,113,223,113,238,113,230,113,229,113,237,113,236,113,244,113,224,113,53,114,70,114,112,115,114,115,169,116,176,116,166,116,168,116,70,118,66,118,76,118,234,118,179,119,170,119,176,119,172,119,167,119,173,119,239,119,247,120,250,120,244,120,239,120,1,121,167,121,170,121,87,122,191,122,7,124,13,124,254,123,247,123,12,124,224,123,224,124,220,124,222,124,226,124,223,124,217,124,221,124,46,126,62,126,70,126,55,126,50,126,67,126,43,126,61,126,49,126,69,126,65,126,52,126,57,126,72,126,53,126,63,126,47,126,68,127,243,127,252,127,113,128,114,128,112,128,111,128,115,128,198,129,195,129,186,129,194,129,192,129,191,129,189,129,201,129,190,129,232,129,9,130,113,130,170,133,132,133,126,133,156,133,145,133,148,133,175,133,155,133,135,133,168,133,138,133,103,134,192,135,209,135,179,135,210,135,198,135,171,135,187,135,186,135,200,135,203,135,59,137,54,137,68,137,56,137,61,137,172,137,14,139,23,139,25,139,27,139,10,139,32,139,29,139,4,139,16,139,65,140,63,140,115,140,250,140,253,140,252,140,248,140,251,140,168,141,73,142,75,142,72,142,74,142,68,143,62,143,66,143,69,143,63,143,127,144,125,144,132,144,129,144,130,144,128,144,57,145,163,145,158,145,156,145,77,147,130,147,40,147,117,147,74,147,101,147,75,147,24,147,126,147,108,147,91,147,112,147,90,147,84,147,202,149,203,149,204,149,200,149,198,149,177,150,184,150,214,150,28,151,30,151,160,151,211,151,70,152,182,152,53,153,1,154,255,153,174,155,171,155,170,155,173,155,59,157,63,157,139,158,207,158,222,158,220,158,221,158,219,158,62,159,75,159,226,83,149,86,174,86,217,88,216,88,56,91,93,95,227,97,51,98,244,100,242,100,254,100,6,101,250,100,251,100,247,100,183,101,220,102,38,103,179,106,172,106,195,106,187,106,184,106,194,106,174,106,175,106,95,107,120,107,175,107,9,112,11,112,254,111,6,112,250,111,17,112,15,112,251,113,252,113,254,113,248,113,119,115,117,115,167,116,191,116,21,117,86,118,88,118,82,118,189,119,191,119,187,119,188,119,14,121,174,121,97,122,98,122,96,122,196,122,197,122,43,124,39,124,42,124,30,124,35,124,33,124,231,124,84,126,85,126,94,126,90,126,97,126,82,126,89,126,72,127,249,127,251,127,119,128,118,128,205,129,207,129,10,130,207,133,169,133,205,133,208,133,201,133,176,133,186,133,185,133,166,133,239,135,236,135,242,135,224,135,134,137,178,137,244,137,40,139,57,139,44,139,43,139,80,140,5,141,89,142,99,142,102,142,100,142,95,142,85,142,192,142,73,143,77,143,135,144,131,144,136,144,171,145,172,145,208,145,148,147,138,147,150,147,162,147,179,147,174,147,172,147,176,147,152,147,154,147,151,147,212,149,214,149,208,149,213,149,226,150,220,150,217,150,219,150,222,150,36,151,163,151,166,151,173,151,249,151,77,152,79,152,76,152,78,152,83,152,186,152,62,153,63,153,61,153,46,153,165,153,14,154,193,154,3,155,6,155,79,155,78,155,77,155,202,155,201,155,253,155,200,155],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+281828),
	allocate([192,155,81,157,93,157,96,157,224,158,21,159,44,159,51,81,165,86,222,88,223,88,226,88,245,91,144,159,236,94,242,97,247,97,246,97,245,97,0,101,15,101,224,102,221,102,229,106,221,106,218,106,211,106,27,112,31,112,40,112,26,112,29,112,21,112,24,112,6,114,13,114,88,114,162,114,120,115,122,115,189,116,202,116,227,116,135,117,134,117,95,118,97,118,199,119,25,121,177,121,107,122,105,122,62,124,63,124,56,124,61,124,55,124,64,124,107,126,109,126,121,126,105,126,106,126,133,127,115,126,182,127,185,127,184,127,216,129,233,133,221,133,234,133,213,133,228,133,229,133,247,133,251,135,5,136,13,136,249,135,254,135,96,137,95,137,86,137,94,137,65,139,92,139,88,139,73,139,90,139,78,139,79,139,70,139,89,139,8,141,10,141,124,142,114,142,135,142,118,142,108,142,122,142,116,142,84,143,78,143,173,143,138,144,139,144,177,145,174,145,225,147,209,147,223,147,195,147,200,147,220,147,221,147,214,147,226,147,205,147,216,147,228,147,215,147,232,147,220,149,180,150,227,150,42,151,39,151,97,151,220,151,251,151,94,152,88,152,91,152,188,152,69,153,73,153,22,154,25,154,13,155,232,155,231,155,214,155,219,155,137,157,97,157,114,157,106,157,108,157,146,158,151,158,147,158,180,158,248,82,168,86,183,86,182,86,180,86,188,86,228,88,64,91,67,91,125,91,246,91,201,93,248,97,250,97,24,101,20,101,25,101,230,102,39,103,236,106,62,112,48,112,50,112,16,114,123,115,207,116,98,118,101,118,38,121,42,121,44,121,43,121,199,122,246,122,76,124,67,124,77,124,239,124,240,124,174,143,125,126,124,126,130,126,76,127,0,128,218,129,102,130,251,133,249,133,17,134,250,133,6,134,11,134,7,134,10,134,20,136,21,136,100,137,186,137,248,137,112,139,108,139,102,139,111,139,95,139,107,139,15,141,13,141,137,142,129,142,133,142,130,142,180,145,203,145,24,148,3,148,253,147,225,149,48,151,196,152,82,153,81,153,168,153,43,154,48,154,55,154,53,154,19,156,13,156,121,158,181,158,232,158,47,159,95,159,99,159,97,159,55,81,56,81,193,86,192,86,194,86,20,89,108,92,205,93,252,97,254,97,29,101,28,101,149,101,233,102,251,106,4,107,250,106,178,107,76,112,27,114,167,114,214,116,212,116,105,118,211,119,80,124,143,126,140,126,188,127,23,134,45,134,26,134,35,136,34,136,33,136,31,136,106,137,108,137,189,137,116,139,119,139,125,139,19,141,138,142,141,142,139,142,95,143,175,143,186,145,46,148,51,148,53,148,58,148,56,148,50,148,43,148,226,149,56,151,57,151,50,151,255,151,103,152,101,152,87,153,69,154,67,154,64,154,62,154,207,154,84,155,81,155,45,156,37,156,175,157,180,157,194,157,184,157,157,158,239,158,25,159,92,159,102,159,103,159,60,81,59,81,200,86,202,86,201,86,127,91,212,93,210,93,78,95,255,97,36,101,10,107,97,107,81,112,88,112,128,115,228,116,138,117,110,118,108,118,179,121,96,124,95,124,126,128,125,128,223,129,114,137,111,137,252,137,128,139,22,141,23,141,145,142,147,142,97,143,72,145,68,148,81,148,82,148,61,151,62,151,195,151,193,151,107,152,85,153,85,154,77,154,210,154,26,155,73,156,49,156,62,156,59,156,211,157,215,157,52,159,108,159,106,159,148,159,204,86,214,93,0,98,35,101,43,101,42,101,236,102,16,107,218,116,202,122,100,124,99,124,101,124,147,126,150,126,148,126,226,129,56,134,63,134,49,136,138,139,144,144,143,144,99,148,96,148,100,148,104,151,111,152,92,153,90,154,91,154,87,154,211,154,212,154,209,154,84,156,87,156,86,156,229,157,159,158,244,158,209,86,233,88,44,101,94,112,113,118,114,118,215,119,80,127,136,127,54,136,57,136,98,136,147,139,146,139,150,139,119,130,27,141,192,145,106,148,66,151,72,151,68,151,198,151,112,152,95,154,34,155,88,155,95,156,249,157,250,157,124,158,125,158,7,159,119,159,114,159,243,94,22,107,99,112,108,124,110,124,59,136,192,137,161,142,193,145,114,148,112,148,113,152,94,153,214,154,35,155,204,158,100,112,218,119,154,139,119,148,201,151,98,154,101,154,156,126,156,139,170,142,197,145,125,148,126,148,124,148,119,156,120,156,247,158,84,140,127,148,26,158,40,114,106,154,49,155,27,158,30,158,114,124,96,36,97,36,98,36,99,36,100,36,101,36,102,36,103,36,104,36,105,36,116,36,117,36,118,36,119,36,120,36,121,36,122,36,123,36,124,36,125,36,112,33,113,33,114,33,115,33,116,33,117,33,118,33,119,33,120,33,121,33,54,78,63,78,133,78,160,78,130,81,150,81,171,81,249,82,56,83,105,83,182,83,10,89,128,91,219,93,122,94,127,94,244,94,80,95,97,95,52,101,224,101,146,117,118,118,181,143,182,150,168,0,198,2,253,48,254,48,157,48,158,48,0,0,0,0,5,48,6,48,7,48,252,48,59,255,61,255,61,39,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,231,33,184,33,185,33,207,49,204,0,90,78,138,0,2,82,145,68,176,159,136,81,177,159,7,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,226,255,228,255,7,255,2,255,49,50,22,33,33,33,155,48,156,48,128,46,132,46,134,46,135,46,136,46,138,46,140,46,141,46,149,46,156,46,157,46,165,46,167,46,170,46,172,46,174,46,182,46,188,46,190,46,198,46,202,46,204,46,205,46,207,46,214,46,215,46,222,46,227,46,0,0,0,0,0,0,131,2,80,2,91,2,84,2,117,2,83,1,248,0,75,1,138,2,106,2,66,78,92,78,245,81,26,83,130,83,7,78,12,78,71,78,141,78,215,86,12,250,110,92,115,95,15,78,135,81,14,78,46,78,147,78,194,78,201,78,200,78,152,81,252,82,108,83,185,83,32,87,3,89,44,89,16,92,255,93,225,101,179,107,204,107,20,108,63,114,49,78,60,78,232,78,220,78,233,78,225,78,221,78,218,78,12,82,28,83,76,83,34,87,35,87,23,89,47,89,129,91,132,91,18,92,59,92,116,92,115,92,4,94,128,94,130,94,201,95,9,98,80,98,21,108,54,108,67,108,63,108,59,108,174,114,176,114,138,115,184,121,138,128,30,150,14,79,24,79,44,79,245,78,20,79,241,78,0,79,247,78,8,79,29,79,2,79,5,79,34,79,19,79,4,79,244,78,18,79,177,81,19,82,9,82,16,82,166,82,34,83,31,83,77,83,138,83,7,84,225,86,223,86,46,87,42,87,52,87,60,89,128,89,124,89,133,89,123,89,126,89,119,89,127,89,86,91,21,92,37,92,124,92,122,92,123,92,126,92,223,93,117,94,132,94,2,95,26,95,116,95,213,95,212,95,207,95,92,98,94,98,100,98,97,98,102,98,98,98,89,98,96,98,90,98,101,98,239,101,238,101,62,103,57,103,56,103,59,103,58,103,63,103,60,103,51,103,24,108,70,108,82,108,92,108,79,108,74,108,84,108,75,108,76,108,113,112,94,114,180,114,181,114,142,115,42,117,127,118,117,122,81,127,120,130,124,130,128,130,125,130,127,130,77,134,126,137,153,144,151,144,152,144,155,144,148,144,34,150,36,150,32,150,35,150,86,79,59,79,98,79,73,79,83,79,100,79,62,79,103,79,82,79,95,79,65,79,88,79,45,79,51,79,63,79,97,79,143,81,185,81,28,82,30,82,33,82,173,82,174,82,9,83,99,83,114,83,142,83,143,83,48,84,55,84,42,84,84,84,69,84,25,84,28,84,37,84,24,84,61,84,79,84,65,84,40,84,36,84,71,84,238,86,231,86,229,86,65,87,69,87,76,87,73,87,75,87,82,87,6,89,64,89,166,89,152,89,160,89,151,89,142,89,162,89,144,89,143,89,167,89,161,89,142,91,146,91,40,92,42,92,141,92,143,92,136,92,139,92,137,92,146,92,138,92,134,92,147,92,149,92,224,93,10,94,14,94,139,94,137,94,140,94,136,94,141,94,5,95,29,95,120,95,118,95,210,95,209,95,208,95,237,95,232,95,238,95,243,95,225,95,228,95,227,95,250,95,239,95,247,95,251,95,0,96,244,95,58,98,131,98,140,98,142,98,143,98,148,98,135,98,113,98,123,98,122,98,112,98,129,98,136,98,119,98,125,98,114,98,116,98,55,101,240,101,244,101,243,101,242,101,245,101,69,103,71,103,89,103,85,103,76,103,72,103,93,103,77,103,90,103,75,103,208,107,25,108,26,108,120,108,103,108,107,108,132,108,139,108,143,108,113,108,111,108,105,108,154,108,109,108,135,108,149,108,156,108,102,108,115,108,101,108,123,108,142,108,116,112,122,112,99,114,191,114,189,114,195,114,198,114,193,114,186,114,197,114,149,115,151,115,147,115,148,115,146,115,58,117,57,117,148,117,149,117,129,118,61,121,52,128,149,128,153,128,144,128,146,128,156,128,144,130,143,130,133,130,142,130,145,130,147,130,138,130,131,130,132,130,120,140,201,143,191,143,159,144,161,144,165,144,158,144,167,144,160,144,48,150,40,150,47,150,45,150,51,78,152,79,124,79,133,79,125,79,128,79,135,79,118,79,116,79,137,79,132,79,119,79,76,79,151,79,106,79,154,79,121,79,129,79,120,79,144,79,156,79,148,79,158,79,146,79,130,79,149,79,107,79,110,79,158,81,188,81,190,81,53,82,50,82,51,82,70,82,49,82,188,82,10,83,11,83,60,83,146,83,148,83,135,84,127,84,129,84,145,84,130,84,136,84,107,84,122,84,126,84,101,84,108,84,116,84,102,84,141,84,111,84,97,84,96,84,152,84,99,84,103,84,100,84,247,86,249,86,111,87,114,87,109,87,107,87,113,87,112,87,118,87,128,87,117,87,123,87,115,87,116,87,98,87,104,87,125,87,12,89,69,89,181,89,186,89,207,89,206,89,178,89,204,89,193,89,182,89,188,89,195,89,214,89,177,89,189,89,192,89,200,89,180,89,199,89,98,91,101,91,147,91,149,91,68,92,71,92,174,92,164,92,160,92,181,92,175,92,168,92,172,92,159,92,163,92,173,92,162,92,170,92,167,92,157,92,165,92,182,92,176,92,166,92,23,94,20,94,25,94,40,95,34,95,35,95,36,95,84,95,130,95,126,95,125,95,222,95,229,95,45,96,38,96,25,96,50,96,11,96,52,96,10,96,23,96,51,96,26,96,30,96,44,96,34,96,13,96,16,96,46,96,19,96,17,96,12,96,9,96,28,96,20,98,61,98,173,98,180,98,209,98,190,98,170,98,182,98,202,98,174,98,179,98,175,98,187,98,169,98,176,98,184,98,61,101,168,101,187,101,9,102,252,101,4,102,18,102,8,102,251,101,3,102,11,102,13,102,5,102,253,101,17,102,16,102,246,102,10,103,133,103,108,103,142,103,146,103,118,103,123,103,152,103,134,103,132,103,116,103,141,103,140,103,122,103,159,103,145,103,153,103,131,103,125,103,129,103,120,103,121,103,148,103,37,107,128,107,126,107,222,107,29,108,147,108,236,108,235,108,238,108,217,108,182,108,212,108,173,108,231,108,183,108,208,108,194,108,186,108,195,108,198,108,237,108,242,108,210,108,221,108,180,108,138,108,157,108,128,108,222,108,192,108,48,109,205,108,199,108,176,108,249,108,207,108,233,108,209,108,148,112,152,112,133,112,147,112,134,112,132,112,145,112,150,112,130,112,154,112,131,112,106,114,214,114,203,114,216,114,201,114,220,114,210,114,212,114,218,114,204,114,209,114,164,115,161,115,173,115,166,115,162,115,160,115,172,115,157,115,221,116,232,116,63,117,64,117,62,117,140,117,152,117,175,118,243,118,241,118,240,118,245,118,248,119,252,119,249,119,251,119,250,119,247,119,66,121,63,121,197,121,120,122,123,122,251,122,117,124,253,124,53,128,143,128,174,128,163,128,184,128,181,128,173,128,32,130,160,130,192,130,171,130,154,130,152,130,155,130,181,130,167,130,174,130,188,130,158,130,186,130,180,130,168,130,161,130,169,130,194,130,164,130,195,130,182,130,162,130,112,134,111,134,109,134,110,134,86,140,210,143,203,143,211,143,205,143,214,143,213,143,215,143,178,144,180,144,175,144,179,144,176,144,57,150,61,150,60,150,58,150,67,150,205,79,197,79,211,79,178,79,201,79,203,79,193,79,212,79,220,79,217,79,187,79,179,79,219,79,199,79,214,79,186,79,192,79,185,79,236,79,68,82,73,82,192,82,194,82,61,83,124,83,151,83,150,83,153,83,152,83,186,84,161,84,173,84,165,84,207,84,195,84,13,131,183,84,174,84,214,84,182,84,197,84,198,84,160,84,112,84,188,84,162,84,190,84,114,84,222,84,176,84,181,87,158,87,159,87,164,87,140,87,151,87,157,87,155,87,148,87,152,87,143,87,153,87,165,87,154,87,149,87,244,88,13,89,83,89,225,89,222,89,238,89,0,90,241,89,221,89,250,89,253,89,252,89,246,89,228,89,242,89,247,89,219,89,233,89,243,89,245,89,224,89,254,89,244,89,237,89,168,91,76,92,208,92,216,92,204,92,215,92,203,92,219,92,222,92,218,92,201,92,199,92,202,92,214,92,211,92,212,92,207,92,200,92,198,92,206,92,223,92,248,92,249,93,33,94,34,94,35,94,32,94,36,94,176,94,164,94,162,94,155,94,163,94,165,94,7,95,46,95,86,95,134,95,55,96,57,96,84,96,114,96,94,96,69,96,83,96,71,96,73,96,91,96,76,96,64,96,66,96,95,96,36,96,68,96,88,96,102,96,110,96,66,98,67,98,207,98,13,99,11,99,245,98,14,99,3,99,235,98,249,98,15,99,12,99,248,98,246,98,0,99,19,99,20,99,250,98,21,99,251,98,240,98,65,101,67,101,170,101,191,101,54,102,33,102,50,102,53,102,28,102,38,102,34,102,51,102,43,102,58,102,29,102,52,102,57,102,46,102,15,103,16,103,193,103,242,103,200,103,186,103,220,103,187,103,248,103,216,103,192,103,183,103,197,103,235,103,228,103,223,103,181,103,205,103,179,103,247,103,246,103,238,103,227,103,194,103,185,103,206,103,231,103,240,103,178,103,252,103,198,103,237,103,204,103,174,103,230,103,219,103,250,103,201,103,202,103,195,103,234,103,203,103,40,107,130,107,132,107,182,107,214,107,216,107,224,107,32,108,33,108,40,109,52,109,45,109,31,109,60,109,63,109,18,109,10,109,218,108,51,109,4,109,25,109,58,109,26,109,17,109,0,109,29,109,66,109,1,109,24,109,55,109,3,109,15,109,64,109,7,109,32,109,44,109,8,109,34,109,9,109,16,109,183,112,159,112,190,112,177,112,176,112,161,112,180,112,181,112,169,112,65,114,73,114,74,114,108,114,112,114,115,114,110,114,202,114,228,114,232,114,235,114,223,114,234,114,230,114,227,114,133,115,204,115,194,115,200,115,197,115,185,115,182,115,181,115,180,115,235,115,191,115,199,115,190,115,195,115,198,115,184,115,203,115,236,116,238,116,46,117,71,117,72,117,167,117,170,117,121,118,196,118,8,119,3,119,4,119,5,119,10,119,247,118,251,118,250,118,231,119,232,119,6,120,17,120,18,120,5,120,16,120,15,120,14,120,9,120,3,120,19,120,74,121,76,121,75,121,69,121,68,121,213,121,205,121,207,121,214,121,206,121,128,122,126,122,209,122,0,123,1,123,122,124,120,124,121,124,127,124,128,124,129,124,3,125,8,125,1,125,88,127,145,127,141,127,190,127,7,128,14,128,15,128,20,128,55,128,216,128,199,128,224,128,209,128,200,128,194,128,208,128,197,128,227,128,217,128,220,128,202,128,213,128,201,128,207,128,215,128,230,128,205,128,255,129,33,130,148,130,217,130,254,130,249,130,7,131,232,130,0,131,213,130,58,131,235,130,214,130,244,130,236,130,225,130,242,130,245,130,12,131,251,130,246,130,240,130,234,130,228,130,224,130,250,130,243,130,237,130,119,134,116,134,124,134,115,134,65,136,78,136,103,136,106,136,105,136,211,137,4,138,7,138,114,141,227,143,225,143,238,143,224,143,241,144,189,144,191,144,213,144,197,144,190,144,199,144,203,144,200,144,212,145,211,145,84,150,79,150,81,150,83,150,74,150,78,150,30,80,5,80,7,80,19,80,34,80,48,80,27,80,245,79,244,79,51,80,55,80,44,80,246,79,247,79,23,80,28,80,32,80,39,80,53,80,47,80,49,80,14,80,90,81,148,81,147,81,202,81,196,81,197,81,200,81,206,81,97,82,90,82,82,82,94,82,95,82,85,82,98,82,205,82,14,83,158,83,38,85,226,84,23,85,18,85,231,84,243,84,228,84,26,85,255,84,4,85,8,85,235,84,17,85,5,85,241,84,10,85,251,84,247,84,248,84,224,84,14,85,3,85,11,85,1,87,2,87,204,87,50,88,213,87,210,87,186,87,198,87,189,87,188,87,184,87,182,87,191,87,199,87,208,87,185,87,193,87,14,89,74,89,25,90,22,90,45,90,46,90,21,90,15,90,23,90,10,90,30,90,51,90,108,91,167,91,173,91,172,91,3,92,86,92,84,92,236,92,255,92,238,92,241,92,247,92,0,93,249,92,41,94,40,94,168,94,174,94,170,94,172,94,51,95,48,95,103,95,93,96,90,96,103,96,65,96,162,96,136,96,128,96,146,96,129,96,157,96,131,96,149,96,155,96,151,96,135,96,156,96,142,96,25,98,70,98,242,98,16,99,86,99,44,99,68,99,69,99,54,99,67,99,228,99,57,99,75,99,74,99,60,99,41,99,65,99,52,99,88,99,84,99,89,99,45,99,71,99,51,99,90,99,81,99,56,99,87,99,64,99,72,99,74,101,70,101,198,101,195,101,196,101,194,101,74,102,95,102,71,102,81,102,18,103,19,103,31,104,26,104,73,104,50,104,51,104,59,104,75,104,79,104,22,104,49,104,28,104,53,104,43,104,45,104,47,104,78,104,68,104,52,104,29,104,18,104,20,104,38,104,40,104,46,104,77,104,58,104,37,104,32,104,44,107,47,107,45,107,49,107,52,107,109,107,130,128,136,107,230,107,228,107,232,107,227,107,226,107,231,107,37,108,122,109,99,109,100,109,118,109,13,109,97,109,146,109,88,109,98,109,109,109,111,109,145,109,141,109,239,109,127,109,134,109,94,109,103,109,96,109,151,109,112,109,124,109,95,109,130,109,152,109,47,109,104,109,139,109,126,109,128,109,132,109,22,109,131,109,123,109,125,109,117,109,144,109,220,112,211,112,209,112,221,112,203,112,57,127,226,112,215,112,210,112,222,112,224,112,212,112,205,112,197,112,198,112,199,112,218,112,206,112,225,112,66,114,120,114,119,114,118,114,0,115,250,114,244,114,254,114,246,114,243,114,251,114,1,115,211,115,217,115,229,115,214,115,188,115,231,115,227,115,233,115,220,115,210,115,219,115,212,115,221,115,218,115,215,115,216,115,232,115,222,116,223,116,244,116,245,116,33,117,91,117,95,117,176,117,193,117,187,117,196,117,192,117,191,117,182,117,186,117,138,118,201,118,29,119,27,119,16,119,19,119,18,119,35,119,17,119,21,119,25,119,26,119,34,119,39,119,35,120,44,120,34,120,53,120,47,120,40,120,46,120,43,120,33,120,41,120,51,120,42,120,49,120,84,121,91,121,79,121,92,121,83,121,82,121,81,121,235,121,236,121,224,121,238,121,237,121,234,121,220,121,222,121,221,121,134,122,137,122,133,122,139,122,140,122,138,122,135,122,216,122,16,123,4,123,19,123,5,123,15,123,8,123,10,123,14,123,9,123,18,123,132,124,145,124,138,124,140,124,136,124,141,124,133,124,30,125,29,125,17,125,14,125,24,125,22,125,19,125,31,125,18,125,15,125,12,125,92,127,97,127,94,127,96,127,93,127,91,127,150,127,146,127,195,127,194,127,192,127,22,128,62,128,57,128,250,128,242,128,249,128,245,128,1,129,251,128,0,129,1,130,47,130,37,130,51,131,45,131,68,131,25,131,81,131,37,131,86,131,63,131,65,131,38,131,28,131,34,131,66,131,78,131,27,131,42,131,8,131,60,131,77,131,22,131,36,131,32,131,55,131,47,131,41,131,71,131,69,131,76,131,83,131,30,131,44,131,75,131,39,131,72,131,83,134,82,134,162,134,168,134,150,134,141,134,145,134,158,134,135,134,151,134,134,134,139,134,154,134,133,134,165,134,153,134,161,134,167,134,149,134,152,134,142,134,157,134,144,134,148,134,67,136,68,136,109,136,117,136,118,136,114,136,128,136,113,136,127,136,111,136,131,136,126,136,116,136,124,136,18,138,71,140,87,140,123,140,164,140,163,140,118,141,120,141,181,141,183,141,182,141,209,142,211,142,254,143,245,143,2,144,255,143,251,143,4,144,252,143,246,143,214,144,224,144,217,144,218,144,227,144,223,144,229,144,216,144,219,144,215,144,220,144,228,144,80,145,78,145,79,145,213,145,226,145,218,145,92,150,95,150,188,150,227,152,223,154,47,155,127,78,112,80,106,80,97,80,94,80,96,80,83,80,75,80,93,80,114,80,72,80,77,80,65,80,91,80,74,80,98,80,21,80,69,80,95,80,105,80,107,80,99,80,100,80,70,80,64,80,110,80,115,80,87,80,81,80,208,81,107,82,109,82,108,82,110,82,214,82,211,82,45,83,156,83,117,85,118,85,60,85,77,85,80,85,52,85,42,85,81,85,98,85,54,85,53,85,48,85,82,85,69,85,12,85,50,85,101,85,78,85,57,85,72,85,45,85,59,85,64,85,75,85,10,87,7,87,251,87,20,88,226,87,246,87,220,87,244,87,0,88,237,87,253,87,8,88,248,87,11,88,243,87,207,87,7,88,238,87,227,87,242,87,229,87,236,87,225,87,14,88,252,87,16,88,231,87,1,88,12,88,241,87,233,87,240,87,13,88,4,88,92,89,96,90,88,90,85,90,103,90,94,90,56,90,53,90,109,90,80,90,95,90,101,90,108,90,83,90,100,90,87,90,67,90,93,90,82,90,68,90,91,90,72,90,142,90,62,90,77,90,57,90,76,90,112,90,105,90,71,90,81,90,86,90,66,90,92,90,114,91,110,91,193,91,192,91,89,92,30,93,11,93,29,93,26,93,32,93,12,93,40,93,13,93,38,93,37,93,15,93,48,93,18,93,35,93,31,93,46,93,62,94,52,94,177,94,180,94,185,94,178,94,179,94,54,95,56,95,155,95,150,95,159,95,138,96,144,96,134,96,190,96,176,96,186,96,211,96,212,96,207,96,228,96,217,96,221,96,200,96,177,96,219,96,183,96,202,96,191,96,195,96,205,96,192,96,50,99,101,99,138,99,130,99,125,99,189,99,158,99,173,99,157,99,151,99,171,99,142,99,111,99,135,99,144,99,110,99,175,99,117,99,156,99,109,99,174,99,124,99,164,99,59,99,159,99,120,99,133,99,129,99,145,99,141,99,112,99,83,101,205,101,101,102,97,102,91,102,89,102,92,102,98,102,24,103,121,104,135,104,144,104,156,104,109,104,110,104,174,104,171,104,86,105,111,104,163,104,172,104,169,104,117,104,116,104,178,104,143,104,119,104,146,104,124,104,107,104,114,104,170,104,128,104,113,104,126,104,155,104,150,104,139,104,160,104,137,104,164,104,120,104,123,104,145,104,140,104,138,104,125,104,54,107,51,107,55,107,56,107,145,107,143,107,141,107,142,107,140,107,42,108,192,109,171,109,180,109,179,109,116,110,172,109,233,109,226,109,183,109,246,109,212,109,0,110,200,109,224,109,223,109,214,109,190,109,229,109,220,109,221,109,219,109,244,109,202,109,189,109,237,109,240,109,186,109,213,109,194,109,207,109,201,109,208,109,242,109,211,109,253,109,215,109,205,109,227,109,187,109,250,112,13,113,247,112,23,113,244,112,12,113,240,112,4,113,243,112,16,113,252,112,255,112,6,113,19,113,0,113,248,112,246,112,11,113,2,113,14,113,126,114,123,114,124,114,127,114,29,115,23,115,7,115,17,115,24,115,10,115,8,115,255,114,15,115,30,115,136,115,246,115,248,115,245,115,4,116,1,116,253,115,7,116,0,116,250,115,252,115,255,115,12,116,11,116,244,115,8,116,100,117,99,117,206,117,210,117,207,117,203,117,204,117,209,117,208,117,143,118,137,118,211,118,57,119,47,119,45,119,49,119,50,119,52,119,51,119,61,119,37,119,59,119,53,119,72,120,82,120,73,120,77,120,74,120,76,120,38,120,69,120,80,120,100,121,103,121,105,121,106,121,99,121,107,121,97,121,187,121,250,121,248,121,246,121,247,121,143,122,148,122,144,122,53,123,71,123,52,123,37,123,48,123,34,123,36,123,51,123,24,123,42,123,29,123,49,123,43,123,45,123,47,123,50,123,56,123,26,123,35,123,148,124,152,124,150,124,163,124,53,125,61,125,56,125,54,125,58,125,69,125,44,125,41,125,65,125,71,125,62,125,63,125,74,125,59,125,40,125,99,127,149,127,156,127,157,127,155,127,202,127,203,127,205,127,208,127,209,127,199,127,207,127,201,127,31,128,30,128,27,128,71,128,67,128,72,128,24,129,37,129,25,129,27,129,45,129,31,129,44,129,30,129,33,129,21,129,39,129,29,129,34,129,17,130,56,130,51,130,58,130,52,130,50,130,116,130,144,131,163,131,168,131,141,131,122,131,115,131,164,131,116,131,143,131,129,131,149,131,153,131,117,131,148,131,169,131,125,131,131,131,140,131,157,131,155,131,170,131,139,131,126,131,165,131,175,131,136,131,151,131,176,131,127,131,166,131,135,131,174,131,118,131,154,131,89,134,86,134,191,134,183,134,194,134,193,134,197,134,186,134,176,134,200,134,185,134,179,134,184,134,204,134,180,134,187,134,188,134,195,134,189,134,190,134,82,136,137,136,149,136,168,136,162,136,170,136,154,136,145,136,161,136,159,136,152,136,167,136,153,136,155,136,151,136,164,136,172,136,140,136,147,136,142,136,130,137,214,137,217,137,213,137,48,138,39,138,44,138,30,138,57,140,59,140,92,140,93,140,125,140,165,140,125,141,123,141,121,141,188,141,194,141,185,141,191,141,193,141,216,142,222,142,221,142,220,142,215,142,224,142,225,142,36,144,11,144,17,144,28,144,12,144,33,144,239,144,234,144,240,144,244,144,242,144,243,144,212,144,235,144,236,144,233,144,86,145,88,145,90,145,83,145,85,145,236,145,244,145,241,145,243,145,248,145,228,145,249,145,234,145,235,145,247,145,232,145,238,145,122,149,134,149,136,149,124,150,109,150,107,150,113,150,111,150,191,150,106,151,4,152,229,152,151,153,155,80,149,80,148,80,158,80,139,80,163,80,131,80,140,80,142,80,157,80,104,80,156,80,146,80,130,80,135,80,95,81,212,81,18,83,17,83,164,83,167,83,145,85,168,85,165,85,173,85,119,85,69,86,162,85,147,85,136,85,143,85,181,85,129,85,163,85,146,85,164,85,125,85,140,85,166,85,127,85,149,85,161,85,142,85,12,87,41,88,55,88,25,88,30,88,39,88,35,88,40,88,245,87,72,88,37,88,28,88,27,88,51,88,63,88,54,88,46,88,57,88,56,88,45,88,44,88,59,88,97,89,175,90,148,90,159,90,122,90,162,90,158,90,120,90,166,90,124,90,165,90,172,90,149,90,174,90,55,90,132,90,138,90,151,90,131,90,139,90,169,90,123,90,125,90,140,90,156,90,143,90,147,90,157,90,234,91,205,91,203,91,212,91,209,91,202,91,206,91,12,92,48,92,55,93,67,93,107,93,65,93,75,93,63,93,53,93,81,93,78,93,85,93,51,93,58,93,82,93,61,93,49,93,89,93,66,93,57,93,73,93,56,93,60,93,50,93,54,93,64,93,69,93,68,94,65,94,88,95,166,95,165,95,171,95,201,96,185,96,204,96,226,96,206,96,196,96,20,97,242,96,10,97,22,97,5,97,245,96,19,97,248,96,252,96,254,96,193,96,3,97,24,97,29,97,16,97,255,96,4,97,11,97,74,98,148,99,177,99,176,99,206,99,229,99,232,99,239,99,195,99,157,100,243,99,202,99,224,99,246,99,213,99,242,99,245,99,97,100,223,99,190,99,221,99,220,99,196,99,216,99,211,99,194,99,199,99,204,99,203,99,200,99,240,99,215,99,217,99,50,101,103,101,106,101,100,101,92,101,104,101,101,101,140,101,157,101,158,101,174,101,208,101,210,101,124,102,108,102,123,102,128,102,113,102,121,102,106,102,114,102,1,103,12,105,211,104,4,105,220,104,42,105,236,104,234,104,241,104,15,105,214,104,247,104,235,104,228,104,246,104,19,105,16,105,243,104,225,104,7,105,204,104,8,105,112,105,180,104,17,105,239,104,198,104,20,105,248,104,208,104,253,104,252,104,232,104,11,105,10,105,23,105,206,104,200,104,221,104,222,104,230,104,244,104,209,104,6,105,212,104,233,104,21,105,37,105,199,104,57,107,59,107,63,107,60,107,148,107,151,107,153,107,149,107,189,107,240,107,242,107,243,107,48,108,252,109,70,110,71,110,31,110,73,110,136,110,60,110,61,110,69,110,98,110,43,110,63,110,65,110,93,110,115,110,28,110,51,110,75,110,64,110,81,110,59,110,3,110,46,110,94,110,104,110,92,110,97,110,49,110,40,110,96,110,113,110,107,110,57,110,34,110,48,110,83,110,101,110,39,110,120,110,100,110,119,110,85,110,121,110,82,110,102,110,53,110,54,110,90,110,32,113,30,113,47,113,251,112,46,113,49,113,35,113,37,113,34,113,50,113,31,113,40,113,58,113,27,113,75,114,90,114,136,114,137,114,134,114,133,114,139,114,18,115,11,115,48,115,34,115,49,115,51,115,39,115,50,115,45,115,38,115,35,115,53,115,12,115,46,116,44,116,48,116,43,116,22,116,26,116,33,116,45,116,49,116,36,116,35,116,29,116,41,116,32,116,50,116,251,116,47,117,111,117,108,117,231,117,218,117,225,117,230,117,221,117,223,117,228,117,215,117,149,118,146,118,218,118,70,119,71,119,68,119,77,119,69,119,74,119,78,119,75,119,76,119,222,119,236,119,96,120,100,120,101,120,92,120,109,120,113,120,106,120,110,120,112,120,105,120,104,120,94,120,98,120,116,121,115,121,114,121,112,121,2,122,10,122,3,122,12,122,4,122,153,122,230,122,228,122,74,123,59,123,68,123,72,123,76,123,78,123,64,123,88,123,69,123,162,124,158,124,168,124,161,124,88,125,111,125,99,125,83,125,86,125,103,125,106,125,79,125,109,125,92,125,107,125,82,125,84,125,105,125,81,125,95,125,78,125,62,127,63,127,101,127,102,127,162,127,160,127,161,127,215,127,81,128,79,128,80,128,254,128,212,128,67,129,74,129,82,129,79,129,71,129,61,129,77,129,58,129,230,129,238,129,247,129,248,129,249,129,4,130,60,130,61,130,63,130,117,130,59,131,207,131,249,131,35,132,192,131,232,131,18,132,231,131,228,131,252,131,246,131,16,132,198,131,200,131,235,131,227,131,191,131,1,132,221,131,229,131,216,131,255,131,225,131,203,131,206,131,214,131,245,131,201,131,9,132,15,132,222,131,17,132,6,132,194,131,243,131,213,131,250,131,199,131,209,131,234,131,19,132,195,131,236,131,238,131,196,131,251,131,215,131,226,131,27,132,219,131,254,131,216,134,226,134,230,134,211,134,227,134,218,134,234,134,221,134,235,134,220,134,236,134,233,134,215,134,232,134,209,134,72,136,86,136,85,136,186,136,215,136,185,136,184,136,192,136,190,136,182,136,188,136,183,136,189,136,178,136,1,137,201,136,149,137,152,137,151,137,221,137,218,137,219,137,78,138,77,138,57,138,89,138,64,138,87,138,88,138,68,138,69,138,82,138,72,138,81,138,74,138,76,138,79,138,95,140,129,140,128,140,186,140,190,140,176,140,185,140,181,140,132,141,128,141,137,141,216,141,211,141,205,141,199,141,214,141,220,141,207,141,213,141,217,141,200,141,215,141,197,141,239,142,247,142,250,142,249,142,230,142,238,142,229,142,245,142,231,142,232,142,246,142,235,142,241,142,236,142,244,142,233,142,45,144,52,144,47,144,6,145,44,145,4,145,255,144,252,144,8,145,249,144,251,144,1,145,0,145,7,145,5,145,3,145,97,145,100,145,95,145,98,145,96,145,1,146,10,146,37,146,3,146,26,146,38,146,15,146,12,146,0,146,18,146,255,145,253,145,6,146,4,146,39,146,2,146,28,146,36,146,25,146,23,146,5,146,22,146,123,149,141,149,140,149,144,149,135,150,126,150,136,150,137,150,131,150,128,150,194,150,200,150,195,150,241,150,240,150,108,151,112,151,110,151,7,152,169,152,235,152,230,156,249,158,131,78,132,78,182,78,189,80,191,80,198,80,174,80,196,80,202,80,180,80,200,80,194,80,176,80,193,80,186,80,177,80,203,80,201,80,182,80,184,80,215,81,122,82,120,82,123,82,124,82,195,85,219,85,204,85,208,85,203,85,202,85,221,85,192,85,212,85,196,85,233,85,191,85,210,85,141,85,207,85,213,85,226,85,214,85,200,85,242,85,205,85,217,85,194,85,20,87,83,88,104,88,100,88,79,88,77,88,73,88,111,88,85,88,78,88,93,88,89,88,101,88,91,88,61,88,99,88,113,88,252,88,199,90,196,90,203,90,186,90,184,90,177,90,181,90,176,90,191,90,200,90,187,90,198,90,183,90,192,90,202,90,180,90,182,90,205,90,185,90,144,90,214,91,216,91,217,91,31,92,51,92,113,93,99,93,74,93,101,93,114,93,108,93,94,93,104,93,103,93,98,93,240,93,79,94,78,94,74,94,77,94,75,94,197,94,204,94,198,94,203,94,199,94,64,95,175,95,173,95,247,96,73,97,74,97,43,97,69,97,54,97,50,97,46,97,70,97,47,97,79,97,41,97,64,97,32,98,104,145,35,98,37,98,36,98,197,99,241,99,235,99,16,100,18,100,9,100,32,100,36,100,51,100,67,100,31,100,21,100,24,100,57,100,55,100,34,100,35,100,12,100,38,100,48,100,40,100,65,100,53,100,47,100,10,100,26,100,64,100,37,100,39,100,11,100,231,99,27,100,46,100,33,100,14,100,111,101,146,101,211,101,134,102,140,102,149,102,144,102,139,102,138,102,153,102,148,102,120,102,32,103,102,105,95,105,56,105,78,105,98,105,113,105,63,105,69,105,106,105,57,105,66,105,87,105,89,105,122,105,72,105,73,105,53,105,108,105,51,105,61,105,101,105,240,104,120,105,52,105,105,105,64,105,111,105,68,105,118,105,88,105,65,105,116,105,76,105,59,105,75,105,55,105,92,105,79,105,81,105,50,105,82,105,47,105,123,105,60,105,70,107,69,107,67,107,66,107,72,107,65,107,155,107,13,250,251,107,252,107,249,107,247,107,248,107,155,110,214,110,200,110,143,110,192,110,159,110,147,110,148,110,160,110,177,110,185,110,198,110,210,110,189,110,193,110,158,110,201,110,183,110,176,110,205,110,166,110,207,110,178,110,190,110,195,110,220,110,216,110,153,110,146,110,142,110,141,110,164,110,161,110,191,110,179,110,208,110,202,110,151,110,174,110,163,110,71,113,84,113,82,113,99,113,96,113,65,113,93,113,98,113,114,113,120,113,106,113,97,113,66,113,88,113,67,113,75,113,112,113,95,113,80,113,83,113,68,113,77,113,90,113,79,114,141,114,140,114,145,114,144,114,142,114,60,115,66,115,59,115,58,115,64,115,74,115,73,115,68,116,74,116,75,116,82,116,81,116,87,116,64,116,79,116,80,116,78,116,66,116,70,116,77,116,84,116,225,116,255,116,254,116,253,116,29,117,121,117,119,117,131,105,239,117,15,118,3,118,247,117,254,117,252,117,249,117,248,117,16,118,251,117,246,117,237,117,245,117,253,117,153,118,181,118,221,118,85,119,95,119,96,119,82,119,86,119,90,119,105,119,103,119,84,119,89,119,109,119,224,119,135,120,154,120,148,120,143,120,132,120,149,120,133,120,134,120,161,120,131,120,121,120,153,120,128,120,150,120,123,120,124,121,130,121,125,121,121,121,17,122,24,122,25,122,18,122,23,122,21,122,34,122,19,122,27,122,16,122,163,122,162,122,158,122,235,122,102,123,100,123,109,123,116,123,105,123,114,123,101,123,115,123,113,123,112,123,97,123,120,123,118,123,99,123,178,124,180,124,175,124,136,125,134,125,128,125,141,125,127,125,133,125,122,125,142,125,123,125,131,125,124,125,140,125,148,125,132,125,125,125,146,125,109,127,107,127,103,127,104,127,108,127,166,127,165,127,167,127,219,127,220,127,33,128,100,129,96,129,119,129,92,129,105,129,91,129,98,129,114,129,33,103,94,129,118,129,103,129,111,129,68,129,97,129,29,130,73,130,68,130,64,130,66,130,69,130,241,132,63,132,86,132,118,132,121,132,143,132,141,132,101,132,81,132,64,132,134,132,103,132,48,132,77,132,125,132,90,132,89,132,116,132,115,132,93,132,7,133,94,132,55,132,58,132,52,132,122,132,67,132,120,132,50,132,69,132,41,132,217,131,75,132,47,132,66,132,45,132,95,132,112,132,57,132,78,132,76,132,82,132,111,132,197,132,142,132,59,132,71,132,54,132,51,132,104,132,126,132,68,132,43,132,96,132,84,132,110,132,80,132,11,135,4,135,247,134,12,135,250,134,214,134,245,134,77,135,248,134,14,135,9,135,1,135,246,134,13,135,5,135,214,136,203,136,205,136,206,136,222,136,219,136,218,136,204,136,208,136,133,137,155,137,223,137,229,137,228,137,225,137,224,137,226,137,220,137,230,137,118,138,134,138,127,138,97,138,63,138,119,138,130,138,132,138,117,138,131,138,129,138,116,138,122,138,60,140,75,140,74,140,101,140,100,140,102,140,134,140,132,140,133,140,204,140,104,141,105,141,145,141,140,141,142,141,143,141,141,141,147,141,148,141,144,141,146,141,240,141,224,141,236,141,241,141,238,141,208,141,233,141,227,141,226,141,231,141,242,141,235,141,244,141,6,143,255,142,1,143,0,143,5,143,7,143,8,143,2,143,11,143,82,144,63,144,68,144,73,144,61,144,16,145,13,145,15,145,17,145,22,145,20,145,11,145,14,145,110,145,111,145,72,146,82,146,48,146,58,146,102,146,51,146,101,146,94,146,131,146,46,146,74,146,70,146,109,146,108,146,79,146,96,146,103,146,111,146,54,146,97,146,112,146,49,146,84,146,99,146,80,146,114,146,78,146,83,146,76,146,86,146,50,146,159,149,156,149,158,149,155,149,146,150,147,150,145,150,151,150,206,150,250,150,253,150,248,150,245,150,115,151,119,151,120,151,114,151,15,152,13,152,14,152,172,152,246,152,249,152,175,153,178,153,176,153,181,153,173,154,171,154,91,155,234,156,237,156,231,156,128,158,253,158,230,80,212,80,215,80,232,80,243,80,219,80,234,80,221,80,228,80,211,80,236,80,240,80,239,80,227,80,224,80,216,81,128,82,129,82,233,82,235,82,48,83,172,83,39,86,21,86,12,86,18,86,252,85,15,86,28,86,1,86,19,86,2,86,250,85,29,86,4,86,255,85,249,85,137,88,124,88,144,88,152,88,134,88,129,88,127,88,116,88,139,88,122,88,135,88,145,88,142,88,118,88,130,88,136,88,123,88,148,88,143,88,254,88,107,89,220,90,238,90,229,90,213,90,234,90,218,90,237,90,235,90,243,90,226,90,224,90,219,90,236,90,222,90,221,90,217,90,232,90,223,90,119,91,224,91,227,91,99,92,130,93,128,93,125,93,134,93,122,93,129,93,119,93,138,93,137,93,136,93,126,93,124,93,141,93,121,93,127,93,88,94,89,94,83,94,216,94,209,94,215,94,206,94,220,94,213,94,217,94,210,94,212,94,68,95,67,95,111,95,182,95,44,97,40,97,65,97,94,97,113,97,115,97,82,97,83,97,114,97,108,97,128,97,116,97,84,97,122,97,91,97,101,97,59,97,106,97,97,97,86,97,41,98,39,98,43,98,43,100,77,100,91,100,93,100,116,100,118,100,114,100,115,100,125,100,117,100,102,100,166,100,78,100,130,100,94,100,92,100,75,100,83,100,96,100,80,100,127,100,63,100,108,100,107,100,89,100,101,100,119,100,115,101,160,101,161,102,160,102,159,102,5,103,4,103,34,103,177,105,182,105,201,105,160,105,206,105,150,105,176,105,172,105,188,105,145,105,153,105,142,105,167,105,141,105,169,105,190,105,175,105,191,105,196,105,189,105,164,105,212,105,185,105,202,105,154,105,207,105,179,105,147,105,170,105,161,105,158,105,217,105,151,105,144,105,194,105,181,105,165,105,198,105,74,107,77,107,75,107,158,107,159,107,160,107,195,107,196,107,254,107,206,110,245,110,241,110,3,111,37,111,248,110,55,111,251,110,46,111,9,111,78,111,25,111,26,111,39,111,24,111,59,111,18,111,237,110,10,111,54,111,115,111,249,110,238,110,45,111,64,111,48,111,60,111,53,111,235,110,7,111,14,111,67,111,5,111,253,110,246,110,57,111,28,111,252,110,58,111,31,111,13,111,30,111,8,111,33,111,135,113,144,113,137,113,128,113,133,113,130,113,143,113,123,113,134,113,129,113,151,113,68,114,83,114,151,114,149,114,147,114,67,115,77,115,81,115,76,115,98,116,115,116,113,116,117,116,114,116,103,116,110,116,0,117,2,117,3,117,125,117,144,117,22,118,8,118,12,118,21,118,17,118,10,118,20,118,184,118,129,119,124,119,133,119,130,119,110,119,128,119,111,119,126,119,131,119,178,120,170,120,180,120,173,120,168,120,126,120,171,120,158,120,165,120,160,120,172,120,162,120,164,120,152,121,138,121,139,121,150,121,149,121,148,121,147,121,151,121,136,121,146,121,144,121,43,122,74,122,48,122,47,122,40,122,38,122,168,122,171,122,172,122,238,122,136,123,156,123,138,123,145,123,144,123,150,123,141,123,140,123,155,123,142,123,133,123,152,123,132,82,153,123,164,123,130,123,187,124,191,124,188,124,186,124,167,125,183,125,194,125,163,125,170,125,193,125,192,125,197,125,157,125,206,125,196,125,198,125,203,125,204,125,175,125,185,125,150,125,188,125,159,125,166,125,174,125,169,125,161,125,201,125,115,127,226,127,227,127,229,127,222,127,36,128,93,128,92,128,137,129,134,129,131,129,135,129,141,129,140,129,139,129,21,130,151,132,164,132,161,132,159,132,186,132,206,132,194,132,172,132,174,132,171,132,185,132,180,132,193,132,205,132,170,132,154,132,177,132,208,132,157,132,167,132,187,132,162,132,148,132,199,132,204,132,155,132,169,132,175,132,168,132,214,132,152,132,182,132,207,132,160,132,215,132,212,132,210,132,219,132,176,132,145,132,97,134,51,135,35,135,40,135,107,135,64,135],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+292068),
	allocate([46,135,30,135,33,135,25,135,27,135,67,135,44,135,65,135,62,135,70,135,32,135,50,135,42,135,45,135,60,135,18,135,58,135,49,135,53,135,66,135,38,135,39,135,56,135,36,135,26,135,48,135,17,135,247,136,231,136,241,136,242,136,250,136,254,136,238,136,252,136,246,136,251,136,240,136,236,136,235,136,157,137,161,137,159,137,158,137,233,137,235,137,232,137,171,138,153,138,139,138,146,138,143,138,150,138,61,140,104,140,105,140,213,140,207,140,215,140,150,141,9,142,2,142,255,141,13,142,253,141,10,142,3,142,7,142,6,142,5,142,254,141,0,142,4,142,16,143,17,143,14,143,13,143,35,145,28,145,32,145,34,145,31,145,29,145,26,145,36,145,33,145,27,145,122,145,114,145,121,145,115,145,165,146,164,146,118,146,155,146,122,146,160,146,148,146,170,146,141,146,166,146,154,146,171,146,121,146,151,146,127,146,163,146,238,146,142,146,130,146,149,146,162,146,125,146,136,146,161,146,138,146,134,146,140,146,153,146,167,146,126,146,135,146,169,146,157,146,139,146,45,146,158,150,161,150,255,150,88,151,125,151,122,151,126,151,131,151,128,151,130,151,123,151,132,151,129,151,127,151,206,151,205,151,22,152,173,152,174,152,2,153,0,153,7,153,157,153,156,153,195,153,185,153,187,153,186,153,194,153,189,153,199,153,177,154,227,154,231,154,62,155,63,155,96,155,97,155,95,155,241,156,242,156,245,156,167,158,255,80,3,81,48,81,248,80,6,81,7,81,246,80,254,80,11,81,12,81,253,80,10,81,139,82,140,82,241,82,239,82,72,86,66,86,76,86,53,86,65,86,74,86,73,86,70,86,88,86,90,86,64,86,51,86,61,86,44,86,62,86,56,86,42,86,58,86,26,87,171,88,157,88,177,88,160,88,163,88,175,88,172,88,165,88,161,88,255,88,255,90,244,90,253,90,247,90,246,90,3,91,248,90,2,91,249,90,1,91,7,91,5,91,15,91,103,92,153,93,151,93,159,93,146,93,162,93,147,93,149,93,160,93,156,93,161,93,154,93,158,93,105,94,93,94,96,94,92,94,243,125,219,94,222,94,225,94,73,95,178,95,139,97,131,97,121,97,177,97,176,97,162,97,137,97,155,97,147,97,175,97,173,97,159,97,146,97,170,97,161,97,141,97,102,97,179,97,45,98,110,100,112,100,150,100,160,100,133,100,151,100,156,100,143,100,139,100,138,100,140,100,163,100,159,100,104,100,177,100,152,100,118,101,122,101,121,101,123,101,178,101,179,101,181,102,176,102,169,102,178,102,183,102,170,102,175,102,0,106,6,106,23,106,229,105,248,105,21,106,241,105,228,105,32,106,255,105,236,105,226,105,27,106,29,106,254,105,39,106,242,105,238,105,20,106,247,105,231,105,64,106,8,106,230,105,251,105,13,106,252,105,235,105,9,106,4,106,24,106,37,106,15,106,246,105,38,106,7,106,244,105,22,106,81,107,165,107,163,107,162,107,166,107,1,108,0,108,255,107,2,108,65,111,38,111,126,111,135,111,198,111,146,111,141,111,137,111,140,111,98,111,79,111,133,111,90,111,150,111,118,111,108,111,130,111,85,111,114,111,82,111,80,111,87,111,148,111,147,111,93,111,0,111,97,111,107,111,125,111,103,111,144,111,83,111,139,111,105,111,127,111,149,111,99,111,119,111,106,111,123,111,178,113,175,113,155,113,176,113,160,113,154,113,169,113,181,113,157,113,165,113,158,113,164,113,161,113,170,113,156,113,167,113,179,113,152,114,154,114,88,115,82,115,94,115,95,115,96,115,93,115,91,115,97,115,90,115,89,115,98,115,135,116,137,116,138,116,134,116,129,116,125,116,133,116,136,116,124,116,121,116,8,117,7,117,126,117,37,118,30,118,25,118,29,118,28,118,35,118,26,118,40,118,27,118,156,118,157,118,158,118,155,118,141,119,143,119,137,119,136,119,205,120,187,120,207,120,204,120,209,120,206,120,212,120,200,120,195,120,196,120,201,120,154,121,161,121,160,121,156,121,162,121,155,121,118,107,57,122,178,122,180,122,179,122,183,123,203,123,190,123,172,123,206,123,175,123,185,123,202,123,181,123,197,124,200,124,204,124,203,124,247,125,219,125,234,125,231,125,215,125,225,125,3,126,250,125,230,125,246,125,241,125,240,125,238,125,223,125,118,127,172,127,176,127,173,127,237,127,235,127,234,127,236,127,230,127,232,127,100,128,103,128,163,129,159,129,158,129,149,129,162,129,153,129,151,129,22,130,79,130,83,130,82,130,80,130,78,130,81,130,36,133,59,133,15,133,0,133,41,133,14,133,9,133,13,133,31,133,10,133,39,133,28,133,251,132,43,133,250,132,8,133,12,133,244,132,42,133,242,132,21,133,247,132,235,132,243,132,252,132,18,133,234,132,233,132,22,133,254,132,40,133,29,133,46,133,2,133,253,132,30,133,246,132,49,133,38,133,231,132,232,132,240,132,239,132,249,132,24,133,32,133,48,133,11,133,25,133,47,133,98,134,86,135,99,135,100,135,119,135,225,135,115,135,88,135,84,135,91,135,82,135,97,135,90,135,81,135,94,135,109,135,106,135,80,135,78,135,95,135,93,135,111,135,108,135,122,135,110,135,92,135,101,135,79,135,123,135,117,135,98,135,103,135,105,135,90,136,5,137,12,137,20,137,11,137,23,137,24,137,25,137,6,137,22,137,17,137,14,137,9,137,162,137,164,137,163,137,237,137,240,137,236,137,207,138,198,138,184,138,211,138,209,138,212,138,213,138,187,138,215,138,190,138,192,138,197,138,216,138,195,138,186,138,189,138,217,138,62,140,77,140,143,140,229,140,223,140,217,140,232,140,218,140,221,140,231,140,160,141,156,141,161,141,155,141,32,142,35,142,37,142,36,142,46,142,21,142,27,142,22,142,17,142,25,142,38,142,39,142,20,142,18,142,24,142,19,142,28,142,23,142,26,142,44,143,36,143,24,143,26,143,32,143,35,143,22,143,23,143,115,144,112,144,111,144,103,144,107,144,47,145,43,145,41,145,42,145,50,145,38,145,46,145,133,145,134,145,138,145,129,145,130,145,132,145,128,145,208,146,195,146,196,146,192,146,217,146,182,146,207,146,241,146,223,146,216,146,233,146,215,146,221,146,204,146,239,146,194,146,232,146,202,146,200,146,206,146,230,146,205,146,213,146,201,146,224,146,222,146,231,146,209,146,211,146,181,146,225,146,198,146,180,146,124,149,172,149,171,149,174,149,176,149,164,150,162,150,211,150,5,151,8,151,2,151,90,151,138,151,142,151,136,151,208,151,207,151,30,152,29,152,38,152,41,152,40,152,32,152,27,152,39,152,178,152,8,153,250,152,17,153,20,153,22,153,23,153,21,153,220,153,205,153,207,153,211,153,212,153,206,153,201,153,214,153,216,153,203,153,215,153,204,153,179,154,236,154,235,154,243,154,242,154,241,154,70,155,67,155,103,155,116,155,113,155,102,155,118,155,117,155,112,155,104,155,100,155,108,155,252,156,250,156,253,156,255,156,247,156,7,157,0,157,249,156,251,156,8,157,5,157,4,157,131,158,211,158,15,159,16,159,28,81,19,81,23,81,26,81,17,81,222,81,52,83,225,83,112,86,96,86,110,86,115,86,102,86,99,86,109,86,114,86,94,86,119,86,28,87,27,87,200,88,189,88,201,88,191,88,186,88,194,88,188,88,198,88,23,91,25,91,27,91,33,91,20,91,19,91,16,91,22,91,40,91,26,91,32,91,30,91,239,91,172,93,177,93,169,93,167,93,181,93,176,93,174,93,170,93,168,93,178,93,173,93,175,93,180,93,103,94,104,94,102,94,111,94,233,94,231,94,230,94,232,94,229,94,75,95,188,95,157,97,168,97,150,97,197,97,180,97,198,97,193,97,204,97,186,97,191,97,184,97,140,97,215,100,214,100,208,100,207,100,201,100,189,100,137,100,195,100,219,100,243,100,217,100,51,101,127,101,124,101,162,101,200,102,190,102,192,102,202,102,203,102,207,102,189,102,187,102,186,102,204,102,35,103,52,106,102,106,73,106,103,106,50,106,104,106,62,106,93,106,109,106,118,106,91,106,81,106,40,106,90,106,59,106,63,106,65,106,106,106,100,106,80,106,79,106,84,106,111,106,105,106,96,106,60,106,94,106,86,106,85,106,77,106,78,106,70,106,85,107,84,107,86,107,167,107,170,107,171,107,200,107,199,107,4,108,3,108,6,108,173,111,203,111,163,111,199,111,188,111,206,111,200,111,94,111,196,111,189,111,158,111,202,111,168,111,4,112,165,111,174,111,186,111,172,111,170,111,207,111,191,111,184,111,162,111,201,111,171,111,205,111,175,111,178,111,176,111,197,113,194,113,191,113,184,113,214,113,192,113,193,113,203,113,212,113,202,113,199,113,207,113,189,113,216,113,188,113,198,113,218,113,219,113,157,114,158,114,105,115,102,115,103,115,108,115,101,115,107,115,106,115,127,116,154,116,160,116,148,116,146,116,149,116,161,116,11,117,128,117,47,118,45,118,49,118,61,118,51,118,60,118,53,118,50,118,48,118,187,118,230,118,154,119,157,119,161,119,156,119,155,119,162,119,163,119,149,119,153,119,151,119,221,120,233,120,229,120,234,120,222,120,227,120,219,120,225,120,226,120,237,120,223,120,224,120,164,121,68,122,72,122,71,122,182,122,184,122,181,122,177,122,183,122,222,123,227,123,231,123,221,123,213,123,229,123,218,123,232,123,249,123,212,123,234,123,226,123,220,123,235,123,216,123,223,123,210,124,212,124,215,124,208,124,209,124,18,126,33,126,23,126,12,126,31,126,32,126,19,126,14,126,28,126,21,126,26,126,34,126,11,126,15,126,22,126,13,126,20,126,37,126,36,126,67,127,123,127,124,127,122,127,177,127,239,127,42,128,41,128,108,128,177,129,166,129,174,129,185,129,181,129,171,129,176,129,172,129,180,129,178,129,183,129,167,129,242,129,85,130,86,130,87,130,86,133,69,133,107,133,77,133,83,133,97,133,88,133,64,133,70,133,100,133,65,133,98,133,68,133,81,133,71,133,99,133,62,133,91,133,113,133,78,133,110,133,117,133,85,133,103,133,96,133,140,133,102,133,93,133,84,133,101,133,108,133,99,134,101,134,100,134,155,135,143,135,151,135,147,135,146,135,136,135,129,135,150,135,152,135,121,135,135,135,163,135,133,135,144,135,145,135,157,135,132,135,148,135,156,135,154,135,137,135,30,137,38,137,48,137,45,137,46,137,39,137,49,137,34,137,41,137,35,137,47,137,44,137,31,137,241,137,224,138,226,138,242,138,244,138,245,138,221,138,20,139,228,138,223,138,240,138,200,138,222,138,225,138,232,138,255,138,239,138,251,138,145,140,146,140,144,140,245,140,238,140,241,140,240,140,243,140,108,141,110,141,165,141,167,141,51,142,62,142,56,142,64,142,69,142,54,142,60,142,61,142,65,142,48,142,63,142,189,142,54,143,46,143,53,143,50,143,57,143,55,143,52,143,118,144,121,144,123,144,134,144,250,144,51,145,53,145,54,145,147,145,144,145,145,145,141,145,143,145,39,147,30,147,8,147,31,147,6,147,15,147,122,147,56,147,60,147,27,147,35,147,18,147,1,147,70,147,45,147,14,147,13,147,203,146,29,147,250,146,37,147,19,147,249,146,247,146,52,147,2,147,36,147,255,146,41,147,57,147,53,147,42,147,20,147,12,147,11,147,254,146,9,147,0,147,251,146,22,147,188,149,205,149,190,149,185,149,186,149,182,149,191,149,181,149,189,149,169,150,212,150,11,151,18,151,16,151,153,151,151,151,148,151,240,151,248,151,53,152,47,152,50,152,36,153,31,153,39,153,41,153,158,153,238,153,236,153,229,153,228,153,240,153,227,153,234,153,233,153,231,153,185,154,191,154,180,154,187,154,246,154,250,154,249,154,247,154,51,155,128,155,133,155,135,155,124,155,126,155,123,155,130,155,147,155,146,155,144,155,122,155,149,155,125,155,136,155,37,157,23,157,32,157,30,157,20,157,41,157,29,157,24,157,34,157,16,157,25,157,31,157,136,158,134,158,135,158,174,158,173,158,213,158,214,158,250,158,18,159,61,159,38,81,37,81,34,81,36,81,32,81,41,81,244,82,147,86,140,86,141,86,134,86,132,86,131,86,126,86,130,86,127,86,129,86,214,88,212,88,207,88,210,88,45,91,37,91,50,91,35,91,44,91,39,91,38,91,47,91,46,91,123,91,241,91,242,91,183,93,108,94,106,94,190,95,187,95,195,97,181,97,188,97,231,97,224,97,229,97,228,97,232,97,222,97,239,100,233,100,227,100,235,100,228,100,232,100,129,101,128,101,182,101,218,101,210,102,141,106,150,106,129,106,165,106,137,106,159,106,155,106,161,106,158,106,135,106,147,106,142,106,149,106,131,106,168,106,164,106,145,106,127,106,166,106,154,106,133,106,140,106,146,106,91,107,173,107,9,108,204,111,169,111,244,111,212,111,227,111,220,111,237,111,231,111,230,111,222,111,242,111,221,111,226,111,232,111,225,113,241,113,232,113,242,113,228,113,240,113,226,113,115,115,110,115,111,115,151,116,178,116,171,116,144,116,170,116,173,116,177,116,165,116,175,116,16,117,17,117,18,117,15,117,132,117,67,118,72,118,73,118,71,118,164,118,233,118,181,119,171,119,178,119,183,119,182,119,180,119,177,119,168,119,240,119,243,120,253,120,2,121,251,120,252,120,242,120,5,121,249,120,254,120,4,121,171,121,168,121,92,122,91,122,86,122,88,122,84,122,90,122,190,122,192,122,193,122,5,124,15,124,242,123,0,124,255,123,251,123,14,124,244,123,11,124,243,123,2,124,9,124,3,124,1,124,248,123,253,123,6,124,240,123,241,123,16,124,10,124,232,124,45,126,60,126,66,126,51,126,72,152,56,126,42,126,73,126,64,126,71,126,41,126,76,126,48,126,59,126,54,126,68,126,58,126,69,127,127,127,126,127,125,127,244,127,242,127,44,128,187,129,196,129,204,129,202,129,197,129,199,129,188,129,233,129,91,130,90,130,92,130,131,133,128,133,143,133,167,133,149,133,160,133,139,133,163,133,123,133,164,133,154,133,158,133,119,133,124,133,137,133,161,133,122,133,120,133,87,133,142,133,150,133,134,133,141,133,153,133,157,133,129,133,162,133,130,133,136,133,133,133,121,133,118,133,152,133,144,133,159,133,104,134,190,135,170,135,173,135,197,135,176,135,172,135,185,135,181,135,188,135,174,135,201,135,195,135,194,135,204,135,183,135,175,135,196,135,202,135,180,135,182,135,191,135,184,135,189,135,222,135,178,135,53,137,51,137,60,137,62,137,65,137,82,137,55,137,66,137,173,137,175,137,174,137,242,137,243,137,30,139,24,139,22,139,17,139,5,139,11,139,34,139,15,139,18,139,21,139,7,139,13,139,8,139,6,139,28,139,19,139,26,139,79,140,112,140,114,140,113,140,111,140,149,140,148,140,249,140,111,141,78,142,77,142,83,142,80,142,76,142,71,142,67,143,64,143,133,144,126,144,56,145,154,145,162,145,155,145,153,145,159,145,161,145,157,145,160,145,161,147,131,147,175,147,100,147,86,147,71,147,124,147,88,147,92,147,118,147,73,147,80,147,81,147,96,147,109,147,143,147,76,147,106,147,121,147,87,147,85,147,82,147,79,147,113,147,119,147,123,147,97,147,94,147,99,147,103,147,128,147,78,147,89,147,199,149,192,149,201,149,195,149,197,149,183,149,174,150,176,150,172,150,32,151,31,151,24,151,29,151,25,151,154,151,161,151,156,151,158,151,157,151,213,151,212,151,241,151,65,152,68,152,74,152,73,152,69,152,67,152,37,153,43,153,44,153,42,153,51,153,50,153,47,153,45,153,49,153,48,153,152,153,163,153,161,153,2,154,250,153,244,153,247,153,249,153,248,153,246,153,251,153,253,153,254,153,252,153,3,154,190,154,254,154,253,154,1,155,252,154,72,155,154,155,168,155,158,155,155,155,166,155,161,155,165,155,164,155,134,155,162,155,160,155,175,155,51,157,65,157,103,157,54,157,46,157,47,157,49,157,56,157,48,157,69,157,66,157,67,157,62,157,55,157,64,157,61,157,245,127,45,157,138,158,137,158,141,158,176,158,200,158,218,158,251,158,255,158,36,159,35,159,34,159,84,159,160,159,49,81,45,81,46,81,152,86,156,86,151,86,154,86,157,86,153,86,112,89,60,91,105,92,106,92,192,93,109,94,110,94,216,97,223,97,237,97,238,97,241,97,234,97,240,97,235,97,214,97,233,97,255,100,4,101,253,100,248,100,1,101,3,101,252,100,148,101,219,101,218,102,219,102,216,102,197,106,185,106,189,106,225,106,198,106,186,106,182,106,183,106,199,106,180,106,173,106,94,107,201,107,11,108,7,112,12,112,13,112,1,112,5,112,20,112,14,112,255,111,0,112,251,111,38,112,252,111,247,111,10,112,1,114,255,113,249,113,3,114,253,113,118,115,184,116,192,116,181,116,193,116,190,116,182,116,187,116,194,116,20,117,19,117,92,118,100,118,89,118,80,118,83,118,87,118,90,118,166,118,189,118,236,118,194,119,186,119,255,120,12,121,19,121,20,121,9,121,16,121,18,121,17,121,173,121,172,121,95,122,28,124,41,124,25,124,32,124,31,124,45,124,29,124,38,124,40,124,34,124,37,124,48,124,92,126,80,126,86,126,99,126,88,126,98,126,95,126,81,126,96,126,87,126,83,126,181,127,179,127,247,127,248,127,117,128,209,129,210,129,208,129,95,130,94,130,180,133,198,133,192,133,195,133,194,133,179,133,181,133,189,133,199,133,196,133,191,133,203,133,206,133,200,133,197,133,177,133,182,133,210,133,36,134,184,133,183,133,190,133,105,134,231,135,230,135,226,135,219,135,235,135,234,135,229,135,223,135,243,135,228,135,212,135,220,135,211,135,237,135,216,135,227,135,164,135,215,135,217,135,1,136,244,135,232,135,221,135,83,137,75,137,79,137,76,137,70,137,80,137,81,137,73,137,42,139,39,139,35,139,51,139,48,139,53,139,71,139,47,139,60,139,62,139,49,139,37,139,55,139,38,139,54,139,46,139,36,139,59,139,61,139,58,139,66,140,117,140,153,140,152,140,151,140,254,140,4,141,2,141,0,141,92,142,98,142,96,142,87,142,86,142,94,142,101,142,103,142,91,142,90,142,97,142,93,142,105,142,84,142,70,143,71,143,72,143,75,143,40,145,58,145,59,145,62,145,168,145,165,145,167,145,175,145,170,145,181,147,140,147,146,147,183,147,155,147,157,147,137,147,167,147,142,147,170,147,158,147,166,147,149,147,136,147,153,147,159,147,141,147,177,147,145,147,178,147,164,147,168,147,180,147,163,147,165,147,210,149,211,149,209,149,179,150,215,150,218,150,194,93,223,150,216,150,221,150,35,151,34,151,37,151,172,151,174,151,168,151,171,151,164,151,170,151,162,151,165,151,215,151,217,151,214,151,216,151,250,151,80,152,81,152,82,152,184,152,65,153,60,153,58,153,15,154,11,154,9,154,13,154,4,154,17,154,10,154,5,154,7,154,6,154,192,154,220,154,8,155,4,155,5,155,41,155,53,155,74,155,76,155,75,155,199,155,198,155,195,155,191,155,193,155,181,155,184,155,211,155,182,155,196,155,185,155,189,155,92,157,83,157,79,157,74,157,91,157,75,157,89,157,86,157,76,157,87,157,82,157,84,157,95,157,88,157,90,157,142,158,140,158,223,158,1,159,0,159,22,159,37,159,43,159,42,159,41,159,40,159,76,159,85,159,52,81,53,81,150,82,247,82,180,83,171,86,173,86,166,86,167,86,170,86,172,86,218,88,221,88,219,88,18,89,61,91,62,91,63,91,195,93,112,94,191,95,251,97,7,101,16,101,13,101,9,101,12,101,14,101,132,101,222,101,221,101,222,102,231,106,224,106,204,106,209,106,217,106,203,106,223,106,220,106,208,106,235,106,207,106,205,106,222,106,96,107,176,107,12,108,25,112,39,112,32,112,22,112,43,112,33,112,34,112,35,112,41,112,23,112,36,112,28,112,42,112,12,114,10,114,7,114,2,114,5,114,165,114,166,114,164,114,163,114,161,114,203,116,197,116,183,116,195,116,22,117,96,118,201,119,202,119,196,119,241,119,29,121,27,121,33,121,28,121,23,121,30,121,176,121,103,122,104,122,51,124,60,124,57,124,44,124,59,124,236,124,234,124,118,126,117,126,120,126,112,126,119,126,111,126,122,126,114,126,116,126,104,126,75,127,74,127,131,127,134,127,183,127,253,127,254,127,120,128,215,129,213,129,100,130,97,130,99,130,235,133,241,133,237,133,217,133,225,133,232,133,218,133,215,133,236,133,242,133,248,133,216,133,223,133,227,133,220,133,209,133,240,133,230,133,239,133,222,133,226,133,0,136,250,135,3,136,246,135,247,135,9,136,12,136,11,136,6,136,252,135,8,136,255,135,10,136,2,136,98,137,90,137,91,137,87,137,97,137,92,137,88,137,93,137,89,137,136,137,183,137,182,137,246,137,80,139,72,139,74,139,64,139,83,139,86,139,84,139,75,139,85,139,81,139,66,139,82,139,87,139,67,140,119,140,118,140,154,140,6,141,7,141,9,141,172,141,170,141,173,141,171,141,109,142,120,142,115,142,106,142,111,142,123,142,194,142,82,143,81,143,79,143,80,143,83,143,180,143,64,145,63,145,176,145,173,145,222,147,199,147,207,147,194,147,218,147,208,147,249,147,236,147,204,147,217,147,169,147,230,147,202,147,212,147,238,147,227,147,213,147,196,147,206,147,192,147,210,147,231,147,125,149,218,149,219,149,225,150,41,151,43,151,44,151,40,151,38,151,179,151,183,151,182,151,221,151,222,151,223,151,92,152,89,152,93,152,87,152,191,152,189,152,187,152,190,152,72,153,71,153,67,153,166,153,167,153,26,154,21,154,37,154,29,154,36,154,27,154,34,154,32,154,39,154,35,154,30,154,28,154,20,154,194,154,11,155,10,155,14,155,12,155,55,155,234,155,235,155,224,155,222,155,228,155,230,155,226,155,240,155,212,155,215,155,236,155,220,155,217,155,229,155,213,155,225,155,218,155,119,157,129,157,138,157,132,157,136,157,113,157,128,157,120,157,134,157,139,157,140,157,125,157,107,157,116,157,117,157,112,157,105,157,133,157,115,157,123,157,130,157,111,157,121,157,127,157,135,157,104,157,148,158,145,158,192,158,252,158,45,159,64,159,65,159,77,159,86,159,87,159,88,159,55,83,178,86,181,86,179,86,227,88,69,91,198,93,199,93,238,94,239,94,192,95,193,95,249,97,23,101,22,101,21,101,19,101,223,101,232,102,227,102,228,102,243,106,240,106,234,106,232,106,249,106,241,106,238,106,239,106,60,112,53,112,47,112,55,112,52,112,49,112,66,112,56,112,63,112,58,112,57,112,64,112,59,112,51,112,65,112,19,114,20,114,168,114,125,115,124,115,186,116,171,118,170,118,190,118,237,118,204,119,206,119,207,119,205,119,242,119,37,121,35,121,39,121,40,121,36,121,41,121,178,121,110,122,108,122,109,122,247,122,73,124,72,124,74,124,71,124,69,124,238,124,123,126,126,126,129,126,128,126,186,127,255,127,121,128,219,129,217,129,11,130,104,130,105,130,34,134,255,133,1,134,254,133,27,134,0,134,246,133,4,134,9,134,5,134,12,134,253,133,25,136,16,136,17,136,23,136,19,136,22,136,99,137,102,137,185,137,247,137,96,139,106,139,93,139,104,139,99,139,101,139,103,139,109,139,174,141,134,142,136,142,132,142,89,143,86,143,87,143,85,143,88,143,90,143,141,144,67,145,65,145,183,145,181,145,178,145,179,145,11,148,19,148,251,147,32,148,15,148,20,148,254,147,21,148,16,148,40,148,25,148,13,148,245,147,0,148,247,147,7,148,14,148,22,148,18,148,250,147,9,148,248,147,10,148,255,147,252,147,12,148,246,147,17,148,6,148,222,149,224,149,223,149,46,151,47,151,185,151,187,151,253,151,254,151,96,152,98,152,99,152,95,152,193,152,194,152,80,153,78,153,89,153,76,153,75,153,83,153,50,154,52,154,49,154,44,154,42,154,54,154,41,154,46,154,56,154,45,154,199,154,202,154,198,154,16,155,18,155,17,155,11,156,8,156,247,155,5,156,18,156,248,155,64,156,7,156,14,156,6,156,23,156,20,156,9,156,159,157,153,157,164,157,157,157,146,157,152,157,144,157,155,157,160,157,148,157,156,157,170,157,151,157,161,157,154,157,162,157,168,157,158,157,163,157,191,157,169,157,150,157,166,157,167,157,153,158,155,158,154,158,229,158,228,158,231,158,230,158,48,159,46,159,91,159,96,159,94,159,93,159,89,159,145,159,58,81,57,81,152,82,151,82,195,86,189,86,190,86,72,91,71,91,203,93,207,93,241,94,253,97,27,101,2,107,252,106,3,107,248,106,0,107,67,112,68,112,74,112,72,112,73,112,69,112,70,112,29,114,26,114,25,114,126,115,23,117,106,118,208,119,45,121,49,121,47,121,84,124,83,124,242,124,138,126,135,126,136,126,139,126,134,126,141,126,77,127,187,127,48,128,221,129,24,134,42,134,38,134,31,134,35,134,28,134,25,134,39,134,46,134,33,134,32,134,41,134,30,134,37,134,41,136,29,136,27,136,32,136,36,136,28,136,43,136,74,136,109,137,105,137,110,137,107,137,250,137,121,139,120,139,69,139,122,139,123,139,16,141,20,141,175,141,142,142,140,142,94,143,91,143,93,143,70,145,68,145,69,145,185,145,63,148,59,148,54,148,41,148,61,148,60,148,48,148,57,148,42,148,55,148,44,148,64,148,49,148,229,149,228,149,227,149,53,151,58,151,191,151,225,151,100,152,201,152,198,152,192,152,88,153,86,153,57,154,61,154,70,154,68,154,66,154,65,154,58,154,63,154,205,154,21,155,23,155,24,155,22,155,58,155,82,155,43,156,29,156,28,156,44,156,35,156,40,156,41,156,36,156,33,156,183,157,182,157,188,157,193,157,199,157,202,157,207,157,190,157,197,157,195,157,187,157,181,157,206,157,185,157,186,157,172,157,200,157,177,157,173,157,204,157,179,157,205,157,178,157,122,158,156,158,235,158,238,158,237,158,27,159,24,159,26,159,49,159,78,159,101,159,100,159,146,159,185,78,198,86,197,86,203,86,113,89,75,91,76,91,213,93,209,93,242,94,33,101,32,101,38,101,34,101,11,107,8,107,9,107,13,108,85,112,86,112,87,112,82,112,30,114,31,114,169,114,127,115,216,116,213,116,217,116,215,116,109,118,173,118,53,121,180,121,112,122,113,122,87,124,92,124,89,124,91,124,90,124,244,124,241,124,145,126,79,127,135,127,222,129,107,130,52,134,53,134,51,134,44,134,50,134,54,134,44,136,40,136,38,136,42,136,37,136,113,137,191,137,190,137,251,137,126,139,132,139,130,139,134,139,133,139,127,139,21,141,149,142,148,142,154,142,146,142,144,142,150,142,151,142,96,143,98,143,71,145,76,148,80,148,74,148,75,148,79,148,71,148,69,148,72,148,73,148,70,148,63,151,227,151,106,152,105,152,203,152,84,153,91,153,78,154,83,154,84,154,76,154,79,154,72,154,74,154,73,154,82,154,80,154,208,154,25,155,43,155,59,155,86,155,85,155,70,156,72,156,63,156,68,156,57,156,51,156,65,156,60,156,55,156,52,156,50,156,61,156,54,156,219,157,210,157,222,157,218,157,203,157,208,157,220,157,209,157,223,157,233,157,217,157,216,157,214,157,245,157,213,157,221,157,182,158,240,158,53,159,51,159,50,159,66,159,107,159,149,159,162,159,61,81,153,82,232,88,231,88,114,89,77,91,216,93,47,136,79,95,1,98,3,98,4,98,41,101,37,101,150,101,235,102,17,107,18,107,15,107,202,107,91,112,90,112,34,114,130,115,129,115,131,115,112,118,212,119,103,124,102,124,149,126,108,130,58,134,64,134,57,134,60,134,49,134,59,134,62,134,48,136,50,136,46,136,51,136,118,137,116,137,115,137,254,137,140,139,142,139,139,139,136,139,69,140,25,141,152,142,100,143,99,143,188,145,98,148,85,148,93,148,87,148,94,148,196,151,197,151,0,152,86,154,89,154,30,155,31,155,32,155,82,156,88,156,80,156,74,156,77,156,75,156,85,156,89,156,76,156,78,156,251,157,247,157,239,157,227,157,235,157,248,157,228,157,246,157,225,157,238,157,230,157,242,157,240,157,226,157,236,157,244,157,243,157,232,157,237,157,194,158,208,158,242,158,243,158,6,159,28,159,56,159,55,159,54,159,67,159,79,159,113,159,112,159,110,159,111,159,211,86,205,86,78,91,109,92,45,101,237,102,238,102,19,107,95,112,97,112,93,112,96,112,35,114,219,116,229,116,213,119,56,121,183,121,182,121,106,124,151,126,137,127,109,130,67,134,56,136,55,136,53,136,75,136,148,139,149,139,158,142,159,142,160,142,157,142,190,145,189,145,194,145,107,148,104,148,105,148,229,150,70,151,67,151,71,151,199,151,229,151,94,154,213,154,89,155,99,156,103,156,102,156,98,156,94,156,96,156,2,158,254,157,7,158,3,158,6,158,5,158,0,158,1,158,9,158,255,157,253,157,4,158,160,158,30,159,70,159,116,159,117,159,118,159,212,86,46,101,184,101,24,107,25,107,23,107,26,107,98,112,38,114,170,114,216,119,217,119,57,121,105,124,107,124,246,124,154,126,152,126,155,126,153,126,224,129,225,129,70,134,71,134,72,134,121,137,122,137,124,137,123,137,255,137,152,139,153,139,165,142,164,142,163,142,110,148,109,148,111,148,113,148,115,148,73,151,114,152,95,153,104,156,110,156,109,156,11,158,13,158,16,158,15,158,18,158,17,158,161,158,245,158,9,159,71,159,120,159,123,159,122,159,121,159,30,87,102,112,111,124,60,136,178,141,166,142,195,145,116,148,120,148,118,148,117,148,96,154,116,156,115,156,113,156,117,156,20,158,19,158,246,158,10,159,164,159,104,112,101,112,247,124,106,134,62,136,61,136,63,136,158,139,156,140,169,142,201,142,75,151,115,152,116,152,204,152,97,153,171,153,100,154,102,154,103,154,36,155,21,158,23,158,72,159,7,98,30,107,39,114,76,134,168,142,130,148,128,148,129,148,105,154,104,154,46,155,25,158,41,114,75,134,159,139,131,148,121,156,183,158,117,118,107,154,122,156,29,158,105,112,106,112,164,158,126,159,73,159,152,159,129,120,185,146,207,136,187,88,82,96,167,124,250,90,84,37,102,37,87,37,96,37,108,37,99,37,90,37,105,37,93,37,82,37,100,37,85,37,94,37,106,37,97,37,88,37,103,37,91,37,83,37,101,37,86,37,95,37,107,37,98,37,89,37,104,37,92,37,81,37,80,37,109,37,110,37,112,37,111,37,147,37,0,0,0,0,0,0,0,48,1,48,2,48,183,0,37,32,38,32,168,0,3,48,173,0,21,32,37,34,60,255,60,34,24,32,25,32,28,32,29,32,20,48,21,48,8,48,9,48,10,48,11,48,12,48,13,48,14,48,15,48,16,48,17,48,177,0,215,0,247,0,96,34,100,34,101,34,30,34,52,34,176,0,50,32,51,32,3,33,43,33,224,255,225,255,229,255,66,38,64,38,32,34,165,34,18,35,2,34,7,34,97,34,82,34,167,0,59,32,6,38,5,38,203,37,207,37,206,37,199,37,198,37,161,37,160,37,179,37,178,37,189,37,188,37,146,33,144,33,145,33,147,33,148,33,19,48,106,34,107,34,26,34,61,34,29,34,53,34,43,34,44,34,8,34,11,34,134,34,135,34,130,34,131,34,42,34,41,34,39,34,40,34,226,255,210,33,212,33,0,34,3,34,180,0,94,255,199,2,216,2,221,2,218,2,217,2,184,0,219,2,161,0,191,0,208,2,46,34,17,34,15,34,164,0,9,33,48,32,193,37,192,37,183,37,182,37,100,38,96,38,97,38,101,38,103,38,99,38,153,34,200,37,163,37,208,37,209,37,146,37,164,37,165,37,168,37,167,37,166,37,169,37,104,38,15,38,14,38,28,38,30,38,182,0,32,32,33,32,149,33,151,33,153,33,150,33,152,33,109,38,105,38,106,38,108,38,127,50,28,50,22,33,199,51,34,33,194,51,216,51,33,33,172,32,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,255,2,255,3,255,4,255,5,255,6,255,7,255,8,255,9,255,10,255,11,255,12,255,13,255,14,255,15,255,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255,24,255,25,255,26,255,27,255,28,255,29,255,30,255,31,255,32,255,33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,59,255,230,255,61,255,62,255,63,255,64,255,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,91,255,92,255,93,255,227,255,49,49,50,49,51,49,52,49,53,49,54,49,55,49,56,49,57,49,58,49,59,49,60,49,61,49,62,49,63,49,64,49,65,49,66,49,67,49,68,49,69,49,70,49,71,49,72,49,73,49,74,49,75,49,76,49,77,49,78,49,79,49,80,49,81,49,82,49,83,49,84,49,85,49,86,49,87,49,88,49,89,49,90,49,91,49,92,49,93,49,94,49,95,49,96,49,97,49,98,49,99,49,100,49,101,49,102,49,103,49,104,49,105,49,106,49,107,49,108,49,109,49,110,49,111,49,112,49,113,49,114,49,115,49,116,49,117,49,118,49,119,49,120,49,121,49,122,49,123,49,124,49,125,49,126,49,127,49,128,49,129,49,130,49,131,49,132,49,133,49,134,49,135,49,136,49,137,49,138,49,139,49,140,49,141,49,142,49,112,33,113,33,114,33,115,33,116,33,117,33,118,33,119,33,120,33,121,33,0,0,0,0,0,0,0,0,0,0,96,33,97,33,98,33,99,33,100,33,101,33,102,33,103,33,104,33,105,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,0,0,0,0,0,0,0,0,0,0,0,0,0,37,2,37,12,37,16,37,24,37,20,37,28,37,44,37,36,37,52,37,60,37,1,37,3,37,15,37,19,37,27,37,23,37,35,37,51,37,43,37,59,37,75,37,32,37,47,37,40,37,55,37,63,37,29,37,48,37,37,37,56,37,66,37,18,37,17,37,26,37,25,37,22,37,21,37,14,37,13,37,30,37,31,37,33,37,34,37,38,37,39,37,41,37,42,37,45,37,46,37,49,37,50,37,53,37,54,37,57,37,58,37,61,37,62,37,64,37,65,37,67,37,68,37,69,37,70,37,71,37,72,37,73,37,74,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,149,51,150,51,151,51,19,33,152,51,196,51,163,51,164,51,165,51,166,51,153,51,154,51,155,51,156,51,157,51,158,51,159,51,160,51,161,51,162,51,202,51,141,51,142,51,143,51,207,51,136,51,137,51,200,51,167,51,168,51,176,51,177,51,178,51,179,51,180,51,181,51,182,51,183,51,184,51,185,51,128,51,129,51,130,51,131,51,132,51,186,51,187,51,188,51,189,51,190,51,191,51,144,51,145,51,146,51,147,51,148,51,38,33,192,51,193,51,138,51,139,51,140,51,214,51,197,51,173,51,174,51,175,51,219,51,169,51,170,51,171,51,172,51,221,51,208,51,211,51,195,51,201,51,220,51,198,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,198,0,208,0,170,0,38,1,0,0,50,1,0,0,63,1,65,1,216,0,82,1,186,0,222,0,102,1,74,1,0,0,96,50,97,50,98,50,99,50,100,50,101,50,102,50,103,50,104,50,105,50,106,50,107,50,108,50,109,50,110,50,111,50,112,50,113,50,114,50,115,50,116,50,117,50,118,50,119,50,120,50,121,50,122,50,123,50,208,36,209,36,210,36,211,36,212,36,213,36,214,36,215,36,216,36,217,36,218,36,219,36,220,36,221,36,222,36,223,36,224,36,225,36,226,36,227,36,228,36,229,36,230,36,231,36,232,36,233,36,96,36,97,36,98,36,99,36,100,36,101,36,102,36,103,36,104,36,105,36,106,36,107,36,108,36,109,36,110,36,189,0,83,33,84,33,188,0,190,0,91,33,92,33,93,33,94,33,230,0,17,1,240,0,39,1,49,1,51,1,56,1,64,1,66,1,248,0,83,1,223,0,254,0,103,1,75,1,73,1,0,50,1,50,2,50,3,50,4,50,5,50,6,50,7,50,8,50,9,50,10,50,11,50,12,50,13,50,14,50,15,50,16,50,17,50,18,50,19,50,20,50,21,50,22,50,23,50,24,50,25,50,26,50,27,50,156,36,157,36,158,36,159,36,160,36,161,36,162,36,163,36,164,36,165,36,166,36,167,36,168,36,169,36,170,36,171,36,172,36,173,36,174,36,175,36,176,36,177,36,178,36,179,36,180,36,181,36,116,36,117,36,118,36,119,36,120,36,121,36,122,36,123,36,124,36,125,36,126,36,127,36,128,36,129,36,130,36,185,0,178,0,179,0,116,32,127,32,129,32,130,32,131,32,132,32,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,172,1,172,4,172,7,172,8,172,9,172,10,172,16,172,17,172,18,172,19,172,20,172,21,172,22,172,23,172,25,172,26,172,27,172,28,172,29,172,32,172,36,172,44,172,45,172,47,172,48,172,49,172,56,172,57,172,60,172,64,172,75,172,77,172,84,172,88,172,92,172,112,172,113,172,116,172,119,172,120,172,122,172,128,172,129,172,131,172,132,172,133,172,134,172,137,172,138,172,139,172,140,172,144,172,148,172,156,172,157,172,159,172,160,172,161,172,168,172,169,172,170,172,172,172,175,172,176,172,184,172,185,172,187,172,188,172,189,172,193,172,196,172,200,172,204,172,213,172,215,172,224,172,225,172,228,172,231,172,232,172,234,172,236,172,239,172,240,172,241,172,243,172,245,172,246,172,252,172,253,172,0,173,4,173,6,173,12,173,13,173,15,173,17,173,24,173,28,173,32,173,41,173,44,173,45,173,52,173,53,173,56,173,60,173,68,173,69,173,71,173,73,173,80,173,84,173,88,173,97,173,99,173,108,173,109,173,112,173,115,173,116,173,117,173,118,173,123,173,124,173,125,173,127,173,129,173,130,173,136,173,137,173,140,173,144,173,156,173,157,173,164,173,183,173,192,173,193,173,196,173,200,173,208,173,209,173,211,173,220,173,224,173,228,173,248,173,249,173,252,173,255,173,0,174,1,174,8,174,9,174,11,174,13,174,20,174,48,174,49,174,52,174,55,174,56,174,58,174,64,174,65,174,67,174,69,174,70,174,74,174,76,174,77,174,78,174,80,174,84,174,86,174,92,174,93,174,95,174,96,174,97,174,101,174,104,174,105,174,108,174,112,174,120,174,121,174,123,174,124,174,125,174,132,174,133,174,140,174,188,174,189,174,190,174,192,174,196,174,204,174,205,174,207,174,208,174,209,174,216,174,217,174,220,174,232,174,235,174,237,174,244,174,248,174,252,174,7,175,8,175],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+302308),
	allocate([13,175,16,175,44,175,45,175,48,175,50,175,52,175,60,175,61,175,63,175,65,175,66,175,67,175,72,175,73,175,80,175,92,175,93,175,100,175,101,175,121,175,128,175,132,175,136,175,144,175,145,175,149,175,156,175,184,175,185,175,188,175,192,175,199,175,200,175,201,175,203,175,205,175,206,175,212,175,220,175,232,175,233,175,240,175,241,175,244,175,248,175,0,176,1,176,4,176,12,176,16,176,20,176,28,176,29,176,40,176,68,176,69,176,72,176,74,176,76,176,78,176,83,176,84,176,85,176,87,176,89,176,93,176,124,176,125,176,128,176,132,176,140,176,141,176,143,176,145,176,152,176,153,176,154,176,156,176,159,176,160,176,161,176,162,176,168,176,169,176,171,176,172,176,173,176,174,176,175,176,177,176,179,176,180,176,181,176,184,176,188,176,196,176,197,176,199,176,200,176,201,176,208,176,209,176,212,176,216,176,224,176,229,176,8,177,9,177,11,177,12,177,16,177,18,177,19,177,24,177,25,177,27,177,28,177,29,177,35,177,36,177,37,177,40,177,44,177,52,177,53,177,55,177,56,177,57,177,64,177,65,177,68,177,72,177,80,177,81,177,84,177,85,177,88,177,92,177,96,177,120,177,121,177,124,177,128,177,130,177,136,177,137,177,139,177,141,177,146,177,147,177,148,177,152,177,156,177,168,177,204,177,208,177,212,177,220,177,221,177,223,177,232,177,233,177,236,177,240,177,249,177,251,177,253,177,4,178,5,178,8,178,11,178,12,178,20,178,21,178,23,178,25,178,32,178,52,178,60,178,88,178,92,178,96,178,104,178,105,178,116,178,117,178,124,178,132,178,133,178,137,178,144,178,145,178,148,178,152,178,153,178,154,178,160,178,161,178,163,178,165,178,166,178,170,178,172,178,176,178,180,178,200,178,201,178,204,178,208,178,210,178,216,178,217,178,219,178,221,178,226,178,228,178,229,178,230,178,232,178,235,178,236,178,237,178,238,178,239,178,243,178,244,178,245,178,247,178,248,178,249,178,250,178,251,178,255,178,0,179,1,179,4,179,8,179,16,179,17,179,19,179,20,179,21,179,28,179,84,179,85,179,86,179,88,179,91,179,92,179,94,179,95,179,100,179,101,179,103,179,105,179,107,179,110,179,112,179,113,179,116,179,120,179,128,179,129,179,131,179,132,179,133,179,140,179,144,179,148,179,160,179,161,179,168,179,172,179,196,179,197,179,200,179,203,179,204,179,206,179,208,179,212,179,213,179,215,179,217,179,219,179,221,179,224,179,228,179,232,179,252,179,16,180,24,180,28,180,32,180,40,180,41,180,43,180,52,180,80,180,81,180,84,180,88,180,96,180,97,180,99,180,101,180,108,180,128,180,136,180,157,180,164,180,168,180,172,180,181,180,183,180,185,180,192,180,196,180,200,180,208,180,213,180,220,180,221,180,224,180,227,180,228,180,230,180,236,180,237,180,239,180,241,180,248,180,20,181,21,181,24,181,27,181,28,181,36,181,37,181,39,181,40,181,41,181,42,181,48,181,49,181,52,181,56,181,64,181,65,181,67,181,68,181,69,181,75,181,76,181,77,181,80,181,84,181,92,181,93,181,95,181,96,181,97,181,160,181,161,181,164,181,168,181,170,181,171,181,176,181,177,181,179,181,180,181,181,181,187,181,188,181,189,181,192,181,196,181,204,181,205,181,207,181,208,181,209,181,216,181,236,181,16,182,17,182,20,182,24,182,37,182,44,182,52,182,72,182,100,182,104,182,156,182,157,182,160,182,164,182,171,182,172,182,177,182,212,182,240,182,244,182,248,182,0,183,1,183,5,183,40,183,41,183,44,183,47,183,48,183,56,183,57,183,59,183,68,183,72,183,76,183,84,183,85,183,96,183,100,183,104,183,112,183,113,183,115,183,117,183,124,183,125,183,128,183,132,183,140,183,141,183,143,183,144,183,145,183,146,183,150,183,151,183,152,183,153,183,156,183,160,183,168,183,169,183,171,183,172,183,173,183,180,183,181,183,184,183,199,183,201,183,236,183,237,183,240,183,244,183,252,183,253,183,255,183,0,184,1,184,7,184,8,184,9,184,12,184,16,184,24,184,25,184,27,184,29,184,36,184,37,184,40,184,44,184,52,184,53,184,55,184,56,184,57,184,64,184,68,184,81,184,83,184,92,184,93,184,96,184,100,184,108,184,109,184,111,184,113,184,120,184,124,184,141,184,168,184,176,184,180,184,184,184,192,184,193,184,195,184,197,184,204,184,208,184,212,184,221,184,223,184,225,184,232,184,233,184,236,184,240,184,248,184,249,184,251,184,253,184,4,185,24,185,32,185,60,185,61,185,64,185,68,185,76,185,79,185,81,185,88,185,89,185,92,185,96,185,104,185,105,185,107,185,109,185,116,185,117,185,120,185,124,185,132,185,133,185,135,185,137,185,138,185,141,185,142,185,172,185,173,185,176,185,180,185,188,185,189,185,191,185,193,185,200,185,201,185,204,185,206,185,207,185,208,185,209,185,210,185,216,185,217,185,219,185,221,185,222,185,225,185,227,185,228,185,229,185,232,185,236,185,244,185,245,185,247,185,248,185,249,185,250,185,0,186,1,186,8,186,21,186,56,186,57,186,60,186,64,186,66,186,72,186,73,186,75,186,77,186,78,186,83,186,84,186,85,186,88,186,92,186,100,186,101,186,103,186,104,186,105,186,112,186,113,186,116,186,120,186,131,186,132,186,133,186,135,186,140,186,168,186,169,186,171,186,172,186,176,186,178,186,184,186,185,186,187,186,189,186,196,186,200,186,216,186,217,186,252,186,0,187,4,187,13,187,15,187,17,187,24,187,28,187,32,187,41,187,43,187,52,187,53,187,54,187,56,187,59,187,60,187,61,187,62,187,68,187,69,187,71,187,73,187,77,187,79,187,80,187,84,187,88,187,97,187,99,187,108,187,136,187,140,187,144,187,164,187,168,187,172,187,180,187,183,187,192,187,196,187,200,187,208,187,211,187,248,187,249,187,252,187,255,187,0,188,2,188,8,188,9,188,11,188,12,188,13,188,15,188,17,188,20,188,21,188,22,188,23,188,24,188,27,188,28,188,29,188,30,188,31,188,36,188,37,188,39,188,41,188,45,188,48,188,49,188,52,188,56,188,64,188,65,188,67,188,68,188,69,188,73,188,76,188,77,188,80,188,93,188,132,188,133,188,136,188,139,188,140,188,142,188,148,188,149,188,151,188,153,188,154,188,160,188,161,188,164,188,167,188,168,188,176,188,177,188,179,188,180,188,181,188,188,188,189,188,192,188,196,188,205,188,207,188,208,188,209,188,213,188,216,188,220,188,244,188,245,188,246,188,248,188,252,188,4,189,5,189,7,189,9,189,16,189,20,189,36,189,44,189,64,189,72,189,73,189,76,189,80,189,88,189,89,189,100,189,104,189,128,189,129,189,132,189,135,189,136,189,137,189,138,189,144,189,145,189,147,189,149,189,153,189,154,189,156,189,164,189,176,189,184,189,212,189,213,189,216,189,220,189,233,189,240,189,244,189,248,189,0,190,3,190,5,190,12,190,13,190,16,190,20,190,28,190,29,190,31,190,68,190,69,190,72,190,76,190,78,190,84,190,85,190,87,190,89,190,90,190,91,190,96,190,97,190,100,190,104,190,106,190,112,190,113,190,115,190,116,190,117,190,123,190,124,190,125,190,128,190,132,190,140,190,141,190,143,190,144,190,145,190,152,190,153,190,168,190,208,190,209,190,212,190,215,190,216,190,224,190,227,190,228,190,229,190,236,190,1,191,8,191,9,191,24,191,25,191,27,191,28,191,29,191,64,191,65,191,68,191,72,191,80,191,81,191,85,191,148,191,176,191,197,191,204,191,205,191,208,191,212,191,220,191,223,191,225,191,60,192,81,192,88,192,92,192,96,192,104,192,105,192,144,192,145,192,148,192,152,192,160,192,161,192,163,192,165,192,172,192,173,192,175,192,176,192,179,192,180,192,181,192,182,192,188,192,189,192,191,192,192,192,193,192,197,192,200,192,201,192,204,192,208,192,216,192,217,192,219,192,220,192,221,192,228,192,229,192,232,192,236,192,244,192,245,192,247,192,249,192,0,193,4,193,8,193,16,193,21,193,28,193,29,193,30,193,31,193,32,193,35,193,36,193,38,193,39,193,44,193,45,193,47,193,48,193,49,193,54,193,56,193,57,193,60,193,64,193,72,193,73,193,75,193,76,193,77,193,84,193,85,193,88,193,92,193,100,193,101,193,103,193,104,193,105,193,112,193,116,193,120,193,133,193,140,193,141,193,142,193,144,193,148,193,150,193,156,193,157,193,159,193,161,193,165,193,168,193,169,193,172,193,176,193,189,193,196,193,200,193,204,193,212,193,215,193,216,193,224,193,228,193,232,193,240,193,241,193,243,193,252,193,253,193,0,194,4,194,12,194,13,194,15,194,17,194,24,194,25,194,28,194,31,194,32,194,40,194,41,194,43,194,45,194,47,194,49,194,50,194,52,194,72,194,80,194,81,194,84,194,88,194,96,194,101,194,108,194,109,194,112,194,116,194,124,194,125,194,127,194,129,194,136,194,137,194,144,194,152,194,155,194,157,194,164,194,165,194,168,194,172,194,173,194,180,194,181,194,183,194,185,194,220,194,221,194,224,194,227,194,228,194,235,194,236,194,237,194,239,194,241,194,246,194,248,194,249,194,251,194,252,194,0,195,8,195,9,195,12,195,13,195,19,195,20,195,21,195,24,195,28,195,36,195,37,195,40,195,41,195,69,195,104,195,105,195,108,195,112,195,114,195,120,195,121,195,124,195,125,195,132,195,136,195,140,195,192,195,216,195,217,195,220,195,223,195,224,195,226,195,232,195,233,195,237,195,244,195,245,195,248,195,8,196,16,196,36,196,44,196,48,196,52,196,60,196,61,196,72,196,100,196,101,196,104,196,108,196,116,196,117,196,121,196,128,196,148,196,156,196,184,196,188,196,233,196,240,196,241,196,244,196,248,196,250,196,255,196,0,197,1,197,12,197,16,197,20,197,28,197,40,197,41,197,44,197,48,197,56,197,57,197,59,197,61,197,68,197,69,197,72,197,73,197,74,197,76,197,77,197,78,197,83,197,84,197,85,197,87,197,88,197,89,197,93,197,94,197,96,197,97,197,100,197,104,197,112,197,113,197,115,197,116,197,117,197,124,197,125,197,128,197,132,197,135,197,140,197,141,197,143,197,145,197,149,197,151,197,152,197,156,197,160,197,169,197,180,197,181,197,184,197,185,197,187,197,188,197,189,197,190,197,196,197,197,197,198,197,199,197,200,197,201,197,202,197,204,197,206,197,208,197,209,197,212,197,216,197,224,197,225,197,227,197,229,197,236,197,237,197,238,197,240,197,244,197,246,197,247,197,252,197,253,197,254,197,255,197,0,198,1,198,5,198,6,198,7,198,8,198,12,198,16,198,24,198,25,198,27,198,28,198,36,198,37,198,40,198,44,198,45,198,46,198,48,198,51,198,52,198,53,198,55,198,57,198,59,198,64,198,65,198,68,198,72,198,80,198,81,198,83,198,84,198,85,198,92,198,93,198,96,198,108,198,111,198,113,198,120,198,121,198,124,198,128,198,136,198,137,198,139,198,141,198,148,198,149,198,152,198,156,198,164,198,165,198,167,198,169,198,176,198,177,198,180,198,184,198,185,198,186,198,192,198,193,198,195,198,197,198,204,198,205,198,208,198,212,198,220,198,221,198,224,198,225,198,232,198,233,198,236,198,240,198,248,198,249,198,253,198,4,199,5,199,8,199,12,199,20,199,21,199,23,199,25,199,32,199,33,199,36,199,40,199,48,199,49,199,51,199,53,199,55,199,60,199,61,199,64,199,68,199,74,199,76,199,77,199,79,199,81,199,82,199,83,199,84,199,85,199,86,199,87,199,88,199,92,199,96,199,104,199,107,199,116,199,117,199,120,199,124,199,125,199,126,199,131,199,132,199,133,199,135,199,136,199,137,199,138,199,142,199,144,199,145,199,148,199,150,199,151,199,152,199,154,199,160,199,161,199,163,199,164,199,165,199,166,199,172,199,173,199,176,199,180,199,188,199,189,199,191,199,192,199,193,199,200,199,201,199,204,199,206,199,208,199,216,199,221,199,228,199,232,199,236,199,0,200,1,200,4,200,8,200,10,200,16,200,17,200,19,200,21,200,22,200,28,200,29,200,32,200,36,200,44,200,45,200,47,200,49,200,56,200,60,200,64,200,72,200,73,200,76,200,77,200,84,200,112,200,113,200,116,200,120,200,122,200,128,200,129,200,131,200,133,200,134,200,135,200,139,200,140,200,141,200,148,200,157,200,159,200,161,200,168,200,188,200,189,200,196,200,200,200,204,200,212,200,213,200,215,200,217,200,224,200,225,200,228,200,245,200,252,200,253,200,0,201,4,201,5,201,6,201,12,201,13,201,15,201,17,201,24,201,44,201,52,201,80,201,81,201,84,201,88,201,96,201,97,201,99,201,108,201,112,201,116,201,124,201,136,201,137,201,140,201,144,201,152,201,153,201,155,201,157,201,192,201,193,201,196,201,199,201,200,201,202,201,208,201,209,201,211,201,213,201,214,201,217,201,218,201,220,201,221,201,224,201,226,201,228,201,231,201,236,201,237,201,239,201,240,201,241,201,248,201,249,201,252,201,0,202,8,202,9,202,11,202,12,202,13,202,20,202,24,202,41,202,76,202,77,202,80,202,84,202,92,202,93,202,95,202,96,202,97,202,104,202,125,202,132,202,152,202,188,202,189,202,192,202,196,202,204,202,205,202,207,202,209,202,211,202,216,202,217,202,224,202,236,202,244,202,8,203,16,203,20,203,24,203,32,203,33,203,65,203,72,203,73,203,76,203,80,203,88,203,89,203,93,203,100,203,120,203,121,203,156,203,184,203,212,203,228,203,231,203,233,203,12,204,13,204,16,204,20,204,28,204,29,204,33,204,34,204,39,204,40,204,41,204,44,204,46,204,48,204,56,204,57,204,59,204,60,204,61,204,62,204,68,204,69,204,72,204,76,204,84,204,85,204,87,204,88,204,89,204,96,204,100,204,102,204,104,204,112,204,117,204,152,204,153,204,156,204,160,204,168,204,169,204,171,204,172,204,173,204,180,204,181,204,184,204,188,204,196,204,197,204,199,204,201,204,208,204,212,204,228,204,236,204,240,204,1,205,8,205,9,205,12,205,16,205,24,205,25,205,27,205,29,205,36,205,40,205,44,205,57,205,92,205,96,205,100,205,108,205,109,205,111,205,113,205,120,205,136,205,148,205,149,205,152,205,156,205,164,205,165,205,167,205,169,205,176,205,196,205,204,205,208,205,232,205,236,205,240,205,248,205,249,205,251,205,253,205,4,206,8,206,12,206,20,206,25,206,32,206,33,206,36,206,40,206,48,206,49,206,51,206,53,206,88,206,89,206,92,206,95,206,96,206,97,206,104,206,105,206,107,206,109,206,116,206,117,206,120,206,124,206,132,206,133,206,135,206,137,206,144,206,145,206,148,206,152,206,160,206,161,206,163,206,164,206,165,206,172,206,173,206,193,206,228,206,229,206,232,206,235,206,236,206,244,206,245,206,247,206,248,206,249,206,0,207,1,207,4,207,8,207,16,207,17,207,19,207,21,207,28,207,32,207,36,207,44,207,45,207,47,207,48,207,49,207,56,207,84,207,85,207,88,207,92,207,100,207,101,207,103,207,105,207,112,207,113,207,116,207,120,207,128,207,133,207,140,207,161,207,168,207,176,207,196,207,224,207,225,207,228,207,232,207,240,207,241,207,243,207,245,207,252,207,0,208,4,208,17,208,24,208,45,208,52,208,53,208,56,208,60,208,68,208,69,208,71,208,73,208,80,208,84,208,88,208,96,208,108,208,109,208,112,208,116,208,124,208,125,208,129,208,164,208,165,208,168,208,172,208,180,208,181,208,183,208,185,208,192,208,193,208,196,208,200,208,201,208,208,208,209,208,211,208,212,208,213,208,220,208,221,208,224,208,228,208,236,208,237,208,239,208,240,208,241,208,248,208,13,209,48,209,49,209,52,209,56,209,58,209,64,209,65,209,67,209,68,209,69,209,76,209,77,209,80,209,84,209,92,209,93,209,95,209,97,209,104,209,108,209,124,209,132,209,136,209,160,209,161,209,164,209,168,209,176,209,177,209,179,209,181,209,186,209,188,209,192,209,216,209,244,209,248,209,7,210,9,210,16,210,44,210,45,210,48,210,52,210,60,210,61,210,63,210,65,210,72,210,92,210,100,210,128,210,129,210,132,210,136,210,144,210,145,210,149,210,156,210,160,210,164,210,172,210,177,210,184,210,185,210,188,210,191,210,192,210,194,210,200,210,201,210,203,210,212,210,216,210,220,210,228,210,229,210,240,210,241,210,244,210,248,210,0,211,1,211,3,211,5,211,12,211,13,211,14,211,16,211,20,211,22,211,28,211,29,211,31,211,32,211,33,211,37,211,40,211,41,211,44,211,48,211,56,211,57,211,59,211,60,211,61,211,68,211,69,211,124,211,125,211,128,211,132,211,140,211,141,211,143,211,144,211,145,211,152,211,153,211,156,211,160,211,168,211,169,211,171,211,173,211,180,211,184,211,188,211,196,211,197,211,200,211,201,211,208,211,216,211,225,211,227,211,236,211,237,211,240,211,244,211,252,211,253,211,255,211,1,212,8,212,29,212,64,212,68,212,92,212,96,212,100,212,109,212,111,212,120,212,121,212,124,212,127,212,128,212,130,212,136,212,137,212,139,212,141,212,148,212,169,212,204,212,208,212,212,212,220,212,223,212,232,212,236,212,240,212,248,212,251,212,253,212,4,213,8,213,12,213,20,213,21,213,23,213,60,213,61,213,64,213,68,213,76,213,77,213,79,213,81,213,88,213,89,213,92,213,96,213,101,213,104,213,105,213,107,213,109,213,116,213,117,213,120,213,124,213,132,213,133,213,135,213,136,213,137,213,144,213,165,213,200,213,201,213,204,213,208,213,210,213,216,213,217,213,219,213,221,213,228,213,229,213,232,213,236,213,244,213,245,213,247,213,249,213,0,214,1,214,4,214,8,214,16,214,17,214,19,214,20,214,21,214,28,214,32,214,36,214,45,214,56,214,57,214,60,214,64,214,69,214,72,214,73,214,75,214,77,214,81,214,84,214,85,214,88,214,92,214,103,214,105,214,112,214,113,214,116,214,131,214,133,214,140,214,141,214,144,214,148,214,157,214,159,214,161,214,168,214,172,214,176,214,185,214,187,214,196,214,197,214,200,214,204,214,209,214,212,214,215,214,217,214,224,214,228,214,232,214,240,214,245,214,252,214,253,214,0,215,4,215,17,215,24,215,25,215,28,215,32,215,40,215,41,215,43,215,45,215,52,215,53,215,56,215,60,215,68,215,71,215,73,215,80,215,81,215,84,215,86,215,87,215,88,215,89,215,96,215,97,215,99,215,101,215,105,215,108,215,112,215,116,215,124,215,125,215,129,215,136,215,137,215,140,215,144,215,152,215,153,215,155,215,157,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61,79,115,79,71,80,249,80,160,82,239,83,117,84,229,84,9,86,193,90,182,91,135,102,182,103,183,103,239,103,76,107,194,115,194,117,60,122,219,130,4,131,87,136,136,136,54,138,200,140,207,141,251,142,230,143,213,153,59,82,116,83,4,84,106,96,100,97,188,107,207,115,26,129,186,137,210,137,163,149,131,79,10,82,190,88,120,89,230,89,114,94,121,94,199,97,192,99,70,103,236,103,127,104,151,111,78,118,11,119,245,120,8,122,255,122,33,124,157,128,110,130,113,130,235,138,147,149,107,78,157,85,247,102,52,110,163,120,237,122,91,132,16,137,78,135,168,151,216,82,78,87,42,88,76,93,31,97,190,97,33,98,98,101,209,103,68,106,27,110,24,117,179,117,227,118,176,119,58,125,175,144,81,148,82,148,149,159,35,83,172,92,50,117,219,128,64,146,152,149,91,82,8,88,220,89,161,92,23,93,183,94,58,95,74,95,119,97,95,108,122,117,134,117,224,124,115,125,177,125,140,127,84,129,33,130,145,133,65,137,27,139,252,146,77,150,71,156,203,78,247,78,11,80,241,81,79,88,55,97,62,97,104,97,57,101,234,105,17,111,165,117,134,118,214,118,135,123,165,130,203,132,0,249,167,147,139,149,128,85,162,91,81,87,1,249,179,124,185,127,181,145,40,80,187,83,69,92,232,93,210,98,110,99,218,100,231,100,32,110,172,112,91,121,221,141,30,142,2,249,125,144,69,146,248,146,126,78,246,78,101,80,254,93,250,94,6,97,87,105,113,129,84,134,71,142,117,147,43,154,94,78,145,80,112,103,64,104,9,81,141,82,146,82,162,106,188,119,16,146,212,158,171,82,47,96,242,143,72,80,169,97,237,99,202,100,60,104,132,106,192,111,136,129,161,137,148,150,5,88,125,114,172,114,4,117,121,125,109,126,169,128,139,137,116,139,99,144,81,157,137,98,122,108,84,111,80,125,58,127,35,138,124,81,74,97,157,123,25,139,87,146,140,147,172,78,211,79,30,80,190,80,6,81,193,82,205,82,127,83,112,87,131,88,154,94,145,95,118,97,172,97,206,100,108,101,111,102,187,102,244,102,151,104,135,109,133,112,241,112,159,116,165,116,202,116,217,117,108,120,236,120,223,122,246,122,69,125,147,125,21,128,63,128,27,129,150,131,102,139,21,143,21,144,225,147,3,152,56,152,90,154,232,155,194,79,83,85,58,88,81,89,99,91,70,92,184,96,18,98,66,104,176,104,232,104,170,110,76,117,120,118,206,120,61,122,251,124,107,126,124,126,8,138,161,138,63,140,142,150,196,157,228,83,233,83,74,84,113,84,250,86,209,89,100,91,59,92,171,94,247,98,55,101,69,101,114,101,160,102,175,103,193,105,189,108,252,117,144,118,126,119,63,122,148,127,3,128,161,128,143,129,230,130,253,130,240,131,193,133,49,136,180,136,165,138,3,249,156,143,46,147,199,150,103,152,216,154,19,159,237,84,155,101,242,102,143,104,64,122,55,140,96,157,240,86,100,87,17,93,6,102,177,104,205,104,254,110,40,116,158,136,228,155,104,108,4,249,168,154,155,79,108,81,113,81,159,82,84,91,229,93,80,96,109,96,241,98,167,99,59,101,217,115,122,122,163,134,162,140,143,151,50,78,225,91,8,98,156,103,220,116,209,121,211,131,135,138,178,138,232,141,78,144,75,147,70,152,211,94,232,105,255,133,237,144,5,249,160,81,152,91,236,91,99,97,250,104,62,107,76,112,47,116,216,116,161,123,80,127,197,131,192,137,171,140,220,149,40,153,46,82,93,96,236,98,2,144,138,79,73,81,33,83,217,88,227,94,224,102,56,109,154,112,194,114,214,115,80,123,241,128,91,148,102,83,155,99,107,127,86,78,128,80,74,88,222,88,42,96,39,97,208,98,208,105,65,155,143,91,24,125,177,128,95,143,164,78,209,80,172,84,172,85,12,91,160,93,231,93,42,101,78,101,33,104,75,106,225,114,142,118,239,119,94,125,249,127,160,129,78,133,223,134,3,143,78,143,202,144,3,153,85,154,171,155,24,78,69,78,93,78,199,78,241,79,119,81,254,82,64,83,227,83,229,83,142,84,20,86,117,87,162,87,199,91,135,93,208,94,252,97,216,98,81,101,184,103,233,103,203,105,80,107,198,107,236,107,66,108,157,110,120,112,215,114,150,115,3,116,191,119,233,119,118,122,127,125,9,128,252,129,5,130,10,130,223,130,98,136,51,139,252,140,192,142,17,144,177,144,100,146,182,146,210,153,69,154,233,156,215,157,156,159,11,87,64,92,202,131,160,151,171,151,180,158,27,84,152,122,164,127,217,136,205,142,225,144,0,88,72,92,152,99,159,122,174,91,19,95,121,122,174,122,142,130,172,142,38,80,56,82,248,82,119,83,8,87,243,98,114,99,10,107,195,109,55,119,165,83,87,115,104,133,118,142,213,149,58,103,195,106,112,111,109,138,204,142,75,153,6,249,119,102,120,107,180,140,60,155,7,249,235,83,45,87,78,89,198,99,251,105,234,115,69,120,186,122,197,122,254,124,117,132,143,137,115,141,53,144,168,149,251,82,71,87,71,117,96,123,204,131,30,146,8,249,88,106,75,81,75,82,135,82,31,98,216,104,117,105,153,150,197,80,164,82,228,82,195,97,164,101,57,104,255,105,126,116,75,123,185,130,235,131,178,137,57,139,209,143,73,153,9,249,202,78,151,89,210,100,17,102,142,106,52,116,129,121,189,121,169,130,126,136,127,136,95,137,10,249,38,147,11,79,202,83,37,96,113,98,114,108,26,125,102,125,152,78,98,81,220,119,175,128,1,79,14,79,118,81,128,81,220,85,104,86,59,87,250,87,252,87,20,89,71,89,147,89,196,91,144,92,14,93,241,93,126,94,204,95,128,98,215,101,227,101,30,103,31,103,94,103,203,104,196,104,95,106,58,107,35,108,125,108,130,108,199,109,152,115,38,116,42,116,130,116,163,116,120,117,127,117,129,120,239,120,65,121,71,121,72,121,122,121,149,123,0,125,186,125,136,127,6,128,45,128,140,128,24,138,79,139,72,140,119,141,33,147,36,147,226,152,81,153,14,154,15,154,101,154,146,158,202,125,118,79,9,84,238,98,84,104,209,145,171,85,58,81,11,249,12,249,28,90,230,97,13,249,207,98,255,98,14,249,15,249,16,249,17,249,18,249,19,249,163,144,20,249,21,249,22,249,23,249,24,249,254,138,25,249,26,249,27,249,28,249,150,102,29,249,86,113,30,249,31,249,227,150,32,249,79,99,122,99,87,83,33,249,143,103,96,105,115,110,34,249,55,117,35,249,36,249,37,249,13,125,38,249,39,249,114,136,202,86,24,90,40,249,41,249,42,249,43,249,44,249,67,78,45,249,103,81,72,89,240,103,16,128,46,249,115,89,116,94,154,100,202,121,245,95,108,96,200,98,123,99,231,91,215,91,170,82,47,249,116,89,41,95,18,96,48,249,49,249,50,249,89,116,51,249,52,249,53,249,54,249,55,249,56,249,209,153,57,249,58,249,59,249,60,249,61,249,62,249,63,249,64,249,65,249,66,249,67,249,195,111,68,249,69,249,191,129,178,143,241,96,70,249,71,249,102,129,72,249,73,249,63,92,74,249,75,249,76,249,77,249,78,249,79,249,80,249,81,249,233,90,37,138,123,103,16,125,82,249,83,249,84,249,85,249,86,249,87,249,253,128,88,249,89,249,60,92,229,108,63,83,186,110,26,89,54,131,57,78,182,78,70,79,174,85,24,87,199,88,86,95,183,101,230,101,128,106,181,107,77,110,237,119,239,122,30,124,222,125,203,134,146,136,50,145,91,147,187,100,190,111,122,115,184,117,84,144,86,85,77,87,186,97,212,100,199,102,225,109,91,110,109,111,185,111,240,117,67,128,189,129,65,133,131,137,199,138,90,139,31,147,147,108,83,117,84,123,15,142,93,144,16,85,2,88,88,88,98,94,7,98,158,100,224,104,118,117,214,124,179,135,232,158,227,78,136,87,110,87,39,89,13,92,177,92,54,94,133,95,52,98,225,100,179,115,250,129,139,136,184,140,138,150,219,158,133,91,183,95,179,96,18,80,0,82,48,82,22,87,53,88,87,88,14,92,96,92,246,92,139,93,166,94,146,95,188,96,17,99,137,99,23,100,67,104,249,104,194,106,216,109,33,110,212,110,228,111,254,113,220,118,121,119,177,121,59,122,4,132,169,137,237,140,243,141,72,142,3,144,20,144,83,144,253,144,77,147,118,150,220,151,210,107,6,112,88,114,162,114,104,115,99,119,191,121,228,123,155,126,128,139,169,88,199,96,102,101,253,101,190,102,140,108,30,113,201,113,90,140,19,152,109,78,129,122,221,78,172,81,205,81,213,82,12,84,167,97,113,103,80,104,223,104,30,109,124,111,188,117,179,119,229,122,244,128,99,132,133,146,92,81,151,101,92,103,147,103,216,117,199,122,115,131,90,249,70,140,23,144,45,152,111,92,192,129,154,130,65,144,111,144,13,146,151,95,157,93,89,106,200,113,123,118,73,123,228,133,4,139,39,145,48,154,135,85,246,97,91,249,105,118,133,127,63,134,186,135,248,136,143,144,92,249,27,109,217,112,222,115,97,125,61,132,93,249,106,145,241,153,94,249,130,78,117,83,4,107,18,107,62,112,27,114,45,134,30,158,76,82,163,143,80,93,229,100,44,101,22,107,235,111,67,124,156,126,205,133,100,137,189,137,201,98,216,129,31,136,202,94,23,103,106,109,252,114,5,116,111,116,130,135,222,144,134,79,13,93,160,95,10,132,183,81,160,99,101,117,174,78,6,80,105,81,201,81,129,104,17,106,174,124,177,124,231,124,111,130,210,138,27,143,207,145,182,79,55,81,245,82,66,84,236,94,110,97,62,98,197,101,218,106,254,111,42,121,220,133,35,136,173,149,98,154,106,154,151,158,206,158,155,82,198,102,119,107,29,112,43,121,98,143,66,151,144,97,0,98,35,101,35,111,73,113,137,116,244,125,111,128,238,132,38,143,35,144,74,147,189,81,23,82,163,82,12,109,200,112,194,136,201,94,130,101,174,107,194,111,62,124,117,115,228,78,54,79,249,86,95,249,186,92,186,93,28,96,178,115,45,123,154,127,206,127,70,128,30,144,52,146,246,150,72,151,24,152,97,159,139,79,167,111,174,121,180,145,183,150,222,82,96,249,136,100,196,100,211,106,94,111,24,112,16,114,231,118,1,128,6,134,92,134,239,141,5,143,50,151,111,155,250,157,117,158,140,120,127,121,160,125,201,131,4,147,127,158,147,158,214,138,223,88,4,95,39,103,39,112,207,116,96,124,126,128,33,81,40,112,98,114,202,120,194,140,218,140,244,140,247,150,134,78,218,80,238,91,214,94,153,101,206,113,66,118,173,119,74,128,252,132,124,144,39,155,141,159,216,88,65,90,98,92,19,106,218,109,15,111,59,118,47,125,55,126,30,133,56,137,228,147,75,150,137,82,210,101,243,103,180,105,65,109,156,110,15,112,9,116,96,116,89,117,36,118,107,120,44,139,94,152,109,81,46,98,120,150,150,79,43,80,25,93,234,109,184,125,42,143,139,95,68,97,23,104,97,249,134,150,210,82,139,128,220,81,204,81,94,105,28,122,190,125,241,131,117,150,218,79,41,82,152,83,15,84,14,85,101,92,167,96,78,103,168,104,108,109,129,114,248,114,6,116,131,116,98,249,226,117,108,124,121,127,184,127,137,131,207,136,225,136,204,145,208,145,226,150,201,155,29,84,126,111,208,113,152,116,250,133,170,142,163,150,87,156,159,158,151,103,203,109,51,116,232,129,22,151,44,120,203,122,32,123,146,124,105,100,106,116,242,117,188,120,232,120,172,153,84,155,187,158,222,91,85,94,32,111,156,129,171,131,136,144,7,78,77,83,41,90,210,93,78,95,98,97,61,99,105,102,252,102,255,110,43,111,99,112,158,119,44,132,19,133,59,136,19,143,69,153,59,156,28,85,185,98,43,103,171,108,9,131,106,137,122,151,161,78,132,89,216,95,217,95,27,103,178,125,84,127,146,130,43,131,189,131,30,143,153,144,203,87,185,89,146,90,208,91,39,102,154,103,133,104,207,107,100,113,117,127,183,140,227,140,129,144,69,155,8,129,138,140,76,150,64,154,165,158,95,91,19,108,27,115,242,118,223,118,12,132,170,81,147,137,77,81,149,81,201,82,201,104,148,108,4,119,32,119,191,125,236,125,98,151,181,158,197,110,17,133,165,81,13,84,125,84,14,102,157,102,39,105,159,110,191,118,145,119,23,131,194,132,159,135,105,145,152,146,244,156,130,136,174,79,146,81,223,82,198,89,61,94,85,97,120,100,121,100,174,102,208,103,33,106,205,107,219,107,95,114,97,114,65,116,56,119,219,119,23,128,188,130,5,131,0,139,40,139,140,140,40,103,144,108,103,114,238,118,102,119,70,122,169,157,127,107,146,108,34,89,38,103,153,132,111,83,147,88,153,89,223,94,207,99,52,102,115,103,58,110,43,115,215,122,215,130,40,147,217,82,235,93,174,97,203,97,10,98,199,98,171,100,224,101,89,105,102,107,203,107,33,113,247,115,93,117,70,126,30,130,2,131,106,133,163,138,191,140,39,151,97,157,168,88,216,158,17,80,14,82,59,84,79,85,135,101,118,108,10,125,11,125,94,128,138,134,128,149,239,150,255,82,149,108,105,114,115,84,154,90,62,92,75,93,76,95,174,95,42,103,182,104,99,105,60,110,68,110,9,119,115,124,142,127,135,133,14,139,247,143,97,151,244,158,183,92,182,96,13,97,171,97,79,101,251,101,252,101,17,108,239,108,159,115,201,115,225,125,148,149,198,91,28,135,16,139,93,82,90,83,205,98,15,100,178,100,52,103,56,106,202,108,192,115,158,116,148,123,149,124,27,126,138,129,54,130,132,133,235,143,249,150,193,153,52,79,74,83,205,83,219,83,204,98,44,100,0,101,145,101,195,105,238,108,88,111,237,115,84,117,34,118,228,118,252,118,208,120,251,120,44,121,70,125,44,130,224,135,212,143,18,152,239,152,195,82,212,98,165,100,36,110,81,111,124,118,203,141,177,145,98,146,238,154,67,155,35,80,141,80,74,87,168,89,40,92,71,94,119,95,63,98,62,101,185,101,193,101,9,102,139,103,156,105,194,110,197,120,33,125,170,128,128,129,43,130,179,130,161,132,140,134,42,138,23,139,166,144,50,150,144,159,13,80,243,79,99,249,249,87,152,95,220,98,146,99,111,103,67,110,25,113,195,118,204,128,218,128,244,136,245,136,25,137,224,140,41,143,77,145,106,150,47,79,112,79,27,94,207,103,34,104,125,118,126,118,68,155,97,94,10,106,105,113,212,113,106,117,100,249,65,126,67,133,233,133,220,152,16,79,79,123,112,127,165,149,225,81,6,94,181,104,62,108,78,108,219,108,175,114,196,123,3,131,213,108,58,116,251,80,136,82,193,88,216,100,151,106,167,116,86,118,167,120,23,134,226,149,57,151,101,249,94,83,1,95,138,139,168,143,175,143,138,144,37,82,165,119,73,156,8,159,25,78,2,80,117,81,91,92,119,94,30,102,58,102,196,103,197,104,179,112,1,117,197,117,201,121,221,122,39,143,32,153,8,154,221,79,33,88,49,88,246,91,110,102,101,107,17,109,122,110,125,111,228,115,43,117,233,131,220,136,19,137,92,139,20,143,15,79,213,80,16,83,92,83,147,91,169,95,13,103,143,121,121,129,47,131,20,133,7,137,134,137,57,143,59,143,165,153,18,156,44,103,118,78,248,79,73,89,1,92,239,92,240,92,103,99,210,104,253,112,162,113,43,116,43,126,236,132,2,135,34,144,210,146,243,156,13,78,216,78,239,79,133,80,86,82,111,82,38,84,144,84,224,87,43,89,102,90,90,91,117,91,204,91,156,94,102,249,118,98,119,101,167,101,110,109,165,110,54,114,38,123,63,124,54,127,80,129,81,129,154,129,64,130,153,130,169,131,3,138,160,140,230,140,251,140,116,141,186,141,232,144,220,145,28,150,68,150,217,153,231,156,23,83,6,82,41,84,116,86,179,88,84,89,110,89,255,95,164,97,110,98,16,102,126,108,26,113,198,118,137,124,222,124,27,125,172,130,193,140,240,150,103,249,91,79,23,95,127,95,194,98,41,93,11,103,218,104,124,120,67,126,108,157,21,78,153,80,21,83,42,83,81,83,131,89,98,90,135,94,178,96,138,97,73,98,121,98,144,101,135,103,167,105,212,107,214,107,215,107,216,107,184,108,104,249,53,116,250,117,18,120,145,120,213,121,216,121,131,124,203,125,225,127,165,128,62,129,194,129,242,131,26,135,232,136,185,138,108,139,187,140,25,145,94,151,219,152,59,159,172,86,42,91,108,95,140,101,179,106,175,107,92,109,241,111,21,112,93,114,173,115,167,140,211,140,59,152,145,97,55,108,88,128,1,154,77,78,139,78,155,78,213,78,58,79,60,79,127,79,223,79,255,80,242,83,248,83,6,85,227,85,219,86,235,88,98,89,17,90,235,91,250,91,4,92,243,93,43,94,153,95,29,96,104,99,156,101,175,101,246,103,251,103,173,104,123,107,153,108,215,108,35,110,9,112,69,115,2,120,62,121,64,121,96,121,193,121,233,123,23,125,114,125,134,128,13,130,142,131,209,132,199,134,223,136,80,138,94,138,29,139,220,140,102,141,173,143,170,144,252,152,223,153,157,158,74,82,105,249,20,103,106,249,152,80,42,82,113,92,99,101,85,108,202,115,35,117,157,117,151,123,156,132,120,145,48,151,119,78,146,100,186,107,94,113,169,133,9,78,107,249,73,103,238,104,23,110,159,130,24,133,107,136,247,99,129,111,18,146,175,152,10,78,183,80,207,80,31,81,70,85,170,85,23,86,64,91,25,92,224,92,56,94,138,94,160,94,194,94,243,96,81,104,97,106,88,110,61,114,64,114,192,114,248,118,101,121,177,123,212,127,243,136,244,137,115,138,97,140,222,140,28,151,94,88,189,116,253,140,199,85,108,249,97,122,34,125,114,130,114,114,31,117,37,117,109,249,25,123,133,88,251,88,188,93,143,94,182,94,144,95,85,96,146,98,127,99,77,101,145,102,217,102,248,102,22,104,242,104,128,114,94,116,110,123,110,125,214,125,114,127,229,128,18,130,175,133,127,137,147,138,29,144,228,146,205,158,32,159,21,89,109,89,45,94,220,96,20,102,115,102,144,103,80,108,197,109,95,111,243,119,169,120,198,132,203,145,43,147,217,78,202,80,72,81,132,85,11,91,163,91,71,98,126,101,203,101,50,110,125,113,1,116,68,116,135,116,191,116,108,118,170,121,218,125,85,126,168,127,122,129,179,129,57,130,26,134,236,135,117,138,227,141,120,144,145,146,37,148,77,153,174,155,104,83,81,92,84,105,196,108,41,109,43,110,12,130,155,133,59,137,45,138,170,138,234,150,103,159,97,82,185,102,178,107,150,126,254,135,13,141,131,149,93,150,29,101,137,109,238,113,110,249,206,87,211,89,172,91,39,96,250,96,16,98,31,102,95,102,41,115,249,115,219,118,1,119,108,123,86,128,114,128,101,129,160,138,146,145,22,78,226,82,114,107,23,109,5,122,57,123,48,125,111,249,176,140,236,83,47,86,81,88,181,91,15,92,17,92,226,93,64,98,131,99,20,100,45,102,179,104,188,108,136,109,175,110,31,112,164,112,210,113,38,117,143,117,142,117,25,118,17,123,224,123,43,124,32,125,57,125,44,133,109,133,7,134,52,138,13,144,97,144,181,144,183,146,246,151,55,154,215,79,108,92,95,103,145,109,159,124,140,126,22,139,22,141,31,144,107,91,253,93,13,100,192,132,92,144,225,152,135,115,139,91,154,96,126,103,222,109,31,138,166,138,1,144,12,152,55,82,112,249,81,112,142,120,150,147,112,136,215,145,238,79,215,83,253,85,218,86,130,87,253,88,194,90,136,91,171,92,192,92,37,94,1,97,13,98,75,98,136,99,28,100,54,101,120,101,57,106,138,107,52,108,25,109,49,111,231,113,233,114,120,115,7,116,178,116,38,118,97,119,192,121,87,122,234,122,185,124,143,125,172,125,97,126,158,127,41,129,49,131,144,132,218,132,234,133,150,136,176,138,144,139,56,143,66,144,131,144,108,145,150,146,185,146,139,150,167,150,168,150,214,150,0,151,8,152,150,153,211,154,26,155,212,83,126,88,25,89,112,91,191,91,209,109,90,111,159,113,33,116,185,116,133,128,253,131,225,93,135,95,170,95,66,96,236,101,18,104,111,105,83,106,137,107,53,109,243,109,227,115,254,118,172,119,77,123,20,125,35,129,28,130,64,131,244,132,99,133,98,138,196,138,135,145,30,147,6,152,180,153,12,98,83,136,240,143,101,146,7,93,39,93,105,93,95,116,157,129,104,135,213,111,254,98,210,127,54,137,114,137,30,78,88,78,231,80,221,82,71,83,127,98,7,102,105,126,5,136,94,150,141,79,25,83,54,86,203,89,164,90,56,92,78,92,77,92,2,94,17,95,67,96,189,101,47,102,66,102,190,103,244,103,28,115,226,119,58,121,197,127,148,132,205,132,150,137,102,138,105,138,225,138,85,140,122,140,244,87,212,91,15,95,111,96,237,98,13,105,150,107,92,110,132,113,210,123,85,135,88,139,254,142,223,152,254,152,56,79,129,79,225,79,123,84,32,90,184,91,60,97,176,101,104,102,252,113,51,117,94,121,51,125,78,129,227,129,152,131,170,133,206,133,3,135,10,138,171,142,155,143,113,249,197,143,49,89,164,91,230,91,137,96,233,91,11,92,195,95,129,108,114,249,241,109,11,112,26,117,175,130,246,138,192,78,65,83,115,249,217,150,15,108,158,78,196,79,82,81,94,85,37,90,232,92,17,98,89,114,189,130,170,131,254,134,89,136,29,138,63,150,197,150,19,153,9,157,93,157,10,88,179,92,189,93,68,94,225,96,21,97,225,99,2,106,37,110,2,145,84,147,78,152,16,156,119,159,137,91,184,92,9,99,79,102,72,104,60,119,193,150,141,151,84,152,159,155,161,101,1,139,203,142,188,149,53,85,169,92,214,93,181,94,151,102,76,118,244,131,199,149,211,88,188,98,206,114,40,157,240,78,46,89,15,96,59,102,131,107,231,121,38,157,147,83,192,84,195,87,22,93,27,97,214,102,175,109,141,120,126,130,152,150,68,151,132,83,124,98,150,99,178,109,10,126,75,129,77,152,251,106,76,127,175,157,26,158,95,78,59,80,182,81,28,89,249,96,246,99,48,105,58,114,54,128,116,249,206,145,49,95,117,249,118,249,4,125,229,130,111,132,187,132,229,133,141,142,119,249,111,79,120,249,121,249,228,88,67,91,89,96,218,99,24,101,109,101,152,102,122,249,74,105,35,106,11,109,1,112,108,113,210,117,13,118,179,121,112,122,123,249,138,127,124,249,68,137,125,249,147,139,192,145,125,150,126,249,10,153,4,87,161,95,188,101,1,111,0,118,166,121,158,138,173,153,90,155,108,159,4,81,182,97,145,98,141,106,198,129,67,80,48,88,102,95,9,113,0,138,250,138,124,91,22,134,250,79,60,81,180,86,68,89,169,99,249,109,170,93,109,105,134,81,136,78,89,79,127,249,128,249,129,249,130,89,130,249,131,249,95,107,93,108,132,249,181,116,22,121,133,249,7,130,69,130,57,131,63,143,93,143,134,249,24,153,135,249,136,249,137,249,166,78,138,249,223,87,121,95,19,102,139,249,140,249,171,117,121,126,111,139,141,249,6,144,91,154,165,86,39,88,248,89,31,90,180,91,142,249,246,94,143,249,144,249,80,99,59,99,145,249,61,105,135,108,191,108,142,109,147,109,245,109,20,111,146,249,223,112,54,113,89,113,147,249,195,113,213,113,148,249,79,120,111,120,149,249,117,123,227,125,150,249,47,126,151,249,77,136,223,142,152,249,153,249,154,249,91,146,155,249,246,156,156,249,157,249,158,249,133,96,133,109,159,249,177,113,160,249,161,249,177,149,173,83,162,249,163,249,164,249,211,103,165,249,142,112,48,113,48,116,118,130,210,130,166,249,187,149,229,154,125,158,196,102,167,249,193,113,73,132,168,249,169,249,75,88,170,249,171,249,184,93,113,95,172,249,32,102,142,102,121,105,174,105,56,108,243,108,54,110,65,111,218,111,27,112,47,112,80,113,223,113,112,115,173,249,91,116,174,249,212,116,200,118,78,122,147,126,175,249,176,249,241,130,96,138,206,143,177,249,72,147,178,249,25,151,179,249,180,249,66,78,42,80,181,249,8,82,225,83,243,102,109,108,202,111,10,115,127,119,98,122,174,130,221,133,2,134,182,249,212,136,99,138,125,139,107,140,183,249,179,146,184,249,19,151,16,152,148,78,13,79,201,79,178,80,72,83,62,84,51,84,218,85,98,88,186,88,103,89,27,90,228,91,159,96,185,249,202,97,86,101,255,101,100,102,167,104,90,108,179,111,207,112,172,113,82,115,125,123,8,135,164,138,50,156,7,159,75,92,131,108,68,115,137,115,58,146,171,110,101,116,31,118,105,122,21,126,10,134,64,81,197,88,193,100,238,116,21,117,112,118,193,127,149,144,205,150,84,153,38,110,230,116,169,122,170,122,229,129,217,134,120,135,27,138,73,90,140,91,155,91,161,104,0,105,99,109,169,115,19,116,44,116,151,120,233,125,235,127,24,129,85,129,158,131,76,140,46,150,17,152,240,102,128,95,250,101,137,103,106,108,139,115,45,80,3,90,106,107,238,119,22,89,108,93,205,93,37,115,79,117,186,249,187,249],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+312548),
	allocate([229,80,249,81,47,88,45,89,150,89,218,89,229,91,188,249,189,249,162,93,215,98,22,100,147,100,254,100,190,249,220,102,191,249,72,106,192,249,255,113,100,116,193,249,136,122,175,122,71,126,94,126,0,128,112,129,194,249,239,135,129,137,32,139,89,144,195,249,128,144,82,153,126,97,50,107,116,109,31,126,37,137,177,143,209,79,173,80,151,81,199,82,199,87,137,88,185,91,184,94,66,97,149,105,140,109,103,110,182,110,148,113,98,116,40,117,44,117,115,128,56,131,201,132,10,142,148,147,222,147,196,249,142,78,81,79,118,80,42,81,200,83,203,83,243,83,135,91,211,91,36,92,26,97,130,97,244,101,91,114,151,115,64,116,194,118,80,121,145,121,185,121,6,125,189,127,139,130,213,133,94,134,194,143,71,144,245,144,234,145,133,150,232,150,233,150,214,82,103,95,237,101,49,102,47,104,92,113,54,122,193,144,10,152,145,78,197,249,82,106,158,107,144,111,137,113,24,128,184,130,83,133,75,144,149,150,242,150,251,151,26,133,49,155,144,78,138,113,196,150,67,81,159,83,225,84,19,87,18,87,163,87,155,90,196,90,195,91,40,96,63,97,244,99,133,108,57,109,114,110,144,110,48,114,63,115,87,116,209,130,129,136,69,143,96,144,198,249,98,150,88,152,27,157,8,103,138,141,94,146,77,79,73,80,222,80,113,83,13,87,212,89,1,90,9,92,112,97,144,102,45,110,50,114,75,116,239,125,195,128,14,132,102,132,63,133,95,135,91,136,24,137,2,139,85,144,203,151,79,155,115,78,145,79,18,81,106,81,199,249,47,85,169,85,122,91,165,91,124,94,125,94,190,94,160,96,223,96,8,97,9,97,196,99,56,101,9,103,200,249,212,103,218,103,201,249,97,105,98,105,185,108,39,109,202,249,56,110,203,249,225,111,54,115,55,115,204,249,92,116,49,117,205,249,82,118,206,249,207,249,173,125,254,129,56,132,213,136,152,138,219,138,237,138,48,142,66,142,74,144,62,144,122,144,73,145,201,145,110,147,208,249,209,249,9,88,210,249,211,107,137,128,178,128,211,249,212,249,65,81,107,89,57,92,213,249,214,249,100,111,167,115,228,128,7,141,215,249,23,146,143,149,216,249,217,249,218,249,219,249,127,128,14,98,28,112,104,125,141,135,220,249,160,87,105,96,71,97,183,107,190,138,128,146,177,150,89,78,31,84,235,109,45,133,112,150,243,151,238,152,214,99,227,108,145,144,221,81,201,97,186,129,249,157,157,79,26,80,0,81,156,91,15,97,255,97,236,100,5,105,197,107,145,117,227,119,169,127,100,130,143,133,251,135,99,136,188,138,112,139,171,145,140,78,229,78,10,79,221,249,222,249,55,89,232,89,223,249,242,93,27,95,91,95,33,96,224,249,225,249,226,249,227,249,62,114,229,115,228,249,112,117,205,117,229,249,251,121,230,249,12,128,51,128,132,128,225,130,81,131,231,249,232,249,189,140,179,140,135,144,233,249,234,249,244,152,12,153,235,249,236,249,55,112,202,118,202,127,204,127,252,127,26,139,186,78,193,78,3,82,112,83,237,249,189,84,224,86,251,89,197,91,21,95,205,95,110,110,238,249,239,249,106,125,53,131,240,249,147,134,141,138,241,249,109,151,119,151,242,249,243,249,0,78,90,79,126,79,249,88,229,101,162,110,56,144,176,147,185,153,251,78,236,88,138,89,217,89,65,96,244,249,245,249,20,122,246,249,79,131,195,140,101,81,68,83,247,249,248,249,249,249,205,78,105,82,85,91,191,130,212,78,58,82,168,84,201,89,255,89,80,91,87,91,92,91,99,96,72,97,203,110,153,112,110,113,134,115,247,116,181,117,193,120,43,125,5,128,234,129,40,131,23,133,201,133,238,138,199,140,204,150,92,79,250,82,188,86,171,101,40,102,124,112,184,112,53,114,189,125,141,130,76,145,192,150,114,157,113,91,231,104,152,107,122,111,222,118,145,92,171,102,91,111,180,123,42,124,54,136,220,150,8,78,215,78,32,83,52,88,187,88,239,88,108,89,7,92,51,94,132,94,53,95,140,99,178,102,86,103,31,106,163,106,12,107,63,111,70,114,250,249,80,115,139,116,224,122,167,124,120,129,223,129,231,129,138,131,108,132,35,133,148,133,207,133,221,136,19,141,172,145,119,149,156,150,141,81,201,84,40,87,176,91,77,98,80,103,61,104,147,104,61,110,211,110,125,112,33,126,193,136,161,140,9,143,75,159,78,159,45,114,143,123,205,138,26,147,71,79,78,79,50,81,128,84,208,89,149,94,181,98,117,103,110,105,23,106,174,108,26,110,217,114,42,115,189,117,184,123,53,125,231,130,249,131,87,132,247,133,91,138,175,140,135,142,25,144,184,144,206,150,95,159,227,82,10,84,225,90,194,91,88,100,117,101,244,110,196,114,251,249,132,118,77,122,27,123,77,124,62,126,223,127,123,131,43,139,202,140,100,141,225,141,95,142,234,143,249,143,105,144,209,147,67,79,122,79,179,80,104,81,120,81,77,82,106,82,97,88,124,88,96,89,8,92,85,92,219,94,155,96,48,98,19,104,191,107,8,108,177,111,78,113,32,116,48,117,56,117,81,117,114,118,76,123,139,123,173,123,198,123,143,126,110,138,62,143,73,143,63,146,147,146,34,147,43,148,251,150,90,152,107,152,30,153,7,82,42,98,152,98,89,109,100,118,202,122,192,123,118,125,96,83,190,92,151,94,56,111,185,112,152,124,17,151,142,155,222,158,165,99,122,100,118,135,1,78,149,78,173,78,92,80,117,80,72,84,195,89,154,91,64,94,173,94,247,94,129,95,197,96,58,99,63,101,116,101,204,101,118,102,120,102,254,103,104,105,137,106,99,107,64,108,192,109,232,109,31,110,94,110,30,112,161,112,142,115,253,115,58,117,91,119,135,120,142,121,11,122,125,122,190,124,142,125,71,130,2,138,234,138,158,140,45,145,74,145,216,145,102,146,204,146,32,147,6,151,86,151,92,151,2,152,14,159,54,82,145,82,124,85,36,88,29,94,31,95,140,96,208,99,175,104,223,111,109,121,44,123,205,129,186,133,253,136,248,138,68,142,141,145,100,150,155,150,61,151,76,152,74,159,206,79,70,81,203,81,169,82,50,86,20,95,107,95,170,99,205,100,233,101,65,102,250,102,249,102,29,103,157,104,215,104,253,105,21,111,110,111,103,113,229,113,42,114,170,116,58,119,86,121,90,121,223,121,32,122,149,122,151,124,223,124,68,125,112,126,135,128,251,133,164,134,84,138,191,138,153,141,129,142,32,144,109,144,227,145,59,150,213,150,229,156,207,101,7,124,179,141,195,147,88,91,10,92,82,83,217,98,29,115,39,80,151,91,158,95,176,96,107,97,213,104,217,109,46,116,46,122,66,125,156,125,49,126,107,129,42,142,53,142,126,147,24,148,80,79,80,87,230,93,167,94,43,99,106,127,59,78,79,79,143,79,90,80,221,89,196,128,106,84,104,84,254,85,79,89,153,91,222,93,218,94,93,102,49,103,241,103,42,104,232,108,50,109,74,110,141,111,183,112,224,115,135,117,76,124,2,125,44,125,162,125,31,130,219,134,59,138,133,138,112,141,138,142,51,143,49,144,78,145,82,145,68,148,208,153,249,122,165,124,202,79,1,81,198,81,200,87,239,91,251,92,89,102,61,106,90,109,150,110,236,111,12,113,111,117,227,122,34,136,33,144,117,144,203,150,255,153,1,131,45,78,242,78,70,136,205,145,125,83,219,106,107,105,65,108,122,132,158,88,142,97,254,102,239,98,221,112,17,117,199,117,82,126,184,132,73,139,8,141,75,78,234,83,171,84,48,87,64,87,215,95,1,99,7,99,111,100,47,101,232,101,122,102,157,103,179,103,98,107,96,108,154,108,44,111,229,119,37,120,73,121,87,121,25,125,162,128,2,129,243,129,157,130,183,130,24,135,140,138,252,249,4,141,190,141,114,144,244,118,25,122,55,122,84,126,119,128,7,85,212,85,117,88,47,99,34,100,73,102,75,102,109,104,155,105,132,107,37,109,177,110,205,115,104,116,161,116,91,117,185,117,225,118,30,119,139,119,230,121,9,126,29,126,251,129,47,133,151,136,58,138,209,140,235,142,176,143,50,144,173,147,99,150,115,150,7,151,132,79,241,83,234,89,201,90,25,94,78,104,198,116,190,117,233,121,146,122,163,129,237,134,234,140,204,141,237,143,159,101,21,103,253,249,247,87,87,111,221,125,47,143,246,147,198,150,181,95,242,97,132,111,20,78,152,79,31,80,201,83,223,85,111,93,238,93,33,107,100,107,203,120,154,123,254,249,73,142,202,142,110,144,73,99,62,100,64,119,132,122,47,147,127,148,106,159,176,100,175,111,230,113,168,116,218,116,196,122,18,124,130,126,178,124,152,126,154,139,10,141,125,148,16,153,76,153,57,82,223,91,230,100,45,103,46,125,237,80,195,83,121,88,88,97,89,97,250,97,172,101,217,122,146,139,150,139,9,80,33,80,117,82,49,85,60,90,224,94,112,95,52,97,94,101,12,102,54,102,162,102,205,105,196,110,50,111,22,115,33,118,147,122,57,129,89,130,214,131,188,132,181,80,240,87,192,91,232,91,105,95,161,99,38,120,181,125,220,131,33,133,199,145,245,145,138,81,245,103,86,123,172,140,196,81,187,89,189,96,85,134,28,80,255,249,84,82,58,92,125,97,26,98,211,98,242,100,165,101,204,110,32,118,10,129,96,142,95,150,187,150,223,78,67,83,152,85,41,89,221,93,197,100,201,108,250,109,148,115,127,122,27,130,166,133,228,140,16,142,119,144,231,145,225,149,33,150,198,151,248,81,242,84,134,85,185,95,164,100,136,111,180,125,31,143,77,143,53,148,201,80,22,92,190,108,251,109,27,117,187,119,61,124,100,124,121,138,194,138,30,88,190,89,22,94,119,99,82,114,138,117,107,119,220,138,188,140,18,143,243,94,116,102,248,109,125,128,193,131,203,138,81,151,214,155,0,250,67,82,255,102,149,109,239,110,224,125,230,138,46,144,94,144,212,154,29,82,127,82,232,84,148,97,132,98,219,98,162,104,18,105,90,105,53,106,146,112,38,113,93,120,1,121,14,121,210,121,13,122,150,128,120,130,213,130,73,131,73,133,130,140,133,141,98,145,139,145,174,145,195,79,209,86,237,113,215,119,0,135,248,137,248,91,214,95,81,103,168,144,226,83,90,88,245,91,164,96,129,97,96,100,61,126,112,128,37,133,131,146,174,100,172,80,20,93,0,103,156,88,189,98,168,99,14,105,120,105,30,106,107,110,186,118,203,121,187,130,41,132,207,138,168,141,253,143,18,145,75,145,156,145,16,147,24,147,154,147,219,150,54,154,13,156,17,78,92,117,93,121,250,122,81,123,201,123,46,126,196,132,89,142,116,142,248,142,16,144,37,102,63,105,67,116,250,81,46,103,220,158,69,81,224,95,150,108,242,135,93,136,119,136,180,96,181,129,3,132,5,141,214,83,57,84,52,86,54,90,49,92,138,112,224,127,90,128,6,129,237,129,163,141,137,145,95,154,242,157,116,80,196,78,160,83,251,96,44,110,100,92,136,79,36,80,228,85,217,92,95,94,101,96,148,104,187,108,196,109,190,113,212,117,244,117,97,118,26,122,73,122,199,125,251,125,110,127,244,129,169,134,28,143,201,150,179,153,82,159,71,82,197,82,237,152,170,137,3,78,210,103,6,111,181,79,226,91,149,103,136,108,120,109,27,116,39,120,221,145,124,147,196,135,228,121,49,122,235,95,214,78,164,84,62,85,174,88,165,89,240,96,83,98,214,98,54,103,85,105,53,130,64,150,177,153,221,153,44,80,83,83,68,85,124,87,1,250,88,98,2,250,226,100,107,102,221,103,193,111,239,111,34,116,56,116,23,138,56,148,81,84,6,86,102,87,72,95,154,97,78,107,88,112,173,112,187,125,149,138,106,89,43,129,162,99,8,119,61,128,170,140,84,88,45,100,187,105,149,91,17,94,111,110,3,250,105,133,76,81,240,83,42,89,32,96,75,97,134,107,112,108,240,108,30,123,206,128,212,130,198,141,176,144,177,152,4,250,199,100,164,111,145,100,4,101,78,81,16,84,31,87,14,138,95,97,118,104,5,250,219,117,82,123,113,125,26,144,6,88,204,105,127,129,42,137,0,144,57,152,120,80,87,89,172,89,149,98,15,144,42,155,93,97,121,114,214,149,97,87,70,90,244,93,138,98,173,100,250,100,119,103,226,108,62,109,44,114,54,116,52,120,119,127,173,130,219,141,23,152,36,82,66,87,127,103,72,114,227,116,169,140,166,143,17,146,42,150,107,81,237,83,76,99,105,79,4,85,150,96,87,101,155,108,127,109,76,114,253,114,23,122,135,137,157,140,109,95,142,111,249,112,168,129,14,97,191,79,79,80,65,98,71,114,199,123,232,125,233,127,77,144,173,151,25,154,182,140,106,87,115,94,176,103,13,132,85,138,32,84,22,91,99,94,226,94,10,95,131,101,186,128,61,133,137,149,91,150,72,79,5,83,13,83,15,83,134,84,250,84,3,87,3,94,22,96,155,98,177,98,85,99,6,250,225,108,102,109,177,117,50,120,222,128,47,129,222,130,97,132,178,132,141,136,18,137,11,144,234,146,253,152,145,155,69,94,180,102,221,102,17,112,6,114,7,250,245,79,125,82,106,95,83,97,83,103,25,106,2,111,226,116,104,121,104,136,121,140,199,152,196,152,67,154,193,84,31,122,83,105,247,138,74,140,168,152,174,153,124,95,171,98,178,117,174,118,171,136,127,144,66,150,57,83,60,95,197,95,204,108,204,115,98,117,139,117,70,123,254,130,157,153,79,78,60,144,11,78,85,79,166,83,15,89,200,94,48,102,179,108,85,116,119,131,102,135,192,140,80,144,30,151,21,156,209,88,120,91,80,134,20,139,180,157,210,91,104,96,141,96,241,101,87,108,34,111,163,111,26,112,85,127,240,127,145,149,146,149,80,150,211,151,114,82,68,143,253,81,43,84,184,84,99,85,138,85,187,106,181,109,216,125,102,130,156,146,119,150,121,158,8,84,200,84,210,118,228,134,164,149,212,149,92,150,162,78,9,79,238,89,230,90,247,93,82,96,151,98,109,103,65,104,134,108,47,110,56,127,155,128,42,130,8,250,9,250,5,152,165,78,85,80,179,84,147,87,90,89,105,91,179,91,200,97,119,105,119,109,35,112,249,135,227,137,114,138,231,138,130,144,237,153,184,154,190,82,56,104,22,80,120,94,79,103,71,131,76,136,171,78,17,84,174,86,230,115,21,145,255,151,9,153,87,153,153,153,83,86,159,88,91,134,49,138,178,97,246,106,123,115,210,142,71,107,170,150,87,154,85,89,0,114,107,141,105,151,212,79,244,92,38,95,248,97,91,102,235,108,171,112,132,115,185,115,254,115,41,119,77,119,67,125,98,125,35,126,55,130,82,136,10,250,226,140,73,146,111,152,81,91,116,122,64,136,1,152,204,90,224,79,84,83,62,89,253,92,62,99,121,109,249,114,5,129,7,129,162,131,207,146,48,152,168,78,68,81,17,82,139,87,98,95,194,108,206,110,5,112,80,112,175,112,146,113,233,115,105,116,74,131,162,135,97,136,8,144,162,144,163,147,168,153,110,81,87,95,224,96,103,97,179,102,89,133,74,142,175,145,139,151,78,78,146,78,124,84,213,88,250,88,125,89,181,92,39,95,54,98,72,98,10,102,103,102,235,107,105,109,207,109,86,110,248,110,148,111,224,111,233,111,93,112,208,114,37,116,90,116,224,116,147,118,92,121,202,124,30,126,225,128,166,130,107,132,191,132,78,134,95,134,116,135,119,139,106,140,172,147,0,152,101,152,209,96,22,98,119,145,90,90,15,102,247,109,62,110,63,116,66,155,253,95,218,96,15,123,196,84,24,95,94,108,211,108,42,109,216,112,5,125,121,134,12,138,59,157,22,83,140,84,5,91,58,106,107,112,117,117,141,121,190,121,177,130,239,131,113,138,65,139,168,140,116,151,11,250,244,100,43,101,186,120,187,120,107,122,56,78,154,85,80,89,166,91,123,94,163,96,219,99,97,107,101,102,83,104,25,110,101,113,176,116,8,125,132,144,105,154,37,156,59,109,209,110,62,115,65,140,202,149,240,81,76,94,168,95,77,96,246,96,48,97,76,97,67,102,68,102,165,105,193,108,95,110,201,110,98,111,76,113,156,116,135,118,193,123,39,124,82,131,87,135,81,144,141,150,195,158,47,83,222,86,251,94,138,95,98,96,148,96,247,97,102,102,3,103,156,106,238,109,174,111,112,112,106,115,106,126,190,129,52,131,212,134,168,138,196,140,131,82,114,115,150,91,107,106,4,148,238,84,134,86,93,91,72,101,133,101,201,102,159,104,141,109,198,109,59,114,180,128,117,145,77,154,175,79,25,80,154,83,14,84,60,84,137,85,197,85,63,94,140,95,61,103,102,113,221,115,5,144,219,82,243,82,100,88,206,88,4,113,143,113,251,113,176,133,19,138,136,102,168,133,167,85,132,102,74,113,49,132,73,83,153,85,193,107,89,95,189,95,238,99,137,102,71,113,241,138,29,143,190,158,17,79,58,100,203,112,102,117,103,134,100,96,78,139,248,157,71,81,246,81,8,83,54,109,248,128,209,158,21,102,35,107,152,112,213,117,3,84,121,92,7,125,22,138,32,107,61,107,70,107,56,84,112,96,61,109,213,127,8,130,214,80,222,81,156,85,107,86,205,86,236,89,9,91,12,94,153,97,152,97,49,98,94,102,230,102,153,113,185,113,186,113,167,114,167,121,0,122,178,127,112,138,0,0,0,0,0,0,1,0,160,0,167,0,168,0,169,0,175,0,176,0,178,0,183,0,184,0,198,0,215,0,216,0,230,0,247,0,248,0,0,1,1,1,2,1,3,1,4,1,5,1,6,1,7,1,8,1,9,1,10,1,11,1,12,1,13,1,14,1,15,1,16,1,17,1,18,1,19,1,22,1,23,1,24,1,25,1,26,1,27,1,28,1,29,1,30,1,31,1,32,1,33,1,34,1,35,1,36,1,37,1,38,1,39,1,40,1,41,1,42,1,43,1,46,1,47,1,48,1,49,1,52,1,53,1,54,1,55,1,56,1,57,1,58,1,59,1,60,1,61,1,62,1,65,1,66,1,67,1,68,1,69,1,70,1,71,1,72,1,74,1,75,1,76,1,77,1,80,1,81,1,82,1,83,1,84,1,85,1,86,1,87,1,88,1,89,1,90,1,91,1,92,1,93,1,94,1,95,1,96,1,97,1,98,1,99,1,100,1,101,1,102,1,103,1,104,1,105,1,106,1,107,1,108,1,109,1,110,1,111,1,112,1,113,1,114,1,115,1,116,1,117,1,118,1,119,1,120,1,121,1,122,1,123,1,124,1,125,1,126,1,146,1,160,1,161,1,175,1,176,1,24,2,25,2,26,2,27,2,198,2,199,2,216,2,217,2,219,2,220,2,221,2,0,3,1,3,3,3,9,3,35,3,122,3,132,3,133,3,134,3,136,3,137,3,138,3,140,3,142,3,143,3,144,3,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,170,3,171,3,172,3,173,3,174,3,175,3,176,3,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,194,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,202,3,203,3,204,3,205,3,206,3,1,4,2,4,3,4,4,4,5,4,6,4,7,4,8,4,9,4,10,4,11,4,12,4,14,4,15,4,16,4,17,4,18,4,19,4,20,4,21,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,48,4,49,4,50,4,51,4,52,4,53,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,81,4,82,4,83,4,84,4,85,4,86,4,87,4,88,4,89,4,90,4,91,4,92,4,94,4,95,4,144,4,145,4,176,5,177,5,178,5,179,5,180,5,181,5,182,5,183,5,184,5,185,5,187,5,188,5,189,5,190,5,191,5,192,5,193,5,194,5,195,5,208,5,209,5,210,5,211,5,212,5,213,5,214,5,215,5,216,5,217,5,218,5,219,5,220,5,221,5,222,5,223,5,224,5,225,5,226,5,227,5,228,5,229,5,230,5,231,5,232,5,233,5,234,5,240,5,241,5,242,5,243,5,244,5,12,6,27,6,31,6,33,6,34,6,35,6,36,6,37,6,38,6,39,6,40,6,41,6,42,6,43,6,44,6,45,6,46,6,47,6,48,6,49,6,50,6,51,6,52,6,53,6,54,6,55,6,56,6,57,6,58,6,64,6,65,6,66,6,67,6,68,6,69,6,70,6,71,6,72,6,73,6,74,6,75,6,76,6,77,6,78,6,79,6,80,6,81,6,82,6,121,6,126,6,134,6,136,6,145,6,152,6,169,6,175,6,186,6,190,6,193,6,210,6,1,14,2,14,3,14,4,14,5,14,6,14,7,14,8,14,9,14,10,14,11,14,12,14,13,14,14,14,15,14,16,14,17,14,18,14,19,14,20,14,21,14,22,14,23,14,24,14,25,14,26,14,27,14,28,14,29,14,30,14,31,14,32,14,33,14,34,14,35,14,36,14,37,14,38,14,39,14,40,14,41,14,42,14,43,14,44,14,45,14,46,14,47,14,48,14,49,14,50,14,51,14,52,14,53,14,54,14,55,14,56,14,57,14,58,14,63,14,64,14,65,14,66,14,67,14,68,14,69,14,70,14,71,14,72,14,73,14,74,14,75,14,76,14,77,14,78,14,79,14,80,14,81,14,82,14,83,14,84,14,85,14,86,14,87,14,88,14,89,14,90,14,91,14,2,30,3,30,10,30,11,30,30,30,31,30,64,30,65,30,86,30,87,30,96,30,97,30,106,30,107,30,128,30,129,30,130,30,131,30,132,30,133,30,242,30,243,30,12,32,13,32,14,32,15,32,19,32,20,32,21,32,23,32,24,32,25,32,26,32,28,32,29,32,30,32,32,32,33,32,34,32,38,32,48,32,57,32,58,32,170,32,171,32,172,32,175,32,22,33,34,33,25,34,26,34,72,34,100,34,101,34,32,35,33,35,0,37,2,37,12,37,16,37,20,37,24,37,28,37,36,37,44,37,52,37,60,37,80,37,81,37,82,37,83,37,84,37,85,37,86,37,87,37,88,37,89,37,90,37,91,37,92,37,93,37,94,37,95,37,96,37,97,37,98,37,99,37,100,37,101,37,102,37,103,37,104,37,105,37,106,37,107,37,108,37,128,37,132,37,136,37,140,37,144,37,145,37,146,37,147,37,160,37,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,1,2,4,7,3,6,5,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,0,0,0,0,0,0,40,110,117,108,108,41,0,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,0,0,0,0,0,105,110,102,0,0,0,0,0,73,78,70,0,0,0,0,0,110,97,110,0,0,0,0,0,78,65,78,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+322788);var tempDoublePtr=Runtime.alignMemory(allocate(12,"i8",ALLOC_STATIC),8);assert(tempDoublePtr%8==0),Module._i64Subtract=_i64Subtract,Module._bitshift64Ashr=_bitshift64Ashr;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86},ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"},___errno_state=0,PATH={splitPath:function(e){var i=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return i.exec(e).slice(1)},normalizeArray:function(e,i){for(var r=0,n=e.length-1;n>=0;n--){var f=e[n];"."===f?e.splice(n,1):".."===f?(e.splice(n,1),r++):r&&(e.splice(n,1),r--)}if(i)for(;r--;r)e.unshift("..");return e},normalize:function(e){var i="/"===e.charAt(0),r="/"===e.substr(-1);return e=PATH.normalizeArray(e.split("/").filter(function(e){return!!e}),!i).join("/"),e||i||(e="."),e&&r&&(e+="/"),(i?"/":"")+e},dirname:function(e){var i=PATH.splitPath(e),r=i[0],n=i[1];return r||n?(n&&(n=n.substr(0,n.length-1)),r+n):"."},basename:function(e){if("/"===e)return"/";var i=e.lastIndexOf("/");return i===-1?e:e.substr(i+1)},extname:function(e){return PATH.splitPath(e)[3]},join:function(){var e=Array.prototype.slice.call(arguments,0);return PATH.normalize(e.join("/"))},join2:function(e,i){return PATH.normalize(e+"/"+i)},resolve:function(){for(var e="",i=!1,r=arguments.length-1;r>=-1&&!i;r--){var n=r>=0?arguments[r]:FS.cwd();if("string"!=typeof n)throw new TypeError("Arguments to path.resolve must be strings");if(!n)return"";e=n+"/"+e,i="/"===n.charAt(0)}return e=PATH.normalizeArray(e.split("/").filter(function(e){return!!e}),!i).join("/"),(i?"/":"")+e||"."},relative:function(e,i){function r(e){for(var i=0;i<e.length&&""===e[i];i++);for(var r=e.length-1;r>=0&&""===e[r];r--);return i>r?[]:e.slice(i,r-i+1)}e=PATH.resolve(e).substr(1),i=PATH.resolve(i).substr(1);for(var n=r(e.split("/")),f=r(i.split("/")),t=Math.min(n.length,f.length),u=t,a=0;a<t;a++)if(n[a]!==f[a]){u=a;break}for(var o=[],a=u;a<n.length;a++)o.push("..");return o=o.concat(f.slice(u)),o.join("/")}},TTY={ttys:[],init:function(){},shutdown:function(){},register:function(e,i){TTY.ttys[e]={input:[],output:[],ops:i},FS.registerDevice(e,TTY.stream_ops)},stream_ops:{open:function(e){var i=TTY.ttys[e.node.rdev];if(!i)throw new FS.ErrnoError(ERRNO_CODES.ENODEV);e.tty=i,e.seekable=!1},close:function(e){e.tty.ops.flush(e.tty)},flush:function(e){e.tty.ops.flush(e.tty)},read:function(e,i,r,n,f){if(!e.tty||!e.tty.ops.get_char)throw new FS.ErrnoError(ERRNO_CODES.ENXIO);for(var t=0,u=0;u<n;u++){var a;try{a=e.tty.ops.get_char(e.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(void 0===a&&0===t)throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);if(null===a||void 0===a)break;t++,i[r+u]=a}return t&&(e.node.timestamp=Date.now()),t},write:function(e,i,r,n,f){if(!e.tty||!e.tty.ops.put_char)throw new FS.ErrnoError(ERRNO_CODES.ENXIO);for(var t=0;t<n;t++)try{e.tty.ops.put_char(e.tty,i[r+t])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return n&&(e.node.timestamp=Date.now()),t}},default_tty_ops:{get_char:function(e){if(!e.input.length){var i=null;if("undefined"!=typeof window&&"function"==typeof window.prompt?(i=window.prompt("Input: "),null!==i&&(i+="\n")):"function"==typeof readline&&(i=readline(),null!==i&&(i+="\n")),!i)return null;e.input=intArrayFromString(i,!0)}return e.input.shift()},flush:function(e){e.output&&e.output.length>0&&(Module.print(e.output.join("")),e.output=[])},put_char:function(e,i){null===i||10===i?(Module.print(e.output.join("")),e.output=[]):e.output.push(TTY.utf8.processCChar(i))}},default_tty1_ops:{put_char:function(e,i){null===i||10===i?(Module.printErr(e.output.join("")),e.output=[]):e.output.push(TTY.utf8.processCChar(i))},flush:function(e){e.output&&e.output.length>0&&(Module.printErr(e.output.join("")),e.output=[])}}},MEMFS={ops_table:null,mount:function(e){return MEMFS.createNode(null,"/",16895,0)},createNode:function(e,i,r,n){if(FS.isBlkdev(r)||FS.isFIFO(r))throw new FS.ErrnoError(ERRNO_CODES.EPERM);MEMFS.ops_table||(MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}});var f=FS.createNode(e,i,r,n);return FS.isDir(f.mode)?(f.node_ops=MEMFS.ops_table.dir.node,f.stream_ops=MEMFS.ops_table.dir.stream,f.contents={}):FS.isFile(f.mode)?(f.node_ops=MEMFS.ops_table.file.node,f.stream_ops=MEMFS.ops_table.file.stream,f.usedBytes=0,f.contents=null):FS.isLink(f.mode)?(f.node_ops=MEMFS.ops_table.link.node,f.stream_ops=MEMFS.ops_table.link.stream):FS.isChrdev(f.mode)&&(f.node_ops=MEMFS.ops_table.chrdev.node,
	f.stream_ops=MEMFS.ops_table.chrdev.stream),f.timestamp=Date.now(),e&&(e.contents[i]=f),f},getFileDataAsRegularArray:function(e){if(e.contents&&e.contents.subarray){for(var i=[],r=0;r<e.usedBytes;++r)i.push(e.contents[r]);return i}return e.contents},getFileDataAsTypedArray:function(e){return e.contents?e.contents.subarray?e.contents.subarray(0,e.usedBytes):new Uint8Array(e.contents):new Uint8Array},expandFileStorage:function(e,i){if(e.contents&&e.contents.subarray&&i>e.contents.length&&(e.contents=MEMFS.getFileDataAsRegularArray(e),e.usedBytes=e.contents.length),!e.contents||e.contents.subarray){var r=e.contents?e.contents.buffer.byteLength:0;if(r>=i)return;var n=1048576;i=Math.max(i,r*(r<n?2:1.125)|0),0!=r&&(i=Math.max(i,256));var f=e.contents;return e.contents=new Uint8Array(i),void(e.usedBytes>0&&e.contents.set(f.subarray(0,e.usedBytes),0))}for(!e.contents&&i>0&&(e.contents=[]);e.contents.length<i;)e.contents.push(0)},resizeFileStorage:function(e,i){if(e.usedBytes!=i){if(0==i)return e.contents=null,void(e.usedBytes=0);if(!e.contents||e.contents.subarray){var r=e.contents;return e.contents=new Uint8Array(new ArrayBuffer(i)),r&&e.contents.set(r.subarray(0,Math.min(i,e.usedBytes))),void(e.usedBytes=i)}if(e.contents||(e.contents=[]),e.contents.length>i)e.contents.length=i;else for(;e.contents.length<i;)e.contents.push(0);e.usedBytes=i}},node_ops:{getattr:function(e){var i={};return i.dev=FS.isChrdev(e.mode)?e.id:1,i.ino=e.id,i.mode=e.mode,i.nlink=1,i.uid=0,i.gid=0,i.rdev=e.rdev,FS.isDir(e.mode)?i.size=4096:FS.isFile(e.mode)?i.size=e.usedBytes:FS.isLink(e.mode)?i.size=e.link.length:i.size=0,i.atime=new Date(e.timestamp),i.mtime=new Date(e.timestamp),i.ctime=new Date(e.timestamp),i.blksize=4096,i.blocks=Math.ceil(i.size/i.blksize),i},setattr:function(e,i){void 0!==i.mode&&(e.mode=i.mode),void 0!==i.timestamp&&(e.timestamp=i.timestamp),void 0!==i.size&&MEMFS.resizeFileStorage(e,i.size)},lookup:function(e,i){throw FS.genericErrors[ERRNO_CODES.ENOENT]},mknod:function(e,i,r,n){return MEMFS.createNode(e,i,r,n)},rename:function(e,i,r){if(FS.isDir(e.mode)){var n;try{n=FS.lookupNode(i,r)}catch(e){}if(n)for(var f in n.contents)throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete e.parent.contents[e.name],e.name=r,i.contents[r]=e,e.parent=i},unlink:function(e,i){delete e.contents[i]},rmdir:function(e,i){var r=FS.lookupNode(e,i);for(var n in r.contents)throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);delete e.contents[i]},readdir:function(e){var i=[".",".."];for(var r in e.contents)e.contents.hasOwnProperty(r)&&i.push(r);return i},symlink:function(e,i,r){var n=MEMFS.createNode(e,i,41471,0);return n.link=r,n},readlink:function(e){if(!FS.isLink(e.mode))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return e.link}},stream_ops:{read:function(e,i,r,n,f){var t=e.node.contents;if(f>=e.node.usedBytes)return 0;var u=Math.min(e.node.usedBytes-f,n);if(assert(u>=0),u>8&&t.subarray)i.set(t.subarray(f,f+u),r);else for(var a=0;a<u;a++)i[r+a]=t[f+a];return u},write:function(e,i,r,n,f,t){if(!n)return 0;var u=e.node;if(u.timestamp=Date.now(),i.subarray&&(!u.contents||u.contents.subarray)){if(t)return u.contents=i.subarray(r,r+n),u.usedBytes=n,n;if(0===u.usedBytes&&0===f)return u.contents=new Uint8Array(i.subarray(r,r+n)),u.usedBytes=n,n;if(f+n<=u.usedBytes)return u.contents.set(i.subarray(r,r+n),f),n}if(MEMFS.expandFileStorage(u,f+n),u.contents.subarray&&i.subarray)u.contents.set(i.subarray(r,r+n),f);else for(var a=0;a<n;a++)u.contents[f+a]=i[r+a];return u.usedBytes=Math.max(u.usedBytes,f+n),n},llseek:function(e,i,r){var n=i;if(1===r?n+=e.position:2===r&&FS.isFile(e.node.mode)&&(n+=e.node.usedBytes),n<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return n},allocate:function(e,i,r){MEMFS.expandFileStorage(e.node,i+r),e.node.usedBytes=Math.max(e.node.usedBytes,i+r)},mmap:function(e,i,r,n,f,t,u){if(!FS.isFile(e.node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENODEV);var a,o,c=e.node.contents;if(2&u||c.buffer!==i&&c.buffer!==i.buffer){if((f>0||f+n<e.node.usedBytes)&&(c=c.subarray?c.subarray(f,f+n):Array.prototype.slice.call(c,f,f+n)),o=!0,a=_malloc(n),!a)throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);i.set(c,a)}else o=!1,a=c.byteOffset;return{ptr:a,allocated:o}}}},IDBFS={dbs:{},indexedDB:function(){if("undefined"!=typeof indexedDB)return indexedDB;var e=null;return"object"==typeof window&&(e=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB),assert(e,"IDBFS used, but indexedDB not supported"),e},DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function(e){return MEMFS.mount.apply(null,arguments)},syncfs:function(e,i,r){IDBFS.getLocalSet(e,function(n,f){return n?r(n):void IDBFS.getRemoteSet(e,function(e,n){if(e)return r(e);var t=i?n:f,u=i?f:n;IDBFS.reconcile(t,u,r)})})},getDB:function(e,i){var r=IDBFS.dbs[e];if(r)return i(null,r);var n;try{n=IDBFS.indexedDB().open(e,IDBFS.DB_VERSION)}catch(e){return i(e)}n.onupgradeneeded=function(e){var i,r=e.target.result,n=e.target.transaction;i=r.objectStoreNames.contains(IDBFS.DB_STORE_NAME)?n.objectStore(IDBFS.DB_STORE_NAME):r.createObjectStore(IDBFS.DB_STORE_NAME),i.createIndex("timestamp","timestamp",{unique:!1})},n.onsuccess=function(){r=n.result,IDBFS.dbs[e]=r,i(null,r)},n.onerror=function(){i(this.error)}},getLocalSet:function(e,i){function r(e){return"."!==e&&".."!==e}function n(e){return function(i){return PATH.join2(e,i)}}for(var f={},t=FS.readdir(e.mountpoint).filter(r).map(n(e.mountpoint));t.length;){var u,a=t.pop();try{u=FS.stat(a)}catch(e){return i(e)}FS.isDir(u.mode)&&t.push.apply(t,FS.readdir(a).filter(r).map(n(a))),f[a]={timestamp:u.mtime}}return i(null,{type:"local",entries:f})},getRemoteSet:function(e,i){var r={};IDBFS.getDB(e.mountpoint,function(e,n){if(e)return i(e);var f=n.transaction([IDBFS.DB_STORE_NAME],"readonly");f.onerror=function(){i(this.error)};var t=f.objectStore(IDBFS.DB_STORE_NAME),u=t.index("timestamp");u.openKeyCursor().onsuccess=function(e){var f=e.target.result;return f?(r[f.primaryKey]={timestamp:f.key},void f.continue()):i(null,{type:"remote",db:n,entries:r})}})},loadLocalEntry:function(e,i){var r,n;try{var f=FS.lookupPath(e);n=f.node,r=FS.stat(e)}catch(e){return i(e)}return FS.isDir(r.mode)?i(null,{timestamp:r.mtime,mode:r.mode}):FS.isFile(r.mode)?(n.contents=MEMFS.getFileDataAsTypedArray(n),i(null,{timestamp:r.mtime,mode:r.mode,contents:n.contents})):i(new Error("node type not supported"))},storeLocalEntry:function(e,i,r){try{if(FS.isDir(i.mode))FS.mkdir(e,i.mode);else{if(!FS.isFile(i.mode))return r(new Error("node type not supported"));FS.writeFile(e,i.contents,{encoding:"binary",canOwn:!0})}FS.chmod(e,i.mode),FS.utime(e,i.timestamp,i.timestamp)}catch(e){return r(e)}r(null)},removeLocalEntry:function(e,i){try{var r=(FS.lookupPath(e),FS.stat(e));FS.isDir(r.mode)?FS.rmdir(e):FS.isFile(r.mode)&&FS.unlink(e)}catch(e){return i(e)}i(null)},loadRemoteEntry:function(e,i,r){var n=e.get(i);n.onsuccess=function(e){r(null,e.target.result)},n.onerror=function(){r(this.error)}},storeRemoteEntry:function(e,i,r,n){var f=e.put(r,i);f.onsuccess=function(){n(null)},f.onerror=function(){n(this.error)}},removeRemoteEntry:function(e,i,r){var n=e.delete(i);n.onsuccess=function(){r(null)},n.onerror=function(){r(this.error)}},reconcile:function(e,i,r){function n(e){if(e){if(!n.errored)return n.errored=!0,r(e)}else if(++a>=f)return r(null)}var f=0,t=[];Object.keys(e.entries).forEach(function(r){var n=e.entries[r],u=i.entries[r];(!u||n.timestamp>u.timestamp)&&(t.push(r),f++)});var u=[];if(Object.keys(i.entries).forEach(function(r){var n=(i.entries[r],e.entries[r]);n||(u.push(r),f++)}),!f)return r(null);var a=0,o="remote"===e.type?e.db:i.db,c=o.transaction([IDBFS.DB_STORE_NAME],"readwrite"),l=c.objectStore(IDBFS.DB_STORE_NAME);c.onerror=function(){n(this.error)},t.sort().forEach(function(e){"local"===i.type?IDBFS.loadRemoteEntry(l,e,function(i,r){return i?n(i):void IDBFS.storeLocalEntry(e,r,n)}):IDBFS.loadLocalEntry(e,function(i,r){return i?n(i):void IDBFS.storeRemoteEntry(l,e,r,n)})}),u.sort().reverse().forEach(function(e){"local"===i.type?IDBFS.removeLocalEntry(e,n):IDBFS.removeRemoteEntry(l,e,n)})}},NODEFS={isWindows:!1,staticInit:function(){NODEFS.isWindows=!!process.platform.match(/^win/)},mount:function(e){return assert(!1),NODEFS.createNode(null,"/",NODEFS.getMode(e.opts.root),0)},createNode:function(e,i,r,n){if(!FS.isDir(r)&&!FS.isFile(r)&&!FS.isLink(r))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var f=FS.createNode(e,i,r);return f.node_ops=NODEFS.node_ops,f.stream_ops=NODEFS.stream_ops,f},getMode:function(e){var i;try{i=fs.lstatSync(e),NODEFS.isWindows&&(i.mode=i.mode|(146&i.mode)>>1)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return i.mode},realPath:function(e){for(var i=[];e.parent!==e;)i.push(e.name),e=e.parent;return i.push(e.mount.opts.root),i.reverse(),PATH.join.apply(null,i)},flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function(e){return e in NODEFS.flagsToPermissionStringMap?NODEFS.flagsToPermissionStringMap[e]:e},node_ops:{getattr:function(e){var i,r=NODEFS.realPath(e);try{i=fs.lstatSync(r)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return NODEFS.isWindows&&!i.blksize&&(i.blksize=4096),NODEFS.isWindows&&!i.blocks&&(i.blocks=(i.size+i.blksize-1)/i.blksize|0),{dev:i.dev,ino:i.ino,mode:i.mode,nlink:i.nlink,uid:i.uid,gid:i.gid,rdev:i.rdev,size:i.size,atime:i.atime,mtime:i.mtime,ctime:i.ctime,blksize:i.blksize,blocks:i.blocks}},setattr:function(e,i){var r=NODEFS.realPath(e);try{if(void 0!==i.mode&&(fs.chmodSync(r,i.mode),e.mode=i.mode),void 0!==i.timestamp){var n=new Date(i.timestamp);fs.utimesSync(r,n,n)}void 0!==i.size&&fs.truncateSync(r,i.size)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},lookup:function(e,i){var r=PATH.join2(NODEFS.realPath(e),i),n=NODEFS.getMode(r);return NODEFS.createNode(e,i,n)},mknod:function(e,i,r,n){var f=NODEFS.createNode(e,i,r,n),t=NODEFS.realPath(f);try{FS.isDir(f.mode)?fs.mkdirSync(t,f.mode):fs.writeFileSync(t,"",{mode:f.mode})}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return f},rename:function(e,i,r){var n=NODEFS.realPath(e),f=PATH.join2(NODEFS.realPath(i),r);try{fs.renameSync(n,f)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},unlink:function(e,i){var r=PATH.join2(NODEFS.realPath(e),i);try{fs.unlinkSync(r)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},rmdir:function(e,i){var r=PATH.join2(NODEFS.realPath(e),i);try{fs.rmdirSync(r)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},readdir:function(e){var i=NODEFS.realPath(e);try{return fs.readdirSync(i)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},symlink:function(e,i,r){var n=PATH.join2(NODEFS.realPath(e),i);try{fs.symlinkSync(r,n)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},readlink:function(e){var i=NODEFS.realPath(e);try{return fs.readlinkSync(i)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}},stream_ops:{open:function(e){var i=NODEFS.realPath(e.node);try{FS.isFile(e.node.mode)&&(e.nfd=fs.openSync(i,NODEFS.flagsToPermissionString(e.flags)))}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},close:function(e){try{FS.isFile(e.node.mode)&&e.nfd&&fs.closeSync(e.nfd)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},read:function(e,i,r,n,f){if(0===n)return 0;var t,u=new Buffer(n);try{t=fs.readSync(e.nfd,u,0,n,f)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(t>0)for(var a=0;a<t;a++)i[r+a]=u[a];return t},write:function(e,i,r,n,f){var t,u=new Buffer(i.subarray(r,r+n));try{t=fs.writeSync(e.nfd,u,0,n,f)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return t},llseek:function(e,i,r){var n=i;if(1===r)n+=e.position;else if(2===r&&FS.isFile(e.node.mode))try{var f=fs.fstatSync(e.nfd);n+=f.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(n<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return n}}},_stdin=allocate(1,"i32*",ALLOC_STATIC),_stdout=allocate(1,"i32*",ALLOC_STATIC),_stderr=allocate(1,"i32*",ALLOC_STATIC),FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:!1,ignorePermissions:!0,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},handleFSError:function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)},lookupPath:function(e,i){if(e=PATH.resolve(FS.cwd(),e),i=i||{},!e)return{path:"",node:null};var r={follow_mount:!0,recurse_count:0};for(var n in r)void 0===i[n]&&(i[n]=r[n]);if(i.recurse_count>8)throw new FS.ErrnoError(ERRNO_CODES.ELOOP);for(var f=PATH.normalizeArray(e.split("/").filter(function(e){return!!e}),!1),t=FS.root,u="/",a=0;a<f.length;a++){var o=a===f.length-1;if(o&&i.parent)break;if(t=FS.lookupNode(t,f[a]),u=PATH.join2(u,f[a]),FS.isMountpoint(t)&&(!o||o&&i.follow_mount)&&(t=t.mounted.root),!o||i.follow)for(var c=0;FS.isLink(t.mode);){var l=FS.readlink(u);u=PATH.resolve(PATH.dirname(u),l);var s=FS.lookupPath(u,{recurse_count:i.recurse_count});if(t=s.node,c++>40)throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}return{path:u,node:t}},getPath:function(e){for(var i;;){if(FS.isRoot(e)){var r=e.mount.mountpoint;return i?"/"!==r[r.length-1]?r+"/"+i:r+i:r}i=i?e.name+"/"+i:e.name,e=e.parent}},hashName:function(e,i){for(var r=0,n=0;n<i.length;n++)r=(r<<5)-r+i.charCodeAt(n)|0;return(e+r>>>0)%FS.nameTable.length},hashAddNode:function(e){var i=FS.hashName(e.parent.id,e.name);e.name_next=FS.nameTable[i],FS.nameTable[i]=e},hashRemoveNode:function(e){var i=FS.hashName(e.parent.id,e.name);if(FS.nameTable[i]===e)FS.nameTable[i]=e.name_next;else for(var r=FS.nameTable[i];r;){if(r.name_next===e){r.name_next=e.name_next;break}r=r.name_next}},lookupNode:function(e,i){var r=FS.mayLookup(e);if(r)throw new FS.ErrnoError(r,e);for(var n=FS.hashName(e.id,i),f=FS.nameTable[n];f;f=f.name_next){var t=f.name;if(f.parent.id===e.id&&t===i)return f}return FS.lookup(e,i)},createNode:function(e,i,r,n){if(!FS.FSNode){FS.FSNode=function(e,i,r,n){e||(e=this),this.parent=e,this.mount=e.mount,this.mounted=null,this.id=FS.nextInode++,this.name=i,this.mode=r,this.node_ops={},this.stream_ops={},this.rdev=n},FS.FSNode.prototype={};var f=365,t=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:function(){return(this.mode&f)===f},set:function(e){e?this.mode|=f:this.mode&=~f}},write:{get:function(){return(this.mode&t)===t},set:function(e){e?this.mode|=t:this.mode&=~t}},isFolder:{get:function(){return FS.isDir(this.mode)}},isDevice:{get:function(){return FS.isChrdev(this.mode)}}})}var u=new FS.FSNode(e,i,r,n);return FS.hashAddNode(u),u},destroyNode:function(e){FS.hashRemoveNode(e)},isRoot:function(e){return e===e.parent},isMountpoint:function(e){return!!e.mounted},isFile:function(e){return 32768===(61440&e)},isDir:function(e){return 16384===(61440&e)},isLink:function(e){return 40960===(61440&e)},isChrdev:function(e){return 8192===(61440&e)},isBlkdev:function(e){return 24576===(61440&e)},isFIFO:function(e){return 4096===(61440&e)},isSocket:function(e){return 49152===(49152&e)},flagModes:{r:0,rs:1052672,"r+":2,w:577,wx:705,xw:705,"w+":578,"wx+":706,"xw+":706,a:1089,ax:1217,xa:1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function(e){var i=FS.flagModes[e];if("undefined"==typeof i)throw new Error("Unknown file open mode: "+e);return i},flagsToPermissionString:function(e){var i=2097155&e,r=["r","w","rw"][i];return 512&e&&(r+="w"),r},nodePermissions:function(e,i){return FS.ignorePermissions?0:(i.indexOf("r")===-1||292&e.mode)&&(i.indexOf("w")===-1||146&e.mode)&&(i.indexOf("x")===-1||73&e.mode)?0:ERRNO_CODES.EACCES},mayLookup:function(e){var i=FS.nodePermissions(e,"x");return i?i:e.node_ops.lookup?0:ERRNO_CODES.EACCES},mayCreate:function(e,i){try{FS.lookupNode(e,i);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(e,"wx")},mayDelete:function(e,i,r){var n;try{n=FS.lookupNode(e,i)}catch(e){return e.errno}var f=FS.nodePermissions(e,"wx");if(f)return f;if(r){if(!FS.isDir(n.mode))return ERRNO_CODES.ENOTDIR;if(FS.isRoot(n)||FS.getPath(n)===FS.cwd())return ERRNO_CODES.EBUSY}else if(FS.isDir(n.mode))return ERRNO_CODES.EISDIR;return 0},mayOpen:function(e,i){return e?FS.isLink(e.mode)?ERRNO_CODES.ELOOP:FS.isDir(e.mode)&&(0!==(2097155&i)||512&i)?ERRNO_CODES.EISDIR:FS.nodePermissions(e,FS.flagsToPermissionString(i)):ERRNO_CODES.ENOENT},MAX_OPEN_FDS:4096,nextfd:function(e,i){e=e||0,i=i||FS.MAX_OPEN_FDS;for(var r=e;r<=i;r++)if(!FS.streams[r])return r;throw new FS.ErrnoError(ERRNO_CODES.EMFILE)},getStream:function(e){return FS.streams[e]},createStream:function(e,i,r){FS.FSStream||(FS.FSStream=function(){},FS.FSStream.prototype={},Object.defineProperties(FS.FSStream.prototype,{object:{get:function(){return this.node},set:function(e){this.node=e}},isRead:{get:function(){return 1!==(2097155&this.flags)}},isWrite:{get:function(){return 0!==(2097155&this.flags)}},isAppend:{get:function(){return 1024&this.flags}}}));var n=new FS.FSStream;for(var f in e)n[f]=e[f];e=n;var t=FS.nextfd(i,r);return e.fd=t,FS.streams[t]=e,e},closeStream:function(e){FS.streams[e]=null},getStreamFromPtr:function(e){return FS.streams[e-1]},getPtrForStream:function(e){return e?e.fd+1:0},chrdev_stream_ops:{open:function(e){var i=FS.getDevice(e.node.rdev);e.stream_ops=i.stream_ops,e.stream_ops.open&&e.stream_ops.open(e)},llseek:function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}},major:function(e){return e>>8},minor:function(e){return 255&e},makedev:function(e,i){return e<<8|i},registerDevice:function(e,i){FS.devices[e]={stream_ops:i}},getDevice:function(e){return FS.devices[e]},getMounts:function(e){for(var i=[],r=[e];r.length;){var n=r.pop();i.push(n),r.push.apply(r,n.mounts)}return i},syncfs:function(e,i){function r(e){if(e){if(!r.errored)return r.errored=!0,i(e)}else++f>=n.length&&i(null)}"function"==typeof e&&(i=e,e=!1);var n=FS.getMounts(FS.root.mount),f=0;n.forEach(function(i){return i.type.syncfs?void i.type.syncfs(i,e,r):r(null)})},mount:function(e,i,r){var n,f="/"===r,t=!r;if(f&&FS.root)throw new FS.ErrnoError(ERRNO_CODES.EBUSY);if(!f&&!t){var u=FS.lookupPath(r,{follow_mount:!1});if(r=u.path,n=u.node,FS.isMountpoint(n))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);if(!FS.isDir(n.mode))throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var a={type:e,opts:i,mountpoint:r,mounts:[]},o=e.mount(a);return o.mount=a,a.root=o,f?FS.root=o:n&&(n.mounted=a,n.mount&&n.mount.mounts.push(a)),o},unmount:function(e){var i=FS.lookupPath(e,{follow_mount:!1});if(!FS.isMountpoint(i.node))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var r=i.node,n=r.mounted,f=FS.getMounts(n);Object.keys(FS.nameTable).forEach(function(e){for(var i=FS.nameTable[e];i;){var r=i.name_next;f.indexOf(i.mount)!==-1&&FS.destroyNode(i),i=r}}),r.mounted=null;var t=r.mount.mounts.indexOf(n);assert(t!==-1),r.mount.mounts.splice(t,1)},lookup:function(e,i){return e.node_ops.lookup(e,i)},mknod:function(e,i,r){var n=FS.lookupPath(e,{parent:!0}),f=n.node,t=PATH.basename(e);if(!t||"."===t||".."===t)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var u=FS.mayCreate(f,t);if(u)throw new FS.ErrnoError(u);if(!f.node_ops.mknod)throw new FS.ErrnoError(ERRNO_CODES.EPERM);return f.node_ops.mknod(f,t,i,r)},create:function(e,i){return i=void 0!==i?i:438,i&=4095,i|=32768,FS.mknod(e,i,0)},mkdir:function(e,i){return i=void 0!==i?i:511,i&=1023,i|=16384,FS.mknod(e,i,0)},mkdev:function(e,i,r){return"undefined"==typeof r&&(r=i,i=438),i|=8192,FS.mknod(e,i,r)},symlink:function(e,i){if(!PATH.resolve(e))throw new FS.ErrnoError(ERRNO_CODES.ENOENT);var r=FS.lookupPath(i,{parent:!0}),n=r.node;if(!n)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);var f=PATH.basename(i),t=FS.mayCreate(n,f);if(t)throw new FS.ErrnoError(t);if(!n.node_ops.symlink)throw new FS.ErrnoError(ERRNO_CODES.EPERM);return n.node_ops.symlink(n,f,e)},rename:function(e,i){var r,n,f,t=PATH.dirname(e),u=PATH.dirname(i),a=PATH.basename(e),o=PATH.basename(i);try{r=FS.lookupPath(e,{parent:!0}),n=r.node,r=FS.lookupPath(i,{parent:!0}),f=r.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!n||!f)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(n.mount!==f.mount)throw new FS.ErrnoError(ERRNO_CODES.EXDEV);var c=FS.lookupNode(n,a),l=PATH.relative(e,u);if("."!==l.charAt(0))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(l=PATH.relative(i,t),"."!==l.charAt(0))throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);var s;try{s=FS.lookupNode(f,o)}catch(e){}if(c!==s){var b=FS.isDir(c.mode),k=FS.mayDelete(n,a,b);if(k)throw new FS.ErrnoError(k);if(k=s?FS.mayDelete(f,o,b):FS.mayCreate(f,o))throw new FS.ErrnoError(k);if(!n.node_ops.rename)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isMountpoint(c)||s&&FS.isMountpoint(s))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);if(f!==n&&(k=FS.nodePermissions(n,"w")))throw new FS.ErrnoError(k);try{FS.trackingDelegate.willMovePath&&FS.trackingDelegate.willMovePath(e,i)}catch(r){console.log("FS.trackingDelegate['willMovePath']('"+e+"', '"+i+"') threw an exception: "+r.message)}FS.hashRemoveNode(c);try{n.node_ops.rename(c,f,o)}catch(e){throw e}finally{FS.hashAddNode(c)}try{FS.trackingDelegate.onMovePath&&FS.trackingDelegate.onMovePath(e,i)}catch(r){console.log("FS.trackingDelegate['onMovePath']('"+e+"', '"+i+"') threw an exception: "+r.message)}}},rmdir:function(e){var i=FS.lookupPath(e,{parent:!0}),r=i.node,n=PATH.basename(e),f=FS.lookupNode(r,n),t=FS.mayDelete(r,n,!0);if(t)throw new FS.ErrnoError(t);if(!r.node_ops.rmdir)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isMountpoint(f))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);try{FS.trackingDelegate.willDeletePath&&FS.trackingDelegate.willDeletePath(e)}catch(i){console.log("FS.trackingDelegate['willDeletePath']('"+e+"') threw an exception: "+i.message)}r.node_ops.rmdir(r,n),FS.destroyNode(f);try{FS.trackingDelegate.onDeletePath&&FS.trackingDelegate.onDeletePath(e)}catch(i){console.log("FS.trackingDelegate['onDeletePath']('"+e+"') threw an exception: "+i.message)}},readdir:function(e){var i=FS.lookupPath(e,{follow:!0}),r=i.node;if(!r.node_ops.readdir)throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);return r.node_ops.readdir(r)},unlink:function(e){var i=FS.lookupPath(e,{parent:!0}),r=i.node,n=PATH.basename(e),f=FS.lookupNode(r,n),t=FS.mayDelete(r,n,!1);if(t)throw t===ERRNO_CODES.EISDIR&&(t=ERRNO_CODES.EPERM),new FS.ErrnoError(t);if(!r.node_ops.unlink)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isMountpoint(f))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);try{FS.trackingDelegate.willDeletePath&&FS.trackingDelegate.willDeletePath(e)}catch(i){console.log("FS.trackingDelegate['willDeletePath']('"+e+"') threw an exception: "+i.message)}r.node_ops.unlink(r,n),FS.destroyNode(f);try{FS.trackingDelegate.onDeletePath&&FS.trackingDelegate.onDeletePath(e)}catch(i){console.log("FS.trackingDelegate['onDeletePath']('"+e+"') threw an exception: "+i.message)}},readlink:function(e){var i=FS.lookupPath(e),r=i.node;if(!r)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(!r.node_ops.readlink)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return r.node_ops.readlink(r)},stat:function(e,i){var r=FS.lookupPath(e,{follow:!i}),n=r.node;if(!n)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(!n.node_ops.getattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);return n.node_ops.getattr(n)},lstat:function(e){return FS.stat(e,!0)},chmod:function(e,i,r){var n;if("string"==typeof e){var f=FS.lookupPath(e,{follow:!r});n=f.node}else n=e;if(!n.node_ops.setattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);n.node_ops.setattr(n,{mode:4095&i|n.mode&-4096,timestamp:Date.now()})},lchmod:function(e,i){FS.chmod(e,i,!0)},fchmod:function(e,i){var r=FS.getStream(e);if(!r)throw new FS.ErrnoError(ERRNO_CODES.EBADF);FS.chmod(r.node,i)},chown:function(e,i,r,n){var f;if("string"==typeof e){var t=FS.lookupPath(e,{follow:!n});f=t.node}else f=e;if(!f.node_ops.setattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);f.node_ops.setattr(f,{timestamp:Date.now()})},lchown:function(e,i,r){FS.chown(e,i,r,!0)},fchown:function(e,i,r){var n=FS.getStream(e);if(!n)throw new FS.ErrnoError(ERRNO_CODES.EBADF);FS.chown(n.node,i,r)},truncate:function(e,i){if(i<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var r;if("string"==typeof e){var n=FS.lookupPath(e,{follow:!0});r=n.node}else r=e;if(!r.node_ops.setattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isDir(r.mode))throw new FS.ErrnoError(ERRNO_CODES.EISDIR);if(!FS.isFile(r.mode))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var f=FS.nodePermissions(r,"w");if(f)throw new FS.ErrnoError(f);r.node_ops.setattr(r,{size:i,timestamp:Date.now()})},ftruncate:function(e,i){var r=FS.getStream(e);if(!r)throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(0===(2097155&r.flags))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);FS.truncate(r.node,i)},utime:function(e,i,r){var n=FS.lookupPath(e,{follow:!0}),f=n.node;f.node_ops.setattr(f,{timestamp:Math.max(i,r)})},open:function(e,i,r,n,f){if(""===e)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);i="string"==typeof i?FS.modeStringToFlags(i):i,r="undefined"==typeof r?438:r,r=64&i?4095&r|32768:0;var t;if("object"==typeof e)t=e;else{e=PATH.normalize(e);try{var u=FS.lookupPath(e,{follow:!(131072&i)});t=u.node}catch(e){}}var a=!1;if(64&i)if(t){if(128&i)throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}else t=FS.mknod(e,r,0),a=!0;if(!t)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(FS.isChrdev(t.mode)&&(i&=-513),!a){var o=FS.mayOpen(t,i);if(o)throw new FS.ErrnoError(o)}512&i&&FS.truncate(t,0),i&=-641;var c=FS.createStream({node:t,path:FS.getPath(t),flags:i,seekable:!0,position:0,stream_ops:t.stream_ops,ungotten:[],error:!1},n,f);c.stream_ops.open&&c.stream_ops.open(c),!Module.logReadFiles||1&i||(FS.readFiles||(FS.readFiles={}),e in FS.readFiles||(FS.readFiles[e]=1,Module.printErr("read file: "+e)));try{if(FS.trackingDelegate.onOpenFile){var l=0;1!==(2097155&i)&&(l|=FS.tracking.openFlags.READ),0!==(2097155&i)&&(l|=FS.tracking.openFlags.WRITE),FS.trackingDelegate.onOpenFile(e,l)}}catch(i){console.log("FS.trackingDelegate['onOpenFile']('"+e+"', flags) threw an exception: "+i.message)}return c},close:function(e){try{e.stream_ops.close&&e.stream_ops.close(e)}catch(e){throw e}finally{FS.closeStream(e.fd)}},llseek:function(e,i,r){if(!e.seekable||!e.stream_ops.llseek)throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);return e.position=e.stream_ops.llseek(e,i,r),e.ungotten=[],e.position},read:function(e,i,r,n,f){if(n<0||f<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(1===(2097155&e.flags))throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(FS.isDir(e.node.mode))throw new FS.ErrnoError(ERRNO_CODES.EISDIR);if(!e.stream_ops.read)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var t=!0;if("undefined"==typeof f)f=e.position,t=!1;else if(!e.seekable)throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);var u=e.stream_ops.read(e,i,r,n,f);return t||(e.position+=u),u},write:function(e,i,r,n,f,t){if(n<0||f<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(0===(2097155&e.flags))throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(FS.isDir(e.node.mode))throw new FS.ErrnoError(ERRNO_CODES.EISDIR);if(!e.stream_ops.write)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);1024&e.flags&&FS.llseek(e,0,2);var u=!0;if("undefined"==typeof f)f=e.position,u=!1;else if(!e.seekable)throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);var a=e.stream_ops.write(e,i,r,n,f,t);u||(e.position+=a);try{e.path&&FS.trackingDelegate.onWriteToFile&&FS.trackingDelegate.onWriteToFile(e.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return a},allocate:function(e,i,r){if(i<0||r<=0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(0===(2097155&e.flags))throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(!FS.isFile(e.node.mode)&&!FS.isDir(node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENODEV);if(!e.stream_ops.allocate)throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);e.stream_ops.allocate(e,i,r)},mmap:function(e,i,r,n,f,t,u){if(1===(2097155&e.flags))throw new FS.ErrnoError(ERRNO_CODES.EACCES);if(!e.stream_ops.mmap)throw new FS.ErrnoError(ERRNO_CODES.ENODEV);return e.stream_ops.mmap(e,i,r,n,f,t,u)},ioctl:function(e,i,r){if(!e.stream_ops.ioctl)throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);return e.stream_ops.ioctl(e,i,r)},readFile:function(e,i){if(i=i||{},i.flags=i.flags||"r",i.encoding=i.encoding||"binary","utf8"!==i.encoding&&"binary"!==i.encoding)throw new Error('Invalid encoding type "'+i.encoding+'"');var r,n=FS.open(e,i.flags),f=FS.stat(e),t=f.size,u=new Uint8Array(t);if(FS.read(n,u,0,t,0),"utf8"===i.encoding){r="";for(var a=new Runtime.UTF8Processor,o=0;o<t;o++)r+=a.processCChar(u[o])}else"binary"===i.encoding&&(r=u);return FS.close(n),r},writeFile:function(e,i,r){if(r=r||{},r.flags=r.flags||"w",r.encoding=r.encoding||"utf8","utf8"!==r.encoding&&"binary"!==r.encoding)throw new Error('Invalid encoding type "'+r.encoding+'"');var n=FS.open(e,r.flags,r.mode);if("utf8"===r.encoding){var f=new Runtime.UTF8Processor,t=new Uint8Array(f.processJSString(i));FS.write(n,t,0,t.length,0,r.canOwn)}else"binary"===r.encoding&&FS.write(n,i,0,i.length,0,r.canOwn);FS.close(n)},cwd:function(){return FS.currentPath},chdir:function(e){var i=FS.lookupPath(e,{follow:!0});if(!FS.isDir(i.node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);var r=FS.nodePermissions(i.node,"x");if(r)throw new FS.ErrnoError(r);FS.currentPath=i.path},createDefaultDirectories:function(){FS.mkdir("/tmp"),FS.mkdir("/home"),FS.mkdir("/home/web_user")},createDefaultDevices:function(){FS.mkdir("/dev"),FS.registerDevice(FS.makedev(1,3),{read:function(){return 0},write:function(){return 0}}),FS.mkdev("/dev/null",FS.makedev(1,3)),TTY.register(FS.makedev(5,0),TTY.default_tty_ops),TTY.register(FS.makedev(6,0),TTY.default_tty1_ops),FS.mkdev("/dev/tty",FS.makedev(5,0)),FS.mkdev("/dev/tty1",FS.makedev(6,0));var e;if("undefined"!=typeof crypto){var i=new Uint8Array(1);e=function(){return crypto.getRandomValues(i),i[0]}}else e=function(){return 256*Math.random()|0};FS.createDevice("/dev","random",e),FS.createDevice("/dev","urandom",e),FS.mkdir("/dev/shm"),FS.mkdir("/dev/shm/tmp")},createStandardStreams:function(){Module.stdin?FS.createDevice("/dev","stdin",Module.stdin):FS.symlink("/dev/tty","/dev/stdin"),Module.stdout?FS.createDevice("/dev","stdout",null,Module.stdout):FS.symlink("/dev/tty","/dev/stdout"),Module.stderr?FS.createDevice("/dev","stderr",null,Module.stderr):FS.symlink("/dev/tty1","/dev/stderr");var e=FS.open("/dev/stdin","r");HEAP32[_stdin>>2]=FS.getPtrForStream(e),assert(0===e.fd,"invalid handle for stdin ("+e.fd+")");var i=FS.open("/dev/stdout","w");HEAP32[_stdout>>2]=FS.getPtrForStream(i),assert(1===i.fd,"invalid handle for stdout ("+i.fd+")");var r=FS.open("/dev/stderr","w");HEAP32[_stderr>>2]=FS.getPtrForStream(r),assert(2===r.fd,"invalid handle for stderr ("+r.fd+")")},ensureErrnoError:function(){FS.ErrnoError||(FS.ErrnoError=function(e,i){this.node=i,this.setErrno=function(e){this.errno=e;for(var i in ERRNO_CODES)if(ERRNO_CODES[i]===e){this.code=i;break}},this.setErrno(e),this.message=ERRNO_MESSAGES[e]},FS.ErrnoError.prototype=new Error,FS.ErrnoError.prototype.constructor=FS.ErrnoError,[ERRNO_CODES.ENOENT].forEach(function(e){FS.genericErrors[e]=new FS.ErrnoError(e),FS.genericErrors[e].stack="<generic error, no stack>"}))},staticInit:function(){FS.ensureErrnoError(),FS.nameTable=new Array(4096),FS.mount(MEMFS,{},"/"),FS.createDefaultDirectories(),FS.createDefaultDevices()},init:function(e,i,r){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)"),FS.init.initialized=!0,FS.ensureErrnoError(),Module.stdin=e||Module.stdin,Module.stdout=i||Module.stdout,Module.stderr=r||Module.stderr,FS.createStandardStreams()},quit:function(){FS.init.initialized=!1;
	for(var e=0;e<FS.streams.length;e++){var i=FS.streams[e];i&&FS.close(i)}},getMode:function(e,i){var r=0;return e&&(r|=365),i&&(r|=146),r},joinPath:function(e,i){var r=PATH.join.apply(null,e);return i&&"/"==r[0]&&(r=r.substr(1)),r},absolutePath:function(e,i){return PATH.resolve(i,e)},standardizePath:function(e){return PATH.normalize(e)},findObject:function(e,i){var r=FS.analyzePath(e,i);return r.exists?r.object:(___setErrNo(r.error),null)},analyzePath:function(e,i){try{var r=FS.lookupPath(e,{follow:!i});e=r.path}catch(e){}var n={isRoot:!1,exists:!1,error:0,name:null,path:null,object:null,parentExists:!1,parentPath:null,parentObject:null};try{var r=FS.lookupPath(e,{parent:!0});n.parentExists=!0,n.parentPath=r.path,n.parentObject=r.node,n.name=PATH.basename(e),r=FS.lookupPath(e,{follow:!i}),n.exists=!0,n.path=r.path,n.object=r.node,n.name=r.node.name,n.isRoot="/"===r.path}catch(e){n.error=e.errno}return n},createFolder:function(e,i,r,n){var f=PATH.join2("string"==typeof e?e:FS.getPath(e),i),t=FS.getMode(r,n);return FS.mkdir(f,t)},createPath:function(e,i,r,n){e="string"==typeof e?e:FS.getPath(e);for(var f=i.split("/").reverse();f.length;){var t=f.pop();if(t){var u=PATH.join2(e,t);try{FS.mkdir(u)}catch(e){}e=u}}return u},createFile:function(e,i,r,n,f){var t=PATH.join2("string"==typeof e?e:FS.getPath(e),i),u=FS.getMode(n,f);return FS.create(t,u)},createDataFile:function(e,i,r,n,f,t){var u=i?PATH.join2("string"==typeof e?e:FS.getPath(e),i):e,a=FS.getMode(n,f),o=FS.create(u,a);if(r){if("string"==typeof r){for(var c=new Array(r.length),l=0,s=r.length;l<s;++l)c[l]=r.charCodeAt(l);r=c}FS.chmod(o,146|a);var b=FS.open(o,"w");FS.write(b,r,0,r.length,0,t),FS.close(b),FS.chmod(o,a)}return o},createDevice:function(e,i,r,n){var f=PATH.join2("string"==typeof e?e:FS.getPath(e),i),t=FS.getMode(!!r,!!n);FS.createDevice.major||(FS.createDevice.major=64);var u=FS.makedev(FS.createDevice.major++,0);return FS.registerDevice(u,{open:function(e){e.seekable=!1},close:function(e){n&&n.buffer&&n.buffer.length&&n(10)},read:function(e,i,n,f,t){for(var u=0,a=0;a<f;a++){var o;try{o=r()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(void 0===o&&0===u)throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);if(null===o||void 0===o)break;u++,i[n+a]=o}return u&&(e.node.timestamp=Date.now()),u},write:function(e,i,r,f,t){for(var u=0;u<f;u++)try{n(i[r+u])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return f&&(e.node.timestamp=Date.now()),u}}),FS.mkdev(f,t,u)},createLink:function(e,i,r,n,f){var t=PATH.join2("string"==typeof e?e:FS.getPath(e),i);return FS.symlink(r,t)},forceLoadFile:function(e){if(e.isDevice||e.isFolder||e.link||e.contents)return!0;var i=!0;if("undefined"!=typeof XMLHttpRequest)throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");if(!Module.read)throw new Error("Cannot load without read() or XMLHttpRequest.");try{e.contents=intArrayFromString(Module.read(e.url),!0),e.usedBytes=e.contents.length}catch(e){i=!1}return i||___setErrNo(ERRNO_CODES.EIO),i},createLazyFile:function(e,i,r,n,f){function t(){this.lengthKnown=!1,this.chunks=[]}if(t.prototype.get=function(e){if(!(e>this.length-1||e<0)){var i=e%this.chunkSize,r=e/this.chunkSize|0;return this.getter(r)[i]}},t.prototype.setDataGetter=function(e){this.getter=e},t.prototype.cacheLength=function(){var e=new XMLHttpRequest;if(e.open("HEAD",r,!1),e.send(null),!(e.status>=200&&e.status<300||304===e.status))throw new Error("Couldn't load "+r+". Status: "+e.status);var i,n=Number(e.getResponseHeader("Content-length")),f=(i=e.getResponseHeader("Accept-Ranges"))&&"bytes"===i,t=1048576;f||(t=n);var u=function(e,i){if(e>i)throw new Error("invalid range ("+e+", "+i+") or no bytes requested!");if(i>n-1)throw new Error("only "+n+" bytes available! programmer error!");var f=new XMLHttpRequest;if(f.open("GET",r,!1),n!==t&&f.setRequestHeader("Range","bytes="+e+"-"+i),"undefined"!=typeof Uint8Array&&(f.responseType="arraybuffer"),f.overrideMimeType&&f.overrideMimeType("text/plain; charset=x-user-defined"),f.send(null),!(f.status>=200&&f.status<300||304===f.status))throw new Error("Couldn't load "+r+". Status: "+f.status);return void 0!==f.response?new Uint8Array(f.response||[]):intArrayFromString(f.responseText||"",!0)},a=this;a.setDataGetter(function(e){var i=e*t,r=(e+1)*t-1;if(r=Math.min(r,n-1),"undefined"==typeof a.chunks[e]&&(a.chunks[e]=u(i,r)),"undefined"==typeof a.chunks[e])throw new Error("doXHR failed!");return a.chunks[e]}),this._length=n,this._chunkSize=t,this.lengthKnown=!0},"undefined"!=typeof XMLHttpRequest){throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var u}else var u={isDevice:!1,url:r};var a=FS.createFile(e,i,u,n,f);u.contents?a.contents=u.contents:u.url&&(a.contents=null,a.url=u.url),Object.defineProperty(a,"usedBytes",{get:function(){return this.contents.length}});var o={},c=Object.keys(a.stream_ops);return c.forEach(function(e){var i=a.stream_ops[e];o[e]=function(){if(!FS.forceLoadFile(a))throw new FS.ErrnoError(ERRNO_CODES.EIO);return i.apply(null,arguments)}}),o.read=function(e,i,r,n,f){if(!FS.forceLoadFile(a))throw new FS.ErrnoError(ERRNO_CODES.EIO);var t=e.node.contents;if(f>=t.length)return 0;var u=Math.min(t.length-f,n);if(assert(u>=0),t.slice)for(var o=0;o<u;o++)i[r+o]=t[f+o];else for(var o=0;o<u;o++)i[r+o]=t.get(f+o);return u},a.stream_ops=o,a},createPreloadedFile:function(e,i,r,n,f,t,u,a,o){function c(r){function c(r){a||FS.createDataFile(e,i,r,n,f,o),t&&t(),removeRunDependency("cp "+l)}var s=!1;Module.preloadPlugins.forEach(function(e){s||e.canHandle(l)&&(e.handle(r,l,c,function(){u&&u(),removeRunDependency("cp "+l)}),s=!0)}),s||c(r)}Browser.init();var l=i?PATH.resolve(PATH.join2(e,i)):e;addRunDependency("cp "+l),"string"==typeof r?Browser.asyncLoad(r,function(e){c(e)},u):c(r)},indexedDB:function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB},DB_NAME:function(){return"EM_FS_"+window.location.pathname},DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function(e,i,r){i=i||function(){},r=r||function(){};var n=FS.indexedDB();try{var f=n.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return r(e)}f.onupgradeneeded=function(){console.log("creating db");var e=f.result;e.createObjectStore(FS.DB_STORE_NAME)},f.onsuccess=function(){function n(){0==c?i():r()}var t=f.result,u=t.transaction([FS.DB_STORE_NAME],"readwrite"),a=u.objectStore(FS.DB_STORE_NAME),o=0,c=0,l=e.length;e.forEach(function(e){var i=a.put(FS.analyzePath(e).object.contents,e);i.onsuccess=function(){o++,o+c==l&&n()},i.onerror=function(){c++,o+c==l&&n()}}),u.onerror=r},f.onerror=r},loadFilesFromDB:function(e,i,r){i=i||function(){},r=r||function(){};var n=FS.indexedDB();try{var f=n.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return r(e)}f.onupgradeneeded=r,f.onsuccess=function(){function n(){0==c?i():r()}var t=f.result;try{var u=t.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){return void r(e)}var a=u.objectStore(FS.DB_STORE_NAME),o=0,c=0,l=e.length;e.forEach(function(e){var i=a.get(e);i.onsuccess=function(){FS.analyzePath(e).exists&&FS.unlink(e),FS.createDataFile(PATH.dirname(e),PATH.basename(e),i.result,!0,!0,!0),o++,o+c==l&&n()},i.onerror=function(){c++,o+c==l&&n()}}),u.onerror=r},f.onerror=r}},SOCKFS={mount:function(e){return Module.websocket=Module.websocket&&"object"==typeof Module.websocket?Module.websocket:{},Module.websocket._callbacks={},Module.websocket.on=function(e,i){return"function"==typeof i&&(this._callbacks[e]=i),this},Module.websocket.emit=function(e,i){"function"==typeof this._callbacks[e]&&this._callbacks[e].call(this,i)},FS.createNode(null,"/",16895,0)},createSocket:function(e,i,r){var n=1==i;r&&assert(n==(6==r));var f={family:e,type:i,protocol:r,server:null,error:null,peers:{},pending:[],recv_queue:[],sock_ops:SOCKFS.websocket_sock_ops},t=SOCKFS.nextname(),u=FS.createNode(SOCKFS.root,t,49152,0);u.sock=f;var a=FS.createStream({path:t,node:u,flags:FS.modeStringToFlags("r+"),seekable:!1,stream_ops:SOCKFS.stream_ops});return f.stream=a,f},getSocket:function(e){var i=FS.getStream(e);return i&&FS.isSocket(i.node.mode)?i.node.sock:null},stream_ops:{poll:function(e){var i=e.node.sock;return i.sock_ops.poll(i)},ioctl:function(e,i,r){var n=e.node.sock;return n.sock_ops.ioctl(n,i,r)},read:function(e,i,r,n,f){var t=e.node.sock,u=t.sock_ops.recvmsg(t,n);return u?(i.set(u.buffer,r),u.buffer.length):0},write:function(e,i,r,n,f){var t=e.node.sock;return t.sock_ops.sendmsg(t,i,r,n)},close:function(e){var i=e.node.sock;i.sock_ops.close(i)}},nextname:function(){return SOCKFS.nextname.current||(SOCKFS.nextname.current=0),"socket["+SOCKFS.nextname.current++ +"]"},websocket_sock_ops:{createPeer:function(e,i,r){var n;if("object"==typeof i&&(n=i,i=null,r=null),n)if(n._socket)i=n._socket.remoteAddress,r=n._socket.remotePort;else{var f=/ws[s]?:\/\/([^:]+):(\d+)/.exec(n.url);if(!f)throw new Error("WebSocket URL must be in the format ws(s)://address:port");i=f[1],r=parseInt(f[2],10)}else try{var t=Module.websocket&&"object"==typeof Module.websocket,u="ws:#".replace("#","//");if(t&&"string"==typeof Module.websocket.url&&(u=Module.websocket.url),"ws://"===u||"wss://"===u){var a=i.split("/");u=u+a[0]+":"+r+"/"+a.slice(1).join("/")}var o="binary";t&&"string"==typeof Module.websocket.subprotocol&&(o=Module.websocket.subprotocol),o=o.replace(/^ +| +$/g,"").split(/ *, */);var c=o,l=window.WebSocket;n=new l(u,c),n.binaryType="arraybuffer"}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH)}var s={addr:i,port:r,socket:n,dgram_send_queue:[]};return SOCKFS.websocket_sock_ops.addPeer(e,s),SOCKFS.websocket_sock_ops.handlePeerEvents(e,s),2===e.type&&"undefined"!=typeof e.sport&&s.dgram_send_queue.push(new Uint8Array([255,255,255,255,"p".charCodeAt(0),"o".charCodeAt(0),"r".charCodeAt(0),"t".charCodeAt(0),(65280&e.sport)>>8,255&e.sport])),s},getPeer:function(e,i,r){return e.peers[i+":"+r]},addPeer:function(e,i){e.peers[i.addr+":"+i.port]=i},removePeer:function(e,i){delete e.peers[i.addr+":"+i.port]},handlePeerEvents:function(e,i){function r(r){assert("string"!=typeof r&&void 0!==r.byteLength),r=new Uint8Array(r);var f=n;if(n=!1,f&&10===r.length&&255===r[0]&&255===r[1]&&255===r[2]&&255===r[3]&&r[4]==="p".charCodeAt(0)&&r[5]==="o".charCodeAt(0)&&r[6]==="r".charCodeAt(0)&&r[7]==="t".charCodeAt(0)){var t=r[8]<<8|r[9];return SOCKFS.websocket_sock_ops.removePeer(e,i),i.port=t,void SOCKFS.websocket_sock_ops.addPeer(e,i)}e.recv_queue.push({addr:i.addr,port:i.port,data:r}),Module.websocket.emit("message",e.stream.fd)}var n=!0,f=function(){Module.websocket.emit("open",e.stream.fd);try{for(var r=i.dgram_send_queue.shift();r;)i.socket.send(r),r=i.dgram_send_queue.shift()}catch(e){i.socket.close()}};i.socket.onopen=f,i.socket.onclose=function(){Module.websocket.emit("close",e.stream.fd)},i.socket.onmessage=function(e){r(e.data)},i.socket.onerror=function(i){e.error=ERRNO_CODES.ECONNREFUSED,Module.websocket.emit("error",[e.stream.fd,e.error,"ECONNREFUSED: Connection refused"])}},poll:function(e){if(1===e.type&&e.server)return e.pending.length?65:0;var i=0,r=1===e.type?SOCKFS.websocket_sock_ops.getPeer(e,e.daddr,e.dport):null;return(e.recv_queue.length||!r||r&&r.socket.readyState===r.socket.CLOSING||r&&r.socket.readyState===r.socket.CLOSED)&&(i|=65),(!r||r&&r.socket.readyState===r.socket.OPEN)&&(i|=4),(r&&r.socket.readyState===r.socket.CLOSING||r&&r.socket.readyState===r.socket.CLOSED)&&(i|=16),i},ioctl:function(e,i,r){switch(i){case 21531:var n=0;return e.recv_queue.length&&(n=e.recv_queue[0].data.length),HEAP32[r>>2]=n,0;default:return ERRNO_CODES.EINVAL}},close:function(e){if(e.server){try{e.server.close()}catch(e){}e.server=null}for(var i=Object.keys(e.peers),r=0;r<i.length;r++){var n=e.peers[i[r]];try{n.socket.close()}catch(e){}SOCKFS.websocket_sock_ops.removePeer(e,n)}return 0},bind:function(e,i,r){if("undefined"!=typeof e.saddr||"undefined"!=typeof e.sport)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(e.saddr=i,e.sport=r||_mkport(),2===e.type){e.server&&(e.server.close(),e.server=null);try{e.sock_ops.listen(e,0)}catch(e){if(!(e instanceof FS.ErrnoError))throw e;if(e.errno!==ERRNO_CODES.EOPNOTSUPP)throw e}}},connect:function(e,i,r){if(e.server)throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);if("undefined"!=typeof e.daddr&&"undefined"!=typeof e.dport){var n=SOCKFS.websocket_sock_ops.getPeer(e,e.daddr,e.dport);if(n)throw n.socket.readyState===n.socket.CONNECTING?new FS.ErrnoError(ERRNO_CODES.EALREADY):new FS.ErrnoError(ERRNO_CODES.EISCONN)}var f=SOCKFS.websocket_sock_ops.createPeer(e,i,r);throw e.daddr=f.addr,e.dport=f.port,new FS.ErrnoError(ERRNO_CODES.EINPROGRESS)},listen:function(e,i){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)},accept:function(e){if(!e.server)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var i=e.pending.shift();return i.stream.flags=e.stream.flags,i},getname:function(e,i){var r,n;if(i){if(void 0===e.daddr||void 0===e.dport)throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);r=e.daddr,n=e.dport}else r=e.saddr||0,n=e.sport||0;return{addr:r,port:n}},sendmsg:function(e,i,r,n,f,t){if(2===e.type){if(void 0!==f&&void 0!==t||(f=e.daddr,t=e.dport),void 0===f||void 0===t)throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ)}else f=e.daddr,t=e.dport;var u=SOCKFS.websocket_sock_ops.getPeer(e,f,t);if(1===e.type){if(!u||u.socket.readyState===u.socket.CLOSING||u.socket.readyState===u.socket.CLOSED)throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);if(u.socket.readyState===u.socket.CONNECTING)throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}var a;if(a=i instanceof Array||i instanceof ArrayBuffer?i.slice(r,r+n):i.buffer.slice(i.byteOffset+r,i.byteOffset+r+n),2===e.type&&(!u||u.socket.readyState!==u.socket.OPEN))return u&&u.socket.readyState!==u.socket.CLOSING&&u.socket.readyState!==u.socket.CLOSED||(u=SOCKFS.websocket_sock_ops.createPeer(e,f,t)),u.dgram_send_queue.push(a),n;try{return u.socket.send(a),n}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}},recvmsg:function(e,i){if(1===e.type&&e.server)throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);var r=e.recv_queue.shift();if(!r){if(1===e.type){var n=SOCKFS.websocket_sock_ops.getPeer(e,e.daddr,e.dport);if(n){if(n.socket.readyState===n.socket.CLOSING||n.socket.readyState===n.socket.CLOSED)return null;throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)}throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}var f=r.data.byteLength||r.data.length,t=r.data.byteOffset||0,u=r.data.buffer||r.data,a=Math.min(i,f),o={buffer:new Uint8Array(u,t,a),addr:r.addr,port:r.port};if(1===e.type&&a<f){var c=f-a;r.data=new Uint8Array(u,t+a,c),e.recv_queue.unshift(r)}return o}}};Module._strlen=_strlen,Module._strcat=_strcat,Module._bitshift64Shl=_bitshift64Shl,Module._strncpy=_strncpy,Module._i64Add=_i64Add;var _fabs=Math_abs,_floor=Math_floor;Module._memset=_memset;var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:function(){Browser.mainLoop.scheduler=null,Browser.mainLoop.currentlyRunningMainloop++},resume:function(){Browser.mainLoop.currentlyRunningMainloop++;var e=Browser.mainLoop.timingMode,i=Browser.mainLoop.timingValue,r=Browser.mainLoop.func;Browser.mainLoop.func=null,_emscripten_set_main_loop(r,0,!1,Browser.mainLoop.arg),_emscripten_set_main_loop_timing(e,i)},updateStatus:function(){if(Module.setStatus){var e=Module.statusMessage||"Please wait...",i=Browser.mainLoop.remainingBlockers,r=Browser.mainLoop.expectedBlockers;i?i<r?Module.setStatus(e+" ("+(r-i)+"/"+r+")"):Module.setStatus(e):Module.setStatus("")}},runIter:function(e){if(!ABORT){if(Module.preMainLoop){var i=Module.preMainLoop();if(i===!1)return}try{e()}catch(e){if(e instanceof ExitStatus)return;throw e&&"object"==typeof e&&e.stack&&Module.printErr("exception thrown: "+[e,e.stack]),e}Module.postMainLoop&&Module.postMainLoop()}}},isFullScreen:!1,pointerLock:!1,moduleContextCreatedCallbacks:[],workers:[],init:function(){function e(){Browser.pointerLock=document.pointerLockElement===n||document.mozPointerLockElement===n||document.webkitPointerLockElement===n||document.msPointerLockElement===n}if(Module.preloadPlugins||(Module.preloadPlugins=[]),!Browser.initted){Browser.initted=!0;try{new Blob,Browser.hasBlobConstructor=!0}catch(e){Browser.hasBlobConstructor=!1,console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder="undefined"!=typeof MozBlobBuilder?MozBlobBuilder:"undefined"!=typeof WebKitBlobBuilder?WebKitBlobBuilder:Browser.hasBlobConstructor?null:console.log("warning: no BlobBuilder"),Browser.URLObject="undefined"!=typeof window?window.URL?window.URL:window.webkitURL:void 0,Module.noImageDecoding||"undefined"!=typeof Browser.URLObject||(console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available."),Module.noImageDecoding=!0);var i={};i.canHandle=function(e){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(e)},i.handle=function(e,i,r,n){var f=null;if(Browser.hasBlobConstructor)try{f=new Blob([e],{type:Browser.getMimetype(i)}),f.size!==e.length&&(f=new Blob([new Uint8Array(e).buffer],{type:Browser.getMimetype(i)}))}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}if(!f){var t=new Browser.BlobBuilder;t.append(new Uint8Array(e).buffer),f=t.getBlob()}var u=Browser.URLObject.createObjectURL(f),a=new Image;a.onload=function(){assert(a.complete,"Image "+i+" could not be decoded");var n=document.createElement("canvas");n.width=a.width,n.height=a.height;var f=n.getContext("2d");f.drawImage(a,0,0),Module.preloadedImages[i]=n,Browser.URLObject.revokeObjectURL(u),r&&r(e)},a.onerror=function(e){console.log("Image "+u+" could not be decoded"),n&&n()},a.src=u},Module.preloadPlugins.push(i);var r={};r.canHandle=function(e){return!Module.noAudioDecoding&&e.substr(-4)in{".ogg":1,".wav":1,".mp3":1}},r.handle=function(e,i,r,n){function f(n){u||(u=!0,Module.preloadedAudios[i]=n,r&&r(e))}function t(){u||(u=!0,Module.preloadedAudios[i]=new Audio,n&&n())}var u=!1;if(!Browser.hasBlobConstructor)return t();try{var a=new Blob([e],{type:Browser.getMimetype(i)})}catch(e){return t()}var o=Browser.URLObject.createObjectURL(a),c=new Audio;c.addEventListener("canplaythrough",function(){f(c)},!1),c.onerror=function(r){function n(e){for(var i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="=",n="",f=0,t=0,u=0;u<e.length;u++)for(f=f<<8|e[u],t+=8;t>=6;){var a=f>>t-6&63;t-=6,n+=i[a]}return 2==t?(n+=i[(3&f)<<4],n+=r+r):4==t&&(n+=i[(15&f)<<2],n+=r),n}u||(console.log("warning: browser could not fully decode audio "+i+", trying slower base64 approach"),c.src="data:audio/x-"+i.substr(-3)+";base64,"+n(e),f(c))},c.src=o,Browser.safeSetTimeout(function(){f(c)},1e4)},Module.preloadPlugins.push(r);var n=Module.canvas;n&&(n.requestPointerLock=n.requestPointerLock||n.mozRequestPointerLock||n.webkitRequestPointerLock||n.msRequestPointerLock||function(){},n.exitPointerLock=document.exitPointerLock||document.mozExitPointerLock||document.webkitExitPointerLock||document.msExitPointerLock||function(){},n.exitPointerLock=n.exitPointerLock.bind(document),document.addEventListener("pointerlockchange",e,!1),document.addEventListener("mozpointerlockchange",e,!1),document.addEventListener("webkitpointerlockchange",e,!1),document.addEventListener("mspointerlockchange",e,!1),Module.elementPointerLock&&n.addEventListener("click",function(e){!Browser.pointerLock&&n.requestPointerLock&&(n.requestPointerLock(),e.preventDefault())},!1))}},createContext:function(e,i,r,n){if(i&&Module.ctx&&e==Module.canvas)return Module.ctx;var f,t;if(i){var u={antialias:!1,alpha:!1};if(n)for(var a in n)u[a]=n[a];t=GL.createContext(e,u),t&&(f=GL.getContext(t).GLctx),e.style.backgroundColor="black"}else f=e.getContext("2d");return f?(r&&(i||assert("undefined"==typeof GLctx,"cannot set in module if GLctx is used, but we are a non-GL context that would replace it"),Module.ctx=f,i&&GL.makeContextCurrent(t),Module.useWebGL=i,Browser.moduleContextCreatedCallbacks.forEach(function(e){e()}),Browser.init()),f):null},destroyContext:function(e,i,r){},fullScreenHandlersInstalled:!1,lockPointer:void 0,resizeCanvas:void 0,requestFullScreen:function(e,i){function r(){Browser.isFullScreen=!1;var e=n.parentNode;(document.webkitFullScreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.mozFullscreenElement||document.fullScreenElement||document.fullscreenElement||document.msFullScreenElement||document.msFullscreenElement||document.webkitCurrentFullScreenElement)===e?(n.cancelFullScreen=document.cancelFullScreen||document.mozCancelFullScreen||document.webkitCancelFullScreen||document.msExitFullscreen||document.exitFullscreen||function(){},n.cancelFullScreen=n.cancelFullScreen.bind(document),Browser.lockPointer&&n.requestPointerLock(),Browser.isFullScreen=!0,Browser.resizeCanvas&&Browser.setFullScreenCanvasSize()):(e.parentNode.insertBefore(n,e),e.parentNode.removeChild(e),Browser.resizeCanvas&&Browser.setWindowedCanvasSize()),Module.onFullScreen&&Module.onFullScreen(Browser.isFullScreen),Browser.updateCanvasDimensions(n)}Browser.lockPointer=e,Browser.resizeCanvas=i,"undefined"==typeof Browser.lockPointer&&(Browser.lockPointer=!0),"undefined"==typeof Browser.resizeCanvas&&(Browser.resizeCanvas=!1);var n=Module.canvas;Browser.fullScreenHandlersInstalled||(Browser.fullScreenHandlersInstalled=!0,document.addEventListener("fullscreenchange",r,!1),document.addEventListener("mozfullscreenchange",r,!1),document.addEventListener("webkitfullscreenchange",r,!1),document.addEventListener("MSFullscreenChange",r,!1));var f=document.createElement("div");n.parentNode.insertBefore(f,n),f.appendChild(n),f.requestFullScreen=f.requestFullScreen||f.mozRequestFullScreen||f.msRequestFullscreen||(f.webkitRequestFullScreen?function(){f.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT)}:null),f.requestFullScreen()},nextRAF:0,fakeRequestAnimationFrame:function(e){var i=Date.now();if(0===Browser.nextRAF)Browser.nextRAF=i+1e3/60;else for(;i+2>=Browser.nextRAF;)Browser.nextRAF+=1e3/60;var r=Math.max(Browser.nextRAF-i,0);setTimeout(e,r)},requestAnimationFrame:function(e){"undefined"==typeof window?Browser.fakeRequestAnimationFrame(e):(window.requestAnimationFrame||(window.requestAnimationFrame=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame||Browser.fakeRequestAnimationFrame),window.requestAnimationFrame(e))},safeCallback:function(e){return function(){if(!ABORT)return e.apply(null,arguments)}},safeRequestAnimationFrame:function(e){return Browser.requestAnimationFrame(function(){ABORT||e()})},safeSetTimeout:function(e,i){return Module.noExitRuntime=!0,setTimeout(function(){ABORT||e()},i)},safeSetInterval:function(e,i){return Module.noExitRuntime=!0,setInterval(function(){ABORT||e()},i)},getMimetype:function(e){return{jpg:"image/jpeg",jpeg:"image/jpeg",png:"image/png",bmp:"image/bmp",ogg:"audio/ogg",wav:"audio/wav",mp3:"audio/mpeg"}[e.substr(e.lastIndexOf(".")+1)]},getUserMedia:function(e){window.getUserMedia||(window.getUserMedia=navigator.getUserMedia||navigator.mozGetUserMedia),window.getUserMedia(e)},getMovementX:function(e){return e.movementX||e.mozMovementX||e.webkitMovementX||0},getMovementY:function(e){return e.movementY||e.mozMovementY||e.webkitMovementY||0},getMouseWheelDelta:function(e){var i=0;switch(e.type){case"DOMMouseScroll":i=e.detail;break;case"mousewheel":i=e.wheelDelta;break;case"wheel":i=e.deltaY;break;default:throw"unrecognized mouse wheel event: "+e.type}return i},mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:function(e){if(Browser.pointerLock)"mousemove"!=e.type&&"mozMovementX"in e?Browser.mouseMovementX=Browser.mouseMovementY=0:(Browser.mouseMovementX=Browser.getMovementX(e),Browser.mouseMovementY=Browser.getMovementY(e)),"undefined"!=typeof SDL?(Browser.mouseX=SDL.mouseX+Browser.mouseMovementX,Browser.mouseY=SDL.mouseY+Browser.mouseMovementY):(Browser.mouseX+=Browser.mouseMovementX,Browser.mouseY+=Browser.mouseMovementY);else{var i=Module.canvas.getBoundingClientRect(),r=Module.canvas.width,n=Module.canvas.height,f="undefined"!=typeof window.scrollX?window.scrollX:window.pageXOffset,t="undefined"!=typeof window.scrollY?window.scrollY:window.pageYOffset;if("touchstart"===e.type||"touchend"===e.type||"touchmove"===e.type){var u=e.touch;if(void 0===u)return;var a=u.pageX-(f+i.left),o=u.pageY-(t+i.top);a*=r/i.width,o*=n/i.height;var c={x:a,y:o};return void("touchstart"===e.type?(Browser.lastTouches[u.identifier]=c,Browser.touches[u.identifier]=c):"touchend"!==e.type&&"touchmove"!==e.type||(Browser.lastTouches[u.identifier]=Browser.touches[u.identifier],Browser.touches[u.identifier]={x:a,y:o}))}var l=e.pageX-(f+i.left),s=e.pageY-(t+i.top);l*=r/i.width,s*=n/i.height,Browser.mouseMovementX=l-Browser.mouseX,Browser.mouseMovementY=s-Browser.mouseY,Browser.mouseX=l,Browser.mouseY=s}},xhrLoad:function(e,i,r){var n=new XMLHttpRequest;n.open("GET",e,!0),n.responseType="arraybuffer",n.onload=function(){200==n.status||0==n.status&&n.response?i(n.response):r()},n.onerror=r,n.send(null)},asyncLoad:function(e,i,r,n){Browser.xhrLoad(e,function(r){assert(r,'Loading data file "'+e+'" failed (no arrayBuffer).'),i(new Uint8Array(r)),n||removeRunDependency("al "+e)},function(i){if(!r)throw'Loading data file "'+e+'" failed.';r()}),n||addRunDependency("al "+e)},resizeListeners:[],updateResizeListeners:function(){var e=Module.canvas;Browser.resizeListeners.forEach(function(i){i(e.width,e.height)})},setCanvasSize:function(e,i,r){var n=Module.canvas;Browser.updateCanvasDimensions(n,e,i),r||Browser.updateResizeListeners()},windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function(){if("undefined"!=typeof SDL){var e=HEAPU32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2];e|=8388608,HEAP32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2]=e}Browser.updateResizeListeners()},setWindowedCanvasSize:function(){if("undefined"!=typeof SDL){var e=HEAPU32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2];e&=-8388609,HEAP32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2]=e}Browser.updateResizeListeners()},updateCanvasDimensions:function(e,i,r){i&&r?(e.widthNative=i,e.heightNative=r):(i=e.widthNative,r=e.heightNative);var n=i,f=r;if(Module.forcedAspectRatio&&Module.forcedAspectRatio>0&&(n/f<Module.forcedAspectRatio?n=Math.round(f*Module.forcedAspectRatio):f=Math.round(n/Module.forcedAspectRatio)),(document.webkitFullScreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.mozFullscreenElement||document.fullScreenElement||document.fullscreenElement||document.msFullScreenElement||document.msFullscreenElement||document.webkitCurrentFullScreenElement)===e.parentNode&&"undefined"!=typeof screen){var t=Math.min(screen.width/n,screen.height/f);n=Math.round(n*t),f=Math.round(f*t)}Browser.resizeCanvas?(e.width!=n&&(e.width=n),e.height!=f&&(e.height=f),"undefined"!=typeof e.style&&(e.style.removeProperty("width"),e.style.removeProperty("height"))):(e.width!=i&&(e.width=i),e.height!=r&&(e.height=r),"undefined"!=typeof e.style&&(n!=i||f!=r?(e.style.setProperty("width",n+"px","important"),e.style.setProperty("height",f+"px","important")):(e.style.removeProperty("width"),e.style.removeProperty("height"))))},wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:function(){var e=Browser.nextWgetRequestHandle;return Browser.nextWgetRequestHandle++,e}};Module._bitshift64Lshr=_bitshift64Lshr;var _BDtoILow=!0,_BDtoIHigh=!0,_environ=allocate(1,"i32*",ALLOC_STATIC),___environ=_environ,ENV={},_labs=Math_abs;Module._memcpy=_memcpy;var _llvm_pow_f64=Math_pow;Module._memmove=_memmove;var _BItoD=!0;Module._strcpy=_strcpy;var ctlz_i8=allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],"i8",ALLOC_STATIC);Module._llvm_ctlz_i32=_llvm_ctlz_i32,FS.staticInit(),__ATINIT__.unshift({func:function(){Module.noFSInit||FS.init.initialized||FS.init()}}),__ATMAIN__.push({func:function(){FS.ignorePermissions=!1}}),__ATEXIT__.push({func:function(){FS.quit()}}),Module.FS_createFolder=FS.createFolder,Module.FS_createPath=FS.createPath,Module.FS_createDataFile=FS.createDataFile,Module.FS_createPreloadedFile=FS.createPreloadedFile,Module.FS_createLazyFile=FS.createLazyFile,Module.FS_createLink=FS.createLink,Module.FS_createDevice=FS.createDevice,___errno_state=Runtime.staticAlloc(4),HEAP32[___errno_state>>2]=0,__ATINIT__.unshift({func:function(){TTY.init()}}),__ATEXIT__.push({func:function(){TTY.shutdown()}}),TTY.utf8=new Runtime.UTF8Processor,__ATINIT__.push({func:function(){SOCKFS.root=FS.mount(SOCKFS,{},null)}}),_fgetc.ret=allocate([0],"i8",ALLOC_STATIC),_fputc.ret=allocate([0],"i8",ALLOC_STATIC),Module.requestFullScreen=function(e,i){Browser.requestFullScreen(e,i)},Module.requestAnimationFrame=function(e){Browser.requestAnimationFrame(e)},Module.setCanvasSize=function(e,i,r){Browser.setCanvasSize(e,i,r)},Module.pauseMainLoop=function(){Browser.mainLoop.pause()},Module.resumeMainLoop=function(){Browser.mainLoop.resume()},Module.getUserMedia=function(){Browser.getUserMedia()},___buildEnvironment(ENV),STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP),staticSealed=!0,STACK_MAX=STACK_BASE+TOTAL_STACK,DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX),assert(DYNAMIC_BASE<TOTAL_MEMORY,"TOTAL_MEMORY not big enough for stack");var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_DYNAMIC);Module.asmGlobalArg={Math:Math,Int8Array:Int8Array,Int16Array:Int16Array,Int32Array:Int32Array,Uint8Array:Uint8Array,Uint16Array:Uint16Array,Uint32Array:Uint32Array,Float32Array:Float32Array,Float64Array:Float64Array},Module.asmLibraryArg={abort:abort,assert:assert,min:Math_min,invoke_iiiiiiii:invoke_iiiiiiii,invoke_iiii:invoke_iiii,invoke_viiiiiii:invoke_viiiiiii,invoke_viiiii:invoke_viiiii,invoke_i:invoke_i,invoke_vi:invoke_vi,invoke_vii:invoke_vii,invoke_iiiiiii:invoke_iiiiiii,invoke_ii:invoke_ii,invoke_viii:invoke_viii,invoke_viiiiiiiii:invoke_viiiiiiiii,invoke_iiiii:invoke_iiiii,invoke_viiiiii:invoke_viiiiii,invoke_iii:invoke_iii,invoke_iiiiii:invoke_iiiiii,invoke_viiii:invoke_viiii,_fabs:_fabs,_llvm_pow_f64:_llvm_pow_f64,_send:_send,_getcwd:_getcwd,_fread:_fread,__reallyNegative:__reallyNegative,_vfprintf:_vfprintf,_emscripten_set_main_loop_timing:_emscripten_set_main_loop_timing,___assert_fail:___assert_fail,_floor:_floor,_fflush:_fflush,_llvm_ctlz_i64:_llvm_ctlz_i64,_pwrite:_pwrite,_strerror_r:_strerror_r,_fprintf:_fprintf,_open:_open,_sbrk:_sbrk,_emscripten_memcpy_big:_emscripten_memcpy_big,_fileno:_fileno,__formatString:__formatString,__exit:__exit,_close:_close,_ferror:_ferror,_munmap:_munmap,___buildEnvironment:___buildEnvironment,_pread:_pread,_printf:_printf,_fclose:_fclose,_write:_write,_fsync:_fsync,___errno_location:___errno_location,_stat:_stat,_recv:_recv,_fgetc:_fgetc,_getenv:_getenv,_sysconf:_sysconf,
	_read:_read,_fputc:_fputc,_emscripten_set_main_loop:_emscripten_set_main_loop,_abort:_abort,_fwrite:_fwrite,_time:_time,_mkport:_mkport,_strerror:_strerror,_gettimeofday:_gettimeofday,_fgets:_fgets,_mmap:_mmap,_fopen:_fopen,_exit:_exit,_labs:_labs,___setErrNo:___setErrNo,STACKTOP:STACKTOP,STACK_MAX:STACK_MAX,tempDoublePtr:tempDoublePtr,ABORT:ABORT,cttz_i8:cttz_i8,ctlz_i8:ctlz_i8,NaN:NaN,Infinity:1/0,_stderr:_stderr,_stdin:_stdin,_stdout:_stdout};var asm=function(e,i,r){"use asm";var n=new e.Int8Array(r);var f=new e.Int16Array(r);var t=new e.Int32Array(r);var u=new e.Uint8Array(r);var a=new e.Uint16Array(r);var o=new e.Uint32Array(r);var c=new e.Float32Array(r);var l=new e.Float64Array(r);var s=i.STACKTOP|0;var b=i.STACK_MAX|0;var k=i.tempDoublePtr|0;var h=i.ABORT|0;var w=i.cttz_i8|0;var d=i.ctlz_i8|0;var v=i._stderr|0;var m=i._stdin|0;var _=i._stdout|0;var p=0;var E=0;var S=0;var g=0;var y=+i.NaN,F=+i.Infinity;var O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0;var P=0;var B=0;var I=0;var H=0;var x=0;var U=0;var z=0;var j=0;var V=0;var q=0;var Y=e.Math.floor;var G=e.Math.abs;var W=e.Math.sqrt;var K=e.Math.pow;var X=e.Math.cos;var Z=e.Math.sin;var J=e.Math.tan;var Q=e.Math.acos;var $=e.Math.asin;var ee=e.Math.atan;var ie=e.Math.atan2;var re=e.Math.exp;var ne=e.Math.log;var fe=e.Math.ceil;var te=e.Math.imul;var ue=i.abort;var ae=i.assert;var oe=i.min;var ce=i.invoke_iiiiiiii;var le=i.invoke_iiii;var se=i.invoke_viiiiiii;var be=i.invoke_viiiii;var ke=i.invoke_i;var he=i.invoke_vi;var we=i.invoke_vii;var de=i.invoke_iiiiiii;var ve=i.invoke_ii;var me=i.invoke_viii;var _e=i.invoke_viiiiiiiii;var pe=i.invoke_iiiii;var Ee=i.invoke_viiiiii;var Se=i.invoke_iii;var ge=i.invoke_iiiiii;var ye=i.invoke_viiii;var Fe=i._fabs;var Oe=i._llvm_pow_f64;var Ae=i._send;var Me=i._getcwd;var Re=i._fread;var Ne=i.__reallyNegative;var Te=i._vfprintf;var Le=i._emscripten_set_main_loop_timing;var De=i.___assert_fail;var Ce=i._floor;var Pe=i._fflush;var Be=i._llvm_ctlz_i64;var Ie=i._pwrite;var He=i._strerror_r;var xe=i._fprintf;var Ue=i._open;var ze=i._sbrk;var je=i._emscripten_memcpy_big;var Ve=i._fileno;var qe=i.__formatString;var Ye=i.__exit;var Ge=i._close;var We=i._ferror;var Ke=i._munmap;var Xe=i.___buildEnvironment;var Ze=i._pread;var Je=i._printf;var Qe=i._fclose;var $e=i._write;var ei=i._fsync;var ii=i.___errno_location;var ri=i._stat;var ni=i._recv;var fi=i._fgetc;var ti=i._getenv;var ui=i._sysconf;var ai=i._read;var oi=i._fputc;var ci=i._emscripten_set_main_loop;var li=i._abort;var si=i._fwrite;var bi=i._time;var ki=i._mkport;var hi=i._strerror;var wi=i._gettimeofday;var di=i._fgets;var vi=i._mmap;var mi=i._fopen;var _i=i._exit;var pi=i._labs;var Ei=i.___setErrNo;var Si=0;function gi(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;t[f>>2]=QN(t[n>>2]|0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}jN(t[n>>2]|0)|0;if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)b=10;else if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)b=11;else b=10;if((b|0)==10)if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)b=11;else Op(t[n>>2]|0);e:do if((b|0)==11?(BN(t[n>>2]|0,73,95624,0,0),(t[(t[n>>2]|0)+288>>2]|0)!=0):0){while(1){k=t[n>>2]|0;if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;e=(u[t[(t[k+36>>2]|0)+16>>2]>>0]|0|0)!=62;Op(t[n>>2]|0);if(!e)break e}Op(k)}while(0);do if((t[(t[n>>2]|0)+248>>2]|0)>0){if(((Xl(t[f>>2]|0,94240)|0)==0?(Xl(t[f>>2]|0,95648)|0)==0:0)?(Xl(t[f>>2]|0,95656)|0)==0:0)break;k=(t[n>>2]|0)+248|0;t[k>>2]=(t[k>>2]|0)+-1;t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}while(0);t[o>>2]=(t[(t[n>>2]|0)+188>>2]|0)-1;while(1){if((t[o>>2]|0)<0)break;if(Xl(t[f>>2]|0,t[(t[(t[n>>2]|0)+196>>2]|0)+(t[o>>2]<<2)>>2]|0)|0)break;t[o>>2]=(t[o>>2]|0)+-1}k=t[n>>2]|0;b=t[f>>2]|0;if((t[o>>2]|0)<0){BN(k,76,95664,b,0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}Hi(k,b);if(((Xl(t[f>>2]|0,t[(t[n>>2]|0)+184>>2]|0)|0)==0?(t[(t[n>>2]|0)+184>>2]|0)!=0:0)?(Xl(t[(t[n>>2]|0)+184>>2]|0,t[f>>2]|0)|0)==0:0)BN(t[n>>2]|0,76,95696,t[f>>2]|0,t[(t[n>>2]|0)+184>>2]|0);t[a>>2]=t[(t[n>>2]|0)+184>>2];if((t[a>>2]|0)!=0?(Xl(t[a>>2]|0,t[f>>2]|0)|0)!=0:0){if((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[n>>2]>>2]|0)+60>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[f>>2]|0);xi(t[n>>2]|0)|0;xN(t[n>>2]|0)|0;t[c>>2]=1}else t[c>>2]=0;t[r>>2]=t[c>>2];l=t[r>>2]|0;s=i;return l|0}BN(t[n>>2]|0,74,95584,0,0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}function yi(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+112|0;r=i+8|0;f=i+4|0;a=i;o=i+12|0;t[f>>2]=e;t[a>>2]=0;if(!(65<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=90:0))c=3;do if((c|0)==3){if(97<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=122:0)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=95?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=58:0){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}}while(0);e:while(1){if((t[a>>2]|0)>=100)break;if(!(65<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)<=90:0))c=11;do if((c|0)==11){c=0;if(97<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)<=122:0)break;if(48<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)<=57:0)break;if(((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)!=58?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)!=45:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)!=95:0)break e}while(0);if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)>=65?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0|0)<=90:0)n[o+(t[a>>2]|0)>>0]=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0)+32;else n[o+(t[a>>2]|0)>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(t[a>>2]|0))>>0]|0;t[a>>2]=(t[a>>2]|0)+1}t[r>>2]=kz(t[(t[f>>2]|0)+296>>2]|0,o,t[a>>2]|0)|0;l=t[r>>2]|0;s=i;return l|0}function Fi(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+1024|0;r=i+12|0;f=i+16|0;a=i+8|0;o=i+4|0;c=i;t[r>>2]=e;t[a>>2]=0;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);t[o>>2]=Ni(t[r>>2]|0,c)|0;e:while(1){if(!(9<=(t[o>>2]|0)&(t[o>>2]|0)<=10|(t[o>>2]|0)==13|32<=(t[o>>2]|0)))break;do if((t[o>>2]|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){e=t[r>>2]|0;if(t[(t[r>>2]|0)+288>>2]|0){l=t[e+184>>2]|0;b=(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2|0;if(!($l(l,b,rs(t[(t[r>>2]|0)+184>>2]|0)|0)|0))break e;BN(t[r>>2]|0,76,95912,t[(t[r>>2]|0)+184>>2]|0,0);break}if((u[(t[(t[e+36>>2]|0)+16>>2]|0)+2>>0]|0|0)>=65?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)<=90:0)break e;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)>=97?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)<=122:0)break e}while(0);if((t[c>>2]|0)==1){e=t[o>>2]&255;b=t[a>>2]|0;t[a>>2]=b+1;n[f+b>>0]=e}else{e=Np(t[c>>2]|0,f+(t[a>>2]|0)|0,t[o>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+e}if((t[a>>2]|0)>=1e3){e=t[t[r>>2]>>2]|0;if(!(t[(t[t[r>>2]>>2]|0)+100>>2]|0)){if(t[e+68>>2]|0)yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0)}else yAi[t[e+100>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);t[a>>2]=0}if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;e=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=e+28|0;t[b>>2]=(t[b>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{b=e+32|0;t[b>>2]=(t[b>>2]|0)+1}t[(t[r>>2]|0)+176>>2]=0;b=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[b>>2]=(t[b>>2]|0)+(t[c>>2]|0);b=(t[r>>2]|0)+200|0;t[b>>2]=(t[b>>2]|0)+1;t[o>>2]=Ni(t[r>>2]|0,c)|0}do if(!(9<=(t[o>>2]|0)&(t[o>>2]|0)<=10|(t[o>>2]|0)==13|32<=(t[o>>2]|0))){if((t[o>>2]|0)==0?(t[(t[r>>2]|0)+292>>2]|0)!=0:0)break;IN(t[r>>2]|0,9,95944,t[o>>2]|0);if((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)>>>0<(t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)Op(t[r>>2]|0)}while(0);if(!(t[a>>2]|0)){s=i;return}if(!(t[t[r>>2]>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+212>>2]|0){s=i;return}o=t[t[r>>2]>>2]|0;if(t[(t[t[r>>2]>>2]|0)+100>>2]|0){yAi[t[o+100>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);s=i;return}if(!(t[o+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);s=i;return}function Oi(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+48|0;r=i+32|0;f=i+28|0;a=i+36|0;o=i+24|0;c=i+20|0;l=i+16|0;b=i+12|0;k=i+8|0;h=i+4|0;w=i;t[r>>2]=e;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){t[b>>2]=0;t[c>>2]=_N(t[r>>2]|0)|0;if(!(t[c>>2]|0)){s=i;return}e=t[c>>2]|0;do if((t[c>>2]|0)>>>0>=128){d=t[c>>2]|0;if(e>>>0<2048){v=t[b>>2]|0;t[b>>2]=v+1;n[a+v>>0]=d>>>6&31|192;t[l>>2]=0;break}v=t[c>>2]|0;if(d>>>0<65536){d=t[b>>2]|0;t[b>>2]=d+1;n[a+d>>0]=v>>>12&15|224;t[l>>2]=6;break}else{d=t[b>>2]|0;t[b>>2]=d+1;n[a+d>>0]=v>>>18&7|240;t[l>>2]=12;break}}else{v=t[b>>2]|0;t[b>>2]=v+1;n[a+v>>0]=e;t[l>>2]=-6}while(0);while(1){if((t[l>>2]|0)<0)break;e=((t[c>>2]|0)>>>(t[l>>2]|0)&63|128)&255;v=t[b>>2]|0;t[b>>2]=v+1;n[a+v>>0]=e;t[l>>2]=(t[l>>2]|0)-6}n[a+(t[b>>2]|0)>>0]=0;Ci(t[r>>2]|0)|0;if(!(t[t[r>>2]>>2]|0)){s=i;return}if(!(t[(t[t[r>>2]>>2]|0)+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,a,t[b>>2]|0);s=i;return}t[f>>2]=mN(t[r>>2]|0,o)|0;if(!(t[o>>2]|0)){Ci(t[r>>2]|0)|0;if(!(t[t[r>>2]>>2]|0)){s=i;return}if(!(t[(t[t[r>>2]>>2]|0)+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,95904,1);s=i;return}if((t[f>>2]|0)!=0?(t[t[f>>2]>>2]|0)>>>0>0:0){t[w>>2]=0;t[k>>2]=t[t[f>>2]>>2];f=t[k>>2]|0;do if((t[k>>2]|0)>>>0>=128){b=t[k>>2]|0;if(f>>>0<2048){l=t[w>>2]|0;t[w>>2]=l+1;n[a+l>>0]=b>>>6&31|192;t[h>>2]=0;break}l=t[k>>2]|0;if(b>>>0<65536){b=t[w>>2]|0;t[w>>2]=b+1;n[a+b>>0]=l>>>12&15|224;t[h>>2]=6;break}else{b=t[w>>2]|0;t[w>>2]=b+1;n[a+b>>0]=l>>>18&7|240;t[h>>2]=12;break}}else{l=t[w>>2]|0;t[w>>2]=l+1;n[a+l>>0]=f;t[h>>2]=-6}while(0);while(1){if((t[h>>2]|0)<0)break;f=((t[k>>2]|0)>>>(t[h>>2]|0)&63|128)&255;l=t[w>>2]|0;t[w>>2]=l+1;n[a+l>>0]=f;t[h>>2]=(t[h>>2]|0)-6}n[a+(t[w>>2]|0)>>0]=0;Ci(t[r>>2]|0)|0;if(!(t[t[r>>2]>>2]|0)){s=i;return}if(!(t[(t[t[r>>2]>>2]|0)+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,a,t[w>>2]|0);s=i;return}Ci(t[r>>2]|0)|0;if(!(t[t[r>>2]>>2]|0)){s=i;return}if(!(t[(t[t[r>>2]>>2]|0)+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,95904,1);w=t[(t[t[r>>2]>>2]|0)+68>>2]|0;a=t[(t[r>>2]|0)+4>>2]|0;r=t[o>>2]|0;h=rs(t[o>>2]|0)|0;yAi[w&511](a,r,h);s=i;return}function Ai(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+1040|0;r=i+16|0;f=i+20|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[r>>2]=e;t[a>>2]=0;t[l>>2]=0;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);t[o>>2]=Ni(t[r>>2]|0,c)|0;while(1){if((t[o>>2]|0)==60?(t[(t[r>>2]|0)+176>>2]|0)!=60:0)break;if((t[o>>2]|0)!=38){if(!(t[o>>2]|0))break}else if(!((t[o>>2]|0)!=0?(t[(t[r>>2]|0)+176>>2]|0)==38:0))break;e=t[o>>2]|0;if((t[o>>2]|0)<256)if(9<=(e|0)&(t[o>>2]|0)<=10|(t[o>>2]|0)==13|32<=(t[o>>2]|0))b=16;else b=15;else if((!(256<=(e|0)&(t[o>>2]|0)<=55295)?!(57344<=(t[o>>2]|0)&(t[o>>2]|0)<=65533):0)?!(65536<=(t[o>>2]|0)&(t[o>>2]|0)<=1114111):0)b=15;else b=16;do if((b|0)==15){b=0;IN(t[r>>2]|0,9,95944,t[o>>2]|0)}else if((b|0)==16){b=0;if((t[c>>2]|0)==1){e=t[o>>2]&255;k=t[a>>2]|0;t[a>>2]=k+1;n[f+k>>0]=e;break}else{e=Np(t[c>>2]|0,f+(t[a>>2]|0)|0,t[o>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+e;break}}while(0);if((t[a>>2]|0)>=1e3){do if((t[t[r>>2]>>2]|0)!=0?(t[(t[r>>2]|0)+212>>2]|0)==0:0){e=(Ui(t[r>>2]|0,f,t[a>>2]|0)|0)!=0;k=t[r>>2]|0;if(!e){Ci(k)|0;if(!(t[(t[t[r>>2]>>2]|0)+68>>2]|0))break;yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);break}e=t[t[r>>2]>>2]|0;if(t[k+208>>2]|0){if(!(t[e+68>>2]|0))break;yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);break}else{if(!(t[e+72>>2]|0))break;yAi[t[(t[t[r>>2]>>2]|0)+72>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);break}}while(0);t[a>>2]=0}e=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=e+28|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{k=e+32|0;t[k>>2]=(t[k>>2]|0)+1}t[(t[r>>2]|0)+176>>2]=0;k=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+(t[c>>2]|0);k=(t[r>>2]|0)+200|0;t[k>>2]=(t[k>>2]|0)+1;t[l>>2]=(t[l>>2]|0)+1;if((t[l>>2]|0)>100){t[l>>2]=0;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[r>>2]|0)+36>>2]|0,250)|0}t[o>>2]=Ni(t[r>>2]|0,c)|0;if(t[o>>2]|0)continue;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;t[o>>2]=Ni(t[r>>2]|0,c)|0}if(!(t[a>>2]|0)){if(t[o>>2]|0){s=i;return}t[(t[r>>2]|0)+172>>2]=-1;s=i;return}n[f+(t[a>>2]|0)>>0]=0;if(!(t[t[r>>2]>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+212>>2]|0){s=i;return}o=(Ui(t[r>>2]|0,f,t[a>>2]|0)|0)!=0;c=t[r>>2]|0;if(!o){Ci(c)|0;if(!(t[(t[t[r>>2]>>2]|0)+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);s=i;return}o=t[t[r>>2]>>2]|0;if(t[c+208>>2]|0){if(!(t[o+68>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);s=i;return}else{if(!(t[o+72>>2]|0)){s=i;return}yAi[t[(t[t[r>>2]>>2]|0)+72>>2]&511](t[(t[r>>2]|0)+4>>2]|0,f,t[a>>2]|0);s=i;return}}function Mi(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[(t[r>>2]|0)+52>>2]|0)!=0?(t[(t[r>>2]|0)+68>>2]|0)!=0:0){t[(t[(t[r>>2]|0)+448>>2]|0)+12>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0));t[(t[(t[r>>2]|0)+448>>2]|0)+16>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2];t[t[(t[r>>2]|0)+448>>2]>>2]=t[(t[r>>2]|0)+52>>2];Vp(t[r>>2]|0,t[(t[r>>2]|0)+448>>2]|0);xi(t[r>>2]|0)|0}if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0){s=i;return}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13){s=i;return}if(32<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)){s=i;return}UN(t[r>>2]|0);s=i;return}function Ri(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0;i=s;s=s+48|0;r=i+32|0;f=i+28|0;a=i+24|0;o=i+4|0;c=i;t[r>>2]=e;t[o+0>>2]=0;t[o+4>>2]=0;t[o+8>>2]=0;t[o+12>>2]=0;t[o+16>>2]=0;if((t[r>>2]|0)!=0?(t[(t[r>>2]|0)+36>>2]|0)!=0:0){if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}if(t[(t[r>>2]|0)+68>>2]|0){t[o+4>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0));t[o+8>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2]}t[c>>2]=HN(t[r>>2]|0)|0;t[f>>2]=t[(t[r>>2]|0)+184>>2];if((t[c>>2]|0)==-1|(t[f>>2]|0)==0){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62){s=i;return}Op(t[r>>2]|0);s=i;return}t[a>>2]=kN(t[f>>2]|0)|0;if(!(t[a>>2]|0))BN(t[r>>2]|0,801,94576,t[f>>2]|0,0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)==47?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)==62:0){c=(t[r>>2]|0)+200|0;t[c>>2]=(t[c>>2]|0)+2;c=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[c>>2]=(t[c>>2]|0)+2;c=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[c>>2]=(t[c>>2]|0)+2;if((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[r>>2]>>2]|0)+60>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[f>>2]|0);xN(t[r>>2]|0)|0;s=i;return}c=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62){BN(c,73,94592,t[f>>2]|0,0);if(Xl(t[f>>2]|0,t[(t[r>>2]|0)+184>>2]|0)|0){nE(t[r>>2]|0)|0;xN(t[r>>2]|0)|0}if(t[(t[r>>2]|0)+68>>2]|0)Di(t[r>>2]|0,o)|0;Mi(t[r>>2]|0);s=i;return}Op(c);if((t[a>>2]|0)!=0?(n[(t[a>>2]|0)+7>>0]|0)!=0:0){if((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[r>>2]>>2]|0)+60>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[f>>2]|0);xN(t[r>>2]|0)|0;s=i;return}if(!(t[(t[r>>2]|0)+68>>2]|0)){s=i;return}Di(t[r>>2]|0,o)|0;s=i;return}BN(t[r>>2]|0,1,97568,0,0);s=i;return}function Ni(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+208|0;f=r;a=r+40|0;o=r+36|0;c=r+32|0;l=r+28|0;b=r+194|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+44|0;t[o>>2]=e;t[c>>2]=i;if((t[(t[o>>2]|0)+172>>2]|0)==-1){t[a>>2]=0;v=t[a>>2]|0;s=r;return v|0}if(t[(t[o>>2]|0)+176>>2]|0){t[t[c>>2]>>2]=0;t[a>>2]=t[(t[o>>2]|0)+176>>2];v=t[a>>2]|0;s=r;return v|0}if((t[(t[o>>2]|0)+256>>2]|0)!=1){t[t[c>>2]>>2]=1;i=t[o>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<128){t[a>>2]=u[t[(t[i+36>>2]|0)+16>>2]>>0];v=t[a>>2]|0;s=r;return v|0}t[h>>2]=zi(i)|0;i=t[o>>2]|0;do if(t[h>>2]|0){if(t[(t[i+36>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[o>>2]|0)+36>>2]|0)+44>>2]|0);t[(t[(t[o>>2]|0)+36>>2]|0)+44>>2]=t[h>>2];t[w>>2]=V_(t[h>>2]|0)|0;e=t[o>>2]|0;if(t[w>>2]|0){Lp(e,t[w>>2]|0)|0;break}else{BN(e,81,96008,t[h>>2]|0,0);break}}else Tp(i,10)|0;while(0);t[(t[o>>2]|0)+256>>2]=1;t[a>>2]=Ap(t[o>>2]|0,t[c>>2]|0)|0;v=t[a>>2]|0;s=r;return v|0}t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2];n[b>>0]=n[t[l>>2]>>0]|0;if(!((u[b>>0]|0)&128)){if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)>>>0<(t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)>>>0:0){IN(t[o>>2]|0,9,95976,0);t[t[c>>2]>>2]=1;t[a>>2]=32;v=t[a>>2]|0;s=r;return v|0}t[t[c>>2]>>2]=1;t[a>>2]=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0];v=t[a>>2]|0;s=r;return v|0}if(!(u[(t[l>>2]|0)+1>>0]|0)){yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]}e:do if(((u[(t[l>>2]|0)+1>>0]|0)&192|0)==128){do if(((u[b>>0]|0)&224|0)==224){if(!(u[(t[l>>2]|0)+2>>0]|0)){yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]}if(((u[(t[l>>2]|0)+2>>0]|0)&192|0)!=128)break e;if(((u[b>>0]|0)&240|0)!=240){t[t[c>>2]>>2]=3;t[k>>2]=((u[t[l>>2]>>0]|0)&15)<<12;t[k>>2]=t[k>>2]|((u[(t[l>>2]|0)+1>>0]|0)&63)<<6;t[k>>2]=t[k>>2]|(u[(t[l>>2]|0)+2>>0]|0)&63;break}if(!(u[(t[l>>2]|0)+3>>0]|0)){yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]}if(((u[b>>0]|0)&248|0)!=240)break e;if(((u[(t[l>>2]|0)+3>>0]|0)&192|0)!=128)break e;t[t[c>>2]>>2]=4;t[k>>2]=((u[t[l>>2]>>0]|0)&7)<<18;t[k>>2]=t[k>>2]|((u[(t[l>>2]|0)+1>>0]|0)&63)<<12;t[k>>2]=t[k>>2]|((u[(t[l>>2]|0)+2>>0]|0)&63)<<6;t[k>>2]=t[k>>2]|(u[(t[l>>2]|0)+3>>0]|0)&63}else{t[t[c>>2]>>2]=2;t[k>>2]=((u[t[l>>2]>>0]|0)&31)<<6;t[k>>2]=t[k>>2]|(u[(t[l>>2]|0)+1>>0]|0)&63}while(0);i=t[k>>2]|0;if((t[k>>2]|0)>>>0<256){if(!(9<=i>>>0&(t[k>>2]|0)>>>0<=10|(t[k>>2]|0)==13|32<=(t[k>>2]|0)>>>0))m=27}else if((!(256<=i>>>0&(t[k>>2]|0)>>>0<=55295)?!(57344<=(t[k>>2]|0)>>>0&(t[k>>2]|0)>>>0<=65533):0)?!(65536<=(t[k>>2]|0)>>>0&(t[k>>2]|0)>>>0<=1114111):0)m=27;if((m|0)==27)IN(t[o>>2]|0,9,95976,t[k>>2]|0);t[a>>2]=t[k>>2];v=t[a>>2]|0;s=r;return v|0}while(0);k=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4){m=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;l=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;b=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[f>>2]=k;t[f+4>>2]=m;t[f+8>>2]=l;t[f+12>>2]=b;SY(d,149,96032,f)|0}else{t[f>>2]=k;SY(d,149,96072,f)|0}BN(t[o>>2]|0,81,96088,d,0);t[(t[o>>2]|0)+256>>2]=10;t[t[c>>2]>>2]=1;t[a>>2]=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0];v=t[a>>2]|0;s=r;return v|0}function Ti(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=0;if((((((Pq(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)|0)==83?(Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)|0)==89:0)?(Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==83:0)?(Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==84:0)?(Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==69:0)?(Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==77:0){i=(t[n>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+6;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BN(t[n>>2]|0,65,97056,0,0)}while(0);jN(t[n>>2]|0)|0;t[a>>2]=ji(t[n>>2]|0)|0;if(t[a>>2]|0){o=t[a>>2]|0;s=r;return o|0}BN(t[n>>2]|0,70,97088,0,0);o=t[a>>2]|0;s=r;return o|0}if((Pq(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)|0)!=80){o=t[a>>2]|0;s=r;return o|0}if((Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)|0)!=85){o=t[a>>2]|0;s=r;return o|0}if((Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)!=66){o=t[a>>2]|0;s=r;return o|0}if((Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)!=76){o=t[a>>2]|0;s=r;return o|0}if((Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)!=73){o=t[a>>2]|0;s=r;return o|0}if((Pq(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)!=67){o=t[a>>2]|0;s=r;return o|0}i=(t[n>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+6;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BN(t[n>>2]|0,65,97128,0,0)}while(0);jN(t[n>>2]|0)|0;i=Vi(t[n>>2]|0)|0;t[t[f>>2]>>2]=i;if(!(t[t[f>>2]>>2]|0))BN(t[n>>2]|0,71,97160,0,0);jN(t[n>>2]|0)|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39:0){o=t[a>>2]|0;s=r;return o|0}t[a>>2]=ji(t[n>>2]|0)|0;o=t[a>>2]|0;s=r;return o|0}function Li(e,i,r,f,a,o){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;c=s;s=s+48|0;l=c+36|0;b=c+32|0;k=c+43|0;h=c+42|0;w=c+41|0;d=c+28|0;v=c+24|0;m=c+20|0;_=c+16|0;p=c+12|0;E=c+8|0;S=c+4|0;g=c;y=c+40|0;t[b>>2]=e;n[k>>0]=i;n[h>>0]=r;n[w>>0]=f;t[d>>2]=a;t[v>>2]=o;t[S>>2]=0;t[g>>2]=0;n[y>>0]=0;t[p>>2]=t[(t[b>>2]|0)+36>>2];if(!(t[p>>2]|0)){t[l>>2]=-1;F=t[l>>2]|0;s=c;return F|0}t[m>>2]=(t[(t[p>>2]|0)+16>>2]|0)-(t[(t[p>>2]|0)+12>>2]|0);if((t[m>>2]|0)<0){t[l>>2]=-1;F=t[l>>2]|0;s=c;return F|0}if((t[(t[b>>2]|0)+204>>2]|0)>(t[m>>2]|0))t[m>>2]=t[(t[b>>2]|0)+204>>2];o=t[p>>2]|0;if(!(t[t[p>>2]>>2]|0)){t[E>>2]=t[o+12>>2];t[_>>2]=t[(t[p>>2]|0)+24>>2]}else{t[E>>2]=Os(t[(t[o>>2]|0)+16>>2]|0)|0;t[_>>2]=Ts(t[(t[t[p>>2]>>2]|0)+16>>2]|0)|0}if(!(n[w>>0]|0)){if(n[h>>0]|0)t[_>>2]=(t[_>>2]|0)+-1}else t[_>>2]=(t[_>>2]|0)-2;e:while(1){O=(t[S>>2]|0)!=0;if((t[m>>2]|0)>=(t[_>>2]|0)){A=45;break}if(((((!O?!((t[d>>2]|0)!=0?1:((t[m>>2]|0)+4|0)>=(t[_>>2]|0)):0)?(u[(t[E>>2]|0)+(t[m>>2]|0)>>0]|0)==60:0)?(u[(t[E>>2]|0)+((t[m>>2]|0)+1)>>0]|0)==33:0)?(u[(t[E>>2]|0)+((t[m>>2]|0)+2)>>0]|0)==45:0)?(u[(t[E>>2]|0)+((t[m>>2]|0)+3)>>0]|0)==45:0){t[S>>2]=1;t[m>>2]=(t[m>>2]|0)+2}do if(t[v>>2]|0){if((u[(t[E>>2]|0)+(t[m>>2]|0)>>0]|0)!=34?(u[(t[E>>2]|0)+(t[m>>2]|0)>>0]|0)!=39:0)if(t[g>>2]|0)break;else{A=30;break}o=n[(t[E>>2]|0)+(t[m>>2]|0)>>0]|0;if(!(t[g>>2]|0)){n[y>>0]=o;t[g>>2]=1;break}if((o&255|0)==(n[y>>0]|0))t[g>>2]=0;else A=30}else A=30;while(0);do if((A|0)==30){A=0;o=t[m>>2]|0;if(t[S>>2]|0){if((o+3|0)>(t[_>>2]|0)){A=32;break e}if((u[(t[E>>2]|0)+(t[m>>2]|0)>>0]|0)!=45)break;if((u[(t[E>>2]|0)+((t[m>>2]|0)+1)>>0]|0)!=45)break;if((u[(t[E>>2]|0)+((t[m>>2]|0)+2)>>0]|0)!=62)break;t[S>>2]=0;t[m>>2]=(t[m>>2]|0)+2;break}if((u[(t[E>>2]|0)+o>>0]|0)==(u[k>>0]|0))if(u[w>>0]|0){if((u[(t[E>>2]|0)+((t[m>>2]|0)+1)>>0]|0)!=(u[h>>0]|0))break;if((u[(t[E>>2]|0)+((t[m>>2]|0)+2)>>0]|0)!=(u[w>>0]|0))break;else{A=43;break e}}else{if(!(u[h>>0]|0)){A=43;break e}if((u[(t[E>>2]|0)+((t[m>>2]|0)+1)>>0]|0)!=(u[h>>0]|0))break;else{A=43;break e}}}while(0);t[m>>2]=(t[m>>2]|0)+1}if((A|0)==32){t[l>>2]=-1;F=t[l>>2]|0;s=c;return F|0}else if((A|0)==43){t[(t[b>>2]|0)+204>>2]=0;t[l>>2]=(t[m>>2]|0)-((t[(t[p>>2]|0)+16>>2]|0)-(t[(t[p>>2]|0)+12>>2]|0));F=t[l>>2]|0;s=c;return F|0}else if((A|0)==45){if(!(O|(t[g>>2]|0)!=0))t[(t[b>>2]|0)+204>>2]=t[m>>2];t[l>>2]=-1;F=t[l>>2]|0;s=c;return F|0}return 0}function Di(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[f>>2]|0)+452>>2]|0)>=(t[(t[f>>2]|0)+456>>2]|0)){if(!(t[(t[f>>2]|0)+456>>2]|0))t[(t[f>>2]|0)+456>>2]=5;i=(t[f>>2]|0)+456|0;t[i>>2]=t[i>>2]<<1;i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+460>>2]|0,(t[(t[f>>2]|0)+456>>2]|0)*20|0)|0;t[(t[f>>2]|0)+460>>2]=i;if(!(t[(t[f>>2]|0)+460>>2]|0)){CN(t[f>>2]|0,0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}}i=(t[(t[f>>2]|0)+460>>2]|0)+((t[(t[f>>2]|0)+452>>2]|0)*20|0)|0;e=t[u>>2]|0;t[i+0>>2]=t[e+0>>2];t[i+4>>2]=t[e+4>>2];t[i+8>>2]=t[e+8>>2];t[i+12>>2]=t[e+12>>2];t[i+16>>2]=t[e+16>>2];t[(t[f>>2]|0)+448>>2]=(t[(t[f>>2]|0)+460>>2]|0)+((t[(t[f>>2]|0)+452>>2]|0)*20|0);e=(t[f>>2]|0)+452|0;f=t[e>>2]|0;t[e>>2]=f+1;t[n>>2]=f;a=t[n>>2]|0;s=r;return a|0}function Ci(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}t[f>>2]=t[(t[n>>2]|0)+184>>2];if(!(t[f>>2]|0)){$N(t[n>>2]|0,96176);eT(t[n>>2]|0,96176);nT(t[n>>2]|0,96176)|0;if((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+56>>2]|0)!=0:0)yAi[t[(t[t[n>>2]>>2]|0)+56>>2]&511](t[(t[n>>2]|0)+4>>2]|0,96176,0);t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}if(!(t[23702]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[u>>2]=0;while(1){if(!(t[96184+(t[u>>2]<<2)>>2]|0)){o=18;break}if(Xl(t[f>>2]|0,t[96184+(t[u>>2]<<2)>>2]|0)|0)break;t[u>>2]=(t[u>>2]|0)+1}if((o|0)==18){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}$N(t[n>>2]|0,96176);eT(t[n>>2]|0,96176);nT(t[n>>2]|0,96176)|0;if((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+56>>2]|0)!=0:0)yAi[t[(t[t[n>>2]>>2]|0)+56>>2]&511](t[(t[n>>2]|0)+4>>2]|0,96176,0);t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}function Pi(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;n=s;s=s+48|0;f=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[w>>2]=0;t[k>>2]=t[(t[a>>2]|0)+36>>2];if(!(t[k>>2]|0)){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}t[l>>2]=(t[(t[k>>2]|0)+16>>2]|0)-(t[(t[k>>2]|0)+12>>2]|0);if((t[l>>2]|0)<0){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}if((t[(t[a>>2]|0)+204>>2]|0)>(t[l>>2]|0))t[l>>2]=t[(t[a>>2]|0)+204>>2];r=t[k>>2]|0;if(!(t[t[k>>2]>>2]|0)){t[h>>2]=t[r+12>>2];t[b>>2]=t[(t[k>>2]|0)+24>>2]}else{t[h>>2]=Os(t[(t[r>>2]|0)+16>>2]|0)|0;t[b>>2]=Ts(t[(t[t[k>>2]>>2]|0)+16>>2]|0)|0}e:while(1){if((t[l>>2]|0)>=(t[b>>2]|0)){m=31;break}if((((((t[w>>2]|0)==0?((t[l>>2]|0)+4|0)<(t[b>>2]|0):0)?(u[(t[h>>2]|0)+(t[l>>2]|0)>>0]|0|0)==60:0)?(u[(t[h>>2]|0)+((t[l>>2]|0)+1)>>0]|0|0)==33:0)?(u[(t[h>>2]|0)+((t[l>>2]|0)+2)>>0]|0|0)==45:0)?(u[(t[h>>2]|0)+((t[l>>2]|0)+3)>>0]|0|0)==45:0){t[w>>2]=1;t[l>>2]=(t[l>>2]|0)+2}i:do if(t[w>>2]|0){if(((t[l>>2]|0)+3|0)>(t[b>>2]|0)){m=20;break e}if(((u[(t[h>>2]|0)+(t[l>>2]|0)>>0]|0|0)==45?(u[(t[h>>2]|0)+((t[l>>2]|0)+1)>>0]|0|0)==45:0)?(u[(t[h>>2]|0)+((t[l>>2]|0)+2)>>0]|0|0)==62:0){t[w>>2]=0;t[l>>2]=(t[l>>2]|0)+2}}else{t[d>>2]=0;while(1){if((t[d>>2]|0)>=(t[c>>2]|0))break i;if((u[(t[h>>2]|0)+(t[l>>2]|0)>>0]|0|0)==(u[(t[o>>2]|0)+(t[d>>2]|0)>>0]|0|0)){m=28;break e}t[d>>2]=(t[d>>2]|0)+1}}while(0);t[l>>2]=(t[l>>2]|0)+1}if((m|0)==20){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==28){t[(t[a>>2]|0)+204>>2]=0;t[f>>2]=(t[l>>2]|0)-((t[(t[k>>2]|0)+16>>2]|0)-(t[(t[k>>2]|0)+12>>2]|0));v=t[f>>2]|0;s=n;return v|0}else if((m|0)==31){t[(t[a>>2]|0)+204>>2]=t[l>>2];t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}return 0}function Bi(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}if(t[(t[n>>2]|0)+360>>2]&2097152){s=r;return}if(!((t[f>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]|0)==0:0)){s=r;return}while(1){if((u[t[f>>2]>>0]|0|0)!=32?(u[t[f>>2]>>0]|0|0)!=9:0)break;t[f>>2]=(t[f>>2]|0)+1}if(t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]|0);i=Yl(t[f>>2]|0)|0;t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]=i;t[a>>2]=B_(t[f>>2]|0)|0;do if((t[a>>2]|0)==-1){t[o>>2]=V_(t[f>>2]|0)|0;i=t[n>>2]|0;if(t[o>>2]|0){Lp(i,t[o>>2]|0)|0;t[(t[n>>2]|0)+256>>2]=1;break}else{BN(i,32,94872,t[f>>2]|0,0);break}}else{if(((t[a>>2]|0)==2|(t[a>>2]|0)==3|(t[a>>2]|0)==4|(t[a>>2]|0)==5?(t[t[(t[n>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+12>>2]|0)==0:0)BN(t[n>>2]|0,81,94832,0,0);else Tp(t[n>>2]|0,t[a>>2]|0)|0;t[(t[n>>2]|0)+256>>2]=1}while(0);if(!(t[t[(t[n>>2]|0)+36>>2]>>2]|0)){s=r;return}if(!(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+12>>2]|0)){s=r;return}if(!(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+20>>2]|0)){s=r;return}if(!(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+16>>2]|0)){s=r;return}t[l>>2]=(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0);ys(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[l>>2]|0)|0;t[c>>2]=Y_(t[t[(t[n>>2]|0)+36>>2]>>2]|0,1)|0;if((t[c>>2]|0)<0)BN(t[n>>2]|0,81,94912,0,0);zs(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[n>>2]|0)+36>>2]|0)|0;s=r;return}function Ii(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;e=t[r>>2]|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){Op(e);t[n>>2]=qi(t[r>>2]|0,34)|0;f=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){BN(f,40,97944,0,0);break}else{Op(f);break}}else{f=t[r>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=39){t[n>>2]=qi(f,0)|0;if(t[n>>2]|0)break;BN(t[r>>2]|0,41,97992,0,0);break}Op(f);t[n>>2]=qi(t[r>>2]|0,39)|0;f=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){BN(f,40,97968,0,0);break}else{Op(f);break}}while(0);s=i;return t[n>>2]|0}function Hi(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=Yi(t[u>>2]|0)|0;t[o>>2]=(t[(t[f>>2]|0)+188>>2]|0)-1;while(1){if((t[o>>2]|0)<0)break;if(Xl(t[u>>2]|0,t[(t[(t[f>>2]|0)+196>>2]|0)+(t[o>>2]<<2)>>2]|0)|0)break;i=Yi(t[(t[(t[f>>2]|0)+196>>2]|0)+(t[o>>2]<<2)>>2]|0)|0;if((i|0)>(t[c>>2]|0)){l=15;break}t[o>>2]=(t[o>>2]|0)+-1}if((l|0)==15){s=r;return}if((t[o>>2]|0)<0){s=r;return}while(1){if(!((Xl(t[u>>2]|0,t[(t[f>>2]|0)+184>>2]|0)|0)!=0^1))break;t[a>>2]=kN(t[(t[f>>2]|0)+184>>2]|0)|0;if((t[a>>2]|0)!=0?(n[(t[a>>2]|0)+5>>0]|0)==3:0)BN(t[f>>2]|0,76,95696,t[u>>2]|0,t[(t[f>>2]|0)+184>>2]|0);if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[f>>2]>>2]|0)+60>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[(t[f>>2]|0)+184>>2]|0);xN(t[f>>2]|0)|0}s=r;return}function xi(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[(t[n>>2]|0)+452>>2]|0)<=0){t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}e=(t[n>>2]|0)+452|0;t[e>>2]=(t[e>>2]|0)+-1;if((t[(t[n>>2]|0)+452>>2]|0)<0){t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}e=t[n>>2]|0;if((t[(t[n>>2]|0)+452>>2]|0)>0)t[(t[n>>2]|0)+448>>2]=(t[(t[n>>2]|0)+460>>2]|0)+(((t[e+452>>2]|0)-1|0)*20|0);else t[e+448>>2]=0;t[r>>2]=(t[(t[n>>2]|0)+460>>2]|0)+((t[(t[n>>2]|0)+452>>2]|0)*20|0);f=t[r>>2]|0;s=i;return f|0}function Ui(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;n=s;s=s+32|0;f=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=0;
	e:while(1){if((t[b>>2]|0)>=(t[c>>2]|0))break;do if((u[(t[o>>2]|0)+(t[b>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[o>>2]|0)+(t[b>>2]|0)>>0]|0|0)?(u[(t[o>>2]|0)+(t[b>>2]|0)>>0]|0|0)<=10:0)break;if((u[(t[o>>2]|0)+(t[b>>2]|0)>>0]|0|0)!=13){w=7;break e}}while(0);t[b>>2]=(t[b>>2]|0)+1}if((w|0)==7){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if(!(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if(!(t[(t[a>>2]|0)+184>>2]|0)){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}if(Xl(t[(t[a>>2]|0)+184>>2]|0,94240)|0){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}if(Xl(t[(t[a>>2]|0)+184>>2]|0,95656)|0){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}do if((((Xl(t[(t[a>>2]|0)+184>>2]|0,95648)|0)!=0?(t[(t[a>>2]|0)+8>>2]|0)!=0:0)?(t[h>>2]=Qg(t[(t[a>>2]|0)+8>>2]|0)|0,(t[h>>2]|0)!=0):0)?(t[(t[h>>2]|0)+52>>2]|0)!=0:0){if((Ql(t[(t[h>>2]|0)+52>>2]|0,96272)|0)!=0?(Ql(t[(t[h>>2]|0)+52>>2]|0,96304)|0)!=0:0)break;t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}while(0);if(!(t[(t[a>>2]|0)+52>>2]|0)){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[k>>2]=Uy(t[(t[a>>2]|0)+52>>2]|0)|0;while(1){if(t[k>>2]|0)v=(t[(t[k>>2]|0)+4>>2]|0)==8;else v=0;m=t[k>>2]|0;if(!v)break;t[k>>2]=t[m+28>>2]}e:do if(!m){if((t[(t[(t[a>>2]|0)+52>>2]|0)+4>>2]|0)!=1?(t[(t[(t[a>>2]|0)+52>>2]|0)+40>>2]|0)!=0:0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[l>>2]=0;while(1){if((t[l>>2]|0)>>>0>=53)break e;if(Xl(t[(t[a>>2]|0)+184>>2]|0,t[96328+(t[l>>2]<<2)>>2]|0)|0)break;t[l>>2]=(t[l>>2]|0)+1}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}else{if(pF(t[k>>2]|0)|0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[l>>2]=0;while(1){if((t[l>>2]|0)>>>0>=53)break e;if(Xl(t[(t[k>>2]|0)+8>>2]|0,t[96328+(t[l>>2]<<2)>>2]|0)|0)break;t[l>>2]=(t[l>>2]|0)+1}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}while(0);t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}function zi(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;if(((((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]|0)==0:0)?(t[t[(t[n>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+12>>2]|0)==0:0){if((t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)!=0:0){t[f>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];t[o>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2];if(u[t[o>>2]>>0]|0){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=ns(t[f>>2]|0,96136)|0;if(!(t[a>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=ns(t[a>>2]|0,96152)|0;if(!(t[a>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=ns(t[a>>2]|0,96160)|0;if(!(t[a>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=(t[a>>2]|0)+8;t[f>>2]=t[a>>2];while(1){if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)l=1;else b=21;do if((b|0)==21){b=0;if((u[t[a>>2]>>0]|0|0)>=97?(u[t[a>>2]>>0]|0|0)<=122:0){l=1;break}if((u[t[a>>2]>>0]|0|0)>=48?(u[t[a>>2]>>0]|0|0)<=57:0){l=1;break}if((u[t[a>>2]>>0]|0|0)!=45?(u[t[a>>2]>>0]|0|0)!=95:0){if((u[t[a>>2]>>0]|0|0)==58){l=1;break}l=(u[t[a>>2]>>0]|0|0)==47}else l=1}while(0);k=t[a>>2]|0;if(!l)break;t[a>>2]=k+1}if((k|0)==(t[f>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else{t[r>>2]=ql(t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;c=t[r>>2]|0;s=i;return c|0}}t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}function ji(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[f>>2]=0;e=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){Op(e);t[n>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];while(1){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)a=7;else if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)o=0;else a=7;if((a|0)==7){a=0;o=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34}c=t[r>>2]|0;if(!o)break;Op(c)}if(!(9<=(u[t[(t[c+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))a=12;if(((a|0)==12?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0)?32>(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0){BN(t[r>>2]|0,44,97280,0,0);l=t[f>>2]|0;s=i;return l|0}t[f>>2]=ql(t[n>>2]|0,(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[n>>2]|0)|0)|0;Op(t[r>>2]|0);l=t[f>>2]|0;s=i;return l|0}c=t[r>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=39){BN(c,43,97312,0,0);l=t[f>>2]|0;s=i;return l|0}Op(c);t[n>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];while(1){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)a=22;else if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)b=0;else a=22;if((a|0)==22){a=0;b=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39}k=t[r>>2]|0;if(!b)break;Op(k)}if(!(9<=(u[t[(t[k+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))a=27;if(((a|0)==27?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0)?32>(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0){BN(t[r>>2]|0,44,97280,0,0);l=t[f>>2]|0;s=i;return l|0}t[f>>2]=ql(t[n>>2]|0,(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[n>>2]|0)|0)|0;Op(t[r>>2]|0);l=t[f>>2]|0;s=i;return l|0}function Vi(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[a>>2]=0;e=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)==34){Op(e);t[f>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];while(1){o=t[r>>2]|0;if(!(n[198696+(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)>>0]|0))break;Op(o)}if((u[t[(t[o+36>>2]|0)+16>>2]>>0]|0)!=34){BN(t[r>>2]|0,44,97216,0,0);c=t[a>>2]|0;s=i;return c|0}else{t[a>>2]=ql(t[f>>2]|0,(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[f>>2]|0)|0)|0;Op(t[r>>2]|0);c=t[a>>2]|0;s=i;return c|0}}o=t[r>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0)!=39){BN(o,43,97248,0,0);c=t[a>>2]|0;s=i;return c|0}Op(o);t[f>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];while(1){if(u[198696+(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)>>0]|0)l=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=39;else l=0;b=t[r>>2]|0;if(!l)break;Op(b)}if((u[t[(t[b+36>>2]|0)+16>>2]>>0]|0)!=39){BN(t[r>>2]|0,44,97216,0,0);c=t[a>>2]|0;s=i;return c|0}else{t[a>>2]=ql(t[f>>2]|0,(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[f>>2]|0)|0)|0;Op(t[r>>2]|0);c=t[a>>2]|0;s=i;return c|0}return 0}function qi(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0;r=s;s=s+112|0;f=r+96|0;a=r+92|0;o=r+100|0;c=r+88|0;l=r+84|0;b=r+80|0;k=r+76|0;h=r+72|0;w=r+68|0;d=r+64|0;v=r+60|0;m=r+56|0;_=r+52|0;p=r+48|0;E=r+44|0;S=r+40|0;g=r+36|0;y=r+32|0;F=r+28|0;O=r+24|0;A=r+20|0;M=r+16|0;R=r+12|0;N=r+8|0;T=r+4|0;L=r;t[a>>2]=e;n[o>>0]=i;t[c>>2]=0;t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;t[l>>2]=100;t[c>>2]=gAi[t[135752>>2]&511](t[l>>2]|0)|0;if(!(t[c>>2]|0)){CN(t[a>>2]|0,97424);t[f>>2]=0;D=t[f>>2]|0;s=r;return D|0}t[b>>2]=t[c>>2];e:while(1){if(!(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){C=68;break}if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==(u[o>>0]|0|0)){C=68;break}if((u[o>>0]|0|0)==0?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62:0){C=68;break}if(!(u[o>>0]|0)){if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==32){C=68;break}if(9<=(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0){C=68;break}if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13){C=68;break}}if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){if(((t[b>>2]|0)-(t[c>>2]|0)|0)>((t[l>>2]|0)-100|0)){t[T>>2]=(t[b>>2]|0)-(t[c>>2]|0);t[l>>2]=t[l>>2]<<1;t[L>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[l>>2]|0)|0;if(!(t[L>>2]|0)){C=56;break}t[c>>2]=t[L>>2];t[b>>2]=(t[c>>2]|0)+(t[T>>2]|0)}t[M>>2]=Ni(t[a>>2]|0,N)|0;i=t[M>>2]|0;do if((t[M>>2]|0)>>>0>=128){e=t[M>>2]|0;if(i>>>0<2048){P=t[b>>2]|0;t[b>>2]=P+1;n[P>>0]=e>>>6&31|192;t[R>>2]=0;break}P=t[M>>2]|0;if(e>>>0<65536){e=t[b>>2]|0;t[b>>2]=e+1;n[e>>0]=P>>>12&15|224;t[R>>2]=6;break}else{e=t[b>>2]|0;t[b>>2]=e+1;n[e>>0]=P>>>18&7|240;t[R>>2]=12;break}}else{P=t[b>>2]|0;t[b>>2]=P+1;n[P>>0]=i;t[R>>2]=-6}while(0);while(1){if((t[R>>2]|0)<0)break;i=((t[M>>2]|0)>>>(t[R>>2]|0)&63|128)&255;P=t[b>>2]|0;t[b>>2]=P+1;n[P>>0]=i;t[R>>2]=(t[R>>2]|0)-6}Op(t[a>>2]|0);continue}i=t[a>>2]|0;if((u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){t[d>>2]=_N(i)|0;P=t[d>>2]|0;do if((t[d>>2]|0)>>>0>=128){e=t[d>>2]|0;if(P>>>0<2048){B=t[b>>2]|0;t[b>>2]=B+1;n[B>>0]=e>>>6&31|192;t[v>>2]=0;break}B=t[d>>2]|0;if(e>>>0<65536){e=t[b>>2]|0;t[b>>2]=e+1;n[e>>0]=B>>>12&15|224;t[v>>2]=6;break}else{e=t[b>>2]|0;t[b>>2]=e+1;n[e>>0]=B>>>18&7|240;t[v>>2]=12;break}}else{B=t[b>>2]|0;t[b>>2]=B+1;n[B>>0]=P;t[v>>2]=-6}while(0);while(1){if((t[v>>2]|0)<0)break;P=((t[d>>2]|0)>>>(t[v>>2]|0)&63|128)&255;B=t[b>>2]|0;t[b>>2]=B+1;n[B>>0]=P;t[v>>2]=(t[v>>2]|0)-6}if(((t[b>>2]|0)-(t[c>>2]|0)|0)<=((t[l>>2]|0)-100|0))continue;t[m>>2]=(t[b>>2]|0)-(t[c>>2]|0);t[l>>2]=t[l>>2]<<1;t[_>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[l>>2]|0)|0;if(!(t[_>>2]|0)){C=26;break}t[c>>2]=t[_>>2];t[b>>2]=(t[c>>2]|0)+(t[m>>2]|0);continue}t[w>>2]=mN(i,k)|0;if(!(t[k>>2]|0)){P=t[b>>2]|0;t[b>>2]=P+1;n[P>>0]=38;if(((t[b>>2]|0)-(t[c>>2]|0)|0)<=((t[l>>2]|0)-100|0))continue;t[p>>2]=(t[b>>2]|0)-(t[c>>2]|0);t[l>>2]=t[l>>2]<<1;t[E>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[l>>2]|0)|0;if(!(t[E>>2]|0)){C=31;break}t[c>>2]=t[E>>2];t[b>>2]=(t[c>>2]|0)+(t[p>>2]|0);continue}P=t[b>>2]|0;if(!(t[w>>2]|0)){t[b>>2]=P+1;n[P>>0]=38;t[h>>2]=t[k>>2];while(1){if(!(u[t[h>>2]>>0]|0))continue e;if(((t[b>>2]|0)-(t[c>>2]|0)|0)>((t[l>>2]|0)-100|0)){t[S>>2]=(t[b>>2]|0)-(t[c>>2]|0);t[l>>2]=t[l>>2]<<1;t[g>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[l>>2]|0)|0;if(!(t[g>>2]|0)){C=38;break e}t[c>>2]=t[g>>2];t[b>>2]=(t[c>>2]|0)+(t[S>>2]|0)}B=t[h>>2]|0;t[h>>2]=B+1;e=n[B>>0]|0;B=t[b>>2]|0;t[b>>2]=B+1;n[B>>0]=e}}if((P-(t[c>>2]|0)|0)>((t[l>>2]|0)-100|0)){t[O>>2]=(t[b>>2]|0)-(t[c>>2]|0);t[l>>2]=t[l>>2]<<1;t[A>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[l>>2]|0)|0;if(!(t[A>>2]|0)){C=43;break}t[c>>2]=t[A>>2];t[b>>2]=(t[c>>2]|0)+(t[O>>2]|0)}t[y>>2]=t[t[w>>2]>>2];i=t[y>>2]|0;do if((t[y>>2]|0)>>>0>=128){e=t[y>>2]|0;if(i>>>0<2048){B=t[b>>2]|0;t[b>>2]=B+1;n[B>>0]=e>>>6&31|192;t[F>>2]=0;break}B=t[y>>2]|0;if(e>>>0<65536){e=t[b>>2]|0;t[b>>2]=e+1;n[e>>0]=B>>>12&15|224;t[F>>2]=6;break}else{e=t[b>>2]|0;t[b>>2]=e+1;n[e>>0]=B>>>18&7|240;t[F>>2]=12;break}}else{B=t[b>>2]|0;t[b>>2]=B+1;n[B>>0]=i;t[F>>2]=-6}while(0);while(1){if((t[F>>2]|0)<0)continue e;i=((t[y>>2]|0)>>>(t[F>>2]|0)&63|128)&255;P=t[b>>2]|0;t[b>>2]=P+1;n[P>>0]=i;t[F>>2]=(t[F>>2]|0)-6}}if((C|0)==26){CN(t[a>>2]|0,98024);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;D=t[f>>2]|0;s=r;return D|0}else if((C|0)==31){CN(t[a>>2]|0,98024);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;D=t[f>>2]|0;s=r;return D|0}else if((C|0)==38){CN(t[a>>2]|0,98024);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;D=t[f>>2]|0;s=r;return D|0}else if((C|0)==43){CN(t[a>>2]|0,98024);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;D=t[f>>2]|0;s=r;return D|0}else if((C|0)==56){CN(t[a>>2]|0,98024);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;D=t[f>>2]|0;s=r;return D|0}else if((C|0)==68){n[t[b>>2]>>0]=0;t[f>>2]=t[c>>2];D=t[f>>2]|0;s=r;return D|0}return 0}function Yi(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;while(1){if(t[95744+(t[n>>2]<<3)>>2]|0)f=(Xl(t[95744+(t[n>>2]<<3)>>2]|0,t[r>>2]|0)|0)!=0^1;else f=0;u=t[n>>2]|0;if(!f)break;t[n>>2]=u+1}s=i;return t[95748+(u<<3)>>2]|0}function Gi(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+28|0;n=i+24|0;f=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[f>>2]=t[(t[n>>2]|0)+12>>2];while(1){if(!(t[f>>2]|0)){h=11;break}if((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){if(Xl(t[(t[f>>2]|0)+8>>2]|0,120888)|0){h=11;break}if(Xl(t[(t[f>>2]|0)+8>>2]|0,120896)|0){h=22;break}if(Xl(t[(t[f>>2]|0)+8>>2]|0,120904)|0)break}t[f>>2]=t[(t[f>>2]|0)+24>>2]}e:do if((h|0)==11){if(!(t[f>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[f>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[f>>2]|0))break;if((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){if(Xl(t[(t[f>>2]|0)+8>>2]|0,120896)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,120904)|0)break e}t[f>>2]=t[(t[f>>2]|0)+24>>2]}if(!(t[f>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}else h=22}while(0);if((h|0)==22)t[f>>2]=t[(t[f>>2]|0)+12>>2];e:while(1){if(!(t[f>>2]|0)){h=41;break}i:do if(((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[f>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[f>>2]|0)+8>>2]|0,120904)|0)!=0:0){t[c>>2]=t[(t[f>>2]|0)+44>>2];t[a>>2]=0;t[l>>2]=0;while(1){if(!(t[c>>2]|0))break i;if(((t[(t[c>>2]|0)+12>>2]|0)!=0?(t[(t[(t[c>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(t[(t[(t[c>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){t[b>>2]=t[(t[(t[c>>2]|0)+12>>2]|0)+40>>2];if((Ql(t[(t[c>>2]|0)+8>>2]|0,120912)|0)==0?(Ql(t[b>>2]|0,120928)|0)==0:0)t[l>>2]=1;else h=35;if(((h|0)==35?(h=0,(t[b>>2]|0)!=0):0)?(Ql(t[(t[c>>2]|0)+8>>2]|0,120944)|0)==0:0)t[a>>2]=t[b>>2];if((t[l>>2]|0)!=0&(t[a>>2]|0)!=0)break e}t[c>>2]=t[(t[c>>2]|0)+24>>2]}}while(0);t[f>>2]=t[(t[f>>2]|0)+24>>2]}if((h|0)==41){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[o>>2]=is(t[a>>2]|0,120952)|0;if(!(t[o>>2]|0))t[o>>2]=is(t[a>>2]|0,120968)|0;if(!(t[o>>2]|0))t[o>>2]=is(t[a>>2]|0,120984)|0;if(!(t[o>>2]|0)){t[o>>2]=is(t[a>>2]|0,121e3)|0;if(!(t[o>>2]|0))t[o>>2]=is(t[a>>2]|0,121016)|0;if(!(t[o>>2]|0))t[o>>2]=is(t[a>>2]|0,121032)|0;if(t[o>>2]|0)t[o>>2]=(t[o>>2]|0)+9}else t[o>>2]=(t[o>>2]|0)+8;e:do if(t[o>>2]|0)while(1){if((u[t[o>>2]>>0]|0|0)!=32?(u[t[o>>2]>>0]|0|0)!=9:0)break e;t[o>>2]=(t[o>>2]|0)+1}while(0);t[r>>2]=t[o>>2];k=t[r>>2]|0;s=i;return k|0}function Wi(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+144|0;f=r;u=r+40|0;a=r+36|0;o=r+32|0;c=r+28|0;l=r+24|0;b=r+20|0;k=r+16|0;h=r+44|0;w=r+12|0;d=r+8|0;v=r+4|0;t[a>>2]=e;t[o>>2]=i;t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;n[h>>0]=0;if(!(t[a>>2]|0)){t[u>>2]=-1;m=t[u>>2]|0;s=r;return m|0}if(!(Ql(t[o>>2]|0,120888)|0)){t[u>>2]=-1;m=t[u>>2]|0;s=r;return m|0}if(t[o>>2]|0){t[f>>2]=t[o>>2];SY(h,100,121048,f)|0;n[h+99>>0]=0}t[c>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0)){_=15;break}if((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){if(!(Ql(t[(t[c>>2]|0)+8>>2]|0,120888)|0)){_=15;break}if(!(Ql(t[(t[c>>2]|0)+8>>2]|0,120896)|0)){_=27;break}if(!(Ql(t[(t[c>>2]|0)+8>>2]|0,120904)|0)){_=29;break}}t[c>>2]=t[(t[c>>2]|0)+24>>2]}do if((_|0)==15){if(!(t[c>>2]|0)){t[u>>2]=-1;m=t[u>>2]|0;s=r;return m|0}t[c>>2]=t[(t[c>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){if(!(Ql(t[(t[c>>2]|0)+8>>2]|0,120896)|0))break;if(!(Ql(t[(t[c>>2]|0)+8>>2]|0,120904)|0)){_=23;break}}t[c>>2]=t[(t[c>>2]|0)+24>>2]}if((_|0)==23){t[b>>2]=t[(t[c>>2]|0)+20>>2];_=29;break}if(!(t[c>>2]|0)){t[u>>2]=-1;m=t[u>>2]|0;s=r;return m|0}else _=27}while(0);if((_|0)==27?(t[b>>2]=t[c>>2],(t[(t[c>>2]|0)+12>>2]|0)!=0):0){t[c>>2]=t[(t[c>>2]|0)+12>>2];_=29}e:do if((_|0)==29){while(1){_=0;if(!(t[c>>2]|0))break e;if(((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+8>>2]|0)!=0:0)?(Ql(t[(t[c>>2]|0)+8>>2]|0,120904)|0)==0:0){t[w>>2]=t[(t[c>>2]|0)+44>>2];t[k>>2]=0;t[d>>2]=0;while(1){if(!(t[w>>2]|0))break;if(((t[(t[w>>2]|0)+12>>2]|0)!=0?(t[(t[(t[w>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(t[(t[(t[w>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){t[v>>2]=t[(t[(t[w>>2]|0)+12>>2]|0)+40>>2];if((Ql(t[(t[w>>2]|0)+8>>2]|0,120912)|0)==0?(Ql(t[v>>2]|0,120928)|0)==0:0)t[d>>2]=1;else _=41;if(((_|0)==41?(_=0,(t[v>>2]|0)!=0):0)?(Ql(t[(t[w>>2]|0)+8>>2]|0,120944)|0)==0:0)t[k>>2]=t[v>>2];if((t[d>>2]|0)!=0&(t[k>>2]|0)!=0)break}t[w>>2]=t[(t[w>>2]|0)+24>>2]}if((t[d>>2]|0)!=0&(t[k>>2]|0)!=0)break}t[c>>2]=t[(t[c>>2]|0)+24>>2];_=29}t[l>>2]=t[c>>2]}while(0);c=t[o>>2]|0;do if(!(t[l>>2]|0)){if((c|0)!=0&(t[b>>2]|0)!=0){t[l>>2]=Sy(t[a>>2]|0,0,120904,0)|0;_=t[b>>2]|0;if(!(t[(t[b>>2]|0)+12>>2]|0))Hy(_,t[l>>2]|0)|0;else Py(t[_+12>>2]|0,t[l>>2]|0)|0;by(t[l>>2]|0,120912,120928)|0;by(t[l>>2]|0,120944,h)|0}}else{if(!c){iy(t[l>>2]|0);ry(t[l>>2]|0);break}if(!(ns(t[k>>2]|0,t[o>>2]|0)|0))_F(t[l>>2]|0,120944,h)|0}while(0);t[u>>2]=0;m=t[u>>2]|0;s=r;return m|0}function Ki(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;while(1){if(!(t[121072+(t[f>>2]<<2)>>2]|0)){u=6;break}if(!(Ql(t[121072+(t[f>>2]<<2)>>2]|0,t[n>>2]|0)|0)){u=4;break}t[f>>2]=(t[f>>2]|0)+1}if((u|0)==4){t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}else if((u|0)==6){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}return 0}function Xi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;rS();if(((t[b>>2]|0)!=0?(t[v>>2]=B_(t[b>>2]|0)|0,(t[v>>2]|0)!=1):0)?(t[w>>2]=V_(t[b>>2]|0)|0,(t[w>>2]|0)==0):0)fr(1403,0,t[b>>2]|0);if(!(t[w>>2]|0))t[w>>2]=V_(121128)|0;if(!(t[w>>2]|0))t[w>>2]=V_(121136)|0;t[h>>2]=qO(t[o>>2]|0,t[w>>2]|0)|0;if(!(t[h>>2]|0)){t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}else{Zi(t[h>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0);t[d>>2]=HO(t[h>>2]|0)|0;t[a>>2]=t[d>>2];m=t[a>>2]|0;s=u;return m|0}return 0}function Zi(e,i,r,f,a){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+32|0;c=o+24|0;l=o+20|0;b=o+16|0;k=o+12|0;h=o+8|0;w=o+4|0;d=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=a;rS();if((t[b>>2]|0)==0|(t[c>>2]|0)==0){s=o;return}if((t[(t[b>>2]|0)+4>>2]|0)==14){s=o;return}if((t[(t[b>>2]|0)+4>>2]|0)!=13?(t[(t[b>>2]|0)+4>>2]|0)!=9:0){if((t[(t[b>>2]|0)+4>>2]|0)==2){tr(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0);s=o;return}a=t[b>>2]|0;if((t[(t[b>>2]|0)+4>>2]|0)==3){if(!(t[a+40>>2]|0)){s=o;return}if(!((t[(t[b>>2]|0)+8>>2]|0)!=75104?(t[(t[b>>2]|0)+8>>2]|0)==75112:0))v=12;do if((v|0)==12){if(t[(t[b>>2]|0)+20>>2]|0){if(!(Ql(t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]|0,121144)|0))break;if(!(Ql(t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]|0,121152)|0))break}t[d>>2]=d_(t[l>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0;if(!(t[d>>2]|0)){s=o;return}iA(t[c>>2]|0,t[d>>2]|0)|0;pAi[t[135736>>2]&511](t[d>>2]|0);s=o;return}while(0);iA(t[c>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0;s=o;return}d=t[b>>2]|0;if((t[a+4>>2]|0)==8){if(!(t[d+40>>2]|0)){s=o;return}iA(t[c>>2]|0,121160)|0;iA(t[c>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0;iA(t[c>>2]|0,121168)|0;s=o;return}a=t[b>>2]|0;if((t[d+4>>2]|0)==7){if(!(t[a+8>>2]|0)){s=o;return}iA(t[c>>2]|0,121176)|0;iA(t[c>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;if(t[(t[b>>2]|0)+40>>2]|0){iA(t[c>>2]|0,121184)|0;iA(t[c>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0}iA(t[c>>2]|0,121192)|0;s=o;return}if((t[a+4>>2]|0)==5){iA(t[c>>2]|0,121200)|0;iA(t[c>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;iA(t[c>>2]|0,121208)|0;s=o;return}a=t[b>>2]|0;if((t[(t[b>>2]|0)+4>>2]|0)==4){if(!(t[a+40>>2]|0)){s=o;return}iA(t[c>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0;s=o;return}if(!(t[a+36>>2]|0))t[w>>2]=kN(t[(t[b>>2]|0)+8>>2]|0)|0;else t[w>>2]=0;iA(t[c>>2]|0,121216)|0;if((t[(t[b>>2]|0)+36>>2]|0)!=0?(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){iA(t[c>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[c>>2]|0,121224)|0}iA(t[c>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;if(t[(t[b>>2]|0)+48>>2]|0)nV(t[c>>2]|0,t[(t[b>>2]|0)+48>>2]|0);if(t[(t[b>>2]|0)+44>>2]|0)ur(t[c>>2]|0,t[l>>2]|0,t[(t[b>>2]|0)+44>>2]|0,t[k>>2]|0);if((t[w>>2]|0)!=0?(n[(t[w>>2]|0)+7>>0]|0)!=0:0){iA(t[c>>2]|0,121192)|0;if(!(t[h>>2]|0)){s=o;return}if(n[(t[w>>2]|0)+10>>0]|0){s=o;return}if(!(t[(t[b>>2]|0)+24>>2]|0)){s=o;return}if((t[(t[(t[b>>2]|0)+24>>2]|0)+4>>2]|0)==3){s=o;return}if((t[(t[(t[b>>2]|0)+24>>2]|0)+4>>2]|0)==5){s=o;return}if(!(t[(t[b>>2]|0)+20>>2]|0)){s=o;return}if(!(t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]|0)){s=o;return}if((u[t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]>>0]|0)==112){s=o;return}iA(t[c>>2]|0,121232)|0;s=o;return}if(!((t[(t[b>>2]|0)+4>>2]|0)!=1?(t[(t[b>>2]|0)+40>>2]|0)!=0:0))v=54;if((v|0)==54?(t[(t[b>>2]|0)+12>>2]|0)==0:0){do if(t[w>>2]|0){if(!(n[(t[w>>2]|0)+6>>0]|0)){v=60;break}if(!(Kl(t[t[w>>2]>>2]|0,120888)|0)){v=60;break}if(!(Kl(t[t[w>>2]>>2]|0,121240)|0)){v=60;break}iA(t[c>>2]|0,121192)|0}else v=60;while(0);if((v|0)==60){iA(t[c>>2]|0,121248)|0;do if(t[(t[b>>2]|0)+36>>2]|0){if(!(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[c>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[c>>2]|0,121224)|0}while(0);iA(t[c>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;iA(t[c>>2]|0,121192)|0}if(!(t[h>>2]|0)){s=o;return}if(!((t[w>>2]|0)!=0?(t[(t[b>>2]|0)+24>>2]|0)!=0:0)){s=o;return}if(n[(t[w>>2]|0)+10>>0]|0){s=o;return}if((t[(t[(t[b>>2]|0)+24>>2]|0)+4>>2]|0)==3){s=o;return}if((t[(t[(t[b>>2]|0)+24>>2]|0)+4>>2]|0)==5){s=o;return}if(!(t[(t[b>>2]|0)+20>>2]|0)){s=o;return}if(!(t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]|0)){s=o;return}if((u[t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]>>0]|0)==112){s=o;return}iA(t[c>>2]|0,121232)|0;s=o;return}iA(t[c>>2]|0,121192)|0;if((t[(t[b>>2]|0)+4>>2]|0)!=1?(t[(t[b>>2]|0)+40>>2]|0)!=0:0)iA(t[c>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0;do if(t[(t[b>>2]|0)+12>>2]|0){do if((t[h>>2]|0)!=0&(t[w>>2]|0)!=0){if(n[(t[w>>2]|0)+10>>0]|0)break;if((t[(t[(t[b>>2]|0)+12>>2]|0)+4>>2]|0)==3)break;if((t[(t[(t[b>>2]|0)+12>>2]|0)+4>>2]|0)==5)break;if((t[(t[b>>2]|0)+12>>2]|0)==(t[(t[b>>2]|0)+16>>2]|0))break;if(!(t[(t[b>>2]|0)+8>>2]|0))break;if((u[t[(t[b>>2]|0)+8>>2]>>0]|0)==112)break;iA(t[c>>2]|0,121232)|0}while(0);ar(t[c>>2]|0,t[l>>2]|0,t[(t[b>>2]|0)+12>>2]|0,t[k>>2]|0,t[h>>2]|0);if(!((t[h>>2]|0)!=0&(t[w>>2]|0)!=0))break;if(n[(t[w>>2]|0)+10>>0]|0)break;if((t[(t[(t[b>>2]|0)+16>>2]|0)+4>>2]|0)==3)break;if((t[(t[(t[b>>2]|0)+16>>2]|0)+4>>2]|0)==5)break;if((t[(t[b>>2]|0)+12>>2]|0)==(t[(t[b>>2]|0)+16>>2]|0))break;if(!(t[(t[b>>2]|0)+8>>2]|0))break;if((u[t[(t[b>>2]|0)+8>>2]>>0]|0)==112)break;iA(t[c>>2]|0,121232)|0}while(0);iA(t[c>>2]|0,121256)|0;do if(t[(t[b>>2]|0)+36>>2]|0){if(!(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[c>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[c>>2]|0,121224)|0}while(0);iA(t[c>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;iA(t[c>>2]|0,121192)|0;if(!((t[h>>2]|0)!=0&(t[w>>2]|0)!=0)){s=o;return}if(n[(t[w>>2]|0)+10>>0]|0){s=o;return}if(!(t[(t[b>>2]|0)+24>>2]|0)){s=o;return}if((t[(t[(t[b>>2]|0)+24>>2]|0)+4>>2]|0)==3){s=o;return}if((t[(t[(t[b>>2]|0)+24>>2]|0)+4>>2]|0)==5){s=o;return}if(!(t[(t[b>>2]|0)+20>>2]|0)){s=o;return}if(!(t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]|0)){s=o;return}if((u[t[(t[(t[b>>2]|0)+20>>2]|0)+8>>2]>>0]|0)==112){s=o;return}iA(t[c>>2]|0,121232)|0;s=o;return}$i(t[c>>2]|0,t[b>>2]|0,t[k>>2]|0);s=o;return}function Ji(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;Xi(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0,1)|0;s=n;return}function Qi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;rS();if((t[u>>2]|0)==0|(t[a>>2]|0)==0){s=f;return}t[l>>2]=t[(t[a>>2]|0)+4>>2];t[(t[a>>2]|0)+4>>2]=13;if(t[(t[a>>2]|0)+44>>2]|0)or(t[u>>2]|0,t[a>>2]|0,0);if(t[(t[a>>2]|0)+12>>2]|0)ar(t[u>>2]|0,t[a>>2]|0,t[(t[a>>2]|0)+12>>2]|0,t[o>>2]|0,t[c>>2]|0);iA(t[u>>2]|0,121232)|0;t[(t[a>>2]|0)+4>>2]=t[l>>2];s=f;return}function $i(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;Qi(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,1);s=n;return}function er(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;Zi(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,1);s=f;return}function ir(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;rS();if((t[u>>2]|0)==0|(t[f>>2]|0)==0){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}t[c>>2]=Gi(t[u>>2]|0)|0;do if(t[c>>2]|0){t[b>>2]=B_(t[c>>2]|0)|0;if((t[b>>2]|0)==(t[(t[u>>2]|0)+76>>2]|0)){t[o>>2]=V_(t[c>>2]|0)|0;break}if((t[(t[u>>2]|0)+76>>2]|0)!=1){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else{t[o>>2]=V_(t[c>>2]|0)|0;if(t[o>>2]|0)break;fr(1403,0,t[c>>2]|0);break}}while(0);if(!(t[o>>2]|0))t[o>>2]=V_(121128)|0;if(!(t[o>>2]|0))t[o>>2]=V_(121136)|0;t[a>>2]=qO(t[f>>2]|0,t[o>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else{$i(t[a>>2]|0,t[u>>2]|0,0);t[l>>2]=HO(t[a>>2]|0)|0;t[n>>2]=t[l>>2];k=t[n>>2]|0;s=r;return k|0}return 0}function rr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;if((t[u>>2]|0)==0|(t[f>>2]|0)==0){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}rS();t[c>>2]=Gi(t[u>>2]|0)|0;do if((t[c>>2]|0)!=0?(t[b>>2]=B_(t[c>>2]|0)|0,(t[b>>2]|0)!=(t[(t[u>>2]|0)+76>>2]|0)):0)if((t[(t[u>>2]|0)+76>>2]|0)!=1){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else{t[o>>2]=V_(t[c>>2]|0)|0;if(t[o>>2]|0)break;fr(1403,0,t[c>>2]|0);break}while(0);if(!(t[o>>2]|0))t[o>>2]=V_(121128)|0;if(!(t[o>>2]|0))t[o>>2]=V_(121136)|0;t[a>>2]=VO(t[f>>2]|0,t[o>>2]|0,t[(t[u>>2]|0)+36>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else{$i(t[a>>2]|0,t[u>>2]|0,0);t[l>>2]=HO(t[a>>2]|0)|0;t[n>>2]=t[l>>2];k=t[n>>2]|0;s=r;return k|0}return 0}function nr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;if((t[o>>2]|0)==0|(t[a>>2]|0)==0){t[u>>2]=-1;d=t[u>>2]|0;s=f;return d|0}rS();if(t[c>>2]|0){t[w>>2]=B_(t[c>>2]|0)|0;do if((t[w>>2]|0)!=(t[(t[o>>2]|0)+76>>2]|0))if((t[(t[o>>2]|0)+76>>2]|0)!=1){t[u>>2]=-1;d=t[u>>2]|0;s=f;return d|0}else{t[k>>2]=V_(t[c>>2]|0)|0;if(t[k>>2]|0)break;fr(1403,0,t[c>>2]|0);break}while(0);Wi(t[o>>2]|0,t[c>>2]|0)|0}else Wi(t[o>>2]|0,121264)|0;if(!(t[k>>2]|0))t[k>>2]=V_(121128)|0;if(!(t[k>>2]|0))t[k>>2]=V_(121136)|0;t[b>>2]=VO(t[a>>2]|0,t[k>>2]|0,0)|0;if(!(t[b>>2]|0)){t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}else{Qi(t[b>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);t[h>>2]=HO(t[b>>2]|0)|0;t[u>>2]=t[h>>2];d=t[u>>2]|0;s=f;return d|0}return 0}function fr(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;r=t[f>>2]|0;if((r|0)==1402)t[o>>2]=121488;else if((r|0)==1401)t[o>>2]=121432;else if((r|0)==1400)t[o>>2]=121408;else if((r|0)==1403)t[o>>2]=121464;else t[o>>2]=121512;dp(7,t[f>>2]|0,t[u>>2]|0,t[o>>2]|0,t[a>>2]|0);s=n;return}function tr(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+36|0;d=a+4|0;v=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[a+20>>2]=f;if(!(t[l>>2]|0)){s=a;return}iA(t[o>>2]|0,121184)|0;if((t[(t[l>>2]|0)+36>>2]|0)!=0?(t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){iA(t[o>>2]|0,t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[o>>2]|0,121224)|0}iA(t[o>>2]|0,t[(t[l>>2]|0)+8>>2]|0)|0;if(!(t[(t[l>>2]|0)+12>>2]|0)){s=a;return}if(Ki(t[(t[l>>2]|0)+8>>2]|0)|0){s=a;return}t[b>>2]=sy(t[c>>2]|0,t[(t[l>>2]|0)+12>>2]|0,0)|0;c=t[o>>2]|0;if(!(t[b>>2]|0)){iA(c,121400)|0;s=a;return}iA(c,121328)|0;do if(((t[(t[l>>2]|0)+36>>2]|0)==0?(t[(t[l>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[l>>2]|0)+20>>2]|0)+36>>2]|0)==0:0){if(((Ql(t[(t[l>>2]|0)+8>>2]|0,121336)|0)!=0?(Ql(t[(t[l>>2]|0)+8>>2]|0,121344)|0)!=0:0)?(Ql(t[(t[l>>2]|0)+8>>2]|0,121352)|0)!=0:0){if(Ql(t[(t[l>>2]|0)+8>>2]|0,121360)|0){m=31;break}if(Ql(t[(t[(t[l>>2]|0)+20>>2]|0)+8>>2]|0,121368)|0){m=31;break}}t[k>>2]=t[b>>2];Hs(t[(t[o>>2]|0)+16>>2]|0,121376)|0;e:while(1){do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)break e}while(0);t[k>>2]=(t[k>>2]|0)+1}while(1){t[d>>2]=0;t[v>>2]=is(t[k>>2]|0,121160)|0;if((t[v>>2]|0)!=0?(t[d>>2]=is(t[k>>2]|0,121168)|0,(t[d>>2]|0)!=0):0)n[t[v>>2]>>0]=0;t[h>>2]=qA(t[k>>2]|0,121384)|0;c=t[(t[o>>2]|0)+16>>2]|0;if(t[h>>2]|0){Is(c,t[h>>2]|0)|0;pAi[t[135736>>2]&511](t[h>>2]|0)}else Is(c,t[k>>2]|0)|0;if(!(t[d>>2]|0))break;n[t[v>>2]>>0]=60;t[d>>2]=(t[d>>2]|0)+3;n[w>>0]=n[t[d>>2]>>0]|0;n[t[d>>2]>>0]=0;Is(t[(t[o>>2]|0)+16>>2]|0,t[v>>2]|0)|0;n[t[d>>2]>>0]=n[w>>0]|0;t[k>>2]=t[d>>2]}Hs(t[(t[o>>2]|0)+16>>2]|0,121376)|0}else m=31;while(0);if((m|0)==31)xs(t[(t[o>>2]|0)+16>>2]|0,t[b>>2]|0)|0;pAi[t[135736>>2]&511](t[b>>2]|0);s=a;return}function ur(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!((t[o>>2]|0)!=0&(t[o>>2]|0)!=0)){s=f;return}do{tr(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);t[o>>2]=t[(t[o>>2]|0)+24>>2]}while((t[o>>2]|0)!=0);s=f;return}function ar(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0;u=s;s=s+32|0;a=u+16|0;o=u+12|0;c=u+8|0;l=u+4|0;b=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;if(!((t[c>>2]|0)!=0&(t[c>>2]|0)!=0)){s=u;return}do{Zi(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}while((t[c>>2]|0)!=0);s=u;return}function or(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n;t[f>>2]=e;t[u>>2]=i;t[n+4>>2]=r;t[a>>2]=t[(t[u>>2]|0)+44>>2];if(!(t[a>>2]|0)){fr(1402,t[u>>2]|0,0);s=n;return}iA(t[f>>2]|0,121272)|0;iA(t[f>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if(t[(t[a>>2]|0)+52>>2]|0){iA(t[f>>2]|0,121288)|0;xs(t[(t[f>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+52>>2]|0)|0;if(t[(t[a>>2]|0)+56>>2]|0){iA(t[f>>2]|0,121184)|0;xs(t[(t[f>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+56>>2]|0)|0}}else if(t[(t[a>>2]|0)+56>>2]|0){iA(t[f>>2]|0,121304)|0;xs(t[(t[f>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+56>>2]|0)|0}iA(t[f>>2]|0,121320)|0;s=n;return}function cr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r;f=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[a>>2]=i;if(!(t[f>>2]|0))t[f>>2]=t[_>>2];if(!(t[a>>2]|0)){xe(t[f>>2]|0,121688,n|0)|0;s=r;return}t[o>>2]=0;while(1){if((t[o>>2]|0)>=40)break;if(!(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0)){c=18;break}do if((u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)?(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)<=10:0){c=12;break}if((u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)!=13)if((u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)>=128){i=t[f>>2]|0;t[n>>2]=u[(t[a>>2]|0)+(t[o>>2]|0)>>0];xe(i|0,121696,n|0)|0;break}else{oi(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0,t[f>>2]|0)|0;break}else c=12}else c=12;while(0);if((c|0)==12){c=0;oi(32,t[f>>2]|0)|0}t[o>>2]=(t[o>>2]|0)+1}if((c|0)==18){s=r;return}xe(t[f>>2]|0,121704,n|0)|0;s=r;return}function lr(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+160|0;f=n+148|0;u=n+144|0;a=n+140|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}Mr(o);t[o>>2]=t[f>>2];t[o+108>>2]=t[a>>2];Rr(o,t[u>>2]|0);Nr(o);s=n;return}function sr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+160|0;n=r+144|0;f=r+140|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}Mr(u);t[u>>2]=t[n>>2];Tr(u,t[f>>2]|0);Nr(u);s=r;return}function br(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+160|0;f=n+148|0;u=n+144|0;a=n+140|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}Mr(o);t[o>>2]=t[f>>2];t[o+108>>2]=t[a>>2];Dr(o,t[u>>2]|0);Nr(o);s=n;return}function kr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+160|0;n=r+144|0;f=r+140|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0))t[n>>2]=t[_>>2];Mr(u);i=u+136|0;t[i>>2]=t[i>>2]|1;t[u>>2]=t[n>>2];Br(u,t[f>>2]|0);Nr(u);s=r;return}function hr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+160|0;n=r+144|0;f=r+140|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0))t[n>>2]=t[_>>2];Mr(u);i=u+136|0;t[i>>2]=t[i>>2]|1;t[u>>2]=t[n>>2];Ir(u,t[f>>2]|0);Nr(u);s=r;return}function wr(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}switch(t[(t[n>>2]|0)+4>>2]|0){case 21:case 13:case 9:{t[u>>2]=t[(t[n>>2]|0)+12>>2];break}case 20:case 19:case 18:case 17:case 16:case 15:case 14:case 12:case 11:case 6:case 10:case 5:{t[f>>2]=1;break}case 1:{t[u>>2]=t[(t[n>>2]|0)+12>>2];break}case 2:{t[u>>2]=t[(t[n>>2]|0)+12>>2];break}case 8:case 7:case 4:case 3:{if(t[(t[n>>2]|0)+40>>2]|0)t[f>>2]=rs(t[(t[n>>2]|0)+40>>2]|0)|0;break}default:{}}while(1){if(!(t[u>>2]|0))break;t[u>>2]=t[(t[u>>2]|0)+24>>2];t[f>>2]=(t[f>>2]|0)+1}t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function dr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){s=r;return}if(!(t[u>>2]|0)){xe(t[f>>2]|0,121712,n|0)|0;s=r;return}do switch(t[(t[u>>2]|0)+4>>2]|0){case 4:{xe(t[f>>2]|0,121744,n|0)|0;break}case 8:{xe(t[f>>2]|0,121776,n|0)|0;
	break}case 12:{xe(t[f>>2]|0,121816,n|0)|0;break}case 10:{xe(t[f>>2]|0,121800,n|0)|0;break}case 3:{xe(t[f>>2]|0,121736,n|0)|0;break}case 13:{xe(t[f>>2]|0,121792,n|0)|0;break}case 11:{xe(t[f>>2]|0,121808,n|0)|0;break}case 18:{xe(t[f>>2]|0,121824,n|0)|0;break}case 6:{xe(t[f>>2]|0,121760,n|0)|0;break}case 2:{xe(t[f>>2]|0,121728,n|0)|0;break}case 7:{xe(t[f>>2]|0,121768,n|0)|0;break}case 1:{xe(t[f>>2]|0,121720,n|0)|0;break}case 5:{xe(t[f>>2]|0,121752,n|0)|0;break}case 9:{xe(t[f>>2]|0,121784,n|0)|0;break}default:xe(t[f>>2]|0,121832,n|0)|0}while(0);do if((t[(t[u>>2]|0)+4>>2]|0)!=18){i=t[f>>2]|0;if(t[(t[u>>2]|0)+44>>2]|0)xe(i|0,121728,n|0)|0;else xe(i|0,121720,n|0)|0;i=t[f>>2]|0;if(t[(t[u>>2]|0)+48>>2]|0){xe(i|0,121824,n|0)|0;break}else{xe(i|0,121720,n|0)|0;break}}while(0);i=t[f>>2]|0;t[n>>2]=wr(t[u>>2]|0)|0;xe(i|0,121840,n|0)|0;e:do switch(t[(t[u>>2]|0)+4>>2]|0){case 1:{if(t[(t[u>>2]|0)+8>>2]|0){if((t[(t[u>>2]|0)+36>>2]|0)!=0?(t[(t[(t[u>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){i=t[f>>2]|0;t[n>>2]=t[(t[(t[u>>2]|0)+36>>2]|0)+12>>2];xe(i|0,121848,n|0)|0}i=t[f>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,121856,n|0)|0}break}case 6:{if(t[(t[u>>2]|0)+8>>2]|0){i=t[f>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,121856,n|0)|0}break}case 2:{if(t[(t[u>>2]|0)+8>>2]|0){i=t[f>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,121856,n|0)|0}break}case 5:{if(t[(t[u>>2]|0)+8>>2]|0){i=t[f>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,121856,n|0)|0}break}case 12:case 11:case 10:case 13:case 9:case 8:case 4:break;case 3:{if(t[(t[u>>2]|0)+40>>2]|0)cr(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);break}case 7:{if(t[(t[u>>2]|0)+8>>2]|0){i=t[f>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,121856,n|0)|0}break}case 18:{t[a>>2]=t[u>>2];i=t[f>>2]|0;e=t[a>>2]|0;if(!(t[(t[a>>2]|0)+12>>2]|0)){t[n>>2]=t[e+8>>2];xe(i|0,121864,n|0)|0;break e}else{o=t[(t[a>>2]|0)+8>>2]|0;t[n>>2]=t[e+12>>2];t[n+4>>2]=o;xe(i|0,121880,n|0)|0;break e}break}default:if(t[(t[u>>2]|0)+8>>2]|0){i=t[f>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,121856,n|0)|0}}while(0);xe(t[f>>2]|0,121896,n|0)|0;s=r;return}function vr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+12|0;c=f+4|0;t[a>>2]=e;t[f+16>>2]=i;t[o>>2]=r;t[f+8>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=0;l=t[u>>2]|0;s=f;return l|0}if(!(t[o>>2]|0)){xe(t[(t[a>>2]|0)+20>>2]|0,121712,f|0)|0;t[u>>2]=0;l=t[u>>2]|0;s=f;return l|0}do if((t[(t[o>>2]|0)+4>>2]|0)!=9?(t[(t[o>>2]|0)+4>>2]|0)!=13:0){if((t[(t[o>>2]|0)+4>>2]|0)==18){dr(t[(t[a>>2]|0)+20>>2]|0,t[o>>2]|0);t[u>>2]=0;l=t[u>>2]|0;s=f;return l|0}if(t[(t[o>>2]|0)+12>>2]|0){t[c>>2]=t[(t[o>>2]|0)+12>>2];break}dr(t[(t[a>>2]|0)+20>>2]|0,t[o>>2]|0);t[u>>2]=0;l=t[u>>2]|0;s=f;return l|0}else b=7;while(0);if((b|0)==7)t[c>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break;dr(t[(t[a>>2]|0)+20>>2]|0,t[c>>2]|0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}t[u>>2]=0;l=t[u>>2]|0;s=f;return l|0}function mr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f;a=f+24|0;o=f+20|0;c=f+12|0;l=f+4|0;t[o>>2]=e;t[f+16>>2]=i;t[c>>2]=r;t[f+8>>2]=n;if(!(t[o>>2]|0)){t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}if(!(t[c>>2]|0)){xe(t[(t[o>>2]|0)+20>>2]|0,121712,u|0)|0;t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}t[l>>2]=oF(t[(t[c>>2]|0)+32>>2]|0,t[c>>2]|0)|0;c=t[(t[o>>2]|0)+20>>2]|0;if(!(t[l>>2]|0))xe(c|0,122072,u|0)|0;else{t[u>>2]=t[l>>2];xe(c|0,122096,u|0)|0;pAi[t[135736>>2]&511](t[l>>2]|0)}t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}function _r(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+8|0;t[a>>2]=e;t[f+12>>2]=i;t[o>>2]=r;t[f+4>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=0;c=t[u>>2]|0;s=f;return c|0}if(!(t[o>>2]|0)){xe(t[(t[a>>2]|0)+20>>2]|0,121712,f|0)|0;t[u>>2]=0;c=t[u>>2]|0;s=f;return c|0}do if((t[(t[o>>2]|0)+4>>2]|0)!=9?(t[(t[o>>2]|0)+4>>2]|0)!=13:0){n=t[(t[a>>2]|0)+20>>2]|0;r=t[o>>2]|0;if((t[(t[o>>2]|0)+4>>2]|0)==2){lr(n,r,0);break}else{br(n,r,0);break}}else l=7;while(0);if((l|0)==7)kr(t[(t[a>>2]|0)+20>>2]|0,t[o>>2]|0);t[u>>2]=0;c=t[u>>2]|0;s=f;return c|0}function pr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+20|0;o=f+16|0;c=f+8|0;t[o>>2]=e;t[f+12>>2]=i;t[c>>2]=r;t[f+4>>2]=n;if(!(t[o>>2]|0)){t[a>>2]=0;l=t[a>>2]|0;s=f;return l|0}n=t[o>>2]|0;if(!(t[c>>2]|0)){xe(t[n+20>>2]|0,121712,u|0)|0;t[a>>2]=0;l=t[a>>2]|0;s=f;return l|0}r=t[(t[c>>2]|0)+4>>2]|0;do if((t[(t[n+4>>2]|0)+4>>2]|0)==13){i=t[(t[o>>2]|0)+20>>2]|0;if((r|0)==13){ir(i,t[c>>2]|0)|0;break}else{Ji(i,t[(t[o>>2]|0)+4>>2]|0,t[c>>2]|0);break}}else{i=t[(t[o>>2]|0)+20>>2]|0;if((r|0)==9){mV(i,t[c>>2]|0)|0;break}else{bV(i,t[(t[o>>2]|0)+4>>2]|0,t[c>>2]|0);break}}while(0);xe(t[(t[o>>2]|0)+20>>2]|0,121896,u|0)|0;t[a>>2]=0;l=t[a>>2]|0;s=f;return l|0}function Er(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[f+12>>2]=r;t[f+8>>2]=n;t[l>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if(t[(t[a>>2]|0)+4>>2]|0)t[l>>2]=(t[(t[(t[a>>2]|0)+4>>2]|0)+4>>2]|0)==13&1;n=t[o>>2]|0;if(t[l>>2]|0)t[c>>2]=RN(n,0)|0;else t[c>>2]=_S(n,0,0)|0;if(!(t[c>>2]|0)){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if((t[(t[a>>2]|0)+16>>2]|0)==1)fy(t[(t[a>>2]|0)+4>>2]|0);t[(t[a>>2]|0)+16>>2]=1;vf(t[(t[a>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[t[a>>2]>>2]|0);t[(t[a>>2]|0)+4>>2]=t[c>>2];t[(t[a>>2]|0)+8>>2]=t[c>>2];n=wf(t[c>>2]|0)|0;t[(t[a>>2]|0)+12>>2]=n;n=KA(t[o>>2]|0)|0;t[t[a>>2]>>2]=n;t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}function Sr(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+4|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[u+8>>2]=f;if(!(t[b>>2]|0)){t[o>>2]=-1;h=t[o>>2]|0;s=u;return h|0}if((t[l>>2]|0)!=0?(n[t[l>>2]>>0]|0)!=0:0){f=t[(t[b>>2]|0)+4>>2]|0;do if((f|0)==9){if((SV(t[l>>2]|0,t[(t[c>>2]|0)+4>>2]|0)|0)<-1){r=t[33976]|0;i=t[33980]|0;t[a>>2]=t[l>>2];yAi[r&511](i,122104,a);t[o>>2]=-1;h=t[o>>2]|0;s=u;return h|0}}else if((f|0)==13){if((rr(t[l>>2]|0,t[(t[c>>2]|0)+4>>2]|0)|0)<0){i=t[33976]|0;r=t[33980]|0;t[a>>2]=t[l>>2];yAi[i&511](r,122104,a);t[o>>2]=-1;h=t[o>>2]|0;s=u;return h|0}}else{t[k>>2]=mi(t[l>>2]|0,122128)|0;if(t[k>>2]|0){bV(t[k>>2]|0,t[(t[c>>2]|0)+4>>2]|0,t[b>>2]|0);Qe(t[k>>2]|0)|0;break}r=t[33976]|0;i=t[33980]|0;t[a>>2]=t[l>>2];yAi[r&511](i,122104,a);t[o>>2]=-1;h=t[o>>2]|0;s=u;return h|0}while(0);t[o>>2]=0;h=t[o>>2]|0;s=u;return h|0}t[o>>2]=-1;h=t[o>>2]|0;s=u;return h|0}function gr(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0;u=s;s=s+32|0;a=u;o=u+20|0;c=u+16|0;l=u+12|0;t[c>>2]=e;t[l>>2]=i;t[u+8>>2]=r;t[u+4>>2]=f;if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)!=0:0){if(!((t[l>>2]|0)!=0?(n[t[l>>2]>>0]|0)!=0:0))t[l>>2]=t[t[c>>2]>>2];if(!(t[l>>2]|0)){t[o>>2]=-1;b=t[o>>2]|0;s=u;return b|0}f=t[(t[(t[c>>2]|0)+4>>2]|0)+4>>2]|0;if((f|0)==9){if((SV(t[l>>2]|0,t[(t[c>>2]|0)+4>>2]|0)|0)<0){r=t[33976]|0;i=t[33980]|0;t[a>>2]=t[l>>2];yAi[r&511](i,122136,a)}}else if((f|0)==13){if((rr(t[l>>2]|0,t[(t[c>>2]|0)+4>>2]|0)|0)<0){c=t[33976]|0;f=t[33980]|0;t[a>>2]=t[l>>2];yAi[c&511](f,122136,a)}}else{yAi[t[135904>>2]&511](t[33980]|0,122160,a);t[o>>2]=-1;b=t[o>>2]|0;s=u;return b|0}t[o>>2]=0;b=t[o>>2]|0;s=u;return b|0}t[o>>2]=-1;b=t[o>>2]|0;s=u;return b|0}function yr(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+96|0;a=u+88|0;o=u+84|0;c=u+80|0;l=u+8|0;b=u+4|0;k=u;t[o>>2]=e;t[c>>2]=i;t[u+76>>2]=r;t[u+72>>2]=f;t[b>>2]=-1;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)!=0:0){t[l>>2]=t[v>>2];t[l+4>>2]=203;t[l+8>>2]=203;if((t[c>>2]|0)!=0?(n[t[c>>2]>>0]|0)!=0:0){t[k>>2]=aS(0,t[c>>2]|0)|0;if(t[k>>2]|0){t[b>>2]=dR(l,t[(t[o>>2]|0)+4>>2]|0,t[k>>2]|0)|0;ey(t[k>>2]|0)}}else t[b>>2]=mR(l,t[(t[o>>2]|0)+4>>2]|0)|0;t[a>>2]=t[b>>2];h=t[a>>2]|0;s=u;return h|0}t[a>>2]=-1;h=t[a>>2]|0;s=u;return h|0}function Fr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+48|0;u=f;a=f+32|0;o=f+28|0;c=f+20|0;l=f+12|0;b=f+8|0;k=f+4|0;t[o>>2]=e;t[f+24>>2]=i;t[c>>2]=r;t[f+16>>2]=n;t[b>>2]=0;if(!(t[o>>2]|0)){t[a>>2]=-1;h=t[a>>2]|0;s=f;return h|0}if(!(t[c>>2]|0)){t[a>>2]=-1;h=t[a>>2]|0;s=f;return h|0}t[l>>2]=t[c>>2];while(1){if(!(t[l>>2]|0))break;if((t[(t[l>>2]|0)+4>>2]|0)!=9?(t[(t[l>>2]|0)+4>>2]|0)!=13:0){if((t[(t[l>>2]|0)+4>>2]|0)==1){t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[b>>2]|0))break;xe(t[(t[o>>2]|0)+20>>2]|0,122232,u|0)|0;t[k>>2]=(t[k>>2]|0)+1}if((t[(t[l>>2]|0)+36>>2]|0)!=0?(t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){n=t[(t[o>>2]|0)+20>>2]|0;t[u>>2]=t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2];xe(n|0,121848,u|0)|0}n=t[(t[o>>2]|0)+20>>2]|0;t[u>>2]=t[(t[l>>2]|0)+8>>2];xe(n|0,122096,u|0)|0}}else xe(t[(t[o>>2]|0)+20>>2]|0,122224,u|0)|0;if((t[(t[l>>2]|0)+4>>2]|0)!=9?(t[(t[l>>2]|0)+4>>2]|0)!=13:0){if((t[(t[l>>2]|0)+12>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)!=5:0){t[l>>2]=t[(t[l>>2]|0)+12>>2];t[b>>2]=(t[b>>2]|0)+1;continue}if((t[l>>2]|0)!=(t[c>>2]|0)?(t[(t[l>>2]|0)+24>>2]|0)!=0:0){t[l>>2]=t[(t[l>>2]|0)+24>>2];continue}if((t[l>>2]|0)==(t[c>>2]|0)){t[l>>2]=0;continue}while(1){if((t[l>>2]|0)==(t[c>>2]|0))break;if(t[(t[l>>2]|0)+20>>2]|0){t[l>>2]=t[(t[l>>2]|0)+20>>2];t[b>>2]=(t[b>>2]|0)+-1}if((t[l>>2]|0)!=(t[c>>2]|0)?(t[(t[l>>2]|0)+24>>2]|0)!=0:0){w=33;break}if(!(t[(t[l>>2]|0)+20>>2]|0)){w=35;break}if((t[l>>2]|0)==(t[c>>2]|0)){w=37;break}}if((w|0)==33){w=0;t[l>>2]=t[(t[l>>2]|0)+24>>2]}else if((w|0)==35){w=0;t[l>>2]=0}else if((w|0)==37){w=0;t[l>>2]=0}if((t[l>>2]|0)!=(t[c>>2]|0))continue;t[l>>2]=0;continue}t[l>>2]=t[(t[l>>2]|0)+12>>2]}t[a>>2]=0;h=t[a>>2]|0;s=f;return h|0}function Or(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+16|0;l=u+12|0;b=u+4|0;t[u+20>>2]=e;t[c>>2]=i;t[l>>2]=r;t[u+8>>2]=f;if((t[l>>2]|0)==0|(t[c>>2]|0)==0){t[o>>2]=-1;k=t[o>>2]|0;s=u;return k|0}t[b>>2]=$y(t[l>>2]|0)|0;if(!(t[b>>2]|0)){t[o>>2]=-1;k=t[o>>2]|0;s=u;return k|0}else{l=t[c>>2]|0;t[a>>2]=t[b>>2];SY(l,499,121856,a)|0;n[(t[c>>2]|0)+499>>0]=48;pAi[t[135736>>2]&511](t[b>>2]|0);t[o>>2]=0;k=t[o>>2]|0;s=u;return k|0}return 0}function Ar(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;u=s;s=s+2080|0;a=u;o=u+72|0;c=u+68|0;l=u+64|0;b=u+60|0;k=u+1580|0;h=u+56|0;w=u+52|0;d=u+1480|0;v=u+1080|0;m=u+48|0;p=u+44|0;E=u+40|0;S=u+36|0;g=u+576|0;y=u+32|0;F=u+28|0;O=u+24|0;A=u+20|0;M=u+76|0;R=u+16|0;N=u+12|0;T=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;VY(k|0,0,500)|0;n[k>>0]=47;n[k+1>>0]=32;n[k+2>>0]=62;n[k+3>>0]=32;t[h>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){s=u;return}if(!(t[b>>2]|0))t[b>>2]=t[_>>2];t[p>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[p>>2]|0)){s=u;return}t[(t[p>>2]|0)+16>>2]=0;t[(t[p>>2]|0)+4>>2]=t[o>>2];t[(t[p>>2]|0)+24>>2]=t[l>>2];t[(t[p>>2]|0)+20>>2]=t[b>>2];b=Yl(t[c>>2]|0)|0;t[t[p>>2]>>2]=b;t[(t[p>>2]|0)+8>>2]=t[(t[p>>2]|0)+4>>2];b=wf(t[(t[p>>2]|0)+4>>2]|0)|0;t[(t[p>>2]|0)+12>>2]=b;if(!(t[(t[p>>2]|0)+12>>2]|0)){pAi[t[135736>>2]&511](t[p>>2]|0);s=u;return}while(1){do if((t[(t[p>>2]|0)+8>>2]|0)==(t[(t[p>>2]|0)+4>>2]|0)){t[a>>2]=122248;SY(k,500,122240,a)|0}else{if((((t[(t[p>>2]|0)+8>>2]|0)!=0?(t[(t[(t[p>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[p>>2]|0)+8>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[(t[p>>2]|0)+8>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){b=t[(t[(t[p>>2]|0)+8>>2]|0)+8>>2]|0;t[a>>2]=t[(t[(t[(t[p>>2]|0)+8>>2]|0)+36>>2]|0)+12>>2];t[a+4>>2]=b;SY(k,500,122256,a)|0;break}if((t[(t[p>>2]|0)+8>>2]|0)!=0?(t[(t[(t[p>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){t[a>>2]=t[(t[(t[p>>2]|0)+8>>2]|0)+8>>2];SY(k,500,122240,a)|0;break}SY(k,500,122272,a)|0}while(0);n[k+499>>0]=0;t[h>>2]=gAi[t[(t[p>>2]|0)+24>>2]&511](k)|0;if(!(t[h>>2]|0))break;t[w>>2]=t[h>>2];while(1){if((n[t[w>>2]>>0]|0)!=32?(n[t[w>>2]>>0]|0)!=9:0)break;t[w>>2]=(t[w>>2]|0)+1}t[m>>2]=0;while(1){if((n[t[w>>2]>>0]|0)==32)break;if((n[t[w>>2]>>0]|0)==9)break;if((n[t[w>>2]>>0]|0)==10)break;if((n[t[w>>2]>>0]|0)==13)break;if(!(n[t[w>>2]>>0]|0))break;b=t[w>>2]|0;t[w>>2]=b+1;c=n[b>>0]|0;b=t[m>>2]|0;t[m>>2]=b+1;n[d+b>>0]=c}n[d+(t[m>>2]|0)>>0]=0;if(!(t[m>>2]|0))continue;while(1){if((n[t[w>>2]>>0]|0)!=32?(n[t[w>>2]>>0]|0)!=9:0)break;t[w>>2]=(t[w>>2]|0)+1}t[m>>2]=0;while(1){if((n[t[w>>2]>>0]|0)==10)break;if((n[t[w>>2]>>0]|0)==13)break;if(!(n[t[w>>2]>>0]|0))break;if(!(n[t[w>>2]>>0]|0))break;c=t[w>>2]|0;t[w>>2]=c+1;b=n[c>>0]|0;c=t[m>>2]|0;t[m>>2]=c+1;n[v+c>>0]=b}n[v+(t[m>>2]|0)>>0]=0;if(!(MY(d,122280)|0))break;if(!(MY(d,122288)|0))break;if(!(MY(d,122296)|0))break;e:do if(MY(d,122304)|0){if(!(MY(d,123880)|0)){yr(t[p>>2]|0,v,0,0)|0;break}if(!(MY(d,123896)|0)){Er(t[p>>2]|0,v,0,0)|0;break}if(!(MY(d,123904)|0)){Hr(t[p>>2]|0,v,0,0)|0;break}if(!(MY(d,123912)|0)){gr(t[p>>2]|0,v,0,0)|0;break}if(!(MY(d,123920)|0))if(!(n[v>>0]|0)){yAi[t[135904>>2]&511](t[33980]|0,123928,a);break}else{Sr(t[p>>2]|0,v,t[(t[p>>2]|0)+8>>2]|0,0)|0;break}if(!(MY(d,123976)|0)){xr(t[p>>2]|0,v,t[(t[p>>2]|0)+8>>2]|0,0)|0;break}if(!(MY(d,123984)|0))if(!(n[v>>0]|0)){DA(t[(t[p>>2]|0)+20>>2]|0,0);break}else{t[S>>2]=0;t[a>>2]=S;jq(v,123992,a)|0;DA(t[(t[p>>2]|0)+20>>2]|0,t[S>>2]|0);break}if(!(MY(d,124e3)|0)){if(Or(t[p>>2]|0,g,t[(t[p>>2]|0)+8>>2]|0,0)|0)break;b=t[(t[p>>2]|0)+20>>2]|0;t[a>>2]=g;xe(b|0,122096,a|0)|0;break}if(!(MY(d,124008)|0)){b=t[p>>2]|0;if(!(n[v>>0]|0)){Fr(b,0,t[(t[p>>2]|0)+8>>2]|0,0)|0;break}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[b+8>>2];t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[(t[p>>2]|0)+8>>2];t[E>>2]=Et(v,t[(t[p>>2]|0)+12>>2]|0)|0;if(t[E>>2]|0){i:do switch(t[t[E>>2]>>2]|0){case 8:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122016,a);break}case 9:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122040,a);break}case 3:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121952,a);break}case 4:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121968,a);break}case 7:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122e3,a);break}case 0:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121904,a);break}case 1:{if(!(t[(t[E>>2]|0)+4>>2]|0))break i;t[y>>2]=0;while(1){if((t[y>>2]|0)>=(t[t[(t[E>>2]|0)+4>>2]>>2]|0))break i;Fr(t[p>>2]|0,0,t[(t[(t[(t[E>>2]|0)+4>>2]|0)+8>>2]|0)+(t[y>>2]<<2)>>2]|0,0)|0;t[y>>2]=(t[y>>2]|0)+1}break}case 2:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121928,a);break}case 5:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121984,a);break}case 6:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122e3,a);break}default:{}}while(0);_n(t[E>>2]|0)}else{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121904,a)}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=0;break}if(!(MY(d,124016)|0)){mr(t[p>>2]|0,0,t[(t[p>>2]|0)+8>>2]|0,0)|0;break}if(!(MY(d,124024)|0)){Ur(t[p>>2]|0,v,t[(t[p>>2]|0)+8>>2]|0,0)|0;break}if(!(MY(d,124032)|0))if(!(n[v>>0]|0)){yAi[t[135904>>2]&511](t[33980]|0,124040,a);break}else{zr(t[p>>2]|0,v,0,0)|0;break}if(!(MY(d,124072)|0)){t[F>>2]=eF(t[(t[p>>2]|0)+4>>2]|0)|0;jr(t[p>>2]|0,0,t[F>>2]|0,0)|0;break}if(!(MY(d,124088)|0))if(!(n[v>>0]|0)){yAi[t[135904>>2]&511](t[33980]|0,124096,a);break}else{t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[(t[p>>2]|0)+8>>2];t[E>>2]=Et(v,t[(t[p>>2]|0)+12>>2]|0)|0;pn(t[(t[p>>2]|0)+20>>2]|0,t[E>>2]|0,0);_n(t[E>>2]|0);break}if(!(MY(d,124128)|0)){Vr(t[p>>2]|0,v,t[(t[p>>2]|0)+8>>2]|0,0)|0;break}do if(MY(d,124136)|0){if(!(MY(d,124144)|0))break;if(!(MY(d,124152)|0)){b=t[p>>2]|0;if(!(n[v>>0]|0)){if(Or(b,M,t[(t[p>>2]|0)+8>>2]|0,0)|0)break e;c=t[(t[p>>2]|0)+20>>2]|0;t[a>>2]=M;xe(c|0,122096,a|0)|0;break e}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[b+8>>2];t[E>>2]=Et(v,t[(t[p>>2]|0)+12>>2]|0)|0;if(t[E>>2]|0){i:do switch(t[t[E>>2]>>2]|0){case 4:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121968,a);break}case 5:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121984,a);break}case 6:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122e3,a);break}case 7:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122e3,a);break}case 8:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122016,a);break}case 9:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122040,a);break}case 2:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121928,a);break}case 3:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121952,a);break}case 0:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121904,a);break}case 1:{if(!(t[(t[E>>2]|0)+4>>2]|0))break i;t[R>>2]=0;while(1){if((t[R>>2]|0)>=(t[t[(t[E>>2]|0)+4>>2]>>2]|0))break i;if(!(Or(t[p>>2]|0,M,t[(t[(t[(t[E>>2]|0)+4>>2]|0)+8>>2]|0)+(t[R>>2]<<2)>>2]|0,0)|0)){c=t[(t[p>>2]|0)+20>>2]|0;t[a>>2]=M;xe(c|0,122096,a|0)|0}t[R>>2]=(t[R>>2]|0)+1}break}default:{}}while(0);_n(t[E>>2]|0)}else{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121904,a)}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=0;break e}if(MY(d,124160)|0){if(MY(d,124248)|0){b=t[33976]|0;c=t[33980]|0;t[a>>2]=d;yAi[b&511](c,124272,a);break e}c=t[p>>2]|0;if(!(n[v>>0]|0)){pr(c,0,t[(t[p>>2]|0)+8>>2]|0,0)|0;break e}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[c+8>>2];t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[(t[p>>2]|0)+8>>2];t[E>>2]=Et(v,t[(t[p>>2]|0)+12>>2]|0)|0;if(t[E>>2]|0){i:do switch(t[t[E>>2]>>2]|0){case 2:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121928,a);break}case 3:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121952,a);break}case 4:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121968,a);break}case 5:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121984,a);break}case 6:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122e3,a);break}case 7:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122e3,a);break}case 8:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122016,a);break}case 9:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122040,a);break}case 0:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121904,a);break}case 1:{if(!(t[(t[E>>2]|0)+4>>2]|0))break i;t[T>>2]=0;while(1){if((t[T>>2]|0)>=(t[t[(t[E>>2]|0)+4>>2]>>2]|0))break i;if((t[m>>2]|0)>0)xe(t[(t[p>>2]|0)+20>>2]|0,124256,a|0)|0;pr(t[p>>2]|0,0,t[(t[(t[(t[E>>2]|0)+4>>2]|0)+8>>2]|0)+(t[T>>2]<<2)>>2]|0,0)|0;t[T>>2]=(t[T>>2]|0)+1}break}default:{}}while(0);_n(t[E>>2]|0)}else{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121904,a)}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=0;break e}c=t[p>>2]|0;if(!(n[v>>0]|0)){t[(t[p>>2]|0)+8>>2]=t[c+4>>2];break e}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[c+8>>2];t[N>>2]=HY(v|0)|0;do if((t[N>>2]|0)>=2){if((n[v+((t[N>>2]|0)-1)>>0]|0)!=47)break;n[v+((t[N>>2]|0)-1)>>0]=0}while(0);t[E>>2]=Et(v,t[(t[p>>2]|0)+12>>2]|0)|0;if(t[E>>2]|0){i:do switch(t[t[E>>2]>>2]|0){case 0:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121904,a);break}case 1:{if(!(t[(t[E>>2]|0)+4>>2]|0)){b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,124216,a);break i}if((t[t[(t[E>>2]|0)+4>>2]>>2]|0)!=1){c=t[33976]|0;b=t[33980]|0;l=t[t[(t[E>>2]|0)+4>>2]>>2]|0;t[a>>2]=v;t[a+4>>2]=l;yAi[c&511](b,124192,a);break i}t[(t[p>>2]|0)+8>>2]=t[t[(t[(t[E>>2]|0)+4>>2]|0)+8>>2]>>2];if(!(t[(t[p>>2]|0)+8>>2]|0))break i;if((t[(t[(t[p>>2]|0)+8>>2]|0)+4>>2]|0)!=18)break i;yAi[t[135904>>2]&511](t[33980]|0,124168,a);t[(t[p>>2]|0)+8>>2]=0;break}case 2:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121928,a);break}case 3:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121952,a);break}case 4:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121968,a);break}case 5:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121984,a);break}case 6:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122e3,a);break}case 7:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122e3,a);break}case 8:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122016,a);break}case 9:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122040,a);break}default:{}}while(0);_n(t[E>>2]|0)}else{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121904,a)}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=0;break e}while(0);t[O>>2]=((MY(d,124144)|0)!=0^1)&1;if(!(n[v>>0]|0)){c=t[p>>2]|0;b=t[(t[p>>2]|0)+8>>2]|0;if(t[O>>2]|0){_r(c,0,b,0)|0;break}else{vr(c,0,b,0)|0;break}}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[(t[p>>2]|0)+8>>2];t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=t[(t[p>>2]|0)+8>>2];t[E>>2]=Et(v,t[(t[p>>2]|0)+12>>2]|0)|0;if(t[E>>2]|0){i:do switch(t[t[E>>2]>>2]|0){case 1:{if(!(t[(t[E>>2]|0)+4>>2]|0))break i;t[A>>2]=0;while(1){if((t[A>>2]|0)>=(t[t[(t[E>>2]|0)+4>>2]>>2]|0))break i;b=t[p>>2]|0;c=t[(t[(t[(t[E>>2]|0)+4>>2]|0)+8>>2]|0)+(t[A>>2]<<2)>>2]|0;if(t[O>>2]|0)_r(b,0,c,0)|0;else vr(b,0,c,0)|0;t[A>>2]=(t[A>>2]|0)+1}break}case 7:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122e3,a);break}case 8:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,122016,a);break}case 9:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122040,a);break}case 0:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121904,a);break}case 2:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121928,a);break}case 3:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121952,a);break}case 4:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,121968,a);break}case 5:{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121984,a);break}case 6:{c=t[33976]|0;b=t[33980]|0;t[a>>2]=v;yAi[c&511](b,122e3,a);break}default:{}}while(0);_n(t[E>>2]|0)}else{b=t[33976]|0;c=t[33980]|0;t[a>>2]=v;yAi[b&511](c,121904,a)}t[(t[(t[p>>2]|0)+12>>2]|0)+4>>2]=0}else{xe(t[(t[p>>2]|0)+20>>2]|0,122312,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122360,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122408,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122440,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122488,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122544,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122632,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122712,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122744,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122784,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122824,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122872,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,122936,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123024,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123112,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123192,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123280,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123344,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123416,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123472,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123552,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123584,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123648,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123704,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123752,a|0)|0;xe(t[(t[p>>2]|0)+20>>2]|0,123824,a|0)|0}while(0);Zq(t[h>>2]|0);t[h>>2]=0}vf(t[(t[p>>2]|0)+12>>2]|0);if(t[(t[p>>2]|0)+16>>2]|0)fy(t[(t[p>>2]|0)+4>>2]|0);if(t[t[p>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[p>>2]>>2]|0);pAi[t[135736>>2]&511](t[p>>2]|0);if(!(t[h>>2]|0)){s=u;return}Zq(t[h>>2]|0);s=u;return}function Mr(e){e=e|0;var i=0,r=0,f=0;i=s;s=s+16|0;r=i+4|0;f=i;t[r>>2]=e;t[(t[r>>2]|0)+108>>2]=0;t[(t[r>>2]|0)+124>>2]=0;t[(t[r>>2]|0)+128>>2]=0;t[t[r>>2]>>2]=t[_>>2];t[(t[r>>2]|0)+112>>2]=0;t[(t[r>>2]|0)+116>>2]=0;t[(t[r>>2]|0)+120>>2]=0;t[(t[r>>2]|0)+132>>2]=0;t[(t[r>>2]|0)+136>>2]=0;t[f>>2]=0;while(1){if((t[f>>2]|0)>=100)break;n[(t[r>>2]|0)+4+(t[f>>2]|0)>>0]=32;t[f>>2]=(t[f>>2]|0)+1}n[(t[r>>2]|0)+104>>0]=0;s=i;return}function Rr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;qr(t[f>>2]|0);i=(t[(t[f>>2]|0)+124>>2]|0)!=0;if(!(t[u>>2]|0)){if(i){s=r;return}xe(t[t[f>>2]>>2]|0,127816,n|0)|0;s=r;return}if(!i?(xe(t[t[f>>2]>>2]|0,127832,n|0)|0,Yr(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0),xe(t[t[f>>2]>>2]|0,121896,n|0)|0,(t[(t[u>>2]|0)+12>>2]|0)!=0):0){n=(t[f>>2]|0)+108|0;t[n>>2]=(t[n>>2]|0)+1;Pr(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0);n=(t[f>>2]|0)+108|0;t[n>>2]=(t[n>>2]|0)+-1}if(!(t[(t[u>>2]|0)+8>>2]|0))Gr(t[f>>2]|0,5015,127848);Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}function Nr(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return}function Tr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){s=r;return}Kr(t[f>>2]|0,t[u>>2]|0);if((t[(t[u>>2]|0)+44>>2]|0)!=0?(t[(t[(t[u>>2]|0)+44>>2]|0)+48>>2]|0)!=0:0){t[a>>2]=t[(t[(t[u>>2]|0)+44>>2]|0)+48>>2];if(!(t[(t[f>>2]|0)+124>>2]|0))xe(t[t[f>>2]>>2]|0,127472,n|0)|0;aO(t[a>>2]|0,259,t[f>>2]|0)}else xe(t[t[f>>2]>>2]|0,127504,n|0)|0;if((t[(t[u>>2]|0)+48>>2]|0)!=0?(t[(t[(t[u>>2]|0)+48>>2]|0)+48>>2]|0)!=0:0){t[o>>2]=t[(t[(t[u>>2]|0)+48>>2]|0)+48>>2];if(!(t[(t[f>>2]|0)+124>>2]|0))xe(t[t[f>>2]>>2]|0,127536,n|0)|0;aO(t[o>>2]|0,259,t[f>>2]|0);s=r;return}if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}xe(t[t[f>>2]>>2]|0,127568,n|0)|0;s=r;return}function Lr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;Rr(t[n>>2]|0,t[f>>2]|0);t[f>>2]=t[(t[f>>2]|0)+24>>2]}s=r;return}function Dr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+8|0;a=r+4|0;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126040,n|0)|0;s=r;return}t[(t[f>>2]|0)+116>>2]=t[u>>2];e:do switch(t[(t[u>>2]|0)+4>>2]|0){case 1:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126056,n|0)|0;if((t[(t[u>>2]|0)+36>>2]|0)!=0?(t[(t[(t[u>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){Yr(t[f>>2]|0,t[(t[(t[u>>2]|0)+36>>2]|0)+12>>2]|0);xe(t[t[f>>2]>>2]|0,126072,n|0)|0}Yr(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}break}case 4:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126168,n|0)|0}break}case 15:{Jr(t[f>>2]|0,t[u>>2]|0);s=r;return}case 13:case 9:{if(!(t[(t[f>>2]|0)+124>>2]|0))qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126232,n|0)|0;Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}case 11:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126280,n|0)|0}break}case 2:{if(!(t[(t[f>>2]|0)+124>>2]|0))qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126080,n|0)|0;Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}case 16:{Qr(t[f>>2]|0,t[u>>2]|0);s=r;return}case 5:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,126184,n|0)|0}break}case 17:{$r(t[f>>2]|0,t[u>>2]|0);s=r;return}case 8:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126216,n|0)|0}break}case 7:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,126208,n|0)|0}break}case 12:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126296,n|0)|0}break}case 14:{Zr(t[f>>2]|0,t[u>>2]|0);s=r;return}case 19:{if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126312,n|0)|0;s=r;return}case 6:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126200,n|0)|0}break}case 10:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126264,n|0)|0}break}case 18:{en(t[f>>2]|0,t[u>>2]|0);s=r;return}case 20:{if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126328,n|0)|0;s=r;return}case 3:{if(!(t[(t[f>>2]|0)+124>>2]|0)){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;if((t[(t[u>>2]|0)+8>>2]|0)==75112)xe(i|0,126112,n|0)|0;else xe(i|0,126128,n|0)|0;if(!(t[(t[f>>2]|0)+136>>2]&1)){xe(t[t[f>>2]>>2]|0,121896,n|0)|0;break e}i=t[f>>2]|0;if((t[(t[u>>2]|0)+40>>2]|0)==((t[u>>2]|0)+44|0)){xe(t[i>>2]|0,126136,n|0)|0;break e}e=(wz(t[i+120>>2]|0,t[(t[u>>2]|0)+40>>2]|0)|0)==1;i=t[t[f>>2]>>2]|0;if(e){xe(i|0,126152,n|0)|0;break e}else{xe(i|0,121896,n|0)|0;break e}}break}default:{if(!(t[(t[f>>2]|0)+124>>2]|0))qr(t[f>>2]|0);rn(t[f>>2]|0,5011,126016,t[(t[u>>2]|0)+4>>2]|0);s=r;return}}while(0);if(!(t[(t[u>>2]|0)+32>>2]|0)){if(!(t[(t[f>>2]|0)+124>>2]|0))qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126344,n|0)|0}i=(t[f>>2]|0)+108|0;t[i>>2]=(t[i>>2]|0)+1;if((t[(t[u>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+48>>2]|0)!=0:0)nn(t[f>>2]|0,t[(t[u>>2]|0)+48>>2]|0);if((t[(t[u>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+44>>2]|0)!=0:0)Lr(t[f>>2]|0,t[(t[u>>2]|0)+44>>2]|0);i=t[u>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)!=5){if(((t[i+4>>2]|0)!=1?(t[(t[u>>2]|0)+40>>2]|0)!=0:0)?(t[(t[f>>2]|0)+124>>2]|0)==0:0){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126368,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}}else{t[a>>2]=h_(t[i+32>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;if(t[a>>2]|0)fn(t[f>>2]|0,t[a>>2]|0)}a=(t[f>>2]|0)+108|0;t[a>>2]=(t[a>>2]|0)+-1;Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}function Cr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;if(!(t[u>>2]|0)){if(t[i+124>>2]|0){s=r;return}qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126040,n|0)|0;s=r;return}Dr(i,t[u>>2]|0);if((t[(t[u>>2]|0)+4>>2]|0)==18){s=r;return}if(!(t[(t[u>>2]|0)+12>>2]|0)){s=r;return}if((t[(t[u>>2]|0)+4>>2]|0)==5){s=r;return}i=(t[f>>2]|0)+108|0;t[i>>2]=(t[i>>2]|0)+1;Pr(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0);u=(t[f>>2]|0)+108|0;t[u>>2]=(t[u>>2]|0)+-1;s=r;return}function Pr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;Cr(t[n>>2]|0,t[f>>2]|0);t[f>>2]=t[(t[f>>2]|0)+24>>2]}s=r;return}function Br(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){s=r;return}Kr(t[f>>2]|0,t[u>>2]|0);if(!(t[(t[f>>2]|0)+124>>2]|0)){if(t[(t[u>>2]|0)+8>>2]|0){xe(t[t[f>>2]>>2]|0,125424,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}if(t[(t[u>>2]|0)+56>>2]|0){xe(t[t[f>>2]>>2]|0,125432,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+56>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}if(t[(t[u>>2]|0)+60>>2]|0){xe(t[t[f>>2]>>2]|0,125448,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+60>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}if(t[(t[u>>2]|0)+72>>2]|0){xe(t[t[f>>2]>>2]|0,125464,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+72>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}if(t[(t[u>>2]|0)+40>>2]|0)xe(t[t[f>>2]>>2]|0,125472,n|0)|0}if(!(t[(t[u>>2]|0)+52>>2]|0)){s=r;return}nn(t[f>>2]|0,t[(t[u>>2]|0)+52>>2]|0);s=r;return}function Ir(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;if(!(t[u>>2]|0)){if(t[i+124>>2]|0){s=r;return}xe(t[t[f>>2]>>2]|0,125400,n|0)|0;s=r;return}Br(i,t[u>>2]|0);if((t[(t[u>>2]|0)+4>>2]|0)!=9?(t[(t[u>>2]|0)+4>>2]|0)!=13:0){s=r;return}if(!(t[(t[u>>2]|0)+12>>2]|0)){s=r;return}i=(t[f>>2]|0)+108|0;t[i>>2]=(t[i>>2]|0)+1;Pr(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0);u=(t[f>>2]|0)+108|0;t[u>>2]=(t[u>>2]|0)+-1;s=r;return}function Hr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+48|0;u=f;a=f+36|0;o=f+32|0;c=f+28|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;t[o>>2]=e;t[c>>2]=i;t[f+24>>2]=r;t[f+20>>2]=n;t[b>>2]=IH(t[c>>2]|0)|0;UH(t[b>>2]|0,203,203,t[v>>2]|0);t[l>>2]=xH(t[b>>2]|0)|0;HH(t[b>>2]|0);if(!(t[l>>2]|0)){b=t[33976]|0;n=t[33980]|0;t[u>>2]=t[c>>2];yAi[b&511](n,124416,u);t[a>>2]=-1;w=t[a>>2]|0;s=f;return w|0}t[k>>2]=YH(t[l>>2]|0)|0;WH(t[k>>2]|0,203,203,t[v>>2]|0);t[h>>2]=XH(t[k>>2]|0,t[(t[o>>2]|0)+4>>2]|0)|0;do if(t[h>>2]|0){n=t[v>>2]|0;b=t[t[o>>2]>>2]|0;if((t[h>>2]|0)>0){t[u>>2]=b;xe(n|0,124472,u|0)|0;break}else{t[u>>2]=b;xe(n|0,124496,u|0)|0;break}}else{n=t[v>>2]|0;t[u>>2]=t[t[o>>2]>>2];xe(n|0,124456,u|0)|0}while(0);GH(t[k>>2]|0);if(t[l>>2]|0)CH(t[l>>2]|0);t[a>>2]=0;w=t[a>>2]|0;s=f;return w|0}function xr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[f+4>>2]=n;if(!(t[o>>2]|0)){t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}if(!(t[l>>2]|0)){t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}if(!(t[c>>2]|0)){t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}if(((es(t[c>>2]|0,63)|0)==0?(es(t[c>>2]|0,42)|0)==0:0)?(es(t[c>>2]|0,46)|0)==0:0)es(t[c>>2]|0,91)|0;e:while(1){if(!(t[l>>2]|0))break;n=t[l>>2]|0;if((t[(t[l>>2]|0)+4>>2]|0)==8){if(is(t[n+40>>2]|0,t[c>>2]|0)|0){r=t[(t[o>>2]|0)+20>>2]|0;t[u>>2]=$y(t[l>>2]|0)|0;xe(r|0,124408,u|0)|0;vr(t[o>>2]|0,0,t[l>>2]|0,0)|0}}else if((t[n+4>>2]|0)==3?(is(t[(t[l>>2]|0)+40>>2]|0,t[c>>2]|0)|0)!=0:0){n=t[(t[o>>2]|0)+20>>2]|0;t[u>>2]=$y(t[(t[l>>2]|0)+20>>2]|0)|0;xe(n|0,124408,u|0)|0;vr(t[o>>2]|0,0,t[(t[l>>2]|0)+20>>2]|0,0)|0}if((t[(t[l>>2]|0)+4>>2]|0)!=9?(t[(t[l>>2]|0)+4>>2]|0)!=13:0){if((t[(t[l>>2]|0)+12>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)!=5:0){t[l>>2]=t[(t[l>>2]|0)+12>>2];continue}if(t[(t[l>>2]|0)+24>>2]|0){t[l>>2]=t[(t[l>>2]|0)+24>>2];continue}while(1){if(!(t[l>>2]|0))continue e;if(t[(t[l>>2]|0)+20>>2]|0)t[l>>2]=t[(t[l>>2]|0)+20>>2];k=t[l>>2]|0;if(t[(t[l>>2]|0)+24>>2]|0){h=30;break}if(!(t[k+20>>2]|0)){h=32;break}}if((h|0)==30){h=0;t[l>>2]=t[k+24>>2];continue}else if((h|0)==32){h=0;t[l>>2]=0;continue}}t[l>>2]=t[(t[l>>2]|0)+12>>2]}t[a>>2]=0;b=t[a>>2]|0;s=f;return b|0}function Ur(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+8|0;k=f+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[f+12>>2]=n;if(!(t[o>>2]|0)){t[a>>2]=0;h=t[a>>2]|0;s=f;return h|0}if(!(t[l>>2]|0)){xe(t[(t[o>>2]|0)+20>>2]|0,121712,u|0)|0;
	t[a>>2]=0;h=t[a>>2]|0;s=f;return h|0}if(!(t[c>>2]|0)){xe(t[(t[o>>2]|0)+20>>2]|0,121712,u|0)|0;t[a>>2]=0;h=t[a>>2]|0;s=f;return h|0}n=t[l>>2]|0;r=t[c>>2]|0;t[k>>2]=cS(n,r,HY(t[c>>2]|0)|0,0,b)|0;if(!(t[k>>2]|0)){if(t[(t[l>>2]|0)+12>>2]|0){ty(t[(t[l>>2]|0)+12>>2]|0);t[(t[l>>2]|0)+12>>2]=0;t[(t[l>>2]|0)+16>>2]=0}Iy(t[l>>2]|0,t[b>>2]|0)|0}else xe(t[(t[o>>2]|0)+20>>2]|0,124376,u|0)|0;t[a>>2]=0;h=t[a>>2]|0;s=f;return h|0}function zr(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;t[l>>2]=e;t[b>>2]=i;t[a+28>>2]=r;t[a+24>>2]=f;t[k>>2]=Yl(t[b>>2]|0)|0;t[d>>2]=t[k>>2];while(1){if(!(t[d>>2]|0)){v=10;break}if(!(u[t[d>>2]>>0]|0)){v=10;break}t[h>>2]=t[d>>2];t[d>>2]=es(t[d>>2]|0,61)|0;if(!(t[d>>2]|0)){v=5;break}b=t[d>>2]|0;t[d>>2]=b+1;n[b>>0]=0;t[w>>2]=t[d>>2];t[d>>2]=es(t[d>>2]|0,32)|0;if(t[d>>2]|0){b=t[d>>2]|0;t[d>>2]=b+1;n[b>>0]=0}if(Kn(t[(t[l>>2]|0)+12>>2]|0,t[h>>2]|0,t[w>>2]|0)|0){v=9;break}}if((v|0)==5){xe(t[(t[l>>2]|0)+20>>2]|0,124040,o|0)|0;pAi[t[135736>>2]&511](t[k>>2]|0);t[c>>2]=-1;m=t[c>>2]|0;s=a;return m|0}else if((v|0)==9){d=t[(t[l>>2]|0)+20>>2]|0;l=t[w>>2]|0;t[o>>2]=t[h>>2];t[o+4>>2]=l;xe(d|0,124312,o|0)|0;pAi[t[135736>>2]&511](t[k>>2]|0);t[c>>2]=-1;m=t[c>>2]|0;s=a;return m|0}else if((v|0)==10){pAi[t[135736>>2]&511](t[k>>2]|0);t[c>>2]=0;m=t[c>>2]|0;s=a;return m|0}return 0}function jr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+8|0;c=f;t[a>>2]=e;t[f+12>>2]=i;t[o>>2]=r;t[f+4>>2]=n;if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?!((t[a>>2]|0)==0?1:(t[(t[o>>2]|0)+48>>2]|0)==0):0)?(t[(t[a>>2]|0)+12>>2]|0)!=0:0){t[c>>2]=t[(t[o>>2]|0)+48>>2];while(1){if(!(t[c>>2]|0))break;o=t[(t[a>>2]|0)+12>>2]|0;n=t[c>>2]|0;if(!(t[(t[c>>2]|0)+12>>2]|0))Kn(o,124296,t[n+8>>2]|0)|0;else Kn(o,t[n+12>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0;t[c>>2]=t[t[c>>2]>>2]}t[u>>2]=0;l=t[u>>2]|0;s=f;return l|0}t[u>>2]=-1;l=t[u>>2]|0;s=f;return l|0}function Vr(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0;f=s;s=s+16|0;u=f+8|0;a=f+4|0;t[f+12>>2]=e;t[u>>2]=i;t[a>>2]=r;t[f>>2]=n;aF(t[a>>2]|0,t[u>>2]|0);s=f;return 0}function qr(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;if(t[(t[n>>2]|0)+124>>2]|0){s=i;return}if(!(t[t[n>>2]>>2]|0)){s=i;return}if((t[(t[n>>2]|0)+108>>2]|0)<=0){s=i;return}e=t[t[n>>2]>>2]|0;f=t[n>>2]|0;if((t[(t[n>>2]|0)+108>>2]|0)<50){t[r>>2]=(t[n>>2]|0)+4+(100-(t[f+108>>2]<<1));xe(e|0,121856,r|0)|0;s=i;return}else{t[r>>2]=f+4;xe(e|0,121856,r|0)|0;s=i;return}}function Yr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r;f=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[a>>2]=i;if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}if(!(t[a>>2]|0)){xe(t[t[f>>2]>>2]|0,121688,n|0)|0;s=r;return}t[o>>2]=0;while(1){if((t[o>>2]|0)>=40)break;if(!(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0)){c=17;break}do if((u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)?(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)<=10:0){c=11;break}if((u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)!=13)if((u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0)>=128){i=t[t[f>>2]>>2]|0;t[n>>2]=u[(t[a>>2]|0)+(t[o>>2]|0)>>0];xe(i|0,121696,n|0)|0;break}else{oi(u[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0|0,t[t[f>>2]>>2]|0)|0;break}else c=11}else c=11;while(0);if((c|0)==11){c=0;oi(32,t[t[f>>2]>>2]|0)|0}t[o>>2]=(t[o>>2]|0)+1}if((c|0)==17){s=r;return}xe(t[t[f>>2]>>2]|0,121704,n|0)|0;s=r;return}function Gr(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n;u=n+12|0;a=n+8|0;o=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;r=(t[u>>2]|0)+128|0;t[r>>2]=(t[r>>2]|0)+1;r=t[(t[u>>2]|0)+116>>2]|0;u=t[a>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,0,r,24,u,2,0,0,0,0,0,0,0,121856,f);s=n;return}function Wr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[(t[f>>2]|0)+32>>2];if(!(t[(t[f>>2]|0)+20>>2]|0))Gr(t[n>>2]|0,5013,124640);if(t[(t[f>>2]|0)+32>>2]|0){t[a>>2]=t[(t[u>>2]|0)+80>>2];if((t[a>>2]|0)==0?(t[(t[n>>2]|0)+132>>2]|0)==0:0)t[(t[n>>2]|0)+132>>2]=1;if(!(t[(t[n>>2]|0)+112>>2]|0))t[(t[n>>2]|0)+112>>2]=t[u>>2];if(!(t[(t[n>>2]|0)+120>>2]|0))t[(t[n>>2]|0)+120>>2]=t[a>>2]}else{Gr(t[n>>2]|0,5014,124664);t[a>>2]=0}if(((t[(t[f>>2]|0)+20>>2]|0)!=0?(t[(t[f>>2]|0)+32>>2]|0)!=(t[(t[(t[f>>2]|0)+20>>2]|0)+32>>2]|0):0)?(Xl(t[(t[f>>2]|0)+8>>2]|0,124688)|0)==0:0)Gr(t[n>>2]|0,5017,124704);a=t[f>>2]|0;do if(!(t[(t[f>>2]|0)+28>>2]|0)){u=(t[(t[f>>2]|0)+20>>2]|0)!=0;if((t[a+4>>2]|0)==2){if(!u)break;if((t[f>>2]|0)==(t[(t[(t[f>>2]|0)+20>>2]|0)+44>>2]|0))break;Gr(t[n>>2]|0,5018,124744);break}else{if(!u)break;if((t[(t[(t[f>>2]|0)+20>>2]|0)+12>>2]|0)==(t[f>>2]|0))break;Gr(t[n>>2]|0,5018,124792);break}}else if((t[(t[a+28>>2]|0)+24>>2]|0)!=(t[f>>2]|0))Gr(t[n>>2]|0,5019,124840);while(0);a=t[f>>2]|0;if(!(t[(t[f>>2]|0)+24>>2]|0)){if((((t[a+20>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=2:0)?(t[(t[(t[f>>2]|0)+20>>2]|0)+16>>2]|0)!=(t[f>>2]|0):0)?(t[(t[(t[f>>2]|0)+20>>2]|0)+4>>2]|0)==1:0)Gr(t[n>>2]|0,5020,124880)}else{if((t[(t[a+24>>2]|0)+28>>2]|0)!=(t[f>>2]|0))Gr(t[n>>2]|0,5021,124928);if((t[(t[(t[f>>2]|0)+24>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+20>>2]|0))Gr(t[n>>2]|0,5029,124928)}a=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==1){t[o>>2]=t[a+48>>2];while(1){if(!(t[o>>2]|0))break;tn(t[n>>2]|0,t[f>>2]|0,t[o>>2]|0);t[o>>2]=t[t[o>>2]>>2]}if(t[(t[f>>2]|0)+36>>2]|0)tn(t[n>>2]|0,t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0)}else if((t[a+4>>2]|0)==2?(t[(t[f>>2]|0)+36>>2]|0)!=0:0)tn(t[n>>2]|0,t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0);if((((((((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=2:0)?(t[(t[f>>2]|0)+4>>2]|0)!=15:0)?(t[(t[f>>2]|0)+4>>2]|0)!=16:0)?(t[(t[f>>2]|0)+4>>2]|0)!=14:0)?(t[(t[f>>2]|0)+4>>2]|0)!=13:0)?(t[(t[f>>2]|0)+4>>2]|0)!=9:0)?(t[(t[f>>2]|0)+40>>2]|0)!=0:0)un(t[n>>2]|0,t[(t[f>>2]|0)+40>>2]|0);switch(t[(t[f>>2]|0)+4>>2]|0){case 2:case 1:{an(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);s=r;return}case 4:{if(!(t[(t[f>>2]|0)+8>>2]|0)){s=r;return}on(t[n>>2]|0,5037,125048,t[(t[f>>2]|0)+8>>2]|0);s=r;return}case 3:{if((t[(t[f>>2]|0)+8>>2]|0)==75104){s=r;return}if((t[(t[f>>2]|0)+8>>2]|0)==75112){s=r;return}if((t[(t[n>>2]|0)+120>>2]|0)!=0?(a=t[(t[f>>2]|0)+8>>2]|0,(a|0)==(kz(t[(t[n>>2]|0)+120>>2]|0,124968,7)|0)):0){s=r;return}on(t[n>>2]|0,5036,124976,t[(t[f>>2]|0)+8>>2]|0);s=r;return}case 7:{an(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);s=r;return}case 8:{if((t[(t[f>>2]|0)+8>>2]|0)==75128){s=r;return}on(t[n>>2]|0,5036,125008,t[(t[f>>2]|0)+8>>2]|0);s=r;return}default:{s=r;return}}}function Kr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;e:do if(!(t[u>>2]|0)){if(!(t[(t[f>>2]|0)+124>>2]|0))xe(t[t[f>>2]>>2]|0,125400,n|0)|0}else{t[(t[f>>2]|0)+116>>2]=t[u>>2];do switch(t[(t[u>>2]|0)+4>>2]|0){case 3:{Gr(t[f>>2]|0,5002,125744);break e;break}case 5:{Gr(t[f>>2]|0,5004,125792);break e;break}case 10:{Gr(t[f>>2]|0,5008,125928);break e;break}case 12:{Gr(t[f>>2]|0,5010,125984);break e;break}case 4:{Gr(t[f>>2]|0,5003,125768);break e;break}case 13:{if(t[(t[f>>2]|0)+124>>2]|0)break e;xe(t[t[f>>2]>>2]|0,125912,n|0)|0;break e;break}case 9:{if(t[(t[f>>2]|0)+124>>2]|0)break e;xe(t[t[f>>2]>>2]|0,125896,n|0)|0;break e;break}case 7:{Gr(t[f>>2]|0,5006,125848);break e;break}case 2:{Gr(t[f>>2]|0,5001,125712);break e;break}case 8:{Gr(t[f>>2]|0,5007,125872);break e;break}case 1:{Gr(t[f>>2]|0,5e3,125688);break e;break}case 11:{Gr(t[f>>2]|0,5009,125952);break e;break}case 6:{Gr(t[f>>2]|0,5005,125824);break e;break}default:{rn(t[f>>2]|0,5011,126016,t[(t[u>>2]|0)+4>>2]|0);break e}}while(0)}while(0);s=r;return}function Xr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;i=(t[(t[u>>2]|0)+124>>2]|0)!=0;if(!(t[f>>2]|0)){if(i){s=r;return}xe(t[t[u>>2]>>2]|0,127600,n|0)|0;s=r;return}if(i){s=r;return}i=t[t[u>>2]>>2]|0;t[n>>2]=t[(t[f>>2]|0)+8>>2];xe(i|0,124408,n|0)|0;switch(t[(t[f>>2]|0)+48>>2]|0){case 2:{xe(t[t[u>>2]>>2]|0,127640,n|0)|0;break}case 5:{xe(t[t[u>>2]>>2]|0,127712,n|0)|0;break}case 1:{xe(t[t[u>>2]>>2]|0,127616,n|0)|0;break}case 3:{xe(t[t[u>>2]>>2]|0,127664,n|0)|0;break}case 4:{xe(t[t[u>>2]>>2]|0,127688,n|0)|0;break}default:rn(t[u>>2]|0,5012,127736,t[(t[f>>2]|0)+48>>2]|0)}if(t[(t[f>>2]|0)+52>>2]|0){i=t[t[u>>2]>>2]|0;t[n>>2]=t[(t[f>>2]|0)+52>>2];xe(i|0,127760,n|0)|0}if(t[(t[f>>2]|0)+56>>2]|0){i=t[t[u>>2]>>2]|0;t[n>>2]=t[(t[f>>2]|0)+56>>2];xe(i|0,127768,n|0)|0}if(t[(t[f>>2]|0)+36>>2]|0){i=t[t[u>>2]>>2]|0;t[n>>2]=t[(t[f>>2]|0)+36>>2];xe(i|0,127784,n|0)|0}if((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+40>>2]|0)!=0:0){i=t[t[u>>2]>>2]|0;t[n>>2]=t[(t[f>>2]|0)+40>>2];xe(i|0,127800,n|0)|0}xe(t[t[u>>2]>>2]|0,121896,n|0)|0;s=r;return}function Zr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;qr(t[f>>2]|0);if(!(t[u>>2]|0)){if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}xe(t[t[f>>2]>>2]|0,124544,n|0)|0;s=r;return}i=t[f>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)!=14){Gr(i,5022,124568);s=r;return}if(!(t[i+124>>2]|0)){i=t[t[f>>2]>>2]|0;if(t[(t[u>>2]|0)+8>>2]|0){t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,124592,n|0)|0}else xe(i|0,124600,n|0)|0;if(t[(t[u>>2]|0)+52>>2]|0){i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+52>>2];xe(i|0,124608,n|0)|0}if(t[(t[u>>2]|0)+56>>2]|0){i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+56>>2];xe(i|0,124624,n|0)|0}xe(t[t[f>>2]>>2]|0,121896,n|0)|0}Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}function Jr(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0;r=s;s=s+5024|0;f=r;u=r+8|0;a=r+4|0;o=r+12|0;t[u>>2]=e;t[a>>2]=i;qr(t[u>>2]|0);if(!(t[a>>2]|0)){if(t[(t[u>>2]|0)+124>>2]|0){s=r;return}xe(t[t[u>>2]>>2]|0,127304,f|0)|0;s=r;return}if((t[(t[a>>2]|0)+4>>2]|0)!=15){Gr(t[u>>2]|0,5025,127336);s=r;return}i=t[u>>2]|0;if(t[(t[a>>2]|0)+8>>2]|0){if(!(t[i+124>>2]|0)){xe(t[t[u>>2]>>2]|0,127376,f|0)|0;Yr(t[u>>2]|0,t[(t[a>>2]|0)+8>>2]|0);xe(t[t[u>>2]>>2]|0,126712,f|0)|0}}else Gr(i,5015,127392);if(!(t[(t[u>>2]|0)+124>>2]|0)){switch(t[(t[a>>2]|0)+36>>2]|0){case 0:{xe(t[t[u>>2]>>2]|0,127424,f|0)|0;break}case 2:{xe(t[t[u>>2]>>2]|0,127448,f|0)|0;break}case 4:{xe(t[t[u>>2]>>2]|0,127456,f|0)|0;break}case 1:{xe(t[t[u>>2]>>2]|0,127440,f|0)|0;break}case 3:{xe(t[t[u>>2]>>2]|0,127456,f|0)|0;break}default:{}}if((t[(t[a>>2]|0)+4>>2]|0)!=1?(t[(t[a>>2]|0)+40>>2]|0)!=0:0){n[o>>0]=0;mM(o,5e3,t[(t[a>>2]|0)+40>>2]|0,1);n[o+5e3>>0]=0;i=t[t[u>>2]>>2]|0;t[f>>2]=o;xe(i|0,121856,f|0)|0}xe(t[t[u>>2]>>2]|0,121896,f|0)|0}Wr(t[u>>2]|0,t[a>>2]|0);s=r;return}function Qr(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[u>>2]=i;qr(t[f>>2]|0);if(!(t[u>>2]|0)){if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}xe(t[t[f>>2]>>2]|0,126928,n|0)|0;s=r;return}if((t[(t[u>>2]|0)+4>>2]|0)!=16){Gr(t[f>>2]|0,5024,126960);s=r;return}i=t[f>>2]|0;if(t[(t[u>>2]|0)+8>>2]|0){if(!(t[i+124>>2]|0)){e=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(e|0,127e3,n|0)|0}}else Gr(i,5015,127016);i=t[f>>2]|0;if(t[(t[u>>2]|0)+60>>2]|0){if(!(t[i+124>>2]|0)){e=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+60>>2];xe(e|0,127056,n|0)|0}}else Gr(i,5016,127064);if(!(t[(t[f>>2]|0)+124>>2]|0)){do switch(t[(t[u>>2]|0)+40>>2]|0){case 3:{xe(t[t[f>>2]>>2]|0,127128,n|0)|0;break}case 8:{xe(t[t[f>>2]>>2]|0,127184,n|0)|0;break}case 1:{xe(t[t[f>>2]>>2]|0,127112,n|0)|0;break}case 9:{xe(t[t[f>>2]>>2]|0,127200,n|0)|0;break}case 2:{xe(t[t[f>>2]>>2]|0,127120,n|0)|0;break}case 6:{xe(t[t[f>>2]>>2]|0,127152,n|0)|0;break}case 5:{xe(t[t[f>>2]>>2]|0,127144,n|0)|0;break}case 10:{xe(t[t[f>>2]>>2]|0,127216,n|0)|0;break}case 4:{xe(t[t[f>>2]>>2]|0,127136,n|0)|0;break}case 7:{xe(t[t[f>>2]>>2]|0,127168,n|0)|0;break}default:{}}while(0);do if(t[(t[u>>2]|0)+52>>2]|0){t[o>>2]=t[(t[u>>2]|0)+52>>2];t[a>>2]=0;while(1){if((t[a>>2]|0)>=5)break;i=t[t[f>>2]>>2]|0;e=t[(t[o>>2]|0)+4>>2]|0;if(t[a>>2]|0){t[n>>2]=e;xe(i|0,127232,n|0)|0}else{t[n>>2]=e;xe(i|0,127240,n|0)|0}t[o>>2]=t[t[o>>2]>>2];if(!(t[o>>2]|0))break;t[a>>2]=(t[a>>2]|0)+1}i=t[t[f>>2]>>2]|0;if(!(t[o>>2]|0)){xe(i|0,126712,n|0)|0;break}else{xe(i|0,127248,n|0)|0;break}}while(0);o=t[(t[u>>2]|0)+44>>2]|0;if((o|0)==4)xe(t[t[f>>2]>>2]|0,127288,n|0)|0;else if((o|0)==2)xe(t[t[f>>2]>>2]|0,127256,n|0)|0;else if((o|0)==3)xe(t[t[f>>2]>>2]|0,127272,n|0)|0;if(t[(t[u>>2]|0)+48>>2]|0){xe(t[t[f>>2]>>2]|0,127296,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+48>>2]|0);xe(t[t[f>>2]>>2]|0,127296,n|0)|0}xe(t[t[f>>2]>>2]|0,121896,n|0)|0}Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}function $r(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;qr(t[f>>2]|0);if(!(t[u>>2]|0)){if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}xe(t[t[f>>2]>>2]|0,126624,n|0)|0;s=r;return}if((t[(t[u>>2]|0)+4>>2]|0)!=17){Gr(t[f>>2]|0,5026,126656);s=r;return}i=t[f>>2]|0;if(t[(t[u>>2]|0)+8>>2]|0){if(!(t[i+124>>2]|0)){xe(t[t[f>>2]>>2]|0,126696,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0);xe(t[t[f>>2]>>2]|0,126712,n|0)|0}}else Gr(i,5015,126720);if(!(t[(t[f>>2]|0)+124>>2]|0)){switch(t[(t[u>>2]|0)+48>>2]|0){case 5:{xe(t[t[f>>2]>>2]|0,126824,n|0)|0;break}case 2:{xe(t[t[f>>2]>>2]|0,126768,n|0)|0;break}case 4:{xe(t[t[f>>2]>>2]|0,126808,n|0)|0;break}case 6:{xe(t[t[f>>2]>>2]|0,126848,n|0)|0;break}case 1:{xe(t[t[f>>2]>>2]|0,126752,n|0)|0;break}case 3:{xe(t[t[f>>2]>>2]|0,126792,n|0)|0;break}default:{}}if(t[(t[u>>2]|0)+52>>2]|0){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+52>>2];xe(i|0,126864,n|0)|0}if(t[(t[u>>2]|0)+56>>2]|0){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+56>>2];xe(i|0,126880,n|0)|0}if(t[(t[u>>2]|0)+64>>2]|0){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+64>>2];xe(i|0,126896,n|0)|0}if(t[(t[u>>2]|0)+40>>2]|0){qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126912,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0}}Wr(t[f>>2]|0,t[u>>2]|0);s=r;return}function en(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;qr(t[f>>2]|0);if(!(t[u>>2]|0)){if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}xe(t[t[f>>2]>>2]|0,125496,n|0)|0;s=r;return}if((t[(t[u>>2]|0)+4>>2]|0)!=18){Gr(t[f>>2]|0,5027,125520);s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){i=t[f>>2]|0;if(t[(t[u>>2]|0)+12>>2]|0){on(i,5028,125560,t[(t[u>>2]|0)+12>>2]|0);s=r;return}else{Gr(i,5028,125600);s=r;return}}if(t[(t[f>>2]|0)+124>>2]|0){s=r;return}i=t[t[f>>2]>>2]|0;if(t[(t[u>>2]|0)+12>>2]|0){t[n>>2]=t[(t[u>>2]|0)+12>>2];xe(i|0,125640,n|0)|0}else xe(i|0,125664,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0;s=r;return}function rn(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;n=(t[a>>2]|0)+128|0;t[n>>2]=(t[n>>2]|0)+1;n=t[(t[a>>2]|0)+116>>2]|0;a=t[o>>2]|0;o=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,0,n,24,a,2,0,0,0,0,0,0,0,o,u);s=f;return}function nn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;en(t[n>>2]|0,t[f>>2]|0);t[f>>2]=t[t[f>>2]>>2]}s=r;return}function fn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;qr(t[f>>2]|0);i=(t[(t[f>>2]|0)+124>>2]|0)!=0;if(!(t[u>>2]|0)){if(i){s=r;return}xe(t[t[f>>2]>>2]|0,126384,n|0)|0;s=r;return}if(i){s=r;return}switch(t[(t[u>>2]|0)+48>>2]|0){case 5:{xe(t[t[f>>2]>>2]|0,126536,n|0)|0;break}case 2:{xe(t[t[f>>2]>>2]|0,126432,n|0)|0;break}case 3:{xe(t[t[f>>2]>>2]|0,126464,n|0)|0;break}case 4:{xe(t[t[f>>2]>>2]|0,126504,n|0)|0;break}case 1:{xe(t[t[f>>2]>>2]|0,126400,n|0)|0;break}default:{i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+48>>2];xe(i|0,126568,n|0)|0}}i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+8>>2];xe(i|0,122096,n|0)|0;if(t[(t[u>>2]|0)+52>>2]|0){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+52>>2];xe(i|0,126584,n|0)|0}if(t[(t[u>>2]|0)+56>>2]|0){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+56>>2];xe(i|0,126600,n|0)|0}if(t[(t[u>>2]|0)+64>>2]|0){qr(t[f>>2]|0);i=t[t[f>>2]>>2]|0;t[n>>2]=t[(t[u>>2]|0)+64>>2];xe(i|0,126616,n|0)|0}if(!(t[(t[u>>2]|0)+40>>2]|0)){s=r;return}qr(t[f>>2]|0);xe(t[t[f>>2]>>2]|0,126368,n|0)|0;Yr(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);xe(t[t[f>>2]>>2]|0,121896,n|0)|0;s=r;return}function tn(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=cn(t[u>>2]|0,t[a>>2]|0)|0;do if((t[o>>2]|0)==-2){u=t[f>>2]|0;if(!(t[(t[a>>2]|0)+12>>2]|0)){Gr(u,5030,125208);break}else{on(u,5030,125256,t[(t[a>>2]|0)+12>>2]|0);break}}while(0);if((t[o>>2]|0)!=-3){s=n;return}o=t[f>>2]|0;if(!(t[(t[a>>2]|0)+12>>2]|0)){Gr(o,5031,125304);s=n;return}else{on(o,5031,125352,t[(t[a>>2]|0)+12>>2]|0);s=n;return}}function un(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}if(!(t[(t[n>>2]|0)+124>>2]|0)){s=r;return}if(ls(t[f>>2]|0)|0){s=r;return}on(t[n>>2]|0,5032,125184,t[f>>2]|0);s=r;return}function an(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[(t[n>>2]|0)+124>>2]|0)){s=r;return}if(!(t[f>>2]|0)){Gr(t[n>>2]|0,5015,125088);s=r;return}if(Yg(t[f>>2]|0,0)|0)on(t[n>>2]|0,5034,125104,t[f>>2]|0);if(!(t[(t[n>>2]|0)+120>>2]|0)){s=r;return}if(wz(t[(t[n>>2]|0)+120>>2]|0,t[f>>2]|0)|0){s=r;return}if((t[(t[n>>2]|0)+112>>2]|0)!=0?(t[(t[(t[n>>2]|0)+112>>2]|0)+88>>2]&4608|0)!=0:0){s=r;return}on(t[n>>2]|0,5035,125136,t[f>>2]|0);s=r;return}function on(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;n=(t[a>>2]|0)+128|0;t[n>>2]=(t[n>>2]|0)+1;n=t[(t[a>>2]|0)+116>>2]|0;a=t[o>>2]|0;o=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,0,n,24,a,2,0,0,0,0,0,0,0,o,u);s=f;return}function cn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}if((((((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=2:0)?(t[(t[f>>2]|0)+4>>2]|0)!=9:0)?(t[(t[f>>2]|0)+4>>2]|0)!=3:0)?(t[(t[f>>2]|0)+4>>2]|0)!=13:0)?(t[(t[f>>2]|0)+4>>2]|0)!=19:0){t[n>>2]=-2;c=t[n>>2]|0;s=r;return c|0}e:while(1){if(t[f>>2]|0)if(((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=2:0)?(t[(t[f>>2]|0)+4>>2]|0)!=3:0)l=(t[(t[f>>2]|0)+4>>2]|0)==19;else l=1;else l=0;b=t[f>>2]|0;if(!l){k=26;break}if(!((t[b+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=19:0))k=18;i:do if((k|0)==18){k=0;t[a>>2]=t[(t[f>>2]|0)+48>>2];while(1){if(!(t[a>>2]|0))break i;if((t[a>>2]|0)==(t[u>>2]|0)){k=21;break e}if(Xl(t[(t[a>>2]|0)+12>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0){k=23;break e}t[a>>2]=t[t[a>>2]>>2]}}while(0);t[f>>2]=t[(t[f>>2]|0)+20>>2]}if((k|0)==21){t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}else if((k|0)==23){t[n>>2]=-2;c=t[n>>2]|0;s=r;return c|0}else if((k|0)==26){do if(b){if((t[(t[f>>2]|0)+4>>2]|0)!=9?(t[(t[f>>2]|0)+4>>2]|0)!=13:0)break;t[o>>2]=t[(t[f>>2]|0)+52>>2];if((t[o>>2]|0)==(t[u>>2]|0)){t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}}while(0);t[n>>2]=-3;c=t[n>>2]|0;s=r;return c|0}return 0}function ln(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+28|0;f=r+8|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r;l=f;t[l>>2]=e;t[l+4>>2]=i;i=f;l=Be(t[i>>2]|0,t[i+4>>2]|0,0)|0;t[u>>2]=64-l;t[a>>2]=((t[u>>2]|0)>6?t[u>>2]|0:6)-6;u=f;l=qY(t[u>>2]|0,t[u+4>>2]|0,t[a>>2]|0)|0;t[o>>2]=l;l=UY(1,0,t[a>>2]|0)|0;a=BY(l|0,P|0,1,0)|0;l=c;t[l>>2]=a;t[l+4>>2]=P;l=c;c=f;f=t[o>>2]|0;if((t[l>>2]&t[c>>2]|0)!=0?1:(t[l+4>>2]&t[c+4>>2]|0)!=0){t[n>>2]=f+1;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=f;b=t[n>>2]|0;s=r;return b|0}return 0}function sn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;St(t[n>>2]|0,1,t[f>>2]|0);s=r;return}function bn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+2112|0;n=r+2096|0;f=r+2092|0;u=r+2088|0;a=r+2076|0;o=r+24|0;c=r+2072|0;l=r+16|0;b=r+8|0;k=r;t[n>>2]=e;t[f>>2]=i;t[c>>2]=0;i=k;t[i>>2]=0;t[i+4>>2]=0;if((t[f>>2]|0)>>>0<64){sn(t[n>>2]|0,t[f>>2]|0);s=r;return}t[u>>2]=ln(t[f>>2]|0,0)|0;t[a>>2]=r+2080;t[t[a>>2]>>2]=0;t[(t[a>>2]|0)+4>>2]=0;i=k;e=gt(t[n>>2]|0,t[i>>2]|0,t[i+4>>2]|0,t[f>>2]|0)|0;i=l;t[i>>2]=e;t[i+4>>2]=P;i=t[u>>2]|0;e=b;t[e>>2]=i;t[e+4>>2]=((i|0)<0)<<31>>31;i=b;e=t[i+4>>2]|0;h=t[u>>2]|0;w=((h|0)<0)<<31>>31;if((e|0)<(w|0)|((e|0)==(w|0)?(t[i>>2]|0)>>>0<h>>>0:0)){h=t[u>>2]|0;i=b;t[i>>2]=h;t[i+4>>2]=((h|0)<0)<<31>>31}h=b;i=t[h>>2]|0;w=t[h+4>>2]|0;h=k;e=BY(t[f>>2]|0,0,t[h>>2]|0,t[h+4>>2]|0)|0;h=P;if((w|0)>(h|0)|(w|0)==(h|0)&i>>>0>e>>>0){e=k;i=BY(t[f>>2]|0,0,t[e>>2]|0,t[e+4>>2]|0)|0;e=b;t[e>>2]=i;t[e+4>>2]=P}e=b;i=t[e+4>>2]|0;h=l;w=t[h+4>>2]|0;if((i|0)>(w|0)|((i|0)==(w|0)?(t[e>>2]|0)>>>0>(t[h>>2]|0)>>>0:0)){St((t[n>>2]|0)+(t[k>>2]<<2)|0,t[l>>2]|0,t[b>>2]|0);h=b;e=t[h+4>>2]|0;w=l;t[w>>2]=t[h>>2];t[w+4>>2]=e}e=k;w=t[e+4>>2]|0;h=o+(t[c>>2]<<4)|0;t[h>>2]=t[e>>2];t[h+4>>2]=w;w=l;h=t[w+4>>2]|0;e=o+(t[c>>2]<<4)+8|0;t[e>>2]=t[w>>2];t[e+4>>2]=h;t[c>>2]=(t[c>>2]|0)+1;h=l;e=k;w=jY(t[e>>2]|0,t[e+4>>2]|0,t[h>>2]|0,t[h+4>>2]|0)|0;h=k;t[h>>2]=w;t[h+4>>2]=P;h=k;if((t[h+4>>2]|0)==0?(t[h>>2]|0)==(t[f>>2]|0):0){while(1){if((t[c>>2]|0)<=1)break;yt(t[n>>2]|0,o,t[c>>2]|0,t[a>>2]|0);h=o+((t[c>>2]|0)-1<<4)+8|0;w=o+((t[c>>2]|0)-2<<4)+8|0;e=w;i=jY(t[e>>2]|0,t[e+4>>2]|0,t[h>>2]|0,t[h+4>>2]|0)|0;h=w;t[h>>2]=i;t[h+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1}if(!(t[(t[a>>2]|0)+4>>2]|0)){s=r;return}Zq(t[(t[a>>2]|0)+4>>2]|0);t[(t[a>>2]|0)+4>>2]=0;s=r;return}h=k;i=gt(t[n>>2]|0,t[h>>2]|0,t[h+4>>2]|0,t[f>>2]|0)|0;h=l;t[h>>2]=i;t[h+4>>2]=P;h=t[u>>2]|0;i=b;t[i>>2]=h;t[i+4>>2]=((h|0)<0)<<31>>31;h=b;i=t[h+4>>2]|0;w=t[u>>2]|0;e=((w|0)<0)<<31>>31;if((i|0)<(e|0)|((i|0)==(e|0)?(t[h>>2]|0)>>>0<w>>>0:0)){w=t[u>>2]|0;h=b;t[h>>2]=w;t[h+4>>2]=((w|0)<0)<<31>>31}w=b;h=t[w>>2]|0;e=t[w+4>>2]|0;w=k;i=BY(t[f>>2]|0,0,t[w>>2]|0,t[w+4>>2]|0)|0;w=P;if((e|0)>(w|0)|(e|0)==(w|0)&h>>>0>i>>>0){i=k;h=BY(t[f>>2]|0,0,t[i>>2]|0,t[i+4>>2]|0)|0;i=b;t[i>>2]=h;t[i+4>>2]=P}i=b;h=t[i+4>>2]|0;w=l;e=t[w+4>>2]|0;if((h|0)>(e|0)|((h|0)==(e|0)?(t[i>>2]|0)>>>0>(t[w>>2]|0)>>>0:0)){St((t[n>>2]|0)+(t[k>>2]<<2)|0,t[l>>2]|0,t[b>>2]|0);w=b;i=t[w+4>>2]|0;e=l;t[e>>2]=t[w>>2];t[e+4>>2]=i}i=k;e=t[i+4>>2]|0;w=o+(t[c>>2]<<4)|0;t[w>>2]=t[i>>2];t[w+4>>2]=e;e=l;w=t[e+4>>2]|0;i=o+(t[c>>2]<<4)+8|0;t[i>>2]=t[e>>2];t[i+4>>2]=w;t[c>>2]=(t[c>>2]|0)+1;w=l;i=k;e=jY(t[i>>2]|0,t[i+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=k;t[w>>2]=e;t[w+4>>2]=P;w=k;if((t[w+4>>2]|0)==0?(t[w>>2]|0)==(t[f>>2]|0):0){while(1){if((t[c>>2]|0)<=1)break;yt(t[n>>2]|0,o,t[c>>2]|0,t[a>>2]|0);w=o+((t[c>>2]|0)-1<<4)+8|0;e=o+((t[c>>2]|0)-2<<4)+8|0;i=e;h=jY(t[i>>2]|0,t[i+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=e;t[w>>2]=h;t[w+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1}if(!(t[(t[a>>2]|0)+4>>2]|0)){s=r;return}Zq(t[(t[a>>2]|0)+4>>2]|0);t[(t[a>>2]|0)+4>>2]=0;s=r;return}w=k;h=gt(t[n>>2]|0,t[w>>2]|0,t[w+4>>2]|0,t[f>>2]|0)|0;w=l;t[w>>2]=h;t[w+4>>2]=P;w=t[u>>2]|0;h=b;t[h>>2]=w;t[h+4>>2]=((w|0)<0)<<31>>31;w=b;h=t[w+4>>2]|0;e=t[u>>2]|0;i=((e|0)<0)<<31>>31;if((h|0)<(i|0)|((h|0)==(i|0)?(t[w>>2]|0)>>>0<e>>>0:0)){e=t[u>>2]|0;w=b;t[w>>2]=e;t[w+4>>2]=((e|0)<0)<<31>>31}e=b;w=t[e>>2]|0;i=t[e+4>>2]|0;e=k;h=BY(t[f>>2]|0,0,t[e>>2]|0,t[e+4>>2]|0)|0;e=P;if((i|0)>(e|0)|(i|0)==(e|0)&w>>>0>h>>>0){h=k;w=BY(t[f>>2]|0,0,t[h>>2]|0,t[h+4>>2]|0)|0;h=b;t[h>>2]=w;t[h+4>>2]=P}h=b;w=t[h+4>>2]|0;e=l;i=t[e+4>>2]|0;if((w|0)>(i|0)|((w|0)==(i|0)?(t[h>>2]|0)>>>0>(t[e>>2]|0)>>>0:0)){St((t[n>>2]|0)+(t[k>>2]<<2)|0,t[l>>2]|0,t[b>>2]|0);e=b;h=t[e+4>>2]|0;i=l;t[i>>2]=t[e>>2];t[i+4>>2]=h}h=k;i=t[h+4>>2]|0;e=o+(t[c>>2]<<4)|0;t[e>>2]=t[h>>2];t[e+4>>2]=i;i=l;e=t[i+4>>2]|0;h=o+(t[c>>2]<<4)+8|0;t[h>>2]=t[i>>2];t[h+4>>2]=e;t[c>>2]=(t[c>>2]|0)+1;e=l;h=k;i=jY(t[h>>2]|0,t[h+4>>2]|0,t[e>>2]|0,t[e+4>>2]|0)|0;e=k;t[e>>2]=i;t[e+4>>2]=P;e=k;if((t[e+4>>2]|0)==0?(t[e>>2]|0)==(t[f>>2]|0):0){while(1){if((t[c>>2]|0)<=1)break;yt(t[n>>2]|0,o,t[c>>2]|0,t[a>>2]|0);e=o+((t[c>>2]|0)-1<<4)+8|0;i=o+((t[c>>2]|0)-2<<4)+8|0;h=i;w=jY(t[h>>2]|0,t[h+4>>2]|0,t[e>>2]|0,t[e+4>>2]|0)|0;e=i;t[e>>2]=w;t[e+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1}if(!(t[(t[a>>2]|0)+4>>2]|0)){s=r;return}Zq(t[(t[a>>2]|0)+4>>2]|0);t[(t[a>>2]|0)+4>>2]=0;s=r;return}while(1){e=(Ft(o,t[c>>2]|0)|0)!=0;w=t[n>>2]|0;if(!e){t[c>>2]=Ot(w,o,t[c>>2]|0,t[a>>2]|0,t[f>>2]|0)|0;continue}e=k;i=gt(w,t[e>>2]|0,t[e+4>>2]|0,t[f>>2]|0)|0;e=l;t[e>>2]=i;t[e+4>>2]=P;e=t[u>>2]|0;i=b;t[i>>2]=e;t[i+4>>2]=((e|0)<0)<<31>>31;e=b;i=t[e+4>>2]|0;w=t[u>>2]|0;h=((w|0)<0)<<31>>31;if((i|0)<(h|0)|((i|0)==(h|0)?(t[e>>2]|0)>>>0<w>>>0:0)){w=t[u>>2]|0;e=b;t[e>>2]=w;t[e+4>>2]=((w|0)<0)<<31>>31}w=b;e=t[w>>2]|0;h=t[w+4>>2]|0;w=k;i=BY(t[f>>2]|0,0,t[w>>2]|0,t[w+4>>2]|0)|0;w=P;if((h|0)>(w|0)|(h|0)==(w|0)&e>>>0>i>>>0){i=k;e=BY(t[f>>2]|0,0,t[i>>2]|0,t[i+4>>2]|0)|0;i=b;t[i>>2]=e;t[i+4>>2]=P}i=b;e=t[i+4>>2]|0;w=l;h=t[w+4>>2]|0;if((e|0)>(h|0)|((e|0)==(h|0)?(t[i>>2]|0)>>>0>(t[w>>2]|0)>>>0:0)){St((t[n>>2]|0)+(t[k>>2]<<2)|0,t[l>>2]|0,t[b>>2]|0);w=b;i=t[w+4>>2]|0;h=l;t[h>>2]=t[w>>2];t[h+4>>2]=i}i=k;h=t[i+4>>2]|0;w=o+(t[c>>2]<<4)|0;t[w>>2]=t[i>>2];t[w+4>>2]=h;h=l;w=t[h+4>>2]|0;i=o+(t[c>>2]<<4)+8|0;t[i>>2]=t[h>>2];t[i+4>>2]=w;t[c>>2]=(t[c>>2]|0)+1;w=l;i=k;h=jY(t[i>>2]|0,t[i+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=k;t[w>>2]=h;t[w+4>>2]=P;w=k;if((t[w+4>>2]|0)==0?(t[w>>2]|0)==(t[f>>2]|0):0)break}while(1){if((t[c>>2]|0)<=1)break;yt(t[n>>2]|0,o,t[c>>2]|0,t[a>>2]|0);f=o+((t[c>>2]|0)-1<<4)+8|0;k=o+((t[c>>2]|0)-2<<4)+8|0;l=k;b=jY(t[l>>2]|0,t[l+4>>2]|0,t[f>>2]|0,t[f+4>>2]|0)|0;f=k;t[f>>2]=b;t[f+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1}if(!(t[(t[a>>2]|0)+4>>2]|0)){s=r;return}Zq(t[(t[a>>2]|0)+4>>2]|0);t[(t[a>>2]|0)+4>>2]=0;s=r;return}function kn(){var e=0;e=s;if(t[31974]|0){s=e;return}l[15985]=+At();l[15986]=+Mt();l[15984]=+Rt();l[15988]=+Nt();t[31974]=1;s=e;return}function hn(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;l[r>>3]=e;n=Tt(+l[r>>3])|0;s=i;return n|0}function wn(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;l[r>>3]=e;n=Lt(+l[r>>3])|0;s=i;return n|0}function dn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;t[u>>2]=(t[u>>2]|0)<0|(t[u>>2]|0)>25?25:i;i=t[u>>2]|0;if(!(t[f>>2]|0)){t[n>>2]=t[127920+(t[u>>2]<<2)>>2];cp(0,0,0,0,0,12,i+1200-0|0,2,0,0,0,0,0,0,0,127912,n);s=r;return}t[(t[f>>2]|0)+8>>2]=i;if(!(t[(t[f>>2]|0)+12>>2]|0)){i=(t[u>>2]|0)+1200-0|0;e=t[(t[f>>2]|0)+4>>2]|0;a=(t[t[f>>2]>>2]|0)-(t[(t[f>>2]|0)+4>>2]|0)|0;t[n>>2]=t[127920+(t[u>>2]<<2)>>2];cp(0,0,0,0,0,12,i,2,0,0,e,0,0,a,0,127912,n);s=r;return}lp((t[(t[f>>2]|0)+12>>2]|0)+136|0);t[(t[(t[f>>2]|0)+12>>2]|0)+136>>2]=12;t[(t[(t[f>>2]|0)+12>>2]|0)+140>>2]=(t[u>>2]|0)+1200-0;t[(t[(t[f>>2]|0)+12>>2]|0)+148>>2]=2;a=Yl(t[(t[f>>2]|0)+4>>2]|0)|0;t[(t[(t[f>>2]|0)+12>>2]|0)+160>>2]=a;t[(t[(t[f>>2]|0)+12>>2]|0)+172>>2]=(t[t[f>>2]>>2]|0)-(t[(t[f>>2]|0)+4>>2]|0);t[(t[(t[f>>2]|0)+12>>2]|0)+184>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+188>>2];a=t[(t[f>>2]|0)+12>>2]|0;if(t[(t[(t[f>>2]|0)+12>>2]|0)+132>>2]|0){EAi[t[a+132>>2]&511](t[(t[(t[f>>2]|0)+12>>2]|0)+128>>2]|0,(t[(t[f>>2]|0)+12>>2]|0)+136|0);s=r;return}else{e=t[a+188>>2]|0;a=(t[u>>2]|0)+1200-0|0;i=t[(t[f>>2]|0)+4>>2]|0;o=(t[t[f>>2]>>2]|0)-(t[(t[f>>2]|0)+4>>2]|0)|0;t[n>>2]=t[127920+(t[u>>2]<<2)>>2];cp(0,0,0,0,e,12,a,2,0,0,i,0,0,o,0,127912,n);s=r;return}}function vn(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0;f=s;s=s+16|0;u=f+12|0;a=f;t[u>>2]=e;t[f+8>>2]=i;t[f+4>>2]=r;t[a>>2]=n;dn(t[u>>2]|0,t[a>>2]|0);s=f;return}function mn(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}e=(t[(t[r>>2]|0)+20>>2]|0)==0;t[f>>2]=0;e:do if(e)while(1){if((t[f>>2]|0)>=(t[t[r>>2]>>2]|0))break e;t[n>>2]=(t[(t[r>>2]|0)+8>>2]|0)+((t[f>>2]|0)*40|0);do if(t[(t[n>>2]|0)+24>>2]|0)if((t[t[n>>2]>>2]|0)==12){_n(t[(t[n>>2]|0)+24>>2]|0);break}else{pAi[t[135736>>2]&511](t[(t[n>>2]|0)+24>>2]|0);break}while(0);if(t[(t[n>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+28>>2]|0);t[f>>2]=(t[f>>2]|0)+1}else{while(1){if((t[f>>2]|0)>=(t[t[r>>2]>>2]|0))break;t[n>>2]=(t[(t[r>>2]|0)+8>>2]|0)+((t[f>>2]|0)*40|0);if((t[(t[n>>2]|0)+24>>2]|0)!=0?(t[t[n>>2]>>2]|0)==12:0)_n(t[(t[n>>2]|0)+24>>2]|0);t[f>>2]=(t[f>>2]|0)+1}bz(t[(t[r>>2]|0)+20>>2]|0)}while(0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)mj(t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function _n(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}do if((t[t[r>>2]>>2]|0)!=1?(t[t[r>>2]>>2]|0)!=9:0){e=t[r>>2]|0;if((t[t[r>>2]>>2]|0)==7){if(!(t[e+28>>2]|0))break;Ba(t[(t[r>>2]|0)+28>>2]|0);break}if((t[e>>2]|0)==4?(t[(t[r>>2]|0)+24>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0)}else n=4;while(0);do if((n|0)==4){e=t[r>>2]|0;if(t[(t[r>>2]|0)+8>>2]|0){t[e>>2]=9;if(!(t[(t[r>>2]|0)+4>>2]|0))break;Dt(t[(t[r>>2]|0)+4>>2]|0);break}else{if(!(t[e+4>>2]|0))break;Bn(t[(t[r>>2]|0)+4>>2]|0);break}}while(0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function pn(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,b=0,h=0,w=0;f=s;s=s+128|0;u=f;a=f+20|0;o=f+16|0;c=f+12|0;b=f+8|0;h=f+24|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if(!(t[a>>2]|0)){s=f;return}t[b>>2]=0;while(1){w=h+((t[b>>2]<<1)+1)|0;if(!((t[b>>2]|0)<25?(t[b>>2]|0)<(t[c>>2]|0):0))break;n[w>>0]=32;n[h+(t[b>>2]<<1)>>0]=32;t[b>>2]=(t[b>>2]|0)+1}n[w>>0]=0;n[h+(t[b>>2]<<1)>>0]=0;b=t[a>>2]|0;t[u>>2]=h;xe(b|0,127912,u|0)|0;if(!(t[o>>2]|0)){xe(t[a>>2]|0,128024,u|0)|0;s=f;return}do switch(t[t[o>>2]>>2]|0){case 5:{b=t[a>>2]|0;t[u>>2]=t[(t[o>>2]|0)+32>>2];xe(b|0,128360,u|0)|0;It(t[a>>2]|0,t[(t[o>>2]|0)+28>>2]|0,(t[c>>2]|0)+1|0);xe(t[a>>2]|0,128352,u|0)|0;s=f;return}case 6:{do if(t[(t[o>>2]|0)+36>>2]|0){if((t[(t[o>>2]|0)+36>>2]|0)==(t[(t[o>>2]|0)+28>>2]|0)?(t[(t[o>>2]|0)+32>>2]|0)==(t[(t[o>>2]|0)+40>>2]|0):0)break;xe(t[a>>2]|0,128456,u|0)|0;b=t[a>>2]|0;t[u>>2]=h;xe(b|0,127912,u|0)|0;xe(t[a>>2]|0,128480,u|0)|0;if((t[(t[o>>2]|0)+32>>2]|0)>=0){b=t[a>>2]|0;t[u>>2]=t[(t[o>>2]|0)+32>>2];xe(b|0,128432,u|0)|0}xe(t[a>>2]|0,128448,u|0)|0;It(t[a>>2]|0,t[(t[o>>2]|0)+28>>2]|0,(t[c>>2]|0)+1|0);b=t[a>>2]|0;t[u>>2]=h;xe(b|0,127912,u|0)|0;xe(t[a>>2]|0,128488,u|0)|0;if((t[(t[o>>2]|0)+40>>2]|0)>=0){b=t[a>>2]|0;t[u>>2]=t[(t[o>>2]|0)+40>>2];xe(b|0,128432,u|0)|0}xe(t[a>>2]|0,128448,u|0)|0;It(t[a>>2]|0,t[(t[o>>2]|0)+36>>2]|0,(t[c>>2]|0)+1|0);xe(t[a>>2]|0,128352,u|0)|0;s=f;return}while(0);xe(t[a>>2]|0,128400,u|0)|0;b=t[a>>2]|0;t[u>>2]=h;xe(b|0,127912,u|0)|0;if((t[(t[o>>2]|0)+32>>2]|0)>=0){b=t[a>>2]|0;t[u>>2]=t[(t[o>>2]|0)+32>>2];xe(b|0,128432,u|0)|0}xe(t[a>>2]|0,128448,u|0)|0;It(t[a>>2]|0,t[(t[o>>2]|0)+28>>2]|0,(t[c>>2]|0)+1|0);s=f;return}case 9:{xe(t[a>>2]|0,128104,u|0)|0;Pt(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,t[c>>2]|0);s=f;return}case 0:{xe(t[a>>2]|0,128048,u|0)|0;s=f;return}case 4:{xe(t[a>>2]|0,128328,u|0)|0;cr(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0);xe(t[a>>2]|0,128352,u|0)|0;s=f;return}case 3:{b=wn(+l[(t[o>>2]|0)+16>>3])|0;if((b|0)==-1){xe(t[a>>2]|0,128208,u|0)|0;s=f;return}else if((b|0)==1){xe(t[a>>2]|0,128176,u|0)|0;s=f;return}else{if(hn(+l[(t[o>>2]|0)+16>>3])|0){xe(t[a>>2]|0,128240,u|0)|0;s=f;return}if(+l[(t[o>>2]|0)+16>>3]==0?(Bt(+l[(t[o>>2]|0)+16>>3])|0)!=0:0){xe(t[a>>2]|0,128272,u|0)|0;s=f;return}b=t[a>>2]|0;l[k>>3]=+l[(t[o>>2]|0)+16>>3];t[u>>2]=t[k>>2];t[u+4>>2]=t[k+4>>2];xe(b|0,128296,u|0)|0;s=f;return}break}case 7:{xe(t[a>>2]|0,128496,u|0)|0;Ht(t[a>>2]|0,t[(t[o>>2]|0)+28>>2]|0,t[c>>2]|0);s=f;return}case 8:{xe(t[a>>2]|0,128528,u|0)|0;s=f;return}case 1:{xe(t[a>>2]|0,128080,u|0)|0;Ct(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,t[c>>2]|0);s=f;return}case 2:{xe(t[a>>2]|0,128136,u|0)|0;b=t[a>>2]|0;if(t[(t[o>>2]|0)+8>>2]|0){xe(b|0,128160,u|0)|0;s=f;return}else{xe(b|0,128168,u|0)|0;s=f;return}break}default:{s=f;return}}while(0)}function En(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+20>>2]|0)>0:0){e=t[n>>2]|0;if((t[(t[n>>2]|0)+20>>2]|0)<=(t[(t[n>>2]|0)+44>>2]|0)){vn(e,128552,2830,23);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}a=e+20|0;t[a>>2]=(t[a>>2]|0)+-1;a=t[n>>2]|0;if((t[(t[n>>2]|0)+20>>2]|0)>0)t[(t[n>>2]|0)+16>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[a+20>>2]|0)-1<<2)>>2];else t[a+16>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+(t[(t[n>>2]|0)+20>>2]<<2)>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+(t[(t[n>>2]|0)+20>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Sn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}do if((t[(t[f>>2]|0)+20>>2]|0)>=(t[(t[f>>2]|0)+24>>2]|0)){
	if((t[(t[f>>2]|0)+24>>2]|0)>=1e6){Ut(0,128576);t[(t[f>>2]|0)+8>>2]=15;t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+28>>2]|0,t[(t[f>>2]|0)+24>>2]<<1<<2)|0;if(t[a>>2]|0){i=(t[f>>2]|0)+24|0;t[i>>2]=t[i>>2]<<1;t[(t[f>>2]|0)+28>>2]=t[a>>2];break}Ut(0,128616);t[(t[f>>2]|0)+8>>2]=15;t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}while(0);t[(t[(t[f>>2]|0)+28>>2]|0)+(t[(t[f>>2]|0)+20>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+16>>2]=t[u>>2];u=(t[f>>2]|0)+20|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;o=t[n>>2]|0;s=r;return o|0}function gn(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=En(t[n>>2]|0)|0;if(!(t[f>>2]|0)){vn(t[n>>2]|0,128552,2896,10);if(t[n>>2]|0)t[(t[n>>2]|0)+8>>2]=10;t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}e=t[f>>2]|0;if((t[t[f>>2]>>2]|0)!=2)t[u>>2]=yn(e)|0;else t[u>>2]=t[e+8>>2];zt(t[(t[n>>2]|0)+12>>2]|0,t[f>>2]|0);t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}function yn(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i;n=i+16|0;f=i+12|0;u=i+8|0;t[f>>2]=e;t[u>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=i;return a|0}switch(t[t[f>>2]>>2]|0){case 2:{t[u>>2]=t[(t[f>>2]|0)+8>>2];break}case 4:{t[u>>2]=kf(t[(t[f>>2]|0)+24>>2]|0)|0;break}case 3:{t[u>>2]=bf(+l[(t[f>>2]|0)+16>>3])|0;break}case 7:case 6:case 5:case 8:{e=t[33976]|0;o=t[33980]|0;t[r>>2]=128552;t[r+4>>2]=6066;yAi[e&511](o,129064,r);t[u>>2]=0;break}case 9:case 1:{t[u>>2]=hf(t[(t[f>>2]|0)+4>>2]|0)|0;break}case 0:{t[u>>2]=0;break}default:{}}t[n>>2]=t[u>>2];a=t[n>>2]|0;s=i;return a|0}function Fn(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+16|0;n=i+8|0;f=i+24|0;u=i;t[f>>2]=e;l[u>>3]=0;if(!(t[f>>2]|0)){l[n>>3]=+l[15984];a=+l[n>>3];s=i;return+a}switch(t[t[f>>2]>>2]|0){case 0:{l[u>>3]=+l[15984];break}case 2:{l[u>>3]=+af(t[(t[f>>2]|0)+8>>2]|0);break}case 4:{l[u>>3]=+of(t[(t[f>>2]|0)+24>>2]|0);break}case 3:{l[u>>3]=+l[(t[f>>2]|0)+16>>3];break}case 7:case 6:case 5:case 8:{e=t[33976]|0;o=t[33980]|0;t[r>>2]=128552;t[r+4>>2]=5954;yAi[e&511](o,129064,r);l[u>>3]=+l[15984];break}case 9:case 1:{l[u>>3]=+sf(t[(t[f>>2]|0)+4>>2]|0);break}default:{}}l[n>>3]=+l[u>>3];a=+l[n>>3];s=i;return+a}function On(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}t[u>>2]=t[(t[n>>2]|0)+12>>2];e:while(1){if(!(t[u>>2]|0))break;if((t[(t[u>>2]|0)+4>>2]|0)==1?(e=(t[f>>2]|0)+1|0,t[f>>2]=e,t[(t[u>>2]|0)+40>>2]=0-e,(t[(t[u>>2]|0)+12>>2]|0)!=0):0){t[u>>2]=t[(t[u>>2]|0)+12>>2];continue}if(t[(t[u>>2]|0)+24>>2]|0){t[u>>2]=t[(t[u>>2]|0)+24>>2];continue}while(1){t[u>>2]=t[(t[u>>2]|0)+20>>2];if(!(t[u>>2]|0))continue e;if((t[u>>2]|0)==(t[n>>2]|0)){o=12;break}c=t[u>>2]|0;if(t[(t[u>>2]|0)+24>>2]|0){o=14;break}if(!c)continue e}if((o|0)==12){o=0;t[u>>2]=0;continue}else if((o|0)==14){o=0;t[u>>2]=t[c+24>>2];continue}}t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function An(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;r=s;s=s+64|0;n=r+56|0;f=r+52|0;u=r+48|0;a=r+44|0;o=r+40|0;c=r+36|0;l=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+12|0;v=r+8|0;m=r+4|0;_=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-2;p=t[n>>2]|0;s=r;return p|0}if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}if((t[(t[f>>2]|0)+4>>2]|0)==2){t[c>>2]=1;t[b>>2]=t[f>>2];t[f>>2]=t[(t[f>>2]|0)+20>>2]}if((t[(t[u>>2]|0)+4>>2]|0)==2){t[l>>2]=1;t[k>>2]=t[u>>2];t[u>>2]=t[(t[u>>2]|0)+20>>2]}if((t[f>>2]|0)==(t[u>>2]|0)){if((t[c>>2]|0)!=(t[l>>2]|0))if((t[l>>2]|0)==1){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}else{t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}if(!(t[c>>2]|0)){t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}t[h>>2]=t[(t[k>>2]|0)+28>>2];while(1){if(!(t[h>>2]|0)){E=17;break}if((t[h>>2]|0)==(t[b>>2]|0)){E=15;break}t[h>>2]=t[(t[h>>2]|0)+28>>2]}if((E|0)==15){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}else if((E|0)==17){t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}}if((t[(t[f>>2]|0)+4>>2]|0)!=18?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){if((t[f>>2]|0)==(t[(t[u>>2]|0)+28>>2]|0)){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}if((t[f>>2]|0)==(t[(t[u>>2]|0)+24>>2]|0)){t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}if(((((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?0>(t[(t[f>>2]|0)+40>>2]|0):0)?0>(t[(t[u>>2]|0)+40>>2]|0):0)?(t[(t[f>>2]|0)+32>>2]|0)==(t[(t[u>>2]|0)+32>>2]|0):0){t[d>>2]=0-(t[(t[f>>2]|0)+40>>2]|0);t[v>>2]=0-(t[(t[u>>2]|0)+40>>2]|0);if((t[d>>2]|0)<(t[v>>2]|0)){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}if((t[d>>2]|0)>(t[v>>2]|0)){t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}}t[o>>2]=0;t[h>>2]=t[u>>2];while(1){S=t[h>>2]|0;if(!(t[(t[h>>2]|0)+20>>2]|0))break;if((S|0)==(t[f>>2]|0)){E=41;break}t[o>>2]=(t[o>>2]|0)+1;t[h>>2]=t[(t[h>>2]|0)+20>>2]}if((E|0)==41){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}t[w>>2]=S;t[a>>2]=0;t[h>>2]=t[f>>2];while(1){if(!(t[(t[h>>2]|0)+20>>2]|0))break;if((t[h>>2]|0)==(t[u>>2]|0)){E=46;break}t[a>>2]=(t[a>>2]|0)+1;t[h>>2]=t[(t[h>>2]|0)+20>>2]}if((E|0)==46){t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}if((t[w>>2]|0)!=(t[h>>2]|0)){t[n>>2]=-2;p=t[n>>2]|0;s=r;return p|0}while(1){if((t[a>>2]|0)<=(t[o>>2]|0))break;t[a>>2]=(t[a>>2]|0)+-1;t[f>>2]=t[(t[f>>2]|0)+20>>2]}while(1){if((t[o>>2]|0)<=(t[a>>2]|0))break;t[o>>2]=(t[o>>2]|0)+-1;t[u>>2]=t[(t[u>>2]|0)+20>>2]}while(1){g=t[f>>2]|0;if((t[(t[f>>2]|0)+20>>2]|0)==(t[(t[u>>2]|0)+20>>2]|0))break;t[f>>2]=t[g+20>>2];t[u>>2]=t[(t[u>>2]|0)+20>>2];if((t[f>>2]|0)==0|(t[u>>2]|0)==0){E=56;break}}if((E|0)==56){t[n>>2]=-2;p=t[n>>2]|0;s=r;return p|0}if((g|0)==(t[(t[u>>2]|0)+28>>2]|0)){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}if((t[f>>2]|0)==(t[(t[u>>2]|0)+24>>2]|0)){t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}do if(((((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?0>(t[(t[f>>2]|0)+40>>2]|0):0)?0>(t[(t[u>>2]|0)+40>>2]|0):0)?(t[(t[f>>2]|0)+32>>2]|0)==(t[(t[u>>2]|0)+32>>2]|0):0){t[m>>2]=0-(t[(t[f>>2]|0)+40>>2]|0);t[_>>2]=0-(t[(t[u>>2]|0)+40>>2]|0);if((t[m>>2]|0)<(t[_>>2]|0)){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}if((t[m>>2]|0)<=(t[_>>2]|0))break;t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}while(0);t[h>>2]=t[(t[f>>2]|0)+24>>2];while(1){if(!(t[h>>2]|0)){E=75;break}if((t[h>>2]|0)==(t[u>>2]|0)){E=73;break}t[h>>2]=t[(t[h>>2]|0)+24>>2]}if((E|0)==73){t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}else if((E|0)==75){t[n>>2]=-1;p=t[n>>2]|0;s=r;return p|0}}t[n>>2]=1;p=t[n>>2]|0;s=r;return p|0}function Mn(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}bn(t[(t[r>>2]|0)+8>>2]|0,t[t[r>>2]>>2]|0);s=i;return}function Rn(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+4>>2]|0)!=18){s=i;return}if(!(t[t[r>>2]>>2]|0)){s=i;return}if((t[(t[t[r>>2]>>2]|0)+4>>2]|0)==18){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Nn(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[f>>2]|0)){Ut(0,128632);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;do if(t[n>>2]|0){e=gAi[t[135744>>2]&511](40)|0;t[(t[f>>2]|0)+8>>2]=e;if(!(t[(t[f>>2]|0)+8>>2]|0)){Ut(0,128632);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}e=(t[(t[f>>2]|0)+8>>2]|0)+0|0;o=e+40|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(o|0));t[(t[f>>2]|0)+4>>2]=10;e=t[n>>2]|0;if((t[(t[n>>2]|0)+4>>2]|0)==18){t[u>>2]=e;o=jt(t[t[u>>2]>>2]|0,t[u>>2]|0)|0;c=t[f>>2]|0;l=t[c>>2]|0;t[c>>2]=l+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(l<<2)>>2]=o;break}else{o=t[f>>2]|0;l=t[o>>2]|0;t[o>>2]=l+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(l<<2)>>2]=e;break}}while(0);t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function Tn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}i=(t[(t[u>>2]|0)+4>>2]|0)==18;t[a>>2]=0;e:do if(i){while(1){if((t[a>>2]|0)>=(t[t[f>>2]>>2]|0))break e;if((t[(t[(t[(t[f>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0)+4>>2]|0)==18){t[o>>2]=t[u>>2];t[c>>2]=t[(t[(t[f>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2];if((t[o>>2]|0)==(t[c>>2]|0)){b=7;break}if(((t[t[o>>2]>>2]|0)!=0?(t[t[c>>2]>>2]|0)==(t[t[o>>2]>>2]|0):0)?(Xl(t[(t[o>>2]|0)+12>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0)!=0:0){b=11;break}}t[a>>2]=(t[a>>2]|0)+1}if((b|0)==7){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((b|0)==11){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}}else{while(1){if((t[a>>2]|0)>=(t[t[f>>2]>>2]|0))break e;if((t[(t[(t[f>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0)==(t[u>>2]|0))break;t[a>>2]=(t[a>>2]|0)+1}t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}while(0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function Ln(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((!((t[u>>2]|0)==0|(t[o>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[o>>2]|0)+4>>2]|0)==18:0)?(t[(t[a>>2]|0)+4>>2]|0)==1:0){t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[t[u>>2]>>2]|0))break;if((((t[(t[(t[u>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)!=0?(t[(t[(t[(t[u>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0)==18:0)?(t[t[(t[(t[u>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]>>2]|0)==(t[a>>2]|0):0)?(Xl(t[(t[o>>2]|0)+12>>2]|0,t[(t[(t[(t[u>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0)|0)!=0:0){b=11;break}t[c>>2]=(t[c>>2]|0)+1}if((b|0)==11){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}do if(t[(t[u>>2]|0)+4>>2]|0){if((t[t[u>>2]>>2]|0)==(t[(t[u>>2]|0)+4>>2]|0)){if((t[(t[u>>2]|0)+4>>2]|0)>=1e7){Ut(0,128680);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}t[l>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+4>>2]<<1<<2)|0;if(t[l>>2]|0){b=(t[u>>2]|0)+4|0;t[b>>2]=t[b>>2]<<1;t[(t[u>>2]|0)+8>>2]=t[l>>2];break}Ut(0,128656);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}}else{b=gAi[t[135744>>2]&511](40)|0;t[(t[u>>2]|0)+8>>2]=b;if(t[(t[u>>2]|0)+8>>2]|0){b=(t[(t[u>>2]|0)+8>>2]|0)+0|0;c=b+40|0;do{t[b>>2]=0;b=b+4|0}while((b|0)<(c|0));t[(t[u>>2]|0)+4>>2]=10;break}Ut(0,128656);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}while(0);l=jt(t[a>>2]|0,t[o>>2]|0)|0;o=t[u>>2]|0;a=t[o>>2]|0;t[o>>2]=a+1;t[(t[(t[u>>2]|0)+8>>2]|0)+(a<<2)>>2]=l;t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}function Dn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[t[f>>2]>>2]|0))break;if((t[(t[(t[f>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0)==(t[u>>2]|0)){b=6;break}t[a>>2]=(t[a>>2]|0)+1}if((b|0)==6){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}do if(t[(t[f>>2]|0)+4>>2]|0){if((t[t[f>>2]>>2]|0)==(t[(t[f>>2]|0)+4>>2]|0)){if((t[(t[f>>2]|0)+4>>2]|0)>=1e7){Ut(0,128680);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+4>>2]<<1<<2)|0;if(t[o>>2]|0){b=(t[f>>2]|0)+4|0;t[b>>2]=t[b>>2]<<1;t[(t[f>>2]|0)+8>>2]=t[o>>2];break}Ut(0,128656);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}}else{b=gAi[t[135744>>2]&511](40)|0;t[(t[f>>2]|0)+8>>2]=b;if(t[(t[f>>2]|0)+8>>2]|0){b=(t[(t[f>>2]|0)+8>>2]|0)+0|0;a=b+40|0;do{t[b>>2]=0;b=b+4|0}while((b|0)<(a|0));t[(t[f>>2]|0)+4>>2]=10;break}Ut(0,128656);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}while(0);o=t[u>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)==18){t[c>>2]=o;u=jt(t[t[c>>2]>>2]|0,t[c>>2]|0)|0;c=t[f>>2]|0;b=t[c>>2]|0;t[c>>2]=b+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(b<<2)>>2]=u}else{u=t[f>>2]|0;b=t[u>>2]|0;t[u>>2]=b+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(b<<2)>>2]=o}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function Cn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}do if(t[(t[f>>2]|0)+4>>2]|0){if((t[t[f>>2]>>2]|0)==(t[(t[f>>2]|0)+4>>2]|0)){if((t[(t[f>>2]|0)+4>>2]|0)>=1e7){Ut(0,128680);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+4>>2]<<1<<2)|0;if(t[a>>2]|0){t[(t[f>>2]|0)+8>>2]=t[a>>2];i=(t[f>>2]|0)+4|0;t[i>>2]=t[i>>2]<<1;break}Ut(0,128656);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}}else{i=gAi[t[135744>>2]&511](40)|0;t[(t[f>>2]|0)+8>>2]=i;if(t[(t[f>>2]|0)+8>>2]|0){i=(t[(t[f>>2]|0)+8>>2]|0)+0|0;e=i+40|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[f>>2]|0)+4>>2]=10;break}Ut(0,128656);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}while(0);a=t[u>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)==18){t[o>>2]=a;u=jt(t[t[o>>2]>>2]|0,t[o>>2]|0)|0;o=t[f>>2]|0;i=t[o>>2]|0;t[o>>2]=i+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(i<<2)>>2]=u}else{u=t[f>>2]|0;i=t[u>>2]|0;t[u>>2]=i+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(i<<2)>>2]=a}t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}function Pn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+48|0;n=r+40|0;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;if(!(t[u>>2]|0)){t[n>>2]=i;d=t[n>>2]|0;s=r;return d|0}if((i|0)==0?(t[f>>2]=Nn(0)|0,(t[f>>2]|0)==0):0){t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}t[c>>2]=t[t[f>>2]>>2];t[a>>2]=0;e:while(1){if((t[a>>2]|0)>=(t[t[u>>2]>>2]|0)){v=33;break}t[k>>2]=t[(t[(t[u>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2];t[l>>2]=0;t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[c>>2]|0))break;t[b>>2]=t[(t[(t[f>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2];if((t[b>>2]|0)==(t[k>>2]|0)){v=11;break}if((((t[(t[b>>2]|0)+4>>2]|0)==18?(t[(t[k>>2]|0)+4>>2]|0)==18:0)?(t[t[b>>2]>>2]|0)==(t[t[k>>2]>>2]|0):0)?(Xl(t[(t[b>>2]|0)+12>>2]|0,t[(t[k>>2]|0)+12>>2]|0)|0)!=0:0){v=16;break}t[o>>2]=(t[o>>2]|0)+1}if((v|0)==11){v=0;t[l>>2]=1}else if((v|0)==16){v=0;t[l>>2]=1}do if(!(t[l>>2]|0)){if(t[(t[f>>2]|0)+4>>2]|0){if((t[t[f>>2]>>2]|0)==(t[(t[f>>2]|0)+4>>2]|0)){if((t[(t[f>>2]|0)+4>>2]|0)>=1e7){v=25;break e}t[h>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+4>>2]<<1<<2)|0;if(!(t[h>>2]|0)){v=27;break e}t[(t[f>>2]|0)+8>>2]=t[h>>2];i=(t[f>>2]|0)+4|0;t[i>>2]=t[i>>2]<<1}}else{i=gAi[t[135744>>2]&511](40)|0;t[(t[f>>2]|0)+8>>2]=i;if(!(t[(t[f>>2]|0)+8>>2]|0)){v=21;break e}i=(t[(t[f>>2]|0)+8>>2]|0)+0|0;e=i+40|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[f>>2]|0)+4>>2]=10}i=t[k>>2]|0;if((t[(t[k>>2]|0)+4>>2]|0)==18){t[w>>2]=i;e=jt(t[t[w>>2]>>2]|0,t[w>>2]|0)|0;m=t[f>>2]|0;_=t[m>>2]|0;t[m>>2]=_+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(_<<2)>>2]=e;break}else{e=t[f>>2]|0;_=t[e>>2]|0;t[e>>2]=_+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(_<<2)>>2]=i;break}}while(0);t[a>>2]=(t[a>>2]|0)+1}if((v|0)==21){Ut(0,128712);t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}else if((v|0)==25){Ut(0,128736);t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}else if((v|0)==27){Ut(0,128712);t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}else if((v|0)==33){t[n>>2]=t[f>>2];d=t[n>>2]|0;s=r;return d|0}return 0}function Bn(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[t[r>>2]>>2]|0))break;if((t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0)!=0?(t[(t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0)+4>>2]|0)==18:0)Rn(t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function In(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128632);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=1;t[(t[f>>2]|0)+8>>2]=0;e=Nn(t[n>>2]|0)|0;t[(t[f>>2]|0)+4>>2]=e;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Hn(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128768);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=1;t[(t[f>>2]|0)+4>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function xn(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;e=sF(t[r>>2]|0)|0;t[n>>2]=e;if(!e)t[n>>2]=Yl(128928)|0;s=i;return t[n>>2]|0}function Un(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=zn(t[f>>2]|0,t[u>>2]|0,0,t[a>>2]|0)|0;s=n;return r|0}function zn(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;do if(t[a>>2]|0){if(!(t[o>>2]|0)){t[u>>2]=-1;break}if(!(t[(t[a>>2]|0)+40>>2]|0)){n=WF(0)|0;t[(t[a>>2]|0)+40>>2]=n}if(!(t[(t[a>>2]|0)+40>>2]|0)){t[u>>2]=-1;break}n=t[(t[a>>2]|0)+40>>2]|0;r=t[o>>2]|0;i=t[c>>2]|0;if(!(t[l>>2]|0)){t[u>>2]=wO(n,r,i,0)|0;break}else{t[u>>2]=QF(n,r,i,t[l>>2]|0)|0;break}}else t[u>>2]=-1;while(0);s=f;return t[u>>2]|0}function jn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if((t[(t[f>>2]|0)+112>>2]|0)!=0?(t[o>>2]=t[(t[f>>2]|0)+112>>2],t[c>>2]=dAi[t[o>>2]&511](t[(t[f>>2]|0)+116>>2]|0,t[u>>2]|0,0)|0,t[a>>2]=t[c>>2],(t[a>>2]|0)!=0):0){t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}t[n>>2]=Vn(t[f>>2]|0,t[u>>2]|0,0)|0;l=t[n>>2]|0;s=r;return l|0}function Vn(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}if(!(t[a>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}if((t[(t[u>>2]|0)+112>>2]|0)!=0?(t[l>>2]=t[(t[u>>2]|0)+112>>2],t[b>>2]=dAi[t[l>>2]&511](t[(t[u>>2]|0)+116>>2]|0,t[a>>2]|0,t[o>>2]|0)|0,t[c>>2]=t[b>>2],(t[c>>2]|0)!=0):0){t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}if(!(t[(t[u>>2]|0)+40>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else{t[c>>2]=fO(t[(t[u>>2]|0)+40>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}return 0}function qn(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}XF(t[(t[r>>2]|0)+40>>2]|0,0);t[(t[r>>2]|0)+40>>2]=0;s=i;return}function Yn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=t[f>>2]|0;if(t[(t[f>>2]|0)+92>>2]|0){t[a>>2]=dAi[t[i+92>>2]&511](t[(t[f>>2]|0)+96>>2]|0,t[u>>2]|0,0)|0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=Gn(i,t[u>>2]|0,0)|0;o=t[n>>2]|0;s=r;return o|0}return 0}function Gn(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+92>>2]|0)!=0?(t[c>>2]=dAi[t[(t[u>>2]|0)+92>>2]&511](t[(t[u>>2]|0)+96>>2]|0,t[a>>2]|0,t[o>>2]|0)|0,(t[c>>2]|0)!=0):0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}if(!(t[(t[u>>2]|0)+16>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{c=t[u>>2]|0;t[f>>2]=Vt(c,fO(t[(t[u>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function Wn(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}XF(t[(t[r>>2]|0)+16>>2]|0,260);t[(t[r>>2]|0)+16>>2]=0;s=i;return}function Kn(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;a=n+8|0;o=n+4|0;c=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;do if(t[a>>2]|0){if(!(t[o>>2]|0)){t[f>>2]=-1;break}if(!(u[t[o>>2]>>0]|0)){t[f>>2]=-1;break}if(!(t[(t[a>>2]|0)+88>>2]|0)){r=WF(10)|0;t[(t[a>>2]|0)+88>>2]=r}if(!(t[(t[a>>2]|0)+88>>2]|0)){t[f>>2]=-1;break}r=t[(t[a>>2]|0)+88>>2]|0;i=t[o>>2]|0;if(!(t[c>>2]|0)){t[f>>2]=kO(r,i,t[33934]|0)|0;break}else{e=Yl(t[c>>2]|0)|0;t[f>>2]=$F(r,i,e,t[33934]|0)|0;break}}else t[f>>2]=-1;while(0);s=n;return t[f>>2]|0}function Xn(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(!(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(Xl(t[u>>2]|0,128800)|0){t[n>>2]=128808;o=t[n>>2]|0;s=r;return o|0}e:do if(t[(t[f>>2]|0)+56>>2]|0){t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[f>>2]|0)+60>>2]|0))break e;if((t[(t[(t[f>>2]|0)+56>>2]|0)+(t[a>>2]<<2)>>2]|0)!=0?(Xl(t[(t[(t[(t[f>>2]|0)+56>>2]|0)+(t[a>>2]<<2)>>2]|0)+12>>2]|0,t[u>>2]|0)|0)!=0:0)break;t[a>>2]=(t[a>>2]|0)+1}t[n>>2]=t[(t[(t[(t[f>>2]|0)+56>>2]|0)+(t[a>>2]<<2)>>2]|0)+8>>2];o=t[n>>2]|0;s=r;return o|0}while(0);t[n>>2]=rO(t[(t[f>>2]|0)+88>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}function Zn(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}XF(t[(t[r>>2]|0)+88>>2]|0,t[33934]|0);t[(t[r>>2]|0)+88>>2]=0;s=i;return}function Jn(e){e=+e;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i;f=i+8|0;l[n>>3]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128848);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{a=(t[f>>2]|0)+0|0;o=a+48|0;do{t[a>>2]=0;a=a+4|0}while((a|0)<(o|0));t[t[f>>2]>>2]=3;l[(t[f>>2]|0)+16>>3]=+l[n>>3];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Qn(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128872);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=2;t[(t[f>>2]|0)+8>>2]=(t[n>>2]|0)!=0&1;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function $n(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128904);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=4;if(t[n>>2]|0){e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+24>>2]=e}else{e=Yl(128928)|0;t[(t[f>>2]|0)+24>>2]=e}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function ef(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128904);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=4;t[(t[f>>2]|0)+24>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function rf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){Ut(0,128904);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=4;e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+24>>2]=e;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function nf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+32|0;r=i;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;t[f>>2]=e;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=i;return o|0}t[u>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[u>>2]|0)){Ut(0,128936);t[n>>2]=0;o=t[n>>2]|0;s=i;return o|0}e=(t[u>>2]|0)+0|0;c=(t[f>>2]|0)+0|0;l=e+48|0;do{t[e>>2]=t[c>>2];e=e+4|0;c=c+4|0}while((e|0)<(l|0));switch(t[t[f>>2]>>2]|0){case 9:case 1:{c=Pn(0,t[(t[f>>2]|0)+4>>2]|0)|0;t[(t[u>>2]|0)+4>>2]=c;t[(t[u>>2]|0)+8>>2]=0;break}case 0:{c=t[33976]|0;e=t[33980]|0;t[r>>2]=t[t[f>>2]>>2];yAi[c&511](e,128952,r);break}case 7:{t[a>>2]=t[(t[f>>2]|0)+28>>2];r=Pa(0,t[a>>2]|0)|0;t[(t[u>>2]|0)+28>>2]=r;break}case 8:{t[(t[u>>2]|0)+28>>2]=t[(t[f>>2]|0)+28>>2];break}case 4:{r=Yl(t[(t[f>>2]|0)+24>>2]|0)|0;t[(t[u>>2]|0)+24>>2]=r;break}default:{}}t[n>>2]=t[u>>2];o=t[n>>2]|0;s=i;return o|0}function ff(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(t[r>>2]|0)t[n>>2]=Yl(129e3)|0;else t[n>>2]=Yl(129008)|0;s=i;return t[n>>2]|0}function tf(e){e=+e;var i=0,r=0,f=0,u=0,a=0;i=s;s=s+112|0;r=i;f=i+8|0;u=i+12|0;l[r>>3]=e;a=wn(+l[r>>3])|0;do if((a|0)==1)t[f>>2]=Yl(129016)|0;else if((a|0)==-1)t[f>>2]=Yl(129032)|0;else{if(hn(+l[r>>3])|0){t[f>>2]=Yl(129048)|0;break}if(+l[r>>3]==0?(Bt(+l[r>>3])|0)!=0:0){t[f>>2]=Yl(129056)|0;break}qt(+l[r>>3],u,99);n[u+99>>0]=0;t[f>>2]=Yl(u)|0}while(0);s=i;return t[f>>2]|0}function uf(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(((t[n>>2]|0)!=0?(t[t[n>>2]>>2]|0)!=0:0)?(t[(t[n>>2]|0)+8>>2]|0)!=0:0){if((t[t[n>>2]>>2]|0)>1)Mn(t[n>>2]|0);t[r>>2]=xn(t[t[(t[n>>2]|0)+8>>2]>>2]|0)|0;f=t[r>>2]|0;s=i;return f|0}t[r>>2]=Yl(128928)|0;f=t[r>>2]|0;s=i;return f|0}function af(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+8|0;t[n>>2]=e;if(t[n>>2]|0)l[r>>3]=1;else l[r>>3]=0;s=i;return+ +l[r>>3]}function of(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;n=+cf(t[r>>2]|0);s=i;return+n}function cf(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;i=s;s=s+80|0;r=i+24|0;n=i+64|0;f=i+60|0;a=i+16|0;o=i+56|0;c=i+52|0;b=i+48|0;k=i+44|0;h=i+40|0;w=i+8|0;d=i+36|0;v=i+32|0;m=i;t[n>>2]=e;t[f>>2]=t[n>>2];t[o>>2]=0;t[c>>2]=0;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;if(!(t[f>>2]|0)){l[r>>3]=0;_=+l[r>>3];s=i;return+_}while(1){do if((u[t[f>>2]>>0]|0|0)==32)p=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){p=1;break}p=(u[t[f>>2]>>0]|0|0)==13}while(0);E=t[f>>2]|0;if(!p)break;t[f>>2]=E+1}do if((u[E>>0]|0|0)!=46){if((u[t[f>>2]>>0]|0|0)>=48?(u[t[f>>2]>>0]|0|0)<=57:0)break;if((u[t[f>>2]>>0]|0|0)!=45){l[r>>3]=+l[15984];_=+l[r>>3];s=i;return+_}}while(0);if((u[t[f>>2]>>0]|0|0)==45){t[c>>2]=1;t[f>>2]=(t[f>>2]|0)+1}l[a>>3]=0;while(1){if((u[t[f>>2]>>0]|0|0)<48)break;if((u[t[f>>2]>>0]|0|0)>57)break;l[a>>3]=+l[a>>3]*10;t[h>>2]=(u[t[f>>2]>>0]|0)-48;t[o>>2]=1;t[f>>2]=(t[f>>2]|0)+1;l[w>>3]=+((t[h>>2]|0)>>>0);l[a>>3]=+l[a>>3]+ +l[w>>3]}e:do if((u[t[f>>2]>>0]|0|0)==46){t[v>>2]=0;l[m>>3]=0;t[f>>2]=(t[f>>2]|0)+1;if((u[t[f>>2]>>0]|0|0)<48){if(!(t[o>>2]|0))S=24}else if(!((t[o>>2]|0)!=0?1:(u[t[f>>2]>>0]|0|0)<=57))S=24;if((S|0)==24){l[r>>3]=+l[15984];_=+l[r>>3];s=i;return+_}while(1){if((u[t[f>>2]>>0]|0|0)<48)break;if(!((t[v>>2]|0)<20?(u[t[f>>2]>>0]|0|0)<=57:0))break;t[d>>2]=(u[t[f>>2]>>0]|0)-48;l[m>>3]=+l[m>>3]*10+ +(t[d>>2]|0);t[v>>2]=(t[v>>2]|0)+1;t[f>>2]=(t[f>>2]|0)+1}l[m>>3]=+l[m>>3]/+l[129232+(t[v>>2]<<3)>>3];l[a>>3]=+l[a>>3]+ +l[m>>3];while(1){if((u[t[f>>2]>>0]|0|0)<48)break e;if((u[t[f>>2]>>0]|0|0)>57)break e;t[f>>2]=(t[f>>2]|0)+1}}while(0);if(!((u[t[f>>2]>>0]|0|0)!=101?(u[t[f>>2]>>0]|0|0)!=69:0))S=34;e:do if((S|0)==34){t[f>>2]=(t[f>>2]|0)+1;if((u[t[f>>2]>>0]|0|0)!=45){if((u[t[f>>2]>>0]|0|0)==43)t[f>>2]=(t[f>>2]|0)+1}else{t[k>>2]=1;t[f>>2]=(t[f>>2]|0)+1}while(1){if((u[t[f>>2]>>0]|0|0)<48)break e;if((u[t[f>>2]>>0]|0|0)>57)break e;t[b>>2]=((t[b>>2]|0)*10|0)+((u[t[f>>2]>>0]|0)-48);t[f>>2]=(t[f>>2]|0)+1}}while(0);while(1){do if((u[t[f>>2]>>0]|0|0)==32)g=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){g=1;break}g=(u[t[f>>2]>>0]|0|0)==13}while(0);y=t[f>>2]|0;if(!g)break;t[f>>2]=y+1}if(u[y>>0]|0){l[r>>3]=+l[15984];_=+l[r>>3];s=i;return+_}if(t[c>>2]|0)l[a>>3]=-+l[a>>3];if(t[k>>2]|0)t[b>>2]=0-(t[b>>2]|0);F=+K(10,+ +(t[b>>2]|0));l[a>>3]=+l[a>>3]*F;l[r>>3]=+l[a>>3];_=+l[r>>3];s=i;return+_}function lf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i+8|0;n=i+20|0;f=i+16|0;u=i;t[n>>2]=e;if(!(t[n>>2]|0)){l[r>>3]=+l[15984];a=+l[r>>3];s=i;return+a}t[f>>2]=xn(t[n>>2]|0)|0;if(!(t[f>>2]|0)){l[r>>3]=+l[15984];a=+l[r>>3];s=i;return+a}else{l[u>>3]=+of(t[f>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);l[r>>3]=+l[u>>3];a=+l[r>>3];s=i;return+a}return+0}function sf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i+8|0;n=i+20|0;f=i+16|0;u=i;t[n>>2]=e;if(!(t[n>>2]|0)){l[r>>3]=+l[15984];a=+l[r>>3];s=i;return+a}else{t[f>>2]=uf(t[n>>2]|0)|0;l[u>>3]=+of(t[f>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);l[r>>3]=+l[u>>3];a=+l[r>>3];s=i;return+a}return+0}function bf(e){e=+e;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i;l[n>>3]=e;f=(hn(+l[n>>3])|0)!=0;if(f|+l[n>>3]==0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[r>>2]=1;u=t[r>>2]|0;s=i;return u|0}return 0}function kf(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(rs(t[n>>2]|0)|0)!=0:0)t[r>>2]=1;else t[r>>2]=0;s=i;return t[r>>2]|0}function hf(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[t[n>>2]>>2]|0)!=0:0)t[r>>2]=1;else t[r>>2]=0;s=i;return t[r>>2]|0}function wf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](204)|0;if(!(t[f>>2]|0)){Ut(0,129096);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{VY(t[f>>2]|0,0,204)|0;t[t[f>>2]>>2]=t[n>>2];t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+16>>2]=0;t[(t[f>>2]|0)+20>>2]=0;t[(t[f>>2]|0)+24>>2]=0;t[(t[f>>2]|0)+28>>2]=0;n=WF(0)|0;t[(t[f>>2]|0)+40>>2]=n;t[(t[f>>2]|0)+44>>2]=0;t[(t[f>>2]|0)+48>>2]=0;t[(t[f>>2]|0)+52>>2]=0;t[(t[f>>2]|0)+88>>2]=0;t[(t[f>>2]|0)+64>>2]=0;t[(t[f>>2]|0)+68>>2]=-1;t[(t[f>>2]|0)+72>>2]=-1;df(t[f>>2]|0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function df(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;Un(t[r>>2]|0,129592,261)|0;Un(t[r>>2]|0,129600,262)|0;Un(t[r>>2]|0,129608,263)|0;Un(t[r>>2]|0,129616,264)|0;Un(t[r>>2]|0,129624,265)|0;Un(t[r>>2]|0,129640,266)|0;Un(t[r>>2]|0,129008,267)|0;Un(t[r>>2]|0,129648,268)|0;Un(t[r>>2]|0,129656,269)|0;Un(t[r>>2]|0,129664,270)|0;Un(t[r>>2]|0,129672,271)|0;Un(t[r>>2]|0,129688,272)|0;Un(t[r>>2]|0,129696,273)|0;Un(t[r>>2]|0,129704,274)|0;Un(t[r>>2]|0,129720,275)|0;Un(t[r>>2]|0,129736,276)|0;Un(t[r>>2]|0,129744,277)|0;Un(t[r>>2]|0,129760,278)|0;Un(t[r>>2]|0,129768,279)|0;Un(t[r>>2]|0,129776,280)|0;Un(t[r>>2]|0,129792,281)|0;Un(t[r>>2]|0,129808,282)|0;Un(t[r>>2]|0,129824,283)|0;Un(t[r>>2]|0,129848,284)|0;Un(t[r>>2]|0,129864,285)|0;Un(t[r>>2]|0,129e3,286)|0;Un(t[r>>2]|0,129872,287)|0;zn(t[r>>2]|0,129888,129904,288)|0;s=i;return}function vf(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+200>>2]|0)xt(t[(t[r>>2]|0)+200>>2]|0);Zn(t[r>>2]|0);qn(t[r>>2]|0);Wn(t[r>>2]|0);lp((t[r>>2]|0)+136|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function mf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[a>>2]|0)){Ut(t[u>>2]|0,129120);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+48|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));i=t[f>>2]|0;t[(t[a>>2]|0)+4>>2]=i;t[t[a>>2]>>2]=i;t[(t[a>>2]|0)+12>>2]=t[u>>2];i=Wt()|0;t[(t[a>>2]|0)+32>>2]=i;if(!(t[(t[a>>2]|0)+32>>2]|0)){pAi[t[135736>>2]&511](t[(t[a>>2]|0)+28>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+192>>2]|0)!=0:0){t[(t[(t[a>>2]|0)+32>>2]|0)+20>>2]=t[(t[u>>2]|0)+192>>2];sz(t[(t[(t[a>>2]|0)+32>>2]|0)+20>>2]|0)|0}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function _f(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0);if(!(t[(t[r>>2]|0)+32>>2]|0)){n=t[33934]|0;f=t[r>>2]|0;pAi[n&511](f);s=i;return}if(t[(t[(t[r>>2]|0)+32>>2]|0)+24>>2]|0){mj(t[(t[(t[r>>2]|0)+32>>2]|0)+24>>2]|0);t[(t[(t[r>>2]|0)+32>>2]|0)+24>>2]=0}mn(t[(t[r>>2]|0)+32>>2]|0);n=t[33934]|0;f=t[r>>2]|0;pAi[n&511](f);s=i;return}function pf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,k=0;i=s;s=s+32|0;r=i;n=i+28|0;f=i+24|0;u=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;t[f>>2]=e;t[c>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){t[a>>2]=En(t[f>>2]|0)|0;t[u>>2]=En(t[f>>2]|0)|0;e=t[u>>2]|0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){b=t[(t[f>>2]|0)+12>>2]|0;if(e)zt(b,t[u>>2]|0);else zt(b,t[a>>2]|0);dn(t[f>>2]|0,10);t[n>>2]=0;k=t[n>>2]|0;s=i;return k|0}if((e|0)==(t[a>>2]|0)){_n(t[u>>2]|0);t[n>>2]=1;k=t[n>>2]|0;s=i;return k|0}if((((t[t[a>>2]>>2]|0)!=1?(t[t[a>>2]>>2]|0)!=9:0)?(t[t[u>>2]>>2]|0)!=1:0)?(t[t[u>>2]>>2]|0)!=9:0){t[n>>2]=Jt(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;k=t[n>>2]|0;s=i;return k|0}if((t[t[u>>2]>>2]|0)!=1?(t[t[u>>2]>>2]|0)!=9:0){t[o>>2]=t[a>>2];t[a>>2]=t[u>>2];t[u>>2]=t[o>>2]}switch(t[t[a>>2]>>2]|0){case 2:{if((t[(t[u>>2]|0)+4>>2]|0)!=0?(t[t[(t[u>>2]|0)+4>>2]>>2]|0)!=0:0)t[c>>2]=1;else t[c>>2]=0;t[c>>2]=(t[c>>2]|0)==(t[(t[a>>2]|0)+8>>2]|0)&1;break}case 3:{t[c>>2]=Xt(t[f>>2]|0,t[u>>2]|0,+l[(t[a>>2]|0)+16>>3],0)|0;break}case 4:{t[c>>2]=Zt(t[u>>2]|0,t[(t[a>>2]|0)+24>>2]|0,0)|0;break}case 6:case 5:case 8:case 7:{o=t[33976]|0;e=t[33980]|0;t[r>>2]=128552;t[r+4>>2]=7204;yAi[o&511](e,129064,r);
	break}case 9:case 1:{t[c>>2]=Kt(t[u>>2]|0,t[a>>2]|0,0)|0;break}default:{}}zt(t[(t[f>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[f>>2]|0)+12>>2]|0,t[a>>2]|0);t[n>>2]=t[c>>2];k=t[n>>2]|0;s=i;return k|0}t[n>>2]=0;k=t[n>>2]|0;s=i;return k|0}function Ef(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,k=0;i=s;s=s+32|0;r=i;n=i+28|0;f=i+24|0;u=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;t[f>>2]=e;t[c>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){t[a>>2]=En(t[f>>2]|0)|0;t[u>>2]=En(t[f>>2]|0)|0;e=t[u>>2]|0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){b=t[(t[f>>2]|0)+12>>2]|0;if(e)zt(b,t[u>>2]|0);else zt(b,t[a>>2]|0);dn(t[f>>2]|0,10);t[n>>2]=0;k=t[n>>2]|0;s=i;return k|0}if((e|0)==(t[a>>2]|0)){zt(t[(t[f>>2]|0)+12>>2]|0,t[u>>2]|0);t[n>>2]=0;k=t[n>>2]|0;s=i;return k|0}if((((t[t[a>>2]>>2]|0)!=1?(t[t[a>>2]>>2]|0)!=9:0)?(t[t[u>>2]>>2]|0)!=1:0)?(t[t[u>>2]>>2]|0)!=9:0){t[n>>2]=((Jt(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0)|0)!=0^1)&1;k=t[n>>2]|0;s=i;return k|0}if((t[t[u>>2]>>2]|0)!=1?(t[t[u>>2]>>2]|0)!=9:0){t[o>>2]=t[a>>2];t[a>>2]=t[u>>2];t[u>>2]=t[o>>2]}switch(t[t[a>>2]>>2]|0){case 2:{if((t[(t[u>>2]|0)+4>>2]|0)!=0?(t[t[(t[u>>2]|0)+4>>2]>>2]|0)!=0:0)t[c>>2]=1;else t[c>>2]=0;t[c>>2]=(t[c>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0)&1;break}case 4:{t[c>>2]=Zt(t[u>>2]|0,t[(t[a>>2]|0)+24>>2]|0,1)|0;break}case 3:{t[c>>2]=Xt(t[f>>2]|0,t[u>>2]|0,+l[(t[a>>2]|0)+16>>3],1)|0;break}case 6:case 5:case 8:case 7:{o=t[33976]|0;e=t[33980]|0;t[r>>2]=128552;t[r+4>>2]=7289;yAi[o&511](e,129064,r);break}case 9:case 1:{t[c>>2]=Kt(t[u>>2]|0,t[a>>2]|0,1)|0;break}default:{}}zt(t[(t[f>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[f>>2]|0)+12>>2]|0,t[a>>2]|0);t[n>>2]=t[c>>2];k=t[n>>2]|0;s=i;return k|0}t[n>>2]=0;k=t[n>>2]|0;s=i;return k|0}function Sf(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[b>>2]=0;t[k>>2]=0;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)!=0:0){t[w>>2]=En(t[u>>2]|0)|0;t[h>>2]=En(t[u>>2]|0)|0;if((t[h>>2]|0)==0|(t[w>>2]|0)==0){r=t[(t[u>>2]|0)+12>>2]|0;if(t[h>>2]|0)zt(r,t[h>>2]|0);else zt(r,t[w>>2]|0);dn(t[u>>2]|0,10);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if((((t[t[w>>2]>>2]|0)!=1?(t[t[w>>2]>>2]|0)!=9:0)?(t[t[h>>2]>>2]|0)!=1:0)?(t[t[h>>2]>>2]|0)!=9:0){if((t[t[h>>2]>>2]|0)!=3){Sn(t[u>>2]|0,t[h>>2]|0)|0;gf(t[u>>2]|0,1);t[h>>2]=En(t[u>>2]|0)|0}if((t[t[h>>2]>>2]|0)!=3){_n(t[h>>2]|0);_n(t[w>>2]|0);dn(t[u>>2]|0,10);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if((t[t[w>>2]>>2]|0)!=3){Sn(t[u>>2]|0,t[w>>2]|0)|0;gf(t[u>>2]|0,1);t[w>>2]=En(t[u>>2]|0)|0}if((t[t[w>>2]>>2]|0)!=3){zt(t[(t[u>>2]|0)+12>>2]|0,t[h>>2]|0);zt(t[(t[u>>2]|0)+12>>2]|0,t[w>>2]|0);dn(t[u>>2]|0,10);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}e:do if((hn(+l[(t[h>>2]|0)+16>>3])|0)==0?(hn(+l[(t[w>>2]|0)+16>>3])|0)==0:0){t[b>>2]=wn(+l[(t[h>>2]|0)+16>>3])|0;t[k>>2]=wn(+l[(t[w>>2]|0)+16>>3])|0;if((t[a>>2]|0)!=0&(t[o>>2]|0)!=0){do if(!((t[b>>2]|0)==-1&(t[k>>2]|0)!=-1)){if((t[k>>2]|0)==1&(t[b>>2]|0)!=1)break;if((t[b>>2]|0)==0&(t[k>>2]|0)==0){t[c>>2]=+l[(t[h>>2]|0)+16>>3]<+l[(t[w>>2]|0)+16>>3]&1;break e}else{t[c>>2]=0;break e}}while(0);t[c>>2]=1;break}if(!((t[a>>2]|0)==0|(t[o>>2]|0)!=0)){if((t[b>>2]|0)==-1|(t[k>>2]|0)==1){t[c>>2]=1;break}if((t[b>>2]|0)==0&(t[k>>2]|0)==0){t[c>>2]=+l[(t[h>>2]|0)+16>>3]<=+l[(t[w>>2]|0)+16>>3]&1;break}else{t[c>>2]=0;break}}if(!((t[a>>2]|0)==0&(t[o>>2]|0)!=0)){if((t[a>>2]|0)!=0|(t[o>>2]|0)!=0)break;if((t[b>>2]|0)==1|(t[k>>2]|0)==-1){t[c>>2]=1;break}if((t[b>>2]|0)==0&(t[k>>2]|0)==0){t[c>>2]=+l[(t[h>>2]|0)+16>>3]>=+l[(t[w>>2]|0)+16>>3]&1;break}else{t[c>>2]=0;break}}else{do if(!((t[b>>2]|0)==1&(t[k>>2]|0)!=1)){if((t[k>>2]|0)==-1&(t[b>>2]|0)!=-1)break;if((t[b>>2]|0)==0&(t[k>>2]|0)==0){t[c>>2]=+l[(t[h>>2]|0)+16>>3]>+l[(t[w>>2]|0)+16>>3]&1;break e}else{t[c>>2]=0;break e}}while(0);t[c>>2]=1;break}}else v=33;while(0);if((v|0)==33)t[c>>2]=0;zt(t[(t[u>>2]|0)+12>>2]|0,t[h>>2]|0);zt(t[(t[u>>2]|0)+12>>2]|0,t[w>>2]|0);t[f>>2]=t[c>>2];d=t[f>>2]|0;s=n;return d|0}if((t[t[w>>2]>>2]|0)!=1?(t[t[w>>2]>>2]|0)!=9:0)v=18;else v=15;do if((v|0)==15){if((t[t[h>>2]>>2]|0)!=1?(t[t[h>>2]>>2]|0)!=9:0){v=18;break}t[c>>2]=Qt(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,t[w>>2]|0)|0}while(0);do if((v|0)==18){if((t[t[h>>2]>>2]|0)!=1?(t[t[h>>2]>>2]|0)!=9:0){t[c>>2]=$t(t[u>>2]|0,((t[a>>2]|0)!=0^1)&1,t[o>>2]|0,t[w>>2]|0,t[h>>2]|0)|0;break}t[c>>2]=$t(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,t[w>>2]|0)|0}while(0);t[f>>2]=t[c>>2];d=t[f>>2]|0;s=n;return d|0}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}function gf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r;o=r+8|0;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(!(t[f>>2]|0)){e=t[n>>2]|0;if(!(t[(t[i+12>>2]|0)+4>>2]|0)){Sn(e,eu(t[(t[n>>2]|0)+12>>2]|0,0)|0)|0;s=r;return}else{t[o>>2]=sF(t[(t[e+12>>2]|0)+4>>2]|0)|0;l[a>>3]=+cf(t[o>>2]|0);e=t[n>>2]|0;Sn(e,eu(t[(t[n>>2]|0)+12>>2]|0,+l[a>>3])|0)|0;pAi[t[135736>>2]&511](t[o>>2]|0);s=r;return}}if(!i){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}else{t[u>>2]=En(f)|0;f=t[n>>2]|0;Sn(f,iu(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0)|0)|0;s=r;return}}function yf(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+12>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[r>>2]|0,1);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)==3:0){if(hn(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3])|0){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15984];s=i;return}if((wn(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3])|0)==1){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15986];s=i;return}if((wn(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3])|0)==-1){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15985];s=i;return}n=+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3];if(!(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]==0)){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=-n;s=i;return}if(!(Bt(n)|0)){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15988];s=i;return}else{l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=0;s=i;return}}dn(t[r>>2]|0,11);s=i;return}function Ff(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i;t[r>>2]=e;t[n>>2]=En(t[r>>2]|0)|0;if(!(t[n>>2]|0)){dn(t[r>>2]|0,10);s=i;return}l[f>>3]=+Fn(t[n>>2]|0);zt(t[(t[r>>2]|0)+12>>2]|0,t[n>>2]|0);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[r>>2]|0,1);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)==3:0){n=(t[(t[r>>2]|0)+16>>2]|0)+16|0;l[n>>3]=+l[n>>3]+ +l[f>>3];s=i;return}dn(t[r>>2]|0,11);s=i;return}function Of(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i;t[r>>2]=e;t[n>>2]=En(t[r>>2]|0)|0;if(!(t[n>>2]|0)){dn(t[r>>2]|0,10);s=i;return}l[f>>3]=+Fn(t[n>>2]|0);zt(t[(t[r>>2]|0)+12>>2]|0,t[n>>2]|0);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[r>>2]|0,1);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)==3:0){n=(t[(t[r>>2]|0)+16>>2]|0)+16|0;l[n>>3]=+l[n>>3]-+l[f>>3];s=i;return}dn(t[r>>2]|0,11);s=i;return}function Af(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i;t[r>>2]=e;t[n>>2]=En(t[r>>2]|0)|0;if(!(t[n>>2]|0)){dn(t[r>>2]|0,10);s=i;return}l[f>>3]=+Fn(t[n>>2]|0);zt(t[(t[r>>2]|0)+12>>2]|0,t[n>>2]|0);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[r>>2]|0,1);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)==3:0){n=(t[(t[r>>2]|0)+16>>2]|0)+16|0;l[n>>3]=+l[n>>3]*+l[f>>3];s=i;return}dn(t[r>>2]|0,11);s=i;return}function Mf(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i;t[r>>2]=e;t[n>>2]=En(t[r>>2]|0)|0;if(!(t[n>>2]|0)){dn(t[r>>2]|0,10);s=i;return}l[f>>3]=+Fn(t[n>>2]|0);zt(t[(t[r>>2]|0)+12>>2]|0,t[n>>2]|0);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[r>>2]|0,1);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)==3:0){if((hn(+l[f>>3])|0)==0?(hn(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3])|0)==0:0){if(+l[f>>3]==0?(Bt(+l[f>>3])|0)!=0:0){if(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]==0){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15984];s=i;return}if(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]>0){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15986];s=i;return}if(!(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]<0)){s=i;return}l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15985];s=i;return}if(!(+l[f>>3]==0)){n=(t[(t[r>>2]|0)+16>>2]|0)+16|0;l[n>>3]=+l[n>>3]/+l[f>>3];s=i;return}if(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]==0){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15984];s=i;return}if(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]>0){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15985];s=i;return}if(!(+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]<0)){s=i;return}l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15986];s=i;return}l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15984];s=i;return}dn(t[r>>2]|0,11);s=i;return}function Rf(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+8|0;u=i;t[r>>2]=e;t[n>>2]=En(t[r>>2]|0)|0;if(!(t[n>>2]|0)){dn(t[r>>2]|0,10);s=i;return}l[u>>3]=+Fn(t[n>>2]|0);zt(t[(t[r>>2]|0)+12>>2]|0,t[n>>2]|0);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[r>>2]|0,1);if((t[(t[r>>2]|0)+16>>2]|0)!=0?(t[t[(t[r>>2]|0)+16>>2]>>2]|0)==3:0){l[f>>3]=+l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3];if(+l[u>>3]==0){l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=+l[15984];s=i;return}else{a=+aY(+l[f>>3],+l[u>>3]);l[(t[(t[r>>2]|0)+16>>2]|0)+16>>3]=a;s=i;return}}dn(t[r>>2]|0,11);s=i;return}function Nf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0)if(!(t[u>>2]|0)){t[n>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];break}else{t[n>>2]=0;break}else a=3;while(0);if((a|0)==3)t[n>>2]=0;s=r;return t[n>>2]|0}function Tf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if(t[u>>2]|0){if((t[(t[u>>2]|0)+4>>2]|0)!=9?(t[(t[u>>2]|0)+4>>2]|0)!=13:0){t[n>>2]=t[(t[u>>2]|0)+24>>2];break}t[n>>2]=0;break}if(!(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){t[n>>2]=0;break}switch(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0){case 20:case 19:case 18:case 2:case 17:case 16:case 15:{t[n>>2]=0;break e;break}case 14:case 12:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+12>>2];break e;break}case 21:case 13:case 11:case 10:case 9:{t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+12>>2];break e;break}default:{t[n>>2]=0;break e}}}else a=3;while(0);if((a|0)==3)t[n>>2]=0;s=r;return t[n>>2]|0}function Lf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if(!(t[u>>2]|0)){if(!(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){i=t[(t[f>>2]|0)+12>>2]|0;if((t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)==(t[t[(t[f>>2]|0)+12>>2]>>2]|0)){t[n>>2]=t[(t[i>>2]|0)+12>>2];a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=t[(t[i+4>>2]|0)+12>>2];a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[u>>2]|0)+4>>2]|0)==18){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if(((t[(t[u>>2]|0)+12>>2]|0)!=0?(t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(t[u>>2]=t[(t[u>>2]|0)+12>>2],(t[(t[u>>2]|0)+4>>2]|0)!=14):0){t[n>>2]=t[u>>2];a=t[n>>2]|0;s=r;return a|0}if((t[u>>2]|0)==(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}while(1){if(!(t[(t[u>>2]|0)+24>>2]|0))break;t[u>>2]=t[(t[u>>2]|0)+24>>2];if((t[(t[u>>2]|0)+4>>2]|0)==17)continue;if((t[(t[u>>2]|0)+4>>2]|0)!=14){o=24;break}}if((o|0)==24){t[n>>2]=t[u>>2];a=t[n>>2]|0;s=r;return a|0}while(1){t[u>>2]=t[(t[u>>2]|0)+20>>2];if(!(t[u>>2]|0)){o=31;break}if((t[u>>2]|0)==(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){o=27;break}c=t[u>>2]|0;if(t[(t[u>>2]|0)+24>>2]|0){o=29;break}if(!c){o=31;break}}if((o|0)==27){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else if((o|0)==29){t[u>>2]=t[c+24>>2];t[n>>2]=t[u>>2];a=t[n>>2]|0;s=r;return a|0}else if((o|0)==31){t[n>>2]=t[u>>2];a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Df(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){i=t[f>>2]|0;if(t[u>>2]|0){t[n>>2]=Lf(i,t[u>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}if(!(t[(t[i+12>>2]|0)+4>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){t[n>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Cf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){e:do if(!(t[a>>2]|0)){if(!(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}switch(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0){case 2:{t[o>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];t[n>>2]=t[(t[o>>2]|0)+20>>2];l=t[n>>2]|0;s=r;return l|0}case 21:case 13:case 11:case 10:case 9:{t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}case 18:{t[c>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];if((t[t[c>>2]>>2]|0)!=0?(t[(t[t[c>>2]>>2]|0)+4>>2]|0)!=18:0){t[n>>2]=t[t[c>>2]>>2];l=t[n>>2]|0;s=r;return l|0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}case 17:case 20:case 19:case 16:case 15:case 14:case 12:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{i=t[(t[f>>2]|0)+12>>2]|0;if(!(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)){t[n>>2]=t[i>>2];l=t[n>>2]|0;s=r;return l|0}do if((t[(t[(t[i+4>>2]|0)+20>>2]|0)+4>>2]|0)==1){if((u[t[(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]>>0]|0|0)!=32?(Xl(t[(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]|0,129152)|0)==0:0)break;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}while(0);t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2];l=t[n>>2]|0;s=r;return l|0}default:break e}}while(0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function Pf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[a>>2]=i;e:do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if(!(t[a>>2]|0)){if(!(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){t[n>>2]=0;break}switch(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0){case 2:{t[o>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];t[n>>2]=t[(t[o>>2]|0)+20>>2];break e;break}case 18:{t[c>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];if((t[t[c>>2]>>2]|0)!=0?(t[(t[t[c>>2]>>2]|0)+4>>2]|0)!=18:0){t[n>>2]=t[t[c>>2]>>2];break e}t[n>>2]=0;break e;break}case 20:case 19:case 12:case 17:case 16:case 15:case 14:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{i=t[(t[f>>2]|0)+12>>2]|0;if(!(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)){t[n>>2]=t[i>>2];break e}do if((t[(t[(t[i+4>>2]|0)+20>>2]|0)+4>>2]|0)==1){if((u[t[(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]>>0]|0|0)!=32?(Xl(t[(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]|0,129152)|0)==0:0)break;t[n>>2]=0;break e}while(0);t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2];break e;break}case 21:case 13:case 11:case 10:case 9:{t[n>>2]=0;break e;break}default:{t[n>>2]=0;break e}}}if((t[a>>2]|0)==(t[(t[t[(t[f>>2]|0)+12>>2]>>2]|0)+12>>2]|0)){t[n>>2]=t[t[(t[f>>2]|0)+12>>2]>>2];break}if((t[a>>2]|0)==(t[t[(t[f>>2]|0)+12>>2]>>2]|0)){t[n>>2]=0;break}switch(t[(t[a>>2]|0)+4>>2]|0){case 21:case 13:case 11:case 10:case 9:{t[n>>2]=0;break e;break}case 18:{t[b>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];if((t[t[b>>2]>>2]|0)!=0?(t[(t[t[b>>2]>>2]|0)+4>>2]|0)!=18:0){t[n>>2]=t[t[b>>2]>>2];break e}t[n>>2]=0;break e;break}case 20:case 19:case 17:case 16:case 15:case 14:case 12:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{if(!(t[(t[a>>2]|0)+20>>2]|0)){t[n>>2]=0;break e}do if((t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]|0)==1){if((u[t[(t[(t[a>>2]|0)+20>>2]|0)+8>>2]>>0]|0|0)!=32?(Xl(t[(t[(t[a>>2]|0)+20>>2]|0)+8>>2]|0,129152)|0)==0:0)break;t[n>>2]=0;break e}while(0);t[n>>2]=t[(t[a>>2]|0)+20>>2];break e;break}case 2:{t[l>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];t[n>>2]=t[(t[l>>2]|0)+20>>2];break e;break}default:{t[n>>2]=0;break e}}}else k=3;while(0);if((k|0)==3)t[n>>2]=0;s=r;return t[n>>2]|0}function Bf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){i=t[f>>2]|0;if(!(t[u>>2]|0)){t[n>>2]=t[(t[i+12>>2]|0)+4>>2];a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=Pf(i,t[u>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function If(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if((t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)==(t[t[(t[f>>2]|0)+12>>2]>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if(!(t[u>>2]|0)){t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+24>>2];a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=t[(t[u>>2]|0)+24>>2];a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Hf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if((t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)==(t[t[(t[f>>2]|0)+12>>2]>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if(!(t[u>>2]|0)){t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+28>>2];a=t[n>>2]|0;s=r;return a|0}if(((t[(t[u>>2]|0)+28>>2]|0)!=0?(t[(t[(t[u>>2]|0)+28>>2]|0)+4>>2]|0)==14:0)?(t[u>>2]=t[(t[u>>2]|0)+28>>2],(t[u>>2]|0)==0):0){t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+28>>2];a=t[n>>2]|0;s=r;return a|0}t[n>>2]=t[(t[u>>2]|0)+28>>2];a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function xf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=2:0)?(t[(t[u>>2]|0)+4>>2]|0)!=18:0)?(t[(t[u>>2]|0)+12>>2]|0)!=0:0){t[n>>2]=t[(t[u>>2]|0)+12>>2];a=t[n>>2]|0;s=r;return a|0}do if(!(t[u>>2]|0)){t[u>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];if((t[(t[u>>2]|0)+4>>2]|0)==18){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else{if((t[(t[u>>2]|0)+4>>2]|0)!=2)break;t[u>>2]=t[(t[u>>2]|0)+20>>2];break}}while(0);if(!(t[u>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if(t[(t[u>>2]|0)+24>>2]|0){t[n>>2]=t[(t[u>>2]|0)+24>>2];a=t[n>>2]|0;s=r;return a|0}while(1){t[u>>2]=t[(t[u>>2]|0)+20>>2];if(!(t[u>>2]|0)){o=24;break}if((t[u>>2]|0)==(t[t[(t[f>>2]|0)+12>>2]>>2]|0)){o=20;break}c=t[u>>2]|0;if(t[(t[u>>2]|0)+24>>2]|0){o=22;break}if(!c){o=24;break}}if((o|0)==20){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else if((o|0)==22){t[n>>2]=t[c+24>>2];a=t[n>>2]|0;s=r;return a|0}else if((o|0)==24){t[n>>2]=t[u>>2];a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Uf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if((t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=1){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0)==0?(t[u>>2]|0)!=(t[32294]|0):0){if(t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0);u=hF(t[t[(t[f>>2]|0)+12>>2]>>2]|0,t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)|0;t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]=u;t[(t[(t[f>>2]|0)+12>>2]|0)+124>>2]=0;e:do if(t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0)while(1){if(!(t[(t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0)+(t[(t[(t[f>>2]|0)+12>>2]|0)+124>>2]<<2)>>2]|0))break e;u=(t[(t[f>>2]|0)+12>>2]|0)+124|0;t[u>>2]=(t[u>>2]|0)+1}while(0);t[n>>2]=t[32294];a=t[n>>2]|0;s=r;return a|0}u=t[(t[f>>2]|0)+12>>2]|0;if((t[(t[(t[f>>2]|0)+12>>2]|0)+124>>2]|0)>0){i=u+124|0;e=(t[i>>2]|0)+-1|0;t[i>>2]=e;t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0)+(e<<2)>>2];a=t[n>>2]|0;s=r;return a|0}if(t[u+120>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]|0);t[(t[(t[f>>2]|0)+12>>2]|0)+120>>2]=0;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function zf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if(!(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)){t[n>>2]=0;break}if((t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=1){t[n>>2]=0;break}if(t[u>>2]|0){t[n>>2]=t[(t[u>>2]|0)+24>>2];break}if((t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)==(t[t[(t[f>>2]|0)+12>>2]>>2]|0)){t[n>>2]=0;break}else{t[n>>2]=t[(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)+44>>2];break}}else a=3;while(0);if((a|0)==3)t[n>>2]=0;s=r;return t[n>>2]|0}function jf(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+12>>2]|0)){s=i;return}t[(t[(t[r>>2]|0)+12>>2]|0)+4>>2]=t[t[(t[r>>2]|0)+12>>2]>>2];e=t[r>>2]|0;Sn(e,ru(t[(t[r>>2]|0)+12>>2]|0,t[(t[(t[r>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;s=i;return}function Vf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(t[f>>2]|0){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+0|0)){dn(f,23);s=r;return}i=t[n>>2]|0;if((t[(t[f+12>>2]|0)+68>>2]|0)>=0){Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,+(t[(t[(t[n>>2]|0)+12>>2]|0)+68>>2]|0))|0)|0;s=r;return}else{dn(i,13);s=r;return}}function qf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(t[f>>2]|0){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+0|0)){dn(f,23);s=r;return}i=t[n>>2]|0;if((t[(t[f+12>>2]|0)+72>>2]|0)>=0){Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,+(t[(t[(t[n>>2]|0)+12>>2]|0)+72>>2]|0))|0)|0;s=r;return}else{dn(i,14);s=r;return}}function Yf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=9:0)break;t[u>>2]=En(t[n>>2]|0)|0;do if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=0:0){if((t[t[u>>2]>>2]|0)!=1?(t[t[u>>2]>>2]|0)!=9:0){if((t[t[(t[u>>2]|0)+4>>2]>>2]|0)==1?(t[(t[(t[u>>2]|0)+4>>2]|0)+8>>2]|0)!=0:0){t[o>>2]=0;t[a>>2]=t[t[(t[(t[u>>2]|0)+4>>2]|0)+8>>2]>>2];e:do if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)!=18:0){t[a>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(t[a>>2]|0))break e;t[a>>2]=t[(t[a>>2]|0)+24>>2];t[o>>2]=(t[o>>2]|0)+1}}while(0);i=t[n>>2]|0;Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,+(t[o>>2]|0))|0)|0;break}i=t[n>>2]|0;Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,0)|0)|0;break}i=t[n>>2]|0;Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,+(t[t[(t[u>>2]|0)+4>>2]>>2]|0))|0)|0}else c=12;while(0);if((c|0)==12){i=t[n>>2]|0;Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,0)|0)|0}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Gf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}t[o>>2]=En(f)|0;if(!(t[o>>2]|0)){dn(t[n>>2]|0,10);s=r;return}if((t[t[o>>2]>>2]|0)!=1?(t[t[o>>2]>>2]|0)!=9:0){t[o>>2]=tu(t[(t[n>>2]|0)+12>>2]|0,t[o>>2]|0)|0;t[a>>2]=nu(t[t[(t[n>>2]|0)+12>>2]>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;f=t[n>>2]|0;Sn(f,fu(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0)|0)|0;zt(t[(t[n>>2]|0)+12>>2]|0,t[o>>2]|0);s=r;return}t[a>>2]=Nn(0)|0;e:do if(t[(t[o>>2]|0)+4>>2]|0){t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[t[(t[o>>2]|0)+4>>2]>>2]|0))break e;t[u>>2]=xn(t[(t[(t[(t[o>>2]|0)+4>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0)|0;t[c>>2]=nu(t[t[(t[n>>2]|0)+12>>2]>>2]|0,t[u>>2]|0)|0;t[a>>2]=Pn(t[a>>2]|0,t[c>>2]|0)|0;Bn(t[c>>2]|0);if(t[u>>2]|0)pAi[t[135736>>2]&511](t[u>>2]|0);t[l>>2]=(t[l>>2]|0)+1}}while(0);zt(t[(t[n>>2]|0)+12>>2]|0,t[o>>2]|0);o=t[n>>2]|0;Sn(o,fu(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0)|0)|0;s=r;return}function Wf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if(!(t[f>>2]|0)){i=t[n>>2]|0;Sn(i,ru(t[(t[n>>2]|0)+12>>2]|0,t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;t[f>>2]=1}if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=9:0)break;t[a>>2]=En(t[n>>2]|0)|0;do if((t[(t[a>>2]|0)+4>>2]|0)!=0?(t[t[(t[a>>2]|0)+4>>2]>>2]|0)!=0:0){t[o>>2]=0;i=t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+4>>2]|0;if((i|0)==7|(i|0)==2|(i|0)==1){e=t[n>>2]|0;c=t[(t[n>>2]|0)+12>>2]|0;if((u[t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]>>0]|0|0)==32){Sn(e,uu(c,128928)|0)|0;break}else{Sn(e,au(c,t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]|0)|0)|0;break}}else if((i|0)==18){i=t[n>>2]|0;Sn(i,au(t[(t[n>>2]|0)+12>>2]|0,t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+12>>2]|0)|0)|0;break}else{i=t[n>>2]|0;Sn(i,uu(t[(t[n>>2]|0)+12>>2]|0,128928)|0)|0;break}}else l=15;while(0);if((l|0)==15){i=t[n>>2]|0;Sn(i,uu(t[(t[n>>2]|0)+12>>2]|0,128928)|0)|0}zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Kf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if(!(t[f>>2]|0)){i=t[n>>2]|0;Sn(i,ru(t[(t[n>>2]|0)+12>>2]|0,t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;t[f>>2]=1}if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=9:0)break;t[u>>2]=En(t[n>>2]|0)|0;do if((t[(t[u>>2]|0)+4>>2]|0)!=0?(t[t[(t[u>>2]|0)+4>>2]>>2]|0)!=0:0){t[a>>2]=0;if(((t[(t[(t[(t[(t[u>>2]|0)+4>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0)+4>>2]|0)+-1|0)>>>0>=2){i=t[n>>2]|0;Sn(i,uu(t[(t[n>>2]|0)+12>>2]|0,128928)|0)|0;break}i=t[n>>2]|0;e=t[(t[n>>2]|0)+12>>2]|0;if(!(t[(t[(t[(t[(t[u>>2]|0)+4>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0)+36>>2]|0)){Sn(i,uu(e,128928)|0)|0;break}else{Sn(i,au(e,t[(t[(t[(t[(t[(t[u>>2]|0)+4>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0)+36>>2]|0)+8>>2]|0)|0)|0;break}}else o=15;while(0);if((o|0)==15){e=t[n>>2]|0;Sn(e,uu(t[(t[n>>2]|0)+12>>2]|0,128928)|0)|0}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Xf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(!(t[f>>2]|0)){e=t[(t[n>>2]|0)+12>>2]|0;Sn(i,ou(e,xn(t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0)|0;s=r;return}if(!i){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}t[u>>2]=En(f)|0;f=t[n>>2]|0;if(!(t[u>>2]|0)){dn(f,10);s=r;return}else{Sn(f,tu(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0)|0)|0;s=r;return}}function Zf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;i=(t[n>>2]|0)==0;if(!(t[f>>2]|0)){if(i){s=r;return}if(!(t[(t[n>>2]|0)+12>>2]|0)){s=r;return}e=t[n>>2]|0;if(!(t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)){Sn(e,eu(t[(t[n>>2]|0)+12>>2]|0,0)|0)|0;s=r;return}else{t[a>>2]=xn(t[(t[e+12>>2]|0)+4>>2]|0)|0;e=t[n>>2]|0;o=t[(t[n>>2]|0)+12>>2]|0;Sn(e,eu(o,+(os(t[a>>2]|0)|0))|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);s=r;return}}if(i){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==4:0){t[u>>2]=En(t[n>>2]|0)|0;f=t[n>>2]|0;i=t[(t[n>>2]|0)+12>>2]|0;Sn(f,eu(i,+(os(t[(t[u>>2]|0)+24>>2]|0)|0))|0)|0;zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);s=r;return}dn(t[n>>2]|0,11);s=r;return}function Jf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[f>>2]|0)<2){if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=2){dn(i,12);s=r;return}if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+2|0)){dn(t[n>>2]|0,23);s=r;return}}if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[u>>2]=En(t[n>>2]|0)|0;if((t[u>>2]|0)!=0?(t[t[u>>2]>>2]|0)==4:0){t[f>>2]=(t[f>>2]|0)+-1;while(1){c=t[n>>2]|0;if((t[f>>2]|0)<=0){l=23;break}if((t[c+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[a>>2]=En(t[n>>2]|0)|0;if(!(t[a>>2]|0)){l=21;break}if((t[t[a>>2]>>2]|0)!=4){l=21;break}t[o>>2]=us(t[(t[a>>2]|0)+24>>2]|0,t[(t[u>>2]|0)+24>>2]|0)|0;t[(t[a>>2]|0)+24>>2]=t[(t[u>>2]|0)+24>>2];t[(t[u>>2]|0)+24>>2]=t[o>>2];zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);t[f>>2]=(t[f>>2]|0)+-1}if((l|0)==21){zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);dn(t[n>>2]|0,11);s=r;return}else if((l|0)==23){Sn(c,t[u>>2]|0)|0;s=r;return}}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);s=r;return}function Qf(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=2){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+2|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==4:0){t[a>>2]=En(t[n>>2]|0)|0;if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[u>>2]=En(t[n>>2]|0)|0;if((t[u>>2]|0)!=0?(t[t[u>>2]>>2]|0)==4:0){f=(is(t[(t[u>>2]|0)+24>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0)!=0;i=t[n>>2]|0;e=t[(t[n>>2]|0)+12>>2]|0;if(f)Sn(i,cu(e,1)|0)|0;else Sn(i,cu(e,0)|0)|0;zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);s=r;return}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);dn(t[n>>2]|0,11);s=r;return}dn(t[n>>2]|0,11);s=r;return}function $f(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=2){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+2|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==4:0){t[a>>2]=En(t[n>>2]|0)|0;if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[u>>2]=En(t[n>>2]|0)|0;if((t[u>>2]|0)!=0?(t[t[u>>2]>>2]|0)==4:0){t[o>>2]=rs(t[(t[a>>2]|0)+24>>2]|0)|0;f=(Jl(t[(t[u>>2]|0)+24>>2]|0,t[(t[a>>2]|0)+24>>2]|0,t[o>>2]|0)|0)!=0;o=t[n>>2]|0;i=t[(t[n>>2]|0)+12>>2]|0;if(f)Sn(o,cu(i,0)|0)|0;else Sn(o,cu(i,1)|0)|0;zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);s=r;return}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);dn(t[n>>2]|0,11);s=r;return}dn(t[n>>2]|0,11);s=r;return}function et(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0;r=s;s=s+64|0;n=r+48|0;f=r+44|0;u=r+40|0;a=r+36|0;o=r+32|0;c=r+8|0;b=r;k=r+28|0;h=r+24|0;w=r+20|0;d=r+16|0;t[n>>2]=e;t[f>>2]=i;l[c>>3]=0;if((t[f>>2]|0)<2){if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=2){dn(i,12);s=r;return}if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+2|0)){dn(t[n>>2]|0,23);s=r;return}}if((t[f>>2]|0)>3){if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=3){dn(i,12);s=r;return}if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+3|0)){dn(t[n>>2]|0,23);s=r;return}}do if((t[f>>2]|0)==3){if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){t[o>>2]=En(t[n>>2]|0)|0;
	l[c>>3]=+l[(t[o>>2]|0)+16>>3];zt(t[(t[n>>2]|0)+12>>2]|0,t[o>>2]|0);break}dn(t[n>>2]|0,11);s=r;return}while(0);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){t[a>>2]=En(t[n>>2]|0)|0;l[b>>3]=+l[(t[a>>2]|0)+16>>3];zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==4:0){t[u>>2]=En(t[n>>2]|0)|0;t[w>>2]=os(t[(t[u>>2]|0)+24>>2]|0)|0;if((t[f>>2]|0)!=3?(l[c>>3]=+(t[w>>2]|0),+l[b>>3]<1):0)l[b>>3]=1;if((wn(+l[b>>3])|0)==0?(hn(+l[b>>3]+ +l[c>>3])|0)==0:0){t[k>>2]=~~+l[b>>3];if(+(t[k>>2]|0)+.5<=+l[b>>3])t[k>>2]=(t[k>>2]|0)+1;do if((wn(+l[c>>3])|0)==1){t[h>>2]=t[w>>2];if((t[k>>2]|0)<1)t[k>>2]=1}else{b=(wn(+l[c>>3])|0)==-1;if(b|+l[c>>3]<0){t[h>>2]=0;break}t[h>>2]=~~+l[c>>3];if(+(t[h>>2]|0)+.5<=+l[c>>3])t[h>>2]=(t[h>>2]|0)+1}while(0);t[k>>2]=(t[k>>2]|0)-1;t[h>>2]=(t[h>>2]|0)+(t[k>>2]|0);if((t[k>>2]|0)<0)t[k>>2]=0;if((t[h>>2]|0)>(t[w>>2]|0))t[h>>2]=t[w>>2];t[h>>2]=(t[h>>2]|0)-(t[k>>2]|0);t[d>>2]=ws(t[(t[u>>2]|0)+24>>2]|0,t[k>>2]|0,t[h>>2]|0)|0}else t[d>>2]=0;h=t[n>>2]|0;k=t[(t[n>>2]|0)+12>>2]|0;if(!(t[d>>2]|0))Sn(h,uu(k,128928)|0)|0;else{Sn(h,au(k,t[d>>2]|0)|0)|0;pAi[t[135736>>2]&511](t[d>>2]|0)}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);s=r;return}dn(t[n>>2]|0,11);s=r;return}dn(t[n>>2]|0,11);s=r;return}function it(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=2){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+2|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[a>>2]=En(t[n>>2]|0)|0;if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[u>>2]=En(t[n>>2]|0)|0;t[o>>2]=ds()|0;if(t[o>>2]|0){t[c>>2]=is(t[(t[u>>2]|0)+24>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0;if(t[c>>2]|0){t[l>>2]=(t[c>>2]|0)-(t[(t[u>>2]|0)+24>>2]|0);Ps(t[o>>2]|0,t[(t[u>>2]|0)+24>>2]|0,t[l>>2]|0)|0}l=t[n>>2]|0;c=t[(t[n>>2]|0)+12>>2]|0;Sn(l,au(c,Os(t[o>>2]|0)|0)|0)|0;Ss(t[o>>2]|0)}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);s=r;return}function rt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=2){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+2|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[a>>2]=En(t[n>>2]|0)|0;if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);t[u>>2]=En(t[n>>2]|0)|0;t[o>>2]=ds()|0;if(t[o>>2]|0){t[c>>2]=is(t[(t[u>>2]|0)+24>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0;if(t[c>>2]|0){f=(t[c>>2]|0)-(t[(t[u>>2]|0)+24>>2]|0)|0;t[l>>2]=f+(rs(t[(t[a>>2]|0)+24>>2]|0)|0);f=t[o>>2]|0;c=(t[(t[u>>2]|0)+24>>2]|0)+(t[l>>2]|0)|0;i=rs(t[(t[u>>2]|0)+24>>2]|0)|0;Ps(f,c,i-(t[l>>2]|0)|0)|0}l=t[n>>2]|0;i=t[(t[n>>2]|0)+12>>2]|0;Sn(l,au(i,Os(t[o>>2]|0)|0)|0)|0;Ss(t[o>>2]|0)}zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);s=r;return}function nt(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;b=r+20|0;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;t[c>>2]=0;if(!(t[f>>2]|0)){s=r;return}if(!(t[a>>2]|0)){i=t[f>>2]|0;e=t[(t[f>>2]|0)+12>>2]|0;Sn(i,ou(e,xn(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0)|0;t[a>>2]=1}if(!(t[f>>2]|0)){s=r;return}e=t[f>>2]|0;if((t[a>>2]|0)!=1){dn(e,12);s=r;return}a=t[f>>2]|0;if((t[e+20>>2]|0)<((t[(t[f>>2]|0)+44>>2]|0)+1|0)){dn(a,23);s=r;return}if((t[a+16>>2]|0)!=0?(t[t[(t[f>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[f>>2]|0,1);if((t[(t[f>>2]|0)+16>>2]|0)!=0?(t[t[(t[f>>2]|0)+16>>2]>>2]|0)==4:0){t[o>>2]=En(t[f>>2]|0)|0;t[c>>2]=t[(t[o>>2]|0)+24>>2];t[l>>2]=ds()|0;if((t[l>>2]|0)!=0&(t[c>>2]|0)!=0){e:while(1){do if((u[t[c>>2]>>0]|0)!=32){if(9<=(u[t[c>>2]>>0]|0)?(u[t[c>>2]>>0]|0)<=10:0)break;if((u[t[c>>2]>>0]|0)!=13)break e}while(0);t[c>>2]=(t[c>>2]|0)+1}n[b>>0]=0;while(1){if(!(n[t[c>>2]>>0]|0))break;do if((u[t[c>>2]>>0]|0)!=32){if(9<=(u[t[c>>2]>>0]|0)?(u[t[c>>2]>>0]|0)<=10:0){k=27;break}if((u[t[c>>2]>>0]|0)!=13){if(n[b>>0]|0){Ps(t[l>>2]|0,b,1)|0;n[b>>0]=0}Ps(t[l>>2]|0,t[c>>2]|0,1)|0}else k=27}else k=27;while(0);if((k|0)==27){k=0;n[b>>0]=32}t[c>>2]=(t[c>>2]|0)+1}c=t[f>>2]|0;b=t[(t[f>>2]|0)+12>>2]|0;Sn(c,au(b,Os(t[l>>2]|0)|0)|0)|0;Ss(t[l>>2]|0)}zt(t[(t[f>>2]|0)+12>>2]|0,t[o>>2]|0);s=r;return}dn(t[f>>2]|0,11);s=r;return}function ft(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+48|0;f=r;a=r+40|0;o=r+36|0;c=r+32|0;l=r+28|0;b=r+24|0;k=r+20|0;h=r+16|0;w=r+12|0;d=r+44|0;v=r+8|0;m=r+4|0;t[a>>2]=e;t[o>>2]=i;if(!(t[a>>2]|0)){s=r;return}i=t[a>>2]|0;if((t[o>>2]|0)!=3){dn(i,12);s=r;return}o=t[a>>2]|0;if((t[i+20>>2]|0)<((t[(t[a>>2]|0)+44>>2]|0)+3|0)){dn(o,23);s=r;return}if((t[o+16>>2]|0)!=0?(t[t[(t[a>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[a>>2]|0,1);t[b>>2]=En(t[a>>2]|0)|0;if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[t[(t[a>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[a>>2]|0,1);t[l>>2]=En(t[a>>2]|0)|0;if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[t[(t[a>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[a>>2]|0,1);t[c>>2]=En(t[a>>2]|0)|0;t[k>>2]=ds()|0;e:do if(t[k>>2]|0){t[w>>2]=os(t[(t[b>>2]|0)+24>>2]|0)|0;t[m>>2]=t[(t[c>>2]|0)+24>>2];while(1){o=n[t[m>>2]>>0]|0;n[d>>0]=o;if(!(o<<24>>24))break e;t[h>>2]=hs(t[(t[l>>2]|0)+24>>2]|0,t[m>>2]|0)|0;if((t[h>>2]|0)>=0){if((t[h>>2]|0)<(t[w>>2]|0)?(t[v>>2]=ks(t[(t[b>>2]|0)+24>>2]|0,t[h>>2]|0)|0,(t[v>>2]|0)!=0):0){o=t[k>>2]|0;i=t[v>>2]|0;Ps(o,i,ss(t[v>>2]|0,1)|0)|0}}else{i=t[k>>2]|0;o=t[m>>2]|0;Ps(i,o,ss(t[m>>2]|0,1)|0)|0}t[m>>2]=(t[m>>2]|0)+1;if(!((u[d>>0]|0)&128))continue;if(((u[d>>0]|0)&192|0)!=192)break;while(1){o=(u[d>>0]|0)<<1&255;n[d>>0]=o;if(!(o&128))break;o=t[m>>2]|0;t[m>>2]=o+1;if(((u[o>>0]|0)&192|0)!=128){_=28;break}}if((_|0)==28){_=0;yAi[t[135904>>2]&511](t[33980]|0,129184,f)}if((u[d>>0]|0)&128)break e}yAi[t[135904>>2]&511](t[33980]|0,129184,f)}while(0);f=t[a>>2]|0;d=t[(t[a>>2]|0)+12>>2]|0;Sn(f,au(d,Os(t[k>>2]|0)|0)|0)|0;Ss(t[k>>2]|0);zt(t[(t[a>>2]|0)+12>>2]|0,t[c>>2]|0);zt(t[(t[a>>2]|0)+12>>2]|0,t[l>>2]|0);zt(t[(t[a>>2]|0)+12>>2]|0,t[b>>2]|0);s=r;return}function tt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}t[u>>2]=En(f)|0;f=t[n>>2]|0;if(!(t[u>>2]|0)){dn(f,10);s=r;return}else{t[u>>2]=lu(t[f+12>>2]|0,t[u>>2]|0)|0;Sn(t[n>>2]|0,t[u>>2]|0)|0;s=r;return}}function ut(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=2:0)tt(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==2:0){t[(t[(t[n>>2]|0)+16>>2]|0)+8>>2]=((t[(t[(t[n>>2]|0)+16>>2]|0)+8>>2]|0)!=0^1)&1;s=r;return}dn(t[n>>2]|0,11);s=r;return}function at(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(t[f>>2]|0){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+0|0)){dn(f,23);s=r;return}else{Sn(f,cu(t[(t[n>>2]|0)+12>>2]|0,1)|0)|0;s=r;return}}function ot(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(t[f>>2]|0){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+0|0)){dn(f,23);s=r;return}else{Sn(f,cu(t[(t[n>>2]|0)+12>>2]|0,0)|0)|0;s=r;return}}function ct(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=0;t[o>>2]=0;t[l>>2]=0;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==4:0){t[a>>2]=En(t[n>>2]|0)|0;t[c>>2]=t[(t[a>>2]|0)+24>>2];t[o>>2]=fF(t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)|0;e:do if((t[o>>2]|0)!=0&(t[c>>2]|0)!=0){t[b>>2]=0;while(1){k=t[b>>2]|0;if(!(u[(t[c>>2]|0)+(t[b>>2]|0)>>0]|0))break;f=Pq(u[(t[c>>2]|0)+k>>0]|0)|0;if((f|0)!=(Pq(u[(t[o>>2]|0)+(t[b>>2]|0)>>0]|0)|0))break e;t[b>>2]=(t[b>>2]|0)+1}if((u[(t[o>>2]|0)+k>>0]|0|0)!=0?(u[(t[o>>2]|0)+(t[b>>2]|0)>>0]|0|0)!=45:0)break;t[l>>2]=1}while(0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);a=t[n>>2]|0;Sn(a,cu(t[(t[n>>2]|0)+12>>2]|0,t[l>>2]|0)|0)|0;s=r;return}dn(t[n>>2]|0,11);s=r;return}function lt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r;t[n>>2]=e;t[f>>2]=i;l[o>>3]=0;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=9:0)break;t[u>>2]=En(t[n>>2]|0)|0;e:do if((t[(t[u>>2]|0)+4>>2]|0)!=0?(t[t[(t[u>>2]|0)+4>>2]>>2]|0)!=0:0){t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[t[(t[u>>2]|0)+4>>2]>>2]|0))break e;c=+lf(t[(t[(t[(t[u>>2]|0)+4>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0);l[o>>3]=+l[o>>3]+c;t[a>>2]=(t[a>>2]|0)+1}}while(0);i=t[n>>2]|0;Sn(i,eu(t[(t[n>>2]|0)+12>>2]|0,+l[o>>3])|0)|0;zt(t[(t[n>>2]|0)+12>>2]|0,t[u>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function st(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){l[u>>3]=+aY(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3],2147483647);l[u>>3]=+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]-+l[u>>3]+ +(~~+l[u>>3]|0);if(!(+l[u>>3]!=+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3])){s=r;return}a=+l[u>>3];if(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]>0){l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=a;s=r;return}else{l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=a-1;s=r;return}}dn(t[n>>2]|0,11);s=r;return}function bt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){l[u>>3]=+aY(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3],2147483647);l[u>>3]=+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]-+l[u>>3]+ +(~~+l[u>>3]|0);if(!(+l[u>>3]!=+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3])){s=r;return}if(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]>0){l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=+l[u>>3]+1;s=r;return}if(+l[u>>3]==0?+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]<0:0){l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=+l[15988];s=r;return}else{l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=+l[u>>3];s=r;return}}dn(t[n>>2]|0,11);s=r;return}function kt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[n>>2]|0,1);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){if(hn(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3])|0){s=r;return}if((wn(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3])|0)==1){s=r;return}if((wn(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3])|0)==-1){s=r;return}if(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]==0){s=r;return}l[u>>3]=+aY(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3],2147483647);l[u>>3]=+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]-+l[u>>3]+ +(~~+l[u>>3]|0);a=+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3];o=+l[u>>3];if(!(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]<0)){c=+l[u>>3];if(a<o+.5){l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=c;s=r;return}else{l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=c+1;s=r;return}}c=+l[u>>3];if(a<o-.5)l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=c-1;else l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=c;if(!(+l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]==0)){s=r;return}l[(t[(t[n>>2]|0)+16>>2]|0)+16>>3]=+l[15988];s=r;return}dn(t[n>>2]|0,11);s=r;return}function ht(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[o>>2]=0;if((t[n>>2]|0)!=0?(t[t[n>>2]>>2]|0)!=0:0){t[f>>2]=t[t[n>>2]>>2];if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)c=9;else c=6;do if((c|0)==6){if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){c=9;break}if((u[t[f>>2]>>0]|0|0)==95)c=9}while(0);do if((c|0)==9){t[f>>2]=(t[f>>2]|0)+1;while(1){if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)l=1;else c=12;do if((c|0)==12){c=0;if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){l=1;break}if((u[t[f>>2]>>0]|0|0)>=48?(u[t[f>>2]>>0]|0|0)<=57:0){l=1;break}if((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=46:0)l=(u[t[f>>2]>>0]|0|0)==45;else l=1}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if((((((((u[b>>0]|0|0)!=32?(u[t[f>>2]>>0]|0|0)!=62:0)?(u[t[f>>2]>>0]|0|0)!=47:0)?(u[t[f>>2]>>0]|0|0)!=91:0)?(u[t[f>>2]>>0]|0|0)!=93:0)?(u[t[f>>2]>>0]|0|0)!=58:0)?(u[t[f>>2]>>0]|0|0)!=64:0)?(u[t[f>>2]>>0]|0|0)!=42:0)break;t[o>>2]=(t[f>>2]|0)-(t[t[n>>2]>>2]|0);if(!(t[o>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}else{t[a>>2]=ql(t[t[n>>2]>>2]|0,t[o>>2]|0)|0;t[t[n>>2]>>2]=t[f>>2];t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}}while(0);t[r>>2]=su(t[n>>2]|0,0)|0;k=t[r>>2]|0;s=i;return k|0}t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}function wt(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[o>>2]=0;if((t[n>>2]|0)!=0?(t[t[n>>2]>>2]|0)!=0:0){t[f>>2]=t[t[n>>2]>>2];if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)c=10;else c=6;do if((c|0)==6){if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){c=10;break}if(!((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=58:0))c=10}while(0);if((c|0)==10){t[f>>2]=(t[f>>2]|0)+1;while(1){if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)l=1;else c=13;do if((c|0)==13){c=0;if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){l=1;break}if((u[t[f>>2]>>0]|0|0)>=48?(u[t[f>>2]>>0]|0|0)<=57:0){l=1;break}if(((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=45:0)?(u[t[f>>2]>>0]|0|0)!=58:0)l=(u[t[f>>2]>>0]|0|0)==46;else l=1}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if((u[b>>0]|0|0)>0?(u[t[f>>2]>>0]|0|0)<128:0){t[o>>2]=(t[f>>2]|0)-(t[t[n>>2]>>2]|0);if((t[o>>2]|0)>>>0>5e4){t[t[n>>2]>>2]=t[f>>2];dn(t[n>>2]|0,7);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}else{t[a>>2]=ql(t[t[n>>2]>>2]|0,t[o>>2]|0)|0;t[t[n>>2]>>2]=t[f>>2];t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}}}t[r>>2]=su(t[n>>2]|0,1)|0;k=t[r>>2]|0;s=i;return k|0}t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}function dt(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0){if(Xl(t[n>>2]|0,129400)|0){t[r>>2]=1;break}if(Xl(t[n>>2]|0,129408)|0){t[r>>2]=1;break}if(Xl(t[n>>2]|0,129416)|0){t[r>>2]=1;break}if(Xl(t[n>>2]|0,129424)|0){t[r>>2]=1;break}else{t[r>>2]=0;break}}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function vt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,b=0;r=s;s=s+32|0;n=r;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;t[a>>2]=e;t[o>>2]=i;e:do if((t[a>>2]|0)==0|(t[o>>2]|0)==0)t[f>>2]=0;else switch(t[t[o>>2]>>2]|0){case 9:case 1:{if(!(t[(t[o>>2]|0)+4>>2]|0)){t[f>>2]=0;break e}else{t[f>>2]=(t[t[(t[o>>2]|0)+4>>2]>>2]|0)!=0&1;break e}break}case 2:{t[f>>2]=t[(t[o>>2]|0)+8>>2];break e;break}case 7:{t[c>>2]=t[(t[o>>2]|0)+28>>2];if(!(t[c>>2]|0)){t[f>>2]=0;break e}else{t[f>>2]=(t[t[c>>2]>>2]|0)!=0&1;break e}break}case 4:{if(t[(t[o>>2]|0)+24>>2]|0)b=(u[t[(t[o>>2]|0)+24>>2]>>0]|0|0)!=0;else b=0;t[f>>2]=b&1;break e;break}case 3:{t[f>>2]=+l[(t[o>>2]|0)+16>>3]==+(t[(t[(t[a>>2]|0)+12>>2]|0)+72>>2]|0)&1;break e;break}default:{i=t[33976]|0;e=t[33980]|0;t[n>>2]=128552;t[n+4>>2]=14647;yAi[i&511](e,129448,n);t[f>>2]=0;break e}}while(0);s=r;return t[f>>2]|0}function mt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=bu(t[f>>2]|0,t[a>>2]|0)|0;if(t[c>>2]|0){t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}kn();t[o>>2]=mf(t[a>>2]|0,t[f>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}ku(t[o>>2]|0,1);f=t[o>>2]|0;if(t[(t[o>>2]|0)+8>>2]|0){_f(f);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}i=t[o>>2]|0;if(u[t[f>>2]>>0]|0){vn(i,128552,14835,7);t[c>>2]=0}else{t[c>>2]=t[i+32>>2];t[(t[o>>2]|0)+32>>2]=0}_f(t[o>>2]|0);if(((t[c>>2]|0)!=0?(o=Yl(t[a>>2]|0)|0,t[(t[c>>2]|0)+16>>2]=o,(t[t[c>>2]>>2]|0)>1):0)?(t[(t[c>>2]|0)+12>>2]|0)>=0:0)hu(t[c>>2]|0,(t[(t[c>>2]|0)+8>>2]|0)+((t[(t[c>>2]|0)+12>>2]|0)*40|0)|0);t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}function _t(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=0;wu(t[n>>2]|0,t[f>>2]|0,u,0)|0;s=r;return t[u>>2]|0}function pt(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[n>>2]=bu(t[(t[r>>2]|0)+12>>2]|0,t[(t[r>>2]|0)+4>>2]|0)|0;e=t[r>>2]|0;e:do if(t[n>>2]|0){if(t[e+32>>2]|0)mn(t[(t[r>>2]|0)+32>>2]|0);t[(t[r>>2]|0)+32>>2]=t[n>>2];if(t[t[r>>2]>>2]|0)while(1){if(!(u[t[t[r>>2]>>2]>>0]|0))break e;f=t[r>>2]|0;t[f>>2]=(t[f>>2]|0)+1}}else{ku(e,1);if((((t[(t[r>>2]|0)+8>>2]|0)==0?(t[(t[r>>2]|0)+32>>2]|0)!=0:0)?(t[t[(t[r>>2]|0)+32>>2]>>2]|0)>1:0)?(t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0)>=0:0)hu(t[(t[r>>2]|0)+32>>2]|0,(t[(t[(t[r>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0)*40|0)|0)}while(0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}du(t[r>>2]|0,0)|0;s=i;return}function Et(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r;f=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;t[a>>2]=e;t[o>>2]=i;t[k>>2]=0;t[h>>2]=0;if(!(t[o>>2]|0)){cp(0,0,0,0,0,12,1,3,128552,15056,0,0,0,0,0,129480,n);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}kn();t[c>>2]=mf(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}pt(t[c>>2]|0);do if(!(t[(t[c>>2]|0)+16>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,129504,n);t[l>>2]=0}else{if(((u[t[t[c>>2]>>2]>>0]|0|0)!=0?(t[(t[c>>2]|0)+32>>2]|0)!=0:0)?(t[(t[(t[c>>2]|0)+32>>2]|0)+24>>2]|0)==0:0){vn(t[c>>2]|0,128552,15074,7);t[l>>2]=0;break}t[l>>2]=En(t[c>>2]|0)|0}while(0);do{t[b>>2]=En(t[c>>2]|0)|0;if(t[b>>2]|0){if((t[b>>2]|0)!=(t[k>>2]|0))t[h>>2]=(t[h>>2]|0)+1;zt(t[o>>2]|0,t[b>>2]|0)}}while((t[b>>2]|0)!=0);if((t[h>>2]|0)!=0&(t[l>>2]|0)!=0){b=t[33976]|0;o=t[33980]|0;t[n>>2]=t[h>>2];yAi[b&511](o,129544,n)}if(t[(t[c>>2]|0)+8>>2]|0){_n(t[l>>2]|0);t[l>>2]=0}_f(t[c>>2]|0);t[f>>2]=t[l>>2];w=t[f>>2]|0;s=r;return w|0}function St(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+16|0;c=n+8|0;l=n+24|0;b=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=o;t[r>>2]=t[u>>2];t[r+4>>2]=0;while(1){r=o;u=t[r+4>>2]|0;if(!((u|0)<0|((u|0)==0?(t[r>>2]|0)>>>0<(t[a>>2]|0)>>>0:0)))break;r=o;u=BY(t[r>>2]|0,t[r+4>>2]|0,1,0)|0;if((vu(t[(t[f>>2]|0)+(u<<2)>>2]|0,t[(t[f>>2]|0)+(t[o>>2]<<2)>>2]|0)|0)>0){t[l>>2]=t[(t[f>>2]|0)+(t[o>>2]<<2)>>2];u=mu(t[f>>2]|0,t[l>>2]|0,t[o>>2]|0)|0;r=b;t[r>>2]=u;t[r+4>>2]=P;r=o;u=BY(t[r>>2]|0,t[r+4>>2]|0,1,0)|0;r=c;t[r>>2]=u;t[r+4>>2]=P;while(1){r=c;u=t[r+4>>2]|0;i=b;e=t[i+4>>2]|0;if(!((u|0)>(e|0)|((u|0)==(e|0)?(t[r>>2]|0)>>>0>=(t[i>>2]|0)>>>0:0)))break;i=t[(t[f>>2]|0)+(t[c>>2]<<2)>>2]|0;r=c;e=jY(t[r>>2]|0,t[r+4>>2]|0,1,0)|0;t[(t[f>>2]|0)+(e<<2)>>2]=i;i=c;e=jY(t[i>>2]|0,t[i+4>>2]|0,-1,-1)|0;i=c;t[i>>2]=e;t[i+4>>2]=P}t[(t[f>>2]|0)+(t[b>>2]<<2)>>2]=t[l>>2]}i=o;e=jY(t[i>>2]|0,t[i+4>>2]|0,1,0)|0;i=o;t[i>>2]=e;t[i+4>>2]=P}s=n;return}function gt(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;f=s;s=s+48|0;u=f+16|0;a=f+32|0;o=f+8|0;c=f+28|0;l=f;b=f+24|0;t[a>>2]=e;e=o;t[e>>2]=i;t[e+4>>2]=r;t[c>>2]=n;n=o;r=BY(t[c>>2]|0,0,t[n>>2]|0,t[n+4>>2]|0)|0;if((r|0)==1&(P|0)==0){r=u;t[r>>2]=1;t[r+4>>2]=0;k=u;h=k;w=t[h>>2]|0;d=k+4|0;v=d;m=t[v>>2]|0;P=m;s=f;return w|0}r=o;n=t[r>>2]|0;e=t[r+4>>2]|0;r=BY(t[c>>2]|0,0,2,0)|0;i=P;if((e|0)>(i|0)|(e|0)==(i|0)&n>>>0>=r>>>0){if((vu(t[(t[a>>2]|0)+((t[c>>2]|0)-2<<2)>>2]|0,t[(t[a>>2]|0)+((t[c>>2]|0)-1<<2)>>2]|0)|0)>0){t[b>>2]=t[(t[a>>2]|0)+((t[c>>2]|0)-2<<2)>>2];t[(t[a>>2]|0)+((t[c>>2]|0)-2<<2)>>2]=t[(t[a>>2]|0)+((t[c>>2]|0)-1<<2)>>2];t[(t[a>>2]|0)+((t[c>>2]|0)-1<<2)>>2]=t[b>>2]}b=u;t[b>>2]=2;t[b+4>>2]=0;k=u;h=k;w=t[h>>2]|0;d=k+4|0;v=d;m=t[v>>2]|0;P=m;s=f;return w|0}b=o;r=jY(t[b>>2]|0,t[b+4>>2]|0,2,0)|0;b=l;t[b>>2]=r;t[b+4>>2]=P;b=t[(t[a>>2]|0)+(t[o>>2]<<2)>>2]|0;r=o;n=jY(t[r>>2]|0,t[r+4>>2]|0,1,0)|0;if((vu(b,t[(t[a>>2]|0)+(n<<2)>>2]|0)|0)<=0){while(1){n=l;b=t[n>>2]|0;r=t[n+4>>2]|0;n=BY(t[c>>2]|0,0,1,0)|0;if((b|0)==(n|0)&(r|0)==(P|0))break;r=l;n=BY(t[r>>2]|0,t[r+4>>2]|0,1,0)|0;if((vu(t[(t[a>>2]|0)+(n<<2)>>2]|0,t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0)|0)>0)break;n=l;r=jY(t[n>>2]|0,t[n+4>>2]|0,1,0)|0;n=l;t[n>>2]=r;t[n+4>>2]=P}n=l;r=o;b=BY(t[n>>2]|0,t[n+4>>2]|0,t[r>>2]|0,t[r+4>>2]|0)|0;r=u;t[r>>2]=b;t[r+4>>2]=P;k=u;h=k;w=t[h>>2]|0;d=k+4|0;v=d;m=t[v>>2]|0;P=m;s=f;return w|0}else{while(1){r=l;b=t[r>>2]|0;n=t[r+4>>2]|0;r=BY(t[c>>2]|0,0,1,0)|0;if((b|0)==(r|0)&(n|0)==(P|0))break;n=l;r=BY(t[n>>2]|0,t[n+4>>2]|0,1,0)|0;if((vu(t[(t[a>>2]|0)+(r<<2)>>2]|0,t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0)|0)<=0)break;r=l;n=jY(t[r>>2]|0,t[r+4>>2]|0,1,0)|0;r=l;t[r>>2]=n;t[r+4>>2]=P}c=t[a>>2]|0;a=o;r=t[a>>2]|0;n=t[a+4>>2]|0;a=l;b=BY(t[a>>2]|0,t[a+4>>2]|0,1,0)|0;_u(c,r,n,b,P);b=l;l=o;o=BY(t[b>>2]|0,t[b+4>>2]|0,t[l>>2]|0,t[l+4>>2]|0)|0;l=u;t[l>>2]=o;t[l+4>>2]=P;k=u;h=k;w=t[h>>2]|0;d=k+4|0;v=d;m=t[v>>2]|0;P=m;s=f;return w|0}return 0}function yt(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;f=s;s=s+80|0;u=f+64|0;a=f+60|0;o=f+56|0;c=f+52|0;l=f+40|0;b=f+32|0;k=f+24|0;h=f+48|0;w=f+16|0;d=f+8|0;v=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=(t[a>>2]|0)+((t[o>>2]|0)-2<<4)+8|0;r=t[n+4>>2]|0;i=l;t[i>>2]=t[n>>2];t[i+4>>2]=r;r=(t[a>>2]|0)+((t[o>>2]|0)-1<<4)+8|0;i=t[r+4>>2]|0;n=b;t[n>>2]=t[r>>2];t[n+4>>2]=i;i=(t[a>>2]|0)+((t[o>>2]|0)-2<<4)|0;o=t[i+4>>2]|0;a=k;t[a>>2]=t[i>>2];t[a+4>>2]=o;o=t[c>>2]|0;a=l;i=t[a+4>>2]|0;n=b;r=t[n+4>>2]|0;e=(i|0)<(r|0)|((i|0)==(r|0)?(t[a>>2]|0)>>>0<(t[n>>2]|0)>>>0:0);n=l;a=t[n+4>>2]|0;a=b;r=t[a+4>>2]|0;r=e?t[n>>2]|0:t[a>>2]|0;pu(o,r);t[h>>2]=t[(t[c>>2]|0)+4>>2];c=l;r=t[c+4>>2]|0;o=b;a=t[o+4>>2]|0;n=t[h>>2]|0;e=k;i=t[e>>2]|0;m=t[e+4>>2]|0;if((r|0)<(a|0)|((r|0)==(a|0)?(t[c>>2]|0)>>>0<(t[o>>2]|0)>>>0:0)){o=(t[u>>2]|0)+(i<<2)|0;c=l;a=$Y(t[c>>2]|0,t[c+4>>2]|0,4,0)|0;YY(n|0,o|0,a|0)|0;a=w;t[a>>2]=0;t[a+4>>2]=0;a=k;o=l;c=jY(t[a>>2]|0,t[a+4>>2]|0,t[o>>2]|0,t[o+4>>2]|0)|0;o=d;t[o>>2]=c;t[o+4>>2]=P;o=k;c=t[o+4>>2]|0;a=v;t[a>>2]=t[o>>2];t[a+4>>2]=c;while(1){c=v;a=t[c>>2]|0;o=t[c+4>>2]|0;c=k;r=l;e=jY(t[c>>2]|0,t[c+4>>2]|0,t[r>>2]|0,t[r+4>>2]|0)|0;r=b;c=jY(e|0,P|0,t[r>>2]|0,t[r+4>>2]|0)|0;r=P;if(!((o|0)<(r|0)|(o|0)==(r|0)&a>>>0<c>>>0))break;c=w;a=t[c+4>>2]|0;r=l;o=t[r+4>>2]|0;do if((a|0)<(o|0)|((a|0)==(o|0)?(t[c>>2]|0)>>>0<(t[r>>2]|0)>>>0:0)?(e=d,_=t[e>>2]|0,p=t[e+4>>2]|0,e=k,E=l,S=jY(t[e>>2]|0,t[e+4>>2]|0,t[E>>2]|0,t[E+4>>2]|0)|0,E=b,e=jY(S|0,P|0,t[E>>2]|0,t[E+4>>2]|0)|0,E=P,(p|0)<(E|0)|(p|0)==(E|0)&_>>>0<e>>>0):0)if((vu(t[(t[h>>2]|0)+(t[w>>2]<<2)>>2]|0,t[(t[u>>2]|0)+(t[d>>2]<<2)>>2]|0)|0)<=0){e=w;_=t[e>>2]|0;E=jY(_|0,t[e+4>>2]|0,1,0)|0;e=w;t[e>>2]=E;t[e+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[h>>2]|0)+(_<<2)>>2];break}else{_=d;e=t[_>>2]|0;E=jY(e|0,t[_+4>>2]|0,1,0)|0;_=d;t[_>>2]=E;t[_+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[u>>2]|0)+(e<<2)>>2];break}else g=9;while(0);do if((g|0)==9){g=0;r=w;c=t[r+4>>2]|0;o=l;a=t[o+4>>2]|0;if((c|0)<(a|0)|((c|0)==(a|0)?(t[r>>2]|0)>>>0<(t[o>>2]|0)>>>0:0)){o=w;r=t[o>>2]|0;a=jY(r|0,t[o+4>>2]|0,1,0)|0;o=w;t[o>>2]=a;t[o+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[h>>2]|0)+(r<<2)>>2];break}else{r=d;o=t[r>>2]|0;a=jY(o|0,t[r+4>>2]|0,1,0)|0;r=d;t[r>>2]=a;t[r+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[u>>2]|0)+(o<<2)>>2];break}}while(0);o=v;r=jY(t[o>>2]|0,t[o+4>>2]|0,1,0)|0;o=v;t[o>>2]=r;t[o+4>>2]=P}s=f;return}else{o=l;r=jY(i|0,m|0,t[o>>2]|0,t[o+4>>2]|0)|0;o=(t[u>>2]|0)+(r<<2)|0;r=b;m=$Y(t[r>>2]|0,t[r+4>>2]|0,4,0)|0;YY(n|0,o|0,m|0)|0;m=b;o=BY(t[m>>2]|0,t[m+4>>2]|0,1,0)|0;m=w;t[m>>2]=o;t[m+4>>2]=P;m=k;o=l;n=jY(t[m>>2]|0,t[m+4>>2]|0,t[o>>2]|0,t[o+4>>2]|0)|0;o=BY(n|0,P|0,1,0)|0;n=d;t[n>>2]=o;t[n+4>>2]=P;n=k;o=l;l=jY(t[n>>2]|0,t[n+4>>2]|0,t[o>>2]|0,t[o+4>>2]|0)|0;o=b;b=jY(l|0,P|0,t[o>>2]|0,t[o+4>>2]|0)|0;o=BY(b|0,P|0,1,0)|0;b=v;t[b>>2]=o;t[b+4>>2]=P;while(1){b=v;o=t[b+4>>2]|0;l=k;n=t[l+4>>2]|0;if(!((o|0)>(n|0)|((o|0)==(n|0)?(t[b>>2]|0)>>>0>=(t[l>>2]|0)>>>0:0)))break;l=w;b=t[l+4>>2]|0;do if((b|0)>0|(b|0)==0&(t[l>>2]|0)>>>0>=0?(n=d,o=t[n+4>>2]|0,m=k,r=t[m+4>>2]|0,(o|0)>(r|0)|((o|0)==(r|0)?(t[n>>2]|0)>>>0>=(t[m>>2]|0)>>>0:0)):0)if((vu(t[(t[u>>2]|0)+(t[d>>2]<<2)>>2]|0,t[(t[h>>2]|0)+(t[w>>2]<<2)>>2]|0)|0)>0){m=d;n=t[m>>2]|0;r=jY(n|0,t[m+4>>2]|0,-1,-1)|0;m=d;t[m>>2]=r;t[m+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[u>>2]|0)+(n<<2)>>2];break}else{n=w;m=t[n>>2]|0;r=jY(m|0,t[n+4>>2]|0,-1,-1)|0;n=w;t[n>>2]=r;t[n+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[h>>2]|0)+(m<<2)>>2];break}else g=20;while(0);do if((g|0)==20){g=0;l=w;b=t[l+4>>2]|0;if((b|0)>0|(b|0)==0&(t[l>>2]|0)>>>0>=0){l=w;b=t[l>>2]|0;m=jY(b|0,t[l+4>>2]|0,-1,-1)|0;l=w;t[l>>2]=m;t[l+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[h>>2]|0)+(b<<2)>>2];break}else{b=d;l=t[b>>2]|0;m=jY(l|0,t[b+4>>2]|0,-1,-1)|0;b=d;t[b>>2]=m;t[b+4>>2]=P;t[(t[u>>2]|0)+(t[v>>2]<<2)>>2]=t[(t[u>>2]|0)+(l<<2)>>2];break}}while(0);l=v;b=jY(t[l>>2]|0,t[l+4>>2]|0,-1,-1)|0;l=v;t[l>>2]=b;t[l+4>>2]=P}s=f;return}}function Ft(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+64|0;n=r+48|0;f=r+44|0;u=r+40|0;a=r+32|0;o=r+24|0;c=r+16|0;l=r+8|0;b=r;t[f>>2]=e;t[u>>2]=i;if((t[u>>2]|0)<2){t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}i=t[u>>2]|0;if((t[u>>2]|0)==2){e=(t[f>>2]|0)+(i-2<<4)+8|0;h=t[e+4>>2]|0;w=l;t[w>>2]=t[e>>2];t[w+4>>2]=h;h=(t[f>>2]|0)+((t[u>>2]|0)-1<<4)+8|0;w=t[h+4>>2]|0;e=b;t[e>>2]=t[h>>2];t[e+4>>2]=w;w=l;l=t[w+4>>2]|0;e=b;b=t[e+4>>2]|0;if((l|0)<(b|0)|((l|0)==(b|0)?(t[w>>2]|0)>>>0<=(t[e>>2]|0)>>>0:0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else{t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}}e=(t[f>>2]|0)+(i-3<<4)+8|0;i=t[e+4>>2]|0;w=a;t[w>>2]=t[e>>2];t[w+4>>2]=i;i=(t[f>>2]|0)+((t[u>>2]|0)-2<<4)+8|0;w=t[i+4>>2]|0;e=o;t[e>>2]=t[i>>2];t[e+4>>2]=w;w=(t[f>>2]|0)+((t[u>>2]|0)-1<<4)+8|0;u=t[w+4>>2]|0;f=c;t[f>>2]=t[w>>2];t[f+4>>2]=u;u=a;a=t[u>>2]|0;f=t[u+4>>2]|0;u=o;w=c;e=jY(t[u>>2]|0,t[u+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=P;if(!((f|0)<(w|0)|(f|0)==(w|0)&a>>>0<=e>>>0)?(e=o,o=t[e+4>>2]|0,a=c,c=t[a+4>>2]|0,!((o|0)<(c|0)|((o|0)==(c|0)?(t[e>>2]|0)>>>0<=(t[a>>2]|0)>>>0:0))):0){t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}function Ot(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;u=s;s=s+48|0;a=u+40|0;o=u+36|0;c=u+32|0;l=u+28|0;b=u+24|0;k=u+16|0;h=u+8|0;w=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;while(1){if((t[c>>2]|0)<=1){d=16;break}if((t[c>>2]|0)==2?(f=(t[o>>2]|0)+8|0,n=(t[o>>2]|0)+24|0,r=jY(t[f>>2]|0,t[f+4>>2]|0,t[n>>2]|0,t[n+4>>2]|0)|0,(P|0)==0?(r|0)==(t[b>>2]|0):0):0){d=5;break}if((t[c>>2]|0)==2?(r=(t[o>>2]|0)+8|0,n=t[r+4>>2]|0,f=(t[o>>2]|0)+24|0,i=t[f+4>>2]|0,(n|0)<(i|0)|((n|0)==(i|0)?(t[r>>2]|0)>>>0<=(t[f>>2]|0)>>>0:0)):0){d=8;break}if((t[c>>2]|0)==2){d=16;break}f=(t[o>>2]|0)+((t[c>>2]|0)-3<<4)+8|0;r=t[f+4>>2]|0;i=k;t[i>>2]=t[f>>2];t[i+4>>2]=r;r=(t[o>>2]|0)+((t[c>>2]|0)-2<<4)+8|0;i=t[r+4>>2]|0;f=h;t[f>>2]=t[r>>2];t[f+4>>2]=i;i=(t[o>>2]|0)+((t[c>>2]|0)-1<<4)+8|0;f=t[i+4>>2]|0;r=w;t[r>>2]=t[i>>2];t[r+4>>2]=f;f=k;r=t[f>>2]|0;i=t[f+4>>2]|0;f=h;n=w;e=jY(t[f>>2]|0,t[f+4>>2]|0,t[n>>2]|0,t[n+4>>2]|0)|0;n=P;if(!((i|0)<(n|0)|(i|0)==(n|0)&r>>>0<=e>>>0)){e=h;r=t[e+4>>2]|0;n=w;i=t[n+4>>2]|0;if(!((r|0)<(i|0)|((r|0)==(i|0)?(t[e>>2]|0)>>>0<=(t[n>>2]|0)>>>0:0))){d=16;break}yt(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);n=(t[o>>2]|0)+((t[c>>2]|0)-1<<4)+8|0;e=(t[o>>2]|0)+((t[c>>2]|0)-2<<4)+8|0;i=e;r=jY(t[i>>2]|0,t[i+4>>2]|0,t[n>>2]|0,t[n+4>>2]|0)|0;n=e;t[n>>2]=r;t[n+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1;continue}n=k;r=t[n+4>>2]|0;e=w;i=t[e+4>>2]|0;f=t[a>>2]|0;v=t[o>>2]|0;m=t[c>>2]|0;if((r|0)<(i|0)|((r|0)==(i|0)?(t[n>>2]|0)>>>0<(t[e>>2]|0)>>>0:0)){yt(f,v,m-1|0,t[l>>2]|0);e=(t[o>>2]|0)+((t[c>>2]|0)-2<<4)+8|0;n=(t[o>>2]|0)+((t[c>>2]|0)-3<<4)+8|0;i=n;r=jY(t[i>>2]|0,t[i+4>>2]|0,t[e>>2]|0,t[e+4>>2]|0)|0;e=n;t[e>>2]=r;t[e+4>>2]=P;e=(t[o>>2]|0)+((t[c>>2]|0)-2<<4)|0;r=(t[o>>2]|0)+((t[c>>2]|0)-1<<4)|0;t[e+0>>2]=t[r+0>>2];t[e+4>>2]=t[r+4>>2];t[e+8>>2]=t[r+8>>2];t[e+12>>2]=t[r+12>>2];t[c>>2]=(t[c>>2]|0)+-1;continue}else{yt(f,v,m,t[l>>2]|0);m=(t[o>>2]|0)+((t[c>>2]|0)-1<<4)+8|0;v=(t[o>>2]|0)+((t[c>>2]|0)-2<<4)+8|0;f=v;r=jY(t[f>>2]|0,t[f+4>>2]|0,t[m>>2]|0,t[m+4>>2]|0)|0;m=v;t[m>>2]=r;t[m+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1;continue}}if((d|0)==5){yt(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);w=(t[o>>2]|0)+24|0;k=(t[o>>2]|0)+8|0;h=k;b=jY(t[h>>2]|0,t[h+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=k;t[w>>2]=b;t[w+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1;_=t[c>>2]|0;s=u;return _|0}else if((d|0)==8){yt(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);l=(t[o>>2]|0)+24|0;a=(t[o>>2]|0)+8|0;o=a;w=jY(t[o>>2]|0,t[o+4>>2]|0,t[l>>2]|0,t[l+4>>2]|0)|0;l=a;t[l>>2]=w;t[l+4>>2]=P;t[c>>2]=(t[c>>2]|0)+-1;_=t[c>>2]|0;s=u;return _|0}else if((d|0)==16){_=t[c>>2]|0;s=u;return _|0}return 0}function At(){var e=0;e=s;if(+l[16480]==0)l[16480]=+Eu(131848);s=e;return+ +l[16480]}function Mt(){var e=0;e=s;if(+l[16479]==0)l[16479]=-+At();s=e;return+ +l[16479]}function Rt(){var e=0;e=s;if(+l[16478]==0)l[16478]=+bY(128928);s=e;return+ +l[16478]}function Nt(){var e=0,i=0;e=s;i=+Eu(131808);s=e;return+i}function Tt(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;l[r>>3]=e;n=Su(+l[r>>3])|0;r=P&2147483647;s=i;return(r>>>0>2146435072|(r|0)==2146435072&n>>>0>0)&1|0}function Lt(e){e=+e;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;l[r>>3]=e;n=Su(+l[r>>3])|0;if(!((n|0)==0&(P&2147483647|0)==2146435072)){f=0;s=i;return f|0}f=+l[r>>3]>0?1:-1;s=i;return f|0}function Dt(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[t[r>>2]>>2]|0))break;do if(t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0){e=t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0;if((t[(t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0)+4>>2]|0)==18){Rn(e);break}else{ty(e);break}}while(0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Ct(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+128|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f+20|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;while(1){k=b+((t[l>>2]<<1)+1)|0;if(!((t[l>>2]|0)<25?(t[l>>2]|0)<(t[c>>2]|0):0))break;n[k>>0]=32;n[b+(t[l>>2]<<1)>>0]=32;t[l>>2]=(t[l>>2]|0)+1}n[k>>0]=0;n[b+(t[l>>2]<<1)>>0]=0;if(!(t[o>>2]|0)){k=t[a>>2]|0;t[u>>2]=b;xe(k|0,127912,u|0)|0;xe(t[a>>2]|0,131120,u|0)|0;s=f;return}if(!(t[o>>2]|0)){s=f;return}k=t[a>>2]|0;t[u>>2]=t[t[o>>2]>>2];xe(k|0,131144,u|0)|0;t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[t[o>>2]>>2]|0))break;k=t[a>>2]|0;t[u>>2]=b;xe(k|0,127912,u|0)|0;k=t[a>>2]|0;t[u>>2]=(t[l>>2]|0)+1;xe(k|0,130840,u|0)|0;It(t[a>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0,(t[c>>2]|0)+1|0);t[l>>2]=(t[l>>2]|0)+1}s=f;return}function Pt(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+128|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f+20|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;while(1){k=b+((t[l>>2]<<1)+1)|0;if(!((t[l>>2]|0)<25?(t[l>>2]|0)<(t[c>>2]|0):0))break;n[k>>0]=32;n[b+(t[l>>2]<<1)>>0]=32;t[l>>2]=(t[l>>2]|0)+1}n[k>>0]=0;n[b+(t[l>>2]<<1)>>0]=0;if(((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)!=0:0)?(t[t[(t[o>>2]|0)+8>>2]>>2]|0)!=0:0){
	k=t[a>>2]|0;t[u>>2]=b;xe(k|0,127912,u|0)|0;k=t[a>>2]|0;t[u>>2]=(t[l>>2]|0)+1;xe(k|0,130840,u|0)|0;yu(t[a>>2]|0,t[(t[t[(t[o>>2]|0)+8>>2]>>2]|0)+12>>2]|0,(t[c>>2]|0)+1|0);s=f;return}c=t[a>>2]|0;t[u>>2]=b;xe(c|0,127912,u|0)|0;xe(t[a>>2]|0,131096,u|0)|0;s=f;return}function Bt(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;l[r>>3]=e;n=Fu(+l[r>>3])|0;s=i;return n|0}function It(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+128|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f+20|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;while(1){k=b+((t[l>>2]<<1)+1)|0;if(!((t[l>>2]|0)<25?(t[l>>2]|0)<(t[c>>2]|0):0))break;n[k>>0]=32;n[b+(t[l>>2]<<1)>>0]=32;t[l>>2]=(t[l>>2]|0)+1}n[k>>0]=0;n[b+(t[l>>2]<<1)>>0]=0;if(!(t[o>>2]|0)){l=t[a>>2]|0;t[u>>2]=b;xe(l|0,127912,u|0)|0;xe(t[a>>2]|0,131072,u|0)|0;s=f;return}if((t[(t[o>>2]|0)+4>>2]|0)!=9?(t[(t[o>>2]|0)+4>>2]|0)!=13:0){l=t[a>>2]|0;k=t[o>>2]|0;if((t[(t[o>>2]|0)+4>>2]|0)==2){lr(l,k,t[c>>2]|0);s=f;return}else{br(l,k,t[c>>2]|0);s=f;return}}c=t[a>>2]|0;t[u>>2]=b;xe(c|0,127912,u|0)|0;xe(t[a>>2]|0,131088,u|0)|0;s=f;return}function Ht(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+128|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f+20|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;while(1){k=b+((t[l>>2]<<1)+1)|0;if(!((t[l>>2]|0)<25?(t[l>>2]|0)<(t[c>>2]|0):0))break;n[k>>0]=32;n[b+(t[l>>2]<<1)>>0]=32;t[l>>2]=(t[l>>2]|0)+1}n[k>>0]=0;n[b+(t[l>>2]<<1)>>0]=0;if(!(t[o>>2]|0)){k=t[a>>2]|0;t[u>>2]=b;xe(k|0,127912,u|0)|0;xe(t[a>>2]|0,131040,u|0)|0;s=f;return}t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[t[o>>2]>>2]|0))break;k=t[a>>2]|0;t[u>>2]=b;xe(k|0,127912,u|0)|0;k=t[a>>2]|0;t[u>>2]=(t[l>>2]|0)+1;xe(k|0,131064,u|0)|0;pn(t[a>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0,(t[c>>2]|0)+1|0);t[l>>2]=(t[l>>2]|0)+1}s=f;return}function xt(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)Ou(t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+4>>2]|0)Ou(t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)Ou(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)Ou(t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)Ou(t[(t[r>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Ut(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+224|0;n=r;f=r+8|0;u=r+4|0;a=r+16|0;t[f>>2]=e;t[u>>2]=i;i=(t[u>>2]|0)!=0;if(!(t[f>>2]|0))if(i){e=t[u>>2]|0;t[n>>2]=t[u>>2];cp(0,0,0,0,0,12,2,3,0,0,e,0,0,0,0,130976,n);s=r;return}else{cp(0,0,0,0,0,12,2,3,0,0,0,0,0,0,0,131008,n);s=r;return}if(i){t[n>>2]=t[u>>2];as(a,200,130976,n)|0;n=Yl(a)|0;t[(t[f>>2]|0)+144>>2]=n}else{n=Yl(131008)|0;t[(t[f>>2]|0)+144>>2]=n}t[(t[f>>2]|0)+136>>2]=12;t[(t[f>>2]|0)+140>>2]=2;if(!(t[(t[f>>2]|0)+132>>2]|0)){s=r;return}EAi[t[(t[f>>2]|0)+132>>2]&511](t[(t[f>>2]|0)+128>>2]|0,(t[f>>2]|0)+136|0);s=r;return}function zt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+200>>2]|0)!=0:0){t[u>>2]=t[(t[n>>2]|0)+200>>2];e:do switch(t[t[f>>2]>>2]|0){case 3:{if((t[(t[u>>2]|0)+12>>2]|0)!=0?(t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)>=(t[(t[u>>2]|0)+32>>2]|0):0){l=35;break e}if((t[(t[u>>2]|0)+12>>2]|0)==0?(n=Au(10)|0,t[(t[u>>2]|0)+12>>2]=n,(t[(t[u>>2]|0)+12>>2]|0)==0):0){l=54;break e}if((Mu(t[(t[u>>2]|0)+12>>2]|0,t[f>>2]|0,0)|0)==-1)l=54;break}case 7:{if(t[(t[f>>2]|0)+28>>2]|0){Ba(t[(t[f>>2]|0)+28>>2]|0);l=54}else l=54;break}case 2:{if((t[(t[u>>2]|0)+8>>2]|0)!=0?(t[(t[(t[u>>2]|0)+8>>2]|0)+4>>2]|0)>=(t[(t[u>>2]|0)+28>>2]|0):0){l=35;break e}if((t[(t[u>>2]|0)+8>>2]|0)==0?(n=Au(10)|0,t[(t[u>>2]|0)+8>>2]=n,(t[(t[u>>2]|0)+8>>2]|0)==0):0){l=54;break e}if((Mu(t[(t[u>>2]|0)+8>>2]|0,t[f>>2]|0,0)|0)==-1)l=54;break}case 9:case 1:{if(t[(t[f>>2]|0)+4>>2]|0){n=t[f>>2]|0;if(t[(t[f>>2]|0)+8>>2]|0){t[n>>2]=9;Dt(t[(t[f>>2]|0)+4>>2]|0);t[(t[f>>2]|0)+4>>2]=0;l=35;break e}do if((t[(t[n+4>>2]|0)+4>>2]|0)<=40){if((t[t[u>>2]>>2]|0)!=0?(t[(t[t[u>>2]>>2]|0)+4>>2]|0)>=(t[(t[u>>2]|0)+20>>2]|0):0)break;if((t[t[u>>2]>>2]|0)==0?(i=Au(10)|0,t[t[u>>2]>>2]=i,(t[t[u>>2]>>2]|0)==0):0){l=54;break e}if((Mu(t[t[u>>2]>>2]|0,t[f>>2]|0,0)|0)==-1){l=54;break e}else break e}while(0);Bn(t[(t[f>>2]|0)+4>>2]|0);t[(t[f>>2]|0)+4>>2]=0;l=35}else l=35;break}case 4:{if(t[(t[f>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+24>>2]|0);if((t[(t[u>>2]|0)+4>>2]|0)!=0?(t[(t[(t[u>>2]|0)+4>>2]|0)+4>>2]|0)>=(t[(t[u>>2]|0)+24>>2]|0):0){l=35;break e}if((t[(t[u>>2]|0)+4>>2]|0)==0?(n=Au(10)|0,t[(t[u>>2]|0)+4>>2]=n,(t[(t[u>>2]|0)+4>>2]|0)==0):0){l=54;break e}if((Mu(t[(t[u>>2]|0)+4>>2]|0,t[f>>2]|0,0)|0)==-1)l=54;break}default:l=54}while(0);do if((l|0)==35){if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)>=(t[(t[u>>2]|0)+36>>2]|0):0){l=54;break}if((t[(t[u>>2]|0)+16>>2]|0)==0?(n=Au(10)|0,t[(t[u>>2]|0)+16>>2]=n,(t[(t[u>>2]|0)+16>>2]|0)==0):0){l=54;break}if((Mu(t[(t[u>>2]|0)+16>>2]|0,t[f>>2]|0,0)|0)==-1)l=54}while(0);if((l|0)==54){if(t[(t[f>>2]|0)+4>>2]|0)Bn(t[(t[f>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}l=t[f>>2]|0;if(!(t[(t[f>>2]|0)+4>>2]|0)){b=l+0|0;k=b+48|0;do{t[b>>2]=0;b=b+4|0}while((b|0)<(k|0));s=r;return}t[a>>2]=t[l+4>>2];e:do if((t[t[a>>2]>>2]|0)<=1){if(((t[t[a>>2]>>2]|0)==1?(t[t[(t[a>>2]|0)+8>>2]>>2]|0)!=0:0)?(t[(t[t[(t[a>>2]|0)+8>>2]>>2]|0)+4>>2]|0)==18:0)Rn(t[t[(t[a>>2]|0)+8>>2]>>2]|0)}else{t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[t[a>>2]>>2]|0))break e;t[c>>2]=t[(t[(t[a>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2];if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==18:0)Rn(t[c>>2]|0);t[o>>2]=(t[o>>2]|0)+1}}while(0);t[t[a>>2]>>2]=0;b=(t[f>>2]|0)+0|0;k=b+48|0;do{t[b>>2]=0;b=b+4|0}while((b|0)<(k|0));t[(t[f>>2]|0)+4>>2]=t[a>>2];s=r;return}_n(t[f>>2]|0);s=r;return}function jt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)==18:0){if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){t[a>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[a>>2]|0)){Ut(0,130952);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=t[a>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[i+8>>2]=0;t[i+12>>2]=0;t[i+16>>2]=0;t[i+20>>2]=0;t[(t[a>>2]|0)+4>>2]=18;if(t[(t[u>>2]|0)+8>>2]|0){i=Yl(t[(t[u>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=i}if(t[(t[u>>2]|0)+12>>2]|0){i=Yl(t[(t[u>>2]|0)+12>>2]|0)|0;t[(t[a>>2]|0)+12>>2]=i}t[t[a>>2]>>2]=t[f>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Vt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;e:do if(!(t[u>>2]|0))t[n>>2]=0;else{do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){i=t[t[u>>2]>>2]|0;if((i|0)==4){t[n>>2]=au(t[f>>2]|0,t[(t[u>>2]|0)+24>>2]|0)|0;break e}else if((i|0)==3){t[n>>2]=eu(t[f>>2]|0,+l[(t[u>>2]|0)+16>>3])|0;break e}else if((i|0)==2){t[n>>2]=cu(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;break e}else if((i|0)==1){i=t[f>>2]|0;t[n>>2]=fu(i,Pn(0,t[(t[u>>2]|0)+4>>2]|0)|0)|0;break e}else break}while(0);t[n>>2]=nf(t[u>>2]|0)|0}while(0);s=r;return t[n>>2]|0}function qt(e,i,r){e=+e;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,b=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;f=s;s=s+144|0;u=f+16|0;a=f+8|0;o=f+68|0;c=f+64|0;b=f+100|0;h=f+60|0;w=f+56|0;d=f+52|0;v=f+72|0;m=f+48|0;_=f+44|0;p=f+40|0;E=f+36|0;S=f;g=f+32|0;l[a>>3]=e;t[o>>2]=i;t[c>>2]=r;r=wn(+l[a>>3])|0;if((r|0)==-1){if((t[c>>2]|0)<=10){s=f;return}SY(t[o>>2]|0,t[c>>2]|0,129032,u)|0;s=f;return}else if((r|0)==1){if((t[c>>2]|0)<=9){s=f;return}SY(t[o>>2]|0,t[c>>2]|0,129016,u)|0;s=f;return}else{if(hn(+l[a>>3])|0){if((t[c>>2]|0)<=4){s=f;return}SY(t[o>>2]|0,t[c>>2]|0,129048,u)|0;s=f;return}if(+l[a>>3]==0?(Bt(+l[a>>3])|0)!=0:0){SY(t[o>>2]|0,t[c>>2]|0,129056,u)|0;s=f;return}e=+l[a>>3];if(+l[a>>3]==+(~~+l[a>>3]|0)){t[d>>2]=~~e;t[h>>2]=t[o>>2];e:do if(!(t[d>>2]|0)){r=t[h>>2]|0;t[h>>2]=r+1;n[r>>0]=48}else{t[u>>2]=t[d>>2];SY(b,29,130840,u)|0;t[w>>2]=b;while(1){if(!(n[t[w>>2]>>0]|0))break e;if(((t[h>>2]|0)-(t[o>>2]|0)|0)>=(t[c>>2]|0))break e;r=t[w>>2]|0;t[w>>2]=r+1;i=n[r>>0]|0;r=t[h>>2]|0;t[h>>2]=r+1;n[r>>0]=i}}while(0);if(((t[h>>2]|0)-(t[o>>2]|0)|0)<(t[c>>2]|0)){n[t[h>>2]>>0]=0;s=f;return}if((t[c>>2]|0)<=0){s=f;return}t[h>>2]=(t[h>>2]|0)+-1;n[t[h>>2]>>0]=0;s=f;return}l[S>>3]=+G(+e);e:do if((+l[S>>3]>1e9|+l[S>>3]<1e-5)&+l[S>>3]!=0){t[m>>2]=21;t[_>>2]=14;h=t[_>>2]|0;e=+l[a>>3];t[u>>2]=t[m>>2];t[u+4>>2]=h;h=u+8|0;l[k>>3]=e;t[h>>2]=t[k>>2];t[h+4>>2]=t[k+4>>2];t[g>>2]=SY(v,28,130848,u)|0;while(1){if((t[g>>2]|0)<=0)break e;if((n[v+(t[g>>2]|0)>>0]|0)==101)break e;t[g>>2]=(t[g>>2]|0)+-1}}else{do if(+l[S>>3]>0){t[m>>2]=~~+sY(+l[S>>3]);h=15-(t[m>>2]|0)|0;if((t[m>>2]|0)>0){t[_>>2]=h-1;break}else{t[_>>2]=h;break}}else t[_>>2]=1;while(0);e=+l[a>>3];t[u>>2]=t[_>>2];h=u+4|0;l[k>>3]=e;t[h>>2]=t[k>>2];t[h+4>>2]=t[k+4>>2];t[g>>2]=SY(v,28,130856,u)|0}while(0);while(1){if((n[v>>0]|0)!=32)break;t[p>>2]=v;while(1){u=n[(t[p>>2]|0)+1>>0]|0;n[t[p>>2]>>0]=u;if(!(u<<24>>24))break;t[p>>2]=(t[p>>2]|0)+1}t[g>>2]=(t[g>>2]|0)+-1}t[E>>2]=v+(t[g>>2]|0);t[p>>2]=t[E>>2];do{u=(t[p>>2]|0)+-1|0;t[p>>2]=u}while((n[u>>0]|0)==48);if((n[t[p>>2]>>0]|0)!=46)t[p>>2]=(t[p>>2]|0)+1;do{u=t[E>>2]|0;t[E>>2]=u+1;_=n[u>>0]|0;u=t[p>>2]|0;t[p>>2]=u+1;n[u>>0]=_}while((_<<24>>24|0)!=0);t[g>>2]=(HY(v|0)|0)+1;if((t[g>>2]|0)>(t[c>>2]|0)){n[v+((t[c>>2]|0)-1)>>0]=0;t[g>>2]=t[c>>2]}GY(t[o>>2]|0,v|0,t[g>>2]|0)|0;s=f;return}}function Yt(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){i=t[n>>2]|0;Sn(i,ru(t[(t[n>>2]|0)+12>>2]|0,t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;t[f>>2]=1}if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=9:0)break;t[a>>2]=En(t[n>>2]|0)|0;do if((t[(t[a>>2]|0)+4>>2]|0)!=0?(t[t[(t[a>>2]|0)+4>>2]>>2]|0)!=0:0){t[o>>2]=0;if(((t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+4>>2]|0)+-1|0)>>>0>=2){i=t[n>>2]|0;Sn(i,ru(t[(t[n>>2]|0)+12>>2]|0,t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)|0)|0;Wf(t[n>>2]|0,1);break}if((u[t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]>>0]|0|0)==32){i=t[n>>2]|0;Sn(i,uu(t[(t[n>>2]|0)+12>>2]|0,128928)|0)|0;break}if((t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+36>>2]|0)!=0?(t[(t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[c>>2]=Ug(t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]|0,t[(t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+36>>2]|0)+12>>2]|0,0,0)|0;if((t[c>>2]|0)==(t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]|0))t[c>>2]=Yl(t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]|0)|0;i=t[n>>2]|0;if(t[c>>2]|0){Sn(i,ou(t[(t[n>>2]|0)+12>>2]|0,t[c>>2]|0)|0)|0;break}dn(i,15);s=r;return}i=t[n>>2]|0;Sn(i,au(t[(t[n>>2]|0)+12>>2]|0,t[(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+8>>2]|0)|0)|0}else l=14;while(0);if((l|0)==14){i=t[n>>2]|0;Sn(i,uu(t[(t[n>>2]|0)+12>>2]|0,128928)|0)|0}zt(t[(t[n>>2]|0)+12>>2]|0,t[a>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Gt(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;k=r+24|0;t[f>>2]=e;t[a>>2]=i;if(!(t[f>>2]|0)){s=r;return}i=t[f>>2]|0;if((t[a>>2]|0)!=2){dn(i,12);s=r;return}a=t[f>>2]|0;if((t[i+20>>2]|0)<((t[(t[f>>2]|0)+44>>2]|0)+2|0)){dn(a,23);s=r;return}t[c>>2]=gn(a)|0;if((t[(t[f>>2]|0)+16>>2]|0)!=0?(t[t[(t[f>>2]|0)+16>>2]>>2]|0)!=4:0)Xf(t[f>>2]|0,1);t[o>>2]=En(t[f>>2]|0)|0;t[l>>2]=ds()|0;n[k>>0]=37;n[k+3>>0]=0;e:do if(t[l>>2]|0){t[b>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!(n[t[b>>2]>>0]|0))break e;if((u[t[b>>2]>>0]|0)>=65?(u[t[b>>2]>>0]|0)<=90:0)h=51;else h=14;i:do if((h|0)==14){h=0;if((u[t[b>>2]>>0]|0)>=97?(u[t[b>>2]>>0]|0)<=122:0){h=51;break}if((u[t[b>>2]>>0]|0)>=48?(u[t[b>>2]>>0]|0)<=57:0){h=51;break}if((((((((u[t[b>>2]>>0]|0)!=45?(u[t[b>>2]>>0]|0)!=95:0)?(u[t[b>>2]>>0]|0)!=46:0)?(u[t[b>>2]>>0]|0)!=33:0)?(u[t[b>>2]>>0]|0)!=126:0)?(u[t[b>>2]>>0]|0)!=42:0)?(u[t[b>>2]>>0]|0)!=39:0)?(u[t[b>>2]>>0]|0)!=40:0){if((u[t[b>>2]>>0]|0)==41){h=51;break}r:do if((u[t[b>>2]>>0]|0)==37){if(!((u[(t[b>>2]|0)+1>>0]|0)>=65?(u[(t[b>>2]|0)+1>>0]|0)<=70:0))h=30;do if((h|0)==30){h=0;if((u[(t[b>>2]|0)+1>>0]|0)>=97?(u[(t[b>>2]|0)+1>>0]|0)<=102:0)break;if((u[(t[b>>2]|0)+1>>0]|0)<48)break r;if((u[(t[b>>2]|0)+1>>0]|0)>57)break r}while(0);if((u[(t[b>>2]|0)+2>>0]|0)>=65?(u[(t[b>>2]|0)+2>>0]|0)<=70:0){h=51;break i}if((u[(t[b>>2]|0)+2>>0]|0)>=97?(u[(t[b>>2]|0)+2>>0]|0)<=102:0){h=51;break i}if((u[(t[b>>2]|0)+2>>0]|0)<48)break;if((u[(t[b>>2]|0)+2>>0]|0)<=57){h=51;break i}}while(0);if(!(t[c>>2]|0)){if((u[t[b>>2]>>0]|0)==59){h=51;break}if((u[t[b>>2]>>0]|0)==47){h=51;break}if((u[t[b>>2]>>0]|0)==63){h=51;break}if((u[t[b>>2]>>0]|0)==58){h=51;break}if((u[t[b>>2]>>0]|0)==64){h=51;break}if((u[t[b>>2]>>0]|0)==38){h=51;break}if((u[t[b>>2]>>0]|0)==61){h=51;break}if((u[t[b>>2]>>0]|0)==43){h=51;break}if((u[t[b>>2]>>0]|0)==36){h=51;break}if((u[t[b>>2]>>0]|0)==44){h=51;break}}a=u[t[b>>2]>>0]>>4;if((u[t[b>>2]>>0]>>4|0)<10)n[k+1>>0]=48+a;else n[k+1>>0]=55+a;a=u[t[b>>2]>>0]&15;if((u[t[b>>2]>>0]&15|0)<10)n[k+2>>0]=48+a;else n[k+2>>0]=55+a;Ps(t[l>>2]|0,k,3)|0}else h=51}while(0);if((h|0)==51){h=0;Ps(t[l>>2]|0,t[b>>2]|0,1)|0}t[b>>2]=(t[b>>2]|0)+1}}while(0);b=t[f>>2]|0;h=t[(t[f>>2]|0)+12>>2]|0;Sn(b,au(h,Os(t[l>>2]|0)|0)|0)|0;Ss(t[l>>2]|0);zt(t[(t[f>>2]|0)+12>>2]|0,t[o>>2]|0);s=r;return}function Wt(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[r>>2]|0)){Ut(0,130792);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}f=t[r>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[f+12>>2]=0;t[f+16>>2]=0;t[f+20>>2]=0;t[f+24>>2]=0;t[(t[r>>2]|0)+4>>2]=10;t[t[r>>2]>>2]=0;f=gAi[t[135744>>2]&511]((t[(t[r>>2]|0)+4>>2]|0)*40|0)|0;t[(t[r>>2]|0)+8>>2]=f;if(!(t[(t[r>>2]|0)+8>>2]|0)){Ut(0,130816);pAi[t[135736>>2]&511](t[r>>2]|0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{VY(t[(t[r>>2]|0)+8>>2]|0,0,(t[(t[r>>2]|0)+4>>2]|0)*40|0)|0;t[(t[r>>2]|0)+12>>2]=-1;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function Kt(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;n=s;s=s+64|0;f=n+48|0;u=n+44|0;a=n+40|0;o=n+36|0;c=n+32|0;l=n+28|0;b=n+24|0;k=n+20|0;h=n+16|0;w=n+12|0;d=n+8|0;v=n+4|0;m=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[d>>2]=0;do if(t[u>>2]|0){if((t[t[u>>2]>>2]|0)!=1?(t[t[u>>2]>>2]|0)!=9:0)break;do if(t[a>>2]|0){if((t[t[a>>2]>>2]|0)!=1?(t[t[a>>2]>>2]|0)!=9:0)break;t[v>>2]=t[(t[u>>2]|0)+4>>2];t[m>>2]=t[(t[a>>2]|0)+4>>2];if((t[v>>2]|0)!=0?(t[t[v>>2]>>2]|0)>0:0){if((t[m>>2]|0)!=0?(t[t[m>>2]>>2]|0)>0:0){e:do if(!(t[o>>2]|0)){t[c>>2]=0;i:while(1){if((t[c>>2]|0)>=(t[t[v>>2]>>2]|0))break e;t[l>>2]=0;while(1){_=t[c>>2]|0;if((t[l>>2]|0)>=(t[t[m>>2]>>2]|0))break;if((t[(t[(t[v>>2]|0)+8>>2]|0)+(_<<2)>>2]|0)==(t[(t[(t[m>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0))break i;t[l>>2]=(t[l>>2]|0)+1}t[c>>2]=_+1}t[f>>2]=1;p=t[f>>2]|0;s=n;return p|0}while(0);t[h>>2]=gAi[t[135744>>2]&511](t[t[v>>2]>>2]<<2)|0;if(!(t[h>>2]|0)){Ut(0,130768);t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}t[b>>2]=gAi[t[135744>>2]&511](t[t[v>>2]>>2]<<2)|0;if(!(t[b>>2]|0)){Ut(0,130768);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}VY(t[h>>2]|0,0,t[t[v>>2]>>2]<<2|0)|0;t[w>>2]=gAi[t[135744>>2]&511](t[t[m>>2]>>2]<<2)|0;if(!(t[w>>2]|0)){Ut(0,130768);pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}t[k>>2]=gAi[t[135744>>2]&511](t[t[m>>2]>>2]<<2)|0;if(!(t[k>>2]|0)){Ut(0,130768);pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);pAi[t[135736>>2]&511](t[w>>2]|0);t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}VY(t[w>>2]|0,0,t[t[m>>2]>>2]<<2|0)|0;t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[t[v>>2]>>2]|0))break;r=Ru(t[(t[(t[v>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)|0;t[(t[b>>2]|0)+(t[c>>2]<<2)>>2]=r;t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[t[m>>2]>>2]|0))break;if(!(t[c>>2]|0)){r=Ru(t[(t[(t[m>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0)|0;t[(t[k>>2]|0)+(t[l>>2]<<2)>>2]=r}if((t[(t[b>>2]|0)+(t[c>>2]<<2)>>2]|0)!=(t[(t[k>>2]|0)+(t[l>>2]<<2)>>2]|0)){if(t[o>>2]|0){E=40;break}}else{if(!(t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]|0)){r=sF(t[(t[(t[v>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)|0;t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]=r}if(!(t[(t[w>>2]|0)+(t[l>>2]<<2)>>2]|0)){r=sF(t[(t[(t[m>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0)|0;t[(t[w>>2]|0)+(t[l>>2]<<2)>>2]=r}r=Xl(t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]|0,t[(t[w>>2]|0)+(t[l>>2]<<2)>>2]|0)|0;t[d>>2]=r^t[o>>2];if(t[d>>2]|0)break}t[l>>2]=(t[l>>2]|0)+1}if((E|0)==40){E=0;t[d>>2]=1}if(t[d>>2]|0)break;t[c>>2]=(t[c>>2]|0)+1}t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[t[v>>2]>>2]|0))break;if(t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]|0);t[c>>2]=(t[c>>2]|0)+1}t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[t[m>>2]>>2]|0))break;if(t[(t[w>>2]|0)+(t[l>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[w>>2]|0)+(t[l>>2]<<2)>>2]|0);t[l>>2]=(t[l>>2]|0)+1}pAi[t[135736>>2]&511](t[h>>2]|0);pAi[t[135736>>2]&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[k>>2]|0);t[f>>2]=t[d>>2];p=t[f>>2]|0;s=n;return p|0}t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}while(0);t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}while(0);t[f>>2]=0;p=t[f>>2]|0;s=n;return p|0}function Xt(e,i,r,n){e=e|0;i=i|0;r=+r;n=n|0;var f=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;f=s;s=s+64|0;u=f+48|0;a=f+44|0;o=f+40|0;c=f+8|0;b=f+36|0;k=f+32|0;h=f+28|0;w=f+24|0;d=f+20|0;v=f+16|0;m=f;t[a>>2]=e;t[o>>2]=i;l[c>>3]=r;t[b>>2]=n;t[h>>2]=0;do if(t[o>>2]|0){if((t[t[o>>2]>>2]|0)!=1?(t[t[o>>2]>>2]|0)!=9:0)break;t[w>>2]=t[(t[o>>2]|0)+4>>2];e:do if(t[w>>2]|0){t[k>>2]=0;i:while(1){if((t[k>>2]|0)>=(t[t[w>>2]>>2]|0))break e;t[d>>2]=xn(t[(t[(t[w>>2]|0)+8>>2]|0)+(t[k>>2]<<2)>>2]|0)|0;do if(t[d>>2]|0){n=t[a>>2]|0;Sn(n,au(t[(t[a>>2]|0)+12>>2]|0,t[d>>2]|0)|0)|0;pAi[t[135736>>2]&511](t[d>>2]|0);gf(t[a>>2]|0,1);t[v>>2]=En(t[a>>2]|0)|0;l[m>>3]=+l[(t[v>>2]|0)+16>>3];zt(t[(t[a>>2]|0)+12>>2]|0,t[v>>2]|0);n=(hn(+l[m>>3])|0)!=0;i=(t[b>>2]|0)!=0;if(n){if(!i)break;t[h>>2]=1;break}if(!i?+l[m>>3]==+l[c>>3]:0){_=12;break i}if((t[b>>2]|0)!=0?+l[m>>3]!=+l[c>>3]:0){_=15;break i}}while(0);t[k>>2]=(t[k>>2]|0)+1}if((_|0)==12){t[h>>2]=1;break}else if((_|0)==15){t[h>>2]=1;break}}while(0);t[u>>2]=t[h>>2];p=t[u>>2]|0;s=f;return p|0}while(0);t[u>>2]=0;p=t[u>>2]|0;s=f;return p|0}function Zt(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(!((t[a>>2]|0)==0|(t[u>>2]|0)==0)){if((t[t[u>>2]>>2]|0)!=1?(t[t[u>>2]>>2]|0)!=9:0)break;t[l>>2]=t[(t[u>>2]|0)+4>>2];if((t[l>>2]|0)!=0?(t[t[l>>2]>>2]|0)>0:0){t[k>>2]=Nu(t[a>>2]|0)|0;t[c>>2]=0;e:while(1){if((t[c>>2]|0)>=(t[t[l>>2]>>2]|0)){h=28;break}r=Ru(t[(t[(t[l>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)|0;do if((r|0)==(t[k>>2]|0)){t[b>>2]=sF(t[(t[(t[l>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)|0;if((t[b>>2]|0)!=0?(Xl(t[a>>2]|0,t[b>>2]|0)|0)!=0:0){pAi[t[135736>>2]&511](t[b>>2]|0);if(t[o>>2]|0)break;else{h=14;break e}}if((t[b>>2]|0)==0?(Xl(t[a>>2]|0,128928)|0)!=0:0)if(t[o>>2]|0)break;else{h=18;break e}w=(t[b>>2]|0)!=0;if(t[o>>2]|0){h=20;break e}if(w)pAi[t[135736>>2]&511](t[b>>2]|0)}else if(t[o>>2]|0){h=26;break e}while(0);t[c>>2]=(t[c>>2]|0)+1}if((h|0)==14){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}else if((h|0)==18){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}else if((h|0)==20){if(w)pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}else if((h|0)==26){t[f>>2]=1;d=t[f>>2]|0;s=n;return d|0}else if((h|0)==28){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}while(0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}function Jt(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,b=0,k=0;n=s;s=s+32|0;f=n;a=n+20|0;o=n+16|0;c=n+12|0;b=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=0;e:do switch(t[t[o>>2]>>2]|0){case 3:{switch(t[t[c>>2]>>2]|0){case 4:{Sn(t[a>>2]|0,t[c>>2]|0)|0;gf(t[a>>2]|0,1);t[c>>2]=En(t[a>>2]|0)|0;break}case 3:break;case 6:case 5:case 8:case 7:{r=t[33976]|0;i=t[33980]|0;t[f>>2]=128552;t[f+4>>2]=7047;yAi[r&511](i,129064,f);break e;break}case 2:{t[b>>2]=(t[(t[c>>2]|0)+8>>2]|0)==(bf(+l[(t[o>>2]|0)+16>>3])|0)&1;break e;break}default:break e}if((hn(+l[(t[o>>2]|0)+16>>3])|0)==0?(hn(+l[(t[c>>2]|0)+16>>3])|0)==0:0){if((wn(+l[(t[o>>2]|0)+16>>3])|0)==1)if((wn(+l[(t[c>>2]|0)+16>>3])|0)==1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}i=(wn(+l[(t[o>>2]|0)+16>>3])|0)==-1;r=wn(+l[(t[c>>2]|0)+16>>3])|0;if(i)if((r|0)==-1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}if((r|0)==1)if((wn(+l[(t[o>>2]|0)+16>>3])|0)==1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}r=(wn(+l[(t[c>>2]|0)+16>>3])|0)==-1;k=+l[(t[o>>2]|0)+16>>3];if(!r){t[b>>2]=k==+l[(t[c>>2]|0)+16>>3]&1;break e}if((wn(k)|0)==-1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}}t[b>>2]=0;break}case 6:case 5:case 8:case 7:{r=t[33976]|0;i=t[33980]|0;t[f>>2]=128552;t[f+4>>2]=7119;yAi[r&511](i,129064,f);break}case 2:{switch(t[t[c>>2]>>2]|0){case 6:case 5:case 8:case 7:{i=t[33976]|0;r=t[33980]|0;t[f>>2]=128552;t[f+4>>2]=6990;yAi[i&511](r,129064,f);break e;break}case 3:{t[b>>2]=(t[(t[o>>2]|0)+8>>2]|0)==(bf(+l[(t[c>>2]|0)+16>>3])|0)&1;break e;break}case 2:{t[b>>2]=(t[(t[o>>2]|0)+8>>2]|0)==(t[(t[c>>2]|0)+8>>2]|0)&1;break e;break}case 4:{if((t[(t[c>>2]|0)+24>>2]|0)!=0?(u[t[(t[c>>2]|0)+24>>2]>>0]|0|0)!=0:0)t[b>>2]=1;else t[b>>2]=0;t[b>>2]=(t[(t[o>>2]|0)+8>>2]|0)==(t[b>>2]|0)&1;break e;break}default:break e}break}case 4:{switch(t[t[c>>2]>>2]|0){case 3:{Sn(t[a>>2]|0,t[o>>2]|0)|0;gf(t[a>>2]|0,1);t[o>>2]=En(t[a>>2]|0)|0;if((hn(+l[(t[o>>2]|0)+16>>3])|0)==0?(hn(+l[(t[c>>2]|0)+16>>3])|0)==0:0){if((wn(+l[(t[o>>2]|0)+16>>3])|0)==1)if((wn(+l[(t[c>>2]|0)+16>>3])|0)==1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}r=(wn(+l[(t[o>>2]|0)+16>>3])|0)==-1;i=wn(+l[(t[c>>2]|0)+16>>3])|0;if(r)if((i|0)==-1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}if((i|0)==1)if((wn(+l[(t[o>>2]|0)+16>>3])|0)==1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}i=(wn(+l[(t[c>>2]|0)+16>>3])|0)==-1;k=+l[(t[o>>2]|0)+16>>3];if(!i){t[b>>2]=k==+l[(t[c>>2]|0)+16>>3]&1;break e}if((wn(k)|0)==-1){t[b>>2]=1;break e}else{t[b>>2]=0;break e}}t[b>>2]=0;break e;break}case 6:case 5:case 8:case 7:{i=t[33976]|0;r=t[33980]|0;t[f>>2]=128552;t[f+4>>2]=7108;yAi[i&511](r,129064,f);break e;break}case 2:{if((t[(t[o>>2]|0)+24>>2]|0)!=0?(u[t[(t[o>>2]|0)+24>>2]>>0]|0|0)!=0:0)t[b>>2]=1;else t[b>>2]=0;t[b>>2]=(t[(t[c>>2]|0)+8>>2]|0)==(t[b>>2]|0)&1;break e;break}case 4:{t[b>>2]=Xl(t[(t[o>>2]|0)+24>>2]|0,t[(t[c>>2]|0)+24>>2]|0)|0;break e;break}default:break e}break}default:{}}while(0);zt(t[(t[a>>2]|0)+12>>2]|0,t[o>>2]|0);zt(t[(t[a>>2]|0)+12>>2]|0,t[c>>2]|0);s=n;return t[b>>2]|0}function Qt(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;f=s;s=s+64|0;u=f+52|0;a=f+48|0;o=f+44|0;c=f+40|0;b=f+36|0;k=f+32|0;h=f+28|0;w=f+24|0;d=f;v=f+20|0;m=f+16|0;_=f+12|0;p=f+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=n;t[w>>2]=0;t[m>>2]=0;do if(t[c>>2]|0){if((t[t[c>>2]>>2]|0)!=1?(t[t[c>>2]>>2]|0)!=9:0)break;do if(t[b>>2]|0){if((t[t[b>>2]>>2]|0)!=1?(t[t[b>>2]>>2]|0)!=9:0)break;t[_>>2]=t[(t[c>>2]|0)+4>>2];t[p>>2]=t[(t[b>>2]|0)+4>>2];if((t[_>>2]|0)!=0?(t[t[_>>2]>>2]|0)>0:0){if((t[p>>2]|0)!=0?(t[t[p>>2]>>2]|0)>0:0){t[v>>2]=gAi[t[135744>>2]&511](t[t[p>>2]>>2]<<3)|0;if(!(t[v>>2]|0)){Ut(0,130768);_n(t[c>>2]|0);_n(t[b>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[t[_>>2]>>2]|0))break;l[d>>3]=+lf(t[(t[(t[_>>2]|0)+8>>2]|0)+(t[k>>2]<<2)>>2]|0);if(!(hn(+l[d>>3])|0)){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[t[p>>2]>>2]|0))break;if(!(t[w>>2]|0)){S=+lf(t[(t[(t[p>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0);l[(t[v>>2]|0)+(t[h>>2]<<3)>>3]=S}if(!(hn(+l[(t[v>>2]|0)+(t[h>>2]<<3)>>3])|0)){do if((t[a>>2]|0)!=0&(t[o>>2]|0)!=0)t[m>>2]=+l[d>>3]<+l[(t[v>>2]|0)+(t[h>>2]<<3)>>3]&1;else{if(!((t[a>>2]|0)==0|(t[o>>2]|0)!=0)){t[m>>2]=+l[d>>3]<=+l[(t[v>>2]|0)+(t[h>>2]<<3)>>3]&1;break}if((t[a>>2]|0)==0&(t[o>>2]|0)!=0){t[m>>2]=+l[d>>3]>+l[(t[v>>2]|0)+(t[h>>2]<<3)>>3]&1;break}if((t[a>>2]|0)!=0|(t[o>>2]|0)!=0)break;t[m>>2]=+l[d>>3]>=+l[(t[v>>2]|0)+(t[h>>2]<<3)>>3]&1}while(0);if(t[m>>2]|0)break}t[h>>2]=(t[h>>2]|0)+1}if(t[m>>2]|0)break;t[w>>2]=1}t[k>>2]=(t[k>>2]|0)+1}pAi[t[135736>>2]&511](t[v>>2]|0);_n(t[c>>2]|0);_n(t[b>>2]|0);t[u>>2]=t[m>>2];E=t[u>>2]|0;s=f;return E|0}_n(t[c>>2]|0);_n(t[b>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}_n(t[c>>2]|0);_n(t[b>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}while(0);_n(t[c>>2]|0);_n(t[b>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}while(0);_n(t[b>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}function $t(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;do if(!((t[h>>2]|0)==0|(t[k>>2]|0)==0)){if((t[t[k>>2]>>2]|0)!=1?(t[t[k>>2]>>2]|0)!=9:0)break;switch(t[t[h>>2]>>2]|0){case 9:case 1:{t[o>>2]=Qt(t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;w=t[o>>2]|0;s=u;return w|0}case 4:{t[o>>2]=Lu(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;w=t[o>>2]|0;s=u;return w|0}case 2:{Sn(t[c>>2]|0,t[k>>2]|0)|0;tt(t[c>>2]|0,1);Sn(t[c>>2]|0,t[h>>2]|0)|0;t[o>>2]=Sf(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;w=t[o>>2]|0;s=u;return w|0}case 3:{t[o>>2]=Tu(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;w=t[o>>2]|0;s=u;return w|0}default:{f=t[33976]|0;n=t[33980]|0;t[a>>2]=128552;t[a+4>>2]=6705;yAi[f&511](n,129064,a);t[o>>2]=0;w=t[o>>2]|0;s=u;return w|0}}}while(0);t[o>>2]=0;w=t[o>>2]|0;s=u;return w|0}function eu(e,i){e=e|0;i=+i;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r;a=r+16|0;o=r+12|0;c=r+8|0;t[f>>2]=e;l[u>>3]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+200>>2];if((t[(t[a>>2]|0)+12>>2]|0)!=0?(t[(t[(t[a>>2]|0)+12>>2]|0)+4>>2]|0)!=0:0){f=(t[(t[a>>2]|0)+12>>2]|0)+4|0;e=(t[f>>2]|0)+-1|0;t[f>>2]=e;t[o>>2]=t[(t[t[(t[a>>2]|0)+12>>2]>>2]|0)+(e<<2)>>2];t[t[o>>2]>>2]=3;l[(t[o>>2]|0)+16>>3]=+l[u>>3];t[n>>2]=t[o>>2];b=t[n>>2]|0;s=r;return b|0}if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){o=(t[(t[a>>2]|0)+16>>2]|0)+4|0;e=(t[o>>2]|0)+-1|0;t[o>>2]=e;t[c>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(e<<2)>>2];t[t[c>>2]>>2]=3;l[(t[c>>2]|0)+16>>3]=+l[u>>3];t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}}t[n>>2]=Jn(+l[u>>3])|0;b=t[n>>2]|0;s=r;return b|0}function iu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=eu(t[f>>2]|0,0)|0;o=t[n>>2]|0;s=r;return o|0}if((t[t[u>>2]>>2]|0)==3){t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}else{i=t[f>>2]|0;t[a>>2]=eu(i,+Fn(t[u>>2]|0))|0;zt(t[f>>2]|0,t[u>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function ru(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+200>>2];if((t[t[a>>2]>>2]|0)!=0?(t[(t[t[a>>2]>>2]|0)+4>>2]|0)!=0:0){i=(t[t[a>>2]>>2]|0)+4|0;e=(t[i>>2]|0)+-1|0;t[i>>2]=e;t[o>>2]=t[(t[t[t[a>>2]>>2]>>2]|0)+(e<<2)>>2];t[t[o>>2]>>2]=1;t[(t[o>>2]|0)+8>>2]=0;do if(t[u>>2]|0){if((t[(t[(t[o>>2]|0)+4>>2]|0)+4>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){t[t[(t[(t[o>>2]|0)+4>>2]|0)+8>>2]>>2]=t[u>>2];t[t[(t[o>>2]|0)+4>>2]>>2]=1;break}Cn(t[(t[o>>2]|0)+4>>2]|0,t[u>>2]|0)|0}while(0);t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){o=(t[(t[a>>2]|0)+16>>2]|0)+4|0;e=(t[o>>2]|0)+-1|0;t[o>>2]=e;t[c>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(e<<2)>>2];t[t[c>>2]>>2]=1;t[(t[c>>2]|0)+8>>2]=0;e=Nn(t[u>>2]|0)|0;t[(t[c>>2]|0)+4>>2]=e;if(!(t[(t[c>>2]|0)+4>>2]|0)){t[(t[f>>2]|0)+136>>2]=12;t[(t[f>>2]|0)+140>>2]=2;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}}}t[n>>2]=In(t[u>>2]|0)|0;l=t[n>>2]|0;s=r;return l|0}function nu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=t[a>>2];t[k>>2]=0;if(!(t[a>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}t[o>>2]=Nn(0)|0;if(!(t[o>>2]|0)){t[n>>2]=t[o>>2];h=t[n>>2]|0;s=r;return h|0}e:while(1){do if((u[t[c>>2]>>0]|0|0)!=32){if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0)break;if((u[t[c>>2]>>0]|0|0)!=13)break e}while(0);t[c>>2]=(t[c>>2]|0)+1}while(1){if(!(u[t[c>>2]>>0]|0))break;while(1){if((u[t[c>>2]>>0]|0|0)==32)break;if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0)break;if((u[t[c>>2]>>0]|0|0)==13)break;if(!(u[t[c>>2]>>0]|0))break;t[c>>2]=(t[c>>2]|0)+1}t[l>>2]=ql(t[a>>2]|0,(t[c>>2]|0)-(t[a>>2]|0)|0)|0;if(t[l>>2]|0){t[b>>2]=GM(t[f>>2]|0,t[l>>2]|0)|0;if(t[b>>2]|0){i=t[b>>2]|0;do if((t[(t[b>>2]|0)+4>>2]|0)!=2)if((t[i+4>>2]|0)==1){t[k>>2]=t[b>>2];break}else{t[k>>2]=0;break}else t[k>>2]=t[i+20>>2];while(0);if(t[k>>2]|0)Dn(t[o>>2]|0,t[k>>2]|0)|0}pAi[t[135736>>2]&511](t[l>>2]|0)}while(1){do if((u[t[c>>2]>>0]|0|0)==32)w=1;else{if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){w=1;break}w=(u[t[c>>2]>>0]|0|0)==13}while(0);d=t[c>>2]|0;if(!w)break;t[c>>2]=d+1}t[a>>2]=d}t[n>>2]=t[o>>2];h=t[n>>2]|0;s=r;return h|0}function fu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0)?(t[a>>2]=t[(t[f>>2]|0)+200>>2],(t[(t[a>>2]|0)+16>>2]|0)!=0):0)?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){f=(t[(t[a>>2]|0)+16>>2]|0)+4|0;i=(t[f>>2]|0)+-1|0;t[f>>2]=i;t[o>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(i<<2)>>2];t[t[o>>2]>>2]=1;t[(t[o>>2]|0)+4>>2]=t[u>>2];t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}t[n>>2]=Hn(t[u>>2]|0)|0;c=t[n>>2]|0;s=r;return c|0}function tu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=uu(t[u>>2]|0,128928)|0;c=t[f>>2]|0;s=r;return c|0}switch(t[t[a>>2]>>2]|0){case 9:case 1:{t[o>>2]=uf(t[(t[a>>2]|0)+4>>2]|0)|0;break}case 3:{t[o>>2]=tf(+l[(t[a>>2]|0)+16>>3])|0;break}case 6:case 5:case 8:case 7:{i=t[33976]|0;e=t[33980]|0;t[n>>2]=128552;t[n+4>>2]=2680;yAi[i&511](e,129064,n);break}case 2:{t[o>>2]=ff(t[(t[a>>2]|0)+8>>2]|0)|0;break}case 4:{t[f>>2]=t[a>>2];c=t[f>>2]|0;s=r;return c|0}default:{}}zt(t[u>>2]|0,t[a>>2]|0);a=t[u>>2]|0;if(!(t[o>>2]|0)){t[f>>2]=uu(a,128928)|0;c=t[f>>2]|0;s=r;return c|0}else{t[f>>2]=ou(a,t[o>>2]|0)|0;c=t[f>>2]|0;s=r;return c|0}return 0}function uu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+200>>2];if((t[(t[a>>2]|0)+4>>2]|0)!=0?(t[(t[(t[a>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0){f=(t[(t[a>>2]|0)+4>>2]|0)+4|0;i=(t[f>>2]|0)+-1|0;t[f>>2]=i;t[o>>2]=t[(t[t[(t[a>>2]|0)+4>>2]>>2]|0)+(i<<2)>>2];t[t[o>>2]>>2]=4;i=Yl(t[u>>2]|0)|0;t[(t[o>>2]|0)+24>>2]=i;t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){o=(t[(t[a>>2]|0)+16>>2]|0)+4|0;i=(t[o>>2]|0)+-1|0;t[o>>2]=i;t[c>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(i<<2)>>2];t[t[c>>2]>>2]=4;i=Yl(t[u>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=i;t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}}t[n>>2]=rf(t[u>>2]|0)|0;l=t[n>>2]|0;s=r;return l|0}function au(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+200>>2];if((t[(t[a>>2]|0)+4>>2]|0)!=0?(t[(t[(t[a>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0){f=(t[(t[a>>2]|0)+4>>2]|0)+4|0;i=(t[f>>2]|0)+-1|0;t[f>>2]=i;t[o>>2]=t[(t[t[(t[a>>2]|0)+4>>2]>>2]|0)+(i<<2)>>2];t[t[o>>2]>>2]=4;if(t[u>>2]|0){i=Yl(t[u>>2]|0)|0;t[(t[o>>2]|0)+24>>2]=i}else{i=Yl(128928)|0;t[(t[o>>2]|0)+24>>2]=i}t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){o=(t[(t[a>>2]|0)+16>>2]|0)+4|0;i=(t[o>>2]|0)+-1|0;t[o>>2]=i;t[c>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(i<<2)>>2];
	t[t[c>>2]>>2]=4;if(t[u>>2]|0){i=Yl(t[u>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=i}else{i=Yl(128928)|0;t[(t[c>>2]|0)+24>>2]=i}t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}}t[n>>2]=$n(t[u>>2]|0)|0;l=t[n>>2]|0;s=r;return l|0}function ou(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+200>>2];if((t[(t[a>>2]|0)+4>>2]|0)!=0?(t[(t[(t[a>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0){f=(t[(t[a>>2]|0)+4>>2]|0)+4|0;i=(t[f>>2]|0)+-1|0;t[f>>2]=i;t[o>>2]=t[(t[t[(t[a>>2]|0)+4>>2]>>2]|0)+(i<<2)>>2];t[t[o>>2]>>2]=4;t[(t[o>>2]|0)+24>>2]=t[u>>2];t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){o=(t[(t[a>>2]|0)+16>>2]|0)+4|0;i=(t[o>>2]|0)+-1|0;t[o>>2]=i;t[c>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(i<<2)>>2];t[t[c>>2]>>2]=4;t[(t[c>>2]|0)+24>>2]=t[u>>2];t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}}t[n>>2]=ef(t[u>>2]|0)|0;l=t[n>>2]|0;s=r;return l|0}function cu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+200>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+200>>2];if((t[(t[a>>2]|0)+8>>2]|0)!=0?(t[(t[(t[a>>2]|0)+8>>2]|0)+4>>2]|0)!=0:0){f=(t[(t[a>>2]|0)+8>>2]|0)+4|0;i=(t[f>>2]|0)+-1|0;t[f>>2]=i;t[o>>2]=t[(t[t[(t[a>>2]|0)+8>>2]>>2]|0)+(i<<2)>>2];t[t[o>>2]>>2]=2;t[(t[o>>2]|0)+8>>2]=(t[u>>2]|0)!=0&1;t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}if((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){o=(t[(t[a>>2]|0)+16>>2]|0)+4|0;i=(t[o>>2]|0)+-1|0;t[o>>2]=i;t[c>>2]=t[(t[t[(t[a>>2]|0)+16>>2]>>2]|0)+(i<<2)>>2];t[t[c>>2]>>2]=2;t[(t[c>>2]|0)+8>>2]=(t[u>>2]|0)!=0&1;t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}}t[n>>2]=Qn(t[u>>2]|0)|0;l=t[n>>2]|0;s=r;return l|0}function lu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=cu(t[f>>2]|0,0)|0;o=t[n>>2]|0;s=r;return o|0}if((t[t[u>>2]>>2]|0)==2){t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}else{i=t[f>>2]|0;t[a>>2]=cu(i,yn(t[u>>2]|0)|0)|0;zt(t[f>>2]|0,t[u>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function su(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+144|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+32|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[u>>2]=e;t[a>>2]=i;t[c>>2]=0;t[b>>2]=Du(t[u>>2]|0,l)|0;e:do if(!((t[b>>2]|0)==32|(t[b>>2]|0)==62|(t[b>>2]|0)==47|(t[b>>2]|0)==91|(t[b>>2]|0)==93|(t[b>>2]|0)==64|(t[b>>2]|0)==42)){i=t[b>>2]|0;if((t[b>>2]|0)<256){if(((!(65<=(i|0)&(t[b>>2]|0)<=90)?!(97<=(t[b>>2]|0)&(t[b>>2]|0)<=122):0)?!(192<=(t[b>>2]|0)&(t[b>>2]|0)<=214):0)?!(216<=(t[b>>2]|0)&(t[b>>2]|0)<=246|248<=(t[b>>2]|0)):0)w=8}else if(!(dj(i,199744)|0))w=8;do if((w|0)==8){i=t[b>>2]|0;if((t[b>>2]|0)<256)if((i|0)!=95&(t[a>>2]|0)!=0&(t[b>>2]|0)!=58)break e;else break;if(!(19968<=(i|0)&(t[b>>2]|0)<=40869|(t[b>>2]|0)==12295)?(12321<=(t[b>>2]|0)&(t[b>>2]|0)<=12329^1)&(t[b>>2]|0)!=95&(t[a>>2]|0)!=0&(t[b>>2]|0)!=58:0)break e}while(0);i:do{if(!((t[b>>2]|0)!=32&(t[b>>2]|0)!=62&(t[b>>2]|0)!=47)){w=72;break}i=t[b>>2]|0;if((t[b>>2]|0)<256){if(((!(65<=(i|0)&(t[b>>2]|0)<=90)?!(97<=(t[b>>2]|0)&(t[b>>2]|0)<=122):0)?!(192<=(t[b>>2]|0)&(t[b>>2]|0)<=214):0)?!(216<=(t[b>>2]|0)&(t[b>>2]|0)<=246|248<=(t[b>>2]|0)):0)w=20}else if(!(dj(i,199744)|0))w=20;do if((w|0)==20){w=0;if((t[b>>2]|0)>=256){if(19968<=(t[b>>2]|0)&(t[b>>2]|0)<=40869|(t[b>>2]|0)==12295)break;if(12321<=(t[b>>2]|0)&(t[b>>2]|0)<=12329)break}i=t[b>>2]|0;if((t[b>>2]|0)<256){if(48<=(i|0)&(t[b>>2]|0)<=57|(t[b>>2]|0)==46|(t[b>>2]|0)==45|(t[b>>2]|0)==95)break}else{e=(dj(i,200216)|0)!=0;if(e|(t[b>>2]|0)==46|(t[b>>2]|0)==45|(t[b>>2]|0)==95)break}if(!((t[a>>2]|0)!=0&(t[b>>2]|0)==58)){if((t[b>>2]|0)>=256?(dj(t[b>>2]|0,200144)|0)!=0:0)break;e=t[b>>2]|0;if((t[b>>2]|0)<256)d=(e|0)==183&1;else d=dj(e,200272)|0;if(!d){w=72;break i}}}while(0);if((t[l>>2]|0)==1){e=t[b>>2]&255;i=t[c>>2]|0;t[c>>2]=i+1;n[o+i>>0]=e}else{e=Np(t[l>>2]|0,o+(t[c>>2]|0)|0,t[b>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+e}e=t[u>>2]|0;t[e>>2]=(t[e>>2]|0)+(t[l>>2]|0);t[b>>2]=Du(t[u>>2]|0,l)|0}while((t[c>>2]|0)<100);if((w|0)==72)if(!(t[c>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}else{t[f>>2]=ql(o,t[c>>2]|0)|0;v=t[f>>2]|0;s=r;return v|0}t[h>>2]=t[c>>2]<<1;if((t[c>>2]|0)>5e4){dn(t[u>>2]|0,7);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}t[k>>2]=gAi[t[135752>>2]&511](t[h>>2]|0)|0;if(!(t[k>>2]|0)){dn(t[u>>2]|0,15);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}YY(t[k>>2]|0,o|0,t[c>>2]|0)|0;while(1){e=t[b>>2]|0;if((t[b>>2]|0)<256)if(((!(65<=(e|0)&(t[b>>2]|0)<=90)?!(97<=(t[b>>2]|0)&(t[b>>2]|0)<=122):0)?!(192<=(t[b>>2]|0)&(t[b>>2]|0)<=214):0)?!(216<=(t[b>>2]|0)&(t[b>>2]|0)<=246|248<=(t[b>>2]|0)):0)w=48;else m=1;else if(dj(e,199744)|0)m=1;else w=48;do if((w|0)==48){w=0;if((t[b>>2]|0)>=256){if(19968<=(t[b>>2]|0)&(t[b>>2]|0)<=40869|(t[b>>2]|0)==12295){m=1;break}if(12321<=(t[b>>2]|0)&(t[b>>2]|0)<=12329){m=1;break}}e=t[b>>2]|0;if((t[b>>2]|0)<256){if(48<=(e|0)&(t[b>>2]|0)<=57|(t[b>>2]|0)==46|(t[b>>2]|0)==45|(t[b>>2]|0)==95){m=1;break}}else{i=(dj(e,200216)|0)!=0;if(i|(t[b>>2]|0)==46|(t[b>>2]|0)==45|(t[b>>2]|0)==95){m=1;break}}if((t[a>>2]|0)!=0&(t[b>>2]|0)==58)m=1;else{if((t[b>>2]|0)>=256?(dj(t[b>>2]|0,200144)|0)!=0:0){m=1;break}i=t[b>>2]|0;if((t[b>>2]|0)<256)_=(i|0)==183&1;else _=dj(i,200272)|0;m=(_|0)!=0}}while(0);p=t[c>>2]|0;if(!m){w=71;break}if((p+10|0)>(t[h>>2]|0)){if((t[h>>2]|0)>5e4){w=64;break}t[h>>2]=t[h>>2]<<1;t[k>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[h>>2]|0)|0;if(!(t[k>>2]|0)){w=66;break}}if((t[l>>2]|0)==1){i=t[b>>2]&255;e=t[c>>2]|0;t[c>>2]=e+1;n[(t[k>>2]|0)+e>>0]=i}else{i=Np(t[l>>2]|0,(t[k>>2]|0)+(t[c>>2]|0)|0,t[b>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+i}i=t[u>>2]|0;t[i>>2]=(t[i>>2]|0)+(t[l>>2]|0);t[b>>2]=Du(t[u>>2]|0,l)|0}if((w|0)==64){dn(t[u>>2]|0,7);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}else if((w|0)==66){dn(t[u>>2]|0,15);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}else if((w|0)==71){n[(t[k>>2]|0)+p>>0]=0;t[f>>2]=t[k>>2];v=t[f>>2]|0;s=r;return v|0}}while(0);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}function bu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+40|0;f=r+36|0;a=r+32|0;o=r+28|0;c=r+24|0;l=r+20|0;b=r+16|0;k=r+12|0;h=r+8|0;w=r+4|0;d=r;t[f>>2]=e;t[a>>2]=i;t[l>>2]=0;t[b>>2]=0;if(((es(t[a>>2]|0,91)|0)==0?(es(t[a>>2]|0,40)|0)==0:0)?(es(t[a>>2]|0,64)|0)==0:0){t[d>>2]=es(t[a>>2]|0,58)|0;do if(t[d>>2]|0){if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+60>>2]|0)!=0:0)?(u[(t[d>>2]|0)+1>>0]|0|0)!=58:0)break;t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}while(0);if((t[f>>2]|0)!=0?(t[l>>2]=t[(t[f>>2]|0)+192>>2],(t[(t[f>>2]|0)+60>>2]|0)>0):0){t[b>>2]=gAi[t[135744>>2]&511]((t[(t[f>>2]|0)+60>>2]|0)+1<<1<<2)|0;if(!(t[b>>2]|0)){Ut(t[f>>2]|0,130672);t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[h>>2]=0;t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[(t[f>>2]|0)+60>>2]|0))break;t[k>>2]=t[(t[(t[f>>2]|0)+56>>2]|0)+(t[w>>2]<<2)>>2];d=t[(t[k>>2]|0)+8>>2]|0;i=t[h>>2]|0;t[h>>2]=i+1;t[(t[b>>2]|0)+(i<<2)>>2]=d;d=t[(t[k>>2]|0)+12>>2]|0;i=t[h>>2]|0;t[h>>2]=i+1;t[(t[b>>2]|0)+(i<<2)>>2]=d;t[w>>2]=(t[w>>2]|0)+1}w=t[h>>2]|0;t[h>>2]=w+1;t[(t[b>>2]|0)+(w<<2)>>2]=0;t[(t[b>>2]|0)+(t[h>>2]<<2)>>2]=0}t[o>>2]=Fj(t[a>>2]|0,t[l>>2]|0,1,t[b>>2]|0)|0;if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);if((t[o>>2]|0)!=0?(Mj(t[o>>2]|0)|0)==1:0){t[c>>2]=Wt()|0;if(!(t[c>>2]|0)){Ut(t[f>>2]|0,130704);t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[(t[c>>2]|0)+24>>2]=t[o>>2];t[(t[c>>2]|0)+20>>2]=t[l>>2];if(t[(t[c>>2]|0)+20>>2]|0)sz(t[(t[c>>2]|0)+20>>2]|0)|0;t[n>>2]=t[c>>2];v=t[n>>2]|0;s=r;return v|0}vj(t[o>>2]|0)}t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}function ku(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;Cu(t[n>>2]|0);if(t[(t[n>>2]|0)+8>>2]|0){s=r;return}e:while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[n>>2]>>2]>>0]|0|0)!=13)break e}while(0);i=t[n>>2]|0;if(!(u[t[t[n>>2]>>2]>>0]|0))continue;t[i>>2]=(t[i>>2]|0)+1}e:while(1){if((u[t[t[n>>2]>>2]>>0]|0|0)!=111)break;if((u[(t[t[n>>2]>>2]|0)+1>>0]|0|0)!=114)break;t[a>>2]=t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2];i=t[n>>2]|0;t[i>>2]=(t[i>>2]|0)+2;while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[n>>2]>>2]>>0]|0|0)==13}while(0);c=t[n>>2]|0;if(!o)break;i=t[n>>2]|0;if(!(u[t[c>>2]>>0]|0))continue;t[i>>2]=(t[i>>2]|0)+1}Cu(c);if(t[(t[n>>2]|0)+8>>2]|0){l=29;break}Pu(t[(t[n>>2]|0)+32>>2]|0,t[a>>2]|0,t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2]|0,2,0,0,0,0,0)|0;while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[n>>2]>>2]>>0]|0|0)!=13)continue e}while(0);i=t[n>>2]|0;if(!(u[t[t[n>>2]>>2]>>0]|0))continue;t[i>>2]=(t[i>>2]|0)+1}}if((l|0)==29){s=r;return}if(!(t[f>>2]|0)){s=r;return}if((t[(t[(t[(t[n>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2]|0)*40|0)>>2]|0)==12){s=r;return}Pu(t[(t[n>>2]|0)+32>>2]|0,t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2]|0,-1,18,0,0,0,0,0)|0;s=r;return}function hu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;do if((((((((t[t[f>>2]>>2]|0)==11?(t[(t[f>>2]|0)+4>>2]|0)!=-1:0)?(t[(t[f>>2]|0)+8>>2]|0)==-1:0)?(t[u>>2]=(t[(t[n>>2]|0)+8>>2]|0)+((t[(t[f>>2]|0)+4>>2]|0)*40|0),(t[t[u>>2]>>2]|0)==11):0)?(t[(t[u>>2]|0)+12>>2]|0)==6:0)?(t[(t[u>>2]|0)+8>>2]|0)==-1:0)?(t[(t[u>>2]|0)+16>>2]|0)==1:0)?(t[(t[u>>2]|0)+20>>2]|0)==0:0){i=t[(t[f>>2]|0)+12>>2]|0;if((i|0)==6|(i|0)==13){t[(t[f>>2]|0)+4>>2]=t[(t[u>>2]|0)+4>>2];t[(t[f>>2]|0)+12>>2]=6;break}else if((i|0)==5|(i|0)==4){t[(t[f>>2]|0)+4>>2]=t[(t[u>>2]|0)+4>>2];t[(t[f>>2]|0)+12>>2]=5;break}else break}while(0);if((t[(t[f>>2]|0)+4>>2]|0)!=-1)hu(t[n>>2]|0,(t[(t[n>>2]|0)+8>>2]|0)+((t[(t[f>>2]|0)+4>>2]|0)*40|0)|0);if((t[(t[f>>2]|0)+8>>2]|0)==-1){s=r;return}hu(t[n>>2]|0,(t[(t[n>>2]|0)+8>>2]|0)+((t[(t[f>>2]|0)+8>>2]|0)*40|0)|0);s=r;return}function wu(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+48|0;u=f;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;d=f+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;if(!(t[c>>2]|0)){cp(0,0,0,0,0,12,1,3,128552,14895,0,0,0,0,0,129480,u);t[a>>2]=-1;v=t[a>>2]|0;s=f;return v|0}if(!(t[o>>2]|0)){t[a>>2]=-1;v=t[a>>2]|0;s=f;return v|0}kn();t[32576]=(t[32576]|0)+1;if((t[32576]|0)>1)t[32574]=1;t[k>>2]=Bu(t[o>>2]|0,t[c>>2]|0)|0;t[h>>2]=du(t[k>>2]|0,t[b>>2]|0)|0;do if(t[l>>2]|0)if(!(t[(t[k>>2]|0)+16>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,130312,u);t[t[l>>2]>>2]=0;break}else{o=En(t[k>>2]|0)|0;t[t[l>>2]>>2]=o;break}while(0);do if((t[(t[k>>2]|0)+20>>2]|0)>0){t[d>>2]=0;do{t[w>>2]=En(t[k>>2]|0)|0;if(t[w>>2]|0){t[d>>2]=(t[d>>2]|0)+1;zt(t[c>>2]|0,t[w>>2]|0)}}while((t[w>>2]|0)!=0);if(t[d>>2]|0){if(!(t[b>>2]|0)){if(!(t[l>>2]|0))break;if(!(t[t[l>>2]>>2]|0))break}o=t[33976]|0;n=t[33980]|0;t[u>>2]=t[d>>2];yAi[o&511](n,130360,u)}}while(0);if(((t[l>>2]|0)!=0?(t[(t[k>>2]|0)+8>>2]|0)!=0:0)?(t[t[l>>2]>>2]|0)!=0:0){_n(t[t[l>>2]>>2]|0);t[t[l>>2]>>2]=0}t[(t[k>>2]|0)+32>>2]=0;_f(t[k>>2]|0);t[32576]=(t[32576]|0)+-1;t[a>>2]=t[h>>2];v=t[a>>2]|0;s=f;return v|0}function du(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]|0)!=0:0){if(!(t[(t[u>>2]|0)+28>>2]|0)){i=gAi[t[135744>>2]&511](40)|0;t[(t[u>>2]|0)+28>>2]=i;if(!(t[(t[u>>2]|0)+28>>2]|0)){Iu(t[u>>2]|0,129952);pAi[t[135736>>2]&511](t[u>>2]|0)}t[(t[u>>2]|0)+20>>2]=0;t[(t[u>>2]|0)+24>>2]=10;t[(t[u>>2]|0)+16>>2]=0;t[(t[u>>2]|0)+44>>2]=0}do if(t[(t[(t[u>>2]|0)+32>>2]|0)+24>>2]|0){if(t[a>>2]|0){t[c>>2]=Hu(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+32>>2]|0)+24>>2]|0,0,1)|0;if((t[c>>2]|0)==-1)break;t[f>>2]=t[c>>2];b=t[f>>2]|0;s=r;return b|0}t[l>>2]=0;t[c>>2]=Hu(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+32>>2]|0)+24>>2]|0,l,0)|0;if((t[c>>2]|0)!=-1&(t[l>>2]|0)!=0){Sn(t[u>>2]|0,t[l>>2]|0)|0;t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else{if(!(t[l>>2]|0))break;zt(t[(t[u>>2]|0)+12>>2]|0,t[l>>2]|0);break}}while(0);t[o>>2]=t[(t[u>>2]|0)+32>>2];if((t[(t[o>>2]|0)+12>>2]|0)<0){yAi[t[135904>>2]&511](t[33980]|0,129984,n);t[f>>2]=-1;b=t[f>>2]|0;s=r;return b|0}n=t[u>>2]|0;u=(t[(t[o>>2]|0)+8>>2]|0)+((t[(t[o>>2]|0)+12>>2]|0)*40|0)|0;if(t[a>>2]|0){t[f>>2]=xu(n,u,0)|0;b=t[f>>2]|0;s=r;return b|0}else{Uu(n,u)|0;t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}}t[f>>2]=-1;b=t[f>>2]|0;s=r;return b|0}function vu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=zu(t[n>>2]|0,t[f>>2]|0)|0;f=t[u>>2]|0;s=r;return((t[u>>2]|0)==-2?f:0-f|0)|0}function mu(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;n=s;s=s+64|0;f=n+32|0;u=n+60|0;a=n+56|0;o=n+52|0;c=n+24|0;l=n+16|0;b=n+8|0;k=n+48|0;h=n+44|0;w=n;d=n+40|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;r=c;t[r>>2]=0;t[r+4>>2]=0;r=b;t[r>>2]=(t[o>>2]|0)-1;t[r+4>>2]=0;r=b;o=IY(t[r>>2]|0,t[r+4>>2]|0,1)|0;r=l;t[r>>2]=o;t[r+4>>2]=P;t[k>>2]=t[(t[u>>2]|0)+(t[c>>2]<<2)>>2];if((vu(t[a>>2]|0,t[k>>2]|0)|0)<0){r=f;t[r>>2]=0;t[r+4>>2]=0;v=f;m=v;_=t[m>>2]|0;p=v+4|0;E=p;S=t[E>>2]|0;P=S;s=n;return _|0}if(!(vu(t[a>>2]|0,t[k>>2]|0)|0)){r=w;t[r>>2]=1;t[r+4>>2]=0;while(1){r=(vu(t[a>>2]|0,t[(t[u>>2]|0)+(t[w>>2]<<2)>>2]|0)|0)==0;o=w;g=t[o>>2]|0;y=t[o+4>>2]|0;if(!r)break;r=jY(g|0,y|0,1,0)|0;o=w;t[o>>2]=r;t[o+4>>2]=P}w=f;t[w>>2]=g;t[w+4>>2]=y;v=f;m=v;_=t[m>>2]|0;p=v+4|0;E=p;S=t[E>>2]|0;P=S;s=n;return _|0}t[h>>2]=t[(t[u>>2]|0)+(t[l>>2]<<2)>>2];while(1){t[d>>2]=vu(t[a>>2]|0,t[h>>2]|0)|0;if((t[d>>2]|0)<0){y=l;w=c;g=BY(t[y>>2]|0,t[y+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=P;y=l;F=t[y>>2]|0;O=t[y+4>>2]|0;if((w|0)<0|(w|0)==0&g>>>0<=1){A=11;break}g=b;t[g>>2]=F;t[g+4>>2]=O}else{if((t[d>>2]|0)<=0){A=17;break}g=b;w=l;y=BY(t[g>>2]|0,t[g+4>>2]|0,t[w>>2]|0,t[w+4>>2]|0)|0;w=P;g=l;M=t[g>>2]|0;R=t[g+4>>2]|0;if((w|0)<0|(w|0)==0&y>>>0<=1){A=15;break}y=c;t[y>>2]=M;t[y+4>>2]=R;t[k>>2]=t[h>>2]}y=c;w=t[y>>2]|0;g=t[y+4>>2]|0;y=b;o=c;r=BY(t[y>>2]|0,t[y+4>>2]|0,t[o>>2]|0,t[o+4>>2]|0)|0;o=IY(r|0,P|0,1)|0;r=jY(w|0,g|0,o|0,P|0)|0;o=l;t[o>>2]=r;t[o+4>>2]=P;t[h>>2]=t[(t[u>>2]|0)+(t[l>>2]<<2)>>2]}if((A|0)==11){c=f;t[c>>2]=F;t[c+4>>2]=O;v=f;m=v;_=t[m>>2]|0;p=v+4|0;E=p;S=t[E>>2]|0;P=S;s=n;return _|0}else if((A|0)==15){O=jY(M|0,R|0,1,0)|0;R=f;t[R>>2]=O;t[R+4>>2]=P;v=f;m=v;_=t[m>>2]|0;p=v+4|0;E=p;S=t[E>>2]|0;P=S;s=n;return _|0}else if((A|0)==17){while(1){A=0;R=l;O=jY(t[R>>2]|0,t[R+4>>2]|0,1,0)|0;R=l;t[R>>2]=O;t[R+4>>2]=P;t[h>>2]=t[(t[u>>2]|0)+(O<<2)>>2];if(!(vu(t[a>>2]|0,t[h>>2]|0)|0))A=17;else break}A=l;l=t[A+4>>2]|0;h=f;t[h>>2]=t[A>>2];t[h+4>>2]=l;v=f;m=v;_=t[m>>2]|0;p=v+4|0;E=p;S=t[E>>2]|0;P=S;s=n;return _|0}return 0}function _u(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0;u=s;s=s+32|0;a=u+20|0;o=u+8|0;c=u;l=u+16|0;t[a>>2]=e;e=o;t[e>>2]=i;t[e+4>>2]=r;r=c;t[r>>2]=n;t[r+4>>2]=f;while(1){f=o;r=t[f+4>>2]|0;n=c;e=t[n+4>>2]|0;if((r|0)>(e|0)|((r|0)==(e|0)?(t[f>>2]|0)>>>0>=(t[n>>2]|0)>>>0:0))break;t[l>>2]=t[(t[a>>2]|0)+(t[o>>2]<<2)>>2];t[(t[a>>2]|0)+(t[o>>2]<<2)>>2]=t[(t[a>>2]|0)+(t[c>>2]<<2)>>2];t[(t[a>>2]|0)+(t[c>>2]<<2)>>2]=t[l>>2];n=o;f=jY(t[n>>2]|0,t[n+4>>2]|0,1,0)|0;n=o;t[n>>2]=f;t[n+4>>2]=P;n=c;f=jY(t[n>>2]|0,t[n+4>>2]|0,-1,-1)|0;n=c;t[n>>2]=f;t[n+4>>2]=P}s=u;return}function pu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+8|0;a=r+4|0;t[f>>2]=e;t[u>>2]=i;if((t[t[f>>2]>>2]|0)>>>0>=(t[u>>2]|0)>>>0){s=r;return}t[a>>2]=Jq(t[(t[f>>2]|0)+4>>2]|0,t[u>>2]<<2)|0;if(!(t[a>>2]|0)){i=t[v>>2]|0;t[n>>2]=t[u>>2]<<2;xe(i|0,131856,n|0)|0;_i(1)}t[(t[f>>2]|0)+4>>2]=t[a>>2];t[t[f>>2]>>2]=t[u>>2];s=r;return}function Eu(e){e=e|0;var i=0,r=0,f=0,a=0;i=s;s=s+16|0;r=i+12|0;f=i;a=i+8|0;t[r>>2]=e;t[a>>2]=0;while(1){if((t[a>>2]|0)>=8)break;n[f+(u[131816+(7-(t[a>>2]|0))>>0]|0)>>0]=n[(t[r>>2]|0)+(t[a>>2]|0)>>0]|0;t[a>>2]=(t[a>>2]|0)+1}s=i;return+ +l[f>>3]}function Su(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+8|0;n=i;l[r>>3]=e;l[n>>3]=+l[r>>3];r=n;P=t[r+4>>2]|0;s=i;return t[r>>2]|0}function gu(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;c[r>>2]=e;c[n>>2]=+c[r>>2];s=i;return t[n>>2]|0}function yu(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+128|0;u=f;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f+24|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=0;while(1){h=k+((t[b>>2]<<1)+1)|0;if(!((t[b>>2]|0)<25?(t[b>>2]|0)<(t[c>>2]|0):0))break;n[h>>0]=32;n[k+(t[b>>2]<<1)>>0]=32;t[b>>2]=(t[b>>2]|0)+1}n[h>>0]=0;n[k+(t[b>>2]<<1)>>0]=0;if(!(t[o>>2]|0)){b=t[a>>2]|0;t[u>>2]=k;xe(b|0,127912,u|0)|0;xe(t[a>>2]|0,131072,u|0)|0;s=f;return}while(1){if(!(t[o>>2]|0))break;t[l>>2]=t[o>>2];t[o>>2]=t[(t[o>>2]|0)+24>>2];br(t[a>>2]|0,t[l>>2]|0,t[c>>2]|0)}s=f;return}function Fu(e){e=+e;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+8|0;l[r>>3]=e;ju(+l[r>>3],n)|0;s=i;return t[n>>2]|0}function Ou(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+4>>2]|0))break;t[f>>2]=t[(t[t[r>>2]>>2]|0)+(t[n>>2]<<2)>>2];if(t[(t[f>>2]|0)+4>>2]|0){if(t[(t[(t[f>>2]|0)+4>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[f>>2]|0)+4>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[(t[f>>2]|0)+4>>2]|0)}pAi[t[135736>>2]&511](t[f>>2]|0);t[n>>2]=(t[n>>2]|0)+1}Vu(t[r>>2]|0);s=i;return}function Au(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[f>>2]|0)){Ut(0,130864);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;if((t[n>>2]|0)>0){Mu(t[f>>2]|0,0,t[n>>2]|0)|0;t[(t[f>>2]|0)+4>>2]=0}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Mu(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(t[t[u>>2]>>2]|0){if((t[(t[u>>2]|0)+8>>2]|0)<=(t[(t[u>>2]|0)+4>>2]|0)){if((t[(t[u>>2]|0)+8>>2]|0)>5e7){Ut(0,130904);t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}r=(t[u>>2]|0)+8|0;t[r>>2]=t[r>>2]<<1;r=MAi[t[135760>>2]&511](t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+8>>2]<<2)|0;t[t[u>>2]>>2]=r;if(!(t[t[u>>2]>>2]|0)){Ut(0,130904);t[(t[u>>2]|0)+8>>2]=0;t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}}}else{if((t[o>>2]|0)<=0)t[o>>2]=1;r=gAi[t[135744>>2]&511](t[o>>2]<<2)|0;t[t[u>>2]>>2]=r;if(t[t[u>>2]>>2]|0){t[(t[u>>2]|0)+4>>2]=0;t[(t[u>>2]|0)+8>>2]=t[o>>2];break}Ut(0,130864);t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}while(0);o=t[a>>2]|0;a=(t[u>>2]|0)+4|0;r=t[a>>2]|0;t[a>>2]=r+1;t[(t[t[u>>2]>>2]|0)+(r<<2)>>2]=o;t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}function Ru(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[f>>2]=2;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}if((t[(t[n>>2]|0)+4>>2]|0)==9){t[o>>2]=eF(t[n>>2]|0)|0;if(!(t[o>>2]|0))t[n>>2]=t[(t[n>>2]|0)+12>>2];else t[n>>2]=t[o>>2];if(!(t[n>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}}switch(t[(t[n>>2]|0)+4>>2]|0){case 2:{t[o>>2]=t[(t[n>>2]|0)+12>>2];break}case 1:{t[o>>2]=t[(t[n>>2]|0)+12>>2];break}case 3:case 4:case 7:case 8:{t[a>>2]=t[(t[n>>2]|0)+40>>2];if(!(t[a>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}if(!(u[t[a>>2]>>0]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else{t[r>>2]=(u[t[a>>2]>>0]|0)+((u[(t[a>>2]|0)+1>>0]|0)<<8);l=t[r>>2]|0;s=i;return l|0}break}case 18:{t[a>>2]=t[(t[n>>2]|0)+8>>2];if(!(t[a>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}if(!(u[t[a>>2]>>0]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else{t[r>>2]=(u[t[a>>2]>>0]|0)+((u[(t[a>>2]|0)+1>>0]|0)<<8);l=t[r>>2]|0;s=i;return l|0}break}default:{t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}}e:while(1){if(!(t[o>>2]|0)){b=47;break}switch(t[(t[o>>2]|0)+4>>2]|0){case 18:{t[a>>2]=t[(t[o>>2]|0)+8>>2];break}case 3:case 4:case 7:case 8:{t[a>>2]=t[(t[o>>2]|0)+40>>2];break}default:{}}if((t[a>>2]|0)!=0?(u[t[a>>2]>>0]|0|0)!=0:0){if((t[f>>2]|0)==1){b=30;break}if(u[(t[a>>2]|0)+1>>0]|0){b=33;break}t[f>>2]=1;t[c>>2]=u[t[a>>2]>>0]}if(((t[(t[o>>2]|0)+12>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)!=14:0)?(t[(t[(t[o>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0){t[o>>2]=t[(t[o>>2]|0)+12>>2];continue}if((t[o>>2]|0)==(t[n>>2]|0)){b=47;break}if(t[(t[o>>2]|0)+24>>2]|0){t[o>>2]=t[(t[o>>2]|0)+24>>2];continue}while(1){t[o>>2]=t[(t[o>>2]|0)+20>>2];if(!(t[o>>2]|0))continue e;if((t[o>>2]|0)==(t[n>>2]|0)){b=43;break}k=t[o>>2]|0;if(t[(t[o>>2]|0)+24>>2]|0){b=45;break}if(!k)continue e}if((b|0)==43){b=0;t[o>>2]=0;continue}else if((b|0)==45){b=0;t[o>>2]=t[k+24>>2];continue}}if((b|0)==30){t[r>>2]=(t[c>>2]|0)+((u[t[a>>2]>>0]|0)<<8);l=t[r>>2]|0;s=i;return l|0}else if((b|0)==33){t[r>>2]=(u[t[a>>2]>>0]|0)+((u[(t[a>>2]|0)+1>>0]|0)<<8);l=t[r>>2]|0;s=i;return l|0}else if((b|0)==47){t[r>>2]=t[c>>2];l=t[r>>2]|0;s=i;return l|0}return 0}function Nu(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0)if(!(u[t[n>>2]>>0]|0)){t[r>>2]=0;break}else{t[r>>2]=(u[t[n>>2]>>0]|0)+((u[(t[n>>2]|0)+1>>0]|0)<<8);break}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function Tu(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;do if(!((t[k>>2]|0)==0|(t[b>>2]|0)==0)){if((t[t[b>>2]>>2]|0)!=1?(t[t[b>>2]>>2]|0)!=9:0)break;t[d>>2]=t[(t[b>>2]|0)+4>>2];e:do if(t[d>>2]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[t[d>>2]>>2]|0))break e;t[v>>2]=xn(t[(t[(t[d>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)|0;if((t[v>>2]|0)!=0?(f=t[o>>2]|0,Sn(f,au(t[(t[o>>2]|0)+12>>2]|0,t[v>>2]|0)|0)|0,pAi[t[135736>>2]&511](t[v>>2]|0),gf(t[o>>2]|0,1),f=t[o>>2]|0,Sn(f,Vt(t[(t[o>>2]|0)+12>>2]|0,t[k>>2]|0)|0)|0,t[w>>2]=Sf(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0,(t[w>>2]|0)!=0):0)break e;t[h>>2]=(t[h>>2]|0)+1}}while(0);zt(t[(t[o>>2]|0)+12>>2]|0,t[b>>2]|0);zt(t[(t[o>>2]|0)+12>>2]|0,t[k>>2]|0);t[a>>2]=t[w>>2];m=t[a>>2]|0;s=u;return m|0}while(0);zt(t[(t[o>>2]|0)+12>>2]|0,t[b>>2]|0);zt(t[(t[o>>2]|0)+12>>2]|0,t[k>>2]|0);t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}function Lu(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;do if(!((t[k>>2]|0)==0|(t[b>>2]|0)==0)){if((t[t[b>>2]>>2]|0)!=1?(t[t[b>>2]>>2]|0)!=9:0)break;t[d>>2]=t[(t[b>>2]|0)+4>>2];e:do if(t[d>>2]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[t[d>>2]>>2]|0))break e;t[v>>2]=xn(t[(t[(t[d>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)|0;if((t[v>>2]|0)!=0?(f=t[o>>2]|0,Sn(f,au(t[(t[o>>2]|0)+12>>2]|0,t[v>>2]|0)|0)|0,pAi[t[135736>>2]&511](t[v>>2]|0),f=t[o>>2]|0,Sn(f,Vt(t[(t[o>>2]|0)+12>>2]|0,t[k>>2]|0)|0)|0,t[w>>2]=Sf(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0,(t[w>>2]|0)!=0):0)break e;t[h>>2]=(t[h>>2]|0)+1}}while(0);zt(t[(t[o>>2]|0)+12>>2]|0,t[b>>2]|0);zt(t[(t[o>>2]|0)+12>>2]|0,t[k>>2]|0);t[a>>2]=t[w>>2];m=t[a>>2]|0;s=u;return m|0}while(0);zt(t[(t[o>>2]|0)+12>>2]|0,t[b>>2]|0);zt(t[(t[o>>2]|0)+12>>2]|0,t[k>>2]|0);t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}function Du(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+20|0;l=r+4|0;b=r;t[a>>2]=e;t[o>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[b>>2]=t[t[a>>2]>>2];n[c>>0]=n[t[b>>2]>>0]|0;if(!((u[c>>0]|0)&128)){t[t[o>>2]>>2]=1;t[f>>2]=u[t[b>>2]>>0];k=t[f>>2]|0;s=r;return k|0}e:do if(((u[(t[b>>2]|0)+1>>0]|0)&192|0)==128){do if(((u[c>>0]|0)&224|0)==224){if(((u[(t[b>>2]|0)+2>>0]|0)&192|0)!=128)break e;if(((u[c>>0]|0)&240|0)!=240){t[t[o>>2]>>2]=3;t[l>>2]=((u[t[b>>2]>>0]|0)&15)<<12;t[l>>2]=t[l>>2]|((u[(t[b>>2]|0)+1>>0]|0)&63)<<6;t[l>>2]=t[l>>2]|(u[(t[b>>2]|0)+2>>0]|0)&63;break}if(((u[c>>0]|0)&248|0)!=240)break e;if(((u[(t[b>>2]|0)+3>>0]|0)&192|0)!=128)break e;t[t[o>>2]>>2]=4;t[l>>2]=((u[t[b>>2]>>0]|0)&7)<<18;t[l>>2]=t[l>>2]|((u[(t[b>>2]|0)+1>>0]|0)&63)<<12;t[l>>2]=t[l>>2]|((u[(t[b>>2]|0)+2>>0]|0)&63)<<6;t[l>>2]=t[l>>2]|(u[(t[b>>2]|0)+3>>0]|0)&63}else{t[t[o>>2]>>2]=2;t[l>>2]=((u[t[b>>2]>>0]|0)&31)<<6;t[l>>2]=t[l>>2]|(u[(t[b>>2]|0)+1>>0]|0)&63}while(0);i=t[l>>2]|0;if((t[l>>2]|0)>>>0<256)if(9<=i>>>0&(t[l>>2]|0)>>>0<=10|(t[l>>2]|0)==13|32<=(t[l>>2]|0)>>>0)h=19;else h=18;else if((!(256<=i>>>0&(t[l>>2]|0)>>>0<=55295)?!(57344<=(t[l>>2]|0)>>>0&(t[l>>2]|0)>>>0<=65533):0)?!(65536<=(t[l>>2]|0)>>>0&(t[l>>2]|0)>>>0<=1114111):0)h=18;else h=19;if((h|0)==18){dn(t[a>>2]|0,21);t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}else if((h|0)==19){t[f>>2]=t[l>>2];k=t[f>>2]|0;s=r;return k|0}}while(0);t[t[o>>2]>>2]=0;dn(t[a>>2]|0,20);t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}function Cu(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;qu(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=97){f=27;break}if((u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)!=110){f=27;break}if((u[(t[t[r>>2]>>2]|0)+2>>0]|0|0)!=100){f=27;break}t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];e=t[r>>2]|0;t[e>>2]=(t[e>>2]|0)+3;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)a=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){a=1;break}a=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);o=t[r>>2]|0;if(!a)break;e=t[r>>2]|0;if(!(u[t[o>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}qu(o);if(t[(t[r>>2]|0)+8>>2]|0){f=27;break}Pu(t[(t[r>>2]|0)+32>>2]|0,t[n>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,1,0,0,0,0,0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}if((f|0)==27){s=i;return}}function Pu(e,i,r,n,f,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;l=s;s=s+48|0;b=l+40|0;k=l+36|0;h=l+32|0;w=l+28|0;d=l+24|0;v=l+20|0;m=l+16|0;_=l+12|0;p=l+8|0;E=l+4|0;S=l;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=n;t[v>>2]=f;t[m>>2]=u;t[_>>2]=a;t[p>>2]=o;t[E>>2]=c;do if((t[t[k>>2]>>2]|0)>=(t[(t[k>>2]|0)+4>>2]|0)){if((t[(t[k>>2]|0)+4>>2]|0)>=1e6){Ut(0,130416);t[b>>2]=-1;g=t[b>>2]|0;s=l;return g|0}c=(t[k>>2]|0)+4|0;t[c>>2]=t[c>>2]<<1;t[S>>2]=MAi[t[135760>>2]&511](t[(t[k>>2]|0)+8>>2]|0,(t[(t[k>>2]|0)+4>>2]|0)*40|0)|0;if(t[S>>2]|0){t[(t[k>>2]|0)+8>>2]=t[S>>2];break}c=(t[k>>2]|0)+4|0;t[c>>2]=(t[c>>2]|0)/2|0;Ut(0,130416);t[b>>2]=-1;g=t[b>>2]|0;s=l;return g|0}while(0);t[(t[k>>2]|0)+12>>2]=t[t[k>>2]>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+4>>2]=t[h>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+8>>2]=t[w>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)>>2]=t[d>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+12>>2]=t[v>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+16>>2]=t[m>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+20>>2]=t[_>>2];do if((t[(t[k>>2]|0)+20>>2]|0)!=0?(t[d>>2]|0)==14|(t[d>>2]|0)==13|(t[d>>2]|0)==11:0){_=t[k>>2]|0;if(t[p>>2]|0){m=kz(t[_+20>>2]|0,t[p>>2]|0,-1)|0;t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+24>>2]=m;pAi[t[135736>>2]&511](t[p>>2]|0)}else t[(t[(t[k>>2]|0)+8>>2]|0)+((t[_>>2]|0)*40|0)+24>>2]=0;_=t[k>>2]|0;if(t[E>>2]|0){m=kz(t[_+20>>2]|0,t[E>>2]|0,-1)|0;t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+28>>2]=m;pAi[t[135736>>2]&511](t[E>>2]|0);break}else{t[(t[(t[k>>2]|0)+8>>2]|0)+((t[_>>2]|0)*40|0)+28>>2]=0;break}}else y=15;while(0);if((y|0)==15){t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+24>>2]=t[p>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+28>>2]=t[E>>2]}t[(t[(t[k>>2]|0)+8>>2]|0)+((t[t[k>>2]>>2]|0)*40|0)+32>>2]=0;E=t[k>>2]|0;k=t[E>>2]|0;t[E>>2]=k+1;t[b>>2]=k;g=t[b>>2]|0;s=l;return g|0}function Bu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[a>>2]|0)){Ut(t[u>>2]|0,129952);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+48|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));i=gAi[t[135744>>2]&511](40)|0;t[(t[a>>2]|0)+28>>2]=i;if(!(t[(t[a>>2]|0)+28>>2]|0)){pAi[t[135736>>2]&511](t[a>>2]|0);Ut(t[u>>2]|0,129952);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[(t[a>>2]|0)+20>>2]=0;t[(t[a>>2]|0)+24>>2]=10;t[(t[a>>2]|0)+16>>2]=0;t[(t[a>>2]|0)+44>>2]=0;t[(t[a>>2]|0)+12>>2]=t[u>>2];t[(t[a>>2]|0)+32>>2]=t[f>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function Iu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){Ut(0,t[f>>2]|0);s=r;return}else{t[(t[n>>2]|0)+8>>2]=15;Ut(t[(t[n>>2]|0)+12>>2]|0,t[f>>2]|0);s=r;return}}function Hu(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;f=s;s=s+64|0;u=f+56|0;a=f+52|0;o=f+48|0;c=f+44|0;l=f+40|0;b=f+36|0;k=f+32|0;h=f+28|0;w=f+24|0;d=f+20|0;v=f+16|0;m=f+12|0;_=f+8|0;p=f+4|0;E=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;t[E>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=-1;S=t[u>>2]|0;s=f;return S|0}t[b>>2]=Rj(t[o>>2]|0)|0;if((t[b>>2]|0)==-1){t[u>>2]=-1;S=t[u>>2]|0;s=f;return S|0}if((t[b>>2]|0)==-2)t[b>>2]=1e4;t[k>>2]=Nj(t[o>>2]|0)|0;if((t[k>>2]|0)==-1){t[u>>2]=-1;S=t[u>>2]|0;s=f;return S|0}t[h>>2]=Tj(t[o>>2]|0)|0;if((t[h>>2]|0)<0){t[u>>2]=-1;S=t[u>>2]|0;s=f;return S|0}if(!(t[l>>2]|0)){if(!(t[c>>2]|0)){t[u>>2]=-1;S=t[u>>2]|0;s=f;return S|0}n=ru(t[a>>2]|0,0)|0;t[t[c>>2]>>2]=n;if(!(t[t[c>>2]>>2]|0)){t[u>>2]=-1;S=t[u>>2]|0;s=f;return S|0}}do if(!(t[k>>2]|0)){n=(t[l>>2]|0)!=0;if(t[h>>2]|0){if(!n){Cn(t[(t[t[c>>2]>>2]|0)+4>>2]|0,t[t[a>>2]>>2]|0)|0;break}t[u>>2]=1;S=t[u>>2]|0;s=f;return S|0}else{if(!n){Cn(t[(t[t[c>>2]>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+4>>2]|0)|0;break}t[u>>2]=1;S=t[u>>2]|0;s=f;return S|0}}while(0);if(!(t[b>>2]|0)){t[u>>2]=0;S=t[u>>2]|0;s=f;return S|0}k=t[a>>2]|0;if(!(t[h>>2]|0)){if(t[k+4>>2]|0){switch(t[(t[(t[a>>2]|0)+4>>2]|0)+4>>2]|0){case 21:case 13:case 11:case 9:case 1:{t[m>>2]=t[(t[a>>2]|0)+4>>2];break}default:{}}t[_>>2]=t[m>>2]}}else t[m>>2]=t[k>>2];if(!(t[m>>2]|0)){t[u>>2]=0;S=t[u>>2]|0;s=f;return S|0}t[p>>2]=Aj(t[o>>2]|0)|0;if(!(t[p>>2]|0)){t[u>>2]=0;S=t[u>>2]|0;s=f;return S|0}t[v>>2]=yj(t[p>>2]|0)|0;if((t[h>>2]|0)!=0?(t[w>>2]=pj(t[p>>2]|0,0,0)|0,(t[w>>2]|0)>=0&(t[w>>2]|0)==1):0){if(!(t[l>>2]|0)){Cn(t[(t[t[c>>2]>>2]|0)+4>>2]|0,t[m>>2]|0)|0;g=40}}else g=40;e:do if((g|0)==40){t[d>>2]=0;i:while(1){if((t[(t[m>>2]|0)+4>>2]|0)==18)break;if((((t[(t[m>>2]|0)+12>>2]|0)!=0?(t[d>>2]|0)<(t[b>>2]|0):0)?(t[(t[(t[m>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(t[m>>2]=t[(t[m>>2]|0)+12>>2],t[d>>2]=(t[d>>2]|0)+1,(t[(t[m>>2]|0)+4>>2]|0)!=14):0)g=80;else g=63;r:do if((g|0)==63){g=0;if((t[m>>2]|0)==(t[_>>2]|0))break i;while(1){if(!(t[(t[m>>2]|0)+24>>2]|0))break;t[m>>2]=t[(t[m>>2]|0)+24>>2];if((t[(t[m>>2]|0)+4>>2]|0)==17)continue;if((t[(t[m>>2]|0)+4>>2]|0)!=14)break r}while(1){t[m>>2]=t[(t[m>>2]|0)+20>>2];t[d>>2]=(t[d>>2]|0)+-1;if(!(t[m>>2]|0))break i;if((t[m>>2]|0)==(t[_>>2]|0))break i;n:do if((t[(t[m>>2]|0)+4>>2]|0)==1)t[w>>2]=gj(t[p>>2]|0)|0;else{if(!(t[v>>2]|0))break;do if((t[(t[m>>2]|0)+4>>2]|0)!=3){if((t[(t[m>>2]|0)+4>>2]|0)==4)break;if((t[(t[m>>2]|0)+4>>2]|0)==8)break;if((t[(t[m>>2]|0)+4>>2]|0)!=7)break n}while(0);t[w>>2]=gj(t[p>>2]|0)|0}while(0);y=t[m>>2]|0;if(t[(t[m>>2]|0)+24>>2]|0)break;if(!y){g=80;break r}}t[m>>2]=t[y+24>>2];g=80}while(0);if((g|0)==80?(g=0,!((t[m>>2]|0)!=0&(t[d>>2]|0)>=0)):0)break;r:while(1){t[E>>2]=(t[E>>2]|0)+1;switch(t[(t[m>>2]|0)+4>>2]|0){case 7:case 8:case 4:case 3:case 1:break;default:continue i}if((t[(t[m>>2]|0)+4>>2]|0)==1){if(t[(t[m>>2]|0)+36>>2]|0)F=t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0;else F=0;t[w>>2]=pj(t[p>>2]|0,t[(t[m>>2]|0)+8>>2]|0,F)|0}else{if(!(t[v>>2]|0))continue i;t[w>>2]=Ej(t[p>>2]|0,0,0,t[(t[m>>2]|0)+4>>2]|0)|0}do if((t[w>>2]|0)>=0&(t[w>>2]|0)==1){if(t[l>>2]|0)break e;if((Cn(t[(t[t[c>>2]>>2]|0)+4>>2]|0,t[m>>2]|0)|0)>=0)break;t[(t[a>>2]|0)+136>>2]=12;t[(t[a>>2]|0)+140>>2]=2}while(0);if((t[(t[m>>2]|0)+12>>2]|0)!=0?(t[d>>2]|0)<(t[b>>2]|0):0)continue i;
	t[w>>2]=gj(t[p>>2]|0)|0;while(1){if(!(t[(t[m>>2]|0)+24>>2]|0))continue i;t[m>>2]=t[(t[m>>2]|0)+24>>2];if((t[(t[m>>2]|0)+4>>2]|0)==17)continue;if((t[(t[m>>2]|0)+4>>2]|0)!=14)continue r}}}if(t[p>>2]|0)_j(t[p>>2]|0);t[u>>2]=0;S=t[u>>2]|0;s=f;return S|0}while(0);if(t[p>>2]|0)_j(t[p>>2]|0);t[u>>2]=1;S=t[u>>2]|0;s=f;return S|0}function xu(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;while(1){r=t[t[a>>2]>>2]|0;if(!r){b=3;break}else if((r|0)==11){b=10;break}else if((r|0)==12){b=4;break}else if((r|0)!=18){b=18;break}if((t[(t[a>>2]|0)+4>>2]|0)==-1){b=9;break}t[a>>2]=(t[(t[(t[u>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)}do if((b|0)==3)t[f>>2]=0;else if((b|0)==4){t[c>>2]=t[(t[a>>2]|0)+24>>2];if(t[o>>2]|0){t[f>>2]=vt(t[u>>2]|0,t[c>>2]|0)|0;break}else{t[f>>2]=yn(t[c>>2]|0)|0;break}}else if((b|0)==9)t[f>>2]=0;else if((b|0)==10){if((t[(t[a>>2]|0)+4>>2]|0)==-1){t[f>>2]=0;break}Uu(t[u>>2]|0,(t[(t[(t[u>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=-1;break}Yu(t[u>>2]|0,t[a>>2]|0,0,0,1)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=-1;break}t[c>>2]=En(t[u>>2]|0)|0;if(!(t[c>>2]|0))t[f>>2]=-1;else b=22}else if((b|0)==18){Uu(t[u>>2]|0,t[a>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=-1;break}t[c>>2]=En(t[u>>2]|0)|0;if(!(t[c>>2]|0))t[f>>2]=-1;else b=22}while(0);do if((b|0)==22){if(!(t[c>>2]|0)){t[f>>2]=0;break}do if((t[t[c>>2]>>2]|0)!=2)if(t[o>>2]|0){t[l>>2]=vt(t[u>>2]|0,t[c>>2]|0)|0;break}else{t[l>>2]=yn(t[c>>2]|0)|0;break}else t[l>>2]=t[(t[c>>2]|0)+8>>2];while(0);zt(t[(t[u>>2]|0)+12>>2]|0,t[c>>2]|0);t[f>>2]=t[l>>2]}while(0);s=n;return t[f>>2]|0}function Uu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0;r=s;s=s+192|0;n=r;f=r+184|0;u=r+180|0;a=r+176|0;o=r+172|0;c=r+168|0;b=r+164|0;k=r+160|0;h=r+156|0;w=r+152|0;d=r+148|0;v=r+144|0;m=r+140|0;_=r+136|0;p=r+132|0;E=r+128|0;S=r+124|0;g=r+120|0;y=r+116|0;F=r+112|0;O=r+108|0;A=r+104|0;M=r+100|0;R=r+96|0;N=r+92|0;T=r+88|0;L=r+84|0;D=r+80|0;C=r+76|0;P=r+72|0;B=r+68|0;I=r+64|0;H=r+60|0;x=r+56|0;U=r+52|0;z=r+48|0;j=r+44|0;V=r+40|0;q=r+36|0;Y=r+32|0;G=r+28|0;W=r+24|0;K=r+20|0;X=r+16|0;Z=r+12|0;J=r+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[k>>2]=t[(t[u>>2]|0)+32>>2];do switch(t[t[a>>2]>>2]|0){case 0:{t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}case 8:{jf(t[u>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 10:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}break}case 9:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{i=t[u>>2]|0;Sn(i,ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}break}case 11:{if((t[(t[a>>2]|0)+4>>2]|0)==-1){t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{i=Yu(t[u>>2]|0,t[a>>2]|0,0,0,0)|0;t[o>>2]=(t[o>>2]|0)+i;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}break}case 7:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[w>>2]=En(t[u>>2]|0)|0;if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[h>>2]=En(t[u>>2]|0)|0;if(t[(t[h>>2]|0)+4>>2]|0){if((t[(t[w>>2]|0)+4>>2]|0)!=0?(t[t[(t[w>>2]|0)+4>>2]>>2]|0)!=0:0)$=78}else $=78;if(($|0)==78){i=Pn(t[(t[h>>2]|0)+4>>2]|0,t[(t[w>>2]|0)+4>>2]|0)|0;t[(t[h>>2]|0)+4>>2]=i}Sn(t[u>>2]|0,t[h>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[w>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}case 5:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}do if(t[(t[a>>2]|0)+12>>2]|0){if((t[(t[a>>2]|0)+12>>2]|0)==1){Ff(t[u>>2]|0);break}if((t[(t[a>>2]|0)+12>>2]|0)==2){yf(t[u>>2]|0);break}if((t[(t[a>>2]|0)+12>>2]|0)==3){if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)!=3:0)gf(t[u>>2]|0,1);if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==3:0)break;dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}}else Of(t[u>>2]|0);while(0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 1:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}tt(t[u>>2]|0,1);if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[(t[(t[u>>2]|0)+16>>2]|0)+8>>2]|0)!=0:0){t[w>>2]=En(t[u>>2]|0)|0;t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i;if(t[(t[u>>2]|0)+8>>2]|0){_n(t[w>>2]|0);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{tt(t[u>>2]|0,1);t[h>>2]=En(t[u>>2]|0)|0;i=(t[h>>2]|0)+8|0;t[i>>2]=t[i>>2]&t[(t[w>>2]|0)+8>>2];Sn(t[u>>2]|0,t[h>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[w>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 2:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}tt(t[u>>2]|0,1);if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[(t[(t[u>>2]|0)+16>>2]|0)+8>>2]|0)!=1:0){t[w>>2]=En(t[u>>2]|0)|0;t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i;if(t[(t[u>>2]|0)+8>>2]|0){_n(t[w>>2]|0);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{tt(t[u>>2]|0,1);t[h>>2]=En(t[u>>2]|0)|0;i=(t[h>>2]|0)+8|0;t[i>>2]=t[i>>2]|t[(t[w>>2]|0)+8>>2];Sn(t[u>>2]|0,t[h>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[w>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 4:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];t[o>>2]=(Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0)+(t[o>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{t[b>>2]=Sf(t[u>>2]|0,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0)|0;i=t[u>>2]|0;Sn(i,cu(t[(t[u>>2]|0)+12>>2]|0,t[b>>2]|0)|0)|0;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}break}case 12:{Sn(t[u>>2]|0,Vt(t[(t[u>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0)|0;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 13:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}i=t[(t[u>>2]|0)+12>>2]|0;e=t[a>>2]|0;do if(!(t[(t[a>>2]|0)+28>>2]|0)){t[p>>2]=Yn(i,t[e+24>>2]|0)|0;ee=t[u>>2]|0;if(t[p>>2]|0){Sn(ee,t[p>>2]|0)|0;break}t[ee+8>>2]=5;t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{t[E>>2]=Xn(i,t[e+28>>2]|0)|0;if(!(t[E>>2]|0)){ee=t[33976]|0;ie=t[33980]|0;re=t[(t[a>>2]|0)+28>>2]|0;t[n>>2]=t[(t[a>>2]|0)+24>>2];t[n+4>>2]=re;yAi[ee&511](ie,130032,n);t[(t[u>>2]|0)+8>>2]=19;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}t[p>>2]=Gn(t[(t[u>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+24>>2]|0,t[E>>2]|0)|0;ie=t[u>>2]|0;if(t[p>>2]|0){Sn(ie,t[p>>2]|0)|0;break}t[ie+8>>2]=5;t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}while(0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 14:{t[O>>2]=Gu(t[u>>2]|0)|0;if((t[(t[a>>2]|0)+4>>2]|0)!=-1?(e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0,t[o>>2]=(t[o>>2]|0)+e,(t[(t[u>>2]|0)+8>>2]|0)!=0):0){Wu(t[u>>2]|0,t[O>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[u>>2]|0)+20>>2]|0)<((t[(t[u>>2]|0)+44>>2]|0)+(t[(t[a>>2]|0)+12>>2]|0)|0)){yAi[t[135904>>2]&511](t[33980]|0,130096,n);t[(t[u>>2]|0)+8>>2]=10;Wu(t[u>>2]|0,t[O>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}t[F>>2]=0;while(1){if((t[F>>2]|0)>=(t[(t[a>>2]|0)+12>>2]|0))break;if(!(t[(t[(t[u>>2]|0)+28>>2]|0)+((t[(t[u>>2]|0)+20>>2]|0)-1-(t[F>>2]|0)<<2)>>2]|0)){$=125;break}t[F>>2]=(t[F>>2]|0)+1}if(($|0)==125){yAi[t[135904>>2]&511](t[33980]|0,130096,n);t[(t[u>>2]|0)+8>>2]=10;Wu(t[u>>2]|0,t[O>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}do if(t[(t[a>>2]|0)+32>>2]|0)t[S>>2]=t[(t[a>>2]|0)+32>>2];else{t[A>>2]=0;e=t[(t[u>>2]|0)+12>>2]|0;i=t[a>>2]|0;do if(!(t[(t[a>>2]|0)+28>>2]|0))t[S>>2]=jn(e,t[i+24>>2]|0)|0;else{t[A>>2]=Xn(e,t[i+28>>2]|0)|0;if(t[A>>2]|0){t[S>>2]=Vn(t[(t[u>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+24>>2]|0,t[A>>2]|0)|0;break}ie=t[33976]|0;ee=t[33980]|0;re=t[(t[a>>2]|0)+28>>2]|0;t[n>>2]=t[(t[a>>2]|0)+24>>2];t[n+4>>2]=re;yAi[ie&511](ee,130136,n);Wu(t[u>>2]|0,t[O>>2]|0);t[(t[u>>2]|0)+8>>2]=19;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}while(0);if(t[S>>2]|0){t[(t[a>>2]|0)+32>>2]=t[S>>2];t[(t[a>>2]|0)+36>>2]=t[A>>2];break}i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[(t[a>>2]|0)+24>>2];yAi[i&511](e,130200,n);dn(t[u>>2]|0,9);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}while(0);t[g>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+104>>2];t[y>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+108>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+104>>2]=t[(t[a>>2]|0)+24>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+108>>2]=t[(t[a>>2]|0)+36>>2];EAi[t[S>>2]&511](t[u>>2]|0,t[(t[a>>2]|0)+12>>2]|0);t[(t[(t[u>>2]|0)+12>>2]|0)+104>>2]=t[g>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+108>>2]=t[y>>2];Wu(t[u>>2]|0,t[O>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 18:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)Mn(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 19:{t[G>>2]=0;if((t[(t[a>>2]|0)+4>>2]|0)!=-1){e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e}if((t[(t[a>>2]|0)+8>>2]|0)==-1){t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}e=(t[(t[u>>2]|0)+16>>2]|0)==0;e:do if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)==7){if(!e?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==7:0){t[q>>2]=En(t[u>>2]|0)|0;t[W>>2]=t[(t[q>>2]|0)+28>>2];if((t[W>>2]|0)!=0?(t[t[W>>2]>>2]|0)!=0:0){t[G>>2]=Da(0)|0;t[X>>2]=0;while(1){if((t[X>>2]|0)>=(t[t[W>>2]>>2]|0))break e;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[(t[W>>2]|0)+8>>2]|0)+(t[X>>2]<<2)>>2]|0)+28>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[t[W>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=(t[X>>2]|0)+1;t[Y>>2]=ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0;Sn(t[u>>2]|0,t[Y>>2]|0)|0;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0)break;t[V>>2]=En(t[u>>2]|0)|0;i:do if((t[t[V>>2]>>2]|0)!=7){t[j>>2]=La(t[(t[(t[(t[W>>2]|0)+8>>2]|0)+(t[X>>2]<<2)>>2]|0)+28>>2]|0,t[V>>2]|0)|0;if(t[j>>2]|0)Ca(t[G>>2]|0,t[j>>2]|0)}else{t[J>>2]=t[(t[V>>2]|0)+28>>2];t[Z>>2]=0;while(1){if((t[Z>>2]|0)>=(t[t[J>>2]>>2]|0))break i;t[j>>2]=Ra(t[(t[(t[(t[W>>2]|0)+8>>2]|0)+(t[X>>2]<<2)>>2]|0)+28>>2]|0,t[(t[(t[(t[W>>2]|0)+8>>2]|0)+(t[X>>2]<<2)>>2]|0)+32>>2]|0,t[(t[(t[(t[J>>2]|0)+8>>2]|0)+(t[Z>>2]<<2)>>2]|0)+36>>2]|0,t[(t[(t[(t[J>>2]|0)+8>>2]|0)+(t[Z>>2]<<2)>>2]|0)+40>>2]|0)|0;if(t[j>>2]|0)Ca(t[G>>2]|0,t[j>>2]|0);t[Z>>2]=(t[Z>>2]|0)+1}}while(0);if(t[V>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[V>>2]|0);if((t[(t[u>>2]|0)+16>>2]|0)==(t[Y>>2]|0)){t[V>>2]=En(t[u>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[V>>2]|0)}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[X>>2]=(t[X>>2]|0)+1}_n(t[q>>2]|0);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=0;i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i;t[V>>2]=En(t[u>>2]|0)|0;if(t[V>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[V>>2]|0);Sn(t[u>>2]|0,t[q>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{if(!e?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[q>>2]=En(t[u>>2]|0)|0;t[K>>2]=t[(t[q>>2]|0)+4>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[G>>2]=Da(0)|0;if(!(t[K>>2]|0))break;t[X>>2]=0;while(1){if((t[X>>2]|0)>=(t[t[K>>2]>>2]|0))break e;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[K>>2]|0)+8>>2]|0)+(t[X>>2]<<2)>>2];t[Y>>2]=ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0;Sn(t[u>>2]|0,t[Y>>2]|0)|0;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){i=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+i}if(t[(t[u>>2]|0)+8>>2]|0)break;t[V>>2]=En(t[u>>2]|0)|0;t[j>>2]=La(t[(t[(t[K>>2]|0)+8>>2]|0)+(t[X>>2]<<2)>>2]|0,t[V>>2]|0)|0;if(t[j>>2]|0)Ca(t[G>>2]|0,t[j>>2]|0);if(t[V>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[V>>2]|0);if((t[(t[u>>2]|0)+16>>2]|0)==(t[Y>>2]|0)){t[V>>2]=En(t[u>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[V>>2]|0)}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[X>>2]=(t[X>>2]|0)+1}_n(t[q>>2]|0);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}while(0);zt(t[(t[u>>2]|0)+12>>2]|0,t[q>>2]|0);t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=-1;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=-1;e=t[u>>2]|0;Sn(e,xa(t[G>>2]|0)|0)|0;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 15:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];if((t[(t[a>>2]|0)+4>>2]|0)!=-1?(e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0,t[o>>2]=(t[o>>2]|0)+e,t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2],t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2],t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2],t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2],(t[(t[u>>2]|0)+8>>2]|0)!=0):0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1?(e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0,t[o>>2]=(t[o>>2]|0)+e,t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2],t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2],t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2],t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2],(t[(t[u>>2]|0)+8>>2]|0)!=0):0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 17:case 16:{t[T>>2]=0;do if((t[(t[a>>2]|0)+4>>2]|0)!=-1?(t[(t[a>>2]|0)+8>>2]|0)!=-1:0){if((t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)>>2]|0)!=18?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)>>2]|0)!=17:0)break;if((((t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)>>2]|0)==12?(t[B>>2]=t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)+24>>2],(t[B>>2]|0)!=0):0)?(t[t[B>>2]>>2]|0)==3:0)?+l[(t[B>>2]|0)+16>>3]==1:0){t[I>>2]=0;e=Ku(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,I)|0;t[o>>2]=(t[o>>2]|0)+e;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]=1;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}while(0);if((((((((((t[(t[a>>2]|0)+4>>2]|0)!=-1?(t[(t[a>>2]|0)+8>>2]|0)!=-1:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)>>2]|0)==18:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)>>2]|0)==18:0)?(t[H>>2]=t[(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)+4>>2],(t[H>>2]|0)!=-1):0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[H>>2]|0)*40|0)>>2]|0)==14:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[H>>2]|0)*40|0)+28>>2]|0)==0:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[H>>2]|0)*40|0)+12>>2]|0)==0:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[H>>2]|0)*40|0)+24>>2]|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+8>>2]|0)+((t[H>>2]|0)*40|0)+24>>2]|0,129656)|0)!=0:0){t[x>>2]=0;e=Xu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,x)|0;t[o>>2]=(t[o>>2]|0)+e;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}do if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)!=0:0){if((t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)<=1)break;t[t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]=t[(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)+((t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)-1<<2)>>2];t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]=1}while(0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[a>>2]|0)+4>>2]|0)!=-1){e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[a>>2]|0)+8>>2]|0)==-1){t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}if(!(t[(t[u>>2]|0)+16>>2]|0)){t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}t[D>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)==7){t[U>>2]=0;if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==7:0){t[R>>2]=En(t[u>>2]|0)|0;t[z>>2]=t[(t[R>>2]|0)+28>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;if((t[z>>2]|0)!=0?(t[t[z>>2]>>2]|0)!=0:0){t[U>>2]=Da(0)|0;t[P>>2]=0;while(1){if((t[P>>2]|0)>=(t[t[z>>2]>>2]|0)){$=214;break}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[(t[z>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2]|0)+28>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[t[z>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=(t[P>>2]|0)+1;t[N>>2]=ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0;Sn(t[u>>2]|0,t[N>>2]|0)|0;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e}if(t[(t[u>>2]|0)+8>>2]|0){$=206;break}t[M>>2]=En(t[u>>2]|0)|0;if(vt(t[u>>2]|0,t[M>>2]|0)|0){e=t[U>>2]|0;Ca(e,nf(t[(t[(t[z>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2]|0)|0)}if(t[M>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[M>>2]|0);if((t[(t[u>>2]|0)+16>>2]|0)==(t[N>>2]|0)){t[M>>2]=En(t[u>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[M>>2]|0)}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[P>>2]=(t[P>>2]|0)+1}if(($|0)==206){_n(t[R>>2]|0);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else if(($|0)==214){zt(t[(t[u>>2]|0)+12>>2]|0,t[R>>2]|0);t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=-1;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=-1;e=t[u>>2]|0;Sn(e,xa(t[U>>2]|0)|0)|0;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[D>>2];t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=0;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e}t[M>>2]=En(t[u>>2]|0)|0;if(t[M>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[M>>2]|0);Sn(t[u>>2]|0,t[R>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}else{t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[R>>2]=En(t[u>>2]|0)|0;t[L>>2]=t[(t[R>>2]|0)+4>>2];t[D>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[C>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;if((t[L>>2]|0)!=0?(t[t[L>>2]>>2]|0)!=0:0){t[N>>2]=0;t[T>>2]=Nn(0)|0;t[P>>2]=0;while(1){if((t[P>>2]|0)>=(t[t[L>>2]>>2]|0))break;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[L>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2];if((t[(t[(t[(t[L>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2]|0)+4>>2]|0)!=18?(t[(t[(t[(t[L>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2]|0)+32>>2]|0)!=0:0)t[t[(t[u>>2]|0)+12>>2]>>2]=t[(t[(t[(t[L>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2]|0)+32>>2];do if(!(t[N>>2]|0))t[N>>2]=ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0;else{if((Cn(t[(t[N>>2]|0)+4>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0)>=0)break;t[(t[u>>2]|0)+8>>2]=15}while(0);Sn(t[u>>2]|0,t[N>>2]|0)|0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[t[L>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=(t[P>>2]|0)+1;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e}if(t[(t[u>>2]|0)+8>>2]|0){$=234;break}t[M>>2]=En(t[u>>2]|0)|0;do if(vt(t[u>>2]|0,t[M>>2]|0)|0){if((Dn(t[T>>2]|0,t[(t[(t[L>>2]|0)+8>>2]|0)+(t[P>>2]<<2)>>2]|0)|0)>=0)break;t[(t[u>>2]|0)+8>>2]=15}while(0);if(t[M>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[M>>2]|0);if((t[(t[u>>2]|0)+16>>2]|0)==(t[N>>2]|0)){En(t[u>>2]|0)|0;Zu(t[(t[N>>2]|0)+4>>2]|0,1)}else t[N>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[P>>2]=(t[P>>2]|0)+1}if(($|0)==234){Bn(t[T>>2]|0);_n(t[R>>2]|0);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}if(t[N>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[N>>2]|0);zt(t[(t[u>>2]|0)+12>>2]|0,t[R>>2]|0);t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=-1;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=-1;t[t[(t[u>>2]|0)+12>>2]>>2]=t[C>>2];e=t[u>>2]|0;Sn(e,fu(t[(t[u>>2]|0)+12>>2]|0,t[T>>2]|0)|0)|0}else $=220;if(($|0)==220?(t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=0,t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=0,Sn(t[u>>2]|0,t[R>>2]|0)|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[D>>2],(t[(t[u>>2]|0)+8>>2]|0)!=0):0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[D>>2];t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}dn(t[u>>2]|0,11);t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}case 3:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}e=t[u>>2]|0;if(t[(t[a>>2]|0)+12>>2]|0)t[c>>2]=pf(e)|0;else t[c>>2]=Ef(e)|0;e=t[u>>2]|0;Sn(e,cu(t[(t[u>>2]|0)+12>>2]|0,t[c>>2]|0)|0)|0;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}case 6:{t[v>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[d>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[_>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}t[t[(t[u>>2]|0)+12>>2]>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[m>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[_>>2];e=Uu(t[u>>2]|0,(t[(t[k>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[o>>2]=(t[o>>2]|0)+e;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;Q=t[f>>2]|0;s=r;return Q|0}do if(t[(t[a>>2]|0)+12>>2]|0){if((t[(t[a>>2]|0)+12>>2]|0)==1){Mf(t[u>>2]|0);break}if((t[(t[a>>2]|0)+12>>2]|0)==2)Rf(t[u>>2]|0)}else Af(t[u>>2]|0);while(0);t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}default:{e=t[33976]|0;i=t[33980]|0;t[n>>2]=t[t[a>>2]>>2];yAi[e&511](i,130248,n);t[(t[u>>2]|0)+8>>2]=10;t[f>>2]=t[o>>2];Q=t[f>>2]|0;s=r;return Q|0}}while(0);return 0}function zu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;r=s;s=s+64|0;n=r+52|0;f=r+48|0;u=r+44|0;a=r+40|0;o=r+36|0;c=r+32|0;l=r+28|0;b=r+24|0;k=r+20|0;h=r+16|0;w=r+12|0;d=r+8|0;v=r+4|0;m=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-2;_=t[n>>2]|0;s=r;return _|0}if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;_=t[n>>2]|0;s=r;return _|0}e:do switch(t[(t[f>>2]|0)+4>>2]|0){case 2:{t[l>>2]=1;t[k>>2]=t[f>>2];t[f>>2]=t[(t[f>>2]|0)+20>>2];t[c>>2]=1;p=27;break}case 7:case 8:case 4:case 3:{t[k>>2]=t[f>>2];do if(t[(t[f>>2]|0)+28>>2]|0){while(1){t[f>>2]=t[(t[f>>2]|0)+28>>2];if((t[(t[f>>2]|0)+4>>2]|0)==1){p=17;break}if(!(t[(t[f>>2]|0)+28>>2]|0)){p=19;break}}if((p|0)==17){t[l>>2]=3;break}else if((p|0)==19){t[l>>2]=2;t[f>>2]=t[(t[f>>2]|0)+20>>2];break}}else{t[l>>2]=2;t[f>>2]=t[(t[f>>2]|0)+20>>2]}while(0);if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)==1:0)?0>(t[(t[f>>2]|0)+40>>2]|0):0){t[c>>2]=1;p=27;break e}t[f>>2]=t[k>>2];t[l>>2]=0;p=27;break}case 18:{t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}case 1:{if((t[(t[u>>2]|0)+4>>2]|0)==1){if((0>(t[(t[f>>2]|0)+40>>2]|0)?0>(t[(t[u>>2]|0)+40>>2]|0):0)?(t[(t[f>>2]|0)+32>>2]|0)==(t[(t[u>>2]|0)+32>>2]|0):0){t[v>>2]=0-(t[(t[f>>2]|0)+40>>2]|0);t[m>>2]=0-(t[(t[u>>2]|0)+40>>2]|0);if((t[v>>2]|0)<(t[m>>2]|0)){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}if((t[v>>2]|0)>(t[m>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}else p=27}}else p=27;break}default:p=27}while(0);if((p|0)==27){e:do switch(t[(t[u>>2]|0)+4>>2]|0){case 7:case 8:case 4:case 3:{t[h>>2]=t[u>>2];do if(t[(t[u>>2]|0)+28>>2]|0){while(1){t[u>>2]=t[(t[u>>2]|0)+28>>2];if((t[(t[u>>2]|0)+4>>2]|0)==1){p=31;break}if(!(t[(t[u>>2]|0)+28>>2]|0)){p=33;break}}if((p|0)==31){t[b>>2]=3;break}else if((p|0)==33){t[b>>2]=2;t[u>>2]=t[(t[u>>2]|0)+20>>2];break}}else{t[b>>2]=2;t[u>>2]=t[(t[u>>2]|0)+20>>2]}while(0);if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?0>(t[(t[u>>2]|0)+40>>2]|0):0){t[c>>2]=1;break e}t[u>>2]=t[h>>2];t[b>>2]=0;break}case 2:{t[b>>2]=1;t[h>>2]=t[u>>2];t[u>>2]=t[(t[u>>2]|0)+20>>2];t[c>>2]=1;break}case 18:{t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}default:{}}while(0);e:do if(t[c>>2]|0){if((t[f>>2]|0)!=(t[u>>2]|0)){i:do if((t[b>>2]|0)==3&(t[l>>2]|0)>1){t[w>>2]=t[(t[f>>2]|0)+20>>2];while(1){if(!(t[w>>2]|0))break i;if((t[w>>2]|0)==(t[u>>2]|0))break;t[w>>2]=t[(t[w>>2]|0)+20>>2]}t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}while(0);if(!((t[l>>2]|0)==3&(t[b>>2]|0)>1))break;t[w>>2]=t[(t[u>>2]|0)+20>>2];while(1){if(!(t[w>>2]|0))break e;if((t[w>>2]|0)==(t[f>>2]|0))break;t[w>>2]=t[(t[w>>2]|0)+20>>2]}t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}if((t[l>>2]|0)!=(t[b>>2]|0))if((t[l>>2]|0)<(t[b>>2]|0)){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}else{t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}t[w>>2]=t[(t[h>>2]|0)+28>>2];while(1){if(!(t[w>>2]|0)){p=51;break}if((t[w>>2]|0)==(t[k>>2]|0)){p=47;break}if((t[(t[w>>2]|0)+4>>2]|0)==1){p=49;break}t[w>>2]=t[(t[w>>2]|0)+28>>2]}if((p|0)==47){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}else if((p|0)==49){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}else if((p|0)==51){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}}while(0);if(((((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?0>(t[(t[f>>2]|0)+40>>2]|0):0)?0>(t[(t[u>>2]|0)+40>>2]|0):0)?(t[(t[f>>2]|0)+32>>2]|0)==(t[(t[u>>2]|0)+32>>2]|0):0){t[v>>2]=0-(t[(t[f>>2]|0)+40>>2]|0);t[m>>2]=0-(t[(t[u>>2]|0)+40>>2]|0);if((t[v>>2]|0)<(t[m>>2]|0)){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}if((t[v>>2]|0)>(t[m>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}}}if((t[f>>2]|0)==(t[(t[u>>2]|0)+28>>2]|0)){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}if((t[f>>2]|0)==(t[(t[u>>2]|0)+24>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}t[o>>2]=0;t[w>>2]=t[u>>2];while(1){E=t[w>>2]|0;if(!(t[(t[w>>2]|0)+20>>2]|0))break;if((E|0)==(t[f>>2]|0)){p=83;break}t[o>>2]=(t[o>>2]|0)+1;t[w>>2]=t[(t[w>>2]|0)+20>>2]}if((p|0)==83){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}t[d>>2]=E;t[a>>2]=0;t[w>>2]=t[f>>2];while(1){if(!(t[(t[w>>2]|0)+20>>2]|0))break;if((t[w>>2]|0)==(t[u>>2]|0)){p=88;break}t[a>>2]=(t[a>>2]|0)+1;t[w>>2]=t[(t[w>>2]|0)+20>>2]}if((p|0)==88){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}if((t[d>>2]|0)!=(t[w>>2]|0)){t[n>>2]=-2;_=t[n>>2]|0;s=r;return _|0}while(1){if((t[a>>2]|0)<=(t[o>>2]|0))break;t[a>>2]=(t[a>>2]|0)+-1;t[f>>2]=t[(t[f>>2]|0)+20>>2]}while(1){if((t[o>>2]|0)<=(t[a>>2]|0))break;t[o>>2]=(t[o>>2]|0)+-1;t[u>>2]=t[(t[u>>2]|0)+20>>2]}while(1){S=t[f>>2]|0;if((t[(t[f>>2]|0)+20>>2]|0)==(t[(t[u>>2]|0)+20>>2]|0))break;t[f>>2]=t[S+20>>2];t[u>>2]=t[(t[u>>2]|0)+20>>2];if((t[f>>2]|0)==0|(t[u>>2]|0)==0){p=98;break}}if((p|0)==98){t[n>>2]=-2;_=t[n>>2]|0;s=r;return _|0}if((S|0)==(t[(t[u>>2]|0)+28>>2]|0)){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}if((t[f>>2]|0)==(t[(t[u>>2]|0)+24>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}if(((((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?0>(t[(t[f>>2]|0)+40>>2]|0):0)?0>(t[(t[u>>2]|0)+40>>2]|0):0)?(t[(t[f>>2]|0)+32>>2]|0)==(t[(t[u>>2]|0)+32>>2]|0):0){t[v>>2]=0-(t[(t[f>>2]|0)+40>>2]|0);t[m>>2]=0-(t[(t[u>>2]|0)+40>>2]|0);if((t[v>>2]|0)<(t[m>>2]|0)){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}if((t[v>>2]|0)>(t[m>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}}t[w>>2]=t[(t[f>>2]|0)+24>>2];while(1){if(!(t[w>>2]|0)){p=117;break}if((t[w>>2]|0)==(t[u>>2]|0)){p=115;break}t[w>>2]=t[(t[w>>2]|0)+24>>2]}if((p|0)==115){t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}else if((p|0)==117){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}return 0}function ju(e,i){e=+e;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r;u=r+8|0;l[f>>3]=e;t[u>>2]=i;i=Su(+l[f>>3])|0;a=qY(i|0,P|0,63)|0;t[t[u>>2]>>2]=a;a=fY(+l[f>>3])|0;if((a|0)==3)t[n>>2]=3;else if((a|0)==2)t[n>>2]=4;else if(!a)t[n>>2]=1;else if((a|0)==1)t[n>>2]=0;else t[n>>2]=2;s=r;return t[n>>2]|0}function Vu(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function qu(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;Ju(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=61){if((u[t[t[r>>2]>>2]>>0]|0|0)!=33){a=34;break}if((u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)!=61){a=34;break}}t[f>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];
	if((u[t[t[r>>2]>>2]>>0]|0|0)==61)t[n>>2]=1;else t[n>>2]=0;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;if((t[n>>2]|0)==0?(e=t[r>>2]|0,(u[t[t[r>>2]>>2]>>0]|0|0)!=0):0)t[e>>2]=(t[e>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);c=t[r>>2]|0;if(!o)break;e=t[r>>2]|0;if(!(u[t[c>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}Ju(c);if(t[(t[r>>2]|0)+8>>2]|0){a=34;break}Pu(t[(t[r>>2]|0)+32>>2]|0,t[f>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,3,t[n>>2]|0,0,0,0,0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}if((a|0)==34){s=i;return}}function Yu(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0;u=s;s=s+160|0;a=u;o=u+148|0;c=u+144|0;l=u+140|0;b=u+136|0;k=u+132|0;h=u+128|0;w=u+124|0;d=u+120|0;v=u+116|0;m=u+112|0;_=u+108|0;p=u+104|0;E=u+100|0;S=u+96|0;g=u+92|0;y=u+88|0;F=u+84|0;O=u+80|0;A=u+76|0;M=u+72|0;R=u+68|0;N=u+64|0;T=u+60|0;L=u+56|0;D=u+52|0;C=u+48|0;P=u+44|0;B=u+40|0;I=u+36|0;H=u+32|0;x=u+28|0;U=u+24|0;z=u+20|0;j=u+16|0;V=u+12|0;q=u+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=t[(t[l>>2]|0)+12>>2];t[d>>2]=t[(t[l>>2]|0)+16>>2];t[v>>2]=t[(t[l>>2]|0)+20>>2];t[m>>2]=t[(t[l>>2]|0)+24>>2];t[_>>2]=t[(t[l>>2]|0)+28>>2];t[p>>2]=0;t[E>>2]=0;t[S>>2]=0;t[H>>2]=0;t[j>>2]=t[(t[c>>2]|0)+12>>2];if((t[(t[c>>2]|0)+16>>2]|0)!=0?(t[t[(t[c>>2]|0)+16>>2]>>2]|0)==1:0){t[g>>2]=En(t[c>>2]|0)|0;if((t[m>>2]|0)!=0?(t[p>>2]=Xn(t[j>>2]|0,t[m>>2]|0)|0,(t[p>>2]|0)==0):0){zt(t[j>>2]|0,t[g>>2]|0);dn(t[c>>2]|0,19);t[o>>2]=0;Y=t[o>>2]|0;s=u;return Y|0}t[U>>2]=289;do switch(t[w>>2]|0){case 9:{t[b>>2]=0;t[k>>2]=0;t[H>>2]=300;t[U>>2]=293;break}case 3:{t[b>>2]=0;t[k>>2]=0;t[H>>2]=292;t[U>>2]=293;break}case 7:{t[k>>2]=0;t[H>>2]=298;break}case 11:{t[b>>2]=0;t[H>>2]=302;break}case 8:{t[k>>2]=0;t[H>>2]=299;break}case 1:{t[b>>2]=0;t[H>>2]=290;break}case 12:{t[b>>2]=0;t[H>>2]=303;break}case 6:{t[k>>2]=0;t[H>>2]=297;break}case 4:{t[k>>2]=0;if(((t[d>>2]|0)==5|(t[d>>2]|0)==3)&(t[v>>2]|0)==0)t[H>>2]=294;else t[H>>2]=295;t[U>>2]=293;break}case 13:{t[b>>2]=0;t[k>>2]=0;t[H>>2]=304;t[U>>2]=293;break}case 2:{t[b>>2]=0;t[H>>2]=291;break}case 5:{t[k>>2]=0;t[H>>2]=296;break}case 10:{t[b>>2]=0;t[H>>2]=301;break}default:{}}while(0);if(!(t[H>>2]|0)){zt(t[j>>2]|0,t[g>>2]|0);t[o>>2]=0;Y=t[o>>2]|0;s=u;return Y|0}t[y>>2]=t[(t[g>>2]|0)+4>>2];if((t[y>>2]|0)!=0?(t[t[y>>2]>>2]|0)>0:0){t[T>>2]=0;t[N>>2]=0;t[L>>2]=0;t[D>>2]=0;do if((t[(t[l>>2]|0)+8>>2]|0)!=-1?(t[N>>2]=(t[(t[(t[c>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[l>>2]|0)+8>>2]|0)*40|0),(ra(t[c>>2]|0,t[N>>2]|0,T)|0)!=0):0)if((t[(t[N>>2]|0)+4>>2]|0)!=-1){t[N>>2]=(t[(t[(t[c>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[N>>2]|0)+4>>2]|0)*40|0);t[L>>2]=1;break}else{t[N>>2]=0;t[D>>2]=1;break}while(0);if(t[h>>2]|0)G=(t[N>>2]|0)==0;else G=0;t[I>>2]=G?1:0;t[z>>2]=t[(t[j>>2]|0)+4>>2];t[x>>2]=305;t[A>>2]=0;t[M>>2]=0;t[O>>2]=0;t[F>>2]=0;e:while(1){if(!((t[O>>2]|0)!=0?1:(t[F>>2]|0)<(t[t[y>>2]>>2]|0)))break;if(t[(t[c>>2]|0)+8>>2]|0)break;G=t[F>>2]|0;t[F>>2]=G+1;t[(t[j>>2]|0)+4>>2]=t[(t[(t[y>>2]|0)+8>>2]|0)+(G<<2)>>2];if((t[M>>2]|0)==0?(t[M>>2]=Nn(0)|0,(t[M>>2]|0)==0):0){W=41;break}t[C>>2]=0;t[R>>2]=0;t[S>>2]=0;i:while(1){t[R>>2]=MAi[t[H>>2]&511](t[c>>2]|0,t[R>>2]|0)|0;if(!(t[R>>2]|0)){W=211;break}do if((t[b>>2]|0)!=0?(t[t[b>>2]>>2]|0)!=0:0){if((t[t[b>>2]>>2]|0)==(t[R>>2]|0)){W=211;break i}if((t[E>>2]|0)%256|0)break;if((zu(t[t[b>>2]>>2]|0,t[R>>2]|0)|0)>=0){W=211;break i}}while(0);do if((t[k>>2]|0)!=0?(t[t[k>>2]>>2]|0)!=0:0){if((t[t[k>>2]>>2]|0)==(t[R>>2]|0)){W=211;break i}if((t[E>>2]|0)%256|0)break;if((zu(t[R>>2]|0,t[t[k>>2]>>2]|0)|0)>=0){W=211;break i}}while(0);t[E>>2]=(t[E>>2]|0)+1;r:do switch(t[d>>2]|0){case 5:{do if((t[w>>2]|0)==3){if((t[(t[R>>2]|0)+4>>2]|0)!=2)break r}else{G=t[(t[R>>2]|0)+4>>2]|0;if((t[w>>2]|0)==9)if((G|0)!=18)break r;else break;else if((G|0)!=1)break r;else break}while(0);G=t[(t[R>>2]|0)+4>>2]|0;if((G|0)==18){if((t[(t[R>>2]|0)+4>>2]|0)!=18)break r;t[q>>2]=t[R>>2];if(!((t[_>>2]|0)!=0?(t[(t[q>>2]|0)+12>>2]|0)!=0:0))break r;if(!(Xl(t[(t[q>>2]|0)+12>>2]|0,t[_>>2]|0)|0))break r;if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=197;break i}else break r}t[S>>2]=1;if((Ln(t[M>>2]|0,t[(t[j>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}else if((G|0)==2){t[V>>2]=t[R>>2];if(!(Xl(t[_>>2]|0,t[(t[V>>2]|0)+8>>2]|0)|0))break r;l=t[(t[V>>2]|0)+36>>2]|0;if(!(t[m>>2]|0)){if((l|0)!=0?(t[(t[(t[V>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)break r;if(t[D>>2]|0){f=(t[C>>2]|0)+1|0;t[C>>2]=f;if((f|0)==(t[T>>2]|0)){W=178;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}else{if(!l)break r;if(!(Xl(t[p>>2]|0,t[(t[(t[V>>2]|0)+36>>2]|0)+8>>2]|0)|0))break r;if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=187;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}}else if((G|0)==1){if(!(Xl(t[_>>2]|0,t[(t[R>>2]|0)+8>>2]|0)|0))break r;G=t[(t[R>>2]|0)+36>>2]|0;if(!(t[m>>2]|0)){if(G)break r;if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=158;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}if(!G)break r;if(!(Xl(t[p>>2]|0,t[(t[(t[R>>2]|0)+36>>2]|0)+8>>2]|0)|0))break r;if(t[D>>2]|0){G=(t[C>>2]|0)+1|0;t[C>>2]=G;if((G|0)==(t[T>>2]|0)){W=167;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}else break r;break}case 2:{if((t[(t[R>>2]|0)+4>>2]|0)==7){if((t[_>>2]|0)!=0?(Xl(t[_>>2]|0,t[(t[R>>2]|0)+8>>2]|0)|0)==0:0)break r;if(t[D>>2]|0){G=(t[C>>2]|0)+1|0;t[C>>2]=G;if((G|0)==(t[T>>2]|0)){W=95;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}}break}case 1:{G=t[(t[R>>2]|0)+4>>2]|0;if(!(t[v>>2]|0)){switch(G|0){case 18:case 3:case 4:case 8:case 7:case 2:case 1:case 21:case 13:case 9:break;default:break r}if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=60;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}if((G|0)!=(t[v>>2]|0)){if((t[v>>2]|0)!=3)break r;if((t[(t[R>>2]|0)+4>>2]|0)!=4)break r;if(t[D>>2]|0){G=(t[C>>2]|0)+1|0;t[C>>2]=G;if((G|0)==(t[T>>2]|0)){W=85;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}G=(t[D>>2]|0)!=0;if((t[(t[R>>2]|0)+4>>2]|0)==18){if(G){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=69;break i}else break r}t[S>>2]=1;if((Ln(t[M>>2]|0,t[(t[j>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}else{if(G){G=(t[C>>2]|0)+1|0;t[C>>2]=G;if((G|0)==(t[T>>2]|0)){W=76;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}break}case 0:{W=55;break e;break}case 4:{G=t[33976]|0;l=t[33980]|0;t[a>>2]=128552;t[a+4>>2]=12457;yAi[G&511](l,129064,a);break}case 3:{if((t[w>>2]|0)==3){if((t[(t[R>>2]|0)+4>>2]|0)!=2)break r;if(!(t[m>>2]|0)){if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=105;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}if(!(t[(t[R>>2]|0)+36>>2]|0))break r;if(!(Xl(t[p>>2]|0,t[(t[(t[R>>2]|0)+36>>2]|0)+8>>2]|0)|0))break r;if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=114;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}l=t[(t[R>>2]|0)+4>>2]|0;if((t[w>>2]|0)==9){if((l|0)!=18)break r;if(t[D>>2]|0){G=(t[C>>2]|0)+1|0;t[C>>2]=G;if((G|0)==(t[T>>2]|0)){W=123;break i}else break r}t[S>>2]=1;if((Ln(t[M>>2]|0,t[(t[j>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}if((l|0)!=1)break r;if(!(t[m>>2]|0)){if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=132;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}else break r}if(!(t[(t[R>>2]|0)+36>>2]|0))break r;if(!(Xl(t[p>>2]|0,t[(t[(t[R>>2]|0)+36>>2]|0)+8>>2]|0)|0))break r;if(t[D>>2]|0){l=(t[C>>2]|0)+1|0;t[C>>2]=l;if((l|0)==(t[T>>2]|0)){W=141;break i}else break r}if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;if(t[I>>2]|0){W=208;break e}break}default:{}}while(0);if(!(t[R>>2]|0)){W=211;break}if(t[(t[c>>2]|0)+8>>2]|0){W=211;break}}switch(W|0){case 60:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 69:{W=0;t[S>>2]=1;if((Ln(t[M>>2]|0,t[(t[j>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 76:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 85:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 95:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 105:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 114:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 123:{W=0;t[S>>2]=1;if((Ln(t[M>>2]|0,t[(t[j>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 132:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 141:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 158:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 167:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 178:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 187:{W=0;if((MAi[t[x>>2]&511](t[M>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 197:{W=0;t[S>>2]=1;if((Ln(t[M>>2]|0,t[(t[j>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0)t[(t[c>>2]|0)+8>>2]=15;break}case 211:{W=0;if(t[(t[c>>2]|0)+8>>2]|0)break e;if((t[N>>2]|0)!=0?(t[t[M>>2]>>2]|0)>0:0){t[P>>2]=t[t[M>>2]>>2];l=t[c>>2]|0;G=t[N>>2]|0;f=t[M>>2]|0;n=t[P>>2]|0;if(t[L>>2]|0)t[B>>2]=na(l,G,f,n,t[T>>2]|0,t[T>>2]|0,t[S>>2]|0)|0;else t[B>>2]=fa(l,G,f,n,t[S>>2]|0)|0;if(t[(t[c>>2]|0)+8>>2]|0){W=218;break e}n=t[M>>2]|0;if(!(t[B>>2]|0)){Zu(n,t[S>>2]|0);continue e}if((t[n>>2]|0)<=0)continue e;do if(!(t[A>>2]|0))if((t[P>>2]|0)!=(t[B>>2]|0)){t[A>>2]=dAi[t[U>>2]&511](0,t[M>>2]|0,1)|0;break}else{t[A>>2]=t[M>>2];t[M>>2]=0;break}else t[A>>2]=dAi[t[U>>2]&511](t[A>>2]|0,t[M>>2]|0,(t[P>>2]|0)!=(t[B>>2]|0)?1:0)|0;while(0);if(t[h>>2]|0)break e;else continue e}if((t[t[M>>2]>>2]|0)<=0)continue e;if(!(t[A>>2]|0)){t[A>>2]=t[M>>2];t[M>>2]=0;continue e}else{t[A>>2]=dAi[t[U>>2]&511](t[A>>2]|0,t[M>>2]|0,0)|0;continue e}break}}if(!(t[A>>2]|0)){t[A>>2]=t[M>>2];t[M>>2]=0}else t[A>>2]=dAi[t[U>>2]&511](t[A>>2]|0,t[M>>2]|0,0)|0;if(t[h>>2]|0)break}do if((W|0)==41)t[E>>2]=0;else if((W|0)==55){t[E>>2]=0;h=t[33976]|0;B=t[33980]|0;t[a>>2]=128552;t[a+4>>2]=12379;yAi[h&511](B,129448,a)}else if((W|0)==208)if(!(t[A>>2]|0)){t[A>>2]=t[M>>2];t[M>>2]=0;break}else{t[A>>2]=dAi[t[U>>2]&511](t[A>>2]|0,t[M>>2]|0,0)|0;break}else if((W|0)==218)t[E>>2]=0;while(0);if((t[(t[g>>2]|0)+8>>2]|0)!=0?(t[(t[g>>2]|0)+28>>2]|0)!=0:0){t[(t[(t[c>>2]|0)+16>>2]|0)+8>>2]=1;t[(t[(t[c>>2]|0)+16>>2]|0)+28>>2]=t[(t[g>>2]|0)+28>>2];t[(t[g>>2]|0)+28>>2]=0;t[(t[g>>2]|0)+8>>2]=0}zt(t[j>>2]|0,t[g>>2]|0);do if(!(t[A>>2]|0)){if((t[M>>2]|0)!=0?(t[t[M>>2]>>2]|0)==0:0){t[A>>2]=t[M>>2];break}t[A>>2]=Nn(0)|0}while(0);if((t[M>>2]|0)!=0?(t[M>>2]|0)!=(t[A>>2]|0):0)Bn(t[M>>2]|0);M=t[c>>2]|0;Sn(M,fu(t[j>>2]|0,t[A>>2]|0)|0)|0;t[(t[j>>2]|0)+4>>2]=t[z>>2];t[o>>2]=t[E>>2];Y=t[o>>2]|0;s=u;return Y|0}zt(t[j>>2]|0,t[g>>2]|0);g=t[c>>2]|0;Sn(g,fu(t[j>>2]|0,0)|0)|0;t[o>>2]=0;Y=t[o>>2]|0;s=u;return Y|0}dn(t[c>>2]|0,11);t[o>>2]=0;Y=t[o>>2]|0;s=u;return Y|0}function Gu(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[f>>2]=t[(t[n>>2]|0)+44>>2];t[(t[n>>2]|0)+44>>2]=t[(t[n>>2]|0)+20>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Wu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+20>>2]|0)<(t[(t[n>>2]|0)+44>>2]|0))vn(t[n>>2]|0,128552,2808,23);t[(t[n>>2]|0)+44>>2]=t[f>>2];s=r;return}function Ku(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[b>>2]=t[(t[u>>2]|0)+32>>2];do switch(t[t[a>>2]>>2]|0){case 0:{t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}case 12:{Sn(t[u>>2]|0,Vt(t[(t[u>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0)|0;t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}case 7:{t[c>>2]=Ku(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,t[o>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>=1:0){if((t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1)Mn(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0);t[t[o>>2]>>2]=t[t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]}t[l>>2]=Ku(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0,t[o>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[h>>2]=En(t[u>>2]|0)|0;if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[k>>2]=En(t[u>>2]|0)|0;r=Pn(t[(t[k>>2]|0)+4>>2]|0,t[(t[h>>2]|0)+4>>2]|0)|0;t[(t[k>>2]|0)+4>>2]=r;Sn(t[u>>2]|0,t[k>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[h>>2]|0);if((t[c>>2]|0)>(t[l>>2]|0))ta(t[a>>2]|0);t[f>>2]=(t[c>>2]|0)+(t[l>>2]|0);w=t[f>>2]|0;s=n;return w|0}dn(t[u>>2]|0,11);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}dn(t[u>>2]|0,11);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}case 10:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){r=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+r}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){r=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+r}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}else{t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}break}case 18:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){r=Ku(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,t[o>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+r}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)Mn(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0);t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}case 9:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){r=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+r}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){r=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+r}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}else{r=t[u>>2]|0;Sn(r,ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}break}case 11:{if((t[(t[a>>2]|0)+4>>2]|0)==-1){t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}t[c>>2]=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}else{r=Yu(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,0,0)|0;t[c>>2]=(t[c>>2]|0)+r;t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}break}case 8:{jf(t[u>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}case 17:{t[c>>2]=(ua(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)+(t[c>>2]|0);t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}default:{t[f>>2]=Uu(t[u>>2]|0,t[a>>2]|0)|0;w=t[f>>2]|0;s=n;return w|0}}while(0);return 0}function Xu(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+64|0;f=n+48|0;u=n+44|0;a=n+40|0;o=n+36|0;c=n+32|0;l=n+28|0;b=n+24|0;k=n+20|0;h=n+16|0;w=n+12|0;d=n+8|0;v=n+4|0;m=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}t[b>>2]=t[(t[u>>2]|0)+32>>2];switch(t[t[a>>2]>>2]|0){case 0:{t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}case 11:{if((t[(t[a>>2]|0)+4>>2]|0)==-1){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}t[c>>2]=(Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0)+(t[c>>2]|0);if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}else{r=Yu(t[u>>2]|0,t[a>>2]|0,0,t[o>>2]|0,0)|0;t[c>>2]=(t[c>>2]|0)+r;t[f>>2]=t[c>>2];_=t[f>>2]|0;s=n;return _|0}break}case 7:{t[d>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[w>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[v>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2];t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2];t[c>>2]=Xu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,t[o>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>=1:0){if((t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1)Mn(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0);t[t[o>>2]>>2]=t[(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)+((t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)-1<<2)>>2]}t[t[(t[u>>2]|0)+12>>2]>>2]=t[d>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[w>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=t[v>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[m>>2];t[l>>2]=Xu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0,t[o>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[h>>2]=En(t[u>>2]|0)|0;if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[k>>2]=En(t[u>>2]|0)|0;m=Pn(t[(t[k>>2]|0)+4>>2]|0,t[(t[h>>2]|0)+4>>2]|0)|0;t[(t[k>>2]|0)+4>>2]=m;Sn(t[u>>2]|0,t[k>>2]|0)|0;zt(t[(t[u>>2]|0)+12>>2]|0,t[h>>2]|0);if((t[c>>2]|0)>(t[l>>2]|0))ta(t[a>>2]|0);t[f>>2]=(t[c>>2]|0)+(t[l>>2]|0);_=t[f>>2]|0;s=n;return _|0}dn(t[u>>2]|0,11);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}dn(t[u>>2]|0,11);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}case 10:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){l=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+l}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){l=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+l}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}else{t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[f>>2]=t[c>>2];_=t[f>>2]|0;s=n;return _|0}break}case 9:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){l=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+l}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if((t[(t[a>>2]|0)+8>>2]|0)!=-1){l=Uu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+l}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}else{l=t[u>>2]|0;Sn(l,ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;t[f>>2]=t[c>>2];_=t[f>>2]|0;s=n;return _|0}break}case 8:{jf(t[u>>2]|0);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}case 12:{Sn(t[u>>2]|0,Vt(t[(t[u>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0)|0;t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}case 18:{if((t[(t[a>>2]|0)+4>>2]|0)!=-1){l=Xu(t[u>>2]|0,(t[(t[b>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,t[o>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+l}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)Mn(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0);t[f>>2]=t[c>>2];_=t[f>>2]|0;s=n;return _|0}default:{t[f>>2]=Uu(t[u>>2]|0,t[a>>2]|0)|0;_=t[f>>2]|0;s=n;return _|0}}return 0}function Zu(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[t[n>>2]>>2]|0)<=0){s=r;return}e:do if(t[f>>2]|0){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[t[n>>2]>>2]|0))break e;t[a>>2]=t[(t[(t[n>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)==18:0)Rn(t[a>>2]|0);t[u>>2]=(t[u>>2]|0)+1}}while(0);t[t[n>>2]>>2]=0;s=r;return}function Ju(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;aa(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=60?(u[t[t[r>>2]>>2]>>0]|0|0)!=62:0){if((u[t[t[r>>2]>>2]>>0]|0|0)==60?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==61:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=62){o=40;break e}if((u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)!=61){o=40;break e}}while(0);t[a>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];if((u[t[t[r>>2]>>2]>>0]|0|0)==60)t[n>>2]=1;else t[n>>2]=0;if((u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==61)t[f>>2]=0;else t[f>>2]=1;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;if((t[f>>2]|0)==0?(e=t[r>>2]|0,(u[t[t[r>>2]>>2]>>0]|0|0)!=0):0)t[e>>2]=(t[e>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)c=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){c=1;break}c=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);l=t[r>>2]|0;if(!c)break;e=t[r>>2]|0;if(!(u[t[l>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}aa(l);if(t[(t[r>>2]|0)+8>>2]|0){o=40;break}Pu(t[(t[r>>2]|0)+32>>2]|0,t[a>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,4,t[n>>2]|0,t[f>>2]|0,0,0,0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}if((o|0)==40){s=i;return}}function Qu(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;e:do if((t[u>>2]|0)==0&(t[o>>2]|0)==0){t[u>>2]=oa(t[t[a>>2]>>2]|0)|0;if(!(t[u>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else{if(!(t[t[a>>2]>>2]|0))break;YY(t[(t[u>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[t[a>>2]>>2]<<2|0)|0;t[t[u>>2]>>2]=t[t[a>>2]>>2];break}}else{if(!(t[u>>2]|0))t[u>>2]=Nn(0)|0;if(!(t[u>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[b>>2]=t[t[u>>2]>>2];t[c>>2]=0;i:while(1){if((t[c>>2]|0)>=(t[t[a>>2]>>2]|0))break e;t[h>>2]=t[(t[(t[a>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2];r:do if(t[h>>2]|0){t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[b>>2]|0))break;t[k>>2]=t[(t[(t[u>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2];if((t[k>>2]|0)==(t[h>>2]|0))break r;if((((t[(t[k>>2]|0)+4>>2]|0)==18?(t[(t[h>>2]|0)+4>>2]|0)==18:0)?(t[t[k>>2]>>2]|0)==(t[t[h>>2]>>2]|0):0)?(Xl(t[(t[k>>2]|0)+12>>2]|0,t[(t[h>>2]|0)+12>>2]|0)|0)!=0:0){m=20;break}t[l>>2]=(t[l>>2]|0)+1}if((m|0)==20){m=0;t[(t[(t[a>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]=0;Rn(t[h>>2]|0);break}if(t[(t[u>>2]|0)+4>>2]|0){if((t[t[u>>2]>>2]|0)>=(t[(t[u>>2]|0)+4>>2]|0)){if((t[(t[u>>2]|0)+4>>2]|0)>=1e7){m=28;break i}t[w>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+4>>2]<<1<<2)|0;if(!(t[w>>2]|0)){m=30;break i}t[(t[u>>2]|0)+8>>2]=t[w>>2];r=(t[u>>2]|0)+4|0;t[r>>2]=t[r>>2]<<1}}else{r=gAi[t[135744>>2]&511](40)|0;t[(t[u>>2]|0)+8>>2]=r;if(!(t[(t[u>>2]|0)+8>>2]|0)){m=24;break i}r=(t[(t[u>>2]|0)+8>>2]|0)+0|0;i=r+40|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[u>>2]|0)+4>>2]=10}r=t[h>>2]|0;if((t[(t[h>>2]|0)+4>>2]|0)==18){t[d>>2]=r;i=jt(t[t[d>>2]>>2]|0,t[d>>2]|0)|0;e=t[u>>2]|0;_=t[e>>2]|0;t[e>>2]=_+1;t[(t[(t[u>>2]|0)+8>>2]|0)+(_<<2)>>2]=i;break}else{i=t[u>>2]|0;_=t[i>>2]|0;t[i>>2]=_+1;t[(t[(t[u>>2]|0)+8>>2]|0)+(_<<2)>>2]=r;break}}while(0);t[c>>2]=(t[c>>2]|0)+1}if((m|0)==24){Ut(0,128712);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==28){Ut(0,128736);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==30){Ut(0,128712);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}}while(0);t[t[a>>2]>>2]=0;t[f>>2]=t[u>>2];v=t[f>>2]|0;s=n;return v|0}function $u(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;r=t[u>>2]|0;if(!(t[a>>2]|0)){t[f>>2]=r;k=t[f>>2]|0;s=n;return k|0}e:do if((r|0)==0&(t[o>>2]|0)==0){t[u>>2]=oa(t[t[a>>2]>>2]|0)|0;if(!(t[u>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else{if(!(t[t[a>>2]>>2]|0))break;YY(t[(t[u>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[t[a>>2]>>2]<<2|0)|0;t[t[u>>2]>>2]=t[t[a>>2]>>2];break}}else{if(!(t[u>>2]|0))t[u>>2]=Nn(0)|0;if(!(t[u>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[t[a>>2]>>2]|0))break e;t[l>>2]=t[(t[(t[a>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2];if(t[l>>2]|0){if(t[(t[u>>2]|0)+4>>2]|0){if((t[t[u>>2]>>2]|0)>=(t[(t[u>>2]|0)+4>>2]|0)){if((t[(t[u>>2]|0)+4>>2]|0)>=1e7){h=21;break}t[b>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+4>>2]<<1<<2)|0;if(!(t[b>>2]|0)){h=23;break}t[(t[u>>2]|0)+8>>2]=t[b>>2];i=(t[u>>2]|0)+4|0;t[i>>2]=t[i>>2]<<1}}else{i=gAi[t[135744>>2]&511](40)|0;t[(t[u>>2]|0)+8>>2]=i;if(!(t[(t[u>>2]|0)+8>>2]|0)){h=17;break}i=(t[(t[u>>2]|0)+8>>2]|0)+0|0;e=i+40|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[u>>2]|0)+4>>2]=10}i=t[l>>2]|0;e=t[u>>2]|0;w=t[e>>2]|0;t[e>>2]=w+1;t[(t[(t[u>>2]|0)+8>>2]|0)+(w<<2)>>2]=i}t[c>>2]=(t[c>>2]|0)+1}if((h|0)==17){Ut(0,128712);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else if((h|0)==21){Ut(0,128736);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else if((h|0)==23){Ut(0,128712);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}}while(0);t[t[a>>2]>>2]=0;t[f>>2]=t[u>>2];k=t[f>>2]|0;s=n;return k|0}function ea(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){if(t[u>>2]|0){switch(t[(t[u>>2]|0)+4>>2]|0){case 20:case 8:case 7:case 4:case 6:case 5:case 3:case 1:break;default:{t[n>>2]=0;break e}}if(!(t[(t[u>>2]|0)+24>>2]|0)){t[n>>2]=0;break}i=t[(t[u>>2]|0)+24>>2]|0;if((t[(t[(t[u>>2]|0)+24>>2]|0)+4>>2]|0)==1){t[n>>2]=i;break}t[u>>2]=i;do{t[u>>2]=t[(t[u>>2]|0)+24>>2];if(!(t[u>>2]|0))break}while((t[(t[u>>2]|0)+4>>2]|0)!=1);t[n>>2]=t[u>>2];break}t[u>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];if(!(t[u>>2]|0)){t[n>>2]=0;break}switch(t[(t[u>>2]|0)+4>>2]|0){case 21:case 13:case 9:{t[n>>2]=eF(t[u>>2]|0)|0;break e;break}case 6:case 5:case 11:case 1:{t[u>>2]=t[(t[u>>2]|0)+12>>2];if(!(t[u>>2]|0)){t[n>>2]=0;break e}if((t[(t[u>>2]|0)+4>>2]|0)==1){t[n>>2]=t[u>>2];break e}do{t[u>>2]=t[(t[u>>2]|0)+24>>2];if(!(t[u>>2]|0))break}while((t[(t[u>>2]|0)+4>>2]|0)!=1);t[n>>2]=t[u>>2];break e;break}default:{t[n>>2]=0;break e}}}else a=3;while(0);if((a|0)==3)t[n>>2]=0;s=r;return t[n>>2]|0}function ia(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){do if(!(t[u>>2]|0)){t[u>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2];if(!(t[u>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[u>>2]|0)+4>>2]|0)!=18){t[(t[f>>2]|0)+40>>2]=t[(t[u>>2]|0)+20>>2];break}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}while(0);if((t[(t[u>>2]|0)+4>>2]|0)==18){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[u>>2]|0)+28>>2]|0)!=0?(t[(t[(t[u>>2]|0)+28>>2]|0)+4>>2]|0)==14:0)t[u>>2]=t[(t[u>>2]|0)+28>>2];while(1){o=t[u>>2]|0;if(t[(t[u>>2]|0)+28>>2]|0){c=23;break}t[u>>2]=t[o+20>>2];if(!(t[u>>2]|0)){c=17;break}if((t[u>>2]|0)==(t[(t[t[(t[f>>2]|0)+12>>2]>>2]|0)+12>>2]|0)){c=19;break}l=t[u>>2]|0;if((t[u>>2]|0)!=(t[(t[f>>2]|0)+40>>2]|0)){c=21;break}t[(t[f>>2]|0)+40>>2]=t[l+20>>2]}if((c|0)==17){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else if((c|0)==19){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else if((c|0)==21){t[n>>2]=l;a=t[n>>2]|0;s=r;return a|0}else if((c|0)==23){t[u>>2]=t[o+28>>2];while(1){b=t[u>>2]|0;if(!(t[(t[u>>2]|0)+16>>2]|0))break;t[u>>2]=t[b+16>>2]}t[n>>2]=b;a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function ra(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,b=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[t[a>>2]>>2]|0)!=16?(t[t[a>>2]>>2]|0)!=17:0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}if((t[(t[a>>2]|0)+8>>2]|0)==-1){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=(t[(t[(t[u>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0);if(((((t[c>>2]|0)!=0?(t[t[c>>2]>>2]|0)==12:0)?(t[(t[c>>2]|0)+24>>2]|0)!=0:0)?(t[t[(t[c>>2]|0)+24>>2]>>2]|0)==3:0)?(t[t[o>>2]>>2]=~~+l[(t[(t[c>>2]|0)+24>>2]|0)+16>>3],+l[(t[(t[c>>2]|0)+24>>2]|0)+16>>3]==+(t[t[o>>2]>>2]|0)):0){t[f>>2]=1;b=t[f>>2]|0;s=n;return b|0}t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}function na(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0;o=s;s=s+96|0;c=o+88|0;l=o+84|0;b=o+80|0;k=o+76|0;h=o+72|0;w=o+68|0;d=o+64|0;v=o+60|0;m=o+56|0;_=o+52|0;p=o+48|0;E=o+44|0;S=o+40|0;g=o+36|0;y=o+32|0;F=o+28|0;O=o+24|0;A=o+20|0;M=o+16|0;R=o+12|0;N=o+8|0;T=o+4|0;L=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;if((t[(t[b>>2]|0)+4>>2]|0)!=-1){t[m>>2]=t[(t[l>>2]|0)+32>>2];t[h>>2]=fa(t[l>>2]|0,(t[(t[m>>2]|0)+8>>2]|0)+((t[(t[b>>2]|0)+4>>2]|0)*40|0)|0,t[k>>2]|0,t[h>>2]|0,t[v>>2]|0)|0;if(t[(t[l>>2]|0)+8>>2]|0){t[c>>2]=0;D=t[c>>2]|0;s=o;return D|0}if((t[h>>2]|0)<=0){t[c>>2]=0;D=t[c>>2]|0;s=o;return D|0}}if((t[h>>2]|0)<(t[w>>2]|0)){Zu(t[k>>2]|0,t[v>>2]|0);t[c>>2]=0;D=t[c>>2]|0;s=o;return D|0}if((t[(t[b>>2]|0)+8>>2]|0)==-1){t[c>>2]=t[h>>2];D=t[c>>2]|0;s=o;return D|0}t[E>>2]=0;t[S>>2]=0;t[g>>2]=0;t[O>>2]=0;t[A>>2]=0;t[R>>2]=0;t[N>>2]=t[(t[l>>2]|0)+12>>2];t[M>>2]=t[(t[N>>2]|0)+4>>2];t[_>>2]=t[t[N>>2]>>2];t[F>>2]=(t[(t[(t[l>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[b>>2]|0)+8>>2]|0)*40|0);t[p>>2]=0;e:while(1){if((t[p>>2]|0)>=(t[t[k>>2]>>2]|0))break;do if(t[(t[(t[k>>2]|0)+8>>2]|0)+(t[p>>2]<<2)>>2]|0){t[R>>2]=t[(t[(t[k>>2]|0)+8>>2]|0)+(t[p>>2]<<2)>>2];t[(t[N>>2]|0)+4>>2]=t[R>>2];t[(t[N>>2]|0)+68>>2]=t[h>>2];b=(t[g>>2]|0)+1|0;t[g>>2]=b;t[(t[N>>2]|0)+72>>2]=b;if((t[(t[R>>2]|0)+4>>2]|0)!=18?(t[(t[R>>2]|0)+32>>2]|0)!=0:0)t[t[N>>2]>>2]=t[(t[R>>2]|0)+32>>2];if(t[O>>2]|0){if((Cn(t[(t[O>>2]|0)+4>>2]|0,t[R>>2]|0)|0)<0){C=19;break e}}else t[O>>2]=ru(t[N>>2]|0,t[R>>2]|0)|0;t[T>>2]=Gu(t[l>>2]|0)|0;Sn(t[l>>2]|0,t[O>>2]|0)|0;t[y>>2]=xu(t[l>>2]|0,t[F>>2]|0,1)|0;t[L>>2]=En(t[l>>2]|0)|0;Wu(t[l>>2]|0,t[T>>2]|0);if((t[y>>2]|0)==-1?1:(t[(t[l>>2]|0)+8>>2]|0)!=0){C=21;break e}Sn(t[l>>2]|0,t[L>>2]|0)|0;if(t[y>>2]|0)t[E>>2]=(t[E>>2]|0)+1;if(((t[y>>2]|0)!=0?(t[E>>2]|0)>=(t[w>>2]|0):0)?(t[E>>2]|0)<=(t[d>>2]|0):0){t[S>>2]=(t[S>>2]|0)+1;if((t[w>>2]|0)==(t[d>>2]|0)){C=29;break e}if((t[E>>2]|0)==(t[d>>2]|0)){C=33;break e}}else C=34;if((C|0)==34?(C=0,t[(t[(t[k>>2]|0)+8>>2]|0)+(t[p>>2]<<2)>>2]=0,(t[(t[R>>2]|0)+4>>2]|0)==18):0)Rn(t[R>>2]|0);if(t[A>>2]|0){zt(t[(t[l>>2]|0)+12>>2]|0,t[A>>2]|0);t[A>>2]=0}if((t[(t[l>>2]|0)+16>>2]|0)==(t[O>>2]|0)){En(t[l>>2]|0)|0;Zu(t[(t[O>>2]|0)+4>>2]|0,t[v>>2]|0);break}else{t[O>>2]=0;break}}while(0);t[p>>2]=(t[p>>2]|0)+1}if((C|0)==19)t[(t[l>>2]|0)+8>>2]=15;else if((C|0)==21){while(1){C=0;if((t[L>>2]|0)==(t[O>>2]|0))break;zt(t[N>>2]|0,t[L>>2]|0);t[L>>2]=En(t[l>>2]|0)|0;C=21}Zu(t[k>>2]|0,t[v>>2]|0);t[S>>2]=0}else if((C|0)==29){if((t[(t[R>>2]|0)+4>>2]|0)==18)t[(t[(t[k>>2]|0)+8>>2]|0)+(t[p>>2]<<2)>>2]=0;
	Zu(t[k>>2]|0,t[v>>2]|0);t[t[k>>2]>>2]=1;t[t[(t[k>>2]|0)+8>>2]>>2]=t[R>>2]}else if((C|0)==33)ca(t[k>>2]|0,(t[p>>2]|0)+1|0,t[v>>2]|0);if(t[O>>2]|0){if((t[(t[l>>2]|0)+16>>2]|0)==(t[O>>2]|0))En(t[l>>2]|0)|0;zt(t[N>>2]|0,t[O>>2]|0)}if(t[A>>2]|0)zt(t[(t[l>>2]|0)+12>>2]|0,t[A>>2]|0);t[(t[N>>2]|0)+4>>2]=t[M>>2];t[t[N>>2]>>2]=t[_>>2];t[(t[N>>2]|0)+68>>2]=-1;t[(t[N>>2]|0)+72>>2]=-1;t[c>>2]=t[S>>2];D=t[c>>2]|0;s=o;return D|0}function fa(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;u=s;s=s+80|0;a=u+68|0;o=u+64|0;c=u+60|0;l=u+56|0;b=u+52|0;k=u+48|0;h=u+44|0;w=u+40|0;d=u+36|0;v=u+32|0;m=u+28|0;_=u+24|0;p=u+20|0;E=u+16|0;S=u+12|0;g=u+8|0;y=u+4|0;F=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if((t[(t[c>>2]|0)+4>>2]|0)!=-1){t[h>>2]=t[(t[o>>2]|0)+32>>2];t[b>>2]=fa(t[o>>2]|0,(t[(t[h>>2]|0)+8>>2]|0)+((t[(t[c>>2]|0)+4>>2]|0)*40|0)|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;if(t[(t[o>>2]|0)+8>>2]|0){t[a>>2]=0;O=t[a>>2]|0;s=u;return O|0}if((t[b>>2]|0)<=0){t[a>>2]=0;O=t[a>>2]|0;s=u;return O|0}}if((t[(t[c>>2]|0)+8>>2]|0)==-1){t[a>>2]=t[b>>2];O=t[a>>2]|0;s=u;return O|0}t[w>>2]=t[(t[o>>2]|0)+12>>2];t[E>>2]=0;t[y>>2]=0;t[F>>2]=0;t[v>>2]=t[(t[w>>2]|0)+4>>2];t[m>>2]=t[t[w>>2]>>2];t[g>>2]=(t[(t[(t[o>>2]|0)+32>>2]|0)+8>>2]|0)+((t[(t[c>>2]|0)+8>>2]|0)*40|0);t[S>>2]=0;t[_>>2]=0;e:while(1){if((t[_>>2]|0)>=(t[t[l>>2]>>2]|0)){A=27;break}do if(t[(t[(t[l>>2]|0)+8>>2]|0)+(t[_>>2]<<2)>>2]|0){t[d>>2]=t[(t[(t[l>>2]|0)+8>>2]|0)+(t[_>>2]<<2)>>2];t[(t[w>>2]|0)+4>>2]=t[d>>2];t[(t[w>>2]|0)+68>>2]=t[b>>2];c=(t[E>>2]|0)+1|0;t[E>>2]=c;t[(t[w>>2]|0)+72>>2]=c;if((t[(t[d>>2]|0)+4>>2]|0)!=18?(t[(t[d>>2]|0)+32>>2]|0)!=0:0)t[t[w>>2]>>2]=t[(t[d>>2]|0)+32>>2];if(t[y>>2]|0){if((Cn(t[(t[y>>2]|0)+4>>2]|0,t[d>>2]|0)|0)<0){A=16;break e}}else t[y>>2]=ru(t[w>>2]|0,t[d>>2]|0)|0;Sn(t[o>>2]|0,t[y>>2]|0)|0;t[p>>2]=xu(t[o>>2]|0,t[g>>2]|0,1)|0;if((t[p>>2]|0)==-1?1:(t[(t[o>>2]|0)+8>>2]|0)!=0){A=18;break e}if(!(t[p>>2]|0)){t[(t[(t[l>>2]|0)+8>>2]|0)+(t[_>>2]<<2)>>2]=0;if((t[(t[d>>2]|0)+4>>2]|0)==18)Rn(t[d>>2]|0)}else t[S>>2]=(t[S>>2]|0)+1;if((t[(t[o>>2]|0)+16>>2]|0)==(t[y>>2]|0)){En(t[o>>2]|0)|0;Zu(t[(t[y>>2]|0)+4>>2]|0,t[k>>2]|0);break}else{t[y>>2]=0;break}}while(0);t[_>>2]=(t[_>>2]|0)+1}if((A|0)==16)t[(t[o>>2]|0)+8>>2]=15;else if((A|0)==18){Zu(t[l>>2]|0,t[k>>2]|0);t[S>>2]=0}else if((A|0)==27?(t[y>>2]|0)!=0:0){if((t[(t[o>>2]|0)+16>>2]|0)==(t[y>>2]|0))En(t[o>>2]|0)|0;zt(t[w>>2]|0,t[y>>2]|0)}if(t[F>>2]|0)zt(t[(t[o>>2]|0)+12>>2]|0,t[F>>2]|0);t[(t[w>>2]|0)+4>>2]=t[v>>2];t[t[w>>2]>>2]=t[m>>2];t[(t[w>>2]|0)+68>>2]=-1;t[(t[w>>2]|0)+72>>2]=-1;t[a>>2]=t[S>>2];O=t[a>>2]|0;s=u;return O|0}function ta(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(t[32574]|0){s=i;return}t[n>>2]=t[(t[r>>2]|0)+4>>2];t[(t[r>>2]|0)+4>>2]=t[(t[r>>2]|0)+8>>2];t[(t[r>>2]|0)+8>>2]=t[n>>2];s=i;return}function ua(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;n=s;s=s+80|0;f=n+72|0;u=n+68|0;a=n+64|0;o=n+60|0;c=n+56|0;l=n+52|0;b=n+48|0;k=n+44|0;h=n+40|0;w=n+36|0;d=n+32|0;v=n+28|0;m=n+24|0;_=n+20|0;p=n+16|0;E=n+12|0;S=n+8|0;g=n+4|0;y=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}t[l>>2]=t[(t[u>>2]|0)+32>>2];if((((((((((t[(t[a>>2]|0)+4>>2]|0)!=-1?(t[(t[a>>2]|0)+8>>2]|0)!=-1:0)?(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)>>2]|0)==18:0)?(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)>>2]|0)==18:0)?(t[m>>2]=t[(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)+4>>2],(t[m>>2]|0)!=-1):0)?(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[m>>2]|0)*40|0)>>2]|0)==14:0)?(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[m>>2]|0)*40|0)+28>>2]|0)==0:0)?(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[m>>2]|0)*40|0)+12>>2]|0)==0:0)?(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[m>>2]|0)*40|0)+24>>2]|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+8>>2]|0)+((t[m>>2]|0)*40|0)+24>>2]|0,129656)|0)!=0:0){t[_>>2]=0;m=Xu(t[u>>2]|0,(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0,_)|0;t[c>>2]=(t[c>>2]|0)+m;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}if(((((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0){t[t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]=t[(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)+((t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]|0)-1<<2)>>2];t[t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]>>2]=1;t[t[o>>2]>>2]=t[t[(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]}t[f>>2]=t[c>>2];F=t[f>>2]|0;s=n;return F|0}if((t[(t[a>>2]|0)+4>>2]|0)!=-1){m=Uu(t[u>>2]|0,(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+4>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+m}if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}if((t[(t[a>>2]|0)+8>>2]|0)==-1){t[f>>2]=t[c>>2];F=t[f>>2]|0;s=n;return F|0}if(!(t[(t[u>>2]|0)+16>>2]|0)){t[f>>2]=t[c>>2];F=t[f>>2]|0;s=n;return F|0}t[w>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)!=7){if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==1:0){t[k>>2]=En(t[u>>2]|0)|0;t[h>>2]=t[(t[k>>2]|0)+4>>2];t[w>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2];t[d>>2]=t[t[(t[u>>2]|0)+12>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;if((t[h>>2]|0)!=0?(t[t[h>>2]>>2]|0)!=0:0){t[y>>2]=0;t[g>>2]=Nn(0)|0;t[v>>2]=0;while(1){if((t[v>>2]|0)>=(t[t[h>>2]>>2]|0))break;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[h>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2];if((t[(t[(t[(t[h>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2]|0)+4>>2]|0)!=18?(t[(t[(t[(t[h>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2]|0)+32>>2]|0)!=0:0)t[t[(t[u>>2]|0)+12>>2]>>2]=t[(t[(t[(t[h>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2]|0)+32>>2];if(t[y>>2]|0){if((Cn(t[(t[y>>2]|0)+4>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0)<0)t[(t[u>>2]|0)+8>>2]=15}else t[y>>2]=ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0;Sn(t[u>>2]|0,t[y>>2]|0)|0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[t[h>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=(t[v>>2]|0)+1;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){m=Uu(t[u>>2]|0,(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+m}if(t[(t[u>>2]|0)+8>>2]|0){O=85;break}t[b>>2]=En(t[u>>2]|0)|0;do if(vt(t[u>>2]|0,t[b>>2]|0)|0){if((Dn(t[g>>2]|0,t[(t[(t[h>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2]|0)|0)>=0)break;t[(t[u>>2]|0)+8>>2]=15}while(0);if(t[b>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[b>>2]|0);if((t[(t[u>>2]|0)+16>>2]|0)==(t[y>>2]|0)){En(t[u>>2]|0)|0;Zu(t[(t[y>>2]|0)+4>>2]|0,1)}else t[y>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;if((t[t[g>>2]>>2]|0)>0){O=95;break}t[v>>2]=(t[v>>2]|0)+1}if((O|0)==85){Bn(t[g>>2]|0);_n(t[k>>2]|0);t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}else if((O|0)==95)t[t[o>>2]>>2]=t[t[(t[g>>2]|0)+8>>2]>>2];if(t[y>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[y>>2]|0);zt(t[(t[u>>2]|0)+12>>2]|0,t[k>>2]|0);t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=-1;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=-1;t[t[(t[u>>2]|0)+12>>2]>>2]=t[d>>2];d=t[u>>2]|0;Sn(d,fu(t[(t[u>>2]|0)+12>>2]|0,t[g>>2]|0)|0)|0}else O=71;if((O|0)==71?(t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=0,t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=0,Sn(t[u>>2]|0,t[k>>2]|0)|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[w>>2],(t[(t[u>>2]|0)+8>>2]|0)!=0):0){t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[w>>2];t[f>>2]=t[c>>2];F=t[f>>2]|0;s=n;return F|0}dn(t[u>>2]|0,11);t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}t[p>>2]=0;t[E>>2]=0;if((t[(t[u>>2]|0)+16>>2]|0)!=0?(t[t[(t[u>>2]|0)+16>>2]>>2]|0)==7:0){t[k>>2]=En(t[u>>2]|0)|0;t[S>>2]=t[(t[k>>2]|0)+28>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;if((t[S>>2]|0)!=0?(t[t[S>>2]>>2]|0)!=0:0){t[E>>2]=Da(0)|0;t[v>>2]=0;while(1){if((t[v>>2]|0)>=(t[t[S>>2]>>2]|0))break;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[(t[S>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2]|0)+28>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=t[t[S>>2]>>2];t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=(t[v>>2]|0)+1;if(t[p>>2]|0){if((Cn(t[(t[p>>2]|0)+4>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0)<0)t[(t[u>>2]|0)+8>>2]=15}else t[p>>2]=ru(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)|0;Sn(t[u>>2]|0,t[p>>2]|0)|0;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){g=Uu(t[u>>2]|0,(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+g}if(t[(t[u>>2]|0)+8>>2]|0){O=52;break}t[b>>2]=En(t[u>>2]|0)|0;if(vt(t[u>>2]|0,t[b>>2]|0)|0){g=t[E>>2]|0;Ca(g,Vt(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[S>>2]|0)+8>>2]|0)+(t[v>>2]<<2)>>2]|0)|0)}if(t[b>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[b>>2]|0);if((t[(t[u>>2]|0)+16>>2]|0)==(t[p>>2]|0)){En(t[u>>2]|0)|0;Zu(t[(t[p>>2]|0)+4>>2]|0,1)}else t[p>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;A=t[v>>2]|0;if((t[t[E>>2]>>2]|0)>0){O=61;break}t[v>>2]=A+1}if((O|0)==52){_n(t[k>>2]|0);t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}else if((O|0)==61)t[t[o>>2]>>2]=t[(t[(t[(t[S>>2]|0)+8>>2]|0)+(A<<2)>>2]|0)+28>>2];if(t[p>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[p>>2]|0);zt(t[(t[u>>2]|0)+12>>2]|0,t[k>>2]|0);t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=-1;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=-1;p=t[u>>2]|0;Sn(p,xa(t[E>>2]|0)|0)|0;t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]=t[w>>2];t[f>>2]=t[c>>2];F=t[f>>2]|0;s=n;return F|0}t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]=0;t[(t[(t[u>>2]|0)+12>>2]|0)+72>>2]=0;if((t[(t[a>>2]|0)+8>>2]|0)!=-1){w=Uu(t[u>>2]|0,(t[(t[l>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+8>>2]|0)*40|0)|0)|0;t[c>>2]=(t[c>>2]|0)+w}t[b>>2]=En(t[u>>2]|0)|0;if(t[b>>2]|0)zt(t[(t[u>>2]|0)+12>>2]|0,t[b>>2]|0);Sn(t[u>>2]|0,t[k>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0){t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}else{t[f>>2]=t[c>>2];F=t[f>>2]|0;s=n;return F|0}}dn(t[u>>2]|0,11);t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}function aa(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;la(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=43?(u[t[t[r>>2]>>2]>>0]|0|0)!=45:0){a=30;break}t[f>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];if((u[t[t[r>>2]>>2]>>0]|0|0)==43)t[n>>2]=1;else t[n>>2]=0;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);c=t[r>>2]|0;if(!o)break;e=t[r>>2]|0;if(!(u[t[c>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}la(c);if(t[(t[r>>2]|0)+8>>2]|0){a=30;break}Pu(t[(t[r>>2]|0)+32>>2]|0,t[f>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,5,t[n>>2]|0,0,0,0,0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}if((a|0)==30){s=i;return}}function oa(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[f>>2]|0)){Ut(0,128632);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;if((t[n>>2]|0)<10)t[n>>2]=10;e=gAi[t[135744>>2]&511](t[n>>2]<<2)|0;t[(t[f>>2]|0)+8>>2]=e;if(!(t[(t[f>>2]|0)+8>>2]|0)){Ut(0,128632);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{VY(t[(t[f>>2]|0)+8>>2]|0,0,t[n>>2]<<2|0)|0;t[(t[f>>2]|0)+4>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function ca(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}if((t[t[f>>2]>>2]|0)<=0){s=n;return}if((t[u>>2]|0)>=(t[t[f>>2]>>2]|0)){s=n;return}e:do if(t[a>>2]|0){t[o>>2]=t[u>>2];while(1){if((t[o>>2]|0)>=(t[t[f>>2]>>2]|0))break e;t[c>>2]=t[(t[(t[f>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2];if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==18:0)Rn(t[c>>2]|0);t[o>>2]=(t[o>>2]|0)+1}}while(0);t[t[f>>2]>>2]=t[u>>2];s=n;return}function la(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;sa(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=42){if(((u[t[t[r>>2]>>2]>>0]|0|0)==100?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==105:0)?(u[(t[t[r>>2]>>2]|0)+2>>0]|0|0)==118:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=109){a=37;break e}if((u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)!=111){a=37;break e}if((u[(t[t[r>>2]>>2]|0)+2>>0]|0|0)!=100){a=37;break e}}while(0);t[n>>2]=-1;t[f>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];do if((u[t[t[r>>2]>>2]>>0]|0|0)==42){t[n>>2]=0;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1}else{if((u[t[t[r>>2]>>2]>>0]|0|0)==100){t[n>>2]=1;e=t[r>>2]|0;t[e>>2]=(t[e>>2]|0)+3;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==109){t[n>>2]=2;e=t[r>>2]|0;t[e>>2]=(t[e>>2]|0)+3}}while(0);while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);c=t[r>>2]|0;if(!o)break;e=t[r>>2]|0;if(!(u[t[c>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}sa(c);if(t[(t[r>>2]|0)+8>>2]|0){a=37;break}Pu(t[(t[r>>2]|0)+32>>2]|0,t[f>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,6,t[n>>2]|0,0,0,0,0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}if((a|0)==37){s=i;return}}function sa(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=45)break;t[n>>2]=1-(t[n>>2]|0);t[f>>2]=1;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}ba(t[r>>2]|0);if(!((t[f>>2]|0)!=0?(t[(t[r>>2]|0)+8>>2]|0)==0:0)){s=i;return}f=t[(t[r>>2]|0)+32>>2]|0;e=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0;if(t[n>>2]|0){Pu(f,e,-1,5,2,0,0,0,0)|0;s=i;return}else{Pu(f,e,-1,5,3,0,0,0,0)|0;s=i;return}}function ba(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;ka(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=124)break;t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];Pu(t[(t[r>>2]|0)+32>>2]|0,-1,-1,9,0,0,0,0,0)|0;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);a=t[r>>2]|0;if(!f)break;e=t[r>>2]|0;if(!(u[t[a>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}ka(a);Pu(t[(t[r>>2]|0)+32>>2]|0,t[n>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,7,0,0,0,0,0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}s=i;return}function ka(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[n>>2]=1;t[f>>2]=0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);c=u[t[t[r>>2]>>2]>>0]|0;if(!o)break;e=t[r>>2]|0;if(!c)continue;t[e>>2]=(t[e>>2]|0)+1}do if((c|0)!=36?(u[t[t[r>>2]>>2]>>0]|0|0)!=40:0){if(48<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=57:0){l=18;break}if((u[t[t[r>>2]>>2]>>0]|0|0)!=39?(u[t[t[r>>2]>>2]>>0]|0|0)!=34:0){if(((u[t[t[r>>2]>>2]>>0]|0|0)==46?48<=(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0):0)?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)<=57:0){l=18;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==42){t[n>>2]=1;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==47){t[n>>2]=1;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==64){t[n>>2]=1;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==46){t[n>>2]=1;break}while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)b=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){b=1;break}b=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);k=t[r>>2]|0;if(!b)break;o=t[r>>2]|0;if(!(u[t[k>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}t[f>>2]=ha(k)|0;if((t[f>>2]|0)!=0?(is(t[f>>2]|0,130432)|0)!=0:0){t[n>>2]=1;pAi[t[135736>>2]&511](t[f>>2]|0);break}if(!(t[f>>2]|0)){dn(t[r>>2]|0,7);s=i;return}t[a>>2]=rs(t[f>>2]|0)|0;e:while(1){if(!(u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0))break;if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)==47){l=41;break}do if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)?(u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)<=10:0)break;if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)!=13){l=46;break e}}while(0);t[a>>2]=(t[a>>2]|0)+1}e:do if((l|0)==41)t[n>>2]=1;else if((l|0)==46){if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)==58){t[n>>2]=1;break}if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)==40)if(dt(t[f>>2]|0)|0){t[n>>2]=1;break}else{t[n>>2]=0;break}if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)==91){t[n>>2]=1;break}do if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)!=60?(u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)!=62:0){if((u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0|0)==61)break;t[n>>2]=1;break e}while(0);t[n>>2]=1}while(0);if(!(u[(t[t[r>>2]>>2]|0)+(t[a>>2]|0)>>0]|0))t[n>>2]=1;pAi[t[135736>>2]&511](t[f>>2]|0)}else l=18}else l=18;while(0);if((l|0)==18)t[n>>2]=0;l=t[r>>2]|0;do if(!(t[n>>2]|0)){da(l);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}if((u[t[t[r>>2]>>2]>>0]|0|0)==47?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==47:0){f=t[r>>2]|0;t[f>>2]=(t[f>>2]|0)+2;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);w=t[r>>2]|0;if(!h)break;f=t[r>>2]|0;if(!(u[t[w>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}Pu(t[w+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0;Pu(t[(t[r>>2]|0)+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,10,1,0,0,0,0)|0;va(t[r>>2]|0);break}if((u[t[t[r>>2]>>2]>>0]|0|0)==47)va(t[r>>2]|0)}else{f=t[(t[r>>2]|0)+32>>2]|0;if((u[t[l>>2]>>0]|0|0)==47)Pu(f,-1,-1,8,0,0,0,0,0)|0;else Pu(f,-1,-1,9,0,0,0,0,0)|0;wa(t[r>>2]|0)}while(0);e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);l=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[l>>2]=(t[l>>2]|0)+1}s=i;return}function ha(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[f>>2]=0;t[o>>2]=t[t[n>>2]>>2];t[a>>2]=Du(t[n>>2]|0,u)|0;e:do if(!((t[a>>2]|0)==32|(t[a>>2]|0)==62|(t[a>>2]|0)==47)){e=t[a>>2]|0;if((t[a>>2]|0)<256){if(((!(65<=(e|0)&(t[a>>2]|0)<=90)?!(97<=(t[a>>2]|0)&(t[a>>2]|0)<=122):0)?!(192<=(t[a>>2]|0)&(t[a>>2]|0)<=214):0)?!(216<=(t[a>>2]|0)&(t[a>>2]|0)<=246|248<=(t[a>>2]|0)):0)l=8}else if(!(dj(e,199744)|0))l=8;do if((l|0)==8){e=t[a>>2]|0;if((t[a>>2]|0)<256)if((e|0)!=95&(t[a>>2]|0)!=58)break e;else break;if(!(19968<=(e|0)&(t[a>>2]|0)<=40869|(t[a>>2]|0)==12295)?(12321<=(t[a>>2]|0)&(t[a>>2]|0)<=12329^1)&(t[a>>2]|0)!=95&(t[a>>2]|0)!=58:0)break e}while(0);i:while(1){if(!((t[a>>2]|0)!=32&(t[a>>2]|0)!=62&(t[a>>2]|0)!=47))break;e=t[a>>2]|0;if((t[a>>2]|0)<256){if(((!(65<=(e|0)&(t[a>>2]|0)<=90)?!(97<=(t[a>>2]|0)&(t[a>>2]|0)<=122):0)?!(192<=(t[a>>2]|0)&(t[a>>2]|0)<=214):0)?!(216<=(t[a>>2]|0)&(t[a>>2]|0)<=246|248<=(t[a>>2]|0)):0)l=20}else if(!(dj(e,199744)|0))l=20;do if((l|0)==20){l=0;if((t[a>>2]|0)>=256){if(19968<=(t[a>>2]|0)&(t[a>>2]|0)<=40869|(t[a>>2]|0)==12295)break;if(12321<=(t[a>>2]|0)&(t[a>>2]|0)<=12329)break}e=t[a>>2]|0;if((t[a>>2]|0)<256){if(48<=(e|0)&(t[a>>2]|0)<=57|(t[a>>2]|0)==46|(t[a>>2]|0)==45|(t[a>>2]|0)==95|(t[a>>2]|0)==58)break}else{b=(dj(e,200216)|0)!=0;if(b|(t[a>>2]|0)==46|(t[a>>2]|0)==45|(t[a>>2]|0)==95|(t[a>>2]|0)==58)break}if((t[a>>2]|0)>=256?(dj(t[a>>2]|0,200144)|0)!=0:0)break;b=t[a>>2]|0;if((t[a>>2]|0)<256)k=(b|0)==183&1;else k=dj(b,200272)|0;if(!k)break i}while(0);t[f>>2]=(t[f>>2]|0)+(t[u>>2]|0);b=t[n>>2]|0;t[b>>2]=(t[b>>2]|0)+(t[u>>2]|0);t[a>>2]=Du(t[n>>2]|0,u)|0}t[c>>2]=ql(t[o>>2]|0,(t[t[n>>2]>>2]|0)-(t[o>>2]|0)|0)|0;t[t[n>>2]>>2]=t[o>>2];t[r>>2]=t[c>>2];h=t[r>>2]|0;s=i;return h|0}while(0);t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}function wa(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+16|0;r=i;t[r>>2]=e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);f=u[t[t[r>>2]>>2]>>0]|0;if(!n)break;e=t[r>>2]|0;if(!f)continue;t[e>>2]=(t[e>>2]|0)+1}if((f|0)!=47){va(t[r>>2]|0);s=i;return}while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=47){a=44;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==47?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==47:0){f=t[r>>2]|0;t[f>>2]=(t[f>>2]|0)+2;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);c=t[r>>2]|0;if(!o)break;f=t[r>>2]|0;if(!(u[t[c>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}Pu(t[c+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0;va(t[r>>2]|0)}else a=23;e:do if((a|0)==23?(a=0,(u[t[t[r>>2]>>2]>>0]|0|0)==47):0){f=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);b=(u[t[t[r>>2]>>2]>>0]|0|0)!=0;if(!l)break;f=t[r>>2]|0;if(!b)continue;t[f>>2]=(t[f>>2]|0)+1}if(b){if(!(65<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=90:0))a=36;do if((a|0)==36){a=0;if(97<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=122:0)break;if((((u[t[t[r>>2]>>2]>>0]|0|0)!=95?(u[t[t[r>>2]>>2]>>0]|0|0)!=46:0)?(u[t[t[r>>2]>>2]>>0]|0|0)!=64:0)?(u[t[t[r>>2]>>2]>>0]|0|0)!=42:0)break e}while(0);va(t[r>>2]|0)}}while(0);if(t[(t[r>>2]|0)+8>>2]|0){a=44;break}}if((a|0)==44){s=i;return}}function da(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;ma(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=91)break;_a(t[r>>2]|0,1);while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}s=i;return}function va(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+16|0;r=i;t[r>>2]=e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);f=u[t[t[r>>2]>>2]>>0]|0;if(!n)break;e=t[r>>2]|0;if(!f)continue;t[e>>2]=(t[e>>2]|0)+1}if((f|0)==47?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==47:0){f=t[r>>2]|0;t[f>>2]=(t[f>>2]|0)+2;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)a=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){a=1;break}a=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);o=t[r>>2]|0;if(!a)break;f=t[r>>2]|0;if(!(u[t[o>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}Pu(t[o+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0}else c=20;e:do if((c|0)==20?(u[t[t[r>>2]>>2]>>0]|0|0)==47:0){o=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);o=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}}while(0);pa(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);o=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}e:while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=47)break;if((u[t[t[r>>2]>>2]>>0]|0|0)==47?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==47:0){o=t[r>>2]|0;t[o>>2]=(t[o>>2]|0)+2;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);b=t[r>>2]|0;if(!l)break;o=t[r>>2]|0;if(!(u[t[b>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}Pu(t[b+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0;pa(t[r>>2]|0)}else c=48;if((c|0)==48?(c=0,(u[t[t[r>>2]>>2]>>0]|0|0)==47):0){o=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);h=t[r>>2]|0;if(!k)break;o=t[r>>2]|0;if(!(u[t[h>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}pa(h)}while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue e}while(0);o=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}}s=i;return}function ma(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i;t[r>>2]=e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);f=u[t[t[r>>2]>>2]>>0]|0;if(!n)break;e=t[r>>2]|0;if(!f)continue;t[e>>2]=(t[e>>2]|0)+1}n=t[r>>2]|0;e:do if((f|0)==36)Ea(n);else{e=u[t[t[r>>2]>>2]>>0]|0;if((u[t[n>>2]>>0]|0|0)!=40){if(!(48<=(e|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=57:0))a=34;do if((a|0)==34){if(((u[t[t[r>>2]>>2]>>0]|0|0)==46?48<=(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0):0)?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)<=57:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=39?(u[t[t[r>>2]>>2]>>0]|0|0)!=34:0){ya(t[r>>2]|0);break e}ga(t[r>>2]|0);break e}while(0);Sa(t[r>>2]|0);break}o=t[r>>2]|0;if(e)t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)c=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){c=1;break}c=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);l=t[r>>2]|0;if(!c)break;o=t[r>>2]|0;if(!(u[t[l>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}ku(l,1);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}e=t[r>>2]|0;if((u[t[t[r>>2]>>2]>>0]|0|0)!=41){dn(e,7);s=i;return}o=t[r>>2]|0;if(u[t[e>>2]>>0]|0)t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);o=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}}while(0);e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);l=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[l>>2]=(t[l>>2]|0)+1}s=i;return}function _a(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2];while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[n>>2]>>2]>>0]|0|0)==13}while(0);c=u[t[t[n>>2]>>2]>>0]|0;if(!o)break;i=t[n>>2]|0;if(!c)continue;t[i>>2]=(t[i>>2]|0)+1}o=t[n>>2]|0;if((c|0)!=91){dn(o,6);s=r;return}c=t[n>>2]|0;if(u[t[o>>2]>>0]|0)t[c>>2]=(t[c>>2]|0)+1;while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[n>>2]>>2]>>0]|0|0)==13}while(0);b=t[n>>2]|0;if(!l)break;c=t[n>>2]|0;if(!(u[t[b>>2]>>0]|0))continue;t[c>>2]=(t[c>>2]|0)+1}t[(t[b+32>>2]|0)+12>>2]=-1;b=t[n>>2]|0;if(t[f>>2]|0)ku(b,1);else ku(b,0);if(t[(t[n>>2]|0)+8>>2]|0){s=r;return}if((u[t[t[n>>2]>>2]>>0]|0|0)!=93){dn(t[n>>2]|0,6);s=r;return}b=t[(t[n>>2]|0)+32>>2]|0;l=t[a>>2]|0;a=t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2]|0;if(t[f>>2]|0)Pu(b,l,a,17,0,0,0,0,0)|0;else Pu(b,l,a,16,0,0,0,0,0)|0;a=t[n>>2]|0;if(u[t[t[n>>2]>>2]>>0]|0)t[a>>2]=(t[a>>2]|0)+1;e:while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[n>>2]>>2]>>0]|0|0)!=13)break e}while(0);a=t[n>>2]|0;if(!(u[t[t[n>>2]>>2]>>0]|0))continue;t[a>>2]=(t[a>>2]|0)+1}s=r;return}function pa(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=-1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);w=u[t[t[r>>2]>>2]>>0]|0;if(!h)break;e=t[r>>2]|0;if(!w)continue;t[e>>2]=(t[e>>2]|0)+1}if((w|0)==46?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==46:0){w=t[r>>2]|0;t[w>>2]=(t[w>>2]|0)+2;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)d=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){d=1;break}d=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);v=t[r>>2]|0;if(!d)break;w=t[r>>2]|0;if(!(u[t[v>>2]>>0]|0))continue;t[w>>2]=(t[w>>2]|0)+1}Pu(t[v+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,10,1,0,0,0)|0;s=i;return}if((u[t[t[r>>2]>>2]>>0]|0|0)==46){v=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[v>>2]=(t[v>>2]|0)+1;e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);v=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[v>>2]=(t[v>>2]|0)+1}s=i;return}t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;t[l>>2]=0;t[b>>2]=0;if(((t[(t[r>>2]|0)+36>>2]|0)!=0?(t[a>>2]=ht(t[r>>2]|0)|0,(t[a>>2]|0)!=0):0)?(Xl(t[a>>2]|0,130440)|0)!=0:0){t[f>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];pAi[t[135736>>2]&511](t[a>>2]|0);while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)m=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);_=u[t[t[r>>2]>>2]>>0]|0;if(!m)break;v=t[r>>2]|0;if(!_)continue;t[v>>2]=(t[v>>2]|0)+1}m=t[r>>2]|0;if((_|0)!=40){dn(m,7);s=i;return}_=t[r>>2]|0;if(u[t[m>>2]>>0]|0)t[_>>2]=(t[_>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)p=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){p=1;break}p=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);E=t[r>>2]|0;if(!p)break;_=t[r>>2]|0;if(!(u[t[E>>2]>>0]|0))continue;t[_>>2]=(t[_>>2]|0)+1}ku(E,1);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)S=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){S=1;break}S=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);g=u[t[t[r>>2]>>2]>>0]|0;if(!S)break;E=t[r>>2]|0;if(!g)continue;t[E>>2]=(t[E>>2]|0)+1}S=t[r>>2]|0;if((g|0)!=41){dn(S,7);s=i;return}g=t[r>>2]|0;if(u[t[S>>2]>>0]|0)t[g>>2]=(t[g>>2]|0)+1;t[n>>2]=1}else{do if((u[t[t[r>>2]>>2]>>0]|0|0)==42)t[l>>2]=4;else{if(!(t[a>>2]|0))t[a>>2]=ht(t[r>>2]|0)|0;if(!(t[a>>2]|0)){if((u[t[t[r>>2]>>2]>>0]|0|0)!=64){t[l>>2]=4;break}g=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[g>>2]=(t[g>>2]|0)+1;t[l>>2]=3;break}t[l>>2]=Fa(t[a>>2]|0)|0;if(!(t[l>>2]|0)){t[l>>2]=4;break}while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)y=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){y=1;break}y=(u[t[t[r>>2]>>2]>>0]|0|0)==13;
	}while(0);F=u[t[t[r>>2]>>2]>>0]|0;if(!y)break;g=t[r>>2]|0;if(!F)continue;t[g>>2]=(t[g>>2]|0)+1}if((F|0)==58?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==58:0){g=t[r>>2]|0;t[g>>2]=(t[g>>2]|0)+2;pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0;break}t[l>>2]=4}while(0);if(t[(t[r>>2]|0)+8>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);s=i;return}t[a>>2]=Oa(t[r>>2]|0,c,b,o,t[a>>2]|0)|0;if(!(t[c>>2]|0)){s=i;return}if((((t[o>>2]|0)!=0?(t[(t[r>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[r>>2]|0)+12>>2]|0)+196>>2]&1|0)!=0:0)?(Xn(t[(t[r>>2]|0)+12>>2]|0,t[o>>2]|0)|0)==0:0)dn(t[r>>2]|0,19)}t[k>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]=-1;e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);F=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[F>>2]=(t[F>>2]|0)+1}while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=91)break;_a(t[r>>2]|0,0)}F=t[(t[r>>2]|0)+32>>2]|0;if(t[n>>2]|0){Pu(F,t[f>>2]|0,t[k>>2]|0,19,0,0,0,0,0)|0;s=i;return}else{Pu(F,t[k>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,11,t[l>>2]|0,t[c>>2]|0,t[b>>2]|0,t[o>>2]|0,t[a>>2]|0)|0;s=i;return}}function Ea(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)a=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){a=1;break}a=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);o=u[t[t[r>>2]>>2]>>0]|0;if(!a)break;e=t[r>>2]|0;if(!o)continue;t[e>>2]=(t[e>>2]|0)+1}a=t[r>>2]|0;if((o|0)!=36){dn(a,4);s=i;return}o=t[r>>2]|0;if(u[t[a>>2]>>0]|0)t[o>>2]=(t[o>>2]|0)+1;t[n>>2]=Aa(t[r>>2]|0,f)|0;o=t[r>>2]|0;if(!(t[n>>2]|0)){dn(o,4);s=i;return}t[(t[o+32>>2]|0)+12>>2]=-1;Pu(t[(t[r>>2]|0)+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,13,0,0,0,t[n>>2]|0,t[f>>2]|0)|0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)c=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){c=1;break}c=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);l=t[r>>2]|0;if(!c)break;f=t[r>>2]|0;if(!(u[t[l>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}if(!(t[l+12>>2]|0)){s=i;return}if(!(t[(t[(t[r>>2]|0)+12>>2]|0)+196>>2]&2)){s=i;return}dn(t[r>>2]|0,24);s=i;return}function Sa(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+64|0;r=i+48|0;n=i+16|0;f=i+44|0;a=i+40|0;o=i+36|0;c=i+32|0;b=i+8|0;k=i+28|0;h=i+24|0;w=i;t[r>>2]=e;l[n>>3]=0;t[f>>2]=0;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}do if((u[t[t[r>>2]>>2]>>0]|0|0)!=46){if((u[t[t[r>>2]>>2]>>0]|0|0)>=48?(u[t[t[r>>2]>>2]>>0]|0|0)<=57:0)break;dn(t[r>>2]|0,1);s=i;return}while(0);l[n>>3]=0;while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)<48)break;if((u[t[t[r>>2]>>2]>>0]|0|0)>57)break;l[n>>3]=+l[n>>3]*10;t[c>>2]=(u[t[t[r>>2]>>2]>>0]|0)-48;t[f>>2]=1;e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;l[b>>3]=+((t[c>>2]|0)>>>0);l[n>>3]=+l[n>>3]+ +l[b>>3]}e:do if((u[t[t[r>>2]>>2]>>0]|0|0)==46){t[h>>2]=0;l[w>>3]=0;b=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[b>>2]=(t[b>>2]|0)+1;if((u[t[t[r>>2]>>2]>>0]|0|0)<48){if(!(t[f>>2]|0))d=18}else if(!((t[f>>2]|0)!=0?1:(u[t[t[r>>2]>>2]>>0]|0|0)<=57))d=18;if((d|0)==18){dn(t[r>>2]|0,1);s=i;return}while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)<48)break;if(!((t[h>>2]|0)<20?(u[t[t[r>>2]>>2]>>0]|0|0)<=57:0))break;t[k>>2]=(u[t[t[r>>2]>>2]>>0]|0)-48;l[w>>3]=+l[w>>3]*10+ +(t[k>>2]|0);t[h>>2]=(t[h>>2]|0)+1;b=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[b>>2]=(t[b>>2]|0)+1}l[w>>3]=+l[w>>3]/+l[129232+(t[h>>2]<<3)>>3];l[n>>3]=+l[n>>3]+ +l[w>>3];while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)<48)break e;if((u[t[t[r>>2]>>2]>>0]|0|0)>57)break e;b=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[b>>2]=(t[b>>2]|0)+1}}while(0);if(!((u[t[t[r>>2]>>2]>>0]|0|0)!=101?(u[t[t[r>>2]>>2]>>0]|0|0)!=69:0)){w=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[w>>2]=(t[w>>2]|0)+1;if((u[t[t[r>>2]>>2]>>0]|0|0)==45){t[o>>2]=1;w=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[w>>2]=(t[w>>2]|0)+1}else if((u[t[t[r>>2]>>2]>>0]|0|0)==43?(w=t[r>>2]|0,(u[t[t[r>>2]>>2]>>0]|0|0)!=0):0)t[w>>2]=(t[w>>2]|0)+1;while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)<48)break;if((u[t[t[r>>2]>>2]>>0]|0|0)>57)break;t[a>>2]=((t[a>>2]|0)*10|0)+((u[t[t[r>>2]>>2]>>0]|0)-48);w=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[w>>2]=(t[w>>2]|0)+1}if(t[o>>2]|0)t[a>>2]=0-(t[a>>2]|0);v=+K(10,+ +(t[a>>2]|0));l[n>>3]=+l[n>>3]*v}a=t[(t[r>>2]|0)+32>>2]|0;o=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0;Pu(a,o,-1,12,3,0,0,eu(t[(t[r>>2]|0)+12>>2]|0,+l[n>>3])|0,0)|0;s=i;return}function ga(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[f>>2]=0;e=u[t[t[r>>2]>>2]>>0]|0;if((u[t[t[r>>2]>>2]>>0]|0|0)==34){a=t[r>>2]|0;if(e)t[a>>2]=(t[a>>2]|0)+1;t[n>>2]=t[t[r>>2]>>2];while(1){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)o=9;else if((u[t[t[r>>2]>>2]>>0]|0|0)!=13?32>(u[t[t[r>>2]>>2]>>0]|0|0):0)c=0;else o=9;if((o|0)==9){o=0;c=(u[t[t[r>>2]>>2]>>0]|0|0)!=34}l=u[t[t[r>>2]>>2]>>0]|0;if(!c)break;a=t[r>>2]|0;if(!l)continue;t[a>>2]=(t[a>>2]|0)+1}if(!(9<=(l|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0))o=15;if(((o|0)==15?(u[t[t[r>>2]>>2]>>0]|0|0)!=13:0)?32>(u[t[t[r>>2]>>2]>>0]|0|0):0){dn(t[r>>2]|0,2);s=i;return}t[f>>2]=ql(t[n>>2]|0,(t[t[r>>2]>>2]|0)-(t[n>>2]|0)|0)|0;l=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[l>>2]=(t[l>>2]|0)+1}else{l=t[r>>2]|0;if((e|0)!=39){dn(l,3);s=i;return}e=t[r>>2]|0;if(u[t[l>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=t[t[r>>2]>>2];while(1){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)o=28;else if((u[t[t[r>>2]>>2]>>0]|0|0)!=13?32>(u[t[t[r>>2]>>2]>>0]|0|0):0)b=0;else o=28;if((o|0)==28){o=0;b=(u[t[t[r>>2]>>2]>>0]|0|0)!=39}k=u[t[t[r>>2]>>2]>>0]|0;if(!b)break;e=t[r>>2]|0;if(!k)continue;t[e>>2]=(t[e>>2]|0)+1}if(!(9<=(k|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0))o=34;if(((o|0)==34?(u[t[t[r>>2]>>2]>>0]|0|0)!=13:0)?32>(u[t[t[r>>2]>>2]>>0]|0|0):0){dn(t[r>>2]|0,2);s=i;return}t[f>>2]=ql(t[n>>2]|0,(t[t[r>>2]>>2]|0)-(t[n>>2]|0)|0)|0;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1}if(!(t[f>>2]|0)){s=i;return}n=t[(t[r>>2]|0)+32>>2]|0;o=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0;Pu(n,o,-1,12,4,0,0,au(t[(t[r>>2]|0)+12>>2]|0,t[f>>2]|0)|0,0)|0;pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}function ya(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[r>>2]=e;t[a>>2]=0;t[o>>2]=1;t[n>>2]=Aa(t[r>>2]|0,f)|0;if(!(t[n>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);dn(t[r>>2]|0,7);s=i;return}while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);b=u[t[t[r>>2]>>2]>>0]|0;if(!l)break;e=t[r>>2]|0;if(!b)continue;t[e>>2]=(t[e>>2]|0)+1}l=t[r>>2]|0;if((b|0)!=40){dn(l,7);s=i;return}b=t[r>>2]|0;if(u[t[l>>2]>>0]|0)t[b>>2]=(t[b>>2]|0)+1;e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);b=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[b>>2]=(t[b>>2]|0)+1}if(((t[f>>2]|0)==0?(u[t[n>>2]>>0]|0|0)==99:0)?(Xl(t[n>>2]|0,129608)|0)!=0:0)t[o>>2]=0;t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]=-1;e:do if((u[t[t[r>>2]>>2]>>0]|0|0)!=41){i:while(1){if(!(u[t[t[r>>2]>>2]>>0]|0))break e;t[c>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2];t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]=-1;ku(t[r>>2]|0,t[o>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){k=27;break}Pu(t[(t[r>>2]|0)+32>>2]|0,t[c>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,15,0,0,0,0,0)|0;t[a>>2]=(t[a>>2]|0)+1;if((u[t[t[r>>2]>>2]>>0]|0|0)==41)break e;h=t[r>>2]|0;if((u[t[t[r>>2]>>2]>>0]|0|0)!=44){k=30;break}b=t[r>>2]|0;if(u[t[h>>2]>>0]|0)t[b>>2]=(t[b>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)continue i}while(0);b=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[b>>2]=(t[b>>2]|0)+1}}if((k|0)==27){pAi[t[135736>>2]&511](t[n>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}else if((k|0)==30){dn(h,7);s=i;return}}while(0);Pu(t[(t[r>>2]|0)+32>>2]|0,t[(t[(t[r>>2]|0)+32>>2]|0)+12>>2]|0,-1,14,t[a>>2]|0,0,0,t[n>>2]|0,t[f>>2]|0)|0;f=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;e:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break e}while(0);f=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}s=i;return}function Fa(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;switch(u[t[r>>2]>>0]|0|0){case 110:{if(Xl(t[r>>2]|0,130600)|0)t[n>>2]=9;break}case 115:{if(Xl(t[r>>2]|0,130664)|0)t[n>>2]=13;break}case 97:{if(Xl(t[r>>2]|0,130456)|0)t[n>>2]=1;if(Xl(t[r>>2]|0,130472)|0)t[n>>2]=2;if(Xl(t[r>>2]|0,130496)|0)t[n>>2]=3;break}case 99:{if(Xl(t[r>>2]|0,130512)|0)t[n>>2]=4;break}case 102:{if(Xl(t[r>>2]|0,130560)|0)t[n>>2]=7;if(Xl(t[r>>2]|0,130576)|0)t[n>>2]=8;break}case 112:{if(Xl(t[r>>2]|0,130616)|0)t[n>>2]=10;if(Xl(t[r>>2]|0,130624)|0)t[n>>2]=11;if(Xl(t[r>>2]|0,130640)|0)t[n>>2]=12;break}case 100:{if(Xl(t[r>>2]|0,130520)|0)t[n>>2]=5;if(Xl(t[r>>2]|0,130536)|0)t[n>>2]=6;break}default:{}}s=i;return t[n>>2]|0}function Oa(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;a=s;s=s+48|0;o=a;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;if((t[b>>2]|0)==0|(t[k>>2]|0)==0|(t[h>>2]|0)==0){f=t[33976]|0;n=t[33980]|0;t[o>>2]=128552;t[o+4>>2]=11124;yAi[f&511](n,129448,o);t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}t[t[k>>2]>>2]=0;t[t[b>>2]>>2]=0;t[t[h>>2]>>2]=0;e:while(1){do if((u[t[t[l>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[l>>2]>>2]>>0]|0|0)?(u[t[t[l>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[l>>2]>>2]>>0]|0|0)!=13)break e}while(0);o=t[l>>2]|0;if(!(u[t[t[l>>2]>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}if((t[w>>2]|0)==0?(u[t[t[l>>2]>>2]>>0]|0|0)==42:0){o=t[l>>2]|0;if(u[t[t[l>>2]>>2]>>0]|0)t[o>>2]=(t[o>>2]|0)+1;t[t[b>>2]>>2]=3;t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}if(!(t[w>>2]|0))t[w>>2]=ht(t[l>>2]|0)|0;o=t[l>>2]|0;if(!(t[w>>2]|0)){dn(o,7);t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}do if((u[t[o>>2]>>0]|0|0)==32)m=1;else{if(9<=(u[t[t[l>>2]>>2]>>0]|0|0)?(u[t[t[l>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(u[t[t[l>>2]>>2]>>0]|0|0)==13}while(0);t[d>>2]=m&1;while(1){do if((u[t[t[l>>2]>>2]>>0]|0|0)==32)_=1;else{if(9<=(u[t[t[l>>2]>>2]>>0]|0|0)?(u[t[t[l>>2]>>2]>>0]|0|0)<=10:0){_=1;break}_=(u[t[t[l>>2]>>2]>>0]|0|0)==13}while(0);p=u[t[t[l>>2]>>2]>>0]|0;if(!_)break;m=t[l>>2]|0;if(!p)continue;t[m>>2]=(t[m>>2]|0)+1}if((p|0)!=40){t[t[b>>2]>>2]=5;do if((t[d>>2]|0)==0?(u[t[t[l>>2]>>2]>>0]|0|0)==58:0){p=t[l>>2]|0;if(u[t[t[l>>2]>>2]>>0]|0)t[p>>2]=(t[p>>2]|0)+1;t[t[h>>2]>>2]=t[w>>2];p=t[l>>2]|0;if((u[t[t[l>>2]>>2]>>0]|0|0)!=42){t[w>>2]=ht(p)|0;if(t[w>>2]|0)break;dn(t[l>>2]|0,7);t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}_=t[l>>2]|0;if(u[t[p>>2]>>0]|0)t[_>>2]=(t[_>>2]|0)+1;t[t[b>>2]>>2]=3;t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}while(0);t[c>>2]=t[w>>2];v=t[c>>2]|0;s=a;return v|0}h=t[l>>2]|0;if(u[t[t[l>>2]>>2]>>0]|0)t[h>>2]=(t[h>>2]|0)+1;do if(Xl(t[w>>2]|0,129416)|0)t[t[k>>2]>>2]=8;else{if(Xl(t[w>>2]|0,129400)|0){t[t[k>>2]>>2]=0;break}if(Xl(t[w>>2]|0,129424)|0){t[t[k>>2]>>2]=7;break}if(Xl(t[w>>2]|0,129408)|0){t[t[k>>2]>>2]=3;break}if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);dn(t[l>>2]|0,7);t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}while(0);t[t[b>>2]>>2]=1;e:while(1){do if((u[t[t[l>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[l>>2]>>2]>>0]|0|0)?(u[t[t[l>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[l>>2]>>2]>>0]|0|0)!=13)break e}while(0);h=t[l>>2]|0;if(!(u[t[t[l>>2]>>2]>>0]|0))continue;t[h>>2]=(t[h>>2]|0)+1}e:do if((t[t[k>>2]>>2]|0)==7){if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0;if((u[t[t[l>>2]>>2]>>0]|0|0)!=41){t[w>>2]=Ma(t[l>>2]|0)|0;if(t[(t[l>>2]|0)+8>>2]|0){t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}t[t[b>>2]>>2]=2;while(1){do if((u[t[t[l>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[l>>2]>>2]>>0]|0|0)?(u[t[t[l>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[l>>2]>>2]>>0]|0|0)!=13)break e}while(0);h=t[l>>2]|0;if(!(u[t[t[l>>2]>>2]>>0]|0))continue;t[h>>2]=(t[h>>2]|0)+1}}}while(0);if((u[t[t[l>>2]>>2]>>0]|0|0)!=41){if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);dn(t[l>>2]|0,8);t[c>>2]=0;v=t[c>>2]|0;s=a;return v|0}else{b=t[l>>2]|0;if(u[t[t[l>>2]>>2]>>0]|0)t[b>>2]=(t[b>>2]|0)+1;t[c>>2]=t[w>>2];v=t[c>>2]|0;s=a;return v|0}return 0}function Aa(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=0;t[t[f>>2]>>2]=0;t[a>>2]=ht(t[n>>2]|0)|0;if(!(t[a>>2]|0)){o=t[a>>2]|0;s=r;return o|0}if((u[t[t[n>>2]>>2]>>0]|0|0)!=58){o=t[a>>2]|0;s=r;return o|0}t[t[f>>2]>>2]=t[a>>2];f=t[n>>2]|0;if(u[t[t[n>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;t[a>>2]=ht(t[n>>2]|0)|0;o=t[a>>2]|0;s=r;return o|0}function Ma(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[a>>2]=0;e=u[t[t[n>>2]>>2]>>0]|0;if((u[t[t[n>>2]>>2]>>0]|0|0)==34){o=t[n>>2]|0;if(e)t[o>>2]=(t[o>>2]|0)+1;t[f>>2]=t[t[n>>2]>>2];while(1){if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0)c=9;else if((u[t[t[n>>2]>>2]>>0]|0|0)!=13?32>(u[t[t[n>>2]>>2]>>0]|0|0):0)l=0;else c=9;if((c|0)==9){c=0;l=(u[t[t[n>>2]>>2]>>0]|0|0)!=34}b=u[t[t[n>>2]>>2]>>0]|0;if(!l)break;o=t[n>>2]|0;if(!b)continue;t[o>>2]=(t[o>>2]|0)+1}if(!(9<=(b|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0))c=15;if(((c|0)==15?(u[t[t[n>>2]>>2]>>0]|0|0)!=13:0)?32>(u[t[t[n>>2]>>2]>>0]|0|0):0){dn(t[n>>2]|0,2);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[a>>2]=ql(t[f>>2]|0,(t[t[n>>2]>>2]|0)-(t[f>>2]|0)|0)|0;b=t[n>>2]|0;if(u[t[t[n>>2]>>2]>>0]|0)t[b>>2]=(t[b>>2]|0)+1}else{b=t[n>>2]|0;if((e|0)!=39){dn(b,3);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}e=t[n>>2]|0;if(u[t[b>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=t[t[n>>2]>>2];while(1){if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0)c=28;else if((u[t[t[n>>2]>>2]>>0]|0|0)!=13?32>(u[t[t[n>>2]>>2]>>0]|0|0):0)h=0;else c=28;if((c|0)==28){c=0;h=(u[t[t[n>>2]>>2]>>0]|0|0)!=39}w=u[t[t[n>>2]>>2]>>0]|0;if(!h)break;e=t[n>>2]|0;if(!w)continue;t[e>>2]=(t[e>>2]|0)+1}if(!(9<=(w|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0))c=34;if(((c|0)==34?(u[t[t[n>>2]>>2]>>0]|0|0)!=13:0)?32>(u[t[t[n>>2]>>2]>>0]|0|0):0){dn(t[n>>2]|0,2);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[a>>2]=ql(t[f>>2]|0,(t[t[n>>2]>>2]|0)-(t[f>>2]|0)|0)|0;f=t[n>>2]|0;if(u[t[t[n>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1}t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}function Ra(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;do if(t[a>>2]|0){if(!(t[c>>2]|0)){t[u>>2]=0;break}if((t[o>>2]|0)<0){t[u>>2]=0;break}if((t[l>>2]|0)<0){t[u>>2]=0;break}t[b>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[b>>2]|0)){qa(131920);t[u>>2]=0;break}else{n=(t[b>>2]|0)+0|0;r=n+48|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));t[t[b>>2]>>2]=6;t[(t[b>>2]|0)+28>>2]=t[a>>2];t[(t[b>>2]|0)+32>>2]=t[o>>2];t[(t[b>>2]|0)+36>>2]=t[c>>2];t[(t[b>>2]|0)+40>>2]=t[l>>2];Ya(t[b>>2]|0);t[u>>2]=t[b>>2];break}}else t[u>>2]=0;while(0);s=f;return t[u>>2]|0}function Na(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(!(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[a>>2]|0)){qa(131920);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{i=(t[a>>2]|0)+0|0;e=i+48|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[t[a>>2]>>2]=6;t[(t[a>>2]|0)+28>>2]=t[f>>2];t[(t[a>>2]|0)+32>>2]=-1;t[(t[a>>2]|0)+36>>2]=t[u>>2];t[(t[a>>2]|0)+40>>2]=-1;Ya(t[a>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function Ta(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){qa(131920);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=6;t[(t[f>>2]|0)+28>>2]=t[n>>2];t[(t[f>>2]|0)+32>>2]=-1;t[(t[f>>2]|0)+36>>2]=0;t[(t[f>>2]|0)+40>>2]=-1;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function La(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;t[u>>2]=e;t[a>>2]=i;if(!(t[u>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if(!(t[a>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}i=t[t[a>>2]>>2]|0;if((i|0)==1)l=6;else if(!((i|0)==6|(i|0)==5)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if((l|0)==6?(t[t[(t[a>>2]|0)+4>>2]>>2]|0)<=0:0){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[o>>2]|0)){qa(131920);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}l=(t[o>>2]|0)+0|0;i=l+48|0;do{t[l>>2]=0;l=l+4|0}while((l|0)<(i|0));t[t[o>>2]>>2]=6;t[(t[o>>2]|0)+28>>2]=t[u>>2];t[(t[o>>2]|0)+32>>2]=-1;u=t[t[a>>2]>>2]|0;if((u|0)==1){t[(t[o>>2]|0)+36>>2]=t[(t[(t[(t[a>>2]|0)+4>>2]|0)+8>>2]|0)+((t[t[(t[a>>2]|0)+4>>2]>>2]|0)-1<<2)>>2];t[(t[o>>2]|0)+40>>2]=-1}else if((u|0)==5){t[(t[o>>2]|0)+36>>2]=t[(t[a>>2]|0)+28>>2];t[(t[o>>2]|0)+40>>2]=t[(t[a>>2]|0)+32>>2]}else if((u|0)==6){t[(t[o>>2]|0)+36>>2]=t[(t[a>>2]|0)+36>>2];t[(t[o>>2]|0)+40>>2]=t[(t[a>>2]|0)+40>>2]}else{a=t[33976]|0;u=t[33980]|0;t[n>>2]=131976;t[n+4>>2]=590;yAi[a&511](u,131944,n);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}Ya(t[o>>2]|0);t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}function Da(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[f>>2]|0)){qa(132e3);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;do if(t[n>>2]|0){e=gAi[t[135744>>2]&511](40)|0;t[(t[f>>2]|0)+8>>2]=e;if(t[(t[f>>2]|0)+8>>2]|0){e=(t[(t[f>>2]|0)+8>>2]|0)+0|0;a=e+40|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=10;e=t[n>>2]|0;a=t[f>>2]|0;o=t[a>>2]|0;t[a>>2]=o+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(o<<2)>>2]=e;break}qa(132e3);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}while(0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Ca(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[t[n>>2]>>2]|0))break;if(Ga(t[(t[(t[n>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2]|0,t[f>>2]|0)|0){o=5;break}t[u>>2]=(t[u>>2]|0)+1}if((o|0)==5){_n(t[f>>2]|0);s=r;return}do if(t[(t[n>>2]|0)+4>>2]|0){if((t[t[n>>2]>>2]|0)==(t[(t[n>>2]|0)+4>>2]|0)){o=(t[n>>2]|0)+4|0;t[o>>2]=t[o>>2]<<1;t[a>>2]=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+8>>2]|0,t[(t[n>>2]|0)+4>>2]<<2)|0;if(t[a>>2]|0){t[(t[n>>2]|0)+8>>2]=t[a>>2];break}qa(132024);s=r;return}}else{o=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+8>>2]=o;if(t[(t[n>>2]|0)+8>>2]|0){o=(t[(t[n>>2]|0)+8>>2]|0)+0|0;u=o+40|0;do{t[o>>2]=0;o=o+4|0}while((o|0)<(u|0));t[(t[n>>2]|0)+4>>2]=10;break}qa(132024);s=r;return}while(0);a=t[f>>2]|0;f=t[n>>2]|0;o=t[f>>2]|0;t[f>>2]=o+1;t[(t[(t[n>>2]|0)+8>>2]|0)+(o<<2)>>2]=a;s=r;return}function Pa(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(!(t[u>>2]|0)){t[n>>2]=t[f>>2];o=t[n>>2]|0;s=r;return o|0}t[a>>2]=0;while(1){c=t[f>>2]|0;if((t[a>>2]|0)>=(t[t[u>>2]>>2]|0))break;Ca(c,t[(t[(t[u>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0);t[a>>2]=(t[a>>2]|0)+1}t[n>>2]=c;o=t[n>>2]|0;s=r;return o|0}function Ba(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[t[r>>2]>>2]|0))break;_n(t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Ia(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[a>>2]|0)){qa(132e3);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+48|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[t[a>>2]>>2]=7;i=t[f>>2]|0;if(!(t[u>>2]|0)){f=Da(Ta(i)|0)|0;t[(t[a>>2]|0)+28>>2]=f}else{f=Da(Na(i,t[u>>2]|0)|0)|0;t[(t[a>>2]|0)+28>>2]=f}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Ha(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){qa(132e3);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}e=(t[f>>2]|0)+0|0;c=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(c|0));t[t[f>>2]>>2]=7;if(t[n>>2]|0){t[a>>2]=Da(0)|0;if(!(t[a>>2]|0)){t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}t[u>>2]=0;while(1){l=t[a>>2]|0;if((t[u>>2]|0)>=(t[t[n>>2]>>2]|0))break;Ca(l,Ta(t[(t[(t[n>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2]|0)|0);t[u>>2]=(t[u>>2]|0)+1}t[(t[f>>2]|0)+28>>2]=l}t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}function xa(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[f>>2]|0)){qa(132e3);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+48|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=7;t[(t[f>>2]|0)+28>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Ua(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=wf(t[u>>2]|0)|0;u=t[c>>2]|0;if(!(t[c>>2]|0)){t[f>>2]=u;l=t[f>>2]|0;s=n;return l|0}else{t[u+76>>2]=1;t[(t[c>>2]|0)+80>>2]=t[a>>2];t[(t[c>>2]|0)+84>>2]=t[o>>2];Un(t[c>>2]|0,132048,306)|0;Un(t[c>>2]|0,132064,307)|0;Un(t[c>>2]|0,132072,308)|0;Un(t[c>>2]|0,132088,309)|0;Un(t[c>>2]|0,132104,310)|0;Un(t[c>>2]|0,132120,311)|0;Un(t[c>>2]|0,132136,312)|0;Un(t[c>>2]|0,132144,313)|0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}return 0}function za(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r+36|0;f=r+32|0;u=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[n>>2]=e;t[f>>2]=i;t[b>>2]=0;if((t[n>>2]|0)==0|(t[n>>2]|0)==0){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}if((t[f+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==1:0){t[c>>2]=En(t[n>>2]|0)|0;t[k>>2]=t[(t[c>>2]|0)+4>>2];t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]=0;t[a>>2]=t[t[n>>2]>>2];t[b>>2]=Da(0)|0;t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[t[k>>2]>>2]|0))break;t[t[n>>2]>>2]=t[a>>2];t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]=t[(t[(t[k>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2];t[l>>2]=In(t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)|0;Sn(t[n>>2]|0,t[l>>2]|0)|0;pt(t[n>>2]|0);if(t[(t[n>>2]|0)+8>>2]|0){w=20;break}t[o>>2]=En(t[n>>2]|0)|0;t[u>>2]=La(t[(t[(t[k>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0,t[o>>2]|0)|0;if(t[u>>2]|0)Ca(t[b>>2]|0,t[u>>2]|0);if(t[o>>2]|0)_n(t[o>>2]|0);if((t[(t[n>>2]|0)+16>>2]|0)==(t[l>>2]|0)){t[o>>2]=En(t[n>>2]|0)|0;_n(t[o>>2]|0)}t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]=0;t[h>>2]=(t[h>>2]|0)+1}if((w|0)==20){s=r;return}_n(t[c>>2]|0);t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]=0;t[(t[(t[n>>2]|0)+12>>2]|0)+68>>2]=-1;t[(t[(t[n>>2]|0)+12>>2]|0)+72>>2]=-1;c=t[n>>2]|0;Sn(c,xa(t[b>>2]|0)|0)|0;s=r;return}dn(t[n>>2]|0,11);s=r;return}function ja(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[l>>2]=0;t[b>>2]=0;kn();if((t[u>>2]|0)==0|(t[f>>2]|0)==0){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}t[a>>2]=mf(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}t[(t[a>>2]|0)+36>>2]=1;eo(t[a>>2]|0);if(((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[t[(t[a>>2]|0)+16>>2]>>2]|0)!=1:0)?(t[t[(t[a>>2]|0)+16>>2]>>2]|0)!=7:0)io(t[a>>2]|0,1902,132152,0);else t[o>>2]=En(t[a>>2]|0)|0;do{t[c>>2]=En(t[a>>2]|0)|0;if(t[c>>2]|0){do if((t[c>>2]|0)!=(t[l>>2]|0)){if((t[t[c>>2]>>2]|0)!=1){t[b>>2]=(t[b>>2]|0)+1;break}t[k>>2]=t[(t[c>>2]|0)+4>>2];if((t[t[k>>2]>>2]|0)==1?(t[t[(t[k>>2]|0)+8>>2]>>2]|0)==(t[t[u>>2]>>2]|0):0)break;t[b>>2]=(t[b>>2]|0)+1}while(0);_n(t[c>>2]|0)}}while((t[c>>2]|0)!=0);if(t[b>>2]|0)io(t[a>>2]|0,1903,132208,0);if(t[(t[a>>2]|0)+8>>2]|0){_n(t[o>>2]|0);t[o>>2]=0}_f(t[a>>2]|0);t[n>>2]=t[o>>2];h=t[n>>2]|0;s=r;return h|0}function Va(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;t[u>>2]=e;t[a>>2]=i;e:while(1){if(!(t[u>>2]|0)){o=4;break}if((t[(t[u>>2]|0)+4>>2]|0)==18){o=4;break}if(t[(t[u>>2]|0)+12>>2]|0){t[u>>2]=t[(t[u>>2]|0)+12>>2];if(t[a>>2]|0){i=t[a>>2]|0;t[i>>2]=(t[i>>2]|0)+1;o=17}else o=17}i:while(1){if((o|0)==17){o=0;if((t[(t[u>>2]|0)+4>>2]|0)==1){o=24;break e}if((t[(t[u>>2]|0)+4>>2]|0)==3){o=24;break e}if((t[(t[u>>2]|0)+4>>2]|0)==9){o=24;break e}if((t[(t[u>>2]|0)+4>>2]|0)==13){o=24;break e}if((t[(t[u>>2]|0)+4>>2]|0)==4){o=24;break e}if((t[(t[u>>2]|0)+4>>2]|0)!=5)continue e;i=t[33976]|0;e=t[33980]|0;t[n>>2]=131976;t[n+4>>2]=2362;yAi[i&511](e,132256,n)}if(t[(t[u>>2]|0)+24>>2]|0){t[u>>2]=t[(t[u>>2]|0)+24>>2];o=17;continue}while(1){t[u>>2]=t[(t[u>>2]|0)+20>>2];if(t[a>>2]|0){e=t[a>>2]|0;t[e>>2]=(t[e>>2]|0)+-1}if(!(t[u>>2]|0)){o=13;break e}c=t[u>>2]|0;if(t[(t[u>>2]|0)+24>>2]|0)break;if(!c){o=17;continue i}}t[u>>2]=t[c+24>>2];o=17}}if((o|0)==4){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}else if((o|0)==13){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}else if((o|0)==24){t[f>>2]=t[u>>2];l=t[f>>2]|0;s=r;return l|0}return 0}function qa(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;e=t[n>>2]|0;t[r>>2]=t[n>>2];cp(0,0,0,0,0,13,2,2,0,0,e,0,0,0,0,132472,r);s=i;return}function Ya(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[t[r>>2]>>2]|0)!=6){s=i;return}if(!(t[(t[r>>2]|0)+36>>2]|0)){s=i;return}t[n>>2]=ro(t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+32>>2]|0,t[(t[r>>2]|0)+36>>2]|0,t[(t[r>>2]|0)+40>>2]|0)|0;if((t[n>>2]|0)!=-1){s=i;return}t[f>>2]=t[(t[r>>2]|0)+28>>2];t[(t[r>>2]|0)+28>>2]=t[(t[r>>2]|0)+36>>2];t[(t[r>>2]|0)+36>>2]=t[f>>2];t[n>>2]=t[(t[r>>2]|0)+32>>2];t[(t[r>>2]|0)+32>>2]=t[(t[r>>2]|0)+40>>2];t[(t[r>>2]|0)+40>>2]=t[n>>2];s=i;return}function Ga(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)!=(t[u>>2]|0)){if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;break}if((t[t[f>>2]>>2]|0)!=(t[t[u>>2]>>2]|0)){t[n>>2]=0;break}if((t[t[f>>2]>>2]|0)!=6){t[n>>2]=0;break}if((t[(t[f>>2]|0)+28>>2]|0)!=(t[(t[u>>2]|0)+28>>2]|0)){t[n>>2]=0;break}if((t[(t[f>>2]|0)+32>>2]|0)!=(t[(t[u>>2]|0)+32>>2]|0)){t[n>>2]=0;break}if((t[(t[f>>2]|0)+36>>2]|0)!=(t[(t[u>>2]|0)+36>>2]|0)){t[n>>2]=0;break}if((t[(t[f>>2]|0)+40>>2]|0)!=(t[(t[u>>2]|0)+40>>2]|0)){t[n>>2]=0;break}else{t[n>>2]=1;break}}else t[n>>2]=1;while(0);s=r;return t[n>>2]|0}function Wa(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=7?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1:0)break;t[a>>2]=En(t[n>>2]|0)|0;do if((t[t[a>>2]>>2]|0)==1){t[l>>2]=Ha(t[(t[a>>2]|0)+4>>2]|0)|0;_n(t[a>>2]|0);if(t[l>>2]|0){t[a>>2]=t[l>>2];break}dn(t[n>>2]|0,15);s=r;return}while(0);t[o>>2]=t[(t[a>>2]|0)+28>>2];t[c>>2]=Da(0)|0;if(!(t[c>>2]|0)){_n(t[a>>2]|0);dn(t[n>>2]|0,15);s=r;return}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[t[o>>2]>>2]|0))break;i=t[c>>2]|0;Ca(i,no(t[n>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2]|0)|0);t[u>>2]=(t[u>>2]|0)+1}i=t[n>>2]|0;Sn(i,xa(t[c>>2]|0)|0)|0;_n(t[a>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Ka(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=7?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1:0)break;t[a>>2]=En(t[n>>2]|0)|0;do if((t[t[a>>2]>>2]|0)==1){t[l>>2]=Ha(t[(t[a>>2]|0)+4>>2]|0)|0;_n(t[a>>2]|0);if(t[l>>2]|0){t[a>>2]=t[l>>2];break}dn(t[n>>2]|0,15);s=r;return}while(0);t[o>>2]=t[(t[a>>2]|0)+28>>2];t[c>>2]=Da(0)|0;if(!(t[c>>2]|0)){_n(t[a>>2]|0);dn(t[n>>2]|0,15);s=r;return}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[t[o>>2]>>2]|0))break;i=t[c>>2]|0;Ca(i,fo(t[n>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2]|0)|0);t[u>>2]=(t[u>>2]|0)+1}i=t[n>>2]|0;Sn(i,xa(t[c>>2]|0)|0)|0;_n(t[a>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Xa(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;r=s;s=s+96|0;n=r+80|0;f=r+76|0;a=r+72|0;o=r+68|0;c=r+64|0;b=r+60|0;k=r+56|0;h=r+52|0;w=r+48|0;d=r+44|0;v=r+40|0;m=r+36|0;_=r+32|0;p=r+28|0;E=r+24|0;S=r+20|0;g=r+16|0;y=r+12|0;F=r+8|0;O=r+4|0;A=r;t[n>>2]=e;t[f>>2]=i;t[c>>2]=0;t[h>>2]=0;t[p>>2]=0;t[E>>2]=0;t[g>>2]=0;t[y>>2]=0;if((t[f>>2]|0)<2|(t[f>>2]|0)>4){dn(t[n>>2]|0,12);s=r;return}do if((t[f>>2]|0)>=4){if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){t[E>>2]=En(t[n>>2]|0)|0;if(!(t[E>>2]|0))break;t[y>>2]=~~+l[(t[E>>2]|0)+16>>3];break}dn(t[n>>2]|0,11);s=r;return}while(0);do if((t[f>>2]|0)>=3){if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==3:0){t[p>>2]=En(t[n>>2]|0)|0;if(!(t[p>>2]|0))break;t[g>>2]=~~+l[(t[p>>2]|0)+16>>3];break}dn(t[n>>2]|0,11);s=r;return}while(0);if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==4:0){t[_>>2]=En(t[n>>2]|0)|0;do if(t[(t[n>>2]|0)+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=7?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1:0)break;t[d>>2]=En(t[n>>2]|0)|0;t[m>>2]=Da(0)|0;f=t[d>>2]|0;if(!(t[m>>2]|0)){_n(f);dn(t[n>>2]|0,15);s=r;return}e:do if(t[f+4>>2]|0){do if((t[t[d>>2]>>2]|0)==1){t[F>>2]=Ha(t[(t[d>>2]|0)+4>>2]|0)|0;_n(t[d>>2]|0);if(t[F>>2]|0){t[d>>2]=t[F>>2];break}dn(t[n>>2]|0,15);s=r;return}while(0);t[v>>2]=t[(t[d>>2]|0)+28>>2];t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[t[v>>2]>>2]|0))break e;to(t[(t[(t[v>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0,k,o)|0;uo(t[(t[(t[v>>2]|0)+8>>2]|0)+(t[a>>2]<<2)>>2]|0,h,c)|0;ao(k,o,0)|0;oo(h,c)|0;do{t[w>>2]=t[h>>2];t[b>>2]=t[c>>2];t[S>>2]=co(t[(t[_>>2]|0)+24>>2]|0,k,o,w,b)|0;if((t[S>>2]|0)==1){do if(t[p>>2]|0){if(ao(k,o,(t[g>>2]|0)-1|0)|0)break;if((t[E>>2]|0)!=0&(t[y>>2]|0)>0){t[A>>2]=t[k>>2];t[O>>2]=(t[o>>2]|0)-1;if(ao(A,O,t[y>>2]|0)|0)break;i=t[m>>2]|0;Ca(i,Ra(t[k>>2]|0,t[o>>2]|0,t[A>>2]|0,t[O>>2]|0)|0);break}i=t[m>>2]|0;e=t[k>>2]|0;M=t[o>>2]|0;if((t[E>>2]|0)!=0&(t[y>>2]|0)<=0){Ca(i,Ra(e,M,t[k>>2]|0,t[o>>2]|0)|0);break}else{Ca(i,Ra(e,M,t[w>>2]|0,t[b>>2]|0)|0);break}}else{M=t[m>>2]|0;Ca(M,Ra(t[k>>2]|0,t[o>>2]|0,t[w>>2]|0,t[b>>2]|0)|0)}while(0);t[k>>2]=t[w>>2];t[o>>2]=t[b>>2];if(!(u[t[(t[_>>2]|0)+24>>2]>>0]|0))t[o>>2]=(t[o>>2]|0)+1}}while((t[S>>2]|0)==1);t[a>>2]=(t[a>>2]|0)+1}}while(0);f=t[n>>2]|0;Sn(f,xa(t[m>>2]|0)|0)|0;_n(t[d>>2]|0);_n(t[_>>2]|0);if(t[p>>2]|0)_n(t[p>>2]|0);if(!(t[E>>2]|0)){s=r;return}_n(t[E>>2]|0);s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}dn(t[n>>2]|0,11);s=r;return}function Za(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[n>>2]=e;t[f>>2]=i;t[c>>2]=0;t[l>>2]=0;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=7?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1:0)break;t[a>>2]=En(t[n>>2]|0)|0;do if((t[t[a>>2]>>2]|0)==1){t[u>>2]=Ha(t[(t[a>>2]|0)+4>>2]|0)|0;_n(t[a>>2]|0);if(t[u>>2]|0){t[a>>2]=t[u>>2];break}dn(t[n>>2]|0,15);s=r;return}while(0);t[c>>2]=Da(0)|0;i=t[a>>2]|0;if(!(t[c>>2]|0)){_n(i);dn(t[n>>2]|0,15);s=r;return}t[l>>2]=t[i+28>>2];e:do if(t[l>>2]|0){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[t[l>>2]>>2]|0))break e;t[u>>2]=t[(t[(t[l>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2];if(t[u>>2]|0){t[o>>2]=0;i=t[t[u>>2]>>2]|0;if((i|0)==5)t[o>>2]=lo(t[(t[u>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+32>>2]|0)|0;else if((i|0)==6?(t[k>>2]=t[(t[u>>2]|0)+28>>2],(t[k>>2]|0)!=0):0){if((t[(t[k>>2]|0)+4>>2]|0)==2)break;t[o>>2]=lo(t[k>>2]|0,t[(t[u>>2]|0)+32>>2]|0)|0;
	}if(t[o>>2]|0)Ca(t[c>>2]|0,t[o>>2]|0)}t[b>>2]=(t[b>>2]|0)+1}_n(t[a>>2]|0);Ba(t[c>>2]|0);dn(t[n>>2]|0,16);s=r;return}while(0);_n(t[a>>2]|0);i=t[n>>2]|0;Sn(i,xa(t[c>>2]|0)|0)|0;s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Ja(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[n>>2]=e;t[f>>2]=i;t[c>>2]=0;t[l>>2]=0;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if((t[f>>2]|0)!=1){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+1|0)){dn(f,23);s=r;return}do if(t[f+16>>2]|0){if((t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=7?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)!=1:0)break;t[a>>2]=En(t[n>>2]|0)|0;do if((t[t[a>>2]>>2]|0)==1){t[u>>2]=Ha(t[(t[a>>2]|0)+4>>2]|0)|0;_n(t[a>>2]|0);if(t[u>>2]|0){t[a>>2]=t[u>>2];break}dn(t[n>>2]|0,15);s=r;return}while(0);t[c>>2]=Da(0)|0;i=t[a>>2]|0;if(!(t[c>>2]|0)){_n(i);dn(t[n>>2]|0,15);s=r;return}t[l>>2]=t[i+28>>2];e:do if(t[l>>2]|0){t[b>>2]=0;i:while(1){if((t[b>>2]|0)>=(t[t[l>>2]>>2]|0))break e;t[u>>2]=t[(t[(t[l>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2];if(t[u>>2]|0){t[o>>2]=0;i=t[t[u>>2]>>2]|0;do if((i|0)==6){t[k>>2]=t[(t[u>>2]|0)+36>>2];if(t[k>>2]|0){if((t[(t[k>>2]|0)+4>>2]|0)==2)break i;t[o>>2]=lo(t[k>>2]|0,t[(t[u>>2]|0)+40>>2]|0)|0;break}else{if(t[(t[u>>2]|0)+28>>2]|0)break;e=t[k>>2]|0;t[o>>2]=lo(e,so(t[k>>2]|0)|0)|0;break}}else if((i|0)==5)t[o>>2]=lo(t[(t[u>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+32>>2]|0)|0;while(0);if(t[o>>2]|0)Ca(t[c>>2]|0,t[o>>2]|0)}t[b>>2]=(t[b>>2]|0)+1}_n(t[a>>2]|0);Ba(t[c>>2]|0);dn(t[n>>2]|0,16);s=r;return}while(0);_n(t[a>>2]|0);i=t[n>>2]|0;Sn(i,xa(t[c>>2]|0)|0)|0;s=r;return}while(0);dn(t[n>>2]|0,11);s=r;return}function Qa(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(t[f>>2]|0){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+0|0)){dn(f,23);s=r;return}i=t[n>>2]|0;if(!(t[(t[f+12>>2]|0)+80>>2]|0)){dn(i,16);s=r;return}else{Sn(i,Ia(t[(t[(t[n>>2]|0)+12>>2]|0)+80>>2]|0,0)|0)|0;s=r;return}}function $a(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=t[n>>2]|0;if(t[f>>2]|0){dn(i,12);s=r;return}f=t[n>>2]|0;if((t[i+20>>2]|0)<((t[(t[n>>2]|0)+44>>2]|0)+0|0)){dn(f,23);s=r;return}i=t[n>>2]|0;if(!(t[(t[f+12>>2]|0)+84>>2]|0)){dn(i,16);s=r;return}else{Sn(i,Ia(t[(t[(t[n>>2]|0)+12>>2]|0)+84>>2]|0,0)|0)|0;s=r;return}}function eo(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;do if(!(t[(t[r>>2]|0)+28>>2]|0)){e=gAi[t[135744>>2]&511](40)|0;t[(t[r>>2]|0)+28>>2]=e;if(t[(t[r>>2]|0)+28>>2]|0){t[(t[r>>2]|0)+20>>2]=0;t[(t[r>>2]|0)+24>>2]=10;t[(t[r>>2]|0)+16>>2]=0;t[(t[r>>2]|0)+44>>2]=0;break}qa(132312);s=i;return}while(0);while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);a=u[t[t[r>>2]>>2]>>0]|0;if(!f)break;e=t[r>>2]|0;if(!a)continue;t[e>>2]=(t[e>>2]|0)+1}f=t[r>>2]|0;do if((a|0)==47){jf(f);bo(t[r>>2]|0,0)}else{t[n>>2]=wt(f)|0;e=t[r>>2]|0;if(!(t[n>>2]|0)){dn(e,7);s=i;return}o=t[r>>2]|0;c=t[n>>2]|0;if((u[t[e>>2]>>0]|0|0)!=40){bo(o,c);break}ko(o,c);s=i;return}while(0);while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);b=(u[t[t[r>>2]>>2]>>0]|0|0)!=0;if(!l)break;n=t[r>>2]|0;if(!b)continue;t[n>>2]=(t[n>>2]|0)+1}if(!b){s=i;return}dn(t[r>>2]|0,7);s=i;return}function io(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(t[a>>2]|0)t[(t[a>>2]|0)+8>>2]=t[o>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+12>>2]|0)!=0:0){t[(t[(t[a>>2]|0)+12>>2]|0)+136>>2]=13;t[(t[(t[a>>2]|0)+12>>2]|0)+140>>2]=t[o>>2];t[(t[(t[a>>2]|0)+12>>2]|0)+148>>2]=2;n=Yl(t[(t[a>>2]|0)+4>>2]|0)|0;t[(t[(t[a>>2]|0)+12>>2]|0)+160>>2]=n;t[(t[(t[a>>2]|0)+12>>2]|0)+172>>2]=(t[t[a>>2]>>2]|0)-(t[(t[a>>2]|0)+4>>2]|0);t[(t[(t[a>>2]|0)+12>>2]|0)+184>>2]=t[(t[(t[a>>2]|0)+12>>2]|0)+188>>2];n=t[(t[a>>2]|0)+12>>2]|0;if(t[(t[(t[a>>2]|0)+12>>2]|0)+132>>2]|0){EAi[t[n+132>>2]&511](t[(t[(t[a>>2]|0)+12>>2]|0)+128>>2]|0,(t[(t[a>>2]|0)+12>>2]|0)+136|0);s=f;return}else{r=t[n+188>>2]|0;n=t[o>>2]|0;i=t[l>>2]|0;e=t[(t[a>>2]|0)+4>>2]|0;b=(t[t[a>>2]>>2]|0)-(t[(t[a>>2]|0)+4>>2]|0)|0;a=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,0,r,13,n,2,0,0,i,e,0,b,0,a,u);s=f;return}}a=t[o>>2]|0;o=t[l>>2]|0;b=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,0,0,13,a,2,0,0,o,0,0,0,0,b,u);s=f;return}function ro(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;do if(!((t[a>>2]|0)==0|(t[c>>2]|0)==0)){if((t[a>>2]|0)!=(t[c>>2]|0)){t[u>>2]=An(t[a>>2]|0,t[c>>2]|0)|0;break}if((t[o>>2]|0)<(t[l>>2]|0)){t[u>>2]=1;break}if((t[o>>2]|0)>(t[l>>2]|0)){t[u>>2]=-1;break}else{t[u>>2]=0;break}}else t[u>>2]=-2;while(0);s=f;return t[u>>2]|0}function no(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;t[u>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)!=0:0)?(t[t[(t[u>>2]|0)+12>>2]>>2]|0)!=0:0){i=t[t[a>>2]>>2]|0;if((i|0)==6){e=t[(t[a>>2]|0)+28>>2]|0;if(t[(t[a>>2]|0)+36>>2]|0){t[f>>2]=Ra(e,t[(t[a>>2]|0)+32>>2]|0,t[(t[a>>2]|0)+36>>2]|0,t[(t[a>>2]|0)+40>>2]|0)|0;l=t[f>>2]|0;s=r;return l|0}t[o>>2]=e;e=t[o>>2]|0;if((t[o>>2]|0)==(t[t[(t[u>>2]|0)+12>>2]>>2]|0)){u=t[o>>2]|0;t[f>>2]=Ra(e,0,u,wo(t[o>>2]|0)|0)|0;l=t[f>>2]|0;s=r;return l|0}switch(t[e+4>>2]|0){case 13:case 12:case 9:case 8:case 7:case 5:case 4:case 3:case 1:{t[c>>2]=vo(t[o>>2]|0)|0;t[o>>2]=t[(t[o>>2]|0)+20>>2];t[f>>2]=Ra(t[o>>2]|0,(t[c>>2]|0)-1|0,t[o>>2]|0,(t[c>>2]|0)+1|0)|0;l=t[f>>2]|0;s=r;return l|0}case 2:{t[f>>2]=Ra(t[o>>2]|0,0,t[o>>2]|0,wo(t[o>>2]|0)|0)|0;l=t[f>>2]|0;s=r;return l|0}default:{t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}}}else if((i|0)==5){t[f>>2]=Ra(t[(t[a>>2]|0)+28>>2]|0,t[(t[a>>2]|0)+32>>2]|0,t[(t[a>>2]|0)+28>>2]|0,t[(t[a>>2]|0)+32>>2]|0)|0;l=t[f>>2]|0;s=r;return l|0}else{a=t[33976]|0;i=t[33980]|0;t[n>>2]=131976;t[n+4>>2]=2022;yAi[a&511](i,132256,n);t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}}t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}function fo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;t[u>>2]=e;t[a>>2]=i;e:do if(!(t[a>>2]|0))t[f>>2]=0;else{if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)!=0:0)?(t[t[(t[u>>2]|0)+12>>2]>>2]|0)!=0:0){i=t[t[a>>2]>>2]|0;if((i|0)==5){t[o>>2]=t[(t[a>>2]|0)+28>>2];switch(t[(t[o>>2]|0)+4>>2]|0){case 4:case 3:case 8:case 7:{e=t[o>>2]|0;l=t[o>>2]|0;if(!(t[(t[o>>2]|0)+40>>2]|0)){t[f>>2]=Ra(e,0,l,0)|0;break e}else{t[f>>2]=Ra(e,0,l,rs(t[(t[o>>2]|0)+40>>2]|0)|0)|0;break e}break}case 13:case 12:case 9:case 5:case 1:case 2:{t[f>>2]=Ra(t[o>>2]|0,0,t[o>>2]|0,wo(t[o>>2]|0)|0)|0;break e;break}default:{t[f>>2]=0;break e}}}else if((i|0)==6){t[c>>2]=t[(t[a>>2]|0)+28>>2];i=t[c>>2]|0;if(t[(t[a>>2]|0)+36>>2]|0){t[f>>2]=Ra(i,t[(t[a>>2]|0)+32>>2]|0,t[(t[a>>2]|0)+36>>2]|0,t[(t[a>>2]|0)+40>>2]|0)|0;break}switch(t[i+4>>2]|0){case 13:case 12:case 9:case 5:case 1:case 2:{t[f>>2]=Ra(t[c>>2]|0,0,t[c>>2]|0,wo(t[c>>2]|0)|0)|0;break e;break}case 4:case 3:case 8:case 7:{i=t[c>>2]|0;l=t[c>>2]|0;if(!(t[(t[c>>2]|0)+40>>2]|0)){t[f>>2]=Ra(i,0,l,0)|0;break e}else{t[f>>2]=Ra(i,0,l,rs(t[(t[c>>2]|0)+40>>2]|0)|0)|0;break e}break}default:{t[f>>2]=0;break e}}}else{l=t[33976]|0;i=t[33980]|0;t[n>>2]=131976;t[n+4>>2]=2167;yAi[l&511](i,132256,n);t[f>>2]=0;break}}t[f>>2]=0}while(0);s=r;return t[f>>2]|0}function to(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}r=t[t[u>>2]>>2]|0;if((r|0)==5){t[t[a>>2]>>2]=t[(t[u>>2]|0)+28>>2];if((t[(t[u>>2]|0)+32>>2]|0)<=0)t[t[o>>2]>>2]=0;else t[t[o>>2]>>2]=t[(t[u>>2]|0)+32>>2];t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}else if((r|0)==6){t[t[a>>2]>>2]=t[(t[u>>2]|0)+28>>2];if((t[(t[u>>2]|0)+32>>2]|0)<=0)t[t[o>>2]>>2]=0;else t[t[o>>2]>>2]=t[(t[u>>2]|0)+32>>2];t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}return 0}function uo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}r=t[t[u>>2]>>2]|0;if((r|0)==6){t[t[a>>2]>>2]=t[(t[u>>2]|0)+28>>2];if((t[(t[u>>2]|0)+32>>2]|0)<=0)t[t[o>>2]>>2]=0;else t[t[o>>2]>>2]=t[(t[u>>2]|0)+32>>2];t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}else if((r|0)==5){t[t[a>>2]>>2]=t[(t[u>>2]|0)+28>>2];if((t[(t[u>>2]|0)+32>>2]|0)<=0)t[t[o>>2]>>2]=0;else t[t[o>>2]>>2]=t[(t[u>>2]|0)+32>>2];t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}return 0}function ao(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+48|0;f=n;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=-1;h=t[u>>2]|0;s=n;return h|0}t[l>>2]=t[t[a>>2]>>2];if((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)!=18:0){t[b>>2]=t[t[o>>2]>>2];while(1){if((t[c>>2]|0)<0){w=30;break}while(1){if(!(t[l>>2]|0))break;if(((t[(t[l>>2]|0)+4>>2]|0)!=1?(t[(t[l>>2]|0)+4>>2]|0)!=9:0)?(t[(t[l>>2]|0)+4>>2]|0)!=13:0)break;r=t[l>>2]|0;if((t[b>>2]|0)>0){t[l>>2]=ho(r,t[b>>2]|0)|0;t[b>>2]=0;continue}else{t[l>>2]=Va(r,0)|0;t[b>>2]=0;continue}}if(!(t[l>>2]|0)){w=16;break}if(!(t[b>>2]|0))t[b>>2]=1;if(!(t[c>>2]|0)){w=20;break}t[k>>2]=0;if((t[(t[l>>2]|0)+4>>2]|0)!=1?(t[(t[l>>2]|0)+40>>2]|0)!=0:0)t[k>>2]=rs(t[(t[l>>2]|0)+40>>2]|0)|0;if((t[b>>2]|0)>(t[k>>2]|0)){r=t[33976]|0;i=t[33980]|0;t[f>>2]=131976;t[f+4>>2]=2436;yAi[r&511](i,131944,f);t[b>>2]=t[k>>2]}if(((t[b>>2]|0)+(t[c>>2]|0)|0)<(t[k>>2]|0))if(((t[b>>2]|0)+(t[c>>2]|0)|0)<(t[k>>2]|0)){w=29;break}else continue;else{t[c>>2]=(t[c>>2]|0)-((t[k>>2]|0)-(t[b>>2]|0));t[l>>2]=Va(t[l>>2]|0,0)|0;t[b>>2]=0;continue}}if((w|0)==16){t[t[a>>2]>>2]=0;t[t[o>>2]>>2]=0;t[u>>2]=-1;h=t[u>>2]|0;s=n;return h|0}else if((w|0)==20){t[t[a>>2]>>2]=t[l>>2];t[t[o>>2]>>2]=t[b>>2];t[u>>2]=0;h=t[u>>2]|0;s=n;return h|0}else if((w|0)==29){t[b>>2]=(t[b>>2]|0)+(t[c>>2]|0);t[t[a>>2]>>2]=t[l>>2];t[t[o>>2]>>2]=t[b>>2];t[u>>2]=0;h=t[u>>2]|0;s=n;return h|0}else if((w|0)==30){t[u>>2]=-1;h=t[u>>2]|0;s=n;return h|0}}t[u>>2]=-1;h=t[u>>2]|0;s=n;return h|0}function oo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;if(((t[f>>2]|0)!=0?(t[t[f>>2]>>2]|0)!=0:0)?!((t[u>>2]|0)==0?1:(t[(t[t[f>>2]>>2]|0)+4>>2]|0)==18):0){t[a>>2]=t[t[f>>2]>>2];t[o>>2]=t[t[u>>2]>>2];if((t[(t[a>>2]|0)+4>>2]|0)!=1?(t[(t[a>>2]|0)+4>>2]|0)!=9:0){if((t[o>>2]|0)>0?(t[(t[a>>2]|0)+4>>2]|0)==13:0)l=9}else l=8;if((l|0)==8?(t[o>>2]|0)>0:0)l=9;if((l|0)==9)t[a>>2]=ho(t[a>>2]|0,t[o>>2]|0)|0;while(1){if(!(t[a>>2]|0))break;b=t[a>>2]|0;if(!(t[(t[a>>2]|0)+16>>2]|0)){l=13;break}t[a>>2]=t[b+16>>2]}do if((l|0)==13){if((t[b+4>>2]|0)!=1?(t[(t[a>>2]|0)+40>>2]|0)!=0:0){t[c>>2]=rs(t[(t[a>>2]|0)+40>>2]|0)|0;break}t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}while(0);if(!(t[a>>2]|0)){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else{t[t[f>>2]>>2]=t[a>>2];t[t[u>>2]>>2]=t[c>>2];t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}}t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}function co(e,i,r,f,a){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;o=s;s=s+48|0;c=o+36|0;l=o+32|0;b=o+28|0;k=o+24|0;h=o+20|0;w=o+16|0;d=o+12|0;v=o+8|0;m=o+4|0;_=o;p=o+40|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=a;if(!(t[l>>2]|0)){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}if(((t[b>>2]|0)!=0?(t[t[b>>2]>>2]|0)!=0:0)?!((t[k>>2]|0)==0?1:(t[(t[t[b>>2]>>2]|0)+4>>2]|0)==18):0){if((t[h>>2]|0)==0|(t[w>>2]|0)==0){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}t[d>>2]=t[t[b>>2]>>2];t[m>>2]=(t[t[k>>2]>>2]|0)-1;n[p>>0]=n[t[l>>2]>>0]|0;e:while(1){if(!(t[d>>2]|0)){S=28;break}i:do if((t[(t[d>>2]|0)+4>>2]|0)!=1?(t[(t[d>>2]|0)+40>>2]|0)!=0:0){t[_>>2]=rs(t[(t[d>>2]|0)+40>>2]|0)|0;while(1){if((t[m>>2]|0)>(t[_>>2]|0))break i;if(!(u[p>>0]|0)){S=21;break e}t[v>>2]=es((t[(t[d>>2]|0)+40>>2]|0)+(t[m>>2]|0)|0,n[p>>0]|0)|0;if(!(t[v>>2]|0)){t[m>>2]=(t[_>>2]|0)+1;continue}t[m>>2]=(t[v>>2]|0)-(t[(t[d>>2]|0)+40>>2]|0);if(mo(t[l>>2]|0,t[d>>2]|0,(t[m>>2]|0)+1|0,t[h>>2]|0,t[w>>2]|0)|0){S=18;break e}t[m>>2]=(t[m>>2]|0)+1}}while(0);if((t[d>>2]|0)==(t[t[h>>2]>>2]|0)?(t[m>>2]|0)>=(t[t[w>>2]>>2]|0):0){S=24;break}t[d>>2]=Va(t[d>>2]|0,0)|0;if(!(t[d>>2]|0)){S=26;break}t[m>>2]=1}if((S|0)==18){t[t[b>>2]>>2]=t[d>>2];t[t[k>>2]>>2]=(t[m>>2]|0)+1;t[c>>2]=1;E=t[c>>2]|0;s=o;return E|0}else if((S|0)==21){t[t[b>>2]>>2]=t[d>>2];t[t[k>>2]>>2]=(t[m>>2]|0)+1;t[t[h>>2]>>2]=t[d>>2];t[t[w>>2]>>2]=(t[m>>2]|0)+1;t[c>>2]=1;E=t[c>>2]|0;s=o;return E|0}else if((S|0)==24){t[c>>2]=0;E=t[c>>2]|0;s=o;return E|0}else if((S|0)==26){t[c>>2]=0;E=t[c>>2]|0;s=o;return E|0}else if((S|0)==28){t[c>>2]=0;E=t[c>>2]|0;s=o;return E|0}}t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}function lo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if((t[u>>2]|0)<0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[a>>2]|0)){qa(132288);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{i=(t[a>>2]|0)+0|0;e=i+48|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[t[a>>2]>>2]=5;t[(t[a>>2]|0)+28>>2]=t[f>>2];t[(t[a>>2]|0)+32>>2]=t[u>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function so(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}e:do switch(t[(t[n>>2]|0)+4>>2]|0){case 1:case 9:case 13:{t[n>>2]=t[(t[n>>2]|0)+12>>2];while(1){if(!(t[n>>2]|0))break e;if((t[(t[n>>2]|0)+4>>2]|0)==1)t[f>>2]=(t[f>>2]|0)+1;t[n>>2]=t[(t[n>>2]|0)+24>>2]}break}case 2:{t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}case 5:case 4:case 3:case 8:case 7:{t[f>>2]=rs(t[(t[n>>2]|0)+40>>2]|0)|0;break}default:{t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}}while(0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function bo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(((t[f>>2]|0)==0?(u[t[t[n>>2]>>2]>>0]|0|0)==47:0)?(u[(t[t[n>>2]>>2]|0)+1>>0]|0|0)!=49:0)io(t[n>>2]|0,1901,132432,0);if((t[f>>2]|0)!=0?(i=t[n>>2]|0,Sn(i,$n(t[f>>2]|0)|0)|0,pAi[t[135736>>2]&511](t[f>>2]|0),Gf(t[n>>2]|0,1),(t[(t[n>>2]|0)+8>>2]|0)!=0):0){s=r;return}while(1){if((u[t[t[n>>2]>>2]>>0]|0|0)!=47)break;t[a>>2]=0;f=t[n>>2]|0;if(u[t[t[n>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;while(1){if((u[t[t[n>>2]>>2]>>0]|0|0)<48)break;if((u[t[t[n>>2]>>2]>>0]|0|0)>57)break;t[a>>2]=((t[a>>2]|0)*10|0)+((u[t[t[n>>2]>>2]>>0]|0)-48);f=t[n>>2]|0;if(!(u[t[t[n>>2]>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}_o(t[n>>2]|0,t[a>>2]|0)}s=r;return}function ko(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0))t[f>>2]=wt(t[n>>2]|0)|0;if(!(t[f>>2]|0)){dn(t[n>>2]|0,7);s=r;return}while(1){if(!(t[f>>2]|0)){l=25;break}t[(t[n>>2]|0)+8>>2]=0;po(t[n>>2]|0,t[f>>2]|0);if((t[(t[n>>2]|0)+8>>2]|0)!=0?(t[(t[n>>2]|0)+8>>2]|0)!=1900:0){l=25;break}if(t[(t[n>>2]|0)+16>>2]|0){t[a>>2]=t[(t[n>>2]|0)+16>>2];i=t[t[a>>2]>>2]|0;if((i|0)==7){t[o>>2]=t[(t[(t[n>>2]|0)+16>>2]|0)+28>>2];if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)>0:0){l=25;break}}else if(((i|0)==1?(t[c>>2]=t[(t[(t[n>>2]|0)+16>>2]|0)+4>>2],(t[c>>2]|0)!=0):0)?(t[t[c>>2]>>2]|0)>0:0){l=25;break}do{t[a>>2]=En(t[n>>2]|0)|0;if(t[a>>2]|0)_n(t[a>>2]|0)}while((t[a>>2]|0)!=0)}while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)==32)b=1;else{if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0){b=1;break}b=(u[t[t[n>>2]>>2]>>0]|0|0)==13}while(0);k=t[n>>2]|0;if(!b)break;i=t[n>>2]|0;if(!(u[t[k>>2]>>0]|0))continue;t[i>>2]=(t[i>>2]|0)+1}t[f>>2]=wt(k)|0}if((l|0)==25){s=r;return}}function ho(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){t[f>>2]=t[(t[f>>2]|0)+12>>2];t[a>>2]=0;while(1){if((t[a>>2]|0)>(t[u>>2]|0)){o=13;break}c=t[f>>2]|0;if(!(t[f>>2]|0)){o=7;break}if(!(((t[c+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=9:0)?(t[(t[f>>2]|0)+4>>2]|0)!=13:0))o=11;if((o|0)==11?(o=0,t[a>>2]=(t[a>>2]|0)+1,(t[a>>2]|0)==(t[u>>2]|0)):0){o=13;break}t[f>>2]=t[(t[f>>2]|0)+24>>2]}if((o|0)==7){t[n>>2]=c;l=t[n>>2]|0;s=r;return l|0}else if((o|0)==13){t[n>>2]=t[f>>2];l=t[n>>2]|0;s=r;return l|0}}t[n>>2]=t[f>>2];l=t[n>>2]|0;s=r;return l|0}function wo(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+4>>2]|0)!=18:0){t[n>>2]=t[(t[n>>2]|0)+12>>2];t[f>>2]=0;while(1){if(!(t[n>>2]|0))break;if(!(((t[(t[n>>2]|0)+4>>2]|0)!=1?(t[(t[n>>2]|0)+4>>2]|0)!=9:0)?(t[(t[n>>2]|0)+4>>2]|0)!=13:0))t[f>>2]=(t[f>>2]|0)+1;t[n>>2]=t[(t[n>>2]|0)+24>>2]}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}function vo(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+4>>2]|0)!=18:0){t[f>>2]=1;while(1){if(!(t[n>>2]|0))break;if(!(((t[(t[n>>2]|0)+4>>2]|0)!=1?(t[(t[n>>2]|0)+4>>2]|0)!=9:0)?(t[(t[n>>2]|0)+4>>2]|0)!=13:0))t[f>>2]=(t[f>>2]|0)+1;t[n>>2]=t[(t[n>>2]|0)+28>>2]}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}function mo(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+48|0;a=u+44|0;o=u+40|0;c=u+36|0;l=u+32|0;b=u+28|0;k=u+24|0;h=u+20|0;w=u+16|0;d=u+12|0;v=u+8|0;m=u+4|0;_=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(!(t[o>>2]|0)){t[a>>2]=-1;p=t[a>>2]|0;s=u;return p|0}if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)!=18:0){if(((t[b>>2]|0)!=0?(t[t[b>>2]>>2]|0)!=0:0)?!((t[k>>2]|0)==0?1:(t[(t[t[b>>2]>>2]|0)+4>>2]|0)==18):0){t[h>>2]=t[c>>2];t[w>>2]=(t[l>>2]|0)-1;t[v>>2]=rs(t[o>>2]|0)|0;while(1){if((t[v>>2]|0)<=0){E=27;break}if((t[h>>2]|0)==(t[t[b>>2]>>2]|0)?((t[w>>2]|0)+(t[v>>2]|0)|0)>(t[t[k>>2]>>2]|0):0){E=14;break}if((t[(t[h>>2]|0)+4>>2]|0)!=1?(t[(t[h>>2]|0)+40>>2]|0)!=0:0){t[d>>2]=rs(t[(t[h>>2]|0)+40>>2]|0)|0;if((t[d>>2]|0)>=((t[w>>2]|0)+(t[v>>2]|0)|0)){E=18;break}t[_>>2]=(t[d>>2]|0)-(t[w>>2]|0);t[m>>2]=((Jl((t[(t[h>>2]|0)+40>>2]|0)+(t[w>>2]|0)|0,t[o>>2]|0,t[_>>2]|0)|0)!=0^1)&1;if(!(t[m>>2]|0)){E=23;break}t[o>>2]=(t[o>>2]|0)+(t[_>>2]|0);t[v>>2]=(t[v>>2]|0)-(t[_>>2]|0)}t[h>>2]=Va(t[h>>2]|0,0)|0;if(!(t[h>>2]|0)){E=25;break}t[w>>2]=0}if((E|0)==14){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}else if((E|0)==18){t[m>>2]=((Jl((t[(t[h>>2]|0)+40>>2]|0)+(t[w>>2]|0)|0,t[o>>2]|0,t[v>>2]|0)|0)!=0^1)&1;if(t[m>>2]|0){t[t[b>>2]>>2]=t[h>>2];t[t[k>>2]>>2]=(t[w>>2]|0)+(t[v>>2]|0);t[a>>2]=1;p=t[a>>2]|0;s=u;return p|0}else{t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else if((E|0)==23){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}else if((E|0)==25){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}else if((E|0)==27){t[a>>2]=1;p=t[a>>2]|0;s=u;return p|0}}t[a>>2]=-1;p=t[a>>2]|0;s=u;return p|0}t[a>>2]=-1;p=t[a>>2]|0;s=u;return p|0}function _o(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=0;if((t[(t[n>>2]|0)+16>>2]|0)!=0?(t[t[(t[n>>2]|0)+16>>2]>>2]|0)==1:0){t[a>>2]=En(t[n>>2]|0)|0;t[o>>2]=t[(t[a>>2]|0)+4>>2];if(!((t[f>>2]|0)<=0|(t[o>>2]|0)==0)?(t[t[o>>2]>>2]|0)==1:0){t[u>>2]=ho(t[t[(t[o>>2]|0)+8>>2]>>2]|0,t[f>>2]|0)|0;if(!(t[u>>2]|0)){_n(t[a>>2]|0);f=t[n>>2]|0;Sn(f,In(0)|0)|0;s=r;return}else{t[t[(t[o>>2]|0)+8>>2]>>2]=t[u>>2];Sn(t[n>>2]|0,t[a>>2]|0)|0;s=r;return}}_n(t[a>>2]|0);a=t[n>>2]|0;Sn(a,In(0)|0)|0;s=r;return}dn(t[n>>2]|0,11);s=r;return}function po(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;r=s;s=s+64|0;f=r+48|0;a=r+44|0;o=r+40|0;c=r+36|0;l=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+12|0;v=r+8|0;m=r+4|0;_=r;t[f>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0))t[a>>2]=wt(t[f>>2]|0)|0;i=t[f>>2]|0;if(!(t[a>>2]|0)){dn(i,7);s=r;return}e=t[f>>2]|0;if((u[t[i>>2]>>0]|0|0)!=40){dn(e,7);s=r;return}i=t[f>>2]|0;if(u[t[e>>2]>>0]|0)t[i>>2]=(t[i>>2]|0)+1;t[b>>2]=1;t[l>>2]=rs(t[t[f>>2]>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+1;t[o>>2]=gAi[t[135752>>2]&511](t[l>>2]|0)|0;if(!(t[o>>2]|0)){qa(132344);s=r;return}t[c>>2]=t[o>>2];e:while(1){if(!(u[t[t[f>>2]>>2]>>0]|0))break;do if((u[t[t[f>>2]>>2]>>0]|0|0)==41){t[b>>2]=(t[b>>2]|0)+-1;if(!(t[b>>2]|0)){p=15;break e}}else{if((u[t[t[f>>2]>>2]>>0]|0|0)==40){t[b>>2]=(t[b>>2]|0)+1;break}if((u[t[t[f>>2]>>2]>>0]|0|0)==94){if(((u[(t[t[f>>2]>>2]|0)+1>>0]|0|0)!=41?(u[(t[t[f>>2]>>2]|0)+1>>0]|0|0)!=40:0)?(u[(t[t[f>>2]>>2]|0)+1>>0]|0|0)!=94:0)break;l=t[f>>2]|0;if(u[t[t[f>>2]>>2]>>0]|0)t[l>>2]=(t[l>>2]|0)+1}}while(0);l=n[t[t[f>>2]>>2]>>0]|0;i=t[c>>2]|0;t[c>>2]=i+1;n[i>>0]=l;l=t[f>>2]|0;if(!(u[t[t[f>>2]>>2]>>0]|0))continue;t[l>>2]=(t[l>>2]|0)+1}if((p|0)==15?(p=t[f>>2]|0,(u[t[t[f>>2]>>2]>>0]|0|0)!=0):0)t[p>>2]=(t[p>>2]|0)+1;n[t[c>>2]>>0]=0;if((t[b>>2]|0)!=0?(u[t[t[f>>2]>>2]>>0]|0|0)==0:0){pAi[t[135736>>2]&511](t[o>>2]|0);dn(t[f>>2]|0,16);s=r;return}do if(Xl(t[a>>2]|0,132368)|0){t[k>>2]=t[t[f>>2]>>2];t[t[f>>2]>>2]=t[o>>2];t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]=t[t[(t[f>>2]|0)+12>>2]>>2];t[(t[(t[f>>2]|0)+12>>2]|0)+72>>2]=1;t[(t[(t[f>>2]|0)+12>>2]|0)+68>>2]=1;pt(t[f>>2]|0);t[t[f>>2]>>2]=t[k>>2]}else{if(Xl(t[a>>2]|0,132384)|0){t[h>>2]=t[t[f>>2]>>2];t[t[f>>2]>>2]=t[o>>2];b=t[f>>2]|0;do if((u[t[o>>2]>>0]|0|0)==47){jf(b);bo(t[f>>2]|0,0)}else{t[w>>2]=wt(b)|0;if(t[w>>2]|0){bo(t[f>>2]|0,t[w>>2]|0);break}t[t[f>>2]>>2]=t[h>>2];pAi[t[135736>>2]&511](t[o>>2]|0);dn(t[f>>2]|0,7);s=r;return}while(0);t[t[f>>2]>>2]=t[h>>2];break}b=(Xl(t[a>>2]|0,132392)|0)!=0;c=t[f>>2]|0;if(!b){io(c,1900,132400,t[a>>2]|0);break}t[d>>2]=t[c>>2];t[t[f>>2]>>2]=t[o>>2];t[v>>2]=ht(t[f>>2]|0)|0;if(!(t[v>>2]|0)){pAi[t[135736>>2]&511](t[o>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);dn(t[f>>2]|0,16);s=r;return}while(1){do if((u[t[t[f>>2]>>2]>>0]|0|0)==32)E=1;else{if(9<=(u[t[t[f>>2]>>2]>>0]|0|0)?(u[t[t[f>>2]>>2]>>0]|0|0)<=10:0){E=1;break}E=(u[t[t[f>>2]>>2]>>0]|0|0)==13}while(0);S=u[t[t[f>>2]>>2]>>0]|0;if(!E)break;c=t[f>>2]|0;if(!S)continue;t[c>>2]=(t[c>>2]|0)+1}if((S|0)!=61){pAi[t[135736>>2]&511](t[v>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);dn(t[f>>2]|0,16);s=r;return}c=t[f>>2]|0;if(u[t[t[f>>2]>>2]>>0]|0)t[c>>2]=(t[c>>2]|0)+1;while(1){do if((u[t[t[f>>2]>>2]>>0]|0|0)==32)g=1;else{if(9<=(u[t[t[f>>2]>>2]>>0]|0|0)?(u[t[t[f>>2]>>2]>>0]|0|0)<=10:0){g=1;break}g=(u[t[t[f>>2]>>2]>>0]|0|0)==13}while(0);y=t[t[f>>2]>>2]|0;if(!g)break;c=t[f>>2]|0;if(!(u[y>>0]|0))continue;t[c>>2]=(t[c>>2]|0)+1}t[_>>2]=IA(y)|0;if(!(t[_>>2]|0)){pAi[t[135736>>2]&511](t[v>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);dn(t[f>>2]|0,16);s=r;return}t[m>>2]=zA(t[_>>2]|0)|0;xA(t[_>>2]|0);if(t[m>>2]|0){Kn(t[(t[f>>2]|0)+12>>2]|0,t[v>>2]|0,t[m>>2]|0)|0;t[t[f>>2]>>2]=t[d>>2];pAi[t[135736>>2]&511](t[m>>2]|0);pAi[t[135736>>2]&511](t[v>>2]|0);break}pAi[t[135736>>2]&511](t[v>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);dn(t[f>>2]|0,15);s=r;return}while(0);pAi[t[135736>>2]&511](t[o>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);s=r;return}function Eo(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](72)|0;if(!(t[f>>2]|0)){Mo(0,t[n>>2]|0,132504);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+72|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=t[n>>2];t[(t[f>>2]|0)+8>>2]=0;t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+16>>2]=0;t[(t[f>>2]|0)+52>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function So(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}while(1){f=t[r>>2]|0;if((t[(t[r>>2]|0)+40>>2]|0)<=0)break;Ro(f)}if(t[f+48>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+8>>2]|0))break;if(t[(t[(t[r>>2]|0)+16>>2]|0)+(t[n>>2]<<2)>>2]|0)No(t[(t[(t[r>>2]|0)+16>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}e:do if(t[(t[r>>2]|0)+32>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+20>>2]|0))break e;if(t[(t[(t[r>>2]|0)+32>>2]|0)+(t[n>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[r>>2]|0)+32>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}}while(0);if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+32>>2]|0);if(t[(t[r>>2]|0)+64>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+64>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function go(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{t[(t[f>>2]|0)+60>>2]=t[u>>2];t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}return 0}function yo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0)?(t[(t[u>>2]|0)+32>>2]|0)!=0:0){t[c>>2]=Eo(t[(t[u>>2]|0)+32>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}t[(t[c>>2]|0)+68>>2]=t[o>>2];o=Yl(t[(t[(t[u>>2]|0)+32>>2]|0)+72>>2]|0)|0;t[(t[c>>2]|0)+64>>2]=o;go(t[c>>2]|0,t[a>>2]|0)|0;t[l>>2]=To(t[c>>2]|0,t[(t[u>>2]|0)+32>>2]|0,t[u>>2]|0)|0;if((t[l>>2]|0)>=0?(t[(t[c>>2]|0)+52>>2]|0)>0:0)t[l>>2]=-1;So(t[c>>2]|0);t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}function Fo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=eF(t[u>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=yo(t[c>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function Oo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=Fo(t[n>>2]|0,t[f>>2]|0,0)|0;s=r;return i|0}function Ao(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0)?!((t[f>>2]|0)==0?1:(t[(t[u>>2]|0)+32>>2]|0)==0):0){t[a>>2]=To(t[f>>2]|0,t[(t[u>>2]|0)+32>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)>=0?(t[(t[f>>2]|0)+52>>2]|0)>0:0)t[a>>2]=-1;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}function Mo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n;u=n+12|0;a=n+8|0;o=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(t[u>>2]|0){r=(t[u>>2]|0)+52|0;t[r>>2]=(t[r>>2]|0)+1}r=t[u>>2]|0;u=t[a>>2]|0;a=t[o>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,r,u,11,2,2,0,0,a,0,0,0,0,133840,f);s=n;return}function Ro(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if((t[(t[r>>2]|0)+40>>2]|0)<=0){s=i;return}e=(t[r>>2]|0)+40|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[r>>2]|0;if((t[(t[r>>2]|0)+40>>2]|0)>0)t[(t[r>>2]|0)+36>>2]=t[(t[(t[r>>2]|0)+48>>2]|0)+((t[e+40>>2]|0)-1<<2)>>2];else t[e+36>>2]=0;t[n>>2]=t[(t[(t[r>>2]|0)+48>>2]|0)+(t[(t[r>>2]|0)+40>>2]<<2)>>2];t[(t[(t[r>>2]|0)+48>>2]|0)+(t[(t[r>>2]|0)+40>>2]<<2)>>2]=0;if(!(t[n>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[n>>2]|0);s=i;return}function No(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0)_n(t[(t[r>>2]|0)+28>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function To(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if(!((t[a>>2]|0)==0|(t[o>>2]|0)==0)?(t[(t[o>>2]|0)+4>>2]|0)!=18:0){if(!(t[u>>2]|0)){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}if((t[(t[a>>2]|0)+72>>2]|0)!=0?(t[l>>2]=Lo(t[u>>2]|0,t[(t[a>>2]|0)+72>>2]|0)|0,(t[l>>2]|0)<0):0){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}t[k>>2]=t[(t[u>>2]|0)+8>>2];t[c>>2]=t[o>>2];if((Do(t[u>>2]|0,t[c>>2]|0)|0)==1)Co(t[u>>2]|0,t[c>>2]|0)|0;e:while(1){if(!(t[c>>2]|0))break;if((t[c>>2]|0)==(t[(t[o>>2]|0)+20>>2]|0))break;if((((t[(t[c>>2]|0)+12>>2]|0)!=0?(t[(t[(t[c>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(t[(t[(t[c>>2]|0)+12>>2]|0)+4>>2]|0)!=19:0)?(t[(t[(t[c>>2]|0)+12>>2]|0)+4>>2]|0)!=20:0){t[c>>2]=t[(t[c>>2]|0)+12>>2];if(!(Do(t[u>>2]|0,t[c>>2]|0)|0))continue;Co(t[u>>2]|0,t[c>>2]|0)|0;continue}r=t[c>>2]|0;if(t[(t[c>>2]|0)+24>>2]|0){t[c>>2]=t[r+24>>2];if(!(Do(t[u>>2]|0,t[c>>2]|0)|0))continue;Co(t[u>>2]|0,t[c>>2]|0)|0;continue}if((r|0)==(t[o>>2]|0))break;while(1){t[c>>2]=t[(t[c>>2]|0)+20>>2];if(!(t[c>>2]|0))continue e;if((t[c>>2]|0)==(t[(t[o>>2]|0)+20>>2]|0))continue e;w=t[c>>2]|0;if(t[(t[c>>2]|0)+24>>2]|0)break;if(!w)continue e}t[c>>2]=t[w+24>>2];if(!(Do(t[u>>2]|0,t[c>>2]|0)|0))continue;Co(t[u>>2]|0,t[c>>2]|0)|0}t[b>>2]=t[k>>2];while(1){d=t[u>>2]|0;if((t[b>>2]|0)>=(t[(t[u>>2]|0)+8>>2]|0))break;Po(d,t[b>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+1;t[b>>2]=(t[b>>2]|0)+1}t[b>>2]=t[d+4>>2];while(1){if((t[b>>2]|0)>=(t[(t[u>>2]|0)+8>>2]|0))break;if(!(((t[(t[(t[(t[u>>2]|0)+16>>2]|0)+(t[b>>2]<<2)>>2]|0)+16>>2]|0)==0?(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+(t[b>>2]<<2)>>2]|0)+28>>2]|0)==0:0)?(t[(t[(t[(t[u>>2]|0)+16>>2]|0)+(t[b>>2]<<2)>>2]|0)+32>>2]|0)==0:0))Bo(t[u>>2]|0,t[b>>2]|0)|0;t[b>>2]=(t[b>>2]|0)+1}if(t[(t[a>>2]|0)+72>>2]|0)Ro(t[u>>2]|0);t[f>>2]=t[l>>2];h=t[f>>2]|0;s=n;return h|0}t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}function Lo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;if((t[(t[f>>2]|0)+40>>2]|0)>40){Io(i,0,1600,133640,t[u>>2]|0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if((t[i+48>>2]|0)==0?(t[(t[f>>2]|0)+44>>2]=4,t[(t[f>>2]|0)+40>>2]=0,i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+44>>2]<<2)|0,t[(t[f>>2]|0)+48>>2]=i,(t[(t[f>>2]|0)+48>>2]|0)==0):0){Mo(t[f>>2]|0,0,133824);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if((t[(t[f>>2]|0)+40>>2]|0)>=(t[(t[f>>2]|0)+44>>2]|0)?(i=(t[f>>2]|0)+44|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+48>>2]|0,t[(t[f>>2]|0)+44>>2]<<2)|0,t[(t[f>>2]|0)+48>>2]=i,(t[(t[f>>2]|0)+48>>2]|0)==0):0){Mo(t[f>>2]|0,0,133824);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}i=Yl(t[u>>2]|0)|0;t[(t[(t[f>>2]|0)+48>>2]|0)+(t[(t[f>>2]|0)+40>>2]<<2)>>2]=i;t[(t[f>>2]|0)+36>>2]=i;i=(t[f>>2]|0)+40|0;f=t[i>>2]|0;t[i>>2]=f+1;t[n>>2]=f;a=t[n>>2]|0;s=r;return a|0}function Do(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if((t[(t[u>>2]|0)+4>>2]|0)!=1){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(!(t[(t[u>>2]|0)+36>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(!((Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0))l=9;e:do if((l|0)==9){if((Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)!=0?(t[(t[f>>2]|0)+56>>2]|0)==0:0)t[(t[f>>2]|0)+56>>2]=1;i=(Xl(t[(t[u>>2]|0)+8>>2]|0,133704)|0)!=0;e=t[u>>2]|0;if(!i){if(!(Xl(t[e+8>>2]|0,132712)|0))break;do if(((t[(t[u>>2]|0)+20>>2]|0)!=0?(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)==1:0)?(t[(t[(t[u>>2]|0)+20>>2]|0)+36>>2]|0)!=0:0){if((Xl(t[(t[(t[(t[u>>2]|0)+20>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(Xl(t[(t[(t[(t[u>>2]|0)+20>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0)break;if(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,133704)|0)break e}while(0);Io(t[f>>2]|0,t[u>>2]|0,1616,133784,132712);break}t[a>>2]=t[e+12>>2];t[o>>2]=0;i:while(1){if(!(t[a>>2]|0))break;do if((t[(t[a>>2]|0)+4>>2]|0)==1?(t[(t[a>>2]|0)+36>>2]|0)!=0:0){if((Xl(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(Xl(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0)break;if(Xl(t[(t[a>>2]|0)+8>>2]|0,133704)|0){l=20;break i}if(Xl(t[(t[a>>2]|0)+8>>2]|0,132712)|0)t[o>>2]=(t[o>>2]|0)+1;
	}while(0);t[a>>2]=t[(t[a>>2]|0)+24>>2]}if((l|0)==20){Io(t[f>>2]|0,t[u>>2]|0,1614,133712,133704);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if((t[o>>2]|0)>1){Io(t[f>>2]|0,t[u>>2]|0,1615,133744,133704);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}}while(0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}function Co(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;Ho(t[n>>2]|0,t[f>>2]|0)|0;s=r;return 0}function Po(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+64|0;n=r+52|0;f=r+48|0;u=r+44|0;a=r+40|0;o=r+36|0;c=r+32|0;l=r+28|0;b=r+24|0;k=r+20|0;h=r+16|0;w=r+12|0;d=r+8|0;v=r+4|0;m=r;t[f>>2]=e;t[u>>2]=i;t[h>>2]=1;if(!(t[f>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}if((t[u>>2]|0)>=0?(t[u>>2]|0)<(t[(t[f>>2]|0)+8>>2]|0):0){t[a>>2]=t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2];if(!(t[a>>2]|0)){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}t[o>>2]=xo(t[f>>2]|0,t[a>>2]|0,132616)|0;if((t[o>>2]|0)==0?(t[o>>2]=Yl(132624)|0,(t[o>>2]|0)==0):0){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}t[c>>2]=xo(t[f>>2]|0,t[a>>2]|0,132632)|0;do if(t[c>>2]|0){if(Xl(t[c>>2]|0,132640)|0){t[h>>2]=1;break}if(Xl(t[c>>2]|0,132648)|0){t[h>>2]=0;break}Io(t[f>>2]|0,t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2]|0,1601,132656,t[c>>2]|0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}while(0);t[l>>2]=oF(t[t[f>>2]>>2]|0,t[a>>2]|0)|0;i=t[o>>2]|0;if(!(t[l>>2]|0))t[k>>2]=GA(i,t[(t[t[f>>2]>>2]|0)+72>>2]|0)|0;else t[k>>2]=GA(i,t[l>>2]|0)|0;if(!(t[k>>2]|0)){t[d>>2]=YA(t[l>>2]|0)|0;t[v>>2]=YA(t[o>>2]|0)|0;t[k>>2]=GA(t[v>>2]|0,t[d>>2]|0)|0;if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0)}v=t[f>>2]|0;if(!(t[k>>2]|0)){Io(v,t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2]|0,1605,132688,0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}t[b>>2]=t[v+64>>2];t[(t[f>>2]|0)+64>>2]=t[l>>2];v=t[f>>2]|0;d=t[k>>2]|0;i=t[u>>2]|0;if(t[h>>2]|0)t[w>>2]=Uo(v,d,i)|0;else t[w>>2]=zo(v,d,i)|0;t[(t[f>>2]|0)+64>>2]=t[b>>2];e:do if((t[w>>2]|0)<0){t[m>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(t[m>>2]|0))break e;do if(((t[(t[m>>2]|0)+4>>2]|0)==1?(t[(t[m>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,132712)|0)!=0:0){if((Xl(t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(Xl(t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0)break;t[w>>2]=jo(t[f>>2]|0,t[m>>2]|0,t[u>>2]|0)|0;if(!(t[w>>2]|0))break e}while(0);t[m>>2]=t[(t[m>>2]|0)+24>>2]}}while(0);if((t[w>>2]|0)<0)Io(t[f>>2]|0,t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2]|0,1604,132792,t[k>>2]|0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[n>>2]=0;_=t[n>>2]|0;s=r;return _|0}t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}function Bo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}if((t[u>>2]|0)>=0?(t[u>>2]|0)<(t[(t[f>>2]|0)+8>>2]|0):0){t[a>>2]=t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)!=18:0){if((t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+16>>2]|0)==0?(t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+28>>2]|0)!=0:0){i=Vo(t[f>>2]|0,t[t[f>>2]>>2]|0,t[t[f>>2]>>2]|0,t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+28>>2]|0)|0;t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+16>>2]=i;_n(t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+28>>2]|0);t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+28>>2]=0}t[c>>2]=t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+16>>2];t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+16>>2]=0;if((t[(t[a>>2]|0)+20>>2]|0)!=0?(t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]|0)!=1:0){t[b>>2]=0;t[l>>2]=t[c>>2];while(1){if(!(t[l>>2]|0))break;if((t[(t[l>>2]|0)+4>>2]|0)==1)t[b>>2]=(t[b>>2]|0)+1;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if((t[b>>2]|0)>1){Io(t[f>>2]|0,t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2]|0,1611,132536,0);t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}}e:do if(t[(t[f>>2]|0)+60>>2]&32768){while(1){if(!(t[c>>2]|0))break;t[o>>2]=t[c>>2];t[c>>2]=t[(t[c>>2]|0)+24>>2];Py(t[a>>2]|0,t[o>>2]|0)|0}iy(t[a>>2]|0);ry(t[a>>2]|0)}else{t[(t[a>>2]|0)+4>>2]=19;t[o>>2]=Sy(t[(t[a>>2]|0)+32>>2]|0,t[(t[a>>2]|0)+36>>2]|0,t[(t[a>>2]|0)+8>>2]|0,0)|0;if(!(t[o>>2]|0)){Io(t[f>>2]|0,t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+12>>2]|0,1609,132592,0);t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}t[(t[o>>2]|0)+4>>2]=20;oy(t[a>>2]|0,t[o>>2]|0)|0;while(1){if(!(t[c>>2]|0))break e;t[a>>2]=t[c>>2];t[c>>2]=t[(t[c>>2]|0)+24>>2];Py(t[o>>2]|0,t[a>>2]|0)|0}}while(0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}function Io(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(t[o>>2]|0){f=(t[o>>2]|0)+52|0;t[f>>2]=(t[f>>2]|0)+1}f=t[o>>2]|0;o=t[c>>2]|0;c=t[l>>2]|0;l=t[k>>2]|0;n=t[b>>2]|0;t[a>>2]=t[k>>2];cp(0,0,0,f,o,11,c,2,0,0,l,0,0,0,0,n,a);s=u;return}function Ho(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;r=s;s=s+64|0;n=r+60|0;f=r+56|0;a=r+52|0;o=r+48|0;c=r+44|0;l=r+40|0;b=r+36|0;k=r+32|0;h=r+28|0;w=r+24|0;d=r+20|0;v=r+16|0;m=r+12|0;_=r+8|0;p=r+4|0;E=r;t[f>>2]=e;t[a>>2]=i;t[b>>2]=0;t[v>>2]=1;t[_>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}if(!(t[a>>2]|0)){t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}t[k>>2]=xo(t[f>>2]|0,t[a>>2]|0,132616)|0;if((t[k>>2]|0)==0?(t[k>>2]=Yl(132624)|0,(t[k>>2]|0)==0):0){t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}if(!((u[t[k>>2]>>0]|0|0)!=35?(u[t[k>>2]>>0]|0|0)!=0:0))t[_>>2]=1;t[h>>2]=xo(t[f>>2]|0,t[a>>2]|0,132632)|0;do if(t[h>>2]|0){if(Xl(t[h>>2]|0,132640)|0){t[v>>2]=1;break}if(Xl(t[h>>2]|0,132648)|0){t[v>>2]=0;break}Io(t[f>>2]|0,t[a>>2]|0,1601,132656,t[h>>2]|0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}while(0);t[w>>2]=oF(t[t[f>>2]>>2]|0,t[a>>2]|0)|0;i=t[k>>2]|0;if(!(t[w>>2]|0))t[d>>2]=GA(i,t[(t[t[f>>2]>>2]|0)+72>>2]|0)|0;else t[d>>2]=GA(i,t[w>>2]|0)|0;if(!(t[d>>2]|0)){t[p>>2]=YA(t[w>>2]|0)|0;t[E>>2]=YA(t[k>>2]|0)|0;t[d>>2]=GA(t[E>>2]|0,t[p>>2]|0)|0;if(t[p>>2]|0)pAi[t[135736>>2]&511](t[p>>2]|0);if(t[E>>2]|0)pAi[t[135736>>2]&511](t[E>>2]|0)}if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);w=t[f>>2]|0;k=t[a>>2]|0;if(!(t[d>>2]|0)){Io(w,k,1605,132688,0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}t[b>>2]=xo(w,k,133496)|0;t[c>>2]=IA(t[d>>2]|0)|0;if(!(t[c>>2]|0)){Io(t[f>>2]|0,t[a>>2]|0,1605,132840,t[d>>2]|0);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[d>>2]|0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}do if(t[(t[c>>2]|0)+32>>2]|0)if(t[(t[f>>2]|0)+56>>2]|0){if(!(t[b>>2]|0))t[b>>2]=t[(t[c>>2]|0)+32>>2];else pAi[t[135736>>2]&511](t[(t[c>>2]|0)+32>>2]|0);t[(t[c>>2]|0)+32>>2]=0;break}else{Io(t[f>>2]|0,t[a>>2]|0,1618,133512,t[d>>2]|0);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);xA(t[c>>2]|0);pAi[t[135736>>2]&511](t[d>>2]|0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}while(0);t[l>>2]=zA(t[c>>2]|0)|0;xA(t[c>>2]|0);pAi[t[135736>>2]&511](t[d>>2]|0);if(!(t[l>>2]|0)){Io(t[f>>2]|0,t[a>>2]|0,1605,132840,t[d>>2]|0);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}do if((t[_>>2]|0)==1&(t[v>>2]|0)==1){if((t[b>>2]|0)!=0?(u[t[b>>2]>>0]|0|0)!=0:0)break;Io(t[f>>2]|0,t[a>>2]|0,1600,133584,t[l>>2]|0);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}while(0);e:do if((t[_>>2]|0)==0&(t[v>>2]|0)==1){t[m>>2]=0;while(1){if((t[m>>2]|0)>=(t[(t[f>>2]|0)+40>>2]|0))break e;if(Xl(t[l>>2]|0,t[(t[(t[f>>2]|0)+48>>2]|0)+(t[m>>2]<<2)>>2]|0)|0)break;t[m>>2]=(t[m>>2]|0)+1}Io(t[f>>2]|0,t[a>>2]|0,1600,133640,t[l>>2]|0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}while(0);t[o>>2]=qo(t[f>>2]|0,t[l>>2]|0,t[a>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}else{t[(t[o>>2]|0)+4>>2]=t[b>>2];t[(t[o>>2]|0)+8>>2]=0;t[(t[o>>2]|0)+20>>2]=t[v>>2];t[(t[o>>2]|0)+24>>2]=1;pAi[t[135736>>2]&511](t[l>>2]|0);t[n>>2]=0;S=t[n>>2]|0;s=r;return S|0}return 0}function xo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=tF(t[a>>2]|0,132728,t[o>>2]|0)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+56>>2]|0)!=0?(t[c>>2]=tF(t[a>>2]|0,132760,t[o>>2]|0)|0,(t[c>>2]|0)!=0):0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}t[c>>2]=cF(t[a>>2]|0,t[o>>2]|0)|0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function Uo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;n=s;s=s+80|0;f=n+68|0;a=n+64|0;o=n+60|0;c=n+56|0;l=n+52|0;b=n+48|0;k=n+44|0;h=n+40|0;w=n+36|0;d=n+32|0;v=n+28|0;m=n+24|0;_=n+20|0;p=n+16|0;E=n+12|0;S=n+8|0;g=n+4|0;y=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[h>>2]=0;t[w>>2]=0;t[b>>2]=IA(t[o>>2]|0)|0;if(!(t[b>>2]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,t[o>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}if(t[(t[b>>2]|0)+32>>2]|0){t[h>>2]=t[(t[b>>2]|0)+32>>2];t[(t[b>>2]|0)+32>>2]=0}if(((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)!=0:0)?(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0)!=0:0){if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=Yl(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0)|0}t[k>>2]=zA(t[b>>2]|0)|0;xA(t[b>>2]|0);if(!(t[k>>2]|0)){b=t[a>>2]|0;if(t[(t[a>>2]|0)+16>>2]|0)Io(b,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,t[o>>2]|0);else Io(b,0,1605,132840,t[o>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}do if((u[t[k>>2]>>0]|0|0)!=0?(u[t[k>>2]>>0]|0|0)!=35:0){if((t[t[a>>2]>>2]|0)!=0?(Xl(t[k>>2]|0,t[(t[t[a>>2]>>2]|0)+72>>2]|0)|0)!=0:0){O=22;break}t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[(t[a>>2]|0)+8>>2]|0))break;if((Xl(t[k>>2]|0,t[t[(t[(t[a>>2]|0)+16>>2]|0)+(t[w>>2]<<2)>>2]>>2]|0)|0)!=0?(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[w>>2]<<2)>>2]|0)+8>>2]|0)!=0:0){O=27;break}t[w>>2]=(t[w>>2]|0)+1}if((O|0)==27){t[l>>2]=t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[w>>2]<<2)>>2]|0)+8>>2];break}t[d>>2]=t[(t[a>>2]|0)+60>>2];if(t[h>>2]|0){o=(t[a>>2]|0)+60|0;t[o>>2]=t[o>>2]|2}t[l>>2]=Yo(t[a>>2]|0,t[k>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=t[d>>2];if(!(t[l>>2]|0)){pAi[t[135736>>2]&511](t[k>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+8>>2]=t[l>>2];if(!(Xl(t[k>>2]|0,t[(t[l>>2]|0)+72>>2]|0)|0)){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=Yl(t[(t[l>>2]|0)+72>>2]|0)|0}t[w>>2]=(t[c>>2]|0)+1;while(1){if((t[w>>2]|0)>=(t[(t[a>>2]|0)+8>>2]|0))break;if(Xl(t[k>>2]|0,t[t[(t[(t[a>>2]|0)+16>>2]|0)+(t[w>>2]<<2)>>2]>>2]|0)|0){O=40;break}t[w>>2]=(t[w>>2]|0)+1}if((O|0)==40){o=(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+24|0;t[o>>2]=(t[o>>2]|0)+1}Go(t[a>>2]|0,t[t[a>>2]>>2]|0,t[l>>2]|0)|0;Wo(t[a>>2]|0,t[l>>2]|0,t[k>>2]|0)}else O=22;while(0);if((O|0)==22)t[l>>2]=0;d=(t[l>>2]|0)==0;do if(!(t[h>>2]|0)){o=t[a>>2]|0;if(d){b=Xy(t[(t[o>>2]|0)+12>>2]|0)|0;t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+16>>2]=b;break}else{b=Ko(o,t[t[a>>2]>>2]|0,t[l>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0;t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+16>>2]=b;break}}else{if(d)t[m>>2]=Ua(t[t[a>>2]>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,0)|0;else t[m>>2]=Ua(t[l>>2]|0,0,0)|0;if(!(t[m>>2]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1612,133056,0);pAi[t[135736>>2]&511](t[k>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}t[v>>2]=ja(t[h>>2]|0,t[m>>2]|0)|0;if(!(t[v>>2]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1612,133096,t[h>>2]|0);vf(t[m>>2]|0);pAi[t[135736>>2]&511](t[k>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}switch(t[t[v>>2]>>2]|0){case 9:case 8:case 5:case 4:case 3:case 2:case 0:{Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1613,133136,t[h>>2]|0);vf(t[m>>2]|0);pAi[t[135736>>2]&511](t[k>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}case 1:{O=56;break}default:{}}do if((O|0)==56){if((t[(t[v>>2]|0)+4>>2]|0)!=0?(t[t[(t[v>>2]|0)+4>>2]>>2]|0)>0:0)break;vf(t[m>>2]|0);pAi[t[135736>>2]&511](t[k>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}while(0);t[_>>2]=t[(t[v>>2]|0)+4>>2];e:do if(t[_>>2]|0){t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[t[_>>2]>>2]|0))break e;i:do if(t[(t[(t[_>>2]|0)+8>>2]|0)+(t[w>>2]<<2)>>2]|0)switch(t[(t[(t[(t[_>>2]|0)+8>>2]|0)+(t[w>>2]<<2)>>2]|0)+4>>2]|0){case 10:case 11:case 12:case 14:case 15:case 16:case 17:case 19:case 20:{Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1613,133248,t[h>>2]|0);t[(t[(t[_>>2]|0)+8>>2]|0)+(t[w>>2]<<2)>>2]=0;t[(t[(t[_>>2]|0)+8>>2]|0)+(t[w>>2]<<2)>>2]=0;break i;break}case 18:{Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1613,133208,t[h>>2]|0);t[(t[(t[_>>2]|0)+8>>2]|0)+(t[w>>2]<<2)>>2]=0;break i;break}case 2:{Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1613,133168,t[h>>2]|0);t[(t[(t[_>>2]|0)+8>>2]|0)+(t[w>>2]<<2)>>2]=0;break i;break}default:break i}while(0);t[w>>2]=(t[w>>2]|0)+1}}while(0);if(!(t[l>>2]|0)){t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+28>>2]=t[v>>2];t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+16>>2]=0}else{b=Vo(t[a>>2]|0,t[t[a>>2]>>2]|0,t[l>>2]|0,t[v>>2]|0)|0;t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+16>>2]=b;_n(t[v>>2]|0)}vf(t[m>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0)}while(0);if(((t[l>>2]|0)!=0&(t[k>>2]|0)!=0?(t[(t[a>>2]|0)+60>>2]&262144|0)==0:0)?(t[(t[l>>2]|0)+88>>2]&262144|0)==0:0){t[E>>2]=tF(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,133288,133296)|0;do if(!(t[E>>2]|0)){t[S>>2]=WA(t[k>>2]|0,t[(t[a>>2]|0)+64>>2]|0)|0;if(!(t[S>>2]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1605,133336,t[k>>2]|0);break}if(es(t[S>>2]|0,47)|0){t[E>>2]=t[S>>2];break}else{pAi[t[135736>>2]&511](t[S>>2]|0);break}}while(0);if(t[E>>2]|0){t[p>>2]=t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+16>>2];while(1){if(!(t[p>>2]|0))break;do if((t[(t[p>>2]|0)+4>>2]|0)==1){t[S>>2]=oF(t[(t[p>>2]|0)+32>>2]|0,t[p>>2]|0)|0;if(!(t[S>>2]|0)){aF(t[p>>2]|0,t[E>>2]|0);break}l=(Xl(t[S>>2]|0,t[(t[(t[p>>2]|0)+32>>2]|0)+72>>2]|0)|0)!=0;h=t[p>>2]|0;if(!l){t[g>>2]=tF(h,133288,133296)|0;if(t[g>>2]|0){t[y>>2]=GA(t[g>>2]|0,t[E>>2]|0)|0;if(!(t[y>>2]|0))Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1605,133376,t[g>>2]|0);else{aF(t[p>>2]|0,t[y>>2]|0);pAi[t[135736>>2]&511](t[y>>2]|0)}pAi[t[135736>>2]&511](t[g>>2]|0)}}else aF(h,t[E>>2]|0);pAi[t[135736>>2]&511](t[S>>2]|0)}while(0);t[p>>2]=t[(t[p>>2]|0)+24>>2]}pAi[t[135736>>2]&511](t[E>>2]|0)}}if(((t[c>>2]|0)<(t[(t[a>>2]|0)+8>>2]|0)?(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+24>>2]|0)<=1:0){fy(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+8>>2]|0);t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+8>>2]=0}pAi[t[135736>>2]&511](t[k>>2]|0);t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}function zo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;n=s;s=s+80|0;f=n+68|0;a=n+64|0;o=n+60|0;c=n+56|0;l=n+52|0;b=n+48|0;k=n+44|0;h=n+40|0;w=n+36|0;d=n+32|0;v=n+28|0;m=n+24|0;_=n+20|0;p=n+16|0;E=n+12|0;S=n+8|0;g=n+4|0;y=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[d>>2]=0;t[v>>2]=0;t[p>>2]=0;t[k>>2]=IA(t[o>>2]|0)|0;if(!(t[k>>2]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,t[o>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}if(t[(t[k>>2]|0)+32>>2]|0){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1606,132864,t[(t[k>>2]|0)+32>>2]|0);xA(t[k>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}t[h>>2]=zA(t[k>>2]|0)|0;xA(t[k>>2]|0);if(!(t[h>>2]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,t[o>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}if(!(u[t[h>>2]>>0]|0)){Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1607,132912,0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[(t[a>>2]|0)+20>>2]|0)){O=14;break}o=(Xl(t[h>>2]|0,t[(t[(t[a>>2]|0)+32>>2]|0)+(t[w>>2]<<2)>>2]|0)|0)!=0;A=t[w>>2]|0;if(o){O=12;break}t[w>>2]=A+1}do if((O|0)==12)t[b>>2]=Gy(t[(t[(t[a>>2]|0)+28>>2]|0)+(A<<2)>>2]|0,1)|0;else if((O|0)==14){if((t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)!=0?(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0)!=0:0)t[d>>2]=cF(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,132960)|0;do if(t[d>>2]|0){t[v>>2]=B_(t[d>>2]|0)|0;if((t[v>>2]|0)!=-1){pAi[t[135736>>2]&511](t[d>>2]|0);break}Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1610,132976,t[d>>2]|0);pAi[t[135736>>2]&511](t[d>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}while(0);t[m>>2]=zp()|0;t[_>>2]=uA(t[h>>2]|0,0,t[m>>2]|0)|0;if(!(t[_>>2]|0)){Up(t[m>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}t[l>>2]=t[t[_>>2]>>2];if(!(t[l>>2]|0)){Dp(t[_>>2]|0);Up(t[m>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}if(t[(t[l>>2]|0)+12>>2]|0)W_(t[(t[l>>2]|0)+12>>2]|0)|0;o=j_(t[v>>2]|0)|0;t[(t[l>>2]|0)+12>>2]=o;t[b>>2]=yy(0)|0;while(1){if((QO(t[l>>2]|0,128)|0)<=0){O=41;break}t[S>>2]=Os(t[(t[l>>2]|0)+16>>2]|0)|0;t[E>>2]=Ns(t[(t[l>>2]|0)+16>>2]|0)|0;t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[E>>2]|0)){O=40;break}t[g>>2]=Mp(0,(t[S>>2]|0)+(t[w>>2]|0)|0,y)|0;o=t[g>>2]|0;if((t[g>>2]|0)<256){if(!(9<=(o|0)&(t[g>>2]|0)<=10|(t[g>>2]|0)==13|32<=(t[g>>2]|0)))break}else if((!(256<=(o|0)&(t[g>>2]|0)<=55295)?!(57344<=(t[g>>2]|0)&(t[g>>2]|0)<=65533):0)?!(65536<=(t[g>>2]|0)&(t[g>>2]|0)<=1114111):0)break;t[p>>2]=0;bF(t[b>>2]|0,(t[S>>2]|0)+(t[w>>2]|0)|0,t[y>>2]|0);t[w>>2]=(t[w>>2]|0)+(t[y>>2]|0)}if((O|0)==40){O=0;ys(t[(t[l>>2]|0)+16>>2]|0,t[E>>2]|0)|0;continue}if((t[p>>2]|0)!=0?1:((t[E>>2]|0)-(t[w>>2]|0)|0)>=4)break;t[p>>2]=1;ys(t[(t[l>>2]|0)+16>>2]|0,t[w>>2]|0)|0}if((O|0)==41){Up(t[m>>2]|0);Xo(t[a>>2]|0,t[b>>2]|0,t[h>>2]|0);Dp(t[_>>2]|0);break}Io(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+12>>2]|0,1608,133008,t[h>>2]|0);IO(t[l>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=-1;F=t[f>>2]|0;s=n;return F|0}while(0);t[(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2]|0)+16>>2]=t[b>>2];pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;F=t[f>>2]|0;s=n;return F|0}function jo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if((t[a>>2]|0)!=0?!((t[u>>2]|0)==0?1:(t[(t[a>>2]|0)+4>>2]|0)==18):0){if(t[(t[a>>2]|0)+12>>2]|0){t[c>>2]=Eo(t[t[u>>2]>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}t[(t[c>>2]|0)+68>>2]=t[(t[u>>2]|0)+68>>2];r=Yl(t[(t[u>>2]|0)+64>>2]|0)|0;t[(t[c>>2]|0)+64>>2]=r;go(t[c>>2]|0,t[(t[u>>2]|0)+60>>2]|0)|0;t[l>>2]=To(t[c>>2]|0,t[t[u>>2]>>2]|0,t[(t[a>>2]|0)+12>>2]|0)|0;if((t[(t[u>>2]|0)+52>>2]|0)<=0){if((t[l>>2]|0)>0)t[l>>2]=0}else t[l>>2]=-1;So(t[c>>2]|0);c=Ky(t[t[u>>2]>>2]|0,t[(t[a>>2]|0)+12>>2]|0)|0;t[(t[(t[(t[u>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]|0)+16>>2]=c}else{t[(t[(t[(t[u>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]|0)+16>>2]=0;t[(t[(t[(t[u>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]|0)+32>>2]=1}t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}function Vo(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f+44|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+8|0;v=f+4|0;m=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;t[k>>2]=0;if(!(t[c>>2]|0))t[c>>2]=t[t[a>>2]>>2];if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}n=t[t[l>>2]>>2]|0;e:do if((n|0)==6){t[u>>2]=Jo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;_=t[u>>2]|0;s=f;return _|0}else if((n|0)==1){t[w>>2]=t[(t[l>>2]|0)+4>>2];if(!(t[w>>2]|0)){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[t[w>>2]>>2]|0))break e;i:do if(t[(t[(t[w>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0){switch(t[(t[(t[(t[w>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)+4>>2]|0){case 2:case 18:case 10:case 11:case 12:case 14:case 15:case 16:case 17:{break i;break}case 19:break;default:{if(!(t[k>>2]|0)){r=Zo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[(t[(t[w>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)|0;t[k>>2]=r;t[b>>2]=r;break i}oy(t[k>>2]|0,Zo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[(t[(t[w>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)|0)|0;if(!(t[(t[k>>2]|0)+24>>2]|0))break i;t[k>>2]=t[(t[k>>2]|0)+24>>2];break i}}t[v>>2]=t[(t[(t[w>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2];t[v>>2]=t[(t[v>>2]|0)+24>>2];while(1){if(!(t[v>>2]|0))break i;switch(t[(t[v>>2]|0)+4>>2]|0){case 8:case 7:case 6:case 5:case 1:case 4:case 3:break;default:break i}t[d>>2]=Zo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[v>>2]|0)|0;if(!(t[k>>2]|0)){r=t[d>>2]|0;t[k>>2]=r;t[b>>2]=r}else{oy(t[k>>2]|0,t[d>>2]|0)|0;t[k>>2]=t[d>>2]}t[v>>2]=t[(t[v>>2]|0)+24>>2]}}while(0);t[h>>2]=(t[h>>2]|0)+1}}else if((n|0)==7){t[m>>2]=t[(t[l>>2]|0)+28>>2];if(!(t[m>>2]|0)){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[t[m>>2]>>2]|0))break e;if(!(t[k>>2]|0)){r=Vo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[(t[(t[m>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)|0;t[k>>2]=r;t[b>>2]=r}else{r=t[k>>2]|0;oy(r,Vo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[(t[(t[m>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2]|0)|0)|0}i:do if(t[k>>2]|0)while(1){if(!(t[(t[k>>2]|0)+24>>2]|0))break i;t[k>>2]=t[(t[k>>2]|0)+24>>2]}while(0);t[h>>2]=(t[h>>2]|0)+1}}while(0);t[u>>2]=t[b>>2];_=t[u>>2]|0;s=f;return _|0}function qo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[c>>2]|0)){Mo(t[u>>2]|0,t[o>>2]|0,133672);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=(t[c>>2]|0)+0|0;i=r+36|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));if(!(t[a>>2]|0))t[t[c>>2]>>2]=0;else{r=Yl(t[a>>2]|0)|0;t[t[c>>2]>>2]=r}t[(t[c>>2]|0)+4>>2]=0;t[(t[c>>2]|0)+12>>2]=t[o>>2];t[(t[c>>2]|0)+8>>2]=0;t[(t[c>>2]|0)+24>>2]=0;t[(t[c>>2]|0)+20>>2]=0;t[(t[c>>2]|0)+16>>2]=0;if((t[(t[u>>2]|0)+12>>2]|0)==0?(t[(t[u>>2]|0)+12>>2]=4,r=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+12>>2]<<2)|0,t[(t[u>>2]|0)+16>>2]=r,(t[(t[u>>2]|0)+16>>2]|0)==0):0){Mo(t[u>>2]|0,t[o>>2]|0,133672);No(t[c>>2]|0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+8>>2]|0)>=(t[(t[u>>2]|0)+12>>2]|0)?(r=(t[u>>2]|0)+12|0,t[r>>2]=t[r>>2]<<1,r=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+12>>2]<<2)|0,t[(t[u>>2]|0)+16>>2]=r,(t[(t[u>>2]|0)+16>>2]|0)==0):0){Mo(t[u>>2]|0,t[o>>2]|0,133672);No(t[c>>2]|0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}o=t[c>>2]|0;r=(t[u>>2]|0)+8|0;a=t[r>>2]|0;t[r>>2]=a+1;t[(t[(t[u>>2]|0)+16>>2]|0)+(a<<2)>>2]=o;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function Yo(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;rS();t[o>>2]=zp()|0;i=t[f>>2]|0;if(!(t[o>>2]|0)){Mo(i,0,133464);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[(t[o>>2]|0)+272>>2]=t[i+68>>2];if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+80>>2]|0)!=0:0){if(t[(t[o>>2]|0)+296>>2]|0)bz(t[(t[o>>2]|0)+296>>2]|0);t[(t[o>>2]|0)+296>>2]=t[(t[t[f>>2]>>2]|0)+80>>2];sz(t[(t[o>>2]|0)+296>>2]|0)|0}mS(t[o>>2]|0,t[(t[f>>2]|0)+60>>2]|4)|0;t[c>>2]=uA(t[u>>2]|0,0,t[o>>2]|0)|0;f=t[o>>2]|0;if(!(t[c>>2]|0)){Up(f);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}eE(f,t[c>>2]|0)|0;if(!(t[(t[o>>2]|0)+180>>2]|0)){c=rA(t[u>>2]|0)|0;t[(t[o>>2]|0)+180>>2]=c}c=(t[o>>2]|0)+276|0;t[c>>2]=t[c>>2]|2;iS(t[o>>2]|0)|0;if(t[(t[o>>2]|0)+12>>2]|0)t[a>>2]=t[(t[o>>2]|0)+8>>2];else{t[a>>2]=0;if(t[(t[o>>2]|0)+8>>2]|0)fy(t[(t[o>>2]|0)+8>>2]|0);t[(t[o>>2]|0)+8>>2]=0}Up(t[o>>2]|0);t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}function Go(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+8|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+44>>2]|0)!=0:0){t[l>>2]=t[(t[a>>2]|0)+44>>2];if(!(t[l>>2]|0)){t[c>>2]=eF(t[a>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}t[l>>2]=$g(t[a>>2]|0,t[(t[c>>2]|0)+8>>2]|0,0,0)|0;if(!(t[l>>2]|0)){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}}t[b>>2]=t[(t[o>>2]|0)+44>>2];if((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+48>>2]|0)!=0:0){t[k+4>>2]=t[u>>2];t[k>>2]=t[a>>2];aO(t[(t[b>>2]|0)+48>>2]|0,314,k)}t[b>>2]=t[(t[o>>2]|0)+48>>2];if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+48>>2]|0)!=0:0)?(t[h+4>>2]=t[u>>2],t[h>>2]=t[a>>2],(Xl(t[(t[l>>2]|0)+52>>2]|0,t[(t[b>>2]|0)+52>>2]|0)|0)==0):0)?(Xl(t[(t[l>>2]|0)+56>>2]|0,t[(t[b>>2]|0)+56>>2]|0)|0)==0:0)aO(t[(t[b>>2]|0)+48>>2]|0,314,h);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}function Wo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[n+8>>2]=r;t[a>>2]=Eo(t[u>>2]|0)|0;if(!(t[a>>2]|0)){s=n;return}t[(t[a>>2]|0)+68>>2]=t[(t[f>>2]|0)+68>>2];t[(t[a>>2]|0)+12>>2]=t[(t[f>>2]|0)+12>>2];t[(t[a>>2]|0)+8>>2]=t[(t[f>>2]|0)+8>>2];r=gAi[t[135744>>2]&511](t[(t[a>>2]|0)+12>>2]<<2)|0;t[(t[a>>2]|0)+16>>2]=r;r=t[f>>2]|0;if(!(t[(t[a>>2]|0)+16>>2]|0)){Mo(r,t[u>>2]|0,133408);pAi[t[135736>>2]&511](t[a>>2]|0);s=n;return}t[(t[a>>2]|0)+44>>2]=t[r+44>>2];t[(t[a>>2]|0)+40>>2]=t[(t[f>>2]|0)+40>>2];t[(t[a>>2]|0)+48>>2]=t[(t[f>>2]|0)+48>>2];r=Yl(t[(t[f>>2]|0)+64>>2]|0)|0;t[(t[a>>2]|0)+64>>2]=r;t[(t[a>>2]|0)+4>>2]=t[(t[f>>2]|0)+8>>2];t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[f>>2]|0)+8>>2]|0))break;t[(t[(t[a>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]=t[(t[(t[f>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2];r=(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]|0)+24|0;t[r>>2]=(t[r>>2]|0)+1;t[o>>2]=(t[o>>2]|0)+1}t[(t[a>>2]|0)+60>>2]=t[(t[f>>2]|0)+60>>2];r=t[a>>2]|0;i=t[u>>2]|0;To(r,i,eF(t[u>>2]|0)|0)|0;t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[f>>2]|0)+8>>2]|0))break;u=(t[(t[(t[a>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]|0)+24|0;t[u>>2]=(t[u>>2]|0)+-1;t[(t[(t[a>>2]|0)+16>>2]|0)+(t[o>>2]<<2)>>2]=0;t[o>>2]=(t[o>>2]|0)+1}t[(t[f>>2]|0)+48>>2]=t[(t[a>>2]|0)+48>>2];t[(t[f>>2]|0)+44>>2]=t[(t[a>>2]|0)+44>>2];t[(t[a>>2]|0)+44>>2]=0;t[(t[a>>2]|0)+40>>2]=0;t[(t[a>>2]|0)+48>>2]=0;So(t[a>>2]|0);s=n;return}function Ko(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[h>>2]=0;t[w>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}t[b>>2]=t[l>>2];while(1){if(!(t[b>>2]|0))break;t[k>>2]=Zo(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[b>>2]|0)|0;do if(t[k>>2]|0){l=t[k>>2]|0;if(!(t[h>>2]|0)){t[w>>2]=l;t[h>>2]=l;break}else{t[(t[w>>2]|0)+24>>2]=l;t[(t[k>>2]|0)+28>>2]=t[w>>2];t[w>>2]=t[k>>2];break}}while(0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}t[u>>2]=t[h>>2];d=t[u>>2]|0;s=f;return d|0}function Xo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[(t[f>>2]|0)+24>>2]|0)){t[(t[f>>2]|0)+24>>2]=4;r=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+24>>2]<<2)|0;t[(t[f>>2]|0)+28>>2]=r;if(!(t[(t[f>>2]|0)+28>>2]|0)){Mo(t[f>>2]|0,0,133040);s=n;return}r=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+24>>2]<<2)|0;t[(t[f>>2]|0)+32>>2]=r;if(!(t[(t[f>>2]|0)+32>>2]|0)){Mo(t[f>>2]|0,0,133040);s=n;return}}if((t[(t[f>>2]|0)+20>>2]|0)>=(t[(t[f>>2]|0)+24>>2]|0)){r=(t[f>>2]|0)+24|0;t[r>>2]=t[r>>2]<<1;r=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+28>>2]|0,t[(t[f>>2]|0)+24>>2]<<2)|0;t[(t[f>>2]|0)+28>>2]=r;if(!(t[(t[f>>2]|0)+28>>2]|0)){Mo(t[f>>2]|0,0,133040);s=n;return}r=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+32>>2]|0,t[(t[f>>2]|0)+24>>2]<<2)|0;t[(t[f>>2]|0)+32>>2]=r;if(!(t[(t[f>>2]|0)+32>>2]|0)){Mo(t[f>>2]|0,0,133040);s=n;return}}t[(t[(t[f>>2]|0)+28>>2]|0)+(t[(t[f>>2]|0)+20>>2]<<2)>>2]=t[u>>2];u=Yl(t[a>>2]|0)|0;t[(t[(t[f>>2]|0)+32>>2]|0)+(t[(t[f>>2]|0)+20>>2]<<2)>>2]=u;u=(t[f>>2]|0)+20|0;t[u>>2]=(t[u>>2]|0)+1;s=n;return}function Zo(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if((t[(t[l>>2]|0)+4>>2]|0)==14){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if((t[(t[l>>2]|0)+4>>2]|0)==9)t[b>>2]=Ko(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0;else t[b>>2]=Wy(t[l>>2]|0,t[o>>2]|0,1)|0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}function Jo(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;f=s;s=s+96|0;u=f+84|0;a=f+80|0;o=f+76|0;c=f+72|0;l=f+68|0;b=f+64|0;k=f+60|0;h=f+56|0;w=f+52|0;d=f+48|0;v=f+44|0;m=f+40|0;_=f+36|0;p=f+32|0;E=f+28|0;S=f+24|0;g=f+20|0;y=f+16|0;F=f+12|0;O=f+8|0;A=f+4|0;M=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;t[S>>2]=0;t[g>>2]=0;t[y>>2]=0;t[F>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=0;R=t[u>>2]|0;s=f;return R|0}if((t[t[l>>2]>>2]|0)!=6){t[u>>2]=0;R=t[u>>2]|0;s=f;return R|0}t[v>>2]=t[(t[l>>2]|0)+28>>2];if((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+4>>2]|0)!=18:0){t[_>>2]=t[(t[l>>2]|0)+36>>2];if(!(t[_>>2]|0)){t[u>>2]=Wy(t[v>>2]|0,t[o>>2]|0,1)|0;R=t[u>>2]|0;s=f;return R|0}if((t[(t[_>>2]|0)+4>>2]|0)==18){t[u>>2]=0;R=t[u>>2]|0;s=f;return R|0}t[m>>2]=t[v>>2];t[p>>2]=t[(t[l>>2]|0)+32>>2];t[E>>2]=t[(t[l>>2]|0)+40>>2];e:while(1){if(!(t[m>>2]|0)){N=65;break}i:while(1){if((t[S>>2]|0)<0){while(1){if((t[S>>2]|0)>=0)break;t[d>>2]=Wy(t[h>>2]|0,t[o>>2]|0,2)|0;Hy(t[d>>2]|0,t[b>>2]|0)|0;t[b>>2]=t[d>>2];t[h>>2]=t[(t[h>>2]|0)+20>>2];t[S>>2]=(t[S>>2]|0)+1}t[k>>2]=t[b>>2];t[g>>2]=0}while(1){if((t[S>>2]|0)>=(t[g>>2]|0))break;t[k>>2]=t[(t[k>>2]|0)+20>>2];t[g>>2]=(t[g>>2]|0)+-1}T=t[m>>2]|0;if((t[m>>2]|0)==(t[_>>2]|0))break;do if((T|0)!=(t[v>>2]|0)){t[w>>2]=0;switch(t[(t[m>>2]|0)+4>>2]|0){case 2:case 20:case 19:case 17:case 6:case 16:case 15:case 14:break;default:t[w>>2]=Wy(t[m>>2]|0,t[o>>2]|0,2)|0}if(t[w>>2]|0){l=t[k>>2]|0;c=t[w>>2]|0;if((t[S>>2]|0)==(t[g>>2]|0))oy(l,c)|0;else{Hy(l,c)|0;t[g>>2]=t[S>>2]}t[k>>2]=t[w>>2]}}else{if((t[(t[m>>2]|0)+4>>2]|0)!=3?(t[(t[m>>2]|0)+4>>2]|0)!=4:0){t[w>>2]=Wy(t[m>>2]|0,t[o>>2]|0,2)|0;c=t[w>>2]|0;t[k>>2]=c;t[b>>2]=c;t[h>>2]=t[(t[m>>2]|0)+20>>2];if((t[p>>2]|0)>1){N=55;break i}else break}t[M>>2]=t[(t[m>>2]|0)+40>>2];if(!(t[M>>2]|0))t[w>>2]=Oy(0,0)|0;else{if((t[p>>2]|0)>1){t[M>>2]=(t[M>>2]|0)+((t[p>>2]|0)-1);t[p>>2]=0}t[w>>2]=yy(t[M>>2]|0)|0}c=t[w>>2]|0;t[b>>2]=c;t[k>>2]=c;t[h>>2]=t[(t[m>>2]|0)+20>>2]}while(0);t[m>>2]=Va(t[m>>2]|0,S)|0;if(!(t[F>>2]|0))continue e;if(!((t[m>>2]|0)!=0?(t[S>>2]|0)<(t[y>>2]|0):0)){N=65;break e}}if((N|0)==55){N=0;t[m>>2]=$o(t[m>>2]|0,(t[p>>2]|0)-1|0)|0;t[g>>2]=1;t[S>>2]=1;t[p>>2]=0;continue}if((t[T+4>>2]|0)==3)break;t[y>>2]=t[S>>2];t[F>>2]=1;t[w>>2]=Wy(t[m>>2]|0,t[o>>2]|0,2)|0;do if(t[b>>2]|0){c=t[k>>2]|0;l=t[w>>2]|0;if((t[S>>2]|0)==(t[g>>2]|0)){oy(c,l)|0;break}else{Hy(c,l)|0;t[g>>2]=t[S>>2];break}}else{t[b>>2]=t[w>>2];t[h>>2]=t[(t[m>>2]|0)+20>>2]}while(0);t[k>>2]=t[w>>2];if((t[E>>2]|0)>1){t[_>>2]=$o(t[m>>2]|0,(t[E>>2]|0)-1|0)|0;t[E>>2]=0}l=t[m>>2]|0;if((t[p>>2]|0)>1?(t[m>>2]|0)==(t[v>>2]|0):0){t[m>>2]=$o(l,(t[p>>2]|0)-1|0)|0;t[p>>2]=0}else t[m>>2]=t[l+12>>2];t[S>>2]=(t[S>>2]|0)+1;
	}if((N|0)==65){t[u>>2]=t[b>>2];R=t[u>>2]|0;s=f;return R|0}t[O>>2]=t[(t[m>>2]|0)+40>>2];if(!(t[O>>2]|0))t[w>>2]=Oy(0,0)|0;else{t[A>>2]=t[E>>2];if((t[p>>2]|0)>1?(t[m>>2]|0)==(t[v>>2]|0):0){t[O>>2]=(t[O>>2]|0)+((t[p>>2]|0)-1);t[A>>2]=(t[A>>2]|0)-((t[p>>2]|0)-1)}else t[A>>2]=t[E>>2];t[w>>2]=Oy(t[O>>2]|0,t[A>>2]|0)|0}if(!(t[b>>2]|0)){t[u>>2]=t[w>>2];R=t[u>>2]|0;s=f;return R|0}A=t[k>>2]|0;k=t[w>>2]|0;if((t[S>>2]|0)==(t[g>>2]|0))oy(A,k)|0;else Hy(A,k)|0;t[u>>2]=t[b>>2];R=t[u>>2]|0;s=f;return R|0}t[u>>2]=0;R=t[u>>2]|0;s=f;return R|0}function Qo(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[f>>2]=e;t[u>>2]=i;t[n+16>>2]=r;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){s=n;return}t[l>>2]=t[(t[u>>2]|0)+4>>2];t[c>>2]=t[t[u>>2]>>2];if((t[l>>2]|0)==0|(t[c>>2]|0)==0){s=n;return}if(((t[(t[f>>2]|0)+48>>2]|0)+-4|0)>>>0<3){s=n;return}t[a>>2]=b_(t[c>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+48>>2]|0,t[(t[f>>2]|0)+52>>2]|0,t[(t[f>>2]|0)+56>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0;if(t[a>>2]|0){if(!(t[(t[f>>2]|0)+64>>2]|0)){s=n;return}u=Yl(t[(t[f>>2]|0)+64>>2]|0)|0;t[(t[a>>2]|0)+64>>2]=u;s=n;return}t[o>>2]=h_(t[c>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if(!(t[o>>2]|0)){s=n;return}do if((t[(t[f>>2]|0)+48>>2]|0)==(t[(t[o>>2]|0)+48>>2]|0)){if((t[(t[f>>2]|0)+56>>2]|0)!=0?(t[(t[o>>2]|0)+56>>2]|0)!=0:0){if(!(Xl(t[(t[f>>2]|0)+56>>2]|0,t[(t[o>>2]|0)+56>>2]|0)|0))break;s=n;return}if((t[(t[f>>2]|0)+52>>2]|0)!=0?(t[(t[o>>2]|0)+52>>2]|0)!=0:0){if(!(Xl(t[(t[f>>2]|0)+52>>2]|0,t[(t[o>>2]|0)+52>>2]|0)|0))break;s=n;return}if(((t[(t[f>>2]|0)+40>>2]|0)!=0?(t[(t[o>>2]|0)+40>>2]|0)!=0:0)?(Xl(t[(t[f>>2]|0)+40>>2]|0,t[(t[o>>2]|0)+40>>2]|0)|0)!=0:0){s=n;return}}while(0);switch(t[(t[f>>2]|0)+48>>2]|0){case 2:case 1:case 6:case 5:case 4:{s=n;return}default:{}}Io(t[l>>2]|0,t[f>>2]|0,1602,133424,t[(t[f>>2]|0)+8>>2]|0);s=n;return}function $o(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){t[f>>2]=t[(t[f>>2]|0)+12>>2];t[a>>2]=0;while(1){if((t[a>>2]|0)>(t[u>>2]|0)){o=13;break}c=t[f>>2]|0;if(!(t[f>>2]|0)){o=7;break}if(!(((t[c+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=9:0)?(t[(t[f>>2]|0)+4>>2]|0)!=13:0))o=11;if((o|0)==11?(o=0,t[a>>2]=(t[a>>2]|0)+1,(t[a>>2]|0)==(t[u>>2]|0)):0){o=13;break}t[f>>2]=t[(t[f>>2]|0)+24>>2]}if((o|0)==7){t[n>>2]=c;l=t[n>>2]|0;s=r;return l|0}else if((o|0)==13){t[n>>2]=t[f>>2];l=t[n>>2]|0;s=r;return l|0}}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function ec(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+60>>2]|0)dc(t[(t[r>>2]|0)+60>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)XF(t[(t[r>>2]|0)+52>>2]|0,315);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function ic(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+32|0;r=i;n=i+28|0;f=i+24|0;u=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;t[f>>2]=e;t[o>>2]=0;t[a>>2]=zp()|0;if(!(t[a>>2]|0)){if(t[34014]|0)yAi[t[135968+88>>2]&511](0,133880,r);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}t[l>>2]=zO(t[f>>2]|0,0)|0;r=t[a>>2]|0;if(!(t[l>>2]|0)){Up(r);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}t[c>>2]=Cp(r)|0;if(!(t[c>>2]|0)){Up(t[a>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}r=KA(t[f>>2]|0)|0;t[(t[c>>2]|0)+4>>2]=r;t[t[c>>2]>>2]=t[l>>2];zs(t[(t[l>>2]|0)+16>>2]|0,t[c>>2]|0)|0;eE(t[a>>2]|0,t[c>>2]|0)|0;if((t[o>>2]|0)==0?(t[(t[a>>2]|0)+180>>2]|0)==0:0)t[o>>2]=rA(t[f>>2]|0)|0;if((t[o>>2]|0)!=0?(t[(t[a>>2]|0)+180>>2]|0)==0:0)t[(t[a>>2]|0)+180>>2]=t[o>>2];t[(t[a>>2]|0)+100>>2]=0;t[(t[a>>2]|0)+104>>2]=0;t[(t[a>>2]|0)+276>>2]=0;t[(t[a>>2]|0)+268>>2]=0;t[(t[a>>2]|0)+364>>2]=1;iS(t[a>>2]|0)|0;if(t[(t[a>>2]|0)+12>>2]|0)t[u>>2]=t[(t[a>>2]|0)+8>>2];else{t[u>>2]=0;fy(t[(t[a>>2]|0)+8>>2]|0);t[(t[a>>2]|0)+8>>2]=0}Up(t[a>>2]|0);t[n>>2]=t[u>>2];b=t[n>>2]|0;s=i;return b|0}function rc(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[f>>2]=mc(t[n>>2]|0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}t[a>>2]=t[f>>2];while(1){if(((u[t[a>>2]>>0]|0|0)!=0?(u[t[a>>2]>>0]|0|0)!=45:0)?(u[t[a>>2]>>0]|0|0)!=60:0){if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)b=1;else if((u[t[a>>2]>>0]|0|0)>=97)b=(u[t[a>>2]>>0]|0|0)<=122;else b=0;k=b^1}else k=0;h=t[a>>2]|0;if(!k)break;t[a>>2]=h+1}a=t[33474]|0;do if((u[h>>0]|0|0)!=60){t[o>>2]=_c(2,a)|0;if(!(t[o>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}t[c>>2]=pc(t[o>>2]|0,t[f>>2]|0,t[n>>2]|0,0)|0;if((t[c>>2]|0)<0){ec(t[o>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}}else{t[o>>2]=_c(1,a)|0;if(t[o>>2]|0){k=Ec(1,0,0,t[n>>2]|0,t[33474]|0,0)|0;t[(t[o>>2]|0)+60>>2]=k;break}pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}while(0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=t[o>>2];l=t[r>>2]|0;s=i;return l|0}function nc(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;if((t[o>>2]|0)==0&(t[c>>2]|0)==0|(t[a>>2]|0)==0){t[u>>2]=0;k=t[u>>2]|0;s=n;return k|0}do if(t[33468]|0){if((t[o>>2]|0)!=0&(t[c>>2]|0)!=0){r=t[33976]|0;i=t[33980]|0;e=t[c>>2]|0;t[f>>2]=t[o>>2];t[f+4>>2]=e;yAi[r&511](i,133904,f);break}i=t[33976]|0;r=t[33980]|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];yAi[i&511](r,133936,f);break}else{t[f>>2]=t[c>>2];yAi[i&511](r,133960,f);break}}while(0);f=t[a>>2]|0;if((t[t[a>>2]>>2]|0)!=1){t[b>>2]=Fc(f,t[o>>2]|0,t[c>>2]|0)|0;if(t[b>>2]|0)t[l>>2]=Yl(t[b>>2]|0)|0}else{b=Sc(t[f+60>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;t[l>>2]=b;t[l>>2]=(t[l>>2]|0)==(-1|0)?0:b}t[u>>2]=t[l>>2];k=t[u>>2]|0;s=n;return k|0}function fc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}if(t[33468]|0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[a>>2];yAi[i&511](e,133984,n)}n=t[u>>2]|0;if((t[t[u>>2]>>2]|0)!=1){t[c>>2]=Fc(n,0,t[a>>2]|0)|0;if(t[c>>2]|0)t[o>>2]=Yl(t[c>>2]|0)|0}else{c=Oc(t[n+60>>2]|0,t[a>>2]|0)|0;t[o>>2]=c;t[o>>2]=(t[o>>2]|0)==(-1|0)?0:c}t[f>>2]=t[o>>2];l=t[f>>2]|0;s=r;return l|0}function tc(){var e=0,i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;e=s;s=s+32|0;i=e+20|0;r=e+16|0;f=e+12|0;u=e+8|0;a=e+4|0;o=e;if(t[33500]|0){s=e;return}Ac();el(t[33502]|0);if(ti(134016)|0)t[33468]=1;if((t[33510]|0)==0?(c=ti(134048)|0,t[i>>2]=c,t[i>>2]=(t[i>>2]|0)==0?134072:c,t[a>>2]=_c(1,t[33474]|0)|0,(t[a>>2]|0)!=0):0){t[f>>2]=t[i>>2];t[o>>2]=(t[a>>2]|0)+60;while(1){if(!(n[t[f>>2]>>0]|0))break;while(1){do if((n[t[f>>2]>>0]|0)==32)l=1;else{if(9<=(n[t[f>>2]>>0]|0)?(n[t[f>>2]>>0]|0)<=10:0){l=1;break}l=(n[t[f>>2]>>0]|0)==13}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if(!(n[b>>0]|0))continue;t[u>>2]=t[f>>2];while(1){if(!(n[t[f>>2]>>0]|0))break;do if((n[t[f>>2]>>0]|0)==32)k=1;else{if(9<=(n[t[f>>2]>>0]|0)?(n[t[f>>2]>>0]|0)<=10:0){k=1;break}k=(n[t[f>>2]>>0]|0)==13}while(0);if(!(k^1))break;t[f>>2]=(t[f>>2]|0)+1}t[r>>2]=ql(t[u>>2]|0,(t[f>>2]|0)-(t[u>>2]|0)|0)|0;if(!(t[r>>2]|0))continue;i=Ec(1,0,0,t[r>>2]|0,t[33474]|0,0)|0;t[t[o>>2]>>2]=i;if(t[t[o>>2]>>2]|0)t[o>>2]=t[t[o>>2]>>2];pAi[t[135736>>2]&511](t[r>>2]|0)}t[33510]=t[a>>2]}il(t[33502]|0);s=e;return}function uc(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if(!(t[33500]|0))Ac();el(t[33502]|0);if(t[33510]|0){t[f>>2]=Mc(t[33510]|0,t[n>>2]|0)|0;il(t[33502]|0);t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}t[u>>2]=rc(t[n>>2]|0)|0;if(!(t[u>>2]|0)){il(t[33502]|0);t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}else{t[33510]=t[u>>2];il(t[33502]|0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}return 0}function ac(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;f=i+8|0;u=i+4|0;a=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[f>>2]=t[r>>2];e:while(1){if(!(n[t[f>>2]>>0]|0))break;while(1){do if((n[t[f>>2]>>0]|0)==32)o=1;else{if(9<=(n[t[f>>2]>>0]|0)?(n[t[f>>2]>>0]|0)<=10:0){o=1;break}o=(n[t[f>>2]>>0]|0)==13}while(0);c=t[f>>2]|0;if(!o)break;t[f>>2]=c+1}if(n[c>>0]|0){t[u>>2]=t[f>>2];while(1){if(!(n[t[f>>2]>>0]|0))break;if((n[t[f>>2]>>0]|0)==58)break;do if((n[t[f>>2]>>0]|0)==32)l=1;else{if(9<=(n[t[f>>2]>>0]|0)?(n[t[f>>2]>>0]|0)<=10:0){l=1;break}l=(n[t[f>>2]>>0]|0)==13}while(0);if(!(l^1))break;t[f>>2]=(t[f>>2]|0)+1}t[a>>2]=ql(t[u>>2]|0,(t[f>>2]|0)-(t[u>>2]|0)|0)|0;if(t[a>>2]|0){uc(t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0)}}while(1){if((n[t[f>>2]>>0]|0)!=58)continue e;t[f>>2]=(t[f>>2]|0)+1}}s=i;return}function oc(){var e=0;e=s;s=s+16|0;if(!(t[33500]|0)){s=e;return}el(t[33502]|0);if(t[33468]|0)yAi[t[135904>>2]&511](t[33980]|0,134096,e);if(t[33530]|0)XF(t[33530]|0,316);t[33530]=0;if(t[33510]|0)ec(t[33510]|0);t[33510]=0;t[33468]=0;t[33500]=0;il(t[33502]|0);$c(t[33502]|0);s=e;return}function cc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[33500]|0))tc();t[u>>2]=nc(t[33510]|0,t[n>>2]|0,t[f>>2]|0)|0;s=r;return t[u>>2]|0}function lc(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[33500]|0))tc();t[n>>2]=fc(t[33510]|0,t[r>>2]|0)|0;s=i;return t[n>>2]|0}function sc(){return t[33534]|0}function bc(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[33500]|0))tc();t[n>>2]=t[r>>2];if(!(t[n>>2]|0)){s=i;return}dc(t[n>>2]|0);s=i;return}function kc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;t[u>>2]=e;t[a>>2]=i;if(!(t[33500]|0))tc();if(!(t[a>>2]|0)){t[f>>2]=t[u>>2];l=t[f>>2]|0;s=r;return l|0}if(t[33468]|0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[a>>2];yAi[i&511](e,134144,n)}t[c>>2]=Ec(1,0,t[a>>2]|0,0,t[33474]|0,0)|0;a=t[u>>2]|0;if(!(t[c>>2]|0)){t[f>>2]=a;l=t[f>>2]|0;s=r;return l|0}t[o>>2]=a;if(!(t[o>>2]|0)){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}while(1){if(!(t[t[o>>2]>>2]|0))break;t[o>>2]=t[t[o>>2]>>2]}t[t[o>>2]>>2]=t[c>>2];t[f>>2]=t[u>>2];l=t[f>>2]|0;s=r;return l|0}function hc(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if(!(t[33500]|0))tc();if((t[o>>2]|0)==0&(t[c>>2]|0)==0){t[u>>2]=0;k=t[u>>2]|0;s=n;return k|0}do if(t[33468]|0){if((t[o>>2]|0)!=0&(t[c>>2]|0)!=0){r=t[33976]|0;i=t[33980]|0;e=t[c>>2]|0;t[f>>2]=t[o>>2];t[f+4>>2]=e;yAi[r&511](i,134176,f);break}i=t[33976]|0;r=t[33980]|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];yAi[i&511](r,134216,f);break}else{t[f>>2]=t[c>>2];yAi[i&511](r,134248,f);break}}while(0);t[l>>2]=t[a>>2];if(!(t[l>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=n;return k|0}t[b>>2]=Sc(t[l>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;if((t[b>>2]|0)!=0&(t[b>>2]|0)!=(-1|0)){t[u>>2]=t[b>>2];k=t[u>>2]|0;s=n;return k|0}else{t[u>>2]=0;k=t[u>>2]|0;s=n;return k|0}return 0}function wc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;t[u>>2]=e;t[a>>2]=i;if(!(t[33500]|0))tc();if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}if(t[33468]|0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[a>>2];yAi[i&511](e,133984,n)}t[o>>2]=t[u>>2];if(!(t[o>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}t[c>>2]=Oc(t[o>>2]|0,t[a>>2]|0)|0;if((t[c>>2]|0)!=0&(t[c>>2]|0)!=(-1|0)){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}else{t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}return 0}function dc(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];vc(t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function vc(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;if(!(t[n>>2]|0)){s=i;return}if((t[(t[n>>2]|0)+32>>2]|0)==1){s=i;return}do if(t[33468]|0){if(t[(t[n>>2]|0)+16>>2]|0){e=t[33976]|0;f=t[33980]|0;t[r>>2]=t[(t[n>>2]|0)+16>>2];yAi[e&511](f,135680,r);break}f=t[33976]|0;e=t[33980]|0;if(t[(t[n>>2]|0)+20>>2]|0){t[r>>2]=t[(t[n>>2]|0)+20>>2];yAi[f&511](e,135680,r);break}else{yAi[f&511](e,135704,r);break}}while(0);if(t[(t[n>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+16>>2]|0);if(t[(t[n>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+20>>2]|0);if(t[(t[n>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+24>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0);s=i;return}function mc(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+112|0;r=i+100|0;f=i+96|0;u=i+92|0;a=i+88|0;o=i+84|0;c=i+8|0;l=i+4|0;t[f>>2]=e;if(!(t[f>>2]|0)){t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}if((ri(t[f>>2]|0,c|0)|0)<0){t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}e=Ue(t[f>>2]|0,0,i|0)|0;t[u>>2]=e;if((e|0)<0){t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}t[o>>2]=t[c+36>>2];t[l>>2]=gAi[t[135752>>2]&511]((t[o>>2]|0)+10|0)|0;if(!(t[l>>2]|0)){Nc(135656);Ge(t[u>>2]|0)|0;t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}t[a>>2]=ai(t[u>>2]|0,t[l>>2]|0,t[o>>2]|0)|0;Ge(t[u>>2]|0)|0;if((t[a>>2]|0)<0){pAi[t[135736>>2]&511](t[l>>2]|0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}else{n[(t[l>>2]|0)+(t[a>>2]|0)>>0]=0;t[r>>2]=t[l>>2];b=t[r>>2]|0;s=i;return b|0}return 0}function _c(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[a>>2]|0)){Nc(135632);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+64|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[t[a>>2]>>2]=t[f>>2];t[(t[a>>2]|0)+44>>2]=0;t[(t[a>>2]|0)+48>>2]=10;t[(t[a>>2]|0)+56>>2]=t[u>>2];if((t[t[a>>2]>>2]|0)==2){u=WF(10)|0;t[(t[a>>2]|0)+52>>2]=u}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function pc(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;f=s;s=s+64|0;a=f+60|0;o=f+56|0;c=f+52|0;l=f+48|0;b=f+44|0;k=f+40|0;h=f+36|0;w=f+32|0;d=f+28|0;v=f+24|0;m=f+20|0;_=f+16|0;p=f+12|0;E=f+8|0;S=f+4|0;g=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=t[c>>2];t[h>>2]=0;if((t[k>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=-1;y=t[a>>2]|0;s=f;return y|0}t[h>>2]=Yl(t[l>>2]|0)|0;e:while(1){if(!(t[k>>2]|0))break;while(1){if(!(u[t[k>>2]>>0]|0))break e;while(1){do if((u[t[k>>2]>>0]|0|0)==32)F=1;else{if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0){F=1;break}F=(u[t[k>>2]>>0]|0|0)==13}while(0);O=t[k>>2]|0;if(!F)break;t[k>>2]=O+1}if(!(u[O>>0]|0))break e;if((u[t[k>>2]>>0]|0|0)!=45)break;if((u[(t[k>>2]|0)+1>>0]|0|0)!=45)break;t[k>>2]=Tc(t[k>>2]|0)|0;if(!((t[k>>2]|0)!=0&(t[k>>2]|0)!=0))break e}t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;t[k>>2]=Lc(t[k>>2]|0,v)|0;if(!(t[v>>2]|0))break;do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)break e}while(0);i:while(1){do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)break i}while(0);t[k>>2]=(t[k>>2]|0)+1}do if(!(Xl(t[v>>2]|0,134936)|0)){if(Xl(t[v>>2]|0,134944)|0){t[m>>2]=14;break}if(Xl(t[v>>2]|0,134952)|0){t[m>>2]=20;break}if(Xl(t[v>>2]|0,134968)|0){t[m>>2]=15;break}if(Xl(t[v>>2]|0,134976)|0){t[m>>2]=17;break}if(Xl(t[v>>2]|0,134984)|0){t[m>>2]=18;break}if(Xl(t[v>>2]|0,135e3)|0){t[m>>2]=19;break}if(Xl(t[v>>2]|0,135016)|0){t[m>>2]=24;break}if(Xl(t[v>>2]|0,135032)|0){t[m>>2]=23;break}if(Xl(t[v>>2]|0,135048)|0){t[m>>2]=22;break}if(Xl(t[v>>2]|0,135056)|0){t[m>>2]=21;break}if(Xl(t[v>>2]|0,135592)|0){pAi[t[135736>>2]&511](t[v>>2]|0);t[k>>2]=Lc(t[k>>2]|0,v)|0;if(!(t[v>>2]|0))break e;pAi[t[135736>>2]&511](t[v>>2]|0);continue e}}else t[m>>2]=13;while(0);pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0;i:do switch(t[m>>2]|0){case 24:case 23:case 22:case 21:{t[k>>2]=Dc(t[k>>2]|0,d)|0;break}case 19:case 18:case 17:case 16:{A=54;break}case 20:case 13:case 14:{t[k>>2]=Dc(t[k>>2]|0,v)|0;if(t[k>>2]|0){do if((t[m>>2]|0)!=13?(t[_>>2]=Cc(t[v>>2]|0)|0,(t[_>>2]|0)!=0):0){if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if(u[t[_>>2]>>0]|0){t[v>>2]=t[_>>2];break}else{pAi[t[135736>>2]&511](t[_>>2]|0);t[v>>2]=0;break}}while(0);do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)break i}while(0);while(1){do if((u[t[k>>2]>>0]|0|0)==32)M=1;else{if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0){M=1;break}M=(u[t[k>>2]>>0]|0|0)==13}while(0);R=t[k>>2]|0;if(!M)break;t[k>>2]=R+1}t[k>>2]=Dc(R,d)|0}break}case 15:{if((u[t[k>>2]>>0]|0|0)==37){t[m>>2]=16;A=54}else A=54;break}default:{}}while(0);i:do if((A|0)==54?(A=0,t[k>>2]=Lc(t[k>>2]|0,v)|0,(t[k>>2]|0)!=0):0){do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)break i}while(0);while(1){do if((u[t[k>>2]>>0]|0|0)==32)N=1;else{if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0){N=1;break}N=(u[t[k>>2]>>0]|0|0)==13}while(0);T=t[k>>2]|0;if(!N)break;t[k>>2]=T+1}t[k>>2]=Dc(T,d)|0}while(0);if(!(t[k>>2]|0)){A=87;break}do if((t[m>>2]|0)!=21){if((t[m>>2]|0)==14|(t[m>>2]|0)==13){t[p>>2]=GA(t[d>>2]|0,t[h>>2]|0)|0;if(!(t[p>>2]|0))break;t[E>>2]=Ec(t[m>>2]|0,t[v>>2]|0,t[p>>2]|0,0,0,0)|0;t[w>>2]=ZF(t[(t[o>>2]|0)+52>>2]|0,t[v>>2]|0,t[E>>2]|0)|0;if((t[w>>2]|0)<0)vc(t[E>>2]|0);pAi[t[135736>>2]&511](t[p>>2]|0);break}if((t[m>>2]|0)==22)if(t[b>>2]|0){t[S>>2]=Ec(t[m>>2]|0,t[d>>2]|0,0,0,0,0)|0;t[w>>2]=ZF(t[(t[o>>2]|0)+52>>2]|0,t[d>>2]|0,t[S>>2]|0)|0;if((t[w>>2]|0)>=0)break;vc(t[S>>2]|0);break}else{t[g>>2]=GA(t[d>>2]|0,t[h>>2]|0)|0;if(!(t[g>>2]|0))break;Mc(t[o>>2]|0,t[g>>2]|0)|0;pAi[t[135736>>2]&511](t[g>>2]|0);break}}else{if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=Yl(t[d>>2]|0)|0}while(0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if(!(t[d>>2]|0))continue;pAi[t[135736>>2]&511](t[d>>2]|0)}if((A|0)==87){if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0)}if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);if(!(t[k>>2]|0)){t[a>>2]=-1;y=t[a>>2]|0;s=f;return y|0}else{t[a>>2]=0;y=t[a>>2]|0;s=f;return y|0}return 0}function Ec(e,i,r,n,f,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+24|0;k=o+20|0;h=o+16|0;w=o+12|0;d=o+8|0;v=o+4|0;m=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=a;t[m>>2]=0;t[v>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[v>>2]|0)){Nc(135528);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}t[t[v>>2]>>2]=0;t[(t[v>>2]|0)+4>>2]=0;t[(t[v>>2]|0)+8>>2]=0;t[(t[v>>2]|0)+12>>2]=t[l>>2];if((t[l>>2]|0)==5|(t[l>>2]|0)==8?(t[m>>2]=Cc(t[b>>2]|0)|0,(t[m>>2]|0)!=0):0)t[b>>2]=(u[t[m>>2]>>0]|0|0)!=0?t[m>>2]|0:0;if(t[b>>2]|0){l=Yl(t[b>>2]|0)|0;t[(t[v>>2]|0)+16>>2]=l}else t[(t[v>>2]|0)+16>>2]=0;if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if(t[k>>2]|0){m=Yl(t[k>>2]|0)|0;t[(t[v>>2]|0)+20>>2]=m}else t[(t[v>>2]|0)+20>>2]=0;if(!(t[h>>2]|0))t[h>>2]=t[k>>2];if(t[h>>2]|0){k=Yl(t[h>>2]|0)|0;t[(t[v>>2]|0)+24>>2]=k}else t[(t[v>>2]|0)+24>>2]=0;t[(t[v>>2]|0)+28>>2]=t[w>>2];t[(t[v>>2]|0)+32>>2]=0;t[(t[v>>2]|0)+36>>2]=0;t[(t[v>>2]|0)+40>>2]=t[d>>2];t[c>>2]=t[v>>2];_=t[c>>2]|0;s=o;return _|0}function Sc(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+32|0;f=n;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=0;t[k>>2]=0;if(!(t[o>>2]|0)){t[a>>2]=0;w=t[a>>2]|0;s=n;return w|0}if((t[c>>2]|0)==0&(t[l>>2]|0)==0){t[a>>2]=0;w=t[a>>2]|0;s=n;return w|0}t[h>>2]=Cc(t[c>>2]|0)|0;if(t[h>>2]|0)t[c>>2]=(u[t[h>>2]>>0]|0|0)!=0?t[h>>2]|0:0;if(!(Jl(t[c>>2]|0,135064,13)|0)){t[k>>2]=Pc(t[c>>2]|0)|0;do if(t[33468]|0){r=t[33976]|0;i=t[33980]|0;if(!(t[k>>2]|0)){t[f>>2]=t[c>>2];yAi[r&511](i,135256,f);break}else{t[f>>2]=t[k>>2];yAi[r&511](i,135296,f);break}}while(0);t[b>>2]=Sc(t[o>>2]|0,t[k>>2]|0,t[l>>2]|0)|0;if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[a>>2]=t[b>>2];w=t[a>>2]|0;s=n;return w|0}if(Jl(t[l>>2]|0,135064,13)|0){while(1){if(!(t[o>>2]|0))break;if((t[(t[o>>2]|0)+12>>2]|0)==1){if(!(t[(t[o>>2]|0)+8>>2]|0))Bc(t[o>>2]|0)|0;if(t[(t[o>>2]|0)+8>>2]|0){t[b>>2]=Ic(t[(t[o>>2]|0)+8>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;if(t[b>>2]|0)break;if((t[(t[o>>2]|0)+8>>2]|0)!=0?(t[(t[(t[o>>2]|0)+8>>2]|0)+36>>2]|0)>50:0){d=40;break}}}t[o>>2]=t[t[o>>2]>>2]}if((d|0)==40)t[b>>2]=0;if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[a>>2]=t[b>>2];w=t[a>>2]|0;s=n;return w|0}t[k>>2]=Pc(t[l>>2]|0)|0;do if(t[33468]|0){d=t[33976]|0;i=t[33980]|0;if(!(t[k>>2]|0)){t[f>>2]=t[l>>2];yAi[d&511](i,135328,f);break}else{t[f>>2]=t[k>>2];yAi[d&511](i,135368,f);break}}while(0);do if(t[c>>2]|0){f=(Xl(t[c>>2]|0,t[k>>2]|0)|0)!=0;l=t[o>>2]|0;i=t[c>>2]|0;if(f){t[b>>2]=Sc(l,i,0)|0;break}else{t[b>>2]=Sc(l,i,t[k>>2]|0)|0;break}}else t[b>>2]=Sc(t[o>>2]|0,t[k>>2]|0,0)|0;while(0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[a>>2]=t[b>>2];w=t[a>>2]|0;s=n;return w|0}function gc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){t[a>>2]=rO(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;break}if((t[(t[a>>2]|0)+12>>2]|0)==13){t[n>>2]=t[(t[a>>2]|0)+24>>2];break}else{t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function yc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[c>>2]=Cc(t[a>>2]|0)|0;if(t[c>>2]|0)t[a>>2]=(u[t[c>>2]>>0]|0|0)!=0?t[c>>2]|0:0;t[o>>2]=rO(t[f>>2]|0,t[a>>2]|0)|0;if(!(t[o>>2]|0)){if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}a=(t[c>>2]|0)!=0;if((t[(t[o>>2]|0)+12>>2]|0)==14){if(a)pAi[t[135736>>2]&511](t[c>>2]|0);t[n>>2]=t[(t[o>>2]|0)+24>>2];l=t[n>>2]|0;s=r;return l|0}else{if(a)pAi[t[135736>>2]&511](t[c>>2]|0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}return 0}function Fc(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if(!(t[(t[u>>2]|0)+52>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if(t[a>>2]|0)t[c>>2]=yc(t[(t[u>>2]|0)+52>>2]|0,t[a>>2]|0)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}if(t[o>>2]|0)t[c>>2]=gc(t[(t[u>>2]|0)+52>>2]|0,t[o>>2]|0)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}return 0}function Oc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;t[c>>2]=0;if(!(t[u>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}if(!(Jl(t[a>>2]|0,135064,13)|0)){t[c>>2]=Pc(t[a>>2]|0)|0;do if(t[33468]|0){i=t[33976]|0;e=t[33980]|0;if(!(t[c>>2]|0)){t[n>>2]=t[a>>2];yAi[i&511](e,135080,n);break}else{t[n>>2]=t[c>>2];yAi[i&511](e,135112,n);break}}while(0);t[o>>2]=Sc(t[u>>2]|0,t[c>>2]|0,0)|0;if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=t[o>>2];l=t[f>>2]|0;s=r;return l|0}while(1){if(!(t[u>>2]|0)){b=21;break}if((t[(t[u>>2]|0)+12>>2]|0)==1){if(!(t[(t[u>>2]|0)+8>>2]|0))Bc(t[u>>2]|0)|0;if((t[(t[u>>2]|0)+8>>2]|0)!=0?(t[o>>2]=Hc(t[(t[u>>2]|0)+8>>2]|0,t[a>>2]|0)|0,(t[o>>2]|0)!=0):0){b=19;break}}t[u>>2]=t[t[u>>2]>>2]}if((b|0)==19){t[f>>2]=t[o>>2];l=t[f>>2]|0;s=r;return l|0}else if((b|0)==21){t[f>>2]=t[o>>2];l=t[f>>2]|0;s=r;return l|0}return 0}function Ac(){var e=0;e=s;if(t[33500]|0){s=e;return}if(ti(134016)|0)t[33468]=1;t[33502]=Qc()|0;t[33500]=1;s=e;return}function Mc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}i=t[u>>2]|0;do if((t[t[f>>2]>>2]|0)==2){t[o>>2]=mc(i)|0;if(!(t[o>>2]|0)){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[a>>2]=pc(t[f>>2]|0,t[o>>2]|0,t[u>>2]|0,0)|0;e=(t[a>>2]|0)<0;pAi[t[135736>>2]&511](t[o>>2]|0);if(e){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}}else{t[c>>2]=Ec(1,0,0,i,t[33474]|0,0)|0;t[l>>2]=t[(t[f>>2]|0)+60>>2];if(!(t[l>>2]|0)){t[(t[f>>2]|0)+60>>2]=t[c>>2];break}while(1){if(!(t[t[l>>2]>>2]|0))break;t[l>>2]=t[t[l>>2]>>2]}t[t[l>>2]>>2]=t[c>>2]}while(0);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}function Rc(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[n>>2]=t[(t[r>>2]|0)+8>>2];while(1){if(!(t[n>>2]|0))break;t[f>>2]=t[t[n>>2]>>2];t[(t[n>>2]|0)+32>>2]=0;t[(t[n>>2]|0)+8>>2]=0;vc(t[n>>2]|0);t[n>>2]=t[f>>2]}t[(t[r>>2]|0)+32>>2]=0;vc(t[r>>2]|0);s=i;return}function Nc(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;e=t[n>>2]|0;t[r>>2]=t[n>>2];cp(0,0,0,0,0,20,2,2,0,0,e,0,0,0,0,135560,r);s=i;return}function Tc(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((u[t[n>>2]>>0]|0|0)==45?(u[(t[n>>2]|0)+1>>0]|0|0)==45:0){t[n>>2]=(t[n>>2]|0)+2;while(1){if(u[t[n>>2]>>0]|0)if((u[t[n>>2]>>0]|0|0)!=45)f=1;else f=(u[(t[n>>2]|0)+1>>0]|0|0)!=45;else f=0;a=t[n>>2]|0;if(!f)break;t[n>>2]=a+1}if(!(u[a>>0]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}else{t[r>>2]=(t[n>>2]|0)+2;o=t[r>>2]|0;s=i;return o|0}}t[r>>2]=t[n>>2];o=t[r>>2]|0;s=i;return o|0}function Lc(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+128|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+20|0;l=r+4|0;b=r;t[a>>2]=e;t[o>>2]=i;t[l>>2]=0;t[t[o>>2]>>2]=0;t[b>>2]=u[t[a>>2]>>0];i=t[b>>2]|0;if((t[b>>2]|0)<256){if(((!(65<=(i|0)&(t[b>>2]|0)<=90)?!(97<=(t[b>>2]|0)&(t[b>>2]|0)<=122):0)?!(192<=(t[b>>2]|0)&(t[b>>2]|0)<=214):0)?!(216<=(t[b>>2]|0)&(t[b>>2]|0)<=246|248<=(t[b>>2]|0)):0)k=7}else if(!(dj(i,199744)|0))k=7;do if((k|0)==7){i=t[b>>2]|0;if((t[b>>2]|0)<256){if(!((i|0)!=95&(t[b>>2]|0)!=58))break}else{if(19968<=(i|0)&(t[b>>2]|0)<=40869|(t[b>>2]|0)==12295)break;if(!((12321<=(t[b>>2]|0)&(t[b>>2]|0)<=12329^1)&(t[b>>2]|0)!=95&(t[b>>2]|0)!=58))break}t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}while(0);e:while(1){i=t[b>>2]|0;if((t[b>>2]|0)<256){if(((!(65<=(i|0)&(t[b>>2]|0)<=90)?!(97<=(t[b>>2]|0)&(t[b>>2]|0)<=122):0)?!(192<=(t[b>>2]|0)&(t[b>>2]|0)<=214):0)?!(216<=(t[b>>2]|0)&(t[b>>2]|0)<=246|248<=(t[b>>2]|0)):0)k=18}else if(!(dj(i,199744)|0))k=18;do if((k|0)==18){k=0;if((t[b>>2]|0)>=256){if(19968<=(t[b>>2]|0)&(t[b>>2]|0)<=40869|(t[b>>2]|0)==12295)break;if(12321<=(t[b>>2]|0)&(t[b>>2]|0)<=12329)break}i=t[b>>2]|0;if((t[b>>2]|0)<256)if(48<=(i|0)&(t[b>>2]|0)<=57|(t[b>>2]|0)==46|(t[b>>2]|0)==45|(t[b>>2]|0)==95|(t[b>>2]|0)==58)break;else{k=26;break e}else{e=(dj(i,200216)|0)!=0;if(e|(t[b>>2]|0)==46|(t[b>>2]|0)==45|(t[b>>2]|0)==95|(t[b>>2]|0)==58)break;else{k=26;break e}}}while(0);e=t[b>>2]&255;i=t[l>>2]|0;t[l>>2]=i+1;n[c+i>>0]=e;t[a>>2]=(t[a>>2]|0)+1;t[b>>2]=u[t[a>>2]>>0];if((t[l>>2]|0)>=100){k=25;break}}if((k|0)==25){t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}else if((k|0)==26){k=ql(c,t[l>>2]|0)|0;t[t[o>>2]>>2]=k;t[f>>2]=t[a>>2];h=t[f>>2]|0;s=r;return h|0}return 0}function Dc(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;f=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r+32|0;w=r;t[a>>2]=e;t[o>>2]=i;t[c>>2]=0;t[b>>2]=0;t[k>>2]=50;t[w>>2]=0;t[t[o>>2]>>2]=0;i=t[a>>2]|0;do if((u[t[a>>2]>>0]|0|0)!=34)if((u[i>>0]|0|0)==39){t[a>>2]=(t[a>>2]|0)+1;n[h>>0]=39;break}else{n[h>>0]=32;break}else{t[a>>2]=i+1;n[h>>0]=34}while(0);t[c>>2]=gAi[t[135752>>2]&511](t[k>>2]|0)|0;if(!(t[c>>2]|0)){Nc(135608);t[f>>2]=0;d=t[f>>2]|0;s=r;return d|0}while(1){if((u[198696+(u[t[a>>2]>>0]|0)>>0]|0|0)==0?(u[t[a>>2]>>0]|0|0)!=63:0)break;if((u[t[a>>2]>>0]|0|0)==(u[h>>0]|0|0)?(u[h>>0]|0|0)!=32:0)break;if((u[h>>0]|0|0)==32){if((u[t[a>>2]>>0]|0|0)==32)break;if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)==13)break}if(((t[b>>2]|0)+1|0)>=(t[k>>2]|0)){t[k>>2]=t[k>>2]<<1;t[l>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[k>>2]|0)|0;if(!(t[l>>2]|0)){v=19;break}t[c>>2]=t[l>>2]}i=n[t[a>>2]>>0]|0;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[c>>2]|0)+e>>0]=i;t[w>>2]=(t[w>>2]|0)+1;t[a>>2]=(t[a>>2]|0)+1}if((v|0)==19){Nc(135608);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=r;return d|0}n[(t[c>>2]|0)+(t[b>>2]|0)>>0]=0;b=u[t[a>>2]>>0]|0;do if((u[h>>0]|0|0)==32){if((b|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)!=13){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=r;return d|0}}}else{if((b|0)==(u[h>>0]|0|0)){t[a>>2]=(t[a>>2]|0)+1;break}pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=r;return d|0}while(0);t[t[o>>2]>>2]=t[c>>2];t[f>>2]=t[a>>2];d=t[f>>2]|0;s=r;return d|0}function Cc(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+24|0;f=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[f>>2]=e;t[a>>2]=1;if(!(t[f>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[o>>2]=1;t[c>>2]=t[f>>2];while(1){if(!((t[a>>2]|0)!=0?(u[t[c>>2]>>0]|0|0)!=0:0))break;do if((u[t[c>>2]>>0]|0|0)!=32){if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){h=10;break}if((u[t[c>>2]>>0]|0|0)!=13)t[o>>2]=0;else h=10}else h=10;while(0);do if((h|0)==10){h=0;if((t[o>>2]|0)!=0?1:(u[t[c>>2]>>0]|0|0)!=32){t[a>>2]=0;break}else{t[o>>2]=1;break}}while(0);t[c>>2]=(t[c>>2]|0)+1}if(!((t[a>>2]|0)==0|(t[o>>2]|0)!=0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[l>>2]=Yl(t[f>>2]|0)|0;t[b>>2]=t[l>>2];t[o>>2]=0;t[c>>2]=t[f>>2];while(1){if(!(u[t[c>>2]>>0]|0))break;do if((u[t[c>>2]>>0]|0|0)!=32){if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){h=22;break}if((u[t[c>>2]>>0]|0|0)!=13){if(t[o>>2]|0){f=t[b>>2]|0;t[b>>2]=f+1;n[f>>0]=32;t[o>>2]=0}f=n[t[c>>2]>>0]|0;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=f}else h=22}else h=22;while(0);if((h|0)==22?(h=0,(t[b>>2]|0)!=(t[l>>2]|0)):0)t[o>>2]=1;t[c>>2]=(t[c>>2]|0)+1}n[t[b>>2]>>0]=0;t[r>>2]=t[l>>2];k=t[r>>2]|0;s=i;return k|0}function Pc(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+2016|0;r=i+8|0;f=i+4|0;a=i+16|0;o=i;t[f>>2]=e;t[o>>2]=0;if(Jl(t[f>>2]|0,135064,13)|0){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[f>>2]=(t[f>>2]|0)+13;e:while(1){if((t[o>>2]|0)>>>0>1996?1:(u[t[f>>2]>>0]|0|0)==0)break;if((u[t[f>>2]>>0]|0|0)==43){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=32;t[f>>2]=(t[f>>2]|0)+1;continue}if((u[t[f>>2]>>0]|0|0)==58){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=47;e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=47;t[f>>2]=(t[f>>2]|0)+1;continue}if((u[t[f>>2]>>0]|0|0)==59){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=58;e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=58;t[f>>2]=(t[f>>2]|0)+1;continue}e=t[f>>2]|0;if((u[t[f>>2]>>0]|0|0)!=37){l=n[e>>0]|0;b=t[o>>2]|0;t[o>>2]=b+1;n[a+b>>0]=l;t[f>>2]=(t[f>>2]|0)+1;continue}if((u[e+1>>0]|0|0)==50?(u[(t[f>>2]|0)+2>>0]|0|0)==66:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=43}else k=15;do if((k|0)==15){k=0;if((u[(t[f>>2]|0)+1>>0]|0|0)==51?(u[(t[f>>2]|0)+2>>0]|0|0)==65:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=58;break}if((u[(t[f>>2]|0)+1>>0]|0|0)==50?(u[(t[f>>2]|0)+2>>0]|0|0)==70:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=47;break}if((u[(t[f>>2]|0)+1>>0]|0|0)==51?(u[(t[f>>2]|0)+2>>0]|0|0)==66:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=59;break}if((u[(t[f>>2]|0)+1>>0]|0|0)==50?(u[(t[f>>2]|0)+2>>0]|0|0)==55:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=39;break}if((u[(t[f>>2]|0)+1>>0]|0|0)==51?(u[(t[f>>2]|0)+2>>0]|0|0)==70:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=63;break}if((u[(t[f>>2]|0)+1>>0]|0|0)==50?(u[(t[f>>2]|0)+2>>0]|0|0)==51:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=35;break}if((u[(t[f>>2]|0)+1>>0]|0|0)==50?(u[(t[f>>2]|0)+2>>0]|0|0)==53:0){e=t[o>>2]|0;t[o>>2]=e+1;n[a+e>>0]=37;break}e=n[t[f>>2]>>0]|0;l=t[o>>2]|0;t[o>>2]=l+1;n[a+l>>0]=e;t[f>>2]=(t[f>>2]|0)+1;continue e}while(0);t[f>>2]=(t[f>>2]|0)+3}n[a+(t[o>>2]|0)>>0]=0;t[r>>2]=Yl(a)|0;c=t[r>>2]|0;s=i;return c|0}function Bc(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i;n=i+12|0;f=i+8|0;u=i+4|0;t[f>>2]=e;if(!(t[f>>2]|0)){t[n>>2]=-1;a=t[n>>2]|0;s=i;return a|0}if(!(t[(t[f>>2]|0)+24>>2]|0)){t[n>>2]=-1;a=t[n>>2]|0;s=i;return a|0}el(t[33502]|0);if(t[(t[f>>2]|0)+8>>2]|0){il(t[33502]|0);t[n>>2]=0;a=t[n>>2]|0;s=i;return a|0}do if(t[33530]|0){t[u>>2]=rO(t[33530]|0,t[(t[f>>2]|0)+24>>2]|0)|0;e=(t[33468]|0)!=0;if(!(t[u>>2]|0)){if(!e)break;o=t[33976]|0;c=t[33980]|0;t[r>>2]=t[(t[f>>2]|0)+24>>2];yAi[o&511](c,134304,r);break}if(e){e=t[33976]|0;c=t[33980]|0;t[r>>2]=t[(t[f>>2]|0)+24>>2];yAi[e&511](c,134280,r)}c=t[u>>2]|0;if((t[(t[f>>2]|0)+12>>2]|0)==1)t[(t[f>>2]|0)+8>>2]=t[c+8>>2];else t[(t[f>>2]|0)+8>>2]=c;t[(t[f>>2]|0)+32>>2]=0;il(t[33502]|0);t[n>>2]=0;a=t[n>>2]|0;s=i;return a|0}while(0);t[u>>2]=xc(t[(t[f>>2]|0)+28>>2]|0,t[(t[f>>2]|0)+24>>2]|0)|0;c=(t[f>>2]|0)+12|0;if(!(t[u>>2]|0)){t[c>>2]=2;il(t[33502]|0);t[n>>2]=-1;a=t[n>>2]|0;s=i;return a|0}e=t[u>>2]|0;if((t[c>>2]|0)==1)t[(t[f>>2]|0)+8>>2]=t[e+8>>2];else t[(t[f>>2]|0)+8>>2]=e;
	t[(t[u>>2]|0)+32>>2]=1;if(!(t[33530]|0))t[33530]=WF(10)|0;if(t[33530]|0){if(t[33468]|0){e=t[33976]|0;c=t[33980]|0;t[r>>2]=t[(t[f>>2]|0)+24>>2];yAi[e&511](c,134336,r)}ZF(t[33530]|0,t[(t[f>>2]|0)+24>>2]|0,t[u>>2]|0)|0}il(t[33502]|0);t[n>>2]=0;a=t[n>>2]|0;s=i;return a|0}function Ic(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;n=s;s=s+480|0;f=n;u=n+464|0;a=n+460|0;o=n+456|0;c=n+452|0;l=n+448|0;b=n+444|0;k=n+440|0;h=n+436|0;w=n+432|0;d=n+428|0;v=n+424|0;m=n+224|0;_=n+220|0;p=n+216|0;E=n+16|0;S=n+12|0;g=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;t[k>>2]=0;t[h>>2]=0;r=t[a>>2]|0;if((t[(t[a>>2]|0)+36>>2]|0)>50){Uc(r,0,1654,135136,t[(t[a>>2]|0)+16>>2]|0,0,0);t[u>>2]=0;y=t[u>>2]|0;s=n;return y|0}i=r+36|0;t[i>>2]=(t[i>>2]|0)+1;if(t[c>>2]|0){t[w>>2]=0;t[d>>2]=0;t[b>>2]=t[a>>2];t[k>>2]=0;while(1){if(!(t[b>>2]|0))break;i=t[(t[b>>2]|0)+12>>2]|0;if((i|0)==7){t[v>>2]=rs(t[(t[b>>2]|0)+16>>2]|0)|0;if((t[v>>2]|0)>(t[d>>2]|0)?(Jl(t[c>>2]|0,t[(t[b>>2]|0)+16>>2]|0,t[v>>2]|0)|0)==0:0){t[d>>2]=t[v>>2];t[w>>2]=t[b>>2]}}else if((i|0)==3)t[h>>2]=(t[h>>2]|0)+1;else if((i|0)==6){if(Xl(t[c>>2]|0,t[(t[b>>2]|0)+16>>2]|0)|0){F=8;break}}else if((i|0)==9?(i=t[c>>2]|0,r=t[(t[b>>2]|0)+16>>2]|0,(Jl(i,r,rs(t[(t[b>>2]|0)+16>>2]|0)|0)|0)==0):0)t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[t[b>>2]>>2]}if((F|0)==8){if(t[33468]|0){v=t[33976]|0;r=t[33980]|0;i=t[(t[b>>2]|0)+24>>2]|0;t[f>>2]=t[(t[b>>2]|0)+16>>2];t[f+4>>2]=i;yAi[v&511](r,135400,f)}r=(t[a>>2]|0)+36|0;t[r>>2]=(t[r>>2]|0)+-1;t[u>>2]=Yl(t[(t[b>>2]|0)+24>>2]|0)|0;y=t[u>>2]|0;s=n;return y|0}if(t[w>>2]|0){if(t[33468]|0){r=t[33976]|0;v=t[33980]|0;t[f>>2]=t[(t[w>>2]|0)+16>>2];yAi[r&511](v,135200,f)}t[l>>2]=Yl(t[(t[w>>2]|0)+24>>2]|0)|0;if(t[l>>2]|0)t[l>>2]=us(t[l>>2]|0,(t[c>>2]|0)+(t[d>>2]|0)|0)|0;d=(t[a>>2]|0)+36|0;t[d>>2]=(t[d>>2]|0)+-1;t[u>>2]=t[l>>2];y=t[u>>2]|0;s=n;return y|0}if(t[k>>2]|0){t[_>>2]=0;t[b>>2]=t[a>>2];while(1){if(!(t[b>>2]|0)){F=45;break}if((t[(t[b>>2]|0)+12>>2]|0)==9?(d=t[c>>2]|0,w=t[(t[b>>2]|0)+16>>2]|0,(Jl(d,w,rs(t[(t[b>>2]|0)+16>>2]|0)|0)|0)==0):0){t[p>>2]=0;while(1){if((t[p>>2]|0)>=(t[_>>2]|0))break;if(Xl(t[(t[b>>2]|0)+24>>2]|0,t[m+(t[p>>2]<<2)>>2]|0)|0)break;t[p>>2]=(t[p>>2]|0)+1}if((t[p>>2]|0)<(t[_>>2]|0)){t[b>>2]=t[t[b>>2]>>2];continue}if((t[_>>2]|0)<50){w=t[(t[b>>2]|0)+24>>2]|0;d=t[_>>2]|0;t[_>>2]=d+1;t[m+(d<<2)>>2]=w}if(!(t[(t[b>>2]|0)+8>>2]|0))Bc(t[b>>2]|0)|0;if(t[(t[b>>2]|0)+8>>2]|0){if(t[33468]|0){w=t[33976]|0;d=t[33980]|0;t[f>>2]=t[(t[b>>2]|0)+24>>2];yAi[w&511](d,135440,f)}t[l>>2]=Sc(t[(t[b>>2]|0)+8>>2]|0,0,t[c>>2]|0)|0;if(t[l>>2]|0){F=43;break}}}t[b>>2]=t[t[b>>2]>>2]}if((F|0)==43){m=(t[a>>2]|0)+36|0;t[m>>2]=(t[m>>2]|0)+-1;t[u>>2]=t[l>>2];y=t[u>>2]|0;s=n;return y|0}else if((F|0)==45){m=(t[a>>2]|0)+36|0;t[m>>2]=(t[m>>2]|0)+-1;t[u>>2]=-1;y=t[u>>2]|0;s=n;return y|0}}}if(t[o>>2]|0){t[b>>2]=t[a>>2];t[k>>2]=0;while(1){if(!(t[b>>2]|0))break;m=t[(t[b>>2]|0)+12>>2]|0;if((m|0)==8){_=t[o>>2]|0;p=t[(t[b>>2]|0)+16>>2]|0;if((Jl(_,p,rs(t[(t[b>>2]|0)+16>>2]|0)|0)|0)==0?(t[(t[b>>2]|0)+28>>2]|0)==1:0)t[k>>2]=(t[k>>2]|0)+1}else if((m|0)==3){if(!(t[c>>2]|0))t[h>>2]=(t[h>>2]|0)+1}else if((m|0)==5?(Xl(t[o>>2]|0,t[(t[b>>2]|0)+16>>2]|0)|0)!=0:0){F=51;break}t[b>>2]=t[t[b>>2]>>2]}if((F|0)==51){if(t[33468]|0){m=t[33976]|0;p=t[33980]|0;t[f>>2]=t[(t[b>>2]|0)+16>>2];yAi[m&511](p,135472,f)}p=(t[a>>2]|0)+36|0;t[p>>2]=(t[p>>2]|0)+-1;t[u>>2]=Yl(t[(t[b>>2]|0)+24>>2]|0)|0;y=t[u>>2]|0;s=n;return y|0}if(t[k>>2]|0){t[S>>2]=0;t[b>>2]=t[a>>2];while(1){if(!(t[b>>2]|0)){F=82;break}if(((t[(t[b>>2]|0)+12>>2]|0)==8?(t[(t[b>>2]|0)+28>>2]|0)==1:0)?(k=t[o>>2]|0,p=t[(t[b>>2]|0)+16>>2]|0,(Jl(k,p,rs(t[(t[b>>2]|0)+16>>2]|0)|0)|0)==0):0){t[g>>2]=0;while(1){if((t[g>>2]|0)>=(t[S>>2]|0))break;if(Xl(t[(t[b>>2]|0)+24>>2]|0,t[E+(t[g>>2]<<2)>>2]|0)|0)break;t[g>>2]=(t[g>>2]|0)+1}if((t[g>>2]|0)<(t[S>>2]|0)){t[b>>2]=t[t[b>>2]>>2];continue}if((t[S>>2]|0)<50){p=t[(t[b>>2]|0)+24>>2]|0;k=t[S>>2]|0;t[S>>2]=k+1;t[E+(k<<2)>>2]=p}if(!(t[(t[b>>2]|0)+8>>2]|0))Bc(t[b>>2]|0)|0;if(t[(t[b>>2]|0)+8>>2]|0){if(t[33468]|0){p=t[33976]|0;k=t[33980]|0;t[f>>2]=t[(t[b>>2]|0)+24>>2];yAi[p&511](k,135496,f)}t[l>>2]=Sc(t[(t[b>>2]|0)+8>>2]|0,t[o>>2]|0,0)|0;if(t[l>>2]|0){F=80;break}}}t[b>>2]=t[t[b>>2]>>2]}if((F|0)==80){f=(t[a>>2]|0)+36|0;t[f>>2]=(t[f>>2]|0)+-1;t[u>>2]=t[l>>2];y=t[u>>2]|0;s=n;return y|0}else if((F|0)==82){f=(t[a>>2]|0)+36|0;t[f>>2]=(t[f>>2]|0)+-1;t[u>>2]=-1;y=t[u>>2]|0;s=n;return y|0}}}e:do if(t[h>>2]|0){t[b>>2]=t[a>>2];while(1){if(!(t[b>>2]|0))break e;if((t[(t[b>>2]|0)+12>>2]|0)==3){if(!(t[(t[b>>2]|0)+8>>2]|0))Bc(t[b>>2]|0)|0;if(t[(t[b>>2]|0)+8>>2]|0){t[l>>2]=Sc(t[(t[b>>2]|0)+8>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;O=(t[a>>2]|0)+36|0;A=t[O>>2]|0;if(t[l>>2]|0){F=91;break}if((A|0)>50){F=93;break}}}t[b>>2]=t[t[b>>2]>>2]}if((F|0)==91){t[O>>2]=A+-1;t[u>>2]=t[l>>2];y=t[u>>2]|0;s=n;return y|0}else if((F|0)==93){t[u>>2]=0;y=t[u>>2]|0;s=n;return y|0}}while(0);F=(t[a>>2]|0)+36|0;t[F>>2]=(t[F>>2]|0)+-1;t[u>>2]=0;y=t[u>>2]|0;s=n;return y|0}function Hc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;r=s;s=s+256|0;n=r;f=r+252|0;u=r+248|0;a=r+244|0;o=r+240|0;c=r+236|0;l=r+232|0;b=r+228|0;k=r+224|0;h=r+220|0;w=r+216|0;d=r+16|0;v=r+8|0;m=r+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;if(!(t[u>>2]|0)){t[f>>2]=0;_=t[f>>2]|0;s=r;return _|0}if(!(t[a>>2]|0)){t[f>>2]=0;_=t[f>>2]|0;s=r;return _|0}i=t[u>>2]|0;if((t[(t[u>>2]|0)+36>>2]|0)>50){Uc(i,0,1654,135136,t[(t[u>>2]|0)+16>>2]|0,0,0);t[f>>2]=0;_=t[f>>2]|0;s=r;return _|0}t[c>>2]=i;t[l>>2]=0;while(1){if(!(t[c>>2]|0))break;i=t[(t[c>>2]|0)+12>>2]|0;if((i|0)==10){if(Xl(t[a>>2]|0,t[(t[c>>2]|0)+16>>2]|0)|0){p=11;break}}else if((i|0)==12){e=t[a>>2]|0;E=t[(t[c>>2]|0)+16>>2]|0;if(!(Jl(e,E,rs(t[(t[c>>2]|0)+16>>2]|0)|0)|0))t[l>>2]=(t[l>>2]|0)+1}else if((i|0)==11){t[w>>2]=rs(t[(t[c>>2]|0)+16>>2]|0)|0;if((t[w>>2]|0)>(t[h>>2]|0)?(Jl(t[a>>2]|0,t[(t[c>>2]|0)+16>>2]|0,t[w>>2]|0)|0)==0:0){t[h>>2]=t[w>>2];t[k>>2]=t[c>>2]}}else if((i|0)==3)t[b>>2]=(t[b>>2]|0)+1;t[c>>2]=t[t[c>>2]>>2]}if((p|0)==11){if(t[33468]|0){w=t[33976]|0;i=t[33980]|0;t[n>>2]=t[(t[c>>2]|0)+16>>2];yAi[w&511](i,135176,n)}t[f>>2]=Yl(t[(t[c>>2]|0)+24>>2]|0)|0;_=t[f>>2]|0;s=r;return _|0}if(t[k>>2]|0){if(t[33468]|0){i=t[33976]|0;w=t[33980]|0;t[n>>2]=t[(t[k>>2]|0)+16>>2];yAi[i&511](w,135200,n)}t[o>>2]=Yl(t[(t[k>>2]|0)+24>>2]|0)|0;if(t[o>>2]|0)t[o>>2]=us(t[o>>2]|0,(t[a>>2]|0)+(t[h>>2]|0)|0)|0;t[f>>2]=t[o>>2];_=t[f>>2]|0;s=r;return _|0}if(!(t[l>>2]|0)){e:do if(t[b>>2]|0){t[c>>2]=t[u>>2];while(1){if(!(t[c>>2]|0))break e;if((t[(t[c>>2]|0)+12>>2]|0)==3){if(!(t[(t[c>>2]|0)+8>>2]|0))Bc(t[c>>2]|0)|0;if((t[(t[c>>2]|0)+8>>2]|0)!=0?(t[o>>2]=Oc(t[(t[c>>2]|0)+8>>2]|0,t[a>>2]|0)|0,(t[o>>2]|0)!=0):0)break}t[c>>2]=t[t[c>>2]>>2]}t[f>>2]=t[o>>2];_=t[f>>2]|0;s=r;return _|0}while(0);t[f>>2]=0;_=t[f>>2]|0;s=r;return _|0}t[v>>2]=0;t[c>>2]=t[u>>2];while(1){if(!(t[c>>2]|0)){p=49;break}if(!((t[(t[c>>2]|0)+12>>2]|0)!=9?(t[(t[c>>2]|0)+12>>2]|0)!=12:0))p=32;if((p|0)==32?(p=0,u=t[a>>2]|0,b=t[(t[c>>2]|0)+16>>2]|0,(Jl(u,b,rs(t[(t[c>>2]|0)+16>>2]|0)|0)|0)==0):0){t[m>>2]=0;while(1){if((t[m>>2]|0)>=(t[v>>2]|0))break;if(Xl(t[(t[c>>2]|0)+24>>2]|0,t[d+(t[m>>2]<<2)>>2]|0)|0)break;t[m>>2]=(t[m>>2]|0)+1}if((t[m>>2]|0)<(t[v>>2]|0)){t[c>>2]=t[t[c>>2]>>2];continue}if((t[v>>2]|0)<50){b=t[(t[c>>2]|0)+24>>2]|0;u=t[v>>2]|0;t[v>>2]=u+1;t[d+(u<<2)>>2]=b}if(!(t[(t[c>>2]|0)+8>>2]|0))Bc(t[c>>2]|0)|0;if(t[(t[c>>2]|0)+8>>2]|0){if(t[33468]|0){b=t[33976]|0;u=t[33980]|0;t[n>>2]=t[(t[c>>2]|0)+24>>2];yAi[b&511](u,135232,n)}t[o>>2]=Oc(t[(t[c>>2]|0)+8>>2]|0,t[a>>2]|0)|0;if(t[o>>2]|0){p=47;break}}}t[c>>2]=t[t[c>>2]>>2]}if((p|0)==47){t[f>>2]=t[o>>2];_=t[f>>2]|0;s=r;return _|0}else if((p|0)==49){t[f>>2]=-1;_=t[f>>2]|0;s=r;return _|0}return 0}function xc(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r;f=r+32|0;u=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;t[u>>2]=e;t[a>>2]=i;t[b>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[o>>2]=ic(t[a>>2]|0)|0;i=(t[33468]|0)!=0;if(!(t[o>>2]|0)){if(i){e=t[33976]|0;h=t[33980]|0;t[n>>2]=t[a>>2];yAi[e&511](h,134360,n)}t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}if(i){i=t[33976]|0;h=t[33980]|0;e=nl()|0;w=t[a>>2]|0;t[n>>2]=e;t[n+4>>2]=w;yAi[i&511](h,134392,n)}t[c>>2]=eF(t[o>>2]|0)|0;if(((((t[c>>2]|0)!=0?(Xl(t[(t[c>>2]|0)+8>>2]|0,134128)|0)!=0:0)?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,134416)|0)!=0:0){t[b>>2]=Ec(1,0,t[a>>2]|0,0,t[u>>2]|0,0)|0;if(!(t[b>>2]|0)){fy(t[o>>2]|0);t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[l>>2]=cF(t[c>>2]|0,134464)|0;if(t[l>>2]|0){do if(!(Xl(t[l>>2]|0,134472)|0))if(Xl(t[l>>2]|0,134480)|0){t[u>>2]=1;break}else{Uc(0,t[c>>2]|0,1652,134488,t[l>>2]|0,0,0);break}else t[u>>2]=2;while(0);pAi[t[135736>>2]&511](t[l>>2]|0)}t[c>>2]=t[(t[c>>2]|0)+12>>2];zc(t[c>>2]|0,t[u>>2]|0,t[b>>2]|0,0);fy(t[o>>2]|0);t[f>>2]=t[b>>2];k=t[f>>2]|0;s=r;return k|0}Uc(0,t[o>>2]|0,1653,134520,t[a>>2]|0,0,0);fy(t[o>>2]|0);t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}function Uc(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+48|0;c=o;l=o+36|0;b=o+32|0;k=o+28|0;h=o+24|0;w=o+20|0;d=o+16|0;v=o+12|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;a=t[l>>2]|0;l=t[b>>2]|0;b=t[k>>2]|0;k=t[w>>2]|0;u=t[d>>2]|0;f=t[v>>2]|0;n=t[h>>2]|0;h=t[d>>2]|0;d=t[v>>2]|0;t[c>>2]=t[w>>2];t[c+4>>2]=h;t[c+8>>2]=d;cp(0,0,0,a,l,20,b,2,0,0,k,u,f,0,0,n,c);s=o;return}function zc(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;while(1){if(!(t[u>>2]|0))break;if(((t[(t[u>>2]|0)+36>>2]|0)!=0?(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,134416)|0)!=0:0)jc(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}s=f;return}function jc(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=0;t[b>>2]=0;if(!(t[u>>2]|0)){s=f;return}do if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,134552)|0)){n=(Xl(t[(t[u>>2]|0)+8>>2]|0,134480)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,5,134480,134616,134632,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134472)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,6,134472,134640,134632,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134656)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,7,134656,134672,134696,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134712)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,8,134712,134728,134128,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134752)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,9,134752,134672,134128,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134632)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,10,134632,134768,134632,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134776)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,11,134776,134792,134696,t[a>>2]|0,t[c>>2]|0)|0;break}n=(Xl(t[r+8>>2]|0,134808)|0)!=0;r=t[u>>2]|0;if(n){t[b>>2]=Vc(r,12,134808,134792,134128,t[a>>2]|0,t[c>>2]|0)|0;break}if(Xl(t[r+8>>2]|0,134824)|0)t[b>>2]=Vc(t[u>>2]|0,3,134824,0,134128,t[a>>2]|0,t[c>>2]|0)|0}else{t[h>>2]=0;t[k>>2]=cF(t[u>>2]|0,134464)|0;if(t[k>>2]|0){do if(!(Xl(t[k>>2]|0,134472)|0))if(Xl(t[k>>2]|0,134480)|0){t[a>>2]=1;break}else{Uc(t[o>>2]|0,t[u>>2]|0,1652,134488,t[k>>2]|0,0,0);break}else t[a>>2]=2;while(0);pAi[t[135736>>2]&511](t[k>>2]|0);t[h>>2]=t[a>>2]}t[k>>2]=cF(t[u>>2]|0,134560)|0;t[l>>2]=tF(t[u>>2]|0,134568,134576)|0;t[b>>2]=Ec(4,t[k>>2]|0,t[l>>2]|0,0,t[h>>2]|0,t[c>>2]|0)|0;pAi[t[135736>>2]&511](t[k>>2]|0)}while(0);if(t[b>>2]|0){do if(t[o>>2]|0){t[(t[b>>2]|0)+4>>2]=t[o>>2];if(!(t[(t[o>>2]|0)+8>>2]|0)){t[(t[o>>2]|0)+8>>2]=t[b>>2];break}t[w>>2]=t[(t[o>>2]|0)+8>>2];while(1){if(!(t[t[w>>2]>>2]|0))break;t[w>>2]=t[t[w>>2]>>2]}t[t[w>>2]>>2]=t[b>>2]}while(0);if((t[(t[b>>2]|0)+12>>2]|0)==4)zc(t[(t[u>>2]|0)+12>>2]|0,t[a>>2]|0,t[o>>2]|0,t[b>>2]|0)}if(!(t[l>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[l>>2]|0);s=f;return}function Vc(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;o=s;s=s+80|0;c=o;l=o+64|0;b=o+60|0;k=o+56|0;h=o+52|0;w=o+48|0;d=o+44|0;v=o+40|0;m=o+36|0;_=o+32|0;p=o+28|0;E=o+24|0;S=o+20|0;g=o+16|0;y=o+12|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=1;t[E>>2]=0;t[S>>2]=0;t[g>>2]=0;t[y>>2]=0;if((t[w>>2]|0)!=0?(t[E>>2]=cF(t[b>>2]|0,t[w>>2]|0)|0,(t[E>>2]|0)==0):0){Uc(t[y>>2]|0,t[b>>2]|0,1650,134840,t[h>>2]|0,t[w>>2]|0,0);t[_>>2]=0}t[p>>2]=cF(t[b>>2]|0,t[d>>2]|0)|0;if(!(t[p>>2]|0)){Uc(t[y>>2]|0,t[b>>2]|0,1650,134840,t[h>>2]|0,t[d>>2]|0,0);t[_>>2]=0}if(!(t[_>>2]|0)){if(t[E>>2]|0)pAi[t[135736>>2]&511](t[E>>2]|0);if(t[p>>2]|0)pAi[t[135736>>2]&511](t[p>>2]|0);t[l>>2]=0;F=t[l>>2]|0;s=o;return F|0}t[S>>2]=oF(t[(t[b>>2]|0)+32>>2]|0,t[b>>2]|0)|0;t[g>>2]=GA(t[p>>2]|0,t[S>>2]|0)|0;if(t[g>>2]|0){do if((t[33468]|0)>1){_=t[33976]|0;w=t[33980]|0;a=t[h>>2]|0;if(t[E>>2]|0){u=t[E>>2]|0;f=t[g>>2]|0;t[c>>2]=a;t[c+4>>2]=u;t[c+8>>2]=f;yAi[_&511](w,134864,c);break}else{f=t[g>>2]|0;t[c>>2]=a;t[c+4>>2]=f;yAi[_&511](w,134888,c);break}}while(0);t[y>>2]=Ec(t[k>>2]|0,t[E>>2]|0,t[p>>2]|0,t[g>>2]|0,t[v>>2]|0,t[m>>2]|0)|0}else Uc(t[y>>2]|0,t[b>>2]|0,1651,134904,t[h>>2]|0,t[d>>2]|0,t[p>>2]|0);if(t[E>>2]|0)pAi[t[135736>>2]&511](t[E>>2]|0);if(t[p>>2]|0)pAi[t[135736>>2]&511](t[p>>2]|0);if(t[S>>2]|0)pAi[t[135736>>2]&511](t[S>>2]|0);if(t[g>>2]|0)pAi[t[135736>>2]&511](t[g>>2]|0);t[l>>2]=t[y>>2];F=t[l>>2]|0;s=o;return F|0}function qc(){var e=0;e=s;if(t[33932]|0){s=e;return}t[33932]=Kc()|0;s=e;return}function Yc(){var e=0;e=s;if(t[33932]|0){Xc(t[33932]|0);t[33932]=0}rl();s=e;return}function Gc(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[33968];t[18774]=1;t[33968]=t[r>>2];s=i;return t[n>>2]|0}function Wc(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[33970];t[18774]=1;t[33970]=t[r>>2];s=i;return t[n>>2]|0}function Kc(){var e=0,i=0,r=0,n=0;e=s;s=s+16|0;i=e+4|0;r=e;n=Xq(4)|0;t[r>>2]=n;if(!n)t[i>>2]=0;else t[i>>2]=t[r>>2];s=e;return t[i>>2]|0}function Xc(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}Zq(t[r>>2]|0);s=i;return}function Zc(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return}function Jc(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return}function Qc(){var e=0,i=0,r=0,n=0;e=s;s=s+16|0;i=e+4|0;r=e;n=Xq(4)|0;t[r>>2]=n;if(!n)t[i>>2]=0;else t[i>>2]=t[r>>2];s=e;return t[i>>2]|0}function $c(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}Zq(t[r>>2]|0);s=i;return}function el(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return}function il(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return}function rl(){return}function nl(){return 0}function fl(){return}function tl(){return}function ul(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;o=s;s=s+48|0;c=o+40|0;l=o+36|0;b=o+32|0;k=o+28|0;h=o+24|0;w=o+20|0;d=o+16|0;v=o+12|0;m=o+8|0;_=o+4|0;p=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[_>>2]=0;if((t[v>>2]|0)==0|(t[l>>2]|0)==0){cl(136264);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}if((t[h>>2]|0)>>>0>=3){cl(136280);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}t[_>>2]=t[h>>2];h=t[l>>2]|0;if(t[(t[v>>2]|0)+12>>2]|0){ll(0,h,1951,136312);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}t[m>>2]=sl(h,t[b>>2]|0,t[k>>2]|0,t[_>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0)|0;d=t[l>>2]|0;if(!(t[m>>2]|0)){ll(0,d,1950,136392);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}if((t[d+12>>2]|0)!=0?(t[p>>2]=bl(t[m>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0,(t[p>>2]|0)<0):0){kl(136440);hl(t[m>>2]|0);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}t[p>>2]=xO(t[v>>2]|0)|0;if((t[p>>2]|0)<0){kl(136472);hl(t[m>>2]|0);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}else{hl(t[m>>2]|0);t[c>>2]=t[p>>2];E=t[c>>2]|0;s=o;return E|0}return 0}function al(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;u=ul(t[o>>2]|0,317,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;s=a;return u|0}function ol(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(!(t[w>>2]|0)){cl(136496);t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[t[w>>2]>>2]=0;t[v>>2]=PO(0)|0;if(!(t[v>>2]|0)){dl(136520);t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[d>>2]=al(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[v>>2]|0)|0;if((t[d>>2]|0)<0){kl(136544);HO(t[v>>2]|0)|0;t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[d>>2]=Ts(t[(t[v>>2]|0)+16>>2]|0)|0;if((t[d>>2]|0)>0){h=Os(t[(t[v>>2]|0)+16>>2]|0)|0;k=ql(h,t[d>>2]|0)|0;t[t[w>>2]>>2]=k}HO(t[v>>2]|0)|0;if((t[d>>2]|0)>0?(t[t[w>>2]>>2]|0)==0:0){dl(136576);t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}else{t[o>>2]=t[d>>2];m=t[o>>2]|0;s=a;return m|0}return 0}function cl(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;e=t[n>>2]|0;t[r>>2]=t[n>>2];cp(0,0,0,0,0,21,1,2,0,0,e,0,0,0,0,138632,r);s=i;return}function ll(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(t[a>>2]|0)t[(t[a>>2]|0)+40>>2]=t[c>>2];n=t[a>>2]|0;a=t[o>>2]|0;o=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,a,21,o,2,0,0,0,0,0,0,0,138624,u);s=f;return}function sl(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+24|0;k=o+20|0;h=o+16|0;w=o+12|0;d=o+8|0;v=o+4|0;m=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=0;if((t[l>>2]|0)==0|(t[v>>2]|0)==0){cl(138360);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}if(t[(t[v>>2]|0)+12>>2]|0){ll(t[m>>2]|0,t[l>>2]|0,1951,138384);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}if((t[(t[l>>2]|0)+76>>2]|0)!=1){ll(t[m>>2]|0,t[l>>2]|0,1951,138464);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}t[m>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[m>>2]|0)){dl(138512);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}a=(t[m>>2]|0)+0|0;u=a+44|0;do{t[a>>2]=0;a=a+4|0}while((a|0)<(u|0));t[t[m>>2]>>2]=t[l>>2];t[(t[m>>2]|0)+12>>2]=t[d>>2];t[(t[m>>2]|0)+4>>2]=t[b>>2];t[(t[m>>2]|0)+8>>2]=t[k>>2];t[(t[m>>2]|0)+16>>2]=t[v>>2];t[(t[m>>2]|0)+24>>2]=1;t[(t[m>>2]|0)+20>>2]=0;v=vl()|0;t[(t[m>>2]|0)+28>>2]=v;if(!(t[(t[m>>2]|0)+28>>2]|0)){ll(t[m>>2]|0,t[l>>2]|0,1952,138536);hl(t[m>>2]|0);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}t[(t[m>>2]|0)+32>>2]=t[h>>2];if((t[(t[m>>2]|0)+32>>2]|0)==1)t[(t[m>>2]|0)+36>>2]=t[w>>2];t[c>>2]=t[m>>2];_=t[c>>2]|0;s=o;return _|0}function bl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){cl(136712);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=0;while(1){if(!((t[u>>2]|0)!=0&(t[a>>2]|0)>=0))break;t[a>>2]=ml(t[f>>2]|0,t[u>>2]|0)|0;t[u>>2]=t[(t[u>>2]|0)+24>>2]}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function kl(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;e=t[n>>2]|0;t[r>>2]=t[n>>2];cp(0,0,0,0,0,21,1,2,0,0,e,0,0,0,0,136688,r);s=i;return}function hl(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){cl(136640);s=i;return}if(t[(t[r>>2]|0)+28>>2]|0)_l(t[(t[r>>2]|0)+28>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function wl(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+24|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!((t[u>>2]|0)!=0&(t[a>>2]|0)!=0)){t[f>>2]=1;l=t[f>>2]|0;s=n;return l|0}if((t[(t[a>>2]|0)+4>>2]|0)!=18){t[f>>2]=Tn(t[u>>2]|0,t[a>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}r=t[a>>2]|0;t[c+0>>2]=t[r+0>>2];t[c+4>>2]=t[r+4>>2];t[c+8>>2]=t[r+8>>2];t[c+12>>2]=t[r+12>>2];t[c+16>>2]=t[r+16>>2];t[c+20>>2]=t[r+20>>2];if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)==2:0)t[c>>2]=t[(t[o>>2]|0)+20>>2];else t[c>>2]=t[o>>2];t[f>>2]=Tn(t[u>>2]|0,c)|0;l=t[f>>2]|0;s=n;return l|0}function dl(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;e=t[n>>2]|0;t[r>>2]=t[n>>2];cp(0,0,0,0,0,21,2,2,0,0,e,0,0,0,0,136608,r);s=i;return}function vl(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[r>>2]|0)){dl(138592);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{f=t[r>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[f+12>>2]=0;t[f+16>>2]=0;t[f+20>>2]=0;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function ml(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;if((t[f>>2]|0)==0|(t[a>>2]|0)==0){cl(136736);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}if(t[(t[f>>2]|0)+4>>2]|0)w=dAi[t[(t[f>>2]|0)+4>>2]&511](t[(t[f>>2]|0)+8>>2]|0,t[a>>2]|0,t[(t[a>>2]|0)+20>>2]|0)|0;else w=1;t[c>>2]=w;e:do switch(t[(t[a>>2]|0)+4>>2]|0){case 8:{if((t[c>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){w=t[(t[f>>2]|0)+16>>2]|0;if((t[(t[f>>2]|0)+20>>2]|0)==2)iA(w,136840)|0;else iA(w,136848)|0;do if(t[(t[a>>2]|0)+40>>2]|0){t[k>>2]=El(t[(t[a>>2]|0)+40>>2]|0,1)|0;if(t[k>>2]|0){iA(t[(t[f>>2]|0)+16>>2]|0,t[k>>2]|0)|0;pAi[t[135736>>2]&511](t[k>>2]|0);break}kl(136856);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}while(0);w=t[(t[f>>2]|0)+16>>2]|0;if(!(t[(t[f>>2]|0)+20>>2]|0)){iA(w,136888)|0;break e}else{iA(w,136896)|0;break e}}break}case 18:{Sl(136928,136736);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}case 7:{if(t[c>>2]|0){w=t[(t[f>>2]|0)+16>>2]|0;if((t[(t[f>>2]|0)+20>>2]|0)==2)iA(w,136776)|0;else iA(w,136784)|0;iA(t[(t[f>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;do if((t[(t[a>>2]|0)+40>>2]|0)!=0?(u[t[(t[a>>2]|0)+40>>2]>>0]|0|0)!=0:0){iA(t[(t[f>>2]|0)+16>>2]|0,136792)|0;t[b>>2]=El(t[(t[a>>2]|0)+40>>2]|0,2)|0;if(t[b>>2]|0){iA(t[(t[f>>2]|0)+16>>2]|0,t[b>>2]|0)|0;pAi[t[135736>>2]&511](t[b>>2]|0);break}kl(136800);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}while(0);w=t[(t[f>>2]|0)+16>>2]|0;if(!(t[(t[f>>2]|0)+20>>2]|0)){iA(w,136824)|0;break e}else{iA(w,136832)|0;break e}}break}case 3:case 4:{if((t[c>>2]|0)!=0?(t[(t[a>>2]|0)+40>>2]|0)!=0:0){t[l>>2]=El(t[(t[a>>2]|0)+40>>2]|0,3)|0;if(t[l>>2]|0){iA(t[(t[f>>2]|0)+16>>2]|0,t[l>>2]|0)|0;pAi[t[135736>>2]&511](t[l>>2]|0);break e}kl(136752);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}break}case 1:{t[o>>2]=pl(t[f>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;break}case 2:{Sl(136904,136736);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}case 13:case 21:case 11:case 9:{if(t[(t[a>>2]|0)+12>>2]|0){t[(t[f>>2]|0)+20>>2]=0;t[(t[f>>2]|0)+24>>2]=1;t[o>>2]=bl(t[f>>2]|0,t[(t[a>>2]|0)+12>>2]|0)|0}break}case 6:{Sl(136976,136736);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}case 20:case 19:case 17:case 16:case 15:case 14:case 12:case 10:break;case 5:{Sl(136952,136736);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}default:{gl(t[(t[a>>2]|0)+4>>2]|0,136736);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}}while(0);t[n>>2]=t[o>>2];h=t[n>>2]|0;s=r;return h|0}function _l(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){cl(136656);s=i;return}if(t[(t[r>>2]|0)+16>>2]|0){VY(t[(t[r>>2]|0)+16>>2]|0,0,t[(t[r>>2]|0)+12>>2]<<2|0)|0;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0)}if(t[(t[r>>2]|0)+20>>2]|0){VY(t[(t[r>>2]|0)+20>>2]|0,0,t[(t[r>>2]|0)+12>>2]<<2|0)|0;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0)}e=t[r>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function pl(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+64|0;f=n+48|0;u=n+44|0;a=n+40|0;o=n+36|0;c=n+32|0;l=n+8|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+4>>2]|0)==1:0){if((yl(t[u>>2]|0,t[a>>2]|0)|0)<0){kl(137128);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}t[l+0>>2]=0;t[l+4>>2]=0;t[l+8>>2]=0;t[l+12>>2]=0;t[l+16>>2]=0;t[l+20>>2]=0;Fl(t[(t[u>>2]|0)+28>>2]|0,l);if(t[o>>2]|0){if(t[(t[u>>2]|0)+24>>2]|0){t[b>>2]=t[(t[u>>2]|0)+24>>2];t[(t[u>>2]|0)+24>>2]=0;t[(t[u>>2]|0)+20>>2]=1}iA(t[(t[u>>2]|0)+16>>2]|0,137168)|0;if((t[(t[a>>2]|0)+36>>2]|0)!=0?(rs(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)|0)>0:0){iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[(t[u>>2]|0)+16>>2]|0,137176)|0}iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0}r=t[u>>2]|0;i=t[a>>2]|0;e=t[o>>2]|0;if((t[(t[u>>2]|0)+32>>2]|0)==1)t[c>>2]=Al(r,i,e)|0;else t[c>>2]=Ol(r,i,e)|0;if((t[c>>2]|0)<0){kl(137184);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}if(t[o>>2]|0)Ml(t[(t[u>>2]|0)+28>>2]|0);t[c>>2]=Rl(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if((t[c>>2]|0)<0){kl(137216);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}if(t[o>>2]|0)iA(t[(t[u>>2]|0)+16>>2]|0,137248)|0;if((t[(t[a>>2]|0)+12>>2]|0)!=0?(t[c>>2]=bl(t[u>>2]|0,t[(t[a>>2]|0)+12>>2]|0)|0,(t[c>>2]|0)<0):0){kl(137256);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}if(t[o>>2]|0){iA(t[(t[u>>2]|0)+16>>2]|0,137288)|0;if((t[(t[a>>2]|0)+36>>2]|0)!=0?(rs(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)|0)>0:0){iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[(t[u>>2]|0)+16>>2]|0,137176)|0}iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;iA(t[(t[u>>2]|0)+16>>2]|0,137248)|0;if(t[b>>2]|0){t[(t[u>>2]|0)+24>>2]=t[b>>2];t[(t[u>>2]|0)+20>>2]=2}}Nl(t[(t[u>>2]|0)+28>>2]|0,l);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}cl(137104);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}function El(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+32|0;f=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}t[k>>2]=1e3;t[l>>2]=gAi[t[135752>>2]&511](t[k>>2]|0)|0;if(!(t[l>>2]|0)){dl(137064);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}t[b>>2]=t[l>>2];while(1){d=t[b>>2]|0;if(!(u[t[c>>2]>>0]|0)){v=30;break}if((d-(t[l>>2]|0)|0)>((t[k>>2]|0)-10|0)){t[h>>2]=(t[b>>2]|0)-(t[l>>2]|0);t[k>>2]=t[k>>2]<<1;t[l>>2]=MAi[t[135760>>2]&511](t[l>>2]|0,t[k>>2]|0)|0;if(!(t[l>>2]|0)){v=9;break}t[b>>2]=(t[l>>2]|0)+(t[h>>2]|0)}if((u[t[c>>2]>>0]|0|0)==60?(t[o>>2]|0)==0|(t[o>>2]|0)==3:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=108;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=116;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59}else v=14;do if((v|0)==14){v=0;if((t[o>>2]|0)==3?(u[t[c>>2]>>0]|0|0)==62:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=103;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=116;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59;break}if((u[t[c>>2]>>0]|0|0)==38?(t[o>>2]|0)==0|(t[o>>2]|0)==3:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=97;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=109;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=112;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59;break}if((t[o>>2]|0)==0?(u[t[c>>2]>>0]|0|0)==34:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=113;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=117;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=111;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=116;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59;break}if((t[o>>2]|0)==0?(u[t[c>>2]>>0]|0|0)==9:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=35;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=120;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=57;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59;break}if((t[o>>2]|0)==0?(u[t[c>>2]>>0]|0|0)==10:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=35;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=120;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=65;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59;break}if((u[t[c>>2]>>0]|0|0)==13?(t[o>>2]|0)==0|(t[o>>2]|0)==3|(t[o>>2]|0)==1|(t[o>>2]|0)==2:0){a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=38;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=35;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=120;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=68;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=59;break}a=n[t[c>>2]>>0]|0;i=t[b>>2]|0;t[b>>2]=i+1;n[i>>0]=a}while(0);t[c>>2]=(t[c>>2]|0)+1}if((v|0)==9){dl(137088);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}else if((v|0)==30){n[d>>0]=0;t[f>>2]=t[l>>2];w=t[f>>2]|0;s=r;return w|0}return 0}function Sl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+8|0;t[f>>2]=e;t[u>>2]=i;i=t[u>>2]|0;e=t[u>>2]|0;t[n>>2]=t[f>>2];t[n+4>>2]=e;cp(0,0,0,0,0,21,1953,2,0,0,i,0,0,0,0,137032,n);s=r;return}function gl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+8|0;t[f>>2]=e;t[u>>2]=i;i=t[u>>2]|0;e=t[u>>2]|0;t[n>>2]=t[f>>2];t[n+4>>2]=e;cp(0,0,0,0,0,21,1954,2,0,0,i,0,0,0,0,136992,n);s=r;return}function yl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!((t[f>>2]|0)==0|(t[u>>2]|0)==0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0){t[a>>2]=t[(t[u>>2]|0)+48>>2];while(1){if(!(t[a>>2]|0)){c=17;break}if((rs(t[(t[a>>2]|0)+8>>2]|0)|0)>0){t[o>>2]=IA(t[(t[a>>2]|0)+8>>2]|0)|0;if(!(t[o>>2]|0)){c=8;break}u=(rs(t[t[o>>2]>>2]|0)|0)==0;l=t[t[o>>2]>>2]|0;if(u){c=10;break}if(((Ql(l,138296)|0)!=0?(Ql(t[t[o>>2]>>2]|0,138304)|0)!=0:0)?(rs(t[(t[o>>2]|0)+12>>2]|0)|0)==0:0){c=14;break}xA(t[o>>2]|0)}t[a>>2]=t[t[a>>2]>>2]}if((c|0)==8){kl(138272);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}else if((c|0)==10){Tl(l);xA(t[o>>2]|0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}else if((c|0)==14){Tl(t[t[o>>2]>>2]|0);xA(t[o>>2]|0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}else if((c|0)==17){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}cl(137128);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}function Fl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){cl(138248);s=r;return}else{t[t[f>>2]>>2]=t[t[n>>2]>>2];t[(t[f>>2]|0)+4>>2]=t[(t[n>>2]|0)+4>>2];t[(t[f>>2]|0)+8>>2]=t[(t[n>>2]|0)+8>>2];s=r;return}}function Ol(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[w>>2]=0;if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+4>>2]|0)==1:0){t[k>>2]=Eq(0,318)|0;if(!(t[k>>2]|0)){kl(138192);t[f>>2]=-1;d=t[f>>2]|0;s=n;return d|0}t[c>>2]=t[a>>2];while(1){if(!(t[c>>2]|0))break;t[l>>2]=t[(t[c>>2]|0)+48>>2];while(1){if(!(t[l>>2]|0))break;t[b>>2]=wF(t[(t[a>>2]|0)+32>>2]|0,t[a>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0;do if((t[b>>2]|0)==(t[l>>2]|0)?(Dl(t[l>>2]|0)|0)==0:0){if((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[l>>2]|0,t[a>>2]|0)|0)==0:0)break;t[h>>2]=Cl(t[(t[u>>2]|0)+28>>2]|0,t[l>>2]|0)|0;if(t[o>>2]|0)Pl(t[(t[u>>2]|0)+28>>2]|0,t[l>>2]|0,t[a>>2]|0);if(!(t[h>>2]|0))gq(t[k>>2]|0,t[l>>2]|0)|0;if(!(rs(t[(t[l>>2]|0)+12>>2]|0)|0))t[w>>2]=1}while(0);t[l>>2]=t[t[l>>2]>>2]}t[c>>2]=t[(t[c>>2]|0)+20>>2]}if(!((t[o>>2]|0)==0|(t[w>>2]|0)!=0)?(t[34556]=0,t[34557]=0,t[34558]=0,t[34559]=0,t[34560]=0,t[34561]=0,(Cl(t[(t[u>>2]|0)+28>>2]|0,138224)|0)==0):0)Bl(138224,t[u>>2]|0)|0;Mq(t[k>>2]|0,319,t[u>>2]|0);Fq(t[k>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}cl(138152);t[f>>2]=-1;d=t[f>>2]|0;s=n;return d|0}function Al(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;n=s;s=s+64|0;f=n+48|0;u=n+44|0;a=n+40|0;o=n+36|0;c=n+32|0;l=n+28|0;b=n+24|0;k=n+20|0;h=n+16|0;w=n+12|0;d=n+8|0;v=n+4|0;m=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+4>>2]|0)==1:0){if((t[(t[u>>2]|0)+32>>2]|0)!=1){cl(137816);t[f>>2]=-1;_=t[f>>2]|0;s=n;return _|0}t[l>>2]=Eq(0,318)|0;if(!(t[l>>2]|0)){kl(137856);t[f>>2]=-1;_=t[f>>2]|0;s=n;return _|0}e:do if(t[(t[u>>2]|0)+36>>2]|0){t[m>>2]=0;while(1){if(!(t[(t[(t[u>>2]|0)+36>>2]|0)+(t[m>>2]<<2)>>2]|0))break e;t[v>>2]=t[(t[(t[u>>2]|0)+36>>2]|0)+(t[m>>2]<<2)>>2];if(!((Xl(t[v>>2]|0,137896)|0)==0?(Xl(t[v>>2]|0,137704)|0)==0:0)){t[v>>2]=0;t[d>>2]=1}t[c>>2]=wF(t[(t[a>>2]|0)+32>>2]|0,t[a>>2]|0,t[v>>2]|0)|0;do if((t[c>>2]|0)!=0?(Dl(t[c>>2]|0)|0)==0:0){if((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[c>>2]|0,t[a>>2]|0)|0)==0:0)break;t[k>>2]=Cl(t[(t[u>>2]|0)+28>>2]|0,t[c>>2]|0)|0;if(t[o>>2]|0)Pl(t[(t[u>>2]|0)+28>>2]|0,t[c>>2]|0,t[a>>2]|0);if(!(t[k>>2]|0))gq(t[l>>2]|0,t[c>>2]|0)|0;if(!(rs(t[(t[c>>2]|0)+12>>2]|0)|0))t[h>>2]=1}while(0);t[m>>2]=(t[m>>2]|0)+1}}while(0);m=t[a>>2]|0;if(t[(t[a>>2]|0)+36>>2]|0)t[c>>2]=t[m+36>>2];else{t[c>>2]=wF(t[m+32>>2]|0,t[a>>2]|0,0)|0;t[w>>2]=1}if((t[c>>2]|0)!=0?(Dl(t[c>>2]|0)|0)==0:0){
	do if(t[o>>2]|0){if((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[c>>2]|0,t[a>>2]|0)|0)==0:0)break;if(!(Il(t[(t[u>>2]|0)+28>>2]|0,t[c>>2]|0,t[u>>2]|0)|0))gq(t[l>>2]|0,t[c>>2]|0)|0}while(0);if(t[o>>2]|0)Pl(t[(t[u>>2]|0)+28>>2]|0,t[c>>2]|0,t[a>>2]|0);if(!(rs(t[(t[c>>2]|0)+12>>2]|0)|0))t[h>>2]=1}t[b>>2]=t[(t[a>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;do if((t[(t[b>>2]|0)+36>>2]|0)!=0?(Dl(t[(t[b>>2]|0)+36>>2]|0)|0)==0:0){if((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[b>>2]|0,t[a>>2]|0)|0)==0:0){p=49;break}t[k>>2]=Il(t[(t[u>>2]|0)+28>>2]|0,t[(t[b>>2]|0)+36>>2]|0,t[u>>2]|0)|0;Pl(t[(t[u>>2]|0)+28>>2]|0,t[(t[b>>2]|0)+36>>2]|0,t[a>>2]|0);if((t[k>>2]|0)==0&(t[o>>2]|0)!=0)gq(t[l>>2]|0,t[(t[b>>2]|0)+36>>2]|0)|0;if(!(rs(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0))t[h>>2]=1}else p=49;while(0);if((((p|0)==49?(p=0,(t[(t[b>>2]|0)+36>>2]|0)!=0):0)?(rs(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0)==0:0)?(rs(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0)|0)==0:0)t[w>>2]=1;t[b>>2]=t[(t[b>>2]|0)+24>>2]}if((t[o>>2]|0)!=0&(t[w>>2]|0)!=0^1|(t[h>>2]|0)!=0|(t[d>>2]|0)!=0){if((((t[o>>2]|0)==0|(t[h>>2]|0)!=0)^1)&(t[d>>2]|0)!=0?(t[34484]=0,t[34485]=0,t[34486]=0,t[34487]=0,t[34488]=0,t[34489]=0,(Cl(t[(t[u>>2]|0)+28>>2]|0,137936)|0)==0):0)Bl(137936,t[u>>2]|0)|0}else{t[34478]=0;t[34479]=0;t[34480]=0;t[34481]=0;t[34482]=0;t[34483]=0;t[k>>2]=Il(t[(t[u>>2]|0)+28>>2]|0,137912,t[u>>2]|0)|0;if(!(t[k>>2]|0))Bl(137912,t[u>>2]|0)|0}Mq(t[l>>2]|0,319,t[u>>2]|0);Fq(t[l>>2]|0);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}cl(137816);t[f>>2]=-1;_=t[f>>2]|0;s=n;return _|0}function Ml(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){cl(137784);s=i;return}else{t[(t[r>>2]|0)+4>>2]=t[(t[r>>2]|0)+8>>2];t[(t[r>>2]|0)+8>>2]=t[t[r>>2]>>2];s=i;return}}function Rl(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;n=s;s=s+48|0;f=n+44|0;u=n+40|0;a=n+36|0;o=n+32|0;c=n+28|0;l=n+24|0;b=n+20|0;k=n+16|0;h=n+12|0;w=n+8|0;d=n+4|0;v=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;t[w>>2]=0;if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+4>>2]|0)==1:0){t[l>>2]=Eq(0,320)|0;if(!(t[l>>2]|0)){kl(137328);t[f>>2]=-1;m=t[f>>2]|0;s=n;return m|0}r=t[(t[u>>2]|0)+32>>2]|0;e:do if((r|0)==2){t[c>>2]=t[(t[a>>2]|0)+44>>2];while(1){_=(t[o>>2]|0)!=0;if(!(t[c>>2]|0))break;do if(_?(xl(t[c>>2]|0)|0)!=0:0){t[v>>2]=0;if((t[v>>2]|0)==0&(t[h>>2]|0)==0?(Xl(t[(t[c>>2]|0)+8>>2]|0,137360)|0)!=0:0){t[h>>2]=t[c>>2];t[v>>2]=1}if((t[v>>2]|0)==0&(t[w>>2]|0)==0?(Xl(t[(t[c>>2]|0)+8>>2]|0,137368)|0)!=0:0){t[w>>2]=t[c>>2];t[v>>2]=1}if((t[v>>2]|0)==0&(t[k>>2]|0)==0?(Xl(t[(t[c>>2]|0)+8>>2]|0,137376)|0)!=0:0){t[k>>2]=t[c>>2];t[v>>2]=1}if(!(t[v>>2]|0)){if((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[c>>2]|0,t[a>>2]|0)|0)==0:0)break;gq(t[l>>2]|0,t[c>>2]|0)|0}}else p=36;while(0);do if((p|0)==36){p=0;if((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[c>>2]|0,t[a>>2]|0)|0)==0:0)break;gq(t[l>>2]|0,t[c>>2]|0)|0}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}if(_){if(!(t[h>>2]|0))t[h>>2]=Ul(t[u>>2]|0,t[(t[a>>2]|0)+20>>2]|0,137360,137384)|0;if(t[h>>2]|0)gq(t[l>>2]|0,t[h>>2]|0)|0;if(!(t[w>>2]|0))t[w>>2]=Ul(t[u>>2]|0,t[(t[a>>2]|0)+20>>2]|0,137368,137384)|0;if(t[w>>2]|0)gq(t[l>>2]|0,t[w>>2]|0)|0;if(!(t[k>>2]|0))t[k>>2]=Ul(t[u>>2]|0,t[(t[a>>2]|0)+20>>2]|0,137376,137384)|0;if((t[k>>2]|0)!=0?(t[k>>2]=zl(t[u>>2]|0,t[k>>2]|0)|0,(t[k>>2]|0)!=0):0){gq(t[l>>2]|0,t[k>>2]|0)|0;t[(t[k>>2]|0)+24>>2]=t[b>>2];t[b>>2]=t[k>>2]}}}else if(!r){t[c>>2]=t[(t[a>>2]|0)+44>>2];while(1){if(!(t[c>>2]|0))break;if(!((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[c>>2]|0,t[a>>2]|0)|0)==0:0))gq(t[l>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2]}if((((t[o>>2]|0)!=0?(t[(t[a>>2]|0)+20>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)!=0:0)?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+20>>2]|0,t[(t[(t[a>>2]|0)+20>>2]|0)+20>>2]|0)|0)==0:0){t[d>>2]=t[(t[a>>2]|0)+20>>2];while(1){if(!(t[d>>2]|0))break e;t[c>>2]=t[(t[d>>2]|0)+44>>2];while(1){if(!(t[c>>2]|0))break;if((xl(t[c>>2]|0)|0)!=0?(Sq(t[l>>2]|0,t[c>>2]|0)|0)==0:0)gq(t[l>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2]}t[d>>2]=t[(t[d>>2]|0)+20>>2]}}}else if((r|0)==1){t[c>>2]=t[(t[a>>2]|0)+44>>2];while(1){if(!(t[c>>2]|0))break e;if(!((t[(t[u>>2]|0)+4>>2]|0)!=0?(dAi[t[(t[u>>2]|0)+4>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[c>>2]|0,t[a>>2]|0)|0)==0:0))gq(t[l>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2]}}while(0);Mq(t[l>>2]|0,321,t[u>>2]|0);dy(t[b>>2]|0);Fq(t[l>>2]|0);t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}cl(137216);t[f>>2]=-1;m=t[f>>2]|0;s=n;return m|0}function Nl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){cl(137296);s=r;return}else{t[t[n>>2]>>2]=t[t[f>>2]>>2];t[(t[n>>2]|0)+4>>2]=t[(t[f>>2]|0)+4>>2];t[(t[n>>2]|0)+8>>2]=t[(t[f>>2]|0)+8>>2];s=r;return}}function Tl(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;t[r>>2]=t[n>>2];cp(0,0,0,0,0,21,1955,2,0,0,0,0,0,0,0,138312,r);s=i;return}function Ll(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)!=(t[u>>2]|0)){if(!(t[f>>2]|0)){t[n>>2]=-1;break}if(!(t[u>>2]|0)){t[n>>2]=1;break}else{t[n>>2]=Kl(t[(t[f>>2]|0)+12>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function Dl(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)!=0?(Xl(t[(t[r>>2]|0)+12>>2]|0,137776)|0)!=0:0)n=(Xl(t[(t[r>>2]|0)+8>>2]|0,137384)|0)!=0;else n=0;s=i;return n&1|0}function Cl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){cl(138112);t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)!=0:0)w=t[(t[u>>2]|0)+12>>2]|0;else w=137704;t[o>>2]=w;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+8>>2]|0)!=0:0)d=t[(t[u>>2]|0)+8>>2]|0;else d=137704;t[c>>2]=d;if(Vl(t[o>>2]|0,0)|0)v=(Vl(t[c>>2]|0,0)|0)!=0;else v=0;t[l>>2]=v&1;e:do if(t[(t[f>>2]|0)+16>>2]|0){if(t[l>>2]|0)m=0;else m=t[(t[f>>2]|0)+4>>2]|0;t[b>>2]=m;t[a>>2]=(t[t[f>>2]>>2]|0)-1;while(1){if((t[a>>2]|0)<(t[b>>2]|0))break e;t[k>>2]=t[(t[(t[f>>2]|0)+16>>2]|0)+(t[a>>2]<<2)>>2];if(t[k>>2]|0)_=t[(t[k>>2]|0)+12>>2]|0;else _=0;if(Vl(t[o>>2]|0,_)|0)break;t[a>>2]=(t[a>>2]|0)+-1}if(t[k>>2]|0)p=t[(t[k>>2]|0)+8>>2]|0;else p=0;t[n>>2]=Vl(t[c>>2]|0,p)|0;h=t[n>>2]|0;s=r;return h|0}while(0);t[n>>2]=t[l>>2];h=t[n>>2]|0;s=r;return h|0}function Pl(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;do if(t[f>>2]|0){if((t[(t[f>>2]|0)+16>>2]|0)==0?(t[(t[f>>2]|0)+20>>2]|0)!=0:0)break;if((t[(t[f>>2]|0)+16>>2]|0)!=0?(t[(t[f>>2]|0)+20>>2]|0)==0:0)break;do if((t[(t[f>>2]|0)+16>>2]|0)==0?(t[(t[f>>2]|0)+20>>2]|0)==0:0){r=gAi[t[135744>>2]&511](64)|0;t[(t[f>>2]|0)+16>>2]=r;r=gAi[t[135744>>2]&511](64)|0;t[(t[f>>2]|0)+20>>2]=r;if((t[(t[f>>2]|0)+16>>2]|0)!=0?(t[(t[f>>2]|0)+20>>2]|0)!=0:0){r=(t[(t[f>>2]|0)+16>>2]|0)+0|0;i=r+64|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));r=(t[(t[f>>2]|0)+20>>2]|0)+0|0;i=r+64|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[f>>2]|0)+12>>2]=16;break}dl(138088);s=n;return}else l=13;while(0);do if((l|0)==13?(t[(t[f>>2]|0)+12>>2]|0)==(t[t[f>>2]>>2]|0):0){t[c>>2]=t[(t[f>>2]|0)+12>>2]<<1;t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+16>>2]|0,t[c>>2]<<2)|0;if(!(t[o>>2]|0)){dl(138088);s=n;return}t[(t[f>>2]|0)+16>>2]=t[o>>2];t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+20>>2]|0,t[c>>2]<<2)|0;if(t[o>>2]|0){t[(t[f>>2]|0)+20>>2]=t[o>>2];t[(t[f>>2]|0)+12>>2]=t[c>>2];break}dl(138088);s=n;return}while(0);t[(t[(t[f>>2]|0)+16>>2]|0)+(t[t[f>>2]>>2]<<2)>>2]=t[u>>2];t[(t[(t[f>>2]|0)+20>>2]|0)+(t[t[f>>2]>>2]<<2)>>2]=t[a>>2];r=t[f>>2]|0;t[r>>2]=(t[r>>2]|0)+1;s=n;return}while(0);cl(138056);s=n;return}function Bl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){cl(137960);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}i=t[(t[u>>2]|0)+16>>2]|0;if(t[(t[f>>2]|0)+12>>2]|0){iA(i,137984)|0;iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+12>>2]|0)|0;iA(t[(t[u>>2]|0)+16>>2]|0,137992)|0}else iA(i,138e3)|0;i=t[(t[u>>2]|0)+16>>2]|0;if(t[(t[f>>2]|0)+8>>2]|0)xs(t[i+16>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;else iA(i,138008)|0;t[n>>2]=1;a=t[n>>2]|0;s=r;return a|0}function Il(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){cl(138016);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+12>>2]|0)!=0:0)v=t[(t[a>>2]|0)+12>>2]|0;else v=137704;t[l>>2]=v;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+8>>2]|0)!=0:0)m=t[(t[a>>2]|0)+8>>2]|0;else m=137704;t[b>>2]=m;if(Vl(t[l>>2]|0,0)|0)_=(Vl(t[b>>2]|0,0)|0)!=0;else _=0;t[k>>2]=_&1;e:do if(t[(t[u>>2]|0)+16>>2]|0){t[h>>2]=0;t[c>>2]=(t[t[u>>2]>>2]|0)-1;while(1){if((t[c>>2]|0)<(t[h>>2]|0))break e;t[w>>2]=t[(t[(t[u>>2]|0)+16>>2]|0)+(t[c>>2]<<2)>>2];if(t[w>>2]|0)p=t[(t[w>>2]|0)+12>>2]|0;else p=0;if(Vl(t[l>>2]|0,p)|0)break;t[c>>2]=(t[c>>2]|0)+-1}if(t[w>>2]|0)E=t[(t[w>>2]|0)+8>>2]|0;else E=0;if(!(Vl(t[b>>2]|0,E)|0)){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if(t[(t[o>>2]|0)+4>>2]|0)S=dAi[t[(t[o>>2]|0)+4>>2]&511](t[(t[o>>2]|0)+8>>2]|0,t[w>>2]|0,t[(t[(t[u>>2]|0)+20>>2]|0)+(t[c>>2]<<2)>>2]|0)|0;else S=1;t[f>>2]=S;d=t[f>>2]|0;s=n;return d|0}while(0);t[f>>2]=t[k>>2];d=t[f>>2]|0;s=n;return d|0}function Hl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;do if((t[f>>2]|0)==(t[u>>2]|0))t[n>>2]=0;else{if(!(t[f>>2]|0)){t[n>>2]=-1;break}if(!(t[u>>2]|0)){t[n>>2]=1;break}i=t[f>>2]|0;if((t[(t[f>>2]|0)+36>>2]|0)==(t[(t[u>>2]|0)+36>>2]|0)){t[n>>2]=Kl(t[i+8>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;break}if(!(t[i+36>>2]|0)){t[n>>2]=-1;break}if(!(t[(t[u>>2]|0)+36>>2]|0)){t[n>>2]=1;break}if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)){t[n>>2]=-1;break}if(!(t[(t[(t[u>>2]|0)+36>>2]|0)+12>>2]|0)){t[n>>2]=1;break}t[a>>2]=Kl(t[(t[(t[f>>2]|0)+36>>2]|0)+8>>2]|0,t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0)|0;if(!(t[a>>2]|0))t[a>>2]=Kl(t[(t[f>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;t[n>>2]=t[a>>2]}while(0);s=r;return t[n>>2]|0}function xl(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[(t[r>>2]|0)+36>>2]|0)){n=0;f=n&1;s=i;return f|0}n=(Dl(t[(t[r>>2]|0)+36>>2]|0)|0)!=0;f=n&1;s=i;return f|0}function Ul(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;while(1){if(!(t[o>>2]|0)){k=9;break}if(t[(t[a>>2]|0)+4>>2]|0)h=dAi[t[(t[a>>2]|0)+4>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[o>>2]|0,t[(t[o>>2]|0)+20>>2]|0)|0;else h=1;if(!((h|0)!=0^1)){k=9;break}t[b>>2]=xy(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;if(t[b>>2]|0){k=7;break}t[o>>2]=t[(t[o>>2]|0)+20>>2]}if((k|0)==7){t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}else if((k|0)==9){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}return 0}function zl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;if(!((t[f>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+20>>2]|0)!=0:0){t[o>>2]=sy(t[t[f>>2]>>2]|0,t[(t[a>>2]|0)+12>>2]|0,1)|0;if(!(t[o>>2]|0)){kl(137528);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}t[c>>2]=t[(t[(t[a>>2]|0)+20>>2]|0)+20>>2];while(1){if(!(t[c>>2]|0)){d=23;break}if(t[(t[f>>2]|0)+4>>2]|0)v=dAi[t[(t[f>>2]|0)+4>>2]&511](t[(t[f>>2]|0)+8>>2]|0,t[c>>2]|0,t[(t[c>>2]|0)+20>>2]|0)|0;else v=1;if(!((v|0)!=0^1)){d=23;break}t[l>>2]=xy(t[c>>2]|0,137376,137384)|0;if(t[l>>2]|0){t[b>>2]=sy(t[t[f>>2]>>2]|0,t[(t[l>>2]|0)+12>>2]|0,1)|0;if(!(t[b>>2]|0)){d=13;break}t[h>>2]=rs(t[b>>2]|0)|0;if((t[h>>2]|0)>1?(u[(t[b>>2]|0)+((t[h>>2]|0)-2)>>0]|0|0)==46:0){t[k>>2]=us(t[b>>2]|0,137584)|0;if(!(t[k>>2]|0)){d=17;break}t[b>>2]=t[k>>2]}t[k>>2]=GA(t[o>>2]|0,t[b>>2]|0)|0;i=(t[k>>2]|0)==0;pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);if(i){d=20;break}t[o>>2]=t[k>>2]}t[c>>2]=t[(t[c>>2]|0)+20>>2]}if((d|0)==13){pAi[t[135736>>2]&511](t[o>>2]|0);kl(137528);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==17){pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);kl(137592);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==20){kl(137648);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==23){if((t[o>>2]|0)!=0?(Xl(t[o>>2]|0,137704)|0)==0:0){t[l>>2]=ky(0,t[(t[a>>2]|0)+36>>2]|0,137376,t[o>>2]|0)|0;a=(t[l>>2]|0)==0;pAi[t[135736>>2]&511](t[o>>2]|0);if(a){kl(137712);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}else{t[n>>2]=t[l>>2];w=t[n>>2]|0;s=r;return w|0}}pAi[t[135736>>2]&511](t[o>>2]|0);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}}cl(137496);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}function jl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){cl(137424);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}iA(t[(t[u>>2]|0)+16>>2]|0,136792)|0;if((t[(t[f>>2]|0)+36>>2]|0)!=0?(rs(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>0:0){iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;iA(t[(t[u>>2]|0)+16>>2]|0,137176)|0}iA(t[(t[u>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;iA(t[(t[u>>2]|0)+16>>2]|0,137448)|0;t[a>>2]=sy(t[t[u>>2]>>2]|0,t[(t[f>>2]|0)+12>>2]|0,1)|0;do if(t[a>>2]|0){t[o>>2]=El(t[a>>2]|0,0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);if(t[o>>2]|0){iA(t[(t[u>>2]|0)+16>>2]|0,t[o>>2]|0)|0;pAi[t[135736>>2]&511](t[o>>2]|0);break}kl(137456);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}while(0);iA(t[(t[u>>2]|0)+16>>2]|0,137488)|0;t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}function Vl(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;f=r+8|0;a=r+4|0;o=r;t[a>>2]=e;t[o>>2]=i;do if((t[a>>2]|0)!=(t[o>>2]|0)){i=t[o>>2]|0;if(!(t[a>>2]|0)){t[f>>2]=(u[i>>0]|0)==0&1;break}if(!i){t[f>>2]=(u[t[a>>2]>>0]|0)==0&1;break}while(1){i=t[a>>2]|0;t[a>>2]=i+1;if((u[i>>0]|0)!=(u[t[o>>2]>>0]|0)){c=8;break}i=t[o>>2]|0;t[o>>2]=i+1;if(!(n[i>>0]|0)){c=10;break}}if((c|0)==8){t[f>>2]=0;break}else if((c|0)==10){t[f>>2]=1;break}}else t[f>>2]=1;while(0);s=r;return t[f>>2]|0}function ql(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)==0|(t[a>>2]|0)<0){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=gAi[t[135752>>2]&511]((t[a>>2]|0)+1|0)|0;if(!(t[o>>2]|0)){Sp(0,0);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}else{YY(t[o>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;n[(t[o>>2]|0)+(t[a>>2]|0)>>0]=0;t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}return 0}function Yl(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(!(t[n>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}while(1){if(!(u[t[f>>2]>>0]|0))break;t[f>>2]=(t[f>>2]|0)+1}t[r>>2]=ql(t[n>>2]|0,(t[f>>2]|0)-(t[n>>2]|0)|0)|0;a=t[r>>2]|0;s=i;return a|0}function Gl(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[a>>2]=e;t[o>>2]=i;if((t[a>>2]|0)==0|(t[o>>2]|0)<0){t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}t[l>>2]=gAi[t[135752>>2]&511]((t[o>>2]|0)+1|0)|0;if(!(t[l>>2]|0)){Sp(0,0);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[o>>2]|0)){k=10;break}n[(t[l>>2]|0)+(t[c>>2]|0)>>0]=n[(t[a>>2]|0)+(t[c>>2]|0)>>0]|0;if(!(u[(t[l>>2]|0)+(t[c>>2]|0)>>0]|0)){k=8;break}t[c>>2]=(t[c>>2]|0)+1}if((k|0)==8){t[f>>2]=t[l>>2];b=t[f>>2]|0;s=r;return b|0}else if((k|0)==10){n[(t[l>>2]|0)+(t[o>>2]|0)>>0]=0;t[f>>2]=t[l>>2];b=t[f>>2]|0;s=r;return b|0}return 0}function Wl(e){e=e|0;var i=0,r=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;u=i;t[f>>2]=e;t[u>>2]=t[f>>2];if(!(t[f>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}while(1){if(!(n[t[u>>2]>>0]|0))break;t[u>>2]=(t[u>>2]|0)+1}t[r>>2]=Gl(t[f>>2]|0,(t[u>>2]|0)-(t[f>>2]|0)|0)|0;a=t[r>>2]|0;s=i;return a|0}function Kl(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;do if((t[f>>2]|0)!=(t[a>>2]|0)){if(!(t[f>>2]|0)){t[n>>2]=-1;break}if(!(t[a>>2]|0)){t[n>>2]=1;break}while(1){i=t[f>>2]|0;t[f>>2]=i+1;t[o>>2]=(u[i>>0]|0)-(u[t[a>>2]>>0]|0);if(t[o>>2]|0){c=8;break}i=t[a>>2]|0;t[a>>2]=i+1;if(!(u[i>>0]|0)){c=10;break}}if((c|0)==8){t[n>>2]=t[o>>2];break}else if((c|0)==10){t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function Xl(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;f=r+8|0;a=r+4|0;o=r;t[a>>2]=e;t[o>>2]=i;do if((t[a>>2]|0)!=(t[o>>2]|0)){if(!(t[a>>2]|0)){t[f>>2]=0;break}if(!(t[o>>2]|0)){t[f>>2]=0;break}while(1){i=t[a>>2]|0;t[a>>2]=i+1;if((u[i>>0]|0)!=(u[t[o>>2]>>0]|0)){c=8;break}i=t[o>>2]|0;t[o>>2]=i+1;if(!(n[i>>0]|0)){c=10;break}}if((c|0)==8){t[f>>2]=0;break}else if((c|0)==10){t[f>>2]=1;break}}else t[f>>2]=1;while(0);s=r;return t[f>>2]|0}function Zl(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;r=t[c>>2]|0;do if(t[o>>2]|0){if(!r){t[a>>2]=0;break}if(!(t[l>>2]|0)){t[a>>2]=0;break}do{i=t[o>>2]|0;t[o>>2]=i+1;if((u[i>>0]|0)!=(u[t[l>>2]>>0]|0)){b=8;break}i=t[l>>2]|0;t[l>>2]=i+1;if(!(u[i>>0]|0))break}while((u[t[o>>2]>>0]|0)!=0);if((b|0)==8){t[a>>2]=0;break}i=t[l>>2]|0;t[l>>2]=i+1;if((u[i>>0]|0)!=58){t[a>>2]=0;break}while(1){i=t[c>>2]|0;t[c>>2]=i+1;if((u[i>>0]|0)!=(u[t[l>>2]>>0]|0)){b=14;break}i=t[l>>2]|0;t[l>>2]=i+1;if(!(n[i>>0]|0)){b=16;break}}if((b|0)==14){t[a>>2]=0;break}else if((b|0)==16){t[a>>2]=1;break}}else t[a>>2]=Xl(r,t[l>>2]|0)|0;while(0);s=f;return t[a>>2]|0}function Jl(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if((t[o>>2]|0)>0){if((t[u>>2]|0)==(t[a>>2]|0)){t[f>>2]=0;break}if(!(t[u>>2]|0)){t[f>>2]=-1;break}if(!(t[a>>2]|0)){t[f>>2]=1;break}else{t[c>>2]=RY(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[f>>2]=t[c>>2];break}}else t[f>>2]=0;while(0);s=n;return t[f>>2]|0}function Ql(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;do if((t[f>>2]|0)!=(t[a>>2]|0)){if(!(t[f>>2]|0)){t[n>>2]=-1;break}if(!(t[a>>2]|0)){t[n>>2]=1;break}while(1){i=t[f>>2]|0;t[f>>2]=i+1;t[o>>2]=(u[138656+(u[i>>0]|0)>>0]|0)-(u[138656+(u[t[a>>2]>>0]|0)>>0]|0);if(t[o>>2]|0){c=8;break}i=t[a>>2]|0;t[a>>2]=i+1;if(!(u[i>>0]|0)){c=10;break}}if((c|0)==8){t[n>>2]=t[o>>2];break}else if((c|0)==10){t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function $l(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;do if((t[c>>2]|0)>0){if((t[a>>2]|0)==(t[o>>2]|0)){t[f>>2]=0;break}if(!(t[a>>2]|0)){t[f>>2]=-1;break}if(!(t[o>>2]|0)){t[f>>2]=1;break}while(1){r=t[a>>2]|0;t[a>>2]=r+1;t[l>>2]=(u[138656+(u[r>>0]|0)>>0]|0)-(u[138656+(u[t[o>>2]>>0]|0)>>0]|0);if(t[l>>2]|0){b=11;break}r=(t[c>>2]|0)+-1|0;t[c>>2]=r;if(!r){b=11;break}r=t[o>>2]|0;t[o>>2]=r+1;if(!(u[r>>0]|0)){b=13;break}}if((b|0)==11){t[f>>2]=t[l>>2];break}else if((b|0)==13){t[f>>2]=0;break}}else t[f>>2]=0;while(0);s=n;return t[f>>2]|0}function es(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+4|0;a=r;o=r+8|0;t[a>>2]=e;n[o>>0]=i;do if(t[a>>2]|0){while(1){if(!(u[t[a>>2]>>0]|0)){c=7;break}l=t[a>>2]|0;if((u[t[a>>2]>>0]|0|0)==(u[o>>0]|0|0)){c=5;break}t[a>>2]=l+1}if((c|0)==5){t[f>>2]=l;break}else if((c|0)==7){t[f>>2]=0;break}}else t[f>>2]=0;while(0);s=r;return t[f>>2]|0}function is(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;do if(t[f>>2]|0){if(!(t[a>>2]|0)){t[n>>2]=0;break}t[o>>2]=rs(t[a>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=t[f>>2];break}while(1){if(!(u[t[f>>2]>>0]|0)){c=12;break}if((u[t[f>>2]>>0]|0|0)==(u[t[a>>2]>>0]|0|0)?(Jl(t[f>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)==0:0){c=10;break}t[f>>2]=(t[f>>2]|0)+1}if((c|0)==10){t[n>>2]=t[f>>2];break}else if((c|0)==12){t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function rs(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}while(1){if(!(u[t[n>>2]>>0]|0))break;t[n>>2]=(t[n>>2]|0)+1;t[f>>2]=(t[f>>2]|0)+1}t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function ns(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;do if(t[f>>2]|0){if(!(t[a>>2]|0)){t[n>>2]=0;break}t[o>>2]=rs(t[a>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=t[f>>2];break}while(1){if(!(u[t[f>>2]>>0]|0)){c=12;break}if((u[138656+(u[t[f>>2]>>0]|0)>>0]|0|0)==(u[138656+(u[t[a>>2]>>0]|0)>>0]|0|0)?($l(t[f>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)==0:0){c=10;break}t[f>>2]=(t[f>>2]|0)+1}if((c|0)==10){t[n>>2]=t[f>>2];break}else if((c|0)==12){t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function fs(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=t[a>>2];k=t[u>>2]|0;s=f;return k|0}if((t[c>>2]|0)<0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if(!(t[a>>2]|0)){t[u>>2]=ql(t[o>>2]|0,t[c>>2]|0)|0;k=t[u>>2]|0;s=f;return k|0}t[l>>2]=rs(t[a>>2]|0)|0;t[b>>2]=MAi[t[135760>>2]&511](t[a>>2]|0,(t[l>>2]|0)+(t[c>>2]|0)+1|0)|0;if(!(t[b>>2]|0)){Sp(0,0);t[u>>2]=t[a>>2];k=t[u>>2]|0;s=f;return k|0}else{YY((t[b>>2]|0)+(t[l>>2]|0)|0,t[o>>2]|0,t[c>>2]|0)|0;n[(t[b>>2]|0)+((t[l>>2]|0)+(t[c>>2]|0))>>0]=0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}return 0}function ts(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if((t[c>>2]|0)<0)t[c>>2]=rs(t[o>>2]|0)|0;r=t[a>>2]|0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=Yl(r)|0;k=t[u>>2]|0;s=f;return k|0}if(!r){t[u>>2]=ql(t[o>>2]|0,t[c>>2]|0)|0;k=t[u>>2]|0;s=f;return k|0}t[l>>2]=rs(t[a>>2]|0)|0;t[b>>2]=gAi[t[135744>>2]&511]((t[l>>2]|0)+(t[c>>2]|0)+1|0)|0;if(!(t[b>>2]|0)){Sp(0,0);t[u>>2]=ql(t[a>>2]|0,t[l>>2]|0)|0;k=t[u>>2]|0;s=f;return k|0}else{YY(t[b>>2]|0,t[a>>2]|0,t[l>>2]|0)|0;YY((t[b>>2]|0)+(t[l>>2]|0)|0,t[o>>2]|0,t[c>>2]|0)|0;n[(t[b>>2]|0)+((t[l>>2]|0)+(t[c>>2]|0))>>0]=0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}return 0}function us(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[a>>2];i=t[f>>2]|0;if(!(t[a>>2]|0)){t[n>>2]=i;c=t[n>>2]|0;s=r;return c|0}if(!i){t[n>>2]=Yl(t[a>>2]|0)|0;c=t[n>>2]|0;s=r;return c|0}while(1){if(!(u[t[o>>2]>>0]|0))break;t[o>>2]=(t[o>>2]|0)+1}t[n>>2]=fs(t[f>>2]|0,t[a>>2]|0,(t[o>>2]|0)-(t[a>>2]|0)|0)|0;c=t[n>>2]|0;s=r;return c|0}function as(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+8|0;k=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;if((t[o>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=-1;h=t[a>>2]|0;s=u;return h|0}else{t[b>>2]=f;t[k>>2]=yY(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,b)|0;n[(t[o>>2]|0)+((t[c>>2]|0)-1)>>0]=0;t[a>>2]=t[k>>2];h=t[a>>2]|0;s=u;return h|0}return 0}function os(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}e:while(1){if(!(u[t[n>>2]>>0]|0)){o=19;break}e=(t[n>>2]|0)+1|0;do if((u[t[n>>2]>>0]|0)&128){if(((u[e>>0]|0)&192|0)!=128){o=6;break e}c=(t[n>>2]|0)+2|0;if(((u[t[n>>2]>>0]|0)&224|0)!=224){t[n>>2]=c;break}if(((u[c>>0]|0)&192|0)!=128){o=9;break e}c=t[n>>2]|0;if(((u[t[n>>2]>>0]|0)&240|0)!=240){t[n>>2]=c+3;break}if(((u[c>>0]|0)&248|0)!=240){o=13;break e}if(((u[(t[n>>2]|0)+3>>0]|0)&192|0)!=128){o=13;break e}t[n>>2]=(t[n>>2]|0)+4}else t[n>>2]=e;while(0);t[f>>2]=(t[f>>2]|0)+1}if((o|0)==6){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==9){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==13){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==19){t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}return 0}function cs(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;e:do if(!((t[f>>2]|0)==0|(t[a>>2]|0)==0)?(t[t[a>>2]>>2]|0)>=1:0){t[o>>2]=u[t[f>>2]>>0];i=t[a>>2]|0;do if(t[o>>2]&128){if((t[i>>2]|0)<2)break e;if(((u[(t[f>>2]|0)+1>>0]|0)&192|0)!=128)break e;e=t[a>>2]|0;if((t[o>>2]&224|0)!=224){t[e>>2]=2;t[o>>2]=((u[t[f>>2]>>0]|0)&31)<<6;t[o>>2]=t[o>>2]|(u[(t[f>>2]|0)+1>>0]|0)&63;break}if((t[e>>2]|0)<3)break e;if(((u[(t[f>>2]|0)+2>>0]|0)&192|0)!=128)break e;e=t[a>>2]|0;if((t[o>>2]&240|0)!=240){t[e>>2]=3;t[o>>2]=((u[t[f>>2]>>0]|0)&15)<<12;t[o>>2]=t[o>>2]|((u[(t[f>>2]|0)+1>>0]|0)&63)<<6;t[o>>2]=t[o>>2]|(u[(t[f>>2]|0)+2>>0]|0)&63;break}if((t[e>>2]|0)<4)break e;if((t[o>>2]&248|0)!=240)break e;if(((u[(t[f>>2]|0)+3>>0]|0)&192|0)!=128)break e;t[t[a>>2]>>2]=4;t[o>>2]=((u[t[f>>2]>>0]|0)&7)<<18;t[o>>2]=t[o>>2]|((u[(t[f>>2]|0)+1>>0]|0)&63)<<12;t[o>>2]=t[o>>2]|((u[(t[f>>2]|0)+2>>0]|0)&63)<<6;t[o>>2]=t[o>>2]|(u[(t[f>>2]|0)+3>>0]|0)&63}else t[i>>2]=1;while(0);t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}while(0);if(t[a>>2]|0)t[t[a>>2]>>2]=0;t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}function ls(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;a=i;o=i+12|0;t[f>>2]=e;if(!(t[f>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=0;while(1){e=n[(t[f>>2]|0)+(t[a>>2]|0)>>0]|0;n[o>>0]=e;if(!(e<<24>>24)){l=23;break}if(!((u[o>>0]|0)&128)){t[a>>2]=(t[a>>2]|0)+1;continue}if(((u[o>>0]|0)&224|0)==192){if(((u[(t[f>>2]|0)+((t[a>>2]|0)+1)>>0]|0)&192|0)!=128){l=9;break}t[a>>2]=(t[a>>2]|0)+2;continue}if(((u[o>>0]|0)&240|0)==224){if(((u[(t[f>>2]|0)+((t[a>>2]|0)+1)>>0]|0)&192|0)!=128){l=14;break}if(((u[(t[f>>2]|0)+((t[a>>2]|0)+2)>>0]|0)&192|0)!=128){l=14;break}t[a>>2]=(t[a>>2]|0)+3;continue}if(((u[o>>0]|0)&248|0)!=240){l=22;break}if(((u[(t[f>>2]|0)+((t[a>>2]|0)+1)>>0]|0)&192|0)!=128){l=20;break}if(((u[(t[f>>2]|0)+((t[a>>2]|0)+2)>>0]|0)&192|0)!=128){l=20;break}if(((u[(t[f>>2]|0)+((t[a>>2]|0)+3)>>0]|0)&192|0)!=128){l=20;break}t[a>>2]=(t[a>>2]|0)+4}if((l|0)==9){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else if((l|0)==14){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else if((l|0)==20){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else if((l|0)==22){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else if((l|0)==23){t[r>>2]=1;c=t[r>>2]|0;s=i;return c|0}return 0}function ss(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;l=r+16|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];if(!(t[a>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}if((t[o>>2]|0)<=0){t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}e:while(1){i=t[o>>2]|0;t[o>>2]=i+-1;if((i|0)<=0)break;if(!(n[t[c>>2]>>0]|0))break;i=t[c>>2]|0;t[c>>2]=i+1;e=n[i>>0]|0;n[l>>0]=e;if(!(e&128))continue;while(1){e=u[l>>0]<<1&255;n[l>>0]=e;if(!(e&128))continue e;t[c>>2]=(t[c>>2]|0)+1;if(!(u[t[c>>2]>>0]|0))continue e}}t[f>>2]=(t[c>>2]|0)-(t[a>>2]|0);b=t[f>>2]|0;s=r;return b|0}function bs(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;t[a>>2]=e;t[o>>2]=i;if((t[a>>2]|0)==0|(t[o>>2]|0)<0){t[u>>2]=0;b=t[u>>2]|0;s=r;return b|0}t[l>>2]=ss(t[a>>2]|0,t[o>>2]|0)|0;t[c>>2]=gAi[t[135752>>2]&511]((t[l>>2]|0)+1|0)|0;if(!(t[c>>2]|0)){i=t[33976]|0;e=t[33980]|0;t[f>>2]=(t[o>>2]|0)+1;yAi[i&511](e,138912,f);t[u>>2]=0;b=t[u>>2]|0;s=r;return b|0}else{YY(t[c>>2]|0,t[a>>2]|0,t[l>>2]|0)|0;n[(t[c>>2]|0)+(t[l>>2]|0)>>0]=0;t[u>>2]=t[c>>2];b=t[u>>2]|0;s=r;return b|0}return 0}function ks(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+16|0;f=r+8|0;a=r+4|0;o=r;c=r+12|0;t[a>>2]=e;t[o>>2]=i;do if(t[a>>2]|0){if((t[o>>2]|0)<0){t[f>>2]=0;break}e:while(1){i=t[o>>2]|0;t[o>>2]=i+-1;l=t[a>>2]|0;if(!i){b=14;break}t[a>>2]=l+1;i=n[l>>0]|0;n[c>>0]=i;if(!(i&255)){b=7;break}if(!((u[c>>0]|0)&128))continue;if(((u[c>>0]|0)&192|0)!=192){b=10;break}while(1){i=(u[c>>0]|0)<<1&255;n[c>>0]=i;if(!(i&128))continue e;i=t[a>>2]|0;t[a>>2]=i+1;if(((u[i>>0]|0)&192|0)!=128){b=13;break e}}}if((b|0)==7){t[f>>2]=0;break}else if((b|0)==10){t[f>>2]=0;break}else if((b|0)==13){t[f>>2]=0;break}else if((b|0)==14){t[f>>2]=l;break}}else t[f>>2]=0;while(0);s=r;return t[f>>2]|0}function hs(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;b=r+20|0;t[a>>2]=e;t[o>>2]=i;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}t[l>>2]=ss(t[o>>2]|0,1)|0;t[c>>2]=0;e:while(1){i=n[t[a>>2]>>0]|0;n[b>>0]=i;if(!(i&255)){h=14;break}if(!(Jl(t[a>>2]|0,t[o>>2]|0,t[l>>2]|0)|0)){h=6;break}t[a>>2]=(t[a>>2]|0)+1;i:do if((u[b>>0]|0)&128){if(((u[b>>0]|0)&192|0)!=192){h=9;break e}while(1){i=(u[b>>0]|0)<<1&255;n[b>>0]=i;if(!(i&128))break i;i=t[a>>2]|0;t[a>>2]=i+1;if(((u[i>>0]|0)&192|0)!=128){h=12;break e}}}while(0);t[c>>2]=(t[c>>2]|0)+1}if((h|0)==6){t[f>>2]=t[c>>2];k=t[f>>2]|0;s=r;return k|0}else if((h|0)==9){t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}else if((h|0)==12){t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}else if((h|0)==14){t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}return 0}function ws(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;k=f+20|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;do if(t[o>>2]|0){if((t[c>>2]|0)<0){t[a>>2]=0;break}if((t[l>>2]|0)<0){t[a>>2]=0;break}t[b>>2]=0;e:while(1){h=t[o>>2]|0;if((t[b>>2]|0)>=(t[c>>2]|0)){w=18;break}t[o>>2]=h+1;r=n[h>>0]|0;n[k>>0]=r;if(!(r&255)){w=10;break}i:do if((u[k>>0]|0)&128){if(((u[k>>0]|0)&192|0)!=192){w=13;break e}while(1){r=(u[k>>0]|0)<<1&255;n[k>>0]=r;if(!(r&128))break i;r=t[o>>2]|0;t[o>>2]=r+1;if(((u[r>>0]|0)&192|0)!=128){w=16;break e}}}while(0);t[b>>2]=(t[b>>2]|0)+1}if((w|0)==10){t[a>>2]=0;break}else if((w|0)==13){t[a>>2]=0;break}else if((w|0)==16){t[a>>2]=0;break}else if((w|0)==18){t[a>>2]=bs(h,t[l>>2]|0)|0;break}}else t[a>>2]=0;while(0);s=f;return t[a>>2]|0}function ds(){var e=0,i=0,r=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[r>>2]|0)){qs(0,138944);t[i>>2]=0;f=t[i>>2]|0;s=e;return f|0}t[(t[r>>2]|0)+4>>2]=0;t[(t[r>>2]|0)+20>>2]=0;t[(t[r>>2]|0)+32>>2]=0;t[(t[r>>2]|0)+28>>2]=0;t[(t[r>>2]|0)+24>>2]=t[33950];t[(t[r>>2]|0)+8>>2]=t[33950];t[(t[r>>2]|0)+12>>2]=t[33948];u=gAi[t[135752>>2]&511](t[(t[r>>2]|0)+24>>2]|0)|0;t[t[r>>2]>>2]=u;u=t[r>>2]|0;if(!(t[t[r>>2]>>2]|0)){qs(u,138944);pAi[t[135736>>2]&511](t[r>>2]|0);t[i>>2]=0;f=t[i>>2]|0;s=e;return f|0}else{n[t[u>>2]>>0]=0;t[(t[r>>2]|0)+16>>2]=0;t[i>>2]=t[r>>2];f=t[i>>2]|0;s=e;return f|0}return 0}function vs(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;u=i;t[f>>2]=e;t[u>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[u>>2]|0)){qs(0,138944);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[(t[u>>2]|0)+4>>2]=0;t[(t[u>>2]|0)+20>>2]=0;t[(t[u>>2]|0)+32>>2]=0;t[(t[u>>2]|0)+28>>2]=0;t[(t[u>>2]|0)+12>>2]=t[33948];if(t[f>>2]|0)o=(t[f>>2]|0)+2|0;else o=0;t[(t[u>>2]|0)+24>>2]=o;t[(t[u>>2]|0)+8>>2]=t[(t[u>>2]|0)+24>>2];do if(t[(t[u>>2]|0)+24>>2]|0){o=gAi[t[135752>>2]&511](t[(t[u>>2]|0)+24>>2]|0)|0;t[t[u>>2]>>2]=o;o=t[u>>2]|0;if(t[t[u>>2]>>2]|0){n[t[o>>2]>>0]=0;break}qs(o,138944);pAi[t[135736>>2]&511](t[u>>2]|0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}else t[t[u>>2]>>2]=0;while(0);t[(t[u>>2]|0)+16>>2]=0;t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}function ms(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;do if(t[n>>2]|0){if((t[(t[n>>2]|0)+12>>2]|0)==2){t[r>>2]=0;break}if(t[(t[n>>2]|0)+28>>2]|0){t[r>>2]=0;break}if(t[(t[n>>2]|0)+32>>2]|0){t[r>>2]=0;break}else{t[f>>2]=t[t[n>>2]>>2];t[t[n>>2]>>2]=0;t[(t[n>>2]|0)+24>>2]=0;t[(t[n>>2]|0)+20>>2]=0;t[(t[n>>2]|0)+4>>2]=0;t[(t[n>>2]|0)+8>>2]=0;t[r>>2]=t[f>>2];break}}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function _s(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[a>>2]|0)){qs(0,138944);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if((t[u>>2]|0)>>>0<2147483647){t[(t[a>>2]|0)+4>>2]=t[u>>2];t[(t[a>>2]|0)+8>>2]=t[u>>2]}else{t[(t[a>>2]|0)+4>>2]=2147483647;t[(t[a>>2]|0)+8>>2]=2147483647}t[(t[a>>2]|0)+20>>2]=t[u>>2];t[(t[a>>2]|0)+24>>2]=t[u>>2];t[(t[a>>2]|0)+12>>2]=2;
	t[t[a>>2]>>2]=t[f>>2];t[(t[a>>2]|0)+32>>2]=0;t[(t[a>>2]|0)+28>>2]=0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function ps(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0))t[r>>2]=-1;else t[r>>2]=t[(t[n>>2]|0)+12>>2];s=i;return t[r>>2]|0}function Es(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+12>>2]|0)!=2?(t[(t[f>>2]|0)+12>>2]|0)!=3:0){i=t[u>>2]|0;if((t[u>>2]|0)==0|(t[u>>2]|0)==1|(t[u>>2]|0)==4|(t[u>>2]|0)==2){t[(t[f>>2]|0)+12>>2]=i;if(t[(t[f>>2]|0)+28>>2]|0)t[(t[(t[f>>2]|0)+28>>2]|0)+12>>2]=t[u>>2];t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else{if((i|0)==3){t[(t[f>>2]|0)+12>>2]=3;t[(t[f>>2]|0)+16>>2]=t[t[f>>2]>>2]}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}function Ss(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+12>>2]|0)==3?(t[(t[r>>2]|0)+16>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);else n=5;if(((n|0)==5?(t[t[r>>2]>>2]|0)!=0:0)?(t[(t[r>>2]|0)+12>>2]|0)!=2:0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function gs(e){e=e|0;var i=0,r=0,f=0,u=0;i=s;s=s+16|0;r=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0){s=i;return}if(!(t[t[r>>2]>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+24>>2]|0)!=(t[(t[r>>2]|0)+8>>2]|0)?(t[(t[r>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[r>>2]|0)+24>>2]=t[(t[r>>2]|0)+8>>2];if((t[(t[r>>2]|0)+20>>2]|0)!=(t[(t[r>>2]|0)+4>>2]|0)?(t[(t[r>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[r>>2]|0)+20>>2]=t[(t[r>>2]|0)+4>>2];t[(t[r>>2]|0)+20>>2]=0;e=t[r>>2]|0;do if((t[(t[r>>2]|0)+12>>2]|0)==2)t[e>>2]=138960;else{if((t[e+12>>2]|0)==3?(t[(t[r>>2]|0)+16>>2]|0)!=0:0){t[f>>2]=(t[t[r>>2]>>2]|0)-(t[(t[r>>2]|0)+16>>2]|0);u=(t[r>>2]|0)+24|0;t[u>>2]=(t[u>>2]|0)+(t[f>>2]|0);t[t[r>>2]>>2]=t[(t[r>>2]|0)+16>>2];n[t[t[r>>2]>>2]>>0]=0;break}n[t[t[r>>2]>>2]>>0]=0}while(0);f=t[r>>2]|0;if((t[(t[r>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[r>>2]|0)+8>>2]=t[f+24>>2];else t[f+8>>2]=2147483647;f=t[r>>2]|0;if((t[(t[r>>2]|0)+20>>2]|0)>>>0<2147483647){t[(t[r>>2]|0)+4>>2]=t[f+20>>2];s=i;return}else{t[f+4>>2]=2147483647;s=i;return}}function ys(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]|0)==0:0){if((t[(t[u>>2]|0)+24>>2]|0)!=(t[(t[u>>2]|0)+8>>2]|0)?(t[(t[u>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+24>>2]=t[(t[u>>2]|0)+8>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=(t[(t[u>>2]|0)+4>>2]|0)?(t[(t[u>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+20>>2]=t[(t[u>>2]|0)+4>>2];if(!(t[a>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if((t[a>>2]|0)>>>0>(t[(t[u>>2]|0)+20>>2]|0)>>>0){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}i=(t[u>>2]|0)+20|0;t[i>>2]=(t[i>>2]|0)-(t[a>>2]|0);do if((t[(t[u>>2]|0)+12>>2]|0)==2)l=17;else{if((t[(t[u>>2]|0)+12>>2]|0)==3?(t[(t[u>>2]|0)+16>>2]|0)!=0:0){l=17;break}GY(t[t[u>>2]>>2]|0,(t[t[u>>2]>>2]|0)+(t[a>>2]|0)|0,t[(t[u>>2]|0)+20>>2]|0)|0;n[(t[t[u>>2]>>2]|0)+(t[(t[u>>2]|0)+20>>2]|0)>>0]=0}while(0);if((((l|0)==17?(l=t[u>>2]|0,t[l>>2]=(t[l>>2]|0)+(t[a>>2]|0),l=(t[u>>2]|0)+24|0,t[l>>2]=(t[l>>2]|0)-(t[a>>2]|0),(t[(t[u>>2]|0)+12>>2]|0)==3):0)?(t[(t[u>>2]|0)+16>>2]|0)!=0:0)?(t[o>>2]=(t[t[u>>2]>>2]|0)-(t[(t[u>>2]|0)+16>>2]|0),(t[o>>2]|0)>>>0>=(t[(t[u>>2]|0)+24>>2]|0)>>>0):0){GY(t[(t[u>>2]|0)+16>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0;t[t[u>>2]>>2]=t[(t[u>>2]|0)+16>>2];n[(t[t[u>>2]>>2]|0)+(t[(t[u>>2]|0)+20>>2]|0)>>0]=0;l=(t[u>>2]|0)+24|0;t[l>>2]=(t[l>>2]|0)+(t[o>>2]|0)}o=t[u>>2]|0;if((t[(t[u>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+8>>2]=t[o+24>>2];else t[o+8>>2]=2147483647;o=t[u>>2]|0;if((t[(t[u>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+4>>2]=t[o+20>>2];else t[o+4>>2]=2147483647;t[f>>2]=t[a>>2];c=t[f>>2]|0;s=r;return c|0}t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}function Fs(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if(!((t[f>>2]|0)==0|(t[u>>2]|0)<0)){if(!(t[u>>2]|0)){t[n>>2]=0;break}t[a>>2]=Ys(t[f>>2]|0,t[u>>2]|0)|0;if(t[(t[f>>2]|0)+32>>2]|0){t[n>>2]=-1;break}else{t[n>>2]=t[a>>2];break}}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function Os(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)==0:0){t[r>>2]=t[t[n>>2]>>2];f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function As(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)==0:0){if((t[(t[n>>2]|0)+24>>2]|0)!=(t[(t[n>>2]|0)+8>>2]|0)?(t[(t[n>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+24>>2]=t[(t[n>>2]|0)+8>>2];if((t[(t[n>>2]|0)+20>>2]|0)!=(t[(t[n>>2]|0)+4>>2]|0)?(t[(t[n>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+20>>2]=t[(t[n>>2]|0)+4>>2];t[r>>2]=(t[t[n>>2]>>2]|0)+(t[(t[n>>2]|0)+20>>2]|0);f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function Ms(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;f=r+8|0;u=r+4|0;a=r;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]|0)==0:0){if((t[(t[u>>2]|0)+24>>2]|0)!=(t[(t[u>>2]|0)+8>>2]|0)?(t[(t[u>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+24>>2]=t[(t[u>>2]|0)+8>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=(t[(t[u>>2]|0)+4>>2]|0)?(t[(t[u>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+20>>2]=t[(t[u>>2]|0)+4>>2];if((t[a>>2]|0)>>>0>((t[(t[u>>2]|0)+24>>2]|0)-(t[(t[u>>2]|0)+20>>2]|0)|0)>>>0){t[f>>2]=-1;o=t[f>>2]|0;s=r;return o|0}i=(t[u>>2]|0)+20|0;t[i>>2]=(t[i>>2]|0)+(t[a>>2]|0);a=t[u>>2]|0;if((t[(t[u>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+8>>2]=t[a+24>>2];else t[a+8>>2]=2147483647;a=t[u>>2]|0;if((t[(t[u>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+4>>2]=t[a+20>>2];else t[a+4>>2]=2147483647;if((t[(t[u>>2]|0)+24>>2]|0)>>>0>(t[(t[u>>2]|0)+20>>2]|0)>>>0){n[(t[t[u>>2]>>2]|0)+(t[(t[u>>2]|0)+20>>2]|0)>>0]=0;t[f>>2]=0;o=t[f>>2]|0;s=r;return o|0}else{t[f>>2]=-1;o=t[f>>2]|0;s=r;return o|0}}t[f>>2]=-1;o=t[f>>2]|0;s=r;return o|0}function Rs(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;f=r+8|0;u=r+4|0;a=r;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]|0)==0:0){if((t[(t[u>>2]|0)+24>>2]|0)!=(t[(t[u>>2]|0)+8>>2]|0)?(t[(t[u>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+24>>2]=t[(t[u>>2]|0)+8>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=(t[(t[u>>2]|0)+4>>2]|0)?(t[(t[u>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+20>>2]=t[(t[u>>2]|0)+4>>2];if((t[a>>2]|0)>>>0>(t[(t[u>>2]|0)+20>>2]|0)>>>0){t[f>>2]=-1;o=t[f>>2]|0;s=r;return o|0}i=(t[u>>2]|0)+20|0;t[i>>2]=(t[i>>2]|0)-(t[a>>2]|0);n[(t[t[u>>2]>>2]|0)+(t[(t[u>>2]|0)+20>>2]|0)>>0]=0;a=t[u>>2]|0;if((t[(t[u>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+8>>2]=t[a+24>>2];else t[a+8>>2]=2147483647;a=t[u>>2]|0;if((t[(t[u>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+4>>2]=t[a+20>>2];else t[a+4>>2]=2147483647;t[f>>2]=0;o=t[f>>2]|0;s=r;return o|0}t[f>>2]=-1;o=t[f>>2]|0;s=r;return o|0}function Ns(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)==0:0){if((t[(t[n>>2]|0)+24>>2]|0)!=(t[(t[n>>2]|0)+8>>2]|0)?(t[(t[n>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+24>>2]=t[(t[n>>2]|0)+8>>2];if((t[(t[n>>2]|0)+20>>2]|0)!=(t[(t[n>>2]|0)+4>>2]|0)?(t[(t[n>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+20>>2]=t[(t[n>>2]|0)+4>>2];t[r>>2]=t[(t[n>>2]|0)+20>>2];f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function Ts(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)==0:0){if((t[(t[n>>2]|0)+24>>2]|0)!=(t[(t[n>>2]|0)+8>>2]|0)?(t[(t[n>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+24>>2]=t[(t[n>>2]|0)+8>>2];if((t[(t[n>>2]|0)+20>>2]|0)!=(t[(t[n>>2]|0)+4>>2]|0)?(t[(t[n>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+20>>2]=t[(t[n>>2]|0)+4>>2];t[r>>2]=t[(t[n>>2]|0)+20>>2];f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function Ls(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)==0:0){if((t[(t[n>>2]|0)+24>>2]|0)!=(t[(t[n>>2]|0)+8>>2]|0)?(t[(t[n>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+24>>2]=t[(t[n>>2]|0)+8>>2];if((t[(t[n>>2]|0)+20>>2]|0)!=(t[(t[n>>2]|0)+4>>2]|0)?(t[(t[n>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+20>>2]=t[(t[n>>2]|0)+4>>2];t[r>>2]=(t[(t[n>>2]|0)+24>>2]|0)-(t[(t[n>>2]|0)+20>>2]|0);f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function Ds(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)==0:0){if((t[(t[n>>2]|0)+24>>2]|0)!=(t[(t[n>>2]|0)+8>>2]|0)?(t[(t[n>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+24>>2]=t[(t[n>>2]|0)+8>>2];if((t[(t[n>>2]|0)+20>>2]|0)!=(t[(t[n>>2]|0)+4>>2]|0)?(t[(t[n>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[n>>2]|0)+20>>2]=t[(t[n>>2]|0)+4>>2];t[r>>2]=(t[(t[n>>2]|0)+20>>2]|0)==0&1;f=t[r>>2]|0;s=i;return f|0}t[r>>2]=-1;f=t[r>>2]|0;s=i;return f|0}function Cs(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[u>>2]=e;t[a>>2]=i;t[c>>2]=0;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]|0)==0:0){if((t[(t[u>>2]|0)+24>>2]|0)!=(t[(t[u>>2]|0)+8>>2]|0)?(t[(t[u>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+24>>2]=t[(t[u>>2]|0)+8>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=(t[(t[u>>2]|0)+4>>2]|0)?(t[(t[u>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+20>>2]=t[(t[u>>2]|0)+4>>2];if((t[(t[u>>2]|0)+12>>2]|0)==2){t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}if((t[a>>2]|0)>>>0<(t[(t[u>>2]|0)+24>>2]|0)>>>0){t[f>>2]=1;b=t[f>>2]|0;s=r;return b|0}i=t[(t[u>>2]|0)+12>>2]|0;e:do if((i|0)==4){if((t[(t[u>>2]|0)+20>>2]|0)>>>0<4096){t[o>>2]=t[a>>2];break}t[o>>2]=t[(t[u>>2]|0)+24>>2]<<1;while(1){if((t[a>>2]|0)>>>0<=(t[o>>2]|0)>>>0)break e;if((t[o>>2]|0)>>>0>2147483647)break;t[o>>2]=t[o>>2]<<1}qs(t[u>>2]|0,138968);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else if((i|0)==0|(i|0)==3){if(t[(t[u>>2]|0)+24>>2]|0)k=t[(t[u>>2]|0)+24>>2]<<1;else k=(t[a>>2]|0)+10|0;t[o>>2]=k;while(1){if((t[a>>2]|0)>>>0<=(t[o>>2]|0)>>>0)break e;if((t[o>>2]|0)>>>0>2147483647)break;t[o>>2]=t[o>>2]<<1}qs(t[u>>2]|0,138968);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else if((i|0)==1)t[o>>2]=(t[a>>2]|0)+10;else t[o>>2]=(t[a>>2]|0)+10;while(0);do if((t[(t[u>>2]|0)+12>>2]|0)==3?(t[(t[u>>2]|0)+16>>2]|0)!=0:0){t[l>>2]=(t[t[u>>2]>>2]|0)-(t[(t[u>>2]|0)+16>>2]|0);if((t[l>>2]|0)>>>0>(t[o>>2]|0)>>>0){GY(t[(t[u>>2]|0)+16>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0;t[t[u>>2]>>2]=t[(t[u>>2]|0)+16>>2];n[(t[t[u>>2]>>2]|0)+(t[(t[u>>2]|0)+20>>2]|0)>>0]=0;a=(t[u>>2]|0)+24|0;t[a>>2]=(t[a>>2]|0)+(t[l>>2]|0);break}t[c>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+16>>2]|0,(t[l>>2]|0)+(t[o>>2]|0)|0)|0;if(t[c>>2]|0){t[(t[u>>2]|0)+16>>2]=t[c>>2];t[t[u>>2]>>2]=(t[c>>2]|0)+(t[l>>2]|0);break}qs(t[u>>2]|0,138968);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else h=39;while(0);do if((h|0)==39){do if(t[t[u>>2]>>2]|0){if(((t[(t[u>>2]|0)+24>>2]|0)-(t[(t[u>>2]|0)+20>>2]|0)|0)>>>0<100){t[c>>2]=MAi[t[135760>>2]&511](t[t[u>>2]>>2]|0,t[o>>2]|0)|0;break}t[c>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;if(t[c>>2]|0){YY(t[c>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0;pAi[t[135736>>2]&511](t[t[u>>2]>>2]|0);n[(t[c>>2]|0)+(t[(t[u>>2]|0)+20>>2]|0)>>0]=0}}else t[c>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;while(0);if(t[c>>2]|0){t[t[u>>2]>>2]=t[c>>2];break}qs(t[u>>2]|0,138968);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}while(0);t[(t[u>>2]|0)+24>>2]=t[o>>2];o=t[u>>2]|0;if((t[(t[u>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+8>>2]=t[o+24>>2];else t[o+8>>2]=2147483647;o=t[u>>2]|0;if((t[(t[u>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+4>>2]=t[o+20>>2];else t[o+4>>2]=2147483647;t[f>>2]=1;b=t[f>>2]|0;s=r;return b|0}t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}function Ps(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if(!((t[o>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+32>>2]|0)==0:0){if((t[(t[a>>2]|0)+24>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0)?(t[(t[a>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[a>>2]|0)+24>>2]=t[(t[a>>2]|0)+8>>2];if((t[(t[a>>2]|0)+20>>2]|0)!=(t[(t[a>>2]|0)+4>>2]|0)?(t[(t[a>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[a>>2]|0)+20>>2]=t[(t[a>>2]|0)+4>>2];if((t[(t[a>>2]|0)+12>>2]|0)==2){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if((t[c>>2]|0)<-1){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if(!(t[c>>2]|0)){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}if((t[c>>2]|0)<0)t[c>>2]=rs(t[o>>2]|0)|0;if((t[c>>2]|0)<0){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if(!(t[c>>2]|0)){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}t[l>>2]=(t[(t[a>>2]|0)+20>>2]|0)+(t[c>>2]|0)+2;if((t[l>>2]|0)>>>0>(t[(t[a>>2]|0)+24>>2]|0)>>>0?(Cs(t[a>>2]|0,t[l>>2]|0)|0)==0:0){qs(t[a>>2]|0,138968);t[u>>2]=2;b=t[u>>2]|0;s=f;return b|0}GY((t[t[a>>2]>>2]|0)+(t[(t[a>>2]|0)+20>>2]|0)|0,t[o>>2]|0,t[c>>2]|0)|0;o=(t[a>>2]|0)+20|0;t[o>>2]=(t[o>>2]|0)+(t[c>>2]|0);n[(t[t[a>>2]>>2]|0)+(t[(t[a>>2]|0)+20>>2]|0)>>0]=0;c=t[a>>2]|0;if((t[(t[a>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[a>>2]|0)+8>>2]=t[c+24>>2];else t[c+8>>2]=2147483647;c=t[a>>2]|0;if((t[(t[a>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[a>>2]|0)+4>>2]=t[c+20>>2];else t[c+4>>2]=2147483647;t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}function Bs(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+32>>2]|0)==0:0){if((t[(t[a>>2]|0)+24>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0)?(t[(t[a>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[a>>2]|0)+24>>2]=t[(t[a>>2]|0)+8>>2];if((t[(t[a>>2]|0)+20>>2]|0)!=(t[(t[a>>2]|0)+4>>2]|0)?(t[(t[a>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[a>>2]|0)+20>>2]=t[(t[a>>2]|0)+4>>2];if((t[(t[a>>2]|0)+12>>2]|0)==2){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if(!(t[o>>2]|0)){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if((t[c>>2]|0)<-1){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if(!(t[c>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if((t[c>>2]|0)<0)t[c>>2]=rs(t[o>>2]|0)|0;if((t[c>>2]|0)<=0){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if(((t[(t[a>>2]|0)+12>>2]|0)==3?(t[(t[a>>2]|0)+16>>2]|0)!=0:0)?(t[b>>2]=(t[t[a>>2]>>2]|0)-(t[(t[a>>2]|0)+16>>2]|0),(t[b>>2]|0)>>>0>(t[c>>2]|0)>>>0):0){b=t[a>>2]|0;t[b>>2]=(t[b>>2]|0)+(0-(t[c>>2]|0));GY(t[t[a>>2]>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;b=(t[a>>2]|0)+20|0;t[b>>2]=(t[b>>2]|0)+(t[c>>2]|0);b=(t[a>>2]|0)+24|0;t[b>>2]=(t[b>>2]|0)+(t[c>>2]|0);b=t[a>>2]|0;if((t[(t[a>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[a>>2]|0)+8>>2]=t[b+24>>2];else t[b+8>>2]=2147483647;b=t[a>>2]|0;if((t[(t[a>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[a>>2]|0)+4>>2]=t[b+20>>2];else t[b+4>>2]=2147483647;t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[l>>2]=(t[(t[a>>2]|0)+20>>2]|0)+(t[c>>2]|0)+2;if((t[l>>2]|0)>>>0>(t[(t[a>>2]|0)+24>>2]|0)>>>0?(Cs(t[a>>2]|0,t[l>>2]|0)|0)==0:0){qs(t[a>>2]|0,138968);t[u>>2]=2;k=t[u>>2]|0;s=f;return k|0}GY((t[t[a>>2]>>2]|0)+(t[c>>2]|0)|0,t[t[a>>2]>>2]|0,t[(t[a>>2]|0)+20>>2]|0)|0;GY(t[t[a>>2]>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;o=(t[a>>2]|0)+20|0;t[o>>2]=(t[o>>2]|0)+(t[c>>2]|0);n[(t[t[a>>2]>>2]|0)+(t[(t[a>>2]|0)+20>>2]|0)>>0]=0;c=t[a>>2]|0;if((t[(t[a>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[a>>2]|0)+8>>2]=t[c+24>>2];else t[c+8>>2]=2147483647;c=t[a>>2]|0;if((t[(t[a>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[a>>2]|0)+4>>2]=t[c+20>>2];else t[c+4>>2]=2147483647;t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}function Is(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+24>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)?(t[(t[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+24>>2]=t[(t[f>>2]|0)+8>>2];if((t[(t[f>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+4>>2]|0)?(t[(t[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+20>>2]=t[(t[f>>2]|0)+4>>2];if((t[(t[f>>2]|0)+12>>2]|0)==2){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if(!(t[u>>2]|0)){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=Ps(t[f>>2]|0,t[u>>2]|0,-1)|0;a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}function Hs(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]|0)==0:0){if((t[(t[u>>2]|0)+24>>2]|0)!=(t[(t[u>>2]|0)+8>>2]|0)?(t[(t[u>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+24>>2]=t[(t[u>>2]|0)+8>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=(t[(t[u>>2]|0)+4>>2]|0)?(t[(t[u>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[u>>2]|0)+20>>2]=t[(t[u>>2]|0)+4>>2];if((t[(t[u>>2]|0)+12>>2]|0)==2){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}if(!(t[a>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=t[a>>2];while(1){l=t[(t[u>>2]|0)+20>>2]|0;if(!(n[t[o>>2]>>0]|0))break;if((l+10|0)>>>0>=(t[(t[u>>2]|0)+24>>2]|0)>>>0?(Cs(t[u>>2]|0,(t[(t[u>>2]|0)+20>>2]|0)+10|0)|0)==0:0){b=18;break}a=n[t[o>>2]>>0]|0;i=(t[u>>2]|0)+20|0;e=t[i>>2]|0;t[i>>2]=e+1;n[(t[t[u>>2]>>2]|0)+e>>0]=a;t[o>>2]=(t[o>>2]|0)+1}if((b|0)==18){qs(t[u>>2]|0,138968);t[f>>2]=2;c=t[f>>2]|0;s=r;return c|0}n[(t[t[u>>2]>>2]|0)+l>>0]=0;l=t[u>>2]|0;if((t[(t[u>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+8>>2]=t[l+24>>2];else t[l+8>>2]=2147483647;l=t[u>>2]|0;if((t[(t[u>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[u>>2]|0)+4>>2]=t[l+20>>2];else t[l+4>>2]=2147483647;t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}function xs(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+24>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)?(t[(t[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+24>>2]=t[(t[f>>2]|0)+8>>2];if((t[(t[f>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+4>>2]|0)?(t[(t[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+20>>2]=t[(t[f>>2]|0)+4>>2];if((t[(t[f>>2]|0)+12>>2]|0)==2){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}do if(es(t[a>>2]|0,34)|0){i=(es(t[a>>2]|0,39)|0)!=0;e=t[f>>2]|0;if(!i){Hs(e,139e3)|0;Is(t[f>>2]|0,t[a>>2]|0)|0;Hs(t[f>>2]|0,139e3)|0;break}Hs(e,138984)|0;e=t[a>>2]|0;t[o>>2]=e;t[c>>2]=e;while(1){if(!(u[t[o>>2]>>0]|0))break;if((u[t[o>>2]>>0]|0|0)!=34){t[o>>2]=(t[o>>2]|0)+1;continue}if((t[c>>2]|0)!=(t[o>>2]|0))Ps(t[f>>2]|0,t[c>>2]|0,(t[o>>2]|0)-(t[c>>2]|0)|0)|0;Ps(t[f>>2]|0,138992,6)|0;t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=t[o>>2]}if((t[c>>2]|0)!=(t[o>>2]|0))Ps(t[f>>2]|0,t[c>>2]|0,(t[o>>2]|0)-(t[c>>2]|0)|0)|0;Hs(t[f>>2]|0,138984)|0}else{Hs(t[f>>2]|0,138984)|0;Is(t[f>>2]|0,t[a>>2]|0)|0;Hs(t[f>>2]|0,138984)|0}while(0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}function Us(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+24>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)?(t[(t[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+24>>2]=t[(t[f>>2]|0)+8>>2];if((t[(t[f>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+4>>2]|0)?(t[(t[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+20>>2]=t[(t[f>>2]|0)+4>>2];if(((t[u>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)>>>0>0:0)t[a>>2]=Ps(t[f>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0;yF(t[u>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}yF(t[u>>2]|0);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}function zs(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!((t[u>>2]|0)==0|(t[f>>2]|0)==0)?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+24>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)?(t[(t[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+24>>2]=t[(t[f>>2]|0)+8>>2];if((t[(t[f>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+4>>2]|0)?(t[(t[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+20>>2]=t[(t[f>>2]|0)+4>>2];i=t[t[f>>2]>>2]|0;t[(t[u>>2]|0)+16>>2]=i;t[(t[u>>2]|0)+12>>2]=i;t[(t[u>>2]|0)+20>>2]=(t[t[f>>2]>>2]|0)+(t[(t[f>>2]|0)+20>>2]|0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}function js(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!((t[u>>2]|0)==0|(t[f>>2]|0)==0)?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+24>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)?(t[(t[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+24>>2]=t[(t[f>>2]|0)+8>>2];if((t[(t[f>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+4>>2]|0)?(t[(t[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+20>>2]=t[(t[f>>2]|0)+4>>2];t[a>>2]=(t[(t[u>>2]|0)+12>>2]|0)-(t[t[f>>2]>>2]|0);if((t[a>>2]|0)>>>0>(t[(t[f>>2]|0)+24>>2]|0)>>>0){Gs(t[f>>2]|0,139008);t[a>>2]=0}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}function Vs(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!((t[o>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[a>>2]|0)+32>>2]|0)==0:0){if((t[(t[a>>2]|0)+24>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0)?(t[(t[a>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[a>>2]|0)+24>>2]=t[(t[a>>2]|0)+8>>2];if((t[(t[a>>2]|0)+20>>2]|0)!=(t[(t[a>>2]|0)+4>>2]|0)?(t[(t[a>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[a>>2]|0)+20>>2]=t[(t[a>>2]|0)+4>>2];t[(t[o>>2]|0)+12>>2]=(t[t[a>>2]>>2]|0)+(t[c>>2]|0);t[(t[o>>2]|0)+16>>2]=(t[(t[o>>2]|0)+12>>2]|0)+(t[l>>2]|0);t[(t[o>>2]|0)+20>>2]=(t[t[a>>2]>>2]|0)+(t[(t[a>>2]|0)+20>>2]|0);t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}function qs(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;dp(29,2,0,0,t[f>>2]|0);if(!(t[n>>2]|0)){s=r;return}if(t[(t[n>>2]|0)+32>>2]|0){s=r;return}t[(t[n>>2]|0)+32>>2]=2;s=r;return}function Ys(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+32>>2]|0)==0:0){if((t[(t[f>>2]|0)+24>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)?(t[(t[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+24>>2]=t[(t[f>>2]|0)+8>>2];if((t[(t[f>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+4>>2]|0)?(t[(t[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)t[(t[f>>2]|0)+20>>2]=t[(t[f>>2]|0)+4>>2];if((t[(t[f>>2]|0)+12>>2]|0)==2){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}i=t[(t[f>>2]|0)+24>>2]|0;if(((t[(t[f>>2]|0)+20>>2]|0)+(t[u>>2]|0)|0)>>>0<(t[(t[f>>2]|0)+24>>2]|0)>>>0){t[n>>2]=i-(t[(t[f>>2]|0)+20>>2]|0);l=t[n>>2]|0;s=r;return l|0}e=t[f>>2]|0;if(i>>>0>(t[u>>2]|0)>>>0)t[a>>2]=t[e+24>>2]<<1;else t[a>>2]=(t[e+20>>2]|0)+(t[u>>2]|0)+100;do if((t[(t[f>>2]|0)+12>>2]|0)==3?(t[(t[f>>2]|0)+16>>2]|0)!=0:0){t[c>>2]=(t[t[f>>2]>>2]|0)-(t[(t[f>>2]|0)+16>>2]|0);t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+16>>2]|0,(t[c>>2]|0)+(t[a>>2]|0)|0)|0;if(t[o>>2]|0){t[(t[f>>2]|0)+16>>2]=t[o>>2];t[t[f>>2]>>2]=(t[o>>2]|0)+(t[c>>2]|0);break}qs(t[f>>2]|0,138968);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else b=22;while(0);do if((b|0)==22){t[o>>2]=MAi[t[135760>>2]&511](t[t[f>>2]>>2]|0,t[a>>2]|0)|0;if(t[o>>2]|0){t[t[f>>2]>>2]=t[o>>2];break}qs(t[f>>2]|0,138968);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}while(0);t[(t[f>>2]|0)+24>>2]=t[a>>2];a=t[f>>2]|0;if((t[(t[f>>2]|0)+24>>2]|0)>>>0<2147483647)t[(t[f>>2]|0)+8>>2]=t[a+24>>2];else t[a+8>>2]=2147483647;a=t[f>>2]|0;if((t[(t[f>>2]|0)+20>>2]|0)>>>0<2147483647)t[(t[f>>2]|0)+4>>2]=t[a+20>>2];else t[a+4>>2]=2147483647;t[n>>2]=(t[(t[f>>2]|0)+24>>2]|0)-(t[(t[f>>2]|0)+20>>2]|0);l=t[n>>2]|0;s=r;return l|0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function Gs(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;dp(29,7e3,0,0,t[f>>2]|0);if(!(t[n>>2]|0)){s=r;return}if(t[(t[n>>2]|0)+32>>2]|0){s=r;return}t[(t[n>>2]|0)+32>>2]=7e3;s=r;return}function Ws(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+40>>2]|0)==0?(t[(t[u>>2]|0)+8>>2]|0)==0:0){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=gAi[t[135744>>2]&511](92)|0;if(!(t[c>>2]|0)){Eb(0,139048);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=(t[c>>2]|0)+0|0;i=r+92|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[c>>2]|0)+64>>2]=0;t[(t[c>>2]|0)+56>>2]=0;t[(t[c>>2]|0)+4>>2]=1;t[(t[c>>2]|0)+32>>2]=0;t[(t[c>>2]|0)+36>>2]=0;t[(t[c>>2]|0)+40>>2]=0;t[t[c>>2]>>2]=0;t[(t[c>>2]|0)+8>>2]=t[u>>2];if(!(t[(t[u>>2]|0)+40>>2]|0))t[(t[c>>2]|0)+20>>2]=t[t[(t[u>>2]|0)+8>>2]>>2];t[(t[c>>2]|0)+24>>2]=0;t[(t[c>>2]|0)+28>>2]=0;t[(t[c>>2]|0)+12>>2]=t[a>>2];t[(t[c>>2]|0)+16>>2]=t[o>>2];do if((t[(t[u>>2]|0)+20>>2]|0)>0){o=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+20>>2]<<2<<1)|0;t[(t[c>>2]|0)+44>>2]=o;if(t[(t[c>>2]|0)+44>>2]|0){VY(t[(t[c>>2]|0)+44>>2]|0,0,t[(t[u>>2]|0)+20>>2]<<2<<1|0)|0;t[(t[c>>2]|0)+84>>2]=(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[u>>2]|0)+20>>2]<<2);break}Eb(0,139048);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[(t[c>>2]|0)+44>>2]=0;t[(t[c>>2]|0)+84>>2]=0}while(0);t[(t[c>>2]|0)+48>>2]=0;t[(t[c>>2]|0)+52>>2]=0;t[(t[c>>2]|0)+68>>2]=0;t[(t[c>>2]|0)+72>>2]=-1;t[(t[c>>2]|0)+80>>2]=0;t[(t[c>>2]|0)+88>>2]=0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function Ks(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+40>>2]|0){e:do if(t[(t[r>>2]|0)+44>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+32>>2]|0))break e;if(t[(t[(t[r>>2]|0)+40>>2]|0)+(t[n>>2]<<4)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[r>>2]|0)+40>>2]|0)+(t[n>>2]<<4)+12>>2]|0);t[n>>2]=(t[n>>2]|0)+1}}while(0);pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0)}if(t[(t[r>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+44>>2]|0);if(t[(t[r>>2]|0)+68>>2]|0){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[r>>2]|0)+52>>2]|0))break;if(t[(t[(t[r>>2]|0)+68>>2]|0)+(t[f>>2]<<3)>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[r>>2]|0)+68>>2]|0)+(t[f>>2]<<3)>>2]|0);t[f>>2]=(t[f>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+68>>2]|0)}if(t[(t[r>>2]|0)+80>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+80>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Xs(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=Sb(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0)|0;s=n;return r|0}function Zs(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+192|0;a=u+32|0;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+36|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;if(!(t[o>>2]|0)){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(!(t[(t[o>>2]|0)+8>>2]|0)){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(t[t[o>>2]>>2]|0){t[a>>2]=t[t[o>>2]>>2];m=t[a>>2]|0;s=u;return m|0}if(!(t[l>>2]|0)){t[a>>2]=Xs(t[o>>2]|0,t[c>>2]|0,t[b>>2]|0)|0;m=t[a>>2]|0;s=u;return m|0}t[h>>2]=HY(t[l>>2]|0)|0;t[w>>2]=HY(t[c>>2]|0)|0;if(150<((t[h>>2]|0)+(t[w>>2]|0)+2|0)){t[v>>2]=gAi[t[135752>>2]&511]((t[h>>2]|0)+(t[w>>2]|0)+2|0)|0;if(!(t[v>>2]|0)){t[t[o>>2]>>2]=-1;t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}}else t[v>>2]=k;YY(t[v>>2]|0,t[c>>2]|0,t[w>>2]|0)|0;n[(t[v>>2]|0)+(t[w>>2]|0)>>0]=124;YY((t[v>>2]|0)+((t[w>>2]|0)+1)|0,t[l>>2]|0,t[h>>2]|0)|0;n[(t[v>>2]|0)+((t[h>>2]|0)+(t[w>>2]|0)+1)>>0]=0;w=t[o>>2]|0;if(t[(t[(t[o>>2]|0)+8>>2]|0)+40>>2]|0)t[d>>2]=gb(w,t[(t[o>>2]|0)+8>>2]|0,t[v>>2]|0,t[b>>2]|0)|0;else t[d>>2]=Sb(w,t[v>>2]|0,t[b>>2]|0,1)|0;if((t[v>>2]|0)!=(k|0))pAi[t[135736>>2]&511](t[v>>2]|0);t[a>>2]=t[d>>2];m=t[a>>2]|0;s=u;return m|0}function Js(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0;u=s;s=s+32|0;a=u+16|0;o=u+12|0;c=u+8|0;l=u+4|0;b=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;f=yb(t[a>>2]|0,0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;s=u;return f|0}function Qs(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(!(t[c>>2]|0)){t[o>>2]=-1;d=t[o>>2]|0;s=a;return d|0}do if(t[l>>2]|0)if(t[t[c>>2]>>2]|0){t[t[l>>2]>>2]=t[(t[c>>2]|0)+80>>2];break}else{t[t[l>>2]>>2]=0;break}while(0);t[o>>2]=yb(t[c>>2]|0,1,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;d=t[o>>2]|0;s=a;return d|0}function $s(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[a>>2]=Fb(t[n>>2]|0)|0;if(!(t[a>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[(t[a>>2]|0)+20>>2]=0;n=Ob(t[a>>2]|0)|0;t[(t[a>>2]|0)+24>>2]=n;t[(t[a>>2]|0)+16>>2]=n;Ab(t[a>>2]|0,t[(t[a>>2]|0)+16>>2]|0)|0;Mb(t[a>>2]|0,1);if(u[t[(t[a>>2]|0)+4>>2]>>0]|0){t[(t[a>>2]|0)+8>>2]=1450;Rb(t[a>>2]|0,139080)}n=t[a>>2]|0;if(t[(t[a>>2]|0)+8>>2]|0){Nb(n);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[(t[a>>2]|0)+20>>2]=t[n+24>>2];t[t[(t[a>>2]|0)+16>>2]>>2]=1;t[t[(t[a>>2]|0)+20>>2]>>2]=2;Tb(t[a>>2]|0);n=t[a>>2]|0;if(t[(t[a>>2]|0)+8>>2]|0){Nb(n);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}else{t[f>>2]=Lb(n)|0;Nb(t[a>>2]|0);t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}return 0}function eb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=Db(t[f>>2]|0,t[u>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}return 0}function ib(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}if((t[(t[n>>2]|0)+28>>2]|0)!=-1){t[r>>2]=t[(t[n>>2]|0)+28>>2];o=t[r>>2]|0;s=i;return o|0}t[f>>2]=rb()|0;if(t[(t[f>>2]|0)+52>>2]|0){t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[f>>2]|0)+48>>2]|0))break;Cb(t[(t[(t[f>>2]|0)+52>>2]|0)+(t[a>>2]<<2)>>2]|0);t[a>>2]=(t[a>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[f>>2]|0)+52>>2]|0)}t[(t[f>>2]|0)+36>>2]=t[(t[n>>2]|0)+12>>2];t[(t[f>>2]|0)+40>>2]=t[(t[n>>2]|0)+16>>2];t[(t[f>>2]|0)+48>>2]=t[(t[n>>2]|0)+4>>2];t[(t[f>>2]|0)+52>>2]=t[(t[n>>2]|0)+8>>2];t[(t[f>>2]|0)+68>>2]=-1;t[(t[f>>2]|0)+76>>2]=t[(t[n>>2]|0)+32>>2];t[u>>2]=Pb(t[f>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=0;t[(t[f>>2]|0)+52>>2]=0;nb(t[f>>2]|0);t[(t[n>>2]|0)+28>>2]=t[u>>2];t[r>>2]=t[u>>2];o=t[r>>2]|0;s=i;return o|0}function rb(){var e=0,i=0,r=0,n=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=Fb(0)|0;if(!(t[r>>2]|0)){t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}t[(t[r>>2]|0)+20>>2]=0;f=Ob(t[r>>2]|0)|0;t[(t[r>>2]|0)+24>>2]=f;t[(t[r>>2]|0)+16>>2]=f;f=t[r>>2]|0;if(!(t[(t[r>>2]|0)+16>>2]|0)){nb(f);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}t[t[f+16>>2]>>2]=1;f=(Ab(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0)|0)<0;u=t[r>>2]|0;if(f){Cb(t[u+16>>2]|0);nb(t[r>>2]|0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{t[u+76>>2]=0;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function nb(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}Nb(t[r>>2]|0);s=i;return}function fb(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+4>>2]|0))break;Cb(t[(t[(t[r>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}if(t[(t[r>>2]|0)+16>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+12>>2]|0))break;Bb(t[(t[(t[r>>2]|0)+16>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0)}if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+40>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0);if(t[(t[r>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+44>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0){t[n>>2]=0;while(1){f=t[33934]|0;if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;pAi[f&511](t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[f&511](t[(t[r>>2]|0)+52>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function tb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}i=(t[n>>2]|0)+76|0;t[i>>2]=t[i>>2]|t[f>>2];s=r;return}function ub(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0))t[r>>2]=0;else t[r>>2]=t[(t[n>>2]|0)+16>>2];s=i;return t[r>>2]|0}function ab(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{t[t[u>>2]>>2]=2;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}return 0}function ob(e,i,r,n,f){e=e|0;i=i|0;r=r|0;
	n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[b>>2]|0)==0){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}t[h>>2]=Ib(t[o>>2]|0,5)|0;if(!(t[h>>2]|0)){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}t[(t[h>>2]|0)+60>>2]=t[k>>2];k=Yl(t[b>>2]|0)|0;t[(t[h>>2]|0)+20>>2]=k;if((Hb(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[h>>2]|0)|0)<0){Bb(t[h>>2]|0);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}if(!(t[l>>2]|0)){t[a>>2]=t[(t[o>>2]|0)+24>>2];w=t[a>>2]|0;s=u;return w|0}else{t[a>>2]=t[l>>2];w=t[a>>2]|0;s=u;return w|0}return 0}function cb(e,i,r,f,a,o){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;c=s;s=s+48|0;l=c+40|0;b=c+36|0;k=c+32|0;h=c+28|0;w=c+24|0;d=c+20|0;v=c+16|0;m=c+12|0;_=c+8|0;p=c+4|0;E=c;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=f;t[d>>2]=a;t[v>>2]=o;if((t[b>>2]|0)==0|(t[k>>2]|0)==0|(t[w>>2]|0)==0){t[l>>2]=0;S=t[l>>2]|0;s=c;return S|0}t[m>>2]=Ib(t[b>>2]|0,5)|0;if(!(t[m>>2]|0)){t[l>>2]=0;S=t[l>>2]|0;s=c;return S|0}t[(t[m>>2]|0)+60>>2]=t[v>>2];do if((t[d>>2]|0)!=0?(u[t[d>>2]>>0]|0|0)!=0:0){t[_>>2]=HY(t[d>>2]|0)|0;t[p>>2]=HY(t[w>>2]|0)|0;t[E>>2]=gAi[t[135752>>2]&511]((t[_>>2]|0)+(t[p>>2]|0)+2|0)|0;if(t[E>>2]|0){YY(t[E>>2]|0,t[w>>2]|0,t[p>>2]|0)|0;n[(t[E>>2]|0)+(t[p>>2]|0)>>0]=124;YY((t[E>>2]|0)+((t[p>>2]|0)+1)|0,t[d>>2]|0,t[_>>2]|0)|0;n[(t[E>>2]|0)+((t[_>>2]|0)+(t[p>>2]|0)+1)>>0]=0;t[(t[m>>2]|0)+20>>2]=t[E>>2];break}Bb(t[m>>2]|0);t[l>>2]=0;S=t[l>>2]|0;s=c;return S|0}else g=7;while(0);if((g|0)==7){g=Yl(t[w>>2]|0)|0;t[(t[m>>2]|0)+20>>2]=g}if((Hb(t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[m>>2]|0)|0)<0){Bb(t[m>>2]|0);t[l>>2]=0;S=t[l>>2]|0;s=c;return S|0}if(!(t[h>>2]|0)){t[l>>2]=t[(t[b>>2]|0)+24>>2];S=t[l>>2]|0;s=c;return S|0}else{t[l>>2]=t[h>>2];S=t[l>>2]|0;s=c;return S|0}return 0}function lb(e,i,r,f,a,o){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;c=s;s=s+256|0;l=c;b=c+44|0;k=c+40|0;h=c+36|0;w=c+32|0;d=c+28|0;v=c+24|0;m=c+20|0;_=c+16|0;p=c+48|0;E=c+12|0;S=c+8|0;g=c+4|0;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=f;t[v>>2]=a;t[m>>2]=o;if((t[k>>2]|0)==0|(t[h>>2]|0)==0|(t[d>>2]|0)==0){t[b>>2]=0;y=t[b>>2]|0;s=c;return y|0}t[_>>2]=Ib(t[k>>2]|0,5)|0;if(!(t[_>>2]|0)){t[b>>2]=0;y=t[b>>2]|0;s=c;return y|0}t[(t[_>>2]|0)+60>>2]=t[m>>2];t[(t[_>>2]|0)+28>>2]=1;do if((t[v>>2]|0)!=0?(u[t[v>>2]>>0]|0|0)!=0:0){t[E>>2]=HY(t[v>>2]|0)|0;t[S>>2]=HY(t[d>>2]|0)|0;t[g>>2]=gAi[t[135752>>2]&511]((t[E>>2]|0)+(t[S>>2]|0)+2|0)|0;if(t[g>>2]|0){YY(t[g>>2]|0,t[d>>2]|0,t[S>>2]|0)|0;n[(t[g>>2]|0)+(t[S>>2]|0)>>0]=124;YY((t[g>>2]|0)+((t[S>>2]|0)+1)|0,t[v>>2]|0,t[E>>2]|0)|0;n[(t[g>>2]|0)+((t[E>>2]|0)+(t[S>>2]|0)+1)>>0]=0;t[(t[_>>2]|0)+20>>2]=t[g>>2];break}Bb(t[_>>2]|0);t[b>>2]=0;y=t[b>>2]|0;s=c;return y|0}else F=7;while(0);if((F|0)==7){F=Yl(t[d>>2]|0)|0;t[(t[_>>2]|0)+20>>2]=F}t[l>>2]=t[(t[_>>2]|0)+20>>2];SY(p,199,139120,l)|0;n[p+199>>0]=0;l=Yl(p)|0;t[(t[_>>2]|0)+24>>2]=l;if((Hb(t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[_>>2]|0)|0)<0){Bb(t[_>>2]|0);t[b>>2]=0;y=t[b>>2]|0;s=c;return y|0}_=(t[k>>2]|0)+72|0;t[_>>2]=(t[_>>2]|0)+1;if(!(t[w>>2]|0)){t[b>>2]=t[(t[k>>2]|0)+24>>2];y=t[b>>2]|0;s=c;return y|0}else{t[b>>2]=t[w>>2];y=t[b>>2]|0;s=c;return y|0}return 0}function sb(e,i,r,f,a,o,c,l){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;b=s;s=s+64|0;k=b+52|0;h=b+48|0;w=b+44|0;d=b+40|0;v=b+36|0;m=b+32|0;_=b+28|0;p=b+24|0;E=b+20|0;S=b+16|0;g=b+12|0;y=b+8|0;F=b+4|0;O=b;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=f;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=l;if((t[h>>2]|0)==0|(t[w>>2]|0)==0|(t[v>>2]|0)==0){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}if((t[_>>2]|0)<0){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}if((t[p>>2]|0)<1?1:(t[p>>2]|0)<(t[_>>2]|0)){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}t[S>>2]=Ib(t[h>>2]|0,5)|0;if(!(t[S>>2]|0)){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}do if((t[m>>2]|0)!=0?(u[t[m>>2]>>0]|0|0)!=0:0){t[y>>2]=HY(t[m>>2]|0)|0;t[F>>2]=HY(t[v>>2]|0)|0;t[O>>2]=gAi[t[135752>>2]&511]((t[y>>2]|0)+(t[F>>2]|0)+2|0)|0;if(t[O>>2]|0){YY(t[O>>2]|0,t[v>>2]|0,t[F>>2]|0)|0;n[(t[O>>2]|0)+(t[F>>2]|0)>>0]=124;YY((t[O>>2]|0)+((t[F>>2]|0)+1)|0,t[m>>2]|0,t[y>>2]|0)|0;n[(t[O>>2]|0)+((t[y>>2]|0)+(t[F>>2]|0)+1)>>0]=0;t[(t[S>>2]|0)+20>>2]=t[O>>2];break}Bb(t[S>>2]|0);t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}else M=11;while(0);if((M|0)==11){M=Yl(t[v>>2]|0)|0;t[(t[S>>2]|0)+20>>2]=M}t[(t[S>>2]|0)+60>>2]=t[E>>2];if(!(t[_>>2]|0))t[(t[S>>2]|0)+12>>2]=1;else t[(t[S>>2]|0)+12>>2]=t[_>>2];t[(t[S>>2]|0)+16>>2]=t[p>>2];t[g>>2]=xb(t[h>>2]|0)|0;t[(t[(t[h>>2]|0)+64>>2]|0)+(t[g>>2]<<3)>>2]=t[_>>2];t[(t[(t[h>>2]|0)+64>>2]|0)+(t[g>>2]<<3)+4>>2]=t[p>>2];if(!(t[d>>2]|0)){t[d>>2]=Ob(t[h>>2]|0)|0;Ab(t[h>>2]|0,t[d>>2]|0)|0}Ub(t[h>>2]|0,t[w>>2]|0,t[S>>2]|0,t[d>>2]|0,t[g>>2]|0,-1);zb(t[h>>2]|0,t[S>>2]|0)|0;t[(t[h>>2]|0)+24>>2]=t[d>>2];if(!(t[d>>2]|0))t[d>>2]=t[(t[h>>2]|0)+24>>2];if(!(t[d>>2]|0)){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}if(!(t[_>>2]|0))jb(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0);t[k>>2]=t[d>>2];A=t[k>>2]|0;s=b;return A|0}function bb(e,i,r,f,a,o,c,l){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;b=s;s=s+64|0;k=b+52|0;h=b+48|0;w=b+44|0;d=b+40|0;v=b+36|0;m=b+32|0;_=b+28|0;p=b+24|0;E=b+20|0;S=b+16|0;g=b+12|0;y=b+8|0;F=b+4|0;O=b;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=f;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=l;if((t[h>>2]|0)==0|(t[w>>2]|0)==0|(t[v>>2]|0)==0){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}if((t[_>>2]|0)<1){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}if((t[p>>2]|0)<1?1:(t[p>>2]|0)<(t[_>>2]|0)){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}t[S>>2]=Ib(t[h>>2]|0,5)|0;if(!(t[S>>2]|0)){t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}do if((t[m>>2]|0)!=0?(u[t[m>>2]>>0]|0|0)!=0:0){t[y>>2]=HY(t[m>>2]|0)|0;t[F>>2]=HY(t[v>>2]|0)|0;t[O>>2]=gAi[t[135752>>2]&511]((t[y>>2]|0)+(t[F>>2]|0)+2|0)|0;if(t[O>>2]|0){YY(t[O>>2]|0,t[v>>2]|0,t[F>>2]|0)|0;n[(t[O>>2]|0)+(t[F>>2]|0)>>0]=124;YY((t[O>>2]|0)+((t[F>>2]|0)+1)|0,t[m>>2]|0,t[y>>2]|0)|0;n[(t[O>>2]|0)+((t[y>>2]|0)+(t[F>>2]|0)+1)>>0]=0;t[(t[S>>2]|0)+20>>2]=t[O>>2];break}Bb(t[S>>2]|0);t[k>>2]=0;A=t[k>>2]|0;s=b;return A|0}else M=11;while(0);if((M|0)==11){M=Yl(t[v>>2]|0)|0;t[(t[S>>2]|0)+20>>2]=M}t[(t[S>>2]|0)+60>>2]=t[E>>2];t[(t[S>>2]|0)+8>>2]=6;t[(t[S>>2]|0)+12>>2]=t[_>>2];t[(t[S>>2]|0)+16>>2]=t[p>>2];t[g>>2]=xb(t[h>>2]|0)|0;t[(t[(t[h>>2]|0)+64>>2]|0)+(t[g>>2]<<3)>>2]=1;t[(t[(t[h>>2]|0)+64>>2]|0)+(t[g>>2]<<3)+4>>2]=1;if(!(t[d>>2]|0)){t[d>>2]=Ob(t[h>>2]|0)|0;Ab(t[h>>2]|0,t[d>>2]|0)|0}Ub(t[h>>2]|0,t[w>>2]|0,t[S>>2]|0,t[d>>2]|0,t[g>>2]|0,-1);zb(t[h>>2]|0,t[S>>2]|0)|0;t[(t[h>>2]|0)+24>>2]=t[d>>2];t[k>>2]=t[d>>2];A=t[k>>2]|0;s=b;return A|0}function kb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[f>>2]=Ob(t[n>>2]|0)|0;Ab(t[n>>2]|0,t[f>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function hb(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}jb(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0);if(!(t[o>>2]|0)){t[f>>2]=t[(t[u>>2]|0)+24>>2];c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=t[o>>2];c=t[f>>2]|0;s=n;return c|0}return 0}function wb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}Vb(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);if(!(t[c>>2]|0)){t[u>>2]=t[(t[a>>2]|0)+24>>2];b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=t[c>>2];b=t[u>>2]|0;s=f;return b|0}return 0}function db(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=xb(t[u>>2]|0)|0;if((t[c>>2]|0)<0){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}else{t[(t[(t[u>>2]|0)+64>>2]|0)+(t[c>>2]<<3)>>2]=t[a>>2];t[(t[(t[u>>2]|0)+64>>2]|0)+(t[c>>2]<<3)+4>>2]=t[o>>2];t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}return 0}function vb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[l>>2]|0)<0){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}qb(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);if(!(t[c>>2]|0)){t[u>>2]=t[(t[a>>2]|0)+24>>2];b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=t[c>>2];b=t[u>>2]|0;s=f;return b|0}return 0}function mb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[l>>2]|0)<0){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}Yb(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);if(!(t[c>>2]|0)){t[u>>2]=t[(t[a>>2]|0)+24>>2];b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=t[c>>2];b=t[u>>2]|0;s=f;return b|0}return 0}function _b(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+8>>2]|0)==0:0){Tb(t[n>>2]|0);t[f>>2]=Lb(t[n>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function pb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}else{t[f>>2]=Pb(t[n>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Eb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+8|0;a=r+4|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(t[f>>2]|0){t[a>>2]=t[t[f>>2]>>2];t[(t[f>>2]|0)+8>>2]=2}f=t[u>>2]|0;i=t[a>>2]|0;t[n>>2]=t[u>>2];cp(0,0,0,0,0,14,2,3,0,0,f,i,0,0,0,140264,n);s=r;return}function Sb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0;f=s;s=s+112|0;u=f;a=f+100|0;o=f+96|0;c=f+92|0;l=f+88|0;b=f+84|0;k=f+80|0;h=f+76|0;w=f+72|0;d=f+68|0;m=f+64|0;_=f+60|0;p=f+56|0;E=f+52|0;S=f+48|0;g=f+44|0;y=f+40|0;F=f+36|0;O=f+32|0;A=f+28|0;M=f+24|0;R=f+20|0;N=f+16|0;T=f+12|0;L=f+8|0;D=f+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[d>>2]=0;t[m>>2]=1;if(!(t[o>>2]|0)){t[a>>2]=-1;C=t[a>>2]|0;s=f;return C|0}if(!(t[(t[o>>2]|0)+8>>2]|0)){t[a>>2]=-1;C=t[a>>2]|0;s=f;return C|0}n=t[o>>2]|0;if(t[t[o>>2]>>2]|0){t[a>>2]=t[n>>2];C=t[a>>2]|0;s=f;return C|0}if(t[(t[n+8>>2]|0)+40>>2]|0){t[a>>2]=gb(t[o>>2]|0,t[(t[o>>2]|0)+8>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;C=t[a>>2]|0;s=f;return C|0}do if(!(t[c>>2]|0)){if((t[t[(t[o>>2]|0)+20>>2]>>2]|0)!=2){t[d>>2]=1;break}t[a>>2]=1;C=t[a>>2]|0;s=f;return C|0}while(0);if((t[c>>2]|0)!=0?(t[(t[o>>2]|0)+52>>2]|0)>0:0){Gb(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);t[c>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)>>2];t[l>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)+4>>2]}e:while(1){if(t[t[o>>2]>>2]|0)break;if(!(t[c>>2]|0)){if((t[d>>2]|0)!=1)break;if((t[t[(t[o>>2]|0)+20>>2]>>2]|0)==2)break}if(!((t[c>>2]|0)==0?(t[(t[o>>2]|0)+44>>2]|0)==0:0))P=22;i:do if((P|0)==22){P=0;t[(t[o>>2]|0)+28>>2]=0;r:while(1){if((t[(t[o>>2]|0)+24>>2]|0)>=(t[(t[(t[o>>2]|0)+20>>2]|0)+24>>2]|0))break;t[k>>2]=(t[(t[(t[o>>2]|0)+20>>2]|0)+28>>2]|0)+((t[(t[o>>2]|0)+24>>2]|0)*20|0);if((t[(t[k>>2]|0)+4>>2]|0)>=0){t[h>>2]=t[t[k>>2]>>2];t[w>>2]=0;n:do if((t[(t[k>>2]|0)+12>>2]|0)==1193047){t[w>>2]=0;if((t[c>>2]|0)==0&(t[d>>2]|0)!=0){t[w>>2]=1;break}if(t[c>>2]|0){t[_>>2]=0;f:while(1){if((t[_>>2]|0)>=(t[(t[(t[o>>2]|0)+20>>2]|0)+24>>2]|0))break n;t[E>>2]=(t[(t[(t[o>>2]|0)+20>>2]|0)+28>>2]|0)+((t[_>>2]|0)*20|0);do if((t[(t[E>>2]|0)+8>>2]|0)>=0){if((t[E>>2]|0)==(t[k>>2]|0))break;t[S>>2]=(t[(t[(t[o>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[E>>2]|0)+8>>2]<<3);t[p>>2]=t[(t[(t[o>>2]|0)+44>>2]|0)+(t[(t[E>>2]|0)+8>>2]<<2)>>2];do if((t[p>>2]|0)<(t[(t[S>>2]|0)+4>>2]|0)){if(!(t[t[E>>2]>>2]|0))break;if(Xl(t[c>>2]|0,t[(t[t[E>>2]>>2]|0)+20>>2]|0)|0){P=36;break f}}while(0);if((t[p>>2]|0)<(t[t[S>>2]>>2]|0))break;if((t[p>>2]|0)>=(t[(t[S>>2]|0)+4>>2]|0))break;if(!(t[t[E>>2]>>2]|0))break;if(Xl(t[c>>2]|0,t[(t[t[E>>2]>>2]|0)+20>>2]|0)|0){P=41;break f}}while(0);t[_>>2]=(t[_>>2]|0)+1}if((P|0)==36){P=0;t[w>>2]=0;break}else if((P|0)==41){P=0;t[w>>2]=1;break}}}else{if((t[(t[k>>2]|0)+12>>2]|0)==1193046){t[w>>2]=1;t[g>>2]=0;f:while(1){if((t[g>>2]|0)>=(t[(t[(t[o>>2]|0)+20>>2]|0)+24>>2]|0))break n;t[F>>2]=(t[(t[(t[o>>2]|0)+20>>2]|0)+28>>2]|0)+((t[g>>2]|0)*20|0);do if((t[(t[F>>2]|0)+8>>2]|0)>=0){if((t[F>>2]|0)==(t[k>>2]|0))break;t[O>>2]=(t[(t[(t[o>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[F>>2]|0)+8>>2]<<3);t[y>>2]=t[(t[(t[o>>2]|0)+44>>2]|0)+(t[(t[F>>2]|0)+8>>2]<<2)>>2];if((t[y>>2]|0)<(t[t[O>>2]>>2]|0))break f;if((t[y>>2]|0)>(t[(t[O>>2]|0)+4>>2]|0))break f}while(0);t[g>>2]=(t[g>>2]|0)+1}t[w>>2]=0;break}if((t[(t[k>>2]|0)+12>>2]|0)>=0){t[A>>2]=t[(t[(t[o>>2]|0)+44>>2]|0)+(t[(t[k>>2]|0)+12>>2]<<2)>>2];t[M>>2]=(t[(t[(t[o>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[k>>2]|0)+12>>2]<<3);if((t[A>>2]|0)>=(t[t[M>>2]>>2]|0))B=(t[A>>2]|0)<=(t[(t[M>>2]|0)+4>>2]|0);else B=0;t[w>>2]=B&1;break}if(!(t[h>>2]|0)){P=57;break r}if(!(t[c>>2]|0))break;t[w>>2]=Wb(t[(t[h>>2]|0)+20>>2]|0,t[c>>2]|0)|0;if(t[(t[h>>2]|0)+28>>2]|0){n=((t[w>>2]|0)!=0^1)&1;t[w>>2]=n;t[w>>2]=(t[b>>2]|0)!=0?n:0}do if((t[w>>2]|0)==1){if((t[(t[k>>2]|0)+8>>2]|0)<0)break;t[N>>2]=t[(t[(t[o>>2]|0)+44>>2]|0)+(t[(t[k>>2]|0)+8>>2]<<2)>>2];t[R>>2]=(t[(t[(t[o>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[k>>2]|0)+8>>2]<<3);if((t[N>>2]|0)<(t[(t[R>>2]|0)+4>>2]|0))break;t[w>>2]=0}while(0);if((t[w>>2]|0)!=1)break;if((t[(t[h>>2]|0)+12>>2]|0)<=0)break;if((t[(t[h>>2]|0)+16>>2]|0)<=0)break;t[T>>2]=t[(t[(t[(t[o>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[k>>2]|0)+4>>2]<<2)>>2];if((t[(t[(t[o>>2]|0)+20>>2]|0)+24>>2]|0)>((t[(t[o>>2]|0)+24>>2]|0)+1|0)){if((t[(t[o>>2]|0)+52>>2]|0)<=0)Gb(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);Kb(t[o>>2]|0)}t[(t[o>>2]|0)+28>>2]=1;do{if((t[(t[o>>2]|0)+28>>2]|0)==(t[(t[h>>2]|0)+16>>2]|0))break;n=(t[o>>2]|0)+56|0;t[n>>2]=(t[n>>2]|0)+1;t[c>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)>>2];t[l>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)+4>>2];I=t[o>>2]|0;if(!(t[c>>2]|0)){P=75;break}if((t[I+28>>2]|0)>=(t[(t[h>>2]|0)+12>>2]|0)){t[L>>2]=t[(t[o>>2]|0)+24>>2];t[D>>2]=t[(t[o>>2]|0)+20>>2];t[(t[o>>2]|0)+24>>2]=-1;t[(t[o>>2]|0)+20>>2]=t[T>>2];if((t[(t[o>>2]|0)+52>>2]|0)<=0)Gb(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);Kb(t[o>>2]|0);t[(t[o>>2]|0)+24>>2]=t[L>>2];t[(t[o>>2]|0)+20>>2]=t[D>>2]}t[w>>2]=Xl(t[c>>2]|0,t[(t[h>>2]|0)+20>>2]|0)|0;n=(t[o>>2]|0)+28|0;t[n>>2]=(t[n>>2]|0)+1}while((t[w>>2]|0)==1);if((P|0)==75){P=0;n=I+56|0;t[n>>2]=(t[n>>2]|0)+-1}if((t[(t[o>>2]|0)+28>>2]|0)<(t[(t[h>>2]|0)+12>>2]|0))t[w>>2]=0;if((t[w>>2]|0)<0)t[w>>2]=0;if(!(t[w>>2]|0))break i}while(0);if((t[w>>2]|0)==1){P=87;break}if((t[w>>2]|0)<0){P=110;break}}n=(t[o>>2]|0)+24|0;t[n>>2]=(t[n>>2]|0)+1}if((P|0)==57){P=0;xe(t[v>>2]|0,139424,u|0)|0;t[t[o>>2]>>2]=-2}else if((P|0)==87){P=0;if(((t[h>>2]|0)!=0?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)&(t[l>>2]|0)!=0)NAi[t[(t[o>>2]|0)+12>>2]&511](t[(t[o>>2]|0)+16>>2]|0,t[(t[h>>2]|0)+20>>2]|0,t[(t[h>>2]|0)+60>>2]|0,t[l>>2]|0);if((t[(t[(t[o>>2]|0)+20>>2]|0)+24>>2]|0)>((t[(t[o>>2]|0)+24>>2]|0)+1|0)){if((t[(t[o>>2]|0)+52>>2]|0)<=0)Gb(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0);Kb(t[o>>2]|0)}if((t[(t[k>>2]|0)+8>>2]|0)>=0){n=(t[(t[o>>2]|0)+44>>2]|0)+(t[(t[k>>2]|0)+8>>2]<<2)|0;t[n>>2]=(t[n>>2]|0)+1}if((t[(t[k>>2]|0)+12>>2]|0)>=0?(t[(t[k>>2]|0)+12>>2]|0)<1193046:0)t[(t[(t[o>>2]|0)+44>>2]|0)+(t[(t[k>>2]|0)+12>>2]<<2)>>2]=0;if((t[(t[(t[(t[o>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[k>>2]|0)+4>>2]<<2)>>2]|0)!=0?(t[t[(t[(t[(t[o>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[k>>2]|0)+4>>2]<<2)>>2]>>2]|0)==4:0){if(t[(t[o>>2]|0)+80>>2]|0)pAi[t[135736>>2]&511](t[(t[o>>2]|0)+80>>2]|0);n=Yl(t[c>>2]|0)|0;t[(t[o>>2]|0)+80>>2]=n;t[(t[o>>2]|0)+76>>2]=t[(t[o>>2]|0)+20>>2];YY(t[(t[o>>2]|0)+84>>2]|0,t[(t[o>>2]|0)+44>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0}t[(t[o>>2]|0)+20>>2]=t[(t[(t[(t[o>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[k>>2]|0)+4>>2]<<2)>>2];t[(t[o>>2]|0)+24>>2]=0;do if(t[t[k>>2]>>2]|0){if(!(t[(t[o>>2]|0)+68>>2]|0)){t[c>>2]=0;t[l>>2]=0;break}n=(t[o>>2]|0)+56|0;t[n>>2]=(t[n>>2]|0)+1;if((t[(t[o>>2]|0)+56>>2]|0)<(t[(t[o>>2]|0)+52>>2]|0)){t[c>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)>>2];t[l>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)+4>>2];break}else{t[c>>2]=0;t[l>>2]=0;break}}while(0);t[m>>2]=1;continue e}else if((P|0)==110){P=0;t[t[o>>2]>>2]=-4}if((t[(t[o>>2]|0)+24>>2]|0)==0?(t[(t[(t[o>>2]|0)+20>>2]|0)+24>>2]|0)!=0:0)continue e}while(0);if(((t[m>>2]|0)!=0?(t[(t[o>>2]|0)+20>>2]|0)!=0:0)?(t[t[(t[o>>2]|0)+20>>2]>>2]|0)!=4:0){t[m>>2]=0;if(t[(t[o>>2]|0)+80>>2]|0)pAi[t[135736>>2]&511](t[(t[o>>2]|0)+80>>2]|0);n=Yl(t[c>>2]|0)|0;t[(t[o>>2]|0)+80>>2]=n;t[(t[o>>2]|0)+76>>2]=t[(t[o>>2]|0)+20>>2];YY(t[(t[o>>2]|0)+84>>2]|0,t[(t[o>>2]|0)+44>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0}t[(t[o>>2]|0)+4>>2]=0;Xb(t[o>>2]|0);if(!(t[(t[o>>2]|0)+68>>2]|0))continue;if(t[t[o>>2]>>2]|0)continue;t[c>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)>>2];t[l>>2]=t[(t[(t[o>>2]|0)+68>>2]|0)+(t[(t[o>>2]|0)+56>>2]<<3)+4>>2]}l=t[o>>2]|0;if(!(t[t[o>>2]>>2]|0)){t[a>>2]=(t[t[l+20>>2]>>2]|0)==2&1;C=t[a>>2]|0;s=f;return C|0}else{t[a>>2]=t[l>>2];C=t[a>>2]|0;s=f;return C|0}return 0}function gb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=t[(t[a>>2]|0)+56>>2];if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+40>>2]|0)!=0:0)?(t[(t[o>>2]|0)+52>>2]|0)!=0:0){if(!(t[c>>2]|0)){n=te(t[b>>2]|0,(t[(t[o>>2]|0)+48>>2]|0)+1|0)|0;if((t[(t[(t[o>>2]|0)+40>>2]|0)+(n<<2)>>2]|0)==2){t[u>>2]=1;w=t[u>>2]|0;s=f;return w|0}else{t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}}t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[(t[o>>2]|0)+48>>2]|0))break;n=te(t[b>>2]|0,(t[(t[o>>2]|0)+48>>2]|0)+1|0)|0;t[h>>2]=t[(t[(t[o>>2]|0)+40>>2]|0)+(n+(t[k>>2]|0)+1<<2)>>2];if(((t[h>>2]|0)>0?(t[h>>2]|0)<=(t[(t[o>>2]|0)+36>>2]|0):0)?(t[h>>2]=(t[h>>2]|0)+-1,(Wb(t[(t[(t[o>>2]|0)+52>>2]|0)+(t[k>>2]<<2)>>2]|0,t[c>>2]|0)|0)!=0):0){d=14;break}t[k>>2]=(t[k>>2]|0)+1}if((d|0)==14){t[(t[a>>2]|0)+56>>2]=t[h>>2];if((t[(t[a>>2]|0)+12>>2]|0)!=0?(t[(t[o>>2]|0)+44>>2]|0)!=0:0){d=te(t[b>>2]|0,t[(t[o>>2]|0)+48>>2]|0)|0;NAi[t[(t[a>>2]|0)+12>>2]&511](t[(t[a>>2]|0)+16>>2]|0,t[c>>2]|0,t[(t[(t[o>>2]|0)+44>>2]|0)+(d+(t[k>>2]|0)<<2)>>2]|0,t[l>>2]|0)}l=te(t[h>>2]|0,(t[(t[o>>2]|0)+48>>2]|0)+1|0)|0;if((t[(t[(t[o>>2]|0)+40>>2]|0)+(l<<2)>>2]|0)!=4){l=te(t[h>>2]|0,(t[(t[o>>2]|0)+48>>2]|0)+1|0)|0;if((t[(t[(t[o>>2]|0)+40>>2]|0)+(l<<2)>>2]|0)==2){t[u>>2]=1;w=t[u>>2]|0;s=f;return w|0}else{t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}}}if(t[(t[a>>2]|0)+80>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+80>>2]|0);l=Yl(t[c>>2]|0)|0;t[(t[a>>2]|0)+80>>2]=l;t[(t[a>>2]|0)+72>>2]=t[b>>2];t[t[a>>2]>>2]=-1;t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}function yb(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0;a=s;s=s+96|0;o=a;c=a+80|0;l=a+76|0;b=a+72|0;k=a+68|0;h=a+64|0;w=a+60|0;d=a+56|0;v=a+52|0;m=a+48|0;_=a+44|0;p=a+40|0;E=a+36|0;S=a+32|0;g=a+28|0;y=a+24|0;F=a+20|0;O=a+16|0;A=a+12|0;M=a+8|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[m>>2]=0;if(!((t[l>>2]|0)==0|(t[k>>2]|0)==0|(t[h>>2]|0)==0|(t[w>>2]|0)==0)?(t[t[k>>2]>>2]|0)>0:0){t[v>>2]=t[t[k>>2]>>2];t[t[k>>2]>>2]=0;t[t[h>>2]>>2]=0;e:do if((t[(t[l>>2]|0)+8>>2]|0)!=0?(t[(t[(t[l>>2]|0)+8>>2]|0)+40>>2]|0)!=0:0){t[_>>2]=t[(t[l>>2]|0)+8>>2];u=t[l>>2]|0;do if(t[b>>2]|0){if((t[u+72>>2]|0)!=-1){t[S>>2]=t[(t[l>>2]|0)+72>>2];break}t[c>>2]=-1;R=t[c>>2]|0;s=a;return R|0}else t[S>>2]=t[u+56>>2];while(0);do if(t[d>>2]|0){u=te(t[S>>2]|0,(t[(t[_>>2]|0)+48>>2]|0)+1|0)|0;f=t[d>>2]|0;if((t[(t[(t[_>>2]|0)+40>>2]|0)+(u<<2)>>2]|0)==2){t[f>>2]=1;break}else{t[f>>2]=0;break}}while(0);t[E>>2]=0;while(1){if((t[E>>2]|0)>=(t[(t[_>>2]|0)+48>>2]|0))break;if((t[m>>2]|0)>=(t[v>>2]|0))break;f=te(t[S>>2]|0,(t[(t[_>>2]|0)+48>>2]|0)+1|0)|0;t[p>>2]=t[(t[(t[_>>2]|0)+40>>2]|0)+(f+(t[E>>2]|0)+1<<2)>>2];if(((t[p>>2]|0)>0?(t[p>>2]|0)<=(t[(t[_>>2]|0)+36>>2]|0):0)?(f=te((t[p>>2]|0)-1|0,(t[(t[_>>2]|0)+48>>2]|0)+1|0)|0,(t[(t[(t[_>>2]|0)+40>>2]|0)+(f<<2)>>2]|0)!=4):0){f=t[(t[(t[_>>2]|0)+52>>2]|0)+(t[E>>2]<<2)>>2]|0;u=t[m>>2]|0;t[m>>2]=u+1;t[(t[w>>2]|0)+(u<<2)>>2]=f;f=t[k>>2]|0;t[f>>2]=(t[f>>2]|0)+1}t[E>>2]=(t[E>>2]|0)+1}t[E>>2]=0;while(1){if((t[E>>2]|0)>=(t[(t[_>>2]|0)+48>>2]|0))break e;if((t[m>>2]|0)>=(t[v>>2]|0))break e;f=te(t[S>>2]|0,(t[(t[_>>2]|0)+48>>2]|0)+1|0)|0;t[p>>2]=t[(t[(t[_>>2]|0)+40>>2]|0)+(f+(t[E>>2]|0)+1<<2)>>2];if(((t[p>>2]|0)>0?(t[p>>2]|0)<=(t[(t[_>>2]|0)+36>>2]|0):0)?(f=te((t[p>>2]|0)-1|0,(t[(t[_>>2]|0)+48>>2]|0)+1|0)|0,(t[(t[(t[_>>2]|0)+40>>2]|0)+(f<<2)>>2]|0)==4):0){f=t[(t[(t[_>>2]|0)+52>>2]|0)+(t[E>>2]<<2)>>2]|0;u=t[m>>2]|0;t[m>>2]=u+1;t[(t[w>>2]|0)+(u<<2)>>2]=f;f=t[h>>2]|0;t[f>>2]=(t[f>>2]|0)+1}t[E>>2]=(t[E>>2]|0)+1}}else N=31;while(0);e:do if((N|0)==31){do if(t[d>>2]|0){E=t[d>>2]|0;if((t[t[(t[l>>2]|0)+20>>2]>>2]|0)==2){t[E>>2]=1;break}else{t[E>>2]=0;break}}while(0);E=t[l>>2]|0;do if(t[b>>2]|0){if(t[E+76>>2]|0){t[O>>2]=t[(t[l>>2]|0)+76>>2];break}t[c>>2]=-1;R=t[c>>2]|0;s=a;return R|0}else{if(t[E+20>>2]|0){t[O>>2]=t[(t[l>>2]|0)+20>>2];break}t[c>>2]=-1;R=t[c>>2]|0;s=a;return R|0}while(0);t[g>>2]=0;while(1){if((t[g>>2]|0)>=(t[(t[O>>2]|0)+24>>2]|0))break;if((t[m>>2]|0)>=(t[v>>2]|0))break;t[y>>2]=(t[(t[O>>2]|0)+28>>2]|0)+((t[g>>2]|0)*20|0);do if(((t[(t[y>>2]|0)+4>>2]|0)>=0?(t[F>>2]=t[t[y>>2]>>2],(t[F>>2]|0)!=0):0)?(t[(t[F>>2]|0)+20>>2]|0)!=0:0){if((t[(t[y>>2]|0)+12>>2]|0)==1193047){E=t[33976]|0;_=t[33980]|0;t[o>>2]=140216;t[o+4>>2]=4289;yAi[E&511](_,140184,o);break}if((t[(t[y>>2]|0)+12>>2]|0)==1193046){_=t[33976]|0;E=t[33980]|0;t[o>>2]=140216;t[o+4>>2]=4292;yAi[_&511](E,140184,o);break}if((t[(t[y>>2]|0)+8>>2]|0)<0){if(!(t[(t[l>>2]|0)+8>>2]|0))break;if(!(t[(t[(t[(t[l>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[y>>2]|0)+4>>2]<<2)>>2]|0))break;if((t[t[(t[(t[(t[l>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[y>>2]|0)+4>>2]<<2)>>2]>>2]|0)==4)break;E=t[F>>2]|0;if(t[(t[F>>2]|0)+28>>2]|0){_=t[E+24>>2]|0;p=t[m>>2]|0;t[m>>2]=p+1;t[(t[w>>2]|0)+(p<<2)>>2]=_}else{_=t[E+20>>2]|0;E=t[m>>2]|0;t[m>>2]=E+1;t[(t[w>>2]|0)+(E<<2)>>2]=_}_=t[k>>2]|0;t[_>>2]=(t[_>>2]|0)+1;break}t[A>>2]=0;_=t[(t[y>>2]|0)+8>>2]|0;E=t[l>>2]|0;if(t[b>>2]|0)t[M>>2]=t[(t[E+84>>2]|0)+(_<<2)>>2];else t[M>>2]=t[(t[E+44>>2]|0)+(_<<2)>>2];if(t[(t[l>>2]|0)+8>>2]|0)t[A>>2]=(t[(t[(t[l>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[y>>2]|0)+8>>2]<<3);if((t[A>>2]|0)!=0?(t[M>>2]|0)>=(t[(t[A>>2]|0)+4>>2]|0):0)break;_=t[F>>2]|0;if(t[(t[F>>2]|0)+28>>2]|0){E=t[_+24>>2]|0;p=t[m>>2]|0;t[m>>2]=p+1;t[(t[w>>2]|0)+(p<<2)>>2]=E}else{E=t[_+20>>2]|0;_=t[m>>2]|0;t[m>>2]=_+1;t[(t[w>>2]|0)+(_<<2)>>2]=E}E=t[k>>2]|0;t[E>>2]=(t[E>>2]|0)+1}while(0);t[g>>2]=(t[g>>2]|0)+1}t[g>>2]=0;while(1){if((t[g>>2]|0)>=(t[(t[O>>2]|0)+24>>2]|0))break e;if((t[m>>2]|0)>=(t[v>>2]|0))break e;t[y>>2]=(t[(t[O>>2]|0)+28>>2]|0)+((t[g>>2]|0)*20|0);if((((((((t[(t[y>>2]|0)+4>>2]|0)>=0?(t[F>>2]=t[t[y>>2]>>2],(t[F>>2]|0)!=0):0)?(t[(t[F>>2]|0)+20>>2]|0)!=0:0)?(t[(t[y>>2]|0)+12>>2]|0)!=1193047:0)?(t[(t[y>>2]|0)+12>>2]|0)!=1193046:0)?(t[(t[y>>2]|0)+8>>2]|0)<0:0)?(t[(t[(t[(t[l>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[y>>2]|0)+4>>2]<<2)>>2]|0)!=0:0)?(t[t[(t[(t[(t[l>>2]|0)+8>>2]|0)+8>>2]|0)+(t[(t[y>>2]|0)+4>>2]<<2)>>2]>>2]|0)==4:0){E=t[F>>2]|0;if(t[(t[F>>2]|0)+28>>2]|0){_=t[E+24>>2]|0;p=t[m>>2]|0;t[m>>2]=p+1;t[(t[w>>2]|0)+(p<<2)>>2]=_}else{_=t[E+20>>2]|0;E=t[m>>2]|0;t[m>>2]=E+1;t[(t[w>>2]|0)+(E<<2)>>2]=_}_=t[h>>2]|0;t[_>>2]=(t[_>>2]|0)+1}t[g>>2]=(t[g>>2]|0)+1}}while(0);t[c>>2]=0;R=t[c>>2]|0;s=a;return R|0}t[c>>2]=-1;R=t[c>>2]|0;s=a;return R|0}function Fb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](80)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+80|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));if(t[n>>2]|0){e=Yl(t[n>>2]|0)|0;t[t[f>>2]>>2]=e}t[(t[f>>2]|0)+4>>2]=t[t[f>>2]>>2];t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+72>>2]=0;t[(t[f>>2]|0)+8>>2]=0;t[(t[f>>2]|0)+68>>2]=-1;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Ob(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[f>>2]|0)){Eb(t[n>>2]|0,140160);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{n=(t[f>>2]|0)+0|0;e=n+44|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(e|0));t[t[f>>2]>>2]=3;t[(t[f>>2]|0)+4>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Ab(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}i=t[f>>2]|0;do if(!(t[(t[f>>2]|0)+44>>2]|0)){t[i+44>>2]=4;e=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+44>>2]<<2)|0;t[(t[f>>2]|0)+52>>2]=e;if(!(t[(t[f>>2]|0)+52>>2]|0)){Eb(t[f>>2]|0,140144);t[(t[f>>2]|0)+44>>2]=0;t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}}else if((t[i+48>>2]|0)>=(t[(t[f>>2]|0)+44>>2]|0)){e=(t[f>>2]|0)+44|0;t[e>>2]=t[e>>2]<<1;t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+52>>2]|0,t[(t[f>>2]|0)+44>>2]<<2)|0;if(t[a>>2]|0){t[(t[f>>2]|0)+52>>2]=t[a>>2];break}Eb(t[f>>2]|0,140144);e=(t[f>>2]|0)+44|0;t[e>>2]=(t[e>>2]|0)/2|0;t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(0);t[(t[u>>2]|0)+16>>2]=t[(t[f>>2]|0)+48>>2];a=t[u>>2]|0;u=(t[f>>2]|0)+48|0;i=t[u>>2]|0;t[u>>2]=i+1;t[(t[(t[f>>2]|0)+52>>2]|0)+(i<<2)>>2]=a;t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Mb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=t[(t[n>>2]|0)+24>>2];t[(t[n>>2]|0)+20>>2]=0;Zb(t[n>>2]|0,0)|0;if(t[f>>2]|0)t[t[(t[n>>2]|0)+24>>2]>>2]=2;i=t[(t[n>>2]|0)+24>>2]|0;if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)!=124){t[(t[n>>2]|0)+20>>2]=i;s=r;return}t[o>>2]=i;while(1){if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)!=124)break;if(t[(t[n>>2]|0)+8>>2]|0)break;i=(t[n>>2]|0)+4|0;t[i>>2]=(t[i>>2]|0)+1;if(!(u[t[(t[n>>2]|0)+4>>2]>>0]|0)){c=9;break}t[(t[n>>2]|0)+24>>2]=t[a>>2];t[(t[n>>2]|0)+20>>2]=0;Zb(t[n>>2]|0,t[o>>2]|0)|0}if((c|0)==9){t[(t[n>>2]|0)+8>>2]=1450;Rb(t[n>>2]|0,139560);s=r;return}if(t[f>>2]|0){s=r;return}t[(t[n>>2]|0)+24>>2]=t[o>>2];t[(t[n>>2]|0)+20>>2]=t[o>>2];s=r;return}function Rb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;if(t[f>>2]|0){t[a>>2]=t[t[f>>2]>>2];t[o>>2]=(t[(t[f>>2]|0)+4>>2]|0)-(t[t[f>>2]>>2]|0);t[(t[f>>2]|0)+8>>2]=1450}f=t[u>>2]|0;i=t[a>>2]|0;a=t[o>>2]|0;t[n>>2]=t[u>>2];cp(0,0,0,0,0,14,1450,3,0,0,f,i,0,a,0,139536,n);s=r;return}function Nb(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;Cb(t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0)}if(t[(t[r>>2]|0)+40>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+36>>2]|0))break;Bb(t[(t[(t[r>>2]|0)+40>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0)}if(t[(t[r>>2]|0)+64>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+64>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Tb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;u=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[r>>2]=e;if(!(t[(t[r>>2]|0)+52>>2]|0)){s=i;return}Jb(t[r>>2]|0);t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;t[u>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];if((t[u>>2]|0)!=0?(t[t[u>>2]>>2]|0)==5:0){Cb(t[u>>2]|0);t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2]=0}t[n>>2]=(t[n>>2]|0)+1}t[a>>2]=0;t[n>>2]=(t[(t[r>>2]|0)+48>>2]|0)-1;while(1){if((t[n>>2]|0)<0)break;t[u>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];e:do if(t[u>>2]|0){if((t[(t[u>>2]|0)+24>>2]|0)==0?(t[t[u>>2]>>2]|0)!=2:0)t[t[u>>2]>>2]=4;t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[u>>2]|0)+24>>2]|0))break e;do if((t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)>>2]|0)==0?(t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+4>>2]|0)>=0:0){e=(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)|0;if((t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+4>>2]|0)==(t[n>>2]|0)){t[e+4>>2]=-1;break}if((t[e+12>>2]|0)<0){t[o>>2]=t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+4>>2];t[a>>2]=1;t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+4>>2]=-2;t[(t[u>>2]|0)+4>>2]=1;Qb(t[r>>2]|0,t[n>>2]|0,t[o>>2]|0,t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+8>>2]|0);t[(t[u>>2]|0)+4>>2]=0}}while(0);t[f>>2]=(t[f>>2]|0)+1}}while(0);t[n>>2]=(t[n>>2]|0)+-1}e:do if(t[a>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break e;t[u>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];i:do if(t[u>>2]|0){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[u>>2]|0)+24>>2]|0))break i;t[c>>2]=(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0);if(((t[t[c>>2]>>2]|0)==0?(t[(t[c>>2]|0)+12>>2]|0)<0:0)?(t[(t[c>>2]|0)+4>>2]|0)>=0:0)t[(t[c>>2]|0)+4>>2]=-1;t[f>>2]=(t[f>>2]|0)+1}}while(0);t[n>>2]=(t[n>>2]|0)+1}}while(0);t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;t[u>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];if(t[u>>2]|0)t[(t[u>>2]|0)+12>>2]=0;t[n>>2]=(t[n>>2]|0)+1}t[u>>2]=t[t[(t[r>>2]|0)+52>>2]>>2];if(t[u>>2]|0)t[(t[u>>2]|0)+12>>2]=1;while(1){if(!(t[u>>2]|0))break;t[l>>2]=0;t[(t[u>>2]|0)+12>>2]=2;t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[u>>2]|0)+24>>2]|0))break;do if((t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+4>>2]|0)>=0){if((t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)>>2]|0)==0?(t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+12>>2]|0)<0:0)break;t[b>>2]=t[(t[(t[u>>2]|0)+28>>2]|0)+((t[f>>2]|0)*20|0)+4>>2];if((t[(t[(t[r>>2]|0)+52>>2]|0)+(t[b>>2]<<2)>>2]|0)!=0?(t[(t[(t[(t[r>>2]|0)+52>>2]|0)+(t[b>>2]<<2)>>2]|0)+12>>2]|0)==0:0){t[(t[(t[(t[r>>2]|0)+52>>2]|0)+(t[b>>2]<<2)>>2]|0)+12>>2]=1;t[l>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[b>>2]<<2)>>2]}}while(0);t[f>>2]=(t[f>>2]|0)+1}e:do if(!(t[l>>2]|0)){t[n>>2]=1;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break e;t[u>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)==1:0)break;t[n>>2]=(t[n>>2]|0)+1}t[l>>2]=t[u>>2]}while(0);t[u>>2]=t[l>>2]}t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;t[u>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)==0:0){Cb(t[u>>2]|0);t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2]=0}t[n>>2]=(t[n>>2]|0)+1}s=i;return}function Lb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;i=s;s=s+80|0;r=i+72|0;n=i+68|0;f=i+64|0;u=i+60|0;a=i+56|0;o=i+52|0;c=i+48|0;l=i+44|0;b=i+40|0;k=i+36|0;h=i+32|0;w=i+28|0;d=i+24|0;v=i+20|0;m=i+16|0;_=i+12|0;p=i+8|0;E=i+4|0;S=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](56)|0;if(!(t[f>>2]|0)){Eb(t[n>>2]|0,139512);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}e=(t[f>>2]|0)+0|0;y=e+56|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(y|0));t[t[f>>2]>>2]=t[t[n>>2]>>2];t[(t[f>>2]|0)+4>>2]=t[(t[n>>2]|0)+48>>2];t[(t[f>>2]|0)+8>>2]=t[(t[n>>2]|0)+52>>2];t[(t[f>>2]|0)+12>>2]=t[(t[n>>2]|0)+36>>2];t[(t[f>>2]|0)+16>>2]=t[(t[n>>2]|0)+40>>2];t[(t[f>>2]|0)+20>>2]=t[(t[n>>2]|0)+60>>2];t[(t[f>>2]|0)+24>>2]=t[(t[n>>2]|0)+64>>2];t[(t[f>>2]|0)+28>>2]=t[(t[n>>2]|0)+68>>2];t[(t[f>>2]|0)+32>>2]=t[(t[n>>2]|0)+76>>2];if((t[(t[f>>2]|0)+28>>2]|0)==-1)ib(t[f>>2]|0)|0;do if((((((t[(t[f>>2]|0)+28>>2]|0)!=0?(t[(t[f>>2]|0)+20>>2]|0)==0:0)?(t[(t[n>>2]|0)+72>>2]|0)==0:0)?(t[(t[f>>2]|0)+16>>2]|0)!=0:0)?(t[t[(t[f>>2]|0)+16>>2]>>2]|0)!=0:0)?(t[(t[t[(t[f>>2]|0)+16>>2]>>2]|0)+4>>2]|0)==5:0){t[o>>2]=0;t[c>>2]=0;t[l>>2]=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+4>>2]<<2)|0;if(!(t[l>>2]|0)){Eb(t[n>>2]|0,139512);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[f>>2]|0)+4>>2]|0))break;if(t[(t[(t[f>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2]|0){t[(t[l>>2]|0)+(t[u>>2]<<2)>>2]=t[o>>2];t[o>>2]=(t[o>>2]|0)+1}else t[(t[l>>2]|0)+(t[u>>2]<<2)>>2]=-1;t[u>>2]=(t[u>>2]|0)+1}t[w>>2]=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+12>>2]<<2)|0;if(!(t[w>>2]|0)){Eb(t[n>>2]|0,139512);
	pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}t[b>>2]=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+12>>2]<<2)|0;if(!(t[b>>2]|0)){Eb(t[n>>2]|0,139512);pAi[t[135736>>2]&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[f>>2]|0)+12>>2]|0)){F=44;break}if((t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+4>>2]|0)!=5){F=39;break}if((t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+8>>2]|0)!=2){F=39;break}t[d>>2]=t[(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0)+20>>2];t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[c>>2]|0))break;e=(Xl(t[(t[w>>2]|0)+(t[a>>2]<<2)>>2]|0,t[d>>2]|0)|0)!=0;O=t[a>>2]|0;if(e){F=30;break}t[a>>2]=O+1}if((F|0)==30){F=0;t[(t[b>>2]|0)+(t[u>>2]<<2)>>2]=O}if((t[a>>2]|0)>=(t[c>>2]|0)){t[(t[b>>2]|0)+(t[u>>2]<<2)>>2]=t[c>>2];e=Yl(t[d>>2]|0)|0;t[(t[w>>2]|0)+(t[c>>2]<<2)>>2]=e;if(!(t[(t[w>>2]|0)+(t[c>>2]<<2)>>2]|0)){F=34;break}t[c>>2]=(t[c>>2]|0)+1}t[u>>2]=(t[u>>2]|0)+1}if((F|0)==34){t[u>>2]=0;while(1){A=t[33934]|0;if((t[u>>2]|0)>=(t[c>>2]|0))break;pAi[A&511](t[(t[w>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}pAi[A&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}else if((F|0)==39){pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[u>>2]=0;while(1){M=t[33934]|0;if((t[u>>2]|0)>=(t[c>>2]|0))break;pAi[M&511](t[(t[w>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}pAi[M&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}else if((F|0)==44){e=(te((t[o>>2]|0)+1|0,(t[c>>2]|0)+1|0)|0)<<2;t[k>>2]=gAi[t[135744>>2]&511](e)|0;if(!(t[k>>2]|0)){pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);pAi[t[135736>>2]&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;g=t[r>>2]|0;s=i;return g|0}VY(t[k>>2]|0,0,(te((t[o>>2]|0)+1|0,(t[c>>2]|0)+1|0)|0)<<2|0)|0;t[h>>2]=0;t[u>>2]=0;e:while(1){if((t[u>>2]|0)>=(t[(t[f>>2]|0)+4>>2]|0))break;t[v>>2]=t[(t[l>>2]|0)+(t[u>>2]<<2)>>2];i:do if((t[v>>2]|0)!=-1){t[E>>2]=t[(t[(t[f>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2];e=te(t[v>>2]|0,(t[c>>2]|0)+1|0)|0;t[(t[k>>2]|0)+(e<<2)>>2]=t[t[E>>2]>>2];t[a>>2]=0;r:while(1){if((t[a>>2]|0)>=(t[(t[E>>2]|0)+24>>2]|0))break i;t[S>>2]=(t[(t[E>>2]|0)+28>>2]|0)+((t[a>>2]|0)*20|0);do if((t[(t[S>>2]|0)+4>>2]|0)!=-1){if(!(t[t[S>>2]>>2]|0))break;t[m>>2]=t[(t[b>>2]|0)+(t[t[t[S>>2]>>2]>>2]<<2)>>2];if((t[h>>2]|0)==0?(t[(t[t[S>>2]>>2]|0)+60>>2]|0)!=0:0){e=(te(t[o>>2]|0,t[c>>2]|0)|0)<<2;t[h>>2]=gAi[t[135744>>2]&511](e)|0;if(!(t[h>>2]|0))break r;VY(t[h>>2]|0,0,(te(t[o>>2]|0,t[c>>2]|0)|0)<<2|0)|0}t[_>>2]=t[(t[l>>2]|0)+(t[(t[S>>2]|0)+4>>2]<<2)>>2];e=te(t[v>>2]|0,(t[c>>2]|0)+1|0)|0;t[p>>2]=t[(t[k>>2]|0)+(e+(t[m>>2]|0)+1<<2)>>2];if(t[p>>2]|0)if((t[p>>2]|0)!=((t[_>>2]|0)+1|0)){F=59;break e}else break;e=te(t[v>>2]|0,(t[c>>2]|0)+1|0)|0;t[(t[k>>2]|0)+(e+(t[m>>2]|0)+1<<2)>>2]=(t[_>>2]|0)+1;if(!(t[h>>2]|0))break;e=te(t[v>>2]|0,t[c>>2]|0)|0;t[(t[h>>2]|0)+(e+(t[m>>2]|0)<<2)>>2]=t[(t[t[S>>2]>>2]|0)+60>>2]}while(0);t[a>>2]=(t[a>>2]|0)+1}Eb(t[n>>2]|0,139512)}while(0);t[u>>2]=(t[u>>2]|0)+1}if((F|0)==59){t[(t[f>>2]|0)+28>>2]=0;if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);pAi[t[135736>>2]&511](t[k>>2]|0);pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[u>>2]=0;while(1){R=t[33934]|0;if((t[u>>2]|0)>=(t[c>>2]|0))break;pAi[R&511](t[(t[w>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}pAi[R&511](t[w>>2]|0);break}t[(t[f>>2]|0)+28>>2]=1;if(t[(t[f>>2]|0)+8>>2]|0){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[f>>2]|0)+4>>2]|0))break;Cb(t[(t[(t[f>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0)}t[(t[f>>2]|0)+8>>2]=0;t[(t[f>>2]|0)+4>>2]=0;if(t[(t[f>>2]|0)+16>>2]|0){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[f>>2]|0)+12>>2]|0))break;Bb(t[(t[(t[f>>2]|0)+16>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[f>>2]|0)+16>>2]|0)}t[(t[f>>2]|0)+16>>2]=0;t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+40>>2]=t[k>>2];t[(t[f>>2]|0)+44>>2]=t[h>>2];t[(t[f>>2]|0)+52>>2]=t[w>>2];t[(t[f>>2]|0)+48>>2]=t[c>>2];t[(t[f>>2]|0)+36>>2]=t[o>>2];pAi[t[135736>>2]&511](t[l>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);break}}while(0);t[t[n>>2]>>2]=0;t[(t[n>>2]|0)+48>>2]=0;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+60>>2]=0;t[(t[n>>2]|0)+64>>2]=0;t[r>>2]=t[f>>2];g=t[r>>2]|0;s=i;return g|0}function Db(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;r=s;s=s+176|0;n=r;f=r+164|0;a=r+160|0;o=r+156|0;c=r+60|0;l=r+56|0;b=r+52|0;k=r+48|0;h=r+44|0;w=r+40|0;d=r+36|0;m=r+32|0;_=r+28|0;p=r+24|0;E=r+20|0;S=r+16|0;g=r+12|0;y=r+8|0;F=r+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r+64;t[b>>2]=0;t[(t[c>>2]|0)+64>>2]=t[o>>2];t[(t[c>>2]|0)+56>>2]=0;t[(t[c>>2]|0)+88>>2]=0;t[(t[c>>2]|0)+4>>2]=1;t[(t[c>>2]|0)+32>>2]=0;t[(t[c>>2]|0)+36>>2]=0;t[(t[c>>2]|0)+40>>2]=0;t[t[c>>2]>>2]=0;t[(t[c>>2]|0)+8>>2]=t[a>>2];t[(t[c>>2]|0)+20>>2]=t[t[(t[a>>2]|0)+8>>2]>>2];t[(t[c>>2]|0)+24>>2]=0;t[(t[c>>2]|0)+28>>2]=0;t[(t[c>>2]|0)+68>>2]=0;t[(t[c>>2]|0)+48>>2]=0;do if((t[(t[a>>2]|0)+20>>2]|0)>0){o=gAi[t[135744>>2]&511](t[(t[a>>2]|0)+20>>2]<<2)|0;t[(t[c>>2]|0)+44>>2]=o;if(t[(t[c>>2]|0)+44>>2]|0){VY(t[(t[c>>2]|0)+44>>2]|0,0,t[(t[a>>2]|0)+20>>2]<<2|0)|0;break}Eb(0,139408);t[f>>2]=-1;O=t[f>>2]|0;s=r;return O|0}else t[(t[c>>2]|0)+44>>2]=0;while(0);e:while(1){if(t[t[c>>2]>>2]|0)break;if(!(t[(t[c>>2]|0)+20>>2]|0))break;if(!(u[(t[(t[c>>2]|0)+64>>2]|0)+(t[(t[c>>2]|0)+56>>2]|0)>>0]|0)){if(!(t[(t[c>>2]|0)+20>>2]|0))break;if((t[t[(t[c>>2]|0)+20>>2]>>2]|0)==2)break}t[k>>2]=1;if((u[(t[(t[c>>2]|0)+64>>2]|0)+(t[(t[c>>2]|0)+56>>2]|0)>>0]|0|0)==0?(t[(t[c>>2]|0)+44>>2]|0)==0:0){if((t[(t[c>>2]|0)+24>>2]|0)<(t[(t[(t[c>>2]|0)+20>>2]|0)+24>>2]|0)){t[w>>2]=(t[(t[(t[c>>2]|0)+20>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0);if((t[(t[w>>2]|0)+4>>2]|0)>=0){t[d>>2]=t[t[w>>2]>>2];if((t[(t[d>>2]|0)+12>>2]|0)==0?(t[(t[d>>2]|0)+16>>2]|0)>0:0)A=17}else A=17}}else A=17;i:do if((A|0)==17){A=0;t[(t[c>>2]|0)+28>>2]=0;r:while(1){if((t[(t[c>>2]|0)+24>>2]|0)>=(t[(t[(t[c>>2]|0)+20>>2]|0)+24>>2]|0)){A=88;break}t[w>>2]=(t[(t[(t[c>>2]|0)+20>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0);n:do if((t[(t[w>>2]|0)+4>>2]|0)>=0){t[d>>2]=t[t[w>>2]>>2];t[l>>2]=0;t[h>>2]=1;do if((t[(t[w>>2]|0)+12>>2]|0)>=0){if(!(t[(t[c>>2]|0)+44>>2]|0)){A=22;break e}t[m>>2]=t[(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+12>>2]<<2)>>2];t[_>>2]=(t[(t[(t[c>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[w>>2]|0)+12>>2]<<3);if((t[m>>2]|0)>=(t[t[_>>2]>>2]|0))M=(t[m>>2]|0)<=(t[(t[_>>2]|0)+4>>2]|0);else M=0;t[l>>2]=M&1;if((t[l>>2]|0)!=0?(t[t[_>>2]>>2]|0)!=(t[(t[_>>2]|0)+4>>2]|0):0)t[h>>2]=0}else{if(!(t[d>>2]|0)){A=29;break r}if(!(u[(t[(t[c>>2]|0)+64>>2]|0)+(t[(t[c>>2]|0)+56>>2]|0)>>0]|0)){if(t[(t[d>>2]|0)+12>>2]|0)break;if((t[(t[d>>2]|0)+16>>2]|0)<=0)break;t[(t[c>>2]|0)+28>>2]=1;t[k>>2]=0;t[l>>2]=1;break}t[b>>2]=Mp(0,(t[(t[c>>2]|0)+64>>2]|0)+(t[(t[c>>2]|0)+56>>2]|0)|0,k)|0;t[l>>2]=$b(t[d>>2]|0,t[b>>2]|0)|0;if(((t[l>>2]|0)==1?(t[(t[d>>2]|0)+12>>2]|0)>=0:0)?(t[(t[d>>2]|0)+16>>2]|0)>0:0){t[p>>2]=t[(t[(t[a>>2]|0)+8>>2]|0)+(t[(t[w>>2]|0)+4>>2]<<2)>>2];if((t[(t[w>>2]|0)+8>>2]|0)>=0){if(!(t[(t[c>>2]|0)+44>>2]|0)){A=38;break e}if(!(t[(t[c>>2]|0)+8>>2]|0)){A=38;break e}if(!(t[(t[(t[c>>2]|0)+8>>2]|0)+24>>2]|0)){A=38;break e}t[E>>2]=(t[(t[(t[c>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<3);if((t[(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<2)>>2]|0)>=(t[(t[E>>2]|0)+4>>2]|0))break n;o=(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<2)|0;t[o>>2]=(t[o>>2]|0)+1}if((t[(t[(t[c>>2]|0)+20>>2]|0)+24>>2]|0)>((t[(t[c>>2]|0)+24>>2]|0)+1|0))Kb(t[c>>2]|0);t[(t[c>>2]|0)+28>>2]=1;do{if((t[(t[c>>2]|0)+28>>2]|0)==(t[(t[d>>2]|0)+16>>2]|0))break;o=(t[c>>2]|0)+56|0;t[o>>2]=(t[o>>2]|0)+(t[k>>2]|0);if(!(u[(t[(t[c>>2]|0)+64>>2]|0)+(t[(t[c>>2]|0)+56>>2]|0)>>0]|0)){A=46;break}if((t[(t[c>>2]|0)+28>>2]|0)>=(t[(t[d>>2]|0)+12>>2]|0)){t[S>>2]=t[(t[c>>2]|0)+24>>2];t[g>>2]=t[(t[c>>2]|0)+20>>2];t[(t[c>>2]|0)+24>>2]=-1;t[(t[c>>2]|0)+20>>2]=t[p>>2];Kb(t[c>>2]|0);t[(t[c>>2]|0)+24>>2]=t[S>>2];t[(t[c>>2]|0)+20>>2]=t[g>>2]}t[b>>2]=Mp(0,(t[(t[c>>2]|0)+64>>2]|0)+(t[(t[c>>2]|0)+56>>2]|0)|0,k)|0;t[l>>2]=$b(t[d>>2]|0,t[b>>2]|0)|0;o=(t[c>>2]|0)+28|0;t[o>>2]=(t[o>>2]|0)+1}while((t[l>>2]|0)==1);if((A|0)==46){A=0;o=(t[c>>2]|0)+56|0;t[o>>2]=(t[o>>2]|0)-(t[k>>2]|0)}if((t[(t[c>>2]|0)+28>>2]|0)<(t[(t[d>>2]|0)+12>>2]|0))t[l>>2]=0;if((t[l>>2]|0)<0)t[l>>2]=0;if(!(t[l>>2]|0))break i;if((t[(t[w>>2]|0)+8>>2]|0)<0)break;if(!(t[(t[c>>2]|0)+44>>2]|0)){A=57;break e}o=(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<2)|0;t[o>>2]=(t[o>>2]|0)+-1;break}if(((t[l>>2]|0)==0?(t[(t[d>>2]|0)+12>>2]|0)==0:0)?(t[(t[d>>2]|0)+16>>2]|0)>0:0){t[(t[c>>2]|0)+28>>2]=1;t[k>>2]=0;t[l>>2]=1}}while(0);if((t[l>>2]|0)!=1)if((t[l>>2]|0)<0){A=86;break r}else break;if((t[(t[w>>2]|0)+16>>2]|0)!=1){if(((t[h>>2]|0)==0?(t[(t[w>>2]|0)+12>>2]|0)>=0:0)?(t[(t[(t[c>>2]|0)+20>>2]|0)+24>>2]|0)>((t[(t[c>>2]|0)+24>>2]|0)+1|0):0)A=70}else A=70;if((A|0)==70){A=0;Kb(t[c>>2]|0)}if((t[(t[w>>2]|0)+8>>2]|0)<0)break r;if(!(t[(t[c>>2]|0)+44>>2]|0)){A=75;break e}if(!(t[(t[c>>2]|0)+8>>2]|0)){A=75;break e}if(!(t[(t[(t[c>>2]|0)+8>>2]|0)+24>>2]|0)){A=75;break e}t[y>>2]=(t[(t[(t[c>>2]|0)+8>>2]|0)+24>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<3);if((t[(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<2)>>2]|0)<(t[(t[y>>2]|0)+4>>2]|0)){A=77;break r}}while(0);o=(t[c>>2]|0)+24|0;t[o>>2]=(t[o>>2]|0)+1}if((A|0)==29){A=0;xe(t[v>>2]|0,139424,n|0)|0;t[t[c>>2]>>2]=-2;A=88}else if((A|0)==77){A=0;o=(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+8>>2]<<2)|0;t[o>>2]=(t[o>>2]|0)+1}else if((A|0)==86){A=0;t[t[c>>2]>>2]=-4;A=88}if((A|0)==88){A=0;if(t[(t[c>>2]|0)+24>>2]|0)break;if(!(t[(t[(t[c>>2]|0)+20>>2]|0)+24>>2]|0))break;else continue e}if((t[(t[w>>2]|0)+12>>2]|0)>=0?(t[(t[w>>2]|0)+12>>2]|0)<1193046:0){if(!(t[(t[c>>2]|0)+44>>2]|0)){A=81;break e}t[(t[(t[c>>2]|0)+44>>2]|0)+(t[(t[w>>2]|0)+12>>2]<<2)>>2]=0}t[(t[c>>2]|0)+20>>2]=t[(t[(t[a>>2]|0)+8>>2]|0)+(t[(t[w>>2]|0)+4>>2]<<2)>>2];t[(t[c>>2]|0)+24>>2]=0;if(!(t[t[w>>2]>>2]|0))continue e;o=(t[c>>2]|0)+56|0;t[o>>2]=(t[o>>2]|0)+(t[k>>2]|0);continue e}while(0);t[(t[c>>2]|0)+4>>2]=0;Xb(t[c>>2]|0)}if((A|0)==22)t[t[c>>2]>>2]=-1;else if((A|0)==38)t[t[c>>2]>>2]=-1;else if((A|0)==57)t[t[c>>2]>>2]=-1;else if((A|0)==75)t[t[c>>2]>>2]=-1;else if((A|0)==81)t[t[c>>2]>>2]=-1;if(t[(t[c>>2]|0)+40>>2]|0){e:do if(t[(t[c>>2]|0)+44>>2]|0){t[F>>2]=0;while(1){if((t[F>>2]|0)>=(t[(t[c>>2]|0)+32>>2]|0))break e;if(t[(t[(t[c>>2]|0)+40>>2]|0)+(t[F>>2]<<4)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[c>>2]|0)+40>>2]|0)+(t[F>>2]<<4)+12>>2]|0);t[F>>2]=(t[F>>2]|0)+1}}while(0);pAi[t[135736>>2]&511](t[(t[c>>2]|0)+40>>2]|0)}if(!(t[(t[c>>2]|0)+20>>2]|0)){t[f>>2]=-1;O=t[f>>2]|0;s=r;return O|0}if(t[(t[c>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[c>>2]|0)+44>>2]|0);if(!(t[t[c>>2]>>2]|0)){t[f>>2]=1;O=t[f>>2]|0;s=r;return O|0}F=t[c>>2]|0;if((t[t[c>>2]>>2]|0)!=-1){t[f>>2]=t[F>>2];O=t[f>>2]|0;s=r;return O|0}if((t[F+88>>2]|0)>1e7){t[f>>2]=-1;O=t[f>>2]|0;s=r;return O|0}else{t[f>>2]=0;O=t[f>>2]|0;s=r;return O|0}return 0}function Cb(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0);if(t[(t[r>>2]|0)+40>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Pb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+48|0;r=i+40|0;n=i+36|0;f=i+32|0;u=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+4|0;h=i;t[n>>2]=e;t[k>>2]=1;t[h>>2]=1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+68>>2]|0)!=-1){t[r>>2]=t[e+68>>2];w=t[r>>2]|0;s=i;return w|0}if(t[e+76>>2]&1)t[h>>2]=0;t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[n>>2]|0)+48>>2]|0))break;t[a>>2]=t[(t[(t[n>>2]|0)+52>>2]|0)+(t[f>>2]<<2)>>2];e:do if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+24>>2]|0)>=2:0){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[a>>2]|0)+24>>2]|0))break e;t[o>>2]=(t[(t[a>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0);i:do if((t[t[o>>2]>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)!=-1:0){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[u>>2]|0))break i;t[c>>2]=(t[(t[a>>2]|0)+28>>2]|0)+((t[b>>2]|0)*20|0);do if(((((t[(t[c>>2]|0)+4>>2]|0)!=-1?(t[t[c>>2]>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==(t[(t[c>>2]|0)+4>>2]|0):0)?(ek(t[t[o>>2]>>2]|0,t[t[c>>2]>>2]|0,t[h>>2]|0)|0)!=0:0)?(t[(t[o>>2]|0)+8>>2]|0)==(t[(t[c>>2]|0)+8>>2]|0):0){if((t[(t[o>>2]|0)+12>>2]|0)!=(t[(t[c>>2]|0)+12>>2]|0))break;t[(t[c>>2]|0)+4>>2]=-1}while(0);t[b>>2]=(t[b>>2]|0)+1}}while(0);t[u>>2]=(t[u>>2]|0)+1}}while(0);t[f>>2]=(t[f>>2]|0)+1}t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[n>>2]|0)+48>>2]|0))break;t[a>>2]=t[(t[(t[n>>2]|0)+52>>2]|0)+(t[f>>2]<<2)>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+24>>2]|0)>=2:0){t[l>>2]=0;t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[a>>2]|0)+24>>2]|0))break;t[o>>2]=(t[(t[a>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0);e:do if((t[t[o>>2]>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)!=-1:0){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[u>>2]|0))break e;t[c>>2]=(t[(t[a>>2]|0)+28>>2]|0)+((t[b>>2]|0)*20|0);do if((t[(t[c>>2]|0)+4>>2]|0)!=-1){h=t[o>>2]|0;if(t[t[c>>2]>>2]|0){if(!(ik(t[h>>2]|0,t[t[c>>2]>>2]|0,1)|0))break;t[k>>2]=0;t[(t[o>>2]|0)+16>>2]=1;t[(t[c>>2]|0)+16>>2]=1;t[l>>2]=t[o>>2];break}if((t[h+4>>2]|0)!=-1?(t[k>>2]=rk(t[n>>2]|0,t[(t[(t[n>>2]|0)+52>>2]|0)+(t[(t[o>>2]|0)+4>>2]<<2)>>2]|0,t[(t[c>>2]|0)+4>>2]|0,t[t[c>>2]>>2]|0)|0,(t[k>>2]|0)==0):0){t[(t[o>>2]|0)+16>>2]=1;t[l>>2]=t[o>>2]}}while(0);t[b>>2]=(t[b>>2]|0)+1}}while(0);t[u>>2]=(t[u>>2]|0)+1}if(t[l>>2]|0)t[(t[l>>2]|0)+16>>2]=2}t[f>>2]=(t[f>>2]|0)+1}t[(t[n>>2]|0)+68>>2]=t[k>>2];t[r>>2]=t[k>>2];w=t[r>>2]|0;s=i;return w|0}function Bb(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+52>>2]|0))break;nk(t[(t[(t[r>>2]|0)+56>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}if(t[(t[r>>2]|0)+56>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0);if((t[(t[r>>2]|0)+4>>2]|0)==5?(t[(t[r>>2]|0)+20>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0);if((t[(t[r>>2]|0)+4>>2]|0)==5?(t[(t[r>>2]|0)+24>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);if((t[(t[r>>2]|0)+4>>2]|0)==136?(t[(t[r>>2]|0)+20>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Ib(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[a>>2]|0)){Eb(t[f>>2]|0,139360);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{f=(t[a>>2]|0)+0|0;i=f+64|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(i|0));t[(t[a>>2]|0)+4>>2]=t[u>>2];t[(t[a>>2]|0)+8>>2]=2;t[(t[a>>2]|0)+12>>2]=0;t[(t[a>>2]|0)+16>>2]=0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function Hb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f+40|0;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;d=f+4|0;v=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[l>>2]|0)){t[(t[a>>2]|0)+8>>2]=1450;Rb(t[a>>2]|0,139280);t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}if((t[(t[l>>2]|0)+4>>2]|0)==4){if((zb(t[a>>2]|0,t[l>>2]|0)|0)<0){t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}if(((t[c>>2]|0)!=0?(t[(t[l>>2]|0)+44>>2]|0)!=(t[c>>2]|0):0)?(t[(t[l>>2]|0)+8>>2]|0)!=8:0)jb(t[a>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[c>>2]|0);n=t[(t[l>>2]|0)+8>>2]|0;do if((n|0)==8){if(t[c>>2]|0)t[w>>2]=t[c>>2];else{t[w>>2]=Ob(t[a>>2]|0)|0;Ab(t[a>>2]|0,t[w>>2]|0)|0}do if((t[(t[l>>2]|0)+12>>2]|0)==0?(t[(t[l>>2]|0)+40>>2]|0)==0:0){t[d>>2]=fk(t[a>>2]|0,t[l>>2]|0)|0;if(!(t[d>>2]|0)){t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}t[(t[d>>2]|0)+8>>2]=2;t[(t[d>>2]|0)+12>>2]=0;t[(t[d>>2]|0)+16>>2]=0;if((Hb(t[a>>2]|0,t[(t[l>>2]|0)+36>>2]|0,0,t[d>>2]|0)|0)>=0){t[h>>2]=t[(t[a>>2]|0)+24>>2];t[k>>2]=xb(t[a>>2]|0)|0;t[(t[(t[a>>2]|0)+64>>2]|0)+(t[k>>2]<<3)>>2]=(t[(t[l>>2]|0)+12>>2]|0)-1;t[(t[(t[a>>2]|0)+64>>2]|0)+(t[k>>2]<<3)+4>>2]=(t[(t[l>>2]|0)+16>>2]|0)-1;qb(t[a>>2]|0,t[h>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[k>>2]|0);Yb(t[a>>2]|0,t[h>>2]|0,t[w>>2]|0,t[k>>2]|0);jb(t[a>>2]|0,t[(t[l>>2]|0)+36>>2]|0,t[w>>2]|0);break}t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}else _=26;while(0);if((_|0)==26?(t[k>>2]=xb(t[a>>2]|0)|0,t[(t[(t[a>>2]|0)+64>>2]|0)+(t[k>>2]<<3)>>2]=(t[(t[l>>2]|0)+12>>2]|0)-1,t[(t[(t[a>>2]|0)+64>>2]|0)+(t[k>>2]<<3)+4>>2]=(t[(t[l>>2]|0)+16>>2]|0)-1,qb(t[a>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[(t[l>>2]|0)+36>>2]|0,t[k>>2]|0),Yb(t[a>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[w>>2]|0,t[k>>2]|0),(t[(t[l>>2]|0)+12>>2]|0)==0):0)jb(t[a>>2]|0,t[(t[l>>2]|0)+40>>2]|0,t[w>>2]|0);t[(t[l>>2]|0)+12>>2]=0;t[(t[l>>2]|0)+16>>2]=0;t[(t[l>>2]|0)+8>>2]=2;t[(t[a>>2]|0)+24>>2]=t[w>>2]}else if((n|0)==4){t[(t[l>>2]|0)+8>>2]=2;jb(t[a>>2]|0,t[(t[l>>2]|0)+36>>2]|0,t[(t[l>>2]|0)+44>>2]|0);jb(t[a>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[(t[l>>2]|0)+36>>2]|0)}else if((n|0)==3){t[(t[l>>2]|0)+8>>2]=2;r=t[a>>2]|0;i=t[(t[l>>2]|0)+36>>2]|0;if(!(t[c>>2]|0)){jb(r,i,0);jb(t[a>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[(t[a>>2]|0)+24>>2]|0);break}else{jb(r,i,t[c>>2]|0);break}}else if((n|0)==5){t[(t[l>>2]|0)+8>>2]=2;jb(t[a>>2]|0,t[(t[l>>2]|0)+44>>2]|0,t[(t[l>>2]|0)+36>>2]|0)}while(0);t[u>>2]=0;m=t[u>>2]|0;s=f;return m|0}else{if(((t[(t[l>>2]|0)+12>>2]|0)==0?(t[(t[l>>2]|0)+16>>2]|0)==0:0)?(t[(t[l>>2]|0)+8>>2]|0)==8:0){do if(!(t[c>>2]|0)){t[c>>2]=Ob(t[a>>2]|0)|0;if(t[c>>2]|0){Ab(t[a>>2]|0,t[c>>2]|0)|0;break}t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}while(0);jb(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);t[(t[a>>2]|0)+24>>2]=t[c>>2];Bb(t[l>>2]|0);t[u>>2]=0;m=t[u>>2]|0;s=f;return m|0}do if(!(t[c>>2]|0)){t[c>>2]=Ob(t[a>>2]|0)|0;if(t[c>>2]|0){Ab(t[a>>2]|0,t[c>>2]|0)|0;break}t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}while(0);t[b>>2]=t[c>>2];if(!((t[(t[l>>2]|0)+8>>2]|0)!=4?(t[(t[l>>2]|0)+8>>2]|0)!=5:0))_=44;do if((_|0)==44){t[v>>2]=Ob(t[a>>2]|0)|0;if(t[v>>2]|0){Ab(t[a>>2]|0,t[v>>2]|0)|0;jb(t[a>>2]|0,t[v>>2]|0,t[c>>2]|0);t[c>>2]=t[v>>2];break}t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}while(0);if((zb(t[a>>2]|0,t[l>>2]|0)|0)<0){t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}Ub(t[a>>2]|0,t[o>>2]|0,t[l>>2]|0,t[c>>2]|0,-1,-1);t[(t[a>>2]|0)+24>>2]=t[b>>2];b=t[(t[l>>2]|0)+8>>2]|0;if((b|0)==5){t[(t[l>>2]|0)+8>>2]=2;Ub(t[a>>2]|0,t[c>>2]|0,t[l>>2]|0,t[c>>2]|0,-1,-1)}else if((b|0)==3){t[(t[l>>2]|0)+8>>2]=2;jb(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)}else if((b|0)==4){t[(t[l>>2]|0)+8>>2]=2;jb(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);Ub(t[a>>2]|0,t[c>>2]|0,t[l>>2]|0,t[c>>2]|0,-1,-1)}t[u>>2]=0;m=t[u>>2]|0;s=f;return m|0}return 0}function xb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;e=t[n>>2]|0;do if(!(t[(t[n>>2]|0)+56>>2]|0)){t[e+56>>2]=4;u=gAi[t[135744>>2]&511](t[(t[n>>2]|0)+56>>2]<<3)|0;t[(t[n>>2]|0)+64>>2]=u;if(!(t[(t[n>>2]|0)+64>>2]|0)){Eb(t[n>>2]|0,139168);t[(t[n>>2]|0)+56>>2]=0;t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}}else if((t[e+60>>2]|0)>=(t[(t[n>>2]|0)+56>>2]|0)){u=(t[n>>2]|0)+56|0;t[u>>2]=t[u>>2]<<1;t[f>>2]=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+64>>2]|0,t[(t[n>>2]|0)+56>>2]<<3)|0;if(t[f>>2]|0){t[(t[n>>2]|0)+64>>2]=t[f>>2];break}Eb(t[n>>2]|0,139168);u=(t[n>>2]|0)+56|0;t[u>>2]=(t[u>>2]|0)/2|0;t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}while(0);t[(t[(t[n>>2]|0)+64>>2]|0)+(t[(t[n>>2]|0)+60>>2]<<3)>>2]=-1;t[(t[(t[n>>2]|0)+64>>2]|0)+(t[(t[n>>2]|0)+60>>2]<<3)+4>>2]=-1;f=(t[n>>2]|0)+60|0;n=t[f>>2]|0;t[f>>2]=n+1;t[r>>2]=n;a=t[r>>2]|0;s=i;return a|0}function Ub(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;if(!(t[c>>2]|0)){t[(t[o>>2]|0)+8>>2]=1450;Rb(t[o>>2]|0,139192);s=a;return}if(!(t[b>>2]|0)){t[(t[o>>2]|0)+8>>2]=1450;Rb(t[o>>2]|0,139224);s=a;return}t[w>>2]=(t[(t[c>>2]|0)+24>>2]|0)-1;while(1){if((t[w>>2]|0)<0)break;t[d>>2]=(t[(t[c>>2]|0)+28>>2]|0)+((t[w>>2]|0)*20|0);if((((t[t[d>>2]>>2]|0)==(t[l>>2]|0)?(t[(t[d>>2]|0)+4>>2]|0)==(t[(t[b>>2]|0)+16>>2]|0):0)?(t[(t[d>>2]|0)+8>>2]|0)==(t[k>>2]|0):0)?(t[(t[d>>2]|0)+12>>2]|0)==(t[h>>2]|0):0){m=20;break}t[w>>2]=(t[w>>2]|0)+-1}if((m|0)==20){s=a;return}m=t[c>>2]|0;do if(!(t[(t[c>>2]|0)+20>>2]|0)){t[m+20>>2]=8;w=gAi[t[135744>>2]&511]((t[(t[c>>2]|0)+20>>2]|0)*20|0)|0;t[(t[c>>2]|0)+28>>2]=w;if(!(t[(t[c>>2]|0)+28>>2]|0)){Eb(t[o>>2]|0,139256);t[(t[c>>2]|0)+20>>2]=0;s=a;return}}else if((t[m+24>>2]|0)>=(t[(t[c>>2]|0)+20>>2]|0)){w=(t[c>>2]|0)+20|0;t[w>>2]=t[w>>2]<<1;t[v>>2]=MAi[t[135760>>2]&511](t[(t[c>>2]|0)+28>>2]|0,(t[(t[c>>2]|0)+20>>2]|0)*20|0)|0;if(t[v>>2]|0){t[(t[c>>2]|0)+28>>2]=t[v>>2];break}Eb(t[o>>2]|0,139256);w=(t[c>>2]|0)+20|0;t[w>>2]=(t[w>>2]|0)/2|0;s=a;return}while(0);t[(t[(t[c>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0)>>2]=t[l>>2];t[(t[(t[c>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0)+4>>2]=t[(t[b>>2]|0)+16>>2];t[(t[(t[c>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0)+8>>2]=t[k>>2];t[(t[(t[c>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0)+12>>2]=t[h>>2];t[(t[(t[c>>2]|0)+28>>2]|0)+((t[(t[c>>2]|0)+24>>2]|0)*20|0)+16>>2]=0;h=(t[c>>2]|0)+24|0;t[h>>2]=(t[h>>2]|0)+1;tk(t[o>>2]|0,t[b>>2]|0,t[(t[c>>2]|0)+16>>2]|0);s=a;return}function zb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;if(!(t[u>>2]|0)){t[i+8>>2]=1450;Rb(t[f>>2]|0,139128);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}e=t[f>>2]|0;do if(!(t[i+32>>2]|0)){t[e+32>>2]=4;c=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+32>>2]<<2)|0;t[(t[f>>2]|0)+40>>2]=c;if(!(t[(t[f>>2]|0)+40>>2]|0)){Eb(t[f>>2]|0,139152);t[(t[f>>2]|0)+32>>2]=0;t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}}else if((t[e+36>>2]|0)>=(t[(t[f>>2]|0)+32>>2]|0)){c=(t[f>>2]|0)+32|0;t[c>>2]=t[c>>2]<<1;t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+40>>2]|0,t[(t[f>>2]|0)+32>>2]<<2)|0;if(t[a>>2]|0){t[(t[f>>2]|0)+40>>2]=t[a>>2];break}Eb(t[f>>2]|0,139168);c=(t[f>>2]|0)+32|0;t[c>>2]=(t[c>>2]|0)/2|0;t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(0);t[t[u>>2]>>2]=t[(t[f>>2]|0)+36>>2];a=t[u>>2]|0;u=(t[f>>2]|0)+36|0;e=t[u>>2]|0;t[u>>2]=e+1;t[(t[(t[f>>2]|0)+40>>2]|0)+(e<<2)>>2]=a;t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function jb(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[a>>2]|0)){t[a>>2]=Ob(t[f>>2]|0)|0;Ab(t[f>>2]|0,t[a>>2]|0)|0;t[(t[f>>2]|0)+24>>2]=t[a>>2]}Ub(t[f>>2]|0,t[u>>2]|0,0,t[a>>2]|0,-1,-1);s=n;return}function Vb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[o>>2]|0)){t[o>>2]=Ob(t[u>>2]|0)|0;Ab(t[u>>2]|0,t[o>>2]|0)|0;t[(t[u>>2]|0)+24>>2]=t[o>>2]}n=t[u>>2]|0;u=t[a>>2]|0;a=t[o>>2]|0;if(t[c>>2]|0){Ub(n,u,0,a,-1,1193047);s=f;return}else{Ub(n,u,0,a,-1,1193046);s=f;return}}function qb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[o>>2]|0)){t[o>>2]=Ob(t[u>>2]|0)|0;Ab(t[u>>2]|0,t[o>>2]|0)|0;t[(t[u>>2]|0)+24>>2]=t[o>>2]}Ub(t[u>>2]|0,t[a>>2]|0,0,t[o>>2]|0,t[c>>2]|0,-1);s=f;return}function Yb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[o>>2]|0)){t[o>>2]=Ob(t[u>>2]|0)|0;Ab(t[u>>2]|0,t[o>>2]|0)|0;t[(t[u>>2]|0)+24>>2]=t[o>>2]}Ub(t[u>>2]|0,t[a>>2]|0,0,t[o>>2]|0,-1,t[c>>2]|0);s=f;return}function Gb(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=t[f>>2]|0;do if(!(t[(t[f>>2]|0)+48>>2]|0)){t[r+48>>2]=4;i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+48>>2]<<3)|0;t[(t[f>>2]|0)+68>>2]=i;if(!(t[(t[f>>2]|0)+68>>2]|0)){Eb(0,140240);t[(t[f>>2]|0)+48>>2]=0;s=n;return}}else if(((t[r+52>>2]|0)+1|0)>=(t[(t[f>>2]|0)+48>>2]|0)){i=(t[f>>2]|0)+48|0;t[i>>2]=t[i>>2]<<1;t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+68>>2]|0,t[(t[f>>2]|0)+48>>2]<<3)|0;if(t[o>>2]|0){t[(t[f>>2]|0)+68>>2]=t[o>>2];break}Eb(0,140240);i=(t[f>>2]|0)+48|0;t[i>>2]=(t[i>>2]|0)/2|0;s=n;return}while(0);o=Yl(t[u>>2]|0)|0;t[(t[(t[f>>2]|0)+68>>2]|0)+(t[(t[f>>2]|0)+52>>2]<<3)>>2]=o;t[(t[(t[f>>2]|0)+68>>2]|0)+(t[(t[f>>2]|0)+52>>2]<<3)+4>>2]=t[a>>2];a=(t[f>>2]|0)+52|0;t[a>>2]=(t[a>>2]|0)+1;t[(t[(t[f>>2]|0)+68>>2]|0)+(t[(t[f>>2]|0)+52>>2]<<3)>>2]=0;t[(t[(t[f>>2]|0)+68>>2]|0)+(t[(t[f>>2]|0)+52>>2]<<3)+4>>2]=0;s=n;return}function Wb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;if((t[f>>2]|0)==(t[a>>2]|0)){t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}if(!(t[f>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(!(t[a>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}e:do i:do if((u[t[f>>2]>>0]|0|0)!=(u[t[a>>2]>>0]|0|0)){if((u[t[a>>2]>>0]|0|0)==42){t[o>>2]=t[a>>2];t[a>>2]=t[f>>2];t[f>>2]=t[o>>2]}if(!(u[t[a>>2]>>0]|0)){l=15;break e}if(!(u[t[f>>2]>>0]|0)){l=15;break e}i=t[f>>2]|0;t[f>>2]=i+1;if((u[i>>0]|0|0)!=42){l=15;break e}do{if((u[t[a>>2]>>0]|0|0)==124)break i;t[a>>2]=(t[a>>2]|0)+1}while((u[t[a>>2]>>0]|0|0)!=0)}else{t[f>>2]=(t[f>>2]|0)+1;t[a>>2]=(t[a>>2]|0)+1}while(0);while((u[t[a>>2]>>0]|0|0)!=0);if((l|0)==15){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(u[t[f>>2]>>0]|0){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}return 0}function Kb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if((t[(t[r>>2]|0)+88>>2]|0)>1e7){s=i;return}e=(t[r>>2]|0)+88|0;t[e>>2]=(t[e>>2]|0)+1;e=t[r>>2]|0;do if(t[(t[r>>2]|0)+32>>2]|0){if((t[e+36>>2]|0)>=(t[(t[r>>2]|0)+32>>2]|0)){t[f>>2]=t[(t[r>>2]|0)+32>>2];u=(t[r>>2]|0)+32|0;t[u>>2]=t[u>>2]<<1;t[n>>2]=MAi[t[135760>>2]&511](t[(t[r>>2]|0)+40>>2]|0,t[(t[r>>2]|0)+32>>2]<<4)|0;if(t[n>>2]|0){t[(t[r>>2]|0)+40>>2]=t[n>>2];t[n>>2]=(t[(t[r>>2]|0)+40>>2]|0)+(t[f>>2]<<4);VY(t[n>>2]|0,0,(t[(t[r>>2]|0)+32>>2]|0)-(t[f>>2]|0)<<4|0)|0;break}Eb(0,139496);u=(t[r>>2]|0)+32|0;t[u>>2]=(t[u>>2]|0)/2|0;s=i;return}}else{t[e+32>>2]=4;u=gAi[t[135744>>2]&511](t[(t[r>>2]|0)+32>>2]<<4)|0;t[(t[r>>2]|0)+40>>2]=u;if(t[(t[r>>2]|0)+40>>2]|0){VY(t[(t[r>>2]|0)+40>>2]|0,0,t[(t[r>>2]|0)+32>>2]<<4|0)|0;break}Eb(0,139496);t[(t[r>>2]|0)+32>>2]=0;s=i;return}while(0);t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)>>2]=t[(t[r>>2]|0)+20>>2];t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+4>>2]=t[(t[r>>2]|0)+56>>2];t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+8>>2]=(t[(t[r>>2]|0)+24>>2]|0)+1;if((t[(t[(t[r>>2]|0)+8>>2]|0)+20>>2]|0)>0){if((t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+12>>2]|0)==0?(e=gAi[t[135744>>2]&511](t[(t[(t[r>>2]|0)+8>>2]|0)+20>>2]<<2)|0,t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+12>>2]=e,(t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+12>>2]|0)==0):0){Eb(0,139496);t[t[r>>2]>>2]=-5;s=i;return}YY(t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+12>>2]|0,t[(t[r>>2]|0)+44>>2]|0,t[(t[(t[r>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0}e=(t[r>>2]|0)+36|0;t[e>>2]=(t[e>>2]|0)+1;s=i;return}function Xb(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;t[r>>2]=e;e=t[r>>2]|0;if((t[(t[r>>2]|0)+36>>2]|0)<=0){t[e>>2]=-1;s=i;return}n=e+36|0;t[n>>2]=(t[n>>2]|0)+-1;t[(t[r>>2]|0)+20>>2]=t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)>>2];t[(t[r>>2]|0)+56>>2]=t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+4>>2];t[(t[r>>2]|0)+24>>2]=t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+8>>2];if((t[(t[(t[r>>2]|0)+8>>2]|0)+20>>2]|0)<=0){s=i;return}if(!(t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+12>>2]|0)){xe(t[v>>2]|0,139464,i|0)|0;t[t[r>>2]>>2]=-6;s=i;return}if(!(t[(t[r>>2]|0)+44>>2]|0)){s=i;return}YY(t[(t[r>>2]|0)+44>>2]|0,t[(t[(t[r>>2]|0)+40>>2]|0)+(t[(t[r>>2]|0)+36>>2]<<4)+12>>2]|0,t[(t[(t[r>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0;s=i;return}function Zb(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[(t[f>>2]|0)+24>>2];t[c>>2]=uk(t[f>>2]|0)|0;do if(t[c>>2]|0){i=t[f>>2]|0;e=t[o>>2]|0;if((u[t[(t[f>>2]|0)+4>>2]>>0]|0|0)!=124?(u[t[(t[f>>2]|0)+4>>2]>>0]|0|0)!=41:0)l=0;else l=t[a>>2]|0;if((Hb(i,e,l,t[(t[f>>2]|0)+28>>2]|0)|0)>=0){t[o>>2]=t[(t[f>>2]|0)+24>>2];t[(t[f>>2]|0)+28>>2]=0;break}t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}while(0);while(1){if(!(t[c>>2]|0)){k=17;break}if(t[(t[f>>2]|0)+8>>2]|0){k=17;break}t[c>>2]=uk(t[f>>2]|0)|0;if(!(t[c>>2]|0))continue;l=t[f>>2]|0;e=t[o>>2]|0;if((u[t[(t[f>>2]|0)+4>>2]>>0]|0|0)!=124?(u[t[(t[f>>2]|0)+4>>2]>>0]|0|0)!=41:0)h=0;else h=t[a>>2]|0;if((Hb(l,e,h,t[(t[f>>2]|0)+28>>2]|0)|0)<0){k=15;break}t[o>>2]=t[(t[f>>2]|0)+24>>2];t[(t[f>>2]|0)+28>>2]=0}if((k|0)==15){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}else if((k|0)==17){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function Jb(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[r>>2]=e;t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;t[o>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[n>>2]<<2)>>2];if(((((((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+24>>2]|0)==1:0)?(t[t[o>>2]>>2]|0)!=5:0)?(t[t[(t[o>>2]|0)+28>>2]>>2]|0)==0:0)?(t[(t[(t[o>>2]|0)+28>>2]|0)+4>>2]|0)>=0:0)?(t[(t[(t[o>>2]|0)+28>>2]|0)+4>>2]|0)!=(t[n>>2]|0):0)?(t[(t[(t[o>>2]|0)+28>>2]|0)+8>>2]|0)<0:0)?(t[(t[(t[o>>2]|0)+28>>2]|0)+12>>2]|0)<0:0)?(t[a>>2]=t[(t[(t[o>>2]|0)+28>>2]|0)+4>>2],(t[t[o>>2]>>2]|0)!=1):0){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[o>>2]|0)+36>>2]|0))break;t[c>>2]=t[(t[(t[r>>2]|0)+52>>2]|0)+(t[(t[(t[o>>2]|0)+40>>2]|0)+(t[f>>2]<<2)>>2]<<2)>>2];t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[c>>2]|0)+24>>2]|0))break;if((t[(t[(t[c>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0)+4>>2]|0)==(t[n>>2]|0)){t[(t[(t[c>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0)+4>>2]=-1;Ub(t[r>>2]|0,t[c>>2]|0,t[(t[(t[c>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0)>>2]|0,t[(t[(t[r>>2]|0)+52>>2]|0)+(t[a>>2]<<2)>>2]|0,t[(t[(t[c>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0)+8>>2]|0,t[(t[(t[c>>2]|0)+28>>2]|0)+((t[u>>2]|0)*20|0)+12>>2]|0)}t[u>>2]=(t[u>>2]|0)+1}t[f>>2]=(t[f>>2]|0)+1}if((t[t[o>>2]>>2]|0)==2)t[t[(t[(t[r>>2]|0)+52>>2]|0)+(t[a>>2]<<2)>>2]>>2]=2;t[(t[o>>2]|0)+24>>2]=0;t[t[o>>2]>>2]=5}t[n>>2]=(t[n>>2]|0)+1}s=i;return}function Qb(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[b>>2]=t[(t[(t[u>>2]|0)+52>>2]|0)+(t[a>>2]<<2)>>2];if(!(t[b>>2]|0)){s=f;return}t[k>>2]=t[(t[(t[u>>2]|0)+52>>2]|0)+(t[o>>2]<<2)>>2];if(!(t[k>>2]|0)){s=f;return}if((t[(t[k>>2]|0)+4>>2]|0)==1){s=f;return}if((t[(t[k>>2]|0)+4>>2]|0)==2){s=f;return}t[(t[k>>2]|0)+4>>2]=2;if((t[t[k>>2]>>2]|0)==2)t[t[b>>2]>>2]=2;t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[(t[k>>2]|0)+24>>2]|0))break;do if((t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+4>>2]|0)>=0){o=t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+4>>2]|0;if(t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)>>2]|0){t[w>>2]=o;n=t[u>>2]|0;r=t[b>>2]|0;i=t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)>>2]|0;e=t[(t[(t[u>>2]|0)+52>>2]|0)+(t[w>>2]<<2)>>2]|0;if((t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+8>>2]|0)>=0){Ub(n,r,i,e,t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+8>>2]|0,-1);break}else{Ub(n,r,i,e,t[c>>2]|0,-1);break}}if((o|0)!=(t[a>>2]|0)){o=(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)|0;if((t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+12>>2]|0)>=0){t[h>>2]=t[o+4>>2];Ub(t[u>>2]|0,t[b>>2]|0,0,t[(t[(t[u>>2]|0)+52>>2]|0)+(t[h>>2]<<2)>>2]|0,-1,t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+12>>2]|0);break}e=t[u>>2]|0;i=t[a>>2]|0;r=t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+4>>2]|0;if((t[o+8>>2]|0)>=0){Qb(e,i,r,t[(t[(t[k>>2]|0)+28>>2]|0)+((t[l>>2]|0)*20|0)+8>>2]|0);break}else{Qb(e,i,r,t[c>>2]|0);break}}}while(0);t[l>>2]=(t[l>>2]|0)+1}t[(t[k>>2]|0)+4>>2]=0;s=f;return}function $b(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;t[u>>2]=e;t[a>>2]=i;t[c>>2]=0;do if(t[u>>2]|0){i=t[a>>2]|0;if((t[a>>2]|0)<256){if(!(9<=(i|0)&(t[a>>2]|0)<=10|(t[a>>2]|0)==13|32<=(t[a>>2]|0)))break}else if((!(256<=(i|0)&(t[a>>2]|0)<=55295)?!(57344<=(t[a>>2]|0)&(t[a>>2]|0)<=65533):0)?!(65536<=(t[a>>2]|0)&(t[a>>2]|0)<=1114111):0)break;switch(t[(t[u>>2]|0)+4>>2]|0){case 136:case 135:case 134:case 133:case 132:case 131:case 130:case 129:
	case 128:case 127:case 126:case 125:case 124:case 123:case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 114:case 113:case 112:case 111:case 110:case 109:case 108:case 107:case 106:case 105:case 104:case 103:case 102:case 101:case 100:case 16:case 15:case 14:case 13:case 12:case 11:case 10:case 9:case 8:case 7:case 6:{t[c>>2]=ak(t[(t[u>>2]|0)+4>>2]|0,t[a>>2]|0,0,0,0,t[(t[u>>2]|0)+20>>2]|0)|0;if(t[(t[u>>2]|0)+28>>2]|0)t[c>>2]=((t[c>>2]|0)!=0^1)&1;break}case 2:{t[f>>2]=(t[a>>2]|0)==(t[(t[u>>2]|0)+32>>2]|0)&1;k=t[f>>2]|0;s=r;return k|0}case 3:{t[b>>2]=0;t[o>>2]=0;e:while(1){if((t[o>>2]|0)>=(t[(t[u>>2]|0)+52>>2]|0)){h=23;break}t[l>>2]=t[(t[(t[u>>2]|0)+56>>2]|0)+(t[o>>2]<<2)>>2];i=t[l>>2]|0;do if((t[t[l>>2]>>2]|0)==2){t[c>>2]=ak(t[i+4>>2]|0,t[a>>2]|0,0,t[(t[l>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+12>>2]|0,t[(t[l>>2]|0)+16>>2]|0)|0;if(t[c>>2]|0){h=15;break e}}else{e=(t[i>>2]|0)!=0;t[c>>2]=ak(t[(t[l>>2]|0)+4>>2]|0,t[a>>2]|0,0,t[(t[l>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+12>>2]|0,t[(t[l>>2]|0)+16>>2]|0)|0;w=t[c>>2]|0;if(e){if(w){h=19;break e}t[b>>2]=1;break}else{if(!w)break;t[b>>2]=1;break}}while(0);t[o>>2]=(t[o>>2]|0)+1}if((h|0)==15){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}else if((h|0)==19){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}else if((h|0)==23){t[f>>2]=t[b>>2];k=t[f>>2]|0;s=r;return k|0}break}case 5:{Je(139376,n|0)|0;t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}case 1:case 4:{t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}default:{}}t[f>>2]=t[c>>2];k=t[f>>2]|0;s=r;return k|0}while(0);t[f>>2]=-1;k=t[f>>2]|0;s=r;return k|0}function ek(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[u>>2]|0)==(t[a>>2]|0)){t[f>>2]=1;l=t[f>>2]|0;s=n;return l|0}if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+4>>2]|0)!=(t[(t[a>>2]|0)+4>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=t[(t[u>>2]|0)+4>>2]|0;do if((r|0)==1)t[c>>2]=0;else if((r|0)==2)t[c>>2]=(t[(t[u>>2]|0)+32>>2]|0)==(t[(t[a>>2]|0)+32>>2]|0)&1;else if((r|0)==3)t[c>>2]=0;else if((r|0)==5){i=t[(t[u>>2]|0)+20>>2]|0;e=t[(t[a>>2]|0)+20>>2]|0;if(t[o>>2]|0){t[c>>2]=Xl(i,e)|0;break}else{t[c>>2]=(i|0)==(e|0)&1;break}}while(0);t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function ik(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=1;if((t[u>>2]|0)==(t[a>>2]|0)){t[f>>2]=1;v=t[f>>2]|0;s=n;return v|0}if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if((t[(t[u>>2]|0)+4>>2]|0)!=6?(t[(t[a>>2]|0)+4>>2]|0)!=6:0){if((t[(t[u>>2]|0)+4>>2]|0)>>>0>(t[(t[a>>2]|0)+4>>2]|0)>>>0){t[l>>2]=t[u>>2];t[u>>2]=t[a>>2];t[a>>2]=t[l>>2]}if((t[(t[u>>2]|0)+4>>2]|0)!=(t[(t[a>>2]|0)+4>>2]|0)?(t[c>>2]=ok(t[(t[u>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+4>>2]|0)|0,(t[c>>2]|0)==0):0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}l=t[(t[u>>2]|0)+4>>2]|0;do if((l|0)==5){r=t[(t[u>>2]|0)+20>>2]|0;i=t[(t[a>>2]|0)+20>>2]|0;if(t[o>>2]|0){t[c>>2]=Wb(r,i)|0;m=30;break}else{t[c>>2]=(r|0)!=(i|0)&1;m=30;break}}else if((l|0)==2)if((t[(t[a>>2]|0)+4>>2]|0)==2){t[c>>2]=(t[(t[u>>2]|0)+32>>2]|0)==(t[(t[a>>2]|0)+32>>2]|0)&1;m=30;break}else{i=$b(t[a>>2]|0,t[(t[u>>2]|0)+32>>2]|0)|0;t[c>>2]=i;t[c>>2]=(t[c>>2]|0)<0?1:i;m=30;break}else if((l|0)==3)if((t[(t[a>>2]|0)+4>>2]|0)==3){t[b>>2]=0;e:while(1){if((t[b>>2]|0)>=(t[(t[u>>2]|0)+52>>2]|0)){m=29;break}t[k>>2]=0;while(1){_=t[b>>2]|0;if((t[k>>2]|0)>=(t[(t[a>>2]|0)+52>>2]|0))break;t[w>>2]=t[(t[(t[u>>2]|0)+56>>2]|0)+(_<<2)>>2];t[d>>2]=t[(t[(t[a>>2]|0)+56>>2]|0)+(t[k>>2]<<2)>>2];t[h>>2]=ck(t[w>>2]|0,t[d>>2]|0)|0;if((t[h>>2]|0)==1){m=26;break e}t[k>>2]=(t[k>>2]|0)+1}t[b>>2]=_+1}if((m|0)==26){t[c>>2]=1;m=30;break}else if((m|0)==29){t[c>>2]=0;m=30;break}}else m=30;while(0);if((m|0)==30){if((t[(t[u>>2]|0)+28>>2]|0)!=(t[(t[a>>2]|0)+28>>2]|0))t[c>>2]=((t[c>>2]|0)!=0^1)&1;if(!(t[c>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}}t[f>>2]=1;v=t[f>>2]|0;s=n;return v|0}t[f>>2]=1;v=t[f>>2]|0;s=n;return v|0}function rk(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;f=s;s=s+48|0;u=f+40|0;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;d=f+4|0;v=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=1;t[v>>2]=1;if(!(t[o>>2]|0)){t[u>>2]=t[b>>2];m=t[u>>2]|0;s=f;return m|0}if((t[(t[o>>2]|0)+8>>2]|0)==2){t[u>>2]=t[b>>2];m=t[u>>2]|0;s=f;return m|0}if(t[(t[a>>2]|0)+76>>2]&1)t[v>>2]=0;t[w>>2]=t[(t[o>>2]|0)+24>>2];t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[w>>2]|0))break;t[d>>2]=(t[(t[o>>2]|0)+28>>2]|0)+((t[h>>2]|0)*20|0);n=t[(t[d>>2]|0)+4>>2]|0;if(!(t[t[d>>2]>>2]|0)){if((n|0)>=0?(t[(t[o>>2]|0)+8>>2]=2,t[k>>2]=rk(t[a>>2]|0,t[(t[(t[a>>2]|0)+52>>2]|0)+(t[(t[d>>2]|0)+4>>2]<<2)>>2]|0,t[c>>2]|0,t[l>>2]|0)|0,t[(t[o>>2]|0)+8>>2]=0,(t[k>>2]|0)==0):0)t[b>>2]=0}else if((n|0)==(t[c>>2]|0)?(ik(t[t[d>>2]>>2]|0,t[l>>2]|0,t[v>>2]|0)|0)!=0:0){t[b>>2]=0;t[(t[d>>2]|0)+16>>2]=1}t[h>>2]=(t[h>>2]|0)+1}t[u>>2]=t[b>>2];m=t[u>>2]|0;s=f;return m|0}function nk(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function fk(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[a>>2]|0)){Eb(t[f>>2]|0,139320);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}i=(t[a>>2]|0)+0|0;e=i+64|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[a>>2]|0)+4>>2]=t[(t[u>>2]|0)+4>>2];t[(t[a>>2]|0)+8>>2]=t[(t[u>>2]|0)+8>>2];t[(t[a>>2]|0)+12>>2]=t[(t[u>>2]|0)+12>>2];t[(t[a>>2]|0)+16>>2]=t[(t[u>>2]|0)+16>>2];e:do if((t[(t[u>>2]|0)+52>>2]|0)>0){i=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+52>>2]<<2)|0;t[(t[a>>2]|0)+56>>2]=i;i:do if(!(t[(t[a>>2]|0)+56>>2]|0))Eb(t[f>>2]|0,139320);else{t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[u>>2]|0)+52>>2]|0))break e;i=lk(t[f>>2]|0,t[(t[(t[u>>2]|0)+56>>2]|0)+(t[o>>2]<<2)>>2]|0)|0;t[(t[(t[a>>2]|0)+56>>2]|0)+(t[o>>2]<<2)>>2]=i;if(!(t[(t[(t[a>>2]|0)+56>>2]|0)+(t[o>>2]<<2)>>2]|0))break i;t[(t[a>>2]|0)+52>>2]=(t[o>>2]|0)+1;t[o>>2]=(t[o>>2]|0)+1}}while(0);Bb(t[a>>2]|0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}while(0);t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}function tk(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=t[u>>2]|0;do if(!(t[(t[u>>2]|0)+32>>2]|0)){t[r+32>>2]=8;i=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+32>>2]<<2)|0;t[(t[u>>2]|0)+40>>2]=i;if(!(t[(t[u>>2]|0)+40>>2]|0)){Eb(t[f>>2]|0,139256);t[(t[u>>2]|0)+32>>2]=0;s=n;return}}else if((t[r+36>>2]|0)>=(t[(t[u>>2]|0)+32>>2]|0)){i=(t[u>>2]|0)+32|0;t[i>>2]=t[i>>2]<<1;t[o>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+40>>2]|0,t[(t[u>>2]|0)+32>>2]<<2)|0;if(t[o>>2]|0){t[(t[u>>2]|0)+40>>2]=t[o>>2];break}Eb(t[f>>2]|0,139256);i=(t[u>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)/2|0;s=n;return}while(0);t[(t[(t[u>>2]|0)+40>>2]|0)+(t[(t[u>>2]|0)+36>>2]<<2)>>2]=t[a>>2];a=(t[u>>2]|0)+36|0;t[a>>2]=(t[a>>2]|0)+1;s=n;return}function uk(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[(t[n>>2]|0)+28>>2]=0;t[f>>2]=sk(t[n>>2]|0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if(!(t[(t[n>>2]|0)+28>>2]|0)){t[(t[n>>2]|0)+8>>2]=1450;Rb(t[n>>2]|0,139592)}bk(t[n>>2]|0)|0;t[r>>2]=1;u=t[r>>2]|0;s=i;return u|0}function ak(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;do switch(t[c>>2]|0){case 128:{t[d>>2]=pI(t[l>>2]|0)|0;break}case 104:{t[d>>2]=$B(t[l>>2]|0)|0;break}case 109:{t[d>>2]=tI(t[l>>2]|0)|0;break}case 108:{t[d>>2]=fI(t[l>>2]|0)|0;break}case 10:{t[b>>2]=((t[b>>2]|0)!=0^1)&1;v=14;break}case 112:{t[d>>2]=cI(t[l>>2]|0)|0;break}case 105:{t[d>>2]=eI(t[l>>2]|0)|0;break}case 9:{v=14;break}case 113:{t[d>>2]=lI(t[l>>2]|0)|0;break}case 110:{t[d>>2]=aI(t[l>>2]|0)|0;break}case 116:{t[d>>2]=kI(t[l>>2]|0)|0;break}case 115:{t[d>>2]=bI(t[l>>2]|0)|0;break}case 102:{t[d>>2]=QB(t[l>>2]|0)|0;break}case 15:{t[b>>2]=((t[b>>2]|0)!=0^1)&1;v=49;break}case 121:{t[d>>2]=vI(t[l>>2]|0)|0;break}case 136:{t[d>>2]=GB(t[l>>2]|0,t[w>>2]|0)|0;break}case 134:{t[d>>2]=ZB(t[l>>2]|0)|0;break}case 135:{t[d>>2]=0;break}case 122:{t[d>>2]=yI(t[l>>2]|0)|0;break}case 6:{if((t[l>>2]|0)!=10)m=(t[l>>2]|0)!=13;else m=0;t[d>>2]=m&1;break}case 13:{v=47;break}case 111:{t[d>>2]=oI(t[l>>2]|0)|0;break}case 11:{v=27;break}case 12:{t[b>>2]=((t[b>>2]|0)!=0^1)&1;v=27;break}case 107:{t[d>>2]=uI(t[l>>2]|0)|0;break}case 123:{t[d>>2]=AI(t[l>>2]|0)|0;break}case 7:{v=10;break}case 8:{t[b>>2]=((t[b>>2]|0)!=0^1)&1;v=10;break}case 2:{if((t[l>>2]|0)>=(t[k>>2]|0))_=(t[l>>2]|0)<=(t[h>>2]|0);else _=0;t[d>>2]=_&1;break}case 133:{t[d>>2]=XB(t[l>>2]|0)|0;break}case 118:{t[d>>2]=hI(t[l>>2]|0)|0;break}case 124:{t[d>>2]=FI(t[l>>2]|0)|0;break}case 131:{t[d>>2]=WB(t[l>>2]|0)|0;break}case 132:{t[d>>2]=KB(t[l>>2]|0)|0;break}case 100:{t[d>>2]=JB(t[l>>2]|0)|0;break}case 103:{t[d>>2]=iI(t[l>>2]|0)|0;break}case 14:{t[b>>2]=((t[b>>2]|0)!=0^1)&1;v=47;break}case 1:case 3:case 4:case 5:{t[o>>2]=-1;p=t[o>>2]|0;s=a;return p|0}case 129:{t[d>>2]=EI(t[l>>2]|0)|0;break}case 130:{t[d>>2]=gI(t[l>>2]|0)|0;break}case 106:{t[d>>2]=nI(t[l>>2]|0)|0;break}case 125:{t[d>>2]=OI(t[l>>2]|0)|0;break}case 117:{t[d>>2]=mI(t[l>>2]|0)|0;break}case 101:{t[d>>2]=rI(t[l>>2]|0)|0;break}case 16:{v=49;break}case 126:{t[d>>2]=_I(t[l>>2]|0)|0;break}case 127:{t[d>>2]=SI(t[l>>2]|0)|0;break}case 120:{t[d>>2]=wI(t[l>>2]|0)|0;break}case 119:{t[d>>2]=dI(t[l>>2]|0)|0;break}case 114:{t[d>>2]=sI(t[l>>2]|0)|0;break}default:{}}while(0);if((v|0)==10){if((t[l>>2]|0)==10|(t[l>>2]|0)==13|(t[l>>2]|0)==9)E=1;else E=(t[l>>2]|0)==32;t[d>>2]=E&1}else if((v|0)==14){E=t[l>>2]|0;if((t[l>>2]|0)<256)if(((!(65<=(E|0)&(t[l>>2]|0)<=90)?!(97<=(t[l>>2]|0)&(t[l>>2]|0)<=122):0)?!(192<=(t[l>>2]|0)&(t[l>>2]|0)<=214):0)?!(216<=(t[l>>2]|0)&(t[l>>2]|0)<=246|248<=(t[l>>2]|0)):0)v=20;else S=1;else if(dj(E,199744)|0)S=1;else v=20;do if((v|0)==20){E=t[l>>2]|0;if((t[l>>2]|0)<256){if((E|0)==95){S=1;break}}else{if(19968<=(E|0)&(t[l>>2]|0)<=40869|(t[l>>2]|0)==12295){S=1;break}if(12321<=(t[l>>2]|0)&(t[l>>2]|0)<=12329|(t[l>>2]|0)==95){S=1;break}}S=(t[l>>2]|0)==58}while(0);t[d>>2]=S&1}else if((v|0)==27){S=t[l>>2]|0;if((t[l>>2]|0)<256)if(((!(65<=(S|0)&(t[l>>2]|0)<=90)?!(97<=(t[l>>2]|0)&(t[l>>2]|0)<=122):0)?!(192<=(t[l>>2]|0)&(t[l>>2]|0)<=214):0)?!(216<=(t[l>>2]|0)&(t[l>>2]|0)<=246|248<=(t[l>>2]|0)):0)v=33;else g=1;else if(dj(S,199744)|0)g=1;else v=33;do if((v|0)==33){if((t[l>>2]|0)>=256){if(19968<=(t[l>>2]|0)&(t[l>>2]|0)<=40869|(t[l>>2]|0)==12295){g=1;break}if(12321<=(t[l>>2]|0)&(t[l>>2]|0)<=12329){g=1;break}}S=t[l>>2]|0;if((t[l>>2]|0)<256){if(48<=(S|0)&(t[l>>2]|0)<=57|(t[l>>2]|0)==46|(t[l>>2]|0)==45|(t[l>>2]|0)==95|(t[l>>2]|0)==58){g=1;break}}else{E=(dj(S,200216)|0)!=0;if(E|(t[l>>2]|0)==46|(t[l>>2]|0)==45|(t[l>>2]|0)==95|(t[l>>2]|0)==58){g=1;break}}if((t[l>>2]|0)>=256?(dj(t[l>>2]|0,200144)|0)!=0:0){g=1;break}E=t[l>>2]|0;if((t[l>>2]|0)<256)y=(E|0)==183&1;else y=dj(E,200272)|0;g=(y|0)!=0}while(0);t[d>>2]=g&1}else if((v|0)==47)t[d>>2]=oI(t[l>>2]|0)|0;else if((v|0)==49){t[d>>2]=sI(t[l>>2]|0)|0;if(!(t[d>>2]|0))t[d>>2]=yI(t[l>>2]|0)|0;if(!(t[d>>2]|0))t[d>>2]=WB(t[l>>2]|0)|0}l=t[d>>2]|0;if(t[b>>2]|0){t[o>>2]=((l|0)!=0^1)&1;p=t[o>>2]|0;s=a;return p|0}else{t[o>>2]=l;p=t[o>>2]|0;s=a;return p|0}return 0}function ok(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[f>>2]|0)==1|(t[f>>2]|0)==2|(t[f>>2]|0)==3|(t[f>>2]|0)==4|(t[f>>2]|0)==5|(t[f>>2]|0)==6)t[n>>2]=1;else{if((t[u>>2]|0)==1|(t[u>>2]|0)==2|(t[u>>2]|0)==3|(t[u>>2]|0)==4|(t[u>>2]|0)==5|(t[u>>2]|0)==6){t[n>>2]=1;break}if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=1;break}if((t[f>>2]|0)>>>0>(t[u>>2]|0)>>>0){t[a>>2]=t[f>>2];t[f>>2]=t[u>>2];t[u>>2]=t[a>>2]}i:do switch(t[f>>2]|0){case 100:{if((t[u>>2]|0)>>>0<=105){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 132:case 133:case 134:case 135:{t[n>>2]=0;break e;break}case 126:{if((t[u>>2]|0)>>>0<=130){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 106:{if((t[u>>2]|0)>>>0<=109){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 13:{if((((((!((t[u>>2]|0)==14|(t[u>>2]|0)==15)?!((t[u>>2]|0)>>>0>=100&(t[u>>2]|0)>>>0<=105):0)?!((t[u>>2]|0)>>>0>=106&(t[u>>2]|0)>>>0<=109):0)?!((t[u>>2]|0)>>>0>=114&(t[u>>2]|0)>>>0<=121):0)?!((t[u>>2]|0)>>>0>=122&(t[u>>2]|0)>>>0<=125):0)?!((t[u>>2]|0)>>>0>=126&(t[u>>2]|0)>>>0<=130):0)?!((t[u>>2]|0)>>>0>=131&(t[u>>2]|0)>>>0<=135):0)break i;t[n>>2]=0;break e;break}case 131:{if((t[u>>2]|0)>>>0<=135){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 15:{if((((((t[u>>2]|0)!=14?!((t[u>>2]|0)>>>0>=106&(t[u>>2]|0)>>>0<=109):0)?!((t[u>>2]|0)>>>0>=114&(t[u>>2]|0)>>>0<=121):0)?!((t[u>>2]|0)>>>0>=122&(t[u>>2]|0)>>>0<=125):0)?!((t[u>>2]|0)>>>0>=126&(t[u>>2]|0)>>>0<=130):0)?!((t[u>>2]|0)>>>0>=131&(t[u>>2]|0)>>>0<=135):0)break i;t[n>>2]=0;break e;break}case 7:{if((((((t[u>>2]|0)!=8?!((t[u>>2]|0)>>>0>=100&(t[u>>2]|0)>>>0<=105):0)?!((t[u>>2]|0)>>>0>=110&(t[u>>2]|0)>>>0<=113):0)?!((t[u>>2]|0)>>>0>=106&(t[u>>2]|0)>>>0<=109):0)?!((t[u>>2]|0)>>>0>=114&(t[u>>2]|0)>>>0<=121):0)?!((t[u>>2]|0)>>>0>=126&(t[u>>2]|0)>>>0<=130):0)break i;t[n>>2]=0;break e;break}case 125:case 124:case 123:{t[n>>2]=0;break e;break}case 105:case 104:case 103:case 102:case 101:{t[n>>2]=0;break e;break}case 11:{if((((((t[u>>2]|0)!=12?!((t[u>>2]|0)>>>0>=106&(t[u>>2]|0)>>>0<=109):0)?!((t[u>>2]|0)>>>0>=114&(t[u>>2]|0)>>>0<=121):0)?!((t[u>>2]|0)>>>0>=122&(t[u>>2]|0)>>>0<=125):0)?!((t[u>>2]|0)>>>0>=126&(t[u>>2]|0)>>>0<=130):0)?!((t[u>>2]|0)>>>0>=131&(t[u>>2]|0)>>>0<=135):0)break i;t[n>>2]=0;break e;break}case 110:{if((t[u>>2]|0)>>>0<=113){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 121:case 120:case 119:case 118:case 117:case 116:case 115:{t[n>>2]=0;break e;break}case 9:{if(((((((t[u>>2]|0)!=10?!((t[u>>2]|0)>>>0>=110&(t[u>>2]|0)>>>0<=113):0)?!((t[u>>2]|0)>>>0>=106&(t[u>>2]|0)>>>0<=109):0)?!((t[u>>2]|0)>>>0>=122&(t[u>>2]|0)>>>0<=125):0)?!((t[u>>2]|0)>>>0>=114&(t[u>>2]|0)>>>0<=121):0)?!((t[u>>2]|0)>>>0>=126&(t[u>>2]|0)>>>0<=130):0)?!((t[u>>2]|0)>>>0>=131&(t[u>>2]|0)>>>0<=135):0)break i;t[n>>2]=0;break e;break}case 122:{if((t[u>>2]|0)>>>0<=125){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 114:{if((t[u>>2]|0)>>>0<=121){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 130:case 129:case 128:case 127:{t[n>>2]=0;break e;break}case 113:case 112:case 111:{t[n>>2]=0;break e;break}case 109:case 108:case 107:{t[n>>2]=0;break e;break}default:{}}while(0);t[n>>2]=1}while(0);s=r;return t[n>>2]|0}function ck(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((((((t[(t[f>>2]|0)+4>>2]|0)!=3?(t[(t[u>>2]|0)+4>>2]|0)!=3:0)?(t[(t[u>>2]|0)+4>>2]|0)!=4:0)?(t[(t[f>>2]|0)+4>>2]|0)!=4:0)?(t[(t[f>>2]|0)+4>>2]|0)!=5:0)?(t[(t[u>>2]|0)+4>>2]|0)!=5:0){if((t[(t[f>>2]|0)+4>>2]|0)>>>0>(t[(t[u>>2]|0)+4>>2]|0)>>>0){t[o>>2]=t[f>>2];t[f>>2]=t[u>>2];t[u>>2]=t[o>>2]}e:do if((t[(t[f>>2]|0)+4>>2]|0)!=6?(t[(t[u>>2]|0)+4>>2]|0)!=6:0){if((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[u>>2]|0)+4>>2]|0)!=1:0){o=t[(t[f>>2]|0)+4>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==(t[(t[u>>2]|0)+4>>2]|0)){if((o|0)!=2){t[a>>2]=1;break}if((t[(t[f>>2]|0)+12>>2]|0)>=(t[(t[u>>2]|0)+8>>2]|0)?(t[(t[u>>2]|0)+12>>2]|0)>=(t[(t[f>>2]|0)+8>>2]|0):0){t[a>>2]=1;break}t[a>>2]=0;break}if((o|0)==2){t[l>>2]=0;if((t[t[f>>2]>>2]|0)==0?(t[t[u>>2]>>2]|0)!=0:0)b=28;else b=26;if(((b|0)==26?(t[t[f>>2]>>2]|0)!=0:0)?(t[t[u>>2]>>2]|0)==0:0)b=28;if((b|0)==28)t[l>>2]=1;t[c>>2]=t[(t[f>>2]|0)+8>>2];while(1){if((t[c>>2]|0)>(t[(t[f>>2]|0)+12>>2]|0)){b=37;break}t[a>>2]=ak(t[(t[u>>2]|0)+4>>2]|0,t[c>>2]|0,0,t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+12>>2]|0,t[(t[u>>2]|0)+16>>2]|0)|0;if((t[a>>2]|0)<0){b=32;break}if((t[l>>2]|0)==1&(t[a>>2]|0)==0){b=35;break}if((t[l>>2]|0)==0&(t[a>>2]|0)==1){b=35;break}t[c>>2]=(t[c>>2]|0)+1}if((b|0)==32){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((b|0)==35){t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}else if((b|0)==37){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}}if((t[(t[f>>2]|0)+4>>2]|0)!=136?(t[(t[u>>2]|0)+4>>2]|0)!=136:0){do if((t[(t[f>>2]|0)+4>>2]|0)>>>0>=100){if((t[(t[u>>2]|0)+4>>2]|0)>>>0<100)break;t[a>>2]=0;switch(t[(t[f>>2]|0)+4>>2]|0){case 106:{do if((t[(t[u>>2]|0)+4>>2]|0)!=107){if((t[(t[u>>2]|0)+4>>2]|0)==108)break;if((t[(t[u>>2]|0)+4>>2]|0)!=109)break e}while(0);t[a>>2]=1;break e;break}case 110:{do if((t[(t[u>>2]|0)+4>>2]|0)!=111){if((t[(t[u>>2]|0)+4>>2]|0)==112)break;if((t[(t[u>>2]|0)+4>>2]|0)!=113)break e}while(0);t[a>>2]=1;break e;break}case 114:{do if((t[(t[u>>2]|0)+4>>2]|0)!=115){if((t[(t[u>>2]|0)+4>>2]|0)==116)break;if((t[(t[u>>2]|0)+4>>2]|0)==117)break;if((t[(t[u>>2]|0)+4>>2]|0)==118)break;if((t[(t[u>>2]|0)+4>>2]|0)==119)break;if((t[(t[u>>2]|0)+4>>2]|0)==120)break;if((t[(t[u>>2]|0)+4>>2]|0)!=121)break e}while(0);t[a>>2]=1;break e;break}case 100:{do if((t[(t[u>>2]|0)+4>>2]|0)!=101){if((t[(t[u>>2]|0)+4>>2]|0)==102)break;if((t[(t[u>>2]|0)+4>>2]|0)==103)break;if((t[(t[u>>2]|0)+4>>2]|0)==104)break;if((t[(t[u>>2]|0)+4>>2]|0)!=105)break e}while(0);t[a>>2]=1;break e;break}case 131:{do if((t[(t[u>>2]|0)+4>>2]|0)!=132){if((t[(t[u>>2]|0)+4>>2]|0)==133)break;if((t[(t[u>>2]|0)+4>>2]|0)!=134)break e}while(0);t[a>>2]=1;break e;break}case 126:{do if((t[(t[u>>2]|0)+4>>2]|0)!=127){if((t[(t[u>>2]|0)+4>>2]|0)==128)break;if((t[(t[u>>2]|0)+4>>2]|0)==129)break;if((t[(t[u>>2]|0)+4>>2]|0)!=130)break e}while(0);t[a>>2]=1;break e;break}case 122:{do if((t[(t[u>>2]|0)+4>>2]|0)!=123){if((t[(t[u>>2]|0)+4>>2]|0)==124)break;if((t[(t[u>>2]|0)+4>>2]|0)!=125)break e}while(0);t[a>>2]=1;break e;break}default:{do if((t[(t[u>>2]|0)+4>>2]|0)>>>0>=100){if((t[(t[u>>2]|0)+4>>2]|0)>>>0>=136)break;t[a>>2]=0;break e}while(0);t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}}}while(0);do if((t[(t[f>>2]|0)+4>>2]|0)==7){if((t[(t[u>>2]|0)+4>>2]|0)!=8)break;t[a>>2]=0;break e}while(0);do if((t[(t[f>>2]|0)+4>>2]|0)==9){if((t[(t[u>>2]|0)+4>>2]|0)!=10)break;t[a>>2]=0;break e}while(0);do if((t[(t[f>>2]|0)+4>>2]|0)==11){if((t[(t[u>>2]|0)+4>>2]|0)!=12)break;t[a>>2]=0;break e}while(0);do if((t[(t[f>>2]|0)+4>>2]|0)==13){if((t[(t[u>>2]|0)+4>>2]|0)!=14)break;t[a>>2]=0;break e}while(0);do if((t[(t[f>>2]|0)+4>>2]|0)==15){if((t[(t[u>>2]|0)+4>>2]|0)!=16)break;t[a>>2]=0;break e}while(0);t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}if((t[(t[f>>2]|0)+4>>2]|0)==(t[(t[u>>2]|0)+4>>2]|0)){t[a>>2]=Xl(t[(t[f>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+16>>2]|0)|0;break}t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else b=12;while(0);if((b|0)==12)t[a>>2]=1;if((t[t[f>>2]>>2]|0)==0?(t[t[u>>2]>>2]|0)!=0:0)b=105;else b=103;if(((b|0)==103?(t[t[f>>2]>>2]|0)!=0:0)?(t[t[u>>2]>>2]|0)==0:0)b=105;if((b|0)==105)t[a>>2]=((t[a>>2]|0)!=0^1)&1;t[n>>2]=t[a>>2];k=t[n>>2]|0;s=r;return k|0}t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}function lk(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=kk(t[f>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+4>>2]|0,t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+16>>2]|0)!=0?(i=Yl(t[(t[u>>2]|0)+16>>2]|0)|0,t[(t[a>>2]|0)+16>>2]=i,(t[(t[a>>2]|0)+16>>2]|0)==0):0){Eb(t[f>>2]|0,139336);nk(t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function sk(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[n>>2]=e;t[f>>2]=hk(t[n>>2]|0)|0;e=t[n>>2]|0;if((t[f>>2]|0)>0){b=Ib(e,2)|0;t[(t[n>>2]|0)+28>>2]=b;if(!(t[(t[n>>2]|0)+28>>2]|0)){t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}else{t[f>>2]=Mp(0,t[(t[n>>2]|0)+4>>2]|0,a)|0;t[(t[(t[n>>2]|0)+28>>2]|0)+32>>2]=t[f>>2];f=(t[n>>2]|0)+4|0;t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);t[r>>2]=1;k=t[r>>2]|0;s=i;return k|0}}if((u[t[e+4>>2]>>0]|0|0)==124){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}if(!(u[t[(t[n>>2]|0)+4>>2]>>0]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)==41){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}e=(t[n>>2]|0)+4|0;a=t[e>>2]|0;if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)!=40){if(((u[a>>0]|0|0)!=91?(u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)!=92:0)?(u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)!=46:0){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}wk(t[n>>2]|0);t[r>>2]=1;k=t[r>>2]|0;s=i;return k|0}t[e>>2]=a+1;jb(t[n>>2]|0,t[(t[n>>2]|0)+24>>2]|0,0);t[l>>2]=t[(t[n>>2]|0)+24>>2];jb(t[n>>2]|0,t[(t[n>>2]|0)+24>>2]|0,0);t[o>>2]=t[(t[n>>2]|0)+24>>2];t[c>>2]=t[(t[n>>2]|0)+20>>2];t[(t[n>>2]|0)+20>>2]=0;t[(t[n>>2]|0)+28>>2]=0;Mb(t[n>>2]|0,0);a=t[n>>2]|0;if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)==41){e=a+4|0;t[e>>2]=(t[e>>2]|0)+1}else{t[a+8>>2]=1450;Rb(t[n>>2]|0,139672)}a=Ib(t[n>>2]|0,4)|0;t[(t[n>>2]|0)+28>>2]=a;if(!(t[(t[n>>2]|0)+28>>2]|0)){t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}else{t[(t[(t[n>>2]|0)+28>>2]|0)+36>>2]=t[o>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+40>>2]=t[l>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+44>>2]=t[(t[n>>2]|0)+24>>2];t[(t[n>>2]|0)+20>>2]=t[c>>2];t[r>>2]=1;k=t[r>>2]|0;s=i;return k|0}return 0}function bk(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[f>>2]=u[t[(t[n>>2]|0)+4>>2]>>0];if((t[f>>2]|0)==63|(t[f>>2]|0)==42|(t[f>>2]|0)==43){do if(t[(t[n>>2]|0)+28>>2]|0){if((t[f>>2]|0)==63){t[(t[(t[n>>2]|0)+28>>2]|0)+8>>2]=3;break}if((t[f>>2]|0)==42){t[(t[(t[n>>2]|0)+28>>2]|0)+8>>2]=4;break}if((t[f>>2]|0)==43)t[(t[(t[n>>2]|0)+28>>2]|0)+8>>2]=5}while(0);e=(t[n>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[r>>2]=1;c=t[r>>2]|0;s=i;return c|0}if((t[f>>2]|0)!=123){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=0;t[o>>2]=0;e=(t[n>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=dk(t[n>>2]|0)|0;if((t[f>>2]|0)>=0)t[a>>2]=t[f>>2];do if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)==44){e=(t[n>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)==125){t[o>>2]=2147483647;break}t[f>>2]=dk(t[n>>2]|0)|0;if((t[f>>2]|0)>=0){t[o>>2]=t[f>>2];break}else{t[(t[n>>2]|0)+8>>2]=1450;Rb(t[n>>2]|0,139624);break}}while(0);f=t[n>>2]|0;if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)==125){e=f+4|0;t[e>>2]=(t[e>>2]|0)+1}else{t[f+8>>2]=1450;Rb(t[n>>2]|0,139648)}if(!(t[o>>2]|0))t[o>>2]=t[a>>2];if(t[(t[n>>2]|0)+28>>2]|0){t[(t[(t[n>>2]|0)+28>>2]|0)+8>>2]=8;t[(t[(t[n>>2]|0)+28>>2]|0)+12>>2]=t[a>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+16>>2]=t[o>>2]}t[r>>2]=1;c=t[r>>2]|0;s=i;return c|0}function kk(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[h>>2]|0)){Eb(t[o>>2]|0,139336);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}else{t[t[h>>2]>>2]=t[c>>2];t[(t[h>>2]|0)+4>>2]=t[l>>2];t[(t[h>>2]|0)+8>>2]=t[b>>2];t[(t[h>>2]|0)+12>>2]=t[k>>2];t[a>>2]=t[h>>2];w=t[a>>2]|0;s=u;return w|0}return 0}function hk(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;t[n>>2]=e;t[f>>2]=Mp(0,t[(t[n>>2]|0)+4>>2]|0,i)|0;if((t[f>>2]|0)==46|(t[f>>2]|0)==92|(t[f>>2]|0)==63|(t[f>>2]|0)==42|(t[f>>2]|0)==43|(t[f>>2]|0)==40|(t[f>>2]|0)==41|(t[f>>2]|0)==124|(t[f>>2]|0)==91|(t[f>>2]|0)==93|(t[f>>2]|0)==0){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}else{t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function wk(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)!=91){mk(e);s=i;return}n=e+4|0;t[n>>2]=(t[n>>2]|0)+1;n=Ib(t[r>>2]|0,3)|0;t[(t[r>>2]|0)+28>>2]=n;if(!(t[(t[r>>2]|0)+28>>2]|0)){s=i;return}vk(t[r>>2]|0);n=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==93){e=n+4|0;t[e>>2]=(t[e>>2]|0)+1;s=i;return}else{t[n+8>>2]=1450;Rb(t[r>>2]|0,139704);s=i;return}}function dk(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[f>>2]=0;t[a>>2]=0;while(1){if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)<48)break;if((u[t[(t[n>>2]|0)+4>>2]>>0]|0|0)>57)break;t[f>>2]=((t[f>>2]|0)*10|0)+((u[t[(t[n>>2]|0)+4>>2]>>0]|0)-48);t[a>>2]=1;e=(t[n>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1}if((t[a>>2]|0)!=1){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}else{t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}return 0}function vk(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[n>>2]=t[(t[r>>2]|0)+12>>2];while(1){if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==93){o=13;break}if(t[(t[r>>2]|0)+8>>2]|0){o=13;break}e=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==94){t[f>>2]=t[e+12>>2];c=(t[r>>2]|0)+4|0;t[c>>2]=(t[c>>2]|0)+1;t[(t[r>>2]|0)+12>>2]=((t[(t[r>>2]|0)+12>>2]|0)!=0^1)&1;_k(t[r>>2]|0);t[(t[r>>2]|0)+12>>2]=t[f>>2];continue}if((u[t[e+4>>2]>>0]|0|0)==45?(u[(t[(t[r>>2]|0)+4>>2]|0)+1>>0]|0|0)==91:0){o=8;break}if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==93)continue;_k(t[r>>2]|0)}if((o|0)==8){t[a>>2]=t[(t[r>>2]|0)+12>>2];t[(t[r>>2]|0)+12>>2]=2;f=(t[r>>2]|0)+4|0;t[f>>2]=(t[f>>2]|0)+1;f=(t[r>>2]|0)+4|0;t[f>>2]=(t[f>>2]|0)+1;vk(t[r>>2]|0);f=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==93){e=f+4|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[r>>2]|0)+12>>2]=t[a>>2];l=t[n>>2]|0;b=t[r>>2]|0;k=b+12|0;t[k>>2]=l;s=i;return}else{t[f+8>>2]=1450;Rb(t[r>>2]|0,139968);l=t[n>>2]|0;b=t[r>>2]|0;k=b+12|0;t[k>>2]=l;s=i;return}}else if((o|0)==13){l=t[n>>2]|0;b=t[r>>2]|0;k=b+12|0;t[k>>2]=l;s=i;return}}function mk(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;e=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==46){a=t[r>>2]|0;if(t[e+28>>2]|0){if((t[(t[a+28>>2]|0)+4>>2]|0)==3)pk(t[r>>2]|0,t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+12>>2]|0,6,0,0,0)}else{o=Ib(a,6)|0;t[(t[r>>2]|0)+28>>2]=o}o=(t[r>>2]|0)+4|0;t[o>>2]=(t[o>>2]|0)+1;s=i;return}o=t[r>>2]|0;if((u[t[e+4>>2]>>0]|0|0)!=92){t[o+8>>2]=1450;Rb(t[r>>2]|0,139744);s=i;return}e=o+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==112){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;e=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)!=123){t[e+8>>2]=1450;Rb(t[r>>2]|0,139776);s=i;return}o=e+4|0;t[o>>2]=(t[o>>2]|0)+1;Ek(t[r>>2]|0);o=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)!=125){t[o+8>>2]=1450;Rb(t[r>>2]|0,139792);s=i;return}else{e=o+4|0;t[e>>2]=(t[e>>2]|0)+1;s=i;return}}if((t[n>>2]|0)==80){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;e=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)!=123){t[e+8>>2]=1450;Rb(t[r>>2]|0,139776);s=i;return}o=e+4|0;t[o>>2]=(t[o>>2]|0)+1;Ek(t[r>>2]|0);t[(t[(t[r>>2]|0)+28>>2]|0)+28>>2]=1;o=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)!=125){t[o+8>>2]=1450;Rb(t[r>>2]|0,139792);s=i;return}else{e=o+4|0;t[e>>2]=(t[e>>2]|0)+1;s=i;return}}if((t[n>>2]|0)==110|(t[n>>2]|0)==114|(t[n>>2]|0)==116|(t[n>>2]|0)==92|(t[n>>2]|0)==124|(t[n>>2]|0)==46|(t[n>>2]|0)==63|(t[n>>2]|0)==42|(t[n>>2]|0)==43|(t[n>>2]|0)==40|(t[n>>2]|0)==41|(t[n>>2]|0)==123|(t[n>>2]|0)==125|(t[n>>2]|0)==45|(t[n>>2]|0)==91|(t[n>>2]|0)==93|(t[n>>2]|0)==94){e=t[r>>2]|0;do if(!(t[(t[r>>2]|0)+28>>2]|0)){o=Ib(e,2)|0;t[(t[r>>2]|0)+28>>2]=o;if(t[(t[r>>2]|0)+28>>2]|0){o=t[n>>2]|0;if((o|0)==116){t[(t[(t[r>>2]|0)+28>>2]|0)+32>>2]=9;break}else if((o|0)==110){t[(t[(t[r>>2]|0)+28>>2]|0)+32>>2]=10;break}else if((o|0)==114){t[(t[(t[r>>2]|0)+28>>2]|0)+32>>2]=13;break}else{t[(t[(t[r>>2]|0)+28>>2]|0)+32>>2]=t[n>>2];break}}}else if((t[(t[e+28>>2]|0)+4>>2]|0)==3){o=t[n>>2]|0;if((o|0)==110)t[n>>2]=10;else if((o|0)==114)t[n>>2]=13;else if((o|0)==116)t[n>>2]=9;pk(t[r>>2]|0,t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+12>>2]|0,2,t[n>>2]|0,t[n>>2]|0,0)}while(0);e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;s=i;return}if(!((t[n>>2]|0)==115|(t[n>>2]|0)==83|(t[n>>2]|0)==105|(t[n>>2]|0)==73|(t[n>>2]|0)==99|(t[n>>2]|0)==67|(t[n>>2]|0)==100|(t[n>>2]|0)==68|(t[n>>2]|0)==119|(t[n>>2]|0)==87)){t[(t[r>>2]|0)+8>>2]=1450;Rb(t[r>>2]|0,139808);s=i;return}t[f>>2]=7;do switch(t[n>>2]|0){case 115:{t[f>>2]=7;break}case 83:{t[f>>2]=8;break}case 99:{t[f>>2]=11;break}case 67:{t[f>>2]=12;break}case 119:{t[f>>2]=15;break}case 87:{t[f>>2]=16;break}case 105:{t[f>>2]=9;break}case 73:{t[f>>2]=10;break}case 100:{t[f>>2]=13;break}case 68:{t[f>>2]=14;break}default:{}}while(0);n=(t[r>>2]|0)+4|0;t[n>>2]=(t[n>>2]|0)+1;n=t[r>>2]|0;if(!(t[(t[r>>2]|0)+28>>2]|0)){e=Ib(n,t[f>>2]|0)|0;t[(t[r>>2]|0)+28>>2]=e;s=i;return}if((t[(t[n+28>>2]|0)+4>>2]|0)!=3){s=i;return}pk(t[r>>2]|0,t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+12>>2]|0,t[f>>2]|0,0,0,0);s=i;return}function _k(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;while(1){e=t[r>>2]|0;if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==92)mk(e);else Sk(e);if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==93){n=10;break}if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==94){n=10;break}if((u[t[(t[r>>2]|0)+4>>2]>>0]|0|0)==45){n=10;break}if(!(u[t[(t[r>>2]|0)+4>>2]>>0]|0)){n=10;break}if(t[(t[r>>2]|0)+8>>2]|0){n=10;break}}if((n|0)==10){s=i;return}}function pk(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+24|0;k=o+20|0;h=o+16|0;w=o+12|0;d=o+8|0;v=o+4|0;m=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;if(!(t[l>>2]|0)){t[(t[c>>2]|0)+8>>2]=1450;Rb(t[c>>2]|0,139896);s=o;return}if((t[(t[l>>2]|0)+4>>2]|0)!=3){t[(t[c>>2]|0)+8>>2]=1450;Rb(t[c>>2]|0,139920);s=o;return}a=t[l>>2]|0;do if(!(t[(t[l>>2]|0)+48>>2]|0)){t[a+48>>2]=4;u=gAi[t[135744>>2]&511](t[(t[l>>2]|0)+48>>2]<<2)|0;t[(t[l>>2]|0)+56>>2]=u;if(!(t[(t[l>>2]|0)+56>>2]|0)){Eb(t[c>>2]|0,139952);t[(t[l>>2]|0)+48>>2]=0;s=o;return}}else if((t[a+52>>2]|0)>=(t[(t[l>>2]|0)+48>>2]|0)){u=(t[l>>2]|0)+48|0;t[u>>2]=t[u>>2]<<1;t[m>>2]=MAi[t[135760>>2]&511](t[(t[l>>2]|0)+56>>2]|0,t[(t[l>>2]|0)+48>>2]<<2)|0;if(t[m>>2]|0){t[(t[l>>2]|0)+56>>2]=t[m>>2];break}Eb(t[c>>2]|0,139952);u=(t[l>>2]|0)+48|0;t[u>>2]=(t[u>>2]|0)/2|0;s=o;return}while(0);t[v>>2]=kk(t[c>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;if(!(t[v>>2]|0)){s=o;return}t[(t[v>>2]|0)+16>>2]=t[d>>2];d=t[v>>2]|0;v=(t[l>>2]|0)+52|0;w=t[v>>2]|0;t[v>>2]=w+1;t[(t[(t[l>>2]|0)+56>>2]|0)+(w<<2)>>2]=d;s=o;return}function Ek(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=0;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];do if((t[n>>2]|0)==76){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==117){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=101;break}if((t[n>>2]|0)==108){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=102;break}if((t[n>>2]|0)==116){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=103;break}if((t[n>>2]|0)==109){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=104;break}if((t[n>>2]|0)==111){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=105;break}else{t[f>>2]=100;break}}else{if((t[n>>2]|0)==77){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==110){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=107;break}if((t[n>>2]|0)==99){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=108;break}if((t[n>>2]|0)==101){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=109;break}else{t[f>>2]=106;break}}if((t[n>>2]|0)==78){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==100){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=111;break}if((t[n>>2]|0)==108){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=112;break}if((t[n>>2]|0)==111){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=113;break}else{t[f>>2]=110;break}}if((t[n>>2]|0)==80){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==99){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=115;break}if((t[n>>2]|0)==100){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=116;break}if((t[n>>2]|0)==115){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=117;break}if((t[n>>2]|0)==101){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=118;break}if((t[n>>2]|0)==105){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=119;break}if((t[n>>2]|0)==102){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=120;break}if((t[n>>2]|0)==111){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=121;break}else{t[f>>2]=114;break}}if((t[n>>2]|0)==90){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;
	t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==115){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=123;break}if((t[n>>2]|0)==108){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=124;break}if((t[n>>2]|0)==112){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=125;break}else{t[f>>2]=122;break}}if((t[n>>2]|0)==83){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==109){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=127;break}if((t[n>>2]|0)==99){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=128;break}if((t[n>>2]|0)==107){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=129;break}if((t[n>>2]|0)==111){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=130;break}else{t[f>>2]=126;break}}if((t[n>>2]|0)==67){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==99){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=132;break}if((t[n>>2]|0)==102){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=133;break}if((t[n>>2]|0)==111){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=134;break}if((t[n>>2]|0)==110){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[f>>2]=135;break}else{t[f>>2]=131;break}}e=t[r>>2]|0;if((t[n>>2]|0)!=73){t[e+8>>2]=1450;Rb(t[r>>2]|0,139872);s=i;return}c=e+4|0;t[c>>2]=(t[c>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];c=t[r>>2]|0;if((t[n>>2]|0)!=115){t[c+8>>2]=1450;Rb(t[r>>2]|0,139856);s=i;return}e=c+4|0;t[e>>2]=(t[e>>2]|0)+1;t[o>>2]=t[(t[r>>2]|0)+4>>2];t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if(!((!((t[n>>2]|0)>=97&(t[n>>2]|0)<=122)?!((t[n>>2]|0)>=65&(t[n>>2]|0)<=90):0)?!((t[n>>2]|0)>=48&(t[n>>2]|0)<=57|(t[n>>2]|0)==45):0))l=79;e:do if((l|0)==79){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];while(1){if((!((t[n>>2]|0)>=97&(t[n>>2]|0)<=122)?!((t[n>>2]|0)>=65&(t[n>>2]|0)<=90):0)?!((t[n>>2]|0)>=48&(t[n>>2]|0)<=57|(t[n>>2]|0)==45):0)break e;e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0]}}while(0);t[f>>2]=136;t[a>>2]=ql(t[o>>2]|0,(t[(t[r>>2]|0)+4>>2]|0)-(t[o>>2]|0)|0)|0}while(0);o=t[r>>2]|0;if(!(t[(t[r>>2]|0)+28>>2]|0)){n=Ib(o,t[f>>2]|0)|0;t[(t[r>>2]|0)+28>>2]=n;if(!(t[(t[r>>2]|0)+28>>2]|0)){s=i;return}t[(t[(t[r>>2]|0)+28>>2]|0)+20>>2]=t[a>>2];s=i;return}else{if((t[(t[o+28>>2]|0)+4>>2]|0)!=3){s=i;return}pk(t[r>>2]|0,t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+12>>2]|0,t[f>>2]|0,0,0,t[a>>2]|0);s=i;return}}function Sk(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[r>>2]=e;t[a>>2]=-1;t[o>>2]=-1;e=t[r>>2]|0;if(!(u[t[(t[r>>2]|0)+4>>2]>>0]|0)){t[e+8>>2]=1450;Rb(t[r>>2]|0,14e4);s=i;return}t[n>>2]=u[t[e+4>>2]>>0];do if((t[n>>2]|0)==92){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];switch(t[n>>2]|0){case 93:case 91:case 41:case 40:case 125:case 123:case 43:case 42:case 63:case 94:case 45:case 46:case 124:case 92:{t[a>>2]=t[n>>2];break}case 114:{t[a>>2]=13;break}case 116:{t[a>>2]=9;break}case 110:{t[a>>2]=10;break}default:{t[(t[r>>2]|0)+8>>2]=1450;Rb(t[r>>2]|0,140016);s=i;return}}t[o>>2]=t[a>>2];t[f>>2]=1}else{e=t[r>>2]|0;if((t[n>>2]|0)!=91&(t[n>>2]|0)!=93){c=Mp(0,t[e+4>>2]|0,f)|0;t[a>>2]=c;t[o>>2]=c;break}t[e+8>>2]=1450;Rb(t[r>>2]|0,140040);s=i;return}while(0);if((((t[a>>2]|0)==45?(u[(t[(t[r>>2]|0)+4>>2]|0)+1>>0]|0|0)!=93:0)?(u[(t[(t[r>>2]|0)+4>>2]|0)+-1>>0]|0|0)!=91:0)?(u[(t[(t[r>>2]|0)+4>>2]|0)+-1>>0]|0|0)!=94:0){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+(t[f>>2]|0);s=i;return}e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+(t[f>>2]|0);t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];if((t[n>>2]|0)==45?(u[(t[(t[r>>2]|0)+4>>2]|0)+1>>0]|0|0)!=93:0){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];do if((t[n>>2]|0)==92){e=(t[r>>2]|0)+4|0;t[e>>2]=(t[e>>2]|0)+1;t[n>>2]=u[t[(t[r>>2]|0)+4>>2]>>0];switch(t[n>>2]|0){case 93:case 91:case 41:case 40:case 125:case 123:case 43:case 42:case 63:case 94:case 45:case 46:case 124:case 92:{t[o>>2]=t[n>>2];break}case 110:{t[o>>2]=10;break}case 114:{t[o>>2]=13;break}case 116:{t[o>>2]=9;break}default:{t[(t[r>>2]|0)+8>>2]=1450;Rb(t[r>>2]|0,140016);s=i;return}}t[f>>2]=1}else{e=t[r>>2]|0;if((t[n>>2]|0)!=91&(t[n>>2]|0)!=93){t[o>>2]=Mp(0,t[e+4>>2]|0,f)|0;break}t[e+8>>2]=1450;Rb(t[r>>2]|0,140064);s=i;return}while(0);n=(t[r>>2]|0)+4|0;t[n>>2]=(t[n>>2]|0)+(t[f>>2]|0);f=t[r>>2]|0;if((t[o>>2]|0)<(t[a>>2]|0)){t[f+8>>2]=1450;Rb(t[r>>2]|0,140104);s=i;return}else{pk(f,t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+12>>2]|0,2,t[a>>2]|0,t[o>>2]|0,0);s=i;return}}pk(t[r>>2]|0,t[(t[r>>2]|0)+28>>2]|0,t[(t[r>>2]|0)+12>>2]|0,2,t[a>>2]|0,t[o>>2]|0,0);s=i;return}function gk(){var e=0,i=0,r=0,n=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](40)|0;if(!(t[r>>2]|0)){t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{f=(t[r>>2]|0)+0|0;u=f+40|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(u|0));t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function yk(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)Yk(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)Gk(t[(t[r>>2]|0)+32>>2]|0);if(t[(t[r>>2]|0)+36>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+36>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Fk(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0)MD(t[(t[r>>2]|0)+32>>2]|0);if(t[(t[r>>2]|0)+36>>2]|0)fb(t[(t[r>>2]|0)+36>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)Yk(t[(t[r>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Ok(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+24>>2]|0)Yk(t[(t[r>>2]|0)+24>>2]|0);e:do if(t[(t[r>>2]|0)+68>>2]|0){t[n>>2]=t[(t[r>>2]|0)+68>>2];while(1){if(!(t[n>>2]|0))break e;t[f>>2]=t[(t[n>>2]|0)+4>>2];Fk(t[n>>2]|0);t[n>>2]=t[f>>2]}}while(0);if(t[(t[r>>2]|0)+116>>2]|0)Wk(t[(t[r>>2]|0)+116>>2]|0);if(t[(t[r>>2]|0)+92>>2]|0)Kk(t[(t[r>>2]|0)+92>>2]|0);if(t[(t[r>>2]|0)+96>>2]|0){t[a>>2]=t[(t[r>>2]|0)+96>>2];do{t[u>>2]=t[t[a>>2]>>2];pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=t[u>>2]}while((t[a>>2]|0)!=0)}if(t[(t[r>>2]|0)+108>>2]|0)fb(t[(t[r>>2]|0)+108>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Ak(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i;n=i+16|0;f=i+12|0;u=i+8|0;t[n>>2]=e;if(!(t[n>>2]|0)){s=i;return}if(t[(t[n>>2]|0)+80>>2]|0){e=t[33976]|0;a=t[33980]|0;t[r>>2]=140328;t[r+4>>2]=4118;yAi[e&511](a,140296,r)}if(t[(t[n>>2]|0)+44>>2]|0)XF(t[(t[n>>2]|0)+44>>2]|0,0);if(t[(t[n>>2]|0)+32>>2]|0)XF(t[(t[n>>2]|0)+32>>2]|0,0);if(t[(t[n>>2]|0)+36>>2]|0)XF(t[(t[n>>2]|0)+36>>2]|0,0);if(t[(t[n>>2]|0)+40>>2]|0)XF(t[(t[n>>2]|0)+40>>2]|0,0);if(t[(t[n>>2]|0)+28>>2]|0)XF(t[(t[n>>2]|0)+28>>2]|0,0);if(t[(t[n>>2]|0)+56>>2]|0)XF(t[(t[n>>2]|0)+56>>2]|0,0);if(t[(t[n>>2]|0)+76>>2]|0)XF(t[(t[n>>2]|0)+76>>2]|0,0);if(t[(t[n>>2]|0)+48>>2]|0)XF(t[(t[n>>2]|0)+48>>2]|0,322);if(t[(t[n>>2]|0)+64>>2]|0){t[f>>2]=t[(t[n>>2]|0)+64>>2];t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[f>>2]|0)+4>>2]|0))break;Xk(t[(t[t[f>>2]>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}Wk(t[f>>2]|0)}if(t[(t[n>>2]|0)+20>>2]|0)Yk(t[(t[n>>2]|0)+20>>2]|0);bz(t[(t[n>>2]|0)+60>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0);s=i;return}function Mk(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=Zk()|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=lz()|0;t[(t[f>>2]|0)+80>>2]=e;e=kz(t[(t[f>>2]|0)+80>>2]|0,t[n>>2]|0,-1)|0;t[(t[f>>2]|0)+44>>2]=e;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Rk(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+48>>2]|0)!=0?(t[(t[r>>2]|0)+52>>2]|0)==0:0)fy(t[(t[r>>2]|0)+48>>2]|0);if(t[(t[r>>2]|0)+92>>2]|0)Nk(t[(t[r>>2]|0)+92>>2]|0);if((t[(t[r>>2]|0)+32>>2]|0)!=0?(t[(t[r>>2]|0)+28>>2]|0)!=0:0){Jk(t[(t[r>>2]|0)+28>>2]|0);t[(t[r>>2]|0)+28>>2]=0;t[(t[r>>2]|0)+32>>2]=0}if(t[(t[r>>2]|0)+128>>2]|0)Wk(t[(t[r>>2]|0)+128>>2]|0);bz(t[(t[r>>2]|0)+80>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Nk(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+48|0;r=i+36|0;n=i+32|0;f=i+28|0;u=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+72>>2]|0)MD(t[(t[r>>2]|0)+72>>2]|0);if(t[(t[r>>2]|0)+88>>2]|0)Rk(t[(t[r>>2]|0)+88>>2]|0);if(t[(t[r>>2]|0)+128>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+132>>2]|0))break;t[f>>2]=t[(t[(t[r>>2]|0)+128>>2]|0)+(t[n>>2]<<2)>>2];pAi[t[135736>>2]&511](t[(t[f>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+128>>2]|0)}if(t[(t[r>>2]|0)+140>>2]|0){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[r>>2]|0)+144>>2]|0))break;Qk(t[(t[(t[r>>2]|0)+140>>2]|0)+(t[u>>2]<<2)>>2]|0);t[u>>2]=(t[u>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+140>>2]|0)}if(t[(t[r>>2]|0)+116>>2]|0){$k(t[(t[r>>2]|0)+116>>2]|0);t[(t[r>>2]|0)+116>>2]=0}if(t[(t[r>>2]|0)+120>>2]|0){$k(t[(t[r>>2]|0)+120>>2]|0);t[(t[r>>2]|0)+120>>2]=0}if(t[(t[r>>2]|0)+112>>2]|0){t[a>>2]=t[(t[r>>2]|0)+112>>2];do{t[o>>2]=t[t[a>>2]>>2];pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=t[o>>2]}while((t[a>>2]|0)!=0)}if(t[(t[r>>2]|0)+164>>2]|0){if(t[(t[r>>2]|0)+168>>2]|0)eh(t[r>>2]|0);t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[(t[r>>2]|0)+172>>2]|0))break;t[l>>2]=t[(t[(t[r>>2]|0)+164>>2]|0)+(t[c>>2]<<2)>>2];pAi[t[135736>>2]&511](t[l>>2]|0);t[c>>2]=(t[c>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+164>>2]|0)}if(t[(t[r>>2]|0)+100>>2]|0){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[(t[r>>2]|0)+104>>2]|0))break;t[k>>2]=t[(t[(t[r>>2]|0)+100>>2]|0)+(t[b>>2]<<2)>>2];if(!(t[k>>2]|0))break;ih(t[r>>2]|0,t[k>>2]|0);pAi[t[135736>>2]&511](t[k>>2]|0);t[b>>2]=(t[b>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+100>>2]|0)}if(t[(t[r>>2]|0)+180>>2]|0)Wk(t[(t[r>>2]|0)+180>>2]|0);if(t[(t[r>>2]|0)+156>>2]|0)bz(t[(t[r>>2]|0)+156>>2]|0);if(t[(t[r>>2]|0)+48>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Tk(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[f+24>>2]=n;t[b>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}if(!(t[l>>2]|0))t[k>>2]=0;else t[k>>2]=1;e:do switch(t[t[o>>2]>>2]|0){case 1007:case 1003:case 1002:case 1001:case 1e3:{n=t[c>>2]|0;if((t[t[c>>2]>>2]|0)!=1){t[h>>2]=t[n+64>>2];if(!(t[h>>2]|0)){rh(t[l>>2]|0,140360,140384);t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}}else t[h>>2]=n;if((t[k>>2]|0)==0?(t[l>>2]=Mk(140432)|0,(t[l>>2]|0)==0):0){t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}t[b>>2]=nh(t[l>>2]|0,t[(t[o>>2]|0)+20>>2]|0,t[h>>2]|0,t[(t[o>>2]|0)+8>>2]|0,(t[o>>2]|0)+32|0,1,1,0)|0;if(!(t[b>>2]|0)){if(t[(t[o>>2]|0)+32>>2]|0){v=45;break e}if(t[k>>2]|0)rh(t[l>>2]|0,140360,140632);n=t[33976]|0;r=t[33980]|0;t[u>>2]=140328;t[u+4>>2]=18739;yAi[n&511](r,140296,u);v=45;break e}if((t[b>>2]|0)<0){if(!(t[k>>2]|0)){v=48;break e}r=t[l>>2]|0;n=t[(t[o>>2]|0)+20>>2]|0;i=t[(t[o>>2]|0)+8>>2]|0;th(r,3069,n,0,140440,i,fh(t[t[o>>2]>>2]|0)|0);v=48;break e}t[b>>2]=1717;if((t[k>>2]|0)!=0?(t[w>>2]=0,i=t[l>>2]|0,n=t[b>>2]|0,r=t[(t[o>>2]|0)+20>>2]|0,e=t[o>>2]|0,m=t[(t[o>>2]|0)+8>>2]|0,th(i,n,r,e,140552,m,uh(w,t[(t[h>>2]|0)+112>>2]|0,t[(t[h>>2]|0)+8>>2]|0)|0),(t[w>>2]|0)!=0):0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0;v=45}else v=45;break}case 1011:case 1010:case 1009:case 1005:case 1004:{if((t[t[o>>2]>>2]|0)==1004){m=ED(34)|0;t[b>>2]=CD(m,t[(t[o>>2]|0)+8>>2]|0,(t[o>>2]|0)+32|0)|0}else{m=ED(33)|0;t[b>>2]=CD(m,t[(t[o>>2]|0)+8>>2]|0,(t[o>>2]|0)+32|0)|0}if(t[b>>2]|0)if((t[b>>2]|0)<0){if(!(t[k>>2]|0)){v=48;break e}rh(t[l>>2]|0,140360,140728);v=48;break e}else{t[b>>2]=1717;if(!(t[k>>2]|0)){v=45;break e}m=t[l>>2]|0;e=t[b>>2]|0;r=t[(t[o>>2]|0)+20>>2]|0;n=t[c>>2]|0;i=t[(t[o>>2]|0)+8>>2]|0;_=fh(t[t[o>>2]>>2]|0)|0;ah(m,e,r,n,140752,i,_,(t[t[o>>2]>>2]|0)!=1004?140808:140832,0);v=45;break e}else v=45;break}case 1006:{_=$s(t[(t[o>>2]|0)+8>>2]|0)|0;t[(t[o>>2]|0)+36>>2]=_;if((t[(t[o>>2]|0)+36>>2]|0)==0?(t[b>>2]=1756,(t[k>>2]|0)!=0):0){th(t[l>>2]|0,t[b>>2]|0,t[(t[o>>2]|0)+20>>2]|0,t[c>>2]|0,140656,t[(t[o>>2]|0)+8>>2]|0,0);v=45}else v=45;break}case 1008:{_=(Xl(t[(t[o>>2]|0)+8>>2]|0,140848)|0)!=0;i=t[o>>2]|0;if(_){t[i+28>>2]=1;v=45;break e}_=(Xl(t[i+8>>2]|0,140864)|0)!=0;i=t[o>>2]|0;if(_){t[i+28>>2]=2;v=45;break e}if(Xl(t[i+8>>2]|0,140872)|0){t[(t[o>>2]|0)+28>>2]=3;v=45;break e}t[b>>2]=1717;if(t[k>>2]|0){th(t[l>>2]|0,t[b>>2]|0,t[(t[o>>2]|0)+20>>2]|0,t[c>>2]|0,140888,t[(t[o>>2]|0)+8>>2]|0,0);v=45}else v=45;break}default:v=45}while(0);if((v|0)==45){if((t[k>>2]|0)==0&(t[l>>2]|0)!=0)Rk(t[l>>2]|0);t[a>>2]=t[b>>2];d=t[a>>2]|0;s=f;return d|0}else if((v|0)==48){if((t[k>>2]|0)==0&(t[l>>2]|0)!=0)Rk(t[l>>2]|0);t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}return 0}function Lk(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=0;mD();if(!(t[n>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[(t[n>>2]|0)+20>>2]=0;t[(t[n>>2]|0)+16>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[f>>2]=oh(t[n>>2]|0)|0;e:do if(t[f>>2]|0){do if(!(t[(t[n>>2]|0)+28>>2]|0)){e=ch(t[(t[n>>2]|0)+80>>2]|0)|0;t[(t[n>>2]|0)+28>>2]=e;if(t[(t[n>>2]|0)+28>>2]|0){t[(t[n>>2]|0)+32>>2]=1;break}t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}while(0);t[t[(t[n>>2]|0)+28>>2]>>2]=t[f>>2];t[a>>2]=lh(t[n>>2]|0,0,t[(t[n>>2]|0)+44>>2]|0,t[(t[n>>2]|0)+48>>2]|0,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0,0,0,0,u)|0;if((t[a>>2]|0)!=-1){do if(!(t[a>>2]|0)){e=t[n>>2]|0;if(!(t[u>>2]|0)){c=t[n>>2]|0;if(t[e+44>>2]|0){th(c,1757,0,0,140944,t[(t[n>>2]|0)+44>>2]|0,0);break}else{th(c,1757,0,0,141e3,0,0);break}}else{if((sh(e,t[f>>2]|0,t[u>>2]|0)|0)==-1)break e;if(t[(t[n>>2]|0)+20>>2]|0)break;t[(t[f>>2]|0)+16>>2]=t[(t[u>>2]|0)+20>>2];t[(t[f>>2]|0)+68>>2]=t[(t[n>>2]|0)+52>>2];t[(t[n>>2]|0)+36>>2]=t[f>>2];if((bh(t[n>>2]|0,t[(t[(t[n>>2]|0)+28>>2]|0)+4>>2]|0)|0)==-1)break e;else break}}while(0);if(t[(t[n>>2]|0)+20>>2]|0){if(t[f>>2]|0){Ak(t[f>>2]|0);t[f>>2]=0}if(t[(t[n>>2]|0)+28>>2]|0){Jk(t[(t[n>>2]|0)+28>>2]|0);t[(t[n>>2]|0)+28>>2]=0;t[(t[n>>2]|0)+32>>2]=0}}t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}}while(0);if(t[f>>2]|0){Ak(t[f>>2]|0);t[f>>2]=0}if(t[(t[n>>2]|0)+28>>2]|0){Jk(t[(t[n>>2]|0)+28>>2]|0);t[(t[n>>2]|0)+28>>2]=0;t[(t[n>>2]|0)+32>>2]=0}rh(t[n>>2]|0,141048,141064);t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}function Dk(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[u>>2]|0)){s=f;return}t[(t[u>>2]|0)+8>>2]=t[a>>2];t[(t[u>>2]|0)+12>>2]=t[o>>2];t[(t[u>>2]|0)+4>>2]=t[c>>2];if(!(t[(t[u>>2]|0)+92>>2]|0)){s=f;return}Ck(t[(t[u>>2]|0)+92>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function Ck(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[u>>2]|0)){s=f;return}t[(t[u>>2]|0)+8>>2]=t[a>>2];t[(t[u>>2]|0)+12>>2]=t[o>>2];t[(t[u>>2]|0)+4>>2]=t[c>>2];if(!(t[(t[u>>2]|0)+88>>2]|0)){s=f;return}Dk(t[(t[u>>2]|0)+88>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function Pk(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}t[(t[f>>2]|0)+24>>2]=t[u>>2];t[(t[f>>2]|0)+4>>2]=t[a>>2];if(!(t[(t[f>>2]|0)+92>>2]|0)){s=n;return}Bk(t[(t[f>>2]|0)+92>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function Bk(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}t[(t[f>>2]|0)+16>>2]=t[u>>2];t[(t[f>>2]|0)+8>>2]=0;t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+4>>2]=t[a>>2];if(!(t[(t[f>>2]|0)+88>>2]|0)){s=n;return}Pk(t[(t[f>>2]|0)+88>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function Ik(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](204)|0;if(!(t[f>>2]|0)){kh(0,141096,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{VY(t[f>>2]|0,0,204)|0;t[t[f>>2]>>2]=2;e=lz()|0;t[(t[f>>2]|0)+156>>2]=e;e=hh()|0;t[(t[f>>2]|0)+180>>2]=e;t[(t[f>>2]|0)+20>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Hk(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if(t[(t[n>>2]|0)+48>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+48>>2]|0);if(t[f>>2]|0){i=Yl(t[f>>2]|0)|0;t[(t[n>>2]|0)+48>>2]=i;s=r;return}else{t[(t[n>>2]|0)+48>>2]=0;s=r;return}}function xk(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;f=t[r>>2]|0;s=i;return f|0}else{t[r>>2]=(t[(t[n>>2]|0)+52>>2]|0)==0&1;f=t[r>>2]|0;s=i;return f|0}return 0}function Uk(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}t[(t[f>>2]|0)+24>>2]=t[u>>2];i=eF(t[u>>2]|0)|0;t[(t[f>>2]|0)+60>>2]=i;i=t[f>>2]|0;if(!(t[(t[f>>2]|0)+60>>2]|0)){th(i,1872,t[u>>2]|0,0,141128,0,0);t[n>>2]=t[(t[f>>2]|0)+52>>2];a=t[n>>2]|0;s=r;return a|0}else{t[(t[f>>2]|0)+84>>2]=t[i+60>>2];t[n>>2]=wh(t[f>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}return 0}function zk(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[l>>2]=t[t[a>>2]>>2];if((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+108>>2]|0)!=-554844497:0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+116>>2]|0)==0:0)?(t[(t[l>>2]|0)+120>>2]|0)==0:0){if((t[(t[l>>2]|0)+56>>2]|0)==0?(t[(t[l>>2]|0)+60>>2]|0)==0:0)break;t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}while(0);t[c>>2]=gAi[t[135744>>2]&511](152)|0;if(!(t[c>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}VY(t[c>>2]|0,0,152)|0;t[t[c>>2]>>2]=-599541215;t[(t[c>>2]|0)+128>>2]=-554844497;t[(t[c>>2]|0)+148>>2]=t[u>>2];t[(t[c>>2]|0)+4>>2]=t[a>>2];t[(t[c>>2]|0)+8>>2]=t[l>>2];if(!(t[l>>2]|0)){t[(t[c>>2]|0)+136>>2]=323;t[(t[c>>2]|0)+140>>2]=324;t[(t[c>>2]|0)+92>>2]=325;t[(t[c>>2]|0)+88>>2]=325;t[(t[c>>2]|0)+120>>2]=326;t[(t[c>>2]|0)+84>>2]=327;t[(t[c>>2]|0)+16>>2]=t[u>>2];t[t[o>>2]>>2]=t[u>>2]}else{if(t[t[l>>2]>>2]|0)t[(t[c>>2]|0)+20>>2]=328;if(t[(t[l>>2]|0)+4>>2]|0)t[(t[c>>2]|0)+24>>2]=329;if(t[(t[l>>2]|0)+8>>2]|0)t[(t[c>>2]|0)+28>>2]=330;if(t[(t[l>>2]|0)+12>>2]|0)t[(t[c>>2]|0)+32>>2]=331;if(t[(t[l>>2]|0)+16>>2]|0)t[(t[c>>2]|0)+36>>2]=332;if(t[(t[l>>2]|0)+20>>2]|0)t[(t[c>>2]|0)+40>>2]=333;if(t[(t[l>>2]|0)+24>>2]|0)t[(t[c>>2]|0)+44>>2]=334;if(t[(t[l>>2]|0)+28>>2]|0)t[(t[c>>2]|0)+48>>2]=335;if(t[(t[l>>2]|0)+32>>2]|0)t[(t[c>>2]|0)+52>>2]=336;if(t[(t[l>>2]|0)+36>>2]|0)t[(t[c>>2]|0)+56>>2]=337;if(t[(t[l>>2]|0)+40>>2]|0)t[(t[c>>2]|0)+60>>2]=338;if(t[(t[l>>2]|0)+44>>2]|0)t[(t[c>>2]|0)+64>>2]=339;if(t[(t[l>>2]|0)+48>>2]|0)t[(t[c>>2]|0)+68>>2]=340;if(t[(t[l>>2]|0)+52>>2]|0)t[(t[c>>2]|0)+72>>2]=341;if(t[(t[l>>2]|0)+76>>2]|0)t[(t[c>>2]|0)+96>>2]=342;if(t[(t[l>>2]|0)+80>>2]|0)t[(t[c>>2]|0)+100>>2]=343;if(t[(t[l>>2]|0)+84>>2]|0)t[(t[c>>2]|0)+104>>2]=344;if(t[(t[l>>2]|0)+88>>2]|0)t[(t[c>>2]|0)+108>>2]=345;if(t[(t[l>>2]|0)+92>>2]|0)t[(t[c>>2]|0)+112>>2]=346;if(t[(t[l>>2]|0)+96>>2]|0)t[(t[c>>2]|0)+116>>2]=347;if(t[(t[l>>2]|0)+104>>2]|0)t[(t[c>>2]|0)+124>>2]=348;t[(t[c>>2]|0)+88>>2]=349;do if(t[(t[l>>2]|0)+72>>2]|0){if((t[(t[l>>2]|0)+72>>2]|0)==(t[(t[l>>2]|0)+68>>2]|0)){k=61;break}t[(t[c>>2]|0)+92>>2]=350}else k=61;while(0);if((k|0)==61)t[(t[c>>2]|0)+92>>2]=349;t[(t[c>>2]|0)+120>>2]=351;t[(t[c>>2]|0)+84>>2]=352;t[(t[c>>2]|0)+136>>2]=353;t[(t[c>>2]|0)+140>>2]=354;t[(t[c>>2]|0)+12>>2]=t[o>>2];t[(t[c>>2]|0)+16>>2]=t[t[o>>2]>>2];t[t[o>>2]>>2]=t[c>>2]}t[t[a>>2]>>2]=(t[c>>2]|0)+20;t[(t[u>>2]|0)+36>>2]=t[t[a>>2]>>2];a=(t[u>>2]|0)+152|0;t[a>>2]=t[a>>2]|1;Kh(t[u>>2]|0)|0;t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function jk(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[t[n>>2]>>2]|0)==-599541215:0){t[t[n>>2]>>2]=0;Xh(t[(t[n>>2]|0)+148>>2]|0);t[f>>2]=t[(t[n>>2]|0)+4>>2];t[t[f>>2]>>2]=t[(t[n>>2]|0)+8>>2];if(t[(t[n>>2]|0)+8>>2]|0){t[u>>2]=t[(t[n>>2]|0)+12>>2];t[t[u>>2]>>2]=t[(t[n>>2]|0)+16>>2]}pAi[t[135736>>2]&511](t[n>>2]|0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}function Vk(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}t[(t[f>>2]|0)+196>>2]=t[u>>2];t[(t[f>>2]|0)+200>>2]=t[a>>2];s=n;return}function qk(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;u=s;s=s+48|0;a=u+40|0;o=u+36|0;c=u+32|0;l=u+28|0;b=u+24|0;k=u+20|0;h=u+16|0;w=u+12|0;d=u+8|0;v=u+4|0;m=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=-1;_=t[a>>2]|0;s=u;return _|0}t[d>>2]=zp()|0;if(!(t[d>>2]|0)){t[a>>2]=-1;_=t[a>>2]|0;s=u;return _|0}t[w>>2]=t[t[d>>2]>>2];t[t[d>>2]>>2]=t[b>>2];t[(t[d>>2]|0)+4>>2]=t[k>>2];t[(t[d>>2]|0)+280>>2]=1;Vk(t[o>>2]|0,355,t[d>>2]|0);t[v>>2]=Pp(t[d>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;do if(t[v>>2]|0){eE(t[d>>2]|0,t[v>>2]|0)|0;t[(t[o>>2]|0)+40>>2]=t[d>>2];t[(t[o>>2]|0)+28>>2]=t[c>>2];t[h>>2]=zk(t[o>>2]|0,t[d>>2]|0,(t[d>>2]|0)+4|0)|0;if(!(t[h>>2]|0)){t[m>>2]=-1;break}t[(t[o>>2]|0)+28>>2]=t[c>>2];t[(t[o>>2]|0)+32>>2]=t[l>>2];t[(t[o>>2]|0)+36>>2]=t[t[d>>2]>>2];k=(t[o>>2]|0)+152|0;t[k>>2]=t[k>>2]|1;t[m>>2]=wh(t[o>>2]|0)|0;if((t[m>>2]|0)==0?(t[(t[(t[o>>2]|0)+40>>2]|0)+12>>2]|0)==0:0){k=t[(t[(t[o>>2]|0)+40>>2]|0)+84>>2]|0;t[m>>2]=k;t[m>>2]=(t[m>>2]|0)==0?1:k}}else t[m>>2]=-1;while(0);t[(t[o>>2]|0)+40>>2]=0;t[(t[o>>2]|0)+36>>2]=0;t[(t[o>>2]|0)+28>>2]=0;if(t[h>>2]|0)jk(t[h>>2]|0)|0;if(t[d>>2]|0){t[t[d>>2]>>2]=t[w>>2];Up(t[d>>2]|0)}t[a>>2]=t[m>>2];_=t[a>>2]|0;s=u;return _|0}function Yk(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[t[r>>2]>>2]|0)){pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}else{do{t[n>>2]=t[r>>2];t[r>>2]=t[t[r>>2]>>2];pAi[t[135736>>2]&511](t[n>>2]|0)}while((t[r>>2]|0)!=0);s=i;return}}function Gk(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function Wk(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Kk(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function Xk(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+44>>2]|0){Jh(t[(t[r>>2]|0)+44>>2]|0);Wk(t[(t[r>>2]|0)+44>>2]|0)}if(t[(t[r>>2]|0)+48>>2]|0){Jh(t[(t[r>>2]|0)+48>>2]|0);Wk(t[(t[r>>2]|0)+48>>2]|0)}if(t[(t[r>>2]|0)+24>>2]|0){t[f>>2]=t[(t[r>>2]|0)+24>>2];do{t[n>>2]=t[f>>2];t[f>>2]=t[t[f>>2]>>2];pAi[t[135736>>2]&511](t[n>>2]|0)}while((t[f>>2]|0)!=0)}if((t[(t[r>>2]|0)+40>>2]|0)==0?(t[(t[r>>2]|0)+20>>2]|0)!=0:0)fy(t[(t[r>>2]|0)+20>>2]|0);if((t[t[r>>2]>>2]|0)==1?(t[(t[r>>2]|0)+52>>2]|0)!=0:0)Ak(t[(t[r>>2]|0)+52>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Zk(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](132)|0;if(!(t[r>>2]|0)){Qh(0,170240,0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}VY(t[r>>2]|0,0,132)|0;t[t[r>>2]>>2]=1;f=hh()|0;t[(t[r>>2]|0)+128>>2]=f;if(!(t[(t[r>>2]|0)+128>>2]|0)){pAi[t[135736>>2]&511](t[r>>2]|0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function Jk(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+12>>2]|0)Wk(t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+20>>2]|0)Wk(t[(t[r>>2]|0)+20>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)XF(t[(t[r>>2]|0)+24>>2]|0,356);if(t[(t[r>>2]|0)+28>>2]|0)ew(t[(t[r>>2]|0)+28>>2]|0);if(!(t[(t[r>>2]|0)+8>>2]|0)){n=t[33934]|0;f=t[r>>2]|0;pAi[n&511](f);s=i;return}bz(t[(t[r>>2]|0)+8>>2]|0);n=t[33934]|0;f=t[r>>2]|0;pAi[n&511](f);s=i;return}function Qk(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+4>>2]|0)MD(t[(t[r>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function $k(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[(t[r>>2]|0)+4>>2];if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)_j(t[(t[r>>2]|0)+32>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function eh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[(t[r>>2]|0)+168>>2]|0)){s=i;return}t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+168>>2]|0))break;t[f>>2]=t[(t[(t[r>>2]|0)+164>>2]|0)+(t[n>>2]<<2)>>2];if(t[(t[f>>2]|0)+32>>2]&1){if(t[(t[f>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+12>>2]|0);if(t[(t[f>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+16>>2]|0)}if((t[(t[f>>2]|0)+32>>2]&2|0)!=0?(t[(t[f>>2]|0)+20>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+20>>2]|0);if(t[(t[f>>2]|0)+24>>2]|0){MD(t[(t[f>>2]|0)+24>>2]|0);t[(t[f>>2]|0)+24>>2]=0}e=(t[f>>2]|0)+0|0;u=e+60|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(u|0));t[n>>2]=(t[n>>2]|0)+1}t[(t[r>>2]|0)+168>>2]=0;s=i;return}function ih(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;t[(t[f>>2]|0)+76>>2]=0;t[(t[f>>2]|0)+80>>2]=0;i=(t[f>>2]|0)+12|0;if(t[(t[f>>2]|0)+32>>2]&1){if(t[i>>2]|0){pAi[t[135736>>2]&511](t[(t[f>>2]|0)+12>>2]|0);t[(t[f>>2]|0)+12>>2]=0}if(t[(t[f>>2]|0)+16>>2]|0){pAi[t[135736>>2]&511](t[(t[f>>2]|0)+16>>2]|0);t[(t[f>>2]|0)+16>>2]=0}}else{t[i>>2]=0;t[(t[f>>2]|0)+16>>2]=0}i=(t[f>>2]|0)+20|0;if(t[(t[f>>2]|0)+32>>2]&2){if(t[i>>2]|0){pAi[t[135736>>2]&511](t[(t[f>>2]|0)+20>>2]|0);t[(t[f>>2]|0)+20>>2]=0}}else t[i>>2]=0;if(t[(t[f>>2]|0)+24>>2]|0){MD(t[(t[f>>2]|0)+24>>2]|0);t[(t[f>>2]|0)+24>>2]=0}if(t[(t[f>>2]|0)+56>>2]|0){iw(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0);t[(t[f>>2]|0)+56>>2]=0}if(t[(t[f>>2]|0)+52>>2]|0){rw(t[(t[f>>2]|0)+52>>2]|0);t[(t[f>>2]|0)+52>>2]=0}if(t[(t[f>>2]|0)+60>>2]|0){Ks(t[(t[f>>2]|0)+60>>2]|0);t[(t[f>>2]|0)+60>>2]=0}if(!(t[(t[f>>2]|0)+64>>2]|0)){s=r;return}pAi[t[135736>>2]&511](t[(t[f>>2]|0)+64>>2]|0);t[(t[f>>2]|0)+64>>2]=0;t[(t[f>>2]|0)+68>>2]=0;t[(t[f>>2]|0)+72>>2]=0;s=r;return}function rh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;nw(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0,0);s=n;return}function nh(e,i,r,n,f,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0;l=s;s=s+96|0;b=l;k=l+92|0;h=l+88|0;w=l+84|0;d=l+80|0;v=l+76|0;m=l+72|0;_=l+68|0;p=l+64|0;E=l+60|0;S=l+56|0;g=l+52|0;y=l+48|0;F=l+44|0;O=l+40|0;A=l+36|0;M=l+32|0;R=l+28|0;N=l+24|0;T=l+20|0;L=l+16|0;D=l+12|0;C=l+8|0;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=n;t[m>>2]=f;t[_>>2]=a;t[p>>2]=o;t[E>>2]=c;t[S>>2]=0;t[g>>2]=(t[m>>2]|0)!=0?1:0;t[y>>2]=0;t[F>>2]=0;if((t[m>>2]|0)!=0?(t[t[m>>2]>>2]|0)!=0:0){MD(t[t[m>>2]>>2]|0);t[t[m>>2]>>2]=0}if((t[g>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&2097152|0)!=0:0)t[g>>2]=1;if(!(t[v>>2]|0))t[v>>2]=142672;if((t[t[d>>2]>>2]|0)==1?(t[(t[d>>2]|0)+88>>2]|0)==46:0)P=12;else P=11;e:do if((P|0)==11)if(!(t[(t[d>>2]|0)+48>>2]&256)){if(!(t[(t[d>>2]|0)+48>>2]&64)){if(!(t[(t[d>>2]|0)+48>>2]&128))break;t[C>>2]=cw(t[d>>2]|0)|0;if(!(t[C>>2]|0)){rh(t[h>>2]|0,156240,156464);P=149;break}while(1){if(!(t[C>>2]|0))break;c=t[h>>2]|0;o=t[w>>2]|0;a=t[(t[C>>2]|0)+4>>2]|0;f=t[v>>2]|0;if(t[g>>2]|0)t[S>>2]=nh(c,o,a,f,y,0,1,0)|0;else t[S>>2]=nh(c,o,a,f,0,0,1,0)|0;if((t[S>>2]|0)<=0)break;t[C>>2]=t[t[C>>2]>>2]}do if(t[S>>2]|0)if((t[S>>2]|0)<0){rh(t[h>>2]|0,156240,156504);P=149;break e}else{t[S>>2]=1826;break}while(0);do if((t[S>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&134217728|0)!=0:0){do if(!(t[E>>2]|0)){if((t[p>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&268435456|0)==0:0)break;t[F>>2]=fw(t[(t[C>>2]|0)+4>>2]|0,t[v>>2]|0)|0;if(t[F>>2]|0)t[v>>2]=t[F>>2];t[E>>2]=1}while(0);t[S>>2]=aw(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,0,t[v>>2]|0,t[y>>2]|0,0,t[_>>2]|0)|0;if(t[S>>2]|0)if((t[S>>2]|0)<0){rh(t[h>>2]|0,156240,156544);P=149;break e}else{t[S>>2]=1826;break}}while(0);if(!((t[_>>2]|0)!=0&(t[S>>2]|0)>0))break;ow(t[h>>2]|0,t[S>>2]|0,t[w>>2]|0,t[v>>2]|0,t[d>>2]|0,1);break}t[N>>2]=0;t[T>>2]=0;t[L>>2]=0;t[D>>2]=0;do if(!(t[E>>2]|0)){if((t[p>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&268435456|0)==0:0)break;t[F>>2]=fw(t[d>>2]|0,t[v>>2]|0)|0;if(t[F>>2]|0)t[v>>2]=t[F>>2];t[E>>2]=1}while(0);t[A>>2]=t[(t[d>>2]|0)+28>>2];t[M>>2]=t[v>>2];while(1){do if((u[t[M>>2]>>0]|0|0)==32)B=1;else{if(9<=(u[t[M>>2]>>0]|0|0)?(u[t[M>>2]>>0]|0|0)<=10:0){B=1;break}B=(u[t[M>>2]>>0]|0|0)==13}while(0);f=t[M>>2]|0;if(B){t[M>>2]=f+1;continue}t[R>>2]=f;while(1){if(u[t[R>>2]>>0]|0){do if((u[t[R>>2]>>0]|0|0)==32)I=1;else{if(9<=(u[t[R>>2]>>0]|0|0)?(u[t[R>>2]>>0]|0|0)<=10:0){I=1;break}I=(u[t[R>>2]>>0]|0|0)==13}while(0);H=I^1}else H=0;x=t[R>>2]|0;if(!H)break;t[R>>2]=x+1}if((x|0)==(t[M>>2]|0))break;t[N>>2]=ql(t[M>>2]|0,(t[R>>2]|0)-(t[M>>2]|0)|0)|0;t[T>>2]=(t[T>>2]|0)+1;f=t[h>>2]|0;a=t[w>>2]|0;o=t[A>>2]|0;c=t[N>>2]|0;n=t[_>>2]|0;if(t[g>>2]|0)t[S>>2]=nh(f,a,o,c,D,n,0,1)|0;else t[S>>2]=nh(f,a,o,c,0,n,0,1)|0;if(t[N>>2]|0){pAi[t[135736>>2]&511](t[N>>2]|0);t[N>>2]=0}if(t[D>>2]|0){if(!(t[y>>2]|0))t[y>>2]=t[D>>2];else SD(t[L>>2]|0,t[D>>2]|0)|0;t[L>>2]=t[D>>2];t[D>>2]=0}if(t[S>>2]|0){P=92;break}t[M>>2]=t[R>>2];if(!(u[t[M>>2]>>0]|0))break}do if((P|0)==92)if((t[S>>2]|0)<0){rh(t[h>>2]|0,156240,156384);P=149;break e}else{t[S>>2]=1825;break}while(0);if(t[N>>2]|0){pAi[t[135736>>2]&511](t[N>>2]|0);t[N>>2]=0}do if(((t[S>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&134217728|0)!=0:0)?(t[S>>2]=aw(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,0,t[v>>2]|0,t[y>>2]|0,t[T>>2]|0,t[_>>2]|0)|0,(t[S>>2]|0)!=0):0)if((t[S>>2]|0)<0){rh(t[h>>2]|0,156240,156424);P=149;break e}else{t[S>>2]=1825;break}while(0);if((t[_>>2]|0)!=0&(t[S>>2]|0)>0){t[p>>2]=1;do if(!(t[E>>2]|0)){if((t[p>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&268435456|0)==0:0)break;t[F>>2]=fw(t[d>>2]|0,t[v>>2]|0)|0;if(t[F>>2]|0)t[v>>2]=t[F>>2];t[E>>2]=1}while(0);ow(t[h>>2]|0,t[S>>2]|0,t[w>>2]|0,t[v>>2]|0,t[d>>2]|0,1)}}else P=12;while(0);e:do if((P|0)==12){do if(!(t[E>>2]|0)){if((t[p>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&268435456|0)==0:0)break;t[F>>2]=fw(t[d>>2]|0,t[v>>2]|0)|0;if(t[F>>2]|0)t[v>>2]=t[F>>2];t[E>>2]=1}while(0);T=t[d>>2]|0;if((t[t[d>>2]>>2]|0)!=1){t[O>>2]=t[T+64>>2];while(1){if(t[O>>2]|0)U=(t[t[O>>2]>>2]|0)!=1;else U=0;z=t[O>>2]|0;if(!U)break;t[O>>2]=t[z+64>>2]}if(!z){rh(t[h>>2]|0,156240,156272);P=149;break}}else t[O>>2]=T;do if((t[t[h>>2]>>2]|0)==2){N=t[(t[O>>2]|0)+88>>2]|0;if((N|0)==21){t[S>>2]=uw(t[h>>2]|0,t[v>>2]|0,y,t[g>>2]|0)|0;break}else if((N|0)!=28){N=t[O>>2]|0;M=t[v>>2]|0;R=t[w>>2]|0;if(t[g>>2]|0){t[S>>2]=DD(N,M,y,R)|0;break}else{t[S>>2]=DD(N,M,0,R)|0;break}}else{t[S>>2]=tw(t[h>>2]|0,t[(t[h>>2]|0)+20>>2]|0,0,t[v>>2]|0,y,t[g>>2]|0)|0;break}}else{if((t[t[h>>2]>>2]|0)!=1){R=t[33976]|0;M=t[33980]|0;t[b>>2]=140328;t[b+4>>2]=24593;yAi[R&511](M,140296,b);P=149;break e}if((t[(t[O>>2]|0)+88>>2]|0)==28){t[S>>2]=tw(0,t[(t[h>>2]|0)+36>>2]|0,t[w>>2]|0,t[v>>2]|0,y,t[g>>2]|0)|0;break}M=t[O>>2]|0;R=t[v>>2]|0;N=t[w>>2]|0;if(t[g>>2]|0){t[S>>2]=DD(M,R,y,N)|0;break}else{t[S>>2]=DD(M,R,0,N)|0;break}}while(0);do if(t[S>>2]|0){if((t[S>>2]|0)<0){rh(t[h>>2]|0,156240,156304);P=149;break e}if(t[(t[d>>2]|0)+48>>2]&64){t[S>>2]=1825;break}else{t[S>>2]=1824;break}}while(0);do if(((t[S>>2]|0)==0?(t[(t[d>>2]|0)+48>>2]&134217728|0)!=0:0)?(t[S>>2]=aw(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[(t[O>>2]|0)+88>>2]|0,t[v>>2]|0,t[y>>2]|0,0,t[_>>2]|0)|0,(t[S>>2]|0)!=0):0){if((t[S>>2]|0)<0){rh(t[h>>2]|0,156240,156344);P=149;break e}if(t[(t[d>>2]|0)+48>>2]&64){t[S>>2]=1825;break}else{t[S>>2]=1824;break}}while(0);if((t[_>>2]|0)!=0&(t[S>>2]|0)>0)ow(t[h>>2]|0,t[S>>2]|0,t[w>>2]|0,t[v>>2]|0,t[d>>2]|0,1)}while(0);if((P|0)==149){if(t[F>>2]|0)pAi[t[135736>>2]&511](t[F>>2]|0);if(t[y>>2]|0)MD(t[y>>2]|0);t[k>>2]=-1;j=t[k>>2]|0;s=l;return j|0}if(t[F>>2]|0)pAi[t[135736>>2]&511](t[F>>2]|0);
	do if(!(t[S>>2]|0)){F=t[y>>2]|0;if(t[m>>2]|0){t[t[m>>2]>>2]=F;break}if(F)MD(t[y>>2]|0)}else if(t[y>>2]|0)MD(t[y>>2]|0);while(0);t[k>>2]=t[S>>2];j=t[k>>2]|0;s=l;return j|0}function fh(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do switch(t[n>>2]|0){case 1e3:{t[r>>2]=157848;break}case 1010:{t[r>>2]=157904;break}case 1002:{t[r>>2]=157816;break}case 1001:{t[r>>2]=157832;break}case 1003:{t[r>>2]=157800;break}case 1004:{t[r>>2]=157936;break}case 1009:{t[r>>2]=157896;break}case 1005:{t[r>>2]=157952;break}case 1007:{t[r>>2]=157880;break}case 1006:{t[r>>2]=157792;break}case 1011:{t[r>>2]=157920;break}case 1008:{t[r>>2]=157864;break}default:t[r>>2]=157968}while(0);s=i;return t[r>>2]|0}function th(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;o=s;s=s+32|0;c=o+24|0;l=o+20|0;b=o+16|0;k=o+12|0;h=o+8|0;w=o+4|0;d=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;ah(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,0,0);s=o;return}function uh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(t[t[u>>2]>>2]|0){pAi[t[135736>>2]&511](t[t[u>>2]>>2]|0);t[t[u>>2]>>2]=0}if(t[a>>2]|0){r=Yl(144432)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,t[a>>2]|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,144440)|0;t[t[u>>2]>>2]=r}do if(t[o>>2]|0){if(t[a>>2]|0){r=us(t[t[u>>2]>>2]|0,t[o>>2]|0)|0;t[t[u>>2]>>2]=r;break}t[f>>2]=t[o>>2];c=t[f>>2]|0;s=n;return c|0}else{r=us(t[t[u>>2]>>2]|0,170232)|0;t[t[u>>2]>>2]=r}while(0);t[f>>2]=t[t[u>>2]>>2];c=t[f>>2]|0;s=n;return c|0}function ah(e,i,r,n,f,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;l=s;s=s+48|0;b=l+36|0;k=l+32|0;h=l+28|0;w=l+24|0;d=l+20|0;v=l+16|0;m=l+12|0;_=l+8|0;p=l+4|0;E=l;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=0;if((t[h>>2]|0)==0&(t[w>>2]|0)!=0?(t[t[b>>2]>>2]|0)==1:0){t[h>>2]=lw(t[w>>2]|0)|0;sw(E,0,t[w>>2]|0,0)|0;t[E>>2]=us(t[E>>2]|0,152080)|0}else bw(E,t[b>>2]|0,t[h>>2]|0)|0;t[E>>2]=us(t[E>>2]|0,t[d>>2]|0)|0;t[E>>2]=us(t[E>>2]|0,142704)|0;kw(t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[E>>2]|0,t[v>>2]|0,t[m>>2]|0,t[_>>2]|0,t[p>>2]|0);if(!(t[E>>2]|0)){s=l;return}pAi[t[135736>>2]&511](t[E>>2]|0);t[E>>2]=0;s=l;return}function oh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](84)|0;if(!(t[f>>2]|0)){Qh(t[n>>2]|0,170208,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+84|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+60>>2]=t[(t[n>>2]|0)+80>>2];sz(t[(t[f>>2]|0)+60>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function ch(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[f>>2]|0)){Qh(0,170080,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+36|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));e=hh()|0;t[(t[f>>2]|0)+12>>2]=e;if(!(t[(t[f>>2]|0)+12>>2]|0)){Qh(0,170120,0);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=hh()|0;t[(t[f>>2]|0)+20>>2]=e;if(!(t[(t[f>>2]|0)+20>>2]|0)){Qh(0,170160,0);Jk(t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[(t[f>>2]|0)+8>>2]=t[n>>2];sz(t[n>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function lh(e,i,r,n,f,u,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0;b=s;s=s+96|0;k=b+88|0;h=b+84|0;w=b+80|0;d=b+76|0;v=b+72|0;m=b+68|0;_=b+64|0;p=b+60|0;E=b+56|0;S=b+52|0;g=b+48|0;y=b+44|0;F=b+40|0;O=b+36|0;A=b+32|0;M=b+28|0;R=b+24|0;N=b+20|0;T=b+16|0;L=b+12|0;D=b+8|0;C=b+4|0;P=b;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=n;t[m>>2]=f;t[_>>2]=u;t[p>>2]=a;t[E>>2]=o;t[S>>2]=c;t[g>>2]=l;t[y>>2]=0;t[F>>2]=0;t[O>>2]=0;t[A>>2]=0;t[M>>2]=0;t[R>>2]=0;t[N>>2]=0;t[T>>2]=0;if(t[g>>2]|0)t[t[g>>2]>>2]=0;l=t[w>>2]|0;if((l|0)==2)t[M>>2]=3050;else if((l|0)==3)t[M>>2]=3081;else if((l|0)==0|(l|0)==1)t[M>>2]=3082;e:do if(((t[w>>2]|0)!=0?(t[(t[(t[h>>2]|0)+28>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[(t[h>>2]|0)+28>>2]|0)+12>>2]|0)+4>>2]|0)>0:0){if(((t[d>>2]|0)!=0?(t[T>>2]=hw(t[h>>2]|0,t[d>>2]|0)|0,(t[T>>2]|0)!=0):0)?(t[(t[(t[h>>2]|0)+28>>2]|0)+16>>2]|0)==(t[T>>2]|0):0){th(t[h>>2]|0,t[M>>2]|0,t[p>>2]|0,0,169048,0,0);B=92;break}t[F>>2]=ww()|0;if(!(t[F>>2]|0)){t[k>>2]=-1;I=t[k>>2]|0;s=b;return I|0}dw(t[(t[(t[h>>2]|0)+28>>2]|0)+16>>2]|0,t[F>>2]|0);t[(t[F>>2]|0)+4>>2]=t[w>>2];if((t[w>>2]|0)==0|(t[w>>2]|0)==1){t[(t[F>>2]|0)+8>>2]=t[S>>2];if(!(t[d>>2]|0)){B=92;break}t[y>>2]=t[S>>2]}do if(t[T>>2]|0){if((t[w>>2]|0)==0|(t[w>>2]|0)==1?(t[(t[T>>2]|0)+36>>2]|0)==0:0){if(!(t[d>>2]|0))t[d>>2]=169104;if(Xl(t[d>>2]|0,t[(t[T>>2]|0)+8>>2]|0)|0)break;th(t[h>>2]|0,t[M>>2]|0,t[p>>2]|0,0,169128,t[d>>2]|0,0);B=92;break e}if(!((t[w>>2]|0)==0|(t[w>>2]|0)==1)?(t[(t[T>>2]|0)+36>>2]|0)!=0:0){if(!(t[d>>2]|0))t[d>>2]=169104;if(!(Xl(t[d>>2]|0,t[(t[T>>2]|0)+8>>2]|0)|0)){th(t[h>>2]|0,t[M>>2]|0,t[p>>2]|0,0,169216,t[d>>2]|0,0);B=92;break e}}}while(0);l=(t[T>>2]|0)!=0;do if((t[w>>2]|0)==0|(t[w>>2]|0)==1){if(l){t[(t[F>>2]|0)+12>>2]=t[T>>2];B=92;break e}t[T>>2]=vw(t[h>>2]|0,t[S>>2]|0,1)|0;if(t[T>>2]|0){t[(t[F>>2]|0)+12>>2]=t[T>>2];c=t[d>>2]|0;o=(t[T>>2]|0)+8|0;if(!(t[(t[T>>2]|0)+8>>2]|0)){t[o>>2]=c;break}if(Xl(c,t[o>>2]|0)|0){B=92;break e}if(!(t[d>>2]|0))t[d>>2]=169104;mw(t[h>>2]|0,3083,t[p>>2]|0,0,169304,t[d>>2]|0,t[S>>2]|0,t[(t[T>>2]|0)+8>>2]|0);B=92;break e}}else if(l){if((t[(t[T>>2]|0)+12>>2]|0)==0?(t[(t[T>>2]|0)+16>>2]|0)!=(t[E>>2]|0):0){t[L>>2]=_w(t[h>>2]|0,t[d>>2]|0,t[E>>2]|0)|0;if(t[L>>2]|0){t[(t[F>>2]|0)+12>>2]=t[L>>2];B=92;break e}else{t[T>>2]=0;break}}t[(t[F>>2]|0)+12>>2]=t[T>>2];B=92;break e}while(0);if((t[T>>2]|0)!=0?(t[(t[T>>2]|0)+20>>2]|0)!=0:0)rh(t[h>>2]|0,169448,169472);else B=52}else B=52;while(0);e:do if((B|0)==52){do if(t[v>>2]|0){t[O>>2]=t[v>>2];t[N>>2]=1;if(t[(t[v>>2]|0)+72>>2]|0){t[d>>2]=kz(t[(t[h>>2]|0)+80>>2]|0,t[(t[v>>2]|0)+72>>2]|0,-1)|0;B=73;break}else{t[d>>2]=169104;B=73;break}}else{if(!((t[d>>2]|0)!=0|(t[m>>2]|0)!=0)){pw(t[h>>2]|0,0,1758,169640,0,0);break e}t[D>>2]=zp()|0;if(!(t[D>>2]|0)){Qh(0,169552,0);break e}if((t[(t[h>>2]|0)+80>>2]|0)!=0?(t[(t[D>>2]|0)+296>>2]|0)!=0:0){bz(t[(t[D>>2]|0)+296>>2]|0);t[(t[D>>2]|0)+296>>2]=t[(t[h>>2]|0)+80>>2];sz(t[(t[D>>2]|0)+296>>2]|0)|0}if(!(t[d>>2]|0)){if((t[m>>2]|0)!=0?(t[O>>2]=yS(t[D>>2]|0,t[m>>2]|0,t[_>>2]|0,0,0,2)|0,t[d>>2]=169104,(t[O>>2]|0)!=0):0){L=Yl(t[d>>2]|0)|0;t[(t[O>>2]|0)+72>>2]=L}}else t[O>>2]=gS(t[D>>2]|0,t[d>>2]|0,0,2)|0;do if(!(t[O>>2]|0)){t[C>>2]=vp()|0;if((t[C>>2]|0)!=0?(t[t[C>>2]>>2]|0)==8:0)break;t[R>>2]=1;t[A>>2]=3067;th(t[h>>2]|0,t[A>>2]|0,t[p>>2]|0,0,169600,t[d>>2]|0,0)}while(0);Up(t[D>>2]|0);if(!((t[O>>2]|0)==0&(t[R>>2]|0)!=0))B=73}while(0);i:do if((B|0)==73){do if(t[O>>2]|0){t[P>>2]=0;t[R>>2]=1;t[P>>2]=eF(t[O>>2]|0)|0;L=t[h>>2]|0;if(!(t[P>>2]|0)){th(L,1759,t[p>>2]|0,0,169720,t[d>>2]|0,0);break i}Ew(L,t[P>>2]|0);if((((t[P>>2]|0)!=0?(t[(t[P>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[P>>2]|0)+8>>2]|0,169768)|0)!=0:0)?(Xl(t[(t[(t[P>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[y>>2]=Sw(t[h>>2]|0,t[P>>2]|0,168888)|0;break}th(t[h>>2]|0,1772,t[p>>2]|0,0,169776,t[d>>2]|0,0);break i}while(0);if((t[T>>2]|0)==0&(t[R>>2]|0)!=0?(t[T>>2]=gw(t[h>>2]|0,t[w>>2]|0,t[y>>2]|0)|0,(t[T>>2]|0)==0):0)break e;if(!(t[T>>2]|0)){B=92;break e}t[(t[T>>2]|0)+8>>2]=t[d>>2];t[(t[T>>2]|0)+28>>2]=t[R>>2];if((t[O>>2]|0)!=0?(t[(t[T>>2]|0)+20>>2]=t[O>>2],t[(t[T>>2]|0)+16>>2]=t[y>>2],t[(t[T>>2]|0)+12>>2]=t[y>>2],(t[N>>2]|0)!=0):0)t[(t[T>>2]|0)+40>>2]=1;if((t[w>>2]|0)==0|(t[w>>2]|0)==1){L=(t[T>>2]|0)+36|0;t[L>>2]=(t[L>>2]|0)+1}if(!(t[F>>2]|0)){B=92;break e}t[(t[F>>2]|0)+12>>2]=t[T>>2];B=92;break e}while(0);if(!((t[O>>2]|0)==0|(t[N>>2]|0)!=0)?(fy(t[O>>2]|0),(t[T>>2]|0)!=0):0)t[(t[T>>2]|0)+20>>2]=0;t[k>>2]=t[(t[h>>2]|0)+16>>2];I=t[k>>2]|0;s=b;return I|0}while(0);if((B|0)==92){if(t[g>>2]|0)t[t[g>>2]>>2]=t[T>>2];t[k>>2]=0;I=t[k>>2]|0;s=b;return I|0}if(!((t[O>>2]|0)==0|(t[N>>2]|0)!=0)?(fy(t[O>>2]|0),(t[T>>2]|0)!=0):0)t[(t[T>>2]|0)+20>>2]=0;t[k>>2]=-1;I=t[k>>2]|0;s=b;return I|0}function sh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[h>>2]=t[(t[(t[f>>2]|0)+28>>2]|0)+16>>2];t[o>>2]=t[(t[u>>2]|0)+24>>2];t[c>>2]=t[(t[u>>2]|0)+16>>2];if(t[(t[u>>2]|0)+24>>2]|0)yw(t[u>>2]|0);t[(t[u>>2]|0)+16>>2]=t[(t[a>>2]|0)+20>>2];t[(t[f>>2]|0)+36>>2]=t[u>>2];t[(t[f>>2]|0)+112>>2]=t[(t[a>>2]|0)+16>>2];t[(t[(t[f>>2]|0)+28>>2]|0)+16>>2]=t[a>>2];if((t[(t[a>>2]|0)+16>>2]|0)!=0?(Xl(t[(t[a>>2]|0)+16>>2]|0,t[38526]|0)|0)!=0:0)t[(t[f>>2]|0)+96>>2]=1;r=(t[a>>2]|0)+32|0;t[r>>2]=(t[r>>2]|0)+1;t[l>>2]=eF(t[(t[a>>2]|0)+20>>2]|0)|0;t[b>>2]=Fw(t[f>>2]|0,t[u>>2]|0,t[l>>2]|0)|0;if((((t[b>>2]|0)==0?(t[(t[l>>2]|0)+12>>2]|0)!=0:0)?(t[k>>2]=t[(t[f>>2]|0)+20>>2],t[b>>2]=Ow(t[f>>2]|0,t[u>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0,(t[b>>2]|0)==0&(t[b>>2]|0)==0):0)?(t[k>>2]|0)!=(t[(t[f>>2]|0)+20>>2]|0):0)t[b>>2]=t[(t[f>>2]|0)+16>>2];t[(t[(t[f>>2]|0)+28>>2]|0)+16>>2]=t[h>>2];t[(t[u>>2]|0)+16>>2]=t[c>>2];t[(t[u>>2]|0)+24>>2]=t[o>>2];s=n;return t[b>>2]|0}function bh(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+40|0;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[f>>2]|0)+28>>2];t[k>>2]=0;t[h>>2]=t[(t[a>>2]|0)+16>>2];if((t[(t[a>>2]|0)+20>>2]|0)!=0?(t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0){if(!(t[(t[a>>2]|0)+16>>2]|0))t[(t[a>>2]|0)+16>>2]=t[u>>2];Aw(t[f>>2]|0)|0;Mw(t[f>>2]|0,t[u>>2]|0)|0;t[(t[f>>2]|0)+84>>2]=0;t[c>>2]=t[t[(t[a>>2]|0)+20>>2]>>2];t[l>>2]=t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2];t[b>>2]=0;e:while(1){if((t[b>>2]|0)>=(t[l>>2]|0)){d=20;break}t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];switch(t[t[o>>2]>>2]|0){case 26:{Lw(t[o>>2]|0,t[f>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 8:case 7:case 6:{Cw(t[f>>2]|0,t[o>>2]|0);if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 4:case 5:{Nw(t[o>>2]|0,t[f>>2]|0);if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 14:{Rw(t[o>>2]|0,t[f>>2]|0);if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 15:{Tw(t[o>>2]|0,t[f>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 2e3:{if((t[(t[o>>2]|0)+8>>2]|0)==16)Dw(t[o>>2]|0,t[f>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 2001:{Bw(t[o>>2]|0,t[f>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}case 24:case 22:case 23:{Pw(t[o>>2]|0,t[f>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}break}default:{}}t[b>>2]=(t[b>>2]|0)+1}e:do if((d|0)==20){i:do if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];u=t[t[o>>2]>>2]|0;if((u|0)==16){xw(t[o>>2]|0,t[f>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}if(t[(t[f>>2]|0)+20>>2]|0)break i}else if((u|0)==4|(u|0)==5){Iw(t[o>>2]|0,t[f>>2]|0);if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}if(t[(t[f>>2]|0)+20>>2]|0)break i}else if((u|0)==17){Hw(t[o>>2]|0,t[f>>2]|0);if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}if(t[(t[f>>2]|0)+20>>2]|0)break i}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if(((t[t[o>>2]>>2]|0)+-6|0)>>>0<2)Uw(t[f>>2]|0,t[o>>2]|0);t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if((((t[t[o>>2]>>2]|0)==16?(t[(t[o>>2]|0)+36>>2]&1|0)==0:0)?(t[(t[o>>2]|0)+36>>2]&16|0)!=0:0)?(zw(t[f>>2]|0,t[o>>2]|0)|0,(t[(t[f>>2]|0)+16>>2]|0)==3069):0){d=115;break e}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if((((t[t[o>>2]>>2]|0)==4?(t[t[o>>2]>>2]|0)!=1:0)?(t[(t[o>>2]|0)+48>>2]&536870912|0)==0:0)?(jw(t[f>>2]|0,t[o>>2]|0)|0,(t[(t[f>>2]|0)+16>>2]|0)==3069):0){d=115;break e}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if(((t[t[o>>2]>>2]|0)==4?(t[(t[o>>2]|0)+92>>2]|0)!=0:0)?(Vw(t[f>>2]|0,t[o>>2]|0)|0,(t[(t[f>>2]|0)+16>>2]|0)==3069):0){d=115;break e}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if((((t[t[o>>2]>>2]|0)==4?(t[t[o>>2]>>2]|0)!=1:0)?(t[(t[o>>2]|0)+48>>2]&4194304|0)==0:0)?(qw(t[f>>2]|0,t[o>>2]|0)|0,(t[(t[f>>2]|0)+16>>2]|0)==3069):0){d=115;break e}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if((t[t[o>>2]>>2]|0)==15?(Yw(t[f>>2]|0,t[o>>2]|0)|0,(t[(t[f>>2]|0)+16>>2]|0)==3069):0){d=115;break e}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if(((t[t[o>>2]>>2]|0)==26?(t[(t[o>>2]|0)+28>>2]|0)!=0:0)?(Gw(t[f>>2]|0,t[o>>2]|0)|0,(t[(t[f>>2]|0)+16>>2]|0)==3069):0){d=115;break e}t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];do if((t[t[o>>2]>>2]|0)==16?(t[(t[o>>2]|0)+56>>2]|0)!=0:0){if((t[(t[(t[o>>2]|0)+56>>2]|0)+4>>2]|0)<=1)break;Ww(t[f>>2]|0,t[o>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}}while(0);t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){if(t[(t[(t[f>>2]|0)+28>>2]|0)+28>>2]|0)Kw(t[f>>2]|0)|0;if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[t[(t[a>>2]|0)+20>>2]>>2]|0)+(t[b>>2]<<2)>>2];do if((t[t[o>>2]>>2]|0)==5){if((t[t[o>>2]>>2]|0)==1)break;if(t[(t[o>>2]|0)+48>>2]&4194304)break;Xw(t[f>>2]|0,t[o>>2]|0)|0;if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}}while(0);t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[c>>2]=t[t[(t[a>>2]|0)+20>>2]>>2];t[l>>2]=t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2];t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];do if((t[t[o>>2]>>2]|0)==14){t[w>>2]=t[o>>2];if(t[(t[w>>2]|0)+48>>2]&262144)break;Zw(t[w>>2]|0,t[f>>2]|0);if((t[(t[f>>2]|0)+16>>2]|0)==3069){d=115;break e}}while(0);t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0)){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;t[o>>2]=t[(t[c>>2]|0)+(t[b>>2]<<2)>>2];if((t[t[o>>2]>>2]|0)==5)Jw(t[o>>2]|0,t[f>>2]|0);t[b>>2]=(t[b>>2]|0)+1}if(!(t[(t[f>>2]|0)+20>>2]|0))break e}}}}}}}}}}}}}while(0);t[k>>2]=t[(t[f>>2]|0)+16>>2]}while(0);if((d|0)==115)t[k>>2]=-1;t[(t[a>>2]|0)+16>>2]=t[h>>2];t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]=0;if(t[(t[a>>2]|0)+24>>2]|0){XF(t[(t[a>>2]|0)+24>>2]|0,356);t[(t[a>>2]|0)+24>>2]=0}if(t[(t[a>>2]|0)+28>>2]|0){ew(t[(t[a>>2]|0)+28>>2]|0);t[(t[a>>2]|0)+28>>2]=0}t[n>>2]=t[k>>2];v=t[n>>2]|0;s=r;return v|0}t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}function kh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(t[f>>2]|0){r=(t[f>>2]|0)+56|0;t[r>>2]=(t[r>>2]|0)+1;t[(t[f>>2]|0)+52>>2]=1818}dp(17,2,t[a>>2]|0,0,t[u>>2]|0);s=n;return}function hh(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[r>>2]|0)){Qh(0,156200,0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{f=t[r>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function wh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;if((Kh(t[n>>2]|0)|0)<0){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}e=t[n>>2]|0;do if(!(t[(t[n>>2]|0)+24>>2]|0)){if(!(t[e+160>>2]|0)){if((t[(t[n>>2]|0)+36>>2]|0)!=0?(t[(t[n>>2]|0)+40>>2]|0)!=0:0){t[f>>2]=iS(t[(t[n>>2]|0)+40>>2]|0)|0;break}rh(t[n>>2]|0,155872,155888);t[f>>2]=-1}}else t[f>>2]=Qw(e)|0;while(0);Xh(t[n>>2]|0);if(!(t[f>>2]|0))t[f>>2]=t[(t[n>>2]|0)+52>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function dh(e,i,r,n,f,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;b=s;s=s+64|0;k=b+56|0;h=b+52|0;w=b+44|0;d=b+40|0;v=b+36|0;m=b+32|0;_=b+24|0;p=b+20|0;E=b+16|0;S=b+12|0;g=b+8|0;y=b+4|0;F=b;t[k>>2]=e;t[h>>2]=i;t[b+48>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=a;t[m>>2]=o;t[b+28>>2]=c;t[_>>2]=l;t[p>>2]=t[k>>2];k=(t[p>>2]|0)+96|0;t[k>>2]=(t[k>>2]|0)+1;if((t[(t[p>>2]|0)+176>>2]|0)!=-1?(t[(t[p>>2]|0)+96>>2]|0)>=(t[(t[p>>2]|0)+176>>2]|0):0){s=b;return}k=($w(t[p>>2]|0)|0)==-1;l=t[p>>2]|0;e:do if(!k){t[S>>2]=t[l+108>>2];c=Oz(t[(t[p>>2]|0)+40>>2]|0)|0;t[(t[S>>2]|0)+8>>2]=c;t[(t[S>>2]|0)+12>>2]=t[h>>2];t[(t[S>>2]|0)+16>>2]=t[w>>2];c=(t[S>>2]|0)+32|0;t[c>>2]=t[c>>2]|32;i:do if(t[d>>2]|0){t[g>>2]=0;t[y>>2]=0;while(1){if((t[g>>2]|0)>=(t[d>>2]|0))break i;if(t[(t[S>>2]|0)+64>>2]|0){if((t[(t[S>>2]|0)+72>>2]|0)<=(t[(t[S>>2]|0)+68>>2]|0)?(c=(t[S>>2]|0)+72|0,t[c>>2]=t[c>>2]<<1,c=MAi[t[135760>>2]&511](t[(t[S>>2]|0)+64>>2]|0,t[(t[S>>2]|0)+72>>2]<<1<<2)|0,t[(t[S>>2]|0)+64>>2]=c,(t[(t[S>>2]|0)+64>>2]|0)==0):0){O=14;break}}else{c=gAi[t[135744>>2]&511](40)|0;t[(t[S>>2]|0)+64>>2]=c;if(!(t[(t[S>>2]|0)+64>>2]|0)){O=10;break}t[(t[S>>2]|0)+68>>2]=0;t[(t[S>>2]|0)+72>>2]=5}t[(t[(t[S>>2]|0)+64>>2]|0)+(t[(t[S>>2]|0)+68>>2]<<1<<2)>>2]=t[(t[v>>2]|0)+(t[y>>2]<<2)>>2];if(!(u[t[(t[v>>2]|0)+((t[y>>2]|0)+1<<2)>>2]>>0]|0))t[(t[(t[S>>2]|0)+64>>2]|0)+((t[(t[S>>2]|0)+68>>2]<<1)+1<<2)>>2]=0;else t[(t[(t[S>>2]|0)+64>>2]|0)+((t[(t[S>>2]|0)+68>>2]<<1)+1<<2)>>2]=t[(t[v>>2]|0)+((t[y>>2]|0)+1<<2)>>2];c=(t[S>>2]|0)+68|0;t[c>>2]=(t[c>>2]|0)+1;t[g>>2]=(t[g>>2]|0)+1;t[y>>2]=(t[y>>2]|0)+2}if((O|0)==10){kh(t[p>>2]|0,144584,0);break e}else if((O|0)==14){kh(t[p>>2]|0,144640,0);break e}}while(0);i:do if(t[m>>2]|0){t[y>>2]=0;t[g>>2]=0;while(1){if((t[g>>2]|0)>=(t[m>>2]|0))break i;t[F>>2]=ql(t[(t[_>>2]|0)+((t[y>>2]|0)+3<<2)>>2]|0,(t[(t[_>>2]|0)+((t[y>>2]|0)+4<<2)>>2]|0)-(t[(t[_>>2]|0)+((t[y>>2]|0)+3<<2)>>2]|0)|0)|0;t[E>>2]=ed(t[p>>2]|0,0,t[(t[S>>2]|0)+8>>2]|0,t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0,t[(t[_>>2]|0)+((t[y>>2]|0)+2<<2)>>2]|0,0,t[F>>2]|0,1)|0;if((t[E>>2]|0)==-1)break;t[g>>2]=(t[g>>2]|0)+1;t[y>>2]=(t[y>>2]|0)+5}rh(t[p>>2]|0,144504,144696);break e}while(0);t[E>>2]=id(t[p>>2]|0)|0;if((t[E>>2]|0)!=0&(t[E>>2]|0)==-1){rh(t[p>>2]|0,144504,144744);break}else{s=b;return}}else rh(l,144504,144544);while(0);t[(t[p>>2]|0)+52>>2]=-1;tS(t[(t[p>>2]|0)+40>>2]|0);s=b;return}function vh(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[f+12>>2]=r;t[o>>2]=n;t[c>>2]=t[u>>2];do if((t[(t[c>>2]|0)+176>>2]|0)!=-1){u=t[c>>2]|0;if((t[(t[c>>2]|0)+96>>2]|0)<=(t[(t[c>>2]|0)+176>>2]|0)){t[u+176>>2]=-1;break}n=u+96|0;t[n>>2]=(t[n>>2]|0)+-1;s=f;return}while(0);if(!((Xl(t[(t[(t[c>>2]|0)+108>>2]|0)+12>>2]|0,t[a>>2]|0)|0)!=0?(Xl(t[(t[(t[c>>2]|0)+108>>2]|0)+16>>2]|0,t[o>>2]|0)|0)!=0:0))rh(t[c>>2]|0,141632,141664);t[l>>2]=rd(t[c>>2]|0)|0;if(!((t[l>>2]|0)!=0&(t[l>>2]|0)<0)){s=f;return}rh(t[c>>2]|0,141632,141688);t[(t[c>>2]|0)+52>>2]=-1;tS(t[(t[c>>2]|0)+40>>2]|0);s=f;return}function mh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if((t[(t[o>>2]|0)+96>>2]|0)<0){s=n;return}if((t[(t[o>>2]|0)+176>>2]|0)!=-1?(t[(t[o>>2]|0)+96>>2]|0)>=(t[(t[o>>2]|0)+176>>2]|0):0){s=n;return}if(t[(t[(t[o>>2]|0)+108>>2]|0)+32>>2]&32){f=(t[(t[o>>2]|0)+108>>2]|0)+32|0;t[f>>2]=t[f>>2]^32}if((nd(t[o>>2]|0,3,t[u>>2]|0,t[a>>2]|0,3,0)|0)!=-1){s=n;return}rh(t[o>>2]|0,141304,141336);t[(t[o>>2]|0)+52>>2]=-1;tS(t[(t[o>>2]|0)+40>>2]|0);s=n;return}function _h(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if((t[(t[o>>2]|0)+96>>2]|0)<0){s=n;return}if((t[(t[o>>2]|0)+176>>2]|0)!=-1?(t[(t[o>>2]|0)+96>>2]|0)>=(t[(t[o>>2]|0)+176>>2]|0):0){s=n;return}if(t[(t[(t[o>>2]|0)+108>>2]|0)+32>>2]&32){f=(t[(t[o>>2]|0)+108>>2]|0)+32|0;t[f>>2]=t[f>>2]^32}if((nd(t[o>>2]|0,4,t[u>>2]|0,t[a>>2]|0,3,0)|0)!=-1){s=n;return}rh(t[o>>2]|0,141304,141336);t[(t[o>>2]|0)+52>>2]=-1;tS(t[(t[o>>2]|0)+40>>2]|0);s=n;return}function ph(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+8|0;t[f>>2]=e;t[r+12>>2]=i;t[u>>2]=t[f>>2];if((t[(t[u>>2]|0)+96>>2]|0)<0){s=r;return}if((t[(t[u>>2]|0)+176>>2]|0)!=-1?(t[(t[u>>2]|0)+96>>2]|0)>=(t[(t[u>>2]|0)+176>>2]|0):0){s=r;return}u=t[33976]|0;f=t[33980]|0;t[n>>2]=140328;t[n+4>>2]=27281;yAi[u&511](f,140296,n);s=r;return}function Eh(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[l>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}if(!(t[t[(t[l>>2]|0)+8>>2]>>2]|0)){s=f;return}NAi[t[t[(t[l>>2]|0)+8>>2]>>2]&511](t[(t[l>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function Sh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+8>>2]|0)+4>>2]|0)!=0:0){t[r>>2]=gAi[t[(t[(t[f>>2]|0)+8>>2]|0)+4>>2]&511](t[(t[f>>2]|0)+16>>2]|0)|0;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function gh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){t[r>>2]=gAi[t[(t[(t[f>>2]|0)+8>>2]|0)+8>>2]&511](t[(t[f>>2]|0)+16>>2]|0)|0;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function yh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0){t[r>>2]=gAi[t[(t[(t[f>>2]|0)+8>>2]|0)+12>>2]&511](t[(t[f>>2]|0)+16>>2]|0)|0;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Fh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[u>>2];if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[c>>2]|0)+8>>2]|0)+16>>2]|0)!=0:0){t[f>>2]=dAi[t[(t[(t[c>>2]|0)+8>>2]|0)+16>>2]&511](t[(t[c>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}function Oh(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[f>>2];if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+8>>2]|0)+20>>2]|0)!=0:0){t[n>>2]=MAi[t[(t[(t[a>>2]|0)+8>>2]|0)+20>>2]&511](t[(t[a>>2]|0)+16>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Ah(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=t[o>>2];if(!(t[w>>2]|0)){s=a;return}if(!(t[(t[w>>2]|0)+8>>2]|0)){s=a;return}if(!(t[(t[(t[w>>2]|0)+8>>2]|0)+24>>2]|0)){s=a;return}AAi[t[(t[(t[w>>2]|0)+8>>2]|0)+24>>2]&511](t[(t[w>>2]|0)+16>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0);s=a;return}function Mh(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[l>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}if(!(t[(t[(t[l>>2]|0)+8>>2]|0)+28>>2]|0)){s=f;return}NAi[t[(t[(t[l>>2]|0)+8>>2]|0)+28>>2]&511](t[(t[l>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function Rh(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+32|0;c=o+28|0;l=o+24|0;b=o+20|0;k=o+16|0;h=o+12|0;w=o+8|0;d=o+4|0;v=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;t[v>>2]=t[c>>2];if(((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[v>>2]|0)+8>>2]|0)+32>>2]|0)!=0:0){vAi[t[(t[(t[v>>2]|0)+8>>2]|0)+32>>2]&511](t[(t[v>>2]|0)+16>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0);s=o;return}NM(t[d>>2]|0);s=o;return}function Nh(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[l>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}if(!(t[(t[(t[l>>2]|0)+8>>2]|0)+36>>2]|0)){s=f;return}NAi[t[(t[(t[l>>2]|0)+8>>2]|0)+36>>2]&511](t[(t[l>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function Th(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u+20|0;o=u+16|0;c=u+12|0;l=u+8|0;b=u+4|0;k=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;t[k>>2]=t[a>>2];if(!(t[k>>2]|0)){s=u;return}if(!(t[(t[k>>2]|0)+8>>2]|0)){s=u;return}if(!(t[(t[(t[k>>2]|0)+8>>2]|0)+40>>2]|0)){s=u;return}mAi[t[(t[(t[k>>2]|0)+8>>2]|0)+40>>2]&511](t[(t[k>>2]|0)+16>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0);s=u;return}function Lh(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[n>>2];if(!(t[u>>2]|0)){s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=r;return}if(!(t[(t[(t[u>>2]|0)+8>>2]|0)+44>>2]|0)){s=r;return}EAi[t[(t[(t[u>>2]|0)+8>>2]|0)+44>>2]&511](t[(t[u>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}function Dh(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[r>>2];if(!(t[n>>2]|0)){s=i;return}if(!(t[(t[n>>2]|0)+8>>2]|0)){s=i;return}if(!(t[(t[(t[n>>2]|0)+8>>2]|0)+48>>2]|0)){s=i;return}pAi[t[(t[(t[n>>2]|0)+8>>2]|0)+48>>2]&511](t[(t[n>>2]|0)+16>>2]|0);s=i;return}function Ch(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[r>>2];if(!(t[n>>2]|0)){s=i;return}if(!(t[(t[n>>2]|0)+8>>2]|0)){s=i;return}if(!(t[(t[(t[n>>2]|0)+8>>2]|0)+52>>2]|0)){s=i;return}pAi[t[(t[(t[n>>2]|0)+8>>2]|0)+52>>2]&511](t[(t[n>>2]|0)+16>>2]|0);s=i;return}function Ph(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if(!(t[o>>2]|0)){s=n;return}if(!(t[(t[o>>2]|0)+8>>2]|0)){s=n;return}if(!(t[(t[(t[o>>2]|0)+8>>2]|0)+76>>2]|0)){s=n;return}yAi[t[(t[(t[o>>2]|0)+8>>2]|0)+76>>2]&511](t[(t[o>>2]|0)+16>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function Bh(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[n>>2];if(!(t[u>>2]|0)){s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=r;return}if(!(t[(t[(t[u>>2]|0)+8>>2]|0)+80>>2]|0)){s=r;return}EAi[t[(t[(t[u>>2]|0)+8>>2]|0)+80>>2]&511](t[(t[u>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}function Ih(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+8|0;t[f>>2]=e;t[r+12>>2]=i;t[u>>2]=t[f>>2];if(!(t[u>>2]|0)){s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=r;return}if(!(t[(t[(t[u>>2]|0)+8>>2]|0)+84>>2]|0)){s=r;return}u=t[33976]|0;f=t[33980]|0;t[n>>2]=140328;t[n+4>>2]=28421;yAi[u&511](f,140296,n);s=r;return}function Hh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+8|0;t[f>>2]=e;t[r+12>>2]=i;t[u>>2]=t[f>>2];if(!(t[u>>2]|0)){s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=r;return}if(!(t[(t[(t[u>>2]|0)+8>>2]|0)+88>>2]|0)){s=r;return}u=t[33976]|0;f=t[33980]|0;t[n>>2]=140328;t[n+4>>2]=28429;yAi[u&511](f,140296,n);s=r;return}function xh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+8|0;t[f>>2]=e;t[r+12>>2]=i;t[u>>2]=t[f>>2];if(!(t[u>>2]|0)){s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=r;return}if(!(t[(t[(t[u>>2]|0)+8>>2]|0)+92>>2]|0)){s=r;return}u=t[33976]|0;f=t[33980]|0;t[n>>2]=140328;t[n+4>>2]=28437;yAi[u&511](f,140296,n);s=r;return}function Uh(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[f>>2];if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+8>>2]|0)+96>>2]|0)!=0:0){t[n>>2]=MAi[t[(t[(t[a>>2]|0)+8>>2]|0)+96>>2]&511](t[(t[a>>2]|0)+16>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function zh(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[l>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}if(!(t[(t[(t[l>>2]|0)+8>>2]|0)+104>>2]|0)){s=f;return}NAi[t[(t[(t[l>>2]|0)+8>>2]|0)+104>>2]&511](t[(t[l>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function jh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if(!(t[o>>2]|0)){s=n;return}if((t[(t[o>>2]|0)+8>>2]|0)!=0?(t[(t[(t[o>>2]|0)+8>>2]|0)+68>>2]|0)!=0:0)yAi[t[(t[(t[o>>2]|0)+8>>2]|0)+68>>2]&511](t[(t[o>>2]|0)+16>>2]|0,t[u>>2]|0,t[a>>2]|0);if(!(t[(t[o>>2]|0)+148>>2]|0)){s=n;return}mh(t[(t[o>>2]|0)+148>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function Vh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if(!(t[o>>2]|0)){s=n;return}if((t[(t[o>>2]|0)+8>>2]|0)!=0?(t[(t[(t[o>>2]|0)+8>>2]|0)+72>>2]|0)!=0:0)yAi[t[(t[(t[o>>2]|0)+8>>2]|0)+72>>2]&511](t[(t[o>>2]|0)+16>>2]|0,t[u>>2]|0,t[a>>2]|0);if(!(t[(t[o>>2]|0)+148>>2]|0)){s=n;return}mh(t[(t[o>>2]|0)+148>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function qh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if(!(t[o>>2]|0)){s=n;return}if((t[(t[o>>2]|0)+8>>2]|0)!=0?(t[(t[(t[o>>2]|0)+8>>2]|0)+100>>2]|0)!=0:0)yAi[t[(t[(t[o>>2]|0)+8>>2]|0)+100>>2]&511](t[(t[o>>2]|0)+16>>2]|0,t[u>>2]|0,t[a>>2]|0);if(!(t[(t[o>>2]|0)+148>>2]|0)){s=n;return}_h(t[(t[o>>2]|0)+148>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function Yh(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[n>>2];if(!(t[u>>2]|0)){s=r;return}if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[u>>2]|0)+8>>2]|0)+64>>2]|0)!=0:0)EAi[t[(t[(t[u>>2]|0)+8>>2]|0)+64>>2]&511](t[(t[u>>2]|0)+16>>2]|0,t[f>>2]|0);if(!(t[(t[u>>2]|0)+148>>2]|0)){s=r;return}ph(t[(t[u>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}function Gh(e,i,r,n,f,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;l=s;s=s+48|0;b=l+36|0;k=l+32|0;h=l+28|0;w=l+24|0;d=l+20|0;v=l+16|0;m=l+12|0;_=l+8|0;p=l+4|0;E=l;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=t[b>>2];if(!(t[E>>2]|0)){s=l;return}if((t[(t[E>>2]|0)+8>>2]|0)!=0?(t[(t[(t[E>>2]|0)+8>>2]|0)+116>>2]|0)!=0:0)FAi[t[(t[(t[E>>2]|0)+8>>2]|0)+116>>2]&511](t[(t[E>>2]|0)+16>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,t[m>>2]|0,t[_>>2]|0,t[p>>2]|0);if(!(t[(t[E>>2]|0)+148>>2]|0)){s=l;return}dh(t[(t[E>>2]|0)+148>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,t[m>>2]|0,t[_>>2]|0,t[p>>2]|0);s=l;return}function Wh(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[l>>2]|0)){s=f;return}if((t[(t[l>>2]|0)+8>>2]|0)!=0?(t[(t[(t[l>>2]|0)+8>>2]|0)+120>>2]|0)!=0:0)NAi[t[(t[(t[l>>2]|0)+8>>2]|0)+120>>2]&511](t[(t[l>>2]|0)+16>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);if(!(t[(t[l>>2]|0)+148>>2]|0)){s=f;return}vh(t[(t[l>>2]|0)+148>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function Kh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+96>>2]=-1;t[(t[n>>2]|0)+176>>2]=-1;t[(t[n>>2]|0)+92>>2]=0;t[(t[n>>2]|0)+184>>2]=0;t[(t[n>>2]|0)+188>>2]=0;do if(!(t[(t[n>>2]|0)+20>>2]|0)){t[(t[n>>2]|0)+92>>2]=1;if((t[(t[n>>2]|0)+88>>2]|0)==0?(fd(t[n>>2]|0)|0)==-1:0){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=t[(t[n>>2]|0)+88>>2];t[(t[f>>2]|0)+104>>2]=1;e=oh(t[f>>2]|0)|0;t[(t[n>>2]|0)+20>>2]=e;if(!(t[(t[n>>2]|0)+20>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}e=ch(t[(t[f>>2]|0)+80>>2]|0)|0;t[(t[f>>2]|0)+28>>2]=e;if(t[(t[f>>2]|0)+28>>2]|0){t[t[(t[f>>2]|0)+28>>2]>>2]=t[(t[n>>2]|0)+20>>2];
	t[(t[f>>2]|0)+32>>2]=1;break}t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}while(0);aO(t[(t[(t[n>>2]|0)+20>>2]|0)+48>>2]|0,357,t[n>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Xh(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[(t[r>>2]|0)+92>>2]|0)!=0?(t[(t[r>>2]|0)+20>>2]|0)!=0:0){Ak(t[(t[r>>2]|0)+20>>2]|0);t[(t[r>>2]|0)+20>>2]=0}ud(t[r>>2]|0);s=i;return}function Zh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)!=0?!((t[a>>2]|0)==0&(t[o>>2]|0)==0):0){if(t[a>>2]|0)t[t[a>>2]>>2]=0;if(t[o>>2]|0)t[t[o>>2]>>2]=0;t[c>>2]=t[u>>2];if(!(t[(t[c>>2]|0)+36>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}if(t[a>>2]|0)t[t[a>>2]>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+4>>2];if(t[o>>2]|0)t[t[o>>2]>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2];t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}function Jh(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+4>>2]|0)){s=i;return}t[f>>2]=t[t[r>>2]>>2];t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[r>>2]|0)+4>>2]|0))break;t[n>>2]=t[(t[f>>2]|0)+(t[u>>2]<<2)>>2];e:do if(t[n>>2]|0)do switch(t[t[n>>2]>>2]|0){case 18:{wd(t[n>>2]|0);break e;break}case 26:{od(t[n>>2]|0);break e;break}case 8:case 7:case 6:{sd(t[n>>2]|0);break e;break}case 14:{ld(t[n>>2]|0);break e;break}case 2e3:{dd(t[n>>2]|0);break e;break}case 25:{if(t[(t[n>>2]|0)+4>>2]|0)Yk(t[(t[n>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0);break e;break}case 5:case 4:{Ok(t[n>>2]|0);break e;break}case 15:{ad(t[n>>2]|0);break e;break}case 17:{kd(t[n>>2]|0);break e;break}case 16:{bd(t[n>>2]|0);break e;break}case 2001:{cd(t[n>>2]|0);break e;break}case 24:case 22:case 23:{hd(t[n>>2]|0);break e;break}case 21:case 2:{yk(t[n>>2]|0);break e;break}default:{md(0,170280,vd(t[n>>2]|0)|0);break e}}while(0);while(0);t[u>>2]=(t[u>>2]|0)+1}t[(t[r>>2]|0)+4>>2]=0;s=i;return}function Qh(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(t[f>>2]|0){r=(t[f>>2]|0)+20|0;t[r>>2]=(t[r>>2]|0)+1}dp(16,2,t[a>>2]|0,0,t[u>>2]|0);s=n;return}function $h(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)Wk(t[(t[r>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function ew(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[r>>2];t[r>>2]=t[t[r>>2]>>2];pAi[t[135736>>2]&511](t[n>>2]|0)}s=i;return}function iw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;t[u>>2]=t[(t[f>>2]|0)+8>>2];e:do if(t[(t[f>>2]|0)+24>>2]|0){t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[f>>2]|0)+28>>2]|0))break e;if(t[(t[(t[f>>2]|0)+24>>2]|0)+(t[a>>2]<<2)>>2]|0){pAi[t[135736>>2]&511](t[(t[(t[f>>2]|0)+24>>2]|0)+(t[a>>2]<<2)>>2]|0);t[(t[(t[f>>2]|0)+24>>2]|0)+(t[a>>2]<<2)>>2]=0}t[a>>2]=(t[a>>2]|0)+1}}while(0);if(t[(t[f>>2]|0)+32>>2]|0){e:do if((t[(t[f>>2]|0)+20>>2]|0)==24){t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[(t[f>>2]|0)+32>>2]|0)+4>>2]|0))break e;t[c>>2]=t[(t[t[(t[f>>2]|0)+32>>2]>>2]|0)+(t[o>>2]<<2)>>2];pAi[t[135736>>2]&511](t[(t[c>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[c>>2]|0);t[o>>2]=(t[o>>2]|0)+1}}while(0);Wk(t[(t[f>>2]|0)+32>>2]|0);t[(t[f>>2]|0)+32>>2]=0}t[(t[f>>2]|0)+8>>2]=0;if(t[(t[n>>2]|0)+124>>2]|0)t[(t[f>>2]|0)+12>>2]=t[(t[n>>2]|0)+124>>2];t[(t[n>>2]|0)+124>>2]=t[f>>2];t[f>>2]=t[u>>2]}s=r;return}function rw(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[r>>2];t[r>>2]=t[t[r>>2]>>2];_d(t[n>>2]|0)}s=i;return}function nw(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u+20|0;o=u+16|0;c=u+12|0;l=u+8|0;b=u+4|0;k=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;t[k>>2]=0;if(!(t[a>>2]|0)){s=u;return}t[k>>2]=Yl(158256)|0;t[k>>2]=us(t[k>>2]|0,t[o>>2]|0)|0;t[k>>2]=us(t[k>>2]|0,144448)|0;t[k>>2]=us(t[k>>2]|0,t[c>>2]|0)|0;t[k>>2]=us(t[k>>2]|0,142704)|0;c=t[a>>2]|0;if((t[t[a>>2]>>2]|0)!=2){if((t[c>>2]|0)==1)pd(t[a>>2]|0,3069,0,t[k>>2]|0,t[l>>2]|0,t[b>>2]|0)}else pd(c,1818,0,t[k>>2]|0,t[l>>2]|0,t[b>>2]|0);if(!(t[k>>2]|0)){s=u;return}pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0;s=u;return}function fw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;i=Ed(t[f>>2]|0)|0;if((i|0)==3)t[n>>2]=TD(t[u>>2]|0)|0;else if((i|0)==2)t[n>>2]=ND(t[u>>2]|0)|0;else t[n>>2]=0;s=r;return t[n>>2]|0}function tw(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+48|0;o=a+44|0;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;_=a+4|0;p=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+20>>2]|0)==0:0){rh(t[c>>2]|0,157712,157744);t[o>>2]=-1;E=t[o>>2]|0;s=a;return E|0}t[d>>2]=qg(t[k>>2]|0,1)|0;if(t[d>>2]|0){t[o>>2]=t[d>>2];E=t[o>>2]|0;s=a;return E|0}t[v>>2]=0;t[m>>2]=0;t[v>>2]=zg(t[k>>2]|0,m)|0;if(!(t[m>>2]|0)){if(!(gd(t[l>>2]|0,t[k>>2]|0,0)|0)){t[o>>2]=1;E=t[o>>2]|0;s=a;return E|0}if((t[w>>2]|0)!=0&(t[h>>2]|0)!=0?(u=OD(Yl(t[k>>2]|0)|0,0)|0,t[t[h>>2]>>2]=u,(t[t[h>>2]>>2]|0)==0):0)t[d>>2]=-1}else{t[_>>2]=0;do if(!(t[c>>2]|0))if(t[b>>2]|0){t[p>>2]=wF(t[(t[b>>2]|0)+32>>2]|0,t[b>>2]|0,t[m>>2]|0)|0;if(!(t[p>>2]|0))break;t[_>>2]=t[(t[p>>2]|0)+8>>2];break}else{pAi[t[135736>>2]&511](t[m>>2]|0);pAi[t[135736>>2]&511](t[v>>2]|0);t[o>>2]=1;E=t[o>>2]|0;s=a;return E|0}else t[_>>2]=Sd(t[c>>2]|0,t[m>>2]|0)|0;while(0);if(!(t[_>>2]|0)){pAi[t[135736>>2]&511](t[m>>2]|0);pAi[t[135736>>2]&511](t[v>>2]|0);t[o>>2]=1;E=t[o>>2]|0;s=a;return E|0}if(gd(t[l>>2]|0,t[v>>2]|0,t[_>>2]|0)|0){if((t[w>>2]|0)!=0&(t[h>>2]|0)!=0?(w=Yl(t[v>>2]|0)|0,l=OD(w,Yl(t[_>>2]|0)|0)|0,t[t[h>>2]>>2]=l,(t[t[h>>2]>>2]|0)==0):0)t[d>>2]=-1}else t[d>>2]=1;pAi[t[135736>>2]&511](t[m>>2]|0);pAi[t[135736>>2]&511](t[v>>2]|0)}t[o>>2]=t[d>>2];E=t[o>>2]|0;s=a;return E|0}function uw(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[w>>2]=0;t[b>>2]=qg(t[o>>2]|0,1)|0;if(t[b>>2]|0)if((t[b>>2]|0)==-1){rh(t[a>>2]|0,157656,157680);t[u>>2]=-1;d=t[u>>2]|0;s=f;return d|0}else{t[u>>2]=1824;d=t[u>>2]|0;s=f;return d|0}t[h>>2]=zg(t[o>>2]|0,w)|0;if(!(t[h>>2]|0))t[h>>2]=Yl(t[o>>2]|0)|0;t[k>>2]=Sd(t[a>>2]|0,t[w>>2]|0)|0;if((t[w>>2]|0)!=0?(pAi[t[135736>>2]&511](t[w>>2]|0),(t[k>>2]|0)==0):0){t[b>>2]=1824;w=t[a>>2]|0;a=t[b>>2]|0;n=ED(21)|0;th(w,a,0,n,154112,t[o>>2]|0,0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[u>>2]=t[b>>2];d=t[u>>2]|0;s=f;return d|0}do if((t[l>>2]|0)!=0&(t[c>>2]|0)!=0)if(t[k>>2]|0){b=Yl(t[k>>2]|0)|0;o=AD(b,t[h>>2]|0)|0;t[t[c>>2]>>2]=o;break}else{o=AD(0,t[h>>2]|0)|0;t[t[c>>2]>>2]=o;break}else pAi[t[135736>>2]&511](t[h>>2]|0);while(0);t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}function aw(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0;c=s;s=s+80|0;l=c+68|0;b=c+64|0;k=c+60|0;h=c+56|0;w=c+52|0;d=c+48|0;v=c+44|0;m=c+40|0;_=c+36|0;p=c+32|0;E=c+28|0;S=c+24|0;g=c+20|0;y=c+16|0;F=c+12|0;O=c+8|0;A=c+4|0;M=c;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[E>>2]=0;t[F>>2]=0;if((t[t[h>>2]>>2]|0)==1){t[l>>2]=0;R=t[l>>2]|0;s=c;return R|0}e:do if(t[(t[h>>2]|0)+96>>2]|0){o=t[h>>2]|0;i:do if(t[(t[h>>2]|0)+48>>2]&256){t[S>>2]=yd(o)|0;do if((t[(t[S>>2]|0)+88>>2]|0)==1)N=9;else{if((t[t[S>>2]>>2]|0)==1?(t[(t[S>>2]|0)+88>>2]|0)==46:0){N=9;break}t[O>>2]=3}while(0);if((N|0)==9)t[O>>2]=Ed(t[h>>2]|0)|0;if(!(t[v>>2]|0))t[w>>2]=t[w>>2];else t[w>>2]=qD(t[v>>2]|0)|0;t[p>>2]=0;t[g>>2]=t[(t[h>>2]|0)+96>>2];while(1){if(!(t[g>>2]|0))break i;switch(t[t[(t[g>>2]|0)+4>>2]>>2]|0){case 1010:case 1011:case 1009:{t[p>>2]=zD(t[(t[g>>2]|0)+4>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,F,t[O>>2]|0)|0;N=19;break}case 1007:case 1006:case 1008:break;default:{t[p>>2]=jD(t[(t[g>>2]|0)+4>>2]|0,t[O>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,t[O>>2]|0)|0;N=19}}if((N|0)==19){N=0;if((t[p>>2]|0)<0){N=20;break}if((t[p>>2]|0)>0){if(!(t[_>>2]|0)){N=24;break}Fd(t[b>>2]|0,t[p>>2]|0,t[k>>2]|0,t[d>>2]|0,t[F>>2]|0,t[h>>2]|0,t[(t[g>>2]|0)+4>>2]|0,0,0,0);if(!(t[E>>2]|0))t[E>>2]=t[p>>2]}t[p>>2]=0}t[g>>2]=t[t[g>>2]>>2]}if((N|0)==20){rh(t[b>>2]|0,156584,156608);t[l>>2]=-1;R=t[l>>2]|0;s=c;return R|0}else if((N|0)==24){t[l>>2]=t[p>>2];R=t[l>>2]|0;s=c;return R|0}}else if(!(t[o+48>>2]&64))break e;while(0);if(t[(t[h>>2]|0)+48>>2]&64){t[p>>2]=0;t[g>>2]=t[(t[h>>2]|0)+96>>2];while(1){if(!(t[g>>2]|0))break e;if(((t[t[(t[g>>2]|0)+4>>2]>>2]|0)+-1009|0)>>>0<3){t[p>>2]=xD(t[(t[g>>2]|0)+4>>2]|0,t[d>>2]|0,t[m>>2]|0,0)|0;if((t[p>>2]|0)<0){N=33;break}if((t[p>>2]|0)>0){if(!(t[_>>2]|0)){N=37;break}Fd(t[b>>2]|0,t[p>>2]|0,t[k>>2]|0,t[d>>2]|0,t[m>>2]|0,t[h>>2]|0,t[(t[g>>2]|0)+4>>2]|0,0,0,0);if(!(t[E>>2]|0))t[E>>2]=t[p>>2]}t[p>>2]=0}t[g>>2]=t[t[g>>2]>>2]}if((N|0)==33){rh(t[b>>2]|0,156584,156648);t[l>>2]=-1;R=t[l>>2]|0;s=c;return R|0}else if((N|0)==37){t[l>>2]=t[p>>2];R=t[l>>2]|0;s=c;return R|0}}}while(0);do if((t[E>>2]|0)>=0){t[A>>2]=0;t[p>>2]=0;t[S>>2]=t[h>>2];e:do{t[y>>2]=t[(t[S>>2]|0)+68>>2];while(1){if(!(t[y>>2]|0))break;if((t[t[y>>2]>>2]|0)==1007){t[A>>2]=1;t[p>>2]=Od(t[(t[y>>2]|0)+32>>2]|0,t[v>>2]|0)|0;if((t[p>>2]|0)==1)break;if((t[p>>2]|0)<0){N=48;break e}}t[y>>2]=t[(t[y>>2]|0)+4>>2]}if((t[p>>2]|0)!=0|(t[A>>2]|0)!=0)break;t[S>>2]=t[(t[S>>2]|0)+64>>2];if(!(t[S>>2]|0))break}while((t[t[S>>2]>>2]|0)!=1);if((N|0)==48){rh(t[b>>2]|0,156584,156688);t[l>>2]=-1;R=t[l>>2]|0;s=c;return R|0}if((t[A>>2]|0)!=0&(t[p>>2]|0)==0){t[p>>2]=1840;if(t[_>>2]|0){Fd(t[b>>2]|0,t[p>>2]|0,t[k>>2]|0,t[d>>2]|0,0,t[h>>2]|0,0,0,0,0);if(t[E>>2]|0)break;t[E>>2]=t[p>>2];break}else{t[l>>2]=t[p>>2];R=t[l>>2]|0;s=c;return R|0}}}while(0);e:do if((t[E>>2]|0)>=0){t[S>>2]=t[h>>2];t[y>>2]=0;i:while(1){t[M>>2]=0;t[g>>2]=t[(t[S>>2]|0)+96>>2];while(1){if(!(t[g>>2]|0))break;if((t[t[(t[g>>2]|0)+4>>2]>>2]|0)==1006){t[M>>2]=1;t[p>>2]=eb(t[(t[(t[g>>2]|0)+4>>2]|0)+36>>2]|0,t[d>>2]|0)|0;if((t[p>>2]|0)==1)break;if((t[p>>2]|0)<0){N=65;break i}t[y>>2]=t[(t[g>>2]|0)+4>>2]}t[g>>2]=t[t[g>>2]>>2]}if((t[M>>2]|0)!=0&(t[p>>2]|0)!=1)break;t[S>>2]=t[(t[S>>2]|0)+64>>2];if(!(t[S>>2]|0))break e;if((t[t[S>>2]>>2]|0)==1)break e}if((N|0)==65){rh(t[b>>2]|0,156584,156728);t[l>>2]=-1;R=t[l>>2]|0;s=c;return R|0}t[p>>2]=1839;if(t[_>>2]|0){Fd(t[b>>2]|0,t[p>>2]|0,t[k>>2]|0,t[d>>2]|0,0,t[h>>2]|0,t[y>>2]|0,0,0,0);if(t[E>>2]|0)break;t[E>>2]=t[p>>2];break}else{t[l>>2]=t[p>>2];R=t[l>>2]|0;s=c;return R|0}}while(0);t[l>>2]=t[E>>2];R=t[l>>2]|0;s=c;return R|0}function ow(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=0;bw(w,t[o>>2]|0,t[l>>2]|0)|0;if((t[h>>2]|0)==0?(Ad(t[o>>2]|0,t[l>>2]|0)|0)!=2:0)t[w>>2]=us(t[w>>2]|0,154288)|0;else t[w>>2]=us(t[w>>2]|0,154256)|0;u=(Md(t[k>>2]|0)|0)!=0;f=t[w>>2]|0;if(u)t[w>>2]=us(f,154352)|0;else t[w>>2]=us(f,154336)|0;do if(!(t[(t[k>>2]|0)+48>>2]&256)){if(t[(t[k>>2]|0)+48>>2]&64){t[w>>2]=us(t[w>>2]|0,147936)|0;break}if(t[(t[k>>2]|0)+48>>2]&128)t[w>>2]=us(t[w>>2]|0,147952)|0}else t[w>>2]=us(t[w>>2]|0,147920)|0;while(0);if(Md(t[k>>2]|0)|0){t[d>>2]=0;t[w>>2]=us(t[w>>2]|0,143656)|0;f=t[w>>2]|0;if(t[(t[k>>2]|0)+88>>2]|0){t[w>>2]=us(f,154360)|0;t[w>>2]=us(t[w>>2]|0,t[(t[k>>2]|0)+8>>2]|0)|0}else t[w>>2]=us(f,uh(d,t[(t[k>>2]|0)+112>>2]|0,t[(t[k>>2]|0)+8>>2]|0)|0)|0;t[w>>2]=us(t[w>>2]|0,142568)|0;if(t[d>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0}}t[w>>2]=us(t[w>>2]|0,142704)|0;if((t[h>>2]|0)==0?(Ad(t[o>>2]|0,t[l>>2]|0)|0)!=2:0)pd(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[w>>2]|0,0,0);else pd(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[w>>2]|0,t[b>>2]|0,0);if(!(t[w>>2]|0)){s=a;return}pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0;s=a;return}function cw(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;while(1){if(!(t[n>>2]|0)){f=7;break}if((t[t[n>>2]>>2]|0)!=4){f=7;break}u=t[n>>2]|0;if(t[(t[n>>2]|0)+92>>2]|0){f=5;break}t[n>>2]=t[u+64>>2]}if((f|0)==5){t[r>>2]=t[u+92>>2];a=t[r>>2]|0;s=i;return a|0}else if((f|0)==7){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}return 0}function lw(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do switch(t[t[n>>2]>>2]|0){case 21:case 2:{t[r>>2]=t[(t[n>>2]|0)+12>>2];break}case 15:{t[r>>2]=t[(t[n>>2]|0)+52>>2];break}case 16:{t[r>>2]=t[(t[n>>2]|0)+32>>2];break}case 2e3:{t[r>>2]=t[(t[n>>2]|0)+20>>2];break}case 24:case 23:case 22:{t[r>>2]=t[(t[n>>2]|0)+12>>2];break}case 8:case 7:case 6:{t[r>>2]=t[(t[n>>2]|0)+16>>2];break}case 25:{t[r>>2]=t[(t[n>>2]|0)+24>>2];break}case 26:{t[r>>2]=t[(t[n>>2]|0)+20>>2];break}case 17:{t[r>>2]=t[(t[n>>2]|0)+24>>2];break}case 4:case 5:{t[r>>2]=t[(t[n>>2]|0)+36>>2];break}case 14:{t[r>>2]=t[(t[n>>2]|0)+36>>2];break}default:t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function sw(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;f=s;s=s+64|0;u=f+48|0;a=f+44|0;o=f+40|0;c=f+36|0;l=f+32|0;b=f+28|0;k=f+24|0;h=f+20|0;w=f+16|0;d=f+12|0;v=f+8|0;m=f+4|0;_=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=0;t[b>>2]=1;if(t[t[u>>2]>>2]|0){pAi[t[135736>>2]&511](t[t[u>>2]>>2]|0);t[t[u>>2]>>2]=0}e:do if(t[a>>2]|0){n=Yl(t[a>>2]|0)|0;t[t[u>>2]>>2]=n}else{if(!(t[o>>2]|0)){t[b>>2]=0;break}do switch(t[t[o>>2]>>2]|0){case 4:{t[h>>2]=t[o>>2];if(t[(t[h>>2]|0)+48>>2]&8){n=Yl(142672)|0;t[t[u>>2]>>2]=n}else{n=Yl(147912)|0;t[t[u>>2]>>2]=n}do if(!(t[(t[h>>2]|0)+48>>2]&256)){if(t[(t[h>>2]|0)+48>>2]&64){n=us(t[t[u>>2]>>2]|0,147936)|0;t[t[u>>2]>>2]=n;break}n=t[t[u>>2]>>2]|0;if(t[(t[h>>2]|0)+48>>2]&128){r=us(n,147952)|0;t[t[u>>2]>>2]=r;break}else{r=us(n,147968)|0;t[t[u>>2]>>2]=r;break}}else{r=us(t[t[u>>2]>>2]|0,147920)|0;t[t[u>>2]>>2]=r}while(0);if(!(t[(t[h>>2]|0)+48>>2]&8))break e;r=us(t[t[u>>2]>>2]|0,143656)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,t[(t[h>>2]|0)+8>>2]|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 15:{t[v>>2]=t[o>>2];r=Yl(148032)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,143656)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,uh(l,t[(t[v>>2]|0)+56>>2]|0,t[(t[v>>2]|0)+8>>2]|0)|0)|0;t[t[u>>2]>>2]=r;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 16:{Nd(t[u>>2]|0,t[o>>2]|0)|0;break e;break}case 5:{t[w>>2]=t[o>>2];if(t[(t[w>>2]|0)+48>>2]&8){r=Yl(142672)|0;t[t[u>>2]>>2]=r}else{r=Yl(147912)|0;t[t[u>>2]>>2]=r}r=us(t[t[u>>2]>>2]|0,147984)|0;t[t[u>>2]>>2]=r;if(!(t[(t[w>>2]|0)+48>>2]&8))break e;r=us(t[t[u>>2]>>2]|0,143656)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,t[(t[w>>2]|0)+8>>2]|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 24:case 23:case 22:{do if((t[t[o>>2]>>2]|0)!=22)if((t[t[o>>2]>>2]|0)==23){r=Yl(148080)|0;t[t[u>>2]>>2]=r;break}else{r=Yl(148088)|0;t[t[u>>2]>>2]=r;break}else{r=Yl(148064)|0;t[t[u>>2]>>2]=r}while(0);r=us(t[t[u>>2]>>2]|0,t[(t[o>>2]|0)+16>>2]|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 14:{t[m>>2]=t[o>>2];r=Yl(148048)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,143656)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,uh(l,t[(t[m>>2]|0)+52>>2]|0,t[(t[m>>2]|0)+8>>2]|0)|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 1:{t[k>>2]=t[o>>2];do if(!(t[(t[k>>2]|0)+48>>2]&256)){if(t[(t[k>>2]|0)+48>>2]&64){r=Yl(147856)|0;t[t[u>>2]>>2]=r;break}if(t[(t[k>>2]|0)+48>>2]&128){r=Yl(147872)|0;t[t[u>>2]>>2]=r;break}else{r=Yl(147888)|0;t[t[u>>2]>>2]=r;break}}else{r=Yl(147832)|0;t[t[u>>2]>>2]=r}while(0);r=us(t[t[u>>2]>>2]|0,t[(t[k>>2]|0)+8>>2]|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 17:{r=Yl(148128)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,143656)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,Rd(l,t[o>>2]|0)|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;if(!(t[l>>2]|0))break e;pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0;break e;break}case 25:case 8:case 7:case 6:{r=Yl(vd(t[o>>2]|0)|0)|0;t[t[u>>2]>>2]=r;break e;break}case 21:case 2:{r=Yl(Td(t[(t[o>>2]|0)+24>>2]|0)|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,148104)|0;t[t[u>>2]>>2]=r;break e;break}case 18:{r=Yl(vd(t[o>>2]|0)|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,143656)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,Rd(l,t[o>>2]|0)|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}break}case 1011:case 1010:case 1009:case 1008:case 1007:case 1006:case 1005:case 1004:case 1003:case 1002:case 1001:case 1e3:{r=Yl(148120)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,fh(t[t[o>>2]>>2]|0)|0)|0;t[t[u>>2]>>2]=r;r=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=r;break e;break}case 26:{t[d>>2]=t[o>>2];r=Yl(148e3)|0;t[t[u>>2]>>2]=r;r=t[t[u>>2]>>2]|0;if(!(t[(t[d>>2]|0)+12>>2]|0)){n=us(r,148016)|0;t[t[u>>2]>>2]=n;break e}n=us(r,142568)|0;t[t[u>>2]>>2]=n;n=us(t[t[u>>2]>>2]|0,Rd(l,t[(t[d>>2]|0)+12>>2]|0)|0)|0;t[t[u>>2]>>2]=n;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}n=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=n;break e;break}default:{}}while(0);t[b>>2]=0}while(0);if((t[b>>2]|0)==0&(t[c>>2]|0)!=0){b=t[c>>2]|0;if((t[(t[c>>2]|0)+4>>2]|0)==2)t[_>>2]=t[b+20>>2];else t[_>>2]=b;b=Yl(144464)|0;t[t[u>>2]>>2]=b;b=t[t[u>>2]>>2]|0;d=t[_>>2]|0;if(t[(t[_>>2]|0)+36>>2]|0){o=us(b,uh(l,t[(t[d+36>>2]|0)+8>>2]|0,t[(t[_>>2]|0)+8>>2]|0)|0)|0;t[t[u>>2]>>2]=o;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}}else{o=us(b,t[d+8>>2]|0)|0;t[t[u>>2]>>2]=o}o=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=o}if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==2:0){o=us(t[t[u>>2]>>2]|0,148152)|0;t[t[u>>2]>>2]=o;o=t[t[u>>2]>>2]|0;d=t[c>>2]|0;if(t[(t[c>>2]|0)+36>>2]|0){b=us(o,uh(l,t[(t[d+36>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)|0;t[t[u>>2]>>2]=b;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}}else{b=us(o,t[d+8>>2]|0)|0;t[t[u>>2]>>2]=b}b=us(t[t[u>>2]>>2]|0,142568)|0;t[t[u>>2]>>2]=b}if(!(t[l>>2]|0)){p=t[u>>2]|0;E=t[p>>2]|0;s=f;return E|0}pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0;p=t[u>>2]|0;E=t[p>>2]|0;s=f;return E|0}function bw(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+48|0;f=n;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;t[t[a>>2]>>2]=0;if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)!=1:0)?(t[(t[c>>2]|0)+4>>2]|0)!=2:0){r=Yl(142672)|0;t[t[a>>2]>>2]=r;t[u>>2]=t[t[a>>2]>>2];w=t[u>>2]|0;s=n;return w|0}do if(t[c>>2]|0){if((t[(t[c>>2]|0)+4>>2]|0)==2){t[b>>2]=t[(t[c>>2]|0)+20>>2];r=Yl(144464)|0;t[t[a>>2]>>2]=r;r=t[t[a>>2]>>2]|0;i=t[b>>2]|0;if(t[(t[b>>2]|0)+36>>2]|0){e=us(r,uh(l,t[(t[i+36>>2]|0)+8>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0)|0;t[t[a>>2]>>2]=e}else{e=us(r,uh(l,0,t[i+8>>2]|0)|0)|0;t[t[a>>2]>>2]=e}if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}e=us(t[t[a>>2]>>2]|0,142656)|0;t[t[a>>2]>>2]=e;e=us(t[t[a>>2]>>2]|0,144480)|0;t[t[a>>2]>>2]=e}else{e=Yl(144464)|0;t[t[a>>2]>>2]=e}e=t[t[a>>2]>>2]|0;i=t[c>>2]|0;if(t[(t[c>>2]|0)+36>>2]|0){r=us(e,uh(l,t[(t[i+36>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)|0;t[t[a>>2]>>2]=r}else{r=us(e,uh(l,0,t[i+8>>2]|0)|0)|0;t[t[a>>2]>>2]=r}if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}r=us(t[t[a>>2]>>2]|0,144496)|0;t[t[a>>2]>>2]=r}else{r=t[o>>2]|0;if((t[t[o>>2]>>2]|0)!=2){if((t[r>>2]|0)==1){i=Yl(142672)|0;t[t[a>>2]>>2]=i;break}i=t[33976]|0;e=t[33980]|0;t[f>>2]=140328;t[f+4>>2]=2246;yAi[i&511](e,140296,f);t[u>>2]=0;w=t[u>>2]|0;s=n;return w|0}t[k>>2]=r;if((t[t[(t[k>>2]|0)+108>>2]>>2]|0)==2){t[h>>2]=t[(t[(t[k>>2]|0)+100>>2]|0)+(t[(t[k>>2]|0)+96>>2]<<2)>>2];r=Yl(144464)|0;t[t[a>>2]>>2]=r;r=t[t[a>>2]>>2]|0;e=us(r,uh(l,t[(t[h>>2]|0)+16>>2]|0,t[(t[h>>2]|0)+12>>2]|0)|0)|0;t[t[a>>2]>>2]=e;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}e=us(t[t[a>>2]>>2]|0,142656)|0;t[t[a>>2]>>2]=e;e=us(t[t[a>>2]>>2]|0,144480)|0;t[t[a>>2]>>2]=e}else{e=Yl(144464)|0;t[t[a>>2]>>2]=e}e=t[t[a>>2]>>2]|0;r=us(e,uh(l,t[(t[(t[k>>2]|0)+108>>2]|0)+16>>2]|0,t[(t[(t[k>>2]|0)+108>>2]|0)+12>>2]|0)|0)|0;t[t[a>>2]>>2]=r;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}r=us(t[t[a>>2]>>2]|0,144496)|0;t[t[a>>2]>>2]=r}while(0);t[u>>2]=t[t[a>>2]>>2];w=t[u>>2]|0;s=n;return w|0}function kw(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;c=s;s=s+32|0;l=c+28|0;b=c+24|0;k=c+20|0;h=c+16|0;w=c+12|0;d=c+8|0;v=c+4|0;m=c;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=o;Ld(t[l>>2]|0,2,t[b>>2]|0,t[k>>2]|0,0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,t[m>>2]|0);s=c;return}function hw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=t[(t[(t[f>>2]|0)+28>>2]|0)+12>>2];if(!(t[(t[o>>2]|0)+4>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[(t[o>>2]|0)+4>>2]|0)){b=8;break}t[a>>2]=t[(t[t[o>>2]>>2]|0)+(t[c>>2]<<2)>>2];if((t[(t[a>>2]|0)+8>>2]|0)==(t[u>>2]|0)){b=6;break}t[c>>2]=(t[c>>2]|0)+1}if((b|0)==6){t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}else if((b|0)==8){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}return 0}function ww(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](16)|0;if(!(t[r>>2]|0)){Qh(0,170048,0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{f=t[r>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[f+12>>2]=0;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function dw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[(t[n>>2]|0)+24>>2];if(!(t[u>>2]|0)){t[(t[n>>2]|0)+24>>2]=t[f>>2];s=r;return}while(1){if(!(t[t[u>>2]>>2]|0))break;t[u>>2]=t[t[u>>2]>>2]}t[t[u>>2]>>2]=t[f>>2];s=r;return}function vw(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2];if(!(t[(t[l>>2]|0)+4>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[(t[l>>2]|0)+4>>2]|0)){h=14;break}t[c>>2]=t[(t[t[l>>2]>>2]|0)+(t[b>>2]<<2)>>2];if(!((t[(t[c>>2]|0)+20>>2]|0)==0?(t[(t[c>>2]|0)+8>>2]|0)!=0:0))h=7;if((h|0)==7?(h=0,(t[(t[c>>2]|0)+12>>2]|0)==(t[a>>2]|0)):0){if((t[o>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0){h=12;break}if((t[o>>2]|0)==0?(t[(t[c>>2]|0)+36>>2]|0)==0:0){h=12;break}}t[b>>2]=(t[b>>2]|0)+1}if((h|0)==12){t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}else if((h|0)==14){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}return 0}function mw(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;c=s;s=s+48|0;l=c+32|0;b=c+28|0;k=c+24|0;h=c+16|0;w=c+12|0;d=c+8|0;v=c+4|0;m=c;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[c+20>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;t[v>>2]=o;t[m>>2]=0;bw(m,t[l>>2]|0,t[k>>2]|0)|0;t[m>>2]=us(t[m>>2]|0,t[h>>2]|0)|0;t[m>>2]=us(t[m>>2]|0,142704)|0;Ld(t[l>>2]|0,1,t[b>>2]|0,t[k>>2]|0,0,t[m>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,0);if(!(t[m>>2]|0)){s=c;return}pAi[t[135736>>2]&511](t[m>>2]|0);t[m>>2]=0;s=c;return}function _w(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2];if(!(t[(t[l>>2]|0)+4>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[(t[l>>2]|0)+4>>2]|0)){h=10;break}t[c>>2]=t[(t[t[l>>2]>>2]|0)+(t[b>>2]<<2)>>2];if(((t[(t[c>>2]|0)+12>>2]|0)==0?(t[(t[c>>2]|0)+8>>2]|0)==(t[a>>2]|0):0)?(t[(t[c>>2]|0)+16>>2]|0)==(t[o>>2]|0):0){h=8;break}t[b>>2]=(t[b>>2]|0)+1}if((h|0)==8){t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}else if((h|0)==10){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}return 0}function pw(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;if(t[c>>2]|0){u=(t[c>>2]|0)+20|0;t[u>>2]=(t[u>>2]|0)+1;t[(t[c>>2]|0)+16>>2]=t[b>>2];t[d>>2]=t[(t[c>>2]|0)+8>>2];t[m>>2]=t[(t[c>>2]|0)+4>>2];t[v>>2]=t[(t[c>>2]|0)+24>>2]}u=t[v>>2]|0;v=t[d>>2]|0;d=t[m>>2]|0;m=t[c>>2]|0;c=t[l>>2]|0;l=t[b>>2]|0;b=t[h>>2]|0;f=t[w>>2]|0;n=t[k>>2]|0;k=t[w>>2]|0;t[o>>2]=t[h>>2];t[o+4>>2]=k;cp(u,v,d,m,c,16,l,2,0,0,b,f,0,0,0,n,o);s=a;return}function Ew(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}t[u>>2]=0;t[a>>2]=t[f>>2];e:while(1){o=(t[u>>2]|0)!=0;if(!(t[a>>2]|0))break;if(o){iy(t[u>>2]|0);ry(t[u>>2]|0);t[u>>2]=0}n=t[(t[a>>2]|0)+4>>2]|0;if((t[(t[a>>2]|0)+4>>2]|0)==3)if(((n|0)==3?(Dd(t[(t[a>>2]|0)+40>>2]|0,-1)|0)!=0:0)?(uF(t[a>>2]|0)|0)!=1:0){t[u>>2]=t[a>>2];c=14}else c=14;else if((n|0)!=1?(t[(t[a>>2]|0)+4>>2]|0)!=4:0)t[u>>2]=t[a>>2];else c=14;if(((((c|0)==14?(c=0,(t[(t[a>>2]|0)+12>>2]|0)!=0):0)?(t[(t[(t[a>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(t[(t[(t[a>>2]|0)+12>>2]|0)+4>>2]|0)!=5:0)?(t[(t[(t[a>>2]|0)+12>>2]|0)+4>>2]|0)!=6:0){t[a>>2]=t[(t[a>>2]|0)+12>>2];continue}if(t[(t[a>>2]|0)+24>>2]|0){t[a>>2]=t[(t[a>>2]|0)+24>>2];continue}while(1){t[a>>2]=t[(t[a>>2]|0)+20>>2];if(!(t[a>>2]|0))continue e;if((t[a>>2]|0)==(t[f>>2]|0)){c=23;break}l=t[a>>2]|0;if(t[(t[a>>2]|0)+24>>2]|0){c=25;break}if(!l)continue e}if((c|0)==23){c=0;t[a>>2]=0;continue}else if((c|0)==25){c=0;t[a>>2]=t[l+24>>2];continue}}if(!o){s=r;return}iy(t[u>>2]|0);ry(t[u>>2]|0);t[u>>2]=0;s=r;return}function Sw(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=vF(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}else{t[l>>2]=kz(t[(t[u>>2]|0)+80>>2]|0,t[c>>2]|0,-1)|0;pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}return 0}function gw(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;r=t[u>>2]|0;if(!(t[t[(t[u>>2]|0)+28>>2]>>2]|0)){rh(r,169824,169848);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[b>>2]=t[t[r+28>>2]>>2];t[l>>2]=56;t[c>>2]=gAi[t[135744>>2]&511](t[l>>2]|0)|0;if(!(t[c>>2]|0)){Qh(0,169880,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}VY(t[c>>2]|0,0,t[l>>2]|0)|0;t[(t[c>>2]|0)+16>>2]=t[o>>2];t[t[c>>2]>>2]=t[a>>2];l=hh()|0;t[(t[c>>2]|0)+44>>2]=l;if(!(t[(t[c>>2]|0)+44>>2]|0)){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}l=hh()|0;t[(t[c>>2]|0)+48>>2]=l;if(!(t[(t[c>>2]|0)+48>>2]|0)){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}do if((t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2]|0)!=0?(t[(t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2]|0)+4>>2]|0)>0:0){if(!(t[a>>2]|0)){rh(t[u>>2]|0,169824,169960);Xk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if((t[a>>2]|0)==1){l=oh(t[u>>2]|0)|0;t[(t[c>>2]|0)+52>>2]=l;if(t[(t[c>>2]|0)+52>>2]|0){t[(t[(t[c>>2]|0)+52>>2]|0)+4>>2]=t[o>>2];break}Xk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}}else w=11;while(0);do if((w|0)==11){if(!((t[a>>2]|0)==2|(t[a>>2]|0)==3)){t[t[c>>2]>>2]=0;t[(t[(t[u>>2]|0)+28>>2]|0)+4>>2]=t[c>>2];t[(t[c>>2]|0)+52>>2]=t[b>>2];t[(t[b>>2]|0)+4>>2]=t[o>>2];break}rh(t[u>>2]|0,169824,169912);Xk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}while(0);if((t[a>>2]|0)==0|(t[a>>2]|0)==1){if((t[(t[b>>2]|0)+48>>2]|0)==0?(a=KF(5,t[(t[(t[u>>2]|0)+28>>2]|0)+8>>2]|0)|0,t[(t[b>>2]|0)+48>>2]=a,(t[(t[b>>2]|0)+48>>2]|0)==0):0){Xk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}a=t[(t[b>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[k>>2]=ZF(a,145792,t[c>>2]|0)|0;else t[k>>2]=ZF(a,t[o>>2]|0,t[c>>2]|0)|0;if(t[k>>2]|0){rh(t[u>>2]|0,169824,17e4);Xk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}}else{if((t[t[(t[(t[u>>2]|0)+28>>2]|0)+16>>2]>>2]|0)!=0?(t[t[(t[(t[u>>2]|0)+28>>2]|0)+16>>2]>>2]|0)!=1:0)t[(t[c>>2]|0)+52>>2]=t[(t[(t[(t[u>>2]|0)+28>>2]|0)+16>>2]|0)+52>>2];else t[(t[c>>2]|0)+52>>2]=t[(t[(t[u>>2]|0)+28>>2]|0)+16>>2];if((t[(t[b>>2]|0)+64>>2]|0)==0?(k=hh()|0,t[(t[b>>2]|0)+64>>2]=k,(t[(t[b>>2]|0)+64>>2]|0)==0):0){Xk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}Cd(t[(t[b>>2]|0)+64>>2]|0,t[c>>2]|0)|0}if((Cd(t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2]|0,t[c>>2]|0)|0)==-1){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}else{t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}return 0}function yw(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+24>>2]&1){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^1}if(t[(t[r>>2]|0)+24>>2]&2){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^2}if(t[(t[r>>2]|0)+24>>2]&4){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^4}if(t[(t[r>>2]|0)+24>>2]&8){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^8}if(t[(t[r>>2]|0)+24>>2]&16){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^16}if(t[(t[r>>2]|0)+24>>2]&32){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^32}if(t[(t[r>>2]|0)+24>>2]&64){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^64}if(t[(t[r>>2]|0)+24>>2]&128){e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^128}if(!(t[(t[r>>2]|0)+24>>2]&256)){s=i;return}e=(t[r>>2]|0)+24|0;t[e>>2]=t[e>>2]^256;s=i;return}function Fw(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;t[k>>2]=t[(t[u>>2]|0)+20>>2];t[b>>2]=Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;do if((t[b>>2]|0)!=-1){t[c>>2]=Bd(t[o>>2]|0,168888)|0;if(t[c>>2]|0){r=t[u>>2]|0;i=t[c>>2]|0;t[b>>2]=Id(r,0,i,ED(29)|0,0)|0;if((t[b>>2]|0)==-1)break;if(t[b>>2]|0)t[(t[u>>2]|0)+108>>2]=3037;else h=6}else h=6;if((h|0)==6){t[c>>2]=Bd(t[o>>2]|0,168904)|0;if(t[c>>2]|0){t[l>>2]=Hd(t[u>>2]|0,t[c>>2]|0)|0;t[b>>2]=xd(t[l>>2]|0,(t[a>>2]|0)+24|0,1)|0;if((t[b>>2]|0)==-1)break;if(t[b>>2]|0)Ud(t[u>>2]|0,1705,0,t[c>>2]|0,0,163568,t[l>>2]|0,0,0,0)}t[c>>2]=Bd(t[o>>2]|0,168928)|0;if(t[c>>2]|0){t[l>>2]=Hd(t[u>>2]|0,t[c>>2]|0)|0;t[b>>2]=xd(t[l>>2]|0,(t[a>>2]|0)+24|0,2)|0;if((t[b>>2]|0)==-1)break;if(t[b>>2]|0)Ud(t[u>>2]|0,1701,0,t[c>>2]|0,0,163568,t[l>>2]|0,0,0,0)}t[c>>2]=Bd(t[o>>2]|0,168952)|0;if(t[c>>2]|0){t[l>>2]=Hd(t[u>>2]|0,t[c>>2]|0)|0;t[b>>2]=zd(t[l>>2]|0,(t[a>>2]|0)+24|0,-1,4,8,-1,16,32)|0;if((t[b>>2]|0)==-1)break;if(t[b>>2]|0)Ud(t[u>>2]|0,3037,0,t[c>>2]|0,0,168968,t[l>>2]|0,0,0,0)}t[c>>2]=Bd(t[o>>2]|0,169032)|0;if(t[c>>2]|0){t[l>>2]=Hd(t[u>>2]|0,t[c>>2]|0)|0;t[b>>2]=zd(t[l>>2]|0,(t[a>>2]|0)+24|0,-1,64,128,256,-1,-1)|0;if((t[b>>2]|0)==-1)break;if(t[b>>2]|0)Ud(t[u>>2]|0,3037,0,t[c>>2]|0,0,164576,t[l>>2]|0,0,0,0)}}if((t[k>>2]|0)!=(t[(t[u>>2]|0)+20>>2]|0))t[b>>2]=t[(t[u>>2]|0)+16>>2];t[f>>2]=t[b>>2];w=t[f>>2]|0;s=n;return w|0}while(0);t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}function Ow(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}t[k>>2]=t[(t[u>>2]|0)+20>>2];t[c>>2]=t[o>>2];e:while(1){if(!((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160960)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0))d=8;do if((d|0)==8){d=0;if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160968)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160976)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if(!(t[c>>2]|0)){d=49;break e}if(!(t[(t[c>>2]|0)+36>>2]|0)){d=49;break e}if(!(Xl(t[(t[c>>2]|0)+8>>2]|0,160992)|0)){d=49;break e}if(!(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)){d=49;break e}}while(0);do if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[l>>2]=jd(t[u>>2]|0,t[c>>2]|0,1)|0;
	o=t[l>>2]|0;if(!(t[(t[a>>2]|0)+20>>2]|0)){t[(t[a>>2]|0)+20>>2]=o;break}else{Yk(o);break}}else d=27;while(0);do if((d|0)==27){d=0;if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160968)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[h>>2]=t[(t[u>>2]|0)+20>>2];t[b>>2]=Vd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;if((t[b>>2]|0)==-1){d=97;break e}if(t[(t[u>>2]|0)+108>>2]|0)break e;if((t[h>>2]|0)!=(t[(t[u>>2]|0)+20>>2]|0))break e;else break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160960)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[h>>2]=t[(t[u>>2]|0)+20>>2];t[b>>2]=qd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;if((t[b>>2]|0)==-1){d=97;break e}if(t[(t[u>>2]|0)+108>>2]|0)break e;if((t[h>>2]|0)!=(t[(t[u>>2]|0)+20>>2]|0))break e;else break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160976)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[h>>2]=t[(t[u>>2]|0)+20>>2];t[b>>2]=Yd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;if((t[b>>2]|0)==-1){d=97;break e}if(t[(t[u>>2]|0)+108>>2]|0)break e;if((t[h>>2]|0)!=(t[(t[u>>2]|0)+20>>2]|0))break e}}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}if((d|0)==97){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}e:do if((d|0)==49)i:while(1){d=0;if(!(t[c>>2]|0))break e;if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Gd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0,1)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2]}else d=55;do if((d|0)==55){d=0;if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Wd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0,1)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2];break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161040)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Kd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0,0,1)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2];break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161048)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Xd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2];break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161064)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Zd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2];break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Jd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2];break}if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,161088)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Qd(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2];break}$d(t[u>>2]|0,3033,0,t[(t[c>>2]|0)+20>>2]|0,t[c>>2]|0,0,161104);t[c>>2]=t[(t[c>>2]|0)+24>>2]}while(0);while(1){if(!(t[c>>2]|0)){d=49;continue i}if(!(t[(t[c>>2]|0)+36>>2]|0)){d=49;continue i}if(!(Xl(t[(t[c>>2]|0)+8>>2]|0,160992)|0)){d=49;continue i}if(!(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)){d=49;continue i}t[l>>2]=jd(t[u>>2]|0,t[c>>2]|0,1)|0;h=t[l>>2]|0;if(!(t[(t[a>>2]|0)+20>>2]|0))t[(t[a>>2]|0)+20>>2]=h;else Yk(h);t[c>>2]=t[(t[c>>2]|0)+24>>2]}}while(0);t[(t[u>>2]|0)+84>>2]=0;if((t[k>>2]|0)!=(t[(t[u>>2]|0)+20>>2]|0))t[b>>2]=t[(t[u>>2]|0)+16>>2];t[f>>2]=t[b>>2];w=t[f>>2]|0;s=n;return w|0}function Aw(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;i=s;s=s+48|0;r=i+40|0;n=i+36|0;f=i+32|0;u=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+4|0;h=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+28>>2];if(!(t[u>>2]|0)){t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}e:while(1){t[o>>2]=t[(t[u>>2]|0)+4>>2];t[a>>2]=ev(t[(t[u>>2]|0)+24>>2]|0,t[t[o>>2]>>2]|0,t[(t[u>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0;do if(!(t[a>>2]|0)){t[l>>2]=0;if(t[(t[u>>2]|0)+8>>2]|0)t[b>>2]=lw(t[(t[u>>2]|0)+8>>2]|0)|0;else t[b>>2]=lw(t[o>>2]|0)|0;e=t[n>>2]|0;d=t[b>>2]|0;v=vd(t[o>>2]|0)|0;th(e,3081,d,0,160712,v,uh(l,t[(t[u>>2]|0)+20>>2]|0,t[(t[u>>2]|0)+16>>2]|0)|0);if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}t[f>>2]=t[(t[n>>2]|0)+16>>2];t[u>>2]=t[t[u>>2]>>2]}else{t[c>>2]=0;v=t[t[o>>2]>>2]|0;do if((v|0)==4|(v|0)==5)if(t[(t[a>>2]|0)+48>>2]&1073741824){t[c>>2]=1;break}else{d=(t[a>>2]|0)+48|0;t[d>>2]=t[d>>2]|1073741824;t[(t[o>>2]|0)+64>>2]=t[a>>2];break}else if((v|0)==17){if(t[(t[a>>2]|0)+28>>2]&2){t[c>>2]=1;break}d=(t[a>>2]|0)+28|0;t[d>>2]=t[d>>2]|2;if(t[(t[u>>2]|0)+8>>2]|0)t[(t[(t[u>>2]|0)+8>>2]|0)+12>>2]=t[a>>2];t[(t[u>>2]|0)+12>>2]=t[a>>2]}else if((v|0)==16){if(t[(t[a>>2]|0)+36>>2]&8){t[c>>2]=1;break}d=(t[a>>2]|0)+36|0;t[d>>2]=t[d>>2]|8;d=t[a>>2]|0;e=t[u>>2]|0;if(t[(t[u>>2]|0)+8>>2]|0){t[(t[e+8>>2]|0)+4>>2]=d;t[(t[u>>2]|0)+12>>2]=0;break}else{t[e+12>>2]=d;break}}else{m=24;break e}while(0);if(!(t[c>>2]|0)){t[u>>2]=t[t[u>>2]>>2];break}t[k>>2]=0;v=t[u>>2]|0;if(t[(t[u>>2]|0)+8>>2]|0)t[h>>2]=lw(t[v+8>>2]|0)|0;else t[h>>2]=lw(t[v+4>>2]|0)|0;v=t[n>>2]|0;d=t[h>>2]|0;th(v,3081,d,0,160856,Nd(k,t[a>>2]|0)|0,0);if(t[k>>2]|0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}t[f>>2]=t[(t[n>>2]|0)+16>>2];t[u>>2]=t[t[u>>2]>>2]}while(0);if(!(t[u>>2]|0)){m=34;break}}if((m|0)==24){rh(t[n>>2]|0,160784,160816);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else if((m|0)==34){t[r>>2]=t[f>>2];w=t[r>>2]|0;s=i;return w|0}return 0}function Mw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+48|0;n=r+36|0;f=r+32|0;u=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}if(t[(t[u>>2]|0)+4>>2]&2){t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}i=(t[u>>2]|0)+4|0;t[i>>2]=t[i>>2]|2;t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[(t[(t[u>>2]|0)+44>>2]|0)+4>>2]|0))break;t[a>>2]=t[(t[t[(t[u>>2]|0)+44>>2]>>2]|0)+(t[b>>2]<<2)>>2];t[c>>2]=0;e:do switch(t[t[a>>2]>>2]|0){case 4:case 5:{if(!(t[(t[a>>2]|0)+48>>2]&1073741824)){t[l>>2]=t[(t[a>>2]|0)+8>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+28;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+28;d=40}break}case 18:{t[l>>2]=t[(t[a>>2]|0)+4>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+44;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+44;d=40;break}case 14:{t[l>>2]=t[(t[a>>2]|0)+8>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+40;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+40;d=40;break}case 16:{if(!(t[(t[a>>2]|0)+36>>2]&8)){t[l>>2]=t[(t[a>>2]|0)+8>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+36;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+36;d=40}break}case 24:case 22:case 23:{t[l>>2]=t[(t[a>>2]|0)+16>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+76;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+76;d=40;break}case 17:{if(!(t[(t[a>>2]|0)+28>>2]&2)){t[l>>2]=t[(t[a>>2]|0)+16>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+56;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+56;d=40}break}case 15:{t[l>>2]=t[(t[a>>2]|0)+8>>2];if((t[t[u>>2]>>2]|0)!=0?(t[t[u>>2]>>2]|0)!=1:0){t[c>>2]=(t[(t[(t[u>>2]|0)+52>>2]|0)+52>>2]|0)+32;d=40;break e}t[c>>2]=(t[(t[u>>2]|0)+52>>2]|0)+32;d=40;break}default:rh(t[f>>2]|0,160568,160592)}while(0);if((d|0)==40){d=0;if((t[t[c>>2]>>2]|0)==0?(i=KF(10,t[(t[f>>2]|0)+80>>2]|0)|0,t[t[c>>2]>>2]=i,(t[t[c>>2]>>2]|0)==0):0){d=42;break}t[o>>2]=ZF(t[t[c>>2]>>2]|0,t[l>>2]|0,t[a>>2]|0)|0;if((t[o>>2]|0)!=0?(t[k>>2]=0,i=t[f>>2]|0,e=lw(t[a>>2]|0)|0,v=t[a>>2]|0,m=vd(t[a>>2]|0)|0,th(i,1761,e,v,160672,m,Rd(k,t[a>>2]|0)|0),(t[k>>2]|0)!=0):0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}}t[b>>2]=(t[b>>2]|0)+1}if((d|0)==42){rh(t[f>>2]|0,160568,160632);t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}e:do if(t[(t[u>>2]|0)+24>>2]|0){t[h>>2]=t[(t[u>>2]|0)+24>>2];while(1){if(((t[(t[h>>2]|0)+12>>2]|0)!=0?(t[(t[(t[h>>2]|0)+12>>2]|0)+4>>2]&2|0)==0:0)?(Mw(t[f>>2]|0,t[(t[h>>2]|0)+12>>2]|0)|0)==-1:0)break;t[h>>2]=t[t[h>>2]>>2];if(!(t[h>>2]|0))break e}t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}while(0);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}function Rw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if((t[f>>2]|0)==0|(t[n>>2]|0)==0){s=r;return}if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+48>>2]&256|0)!=0:0){s=r;return}i=(t[n>>2]|0)+48|0;t[i>>2]=t[i>>2]|256;do if((t[(t[n>>2]|0)+28>>2]|0)==0?(t[(t[n>>2]|0)+56>>2]|0)!=0:0){t[u>>2]=iv(t[(t[f>>2]|0)+36>>2]|0,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0)|0;if(!(t[u>>2]|0)){rv(t[f>>2]|0,3004,t[n>>2]|0,t[(t[n>>2]|0)+36>>2]|0,155448,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0,1,160528);break}else{t[(t[n>>2]|0)+28>>2]=t[u>>2];break}}while(0);do if(t[(t[n>>2]|0)+64>>2]|0){t[a>>2]=nv(t[(t[f>>2]|0)+36>>2]|0,t[(t[n>>2]|0)+64>>2]|0,t[(t[n>>2]|0)+68>>2]|0)|0;if(!(t[a>>2]|0)){rv(t[f>>2]|0,3004,t[n>>2]|0,0,160544,t[(t[n>>2]|0)+64>>2]|0,t[(t[n>>2]|0)+68>>2]|0,14,0);break}Rw(t[a>>2]|0,t[f>>2]|0);t[(t[n>>2]|0)+80>>2]=t[a>>2];if(!(t[(t[n>>2]|0)+28>>2]|0))t[(t[n>>2]|0)+28>>2]=t[(t[a>>2]|0)+28>>2]}while(0);if(t[(t[n>>2]|0)+28>>2]|0){s=r;return}if(t[(t[n>>2]|0)+56>>2]|0){s=r;return}if(t[(t[n>>2]|0)+64>>2]|0){s=r;return}a=ED(45)|0;t[(t[n>>2]|0)+28>>2]=a;s=r;return}function Nw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+64>>2]|0)==0?(i=iv(t[(t[f>>2]|0)+36>>2]|0,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0)|0,t[(t[n>>2]|0)+64>>2]=i,(t[(t[n>>2]|0)+64>>2]|0)==0):0){rv(t[f>>2]|0,3004,t[n>>2]|0,t[(t[n>>2]|0)+36>>2]|0,151424,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0,4,0);s=r;return}do if((t[t[n>>2]>>2]|0)!=4){if((t[t[n>>2]>>2]|0)==1?(t[(t[n>>2]|0)+88>>2]|0)!=45:0)break;if(!(t[(t[n>>2]|0)+28>>2]|0)){s=r;return}if((t[t[(t[n>>2]|0)+28>>2]>>2]|0)!=25){s=r;return}if(!(t[(t[(t[n>>2]|0)+28>>2]|0)+12>>2]|0)){s=r;return}if((t[t[(t[(t[n>>2]|0)+28>>2]|0)+12>>2]>>2]|0)!=2e3){s=r;return}t[u>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+12>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+12>>2]=0;t[a>>2]=tv(t[(t[f>>2]|0)+36>>2]|0,t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+12>>2]|0,t[(t[u>>2]|0)+16>>2]|0)|0;if(!(t[a>>2]|0)){i=t[f>>2]|0;e=lw(t[(t[n>>2]|0)+28>>2]|0)|0;rv(i,3004,0,e,160064,t[(t[u>>2]|0)+12>>2]|0,t[(t[u>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+8>>2]|0,0);t[(t[n>>2]|0)+28>>2]=0;s=r;return}if(!(t[(t[a>>2]|0)+12>>2]|0)){t[(t[n>>2]|0)+28>>2]=0;s=r;return}t[(t[(t[n>>2]|0)+28>>2]|0)+12>>2]=t[(t[a>>2]|0)+12>>2];if((t[t[(t[a>>2]|0)+12>>2]>>2]|0)!=8){s=r;return}if((t[(t[(t[n>>2]|0)+28>>2]|0)+20>>2]|0)==1){s=r;return}e=t[f>>2]|0;th(e,3091,lw(t[(t[n>>2]|0)+28>>2]|0)|0,0,160416,0,0);s=r;return}while(0);if(t[(t[n>>2]|0)+48>>2]&128){fv(t[f>>2]|0,t[n>>2]|0)|0;s=r;return}if(!(t[(t[n>>2]|0)+48>>2]&64)){s=r;return}if(t[(t[n>>2]|0)+28>>2]|0){s=r;return}if(!(t[(t[n>>2]|0)+56>>2]|0)){s=r;return}a=iv(t[(t[f>>2]|0)+36>>2]|0,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0)|0;t[(t[n>>2]|0)+28>>2]=a;if(t[(t[n>>2]|0)+28>>2]|0){if((t[t[(t[n>>2]|0)+28>>2]>>2]|0)==4){s=r;return}if((t[t[(t[n>>2]|0)+28>>2]>>2]|0)==1?(t[(t[(t[n>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){s=r;return}}t[(t[n>>2]|0)+28>>2]=0;rv(t[f>>2]|0,3004,t[n>>2]|0,t[(t[n>>2]|0)+36>>2]|0,160400,t[(t[n>>2]|0)+56>>2]|0,t[(t[n>>2]|0)+60>>2]|0,4,0);s=r;return}function Tw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(t[(t[f>>2]|0)+60>>2]&256){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[f>>2]|0)+60|0;t[i>>2]=t[i>>2]|256;if(t[(t[f>>2]|0)+48>>2]|0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}e:do if(t[(t[f>>2]|0)+24>>2]|0){t[a>>2]=iv(t[(t[u>>2]|0)+36>>2]|0,t[(t[f>>2]|0)+24>>2]|0,t[(t[f>>2]|0)+28>>2]|0)|0;do if(t[a>>2]|0){if((t[t[a>>2]>>2]|0)!=4){if((t[t[a>>2]>>2]|0)!=1)break;if((t[(t[a>>2]|0)+88>>2]|0)==45)break}t[(t[f>>2]|0)+48>>2]=t[a>>2];break e}while(0);rv(t[u>>2]|0,3004,t[f>>2]|0,t[(t[f>>2]|0)+52>>2]|0,155448,t[(t[f>>2]|0)+24>>2]|0,t[(t[f>>2]|0)+28>>2]|0,4,0);t[n>>2]=t[(t[u>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}else{i=ED(46)|0;t[(t[f>>2]|0)+48>>2]=i}while(0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Lw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[u>>2]|0)==0|(t[f>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}if((t[(t[f>>2]|0)+12>>2]|0)!=0?(t[t[(t[f>>2]|0)+12>>2]>>2]|0)==2e3:0){t[a>>2]=t[(t[f>>2]|0)+12>>2];i=uv(t[(t[u>>2]|0)+36>>2]|0,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0)|0;t[(t[f>>2]|0)+12>>2]=i;if(!(t[(t[f>>2]|0)+12>>2]|0)){rv(t[u>>2]|0,3004,t[f>>2]|0,t[(t[f>>2]|0)+20>>2]|0,160064,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0,15,0);t[n>>2]=t[(t[u>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Dw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(t[(t[f>>2]|0)+4>>2]|0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=av(t[(t[u>>2]|0)+36>>2]|0,t[(t[f>>2]|0)+12>>2]|0,t[(t[f>>2]|0)+16>>2]|0)|0;if(!(t[a>>2]|0)){rv(t[u>>2]|0,3004,0,t[(t[f>>2]|0)+20>>2]|0,160064,t[(t[f>>2]|0)+12>>2]|0,t[(t[f>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+8>>2]|0,0);t[n>>2]=t[(t[u>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}else{t[(t[f>>2]|0)+4>>2]=t[a>>2];t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}return 0}function Cw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0))break;do if((t[(t[u>>2]|0)+12>>2]|0)!=0?(t[t[(t[u>>2]|0)+12>>2]>>2]|0)==2e3:0){t[a>>2]=t[(t[u>>2]|0)+12>>2];t[(t[u>>2]|0)+12>>2]=0;t[o>>2]=tv(t[(t[n>>2]|0)+36>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0)|0;if(!(t[o>>2]|0)){f=t[n>>2]|0;i=lw(t[u>>2]|0)|0;rv(f,3004,0,i,160064,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+8>>2]|0,0);break}i=t[o>>2]|0;if((t[t[o>>2]>>2]|0)!=17){t[(t[u>>2]|0)+12>>2]=i;break}if(t[i+12>>2]|0)if((t[t[(t[o>>2]|0)+12>>2]>>2]|0)==8){i=t[n>>2]|0;th(i,3091,lw(t[u>>2]|0)|0,0,160280,0,0);break}else{t[(t[u>>2]|0)+12>>2]=t[o>>2];break}}while(0);t[u>>2]=t[(t[u>>2]|0)+8>>2]}s=r;return}function Pw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((t[t[f>>2]>>2]|0)!=24){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0){i=ov(t[(t[u>>2]|0)+36>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0;t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]=i;if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]|0)){rv(t[u>>2]|0,3004,t[f>>2]|0,t[(t[f>>2]|0)+12>>2]|0,160144,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0,23,0);t[n>>2]=t[(t[u>>2]|0)+16>>2];c=t[n>>2]|0;s=r;return c|0}if((t[t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]>>2]|0)==24){th(t[u>>2]|0,3080,0,t[f>>2]|0,160152,0,0);t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]=0;t[n>>2]=t[(t[u>>2]|0)+16>>2];c=t[n>>2]|0;s=r;return c|0}if((t[(t[f>>2]|0)+32>>2]|0)!=(t[(t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]|0)+32>>2]|0)){t[a>>2]=0;t[o>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2];i=t[u>>2]|0;e=t[f>>2]|0;th(i,3080,0,e,160184,uh(a,t[(t[o>>2]|0)+20>>2]|0,t[(t[o>>2]|0)+16>>2]|0)|0,0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=t[(t[u>>2]|0)+16>>2];c=t[n>>2]|0;s=r;return c|0}}t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}function Bw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!(uv(t[(t[u>>2]|0)+36>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+12>>2]|0)|0)){rv(t[u>>2]|0,3004,0,t[(t[f>>2]|0)+4>>2]|0,160064,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+12>>2]|0,15,0);t[n>>2]=3004;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}return 0}function Iw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[t[n>>2]>>2]|0)==1){s=r;return}if(!(t[(t[n>>2]|0)+64>>2]|0)){s=r;return}cv(t[f>>2]|0,t[n>>2]|0,t[(t[n>>2]|0)+64>>2]|0)|0;s=r;return}function Hw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[t[n>>2]>>2]|0)!=17){s=r;return}if(!(t[(t[n>>2]|0)+12>>2]|0)){s=r;return}t[u>>2]=lv(t[n>>2]|0,t[(t[(t[n>>2]|0)+12>>2]|0)+12>>2]|0)|0;if(!(t[u>>2]|0)){s=r;return}t[a>>2]=0;i=t[f>>2]|0;f=lw(t[u>>2]|0)|0;sv(i,3075,0,f,159968,uh(a,t[(t[n>>2]|0)+20>>2]|0,t[(t[n>>2]|0)+16>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[(t[u>>2]|0)+12>>2]=0;s=r;return}function xw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!(t[(t[f>>2]|0)+56>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(!(t[(t[f>>2]|0)+36>>2]&16)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=bv(t[f>>2]|0,t[(t[f>>2]|0)+56>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[o>>2]=0;i=t[u>>2]|0;e=lw(t[a>>2]|0)|0;sv(i,3073,0,e,159912,Rd(o,t[f>>2]|0)|0);if(t[o>>2]|0){pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=0}t[(t[a>>2]|0)+4>>2]=0;t[n>>2]=t[(t[u>>2]|0)+16>>2];c=t[n>>2]|0;s=r;return c|0}function Uw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[r+8>>2]=e;t[n>>2]=i;t[f>>2]=t[(t[n>>2]|0)+12>>2];while(1){if(!(t[f>>2]|0))break;if((t[(t[f>>2]|0)+12>>2]|0)!=0?(t[t[(t[f>>2]|0)+12>>2]>>2]|0)==17:0){n=(t[f>>2]|0)+12|0;if(!(t[(t[(t[f>>2]|0)+12>>2]|0)+12>>2]|0)){t[n>>2]=0;t[f>>2]=t[(t[f>>2]|0)+8>>2];continue}else{t[(t[f>>2]|0)+12>>2]=t[(t[n>>2]|0)+12>>2];t[f>>2]=t[(t[f>>2]|0)+8>>2];continue}}t[f>>2]=t[(t[f>>2]|0)+8>>2]}s=r;return}function zw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[u>>2]|0)+56>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]&1|0)==0:0){i=(t[u>>2]|0)+36|0;t[i>>2]=t[i>>2]|1;if((kv(t[f>>2]|0,t[u>>2]|0,(t[u>>2]|0)+40|0,t[(t[u>>2]|0)+56>>2]|0,0)|0)==-1){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function jw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[t[u>>2]>>2]|0)!=4){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[t[u>>2]>>2]|0)!=1?(t[(t[u>>2]|0)+48>>2]&536870912|0)==0:0){i=(t[u>>2]|0)+48|0;t[i>>2]=t[i>>2]|536870912;i=t[u>>2]|0;do if(t[(t[u>>2]|0)+48>>2]&64){if(!(t[i+28>>2]|0)){rh(t[f>>2]|0,153152,153192);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}}else{e=t[u>>2]|0;if(t[i+48>>2]&128){if(t[e+92>>2]|0)break;rh(t[f>>2]|0,153152,153232);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if(!(t[e+64>>2]|0)){rh(t[f>>2]|0,153152,153272);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if(((t[t[(t[u>>2]|0)+64>>2]>>2]|0)!=1?(t[(t[(t[u>>2]|0)+64>>2]|0)+48>>2]&536870912|0)==0:0)?(jw(t[f>>2]|0,t[(t[u>>2]|0)+64>>2]|0)|0)==-1:0){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}e=t[u>>2]|0;if(t[(t[(t[u>>2]|0)+64>>2]|0)+48>>2]&256){o=e+48|0;t[o>>2]=t[o>>2]|256;break}o=t[u>>2]|0;if(t[(t[e+64>>2]|0)+48>>2]&64){e=o+48|0;t[e>>2]=t[e>>2]|64;t[(t[u>>2]|0)+28>>2]=t[(t[(t[u>>2]|0)+64>>2]|0)+28>>2];break}if(t[(t[o+64>>2]|0)+48>>2]&128){o=(t[u>>2]|0)+48|0;t[o>>2]=t[o>>2]|128}}while(0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Vw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(t[(t[u>>2]|0)+48>>2]&128){t[n>>2]=hv(t[f>>2]|0,t[u>>2]|0,t[(t[u>>2]|0)+92>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}return 0}function qw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=t[(t[f>>2]|0)+20>>2];if((t[t[u>>2]>>2]|0)!=4){t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}if((t[t[u>>2]>>2]|0)!=1?(t[(t[u>>2]|0)+48>>2]&4194304|0)==0:0){i=(t[u>>2]|0)+48|0;t[i>>2]=t[i>>2]|4194304;t[(t[u>>2]|0)+52>>2]=4;e:do if(t[(t[u>>2]|0)+64>>2]|0){if((t[t[(t[u>>2]|0)+64>>2]>>2]|0)!=1?(t[(t[(t[u>>2]|0)+64>>2]|0)+48>>2]&4194304|0)==0:0)wv(t[(t[u>>2]|0)+64>>2]|0,t[f>>2]|0)|0;if((t[(t[u>>2]|0)+92>>2]|0)!=0?(dv(t[f>>2]|0,t[u>>2]|0)|0)==-1:0){t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=vv(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)!=-1){do if(!(t[a>>2]|0)){t[a>>2]=mv(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(!(t[a>>2]|0)){t[a>>2]=_v(t[u>>2]|0,t[f>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(!(t[a>>2]|0)){if(!((t[(t[u>>2]|0)+96>>2]|0)==0?(t[(t[(t[u>>2]|0)+64>>2]|0)+96>>2]|0)==0:0)){t[a>>2]=pv(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(t[a>>2]|0)break}t[a>>2]=Ev(t[u>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(!(t[a>>2]|0))Sv(t[u>>2]|0)}}}while(0);if((t[o>>2]|0)!=(t[(t[f>>2]|0)+20>>2]|0)){t[n>>2]=t[(t[f>>2]|0)+16>>2];c=t[n>>2]|0;s=r;return c|0}else{t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}}}else rh(t[f>>2]|0,147168,147208);while(0);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}function Yw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[(t[u>>2]|0)+48>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(t[(t[u>>2]|0)+44>>2]|0){i=(gv(t[(t[u>>2]|0)+48>>2]|0,23)|0)!=0;e=t[f>>2]|0;c=t[u>>2]|0;if(i){th(e,3090,0,c,159552,0,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}t[a>>2]=nh(e,t[c+52>>2]|0,t[(t[u>>2]|0)+48>>2]|0,t[(t[u>>2]|0)+44>>2]|0,(t[u>>2]|0)+68|0,1,1,0)|0;if(t[a>>2]|0){c=t[f>>2]|0;if((t[a>>2]|0)<0){rh(c,159840,141832);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}else{th(c,3079,0,t[u>>2]|0,159680,0,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}}}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Gw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}if(((t[(t[u>>2]|0)+28>>2]|0)!=0?(t[(t[u>>2]|0)+12>>2]|0)!=0:0)?(t[t[(t[u>>2]|0)+12>>2]>>2]|0)==15:0){if(((t[(t[(t[u>>2]|0)+12>>2]|0)+44>>2]|0)!=0?(t[(t[(t[u>>2]|0)+12>>2]|0)+60>>2]&512|0)!=0:0)?(t[(t[u>>2]|0)+16>>2]&1|0)==0:0){sv(t[f>>2]|0,3078,t[u>>2]|0,0,159424,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+32>>2]|0)!=0?(t[(t[(t[u>>2]|0)+12>>2]|0)+48>>2]|0)!=0:0){i=(gv(t[(t[(t[u>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)!=0;e=t[f>>2]|0;c=t[u>>2]|0;if(i){th(e,3089,0,c,159552,0,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}t[a>>2]=nh(e,t[c+20>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+48>>2]|0,t[(t[u>>2]|0)+28>>2]|0,(t[u>>2]|0)+32|0,1,1,0)|0;if(t[a>>2]|0){c=t[f>>2]|0;if((t[a>>2]|0)<0){rh(c,159640,141832);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}else{th(c,3089,0,t[u>>2]|0,159680,0,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}}}if((t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]|0)!=0?(t[(t[(t[u>>2]|0)+12>>2]|0)+60>>2]&1|0)==0:0){if(!(Od(t[(t[u>>2]|0)+32>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+68>>2]|0)|0))sv(t[f>>2]|0,3078,t[u>>2]|0,0,159728,t[(t[(t[u>>2]|0)+12>>2]|0)+44>>2]|0);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Ww(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+48|0;n=r+40|0;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[(t[u>>2]|0)+56>>2]|0)!=0?(t[(t[(t[u>>2]|0)+56>>2]|0)+4>>2]|0)>1:0){t[a>>2]=t[(t[u>>2]|0)+56>>2];t[k>>2]=0;t[l>>2]=(t[(t[a>>2]|0)+4>>2]|0)-1;i:while(1){if((t[l>>2]|0)<0)break e;t[o>>2]=t[(t[t[a>>2]>>2]|0)+(t[l>>2]<<2)>>2];r:do if((t[l>>2]|0)>0){t[b>>2]=(t[l>>2]|0)-1;while(1){if((t[b>>2]|0)<0){d=15;break r}t[c>>2]=t[(t[t[a>>2]>>2]|0)+(t[b>>2]<<2)>>2];if((t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]|0)==(t[(t[(t[c>>2]|0)+12>>2]|0)+8>>2]|0)?(t[(t[(t[o>>2]|0)+12>>2]|0)+56>>2]|0)==(t[(t[(t[c>>2]|0)+12>>2]|0)+56>>2]|0):0)break;t[b>>2]=(t[b>>2]|0)+-1}t[h>>2]=0;i=t[f>>2]|0;e=t[(t[u>>2]|0)+32>>2]|0;v=t[u>>2]|0;th(i,3087,e,v,152424,Nd(h,t[o>>2]|0)|0,0);if(t[h>>2]|0){pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=0}if((yv(t[a>>2]|0,t[l>>2]|0)|0)==-1){d=13;break i}}else d=15;while(0);if(((d|0)==15?(d=0,(t[(t[(t[o>>2]|0)+12>>2]|0)+48>>2]|0)!=0):0)?(gv(t[(t[(t[o>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)!=0:0){if(t[k>>2]|0){t[w>>2]=0;v=t[f>>2]|0;e=t[(t[u>>2]|0)+32>>2]|0;i=t[u>>2]|0;th(v,3087,e,i,152440,Nd(w,t[o>>2]|0)|0,0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}if((yv(t[a>>2]|0,t[l>>2]|0)|0)==-1){d=21;break}}t[k>>2]=1}t[l>>2]=(t[l>>2]|0)+-1}if((d|0)==13){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}else if((d|0)==21){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}}while(0);t[n>>2]=0;m=t[n>>2]|0;s=r;return m|0}function Kw(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+28>>2];if(!(t[u>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}while(1){e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0))t[u>>2]=t[e>>2];else{t[a>>2]=t[e+4>>2];e=t[t[a>>2]>>2]|0;if((e|0)==16){t[f>>2]=Fv(t[n>>2]|0,1,t[a>>2]|0,t[(t[u>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+56>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+40>>2]|0,t[(t[(t[u>>2]|0)+12>>2]|0)+40>>2]|0)|0;if((t[f>>2]|0)==-1){c=8;break}}else if((e|0)==5|(e|0)==4)t[(t[(t[u>>2]|0)+12>>2]|0)+8>>2]=0;t[u>>2]=t[t[u>>2]>>2]}if(!(t[u>>2]|0)){c=11;break}}if((c|0)==8){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}else if((c|0)==11){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}return 0}function Xw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+40|0;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=t[(t[f>>2]|0)+20>>2];t[c>>2]=t[(t[u>>2]|0)+64>>2];if((t[t[u>>2]>>2]|0)!=1?(t[(t[u>>2]|0)+48>>2]&4194304|0)==0:0){i=(t[u>>2]|0)+48|0;t[i>>2]=t[i>>2]|4194304;e:do if(t[c>>2]|0){if((t[t[c>>2]>>2]|0)!=1?(t[(t[c>>2]|0)+48>>2]&4194304|0)==0:0)wv(t[c>>2]|0,t[f>>2]|0)|0;if(t[(t[c>>2]|0)+48>>2]&8388608){t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}t[a>>2]=Ov(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)!=-1){i:do if(!(t[a>>2]|0)){r:do if((t[(t[u>>2]|0)+52>>2]|0)==4){if(!((t[t[c>>2]>>2]|0)!=5?(t[(t[c>>2]|0)+88>>2]|0)!=45:0))v=16;if(((v|0)==16?(t[(t[c>>2]|0)+104>>2]|0)!=0:0)?(t[(t[u>>2]|0)+48>>2]&4|0)!=0:0){if(t[(t[u>>2]|0)+104>>2]|0){t[l>>2]=t[(t[u>>2]|0)+104>>2];t[(t[u>>2]|0)+104>>2]=0}else t[l>>2]=t[(t[c>>2]|0)+104>>2];t[b>>2]=Av(t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0,4,0,t[(t[u>>2]|0)+112>>2]|0,t[(t[u>>2]|0)+36>>2]|0,0)|0;if(!(t[b>>2]|0))break e;t[t[b>>2]>>2]=4;t[(t[b>>2]|0)+64>>2]=t[l>>2];t[(t[b>>2]|0)+68>>2]=t[(t[u>>2]|0)+68>>2];t[(t[u>>2]|0)+68>>2]=0;t[(t[b>>2]|0)+96>>2]=t[(t[u>>2]|0)+96>>2];t[(t[u>>2]|0)+96>>2]=0;t[(t[u>>2]|0)+104>>2]=t[b>>2];do if((t[t[l>>2]>>2]|0)!=1){if(t[(t[l>>2]|0)+48>>2]&4194304)break;wv(t[l>>2]|0,t[f>>2]|0)|0}while(0);t[a>>2]=jw(t[f>>2]|0,t[b>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(t[a>>2]|0)break i;t[a>>2]=qw(t[f>>2]|0,t[b>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(t[a>>2]|0)break i;else break}if(!((t[t[c>>2]>>2]|0)!=5?(t[(t[c>>2]|0)+88>>2]|0)!=45:0))v=31;if(((v|0)==31?(t[(t[c>>2]|0)+52>>2]|0)==3:0)?(t[(t[u>>2]|0)+48>>2]&4|0)!=0:0){if((t[(t[u>>2]|0)+104>>2]|0)!=0?(t[(t[(t[u>>2]|0)+104>>2]|0)+64>>2]|0)!=0:0)break;sv(t[f>>2]|0,3069,t[u>>2]|0,0,149808,t[(t[u>>2]|0)+8>>2]|0);break e}if(!((t[t[c>>2]>>2]|0)!=5?(t[(t[c>>2]|0)+88>>2]|0)!=45:0))v=38;if((v|0)==38?(t[(t[u>>2]|0)+48>>2]&2|0)!=0:0)if(!(t[(t[c>>2]|0)+104>>2]|0)){sv(t[f>>2]|0,3069,t[u>>2]|0,0,149976,t[(t[u>>2]|0)+8>>2]|0);break e}else{t[(t[u>>2]|0)+104>>2]=t[(t[c>>2]|0)+104>>2];break}if((t[t[c>>2]>>2]|0)!=4){if((t[t[c>>2]>>2]|0)==1?(t[(t[c>>2]|0)+88>>2]|0)!=45:0)v=45}else v=45;if((v|0)==45?(t[(t[u>>2]|0)+48>>2]&2|0)!=0:0){t[(t[u>>2]|0)+104>>2]=t[c>>2];break}sv(t[f>>2]|0,3069,t[u>>2]|0,0,150112,t[(t[u>>2]|0)+8>>2]|0);break e}else{t[k>>2]=0;t[h>>2]=t[(t[u>>2]|0)+28>>2];n:do if(!(t[h>>2]|0))v=55;else{do if((t[t[h>>2]>>2]|0)==25){if((t[t[(t[h>>2]|0)+12>>2]>>2]|0)!=8?(t[t[(t[h>>2]|0)+12>>2]>>2]|0)!=6:0){if((t[t[(t[h>>2]|0)+12>>2]>>2]|0)!=7)break;if(t[(t[h>>2]|0)+16>>2]|0)break}if(!(t[(t[(t[h>>2]|0)+12>>2]|0)+12>>2]|0)){v=55;break n}}while(0);t[(t[u>>2]|0)+52>>2]=2}while(0);do if((v|0)==55){if(!(t[(t[u>>2]|0)+48>>2]&1)){t[(t[u>>2]|0)+52>>2]=1;break}if(!((t[h>>2]|0)!=0?(t[t[(t[h>>2]|0)+12>>2]>>2]|0)==6:0)){t[h>>2]=Mv(t[f>>2]|0,t[(t[u>>2]|0)+36>>2]|0,1,1)|0;if(!(t[h>>2]|0))break e;i=Rv(t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0,6,t[(t[u>>2]|0)+36>>2]|0)|0;t[(t[h>>2]|0)+12>>2]=i;if(!(t[(t[h>>2]|0)+12>>2]|0))break e;t[(t[u>>2]|0)+28>>2]=t[h>>2]}t[k>>2]=1;t[(t[u>>2]|0)+52>>2]=2}while(0);i=t[(t[u>>2]|0)+52>>2]|0;if(t[(t[u>>2]|0)+48>>2]&4){if((i|0)==1)break;if(!(t[(t[u>>2]|0)+48>>2]&1))break;t[(t[u>>2]|0)+52>>2]=3;break}e=t[(t[c>>2]|0)+52>>2]|0;if((i|0)==1){t[(t[u>>2]|0)+52>>2]=e;t[(t[u>>2]|0)+28>>2]=t[(t[c>>2]|0)+28>>2];t[(t[u>>2]|0)+104>>2]=t[(t[c>>2]|0)+104>>2];break}i=(t[(t[u>>2]|0)+48>>2]&1|0)!=0;if((e|0)==1){if(!i)break;t[(t[u>>2]|0)+52>>2]=3;break}if(i)t[(t[u>>2]|0)+52>>2]=3;do if((t[(t[u>>2]|0)+28>>2]|0)!=0?(t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2]|0)!=0:0){if((t[t[(t[(t[u>>2]|0)+28>>2]|0)+12>>2]>>2]|0)!=8)break;i=t[f>>2]|0;th(i,3091,lw(t[u>>2]|0)|0,0,150216,0,0);break r}while(0);do if(t[(t[c>>2]|0)+28>>2]|0){if(!(t[(t[(t[c>>2]|0)+28>>2]|0)+12>>2]|0))break;if((t[t[(t[(t[c>>2]|0)+28>>2]|0)+12>>2]>>2]|0)!=8)break;i=t[f>>2]|0;th(i,3091,lw(t[u>>2]|0)|0,0,150480,0,0);break r}while(0);if(t[k>>2]|0){t[(t[(t[h>>2]|0)+12>>2]|0)+12>>2]=t[(t[c>>2]|0)+28>>2];break}t[w>>2]=t[(t[u>>2]|0)+28>>2];t[h>>2]=Mv(t[f>>2]|0,t[(t[u>>2]|0)+36>>2]|0,1,1)|0;if(!(t[h>>2]|0))break e;i=Rv(t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0,6,t[(t[u>>2]|0)+36>>2]|0)|0;t[(t[h>>2]|0)+12>>2]=i;if(!(t[(t[h>>2]|0)+12>>2]|0))break e;t[(t[u>>2]|0)+28>>2]=t[h>>2];i=Mv(t[f>>2]|0,t[(t[u>>2]|0)+36>>2]|0,t[(t[(t[c>>2]|0)+28>>2]|0)+16>>2]|0,t[(t[(t[c>>2]|0)+28>>2]|0)+20>>2]|0)|0;t[(t[(t[h>>2]|0)+12>>2]|0)+12>>2]=i;if(!(t[(t[(t[h>>2]|0)+12>>2]|0)+12>>2]|0))break e;t[h>>2]=t[(t[(t[h>>2]|0)+12>>2]|0)+12>>2];t[(t[h>>2]|0)+12>>2]=t[(t[(t[c>>2]|0)+28>>2]|0)+12>>2];t[(t[h>>2]|0)+8>>2]=t[w>>2]}while(0);t[a>>2]=Nv(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(!(t[a>>2]|0)){t[a>>2]=Tv(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)==-1)break e;if(!(t[a>>2]|0))if((t[o>>2]|0)!=(t[(t[f>>2]|0)+20>>2]|0)){t[n>>2]=t[(t[f>>2]|0)+16>>2];d=t[n>>2]|0;s=r;return d|0}else{t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}}}while(0);i=(t[u>>2]|0)+48|0;t[i>>2]=t[i>>2]|8388608;t[n>>2]=t[(t[f>>2]|0)+16>>2];d=t[n>>2]|0;s=r;return d|0}}else rh(t[f>>2]|0,149776,147208);while(0);f=(t[u>>2]|0)+48|0;t[f>>2]=t[f>>2]|8388608;t[n>>2]=-1;d=t[n>>2]|0;s=r;return d|0}t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}function Zw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if(t[(t[n>>2]|0)+48>>2]&262144){s=r;return}i=(t[n>>2]|0)+48|0;t[i>>2]=t[i>>2]|262144;if(Lv(t[f>>2]|0,t[n>>2]|0)|0){s=r;return}Dv(t[f>>2]|0,t[n>>2]|0);s=r;return}function Jw(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;if((t[t[f>>2]>>2]|0)!=5){s=r;return}if(t[(t[f>>2]|0)+108>>2]|0){s=r;return}if((t[(t[f>>2]|0)+52>>2]|0)!=2?(t[(t[f>>2]|0)+52>>2]|0)!=3:0){s=r;return}t[(t[u>>2]|0)+64>>2]=0;i=rb()|0;t[(t[u>>2]|0)+64>>2]=i;if(!(t[(t[u>>2]|0)+64>>2]|0)){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[(t[f>>2]|0)+8>>2];yAi[i&511](e,157984,n);s=r;return}n=ub(t[(t[u>>2]|0)+64>>2]|0)|0;t[(t[u>>2]|0)+76>>2]=n;Cv(t[u>>2]|0,t[(t[f>>2]|0)+28>>2]|0)|0;ab(t[(t[u>>2]|0)+64>>2]|0,t[(t[u>>2]|0)+76>>2]|0)|0;n=_b(t[(t[u>>2]|0)+64>>2]|0)|0;t[(t[f>>2]|0)+108>>2]=n;if(t[(t[f>>2]|0)+108>>2]|0){if((ib(t[(t[f>>2]|0)+108>>2]|0)|0)!=1)sv(t[u>>2]|0,3070,t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0,158072,0)}else sv(t[u>>2]|0,3069,t[f>>2]|0,t[(t[f>>2]|0)+36>>2]|0,158032,0);t[(t[u>>2]|0)+76>>2]=0;nb(t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0;s=r;return}function Qw(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;i=s;s=s+32|0;r=i+28|0;n=i+24|0;f=i+20|0;u=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[n>>2]=e;t[u>>2]=0;t[o>>2]=0;e=t[n>>2]|0;if(t[(t[n>>2]|0)+84>>2]|0)t[l>>2]=t[e+84>>2];else t[l>>2]=eF(t[e+24>>2]|0)|0;e=t[n>>2]|0;if(!(t[l>>2]|0)){th(e,1,0,0,141128,0,0);t[r>>2]=1;k=t[r>>2]|0;
	s=i;return k|0}t[e+96>>2]=-1;t[(t[n>>2]|0)+84>>2]=t[l>>2];t[c>>2]=t[l>>2];e:while(1){if(!(t[c>>2]|0)){h=48;break}if((t[(t[n>>2]|0)+176>>2]|0)!=-1?(t[(t[n>>2]|0)+96>>2]|0)>=(t[(t[n>>2]|0)+176>>2]|0):0)h=45;else h=10;do if((h|0)==10){h=0;if((t[(t[c>>2]|0)+4>>2]|0)==1){e=(t[n>>2]|0)+96|0;t[e>>2]=(t[e>>2]|0)+1;if(($w(t[n>>2]|0)|0)==-1)break e;t[o>>2]=t[(t[n>>2]|0)+108>>2];t[(t[o>>2]|0)+4>>2]=t[c>>2];t[(t[o>>2]|0)+8>>2]=a[(t[c>>2]|0)+56>>1];t[(t[o>>2]|0)+12>>2]=t[(t[c>>2]|0)+8>>2];if(t[(t[c>>2]|0)+36>>2]|0)t[(t[o>>2]|0)+16>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2];e=(t[o>>2]|0)+32|0;t[e>>2]=t[e>>2]|32;t[(t[n>>2]|0)+168>>2]=0;if(t[(t[c>>2]|0)+44>>2]|0){t[f>>2]=t[(t[c>>2]|0)+44>>2];do{if(t[(t[f>>2]|0)+36>>2]|0)t[b>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+8>>2];else t[b>>2]=0;e=t[n>>2]|0;w=t[f>>2]|0;d=t[(t[o>>2]|0)+8>>2]|0;v=t[(t[f>>2]|0)+8>>2]|0;m=t[b>>2]|0;t[u>>2]=ed(e,w,d,v,m,0,sy(t[(t[f>>2]|0)+32>>2]|0,t[(t[f>>2]|0)+12>>2]|0,1)|0,1)|0;if((t[u>>2]|0)==-1){h=20;break e}t[f>>2]=t[(t[f>>2]|0)+24>>2]}while((t[f>>2]|0)!=0)}t[u>>2]=id(t[n>>2]|0)|0;if(t[u>>2]|0)if((t[u>>2]|0)==-1){h=24;break e}else break;if((t[(t[n>>2]|0)+176>>2]|0)!=-1?(t[(t[n>>2]|0)+96>>2]|0)>=(t[(t[n>>2]|0)+176>>2]|0):0)break}else{if((t[(t[c>>2]|0)+4>>2]|0)!=3?(t[(t[c>>2]|0)+4>>2]|0)!=4:0){if((t[(t[c>>2]|0)+4>>2]|0)==6){h=36;break e}if((t[(t[c>>2]|0)+4>>2]|0)==5){h=36;break e}else break}if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+32>>2]&32|0)!=0:0){m=(t[o>>2]|0)+32|0;t[m>>2]=t[m>>2]^32}t[u>>2]=nd(t[n>>2]|0,t[(t[c>>2]|0)+4>>2]|0,t[(t[c>>2]|0)+40>>2]|0,-1,1,0)|0;if((t[u>>2]|0)<0){h=33;break e}}if(t[(t[c>>2]|0)+12>>2]|0){t[c>>2]=t[(t[c>>2]|0)+12>>2];continue e}}while(0);while(1){if((h|0)==45){h=0;_=t[c>>2]|0;if(t[(t[c>>2]|0)+24>>2]|0)break;t[c>>2]=t[_+20>>2]}if((t[(t[c>>2]|0)+4>>2]|0)!=1){h=45;continue}p=t[n>>2]|0;if((t[c>>2]|0)!=(t[(t[(t[n>>2]|0)+108>>2]|0)+4>>2]|0)){h=41;break e}t[u>>2]=rd(p)|0;if((t[u>>2]|0)!=0&(t[u>>2]|0)<0){h=43;break e}if((t[c>>2]|0)==(t[l>>2]|0)){h=48;break e}else h=45}t[c>>2]=t[_+24>>2]}if((h|0)==20)rh(t[n>>2]|0,155912,144696);else if((h|0)==24)rh(t[n>>2]|0,155912,144744);else if((h|0)==33)rh(t[n>>2]|0,155936,141336);else if((h|0)==36)rh(t[n>>2]|0,155936,155960);else if((h|0)==41)rh(p,155936,156168);else if((h|0)==43)rh(t[n>>2]|0,155936,141688);else if((h|0)==48){t[r>>2]=t[u>>2];k=t[r>>2]|0;s=i;return k|0}t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}function $w(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e=Pv(t[n>>2]|0)|0;t[(t[n>>2]|0)+108>>2]=e;e=t[n>>2]|0;if(!(t[(t[n>>2]|0)+108>>2]|0)){rh(e,155592,155624);t[r>>2]=-1;f=t[r>>2]|0;s=i;return f|0}else{t[e+168>>2]=0;t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}return 0}function ed(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;c=s;s=s+48|0;l=c+36|0;b=c+32|0;k=c+28|0;h=c+24|0;w=c+20|0;d=c+16|0;v=c+12|0;m=c+8|0;_=c+4|0;p=c;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=Bv(t[b>>2]|0)|0;if(!(t[p>>2]|0)){rh(t[b>>2]|0,155408,145304);t[l>>2]=-1;E=t[l>>2]|0;s=c;return E|0}t[(t[p>>2]|0)+4>>2]=t[k>>2];t[(t[p>>2]|0)+8>>2]=t[h>>2];t[(t[p>>2]|0)+44>>2]=1;t[(t[p>>2]|0)+12>>2]=t[w>>2];t[(t[p>>2]|0)+16>>2]=t[d>>2];if(t[v>>2]|0){v=(t[p>>2]|0)+32|0;t[v>>2]=t[v>>2]|1}do if(t[d>>2]|0){if(Xl(t[w>>2]|0,155432)|0){if(!(Xl(t[(t[p>>2]|0)+16>>2]|0,t[38860]|0)|0))break;t[(t[p>>2]|0)+48>>2]=2;break}if(Xl(t[w>>2]|0,155448)|0){if(!(Xl(t[(t[p>>2]|0)+16>>2]|0,t[38860]|0)|0))break;t[(t[p>>2]|0)+48>>2]=1;break}if(Xl(t[w>>2]|0,155456)|0){if(!(Xl(t[(t[p>>2]|0)+16>>2]|0,t[38860]|0)|0))break;t[(t[p>>2]|0)+48>>2]=3;break}v=(Xl(t[w>>2]|0,155472)|0)!=0;h=t[(t[p>>2]|0)+16>>2]|0;if(v){if(!(Xl(h,t[38860]|0)|0))break;t[(t[p>>2]|0)+48>>2]=4;break}else{if(!(Xl(h,t[38876]|0)|0))break;t[(t[p>>2]|0)+48>>2]=5;break}}while(0);t[(t[p>>2]|0)+20>>2]=t[m>>2];if(t[_>>2]|0){_=(t[p>>2]|0)+32|0;t[_>>2]=t[_>>2]|2}if(t[(t[p>>2]|0)+48>>2]|0)t[(t[p>>2]|0)+44>>2]=17;t[l>>2]=0;E=t[l>>2]|0;s=c;return E|0}function id(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;if((t[(t[n>>2]|0)+176>>2]|0)!=-1?(t[(t[n>>2]|0)+96>>2]|0)>=(t[(t[n>>2]|0)+176>>2]|0):0)rh(t[n>>2]|0,144776,144800);else a=4;e:do if((a|0)==4){do if(t[(t[n>>2]|0)+92>>2]|0){t[f>>2]=Iv(t[n>>2]|0)|0;if(!(t[f>>2]|0)){aO(t[(t[(t[n>>2]|0)+20>>2]|0)+48>>2]|0,357,t[n>>2]|0);break}if((t[f>>2]|0)==-1)break e;t[(t[n>>2]|0)+176>>2]=0;t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}while(0);e=t[n>>2]|0;do if((t[(t[n>>2]|0)+96>>2]|0)>0){t[f>>2]=Hv(e)|0;if(t[f>>2]|0){if((t[f>>2]|0)>=0)break;rh(t[n>>2]|0,144776,144816);break e}if((t[(t[n>>2]|0)+96>>2]|0)!=(t[(t[n>>2]|0)+176>>2]|0))if((t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]|0)==0?(t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]|0)==0:0){rh(t[n>>2]|0,144776,144864);break e}else a=19}else{c=nv(t[e+20>>2]|0,t[(t[(t[n>>2]|0)+108>>2]|0)+12>>2]|0,t[(t[(t[n>>2]|0)+108>>2]|0)+16>>2]|0)|0;t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]=c;if(!(t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]|0)){t[f>>2]=1845;th(t[n>>2]|0,t[f>>2]|0,0,0,144944,0,0)}else a=19}while(0);i:do if((a|0)==19){do if(t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]|0){if((t[t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]>>2]|0)==2){t[f>>2]=xv(t[n>>2]|0,u)|0;if(t[f>>2]|0){if((t[f>>2]|0)>=0)break i;rh(t[n>>2]|0,144776,145016);break e}e=t[n>>2]|0;if(t[u>>2]|0){t[(t[n>>2]|0)+176>>2]=t[e+96>>2];break i}if((t[t[(t[e+108>>2]|0)+44>>2]>>2]|0)!=14){t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]=0;break}}t[f>>2]=Uv(t[n>>2]|0)|0;if(t[f>>2]|0){if((t[f>>2]|0)>=0)break i;rh(t[n>>2]|0,144776,145056);break e}}while(0);e=t[(t[n>>2]|0)+108>>2]|0;if(!(t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]|0)){c=e+32|0;t[c>>2]=t[c>>2]|1024;t[f>>2]=1875;th(t[n>>2]|0,t[f>>2]|0,0,0,145096,0,0);break}c=t[n>>2]|0;if(t[(t[e+28>>2]|0)+48>>2]&1048576){e=(t[c+108>>2]|0)+32|0;t[e>>2]=t[e>>2]|1024;t[f>>2]=1876;th(t[n>>2]|0,t[f>>2]|0,0,0,145128,0,0);break}if((t[c+116>>2]|0)!=0?(t[f>>2]=zv(t[n>>2]|0,1)|0,t[(t[(t[n>>2]|0)+108>>2]|0)+80>>2]=1,(t[f>>2]|0)==-1):0){rh(t[n>>2]|0,144776,145160);break e}if((t[t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]>>2]|0)!=5?(t[(t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){if(t[(t[n>>2]|0)+168>>2]|0)t[f>>2]=Vv(t[n>>2]|0)|0}else a=40;do if((a|0)==40){if((t[(t[n>>2]|0)+168>>2]|0)==0?(t[(t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]|0)+116>>2]|0)==0:0)break;t[f>>2]=jv(t[n>>2]|0)|0}while(0);if(t[(t[n>>2]|0)+168>>2]|0)eh(t[n>>2]|0);if((t[f>>2]|0)==-1){rh(t[n>>2]|0,144776,145200);break e}else{t[f>>2]=0;break}}while(0);if(t[f>>2]|0)t[(t[n>>2]|0)+176>>2]=t[(t[n>>2]|0)+96>>2];t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}while(0);t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}function rd(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+80|0;r=i+76|0;n=i+72|0;f=i+68|0;u=i+64|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+4|0;h=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=t[(t[n>>2]|0)+108>>2];if(t[(t[n>>2]|0)+168>>2]|0)eh(t[n>>2]|0);e:do if(!(t[(t[u>>2]|0)+32>>2]&512))if((t[(t[u>>2]|0)+28>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]&1024|0)==0:0){if((t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=3?(t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=2:0)w=21;else w=9;i:do if((w|0)==9?(t[(t[(t[u>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0)if(!(t[(t[u>>2]|0)+32>>2]&256)){t[c>>2]=10;if((t[(t[u>>2]|0)+60>>2]|0)==0?(e=Ws(t[(t[(t[u>>2]|0)+28>>2]|0)+108>>2]|0,358,t[n>>2]|0)|0,t[(t[u>>2]|0)+60>>2]=e,(t[(t[u>>2]|0)+60>>2]|0)==0):0){rh(t[n>>2]|0,141728,141760);break e}if(t[(t[u>>2]|0)+32>>2]&4){t[f>>2]=0;w=21;break}Js(t[(t[u>>2]|0)+60>>2]|0,c,l,a,o)|0;t[f>>2]=Xs(t[(t[u>>2]|0)+60>>2]|0,0,0)|0;do if((t[f>>2]|0)>=0){if((t[f>>2]|0)==0?(t[(t[u>>2]|0)+32>>2]&4|0)==0:0)break;t[f>>2]=0;w=21;break i}while(0);t[f>>2]=1;e=(t[u>>2]|0)+32|0;t[e>>2]=t[e>>2]|256;Yv(t[n>>2]|0,1871,0,0,141800,t[c>>2]|0,t[l>>2]|0,a);w=21}else w=21;while(0);if((w|0)==21?(t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)==2:0){w=81;break}if(t[(t[n>>2]|0)+72>>2]|0){MD(t[(t[n>>2]|0)+72>>2]|0);t[(t[n>>2]|0)+72>>2]=0}e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+44>>2]|0)){do if((t[t[e+28>>2]>>2]|0)==4)w=28;else{if((t[t[(t[u>>2]|0)+28>>2]>>2]|0)==1?(t[(t[(t[u>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){w=28;break}if((t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;t[f>>2]=Gv(t[n>>2]|0,t[u>>2]|0,t[(t[(t[u>>2]|0)+28>>2]|0)+104>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0}while(0);if((w|0)==28)t[f>>2]=Gv(t[n>>2]|0,t[u>>2]|0,t[(t[u>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0;if((t[f>>2]|0)>=0){w=81;break}rh(t[n>>2]|0,141728,141832);break}if(((t[(t[e+44>>2]|0)+76>>2]|0)!=0?(t[(t[u>>2]|0)+32>>2]&32|0)!=0:0)?(t[(t[u>>2]|0)+32>>2]&4|0)==0:0){if(t[(t[u>>2]|0)+32>>2]&8){t[f>>2]=Wv(t[n>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0,(t[u>>2]|0)+24|0)|0;if(t[f>>2]|0){if((t[f>>2]|0)>=0){w=81;break}rh(t[n>>2]|0,141728,141872);break}}else{do if((t[t[(t[u>>2]|0)+28>>2]>>2]|0)==4)w=44;else{if((t[t[(t[u>>2]|0)+28>>2]>>2]|0)==1?(t[(t[(t[u>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){w=44;break}if((t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;t[f>>2]=Gv(t[n>>2]|0,t[u>>2]|0,t[(t[(t[u>>2]|0)+28>>2]|0)+104>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)|0}while(0);if((w|0)==44)t[f>>2]=Gv(t[n>>2]|0,t[u>>2]|0,t[(t[u>>2]|0)+28>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)|0;if(t[f>>2]|0){if((t[f>>2]|0)>=0){w=81;break}rh(t[n>>2]|0,141728,141832);break}}if(!(t[(t[n>>2]|0)+80>>2]&1)){w=81;break}if(!(t[(t[u>>2]|0)+4>>2]|0)){w=81;break}t[k>>2]=fw(t[(t[u>>2]|0)+28>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)|0;if(t[k>>2]|0){t[b>>2]=yy(t[k>>2]|0)|0;pAi[t[135736>>2]&511](t[k>>2]|0)}else t[b>>2]=yy(t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)|0;if(!(t[b>>2]|0)){rh(t[n>>2]|0,141728,141912);break}else{Hy(t[(t[u>>2]|0)+4>>2]|0,t[b>>2]|0)|0;w=81;break}}if(!(t[(t[u>>2]|0)+32>>2]&4)){do if((t[t[(t[u>>2]|0)+28>>2]>>2]|0)==4)w=63;else{if((t[t[(t[u>>2]|0)+28>>2]>>2]|0)==1?(t[(t[(t[u>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){w=63;break}if((t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;t[f>>2]=Gv(t[n>>2]|0,t[u>>2]|0,t[(t[(t[u>>2]|0)+28>>2]|0)+104>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0}while(0);if((w|0)==63)t[f>>2]=Gv(t[n>>2]|0,t[u>>2]|0,t[(t[u>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+20>>2]|0)|0;if(t[f>>2]|0){if((t[f>>2]|0)>=0){w=81;break}rh(t[n>>2]|0,141728,141832);break}if((t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)!=0?(t[(t[(t[u>>2]|0)+44>>2]|0)+48>>2]&8|0)!=0:0){if(t[(t[u>>2]|0)+32>>2]&128){t[f>>2]=1856;th(t[n>>2]|0,t[f>>2]|0,0,0,141936,0,0);w=81;break}e=t[u>>2]|0;if((t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)==3){if(Xl(t[e+20>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)|0){w=81;break}t[f>>2]=1857;th(t[n>>2]|0,t[f>>2]|0,0,0,142024,t[(t[u>>2]|0)+20>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0);w=81;break}if((t[(t[e+28>>2]|0)+52>>2]|0)!=4?(t[(t[(t[u>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0){w=81;break}if(!(Xl(t[(t[u>>2]|0)+20>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0)|0)){t[f>>2]=1858;th(t[n>>2]|0,t[f>>2]|0,0,0,142096,t[(t[u>>2]|0)+20>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+76>>2]|0);w=81}else w=81}else w=81}else w=81}else w=81;else{t[(t[n>>2]|0)+176>>2]=(t[(t[n>>2]|0)+96>>2]|0)-1;w=81}while(0);e:do if((w|0)==81){if((t[(t[n>>2]|0)+96>>2]|0)<0){t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}if((t[(t[n>>2]|0)+96>>2]|0)==(t[(t[n>>2]|0)+176>>2]|0))t[(t[n>>2]|0)+176>>2]=-1;if((t[(t[u>>2]|0)+80>>2]|0)!=0?(Kv(t[n>>2]|0,t[(t[n>>2]|0)+96>>2]|0)|0)==-1:0)break;do if(t[(t[u>>2]|0)+56>>2]|0){if((t[(t[n>>2]|0)+184>>2]|0)==0?(t[(t[n>>2]|0)+188>>2]|0)==0:0)break;if((Xv(t[n>>2]|0,t[u>>2]|0)|0)==-1)break e}while(0);if((t[(t[(t[n>>2]|0)+108>>2]|0)+76>>2]|0)!=0?(fT(t[n>>2]|0)|0)==-1:0)break;do if((t[(t[u>>2]|0)+52>>2]|0)!=0?(t[(t[n>>2]|0)+96>>2]|0)>0:0){if((t[(t[n>>2]|0)+184>>2]|0)==0?(t[(t[n>>2]|0)+188>>2]|0)==0:0)break;if((tT(t[n>>2]|0)|0)==-1)break e}while(0);ih(t[n>>2]|0,t[u>>2]|0);b=t[n>>2]|0;if(!(t[(t[n>>2]|0)+96>>2]|0)){k=b+96|0;t[k>>2]=(t[k>>2]|0)+-1;t[(t[n>>2]|0)+108>>2]=0;t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}if(t[b+112>>2]|0){t[h>>2]=t[(t[n>>2]|0)+112>>2];do{if((t[(t[h>>2]|0)+8>>2]|0)==(t[(t[n>>2]|0)+96>>2]|0))t[(t[h>>2]|0)+8>>2]=-1;t[h>>2]=t[t[h>>2]>>2]}while((t[h>>2]|0)!=0)}b=(t[n>>2]|0)+96|0;t[b>>2]=(t[b>>2]|0)+-1;t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2];t[r>>2]=t[f>>2];d=t[r>>2]|0;s=i;return d|0}while(0);t[(t[n>>2]|0)+52>>2]=-1;t[r>>2]=-1;d=t[r>>2]|0;s=i;return d|0}function nd(e,i,r,n,f,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+32|0;c=o+24|0;l=o+20|0;b=o+16|0;k=o+12|0;h=o+8|0;w=o+4|0;d=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=a;if(t[d>>2]|0)t[t[d>>2]>>2]=0;a=t[l>>2]|0;if(t[(t[(t[l>>2]|0)+108>>2]|0)+32>>2]&4){th(a,1848,0,0,141368,0,0);t[c>>2]=t[(t[l>>2]|0)+52>>2];v=t[c>>2]|0;s=o;return v|0}f=t[l>>2]|0;if((t[(t[(t[a+108>>2]|0)+28>>2]|0)+52>>2]|0)==1){th(f,1841,0,0,141456,0,0);t[c>>2]=t[(t[l>>2]|0)+52>>2];v=t[c>>2]|0;s=o;return v|0}if((t[(t[(t[f+108>>2]|0)+28>>2]|0)+52>>2]|0)==2){if((t[b>>2]|0)==3?(Dd(t[k>>2]|0,t[h>>2]|0)|0)!=0:0){t[c>>2]=0;v=t[c>>2]|0;s=o;return v|0}th(t[l>>2]|0,1843,0,0,141528,0,0);t[c>>2]=t[(t[l>>2]|0)+52>>2];v=t[c>>2]|0;s=o;return v|0}if((t[k>>2]|0)!=0?(u[t[k>>2]>>0]|0|0)!=0:0){do if((t[(t[(t[(t[l>>2]|0)+108>>2]|0)+28>>2]|0)+52>>2]|0)==3){if((t[(t[(t[l>>2]|0)+108>>2]|0)+44>>2]|0)!=0?(t[(t[(t[(t[l>>2]|0)+108>>2]|0)+44>>2]|0)+76>>2]|0)!=0:0)break;t[c>>2]=0;v=t[c>>2]|0;s=o;return v|0}while(0);do if(!(t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]|0)){b=t[w>>2]|0;if((b|0)==1){t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]=t[k>>2];break}else if((b|0)==2){t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]=t[k>>2];if(t[d>>2]|0)t[t[d>>2]>>2]=1;f=(t[(t[l>>2]|0)+108>>2]|0)+32|0;t[f>>2]=t[f>>2]|2;break}else if((b|0)==3){b=t[k>>2]|0;if((t[h>>2]|0)!=-1){f=ql(b,t[h>>2]|0)|0;t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]=f}else{f=Yl(b)|0;t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]=f}f=(t[(t[l>>2]|0)+108>>2]|0)+32|0;t[f>>2]=t[f>>2]|2;break}else break}else{if((t[h>>2]|0)<0)t[h>>2]=rs(t[k>>2]|0)|0;f=t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]|0;b=t[k>>2]|0;a=t[h>>2]|0;if(t[(t[(t[l>>2]|0)+108>>2]|0)+32>>2]&2){n=fs(f,b,a)|0;t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]=n;break}else{n=ts(f,b,a)|0;t[(t[(t[l>>2]|0)+108>>2]|0)+20>>2]=n;n=(t[(t[l>>2]|0)+108>>2]|0)+32|0;t[n>>2]=t[n>>2]|2;break}}while(0);t[c>>2]=0;v=t[c>>2]|0;s=o;return v|0}t[c>>2]=0;v=t[c>>2]|0;s=o;return v|0}function fd(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(!(t[(t[n>>2]|0)+88>>2]|0)){if(t[(t[n>>2]|0)+20>>2]|0){e=uT(140432,t[(t[(t[n>>2]|0)+20>>2]|0)+60>>2]|0)|0;t[(t[n>>2]|0)+88>>2]=e}else{e=Mk(140432)|0;t[(t[n>>2]|0)+88>>2]=e}e=t[n>>2]|0;if(t[(t[n>>2]|0)+88>>2]|0){Dk(t[e+88>>2]|0,t[(t[n>>2]|0)+8>>2]|0,t[(t[n>>2]|0)+12>>2]|0,t[(t[n>>2]|0)+4>>2]|0);Pk(t[(t[n>>2]|0)+88>>2]|0,t[(t[n>>2]|0)+16>>2]|0,t[(t[n>>2]|0)+4>>2]|0);break}rh(e,141232,141264);t[r>>2]=-1;f=t[r>>2]|0;s=i;return f|0}while(0);t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function td(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[(t[(t[n>>2]|0)+52>>2]|0)+76>>2]|0)){s=r;return}aO(t[(t[(t[n>>2]|0)+52>>2]|0)+76>>2]|0,359,t[f>>2]|0);s=r;return}function ud(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;u=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[(t[r>>2]|0)+152>>2]=0;t[(t[r>>2]|0)+84>>2]=0;t[(t[r>>2]|0)+24>>2]=0;t[(t[r>>2]|0)+160>>2]=0;t[(t[r>>2]|0)+184>>2]=0;if(t[(t[r>>2]|0)+72>>2]|0){MD(t[(t[r>>2]|0)+72>>2]|0);t[(t[r>>2]|0)+72>>2]=0}if(t[(t[r>>2]|0)+112>>2]|0){t[n>>2]=t[(t[r>>2]|0)+112>>2];do{t[f>>2]=t[t[n>>2]>>2];pAi[t[135736>>2]&511](t[n>>2]|0);t[n>>2]=t[f>>2]}while((t[n>>2]|0)!=0);t[(t[r>>2]|0)+112>>2]=0}if(t[(t[r>>2]|0)+124>>2]|0){t[u>>2]=t[(t[r>>2]|0)+124>>2];while(1){if(!(t[u>>2]|0))break;t[a>>2]=t[u>>2];t[u>>2]=t[(t[u>>2]|0)+12>>2];oT(t[a>>2]|0)}t[(t[r>>2]|0)+124>>2]=0}if(t[(t[r>>2]|0)+128>>2]|0){t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[r>>2]|0)+132>>2]|0))break;t[c>>2]=t[(t[(t[r>>2]|0)+128>>2]|0)+(t[o>>2]<<2)>>2];pAi[t[135736>>2]&511](t[(t[c>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[c>>2]|0);t[o>>2]=(t[o>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+128>>2]|0);t[(t[r>>2]|0)+128>>2]=0;t[(t[r>>2]|0)+132>>2]=0;t[(t[r>>2]|0)+136>>2]=0}if(t[(t[r>>2]|0)+116>>2]|0){$k(t[(t[r>>2]|0)+116>>2]|0);t[(t[r>>2]|0)+116>>2]=0}if(t[(t[r>>2]|0)+168>>2]|0)eh(t[r>>2]|0);e:do if(t[(t[r>>2]|0)+100>>2]|0){t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[(t[r>>2]|0)+104>>2]|0))break e;t[b>>2]=t[(t[(t[r>>2]|0)+100>>2]|0)+(t[l>>2]<<2)>>2];if(!(t[b>>2]|0))break e;ih(t[r>>2]|0,t[b>>2]|0);t[l>>2]=(t[l>>2]|0)+1}}while(0);cT(t[(t[r>>2]|0)+180>>2]|0);bz(t[(t[r>>2]|0)+156>>2]|0);l=lz()|0;t[(t[r>>2]|0)+156>>2]=l;if(!(t[(t[r>>2]|0)+48>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);t[(t[r>>2]|0)+48>>2]=0;s=i;return}function ad(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0)Yk(t[(t[r>>2]|0)+32>>2]|0);if(t[(t[r>>2]|0)+68>>2]|0)MD(t[(t[r>>2]|0)+68>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function od(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)Yk(t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)MD(t[(t[r>>2]|0)+32>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function cd(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function ld(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+24>>2]|0)Yk(t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+84>>2]|0)fb(t[(t[r>>2]|0)+84>>2]|0);if(t[(t[r>>2]|0)+96>>2]|0)MD(t[(t[r>>2]|0)+96>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function sd(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+4>>2]|0)Yk(t[(t[r>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function bd(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+24>>2]|0)Yk(t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+56>>2]|0)Wk(t[(t[r>>2]|0)+56>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function kd(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+4>>2]|0)Yk(t[(t[r>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function hd(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)Yk(t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0){if(t[(t[(t[r>>2]|0)+24>>2]|0)+16>>2]|0)vj(t[(t[(t[r>>2]|0)+24>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0)}if(t[(t[r>>2]|0)+28>>2]|0){t[n>>2]=t[(t[r>>2]|0)+28>>2];do{t[f>>2]=t[n>>2];t[n>>2]=t[t[n>>2]>>2];if(t[(t[f>>2]|0)+16>>2]|0)vj(t[(t[f>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0)}while((t[n>>2]|0)!=0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function wd(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function dd(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function vd(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e=t[n>>2]|0;do if((t[t[n>>2]>>2]|0)==1){if((t[e>>2]|0)!=5?(t[(t[n>>2]|0)+88>>2]|0)!=45:0){t[r>>2]=143688;break}t[r>>2]=143664}else t[r>>2]=lT(t[e>>2]|0)|0;while(0);s=i;return t[r>>2]|0}function md(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;dp(16,3069,t[f>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function _d(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+20>>2]|0)Wk(t[(t[r>>2]|0)+20>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function pd(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;kw(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,0,0);s=a;return}function Ed(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e=t[n>>2]|0;do if((t[t[n>>2]>>2]|0)!=1){if(t[e+48>>2]&64){t[r>>2]=3;break}if(t[(t[n>>2]|0)+48>>2]&128){t[r>>2]=0;break}if(!(t[(t[n>>2]|0)+48>>2]&256)){t[r>>2]=-1;break}if(t[(t[n>>2]|0)+48>>2]&16777216){t[r>>2]=1;break}if(t[(t[n>>2]|0)+48>>2]&33554432){t[r>>2]=2;break}else{t[r>>2]=3;break}}else{if((t[e+88>>2]|0)!=1?(t[(t[n>>2]|0)+88>>2]|0)!=46:0)if((t[(t[n>>2]|0)+88>>2]|0)==2){t[r>>2]=2;break}else{t[r>>2]=3;break}t[r>>2]=1}while(0);s=i;return t[r>>2]|0}function Sd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;if(t[(t[f>>2]|0)+36>>2]|0){t[a>>2]=t[i+96>>2];e:while(1){if((t[a>>2]|0)<0){h=14;break}i:do if(t[(t[(t[(t[f>>2]|0)+100>>2]|0)+(t[a>>2]<<2)>>2]|0)+68>>2]|0){t[c>>2]=t[(t[(t[f>>2]|0)+100>>2]|0)+(t[a>>2]<<2)>>2];t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[c>>2]|0)+68>>2]<<1|0))break i;if((t[u>>2]|0)==0?(t[(t[(t[c>>2]|0)+64>>2]|0)+(t[o>>2]<<2)>>2]|0)==0:0){h=11;break e}if((t[u>>2]|0)!=0?(Xl(t[u>>2]|0,t[(t[(t[c>>2]|0)+64>>2]|0)+(t[o>>2]<<2)>>2]|0)|0)!=0:0){h=11;break e}t[o>>2]=(t[o>>2]|0)+2}}while(0);t[a>>2]=(t[a>>2]|0)+-1}if((h|0)==11){t[n>>2]=t[(t[(t[c>>2]|0)+64>>2]|0)+((t[o>>2]|0)+1<<2)>>2];w=t[n>>2]|0;s=r;return w|0}else if((h|0)==14){t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}}else{h=t[f>>2]|0;if(t[i+160>>2]|0){t[l>>2]=PI(t[h+160>>2]|0,t[u>>2]|0)|0;if(t[l>>2]|0){t[b>>2]=kz(t[(t[f>>2]|0)+156>>2]|0,t[l>>2]|0,-1)|0;pAi[t[135736>>2]&511](t[l>>2]|0);t[n>>2]=t[b>>2];w=t[n>>2]|0;s=r;return w|0}else{t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}}if((t[(t[h+108>>2]|0)+4>>2]|0)!=0?(t[(t[(t[(t[f>>2]|0)+108>>2]|0)+4>>2]|0)+32>>2]|0)!=0:0){t[k>>2]=wF(t[(t[(t[(t[f>>2]|0)+108>>2]|0)+4>>2]|0)+32>>2]|0,t[(t[(t[f>>2]|0)+108>>2]|0)+4>>2]|0,t[u>>2]|0)|0;if(t[k>>2]|0){t[n>>2]=t[(t[k>>2]|0)+8>>2];w=t[n>>2]|0;s=r;return w|0}else{t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}}rh(t[f>>2]|0,154192,154224);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}return 0}function gd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(t[u>>2]|0){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+44>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+44>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function yd(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;while(1){if(!(t[n>>2]|0)){f=7;break}if((t[(t[n>>2]|0)+88>>2]|0)==46){f=5;break}if(t[(t[n>>2]|0)+48>>2]&16384){f=5;break}t[n>>2]=t[(t[n>>2]|0)+64>>2]}if((f|0)==5){t[r>>2]=t[n>>2];u=t[r>>2]|0;s=i;return u|0}else if((f|0)==7){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}return 0}function Fd(e,i,r,n,f,u,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;b=s;s=s+112|0;k=b;h=b+56|0;w=b+52|0;d=b+48|0;v=b+44|0;m=b+40|0;_=b+36|0;p=b+32|0;E=b+28|0;S=b+24|0;g=b+20|0;y=b+16|0;F=b+12|0;O=b+8|0;A=b+4|0;M=b+85|0;R=b+60|0;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=n;t[m>>2]=f;t[_>>2]=u;t[p>>2]=a;t[E>>2]=o;t[S>>2]=c;t[g>>2]=l;t[y>>2]=0;t[F>>2]=0;t[A>>2]=Ad(t[h>>2]|0,t[d>>2]|0)|0;bw(F,t[h>>2]|0,t[d>>2]|0)|0;if((t[w>>2]|0)==1840)t[O>>2]=1007;else t[O>>2]=t[t[p>>2]>>2];t[F>>2]=us(t[F>>2]|0,142560)|0;t[F>>2]=us(t[F>>2]|0,148120)|0;l=t[F>>2]|0;t[F>>2]=us(l,fh(t[O>>2]|0)|0)|0;t[F>>2]=us(t[F>>2]|0,156768)|0;do if(!(t[E>>2]|0)){if((t[O>>2]|0)==1009|(t[O>>2]|0)==1011|(t[O>>2]|0)==1010){l=t[F>>2]|0;if((t[A>>2]|0)==2)t[F>>2]=us(l,156776)|0;else t[F>>2]=us(l,156816)|0;t[k>>2]=HD(t[p>>2]|0)|0;SY(M,24,156856,k)|0;t[k>>2]=t[m>>2];SY(R,24,156856,k)|0;do if((t[O>>2]|0)!=1009){if((t[O>>2]|0)==1010){t[F>>2]=us(t[F>>2]|0,156912)|0;break}if((t[O>>2]|0)==1011)t[F>>2]=us(t[F>>2]|0,156968)|0}else t[F>>2]=us(t[F>>2]|0,156864)|0;while(0);l=t[h>>2]|0;c=t[w>>2]|0;o=t[d>>2]|0;a=t[F>>2]|0;if((t[A>>2]|0)==2){sT(l,c,o,a,t[v>>2]|0,R,M);break}else{pd(l,c,o,a,R,M);break}}if((t[O>>2]|0)==1007){t[F>>2]=us(t[F>>2]|0,157024)|0;a=t[h>>2]|0;o=t[w>>2]|0;c=t[d>>2]|0;l=t[F>>2]|0;u=t[v>>2]|0;pd(a,o,c,l,u,bT(t[h>>2]|0,y,t[_>>2]|0)|0);break}if((t[O>>2]|0)==1006){t[F>>2]=us(t[F>>2]|0,157080)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}if((t[O>>2]|0)==1e3){t[F>>2]=us(t[F>>2]|0,157136)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}if((t[O>>2]|0)==1002){t[F>>2]=us(t[F>>2]|0,157200)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}if((t[O>>2]|0)==1001){t[F>>2]=us(t[F>>2]|0,157272)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}if((t[O>>2]|0)==1003){t[F>>2]=us(t[F>>2]|0,157320)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}if((t[O>>2]|0)==1004){t[F>>2]=us(t[F>>2]|0,157360)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}if((t[O>>2]|0)==1005){t[F>>2]=us(t[F>>2]|0,157424)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,t[(t[p>>2]|0)+8>>2]|0);break}u=t[F>>2]|0;if((t[A>>2]|0)==2){t[F>>2]=us(u,157496)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[v>>2]|0,0);break}else{t[F>>2]=us(u,157536)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,0,0);break}}else{t[F>>2]=us(t[F>>2]|0,t[E>>2]|0)|0;t[F>>2]=us(t[F>>2]|0,142704)|0;pd(t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[F>>2]|0,t[S>>2]|0,t[g>>2]|0)}while(0);if(!(t[y>>2]|0)){N=t[33934]|0;T=t[F>>2]|0;pAi[N&511](T);s=b;return}pAi[t[135736>>2]&511](t[y>>2]|0);t[y>>2]=0;N=t[33934]|0;T=t[F>>2]|0;pAi[N&511](T);s=b;return}function Od(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;e:while(1){if(!(t[f>>2]|0)){k=20;break}t[a>>2]=ED(qD(t[f>>2]|0)|0)|0;t[o>>2]=ED(qD(t[u>>2]|0)|0)|0;t[c>>2]=yd(t[a>>2]|0)|0;t[l>>2]=yd(t[o>>2]|0)|0;if((t[c>>2]|0)!=(t[l>>2]|0)){k=4;break}do if((t[(t[c>>2]|0)+88>>2]|0)!=1){if((t[t[c>>2]>>2]|0)==1?(t[(t[c>>2]|0)+88>>2]|0)==46:0){k=8;break}t[b>>2]=ID(t[f>>2]|0,1,t[u>>2]|0,1)|0;if((t[b>>2]|0)==-2){k=11;break e}if(t[b>>2]|0){k=13;break e}}else k=8;while(0);if((k|0)==8?(k=0,i=yD(t[f>>2]|0)|0,(Xl(i,yD(t[u>>2]|0)|0)|0)==0):0){k=9;break}t[f>>2]=gD(t[f>>2]|0)|0;i=(t[f>>2]|0)!=0;h=gD(t[u>>2]|0)|0;if(!i){k=17;break}t[u>>2]=h;if(!(t[u>>2]|0)){k=16;break}}do if((k|0)==4)t[n>>2]=0;else if((k|0)==9)t[n>>2]=0;else if((k|0)==11)t[n>>2]=-1;else if((k|0)==13)t[n>>2]=0;else if((k|0)==16)t[n>>2]=0;else if((k|0)==17)if(h){t[n>>2]=0;break}else{t[n>>2]=1;break}else if((k|0)==20)t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function Ad(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(t[u>>2]|0){t[n>>2]=t[(t[u>>2]|0)+4>>2];a=t[n>>2]|0;s=r;return a|0}if((t[t[f>>2]>>2]|0)==2?(t[(t[f>>2]|0)+108>>2]|0)!=0:0){t[n>>2]=t[t[(t[f>>2]|0)+108>>2]>>2];a=t[n>>2]|0;s=r;return a|0}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}function Md(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;switch(t[t[n>>2]>>2]|0){case 15:{if(t[(t[n>>2]|0)+60>>2]&1)t[r>>2]=1;else f=10;break}case 17:{t[r>>2]=1;break}case 4:case 5:{if(t[(t[n>>2]|0)+48>>2]&8)t[r>>2]=1;else f=10;break}case 14:{if(t[(t[n>>2]|0)+48>>2]&2)t[r>>2]=1;else f=10;break}default:t[r>>2]=1}if((f|0)==10)t[r>>2]=0;s=i;return t[r>>2]|0}function Rd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=t[n>>2]|0;n=kT(t[f>>2]|0)|0;e=uh(i,n,hT(t[f>>2]|0)|0)|0;s=r;return e|0}function Nd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=0;i=t[t[n>>2]>>2]|0;e=us(i,vd(t[f>>2]|0)|0)|0;t[t[n>>2]>>2]=e;e=us(t[t[n>>2]>>2]|0,143656)|0;t[t[n>>2]>>2]=e;e=t[t[n>>2]>>2]|0;i=us(e,Rd(u,t[f>>2]|0)|0)|0;t[t[n>>2]>>2]=i;i=us(t[t[n>>2]>>2]|0,142568)|0;t[t[n>>2]>>2]=i;if(!(t[u>>2]|0)){a=t[n>>2]|0;o=t[a>>2]|0;s=r;return o|0}pAi[t[135736>>2]&511](t[u>>2]|0);t[u>>2]=0;a=t[n>>2]|0;o=t[a>>2]|0;s=r;return o|0}function Td(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e=t[n>>2]|0;if((e|0)==1)t[r>>2]=148168;else if((e|0)==2)t[r>>2]=148176;else if((e|0)==3)t[r>>2]=148184;else t[r>>2]=148192;s=i;return t[r>>2]|0}function Ld(e,i,r,n,f,u,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0;b=s;s=s+96|0;k=b;h=b+88|0;w=b+84|0;d=b+80|0;v=b+76|0;m=b+72|0;_=b+68|0;p=b+64|0;E=b+60|0;S=b+56|0;g=b+52|0;y=b+48|0;F=b+44|0;O=b+40|0;A=b+36|0;M=b+32|0;R=b+28|0;N=b+24|0;T=b+20|0;L=b+16|0;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=n;t[m>>2]=f;t[_>>2]=u;t[p>>2]=a;t[E>>2]=o;t[S>>2]=c;t[g>>2]=l;t[y>>2]=0;t[F>>2]=0;t[O>>2]=0;if(!(t[h>>2]|0)){s=b;return}l=t[h>>2]|0;if((t[t[h>>2]>>2]|0)!=2){if((t[l>>2]|0)!=1){c=t[33976]|0;o=t[33980]|0;t[k>>2]=140328;t[k+4>>2]=2125;yAi[c&511](o,140296,k);s=b;return}t[L>>2]=t[h>>2];o=t[L>>2]|0;if((t[w>>2]|0)!=1){c=o+20|0;t[c>>2]=(t[c>>2]|0)+1;t[(t[L>>2]|0)+16>>2]=t[d>>2];t[F>>2]=t[(t[L>>2]|0)+8>>2]}else t[F>>2]=t[o+12>>2];t[y>>2]=t[(t[L>>2]|0)+24>>2];t[O>>2]=t[(t[L>>2]|0)+4>>2];L=t[y>>2]|0;o=t[F>>2]|0;c=t[O>>2]|0;a=t[h>>2]|0;u=t[v>>2]|0;f=t[d>>2]|0;n=t[w>>2]|0;r=t[p>>2]|0;i=t[E>>2]|0;e=t[S>>2]|0;D=t[_>>2]|0;C=t[E>>2]|0;P=t[S>>2]|0;B=t[g>>2]|0;t[k>>2]=t[p>>2];t[k+4>>2]=C;t[k+8>>2]=P;t[k+12>>2]=B;cp(L,o,c,a,u,16,f,n,0,0,r,i,e,0,0,D,k);s=b;return}t[A>>2]=l;t[M>>2]=0;t[R>>2]=0;l=t[A>>2]|0;if((t[w>>2]|0)!=1){D=l+56|0;t[D>>2]=(t[D>>2]|0)+1;t[(t[A>>2]|0)+52>>2]=t[d>>2];t[F>>2]=t[(t[A>>2]|0)+8>>2]}else t[F>>2]=t[l+12>>2];t[y>>2]=t[(t[A>>2]|0)+16>>2];t[O>>2]=t[(t[A>>2]|0)+4>>2];do if(!(t[m>>2]|0)){if(((t[v>>2]|0)==0?(t[(t[A>>2]|0)+96>>2]|0)>=0:0)?(t[(t[A>>2]|0)+108>>2]|0)!=0:0)t[v>>2]=t[(t[(t[A>>2]|0)+108>>2]|0)+4>>2];if(((t[v>>2]|0)==0?(t[(t[A>>2]|0)+40>>2]|0)!=0:0)?(t[(t[(t[A>>2]|0)+40>>2]|0)+36>>2]|0)!=0:0){t[M>>2]=t[(t[(t[(t[A>>2]|0)+40>>2]|0)+36>>2]|0)+4>>2];t[m>>2]=t[(t[(t[(t[A>>2]|0)+40>>2]|0)+36>>2]|0)+28>>2];t[R>>2]=t[(t[(t[(t[A>>2]|0)+40>>2]|0)+36>>2]|0)+32>>2]}}else{t[v>>2]=0;l=t[A>>2]|0;if(t[(t[A>>2]|0)+24>>2]|0){t[M>>2]=t[(t[l+24>>2]|0)+72>>2];break}if((t[l+40>>2]|0)!=0?(t[(t[(t[A>>2]|0)+40>>2]|0)+36>>2]|0)!=0:0)t[M>>2]=t[(t[(t[(t[A>>2]|0)+40>>2]|0)+36>>2]|0)+4>>2]}while(0);if((t[(t[A>>2]|0)+196>>2]|0)!=0?(t[M>>2]|0)==0|(t[m>>2]|0)==0:0){dAi[t[(t[A>>2]|0)+196>>2]&511](t[(t[A>>2]|0)+200>>2]|0,T,N)|0;if(!(t[M>>2]|0))t[M>>2]=t[T>>2];if(!(t[m>>2]|0))t[m>>2]=t[N>>2]}if((t[M>>2]|0)==0?(t[(t[A>>2]|0)+48>>2]|0)!=0:0)t[M>>2]=t[(t[A>>2]|0)+48>>2];A=t[y>>2]|0;y=t[F>>2]|0;F=t[O>>2]|0;O=t[h>>2]|0;h=t[v>>2]|0;v=t[d>>2]|0;d=t[w>>2]|0;w=t[M>>2]|0;M=t[m>>2]|0;m=t[p>>2]|0;N=t[E>>2]|0;T=t[S>>2]|0;l=t[R>>2]|0;R=t[_>>2]|0;_=t[E>>2]|0;E=t[S>>2]|0;S=t[g>>2]|0;t[k>>2]=t[p>>2];t[k+4>>2]=_;t[k+8>>2]=E;t[k+12>>2]=S;cp(A,y,F,O,h,17,v,d,w,M,m,N,T,0,l,R,k);s=b;return}function Dd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[f>>2]=e;t[a>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}e:do if((t[a>>2]|0)<0){i:while(1){if(!(u[t[f>>2]>>0]|0))break e;do if((u[t[f>>2]>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13)break i}while(0);t[f>>2]=(t[f>>2]|0)+1}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{i:while(1){if(!((t[a>>2]|0)!=0?(u[t[f>>2]>>0]|0|0)!=0:0))break e;do if((u[t[f>>2]>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13)break i}while(0);t[f>>2]=(t[f>>2]|0)+1;t[a>>2]=(t[a>>2]|0)+-1}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}while(0);t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}function Cd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(t[t[f>>2]>>2]|0){if((t[(t[f>>2]|0)+8>>2]|0)<=(t[(t[f>>2]|0)+4>>2]|0)?(i=(t[f>>2]|0)+8|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[t[f>>2]>>2]|0,t[(t[f>>2]|0)+8>>2]<<2)|0,t[t[f>>2]>>2]=i,(t[t[f>>2]>>2]|0)==0):0){Qh(0,142376,0);t[(t[f>>2]|0)+8>>2]=0;t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}}else{i=gAi[t[135744>>2]&511](80)|0;t[t[f>>2]>>2]=i;if(t[t[f>>2]>>2]|0){t[(t[f>>2]|0)+8>>2]=20;break}Qh(0,142344,0);
	t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}while(0);i=t[u>>2]|0;u=(t[f>>2]|0)+4|0;e=t[u>>2]|0;t[u>>2]=e+1;t[(t[t[f>>2]>>2]|0)+(e<<2)>>2]=i;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Pd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=Bd(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=wT(t[u>>2]|0,t[c>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function Bd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=t[(t[f>>2]|0)+44>>2];while(1){if(!(t[a>>2]|0)){c=9;break}if((t[(t[a>>2]|0)+36>>2]|0)==0?(Xl(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0)!=0:0){c=7;break}t[a>>2]=t[(t[a>>2]|0)+24>>2]}if((c|0)==7){t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}else if((c|0)==9){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}return 0}function Id(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if((t[o>>2]|0)==0|(t[b>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=-1;w=t[a>>2]|0;s=u;return w|0}t[h>>2]=Hd(t[o>>2]|0,t[l>>2]|0)|0;if(t[k>>2]|0)t[t[k>>2]>>2]=t[h>>2];t[a>>2]=dT(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[h>>2]|0,t[b>>2]|0)|0;w=t[a>>2]|0;s=u;return w|0}function Hd(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=sF(t[f>>2]|0)|0;if(!(t[u>>2]|0))t[u>>2]=Yl(142672)|0;t[a>>2]=kz(t[(t[n>>2]|0)+80>>2]|0,t[u>>2]|0,-1)|0;pAi[t[135736>>2]&511](t[u>>2]|0);s=r;return t[a>>2]|0}function xd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(Xl(t[u>>2]|0,163536)|0){if(!(t[t[a>>2]>>2]&t[o>>2])){r=t[a>>2]|0;t[r>>2]=t[r>>2]|t[o>>2]}}else if(!(Xl(t[u>>2]|0,163552)|0)){t[f>>2]=1;c=t[f>>2]|0;s=n;return c|0}t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}function Ud(e,i,r,n,f,u,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;b=s;s=s+48|0;k=b+44|0;h=b+40|0;w=b+32|0;d=b+28|0;v=b+24|0;m=b+20|0;_=b+16|0;p=b+12|0;E=b+8|0;S=b+4|0;g=b;t[k>>2]=e;t[h>>2]=i;t[b+36>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=l;t[S>>2]=0;bw(S,t[k>>2]|0,t[w>>2]|0)|0;do if(!(t[_>>2]|0)){l=(t[(t[w>>2]|0)+4>>2]|0)==2;c=t[S>>2]|0;do if(t[d>>2]|0){if(l)t[S>>2]=us(c,154256)|0;else t[S>>2]=us(c,154288)|0;o=(Md(t[d>>2]|0)|0)!=0;a=t[S>>2]|0;if(o)t[S>>2]=us(a,154352)|0;else t[S>>2]=us(a,154336)|0;do if(!(t[(t[d>>2]|0)+48>>2]&256)){if(t[(t[d>>2]|0)+48>>2]&64){t[S>>2]=us(t[S>>2]|0,147936)|0;break}if(t[(t[d>>2]|0)+48>>2]&128)t[S>>2]=us(t[S>>2]|0,147952)|0}else t[S>>2]=us(t[S>>2]|0,147920)|0;while(0);if(Md(t[d>>2]|0)|0){t[g>>2]=0;t[S>>2]=us(t[S>>2]|0,143656)|0;a=t[S>>2]|0;if(t[(t[d>>2]|0)+88>>2]|0){t[S>>2]=us(a,154360)|0;t[S>>2]=us(t[S>>2]|0,t[(t[d>>2]|0)+8>>2]|0)|0}else t[S>>2]=us(a,uh(g,t[(t[d>>2]|0)+112>>2]|0,t[(t[d>>2]|0)+8>>2]|0)|0)|0;t[S>>2]=us(t[S>>2]|0,161528)|0;if(t[g>>2]|0){pAi[t[135736>>2]&511](t[g>>2]|0);t[g>>2]=0}}}else if(l){t[S>>2]=us(c,161536)|0;break}else{t[S>>2]=us(c,161568)|0;break}while(0);c=t[S>>2]|0;if(t[v>>2]|0){t[S>>2]=us(c,161608)|0;t[S>>2]=us(t[S>>2]|0,t[v>>2]|0)|0;t[S>>2]=us(t[S>>2]|0,161624)|0}else t[S>>2]=us(c,140352)|0;c=t[k>>2]|0;l=t[w>>2]|0;a=t[h>>2]|0;o=t[S>>2]|0;if((t[(t[w>>2]|0)+4>>2]|0)==2){pw(c,l,a,o,t[m>>2]|0,0);break}else{pw(c,l,a,o,0,0);break}}else{t[S>>2]=us(t[S>>2]|0,t[_>>2]|0)|0;t[S>>2]=us(t[S>>2]|0,142704)|0;vT(t[k>>2]|0,t[w>>2]|0,t[h>>2]|0,0,0,0,t[S>>2]|0,t[p>>2]|0,t[E>>2]|0,0,0,0)}while(0);if(!(t[S>>2]|0)){s=b;return}pAi[t[135736>>2]&511](t[S>>2]|0);t[S>>2]=0;s=b;return}function zd(e,i,r,n,f,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;l=s;s=s+64|0;b=l+48|0;k=l+44|0;h=l+40|0;w=l+36|0;d=l+32|0;v=l+28|0;m=l+24|0;_=l+20|0;p=l+16|0;E=l+12|0;S=l+8|0;g=l+4|0;y=l;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=n;t[v>>2]=f;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=0;if((t[h>>2]|0)==0|(t[k>>2]|0)==0){t[b>>2]=-1;F=t[b>>2]|0;s=l;return F|0}if(!(u[t[k>>2]>>0]|0)){t[b>>2]=0;F=t[b>>2]|0;s=l;return F|0}e:do if(Xl(t[k>>2]|0,165432)|0){if((t[w>>2]|0)!=-1){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[w>>2];break}if((t[d>>2]|0)!=-1){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[d>>2]}if((t[v>>2]|0)!=-1){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[v>>2]}if((t[m>>2]|0)!=-1){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[m>>2]}if((t[_>>2]|0)!=-1){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[_>>2]}if((t[p>>2]|0)!=-1){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[p>>2]}}else{t[g>>2]=t[k>>2];while(1){do if((u[t[g>>2]>>0]|0|0)==32)O=1;else{if(9<=(u[t[g>>2]>>0]|0|0)?(u[t[g>>2]>>0]|0|0)<=10:0){O=1;break}O=(u[t[g>>2]>>0]|0|0)==13}while(0);c=t[g>>2]|0;if(O){t[g>>2]=c+1;continue}t[S>>2]=c;while(1){if(u[t[S>>2]>>0]|0){do if((u[t[S>>2]>>0]|0|0)==32)A=1;else{if(9<=(u[t[S>>2]>>0]|0|0)?(u[t[S>>2]>>0]|0|0)<=10:0){A=1;break}A=(u[t[S>>2]>>0]|0|0)==13}while(0);M=A^1}else M=0;R=t[S>>2]|0;if(!M)break;t[S>>2]=R+1}if((R|0)==(t[g>>2]|0))break e;t[y>>2]=ql(t[g>>2]|0,(t[S>>2]|0)-(t[g>>2]|0)|0)|0;do if(Xl(t[y>>2]|0,165440)|0){if((t[d>>2]|0)==-1){t[E>>2]=1;break}if(!(t[t[h>>2]>>2]&t[d>>2])){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[d>>2]}}else{if(Xl(t[y>>2]|0,165456)|0){if((t[v>>2]|0)==-1){t[E>>2]=1;break}if(t[t[h>>2]>>2]&t[v>>2])break;c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[v>>2];break}if(Xl(t[y>>2]|0,165472)|0){if((t[m>>2]|0)==-1){t[E>>2]=1;break}if(t[t[h>>2]>>2]&t[m>>2])break;c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[m>>2];break}if(Xl(t[y>>2]|0,165488)|0){if((t[_>>2]|0)==-1){t[E>>2]=1;break}if(t[t[h>>2]>>2]&t[_>>2])break;c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[_>>2];break}if(!(Xl(t[y>>2]|0,165496)|0)){t[E>>2]=1;break}if((t[p>>2]|0)==-1){t[E>>2]=1;break}if(!(t[t[h>>2]>>2]&t[p>>2])){c=t[h>>2]|0;t[c>>2]=t[c>>2]|t[p>>2]}}while(0);if(t[y>>2]|0)pAi[t[135736>>2]&511](t[y>>2]|0);t[g>>2]=t[S>>2];if(t[E>>2]|0)break e;if(!(u[t[g>>2]>>0]|0))break}}while(0);t[b>>2]=t[E>>2];F=t[b>>2]|0;s=l;return F|0}function jd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;t[k>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(t[o>>2]|0)t[c>>2]=mT(t[u>>2]|0,t[a>>2]|0)|0;else t[c>>2]=0;t[b>>2]=t[(t[a>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;if((t[(t[b>>2]|0)+36>>2]|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,161384)|0)==0:0)w=12;else w=10;if(((w|0)==10?(w=0,(t[(t[b>>2]|0)+36>>2]|0)!=0):0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)w=12;if((w|0)==12){w=0;_T(t[u>>2]|0,3035,0,t[b>>2]|0)}t[b>>2]=t[(t[b>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[a>>2]|0,161384)|0;t[l>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(t[l>>2]|0))break;if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,168752)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[b>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;if((t[(t[b>>2]|0)+36>>2]|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,168760)|0)==0:0)w=26;else w=24;if(((w|0)==24?(w=0,(t[(t[b>>2]|0)+36>>2]|0)!=0):0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)w=26;if((w|0)==26){w=0;_T(t[u>>2]|0,3035,0,t[b>>2]|0)}t[b>>2]=t[(t[b>>2]|0)+24>>2]}o=t[u>>2]|0;r=t[l>>2]|0;pT(o,0,r,168760,ED(29)|0,0)|0;t[l>>2]=t[(t[l>>2]|0)+24>>2];continue}if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,168768)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[b>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;r=t[b>>2]|0;do if(!(t[(t[b>>2]|0)+36>>2]|0)){if(!(Xl(t[r+8>>2]|0,168760)|0))_T(t[u>>2]|0,3035,0,t[b>>2]|0)}else{if(!(Xl(t[(t[r+36>>2]|0)+8>>2]|0,t[38526]|0)|0)){if(!(Xl(t[(t[b>>2]|0)+8>>2]|0,168784)|0))break;if(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,168792)|0)break}_T(t[u>>2]|0,3035,0,t[b>>2]|0)}while(0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}t[b>>2]=ET(t[l>>2]|0,168792,168784)|0;if(t[b>>2]|0){r=t[u>>2]|0;o=t[b>>2]|0;Id(r,0,o,ED(17)|0,0)|0}t[l>>2]=t[(t[l>>2]|0)+24>>2];continue}if(!(t[k>>2]|0))$d(t[u>>2]|0,3033,0,t[a>>2]|0,t[l>>2]|0,0,168832);t[k>>2]=1;t[l>>2]=t[(t[l>>2]|0)+24>>2]}t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}function Vd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;t[b>>2]=0;t[w>>2]=0;t[d>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}t[h>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;r=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if(((Xl(t[r+8>>2]|0,161384)|0)==0?(Xl(t[(t[h>>2]|0)+8>>2]|0,162304)|0)==0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,155456)|0)==0:0)_T(t[u>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[r+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}h=t[u>>2]|0;r=t[o>>2]|0;i=(pT(h,0,r,162304,ED(29)|0,l)|0)!=0;r=t[u>>2]|0;h=t[o>>2]|0;e=ED(29)|0;if(i){Ud(r,3037,0,h,e,0,t[l>>2]|0,0,0,0);t[f>>2]=t[(t[u>>2]|0)+16>>2];v=t[f>>2]|0;s=n;return v|0}if(pT(r,0,h,155456,e,b)|0){e=t[u>>2]|0;h=t[o>>2]|0;r=ED(29)|0;Ud(e,3037,0,h,r,0,t[b>>2]|0,0,0,0);t[f>>2]=t[(t[u>>2]|0)+16>>2];v=t[f>>2]|0;s=n;return v|0}t[c>>2]=t[(t[o>>2]|0)+12>>2];if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)t[c>>2]=t[(t[c>>2]|0)+24>>2];if(t[c>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[c>>2]|0,0,161392);t[k>>2]=t[(t[(t[(t[u>>2]|0)+28>>2]|0)+16>>2]|0)+12>>2];c=t[k>>2]|0;if(t[l>>2]|0){if(Xl(c,t[l>>2]|0)|0){sv(t[u>>2]|0,3064,0,t[o>>2]|0,168408,t[k>>2]|0);t[f>>2]=t[(t[u>>2]|0)+16>>2];v=t[f>>2]|0;s=n;return v|0}}else if(!c){sv(t[u>>2]|0,3065,0,t[o>>2]|0,168512,0);t[f>>2]=t[(t[u>>2]|0)+16>>2];v=t[f>>2]|0;s=n;return v|0}if(t[b>>2]|0)t[b>>2]=ST(t[(t[u>>2]|0)+80>>2]|0,t[b>>2]|0,t[o>>2]|0)|0;t[w>>2]=lh(t[u>>2]|0,1,t[b>>2]|0,0,0,0,t[o>>2]|0,t[k>>2]|0,t[l>>2]|0,d)|0;if(t[w>>2]|0){t[f>>2]=t[w>>2];v=t[f>>2]|0;s=n;return v|0}if((t[d>>2]|0)==0&(t[b>>2]|0)!=0)mw(t[u>>2]|0,3084,t[o>>2]|0,0,168608,t[b>>2]|0,0,0);if(((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+20>>2]|0)!=0:0)?(t[(t[d>>2]|0)+32>>2]|0)==0:0)t[w>>2]=gT(t[u>>2]|0,t[a>>2]|0,t[d>>2]|0)|0;t[f>>2]=t[w>>2];v=t[f>>2]|0;s=n;return v|0}function qd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=yT(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,2)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}return 0}function Yd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=yT(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,3)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}return 0}function Gd(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;f=s;s=s+64|0;u=f+52|0;a=f+48|0;o=f+44|0;c=f+40|0;l=f+36|0;b=f+32|0;k=f+28|0;h=f+24|0;w=f+20|0;d=f+16|0;v=f+12|0;m=f+8|0;_=f+4|0;p=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[h>>2]=0;t[w>>2]=0;t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}t[k>>2]=t[(t[a>>2]|0)+84>>2];if(t[l>>2]|0){t[d>>2]=Bd(t[c>>2]|0,161352)|0;n=t[a>>2]|0;if(!(t[d>>2]|0)){FT(n,3036,0,t[c>>2]|0,161352,0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}r=t[d>>2]|0;if(Id(n,0,r,ED(22)|0,w)|0){t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}}r=t[a>>2]|0;n=t[o>>2]|0;do if(!(t[l>>2]|0)){t[b>>2]=Av(r,n,5,0,t[(t[a>>2]|0)+112>>2]|0,t[c>>2]|0,0)|0;if(t[b>>2]|0){t[w>>2]=t[(t[b>>2]|0)+8>>2];t[(t[b>>2]|0)+36>>2]=t[c>>2];t[t[b>>2]>>2]=5;break}t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}else{t[b>>2]=Av(r,n,5,t[w>>2]|0,t[(t[a>>2]|0)+112>>2]|0,t[c>>2]|0,1)|0;if(t[b>>2]|0){t[(t[b>>2]|0)+36>>2]=t[c>>2];t[t[b>>2]>>2]=5;i=(t[b>>2]|0)+48|0;t[i>>2]=t[i>>2]|8;break}t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}while(0);t[(t[b>>2]|0)+112>>2]=t[(t[a>>2]|0)+112>>2];t[d>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[d>>2]|0))break;w=t[d>>2]|0;do if(!(t[(t[d>>2]|0)+36>>2]|0)){if(Xl(t[w+8>>2]|0,161384)|0){Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;break}if(Xl(t[(t[d>>2]|0)+8>>2]|0,167064)|0){if(!(OT(t[a>>2]|0,0,t[d>>2]|0)|0))break;n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|1;break}if(!(t[l>>2]|0)){_T(t[a>>2]|0,3035,0,t[d>>2]|0);break}if(!(Xl(t[(t[d>>2]|0)+8>>2]|0,161352)|0)){if(Xl(t[(t[d>>2]|0)+8>>2]|0,164512)|0){if(!(OT(t[a>>2]|0,0,t[d>>2]|0)|0))break;n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|1048576;break}if(Xl(t[(t[d>>2]|0)+8>>2]|0,164504)|0){t[v>>2]=Hd(t[a>>2]|0,t[d>>2]|0)|0;if(zd(t[v>>2]|0,(t[b>>2]|0)+48|0,-1,512,1024,-1,-1,-1)|0){Ud(t[a>>2]|0,3037,0,t[d>>2]|0,0,164528,t[v>>2]|0,0,0,0);break}else{t[m>>2]=1;break}}n=(Xl(t[(t[d>>2]|0)+8>>2]|0,164480)|0)!=0;r=t[a>>2]|0;i=t[d>>2]|0;if(!n){_T(r,3035,0,i);break}t[v>>2]=Hd(r,i)|0;if(zd(t[v>>2]|0,(t[b>>2]|0)+48|0,-1,262144,524288,-1,-1,-1)|0){Ud(t[a>>2]|0,3037,0,t[d>>2]|0,0,167072,t[v>>2]|0,0,0,0);break}else{t[_>>2]=1;break}}}else if(Xl(t[(t[w+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[d>>2]|0);while(0);t[d>>2]=t[(t[d>>2]|0)+24>>2]}if(!(t[_>>2]|0)){if(t[(t[o>>2]|0)+24>>2]&128){_=(t[b>>2]|0)+48|0;t[_>>2]=t[_>>2]|524288}if(t[(t[o>>2]|0)+24>>2]&64){_=(t[b>>2]|0)+48|0;t[_>>2]=t[_>>2]|262144}}if(!(t[m>>2]|0)){if(t[(t[o>>2]|0)+24>>2]&8){m=(t[b>>2]|0)+48|0;t[m>>2]=t[m>>2]|1024}if(t[(t[o>>2]|0)+24>>2]&4){m=(t[b>>2]|0)+48|0;t[m>>2]=t[m>>2]|512}}t[h>>2]=t[(t[c>>2]|0)+12>>2];if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=jd(t[a>>2]|0,t[h>>2]|0,1)|0;t[(t[b>>2]|0)+24>>2]=m;t[h>>2]=t[(t[h>>2]|0)+24>>2]}t[(t[a>>2]|0)+84>>2]=t[b>>2];if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,167120)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){if(t[(t[b>>2]|0)+48>>2]&1){m=(t[b>>2]|0)+48|0;t[m>>2]=t[m>>2]^1}AT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,p)|0;t[h>>2]=t[(t[h>>2]|0)+24>>2]}else S=63;do if((S|0)==63){if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,167136)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[(t[b>>2]|0)+52>>2]=1;MT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,p)|0;t[h>>2]=t[(t[h>>2]|0)+24>>2];break}m=ED(45)|0;t[(t[b>>2]|0)+64>>2]=m;m=(t[b>>2]|0)+48|0;t[m>>2]=t[m>>2]|4;if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=RT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,8,1)|0;t[(t[b>>2]|0)+28>>2]=m;t[h>>2]=t[(t[h>>2]|0)+24>>2]}else S=73;do if((S|0)==73){if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=RT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,7,1)|0;t[(t[b>>2]|0)+28>>2]=m;t[h>>2]=t[(t[h>>2]|0)+24>>2];break}if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=RT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,6,1)|0;t[(t[b>>2]|0)+28>>2]=m;t[h>>2]=t[(t[h>>2]|0)+24>>2];break}if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=NT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0)|0;t[(t[b>>2]|0)+28>>2]=m;t[h>>2]=t[(t[h>>2]|0)+24>>2]}}while(0);if((TT(t[a>>2]|0,t[o>>2]|0,h,(t[b>>2]|0)+116|0,12,0)|0)==-1){t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=LT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0)|0;t[(t[b>>2]|0)+84>>2]=m;t[h>>2]=t[(t[h>>2]|0)+24>>2]}}while(0);if(t[h>>2]|0)$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[h>>2]|0,0,167152);if((t[l>>2]|0)!=0?!((t[p>>2]|0)!=0?1:(t[(t[a>>2]|0)+100>>2]|0)==0):0)sv(t[a>>2]|0,3081,0,t[c>>2]|0,167288,0);t[(t[a>>2]|0)+84>>2]=t[k>>2];t[u>>2]=t[b>>2];E=t[u>>2]|0;s=f;return E|0}function Wd(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f+44|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+8|0;v=f+4|0;m=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[h>>2]=0;t[w>>2]=0;t[v>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}if(t[l>>2]|0){t[d>>2]=Bd(t[c>>2]|0,161352)|0;n=t[a>>2]|0;if(!(t[d>>2]|0)){FT(n,3036,0,t[c>>2]|0,161352,0);t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}r=t[d>>2]|0;if(Id(n,0,r,ED(22)|0,w)|0){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}if(t[(t[a>>2]|0)+96>>2]|0){if(t[(t[a>>2]|0)+100>>2]|0){sv(t[a>>2]|0,3081,0,t[c>>2]|0,165552,0);t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[m>>2]=RD(t[w>>2]|0,t[38526]|0)|0;if(t[m>>2]|0){t[u>>2]=t[m>>2];_=t[u>>2]|0;s=f;return _|0}}}m=t[a>>2]|0;r=t[o>>2]|0;e:do if(t[l>>2]|0){t[b>>2]=Av(m,r,4,t[w>>2]|0,t[(t[a>>2]|0)+112>>2]|0,t[c>>2]|0,1)|0;if(!(t[b>>2]|0)){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[t[b>>2]>>2]=4;t[(t[b>>2]|0)+52>>2]=4;n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|8;t[d>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[d>>2]|0))break;n=t[d>>2]|0;if(!(t[(t[d>>2]|0)+36>>2]|0)){if(((Xl(t[n+8>>2]|0,161384)|0)==0?(Xl(t[(t[d>>2]|0)+8>>2]|0,161352)|0)==0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,164504)|0)==0:0)_T(t[a>>2]|0,3035,0,t[d>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[d>>2]|0);t[d>>2]=t[(t[d>>2]|0)+24>>2]}t[d>>2]=Bd(t[c>>2]|0,164504)|0;if(t[d>>2]|0){t[w>>2]=Sw(t[a>>2]|0,t[c>>2]|0,164504)|0;if(!(zd(t[w>>2]|0,(t[b>>2]|0)+48|0,-1,-1,1024,-1,2048,4096)|0))break;Ud(t[a>>2]|0,3037,t[b>>2]|0,t[d>>2]|0,0,165608,t[w>>2]|0,0,0,0);break}if(t[(t[o>>2]|0)+24>>2]&8){n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|1024}if(t[(t[o>>2]|0)+24>>2]&16){n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|2048}if(t[(t[o>>2]|0)+24>>2]&32){n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|4096}}else{t[b>>2]=Av(m,r,4,0,t[(t[a>>2]|0)+112>>2]|0,t[c>>2]|0,0)|0;if(!(t[b>>2]|0)){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[t[b>>2]>>2]=4;t[(t[b>>2]|0)+52>>2]=4;t[d>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[d>>2]|0))break e;n=t[d>>2]|0;if(!(t[(t[d>>2]|0)+36>>2]|0)){if(!(Xl(t[n+8>>2]|0,161384)|0))_T(t[a>>2]|0,3035,0,t[d>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[d>>2]|0);t[d>>2]=t[(t[d>>2]|0)+24>>2]}}while(0);t[(t[b>>2]|0)+112>>2]=t[(t[a>>2]|0)+112>>2];Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;t[k>>2]=t[(t[a>>2]|0)+84>>2];t[(t[a>>2]|0)+84>>2]=t[b>>2];t[h>>2]=t[(t[c>>2]|0)+12>>2];if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){d=jd(t[a>>2]|0,t[h>>2]|0,1)|0;t[(t[b>>2]|0)+24>>2]=d;t[h>>2]=t[(t[h>>2]|0)+24>>2]}do if(t[h>>2]|0){if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,165456)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){DT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0,4)|0;t[v>>2]=1;t[h>>2]=t[(t[h>>2]|0)+24>>2];break}if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,165488)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){CT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0)|0;t[h>>2]=t[(t[h>>2]|0)+24>>2];break}if((((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[h>>2]|0)+8>>2]|0,165496)|0)!=0:0)?(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){PT(t[a>>2]|0,t[o>>2]|0,t[h>>2]|0)|0;t[h>>2]=t[(t[h>>2]|0)+24>>2]}}else $d(t[a>>2]|0,3034,0,t[c>>2]|0,t[h>>2]|0,0,165656);while(0);if(t[h>>2]|0)$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[h>>2]|0,0,165656);if((t[l>>2]|0)!=0?!((t[v>>2]|0)!=0?1:(t[(t[a>>2]|0)+100>>2]|0)==0):0)sv(t[a>>2]|0,3081,0,t[c>>2]|0,165704,0);t[(t[a>>2]|0)+84>>2]=t[k>>2];t[u>>2]=t[b>>2];_=t[u>>2]|0;s=f;return _|0}function Kd(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0;u=s;s=s+112|0;a=u+96|0;o=u+92|0;c=u+88|0;l=u+84|0;b=u+80|0;k=u+76|0;h=u+72|0;w=u+68|0;d=u+64|0;v=u+60|0;m=u+56|0;_=u+52|0;p=u+48|0;E=u+44|0;S=u+40|0;g=u+36|0;y=u+32|0;F=u+28|0;O=u+24|0;A=u+20|0;M=u+16|0;R=u+12|0;N=u+8|0;T=u+4|0;L=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;t[S>>2]=0;t[g>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(t[b>>2]|0)t[t[b>>2]>>2]=0;t[_>>2]=Bd(t[l>>2]|0,161352)|0;t[m>>2]=Bd(t[l>>2]|0,160064)|0;if((t[k>>2]|0)!=0|(t[m>>2]|0)==0){if(!(t[_>>2]|0)){FT(t[o>>2]|0,3036,0,t[l>>2]|0,161352,0);t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}}else t[S>>2]=1;Pd(t[o>>2]|0,t[l>>2]|0,161384)|0;t[v>>2]=t[(t[l>>2]|0)+12>>2];if((((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[v>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[d>>2]=jd(t[o>>2]|0,t[v>>2]|0,1)|0;t[v>>2]=t[(t[v>>2]|0)+24>>2]}if(!(t[k>>2]|0)){t[p>>2]=BT(t[o>>2]|0,t[l>>2]|0,0,-1,1,161744)|0;t[E>>2]=IT(t[o>>2]|0,t[l>>2]|0,0,1073741824,1,161768)|0;HT(t[o>>2]|0,0,t[l>>2]|0,t[p>>2]|0,t[E>>2]|0)|0;t[w>>2]=Mv(t[o>>2]|0,t[l>>2]|0,t[p>>2]|0,t[E>>2]|0)|0;if(t[w>>2]|0)if(t[S>>2]|0){t[y>>2]=0;t[F>>2]=0;t[O>>2]=0;if(t[b>>2]|0)t[t[b>>2]>>2]=1;xT(t[o>>2]|0,t[c>>2]|0,0,t[m>>2]|0,y,F)|0;UT(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[m>>2]|0,t[y>>2]|0)|0;if(t[_>>2]|0)zT(t[o>>2]|0,3039,0,t[_>>2]|0,160064,161352);t[m>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[m>>2]|0))break;b=t[m>>2]|0;if(t[(t[m>>2]|0)+36>>2]|0){if(Xl(t[(t[b+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[o>>2]|0,3035,0,t[m>>2]|0);t[m>>2]=t[(t[m>>2]|0)+24>>2];continue}if(((((Xl(t[b+8>>2]|0,160064)|0)==0?(Xl(t[(t[m>>2]|0)+8>>2]|0,161352)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,161384)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,161808)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,161824)|0)==0:0){C=30;break}t[m>>2]=t[(t[m>>2]|0)+24>>2]}if((C|0)==30)jT(t[o>>2]|0,3040,0,0,t[m>>2]|0,164392);if(t[v>>2]|0)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[v>>2]|0,0,161392);if(!((t[p>>2]|0)==0&(t[E>>2]|0)==0)?(t[O>>2]=VT(t[o>>2]|0,14,t[F>>2]|0,t[y>>2]|0)|0,(t[O>>2]|0)!=0):0){t[(t[w>>2]|0)+12>>2]=t[O>>2];t[(t[w>>2]|0)+4>>2]=t[d>>2];qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[w>>2]|0)|0;t[a>>2]=t[w>>2];D=t[a>>2]|0;s=u;return D|0}}else C=39}else C=39;if((C|0)==39?(t[A>>2]=0,t[T>>2]=0,t[L>>2]=0,O=t[o>>2]|0,y=t[_>>2]|0,(Id(O,0,y,ED(22)|0,R)|0)==0):0){do if(!(t[k>>2]|0)){t[m>>2]=Bd(t[l>>2]|0,163528)|0;if(!(t[m>>2]|0)){if(!(t[(t[c>>2]|0)+24>>2]&1))break;t[A>>2]=t[(t[o>>2]|0)+112>>2];break}t[N>>2]=Hd(t[o>>2]|0,t[m>>2]|0)|0;if(Xl(t[N>>2]|0,163536)|0){t[A>>2]=t[(t[o>>2]|0)+112>>2];break}if(!(Xl(t[N>>2]|0,163552)|0))Ud(t[o>>2]|0,3037,0,t[m>>2]|0,0,163568,t[N>>2]|0,0,0,0)}else t[A>>2]=t[(t[o>>2]|0)+112>>2];while(0);t[h>>2]=YT(t[o>>2]|0,t[R>>2]|0,t[A>>2]|0,t[l>>2]|0,t[k>>2]|0)|0;if(t[h>>2]|0){t[m>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[m>>2]|0))break;A=t[m>>2]|0;do if(!(t[(t[m>>2]|0)+36>>2]|0)){if(((((((Xl(t[A+8>>2]|0,161352)|0)==0?(Xl(t[(t[m>>2]|0)+8>>2]|0,155448)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,161384)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,159128)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,159120)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,164480)|0)==0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,164488)|0)==0:0){R=t[(t[m>>2]|0)+8>>2]|0;if(!(t[k>>2]|0)){if(Xl(R,161808)|0)break;if(Xl(t[(t[m>>2]|0)+8>>2]|0,161824)|0)break;if(Xl(t[(t[m>>2]|0)+8>>2]|0,163528)|0)break;_T(t[o>>2]|0,3035,0,t[m>>2]|0);break}else{if(Xl(R,164504)|0)break;if(Xl(t[(t[m>>2]|0)+8>>2]|0,164512)|0)break;if(Xl(t[(t[m>>2]|0)+8>>2]|0,160544)|0)break;_T(t[o>>2]|0,3035,0,t[m>>2]|0);break}}}else if(Xl(t[(t[A+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[o>>2]|0,3035,0,t[m>>2]|0);while(0);t[m>>2]=t[(t[m>>2]|0)+24>>2]}do if(t[k>>2]|0){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|2;A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|32;GT(t[o>>2]|0,t[c>>2]|0,0,t[l>>2]|0,160544,(t[h>>2]|0)+68|0,(t[h>>2]|0)+64|0)|0;if(WT(t[o>>2]|0,t[l>>2]|0,164512,0)|0){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|16}t[m>>2]=Bd(t[l>>2]|0,164504)|0;if(t[m>>2]|0){t[N>>2]=Hd(t[o>>2]|0,t[m>>2]|0)|0;if(!(zd(t[N>>2]|0,(t[h>>2]|0)+48|0,-1,32768,65536,-1,-1,-1)|0))break;Ud(t[o>>2]|0,3037,0,t[m>>2]|0,0,164528,t[N>>2]|0,0,0,0);break}if(t[(t[c>>2]|0)+24>>2]&4){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|32768}if(t[(t[c>>2]|0)+24>>2]&8){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|65536}}while(0);t[m>>2]=Bd(t[l>>2]|0,164480)|0;if(!(t[m>>2]|0)){if(t[(t[c>>2]|0)+24>>2]&128){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|4096}if(t[(t[c>>2]|0)+24>>2]&64){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|2048}if(t[(t[c>>2]|0)+24>>2]&256){A=(t[h>>2]|0)+48|0;t[A>>2]=t[A>>2]|8192}}else{t[N>>2]=Hd(t[o>>2]|0,t[m>>2]|0)|0;if(zd(t[N>>2]|0,(t[h>>2]|0)+48|0,-1,2048,4096,8192,-1,-1)|0)Ud(t[o>>2]|0,3037,0,t[m>>2]|0,0,164576,t[N>>2]|0,0,0,0)}if(WT(t[o>>2]|0,t[l>>2]|0,164488,0)|0){N=(t[h>>2]|0)+48|0;t[N>>2]=t[N>>2]|1}t[m>>2]=Bd(t[l>>2]|0,155448)|0;if(t[m>>2]|0){xT(t[o>>2]|0,t[c>>2]|0,0,t[m>>2]|0,(t[h>>2]|0)+60|0,(t[h>>2]|0)+56|0)|0;UT(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[m>>2]|0,t[(t[h>>2]|0)+60>>2]|0)|0}N=Sw(t[o>>2]|0,t[l>>2]|0,159128)|0;t[(t[h>>2]|0)+76>>2]=N;t[m>>2]=Bd(t[l>>2]|0,159120)|0;do if(t[m>>2]|0){t[M>>2]=Hd(t[o>>2]|0,t[m>>2]|0)|0;if(t[(t[h>>2]|0)+76>>2]|0){zT(t[o>>2]|0,3038,0,t[m>>2]|0,159128,159120);break}else{N=(t[h>>2]|0)+48|0;t[N>>2]=t[N>>2]|8;t[(t[h>>2]|0)+76>>2]=t[M>>2];break}}while(0);if((((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[v>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){M=t[o>>2]|0;if(t[(t[h>>2]|0)+56>>2]|0)$d(M,3041,0,t[l>>2]|0,t[v>>2]|0,164640,0);else{m=Gd(M,t[c>>2]|0,t[v>>2]|0,0)|0;t[(t[h>>2]|0)+28>>2]=m}t[v>>2]=t[(t[v>>2]|0)+24>>2]}else C=107;if(((((C|0)==107?(t[v>>2]|0)!=0:0)?(t[(t[v>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[v>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){m=t[o>>2]|0;if(t[(t[h>>2]|0)+56>>2]|0)$d(m,3041,0,t[l>>2]|0,t[v>>2]|0,164128,0);else{M=Wd(m,t[c>>2]|0,t[v>>2]|0,0)|0;t[(t[h>>2]|0)+28>>2]=M}t[v>>2]=t[(t[v>>2]|0)+24>>2]}while(1){if((((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[v>>2]|0)+8>>2]|0,164712)|0)!=0:0)?(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)P=1;else C=119;e:do if((C|0)==119){C=0;do if(t[v>>2]|0){if(!(t[(t[v>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[v>>2]|0)+8>>2]|0,164720)|0))break;if(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0){P=1;break e}}while(0);if(t[v>>2]|0){if(!(t[(t[v>>2]|0)+36>>2]|0)){P=0;break}if(!(Xl(t[(t[v>>2]|0)+8>>2]|0,164728)|0)){P=0;break}P=(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0}else P=0}while(0);B=(t[v>>2]|0)!=0;if(!P)break;do if(B){if(!(t[(t[v>>2]|0)+36>>2]|0)){C=133;break}if(!(Xl(t[(t[v>>2]|0)+8>>2]|0,164712)|0)){C=133;break}if(!(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)){C=133;break}t[T>>2]=KT(t[o>>2]|0,t[c>>2]|0,t[v>>2]|0,22,t[(t[h>>2]|0)+52>>2]|0)|0}else C=133;while(0);e:do if((C|0)==133){C=0;do if(t[v>>2]|0){if(!(t[(t[v>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[v>>2]|0)+8>>2]|0,164720)|0))break;if(!(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break;t[T>>2]=KT(t[o>>2]|0,t[c>>2]|0,t[v>>2]|0,23,t[(t[h>>2]|0)+52>>2]|0)|0;break e}while(0);if(!(t[v>>2]|0))break;if(!(t[(t[v>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[v>>2]|0)+8>>2]|0,164728)|0))break;if(!(Xl(t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break;t[T>>2]=KT(t[o>>2]|0,t[c>>2]|0,t[v>>2]|0,24,t[(t[h>>2]|0)+52>>2]|0)|0}while(0);M=t[T>>2]|0;if(t[L>>2]|0)t[(t[L>>2]|0)+8>>2]=M;else t[(t[h>>2]|0)+100>>2]=M;t[L>>2]=t[T>>2];t[v>>2]=t[(t[v>>2]|0)+24>>2]}if(B)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[v>>2]|0,0,164736);t[(t[h>>2]|0)+24>>2]=t[d>>2];if(t[g>>2]|0){pAi[t[135736>>2]&511](t[g>>2]|0);t[g>>2]=0}v=t[h>>2]|0;if(t[k>>2]|0){t[a>>2]=v;D=t[a>>2]|0;s=u;return D|0}else{t[(t[w>>2]|0)+12>>2]=v;t[a>>2]=t[w>>2];D=t[a>>2]|0;s=u;return D|0}}}if(t[g>>2]|0){pAi[t[135736>>2]&511](t[g>>2]|0);t[g>>2]=0}if(t[d>>2]|0){if(t[w>>2]|0)t[(t[w>>2]|0)+4>>2]=0;if(t[h>>2]|0)t[(t[h>>2]|0)+24>>2]=0;Yk(t[d>>2]|0)}t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}function Xd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[k>>2]=Bd(t[o>>2]|0,161352)|0;r=t[u>>2]|0;if(!(t[k>>2]|0)){FT(r,3036,0,t[o>>2]|0,161352,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}i=t[k>>2]|0;if(Id(r,0,i,ED(22)|0,c)|0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}i=(Xl(t[c>>2]|0,163840)|0)!=0;r=t[u>>2]|0;if(i){i=t[k>>2]|0;Ud(r,3056,0,i,ED(22)|0,0,0,163848,0,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(Xl(t[r+112>>2]|0,t[38860]|0)|0)th(t[u>>2]|0,3057,t[o>>2]|0,0,163792,t[38860]|0,0);t[l>>2]=XT(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0,t[(t[u>>2]|0)+112>>2]|0,t[o>>2]|0,1)|0;if(!(t[l>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}c=(t[l>>2]|0)+60|0;t[c>>2]=t[c>>2]|1;t[k>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[k>>2]|0))break;c=t[k>>2]|0;if(!(t[(t[k>>2]|0)+36>>2]|0)){if(((((Xl(t[c+8>>2]|0,161384)|0)==0?(Xl(t[(t[k>>2]|0)+8>>2]|0,159128)|0)==0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,159120)|0)==0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161352)|0)==0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,155448)|0)==0:0)_T(t[u>>2]|0,3035,0,t[k>>2]|0)}else if(Xl(t[(t[c+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[k>>2]|0);t[k>>2]=t[(t[k>>2]|0)+24>>2]}GT(t[u>>2]|0,t[a>>2]|0,0,t[o>>2]|0,155448,(t[l>>2]|0)+28|0,(t[l>>2]|0)+24|0)|0;Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;c=Sw(t[u>>2]|0,t[o>>2]|0,159120)|0;t[(t[l>>2]|0)+44>>2]=c;if(t[(t[l>>2]|0)+44>>2]|0){c=(t[l>>2]|0)+60|0;t[c>>2]=t[c>>2]|512}t[k>>2]=Bd(t[o>>2]|0,159128)|0;do if(t[k>>2]|0){c=t[u>>2]|0;if(t[(t[l>>2]|0)+60>>2]&512){zT(c,3051,t[l>>2]|0,t[k>>2]|0,159128,159120);break}else{r=Hd(c,t[k>>2]|0)|0;t[(t[l>>2]|0)+44>>2]=r;break}}while(0);t[b>>2]=t[(t[o>>2]|0)+12>>2];if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){k=jd(t[u>>2]|0,t[b>>2]|0,1)|0;t[(t[l>>2]|0)+32>>2]=k;t[b>>2]=t[(t[b>>2]|0)+24>>2]}if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){k=t[u>>2]|0;if(t[(t[l>>2]|0)+24>>2]|0)$d(k,3055,0,t[o>>2]|0,t[b>>2]|0,164128,0);else{r=Wd(k,t[a>>2]|0,t[b>>2]|0,0)|0;t[(t[l>>2]|0)+48>>2]=r}t[b>>2]=t[(t[b>>2]|0)+24>>2]}if(t[b>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[b>>2]|0,0,164200);t[f>>2]=t[l>>2];h=t[f>>2]|0;s=n;return h|0}function Zd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;t[h>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[k>>2]=Bd(t[o>>2]|0,161352)|0;r=t[u>>2]|0;if(!(t[k>>2]|0)){FT(r,3036,0,t[o>>2]|0,161352,0);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}i=t[k>>2]|0;if(Id(r,0,i,ED(22)|0,c)|0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[l>>2]=ZT(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0,t[(t[u>>2]|0)+112>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[k>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[k>>2]|0))break;c=t[k>>2]|0;if(!(t[(t[k>>2]|0)+36>>2]|0)){if((Xl(t[c+8>>2]|0,161352)|0)==0?(Xl(t[(t[k>>2]|0)+8>>2]|0,161384)|0)==0:0)_T(t[u>>2]|0,3035,0,t[k>>2]|0)}else if(Xl(t[(t[c+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[k>>2]|0);t[k>>2]=t[(t[k>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[b>>2]=t[(t[o>>2]|0)+12>>2];if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){k=jd(t[u>>2]|0,t[b>>2]|0,1)|0;t[(t[l>>2]|0)+24>>2]=k;t[b>>2]=t[(t[b>>2]|0)+24>>2]}if((TT(t[u>>2]|0,t[a>>2]|0,b,(t[l>>2]|0)+56|0,16,h)|0)==-1){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if(t[h>>2]|0){h=(t[l>>2]|0)+36|0;t[h>>2]=t[h>>2]|16}if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=LT(t[u>>2]|0,t[a>>2]|0,t[b>>2]|0)|0;t[(t[l>>2]|0)+40>>2]=h;t[b>>2]=t[(t[b>>2]|0)+24>>2];
	}if(t[b>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[b>>2]|0,0,163344);t[f>>2]=t[l>>2];w=t[f>>2]|0;s=n;return w|0}function Jd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[b>>2]=Bd(t[o>>2]|0,161352)|0;r=t[u>>2]|0;if(!(t[b>>2]|0)){FT(r,3036,0,t[o>>2]|0,161352,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}i=t[b>>2]|0;if(Id(r,0,i,ED(22)|0,k)|0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[c>>2]=JT(t[u>>2]|0,t[a>>2]|0,t[k>>2]|0,t[(t[u>>2]|0)+112>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[b>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;k=t[b>>2]|0;if(!(t[(t[b>>2]|0)+36>>2]|0)){if((Xl(t[k+8>>2]|0,161352)|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,161384)|0)==0:0)_T(t[u>>2]|0,3035,0,t[b>>2]|0)}else if(Xl(t[(t[k+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[b>>2]|0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=jd(t[u>>2]|0,t[l>>2]|0,1)|0;t[(t[c>>2]|0)+4>>2]=b;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=RT(t[u>>2]|0,t[a>>2]|0,t[l>>2]|0,8,0)|0;t[(t[c>>2]|0)+12>>2]=b;t[l>>2]=t[(t[l>>2]|0)+24>>2]}else w=28;do if((w|0)==28){if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=RT(t[u>>2]|0,t[a>>2]|0,t[l>>2]|0,7,0)|0;t[(t[c>>2]|0)+12>>2]=b;t[l>>2]=t[(t[l>>2]|0)+24>>2];break}if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=RT(t[u>>2]|0,t[a>>2]|0,t[l>>2]|0,6,0)|0;t[(t[c>>2]|0)+12>>2]=b;t[l>>2]=t[(t[l>>2]|0)+24>>2]}}while(0);if(t[l>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[l>>2]|0,0,161680);t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}function Qd(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[c>>2]=Sw(t[u>>2]|0,t[o>>2]|0,161352)|0;r=t[u>>2]|0;if(!(t[c>>2]|0)){QT(r,t[o>>2]|0,t[b>>2]|0,1723,161360,0,0);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[l>>2]=$T(r,t[a>>2]|0,t[c>>2]|0,t[(t[u>>2]|0)+112>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[b>>2]=t[(t[o>>2]|0)+12>>2];if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){c=jd(t[u>>2]|0,t[b>>2]|0,1)|0;t[(t[l>>2]|0)+8>>2]=c;t[b>>2]=t[(t[b>>2]|0)+24>>2]}if(t[b>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[b>>2]|0,0,161392);t[f>>2]=t[l>>2];k=t[f>>2]|0;s=n;return k|0}function $d(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+32|0;c=o+28|0;l=o+24|0;b=o+20|0;k=o+16|0;h=o+12|0;w=o+8|0;d=o+4|0;v=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;t[v>>2]=0;sw(v,0,t[b>>2]|0,t[k>>2]|0)|0;do if(!(t[w>>2]|0)){b=t[c>>2]|0;a=t[k>>2]|0;u=t[h>>2]|0;f=t[l>>2]|0;n=t[v>>2]|0;if(t[d>>2]|0){QT(b,a,u,f,161272,n,t[d>>2]|0);break}else{QT(b,a,u,f,161320,n,0);break}}else QT(t[c>>2]|0,t[k>>2]|0,t[h>>2]|0,t[l>>2]|0,161256,t[v>>2]|0,t[w>>2]|0);while(0);if(!(t[v>>2]|0)){s=o;return}pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0;s=o;return}function ev(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}e:do if((t[(t[a>>2]|0)+44>>2]|0)!=0?(t[(t[(t[a>>2]|0)+44>>2]|0)+4>>2]|0)!=0:0){t[k>>2]=0;i:while(1){if((t[k>>2]|0)>=(t[(t[(t[a>>2]|0)+44>>2]|0)+4>>2]|0))break e;t[b>>2]=t[(t[t[(t[a>>2]|0)+44>>2]>>2]|0)+(t[k>>2]<<2)>>2];do if((t[t[b>>2]>>2]|0)==(t[o>>2]|0)){n=t[o>>2]|0;if((n|0)==4|(n|0)==5){if((t[(t[b>>2]|0)+8>>2]|0)!=(t[c>>2]|0))break;if((t[(t[b>>2]|0)+112>>2]|0)==(t[l>>2]|0)){d=11;break i}else break}else if((n|0)==16){if((t[(t[b>>2]|0)+8>>2]|0)!=(t[c>>2]|0))break;if((t[(t[b>>2]|0)+52>>2]|0)==(t[l>>2]|0)){d=17;break i}else break}else if((n|0)==17){if((t[(t[b>>2]|0)+16>>2]|0)!=(t[c>>2]|0))break;if((t[(t[b>>2]|0)+20>>2]|0)==(t[l>>2]|0)){d=14;break i}else break}else{d=18;break i}}while(0);t[k>>2]=(t[k>>2]|0)+1}if((d|0)==11){t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}else if((d|0)==14){t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}else if((d|0)==17){t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}else if((d|0)==18){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}}while(0);do if(t[(t[a>>2]|0)+24>>2]|0){t[h>>2]=t[(t[a>>2]|0)+24>>2];k=(t[a>>2]|0)+4|0;t[k>>2]=t[k>>2]|1;while(1){if(((t[(t[h>>2]|0)+12>>2]|0)!=0?(t[(t[(t[h>>2]|0)+12>>2]|0)+4>>2]&1|0)==0:0)?(t[b>>2]=ev(t[(t[h>>2]|0)+12>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0,(t[b>>2]|0)!=0):0)break;t[h>>2]=t[t[h>>2]>>2];if(!(t[h>>2]|0)){d=27;break}}if((d|0)==27){k=(t[a>>2]|0)+4|0;t[k>>2]=t[k>>2]^1;break}t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}while(0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function iv(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}if((t[o>>2]|0)!=0?(Xl(t[o>>2]|0,t[38526]|0)|0)!=0:0){t[c>>2]=RD(t[a>>2]|0,t[o>>2]|0)|0;if((t[c>>2]|0)==0&(t[u>>2]|0)!=0)k=7}else k=6;if((k|0)==6?(t[u>>2]|0)!=0:0)k=7;do if((k|0)==7){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+28>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+28>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function rv(e,i,r,n,f,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;l=s;s=s+48|0;b=l+40|0;k=l+36|0;h=l+32|0;w=l+28|0;d=l+24|0;v=l+20|0;m=l+16|0;_=l+12|0;p=l+8|0;E=l+4|0;S=l;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=0;t[S>>2]=0;sw(E,0,t[h>>2]|0,t[w>>2]|0)|0;if(!(t[p>>2]|0))t[p>>2]=lT(t[_>>2]|0)|0;_=t[b>>2]|0;b=t[w>>2]|0;w=t[k>>2]|0;k=t[E>>2]|0;h=t[d>>2]|0;d=uh(S,t[m>>2]|0,t[v>>2]|0)|0;vT(_,b,w,0,0,0,160072,k,h,d,t[p>>2]|0,0);if(t[E>>2]|0){pAi[t[135736>>2]&511](t[E>>2]|0);t[E>>2]=0}if(!(t[S>>2]|0)){s=l;return}pAi[t[135736>>2]&511](t[S>>2]|0);t[S>>2]=0;s=l;return}function nv(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(t[u>>2]|0){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+40>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+40>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function fv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[u>>2]|0)+92>>2];t[o>>2]=0;e:while(1){if(!(t[a>>2]|0))break;t[b>>2]=t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2];t[k>>2]=t[(t[(t[a>>2]|0)+4>>2]|0)+16>>2];t[l>>2]=iv(t[(t[f>>2]|0)+36>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;do if(t[l>>2]|0){if((t[t[l>>2]>>2]|0)!=4){if((t[t[l>>2]>>2]|0)!=1)break;if((t[(t[l>>2]|0)+88>>2]|0)==45)break}t[(t[a>>2]|0)+4>>2]=t[l>>2];t[o>>2]=t[a>>2];t[a>>2]=t[t[a>>2]>>2];continue e}while(0);rv(t[f>>2]|0,3004,t[u>>2]|0,t[(t[u>>2]|0)+36>>2]|0,160512,t[b>>2]|0,t[k>>2]|0,4,0);i=t[t[a>>2]>>2]|0;if(!(t[o>>2]|0))t[(t[u>>2]|0)+92>>2]=i;else t[t[o>>2]>>2]=i;t[c>>2]=t[a>>2];t[a>>2]=t[t[a>>2]>>2];pAi[t[135736>>2]&511](t[c>>2]|0)}t[l>>2]=t[(t[u>>2]|0)+28>>2];while(1){if(!(t[l>>2]|0)){h=20;break}t[a>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[a>>2]|0)){h=15;break}t[(t[a>>2]|0)+4>>2]=t[l>>2];t[t[a>>2]>>2]=0;c=t[a>>2]|0;if(!(t[o>>2]|0))t[(t[u>>2]|0)+92>>2]=c;else t[t[o>>2]>>2]=c;t[o>>2]=t[a>>2];t[l>>2]=t[(t[l>>2]|0)+4>>2]}if((h|0)==15){Qh(t[f>>2]|0,149752,0);t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}else if((h|0)==20){t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}return 0}function tv(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;n=t[c>>2]|0;if((n|0)==17){t[a>>2]=eL(t[o>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;k=t[a>>2]|0;s=f;return k|0}else if((n|0)==14){t[a>>2]=nv(t[o>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;k=t[a>>2]|0;s=f;return k|0}else{b=t[33976]|0;l=t[33980]|0;t[u>>2]=140328;t[u+4>>2]=4984;yAi[b&511](l,140296,u);t[a>>2]=0;k=t[a>>2]|0;s=f;return k|0}return 0}function uv(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(t[u>>2]|0){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+32>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+32>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function av(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(t[u>>2]|0){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+36>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+36>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function ov(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(t[u>>2]|0){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+76>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+76>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function cv(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)!=1:0){if((t[a>>2]|0)==(t[o>>2]|0)){r=t[u>>2]|0;i=t[a>>2]|0;sv(r,3009,i,lw(t[a>>2]|0)|0,160032,0);t[f>>2]=3009;l=t[f>>2]|0;s=n;return l|0}if(t[(t[o>>2]|0)+48>>2]&65536){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{i=(t[o>>2]|0)+48|0;t[i>>2]=t[i>>2]|65536;t[c>>2]=cv(t[u>>2]|0,t[a>>2]|0,t[(t[o>>2]|0)+64>>2]|0)|0;a=(t[o>>2]|0)+48|0;t[a>>2]=t[a>>2]^65536;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}}t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}function lv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;e:while(1){if(!(t[u>>2]|0)){l=14;break}t[o>>2]=t[(t[u>>2]|0)+12>>2];do if(t[o>>2]|0){i=t[t[o>>2]>>2]|0;if((i|0)==8|(i|0)==7|(i|0)==6){t[a>>2]=lv(t[f>>2]|0,t[(t[o>>2]|0)+12>>2]|0)|0;if(t[a>>2]|0){l=12;break e}else break}else if((i|0)!=17)break;t[c>>2]=t[o>>2];if((t[c>>2]|0)==(t[f>>2]|0)){l=6;break e}if(((t[(t[c>>2]|0)+28>>2]&1|0)==0?(t[(t[c>>2]|0)+12>>2]|0)!=0:0)?(i=(t[c>>2]|0)+28|0,t[i>>2]=t[i>>2]|1,t[a>>2]=lv(t[f>>2]|0,t[(t[(t[c>>2]|0)+12>>2]|0)+12>>2]|0)|0,i=(t[c>>2]|0)+28|0,t[i>>2]=t[i>>2]^1,(t[a>>2]|0)!=0):0){l=10;break e}}while(0);t[u>>2]=t[(t[u>>2]|0)+8>>2]}if((l|0)==6){t[n>>2]=t[u>>2];b=t[n>>2]|0;s=r;return b|0}else if((l|0)==10){t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}else if((l|0)==12){t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}else if((l|0)==14){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function sv(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;iL(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,0,0);s=a;return}function bv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[(t[u>>2]|0)+4>>2]|0)){b=14;break}t[o>>2]=t[(t[t[u>>2]>>2]|0)+(t[l>>2]<<2)>>2];if(((t[t[o>>2]>>2]|0)==2e3?(t[(t[o>>2]|0)+8>>2]|0)==16:0)?(t[(t[o>>2]|0)+4>>2]|0)!=0:0){t[a>>2]=t[(t[o>>2]|0)+4>>2];if((t[a>>2]|0)==(t[f>>2]|0)){b=7;break}if((((t[(t[a>>2]|0)+36>>2]&4|0)==0?(t[(t[a>>2]|0)+56>>2]|0)!=0:0)?(t[(t[a>>2]|0)+36>>2]&16|0)!=0:0)?(i=(t[a>>2]|0)+36|0,t[i>>2]=t[i>>2]|4,t[c>>2]=bv(t[f>>2]|0,t[(t[a>>2]|0)+56>>2]|0)|0,i=(t[a>>2]|0)+36|0,t[i>>2]=t[i>>2]^4,(t[c>>2]|0)!=0):0){b=12;break}}t[l>>2]=(t[l>>2]|0)+1}if((b|0)==7){t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}else if((b|0)==12){t[n>>2]=t[c>>2];k=t[n>>2]|0;s=r;return k|0}else if((b|0)==14){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}return 0}function kv(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;u=s;s=s+64|0;a=u+56|0;o=u+52|0;c=u+48|0;l=u+44|0;b=u+40|0;k=u+36|0;h=u+32|0;w=u+28|0;d=u+24|0;v=u+20|0;m=u+16|0;_=u+12|0;p=u+8|0;E=u+4|0;S=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[_>>2]=(t[t[l>>2]>>2]|0)==0?0:1;if(t[k>>2]|0)t[(t[k>>2]|0)+4>>2]=0;t[v>>2]=0;e:while(1){if((t[v>>2]|0)>=(t[(t[b>>2]|0)+4>>2]|0)){g=41;break}t[w>>2]=t[(t[t[b>>2]>>2]|0)+(t[v>>2]<<2)>>2];i:do if((t[t[w>>2]>>2]|0)!=2001){if((t[t[w>>2]>>2]|0)==2e3?(t[(t[w>>2]|0)+8>>2]|0)==16:0){if(!(t[(t[w>>2]|0)+4>>2]|0)){g=14;break e}t[h>>2]=t[(t[w>>2]|0)+4>>2];if((t[(t[h>>2]|0)+36>>2]&1|0)==0?(zw(t[o>>2]|0,t[h>>2]|0)|0)==-1:0){g=17;break e}do if(t[(t[h>>2]|0)+40>>2]|0){if(!(t[t[l>>2]>>2]|0)){t[t[l>>2]>>2]=t[(t[h>>2]|0)+40>>2];break}if(!(t[_>>2]|0)){f=t[o>>2]|0;n=t[(t[o>>2]|0)+36>>2]|0;t[p>>2]=nL(f,n,21,lw(t[c>>2]|0)|0)|0;if(!(t[p>>2]|0)){g=23;break e}if((fL(t[o>>2]|0,t[p>>2]|0,t[t[l>>2]>>2]|0)|0)==-1){g=25;break e}t[(t[p>>2]|0)+24>>2]=t[(t[t[l>>2]>>2]|0)+24>>2];t[t[l>>2]>>2]=t[p>>2];t[_>>2]=1}if((tL(t[o>>2]|0,t[t[l>>2]>>2]|0,t[(t[h>>2]|0)+40>>2]|0)|0)==-1){g=28;break e}}while(0);t[d>>2]=t[(t[h>>2]|0)+56>>2];if((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+4>>2]|0)!=0:0){t[(t[t[b>>2]>>2]|0)+(t[v>>2]<<2)>>2]=t[t[t[d>>2]>>2]>>2];if((t[(t[d>>2]|0)+4>>2]|0)==1)break;t[m>>2]=1;while(1){if((t[m>>2]|0)>=(t[(t[d>>2]|0)+4>>2]|0))break i;t[v>>2]=(t[v>>2]|0)+1;if((uL(t[b>>2]|0,t[(t[t[d>>2]>>2]|0)+(t[m>>2]<<2)>>2]|0,t[v>>2]|0)|0)==-1){g=38;break e}t[m>>2]=(t[m>>2]|0)+1}}if((yv(t[b>>2]|0,t[v>>2]|0)|0)==-1){g=32;break e}t[v>>2]=(t[v>>2]|0)+-1}}else{if(!(t[k>>2]|0)){g=7;break e}if((yv(t[b>>2]|0,t[v>>2]|0)|0)==-1){g=9;break e}t[v>>2]=(t[v>>2]|0)+-1;rL(t[k>>2]|0,2,t[w>>2]|0)|0}while(0);t[v>>2]=(t[v>>2]|0)+1}switch(g|0){case 7:{rh(t[o>>2]|0,152800,152840);t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 9:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 14:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 17:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 23:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 25:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 28:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 32:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 38:{t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}case 41:{e:do if(((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+4>>2]|0)!=0:0)?(t[(t[b>>2]|0)+4>>2]|0)!=0:0){t[v>>2]=(t[(t[k>>2]|0)+4>>2]|0)-1;while(1){if((t[v>>2]|0)<0)break e;t[E>>2]=t[(t[t[k>>2]>>2]|0)+(t[v>>2]<<2)>>2];t[m>>2]=0;while(1){if((t[m>>2]|0)>=(t[(t[b>>2]|0)+4>>2]|0))break;t[w>>2]=t[(t[t[b>>2]>>2]|0)+(t[m>>2]<<2)>>2];if((t[(t[E>>2]|0)+8>>2]|0)==(t[(t[(t[w>>2]|0)+12>>2]|0)+8>>2]|0)?(t[(t[E>>2]|0)+12>>2]|0)==(t[(t[(t[w>>2]|0)+12>>2]|0)+56>>2]|0):0){g=50;break}t[m>>2]=(t[m>>2]|0)+1}if((g|0)==50){g=0;t[S>>2]=0;d=t[o>>2]|0;h=t[(t[E>>2]|0)+4>>2]|0;mw(d,3086,h,0,152880,uh(S,t[(t[E>>2]|0)+12>>2]|0,t[(t[E>>2]|0)+8>>2]|0)|0,0,0);if(t[S>>2]|0){pAi[t[135736>>2]&511](t[S>>2]|0);t[S>>2]=0}if((yv(t[k>>2]|0,t[v>>2]|0)|0)==-1)break}t[v>>2]=(t[v>>2]|0)+-1}t[a>>2]=-1;y=t[a>>2]|0;s=u;return y|0}while(0);t[a>>2]=0;y=t[a>>2]|0;s=u;return y|0}}return 0}function hv(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[o>>2];e:while(1){if(!(t[c>>2]|0)){k=14;break}t[l>>2]=t[(t[c>>2]|0)+4>>2];while(1){if(!(t[l>>2]|0))break;if((t[t[l>>2]>>2]|0)==1)break;if((t[l>>2]|0)==(t[a>>2]|0)){k=7;break e}if(((t[(t[l>>2]|0)+48>>2]&128|0)!=0?(t[(t[l>>2]|0)+48>>2]&65536|0)==0:0)?(o=(t[l>>2]|0)+48|0,t[o>>2]=t[o>>2]|65536,o=t[u>>2]|0,r=t[a>>2]|0,t[b>>2]=hv(o,r,cw(t[l>>2]|0)|0)|0,r=(t[l>>2]|0)+48|0,t[r>>2]=t[r>>2]^65536,(t[b>>2]|0)!=0):0){k=11;break e}t[l>>2]=t[(t[l>>2]|0)+64>>2]}t[c>>2]=t[t[c>>2]>>2]}if((k|0)==7){sv(t[u>>2]|0,3003,t[a>>2]|0,0,159872,0);t[f>>2]=3003;h=t[f>>2]|0;s=n;return h|0}else if((k|0)==11){t[f>>2]=t[b>>2];h=t[f>>2]|0;s=n;return h|0}else if((k|0)==14){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}return 0}function wv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(!(t[f>>2]|0))t[n>>2]=0;else{if((t[t[u>>2]>>2]|0)!=1){rh(t[u>>2]|0,147104,147128);t[n>>2]=-1;break}if((t[t[f>>2]>>2]|0)!=1?(t[(t[f>>2]|0)+48>>2]&4194304|0)==0:0){if((t[t[f>>2]>>2]|0)==5){t[n>>2]=Xw(t[u>>2]|0,t[f>>2]|0)|0;break}if((t[t[f>>2]>>2]|0)==4){t[n>>2]=qw(t[u>>2]|0,t[f>>2]|0)|0;break}else{t[n>>2]=0;break}}t[n>>2]=0}while(0);s=r;return t[n>>2]|0}function dv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[u>>2]|0)+92>>2];e:while(1){if(!(t[a>>2]|0)){k=15;break}if((t[t[(t[a>>2]|0)+4>>2]>>2]|0)!=1?(t[(t[(t[a>>2]|0)+4>>2]|0)+48>>2]&4194304|0)==0:0)wv(t[(t[a>>2]|0)+4>>2]|0,t[f>>2]|0)|0;i:do if(((t[(t[(t[a>>2]|0)+4>>2]|0)+48>>2]&128|0)!=0?(t[l>>2]=cw(t[(t[a>>2]|0)+4>>2]|0)|0,(t[l>>2]|0)!=0):0)?(t[(t[a>>2]|0)+4>>2]=t[(t[l>>2]|0)+4>>2],(t[t[l>>2]>>2]|0)!=0):0){t[o>>2]=t[t[a>>2]>>2];t[l>>2]=t[t[l>>2]>>2];t[c>>2]=t[a>>2];while(1){if(!(t[l>>2]|0))break i;t[b>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[b>>2]|0)){k=12;break e}t[(t[b>>2]|0)+4>>2]=t[(t[l>>2]|0)+4>>2];t[t[c>>2]>>2]=t[b>>2];t[c>>2]=t[b>>2];t[t[b>>2]>>2]=t[o>>2];t[l>>2]=t[t[l>>2]>>2]}}while(0);t[a>>2]=t[t[a>>2]>>2]}if((k|0)==12){Qh(t[f>>2]|0,149752,0);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}else if((k|0)==15){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}return 0}function vv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[u>>2]|0)+64>>2];t[o>>2]=0;if(!(t[a>>2]|0)){sv(t[f>>2]|0,3008,t[u>>2]|0,0,149560,0);t[n>>2]=3008;c=t[n>>2]|0;s=r;return c|0}do if((t[t[a>>2]>>2]|0)!=4){if((t[t[a>>2]>>2]|0)==1?(t[(t[a>>2]|0)+88>>2]|0)!=45:0)break;i=t[f>>2]|0;e=t[u>>2]|0;sv(i,3008,e,0,149584,Rd(o,t[a>>2]|0)|0);if(t[o>>2]|0){pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=0}t[n>>2]=3008;c=t[n>>2]|0;s=r;return c|0}while(0);if(!((t[(t[u>>2]|0)+48>>2]&64|0)==0?(t[(t[u>>2]|0)+48>>2]&128|0)==0:0))l=11;do if((l|0)==11?(t[(t[u>>2]|0)+48>>2]&4|0)==0:0){if((t[t[a>>2]>>2]|0)==1?(t[(t[a>>2]|0)+88>>2]|0)==46:0)break;if((t[t[a>>2]>>2]|0)!=4){e=t[f>>2]|0;i=t[u>>2]|0;sv(e,3008,i,0,149624,Rd(o,t[a>>2]|0)|0);if(t[o>>2]|0){pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=0}t[n>>2]=3008;c=t[n>>2]|0;s=r;return c|0}}while(0);if(((t[(t[u>>2]|0)+48>>2]&256|0)==0?(t[(t[u>>2]|0)+48>>2]&128|0)==0:0)?(t[(t[u>>2]|0)+48>>2]&64|0)==0:0){sv(t[f>>2]|0,3008,t[u>>2]|0,0,149728,0);t[n>>2]=3008;c=t[n>>2]|0;s=r;return c|0}if(!(aL(t[a>>2]|0,1024)|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}l=t[f>>2]|0;f=t[u>>2]|0;sv(l,3010,f,0,149224,Rd(o,t[a>>2]|0)|0);if(t[o>>2]|0){pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=0}t[n>>2]=3010;c=t[n>>2]|0;s=r;return c|0}function mv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;r=s;s=s+96|0;n=r+80|0;f=r+76|0;u=r+72|0;a=r+68|0;o=r+64|0;c=r+60|0;l=r+56|0;b=r+52|0;k=r+48|0;h=r+44|0;w=r+40|0;d=r+36|0;v=r+32|0;m=r+28|0;_=r+24|0;p=r+20|0;E=r+16|0;S=r+12|0;g=r+8|0;y=r+4|0;F=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((t[t[u>>2]>>2]|0)!=4){rh(t[f>>2]|0,148320,148352);t[n>>2]=-1;O=t[n>>2]|0;s=r;return O|0}i=t[u>>2]|0;e:do if(t[(t[u>>2]|0)+48>>2]&256){if(!(t[(t[i+64>>2]|0)+48>>2]&256)){e=t[f>>2]|0;A=t[u>>2]|0;sv(e,3011,A,0,148400,Rd(a,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3011;O=t[n>>2]|0;s=r;return O|0}if(aL(t[(t[u>>2]|0)+64>>2]|0,1024)|0){A=t[f>>2]|0;e=t[u>>2]|0;sv(A,3012,e,0,148448,Rd(a,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3012;O=t[n>>2]|0;s=r;return O|0}if(t[(t[u>>2]|0)+68>>2]|0){t[l>>2]=1;t[o>>2]=yd(t[u>>2]|0)|0;if(!(t[o>>2]|0)){rh(t[f>>2]|0,148320,148512);t[n>>2]=-1;O=t[n>>2]|0;s=r;return O|0}t[c>>2]=t[(t[u>>2]|0)+68>>2];do{if(!(pD(t[o>>2]|0,t[t[c>>2]>>2]|0)|0)){t[l>>2]=0;oL(t[f>>2]|0,3013,t[u>>2]|0,t[o>>2]|0,t[c>>2]|0)}t[c>>2]=t[(t[c>>2]|0)+4>>2]}while((t[c>>2]|0)!=0);if(!(t[l>>2]|0)){t[n>>2]=3013;O=t[n>>2]|0;s=r;return O|0}}}else{if(!(t[i+48>>2]&64)){if(!(t[(t[u>>2]|0)+48>>2]&128))break;t[p>>2]=t[(t[u>>2]|0)+92>>2];while(1){if(!(t[p>>2]|0))break;if((t[t[(t[p>>2]|0)+4>>2]>>2]|0)!=1?(t[(t[(t[p>>2]|0)+4>>2]|0)+48>>2]&4194304|0)==0:0)wv(t[(t[p>>2]|0)+4>>2]|0,t[f>>2]|0)|0;if((t[(t[(t[p>>2]|0)+4>>2]|0)+48>>2]&256|0)==0?(t[(t[(t[p>>2]|0)+4>>2]|0)+48>>2]&64|0)==0:0){M=91;break}t[p>>2]=t[t[p>>2]>>2]}if((M|0)==91){e=t[f>>2]|0;A=t[u>>2]|0;sv(e,3023,A,0,149040,Rd(a,t[(t[p>>2]|0)+4>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3023;O=t[n>>2]|0;s=r;return O|0}A=t[u>>2]|0;if((t[(t[(t[u>>2]|0)+64>>2]|0)+88>>2]|0)==46){t[p>>2]=t[A+92>>2];while(1){if(!(t[p>>2]|0)){M=103;break}if(aL(t[(t[p>>2]|0)+4>>2]|0,4096)|0)break;t[p>>2]=t[t[p>>2]>>2]}if((M|0)==103){if(!(t[(t[u>>2]|0)+96>>2]|0))break;sv(t[f>>2]|0,3025,t[u>>2]|0,0,149160,0);t[n>>2]=3025;O=t[n>>2]|0;s=r;return O|0}e=t[f>>2]|0;R=t[u>>2]|0;sv(e,3024,R,0,149104,Rd(a,t[(t[p>>2]|0)+4>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3024;O=t[n>>2]|0;s=r;return O|0}if(!(t[(t[A+64>>2]|0)+48>>2]&128)){R=t[f>>2]|0;e=t[u>>2]|0;sv(R,3027,e,0,149184,Rd(a,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3027;O=t[n>>2]|0;s=r;return O|0}if(aL(t[(t[u>>2]|0)+64>>2]|0,1024)|0){e=t[f>>2]|0;R=t[u>>2]|0;sv(e,3026,R,0,149224,Rd(a,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3026;O=t[n>>2]|0;s=r;return O|0}i:do if(t[(t[u>>2]|0)+92>>2]|0){t[p>>2]=t[(t[u>>2]|0)+92>>2];t[E>>2]=cw(t[(t[u>>2]|0)+64>>2]|0)|0;if((t[p>>2]|0)==0&(t[E>>2]|0)!=0)rh(t[f>>2]|0,148320,149296);while(1){if(!(t[p>>2]|0))break i;if(t[E>>2]|0){if((t[(t[p>>2]|0)+4>>2]|0)!=(t[(t[E>>2]|0)+4>>2]|0)?(lL(t[f>>2]|0,t[(t[p>>2]|0)+4>>2]|0,t[(t[E>>2]|0)+4>>2]|0,0)|0)!=0:0)break}else rh(t[f>>2]|0,148320,149296);t[p>>2]=t[t[p>>2]>>2];if(!(t[E>>2]|0))continue;t[E>>2]=t[t[E>>2]>>2]}t[S>>2]=0;t[g>>2]=0;R=t[f>>2]|0;e=t[u>>2]|0;N=Rd(a,t[(t[p>>2]|0)+4>>2]|0)|0;T=Rd(S,t[(t[E>>2]|0)+4>>2]|0)|0;iL(R,3028,e,0,149344,N,T,Rd(g,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}if(t[S>>2]|0){pAi[t[135736>>2]&511](t[S>>2]|0);t[S>>2]=0}if(t[g>>2]|0){pAi[t[135736>>2]&511](t[g>>2]|0);t[g>>2]=0}t[n>>2]=3028;O=t[n>>2]|0;s=r;return O|0}while(0);if(!(t[(t[u>>2]|0)+68>>2]|0))break;t[F>>2]=1;t[y>>2]=t[(t[u>>2]|0)+68>>2];do{if((t[t[y>>2]>>2]|0)!=1006?(t[t[y>>2]>>2]|0)!=1007:0){cL(t[f>>2]|0,3029,t[u>>2]|0,t[y>>2]|0);t[F>>2]=0}t[y>>2]=t[(t[y>>2]|0)+4>>2]}while((t[y>>2]|0)!=0);if(t[F>>2]|0)break;t[n>>2]=3029;O=t[n>>2]|0;s=r;return O|0}t[b>>2]=0;t[b>>2]=t[(t[u>>2]|0)+28>>2];do if(t[b>>2]|0){if((t[t[b>>2]>>2]|0)!=4){if((t[t[b>>2]>>2]|0)!=1)break;if((t[(t[b>>2]|0)+88>>2]|0)==45)break}if((t[t[b>>2]>>2]|0)!=1?(t[(t[b>>2]|0)+48>>2]&4194304|0)==0:0)wv(t[b>>2]|0,t[f>>2]|0)|0;if((t[(t[b>>2]|0)+48>>2]&256|0)==0?(t[(t[b>>2]|0)+48>>2]&128|0)==0:0){A=t[f>>2]|0;T=t[u>>2]|0;sv(A,3015,T,0,148584,Rd(a,t[b>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3015;O=t[n>>2]|0;s=r;return O|0}i:do if(t[(t[b>>2]|0)+48>>2]&128){t[k>>2]=t[(t[b>>2]|0)+92>>2];while(1){if(!(t[k>>2]|0))break i;if(!(t[(t[(t[k>>2]|0)+4>>2]|0)+48>>2]&256))break;t[k>>2]=t[t[k>>2]>>2]}T=t[f>>2]|0;A=t[u>>2]|0;sv(T,3015,A,0,148648,Rd(a,t[(t[k>>2]|0)+4>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3015;O=t[n>>2]|0;s=r;return O|0}while(0);if((t[t[(t[u>>2]|0)+64>>2]>>2]|0)==1?(t[(t[(t[u>>2]|0)+64>>2]|0)+88>>2]|0)==46:0){if(aL(t[b>>2]|0,2048)|0){A=t[f>>2]|0;T=t[u>>2]|0;sv(A,3016,T,0,148736,Rd(a,t[b>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3016;O=t[n>>2]|0;s=r;return O|0}if(!(t[(t[u>>2]|0)+68>>2]|0))break e;t[h>>2]=t[(t[u>>2]|0)+68>>2];while(1){if((t[t[h>>2]>>2]|0)!=1008)break;t[h>>2]=t[(t[h>>2]|0)+4>>2];if(!(t[h>>2]|0))break e}cL(t[f>>2]|0,3017,t[u>>2]|0,t[h>>2]|0);t[n>>2]=3017;O=t[n>>2]|0;s=r;return O|0}if(!(t[(t[(t[u>>2]|0)+64>>2]|0)+48>>2]&64)){T=t[f>>2]|0;A=t[u>>2]|0;sv(T,3018,A,0,148792,Rd(a,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3018;O=t[n>>2]|0;s=r;return O|0}if(aL(t[(t[u>>2]|0)+64>>2]|0,1024)|0){A=t[f>>2]|0;T=t[u>>2]|0;sv(A,3019,T,0,148832,Rd(a,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}t[n>>2]=3019;O=t[n>>2]|0;s=r;return O|0}t[w>>2]=t[(t[(t[u>>2]|0)+64>>2]|0)+28>>2];do if(t[w>>2]|0){if((t[t[w>>2]>>2]|0)!=4){if((t[t[w>>2]>>2]|0)!=1)break;if((t[(t[w>>2]|0)+88>>2]|0)==45)break}if((t[b>>2]|0)!=(t[w>>2]|0)?(lL(t[f>>2]|0,t[b>>2]|0,t[w>>2]|0,0)|0)!=0:0){t[d>>2]=0;t[v>>2]=0;T=t[f>>2]|0;A=t[u>>2]|0;N=Rd(a,t[b>>2]|0)|0;e=Rd(d,t[w>>2]|0)|0;iL(T,3020,A,0,148952,N,e,Rd(v,t[(t[u>>2]|0)+64>>2]|0)|0);if(t[a>>2]|0){pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=0}if(t[d>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0}if(t[v>>2]|0){pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0}t[n>>2]=3020;O=t[n>>2]|0;s=r;return O|0}if(!(t[(t[u>>2]|0)+68>>2]|0))break e;t[_>>2]=1;t[m>>2]=t[(t[u>>2]|0)+68>>2];do{if(((t[t[m>>2]>>2]|0)+-1006|0)>>>0>=6){cL(t[f>>2]|0,3021,t[u>>2]|0,t[m>>2]|0);t[_>>2]=0}t[m>>2]=t[(t[m>>2]|0)+4>>2]}while((t[m>>2]|0)!=0);if(t[_>>2]|0)break e;t[n>>2]=3021;O=t[n>>2]|0;s=r;return O|0}while(0);rh(t[f>>2]|0,148320,148904);t[n>>2]=-1;O=t[n>>2]|0;s=r;return O|0}while(0);rh(t[f>>2]|0,148320,148544);t[n>>2]=-1;O=t[n>>2]|0;s=r;return O|0}while(0);t[n>>2]=0;O=t[n>>2]|0;s=r;return O|0}function _v(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=t[(t[u>>2]|0)+20>>2];t[c>>2]=t[(t[f>>2]|0)+8>>2];do if(t[(t[f>>2]|0)+68>>2]|0){t[l>>2]=t[(t[f>>2]|0)+68>>2];if((t[(t[u>>2]|0)+92>>2]|0)==0?(sL(t[u>>2]|0)|0)==-1:0){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[(t[(t[u>>2]|0)+92>>2]|0)+20>>2]=t[(t[u>>2]|0)+36>>2];while(1){if(!(t[l>>2]|0)){k=9;break}t[a>>2]=Tk(t[l>>2]|0,t[f>>2]|0,t[u>>2]|0,t[c>>2]|0)|0;if((t[a>>2]|0)==-1)break;t[l>>2]=t[(t[l>>2]|0)+4>>2]}if((k|0)==9){t[(t[(t[u>>2]|0)+92>>2]|0)+20>>2]=0;break}t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}while(0);if((t[o>>2]|0)!=(t[(t[u>>2]|0)+20>>2]|0)){t[n>>2]=t[(t[u>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function pv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0;r=s;s=s+112|0;n=r+108|0;f=r+104|0;u=r+100|0;a=r+96|0;o=r+92|0;c=r+88|0;l=r+84|0;b=r+80|0;k=r+76|0;h=r+72|0;w=r+68|0;d=r+64|0;v=r+60|0;m=r+56|0;_=r+52|0;p=r+48|0;E=r+44|0;S=r+40|0;g=r+36|0;y=r+32|0;F=r+28|0;O=r+24|0;A=r+20|0;M=r+16|0;R=r+12|0;N=r+8|0;T=r+4|0;L=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[u>>2]|0)+64>>2];t[l>>2]=0;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;t[E>>2]=0;t[S>>2]=0;t[g>>2]=0;t[y>>2]=0;t[F>>2]=0;t[O>>2]=0;t[A>>2]=0;t[M>>2]=0;t[R>>2]=0;t[N>>2]=0;t[T>>2]=0;if((t[(t[u>>2]|0)+96>>2]|0)==0?(t[(t[a>>2]|0)+96>>2]|0)==0:0){t[n>>2]=0;D=t[n>>2]|0;s=r;return D|0}t[l>>2]=t[(t[u>>2]|0)+96>>2];e:do if(t[l>>2]|0)while(1){if(!(t[t[l>>2]>>2]|0))break e;t[l>>2]=t[t[l>>2]>>2]}while(0);t[c>>2]=t[(t[u>>2]|0)+96>>2];while(1){if(!(t[c>>2]|0))break;t[b>>2]=t[(t[c>>2]|0)+4>>2];switch(t[t[b>>2]>>2]|0){case 1011:{t[m>>2]=t[b>>2];break}case 1005:{t[d>>2]=t[b>>2];break}case 1009:{t[h>>2]=t[b>>2];break}case 1003:{t[S>>2]=t[b>>2];break}case 1004:{t[w>>2]=t[b>>2];break}case 1001:{t[E>>2]=t[b>>2];break}case 1002:{t[p>>2]=t[b>>2];break}case 1e3:{t[_>>2]=t[b>>2];break}case 1010:{t[v>>2]=t[b>>2];break}default:{}}t[c>>2]=t[t[c>>2]>>2]}t[c>>2]=t[(t[a>>2]|0)+96>>2];while(1){if(!(t[c>>2]|0))break;t[b>>2]=t[(t[c>>2]|0)+4>>2];switch(t[t[b>>2]>>2]|0){case 1002:{t[R>>2]=t[b>>2];break}case 1001:{t[N>>2]=t[b>>2];break}case 1005:{t[F>>2]=t[b>>2];break}case 1004:{t[y>>2]=t[b>>2];break}case 1e3:{t[M>>2]=t[b>>2];break}case 1003:{t[T>>2]=t[b>>2];break}case 1011:{t[A>>2]=t[b>>2];break}case 1010:{t[O>>2]=t[b>>2];break}case 1009:{t[g>>2]=t[b>>2];break}default:{}}t[c>>2]=t[t[c>>2]>>2]}if((t[h>>2]|0)!=0?(t[m>>2]|0)!=0|(t[v>>2]|0)!=0:0)sv(t[f>>2]|0,1717,t[h>>2]|0,t[(t[h>>2]|0)+20>>2]|0,147232,0);if((t[p>>2]|0)!=0&(t[S>>2]|0)!=0){i=t[f>>2]|0;e=t[p>>2]|0;C=t[(t[p>>2]|0)+20>>2]|0;P=fh(t[t[p>>2]>>2]|0)|0;iL(i,1717,e,C,147352,P,fh(t[t[S>>2]>>2]|0)|0,0)}if((t[_>>2]|0)!=0&(t[E>>2]|0)!=0){P=t[f>>2]|0;C=t[_>>2]|0;e=t[(t[_>>2]|0)+20>>2]|0;i=fh(t[t[_>>2]>>2]|0)|0;iL(P,1717,C,e,147352,i,fh(t[t[E>>2]>>2]|0)|0,0)}if((t[h>>2]|0)!=0&(t[g>>2]|0)!=0){t[L>>2]=BD(t[(t[h>>2]|0)+32>>2]|0,t[(t[g>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)!=-2){if(t[L>>2]|0)bL(t[f>>2]|0,t[h>>2]|0,t[g>>2]|0,0,0,1);if((t[L>>2]|0)!=0?(t[(t[g>>2]|0)+24>>2]|0)!=0:0){sv(t[f>>2]|0,1717,t[h>>2]|0,t[(t[h>>2]|0)+20>>2]|0,147440,0);B=47}else B=47}}else B=47;e:do if((B|0)==47){if((t[m>>2]|0)!=0&(t[A>>2]|0)!=0){t[L>>2]=BD(t[(t[m>>2]|0)+32>>2]|0,t[(t[A>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[m>>2]|0,t[A>>2]|0,1,1,1);if((t[L>>2]|0)!=0?(t[(t[A>>2]|0)+24>>2]|0)!=0:0)sv(t[f>>2]|0,1717,t[m>>2]|0,t[(t[m>>2]|0)+20>>2]|0,147440,0)}if((t[v>>2]|0)!=0&(t[O>>2]|0)!=0){t[L>>2]=BD(t[(t[v>>2]|0)+32>>2]|0,t[(t[O>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[v>>2]|0,t[O>>2]|0,-1,1,1);if((t[L>>2]|0)!=0?(t[(t[O>>2]|0)+24>>2]|0)!=0:0)sv(t[f>>2]|0,1717,t[v>>2]|0,t[(t[v>>2]|0)+20>>2]|0,147440,0)}if(!(t[h>>2]|0))t[h>>2]=t[g>>2];if(t[h>>2]|0){if(!(t[m>>2]|0))t[m>>2]=t[A>>2];if(t[m>>2]|0){t[L>>2]=BD(t[(t[h>>2]|0)+32>>2]|0,t[(t[m>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[h>>2]|0,t[m>>2]|0,1,1,0)}if(!(t[v>>2]|0))t[v>>2]=t[O>>2];if(t[v>>2]|0){t[L>>2]=BD(t[(t[h>>2]|0)+32>>2]|0,t[(t[v>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[h>>2]|0,t[v>>2]|0,-1,1,0)}}if(t[p>>2]|0){if(t[_>>2]|0){t[L>>2]=BD(t[(t[p>>2]|0)+32>>2]|0,t[(t[_>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[p>>2]|0,t[_>>2]|0,1,1,0);
	}if(t[R>>2]|0){t[L>>2]=BD(t[(t[p>>2]|0)+32>>2]|0,t[(t[R>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[p>>2]|0,t[R>>2]|0,-1,1,1);if((t[L>>2]|0)!=0?(t[(t[R>>2]|0)+24>>2]|0)!=0:0)sv(t[f>>2]|0,1717,t[p>>2]|0,t[(t[p>>2]|0)+20>>2]|0,147440,0)}if(t[T>>2]|0){t[L>>2]=BD(t[(t[p>>2]|0)+32>>2]|0,t[(t[T>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)!=-1)bL(t[f>>2]|0,t[p>>2]|0,t[T>>2]|0,-1,0,1)}if(t[M>>2]|0){t[L>>2]=BD(t[(t[p>>2]|0)+32>>2]|0,t[(t[M>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[p>>2]|0,t[M>>2]|0,1,1,1)}if(t[N>>2]|0){t[L>>2]=BD(t[(t[p>>2]|0)+32>>2]|0,t[(t[N>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break;if((t[L>>2]|0)!=1)bL(t[f>>2]|0,t[p>>2]|0,t[N>>2]|0,1,0,1)}}do if(t[S>>2]|0){if(t[E>>2]|0){t[L>>2]=BD(t[(t[S>>2]|0)+32>>2]|0,t[(t[E>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[S>>2]|0,t[E>>2]|0,1,1,0)}do if(t[T>>2]|0){t[L>>2]=BD(t[(t[S>>2]|0)+32>>2]|0,t[(t[T>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[S>>2]|0,t[T>>2]|0,-1,1,1);if(t[L>>2]|0){if(!(t[(t[T>>2]|0)+24>>2]|0))break;sv(t[f>>2]|0,1717,t[S>>2]|0,t[(t[S>>2]|0)+20>>2]|0,147440,0)}}while(0);if(t[R>>2]|0){t[L>>2]=BD(t[(t[S>>2]|0)+32>>2]|0,t[(t[R>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[S>>2]|0,t[R>>2]|0,-1,1,1)}do if(t[M>>2]|0){t[L>>2]=BD(t[(t[S>>2]|0)+32>>2]|0,t[(t[M>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)break;bL(t[f>>2]|0,t[S>>2]|0,t[M>>2]|0,1,0,1)}while(0);if(t[N>>2]|0){t[L>>2]=BD(t[(t[S>>2]|0)+32>>2]|0,t[(t[N>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)break;bL(t[f>>2]|0,t[S>>2]|0,t[N>>2]|0,1,0,1)}}while(0);do if(t[E>>2]|0){if(t[p>>2]|0){t[L>>2]=BD(t[(t[E>>2]|0)+32>>2]|0,t[(t[p>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)!=-1)bL(t[f>>2]|0,t[E>>2]|0,t[p>>2]|0,-1,0,0)}do if(t[N>>2]|0){t[L>>2]=BD(t[(t[E>>2]|0)+32>>2]|0,t[(t[N>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[E>>2]|0,t[N>>2]|0,1,1,1);if(!(t[L>>2]|0))break;if(!(t[(t[N>>2]|0)+24>>2]|0))break;sv(t[f>>2]|0,1717,t[E>>2]|0,t[(t[E>>2]|0)+20>>2]|0,147440,0)}while(0);do if(t[R>>2]|0){t[L>>2]=BD(t[(t[E>>2]|0)+32>>2]|0,t[(t[R>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)!=1)break;bL(t[f>>2]|0,t[E>>2]|0,t[R>>2]|0,-1,1,1)}while(0);do if(t[M>>2]|0){t[L>>2]=BD(t[(t[E>>2]|0)+32>>2]|0,t[(t[M>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)!=-1)break;bL(t[f>>2]|0,t[E>>2]|0,t[M>>2]|0,1,1,1)}while(0);if(t[T>>2]|0){t[L>>2]=BD(t[(t[E>>2]|0)+32>>2]|0,t[(t[T>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==-1)break;bL(t[f>>2]|0,t[E>>2]|0,t[T>>2]|0,-1,0,1)}}while(0);do if(t[_>>2]|0){if(t[S>>2]|0){t[L>>2]=BD(t[(t[_>>2]|0)+32>>2]|0,t[(t[S>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)!=-1)bL(t[f>>2]|0,t[_>>2]|0,t[S>>2]|0,-1,0,0)}do if(t[M>>2]|0){t[L>>2]=BD(t[(t[_>>2]|0)+32>>2]|0,t[(t[M>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==-1)bL(t[f>>2]|0,t[_>>2]|0,t[M>>2]|0,1,1,1);if(!(t[L>>2]|0))break;if(!(t[(t[M>>2]|0)+24>>2]|0))break;sv(t[f>>2]|0,1717,t[_>>2]|0,t[(t[_>>2]|0)+20>>2]|0,147440,0)}while(0);do if(t[R>>2]|0){t[L>>2]=BD(t[(t[_>>2]|0)+32>>2]|0,t[(t[R>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)!=1)break;bL(t[f>>2]|0,t[_>>2]|0,t[R>>2]|0,-1,1,1)}while(0);do if(t[N>>2]|0){t[L>>2]=BD(t[(t[_>>2]|0)+32>>2]|0,t[(t[N>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)break;bL(t[f>>2]|0,t[_>>2]|0,t[N>>2]|0,1,0,1)}while(0);if(!(t[T>>2]|0))break;t[L>>2]=BD(t[(t[_>>2]|0)+32>>2]|0,t[(t[T>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==-1)break;bL(t[f>>2]|0,t[_>>2]|0,t[T>>2]|0,-1,0,1)}while(0);do if((t[w>>2]|0)!=0&(t[y>>2]|0)!=0){t[L>>2]=BD(t[(t[w>>2]|0)+32>>2]|0,t[(t[y>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[w>>2]|0,t[y>>2]|0,-1,1,1);if(t[L>>2]|0){if(!(t[(t[y>>2]|0)+24>>2]|0))break;sv(t[f>>2]|0,1717,t[w>>2]|0,t[(t[w>>2]|0)+20>>2]|0,147440,0)}}while(0);do if((t[d>>2]|0)!=0&(t[F>>2]|0)!=0){t[L>>2]=BD(t[(t[d>>2]|0)+32>>2]|0,t[(t[F>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)==1)bL(t[f>>2]|0,t[d>>2]|0,t[F>>2]|0,-1,1,1);if(!(t[L>>2]|0))break;if(!(t[(t[F>>2]|0)+24>>2]|0))break;sv(t[f>>2]|0,1717,t[d>>2]|0,t[(t[d>>2]|0)+20>>2]|0,147440,0)}while(0);if(!(t[w>>2]|0))t[w>>2]=t[y>>2];if(!(t[d>>2]|0))t[d>>2]=t[F>>2];do if((t[w>>2]|0)!=0&(t[d>>2]|0)!=0){t[L>>2]=BD(t[(t[d>>2]|0)+32>>2]|0,t[(t[w>>2]|0)+32>>2]|0)|0;if((t[L>>2]|0)==-2)break e;if((t[L>>2]|0)!=1)break;bL(t[f>>2]|0,t[d>>2]|0,t[w>>2]|0,-1,1,0)}while(0);t[c>>2]=t[(t[a>>2]|0)+96>>2];i:while(1){if(!(t[c>>2]|0)){B=216;break}t[k>>2]=t[(t[c>>2]|0)+4>>2];do if((t[t[k>>2]>>2]|0)!=1006){if((t[t[k>>2]>>2]|0)==1007)break;t[o>>2]=t[(t[u>>2]|0)+96>>2];while(1){if(!(t[o>>2]|0))break;t[b>>2]=t[(t[o>>2]|0)+4>>2];if((t[t[b>>2]>>2]|0)==(t[t[k>>2]>>2]|0)){B=201;break}t[o>>2]=t[t[o>>2]>>2]}do if((B|0)==201){B=0;if((t[t[b>>2]>>2]|0)!=1008)break;if((t[(t[b>>2]|0)+28>>2]|0)<(t[(t[k>>2]|0)+28>>2]|0))sv(t[f>>2]|0,1717,t[b>>2]|0,t[(t[b>>2]|0)+20>>2]|0,147512,0);if(!(t[(t[k>>2]|0)+24>>2]|0))break;if((t[(t[b>>2]|0)+28>>2]|0)==(t[(t[k>>2]|0)+28>>2]|0))break;sv(t[f>>2]|0,1717,t[b>>2]|0,t[(t[b>>2]|0)+20>>2]|0,147440,0)}while(0);if(t[o>>2]|0)break;t[o>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[o>>2]|0)){B=210;break i}t[(t[o>>2]|0)+4>>2]=t[(t[c>>2]|0)+4>>2];t[t[o>>2]>>2]=0;i=t[o>>2]|0;if(!(t[l>>2]|0))t[(t[u>>2]|0)+96>>2]=i;else t[t[l>>2]>>2]=i;t[l>>2]=t[o>>2]}while(0);t[c>>2]=t[t[c>>2]>>2]}if((B|0)==210){Qh(t[f>>2]|0,147616,0);t[n>>2]=-1;D=t[n>>2]|0;s=r;return D|0}else if((B|0)==216){t[n>>2]=0;D=t[n>>2]|0;s=r;return D|0}}while(0);rh(t[f>>2]|0,147656,147696);t[n>>2]=-1;D=t[n>>2]|0;s=r;return D|0}function Ev(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;e=(t[n>>2]|0)+48|0;a=t[e>>2]|0;if(t[(t[n>>2]|0)+48>>2]&64){t[e>>2]=a|67108864;t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if(a&128){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}e:do if(t[(t[n>>2]|0)+96>>2]|0){t[f>>2]=t[(t[n>>2]|0)+96>>2];while(1){if(!(t[f>>2]|0))break e;c=t[f>>2]|0;if((t[t[(t[f>>2]|0)+4>>2]>>2]|0)==1008)break;t[f>>2]=t[c>>2]}a=t[(t[c+4>>2]|0)+28>>2]|0;if((a|0)==2){e=(t[n>>2]|0)+48|0;t[e>>2]=t[e>>2]|33554432}else if((a|0)==1){e=(t[n>>2]|0)+48|0;t[e>>2]=t[e>>2]|16777216}else if((a|0)==3){a=(t[n>>2]|0)+48|0;t[a>>2]=t[a>>2]|67108864}else{t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}while(0);t[u>>2]=t[(t[n>>2]|0)+64>>2];while(1){if(!(t[u>>2]|0))break;if((t[(t[u>>2]|0)+88>>2]|0)==45)break;l=t[u>>2]|0;if((t[t[u>>2]>>2]|0)==1){b=20;break}t[u>>2]=t[l+64>>2]}do if((b|0)==20){if((t[l+88>>2]|0)==2){c=(t[n>>2]|0)+48|0;t[c>>2]=t[c>>2]|33554432;break}if((t[(t[u>>2]|0)+88>>2]|0)!=1?(t[(t[u>>2]|0)+88>>2]|0)!=46:0){c=(t[n>>2]|0)+48|0;t[c>>2]=t[c>>2]|67108864;break}c=(t[n>>2]|0)+48|0;t[c>>2]=t[c>>2]|16777216}while(0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}function Sv(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;o=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;t[u>>2]=0;t[n>>2]=(t[(t[(t[r>>2]|0)+64>>2]|0)+48>>2]&134217728|0)!=0?1:0;if(t[n>>2]|0){t[f>>2]=(t[(t[(t[r>>2]|0)+64>>2]|0)+48>>2]&2097152|0)!=0?1:0;t[u>>2]=(t[(t[(t[r>>2]|0)+64>>2]|0)+48>>2]&268435456|0)!=0?1:0}e:do if(t[(t[r>>2]|0)+68>>2]|0){t[a>>2]=t[(t[r>>2]|0)+68>>2];while(1){if(!(t[a>>2]|0))break e;e=t[t[a>>2]>>2]|0;if((e|0)==1007){t[f>>2]=1;t[u>>2]=1;t[n>>2]=1}else if((e|0)==1006){t[u>>2]=1;t[n>>2]=1}else if((e|0)!=1008)t[n>>2]=1;t[a>>2]=t[(t[a>>2]|0)+4>>2]}}while(0);if(t[u>>2]|0){u=(t[r>>2]|0)+48|0;t[u>>2]=t[u>>2]|268435456}if(t[f>>2]|0){u=(t[r>>2]|0)+48|0;t[u>>2]=t[u>>2]|2097152}if(t[n>>2]|0){u=(t[r>>2]|0)+48|0;t[u>>2]=t[u>>2]|134217728}if((t[n>>2]|0)==0|(t[f>>2]|0)!=0){s=i;return}if(!(t[(t[r>>2]|0)+48>>2]&256)){s=i;return}t[o>>2]=yd(t[r>>2]|0)|0;if((t[(t[o>>2]|0)+88>>2]|0)==46){s=i;return}if((t[(t[o>>2]|0)+88>>2]|0)==1){s=i;return}o=(t[r>>2]|0)+48|0;t[o>>2]=t[o>>2]|2097152;s=i;return}function gv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(!(t[f>>2]|0))t[n>>2]=0;else{if((t[t[f>>2]>>2]|0)!=5?(t[(t[f>>2]|0)+88>>2]|0)!=45:0){i=t[f>>2]|0;if((t[t[f>>2]>>2]|0)!=1){t[n>>2]=gv(t[i+28>>2]|0,t[u>>2]|0)|0;break}if((t[i+88>>2]|0)==(t[u>>2]|0)){t[n>>2]=1;break}if((t[(t[f>>2]|0)+88>>2]|0)!=46?(t[(t[f>>2]|0)+88>>2]|0)!=45:0){t[n>>2]=gv(t[(t[f>>2]|0)+28>>2]|0,t[u>>2]|0)|0;break}t[n>>2]=0;break}t[n>>2]=0}while(0);s=r;return t[n>>2]|0}function yv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[t[f>>2]>>2]|0)!=0?(t[u>>2]|0)<(t[(t[f>>2]|0)+4>>2]|0):0){do if((t[(t[f>>2]|0)+4>>2]|0)==1){pAi[t[135736>>2]&511](t[t[f>>2]>>2]|0);t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=0}else{if(((t[(t[f>>2]|0)+4>>2]|0)-1|0)==(t[u>>2]|0)){i=(t[f>>2]|0)+4|0;t[i>>2]=(t[i>>2]|0)+-1;break}t[a>>2]=t[u>>2];while(1){if((t[a>>2]|0)>=((t[(t[f>>2]|0)+4>>2]|0)-1|0))break;t[(t[t[f>>2]>>2]|0)+(t[a>>2]<<2)>>2]=t[(t[t[f>>2]>>2]|0)+((t[a>>2]|0)+1<<2)>>2];t[a>>2]=(t[a>>2]|0)+1}i=(t[f>>2]|0)+4|0;t[i>>2]=(t[i>>2]|0)+-1}while(0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}kL(152576);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}function Fv(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0;c=s;s=s+112|0;l=c+108|0;b=c+104|0;k=c+100|0;h=c+96|0;w=c+92|0;d=c+88|0;v=c+84|0;m=c+80|0;_=c+76|0;p=c+72|0;E=c+68|0;S=c+64|0;g=c+60|0;y=c+56|0;F=c+52|0;O=c+48|0;A=c+44|0;M=c+40|0;R=c+36|0;N=c+32|0;T=c+28|0;L=c+24|0;D=c+20|0;C=c+16|0;P=c+12|0;B=c+8|0;I=c+4|0;H=c;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=0;e:do if(t[d>>2]|0){t[S>>2]=0;while(1){if((t[S>>2]|0)>=(t[(t[d>>2]|0)+4>>2]|0))break e;t[p>>2]=t[(t[t[d>>2]>>2]|0)+(t[S>>2]<<2)>>2];t[y>>2]=0;i:do if(t[v>>2]|0){t[g>>2]=0;while(1){if((t[g>>2]|0)>=(t[(t[v>>2]|0)+4>>2]|0))break i;t[E>>2]=t[(t[t[v>>2]>>2]|0)+(t[g>>2]<<2)>>2];if((t[(t[(t[p>>2]|0)+12>>2]|0)+8>>2]|0)==(t[(t[(t[E>>2]|0)+12>>2]|0)+8>>2]|0)?(t[(t[(t[p>>2]|0)+12>>2]|0)+56>>2]|0)==(t[(t[(t[E>>2]|0)+12>>2]|0)+56>>2]|0):0)break;t[g>>2]=(t[g>>2]|0)+1}t[y>>2]=1;if((t[(t[p>>2]|0)+24>>2]|0)==2?(t[(t[E>>2]|0)+24>>2]|0)==1:0){t[A>>2]=0;o=t[b>>2]|0;a=lw(t[h>>2]|0)|0;u=t[h>>2]|0;f=t[p>>2]|0;n=(t[k>>2]|0)==0?151424:151432;hL(o,1788,a,u,f,151312,n,Nd(A,t[w>>2]|0)|0,0,0);if(!(t[A>>2]|0))break;pAi[t[135736>>2]&511](t[A>>2]|0);t[A>>2]=0;break}if(!(lL(t[b>>2]|0,t[(t[(t[p>>2]|0)+12>>2]|0)+48>>2]|0,t[(t[(t[E>>2]|0)+12>>2]|0)+48>>2]|0,0)|0)){wL(t[E>>2]|0,O,F,0)|0;if(!((t[F>>2]|0)!=0&(t[O>>2]|0)==1))break;t[T>>2]=0;wL(t[E>>2]|0,O,T,0)|0;if((t[O>>2]|0)!=0?(t[T>>2]|0)==(t[F>>2]|0):0)break;t[L>>2]=0;n=t[b>>2]|0;f=lw(t[h>>2]|0)|0;u=t[h>>2]|0;a=t[p>>2]|0;o=(t[k>>2]|0)==0?151424:151432;hL(n,3077,f,u,a,151576,o,Nd(L,t[w>>2]|0)|0,0,0);if(!(t[L>>2]|0))break;pAi[t[135736>>2]&511](t[L>>2]|0);t[L>>2]=0;break}t[M>>2]=0;t[R>>2]=0;t[N>>2]=0;o=t[b>>2]|0;a=lw(t[h>>2]|0)|0;u=t[h>>2]|0;f=t[p>>2]|0;n=Nd(M,t[(t[(t[p>>2]|0)+12>>2]|0)+48>>2]|0)|0;r=Nd(R,t[(t[(t[E>>2]|0)+12>>2]|0)+48>>2]|0)|0;i=(t[k>>2]|0)==0?151424:151432;hL(o,1789,a,u,f,151448,n,r,i,Nd(N,t[w>>2]|0)|0);if(t[M>>2]|0){pAi[t[135736>>2]&511](t[M>>2]|0);t[M>>2]=0}if(t[R>>2]|0){pAi[t[135736>>2]&511](t[R>>2]|0);t[R>>2]=0}if(t[N>>2]|0){pAi[t[135736>>2]&511](t[N>>2]|0);t[N>>2]=0}}while(0);do if(!(t[y>>2]|0)){if((t[_>>2]|0)!=0?(dL(t[_>>2]|0,t[(t[(t[p>>2]|0)+12>>2]|0)+56>>2]|0)|0)==0:0)break;t[D>>2]=0;i=t[b>>2]|0;r=lw(t[h>>2]|0)|0;n=t[h>>2]|0;f=t[p>>2]|0;u=(t[k>>2]|0)==0?151424:151432;hL(i,1790,r,n,f,151680,u,Nd(D,t[w>>2]|0)|0,0,0);if(t[D>>2]|0){pAi[t[135736>>2]&511](t[D>>2]|0);t[D>>2]=0}}while(0);t[S>>2]=(t[S>>2]|0)+1}}while(0);e:do if(t[v>>2]|0){t[g>>2]=0;while(1){if((t[g>>2]|0)>=(t[(t[v>>2]|0)+4>>2]|0))break e;t[E>>2]=t[(t[t[v>>2]>>2]|0)+(t[g>>2]<<2)>>2];if((t[(t[E>>2]|0)+24>>2]|0)==1){t[y>>2]=0;i:do if(t[d>>2]|0){t[S>>2]=0;while(1){if((t[S>>2]|0)>=(t[(t[d>>2]|0)+4>>2]|0))break i;t[p>>2]=t[(t[t[d>>2]>>2]|0)+(t[S>>2]<<2)>>2];if((t[(t[(t[p>>2]|0)+12>>2]|0)+8>>2]|0)==(t[(t[(t[E>>2]|0)+12>>2]|0)+8>>2]|0)?(t[(t[(t[p>>2]|0)+12>>2]|0)+56>>2]|0)==(t[(t[(t[E>>2]|0)+12>>2]|0)+56>>2]|0):0)break;t[S>>2]=(t[S>>2]|0)+1}t[y>>2]=1}while(0);if(!(t[y>>2]|0)){t[C>>2]=0;t[P>>2]=0;D=t[b>>2]|0;N=t[h>>2]|0;R=Nd(C,t[E>>2]|0)|0;M=(t[k>>2]|0)==0?151424:151432;ah(D,1791,0,N,151760,R,M,Nd(P,t[w>>2]|0)|0,0);if(t[C>>2]|0){pAi[t[135736>>2]&511](t[C>>2]|0);t[C>>2]=0}if(t[P>>2]|0){pAi[t[135736>>2]&511](t[P>>2]|0);t[P>>2]=0}}}t[g>>2]=(t[g>>2]|0)+1}}while(0);do if(t[m>>2]|0){if(!(t[_>>2]|0)){t[B>>2]=0;g=t[b>>2]|0;P=t[h>>2]|0;C=vd(t[h>>2]|0)|0;E=(t[k>>2]|0)==0?151424:151432;y=vd(t[w>>2]|0)|0;ah(g,1797,0,P,151832,C,E,y,Rd(B,t[w>>2]|0)|0);if(t[B>>2]|0){pAi[t[135736>>2]&511](t[B>>2]|0);t[B>>2]=0}t[l>>2]=t[(t[b>>2]|0)+16>>2];x=t[l>>2]|0;s=c;return x|0}if((t[(t[_>>2]|0)+28>>2]|0)==0?(vL(t[m>>2]|0,t[_>>2]|0)|0)!=0:0){t[I>>2]=0;y=t[b>>2]|0;E=t[h>>2]|0;C=(t[k>>2]|0)==0?151424:151432;P=vd(t[w>>2]|0)|0;ah(y,1798,0,E,151904,C,P,Rd(I,t[w>>2]|0)|0,0);if(t[I>>2]|0){pAi[t[135736>>2]&511](t[I>>2]|0);t[I>>2]=0}t[l>>2]=t[(t[b>>2]|0)+16>>2];x=t[l>>2]|0;s=c;return x|0}if((t[t[w>>2]>>2]|0)==1?(t[(t[w>>2]|0)+88>>2]|0)==45:0)break;if((t[(t[m>>2]|0)+24>>2]|0)<(t[(t[_>>2]|0)+24>>2]|0)){t[H>>2]=0;P=t[b>>2]|0;C=t[w>>2]|0;E=(t[k>>2]|0)==0?151424:151432;y=vd(t[w>>2]|0)|0;ah(P,1799,0,C,151984,E,y,Rd(H,t[w>>2]|0)|0,0);if(t[H>>2]|0){pAi[t[135736>>2]&511](t[H>>2]|0);t[H>>2]=0}t[l>>2]=t[(t[b>>2]|0)+16>>2];x=t[l>>2]|0;s=c;return x|0}}while(0);t[l>>2]=0;x=t[l>>2]|0;s=c;return x|0}function Ov(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[a>>2]=t[(t[u>>2]|0)+64>>2];if((t[(t[u>>2]|0)+52>>2]|0)!=4?(t[(t[u>>2]|0)+52>>2]|0)!=6:0){if((t[t[a>>2]>>2]|0)!=5?(t[(t[a>>2]|0)+88>>2]|0)!=45:0){t[c>>2]=0;i=t[f>>2]|0;e=t[u>>2]|0;h=t[(t[u>>2]|0)+36>>2]|0;sv(i,3076,e,h,153352,uh(c,t[(t[a>>2]|0)+112>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0);if(t[c>>2]|0){pAi[t[135736>>2]&511](t[c>>2]|0);t[c>>2]=0}t[n>>2]=3076;w=t[n>>2]|0;s=r;return w|0}}else{do if((t[t[a>>2]>>2]|0)!=4){if((t[t[a>>2]>>2]|0)==1?(t[(t[a>>2]|0)+88>>2]|0)!=45:0){d=11;break}if((t[(t[a>>2]|0)+52>>2]|0)!=4?(t[(t[a>>2]|0)+52>>2]|0)!=6:0){if((t[(t[a>>2]|0)+52>>2]|0)==3?(t[(t[u>>2]|0)+48>>2]&4|0)!=0:0){if(!(mL(t[(t[a>>2]|0)+28>>2]|0)|0)){t[o>>2]=3076;break}if(t[(t[u>>2]|0)+104>>2]|0)break;t[b>>2]=0;c=t[f>>2]|0;h=t[u>>2]|0;sv(c,3076,h,0,153664,uh(b,t[(t[a>>2]|0)+112>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0);if(t[b>>2]|0){pAi[t[135736>>2]&511](t[b>>2]|0);t[b>>2]=0}t[n>>2]=3076;w=t[n>>2]|0;s=r;return w|0}t[o>>2]=3076;break}if(!(t[(t[a>>2]|0)+104>>2]|0)){sv(t[f>>2]|0,3069,t[u>>2]|0,0,153584,t[(t[u>>2]|0)+8>>2]|0);t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}}else d=11;while(0);if((d|0)==11?(t[(t[u>>2]|0)+48>>2]&2|0)==0:0){t[l>>2]=0;d=t[f>>2]|0;b=t[u>>2]|0;sv(d,3076,b,0,153464,uh(l,t[(t[a>>2]|0)+112>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0);if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}t[n>>2]=3076;w=t[n>>2]|0;s=r;return w|0}if((t[o>>2]|0)>0){t[k>>2]=0;l=(t[(t[u>>2]|0)+48>>2]&4|0)!=0;b=t[f>>2]|0;f=t[u>>2]|0;u=uh(k,t[(t[a>>2]|0)+112>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if(l)sv(b,3076,f,0,153800,u);else sv(b,3076,f,0,153984,u);if(t[k>>2]|0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}}}t[n>>2]=t[o>>2];w=t[n>>2]|0;s=r;return w|0}function Av(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+24|0;k=o+20|0;h=o+16|0;w=o+12|0;d=o+8|0;v=o+4|0;m=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=0;if((t[l>>2]|0)==0|(t[b>>2]|0)==0){t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}t[m>>2]=gAi[t[135744>>2]&511](120)|0;if(!(t[m>>2]|0)){Qh(t[l>>2]|0,153304,0);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}b=(t[m>>2]|0)+0|0;a=b+120|0;do{t[b>>2]=0;b=b+4|0}while((b|0)<(a|0));t[t[m>>2]>>2]=t[k>>2];t[(t[m>>2]|0)+8>>2]=t[h>>2];t[(t[m>>2]|0)+112>>2]=t[w>>2];t[(t[m>>2]|0)+36>>2]=t[d>>2];d=t[l>>2]|0;if(t[v>>2]|0){do if(t[d+100>>2]|0){v=_L(t[l>>2]|0,t[(t[l>>2]|0)+116>>2]|0,t[m>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;t[(t[l>>2]|0)+120>>2]=v;if(t[(t[l>>2]|0)+120>>2]|0){t[(t[l>>2]|0)+124>>2]=0;break}pAi[t[135736>>2]&511](t[m>>2]|0);t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}while(0);qT((t[(t[(t[l>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,t[m>>2]|0)|0}else qT((t[(t[d+28>>2]|0)+16>>2]|0)+48|0,10,t[m>>2]|0)|0;qT((t[(t[l>>2]|0)+28>>2]|0)+20|0,10,t[m>>2]|0)|0;t[c>>2]=t[m>>2];_=t[c>>2]|0;s=o;return _|0}function Mv(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if(!(t[a>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[b>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[b>>2]|0)){Qh(t[a>>2]|0,153120,0);t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}else{t[t[b>>2]>>2]=25;t[(t[b>>2]|0)+4>>2]=0;t[(t[b>>2]|0)+24>>2]=t[o>>2];t[(t[b>>2]|0)+16>>2]=t[c>>2];t[(t[b>>2]|0)+20>>2]=t[l>>2];t[(t[b>>2]|0)+8>>2]=0;t[(t[b>>2]|0)+12>>2]=0;qT((t[(t[(t[a>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,t[b>>2]|0)|0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}return 0}function Rv(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[b>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[b>>2]|0)){Qh(t[a>>2]|0,153080,0);t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}o=t[b>>2]|0;t[o+0>>2]=0;t[o+4>>2]=0;t[o+8>>2]=0;t[o+12>>2]=0;t[o+16>>2]=0;t[t[b>>2]>>2]=t[c>>2];t[(t[b>>2]|0)+16>>2]=t[l>>2];qT((t[(t[(t[a>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,t[b>>2]|0)|0;if((t[c>>2]|0)==6|(t[c>>2]|0)==7)qT((t[(t[a>>2]|0)+28>>2]|0)+20|0,10,t[b>>2]|0)|0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}function Nv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;r=s;s=s+64|0;n=r+48|0;f=r+44|0;u=r+40|0;a=r+36|0;o=r+32|0;c=r+28|0;l=r+24|0;b=r+20|0;k=r+16|0;h=r+12|0;w=r+8|0;d=r+4|0;v=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[b>>2]=0;if(!(t[(t[u>>2]|0)+64>>2]|0)){rh(t[f>>2]|0,152632,152664);t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}t[a>>2]=t[(t[u>>2]|0)+64>>2];if(((t[t[a>>2]>>2]|0)!=1?(t[(t[a>>2]|0)+48>>2]&4194304|0)==0:0)?(wv(t[a>>2]|0,t[f>>2]|0)|0)==-1:0){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}t[c>>2]=t[(t[u>>2]|0)+116>>2];t[l>>2]=t[(t[a>>2]|0)+116>>2];do if(t[c>>2]|0){i=t[f>>2]|0;e=t[u>>2]|0;_=(t[u>>2]|0)+84|0;p=t[c>>2]|0;if(!(t[(t[u>>2]|0)+48>>2]&4)){if((kv(i,e,_,p,0)|0)!=-1)break;rh(t[f>>2]|0,152632,152680);break}if((kv(i,e,_,p,t[(t[f>>2]|0)+128>>2]|0)|0)==-1)rh(t[f>>2]|0,152632,152680);if(t[(t[(t[f>>2]|0)+128>>2]|0)+4>>2]|0)t[b>>2]=t[(t[f>>2]|0)+128>>2]}while(0);e:do if(t[l>>2]|0){if(!(t[(t[u>>2]|0)+48>>2]&4)){t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[(t[l>>2]|0)+4>>2]|0)){E=45;break e}t[o>>2]=t[(t[t[l>>2]>>2]|0)+(t[k>>2]<<2)>>2];if(!(t[c>>2]|0)){p=hh()|0;t[(t[u>>2]|0)+116>>2]=p;if(!(t[(t[u>>2]|0)+116>>2]|0))break e;t[c>>2]=t[(t[u>>2]|0)+116>>2]}rL(t[c>>2]|0,t[(t[l>>2]|0)+4>>2]|0,t[o>>2]|0)|0;t[k>>2]=(t[k>>2]|0)+1}}if(t[c>>2]|0)t[d>>2]=t[(t[c>>2]|0)+4>>2];else t[d>>2]=0;t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[(t[l>>2]|0)+4>>2]|0)){E=45;break e}t[o>>2]=t[(t[t[l>>2]>>2]|0)+(t[k>>2]<<2)>>2];i:do if(t[b>>2]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[(t[b>>2]|0)+4>>2]|0)){E=28;break i}t[w>>2]=t[(t[t[b>>2]>>2]|0)+(t[h>>2]<<2)>>2];if((t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]|0)==(t[(t[w>>2]|0)+8>>2]|0)?(t[(t[(t[o>>2]|0)+12>>2]|0)+56>>2]|0)==(t[(t[w>>2]|0)+12>>2]|0):0)break i;t[h>>2]=(t[h>>2]|0)+1}}else E=28;while(0);i:do if((E|0)==28){E=0;r:do if(t[d>>2]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[d>>2]|0))break r;t[v>>2]=t[(t[t[c>>2]>>2]|0)+(t[h>>2]<<2)>>2];if((t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]|0)==(t[(t[(t[v>>2]|0)+12>>2]|0)+8>>2]|0)?(t[(t[(t[o>>2]|0)+12>>2]|0)+56>>2]|0)==(t[(t[(t[v>>2]|0)+12>>2]|0)+56>>2]|0):0)break i;t[h>>2]=(t[h>>2]|0)+1}}while(0);if(!(t[c>>2]|0)){p=hh()|0;t[(t[u>>2]|0)+116>>2]=p;if(!(t[(t[u>>2]|0)+116>>2]|0))break e;t[c>>2]=t[(t[u>>2]|0)+116>>2]}rL(t[c>>2]|0,2,t[o>>2]|0)|0}while(0);t[k>>2]=(t[k>>2]|0)+1}}else E=45;while(0);e:do if((E|0)==45){if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==0:0){Wk(t[c>>2]|0);t[(t[u>>2]|0)+116>>2]=0}do if((t[(t[u>>2]|0)+48>>2]&2|0)!=0?(t[(t[a>>2]|0)+84>>2]|0)!=0:0)if(t[(t[u>>2]|0)+84>>2]|0)if((pL(t[f>>2]|0,t[(t[u>>2]|0)+84>>2]|0,t[(t[a>>2]|0)+84>>2]|0)|0)==-1)break e;else break;else{t[(t[u>>2]|0)+84>>2]=t[(t[a>>2]|0)+84>>2];break}while(0);t[n>>2]=0;m=t[n>>2]|0;s=r;return m|0}while(0);t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}function Tv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=EL(t[f>>2]|0,t[u>>2]|0)|0;if(t[a>>2]|0){t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}i=t[f>>2]|0;f=t[u>>2]|0;if(t[(t[u>>2]|0)+48>>2]&2)t[a>>2]=SL(i,f)|0;else t[a>>2]=gL(i,f)|0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Lv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;r=s;s=s+64|0;n=r+56|0;f=r+52|0;u=r+48|0;a=r+44|0;o=r+40|0;c=r+36|0;l=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+12|0;v=r+8|0;m=r+4|0;_=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=t[(t[u>>2]|0)+28>>2];if(t[(t[u>>2]|0)+80>>2]|0){t[c>>2]=t[(t[u>>2]|0)+80>>2];Zw(t[c>>2]|0,t[f>>2]|0);if(!(t[(t[u>>2]|0)+48>>2]&2)){sv(t[f>>2]|0,3046,t[u>>2]|0,0,158528,0);t[a>>2]=3046}i=t[c>>2]|0;do if((t[c>>2]|0)!=(t[u>>2]|0))if(t[i+80>>2]|0){t[l>>2]=yL(t[c>>2]|0,t[c>>2]|0)|0;break}else{t[l>>2]=0;break}else t[l>>2]=i;while(0);if(t[l>>2]|0){t[b>>2]=0;t[k>>2]=0;i=t[f>>2]|0;e=t[l>>2]|0;p=Rd(b,t[l>>2]|0)|0;iL(i,3049,e,0,158608,p,Rd(k,t[c>>2]|0)|0,0);if(t[b>>2]|0){pAi[t[135736>>2]&511](t[b>>2]|0);t[b>>2]=0}if(t[k>>2]|0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}t[a>>2]=3049}if((t[o>>2]|0)!=(t[(t[(t[u>>2]|0)+80>>2]|0)+28>>2]|0)){t[h>>2]=0;if(t[(t[c>>2]|0)+48>>2]&32768)t[h>>2]=t[h>>2]|2;if(t[(t[c>>2]|0)+48>>2]&65536)t[h>>2]=t[h>>2]|1;if(FL(t[f>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+28>>2]|0,t[h>>2]|0)|0){t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;t[a>>2]=3047;h=t[f>>2]|0;k=t[u>>2]|0;b=Rd(w,t[o>>2]|0)|0;p=Rd(d,t[c>>2]|0)|0;iL(h,3047,k,0,158704,b,p,Rd(v,t[(t[c>>2]|0)+28>>2]|0)|0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}if(t[d>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0}if(t[v>>2]|0){pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0}}}}do if(t[(t[u>>2]|0)+76>>2]|0){if((t[t[o>>2]>>2]|0)!=4)if((t[t[o>>2]>>2]|0)==1?(t[(t[o>>2]|0)+88>>2]|0)!=45:0)E=31;else E=32;else E=31;if((E|0)==31?(gv(t[o>>2]|0,23)|0)==0:0)E=32;if((E|0)==32){if((t[t[o>>2]>>2]|0)!=5?(t[(t[o>>2]|0)+88>>2]|0)!=45:0){E=38;break}if((t[(t[o>>2]|0)+52>>2]|0)!=4?(t[(t[o>>2]|0)+52>>2]|0)!=6:0){E=38;break}if(!(gv(t[(t[o>>2]|0)+104>>2]|0,23)|0)){E=38;break}}t[a>>2]=3048;sv(t[f>>2]|0,3048,t[u>>2]|0,0,158848,0)}else E=38;while(0);if((E|0)==38?(t[(t[u>>2]|0)+76>>2]|0)!=0:0){t[_>>2]=0;if(!(t[o>>2]|0)){pw(t[f>>2]|0,t[(t[u>>2]|0)+36>>2]|0,3069,159008,0,0);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}do if(t[(t[u>>2]|0)+36>>2]|0){E=t[(t[u>>2]|0)+36>>2]|0;if(t[(t[u>>2]|0)+48>>2]&8){t[_>>2]=dF(E,159120)|0;break}else{t[_>>2]=dF(E,159128)|0;break}}while(0);t[m>>2]=OL(t[f>>2]|0,t[_>>2]|0,t[o>>2]|0,t[(t[u>>2]|0)+76>>2]|0,(t[u>>2]|0)+96|0)|0;if(t[m>>2]|0)if((t[m>>2]|0)<0){rh(t[f>>2]|0,159136,159168);t[n>>2]=-1;S=t[n>>2]|0;s=r;return S|0}else{t[n>>2]=t[m>>2];S=t[n>>2]|0;s=r;return S|0}}t[n>>2]=t[a>>2];S=t[n>>2]|0;s=r;return S|0}function Dv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;if(!(t[(t[f>>2]|0)+80>>2]|0)){s=r;return}if(t[(t[f>>2]|0)+48>>2]&16){s=r;return}t[u>>2]=t[(t[f>>2]|0)+80>>2];while(1){if(!(t[u>>2]|0))break;t[c>>2]=0;t[l>>2]=0;do if(!(t[(t[u>>2]|0)+48>>2]&8192)){t[a>>2]=t[(t[u>>2]|0)+28>>2];t[o>>2]=t[(t[f>>2]|0)+28>>2];if((t[a>>2]|0)!=(t[o>>2]|0)){if(t[(t[u>>2]|0)+48>>2]&4096)t[c>>2]=t[c>>2]|524288;if(t[(t[u>>2]|0)+48>>2]&2048)t[c>>2]=t[c>>2]|262144;while(1){if(!(t[o>>2]|0))break;if((t[o>>2]|0)==(t[a>>2]|0))break;if((t[(t[o>>2]|0)+48>>2]&2|0)!=0?(t[l>>2]&524288|0)==0:0)t[l>>2]=t[l>>2]|262144;if((t[(t[o>>2]|0)+48>>2]&4|0)!=0?(t[l>>2]&524288|0)==0:0)t[l>>2]=t[l>>2]|524288;t[o>>2]=t[(t[o>>2]|0)+64>>2]}t[o>>2]=t[(t[(t[f>>2]|0)+28>>2]|0)+64>>2];while(1){if(!(t[o>>2]|0))break;if((t[t[o>>2]>>2]|0)!=5?(t[(t[o>>2]|0)+88>>2]|0)!=45:0)break;if((t[(t[o>>2]|0)+48>>2]&262144|0)!=0?(t[c>>2]&262144|0)==0:0)t[c>>2]=t[c>>2]|262144;if((t[(t[o>>2]|0)+48>>2]&524288|0)!=0?(t[c>>2]&524288|0)==0:0)t[c>>2]=t[c>>2]|524288;if((t[o>>2]|0)==(t[a>>2]|0))break;t[o>>2]=t[(t[o>>2]|0)+64>>2]}if(t[c>>2]|0){if((t[c>>2]&262144|0)!=0?(t[l>>2]&262144|0)!=0:0)break;if((t[c>>2]&524288|0)!=0?(t[l>>2]&524288|0)!=0:0)break}}AL(t[n>>2]|0,t[u>>2]|0,t[f>>2]|0)|0;if(!(t[(t[u>>2]|0)+48>>2]&131072)){i=(t[u>>2]|0)+48|0;t[i>>2]=t[i>>2]|131072}}while(0);t[u>>2]=t[(t[u>>2]|0)+80>>2]}s=r;return}function Cv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0;r=s;s=s+128|0;n=r+124|0;f=r+120|0;u=r+116|0;a=r+112|0;o=r+108|0;c=r+104|0;l=r+100|0;b=r+96|0;k=r+92|0;h=r+88|0;w=r+84|0;d=r+80|0;v=r+76|0;m=r+72|0;_=r+68|0;p=r+64|0;E=r+60|0;S=r+56|0;g=r+52|0;y=r+48|0;F=r+44|0;O=r+40|0;A=r+36|0;M=r+32|0;R=r+28|0;N=r+24|0;T=r+20|0;L=r+16|0;D=r+12|0;C=r+8|0;P=r+4|0;B=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[u>>2]|0)){rh(t[f>>2]|0,158112,158144);t[n>>2]=1;I=t[n>>2]|0;s=r;return I|0}if(!(t[(t[u>>2]|0)+12>>2]|0)){t[n>>2]=1;I=t[n>>2]|0;s=r;return I|0}e:do switch(t[t[(t[u>>2]|0)+12>>2]>>2]|0){case 8:{t[a>>2]=1;t[C>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];if(t[C>>2]|0){t[a>>2]=0;t[L>>2]=t[(t[f>>2]|0)+76>>2];t[D>>2]=kb(t[(t[f>>2]|0)+64>>2]|0)|0;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[D>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=t[D>>2];while(1){if(!(t[C>>2]|0)){H=103;break}t[(t[f>>2]|0)+76>>2]=t[D>>2];t[P>>2]=t[(t[C>>2]|0)+12>>2];if(!(t[P>>2]|0)){H=93;break}do if(!(t[(t[P>>2]|0)+48>>2]&131072)){if((t[(t[C>>2]|0)+16>>2]|0)==1?(t[(t[C>>2]|0)+20>>2]|0)==1:0){bb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[(t[P>>2]|0)+8>>2]|0,t[(t[P>>2]|0)+52>>2]|0,1,1,t[P>>2]|0)|0;break}if((t[(t[C>>2]|0)+16>>2]|0)==0?(t[(t[C>>2]|0)+20>>2]|0)==1:0)sb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[(t[P>>2]|0)+8>>2]|0,t[(t[P>>2]|0)+52>>2]|0,0,1,t[P>>2]|0)|0}else{t[B>>2]=db(t[(t[f>>2]|0)+64>>2]|0,t[(t[C>>2]|0)+16>>2]|0,t[(t[C>>2]|0)+20>>2]|0)|0;RL(t[f>>2]|0,t[C>>2]|0,t[B>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0}while(0);t[C>>2]=t[(t[C>>2]|0)+8>>2]}if((H|0)==93){rh(t[f>>2]|0,158112,158168);t[n>>2]=t[a>>2];I=t[n>>2]|0;s=r;return I|0}else if((H|0)==103){i=wb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,0,0)|0;t[(t[f>>2]|0)+76>>2]=i;if(t[(t[u>>2]|0)+16>>2]|0)break e;hb(t[(t[f>>2]|0)+64>>2]|0,t[L>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0;t[a>>2]=1;break e}}break}case 2:{t[b>>2]=t[(t[u>>2]|0)+12>>2];t[c>>2]=t[(t[f>>2]|0)+76>>2];t[l>>2]=kb(t[(t[f>>2]|0)+64>>2]|0)|0;do if((t[(t[u>>2]|0)+20>>2]|0)==1){if((t[(t[b>>2]|0)+28>>2]|0)==1){i=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,140432,140432,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[l>>2]|0)|0;i=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,140432,0,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[l>>2]|0)|0;break}i=t[b>>2]|0;if(t[(t[b>>2]|0)+32>>2]|0){t[k>>2]=t[i+32>>2];do{t[(t[f>>2]|0)+76>>2]=t[c>>2];e=cb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,0,140432,t[(t[k>>2]|0)+4>>2]|0,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=e;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[l>>2]|0)|0;t[k>>2]=t[t[k>>2]>>2]}while((t[k>>2]|0)!=0)}else{if(!(t[i+36>>2]|0))break;e=lb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,t[l>>2]|0,140432,t[(t[(t[b>>2]|0)+36>>2]|0)+4>>2]|0,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=e;break}}else{if((t[(t[u>>2]|0)+20>>2]|0)==1073741824)x=1073741824;else x=(t[(t[u>>2]|0)+20>>2]|0)-1|0;t[d>>2]=x;if((t[(t[u>>2]|0)+16>>2]|0)<1)U=0;else U=(t[(t[u>>2]|0)+16>>2]|0)-1|0;t[v>>2]=U;t[h>>2]=db(t[(t[f>>2]|0)+64>>2]|0,t[v>>2]|0,t[d>>2]|0)|0;t[w>>2]=kb(t[(t[f>>2]|0)+64>>2]|0)|0;do if((t[(t[b>>2]|0)+28>>2]|0)!=1){e=t[b>>2]|0;if(t[(t[b>>2]|0)+32>>2]|0){t[k>>2]=t[e+32>>2];do{z=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,140432,t[(t[k>>2]|0)+4>>2]|0,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=z;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[w>>2]|0)|0;t[k>>2]=t[t[k>>2]>>2]}while((t[k>>2]|0)!=0)}else{if(!(t[e+36>>2]|0))break;z=lb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,t[w>>2]|0,140432,t[(t[(t[b>>2]|0)+36>>2]|0)+4>>2]|0,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=z;break}}else{z=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,140432,140432,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=z;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[w>>2]|0)|0;z=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,140432,0,t[b>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=z;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[w>>2]|0)|0}while(0);vb(t[(t[f>>2]|0)+64>>2]|0,t[w>>2]|0,t[c>>2]|0,t[h>>2]|0)|0;mb(t[(t[f>>2]|0)+64>>2]|0,t[w>>2]|0,t[l>>2]|0,t[h>>2]|0)|0}while(0);if(!(t[(t[u>>2]|0)+16>>2]|0)){hb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;t[a>>2]=1}t[(t[f>>2]|0)+76>>2]=t[l>>2];break}case 14:{t[a>>2]=ML(t[f>>2]|0,t[u>>2]|0)|0;break}case 17:{t[a>>2]=1;break}case 7:{t[a>>2]=0;t[F>>2]=t[(t[f>>2]|0)+76>>2];t[O>>2]=kb(t[(t[f>>2]|0)+64>>2]|0)|0;i=t[u>>2]|0;i:do if((t[(t[u>>2]|0)+20>>2]|0)!=1){if((t[i+20>>2]|0)==1073741824)j=1073741824;else j=(t[(t[u>>2]|0)+20>>2]|0)-1|0;t[N>>2]=j;if((t[(t[u>>2]|0)+16>>2]|0)<1)V=0;else V=(t[(t[u>>2]|0)+16>>2]|0)-1|0;t[T>>2]=V;t[A>>2]=db(t[(t[f>>2]|0)+64>>2]|0,t[T>>2]|0,t[N>>2]|0)|0;t[M>>2]=kb(t[(t[f>>2]|0)+64>>2]|0)|0;t[R>>2]=kb(t[(t[f>>2]|0)+64>>2]|0)|0;t[y>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];while(1){if(!(t[y>>2]|0))break;t[(t[f>>2]|0)+76>>2]=t[R>>2];t[o>>2]=Cv(t[f>>2]|0,t[y>>2]|0)|0;if((t[o>>2]|0)==1)t[a>>2]=1;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[M>>2]|0)|0;t[y>>2]=t[(t[y>>2]|0)+8>>2]}hb(t[(t[f>>2]|0)+64>>2]|0,t[F>>2]|0,t[R>>2]|0)|0;vb(t[(t[f>>2]|0)+64>>2]|0,t[M>>2]|0,t[R>>2]|0,t[A>>2]|0)|0;mb(t[(t[f>>2]|0)+64>>2]|0,t[M>>2]|0,t[O>>2]|0,t[A>>2]|0)|0;if((t[a>>2]|0)==1)hb(t[(t[f>>2]|0)+64>>2]|0,t[R>>2]|0,t[O>>2]|0)|0}else{t[y>>2]=t[(t[i+12>>2]|0)+12>>2];while(1){if(!(t[y>>2]|0))break i;t[(t[f>>2]|0)+76>>2]=t[F>>2];t[o>>2]=Cv(t[f>>2]|0,t[y>>2]|0)|0;if((t[o>>2]|0)==1)t[a>>2]=1;hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[O>>2]|0)|0;t[y>>2]=t[(t[y>>2]|0)+8>>2]}}while(0);if(!(t[(t[u>>2]|0)+16>>2]|0)){hb(t[(t[f>>2]|0)+64>>2]|0,t[F>>2]|0,t[O>>2]|0)|0;t[a>>2]=1}t[(t[f>>2]|0)+76>>2]=t[O>>2];break}case 6:{t[a>>2]=1;if((t[(t[u>>2]|0)+16>>2]|0)==1?(t[(t[u>>2]|0)+20>>2]|0)==1:0){t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];while(1){if(!(t[m>>2]|0))break e;t[o>>2]=Cv(t[f>>2]|0,t[m>>2]|0)|0;if((t[o>>2]|0)!=1)t[a>>2]=0;t[m>>2]=t[(t[m>>2]|0)+8>>2]}}t[_>>2]=t[(t[f>>2]|0)+76>>2];i=t[u>>2]|0;if((t[(t[u>>2]|0)+20>>2]|0)>=1073741824){z=(t[i+16>>2]|0)>1;q=hb(t[(t[f>>2]|0)+64>>2]|0,t[_>>2]|0,0)|0;t[(t[f>>2]|0)+76>>2]=q;t[_>>2]=t[(t[f>>2]|0)+76>>2];if(z){t[E>>2]=db(t[(t[f>>2]|0)+64>>2]|0,(t[(t[u>>2]|0)+16>>2]|0)-1|0,1073741824)|0;t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];while(1){Y=t[f>>2]|0;if(!(t[m>>2]|0))break;t[o>>2]=Cv(Y,t[m>>2]|0)|0;if((t[o>>2]|0)!=1)t[a>>2]=0;t[m>>2]=t[(t[m>>2]|0)+8>>2]}t[p>>2]=t[Y+76>>2];vb(t[(t[f>>2]|0)+64>>2]|0,t[p>>2]|0,t[_>>2]|0,t[E>>2]|0)|0;z=mb(t[(t[f>>2]|0)+64>>2]|0,t[p>>2]|0,0,t[E>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=z;if((t[a>>2]|0)!=1)break e;hb(t[(t[f>>2]|0)+64>>2]|0,t[_>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0;break e}else{t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];while(1){G=t[f>>2]|0;if(!(t[m>>2]|0))break;t[o>>2]=Cv(G,t[m>>2]|0)|0;if((t[o>>2]|0)!=1)t[a>>2]=0;t[m>>2]=t[(t[m>>2]|0)+8>>2]}hb(t[G+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[_>>2]|0)|0;z=hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,0)|0;t[(t[f>>2]|0)+76>>2]=z;if(t[(t[u>>2]|0)+16>>2]|0)break e;hb(t[(t[f>>2]|0)+64>>2]|0,t[_>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0;t[a>>2]=1;break e}}if((t[i+20>>2]|0)<=1?(t[(t[u>>2]|0)+16>>2]|0)<=1:0){t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];while(1){W=t[f>>2]|0;if(!(t[m>>2]|0))break;
	t[o>>2]=Cv(W,t[m>>2]|0)|0;if((t[o>>2]|0)!=1)t[a>>2]=0;t[m>>2]=t[(t[m>>2]|0)+8>>2]}i=hb(t[W+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,0)|0;t[(t[f>>2]|0)+76>>2]=i;if(t[(t[u>>2]|0)+16>>2]|0)break e;hb(t[(t[f>>2]|0)+64>>2]|0,t[_>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0;t[a>>2]=1;break e}i=hb(t[(t[f>>2]|0)+64>>2]|0,t[_>>2]|0,0)|0;t[(t[f>>2]|0)+76>>2]=i;t[_>>2]=t[(t[f>>2]|0)+76>>2];t[g>>2]=db(t[(t[f>>2]|0)+64>>2]|0,(t[(t[u>>2]|0)+16>>2]|0)-1|0,(t[(t[u>>2]|0)+20>>2]|0)-1|0)|0;t[m>>2]=t[(t[(t[u>>2]|0)+12>>2]|0)+12>>2];while(1){K=t[f>>2]|0;if(!(t[m>>2]|0))break;t[o>>2]=Cv(K,t[m>>2]|0)|0;if((t[o>>2]|0)!=1)t[a>>2]=0;t[m>>2]=t[(t[m>>2]|0)+8>>2]}t[S>>2]=t[K+76>>2];vb(t[(t[f>>2]|0)+64>>2]|0,t[S>>2]|0,t[_>>2]|0,t[g>>2]|0)|0;i=mb(t[(t[f>>2]|0)+64>>2]|0,t[S>>2]|0,0,t[g>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i;if((t[a>>2]|0)==1?1:(t[(t[u>>2]|0)+16>>2]|0)==0){hb(t[(t[f>>2]|0)+64>>2]|0,t[_>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0;t[a>>2]=1}break}default:{i=t[f>>2]|0;nw(i,158112,158200,vd(t[(t[u>>2]|0)+12>>2]|0)|0,0);t[n>>2]=t[a>>2];I=t[n>>2]|0;s=r;return I|0}}while(0);t[n>>2]=t[a>>2];I=t[n>>2]|0;s=r;return I|0}function Pv(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;e=t[n>>2]|0;if((t[(t[n>>2]|0)+96>>2]|0)>(t[(t[n>>2]|0)+104>>2]|0)){rh(e,155664,155696);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}e:do if(t[e+100>>2]|0){o=t[n>>2]|0;if((t[(t[n>>2]|0)+104>>2]|0)>(t[(t[n>>2]|0)+96>>2]|0)){t[f>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[o+96>>2]<<2)>>2];break}t[u>>2]=t[o+104>>2];o=(t[n>>2]|0)+104|0;t[o>>2]=t[o>>2]<<1;o=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+100>>2]|0,t[(t[n>>2]|0)+104>>2]<<2)|0;t[(t[n>>2]|0)+100>>2]=o;if(!(t[(t[n>>2]|0)+100>>2]|0)){kh(t[n>>2]|0,155768,0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}else while(1){if((t[u>>2]|0)>=(t[(t[n>>2]|0)+104>>2]|0))break e;t[(t[(t[n>>2]|0)+100>>2]|0)+(t[u>>2]<<2)>>2]=0;t[u>>2]=(t[u>>2]|0)+1}}else{o=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+100>>2]=o;o=t[n>>2]|0;if(t[(t[n>>2]|0)+100>>2]|0){c=(t[o+100>>2]|0)+0|0;l=c+40|0;do{t[c>>2]=0;c=c+4|0}while((c|0)<(l|0));t[(t[n>>2]|0)+104>>2]=10;break}kh(o,155728,0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}while(0);do if(t[f>>2]|0){if(t[(t[f>>2]|0)+12>>2]|0){rh(t[n>>2]|0,155664,155840);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}}else{t[f>>2]=gAi[t[135744>>2]&511](84)|0;if(t[f>>2]|0){t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2]=t[f>>2];break}kh(t[n>>2]|0,155808,0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}while(0);c=(t[f>>2]|0)+0|0;l=c+84|0;do{t[c>>2]=0;c=c+4|0}while((c|0)<(l|0));t[t[f>>2]>>2]=1;t[(t[f>>2]|0)+48>>2]=t[(t[n>>2]|0)+96>>2];t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function Bv(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;do if(!(t[(t[n>>2]|0)+164>>2]|0)){e=gAi[t[135744>>2]&511](4)|0;t[(t[n>>2]|0)+164>>2]=e;t[(t[n>>2]|0)+172>>2]=1;if(!(t[(t[n>>2]|0)+164>>2]|0)){kh(t[n>>2]|0,145800,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}}else{e=t[n>>2]|0;if((t[(t[n>>2]|0)+172>>2]|0)<=(t[(t[n>>2]|0)+168>>2]|0)){a=e+172|0;t[a>>2]=(t[a>>2]|0)+1;a=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+164>>2]|0,t[(t[n>>2]|0)+172>>2]<<2)|0;t[(t[n>>2]|0)+164>>2]=a;if(t[(t[n>>2]|0)+164>>2]|0)break;kh(t[n>>2]|0,145832,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}a=e+168|0;e=t[a>>2]|0;t[a>>2]=e+1;t[f>>2]=t[(t[(t[n>>2]|0)+164>>2]|0)+(e<<2)>>2];if(t[(t[f>>2]|0)+12>>2]|0){rh(t[n>>2]|0,145872,145904);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[t[f>>2]>>2]=2;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}}while(0);t[f>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[f>>2]|0)){kh(t[n>>2]|0,145928,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+60|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=2;e=t[f>>2]|0;a=(t[n>>2]|0)+168|0;o=t[a>>2]|0;t[a>>2]=o+1;t[(t[(t[n>>2]|0)+164>>2]|0)+(o<<2)>>2]=e;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Iv(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[n>>2]=e;t[o>>2]=0;t[l>>2]=0;t[b>>2]=0;t[k>>2]=NL(t[n>>2]|0,3)|0;if(!(t[k>>2]|0))t[k>>2]=NL(t[n>>2]|0,4)|0;if(!(t[k>>2]|0)){t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}t[f>>2]=t[(t[k>>2]|0)+20>>2];do{if((t[(t[k>>2]|0)+48>>2]|0)==3){while(1){do if((u[t[f>>2]>>0]|0|0)==32)w=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){w=1;break}w=(u[t[f>>2]>>0]|0|0)==13}while(0);d=t[f>>2]|0;if(!w)break;t[f>>2]=d+1}t[a>>2]=d;while(1){if(u[t[a>>2]>>0]|0){do if((u[t[a>>2]>>0]|0|0)==32)v=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){v=1;break}v=(u[t[a>>2]>>0]|0|0)==13}while(0);m=v^1}else m=0;_=t[a>>2]|0;if(!m)break;t[a>>2]=_+1}if((_|0)==(t[f>>2]|0))break;t[l>>2]=(t[l>>2]|0)+1;t[o>>2]=kz(t[(t[(t[n>>2]|0)+20>>2]|0)+60>>2]|0,t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;t[f>>2]=t[a>>2]}while(1){do if((u[t[f>>2]>>0]|0|0)==32)p=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){p=1;break}p=(u[t[f>>2]>>0]|0|0)==13}while(0);E=t[f>>2]|0;if(!p)break;t[f>>2]=E+1}t[a>>2]=E;while(1){if(u[t[a>>2]>>0]|0){do if((u[t[a>>2]>>0]|0|0)==32)S=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){S=1;break}S=(u[t[a>>2]>>0]|0|0)==13}while(0);g=S^1}else g=0;y=t[a>>2]|0;if(!g)break;t[a>>2]=y+1}if((y|0)==(t[f>>2]|0)){F=40;break}t[l>>2]=(t[l>>2]|0)+1;t[c>>2]=kz(t[(t[(t[n>>2]|0)+20>>2]|0)+60>>2]|0,t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;t[f>>2]=t[a>>2];t[b>>2]=TL(t[n>>2]|0,t[(t[n>>2]|0)+20>>2]|0,t[(t[k>>2]|0)+4>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;if((t[b>>2]|0)==-1){F=43;break}}while((u[t[f>>2]>>0]|0|0)!=0);if((F|0)==40){if((t[(t[k>>2]|0)+48>>2]|0)==3)mw(t[n>>2]|0,1879,t[(t[k>>2]|0)+4>>2]|0,0,155136,0,0,0)}else if((F|0)==43){rh(t[n>>2]|0,155224,155248);t[r>>2]=-1;h=t[r>>2]|0;s=i;return h|0}t[r>>2]=t[b>>2];h=t[r>>2]|0;s=i;return h|0}function Hv(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+96|0;r=i+80|0;n=i+76|0;f=i+72|0;u=i+68|0;a=i+64|0;o=i+60|0;c=i+56|0;l=i+16|0;b=i+8|0;k=i+4|0;h=i;t[n>>2]=e;t[a>>2]=0;e=t[n>>2]|0;if((t[(t[n>>2]|0)+96>>2]|0)<=0){rh(e,154576,154608);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}t[f>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+((t[e+96>>2]|0)-1<<2)>>2];if(t[(t[f>>2]|0)+32>>2]&32){e=(t[f>>2]|0)+32|0;t[e>>2]=t[e>>2]^32}e:do if(t[(t[f>>2]|0)+32>>2]&4){t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+((t[(t[n>>2]|0)+96>>2]|0)-1<<2)>>2];t[a>>2]=1848;th(t[n>>2]|0,t[a>>2]|0,0,0,154648,0,0);t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2]}else{t[u>>2]=t[(t[f>>2]|0)+28>>2];if((t[(t[u>>2]|0)+88>>2]|0)==45){e=nv(t[(t[n>>2]|0)+20>>2]|0,t[(t[(t[n>>2]|0)+108>>2]|0)+12>>2]|0,t[(t[(t[n>>2]|0)+108>>2]|0)+16>>2]|0)|0;t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]=e;do if(!(t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2]|0)){t[o>>2]=NL(t[n>>2]|0,1)|0;if(!(t[o>>2]|0)){e=ED(45)|0;t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]=e;break}t[a>>2]=LL(t[n>>2]|0,t[o>>2]|0,(t[(t[n>>2]|0)+108>>2]|0)+28|0,0)|0;if(t[a>>2]|0)if((t[a>>2]|0)==-1){rh(t[n>>2]|0,154576,154504);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else{t[r>>2]=t[a>>2];w=t[r>>2]|0;s=i;return w|0}}while(0);t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}i:do switch(t[(t[u>>2]|0)+52>>2]|0){case 2:case 3:{t[k>>2]=10;if(!(t[(t[u>>2]|0)+108>>2]|0)){rh(t[n>>2]|0,154576,154808);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}if(t[(t[f>>2]|0)+32>>2]&256){rh(t[n>>2]|0,154576,154856);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}t[c>>2]=t[(t[f>>2]|0)+60>>2];do if(!(t[c>>2]|0)){t[c>>2]=Ws(t[(t[u>>2]|0)+108>>2]|0,358,t[n>>2]|0)|0;if(t[c>>2]|0){t[(t[f>>2]|0)+60>>2]=t[c>>2];break}rh(t[n>>2]|0,154576,141760);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}while(0);t[a>>2]=Zs(t[c>>2]|0,t[(t[(t[n>>2]|0)+108>>2]|0)+12>>2]|0,t[(t[(t[n>>2]|0)+108>>2]|0)+16>>2]|0,t[(t[n>>2]|0)+108>>2]|0)|0;if((t[(t[n>>2]|0)+52>>2]|0)==1818){rh(t[n>>2]|0,154576,154912);t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}if((t[a>>2]|0)<0){Qs(t[c>>2]|0,0,k,h,l,b)|0;Yv(t[n>>2]|0,1871,0,0,154944,t[k>>2]|0,t[h>>2]|0,l);t[a>>2]=t[(t[n>>2]|0)+52>>2];break e}else{t[a>>2]=0;break i}break}case 1:{t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+((t[(t[n>>2]|0)+96>>2]|0)-1<<2)>>2];t[a>>2]=1841;th(t[n>>2]|0,t[a>>2]|0,0,0,154736,0,0);t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2];break e;break}case 6:case 4:{t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+((t[(t[n>>2]|0)+96>>2]|0)-1<<2)>>2];if((t[t[u>>2]>>2]|0)!=5?(t[(t[u>>2]|0)+88>>2]|0)!=45:0){t[a>>2]=1828;th(t[n>>2]|0,t[a>>2]|0,0,0,155064,0,0)}else{t[a>>2]=1842;th(t[n>>2]|0,t[a>>2]|0,0,0,154976,0,0)}t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2];t[a>>2]=t[(t[n>>2]|0)+52>>2];break e;break}default:{}}while(0);t[r>>2]=t[a>>2];w=t[r>>2]|0;s=i;return w|0}while(0);t[(t[n>>2]|0)+176>>2]=t[(t[n>>2]|0)+96>>2];u=(t[(t[n>>2]|0)+108>>2]|0)+32|0;t[u>>2]=t[u>>2]|512;u=(t[f>>2]|0)+32|0;t[u>>2]=t[u>>2]|256;t[r>>2]=t[a>>2];w=t[r>>2]|0;s=i;return w|0}function xv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[(t[f>>2]|0)+108>>2]|0)+44>>2];if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)?(t[t[a>>2]>>2]|0)==2:0){t[t[u>>2]>>2]=0;if((t[(t[a>>2]|0)+24>>2]|0)==1){t[t[u>>2]>>2]=1;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=0;t[o>>2]=nv(t[(t[f>>2]|0)+20>>2]|0,t[(t[(t[f>>2]|0)+108>>2]|0)+12>>2]|0,t[(t[(t[f>>2]|0)+108>>2]|0)+16>>2]|0)|0;if(t[o>>2]|0){t[(t[(t[f>>2]|0)+108>>2]|0)+44>>2]=t[o>>2];t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}o=t[f>>2]|0;if((t[(t[a>>2]|0)+24>>2]|0)==3){th(o,1845,0,0,154416,0,0);t[n>>2]=t[(t[f>>2]|0)+52>>2];l=t[n>>2]|0;s=r;return l|0}if((t[o+168>>2]|0)!=0?(t[c>>2]=NL(t[f>>2]|0,1)|0,(t[c>>2]|0)!=0):0)if((LL(t[f>>2]|0,t[c>>2]|0,(t[(t[f>>2]|0)+108>>2]|0)+28|0,0)|0)==-1){rh(t[f>>2]|0,154368,154504);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}c=ED(45)|0;t[(t[(t[f>>2]|0)+108>>2]|0)+28>>2]=c;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}rh(t[f>>2]|0,154368,154400);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}function Uv(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[f>>2]=t[(t[(t[n>>2]|0)+108>>2]|0)+44>>2];if(!(t[f>>2]|0)){th(t[n>>2]|0,1845,0,0,146200,0,0);t[r>>2]=t[(t[n>>2]|0)+52>>2];l=t[r>>2]|0;s=i;return l|0}t[u>>2]=t[(t[f>>2]|0)+28>>2];if(t[(t[f>>2]|0)+48>>2]&16){th(t[n>>2]|0,1846,0,0,146240,0,0);t[r>>2]=t[(t[n>>2]|0)+52>>2];l=t[r>>2]|0;s=i;return l|0}e=t[n>>2]|0;if(!(t[u>>2]|0)){th(e,1875,0,0,145096,0,0);t[r>>2]=1875;l=t[r>>2]|0;s=i;return l|0}do if(t[e+168>>2]|0){t[o>>2]=NL(t[n>>2]|0,2)|0;do if(t[o>>2]|0){t[(t[n>>2]|0)+108>>2]=t[o>>2];b=t[n>>2]|0;k=ED(15)|0;t[a>>2]=nh(b,0,k,t[(t[o>>2]|0)+20>>2]|0,(t[o>>2]|0)+24|0,1,0,0)|0;t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2];if((t[a>>2]|0)<0){rh(t[n>>2]|0,146280,146312);t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}if(!(t[a>>2]|0)){if(!(t[(t[f>>2]|0)+48>>2]&1)){th(t[n>>2]|0,1847,0,0,146392,0,0);break}if(FD(t[(t[o>>2]|0)+24>>2]|0)|0){if((t[(t[f>>2]|0)+48>>2]&8|0)!=0?(t[(t[f>>2]|0)+76>>2]|0)!=0:0){th(t[n>>2]|0,1849,0,0,146424,0,0);break}k=(t[(t[n>>2]|0)+108>>2]|0)+32|0;t[k>>2]=t[k>>2]|4}}}while(0);t[o>>2]=NL(t[n>>2]|0,1)|0;if(t[o>>2]|0){t[c>>2]=0;t[a>>2]=LL(t[n>>2]|0,t[o>>2]|0,c,t[f>>2]|0)|0;if((t[a>>2]|0)!=0&(t[a>>2]|0)==-1){rh(t[n>>2]|0,146280,146512);t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}else{if(!(t[c>>2]|0))break;k=(t[(t[n>>2]|0)+108>>2]|0)+32|0;t[k>>2]=t[k>>2]|8;t[u>>2]=t[c>>2];break}}}while(0);if((t[(t[f>>2]|0)+100>>2]|0)!=0?(DL(t[n>>2]|0,t[f>>2]|0)|0)==-1:0){t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}if(!(t[u>>2]|0)){th(t[n>>2]|0,1875,0,0,145096,0,0);t[r>>2]=1875;l=t[r>>2]|0;s=i;return l|0}else{t[(t[(t[n>>2]|0)+108>>2]|0)+28>>2]=t[u>>2];t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}return 0}function zv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+36|0;f=r+32|0;u=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[b>>2]=0;t[k>>2]=t[(t[f>>2]|0)+96>>2];if(!(t[(t[f>>2]|0)+116>>2]|0)){t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}if((t[u>>2]|0)==2)t[k>>2]=(t[k>>2]|0)+1;t[c>>2]=t[(t[f>>2]|0)+116>>2];t[a>>2]=t[c>>2];e:while(1){if((t[a>>2]|0)==(t[o>>2]|0)){d=34;break}i=t[(t[a>>2]|0)+32>>2]|0;e=t[(t[(t[f>>2]|0)+108>>2]|0)+12>>2]|0;v=t[(t[(t[f>>2]|0)+108>>2]|0)+16>>2]|0;if((t[u>>2]|0)==1)t[l>>2]=pj(i,e,v)|0;else t[l>>2]=Sj(i,e,v)|0;if((t[l>>2]|0)==-1){d=11;break}i:do if(t[l>>2]|0){if(t[(t[a>>2]|0)+12>>2]|0){if((t[(t[a>>2]|0)+20>>2]|0)<=(t[(t[a>>2]|0)+16>>2]|0)?(v=(t[a>>2]|0)+20|0,t[v>>2]=t[v>>2]<<1,v=MAi[t[135760>>2]&511](t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+20>>2]<<2)|0,t[(t[a>>2]|0)+12>>2]=v,(t[(t[a>>2]|0)+12>>2]|0)==0):0){d=19;break e}}else{v=gAi[t[135744>>2]&511](20)|0;t[(t[a>>2]|0)+12>>2]=v;if(!(t[(t[a>>2]|0)+12>>2]|0)){d=15;break e}t[(t[a>>2]|0)+20>>2]=5}v=t[k>>2]|0;e=(t[a>>2]|0)+16|0;i=t[e>>2]|0;t[e>>2]=i+1;t[(t[(t[a>>2]|0)+12>>2]|0)+(i<<2)>>2]=v;v=t[a>>2]|0;if((t[t[a>>2]>>2]|0)==1){t[h>>2]=t[(t[(t[(t[v+24>>2]|0)+16>>2]|0)+4>>2]|0)+28>>2];while(1){if(!(t[h>>2]|0))break i;if((CL(t[f>>2]|0,t[(t[a>>2]|0)+24>>2]|0,t[h>>2]|0,2)|0)==-1){d=24;break e}t[h>>2]=t[t[h>>2]>>2]}}if((t[v>>2]|0)==2){if((t[b>>2]|0)==0?(t[(t[(t[f>>2]|0)+108>>2]|0)+32>>2]&16|0)==0:0){i=(t[(t[f>>2]|0)+108>>2]|0)+32|0;t[i>>2]=t[i>>2]|16}t[b>>2]=(t[b>>2]|0)+1}}while(0);if(!(t[(t[a>>2]|0)+4>>2]|0)){t[o>>2]=t[c>>2];t[a>>2]=t[(t[f>>2]|0)+116>>2];continue}else{t[a>>2]=t[(t[a>>2]|0)+4>>2];continue}}if((d|0)==11){rh(t[f>>2]|0,145960,145984);t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==15){kh(0,146008,0);t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==19){kh(0,146048,0);t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==24){t[n>>2]=-1;w=t[n>>2]|0;s=r;return w|0}else if((d|0)==34){t[n>>2]=t[b>>2];w=t[n>>2]|0;s=r;return w|0}return 0}function jv(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0;i=s;s=s+128|0;r=i;n=i+100|0;f=i+96|0;a=i+92|0;o=i+88|0;c=i+84|0;l=i+80|0;b=i+76|0;k=i+72|0;h=i+68|0;w=i+64|0;d=i+60|0;v=i+56|0;m=i+52|0;_=i+48|0;p=i+44|0;E=i+40|0;S=i+36|0;g=i+32|0;y=i+28|0;F=i+24|0;O=i+20|0;A=i+16|0;M=i+104|0;R=i+12|0;N=i+8|0;t[f>>2]=e;t[a>>2]=t[(t[(t[f>>2]|0)+108>>2]|0)+28>>2];t[c>>2]=0;t[l>>2]=0;t[_>>2]=0;t[E>>2]=0;t[g>>2]=0;t[o>>2]=t[(t[a>>2]|0)+116>>2];t[v>>2]=t[(t[f>>2]|0)+168>>2];if(t[o>>2]|0)t[m>>2]=t[(t[o>>2]|0)+4>>2];else t[m>>2]=0;t[h>>2]=0;e:while(1){if((t[h>>2]|0)>=(t[m>>2]|0)){T=26;break}t[d>>2]=0;t[c>>2]=t[(t[t[o>>2]>>2]|0)+(t[h>>2]<<2)>>2];t[l>>2]=t[(t[c>>2]|0)+12>>2];t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[v>>2]|0))break;t[b>>2]=t[(t[(t[f>>2]|0)+164>>2]|0)+(t[w>>2]<<2)>>2];if((((t[(t[b>>2]|0)+48>>2]|0)==0?(u[t[(t[b>>2]|0)+12>>2]>>0]|0|0)==(u[t[(t[l>>2]|0)+8>>2]>>0]|0|0):0)?(Xl(t[(t[b>>2]|0)+12>>2]|0,t[(t[l>>2]|0)+8>>2]|0)|0)!=0:0)?(Xl(t[(t[b>>2]|0)+16>>2]|0,t[(t[l>>2]|0)+56>>2]|0)|0)!=0:0){T=12;break}t[w>>2]=(t[w>>2]|0)+1}if((T|0)==12){T=0;t[d>>2]=1;t[(t[b>>2]|0)+44>>2]=2;t[(t[b>>2]|0)+40>>2]=t[c>>2];t[(t[b>>2]|0)+36>>2]=t[l>>2];t[(t[b>>2]|0)+28>>2]=t[(t[l>>2]|0)+48>>2]}do if(!(t[d>>2]|0)){if((t[(t[c>>2]|0)+24>>2]|0)==1){t[k>>2]=Bv(t[f>>2]|0)|0;if(!(t[k>>2]|0)){T=17;break e}t[(t[k>>2]|0)+44>>2]=4;t[(t[k>>2]|0)+40>>2]=t[c>>2];t[(t[k>>2]|0)+36>>2]=t[l>>2];break}if((t[(t[c>>2]|0)+24>>2]|0)==2){if((t[(t[c>>2]|0)+28>>2]|0)==0?(t[(t[l>>2]|0)+44>>2]|0)==0:0)break;t[k>>2]=Bv(t[f>>2]|0)|0;if(!(t[k>>2]|0)){T=23;break e}t[(t[k>>2]|0)+44>>2]=8;t[(t[k>>2]|0)+40>>2]=t[c>>2];t[(t[k>>2]|0)+36>>2]=t[l>>2];t[(t[k>>2]|0)+28>>2]=t[(t[l>>2]|0)+48>>2];t[(t[k>>2]|0)+12>>2]=t[(t[l>>2]|0)+8>>2];t[(t[k>>2]|0)+16>>2]=t[(t[l>>2]|0)+56>>2]}}while(0);t[h>>2]=(t[h>>2]|0)+1}if((T|0)==17){rh(t[f>>2]|0,145272,145304);t[n>>2]=-1;L=t[n>>2]|0;s=i;return L|0}else if((T|0)==23){rh(t[f>>2]|0,145272,145304);t[n>>2]=-1;L=t[n>>2]|0;s=i;return L|0}else if((T|0)==26){if(!(t[(t[f>>2]|0)+168>>2]|0)){t[n>>2]=0;L=t[n>>2]|0;s=i;return L|0}e:do if(t[(t[a>>2]|0)+84>>2]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[v>>2]|0))break e;t[b>>2]=t[(t[(t[f>>2]|0)+164>>2]|0)+(t[h>>2]<<2)>>2];i:do if((t[(t[b>>2]|0)+44>>2]|0)==1?(dL(t[(t[a>>2]|0)+84>>2]|0,t[(t[b>>2]|0)+16>>2]|0)|0)==0:0){if((t[(t[(t[a>>2]|0)+84>>2]|0)+24>>2]|0)==1){t[(t[b>>2]|0)+44>>2]=13;break}l=uv(t[(t[f>>2]|0)+20>>2]|0,t[(t[b>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+16>>2]|0)|0;t[(t[b>>2]|0)+36>>2]=l;if(!(t[(t[b>>2]|0)+36>>2]|0)){l=(t[b>>2]|0)+44|0;if((t[(t[(t[a>>2]|0)+84>>2]|0)+24>>2]|0)==2){t[l>>2]=14;break}else{t[l>>2]=10;break}}t[(t[b>>2]|0)+44>>2]=2;t[(t[b>>2]|0)+28>>2]=t[(t[(t[b>>2]|0)+36>>2]|0)+48>>2];if(gv(t[(t[b>>2]|0)+28>>2]|0,23)|0){if(t[E>>2]|0){t[(t[b>>2]|0)+44>>2]=15;l=t[33976]|0;k=t[33980]|0;t[r>>2]=140328;t[r+4>>2]=25406;yAi[l&511](k,140296,r);break}t[E>>2]=(t[E>>2]|0)+1;if(t[o>>2]|0){t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[(t[o>>2]|0)+4>>2]|0))break i;if(gv(t[(t[(t[(t[t[o>>2]>>2]|0)+(t[w>>2]<<2)>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)break;t[w>>2]=(t[w>>2]|0)+1}t[(t[b>>2]|0)+44>>2]=16;k=t[33976]|0;l=t[33980]|0;t[r>>2]=140328;t[r+4>>2]=25424;yAi[k&511](l,140296,r)}}}while(0);t[h>>2]=(t[h>>2]|0)+1}}while(0);if(!(t[(t[f>>2]|0)+168>>2]|0)){t[n>>2]=0;L=t[n>>2]|0;s=i;return L|0}if((((t[(t[f>>2]|0)+80>>2]&1|0)!=0?(t[y>>2]=t[(t[(t[f>>2]|0)+100>>2]|0)+(t[(t[f>>2]|0)+96>>2]<<2)>>2],(t[y>>2]|0)!=0):0)?(t[(t[y>>2]|0)+4>>2]|0)!=0:0)?(t[(t[(t[y>>2]|0)+4>>2]|0)+32>>2]|0)!=0:0)t[g>>2]=t[(t[y>>2]|0)+4>>2];t[h>>2]=0;e:while(1){if((t[h>>2]|0)>=(t[(t[f>>2]|0)+168>>2]|0)){T=124;break}t[b>>2]=t[(t[(t[f>>2]|0)+164>>2]|0)+(t[h>>2]<<2)>>2];if(!((t[(t[b>>2]|0)+44>>2]|0)!=2?(t[(t[b>>2]|0)+44>>2]|0)!=8:0))T=60;do if((T|0)==60){T=0;y=t[b>>2]|0;if(!(t[(t[b>>2]|0)+28>>2]|0)){t[y+44>>2]=6;break}t[(t[f>>2]|0)+108>>2]=y;t[S>>2]=0;t[_>>2]=0;if((t[(t[f>>2]|0)+116>>2]|0)!=0?(t[_>>2]=zv(t[f>>2]|0,2)|0,(t[_>>2]|0)==-1):0){T=64;break e}i:do if((t[(t[b>>2]|0)+44>>2]|0)==8){if((t[_>>2]|0)!=0|(t[g>>2]|0)!=0){y=t[b>>2]|0;if(t[(t[(t[b>>2]|0)+40>>2]|0)+28>>2]|0){t[(t[b>>2]|0)+20>>2]=t[(t[y+40>>2]|0)+28>>2];t[(t[b>>2]|0)+24>>2]=t[(t[(t[b>>2]|0)+40>>2]|0)+32>>2]}else{t[(t[b>>2]|0)+20>>2]=t[(t[y+36>>2]|0)+44>>2];t[(t[b>>2]|0)+24>>2]=t[(t[(t[b>>2]|0)+36>>2]|0)+68>>2]}if(!(t[(t[b>>2]|0)+24>>2]|0)){T=71;break e}y=PD(t[(t[b>>2]|0)+24>>2]|0)|0;t[(t[b>>2]|0)+24>>2]=y;if(!(t[(t[b>>2]|0)+24>>2]|0)){T=73;break e}}if(t[g>>2]|0){t[O>>2]=t[(t[b>>2]|0)+20>>2];t[F>>2]=fw(t[(t[b>>2]|0)+28>>2]|0,t[(t[b>>2]|0)+20>>2]|0)|0;if(t[F>>2]|0)t[O>>2]=t[F>>2];y=t[g>>2]|0;if(!(t[(t[b>>2]|0)+16>>2]|0)){if(!(by(y,t[(t[b>>2]|0)+12>>2]|0,t[O>>2]|0)|0)){T=79;break e}}else{t[A>>2]=rF(t[y+32>>2]|0,t[g>>2]|0,t[(t[b>>2]|0)+16>>2]|0)|0;if(!(t[A>>2]|0)){t[R>>2]=0;do{y=t[R>>2]|0;t[R>>2]=y+1;t[r>>2]=y;SY(M,12,145464,r)|0;t[A>>2]=wF(t[(t[g>>2]|0)+32>>2]|0,t[g>>2]|0,M)|0;if((t[R>>2]|0)>1e3){T=84;break e}}while((t[A>>2]|0)!=0);t[A>>2]=Wg(t[(t[f>>2]|0)+84>>2]|0,t[(t[b>>2]|0)+16>>2]|0,M)|0}ky(t[g>>2]|0,t[A>>2]|0,t[(t[b>>2]|0)+12>>2]|0,t[O>>2]|0)|0}if(t[F>>2]|0)pAi[t[135736>>2]&511](t[F>>2]|0)}}else{if(t[(t[f>>2]|0)+72>>2]|0){MD(t[(t[f>>2]|0)+72>>2]|0);t[(t[f>>2]|0)+72>>2]=0}do if(t[(t[(t[b>>2]|0)+36>>2]|0)+60>>2]&512)T=96;else{if((t[(t[b>>2]|0)+40>>2]|0)!=0?(t[(t[(t[b>>2]|0)+40>>2]|0)+16>>2]&512|0)!=0:0){T=96;break}t[S>>2]=0}while(0);if((T|0)==96){T=0;t[S>>2]=1}if((t[_>>2]|0)!=0|(t[S>>2]|0)!=0){y=(t[b>>2]|0)+32|0;t[y>>2]=t[y>>2]|16;t[p>>2]=nh(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,t[(t[b>>2]|0)+28>>2]|0,t[(t[b>>2]|0)+20>>2]|0,(t[b>>2]|0)+24|0,1,1,0)|0}else t[p>>2]=nh(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,t[(t[b>>2]|0)+28>>2]|0,t[(t[b>>2]|0)+20>>2]|0,0,1,0,0)|0;if(t[p>>2]|0){if((t[p>>2]|0)==-1){T=103;break e}t[(t[b>>2]|0)+44>>2]=5;break}if(t[S>>2]|0){if(!(t[(t[b>>2]|0)+24>>2]|0)){y=t[33976]|0;w=t[33980]|0;t[r>>2]=140328;t[r+4>>2]=25678;yAi[y&511](w,140296,r);break}do if(t[(t[b>>2]|0)+40>>2]|0){if(!(t[(t[(t[b>>2]|0)+40>>2]|0)+28>>2]|0))break;if(!(t[(t[(t[b>>2]|0)+40>>2]|0)+32>>2]|0)){w=t[33976]|0;y=t[33980]|0;t[r>>2]=140328;t[r+4>>2]=25685;yAi[w&511](y,140296,r);break i}t[(t[b>>2]|0)+52>>2]=t[(t[(t[b>>2]|0)+40>>2]|0)+28>>2];if(Od(t[(t[b>>2]|0)+24>>2]|0,t[(t[(t[b>>2]|0)+40>>2]|0)+32>>2]|0)|0)break i;t[(t[b>>2]|0)+44>>2]=7;break i}while(0);if(!(t[(t[(t[b>>2]|0)+36>>2]|0)+68>>2]|0)){y=t[33976]|0;w=t[33980]|0;t[r>>2]=140328;t[r+4>>2]=25700;yAi[y&511](w,140296,r);break}t[(t[b>>2]|0)+52>>2]=t[(t[(t[b>>2]|0)+36>>2]|0)+44>>2];if(Od(t[(t[b>>2]|0)+24>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+68>>2]|0)|0)break;t[(t[b>>2]|0)+44>>2]=7}}while(0);w=t[f>>2]|0;if(t[_>>2]|0)if((Kv(w,(t[(t[f>>2]|0)+96>>2]|0)+1|0)|0)==-1){T=120;break e}else break;if(t[w+116>>2]|0)PL(t[f>>2]|0)|0}while(0);t[h>>2]=(t[h>>2]|0)+1}if((T|0)==64)rh(t[f>>2]|0,145272,145160);else if((T|0)==71)rh(t[f>>2]|0,145272,145344);else if((T|0)==73)rh(t[f>>2]|0,145272,145408);else if((T|0)==79){rh(t[f>>2]|0,145272,145440);if(t[F>>2]|0)pAi[t[135736>>2]&511](t[F>>2]|0)}else if((T|0)==84){rh(t[f>>2]|0,145272,145472);if(t[F>>2]|0)pAi[t[135736>>2]&511](t[F>>2]|0)}else if((T|0)==103)rh(t[f>>2]|0,145272,145536);else if((T|0)==120)rh(t[f>>2]|0,145272,145160);else if((T|0)==124){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[(t[f>>2]|0)+168>>2]|0))break;t[b>>2]=t[(t[(t[f>>2]|0)+164>>2]|0)+(t[h>>2]<<2)>>2];e:do if((((t[(t[b>>2]|0)+44>>2]|0)!=17?(t[(t[b>>2]|0)+44>>2]|0)!=2:0)?(t[(t[b>>2]|0)+44>>2]|0)!=13:0)?(t[(t[b>>2]|0)+44>>2]|0)!=14:0){t[(t[f>>2]|0)+108>>2]=t[b>>2];switch(t[(t[b>>2]|0)+44>>2]|0){case 6:{th(t[f>>2]|0,1862,0,0,145096,0,0);break e;break}case 4:{t[N>>2]=0;t[(t[f>>2]|0)+108>>2]=t[(t[(t[f>>2]|0)+100>>2]|0)+(t[(t[f>>2]|0)+96>>2]<<2)>>2];th(t[f>>2]|0,1868,0,0,145592,uh(N,t[(t[(t[b>>2]|0)+36>>2]|0)+56>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0)|0,0);if(!(t[N>>2]|0))break e;pAi[t[135736>>2]&511](t[N>>2]|0);t[N>>2]=0;break e;break}case 7:{th(t[f>>2]|0,1874,0,0,145640,t[(t[b>>2]|0)+20>>2]|0,t[(t[b>>2]|0)+52>>2]|0);break e;break}case 10:{th(t[f>>2]|0,1878,0,0,145704,0,0);break e;break}case 1:{if(t[(t[b>>2]|0)+48>>2]|0)break e;T=t[f>>2]|0;F=t[b>>2]|0;if(!(t[(t[a>>2]|0)+84>>2]|0)){BL(T,1866,F,0);break e}else{BL(T,1867,F,0);break e}break}default:break e}}while(0);t[h>>2]=(t[h>>2]|0)+1}t[(t[f>>2]|0)+108>>2]=t[(t[(t[f>>2]|0)+100>>2]|0)+(t[(t[f>>2]|0)+96>>2]<<2)>>2];t[n>>2]=0;L=t[n>>2]|0;s=i;return L|0}t[(t[f>>2]|0)+108>>2]=t[(t[(t[f>>2]|0)+100>>2]|0)+(t[(t[f>>2]|0)+96>>2]<<2)>>2];t[n>>2]=-1;L=t[n>>2]|0;s=i;return L|0}return 0}function Vv(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;t[u>>2]=0;if(!(t[(t[n>>2]|0)+168>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[n>>2]|0)+168>>2]|0))break;t[f>>2]=t[(t[(t[n>>2]|0)+164>>2]|0)+(t[a>>2]<<2)>>2];if(!(t[(t[f>>2]|0)+48>>2]|0)){t[(t[n>>2]|0)+108>>2]=t[f>>2];BL(t[n>>2]|0,1827,t[f>>2]|0,0);t[u>>2]=1827}t[a>>2]=(t[a>>2]|0)+1}t[(t[n>>2]|0)+108>>2]=t[(t[(t[n>>2]|0)+100>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2];t[r>>2]=t[u>>2];o=t[r>>2]|0;s=i;return o|0}function qv(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0;f=s;s=s+16|0;u=f+4|0;a=f;t[f+12>>2]=e;t[f+8>>2]=i;t[u>>2]=r;t[a>>2]=n;t[(t[a>>2]|0)+44>>2]=t[u>>2];s=f;return}function Yv(e,i,r,n,f,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;l=s;s=s+64|0;b=l+56|0;k=l+52|0;h=l+48|0;w=l+40|0;d=l+36|0;v=l+32|0;m=l+28|0;_=l+24|0;p=l+20|0;E=l+16|0;S=l+12|0;g=l+8|0;y=l+4|0;F=l;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[l+44>>2]=n;t[w>>2]=f;t[d>>2]=a;t[v>>2]=o;t[m>>2]=c;t[_>>2]=0;t[p>>2]=0;bw(p,t[b>>2]|0,t[h>>2]|0)|0;t[p>>2]=us(t[p>>2]|0,t[w>>2]|0)|0;t[p>>2]=us(t[p>>2]|0,144352)|0;if(((t[d>>2]|0)+(t[v>>2]|0)|0)<=0){t[p>>2]=us(t[p>>2]|0,140352)|0;O=t[b>>2]|0;A=t[k>>2]|0;M=t[h>>2]|0;R=t[p>>2]|0;pd(O,A,M,R,0,0);N=t[33934]|0;T=t[p>>2]|0;pAi[N&511](T);s=l;return}if(((t[d>>2]|0)+(t[v>>2]|0)|0)>1)t[_>>2]=Yl(144360)|0;else t[_>>2]=Yl(144384)|0;t[S>>2]=0;t[F>>2]=0;while(1){if((t[F>>2]|0)>=((t[d>>2]|0)+(t[v>>2]|0)|0))break;t[g>>2]=t[(t[m>>2]|0)+(t[F>>2]<<2)>>2];do if(t[g>>2]|0){if((((u[t[g>>2]>>0]|0|0)==110?(u[(t[g>>2]|0)+1>>0]|0|0)==111:0)?(u[(t[g>>2]|0)+2>>0]|0|0)==116:0)?(u[(t[g>>2]|0)+3>>0]|0|0)==32:0){t[g>>2]=(t[g>>2]|0)+4;t[_>>2]=us(t[_>>2]|0,144400)|0}t[E>>2]=0;t[y>>2]=t[g>>2];if((u[t[y>>2]>>0]|0|0)==42){t[E>>2]=Yl(140432)|0;t[y>>2]=(t[y>>2]|0)+1}else{while(1){if(!(u[t[y>>2]>>0]|0))break;if((u[t[y>>2]>>0]|0|0)==124)break;t[y>>2]=(t[y>>2]|0)+1}t[E>>2]=fs(t[E>>2]|0,t[g>>2]|0,(t[y>>2]|0)-(t[g>>2]|0)|0)|0}if(u[t[y>>2]>>0]|0){t[y>>2]=(t[y>>2]|0)+1;if(((t[v>>2]|0)!=0?(u[t[y>>2]>>0]|0|0)==42:0)?(u[t[E>>2]>>0]|0|0)==42:0){if(!(t[E>>2]|0))break;pAi[t[135736>>2]&511](t[E>>2]|0);t[E>>2]=0;break}t[g>>2]=t[y>>2];if((u[t[y>>2]>>0]|0|0)==42)t[S>>2]=Yl(144408)|0;else{while(1){if(!(u[t[y>>2]>>0]|0))break;t[y>>2]=(t[y>>2]|0)+1}if((t[F>>2]|0)>=(t[d>>2]|0))t[S>>2]=Yl(144416)|0;else t[S>>2]=Yl(144432)|0;t[S>>2]=fs(t[S>>2]|0,t[g>>2]|0,(t[y>>2]|0)-(t[g>>2]|0)|0)|0;t[S>>2]=us(t[S>>2]|0,144440)|0}t[_>>2]=us(t[_>>2]|0,t[S>>2]|0)|0;if(t[S>>2]|0){pAi[t[135736>>2]&511](t[S>>2]|0);t[S>>2]=0}}t[_>>2]=us(t[_>>2]|0,t[E>>2]|0)|0;if(t[E>>2]|0){pAi[t[135736>>2]&511](t[E>>2]|0);t[E>>2]=0}if((t[F>>2]|0)<((t[d>>2]|0)+(t[v>>2]|0)-1|0))t[_>>2]=us(t[_>>2]|0,144448)|0}while(0);t[F>>2]=(t[F>>2]|0)+1}t[_>>2]=us(t[_>>2]|0,144456)|0;t[p>>2]=us(t[p>>2]|0,t[_>>2]|0)|0;if(!(t[_>>2]|0)){O=t[b>>2]|0;A=t[k>>2]|0;M=t[h>>2]|0;R=t[p>>2]|0;pd(O,A,M,R,0,0);N=t[33934]|0;T=t[p>>2]|0;pAi[N&511](T);s=l;return}pAi[t[135736>>2]&511](t[_>>2]|0);t[_>>2]=0;O=t[b>>2]|0;A=t[k>>2]|0;M=t[h>>2]|0;R=t[p>>2]|0;pd(O,A,M,R,0,0);N=t[33934]|0;T=t[p>>2]|0;pAi[N&511](T);s=l;return}function Gv(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;n=t[a>>2]|0;a=t[c>>2]|0;c=t[l>>2]|0;if(t[(t[o>>2]|0)+32>>2]&16){t[u>>2]=nh(n,0,a,c,(t[o>>2]|0)+24|0,1,1,0)|0;b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=nh(n,0,a,c,0,1,0,0)|0;b=t[u>>2]|0;s=f;return b|0}return 0}function Wv(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[l>>2]=t[(t[u>>2]|0)+108>>2];if(!((t[t[(t[l>>2]|0)+28>>2]>>2]|0)!=5?(t[(t[(t[l>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0))b=3;do if(((b|0)==3?(t[(t[(t[l>>2]|0)+28>>2]|0)+52>>2]|0)!=4:0)?(t[(t[(t[l>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0){if((t[(t[(t[l>>2]|0)+28>>2]|0)+52>>2]|0)==3?(mL(t[(t[(t[l>>2]|0)+28>>2]|0)+28>>2]|0)|0)!=0:0)break;t[c>>2]=3059;th(t[u>>2]|0,t[c>>2]|0,0,0,144160,0,0);t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}while(0);do if((t[t[(t[l>>2]|0)+28>>2]>>2]|0)==4)b=11;else{if((t[t[(t[l>>2]|0)+28>>2]>>2]|0)==1?(t[(t[(t[l>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){b=11;break}if((t[(t[(t[l>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(t[(t[(t[l>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;t[c>>2]=nh(t[u>>2]|0,0,t[(t[(t[l>>2]|0)+28>>2]|0)+104>>2]|0,t[a>>2]|0,t[o>>2]|0,1,1,0)|0}while(0);if((b|0)==11)t[c>>2]=nh(t[u>>2]|0,0,t[(t[l>>2]|0)+28>>2]|0,t[a>>2]|0,t[o>>2]|0,1,1,0)|0;if((t[c>>2]|0)<0)rh(t[u>>2]|0,144320,141832);t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}function Kv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0;r=s;s=s+128|0;n=r+124|0;f=r+120|0;u=r+116|0;a=r+112|0;o=r+108|0;c=r+104|0;l=r+100|0;b=r+96|0;k=r+92|0;h=r+88|0;w=r+84|0;d=r+80|0;v=r+76|0;m=r+72|0;_=r+68|0;p=r+64|0;E=r+60|0;S=r+56|0;g=r+52|0;y=r+48|0;F=r+44|0;O=r+40|0;A=r+36|0;M=r+32|0;R=r+28|0;N=r+24|0;T=r+20|0;L=r+16|0;D=r+12|0;C=r+8|0;P=r+4|0;B=r;t[f>>2]=e;t[u>>2]=i;t[b>>2]=0;t[k>>2]=t[(t[(t[f>>2]|0)+108>>2]|0)+28>>2];t[h>>2]=0;if(!(t[(t[f>>2]|0)+116>>2]|0)){t[n>>2]=0;I=t[n>>2]|0;s=r;return I|0}t[a>>2]=t[(t[f>>2]|0)+116>>2];e:while(1){if(!(t[a>>2]|0)){H=103;break}t[c>>2]=gj(t[(t[a>>2]|0)+32>>2]|0)|0;if((t[c>>2]|0)==-1){H=6;break}do if(t[(t[a>>2]|0)+16>>2]|0){t[l>>2]=t[(t[(t[a>>2]|0)+12>>2]|0)+((t[(t[a>>2]|0)+16>>2]|0)-1<<2)>>2];i=t[a>>2]|0;if((t[l>>2]|0)!=(t[u>>2]|0)){t[a>>2]=t[i+4>>2];continue e}if((t[i>>2]|0)!=2){if((t[t[a>>2]>>2]|0)==1){t[S>>2]=0;t[y>>2]=t[(t[a>>2]|0)+24>>2];t[F>>2]=t[(t[(t[y>>2]|0)+16>>2]|0)+4>>2];t[N>>2]=t[(t[F>>2]|0)+32>>2];t[A>>2]=(t[u>>2]|0)-(t[(t[y>>2]|0)+4>>2]|0);do if((t[(t[y>>2]|0)+24>>2]|0)!=0?(t[(t[y>>2]|0)+28>>2]|0)>(t[A>>2]|0):0){t[S>>2]=(t[(t[y>>2]|0)+24>>2]|0)+(t[A>>2]<<2);if(!(t[t[S>>2]>>2]|0))if((t[t[F>>2]>>2]|0)==23){H=91;break}else break;t[M>>2]=0;while(1){if((t[M>>2]|0)>=(t[N>>2]|0))break;if(!(t[(t[t[S>>2]>>2]|0)+(t[M>>2]<<2)>>2]|0)){H=61;break}t[M>>2]=(t[M>>2]|0)+1}if((H|0)==61){H=0;if((t[t[F>>2]>>2]|0)==23){H=91;break}else break}t[O>>2]=xL(t[f>>2]|0,t[y>>2]|0)|0;if((t[t[F>>2]>>2]|0)!=24?(t[(t[O>>2]|0)+4>>2]|0)!=0:0){t[M>>2]=0;t[c>>2]=0;do{t[D>>2]=t[(t[(t[t[O>>2]>>2]|0)+(t[M>>2]<<2)>>2]|0)+4>>2];t[R>>2]=0;while(1){if((t[R>>2]|0)>=(t[N>>2]|0))break;t[T>>2]=t[(t[t[S>>2]>>2]|0)+(t[R>>2]<<2)>>2];t[L>>2]=t[(t[D>>2]|0)+(t[R>>2]<<2)>>2];t[c>>2]=Od(t[(t[T>>2]|0)+4>>2]|0,t[(t[L>>2]|0)+4>>2]|0)|0;if((t[c>>2]|0)==-1){H=69;break e}if(!(t[c>>2]|0))break;t[R>>2]=(t[R>>2]|0)+1}if((t[c>>2]|0)==1)break;t[M>>2]=(t[M>>2]|0)+1}while((t[M>>2]|0)<(t[(t[O>>2]|0)+4>>2]|0));if((t[M>>2]|0)!=(t[(t[O>>2]|0)+4>>2]|0)){t[C>>2]=0;t[P>>2]=0;i=t[f>>2]|0;e=t[F>>2]|0;x=UL(t[f>>2]|0,C,t[t[S>>2]>>2]|0,t[N>>2]|0)|0;th(i,1877,0,e,143312,x,IL(P,t[F>>2]|0)|0);if(t[C>>2]|0){pAi[t[135736>>2]&511](t[C>>2]|0);t[C>>2]=0}if(!(t[P>>2]|0))break;pAi[t[135736>>2]&511](t[P>>2]|0);t[P>>2]=0;break}}t[g>>2]=gAi[t[135744>>2]&511](16)|0;if(!(t[g>>2]|0)){H=80;break e}x=t[g>>2]|0;t[x+0>>2]=0;t[x+4>>2]=0;t[x+8>>2]=0;t[x+12>>2]=0;x=t[f>>2]|0;if((t[t[F>>2]>>2]|0)==24){e=jL(x,t[(t[(t[f>>2]|0)+108>>2]|0)+12>>2]|0,t[(t[(t[f>>2]|0)+108>>2]|0)+16>>2]|0)|0;t[(t[g>>2]|0)+12>>2]=e;if((t[(t[g>>2]|0)+12>>2]|0)==-1){H=86;break e}}else{if((zL(x,t[g>>2]|0)|0)==-1){H=83;break e}t[(t[g>>2]|0)+12>>2]=-1}t[t[g>>2]>>2]=t[(t[f>>2]|0)+60>>2];t[(t[g>>2]|0)+8>>2]=t[(t[(t[f>>2]|0)+108>>2]|0)+8>>2];t[(t[g>>2]|0)+4>>2]=t[t[S>>2]>>2];t[t[S>>2]>>2]=0;if((Cd(t[O>>2]|0,t[g>>2]|0)|0)==-1){H=88;break e}}else H=55;while(0);if((H|0)==55?(H=0,(t[t[F>>2]>>2]|0)==23):0)H=91;if((H|0)==91?(H=0,t[B>>2]=0,x=t[f>>2]|0,e=t[F>>2]|0,th(x,1877,0,e,143384,IL(B,t[F>>2]|0)|0,0),(t[B>>2]|0)!=0):0){pAi[t[135736>>2]&511](t[B>>2]|0);t[B>>2]=0}if((t[S>>2]|0)!=0?(t[t[S>>2]>>2]|0)!=0:0){pAi[t[135736>>2]&511](t[t[S>>2]>>2]|0);t[t[S>>2]>>2]=0}}}else{if((t[t[k>>2]>>2]|0)!=5?(t[(t[k>>2]|0)+88>>2]|0)!=45:0)t[h>>2]=t[k>>2];else H=13;do if((H|0)==13){H=0;if((t[(t[k>>2]|0)+52>>2]|0)!=4?(t[(t[k>>2]|0)+52>>2]|0)!=6:0){t[h>>2]=0;break}t[h>>2]=t[(t[k>>2]|0)+104>>2];if(!(t[h>>2]|0)){H=16;break e}}while(0);if(!(t[h>>2]|0)){t[w>>2]=0;e=t[f>>2]|0;x=t[(t[(t[(t[a>>2]|0)+24>>2]|0)+16>>2]|0)+4>>2]|0;i=t[(t[(t[a>>2]|0)+28>>2]|0)+12>>2]|0;th(e,1877,0,x,142904,i,IL(w,t[(t[(t[(t[a>>2]|0)+24>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}i=(t[a>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+-1;break}if((t[b>>2]|0)==0?(t[(t[(t[f>>2]|0)+108>>2]|0)+24>>2]|0)==0:0){th(t[f>>2]|0,1877,0,t[(t[(t[(t[a>>2]|0)+24>>2]|0)+16>>2]|0)+4>>2]|0,142984,0,0);i=(t[a>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+-1;break}t[d>>2]=t[(t[a>>2]|0)+24>>2];t[m>>2]=(t[(t[a>>2]|0)+8>>2]|0)-(t[(t[d>>2]|0)+4>>2]|0);t[_>>2]=t[(t[(t[a>>2]|0)+28>>2]|0)+8>>2];i=t[m>>2]|0;i:do if(t[(t[d>>2]|0)+24>>2]|0){if((i|0)>=(t[(t[d>>2]|0)+28>>2]|0)){t[p>>2]=t[(t[d>>2]|0)+28>>2];x=(t[d>>2]|0)+28|0;t[x>>2]=t[x>>2]<<1;x=MAi[t[135760>>2]&511](t[(t[d>>2]|0)+24>>2]|0,t[(t[d>>2]|0)+28>>2]<<2)|0;t[(t[d>>2]|0)+24>>2]=x;if(!(t[(t[d>>2]|0)+24>>2]|0)){H=35;break e}while(1){if((t[p>>2]|0)>=(t[(t[d>>2]|0)+28>>2]|0))break i;t[(t[(t[d>>2]|0)+24>>2]|0)+(t[p>>2]<<2)>>2]=0;t[p>>2]=(t[p>>2]|0)+1}}}else{if((i|0)>9)t[(t[d>>2]|0)+28>>2]=t[m>>2]<<1;else t[(t[d>>2]|0)+28>>2]=10;x=gAi[t[135744>>2]&511](t[(t[d>>2]|0)+28>>2]<<2)|0;t[(t[d>>2]|0)+24>>2]=x;if(!(t[(t[d>>2]|0)+24>>2]|0)){H=31;break e}VY(t[(t[d>>2]|0)+24>>2]|0,0,t[(t[d>>2]|0)+28>>2]<<2|0)|0}while(0);t[v>>2]=t[(t[(t[d>>2]|0)+24>>2]|0)+(t[m>>2]<<2)>>2];if(t[v>>2]|0){if(t[(t[v>>2]|0)+(t[_>>2]<<2)>>2]|0){t[E>>2]=0;i=t[f>>2]|0;x=t[(t[(t[d>>2]|0)+16>>2]|0)+4>>2]|0;e=t[(t[(t[a>>2]|0)+28>>2]|0)+12>>2]|0;th(i,1877,0,x,143168,e,IL(E,t[(t[(t[d>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(t[E>>2]|0){pAi[t[135736>>2]&511](t[E>>2]|0);t[E>>2]=0}e=(t[a>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+-1;break}}else{t[v>>2]=gAi[t[135744>>2]&511](t[(t[(t[(t[d>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2]<<2)|0;if(!(t[v>>2]|0)){H=44;break e}VY(t[v>>2]|0,0,t[(t[(t[(t[d>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2]<<2|0)|0;
	t[(t[(t[d>>2]|0)+24>>2]|0)+(t[m>>2]<<2)>>2]=t[v>>2]}if(!(t[b>>2]|0)){t[b>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[b>>2]|0)){H=48;break e}t[t[b>>2]>>2]=t[h>>2];t[(t[b>>2]|0)+4>>2]=t[(t[(t[f>>2]|0)+108>>2]|0)+24>>2];t[(t[(t[f>>2]|0)+108>>2]|0)+24>>2]=0;if((HL(t[f>>2]|0,t[b>>2]|0)|0)==-1){H=50;break e}}t[(t[v>>2]|0)+(t[_>>2]<<2)>>2]=t[b>>2]}e=(t[a>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+-1}while(0);if((t[(t[a>>2]|0)+16>>2]|0)==0?(t[(t[a>>2]|0)+8>>2]|0)==(t[u>>2]|0):0){if((t[(t[f>>2]|0)+116>>2]|0)!=(t[a>>2]|0))rh(t[f>>2]|0,142760,143424);t[o>>2]=t[(t[a>>2]|0)+4>>2];t[(t[f>>2]|0)+116>>2]=t[(t[a>>2]|0)+4>>2];t[(t[a>>2]|0)+4>>2]=t[(t[f>>2]|0)+120>>2];t[(t[f>>2]|0)+120>>2]=t[a>>2];t[a>>2]=t[o>>2];continue}t[a>>2]=t[(t[a>>2]|0)+4>>2]}switch(H|0){case 6:{rh(t[f>>2]|0,142760,142792);t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 16:{rh(t[f>>2]|0,142760,142816);t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 31:{kh(0,143088,0);t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 35:{kh(0,143128,0);t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 44:{kh(0,143256,0);t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 48:{kh(0,143288,0);pAi[t[135736>>2]&511](t[v>>2]|0);t[(t[(t[d>>2]|0)+24>>2]|0)+(t[m>>2]<<2)>>2]=0;t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 50:{Qk(t[b>>2]|0);t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 69:{t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 80:{kh(0,143344,0);pAi[t[135736>>2]&511](t[t[S>>2]>>2]|0);t[t[S>>2]>>2]=0;t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 83:{pAi[t[135736>>2]&511](t[g>>2]|0);pAi[t[135736>>2]&511](t[t[S>>2]>>2]|0);t[t[S>>2]>>2]=0;t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 86:{pAi[t[135736>>2]&511](t[g>>2]|0);pAi[t[135736>>2]&511](t[t[S>>2]>>2]|0);t[t[S>>2]>>2]=0;t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 88:{if((t[t[F>>2]>>2]|0)==24){pAi[t[135736>>2]&511](t[(t[g>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[g>>2]|0)}t[n>>2]=-1;I=t[n>>2]|0;s=r;return I|0}case 103:{t[n>>2]=0;I=t[n>>2]|0;s=r;return I|0}}return 0}function Xv(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;r=s;s=s+80|0;n=r+64|0;f=r+60|0;u=r+56|0;a=r+52|0;o=r+48|0;c=r+44|0;l=r+40|0;b=r+36|0;k=r+32|0;h=r+28|0;w=r+24|0;d=r+20|0;v=r+16|0;m=r+12|0;_=r+8|0;p=r+4|0;E=r;t[f>>2]=e;t[u>>2]=i;t[E>>2]=t[(t[u>>2]|0)+56>>2];e:while(1){if(!(t[E>>2]|0)){S=51;break}if(((t[t[(t[(t[E>>2]|0)+16>>2]|0)+4>>2]>>2]|0)!=24?(t[(t[E>>2]|0)+32>>2]|0)!=0:0)?(t[(t[(t[E>>2]|0)+32>>2]|0)+4>>2]|0)!=0:0){do if(!(t[(t[f>>2]|0)+188>>2]|0)){if((t[(t[(t[E>>2]|0)+16>>2]|0)+8>>2]|0)!=-1?(t[(t[(t[E>>2]|0)+16>>2]|0)+8>>2]|0)<=(t[(t[f>>2]|0)+96>>2]|0):0)break;t[E>>2]=t[(t[E>>2]|0)+8>>2];continue e}while(0);t[a>>2]=VL(t[f>>2]|0,t[E>>2]|0)|0;if((t[(t[a>>2]|0)+20>>2]|0)!=0?(t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0){t[p>>2]=t[t[(t[a>>2]|0)+20>>2]>>2];t[w>>2]=t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]}else{t[p>>2]=0;t[w>>2]=0}if(t[(t[a>>2]|0)+8>>2]|0)t[d>>2]=t[(t[a>>2]|0)+12>>2];else t[d>>2]=0;u=t[(t[E>>2]|0)+32>>2]|0;if((t[d>>2]|0)==0&(t[w>>2]|0)==0){t[(t[a>>2]|0)+8>>2]=t[u>>2];t[(t[a>>2]|0)+16>>2]=t[(t[(t[E>>2]|0)+32>>2]|0)+8>>2];t[(t[a>>2]|0)+12>>2]=t[(t[(t[E>>2]|0)+32>>2]|0)+4>>2];t[t[(t[E>>2]|0)+32>>2]>>2]=0;t[(t[(t[E>>2]|0)+32>>2]|0)+8>>2]=0;t[(t[(t[E>>2]|0)+32>>2]|0)+4>>2]=0}else{t[k>>2]=t[u+4>>2];t[_>>2]=t[t[(t[E>>2]|0)+32>>2]>>2];t[h>>2]=t[(t[(t[(t[E>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2];t[c>>2]=0;do{t[v>>2]=t[(t[(t[_>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2];i:do if(t[w>>2]|0){t[l>>2]=0;while(1){if((t[h>>2]|0)==1){t[o>>2]=Od(t[(t[t[v>>2]>>2]|0)+4>>2]|0,t[(t[t[(t[(t[p>>2]|0)+(t[l>>2]<<2)>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((t[o>>2]|0)==-1){S=52;break e}if((t[o>>2]|0)==1)break i}else{t[o>>2]=0;t[m>>2]=t[(t[(t[p>>2]|0)+(t[l>>2]<<2)>>2]|0)+4>>2];t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[h>>2]|0))break;t[o>>2]=Od(t[(t[(t[v>>2]|0)+(t[b>>2]<<2)>>2]|0)+4>>2]|0,t[(t[(t[m>>2]|0)+(t[b>>2]<<2)>>2]|0)+4>>2]|0)|0;if((t[o>>2]|0)==-1){S=52;break e}if(!(t[o>>2]|0))break;t[b>>2]=(t[b>>2]|0)+1}if((t[o>>2]|0)==1)break i}t[l>>2]=(t[l>>2]|0)+1;if((t[l>>2]|0)>=(t[w>>2]|0)){S=33;break}}}else S=33;while(0);i:do if((S|0)==33){S=0;r:do if(t[d>>2]|0){t[l>>2]=0;n:while(1){f:do if((t[h>>2]|0)==1){t[o>>2]=Od(t[(t[t[v>>2]>>2]|0)+4>>2]|0,t[(t[t[(t[(t[(t[a>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((t[o>>2]|0)==-1){S=52;break e}if(t[o>>2]|0)break n}else{t[o>>2]=0;t[m>>2]=t[(t[(t[(t[a>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0)+4>>2];t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[h>>2]|0))break n;t[o>>2]=Od(t[(t[(t[v>>2]|0)+(t[b>>2]<<2)>>2]|0)+4>>2]|0,t[(t[(t[m>>2]|0)+(t[b>>2]<<2)>>2]|0)+4>>2]|0)|0;if((t[o>>2]|0)==-1){S=52;break e}if(!(t[o>>2]|0))break f;t[b>>2]=(t[b>>2]|0)+1}}while(0);t[l>>2]=(t[l>>2]|0)+1;if((t[l>>2]|0)>=(t[d>>2]|0))break r}if((t[(t[a>>2]|0)+20>>2]|0)==0?(u=hh()|0,t[(t[a>>2]|0)+20>>2]=u,(t[(t[a>>2]|0)+20>>2]|0)==0):0){S=52;break e}if((Cd(t[(t[a>>2]|0)+20>>2]|0,t[(t[(t[a>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]|0)|0)==-1){S=52;break e}t[(t[(t[a>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2]=t[(t[(t[a>>2]|0)+8>>2]|0)+((t[(t[a>>2]|0)+12>>2]|0)-1<<2)>>2];u=(t[a>>2]|0)+12|0;t[u>>2]=(t[u>>2]|0)+-1;break i}while(0);if((qL(t[a>>2]|0,t[(t[_>>2]|0)+(t[c>>2]<<2)>>2]|0)|0)==-1){S=52;break e}}while(0);t[c>>2]=(t[c>>2]|0)+1}while((t[c>>2]|0)<(t[k>>2]|0))}t[E>>2]=t[(t[E>>2]|0)+8>>2];continue}t[E>>2]=t[(t[E>>2]|0)+8>>2]}if((S|0)==51){t[n>>2]=0;g=t[n>>2]|0;s=r;return g|0}else if((S|0)==52){t[n>>2]=-1;g=t[n>>2]|0;s=r;return g|0}return 0}function Zv(e){e=e|0;var i=0;i=s;s=s+e|0;s=s+15&-16;return i|0}function Jv(){return s|0}function Qv(e){e=e|0;s=e}function $v(e,i){e=e|0;i=i|0;if(!p){p=e;E=i}}function em(e){e=e|0;n[k>>0]=n[e>>0];n[k+1>>0]=n[e+1>>0];n[k+2>>0]=n[e+2>>0];n[k+3>>0]=n[e+3>>0]}function im(e){e=e|0;n[k>>0]=n[e>>0];n[k+1>>0]=n[e+1>>0];n[k+2>>0]=n[e+2>>0];n[k+3>>0]=n[e+3>>0];n[k+4>>0]=n[e+4>>0];n[k+5>>0]=n[e+5>>0];n[k+6>>0]=n[e+6>>0];n[k+7>>0]=n[e+7>>0]}function rm(e){e=e|0;P=e}function nm(){return P|0}function fm(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,m=0,_=0,p=0,E=0,S=0;r=s;s=s+64|0;f=r;u=r+52|0;a=r+48|0;o=r+44|0;c=r+40|0;l=r+36|0;b=r+32|0;k=r+28|0;h=r+24|0;w=r+20|0;d=r+16|0;m=r+12|0;_=r+8|0;p=r+4|0;t[u>>2]=0;t[a>>2]=e;t[o>>2]=i;t[b>>2]=0;t[k>>2]=0;if((t[a>>2]|0)<=1){tm(t[t[o>>2]>>2]|0);t[u>>2]=1;E=t[u>>2]|0;s=r;return E|0}Ep(20902);t[c>>2]=1;e:while(1){if((t[c>>2]|0)>=(t[a>>2]|0))break;if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,144)|0))break;i:do if((n[t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]>>0]|0)==45){if((MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,152)|0)!=0?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,160)|0)!=0:0){if((MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,176)|0)!=0?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,184)|0)!=0:0){if((MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,208)|0)!=0?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,216)|0)!=0:0){if((MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,232)|0)!=0?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,248)|0)!=0:0){do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,280)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,288)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,296)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,304)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,320)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,328)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,344)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,360)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,376)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,392)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,408)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,416)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,432)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,448)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,464)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,472)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,480)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,488)|0))break;if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,496)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,520)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,536)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,560)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,568)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,592)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,600)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,616)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,624)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,648)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,664)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,688)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,704)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,728)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,744)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,768)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,776)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,792)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,808)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,832)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,848)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,872)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,888)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,912)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,928)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,952)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,960)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,984)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,992)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1016)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1024)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1040)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1048)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1072)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1080)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1096)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1112)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1136)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1144)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1168)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1176)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1200)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1216)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1240)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1256)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1280)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1304)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1328)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1344)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1360)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1376)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1392)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1408)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1432)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1440)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1456)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1464)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1488)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1504)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1528)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1544)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1568)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1584)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1608)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1616)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1656)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1672)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1696)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1704)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1736)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1744)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1768)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1776)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1792)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1800)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1824)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1832)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1856)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1864)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1880)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1888)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1904)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1920)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1944)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1960)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1984)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1992)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2016)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2032)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2056)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2064)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2072)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2088)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2104)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2120)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2144)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2152)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2160)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2176)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2200)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2208)|0))break;if((MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2224)|0)!=0?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2240)|0)!=0:0){S=206;break e}t[564]=(t[564]|0)+1;t[68]=t[68]|131072;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[50]=(t[50]|0)+1;t[554]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[548]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];break i}while(0);t[c>>2]=(t[c>>2]|0)+1;sm(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0);break i}while(0);t[534]=(t[534]|0)+1;break i}while(0);t[68]=t[68]&-65537;break i}while(0);t[68]=t[68]|2048;fA(199);break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[512]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];t[78]=(t[78]|0)+1;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[502]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];t[78]=(t[78]|0)+1;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[494]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];t[78]=(t[78]|0)+1;t[68]=t[68]|2;break i}while(0);t[484]=(t[484]|0)+1;break i}while(0);t[474]=(t[474]|0)+1;break i}while(0);t[468]=(t[468]|0)+1;t[68]=t[68]|512;break i}while(0);t[462]=(t[462]|0)+1;t[50]=(t[50]|0)+1;break i}while(0);t[454]=(t[454]|0)+1;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;if(!(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0))break i;t[440]=FY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0)|0;if((t[440]|0)!=1)break i;t[422]=(t[422]|0)+1;Wp(0)|0;break i}while(0);t[422]=(t[422]|0)+1;t[440]=1;Wp(0)|0;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;i=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0;t[f>>2]=1728;if((jq(i,1720,f)|0)==1){PA(195,196,197,198)|0;break i}else{t[432]=0;break i}}while(0);t[422]=(t[422]|0)+1;Wp(0)|0;t[68]=t[68]|256;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[408]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];P_(1640,1648)|0;break i}while(0);t[400]=(t[400]|0)+1;break i}while(0);t[390]=(t[390]|0)+1;break i}while(0);t[380]=(t[380]|0)+1;t[68]=t[68]|14;break i}while(0);t[370]=(t[370]|0)+1;t[68]=t[68]|14;break i}while(0);t[362]=(t[362]|0)+1;t[68]=t[68]|14;break i}while(0);t[356]=(t[356]|0)+1;t[33952]=1;break i}while(0);t[33956]=1;qp(1)|0;t[68]=t[68]|128;break i}while(0);t[33956]=0;qp(0)|0;t[68]=t[68]|64;break i}while(0);t[308]=(t[308]|0)+1;t[68]=t[68]|1024;t[68]=t[68]|262144;break i}while(0);t[308]=(t[308]|0)+1;t[68]=t[68]|1024;t[68]=t[68]|32768;break i}while(0);t[308]=(t[308]|0)+1;t[68]=t[68]|1024;break i}while(0);t[298]=(t[298]|0)+1;break i}while(0);t[290]=(t[290]|0)+1;break i}while(0);t[272]=(t[272]|0)+1;t[282]=10;break i}while(0);t[272]=(t[272]|0)+1;break i}while(0);if(t[266]|0){t[266]=(t[266]|0)*10;break i}else{t[266]=100;break i}}while(0);t[258]=(t[258]|0)+1;break i}while(0);t[252]=(t[252]|0)+1;break i}while(0);t[244]=(t[244]|0)+1;break i}while(0);t[236]=(t[236]|0)+1;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[226]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];t[180]=(t[180]|0)+1;t[68]=t[68]|4;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[216]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];t[180]=(t[180]|0)+1;t[68]=t[68]|4;break i}while(0);t[206]=(t[206]|0)+1;t[180]=(t[180]|0)+1;t[68]=t[68]|4;break i}while(0);t[196]=(t[196]|0)+1;t[68]=t[68]|16;break i}while(0);t[180]=(t[180]|0)+1;t[190]=(t[190]|0)+1;t[68]=t[68]|8;break i}while(0);t[180]=(t[180]|0)+1;t[68]=t[68]|4;break i}while(0);t[170]=(t[170]|0)+1;t[68]=t[68]|4;break i}while(0);t[160]=(t[160]|0)+1;break i}while(0);t[152]=(t[152]|0)+1;break i}while(0);t[146]=(t[146]|0)+1;break i}while(0);t[138]=(t[138]|0)+1;break i}while(0);t[c>>2]=(t[c>>2]|0)+1;t[128]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];break i}while(0);t[50]=(t[50]|0)+1;break i}while(0);um(t[t[o>>2]>>2]|0);t[k>>2]=1;break i}while(0);t[68]=t[68]|4096;break i}while(0);t[68]=t[68]|16384;break i}while(0);t[68]=t[68]|8192;break i}while(0);t[84]=(t[84]|0)+1;t[68]=t[68]|2097152;break i}while(0);t[78]=(t[78]|0)+1;t[68]=t[68]|2;break i}while(0);t[68]=t[68]|524288;break}t[66]=(t[66]|0)+1;t[68]=t[68]|1;break}t[56]=(t[56]|0)+1;break}t[48]=(t[48]|0)+1;t[50]=1;break}t[42]=(t[42]|0)+1}while(0);t[c>>2]=(t[c>>2]|0)+1}if((S|0)==206){i=t[v>>2]|0;t[f>>2]=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2];xe(i|0,2264,f|0)|0;tm(t[t[o>>2]>>2]|0);t[u>>2]=1;E=t[u>>2]|0;s=r;return E|0}do if((t[400]|0)==0&(t[390]|0)!=0){t[w>>2]=ti(2288)|0;if(t[w>>2]|0){ac(t[w>>2]|0);break}else{xe(t[v>>2]|0,2312,f|0)|0;break}}while(0);if(t[468]|0)ej(1)|0;else ej(2)|0;if(t[484]|0){Gc(200)|0;Wc(201)|0}t[h>>2]=ti(2352)|0;if(t[h>>2]|0)t[33988]=t[h>>2];t[592]=tA()|0;fA(202);Yp(1)|0;if(t[180]|0)t[33958]=t[33958]|2;if(t[190]|0)t[33958]=t[33958]|4;if(t[78]|0)Gp(1)|0;if(t[196]|0)t[33954]=1;if(!((t[138]|0)==0|(t[146]|0)!=0)){yAi[t[135904>>2]&511](t[33980]|0,2376,f);yAi[t[135904>>2]&511](t[33980]|0,2440,f);h=t[33976]|0;w=t[33980]|0;t[f>>2]=t[t[o>>2]>>2];yAi[h&511](w,2488,f);w=t[33976]|0;h=t[33980]|0;t[f>>2]=t[t[o>>2]>>2];yAi[w&511](h,2536,f)}if((t[512]|0)!=0&(t[474]|0)==0&(t[454]|0)==0){t[33958]=t[33958]|1;t[68]=t[68]|4;if(t[252]|0)wm();t[d>>2]=XV(t[512]|0)|0;t[650]=JV(t[d>>2]|0)|0;if(!(t[650]|0)){h=t[33976]|0;w=t[33980]|0;t[f>>2]=t[512];yAi[h&511](w,2608,f);t[662]=5;t[512]=0}ZV(t[d>>2]|0);if(t[252]|0)dm(2656,f)}if((t[494]|0)!=0&(t[474]|0)==0&(t[454]|0)==0){t[33958]=t[33958]|1;t[68]=t[68]|4;if(t[252]|0)wm();t[m>>2]=IH(t[494]|0)|0;UH(t[m>>2]|0,203,203,t[v>>2]|0);t[670]=xH(t[m>>2]|0)|0;if(!(t[670]|0)){d=t[33976]|0;w=t[33980]|0;t[f>>2]=t[494];yAi[d&511](w,2688,f);t[662]=5;t[494]=0}HH(t[m>>2]|0);if(t[252]|0)dm(2656,f)}else if((t[502]|0)!=0&(t[454]|0)==0){if(t[252]|0)wm();t[_>>2]=Mk(t[502]|0)|0;Dk(t[_>>2]|0,203,203,t[v>>2]|0);t[682]=Lk(t[_>>2]|0)|0;if(!(t[682]|0)){m=t[33976]|0;w=t[33980]|0;t[f>>2]=t[502];yAi[m&511](w,2736,f);t[662]=5;t[502]=0}Rk(t[_>>2]|0);if(t[252]|0)dm(2656,f)}if((t[548]|0)!=0&(t[462]|0)==0?(t[694]=Fj(t[548]|0,0,0,0)|0,(t[694]|0)==0):0){_=t[33976]|0;w=t[33980]|0;t[f>>2]=t[548];yAi[_&511](w,2784,f);t[662]=7;t[548]=0}t[c>>2]=1;while(1){if((t[c>>2]|0)>=(t[a>>2]|0))break;e:do if((MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1608)|0)!=0?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1616)|0)!=0:0){do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,480)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,488)|0))break;if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,496)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,832)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,848)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2144)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2152)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,872)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,888)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1944)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1960)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1696)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1704)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1768)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1776)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1984)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,1992)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2016)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2032)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2160)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2176)|0))break;do if(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2200)|0){if(!(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,2208)|0))break;if((t[252]|0)!=0&(t[266]|0)!=0)wm();if((n[t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]>>0]|0)==45?(MY(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,144)|0)!=0:0)break e;do if(t[266]|0){t[p>>2]=0;t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[266]|0))break;do if(t[454]|0)vm(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0);else{if(t[474]|0){mm(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0);break}if(!(t[p>>2]|0))t[p>>2]=zp()|0;_m(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0,t[p>>2]|0)}while(0);t[l>>2]=(t[l>>2]|0)+1}if(!(t[p>>2]|0))break;Up(t[p>>2]|0)}else{t[704]=0;do if(!(t[454]|0)){w=t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0;if(t[474]|0){mm(w);break}else{_m(w,0);break}}else vm(t[(t[o>>2]|0)+(t[c>>2]<<2)>>2]|0);while(0);if(!((t[484]|0)!=0&(t[704]|0)!=0))break;w=t[v>>2]|0;t[f>>2]=t[704];xe(w|0,2824,f|0)|0;t[662]=8}while(0);t[b>>2]=(t[b>>2]|0)+1;if(!((t[252]|0)!=0&(t[266]|0)!=0))break e;t[f>>2]=t[266];dm(2856,f);break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1;break e}while(0);t[c>>2]=(t[c>>2]|0)+1}else S=257;while(0);if((S|0)==257){S=0;t[c>>2]=(t[c>>2]|0)+1}t[c>>2]=(t[c>>2]|0)+1}if(t[258]|0)_m(0,0);if(!((t[138]|0)==0|(t[146]|0)!=0))yAi[t[135904>>2]&511](t[33980]|0,2872,f);if((((t[b>>2]|0)!=0|(t[258]|0)!=0)^1)&(t[k>>2]|0)==0)tm(t[t[o>>2]>>2]|0);if(t[650]|0)KV(t[650]|0);if(t[670]|0)CH(t[670]|0);if(t[682]|0)Ak(t[682]|0);BH();if(t[694]|0)vj(t[694]|0);dS();FA();t[u>>2]=t[662];E=t[u>>2]|0;s=r;return E|0}function tm(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;t[r>>2]=t[n>>2];Je(56872,r|0)|0;Je(56912,r|0)|0;Je(56976,r|0)|0;Je(57040,r|0)|0;Je(57096,r|0)|0;Je(57136,r|0)|0;Je(57200,r|0)|0;Je(57264,r|0)|0;Je(57328,r|0)|0;Je(57384,r|0)|0;Je(57440,r|0)|0;Je(57504,r|0)|0;Je(57552,r|0)|0;Je(57608,r|0)|0;Je(57672,r|0)|0;Je(57736,r|0)|0;Je(57792,r|0)|0;Je(57832,r|0)|0;Je(57880,r|0)|0;Je(57952,r|0)|0;Je(58016,r|0)|0;Je(58088,r|0)|0;Je(58160,r|0)|0;Je(58192,r|0)|0;Je(58248,r|0)|0;Je(58304,r|0)|0;Je(58352,r|0)|0;Je(58384,r|0)|0;Je(58448,r|0)|0;Je(58496,r|0)|0;Je(58544,r|0)|0;Je(58616,r|0)|0;Je(58648,r|0)|0;Je(58712,r|0)|0;Je(58776,r|0)|0;Je(58824,r|0)|0;Je(58880,r|0)|0;Je(58928,r|0)|0;Je(58984,r|0)|0;Je(59040,r|0)|0;Je(59096,r|0)|0;Je(59144,r|0)|0;Je(59208,r|0)|0;Je(59280,r|0)|0;Je(59344,r|0)|0;Je(59408,r|0)|0;Je(59480,r|0)|0;Je(59536,r|0)|0;Je(59576,r|0)|0;Je(59640,r|0)|0;t[r>>2]=59736;Je(59696,r|0)|0;Je(59760,r|0)|0;Je(59800,r|0)|0;Je(59848,r|0)|0;Je(59888,r|0)|0;Je(59952,r|0)|0;Je(60008,r|0)|0;Je(60048,r|0)|0;Je(60120,r|0)|0;Je(60192,r|0)|0;Je(60256,r|0)|0;Je(60312,r|0)|0;Je(60368,r|0)|0;Je(60432,r|0)|0;Je(60496,r|0)|0;Je(60560,r|0)|0;Je(60616,r|0)|0;Je(60680,r|0)|0;Je(60744,r|0)|0;Je(60808,r|0)|0;Je(60856,r|0)|0;s=i;return}function um(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i;n=i+8|0;t[n>>2]=e;e=t[v>>2]|0;f=t[33946]|0;t[r>>2]=t[n>>2];t[r+4>>2]=f;xe(e|0,56440,r|0)|0;xe(t[v>>2]|0,56472,r|0)|0;if(Qp(1)|0)xe(t[v>>2]|0,56496,r|0)|0;if(Qp(2)|0)xe(t[v>>2]|0,56512,r|0)|0;if(Qp(3)|0)xe(t[v>>2]|0,56520,r|0)|0;if(Qp(4)|0)xe(t[v>>2]|0,56528,r|0)|0;if(Qp(5)|0)xe(t[v>>2]|0,56536,r|0)|0;if(Qp(6)|0)xe(t[v>>2]|0,56544,r|0)|0;if(Qp(7)|0)xe(t[v>>2]|0,56560,r|0)|0;if(Qp(8)|0)xe(t[v>>2]|0,56568,r|0)|0;if(Qp(9)|0)xe(t[v>>2]|0,56576,r|0)|0;if(Qp(10)|0)xe(t[v>>2]|0,56584,r|0)|0;if(Qp(11)|0)xe(t[v>>2]|0,56592,r|0)|0;if(Qp(12)|0)xe(t[v>>2]|0,56608,r|0)|0;if(Qp(13)|0)xe(t[v>>2]|0,56616,r|0)|0;if(Qp(14)|0)xe(t[v>>2]|0,56624,r|0)|0;if(Qp(15)|0)xe(t[v>>2]|0,56632,r|0)|0;if(Qp(16)|0)xe(t[v>>2]|0,56648,r|0)|0;if(Qp(17)|0)xe(t[v>>2]|0,56656,r|0)|0;if(Qp(18)|0)xe(t[v>>2]|0,56672,r|0)|0;if(Qp(19)|0)xe(t[v>>2]|0,56688,r|0)|0;if(Qp(20)|0)xe(t[v>>2]|0,56696,r|0)|0;if(Qp(21)|0)xe(t[v>>2]|0,56712,r|0)|0;if(Qp(22)|0)xe(t[v>>2]|0,56728,r|0)|0;if(Qp(23)|0)xe(t[v>>2]|0,56744,r|0)|0;if(Qp(24)|0)xe(t[v>>2]|0,56760,r|0)|0;if(Qp(25)|0)xe(t[v>>2]|0,56768,r|0)|0;if(Qp(26)|0)xe(t[v>>2]|0,56784,r|0)|0;if(Qp(27)|0)xe(t[v>>2]|0,56800,r|0)|0;if(Qp(28)|0)xe(t[v>>2]|0,56816,r|0)|0;if(Qp(29)|0)xe(t[v>>2]|0,56824,r|0)|0;if(Qp(30)|0)xe(t[v>>2]|0,56840,r|0)|0;if(Qp(31)|0)xe(t[v>>2]|0,56856,r|0)|0;if(!(Qp(33)|0)){u=t[v>>2]|0;xe(u|0,3760,r|0)|0;s=i;return}xe(t[v>>2]|0,56864,r|0)|0;u=t[v>>2]|0;xe(u|0,3760,r|0)|0;s=i;return}function am(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;RA(t[r>>2]|0);s=i;return}function om(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=OA(t[n>>2]|0)|0;if((t[f>>2]|0)!=0?(n=LA()|0,(n|0)>(t[432]|0)):0){a_();RA(t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function cm(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=MA(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)!=0?(u=LA()|0,(u|0)>(t[432]|0)):0){a_();RA(t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function lm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=TA(t[n>>2]|0)|0;if((t[f>>2]|0)!=0?(n=LA()|0,(n|0)>(t[432]|0)):0){a_();pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function sm(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+16|0;r=i;n=i+8|0;f=i+4|0;t[n>>2]=e;if(!(t[n>>2]|0)){s=i;return}while(1){if(!(u[t[n>>2]>>0]|0)){a=20;break}if((t[13962]|0)>=64)break;t[f>>2]=t[n>>2];while(1){if((u[t[f>>2]>>0]|0|0)==32)o=1;else o=(u[t[f>>2]>>0]|0|0)==58;c=t[f>>2]|0;if(!o)break;t[f>>2]=c+1}t[n>>2]=c;while(1){if((u[t[f>>2]>>0]|0|0)!=0?(u[t[f>>2]>>0]|0|0)!=32:0)l=(u[t[f>>2]>>0]|0|0)!=58;else l=0;b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if((b|0)==(t[n>>2]|0))continue;e=ql(t[n>>2]|0,(t[f>>2]|0)-(t[n>>2]|0)|0)|0;t[55888+(t[13962]<<2)>>2]=e;if(t[55888+(t[13962]<<2)>>2]|0)t[13962]=(t[13962]|0)+1;t[n>>2]=t[f>>2]}if((a|0)==20){s=i;return}xe(t[v>>2]|0,56360,r|0)|0;s=i;return}function bm(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i+4|0;t[r>>2]=e;e=Xq(4)|0;t[t[r>>2]>>2]=e;if(!(t[t[r>>2]>>2]|0)){xe(t[v>>2]|0,56312,i|0)|0;_i(9)}else{t[t[t[r>>2]>>2]>>2]=-2123209900;t[704]=(t[704]|0)+1;s=i;return}}function km(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[t[r>>2]>>2]|0))De(56200,56224,3119,56248);if((t[t[t[r>>2]>>2]>>2]|0)==-2123209900){Zq(t[t[r>>2]>>2]|0);t[704]=(t[704]|0)+-1;s=i;return}else De(56264,56224,3120,56248)}function hm(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,m=0,_=0,p=0,E=0;f=s;s=s+64|0;u=f;a=f+48|0;o=f+44|0;c=f+40|0;l=f+36|0;b=f+32|0;k=f+28|0;h=f+24|0;w=f+20|0;d=f+16|0;m=f+12|0;_=f+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[k>>2]=0;t[h>>2]=0;t[d>>2]=t[o>>2];t[m>>2]=t[o>>2];e:do if((t[13962]|0)>0&(t[m>>2]|0)!=0)while(1){if(!(n[t[m>>2]>>0]|0))break e;if((n[t[m>>2]>>0]|0)==47)t[d>>2]=(t[m>>2]|0)+1;t[m>>2]=(t[m>>2]|0)+1}while(0);if((t[l>>2]|0)!=0?(t[t[l>>2]>>2]|0)!=0:0){t[k>>2]=t[(t[t[l>>2]>>2]|0)+84>>2];t[h>>2]=t[(t[t[l>>2]>>2]|0)+88>>2];t[(t[t[l>>2]>>2]|0)+84>>2]=0;t[(t[t[l>>2]>>2]|0)+88>>2]=0}if((t[592]|0)!=0?(t[b>>2]=dAi[t[2368>>2]&511](t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0,(t[b>>2]|0)!=0):0){if(t[k>>2]|0)t[(t[t[l>>2]>>2]|0)+84>>2]=t[k>>2];if(t[h>>2]|0)t[(t[t[l>>2]>>2]|0)+88>>2]=t[h>>2];if(t[534]|0){m=t[v>>2]|0;r=(t[c>>2]|0)!=0?t[c>>2]|0:55152;t[u>>2]=(t[o>>2]|0)!=0?t[o>>2]|0:55152;t[u+4>>2]=r;xe(m|0,55856,u|0)|0}t[a>>2]=t[b>>2];p=t[a>>2]|0;s=f;return p|0}t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[13962]|0))break;t[_>>2]=Yl(t[55888+(t[w>>2]<<2)>>2]|0)|0;t[_>>2]=us(t[_>>2]|0,56152)|0;t[_>>2]=us(t[_>>2]|0,t[d>>2]|0)|0;if(t[_>>2]|0){t[b>>2]=dAi[t[2368>>2]&511](t[_>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;if(t[b>>2]|0){E=22;break}pAi[t[135736>>2]&511](t[_>>2]|0)}t[w>>2]=(t[w>>2]|0)+1}if((E|0)==22){if(t[k>>2]|0)t[(t[t[l>>2]>>2]|0)+84>>2]=t[k>>2];if(t[h>>2]|0)t[(t[t[l>>2]>>2]|0)+88>>2]=t[h>>2];if(t[534]|0){E=t[v>>2]|0;w=(t[c>>2]|0)!=0?t[c>>2]|0:55152;t[u>>2]=t[_>>2];t[u+4>>2]=w;xe(E|0,55856,u|0)|0}pAi[t[135736>>2]&511](t[_>>2]|0);t[a>>2]=t[b>>2];p=t[a>>2]|0;s=f;return p|0}if(t[h>>2]|0)t[(t[t[l>>2]>>2]|0)+88>>2]=t[h>>2];do if(t[k>>2]|0){t[(t[t[l>>2]>>2]|0)+84>>2]=t[k>>2];if(t[o>>2]|0){h=t[k>>2]|0;b=t[l>>2]|0;t[u>>2]=t[o>>2];yAi[h&511](b,56160,u);break}if(t[c>>2]|0){b=t[k>>2]|0;h=t[l>>2]|0;t[u>>2]=t[c>>2];yAi[b&511](h,56160,u)}}while(0);t[a>>2]=0;p=t[a>>2]|0;s=f;return p|0}function wm(){var e=0;e=s;wi(55824,0)|0;s=e;return}function dm(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+32|0;n=r;f=r+28|0;u=r+24|0;a=r+8|0;t[f>>2]=e;wi(55816,0)|0;t[u>>2]=(t[13954]|0)-(t[13956]|0);t[u>>2]=(t[u>>2]|0)*1e3;t[u>>2]=(t[u>>2]|0)+(((t[13955]|0)-(t[13957]|0)|0)/1e3|0);t[a>>2]=i;Te(t[v>>2]|0,t[f>>2]|0,a|0)|0;a=t[v>>2]|0;t[n>>2]=t[u>>2];xe(a|0,55832,n|0)|0;s=r;return}function vm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+112|0;r=i;n=i+100|0;f=i+96|0;u=i+92|0;a=i+88|0;o=i+12|0;c=i+8|0;l=i+4|0;t[n>>2]=e;t[a>>2]=-1;t[c>>2]=0;t[l>>2]=0;e=t[n>>2]|0;do if(t[290]|0){if((ri(e|0,o|0)|0)<0){s=i;return}b=Ue(t[n>>2]|0,0,r|0)|0;t[a>>2]=b;if((b|0)<0){s=i;return}t[c>>2]=vi(0,t[o+36>>2]|0,1,1,t[a>>2]|0,0)|0;if((t[c>>2]|0)!=(-1|0)){t[f>>2]=JI(t[c>>2]|0,t[o+36>>2]|0,t[n>>2]|0,0,t[68]|0)|0;break}Ge(t[a>>2]|0)|0;b=t[v>>2]|0;t[r>>2]=t[n>>2];xe(b|0,2920,r|0)|0;t[662]=4;s=i;return}else t[f>>2]=QI(e,0,t[68]|0)|0;while(0);if((t[548]|0)!=0?(t[694]=Fj(t[548]|0,0,0,0)|0,(t[694]|0)==0):0){e=t[33976]|0;b=t[33980]|0;t[r>>2]=t[548];yAi[e&511](b,2784,r);t[662]=7;t[548]=0}if(((t[694]|0)!=0?(t[898]=Aj(t[694]|0)|0,(t[898]|0)!=0):0)?(t[u>>2]=pj(t[898]|0,0,0)|0,(t[u>>2]|0)<0):0){xe(t[v>>2]|0,3600,r|0)|0;_j(t[898]|0);t[898]=0}if(t[f>>2]|0){if(!(t[196]|0)){if(t[180]|0)qI(t[f>>2]|0,1,1)|0}else qI(t[f>>2]|0,3,1)|0;if(t[494]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[u>>2]=WI(t[f>>2]|0,t[494]|0)|0;if((t[u>>2]|0)<0){b=t[33976]|0;e=t[33980]|0;t[r>>2]=t[494];yAi[b&511](e,2688,r);t[662]=5;t[494]=0}if(!((t[252]|0)==0|(t[266]|0)!=0))dm(2656,r)}if(t[502]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[u>>2]=GI(t[f>>2]|0,t[502]|0)|0;if((t[u>>2]|0)<0){e=t[33976]|0;b=t[33980]|0;t[r>>2]=t[502];yAi[e&511](b,55704,r);t[662]=5;t[502]=0}if(!((t[252]|0)==0|(t[266]|0)!=0))dm(2656,r)}if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[u>>2]=RI(t[f>>2]|0)|0;while(1){if((t[u>>2]|0)!=1)break;if((t[42]|0)!=0|(t[694]|0)!=0)Rm(t[f>>2]|0);t[u>>2]=RI(t[f>>2]|0)|0}do if(!((t[252]|0)==0|(t[266]|0)!=0)){if(t[494]|0){dm(55744,r);break}if(t[196]|0){dm(55744,r);break}else{dm(2952,r);break}}while(0);if((t[196]|0)!=0?(KI(t[f>>2]|0)|0)!=1:0){b=t[33976]|0;e=t[33980]|0;t[r>>2]=t[n>>2];yAi[b&511](e,3448,r);t[662]=3}do if((t[494]|0)!=0|(t[502]|0)!=0){e=(KI(t[f>>2]|0)|0)!=1;b=t[v>>2]|0;k=t[n>>2]|0;if(e){t[r>>2]=k;xe(b|0,3512,r|0)|0;t[662]=3;break}else{t[r>>2]=k;xe(b|0,3496,r|0)|0;break}}while(0);CI(t[f>>2]|0);if(t[u>>2]|0){u=t[v>>2]|0;t[r>>2]=t[n>>2];xe(u|0,55768,r|0)|0;t[662]=1}}else{u=t[v>>2]|0;t[r>>2]=t[n>>2];xe(u|0,55792,r|0)|0;t[662]=1}if(t[898]|0){_j(t[898]|0);t[898]=0}if(!(t[290]|0)){s=i;return}IO(t[l>>2]|0);Ke(t[c>>2]|0,t[o+36>>2]|0)|0;Ge(t[a>>2]|0)|0;s=i;return}function mm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+48|0;r=i;n=i+36|0;f=i+32|0;u=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+4|0;t[n>>2]=e;t[u>>2]=54320;t[a>>2]=0;t[c>>2]=0;t[l>>2]=0;t[13584]=0;do if(!(t[50]|0))if(t[468]|0){t[f>>2]=t[34];break}else{t[f>>2]=t[13588];break}else t[f>>2]=t[13586];while(0);t[a>>2]=zO(t[n>>2]|0,0)|0;do if(t[a>>2]|0){if(!(t[682]|0)){t[c>>2]=zp()|0;if(!(t[c>>2]|0)){IO(t[a>>2]|0);break}t[l>>2]=t[t[c>>2]>>2];t[t[c>>2]>>2]=t[f>>2];t[(t[c>>2]|0)+4>>2]=t[u>>2];t[o>>2]=Pp(t[c>>2]|0,t[a>>2]|0,0)|0;if(!(t[o>>2]|0)){IO(t[a>>2]|0);break}eE(t[c>>2]|0,t[o>>2]|0)|0;iS(t[c>>2]|0)|0;if(!(t[(t[c>>2]|0)+8>>2]|0))break;xe(t[v>>2]|0,54360,r|0)|0;fy(t[(t[c>>2]|0)+8>>2]|0);t[(t[c>>2]|0)+8>>2]=0;break}t[k>>2]=Ik(t[682]|0)|0;Ck(t[k>>2]|0,203,203,t[v>>2]|0);Hk(t[k>>2]|0,t[n>>2]|0);t[b>>2]=qk(t[k>>2]|0,t[a>>2]|0,0,t[f>>2]|0,t[u>>2]|0)|0;do if(!(t[266]|0)){if(!(t[b>>2]|0)){e=t[v>>2]|0;t[r>>2]=t[n>>2];xe(e|0,3496,r|0)|0;break;
	}e=t[v>>2]|0;h=t[n>>2]|0;if((t[b>>2]|0)>0){t[r>>2]=h;xe(e|0,3512,r|0)|0;t[662]=3;break}else{t[r>>2]=h;xe(e|0,3536,r|0)|0;t[662]=3;break}}while(0);Nk(t[k>>2]|0)}while(0);if(!(t[c>>2]|0)){s=i;return}t[t[c>>2]>>2]=t[l>>2];Up(t[c>>2]|0);s=i;return}function _m(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,te=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0;r=s;s=s+6512|0;f=r;u=r+1376|0;a=r+1372|0;o=r+1368|0;c=r+1364|0;l=r+1360|0;b=r+1356|0;k=r+1352|0;h=r+2408|0;w=r+1348|0;d=r+1344|0;p=r+1268|0;E=r+1264|0;S=r+1260|0;g=r+1256|0;y=r+1252|0;F=r+1248|0;O=r+1384|0;A=r+1244|0;M=r+1240|0;R=r+1236|0;N=r+1232|0;T=r+1156|0;L=r+1152|0;D=r+1148|0;C=r+1144|0;P=r+120|0;B=r+112|0;I=r+108|0;H=r+104|0;x=r+100|0;U=r+96|0;z=r+92|0;j=r+88|0;V=r+84|0;q=r+80|0;Y=r+76|0;G=r+72|0;W=r+68|0;K=r+64|0;X=r+60|0;Z=r+56|0;J=r+52|0;Q=r+48|0;$=r+44|0;ee=r+40|0;ie=r+36|0;re=r+32|0;ne=r+28|0;fe=r+24|0;te=r+20|0;ue=r+16|0;ae=r+12|0;oe=r+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;if(!((t[252]|0)==0|(t[266]|0)!=0))wm();do if(!(t[u>>2]|0)){if(t[258]|0){t[o>>2]=ny(2888)|0;t[l>>2]=Sy(t[o>>2]|0,0,2896,0)|0;Cy(t[l>>2]|0,2904);iF(t[o>>2]|0,t[l>>2]|0)|0}}else{if((t[152]|0)!=0&(t[272]|0)!=0){t[b>>2]=mi(t[u>>2]|0,2912)|0;if(!(t[b>>2]|0))break;t[k>>2]=Re(h|0,1,4,t[b>>2]|0)|0;if((t[k>>2]|0)>0){t[w>>2]=ON(0,0,h,t[k>>2]|0,t[u>>2]|0,0)|0;mS(t[w>>2]|0,t[68]|0)|0;while(1){i=Re(h|0,1,t[282]|0,t[b>>2]|0)|0;t[k>>2]=i;ce=t[w>>2]|0;if((i|0)<=0)break;FN(ce,h,t[k>>2]|0,0)|0}FN(ce,h,0,1)|0;t[o>>2]=t[(t[w>>2]|0)+8>>2];SN(t[w>>2]|0)}Qe(t[b>>2]|0)|0;break}if((t[152]|0)!=0&(t[290]|0)!=0){if((ri(t[u>>2]|0,p|0)|0)<0){s=r;return}i=Ue(t[u>>2]|0,0,f|0)|0;t[d>>2]=i;if((i|0)<0){s=r;return}t[E>>2]=vi(0,t[p+36>>2]|0,1,1,t[d>>2]|0,0)|0;if((t[E>>2]|0)!=(-1|0)){t[o>>2]=LN(t[E>>2]|0,t[p+36>>2]|0,t[u>>2]|0,0,t[68]|0)|0;Ke(t[E>>2]|0,t[p+36>>2]|0)|0;Ge(t[d>>2]|0)|0;break}Ge(t[d>>2]|0)|0;i=t[v>>2]|0;t[f>>2]=t[u>>2];xe(i|0,2920,f|0)|0;t[662]=4;s=r;return}if(t[152]|0){t[o>>2]=TN(t[u>>2]|0,0,t[68]|0)|0;break}if(t[272]|0){if((n[t[u>>2]>>0]|0)==45?(n[(t[u>>2]|0)+1>>0]|0)==0:0)t[S>>2]=t[m>>2];else t[S>>2]=mi(t[u>>2]|0,2912)|0;if(!(t[S>>2]|0))break;t[F>>2]=1024;t[y>>2]=Re(O|0,1,4,t[S>>2]|0)|0;if((t[y>>2]|0)>0){t[A>>2]=fS(0,0,O,t[y>>2]|0,t[u>>2]|0)|0;mS(t[A>>2]|0,t[68]|0)|0;while(1){i=Re(O|0,1,t[F>>2]|0,t[S>>2]|0)|0;t[y>>2]=i;le=t[A>>2]|0;if((i|0)<=0)break;nS(le,O,t[y>>2]|0,0)|0}nS(le,O,0,1)|0;t[o>>2]=t[(t[A>>2]|0)+8>>2];t[g>>2]=t[(t[A>>2]|0)+12>>2];Up(t[A>>2]|0);if(!(t[g>>2]|0)){fy(t[o>>2]|0);t[o>>2]=0}}if((t[S>>2]|0)==(t[m>>2]|0))break;Qe(t[S>>2]|0)|0;break}if(t[298]|0){if((n[t[u>>2]>>0]|0)==45?(n[(t[u>>2]|0)+1>>0]|0)==0:0){t[o>>2]=ES(0,0,0,t[68]|0)|0;break}t[M>>2]=mi(t[u>>2]|0,2912)|0;if(!(t[M>>2]|0)){t[o>>2]=0;break}if(!(t[a>>2]|0)){t[o>>2]=SS(204,205,t[M>>2]|0,t[u>>2]|0,0,t[68]|0)|0;break}else{t[o>>2]=FS(t[a>>2]|0,204,205,t[M>>2]|0,t[u>>2]|0,0,t[68]|0)|0;break}}if(t[138]|0){if(!(t[a>>2]|0))t[R>>2]=zp()|0;else t[R>>2]=t[a>>2];if(!(t[R>>2]|0)){t[o>>2]=0;break}t[(t[t[R>>2]>>2]|0)+88>>2]=206;t[(t[t[R>>2]>>2]|0)+84>>2]=207;t[(t[R>>2]|0)+112>>2]=208;t[(t[R>>2]|0)+116>>2]=209;t[o>>2]=gS(t[R>>2]|0,t[u>>2]|0,0,t[68]|0)|0;if(t[a>>2]|0)break;Up(t[R>>2]|0);break}if(t[290]|0){if((ri(t[u>>2]|0,T|0)|0)<0){s=r;return}i=Ue(t[u>>2]|0,0,f|0)|0;t[N>>2]=i;if((i|0)<0){s=r;return}t[L>>2]=vi(0,t[T+36>>2]|0,1,1,t[N>>2]|0,0)|0;if((t[L>>2]|0)==(-1|0)){Ge(t[N>>2]|0)|0;i=t[v>>2]|0;t[f>>2]=t[u>>2];xe(i|0,2920,f|0)|0;t[662]=4;s=r;return}if(!(t[a>>2]|0))t[o>>2]=pS(t[L>>2]|0,t[T+36>>2]|0,t[u>>2]|0,0,t[68]|0)|0;else t[o>>2]=yS(t[a>>2]|0,t[L>>2]|0,t[T+36>>2]|0,t[u>>2]|0,0,t[68]|0)|0;Ke(t[L>>2]|0,t[T+36>>2]|0)|0;Ge(t[N>>2]|0)|0;break}if(!(t[196]|0)){if(t[a>>2]|0){t[o>>2]=gS(t[a>>2]|0,t[u>>2]|0,0,t[68]|0)|0;break}i=t[u>>2]|0;if(t[468]|0){t[o>>2]=wS(i)|0;break}else{t[o>>2]=_S(i,0,t[68]|0)|0;break}}t[D>>2]=0;if(!(t[a>>2]|0))t[D>>2]=zp()|0;else t[D>>2]=t[a>>2];if(!(t[D>>2]|0)){t[o>>2]=0;break}t[o>>2]=gS(t[D>>2]|0,t[u>>2]|0,0,t[68]|0)|0;if(!(t[(t[D>>2]|0)+100>>2]|0))t[662]=4;if(!(t[a>>2]|0))Up(t[D>>2]|0)}while(0);if(!(t[o>>2]|0)){t[662]=1;s=r;return}if(!((t[252]|0)==0|(t[266]|0)!=0))dm(2952,f);if((t[236]|0)!=0?(t[C>>2]=Qg(t[o>>2]|0)|0,(t[C>>2]|0)!=0):0){iy(t[C>>2]|0);ey(t[C>>2]|0)}if(t[308]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();if((Oo(t[o>>2]|0,t[68]|0)|0)<0)t[662]=1;if(!((t[252]|0)==0|(t[266]|0)!=0))dm(2960,f)}if(t[554]|0)Om(t[o>>2]|0,t[554]|0);if(t[48]|0){On(t[o>>2]|0)|0;Ar(t[o>>2]|0,t[u>>2]|0,210,t[_>>2]|0)}if(t[56]|0){t[c>>2]=t[o>>2];if(t[252]|0)wm();t[o>>2]=Jy(t[o>>2]|0,1)|0;if(t[252]|0)dm(2984,f);if(t[252]|0)wm();fy(t[c>>2]|0);if(t[252]|0)dm(2992,f)}e:do if((t[244]|0)==0|(t[152]|0)!=0){if(t[462]|0)Mm(t[o>>2]|0)}else if(t[(t[o>>2]|0)+12>>2]|0){t[H>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(t[H>>2]|0)se=(t[(t[H>>2]|0)+16>>2]|0)==0;else se=0;be=t[H>>2]|0;if(!se)break;t[H>>2]=t[be+24>>2]}if(be){t[B>>2]=pR(t[(t[H>>2]|0)+16>>2]|0,0,P,256)|0;if((t[B>>2]|0)<0){xe(t[v>>2]|0,3016,f|0)|0;break}c=t[v>>2]|0;if(!(t[B>>2]|0)){xe(c|0,3056,f|0)|0;break}t[f>>2]=t[B>>2];xe(c|0,3096,f|0)|0;t[I>>2]=0;while(1){if((t[I>>2]|0)>=(t[B>>2]|0))break e;c=t[v>>2]|0;t[f>>2]=t[P+(t[I>>2]<<2)>>2];xe(c|0,3144,f|0)|0;t[I>>2]=(t[I>>2]|0)+1}}}while(0);do if(!(t[50]|0)){if(t[42]|0){if(!(t[128]|0))t[Q>>2]=t[_>>2];else t[Q>>2]=mi(t[128]|0,3160)|0;if(!(t[Q>>2]|0)){I=t[v>>2]|0;t[f>>2]=t[128];xe(I|0,3168,f|0)|0;t[662]=6;break}hr(t[Q>>2]|0,t[o>>2]|0);if(!(t[128]|0))break;Qe(t[Q>>2]|0)|0;break}if(!((t[252]|0)==0|(t[266]|0)!=0))wm();do if(!((t[152]|0)==0|(t[160]|0)!=0)){do if(t[788]|0)rr((t[128]|0)!=0?t[128]|0:144,t[o>>2]|0)|0;else{I=(t[440]|0)==1;P=t[128]|0;if(t[408]|0){B=(P|0)!=0?t[128]|0:144;H=t[o>>2]|0;be=t[408]|0;if(I){nr(B,H,be,1)|0;break}else{nr(B,H,be,0)|0;break}}if(I){nr((P|0)!=0?t[128]|0:144,t[o>>2]|0,0,1)|0;break}if(!P)t[U>>2]=t[_>>2];else t[U>>2]=mi(t[128]|0,3160)|0;if(!(t[U>>2]|0)){P=t[v>>2]|0;t[f>>2]=t[128];xe(P|0,3168,f|0)|0;t[662]=6;break}if((ir(t[U>>2]|0,t[o>>2]|0)|0)<0)t[662]=6;if(!(t[128]|0))break;Qe(t[U>>2]|0)|0}while(0);if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3192,f)}else{if(t[362]|0){t[z>>2]=0;t[j>>2]=ol(t[o>>2]|0,0,0,0,1,z)|0;if((t[j>>2]|0)<0){xe(t[v>>2]|0,3224,f|0)|0;t[662]=6;break}if(($e(1,t[z>>2]|0,t[j>>2]|0)|0)==-1)xe(t[v>>2]|0,3200,f|0)|0;pAi[t[135736>>2]&511](t[z>>2]|0);break}if(t[370]|0){t[V>>2]=0;t[q>>2]=ol(t[o>>2]|0,0,2,0,1,V)|0;if((t[q>>2]|0)<0){xe(t[v>>2]|0,3224,f|0)|0;t[662]=6;break}if(($e(1,t[V>>2]|0,t[q>>2]|0)|0)==-1)xe(t[v>>2]|0,3200,f|0)|0;pAi[t[135736>>2]&511](t[V>>2]|0);break}if(t[380]|0){t[Y>>2]=0;t[G>>2]=ol(t[o>>2]|0,0,1,0,1,Y)|0;if((t[G>>2]|0)<0){xe(t[v>>2]|0,3224,f|0)|0;t[662]=6;break}if(($e(1,t[Y>>2]|0,t[G>>2]|0)|0)==-1)xe(t[v>>2]|0,3200,f|0)|0;pAi[t[135736>>2]&511](t[Y>>2]|0);break}if(t[290]|0){P=(t[440]|0)==1;I=t[o>>2]|0;do if(t[408]|0){be=t[408]|0;if(P){kV(I,W,K,be,1);break}else{dV(I,W,K,be);break}}else if(P){wV(I,W,K,1);break}else{hV(I,W,K);break}while(0);if(!(t[W>>2]|0)){xe(t[v>>2]|0,3248,f|0)|0;t[662]=6;break}if(($e(1,t[W>>2]|0,t[K>>2]|0)|0)==-1)xe(t[v>>2]|0,3200,f|0)|0;pAi[t[135736>>2]&511](t[W>>2]|0);break}if(t[788]|0){SV((t[128]|0)!=0?t[128]|0:144,t[o>>2]|0)|0;break}if(!(t[816]|0)){t[J>>2]=0;do if((t[440]|0)==1)t[J>>2]=t[J>>2]|1;else{if((t[440]|0)!=2)break;t[J>>2]=t[J>>2]|128}while(0);if(t[160]|0)t[J>>2]=t[J>>2]|32;if(!(t[128]|0))t[Z>>2]=fV(1,t[408]|0,t[J>>2]|0)|0;else t[Z>>2]=tV(t[128]|0,t[408]|0,t[J>>2]|0)|0;if(!(t[Z>>2]|0)){t[662]=6;break}if((uV(t[Z>>2]|0,t[o>>2]|0)|0)<0){I=t[v>>2]|0;t[f>>2]=(t[128]|0)!=0?t[128]|0:144;xe(I|0,3272,f|0)|0;t[662]=6}cV(t[Z>>2]|0)|0;break}I=(t[440]|0)==1;P=t[128]|0;if(t[408]|0){be=(P|0)!=0?t[128]|0:144;H=t[o>>2]|0;B=t[408]|0;if(I)t[x>>2]=_V(be,H,B,1)|0;else t[x>>2]=pV(be,H,B)|0;if((t[x>>2]|0)>=0)break;B=t[v>>2]|0;t[f>>2]=(t[128]|0)!=0?t[128]|0:144;xe(B|0,3272,f|0)|0;t[662]=6;break}if(I){t[x>>2]=EV((P|0)!=0?t[128]|0:144,t[o>>2]|0,1)|0;if((t[x>>2]|0)>=0)break;I=t[v>>2]|0;t[f>>2]=(t[128]|0)!=0?t[128]|0:144;xe(I|0,3272,f|0)|0;t[662]=6;break}if(!P)t[X>>2]=t[_>>2];else t[X>>2]=mi(t[128]|0,3160)|0;if(!(t[X>>2]|0)){P=t[v>>2]|0;t[f>>2]=t[128];xe(P|0,3168,f|0)|0;t[662]=6;break}if((mV(t[X>>2]|0,t[o>>2]|0)|0)<0)t[662]=6;if(!(t[128]|0))break;Qe(t[X>>2]|0)|0}while(0);if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3192,f)}while(0);do if(!((t[216]|0)!=0|(t[226]|0)!=0)){if(t[206]|0){X=_M()|0;t[ie>>2]=X;if(!X){yAi[t[135904>>2]&511](t[33980]|0,3336,f);_i(-1)}if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[t[ie>>2]>>2]=t[v>>2];t[(t[ie>>2]|0)+4>>2]=203;t[(t[ie>>2]|0)+8>>2]=203;if(!(mR(t[ie>>2]|0,t[o>>2]|0)|0)){X=t[33976]|0;x=t[33980]|0;t[f>>2]=t[u>>2];yAi[X&511](x,3448,f);t[662]=3}if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3480,f);pM(t[ie>>2]|0)}}else{if(!((t[252]|0)==0|(t[266]|0)!=0))wm();if(t[216]|0)t[$>>2]=aS(0,t[216]|0)|0;else t[$>>2]=aS(t[226]|0,0)|0;if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3296,f);if(!(t[$>>2]|0)){x=t[33976]|0;X=t[33980]|0;if(t[216]|0){t[f>>2]=t[216];yAi[x&511](X,3312,f)}else{t[f>>2]=t[226];yAi[x&511](X,3312,f)}t[662]=2;break}X=_M()|0;t[ee>>2]=X;if(!X){yAi[t[135904>>2]&511](t[33980]|0,3336,f);_i(-1)}t[t[ee>>2]>>2]=t[v>>2];t[(t[ee>>2]|0)+4>>2]=203;t[(t[ee>>2]|0)+8>>2]=203;if(!((t[252]|0)==0|(t[266]|0)!=0))wm();if(!(dR(t[ee>>2]|0,t[o>>2]|0,t[$>>2]|0)|0)){X=t[33976]|0;x=t[33980]|0;Z=t[u>>2]|0;if(t[216]|0){J=t[216]|0;t[f>>2]=Z;t[f+4>>2]=J;yAi[X&511](x,3376,f)}else{J=t[226]|0;t[f>>2]=Z;t[f+4>>2]=J;yAi[X&511](x,3376,f)}t[662]=3}if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3424,f);pM(t[ee>>2]|0);ey(t[$>>2]|0)}while(0);if(t[650]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();if(t[42]|0)t[fe>>2]=4;else t[fe>>2]=2;if(t[50]|0)t[fe>>2]=t[fe>>2]|1;t[re>>2]=QV(t[650]|0,t[fe>>2]|0)|0;t[ne>>2]=eq(t[re>>2]|0,t[o>>2]|0)|0;do if(t[ne>>2]|0){fe=t[v>>2]|0;$=t[u>>2]|0;if((t[ne>>2]|0)>0){t[f>>2]=$;xe(fe|0,3512,f|0)|0;t[662]=3;break}else{t[f>>2]=$;xe(fe|0,3536,f|0)|0;t[662]=3;break}}else{fe=t[v>>2]|0;t[f>>2]=t[u>>2];xe(fe|0,3496,f|0)|0}while(0);$V(t[re>>2]|0);if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3480,f)}if(t[670]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[te>>2]=YH(t[670]|0)|0;WH(t[te>>2]|0,203,203,t[v>>2]|0);t[ue>>2]=XH(t[te>>2]|0,t[o>>2]|0)|0;do if(t[ue>>2]|0){re=t[v>>2]|0;ne=t[u>>2]|0;if((t[ue>>2]|0)>0){t[f>>2]=ne;xe(re|0,3512,f|0)|0;t[662]=3;break}else{t[f>>2]=ne;xe(re|0,3536,f|0)|0;t[662]=3;break}}else{re=t[v>>2]|0;t[f>>2]=t[u>>2];xe(re|0,3496,f|0)|0}while(0);GH(t[te>>2]|0);if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3480,f)}else if(t[682]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[ae>>2]=Ik(t[682]|0)|0;Ck(t[ae>>2]|0,203,203,t[v>>2]|0);t[oe>>2]=Uk(t[ae>>2]|0,t[o>>2]|0)|0;do if(t[oe>>2]|0){te=t[v>>2]|0;ue=t[u>>2]|0;if((t[oe>>2]|0)>0){t[f>>2]=ue;xe(te|0,3512,f|0)|0;t[662]=3;break}else{t[f>>2]=ue;xe(te|0,3536,f|0)|0;t[662]=3;break}}else{te=t[v>>2]|0;t[f>>2]=t[u>>2];xe(te|0,3496,f|0)|0}while(0);Nk(t[ae>>2]|0);if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3480,f)}if(!((t[356]|0)==0|(t[152]|0)!=0))sr(t[v>>2]|0,t[o>>2]|0);if(!((t[252]|0)==0|(t[266]|0)!=0))wm();fy(t[o>>2]|0);if((t[252]|0)==0|(t[266]|0)!=0){s=r;return}dm(3584,f);s=r;return}function pm(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=Re(t[u>>2]|0,1,t[a>>2]|0,t[f>>2]|0)|0;s=n;return r|0}function Em(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)==(t[m>>2]|0)){s=i;return}Qe(t[r>>2]|0)|0;s=i;return}function Sm(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+48|0;u=f;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+8|0;k=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];n[4136]=0;t[l>>2]=t[(t[c>>2]|0)+36>>2];if(((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)==0:0)?(t[(t[c>>2]|0)+40>>2]|0)>1:0)t[l>>2]=t[(t[(t[c>>2]|0)+48>>2]|0)+((t[(t[c>>2]|0)+40>>2]|0)-2<<2)>>2];Tm(t[l>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,54304,u);t[b>>2]=r;t[k>>2]=HY(4136)|0;yY(4136+(t[k>>2]|0)|0,5e4-(t[k>>2]|0)|0,t[o>>2]|0,b)|0;Lm();yAi[t[135904>>2]&511](t[33980]|0,54168,u);Dm(t[l>>2]|0);Lm();s=f;return}function gm(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+48|0;u=f;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+8|0;k=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];n[4136]=0;t[l>>2]=t[(t[c>>2]|0)+36>>2];if(((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)==0:0)?(t[(t[c>>2]|0)+40>>2]|0)>1:0)t[l>>2]=t[(t[(t[c>>2]|0)+48>>2]|0)+((t[(t[c>>2]|0)+40>>2]|0)-2<<2)>>2];Tm(t[l>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,54280,u);t[b>>2]=r;t[k>>2]=HY(4136)|0;yY(4136+(t[k>>2]|0)|0,5e4-(t[k>>2]|0)|0,t[o>>2]|0,b)|0;Lm();yAi[t[135904>>2]&511](t[33980]|0,54168,u);Dm(t[l>>2]|0);Lm();s=f;return}function ym(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+48|0;u=f;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+8|0;k=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];n[4136]=0;t[l>>2]=t[(t[c>>2]|0)+36>>2];if((t[(t[l>>2]|0)+4>>2]|0)==0?(t[(t[c>>2]|0)+40>>2]|0)>1:0)t[l>>2]=t[(t[(t[c>>2]|0)+48>>2]|0)+((t[(t[c>>2]|0)+40>>2]|0)-2<<2)>>2];Tm(t[l>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,54256,u);t[k>>2]=HY(4136)|0;t[b>>2]=r;yY(4136+(t[k>>2]|0)|0,5e4-(t[k>>2]|0)|0,t[o>>2]|0,b)|0;Lm();yAi[t[135904>>2]&511](t[33980]|0,54168,u);Dm(t[l>>2]|0);Lm();t[662]=3;s=f;return}function Fm(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+48|0;u=f;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+8|0;k=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];n[4136]=0;t[l>>2]=t[(t[c>>2]|0)+36>>2];if((t[(t[l>>2]|0)+4>>2]|0)==0?(t[(t[c>>2]|0)+40>>2]|0)>1:0)t[l>>2]=t[(t[(t[c>>2]|0)+48>>2]|0)+((t[(t[c>>2]|0)+40>>2]|0)-2<<2)>>2];Tm(t[l>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,54136,u);t[b>>2]=r;t[k>>2]=HY(4136)|0;yY(4136+(t[k>>2]|0)|0,5e4-(t[k>>2]|0)|0,t[o>>2]|0,b)|0;Lm();yAi[t[135904>>2]&511](t[33980]|0,54168,u);Dm(t[l>>2]|0);Lm();s=f;return}function Om(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=wf(t[f>>2]|0)|0;if(!(t[a>>2]|0)){xe(t[v>>2]|0,3912,n|0)|0;t[662]=9;s=r;return}t[(t[a>>2]|0)+4>>2]=t[f>>2];t[o>>2]=Et(t[u>>2]|0,t[a>>2]|0)|0;vf(t[a>>2]|0);if(!(t[o>>2]|0)){xe(t[v>>2]|0,3944,n|0)|0;t[662]=10;s=r;return}else{Nm(t[o>>2]|0);_n(t[o>>2]|0);s=r;return}}function Am(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+528|0;r=i;f=i+16|0;u=i+12|0;a=i+20|0;o=i+8|0;c=i+4|0;t[u>>2]=e;if(t[u>>2]|0){e=t[_>>2]|0;t[r>>2]=t[u>>2];xe(e|0,3904,r|0)|0}if(!(di(a|0,500,t[m>>2]|0)|0)){t[f>>2]=0;l=t[f>>2]|0;s=i;return l|0}n[a+500>>0]=0;t[c>>2]=HY(a|0)|0;t[o>>2]=Xq((t[c>>2]|0)+1|0)|0;if(t[o>>2]|0)YY(t[o>>2]|0,a|0,(t[c>>2]|0)+1|0)|0;t[f>>2]=t[o>>2];l=t[f>>2]|0;s=i;return l|0}function Mm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+128|0;r=i;n=i+116|0;f=i+112|0;u=i+108|0;a=i+104|0;o=i+16|0;c=i+8|0;l=i+4|0;t[n>>2]=e;t[a>>2]=eF(t[n>>2]|0)|0;t[l>>2]=t[(t[a>>2]|0)+48>>2];t[c>>2]=0;while(1){if(!((t[l>>2]|0)!=0&(t[c>>2]|0)<20))break;a=t[(t[l>>2]|0)+8>>2]|0;e=t[c>>2]|0;t[c>>2]=e+1;t[o+(e<<2)>>2]=a;a=t[(t[l>>2]|0)+12>>2]|0;e=t[c>>2]|0;t[c>>2]=e+1;t[o+(e<<2)>>2]=a;t[l>>2]=t[t[l>>2]>>2]}l=t[c>>2]|0;t[c>>2]=l+1;t[o+(l<<2)>>2]=0;t[o+(t[c>>2]<<2)>>2]=0;if((t[548]|0)!=0?(t[694]=Fj(t[548]|0,t[(t[n>>2]|0)+80>>2]|0,0,o)|0,(t[694]|0)==0):0){o=t[33976]|0;c=t[33980]|0;t[r>>2]=t[548];yAi[o&511](c,2784,r);t[662]=7;t[548]=0}if(((t[694]|0)!=0?(t[898]=Aj(t[694]|0)|0,(t[898]|0)!=0):0)?(t[u>>2]=pj(t[898]|0,0,0)|0,(t[u>>2]|0)<0):0){xe(t[v>>2]|0,3600,r|0)|0;_j(t[898]|0);t[898]=0}t[f>>2]=ZI(t[n>>2]|0)|0;if(t[f>>2]|0){if(!((t[252]|0)==0|(t[266]|0)!=0))wm();t[u>>2]=RI(t[f>>2]|0)|0;while(1){if((t[u>>2]|0)!=1)break;if((t[42]|0)!=0|(t[694]|0)!=0)Rm(t[f>>2]|0);t[u>>2]=RI(t[f>>2]|0)|0}if(!((t[252]|0)==0|(t[266]|0)!=0))dm(3632,r);CI(t[f>>2]|0);if(t[u>>2]|0){xe(t[v>>2]|0,3656,r|0)|0;t[662]=1}}else{xe(t[v>>2]|0,3688,r|0)|0;t[662]=1}if(!(t[898]|0)){s=i;return}_j(t[898]|0);t[898]=0;s=i;return}function Rm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+64|0;r=i;n=i+48|0;f=i+44|0;u=i+40|0;a=i+36|0;o=i+32|0;c=i+28|0;l=i+24|0;b=i+20|0;t[n>>2]=e;t[a>>2]=BI(t[n>>2]|0)|0;t[o>>2]=II(t[n>>2]|0)|0;do if(t[42]|0){e=xI(t[n>>2]|0)|0;t[f>>2]=e;t[f>>2]=(t[f>>2]|0)==0?3736:e;t[u>>2]=VI(t[n>>2]|0)|0;e=zI(t[n>>2]|0)|0;k=t[a>>2]|0;h=t[f>>2]|0;w=t[o>>2]|0;d=jI(t[n>>2]|0)|0;t[r>>2]=e;t[r+4>>2]=k;t[r+8>>2]=h;t[r+12>>2]=w;t[r+16>>2]=d;Je(3744,r|0)|0;if(!(t[u>>2]|0)){Je(3760,r|0)|0;break}else{t[r>>2]=t[u>>2];Je(3768,r|0)|0;break}}while(0);if(!(t[694]|0)){s=i;return}t[c>>2]=0;t[l>>2]=-1;if((t[a>>2]|0)==1?(u=t[694]|0,t[l>>2]=Oj(u,YI(t[n>>2]|0)|0)|0,(t[l>>2]|0)!=0):0){t[c>>2]=$y(YI(t[n>>2]|0)|0)|0;u=t[548]|0;t[r>>2]=t[c>>2];t[r+4>>2]=u;Je(3776,r|0)|0}do if(t[898]|0){do if((t[a>>2]|0)==1){u=t[898]|0;f=HI(t[n>>2]|0)|0;t[b>>2]=pj(u,f,UI(t[n>>2]|0)|0)|0;if((t[b>>2]|0)<0){xe(t[v>>2]|0,3600,r|0)|0;_j(t[898]|0);t[898]=0;break}if((t[b>>2]|0)!=(t[l>>2]|0)){if(!(t[c>>2]|0))t[c>>2]=$y(YI(t[n>>2]|0)|0)|0;xe(t[v>>2]|0,3808,r|0)|0;f=t[v>>2]|0;u=t[548]|0;if(t[c>>2]|0){d=t[c>>2]|0;t[r>>2]=u;t[r+4>>2]=d;xe(f|0,3856,r|0)|0;break}else{d=xI(t[n>>2]|0)|0;t[r>>2]=u;t[r+4>>2]=d;xe(f|0,3856,r|0)|0;break}}}while(0);if((t[a>>2]|0)!=15?!((t[a>>2]|0)==1&(t[o>>2]|0)!=0):0)break;t[b>>2]=gj(t[898]|0)|0;if((t[b>>2]|0)<0){xe(t[v>>2]|0,3880,r|0)|0;_j(t[898]|0);t[898]=0}}while(0);if(!(t[c>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[c>>2]|0);s=i;return}function Nm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;t[n>>2]=e;switch(t[t[n>>2]>>2]|0){case 4:{t[r>>2]=t[(t[n>>2]|0)+24>>2];Je(3904,r|0)|0;s=i;return}case 3:{e=wn(+l[(t[n>>2]|0)+16>>3])|0;if((e|0)==-1){Je(4032,r|0)|0;s=i;return}else if((e|0)!=1)if(hn(+l[(t[n>>2]|0)+16>>3])|0){Je(4048,r|0)|0;s=i;return}else{l[k>>3]=+l[(t[n>>2]|0)+16>>3];t[r>>2]=t[k>>2];t[r+4>>2]=t[k+4>>2];Je(4056,r|0)|0;s=i;return}else{Je(4016,r|0)|0;s=i;return}break}case 1:{if((t[(t[n>>2]|0)+4>>2]|0)!=0?(t[t[(t[n>>2]|0)+4>>2]>>2]|0)>0:0){t[a>>2]=fV(1,0,0)|0;if(!(t[a>>2]|0)){xe(t[v>>2]|0,3912,r|0)|0;t[662]=9;s=i;return}t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[t[(t[n>>2]|0)+4>>2]>>2]|0))break;t[u>>2]=t[(t[(t[(t[n>>2]|0)+4>>2]|0)+8>>2]|0)+(t[f>>2]<<2)>>2];aV(t[a>>2]|0,t[u>>2]|0)|0;t[f>>2]=(t[f>>2]|0)+1}cV(t[a>>2]|0)|0;s=i;return}xe(t[v>>2]|0,3976,r|0)|0;t[662]=10;s=i;return}case 2:{if(t[(t[n>>2]|0)+8>>2]|0){Je(4e3,r|0)|0;s=i;return}else{Je(4008,r|0)|0;s=i;return}break}case 0:{xe(t[v>>2]|0,4064,r|0)|0;t[662]=10;s=i;return}default:{xe(t[v>>2]|0,4096,r|0)|0;t[662]=10;s=i;return}}}function Tm(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i;n=i+12|0;f=i+8|0;t[n>>2]=e;yAi[t[135904>>2]&511](t[33980]|0,54216,r);t[f>>2]=HY(4136)|0;if(!(t[n>>2]|0)){Lm();s=i;return}e=4136+(t[f>>2]|0)|0;u=5e4-(t[f>>2]|0)|0;f=t[n>>2]|0;if(t[(t[n>>2]|0)+4>>2]|0){a=t[(t[n>>2]|0)+28>>2]|0;t[r>>2]=t[f+4>>2];t[r+4>>2]=a;SY(e,u,54224,r)|0;Lm();s=i;return}else{t[r>>2]=t[f+28>>2];SY(e,u,54232,r)|0;Lm();s=i;return}}function Lm(){var e=0,i=0,r=0,f=0,u=0;e=s;s=s+16|0;i=e;r=e+4|0;t[r>>2]=d_(0,4136)|0;if(!(t[r>>2]|0)){n[4136]=0;s=e;return}f=t[33976]|0;u=t[33980]|0;t[i>>2]=t[r>>2];yAi[f&511](u,3904,i);pAi[t[135736>>2]&511](t[r>>2]|0);n[4136]=0;s=e;return}function Dm(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;i=s;s=s+32|0;r=i;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;t[n>>2]=e;if(!(t[n>>2]|0)){s=i;return}yAi[t[135904>>2]&511](t[33980]|0,54176,r);t[f>>2]=t[(t[n>>2]|0)+16>>2];t[a>>2]=t[(t[n>>2]|0)+12>>2];while(1){if((t[f>>2]|0)>>>0<=(t[a>>2]|0)>>>0)break;if((u[t[f>>2]>>0]|0|0)!=10?(u[t[f>>2]>>0]|0|0)!=13:0)break;t[f>>2]=(t[f>>2]|0)+-1}t[c>>2]=0;while(1){e=t[c>>2]|0;t[c>>2]=e+1;if(((e|0)<80?(t[f>>2]|0)>>>0>(t[a>>2]|0)>>>0:0)?(u[t[f>>2]>>0]|0|0)!=10:0)l=(u[t[f>>2]>>0]|0|0)!=13;else l=0;b=t[f>>2]|0;if(!l)break;t[f>>2]=b+-1}if(!((u[b>>0]|0|0)!=10?(u[t[f>>2]>>0]|0|0)!=13:0))t[f>>2]=(t[f>>2]|0)+1;t[a>>2]=t[f>>2];t[c>>2]=0;while(1){if(((u[t[f>>2]>>0]|0|0)!=0?(u[t[f>>2]>>0]|0|0)!=10:0)?(u[t[f>>2]>>0]|0|0)!=13:0)k=(t[c>>2]|0)<79;else k=0;t[o>>2]=HY(4136)|0;h=4136+(t[o>>2]|0)|0;w=5e4-(t[o>>2]|0)|0;if(!k)break;b=t[f>>2]|0;t[f>>2]=b+1;t[r>>2]=u[b>>0];SY(h,w,54184,r)|0;t[c>>2]=(t[c>>2]|0)+1}SY(h,w,3760,r)|0;t[f>>2]=t[(t[n>>2]|0)+16>>2];while(1){if((u[t[f>>2]>>0]|0|0)!=10?(u[t[f>>2]>>0]|0|0)!=13:0)break;t[f>>2]=(t[f>>2]|0)+-1}t[c>>2]=0;while(1){if((t[f>>2]|0)!=(t[a>>2]|0)){n=t[c>>2]|0;t[c>>2]=n+1;d=(n|0)<80}else d=0;t[o>>2]=HY(4136)|0;v=4136+(t[o>>2]|0)|0;m=5e4-(t[o>>2]|0)|0;if(!d)break;SY(v,m,54192,r)|0;t[a>>2]=(t[a>>2]|0)+1}SY(v,m,54200,r)|0;Lm();yAi[t[135904>>2]&511](t[33980]|0,54208,r);s=i;return}function Cm(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+32|0;u=f;a=f+12|0;o=f+8|0;c=f+4|0;t[f+16>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}n=t[_>>2]|0;t[u>>2]=t[a>>2];xe(n|0,55552,u|0)|0;n=t[_>>2]|0;if(!(t[o>>2]|0))xe(n|0,54736,u|0)|0;else{t[u>>2]=t[o>>2];xe(n|0,54744,u|0)|0}n=t[_>>2]|0;if(!(t[c>>2]|0)){xe(n|0,54752,u|0)|0;s=f;return}else{t[u>>2]=t[c>>2];xe(n|0,54760,u|0)|0;s=f;return}}function Pm(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+8|0;t[i+4>>2]=e;t[13584]=(t[13584]|0)+1;if(t[50]|0){t[r>>2]=0;n=t[r>>2]|0;s=i;return n|0}else{xe(t[_>>2]|0,55528,i|0)|0;t[r>>2]=0;n=t[r>>2]|0;s=i;return n|0}return 0}function Bm(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+8|0;t[i+4>>2]=e;t[13584]=(t[13584]|0)+1;if(t[50]|0){t[r>>2]=0;n=t[r>>2]|0;s=i;return n|0}else{xe(t[_>>2]|0,55496,i|0)|0;t[r>>2]=0;n=t[r>>2]|0;s=i;return n|0}return 0}function Im(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+8|0;t[i+4>>2]=e;t[13584]=(t[13584]|0)+1;if(t[50]|0){t[r>>2]=0;n=t[r>>2]|0;s=i;return n|0}else{xe(t[_>>2]|0,55464,i|0)|0;t[r>>2]=0;n=t[r>>2]|0;s=i;return n|0}return 0}function Hm(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n;u=n+16|0;a=n+8|0;o=n+4|0;t[n+12>>2]=e;t[a>>2]=i;t[o>>2]=r;t[13584]=(t[13584]|0)+1;if(t[50]|0){t[u>>2]=0;c=t[u>>2]|0;s=n;return c|0}xe(t[_>>2]|0,55424,f|0)|0;r=t[_>>2]|0;if(t[a>>2]|0){t[f>>2]=t[a>>2];xe(r|0,3904,f|0)|0}else xe(r|0,54192,f|0)|0;r=t[_>>2]|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];xe(r|0,55448,f|0)|0}else xe(r|0,55456,f|0)|0;t[u>>2]=0;c=t[u>>2]|0;s=n;return c|0}function xm(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+4|0;t[r+8>>2]=e;t[u>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){t[f>>2]=0;a=t[f>>2]|0;s=r;return a|0}else{i=t[_>>2]|0;t[n>>2]=t[u>>2];xe(i|0,55400,n|0)|0;t[f>>2]=0;a=t[f>>2]|0;s=r;return a|0}return 0}function Um(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;t[a+44>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=55152;if(!(t[b>>2]|0))t[b>>2]=t[w>>2];if(!(t[k>>2]|0))t[k>>2]=t[w>>2];if(!(t[h>>2]|0))t[h>>2]=t[w>>2];t[13584]=(t[13584]|0)+1;if(t[50]|0){s=a;return}w=t[_>>2]|0;u=t[l>>2]|0;l=t[b>>2]|0;b=t[k>>2]|0;k=t[h>>2]|0;t[o>>2]=t[c>>2];t[o+4>>2]=u;t[o+8>>2]=l;t[o+12>>2]=b;t[o+16>>2]=k;xe(w|0,55360,o|0)|0;s=a;return}function zm(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+32|0;u=f;a=f+20|0;o=f+16|0;c=f+12|0;t[f+24>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}n=t[_>>2]|0;r=t[o>>2]|0;o=t[c>>2]|0;t[u>>2]=t[a>>2];t[u+4>>2]=r;t[u+8>>2]=o;xe(n|0,55328,u|0)|0;s=f;return}function jm(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;o=s;s=s+48|0;c=o;l=o+40|0;b=o+36|0;k=o+32|0;h=o+28|0;w=o+24|0;d=o+20|0;t[o+44>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=o;return}a=t[_>>2]|0;u=t[l>>2]|0;l=t[b>>2]|0;b=t[k>>2]|0;k=t[h>>2]|0;if(!(t[w>>2]|0)){t[c>>2]=u;t[c+4>>2]=l;t[c+8>>2]=b;t[c+12>>2]=k;xe(a|0,55232,c|0)|0}else{h=t[w>>2]|0;t[c>>2]=u;t[c+4>>2]=l;t[c+8>>2]=b;t[c+12>>2]=k;t[c+16>>2]=h;xe(a|0,55280,c|0)|0}NM(t[d>>2]|0);s=o;return}function Vm(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;t[f+20>>2]=e;t[a>>2]=i;t[o>>2]=r;t[f+8>>2]=n;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}n=t[_>>2]|0;r=t[o>>2]|0;t[u>>2]=t[a>>2];t[u+4>>2]=r;xe(n|0,55200,u|0)|0;s=f;return}function qm(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+48|0;a=u;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;t[u+36>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;t[k>>2]=55152;if(!(t[c>>2]|0))t[c>>2]=t[k>>2];if(!(t[l>>2]|0))t[l>>2]=t[k>>2];if(!(t[b>>2]|0))t[b>>2]=t[k>>2];t[13584]=(t[13584]|0)+1;if(t[50]|0){s=u;return}k=t[_>>2]|0;f=t[c>>2]|0;c=t[l>>2]|0;l=t[b>>2]|0;t[a>>2]=t[o>>2];t[a+4>>2]=f;t[a+8>>2]=c;t[a+12>>2]=l;xe(k|0,55160,a|0)|0;s=u;return}function Ym(e,i){e=e|0;i=i|0;var r=0;r=s;s=s+16|0;t[r+8>>2]=e;t[r+4>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=r;return}xe(t[_>>2]|0,55120,r|0)|0;s=r;return}function Gm(e){e=e|0;var i=0;i=s;s=s+16|0;t[i+4>>2]=e;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=i;return}xe(t[_>>2]|0,55096,i|0)|0;s=i;return}function Wm(e){e=e|0;var i=0;i=s;s=s+16|0;t[i+4>>2]=e;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=i;return}xe(t[_>>2]|0,55072,i|0)|0;s=i;return}function Km(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r;f=r+4|0;t[r+8>>2]=e;t[f>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=r;return}i=t[_>>2]|0;t[n>>2]=t[f>>2];xe(i|0,55048,n|0)|0;s=r;return}function Xm(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+64|0;u=f;a=f+16|0;o=f+12|0;c=f+24|0;l=f+8|0;t[f+20>>2]=e;t[a>>2]=i;t[o>>2]=r;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}t[l>>2]=0;while(1){b=t[l>>2]|0;if(!((t[l>>2]|0)<30?(t[l>>2]|0)<(t[o>>2]|0):0))break;n[c+(t[l>>2]|0)>>0]=n[(t[a>>2]|0)+b>>0]|0;t[l>>2]=(t[l>>2]|0)+1}n[c+b>>0]=0;b=t[_>>2]|0;l=t[o>>2]|0;t[u>>2]=c;t[u+4>>2]=l;xe(b|0,55024,u|0)|0;s=f;return}function Zm(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+64|0;u=f;a=f+16|0;o=f+12|0;c=f+24|0;l=f+8|0;t[f+20>>2]=e;t[a>>2]=i;t[o>>2]=r;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}t[l>>2]=0;while(1){b=t[l>>2]|0;if(!((t[l>>2]|0)<30?(t[l>>2]|0)<(t[o>>2]|0):0))break;n[c+(t[l>>2]|0)>>0]=n[(t[a>>2]|0)+b>>0]|0;t[l>>2]=(t[l>>2]|0)+1}n[c+b>>0]=0;b=t[_>>2]|0;l=t[o>>2]|0;t[u>>2]=c;t[u+4>>2]=l;xe(b|0,54984,u|0)|0;s=f;return}function Jm(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+32|0;f=n;u=n+12|0;a=n+8|0;t[n+16>>2]=e;t[u>>2]=i;t[a>>2]=r;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=n;return}r=t[_>>2]|0;i=t[u>>2]|0;if(t[a>>2]|0){u=t[a>>2]|0;t[f>>2]=i;t[f+4>>2]=u;xe(r|0,54904,f|0)|0;s=n;return}else{t[f>>2]=i;xe(r|0,54944,f|0)|0;s=n;return}}function Qm(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r;f=r+4|0;t[r+8>>2]=e;t[f>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=r;return}i=t[_>>2]|0;t[n>>2]=t[f>>2];xe(i|0,54880,n|0)|0;s=r;return}function $m(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;n=s;s=s+32|0;f=n+24|0;u=n+8|0;t[n+28>>2]=e;t[f>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=n;return}t[u>>2]=r;xe(t[_>>2]|0,54864,n|0)|0;Te(t[_>>2]|0,t[f>>2]|0,u|0)|0;s=n;return}function e_(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;n=s;s=s+32|0;f=n+24|0;u=n+8|0;t[n+28>>2]=e;t[f>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=n;return}t[u>>2]=r;xe(t[_>>2]|0,54848,n|0)|0;Te(t[_>>2]|0,t[f>>2]|0,u|0)|0;s=n;return}function i_(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;n=s;s=s+32|0;f=n+24|0;u=n+8|0;t[n+28>>2]=e;t[f>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=n;return}t[u>>2]=r;xe(t[_>>2]|0,54824,n|0)|0;Te(t[_>>2]|0,t[f>>2]|0,u|0)|0;s=n;return}function r_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+4|0;t[r+8>>2]=e;t[u>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){t[f>>2]=0;a=t[f>>2]|0;s=r;return a|0}else{i=t[_>>2]|0;t[n>>2]=t[u>>2];xe(i|0,54792,n|0)|0;t[f>>2]=0;a=t[f>>2]|0;s=r;return a|0}return 0}function n_(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+32|0;f=n;u=n+12|0;a=n+8|0;t[n+16>>2]=e;t[u>>2]=i;t[a>>2]=r;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=n;return}r=t[_>>2]|0;i=t[a>>2]|0;t[f>>2]=t[u>>2];t[f+4>>2]=i;xe(r|0,54768,f|0)|0;s=n;return}function f_(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+32|0;u=f;a=f+12|0;o=f+8|0;c=f+4|0;t[f+16>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}n=t[_>>2]|0;t[u>>2]=t[a>>2];xe(n|0,54712,u|0)|0;n=t[_>>2]|0;if(!(t[o>>2]|0))xe(n|0,54736,u|0)|0;else{t[u>>2]=t[o>>2];xe(n|0,54744,u|0)|0}n=t[_>>2]|0;if(!(t[c>>2]|0)){xe(n|0,54752,u|0)|0;s=f;return}else{t[u>>2]=t[c>>2];xe(n|0,54760,u|0)|0;s=f;return}}function t_(e,i,r,n,f,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,p=0,E=0,S=0;l=s;s=s+48|0;b=l;k=l+40|0;h=l+36|0;w=l+32|0;d=l+28|0;v=l+24|0;m=l+20|0;p=l+16|0;E=l+12|0;S=l+8|0;t[l+44>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;t[p>>2]=o;t[E>>2]=c;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=l;return}c=t[_>>2]|0;t[b>>2]=t[k>>2];xe(c|0,54584,b|0)|0;c=t[_>>2]|0;if(!(t[h>>2]|0))xe(c|0,54536,b|0)|0;else{t[b>>2]=t[h>>2];xe(c|0,54544,b|0)|0}c=t[_>>2]|0;if(!(t[w>>2]|0))xe(c|0,54536,b|0)|0;else{t[b>>2]=t[w>>2];xe(c|0,54608,b|0)|0}c=t[_>>2]|0;t[b>>2]=t[d>>2];xe(c|0,54616,b|0)|0;e:do if(t[v>>2]|0){t[S>>2]=0;while(1){if((t[S>>2]|0)>=(t[d>>2]<<1|0))break e;xe(t[_>>2]|0,54624,b|0)|0;if(t[(t[v>>2]|0)+(t[S>>2]<<2)>>2]|0){c=t[_>>2]|0;t[b>>2]=t[(t[v>>2]|0)+(t[S>>2]<<2)>>2];xe(c|0,54632,b|0)|0}t[S>>2]=(t[S>>2]|0)+1;c=t[_>>2]|0;t[b>>2]=t[(t[v>>2]|0)+(t[S>>2]<<2)>>2];xe(c|0,54640,b|0)|0;t[S>>2]=(t[S>>2]|0)+1}}while(0);v=t[_>>2]|0;d=t[p>>2]|0;t[b>>2]=t[m>>2];t[b+4>>2]=d;xe(v|0,54648,b|0)|0;e:do if(t[E>>2]|0){t[S>>2]=0;while(1){if((t[S>>2]|0)>=((t[m>>2]|0)*5|0))break e;v=t[_>>2]|0;d=t[S>>2]|0;if(t[(t[E>>2]|0)+((t[S>>2]|0)+1<<2)>>2]|0){p=t[(t[E>>2]|0)+(t[S>>2]<<2)>>2]|0;t[b>>2]=t[(t[E>>2]|0)+(d+1<<2)>>2];t[b+4>>2]=p;xe(v|0,54664,b|0)|0}else{t[b>>2]=t[(t[E>>2]|0)+(d<<2)>>2];xe(v|0,54680,b|0)|0}v=t[_>>2]|0;d=(t[(t[E>>2]|0)+((t[S>>2]|0)+4<<2)>>2]|0)-(t[(t[E>>2]|0)+((t[S>>2]|0)+3<<2)>>2]|0)|0;t[b>>2]=t[(t[E>>2]|0)+((t[S>>2]|0)+3<<2)>>2];t[b+4>>2]=d;xe(v|0,54688,b|0)|0;t[S>>2]=(t[S>>2]|0)+5}}while(0);xe(t[_>>2]|0,54704,b|0)|0;s=l;return}function u_(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+32|0;u=f;a=f+12|0;o=f+8|0;c=f+4|0;t[f+16>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=f;return}n=t[_>>2]|0;t[u>>2]=t[a>>2];xe(n|0,54512,u|0)|0;n=t[_>>2]|0;if(!(t[o>>2]|0))xe(n|0,54536,u|0)|0;else{t[u>>2]=t[o>>2];xe(n|0,54544,u|0)|0}n=t[_>>2]|0;if(!(t[c>>2]|0)){xe(n|0,54552,u|0)|0;s=f;return}else{t[u>>2]=t[c>>2];xe(n|0,54568,u|0)|0;s=f;return}}function a_(){var e=0,i=0,r=0;e=s;s=s+16|0;i=e;r=t[v>>2]|0;t[i>>2]=t[432];xe(r|0,56400,i|0)|0;t[662]=9;s=e;return}function o_(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+32|0;f=n;u=n+12|0;a=n+8|0;o=n+4|0;t[n+16>>2]=e;t[u>>2]=i;t[a>>2]=r;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=n;return}r=t[_>>2]|0;t[f>>2]=t[u>>2];xe(r|0,60952,f|0)|0;e:do if(t[a>>2]|0){t[o>>2]=0;while(1){if(!(t[(t[a>>2]|0)+(t[o>>2]<<2)>>2]|0))break e;r=t[_>>2]|0;u=t[o>>2]|0;t[o>>2]=u+1;t[f>>2]=t[(t[a>>2]|0)+(u<<2)>>2];xe(r|0,54680,f|0)|0;if(t[(t[a>>2]|0)+(t[o>>2]<<2)>>2]|0){r=t[_>>2]|0;t[f>>2]=t[(t[a>>2]|0)+(t[o>>2]<<2)>>2];xe(r|0,60976,f|0)|0}t[o>>2]=(t[o>>2]|0)+1}}while(0);xe(t[_>>2]|0,54704,f|0)|0;s=n;return}function c_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r;f=r+4|0;t[r+8>>2]=e;t[f>>2]=i;t[13584]=(t[13584]|0)+1;if(t[50]|0){s=r;return}i=t[_>>2]|0;t[n>>2]=t[f>>2];xe(i|0,60928,n|0)|0;s=r;return}function l_(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(!(t[n>>2]|0))t[r>>2]=0;else{e=u[t[n>>2]>>0]|0;if((e|0)==103){if(Xl(t[n>>2]|0,61072)|0){t[r>>2]=61080;break}}else if((e|0)==97){if(Xl(t[n>>2]|0,61160)|0){t[r>>2]=61168;break}if(Xl(t[n>>2]|0,61248)|0){t[r>>2]=61256;break}}else if((e|0)==108){if(Xl(t[n>>2]|0,60984)|0){t[r>>2]=60992;break}}else if((e|0)==113?(Xl(t[n>>2]|0,61336)|0)!=0:0){t[r>>2]=61344;break}t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function s_(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(!(t[c>>2]|0)){p_(521,61424);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}if(!(t[(t[c>>2]|0)+48>>2]|0)){p_(522,61464);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}t[v>>2]=t[(t[c>>2]|0)+48>>2];t[d>>2]=E_(t[v>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;if(!(t[d>>2]|0)){t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}t[(t[d>>2]|0)+20>>2]=t[v>>2];t[(t[d>>2]|0)+32>>2]=t[(t[v>>2]|0)+32>>2];w=t[d>>2]|0;h=(t[v>>2]|0)+16|0;if(!(t[(t[v>>2]|0)+16>>2]|0)){
	t[h>>2]=w;t[(t[v>>2]|0)+12>>2]=w}else{t[(t[h>>2]|0)+24>>2]=w;t[(t[d>>2]|0)+28>>2]=t[(t[v>>2]|0)+16>>2];t[(t[v>>2]|0)+16>>2]=t[d>>2]}t[o>>2]=t[d>>2];m=t[o>>2]|0;s=a;return m|0}function b_(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(!(t[c>>2]|0)){p_(521,61520);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}if(!(t[(t[c>>2]|0)+44>>2]|0)){p_(522,61560);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}t[v>>2]=t[(t[c>>2]|0)+44>>2];t[d>>2]=E_(t[v>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;if(!(t[d>>2]|0)){t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}t[(t[d>>2]|0)+20>>2]=t[v>>2];t[(t[d>>2]|0)+32>>2]=t[(t[v>>2]|0)+32>>2];w=t[d>>2]|0;h=(t[v>>2]|0)+16|0;if(!(t[(t[v>>2]|0)+16>>2]|0)){t[h>>2]=w;t[(t[v>>2]|0)+12>>2]=w}else{t[(t[h>>2]|0)+24>>2]=w;t[(t[d>>2]|0)+28>>2]=t[(t[v>>2]|0)+16>>2];t[(t[v>>2]|0)+16>>2]=t[d>>2]}t[o>>2]=t[d>>2];m=t[o>>2]|0;s=a;return m|0}function k_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(((t[(t[f>>2]|0)+44>>2]|0)!=0?(t[(t[(t[f>>2]|0)+44>>2]|0)+60>>2]|0)!=0:0)?(t[a>>2]=t[(t[(t[f>>2]|0)+44>>2]|0)+60>>2],t[o>>2]=g_(t[a>>2]|0,t[u>>2]|0)|0,(t[o>>2]|0)!=0):0){t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}if((t[(t[f>>2]|0)+48>>2]|0)!=0?(t[(t[(t[f>>2]|0)+48>>2]|0)+60>>2]|0)!=0:0){t[a>>2]=t[(t[(t[f>>2]|0)+48>>2]|0)+60>>2];t[n>>2]=g_(t[a>>2]|0,t[u>>2]|0)|0;c=t[n>>2]|0;s=r;return c|0}t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}function h_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(t[f>>2]|0){if(((t[(t[f>>2]|0)+44>>2]|0)!=0?(t[(t[(t[f>>2]|0)+44>>2]|0)+48>>2]|0)!=0:0)?(t[o>>2]=t[(t[(t[f>>2]|0)+44>>2]|0)+48>>2],t[a>>2]=g_(t[o>>2]|0,t[u>>2]|0)|0,(t[a>>2]|0)!=0):0){t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}if((((t[(t[f>>2]|0)+40>>2]|0)!=1?(t[(t[f>>2]|0)+48>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+48>>2]|0)+48>>2]|0)!=0:0)?(t[o>>2]=t[(t[(t[f>>2]|0)+48>>2]|0)+48>>2],t[a>>2]=g_(t[o>>2]|0,t[u>>2]|0)|0,(t[a>>2]|0)!=0):0){t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}}t[n>>2]=l_(t[u>>2]|0)|0;c=t[n>>2]|0;s=r;return c|0}function w_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=y_(t[n>>2]|0,t[f>>2]|0,1)|0;s=r;return i|0}function d_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=y_(t[n>>2]|0,t[f>>2]|0,0)|0;s=r;return i|0}function v_(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,211);s=i;return}function m_(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=sO(t[r>>2]|0,212)|0;s=i;return e|0}function __(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}switch(t[(t[f>>2]|0)+48>>2]|0){case 2:{NF(t[n>>2]|0,61616);RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);i=t[n>>2]|0;if(t[(t[f>>2]|0)+52>>2]|0){NF(i,61648);TF(t[n>>2]|0,t[(t[f>>2]|0)+52>>2]|0);NF(t[n>>2]|0,61632);TF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)}else{NF(i,61664);TF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)}NF(t[n>>2]|0,61640);s=r;return}case 1:{NF(t[n>>2]|0,61616);RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);NF(t[n>>2]|0,61632);i=t[n>>2]|0;e=t[f>>2]|0;if(t[(t[f>>2]|0)+36>>2]|0)TF(i,t[e+36>>2]|0);else M_(i,t[e+40>>2]|0);NF(t[n>>2]|0,61640);s=r;return}case 5:{NF(t[n>>2]|0,61688);RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);e=t[n>>2]|0;if(t[(t[f>>2]|0)+52>>2]|0){NF(e,61648);TF(t[n>>2]|0,t[(t[f>>2]|0)+52>>2]|0);NF(t[n>>2]|0,61632);TF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)}else{NF(e,61664);TF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)}NF(t[n>>2]|0,61640);s=r;return}case 3:{NF(t[n>>2]|0,61616);RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);e=t[n>>2]|0;if(t[(t[f>>2]|0)+52>>2]|0){NF(e,61648);TF(t[n>>2]|0,t[(t[f>>2]|0)+52>>2]|0);NF(t[n>>2]|0,61632);TF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)}else{NF(e,61664);TF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)}do if(t[(t[f>>2]|0)+40>>2]|0){NF(t[n>>2]|0,61680);e=t[n>>2]|0;i=t[f>>2]|0;if(t[(t[f>>2]|0)+36>>2]|0){RF(e,t[i+36>>2]|0);break}else{RF(e,t[i+40>>2]|0);break}}while(0);NF(t[n>>2]|0,61640);s=r;return}case 4:{NF(t[n>>2]|0,61688);RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);NF(t[n>>2]|0,61632);i=t[n>>2]|0;e=t[f>>2]|0;if(!(t[(t[f>>2]|0)+36>>2]|0))M_(i,t[e+40>>2]|0);else TF(i,t[e+36>>2]|0);NF(t[n>>2]|0,61640);s=r;return}default:{p_(535,61704);s=r;return}}}function p_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;dp(2,t[n>>2]|0,0,t[f>>2]|0,0);s=r;return}function E_(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;t[v>>2]=0;if(!(t[l>>2]|0)){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}if(!(t[c>>2]|0)){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}if(t[(t[c>>2]|0)+32>>2]|0)t[d>>2]=t[(t[(t[c>>2]|0)+32>>2]|0)+80>>2];switch(t[b>>2]|0){case 6:{t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}case 3:case 2:case 1:{if(!(t[(t[c>>2]|0)+48>>2]|0)){u=KF(0,t[d>>2]|0)|0;t[(t[c>>2]|0)+48>>2]=u}t[v>>2]=t[(t[c>>2]|0)+48>>2];break}case 5:case 4:{if(!(t[(t[c>>2]|0)+60>>2]|0)){u=KF(0,t[d>>2]|0)|0;t[(t[c>>2]|0)+60>>2]=u}t[v>>2]=t[(t[c>>2]|0)+60>>2];break}default:{}}if(!(t[v>>2]|0)){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}t[m>>2]=S_(t[d>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;if(!(t[m>>2]|0)){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}t[(t[m>>2]|0)+32>>2]=t[(t[c>>2]|0)+32>>2];c=(ZF(t[v>>2]|0,t[l>>2]|0,t[m>>2]|0)|0)!=0;l=t[m>>2]|0;if(c){R_(l);t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}else{t[o>>2]=l;_=t[o>>2]|0;s=a;return _|0}return 0}function S_(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=gAi[t[135744>>2]&511](76)|0;if(!(t[d>>2]|0)){F_(62016);t[o>>2]=0;v=t[o>>2]|0;s=a;return v|0}u=(t[d>>2]|0)+0|0;f=u+76|0;do{t[u>>2]=0;u=u+4|0}while((u|0)<(f|0));t[(t[d>>2]|0)+4>>2]=17;t[(t[d>>2]|0)+72>>2]=0;t[(t[d>>2]|0)+48>>2]=t[b>>2];if(!(t[c>>2]|0)){b=Yl(t[l>>2]|0)|0;t[(t[d>>2]|0)+8>>2]=b;if(t[k>>2]|0){b=Yl(t[k>>2]|0)|0;t[(t[d>>2]|0)+52>>2]=b}if(t[h>>2]|0){b=Yl(t[h>>2]|0)|0;t[(t[d>>2]|0)+56>>2]=b}}else{b=kz(t[c>>2]|0,t[l>>2]|0,-1)|0;t[(t[d>>2]|0)+8>>2]=b;if(t[k>>2]|0){b=kz(t[c>>2]|0,t[k>>2]|0,-1)|0;t[(t[d>>2]|0)+52>>2]=b}if(t[h>>2]|0){b=kz(t[c>>2]|0,t[h>>2]|0,-1)|0;t[(t[d>>2]|0)+56>>2]=b}}do if(t[w>>2]|0){b=rs(t[w>>2]|0)|0;t[(t[d>>2]|0)+44>>2]=b;if((t[c>>2]|0)!=0?(t[(t[d>>2]|0)+44>>2]|0)<5:0){b=kz(t[c>>2]|0,t[w>>2]|0,t[(t[d>>2]|0)+44>>2]|0)|0;t[(t[d>>2]|0)+40>>2]=b;break}b=ql(t[w>>2]|0,t[(t[d>>2]|0)+44>>2]|0)|0;t[(t[d>>2]|0)+40>>2]=b}else{t[(t[d>>2]|0)+44>>2]=0;t[(t[d>>2]|0)+40>>2]=0}while(0);t[(t[d>>2]|0)+64>>2]=0;t[(t[d>>2]|0)+36>>2]=0;t[(t[d>>2]|0)+68>>2]=0;t[o>>2]=t[d>>2];v=t[o>>2]|0;s=a;return v|0}function g_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=rO(t[n>>2]|0,t[f>>2]|0)|0;s=r;return i|0}function y_(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0;f=s;s=s+112|0;a=f;o=f+84|0;c=f+80|0;l=f+76|0;b=f+72|0;k=f+68|0;h=f+64|0;w=f+60|0;d=f+56|0;v=f+52|0;m=f+48|0;_=f+44|0;p=f+40|0;E=f+36|0;S=f+32|0;g=f+28|0;y=f+24|0;F=f+20|0;O=f+99|0;A=f+16|0;M=f+12|0;R=f+8|0;N=f+88|0;T=f+4|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=t[l>>2];t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;if(!(t[l>>2]|0)){t[o>>2]=0;L=t[o>>2]|0;s=f;return L|0}if(t[c>>2]|0)t[v>>2]=(t[(t[c>>2]|0)+4>>2]|0)==13&1;t[d>>2]=1e3;t[h>>2]=gAi[t[135744>>2]&511](t[d>>2]|0)|0;if(!(t[h>>2]|0)){F_(61816);t[o>>2]=0;L=t[o>>2]|0;s=f;return L|0}t[w>>2]=t[h>>2];e:while(1){D=t[w>>2]|0;if(!(u[t[k>>2]>>0]|0)){C=87;break}t[m>>2]=D-(t[h>>2]|0);if(((t[m>>2]|0)+100|0)>>>0>(t[d>>2]|0)>>>0){t[p>>2]=t[d>>2]<<1;if((t[p>>2]|0)>>>0<(t[d>>2]|0)>>>0){C=88;break}t[_>>2]=MAi[t[135760>>2]&511](t[h>>2]|0,t[p>>2]|0)|0;if(!(t[_>>2]|0)){C=88;break}t[h>>2]=t[_>>2];t[d>>2]=t[p>>2];t[w>>2]=(t[h>>2]|0)+(t[m>>2]|0)}i:do if((u[t[k>>2]>>0]|0)==60){if(((((t[v>>2]|0)!=0&(t[b>>2]|0)!=0?(u[(t[k>>2]|0)+1>>0]|0)==33:0)?(u[(t[k>>2]|0)+2>>0]|0)==45:0)?(u[(t[k>>2]|0)+3>>0]|0)==45:0)?(l=is(t[k>>2]|0,61856)|0,t[E>>2]=l,(l|0)!=0):0){while(1){l=(t[k>>2]|0)!=(t[E>>2]|0);r=t[k>>2]|0;t[k>>2]=r+1;i=n[r>>0]|0;r=t[w>>2]|0;t[w>>2]=r+1;n[r>>0]=i;if(!l)break;t[m>>2]=(t[w>>2]|0)-(t[h>>2]|0);if(((t[m>>2]|0)+100|0)>>>0<=(t[d>>2]|0)>>>0)continue;t[g>>2]=t[d>>2]<<1;if((t[g>>2]|0)>>>0<(t[d>>2]|0)>>>0){C=88;break e}t[S>>2]=MAi[t[135760>>2]&511](t[h>>2]|0,t[g>>2]|0)|0;if(!(t[S>>2]|0)){C=88;break e}t[h>>2]=t[S>>2];t[d>>2]=t[g>>2];t[w>>2]=(t[h>>2]|0)+(t[m>>2]|0)}l=t[k>>2]|0;t[k>>2]=l+1;i=n[l>>0]|0;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=i;i=t[k>>2]|0;t[k>>2]=i+1;l=n[i>>0]|0;i=t[w>>2]|0;t[w>>2]=i+1;n[i>>0]=l;continue e}l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=38;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=108;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=116;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=59}else{if((u[t[k>>2]>>0]|0)==62){l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=38;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=103;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=116;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=59;break}if((u[t[k>>2]>>0]|0)==38){if(((t[v>>2]|0)!=0&(t[b>>2]|0)!=0?(u[(t[k>>2]|0)+1>>0]|0)==123:0)?(Yq(t[k>>2]|0,125)|0)!=0:0)while(1){l=(u[t[k>>2]>>0]|0)!=125;i=t[k>>2]|0;t[k>>2]=i+1;r=n[i>>0]|0;i=t[w>>2]|0;t[w>>2]=i+1;n[i>>0]=r;if(!l)continue e;t[m>>2]=(t[w>>2]|0)-(t[h>>2]|0);if(((t[m>>2]|0)+100|0)>>>0<=(t[d>>2]|0)>>>0)continue;t[F>>2]=t[d>>2]<<1;if((t[F>>2]|0)>>>0<(t[d>>2]|0)>>>0){C=88;break e}t[y>>2]=MAi[t[135760>>2]&511](t[h>>2]|0,t[F>>2]|0)|0;if(!(t[y>>2]|0)){C=88;break e}t[h>>2]=t[y>>2];t[d>>2]=t[F>>2];t[w>>2]=(t[h>>2]|0)+(t[m>>2]|0)}l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=38;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=97;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=109;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=112;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=59;break}if(!((u[t[k>>2]>>0]|0)>=32?(u[t[k>>2]>>0]|0)<128:0))C=40;do if(((C|0)==40?(C=0,(u[t[k>>2]>>0]|0)!=10):0)?(u[t[k>>2]>>0]|0)!=9:0){if((t[v>>2]|0)!=0?(u[t[k>>2]>>0]|0)==13:0)break;if((u[t[k>>2]>>0]|0)<128){if(!(9<=(u[t[k>>2]>>0]|0)?(u[t[k>>2]>>0]|0)<=10:0))C=81;if(((C|0)==81?(C=0,(u[t[k>>2]>>0]|0)!=13):0)?32>(u[t[k>>2]>>0]|0):0)break i;t[a>>2]=u[t[k>>2]>>0];SY(N,11,61920,a)|0;n[N+10>>0]=0;t[T>>2]=N;while(1){if(!(n[t[T>>2]>>0]|0))break i;l=t[T>>2]|0;t[T>>2]=l+1;r=n[l>>0]|0;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=r}}if(t[c>>2]|0){if((t[v>>2]|0)!=0?1:(t[(t[c>>2]|0)+60>>2]|0)!=0)C=49}else if(t[v>>2]|0)C=49;if((C|0)==49){C=0;r=n[t[k>>2]>>0]|0;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=r;break i}t[M>>2]=0;t[R>>2]=1;if((u[t[k>>2]>>0]|0)<192){p_(5032,61864);if(t[c>>2]|0){r=Yl(61904)|0;t[(t[c>>2]|0)+60>>2]=r}t[a>>2]=u[t[k>>2]>>0];SY(O,11,61920,a)|0;n[O+10>>0]=0;t[A>>2]=O;while(1){if(!(n[t[A>>2]>>0]|0))break;r=t[A>>2]|0;t[A>>2]=r+1;l=n[r>>0]|0;r=t[w>>2]|0;t[w>>2]=r+1;n[r>>0]=l}t[k>>2]=(t[k>>2]|0)+1;continue e}l=t[k>>2]|0;do if((u[t[k>>2]>>0]|0)<224){t[M>>2]=u[l>>0]&31;t[M>>2]=t[M>>2]<<6;t[M>>2]=t[M>>2]|u[(t[k>>2]|0)+1>>0]&63;t[R>>2]=2}else{r=t[k>>2]|0;if((u[l>>0]|0)<240){t[M>>2]=u[r>>0]&15;t[M>>2]=t[M>>2]<<6;t[M>>2]=t[M>>2]|u[(t[k>>2]|0)+1>>0]&63;t[M>>2]=t[M>>2]<<6;t[M>>2]=t[M>>2]|u[(t[k>>2]|0)+2>>0]&63;t[R>>2]=3;break}if((u[r>>0]|0)>=248)break;t[M>>2]=u[t[k>>2]>>0]&7;t[M>>2]=t[M>>2]<<6;t[M>>2]=t[M>>2]|u[(t[k>>2]|0)+1>>0]&63;t[M>>2]=t[M>>2]<<6;t[M>>2]=t[M>>2]|u[(t[k>>2]|0)+2>>0]&63;t[M>>2]=t[M>>2]<<6;t[M>>2]=t[M>>2]|u[(t[k>>2]|0)+3>>0]&63;t[R>>2]=4}while(0);r:do if((t[R>>2]|0)!=1){l=t[M>>2]|0;do if((t[M>>2]|0)<256){if(!(9<=(l|0)&(t[M>>2]|0)<=10|(t[M>>2]|0)==13|32<=(t[M>>2]|0)))break r}else{if(256<=(l|0)&(t[M>>2]|0)<=55295)break;if(57344<=(t[M>>2]|0)&(t[M>>2]|0)<=65533)break;if(!(65536<=(t[M>>2]|0)&(t[M>>2]|0)<=1114111))break r}while(0);t[a>>2]=t[M>>2];SY(O,11,61968,a)|0;n[O+10>>0]=0;t[A>>2]=O;while(1){if(!(n[t[A>>2]>>0]|0))break;l=t[A>>2]|0;t[A>>2]=l+1;r=n[l>>0]|0;l=t[w>>2]|0;t[w>>2]=l+1;n[l>>0]=r}t[k>>2]=(t[k>>2]|0)+(t[R>>2]|0);continue e}while(0);p_(9,61928);if(t[c>>2]|0){r=Yl(61904)|0;t[(t[c>>2]|0)+60>>2]=r}t[a>>2]=u[t[k>>2]>>0];SY(O,11,61920,a)|0;n[O+10>>0]=0;t[A>>2]=O;while(1){if(!(n[t[A>>2]>>0]|0))break;r=t[A>>2]|0;t[A>>2]=r+1;l=n[r>>0]|0;r=t[w>>2]|0;t[w>>2]=r+1;n[r>>0]=l}t[k>>2]=(t[k>>2]|0)+1;continue e}while(0);l=n[t[k>>2]>>0]|0;r=t[w>>2]|0;t[w>>2]=r+1;n[r>>0]=l}while(0);t[k>>2]=(t[k>>2]|0)+1}if((C|0)==87){n[D>>0]=0;t[o>>2]=t[h>>2];L=t[o>>2]|0;s=f;return L|0}else if((C|0)==88){F_(61976);pAi[t[135736>>2]&511](t[h>>2]|0);t[o>>2]=0;L=t[o>>2]|0;s=f;return L|0}return 0}function F_(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;dp(2,2,0,0,t[r>>2]|0);s=i;return}function O_(e,i){e=e|0;i=i|0;var r=0,n=0;r=s;s=s+16|0;n=r+4|0;t[n>>2]=e;t[r>>2]=i;if(!(t[n>>2]|0)){s=r;return}R_(t[n>>2]|0);s=r;return}function A_(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](76)|0;if(!(t[f>>2]|0)){F_(61784);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+76|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=17;t[(t[f>>2]|0)+48>>2]=t[(t[n>>2]|0)+48>>2];if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[f>>2]|0)+8>>2]=e}if(t[(t[n>>2]|0)+52>>2]|0){e=Yl(t[(t[n>>2]|0)+52>>2]|0)|0;t[(t[f>>2]|0)+52>>2]=e}if(t[(t[n>>2]|0)+56>>2]|0){e=Yl(t[(t[n>>2]|0)+56>>2]|0)|0;t[(t[f>>2]|0)+56>>2]=e}if(t[(t[n>>2]|0)+40>>2]|0){e=Yl(t[(t[n>>2]|0)+40>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=e}if(t[(t[n>>2]|0)+36>>2]|0){e=Yl(t[(t[n>>2]|0)+36>>2]|0)|0;t[(t[f>>2]|0)+36>>2]=e}if(t[(t[n>>2]|0)+64>>2]|0){e=Yl(t[(t[n>>2]|0)+64>>2]|0)|0;t[(t[f>>2]|0)+64>>2]=e}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function M_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if((t[(t[n>>2]|0)+12>>2]|0)==2){s=r;return}i=(es(t[f>>2]|0,37)|0)!=0;e=t[n>>2]|0;if(!i){TF(e,t[f>>2]|0);s=r;return}MF(e,61760)|0;e=t[f>>2]|0;t[o>>2]=e;t[a>>2]=e;while(1){if(!(u[t[o>>2]>>0]|0))break;if((u[t[o>>2]>>0]|0|0)==34){if((t[a>>2]|0)!=(t[o>>2]|0))OF(t[n>>2]|0,t[a>>2]|0,(t[o>>2]|0)-(t[a>>2]|0)|0)|0;OF(t[n>>2]|0,61768,6)|0;t[o>>2]=(t[o>>2]|0)+1;t[a>>2]=t[o>>2];continue}if((u[t[o>>2]>>0]|0|0)!=37){t[o>>2]=(t[o>>2]|0)+1;continue}if((t[a>>2]|0)!=(t[o>>2]|0))OF(t[n>>2]|0,t[a>>2]|0,(t[o>>2]|0)-(t[a>>2]|0)|0)|0;OF(t[n>>2]|0,61776,6)|0;t[o>>2]=(t[o>>2]|0)+1;t[a>>2]=t[o>>2]}if((t[a>>2]|0)!=(t[o>>2]|0))OF(t[n>>2]|0,t[a>>2]|0,(t[o>>2]|0)-(t[a>>2]|0)|0)|0;MF(t[n>>2]|0,61760)|0;s=r;return}function R_(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+80>>2];if(((t[(t[r>>2]|0)+12>>2]|0)!=0?(t[(t[r>>2]|0)+68>>2]|0)==1:0)?(t[r>>2]|0)==(t[(t[(t[r>>2]|0)+12>>2]|0)+20>>2]|0):0)ty(t[(t[r>>2]|0)+12>>2]|0);e=(t[(t[r>>2]|0)+8>>2]|0)!=0;if(t[n>>2]|0){if(e?(wz(t[n>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if((t[(t[r>>2]|0)+52>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+52>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0);if((t[(t[r>>2]|0)+56>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+56>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0);if((t[(t[r>>2]|0)+64>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+64>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+64>>2]|0);if((t[(t[r>>2]|0)+40>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+40>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0);if((t[(t[r>>2]|0)+36>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+36>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+36>>2]|0)}else{if(e)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0);if(t[(t[r>>2]|0)+56>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0);if(t[(t[r>>2]|0)+64>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+64>>2]|0);if(t[(t[r>>2]|0)+40>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0);if(t[(t[r>>2]|0)+36>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+36>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function N_(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=t[c>>2];t[w>>2]=t[b>>2];if((t[c>>2]|0)==0|(t[b>>2]|0)==0|(t[l>>2]|0)==0|(t[k>>2]|0)==0){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}t[d>>2]=(t[c>>2]|0)+(t[t[l>>2]>>2]|0);t[v>>2]=(t[b>>2]|0)+(t[t[k>>2]>>2]|0);t[m>>2]=t[v>>2];e:while(1){if((t[b>>2]|0)>>>0<(t[v>>2]|0)>>>0)p=(t[c>>2]|0)>>>0<((t[d>>2]|0)+-1|0)>>>0;else p=0;E=t[b>>2]|0;if(!p)break;if((u[E>>0]|0|0)>=128){f=((u[t[b>>2]>>0]|0)>>6&31|192)&255;r=t[c>>2]|0;t[c>>2]=r+1;n[r>>0]=f;f=((u[t[b>>2]>>0]|0)&63|128)&255;r=t[c>>2]|0;t[c>>2]=r+1;n[r>>0]=f;t[b>>2]=(t[b>>2]|0)+1}if(((t[m>>2]|0)-(t[b>>2]|0)|0)>((t[d>>2]|0)-(t[c>>2]|0)|0))t[m>>2]=(t[b>>2]|0)+((t[d>>2]|0)-(t[c>>2]|0));while(1){if((t[b>>2]|0)>>>0>=(t[m>>2]|0)>>>0)continue e;if((u[t[b>>2]>>0]|0|0)>=128)continue e;f=t[b>>2]|0;t[b>>2]=f+1;r=n[f>>0]|0;f=t[c>>2]|0;t[c>>2]=f+1;n[f>>0]=r}}if((E>>>0<(t[v>>2]|0)>>>0?(t[c>>2]|0)>>>0<(t[d>>2]|0)>>>0:0)?(u[t[b>>2]>>0]|0|0)<128:0){d=t[b>>2]|0;t[b>>2]=d+1;v=n[d>>0]|0;d=t[c>>2]|0;t[c>>2]=d+1;n[d>>0]=v}t[t[l>>2]>>2]=(t[c>>2]|0)-(t[h>>2]|0);t[t[k>>2]>>2]=(t[b>>2]|0)-(t[w>>2]|0);t[o>>2]=t[t[l>>2]>>2];_=t[o>>2]|0;s=a;return _|0}function T_(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;a=s;s=s+64|0;o=a+48|0;c=a+44|0;l=a+40|0;b=a+36|0;k=a+32|0;h=a+28|0;w=a+24|0;d=a+20|0;v=a+16|0;m=a+12|0;_=a+8|0;p=a+4|0;E=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=t[b>>2];t[d>>2]=t[c>>2];t[v>>2]=t[b>>2];if((t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[k>>2]|0)==0){t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}if(!(t[b>>2]|0)){t[t[l>>2]>>2]=0;t[t[k>>2]>>2]=0;t[o>>2]=0;S=t[o>>2]|0;s=a;return S|0}t[m>>2]=(t[b>>2]|0)+(t[t[k>>2]>>2]|0);t[w>>2]=(t[c>>2]|0)+(t[t[l>>2]>>2]|0);e:while(1){if((t[b>>2]|0)>>>0>=(t[m>>2]|0)>>>0){g=28;break}f=t[b>>2]|0;t[b>>2]=f+1;t[p>>2]=u[f>>0];f=t[p>>2]|0;do if((t[p>>2]|0)>>>0<128){t[_>>2]=f;t[E>>2]=0}else{if(f>>>0<192){g=10;break e}r=t[p>>2]|0;if((t[p>>2]|0)>>>0<224){t[_>>2]=r&31;t[E>>2]=1;break}i=t[p>>2]|0;if(r>>>0<240){t[_>>2]=i&15;t[E>>2]=2;break}if(i>>>0>=248){g=17;break e}t[_>>2]=t[p>>2]&7;t[E>>2]=3}while(0);if(((t[m>>2]|0)-(t[b>>2]|0)|0)<(t[E>>2]|0)){g=28;break}while(1){if(!(t[E>>2]|0))break;if((t[b>>2]|0)>>>0>=(t[m>>2]|0)>>>0)break;f=t[b>>2]|0;t[b>>2]=f+1;i=u[f>>0]|0;t[p>>2]=i;if((i&192|0)!=128){g=22;break e}t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|t[p>>2]&63;t[E>>2]=(t[E>>2]|0)+-1}y=t[c>>2]|0;if((t[_>>2]|0)>>>0>255){g=27;break}if(y>>>0>=(t[w>>2]|0)>>>0){g=28;break}i=t[_>>2]&255;f=t[c>>2]|0;t[c>>2]=f+1;n[f>>0]=i;t[h>>2]=t[b>>2]}if((g|0)==10){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==17){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==22){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==27){t[t[l>>2]>>2]=y-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==28){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=t[t[l>>2]>>2];S=t[o>>2]|0;s=a;return S|0}return 0}function L_(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[f>>2]=e;t[a>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if((t[a>>2]|0)>=4){if((((u[t[f>>2]>>0]|0|0)==0?(u[(t[f>>2]|0)+1>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==60:0){t[n>>2]=5;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==60?(u[(t[f>>2]|0)+1>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==0:0){t[n>>2]=4;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==0?(u[(t[f>>2]|0)+1>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==60:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==0:0){t[n>>2]=7;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==0?(u[(t[f>>2]|0)+1>>0]|0|0)==60:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==0:0){t[n>>2]=8;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==76?(u[(t[f>>2]|0)+1>>0]|0|0)==111:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==167:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==148:0){t[n>>2]=6;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==60?(u[(t[f>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==120:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==109:0){t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==60?(u[(t[f>>2]|0)+1>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==63:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==0:0){t[n>>2]=2;o=t[n>>2]|0;s=r;return o|0}if((((u[t[f>>2]>>0]|0|0)==0?(u[(t[f>>2]|0)+1>>0]|0|0)==60:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==0:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==63:0){t[n>>2]=3;o=t[n>>2]|0;s=r;return o|0}}if((((t[a>>2]|0)>=3?(u[t[f>>2]>>0]|0|0)==239:0)?(u[(t[f>>2]|0)+1>>0]|0|0)==187:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==191:0){t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}if((t[a>>2]|0)>=2){if((u[t[f>>2]>>0]|0|0)==254?(u[(t[f>>2]|0)+1>>0]|0|0)==255:0){t[n>>2]=3;o=t[n>>2]|0;s=r;return o|0}if((u[t[f>>2]>>0]|0|0)==255?(u[(t[f>>2]|0)+1>>0]|0|0)==254:0){t[n>>2]=2;o=t[n>>2]|0;s=r;return o|0}}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function D_(){var e=0,i=0;e=s;s=s+16|0;i=e;if(!(t[15520]|0)){s=e;return}t[i>>2]=0;while(1){if((t[i>>2]|0)>=(t[15522]|0))break;if(t[(t[15520]|0)+(t[i>>2]<<3)>>2]|0)pAi[t[135736>>2]&511](t[(t[15520]|0)+(t[i>>2]<<3)>>2]|0);if(t[(t[15520]|0)+(t[i>>2]<<3)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[15520]|0)+(t[i>>2]<<3)+4>>2]|0);t[i>>2]=(t[i>>2]|0)+1}t[15522]=0;t[15524]=0;pAi[t[135736>>2]&511](t[15520]|0);t[15520]=0;s=e;return}function C_(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+112|0;r=i+8|0;f=i+4|0;u=i;a=i+12|0;t[f>>2]=e;if(!(t[f>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if(!(t[15520]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[u>>2]=0;while(1){if((t[u>>2]|0)>=99)break;e=(Pq(n[(t[f>>2]|0)+(t[u>>2]|0)>>0]|0)|0)&255;n[a+(t[u>>2]|0)>>0]=e;if(!(n[a+(t[u>>2]|0)>>0]|0))break;t[u>>2]=(t[u>>2]|0)+1}n[a+(t[u>>2]|0)>>0]=0;t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[15522]|0)){c=14;break}f=(MY(t[(t[15520]|0)+(t[u>>2]<<3)+4>>2]|0,a)|0)!=0;l=t[u>>2]|0;if(!f){c=12;break}t[u>>2]=l+1}if((c|0)==12){t[r>>2]=t[(t[15520]|0)+(l<<3)>>2];o=t[r>>2]|0;s=i;return o|0}else if((c|0)==14){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}return 0}function P_(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+128|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;c=r+16|0;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;l=t[f>>2]|0;s=r;return l|0}t[o>>2]=0;while(1){if((t[o>>2]|0)>=99)break;i=(Pq(n[(t[a>>2]|0)+(t[o>>2]|0)>>0]|0)|0)&255;n[c+(t[o>>2]|0)>>0]=i;if(!(n[c+(t[o>>2]|0)>>0]|0))break;t[o>>2]=(t[o>>2]|0)+1}n[c+(t[o>>2]|0)>>0]=0;if(!(t[15520]|0)){t[15522]=0;t[15524]=20;t[15520]=gAi[t[135744>>2]&511](t[15524]<<3)|0;if(!(t[15520]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=r;return l|0}}else if((t[15522]|0)>=(t[15524]|0)){t[15524]=t[15524]<<1;t[15520]=MAi[t[135760>>2]&511](t[15520]|0,t[15524]<<3)|0}t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[15522]|0)){b=17;break}if(!(MY(t[(t[15520]|0)+(t[o>>2]<<3)+4>>2]|0,c)|0)){b=15;break}t[o>>2]=(t[o>>2]|0)+1}if((b|0)==15){pAi[t[135736>>2]&511](t[(t[15520]|0)+(t[o>>2]<<3)>>2]|0);a=gAi[t[135768>>2]&511](t[u>>2]|0)|0;t[(t[15520]|0)+(t[o>>2]<<3)>>2]=a;t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}else if((b|0)==17){b=gAi[t[135768>>2]&511](t[u>>2]|0)|0;t[(t[15520]|0)+(t[15522]<<3)>>2]=b;b=gAi[t[135768>>2]&511](c)|0;t[(t[15520]|0)+(t[15522]<<3)+4>>2]=b;t[15522]=(t[15522]|0)+1;t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}return 0}function B_(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0;i=s;s=s+528|0;r=i+12|0;f=i+8|0;u=i+4|0;a=i+16|0;o=i;t[f>>2]=e;do if(t[f>>2]|0){t[u>>2]=C_(t[f>>2]|0)|0;if(t[u>>2]|0)t[f>>2]=t[u>>2];t[o>>2]=0;while(1){if((t[o>>2]|0)>=499)break;e=(Pq(n[(t[f>>2]|0)+(t[o>>2]|0)>>0]|0)|0)&255;n[a+(t[o>>2]|0)>>0]=e;if(!(n[a+(t[o>>2]|0)>>0]|0))break;t[o>>2]=(t[o>>2]|0)+1}n[a+(t[o>>2]|0)>>0]=0;if(!(MY(a,62104)|0)){t[r>>2]=0;break}if(!(MY(a,62112)|0)){t[r>>2]=1;break}if(!(MY(a,62120)|0)){t[r>>2]=1;break}if(!(MY(a,62128)|0)){t[r>>2]=2;break}if(!(MY(a,62136)|0)){t[r>>2]=2;break}if(!(MY(a,62144)|0)){t[r>>2]=9;break}if(!(MY(a,62160)|0)){t[r>>2]=9;break}if(!(MY(a,62168)|0)){t[r>>2]=9;break}if(!(MY(a,62176)|0)){t[r>>2]=4;break}if(!(MY(a,62192)|0)){t[r>>2]=4;break}if(!(MY(a,62200)|0)){t[r>>2]=4;break}if(!(MY(a,62208)|0)){t[r>>2]=10;break}if(!(MY(a,62224)|0)){t[r>>2]=10;break}if(!(MY(a,62240)|0)){t[r>>2]=10;break}if(!(MY(a,62256)|0)){t[r>>2]=11;break}if(!(MY(a,62272)|0)){t[r>>2]=11;break}if(!(MY(a,62288)|0)){t[r>>2]=11;break}if(!(MY(a,62304)|0)){t[r>>2]=12;break}if(!(MY(a,62320)|0)){t[r>>2]=13;break}if(!(MY(a,62336)|0)){t[r>>2]=14;break}if(!(MY(a,62352)|0)){t[r>>2]=15;break}if(!(MY(a,62368)|0)){t[r>>2]=16;break}if(!(MY(a,62384)|0)){t[r>>2]=17;break}if(!(MY(a,62400)|0)){t[r>>2]=18;break}if(!(MY(a,62416)|0)){t[r>>2]=19;break}if(!(MY(a,62432)|0)){t[r>>2]=20;break}if(MY(a,62448)|0){t[r>>2]=-1;break}else{t[r>>2]=21;break}}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function I_(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do switch(t[n>>2]|0){case 4:{t[r>>2]=62176;break}case 10:{t[r>>2]=62208;break}case 20:{t[r>>2]=62464;break}case 3:{t[r>>2]=62128;break}case 15:{t[r>>2]=62352;break}case 12:{t[r>>2]=62304;break}case 6:{t[r>>2]=62456;break}case 21:{t[r>>2]=62448;break}case 13:{t[r>>2]=62320;break}case 19:{t[r>>2]=62416;break}case 7:{t[r>>2]=62176;break}case 5:{t[r>>2]=62176;break}case 1:{t[r>>2]=62112;break}case 9:{t[r>>2]=62144;break}case 11:{t[r>>2]=62256;break}case 8:{t[r>>2]=62176;break}case 17:{t[r>>2]=62384;break}case 14:{t[r>>2]=62336;break}case 18:{t[r>>2]=62400;break}case-1:{t[r>>2]=0;break}case 16:{t[r>>2]=62368;break}case 22:{t[r>>2]=0;break}case 0:{t[r>>2]=0;break}case 2:{t[r>>2]=62128;break}default:t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function H_(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+544|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+32|0;h=f+4|0;w=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[w>>2]=0;t[b>>2]=C_(t[a>>2]|0)|0;if(t[b>>2]|0)t[a>>2]=t[b>>2];if(!(t[a>>2]|0)){K_(6e3,62480,0);t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}t[h>>2]=0;while(1){if((t[h>>2]|0)>=499)break;b=(Pq(n[(t[a>>2]|0)+(t[h>>2]|0)>>0]|0)|0)&255;n[k+(t[h>>2]|0)>>0]=b;if(!(n[k+(t[h>>2]|0)>>0]|0))break;t[h>>2]=(t[h>>2]|0)+1}n[k+(t[h>>2]|0)>>0]=0;t[w>>2]=gAi[t[135768>>2]&511](k)|0;if(!(t[w>>2]|0)){X_(62520);t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}t[l>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[l>>2]|0)){pAi[t[135736>>2]&511](t[w>>2]|0);X_(62520);t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}else{k=t[l>>2]|0;t[k+0>>2]=0;t[k+4>>2]=0;t[k+8>>2]=0;t[k+12>>2]=0;t[k+16>>2]=0;t[(t[l>>2]|0)+4>>2]=t[o>>2];t[(t[l>>2]|0)+8>>2]=t[c>>2];t[t[l>>2]>>2]=t[w>>2];t[(t[l>>2]|0)+12>>2]=0;t[(t[l>>2]|0)+16>>2]=0;x_(t[l>>2]|0);t[u>>2]=t[l>>2];d=t[u>>2]|0;s=f;return d|0}return 0}function x_(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[15642]|0))U_();if((t[r>>2]|0)==0|(t[15642]|0)==0){K_(6001,62768,0);s=i;return}if((t[15688]|0)>=50){K_(6002,62816,62888);s=i;return}else{e=t[r>>2]|0;r=t[15688]|0;t[15688]=r+1;t[(t[15642]|0)+(r<<2)>>2]=e;s=i;return}}function U_(){var e=0,i=0,r=0;e=s;s=s+16|0;i=e+4|0;r=e;f[i>>1]=4660;t[r>>2]=i;if(t[15642]|0){s=e;return}t[15642]=gAi[t[135744>>2]&511](200)|0;do if((u[t[r>>2]>>0]|0|0)!=18)if((u[t[r>>2]>>0]|0|0)==52){t[15644]=1;break}else{K_(1,62584,0);break}else t[15644]=0;while(0);if(!(t[15642]|0)){X_(62624);s=e;return}else{H_(62112,213,213)|0;t[15672]=H_(62672,214,215)|0;t[15678]=H_(62696,216,217)|0;H_(62128,214,218)|0;H_(62208,219,220)|0;H_(62720,221,222)|0;H_(62728,221,222)|0;H_(62744,0,223)|0;s=e;return}}function z_(){var e=0;e=s;D_();if(!(t[15642]|0)){s=e;return}while(1){if((t[15688]|0)<=0)break;t[15688]=(t[15688]|0)+-1;if(!(t[(t[15642]|0)+(t[15688]<<2)>>2]|0))continue;if(t[t[(t[15642]|0)+(t[15688]<<2)>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[(t[15642]|0)+(t[15688]<<2)>>2]>>2]|0);pAi[t[135736>>2]&511](t[(t[15642]|0)+(t[15688]<<2)>>2]|0)}pAi[t[135736>>2]&511](t[15642]|0);t[15642]=0;t[15688]=0;t[15690]=0;s=e;return}function j_(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[15642]|0))U_();e:do switch(t[n>>2]|0){case 6:{t[f>>2]=V_(62456)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62912)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62920)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62936)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 2:{t[r>>2]=t[15672];break}case 9:{t[f>>2]=V_(62144)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62160)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62168)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 18:{t[f>>2]=V_(62400)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 3:{t[r>>2]=t[15678];break}case 10:{t[f>>2]=V_(62208)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case-1:{t[r>>2]=0;break}case 12:{t[f>>2]=V_(62304)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 5:{t[f>>2]=V_(62176)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62192)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62200)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 14:{t[f>>2]=V_(62336)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 19:{t[f>>2]=V_(62416)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 20:{t[f>>2]=V_(62944)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62432)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62960)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 11:{t[f>>2]=V_(62256)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 0:{t[r>>2]=0;break}case 17:{t[f>>2]=V_(62384)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 15:{t[f>>2]=V_(62352)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 16:{t[f>>2]=V_(62368)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 13:{t[f>>2]=V_(62320)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 21:{t[f>>2]=V_(62448)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}case 1:{t[r>>2]=0;break}case 4:{t[f>>2]=V_(62176)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62192)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];break e}t[f>>2]=V_(62200)|0;if(t[f>>2]|0)t[r>>2]=t[f>>2];else u=63;break}default:u=63}while(0);if((u|0)==63)t[r>>2]=0;s=i;return t[r>>2]|0}function V_(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+144|0;r=i+36|0;f=i+32|0;u=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+40|0;h=i+4|0;w=i;t[f>>2]=e;if(!(t[15642]|0))U_();if(!(t[f>>2]|0)){t[r>>2]=t[15690];d=t[r>>2]|0;s=i;return d|0}if(!(n[t[f>>2]>>0]|0)){t[r>>2]=t[15690];d=t[r>>2]|0;s=i;return d|0}t[a>>2]=t[f>>2];t[u>>2]=C_(t[f>>2]|0)|0;if(t[u>>2]|0)t[f>>2]=t[u>>2];t[h>>2]=0;while(1){if((t[h>>2]|0)>=99)break;u=(Pq(n[(t[f>>2]|0)+(t[h>>2]|0)>>0]|0)|0)&255;n[k+(t[h>>2]|0)>>0]=u;if(!(n[k+(t[h>>2]|0)>>0]|0))break;t[h>>2]=(t[h>>2]|0)+1}n[k+(t[h>>2]|0)>>0]=0;e:do if(t[15642]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[15688]|0))break e;u=(MY(k,t[t[(t[15642]|0)+(t[h>>2]<<2)>>2]>>2]|0)|0)!=0;v=t[h>>2]|0;if(!u)break;t[h>>2]=v+1}t[r>>2]=t[(t[15642]|0)+(v<<2)>>2];d=t[r>>2]|0;s=i;return d|0}while(0);t[l>>2]=Bq(62112,t[f>>2]|0)|0;t[b>>2]=Bq(t[f>>2]|0,62112)|0;if((t[l>>2]|0)==(-1|0))t[l>>2]=Bq(62112,k)|0;if((t[b>>2]|0)==(-1|0))t[b>>2]=Bq(k,62112)|0;if((t[l>>2]|0)!=(-1|0)&(t[b>>2]|0)!=(-1|0)){t[c>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[c>>2]|0)){t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}else{k=t[c>>2]|0;t[k+0>>2]=0;t[k+4>>2]=0;t[k+8>>2]=0;t[k+12>>2]=0;t[k+16>>2]=0;k=gAi[t[135768>>2]&511](t[f>>2]|0)|0;t[t[c>>2]>>2]=k;t[(t[c>>2]|0)+4>>2]=0;t[(t[c>>2]|0)+8>>2]=0;t[(t[c>>2]|0)+12>>2]=t[l>>2];t[(t[c>>2]|0)+16>>2]=t[b>>2];t[r>>2]=t[c>>2];d=t[r>>2]|0;s=i;return d|0}}if((t[l>>2]|0)!=(-1|0)|(t[b>>2]|0)!=(-1|0))K_(1,62976,t[f>>2]|0);t[o>>2]=B_(t[a>>2]|0)|0;if(((t[o>>2]|0)!=-1?(t[w>>2]=I_(t[o>>2]|0)|0,(t[w>>2]|0)!=0):0)?(MY(t[f>>2]|0,t[w>>2]|0)|0)!=0:0){t[r>>2]=V_(t[w>>2]|0)|0;d=t[r>>2]|0;s=i;return d|0}t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}function q_(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;
	r=s;s=s+112|0;f=r;a=r+56|0;o=r+52|0;c=r+48|0;l=r+44|0;b=r+40|0;k=r+36|0;h=r+32|0;w=r+28|0;d=r+24|0;v=r+20|0;m=r+60|0;_=r+16|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=-2;if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)?(t[(t[o>>2]|0)+16>>2]|0)!=0:0)?(t[(t[o>>2]|0)+20>>2]|0)!=0:0){t[v>>2]=t[(t[o>>2]|0)+16>>2];t[d>>2]=t[(t[o>>2]|0)+20>>2];t[k>>2]=Ts(t[d>>2]|0)|0;if(!(t[k>>2]|0)){t[a>>2]=0;p=t[a>>2]|0;s=r;return p|0}t[b>>2]=(Ls(t[v>>2]|0)|0)-1;i=t[k>>2]|0;if((t[c>>2]|0)>=0){if(i>>>0>(t[c>>2]|0)>>>0)t[k>>2]=t[c>>2]}else if(i>>>0>180)t[k>>2]=180;if(t[k>>2]<<1>>>0>=(t[b>>2]|0)>>>0){Fs(t[v>>2]|0,t[k>>2]<<1)|0;t[b>>2]=(Ls(t[v>>2]|0)|0)-1}if((t[b>>2]|0)>>>0>360)t[b>>2]=360;t[h>>2]=t[k>>2];t[w>>2]=t[b>>2];b=t[(t[o>>2]|0)+12>>2]|0;if(!(t[(t[(t[o>>2]|0)+12>>2]|0)+4>>2]|0)){if((t[b+12>>2]|0)!=0?(k=t[(t[(t[o>>2]|0)+12>>2]|0)+12>>2]|0,o=As(t[v>>2]|0)|0,t[l>>2]=fp(k,o,w,Os(t[d>>2]|0)|0,h)|0,ys(t[d>>2]|0,t[h>>2]|0)|0,Ms(t[v>>2]|0,t[w>>2]|0)|0,(t[l>>2]|0)==-1):0)t[l>>2]=-3}else{o=t[b+4>>2]|0;b=As(t[v>>2]|0)|0;k=Os(t[d>>2]|0)|0;t[l>>2]=OAi[o&511](b,w,k,h)|0;ys(t[d>>2]|0,t[h>>2]|0)|0;Ms(t[v>>2]|0,t[w>>2]|0)|0}if((t[l>>2]|0)==-2){t[_>>2]=Os(t[d>>2]|0)|0;d=u[(t[_>>2]|0)+1>>0]|0;w=u[(t[_>>2]|0)+2>>0]|0;v=u[(t[_>>2]|0)+3>>0]|0;t[f>>2]=u[t[_>>2]>>0];t[f+4>>2]=d;t[f+8>>2]=w;t[f+12>>2]=v;SY(m,49,63016,f)|0;n[m+49>>0]=0;K_(6003,63048,m)}if((t[l>>2]|0)==-3)t[l>>2]=0;if((t[l>>2]|0)==-1)t[l>>2]=0;t[a>>2]=t[l>>2];p=t[a>>2]|0;s=r;return p|0}t[a>>2]=-1;p=t[a>>2]|0;s=r;return p|0}function Y_(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+112|0;f=r;a=r+56|0;o=r+52|0;c=r+48|0;l=r+44|0;b=r+40|0;k=r+36|0;h=r+32|0;w=r+28|0;d=r+24|0;v=r+20|0;m=r+60|0;_=r+16|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=-2;if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)?(t[(t[o>>2]|0)+16>>2]|0)!=0:0)?(t[(t[o>>2]|0)+20>>2]|0)!=0:0){t[v>>2]=t[(t[o>>2]|0)+16>>2];t[d>>2]=t[(t[o>>2]|0)+20>>2];t[k>>2]=Ts(t[d>>2]|0)|0;if(!(t[k>>2]|0)){t[a>>2]=0;p=t[a>>2]|0;s=r;return p|0}if((t[k>>2]|0)>>>0>65536&(t[c>>2]|0)==0)t[k>>2]=65536;t[b>>2]=Ls(t[v>>2]|0)|0;if((t[b>>2]|0)>>>0>0)t[b>>2]=(t[b>>2]|0)+-1;if(t[k>>2]<<1>>>0>=(t[b>>2]|0)>>>0?(Fs(t[v>>2]|0,t[k>>2]<<1)|0,t[b>>2]=Ls(t[v>>2]|0)|0,(t[b>>2]|0)>>>0>0):0)t[b>>2]=(t[b>>2]|0)+-1;if((t[b>>2]|0)>>>0>131072&(t[c>>2]|0)==0)t[b>>2]=131072;t[h>>2]=t[k>>2];t[w>>2]=t[b>>2];b=t[(t[o>>2]|0)+12>>2]|0;if(!(t[(t[(t[o>>2]|0)+12>>2]|0)+4>>2]|0)){if((t[b+12>>2]|0)!=0?(k=t[(t[(t[o>>2]|0)+12>>2]|0)+12>>2]|0,o=As(t[v>>2]|0)|0,t[l>>2]=fp(k,o,w,Os(t[d>>2]|0)|0,h)|0,ys(t[d>>2]|0,t[h>>2]|0)|0,Ms(t[v>>2]|0,t[w>>2]|0)|0,(t[l>>2]|0)==-1):0)t[l>>2]=-3}else{o=t[b+4>>2]|0;b=As(t[v>>2]|0)|0;k=Os(t[d>>2]|0)|0;t[l>>2]=OAi[o&511](b,w,k,h)|0;ys(t[d>>2]|0,t[h>>2]|0)|0;Ms(t[v>>2]|0,t[w>>2]|0)|0}if((t[l>>2]|0)==-2){t[_>>2]=Os(t[d>>2]|0)|0;d=u[(t[_>>2]|0)+1>>0]|0;v=u[(t[_>>2]|0)+2>>0]|0;h=u[(t[_>>2]|0)+3>>0]|0;t[f>>2]=u[t[_>>2]>>0];t[f+4>>2]=d;t[f+8>>2]=v;t[f+12>>2]=h;SY(m,49,63016,f)|0;n[m+49>>0]=0;K_(6003,63048,m)}if((t[l>>2]|0)==-3)t[l>>2]=0;t[a>>2]=(t[w>>2]|0)!=0?t[w>>2]|0:t[l>>2]|0;p=t[a>>2]|0;s=r;return p|0}t[a>>2]=-1;p=t[a>>2]|0;s=r;return p|0}function G_(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;r=s;s=s+160|0;f=r;a=r+72|0;o=r+68|0;c=r+64|0;l=r+60|0;b=r+56|0;k=r+52|0;h=r+48|0;w=r+44|0;d=r+40|0;v=r+36|0;m=r+32|0;_=r+28|0;p=r+24|0;E=r+20|0;S=r+16|0;g=r+128|0;y=r+76|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=-2;t[k>>2]=0;t[_>>2]=0;if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)?(t[(t[o>>2]|0)+16>>2]|0)!=0:0)?(t[(t[o>>2]|0)+20>>2]|0)!=0:0){t[m>>2]=t[(t[o>>2]|0)+20>>2];t[v>>2]=t[(t[o>>2]|0)+16>>2];e:while(1){t[b>>2]=Ls(t[m>>2]|0)|0;if((t[b>>2]|0)>>>0>0)t[b>>2]=(t[b>>2]|0)+-1;if(t[c>>2]|0){F=10;break}t[h>>2]=Ts(t[v>>2]|0)|0;if(!(t[h>>2]|0)){F=17;break}if((t[h>>2]|0)>>>0>65536)t[h>>2]=65536;if(t[h>>2]<<2>>>0>=(t[b>>2]|0)>>>0){Fs(t[m>>2]|0,t[h>>2]<<2)|0;t[b>>2]=(Ls(t[m>>2]|0)|0)-1}if((t[b>>2]|0)>>>0>262144)t[b>>2]=262144;t[w>>2]=t[h>>2];t[d>>2]=t[b>>2];i=t[(t[o>>2]|0)+12>>2]|0;do if(t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]|0){e=t[i+8>>2]|0;O=As(t[m>>2]|0)|0;A=Os(t[v>>2]|0)|0;t[l>>2]=OAi[e&511](O,d,A,w)|0;if((t[d>>2]|0)>0){ys(t[v>>2]|0,t[w>>2]|0)|0;Ms(t[m>>2]|0,t[d>>2]|0)|0;t[k>>2]=(t[k>>2]|0)+(t[d>>2]|0)}}else{if(!(t[i+16>>2]|0)){F=32;break e}A=t[(t[(t[o>>2]|0)+12>>2]|0)+16>>2]|0;O=As(t[m>>2]|0)|0;t[l>>2]=fp(A,O,d,Os(t[v>>2]|0)|0,w)|0;ys(t[v>>2]|0,t[w>>2]|0)|0;Ms(t[m>>2]|0,t[d>>2]|0)|0;t[k>>2]=(t[k>>2]|0)+(t[d>>2]|0);if((t[l>>2]|0)==-1)if((t[d>>2]|0)>0){t[_>>2]=0;continue e}else{t[l>>2]=-3;break}}while(0);if((t[l>>2]|0)>=0)t[o>>2]=(t[o>>2]|0)+(t[l>>2]<<5);if((t[l>>2]|0)!=-2)break;t[p>>2]=Ts(t[v>>2]|0)|0;t[E>>2]=Os(t[v>>2]|0)|0;t[S>>2]=cs(t[E>>2]|0,p)|0;if((t[_>>2]|0)!=0?(t[d>>2]|0)<(t[_>>2]|0):0){F=38;break}if((t[S>>2]|0)<=0){F=41;break}t[f>>2]=t[S>>2];t[_>>2]=SY(g,20,63152,f)|0;ys(t[v>>2]|0,t[p>>2]|0)|0;Bs(t[v>>2]|0,g,-1)|0}if((F|0)==10){t[w>>2]=0;t[d>>2]=t[b>>2];b=t[(t[o>>2]|0)+12>>2]|0;if(t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]|0){g=t[b+8>>2]|0;p=As(t[m>>2]|0)|0;t[l>>2]=OAi[g&511](p,d,0,w)|0;if((t[l>>2]|0)>0)Ms(t[m>>2]|0,t[d>>2]|0)|0}else if(t[b+16>>2]|0){b=t[(t[(t[o>>2]|0)+12>>2]|0)+16>>2]|0;t[l>>2]=fp(b,As(t[m>>2]|0)|0,d,0,w)|0;Ms(t[m>>2]|0,t[d>>2]|0)|0}t[a>>2]=0;M=t[a>>2]|0;s=r;return M|0}else if((F|0)==17){t[a>>2]=0;M=t[a>>2]|0;s=r;return M|0}else if((F|0)==32){K_(6004,63104,0);t[a>>2]=-1;M=t[a>>2]|0;s=r;return M|0}else if((F|0)==38){Rs(t[m>>2]|0,t[d>>2]|0)|0;t[k>>2]=(t[k>>2]|0)-(t[d>>2]|0);ys(t[v>>2]|0,(t[_>>2]|0)-(t[d>>2]|0)|0)|0;t[_>>2]=0;t[l>>2]=-1}else if((F|0)==41?(F=u[(t[E>>2]|0)+1>>0]|0,_=u[(t[E>>2]|0)+2>>0]|0,d=u[(t[E>>2]|0)+3>>0]|0,t[f>>2]=u[t[E>>2]>>0],t[f+4>>2]=F,t[f+8>>2]=_,t[f+12>>2]=d,SY(y,49,63016,f)|0,n[y+49>>0]=0,K_(6003,63160,y),(ps(t[v>>2]|0)|0)!=2):0)n[t[E>>2]>>0]=32;t[a>>2]=t[l>>2];M=t[a>>2]|0;s=r;return M|0}t[a>>2]=-1;M=t[a>>2]|0;s=r;return M|0}function W_(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=0;t[o>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}if(!(t[t[n>>2]>>2]|0)){t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}e:do if(t[15642]|0){t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[15688]|0))break e;if((t[n>>2]|0)==(t[(t[15642]|0)+(t[a>>2]<<2)>>2]|0))break;t[a>>2]=(t[a>>2]|0)+1}t[o>>2]=1}while(0);do if(!(t[o>>2]|0)){if((t[(t[n>>2]|0)+16>>2]|0)==0?(t[(t[n>>2]|0)+12>>2]|0)==0:0)break;t[u>>2]=1;if(t[(t[n>>2]|0)+16>>2]|0){if(Iq(t[(t[n>>2]|0)+16>>2]|0)|0)t[f>>2]=-1;t[(t[n>>2]|0)+16>>2]=0}if(t[(t[n>>2]|0)+12>>2]|0){if(Iq(t[(t[n>>2]|0)+12>>2]|0)|0)t[f>>2]=-1;t[(t[n>>2]|0)+12>>2]=0}}while(0);if(t[u>>2]|0){if(t[t[n>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[n>>2]>>2]|0);t[t[n>>2]>>2]=0;pAi[t[135736>>2]&511](t[n>>2]|0)}t[r>>2]=t[f>>2];c=t[r>>2]|0;s=i;return c|0}function K_(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n;u=n+12|0;a=n+8|0;o=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;r=t[u>>2]|0;u=t[o>>2]|0;i=t[a>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,0,0,27,r,3,0,0,u,0,0,0,0,i,f);s=n;return}function X_(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;dp(27,2,0,0,t[r>>2]|0);s=i;return}function Z_(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[c>>2]|0)==0|(t[o>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if((t[t[o>>2]>>2]|0)>(t[t[l>>2]>>2]|0))t[b>>2]=t[t[l>>2]>>2];else t[b>>2]=t[t[o>>2]>>2];if((t[b>>2]|0)<0){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}else{YY(t[a>>2]|0,t[c>>2]|0,t[b>>2]|0)|0;t[t[o>>2]>>2]=t[b>>2];t[t[l>>2]>>2]=t[b>>2];t[u>>2]=t[t[o>>2]>>2];k=t[u>>2]|0;s=f;return k|0}return 0}function J_(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;o=s;s=s+64|0;c=o+56|0;l=o+52|0;b=o+48|0;k=o+44|0;h=o+40|0;w=o+36|0;d=o+32|0;v=o+28|0;m=o+24|0;_=o+20|0;p=o+16|0;E=o+12|0;S=o+8|0;g=o+4|0;y=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=t[l>>2];t[d>>2]=t[k>>2];t[v>>2]=(t[l>>2]|0)+(t[t[b>>2]>>2]|0);t[m>>2]=t[k>>2];if(((t[t[h>>2]>>2]|0)%2|0|0)==1){f=t[h>>2]|0;t[f>>2]=(t[f>>2]|0)+-1}t[S>>2]=(t[t[h>>2]>>2]|0)/2|0;t[_>>2]=(t[m>>2]|0)+(t[S>>2]<<1);while(1){if((t[m>>2]|0)>>>0>=(t[_>>2]|0)>>>0){F=29;break}if(((t[l>>2]|0)-(t[w>>2]|0)+5|0)>=(t[t[b>>2]>>2]|0)){F=29;break}S=t[m>>2]|0;if(t[15644]|0){t[m>>2]=S+2;t[p>>2]=a[S>>1]}else{t[g>>2]=S;S=t[g>>2]|0;t[g>>2]=S+1;t[p>>2]=u[S>>0];t[p>>2]=t[p>>2]|(u[t[g>>2]>>0]|0)<<8;t[m>>2]=(t[m>>2]|0)+2}if((t[p>>2]&64512|0)==55296){if((t[m>>2]|0)>>>0>=(t[_>>2]|0)>>>0){F=29;break}S=t[m>>2]|0;if(t[15644]|0){t[m>>2]=S+2;t[E>>2]=a[S>>1]}else{t[g>>2]=S;S=t[g>>2]|0;t[g>>2]=S+1;t[E>>2]=u[S>>0];t[E>>2]=t[E>>2]|(u[t[g>>2]>>0]|0)<<8;t[m>>2]=(t[m>>2]|0)+2}if((t[E>>2]&64512|0)!=56320){F=16;break}t[p>>2]=t[p>>2]&1023;t[p>>2]=t[p>>2]<<10;t[p>>2]=t[p>>2]|t[E>>2]&1023;t[p>>2]=(t[p>>2]|0)+65536}if((t[l>>2]|0)>>>0>=(t[v>>2]|0)>>>0){F=29;break}S=t[p>>2]|0;do if((t[p>>2]|0)>>>0>=128){f=t[p>>2]|0;if(S>>>0<2048){r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=f>>>6&31|192;t[y>>2]=0;break}r=t[p>>2]|0;if(f>>>0<65536){f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=r>>>12&15|224;t[y>>2]=6;break}else{f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=r>>>18&7|240;t[y>>2]=12;break}}else{r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=S;t[y>>2]=-6}while(0);while(1){if((t[y>>2]|0)<0)break;if((t[l>>2]|0)>>>0>=(t[v>>2]|0)>>>0)break;S=((t[p>>2]|0)>>>(t[y>>2]|0)&63|128)&255;r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=S;t[y>>2]=(t[y>>2]|0)-6}t[d>>2]=t[m>>2]}if((F|0)==16){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[d>>2]|0)-(t[k>>2]|0);t[c>>2]=-2;O=t[c>>2]|0;s=o;return O|0}else if((F|0)==29){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[d>>2]|0)-(t[k>>2]|0);t[c>>2]=t[t[b>>2]>>2];O=t[c>>2]|0;s=o;return O|0}return 0}function Q_(e,i,r,o){e=e|0;i=i|0;r=r|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;c=s;s=s+64|0;l=c+56|0;b=c+52|0;k=c+48|0;h=c+44|0;w=c+40|0;d=c+36|0;v=c+32|0;m=c+28|0;_=c+24|0;p=c+20|0;E=c+16|0;S=c+12|0;g=c+8|0;y=c+4|0;F=c;O=c+62|0;A=c+60|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=o;t[d>>2]=t[b>>2];t[v>>2]=t[h>>2];t[m>>2]=t[h>>2];t[_>>2]=t[d>>2];if((t[d>>2]|0)==0|(t[k>>2]|0)==0|(t[w>>2]|0)==0){t[l>>2]=-1;M=t[l>>2]|0;s=c;return M|0}if(!(t[h>>2]|0)){t[t[k>>2]>>2]=0;t[t[w>>2]>>2]=0;t[l>>2]=0;M=t[l>>2]|0;s=c;return M|0}t[E>>2]=(t[h>>2]|0)+(t[t[w>>2]>>2]|0);t[p>>2]=(t[d>>2]|0)+(((t[t[k>>2]>>2]|0)/2|0)<<1);e:while(1){if((t[h>>2]|0)>>>0>=(t[E>>2]|0)>>>0){R=34;break}b=t[h>>2]|0;t[h>>2]=b+1;t[g>>2]=u[b>>0];b=t[g>>2]|0;do if((t[g>>2]|0)>>>0<128){t[S>>2]=b;t[y>>2]=0}else{if(b>>>0<192){R=10;break e}o=t[g>>2]|0;if((t[g>>2]|0)>>>0<224){t[S>>2]=o&31;t[y>>2]=1;break}r=t[g>>2]|0;if(o>>>0<240){t[S>>2]=r&15;t[y>>2]=2;break}if(r>>>0>=248){R=17;break e}t[S>>2]=t[g>>2]&7;t[y>>2]=3}while(0);if(((t[E>>2]|0)-(t[h>>2]|0)|0)<(t[y>>2]|0)){R=34;break}while(1){if(!(t[y>>2]|0))break;if((t[h>>2]|0)>>>0>=(t[E>>2]|0)>>>0)break;b=t[h>>2]|0;t[h>>2]=b+1;r=u[b>>0]|0;t[g>>2]=r;if((r&192|0)!=128)break;t[S>>2]=t[S>>2]<<6;t[S>>2]=t[S>>2]|t[g>>2]&63;t[y>>2]=(t[y>>2]|0)+-1}do if((t[S>>2]|0)>>>0<65536){if((t[d>>2]|0)>>>0>=(t[p>>2]|0)>>>0){R=34;break e}if(t[15644]|0){r=t[S>>2]&65535;b=t[d>>2]|0;t[d>>2]=b+2;f[b>>1]=r;break}else{t[F>>2]=t[d>>2];n[t[F>>2]>>0]=t[S>>2];n[(t[F>>2]|0)+1>>0]=(t[S>>2]|0)>>>8;t[d>>2]=(t[d>>2]|0)+2;break}}else{if((t[S>>2]|0)>>>0>=1114112){R=34;break e}if(((t[d>>2]|0)+2|0)>>>0>=(t[p>>2]|0)>>>0){R=34;break e}t[S>>2]=(t[S>>2]|0)-65536;r=(55296|(t[S>>2]|0)>>>10)&65535;if(t[15644]|0){b=t[d>>2]|0;t[d>>2]=b+2;f[b>>1]=r;b=(56320|t[S>>2]&1023)&65535;o=t[d>>2]|0;t[d>>2]=o+2;f[o>>1]=b;break}else{f[O>>1]=r;t[F>>2]=t[d>>2];n[t[F>>2]>>0]=f[O>>1];n[(t[F>>2]|0)+1>>0]=(a[O>>1]|0)>>8;t[d>>2]=(t[d>>2]|0)+2;f[A>>1]=56320|t[S>>2]&1023;t[F>>2]=t[d>>2];n[t[F>>2]>>0]=f[A>>1];n[(t[F>>2]|0)+1>>0]=(a[A>>1]|0)>>8;t[d>>2]=(t[d>>2]|0)+2;break}}while(0);t[v>>2]=t[h>>2]}if((R|0)==10){t[t[k>>2]>>2]=(((t[d>>2]|0)-(t[_>>2]|0)|0)/2|0)<<1;t[t[w>>2]>>2]=(t[v>>2]|0)-(t[m>>2]|0);t[l>>2]=-2;M=t[l>>2]|0;s=c;return M|0}else if((R|0)==17){t[t[k>>2]>>2]=(((t[d>>2]|0)-(t[_>>2]|0)|0)/2|0)<<1;t[t[w>>2]>>2]=(t[v>>2]|0)-(t[m>>2]|0);t[l>>2]=-2;M=t[l>>2]|0;s=c;return M|0}else if((R|0)==34){t[t[k>>2]>>2]=(((t[d>>2]|0)-(t[_>>2]|0)|0)/2|0)<<1;t[t[w>>2]>>2]=(t[v>>2]|0)-(t[m>>2]|0);t[l>>2]=t[t[k>>2]>>2];M=t[l>>2]|0;s=c;return M|0}return 0}function $_(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;o=s;s=s+64|0;c=o+56|0;l=o+52|0;b=o+48|0;k=o+44|0;h=o+40|0;w=o+36|0;d=o+32|0;v=o+28|0;m=o+24|0;_=o+20|0;p=o+16|0;E=o+12|0;S=o+8|0;g=o+4|0;y=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=t[l>>2];t[d>>2]=t[k>>2];t[v>>2]=(t[l>>2]|0)+(t[t[b>>2]>>2]|0);t[m>>2]=t[k>>2];if(((t[t[h>>2]>>2]|0)%2|0|0)==1){f=t[h>>2]|0;t[f>>2]=(t[f>>2]|0)+-1}t[S>>2]=(t[t[h>>2]>>2]|0)/2|0;t[_>>2]=(t[m>>2]|0)+(t[S>>2]<<1);while(1){if((t[m>>2]|0)>>>0>=(t[_>>2]|0)>>>0){F=29;break}S=t[m>>2]|0;if(t[15644]|0){t[g>>2]=S;f=t[g>>2]|0;t[g>>2]=f+1;t[p>>2]=u[f>>0];t[p>>2]=t[p>>2]<<8;t[p>>2]=t[p>>2]|(u[t[g>>2]>>0]|0);t[m>>2]=(t[m>>2]|0)+2}else{t[m>>2]=S+2;t[p>>2]=a[S>>1]}if((t[p>>2]&64512|0)==55296){if((t[m>>2]|0)>>>0>=(t[_>>2]|0)>>>0){F=10;break}S=t[m>>2]|0;if(t[15644]|0){t[g>>2]=S;f=t[g>>2]|0;t[g>>2]=f+1;t[E>>2]=u[f>>0];t[E>>2]=t[E>>2]<<8;t[E>>2]=t[E>>2]|(u[t[g>>2]>>0]|0);t[m>>2]=(t[m>>2]|0)+2}else{t[m>>2]=S+2;t[E>>2]=a[S>>1]}if((t[E>>2]&64512|0)!=56320){F=16;break}t[p>>2]=t[p>>2]&1023;t[p>>2]=t[p>>2]<<10;t[p>>2]=t[p>>2]|t[E>>2]&1023;t[p>>2]=(t[p>>2]|0)+65536}if((t[l>>2]|0)>>>0>=(t[v>>2]|0)>>>0){F=29;break}S=t[p>>2]|0;do if((t[p>>2]|0)>>>0>=128){f=t[p>>2]|0;if(S>>>0<2048){r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=f>>>6&31|192;t[y>>2]=0;break}r=t[p>>2]|0;if(f>>>0<65536){f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=r>>>12&15|224;t[y>>2]=6;break}else{f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=r>>>18&7|240;t[y>>2]=12;break}}else{r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=S;t[y>>2]=-6}while(0);while(1){if((t[y>>2]|0)<0)break;if((t[l>>2]|0)>>>0>=(t[v>>2]|0)>>>0)break;S=((t[p>>2]|0)>>>(t[y>>2]|0)&63|128)&255;r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=S;t[y>>2]=(t[y>>2]|0)-6}t[d>>2]=t[m>>2]}if((F|0)==10){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[d>>2]|0)-(t[k>>2]|0);t[c>>2]=-2;O=t[c>>2]|0;s=o;return O|0}else if((F|0)==16){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[d>>2]|0)-(t[k>>2]|0);t[c>>2]=-2;O=t[c>>2]|0;s=o;return O|0}else if((F|0)==29){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[d>>2]|0)-(t[k>>2]|0);t[c>>2]=t[t[b>>2]>>2];O=t[c>>2]|0;s=o;return O|0}return 0}function ep(e,i,r,o){e=e|0;i=i|0;r=r|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;c=s;s=s+64|0;l=c+56|0;b=c+52|0;k=c+48|0;h=c+44|0;w=c+40|0;d=c+36|0;v=c+32|0;m=c+28|0;_=c+24|0;p=c+20|0;E=c+16|0;S=c+12|0;g=c+8|0;y=c+4|0;F=c;O=c+62|0;A=c+60|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=o;t[d>>2]=t[b>>2];t[v>>2]=t[h>>2];t[m>>2]=t[h>>2];t[_>>2]=t[d>>2];if((t[b>>2]|0)==0|(t[k>>2]|0)==0|(t[w>>2]|0)==0){t[l>>2]=-1;M=t[l>>2]|0;s=c;return M|0}if(!(t[h>>2]|0)){t[t[k>>2]>>2]=0;t[t[w>>2]>>2]=0;t[l>>2]=0;M=t[l>>2]|0;s=c;return M|0}t[E>>2]=(t[h>>2]|0)+(t[t[w>>2]>>2]|0);t[p>>2]=(t[d>>2]|0)+(((t[t[k>>2]>>2]|0)/2|0)<<1);e:while(1){if((t[h>>2]|0)>>>0>=(t[E>>2]|0)>>>0){R=34;break}b=t[h>>2]|0;t[h>>2]=b+1;t[g>>2]=u[b>>0];b=t[g>>2]|0;do if((t[g>>2]|0)>>>0<128){t[S>>2]=b;t[y>>2]=0}else{if(b>>>0<192){R=10;break e}o=t[g>>2]|0;if((t[g>>2]|0)>>>0<224){t[S>>2]=o&31;t[y>>2]=1;break}r=t[g>>2]|0;if(o>>>0<240){t[S>>2]=r&15;t[y>>2]=2;break}if(r>>>0>=248){R=17;break e}t[S>>2]=t[g>>2]&7;t[y>>2]=3}while(0);if(((t[E>>2]|0)-(t[h>>2]|0)|0)<(t[y>>2]|0)){R=34;break}while(1){if(!(t[y>>2]|0))break;if((t[h>>2]|0)>>>0>=(t[E>>2]|0)>>>0)break;b=t[h>>2]|0;t[h>>2]=b+1;r=u[b>>0]|0;t[g>>2]=r;if((r&192|0)!=128)break;t[S>>2]=t[S>>2]<<6;t[S>>2]=t[S>>2]|t[g>>2]&63;t[y>>2]=(t[y>>2]|0)+-1}do if((t[S>>2]|0)>>>0<65536){if((t[d>>2]|0)>>>0>=(t[p>>2]|0)>>>0){R=34;break e}if(t[15644]|0){t[F>>2]=t[d>>2];n[t[F>>2]>>0]=(t[S>>2]|0)>>>8;n[(t[F>>2]|0)+1>>0]=t[S>>2];t[d>>2]=(t[d>>2]|0)+2;break}else{r=t[S>>2]&65535;b=t[d>>2]|0;t[d>>2]=b+2;f[b>>1]=r;break}}else{if((t[S>>2]|0)>>>0>=1114112){R=34;break e}if(((t[d>>2]|0)+2|0)>>>0>=(t[p>>2]|0)>>>0){R=34;break e}t[S>>2]=(t[S>>2]|0)-65536;r=(55296|(t[S>>2]|0)>>>10)&65535;if(t[15644]|0){f[O>>1]=r;t[F>>2]=t[d>>2];n[t[F>>2]>>0]=(a[O>>1]|0)>>8;n[(t[F>>2]|0)+1>>0]=f[O>>1];t[d>>2]=(t[d>>2]|0)+2;f[A>>1]=56320|t[S>>2]&1023;t[F>>2]=t[d>>2];n[t[F>>2]>>0]=(a[A>>1]|0)>>8;n[(t[F>>2]|0)+1>>0]=f[A>>1];t[d>>2]=(t[d>>2]|0)+2;break}else{b=t[d>>2]|0;t[d>>2]=b+2;f[b>>1]=r;r=(56320|t[S>>2]&1023)&65535;b=t[d>>2]|0;t[d>>2]=b+2;f[b>>1]=r;break}}while(0);t[v>>2]=t[h>>2]}if((R|0)==10){t[t[k>>2]>>2]=((t[d>>2]|0)-(t[_>>2]|0)|0)/2|0;t[t[w>>2]>>2]=(t[v>>2]|0)-(t[m>>2]|0);t[l>>2]=-2;M=t[l>>2]|0;s=c;return M|0}else if((R|0)==17){t[t[k>>2]>>2]=((t[d>>2]|0)-(t[_>>2]|0)|0)/2|0;t[t[w>>2]>>2]=(t[v>>2]|0)-(t[m>>2]|0);t[l>>2]=-2;M=t[l>>2]|0;s=c;return M|0}else if((R|0)==34){t[t[k>>2]>>2]=(((t[d>>2]|0)-(t[_>>2]|0)|0)/2|0)<<1;t[t[w>>2]>>2]=(t[v>>2]|0)-(t[m>>2]|0);t[l>>2]=t[t[k>>2]>>2];M=t[l>>2]|0;s=c;return M|0}return 0}function ip(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u+16|0;o=u+12|0;c=u+8|0;l=u+4|0;b=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;if(t[l>>2]|0){t[a>>2]=Q_(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;k=t[a>>2]|0;s=u;return k|0}if((t[t[c>>2]>>2]|0)>=2){n[t[o>>2]>>0]=-1;n[(t[o>>2]|0)+1>>0]=-2;t[t[c>>2]>>2]=2;t[t[b>>2]>>2]=0;t[a>>2]=2;k=t[a>>2]|0;s=u;return k|0}else{t[t[c>>2]>>2]=0;t[t[b>>2]>>2]=0;t[a>>2]=0;k=t[a>>2]|0;s=u;return k|0}return 0}function rp(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+48|0;o=a+40|0;c=a+36|0;l=a+32|0;b=a+28|0;k=a+24|0;h=a+20|0;w=a+16|0;d=a+12|0;v=a+8|0;m=a+4|0;_=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=t[c>>2];t[w>>2]=t[b>>2];t[d>>2]=t[b>>2];t[v>>2]=(t[c>>2]|0)+(t[t[l>>2]>>2]|0);t[m>>2]=(t[b>>2]|0)+(t[t[k>>2]>>2]|0);while(1){if((t[b>>2]|0)>>>0>=(t[m>>2]|0)>>>0){p=8;break}if(((t[c>>2]|0)-(t[h>>2]|0)+5|0)>=(t[t[l>>2]>>2]|0)){p=8;break}f=t[b>>2]|0;t[b>>2]=f+1;t[_>>2]=u[f>>0];if((t[c>>2]|0)>>>0>=(t[v>>2]|0)>>>0){p=8;break}if((t[_>>2]|0)>>>0>=128){p=7;break}f=t[_>>2]&255;r=t[c>>2]|0;t[c>>2]=r+1;n[r>>0]=f;t[d>>2]=t[b>>2]}if((p|0)==7){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[h>>2]|0);t[t[k>>2]>>2]=(t[d>>2]|0)-(t[w>>2]|0);t[o>>2]=-1;E=t[o>>2]|0;s=a;return E|0}else if((p|0)==8){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[h>>2]|0);t[t[k>>2]>>2]=(t[d>>2]|0)-(t[w>>2]|0);t[o>>2]=t[t[l>>2]>>2];E=t[o>>2]|0;s=a;return E|0}return 0}function np(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;a=s;s=s+64|0;o=a+48|0;c=a+44|0;l=a+40|0;b=a+36|0;k=a+32|0;h=a+28|0;w=a+24|0;d=a+20|0;v=a+16|0;m=a+12|0;_=a+8|0;p=a+4|0;E=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=t[b>>2];t[d>>2]=t[c>>2];t[v>>2]=t[b>>2];if((t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[k>>2]|0)==0){t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}if(!(t[b>>2]|0)){t[t[l>>2]>>2]=0;t[t[k>>2]>>2]=0;t[o>>2]=0;S=t[o>>2]|0;s=a;return S|0}t[m>>2]=(t[b>>2]|0)+(t[t[k>>2]>>2]|0);t[w>>2]=(t[c>>2]|0)+(t[t[l>>2]>>2]|0);e:while(1){if((t[b>>2]|0)>>>0>=(t[m>>2]|0)>>>0){g=27;break}f=t[b>>2]|0;t[b>>2]=f+1;t[p>>2]=u[f>>0];f=t[p>>2]|0;do if((t[p>>2]|0)>>>0<128){t[_>>2]=f;t[E>>2]=0}else{if(f>>>0<192){g=10;break e}r=t[p>>2]|0;if((t[p>>2]|0)>>>0<224){t[_>>2]=r&31;t[E>>2]=1;break}i=t[p>>2]|0;if(r>>>0<240){t[_>>2]=i&15;t[E>>2]=2;break}if(i>>>0>=248){g=17;break e}t[_>>2]=t[p>>2]&7;t[E>>2]=3}while(0);if(((t[m>>2]|0)-(t[b>>2]|0)|0)<(t[E>>2]|0)){g=27;break}while(1){if(!(t[E>>2]|0))break;if((t[b>>2]|0)>>>0>=(t[m>>2]|0)>>>0)break;f=t[b>>2]|0;t[b>>2]=f+1;i=u[f>>0]|0;t[p>>2]=i;if((i&192|0)!=128)break;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|t[p>>2]&63;t[E>>2]=(t[E>>2]|0)+-1}y=t[c>>2]|0;if((t[_>>2]|0)>>>0>=128){g=26;break}if(y>>>0>=(t[w>>2]|0)>>>0){g=27;break}i=t[_>>2]&255;f=t[c>>2]|0;t[c>>2]=f+1;n[f>>0]=i;t[h>>2]=t[b>>2]}if((g|0)==10){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==17){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==26){t[t[l>>2]>>2]=y-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=-2;S=t[o>>2]|0;s=a;return S|0}else if((g|0)==27){t[t[l>>2]>>2]=(t[c>>2]|0)-(t[d>>2]|0);t[t[k>>2]>>2]=(t[h>>2]|0)-(t[v>>2]|0);t[o>>2]=t[t[l>>2]>>2];S=t[o>>2]|0;s=a;return S|0}return 0}function fp(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;u=s;s=s+48|0;a=u+40|0;o=u+36|0;c=u+32|0;l=u+28|0;b=u+24|0;k=u+20|0;h=u+16|0;w=u+12|0;d=u+8|0;v=u+4|0;m=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[d>>2]=t[b>>2];t[v>>2]=t[c>>2];if((t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[k>>2]|0)==0|(t[b>>2]|0)==0){if(t[l>>2]|0)t[t[l>>2]>>2]=0;t[a>>2]=-1;_=t[a>>2]|0;s=u;return _|0}t[h>>2]=t[t[k>>2]>>2];t[w>>2]=t[t[l>>2]>>2];t[m>>2]=Hq(t[o>>2]|0,d,h,v,w)|0;v=t[k>>2]|0;t[v>>2]=(t[v>>2]|0)-(t[h>>2]|0);v=t[l>>2]|0;t[v>>2]=(t[v>>2]|0)-(t[w>>2]|0);if(!((t[h>>2]|0)!=0|(t[m>>2]|0)==-1)){t[a>>2]=0;_=t[a>>2]|0;s=u;return _|0}if((t[(ii()|0)>>2]|0)==84){t[a>>2]=-2;_=t[a>>2]|0;s=u;return _|0}if((t[(ii()|0)>>2]|0)==7){t[a>>2]=-1;_=t[a>>2]|0;s=u;return _|0}else{t[a>>2]=-3;_=t[a>>2]|0;s=u;return _|0}return 0}function tp(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;n=s;s=s+32|0;f=n+16|0;u=n;t[n+20>>2]=e;t[f>>2]=i;if(!(t[33980]|0))t[33980]=t[v>>2];t[u>>2]=r;Te(t[33980]|0,t[f>>2]|0,u|0)|0;s=n;return}function up(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){t[33976]=35;s=i;return}else{t[33976]=t[t[r>>2]>>2];s=i;return}}function ap(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i;n=i+8|0;t[n>>2]=e;if(!(t[n>>2]|0)){s=i;return}e=t[33976]|0;f=t[33980]|0;u=t[n>>2]|0;if(t[(t[n>>2]|0)+4>>2]|0){a=t[(t[n>>2]|0)+28>>2]|0;t[r>>2]=t[u+4>>2];t[r+4>>2]=a;yAi[e&511](f,63216,r);s=i;return}else{t[r>>2]=t[u+28>>2];yAi[e&511](f,63224,r);s=i;return}}function op(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;_p(t[r>>2]|0,t[33976]|0,t[33980]|0);s=i;return}function cp(e,i,r,n,f,u,o,c,l,b,k,h,w,d,v,m,_){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;o=o|0;c=c|0;l=l|0;b=b|0;k=k|0;h=h|0;w=w|0;d=d|0;v=v|0;m=m|0;_=_|0;var p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0;p=s;s=s+144|0;E=p;S=p+132|0;g=p+128|0;y=p+124|0;F=p+120|0;O=p+116|0;A=p+112|0;M=p+108|0;R=p+104|0;N=p+100|0;T=p+96|0;L=p+92|0;D=p+88|0;C=p+84|0;P=p+80|0;B=p+76|0;I=p+72|0;H=p+68|0;x=p+64|0;U=p+60|0;z=p+56|0;j=p+52|0;V=p+48|0;q=p+44|0;Y=p+40|0;G=p+36|0;W=p+32|0;K=p+16|0;X=p+12|0;Z=p+8|0;J=p+4|0;t[S>>2]=e;t[g>>2]=i;t[y>>2]=r;t[F>>2]=n;t[O>>2]=f;t[A>>2]=u;t[M>>2]=o;t[R>>2]=c;t[N>>2]=l;t[T>>2]=b;t[L>>2]=k;t[D>>2]=h;t[C>>2]=w;t[P>>2]=d;t[B>>2]=v;t[I>>2]=m;t[H>>2]=0;t[x>>2]=t[O>>2];t[U>>2]=0;t[z>>2]=0;t[j>>2]=136208;t[V>>2]=0;if(!(t[M>>2]|0)){s=p;return}if((t[33956]|0)==0&(t[R>>2]|0)==1){s=p;return}if(((((t[A>>2]|0)==1|(t[A>>2]|0)==5|(t[A>>2]|0)==4|(t[A>>2]|0)==3|(t[A>>2]|0)==8|(t[A>>2]|0)==23?(t[H>>2]=t[F>>2],(t[S>>2]|0)==0&(t[H>>2]|0)!=0):0)?(t[t[H>>2]>>2]|0)!=0:0)?(t[(t[t[H>>2]>>2]|0)+108>>2]|0)==-554844497:0)?(t[(t[t[H>>2]>>2]|0)+124>>2]|0)!=0:0){t[S>>2]=t[(t[t[H>>2]>>2]|0)+124>>2];t[y>>2]=t[(t[H>>2]|0)+4>>2]}if((t[S>>2]|0)==0?(t[S>>2]=t[33978],(t[S>>2]|0)!=0):0)t[y>>2]=t[33982];e:do if(t[I>>2]|0){t[Y>>2]=-1;t[U>>2]=gAi[t[135744>>2]&511](150)|0;if(t[U>>2]|0){t[q>>2]=150;while(1){if((t[q>>2]|0)>=64e3)break e;t[K>>2]=_;t[G>>2]=yY(t[U>>2]|0,t[q>>2]|0,t[I>>2]|0,K)|0;if((t[G>>2]|0)>-1?(t[G>>2]|0)<(t[q>>2]|0):0){if((t[Y>>2]|0)==(t[G>>2]|0))break e;t[Y>>2]=t[G>>2]}if((t[G>>2]|0)>-1)t[q>>2]=(t[q>>2]|0)+((t[G>>2]|0)+1);else t[q>>2]=(t[q>>2]|0)+100;O=MAi[t[135760>>2]&511](t[U>>2]|0,t[q>>2]|0)|0;t[W>>2]=O;if(!O)break e;t[U>>2]=t[W>>2]}}}else t[U>>2]=Yl(63248)|0;while(0);if(!(t[H>>2]|0)){if((t[x>>2]|0)!=0&(t[N>>2]|0)==0){if((t[(t[x>>2]|0)+32>>2]|0)!=0?(t[(t[(t[x>>2]|0)+32>>2]|0)+72>>2]|0)!=0:0)t[V>>2]=t[x>>2];t[X>>2]=0;while(1){if(!((t[X>>2]|0)<10&(t[x>>2]|0)!=0))break;if((t[(t[x>>2]|0)+4>>2]|0)==1)break;t[x>>2]=t[(t[x>>2]|0)+20>>2];t[X>>2]=(t[X>>2]|0)+1}if(((t[V>>2]|0)==0&(t[x>>2]|0)!=0?(t[(t[x>>2]|0)+32>>2]|0)!=0:0)?(t[(t[(t[x>>2]|0)+32>>2]|0)+72>>2]|0)!=0:0)t[V>>2]=t[x>>2];if((t[x>>2]|0)!=0?(t[(t[x>>2]|0)+4>>2]|0)==1:0)t[T>>2]=a[(t[x>>2]|0)+56>>1];if((t[T>>2]|0)==0|(t[T>>2]|0)==65535)t[T>>2]=Qy(t[x>>2]|0)|0}}else{if(!(t[N>>2]|0)){t[z>>2]=t[(t[H>>2]|0)+36>>2];if(((t[z>>2]|0)!=0?(t[(t[z>>2]|0)+4>>2]|0)==0:0)?(t[(t[H>>2]|0)+40>>2]|0)>1:0)t[z>>2]=t[(t[(t[H>>2]|0)+48>>2]|0)+((t[(t[H>>2]|0)+40>>2]|0)-2<<2)>>2];if(t[z>>2]|0){t[N>>2]=t[(t[z>>2]|0)+4>>2];t[T>>2]=t[(t[z>>2]|0)+28>>2];t[B>>2]=t[(t[z>>2]|0)+32>>2]}}t[j>>2]=(t[H>>2]|0)+384}lp(t[j>>2]|0);t[t[j>>2]>>2]=t[A>>2];t[(t[j>>2]|0)+4>>2]=t[M>>2];t[(t[j>>2]|0)+8>>2]=t[U>>2];t[(t[j>>2]|0)+12>>2]=t[R>>2];if(!(t[N>>2]|0)){if(t[V>>2]|0){t[Z>>2]=t[V>>2];t[J>>2]=0;e:while(1){if(!(t[Z>>2]|0))break;while(1){Q=t[Z>>2]|0;if(!(t[(t[Z>>2]|0)+28>>2]|0)){$=58;break}t[Z>>2]=t[Q+28>>2];if((t[(t[Z>>2]|0)+4>>2]|0)!=19)break;M=(t[J>>2]|0)+-1|0;t[J>>2]=M;if(!((M|0)>=0&(t[Z>>2]|0)!=0))break e}if(($|0)==58){$=0;t[Z>>2]=t[Q+20>>2];continue}if((t[(t[Z>>2]|0)+4>>2]|0)!=20)continue;t[J>>2]=(t[J>>2]|0)+1}do if(t[Z>>2]|0){J=t[Z>>2]|0;if((t[(t[Z>>2]|0)+4>>2]|0)==19){t[J+4>>2]=1;Q=cF(t[Z>>2]|0,63280)|0;t[(t[j>>2]|0)+16>>2]=Q;t[(t[Z>>2]|0)+4>>2]=19;break}else{Q=cF(J,63280)|0;t[(t[j>>2]|0)+16>>2]=Q;break}}else{Q=Yl(t[(t[(t[V>>2]|0)+32>>2]|0)+72>>2]|0)|0;t[(t[j>>2]|0)+16>>2]=Q}while(0);if(((t[x>>2]|0)!=0?(t[(t[j>>2]|0)+16>>2]|0)==0:0)?(t[(t[x>>2]|0)+32>>2]|0)!=0:0){V=Yl(t[(t[(t[x>>2]|0)+32>>2]|0)+72>>2]|0)|0;t[(t[j>>2]|0)+16>>2]=V}}}else{V=Yl(t[N>>2]|0)|0;t[(t[j>>2]|0)+16>>2]=V}t[(t[j>>2]|0)+20>>2]=t[T>>2];if(t[L>>2]|0){T=Yl(t[L>>2]|0)|0;t[(t[j>>2]|0)+24>>2]=T}if(t[D>>2]|0){T=Yl(t[D>>2]|0)|0;t[(t[j>>2]|0)+28>>2]=T}if(t[C>>2]|0){T=Yl(t[C>>2]|0)|0;t[(t[j>>2]|0)+32>>2]=T}t[(t[j>>2]|0)+36>>2]=t[P>>2];t[(t[j>>2]|0)+40>>2]=t[B>>2];t[(t[j>>2]|0)+48>>2]=t[x>>2];t[(t[j>>2]|0)+44>>2]=t[F>>2];if((t[j>>2]|0)!=136208)sp(t[j>>2]|0,136208)|0;if(t[S>>2]|0){EAi[t[S>>2]&511](t[y>>2]|0,t[j>>2]|0);s=p;return}if((t[H>>2]|0)!=0&(t[g>>2]|0)==0&(t[33978]|0)==0?(t[t[H>>2]>>2]|0)!=0:0){S=t[t[H>>2]>>2]|0;if((t[R>>2]|0)==1)t[g>>2]=t[S+84>>2];else t[g>>2]=t[S+88>>2];t[y>>2]=t[(t[H>>2]|0)+4>>2]}else $=87;do if(($|0)==87?(t[g>>2]|0)==0:0){t[g>>2]=t[33976];if(t[H>>2]|0){t[y>>2]=t[H>>2];break}else{t[y>>2]=t[33980];break}}while(0);if(!(t[g>>2]|0)){s=p;return}if((t[g>>2]|0)==57|(t[g>>2]|0)==56|(t[g>>2]|0)==224|(t[g>>2]|0)==225){pp(t[j>>2]|0,t[H>>2]|0,t[U>>2]|0,0,0);s=p;return}if((t[g>>2]|0)==203|(t[g>>2]|0)==35){pp(t[j>>2]|0,t[H>>2]|0,t[U>>2]|0,t[g>>2]|0,t[y>>2]|0);s=p;return}else{H=t[g>>2]|0;g=t[y>>2]|0;t[E>>2]=t[U>>2];yAi[H&511](g,63288,E);s=p;return}}function lp(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+4>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+32>>2]|0);e=(t[r>>2]|0)+0|0;n=e+52|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(n|0));t[(t[r>>2]|0)+4>>2]=0;s=i;return}function sp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}t[a>>2]=Yl(t[(t[f>>2]|0)+8>>2]|0)|0;t[o>>2]=Yl(t[(t[f>>2]|0)+16>>2]|0)|0;t[c>>2]=Yl(t[(t[f>>2]|0)+24>>2]|0)|0;t[l>>2]=Yl(t[(t[f>>2]|0)+28>>2]|0)|0;t[b>>2]=Yl(t[(t[f>>2]|0)+32>>2]|0)|0;if(t[(t[u>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+8>>2]|0);if(t[(t[u>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+16>>2]|0);if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);if(t[(t[u>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+28>>2]|0);if(t[(t[u>>2]|0)+32>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+32>>2]|0);t[t[u>>2]>>2]=t[t[f>>2]>>2];t[(t[u>>2]|0)+4>>2]=t[(t[f>>2]|0)+4>>2];t[(t[u>>2]|0)+12>>2]=t[(t[f>>2]|0)+12>>2];t[(t[u>>2]|0)+20>>2]=t[(t[f>>2]|0)+20>>2];t[(t[u>>2]|0)+48>>2]=t[(t[f>>2]|0)+48>>2];t[(t[u>>2]|0)+36>>2]=t[(t[f>>2]|0)+36>>2];t[(t[u>>2]|0)+40>>2]=t[(t[f>>2]|0)+40>>2];t[(t[u>>2]|0)+48>>2]=t[(t[f>>2]|0)+48>>2];t[(t[u>>2]|0)+44>>2]=t[(t[f>>2]|0)+44>>2];t[(t[u>>2]|0)+8>>2]=t[a>>2];t[(t[u>>2]|0)+16>>2]=t[o>>2];t[(t[u>>2]|0)+24>>2]=t[c>>2];t[(t[u>>2]|0)+28>>2]=t[l>>2];t[(t[u>>2]|0)+32>>2]=t[b>>2];t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}function bp(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+64|0;f=n;u=n+60|0;a=n+56|0;o=n+52|0;c=n+48|0;l=n+44|0;b=n+40|0;k=n+36|0;h=n+32|0;w=n+28|0;d=n+24|0;v=n+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[u>>2];t[c>>2]=0;t[l>>2]=0;if(t[o>>2]|0){t[c>>2]=t[(t[o>>2]|0)+36>>2];if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==0:0)?(t[(t[o>>2]|0)+40>>2]|0)>1:0){t[l>>2]=t[c>>2];t[c>>2]=t[(t[(t[o>>2]|0)+48>>2]|0)+((t[(t[o>>2]|0)+40>>2]|0)-2<<2)>>2]}ap(t[c>>2]|0)}yAi[t[135904>>2]&511](t[33980]|0,63360,f);t[h>>2]=-1;t[b>>2]=gAi[t[135744>>2]&511](150)|0;e:do if(t[b>>2]|0){t[k>>2]=150;while(1){if((t[k>>2]|0)>=64e3)break e;t[v>>2]=r;t[w>>2]=yY(t[b>>2]|0,t[k>>2]|0,t[a>>2]|0,v)|0;if((t[w>>2]|0)>-1?(t[w>>2]|0)<(t[k>>2]|0):0){if((t[h>>2]|0)==(t[w>>2]|0))break e;t[h>>2]=t[w>>2]}if((t[w>>2]|0)>-1)t[k>>2]=(t[k>>2]|0)+((t[w>>2]|0)+1);else t[k>>2]=(t[k>>2]|0)+100;u=MAi[t[135760>>2]&511](t[b>>2]|0,t[k>>2]|0)|0;t[d>>2]=u;if(!u)break e;t[b>>2]=t[d>>2]}}while(0);d=t[33976]|0;k=t[33980]|0;t[f>>2]=t[b>>2];yAi[d&511](k,63288,f);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);if(!(t[o>>2]|0)){s=n;return}op(t[c>>2]|0);if(!(t[l>>2]|0)){s=n;return}ap(t[l>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,63368,f);op(t[l>>2]|0);s=n;return}function kp(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+64|0;f=n;u=n+60|0;a=n+56|0;o=n+52|0;c=n+48|0;l=n+44|0;b=n+40|0;k=n+36|0;h=n+32|0;w=n+28|0;d=n+24|0;v=n+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[u>>2];t[c>>2]=0;t[l>>2]=0;if(t[o>>2]|0){t[c>>2]=t[(t[o>>2]|0)+36>>2];if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==0:0)?(t[(t[o>>2]|0)+40>>2]|0)>1:0){t[l>>2]=t[c>>2];t[c>>2]=t[(t[(t[o>>2]|0)+48>>2]|0)+((t[(t[o>>2]|0)+40>>2]|0)-2<<2)>>2]}ap(t[c>>2]|0)}yAi[t[135904>>2]&511](t[33980]|0,63376,f);t[h>>2]=-1;t[b>>2]=gAi[t[135744>>2]&511](150)|0;e:do if(t[b>>2]|0){t[k>>2]=150;while(1){if((t[k>>2]|0)>=64e3)break e;t[v>>2]=r;t[w>>2]=yY(t[b>>2]|0,t[k>>2]|0,t[a>>2]|0,v)|0;if((t[w>>2]|0)>-1?(t[w>>2]|0)<(t[k>>2]|0):0){if((t[h>>2]|0)==(t[w>>2]|0))break e;t[h>>2]=t[w>>2]}if((t[w>>2]|0)>-1)t[k>>2]=(t[k>>2]|0)+((t[w>>2]|0)+1);else t[k>>2]=(t[k>>2]|0)+100;u=MAi[t[135760>>2]&511](t[b>>2]|0,t[k>>2]|0)|0;t[d>>2]=u;if(!u)break e;t[b>>2]=t[d>>2]}}while(0);d=t[33976]|0;k=t[33980]|0;t[f>>2]=t[b>>2];yAi[d&511](k,63288,f);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);if(!(t[o>>2]|0)){s=n;return}op(t[c>>2]|0);if(!(t[l>>2]|0)){s=n;return}ap(t[l>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,63368,f);op(t[l>>2]|0);s=n;return}function hp(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;f=s;s=s+64|0;u=f;a=f+60|0;o=f+56|0;c=f+52|0;l=f+48|0;b=f+44|0;k=f+40|0;h=f+36|0;w=f+32|0;d=f+28|0;v=f+24|0;m=f+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];t[l>>2]=0;t[k>>2]=rs(t[o>>2]|0)|0;if((t[k>>2]|0)>1?(n[(t[o>>2]|0)+((t[k>>2]|0)-2)>>0]|0)!=58:0){if(t[c>>2]|0){t[l>>2]=t[(t[c>>2]|0)+36>>2];if((t[(t[l>>2]|0)+4>>2]|0)==0?(t[(t[c>>2]|0)+40>>2]|0)>1:0)t[l>>2]=t[(t[(t[c>>2]|0)+48>>2]|0)+((t[(t[c>>2]|0)+40>>2]|0)-2<<2)>>2];if(!(t[15848]|0))ap(t[l>>2]|0)}yAi[t[135904>>2]&511](t[33980]|0,63400,u);t[15848]=0}else t[15848]=1;t[w>>2]=-1;t[b>>2]=gAi[t[135744>>2]&511](150)|0;e:do if(t[b>>2]|0){t[h>>2]=150;while(1){if((t[h>>2]|0)>=64e3)break e;t[m>>2]=r;t[d>>2]=yY(t[b>>2]|0,t[h>>2]|0,t[o>>2]|0,m)|0;if((t[d>>2]|0)>-1?(t[d>>2]|0)<(t[h>>2]|0):0){if((t[w>>2]|0)==(t[d>>2]|0))break e;t[w>>2]=t[d>>2]}if((t[d>>2]|0)>-1)t[h>>2]=(t[h>>2]|0)+((t[d>>2]|0)+1);else t[h>>2]=(t[h>>2]|0)+100;k=MAi[t[135760>>2]&511](t[b>>2]|0,t[h>>2]|0)|0;t[v>>2]=k;if(!k)break e;t[b>>2]=t[v>>2]}}while(0);v=t[33976]|0;h=t[33980]|0;
	t[u>>2]=t[b>>2];yAi[v&511](h,63288,u);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);if(!((t[c>>2]|0)!=0&(t[l>>2]|0)!=0)){s=f;return}op(t[l>>2]|0);s=f;return}function wp(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;f=s;s=s+64|0;u=f;a=f+60|0;o=f+56|0;c=f+52|0;l=f+48|0;b=f+44|0;k=f+40|0;h=f+36|0;w=f+32|0;d=f+28|0;v=f+24|0;m=f+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[a>>2];t[l>>2]=0;t[k>>2]=rs(t[o>>2]|0)|0;if((t[c>>2]|0)!=0&(t[k>>2]|0)!=0?(n[(t[o>>2]|0)+((t[k>>2]|0)-1)>>0]|0)!=58:0){t[l>>2]=t[(t[c>>2]|0)+36>>2];if((t[(t[l>>2]|0)+4>>2]|0)==0?(t[(t[c>>2]|0)+40>>2]|0)>1:0)t[l>>2]=t[(t[(t[c>>2]|0)+48>>2]|0)+((t[(t[c>>2]|0)+40>>2]|0)-2<<2)>>2];ap(t[l>>2]|0)}yAi[t[135904>>2]&511](t[33980]|0,63424,u);t[w>>2]=-1;t[b>>2]=gAi[t[135744>>2]&511](150)|0;e:do if(t[b>>2]|0){t[h>>2]=150;while(1){if((t[h>>2]|0)>=64e3)break e;t[m>>2]=r;t[d>>2]=yY(t[b>>2]|0,t[h>>2]|0,t[o>>2]|0,m)|0;if((t[d>>2]|0)>-1?(t[d>>2]|0)<(t[h>>2]|0):0){if((t[w>>2]|0)==(t[d>>2]|0))break e;t[w>>2]=t[d>>2]}if((t[d>>2]|0)>-1)t[h>>2]=(t[h>>2]|0)+((t[d>>2]|0)+1);else t[h>>2]=(t[h>>2]|0)+100;k=MAi[t[135760>>2]&511](t[b>>2]|0,t[h>>2]|0)|0;t[v>>2]=k;if(!k)break e;t[b>>2]=t[v>>2]}}while(0);v=t[33976]|0;h=t[33980]|0;t[u>>2]=t[b>>2];yAi[v&511](h,63288,u);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);if(!(t[c>>2]|0)){s=f;return}op(t[l>>2]|0);s=f;return}function dp(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if((t[c>>2]|0)!=2){f=t[l>>2]|0;n=t[o>>2]|0;r=t[c>>2]|0;c=t[k>>2]|0;i=t[b>>2]|0;t[a>>2]=t[k>>2];cp(0,0,0,0,f,n,r,2,0,0,c,0,0,0,0,i,a);s=u;return}i=t[l>>2]|0;l=t[o>>2]|0;if(t[k>>2]|0){o=t[k>>2]|0;t[a>>2]=t[k>>2];cp(0,0,0,0,i,l,2,3,0,0,o,0,0,0,0,63296,a);s=u;return}else{cp(0,0,0,0,i,l,2,3,0,0,0,0,0,0,0,63328,a);s=u;return}}function vp(){var e=0,i=0;e=s;s=s+16|0;i=e;if(!(t[34053]|0))t[i>>2]=0;else t[i>>2]=136208;s=e;return t[i>>2]|0}function mp(){var e=0;e=s;if(t[34053]|0)lp(136208);s=e;return}function _p(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;f=s;s=s+128|0;a=f;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;d=f+36|0;v=f+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;if(!(t[o>>2]|0)){s=f;return}t[b>>2]=t[(t[o>>2]|0)+16>>2];t[k>>2]=t[(t[o>>2]|0)+12>>2];while(1){if((t[b>>2]|0)>>>0<=(t[k>>2]|0)>>>0)break;if((u[t[b>>2]>>0]|0|0)!=10?(u[t[b>>2]>>0]|0|0)!=13:0)break;t[b>>2]=(t[b>>2]|0)+-1}t[h>>2]=0;while(1){r=t[h>>2]|0;t[h>>2]=r+1;if((r>>>0<80?(t[b>>2]|0)>>>0>(t[k>>2]|0)>>>0:0)?(u[t[b>>2]>>0]|0|0)!=10:0)m=(u[t[b>>2]>>0]|0|0)!=13;else m=0;_=t[b>>2]|0;if(!m)break;t[b>>2]=_+-1}if(!((u[_>>0]|0|0)!=10?(u[t[b>>2]>>0]|0|0)!=13:0))t[b>>2]=(t[b>>2]|0)+1;t[w>>2]=(t[(t[o>>2]|0)+16>>2]|0)-(t[b>>2]|0);t[h>>2]=0;t[v>>2]=d;while(1){if(!(u[t[b>>2]>>0]|0))break;if((u[t[b>>2]>>0]|0|0)==10)break;if(!((t[h>>2]|0)>>>0<80?(u[t[b>>2]>>0]|0|0)!=13:0))break;o=t[b>>2]|0;t[b>>2]=o+1;_=n[o>>0]|0;o=t[v>>2]|0;t[v>>2]=o+1;n[o>>0]=_;t[h>>2]=(t[h>>2]|0)+1}n[t[v>>2]>>0]=0;b=t[c>>2]|0;_=t[l>>2]|0;t[a>>2]=d;yAi[b&511](_,63808,a);t[h>>2]=0;t[v>>2]=d;while(1){if((t[h>>2]|0)>>>0<(t[w>>2]|0)>>>0?(_=t[h>>2]|0,t[h>>2]=_+1,_>>>0<79):0)p=(u[t[v>>2]>>0]|0|0)!=0;else p=0;E=t[v>>2]|0;if(!p)break;if((u[E>>0]|0|0)!=9)n[t[v>>2]>>0]=32;t[v>>2]=(t[v>>2]|0)+1}t[v>>2]=E+1;n[E>>0]=94;n[t[v>>2]>>0]=0;v=t[c>>2]|0;c=t[l>>2]|0;t[a>>2]=d;yAi[v&511](c,63808,a);s=f;return}function pp(e,i,r,f,u){e=e|0;i=i|0;r=r|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;a=s;s=s+224|0;o=a;c=a+68|0;l=a+64|0;b=a+60|0;k=a+56|0;h=a+52|0;w=a+48|0;d=a+44|0;v=a+40|0;m=a+36|0;_=a+32|0;p=a+28|0;E=a+24|0;S=a+20|0;g=a+16|0;y=a+12|0;F=a+72|0;O=a+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=u;t[w>>2]=0;t[d>>2]=0;t[v>>2]=-1;t[_>>2]=0;t[S>>2]=0;t[g>>2]=0;if(!(t[c>>2]|0)){s=a;return}if(!(t[k>>2]|0)){t[k>>2]=t[33976];t[h>>2]=t[33980]}t[w>>2]=t[(t[c>>2]|0)+16>>2];t[d>>2]=t[(t[c>>2]|0)+20>>2];t[v>>2]=t[(t[c>>2]|0)+4>>2];t[m>>2]=t[t[c>>2]>>2];t[E>>2]=t[(t[c>>2]|0)+12>>2];t[p>>2]=t[(t[c>>2]|0)+48>>2];if(!(t[v>>2]|0)){s=a;return}if((t[p>>2]|0)!=0?(t[(t[p>>2]|0)+4>>2]|0)==1:0)t[_>>2]=t[(t[p>>2]|0)+8>>2];do if(t[l>>2]|0){t[S>>2]=t[(t[l>>2]|0)+36>>2];if(((t[S>>2]|0)!=0?(t[(t[S>>2]|0)+4>>2]|0)==0:0)?(t[(t[l>>2]|0)+40>>2]|0)>1:0){t[g>>2]=t[S>>2];t[S>>2]=t[(t[(t[l>>2]|0)+48>>2]|0)+((t[(t[l>>2]|0)+40>>2]|0)-2<<2)>>2]}if(t[S>>2]|0){if(t[(t[S>>2]|0)+4>>2]|0){p=t[k>>2]|0;v=t[h>>2]|0;u=t[(t[S>>2]|0)+28>>2]|0;t[o>>2]=t[(t[S>>2]|0)+4>>2];t[o+4>>2]=u;yAi[p&511](v,63216,o);break}if((t[d>>2]|0)!=0&(t[m>>2]|0)==1){v=t[k>>2]|0;p=t[h>>2]|0;t[o>>2]=t[(t[S>>2]|0)+28>>2];yAi[v&511](p,63224,o)}}}else{if(t[w>>2]|0){p=t[k>>2]|0;v=t[h>>2]|0;u=t[d>>2]|0;t[o>>2]=t[w>>2];t[o+4>>2]=u;yAi[p&511](v,63216,o);break}if((t[d>>2]|0)!=0?(t[m>>2]|0)==1|(t[m>>2]|0)==17|(t[m>>2]|0)==16|(t[m>>2]|0)==4|(t[m>>2]|0)==18|(t[m>>2]|0)==19:0){v=t[k>>2]|0;p=t[h>>2]|0;t[o>>2]=t[d>>2];yAi[v&511](p,63224,o)}}while(0);if(t[_>>2]|0){w=t[k>>2]|0;p=t[h>>2]|0;t[o>>2]=t[_>>2];yAi[w&511](p,63448,o)}do switch(t[m>>2]|0){case 29:{yAi[t[k>>2]&511](t[h>>2]|0,63736,o);break}case 30:{yAi[t[k>>2]&511](t[h>>2]|0,63760,o);break}case 20:{yAi[t[k>>2]&511](t[h>>2]|0,63672,o);break}case 5:{yAi[t[k>>2]&511](t[h>>2]|0,63504,o);break}case 1:{yAi[t[k>>2]&511](t[h>>2]|0,63464,o);break}case 13:{yAi[t[k>>2]&511](t[h>>2]|0,63464,o);break}case 18:{yAi[t[k>>2]&511](t[h>>2]|0,63624,o);break}case 19:{yAi[t[k>>2]&511](t[h>>2]|0,63648,o);break}case 14:{yAi[t[k>>2]&511](t[h>>2]|0,63568,o);break}case 26:{yAi[t[k>>2]&511](t[h>>2]|0,63576,o);break}case 23:case 4:{yAi[t[k>>2]&511](t[h>>2]|0,63488,o);break}case 3:{yAi[t[k>>2]&511](t[h>>2]|0,63472,o);break}case 17:{yAi[t[k>>2]&511](t[h>>2]|0,63584,o);break}case 16:{yAi[t[k>>2]&511](t[h>>2]|0,63608,o);break}case 21:{yAi[t[k>>2]&511](t[h>>2]|0,63688,o);break}case 22:{yAi[t[k>>2]&511](t[h>>2]|0,63696,o);break}case 27:{yAi[t[k>>2]&511](t[h>>2]|0,63704,o);break}case 28:{yAi[t[k>>2]&511](t[h>>2]|0,63720,o);break}case 6:{yAi[t[k>>2]&511](t[h>>2]|0,63520,o);break}case 7:{yAi[t[k>>2]&511](t[h>>2]|0,63528,o);break}case 8:{yAi[t[k>>2]&511](t[h>>2]|0,63536,o);break}case 11:{yAi[t[k>>2]&511](t[h>>2]|0,63544,o);break}case 12:{yAi[t[k>>2]&511](t[h>>2]|0,63560,o);break}default:{}}while(0);p=t[E>>2]|0;if((p|0)==1)yAi[t[k>>2]&511](t[h>>2]|0,63776,o);else if((p|0)==2)yAi[t[k>>2]&511](t[h>>2]|0,63792,o);else if((p|0)==3)yAi[t[k>>2]&511](t[h>>2]|0,63792,o);else if(!p)yAi[t[k>>2]&511](t[h>>2]|0,63768,o);do if(t[b>>2]|0){t[y>>2]=rs(t[b>>2]|0)|0;if((t[y>>2]|0)>0?(n[(t[b>>2]|0)+((t[y>>2]|0)-1)>>0]|0)!=10:0){p=t[k>>2]|0;E=t[h>>2]|0;t[o>>2]=t[b>>2];yAi[p&511](E,63808,o);break}E=t[k>>2]|0;p=t[h>>2]|0;t[o>>2]=t[b>>2];yAi[E&511](p,63288,o)}else{p=t[k>>2]|0;E=t[h>>2]|0;t[o>>2]=63816;yAi[p&511](E,63808,o)}while(0);if((t[l>>2]|0)!=0?(_p(t[S>>2]|0,t[k>>2]|0,t[h>>2]|0),(t[g>>2]|0)!=0):0){if(!(t[(t[g>>2]|0)+4>>2]|0)){if((t[d>>2]|0)!=0&(t[m>>2]|0)==1){d=t[k>>2]|0;S=t[h>>2]|0;t[o>>2]=t[(t[g>>2]|0)+28>>2];yAi[d&511](S,63856,o)}}else{S=t[k>>2]|0;d=t[h>>2]|0;l=t[(t[g>>2]|0)+28>>2]|0;t[o>>2]=t[(t[g>>2]|0)+4>>2];t[o+4>>2]=l;yAi[S&511](d,63840,o)}_p(t[g>>2]|0,t[k>>2]|0,t[h>>2]|0)}if((t[m>>2]|0)!=12){s=a;return}if(!(t[(t[c>>2]|0)+24>>2]|0)){s=a;return}if((t[(t[c>>2]|0)+36>>2]|0)>=100){s=a;return}m=t[(t[c>>2]|0)+36>>2]|0;if((m|0)>=(rs(t[(t[c>>2]|0)+24>>2]|0)|0)){s=a;return}m=t[k>>2]|0;g=t[h>>2]|0;t[o>>2]=t[(t[c>>2]|0)+24>>2];yAi[m&511](g,63808,o);t[O>>2]=0;while(1){A=t[O>>2]|0;if((t[O>>2]|0)>=(t[(t[c>>2]|0)+36>>2]|0))break;n[F+A>>0]=32;t[O>>2]=(t[O>>2]|0)+1}t[O>>2]=A+1;n[F+A>>0]=94;n[F+(t[O>>2]|0)>>0]=0;O=t[k>>2]|0;k=t[h>>2]|0;t[o>>2]=F;yAi[O&511](k,63808,o);s=a;return}function Ep(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i;n=i+12|0;f=i+8|0;t[n>>2]=e;t[f>>2]=20902;rS();if(((t[f>>2]|0)/1e4|0|0)!=((t[n>>2]|0)/1e4|0|0)){e=t[33976]|0;u=t[33980]|0;a=(t[f>>2]|0)/1e4|0;t[r>>2]=(t[n>>2]|0)/1e4|0;t[r+4>>2]=a;yAi[e&511](u,63880,r);u=t[v>>2]|0;e=(t[f>>2]|0)/1e4|0;t[r>>2]=(t[n>>2]|0)/1e4|0;t[r+4>>2]=e;xe(u|0,63880,r|0)|0}if(((t[f>>2]|0)/100|0|0)>=((t[n>>2]|0)/100|0|0)){s=i;return}u=t[33976]|0;e=t[33980]|0;a=(t[f>>2]|0)/100|0;t[r>>2]=(t[n>>2]|0)/100|0;t[r+4>>2]=a;yAi[u&511](e,63944,r);s=i;return}function Sp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+212>>2]|0)!=0:0)?(t[(t[f>>2]|0)+172>>2]|0)==-1:0){s=r;return}if(t[f>>2]|0){t[(t[f>>2]|0)+84>>2]=2;t[(t[f>>2]|0)+172>>2]=-1;t[(t[f>>2]|0)+212>>2]=1}i=t[f>>2]|0;if(t[u>>2]|0){f=t[u>>2]|0;t[n>>2]=t[u>>2];cp(0,0,0,i,0,1,2,3,0,0,f,0,0,0,0,64008,n);s=r;return}else{cp(0,0,0,i,0,1,2,3,0,0,0,0,0,0,0,64040,n);s=r;return}}function gp(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(t[o>>2]|0)t[(t[o>>2]|0)+84>>2]=t[c>>2];f=t[o>>2]|0;n=t[c>>2]|0;c=t[b>>2]|0;r=t[k>>2]|0;i=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(0,0,0,f,0,1,n,3,0,0,c,r,0,0,0,i,a);if(!(t[o>>2]|0)){s=u;return}t[(t[o>>2]|0)+12>>2]=0;if(t[(t[o>>2]|0)+288>>2]|0){s=u;return}t[(t[o>>2]|0)+212>>2]=1;s=u;return}function yp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)<0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}if(!(t[t[f>>2]>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}if(!(t[(t[f>>2]|0)+12>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}if(!(t[(t[f>>2]|0)+16>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}if(!(t[(t[t[f>>2]>>2]|0)+16>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=(t[(t[f>>2]|0)+16>>2]|0)-(t[(t[f>>2]|0)+12>>2]|0);i=Ts(t[(t[t[f>>2]>>2]|0)+16>>2]|0)|0;if(i>>>0>((t[o>>2]|0)+250|0)>>>0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if(!(t[(t[t[f>>2]>>2]|0)+4>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=JO(t[t[f>>2]>>2]|0,t[u>>2]|0)|0;t[c>>2]=Os(t[(t[t[f>>2]>>2]|0)+16>>2]|0)|0;if((t[(t[f>>2]|0)+12>>2]|0)!=(t[c>>2]|0)){t[o>>2]=(t[(t[f>>2]|0)+16>>2]|0)-(t[(t[f>>2]|0)+12>>2]|0);t[(t[f>>2]|0)+12>>2]=t[c>>2];t[(t[f>>2]|0)+16>>2]=(t[c>>2]|0)+(t[o>>2]|0)}o=As(t[(t[t[f>>2]>>2]|0)+16>>2]|0)|0;t[(t[f>>2]|0)+20>>2]=o;t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}function Fp(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[t[r>>2]>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+12>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+16>>2]|0)){s=i;return}if(!(t[(t[t[r>>2]>>2]|0)+16>>2]|0)){s=i;return}e=t[(t[r>>2]|0)+16>>2]|0;t[n>>2]=e-(Os(t[(t[t[r>>2]>>2]|0)+16>>2]|0)|0);if((t[n>>2]|0)>>>0>250){t[f>>2]=ys(t[(t[t[r>>2]>>2]|0)+16>>2]|0,(t[n>>2]|0)-80|0)|0;if((t[f>>2]|0)>>>0>0){n=(t[r>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+(0-(t[f>>2]|0));n=(t[r>>2]|0)+36|0;t[n>>2]=(t[n>>2]|0)+(t[f>>2]|0)}f=As(t[(t[t[r>>2]>>2]|0)+16>>2]|0)|0;t[(t[r>>2]|0)+20>>2]=f}if((Ts(t[(t[t[r>>2]>>2]|0)+16>>2]|0)|0)>>>0>250){s=i;return}QO(t[t[r>>2]>>2]|0,500)|0;t[a>>2]=Os(t[(t[t[r>>2]>>2]|0)+16>>2]|0)|0;if((t[(t[r>>2]|0)+12>>2]|0)!=(t[a>>2]|0)){t[u>>2]=(t[(t[r>>2]|0)+16>>2]|0)-(t[(t[r>>2]|0)+12>>2]|0);t[(t[r>>2]|0)+12>>2]=t[a>>2];t[(t[r>>2]|0)+16>>2]=(t[a>>2]|0)+(t[u>>2]|0)}u=As(t[(t[t[r>>2]>>2]|0)+16>>2]|0)|0;t[(t[r>>2]|0)+20>>2]=u;s=i;return}function Op(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+192|0;r=i;f=i+24|0;a=i+20|0;o=i+178|0;c=i+16|0;l=i+28|0;t[f>>2]=e;if(!(t[f>>2]|0)){s=i;return}if((t[(t[f>>2]|0)+172>>2]|0)==-1){s=i;return}if(!(t[(t[f>>2]|0)+36>>2]|0)){s=i;return}e=u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;do if((t[(t[f>>2]|0)+256>>2]|0)==1){if(((e|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)?(t[(t[f>>2]|0)+172>>2]|0)!=5:0){aE(t[f>>2]|0)|0;break}b=t[(t[f>>2]|0)+36>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=b+28|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{k=b+32|0;t[k>>2]=(t[k>>2]|0)+1}t[a>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2];n[o>>0]=n[t[a>>2]>>0]|0;e:do if((u[o>>0]|0)&128){do if((u[o>>0]|0|0)!=192){if(!(u[(t[a>>2]|0)+1>>0]|0)){yp(t[(t[f>>2]|0)+36>>2]|0,250)|0;t[a>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]}if(((u[(t[a>>2]|0)+1>>0]|0)&192|0)==128){if(((u[o>>0]|0)&224|0)!=224){k=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+2;break e}if(!(u[(t[a>>2]|0)+2>>0]|0)){yp(t[(t[f>>2]|0)+36>>2]|0,250)|0;t[a>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]}if(((u[(t[a>>2]|0)+2>>0]|0)&192|0)==128){if(((u[o>>0]|0)&240|0)==240){if(!(u[(t[a>>2]|0)+3>>0]|0)){yp(t[(t[f>>2]|0)+36>>2]|0,250)|0;t[a>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]}if(((u[o>>0]|0)&248|0)!=240)break;if(((u[(t[a>>2]|0)+3>>0]|0)&192|0)!=128)break;k=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+4;t[c>>2]=((u[t[a>>2]>>0]|0)&7)<<18;t[c>>2]=t[c>>2]|((u[(t[a>>2]|0)+1>>0]|0)&63)<<12;t[c>>2]=t[c>>2]|((u[(t[a>>2]|0)+2>>0]|0)&63)<<6;t[c>>2]=t[c>>2]|(u[(t[a>>2]|0)+3>>0]|0)&63}else{k=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+3;t[c>>2]=((u[t[a>>2]>>0]|0)&15)<<12;t[c>>2]=t[c>>2]|((u[(t[a>>2]|0)+1>>0]|0)&63)<<6;t[c>>2]=t[c>>2]|(u[(t[a>>2]|0)+2>>0]|0)&63}if(!((t[c>>2]|0)>>>0>55295&(t[c>>2]|0)>>>0<57344)?!((t[c>>2]|0)>>>0>65533&(t[c>>2]|0)>>>0<65536|(t[c>>2]|0)>>>0>=1114112):0)break e;Kp(t[f>>2]|0,9,64072,t[c>>2]|0);break e}}}while(0);if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0){k=u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;b=u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;h=u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[r>>2]=u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0];t[r+4>>2]=k;t[r+8>>2]=b;t[r+12>>2]=h;SY(l,149,64152,r)|0;gp(t[f>>2]|0,9,64192,l,0)}else gp(t[f>>2]|0,9,64104,0,0);t[(t[f>>2]|0)+256>>2]=10;h=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[h>>2]=(t[h>>2]|0)+1;s=i;return}else{h=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[h>>2]=(t[h>>2]|0)+1}while(0);h=(t[f>>2]|0)+200|0;t[h>>2]=(t[h>>2]|0)+1;if(!(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[f>>2]|0)+36>>2]|0,250)|0}else{h=t[(t[f>>2]|0)+36>>2]|0;if((e|0)==10){b=h+28|0;t[b>>2]=(t[b>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{b=h+32|0;t[b>>2]=(t[b>>2]|0)+1}b=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[b>>2]=(t[b>>2]|0)+1;b=(t[f>>2]|0)+200|0;t[b>>2]=(t[b>>2]|0)+1;if(!(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[f>>2]|0)+36>>2]|0,250)|0}while(0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37?(t[(t[f>>2]|0)+32>>2]|0)==0:0)oE(t[f>>2]|0);if(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[f>>2]|0)|0;s=i;return}function Ap(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;r=s;s=s+192|0;f=r;a=r+32|0;o=r+28|0;c=r+24|0;l=r+20|0;b=r+186|0;k=r+16|0;h=r+36|0;t[o>>2]=e;t[c>>2]=i;if(!((t[o>>2]|0)==0|(t[c>>2]|0)==0)?(t[(t[o>>2]|0)+36>>2]|0)!=0:0){if((t[(t[o>>2]|0)+172>>2]|0)==-1){t[a>>2]=0;w=t[a>>2]|0;s=r;return w|0}if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=32?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=127:0){t[t[c>>2]>>2]=1;t[a>>2]=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0];w=t[a>>2]|0;s=r;return w|0}if((t[(t[o>>2]|0)+256>>2]|0)!=1){t[t[c>>2]>>2]=1;i=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){t[a>>2]=u[i>>0];w=t[a>>2]|0;s=r;return w|0}if((u[i+1>>0]|0|0)==10){i=(t[o>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+1}t[a>>2]=10;w=t[a>>2]|0;s=r;return w|0}t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2];n[b>>0]=n[t[l>>2]>>0]|0;if(!((u[b>>0]|0)&128)){t[t[c>>2]>>2]=1;if(!(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)>>>0>(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)>>>0:0)Kp(t[o>>2]|0,9,64248,0);i=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){t[a>>2]=u[i>>0];w=t[a>>2]|0;s=r;return w|0}if((u[i+1>>0]|0|0)==10){i=(t[o>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+1}t[a>>2]=10;w=t[a>>2]|0;s=r;return w|0}e:do if(((u[b>>0]|0)&64|0)!=0?(u[b>>0]|0|0)!=192:0){if(!(u[(t[l>>2]|0)+1>>0]|0)){yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]}if(((u[(t[l>>2]|0)+1>>0]|0)&192|0)==128){do if(((u[b>>0]|0)&224|0)==224){if(!(u[(t[l>>2]|0)+2>>0]|0)){yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]}if(((u[(t[l>>2]|0)+2>>0]|0)&192|0)!=128)break e;if(((u[b>>0]|0)&240|0)!=240){t[t[c>>2]>>2]=3;t[k>>2]=((u[t[l>>2]>>0]|0)&15)<<12;t[k>>2]=t[k>>2]|((u[(t[l>>2]|0)+1>>0]|0)&63)<<6;t[k>>2]=t[k>>2]|(u[(t[l>>2]|0)+2>>0]|0)&63;if((t[k>>2]|0)>>>0<2048)break e;else break}if(!(u[(t[l>>2]|0)+3>>0]|0)){yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;t[l>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]}if(((u[b>>0]|0)&248|0)!=240)break e;if(((u[(t[l>>2]|0)+3>>0]|0)&192|0)!=128)break e;t[t[c>>2]>>2]=4;t[k>>2]=((u[t[l>>2]>>0]|0)&7)<<18;t[k>>2]=t[k>>2]|((u[(t[l>>2]|0)+1>>0]|0)&63)<<12;t[k>>2]=t[k>>2]|((u[(t[l>>2]|0)+2>>0]|0)&63)<<6;t[k>>2]=t[k>>2]|(u[(t[l>>2]|0)+3>>0]|0)&63;if((t[k>>2]|0)>>>0<65536)break e}else{t[t[c>>2]>>2]=2;t[k>>2]=((u[t[l>>2]>>0]|0)&31)<<6;t[k>>2]=t[k>>2]|(u[(t[l>>2]|0)+1>>0]|0)&63;if((t[k>>2]|0)>>>0<128)break e}while(0);i=t[k>>2]|0;if((t[k>>2]|0)>>>0<256){if(!(9<=i>>>0&(t[k>>2]|0)>>>0<=10|(t[k>>2]|0)==13|32<=(t[k>>2]|0)>>>0))d=33}else if((!(256<=i>>>0&(t[k>>2]|0)>>>0<=55295)?!(57344<=(t[k>>2]|0)>>>0&(t[k>>2]|0)>>>0<=65533):0)?!(65536<=(t[k>>2]|0)>>>0&(t[k>>2]|0)>>>0<=1114111):0)d=33;if((d|0)==33)Kp(t[o>>2]|0,9,64072,t[k>>2]|0);t[a>>2]=t[k>>2];w=t[a>>2]|0;s=r;return w|0}}while(0);if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<4){t[t[c>>2]>>2]=0;t[a>>2]=0;w=t[a>>2]|0;s=r;return w|0}else{k=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;d=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;l=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[f>>2]=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0];t[f+4>>2]=k;t[f+8>>2]=d;t[f+12>>2]=l;SY(h,149,64152,f)|0;gp(t[o>>2]|0,9,64192,h,0);t[(t[o>>2]|0)+256>>2]=10;t[t[c>>2]>>2]=1;t[a>>2]=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0];w=t[a>>2]|0;s=r;return w|0}}t[a>>2]=0;w=t[a>>2]|0;s=r;return w|0}function Mp(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+192|0;a=f;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+186|0;h=f+16|0;w=f+36|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;if((t[b>>2]|0)==0|(t[l>>2]|0)==0){t[o>>2]=0;d=t[o>>2]|0;s=f;return d|0}if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+256>>2]|0)!=1:0){t[t[b>>2]>>2]=1;t[o>>2]=u[t[l>>2]>>0];d=t[o>>2]|0;s=f;return d|0}n[k>>0]=n[t[l>>2]>>0]|0;if(!((u[k>>0]|0)&128)){t[t[b>>2]>>2]=1;t[o>>2]=u[t[l>>2]>>0];d=t[o>>2]|0;s=f;return d|0}e:do if(((u[(t[l>>2]|0)+1>>0]|0)&192|0)==128){do if(((u[k>>0]|0)&224|0)==224){if(((u[(t[l>>2]|0)+2>>0]|0)&192|0)!=128)break e;if(((u[k>>0]|0)&240|0)!=240){t[t[b>>2]>>2]=3;t[h>>2]=((u[t[l>>2]>>0]|0)&15)<<12;t[h>>2]=t[h>>2]|((u[(t[l>>2]|0)+1>>0]|0)&63)<<6;t[h>>2]=t[h>>2]|(u[(t[l>>2]|0)+2>>0]|0)&63;break}if(((u[k>>0]|0)&248|0)!=240)break e;if(((u[(t[l>>2]|0)+3>>0]|0)&192|0)!=128)break e;t[t[b>>2]>>2]=4;t[h>>2]=((u[t[l>>2]>>0]|0)&7)<<18;t[h>>2]=t[h>>2]|((u[(t[l>>2]|0)+1>>0]|0)&63)<<12;t[h>>2]=t[h>>2]|((u[(t[l>>2]|0)+2>>0]|0)&63)<<6;t[h>>2]=t[h>>2]|(u[(t[l>>2]|0)+3>>0]|0)&63}else{t[t[b>>2]>>2]=2;t[h>>2]=((u[t[l>>2]>>0]|0)&31)<<6;t[h>>2]=t[h>>2]|(u[(t[l>>2]|0)+1>>0]|0)&63}while(0);r=t[h>>2]|0;if((t[h>>2]|0)>>>0<256){if(!(9<=r>>>0&(t[h>>2]|0)>>>0<=10|(t[h>>2]|0)==13|32<=(t[h>>2]|0)>>>0))v=20}else if((!(256<=r>>>0&(t[h>>2]|0)>>>0<=55295)?!(57344<=(t[h>>2]|0)>>>0&(t[h>>2]|0)>>>0<=65533):0)?!(65536<=(t[h>>2]|0)>>>0&(t[h>>2]|0)>>>0<=1114111):0)v=20;if((v|0)==20)Kp(t[c>>2]|0,9,64072,t[h>>2]|0);t[o>>2]=t[h>>2];d=t[o>>2]|0;s=f;return d|0}while(0);if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0){h=u[(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;v=u[(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;k=u[(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[a>>2]=u[t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]>>0];t[a+4>>2]=h;t[a+8>>2]=v;t[a+12>>2]=k;SY(w,149,64152,a)|0;gp(t[c>>2]|0,9,64192,w,0);t[t[b>>2]>>2]=1;t[o>>2]=u[t[l>>2]>>0];d=t[o>>2]|0;s=f;return d|0}t[t[b>>2]>>2]=0;t[o>>2]=0;d=t[o>>2]|0;s=f;return d|0}function Rp(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;if(!(t[u>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}if((t[a>>2]|0)<128){n[t[u>>2]>>0]=t[a>>2];t[f>>2]=1;l=t[f>>2]|0;s=r;return l|0}t[o>>2]=t[u>>2];i=t[a>>2]|0;do if((t[a>>2]|0)<2048){e=t[u>>2]|0;t[u>>2]=e+1;n[e>>0]=i>>6|192;t[c>>2]=0}else{e=t[a>>2]|0;if((i|0)<65536){b=t[u>>2]|0;t[u>>2]=b+1;n[b>>0]=e>>12|224;t[c>>2]=6;break}b=t[a>>2]|0;if((e|0)<1114112){e=t[u>>2]|0;t[u>>2]=e+1;n[e>>0]=b>>18|240;t[c>>2]=12;break}Kp(0,9,64280,b);t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}while(0);while(1){if((t[c>>2]|0)<0)break;i=(t[a>>2]>>t[c>>2]&63|128)&255;b=t[u>>2]|0;t[u>>2]=b+1;n[b>>0]=i;t[c>>2]=(t[c>>2]|0)-6}t[f>>2]=(t[u>>2]|0)-(t[o>>2]|0);l=t[f>>2]|0;s=r;return l|0}function Np(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0;f=s;s=s+16|0;u=f+12|0;a=f+4|0;o=f;t[f+8>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(t[a>>2]|0)if((t[o>>2]|0)>=128){t[u>>2]=Rp(t[a>>2]|0,t[o>>2]|0)|0;break}else{n[t[a>>2]>>0]=t[o>>2];t[u>>2]=1;break}else t[u>>2]=0;while(0);s=f;return t[u>>2]|0}function Tp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=-1;if(!(t[f>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}switch(t[a>>2]|0){case 1:{t[(t[f>>2]|0)+256>>2]=1;if((((t[(t[f>>2]|0)+36>>2]|0)!=0?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==239:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==187:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==191:0){i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+3}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}case 21:case 20:case 19:case 22:case 18:case 17:case 16:case 15:case 14:case 13:case 12:case 11:case 10:case 6:{t[c>>2]=45;break}case-1:{gp(t[f>>2]|0,31,64336,0,0);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}case 0:{t[(t[f>>2]|0)+256>>2]=1;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}case 9:{t[c>>2]=90;break}case 8:case 7:case 4:case 5:{t[c>>2]=180;break}case 3:case 2:{if(((((t[(t[f>>2]|0)+36>>2]|0)!=0?(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)!=0:0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==239:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==187:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==191:0){i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+3}t[c>>2]=90;break}default:{}}t[o>>2]=j_(t[a>>2]|0)|0;e:do if(!(t[o>>2]|0))do switch(t[a>>2]|0){case 8:{gp(t[f>>2]|0,32,64360,64456,0);break e;break}case 9:{gp(t[f>>2]|0,32,64360,64472,0);break e;break}case 7:{gp(t[f>>2]|0,32,64360,64440,0);break e;break}case 18:case 17:case 16:case 15:case 14:case 13:case 12:case 11:case 10:{if((((t[(t[f>>2]|0)+40>>2]|0)==1?(t[(t[f>>2]|0)+24>>2]|0)==0:0)?(t[(t[f>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+36>>2]|0)+44>>2]|0)!=0:0){i=Yl(t[(t[(t[f>>2]|0)+36>>2]|0)+44>>2]|0)|0;t[(t[f>>2]|0)+24>>2]=i}t[(t[f>>2]|0)+256>>2]=t[a>>2];t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}case 19:{gp(t[f>>2]|0,32,64360,64480,0);break e;break}case 20:{gp(t[f>>2]|0,32,64360,64496,0);break e;break}case 22:{t[(t[f>>2]|0)+256>>2]=1;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}case 4:{gp(t[f>>2]|0,32,64360,64392,0);break e;break}case 5:{gp(t[f>>2]|0,32,64360,64416,0);break e;break}case 21:{gp(t[f>>2]|0,32,64360,64512,0);break e;break}case 6:{gp(t[f>>2]|0,32,64360,64432,0);break e;break}default:break e}while(0);while(0);if(!(t[o>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[(t[f>>2]|0)+256>>2]=1;t[n>>2]=Xp(t[f>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;l=t[n>>2]|0;s=r;return l|0}return 0}function Lp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=Xp(t[n>>2]|0,t[f>>2]|0,-1)|0;s=r;return i|0}function Dp(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+44>>2]|0);if(t[(t[r>>2]|0)+48>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);if((t[(t[r>>2]|0)+40>>2]|0)!=0?(t[(t[r>>2]|0)+12>>2]|0)!=0:0)pAi[t[(t[r>>2]|0)+40>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[t[r>>2]>>2]|0)IO(t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Cp(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[f>>2]|0)){Sp(t[n>>2]|0,64520);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+60|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+28>>2]=1;t[(t[f>>2]|0)+32>>2]=1;t[(t[f>>2]|0)+52>>2]=-1;if(t[n>>2]|0){e=(t[n>>2]|0)+464|0;n=t[e>>2]|0;t[e>>2]=n+1;t[(t[f>>2]|0)+56>>2]=n}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Pp(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if(t[33952]|0)yAi[t[135904>>2]&511](t[33980]|0,64560,n);t[c>>2]=Cp(t[u>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[(t[c>>2]|0)+4>>2]=0;t[t[c>>2]>>2]=t[a>>2];zs(t[(t[t[c>>2]>>2]|0)+16>>2]|0,t[c>>2]|0)|0;if(t[o>>2]|0)Tp(t[u>>2]|0,t[o>>2]|0)|0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function Bp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[u>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){Jp(t[u>>2]|0,64584,0);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if(t[33952]|0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[(t[a>>2]|0)+8>>2];yAi[i&511](e,64624,n)}if(t[(t[a>>2]|0)+40>>2]|0){t[o>>2]=Cp(t[u>>2]|0)|0;if(!(t[o>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if(t[(t[a>>2]|0)+64>>2]|0){n=Yl(t[(t[a>>2]|0)+64>>2]|0)|0;t[(t[o>>2]|0)+4>>2]=n}t[(t[o>>2]|0)+12>>2]=t[(t[a>>2]|0)+40>>2];t[(t[o>>2]|0)+16>>2]=t[(t[a>>2]|0)+40>>2];t[(t[o>>2]|0)+24>>2]=t[(t[a>>2]|0)+44>>2];t[(t[o>>2]|0)+20>>2]=(t[(t[a>>2]|0)+40>>2]|0)+(t[(t[o>>2]|0)+24>>2]|0);t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}switch(t[(t[a>>2]|0)+48>>2]|0){case 4:{Jp(t[u>>2]|0,64720,t[(t[a>>2]|0)+8>>2]|0);break}case 1:{Jp(t[u>>2]|0,64680,t[(t[a>>2]|0)+8>>2]|0);break}case 6:{Jp(t[u>>2]|0,64768,t[(t[a>>2]|0)+8>>2]|0);break}case 3:{Jp(t[u>>2]|0,64656,t[(t[a>>2]|0)+8>>2]|0);break}case 5:case 2:{t[f>>2]=uA(t[(t[a>>2]|0)+64>>2]|0,t[(t[a>>2]|0)+52>>2]|0,t[u>>2]|0)|0;c=t[f>>2]|0;s=r;return c|0}default:{}}t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}function Ip(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;t[u>>2]=e;t[a>>2]=i;t[l>>2]=0;t[b>>2]=0;if(t[33952]|0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[a>>2];yAi[i&511](e,64808,n)}if(!(t[u>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[o>>2]=zO(t[a>>2]|0,0)|0;if(!(t[o>>2]|0)){n=t[u>>2]|0;if(!(t[a>>2]|0))EO(n,64840,0);else EO(n,64888,t[a>>2]|0);t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[c>>2]=Cp(t[u>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[t[c>>2]>>2]=t[o>>2];t[c>>2]=nA(t[u>>2]|0,t[c>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}if(!(t[(t[c>>2]|0)+4>>2]|0))t[b>>2]=Yl(t[a>>2]|0)|0;else t[b>>2]=Yl(t[(t[c>>2]|0)+4>>2]|0)|0;t[l>>2]=rA(t[b>>2]|0)|0;if(t[(t[c>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[c>>2]|0)+4>>2]|0);a=KA(t[b>>2]|0)|0;t[(t[c>>2]|0)+4>>2]=a;if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[(t[c>>2]|0)+8>>2]=t[l>>2];zs(t[(t[t[c>>2]>>2]|0)+16>>2]|0,t[c>>2]|0)|0;if((t[l>>2]|0)!=0?(t[(t[u>>2]|0)+180>>2]|0)==0:0){b=Yl(t[l>>2]|0)|0;t[(t[u>>2]|0)+180>>2]=b}t[f>>2]=t[c>>2];k=t[f>>2]|0;s=r;return k|0}function Hp(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){Jp(0,64928,0);t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}rj();if(!(t[(t[n>>2]|0)+296>>2]|0)){e=lz()|0;t[(t[n>>2]|0)+296>>2]=e}if(!(t[(t[n>>2]|0)+296>>2]|0)){Sp(0,64960);t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}dz(t[(t[n>>2]|0)+296>>2]|0,1e7)|0;if(!(t[t[n>>2]>>2]|0)){e=gAi[t[135744>>2]&511](128)|0;t[t[n>>2]>>2]=e}if(!(t[t[n>>2]>>2]|0)){Sp(0,64960);t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}ij(t[t[n>>2]>>2]|0,2)|0;t[(t[n>>2]|0)+304>>2]=0;t[(t[n>>2]|0)+300>>2]=0;if(!(t[(t[n>>2]|0)+48>>2]|0)){e=gAi[t[135744>>2]&511](20)|0;t[(t[n>>2]|0)+48>>2]=e;t[(t[n>>2]|0)+44>>2]=5}if(!(t[(t[n>>2]|0)+48>>2]|0)){Sp(0,64960);t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}while(1){e=iE(t[n>>2]|0)|0;t[f>>2]=e;if(!e)break;Dp(t[f>>2]|0)}t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[(t[n>>2]|0)+20>>2]=0;t[(t[n>>2]|0)+24>>2]=0;t[(t[n>>2]|0)+28>>2]=-1;t[(t[n>>2]|0)+88>>2]=0;t[(t[n>>2]|0)+92>>2]=0;t[(t[n>>2]|0)+32>>2]=0;t[(t[n>>2]|0)+96>>2]=0;t[(t[n>>2]|0)+172>>2]=0;t[(t[n>>2]|0)+176>>2]=0;t[(t[n>>2]|0)+180>>2]=0;if(!(t[(t[n>>2]|0)+64>>2]|0)){f=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+64>>2]=f;t[(t[n>>2]|0)+60>>2]=10}if(!(t[(t[n>>2]|0)+64>>2]|0)){Sp(0,64960);t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+60>>2]=0;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+52>>2]=0;if(!(t[(t[n>>2]|0)+196>>2]|0)){f=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+196>>2]=f;t[(t[n>>2]|0)+192>>2]=10}if(!(t[(t[n>>2]|0)+196>>2]|0)){Sp(0,64960);t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+60>>2]=0;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[(t[n>>2]|0)+188>>2]=0;t[(t[n>>2]|0)+192>>2]=0;t[(t[n>>2]|0)+184>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[n>>2]|0)+188>>2]=0;t[(t[n>>2]|0)+184>>2]=0;if(!(t[(t[n>>2]|0)+244>>2]|0)){f=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+244>>2]=f;t[(t[n>>2]|0)+240>>2]=10}if(!(t[(t[n>>2]|0)+244>>2]|0)){Sp(0,64960);t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+60>>2]=0;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[(t[n>>2]|0)+188>>2]=0;t[(t[n>>2]|0)+192>>2]=0;t[(t[n>>2]|0)+184>>2]=0;t[(t[n>>2]|0)+236>>2]=0;t[(t[n>>2]|0)+240>>2]=0;t[(t[n>>2]|0)+232>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[n>>2]|0)+236>>2]=1;t[(t[n>>2]|0)+240>>2]=10;t[t[(t[n>>2]|0)+244>>2]>>2]=-1;t[(t[n>>2]|0)+232>>2]=t[(t[n>>2]|0)+244>>2];t[(t[n>>2]|0)+4>>2]=t[n>>2];t[(t[n>>2]|0)+8>>2]=0;t[(t[n>>2]|0)+12>>2]=1;t[(t[n>>2]|0)+356>>2]=1;t[(t[n>>2]|0)+100>>2]=1;t[(t[n>>2]|0)+276>>2]=t[33958];if(t[(t[n>>2]|0)+276>>2]|0){f=(t[n>>2]|0)+360|0;t[f>>2]=t[f>>2]|4}t[(t[n>>2]|0)+104>>2]=t[33954];t[(t[n>>2]|0)+268>>2]=t[33960];if(t[(t[n>>2]|0)+268>>2]|0){f=(t[n>>2]|0)+360|0;t[f>>2]=t[f>>2]|128}t[(t[n>>2]|0)+280>>2]=t[33962];t[(t[n>>2]|0)+208>>2]=t[33964];if(!(t[(t[n>>2]|0)+208>>2]|0)){t[(t[t[n>>2]>>2]|0)+72>>2]=65;f=(t[n>>2]|0)+360|0;t[f>>2]=t[f>>2]|256}t[(t[n>>2]|0)+136>>2]=-1412623820;t[(t[n>>2]|0)+108>>2]=t[n>>2];t[(t[n>>2]|0)+112>>2]=224;t[(t[n>>2]|0)+116>>2]=225;if(t[(t[n>>2]|0)+104>>2]|0){f=(t[n>>2]|0)+116|0;if(!(t[33956]|0))t[f>>2]=0;else t[f>>2]=225;t[(t[n>>2]|0)+128>>2]=0;f=(t[n>>2]|0)+360|0;t[f>>2]=t[f>>2]|16}t[(t[n>>2]|0)+16>>2]=t[33966];if(t[(t[n>>2]|0)+16>>2]|0){f=(t[n>>2]|0)+360|0;t[f>>2]=t[f>>2]|2}t[(t[n>>2]|0)+68>>2]=0;t[(t[n>>2]|0)+200>>2]=0;t[(t[n>>2]|0)+204>>2]=0;t[(t[n>>2]|0)+216>>2]=0;t[(t[n>>2]|0)+84>>2]=0;t[(t[n>>2]|0)+248>>2]=0;t[(t[n>>2]|0)+256>>2]=1;t[(t[n>>2]|0)+284>>2]=0;t[(t[n>>2]|0)+440>>2]=0;t[(t[n>>2]|0)+444>>2]=0;t[(t[n>>2]|0)+468>>2]=0;t[(t[n>>2]|0)+464>>2]=1;xp((t[n>>2]|0)+72|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function xp(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[(t[r>>2]|0)+4>>2]=0;t[t[r>>2]>>2]=0;t[(t[r>>2]|0)+8>>2]=0;s=i;return}function Up(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;o=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}while(1){e=iE(t[r>>2]|0)|0;t[n>>2]=e;if(!e)break;Dp(t[n>>2]|0)}if(t[(t[r>>2]|0)+244>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+244>>2]|0);if(t[(t[r>>2]|0)+196>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+196>>2]|0);if(t[(t[r>>2]|0)+64>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+64>>2]|0);
	if(t[(t[r>>2]|0)+460>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+460>>2]|0);if(t[(t[r>>2]|0)+48>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);if(t[(t[r>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+224>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+224>>2]|0);if(t[(t[r>>2]|0)+228>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+228>>2]|0);if((t[t[r>>2]>>2]|0)!=0?(t[t[r>>2]>>2]|0)!=135968:0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+180>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+180>>2]|0);if(t[(t[r>>2]|0)+132>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+132>>2]|0);if(t[(t[r>>2]|0)+300>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+300>>2]|0);if(t[(t[r>>2]|0)+296>>2]|0)bz(t[(t[r>>2]|0)+296>>2]|0);if(t[(t[r>>2]|0)+336>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+336>>2]|0);if(t[(t[r>>2]|0)+344>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+344>>2]|0);if(t[(t[r>>2]|0)+340>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+340>>2]|0);if(t[(t[r>>2]|0)+348>>2]|0)XF(t[(t[r>>2]|0)+348>>2]|0,t[33934]|0);if(t[(t[r>>2]|0)+352>>2]|0)XF(t[(t[r>>2]|0)+352>>2]|0,0);e:do if(t[(t[r>>2]|0)+372>>2]|0){t[f>>2]=t[(t[r>>2]|0)+372>>2];while(1){if(!(t[f>>2]|0))break e;t[u>>2]=t[(t[f>>2]|0)+24>>2];pAi[t[135736>>2]&511](t[f>>2]|0);t[f>>2]=t[u>>2]}}while(0);e:do if(t[(t[r>>2]|0)+380>>2]|0){t[a>>2]=t[(t[r>>2]|0)+380>>2];while(1){if(!(t[a>>2]|0))break e;t[o>>2]=t[(t[a>>2]|0)+24>>2];pAi[t[135736>>2]&511](t[a>>2]|0);t[a>>2]=t[o>>2]}}while(0);if(t[(t[r>>2]|0)+392>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+392>>2]|0);if(t[(t[r>>2]|0)+400>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+400>>2]|0);if(t[(t[r>>2]|0)+408>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+408>>2]|0);if(t[(t[r>>2]|0)+412>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+412>>2]|0);if(t[(t[r>>2]|0)+416>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+416>>2]|0);if(t[(t[r>>2]|0)+284>>2]|0)bc(t[(t[r>>2]|0)+284>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function zp(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](472)|0;do if(t[r>>2]|0){VY(t[r>>2]|0,0,472)|0;n=(Hp(t[r>>2]|0)|0)<0;f=t[r>>2]|0;if(n){Up(f);t[i>>2]=0;break}else{t[i>>2]=f;break}}else{Sp(0,65e3);t[i>>2]=0}while(0);s=e;return t[i>>2]|0}function jp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[l>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[o>>2]=1;t[a>>2]=t[(t[f>>2]|0)+4>>2];t[c>>2]=0;while(1){if((t[o>>2]|0)>>>0>(t[a>>2]|0)>>>0)break;if(!((t[l>>2]|0)!=0^1))break;t[c>>2]=(t[o>>2]|0)+((((t[a>>2]|0)-(t[o>>2]|0)|0)>>>0)/2|0);if((t[u>>2]|0)==(t[(t[(t[f>>2]|0)+8>>2]|0)+(((t[c>>2]|0)-1|0)*20|0)>>2]|0)){t[l>>2]=1;continue}i=t[c>>2]|0;if((t[u>>2]|0)>>>0<(t[(t[(t[f>>2]|0)+8>>2]|0)+(((t[c>>2]|0)-1|0)*20|0)>>2]|0)>>>0){t[a>>2]=i-1;continue}else{t[o>>2]=i+1;continue}}if((t[c>>2]|0)!=0?(t[(t[(t[f>>2]|0)+8>>2]|0)+(((t[c>>2]|0)-1|0)*20|0)>>2]|0)>>>0>=(t[u>>2]|0)>>>0:0){t[n>>2]=(t[c>>2]|0)-1;b=t[n>>2]|0;s=r;return b|0}t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}function Vp(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}t[u>>2]=jp((t[n>>2]|0)+72|0,t[t[f>>2]>>2]|0)|0;if(((t[u>>2]|0)>>>0<(t[(t[n>>2]|0)+76>>2]|0)>>>0?(t[(t[n>>2]|0)+80>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+80>>2]|0)+((t[u>>2]|0)*20|0)>>2]|0)==(t[t[f>>2]>>2]|0):0){i=(t[(t[n>>2]|0)+80>>2]|0)+((t[u>>2]|0)*20|0)|0;e=t[f>>2]|0;t[i+0>>2]=t[e+0>>2];t[i+4>>2]=t[e+4>>2];t[i+8>>2]=t[e+8>>2];t[i+12>>2]=t[e+12>>2];t[i+16>>2]=t[e+16>>2];s=r;return}if(!(((t[(t[n>>2]|0)+76>>2]|0)+1|0)>>>0<=(t[(t[n>>2]|0)+72>>2]|0)>>>0?(t[(t[n>>2]|0)+80>>2]|0)!=0:0))l=8;do if((l|0)==8){if(!(t[(t[n>>2]|0)+72>>2]|0))t[(t[n>>2]|0)+72>>2]=2;t[o>>2]=(t[(t[n>>2]|0)+72>>2]<<1)*20;if(!(t[(t[n>>2]|0)+80>>2]|0))t[a>>2]=gAi[t[135744>>2]&511](t[o>>2]|0)|0;else t[a>>2]=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+80>>2]|0,t[o>>2]|0)|0;if(t[a>>2]|0){t[(t[n>>2]|0)+80>>2]=t[a>>2];e=(t[n>>2]|0)+72|0;t[e>>2]=t[e>>2]<<1;break}Sp(t[n>>2]|0,65032);s=r;return}while(0);e:do if((t[u>>2]|0)!=(t[(t[n>>2]|0)+76>>2]|0)){t[c>>2]=t[(t[n>>2]|0)+76>>2];while(1){if((t[c>>2]|0)>>>0<=(t[u>>2]|0)>>>0)break e;a=(t[(t[n>>2]|0)+80>>2]|0)+((t[c>>2]|0)*20|0)|0;o=(t[(t[n>>2]|0)+80>>2]|0)+(((t[c>>2]|0)-1|0)*20|0)|0;t[a+0>>2]=t[o+0>>2];t[a+4>>2]=t[o+4>>2];t[a+8>>2]=t[o+8>>2];t[a+12>>2]=t[o+12>>2];t[a+16>>2]=t[o+16>>2];t[c>>2]=(t[c>>2]|0)+-1}}while(0);c=(t[(t[n>>2]|0)+80>>2]|0)+((t[u>>2]|0)*20|0)|0;u=t[f>>2]|0;t[c+0>>2]=t[u+0>>2];t[c+4>>2]=t[u+4>>2];t[c+8>>2]=t[u+8>>2];t[c+12>>2]=t[u+12>>2];t[c+16>>2]=t[u+16>>2];u=(t[n>>2]|0)+76|0;t[u>>2]=(t[u>>2]|0)+1;s=r;return}function qp(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[33960];t[33960]=t[r>>2];s=i;return t[n>>2]|0}function Yp(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[33962];t[33962]=t[r>>2];s=i;return t[n>>2]|0}function Gp(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[33966];t[33966]=t[r>>2];s=i;return t[n>>2]|0}function Wp(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[33964];t[33964]=t[r>>2];if(!(t[r>>2]|0))t[33984]=1;s=i;return t[n>>2]|0}function Kp(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+212>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)==-1:0){s=f;return}if(t[a>>2]|0)t[(t[a>>2]|0)+84>>2]=t[o>>2];n=t[a>>2]|0;r=t[o>>2]|0;o=t[l>>2]|0;i=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,0,1,r,3,0,0,0,0,0,o,0,i,u);if(!(t[a>>2]|0)){s=f;return}t[(t[a>>2]|0)+12>>2]=0;if(t[(t[a>>2]|0)+288>>2]|0){s=f;return}t[(t[a>>2]|0)+212>>2]=1;s=f;return}function Xp(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}r=t[u>>2]|0;if(t[(t[u>>2]|0)+36>>2]|0){t[c>>2]=Zp(r,t[(t[u>>2]|0)+36>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[(t[u>>2]|0)+256>>2]=1;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}else{Jp(r,65064,0);t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}return 0}function Zp(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;if(!(t[l>>2]|0)){t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}if(!(t[c>>2]|0)){t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}n=t[c>>2]|0;if(!(t[t[c>>2]>>2]|0))if(!(t[n+24>>2]|0)){Jp(t[o>>2]|0,65184,0);t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}else{t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}if(t[(t[n>>2]|0)+12>>2]|0)if((t[(t[t[c>>2]>>2]|0)+12>>2]|0)==(t[l>>2]|0)){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}else{W_(t[(t[t[c>>2]>>2]|0)+12>>2]|0)|0;t[(t[t[c>>2]>>2]|0)+12>>2]=t[l>>2];t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}t[(t[t[c>>2]>>2]|0)+12>>2]=t[l>>2];do if(!(Ds(t[(t[t[c>>2]>>2]|0)+16>>2]|0)|0)){do if(t[t[l>>2]>>2]|0){if((MY(t[t[l>>2]>>2]|0,65096)|0)!=0?(MY(t[t[l>>2]>>2]|0,65112)|0)!=0:0)break;if((u[t[(t[c>>2]|0)+16>>2]>>0]|0|0)==255?(u[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0|0)==254:0){n=(t[c>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+2}}while(0);if((((t[t[l>>2]>>2]|0)!=0?(MY(t[t[l>>2]>>2]|0,65120)|0)==0:0)?(u[t[(t[c>>2]|0)+16>>2]>>0]|0|0)==254:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0|0)==255:0){n=(t[c>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+2}if(((((t[t[l>>2]>>2]|0)!=0?(MY(t[t[l>>2]>>2]|0,65136)|0)==0:0)?(u[t[(t[c>>2]|0)+16>>2]>>0]|0|0)==239:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0|0)==187:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+2>>0]|0|0)==191:0){n=(t[c>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+3}t[h>>2]=(t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0);ys(t[(t[t[c>>2]>>2]|0)+16>>2]|0,t[h>>2]|0)|0;t[(t[t[c>>2]>>2]|0)+20>>2]=t[(t[t[c>>2]>>2]|0)+16>>2];n=ds()|0;t[(t[t[c>>2]>>2]|0)+16>>2]=n;t[(t[t[c>>2]>>2]|0)+32>>2]=t[h>>2];t[w>>2]=Ts(t[(t[t[c>>2]>>2]|0)+20>>2]|0)|0;n=t[t[c>>2]>>2]|0;if(t[(t[o>>2]|0)+32>>2]|0)t[k>>2]=Y_(n,1)|0;else t[k>>2]=q_(n,t[b>>2]|0)|0;if((t[k>>2]|0)>=0){n=t[w>>2]|0;r=n-(Ts(t[(t[t[c>>2]>>2]|0)+20>>2]|0)|0)|0;n=(t[t[c>>2]>>2]|0)+32|0;t[n>>2]=(t[n>>2]|0)+r;zs(t[(t[t[c>>2]>>2]|0)+16>>2]|0,t[c>>2]|0)|0;break}Jp(t[o>>2]|0,65144,0);t[a>>2]=-1;d=t[a>>2]|0;s=f;return d|0}while(0);t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}function Jp(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n;u=n+12|0;a=n+8|0;o=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+212>>2]|0)!=0:0)?(t[(t[u>>2]|0)+172>>2]|0)==-1:0){s=n;return}if(t[u>>2]|0)t[(t[u>>2]|0)+84>>2]=1;r=t[u>>2]|0;i=t[o>>2]|0;e=t[a>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,r,0,1,1,3,0,0,i,0,0,0,0,e,f);if(!(t[u>>2]|0)){s=n;return}t[(t[u>>2]|0)+12>>2]=0;if(t[(t[u>>2]|0)+288>>2]|0){s=n;return}t[(t[u>>2]|0)+212>>2]=1;s=n;return}function Qp(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do switch(t[n>>2]|0){case 21:{t[r>>2]=1;break}case 18:{t[r>>2]=1;break}case 30:{t[r>>2]=0;break}case 29:{t[r>>2]=0;break}case 33:{t[r>>2]=0;break}case 10:{t[r>>2]=0;break}case 16:{t[r>>2]=1;break}case 14:{t[r>>2]=1;break}case 28:{t[r>>2]=1;break}case 8:{t[r>>2]=1;break}case 15:{t[r>>2]=1;break}case 27:{t[r>>2]=1;break}case 13:{t[r>>2]=1;break}case 20:{t[r>>2]=1;break}case 3:{t[r>>2]=1;break}case 17:{t[r>>2]=1;break}case 4:{t[r>>2]=1;break}case 12:{t[r>>2]=1;break}case 2:{t[r>>2]=1;break}case 11:{t[r>>2]=1;break}case 19:{t[r>>2]=1;break}case 9:{t[r>>2]=0;break}case 24:{t[r>>2]=1;break}case 26:{t[r>>2]=1;break}case 1:{t[r>>2]=0;break}case 22:{t[r>>2]=1;break}case 5:{t[r>>2]=1;break}case 23:{t[r>>2]=1;break}case 32:{t[r>>2]=0;break}case 25:{t[r>>2]=1;break}case 6:{t[r>>2]=1;break}case 31:{t[r>>2]=0;break}case 7:{t[r>>2]=1;break}default:t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function $p(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(!(t[f>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if(!((u[t[f>>2]>>0]|0|0)==105?(u[(t[f>>2]|0)+1>>0]|0|0)==45:0))c=5;do if((c|0)==5){if((u[t[f>>2]>>0]|0|0)==73?(u[(t[f>>2]|0)+1>>0]|0|0)==45:0)break;if((u[t[f>>2]>>0]|0|0)==120?(u[(t[f>>2]|0)+1>>0]|0|0)==45:0)break;if((u[t[f>>2]>>0]|0|0)==88?(u[(t[f>>2]|0)+1>>0]|0|0)==45:0)break;t[a>>2]=t[f>>2];while(1){if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)l=1;else if((u[t[a>>2]>>0]|0|0)>=97)l=(u[t[a>>2]>>0]|0|0)<=122;else l=0;b=t[a>>2]|0;if(!l)break;t[a>>2]=b+1}n=(t[a>>2]|0)-(t[f>>2]|0)|0;if((b-(t[f>>2]|0)|0)>=4){if((n|0)<=8?(u[t[a>>2]>>0]|0|0)==0:0){t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if((n|0)<2){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if(!(u[t[a>>2]>>0]|0)){t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}if((u[t[a>>2]>>0]|0|0)!=45){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[a>>2]=(t[a>>2]|0)+1;t[f>>2]=t[a>>2];if((u[t[a>>2]>>0]|0|0)>=48?(u[t[a>>2]>>0]|0|0)<=57:0)c=103;else c=39;e:do if((c|0)==39){while(1){c=0;if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)k=1;else if((u[t[a>>2]>>0]|0|0)>=97)k=(u[t[a>>2]>>0]|0|0)<=122;else k=0;h=t[a>>2]|0;if(!k)break;t[a>>2]=h+1;c=39}do if((h-(t[f>>2]|0)|0)!=4){if(((t[a>>2]|0)-(t[f>>2]|0)|0)==2){c=84;break e}if(((t[a>>2]|0)-(t[f>>2]|0)|0)>=5?((t[a>>2]|0)-(t[f>>2]|0)|0)<=8:0)break e;if(((t[a>>2]|0)-(t[f>>2]|0)|0)!=3){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if(!(u[t[a>>2]>>0]|0)){t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}if((u[t[a>>2]>>0]|0|0)!=45){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[a>>2]=(t[a>>2]|0)+1;t[f>>2]=t[a>>2];if((u[t[a>>2]>>0]|0|0)>=48?(u[t[a>>2]>>0]|0|0)<=57:0){c=103;break e}while(1){if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)w=1;else c=59;do if((c|0)==59){c=0;if((u[t[a>>2]>>0]|0|0)<97){w=0;break}w=(u[t[a>>2]>>0]|0|0)<=122}while(0);d=t[a>>2]|0;if(!w)break;t[a>>2]=d+1}if((d-(t[f>>2]|0)|0)==2){c=84;break e}if(((t[a>>2]|0)-(t[f>>2]|0)|0)>=5?((t[a>>2]|0)-(t[f>>2]|0)|0)<=8:0)break e;if(((t[a>>2]|0)-(t[f>>2]|0)|0)==4)break;t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}while(0);if(!(u[t[a>>2]>>0]|0)){t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}if((u[t[a>>2]>>0]|0|0)!=45){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[a>>2]=(t[a>>2]|0)+1;t[f>>2]=t[a>>2];if((u[t[a>>2]>>0]|0|0)>=48?(u[t[a>>2]>>0]|0|0)<=57:0){c=103;break}while(1){if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)v=1;else if((u[t[a>>2]>>0]|0|0)>=97)v=(u[t[a>>2]>>0]|0|0)<=122;else v=0;m=t[a>>2]|0;if(!v)break;t[a>>2]=m+1}if((m-(t[f>>2]|0)|0)>=5?((t[a>>2]|0)-(t[f>>2]|0)|0)<=8:0)break;if(((t[a>>2]|0)-(t[f>>2]|0)|0)!=2){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}else c=84}while(0);do if((c|0)==103){if((((u[(t[a>>2]|0)+1>>0]|0|0)>=48?(u[(t[a>>2]|0)+1>>0]|0|0)<=57:0)?(u[(t[a>>2]|0)+2>>0]|0|0)>=48:0)?(u[(t[a>>2]|0)+2>>0]|0|0)<=57:0){t[a>>2]=(t[a>>2]|0)+3;c=84;break}t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}while(0);do if((c|0)==84){if(!(u[t[a>>2]>>0]|0)){t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}if((u[t[a>>2]>>0]|0|0)!=45){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[a>>2]=(t[a>>2]|0)+1;t[f>>2]=t[a>>2];while(1){if((u[t[a>>2]>>0]|0|0)>=65?(u[t[a>>2]>>0]|0|0)<=90:0)_=1;else if((u[t[a>>2]>>0]|0|0)>=97)_=(u[t[a>>2]>>0]|0|0)<=122;else _=0;p=t[a>>2]|0;if(!_)break;t[a>>2]=p+1}if((p-(t[f>>2]|0)|0)>=5?((t[a>>2]|0)-(t[f>>2]|0)|0)<=8:0)break;t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}while(0);if(!(u[t[a>>2]>>0]|0)){t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}if((u[t[a>>2]>>0]|0|0)!=45){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}else{t[r>>2]=1;o=t[r>>2]|0;s=i;return o|0}}while(0);t[f>>2]=(t[f>>2]|0)+2;while(1){if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0)E=1;else if((u[t[f>>2]>>0]|0|0)>=97)E=(u[t[f>>2]>>0]|0|0)<=122;else E=0;S=t[f>>2]|0;if(!E)break;t[f>>2]=S+1}t[r>>2]=(u[S>>0]|0|0)==0&1;o=t[r>>2]|0;s=i;return o|0}function eE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if((t[(t[f>>2]|0)+40>>2]|0)>=(t[(t[f>>2]|0)+44>>2]|0)?(i=(t[f>>2]|0)+44|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+48>>2]|0,t[(t[f>>2]|0)+44>>2]<<2)|0,t[(t[f>>2]|0)+48>>2]=i,(t[(t[f>>2]|0)+48>>2]|0)==0):0){Sp(t[f>>2]|0,0);Dp(t[u>>2]|0);i=(t[f>>2]|0)+44|0;t[i>>2]=(t[i>>2]|0)/2|0;t[u>>2]=0;t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}t[(t[(t[f>>2]|0)+48>>2]|0)+(t[(t[f>>2]|0)+40>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+36>>2]=t[u>>2];u=(t[f>>2]|0)+40|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;a=t[n>>2]|0;s=r;return a|0}function iE(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if((t[(t[n>>2]|0)+40>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+40|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+40>>2]|0)>0)t[(t[n>>2]|0)+36>>2]=t[(t[(t[n>>2]|0)+48>>2]|0)+((t[e+40>>2]|0)-1<<2)>>2];else t[e+36>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+48>>2]|0)+(t[(t[n>>2]|0)+40>>2]<<2)>>2];t[(t[(t[n>>2]|0)+48>>2]|0)+(t[(t[n>>2]|0)+40>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function rE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}do if((t[(t[f>>2]|0)+56>>2]|0)>=(t[(t[f>>2]|0)+60>>2]|0)){t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+60>>2]<<1<<2)|0;if(t[a>>2]|0){t[(t[f>>2]|0)+64>>2]=t[a>>2];i=(t[f>>2]|0)+60|0;t[i>>2]=t[i>>2]<<1;break}Sp(t[f>>2]|0,0);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(0);if((t[(t[f>>2]|0)+56>>2]|0)>>>0>(t[16304]|0)>>>0?(t[(t[f>>2]|0)+360>>2]&524288|0)==0:0){OS(t[f>>2]|0,1,65224,t[16304]|0);t[(t[f>>2]|0)+172>>2]=-1;t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}t[(t[(t[f>>2]|0)+64>>2]|0)+(t[(t[f>>2]|0)+56>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+52>>2]=t[u>>2];u=(t[f>>2]|0)+56|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;o=t[n>>2]|0;s=r;return o|0}function nE(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if((t[(t[n>>2]|0)+56>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+56|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+56>>2]|0)>0)t[(t[n>>2]|0)+52>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+((t[e+56>>2]|0)-1<<2)>>2];else t[e+52>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+(t[(t[n>>2]|0)+56>>2]<<2)>>2];t[(t[(t[n>>2]|0)+64>>2]|0)+(t[(t[n>>2]|0)+56>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function fE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}do if((t[(t[f>>2]|0)+188>>2]|0)>=(t[(t[f>>2]|0)+192>>2]|0)){t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+196>>2]|0,t[(t[f>>2]|0)+192>>2]<<1<<2)|0;if(t[a>>2]|0){t[(t[f>>2]|0)+196>>2]=t[a>>2];i=(t[f>>2]|0)+192|0;t[i>>2]=t[i>>2]<<1;break}Sp(t[f>>2]|0,0);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(0);t[(t[(t[f>>2]|0)+196>>2]|0)+(t[(t[f>>2]|0)+188>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+184>>2]=t[u>>2];u=(t[f>>2]|0)+188|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;o=t[n>>2]|0;s=r;return o|0}function tE(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+188>>2]|0)>0:0){e=(t[n>>2]|0)+188|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+188>>2]|0)>0)t[(t[n>>2]|0)+184>>2]=t[(t[(t[n>>2]|0)+196>>2]|0)+((t[e+188>>2]|0)-1<<2)>>2];else t[e+184>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+196>>2]|0)+(t[(t[n>>2]|0)+188>>2]<<2)>>2];t[(t[(t[n>>2]|0)+196>>2]|0)+(t[(t[n>>2]|0)+188>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function uE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[n>>2]=0;if((t[(t[r>>2]|0)+40>>2]|0)==1?(t[(t[r>>2]|0)+172>>2]|0)!=3:0){t[f>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];while(1){do if((u[t[f>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[f>>2]>>0]|0|0)==13}while(0);c=t[f>>2]|0;if(!o)break;e=t[(t[r>>2]|0)+36>>2]|0;if((u[c>>0]|0|0)==10){l=e+28|0;t[l>>2]=(t[l>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{l=e+32|0;t[l>>2]=(t[l>>2]|0)+1}t[f>>2]=(t[f>>2]|0)+1;t[n>>2]=(t[n>>2]|0)+1;if(u[t[f>>2]>>0]|0)continue;t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]=t[f>>2];yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;t[f>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]}t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]=c;b=t[n>>2]|0;s=i;return b|0}do{t[a>>2]=u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0];while(1){if((t[a>>2]|0)!=32?!(9<=(t[a>>2]|0)&(t[a>>2]|0)<=10|(t[a>>2]|0)==13):0)break;Op(t[r>>2]|0);t[a>>2]=u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0];t[n>>2]=(t[n>>2]|0)+1}while(1){if((t[a>>2]|0)==0?(t[(t[r>>2]|0)+40>>2]|0)>1:0)k=(t[(t[r>>2]|0)+172>>2]|0)!=5;else k=0;h=t[r>>2]|0;if(!k)break;aE(h)|0;t[a>>2]=u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]}if((u[t[(t[h+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((t[a>>2]|0)<256){if((t[a>>2]|0)!=32?!(9<=(t[a>>2]|0)&(t[a>>2]|0)<=10):0)w=(t[a>>2]|0)==13;else w=1;d=w&1}else d=0}while((d|0)!=0);b=t[n>>2]|0;s=i;return b|0}function aE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i;f=i+8|0;a=i+4|0;t[a>>2]=e;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+40>>2]|0)>1:0){if(t[33952]|0){e=t[33976]|0;o=t[33980]|0;t[r>>2]=t[(t[a>>2]|0)+40>>2];yAi[e&511](o,65288,r)}Dp(iE(t[a>>2]|0)|0);if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[a>>2]|0)+36>>2]|0,250)|0)<=0:0){n[f>>0]=aE(t[a>>2]|0)|0;c=n[f>>0]|0;s=i;return c|0}n[f>>0]=n[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0;c=n[f>>0]|0;s=i;return c|0}n[f>>0]=0;c=n[f>>0]|0;s=i;return c|0}function oE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i;f=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+24|0;b=i+4|0;t[f>>2]=e;t[o>>2]=0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37){s=i;return}switch(t[(t[f>>2]|0)+172>>2]|0){case 14:{AS(t[f>>2]|0,20,0);s=i;return}case 3:{if((t[(t[f>>2]|0)+96>>2]|0)==0?(t[(t[f>>2]|0)+40>>2]|0)==1:0){s=i;return}if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==32){s=i;return}if(9<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=10:0){s=i;return}if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==13){s=i;return}if(!(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)){s=i;return}break}case 15:case 11:case 16:case 13:case 2:case 12:case 7:case 10:case 9:case 6:case 5:case 8:{s=i;return}case 1:case 0:case 4:{AS(t[f>>2]|0,19,0);s=i;return}case-1:{AS(t[f>>2]|0,18,0);s=i;return}default:{}}Op(t[f>>2]|0);t[a>>2]=sE(t[f>>2]|0)|0;if(t[33952]|0){e=t[33976]|0;k=t[33980]|0;t[r>>2]=t[a>>2];yAi[e&511](k,65408,r)}r=t[f>>2]|0;if(!(t[a>>2]|0)){AS(r,24,0);s=i;return}k=t[f>>2]|0;if((u[t[(t[r+36>>2]|0)+16>>2]>>0]|0|0)!=59){AS(k,25,0);s=i;return}Op(k);if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+96>>2]|0)!=0:0)t[o>>2]=MAi[t[(t[t[f>>2]>>2]|0)+96>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[a>>2]|0)|0;if((t[(t[f>>2]|0)+172>>2]|0)==-1){s=i;return}k=t[f>>2]|0;if(!(t[o>>2]|0)){do if((t[k+28>>2]|0)==1)h=26;else{if((t[(t[f>>2]|0)+88>>2]|0)==0?(t[(t[f>>2]|0)+92>>2]|0)==0:0){h=26;break}if((t[(t[f>>2]|0)+104>>2]|0)!=0?(t[(t[f>>2]|0)+112>>2]|0)!=0:0)RS(t[f>>2]|0,27,65432,t[a>>2]|0,0);else NS(t[f>>2]|0,27,65432,t[a>>2]|0,0);t[(t[f>>2]|0)+100>>2]=0}while(0);if((h|0)==26)MS(t[f>>2]|0,26,65432,t[a>>2]|0);TS(t[f>>2]|0,0,0,0)|0;s=i;return}if((t[(t[k+36>>2]|0)+40>>2]|0)!=226){t[c>>2]=DS(t[f>>2]|0,t[o>>2]|0)|0;cE(t[f>>2]|0,t[c>>2]|0)|0;s=i;return}if((t[(t[o>>2]|0)+48>>2]|0)!=4?(t[(t[o>>2]|0)+48>>2]|0)!=5:0){MS(t[f>>2]|0,30,65464,t[a>>2]|0);s=i;return}if(((((((t[(t[o>>2]|0)+48>>2]|0)==5?(t[(t[f>>2]|0)+360>>2]&2|0)==0:0)?(t[(t[f>>2]|0)+360>>2]&16|0)==0:0)?(t[(t[f>>2]|0)+360>>2]&4|0)==0:0)?(t[(t[f>>2]|0)+360>>2]&8|0)==0:0)?(t[(t[f>>2]|0)+16>>2]|0)==0:0)?(t[(t[f>>2]|0)+104>>2]|0)==0:0){s=i;return}t[c>>2]=Bp(t[f>>2]|0,t[o>>2]|0)|0;if((cE(t[f>>2]|0,t[c>>2]|0)|0)<0){s=i;return}if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){s=i;return}if(((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4?(n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0,n[l+1>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,n[l+2>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,n[l+3>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,t[b>>2]=L_(l,4)|0,(t[b>>2]|0)!=0):0)Tp(t[f>>2]|0,t[b>>2]|0)|0;if((t[(t[o>>2]|0)+48>>2]|0)!=5){s=i;return}if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=63){s=i;return}if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=120){s=i;return}if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=109){s=i;return}if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=108){s=i;return}do if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==13)break;s=i;return}while(0);bE(t[f>>2]|0);s=i;return}function cE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;t[u>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}if(t[33952]|0){if((t[(t[u>>2]|0)+36>>2]|0)!=0?(t[(t[(t[u>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){i=t[33976]|0;e=t[33980]|0;l=t[(t[(t[u>>2]|0)+36>>2]|0)+28>>2]|0;t[n>>2]=t[(t[(t[u>>2]|0)+36>>2]|0)+4>>2];t[n+4>>2]=l;yAi[i&511](e,65312,n)}e=t[33976]|0;i=t[33980]|0;l=t[(t[a>>2]|0)+16>>2]|0;t[n>>2]=(t[(t[u>>2]|0)+40>>2]|0)+1;t[n+4>>2]=l;yAi[e&511](i,65328,n)}t[o>>2]=eE(t[u>>2]|0,t[a>>2]|0)|0;if((t[(t[u>>2]|0)+172>>2]|0)==-1){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}if((t[(t[u>>2]|0)+292>>2]|0)==0?((t[(t[(t[u>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[u>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[u>>2]|0);t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}function lE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[f>>2]=0;t[a>>2]=0;t[o>>2]=0;if(((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);e:while(1){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;e=t[a>>2]|0;t[a>>2]=e+1;if((e|0)>20){t[a>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){c=18;break}}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=48?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=57:0)t[f>>2]=(t[f>>2]<<4)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);else c=22;do if((c|0)==22){c=0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=97?(t[a>>2]|0)<20?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=102:0:0){t[f>>2]=(t[f>>2]<<4)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-97)+10;break}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<65){c=28;break e}if(!((t[a>>2]|0)<20?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=70:0)){c=28;break e}t[f>>2]=(t[f>>2]<<4)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-65)+10}while(0);if((t[f>>2]|0)>>>0>1114111)t[o>>2]=t[f>>2];Op(t[n>>2]|0);t[a>>2]=(t[a>>2]|0)+1}if((c|0)==18){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else if((c|0)==28){AS(t[n>>2]|0,6,0);t[f>>2]=0}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59){e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1;e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+1}}else c=34;do if((c|0)==34){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);while(1){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;e=t[a>>2]|0;t[a>>2]=e+1;if((e|0)>20){t[a>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){c=50;break}}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<48){c=54;break}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>57){c=54;break}t[f>>2]=((t[f>>2]|0)*10|0)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);if((t[f>>2]|0)>>>0>1114111)t[o>>2]=t[f>>2];Op(t[n>>2]|0);t[a>>2]=(t[a>>2]|0)+1}if((c|0)==50){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else if((c|0)==54){AS(t[n>>2]|0,7,0);t[f>>2]=0}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=59)break;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1;e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+1;break}AS(t[n>>2]|0,8,0)}while(0);a=t[f>>2]|0;do if((t[f>>2]|0)>>>0<256)if((9<=a>>>0&(t[f>>2]|0)>>>0<=10|(t[f>>2]|0)==13|32<=(t[f>>2]|0)>>>0)&(t[o>>2]|0)==0)c=66;else c=67;else{if(!(256<=a>>>0&(t[f>>2]|0)>>>0<=55295)?!(57344<=(t[f>>2]|0)>>>0&(t[f>>2]|0)>>>0<=65533):0)if(65536<=(t[f>>2]|0)>>>0&(t[f>>2]|0)>>>0<=1114111&(t[o>>2]|0)==0){c=66;break}else{c=67;break}if(!(t[o>>2]|0))c=66;else c=67}while(0);if((c|0)==66){t[r>>2]=t[f>>2];l=t[r>>2]|0;s=i;return l|0}else if((c|0)==67){OS(t[n>>2]|0,9,65360,t[f>>2]|0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}return 0}function sE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[o>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);t[f>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)c=10;else c=6;do if((c|0)==6){if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){c=10;break}if(!((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=58:0))c=10}while(0);if((c|0)==10){t[f>>2]=(t[f>>2]|0)+1;while(1){if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)l=1;else c=13;do if((c|0)==13){c=0;if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){l=1;break}if((u[t[f>>2]>>0]|0|0)>=48?(u[t[f>>2]>>0]|0|0)<=57:0){l=1;break}if(((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=45:0)?(u[t[f>>2]>>0]|0|0)!=58:0)l=(u[t[f>>2]>>0]|0|0)==46;else l=1}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if((u[b>>0]|0|0)>0?(u[t[f>>2]>>0]|0|0)<128:0){t[o>>2]=(t[f>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0);if((t[o>>2]|0)>5e4?(t[(t[n>>2]|0)+360>>2]&524288|0)==0:0){AS(t[n>>2]|0,110,65688);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[a>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0,t[o>>2]|0)|0;t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]=t[f>>2];f=(t[n>>2]|0)+200|0;t[f>>2]=(t[f>>2]|0)+(t[o>>2]|0);f=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[f>>2]=(t[f>>2]|0)+(t[o>>2]|0);if(!(t[a>>2]|0))Sp(t[n>>2]|0,0);t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}}t[r>>2]=PS(t[n>>2]|0)|0;k=t[r>>2]|0;s=i;return k|0}function bE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;e:do if(((((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break e}while(0);e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+5;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[r>>2]|0,65,68456)}while(0);uE(t[r>>2]|0)|0;t[n>>2]=xE(t[r>>2]|0)|0;do if(t[n>>2]|0){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[r>>2]|0,65,68496)}}else t[n>>2]=Wl(68488)|0;while(0);t[(t[(t[r>>2]|0)+36>>2]|0)+48>>2]=t[n>>2];t[f>>2]=UE(t[r>>2]|0)|0;if((t[(t[r>>2]|0)+84>>2]|0)==32){s=i;return}if((t[f>>2]|0)==0?(t[(t[r>>2]|0)+84>>2]|0)==0:0)BS(t[r>>2]|0,101,68520);uE(t[r>>2]|0)|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[r>>2]|0)|0;s=i;return}e=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62;AS(t[r>>2]|0,57,0);if(e){Op(t[r>>2]|0);s=i;return}while(1){if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)a=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62;else a=0;o=t[r>>2]|0;if(!a)break;e=(t[o+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+1}Op(o);s=i;return}while(0);AS(t[r>>2]|0,56,0);s=i;return}function kE(e,i,r,f,a,o,c){e=e|0;
	i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0;l=s;s=s+128|0;b=l;k=l+116|0;h=l+112|0;w=l+108|0;d=l+104|0;v=l+100|0;m=l+122|0;_=l+121|0;p=l+120|0;E=l+96|0;S=l+92|0;g=l+88|0;y=l+84|0;F=l+80|0;O=l+76|0;A=l+72|0;M=l+68|0;R=l+64|0;N=l+60|0;T=l+56|0;L=l+52|0;D=l+48|0;C=l+44|0;P=l+40|0;B=l+36|0;I=l+32|0;H=l+28|0;x=l+24|0;U=l+20|0;z=l+16|0;j=l+12|0;V=l+8|0;q=l+4|0;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=f;n[m>>0]=a;n[_>>0]=o;n[p>>0]=c;t[E>>2]=0;t[S>>2]=0;t[g>>2]=0;t[y>>2]=0;t[F>>2]=0;if((t[h>>2]|0)==0|(t[w>>2]|0)==0|(t[d>>2]|0)<0){t[k>>2]=0;Y=t[k>>2]|0;s=l;return Y|0}t[O>>2]=(t[w>>2]|0)+(t[d>>2]|0);if(!((t[(t[h>>2]|0)+248>>2]|0)>40?(t[(t[h>>2]|0)+360>>2]&524288|0)==0:0))G=5;if((G|0)==5?(t[(t[h>>2]|0)+248>>2]|0)<=1024:0){t[S>>2]=300;t[E>>2]=gAi[t[135752>>2]&511](t[S>>2]|0)|0;e:do if(!(t[E>>2]|0))G=88;else{if((t[w>>2]|0)>>>0<(t[O>>2]|0)>>>0)t[M>>2]=Mp(t[h>>2]|0,t[w>>2]|0,R)|0;else t[M>>2]=0;while(1){if(!(t[M>>2]|0))break;if((t[M>>2]|0)==(u[m>>0]|0|0))break;if((t[M>>2]|0)==(u[_>>0]|0|0))break;if((t[M>>2]|0)==0?1:(t[M>>2]|0)==(u[p>>0]|0|0))break;if((t[M>>2]|0)==38?(u[(t[w>>2]|0)+1>>0]|0|0)==35:0){t[N>>2]=IS(t[h>>2]|0,w)|0;if(t[N>>2]|0){d=Rp((t[E>>2]|0)+(t[g>>2]|0)|0,t[N>>2]|0)|0;t[g>>2]=(t[g>>2]|0)+d}if(((t[g>>2]|0)+100|0)>>>0>(t[S>>2]|0)>>>0){t[L>>2]=(t[S>>2]<<1)+100;if((t[L>>2]|0)>>>0<(t[S>>2]|0)>>>0){G=88;break e}t[T>>2]=MAi[t[135760>>2]&511](t[E>>2]|0,t[L>>2]|0)|0;if(!(t[T>>2]|0)){G=88;break e}t[E>>2]=t[T>>2];t[S>>2]=t[L>>2]}}else G=23;i:do if((G|0)==23){G=0;if((t[M>>2]|0)==38?(t[v>>2]&1|0)!=0:0){if(t[33952]|0){d=t[33976]|0;c=t[33980]|0;t[b>>2]=t[w>>2];yAi[d&511](c,65512,b)}t[A>>2]=HS(t[h>>2]|0,w)|0;if((t[(t[h>>2]|0)+388>>2]|0)==89)break e;if((t[(t[h>>2]|0)+388>>2]|0)==1)break e;TS(t[h>>2]|0,0,t[A>>2]|0,0)|0;if(t[A>>2]|0){c=(t[h>>2]|0)+440|0;t[c>>2]=(t[c>>2]|0)+((t[(t[A>>2]|0)+72>>2]|0)/2|0)}do if(t[A>>2]|0){if((t[(t[A>>2]|0)+48>>2]|0)!=6)break;if(!(t[(t[A>>2]|0)+40>>2]|0)){BS(t[h>>2]|0,1,65560);break i}c=Rp((t[E>>2]|0)+(t[g>>2]|0)|0,u[t[(t[A>>2]|0)+40>>2]>>0]|0)|0;t[g>>2]=(t[g>>2]|0)+c;if(((t[g>>2]|0)+100|0)>>>0<=(t[S>>2]|0)>>>0)break i;t[C>>2]=(t[S>>2]<<1)+100;if((t[C>>2]|0)>>>0<(t[S>>2]|0)>>>0){G=88;break e}t[D>>2]=MAi[t[135760>>2]&511](t[E>>2]|0,t[C>>2]|0)|0;if(!(t[D>>2]|0)){G=88;break e}t[E>>2]=t[D>>2];t[S>>2]=t[C>>2];break i}while(0);do if(t[A>>2]|0){if(!(t[(t[A>>2]|0)+40>>2]|0))break;c=(t[h>>2]|0)+248|0;t[c>>2]=(t[c>>2]|0)+1;t[F>>2]=hE(t[h>>2]|0,t[(t[A>>2]|0)+40>>2]|0,t[v>>2]|0,0,0,0)|0;c=(t[h>>2]|0)+248|0;t[c>>2]=(t[c>>2]|0)+-1;if(!(t[F>>2]|0))break i;t[y>>2]=t[F>>2];while(1){if(!(u[t[y>>2]>>0]|0))break;c=t[y>>2]|0;t[y>>2]=c+1;d=n[c>>0]|0;c=t[g>>2]|0;t[g>>2]=c+1;n[(t[E>>2]|0)+c>>0]=d;if(((t[g>>2]|0)+100|0)>>>0<=(t[S>>2]|0)>>>0)continue;if(TS(t[h>>2]|0,t[g>>2]|0,t[A>>2]|0,0)|0)break e;t[B>>2]=(t[S>>2]<<1)+100;if((t[B>>2]|0)>>>0<(t[S>>2]|0)>>>0){G=88;break e}t[P>>2]=MAi[t[135760>>2]&511](t[E>>2]|0,t[B>>2]|0)|0;if(!(t[P>>2]|0)){G=88;break e}t[E>>2]=t[P>>2];t[S>>2]=t[B>>2]}pAi[t[135736>>2]&511](t[F>>2]|0);t[F>>2]=0;break i}while(0);if(!(t[A>>2]|0))break;t[I>>2]=rs(t[(t[A>>2]|0)+8>>2]|0)|0;t[H>>2]=t[(t[A>>2]|0)+8>>2];d=t[g>>2]|0;t[g>>2]=d+1;n[(t[E>>2]|0)+d>>0]=38;if(((t[g>>2]|0)+(t[I>>2]|0)+100|0)>>>0>(t[S>>2]|0)>>>0){t[U>>2]=(t[S>>2]<<1)+(t[I>>2]|0)+100;if((t[U>>2]|0)>>>0<(t[S>>2]|0)>>>0){G=88;break e}t[x>>2]=MAi[t[135760>>2]&511](t[E>>2]|0,t[U>>2]|0)|0;if(!(t[x>>2]|0)){G=88;break e}t[E>>2]=t[x>>2];t[S>>2]=t[U>>2]}while(1){if((t[I>>2]|0)<=0)break;d=t[H>>2]|0;t[H>>2]=d+1;c=n[d>>0]|0;d=t[g>>2]|0;t[g>>2]=d+1;n[(t[E>>2]|0)+d>>0]=c;t[I>>2]=(t[I>>2]|0)+-1}c=t[g>>2]|0;t[g>>2]=c+1;n[(t[E>>2]|0)+c>>0]=59;break}if((t[M>>2]|0)==37?(t[v>>2]&2|0)!=0:0){if(t[33952]|0){c=t[33976]|0;d=t[33980]|0;t[b>>2]=t[w>>2];yAi[c&511](d,65600,b)}t[A>>2]=xS(t[h>>2]|0,w)|0;if((t[(t[h>>2]|0)+388>>2]|0)==89)break e;TS(t[h>>2]|0,0,t[A>>2]|0,0)|0;if(t[A>>2]|0){d=(t[h>>2]|0)+440|0;t[d>>2]=(t[d>>2]|0)+((t[(t[A>>2]|0)+72>>2]|0)/2|0)}if(!(t[A>>2]|0))break;if(!(t[(t[A>>2]|0)+40>>2]|0))US(t[h>>2]|0,t[A>>2]|0)|0;d=(t[h>>2]|0)+248|0;t[d>>2]=(t[d>>2]|0)+1;t[F>>2]=hE(t[h>>2]|0,t[(t[A>>2]|0)+40>>2]|0,t[v>>2]|0,0,0,0)|0;d=(t[h>>2]|0)+248|0;t[d>>2]=(t[d>>2]|0)+-1;if(!(t[F>>2]|0))break;t[y>>2]=t[F>>2];while(1){if(!(u[t[y>>2]>>0]|0))break;d=t[y>>2]|0;t[y>>2]=d+1;c=n[d>>0]|0;d=t[g>>2]|0;t[g>>2]=d+1;n[(t[E>>2]|0)+d>>0]=c;if(((t[g>>2]|0)+100|0)>>>0<=(t[S>>2]|0)>>>0)continue;if(TS(t[h>>2]|0,t[g>>2]|0,t[A>>2]|0,0)|0)break e;t[j>>2]=(t[S>>2]<<1)+100;if((t[j>>2]|0)>>>0<(t[S>>2]|0)>>>0){G=88;break e}t[z>>2]=MAi[t[135760>>2]&511](t[E>>2]|0,t[j>>2]|0)|0;if(!(t[z>>2]|0)){G=88;break e}t[E>>2]=t[z>>2];t[S>>2]=t[j>>2]}pAi[t[135736>>2]&511](t[F>>2]|0);t[F>>2]=0;break}if((t[R>>2]|0)==1){c=t[M>>2]&255;d=t[g>>2]|0;t[g>>2]=d+1;n[(t[E>>2]|0)+d>>0]=c}else{c=Rp((t[E>>2]|0)+(t[g>>2]|0)|0,t[M>>2]|0)|0;t[g>>2]=(t[g>>2]|0)+c}t[w>>2]=(t[w>>2]|0)+(t[R>>2]|0);if(((t[g>>2]|0)+100|0)>>>0>(t[S>>2]|0)>>>0){t[q>>2]=(t[S>>2]<<1)+100;if((t[q>>2]|0)>>>0<(t[S>>2]|0)>>>0){G=88;break e}t[V>>2]=MAi[t[135760>>2]&511](t[E>>2]|0,t[q>>2]|0)|0;if(!(t[V>>2]|0)){G=88;break e}t[E>>2]=t[V>>2];t[S>>2]=t[q>>2]}}while(0);if((t[w>>2]|0)>>>0<(t[O>>2]|0)>>>0){t[M>>2]=Mp(t[h>>2]|0,t[w>>2]|0,R)|0;continue}else{t[M>>2]=0;continue}}n[(t[E>>2]|0)+(t[g>>2]|0)>>0]=0;t[k>>2]=t[E>>2];Y=t[k>>2]|0;s=l;return Y|0}while(0);if((G|0)==88)Sp(t[h>>2]|0,0);if(t[F>>2]|0)pAi[t[135736>>2]&511](t[F>>2]|0);if(t[E>>2]|0)pAi[t[135736>>2]&511](t[E>>2]|0);t[k>>2]=0;Y=t[k>>2]|0;s=l;return Y|0}AS(t[h>>2]|0,89,0);t[k>>2]=0;Y=t[k>>2]|0;s=l;return Y|0}function hE(e,i,r,f,u,a){e=e|0;i=i|0;r=r|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+32|0;c=o+12|0;l=o+8|0;b=o+4|0;k=o;h=o+18|0;w=o+17|0;d=o+16|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;n[h>>0]=f;n[w>>0]=u;n[d>>0]=a;if((t[l>>2]|0)==0|(t[b>>2]|0)==0){t[c>>2]=0;v=t[c>>2]|0;s=o;return v|0}else{a=t[l>>2]|0;l=t[b>>2]|0;u=rs(t[b>>2]|0)|0;t[c>>2]=kE(a,l,u,t[k>>2]|0,n[h>>0]|0,n[w>>0]|0,n[d>>0]|0)|0;v=t[c>>2]|0;s=o;return v|0}return 0}function wE(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;f=s;s=s+176|0;a=f+52|0;o=f+48|0;c=f+44|0;l=f+40|0;b=f+56|0;k=f+36|0;h=f+32|0;w=f+28|0;d=f+24|0;v=f+20|0;m=f+16|0;_=f+12|0;p=f+8|0;E=f+4|0;S=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[k>>2]=0;t[h>>2]=0;t[w>>2]=100;t[d>>2]=0;t[v>>2]=t[c>>2];if(!(t[l>>2]|0)){t[a>>2]=0;g=t[a>>2]|0;s=f;return g|0}t[t[l>>2]>>2]=0;if(!(t[v>>2]|0)){t[a>>2]=0;g=t[a>>2]|0;s=f;return g|0}if((u[t[v>>2]>>0]|0|0)==58){t[a>>2]=Yl(t[c>>2]|0)|0;g=t[a>>2]|0;s=f;return g|0}r=t[v>>2]|0;t[v>>2]=r+1;t[m>>2]=u[r>>0];while(1){if(!((t[m>>2]|0)!=0&(t[m>>2]|0)!=58))break;if((t[h>>2]|0)>=(t[w>>2]|0))break;r=t[m>>2]&255;i=t[h>>2]|0;t[h>>2]=i+1;n[b+i>>0]=r;r=t[v>>2]|0;t[v>>2]=r+1;t[m>>2]=u[r>>0]}do if((t[h>>2]|0)>=(t[w>>2]|0)){t[w>>2]=t[h>>2]<<1;t[k>>2]=gAi[t[135752>>2]&511](t[w>>2]|0)|0;if(!(t[k>>2]|0)){Sp(t[o>>2]|0,0);t[a>>2]=0;g=t[a>>2]|0;s=f;return g|0}YY(t[k>>2]|0,b|0,t[h>>2]|0)|0;while(1){if(t[m>>2]|0)y=(t[m>>2]|0)!=58;else y=0;F=t[h>>2]|0;if(!y){O=23;break}if((F+10|0)>(t[w>>2]|0)){t[w>>2]=t[w>>2]<<1;t[_>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[w>>2]|0)|0;if(!(t[_>>2]|0))break;t[k>>2]=t[_>>2]}r=t[m>>2]&255;i=t[h>>2]|0;t[h>>2]=i+1;n[(t[k>>2]|0)+i>>0]=r;r=t[v>>2]|0;t[v>>2]=r+1;t[m>>2]=u[r>>0]}if((O|0)==23){n[(t[k>>2]|0)+F>>0]=0;break}pAi[t[135736>>2]&511](t[k>>2]|0);Sp(t[o>>2]|0,0);t[a>>2]=0;g=t[a>>2]|0;s=f;return g|0}while(0);if((t[m>>2]|0)==58?(u[t[v>>2]>>0]|0|0)==0:0){if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);t[t[l>>2]>>2]=0;t[a>>2]=Yl(t[c>>2]|0)|0;g=t[a>>2]|0;s=f;return g|0}if(!(t[k>>2]|0))t[d>>2]=ql(b,t[h>>2]|0)|0;else{t[d>>2]=t[k>>2];t[k>>2]=0;t[w>>2]=100}do if((t[m>>2]|0)==58){t[m>>2]=u[t[v>>2]>>0];t[t[l>>2]>>2]=t[d>>2];if(!(t[m>>2]|0)){t[a>>2]=ql(65640,0)|0;g=t[a>>2]|0;s=f;return g|0}t[h>>2]=0;do if(!((t[m>>2]|0)>=97&(t[m>>2]|0)<=122)?!((t[m>>2]|0)>=65&(t[m>>2]|0)<=90|(t[m>>2]|0)==95|(t[m>>2]|0)==58):0){t[E>>2]=Mp(t[o>>2]|0,t[v>>2]|0,p)|0;F=t[E>>2]|0;if((t[E>>2]|0)<256){if(65<=(F|0)&(t[E>>2]|0)<=90)break;if(97<=(t[E>>2]|0)&(t[E>>2]|0)<=122)break;if(192<=(t[E>>2]|0)&(t[E>>2]|0)<=214)break;if(216<=(t[E>>2]|0)&(t[E>>2]|0)<=246|248<=(t[E>>2]|0))break}else if(dj(F,199744)|0)break;F=t[E>>2]|0;if((t[E>>2]|0)<256){if((F|0)==95)break}else{if(19968<=(F|0)&(t[E>>2]|0)<=40869|(t[E>>2]|0)==12295)break;if(!((12321<=(t[E>>2]|0)&(t[E>>2]|0)<=12329^1)&(t[E>>2]|0)!=95))break}MS(t[o>>2]|0,202,65648,t[c>>2]|0)}while(0);t[v>>2]=(t[v>>2]|0)+1;while(1){if(!(t[m>>2]|0))break;if((t[h>>2]|0)>=(t[w>>2]|0))break;F=t[m>>2]&255;_=t[h>>2]|0;t[h>>2]=_+1;n[b+_>>0]=F;F=t[v>>2]|0;t[v>>2]=F+1;t[m>>2]=u[F>>0]}do if((t[h>>2]|0)>=(t[w>>2]|0)){t[w>>2]=t[h>>2]<<1;t[k>>2]=gAi[t[135752>>2]&511](t[w>>2]|0)|0;if(!(t[k>>2]|0)){Sp(t[o>>2]|0,0);t[a>>2]=0;g=t[a>>2]|0;s=f;return g|0}YY(t[k>>2]|0,b|0,t[h>>2]|0)|0;while(1){A=t[h>>2]|0;if(!(t[m>>2]|0)){O=62;break}if((A+10|0)>(t[w>>2]|0)){t[w>>2]=t[w>>2]<<1;t[S>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[w>>2]|0)|0;if(!(t[S>>2]|0))break;t[k>>2]=t[S>>2]}F=t[m>>2]&255;_=t[h>>2]|0;t[h>>2]=_+1;n[(t[k>>2]|0)+_>>0]=F;F=t[v>>2]|0;t[v>>2]=F+1;t[m>>2]=u[F>>0]}if((O|0)==62){n[(t[k>>2]|0)+A>>0]=0;break}Sp(t[o>>2]|0,0);pAi[t[135736>>2]&511](t[k>>2]|0);t[a>>2]=0;g=t[a>>2]|0;s=f;return g|0}while(0);if(!(t[k>>2]|0)){t[d>>2]=ql(b,t[h>>2]|0)|0;break}else{t[d>>2]=t[k>>2];break}}while(0);t[a>>2]=t[d>>2];g=t[a>>2]|0;s=f;return g|0}function dE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;i=s;s=s+144|0;r=i+32|0;f=i+28|0;a=i+36|0;o=i+24|0;c=i+20|0;l=i+16|0;b=i+12|0;k=i+8|0;h=i+4|0;w=i;t[f>>2]=e;t[o>>2]=0;t[b>>2]=0;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}t[l>>2]=Ap(t[f>>2]|0,c)|0;while(1){if(!(zS(t[f>>2]|0,t[l>>2]|0)|0)){v=55;break}e=t[b>>2]|0;t[b>>2]=e+1;if(((e|0)>100?(t[b>>2]=0,(t[(t[f>>2]|0)+292>>2]|0)==0):0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[c>>2]|0)==1){e=t[l>>2]&255;m=t[o>>2]|0;t[o>>2]=m+1;n[a+m>>0]=e}else{e=Rp(a+(t[o>>2]|0)|0,t[l>>2]|0)|0;t[o>>2]=(t[o>>2]|0)+e}e=t[(t[f>>2]|0)+36>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){m=e+28|0;t[m>>2]=(t[m>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{m=e+32|0;t[m>>2]=(t[m>>2]|0)+1}m=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[m>>2]=(t[m>>2]|0)+(t[c>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);t[l>>2]=Ap(t[f>>2]|0,c)|0;if(!(t[l>>2]|0)){t[b>>2]=0;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){v=25;break}t[l>>2]=Ap(t[f>>2]|0,c)|0}if((t[o>>2]|0)>=100){v=28;break}}if((v|0)==25){t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}else if((v|0)==28){t[h>>2]=t[o>>2]<<1;t[k>>2]=gAi[t[135752>>2]&511](t[h>>2]|0)|0;if(!(t[k>>2]|0)){Sp(t[f>>2]|0,0);t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}YY(t[k>>2]|0,a|0,t[o>>2]|0)|0;while(1){if(!(zS(t[f>>2]|0,t[l>>2]|0)|0)){v=54;break}m=t[b>>2]|0;t[b>>2]=m+1;if((m|0)>100){t[b>>2]=0;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){v=37;break}}if(((t[o>>2]|0)+10|0)>(t[h>>2]|0)){if((t[h>>2]|0)>5e4?(t[(t[f>>2]|0)+360>>2]&524288|0)==0:0){v=41;break}t[h>>2]=t[h>>2]<<1;t[w>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[h>>2]|0)|0;if(!(t[w>>2]|0)){v=43;break}t[k>>2]=t[w>>2]}if((t[c>>2]|0)==1){m=t[l>>2]&255;e=t[o>>2]|0;t[o>>2]=e+1;n[(t[k>>2]|0)+e>>0]=m}else{m=Rp((t[k>>2]|0)+(t[o>>2]|0)|0,t[l>>2]|0)|0;t[o>>2]=(t[o>>2]|0)+m}m=t[(t[f>>2]|0)+36>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=m+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{e=m+32|0;t[e>>2]=(t[e>>2]|0)+1}e=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[c>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);t[l>>2]=Ap(t[f>>2]|0,c)|0}if((v|0)==37){pAi[t[135736>>2]&511](t[k>>2]|0);t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}else if((v|0)==41){AS(t[f>>2]|0,110,65696);pAi[t[135736>>2]&511](t[k>>2]|0);t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}else if((v|0)==43){Sp(t[f>>2]|0,0);pAi[t[135736>>2]&511](t[k>>2]|0);t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}else if((v|0)==54){n[(t[k>>2]|0)+(t[o>>2]|0)>>0]=0;t[r>>2]=t[k>>2];d=t[r>>2]|0;s=i;return d|0}}else if((v|0)==55){if(!(t[o>>2]|0)){t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}if((t[o>>2]|0)>5e4?(t[(t[f>>2]|0)+360>>2]&524288|0)==0:0){AS(t[f>>2]|0,110,65696);t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}t[r>>2]=ql(a,t[o>>2]|0)|0;d=t[r>>2]|0;s=i;return d|0}return 0}function vE(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;r=s;s=s+64|0;f=r+48|0;a=r+44|0;o=r+40|0;c=r+36|0;l=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+53|0;d=r+16|0;v=r+12|0;m=r+8|0;_=r+4|0;p=r;E=r+52|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=0;t[l>>2]=0;t[b>>2]=100;t[d>>2]=0;t[v>>2]=0;do if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34)n[w>>0]=34;else{if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39){n[w>>0]=39;break}AS(t[a>>2]|0,36,0);t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}while(0);t[c>>2]=gAi[t[135752>>2]&511](t[b>>2]|0)|0;i=t[a>>2]|0;if(!(t[c>>2]|0)){Sp(i,0);t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}t[i+172>>2]=11;t[m>>2]=t[(t[a>>2]|0)+36>>2];if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);if((t[(t[a>>2]|0)+172>>2]|0)==-1){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}Op(t[a>>2]|0);t[k>>2]=Ap(t[a>>2]|0,h)|0;while(1){i=t[k>>2]|0;if((t[k>>2]|0)<256)if(9<=(i|0)&(t[k>>2]|0)<=10|(t[k>>2]|0)==13|32<=(t[k>>2]|0))g=19;else y=0;else if((!(256<=(i|0)&(t[k>>2]|0)<=55295)?!(57344<=(t[k>>2]|0)&(t[k>>2]|0)<=65533):0)?!(65536<=(t[k>>2]|0)&(t[k>>2]|0)<=1114111):0)y=0;else g=19;do if((g|0)==19){g=0;if((t[k>>2]|0)==(u[w>>0]|0|0)?(t[(t[a>>2]|0)+36>>2]|0)==(t[m>>2]|0):0){y=0;break}y=(t[(t[a>>2]|0)+172>>2]|0)!=-1}while(0);F=t[l>>2]|0;if(!y)break;if((F+5|0)>=(t[b>>2]|0)){t[b>>2]=t[b>>2]<<1;t[_>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[b>>2]|0)|0;if(!(t[_>>2]|0)){g=25;break}t[c>>2]=t[_>>2]}if((t[h>>2]|0)==1){i=t[k>>2]&255;e=t[l>>2]|0;t[l>>2]=e+1;n[(t[c>>2]|0)+e>>0]=i}else{i=Rp((t[c>>2]|0)+(t[l>>2]|0)|0,t[k>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+i}i=t[(t[a>>2]|0)+36>>2]|0;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=i+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[a>>2]|0)+36>>2]|0)+32>>2]=1}else{e=i+32|0;t[e>>2]=(t[e>>2]|0)+1}e=(t[(t[a>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[h>>2]|0);if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[a>>2]|0);while(1){if(!(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0))O=(t[(t[a>>2]|0)+40>>2]|0)>1;else O=0;A=t[a>>2]|0;if(!O)break;aE(A)|0}if((t[A+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);t[k>>2]=Ap(t[a>>2]|0,h)|0;if(t[k>>2]|0)continue;if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);t[k>>2]=Ap(t[a>>2]|0,h)|0}if((g|0)==25){Sp(t[a>>2]|0,0);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}n[(t[c>>2]|0)+F>>0]=0;if((t[(t[a>>2]|0)+172>>2]|0)==-1){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}t[v>>2]=t[c>>2];while(1){if(!(u[t[v>>2]>>0]|0))break;if((u[t[v>>2]>>0]|0|0)!=37){if((u[t[v>>2]>>0]|0|0)==38?(u[(t[v>>2]|0)+1>>0]|0|0)!=35:0)g=54}else g=54;if((g|0)==54){g=0;n[E>>0]=n[t[v>>2]>>0]|0;t[v>>2]=(t[v>>2]|0)+1;t[p>>2]=jS(t[a>>2]|0,v)|0;if(!((t[p>>2]|0)!=0?(u[t[v>>2]>>0]|0|0)==59:0))OS(t[a>>2]|0,87,65704,u[E>>0]|0);if(((u[E>>0]|0|0)==37?(t[(t[a>>2]|0)+216>>2]|0)==1:0)?(t[(t[a>>2]|0)+40>>2]|0)==1:0)AS(t[a>>2]|0,88,0);if(t[p>>2]|0)pAi[t[135736>>2]&511](t[p>>2]|0);if(!(u[t[v>>2]>>0]|0))break}t[v>>2]=(t[v>>2]|0)+1}v=t[a>>2]|0;do if((t[k>>2]|0)==(u[w>>0]|0|0)){Op(v);t[d>>2]=hE(t[a>>2]|0,t[c>>2]|0,2,0,0,0)|0;if(t[o>>2]|0){t[t[o>>2]>>2]=t[c>>2];break}else{pAi[t[135736>>2]&511](t[c>>2]|0);break}}else{AS(v,37,0);pAi[t[135736>>2]&511](t[c>>2]|0)}while(0);t[f>>2]=t[d>>2];S=t[f>>2]|0;s=r;return S|0}function mE(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+36>>2]|0)!=0:0){t[r>>2]=VS(t[n>>2]|0,0,0,0)|0;f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function _E(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;i=s;s=s+48|0;r=i+36|0;f=i+32|0;a=i+28|0;o=i+24|0;c=i+20|0;l=i+16|0;b=i+12|0;k=i+40|0;h=i+8|0;w=i+4|0;d=i;t[f>>2]=e;t[a>>2]=0;t[o>>2]=0;t[c>>2]=100;t[h>>2]=t[(t[f>>2]|0)+172>>2];t[w>>2]=0;if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);e=t[f>>2]|0;do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){Op(e);n[k>>0]=34}else{v=t[f>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)==39){Op(v);n[k>>0]=39;break}AS(v,43,0);t[r>>2]=0;m=t[r>>2]|0;s=i;return m|0}while(0);t[a>>2]=gAi[t[135752>>2]&511](t[c>>2]|0)|0;e=t[f>>2]|0;if(!(t[a>>2]|0)){Sp(e,0);t[r>>2]=0;m=t[r>>2]|0;s=i;return m|0}t[e+172>>2]=13;t[l>>2]=Ap(t[f>>2]|0,b)|0;while(1){e=t[l>>2]|0;if((t[l>>2]|0)<256)if(9<=(e|0)&(t[l>>2]|0)<=10|(t[l>>2]|0)==13|32<=(t[l>>2]|0))_=18;else p=0;else if((!(256<=(e|0)&(t[l>>2]|0)<=55295)?!(57344<=(t[l>>2]|0)&(t[l>>2]|0)<=65533):0)?!(65536<=(t[l>>2]|0)&(t[l>>2]|0)<=1114111):0)p=0;else _=18;if((_|0)==18){_=0;p=(t[l>>2]|0)!=(u[k>>0]|0|0)}E=t[o>>2]|0;if(!p){_=50;break}if((E+5|0)>=(t[c>>2]|0)){if((t[c>>2]|0)>5e4?(t[(t[f>>2]|0)+360>>2]&524288|0)==0:0){_=23;break}t[c>>2]=t[c>>2]<<1;t[d>>2]=MAi[t[135760>>2]&511](t[a>>2]|0,t[c>>2]|0)|0;if(!(t[d>>2]|0)){_=25;break}t[a>>2]=t[d>>2]}t[w>>2]=(t[w>>2]|0)+1;if((t[w>>2]|0)>50){if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);t[w>>2]=0;if((t[(t[f>>2]|0)+172>>2]|0)==-1){_=32;break}}if((t[b>>2]|0)==1){e=t[l>>2]&255;v=t[o>>2]|0;t[o>>2]=v+1;n[(t[a>>2]|0)+v>>0]=e}else{e=Rp((t[a>>2]|0)+(t[o>>2]|0)|0,t[l>>2]|0)|0;t[o>>2]=(t[o>>2]|0)+e}e=t[(t[f>>2]|0)+36>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){v=e+28|0;t[v>>2]=(t[v>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{v=e+32|0;t[v>>2]=(t[v>>2]|0)+1}v=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[v>>2]=(t[v>>2]|0)+(t[b>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);t[l>>2]=Ap(t[f>>2]|0,b)|0;if(t[l>>2]|0)continue;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);t[l>>2]=Ap(t[f>>2]|0,b)|0}if((_|0)==23){AS(t[f>>2]|0,110,65768);pAi[t[135736>>2]&511](t[a>>2]|0);t[(t[f>>2]|0)+172>>2]=t[h>>2];t[r>>2]=0;m=t[r>>2]|0;s=i;return m|0}else if((_|0)==25){pAi[t[135736>>2]&511](t[a>>2]|0);Sp(t[f>>2]|0,0);t[(t[f>>2]|0)+172>>2]=t[h>>2];t[r>>2]=0;m=t[r>>2]|0;s=i;return m|0}else if((_|0)==32){pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;m=t[r>>2]|0;s=i;return m|0}else if((_|0)==50){n[(t[a>>2]|0)+E>>0]=0;t[(t[f>>2]|0)+172>>2]=t[h>>2];h=t[l>>2]|0;if((t[l>>2]|0)<256)if(9<=(h|0)&(t[l>>2]|0)<=10|(t[l>>2]|0)==13|32<=(t[l>>2]|0))_=56;else _=55;else if((!(256<=(h|0)&(t[l>>2]|0)<=55295)?!(57344<=(t[l>>2]|0)&(t[l>>2]|0)<=65533):0)?!(65536<=(t[l>>2]|0)&(t[l>>2]|0)<=1114111):0)_=55;else _=56;if((_|0)==55)AS(t[f>>2]|0,44,0);else if((_|0)==56)Op(t[f>>2]|0);t[r>>2]=t[a>>2];m=t[r>>2]|0;s=i;return m|0}return 0}function pE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;i=s;s=s+48|0;r=i+28|0;f=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+33|0;b=i+32|0;k=i+8|0;h=i+4|0;w=i;t[f>>2]=e;t[a>>2]=0;t[o>>2]=0;t[c>>2]=100;t[k>>2]=0;t[h>>2]=t[(t[f>>2]|0)+172>>2];if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);e=t[f>>2]|0;do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){Op(e);n[b>>0]=34}else{d=t[f>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)==39){Op(d);n[b>>0]=39;break}AS(d,43,0);t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}while(0);t[a>>2]=gAi[t[135752>>2]&511](t[c>>2]|0)|0;e=t[f>>2]|0;if(!(t[a>>2]|0)){Sp(e,0);t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}t[e+172>>2]=16;n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;while(1){if(u[198696+(u[l>>0]|0)>>0]|0)m=(u[l>>0]|0|0)!=(u[b>>0]|0|0);else m=0;_=t[o>>2]|0;if(!m){p=38;break}if((_+1|0)>=(t[c>>2]|0)){if((t[c>>2]|0)>5e4?(t[(t[f>>2]|0)+360>>2]&524288|0)==0:0){p=19;break}t[c>>2]=t[c>>2]<<1;t[w>>2]=MAi[t[135760>>2]&511](t[a>>2]|0,t[c>>2]|0)|0;if(!(t[w>>2]|0)){p=21;break}t[a>>2]=t[w>>2]}e=n[l>>0]|0;d=t[o>>2]|0;t[o>>2]=d+1;n[(t[a>>2]|0)+d>>0]=e;t[k>>2]=(t[k>>2]|0)+1;if((t[k>>2]|0)>50){if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);t[k>>2]=0;if((t[(t[f>>2]|0)+172>>2]|0)==-1){p=28;break}}Op(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if(u[l>>0]|0)continue;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0}if((p|0)==19){AS(t[f>>2]|0,110,65784);pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}else if((p|0)==21){Sp(t[f>>2]|0,0);pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}else if((p|0)==28){pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}else if((p|0)==38){n[(t[a>>2]|0)+_>>0]=0;_=t[f>>2]|0;if((u[l>>0]|0|0)!=(u[b>>0]|0|0))AS(_,44,0);else Op(_);t[(t[f>>2]|0)+172>>2]=t[h>>2];t[r>>2]=t[a>>2];v=t[r>>2]|0;s=i;return v|0}return 0}function EE(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;f=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=0;t[l>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2];t[b>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2];if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);do if(!(t[a>>2]|0)){t[o>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2];e:while(1){i=t[o>>2]|0;if((u[t[o>>2]>>0]|0)==32){t[o>>2]=i+1;e=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1;continue}if((u[i>>0]|0)==10)while(1){i=(t[(t[f>>2]|0)+36>>2]|0)+28|0;t[i>>2]=(t[i>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1;t[o>>2]=(t[o>>2]|0)+1;if((u[t[o>>2]>>0]|0)!=10)continue e}if((u[t[o>>2]>>0]|0)==60){d=15;break}i:while(1){t[k>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2];while(1){if(!(n[65800+(u[t[o>>2]>>0]|0)>>0]|0))break;t[o>>2]=(t[o>>2]|0)+1;t[k>>2]=(t[k>>2]|0)+1}t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=t[k>>2];if((u[t[o>>2]>>0]|0)==10)while(1){i=(t[(t[f>>2]|0)+36>>2]|0)+28|0;t[i>>2]=(t[i>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1;t[o>>2]=(t[o>>2]|0)+1;if((u[t[o>>2]>>0]|0)!=10)continue i}v=t[o>>2]|0;if((u[t[o>>2]>>0]|0)!=93)break;if((u[v+1>>0]|0)==93?(u[(t[o>>2]|0)+2>>0]|0)==62:0){d=36;break e}t[o>>2]=(t[o>>2]|0)+1;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+1}t[c>>2]=v-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0);if((t[c>>2]|0)>0){i:do if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+72>>2]|0)!=(t[(t[t[f>>2]>>2]|0)+68>>2]|0):0){do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=32){if(9<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)<=10:0)break;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=13){d=53;break i}}while(0);t[w>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2];t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]=t[o>>2];i=(YS(t[f>>2]|0,t[w>>2]|0,t[c>>2]|0,0)|0)!=0;e=t[t[f>>2]>>2]|0;if(i){if(t[e+72>>2]|0)yAi[t[(t[t[f>>2]>>2]|0)+72>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[w>>2]|0,t[c>>2]|0)}else{if(t[e+68>>2]|0)yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[w>>2]|0,t[c>>2]|0);if((t[t[(t[f>>2]|0)+232>>2]>>2]|0)==-1)t[t[(t[f>>2]|0)+232>>2]>>2]=-2}t[l>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2];t[b>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]}else d=53;while(0);if((d|0)==53?(d=0,(t[t[f>>2]>>2]|0)!=0):0){if(t[(t[t[f>>2]>>2]|0)+68>>2]|0)yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0,t[c>>2]|0);t[l>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2];t[b>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]}if((t[(t[f>>2]|0)+172>>2]|0)!=7){d=78;break}}t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]=t[o>>2];do if((u[t[o>>2]>>0]|0)==13){t[o>>2]=(t[o>>2]|0)+1;e=t[o>>2]|0;if((u[t[o>>2]>>0]|0)==10){t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]=e;t[o>>2]=(t[o>>2]|0)+1;i=(t[(t[f>>2]|0)+36>>2]|0)+28|0;t[i>>2]=(t[i>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1;break}else{t[o>>2]=e+-1;d=62;break}}else d=62;while(0);if((d|0)==62){d=0;if((u[t[o>>2]>>0]|0)==60){d=78;break}if((u[t[o>>2]>>0]|0)==38){d=78;break}if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){d=78;break}t[o>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]}if((u[t[o>>2]>>0]|0)>=32?(u[t[o>>2]>>0]|0)<=127:0)continue;if((u[t[o>>2]>>0]|0)!=9){d=76;break}}if((d|0)==15){t[c>>2]=(t[o>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0);if((t[c>>2]|0)<=0){s=r;return}t[h>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2];t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]=t[o>>2];if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+72>>2]|0)!=(t[(t[t[f>>2]>>2]|0)+68>>2]|0):0){e=(YS(t[f>>2]|0,t[h>>2]|0,t[c>>2]|0,1)|0)!=0;i=t[t[f>>2]>>2]|0;if(e){if(!(t[i+72>>2]|0)){s=r;return}yAi[t[(t[t[f>>2]>>2]|0)+72>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[h>>2]|0,t[c>>2]|0);s=r;return}if(t[i+68>>2]|0)yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[h>>2]|0,t[c>>2]|0);if((t[t[(t[f>>2]|0)+232>>2]>>2]|0)!=-1){s=r;return}t[t[(t[f>>2]|0)+232>>2]>>2]=-2;s=r;return}if(!(t[t[f>>2]>>2]|0)){s=r;return}if(!(t[(t[t[f>>2]>>2]|0)+68>>2]|0)){s=r;return}yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[h>>2]|0,t[c>>2]|0);s=r;return}else if((d|0)==36){AS(t[f>>2]|0,62,0);t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]=t[o>>2];s=r;return}else if((d|0)==76){t[c>>2]=0;break}else if((d|0)==78){s=r;return}}while(0);t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2]=t[l>>2];t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=t[b>>2];GS(t[f>>2]|0,t[a>>2]|0);s=r;return}function SE(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+32|0;f=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;if(((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[a>>2]|0);t[t[o>>2]>>2]=0;if((((((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==83?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==89:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==83:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==84:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==69:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==77:0){r=(t[a>>2]|0)+200|0;t[r>>2]=(t[r>>2]|0)+6;r=(t[(t[a>>2]|0)+36>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+6;r=(t[(t[a>>2]|0)+36>>2]|0)+32|0;t[r>>2]=(t[r>>2]|0)+6;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[a>>2]|0);if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[a>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[a>>2]|0)|0;do if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[a>>2]|0,65,66056)}while(0);uE(t[a>>2]|0)|0;t[l>>2]=_E(t[a>>2]|0)|0;if(!(t[l>>2]|0))AS(t[a>>2]|0,70,0)}else k=23;if(((((((k|0)==23?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==80:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==85:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==66:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==73:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==67:0){k=(t[a>>2]|0)+200|0;t[k>>2]=(t[k>>2]|0)+6;k=(t[(t[a>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+6;k=(t[(t[a>>2]|0)+36>>2]|0)+32|0;t[k>>2]=(t[k>>2]|0)+6;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[a>>2]|0);if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[a>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[a>>2]|0)|0;do if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[a>>2]|0,65,66088)}while(0);uE(t[a>>2]|0)|0;k=pE(t[a>>2]|0)|0;t[t[o>>2]>>2]=k;if(!(t[t[o>>2]>>2]|0))AS(t[a>>2]|0,71,0);o=t[a>>2]|0;do if(t[c>>2]|0){if((u[t[(t[o+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[a>>2]|0,65,66120)}}else{if((t[o+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);t[b>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2];do if((u[t[b>>2]>>0]|0|0)!=32){if(9<=(u[t[b>>2]>>0]|0|0)?(u[t[b>>2]>>0]|0|0)<=10:0)break;if((u[t[b>>2]>>0]|0|0)!=13){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}}while(0);while(1){do if((u[t[b>>2]>>0]|0|0)==32)w=1;else{if(9<=(u[t[b>>2]>>0]|0|0)?(u[t[b>>2]>>0]|0|0)<=10:0){w=1;break}w=(u[t[b>>2]>>0]|0|0)==13}while(0);d=t[b>>2]|0;if(!w)break;t[b>>2]=d+1}if((u[d>>0]|0|0)!=39?(u[t[b>>2]>>0]|0|0)!=34:0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}}while(0);uE(t[a>>2]|0)|0;t[l>>2]=_E(t[a>>2]|0)|0;if(!(t[l>>2]|0))AS(t[a>>2]|0,70,0)}t[f>>2]=t[l>>2];h=t[f>>2]|0;s=n;return h|0}function gE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+48|0;r=i+36|0;f=i+32|0;a=i+28|0;o=i+24|0;c=i+20|0;l=i+16|0;b=i+12|0;k=i+8|0;h=i+4|0;w=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=100;t[o>>2]=0;t[b>>2]=0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=45){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=45){s=i;return}t[c>>2]=t[(t[r>>2]|0)+172>>2];t[(t[r>>2]|0)+172>>2]=5;t[h>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+56>>2];e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+4;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+4;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+4;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;if(((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[r>>2]|0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);t[l>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];e:while(1){if((u[t[l>>2]>>0]|0|0)==10)do{e=(t[(t[r>>2]|0)+36>>2]|0)+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1;t[l>>2]=(t[l>>2]|0)+1}while((u[t[l>>2]>>0]|0|0)==10);
	i:while(1){t[k>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2];r:while(1){if(!((u[t[l>>2]>>0]|0|0)>45?(u[t[l>>2]>>0]|0|0)<=127:0))d=23;do if((d|0)==23){d=0;if((u[t[l>>2]>>0]|0|0)>=32?(u[t[l>>2]>>0]|0|0)<45:0)break;if((u[t[l>>2]>>0]|0|0)!=9)break r}while(0);t[l>>2]=(t[l>>2]|0)+1;t[k>>2]=(t[k>>2]|0)+1}t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=t[k>>2];if((u[t[l>>2]>>0]|0|0)==10)while(1){e=(t[(t[r>>2]|0)+36>>2]|0)+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1;t[l>>2]=(t[l>>2]|0)+1;if((u[t[l>>2]>>0]|0|0)!=10)continue i}t[b>>2]=(t[l>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0);if(((t[b>>2]|0)>>>0>0?(t[t[r>>2]>>2]|0)!=0:0)?(t[(t[t[r>>2]>>2]|0)+80>>2]|0)!=0:0){if(t[f>>2]|0){if(((t[o>>2]|0)+(t[b>>2]|0)+1|0)>>>0>=(t[a>>2]|0)>>>0){t[a>>2]=(t[a>>2]|0)+((t[o>>2]|0)+(t[b>>2]|0)+100);t[w>>2]=MAi[t[135760>>2]&511](t[f>>2]|0,t[a>>2]|0)|0;if(!(t[w>>2]|0)){d=42;break e}t[f>>2]=t[w>>2]}}else{do if((u[t[l>>2]>>0]|0|0)==45){if((u[(t[l>>2]|0)+1>>0]|0|0)!=45){d=36;break}t[a>>2]=(t[b>>2]|0)+1}else d=36;while(0);if((d|0)==36){d=0;t[a>>2]=100+(t[b>>2]|0)}t[f>>2]=gAi[t[135752>>2]&511](t[a>>2]|0)|0;if(!(t[f>>2]|0)){d=38;break e}t[o>>2]=0}YY((t[f>>2]|0)+(t[o>>2]|0)|0,t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0,t[b>>2]|0)|0;t[o>>2]=(t[o>>2]|0)+(t[b>>2]|0);n[(t[f>>2]|0)+(t[o>>2]|0)>>0]=0}if((t[o>>2]|0)>>>0>1e7?(t[(t[r>>2]|0)+360>>2]&524288|0)==0:0){d=47;break e}t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]=t[l>>2];if((u[t[l>>2]>>0]|0|0)==10){t[l>>2]=(t[l>>2]|0)+1;e=(t[(t[r>>2]|0)+36>>2]|0)+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}if((u[t[l>>2]>>0]|0|0)==13){t[l>>2]=(t[l>>2]|0)+1;v=t[l>>2]|0;if((u[t[l>>2]>>0]|0|0)==10){d=52;break}t[l>>2]=v+-1}if(((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[r>>2]|0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){d=62;break e}t[l>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];if((u[t[l>>2]>>0]|0|0)!=45)break;if((u[(t[l>>2]|0)+1>>0]|0|0)==45){if((u[(t[l>>2]|0)+2>>0]|0|0)==62){d=66;break e}e=t[r>>2]|0;if(t[f>>2]|0)MS(e,80,66248,t[f>>2]|0);else MS(e,80,66296,0);t[l>>2]=(t[l>>2]|0)+1;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1}t[l>>2]=(t[l>>2]|0)+1;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1}if((d|0)==52){d=0;t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]=v;t[l>>2]=(t[l>>2]|0)+1;e=(t[(t[r>>2]|0)+36>>2]|0)+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}if((u[t[l>>2]>>0]|0|0)>=32?(u[t[l>>2]>>0]|0|0)<=127:0)continue;if((u[t[l>>2]>>0]|0|0)!=9){d=91;break}}if((d|0)==38){Sp(t[r>>2]|0,0);t[(t[r>>2]|0)+172>>2]=t[c>>2];s=i;return}else if((d|0)==42){pAi[t[135736>>2]&511](t[f>>2]|0);Sp(t[r>>2]|0,0);t[(t[r>>2]|0)+172>>2]=t[c>>2];s=i;return}else if((d|0)==47){MS(t[r>>2]|0,45,66168,0);pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}else if((d|0)==62){pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}else if((d|0)==66){if((t[(t[(t[r>>2]|0)+36>>2]|0)+56>>2]|0)!=(t[h>>2]|0))BS(t[r>>2]|0,90,66192);h=(t[r>>2]|0)+200|0;t[h>>2]=(t[h>>2]|0)+3;h=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[h>>2]=(t[h>>2]|0)+3;h=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[h>>2]=(t[h>>2]|0)+3;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;do if(((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+80>>2]|0)!=0:0)?(t[(t[r>>2]|0)+212>>2]|0)==0:0){h=t[(t[t[r>>2]>>2]|0)+80>>2]|0;l=t[(t[r>>2]|0)+4>>2]|0;if(t[f>>2]|0){EAi[h&511](l,t[f>>2]|0);break}else{EAi[h&511](l,65640);break}}while(0);if(t[f>>2]|0)pAi[t[135736>>2]&511](t[f>>2]|0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}t[(t[r>>2]|0)+172>>2]=t[c>>2];s=i;return}else if((d|0)==91){WS(t[r>>2]|0,t[f>>2]|0,t[o>>2]|0,t[a>>2]|0);t[(t[r>>2]|0)+172>>2]=t[c>>2];s=i;return}}function yE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[f>>2]=sE(t[n>>2]|0)|0;do if(t[f>>2]|0){if((u[t[f>>2]>>0]|0|0)!=120?(u[t[f>>2]>>0]|0|0)!=88:0)break;if((u[(t[f>>2]|0)+1>>0]|0|0)!=109?(u[(t[f>>2]|0)+1>>0]|0|0)!=77:0)break;if((u[(t[f>>2]|0)+2>>0]|0|0)!=108?(u[(t[f>>2]|0)+2>>0]|0|0)!=76:0)break;if((((u[t[f>>2]>>0]|0|0)==120?(u[(t[f>>2]|0)+1>>0]|0|0)==109:0)?(u[(t[f>>2]|0)+2>>0]|0|0)==108:0)?(u[(t[f>>2]|0)+3>>0]|0|0)==0:0){BS(t[n>>2]|0,64,66328);t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}if(!(u[(t[f>>2]|0)+3>>0]|0)){AS(t[n>>2]|0,64,0);t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}t[a>>2]=0;while(1){if(!(t[66392+(t[a>>2]<<2)>>2]|0)){c=20;break}if(Xl(t[f>>2]|0,t[66392+(t[a>>2]<<2)>>2]|0)|0)break;t[a>>2]=(t[a>>2]|0)+1}if((c|0)==20){NS(t[n>>2]|0,64,66408,0,0);break}t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}while(0);if((t[f>>2]|0)!=0?(es(t[f>>2]|0,58)|0)!=0:0)KS(t[n>>2]|0,205,66456,t[f>>2]|0,0,0);t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}function FE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;i=s;s=s+64|0;r=i+48|0;f=i+44|0;a=i+40|0;o=i+36|0;c=i+32|0;l=i+28|0;b=i+24|0;k=i+20|0;h=i+16|0;w=i+12|0;d=i+8|0;v=i+4|0;m=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=0;t[o>>2]=100;t[h>>2]=0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=63){s=i;return}t[w>>2]=t[(t[r>>2]|0)+36>>2];t[k>>2]=t[(t[r>>2]|0)+172>>2];t[(t[r>>2]|0)+172>>2]=2;e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;if(((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[r>>2]|0);t[b>>2]=yE(t[r>>2]|0)|0;e=t[r>>2]|0;do if(t[b>>2]|0){if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)==63?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){if((t[w>>2]|0)!=(t[(t[r>>2]|0)+36>>2]|0))BS(t[r>>2]|0,90,66504);_=(t[r>>2]|0)+200|0;t[_>>2]=(t[_>>2]|0)+2;_=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[_>>2]=(t[_>>2]|0)+2;_=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[_>>2]=(t[_>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;if(((t[t[r>>2]>>2]|0)!=0?(t[(t[r>>2]|0)+212>>2]|0)==0:0)?(t[(t[t[r>>2]>>2]|0)+76>>2]|0)!=0:0)yAi[t[(t[t[r>>2]>>2]|0)+76>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[b>>2]|0,0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}t[f>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;_=t[r>>2]|0;if(!(t[f>>2]|0)){Sp(_,0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}t[c>>2]=u[t[(t[_+36>>2]|0)+16>>2]>>0];if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10|(t[c>>2]|0)==13):0)p=33}else p=33;if((p|0)==33)MS(t[r>>2]|0,65,66568,t[b>>2]|0);uE(t[r>>2]|0)|0;t[c>>2]=Ap(t[r>>2]|0,l)|0;while(1){_=t[c>>2]|0;if((t[c>>2]|0)<256)if(9<=(_|0)&(t[c>>2]|0)<=10|(t[c>>2]|0)==13|32<=(t[c>>2]|0))p=40;else E=0;else if((!(256<=(_|0)&(t[c>>2]|0)<=55295)?!(57344<=(t[c>>2]|0)&(t[c>>2]|0)<=65533):0)?!(65536<=(t[c>>2]|0)&(t[c>>2]|0)<=1114111):0)E=0;else p=40;if((p|0)==40){p=0;if((t[c>>2]|0)!=63)E=1;else E=(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=62}S=t[a>>2]|0;if(!E){p=73;break}if((S+5|0)>>>0>=(t[o>>2]|0)>>>0){t[v>>2]=t[o>>2]<<1;t[d>>2]=MAi[t[135760>>2]&511](t[f>>2]|0,t[v>>2]|0)|0;if(!(t[d>>2]|0)){p=45;break}t[f>>2]=t[d>>2];t[o>>2]=t[v>>2]}t[h>>2]=(t[h>>2]|0)+1;if((t[h>>2]|0)>50){if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){p=52;break}t[h>>2]=0;if((t[a>>2]|0)>>>0>1e7?(t[(t[r>>2]|0)+360>>2]&524288|0)==0:0){p=55;break}}if((t[l>>2]|0)==1){_=t[c>>2]&255;g=t[a>>2]|0;t[a>>2]=g+1;n[(t[f>>2]|0)+g>>0]=_}else{_=Rp((t[f>>2]|0)+(t[a>>2]|0)|0,t[c>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+_}_=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){g=_+28|0;t[g>>2]=(t[g>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{g=_+32|0;t[g>>2]=(t[g>>2]|0)+1}g=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[g>>2]=(t[g>>2]|0)+(t[l>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);t[c>>2]=Ap(t[r>>2]|0,l)|0;if(t[c>>2]|0)continue;do if(!(t[(t[r>>2]|0)+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)<=500)break;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=500)break;qS(t[r>>2]|0)}while(0);do if(!(t[(t[r>>2]|0)+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[r>>2]|0)}while(0);t[c>>2]=Ap(t[r>>2]|0,l)|0}if((p|0)==45){Sp(t[r>>2]|0,0);pAi[t[135736>>2]&511](t[f>>2]|0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}else if((p|0)==52){pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}else if((p|0)==55){MS(t[r>>2]|0,47,66600,t[b>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}else if((p|0)==73){if(S>>>0>1e7?(t[(t[r>>2]|0)+360>>2]&524288|0)==0:0){MS(t[r>>2]|0,47,66600,t[b>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}n[(t[f>>2]|0)+(t[a>>2]|0)>>0]=0;do if((t[c>>2]|0)==63){if((t[w>>2]|0)!=(t[(t[r>>2]|0)+36>>2]|0))BS(t[r>>2]|0,65,66504);g=(t[r>>2]|0)+200|0;t[g>>2]=(t[g>>2]|0)+2;g=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[g>>2]=(t[g>>2]|0)+2;g=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[g>>2]=(t[g>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;do if((t[k>>2]|0)==1|(t[k>>2]|0)==0?(Xl(t[b>>2]|0,66656)|0)!=0:0){t[m>>2]=sc()|0;if(!((t[m>>2]|0)==2|(t[m>>2]|0)==3))break;XS(t[r>>2]|0,t[f>>2]|0)}while(0);if((t[t[r>>2]>>2]|0)!=0?(t[(t[r>>2]|0)+212>>2]|0)==0:0){if(!(t[(t[t[r>>2]>>2]|0)+76>>2]|0))break;yAi[t[(t[t[r>>2]>>2]|0)+76>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[b>>2]|0,t[f>>2]|0)}}else MS(t[r>>2]|0,47,66624,t[b>>2]|0);while(0);pAi[t[135736>>2]&511](t[f>>2]|0);break}}else AS(e,46,0);while(0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}function OE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[r>>2]=e;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=78){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=79){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=65){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=73){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=79){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+9>>0]|0|0)!=78){s=i;return}t[o>>2]=t[(t[r>>2]|0)+36>>2];if(((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[r>>2]|0);e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+10;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+10;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+10;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){BS(t[r>>2]|0,65,66680);s=i;return}}while(0);uE(t[r>>2]|0)|0;t[n>>2]=sE(t[r>>2]|0)|0;e=t[r>>2]|0;if(!(t[n>>2]|0)){AS(e,48,0);s=i;return}do if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){BS(t[r>>2]|0,65,66720);s=i;return}}while(0);if(es(t[n>>2]|0,58)|0)KS(t[r>>2]|0,205,66768,t[n>>2]|0,0,0);uE(t[r>>2]|0)|0;t[a>>2]=SE(t[r>>2]|0,f,0)|0;uE(t[r>>2]|0)|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){if((t[o>>2]|0)!=(t[(t[r>>2]|0)+36>>2]|0))BS(t[r>>2]|0,65,66816);Op(t[r>>2]|0);if(!(t[t[r>>2]>>2]|0))break;if(t[(t[r>>2]|0)+212>>2]|0)break;if(!(t[(t[t[r>>2]>>2]|0)+28>>2]|0))break;NAi[t[(t[t[r>>2]>>2]|0)+28>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,t[f>>2]|0,t[a>>2]|0)}else AS(t[r>>2]|0,49,0);while(0);if(t[a>>2]|0)pAi[t[135736>>2]&511](t[a>>2]|0);if(!(t[f>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}function AE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+64|0;r=i+48|0;n=i+44|0;f=i+40|0;a=i+36|0;o=i+32|0;c=i+28|0;l=i+24|0;b=i+20|0;k=i+16|0;h=i+12|0;w=i+8|0;d=i+4|0;v=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;t[l>>2]=0;t[b>>2]=0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=69){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=78){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=73){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=89){s=i;return}t[h>>2]=t[(t[r>>2]|0)+36>>2];if(((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[r>>2]|0);e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+8;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+8;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+8;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;t[k>>2]=uE(t[r>>2]|0)|0;if(!(t[k>>2]|0))BS(t[r>>2]|0,65,66880);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37){Op(t[r>>2]|0);t[k>>2]=uE(t[r>>2]|0)|0;if(!(t[k>>2]|0))BS(t[r>>2]|0,65,66920);t[l>>2]=1}t[n>>2]=sE(t[r>>2]|0)|0;if(!(t[n>>2]|0)){BS(t[r>>2]|0,68,66952);s=i;return}if(es(t[n>>2]|0,58)|0)KS(t[r>>2]|0,205,66984,t[n>>2]|0,0,0);t[k>>2]=uE(t[r>>2]|0)|0;if(!(t[k>>2]|0))BS(t[r>>2]|0,65,67032);t[(t[r>>2]|0)+172>>2]=10;k=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34;e:do if(t[l>>2]|0){do if(!k){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39)break;t[a>>2]=SE(t[r>>2]|0,o,1)|0;if((t[a>>2]|0)==0&(t[o>>2]|0)==0)AS(t[r>>2]|0,84,0);if(!(t[a>>2]|0))break e;t[w>>2]=IA(t[a>>2]|0)|0;if(!(t[w>>2]|0)){ZS(t[r>>2]|0,91,67072,t[a>>2]|0);break e}e=t[r>>2]|0;do if(t[(t[w>>2]|0)+32>>2]|0)AS(e,92,0);else{if(!(t[e>>2]|0))break;if(t[(t[r>>2]|0)+212>>2]|0)break;if(!(t[(t[t[r>>2]>>2]|0)+24>>2]|0))break;AAi[t[(t[t[r>>2]>>2]|0)+24>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,5,t[o>>2]|0,t[a>>2]|0,0)}while(0);xA(t[w>>2]|0);break e}while(0);t[f>>2]=vE(t[r>>2]|0,b)|0;if(t[f>>2]|0){if(!(t[t[r>>2]>>2]|0))break;if(t[(t[r>>2]|0)+212>>2]|0)break;if(!(t[(t[t[r>>2]>>2]|0)+24>>2]|0))break;AAi[t[(t[t[r>>2]>>2]|0)+24>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,4,0,0,t[f>>2]|0)}}else{do if(!k){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39)break;t[a>>2]=SE(t[r>>2]|0,o,1)|0;if((t[a>>2]|0)==0&(t[o>>2]|0)==0)AS(t[r>>2]|0,84,0);do if(t[a>>2]|0){t[d>>2]=IA(t[a>>2]|0)|0;if(!(t[d>>2]|0)){ZS(t[r>>2]|0,91,67072,t[a>>2]|0);break}if(t[(t[d>>2]|0)+32>>2]|0)AS(t[r>>2]|0,92,0);xA(t[d>>2]|0)}while(0);do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==32)break;if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;BS(t[r>>2]|0,65,67152)}while(0);uE(t[r>>2]|0)|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78){if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=68)break;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=65)break;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=84)break;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=65)break;e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+5;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);do if(!(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[r>>2]|0)|0}while(0);do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;BS(t[r>>2]|0,65,67184)}while(0);uE(t[r>>2]|0)|0;t[c>>2]=sE(t[r>>2]|0)|0;if(!(t[t[r>>2]>>2]|0))break e;if(t[(t[r>>2]|0)+212>>2]|0)break e;if(!(t[(t[t[r>>2]>>2]|0)+40>>2]|0))break e;mAi[t[(t[t[r>>2]>>2]|0)+40>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,t[o>>2]|0,t[a>>2]|0,t[c>>2]|0);break e}while(0);do if(t[t[r>>2]>>2]|0){if(t[(t[r>>2]|0)+212>>2]|0)break;if(!(t[(t[t[r>>2]>>2]|0)+24>>2]|0))break;AAi[t[(t[t[r>>2]>>2]|0)+24>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,2,t[o>>2]|0,t[a>>2]|0,0)}while(0);if(!(t[(t[r>>2]|0)+16>>2]|0))break e;if((t[(t[r>>2]|0)+8>>2]|0)!=0?(Xl(t[(t[(t[r>>2]|0)+8>>2]|0)+56>>2]|0,67096)|0)==0:0)break e;do if(!(t[(t[r>>2]|0)+8>>2]|0)){e=ny(67096)|0;t[(t[r>>2]|0)+8>>2]=e;e=t[r>>2]|0;if(t[(t[r>>2]|0)+8>>2]|0){t[(t[e+8>>2]|0)+92>>2]=64;break}Sp(e,67128);s=i;return}while(0);if(!(t[(t[(t[r>>2]|0)+8>>2]|0)+44>>2]|0)){e=Jg(t[(t[r>>2]|0)+8>>2]|0,67144,0,0)|0;t[(t[(t[r>>2]|0)+8>>2]|0)+44>>2]=e}Bz(t[r>>2]|0,t[n>>2]|0,2,t[o>>2]|0,t[a>>2]|0,0);break e}while(0);t[f>>2]=vE(t[r>>2]|0,b)|0;do if(t[t[r>>2]>>2]|0){if(t[(t[r>>2]|0)+212>>2]|0)break;if(!(t[(t[t[r>>2]>>2]|0)+24>>2]|0))break;AAi[t[(t[t[r>>2]>>2]|0)+24>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,1,0,0,t[f>>2]|0)}while(0);if((t[(t[r>>2]|0)+8>>2]|0)!=0?(Xl(t[(t[(t[r>>2]|0)+8>>2]|0)+56>>2]|0,67096)|0)==0:0)break;do if(!(t[(t[r>>2]|0)+8>>2]|0)){e=ny(67096)|0;t[(t[r>>2]|0)+8>>2]=e;e=t[r>>2]|0;if(t[(t[r>>2]|0)+8>>2]|0){t[(t[e+8>>2]|0)+92>>2]=64;break}Sp(e,67128);s=i;return}while(0);if(!(t[(t[(t[r>>2]|0)+8>>2]|0)+44>>2]|0)){e=Jg(t[(t[r>>2]|0)+8>>2]|0,67144,0,0)|0;t[(t[(t[r>>2]|0)+8>>2]|0)+44>>2]=e}Bz(t[r>>2]|0,t[n>>2]|0,1,0,0,t[f>>2]|0)}while(0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}uE(t[r>>2]|0)|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)MS(t[r>>2]|0,37,67216,t[n>>2]|0);else{if((t[h>>2]|0)!=(t[(t[r>>2]|0)+36>>2]|0))BS(t[r>>2]|0,90,67264);Op(t[r>>2]|0)}do if(t[b>>2]|0){t[v>>2]=0;h=(t[t[r>>2]>>2]|0)!=0;do if(t[l>>2]|0){if(!h)break;if(!(t[(t[t[r>>2]>>2]|0)+96>>2]|0))break;t[v>>2]=MAi[t[(t[t[r>>2]>>2]|0)+96>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0)|0}else{do if(h){if(!(t[(t[t[r>>2]>>2]|0)+20>>2]|0))break;t[v>>2]=MAi[t[(t[t[r>>2]>>2]|0)+20>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0)|0}while(0);if(t[v>>2]|0)break;if((t[(t[r>>2]|0)+4>>2]|0)!=(t[r>>2]|0))break;t[v>>2]=Cz(t[r>>2]|0,t[n>>2]|0)|0}while(0);if(!(t[v>>2]|0)){pAi[t[135736>>2]&511](t[b>>2]|0);break}if(t[(t[v>>2]|0)+36>>2]|0){pAi[t[135736>>2]&511](t[b>>2]|0);break}else{t[(t[v>>2]|0)+36>>2]=t[b>>2];break}}while(0);if(t[f>>2]|0)pAi[t[135736>>2]&511](t[f>>2]|0);if(t[a>>2]|0)pAi[t[135736>>2]&511](t[a>>2]|0);if(!(t[o>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[o>>2]|0);s=i;return}function ME(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[t[a>>2]>>2]=0;if(((((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==82:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==81:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==85:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==82:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==68:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+9;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+9;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+9;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=2;l=t[n>>2]|0;s=r;return l|0}if((((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==77:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==80:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==76:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==68:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+8;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=3;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=1;if((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==70:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==88:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==68:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+6;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[o>>2]=4;do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[f>>2]|0,65,67328)}while(0);uE(t[f>>2]|0)|0}t[c>>2]=mE(t[f>>2]|0)|0;t[(t[f>>2]|0)+172>>2]=3;if(!(t[c>>2]|0))BS(t[f>>2]|0,t[(t[f>>2]|0)+84>>2]|0,67360);else t[t[a>>2]>>2]=t[c>>2];t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}function RE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[n>>2]=e;t[a>>2]=0;t[o>>2]=0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){AS(e,48,0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}if(((t[e+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[n>>2]|0);e:while(1){Op(t[n>>2]|0);uE(t[n>>2]|0)|0;t[f>>2]=sE(t[n>>2]|0)|0;if(!(t[f>>2]|0)){k=8;break}t[l>>2]=t[a>>2];while(1){if(!(t[l>>2]|0))break;if(Xl(t[f>>2]|0,t[(t[l>>2]|0)+4>>2]|0)|0){k=12;break}t[l>>2]=t[t[l>>2]>>2]}if((k|0)==12?(k=0,RS(t[n>>2]|0,541,67448,t[f>>2]|0,0),(wz(t[(t[n>>2]|0)+296>>2]|0,t[f>>2]|0)|0)==0):0)pAi[t[135736>>2]&511](t[f>>2]|0);do if(!(t[l>>2]|0)){t[c>>2]=RM(t[f>>2]|0)|0;if(!(t[c>>2]|0)){k=17;break e}e=t[c>>2]|0;if(!(t[o>>2]|0)){t[o>>2]=e;t[a>>2]=e;break}else{t[t[o>>2]>>2]=e;t[o>>2]=t[c>>2];break}}while(0);uE(t[n>>2]|0)|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124){k=22;break}}if((k|0)==8){BS(t[n>>2]|0,68,67408);NM(t[a>>2]|0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}else if((k|0)==17){NM(t[a>>2]|0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}else if((k|0)==22){k=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=41){AS(k,49,0);NM(t[a>>2]|0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}else{Op(k);t[r>>2]=t[a>>2];b=t[r>>2]|0;s=i;return b|0}}return 0}function NE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[n>>2]=e;t[a>>2]=0;t[o>>2]=0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){AS(e,50,0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}if(((t[e+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[n>>2]|0);e:while(1){Op(t[n>>2]|0);uE(t[n>>2]|0)|0;t[f>>2]=dE(t[n>>2]|0)|0;if(!(t[f>>2]|0)){k=8;break}t[l>>2]=t[a>>2];while(1){if(!(t[l>>2]|0))break;if(Xl(t[f>>2]|0,t[(t[l>>2]|0)+4>>2]|0)|0){k=12;break}t[l>>2]=t[t[l>>2]>>2]}if((k|0)==12?(k=0,RS(t[n>>2]|0,541,67512,t[f>>2]|0,0),(wz(t[(t[n>>2]|0)+296>>2]|0,t[f>>2]|0)|0)==0):0)pAi[t[135736>>2]&511](t[f>>2]|0);do if(!(t[l>>2]|0)){t[c>>2]=RM(t[f>>2]|0)|0;if(!(wz(t[(t[n>>2]|0)+296>>2]|0,t[f>>2]|0)|0))pAi[t[135736>>2]&511](t[f>>2]|0);if(!(t[c>>2]|0)){k=19;break e}e=t[c>>2]|0;if(!(t[o>>2]|0)){t[o>>2]=e;t[a>>2]=e;break}else{t[t[o>>2]>>2]=e;t[o>>2]=t[c>>2];break}}while(0);uE(t[n>>2]|0)|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124){k=24;break}}if((k|0)==8){AS(t[n>>2]|0,67,0);t[r>>2]=t[a>>2];b=t[r>>2]|0;s=i;return b|0}else if((k|0)==19){NM(t[a>>2]|0);t[r>>2]=0;b=t[r>>2]|0;s=i;return b|0}else if((k|0)==24){k=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=41){AS(k,51,0);t[r>>2]=t[a>>2];b=t[r>>2]|0;s=i;return b|0}else{Op(k);t[r>>2]=t[a>>2];b=t[r>>2]|0;s=i;return b|0}}return 0}function TE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[f>>2]=e;t[a>>2]=i;if((((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==79:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==65:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==79:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==78:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+8;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){BS(t[f>>2]|0,65,67576);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}}while(0);uE(t[f>>2]|0)|0;i=RE(t[f>>2]|0)|0;t[t[a>>2]>>2]=i;if(!(t[t[a>>2]>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=10;o=t[n>>2]|0;s=r;return o|0}}i=NE(t[f>>2]|0)|0;t[t[a>>2]>>2]=i;if(!(t[t[a>>2]>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=9;o=t[n>>2]|0;s=r;return o|0}return 0}function LE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[f>>2]=e;t[a>>2]=i;if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);if(((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==67?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==65:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==65:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+5;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+5;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+5;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}if((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==82:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==70:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==83:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+6;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=4;o=t[n>>2]|0;s=r;return o|0}if(((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==82:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==70:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+5;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+5;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+5;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=3;o=t[n>>2]|0;s=r;return o|0}if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+2;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+2;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+2;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=2;o=t[n>>2]|0;s=r;return o|0}if((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==69?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==89:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+6;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+6;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=5;o=t[n>>2]|0;s=r;return o|0}if((((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==69?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==83:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+8;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=6;o=t[n>>2]|0;s=r;return o|0}if((((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==77:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==75:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==78:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==83:0){
	i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+8;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+8;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=8;o=t[n>>2]|0;s=r;return o|0}if(((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==77:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==75:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==69:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==78:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+7;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+7;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+7;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;t[n>>2]=7;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=TE(t[f>>2]|0,t[a>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}function DE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[r>>2]=e;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=65){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=76){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=73){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=83){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=84){s=i;return}t[o>>2]=t[(t[r>>2]|0)+36>>2];e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+9;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[r>>2]|0,65,67616)}while(0);uE(t[r>>2]|0)|0;t[n>>2]=sE(t[r>>2]|0)|0;e=t[r>>2]|0;if(!(t[n>>2]|0)){BS(e,68,67656);s=i;return}uE(e)|0;if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);e:while(1){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((t[(t[r>>2]|0)+172>>2]|0)==-1)break;t[c>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];t[k>>2]=0;if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);t[a>>2]=0;t[f>>2]=sE(t[r>>2]|0)|0;h=t[r>>2]|0;if(!(t[f>>2]|0)){w=31;break}do if(!(t[h+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[r>>2]|0)}while(0);do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){w=39;break e}}while(0);uE(t[r>>2]|0)|0;t[l>>2]=LE(t[r>>2]|0,a)|0;if((t[l>>2]|0)<=0)break;do if(!(t[(t[r>>2]|0)+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[r>>2]|0)}while(0);do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){w=48;break e}}while(0);uE(t[r>>2]|0)|0;t[b>>2]=ME(t[r>>2]|0,k)|0;if((t[b>>2]|0)<=0){w=51;break}if((t[l>>2]|0)!=1&(t[k>>2]|0)!=0)JS(t[k>>2]|0,t[k>>2]|0)|0;do if(!(t[(t[r>>2]|0)+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[r>>2]|0)}while(0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){w=65;break e}}while(0);uE(t[r>>2]|0)|0}d=t[r>>2]|0;if((t[c>>2]|0)==(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)){w=71;break}do if(t[d>>2]|0){if(t[(t[r>>2]|0)+212>>2]|0){w=79;break}if(!(t[(t[t[r>>2]>>2]|0)+32>>2]|0)){w=79;break}vAi[t[(t[t[r>>2]>>2]|0)+32>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,t[f>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[a>>2]|0)}else w=79;while(0);do if((w|0)==79){w=0;if(!(t[a>>2]|0))break;NM(t[a>>2]|0)}while(0);if(((t[k>>2]|0)!=0?(t[(t[r>>2]|0)+324>>2]|0)!=0:0)&(t[b>>2]|0)!=3&(t[b>>2]|0)!=2)QS(t[r>>2]|0,t[n>>2]|0,t[f>>2]|0,t[k>>2]|0);if(t[(t[r>>2]|0)+324>>2]|0)$S(t[r>>2]|0,t[n>>2]|0,t[f>>2]|0,t[l>>2]|0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[(t[r>>2]|0)+292>>2]|0)continue;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;CS(t[r>>2]|0)}if((w|0)==31)BS(h,68,67688);else if((w|0)==39)BS(t[r>>2]|0,65,67720);else if((w|0)==48){BS(t[r>>2]|0,65,67768);if(t[a>>2]|0)NM(t[a>>2]|0)}else if((w|0)==51){if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[a>>2]|0)NM(t[a>>2]|0)}else if((w|0)==65){BS(t[r>>2]|0,65,67816);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[a>>2]|0)NM(t[a>>2]|0)}else if((w|0)==71){AS(d,1,67872);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[a>>2]|0)NM(t[a>>2]|0)}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){s=i;return}if((t[o>>2]|0)!=(t[(t[r>>2]|0)+36>>2]|0))RS(t[r>>2]|0,90,67904,0,0);Op(t[r>>2]|0);s=i;return}function CE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;t[c>>2]=0;t[b>>2]=0;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);do if(((((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==80:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==67:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==68:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==65:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==84:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==65:0){i=(t[f>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+7;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+7;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+7;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[f>>2]|0)|0;uE(t[f>>2]|0)|0;if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);i=t[f>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==41){if((t[i+104>>2]|0)!=0?(t[(t[(t[f>>2]|0)+36>>2]|0)+56>>2]|0)!=(t[a>>2]|0):0)RS(t[f>>2]|0,90,67976,0,0);Op(t[f>>2]|0);t[o>>2]=EM(t[(t[f>>2]|0)+8>>2]|0,0,1)|0;if(!(t[o>>2]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){t[(t[o>>2]|0)+4>>2]=3;Op(t[f>>2]|0)}t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}if(!((u[t[(t[i+36>>2]|0)+16>>2]>>0]|0|0)!=40?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124:0))h=31;if((h|0)==31?(i=EM(t[(t[f>>2]|0)+8>>2]|0,0,1)|0,t[c>>2]=i,t[o>>2]=i,(t[o>>2]|0)==0):0){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}while(1){if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==124)w=(t[(t[f>>2]|0)+172>>2]|0)!=-1;else w=0;d=t[f>>2]|0;if(!w){h=54;break}Op(d);i=(t[b>>2]|0)==0;e=EM(t[(t[f>>2]|0)+8>>2]|0,0,4)|0;if(i){t[o>>2]=e;if(!(t[o>>2]|0)){h=38;break}t[(t[o>>2]|0)+12>>2]=t[c>>2];if(t[c>>2]|0)t[(t[c>>2]|0)+20>>2]=t[o>>2];t[c>>2]=t[o>>2]}else{t[l>>2]=e;if(!(t[l>>2]|0)){h=43;break}e=EM(t[(t[f>>2]|0)+8>>2]|0,t[b>>2]|0,2)|0;t[(t[l>>2]|0)+12>>2]=e;if(t[(t[l>>2]|0)+12>>2]|0)t[(t[(t[l>>2]|0)+12>>2]|0)+20>>2]=t[l>>2];t[(t[c>>2]|0)+16>>2]=t[l>>2];if(t[l>>2]|0)t[(t[l>>2]|0)+20>>2]=t[c>>2];t[c>>2]=t[l>>2]}uE(t[f>>2]|0)|0;t[b>>2]=sE(t[f>>2]|0)|0;v=t[f>>2]|0;if(!(t[b>>2]|0)){h=50;break}uE(v)|0;if(t[(t[f>>2]|0)+292>>2]|0)continue;if(((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;CS(t[f>>2]|0)}if((h|0)==38){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==43){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==50){BS(v,68,68048);yM(t[(t[f>>2]|0)+8>>2]|0,t[c>>2]|0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==54){if((u[t[(t[d+36>>2]|0)+16>>2]>>0]|0|0)==41?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==42:0){do if(t[b>>2]|0){e=EM(t[(t[f>>2]|0)+8>>2]|0,t[b>>2]|0,2)|0;t[(t[c>>2]|0)+16>>2]=e;if(!(t[(t[c>>2]|0)+16>>2]|0))break;t[(t[(t[c>>2]|0)+16>>2]|0)+20>>2]=t[c>>2]}while(0);if(t[o>>2]|0)t[(t[o>>2]|0)+4>>2]=3;do if(t[(t[f>>2]|0)+104>>2]|0){if((t[(t[(t[f>>2]|0)+36>>2]|0)+56>>2]|0)==(t[a>>2]|0))break;RS(t[f>>2]|0,90,67976,0,0)}while(0);e=(t[f>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);if(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((yp(t[(t[f>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[f>>2]|0)|0;break}yM(t[(t[f>>2]|0)+8>>2]|0,t[o>>2]|0);AS(t[f>>2]|0,52,0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}}else h=70;while(0);if((h|0)==70)AS(t[f>>2]|0,69,0);t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}function PE(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;t[b>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+56>>2];t[t[c>>2]>>2]=0;r=t[a>>2]|0;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){MS(r,54,68104,t[o>>2]|0);t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}Op(r);if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);if((t[(t[a>>2]|0)+172>>2]|0)==-1){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}uE(t[a>>2]|0)|0;if(((((((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==80:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==67:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==68:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==65:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==84:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==65:0){t[l>>2]=CE(t[a>>2]|0,t[b>>2]|0)|0;t[k>>2]=3}else{t[l>>2]=eg(t[a>>2]|0,t[b>>2]|0,1)|0;t[k>>2]=4}uE(t[a>>2]|0)|0;t[t[c>>2]>>2]=t[l>>2];t[f>>2]=t[k>>2];h=t[f>>2]|0;s=n;return h|0}function BE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[a>>2]=-1;t[o>>2]=0;e:do if(((((((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==69:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==69:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==77:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==78:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==84:0){t[c>>2]=t[(t[n>>2]|0)+36>>2];e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+9;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[n>>2]|0,65,68152)}while(0);uE(t[n>>2]|0)|0;t[f>>2]=sE(t[n>>2]|0)|0;if(!(t[f>>2]|0)){BS(t[n>>2]|0,68,68184);t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}while(1){if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))b=(t[(t[n>>2]|0)+40>>2]|0)>1;else b=0;k=t[n>>2]|0;if(!b)break;aE(k)|0}do if((u[t[(t[k+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[n>>2]|0,65,68232)}while(0);uE(t[n>>2]|0)|0;do if((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==69?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==77:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==80:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==84:0){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=89){h=42;break}e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+5;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);do if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[n>>2]|0)|0}while(0);t[a>>2]=1}else h=42;while(0);i:do if((h|0)==42){do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==65?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=89)break;e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);do if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[n>>2]|0)|0}while(0);t[a>>2]=2;break i}while(0);e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==40){t[a>>2]=PE(e,t[f>>2]|0,o)|0;break}do if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)==37){if(t[(t[n>>2]|0)+96>>2]|0){h=57;break}if((t[(t[n>>2]|0)+40>>2]|0)!=1){h=57;break}BS(t[n>>2]|0,21,68272)}else h=57;while(0);if((h|0)==57)BS(t[n>>2]|0,54,68336);t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}while(0);uE(t[n>>2]|0)|0;while(1){if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))w=(t[(t[n>>2]|0)+40>>2]|0)>1;else w=0;d=t[n>>2]|0;if(!w)break;aE(d)|0}uE(d)|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){AS(t[n>>2]|0,73,0);if(!(t[o>>2]|0))break;yM(t[(t[n>>2]|0)+8>>2]|0,t[o>>2]|0);break}if((t[c>>2]|0)!=(t[(t[n>>2]|0)+36>>2]|0))BS(t[n>>2]|0,90,68392);Op(t[n>>2]|0);do if(t[t[n>>2]>>2]|0){if(t[(t[n>>2]|0)+212>>2]|0)break;if(!(t[(t[t[n>>2]>>2]|0)+36>>2]|0))break;if(t[o>>2]|0)t[(t[o>>2]|0)+20>>2]=0;NAi[t[(t[t[n>>2]>>2]|0)+36>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[f>>2]|0,t[a>>2]|0,t[o>>2]|0);if(!(t[o>>2]|0))break e;if(t[(t[o>>2]|0)+20>>2]|0)break e;yM(t[(t[n>>2]|0)+8>>2]|0,t[o>>2]|0);break e}while(0);if(t[o>>2]|0)yM(t[(t[n>>2]|0)+8>>2]|0,t[o>>2]|0)}while(0);t[r>>2]=t[a>>2];l=t[r>>2]|0;s=i;return l|0}function IE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){e=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){if((u[e+1>>0]|0|0)!=63)break;FE(t[r>>2]|0);break}n=u[e+2>>0]|0;if((n|0)==78){OE(t[r>>2]|0);break}else if((n|0)==65){DE(t[r>>2]|0);break}else if((n|0)==45){gE(t[r>>2]|0);break}else if((n|0)==69){n=t[r>>2]|0;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76){BE(n)|0;break}if((u[(t[(t[n+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=78)break;AE(t[r>>2]|0);break}else break}while(0);if((t[(t[r>>2]|0)+96>>2]|0)==0?(t[(t[r>>2]|0)+40>>2]|0)==1:0)HE(t[r>>2]|0);if(t[(t[r>>2]|0)+96>>2]|0){f=t[r>>2]|0;a=f+172|0;t[a>>2]=3;s=i;return}if((t[(t[r>>2]|0)+40>>2]|0)<=1){f=t[r>>2]|0;a=f+172|0;t[a>>2]=3;s=i;return}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){f=t[r>>2]|0;a=f+172|0;t[a>>2]=3;s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){f=t[r>>2]|0;a=f+172|0;t[a>>2]=3;s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91){f=t[r>>2]|0;a=f+172|0;t[a>>2]=3;s=i;return}ig(t[r>>2]|0);f=t[r>>2]|0;a=f+172|0;t[a>>2]=3;s=i;return}function HE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[f>>2]=0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37){s=i;return}Op(t[r>>2]|0);t[n>>2]=sE(t[r>>2]|0)|0;e=t[r>>2]|0;if(!(t[n>>2]|0)){BS(e,68,68904);s=i;return}o=t[r>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=59){AS(o,23,0);s=i;return}Op(o);o=(t[r>>2]|0)+440|0;t[o>>2]=(t[o>>2]|0)+1;if((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+96>>2]|0)!=0:0)t[f>>2]=MAi[t[(t[t[r>>2]>>2]|0)+96>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0)|0;if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}e:do if(t[f>>2]|0){if((t[(t[f>>2]|0)+48>>2]|0)!=4?(t[(t[f>>2]|0)+48>>2]|0)!=5:0){NS(t[r>>2]|0,27,68936,t[n>>2]|0,0);break}o=t[r>>2]|0;e=t[f>>2]|0;if((t[(t[(t[r>>2]|0)+36>>2]|0)+40>>2]|0)!=226){t[a>>2]=DS(o,e)|0;if((cE(t[r>>2]|0,t[a>>2]|0)|0)>=0)break;s=i;return}t[a>>2]=Bp(o,e)|0;if((cE(t[r>>2]|0,t[a>>2]|0)|0)<0){s=i;return}if((((((t[(t[f>>2]|0)+48>>2]|0)==5?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break e}while(0);bE(t[r>>2]|0);if((t[(t[r>>2]|0)+84>>2]|0)==32){t[(t[r>>2]|0)+172>>2]=-1;s=i;return}}}else{do if((t[(t[r>>2]|0)+28>>2]|0)==1)c=14;else{if((t[(t[r>>2]|0)+88>>2]|0)==0?(t[(t[r>>2]|0)+92>>2]|0)==0:0){c=14;break}NS(t[r>>2]|0,27,65432,t[n>>2]|0,0);t[(t[r>>2]|0)+100>>2]=0}while(0);if((c|0)==14)MS(t[r>>2]|0,26,65432,t[n>>2]|0);TS(t[r>>2]|0,0,0,0)|0}while(0);t[(t[r>>2]|0)+92>>2]=1;s=i;return}function xE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;do if(((((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==118?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==101:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==114:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==115:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==105:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==111:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==110:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+7;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+7;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+7;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;uE(t[n>>2]|0)|0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){AS(e,75,0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}Op(e);uE(t[n>>2]|0)|0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){Op(e);t[f>>2]=ZE(t[n>>2]|0)|0;o=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){AS(o,34,0);break}else{Op(o);break}}o=t[n>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=39){AS(o,33,0);break}Op(o);t[f>>2]=ZE(t[n>>2]|0)|0;o=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){AS(o,34,0);break}else{Op(o);break}}while(0);t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function UE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[f>>2]=0;uE(t[n>>2]|0)|0;e:do if((((((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==101?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==110:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==99:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==111:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==100:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==105:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==110:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==103:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+8;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+8;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+8;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;uE(t[n>>2]|0)|0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){AS(e,75,0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}Op(e);uE(t[n>>2]|0)|0;e=t[n>>2]|0;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){Op(e);t[f>>2]=JE(t[n>>2]|0)|0;c=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){AS(c,34,0);break}else{Op(c);break}}else{c=t[n>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=39){AS(c,33,0);break}Op(c);t[f>>2]=JE(t[n>>2]|0)|0;c=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){AS(c,34,0);break}else{Op(c);break}}while(0);if(t[(t[n>>2]|0)+360>>2]&2097152){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}do if(t[f>>2]|0){if((Ql(t[f>>2]|0,69608)|0)!=0?(Ql(t[f>>2]|0,69616)|0)!=0:0)break;do if((t[(t[n>>2]|0)+24>>2]|0)==0?(t[t[(t[n>>2]|0)+36>>2]>>2]|0)!=0:0){if(t[(t[t[(t[n>>2]|0)+36>>2]>>2]|0)+12>>2]|0)break;BS(t[n>>2]|0,81,69624)}while(0);if(t[(t[n>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+24>>2]|0);t[(t[n>>2]|0)+24>>2]=t[f>>2];break e}while(0);do if(t[f>>2]|0){if((Ql(t[f>>2]|0,69672)|0)!=0?(Ql(t[f>>2]|0,69680)|0)!=0:0)break;if(t[(t[n>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+24>>2]|0);t[(t[n>>2]|0)+24>>2]=t[f>>2];break e}while(0);if(t[f>>2]|0){if(t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]|0);t[(t[(t[n>>2]|0)+36>>2]|0)+44>>2]=t[f>>2];t[a>>2]=V_(t[f>>2]|0)|0;e=t[n>>2]|0;if(t[a>>2]|0){Lp(e,t[a>>2]|0)|0;break}MS(e,32,69688,t[f>>2]|0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}}while(0);t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}function zE(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+32|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+24|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;rg(t[a>>2]|0);if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);if(((t[(t[a>>2]|0)+24>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0)?(n[l>>0]=n[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0,n[l+1>>0]=n[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,n[l+2>>0]=n[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,n[l+3>>0]=n[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,t[b>>2]=L_(l,4)|0,(t[b>>2]|0)!=0):0)Tp(t[a>>2]|0,t[b>>2]|0)|0;if((((((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0)?(bE(t[a>>2]|0),(t[(t[a>>2]|0)+84>>2]|0)==32):0){t[(t[a>>2]|0)+172>>2]=-1;s=f;return}do if(!(t[(t[a>>2]|0)+8>>2]|0)){b=ny(68488)|0;t[(t[a>>2]|0)+8>>2]=b;b=t[a>>2]|0;if(t[(t[a>>2]|0)+8>>2]|0){t[(t[b+8>>2]|0)+92>>2]=64;break}Sp(b,67128);s=f;return}while(0);if((t[(t[a>>2]|0)+8>>2]|0)!=0?(t[(t[(t[a>>2]|0)+8>>2]|0)+44>>2]|0)==0:0)$g(t[(t[a>>2]|0)+8>>2]|0,0,t[o>>2]|0,t[c>>2]|0)|0;t[(t[a>>2]|0)+172>>2]=3;t[(t[a>>2]|0)+96>>2]=1;e:while(1){if(!((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0))w=25;do if((w|0)==25){w=0;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)break;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32:0){if(9<=(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)break e}}while(0);t[k>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2];t[h>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+36>>2];if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);if(((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==91:0)ig(t[a>>2]|0);else w=39;i:do if((w|0)==39){w=0;do if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){c=t[a>>2]|0;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37){HE(c);break i}else{IE(c);break i}}}while(0);Op(t[a>>2]|0)}while(0);while(1){if(!(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0))d=(t[(t[a>>2]|0)+40>>2]|0)>1;else d=0;v=t[a>>2]|0;if(!d)break;aE(v)|0}if((t[(t[v+36>>2]|0)+16>>2]|0)!=(t[k>>2]|0))continue;if((t[h>>2]|0)==(t[(t[(t[a>>2]|0)+36>>2]|0)+36>>2]|0)){w=53;break}}if((w|0)==53)AS(t[a>>2]|0,60,0);if(!(u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){s=f;return}AS(t[a>>2]|0,60,0);s=f;return}function jE(e){e=e|0;var i=0,r=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0;i=s;s=s+112|0;r=i;a=i+84|0;o=i+80|0;c=i+76|0;l=i+72|0;b=i+68|0;k=i+64|0;h=i+60|0;w=i+88|0;d=i+56|0;v=i+52|0;m=i+48|0;_=i+44|0;p=i+40|0;E=i+36|0;S=i+32|0;g=i+28|0;y=i+24|0;F=i+20|0;O=i+16|0;A=i+12|0;M=i+8|0;R=i+4|0;t[a>>2]=e;t[b>>2]=0;t[k>>2]=0;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){s=i;return}if((u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){t[h>>2]=0;t[d>>2]=u[(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0];t[v>>2]=lE(t[a>>2]|0)|0;if(!(t[v>>2]|0)){s=i;return}if((t[(t[a>>2]|0)+256>>2]|0)==1){e=Rp(w+(t[h>>2]|0)|0,t[v>>2]|0)|0;t[h>>2]=(t[h>>2]|0)+e;n[w+(t[h>>2]|0)>>0]=0;if(!(t[t[a>>2]>>2]|0)){s=i;return}if(!(t[(t[t[a>>2]>>2]|0)+68>>2]|0)){s=i;return}if(t[(t[a>>2]|0)+212>>2]|0){s=i;return}yAi[t[(t[t[a>>2]>>2]|0)+68>>2]&511](t[(t[a>>2]|0)+4>>2]|0,w,t[h>>2]|0);s=i;return}if((t[v>>2]|0)<=255){n[w>>0]=t[v>>2];n[w+1>>0]=0;if(!(t[t[a>>2]>>2]|0)){s=i;return}if(!(t[(t[t[a>>2]>>2]|0)+68>>2]|0)){s=i;return}if(t[(t[a>>2]|0)+212>>2]|0){s=i;return}yAi[t[(t[t[a>>2]>>2]|0)+68>>2]&511](t[(t[a>>2]|0)+4>>2]|0,w,1);s=i;return}h=t[v>>2]|0;if((t[d>>2]|0)==120|(t[d>>2]|0)==88){t[r>>2]=h;SY(w,10,68560,r)|0}else{t[r>>2]=h;SY(w,10,68568,r)|0}if(!(t[t[a>>2]>>2]|0)){s=i;return}if(!(t[(t[t[a>>2]>>2]|0)+64>>2]|0)){s=i;return}if(t[(t[a>>2]|0)+212>>2]|0){s=i;return}EAi[t[(t[t[a>>2]>>2]|0)+64>>2]&511](t[(t[a>>2]|0)+4>>2]|0,w);s=i;return}t[o>>2]=VE(t[a>>2]|0)|0;if(!(t[o>>2]|0)){s=i;return}if(!(t[(t[a>>2]|0)+12>>2]|0)){s=i;return}t[l>>2]=t[(t[o>>2]|0)+72>>2];if((t[(t[o>>2]|0)+8>>2]|0)!=0?(t[(t[o>>2]|0)+48>>2]|0)!=6:0){do if(!(t[(t[o>>2]|0)+72>>2]|0)){if((t[(t[o>>2]|0)+48>>2]|0)==2?(t[(t[a>>2]|0)+360>>2]&18|0)==0:0){N=76;break}t[m>>2]=t[(t[a>>2]|0)+440>>2];if((t[(t[a>>2]|0)+4>>2]|0)==(t[a>>2]|0))t[_>>2]=0;else t[_>>2]=t[(t[a>>2]|0)+4>>2];do if((t[(t[o>>2]|0)+48>>2]|0)!=1)if((t[(t[o>>2]|0)+48>>2]|0)==2){w=(t[a>>2]|0)+248|0;t[w>>2]=(t[w>>2]|0)+1;t[k>>2]=fg(t[(t[a>>2]|0)+8>>2]|0,t[a>>2]|0,t[t[a>>2]>>2]|0,t[_>>2]|0,t[(t[a>>2]|0)+248>>2]|0,t[(t[o>>2]|0)+64>>2]|0,t[(t[o>>2]|0)+52>>2]|0,b)|0;w=(t[a>>2]|0)+248|0;t[w>>2]=(t[w>>2]|0)+-1;break}else{t[k>>2]=88;ZS(t[a>>2]|0,1,68576,0);break}else{w=(t[a>>2]|0)+248|0;t[w>>2]=(t[w>>2]|0)+1;t[k>>2]=ng(t[a>>2]|0,t[(t[o>>2]|0)+40>>2]|0,t[_>>2]|0,b)|0;w=(t[a>>2]|0)+248|0;t[w>>2]=(t[w>>2]|0)+-1}while(0);t[(t[o>>2]|0)+72>>2]=(t[(t[a>>2]|0)+440>>2]|0)-(t[m>>2]|0)+1<<1;if((t[(t[o>>2]|0)+40>>2]|0)!=0?(es(t[(t[o>>2]|0)+40>>2]|0,60)|0)!=0:0){w=(t[o>>2]|0)+72|0;t[w>>2]=t[w>>2]|1}w=t[a>>2]|0;if((t[k>>2]|0)==89){AS(w,89,0);ty(t[b>>2]|0);s=i;return}if(TS(w,0,t[o>>2]|0,0)|0){ty(t[b>>2]|0);s=i;return}e:do if(!((t[k>>2]|0)==0&(t[b>>2]|0)!=0)){if((t[k>>2]|0)!=0&(t[k>>2]|0)!=27){MS(t[a>>2]|0,26,68608,t[(t[o>>2]|0)+8>>2]|0);TS(t[a>>2]|0,0,t[o>>2]|0,0)|0;break}if(t[b>>2]|0){ty(t[b>>2]|0);t[b>>2]=0}}else{if(!((t[(t[o>>2]|0)+48>>2]|0)!=1?(t[(t[o>>2]|0)+48>>2]|0)!=2:0))N=51;if((N|0)==51?(t[(t[o>>2]|0)+12>>2]|0)==0:0){t[(t[o>>2]|0)+12>>2]=t[b>>2];if(!(t[(t[a>>2]|0)+16>>2]|0)){t[(t[o>>2]|0)+68>>2]=1;while(1){if(!(t[b>>2]|0))break e;t[(t[b>>2]|0)+20>>2]=t[o>>2];Ny(t[b>>2]|0,t[(t[o>>2]|0)+32>>2]|0);if(!(t[(t[b>>2]|0)+24>>2]|0))t[(t[o>>2]|0)+16>>2]=t[b>>2];t[b>>2]=t[(t[b>>2]|0)+24>>2]}}if(!((t[(t[b>>2]|0)+4>>2]|0)==3?(t[(t[b>>2]|0)+24>>2]|0)==0:0))N=55;do if((N|0)==55){if((t[(t[a>>2]|0)+436>>2]|0)==5)break;t[(t[o>>2]|0)+68>>2]=0;while(1){if(!(t[b>>2]|0))break;t[(t[b>>2]|0)+20>>2]=t[(t[a>>2]|0)+52>>2];t[(t[b>>2]|0)+32>>2]=t[(t[a>>2]|0)+8>>2];if(!(t[(t[b>>2]|0)+24>>2]|0))t[(t[o>>2]|0)+16>>2]=t[b>>2];t[b>>2]=t[(t[b>>2]|0)+24>>2]}t[b>>2]=t[(t[o>>2]|0)+12>>2];if((t[(t[o>>2]|0)+48>>2]|0)!=2)break e;tg(t[o>>2]|0,t[b>>2]|0,0);break e}while(0);t[(t[b>>2]|0)+20>>2]=t[o>>2];t[b>>2]=0;t[(t[o>>2]|0)+68>>2]=1;break}ty(t[b>>2]|0);t[b>>2]=0}while(0);if(!(t[(t[o>>2]|0)+72>>2]|0))t[(t[o>>2]|0)+72>>2]=2}else N=76;while(0);if((N|0)==76?(t[(t[o>>2]|0)+72>>2]|0)!=1:0){m=(t[a>>2]|0)+440|0;t[m>>2]=(t[m>>2]|0)+((t[(t[o>>2]|0)+72>>2]|0)/2|0)}if(!(t[(t[o>>2]|0)+12>>2]|0)){if(t[l>>2]|0){if((t[(t[a>>2]|0)+4>>2]|0)==(t[a>>2]|0))t[p>>2]=0;else t[p>>2]=t[(t[a>>2]|0)+4>>2];do if((t[(t[o>>2]|0)+48>>2]|0)!=1)if((t[(t[o>>2]|0)+48>>2]|0)==2){l=(t[a>>2]|0)+248|0;t[l>>2]=(t[l>>2]|0)+1;t[k>>2]=fg(t[(t[a>>2]|0)+8>>2]|0,t[a>>2]|0,t[t[a>>2]>>2]|0,t[p>>2]|0,t[(t[a>>2]|0)+248>>2]|0,t[(t[o>>2]|0)+64>>2]|0,t[(t[o>>2]|0)+52>>2]|0,0)|0;l=(t[a>>2]|0)+248|0;t[l>>2]=(t[l>>2]|0)+-1;break}else{t[k>>2]=88;ZS(t[a>>2]|0,1,68576,0);break}else{l=(t[a>>2]|0)+248|0;t[l>>2]=(t[l>>2]|0)+1;t[k>>2]=ng(t[a>>2]|0,t[(t[o>>2]|0)+40>>2]|0,t[p>>2]|0,0)|0;l=(t[a>>2]|0)+248|0;t[l>>2]=(t[l>>2]|0)+-1}while(0);if((t[k>>2]|0)==89){AS(t[a>>2]|0,89,0);s=i;return}}if(!(t[t[a>>2]>>2]|0)){s=i;return}if(!(t[(t[t[a>>2]>>2]|0)+64>>2]|0)){s=i;return}if(t[(t[a>>2]|0)+16>>2]|0){s=i;return}if(t[(t[a>>2]|0)+212>>2]|0){s=i;return}EAi[t[(t[t[a>>2]>>2]|0)+64>>2]&511](t[(t[a>>2]|0)+4>>2]|0,t[(t[o>>2]|0)+8>>2]|0);s=i;return}if((((t[t[a>>2]>>2]|0)!=0?(t[(t[t[a>>2]>>2]|0)+64>>2]|0)!=0:0)?(t[(t[a>>2]|0)+16>>2]|0)==0:0)?(t[(t[a>>2]|0)+212>>2]|0)==0:0){EAi[t[(t[t[a>>2]>>2]|0)+64>>2]&511](t[(t[a>>2]|0)+4>>2]|0,t[(t[o>>2]|0)+8>>2]|0);s=i;return}if((t[(t[a>>2]|0)+16>>2]|0)==0?(t[(t[o>>2]|0)+12>>2]|0)!=0:0){s=i;return}if(!(t[(t[a>>2]|0)+52>>2]|0)){s=i;return}if(!(t[(t[o>>2]|0)+12>>2]|0)){s=i;return}if((t[b>>2]|0)==0?(t[(t[o>>2]|0)+68>>2]|0)==0:0)N=107;else N=106;do if((N|0)==106)if((t[(t[a>>2]|0)+436>>2]|0)!=5){if((t[b>>2]|0)!=0?(t[(t[a>>2]|0)+40>>2]|0)<=0:0){t[R>>2]=kz(t[(t[a>>2]|0)+296>>2]|0,68640,-1)|0;if((t[(t[(t[o>>2]|0)+12>>2]|0)+4>>2]|0)==3)t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]=t[R>>2];do if((t[(t[o>>2]|0)+16>>2]|0)!=(t[(t[o>>2]|0)+12>>2]|0)){if((t[(t[(t[o>>2]|0)+16>>2]|0)+4>>2]|0)!=3)break;t[(t[(t[o>>2]|0)+16>>2]|0)+8>>2]=t[R>>2]}while(0);Iy(t[(t[a>>2]|0)+52>>2]|0,t[(t[o>>2]|0)+12>>2]|0)|0;break}t[y>>2]=0;t[M>>2]=0;k=(t[a>>2]|0)+468|0;t[k>>2]=(t[k>>2]|0)+((t[(t[o>>2]|0)+44>>2]|0)+5);if(TS(t[a>>2]|0,0,t[o>>2]|0,t[(t[a>>2]|0)+468>>2]|0)|0){s=i;return}t[F>>2]=t[(t[o>>2]|0)+12>>2];t[(t[o>>2]|0)+12>>2]=0;t[A>>2]=t[(t[o>>2]|0)+16>>2];t[(t[o>>2]|0)+16>>2]=0;while(1){if(!(t[F>>2]|0))break;t[O>>2]=t[(t[F>>2]|0)+24>>2];t[(t[F>>2]|0)+24>>2]=0;t[(t[F>>2]|0)+20>>2]=0;t[y>>2]=Wy(t[F>>2]|0,t[(t[a>>2]|0)+8>>2]|0,1)|0;if(t[y>>2]|0){if(!(t[t[y>>2]>>2]|0))t[t[y>>2]>>2]=t[t[F>>2]>>2];
	if(!(t[M>>2]|0))t[M>>2]=t[F>>2];Hy(t[o>>2]|0,t[y>>2]|0)|0;Hy(t[(t[a>>2]|0)+52>>2]|0,t[F>>2]|0)|0}if((t[F>>2]|0)==(t[A>>2]|0))break;t[F>>2]=t[O>>2]}if(!(t[(t[o>>2]|0)+68>>2]|0))t[(t[o>>2]|0)+68>>2]=1;if((t[(t[o>>2]|0)+48>>2]|0)==2)tg(t[o>>2]|0,t[M>>2]|0,t[y>>2]|0)}else N=107;while(0);if((N|0)==107){t[E>>2]=0;t[g>>2]=0;y=(t[a>>2]|0)+468|0;t[y>>2]=(t[y>>2]|0)+((t[(t[o>>2]|0)+44>>2]|0)+5);if(TS(t[a>>2]|0,0,t[o>>2]|0,t[(t[a>>2]|0)+468>>2]|0)|0){s=i;return}t[S>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[S>>2]|0))break;t[E>>2]=Wy(t[S>>2]|0,t[(t[a>>2]|0)+8>>2]|0,1)|0;if(t[E>>2]|0){if(!(t[t[E>>2]>>2]|0))t[t[E>>2]>>2]=t[t[S>>2]>>2];if(!(t[g>>2]|0))t[g>>2]=t[E>>2];t[E>>2]=Hy(t[(t[a>>2]|0)+52>>2]|0,t[E>>2]|0)|0}if((t[S>>2]|0)==(t[(t[o>>2]|0)+16>>2]|0)){N=117;break}t[S>>2]=t[(t[S>>2]|0)+24>>2]}if((((N|0)==117?(t[E>>2]|0)!=0?(t[(t[a>>2]|0)+436>>2]|0)==5:0:0)?(t[(t[E>>2]|0)+4>>2]|0)==1:0)?(t[(t[E>>2]|0)+12>>2]|0)==0:0)f[(t[E>>2]|0)+58>>1]=1;if((t[(t[o>>2]|0)+48>>2]|0)==2)tg(t[o>>2]|0,t[g>>2]|0,t[E>>2]|0)}t[(t[a>>2]|0)+264>>2]=0;t[(t[a>>2]|0)+260>>2]=0;s=i;return}t[c>>2]=t[(t[o>>2]|0)+40>>2];if(!(t[c>>2]|0)){s=i;return}if(!(t[t[a>>2]>>2]|0)){s=i;return}if(!(t[(t[t[a>>2]>>2]|0)+68>>2]|0)){s=i;return}if(t[(t[a>>2]|0)+212>>2]|0){s=i;return}o=t[(t[t[a>>2]>>2]|0)+68>>2]|0;E=t[(t[a>>2]|0)+4>>2]|0;a=t[c>>2]|0;g=rs(t[c>>2]|0)|0;yAi[o&511](E,a,g);s=i;return}function VE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[a>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}Op(t[n>>2]|0);t[f>>2]=sE(t[n>>2]|0)|0;e=t[n>>2]|0;if(!(t[f>>2]|0)){BS(e,68,68648);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}c=t[n>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=59){AS(c,23,0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}Op(c);if((t[(t[n>>2]|0)+360>>2]&1048576|0)==0?(t[a>>2]=l_(t[f>>2]|0)|0,(t[a>>2]|0)!=0):0){t[r>>2]=t[a>>2];o=t[r>>2]|0;s=i;return o|0}c=(t[n>>2]|0)+440|0;t[c>>2]=(t[c>>2]|0)+1;if(t[t[n>>2]>>2]|0){if(t[(t[t[n>>2]>>2]|0)+20>>2]|0)t[a>>2]=MAi[t[(t[t[n>>2]>>2]|0)+20>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[f>>2]|0)|0;if(((t[a>>2]|0)==0?(t[(t[n>>2]|0)+12>>2]|0)==1:0)?(t[(t[n>>2]|0)+360>>2]&1048576|0)!=0:0)t[a>>2]=l_(t[f>>2]|0)|0;if(((t[a>>2]|0)==0?(t[(t[n>>2]|0)+12>>2]|0)==1:0)?(t[(t[n>>2]|0)+4>>2]|0)==(t[n>>2]|0):0)t[a>>2]=Cz(t[n>>2]|0,t[f>>2]|0)|0}if((t[(t[n>>2]|0)+172>>2]|0)==-1){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}do if(t[a>>2]|0){c=t[n>>2]|0;if((t[(t[a>>2]|0)+48>>2]|0)==3){MS(c,28,68712,t[f>>2]|0);break}if((t[c+172>>2]|0)==12?(t[(t[a>>2]|0)+48>>2]|0)==2:0){MS(t[n>>2]|0,29,68752,t[f>>2]|0);break}if(((t[a>>2]|0)!=0?(t[(t[n>>2]|0)+172>>2]|0)==12:0)?(t[(t[a>>2]|0)+48>>2]|0)!=6:0){if((t[(t[a>>2]|0)+72>>2]&1|0)==0?(t[(t[a>>2]|0)+72>>2]|0)!=0:0)break;if(!(t[(t[a>>2]|0)+40>>2]|0))break;if(!(es(t[(t[a>>2]|0)+40>>2]|0,60)|0))break;MS(t[n>>2]|0,38,68800,t[f>>2]|0);break}if(((t[(t[a>>2]|0)+48>>2]|0)+-4|0)>>>0<2)MS(t[n>>2]|0,30,68856,t[f>>2]|0)}else{do if((t[(t[n>>2]|0)+28>>2]|0)!=1){if((t[(t[n>>2]|0)+88>>2]|0)==0?(t[(t[n>>2]|0)+92>>2]|0)==0:0){l=30;break}ZS(t[n>>2]|0,27,68680,t[f>>2]|0);if(((t[(t[n>>2]|0)+216>>2]|0)==0?(t[t[n>>2]>>2]|0)!=0:0)?(t[(t[t[n>>2]>>2]|0)+64>>2]|0)!=0:0)EAi[t[(t[t[n>>2]>>2]|0)+64>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[f>>2]|0)}else l=30;while(0);if((l|0)==30)MS(t[n>>2]|0,26,68680,t[f>>2]|0);TS(t[n>>2]|0,0,t[a>>2]|0,0)|0;t[(t[n>>2]|0)+100>>2]=0}while(0);t[r>>2]=t[a>>2];o=t[r>>2]|0;s=i;return o|0}function qE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;t[a>>2]=0;e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+9;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;uE(t[r>>2]|0)|0;t[n>>2]=sE(t[r>>2]|0)|0;if(!(t[n>>2]|0))BS(t[r>>2]|0,68,68984);t[(t[r>>2]|0)+220>>2]=t[n>>2];uE(t[r>>2]|0)|0;t[a>>2]=SE(t[r>>2]|0,f,1)|0;if((t[a>>2]|0)!=0|(t[f>>2]|0)!=0)t[(t[r>>2]|0)+88>>2]=1;t[(t[r>>2]|0)+224>>2]=t[a>>2];t[(t[r>>2]|0)+228>>2]=t[f>>2];uE(t[r>>2]|0)|0;if(((t[t[r>>2]>>2]|0)!=0?(t[t[t[r>>2]>>2]>>2]|0)!=0:0)?(t[(t[r>>2]|0)+212>>2]|0)==0:0)NAi[t[t[t[r>>2]>>2]>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,t[f>>2]|0,t[a>>2]|0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){s=i;return}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)AS(t[r>>2]|0,61,0);Op(t[r>>2]|0);s=i;return}function YE(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[t[a>>2]>>2]=0;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);t[o>>2]=sE(t[f>>2]|0)|0;i=t[f>>2]|0;if(!(t[o>>2]|0)){BS(i,68,69032);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}uE(i)|0;i=t[f>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){MS(i,41,69064,t[o>>2]|0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}Op(i);uE(t[f>>2]|0)|0;t[c>>2]=mE(t[f>>2]|0)|0;t[(t[f>>2]|0)+172>>2]=7;if(((t[(t[f>>2]|0)+268>>2]|0)!=0?(Xl(t[o>>2]|0,69112)|0)!=0:0)?($p(t[c>>2]|0)|0)==0:0)NS(t[f>>2]|0,98,69128,t[c>>2]|0,0);do if(Xl(t[o>>2]|0,69168)|0){if(Xl(t[c>>2]|0,69184)|0){t[t[(t[f>>2]|0)+232>>2]>>2]=0;break}i=(Xl(t[c>>2]|0,69192)|0)!=0;e=t[f>>2]|0;if(i){t[t[e+232>>2]>>2]=1;break}else{NS(e,102,69208,t[c>>2]|0,0);break}}while(0);t[t[a>>2]>>2]=t[c>>2];t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}function GE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;i=s;s=s+48|0;r=i+44|0;n=i+40|0;f=i+36|0;a=i+32|0;o=i+28|0;c=i+24|0;l=i+20|0;b=i+16|0;k=i+12|0;h=i+8|0;w=i+4|0;d=i;t[n>>2]=e;t[c>>2]=t[(t[n>>2]|0)+300>>2];t[l>>2]=0;t[b>>2]=t[(t[n>>2]|0)+304>>2];if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+1;e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[n>>2]|0)+36>>2]|0,250)|0;t[f>>2]=sE(t[n>>2]|0)|0;e=t[n>>2]|0;if(!(t[f>>2]|0)){BS(e,68,69280);t[r>>2]=0;v=t[r>>2]|0;s=i;return v|0}uE(e)|0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);while(1){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break;if(!(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))m=15;if(((m|0)==15?(m=0,(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break;if((t[(t[n>>2]|0)+172>>2]|0)==-1)break;t[h>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];t[w>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+36>>2];t[a>>2]=YE(t[n>>2]|0,o)|0;e:do if(!((t[a>>2]|0)!=0&(t[o>>2]|0)!=0)){if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0)}else{t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[l>>2]|0))break;if(Xl(t[(t[c>>2]|0)+(t[k>>2]<<2)>>2]|0,t[a>>2]|0)|0){m=22;break}t[k>>2]=(t[k>>2]|0)+2}if((m|0)==22){m=0;ug(t[n>>2]|0,0,t[a>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);break}do if(t[c>>2]|0){if(((t[l>>2]|0)+4|0)>(t[b>>2]|0)){t[b>>2]=t[b>>2]<<1;t[d>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[b>>2]<<2)|0;if(t[d>>2]|0){t[c>>2]=t[d>>2];t[(t[n>>2]|0)+300>>2]=t[c>>2];t[(t[n>>2]|0)+304>>2]=t[b>>2];break}Sp(t[n>>2]|0,0);if(!(t[o>>2]|0))break e;pAi[t[135736>>2]&511](t[o>>2]|0);break e}}else{t[b>>2]=22;t[c>>2]=gAi[t[135744>>2]&511](t[b>>2]<<2)|0;if(t[c>>2]|0){t[(t[n>>2]|0)+300>>2]=t[c>>2];t[(t[n>>2]|0)+304>>2]=t[b>>2];break}Sp(t[n>>2]|0,0);if(!(t[o>>2]|0))break e;pAi[t[135736>>2]&511](t[o>>2]|0);break e}while(0);e=t[a>>2]|0;_=t[l>>2]|0;t[l>>2]=_+1;t[(t[c>>2]|0)+(_<<2)>>2]=e;e=t[o>>2]|0;_=t[l>>2]|0;t[l>>2]=_+1;t[(t[c>>2]|0)+(_<<2)>>2]=e;t[(t[c>>2]|0)+(t[l>>2]<<2)>>2]=0;t[(t[c>>2]|0)+((t[l>>2]|0)+1<<2)>>2]=0}while(0);if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[n>>2]|0,65,69320)}while(0);uE(t[n>>2]|0)|0;if((t[w>>2]|0)==(t[(t[(t[n>>2]|0)+36>>2]|0)+36>>2]|0)?((t[a>>2]|0)==0?(t[h>>2]|0)==(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0):0)&(t[o>>2]|0)==0:0){m=50;break}if(((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[n>>2]|0);if(t[(t[n>>2]|0)+292>>2]|0)continue;if(((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;CS(t[n>>2]|0)}if((m|0)==50)BS(t[n>>2]|0,1,69352);do if(((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+56>>2]|0)!=0:0)?(t[(t[n>>2]|0)+212>>2]|0)==0:0){m=t[(t[t[n>>2]>>2]|0)+56>>2]|0;o=t[(t[n>>2]|0)+4>>2]|0;h=t[f>>2]|0;if((t[l>>2]|0)>0){yAi[m&511](o,h,t[c>>2]|0);break}else{yAi[m&511](o,h,0);break}}while(0);e:do if(t[c>>2]|0){t[k>>2]=1;while(1){if((t[k>>2]|0)>=(t[l>>2]|0))break e;if(t[(t[c>>2]|0)+(t[k>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[c>>2]|0)+(t[k>>2]<<2)>>2]|0);t[k>>2]=(t[k>>2]|0)+2}}while(0);t[r>>2]=t[f>>2];v=t[r>>2]|0;s=i;return v|0}function WE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;i=s;s=s+48|0;r=i+44|0;f=i+40|0;a=i+36|0;o=i+32|0;c=i+28|0;l=i+24|0;b=i+20|0;k=i+16|0;h=i+12|0;w=i+8|0;d=i+4|0;v=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=0;t[o>>2]=100;t[d>>2]=0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=67){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=68){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=65){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=65){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=91){s=i;return}e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+9;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;t[(t[r>>2]|0)+172>>2]=8;t[c>>2]=Ap(t[r>>2]|0,l)|0;e=t[c>>2]|0;if((t[c>>2]|0)<256){if(!(9<=(e|0)&(t[c>>2]|0)<=10|(t[c>>2]|0)==13|32<=(t[c>>2]|0)))m=20}else if((!(256<=(e|0)&(t[c>>2]|0)<=55295)?!(57344<=(t[c>>2]|0)&(t[c>>2]|0)<=65533):0)?!(65536<=(t[c>>2]|0)&(t[c>>2]|0)<=1114111):0)m=20;if((m|0)==20){AS(t[r>>2]|0,63,0);t[(t[r>>2]|0)+172>>2]=7;s=i;return}e=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){_=e+28|0;t[_>>2]=(t[_>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{_=e+32|0;t[_>>2]=(t[_>>2]|0)+1}_=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[_>>2]=(t[_>>2]|0)+(t[l>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);t[b>>2]=Ap(t[r>>2]|0,k)|0;_=t[b>>2]|0;if((t[b>>2]|0)<256){if(!(9<=(_|0)&(t[b>>2]|0)<=10|(t[b>>2]|0)==13|32<=(t[b>>2]|0)))m=31}else if((!(256<=(_|0)&(t[b>>2]|0)<=55295)?!(57344<=(t[b>>2]|0)&(t[b>>2]|0)<=65533):0)?!(65536<=(t[b>>2]|0)&(t[b>>2]|0)<=1114111):0)m=31;if((m|0)==31){AS(t[r>>2]|0,63,0);t[(t[r>>2]|0)+172>>2]=7;s=i;return}_=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=_+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{e=_+32|0;t[e>>2]=(t[e>>2]|0)+1}e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[k>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);t[h>>2]=Ap(t[r>>2]|0,w)|0;t[f>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;if(!(t[f>>2]|0)){Sp(t[r>>2]|0,0);s=i;return}while(1){e=t[h>>2]|0;do if((t[h>>2]|0)<256)if(9<=(e|0)&(t[h>>2]|0)<=10|(t[h>>2]|0)==13|32<=(t[h>>2]|0))m=44;else p=0;else{if(256<=(e|0)&(t[h>>2]|0)<=55295){m=44;break}if(57344<=(t[h>>2]|0)&(t[h>>2]|0)<=65533){m=44;break}if(65536<=(t[h>>2]|0)&(t[h>>2]|0)<=1114111)m=44;else p=0}while(0);do if((m|0)==44){m=0;if((t[c>>2]|0)!=93|(t[b>>2]|0)!=93){p=1;break}p=(t[h>>2]|0)!=62}while(0);E=t[a>>2]|0;if(!p){m=70;break}if((E+5|0)>=(t[o>>2]|0)){if((t[o>>2]|0)>1e7?(t[(t[r>>2]|0)+360>>2]&524288|0)==0:0){m=50;break}t[v>>2]=MAi[t[135760>>2]&511](t[f>>2]|0,t[o>>2]<<1)|0;if(!(t[v>>2]|0)){m=52;break}t[f>>2]=t[v>>2];t[o>>2]=t[o>>2]<<1}if((t[l>>2]|0)==1){e=t[c>>2]&255;_=t[a>>2]|0;t[a>>2]=_+1;n[(t[f>>2]|0)+_>>0]=e}else{e=Rp((t[f>>2]|0)+(t[a>>2]|0)|0,t[c>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+e}t[c>>2]=t[b>>2];t[l>>2]=t[k>>2];t[b>>2]=t[h>>2];t[k>>2]=t[w>>2];t[d>>2]=(t[d>>2]|0)+1;if((t[d>>2]|0)>50){do if(!(t[(t[r>>2]|0)+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[r>>2]|0)}while(0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){m=62;break}t[d>>2]=0}e=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){_=e+28|0;t[_>>2]=(t[_>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{_=e+32|0;t[_>>2]=(t[_>>2]|0)+1}_=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[_>>2]=(t[_>>2]|0)+(t[w>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);t[h>>2]=Ap(t[r>>2]|0,w)|0}if((m|0)==50){MS(t[r>>2]|0,63,69400,0);pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}else if((m|0)==52){pAi[t[135736>>2]&511](t[f>>2]|0);Sp(t[r>>2]|0,0);s=i;return}else if((m|0)==62){pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}else if((m|0)==70){n[(t[f>>2]|0)+E>>0]=0;t[(t[r>>2]|0)+172>>2]=7;E=t[r>>2]|0;if((t[h>>2]|0)!=62){MS(E,63,69432,t[f>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}h=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[E+36>>2]|0)+16>>2]>>0]|0|0)==10){E=h+28|0;t[E>>2]=(t[E>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{E=h+32|0;t[E>>2]=(t[E>>2]|0)+1}E=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[E>>2]=(t[E>>2]|0)+(t[w>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);do if(t[t[r>>2]>>2]|0){if(t[(t[r>>2]|0)+212>>2]|0)break;w=t[t[r>>2]>>2]|0;if(t[(t[t[r>>2]>>2]|0)+100>>2]|0){yAi[t[w+100>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[f>>2]|0,t[a>>2]|0);break}if(!(t[w+68>>2]|0))break;yAi[t[(t[t[r>>2]>>2]|0)+68>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[f>>2]|0,t[a>>2]|0)}while(0);pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}}function KE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);while(1){if(!(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){o=45;break}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){o=45;break}if((t[(t[r>>2]|0)+172>>2]|0)==-1){o=45;break}t[n>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];t[f>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2];t[a>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];if((u[t[a>>2]>>0]|0|0)==60?(u[(t[a>>2]|0)+1>>0]|0|0)==63:0)FE(t[r>>2]|0);else o=11;do if((o|0)==11){o=0;if(((((((((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==91:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==67:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==68:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==65:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==84:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==65:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==91:0){WE(t[r>>2]|0);break}if((((u[t[a>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){gE(t[r>>2]|0);t[(t[r>>2]|0)+172>>2]=7;break}if((u[t[a>>2]>>0]|0|0)==60){XE(t[r>>2]|0);break}e=t[r>>2]|0;if((u[t[a>>2]>>0]|0|0)==38){jE(e);break}else{EE(e,0);break}}while(0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);while(1){if(!(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0))c=(t[(t[r>>2]|0)+40>>2]|0)>1;else c=0;l=t[r>>2]|0;if(!c)break;aE(l)|0}if(((t[l+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[r>>2]|0);if((t[f>>2]|0)!=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0))continue;if((t[n>>2]|0)==(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)){o=44;break}}if((o|0)==44){AS(t[r>>2]|0,1,69472);t[(t[r>>2]|0)+172>>2]=-1;s=i;return}else if((o|0)==45){s=i;return}}function XE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+64|0;r=i+48|0;n=i+44|0;f=i+40|0;a=i+36|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=0;t[l>>2]=0;t[k>>2]=t[(t[r>>2]|0)+328>>2];if((t[(t[r>>2]|0)+188>>2]|0)>>>0>(t[16304]|0)>>>0?(t[(t[r>>2]|0)+360>>2]&524288|0)==0:0){OS(t[r>>2]|0,1,65224,t[16304]|0);t[(t[r>>2]|0)+172>>2]=-1;s=i;return}if(t[(t[r>>2]|0)+68>>2]|0){t[o+4>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0));t[o+8>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2]}e=t[r>>2]|0;do if(t[(t[r>>2]|0)+236>>2]|0){h=t[r>>2]|0;if((t[t[e+232>>2]>>2]|0)==-2){og(h,-1)|0;break}else{og(h,t[t[(t[r>>2]|0)+232>>2]>>2]|0)|0;break}}else og(e,-1)|0;while(0);t[c>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2];e=t[r>>2]|0;if(t[(t[r>>2]|0)+324>>2]|0)t[n>>2]=cg(e,f,a,l)|0;else t[n>>2]=GE(e)|0;if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}e=t[r>>2]|0;if(!(t[n>>2]|0)){lg(e)|0;s=i;return}fE(e,t[n>>2]|0)|0;t[b>>2]=t[(t[r>>2]|0)+52>>2];if(((((t[(t[r>>2]|0)+104>>2]|0)!=0?(t[(t[r>>2]|0)+12>>2]|0)!=0:0)?(t[(t[r>>2]|0)+8>>2]|0)!=0:0)?(t[(t[r>>2]|0)+52>>2]|0)!=0:0)?(t[(t[r>>2]|0)+52>>2]|0)==(t[(t[(t[r>>2]|0)+8>>2]|0)+12>>2]|0):0){e=kR((t[r>>2]|0)+108|0,t[(t[r>>2]|0)+8>>2]|0)|0;h=(t[r>>2]|0)+100|0;t[h>>2]=t[h>>2]&e}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;e=(t[t[r>>2]>>2]|0)!=0;if(t[(t[r>>2]|0)+324>>2]|0){if((e?(t[(t[t[r>>2]>>2]|0)+120>>2]|0)!=0:0)?(t[(t[r>>2]|0)+212>>2]|0)==0:0)NAi[t[(t[t[r>>2]>>2]|0)+120>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,t[f>>2]|0,t[a>>2]|0)}else if((e?(t[(t[t[r>>2]>>2]|0)+60>>2]|0)!=0:0)?(t[(t[r>>2]|0)+212>>2]|0)==0:0)EAi[t[(t[t[r>>2]>>2]|0)+60>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0);tE(t[r>>2]|0)|0;lg(t[r>>2]|0)|0;if((t[k>>2]|0)!=(t[(t[r>>2]|0)+328>>2]|0))sg(t[r>>2]|0,(t[(t[r>>2]|0)+328>>2]|0)-(t[k>>2]|0)|0)|0;if(!(t[b>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+68>>2]|0)){s=i;return}t[o+12>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0));t[o+16>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2];t[o>>2]=t[b>>2];Vp(t[r>>2]|0,o);s=i;return}e=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){bg(e,73,69512,t[n>>2]|0,t[c>>2]|0,0);nE(t[r>>2]|0)|0;tE(t[r>>2]|0)|0;lg(t[r>>2]|0)|0;if((t[k>>2]|0)!=(t[(t[r>>2]|0)+328>>2]|0))sg(t[r>>2]|0,(t[(t[r>>2]|0)+328>>2]|0)-(t[k>>2]|0)|0)|0;if(!(t[b>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+68>>2]|0)){s=i;return}t[o+12>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0));t[o+16>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2];t[o>>2]=t[b>>2];Vp(t[r>>2]|0,o);s=i;return}h=(t[e+36>>2]|0)+32|0;t[h>>2]=(t[h>>2]|0)+1;h=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[h>>2]=(t[h>>2]|0)+1;h=(t[r>>2]|0)+200|0;t[h>>2]=(t[h>>2]|0)+1;if(!(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;KE(t[r>>2]|0);if((t[(t[r>>2]|0)+172>>2]|0)==-1){s=i;return}if(!(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))w=55;if(((w|0)==55?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0)?32>(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0){bg(t[r>>2]|0,77,69560,t[n>>2]|0,t[c>>2]|0,0);nE(t[r>>2]|0)|0;tE(t[r>>2]|0)|0;lg(t[r>>2]|0)|0;if((t[k>>2]|0)==(t[(t[r>>2]|0)+328>>2]|0)){s=i;return}sg(t[r>>2]|0,(t[(t[r>>2]|0)+328>>2]|0)-(t[k>>2]|0)|0)|0;s=i;return}n=t[r>>2]|0;if(t[(t[r>>2]|0)+324>>2]|0){kg(n,t[f>>2]|0,t[a>>2]|0,t[c>>2]|0,(t[(t[r>>2]|0)+328>>2]|0)-(t[k>>2]|0)|0,t[l>>2]|0);tE(t[r>>2]|0)|0}else ag(n,t[c>>2]|0);if(!(t[b>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+68>>2]|0)){s=i;return}t[o+12>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0));t[o+16>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+28>>2];t[o>>2]=t[b>>2];Vp(t[r>>2]|0,o);s=i;return}function ZE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+32|0;r=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i+24|0;b=i;t[f>>2]=e;t[a>>2]=0;t[o>>2]=0;t[c>>2]=10;t[a>>2]=gAi[t[135752>>2]&511](t[c>>2]|0)|0;e=t[f>>2]|0;if(!(t[a>>2]|0)){Sp(e,0);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}n[l>>0]=n[t[(t[e+36>>2]|0)+16>>2]>>0]|0;if((u[l>>0]|0|0)>=48?(u[l>>0]|0|0)<=57:0){e=n[l>>0]|0;h=t[o>>2]|0;t[o>>2]=h+1;n[(t[a>>2]|0)+h>>0]=e;Op(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((u[l>>0]|0|0)!=46){pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}e=n[l>>0]|0;h=t[o>>2]|0;t[o>>2]=h+1;n[(t[a>>2]|0)+h>>0]=e;Op(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;while(1){if((u[l>>0]|0|0)>=48)w=(u[l>>0]|0|0)<=57;else w=0;d=t[o>>2]|0;if(!w){v=17;break}if((d+1|0)>=(t[c>>2]|0)){t[c>>2]=t[c>>2]<<1;t[b>>2]=MAi[t[135760>>2]&511](t[a>>2]|0,t[c>>2]|0)|0;if(!(t[b>>2]|0)){v=14;break}t[a>>2]=t[b>>2]}e=n[l>>0]|0;h=t[o>>2]|0;t[o>>2]=h+1;n[(t[a>>2]|0)+h>>0]=e;Op(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0}if((v|0)==14){pAi[t[135736>>2]&511](t[a>>2]|0);Sp(t[f>>2]|0,0);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}else if((v|0)==17){n[(t[a>>2]|0)+d>>0]=0;t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}}pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}function JE(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+32|0;r=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i+24|0;b=i;t[f>>2]=e;t[a>>2]=0;t[o>>2]=0;t[c>>2]=10;n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((u[l>>0]|0|0)>=97?(u[l>>0]|0|0)<=122:0)k=5;else k=3;do if((k|0)==3){if((u[l>>0]|0|0)>=65?(u[l>>0]|0|0)<=90:0){k=5;break}AS(t[f>>2]|0,79,0)}while(0);do if((k|0)==5){t[a>>2]=gAi[t[135752>>2]&511](t[c>>2]|0)|0;if(!(t[a>>2]|0)){Sp(t[f>>2]|0,0);t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}e=n[l>>0]|0;w=t[o>>2]|0;t[o>>2]=w+1;n[(t[a>>2]|0)+w>>0]=e;Op(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;while(1){if((u[l>>0]|0|0)>=97?(u[l>>0]|0|0)<=122:0)d=1;else k=10;do if((k|0)==10){k=0;if((u[l>>0]|0|0)>=65?(u[l>>0]|0|0)<=90:0){d=1;break}if((u[l>>0]|0|0)>=48?(u[l>>0]|0|0)<=57:0){d=1;break}if((u[l>>0]|0|0)!=46?(u[l>>0]|0|0)!=95:0)d=(u[l>>0]|0|0)==45;else d=1}while(0);v=t[o>>2]|0;if(!d){k=31;break}if((v+1|0)>=(t[c>>2]|0)){t[c>>2]=t[c>>2]<<1;t[b>>2]=MAi[t[135760>>2]&511](t[a>>2]|0,t[c>>2]|0)|0;if(!(t[b>>2]|0))break;t[a>>2]=t[b>>2]}e=n[l>>0]|0;w=t[o>>2]|0;t[o>>2]=w+1;n[(t[a>>2]|0)+w>>0]=e;Op(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if(u[l>>0]|0)continue;if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);n[l>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0}if((k|0)==31){n[(t[a>>2]|0)+v>>0]=0;break}Sp(t[f>>2]|0,0);pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}while(0);t[r>>2]=t[a>>2];h=t[r>>2]|0;s=i;return h|0}function QE(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=-2;uE(t[n>>2]|0)|0;do if((((((((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==115?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==116:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==97:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==110:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==100:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==97:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==108:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==111:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==110:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+9>>0]|0|0)==101:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+10;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+10;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+10;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;uE(t[n>>2]|0)|0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){AS(e,75,0);t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}Op(e);uE(t[n>>2]|0)|0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39){Op(e);do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==110?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==111:0){t[f>>2]=0;o=(t[n>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+2;o=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+2;o=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+2;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[n>>2]|0)|0}else c=26;while(0);e:do if((c|0)==26){do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==121){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=101)break;if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=115)break;t[f>>2]=1;o=(t[n>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+3;o=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+3;o=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break e;if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)break e;aE(t[n>>2]|0)|0;break e}while(0);AS(t[n>>2]|0,78,0)}while(0);o=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){AS(o,34,0);break}else{Op(o);break}}o=t[n>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=34){AS(o,33,0);break}Op(o);do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==110?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==111:0){t[f>>2]=0;o=(t[n>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+2;o=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+2;o=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+2;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[n>>2]|0)|0}else c=46;while(0);e:do if((c|0)==46){do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==121){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=101)break;if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=115)break;t[f>>2]=1;e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break e;if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)break e;aE(t[n>>2]|0)|0;break e}while(0);AS(t[n>>2]|0,78,0)}while(0);e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){AS(e,34,0);break}else{Op(e);break}}while(0);t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function $E(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[(t[(t[r>>2]|0)+36>>2]|0)+52>>2]=-2;e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+5;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+5;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)BS(t[r>>2]|0,65,69720)}while(0);uE(t[r>>2]|0)|0;t[n>>2]=xE(t[r>>2]|0)|0;if(!(t[n>>2]|0))AS(t[r>>2]|0,96,0);else{do if(!(Xl(t[n>>2]|0,68488)|0)){if(t[(t[r>>2]|0)+360>>2]&131072){MS(t[r>>2]|0,108,69752,t[n>>2]|0);break}if((u[t[n>>2]>>0]|0|0)==49?(u[(t[n>>2]|0)+1>>0]|0|0)==46:0){NS(t[r>>2]|0,97,69752,t[n>>2]|0,0);break}MS(t[r>>2]|0,108,69752,t[n>>2]|0)}while(0);if(t[(t[r>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0);t[(t[r>>2]|0)+20>>2]=t[n>>2]}do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){n=(t[r>>2]|0)+200|0;t[n>>2]=(t[n>>2]|0)+2;n=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+2;n=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[n>>2]=(t[n>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[r>>2]|0)|0;s=i;return}BS(t[r>>2]|0,65,69784)}}while(0);UE(t[r>>2]|0)|0;if((t[(t[r>>2]|0)+84>>2]|0)==32){s=i;return}do if((t[(t[(t[r>>2]|0)+36>>2]|0)+44>>2]|0)!=0?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32:0){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){n=(t[r>>2]|0)+200|0;t[n>>2]=(t[n>>2]|0)+2;n=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+2;n=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[n>>2]=(t[n>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[r>>2]|0)|0;s=i;return}BS(t[r>>2]|0,65,69784)}}while(0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[r>>2]|0);uE(t[r>>2]|0)|0;n=QE(t[r>>2]|0)|0;t[(t[(t[r>>2]|0)+36>>2]|0)+52>>2]=n;uE(t[r>>2]|0)|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){n=(t[r>>2]|0)+200|0;t[n>>2]=(t[n>>2]|0)+2;n=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+2;n=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[n>>2]=(t[n>>2]|0)+2;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[r>>2]|0);if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[r>>2]|0)|0;s=i;return}n=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62;AS(t[r>>2]|0,57,0);if(n){Op(t[r>>2]|0);s=i;return}while(1){if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0)f=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62;else f=0;a=t[r>>2]|0;if(!f)break;n=(t[a+36>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+1}Op(a);
	s=i;return}function eS(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e:while(1){if((t[(t[r>>2]|0)+172>>2]|0)==-1){n=22;break}if(!((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0))n=5;do if((n|0)==5){n=0;if((((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){n=22;break e}}}while(0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0){FE(t[r>>2]|0);continue}do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){gE(t[r>>2]|0);continue e}}while(0);Op(t[r>>2]|0)}if((n|0)==22){s=i;return}}function iS(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;a=i+12|0;o=i;t[f>>2]=e;rS();if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0){if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);rg(t[f>>2]|0);if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+44>>2]|0)!=0:0)EAi[t[(t[t[f>>2]>>2]|0)+44>>2]&511](t[(t[f>>2]|0)+4>>2]|0,136080);if((t[(t[f>>2]|0)+172>>2]|0)==-1){t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}if(((t[(t[f>>2]|0)+24>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0)?(n[a>>0]=n[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0,n[a+1>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,n[a+2>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,n[a+3>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,t[o>>2]=L_(a,4)|0,(t[o>>2]|0)!=0):0)Tp(t[f>>2]|0,t[o>>2]|0)|0;if(!(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))AS(t[f>>2]|0,4,0);if((((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<35?(t[(t[f>>2]|0)+292>>2]|0)==0:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);e:do if(((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13){l=34;break e}}while(0);$E(t[f>>2]|0);if((t[(t[f>>2]|0)+84>>2]|0)!=32){t[(t[f>>2]|0)+28>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+52>>2];uE(t[f>>2]|0)|0;break}t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}else l=34;while(0);if((l|0)==34){l=Wl(68488)|0;t[(t[f>>2]|0)+20>>2]=l}if(((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+48>>2]|0)!=0:0)?(t[(t[f>>2]|0)+212>>2]|0)==0:0)pAi[t[(t[t[f>>2]>>2]|0)+48>>2]&511](t[(t[f>>2]|0)+4>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}if((((t[(t[f>>2]|0)+8>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[f>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[t[(t[f>>2]|0)+36>>2]>>2]|0)+24>>2]|0)>=0:0)t[(t[(t[f>>2]|0)+8>>2]|0)+36>>2]=t[(t[t[(t[f>>2]|0)+36>>2]>>2]|0)+24>>2];if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);eS(t[f>>2]|0);if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);do if((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==68:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0){if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=67)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=84)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=89)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=80)break;if((u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=69)break;t[(t[f>>2]|0)+216>>2]=1;qE(t[f>>2]|0);do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){t[(t[f>>2]|0)+172>>2]=3;hg(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)!=-1)break;t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}while(0);t[(t[f>>2]|0)+216>>2]=2;do if(t[t[f>>2]>>2]|0){if(!(t[(t[t[f>>2]>>2]|0)+104>>2]|0))break;if(t[(t[f>>2]|0)+212>>2]|0)break;NAi[t[(t[t[f>>2]>>2]|0)+104>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[(t[f>>2]|0)+220>>2]|0,t[(t[f>>2]|0)+228>>2]|0,t[(t[f>>2]|0)+224>>2]|0)}while(0);if((t[(t[f>>2]|0)+172>>2]|0)!=-1){t[(t[f>>2]|0)+216>>2]=0;wg(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=4;eS(t[f>>2]|0);break}t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}while(0);if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);l=t[f>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60)BS(l,4,69808);else{t[l+172>>2]=7;XE(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=14;eS(t[f>>2]|0);if(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)AS(t[f>>2]|0,5,0);t[(t[f>>2]|0)+172>>2]=-1}do if(t[t[f>>2]>>2]|0){if(!(t[(t[t[f>>2]>>2]|0)+52>>2]|0))break;pAi[t[(t[t[f>>2]>>2]|0)+52>>2]&511](t[(t[f>>2]|0)+4>>2]|0)}while(0);do if(t[(t[f>>2]|0)+8>>2]|0){if(!(Xl(t[(t[(t[f>>2]|0)+8>>2]|0)+56>>2]|0,67096)|0))break;fy(t[(t[f>>2]|0)+8>>2]|0);t[(t[f>>2]|0)+8>>2]=0}while(0);do if(t[(t[f>>2]|0)+12>>2]|0){if(!(t[(t[f>>2]|0)+8>>2]|0))break;l=(t[(t[f>>2]|0)+8>>2]|0)+92|0;t[l>>2]=t[l>>2]|1;if(t[(t[f>>2]|0)+100>>2]|0){l=(t[(t[f>>2]|0)+8>>2]|0)+92|0;t[l>>2]=t[l>>2]|8}if(t[(t[f>>2]|0)+356>>2]|0){l=(t[(t[f>>2]|0)+8>>2]|0)+92|0;t[l>>2]=t[l>>2]|2}if(!(t[(t[f>>2]|0)+360>>2]&131072))break;l=(t[(t[f>>2]|0)+8>>2]|0)+92|0;t[l>>2]=t[l>>2]|4}while(0);if(t[(t[f>>2]|0)+12>>2]|0){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else{t[(t[f>>2]|0)+100>>2]=0;t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}}t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}function rS(){var e=0;e=s;if(t[17532]|0){s=e;return}fl();qc();if((t[33976]|0)==35|(t[33976]|0)==0)up(0);yA()|0;uz()|0;U_();rj();LO();DO();bN();fj();kn();tc();t[17532]=1;s=e;return}function nS(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0;u=s;s=s+96|0;a=u;o=u+80|0;c=u+76|0;l=u+72|0;b=u+68|0;k=u+64|0;h=u+60|0;w=u+56|0;d=u+52|0;v=u+48|0;m=u+44|0;_=u+40|0;p=u+36|0;E=u+32|0;S=u+28|0;g=u+24|0;y=u+20|0;F=u+16|0;O=u+12|0;A=u+8|0;M=u+4|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;if(!(t[c>>2]|0)){t[o>>2]=1;R=t[o>>2]|0;s=u;return R|0}if((t[(t[c>>2]|0)+84>>2]|0)!=0?(t[(t[c>>2]|0)+212>>2]|0)==1:0){t[o>>2]=t[(t[c>>2]|0)+84>>2];R=t[o>>2]|0;s=u;return R|0}if((t[(t[c>>2]|0)+172>>2]|0)==-1){t[o>>2]=-1;R=t[o>>2]|0;s=u;return R|0}if(!(t[(t[c>>2]|0)+172>>2]|0))rg(t[c>>2]|0);if(!((t[b>>2]|0)>0&(t[l>>2]|0)!=0^1|(t[k>>2]|0)!=0)?(n[(t[l>>2]|0)+((t[b>>2]|0)-1)>>0]|0)==13:0){t[h>>2]=1;t[b>>2]=(t[b>>2]|0)+-1}while(1){if((((t[b>>2]|0)>0&(t[l>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[c>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[c>>2]|0)+172>>2]|0)!=-1:0){t[m>>2]=js(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+36>>2]|0)|0;t[_>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0);t[d>>2]=Ts(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;do if((((t[(t[c>>2]|0)+172>>2]|0)==0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[c>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+12>>2]|0)!=0:0){t[E>>2]=45;do if((ns(t[t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69608)|0)==0?(ns(t[t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69616)|0)==0:0){if((ns(t[t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69848)|0)==0?(ns(t[t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69856)|0)==0:0)break;t[E>>2]=180}else N=23;while(0);if((N|0)==23){N=0;t[E>>2]=90}if((t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+32>>2]|0)>>>0<(t[E>>2]|0)>>>0)t[E>>2]=(t[E>>2]|0)-(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+32>>2]|0);if((t[b>>2]|0)>>>0>(t[E>>2]|0)>>>0){t[w>>2]=(t[b>>2]|0)-(t[E>>2]|0);t[b>>2]=t[E>>2];break}else{t[w>>2]=0;break}}while(0);t[p>>2]=ZO(t[t[(t[c>>2]|0)+36>>2]>>2]|0,t[b>>2]|0,t[l>>2]|0)|0;T=t[c>>2]|0;if((t[p>>2]|0)<0){N=33;break}Vs(t[(t[t[T+36>>2]>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+36>>2]|0,t[m>>2]|0,t[_>>2]|0)|0}else N=35;if(((((((N|0)==35?(N=0,(t[(t[c>>2]|0)+172>>2]|0)!=-1):0)?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[c>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[S>>2]=t[t[(t[c>>2]|0)+36>>2]>>2],(t[(t[S>>2]|0)+12>>2]|0)!=0):0)?(t[(t[S>>2]|0)+16>>2]|0)!=0:0)?(t[(t[S>>2]|0)+20>>2]|0)!=0:0){t[y>>2]=js(t[(t[S>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+36>>2]|0)|0;t[F>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0);t[g>>2]=Y_(t[S>>2]|0,t[k>>2]|0)|0;if((t[g>>2]|0)<0){N=42;break}Vs(t[(t[S>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+36>>2]|0,t[y>>2]|0,t[F>>2]|0)|0}f=t[c>>2]|0;do if(t[w>>2]|0)dg(f,0)|0;else{if((t[f+36>>2]|0)!=0?(t[t[(t[c>>2]|0)+36>>2]>>2]|0)!=0:0)t[v>>2]=Ts(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;if(!((t[k>>2]|0)!=0|(t[v>>2]|0)>>>0>1e7|(t[d>>2]|0)==0|(t[v>>2]|0)==0)?(vg(t[c>>2]|0,(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)+(t[d>>2]|0)|0,(t[v>>2]|0)-(t[d>>2]|0)|0)|0)==0:0)break;dg(t[c>>2]|0,t[k>>2]|0)|0}while(0);L=t[c>>2]|0;if((t[(t[c>>2]|0)+172>>2]|0)==-1){N=53;break}do if(t[L+36>>2]|0){if(((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<=1e7?((t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)|0)<=1e7:0)break;if(!(t[(t[c>>2]|0)+360>>2]&524288)){AS(t[c>>2]|0,1,69896);t[(t[c>>2]|0)+172>>2]=-1}}while(0);if((t[(t[c>>2]|0)+84>>2]|0)!=0?(t[(t[c>>2]|0)+212>>2]|0)==1:0){N=61;break}if(!(t[w>>2]|0)){N=64;break}t[l>>2]=(t[l>>2]|0)+(t[b>>2]|0);t[b>>2]=t[w>>2];t[w>>2]=0}if((N|0)==33){t[T+84>>2]=-1;t[(t[c>>2]|0)+212>>2]=1;t[o>>2]=-1;R=t[o>>2]|0;s=u;return R|0}else if((N|0)==42){yAi[t[135904>>2]&511](t[33980]|0,69864,a);t[o>>2]=81;R=t[o>>2]|0;s=u;return R|0}else if((N|0)==53){t[o>>2]=t[L+84>>2];R=t[o>>2]|0;s=u;return R|0}else if((N|0)==61){t[o>>2]=t[(t[c>>2]|0)+84>>2];R=t[o>>2]|0;s=u;return R|0}else if((N|0)==64){if(((t[h>>2]|0)==1?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[c>>2]|0)+36>>2]>>2]|0)!=0:0){t[O>>2]=js(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+36>>2]|0)|0;t[A>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0);ZO(t[t[(t[c>>2]|0)+36>>2]>>2]|0,1,69920)|0;Vs(t[(t[t[(t[c>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+36>>2]|0,t[O>>2]|0,t[A>>2]|0)|0}if(t[k>>2]|0){t[M>>2]=0;do if(t[(t[c>>2]|0)+36>>2]|0){k=t[(t[c>>2]|0)+36>>2]|0;if(!(t[t[(t[c>>2]|0)+36>>2]>>2]|0)){t[M>>2]=(t[k+24>>2]|0)-((t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0));break}else{A=Ts(t[(t[k>>2]|0)+16>>2]|0)|0;t[M>>2]=A-((t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0));break}}while(0);if((t[(t[c>>2]|0)+172>>2]|0)!=-1?(t[(t[c>>2]|0)+172>>2]|0)!=14:0)AS(t[c>>2]|0,5,0);if((t[M>>2]|0)>0?(t[(t[c>>2]|0)+172>>2]|0)==14:0)AS(t[c>>2]|0,5,0);if(((t[(t[c>>2]|0)+172>>2]|0)!=-1?(t[t[c>>2]>>2]|0)!=0:0)?(t[(t[t[c>>2]>>2]|0)+52>>2]|0)!=0:0)pAi[t[(t[t[c>>2]>>2]|0)+52>>2]&511](t[(t[c>>2]|0)+4>>2]|0);t[(t[c>>2]|0)+172>>2]=-1}if(!(t[(t[c>>2]|0)+12>>2]|0)){t[o>>2]=t[(t[c>>2]|0)+84>>2];R=t[o>>2]|0;s=u;return R|0}else{t[o>>2]=0;R=t[o>>2]|0;s=u;return R|0}}return 0}function fS(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+48|0;a=u+44|0;o=u+40|0;c=u+36|0;l=u+32|0;b=u+28|0;k=u+24|0;h=u+20|0;w=u+16|0;d=u+12|0;v=u+8|0;m=u+4|0;_=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[v>>2]=0;if((t[l>>2]|0)!=0&(t[b>>2]|0)>=4)t[v>>2]=L_(t[l>>2]|0,t[b>>2]|0)|0;t[d>>2]=CO(t[v>>2]|0)|0;if(!(t[d>>2]|0)){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}t[h>>2]=zp()|0;if(!(t[h>>2]|0)){Sp(0,69928);IO(t[d>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}t[(t[h>>2]|0)+364>>2]=1;f=gAi[t[135744>>2]&511]((t[(t[h>>2]|0)+192>>2]|0)*3<<2)|0;t[(t[h>>2]|0)+344>>2]=f;if(!(t[(t[h>>2]|0)+344>>2]|0)){Sp(t[h>>2]|0,0);IO(t[d>>2]|0);Up(t[h>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}if(t[o>>2]|0){if((t[t[h>>2]>>2]|0)!=135968)pAi[t[135736>>2]&511](t[t[h>>2]>>2]|0);f=gAi[t[135744>>2]&511](128)|0;t[t[h>>2]>>2]=f;f=t[h>>2]|0;if(!(t[t[h>>2]>>2]|0)){Sp(f,0);IO(t[d>>2]|0);Up(t[h>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}n=(t[f>>2]|0)+0|0;f=n+128|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(f|0));r=t[t[h>>2]>>2]|0;i=t[o>>2]|0;if((t[(t[o>>2]|0)+108>>2]|0)==-554844497){n=r+0|0;E=i+0|0;f=n+128|0;do{t[n>>2]=t[E>>2];n=n+4|0;E=E+4|0}while((n|0)<(f|0))}else{n=r+0|0;E=i+0|0;f=n+112|0;do{t[n>>2]=t[E>>2];n=n+4|0;E=E+4|0}while((n|0)<(f|0))}if(t[c>>2]|0)t[(t[h>>2]|0)+4>>2]=t[c>>2]}if(!(t[k>>2]|0))t[(t[h>>2]|0)+180>>2]=0;else{c=rA(t[k>>2]|0)|0;t[(t[h>>2]|0)+180>>2]=c}t[w>>2]=Cp(t[h>>2]|0)|0;if(!(t[w>>2]|0)){Up(t[h>>2]|0);IO(t[d>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}if(t[k>>2]|0){c=KA(t[k>>2]|0)|0;t[(t[w>>2]|0)+4>>2]=c;if(!(t[(t[w>>2]|0)+4>>2]|0)){Up(t[h>>2]|0);IO(t[d>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else t[(t[w>>2]|0)+4>>2]=0;t[t[w>>2]>>2]=t[d>>2];zs(t[(t[t[w>>2]>>2]|0)+16>>2]|0,t[w>>2]|0)|0;eE(t[h>>2]|0,t[w>>2]|0)|0;w=t[h>>2]|0;if(!((t[b>>2]|0)==0|(t[l>>2]|0)==0)){if((t[w+36>>2]|0)!=0?(t[t[(t[h>>2]|0)+36>>2]>>2]|0)!=0:0){t[m>>2]=js(t[(t[t[(t[h>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[h>>2]|0)+36>>2]|0)|0;t[_>>2]=(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[h>>2]|0)+36>>2]|0)+12>>2]|0);ZO(t[t[(t[h>>2]|0)+36>>2]>>2]|0,t[b>>2]|0,t[l>>2]|0)|0;Vs(t[(t[t[(t[h>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[h>>2]|0)+36>>2]|0,t[m>>2]|0,t[_>>2]|0)|0}}else t[w+256>>2]=0;if(t[v>>2]|0)Tp(t[h>>2]|0,t[v>>2]|0)|0;t[a>>2]=t[h>>2];p=t[a>>2]|0;s=u;return p|0}function tS(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[(t[r>>2]|0)+172>>2]=-1;t[(t[r>>2]|0)+84>>2]=111;t[(t[r>>2]|0)+212>>2]=1;if(!(t[(t[r>>2]|0)+36>>2]|0)){s=i;return}t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]=65640;t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];s=i;return}function uS(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[b>>2]=0;if((t[a>>2]|0)==0&(t[o>>2]|0)==0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[l>>2]=zp()|0;if(!(t[l>>2]|0)){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}r=(t[l>>2]|0)+360|0;t[r>>2]=t[r>>2]|4;if(t[u>>2]|0){if(t[t[l>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[l>>2]>>2]|0);t[t[l>>2]>>2]=t[u>>2];t[(t[l>>2]|0)+4>>2]=t[l>>2]}t[h>>2]=KA(t[o>>2]|0)|0;r=t[l>>2]|0;if((t[o>>2]|0)!=0&(t[h>>2]|0)==0){Up(r);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if((t[r>>2]|0)!=0?(t[(t[t[l>>2]>>2]|0)+16>>2]|0)!=0:0)t[b>>2]=dAi[t[(t[t[l>>2]>>2]|0)+16>>2]&511](t[(t[l>>2]|0)+4>>2]|0,t[a>>2]|0,t[h>>2]|0)|0;if(!(t[b>>2]|0)){if(t[u>>2]|0)t[t[l>>2]>>2]=0;Up(t[l>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if((cE(t[l>>2]|0,t[b>>2]|0)|0)<0){if(t[u>>2]|0)t[t[l>>2]>>2]=0;Up(t[l>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if(((t[(t[(t[l>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4){t[k>>2]=L_(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0,4)|0;Tp(t[l>>2]|0,t[k>>2]|0)|0}if(!(t[(t[b>>2]|0)+4>>2]|0))t[(t[b>>2]|0)+4>>2]=t[h>>2];else pAi[t[135736>>2]&511](t[h>>2]|0);t[(t[b>>2]|0)+28>>2]=1;t[(t[b>>2]|0)+32>>2]=1;t[(t[b>>2]|0)+12>>2]=t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2];t[(t[b>>2]|0)+16>>2]=t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2];t[(t[b>>2]|0)+40>>2]=0;t[(t[l>>2]|0)+216>>2]=2;b=ny(68488)|0;t[(t[l>>2]|0)+8>>2]=b;b=t[l>>2]|0;if(!(t[(t[l>>2]|0)+8>>2]|0)){Sp(b,67128);if(t[u>>2]|0)t[t[l>>2]>>2]=0;Up(t[l>>2]|0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[(t[b+8>>2]|0)+92>>2]=64;b=Jg(t[(t[l>>2]|0)+8>>2]|0,69960,t[a>>2]|0,t[o>>2]|0)|0;t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2]=b;zE(t[l>>2]|0,t[a>>2]|0,t[o>>2]|0);if(t[(t[l>>2]|0)+8>>2]|0){e:do if(t[(t[l>>2]|0)+12>>2]|0){t[c>>2]=t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2];t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2]=0;if(t[c>>2]|0){t[(t[c>>2]|0)+32>>2]=0;t[w>>2]=t[(t[c>>2]|0)+12>>2];while(1){if(!(t[w>>2]|0))break e;t[(t[w>>2]|0)+32>>2]=0;t[w>>2]=t[(t[w>>2]|0)+24>>2]}}}else t[c>>2]=0;while(0);fy(t[(t[l>>2]|0)+8>>2]|0);t[(t[l>>2]|0)+8>>2]=0}if(t[u>>2]|0)t[t[l>>2]>>2]=0;Up(t[l>>2]|0);t[f>>2]=t[c>>2];d=t[f>>2]|0;s=n;return d|0}function aS(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=uS(0,t[n>>2]|0,t[f>>2]|0)|0;s=r;return i|0}function oS(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;a=s;s=s+64|0;o=a+44|0;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;_=a+48|0;p=a+4|0;E=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[v>>2]=0;t[m>>2]=0;if(!(t[c>>2]|0)){t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}if(!((t[(t[c>>2]|0)+248>>2]|0)>40?(t[(t[c>>2]|0)+360>>2]&524288|0)==0:0))g=5;if((g|0)==5?(t[(t[c>>2]|0)+248>>2]|0)<=1024:0){if(t[k>>2]|0)t[t[k>>2]>>2]=0;if((t[l>>2]|0)==0&(t[b>>2]|0)==0){t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}if(!(t[(t[c>>2]|0)+8>>2]|0)){t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}t[h>>2]=mg(t[l>>2]|0,t[b>>2]|0,0,t[c>>2]|0)|0;if(!(t[h>>2]|0)){t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}t[v>>2]=t[t[h>>2]>>2];t[t[h>>2]>>2]=t[t[c>>2]>>2];rg(t[h>>2]|0);t[w>>2]=ny(68488)|0;if(!(t[w>>2]|0)){Up(t[h>>2]|0);t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}t[(t[w>>2]|0)+92>>2]=64;if(t[(t[(t[c>>2]|0)+8>>2]|0)+80>>2]|0){t[(t[w>>2]|0)+80>>2]=t[(t[(t[c>>2]|0)+8>>2]|0)+80>>2];sz(t[(t[w>>2]|0)+80>>2]|0)|0}if(t[(t[c>>2]|0)+8>>2]|0){t[(t[w>>2]|0)+44>>2]=t[(t[(t[c>>2]|0)+8>>2]|0)+44>>2];t[(t[w>>2]|0)+48>>2]=t[(t[(t[c>>2]|0)+8>>2]|0)+48>>2]}if(t[(t[(t[c>>2]|0)+8>>2]|0)+72>>2]|0){b=Yl(t[(t[(t[c>>2]|0)+8>>2]|0)+72>>2]|0)|0;t[(t[w>>2]|0)+72>>2]=b}t[d>>2]=Sy(t[w>>2]|0,0,69968,0)|0;if(!(t[d>>2]|0)){t[t[h>>2]>>2]=t[v>>2];Up(t[h>>2]|0);t[(t[w>>2]|0)+44>>2]=0;t[(t[w>>2]|0)+48>>2]=0;fy(t[w>>2]|0);t[o>>2]=-1;S=t[o>>2]|0;s=a;return S|0}Hy(t[w>>2]|0,t[d>>2]|0)|0;rE(t[h>>2]|0,t[(t[w>>2]|0)+12>>2]|0)|0;if(!(t[(t[c>>2]|0)+8>>2]|0))t[(t[h>>2]|0)+8>>2]=t[w>>2];else{t[(t[h>>2]|0)+8>>2]=t[(t[c>>2]|0)+8>>2];t[(t[(t[w>>2]|0)+12>>2]|0)+32>>2]=t[(t[c>>2]|0)+8>>2]}if((t[(t[h>>2]|0)+292>>2]|0)==0?((t[(t[(t[h>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[h>>2]|0);if(((t[(t[(t[h>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4?(n[_>>0]=n[t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0,n[_+1>>0]=n[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,n[_+2>>0]=n[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,n[_+3>>0]=n[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,t[p>>2]=L_(_,4)|0,(t[p>>2]|0)!=0):0)Tp(t[h>>2]|0,t[p>>2]|0)|0;e:do if(((u[t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0){if((u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=109)break;if((u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=108)break;do if((u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break e}while(0);bE(t[h>>2]|0);if(!(Xl(t[(t[c>>2]|0)+20>>2]|0,68488)|0))break;if(Xl(t[(t[(t[h>>2]|0)+36>>2]|0)+48>>2]|0,68488)|0)break;BS(t[h>>2]|0,109,69984)}while(0);if((t[(t[c>>2]|0)+4>>2]|0)==(t[c>>2]|0))t[(t[h>>2]|0)+4>>2]=t[h>>2];else t[(t[h>>2]|0)+4>>2]=t[(t[c>>2]|0)+4>>2];t[(t[h>>2]|0)+172>>2]=7;t[(t[h>>2]|0)+104>>2]=t[(t[c>>2]|0)+104>>2];t[(t[h>>2]|0)+100>>2]=t[(t[c>>2]|0)+100>>2];t[(t[h>>2]|0)+276>>2]=t[(t[c>>2]|0)+276>>2];t[(t[h>>2]|0)+248>>2]=(t[(t[c>>2]|0)+248>>2]|0)+1;t[(t[h>>2]|0)+16>>2]=t[(t[c>>2]|0)+16>>2];if(t[(t[h>>2]|0)+104>>2]|0){t[(t[h>>2]|0)+112>>2]=t[(t[c>>2]|0)+112>>2];t[(t[h>>2]|0)+116>>2]=t[(t[c>>2]|0)+116>>2]}else{t[(t[h>>2]|0)+112>>2]=0;t[(t[h>>2]|0)+116>>2]=0}t[(t[h>>2]|0)+132>>2]=0;t[(t[h>>2]|0)+124>>2]=0;t[(t[h>>2]|0)+128>>2]=0;t[(t[h>>2]|0)+120>>2]=0;if(t[(t[h>>2]|0)+296>>2]|0)bz(t[(t[h>>2]|0)+296>>2]|0);t[(t[h>>2]|0)+296>>2]=t[(t[c>>2]|0)+296>>2];p=kz(t[(t[h>>2]|0)+296>>2]|0,70032,3)|0;t[(t[h>>2]|0)+312>>2]=p;p=kz(t[(t[h>>2]|0)+296>>2]|0,70040,5)|0;t[(t[h>>2]|0)+316>>2]=p;p=kz(t[(t[h>>2]|0)+296>>2]|0,70048,36)|0;t[(t[h>>2]|0)+320>>2]=p;t[(t[h>>2]|0)+364>>2]=t[(t[c>>2]|0)+364>>2];t[(t[h>>2]|0)+348>>2]=t[(t[c>>2]|0)+348>>2];t[(t[h>>2]|0)+352>>2]=t[(t[c>>2]|0)+352>>2];t[(t[h>>2]|0)+280>>2]=t[(t[c>>2]|0)+280>>2];KE(t[h>>2]|0);t[(t[c>>2]|0)+104>>2]=t[(t[h>>2]|0)+104>>2];t[(t[c>>2]|0)+100>>2]=t[(t[h>>2]|0)+100>>2];do if((u[t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if((u[(t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=47){g=57;break}AS(t[h>>2]|0,85,0)}else g=57;while(0);do if((g|0)==57){if(!(u[t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;AS(t[h>>2]|0,86,0)}while(0);if((t[(t[h>>2]|0)+52>>2]|0)!=(t[(t[w>>2]|0)+12>>2]|0))AS(t[h>>2]|0,85,0);do if(!(t[(t[h>>2]|0)+12>>2]|0))if(!(t[(t[h>>2]|0)+84>>2]|0)){t[m>>2]=1;break}else{t[m>>2]=t[(t[h>>2]|0)+84>>2];break}else{if(t[k>>2]|0){t[E>>2]=t[(t[(t[w>>2]|0)+12>>2]|0)+12>>2];t[t[k>>2]>>2]=t[E>>2];while(1){if(!(t[E>>2]|0))break;t[(t[E>>2]|0)+20>>2]=0;t[E>>2]=t[(t[E>>2]|0)+24>>2]}t[(t[(t[w>>2]|0)+12>>2]|0)+12>>2]=0}t[m>>2]=0}while(0);t[t[h>>2]>>2]=t[v>>2];t[(t[h>>2]|0)+296>>2]=0;t[(t[h>>2]|0)+348>>2]=0;t[(t[h>>2]|0)+352>>2]=0;Up(t[h>>2]|0);t[(t[w>>2]|0)+44>>2]=0;t[(t[w>>2]|0)+48>>2]=0;fy(t[w>>2]|0);t[o>>2]=t[m>>2];S=t[o>>2]|0;s=a;return S|0}t[o>>2]=89;S=t[o>>2]|0;s=a;return S|0}function cS(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;a=s;s=s+64|0;o=a+60|0;c=a+56|0;l=a+52|0;b=a+48|0;k=a+44|0;h=a+40|0;w=a+36|0;d=a+32|0;v=a+28|0;m=a+24|0;_=a+20|0;p=a+16|0;E=a+12|0;S=a+8|0;g=a+4|0;y=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[d>>2]=0;t[_>>2]=0;t[p>>2]=0;if((t[h>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[b>>2]|0)<0){t[o>>2]=1;F=t[o>>2]|0;s=a;return F|0}switch(t[(t[c>>2]|0)+4>>2]|0){case 13:case 9:case 8:case 7:case 5:case 4:case 3:case 2:case 1:break;default:{t[o>>2]=1;F=t[o>>2]|0;s=a;return F|0}}while(1){if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)!=1:0)?(t[(t[c>>2]|0)+4>>2]|0)!=9:0)O=(t[(t[c>>2]|0)+4>>2]|0)!=13;else O=0;A=t[c>>2]|0;if(!O)break;t[c>>2]=t[A+20>>2]}if(!A){t[o>>2]=1;F=t[o>>2]|0;s=a;return F|0}A=t[c>>2]|0;if((t[(t[c>>2]|0)+4>>2]|0)==1)t[d>>2]=t[A+32>>2];else t[d>>2]=A;if(!(t[d>>2]|0)){t[o>>2]=1;F=t[o>>2]|0;s=a;return F|0}do if((t[(t[d>>2]|0)+4>>2]|0)==9)t[w>>2]=lS(t[l>>2]|0,t[b>>2]|0)|0;else{if((t[(t[d>>2]|0)+4>>2]|0)==13){t[w>>2]=yN(t[l>>2]|0,t[b>>2]|0)|0;t[k>>2]=t[k>>2]|8192;break}t[o>>2]=1;F=t[o>>2]|0;s=a;return F|0}while(0);if(!(t[w>>2]|0)){t[o>>2]=2;F=t[o>>2]|0;s=a;return F|0}if(t[(t[d>>2]|0)+80>>2]|0){if(t[(t[w>>2]|0)+296>>2]|0)bz(t[(t[w>>2]|0)+296>>2]|0);t[(t[w>>2]|0)+296>>2]=t[(t[d>>2]|0)+80>>2]}else t[k>>2]=t[k>>2]|4096;do if(t[(t[d>>2]|0)+60>>2]|0){if(t[(t[w>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[w>>2]|0)+24>>2]|0);b=Yl(t[(t[d>>2]|0)+60>>2]|0)|0;t[(t[w>>2]|0)+24>>2]=b;t[E>>2]=V_(t[(t[d>>2]|0)+60>>2]|0)|0;if(t[E>>2]|0){Lp(t[w>>2]|0,t[E>>2]|0)|0;break}t[o>>2]=32;F=t[o>>2]|0;s=a;return F|0}while(0);_g(t[w>>2]|0,t[k>>2]|0,0)|0;rg(t[w>>2]|0);t[(t[w>>2]|0)+8>>2]=t[d>>2];t[(t[w>>2]|0)+172>>2]=7;t[v>>2]=Ay(0)|0;if(!(t[v>>2]|0)){Up(t[w>>2]|0);t[o>>2]=2;F=t[o>>2]|0;s=a;return F|0}Hy(t[c>>2]|0,t[v>>2]|0)|0;e:do if((t[(t[c>>2]|0)+4>>2]|0)==1){rE(t[w>>2]|0,t[c>>2]|0)|0;t[m>>2]=t[c>>2];while(1){if(!(t[m>>2]|0))break e;if((t[(t[m>>2]|0)+4>>2]|0)!=1)break e;t[S>>2]=t[(t[m>>2]|0)+48>>2];while(1){if(!(t[S>>2]|0))break;if(t[(t[w>>2]|0)+296>>2]|0){t[g>>2]=kz(t[(t[w>>2]|0)+296>>2]|0,t[(t[S>>2]|0)+12>>2]|0,-1)|0;t[y>>2]=kz(t[(t[w>>2]|0)+296>>2]|0,t[(t[S>>2]|0)+8>>2]|0,-1)|0}else{t[g>>2]=t[(t[S>>2]|0)+12>>2];t[y>>2]=t[(t[S>>2]|0)+8>>2]}if(!(pg(t[w>>2]|0,t[g>>2]|0)|0)){Eg(t[w>>2]|0,t[g>>2]|0,t[y>>2]|0)|0;t[_>>2]=(t[_>>2]|0)+1}t[S>>2]=t[t[S>>2]>>2]}t[m>>2]=t[(t[m>>2]|0)+20>>2]}}while(0);if(!((t[(t[w>>2]|0)+104>>2]|0)==0?(t[(t[w>>2]|0)+16>>2]|0)==0:0)){S=(t[w>>2]|0)+276|0;t[S>>2]=t[S>>2]|8}S=t[w>>2]|0;if((t[(t[d>>2]|0)+4>>2]|0)==13)pN(S);else KE(S);sg(t[w>>2]|0,t[_>>2]|0)|0;if((u[t[(t[(t[w>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[w>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0)AS(t[w>>2]|0,85,0);else M=60;if((M|0)==60?(u[t[(t[(t[w>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=0:0)AS(t[w>>2]|0,86,0);if((t[(t[w>>2]|0)+52>>2]|0)!=0?(t[(t[w>>2]|0)+52>>2]|0)!=(t[c>>2]|0):0){AS(t[w>>2]|0,85,0);t[(t[w>>2]|0)+12>>2]=0}do if(!(t[(t[w>>2]|0)+12>>2]|0))if(!(t[(t[w>>2]|0)+84>>2]|0)){t[p>>2]=1;break}else{t[p>>2]=t[(t[w>>2]|0)+84>>2];break}else t[p>>2]=0;while(0);t[m>>2]=t[(t[v>>2]|0)+24>>2];t[(t[v>>2]|0)+24>>2]=0;t[(t[c>>2]|0)+16>>2]=t[v>>2];if(t[m>>2]|0)t[(t[m>>2]|0)+28>>2]=0;t[t[h>>2]>>2]=t[m>>2];while(1){if(!(t[m>>2]|0))break;t[(t[m>>2]|0)+20>>2]=0;t[m>>2]=t[(t[m>>2]|0)+24>>2]}iy(t[v>>2]|0);ry(t[v>>2]|0);if(t[p>>2]|0){ty(t[t[h>>2]>>2]|0);t[t[h>>2]>>2]=0}if(t[(t[d>>2]|0)+80>>2]|0)t[(t[w>>2]|0)+296>>2]=0;Up(t[w>>2]|0);t[o>>2]=t[p>>2];F=t[o>>2]|0;s=a;return F|0}function lS(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if((t[u>>2]|0)<=0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=zp()|0;if(!(t[a>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[c>>2]=GO(t[f>>2]|0,t[u>>2]|0,0)|0;u=t[a>>2]|0;if(!(t[c>>2]|0)){Up(u);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=Cp(u)|0;if(!(t[o>>2]|0)){IO(t[c>>2]|0);Up(t[a>>2]|0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{t[(t[o>>2]|0)+4>>2]=0;t[t[o>>2]>>2]=t[c>>2];zs(t[(t[t[o>>2]>>2]|0)+16>>2]|0,t[o>>2]|0)|0;eE(t[a>>2]|0,t[o>>2]|0)|0;t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}return 0}function sS(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=bS(t[r>>2]|0,0)|0;s=i;return e|0}function bS(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;t[a>>2]=zp()|0;if(!(t[a>>2]|0)){Sp(0,70088);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if(t[u>>2]|0)_g(t[a>>2]|0,t[u>>2]|0,0)|0;t[(t[a>>2]|0)+280>>2]=1;t[o>>2]=uA(t[f>>2]|0,0,t[a>>2]|0)|0;u=t[a>>2]|0;if(!(t[o>>2]|0)){Up(u);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}eE(u,t[o>>2]|0)|0;if((t[c>>2]|0)==0?(t[(t[a>>2]|0)+180>>2]|0)==0:0)t[c>>2]=rA(t[f>>2]|0)|0;if((t[c>>2]|0)!=0?(t[(t[a>>2]|0)+180>>2]|0)==0:0)t[(t[a>>2]|0)+180>>2]=t[c>>2];t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}function kS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;rS();t[k>>2]=sS(t[o>>2]|0)|0;if(!(t[k>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(t[a>>2]|0){if(t[t[k>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[k>>2]>>2]|0);t[t[k>>2]>>2]=t[a>>2]}rg(t[k>>2]|0);if(t[l>>2]|0)t[(t[k>>2]|0)+272>>2]=t[l>>2];if(!(t[(t[k>>2]|0)+180>>2]|0)){l=rA(t[o>>2]|0)|0;t[(t[k>>2]|0)+180>>2]=l}t[(t[k>>2]|0)+288>>2]=t[c>>2];iS(t[k>>2]|0)|0;do if((t[c>>2]|0)!=0?1:(t[(t[k>>2]|0)+12>>2]|0)!=0){t[b>>2]=t[(t[k>>2]|0)+8>>2];if(t[b>>2]|0)if((t[(t[t[(t[k>>2]|0)+36>>2]>>2]|0)+24>>2]|0)>0){t[(t[b>>2]|0)+36>>2]=9;break}else{t[(t[b>>2]|0)+36>>2]=t[(t[t[(t[k>>2]|0)+36>>2]>>2]|0)+24>>2];break}}else{t[b>>2]=0;fy(t[(t[k>>2]|0)+8>>2]|0);t[(t[k>>2]|0)+8>>2]=0}while(0);if(t[a>>2]|0)t[t[k>>2]>>2]=0;Up(t[k>>2]|0);t[u>>2]=t[b>>2];h=t[u>>2]|0;s=f;return h|0}function hS(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=kS(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0)|0;s=n;return r|0}function wS(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=hS(0,t[r>>2]|0,0)|0;s=i;return e|0}function dS(){var e=0;e=s;if(!(t[17532]|0)){s=e;return}z_();oc();cz();SO();gO();_D();BH();mp();Yc();tl();CA();t[17532]=0;s=e;return}function vS(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[f>>2]=t[(t[r>>2]|0)+296>>2];while(1){e=iE(t[r>>2]|0)|0;t[n>>2]=e;if(!e)break;Dp(t[n>>2]|0)}t[(t[r>>2]|0)+40>>2]=0;t[(t[r>>2]|0)+36>>2]=0;t[(t[r>>2]|0)+236>>2]=0;n=t[r>>2]|0;if(t[(t[r>>2]|0)+244>>2]|0){t[t[n+244>>2]>>2]=-1;t[(t[r>>2]|0)+232>>2]=t[(t[r>>2]|0)+244>>2]}else t[n+232>>2]=0;t[(t[r>>2]|0)+56>>2]=0;t[(t[r>>2]|0)+52>>2]=0;t[(t[r>>2]|0)+188>>2]=0;t[(t[r>>2]|0)+184>>2]=0;do if(t[(t[r>>2]|0)+20>>2]|0){if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+20>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0)}while(0);t[(t[r>>2]|0)+20>>2]=0;do if(t[(t[r>>2]|0)+24>>2]|0){if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+24>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0)}while(0);t[(t[r>>2]|0)+24>>2]=0;do if(t[(t[r>>2]|0)+180>>2]|0){if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+180>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+180>>2]|0)}while(0);t[(t[r>>2]|0)+180>>2]=0;do if(t[(t[r>>2]|0)+224>>2]|0){if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+224>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+224>>2]|0)}while(0);t[(t[r>>2]|0)+224>>2]=0;do if(t[(t[r>>2]|0)+228>>2]|0){if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+228>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+228>>2]|0)}while(0);t[(t[r>>2]|0)+228>>2]=0;if(t[(t[r>>2]|0)+8>>2]|0)fy(t[(t[r>>2]|0)+8>>2]|0);t[(t[r>>2]|0)+8>>2]=0;t[(t[r>>2]|0)+28>>2]=-1;t[(t[r>>2]|0)+88>>2]=0;t[(t[r>>2]|0)+92>>2]=0;t[(t[r>>2]|0)+32>>2]=0;t[(t[r>>2]|0)+96>>2]=0;t[(t[r>>2]|0)+172>>2]=0;t[(t[r>>2]|0)+176>>2]=0;t[(t[r>>2]|0)+12>>2]=1;t[(t[r>>2]|0)+356>>2]=1;t[(t[r>>2]|0)+212>>2]=0;t[(t[r>>2]|0)+100>>2]=1;t[(t[r>>2]|0)+68>>2]=0;t[(t[r>>2]|0)+200>>2]=0;t[(t[r>>2]|0)+204>>2]=0;t[(t[r>>2]|0)+216>>2]=0;t[(t[r>>2]|0)+84>>2]=0;t[(t[r>>2]|0)+248>>2]=0;t[(t[r>>2]|0)+256>>2]=1;t[(t[r>>2]|0)+284>>2]=0;t[(t[r>>2]|0)+440>>2]=0;t[(t[r>>2]|0)+444>>2]=0;t[(t[r>>2]|0)+468>>2]=0;xp((t[r>>2]|0)+72|0);if(t[(t[r>>2]|0)+348>>2]|0){XF(t[(t[r>>2]|0)+348>>2]|0,t[33934]|0);t[(t[r>>2]|0)+348>>2]=0}if(t[(t[r>>2]|0)+352>>2]|0){XF(t[(t[r>>2]|0)+352>>2]|0,0);t[(t[r>>2]|0)+352>>2]=0}if(t[(t[r>>2]|0)+284>>2]|0)bc(t[(t[r>>2]|0)+284>>2]|0);if(!(t[(t[r>>2]|0)+388>>2]|0)){s=i;return}lp((t[r>>2]|0)+384|0);s=i;return}function mS(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=_g(t[n>>2]|0,t[f>>2]|0,0)|0;s=r;return i|0}function _S(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;rS();t[c>>2]=bS(t[u>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=Sg(t[c>>2]|0,0,t[a>>2]|0,t[o>>2]|0,0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function pS(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;rS();t[h>>2]=lS(t[o>>2]|0,t[c>>2]|0)|0;if(!(t[h>>2]|0)){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}else{t[a>>2]=Sg(t[h>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,0)|0;w=t[a>>2]|0;s=u;return w|0}return 0}function ES(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)<0){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}rS();t[k>>2]=YO(t[a>>2]|0,0)|0;if(!(t[k>>2]|0)){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}t[(t[k>>2]|0)+8>>2]=0;t[b>>2]=zp()|0;if(!(t[b>>2]|0)){IO(t[k>>2]|0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}t[h>>2]=Pp(t[b>>2]|0,t[k>>2]|0,0)|0;if(!(t[h>>2]|0)){IO(t[k>>2]|0);Up(t[b>>2]|0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}else{eE(t[b>>2]|0,t[h>>2]|0)|0;t[u>>2]=Sg(t[b>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,0)|0;w=t[u>>2]|0;s=f;return w|0}return 0}function SS(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;
	a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(!(t[c>>2]|0)){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}rS();t[v>>2]=XO(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,0)|0;if(!(t[v>>2]|0)){if(t[l>>2]|0)gAi[t[l>>2]&511](t[b>>2]|0)|0;t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}t[d>>2]=zp()|0;if(!(t[d>>2]|0)){IO(t[v>>2]|0);t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}t[m>>2]=Pp(t[d>>2]|0,t[v>>2]|0,0)|0;if(!(t[m>>2]|0)){IO(t[v>>2]|0);Up(t[d>>2]|0);t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}else{eE(t[d>>2]|0,t[m>>2]|0)|0;t[o>>2]=Sg(t[d>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,0)|0;_=t[o>>2]|0;s=a;return _|0}return 0}function gS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[o>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if(!(t[a>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}rS();vS(t[a>>2]|0);t[b>>2]=uA(t[o>>2]|0,0,t[a>>2]|0)|0;if(!(t[b>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}else{eE(t[a>>2]|0,t[b>>2]|0)|0;t[u>>2]=Sg(t[a>>2]|0,0,t[c>>2]|0,t[l>>2]|0,1)|0;k=t[u>>2]|0;s=f;return k|0}return 0}function yS(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(!(t[c>>2]|0)){t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}if(!(t[l>>2]|0)){t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}rS();vS(t[c>>2]|0);t[d>>2]=GO(t[l>>2]|0,t[b>>2]|0,0)|0;if(!(t[d>>2]|0)){t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}t[v>>2]=Pp(t[c>>2]|0,t[d>>2]|0,0)|0;if(!(t[v>>2]|0)){IO(t[d>>2]|0);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}else{eE(t[c>>2]|0,t[v>>2]|0)|0;t[o>>2]=Sg(t[c>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,1)|0;m=t[o>>2]|0;s=a;return m|0}return 0}function FS(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;o=s;s=s+48|0;c=o+36|0;l=o+32|0;b=o+28|0;k=o+24|0;h=o+20|0;w=o+16|0;d=o+12|0;v=o+8|0;m=o+4|0;_=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;if(!(t[b>>2]|0)){t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}if(!(t[l>>2]|0)){t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}rS();vS(t[l>>2]|0);t[m>>2]=XO(t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,0)|0;if(!(t[m>>2]|0)){if(t[k>>2]|0)gAi[t[k>>2]&511](t[h>>2]|0)|0;t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}t[_>>2]=Pp(t[l>>2]|0,t[m>>2]|0,0)|0;if(!(t[_>>2]|0)){IO(t[m>>2]|0);t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}else{eE(t[l>>2]|0,t[_>>2]|0)|0;t[c>>2]=Sg(t[l>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,1)|0;p=t[c>>2]|0;s=o;return p|0}return 0}function OS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+212>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)==-1:0){s=f;return}if(t[a>>2]|0)t[(t[a>>2]|0)+84>>2]=t[o>>2];n=t[a>>2]|0;r=t[o>>2]|0;o=t[l>>2]|0;i=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,0,1,r,3,0,0,0,0,0,o,0,i,u);if(!(t[a>>2]|0)){s=f;return}t[(t[a>>2]|0)+12>>2]=0;if(t[(t[a>>2]|0)+288>>2]|0){s=f;return}t[(t[a>>2]|0)+212>>2]=1;s=f;return}function AS(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+160|0;f=n;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n+20|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;VY(l|0,0,129)|0;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+212>>2]|0)!=0:0)?(t[(t[u>>2]|0)+172>>2]|0)==-1:0){s=n;return}do switch(t[a>>2]|0){case 69:{t[c>>2]=74048;break}case 33:{t[c>>2]=74696;break}case 55:{t[c>>2]=74128;break}case 34:{t[c>>2]=74656;break}case 71:{t[c>>2]=73600;break}case 89:{t[c>>2]=73240;break}case 52:{t[c>>2]=74008;break}case 19:{t[c>>2]=73136;break}case 67:{t[c>>2]=73920;break}case 79:{t[c>>2]=74736;break}case 38:{t[c>>2]=73392;break}case 82:{t[c>>2]=74504;break}case 50:{t[c>>2]=73872;break}case 73:{t[c>>2]=74232;break}case 18:{t[c>>2]=73104;break}case 80:{t[c>>2]=73648;break}case 49:{t[c>>2]=73776;break}case 44:{t[c>>2]=73472;break}case 85:{t[c>>2]=74880;break}case 4:{t[c>>2]=74808;break}case 48:{t[c>>2]=73744;break}case 84:{t[c>>2]=73824;break}case 46:{t[c>>2]=73696;break}case 110:{t[c>>2]=75e3;break}case 74:{t[c>>2]=74616;break}case 7:{t[c>>2]=73032;break}case 8:{t[c>>2]=73064;break}case 88:{t[c>>2]=73312;break}case 70:{t[c>>2]=73560;break}case 25:{t[c>>2]=73208;break}case 20:{t[c>>2]=73160;break}case 5:{t[c>>2]=74832;break}case 61:{t[c>>2]=74584;break}case 54:{t[c>>2]=74088;break}case 78:{t[c>>2]=74768;break}case 62:{t[c>>2]=73520;break}case 96:{t[c>>2]=74960;break}case 23:{t[c>>2]=74552;break}case 36:{t[c>>2]=73280;break}case 6:{t[c>>2]=72992;break}case 51:{t[c>>2]=73960;break}case 1:{t[c>>2]=73088;break}case 56:{t[c>>2]=74424;break}case 75:{t[c>>2]=74640;break}case 60:{t[c>>2]=74288;break}case 83:{t[c>>2]=74248;break}case 57:{t[c>>2]=74464;break}case 21:{t[c>>2]=74168;break}case 95:{t[c>>2]=74328;break}case 59:{t[c>>2]=74384;break}case 64:{t[c>>2]=73728;break}case 43:{t[c>>2]=73440;break}case 24:{t[c>>2]=73184;break}case 92:{t[c>>2]=73848;break}case 37:{t[c>>2]=73280;break}case 86:{t[c>>2]=74912;break}case 39:{t[c>>2]=73360;break}default:t[c>>2]=75040}while(0);r=t[c>>2]|0;if(!(t[o>>2]|0)){t[f>>2]=r;SY(l,128,75072,f)|0}else{t[f>>2]=r;SY(l,128,75080,f)|0}if(t[u>>2]|0)t[(t[u>>2]|0)+84>>2]=t[a>>2];r=t[u>>2]|0;c=t[a>>2]|0;a=t[o>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,r,0,1,c,3,0,0,a,0,0,0,0,l,f);if(!(t[u>>2]|0)){s=n;return}t[(t[u>>2]|0)+12>>2]=0;if(t[(t[u>>2]|0)+288>>2]|0){s=n;return}t[(t[u>>2]|0)+212>>2]=1;s=n;return}function MS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+212>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)==-1:0){s=f;return}if(t[a>>2]|0)t[(t[a>>2]|0)+84>>2]=t[o>>2];n=t[a>>2]|0;r=t[o>>2]|0;o=t[l>>2]|0;i=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,0,1,r,3,0,0,o,0,0,0,0,i,u);if(!(t[a>>2]|0)){s=f;return}t[(t[a>>2]|0)+12>>2]=0;if(t[(t[a>>2]|0)+288>>2]|0){s=f;return}t[(t[a>>2]|0)+212>>2]=1;s=f;return}function RS(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+32|0;a=u;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+84>>2]=t[c>>2],(t[t[o>>2]>>2]|0)!=0):0)?(t[(t[t[o>>2]>>2]|0)+108>>2]|0)==-554844497:0)t[h>>2]=t[(t[t[o>>2]>>2]|0)+124>>2];f=t[h>>2]|0;h=t[o>>2]|0;if(t[o>>2]|0){n=t[h+112>>2]|0;r=t[(t[o>>2]|0)+108>>2]|0;i=t[o>>2]|0;e=t[c>>2]|0;w=t[b>>2]|0;d=t[k>>2]|0;v=t[l>>2]|0;m=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=m;cp(f,n,r,i,0,4,e,2,0,0,w,d,0,0,0,v,a);t[(t[o>>2]|0)+100>>2]=0;s=u;return}else{o=t[c>>2]|0;c=t[b>>2]|0;v=t[k>>2]|0;d=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(f,0,0,h,0,4,o,2,0,0,c,v,0,0,0,d,a);s=u;return}}function NS(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;u=s;s=s+32|0;a=u;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)!=0:0)?(t[(t[t[o>>2]>>2]|0)+108>>2]|0)==-554844497:0)t[h>>2]=t[(t[t[o>>2]>>2]|0)+124>>2];f=t[h>>2]|0;h=t[o>>2]|0;if(!(t[o>>2]|0)){n=t[c>>2]|0;r=t[b>>2]|0;i=t[k>>2]|0;e=t[l>>2]|0;w=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=w;cp(f,0,0,h,0,1,n,1,0,0,r,i,0,0,0,e,a);s=u;return}if(t[h>>2]|0)d=t[(t[t[o>>2]>>2]|0)+84>>2]|0;else d=0;h=t[(t[o>>2]|0)+4>>2]|0;e=t[o>>2]|0;o=t[c>>2]|0;c=t[b>>2]|0;i=t[k>>2]|0;r=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(f,d,h,e,0,1,o,1,0,0,c,i,0,0,0,r,a);s=u;return}function TS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+360>>2]&524288|0)==0:0){if((t[(t[a>>2]|0)+388>>2]|0)==89){t[u>>2]=1;w=t[u>>2]|0;s=f;return w|0}if(((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+48>>2]|0)!=6:0)?(t[(t[c>>2]|0)+40>>2]|0)!=0:0)?(t[(t[c>>2]|0)+72>>2]|0)==0:0)?(t[k>>2]=t[(t[a>>2]|0)+440>>2],t[(t[c>>2]|0)+72>>2]=1,t[h>>2]=hE(t[a>>2]|0,t[(t[c>>2]|0)+40>>2]|0,1,0,0,0)|0,t[(t[c>>2]|0)+72>>2]=(t[(t[a>>2]|0)+440>>2]|0)-(t[k>>2]|0)+1<<1,(t[h>>2]|0)!=0):0){if(es(t[h>>2]|0,60)|0){k=(t[c>>2]|0)+72|0;t[k>>2]=t[k>>2]|1}pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=0}do if(t[l>>2]|0){if((t[l>>2]|0)>>>0<1e7){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if(t[(t[a>>2]|0)+36>>2]|0)t[b>>2]=(t[(t[(t[a>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0));t[b>>2]=(t[b>>2]|0)+(t[(t[a>>2]|0)+444>>2]|0);if((t[l>>2]|0)>>>0<((t[b>>2]|0)*10|0)>>>0){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}}else{if(t[o>>2]|0){if((t[o>>2]|0)>>>0<1e3){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if(t[(t[a>>2]|0)+36>>2]|0)t[b>>2]=(t[(t[(t[a>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0));t[b>>2]=(t[b>>2]|0)+(t[(t[a>>2]|0)+444>>2]|0);if((t[o>>2]|0)>>>0>=((t[b>>2]|0)*10|0)>>>0)break;if(((t[(t[a>>2]|0)+440>>2]|0)*3|0)>>>0>=((t[b>>2]|0)*10|0)>>>0)break;t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if(t[c>>2]|0){t[o>>2]=(t[(t[c>>2]|0)+72>>2]|0)/2|0;if(t[(t[a>>2]|0)+36>>2]|0)t[b>>2]=(t[(t[(t[a>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0));t[b>>2]=(t[b>>2]|0)+(t[(t[a>>2]|0)+444>>2]|0);if(((t[o>>2]|0)*3|0)>>>0>=((t[b>>2]|0)*10|0)>>>0)break;t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}else{if(!((t[(t[a>>2]|0)+388>>2]|0)!=26?(t[(t[a>>2]|0)+388>>2]|0)!=27:0))d=36;if((d|0)==36?(t[(t[a>>2]|0)+440>>2]|0)>>>0>1e4:0)break;t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}}while(0);AS(t[a>>2]|0,89,0);t[u>>2]=1;w=t[u>>2]|0;s=f;return w|0}t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function LS(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function DS(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;f=r;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;t[a>>2]=e;t[o>>2]=i;if(!(t[o>>2]|0)){AS(t[a>>2]|0,1,72912);t[u>>2]=0;k=t[u>>2]|0;s=r;return k|0}if(t[33952]|0){i=t[33976]|0;e=t[33980]|0;t[f>>2]=t[(t[o>>2]|0)+8>>2];yAi[i&511](e,72952,f)}t[c>>2]=Cp(t[a>>2]|0)|0;if(!(t[c>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=r;return k|0}t[b>>2]=(rs(t[(t[o>>2]|0)+8>>2]|0)|0)+5;t[l>>2]=gAi[t[135752>>2]&511](t[b>>2]|0)|0;if(!(t[l>>2]|0)){Sp(t[a>>2]|0,0);pAi[t[135736>>2]&511](t[c>>2]|0);t[u>>2]=0;k=t[u>>2]|0;s=r;return k|0}else{n[t[l>>2]>>0]=32;n[(t[l>>2]|0)+1>>0]=37;n[(t[l>>2]|0)+((t[b>>2]|0)-3)>>0]=59;n[(t[l>>2]|0)+((t[b>>2]|0)-2)>>0]=32;n[(t[l>>2]|0)+((t[b>>2]|0)-1)>>0]=0;YY((t[l>>2]|0)+2|0,t[(t[o>>2]|0)+8>>2]|0,(t[b>>2]|0)-5|0)|0;t[(t[c>>2]|0)+40>>2]=226;t[(t[c>>2]|0)+12>>2]=t[l>>2];t[(t[c>>2]|0)+16>>2]=t[l>>2];t[(t[c>>2]|0)+24>>2]=t[b>>2];t[(t[c>>2]|0)+20>>2]=(t[l>>2]|0)+(t[b>>2]|0);t[u>>2]=t[c>>2];k=t[u>>2]|0;s=r;return k|0}return 0}function CS(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[n>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0);t[f>>2]=(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0);if((((t[n>>2]|0)>>>0>1e7|(t[f>>2]|0)>>>0>1e7?(t[t[(t[r>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[t[(t[r>>2]|0)+36>>2]>>2]|0)+4>>2]|0)!=227:0)?(t[(t[r>>2]|0)+360>>2]&524288|0)==0:0){AS(t[r>>2]|0,1,69896);t[(t[r>>2]|0)+172>>2]=-1}yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;if(!(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)){s=i;return}if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[r>>2]|0)|0;s=i;return}function PS(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[f>>2]=0;t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}t[o>>2]=Ap(t[n>>2]|0,a)|0;e=(t[o>>2]|0)==32|(t[o>>2]|0)==62|(t[o>>2]|0)==47;e:do if(!(t[(t[n>>2]|0)+360>>2]&131072)){do if(!e){if(((((((((((((!((t[o>>2]|0)>=97&(t[o>>2]|0)<=122)?!((t[o>>2]|0)>=65&(t[o>>2]|0)<=90|(t[o>>2]|0)==95|(t[o>>2]|0)==58):0)?!((t[o>>2]|0)>=192&(t[o>>2]|0)<=214):0)?!((t[o>>2]|0)>=216&(t[o>>2]|0)<=246):0)?!((t[o>>2]|0)>=248&(t[o>>2]|0)<=767):0)?!((t[o>>2]|0)>=880&(t[o>>2]|0)<=893):0)?!((t[o>>2]|0)>=895&(t[o>>2]|0)<=8191):0)?!((t[o>>2]|0)>=8204&(t[o>>2]|0)<=8205):0)?!((t[o>>2]|0)>=8304&(t[o>>2]|0)<=8591):0)?!((t[o>>2]|0)>=11264&(t[o>>2]|0)<=12271):0)?!((t[o>>2]|0)>=12289&(t[o>>2]|0)<=55295):0)?!((t[o>>2]|0)>=63744&(t[o>>2]|0)<=64975):0)?!((t[o>>2]|0)>=65008&(t[o>>2]|0)<=65533):0)?!((t[o>>2]|0)>=65536&(t[o>>2]|0)<=983039):0)break;t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);b=t[(t[n>>2]|0)+36>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=b+28|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[(t[n>>2]|0)+36>>2]|0)+32>>2]=1}else{k=b+32|0;t[k>>2]=(t[k>>2]|0)+1}k=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+(t[a>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);t[o>>2]=Ap(t[n>>2]|0,a)|0;while(1){if(!((t[o>>2]|0)!=32&(t[o>>2]|0)!=62&(t[o>>2]|0)!=47))break e;do if(((((((!((t[o>>2]|0)>=97&(t[o>>2]|0)<=122)?!((t[o>>2]|0)>=65&(t[o>>2]|0)<=90):0)?!((t[o>>2]|0)>=48&(t[o>>2]|0)<=57|(t[o>>2]|0)==95|(t[o>>2]|0)==58|(t[o>>2]|0)==45|(t[o>>2]|0)==46|(t[o>>2]|0)==183):0)?!((t[o>>2]|0)>=192&(t[o>>2]|0)<=214):0)?!((t[o>>2]|0)>=216&(t[o>>2]|0)<=246):0)?!((t[o>>2]|0)>=248&(t[o>>2]|0)<=767):0)?!((t[o>>2]|0)>=768&(t[o>>2]|0)<=879):0)?!((t[o>>2]|0)>=880&(t[o>>2]|0)<=893):0){if((t[o>>2]|0)>=895&(t[o>>2]|0)<=8191)break;if((t[o>>2]|0)>=8204&(t[o>>2]|0)<=8205)break;if((t[o>>2]|0)>=8255&(t[o>>2]|0)<=8256)break;if((t[o>>2]|0)>=8304&(t[o>>2]|0)<=8591)break;if((t[o>>2]|0)>=11264&(t[o>>2]|0)<=12271)break;if((t[o>>2]|0)>=12289&(t[o>>2]|0)<=55295)break;if((t[o>>2]|0)>=63744&(t[o>>2]|0)<=64975)break;if((t[o>>2]|0)>=65008&(t[o>>2]|0)<=65533)break;if(!((t[o>>2]|0)>=65536&(t[o>>2]|0)<=983039))break e}while(0);k=t[c>>2]|0;t[c>>2]=k+1;if((k|0)>100){t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1)break}t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);k=t[(t[n>>2]|0)+36>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=k+28|0;t[b>>2]=(t[b>>2]|0)+1;t[(t[(t[n>>2]|0)+36>>2]|0)+32>>2]=1}else{b=k+32|0;t[b>>2]=(t[b>>2]|0)+1}b=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[b>>2]=(t[b>>2]|0)+(t[a>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);t[o>>2]=Ap(t[n>>2]|0,a)|0}t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}while(0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else{i:do if(!e){b=t[o>>2]|0;if((t[o>>2]|0)<256){if(((!(65<=(b|0)&(t[o>>2]|0)<=90)?!(97<=(t[o>>2]|0)&(t[o>>2]|0)<=122):0)?!(192<=(t[o>>2]|0)&(t[o>>2]|0)<=214):0)?!(216<=(t[o>>2]|0)&(t[o>>2]|0)<=246|248<=(t[o>>2]|0)):0)h=66}else if(!(dj(b,199744)|0))h=66;do if((h|0)==66){b=t[o>>2]|0;if((t[o>>2]|0)<256)if((b|0)!=95&(t[o>>2]|0)!=58)break i;else break;if(!(19968<=(b|0)&(t[o>>2]|0)<=40869|(t[o>>2]|0)==12295)?(12321<=(t[o>>2]|0)&(t[o>>2]|0)<=12329^1)&(t[o>>2]|0)!=95&(t[o>>2]|0)!=58:0)break i}while(0);t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);b=t[(t[n>>2]|0)+36>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=b+28|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[(t[n>>2]|0)+36>>2]|0)+32>>2]=1}else{k=b+32|0;t[k>>2]=(t[k>>2]|0)+1}k=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+(t[a>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);t[o>>2]=Ap(t[n>>2]|0,a)|0;while(1){if(!((t[o>>2]|0)!=32&(t[o>>2]|0)!=62&(t[o>>2]|0)!=47))break e;k=t[o>>2]|0;if((t[o>>2]|0)<256){if(((!(65<=(k|0)&(t[o>>2]|0)<=90)?!(97<=(t[o>>2]|0)&(t[o>>2]|0)<=122):0)?!(192<=(t[o>>2]|0)&(t[o>>2]|0)<=214):0)?!(216<=(t[o>>2]|0)&(t[o>>2]|0)<=246|248<=(t[o>>2]|0)):0)h=84}else if(!(dj(k,199744)|0))h=84;do if((h|0)==84){h=0;if((t[o>>2]|0)>=256){if(19968<=(t[o>>2]|0)&(t[o>>2]|0)<=40869|(t[o>>2]|0)==12295)break;if(12321<=(t[o>>2]|0)&(t[o>>2]|0)<=12329)break}k=t[o>>2]|0;if((t[o>>2]|0)<256){if(48<=(k|0)&(t[o>>2]|0)<=57|(t[o>>2]|0)==46|(t[o>>2]|0)==45|(t[o>>2]|0)==95|(t[o>>2]|0)==58)break}else{b=(dj(k,200216)|0)!=0;if(b|(t[o>>2]|0)==46|(t[o>>2]|0)==45|(t[o>>2]|0)==95|(t[o>>2]|0)==58)break}if((t[o>>2]|0)>=256?(dj(t[o>>2]|0,200144)|0)!=0:0)break;b=t[o>>2]|0;if((t[o>>2]|0)<256)w=(b|0)==183&1;else w=dj(b,200272)|0;if(!w)break e}while(0);b=t[c>>2]|0;t[c>>2]=b+1;if((b|0)>100){t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){h=101;break}}t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);b=t[(t[n>>2]|0)+36>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=b+28|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[(t[n>>2]|0)+36>>2]|0)+32>>2]=1}else{k=b+32|0;t[k>>2]=(t[k>>2]|0)+1}k=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+(t[a>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);t[o>>2]=Ap(t[n>>2]|0,a)|0;if(t[o>>2]|0)continue;t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){h=112;break}t[o>>2]=Ap(t[n>>2]|0,a)|0}if((h|0)==101){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else if((h|0)==112){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}}while(0);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}while(0);if((t[f>>2]|0)>5e4?(t[(t[n>>2]|0)+360>>2]&524288|0)==0:0){AS(t[n>>2]|0,110,65688);t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+-1>>0]|0|0)==13:0){t[r>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+(0-((t[f>>2]|0)+1))|0,t[f>>2]|0)|0;l=t[r>>2]|0;s=i;return l|0}t[r>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+(0-(t[f>>2]|0))|0,t[f>>2]|0)|0;l=t[r>>2]|0;s=i;return l|0}function BS(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n;u=n+12|0;a=n+8|0;o=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+212>>2]|0)!=0:0)?(t[(t[u>>2]|0)+172>>2]|0)==-1:0){s=n;return}if(t[u>>2]|0)t[(t[u>>2]|0)+84>>2]=t[a>>2];r=t[u>>2]|0;i=t[a>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,r,0,1,i,3,0,0,0,0,0,0,0,72848,f);if(!(t[u>>2]|0)){s=n;return}t[(t[u>>2]|0)+12>>2]=0;if(t[(t[u>>2]|0)+288>>2]|0){s=n;return}t[(t[u>>2]|0)+212>>2]=1;s=n;return}function IS(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+24|0;b=r+4|0;k=r;t[a>>2]=e;t[o>>2]=i;t[b>>2]=0;t[k>>2]=0;if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)!=0:0){t[c>>2]=t[t[o>>2]>>2];n[l>>0]=n[t[c>>2]>>0]|0;if(((u[l>>0]|0|0)==38?(u[(t[c>>2]|0)+1>>0]|0|0)==35:0)?(u[(t[c>>2]|0)+2>>0]|0|0)==120:0){t[c>>2]=(t[c>>2]|0)+3;n[l>>0]=n[t[c>>2]>>0]|0;e:while(1){if((u[l>>0]|0|0)==59)break;if((u[l>>0]|0|0)>=48?(u[l>>0]|0|0)<=57:0)t[b>>2]=(t[b>>2]<<4)+((u[l>>0]|0)-48);else h=12;do if((h|0)==12){h=0;if((u[l>>0]|0|0)>=97?(u[l>>0]|0|0)<=102:0){t[b>>2]=(t[b>>2]<<4)+((u[l>>0]|0)-97)+10;break}if((u[l>>0]|0|0)<65){h=18;break e}if((u[l>>0]|0|0)>70){h=18;break e}t[b>>2]=(t[b>>2]<<4)+((u[l>>0]|0)-65)+10}while(0);if((t[b>>2]|0)>>>0>1114111)t[k>>2]=t[b>>2];t[c>>2]=(t[c>>2]|0)+1;n[l>>0]=n[t[c>>2]>>0]|0}if((h|0)==18){AS(t[a>>2]|0,6,0);t[b>>2]=0}if((u[l>>0]|0|0)==59)t[c>>2]=(t[c>>2]|0)+1}else h=24;do if((h|0)==24){if((u[l>>0]|0|0)==38?(u[(t[c>>2]|0)+1>>0]|0|0)==35:0){t[c>>2]=(t[c>>2]|0)+2;n[l>>0]=n[t[c>>2]>>0]|0;while(1){if((u[l>>0]|0|0)==59)break;if((u[l>>0]|0|0)<48){h=31;break}if((u[l>>0]|0|0)>57){h=31;break}t[b>>2]=((t[b>>2]|0)*10|0)+((u[l>>0]|0)-48);if((t[b>>2]|0)>>>0>1114111)t[k>>2]=t[b>>2];t[c>>2]=(t[c>>2]|0)+1;n[l>>0]=n[t[c>>2]>>0]|0}if((h|0)==31){AS(t[a>>2]|0,7,0);t[b>>2]=0}if((u[l>>0]|0|0)!=59)break;t[c>>2]=(t[c>>2]|0)+1;break}AS(t[a>>2]|0,8,0);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}while(0);t[t[o>>2]>>2]=t[c>>2];c=t[b>>2]|0;do if((t[b>>2]|0)>>>0<256)if((9<=c>>>0&(t[b>>2]|0)>>>0<=10|(t[b>>2]|0)==13|32<=(t[b>>2]|0)>>>0)&(t[k>>2]|0)==0)h=43;else h=44;else{if(!(256<=c>>>0&(t[b>>2]|0)>>>0<=55295)?!(57344<=(t[b>>2]|0)>>>0&(t[b>>2]|0)>>>0<=65533):0)if(65536<=(t[b>>2]|0)>>>0&(t[b>>2]|0)>>>0<=1114111&(t[k>>2]|0)==0){h=43;break}else{h=44;break}if(!(t[k>>2]|0))h=43;else h=44}while(0);if((h|0)==43){t[f>>2]=t[b>>2];w=t[f>>2]|0;s=r;return w|0}else if((h|0)==44){OS(t[a>>2]|0,9,72856,t[b>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}}t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}function HS(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r+24|0;k=r;t[a>>2]=e;t[o>>2]=i;t[k>>2]=0;if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)!=0:0){t[l>>2]=t[t[o>>2]>>2];n[b>>0]=n[t[l>>2]>>0]|0;if((u[b>>0]|0|0)!=38){t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[l>>2]=(t[l>>2]|0)+1;t[c>>2]=jS(t[a>>2]|0,l)|0;if(!(t[c>>2]|0)){BS(t[a>>2]|0,68,72152);t[t[o>>2]>>2]=t[l>>2];t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}if((u[t[l>>2]>>0]|0|0)!=59){AS(t[a>>2]|0,23,0);pAi[t[135736>>2]&511](t[c>>2]|0);t[t[o>>2]>>2]=t[l>>2];t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[l>>2]=(t[l>>2]|0)+1;if((t[(t[a>>2]|0)+360>>2]&1048576|0)==0?(t[k>>2]=l_(t[c>>2]|0)|0,(t[k>>2]|0)!=0):0){pAi[t[135736>>2]&511](t[c>>2]|0);t[t[o>>2]>>2]=t[l>>2];t[f>>2]=t[k>>2];h=t[f>>2]|0;s=r;return h|0}b=(t[a>>2]|0)+440|0;t[b>>2]=(t[b>>2]|0)+1;if(t[t[a>>2]>>2]|0){if(t[(t[t[a>>2]>>2]|0)+20>>2]|0)t[k>>2]=MAi[t[(t[t[a>>2]>>2]|0)+20>>2]&511](t[(t[a>>2]|0)+4>>2]|0,t[c>>2]|0)|0;if((t[k>>2]|0)==0?(t[(t[a>>2]|0)+360>>2]&1048576|0)!=0:0)t[k>>2]=l_(t[c>>2]|0)|0;if((t[k>>2]|0)==0?(t[(t[a>>2]|0)+4>>2]|0)==(t[a>>2]|0):0)t[k>>2]=Cz(t[a>>2]|0,t[c>>2]|0)|0}if((t[(t[a>>2]|0)+172>>2]|0)==-1){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}do if(t[k>>2]|0){b=t[a>>2]|0;if((t[(t[k>>2]|0)+48>>2]|0)==3){MS(b,28,68712,t[c>>2]|0);break}if((t[b+172>>2]|0)==12?(t[(t[k>>2]|0)+48>>2]|0)==2:0){MS(t[a>>2]|0,29,68752,t[c>>2]|0);break}if(((((t[k>>2]|0)!=0?(t[(t[a>>2]|0)+172>>2]|0)==12:0)?(t[(t[k>>2]|0)+40>>2]|0)!=0:0)?(t[(t[k>>2]|0)+48>>2]|0)!=6:0)?(es(t[(t[k>>2]|0)+40>>2]|0,60)|0)!=0:0){MS(t[a>>2]|0,38,68800,t[c>>2]|0);break}if(((t[(t[k>>2]|0)+48>>2]|0)+-4|0)>>>0<2)MS(t[a>>2]|0,30,68856,t[c>>2]|0)}else{do if((t[(t[a>>2]|0)+28>>2]|0)==1)w=28;else{if((t[(t[a>>2]|0)+88>>2]|0)==0?(t[(t[a>>2]|0)+92>>2]|0)==0:0){w=28;break}ZS(t[a>>2]|0,27,68680,t[c>>2]|0)}while(0);if((w|0)==28)MS(t[a>>2]|0,26,68680,t[c>>2]|0);TS(t[a>>2]|0,0,t[k>>2]|0,0)|0}while(0);pAi[t[135736>>2]&511](t[c>>2]|0);t[t[o>>2]>>2]=t[l>>2];t[f>>2]=t[k>>2];h=t[f>>2]|0;s=r;return h|0}t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}function xS(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+24|0;b=r+4|0;k=r;t[a>>2]=e;t[o>>2]=i;t[k>>2]=0;if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)!=0:0){t[c>>2]=t[t[o>>2]>>2];n[l>>0]=n[t[c>>2]>>0]|0;if((u[l>>0]|0|0)!=37){t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[c>>2]=(t[c>>2]|0)+1;t[b>>2]=jS(t[a>>2]|0,c)|0;if(!(t[b>>2]|0)){BS(t[a>>2]|0,68,71904);t[t[o>>2]>>2]=t[c>>2];t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}n[l>>0]=n[t[c>>2]>>0]|0;if((u[l>>0]|0|0)!=59){AS(t[a>>2]|0,23,0);pAi[t[135736>>2]&511](t[b>>2]|0);t[t[o>>2]>>2]=t[c>>2];t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[c>>2]=(t[c>>2]|0)+1;l=(t[a>>2]|0)+440|0;t[l>>2]=(t[l>>2]|0)+1;if((t[t[a>>2]>>2]|0)!=0?(t[(t[t[a>>2]>>2]|0)+96>>2]|0)!=0:0)t[k>>2]=MAi[t[(t[t[a>>2]>>2]|0)+96>>2]&511](t[(t[a>>2]|0)+4>>2]|0,t[b>>2]|0)|0;if((t[(t[a>>2]|0)+172>>2]|0)==-1){pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}if(t[k>>2]|0){if((t[(t[k>>2]|0)+48>>2]|0)!=4?(t[(t[k>>2]|0)+48>>2]|0)!=5:0)NS(t[a>>2]|0,27,71944,t[b>>2]|0,0)}else{do if((t[(t[a>>2]|0)+28>>2]|0)==1)w=19;else{if((t[(t[a>>2]|0)+88>>2]|0)==0?(t[(t[a>>2]|0)+92>>2]|0)==0:0){w=19;break}NS(t[a>>2]|0,27,65432,t[b>>2]|0,0);t[(t[a>>2]|0)+100>>2]=0}while(0);if((w|0)==19)MS(t[a>>2]|0,26,65432,t[b>>2]|0);TS(t[a>>2]|0,0,0,0)|0}t[(t[a>>2]|0)+92>>2]=1;pAi[t[135736>>2]&511](t[b>>2]|0);t[t[o>>2]>>2]=t[c>>2];t[f>>2]=t[k>>2];h=t[f>>2]|0;s=r;return h|0}t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}function US(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r;f=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;t[a>>2]=e;t[o>>2]=i;t[h>>2]=0;do if(!((t[a>>2]|0)==0|(t[o>>2]|0)==0)){if((t[(t[o>>2]|0)+48>>2]|0)!=5?(t[(t[o>>2]|0)+48>>2]|0)!=2:0)break;if(!(t[(t[o>>2]|0)+40>>2]|0)){if(t[33952]|0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[(t[o>>2]|0)+8>>2];yAi[i&511](e,72024,n)}t[l>>2]=gF()|0;e=t[a>>2]|0;if(!(t[l>>2]|0)){AS(e,1,71984);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}t[c>>2]=Bp(e,t[o>>2]|0)|0;e=t[a>>2]|0;if(!(t[c>>2]|0)){AS(e,1,72064);yF(t[l>>2]|0);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}if((cE(e,t[c>>2]|0)|0)<0){yF(t[l>>2]|0);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);t[k>>2]=Ap(t[a>>2]|0,b)|0;while(1){if((t[(t[a>>2]|0)+36>>2]|0)!=(t[c>>2]|0)){d=46;break}if((t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)>>>0){d=46;break}e=t[k>>2]|0;if((t[k>>2]|0)<256)if(9<=(e|0)&(t[k>>2]|0)<=10|(t[k>>2]|0)==13)v=1;else v=32<=(t[k>>2]|0);else if(!(256<=(e|0)&(t[k>>2]|0)<=55295)?!(57344<=(t[k>>2]|0)&(t[k>>2]|0)<=65533):0)if(65536<=(t[k>>2]|0))v=(t[k>>2]|0)<=1114111;else v=0;else v=1;if(!(v&1)){d=46;break}OF(t[l>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0,t[b>>2]|0)|0;e=t[h>>2]|0;t[h>>2]=e+1;if((e|0)>100){t[h>>2]=0;if((t[(t[a>>2]|0)+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);if((t[(t[a>>2]|0)+172>>2]|0)==-1){d=33;break}}e=t[(t[a>>2]|0)+36>>2]|0;if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){i=e+28|0;t[i>>2]=(t[i>>2]|0)+1;t[(t[(t[a>>2]|0)+36>>2]|0)+32>>2]=1}else{i=e+32|0;t[i>>2]=(t[i>>2]|0)+1}i=(t[(t[a>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+(t[b>>2]|0);if((u[t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[a>>2]|0);t[k>>2]=Ap(t[a>>2]|0,b)|0;if(t[k>>2]|0)continue;t[h>>2]=0;do if(!(t[(t[a>>2]|0)+292>>2]|0)){if(((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[a>>2]|0)}while(0);if((t[(t[a>>2]|0)+172>>2]|0)==-1){d=44;break}t[k>>2]=Ap(t[a>>2]|0,b)|0}if((d|0)==33){yF(t[l>>2]|0);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}else if((d|0)==44){yF(t[l>>2]|0);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}else if((d|0)==46){if((t[(t[a>>2]|0)+36>>2]|0)==(t[c>>2]|0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)>>>0:0)aE(t[a>>2]|0)|0;else d=49;do if((d|0)==49){i=t[k>>2]|0;if((t[k>>2]|0)<256){if(9<=(i|0)&(t[k>>2]|0)<=10|(t[k>>2]|0)==13|32<=(t[k>>2]|0))break}else{if(256<=(i|0)&(t[k>>2]|0)<=55295)break;if(57344<=(t[k>>2]|0)&(t[k>>2]|0)<=65533)break;if(65536<=(t[k>>2]|0)&(t[k>>2]|0)<=1114111)break}OS(t[a>>2]|0,9,72104,t[k>>2]|0);yF(t[l>>2]|0);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}while(0);t[(t[o>>2]|0)+40>>2]=t[t[l>>2]>>2];t[t[l>>2]>>2]=0;yF(t[l>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}}}while(0);AS(t[a>>2]|0,1,71984);t[f>>2]=-1;w=t[f>>2]|0;s=r;return w|0}function zS(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;i=t[u>>2]|0;e:do if(!(t[(t[f>>2]|0)+360>>2]&131072)){if((i|0)!=32&(t[u>>2]|0)!=62&(t[u>>2]|0)!=47){if((((((((((((((((!((t[u>>2]|0)>=97&(t[u>>2]|0)<=122)?!((t[u>>2]|0)>=65&(t[u>>2]|0)<=90):0)?!((t[u>>2]|0)>=48&(t[u>>2]|0)<=57|(t[u>>2]|0)==95|(t[u>>2]|0)==58|(t[u>>2]|0)==45|(t[u>>2]|0)==46|(t[u>>2]|0)==183):0)?!((t[u>>2]|0)>=192&(t[u>>2]|0)<=214):0)?!((t[u>>2]|0)>=216&(t[u>>2]|0)<=246):0)?!((t[u>>2]|0)>=248&(t[u>>2]|0)<=767):0)?!((t[u>>2]|0)>=768&(t[u>>2]|0)<=879):0)?!((t[u>>2]|0)>=880&(t[u>>2]|0)<=893):0)?!((t[u>>2]|0)>=895&(t[u>>2]|0)<=8191):0)?!((t[u>>2]|0)>=8204&(t[u>>2]|0)<=8205):0)?!((t[u>>2]|0)>=8255&(t[u>>2]|0)<=8256):0)?!((t[u>>2]|0)>=8304&(t[u>>2]|0)<=8591):0)?!((t[u>>2]|0)>=11264&(t[u>>2]|0)<=12271):0)?!((t[u>>2]|0)>=12289&(t[u>>2]|0)<=55295):0)?!((t[u>>2]|0)>=63744&(t[u>>2]|0)<=64975):0)?!((t[u>>2]|0)>=65008&(t[u>>2]|0)<=65533):0)?!((t[u>>2]|0)>=65536&(t[u>>2]|0)<=983039):0)break;t[n>>2]=1;a=t[n>>2]|0;s=r;return a|0}}else{e=t[u>>2]|0;if((i|0)<256){if(((!(65<=(e|0)&(t[u>>2]|0)<=90)?!(97<=(t[u>>2]|0)&(t[u>>2]|0)<=122):0)?!(192<=(t[u>>2]|0)&(t[u>>2]|0)<=214):0)?!(216<=(t[u>>2]|0)&(t[u>>2]|0)<=246|248<=(t[u>>2]|0)):0)o=27}else if(!(dj(e,199744)|0))o=27;do if((o|0)==27){if((t[u>>2]|0)>=256){if(19968<=(t[u>>2]|0)&(t[u>>2]|0)<=40869|(t[u>>2]|0)==12295)break;if(12321<=(t[u>>2]|0)&(t[u>>2]|0)<=12329)break}e=t[u>>2]|0;if((t[u>>2]|0)<256){if(48<=(e|0)&(t[u>>2]|0)<=57|(t[u>>2]|0)==46|(t[u>>2]|0)==45|(t[u>>2]|0)==95|(t[u>>2]|0)==58)break}else{c=(dj(e,200216)|0)!=0;if(c|(t[u>>2]|0)==46|(t[u>>2]|0)==45|(t[u>>2]|0)==95|(t[u>>2]|0)==58)break}if((t[u>>2]|0)>=256?(dj(t[u>>2]|0,200144)|0)!=0:0)break;c=t[u>>2]|0;if((t[u>>2]|0)<256)if((c|0)==183)break;else break e;else if(dj(c,200272)|0)break;else break e}while(0);t[n>>2]=1;a=t[n>>2]|0;s=r;return a|0}while(0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function jS(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+160|0;f=r+36|0;u=r+32|0;a=r+28|0;o=r+40|0;c=r+24|0;l=r+20|0;b=r+16|0;k=r+12|0;h=r+8|0;w=r+4|0;d=r;t[u>>2]=e;t[a>>2]=i;t[c>>2]=t[t[a>>2]>>2];t[l>>2]=0;t[k>>2]=Mp(t[u>>2]|0,t[c>>2]|0,b)|0;if(!(gg(t[u>>2]|0,t[k>>2]|0)|0)){t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}if((t[b>>2]|0)==1){i=t[k>>2]&255;e=t[l>>2]|0;t[l>>2]=e+1;n[o+e>>0]=i}else{i=Rp(o+(t[l>>2]|0)|0,t[k>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+i}t[c>>2]=(t[c>>2]|0)+(t[b>>2]|0);t[k>>2]=Mp(t[u>>2]|0,t[c>>2]|0,b)|0;do{if(!(zS(t[u>>2]|0,t[k>>2]|0)|0)){m=28;break}if((t[b>>2]|0)==1){i=t[k>>2]&255;e=t[l>>2]|0;t[l>>2]=e+1;n[o+e>>0]=i}else{i=Rp(o+(t[l>>2]|0)|0,t[k>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+i}t[c>>2]=(t[c>>2]|0)+(t[b>>2]|0);t[k>>2]=Mp(t[u>>2]|0,t[c>>2]|0,b)|0}while((t[l>>2]|0)<100);if((m|0)==28){if((t[l>>2]|0)>5e4?(t[(t[u>>2]|0)+360>>2]&524288|0)==0:0){AS(t[u>>2]|0,110,70920);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=t[c>>2];t[f>>2]=ql(o,t[l>>2]|0)|0;v=t[f>>2]|0;s=r;return v|0}t[w>>2]=t[l>>2]<<1;t[h>>2]=gAi[t[135752>>2]&511](t[w>>2]|0)|0;if(!(t[h>>2]|0)){Sp(t[u>>2]|0,0);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}YY(t[h>>2]|0,o|0,t[l>>2]|0)|0;while(1){o=(zS(t[u>>2]|0,t[k>>2]|0)|0)!=0;_=t[l>>2]|0;if(!o){m=27;break}if((_+10|0)>(t[w>>2]|0)){if((t[l>>2]|0)>5e4?(t[(t[u>>2]|0)+360>>2]&524288|0)==0:0){m=19;break}t[w>>2]=t[w>>2]<<1;t[d>>2]=MAi[t[135760>>2]&511](t[h>>2]|0,t[w>>2]|0)|0;if(!(t[d>>2]|0)){m=21;break}t[h>>2]=t[d>>2]}if((t[b>>2]|0)==1){o=t[k>>2]&255;i=t[l>>2]|0;t[l>>2]=i+1;n[(t[h>>2]|0)+i>>0]=o}else{o=Rp((t[h>>2]|0)+(t[l>>2]|0)|0,t[k>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+o}t[c>>2]=(t[c>>2]|0)+(t[b>>2]|0);t[k>>2]=Mp(t[u>>2]|0,t[c>>2]|0,b)|0}if((m|0)==19){AS(t[u>>2]|0,110,70920);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}else if((m|0)==21){Sp(t[u>>2]|0,0);pAi[t[135736>>2]&511](t[h>>2]|0);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}else if((m|0)==27){n[(t[h>>2]|0)+_>>0]=0;t[t[a>>2]>>2]=t[c>>2];t[f>>2]=t[h>>2];v=t[f>>2]|0;s=r;return v|0}return 0}function VS(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0;a=s;s=s+96|0;o=a+84|0;c=a+80|0;l=a+76|0;b=a+72|0;k=a+68|0;h=a+88|0;w=a+64|0;d=a+60|0;v=a+56|0;m=a+52|0;_=a+48|0;p=a+44|0;E=a+40|0;S=a+36|0;g=a+32|0;y=a+28|0;F=a+24|0;O=a+20|0;A=a+16|0;M=a+12|0;R=a+8|0;N=a+4|0;T=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;n[h>>0]=0;t[w>>2]=0;t[_>>2]=0;if((t[(t[c>>2]|0)+292>>2]|0)==0?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[c>>2]|0);t[w>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2];t[p>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2];t[E>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+32>>2];if((u[t[w>>2]>>0]|0|0)!=34?(u[t[w>>2]>>0]|0|0)!=39:0){AS(t[c>>2]|0,39,0);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}t[(t[c>>2]|0)+172>>2]=12;f=t[w>>2]|0;t[w>>2]=f+1;n[h>>0]=n[f>>0]|0;t[E>>2]=(t[E>>2]|0)+1;t[v>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2];
	t[d>>2]=t[w>>2];if((t[w>>2]|0)>>>0>=(t[v>>2]|0)>>>0){t[S>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2];if((t[(t[c>>2]|0)+292>>2]|0)==0?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[c>>2]|0);if((t[S>>2]|0)!=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)){t[g>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)-(t[S>>2]|0);t[d>>2]=(t[d>>2]|0)+(t[g>>2]|0);t[w>>2]=(t[w>>2]|0)+(t[g>>2]|0)}t[v>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]}do if(t[k>>2]|0){while(1){if((t[w>>2]|0)>>>0>=(t[v>>2]|0)>>>0){D=35;break}if((u[t[w>>2]>>0]|0|0)==(u[h>>0]|0|0)){D=35;break}if((((u[t[w>>2]>>0]|0|0)!=32?(u[t[w>>2]>>0]|0|0)!=9:0)?(u[t[w>>2]>>0]|0|0)!=10:0)?(u[t[w>>2]>>0]|0|0)!=13:0){D=35;break}if((u[t[w>>2]>>0]|0|0)==10){t[p>>2]=(t[p>>2]|0)+1;t[E>>2]=1}else t[E>>2]=(t[E>>2]|0)+1;t[w>>2]=(t[w>>2]|0)+1;t[d>>2]=t[w>>2];if((t[w>>2]|0)>>>0<(t[v>>2]|0)>>>0)continue;t[y>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2];if((t[(t[c>>2]|0)+292>>2]|0)==0?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[c>>2]|0);if((t[(t[c>>2]|0)+172>>2]|0)==-1){D=29;break}if((t[y>>2]|0)!=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)){t[F>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)-(t[y>>2]|0);t[d>>2]=(t[d>>2]|0)+(t[F>>2]|0);t[w>>2]=(t[w>>2]|0)+(t[F>>2]|0)}t[v>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2];if(((t[w>>2]|0)-(t[d>>2]|0)|0)<=1e7)continue;if(!(t[(t[c>>2]|0)+360>>2]&524288)){D=34;break}}if((D|0)==29){t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==34){BS(t[c>>2]|0,40,71720);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==35){while(1){D=0;if((t[w>>2]|0)>>>0>=(t[v>>2]|0)>>>0){D=54;break}if((u[t[w>>2]>>0]|0|0)==(u[h>>0]|0|0)){D=54;break}if((u[t[w>>2]>>0]|0|0)<32){D=54;break}if((u[t[w>>2]>>0]|0|0)>127){D=54;break}if((u[t[w>>2]>>0]|0|0)==38){D=54;break}if((u[t[w>>2]>>0]|0|0)==60){D=54;break}t[E>>2]=(t[E>>2]|0)+1;g=t[w>>2]|0;t[w>>2]=g+1;if((u[g>>0]|0|0)==32?(u[t[w>>2]>>0]|0|0)==32:0){D=54;break}if((t[w>>2]|0)>>>0<(t[v>>2]|0)>>>0){D=35;continue}t[O>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2];if((t[(t[c>>2]|0)+292>>2]|0)==0?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[c>>2]|0);if((t[(t[c>>2]|0)+172>>2]|0)==-1){D=48;break}if((t[O>>2]|0)!=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)){t[A>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)-(t[O>>2]|0);t[d>>2]=(t[d>>2]|0)+(t[A>>2]|0);t[w>>2]=(t[w>>2]|0)+(t[A>>2]|0)}t[v>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2];if(((t[w>>2]|0)-(t[d>>2]|0)|0)<=1e7){D=35;continue}if(!(t[(t[c>>2]|0)+360>>2]&524288)){D=53;break}else D=35}if((D|0)==48){t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==53){BS(t[c>>2]|0,40,71720);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==54){t[m>>2]=t[w>>2];while(1){if((u[(t[m>>2]|0)+-1>>0]|0|0)!=32)break;if((t[m>>2]|0)>>>0<=(t[d>>2]|0)>>>0)break;t[m>>2]=(t[m>>2]|0)+-1}while(1){if((t[w>>2]|0)>>>0<(t[v>>2]|0)>>>0?(u[t[w>>2]>>0]|0|0)!=(u[h>>0]|0|0):0)if(((u[t[w>>2]>>0]|0|0)!=32?(u[t[w>>2]>>0]|0|0)!=9:0)?(u[t[w>>2]>>0]|0|0)!=10:0)C=(u[t[w>>2]>>0]|0|0)==13;else C=1;else C=0;P=t[w>>2]|0;if(!C){D=79;break}if((u[P>>0]|0|0)==10){t[p>>2]=(t[p>>2]|0)+1;t[E>>2]=1}else t[E>>2]=(t[E>>2]|0)+1;t[w>>2]=(t[w>>2]|0)+1;if((t[w>>2]|0)>>>0<(t[v>>2]|0)>>>0)continue;t[M>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2];if((t[(t[c>>2]|0)+292>>2]|0)==0?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[c>>2]|0);if((t[(t[c>>2]|0)+172>>2]|0)==-1){D=73;break}if((t[M>>2]|0)!=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)){t[R>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)-(t[M>>2]|0);t[d>>2]=(t[d>>2]|0)+(t[R>>2]|0);t[w>>2]=(t[w>>2]|0)+(t[R>>2]|0);t[m>>2]=(t[m>>2]|0)+(t[R>>2]|0)}t[v>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2];if(((t[w>>2]|0)-(t[d>>2]|0)|0)<=1e7)continue;if(!(t[(t[c>>2]|0)+360>>2]&524288)){D=78;break}}if((D|0)==73){t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==78){BS(t[c>>2]|0,40,71720);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==79){if((P-(t[d>>2]|0)|0)>1e7?(t[(t[c>>2]|0)+360>>2]&524288|0)==0:0){BS(t[c>>2]|0,40,71720);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}if((u[t[w>>2]>>0]|0|0)!=(u[h>>0]|0|0)){D=113;break}else break}}}}else{while(1){if(((((t[w>>2]|0)>>>0<(t[v>>2]|0)>>>0?(u[t[w>>2]>>0]|0|0)!=(u[h>>0]|0|0):0)?(u[t[w>>2]>>0]|0|0)>=32:0)?(u[t[w>>2]>>0]|0|0)<=127:0)?(u[t[w>>2]>>0]|0|0)!=38:0)B=(u[t[w>>2]>>0]|0|0)!=60;else B=0;I=t[w>>2]|0;if(!B){D=101;break}t[w>>2]=I+1;t[E>>2]=(t[E>>2]|0)+1;if((t[w>>2]|0)>>>0<(t[v>>2]|0)>>>0)continue;t[N>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2];if((t[(t[c>>2]|0)+292>>2]|0)==0?((t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[c>>2]|0);if((t[(t[c>>2]|0)+172>>2]|0)==-1){D=95;break}if((t[N>>2]|0)!=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)){t[T>>2]=(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)-(t[N>>2]|0);t[d>>2]=(t[d>>2]|0)+(t[T>>2]|0);t[w>>2]=(t[w>>2]|0)+(t[T>>2]|0)}t[v>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+20>>2];if(((t[w>>2]|0)-(t[d>>2]|0)|0)<=1e7)continue;if(!(t[(t[c>>2]|0)+360>>2]&524288)){D=100;break}}if((D|0)==95){t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==100){BS(t[c>>2]|0,40,71720);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}else if((D|0)==101){t[m>>2]=I;if(((t[w>>2]|0)-(t[d>>2]|0)|0)>1e7?(t[(t[c>>2]|0)+360>>2]&524288|0)==0:0){BS(t[c>>2]|0,40,71720);t[o>>2]=0;L=t[o>>2]|0;s=a;return L|0}if((u[t[w>>2]>>0]|0|0)!=(u[h>>0]|0|0)){D=113;break}else break}}while(0);if((D|0)==113){if(t[b>>2]|0)t[t[b>>2]>>2]=1;t[o>>2]=yg(t[c>>2]|0,t[l>>2]|0,t[k>>2]|0)|0;L=t[o>>2]|0;s=a;return L|0}t[w>>2]=(t[w>>2]|0)+1;t[E>>2]=(t[E>>2]|0)+1;if(t[l>>2]|0){t[t[l>>2]>>2]=(t[m>>2]|0)-(t[d>>2]|0);t[_>>2]=t[d>>2]}else{if(t[b>>2]|0)t[t[b>>2]>>2]=1;t[_>>2]=ql(t[d>>2]|0,(t[m>>2]|0)-(t[d>>2]|0)|0)|0}t[(t[(t[c>>2]|0)+36>>2]|0)+16>>2]=t[w>>2];t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2]=t[p>>2];t[(t[(t[c>>2]|0)+36>>2]|0)+32>>2]=t[E>>2];if(t[b>>2]|0)t[t[b>>2]>>2]=0;t[o>>2]=t[_>>2];L=t[o>>2]|0;s=a;return L|0}function qS(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;Fp(t[(t[r>>2]|0)+36>>2]|0);if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[r>>2]|0)|0;s=i;return}function YS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;if((t[(t[t[o>>2]>>2]|0)+72>>2]|0)==(t[(t[t[o>>2]>>2]|0)+68>>2]|0)){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}if(((t[(t[o>>2]|0)+232>>2]|0)!=0?(t[t[(t[o>>2]|0)+232>>2]>>2]|0)!=1:0)?(t[t[(t[o>>2]|0)+232>>2]>>2]|0)!=-2:0){e:do if(!(t[b>>2]|0)){t[k>>2]=0;i:while(1){if((t[k>>2]|0)>=(t[l>>2]|0))break e;do if((u[(t[c>>2]|0)+(t[k>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[c>>2]|0)+(t[k>>2]|0)>>0]|0|0)?(u[(t[c>>2]|0)+(t[k>>2]|0)>>0]|0|0)<=10:0)break;if((u[(t[c>>2]|0)+(t[k>>2]|0)>>0]|0|0)!=13)break i}while(0);t[k>>2]=(t[k>>2]|0)+1}t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}while(0);if(!(t[(t[o>>2]|0)+52>>2]|0)){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}if(t[(t[o>>2]|0)+8>>2]|0){t[h>>2]=iR(t[(t[o>>2]|0)+8>>2]|0,t[(t[(t[o>>2]|0)+52>>2]|0)+8>>2]|0)|0;if(!(t[h>>2]|0)){t[a>>2]=1;d=t[a>>2]|0;s=f;return d|0}if((t[h>>2]|0)==1){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}}if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}if(((t[(t[(t[o>>2]|0)+52>>2]|0)+12>>2]|0)==0?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}t[w>>2]=Uy(t[(t[o>>2]|0)+52>>2]|0)|0;if(!(t[w>>2]|0)){if((t[(t[(t[o>>2]|0)+52>>2]|0)+4>>2]|0)!=1?(t[(t[(t[o>>2]|0)+52>>2]|0)+40>>2]|0)!=0:0){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}}else{if(pF(t[w>>2]|0)|0){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}if((t[(t[(t[o>>2]|0)+52>>2]|0)+12>>2]|0)!=0?(pF(t[(t[(t[o>>2]|0)+52>>2]|0)+12>>2]|0)|0)!=0:0){t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}}t[a>>2]=1;d=t[a>>2]|0;s=f;return d|0}t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}function GS(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+336|0;f=r+20|0;a=r+16|0;o=r+24|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=0;t[k>>2]=0;if(((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[f>>2]|0);if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);t[l>>2]=Ap(t[f>>2]|0,b)|0;while(1){if(!((t[l>>2]|0)!=60&(t[l>>2]|0)!=38)){h=49;break}i=t[l>>2]|0;if((t[l>>2]|0)<256)if(9<=(i|0)&(t[l>>2]|0)<=10|(t[l>>2]|0)==13)w=1;else w=32<=(t[l>>2]|0);else if(!(256<=(i|0)&(t[l>>2]|0)<=55295)?!(57344<=(t[l>>2]|0)&(t[l>>2]|0)<=65533):0)if(65536<=(t[l>>2]|0))w=(t[l>>2]|0)<=1114111;else w=0;else w=1;if(!(w&1)){h=49;break}if(((t[l>>2]|0)==93?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==93:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==62:0){if(t[a>>2]|0){h=49;break}AS(t[f>>2]|0,62,0)}if((t[b>>2]|0)==1){i=t[l>>2]&255;e=t[c>>2]|0;t[c>>2]=e+1;n[o+e>>0]=i}else{i=Rp(o+(t[c>>2]|0)|0,t[l>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+i}if((t[c>>2]|0)>=300){n[o+(t[c>>2]|0)>>0]=0;do if((t[t[f>>2]>>2]|0)!=0?(t[(t[f>>2]|0)+212>>2]|0)==0:0){i=(YS(t[f>>2]|0,o,t[c>>2]|0,0)|0)!=0;e=t[t[f>>2]>>2]|0;if(i){if(!(t[e+72>>2]|0))break;yAi[t[(t[t[f>>2]>>2]|0)+72>>2]&511](t[(t[f>>2]|0)+4>>2]|0,o,t[c>>2]|0);break}if(t[e+68>>2]|0)yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,o,t[c>>2]|0);if((t[(t[t[f>>2]>>2]|0)+68>>2]|0)!=(t[(t[t[f>>2]>>2]|0)+72>>2]|0)?(t[t[(t[f>>2]|0)+232>>2]>>2]|0)==-1:0)t[t[(t[f>>2]|0)+232>>2]>>2]=-2}while(0);t[c>>2]=0;if((t[(t[f>>2]|0)+172>>2]|0)!=7){h=71;break}}t[k>>2]=(t[k>>2]|0)+1;if((t[k>>2]|0)>50){if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);t[k>>2]=0;if((t[(t[f>>2]|0)+172>>2]|0)==-1){h=71;break}}e=t[(t[f>>2]|0)+36>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){i=e+28|0;t[i>>2]=(t[i>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{i=e+32|0;t[i>>2]=(t[i>>2]|0)+1}i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+(t[b>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[f>>2]|0);t[l>>2]=Ap(t[f>>2]|0,b)|0}if((h|0)==49){do if(((t[c>>2]|0)!=0?(n[o+(t[c>>2]|0)>>0]=0,(t[t[f>>2]>>2]|0)!=0):0)?(t[(t[f>>2]|0)+212>>2]|0)==0:0){k=(YS(t[f>>2]|0,o,t[c>>2]|0,0)|0)!=0;a=t[t[f>>2]>>2]|0;if(k){if(!(t[a+72>>2]|0))break;yAi[t[(t[t[f>>2]>>2]|0)+72>>2]&511](t[(t[f>>2]|0)+4>>2]|0,o,t[c>>2]|0);break}if(t[a+68>>2]|0)yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,o,t[c>>2]|0);if((t[(t[t[f>>2]>>2]|0)+68>>2]|0)!=(t[(t[t[f>>2]>>2]|0)+72>>2]|0)?(t[t[(t[f>>2]|0)+232>>2]>>2]|0)==-1:0)t[t[(t[f>>2]|0)+232>>2]>>2]=-2}while(0);if(!(t[l>>2]|0)){s=r;return}c=t[l>>2]|0;if((t[l>>2]|0)<256){if(9<=(c|0)&(t[l>>2]|0)<=10|(t[l>>2]|0)==13|32<=(t[l>>2]|0)){s=r;return}}else{if(256<=(c|0)&(t[l>>2]|0)<=55295){s=r;return}if(57344<=(t[l>>2]|0)&(t[l>>2]|0)<=65533){s=r;return}if(65536<=(t[l>>2]|0)&(t[l>>2]|0)<=1114111){s=r;return}}OS(t[f>>2]|0,9,72816,t[l>>2]|0);l=t[(t[f>>2]|0)+36>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){c=l+28|0;t[c>>2]=(t[c>>2]|0)+1;t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2]=1}else{c=l+32|0;t[c>>2]=(t[c>>2]|0)+1}c=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[c>>2]=(t[c>>2]|0)+(t[b>>2]|0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37){s=r;return}oE(t[f>>2]|0);s=r;return}else if((h|0)==71){s=r;return}}function WS(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;a=s;s=s+64|0;o=a+52|0;c=a+48|0;l=a+44|0;b=a+40|0;k=a+36|0;h=a+32|0;w=a+28|0;d=a+24|0;v=a+20|0;m=a+16|0;_=a+12|0;p=a+8|0;E=a+4|0;S=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;t[_>>2]=0;t[p>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+56>>2];if((t[c>>2]|0)==0?(t[l>>2]=0,t[b>>2]=100,t[c>>2]=gAi[t[135752>>2]&511](t[b>>2]|0)|0,(t[c>>2]|0)==0):0){Sp(t[o>>2]|0,0);s=a;return}if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);t[k>>2]=Ap(t[o>>2]|0,h)|0;if(t[k>>2]|0){f=t[k>>2]|0;if((t[k>>2]|0)<256){if(!(9<=(f|0)&(t[k>>2]|0)<=10|(t[k>>2]|0)==13|32<=(t[k>>2]|0)))g=13}else if((!(256<=(f|0)&(t[k>>2]|0)<=55295)?!(57344<=(t[k>>2]|0)&(t[k>>2]|0)<=65533):0)?!(65536<=(t[k>>2]|0)&(t[k>>2]|0)<=1114111):0)g=13;if((g|0)==13){OS(t[o>>2]|0,9,72648,t[k>>2]|0);pAi[t[135736>>2]&511](t[c>>2]|0);s=a;return}f=t[(t[o>>2]|0)+36>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){r=f+28|0;t[r>>2]=(t[r>>2]|0)+1;t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=1}else{r=f+32|0;t[r>>2]=(t[r>>2]|0)+1}r=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+(t[h>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[o>>2]|0);t[w>>2]=Ap(t[o>>2]|0,d)|0;if(t[w>>2]|0){r=t[w>>2]|0;if((t[w>>2]|0)<256){if(!(9<=(r|0)&(t[w>>2]|0)<=10|(t[w>>2]|0)==13|32<=(t[w>>2]|0)))g=25}else if((!(256<=(r|0)&(t[w>>2]|0)<=55295)?!(57344<=(t[w>>2]|0)&(t[w>>2]|0)<=65533):0)?!(65536<=(t[w>>2]|0)&(t[w>>2]|0)<=1114111):0)g=25;if((g|0)==25){OS(t[o>>2]|0,9,72648,t[k>>2]|0);pAi[t[135736>>2]&511](t[c>>2]|0);s=a;return}r=t[(t[o>>2]|0)+36>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){f=r+28|0;t[f>>2]=(t[f>>2]|0)+1;t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=1}else{f=r+32|0;t[f>>2]=(t[f>>2]|0)+1}f=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[f>>2]=(t[f>>2]|0)+(t[d>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[o>>2]|0);t[v>>2]=Ap(t[o>>2]|0,m)|0;if(t[v>>2]|0){while(1){f=t[v>>2]|0;if((t[v>>2]|0)<256){if(!(9<=(f|0)&(t[v>>2]|0)<=10|(t[v>>2]|0)==13|32<=(t[v>>2]|0))){g=70;break}}else if((!(256<=(f|0)&(t[v>>2]|0)<=55295)?!(57344<=(t[v>>2]|0)&(t[v>>2]|0)<=65533):0)?!(65536<=(t[v>>2]|0)&(t[v>>2]|0)<=1114111):0){g=70;break}if(!((t[v>>2]|0)!=62|(t[w>>2]|0)!=45|(t[k>>2]|0)!=45)){g=70;break}if((t[w>>2]|0)==45&(t[k>>2]|0)==45)AS(t[o>>2]|0,80,0);if((t[l>>2]|0)>>>0>1e7?(t[(t[o>>2]|0)+360>>2]&524288|0)==0:0){g=42;break}if(((t[l>>2]|0)+5|0)>>>0>=(t[b>>2]|0)>>>0){t[S>>2]=t[b>>2]<<1;t[E>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[S>>2]|0)|0;if(!(t[E>>2]|0)){g=45;break}t[c>>2]=t[E>>2];t[b>>2]=t[S>>2]}if((t[h>>2]|0)==1){f=t[k>>2]&255;r=t[l>>2]|0;t[l>>2]=r+1;n[(t[c>>2]|0)+r>>0]=f}else{f=Rp((t[c>>2]|0)+(t[l>>2]|0)|0,t[k>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+f}t[k>>2]=t[w>>2];t[h>>2]=t[d>>2];t[w>>2]=t[v>>2];t[d>>2]=t[m>>2];t[_>>2]=(t[_>>2]|0)+1;if((t[_>>2]|0)>>>0>50){do if(!(t[(t[o>>2]|0)+292>>2]|0)){if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[o>>2]|0)}while(0);t[_>>2]=0;if((t[(t[o>>2]|0)+172>>2]|0)==-1){g=55;break}}f=t[(t[o>>2]|0)+36>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){r=f+28|0;t[r>>2]=(t[r>>2]|0)+1;t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=1}else{r=f+32|0;t[r>>2]=(t[r>>2]|0)+1}r=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+(t[m>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[o>>2]|0);t[v>>2]=Ap(t[o>>2]|0,m)|0;if(t[v>>2]|0)continue;do if(!(t[(t[o>>2]|0)+292>>2]|0)){if(((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0)<=500)break;if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=500)break;qS(t[o>>2]|0)}while(0);do if(!(t[(t[o>>2]|0)+292>>2]|0)){if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[o>>2]|0)}while(0);t[v>>2]=Ap(t[o>>2]|0,m)|0}if((g|0)==42){MS(t[o>>2]|0,45,66168,0);pAi[t[135736>>2]&511](t[c>>2]|0);s=a;return}else if((g|0)==45){pAi[t[135736>>2]&511](t[c>>2]|0);Sp(t[o>>2]|0,0);s=a;return}else if((g|0)==55){pAi[t[135736>>2]&511](t[c>>2]|0);s=a;return}else if((g|0)==70){n[(t[c>>2]|0)+(t[l>>2]|0)>>0]=0;do if(t[v>>2]|0){l=t[v>>2]|0;if((t[v>>2]|0)<256){if(!(9<=(l|0)&(t[v>>2]|0)<=10|(t[v>>2]|0)==13|32<=(t[v>>2]|0)))g=77}else if((!(256<=(l|0)&(t[v>>2]|0)<=55295)?!(57344<=(t[v>>2]|0)&(t[v>>2]|0)<=65533):0)?!(65536<=(t[v>>2]|0)&(t[v>>2]|0)<=1114111):0)g=77;if((g|0)==77){OS(t[o>>2]|0,9,72648,t[v>>2]|0);break}if((t[p>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+56>>2]|0))BS(t[o>>2]|0,90,72736);Op(t[o>>2]|0);if(((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+80>>2]|0)!=0:0)?(t[(t[o>>2]|0)+212>>2]|0)==0:0)EAi[t[(t[t[o>>2]>>2]|0)+80>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[c>>2]|0)}else MS(t[o>>2]|0,45,72696,t[c>>2]|0);while(0);pAi[t[135736>>2]&511](t[c>>2]|0);s=a;return}}}}MS(t[o>>2]|0,45,72792,0);pAi[t[135736>>2]&511](t[c>>2]|0);s=a;return}function KS(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+48|0;o=a;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+212>>2]|0)!=0:0)?(t[(t[c>>2]|0)+172>>2]|0)==-1:0){s=a;return}if(t[c>>2]|0)t[(t[c>>2]|0)+84>>2]=t[l>>2];u=t[c>>2]|0;f=t[l>>2]|0;l=t[k>>2]|0;n=t[h>>2]|0;r=t[w>>2]|0;i=t[b>>2]|0;b=t[h>>2]|0;h=t[w>>2]|0;t[o>>2]=t[k>>2];t[o+4>>2]=b;t[o+8>>2]=h;cp(0,0,0,u,0,3,f,2,0,0,l,n,r,0,0,i,o);if(!(t[c>>2]|0)){s=a;return}t[(t[c>>2]|0)+356>>2]=0;s=a;return}function XS(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;r=s;s=s+32|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;b=r+20|0;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;t[c>>2]=t[a>>2];while(1){do if((u[t[c>>2]>>0]|0|0)==32)k=1;else{if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){k=1;break}k=(u[t[c>>2]>>0]|0|0)==13}while(0);h=t[c>>2]|0;if(!k)break;t[c>>2]=h+1}do if(!(Jl(h,72576,7)|0)){t[c>>2]=(t[c>>2]|0)+7;while(1){do if((u[t[c>>2]>>0]|0|0)==32)w=1;else{if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){w=1;break}w=(u[t[c>>2]>>0]|0|0)==13}while(0);d=t[c>>2]|0;if(!w)break;t[c>>2]=d+1}if((u[d>>0]|0|0)!=61){s=r;return}t[c>>2]=(t[c>>2]|0)+1;while(1){do if((u[t[c>>2]>>0]|0|0)==32)v=1;else{if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){v=1;break}v=(u[t[c>>2]>>0]|0|0)==13}while(0);m=t[c>>2]|0;if(!v)break;t[c>>2]=m+1}n[b>>0]=n[m>>0]|0;if((u[b>>0]|0|0)!=39?(u[b>>0]|0|0)!=34:0)break;t[c>>2]=(t[c>>2]|0)+1;t[l>>2]=t[c>>2];while(1){if(u[t[c>>2]>>0]|0)_=(u[t[c>>2]>>0]|0|0)!=(u[b>>0]|0|0);else _=0;p=t[c>>2]|0;if(!_)break;t[c>>2]=p+1}if(u[p>>0]|0){t[o>>2]=ql(t[l>>2]|0,(t[c>>2]|0)-(t[l>>2]|0)|0)|0;t[c>>2]=(t[c>>2]|0)+1;while(1){do if((u[t[c>>2]>>0]|0|0)==32)E=1;else{if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0){E=1;break}E=(u[t[c>>2]>>0]|0|0)==13}while(0);S=t[c>>2]|0;if(!E)break;t[c>>2]=S+1}if(!(u[S>>0]|0)){if(!(t[o>>2]|0)){s=r;return}k=kc(t[(t[f>>2]|0)+284>>2]|0,t[o>>2]|0)|0;t[(t[f>>2]|0)+284>>2]=k;pAi[t[135736>>2]&511](t[o>>2]|0);s=r;return}}}while(0);NS(t[f>>2]|0,93,72584,t[a>>2]|0,0);if(!(t[o>>2]|0)){s=r;return}pAi[t[135736>>2]&511](t[o>>2]|0);s=r;return}function ZS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+212>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)==-1:0){s=f;return}if(t[a>>2]|0)t[(t[a>>2]|0)+84>>2]=t[o>>2];n=t[a>>2]|0;a=t[o>>2]|0;o=t[l>>2]|0;r=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,0,1,a,2,0,0,o,0,0,0,0,r,u);s=f;return}function JS(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+8|0;a=r+4|0;o=r;t[a>>2]=e;t[o>>2]=i;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}while(1){if((u[t[a>>2]>>0]|0|0)!=32)break;t[a>>2]=(t[a>>2]|0)+1}while(1){if(!(u[t[a>>2]>>0]|0))break;if((u[t[a>>2]>>0]|0|0)!=32){i=t[a>>2]|0;t[a>>2]=i+1;e=n[i>>0]|0;i=t[o>>2]|0;t[o>>2]=i+1;n[i>>0]=e;continue}while(1){l=t[a>>2]|0;if((u[t[a>>2]>>0]|0|0)!=32)break;t[a>>2]=l+1}if(!(u[l>>0]|0))continue;e=t[o>>2]|0;t[o>>2]=e+1;n[e>>0]=32}n[t[o>>2]>>0]=0;if((t[o>>2]|0)==(t[a>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}else{t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}return 0}function QS(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if((t[(t[u>>2]|0)+352>>2]|0)!=0?(fO(t[(t[u>>2]|0)+352>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)!=0:0){s=f;return}if(!((t[(t[u>>2]|0)+348>>2]|0)==0?(n=KF(10,t[(t[u>>2]|0)+296>>2]|0)|0,t[(t[u>>2]|0)+348>>2]=n,(t[(t[u>>2]|0)+348>>2]|0)==0):0))d=5;do if((d|0)==5){t[k>>2]=jg(t[a>>2]|0,b)|0;n=t[(t[u>>2]|0)+296>>2]|0;if(!(t[k>>2]|0)){t[k>>2]=kz(n,t[a>>2]|0,-1)|0;t[h>>2]=0}else{t[k>>2]=kz(n,t[k>>2]|0,-1)|0;t[h>>2]=kz(t[(t[u>>2]|0)+296>>2]|0,t[a>>2]|0,t[b>>2]|0)|0}t[l>>2]=fO(t[(t[u>>2]|0)+348>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;if(!(t[l>>2]|0)){t[l>>2]=gAi[t[135744>>2]&511](108)|0;if(!(t[l>>2]|0))break;t[t[l>>2]>>2]=0;t[(t[l>>2]|0)+4>>2]=4;if((iO(t[(t[u>>2]|0)+348>>2]|0,t[k>>2]|0,t[h>>2]|0,t[l>>2]|0,0)|0)<0){pAi[t[135736>>2]&511](t[l>>2]|0);break}}else if((t[t[l>>2]>>2]|0)>=(t[(t[l>>2]|0)+4>>2]|0)){t[w>>2]=MAi[t[135760>>2]&511](t[l>>2]|0,28+((t[(t[l>>2]|0)+4>>2]<<1)*5<<2)|0)|0;if(!(t[w>>2]|0))break;t[l>>2]=t[w>>2];n=(t[l>>2]|0)+4|0;t[n>>2]=t[n>>2]<<1;if((iO(t[(t[u>>2]|0)+348>>2]|0,t[k>>2]|0,t[h>>2]|0,t[l>>2]|0,0)|0)<0){pAi[t[135736>>2]&511](t[l>>2]|0);break}}t[k>>2]=jg(t[o>>2]|0,b)|0;n=t[(t[u>>2]|0)+296>>2]|0;if(!(t[k>>2]|0)){t[k>>2]=kz(n,t[o>>2]|0,-1)|0;t[h>>2]=0}else{t[k>>2]=kz(n,t[k>>2]|0,-1)|0;t[h>>2]=kz(t[(t[u>>2]|0)+296>>2]|0,t[o>>2]|0,t[b>>2]|0)|0}t[(t[l>>2]|0)+8+((t[t[l>>2]>>2]|0)*5<<2)>>2]=t[k>>2];t[(t[l>>2]|0)+8+(((t[t[l>>2]>>2]|0)*5|0)+1<<2)>>2]=t[h>>2];t[b>>2]=rs(t[c>>2]|0)|0;t[c>>2]=kz(t[(t[u>>2]|0)+296>>2]|0,t[c>>2]|0,t[b>>2]|0)|0;t[(t[l>>2]|0)+8+(((t[t[l>>2]>>2]|0)*5|0)+2<<2)>>2]=t[c>>2];t[(t[l>>2]|0)+8+(((t[t[l>>2]>>2]|0)*5|0)+3<<2)>>2]=(t[c>>2]|0)+(t[b>>2]|0);n=(t[l>>2]|0)+8+(((t[t[l>>2]>>2]|0)*5|0)+4<<2)|0;if(t[(t[u>>2]|0)+96>>2]|0)t[n>>2]=72560;else t[n>>2]=0;n=t[l>>2]|0;t[n>>2]=(t[n>>2]|0)+1;s=f;return}while(0);Sp(t[u>>2]|0,0);s=f;return}function $S(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if((t[(t[u>>2]|0)+352>>2]|0)==0?(n=KF(10,t[(t[u>>2]|0)+296>>2]|0)|0,t[(t[u>>2]|0)+352>>2]=n,(t[(t[u>>2]|0)+352>>2]|0)==0):0){Sp(t[u>>2]|0,0);s=f;return}if(fO(t[(t[u>>2]|0)+352>>2]|0,t[a>>2]|0,t[o>>2]|0)|0){s=f;return}QF(t[(t[u>>2]|0)+352>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;s=f;return}function eg(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;f=s;s=s+64|0;a=f+44|0;o=f+40|0;c=f+36|0;l=f+32|0;b=f+28|0;k=f+24|0;h=f+20|0;w=f+16|0;d=f+12|0;v=f+48|0;m=f+8|0;_=f+4|0;p=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;t[w>>2]=0;n[v>>0]=0;if((t[l>>2]|0)>128){if((t[l>>2]|0)>2048?1:(t[(t[o>>2]|0)+360>>2]&524288|0)==0)E=4}else if((t[l>>2]|0)>2048)E=4;if((E|0)==4){OS(t[o>>2]|0,55,72424,t[l>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}uE(t[o>>2]|0)|0;if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);r=t[o>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==40){t[m>>2]=t[(t[r+36>>2]|0)+56>>2];Op(t[o>>2]|0);uE(t[o>>2]|0)|0;i=eg(t[o>>2]|0,t[m>>2]|0,(t[l>>2]|0)+1|0)|0;t[b>>2]=i;t[k>>2]=i;uE(t[o>>2]|0)|0;if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0)}else{t[d>>2]=sE(r)|0;r=t[o>>2]|0;if(!(t[d>>2]|0)){AS(r,54,0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}i=EM(t[r+8>>2]|0,t[d>>2]|0,2)|0;t[b>>2]=i;t[k>>2]=i;i=t[o>>2]|0;if(!(t[k>>2]|0)){Sp(i,0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}if((t[i+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=63){if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){t[(t[k>>2]|0)+4>>2]=3;Op(t[o>>2]|0);break}i=(t[k>>2]|0)+4|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==43){t[i>>2]=4;Op(t[o>>2]|0);break}else{t[i>>2]=1;break}}else{t[(t[k>>2]|0)+4>>2]=2;Op(t[o>>2]|0)}while(0);if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0)}uE(t[o>>2]|0)|0;if(((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[o>>2]|0);e:while(1){if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==41){E=117;break}if((t[(t[o>>2]|0)+172>>2]|0)==-1){E=117;break}do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==44){if(u[v>>0]|0){if((u[v>>0]|0|0)!=(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)){E=39;break e}}else n[v>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;Op(t[o>>2]|0);t[w>>2]=EM(t[(t[o>>2]|0)+8>>2]|0,0,3)|0;g=t[h>>2]|0;if(!(t[w>>2]|0)){E=46;break e}if(!g){t[(t[w>>2]|0)+12>>2]=t[b>>2];if(t[b>>2]|0)t[(t[b>>2]|0)+20>>2]=t[w>>2];i=t[w>>2]|0;t[k>>2]=i;t[b>>2]=i;break}t[(t[k>>2]|0)+16>>2]=t[w>>2];if(t[w>>2]|0)t[(t[w>>2]|0)+20>>2]=t[k>>2];t[(t[w>>2]|0)+12>>2]=t[h>>2];if(t[h>>2]|0)t[(t[h>>2]|0)+20>>2]=t[w>>2];t[k>>2]=t[w>>2];t[h>>2]=0}else{if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124){E=85;break e}if(u[v>>0]|0){if((u[v>>0]|0|0)!=(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)){E=63;break e}}else n[v>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;Op(t[o>>2]|0);t[w>>2]=EM(t[(t[o>>2]|0)+8>>2]|0,0,4)|0;y=t[h>>2]|0;if(!(t[w>>2]|0)){E=70;break e}if(!y){t[(t[w>>2]|0)+12>>2]=t[b>>2];if(t[b>>2]|0)t[(t[b>>2]|0)+20>>2]=t[w>>2];i=t[w>>2]|0;t[k>>2]=i;t[b>>2]=i;break}t[(t[k>>2]|0)+16>>2]=t[w>>2];if(t[w>>2]|0)t[(t[w>>2]|0)+20>>2]=t[k>>2];t[(t[w>>2]|0)+12>>2]=t[h>>2];if(t[h>>2]|0)t[(t[h>>2]|0)+20>>2]=t[w>>2];t[k>>2]=t[w>>2];t[h>>2]=0}while(0);if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);uE(t[o>>2]|0)|0;if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);i=t[o>>2]|0;do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){t[d>>2]=sE(i)|0;F=t[o>>2]|0;if(!(t[d>>2]|0)){E=100;break e}t[h>>2]=EM(t[F+8>>2]|0,t[d>>2]|0,2)|0;if(!(t[h>>2]|0)){E=104;break e}if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63){t[(t[h>>2]|0)+4>>2]=2;Op(t[o>>2]|0);break}if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){t[(t[h>>2]|0)+4>>2]=3;Op(t[o>>2]|0);break}r=(t[h>>2]|0)+4|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==43){t[r>>2]=4;Op(t[o>>2]|0);break}else{t[r>>2]=1;break}}else{t[_>>2]=t[(t[i+36>>2]|0)+56>>2];Op(t[o>>2]|0);uE(t[o>>2]|0)|0;t[h>>2]=eg(t[o>>2]|0,t[_>>2]|0,(t[l>>2]|0)+1|0)|0;uE(t[o>>2]|0)|0}while(0);uE(t[o>>2]|0)|0;if(t[(t[o>>2]|0)+292>>2]|0)continue;if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;CS(t[o>>2]|0)}if((E|0)==39){OS(t[o>>2]|0,66,72504,u[v>>0]|0);if((t[h>>2]|0)!=0?(t[h>>2]|0)!=(t[b>>2]|0):0)yM(t[(t[o>>2]|0)+8>>2]|0,t[h>>2]|0);if(t[b>>2]|0)yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==46){if((g|0)!=0?(t[h>>2]|0)!=(t[b>>2]|0):0)yM(t[(t[o>>2]|0)+8>>2]|0,t[h>>2]|0);yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==63){OS(t[o>>2]|0,66,72504,u[v>>0]|0);if((t[h>>2]|0)!=0?(t[h>>2]|0)!=(t[b>>2]|0):0)yM(t[(t[o>>2]|0)+8>>2]|0,t[h>>2]|0);if(t[b>>2]|0)yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==70){if((y|0)!=0?(t[h>>2]|0)!=(t[b>>2]|0):0)yM(t[(t[o>>2]|0)+8>>2]|0,t[h>>2]|0);if(t[b>>2]|0)yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==85){AS(t[o>>2]|0,55,0);if((t[h>>2]|0)!=0?(t[h>>2]|0)!=(t[b>>2]|0):0)yM(t[(t[o>>2]|0)+8>>2]|0,t[h>>2]|0);if(t[b>>2]|0)yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==100){AS(F,54,0);if(t[b>>2]|0)yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==104){if(t[b>>2]|0)yM(t[(t[o>>2]|0)+8>>2]|0,t[b>>2]|0);t[a>>2]=0;S=t[a>>2]|0;s=f;return S|0}else if((E|0)==117){if((t[k>>2]|0)!=0&(t[h>>2]|0)!=0?(t[(t[k>>2]|0)+16>>2]=t[h>>2],(t[h>>2]|0)!=0):0)t[(t[h>>2]|0)+20>>2]=t[k>>2];if((t[(t[o>>2]|0)+104>>2]|0)!=0?(t[(t[(t[o>>2]|0)+36>>2]|0)+56>>2]|0)!=(t[c>>2]|0):0)RS(t[o>>2]|0,90,67976,0,0);Op(t[o>>2]|0);do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=63){if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){e:do if(t[b>>2]|0){t[(t[b>>2]|0)+4>>2]=3;t[k>>2]=t[b>>2];while(1){if(!(t[k>>2]|0))break e;if((t[t[k>>2]>>2]|0)!=4)break e;do if(t[(t[k>>2]|0)+12>>2]|0){if((t[(t[(t[k>>2]|0)+12>>2]|0)+4>>2]|0)!=2?(t[(t[(t[k>>2]|0)+12>>2]|0)+4>>2]|0)!=3:0)break;t[(t[(t[k>>2]|0)+12>>2]|0)+4>>2]=1}while(0);do if(t[(t[k>>2]|0)+16>>2]|0){if((t[(t[(t[k>>2]|0)+16>>2]|0)+4>>2]|0)!=2?(t[(t[(t[k>>2]|0)+16>>2]|0)+4>>2]|0)!=3:0)break;t[(t[(t[k>>2]|0)+16>>2]|0)+4>>2]=1}while(0);t[k>>2]=t[(t[k>>2]|0)+16>>2]}}while(0);Op(t[o>>2]|0);break}if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==43){if(t[b>>2]|0){t[p>>2]=0;if((t[(t[b>>2]|0)+4>>2]|0)!=2?(t[(t[b>>2]|0)+4>>2]|0)!=3:0)t[(t[b>>2]|0)+4>>2]=4;else t[(t[b>>2]|0)+4>>2]=3;while(1){if(!(t[k>>2]|0))break;if((t[t[k>>2]>>2]|0)!=4)break;do if(t[(t[k>>2]|0)+12>>2]|0){if((t[(t[(t[k>>2]|0)+12>>2]|0)+4>>2]|0)!=2?(t[(t[(t[k>>2]|0)+12>>2]|0)+4>>2]|0)!=3:0)break;t[(t[(t[k>>2]|0)+12>>2]|0)+4>>2]=1;t[p>>2]=1}while(0);do if(t[(t[k>>2]|0)+16>>2]|0){if((t[(t[(t[k>>2]|0)+16>>2]|0)+4>>2]|0)!=2?(t[(t[(t[k>>2]|0)+16>>2]|0)+4>>2]|0)!=3:0)break;t[(t[(t[k>>2]|0)+16>>2]|0)+4>>2]=1;t[p>>2]=1}while(0);t[k>>2]=t[(t[k>>2]|0)+16>>2]}if(t[p>>2]|0)t[(t[b>>2]|0)+4>>2]=3}Op(t[o>>2]|0)}}else{do if(t[b>>2]|0){if((t[(t[b>>2]|0)+4>>2]|0)!=4?(t[(t[b>>2]|0)+4>>2]|0)!=3:0){t[(t[b>>2]|0)+4>>2]=2;break}t[(t[b>>2]|0)+4>>2]=3}while(0);Op(t[o>>2]|0)}while(0);t[a>>2]=t[b>>2];S=t[a>>2]|0;s=f;return S|0}return 0}function ig(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;s=s+48|0;r=i;n=i+32|0;f=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;t[n>>2]=e;t[f>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+56>>2];e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;uE(t[n>>2]|0)|0;if(((((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==67:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==85:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==68:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+7;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+7;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+7;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;uE(t[n>>2]|0)|0;e=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=91)AS(e,83,0);else{if((t[(t[e+36>>2]|0)+56>>2]|0)!=(t[f>>2]|0))RS(t[n>>2]|0,90,72192,0,0);Op(t[n>>2]|0)}if(t[33952]|0){if((t[(t[n>>2]|0)+36>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){e=t[33976]|0;k=t[33980]|0;h=t[(t[(t[n>>2]|0)+36>>2]|0)+28>>2]|0;t[r>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2];t[r+4>>2]=h;yAi[e&511](k,65312,r)}yAi[t[135904>>2]&511](t[33980]|0,72264,r)}while(1){if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;if(((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==93:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==62:0)break;if((t[(t[n>>2]|0)+172>>2]|0)==-1)break;t[a>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];t[o>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+36>>2];do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){w=37;break}if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91){w=37;break}ig(t[n>>2]|0)}else w=37;while(0);e:do if((w|0)==37){w=0;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;k=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37){
	HE(k);break e}else{IE(k);break e}}while(0);Op(t[n>>2]|0)}while(0);while(1){if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))d=(t[(t[n>>2]|0)+40>>2]|0)>1;else d=0;v=t[n>>2]|0;if(!d)break;aE(v)|0}if((t[(t[v+36>>2]|0)+16>>2]|0)!=(t[a>>2]|0))continue;if((t[o>>2]|0)==(t[(t[(t[n>>2]|0)+36>>2]|0)+36>>2]|0)){w=51;break}}if((w|0)==51)AS(t[n>>2]|0,60,0);if(t[33952]|0){if((t[(t[n>>2]|0)+36>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){o=t[33976]|0;a=t[33980]|0;v=t[(t[(t[n>>2]|0)+36>>2]|0)+28>>2]|0;t[r>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2];t[r+4>>2]=v;yAi[o&511](a,65312,r)}yAi[t[135904>>2]&511](t[33980]|0,72304,r)}}else w=57;do if((w|0)==57){if((((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==71:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==78:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==82:0)?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==69:0){t[b>>2]=0;a=(t[n>>2]|0)+200|0;t[a>>2]=(t[a>>2]|0)+6;a=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[a>>2]=(t[a>>2]|0)+6;a=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[a>>2]=(t[a>>2]|0)+6;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;uE(t[n>>2]|0)|0;a=t[n>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=91)AS(a,83,0);else{if((t[(t[a+36>>2]|0)+56>>2]|0)!=(t[f>>2]|0))RS(t[n>>2]|0,90,72192,0,0);Op(t[n>>2]|0)}if(t[33952]|0){if((t[(t[n>>2]|0)+36>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){a=t[33976]|0;o=t[33980]|0;v=t[(t[(t[n>>2]|0)+36>>2]|0)+28>>2]|0;t[r>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2];t[r+4>>2]=v;yAi[a&511](o,65312,r)}yAi[t[135904>>2]&511](t[33980]|0,72344,r)}t[c>>2]=t[(t[n>>2]|0)+212>>2];t[l>>2]=t[(t[n>>2]|0)+172>>2];if(!(t[(t[n>>2]|0)+288>>2]|0))t[(t[n>>2]|0)+212>>2]=1;t[(t[n>>2]|0)+172>>2]=15;e:while(1){if((t[b>>2]|0)<0)break;if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;if((t[(t[n>>2]|0)+172>>2]|0)==-1)break;do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33)break;if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91)break;t[b>>2]=(t[b>>2]|0)+1;o=(t[n>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+3;o=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+3;o=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)continue e;if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)continue e;aE(t[n>>2]|0)|0;continue e}while(0);do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=93)break;if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=62)break;o=(t[b>>2]|0)+-1|0;t[b>>2]=o;if((o|0)<0)continue e;o=(t[n>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+3;o=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+3;o=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)continue e;if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0)continue e;aE(t[n>>2]|0)|0;continue e}while(0);Op(t[n>>2]|0)}t[(t[n>>2]|0)+212>>2]=t[c>>2];t[(t[n>>2]|0)+172>>2]=t[l>>2];if(!(t[33952]|0))break;if((t[(t[n>>2]|0)+36>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){o=t[33976]|0;a=t[33980]|0;v=t[(t[(t[n>>2]|0)+36>>2]|0)+28>>2]|0;t[r>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2];t[r+4>>2]=v;yAi[o&511](a,65312,r)}yAi[t[135904>>2]&511](t[33980]|0,72384,r);break}AS(t[n>>2]|0,95,0)}while(0);if((((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(t[(t[n>>2]|0)+292>>2]|0)==0:0)?((t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[n>>2]|0);r=t[n>>2]|0;if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){AS(r,59,0);s=i;return}if((t[(t[r+36>>2]|0)+56>>2]|0)!=(t[f>>2]|0))RS(t[n>>2]|0,90,72192,0,0);f=(t[n>>2]|0)+200|0;t[f>>2]=(t[f>>2]|0)+3;f=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[f>>2]=(t[f>>2]|0)+3;f=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[f>>2]=(t[f>>2]|0)+3;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0){s=i;return}if((yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)>0){s=i;return}aE(t[n>>2]|0)|0;s=i;return}function rg(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}do if((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+108>>2]|0)==-554844497:0){if((t[(t[t[r>>2]>>2]|0)+116>>2]|0)==0?(t[(t[t[r>>2]>>2]|0)+120>>2]|0)==0:0)break;t[(t[r>>2]|0)+324>>2]=1}while(0);e=kz(t[(t[r>>2]|0)+296>>2]|0,70032,3)|0;t[(t[r>>2]|0)+312>>2]=e;e=kz(t[(t[r>>2]|0)+296>>2]|0,70040,5)|0;t[(t[r>>2]|0)+316>>2]=e;e=kz(t[(t[r>>2]|0)+296>>2]|0,70048,36)|0;t[(t[r>>2]|0)+320>>2]=e;if(((t[(t[r>>2]|0)+312>>2]|0)!=0?(t[(t[r>>2]|0)+316>>2]|0)!=0:0)?(t[(t[r>>2]|0)+320>>2]|0)!=0:0){s=i;return}Sp(t[r>>2]|0,0);s=i;return}function ng(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;f=s;s=s+64|0;a=f+56|0;o=f+52|0;c=f+48|0;l=f+44|0;b=f+40|0;k=f+36|0;h=f+32|0;w=f+28|0;d=f+24|0;v=f+20|0;m=f+16|0;_=f+12|0;p=f+8|0;E=f+4|0;S=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[h>>2]=0;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;t[p>>2]=0;if(!((t[(t[o>>2]|0)+248>>2]|0)>40?(t[(t[o>>2]|0)+360>>2]&524288|0)==0:0))g=3;if((g|0)==3?(t[(t[o>>2]|0)+248>>2]|0)<=1024:0){if(t[b>>2]|0)t[t[b>>2]>>2]=0;if(!(t[c>>2]|0)){t[a>>2]=1;y=t[a>>2]|0;s=f;return y|0}t[_>>2]=rs(t[c>>2]|0)|0;t[k>>2]=lS(t[c>>2]|0,t[_>>2]|0)|0;if(!(t[k>>2]|0)){t[a>>2]=27;y=t[a>>2]|0;s=f;return y|0}if(t[l>>2]|0)t[(t[k>>2]|0)+4>>2]=t[l>>2];else t[(t[k>>2]|0)+4>>2]=t[k>>2];if(t[(t[k>>2]|0)+296>>2]|0)bz(t[(t[k>>2]|0)+296>>2]|0);t[(t[k>>2]|0)+296>>2]=t[(t[o>>2]|0)+296>>2];l=kz(t[(t[k>>2]|0)+296>>2]|0,70032,3)|0;t[(t[k>>2]|0)+312>>2]=l;l=kz(t[(t[k>>2]|0)+296>>2]|0,70040,5)|0;t[(t[k>>2]|0)+316>>2]=l;l=kz(t[(t[k>>2]|0)+296>>2]|0,70048,36)|0;t[(t[k>>2]|0)+320>>2]=l;t[E>>2]=0;while(1){F=t[k>>2]|0;if((t[E>>2]|0)>=(t[(t[o>>2]|0)+328>>2]|0))break;Eg(F,t[(t[(t[o>>2]|0)+336>>2]|0)+(t[E>>2]<<2)>>2]|0,t[(t[(t[o>>2]|0)+336>>2]|0)+((t[E>>2]|0)+1<<2)>>2]|0)|0;t[E>>2]=(t[E>>2]|0)+2}t[d>>2]=t[F>>2];t[t[k>>2]>>2]=t[t[o>>2]>>2];rg(t[k>>2]|0);t[(t[k>>2]|0)+16>>2]=t[(t[o>>2]|0)+16>>2];t[(t[k>>2]|0)+360>>2]=t[(t[o>>2]|0)+360>>2];t[(t[k>>2]|0)+272>>2]=t[(t[o>>2]|0)+272>>2];do if(!(t[(t[o>>2]|0)+8>>2]|0)){t[h>>2]=ny(68488)|0;if(t[h>>2]|0){t[(t[h>>2]|0)+92>>2]=64;t[(t[h>>2]|0)+80>>2]=t[(t[k>>2]|0)+296>>2];sz(t[(t[h>>2]|0)+80>>2]|0)|0;t[(t[k>>2]|0)+8>>2]=t[h>>2];break}t[t[k>>2]>>2]=t[d>>2];t[(t[k>>2]|0)+296>>2]=0;Up(t[k>>2]|0);t[a>>2]=1;y=t[a>>2]|0;s=f;return y|0}else{t[(t[k>>2]|0)+8>>2]=t[(t[o>>2]|0)+8>>2];t[v>>2]=t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2];t[m>>2]=t[(t[(t[k>>2]|0)+8>>2]|0)+16>>2]}while(0);t[w>>2]=Sy(t[(t[k>>2]|0)+8>>2]|0,0,69968,0)|0;if(!(t[w>>2]|0)){t[t[k>>2]>>2]=t[d>>2];t[(t[k>>2]|0)+296>>2]=0;Up(t[k>>2]|0);if(t[h>>2]|0)fy(t[h>>2]|0);t[a>>2]=1;y=t[a>>2]|0;s=f;return y|0}t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]=0;t[(t[(t[k>>2]|0)+8>>2]|0)+16>>2]=0;Hy(t[(t[k>>2]|0)+8>>2]|0,t[w>>2]|0)|0;rE(t[k>>2]|0,t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]|0)|0;t[(t[k>>2]|0)+172>>2]=7;t[(t[k>>2]|0)+248>>2]=(t[(t[o>>2]|0)+248>>2]|0)+1;t[(t[k>>2]|0)+104>>2]=0;t[(t[k>>2]|0)+276>>2]=t[(t[o>>2]|0)+276>>2];if(!((t[(t[o>>2]|0)+104>>2]|0)==0?(t[(t[o>>2]|0)+16>>2]|0)==0:0)){w=(t[k>>2]|0)+276|0;t[w>>2]=t[w>>2]|8}t[(t[k>>2]|0)+364>>2]=t[(t[o>>2]|0)+364>>2];t[(t[k>>2]|0)+348>>2]=t[(t[o>>2]|0)+348>>2];t[(t[k>>2]|0)+352>>2]=t[(t[o>>2]|0)+352>>2];KE(t[k>>2]|0);if((u[t[(t[(t[k>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[k>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0)AS(t[k>>2]|0,85,0);else g=34;if((g|0)==34?(u[t[(t[(t[k>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=0:0)AS(t[k>>2]|0,86,0);if((t[(t[k>>2]|0)+52>>2]|0)!=(t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]|0))AS(t[k>>2]|0,85,0);do if(!(t[(t[k>>2]|0)+12>>2]|0))if(!(t[(t[k>>2]|0)+84>>2]|0)){t[p>>2]=1;break}else{t[p>>2]=t[(t[k>>2]|0)+84>>2];break}else t[p>>2]=0;while(0);if((t[b>>2]|0)!=0&(t[p>>2]|0)==0){t[S>>2]=t[(t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]|0)+12>>2];t[t[b>>2]>>2]=t[S>>2];while(1){if(!(t[S>>2]|0))break;do if(t[(t[o>>2]|0)+104>>2]|0){if(!(t[(t[o>>2]|0)+12>>2]|0))break;if(!(t[(t[o>>2]|0)+8>>2]|0))break;if(!(t[(t[(t[o>>2]|0)+8>>2]|0)+44>>2]|0))break;if((t[(t[S>>2]|0)+4>>2]|0)!=1)break;b=hR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[S>>2]|0)|0;g=(t[o>>2]|0)+100|0;t[g>>2]=t[g>>2]&b}while(0);t[(t[S>>2]|0)+20>>2]=0;t[S>>2]=t[(t[S>>2]|0)+24>>2]}t[(t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]|0)+12>>2]=0}if(t[(t[k>>2]|0)+8>>2]|0){ry(t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]|0);t[(t[(t[k>>2]|0)+8>>2]|0)+12>>2]=t[v>>2];t[(t[(t[k>>2]|0)+8>>2]|0)+16>>2]=t[m>>2]}if(t[o>>2]|0){m=(t[o>>2]|0)+440|0;t[m>>2]=(t[m>>2]|0)+(t[(t[k>>2]|0)+440>>2]|0)}if(t[(t[k>>2]|0)+388>>2]|0)sp((t[k>>2]|0)+384|0,(t[o>>2]|0)+384|0)|0;t[t[k>>2]>>2]=t[d>>2];t[(t[k>>2]|0)+296>>2]=0;t[(t[k>>2]|0)+348>>2]=0;t[(t[k>>2]|0)+352>>2]=0;Up(t[k>>2]|0);if(t[h>>2]|0)fy(t[h>>2]|0);t[a>>2]=t[p>>2];y=t[a>>2]|0;s=f;return y|0}t[a>>2]=89;y=t[a>>2]|0;s=f;return y|0}function fg(e,i,r,f,a,o,c,l){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;b=s;s=s+80|0;k=b+60|0;h=b+56|0;w=b+52|0;d=b+48|0;v=b+44|0;m=b+40|0;_=b+36|0;p=b+32|0;E=b+28|0;S=b+24|0;g=b+20|0;y=b+16|0;F=b+12|0;O=b+8|0;A=b+64|0;M=b+4|0;R=b;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=f;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=l;t[F>>2]=0;t[O>>2]=0;if((t[m>>2]|0)>40){if(!((t[w>>2]|0)!=0?!((t[m>>2]|0)>1024?1:(t[(t[w>>2]|0)+360>>2]&524288|0)==0):0))N=5}else if((t[m>>2]|0)>1024)N=5;if((N|0)==5){t[k>>2]=89;T=t[k>>2]|0;s=b;return T|0}if(t[E>>2]|0)t[t[E>>2]>>2]=0;if((t[_>>2]|0)==0&(t[p>>2]|0)==0){t[k>>2]=1;T=t[k>>2]|0;s=b;return T|0}if(!(t[h>>2]|0)){t[k>>2]=1;T=t[k>>2]|0;s=b;return T|0}t[S>>2]=mg(t[_>>2]|0,t[p>>2]|0,0,t[w>>2]|0)|0;if(!(t[S>>2]|0)){t[k>>2]=27;T=t[k>>2]|0;s=b;return T|0}t[(t[S>>2]|0)+4>>2]=t[S>>2];if(t[w>>2]|0){t[(t[S>>2]|0)+272>>2]=t[(t[w>>2]|0)+272>>2];t[(t[S>>2]|0)+276>>2]=t[(t[w>>2]|0)+276>>2];t[(t[S>>2]|0)+104>>2]=t[(t[w>>2]|0)+104>>2];t[(t[S>>2]|0)+96>>2]=t[(t[w>>2]|0)+96>>2];t[(t[S>>2]|0)+68>>2]=t[(t[w>>2]|0)+68>>2];t[(t[S>>2]|0)+72>>2]=t[(t[w>>2]|0)+72>>2];t[(t[S>>2]|0)+76>>2]=t[(t[w>>2]|0)+76>>2];t[(t[S>>2]|0)+80>>2]=t[(t[w>>2]|0)+80>>2]}else{t[(t[S>>2]|0)+272>>2]=0;t[(t[S>>2]|0)+104>>2]=0;t[(t[S>>2]|0)+96>>2]=2;t[(t[S>>2]|0)+276>>2]=0}if((t[d>>2]|0)!=0?(t[F>>2]=t[t[S>>2]>>2],t[t[S>>2]>>2]=t[d>>2],(t[v>>2]|0)!=0):0)t[(t[S>>2]|0)+4>>2]=t[v>>2];rg(t[S>>2]|0);t[g>>2]=ny(68488)|0;if(!(t[g>>2]|0)){t[(t[S>>2]|0)+72>>2]=0;t[(t[S>>2]|0)+76>>2]=0;t[(t[S>>2]|0)+80>>2]=0;Up(t[S>>2]|0);t[k>>2]=1;T=t[k>>2]|0;s=b;return T|0}t[(t[g>>2]|0)+92>>2]=64;t[(t[g>>2]|0)+44>>2]=t[(t[h>>2]|0)+44>>2];t[(t[g>>2]|0)+48>>2]=t[(t[h>>2]|0)+48>>2];t[(t[g>>2]|0)+80>>2]=t[(t[h>>2]|0)+80>>2];sz(t[(t[g>>2]|0)+80>>2]|0)|0;if(t[(t[h>>2]|0)+72>>2]|0){v=Yl(t[(t[h>>2]|0)+72>>2]|0)|0;t[(t[g>>2]|0)+72>>2]=v}t[y>>2]=Sy(t[g>>2]|0,0,69968,0)|0;if(!(t[y>>2]|0)){if(t[d>>2]|0)t[t[S>>2]>>2]=t[F>>2];t[(t[S>>2]|0)+72>>2]=0;t[(t[S>>2]|0)+76>>2]=0;t[(t[S>>2]|0)+80>>2]=0;Up(t[S>>2]|0);t[(t[g>>2]|0)+44>>2]=0;t[(t[g>>2]|0)+48>>2]=0;fy(t[g>>2]|0);t[k>>2]=1;T=t[k>>2]|0;s=b;return T|0}Hy(t[g>>2]|0,t[y>>2]|0)|0;rE(t[S>>2]|0,t[(t[g>>2]|0)+12>>2]|0)|0;t[(t[S>>2]|0)+8>>2]=t[h>>2];t[(t[y>>2]|0)+32>>2]=t[h>>2];if((t[(t[S>>2]|0)+292>>2]|0)==0?((t[(t[(t[S>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[S>>2]|0);if(((t[(t[(t[S>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4?(n[A>>0]=n[t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]>>0]|0,n[A+1>>0]=n[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,n[A+2>>0]=n[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,n[A+3>>0]=n[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,t[M>>2]=L_(A,4)|0,(t[M>>2]|0)!=0):0)Tp(t[S>>2]|0,t[M>>2]|0)|0;e:do if(((((u[t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break e}while(0);bE(t[S>>2]|0)}while(0);t[(t[S>>2]|0)+172>>2]=7;t[(t[S>>2]|0)+248>>2]=t[m>>2];KE(t[S>>2]|0);if((u[t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0)AS(t[S>>2]|0,85,0);else N=47;if((N|0)==47?(u[t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=0:0)AS(t[S>>2]|0,86,0);if((t[(t[S>>2]|0)+52>>2]|0)!=(t[(t[g>>2]|0)+12>>2]|0))AS(t[S>>2]|0,85,0);do if(!(t[(t[S>>2]|0)+12>>2]|0))if(!(t[(t[S>>2]|0)+84>>2]|0)){t[O>>2]=1;break}else{t[O>>2]=t[(t[S>>2]|0)+84>>2];break}else{if(t[E>>2]|0){t[R>>2]=t[(t[(t[g>>2]|0)+12>>2]|0)+12>>2];t[t[E>>2]>>2]=t[R>>2];while(1){if(!(t[R>>2]|0))break;t[(t[R>>2]|0)+20>>2]=0;t[R>>2]=t[(t[R>>2]|0)+24>>2]}t[(t[(t[g>>2]|0)+12>>2]|0)+12>>2]=0}t[O>>2]=0}while(0);if(t[w>>2]|0){R=(t[w>>2]|0)+440|0;t[R>>2]=(t[R>>2]|0)+(t[(t[S>>2]|0)+440>>2]|0)}if(t[(t[S>>2]|0)+36>>2]|0){R=(t[w>>2]|0)+444|0;t[R>>2]=(t[R>>2]|0)+(t[(t[(t[S>>2]|0)+36>>2]|0)+36>>2]|0);R=(t[w>>2]|0)+444|0;t[R>>2]=(t[R>>2]|0)+((t[(t[(t[S>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[S>>2]|0)+36>>2]|0)+12>>2]|0))}if(t[(t[S>>2]|0)+388>>2]|0)sp((t[S>>2]|0)+384|0,(t[w>>2]|0)+384|0)|0;if(t[d>>2]|0)t[t[S>>2]>>2]=t[F>>2];t[(t[w>>2]|0)+72>>2]=t[(t[S>>2]|0)+72>>2];t[(t[w>>2]|0)+76>>2]=t[(t[S>>2]|0)+76>>2];t[(t[w>>2]|0)+80>>2]=t[(t[S>>2]|0)+80>>2];t[(t[S>>2]|0)+72>>2]=0;t[(t[S>>2]|0)+76>>2]=0;t[(t[S>>2]|0)+80>>2]=0;Up(t[S>>2]|0);t[(t[g>>2]|0)+44>>2]=0;t[(t[g>>2]|0)+48>>2]=0;fy(t[g>>2]|0);t[k>>2]=t[O>>2];T=t[k>>2]|0;s=b;return T|0}function tg(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[17530]|0)){s=n;return}yAi[t[70120>>2]&511](t[f>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function ug(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n;u=n+16|0;a=n+12|0;o=n+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+212>>2]|0)!=0:0)?(t[(t[u>>2]|0)+172>>2]|0)==-1:0){s=n;return}if(t[u>>2]|0)t[(t[u>>2]|0)+84>>2]=42;r=t[u>>2]|0;if(!(t[a>>2]|0)){i=t[o>>2]|0;t[f>>2]=t[o>>2];cp(0,0,0,r,0,1,42,3,0,0,i,0,0,0,0,71848,f)}else{i=t[a>>2]|0;e=t[o>>2]|0;c=t[o>>2]|0;t[f>>2]=t[a>>2];t[f+4>>2]=c;cp(0,0,0,r,0,1,42,3,0,0,i,e,0,0,0,71872,f)}if(!(t[u>>2]|0)){s=n;return}t[(t[u>>2]|0)+12>>2]=0;if(t[(t[u>>2]|0)+288>>2]|0){s=n;return}t[(t[u>>2]|0)+212>>2]=1;s=n;return}function ag(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){i=(t[n>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+2;i=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+2;i=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+2;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[n>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[n>>2]|0)|0;t[a>>2]=Fg(t[n>>2]|0,t[(t[n>>2]|0)+184>>2]|0)|0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);uE(t[n>>2]|0)|0;if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)o=19;else if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)o=20;else o=19;if((o|0)==19)if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){i=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[n>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+1;if(!(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[n>>2]|0)+36>>2]|0,250)|0}else o=20;if((o|0)==20)AS(t[n>>2]|0,73,0);if((t[a>>2]|0)!=1){if(!(t[a>>2]|0))t[a>>2]=70752;bg(t[n>>2]|0,76,70768,t[(t[n>>2]|0)+184>>2]|0,t[f>>2]|0,t[a>>2]|0)}if(((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+60>>2]|0)!=0:0)?(t[(t[n>>2]|0)+212>>2]|0)==0:0)EAi[t[(t[t[n>>2]>>2]|0)+60>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[(t[n>>2]|0)+184>>2]|0);tE(t[n>>2]|0)|0;lg(t[n>>2]|0)|0;s=r;return}BS(t[n>>2]|0,74,71816);s=r;return}function og(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if((t[(t[f>>2]|0)+236>>2]|0)>=(t[(t[f>>2]|0)+240>>2]|0)){i=(t[f>>2]|0)+240|0;t[i>>2]=t[i>>2]<<1;t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+244>>2]|0,t[(t[f>>2]|0)+240>>2]<<2)|0;if(t[a>>2]|0){t[(t[f>>2]|0)+244>>2]=t[a>>2];break}Sp(t[f>>2]|0,0);i=(t[f>>2]|0)+240|0;t[i>>2]=(t[i>>2]|0)/2|0;t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(0);t[(t[(t[f>>2]|0)+244>>2]|0)+(t[(t[f>>2]|0)+236>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+232>>2]=(t[(t[f>>2]|0)+244>>2]|0)+(t[(t[f>>2]|0)+236>>2]<<2);u=(t[f>>2]|0)+236|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;o=t[n>>2]|0;s=r;return o|0}function cg(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0;f=s;s=s+144|0;a=f+132|0;o=f+128|0;c=f+124|0;l=f+120|0;b=f+116|0;k=f+112|0;h=f+108|0;w=f+104|0;d=f+100|0;v=f+96|0;m=f+92|0;_=f+88|0;p=f+84|0;E=f+80|0;S=f+76|0;g=f+72|0;y=f+68|0;F=f+64|0;O=f+60|0;A=f+56|0;M=f+52|0;R=f+48|0;N=f+44|0;T=f+40|0;L=f+36|0;D=f+32|0;C=f+28|0;P=f+24|0;B=f+20|0;I=f+16|0;H=f+12|0;x=f+8|0;U=f+4|0;z=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[_>>2]=t[(t[o>>2]|0)+300>>2];t[p>>2]=t[(t[o>>2]|0)+304>>2];t[L>>2]=t[(t[o>>2]|0)+328>>2];if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){t[a>>2]=0;j=t[a>>2]|0;s=f;return j|0}n=(t[(t[o>>2]|0)+36>>2]|0)+32|0;t[n>>2]=(t[n>>2]|0)+1;n=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[n>>2]=(t[n>>2]|0)+1;n=(t[o>>2]|0)+200|0;t[n>>2]=(t[n>>2]|0)+1;if(!(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[o>>2]|0)+36>>2]|0,250)|0;e:while(1){if(((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)qS(t[o>>2]|0);t[N>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2];t[T>>2]=(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0);t[M>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+28>>2];t[R>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2];t[S>>2]=0;t[E>>2]=0;t[g>>2]=0;t[O>>2]=0;t[A>>2]=0;t[(t[o>>2]|0)+328>>2]=t[L>>2];t[k>>2]=Og(t[o>>2]|0,h)|0;V=t[o>>2]|0;if(!(t[k>>2]|0)){q=10;break}t[t[b>>2]>>2]=(t[(t[V+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)-(t[T>>2]|0);uE(t[o>>2]|0)|0;if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);i:do if((t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)==(t[N>>2]|0)){r:while(1){if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break e;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break e;if(!(9<=(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))q=20;if(((q|0)==20?(q=0,(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break e;if((t[(t[o>>2]|0)+172>>2]|0)==-1)break e;t[D>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2];t[C>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+36>>2];t[P>>2]=-1;t[B>>2]=0;t[w>>2]=Ag(t[o>>2]|0,t[h>>2]|0,t[k>>2]|0,d,m,P,B)|0;if((t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)!=(t[N>>2]|0))break;n:do if((t[w>>2]|0)!=0&(t[m>>2]|0)!=0){if((t[P>>2]|0)<0)t[P>>2]=rs(t[m>>2]|0)|0;if((t[d>>2]|0)==0?(t[w>>2]|0)==(t[(t[o>>2]|0)+316>>2]|0):0){t[I>>2]=kz(t[(t[o>>2]|0)+296>>2]|0,t[m>>2]|0,t[P>>2]|0)|0;if(!(t[I>>2]|0)){q=32;break e}do if(u[t[I>>2]>>0]|0){t[H>>2]=IA(t[I>>2]|0)|0;if(!(t[H>>2]|0))KS(t[o>>2]|0,99,71016,t[I>>2]|0,0,0);else{if(!(t[t[H>>2]>>2]|0))Mg(t[o>>2]|0,100,71048,t[I>>2]|0,0,0);xA(t[H>>2]|0)}if((t[I>>2]|0)==(t[(t[o>>2]|0)+320>>2]|0)){if((t[w>>2]|0)==(t[(t[o>>2]|0)+312>>2]|0))break;KS(t[o>>2]|0,200,71080,0,0,0);break}if((t[P>>2]|0)!=29){q=47;break}if(!(Xl(t[I>>2]|0,71136)|0)){q=47;break}KS(t[o>>2]|0,200,71168,0,0,0)}else q=47;while(0);do if((q|0)==47){q=0;t[F>>2]=1;while(1){if((t[F>>2]|0)>(t[O>>2]|0))break;if(!(t[(t[(t[o>>2]|0)+336>>2]|0)+((t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]<<1)<<2)>>2]|0))break;t[F>>2]=(t[F>>2]|0)+1}n=t[o>>2]|0;if((t[F>>2]|0)<=(t[O>>2]|0)){ug(n,0,t[w>>2]|0);break}if((Eg(n,0,t[I>>2]|0)|0)<=0)break;t[O>>2]=(t[O>>2]|0)+1}while(0);if(t[B>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break e;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break e;do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){q=64;break e}}while(0);uE(t[o>>2]|0)|0;continue r}if((t[d>>2]|0)!=(t[(t[o>>2]|0)+316>>2]|0)){if(!((t[_>>2]|0)!=0?((t[S>>2]|0)+5|0)<=(t[p>>2]|0):0))q=108;do if((q|0)==108){q=0;if((Rg(t[o>>2]|0,(t[S>>2]|0)+5|0)|0)>=0){t[p>>2]=t[(t[o>>2]|0)+304>>2];t[_>>2]=t[(t[o>>2]|0)+300>>2];break}if(u[(t[m>>2]|0)+(t[P>>2]|0)>>0]|0)break n;pAi[t[135736>>2]&511](t[m>>2]|0);break n}while(0);n=t[B>>2]|0;r=t[E>>2]|0;t[E>>2]=r+1;t[(t[(t[o>>2]|0)+340>>2]|0)+(r<<2)>>2]=n;n=t[w>>2]|0;r=t[S>>2]|0;t[S>>2]=r+1;t[(t[_>>2]|0)+(r<<2)>>2]=n;n=t[d>>2]|0;r=t[S>>2]|0;t[S>>2]=r+1;t[(t[_>>2]|0)+(r<<2)>>2]=n;n=t[S>>2]|0;t[S>>2]=n+1;t[(t[_>>2]|0)+(n<<2)>>2]=0;n=t[m>>2]|0;r=t[S>>2]|0;t[S>>2]=r+1;t[(t[_>>2]|0)+(r<<2)>>2]=n;t[m>>2]=(t[m>>2]|0)+(t[P>>2]|0);n=t[m>>2]|0;r=t[S>>2]|0;t[S>>2]=r+1;t[(t[_>>2]|0)+(r<<2)>>2]=n;if(!(t[B>>2]|0))break;t[A>>2]=1;break}t[x>>2]=kz(t[(t[o>>2]|0)+296>>2]|0,t[m>>2]|0,t[P>>2]|0)|0;n=t[x>>2]|0;r=t[(t[o>>2]|0)+320>>2]|0;f:do if((t[w>>2]|0)==(t[(t[o>>2]|0)+312>>2]|0)){if((n|0)==(r|0))break;KS(t[o>>2]|0,200,71216,0,0,0)}else{i=t[w>>2]|0;e=t[o>>2]|0;if((n|0)==(r|0)){if((i|0)==(t[e+312>>2]|0))break;KS(t[o>>2]|0,200,71264,0,0,0);break}if((i|0)==(t[e+316>>2]|0)){KS(t[o>>2]|0,200,71312,0,0,0);break}do if((t[P>>2]|0)==29){if(!(Xl(t[x>>2]|0,71136)|0))break;KS(t[o>>2]|0,200,71168,0,0,0);break f}while(0);do if(t[x>>2]|0){if(!(u[t[x>>2]>>0]|0))break;t[U>>2]=IA(t[x>>2]|0)|0;e=t[o>>2]|0;if(!(t[U>>2]|0))KS(e,99,71408,t[w>>2]|0,t[x>>2]|0,0);else{do if(t[e+268>>2]|0){if(t[t[U>>2]>>2]|0)break;Mg(t[o>>2]|0,100,71448,t[w>>2]|0,t[x>>2]|0,0)}while(0);xA(t[U>>2]|0)}t[F>>2]=1;while(1){if((t[F>>2]|0)>(t[O>>2]|0))break;if((t[(t[(t[o>>2]|0)+336>>2]|0)+((t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]<<1)<<2)>>2]|0)==(t[w>>2]|0))break;t[F>>2]=(t[F>>2]|0)+1}e=t[o>>2]|0;if((t[F>>2]|0)<=(t[O>>2]|0)){ug(e,t[d>>2]|0,t[w>>2]|0);break f}if((Eg(e,t[w>>2]|0,t[x>>2]|0)|0)<=0)break f;t[O>>2]=(t[O>>2]|0)+1;break f}while(0);KS(t[o>>2]|0,200,71360,t[w>>2]|0,0,0)}while(0);if(t[B>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break e;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break e;do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){q=104;break e}}while(0);uE(t[o>>2]|0)|0;if((t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)!=(t[N>>2]|0))break i;else continue r}else if((t[m>>2]|0)!=0?(u[(t[m>>2]|0)+(t[P>>2]|0)>>0]|0|0)==0:0)pAi[t[135736>>2]&511](t[m>>2]|0);while(0);if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1)break e;if((t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)!=(t[N>>2]|0))break i;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break e;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break e;do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){q=129;break e}}while(0);uE(t[o>>2]|0)|0;if((t[C>>2]|0)==(t[(t[(t[o>>2]|0)+36>>2]|0)+36>>2]|0)?((t[w>>2]|0)==0?(t[D>>2]|0)==(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0):0)&(t[m>>2]|0)==0:0){q=132;break e}do if(!(t[(t[o>>2]|0)+292>>2]|0)){if(((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;CS(t[o>>2]|0)}while(0);if((t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)!=(t[N>>2]|0))break i}if((t[m>>2]|0)!=0&(t[B>>2]|0)!=0)pAi[t[135736>>2]&511](t[m>>2]|0);t[m>>2]=0}while(0);i:do if(t[A>>2]|0){t[y>>2]=3;t[F>>2]=0;while(1){if((t[F>>2]|0)>=(t[E>>2]|0))break i;if((t[(t[(t[o>>2]|0)+340>>2]|0)+(t[F>>2]<<2)>>2]|0)!=0?(t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0);t[y>>2]=(t[y>>2]|0)+5;t[F>>2]=(t[F>>2]|0)+1}}while(0);t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]=(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)+(t[T>>2]|0);t[(t[(t[o>>2]|0)+36>>2]|0)+28>>2]=t[M>>2];t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=t[R>>2];if((t[(t[o>>2]|0)+12>>2]|0)!=1){q=219;break}}if((q|0)==10){BS(V,68,70952);t[a>>2]=0;j=t[a>>2]|0;s=f;return j|0}else if((q|0)==32){Sp(t[o>>2]|0,70984);if((t[m>>2]|0)!=0&(t[B>>2]|0)!=0)pAi[t[135736>>2]&511](t[m>>2]|0);t[a>>2]=0;j=t[a>>2]|0;s=f;return j|0}else if((q|0)==64)BS(t[o>>2]|0,65,69320);else if((q|0)==104)BS(t[o>>2]|0,65,69320);else if((q|0)==129)BS(t[o>>2]|0,65,69320);else if((q|0)==132)AS(t[o>>2]|0,1,69352);else if((q|0)==219){t[a>>2]=0;j=t[a>>2]|0;s=f;return j|0}e:do if((t[(t[o>>2]|0)+348>>2]|0)!=0?(t[z>>2]=fO(t[(t[o>>2]|0)+348>>2]|0,t[k>>2]|0,t[h>>2]|0)|0,(t[z>>2]|0)!=0):0){t[y>>2]=0;i:while(1){if((t[y>>2]|0)>=(t[t[z>>2]>>2]|0))break e;t[w>>2]=t[(t[z>>2]|0)+8+((t[y>>2]|0)*5<<2)>>2];t[d>>2]=t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+1<<2)>>2];do if((t[d>>2]|0)==0?(t[w>>2]|0)==(t[(t[o>>2]|0)+316>>2]|0):0){t[F>>2]=1;while(1){if((t[F>>2]|0)>(t[O>>2]|0))break;if(!(t[(t[(t[o>>2]|0)+336>>2]|0)+((t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]<<1)<<2)>>2]|0))break;t[F>>2]=(t[F>>2]|0)+1}if(((t[F>>2]|0)>(t[O>>2]|0)?(t[v>>2]=pg(t[o>>2]|0,0)|0,(t[v>>2]|0)!=(t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+2<<2)>>2]|0)):0)?(Eg(t[o>>2]|0,0,t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+2<<2)>>2]|0)|0)>0:0)t[O>>2]=(t[O>>2]|0)+1}else{if((t[d>>2]|0)==(t[(t[o>>2]|0)+316>>2]|0)){t[F>>2]=1;while(1){if((t[F>>2]|0)>(t[O>>2]|0))break;if((t[(t[(t[o>>2]|0)+336>>2]|0)+((t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]<<1)<<2)>>2]|0)==(t[w>>2]|0))break;t[F>>2]=(t[F>>2]|0)+1}if((t[F>>2]|0)<=(t[O>>2]|0))break;t[v>>2]=pg(t[o>>2]|0,t[w>>2]|0)|0;if((t[v>>2]|0)==(t[(t[z>>2]|0)+16>>2]|0))break;if((Eg(t[o>>2]|0,t[w>>2]|0,t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+2<<2)>>2]|0)|0)<=0)break;t[O>>2]=(t[O>>2]|0)+1;break}t[F>>2]=0;while(1){if((t[F>>2]|0)>=(t[S>>2]|0))break;if((t[w>>2]|0)==(t[(t[_>>2]|0)+(t[F>>2]<<2)>>2]|0)?(t[d>>2]|0)==(t[(t[_>>2]|0)+((t[F>>2]|0)+1<<2)>>2]|0):0)break;t[F>>2]=(t[F>>2]|0)+5}if((t[F>>2]|0)>=(t[S>>2]|0)){if(!((t[_>>2]|0)!=0?((t[S>>2]|0)+5|0)<=(t[p>>2]|0):0)){if((Rg(t[o>>2]|0,(t[S>>2]|0)+5|0)|0)<0)break i;t[p>>2]=t[(t[o>>2]|0)+304>>2];t[_>>2]=t[(t[o>>2]|0)+300>>2]}m=t[w>>2]|0;B=t[S>>2]|0;t[S>>2]=B+1;t[(t[_>>2]|0)+(B<<2)>>2]=m;m=t[d>>2]|0;B=t[S>>2]|0;t[S>>2]=B+1;t[(t[_>>2]|0)+(B<<2)>>2]=m;if(!(t[d>>2]|0)){m=t[S>>2]|0;t[S>>2]=m+1;t[(t[_>>2]|0)+(m<<2)>>2]=0}else{m=pg(t[o>>2]|0,t[d>>2]|0)|0;B=t[S>>2]|0;t[S>>2]=B+1;t[(t[_>>2]|0)+(B<<2)>>2]=m}m=t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+2<<2)>>2]|0;B=t[S>>2]|0;t[S>>2]=B+1;t[(t[_>>2]|0)+(B<<2)>>2]=m;m=t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+3<<2)>>2]|0;B=t[S>>2]|0;t[S>>2]=B+1;t[(t[_>>2]|0)+(B<<2)>>2]=m;if((t[(t[o>>2]|0)+28>>2]|0)==1?(t[(t[z>>2]|0)+8+(((t[y>>2]|0)*5|0)+4<<2)>>2]|0)!=0:0)RS(t[o>>2]|0,538,71488,t[w>>2]|0,t[k>>2]|0);t[g>>2]=(t[g>>2]|0)+1}}while(0);t[y>>2]=(t[y>>2]|0)+1}t[a>>2]=0;j=t[a>>2]|0;s=f;return j|0}while(0);t[y>>2]=0;while(1){if((t[y>>2]|0)>=(t[S>>2]|0))break;if(t[(t[_>>2]|0)+((t[y>>2]|0)+1<<2)>>2]|0){t[v>>2]=pg(t[o>>2]|0,t[(t[_>>2]|0)+((t[y>>2]|0)+1<<2)>>2]|0)|0;if(!(t[v>>2]|0))KS(t[o>>2]|0,201,71552,t[(t[_>>2]|0)+((t[y>>2]|0)+1<<2)>>2]|0,t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0,t[k>>2]|0);t[(t[_>>2]|0)+((t[y>>2]|0)+2<<2)>>2]=t[v>>2]}else t[v>>2]=0;t[F>>2]=0;while(1){if((t[F>>2]|0)>=(t[y>>2]|0))break;if((t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0)==(t[(t[_>>2]|0)+(t[F>>2]<<2)>>2]|0)){if((t[(t[_>>2]|0)+((t[y>>2]|0)+1<<2)>>2]|0)==(t[(t[_>>2]|0)+((t[F>>2]|0)+1<<2)>>2]|0)){q=189;break}if((t[v>>2]|0)!=0?(t[(t[_>>2]|0)+((t[F>>2]|0)+2<<2)>>2]|0)==(t[v>>2]|0):0){q=192;break}}t[F>>2]=(t[F>>2]|0)+5}if((q|0)==189){q=0;ug(t[o>>2]|0,t[(t[_>>2]|0)+((t[y>>2]|0)+1<<2)>>2]|0,t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0)}else if((q|0)==192){q=0;KS(t[o>>2]|0,203,71608,t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0,t[v>>2]|0,0)}t[y>>2]=(t[y>>2]|0)+5}t[v>>2]=pg(t[o>>2]|0,t[h>>2]|0)|0;if((t[h>>2]|0)!=0&(t[v>>2]|0)==0)KS(t[o>>2]|0,201,71656,t[h>>2]|0,t[k>>2]|0,0);t[t[c>>2]>>2]=t[h>>2];t[t[l>>2]>>2]=t[v>>2];do if(((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+116>>2]|0)!=0:0)?(t[(t[o>>2]|0)+212>>2]|0)==0:0){l=t[(t[t[o>>2]>>2]|0)+116>>2]|0;c=t[(t[o>>2]|0)+4>>2]|0;q=t[k>>2]|0;w=t[h>>2]|0;z=t[v>>2]|0;if((t[O>>2]|0)>0){FAi[l&511](c,q,w,z,t[O>>2]|0,(t[(t[o>>2]|0)+336>>2]|0)+((t[(t[o>>2]|0)+328>>2]|0)-(t[O>>2]<<1)<<2)|0,(t[S>>2]|0)/5|0,t[g>>2]|0,t[_>>2]|0);break}else{FAi[l&511](c,q,w,z,0,0,(t[S>>2]|0)/5|0,t[g>>2]|0,t[_>>2]|0);break}}while(0);e:do if(t[A>>2]|0){t[y>>2]=3;t[F>>2]=0;while(1){if((t[F>>2]|0)>=(t[E>>2]|0))break e;if((t[(t[(t[o>>2]|0)+340>>2]|0)+(t[F>>2]<<2)>>2]|0)!=0?(t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[_>>2]|0)+(t[y>>2]<<2)>>2]|0);t[y>>2]=(t[y>>2]|0)+5;t[F>>2]=(t[F>>2]|0)+1}}while(0);t[a>>2]=t[k>>2];j=t[a>>2]|0;s=f;return j|0}function lg(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+236>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+236|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+236>>2]|0)>0)t[(t[n>>2]|0)+232>>2]=(t[(t[n>>2]|0)+244>>2]|0)+((t[e+236>>2]|0)-1<<2);else t[(t[n>>2]|0)+232>>2]=t[e+244>>2];t[f>>2]=t[(t[(t[n>>2]|0)+244>>2]|0)+(t[(t[n>>2]|0)+236>>2]<<2)>>2];t[(t[(t[n>>2]|0)+244>>2]|0)+(t[(t[n>>2]|0)+236>>2]<<2)>>2]=-1;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function sg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[u>>2]=e;t[a>>2]=i;if(!(t[(t[u>>2]|0)+336>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if((t[(t[u>>2]|0)+328>>2]|0)<(t[a>>2]|0)){i=t[33976]|0;e=t[33980]|0;t[n>>2]=t[a>>2];yAi[i&511](e,70928,n);t[a>>2]=t[(t[u>>2]|0)+328>>2]}if((t[(t[u>>2]|0)+328>>2]|0)<=0){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[a>>2]|0))break;n=(t[u>>2]|0)+328|0;t[n>>2]=(t[n>>2]|0)+-1;t[(t[(t[u>>2]|0)+336>>2]|0)+(t[(t[u>>2]|0)+328>>2]<<2)>>2]=0;t[o>>2]=(t[o>>2]|0)+1}t[f>>2]=t[a>>2];c=t[f>>2]|0;s=r;return c|0}function bg(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+48|0;o=a;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+212>>2]|0)!=0:0)?(t[(t[c>>2]|0)+172>>2]|0)==-1:0){s=a;return}if(t[c>>2]|0)t[(t[c>>2]|0)+84>>2]=t[l>>2];u=t[c>>2]|0;f=t[l>>2]|0;l=t[k>>2]|0;n=t[w>>2]|0;r=t[h>>2]|0;i=t[b>>2]|0;b=t[h>>2]|0;h=t[w>>2]|0;t[o>>2]=t[k>>2];t[o+4>>2]=b;t[o+8>>2]=h;cp(0,0,0,u,0,1,f,3,0,0,l,n,0,r,0,i,o);if(!(t[c>>2]|0)){s=a;return}t[(t[c>>2]|0)+12>>2]=0;if(t[(t[c>>2]|0)+288>>2]|0){s=a;return}t[(t[c>>2]|0)+212>>2]=1;s=a;return}function kg(e,i,r,n,f,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;c=s;s=s+32|0;l=c+24|0;b=c+20|0;k=c+16|0;h=c+12|0;w=c+8|0;d=c+4|0;v=c;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=o;if((t[(t[l>>2]|0)+292>>2]|0)==0?((t[(t[(t[l>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[l>>2]|0);
	if((u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){o=(t[l>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+2;o=(t[(t[l>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+2;o=(t[(t[l>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+2;if((u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[l>>2]|0);if((u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[l>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[l>>2]|0)|0;do if((t[d>>2]|0)>0?(Jl(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0,t[(t[l>>2]|0)+184>>2]|0,t[d>>2]|0)|0)==0:0){o=t[d>>2]|0;if((u[(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)+(t[d>>2]|0)>>0]|0|0)==62){f=(t[(t[l>>2]|0)+36>>2]|0)+16|0;t[f>>2]=(t[f>>2]|0)+(o+1);f=(t[(t[l>>2]|0)+36>>2]|0)+32|0;t[f>>2]=(t[f>>2]|0)+((t[d>>2]|0)+1);break}else{f=(t[(t[l>>2]|0)+36>>2]|0)+16|0;t[f>>2]=(t[f>>2]|0)+o;o=(t[(t[l>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+(t[d>>2]|0);t[v>>2]=1;m=20;break}}else m=17;while(0);do if((m|0)==17){d=t[l>>2]|0;o=t[(t[l>>2]|0)+184>>2]|0;if(!(t[b>>2]|0)){t[v>>2]=Fg(d,o)|0;m=20;break}else{t[v>>2]=Ng(d,o,t[b>>2]|0)|0;m=20;break}}while(0);if((m|0)==20){if((t[(t[l>>2]|0)+292>>2]|0)==0?((t[(t[(t[l>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[l>>2]|0);if((t[(t[l>>2]|0)+172>>2]|0)==-1){s=c;return}uE(t[l>>2]|0)|0;if(9<=(u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)m=28;else if((u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)m=29;else m=28;if((m|0)==28)if((u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){o=(t[(t[l>>2]|0)+36>>2]|0)+32|0;t[o>>2]=(t[o>>2]|0)+1;o=(t[(t[l>>2]|0)+36>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+1;o=(t[l>>2]|0)+200|0;t[o>>2]=(t[o>>2]|0)+1;if(!(u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[l>>2]|0)+36>>2]|0,250)|0}else m=29;if((m|0)==29)AS(t[l>>2]|0,73,0);if((t[v>>2]|0)!=1){if(!(t[v>>2]|0))t[v>>2]=70752;if((t[h>>2]|0)==0?(t[(t[l>>2]|0)+52>>2]|0)!=0:0)t[h>>2]=a[(t[(t[l>>2]|0)+52>>2]|0)+56>>1];bg(t[l>>2]|0,76,70768,t[(t[l>>2]|0)+184>>2]|0,t[h>>2]|0,t[v>>2]|0)}}if(((t[t[l>>2]>>2]|0)!=0?(t[(t[t[l>>2]>>2]|0)+120>>2]|0)!=0:0)?(t[(t[l>>2]|0)+212>>2]|0)==0:0)NAi[t[(t[t[l>>2]>>2]|0)+120>>2]&511](t[(t[l>>2]|0)+4>>2]|0,t[(t[l>>2]|0)+184>>2]|0,t[b>>2]|0,t[k>>2]|0);lg(t[l>>2]|0)|0;if(!(t[w>>2]|0)){s=c;return}sg(t[l>>2]|0,t[w>>2]|0)|0;s=c;return}AS(t[l>>2]|0,74,0);s=c;return}function hg(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){t[(t[r>>2]|0)+172>>2]=3;Op(t[r>>2]|0);while(1){if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93)break;if((t[(t[r>>2]|0)+172>>2]|0)==-1)break;t[n>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2];t[f>>2]=t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2];uE(t[r>>2]|0)|0;IE(t[r>>2]|0);HE(t[r>>2]|0);while(1){if(!(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0))a=(t[(t[r>>2]|0)+40>>2]|0)>1;else a=0;o=t[r>>2]|0;if(!a)break;aE(o)|0}if((t[(t[o+36>>2]|0)+16>>2]|0)!=(t[n>>2]|0))continue;if((t[f>>2]|0)==(t[(t[(t[r>>2]|0)+36>>2]|0)+36>>2]|0)){c=12;break}}if((c|0)==12)AS(t[r>>2]|0,1,70688);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93){Op(t[r>>2]|0);uE(t[r>>2]|0)|0}}if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){l=t[r>>2]|0;Op(l);s=i;return}AS(t[r>>2]|0,61,0);l=t[r>>2]|0;Op(l);s=i;return}function wg(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[(t[r>>2]|0)+352>>2]|0)){s=i;return}oO(t[(t[r>>2]|0)+352>>2]|0,228,t[r>>2]|0);if(bO(t[(t[r>>2]|0)+352>>2]|0)|0){s=i;return}XF(t[(t[r>>2]|0)+352>>2]|0,0);t[(t[r>>2]|0)+352>>2]=0;s=i;return}function dg(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0;r=s;s=s+288|0;f=r;a=r+124|0;o=r+120|0;c=r+116|0;l=r+112|0;b=r+108|0;k=r+104|0;h=r+285|0;w=r+284|0;d=r+100|0;v=r+96|0;m=r+92|0;_=r+88|0;p=r+280|0;E=r+84|0;S=r+80|0;g=r+76|0;y=r+72|0;F=r+68|0;O=r+64|0;A=r+60|0;M=r+56|0;R=r+52|0;N=r+48|0;T=r+44|0;L=r+40|0;D=r+36|0;C=r+32|0;P=r+28|0;B=r+24|0;I=r+278|0;H=r+20|0;x=r+16|0;U=r+128|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=0;if(!(t[(t[o>>2]|0)+36>>2]|0)){t[a>>2]=0;z=t[a>>2]|0;s=r;return z|0}if((t[(t[o>>2]|0)+36>>2]|0)!=0?((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0)>4096:0){qS(t[o>>2]|0);t[(t[o>>2]|0)+204>>2]=0}Lg(t[o>>2]|0,d,v);e:while(1){if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break}if((t[(t[o>>2]|0)+84>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)==1:0){j=10;break}while(1){if(!(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0))V=(t[(t[o>>2]|0)+40>>2]|0)>1;else V=0;q=t[o>>2]|0;if(!V)break;aE(q)|0}if(!(t[q+36>>2]|0)){j=407;break}i=t[o>>2]|0;if(!(t[t[(t[o>>2]|0)+36>>2]>>2]|0))t[b>>2]=(t[(t[i+36>>2]|0)+24>>2]|0)-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0));else{if(((t[i+172>>2]|0)!=0?(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+20>>2]|0)!=0:0)?(Ds(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+20>>2]|0)|0)==0:0){t[m>>2]=js(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[o>>2]|0)+36>>2]|0)|0;t[_>>2]=(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0);ZO(t[t[(t[o>>2]|0)+36>>2]>>2]|0,0,65640)|0;Vs(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[o>>2]|0)+36>>2]|0,t[m>>2]|0,t[_>>2]|0)|0}i=Ts(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;t[b>>2]=i-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0))}if((t[b>>2]|0)<1){j=407;break}do switch(t[(t[o>>2]|0)+172>>2]|0){case 1:{uE(t[o>>2]|0)|0;i=t[(t[o>>2]|0)+36>>2]|0;if(!(t[t[(t[o>>2]|0)+36>>2]>>2]|0))t[b>>2]=(t[i+24>>2]|0)-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0));else{e=Ts(t[(t[i>>2]|0)+16>>2]|0)|0;t[b>>2]=e-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0))}if((t[b>>2]|0)<2){j=407;break e}n[h>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[w>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==63:0){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,63,62,0)|0)<0:0){j=265;break e}FE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=1;t[(t[o>>2]|0)+292>>2]=1;t[(t[o>>2]|0)+204>>2]=0;continue e}if((((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,45,45,62)|0)<0:0){j=274;break e}gE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=1;t[(t[o>>2]|0)+292>>2]=1;t[(t[o>>2]|0)+204>>2]=0;continue e}do if((((((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==68:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==67:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==84:0){if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=89)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=80)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=69)break;if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,62,0,0)|0)<0:0){j=288;break e}t[(t[o>>2]|0)+216>>2]=1;t[(t[o>>2]|0)+292>>2]=0;t[(t[o>>2]|0)+204>>2]=0;qE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}e=t[o>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){t[e+172>>2]=3;continue e}t[e+216>>2]=2;do if(t[t[o>>2]>>2]|0){if(t[(t[o>>2]|0)+212>>2]|0)break;if(!(t[(t[t[o>>2]>>2]|0)+104>>2]|0))break;NAi[t[(t[t[o>>2]>>2]|0)+104>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[o>>2]|0)+220>>2]|0,t[(t[o>>2]|0)+228>>2]|0,t[(t[o>>2]|0)+224>>2]|0)}while(0);t[(t[o>>2]|0)+216>>2]=0;wg(t[o>>2]|0);t[(t[o>>2]|0)+172>>2]=4;continue e}while(0);if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33&(t[b>>2]|0)<9:0){j=407;break e}t[(t[o>>2]|0)+172>>2]=6;t[(t[o>>2]|0)+292>>2]=6;Lg(t[o>>2]|0,d,v);continue e;break}case 9:{if((t[b>>2]|0)<2){j=407;break e}do if(!(t[c>>2]|0)){if(!(t[(t[o>>2]|0)+292>>2]|0))if((Dg(t[o>>2]|0,62,0,0)|0)<0){j=407;break e}else break;if(!(t[v>>2]|0)){j=407;break e}if((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(t[v>>2]|0)>>>0){j=407;break e}}while(0);e=t[o>>2]|0;if(t[(t[o>>2]|0)+324>>2]|0){kg(e,t[(t[(t[o>>2]|0)+344>>2]|0)+(((t[(t[o>>2]|0)+188>>2]|0)*3|0)-3<<2)>>2]|0,t[(t[(t[o>>2]|0)+344>>2]|0)+(((t[(t[o>>2]|0)+188>>2]|0)*3|0)-2<<2)>>2]|0,0,t[(t[(t[o>>2]|0)+344>>2]|0)+(((t[(t[o>>2]|0)+188>>2]|0)*3|0)-1<<2)>>2]|0,0);Pg(t[o>>2]|0)|0}else ag(e,0);if((t[(t[o>>2]|0)+172>>2]|0)==-1)continue e;e=(t[o>>2]|0)+172|0;if(!(t[(t[o>>2]|0)+188>>2]|0)){t[e>>2]=14;continue e}else{t[e>>2]=7;continue e}break}case 8:{t[R>>2]=Dg(t[o>>2]|0,93,93,62)|0;if((t[R>>2]|0)<0){j=207;break e}t[L>>2]=Bg(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0,t[R>>2]|0)|0;if((t[L>>2]|0)<0){j=231;break e}if((t[L>>2]|0)!=(t[R>>2]|0)){j=231;break e}if((((t[R>>2]|0)==0?(t[t[o>>2]>>2]|0)!=0:0)?(t[(t[t[o>>2]>>2]|0)+100>>2]|0)!=0:0)?(t[(t[o>>2]|0)+212>>2]|0)==0:0){if(((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0)>=9?(RY((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+-9|0,70176,9)|0)==0:0)yAi[t[(t[t[o>>2]>>2]|0)+100>>2]&511](t[(t[o>>2]|0)+4>>2]|0,65640,0)}else j=238;do if(((j|0)==238?(j=0,(t[R>>2]|0)>0?(t[t[o>>2]>>2]|0)!=0:0):0)?(t[(t[o>>2]|0)+212>>2]|0)==0:0){e=t[t[o>>2]>>2]|0;if(t[(t[t[o>>2]>>2]|0)+100>>2]|0){yAi[t[e+100>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0,t[R>>2]|0);break}if(t[e+68>>2]|0)yAi[t[(t[t[o>>2]>>2]|0)+68>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0,t[R>>2]|0)}while(0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[D>>2]=0;while(1){Y=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((t[D>>2]|0)>=((t[R>>2]|0)+3|0))break;e=t[(t[o>>2]|0)+36>>2]|0;if((Y|0)==10){i=e+28|0;t[i>>2]=(t[i>>2]|0)+1;t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=1}else{i=e+32|0;t[i>>2]=(t[i>>2]|0)+1}i=(t[o>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+1;t[D>>2]=(t[D>>2]|0)+1}if((Y|0)==37)oE(t[o>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[o>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[o>>2]|0)|0;t[(t[o>>2]|0)+204>>2]=0;t[(t[o>>2]|0)+172>>2]=7;continue e;break}case 0:{i=t[b>>2]|0;if(!(t[(t[o>>2]|0)+256>>2]|0)){if((i|0)<4){j=407;break e}n[p>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[p+1>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;n[p+2>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;n[p+3>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[E>>2]=L_(p,4)|0;Tp(t[o>>2]|0,t[E>>2]|0)|0;continue e}if((i|0)<2){j=407;break e}n[h>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[w>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if(!(u[h>>0]|0)){j=30;break e}if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==63:0){if((t[b>>2]|0)<5){j=39;break e}if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,63,62,0)|0)<0:0){j=42;break e}if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+44>>2]|0)!=0:0)EAi[t[(t[t[o>>2]>>2]|0)+44>>2]&511](t[(t[o>>2]|0)+4>>2]|0,136080);i:do if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120){if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=109)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=108)break;do if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break i}while(0);t[l>>2]=(t[l>>2]|0)+5;$E(t[o>>2]|0);G=t[o>>2]|0;if((t[(t[o>>2]|0)+84>>2]|0)==32){j=54;break e}t[(t[o>>2]|0)+28>>2]=t[(t[G+36>>2]|0)+52>>2];do if(!(t[(t[o>>2]|0)+24>>2]|0)){if(!(t[(t[(t[o>>2]|0)+36>>2]|0)+44>>2]|0))break;i=Yl(t[(t[(t[o>>2]|0)+36>>2]|0)+44>>2]|0)|0;t[(t[o>>2]|0)+24>>2]=i}while(0);do if(t[t[o>>2]>>2]|0){if(!(t[(t[t[o>>2]>>2]|0)+48>>2]|0))break;if(t[(t[o>>2]|0)+212>>2]|0)break;pAi[t[(t[t[o>>2]>>2]|0)+48>>2]&511](t[(t[o>>2]|0)+4>>2]|0)}while(0);t[(t[o>>2]|0)+172>>2]=1;continue e}while(0);i=Wl(68488)|0;t[(t[o>>2]|0)+20>>2]=i;do if(t[t[o>>2]>>2]|0){if(!(t[(t[t[o>>2]>>2]|0)+48>>2]|0))break;if(t[(t[o>>2]|0)+212>>2]|0)break;pAi[t[(t[t[o>>2]>>2]|0)+48>>2]&511](t[(t[o>>2]|0)+4>>2]|0)}while(0);t[(t[o>>2]|0)+172>>2]=1;continue e}if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+44>>2]|0)!=0:0)EAi[t[(t[t[o>>2]>>2]|0)+44>>2]&511](t[(t[o>>2]|0)+4>>2]|0,136080);i=Wl(68488)|0;t[(t[o>>2]|0)+20>>2]=i;i=t[o>>2]|0;if(!(t[(t[o>>2]|0)+20>>2]|0)){Sp(i,0);continue e}if(((t[i>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+48>>2]|0)!=0:0)?(t[(t[o>>2]|0)+212>>2]|0)==0:0)pAi[t[(t[t[o>>2]>>2]|0)+48>>2]&511](t[(t[o>>2]|0)+4>>2]|0);t[(t[o>>2]|0)+172>>2]=1;continue e;break}case 7:{if((t[b>>2]|0)<2?(t[(t[o>>2]|0)+40>>2]|0)==1:0){j=407;break e}n[h>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[w>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;t[O>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2];t[A>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+36>>2];if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==47:0){t[(t[o>>2]|0)+172>>2]=9;continue e}if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==63:0){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,63,62,0)|0)<0:0){j=147;break e}FE(t[o>>2]|0);t[(t[o>>2]|0)+172>>2]=7;t[(t[o>>2]|0)+292>>2]=1}else j=149;do if((j|0)==149){j=0;if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)!=33:0){t[(t[o>>2]|0)+172>>2]=6;continue e}if((((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){if((t[b>>2]|0)<4){j=407;break e}i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+4;t[M>>2]=Dg(t[o>>2]|0,45,45,62)|0;i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+-4;W=t[o>>2]|0;if((t[c>>2]|0)==0&(t[M>>2]|0)<0){j=158;break e}gE(W);t[(t[o>>2]|0)+172>>2]=7;t[(t[o>>2]|0)+292>>2]=1;break}do if((((u[h>>0]|0|0)==60?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==91:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==67:0){if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=68)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=65)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=65)break;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=91)break;i=(t[o>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+9;i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+9;i=(t[(t[o>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+9;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[o>>2]|0);do if(!(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((yp(t[(t[o>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[o>>2]|0)|0}while(0);t[(t[o>>2]|0)+172>>2]=8;continue e}while(0);if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33&(t[b>>2]|0)<9:0){j=407;break e}if((u[h>>0]|0|0)==38){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,59,0,0)|0)<0:0){j=407;break e}jE(t[o>>2]|0);break}do if(!(((t[b>>2]|0)<300?(t[(t[o>>2]|0)+40>>2]|0)==1:0)^1|(t[c>>2]|0)!=0)){if(!(t[(t[o>>2]|0)+292>>2]|0))if((Dg(t[o>>2]|0,60,0,0)|0)<0){j=407;break e}else break;if(!(t[d>>2]|0)){j=407;break e}if((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>(t[d>>2]|0)>>>0){j=407;break e}}while(0);t[(t[o>>2]|0)+204>>2]=0;EE(t[o>>2]|0,0)}while(0);while(1){if(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((t[(t[o>>2]|0)+40>>2]|0)<=1)break;aE(t[o>>2]|0)|0}if((t[A>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+36>>2]|0))continue e;if((t[O>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0))continue e;AS(t[o>>2]|0,1,69472);t[(t[o>>2]|0)+172>>2]=-1;continue e;break}case 6:{t[g>>2]=0;t[y>>2]=0;t[F>>2]=t[(t[o>>2]|0)+328>>2];if((t[b>>2]|0)<2?(t[(t[o>>2]|0)+40>>2]|0)==1:0){j=407;break e}n[h>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((u[h>>0]|0|0)!=60){j=81;break e}do if(!(t[c>>2]|0)){if(!(t[(t[o>>2]|0)+292>>2]|0))if((Dg(t[o>>2]|0,62,0,0)|0)<0){j=407;break e}else break;if(!(t[v>>2]|0)){j=407;break e}if((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(t[v>>2]|0)>>>0){j=407;break e}}while(0);i=t[o>>2]|0;do if(t[(t[o>>2]|0)+236>>2]|0){e=t[o>>2]|0;if((t[t[i+232>>2]>>2]|0)==-2){og(e,-1)|0;break}else{og(e,t[t[(t[o>>2]|0)+232>>2]>>2]|0)|0;break}}else og(i,-1)|0;while(0);i=t[o>>2]|0;if(t[(t[o>>2]|0)+324>>2]|0)t[S>>2]=cg(i,g,y,k)|0;else t[S>>2]=GE(i)|0;if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}K=t[o>>2]|0;if(!(t[S>>2]|0)){j=99;break e}do if(((t[K+104>>2]|0)!=0?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)?(t[(t[o>>2]|0)+8>>2]|0)!=0:0){if(!(t[(t[o>>2]|0)+52>>2]|0))break;if((t[(t[o>>2]|0)+52>>2]|0)!=(t[(t[(t[o>>2]|0)+8>>2]|0)+12>>2]|0))break;i=kR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0)|0;e=(t[o>>2]|0)+100|0;t[e>>2]=t[e>>2]&i}while(0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){i=(t[o>>2]|0)+200|0;t[i>>2]=(t[i>>2]|0)+2;i=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+2;i=(t[(t[o>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+2;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[o>>2]|0);do if(!(u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((yp(t[(t[o>>2]|0)+36>>2]|0,250)|0)>0)break;aE(t[o>>2]|0)|0}while(0);i=(t[t[o>>2]>>2]|0)!=0;do if(t[(t[o>>2]|0)+324>>2]|0){do if(i){if(!(t[(t[t[o>>2]>>2]|0)+120>>2]|0))break;if(t[(t[o>>2]|0)+212>>2]|0)break;NAi[t[(t[t[o>>2]>>2]|0)+120>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[S>>2]|0,t[g>>2]|0,t[y>>2]|0)}while(0);if(((t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]|0)|0)<=0)break;sg(t[o>>2]|0,(t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]|0)|0)|0}else{if(!i)break;if(!(t[(t[t[o>>2]>>2]|0)+60>>2]|0))break;if(t[(t[o>>2]|0)+212>>2]|0)break;EAi[t[(t[t[o>>2]>>2]|0)+60>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[S>>2]|0)}while(0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}lg(t[o>>2]|0)|0;i=(t[o>>2]|0)+172|0;if(!(t[(t[o>>2]|0)+188>>2]|0))t[i>>2]=14;else t[i>>2]=7;t[(t[o>>2]|0)+292>>2]=1;continue e}i=t[o>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)Op(i);else{MS(i,73,70136,t[S>>2]|0);nE(t[o>>2]|0)|0;lg(t[o>>2]|0)|0}i=t[o>>2]|0;e=t[S>>2]|0;if(t[(t[o>>2]|0)+324>>2]|0)Cg(i,e,t[g>>2]|0,t[y>>2]|0,(t[(t[o>>2]|0)+328>>2]|0)-(t[F>>2]|0)|0)|0;else fE(i,e)|0;t[(t[o>>2]|0)+172>>2]=7;t[(t[o>>2]|0)+292>>2]=1;continue e;break}case 4:{uE(t[o>>2]|0)|0;e=t[(t[o>>2]|0)+36>>2]|0;if(!(t[t[(t[o>>2]|0)+36>>2]>>2]|0))t[b>>2]=(t[e+24>>2]|0)-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0));else{i=Ts(t[(t[e>>2]|0)+16>>2]|0)|0;t[b>>2]=i-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0))}if((t[b>>2]|0)<2){j=407;break e}n[h>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[w>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==63:0){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,63,62,0)|0)<0:0){j=308;break e}FE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=4;t[(t[o>>2]|0)+292>>2]=1;continue e}if((((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,45,45,62)|0)<0:0){j=317;break e}gE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=4;t[(t[o>>2]|0)+292>>2]=1;continue e}if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33&(t[b>>2]|0)<4:0){j=407;break e}t[(t[o>>2]|0)+172>>2]=6;if(!(t[(t[o>>2]|0)+292>>2]|0))t[(t[o>>2]|0)+292>>2]=6;Lg(t[o>>2]|0,d,v);continue e;break}case 14:{uE(t[o>>2]|0)|0;i=t[(t[o>>2]|0)+36>>2]|0;if(!(t[t[(t[o>>2]|0)+36>>2]>>2]|0))t[b>>2]=(t[i+24>>2]|0)-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0));else{e=Ts(t[(t[i>>2]|0)+16>>2]|0)|0;t[b>>2]=e-((t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0))}if((t[b>>2]|0)<2){j=407;break e}n[h>>0]=n[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[w>>0]=n[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==63:0){if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,63,62,0)|0)<0:0){j=333;break e}FE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=14;t[(t[o>>2]|0)+292>>2]=1;continue e}if((u[h>>0]|0|0)!=60){j=345;break e}if((u[w>>0]|0|0)!=33){j=345;break e}if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=45){j=345;break e}if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=45){j=345;break e}if((t[c>>2]|0)==0?(Dg(t[o>>2]|0,45,45,62)|0)<0:0){j=342;break e}gE(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=14;t[(t[o>>2]|0)+292>>2]=1;continue e;break}case 3:{n[I>>0]=0;t[C>>2]=(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0);if((t[C>>2]|0)<0){j=351;break e}if((t[(t[o>>2]|0)+204>>2]|0)>(t[C>>2]|0))t[C>>2]=t[(t[o>>2]|0)+204>>2];t[B>>2]=Os(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;t[H>>2]=Ts(t[(t[t[(t[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;i:while(1){if((t[C>>2]|0)>>>0>=(t[H>>2]|0)>>>0){j=389;break e}r:do if(u[I>>0]|0){if((u[(t[B>>2]|0)+(t[C>>2]|0)>>0]|0|0)==(u[I>>0]|0|0))n[I>>0]=0}else{do if((((u[I>>0]|0|0)==0?(u[(t[B>>2]|0)+(t[C>>2]|0)>>0]|0|0)==60:0)?(t[x>>2]=0,((t[C>>2]|0)+4|0)>>>0<(t[H>>2]|0)>>>0):0)?(u[(t[B>>2]|0)+((t[C>>2]|0)+1)>>0]|0|0)==33:0){if((u[(t[B>>2]|0)+((t[C>>2]|0)+2)>>0]|0|0)!=45)break;if((u[(t[B>>2]|0)+((t[C>>2]|0)+3)>>0]|0|0)!=45)break;n:while(1){if(((t[C>>2]|0)+3|0)>>>0>=(t[H>>2]|0)>>>0)break;do if((u[(t[B>>2]|0)+(t[C>>2]|0)>>0]|0|0)==45){if((u[(t[B>>2]|0)+((t[C>>2]|0)+1)>>0]|0|0)!=45)break;if((u[(t[B>>2]|0)+((t[C>>2]|0)+2)>>0]|0|0)==62){j=369;break n}}while(0);t[C>>2]=(t[C>>2]|0)+1}if((j|0)==369){j=0;t[x>>2]=1;t[C>>2]=(t[C>>2]|0)+2}if(t[x>>2]|0)break r;else{j=389;break e}}while(0);if((u[(t[B>>2]|0)+(t[C>>2]|0)>>0]|0|0)==34){n[I>>0]=34;break}if((u[(t[B>>2]|0)+(t[C>>2]|0)>>0]|0|0)==39){n[I>>0]=39;break}if((u[(t[B>>2]|0)+(t[C>>2]|0)>>0]|0|0)==93){if(((t[C>>2]|0)+1|0)>>>0>=(t[H>>2]|0)>>>0){j=389;break e}if((u[(t[B>>2]|0)+((t[C>>2]|0)+1)>>0]|0|0)==93){t[C>>2]=(t[C>>2]|0)+1;break}t[P>>2]=1;while(1){if(((t[C>>2]|0)+(t[P>>2]|0)|0)>>>0>=(t[H>>2]|0)>>>0){j=389;break e}if((u[(t[B>>2]|0)+((t[C>>2]|0)+(t[P>>2]|0))>>0]|0|0)==62)break i;do if((u[(t[B>>2]|0)+((t[C>>2]|0)+(t[P>>2]|0))>>0]|0|0)!=32){if(9<=(u[(t[B>>2]|0)+((t[C>>2]|0)+(t[P>>2]|0))>>0]|0|0)?(u[(t[B>>2]|0)+((t[C>>2]|0)+(t[P>>2]|0))>>0]|0|0)<=10:0)break;if((u[(t[B>>2]|0)+((t[C>>2]|0)+(t[P>>2]|0))>>0]|0|0)!=13)break r}while(0);t[P>>2]=(t[P>>2]|0)+1}}}while(0);t[C>>2]=(t[C>>2]|0)+1}t[(t[o>>2]|0)+204>>2]=0;hg(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+216>>2]=2;if(((t[t[o>>2]>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)==0:0)?(t[(t[t[o>>2]>>2]|0)+104>>2]|0)!=0:0)NAi[t[(t[t[o>>2]>>2]|0)+104>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[o>>2]|0)+220>>2]|0,t[(t[o>>2]|0)+228>>2]|0,t[(t[o>>2]|0)+224>>2]|0);t[(t[o>>2]|0)+216>>2]=0;wg(t[o>>2]|0);if((t[(t[o>>2]|0)+172>>2]|0)==-1){j=407;break e}t[(t[o>>2]|0)+172>>2]=4;t[(t[o>>2]|0)+204>>2]=0;continue e;break}case 5:{yAi[t[135904>>2]&511](t[33980]|0,70192,f);t[(t[o>>2]|0)+172>>2]=7;continue e;break}case 15:{yAi[t[135904>>2]&511](t[33980]|0,70232,f);t[(t[o>>2]|0)+172>>2]=3;continue e;break}case 2:{yAi[t[135904>>2]&511](t[33980]|0,70272,f);t[(t[o>>2]|0)+172>>2]=7;continue e;break}case 10:{yAi[t[135904>>2]&511](t[33980]|0,70312,f);t[(t[o>>2]|0)+172>>2]=3;continue e;break}case 11:{yAi[t[135904>>2]&511](t[33980]|0,70360,f);t[(t[o>>2]|0)+172>>2]=7;continue e;break}case 12:{yAi[t[135904>>2]&511](t[33980]|0,70408,f);t[(t[o>>2]|0)+172>>2]=6;continue e;break}case 13:{yAi[t[135904>>2]&511](t[33980]|0,70456,f);t[(t[o>>2]|0)+172>>2]=6;continue e;break}case 16:{yAi[t[135904>>2]&511](t[33980]|0,70504,f);t[(t[o>>2]|0)+172>>2]=6;continue e;break}case-1:{j=407;break e;break}default:continue e}while(0)}switch(j|0){case 10:{t[a>>2]=0;z=t[a>>2]|0;s=r;return z|0}case 30:{if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+44>>2]|0)!=0:0)EAi[t[(t[t[o>>2]>>2]|0)+44>>2]&511](t[(t[o>>2]|0)+4>>2]|0,136080);AS(t[o>>2]|0,4,0);t[(t[o>>2]|0)+172>>2]=-1;if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+52>>2]|0)!=0:0){pAi[t[(t[t[o>>2]>>2]|0)+52>>2]&511](t[(t[o>>2]|0)+4>>2]|0);j=407}else j=407;break}case 39:{t[a>>2]=t[l>>2];z=t[a>>2]|0;s=r;return z|0}case 42:{t[a>>2]=t[l>>2];z=t[a>>2]|0;s=r;return z|0}case 54:{t[G+172>>2]=-1;t[a>>2]=0;z=t[a>>2]|0;s=r;return z|0}case 81:{AS(t[o>>2]|0,4,0);t[(t[o>>2]|0)+172>>2]=-1;if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+52>>2]|0)!=0:0){pAi[t[(t[t[o>>2]>>2]|0)+52>>2]&511](t[(t[o>>2]|0)+4>>2]|0);j=407}else j=407;break}case 99:{lg(K)|0;t[(t[o>>2]|0)+172>>2]=-1;if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+52>>2]|0)!=0:0){pAi[t[(t[t[o>>2]>>2]|0)+52>>2]&511](t[(t[o>>2]|0)+4>>2]|0);j=407}else j=407;break}case 147:{t[(t[o>>2]|0)+292>>2]=2;j=407;break}case 158:{t[W+292>>2]=5;j=407;break}case 207:{if((t[b>>2]|0)>=302){t[N>>2]=Bg(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0,300)|0;if((t[N>>2]|0)<0){t[N>>2]=0-(t[N>>2]|0);W=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[W>>2]=(t[W>>2]|0)+(t[N>>2]|0);j=408;break}do if((t[t[o>>2]>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)==0:0){W=t[t[o>>2]>>2]|0;if(t[(t[t[o>>2]>>2]|0)+100>>2]|0){yAi[t[W+100>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0,t[N>>2]|0);break}if(t[W+68>>2]|0)yAi[t[(t[t[o>>2]>>2]|0)+68>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0,t[N>>2]|0)}while(0);if((t[(t[o>>2]|0)+172>>2]|0)!=-1){t[T>>2]=0;while(1){X=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((t[T>>2]|0)>=(t[N>>2]|0))break;W=t[(t[o>>2]|0)+36>>2]|0;if((X|0)==10){K=W+28|0;t[K>>2]=(t[K>>2]|0)+1;t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=1}else{K=W+32|0;t[K>>2]=(t[K>>2]|0)+1}K=(t[o>>2]|0)+200|0;t[K>>2]=(t[K>>2]|0)+1;K=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[K>>2]=(t[K>>2]|0)+1;t[T>>2]=(t[T>>2]|0)+1}if((X|0)==37)oE(t[o>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[o>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[o>>2]|0)|0;t[(t[o>>2]|0)+204>>2]=0;j=407}else j=407}else j=407;break}case 231:{t[L>>2]=0-(t[L>>2]|0);X=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[X>>2]=(t[X>>2]|0)+(t[L>>2]|0);j=408;break}case 265:{t[(t[o>>2]|0)+292>>2]=2;j=407;break}case 274:{t[(t[o>>2]|0)+292>>2]=5;j=407;break}case 288:{t[(t[o>>2]|0)+292>>2]=3;j=407;break}case 308:{t[(t[o>>2]|0)+292>>2]=2;j=407;break}case 317:{t[(t[o>>2]|0)+292>>2]=5;j=407;break}case 333:{t[(t[o>>2]|0)+292>>2]=2;j=407;break}case 342:{t[(t[o>>2]|0)+292>>2]=5;j=407;break}case 345:{if((u[h>>0]|0|0)==60?(u[w>>0]|0|0)==33&(t[b>>2]|0)<4:0){j=407;break}AS(t[o>>2]|0,5,0);t[(t[o>>2]|0)+172>>2]=-1;if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+52>>2]|0)!=0:0){pAi[t[(t[t[o>>2]>>2]|0)+52>>2]&511](t[(t[o>>2]|0)+4>>2]|0);j=407}else j=407;break}case 351:{t[a>>2]=0;z=t[a>>2]|0;s=r;return z|0}case 389:{if(!(u[I>>0]|0)){t[(t[o>>2]|0)+204>>2]=t[C>>2];j=407;break}else{t[(t[o>>2]|0)+204>>2]=0;j=407;break}break}}if((j|0)==407){t[a>>2]=t[l>>2];z=t[a>>2]|0;s=r;return z|0}else if((j|0)==408){j=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;l=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;C=u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[f>>2]=u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0];t[f+4>>2]=j;t[f+8>>2]=l;t[f+12>>2]=C;SY(U,149,70552,f)|0;gp(t[o>>2]|0,9,70592,U,0);t[a>>2]=0;z=t[a>>2]|0;s=r;return z|0}return 0}function vg(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)<0)){if((t[(t[u>>2]|0)+172>>2]|0)==6)if(OY(t[a>>2]|0,62,t[o>>2]|0)|0){t[f>>2]=1;break}else{t[f>>2]=0;break}if((t[(t[u>>2]|0)+292>>2]|0)==5)if(OY(t[a>>2]|0,62,t[o>>2]|0)|0){t[f>>2]=1;break}else{t[f>>2]=0;break}if((t[(t[u>>2]|0)+172>>2]|0)==8)if(OY(t[a>>2]|0,62,t[o>>2]|0)|0){t[f>>2]=1;break}else{t[f>>2]=0;break}if((t[(t[u>>2]|0)+292>>2]|0)==2)if(OY(t[a>>2]|0,62,t[o>>2]|0)|0){t[f>>2]=1;break}else{t[f>>2]=0;break}if((t[(t[u>>2]|0)+172>>2]|0)==9)if(OY(t[a>>2]|0,62,t[o>>2]|0)|0){t[f>>2]=1;break}else{t[f>>2]=0;break}if((t[(t[u>>2]|0)+292>>2]|0)!=3?(t[(t[u>>2]|0)+172>>2]|0)!=3:0){t[f>>2]=1;break}if(OY(t[a>>2]|0,62,t[o>>2]|0)|0){t[f>>2]=1;break}else{t[f>>2]=0;break}}else t[f>>2]=-1;while(0);s=n;return t[f>>2]|0}function mg(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;u=f+32|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[h>>2]=0;t[b>>2]=zp()|0;if(!(t[b>>2]|0)){t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}if(t[l>>2]|0){t[(t[b>>2]|0)+360>>2]=t[(t[l>>2]|0)+360>>2];t[(t[b>>2]|0)+272>>2]=t[(t[l>>2]|0)+272>>2]}t[w>>2]=GA(t[a>>2]|0,t[c>>2]|0)|0;if(!(t[w>>2]|0)){t[k>>2]=uA(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0)|0;c=t[b>>2]|0;if(!(t[k>>2]|0)){Up(c);t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}eE(c,t[k>>2]|0)|0;if((t[h>>2]|0)==0?(t[(t[b>>2]|0)+180>>2]|0)==0:0)t[h>>2]=rA(t[a>>2]|0)|0;if((t[h>>2]|0)!=0?(t[(t[b>>2]|0)+180>>2]|0)==0:0)t[(t[b>>2]|0)+180>>2]=t[h>>2]}else{t[k>>2]=uA(t[w>>2]|0,t[o>>2]|0,t[b>>2]|0)|0;if(!(t[k>>2]|0)){pAi[t[135736>>2]&511](t[w>>2]|0);Up(t[b>>2]|0);t[u>>2]=0;d=t[u>>2]|0;s=f;return d|0}eE(t[b>>2]|0,t[k>>2]|0)|0;if((t[h>>2]|0)==0?(t[(t[b>>2]|0)+180>>2]|0)==0:0)t[h>>2]=rA(t[w>>2]|0)|0;if((t[h>>2]|0)!=0?(t[(t[b>>2]|0)+180>>2]|0)==0:0)t[(t[b>>2]|0)+180>>2]=t[h>>2];pAi[t[135736>>2]&511](t[w>>2]|0)}t[u>>2]=t[b>>2];d=t[u>>2]|0;s=f;return d|0}function _g(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}if(t[o>>2]|0){if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);r=Yl(t[o>>2]|0)|0;t[(t[u>>2]|0)+24>>2]=r}r=(t[u>>2]|0)+288|0;if(t[a>>2]&1){t[r>>2]=1;t[a>>2]=(t[a>>2]|0)-1;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|1}else t[r>>2]=0;r=(t[u>>2]|0)+276|0;if(t[a>>2]&4){t[r>>2]=2;t[a>>2]=(t[a>>2]|0)-4;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|4}else t[r>>2]=0;if(t[a>>2]&8){r=(t[u>>2]|0)+276|0;t[r>>2]=t[r>>2]|4;t[a>>2]=(t[a>>2]|0)-8;r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|8}r=(t[u>>2]|0)+16|0;if(t[a>>2]&2){t[r>>2]=1;t[a>>2]=(t[a>>2]|0)-2;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|2}else t[r>>2]=0;r=(t[u>>2]|0)+268|0;if(t[a>>2]&128){t[r>>2]=1;t[a>>2]=(t[a>>2]|0)-128;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|128}else t[r>>2]=0;r=(t[u>>2]|0)+208|0;if(t[a>>2]&256){t[r>>2]=0;t[(t[t[u>>2]>>2]|0)+72>>2]=65;t[a>>2]=(t[a>>2]|0)-256;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|256}else t[r>>2]=1;r=(t[u>>2]|0)+104|0;if(t[a>>2]&16){t[r>>2]=1;if(t[a>>2]&64)t[(t[u>>2]|0)+116>>2]=0;if(t[a>>2]&32)t[(t[u>>2]|0)+112>>2]=0;t[a>>2]=(t[a>>2]|0)-16;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|16}else t[r>>2]=0;if(t[a>>2]&64){t[(t[t[u>>2]>>2]|0)+84>>2]=0;t[a>>2]=(t[a>>2]|0)-64}if(t[a>>2]&32){t[(t[t[u>>2]>>2]|0)+88>>2]=0;t[(t[t[u>>2]>>2]|0)+92>>2]=0;t[a>>2]=(t[a>>2]|0)-32}if(t[a>>2]&512){t[(t[t[u>>2]>>2]|0)+56>>2]=50;t[(t[t[u>>2]>>2]|0)+60>>2]=51;t[(t[t[u>>2]>>2]|0)+116>>2]=0;t[(t[t[u>>2]>>2]|0)+120>>2]=0;t[(t[t[u>>2]>>2]|0)+108>>2]=1;t[a>>2]=(t[a>>2]|0)-512;r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|512}r=(t[u>>2]|0)+364|0;if(t[a>>2]&4096){t[r>>2]=0;t[a>>2]=(t[a>>2]|0)-4096;o=(t[u>>2]|0)+360|0;t[o>>2]=t[o>>2]|4096}else t[r>>2]=1;if(t[a>>2]&16384){t[(t[t[u>>2]>>2]|0)+100>>2]=0;t[a>>2]=(t[a>>2]|0)-16384;r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|16384}if(t[a>>2]&8192){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|8192;t[a>>2]=(t[a>>2]|0)-8192}if(t[a>>2]&2048){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|2048;t[a>>2]=(t[a>>2]|0)-2048}if(t[a>>2]&65536){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|65536;t[a>>2]=(t[a>>2]|0)-65536}if(t[a>>2]&131072){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|131072;t[a>>2]=(t[a>>2]|0)-131072}if(t[a>>2]&262144){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|262144;t[a>>2]=(t[a>>2]|0)-262144}do if(t[a>>2]&524288){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|524288;t[a>>2]=(t[a>>2]|0)-524288;if(!(t[(t[u>>2]|0)+296>>2]|0))break;dz(t[(t[u>>2]|0)+296>>2]|0,0)|0}while(0);if(t[a>>2]&1048576){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|1048576;t[a>>2]=(t[a>>2]|0)-1048576}if(t[a>>2]&2097152){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|2097152;t[a>>2]=(t[a>>2]|0)-2097152}if(t[a>>2]&4194304){r=(t[u>>2]|0)+360|0;t[r>>2]=t[r>>2]|4194304;t[a>>2]=(t[a>>2]|0)-4194304}t[(t[u>>2]|0)+280>>2]=1;t[f>>2]=t[a>>2];c=t[f>>2]|0;s=n;return c|0}function pg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;i=t[f>>2]|0;if((t[a>>2]|0)==(t[(t[f>>2]|0)+312>>2]|0)){t[n>>2]=t[i+320>>2];c=t[n>>2]|0;s=r;return c|0}t[o>>2]=(t[i+328>>2]|0)-2;while(1){if((t[o>>2]|0)<0){l=11;break}if((t[(t[(t[f>>2]|0)+336>>2]|0)+(t[o>>2]<<2)>>2]|0)==(t[a>>2]|0))break;t[o>>2]=(t[o>>2]|0)-2}if((l|0)==11){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if((t[a>>2]|0)==0?(u[t[(t[(t[f>>2]|0)+336>>2]|0)+((t[o>>2]|0)+1<<2)>>2]>>0]|0|0)==0:0){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[n>>2]=t[(t[(t[f>>2]|0)+336>>2]|0)+((t[o>>2]|0)+1<<2)>>2];
	c=t[n>>2]|0;s=r;return c|0}function Eg(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;e:do if(t[(t[u>>2]|0)+360>>2]&8192){t[c>>2]=(t[(t[u>>2]|0)+328>>2]|0)-2;while(1){if((t[c>>2]|0)<0)break e;b=t[c>>2]|0;if((t[(t[(t[u>>2]|0)+336>>2]|0)+(t[c>>2]<<2)>>2]|0)==(t[a>>2]|0))break;t[c>>2]=b-2}if((t[(t[(t[u>>2]|0)+336>>2]|0)+(b+1<<2)>>2]|0)==(t[o>>2]|0)){t[f>>2]=-2;k=t[f>>2]|0;s=n;return k|0}}while(0);do if((t[(t[u>>2]|0)+332>>2]|0)!=0?(t[(t[u>>2]|0)+336>>2]|0)!=0:0){if((t[(t[u>>2]|0)+328>>2]|0)>=(t[(t[u>>2]|0)+332>>2]|0)){b=(t[u>>2]|0)+332|0;t[b>>2]=t[b>>2]<<1;t[l>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+336>>2]|0,t[(t[u>>2]|0)+332>>2]<<2)|0;if(t[l>>2]|0){t[(t[u>>2]|0)+336>>2]=t[l>>2];break}Sp(t[u>>2]|0,0);b=(t[u>>2]|0)+332|0;t[b>>2]=(t[b>>2]|0)/2|0;t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}}else h=10;while(0);if((h|0)==10?(t[(t[u>>2]|0)+332>>2]=10,t[(t[u>>2]|0)+328>>2]=0,h=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+332>>2]<<2)|0,t[(t[u>>2]|0)+336>>2]=h,(t[(t[u>>2]|0)+336>>2]|0)==0):0){Sp(t[u>>2]|0,0);t[(t[u>>2]|0)+332>>2]=0;t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}h=t[a>>2]|0;a=(t[u>>2]|0)+328|0;l=t[a>>2]|0;t[a>>2]=l+1;t[(t[(t[u>>2]|0)+336>>2]|0)+(l<<2)>>2]=h;h=t[o>>2]|0;o=(t[u>>2]|0)+328|0;l=t[o>>2]|0;t[o>>2]=l+1;t[(t[(t[u>>2]|0)+336>>2]|0)+(l<<2)>>2]=h;t[f>>2]=t[(t[u>>2]|0)+328>>2];k=t[f>>2]|0;s=n;return k|0}function Sg(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;_g(t[a>>2]|0,t[l>>2]|0,t[c>>2]|0)|0;if((t[c>>2]|0)!=0?(t[h>>2]=V_(t[c>>2]|0)|0,(t[h>>2]|0)!=0):0)Lp(t[a>>2]|0,t[h>>2]|0)|0;if(((t[o>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)==0:0){h=Yl(t[o>>2]|0)|0;t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=h}iS(t[a>>2]|0)|0;if((t[(t[a>>2]|0)+12>>2]|0)==0?(t[(t[a>>2]|0)+288>>2]|0)==0:0){t[k>>2]=0;if(t[(t[a>>2]|0)+8>>2]|0)fy(t[(t[a>>2]|0)+8>>2]|0)}else t[k>>2]=t[(t[a>>2]|0)+8>>2];t[(t[a>>2]|0)+8>>2]=0;if(t[b>>2]|0){w=t[k>>2]|0;s=u;return w|0}Up(t[a>>2]|0);w=t[k>>2]|0;s=u;return w|0}function gg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;i=t[u>>2]|0;e:do if(!(t[(t[f>>2]|0)+360>>2]&131072)){if((i|0)!=32&(t[u>>2]|0)!=62&(t[u>>2]|0)!=47){if(((((((((((((!((t[u>>2]|0)>=97&(t[u>>2]|0)<=122)?!((t[u>>2]|0)>=65&(t[u>>2]|0)<=90|(t[u>>2]|0)==95|(t[u>>2]|0)==58):0)?!((t[u>>2]|0)>=192&(t[u>>2]|0)<=214):0)?!((t[u>>2]|0)>=216&(t[u>>2]|0)<=246):0)?!((t[u>>2]|0)>=248&(t[u>>2]|0)<=767):0)?!((t[u>>2]|0)>=880&(t[u>>2]|0)<=893):0)?!((t[u>>2]|0)>=895&(t[u>>2]|0)<=8191):0)?!((t[u>>2]|0)>=8204&(t[u>>2]|0)<=8205):0)?!((t[u>>2]|0)>=8304&(t[u>>2]|0)<=8591):0)?!((t[u>>2]|0)>=11264&(t[u>>2]|0)<=12271):0)?!((t[u>>2]|0)>=12289&(t[u>>2]|0)<=55295):0)?!((t[u>>2]|0)>=63744&(t[u>>2]|0)<=64975):0)?!((t[u>>2]|0)>=65008&(t[u>>2]|0)<=65533):0)?!((t[u>>2]|0)>=65536&(t[u>>2]|0)<=983039):0)break;t[n>>2]=1;a=t[n>>2]|0;s=r;return a|0}}else{e=t[u>>2]|0;if((i|0)<256){if(((!(65<=(e|0)&(t[u>>2]|0)<=90)?!(97<=(t[u>>2]|0)&(t[u>>2]|0)<=122):0)?!(192<=(t[u>>2]|0)&(t[u>>2]|0)<=214):0)?!(216<=(t[u>>2]|0)&(t[u>>2]|0)<=246|248<=(t[u>>2]|0)):0)o=24}else if(!(dj(e,199744)|0))o=24;do if((o|0)==24){e=t[u>>2]|0;if((t[u>>2]|0)<256)if((e|0)==95|(t[u>>2]|0)==58)break;else break e;if(!(19968<=(e|0)&(t[u>>2]|0)<=40869|(t[u>>2]|0)==12295)?!(12321<=(t[u>>2]|0)&(t[u>>2]|0)<=12329|(t[u>>2]|0)==95|(t[u>>2]|0)==58):0)break e}while(0);t[n>>2]=1;a=t[n>>2]|0;s=r;return a|0}while(0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function yg(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0;f=s;s=s+144|0;a=f+136|0;o=f+132|0;c=f+128|0;l=f+124|0;b=f+140|0;k=f+120|0;h=f+116|0;w=f+112|0;d=f+108|0;v=f+104|0;m=f+100|0;_=f+96|0;p=f+92|0;E=f+88|0;S=f+84|0;g=f+80|0;y=f+76|0;F=f+72|0;O=f+68|0;A=f+64|0;M=f+60|0;R=f+56|0;N=f+52|0;T=f+48|0;L=f+44|0;D=f+40|0;C=f+36|0;P=f+32|0;B=f+28|0;I=f+24|0;H=f+20|0;x=f+16|0;U=f+12|0;z=f+8|0;j=f+4|0;V=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;n[b>>0]=0;t[k>>2]=0;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[_>>2]=0;t[p>>2]=0;r=t[o>>2]|0;do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){t[r+172>>2]=12;n[b>>0]=34;Op(t[o>>2]|0)}else{if((u[t[(t[r+36>>2]|0)+16>>2]>>0]|0|0)==39){n[b>>0]=39;t[(t[o>>2]|0)+172>>2]=12;Op(t[o>>2]|0);break}AS(t[o>>2]|0,39,0);t[a>>2]=0;q=t[a>>2]|0;s=f;return q|0}while(0);t[d>>2]=100;t[k>>2]=gAi[t[135752>>2]&511](t[d>>2]|0)|0;e:do if(t[k>>2]|0){t[v>>2]=Ap(t[o>>2]|0,m)|0;i:while(1){if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==(u[b>>0]|0|0))break;r=t[v>>2]|0;do if((t[v>>2]|0)<256){if(!((9<=(r|0)&(t[v>>2]|0)<=10|(t[v>>2]|0)==13|32<=(t[v>>2]|0))&(t[v>>2]|0)!=60))break i}else{if(!(256<=(r|0)&(t[v>>2]|0)<=55295)?!(57344<=(t[v>>2]|0)&(t[v>>2]|0)<=65533):0)if(65536<=(t[v>>2]|0)&(t[v>>2]|0)<=1114111&(t[v>>2]|0)!=60)break;else break i;if((t[v>>2]|0)==60)break i}while(0);if((t[(t[o>>2]|0)+172>>2]|0)==-1)break;if((t[w>>2]|0)>>>0>1e7?(t[(t[o>>2]|0)+360>>2]&524288|0)==0:0){Y=18;break}if(!(t[v>>2]|0))break;do if((t[v>>2]|0)==38){t[_>>2]=0;r=t[o>>2]|0;if((u[(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){t[S>>2]=lE(r)|0;if((t[S>>2]|0)!=38){if(!(t[S>>2]|0))break;if(((t[w>>2]|0)+10|0)>>>0>(t[d>>2]|0)>>>0){t[M>>2]=(t[d>>2]<<1)+10;if((t[M>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[A>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[M>>2]|0)|0;if(!(t[A>>2]|0)){Y=138;break e}t[k>>2]=t[A>>2];t[d>>2]=t[M>>2]}i=Np(0,(t[k>>2]|0)+(t[w>>2]|0)|0,t[S>>2]|0)|0;t[w>>2]=(t[w>>2]|0)+i;break}i=((t[w>>2]|0)+10|0)>>>0>(t[d>>2]|0)>>>0;if(t[(t[o>>2]|0)+16>>2]|0){if(i){t[y>>2]=(t[d>>2]<<1)+10;if((t[y>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[g>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[y>>2]|0)|0;if(!(t[g>>2]|0)){Y=138;break e}t[k>>2]=t[g>>2];t[d>>2]=t[y>>2]}e=t[w>>2]|0;t[w>>2]=e+1;n[(t[k>>2]|0)+e>>0]=38;break}else{if(i){t[O>>2]=(t[d>>2]<<1)+10;if((t[O>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[F>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[O>>2]|0)|0;if(!(t[F>>2]|0)){Y=138;break e}t[k>>2]=t[F>>2];t[d>>2]=t[O>>2]}i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=38;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=35;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=51;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=56;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=59;break}}t[E>>2]=VE(r)|0;r=(t[o>>2]|0)+440|0;t[r>>2]=(t[r>>2]|0)+1;if(t[E>>2]|0){r=(t[o>>2]|0)+440|0;t[r>>2]=(t[r>>2]|0)+(t[(t[E>>2]|0)+68>>2]|0)}if((t[E>>2]|0)!=0?(t[(t[E>>2]|0)+48>>2]|0)==6:0){if(((t[w>>2]|0)+10|0)>>>0>(t[d>>2]|0)>>>0){t[N>>2]=(t[d>>2]<<1)+10;if((t[N>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[R>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[N>>2]|0)|0;if(!(t[R>>2]|0)){Y=138;break e}t[k>>2]=t[R>>2];t[d>>2]=t[N>>2]}if((t[(t[o>>2]|0)+16>>2]|0)==0?(u[t[(t[E>>2]|0)+40>>2]>>0]|0|0)==38:0){r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=38;r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=35;r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=51;r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=56;r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=59;break}r=n[t[(t[E>>2]|0)+40>>2]>>0]|0;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=r;break}if((t[E>>2]|0)!=0?(t[(t[o>>2]|0)+16>>2]|0)!=0:0){if((t[(t[E>>2]|0)+48>>2]|0)==6){if(((t[w>>2]|0)+10|0)>>>0>(t[d>>2]|0)>>>0){t[C>>2]=(t[d>>2]<<1)+10;if((t[C>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[D>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[C>>2]|0)|0;if(!(t[D>>2]|0)){Y=138;break e}t[k>>2]=t[D>>2];t[d>>2]=t[C>>2]}if(!(t[(t[E>>2]|0)+40>>2]|0))break;r=n[t[(t[E>>2]|0)+40>>2]>>0]|0;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=r;break}t[h>>2]=hE(t[o>>2]|0,t[(t[E>>2]|0)+40>>2]|0,1,0,0,0)|0;if(!(t[h>>2]|0))break;t[p>>2]=t[h>>2];while(1){if(!(u[t[p>>2]>>0]|0))break;do if((u[t[p>>2]>>0]|0|0)==13)Y=61;else{if((u[t[p>>2]>>0]|0|0)==10){Y=61;break}if((u[t[p>>2]>>0]|0|0)==9){Y=61;break}r=t[p>>2]|0;t[p>>2]=r+1;i=n[r>>0]|0;r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=i}while(0);if((Y|0)==61){Y=0;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=32;t[p>>2]=(t[p>>2]|0)+1}if(((t[w>>2]|0)+10|0)>>>0<=(t[d>>2]|0)>>>0)continue;t[L>>2]=(t[d>>2]<<1)+10;if((t[L>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[T>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[L>>2]|0)|0;if(!(t[T>>2]|0)){Y=138;break e}t[k>>2]=t[T>>2];t[d>>2]=t[L>>2]}pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=0;break}if(t[E>>2]|0){t[P>>2]=rs(t[(t[E>>2]|0)+8>>2]|0)|0;t[B>>2]=t[(t[E>>2]|0)+8>>2];do if(((t[(t[E>>2]|0)+48>>2]|0)!=6?(t[(t[E>>2]|0)+40>>2]|0)!=0:0)?(t[(t[E>>2]|0)+72>>2]|0)==0:0){t[I>>2]=t[(t[o>>2]|0)+440>>2];t[h>>2]=hE(t[o>>2]|0,t[(t[E>>2]|0)+40>>2]|0,1,0,0,0)|0;t[(t[E>>2]|0)+72>>2]=(t[(t[o>>2]|0)+440>>2]|0)-(t[I>>2]|0)+1<<1;if(!(t[h>>2]|0))break;if(es(t[h>>2]|0,60)|0){i=(t[E>>2]|0)+72|0;t[i>>2]=t[i>>2]|1}pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=0}while(0);i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=38;while(1){if(((t[w>>2]|0)+(t[P>>2]|0)+10|0)>>>0<=(t[d>>2]|0)>>>0)break;t[x>>2]=(t[d>>2]<<1)+(t[P>>2]|0)+10;if((t[x>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[H>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[x>>2]|0)|0;if(!(t[H>>2]|0)){Y=138;break e}t[k>>2]=t[H>>2];t[d>>2]=t[x>>2]}while(1){if((t[P>>2]|0)<=0)break;i=t[B>>2]|0;t[B>>2]=i+1;r=n[i>>0]|0;i=t[w>>2]|0;t[w>>2]=i+1;n[(t[k>>2]|0)+i>>0]=r;t[P>>2]=(t[P>>2]|0)+-1}r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=59}}else{if((t[v>>2]|0)==32|(t[v>>2]|0)==13|(t[v>>2]|0)==10|(t[v>>2]|0)==9){if(!((t[w>>2]|0)==0&(t[l>>2]|0)!=0)){r:do if(!((t[l>>2]|0)!=0&(t[_>>2]|0)!=0)){r=t[w>>2]|0;if((t[m>>2]|0)==1){t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=32}else{i=Rp((t[k>>2]|0)+r|0,32)|0;t[w>>2]=(t[w>>2]|0)+i}while(1){if(((t[w>>2]|0)+10|0)>>>0<=(t[d>>2]|0)>>>0)break r;t[z>>2]=(t[d>>2]<<1)+10;if((t[z>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[U>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[z>>2]|0)|0;if(!(t[U>>2]|0)){Y=138;break e}t[k>>2]=t[U>>2];t[d>>2]=t[z>>2]}}while(0);t[_>>2]=1}}else{t[_>>2]=0;if((t[m>>2]|0)==1){i=t[v>>2]&255;r=t[w>>2]|0;t[w>>2]=r+1;n[(t[k>>2]|0)+r>>0]=i}else{i=Rp((t[k>>2]|0)+(t[w>>2]|0)|0,t[v>>2]|0)|0;t[w>>2]=(t[w>>2]|0)+i}if(((t[w>>2]|0)+10|0)>>>0>(t[d>>2]|0)>>>0){t[V>>2]=(t[d>>2]<<1)+10;if((t[V>>2]|0)>>>0<(t[d>>2]|0)>>>0){Y=138;break e}t[j>>2]=MAi[t[135760>>2]&511](t[k>>2]|0,t[V>>2]|0)|0;if(!(t[j>>2]|0)){Y=138;break e}t[k>>2]=t[j>>2];t[d>>2]=t[V>>2]}}i=t[(t[o>>2]|0)+36>>2]|0;if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){r=i+28|0;t[r>>2]=(t[r>>2]|0)+1;t[(t[(t[o>>2]|0)+36>>2]|0)+32>>2]=1}else{r=i+32|0;t[r>>2]=(t[r>>2]|0)+1}r=(t[(t[o>>2]|0)+36>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+(t[m>>2]|0);if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[o>>2]|0)}while(0);if((t[(t[o>>2]|0)+292>>2]|0)==0?((t[(t[(t[o>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[o>>2]|0);t[v>>2]=Ap(t[o>>2]|0,m)|0}if((Y|0)==18){BS(t[o>>2]|0,40,71720);Y=138;break}if((t[(t[o>>2]|0)+172>>2]|0)!=-1){i:do if((t[_>>2]|0)!=0&(t[l>>2]|0)!=0&(t[w>>2]|0)>>>0>0)do{if((u[(t[k>>2]|0)+((t[w>>2]|0)-1)>>0]|0|0)!=32)break i;t[w>>2]=(t[w>>2]|0)+-1}while((t[w>>2]|0)>>>0>0);while(0);n[(t[k>>2]|0)+(t[w>>2]|0)>>0]=0;r=t[o>>2]|0;i:do if((u[t[(t[(t[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60)AS(r,38,0);else{if((u[t[(t[r+36>>2]|0)+16>>2]>>0]|0|0)==(u[b>>0]|0|0)){Op(t[o>>2]|0);break}do if(t[v>>2]|0){i=t[v>>2]|0;if((t[v>>2]|0)<256){if(9<=(i|0)&(t[v>>2]|0)<=10|(t[v>>2]|0)==13|32<=(t[v>>2]|0))break}else{if(256<=(i|0)&(t[v>>2]|0)<=55295)break;if(57344<=(t[v>>2]|0)&(t[v>>2]|0)<=65533)break;if(65536<=(t[v>>2]|0)&(t[v>>2]|0)<=1114111)break}BS(t[o>>2]|0,9,71752);break i}while(0);BS(t[o>>2]|0,40,71792)}while(0);if((t[w>>2]|0)>>>0>=2147483647){BS(t[o>>2]|0,40,71720);Y=138;break}if(t[c>>2]|0)t[t[c>>2]>>2]=t[w>>2];t[a>>2]=t[k>>2];q=t[a>>2]|0;s=f;return q|0}}else Y=138;while(0);if((Y|0)==138)Sp(t[o>>2]|0,0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);t[a>>2]=0;q=t[a>>2]|0;s=f;return q|0}function Fg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[a>>2];if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);if((t[(t[f>>2]|0)+172>>2]|0)==-1){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[c>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2];while(1){if(!(u[t[c>>2]>>0]|0))break;if((u[t[c>>2]>>0]|0|0)!=(u[t[o>>2]>>0]|0|0))break;t[c>>2]=(t[c>>2]|0)+1;t[o>>2]=(t[o>>2]|0)+1;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+1}e:do if(!(u[t[o>>2]>>0]|0)){do if((u[t[c>>2]>>0]|0|0)!=62?(u[t[c>>2]>>0]|0|0)!=32:0){if(9<=(u[t[c>>2]>>0]|0|0)?(u[t[c>>2]>>0]|0|0)<=10:0)break;if((u[t[c>>2]>>0]|0|0)!=13)break e}while(0);t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]=t[c>>2];t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}while(0);t[l>>2]=sE(t[f>>2]|0)|0;if((t[l>>2]|0)==(t[a>>2]|0)){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=t[l>>2];b=t[n>>2]|0;s=r;return b|0}return 0}function Og(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[a>>2]=i;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[f>>2]|0);t[o>>2]=Ig(t[f>>2]|0)|0;i=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==58;if(!(t[o>>2]|0)){if(i?(t[o>>2]=sE(t[f>>2]|0)|0,(t[o>>2]|0)!=0):0){KS(t[f>>2]|0,202,70824,t[o>>2]|0,0,0);t[t[a>>2]>>2]=0;t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}do if(i){Op(t[f>>2]|0);t[c>>2]=t[o>>2];t[o>>2]=Ig(t[f>>2]|0)|0;e=t[f>>2]|0;if(!(t[o>>2]|0)){KS(e,202,70856,t[c>>2]|0,0,0);t[o>>2]=dE(t[f>>2]|0)|0;if(!(t[o>>2]|0))t[l>>2]=Ug(65640,t[c>>2]|0,0,0)|0;else{t[l>>2]=Ug(t[o>>2]|0,t[c>>2]|0,0,0)|0;pAi[t[135736>>2]&511](t[o>>2]|0)}t[c>>2]=kz(t[(t[f>>2]|0)+296>>2]|0,t[l>>2]|0,-1)|0;if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[t[a>>2]>>2]=0;t[n>>2]=t[c>>2];k=t[n>>2]|0;s=r;return k|0}if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)!=58){t[t[a>>2]>>2]=t[c>>2];break}KS(t[f>>2]|0,202,70888,t[c>>2]|0,t[o>>2]|0,0);Op(t[f>>2]|0);t[b>>2]=sE(t[f>>2]|0)|0;if(t[b>>2]|0){t[b>>2]=Ug(t[b>>2]|0,t[o>>2]|0,0,0)|0;t[o>>2]=kz(t[(t[f>>2]|0)+296>>2]|0,t[b>>2]|0,-1)|0;if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[t[a>>2]>>2]=t[c>>2];t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}else{t[b>>2]=Ug(65640,t[o>>2]|0,0,0)|0;t[o>>2]=kz(t[(t[f>>2]|0)+296>>2]|0,t[b>>2]|0,-1)|0;if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[t[a>>2]>>2]=t[c>>2];t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}}else t[t[a>>2]>>2]=0;while(0);t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}function Ag(e,i,r,n,f,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;c=s;s=s+64|0;l=c+52|0;b=c+48|0;k=c+44|0;h=c+40|0;w=c+36|0;d=c+32|0;v=c+28|0;m=c+24|0;_=c+20|0;p=c+16|0;E=c+12|0;S=c+8|0;g=c+4|0;y=c;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=a;t[m>>2]=o;t[E>>2]=0;t[S>>2]=0;t[t[d>>2]>>2]=0;if((t[(t[b>>2]|0)+292>>2]|0)==0?((t[(t[(t[b>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[b>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[b>>2]|0);t[_>>2]=Og(t[b>>2]|0,t[w>>2]|0)|0;o=t[b>>2]|0;if(!(t[_>>2]|0)){BS(o,68,69032);t[l>>2]=0;F=t[l>>2]|0;s=c;return F|0}if((t[o+352>>2]|0)!=0?(t[g>>2]=uO(t[(t[b>>2]|0)+352>>2]|0,t[k>>2]|0,t[h>>2]|0,t[t[w>>2]>>2]|0,t[_>>2]|0)|0,(t[g>>2]|0)!=0):0)t[S>>2]=1;uE(t[b>>2]|0)|0;g=t[b>>2]|0;if((u[t[(t[(t[b>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){MS(g,41,69064,t[_>>2]|0);t[l>>2]=0;F=t[l>>2]|0;s=c;return F|0}Op(g);uE(t[b>>2]|0)|0;t[p>>2]=VS(t[b>>2]|0,t[v>>2]|0,t[m>>2]|0,t[S>>2]|0)|0;if((((t[S>>2]|0)!=0?(t[t[m>>2]>>2]|0)!=0:0)?(t[y>>2]=Hg(t[b>>2]|0,t[p>>2]|0,t[v>>2]|0)|0,(t[y>>2]|0)!=0):0)?(t[y>>2]|0)!=(t[p>>2]|0):0){pAi[t[135736>>2]&511](t[p>>2]|0);t[p>>2]=t[y>>2]}t[(t[b>>2]|0)+172>>2]=7;if((t[t[w>>2]>>2]|0)==(t[(t[b>>2]|0)+312>>2]|0)){if(((t[(t[b>>2]|0)+268>>2]|0)!=0?(Xl(t[_>>2]|0,71704)|0)!=0:0)?(t[E>>2]=ql(t[p>>2]|0,t[t[v>>2]>>2]|0)|0,($p(t[E>>2]|0)|0)==0):0)NS(t[b>>2]|0,98,69128,t[E>>2]|0,0);do if(Xl(t[_>>2]|0,71712)|0){t[E>>2]=ql(t[p>>2]|0,t[t[v>>2]>>2]|0)|0;if(Xl(t[E>>2]|0,69184)|0){t[t[(t[b>>2]|0)+232>>2]>>2]=0;break}w=(Xl(t[E>>2]|0,69192)|0)!=0;y=t[b>>2]|0;if(w){t[t[y+232>>2]>>2]=1;break}else{NS(y,102,69208,t[E>>2]|0,0);break}}while(0);if(t[E>>2]|0)pAi[t[135736>>2]&511](t[E>>2]|0)}t[t[d>>2]>>2]=t[p>>2];t[l>>2]=t[_>>2];F=t[l>>2]|0;s=c;return F|0}function Mg(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+48|0;o=a;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+212>>2]|0)!=0:0)?(t[(t[c>>2]|0)+172>>2]|0)==-1:0){s=a;return}u=t[c>>2]|0;c=t[l>>2]|0;l=t[k>>2]|0;f=t[h>>2]|0;n=t[w>>2]|0;r=t[b>>2]|0;b=t[h>>2]|0;h=t[w>>2]|0;t[o>>2]=t[k>>2];t[o+4>>2]=b;t[o+8>>2]=h;cp(0,0,0,u,0,3,c,1,0,0,l,f,n,0,0,r,o);s=a;return}function Rg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[(t[f>>2]|0)+300>>2]|0)){t[c>>2]=55;t[a>>2]=gAi[t[135744>>2]&511](t[c>>2]<<2)|0;if((t[a>>2]|0)!=0?(t[(t[f>>2]|0)+300>>2]=t[a>>2],t[o>>2]=gAi[t[135744>>2]&511](((t[c>>2]|0)/5|0)<<2)|0,(t[o>>2]|0)!=0):0){t[(t[f>>2]|0)+340>>2]=t[o>>2];t[(t[f>>2]|0)+304>>2]=t[c>>2];l=9}else l=10}else if(((t[u>>2]|0)+5|0)>(t[(t[f>>2]|0)+304>>2]|0)){t[c>>2]=(t[u>>2]|0)+5<<1;t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+300>>2]|0,t[c>>2]<<2)|0;if((t[a>>2]|0)!=0?(t[(t[f>>2]|0)+300>>2]=t[a>>2],t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+340>>2]|0,((t[c>>2]|0)/5|0)<<2)|0,(t[o>>2]|0)!=0):0){t[(t[f>>2]|0)+340>>2]=t[o>>2];t[(t[f>>2]|0)+304>>2]=t[c>>2];l=9}else l=10}else l=9;if((l|0)==9){t[n>>2]=t[(t[f>>2]|0)+304>>2];b=t[n>>2]|0;s=r;return b|0}else if((l|0)==10){Sp(t[f>>2]|0,0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}return 0}function Ng(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;r=t[a>>2]|0;if(!(t[c>>2]|0)){t[f>>2]=Fg(r,t[o>>2]|0)|0;w=t[f>>2]|0;s=n;return w|0}if((t[r+292>>2]|0)==0?((t[(t[(t[a>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[a>>2]|0);t[b>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2];t[l>>2]=t[c>>2];while(1){if(!(u[t[b>>2]>>0]|0))break;if((u[t[b>>2]>>0]|0|0)!=(u[t[l>>2]>>0]|0|0))break;t[b>>2]=(t[b>>2]|0)+1;t[l>>2]=(t[l>>2]|0)+1}e:do if((u[t[l>>2]>>0]|0|0)==0?(u[t[b>>2]>>0]|0|0)==58:0){t[b>>2]=(t[b>>2]|0)+1;t[l>>2]=t[o>>2];while(1){if(!(u[t[b>>2]>>0]|0))break;if((u[t[b>>2]>>0]|0|0)!=(u[t[l>>2]>>0]|0|0))break;t[b>>2]=(t[b>>2]|0)+1;t[l>>2]=(t[l>>2]|0)+1}if(!(u[t[l>>2]>>0]|0)){do if((u[t[b>>2]>>0]|0|0)!=62?(u[t[b>>2]>>0]|0|0)!=32:0){if(9<=(u[t[b>>2]>>0]|0|0)?(u[t[b>>2]>>0]|0|0)<=10:0)break;if((u[t[b>>2]>>0]|0|0)!=13)break e}while(0);t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]=t[b>>2];t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}}while(0);t[k>>2]=Og(t[a>>2]|0,h)|0;if((t[k>>2]|0)==(t[o>>2]|0)?(t[c>>2]|0)==(t[h>>2]|0):0){t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}t[f>>2]=t[k>>2];w=t[f>>2]|0;s=n;return w|0}function Tg(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0;u=s;s=s+32|0;a=u+20|0;o=u+16|0;c=u+12|0;l=u+8|0;b=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[u+4>>2]=f;t[b>>2]=t[o>>2];if((t[a>>2]|0)!=1){s=u;return}wO(t[(t[b>>2]|0)+352>>2]|0,t[c>>2]|0,t[l>>2]|0,0)|0;s=u;return}function Lg(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;t[f>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[f>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){yAi[t[135904>>2]&511](t[33980]|0,70648,n);s=n;return}if((t[(t[f>>2]|0)+292>>2]|0)!=0?(t[(t[f>>2]|0)+40>>2]|0)==1:0){t[c>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2];t[c>>2]=(t[c>>2]|0)+-1;while(1){if((t[c>>2]|0)>>>0>=(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)>>>0)l=(u[t[c>>2]>>0]|0|0)!=60;else l=0;b=t[c>>2]|0;if(!l)break;t[c>>2]=b+-1}if(b>>>0<(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)>>>0){t[t[a>>2]>>2]=0;t[t[o>>2]>>2]=0;s=n;return}t[t[a>>2]>>2]=t[c>>2];t[c>>2]=(t[c>>2]|0)+1;while(1){if((t[c>>2]|0)>>>0<(t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)k=(u[t[c>>2]>>0]|0|0)!=62;else k=0;h=t[c>>2]|0;if(!k)break;b=t[c>>2]|0;if((u[h>>0]|0|0)==39){t[c>>2]=b+1;while(1){if((t[c>>2]|0)>>>0<(t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)w=(u[t[c>>2]>>0]|0|0)!=39;else w=0;d=t[c>>2]|0;if(!w)break;t[c>>2]=d+1}if(d>>>0>=(t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)continue;t[c>>2]=(t[c>>2]|0)+1;continue}else{l=(u[b>>0]|0|0)==34;t[c>>2]=(t[c>>2]|0)+1;if(!l)continue;while(1){if((t[c>>2]|0)>>>0<(t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)v=(u[t[c>>2]>>0]|0|0)!=34;else v=0;m=t[c>>2]|0;if(!v)break;t[c>>2]=m+1}if(m>>>0>=(t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)continue;t[c>>2]=(t[c>>2]|0)+1;continue}}if(h>>>0<(t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0){t[t[o>>2]>>2]=t[c>>2];s=n;return}t[c>>2]=t[t[a>>2]>>2];t[c>>2]=(t[c>>2]|0)+-1;while(1){if((t[c>>2]|0)>>>0>=(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)>>>0)_=(u[t[c>>2]>>0]|0|0)!=62;else _=0;p=t[c>>2]|0;if(!_)break;t[c>>2]=p+-1}if(p>>>0>=(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)>>>0){t[t[o>>2]>>2]=t[c>>2];s=n;return}else{t[t[o>>2]>>2]=0;s=n;return}}t[t[a>>2]>>2]=0;t[t[o>>2]>>2]=0;s=n;return}function Dg(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+26|0;b=a+25|0;k=a+24|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[c>>2]=e;n[l>>0]=i;n[b>>0]=r;n[k>>0]=f;t[d>>2]=t[(t[c>>2]|0)+36>>2];if(!(t[d>>2]|0)){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[h>>2]=(t[(t[d>>2]|0)+16>>2]|0)-(t[(t[d>>2]|0)+12>>2]|0);if((t[h>>2]|0)<0){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}if((t[(t[c>>2]|0)+204>>2]|0)>(t[h>>2]|0))t[h>>2]=t[(t[c>>2]|0)+204>>2];f=t[d>>2]|0;if(!(t[t[d>>2]>>2]|0)){t[v>>2]=t[f+12>>2];t[w>>2]=t[(t[d>>2]|0)+24>>2]}else{t[v>>2]=Os(t[(t[f>>2]|0)+16>>2]|0)|0;t[w>>2]=Ts(t[(t[t[d>>2]>>2]|0)+16>>2]|0)|0}if(!(n[k>>0]|0)){if(n[b>>0]|0)t[w>>2]=(t[w>>2]|0)+-1}else t[w>>2]=(t[w>>2]|0)-2;e:while(1){_=t[h>>2]|0;if((t[h>>2]|0)>=(t[w>>2]|0)){p=23;break}do if((u[(t[v>>2]|0)+_>>0]|0)==(u[l>>0]|0))if(u[k>>0]|0){if((u[(t[v>>2]|0)+((t[h>>2]|0)+1)>>0]|0)!=(u[b>>0]|0))break;if((u[(t[v>>2]|0)+((t[h>>2]|0)+2)>>0]|0)!=(u[k>>0]|0))break;else{p=21;break e}}else{if(!(u[b>>0]|0)){p=21;break e}if((u[(t[v>>2]|0)+((t[h>>2]|0)+1)>>0]|0)!=(u[b>>0]|0))break;else{p=21;break e}}while(0);t[h>>2]=(t[h>>2]|0)+1}if((p|0)==21){t[(t[c>>2]|0)+204>>2]=0;t[o>>2]=(t[h>>2]|0)-((t[(t[d>>2]|0)+16>>2]|0)-(t[(t[d>>2]|0)+12>>2]|0));m=t[o>>2]|0;s=a;return m|0}else if((p|0)==23){t[(t[c>>2]|0)+204>>2]=_;t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}return 0}function Cg(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;u=s;s=s+32|0;a=u+28|0;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;h=u+4|0;w=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;e:do if((t[(t[o>>2]|0)+188>>2]|0)>=(t[(t[o>>2]|0)+192>>2]|0)){f=(t[o>>2]|0)+192|0;t[f>>2]=t[f>>2]<<1;t[h>>2]=MAi[t[135760>>2]&511](t[(t[o>>2]|0)+196>>2]|0,t[(t[o>>2]|0)+192>>2]<<2)|0;do if(t[h>>2]|0){t[(t[o>>2]|0)+196>>2]=t[h>>2];t[w>>2]=MAi[t[135760>>2]&511](t[(t[o>>2]|0)+344>>2]|0,(t[(t[o>>2]|0)+192>>2]|0)*3<<2)|0;if(!(t[w>>2]|0)){f=(t[o>>2]|0)+192|0;t[f>>2]=(t[f>>2]|0)/2|0;break}else{t[(t[o>>2]|0)+344>>2]=t[w>>2];break e}}else{f=(t[o>>2]|0)+192|0;t[f>>2]=(t[f>>2]|0)/2|0}while(0);Sp(t[o>>2]|0,0);t[a>>2]=-1;d=t[a>>2]|0;s=u;return d|0}while(0);t[(t[(t[o>>2]|0)+196>>2]|0)+(t[(t[o>>2]|0)+188>>2]<<2)>>2]=t[c>>2];t[(t[o>>2]|0)+184>>2]=t[c>>2];t[(t[(t[o>>2]|0)+344>>2]|0)+((t[(t[o>>2]|0)+188>>2]|0)*3<<2)>>2]=t[l>>2];t[(t[(t[o>>2]|0)+344>>2]|0)+(((t[(t[o>>2]|0)+188>>2]|0)*3|0)+1<<2)>>2]=t[b>>2];t[(t[(t[o>>2]|0)+344>>2]|0)+(((t[(t[o>>2]|0)+188>>2]|0)*3|0)+2<<2)>>2]=t[k>>2];k=(t[o>>2]|0)+188|0;o=t[k>>2]|0;t[k>>2]=o+1;t[a>>2]=o;d=t[a>>2]|0;s=u;return d|0}function Pg(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+188>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+188|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+188>>2]|0)>0)t[(t[n>>2]|0)+184>>2]=t[(t[(t[n>>2]|0)+196>>2]|0)+((t[e+188>>2]|0)-1<<2)>>2];else t[e+184>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+196>>2]|0)+(t[(t[n>>2]|0)+188>>2]<<2)>>2];t[(t[(t[n>>2]|0)+196>>2]|0)+(t[(t[n>>2]|0)+188>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Bg(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+32|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r+20|0;b=r;t[a>>2]=e;t[o>>2]=i;if((t[a>>2]|0)==0|(t[o>>2]|0)<=0){t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}t[c>>2]=0;while(1){h=t[c>>2]|0;if((t[c>>2]|0)>=(t[o>>2]|0)){w=53;break}n[l>>0]=n[(t[a>>2]|0)+h>>0]|0;i=u[l>>0]|0;if(!((u[l>>0]|0)&128)){if((i|0)>=32){t[c>>2]=(t[c>>2]|0)+1;continue}if(((u[l>>0]|0|0)!=10?(u[l>>0]|0|0)!=13:0)?(u[l>>0]|0|0)!=9:0){w=12;break}t[c>>2]=(t[c>>2]|0)+1;continue}if((i&224|0)==192){d=t[c>>2]|0;if(((t[c>>2]|0)+2|0)>(t[o>>2]|0)){w=15;break}v=t[c>>2]|0;if(((u[(t[a>>2]|0)+(d+1)>>0]|0)&192|0)!=128){w=17;break}t[b>>2]=((u[(t[a>>2]|0)+v>>0]|0)&31)<<6;t[b>>2]=t[b>>2]|(u[(t[a>>2]|0)+((t[c>>2]|0)+1)>>0]|0)&63;i=t[b>>2]|0;if((t[b>>2]|0)<256){if(!(9<=(i|0)&(t[b>>2]|0)<=10|(t[b>>2]|0)==13|32<=(t[b>>2]|0))){w=23;break}}else if((!(256<=(i|0)&(t[b>>2]|0)<=55295)?!(57344<=(t[b>>2]|0)&(t[b>>2]|0)<=65533):0)?!(65536<=(t[b>>2]|0)&(t[b>>2]|0)<=1114111):0){w=23;break}t[c>>2]=(t[c>>2]|0)+2;continue}if(((u[l>>0]|0)&240|0)==224){m=t[c>>2]|0;if(((t[c>>2]|0)+3|0)>(t[o>>2]|0)){w=27;break}if(((u[(t[a>>2]|0)+(m+1)>>0]|0)&192|0)!=128){w=30;break}if(((u[(t[a>>2]|0)+((t[c>>2]|0)+2)>>0]|0)&192|0)!=128){w=30;break}t[b>>2]=((u[(t[a>>2]|0)+(t[c>>2]|0)>>0]|0)&15)<<12;t[b>>2]=t[b>>2]|((u[(t[a>>2]|0)+((t[c>>2]|0)+1)>>0]|0)&63)<<6;t[b>>2]=t[b>>2]|(u[(t[a>>2]|0)+((t[c>>2]|0)+2)>>0]|0)&63;i=t[b>>2]|0;if((t[b>>2]|0)<256){if(!(9<=(i|0)&(t[b>>2]|0)<=10|(t[b>>2]|0)==13|32<=(t[b>>2]|0))){w=36;break}}else if((!(256<=(i|0)&(t[b>>2]|0)<=55295)?!(57344<=(t[b>>2]|0)&(t[b>>2]|0)<=65533):0)?!(65536<=(t[b>>2]|0)&(t[b>>2]|0)<=1114111):0){w=36;break}t[c>>2]=(t[c>>2]|0)+3;continue}_=t[c>>2]|0;if(((u[l>>0]|0)&248|0)!=240){w=52;break}p=t[c>>2]|0;if((_+4|0)>(t[o>>2]|0)){w=40;break}if(((u[(t[a>>2]|0)+(p+1)>>0]|0)&192|0)!=128){w=44;break}if(((u[(t[a>>2]|0)+((t[c>>2]|0)+2)>>0]|0)&192|0)!=128){w=44;break}if(((u[(t[a>>2]|0)+((t[c>>2]|0)+3)>>0]|0)&192|0)!=128){w=44;break}t[b>>2]=((u[(t[a>>2]|0)+(t[c>>2]|0)>>0]|0)&7)<<18;t[b>>2]=t[b>>2]|((u[(t[a>>2]|0)+((t[c>>2]|0)+1)>>0]|0)&63)<<12;t[b>>2]=t[b>>2]|((u[(t[a>>2]|0)+((t[c>>2]|0)+2)>>0]|0)&63)<<6;t[b>>2]=t[b>>2]|(u[(t[a>>2]|0)+((t[c>>2]|0)+3)>>0]|0)&63;i=t[b>>2]|0;if((t[b>>2]|0)<256){if(!(9<=(i|0)&(t[b>>2]|0)<=10|(t[b>>2]|0)==13|32<=(t[b>>2]|0))){w=50;break}}else if((!(256<=(i|0)&(t[b>>2]|0)<=55295)?!(57344<=(t[b>>2]|0)&(t[b>>2]|0)<=65533):0)?!(65536<=(t[b>>2]|0)&(t[b>>2]|0)<=1114111):0){w=50;break}t[c>>2]=(t[c>>2]|0)+4}switch(w|0){case 12:{t[f>>2]=0-(t[c>>2]|0);k=t[f>>2]|0;s=r;return k|0}case 15:{t[f>>2]=d;k=t[f>>2]|0;s=r;return k|0}case 17:{t[f>>2]=0-v;k=t[f>>2]|0;s=r;return k|0}case 23:{t[f>>2]=0-(t[c>>2]|0);k=t[f>>2]|0;s=r;return k|0}case 27:{t[f>>2]=m;k=t[f>>2]|0;s=r;return k|0}case 30:{t[f>>2]=0-(t[c>>2]|0);k=t[f>>2]|0;s=r;return k|0}case 36:{t[f>>2]=0-(t[c>>2]|0);k=t[f>>2]|0;s=r;return k|0}case 40:{t[f>>2]=p;k=t[f>>2]|0;s=r;return k|0}case 44:{t[f>>2]=0-(t[c>>2]|0);k=t[f>>2]|0;s=r;return k|0}case 50:{t[f>>2]=0-(t[c>>2]|0);k=t[f>>2]|0;s=r;return k|0}case 52:{t[f>>2]=0-_;k=t[f>>2]|0;s=r;return k|0}case 53:{t[f>>2]=h;k=t[f>>2]|0;s=r;return k|0}}return 0}function Ig(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[o>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)c=6;else c=3;do if((c|0)==3){if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){c=6;break}if((u[t[f>>2]>>0]|0|0)==95)c=6}while(0);if((c|0)==6){t[f>>2]=(t[f>>2]|0)+1;while(1){if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)l=1;else c=9;do if((c|0)==9){c=0;if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){l=1;break}if((u[t[f>>2]>>0]|0|0)>=48?(u[t[f>>2]>>0]|0|0)<=57:0){l=1;break}if((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=45:0)l=(u[t[f>>2]>>0]|0|0)==46;else l=1}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if((u[b>>0]|0|0)>0?(u[t[f>>2]>>0]|0|0)<128:0){t[o>>2]=(t[f>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0);if((t[o>>2]|0)>5e4?(t[(t[n>>2]|0)+360>>2]&524288|0)==0:0){AS(t[n>>2]|0,110,70920);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[a>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0,t[o>>2]|0)|0;t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]=t[f>>2];f=(t[n>>2]|0)+200|0;t[f>>2]=(t[f>>2]|0)+(t[o>>2]|0);f=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[f>>2]=(t[f>>2]|0)+(t[o>>2]|0);if(!(t[a>>2]|0))Sp(t[n>>2]|0,0);t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}}t[r>>2]=xg(t[n>>2]|0)|0;k=t[r>>2]|0;s=i;return k|0}function Hg(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=0;t[k>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[l>>2]=t[t[c>>2]>>2];if((t[l>>2]|0)<=0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[h>>2]=t[o>>2];while(1){if((u[t[h>>2]>>0]|0|0)!=32)break;t[h>>2]=(t[h>>2]|0)+1;t[b>>2]=(t[b>>2]|0)+1}while(1){if(!(u[t[h>>2]>>0]|0))break;r=(u[t[h>>2]>>0]|0|0)==32;t[h>>2]=(t[h>>2]|0)+1;if(!r)continue;if((u[t[h>>2]>>0]|0|0)==32){v=12;break}if(!(u[t[h>>2]>>0]|0)){v=12;break}}if((v|0)==12)t[k>>2]=1;if(t[k>>2]|0){t[w>>2]=ql((t[o>>2]|0)+(t[b>>2]|0)|0,(t[l>>2]|0)-(t[b>>2]|0)+1|0)|0;if(!(t[w>>2]|0)){Sp(t[a>>2]|0,0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}else{JS(t[w>>2]|0,t[w>>2]|0)|0;a=HY(t[w>>2]|0)|0;t[t[c>>2]>>2]=a;t[f>>2]=t[w>>2];d=t[f>>2]|0;s=n;return d|0}}else if(t[b>>2]|0){w=t[c>>2]|0;t[w>>2]=(t[w>>2]|0)-(t[b>>2]|0);GY(t[o>>2]|0,(t[o>>2]|0)+(t[b>>2]|0)|0,1+(t[t[c>>2]>>2]|0)|0)|0;t[f>>2]=t[o>>2];d=t[f>>2]|0;s=n;return d|0}else{t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}return 0}function xg(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[n>>2]=e;t[f>>2]=0;t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);t[l>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];t[o>>2]=Ap(t[n>>2]|0,a)|0;if(!((t[o>>2]|0)==32|(t[o>>2]|0)==62|(t[o>>2]|0)==47)?(e=(gg(t[n>>2]|0,t[o>>2]|0)|0)==0,!(e|(t[o>>2]|0)==58)):0){while(1){if(!((t[o>>2]|0)!=32&(t[o>>2]|0)!=62&(t[o>>2]|0)!=47)){b=30;break}e=(zS(t[n>>2]|0,t[o>>2]|0)|0)!=0;if(!(e&(t[o>>2]|0)!=58)){b=30;break}e=t[c>>2]|0;t[c>>2]=e+1;if((e|0)>100){if((t[f>>2]|0)>5e4?(t[(t[n>>2]|0)+360>>2]&524288|0)==0:0){b=12;break}t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){b=17;break}}t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);e=t[(t[n>>2]|0)+36>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=e+28|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[(t[n>>2]|0)+36>>2]|0)+32>>2]=1}else{k=e+32|0;t[k>>2]=(t[k>>2]|0)+1}k=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+(t[a>>2]|0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)oE(t[n>>2]|0);t[l>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];t[o>>2]=Ap(t[n>>2]|0,a)|0;if(t[o>>2]|0)continue;t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)CS(t[n>>2]|0);if((t[(t[n>>2]|0)+172>>2]|0)==-1){b=28;break}t[l>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];t[o>>2]=Ap(t[n>>2]|0,a)|0}if((b|0)==12){AS(t[n>>2]|0,110,70920);t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}else if((b|0)==17){t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}else if((b|0)==28){t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}else if((b|0)==30){if((t[f>>2]|0)>5e4?(t[(t[n>>2]|0)+360>>2]&524288|0)==0:0){AS(t[n>>2]|0,110,70920);t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}t[r>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,(t[l>>2]|0)+(0-(t[f>>2]|0))|0,t[f>>2]|0)|0;h=t[r>>2]|0;s=i;return h|0}}t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}function Ug(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;
	u=s;s=s+32|0;a=u+28|0;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;h=u+4|0;w=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;if(!(t[o>>2]|0)){t[a>>2]=0;d=t[a>>2]|0;s=u;return d|0}f=t[o>>2]|0;if(!(t[c>>2]|0)){t[a>>2]=f;d=t[a>>2]|0;s=u;return d|0}t[k>>2]=HY(f|0)|0;t[h>>2]=HY(t[c>>2]|0)|0;if((t[l>>2]|0)!=0?(t[b>>2]|0)>=((t[k>>2]|0)+(t[h>>2]|0)+2|0):0)t[w>>2]=t[l>>2];else v=7;if((v|0)==7?(t[w>>2]=gAi[t[135752>>2]&511]((t[k>>2]|0)+(t[h>>2]|0)+2|0)|0,(t[w>>2]|0)==0):0){LF(75136);t[a>>2]=0;d=t[a>>2]|0;s=u;return d|0}YY(t[w>>2]|0,t[c>>2]|0,t[h>>2]|0)|0;n[(t[w>>2]|0)+(t[h>>2]|0)>>0]=58;YY((t[w>>2]|0)+((t[h>>2]|0)+1)|0,t[o>>2]|0,t[k>>2]|0)|0;n[(t[w>>2]|0)+((t[k>>2]|0)+(t[h>>2]|0)+1)>>0]=0;t[a>>2]=t[w>>2];d=t[a>>2]|0;s=u;return d|0}function zg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;t[c>>2]=0;if(!(t[a>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[t[a>>2]>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if((u[t[f>>2]>>0]|0|0)==58){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}while(1){if(u[(t[f>>2]|0)+(t[o>>2]|0)>>0]|0)b=(u[(t[f>>2]|0)+(t[o>>2]|0)>>0]|0|0)!=58;else b=0;k=t[o>>2]|0;if(!b)break;t[o>>2]=k+1}if(!(u[(t[f>>2]|0)+k>>0]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}k=ql(t[f>>2]|0,t[o>>2]|0)|0;t[t[a>>2]>>2]=k;if(!(t[t[a>>2]>>2]|0)){LF(75152);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[c>>2]=Yl((t[f>>2]|0)+((t[o>>2]|0)+1)|0)|0;if(t[c>>2]|0){t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}LF(75152);if(t[t[a>>2]>>2]|0){pAi[t[135736>>2]&511](t[t[a>>2]>>2]|0);t[t[a>>2]>>2]=0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function jg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;do if(t[f>>2]|0){if(!(t[a>>2]|0)){t[n>>2]=0;break}if((u[t[f>>2]>>0]|0|0)==58){t[n>>2]=0;break}while(1){if(u[(t[f>>2]|0)+(t[o>>2]|0)>>0]|0)c=(u[(t[f>>2]|0)+(t[o>>2]|0)>>0]|0|0)!=58;else c=0;l=t[o>>2]|0;if(!c)break;t[o>>2]=l+1}if(!(u[(t[f>>2]|0)+l>>0]|0)){t[n>>2]=0;break}else{t[t[a>>2]>>2]=t[o>>2];t[n>>2]=(t[f>>2]|0)+((t[o>>2]|0)+1);break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function Vg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[f>>2];if(!(t[f>>2]|0)){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0)k=14;else k=11;do if((k|0)==11){if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0){k=14;break}if((u[t[o>>2]>>0]|0|0)==95)k=14}while(0);if((k|0)==14){t[o>>2]=(t[o>>2]|0)+1;e:while(1){if(!((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0))k=17;do if((k|0)==17){k=0;if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0)break;if((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0)break;if(((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=45:0)?(u[t[o>>2]>>0]|0|0)!=46:0)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if(!(u[t[o>>2]>>0]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}t[o>>2]=t[f>>2];t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)h=(t[c>>2]|0)==13;else h=1;w=h&1}else w=0;if(!w)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);w=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(w|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=47}else if(!(dj(w,199744)|0))k=47;do if((k|0)==47){w=t[c>>2]|0;if((t[c>>2]|0)<256){if((w|0)==95)break}else{if(19968<=(w|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(!((12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329^1)&(t[c>>2]|0)!=95))break}t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:while(1){w=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(w|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=59}else if(!(dj(w,199744)|0))k=59;do if((k|0)==59){k=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}w=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(w|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{h=(dj(w,200216)|0)!=0;if(h|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;h=t[c>>2]|0;if((t[c>>2]|0)<256)d=(h|0)==183&1;else d=dj(h,200272)|0;if(!d)break e}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)v=(t[c>>2]|0)==13;else v=1;m=v&1}else m=0;if(!m)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);if(t[c>>2]|0){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function qg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[f>>2];if(!(t[f>>2]|0)){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0)k=14;else k=11;do if((k|0)==11){if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0){k=14;break}if((u[t[o>>2]>>0]|0|0)==95)k=14}while(0);e:do if((k|0)==14){t[o>>2]=(t[o>>2]|0)+1;while(1){if((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0)h=1;else k=17;do if((k|0)==17){k=0;if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0){h=1;break}if((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0){h=1;break}if((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=45:0)h=(u[t[o>>2]>>0]|0|0)==46;else h=1}while(0);w=t[o>>2]|0;if(!h)break;t[o>>2]=w+1}i:do if((u[w>>0]|0|0)==58){t[o>>2]=(t[o>>2]|0)+1;if(!((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0))k=29;do if((k|0)==29){if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0)break;if((u[t[o>>2]>>0]|0|0)!=95)break e}while(0);t[o>>2]=(t[o>>2]|0)+1;while(1){if(!((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0))k=35;do if((k|0)==35){k=0;if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0)break;if((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0)break;if(((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=45:0)?(u[t[o>>2]>>0]|0|0)!=46:0)break i}while(0);t[o>>2]=(t[o>>2]|0)+1}}while(0);i:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break i}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if(!(u[t[o>>2]>>0]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}while(0);t[o>>2]=t[f>>2];t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)d=(t[c>>2]|0)==13;else d=1;v=d&1}else v=0;if(!v)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);v=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(v|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=65}else if(!(dj(v,199744)|0))k=65;do if((k|0)==65){v=t[c>>2]|0;if((t[c>>2]|0)<256){if((v|0)==95)break}else{if(19968<=(v|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(!((12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329^1)&(t[c>>2]|0)!=95))break}t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:while(1){v=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(v|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=77}else if(!(dj(v,199744)|0))k=77;do if((k|0)==77){k=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}v=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(v|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{d=(dj(v,200216)|0)!=0;if(d|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;d=t[c>>2]|0;if((t[c>>2]|0)<256)m=(d|0)==183&1;else m=dj(d,200272)|0;if(!m)break e}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}e:do if((t[c>>2]|0)==58){t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0;m=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(m|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=97}else if(!(dj(m,199744)|0))k=97;do if((k|0)==97){m=t[c>>2]|0;if((t[c>>2]|0)<256){if((m|0)==95)break}else{if(19968<=(m|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(!((12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329^1)&(t[c>>2]|0)!=95))break}t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0;while(1){m=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(m|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=109}else if(!(dj(m,199744)|0))k=109;do if((k|0)==109){k=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}m=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(m|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{d=(dj(m,200216)|0)!=0;if(d|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;d=t[c>>2]|0;if((t[c>>2]|0)<256)_=(d|0)==183&1;else _=dj(d,200272)|0;if(!_)break e}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}}while(0);e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)p=(t[c>>2]|0)==13;else p=1;E=p&1}else E=0;if(!E)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);if(t[c>>2]|0){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function Yg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[f>>2];if(!(t[f>>2]|0)){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0)k=15;else k=11;do if((k|0)==11){if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0){k=15;break}if(!((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=58:0))k=15}while(0);if((k|0)==15){t[o>>2]=(t[o>>2]|0)+1;e:while(1){if(!((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0))k=18;do if((k|0)==18){k=0;if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0)break;if((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0)break;if((((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=45:0)?(u[t[o>>2]>>0]|0|0)!=46:0)?(u[t[o>>2]>>0]|0|0)!=58:0)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if(!(u[t[o>>2]>>0]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}t[o>>2]=t[f>>2];t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)h=(t[c>>2]|0)==13;else h=1;w=h&1}else w=0;if(!w)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);w=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(w|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=49}else if(!(dj(w,199744)|0))k=49;do if((k|0)==49){w=t[c>>2]|0;if((t[c>>2]|0)<256){if(!((w|0)!=95&(t[c>>2]|0)!=58))break}else{if(19968<=(w|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(!((12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329^1)&(t[c>>2]|0)!=95&(t[c>>2]|0)!=58))break}t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:while(1){w=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(w|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=61}else if(!(dj(w,199744)|0))k=61;do if((k|0)==61){k=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}w=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(w|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==58|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{h=(dj(w,200216)|0)!=0;if(h|(t[c>>2]|0)==46|(t[c>>2]|0)==58|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;h=t[c>>2]|0;if((t[c>>2]|0)<256)d=(h|0)==183&1;else d=dj(h,200272)|0;if(!d)break e}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)v=(t[c>>2]|0)==13;else v=1;m=v&1}else m=0;if(!m)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);if(t[c>>2]|0){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function Gg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[f>>2];if(!(t[f>>2]|0)){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0)k=19;else k=11;do if((k|0)==11){if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0){k=19;break}if((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0){k=19;break}if(!((((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=45:0)?(u[t[o>>2]>>0]|0|0)!=46:0)?(u[t[o>>2]>>0]|0|0)!=58:0))k=19}while(0);if((k|0)==19){t[o>>2]=(t[o>>2]|0)+1;e:while(1){if(!((u[t[o>>2]>>0]|0|0)>=97?(u[t[o>>2]>>0]|0|0)<=122:0))k=22;do if((k|0)==22){k=0;if((u[t[o>>2]>>0]|0|0)>=65?(u[t[o>>2]>>0]|0|0)<=90:0)break;if((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0)break;if((((u[t[o>>2]>>0]|0|0)!=95?(u[t[o>>2]>>0]|0|0)!=45:0)?(u[t[o>>2]>>0]|0|0)!=46:0)?(u[t[o>>2]>>0]|0|0)!=58:0)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}e:do if(t[a>>2]|0)while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}while(0);if(!(u[t[o>>2]>>0]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}t[o>>2]=t[f>>2];t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)h=(t[c>>2]|0)==13;else h=1;w=h&1}else w=0;if(!w)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);w=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(w|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=53}else if(!(dj(w,199744)|0))k=53;do if((k|0)==53){if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}w=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(w|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==58|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{h=(dj(w,200216)|0)!=0;if(h|(t[c>>2]|0)==46|(t[c>>2]|0)==58|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;h=t[c>>2]|0;if((t[c>>2]|0)<256){if((h|0)==183)break}else if(dj(h,200272)|0)break;t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0;e:while(1){h=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(h|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)k=72}else if(!(dj(h,199744)|0))k=72;do if((k|0)==72){k=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}h=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(h|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==58|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{w=(dj(h,200216)|0)!=0;if(w|(t[c>>2]|0)==46|(t[c>>2]|0)==58|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;w=t[c>>2]|0;if((t[c>>2]|0)<256)d=(w|0)==183&1;else d=dj(w,200272)|0;if(!d)break e}while(0);t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}e:do if(t[a>>2]|0)while(1){if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10):0)v=(t[c>>2]|0)==13;else v=1;m=v&1}else m=0;if(!m)break e;t[o>>2]=(t[o>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[o>>2]|0,l)|0}while(0);if(t[c>>2]|0){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function Wg(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=1:0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}if(((t[o>>2]|0)!=0?(Xl(t[o>>2]|0,75168)|0)!=0:0)?(Xl(t[a>>2]|0,75176)|0)!=0:0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[c>>2]|0)){LF(75216);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}r=t[c>>2]|0;t[r+0>>2]=0;t[r+4>>2]=0;t[r+8>>2]=0;t[r+12>>2]=0;t[r+16>>2]=0;t[r+20>>2]=0;t[(t[c>>2]|0)+4>>2]=18;if(t[a>>2]|0){r=Yl(t[a>>2]|0)|0;t[(t[c>>2]|0)+8>>2]=r}if(t[o>>2]|0){r=Yl(t[o>>2]|0)|0;t[(t[c>>2]|0)+12>>2]=r}do if(t[u>>2]|0){if(!(t[(t[u>>2]|0)+48>>2]|0)){t[(t[u>>2]|0)+48>>2]=t[c>>2];break}t[l>>2]=t[(t[u>>2]|0)+48>>2];if(!((t[(t[l>>2]|0)+12>>2]|0)==0?(t[(t[c>>2]|0)+12>>2]|0)==0:0))k=19;if((k|0)==19?(Xl(t[(t[l>>2]|0)+12>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0)==0:0){do{if(!(t[t[l>>2]>>2]|0)){k=26;break}t[l>>2]=t[t[l>>2]>>2];if((t[(t[l>>2]|0)+12>>2]|0)==0?(t[(t[c>>2]|0)+12>>2]|0)==0:0)break}while((Xl(t[(t[l>>2]|0)+12>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0)==0);if((k|0)==26){t[t[l>>2]>>2]=t[c>>2];break}Kg(t[c>>2]|0);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}Kg(t[c>>2]|0);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function Kg(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Xg(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+4>>2]|0)!=1?(t[(t[n>>2]|0)+4>>2]|0)!=2:0){s=r;return}t[(t[n>>2]|0)+36>>2]=t[f>>2];s=r;return}function Zg(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!((t[r>>2]|0)!=0&(t[r>>2]|0)!=0)){s=i;return}do{t[n>>2]=t[t[r>>2]>>2];Kg(t[r>>2]|0);t[r>>2]=t[n>>2]}while((t[r>>2]|0)!=0);s=i;return}function Jg(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+48>>2]|0)!=0:0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[b>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[b>>2]|0)){LF(75240);t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}n=(t[b>>2]|0)+0|0;r=n+64|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));t[(t[b>>2]|0)+4>>2]=14;if(t[o>>2]|0){n=Yl(t[o>>2]|0)|0;t[(t[b>>2]|0)+8>>2]=n}if(t[c>>2]|0){n=Yl(t[c>>2]|0)|0;t[(t[b>>2]|0)+52>>2]=n}if(t[l>>2]|0){n=Yl(t[l>>2]|0)|0;t[(t[b>>2]|0)+56>>2]=n}if(t[a>>2]|0)t[(t[a>>2]|0)+48>>2]=t[b>>2];t[(t[b>>2]|0)+32>>2]=t[a>>2];if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[b>>2]|0);t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}function Qg(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=t[(t[n>>2]|0)+12>>2];while(1){if(!(t[f>>2]|0)){a=8;break}o=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==14){a=6;break}t[f>>2]=t[o+24>>2]}if((a|0)==6){t[r>>2]=o;u=t[r>>2]|0;s=i;return u|0}else if((a|0)==8){t[r>>2]=t[(t[n>>2]|0)+44>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function $g(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)!=0?(Qg(t[a>>2]|0)|0)!=0:0){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}t[b>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[b>>2]|0)){LF(75256);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}n=(t[b>>2]|0)+0|0;r=n+64|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));t[(t[b>>2]|0)+4>>2]=14;if((t[o>>2]|0)!=0?(n=Yl(t[o>>2]|0)|0,t[(t[b>>2]|0)+8>>2]=n,(t[(t[b>>2]|0)+8>>2]|0)==0):0){LF(75256);pAi[t[135736>>2]&511](t[b>>2]|0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if((t[c>>2]|0)!=0?(n=Yl(t[c>>2]|0)|0,t[(t[b>>2]|0)+52>>2]=n,(t[(t[b>>2]|0)+52>>2]|0)==0):0){LF(75256);if(t[(t[b>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[b>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if((t[l>>2]|0)!=0?(n=Yl(t[l>>2]|0)|0,t[(t[b>>2]|0)+56>>2]=n,(t[(t[b>>2]|0)+56>>2]|0)==0):0){LF(75256);if(t[(t[b>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[b>>2]|0)+8>>2]|0);if(t[(t[b>>2]|0)+52>>2]|0)pAi[t[135736>>2]&511](t[(t[b>>2]|0)+52>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}do if(t[a>>2]|0){t[(t[a>>2]|0)+44>>2]=t[b>>2];t[(t[b>>2]|0)+20>>2]=t[a>>2];t[(t[b>>2]|0)+32>>2]=t[a>>2];if(!(t[(t[a>>2]|0)+12>>2]|0)){t[(t[a>>2]|0)+12>>2]=t[b>>2];t[(t[a>>2]|0)+16>>2]=t[b>>2];break}n=t[(t[a>>2]|0)+12>>2]|0;if((t[(t[a>>2]|0)+4>>2]|0)==13){t[k>>2]=n;t[(t[k>>2]|0)+28>>2]=t[b>>2];t[(t[b>>2]|0)+24>>2]=t[k>>2];t[(t[a>>2]|0)+12>>2]=t[b>>2];break}t[h>>2]=n;while(1){if(t[h>>2]|0)d=(t[(t[h>>2]|0)+4>>2]|0)!=1;else d=0;v=t[h>>2]|0;if(!d)break;t[h>>2]=t[v+24>>2]}if(!v){t[(t[b>>2]|0)+28>>2]=t[(t[a>>2]|0)+16>>2];t[(t[(t[b>>2]|0)+28>>2]|0)+24>>2]=t[b>>2];t[(t[b>>2]|0)+24>>2]=0;t[(t[a>>2]|0)+16>>2]=t[b>>2];break}t[(t[b>>2]|0)+24>>2]=t[h>>2];t[(t[b>>2]|0)+28>>2]=t[(t[h>>2]|0)+28>>2];n=t[b>>2]|0;if(!(t[(t[b>>2]|0)+28>>2]|0))t[(t[a>>2]|0)+12>>2]=n;else t[(t[(t[b>>2]|0)+28>>2]|0)+24>>2]=n;t[(t[h>>2]|0)+28>>2]=t[b>>2]}while(0);if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[b>>2]|0);t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}function ey(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[r>>2]=e;t[n>>2]=0;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+80>>2];if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[r>>2]|0);e:do if(t[(t[r>>2]|0)+12>>2]|0){t[u>>2]=t[(t[r>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0))break e;t[f>>2]=t[(t[u>>2]|0)+24>>2];if((((t[(t[u>>2]|0)+4>>2]|0)!=12?(t[(t[u>>2]|0)+4>>2]|0)!=15:0)?(t[(t[u>>2]|0)+4>>2]|0)!=16:0)?(t[(t[u>>2]|0)+4>>2]|0)!=17:0){iy(t[u>>2]|0);ry(t[u>>2]|0)}t[u>>2]=t[f>>2]}}while(0);do if(t[(t[r>>2]|0)+8>>2]|0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}while(0);do if(t[(t[r>>2]|0)+56>>2]|0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+56>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0)}while(0);do if(t[(t[r>>2]|0)+52>>2]|0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+52>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0)}while(0);if(t[(t[r>>2]|0)+36>>2]|0)IM(t[(t[r>>2]|0)+36>>2]|0);if(t[(t[r>>2]|0)+40>>2]|0)OM(t[(t[r>>2]|0)+40>>2]|0);if(t[(t[r>>2]|0)+44>>2]|0)DM(t[(t[r>>2]|0)+44>>2]|0);if(t[(t[r>>2]|0)+48>>2]|0)v_(t[(t[r>>2]|0)+48>>2]|0);if(t[(t[r>>2]|0)+60>>2]|0)v_(t[(t[r>>2]|0)+60>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function iy(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+4>>2]|0)==18){s=i;return}if((t[(t[r>>2]|0)+4>>2]|0)==14?(t[n>>2]=t[(t[r>>2]|0)+32>>2],(t[n>>2]|0)!=0):0){if((t[(t[n>>2]|0)+44>>2]|0)==(t[r>>2]|0))t[(t[n>>2]|0)+44>>2]=0;if((t[(t[n>>2]|0)+48>>2]|0)==(t[r>>2]|0))t[(t[n>>2]|0)+48>>2]=0}if((t[(t[r>>2]|0)+4>>2]|0)==17?(t[f>>2]=t[(t[r>>2]|0)+32>>2],(t[f>>2]|0)!=0):0){if(t[(t[f>>2]|0)+44>>2]|0){n=rO(t[(t[(t[f>>2]|0)+44>>2]|0)+48>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0;if((n|0)==(t[r>>2]|0))kO(t[(t[(t[f>>2]|0)+44>>2]|0)+48>>2]|0,t[(t[r>>2]|0)+8>>2]|0,0)|0;n=rO(t[(t[(t[f>>2]|0)+44>>2]|0)+60>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0;if((n|0)==(t[r>>2]|0))kO(t[(t[(t[f>>2]|0)+44>>2]|0)+60>>2]|0,t[(t[r>>2]|0)+8>>2]|0,0)|0}if(t[(t[f>>2]|0)+48>>2]|0){n=rO(t[(t[(t[f>>2]|0)+48>>2]|0)+48>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0;if((n|0)==(t[r>>2]|0))kO(t[(t[(t[f>>2]|0)+48>>2]|0)+48>>2]|0,t[(t[r>>2]|0)+8>>2]|0,0)|0;n=rO(t[(t[(t[f>>2]|0)+48>>2]|0)+60>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0;if((n|0)==(t[r>>2]|0))kO(t[(t[(t[f>>2]|0)+48>>2]|0)+60>>2]|0,t[(t[r>>2]|0)+8>>2]|0,0)|0}}if(t[(t[r>>2]|0)+20>>2]|0){t[u>>2]=t[(t[r>>2]|0)+20>>2];f=t[u>>2]|0;if((t[(t[r>>2]|0)+4>>2]|0)==2){if((t[f+44>>2]|0)==(t[r>>2]|0))t[(t[u>>2]|0)+44>>2]=t[(t[r>>2]|0)+24>>2]}else{if((t[f+12>>2]|0)==(t[r>>2]|0))t[(t[u>>2]|0)+12>>2]=t[(t[r>>2]|0)+24>>2];if((t[(t[u>>2]|0)+16>>2]|0)==(t[r>>2]|0))t[(t[u>>2]|0)+16>>2]=t[(t[r>>2]|0)+28>>2]}t[(t[r>>2]|0)+20>>2]=0}if(t[(t[r>>2]|0)+24>>2]|0)t[(t[(t[r>>2]|0)+24>>2]|0)+28>>2]=t[(t[r>>2]|0)+28>>2];if(t[(t[r>>2]|0)+28>>2]|0)t[(t[(t[r>>2]|0)+28>>2]|0)+24>>2]=t[(t[r>>2]|0)+24>>2];t[(t[r>>2]|0)+28>>2]=0;t[(t[r>>2]|0)+24>>2]=0;s=i;return}function ry(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[n>>2]=0;if(!(t[r>>2]|0)){s=i;return}e=t[r>>2]|0;if((t[(t[r>>2]|0)+4>>2]|0)==14){ey(e);s=i;return}u=t[r>>2]|0;if((t[e+4>>2]|0)==18){Kg(u);s=i;return}if((t[u+4>>2]|0)==2){vy(t[r>>2]|0);s=i;return}if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[r>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+80>>2];do if((t[(t[r>>2]|0)+4>>2]|0)==17){t[f>>2]=t[r>>2];do if(t[(t[f>>2]|0)+56>>2]|0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+56>>2]|0)}while(0);if(t[(t[f>>2]|0)+52>>2]|0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[f>>2]|0)+52>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+52>>2]|0)}}while(0);if((t[(t[r>>2]|0)+12>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)!=5:0)ty(t[(t[r>>2]|0)+12>>2]|0);if(!(((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+4>>2]|0)!=19:0)?(t[(t[r>>2]|0)+4>>2]|0)!=20:0))a=27;if((a|0)==27?(t[(t[r>>2]|0)+44>>2]|0)!=0:0)dy(t[(t[r>>2]|0)+44>>2]|0);do if(((((((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+40>>2]|0)!=0:0)?(t[(t[r>>2]|0)+4>>2]|0)!=5:0)?(t[(t[r>>2]|0)+4>>2]|0)!=20:0)?(t[(t[r>>2]|0)+4>>2]|0)!=19:0)?(t[(t[r>>2]|0)+40>>2]|0)!=((t[r>>2]|0)+44|0):0)?(t[(t[r>>2]|0)+40>>2]|0)!=0:0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+40>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0)}while(0);do if((((t[(t[r>>2]|0)+8>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)!=3:0)?(t[(t[r>>2]|0)+4>>2]|0)!=8:0)?(t[(t[r>>2]|0)+8>>2]|0)!=0:0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}while(0);if(!(((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+4>>2]|0)!=19:0)?(t[(t[r>>2]|0)+4>>2]|0)!=20:0))a=49;if((a|0)==49?(t[(t[r>>2]|0)+48>>2]|0)!=0:0)Zg(t[(t[r>>2]|0)+48>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function ny(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[n>>2]=(t[n>>2]|0)==0?75288:e;t[f>>2]=gAi[t[135744>>2]&511](96)|0;if(!(t[f>>2]|0)){LF(75296);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+96|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=9;e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+56>>2]=e;if(!(t[(t[f>>2]|0)+56>>2]|0)){LF(75296);pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[(t[f>>2]|0)+40>>2]=-1;t[(t[f>>2]|0)+36>>2]=-1;t[(t[f>>2]|0)+32>>2]=t[f>>2];t[(t[f>>2]|0)+88>>2]=0;t[(t[f>>2]|0)+92>>2]=32;t[(t[f>>2]|0)+76>>2]=1;if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[f>>2]|0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function fy(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[r>>2]=e;t[u>>2]=0;if(!(t[r>>2]|0)){s=i;return}if(t[r>>2]|0)t[u>>2]=t[(t[r>>2]|0)+80>>2];if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[r>>2]|0);if(t[(t[r>>2]|0)+64>>2]|0)jM(t[(t[r>>2]|0)+64>>2]|0);t[(t[r>>2]|0)+64>>2]=0;if(t[(t[r>>2]|0)+68>>2]|0)KM(t[(t[r>>2]|0)+68>>2]|0);t[(t[r>>2]|0)+68>>2]=0;t[n>>2]=t[(t[r>>2]|0)+48>>2];t[f>>2]=t[(t[r>>2]|0)+44>>2];if((t[f>>2]|0)==(t[n>>2]|0))t[n>>2]=0;if(t[n>>2]|0){iy(t[(t[r>>2]|0)+48>>2]|0);t[(t[r>>2]|0)+48>>2]=0;ey(t[n>>2]|0)}if(t[f>>2]|0){iy(t[(t[r>>2]|0)+44>>2]|0);t[(t[r>>2]|0)+44>>2]=0;ey(t[f>>2]|0)}if(t[(t[r>>2]|0)+12>>2]|0)ty(t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)Zg(t[(t[r>>2]|0)+52>>2]|0);do if(t[(t[r>>2]|0)+56>>2]|0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[r>>2]|0)+56>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0)}while(0);do if(t[(t[r>>2]|0)+8>>2]|0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}while(0);do if(t[(t[r>>2]|0)+60>>2]|0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[r>>2]|0)+60>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+60>>2]|0)}while(0);do if(t[(t[r>>2]|0)+72>>2]|0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[r>>2]|0)+72>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+72>>2]|0)}while(0);pAi[t[135736>>2]&511](t[r>>2]|0);if(!(t[u>>2]|0)){s=i;return}bz(t[u>>2]|0);s=i;return}function ty(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[f>>2]=0;if(!(t[r>>2]|0)){s=i;return}e=t[r>>2]|0;if((t[(t[r>>2]|0)+4>>2]|0)==18){Zg(e);s=i;return}if(((t[e+4>>2]|0)!=9?(t[(t[r>>2]|0)+4>>2]|0)!=21:0)?(t[(t[r>>2]|0)+4>>2]|0)!=13:0){if(t[(t[r>>2]|0)+32>>2]|0)t[f>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+80>>2];while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[(t[r>>2]|0)+24>>2];if((t[(t[r>>2]|0)+4>>2]|0)!=14){if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[r>>2]|0);if((t[(t[r>>2]|0)+12>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)!=5:0)ty(t[(t[r>>2]|0)+12>>2]|0);if(!(((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+4>>2]|0)!=19:0)?(t[(t[r>>2]|0)+4>>2]|0)!=20:0))u=20;if((u|0)==20?(u=0,(t[(t[r>>2]|0)+44>>2]|0)!=0):0)dy(t[(t[r>>2]|0)+44>>2]|0);do if(((((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+4>>2]|0)!=19:0)?(t[(t[r>>2]|0)+4>>2]|0)!=20:0)?(t[(t[r>>2]|0)+4>>2]|0)!=5:0)?(t[(t[r>>2]|0)+40>>2]|0)!=((t[r>>2]|0)+44|0):0){if(!(t[(t[r>>2]|0)+40>>2]|0))break;if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+40>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0)}while(0);if(!(((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+4>>2]|0)!=19:0)?(t[(t[r>>2]|0)+4>>2]|0)!=20:0))u=34;if((u|0)==34?(u=0,(t[(t[r>>2]|0)+48>>2]|0)!=0):0)Zg(t[(t[r>>2]|0)+48>>2]|0);do if(((t[(t[r>>2]|0)+8>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)!=3:0)?(t[(t[r>>2]|0)+4>>2]|0)!=8:0){if(!(t[(t[r>>2]|0)+8>>2]|0))break;if((t[f>>2]|0)!=0?(wz(t[f>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}while(0);pAi[t[135736>>2]&511](t[r>>2]|0)}t[r>>2]=t[n>>2]}s=i;return}fy(t[r>>2]|0);s=i;return}function uy(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;f=s;s=s+80|0;a=f+60|0;o=f+56|0;c=f+52|0;l=f+48|0;b=f+44|0;k=f+40|0;
	h=f+36|0;w=f+32|0;d=f+28|0;v=f+24|0;m=f+20|0;_=f+16|0;p=f+12|0;E=f+8|0;S=f+74|0;g=f+4|0;y=f+64|0;F=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=0;t[k>>2]=0;t[d>>2]=t[c>>2];t[v>>2]=(t[d>>2]|0)+(t[l>>2]|0);if(!(t[c>>2]|0)){t[a>>2]=0;O=t[a>>2]|0;s=f;return O|0}t[p>>2]=vs(0)|0;if(!(t[p>>2]|0)){t[a>>2]=0;O=t[a>>2]|0;s=f;return O|0}Es(t[p>>2]|0,4)|0;t[m>>2]=t[d>>2];e:while(1){if((t[d>>2]|0)>>>0<(t[v>>2]|0)>>>0)A=(u[t[d>>2]>>0]|0|0)!=0;else A=0;M=t[d>>2]|0;if(!A){R=87;break}if((u[M>>0]|0|0)!=38){t[d>>2]=(t[d>>2]|0)+1;continue}t[E>>2]=0;if((t[d>>2]|0)!=(t[m>>2]|0)?(Ps(t[p>>2]|0,t[m>>2]|0,(t[d>>2]|0)-(t[m>>2]|0)|0)|0)!=0:0)break;t[m>>2]=t[d>>2];if((((t[d>>2]|0)+2|0)>>>0<(t[v>>2]|0)>>>0?(u[(t[d>>2]|0)+1>>0]|0|0)==35:0)?(u[(t[d>>2]|0)+2>>0]|0|0)==120:0){t[d>>2]=(t[d>>2]|0)+3;if((t[d>>2]|0)>>>0<(t[v>>2]|0)>>>0)n[S>>0]=n[t[d>>2]>>0]|0;else n[S>>0]=0;i:while(1){if((u[S>>0]|0|0)==59)break;if((u[S>>0]|0|0)>=48?(u[S>>0]|0|0)<=57:0)t[E>>2]=(t[E>>2]<<4)+((u[S>>0]|0)-48);else R=22;do if((R|0)==22){R=0;if((u[S>>0]|0|0)>=97?(u[S>>0]|0|0)<=102:0){t[E>>2]=(t[E>>2]<<4)+((u[S>>0]|0)-97)+10;break}if((u[S>>0]|0|0)<65){R=28;break i}if((u[S>>0]|0|0)>70){R=28;break i}t[E>>2]=(t[E>>2]<<4)+((u[S>>0]|0)-65)+10}while(0);t[d>>2]=(t[d>>2]|0)+1;if((t[d>>2]|0)>>>0<(t[v>>2]|0)>>>0){n[S>>0]=n[t[d>>2]>>0]|0;continue}else{n[S>>0]=0;continue}}if((R|0)==28){R=0;DF(1300,t[o>>2]|0,0);t[E>>2]=0}if((u[S>>0]|0|0)==59)t[d>>2]=(t[d>>2]|0)+1;t[m>>2]=t[d>>2]}else R=35;do if((R|0)==35){R=0;if(((t[d>>2]|0)+1|0)>>>0<(t[v>>2]|0)>>>0?(u[(t[d>>2]|0)+1>>0]|0|0)==35:0){t[d>>2]=(t[d>>2]|0)+2;if((t[d>>2]|0)>>>0<(t[v>>2]|0)>>>0)n[S>>0]=n[t[d>>2]>>0]|0;else n[S>>0]=0;while(1){if((u[S>>0]|0|0)==59)break;if((u[S>>0]|0|0)<48){R=44;break}if((u[S>>0]|0|0)>57){R=44;break}t[E>>2]=((t[E>>2]|0)*10|0)+((u[S>>0]|0)-48);t[d>>2]=(t[d>>2]|0)+1;if((t[d>>2]|0)>>>0<(t[v>>2]|0)>>>0){n[S>>0]=n[t[d>>2]>>0]|0;continue}else{n[S>>0]=0;continue}}if((R|0)==44){R=0;DF(1301,t[o>>2]|0,0);t[E>>2]=0}if((u[S>>0]|0|0)==59)t[d>>2]=(t[d>>2]|0)+1;t[m>>2]=t[d>>2];break}t[d>>2]=(t[d>>2]|0)+1;t[m>>2]=t[d>>2];while(1){if((t[d>>2]|0)>>>0<(t[v>>2]|0)>>>0?(u[t[d>>2]>>0]|0|0)!=0:0)N=(u[t[d>>2]>>0]|0|0)!=59;else N=0;T=t[d>>2]|0;if(!N)break;t[d>>2]=T+1}if(T>>>0>=(t[v>>2]|0)>>>0){R=58;break e}if(!(u[t[d>>2]>>0]|0)){R=58;break e}if((t[d>>2]|0)!=(t[m>>2]|0)){t[w>>2]=ql(t[m>>2]|0,(t[d>>2]|0)-(t[m>>2]|0)|0)|0;t[_>>2]=h_(t[o>>2]|0,t[w>>2]|0)|0;if((t[_>>2]|0)!=0?(t[(t[_>>2]|0)+48>>2]|0)==6:0){if(Is(t[p>>2]|0,t[(t[_>>2]|0)+40>>2]|0)|0)break e}else R=63;do if((R|0)==63){R=0;do if(!(Ds(t[p>>2]|0)|0)){t[h>>2]=ay(t[o>>2]|0,0)|0;if(!(t[h>>2]|0)){R=65;break e}c=ms(t[p>>2]|0)|0;t[(t[h>>2]|0)+40>>2]=c;if(!(t[k>>2]|0)){c=t[h>>2]|0;t[b>>2]=c;t[k>>2]=c;break}else{t[k>>2]=oy(t[k>>2]|0,t[h>>2]|0)|0;break}}while(0);t[h>>2]=cy(t[o>>2]|0,t[w>>2]|0)|0;if(!(t[h>>2]|0)){R=71;break e}i:do if(t[_>>2]|0){if(t[(t[_>>2]|0)+12>>2]|0)break;c=ly(t[o>>2]|0,t[(t[h>>2]|0)+40>>2]|0)|0;t[(t[_>>2]|0)+12>>2]=c;t[(t[_>>2]|0)+68>>2]=1;t[g>>2]=t[(t[_>>2]|0)+12>>2];while(1){if(!(t[g>>2]|0))break i;t[(t[g>>2]|0)+20>>2]=t[_>>2];t[(t[_>>2]|0)+16>>2]=t[g>>2];t[g>>2]=t[(t[g>>2]|0)+24>>2]}}while(0);if(!(t[k>>2]|0)){c=t[h>>2]|0;t[b>>2]=c;t[k>>2]=c;break}else{t[k>>2]=oy(t[k>>2]|0,t[h>>2]|0)|0;break}}while(0);pAi[t[135736>>2]&511](t[w>>2]|0)}t[d>>2]=(t[d>>2]|0)+1;t[m>>2]=t[d>>2]}while(0);if(!(t[E>>2]|0))continue;t[F>>2]=Rp(y,t[E>>2]|0)|0;n[y+(t[F>>2]|0)>>0]=0;if(Is(t[p>>2]|0,y)|0)break;t[E>>2]=0}do if((R|0)==58)DF(1302,t[o>>2]|0,t[m>>2]|0);else if((R|0)==65){if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0)}else if((R|0)==71){if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0)}else if((R|0)==87){if((M|0)!=(t[m>>2]|0)?(Ps(t[p>>2]|0,t[m>>2]|0,(t[d>>2]|0)-(t[m>>2]|0)|0)|0)!=0:0)break;if(Ds(t[p>>2]|0)|0){if(t[b>>2]|0)break;t[b>>2]=ay(t[o>>2]|0,75312)|0;break}t[h>>2]=ay(t[o>>2]|0,0)|0;if(t[h>>2]|0){E=ms(t[p>>2]|0)|0;t[(t[h>>2]|0)+40>>2]=E;if(!(t[k>>2]|0)){E=t[h>>2]|0;t[b>>2]=E;t[k>>2]=E;break}else{t[k>>2]=oy(t[k>>2]|0,t[h>>2]|0)|0;break}}}while(0);Ss(t[p>>2]|0);t[a>>2]=t[b>>2];O=t[a>>2]|0;s=f;return O|0}function ay(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=yy(t[f>>2]|0)|0;if(!(t[u>>2]|0)){a=t[u>>2]|0;s=r;return a|0}t[(t[u>>2]|0)+32>>2]=t[n>>2];a=t[u>>2]|0;s=r;return a|0}function oy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}iy(t[u>>2]|0);if((t[(t[u>>2]|0)+4>>2]|0)==3){i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==3){Dy(i,t[(t[u>>2]|0)+40>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[f>>2];o=t[n>>2]|0;s=r;return o|0}if(((t[i+24>>2]|0)!=0?(t[(t[(t[f>>2]|0)+24>>2]|0)+4>>2]|0)==3:0)?(t[(t[f>>2]|0)+8>>2]|0)==(t[(t[(t[f>>2]|0)+24>>2]|0)+8>>2]|0):0){t[a>>2]=Yl(t[(t[u>>2]|0)+40>>2]|0)|0;t[a>>2]=us(t[a>>2]|0,t[(t[(t[f>>2]|0)+24>>2]|0)+40>>2]|0)|0;Cy(t[(t[f>>2]|0)+24>>2]|0,t[a>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[(t[f>>2]|0)+24>>2];o=t[n>>2]|0;s=r;return o|0}}else if((t[(t[u>>2]|0)+4>>2]|0)==2){t[n>>2]=CF(t[f>>2]|0,t[f>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+32>>2]|0)!=(t[(t[f>>2]|0)+32>>2]|0))Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);t[(t[u>>2]|0)+20>>2]=t[(t[f>>2]|0)+20>>2];t[(t[u>>2]|0)+28>>2]=t[f>>2];t[(t[u>>2]|0)+24>>2]=t[(t[f>>2]|0)+24>>2];t[(t[f>>2]|0)+24>>2]=t[u>>2];if(t[(t[u>>2]|0)+24>>2]|0)t[(t[(t[u>>2]|0)+24>>2]|0)+28>>2]=t[u>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=0?(t[(t[(t[u>>2]|0)+20>>2]|0)+16>>2]|0)==(t[f>>2]|0):0)t[(t[(t[u>>2]|0)+20>>2]|0)+16>>2]=t[u>>2];t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function cy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[o>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[o>>2]|0)){LF(75424);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}i=(t[o>>2]|0)+0|0;e=i+60|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[o>>2]|0)+4>>2]=5;t[(t[o>>2]|0)+32>>2]=t[f>>2];i=t[a>>2]|0;do if((u[t[a>>2]>>0]|0|0)==38){t[a>>2]=i+1;t[l>>2]=rs(t[a>>2]|0)|0;e=t[a>>2]|0;k=t[l>>2]|0;if((u[(t[a>>2]|0)+((t[l>>2]|0)-1)>>0]|0|0)==59){h=ql(e,k-1|0)|0;t[(t[o>>2]|0)+8>>2]=h;break}else{h=ql(e,k)|0;t[(t[o>>2]|0)+8>>2]=h;break}}else{h=Yl(i)|0;t[(t[o>>2]|0)+8>>2]=h}while(0);t[c>>2]=h_(t[f>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0;if(t[c>>2]|0){t[(t[o>>2]|0)+40>>2]=t[(t[c>>2]|0)+40>>2];t[(t[o>>2]|0)+12>>2]=t[c>>2];t[(t[o>>2]|0)+16>>2]=t[c>>2]}if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[o>>2]|0);t[n>>2]=t[o>>2];b=t[n>>2]|0;s=r;return b|0}function ly(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;r=s;s=s+80|0;f=r+52|0;a=r+48|0;o=r+44|0;c=r+40|0;l=r+36|0;b=r+32|0;k=r+28|0;h=r+24|0;w=r+20|0;d=r+16|0;v=r+12|0;m=r+8|0;_=r+66|0;p=r+4|0;E=r+56|0;S=r;t[a>>2]=e;t[o>>2]=i;t[c>>2]=0;t[l>>2]=0;t[h>>2]=t[o>>2];if(!(t[o>>2]|0)){t[f>>2]=0;g=t[f>>2]|0;s=r;return g|0}t[v>>2]=vs(0)|0;if(!(t[v>>2]|0)){t[f>>2]=0;g=t[f>>2]|0;s=r;return g|0}Es(t[v>>2]|0,4)|0;t[w>>2]=t[h>>2];e:while(1){y=t[h>>2]|0;if(!(u[t[h>>2]>>0]|0)){F=70;break}if((u[y>>0]|0|0)!=38){t[h>>2]=(t[h>>2]|0)+1;continue}t[m>>2]=0;if((t[h>>2]|0)!=(t[w>>2]|0)?(Ps(t[v>>2]|0,t[w>>2]|0,(t[h>>2]|0)-(t[w>>2]|0)|0)|0)!=0:0)break;t[w>>2]=t[h>>2];if((u[(t[h>>2]|0)+1>>0]|0|0)==35?(u[(t[h>>2]|0)+2>>0]|0|0)==120:0){t[h>>2]=(t[h>>2]|0)+3;n[_>>0]=n[t[h>>2]>>0]|0;i:while(1){if((u[_>>0]|0|0)==59)break;if((u[_>>0]|0|0)>=48?(u[_>>0]|0|0)<=57:0)t[m>>2]=(t[m>>2]<<4)+((u[_>>0]|0)-48);else F=17;do if((F|0)==17){F=0;if((u[_>>0]|0|0)>=97?(u[_>>0]|0|0)<=102:0){t[m>>2]=(t[m>>2]<<4)+((u[_>>0]|0)-97)+10;break}if((u[_>>0]|0|0)<65){F=23;break i}if((u[_>>0]|0|0)>70){F=23;break i}t[m>>2]=(t[m>>2]<<4)+((u[_>>0]|0)-65)+10}while(0);t[h>>2]=(t[h>>2]|0)+1;n[_>>0]=n[t[h>>2]>>0]|0}if((F|0)==23){F=0;DF(1300,t[a>>2]|0,0);t[m>>2]=0}if((u[_>>0]|0|0)==59)t[h>>2]=(t[h>>2]|0)+1;t[w>>2]=t[h>>2]}else F=28;do if((F|0)==28){F=0;o=t[h>>2]|0;if((u[(t[h>>2]|0)+1>>0]|0|0)==35){t[h>>2]=o+2;n[_>>0]=n[t[h>>2]>>0]|0;while(1){if((u[_>>0]|0|0)==59)break;if((u[_>>0]|0|0)<48){F=34;break}if((u[_>>0]|0|0)>57){F=34;break}t[m>>2]=((t[m>>2]|0)*10|0)+((u[_>>0]|0)-48);t[h>>2]=(t[h>>2]|0)+1;n[_>>0]=n[t[h>>2]>>0]|0}if((F|0)==34){F=0;DF(1301,t[a>>2]|0,0);t[m>>2]=0}if((u[_>>0]|0|0)==59)t[h>>2]=(t[h>>2]|0)+1;t[w>>2]=t[h>>2];break}t[h>>2]=o+1;t[w>>2]=t[h>>2];while(1){if(u[t[h>>2]>>0]|0)O=(u[t[h>>2]>>0]|0|0)!=59;else O=0;A=t[h>>2]|0;if(!O)break;t[h>>2]=A+1}if(!(u[A>>0]|0)){F=44;break e}if((t[h>>2]|0)!=(t[w>>2]|0)){t[k>>2]=ql(t[w>>2]|0,(t[h>>2]|0)-(t[w>>2]|0)|0)|0;t[d>>2]=h_(t[a>>2]|0,t[k>>2]|0)|0;if((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+48>>2]|0)==6:0){if(Is(t[v>>2]|0,t[(t[d>>2]|0)+40>>2]|0)|0)break e}else F=49;do if((F|0)==49){F=0;do if(!(Ds(t[v>>2]|0)|0)){t[b>>2]=ay(t[a>>2]|0,0)|0;o=ms(t[v>>2]|0)|0;t[(t[b>>2]|0)+40>>2]=o;if(!(t[l>>2]|0)){o=t[b>>2]|0;t[c>>2]=o;t[l>>2]=o;break}else{t[l>>2]=oy(t[l>>2]|0,t[b>>2]|0)|0;break}}while(0);t[b>>2]=cy(t[a>>2]|0,t[k>>2]|0)|0;if(!(t[b>>2]|0)){F=54;break e}i:do if((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+12>>2]|0)==0:0){o=ly(t[a>>2]|0,t[(t[b>>2]|0)+40>>2]|0)|0;t[(t[d>>2]|0)+12>>2]=o;t[(t[d>>2]|0)+68>>2]=1;t[p>>2]=t[(t[d>>2]|0)+12>>2];while(1){if(!(t[p>>2]|0))break i;t[(t[p>>2]|0)+20>>2]=t[d>>2];t[p>>2]=t[(t[p>>2]|0)+24>>2]}}while(0);if(!(t[l>>2]|0)){o=t[b>>2]|0;t[c>>2]=o;t[l>>2]=o;break}else{t[l>>2]=oy(t[l>>2]|0,t[b>>2]|0)|0;break}}while(0);pAi[t[135736>>2]&511](t[k>>2]|0)}t[h>>2]=(t[h>>2]|0)+1;t[w>>2]=t[h>>2]}while(0);if(!(t[m>>2]|0))continue;t[S>>2]=Rp(E,t[m>>2]|0)|0;n[E+(t[S>>2]|0)>>0]=0;if(Is(t[v>>2]|0,E)|0)break;t[m>>2]=0}do if((F|0)==44)DF(1302,t[a>>2]|0,t[w>>2]|0);else if((F|0)==54){if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0)}else if((F|0)==70){if((t[c>>2]|0)==0?1:(y|0)!=(t[w>>2]|0))Ps(t[v>>2]|0,t[w>>2]|0,(t[h>>2]|0)-(t[w>>2]|0)|0)|0;if(!(Ds(t[v>>2]|0)|0)){t[b>>2]=ay(t[a>>2]|0,0)|0;m=ms(t[v>>2]|0)|0;t[(t[b>>2]|0)+40>>2]=m;if(!(t[l>>2]|0)){m=t[b>>2]|0;t[c>>2]=m;t[l>>2]=m;break}else{t[l>>2]=oy(t[l>>2]|0,t[b>>2]|0)|0;break}}}while(0);Ss(t[v>>2]|0);t[f>>2]=t[c>>2];g=t[f>>2]|0;s=r;return g|0}function sy(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f+36|0;a=f+32|0;o=f+28|0;c=f+24|0;l=f+20|0;b=f+16|0;k=f+12|0;h=f+8|0;w=f+4|0;d=f;v=f+40|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=t[o>>2];t[b>>2]=0;if(!(t[o>>2]|0)){t[u>>2]=0;m=t[u>>2]|0;s=f;return m|0}if((t[(t[o>>2]|0)+20>>2]|0)!=0?(t[(t[(t[o>>2]|0)+20>>2]|0)+4>>2]|0)==2:0)t[h>>2]=1;else t[h>>2]=0;while(1){if(!(t[l>>2]|0))break;do if((t[(t[l>>2]|0)+4>>2]|0)!=3?(t[(t[l>>2]|0)+4>>2]|0)!=4:0){if((t[(t[l>>2]|0)+4>>2]|0)==5){if(!(t[c>>2]|0)){n[v>>0]=38;n[v+1>>0]=0;t[b>>2]=fs(t[b>>2]|0,v,1)|0;t[b>>2]=us(t[b>>2]|0,t[(t[l>>2]|0)+8>>2]|0)|0;n[v>>0]=59;n[v+1>>0]=0;t[b>>2]=fs(t[b>>2]|0,v,1)|0;break}t[k>>2]=h_(t[a>>2]|0,t[(t[l>>2]|0)+8>>2]|0)|0;if(!(t[k>>2]|0)){t[b>>2]=us(t[b>>2]|0,t[(t[l>>2]|0)+40>>2]|0)|0;break}t[d>>2]=sy(t[a>>2]|0,t[(t[k>>2]|0)+12>>2]|0,1)|0;if(t[d>>2]|0){t[b>>2]=us(t[b>>2]|0,t[d>>2]|0)|0;pAi[t[135736>>2]&511](t[d>>2]|0)}}}else _=10;while(0);do if((_|0)==10){_=0;if(t[c>>2]|0){t[b>>2]=us(t[b>>2]|0,t[(t[l>>2]|0)+40>>2]|0)|0;break}o=t[a>>2]|0;r=t[(t[l>>2]|0)+40>>2]|0;if(t[h>>2]|0)t[w>>2]=w_(o,r)|0;else t[w>>2]=d_(o,r)|0;if(t[w>>2]|0){t[b>>2]=us(t[b>>2]|0,t[w>>2]|0)|0;pAi[t[135736>>2]&511](t[w>>2]|0)}}while(0);t[l>>2]=t[(t[l>>2]|0)+24>>2]}t[u>>2]=t[b>>2];m=t[u>>2]|0;s=f;return m|0}function by(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[a>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=PF(t[u>>2]|0,0,t[a>>2]|0,t[o>>2]|0,0)|0;c=t[f>>2]|0;s=n;return c|0}return 0}function ky(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[c>>2]|0)){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=PF(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,0)|0;b=t[u>>2]|0;s=f;return b|0}return 0}function hy(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[c>>2]|0)){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=PF(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,1)|0;b=t[u>>2]|0;s=f;return b|0}return 0}function wy(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[a>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[c>>2]|0)){LF(75320);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}r=(t[c>>2]|0)+0|0;i=r+48|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[c>>2]|0)+4>>2]=2;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+80>>2]|0)!=0:0){r=kz(t[(t[u>>2]|0)+80>>2]|0,t[a>>2]|0,-1)|0;t[(t[c>>2]|0)+8>>2]=r}else{r=Yl(t[a>>2]|0)|0;t[(t[c>>2]|0)+8>>2]=r}t[(t[c>>2]|0)+32>>2]=t[u>>2];e:do if(t[o>>2]|0){r=ly(t[u>>2]|0,t[o>>2]|0)|0;t[(t[c>>2]|0)+12>>2]=r;t[(t[c>>2]|0)+16>>2]=0;t[l>>2]=t[(t[c>>2]|0)+12>>2];while(1){if(!(t[l>>2]|0))break e;t[(t[l>>2]|0)+20>>2]=t[c>>2];if(!(t[(t[l>>2]|0)+24>>2]|0))t[(t[c>>2]|0)+16>>2]=t[l>>2];t[l>>2]=t[(t[l>>2]|0)+24>>2]}}while(0);if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[c>>2]|0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function dy(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!((t[r>>2]|0)!=0&(t[r>>2]|0)!=0)){s=i;return}do{t[n>>2]=t[(t[r>>2]|0)+24>>2];vy(t[r>>2]|0);t[r>>2]=t[n>>2]}while((t[r>>2]|0)!=0);s=i;return}function vy(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+80>>2];if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[r>>2]|0);if((t[(t[r>>2]|0)+32>>2]|0)!=0?(t[(t[r>>2]|0)+40>>2]|0)==2:0)YM(t[(t[r>>2]|0)+32>>2]|0,t[r>>2]|0)|0;if(t[(t[r>>2]|0)+12>>2]|0)ty(t[(t[r>>2]|0)+12>>2]|0);do if(t[(t[r>>2]|0)+8>>2]|0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0)}while(0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function my(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}if(!(t[(t[n>>2]|0)+20>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+44>>2];if((t[f>>2]|0)==(t[n>>2]|0)){t[(t[(t[n>>2]|0)+20>>2]|0)+44>>2]=t[(t[n>>2]|0)+24>>2];if(t[(t[n>>2]|0)+24>>2]|0)t[(t[(t[n>>2]|0)+24>>2]|0)+28>>2]=0;vy(t[n>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}while(1){if(!(t[f>>2]|0)){a=15;break}if((t[(t[f>>2]|0)+24>>2]|0)==(t[n>>2]|0))break;t[f>>2]=t[(t[f>>2]|0)+24>>2]}if((a|0)==15){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[f>>2]|0)+24>>2]=t[(t[n>>2]|0)+24>>2];if(t[(t[f>>2]|0)+24>>2]|0)t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]=t[f>>2];vy(t[n>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function _y(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[c>>2]|0)){LF(75344);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=(t[c>>2]|0)+0|0;i=r+60|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[c>>2]|0)+4>>2]=7;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+80>>2]|0)!=0:0){r=kz(t[(t[u>>2]|0)+80>>2]|0,t[a>>2]|0,-1)|0;t[(t[c>>2]|0)+8>>2]=r}else{r=Yl(t[a>>2]|0)|0;t[(t[c>>2]|0)+8>>2]=r}if(t[o>>2]|0){r=Yl(t[o>>2]|0)|0;t[(t[c>>2]|0)+40>>2]=r}t[(t[c>>2]|0)+32>>2]=t[u>>2];if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[c>>2]|0);t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function py(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[a>>2]|0)){LF(75360);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+60|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[a>>2]|0)+4>>2]=1;i=Yl(t[u>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=i;t[(t[a>>2]|0)+36>>2]=t[f>>2];if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[a>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Ey(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[a>>2]|0)){LF(75360);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+60|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[a>>2]|0)+4>>2]=1;t[(t[a>>2]|0)+8>>2]=t[u>>2];t[(t[a>>2]|0)+36>>2]=t[f>>2];if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[a>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Sy(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+80>>2]|0)!=0:0){n=t[a>>2]|0;t[l>>2]=Ey(n,kz(t[(t[u>>2]|0)+80>>2]|0,t[o>>2]|0,-1)|0)|0}else t[l>>2]=py(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){k=t[l>>2]|0;s=f;return k|0}t[(t[l>>2]|0)+32>>2]=t[u>>2];if(!(t[c>>2]|0)){k=t[l>>2]|0;s=f;return k|0}o=ly(t[u>>2]|0,t[c>>2]|0)|0;t[(t[l>>2]|0)+12>>2]=o;if(!(t[l>>2]|0)){k=t[l>>2]|0;s=f;return k|0}t[b>>2]=t[(t[l>>2]|0)+12>>2];if(!(t[b>>2]|0)){t[(t[l>>2]|0)+16>>2]=0;k=t[l>>2]|0;s=f;return k|0}while(1){o=(t[(t[b>>2]|0)+24>>2]|0)!=0;t[(t[b>>2]|0)+20>>2]=t[l>>2];h=t[b>>2]|0;if(!o)break;t[b>>2]=t[h+24>>2]}t[(t[l>>2]|0)+16>>2]=h;k=t[l>>2]|0;s=f;return k|0}function gy(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=Ey(t[a>>2]|0,t[o>>2]|0)|0;do if(t[l>>2]|0){t[(t[l>>2]|0)+32>>2]=t[u>>2];if((t[c>>2]|0)!=0?(a=ly(t[u>>2]|0,t[c>>2]|0)|0,t[(t[l>>2]|0)+12>>2]=a,(t[l>>2]|0)!=0):0){t[b>>2]=t[(t[l>>2]|0)+12>>2];if(!(t[b>>2]|0)){t[(t[l>>2]|0)+16>>2]=0;break}while(1){a=(t[(t[b>>2]|0)+24>>2]|0)!=0;t[(t[b>>2]|0)+20>>2]=t[l>>2];k=t[b>>2]|0;if(!a)break;t[b>>2]=t[k+24>>2]}t[(t[l>>2]|0)+16>>2]=k}}else if((t[o>>2]|0)!=0&(t[u>>2]|0)!=0?(wz(t[(t[u>>2]|0)+80>>2]|0,t[o>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[o>>2]|0);while(0);s=f;return t[l>>2]|0}function yy(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[f>>2]|0)){LF(75376);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+60|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=3;t[(t[f>>2]|0)+8>>2]=75104;if(t[n>>2]|0){e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=e}if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[f>>2]|0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Fy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[o>>2]|0)){LF(75392);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}i=(t[o>>2]|0)+0|0;e=i+60|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[o>>2]|0)+4>>2]=5;t[(t[o>>2]|0)+32>>2]=t[f>>2];f=t[a>>2]|0;do if((u[t[a>>2]>>0]|0|0)==38){t[a>>2]=f+1;t[c>>2]=rs(t[a>>2]|0)|0;i=t[a>>2]|0;e=t[c>>2]|0;if((u[(t[a>>2]|0)+((t[c>>2]|0)-1)>>0]|0|0)==59){b=ql(i,e-1|0)|0;t[(t[o>>2]|0)+8>>2]=b;break}else{b=ql(i,e)|0;t[(t[o>>2]|0)+8>>2]=b;break}}else{b=Yl(f)|0;t[(t[o>>2]|0)+8>>2]=b}while(0);if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[o>>2]|0);t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}function Oy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[a>>2]|0)){LF(75376);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+60|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[(t[a>>2]|0)+4>>2]=3;t[(t[a>>2]|0)+8>>2]=75104;if(t[f>>2]|0){i=ql(t[f>>2]|0,t[u>>2]|0)|0;t[(t[a>>2]|0)+40>>2]=i}if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[a>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Ay(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[f>>2]|0)){LF(75448);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+60|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=8;t[(t[f>>2]|0)+8>>2]=75128;if(t[n>>2]|0){e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=e}if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[f>>2]|0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function My(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[c>>2]|0)){LF(75472);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=(t[c>>2]|0)+0|0;i=r+60|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[c>>2]|0)+4>>2]=4;t[(t[c>>2]|0)+32>>2]=t[u>>2];if(t[a>>2]|0){u=ql(t[a>>2]|0,t[o>>2]|0)|0;t[(t[c>>2]|0)+40>>2]=u}if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[c>>2]|0);t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function Ry(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=Ay(t[f>>2]|0)|0;if(!(t[u>>2]|0)){a=t[u>>2]|0;s=r;return a|0}t[(t[u>>2]|0)+32>>2]=t[n>>2];a=t[u>>2]|0;s=r;return a|0}function Ny(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+4>>2]|0)==18){s=r;return}if((t[(t[n>>2]|0)+32>>2]|0)==(t[f>>2]|0)){s=r;return}e:do if((t[(t[n>>2]|0)+4>>2]|0)==1){t[u>>2]=t[(t[n>>2]|0)+44>>2];while(1){if(!(t[u>>2]|0))break e;t[(t[u>>2]|0)+32>>2]=t[f>>2];Ty(t[(t[u>>2]|0)+12>>2]|0,t[f>>2]|0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}}while(0);if(t[(t[n>>2]|0)+12>>2]|0)Ty(t[(t[n>>2]|0)+12>>2]|0,t[f>>2]|0);t[(t[n>>2]|0)+32>>2]=t[f>>2];s=r;return}function Ty(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+4>>2]|0)==18){s=r;return}t[u>>2]=t[n>>2];while(1){if(!(t[u>>2]|0))break;if((t[(t[u>>2]|0)+32>>2]|0)!=(t[f>>2]|0))Ny(t[u>>2]|0,t[f>>2]|0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}s=r;return}function Ly(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(!(t[c>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}do if((t[(t[a>>2]|0)+4>>2]|0)==1){n=t[(t[a>>2]|0)+32>>2]|0;if(!(t[o>>2]|0)){t[b>>2]=Sy(n,t[(t[a>>2]|0)+36>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;break}else{t[b>>2]=Sy(n,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;break}}else{if((t[(t[a>>2]|0)+4>>2]|0)!=9?(t[(t[a>>2]|0)+4>>2]|0)!=13:0){if((t[(t[a>>2]|0)+4>>2]|0)==11){t[b>>2]=Sy(t[(t[a>>2]|0)+32>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;break}t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}n=t[a>>2]|0;if(!(t[o>>2]|0)){t[b>>2]=Sy(n,0,t[c>>2]|0,t[l>>2]|0)|0;break}else{t[b>>2]=Sy(n,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;break}}while(0);if(!(t[b>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}t[(t[b>>2]|0)+4>>2]=1;t[(t[b>>2]|0)+20>>2]=t[a>>2];t[(t[b>>2]|0)+32>>2]=t[(t[a>>2]|0)+32>>2];if(!(t[(t[a>>2]|0)+12>>2]|0)){t[(t[a>>2]|0)+12>>2]=t[b>>2];t[(t[a>>2]|0)+16>>2]=t[b>>2]}else{t[k>>2]=t[(t[a>>2]|0)+16>>2];t[(t[k>>2]|0)+24>>2]=t[b>>2];t[(t[b>>2]|0)+28>>2]=t[k>>2];t[(t[a>>2]|0)+16>>2]=t[b>>2]}t[u>>2]=t[b>>2];h=t[u>>2]|0;s=f;return h|0}function Dy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}t[u>>2]=rs(t[f>>2]|0)|0;bF(t[n>>2]|0,t[f>>2]|0,t[u>>2]|0);s=r;return}function Cy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}switch(t[(t[n>>2]|0)+4>>2]|0){case 8:case 7:case 6:case 5:case 4:case 3:{do if((t[(t[n>>2]|0)+40>>2]|0)!=0?(t[(t[n>>2]|0)+40>>2]|0)!=((t[n>>2]|0)+44|0):0){if(((t[(t[n>>2]|0)+32>>2]|0)!=0?(t[(t[(t[n>>2]|0)+32>>2]|0)+80>>2]|0)!=0:0)?(wz(t[(t[(t[n>>2]|0)+32>>2]|0)+80>>2]|0,t[(t[n>>2]|0)+40>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[n>>2]|0)+40>>2]|0)}while(0);if(t[(t[n>>2]|0)+12>>2]|0)ty(t[(t[n>>2]|0)+12>>2]|0);t[(t[n>>2]|0)+12>>2]=0;t[(t[n>>2]|0)+16>>2]=0;if(t[f>>2]|0){i=Yl(t[f>>2]|0)|0;t[(t[n>>2]|0)+40>>2]=i}else t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+48>>2]=0;s=r;return}case 2:case 1:case 11:{if(t[(t[n>>2]|0)+12>>2]|0)ty(t[(t[n>>2]|0)+12>>2]|0);i=ly(t[(t[n>>2]|0)+32>>2]|0,t[f>>2]|0)|0;t[(t[n>>2]|0)+12>>2]=i;if(!(t[n>>2]|0)){s=r;return}t[u>>2]=t[(t[n>>2]|0)+12>>2];if(!(t[u>>2]|0)){t[(t[n>>2]|0)+16>>2]=0;s=r;return}while(1){i=(t[(t[u>>2]|0)+24>>2]|0)!=0;t[(t[u>>2]|0)+20>>2]=t[n>>2];a=t[u>>2]|0;if(!i)break;t[u>>2]=t[a+24>>2]}t[(t[n>>2]|0)+16>>2]=a;s=r;return}default:{s=r;return}}}function Py(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}iy(t[u>>2]|0);if((t[(t[u>>2]|0)+4>>2]|0)==3){if((t[(t[f>>2]|0)+4>>2]|0)==3){t[a>>2]=Yl(t[(t[u>>2]|0)+40>>2]|0)|0;t[a>>2]=us(t[a>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0;Cy(t[f>>2]|0,t[a>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[f>>2];o=t[n>>2]|0;s=r;return o|0}if(((t[(t[f>>2]|0)+28>>2]|0)!=0?(t[(t[(t[f>>2]|0)+28>>2]|0)+4>>2]|0)==3:0)?(t[(t[f>>2]|0)+8>>2]|0)==(t[(t[(t[f>>2]|0)+28>>2]|0)+8>>2]|0):0){Dy(t[(t[f>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+40>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[(t[f>>2]|0)+28>>2];o=t[n>>2]|0;s=r;return o|0}}else if((t[(t[u>>2]|0)+4>>2]|0)==2){t[n>>2]=CF(t[(t[f>>2]|0)+28>>2]|0,t[f>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+32>>2]|0)!=(t[(t[f>>2]|0)+32>>2]|0))Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);t[(t[u>>2]|0)+20>>2]=t[(t[f>>2]|0)+20>>2];t[(t[u>>2]|0)+24>>2]=t[f>>2];t[(t[u>>2]|0)+28>>2]=t[(t[f>>2]|0)+28>>2];t[(t[f>>2]|0)+28>>2]=t[u>>2];if(t[(t[u>>2]|0)+28>>2]|0)t[(t[(t[u>>2]|0)+28>>2]|0)+24>>2]=t[u>>2];if((t[(t[u>>2]|0)+20>>2]|0)!=0?(t[(t[(t[u>>2]|0)+20>>2]|0)+12>>2]|0)==(t[f>>2]|0):0)t[(t[(t[u>>2]|0)+20>>2]|0)+12>>2]=t[u>>2];t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function By(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(((((t[(t[f>>2]|0)+4>>2]|0)!=2?(t[(t[f>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+20>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+20>>2]|0)+16>>2]|0)!=0:0)?(t[(t[(t[(t[f>>2]|0)+20>>2]|0)+16>>2]|0)+24>>2]|0)==0:0)t[f>>2]=t[(t[(t[f>>2]|0)+20>>2]|0)+16>>2];else c=15;e:do if((c|0)==15)while(1){c=0;if(!(t[(t[f>>2]|0)+24>>2]|0))break e;t[f>>2]=t[(t[f>>2]|0)+24>>2];c=15}while(0);iy(t[u>>2]|0);if(((t[(t[f>>2]|0)+4>>2]|0)==3?(t[(t[u>>2]|0)+4>>2]|0)==3:0)?(t[(t[f>>2]|0)+8>>2]|0)==(t[(t[u>>2]|0)+8>>2]|0):0){Dy(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[f>>2];o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+4>>2]|0)==2){t[n>>2]=CF(t[f>>2]|0,t[f>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+32>>2]|0)!=(t[(t[f>>2]|0)+32>>2]|0))Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);t[a>>2]=t[(t[f>>2]|0)+20>>2];t[(t[u>>2]|0)+28>>2]=t[f>>2];t[(t[u>>2]|0)+24>>2]=0;t[(t[u>>2]|0)+20>>2]=t[a>>2];t[(t[f>>2]|0)+24>>2]=t[u>>2];if(t[a>>2]|0)t[(t[a>>2]|0)+16>>2]=t[u>>2];t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Iy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){i=t[u>>2]|0;if(!(t[(t[f>>2]|0)+12>>2]|0))t[(t[f>>2]|0)+12>>2]=i;else{do if(((t[i+4>>2]|0)==3?(t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0)==3:0)?(t[(t[u>>2]|0)+8>>2]|0)==(t[(t[(t[f>>2]|0)+16>>2]|0)+8>>2]|0):0){Dy(t[(t[f>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+40>>2]|0);e=t[u>>2]|0;if(t[(t[u>>2]|0)+24>>2]|0){t[a>>2]=e;t[u>>2]=t[(t[u>>2]|0)+24>>2];ry(t[a>>2]|0);break}ry(e);t[n>>2]=t[(t[f>>2]|0)+16>>2];o=t[n>>2]|0;s=r;return o|0}while(0);t[a>>2]=t[(t[f>>2]|0)+16>>2];t[(t[a>>2]|0)+24>>2]=t[u>>2];t[(t[u>>2]|0)+28>>2]=t[a>>2]}while(1){a=(t[(t[u>>2]|0)+24>>2]|0)!=0;t[(t[u>>2]|0)+20>>2]=t[f>>2];c=(t[(t[u>>2]|0)+32>>2]|0)!=(t[(t[f>>2]|0)+32>>2]|0);if(!a)break;if(c)Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}if(c)Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);t[(t[f>>2]|0)+16>>2]=t[u>>2];t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function Hy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if((t[(t[u>>2]|0)+4>>2]|0)==3){if(((t[(t[f>>2]|0)+4>>2]|0)==3?(t[(t[f>>2]|0)+40>>2]|0)!=0:0)?(t[(t[f>>2]|0)+8>>2]|0)==(t[(t[u>>2]|0)+8>>2]|0):0){Dy(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[f>>2];l=t[n>>2]|0;s=r;return l|0}if((((t[(t[f>>2]|0)+16>>2]|0)!=0?(t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0)==3:0)?(t[(t[(t[f>>2]|0)+16>>2]|0)+8>>2]|0)==(t[(t[u>>2]|0)+8>>2]|0):0)?(t[(t[f>>2]|0)+16>>2]|0)!=(t[u>>2]|0):0){Dy(t[(t[f>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+40>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[(t[f>>2]|0)+16>>2];l=t[n>>2]|0;s=r;return l|0}}t[a>>2]=t[(t[u>>2]|0)+20>>2];t[(t[u>>2]|0)+20>>2]=t[f>>2];if((t[(t[u>>2]|0)+32>>2]|0)!=(t[(t[f>>2]|0)+32>>2]|0))Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);if((t[a>>2]|0)==(t[f>>2]|0)){t[n>>2]=t[u>>2];l=t[n>>2]|0;s=r;return l|0}if(((t[(t[f>>2]|0)+4>>2]|0)==3?(t[(t[f>>2]|0)+40>>2]|0)!=0:0)?(t[f>>2]|0)!=(t[u>>2]|0):0){Dy(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[f>>2];l=t[n>>2]|0;s=r;return l|0}i=t[f>>2]|0;do if((t[(t[u>>2]|0)+4>>2]|0)!=2)if(!(t[i+12>>2]|0)){t[(t[f>>2]|0)+12>>2]=t[u>>2];t[(t[f>>2]|0)+16>>2]=t[u>>2];break}else{t[a>>2]=t[(t[f>>2]|0)+16>>2];t[(t[a>>2]|0)+24>>2]=t[u>>2];t[(t[u>>2]|0)+28>>2]=t[a>>2];t[(t[f>>2]|0)+16>>2]=t[u>>2];break}else{if((t[i+4>>2]|0)!=1){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if(t[(t[f>>2]|0)+44>>2]|0){e=t[f>>2]|0;b=t[(t[u>>2]|0)+8>>2]|0;if(!(t[(t[u>>2]|0)+36>>2]|0))t[o>>2]=xy(e,b,0)|0;else t[o>>2]=xy(e,b,t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0)|0;do if((t[o>>2]|0)!=0?(t[o>>2]|0)!=(t[u>>2]|0):0){if((t[(t[o>>2]|0)+4>>2]|0)==16)break;iy(t[o>>2]|0);vy(t[o>>2]|0)}while(0);if((t[o>>2]|0)==(t[u>>2]|0)){t[n>>2]=t[u>>2];l=t[n>>2]|0;s=r;return l|0}}if(!(t[(t[f>>2]|0)+44>>2]|0)){t[(t[f>>2]|0)+44>>2]=t[u>>2];break}t[c>>2]=t[(t[f>>2]|0)+44>>2];while(1){if(!(t[(t[c>>2]|0)+24>>2]|0))break;t[c>>2]=t[(t[c>>2]|0)+24>>2]}t[(t[c>>2]|0)+24>>2]=t[u>>2];t[(t[u>>2]|0)+28>>2]=t[c>>2]}while(0);t[n>>2]=t[u>>2];l=t[n>>2]|0;s=r;return l|0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function xy(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=BF(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,t[18946]|0)|0;s=n;return r|0}function Uy(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+4>>2]|0)!=18:0){t[r>>2]=t[(t[n>>2]|0)+16>>2];f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function zy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0)?(t[(t[f>>2]|0)+20>>2]|0)!=0:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){i=t[f>>2]|0;if((t[u>>2]|0)==(t[f>>2]|0)){t[n>>2]=i;a=t[n>>2]|0;s=r;return a|0}if((t[i+4>>2]|0)==2?(t[(t[u>>2]|0)+4>>2]|0)!=2:0){t[n>>2]=t[f>>2];a=t[n>>2]|0;s=r;return a|0}if((t[(t[u>>2]|0)+4>>2]|0)==2?(t[(t[f>>2]|0)+4>>2]|0)!=2:0){
	t[n>>2]=t[f>>2];a=t[n>>2]|0;s=r;return a|0}iy(t[u>>2]|0);Ny(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0);t[(t[u>>2]|0)+20>>2]=t[(t[f>>2]|0)+20>>2];t[(t[u>>2]|0)+24>>2]=t[(t[f>>2]|0)+24>>2];if(t[(t[u>>2]|0)+24>>2]|0)t[(t[(t[u>>2]|0)+24>>2]|0)+28>>2]=t[u>>2];t[(t[u>>2]|0)+28>>2]=t[(t[f>>2]|0)+28>>2];if(t[(t[u>>2]|0)+28>>2]|0)t[(t[(t[u>>2]|0)+28>>2]|0)+24>>2]=t[u>>2];do if(t[(t[u>>2]|0)+20>>2]|0){i=t[(t[u>>2]|0)+20>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)==2){if((t[i+44>>2]|0)!=(t[f>>2]|0))break;t[(t[(t[u>>2]|0)+20>>2]|0)+44>>2]=t[u>>2];break}if((t[i+12>>2]|0)==(t[f>>2]|0))t[(t[(t[u>>2]|0)+20>>2]|0)+12>>2]=t[u>>2];if((t[(t[(t[u>>2]|0)+20>>2]|0)+16>>2]|0)==(t[f>>2]|0))t[(t[(t[u>>2]|0)+20>>2]|0)+16>>2]=t[u>>2]}while(0);t[(t[f>>2]|0)+28>>2]=0;t[(t[f>>2]|0)+24>>2]=0;t[(t[f>>2]|0)+20>>2]=0;t[n>>2]=t[f>>2];a=t[n>>2]|0;s=r;return a|0}iy(t[f>>2]|0);t[n>>2]=t[f>>2];a=t[n>>2]|0;s=r;return a|0}t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function jy(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;do if(t[n>>2]|0)if((t[(t[n>>2]|0)+4>>2]|0)==18){t[f>>2]=Wg(0,t[(t[n>>2]|0)+8>>2]|0,t[(t[n>>2]|0)+12>>2]|0)|0;t[r>>2]=t[f>>2];break}else{t[r>>2]=0;break}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function Vy(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;while(1){if(!(t[r>>2]|0))break;t[u>>2]=jy(t[r>>2]|0)|0;e=t[u>>2]|0;if(!(t[f>>2]|0)){t[f>>2]=e;t[n>>2]=e}else{t[t[f>>2]>>2]=e;t[f>>2]=t[u>>2]}t[r>>2]=t[t[r>>2]>>2]}s=i;return t[n>>2]|0}function qy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=IF(0,t[n>>2]|0,t[f>>2]|0)|0;s=r;return i|0}function Yy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=1:0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}while(1){if(!(t[u>>2]|0)){b=11;break}t[c>>2]=qy(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[c>>2]|0)){b=6;break}i=t[c>>2]|0;if(!(t[o>>2]|0)){t[o>>2]=i;t[a>>2]=i}else{t[(t[o>>2]|0)+24>>2]=i;t[(t[c>>2]|0)+28>>2]=t[o>>2];t[o>>2]=t[c>>2]}t[u>>2]=t[(t[u>>2]|0)+24>>2]}if((b|0)==6){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else if((b|0)==11){t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}return 0}function Gy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=HF(t[n>>2]|0,0,0,t[f>>2]|0)|0;s=r;return t[u>>2]|0}function Wy(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=HF(t[f>>2]|0,t[u>>2]|0,0,t[a>>2]|0)|0;s=n;return t[o>>2]|0}function Ky(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=xF(t[f>>2]|0,t[n>>2]|0,0)|0;s=r;return t[u>>2]|0}function Xy(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=xF(t[r>>2]|0,0,0)|0;s=i;return t[n>>2]|0}function Zy(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;u=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[n>>2]=e;t[a>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[f>>2]=Jg(0,t[(t[n>>2]|0)+8>>2]|0,t[(t[n>>2]|0)+52>>2]|0,t[(t[n>>2]|0)+56>>2]|0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}if(t[(t[n>>2]|0)+48>>2]|0){e=m_(t[(t[n>>2]|0)+48>>2]|0)|0;t[(t[f>>2]|0)+48>>2]=e}if(t[(t[n>>2]|0)+36>>2]|0){e=HM(t[(t[n>>2]|0)+36>>2]|0)|0;t[(t[f>>2]|0)+36>>2]=e}if(t[(t[n>>2]|0)+40>>2]|0){e=AM(t[(t[n>>2]|0)+40>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=e}if(t[(t[n>>2]|0)+44>>2]|0){e=CM(t[(t[n>>2]|0)+44>>2]|0)|0;t[(t[f>>2]|0)+44>>2]=e}if(t[(t[n>>2]|0)+60>>2]|0){e=m_(t[(t[n>>2]|0)+60>>2]|0)|0;t[(t[f>>2]|0)+60>>2]=e}t[u>>2]=t[(t[n>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0))break;t[o>>2]=0;n=t[u>>2]|0;e:do if((t[(t[u>>2]|0)+4>>2]|0)!=17){e=t[u>>2]|0;if((t[n+4>>2]|0)==15){t[l>>2]=e;t[o>>2]=JM(t[f>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+48>>2]|0)|0;break}h=t[u>>2]|0;if((t[e+4>>2]|0)==16){t[b>>2]=h;t[o>>2]=QM(t[f>>2]|0,t[(t[b>>2]|0)+60>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[b>>2]|0)+56>>2]|0)|0;break}if((t[h+4>>2]|0)==8)t[o>>2]=Gy(t[u>>2]|0,0)|0}else{t[c>>2]=n;switch(t[(t[c>>2]|0)+48>>2]|0){case 3:case 2:case 1:{t[o>>2]=UF(t[f>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0;break e;break}case 5:case 4:{t[o>>2]=zF(t[f>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0;break e;break}default:break e}}while(0);if(!(t[o>>2]|0)){t[u>>2]=t[(t[u>>2]|0)+24>>2];continue}n=t[o>>2]|0;if(!(t[a>>2]|0))t[(t[f>>2]|0)+12>>2]=n;else t[(t[a>>2]|0)+24>>2]=n;t[(t[o>>2]|0)+28>>2]=t[a>>2];t[(t[o>>2]|0)+20>>2]=t[f>>2];t[(t[o>>2]|0)+24>>2]=0;t[(t[f>>2]|0)+16>>2]=t[o>>2];t[a>>2]=t[o>>2];t[u>>2]=t[(t[u>>2]|0)+24>>2]}t[r>>2]=t[f>>2];k=t[r>>2]|0;s=i;return k|0}function Jy(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=ny(t[(t[f>>2]|0)+56>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(t[(t[f>>2]|0)+8>>2]|0){i=gAi[t[135768>>2]&511](t[(t[f>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=i}if(t[(t[f>>2]|0)+60>>2]|0){i=Yl(t[(t[f>>2]|0)+60>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=i}if(t[(t[f>>2]|0)+72>>2]|0){i=Yl(t[(t[f>>2]|0)+72>>2]|0)|0;t[(t[a>>2]|0)+72>>2]=i}t[(t[a>>2]|0)+76>>2]=t[(t[f>>2]|0)+76>>2];t[(t[a>>2]|0)+36>>2]=t[(t[f>>2]|0)+36>>2];t[(t[a>>2]|0)+40>>2]=t[(t[f>>2]|0)+40>>2];i=t[a>>2]|0;if(!(t[u>>2]|0)){t[n>>2]=i;c=t[n>>2]|0;s=r;return c|0}t[i+16>>2]=0;t[(t[a>>2]|0)+12>>2]=0;do if(t[(t[f>>2]|0)+44>>2]|0){i=Zy(t[(t[f>>2]|0)+44>>2]|0)|0;t[(t[a>>2]|0)+44>>2]=i;i=t[a>>2]|0;if(t[(t[a>>2]|0)+44>>2]|0){Ny(t[i+44>>2]|0,t[a>>2]|0);t[(t[(t[a>>2]|0)+44>>2]|0)+20>>2]=t[a>>2];break}fy(i);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}while(0);if(t[(t[f>>2]|0)+52>>2]|0){i=Vy(t[(t[f>>2]|0)+52>>2]|0)|0;t[(t[a>>2]|0)+52>>2]=i}e:do if(t[(t[f>>2]|0)+12>>2]|0){i=xF(t[(t[f>>2]|0)+12>>2]|0,t[a>>2]|0,t[a>>2]|0)|0;t[(t[a>>2]|0)+12>>2]=i;t[(t[a>>2]|0)+16>>2]=0;t[o>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(t[o>>2]|0))break e;if(!(t[(t[o>>2]|0)+24>>2]|0))t[(t[a>>2]|0)+16>>2]=t[o>>2];t[o>>2]=t[(t[o>>2]|0)+24>>2]}}while(0);t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}function Qy(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=jF(t[r>>2]|0,0)|0;s=i;return e|0}function $y(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;i=s;s=s+176|0;r=i;f=i+64|0;a=i+60|0;o=i+56|0;c=i+52|0;l=i+48|0;b=i+44|0;k=i+40|0;h=i+36|0;w=i+32|0;d=i+28|0;v=i+24|0;m=i+68|0;_=i+20|0;p=i+16|0;t[a>>2]=e;t[b>>2]=0;t[_>>2]=0;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)!=18:0){t[h>>2]=500;t[b>>2]=gAi[t[135752>>2]&511](t[h>>2]|0)|0;if(!(t[b>>2]|0)){LF(75488);t[f>>2]=0;E=t[f>>2]|0;s=i;return E|0}t[w>>2]=gAi[t[135752>>2]&511](t[h>>2]|0)|0;if(!(t[w>>2]|0)){LF(75488);pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;E=t[f>>2]|0;s=i;return E|0}n[t[b>>2]>>0]=0;t[o>>2]=t[a>>2];while(1){t[v>>2]=75312;t[d>>2]=75512;t[_>>2]=0;e:do if((t[(t[o>>2]|0)+4>>2]|0)!=9?(t[(t[o>>2]|0)+4>>2]|0)!=13:0){if((t[(t[o>>2]|0)+4>>2]|0)==1){t[p>>2]=0;t[d>>2]=75520;t[v>>2]=t[(t[o>>2]|0)+8>>2];do if(t[(t[o>>2]|0)+36>>2]|0)if(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0){a=t[(t[o>>2]|0)+8>>2]|0;t[r>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2];t[r+4>>2]=a;SY(m,99,75528,r)|0;n[m+99>>0]=0;t[v>>2]=m;break}else{t[p>>2]=1;t[v>>2]=75536;break}while(0);t[l>>2]=t[(t[o>>2]|0)+20>>2];t[c>>2]=t[(t[o>>2]|0)+28>>2];while(1){if(!(t[c>>2]|0))break;do if((t[(t[c>>2]|0)+4>>2]|0)==1){if(!(t[p>>2]|0)){if(!(Xl(t[(t[o>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0))break;if((t[(t[c>>2]|0)+36>>2]|0)!=(t[(t[o>>2]|0)+36>>2]|0)){if(!(t[(t[c>>2]|0)+36>>2]|0))break;if(!(t[(t[o>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0,t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)|0))break}}t[_>>2]=(t[_>>2]|0)+1}while(0);t[c>>2]=t[(t[c>>2]|0)+28>>2]}if(t[_>>2]|0){t[_>>2]=(t[_>>2]|0)+1;break}t[c>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!((t[c>>2]|0)!=0&(t[_>>2]|0)==0))break;i:do if((t[(t[c>>2]|0)+4>>2]|0)==1){do if(!(t[p>>2]|0)){if(!(Xl(t[(t[o>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0))break i;if((t[(t[c>>2]|0)+36>>2]|0)==(t[(t[o>>2]|0)+36>>2]|0))break;if(!(t[(t[c>>2]|0)+36>>2]|0))break i;if(!(t[(t[o>>2]|0)+36>>2]|0))break i;if(!(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0,t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)|0))break i}while(0);t[_>>2]=(t[_>>2]|0)+1}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}if(!(t[_>>2]|0))break;t[_>>2]=1;break}if((t[(t[o>>2]|0)+4>>2]|0)==8){t[d>>2]=75520;t[v>>2]=75544;t[l>>2]=t[(t[o>>2]|0)+20>>2];t[c>>2]=t[(t[o>>2]|0)+28>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==8)t[_>>2]=(t[_>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+28>>2]}if(t[_>>2]|0){t[_>>2]=(t[_>>2]|0)+1;break}t[c>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!((t[c>>2]|0)!=0&(t[_>>2]|0)==0))break;if((t[(t[c>>2]|0)+4>>2]|0)==8)t[_>>2]=(t[_>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+24>>2]}if(!(t[_>>2]|0))break;t[_>>2]=1;break}if((t[(t[o>>2]|0)+4>>2]|0)!=3?(t[(t[o>>2]|0)+4>>2]|0)!=4:0){if((t[(t[o>>2]|0)+4>>2]|0)!=7){if((t[(t[o>>2]|0)+4>>2]|0)!=2){t[l>>2]=t[(t[o>>2]|0)+20>>2];break}t[d>>2]=75600;t[v>>2]=t[(t[o>>2]|0)+8>>2];if(t[(t[o>>2]|0)+36>>2]|0){a=t[o>>2]|0;if(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0){e=t[(t[o>>2]|0)+8>>2]|0;t[r>>2]=t[(t[a+36>>2]|0)+12>>2];t[r+4>>2]=e;SY(m,99,75528,r)|0}else{t[r>>2]=t[a+8>>2];SY(m,99,75608,r)|0}n[m+99>>0]=0;t[v>>2]=m}t[l>>2]=t[(t[o>>2]|0)+20>>2];break}t[d>>2]=75520;t[r>>2]=t[(t[o>>2]|0)+8>>2];SY(m,99,75568,r)|0;n[m+99>>0]=0;t[v>>2]=m;t[l>>2]=t[(t[o>>2]|0)+20>>2];t[c>>2]=t[(t[o>>2]|0)+28>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==7?(Xl(t[(t[o>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)!=0:0)t[_>>2]=(t[_>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+28>>2]}if(t[_>>2]|0){t[_>>2]=(t[_>>2]|0)+1;break}t[c>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!((t[c>>2]|0)!=0&(t[_>>2]|0)==0))break;do if((t[(t[c>>2]|0)+4>>2]|0)==7){if(!(Xl(t[(t[o>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0))break;t[_>>2]=(t[_>>2]|0)+1}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}if(!(t[_>>2]|0))break;t[_>>2]=1;break}t[d>>2]=75520;t[v>>2]=75560;t[l>>2]=t[(t[o>>2]|0)+20>>2];t[c>>2]=t[(t[o>>2]|0)+28>>2];while(1){if(!(t[c>>2]|0))break;if(!((t[(t[c>>2]|0)+4>>2]|0)!=3?(t[(t[c>>2]|0)+4>>2]|0)!=4:0))t[_>>2]=(t[_>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+28>>2]}if(t[_>>2]|0){t[_>>2]=(t[_>>2]|0)+1;break}t[c>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break e;if((t[(t[c>>2]|0)+4>>2]|0)==3)break;if((t[(t[c>>2]|0)+4>>2]|0)==4)break;t[c>>2]=t[(t[c>>2]|0)+24>>2]}t[_>>2]=1}else S=11;while(0);if((S|0)==11){S=0;if((u[t[b>>2]>>0]|0|0)==47){S=110;break}t[d>>2]=75520;t[l>>2]=0}a=(rs(t[b>>2]|0)|0)+120|0;if(a>>>0>(t[h>>2]|0)>>>0){a=t[h>>2]<<1;t[h>>2]=a+(rs(t[b>>2]|0)|0)+120;t[k>>2]=MAi[t[135760>>2]&511](t[b>>2]|0,t[h>>2]|0)|0;if(!(t[k>>2]|0)){S=102;break}t[b>>2]=t[k>>2];t[k>>2]=MAi[t[135760>>2]&511](t[w>>2]|0,t[h>>2]|0)|0;if(!(t[k>>2]|0)){S=104;break}t[w>>2]=t[k>>2]}a=t[w>>2]|0;e=t[h>>2]|0;g=t[d>>2]|0;y=t[v>>2]|0;if(!(t[_>>2]|0)){F=t[b>>2]|0;t[r>>2]=g;t[r+4>>2]=y;t[r+8>>2]=F;SY(a,e,75616,r)|0}else{F=t[_>>2]|0;O=t[b>>2]|0;t[r>>2]=g;t[r+4>>2]=y;t[r+8>>2]=F;t[r+12>>2]=O;SY(a,e,75624,r)|0}e=t[b>>2]|0;a=t[h>>2]|0;t[r>>2]=t[w>>2];SY(e,a,75608,r)|0;t[o>>2]=t[l>>2];if(!(t[o>>2]|0)){S=110;break}}if((S|0)==102){LF(75488);pAi[t[135736>>2]&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;E=t[f>>2]|0;s=i;return E|0}else if((S|0)==104){LF(75488);pAi[t[135736>>2]&511](t[w>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;E=t[f>>2]|0;s=i;return E|0}else if((S|0)==110){pAi[t[135736>>2]&511](t[w>>2]|0);t[f>>2]=t[b>>2];E=t[f>>2]|0;s=i;return E|0}}t[f>>2]=0;E=t[f>>2]|0;s=i;return E|0}function eF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=t[(t[n>>2]|0)+12>>2];while(1){a=t[f>>2]|0;if(!(t[f>>2]|0)){o=8;break}c=t[f>>2]|0;if((t[a+4>>2]|0)==1){o=6;break}t[f>>2]=t[c+24>>2]}if((o|0)==6){t[r>>2]=c;u=t[r>>2]|0;s=i;return u|0}else if((o|0)==8){t[r>>2]=a;u=t[r>>2]|0;s=i;return u|0}return 0}function iF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=18:0){iy(t[u>>2]|0);Ny(t[u>>2]|0,t[f>>2]|0);t[(t[u>>2]|0)+20>>2]=t[f>>2];t[a>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[a>>2]|0))break;if((t[(t[a>>2]|0)+4>>2]|0)==1)break;t[a>>2]=t[(t[a>>2]|0)+24>>2]}do if(!(t[a>>2]|0))if(!(t[(t[f>>2]|0)+12>>2]|0)){t[(t[f>>2]|0)+12>>2]=t[u>>2];t[(t[f>>2]|0)+16>>2]=t[u>>2];break}else{By(t[(t[f>>2]|0)+12>>2]|0,t[u>>2]|0)|0;break}else zy(t[a>>2]|0,t[u>>2]|0)|0;while(0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function rF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=t[a>>2];if((t[a>>2]|0)!=0?!((t[o>>2]|0)==0?1:(t[(t[a>>2]|0)+4>>2]|0)==18):0){if(Xl(t[o>>2]|0,75176)|0){if((t[u>>2]|0)==0?(t[(t[a>>2]|0)+4>>2]|0)==1:0){t[c>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[c>>2]|0)){LF(75760);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else{r=t[c>>2]|0;t[r+0>>2]=0;t[r+4>>2]=0;t[r+8>>2]=0;t[r+12>>2]=0;t[r+16>>2]=0;t[r+20>>2]=0;t[(t[c>>2]|0)+4>>2]=18;r=Yl(75176)|0;t[(t[c>>2]|0)+8>>2]=r;r=Yl(75168)|0;t[(t[c>>2]|0)+12>>2]=r;t[t[c>>2]>>2]=t[(t[a>>2]|0)+48>>2];t[(t[a>>2]|0)+48>>2]=t[c>>2];t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}}if((t[u>>2]|0)==0?(t[u>>2]=t[(t[a>>2]|0)+32>>2],(t[u>>2]|0)==0):0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}r=t[u>>2]|0;if(!(t[(t[u>>2]|0)+52>>2]|0)){t[f>>2]=VF(r)|0;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=t[r+52>>2];k=t[f>>2]|0;s=n;return k|0}}t[b>>2]=(t[(t[a>>2]|0)+4>>2]|0)==2&1;e:while(1){if(!(t[a>>2]|0)){h=41;break}if((t[(t[a>>2]|0)+4>>2]|0)==5){h=21;break}if((t[(t[a>>2]|0)+4>>2]|0)==6){h=21;break}if((t[(t[a>>2]|0)+4>>2]|0)==17){h=21;break}do if((t[(t[a>>2]|0)+4>>2]|0)==1){t[c>>2]=t[(t[a>>2]|0)+48>>2];while(1){if(!(t[c>>2]|0))break;do if(((t[o>>2]|0)!=0?(t[(t[c>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[o>>2]|0)|0)!=0:0){if((t[b>>2]|0)!=0?(t[(t[c>>2]|0)+12>>2]|0)==0:0)break;if((qF(t[u>>2]|0,t[l>>2]|0,t[a>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0)==1){h=30;break e}}while(0);t[c>>2]=t[t[c>>2]>>2]}if((((t[l>>2]|0)!=(t[a>>2]|0)?(t[c>>2]=t[(t[a>>2]|0)+36>>2],(t[c>>2]|0)!=0):0)?(t[o>>2]|0)!=0?(t[(t[c>>2]|0)+8>>2]|0)!=0:0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[o>>2]|0)|0)!=0:0){if((t[b>>2]|0)!=0?(t[(t[c>>2]|0)+12>>2]|0)==0:0)break;if((qF(t[u>>2]|0,t[l>>2]|0,t[a>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0)==1){h=39;break e}}}while(0);t[a>>2]=t[(t[a>>2]|0)+20>>2]}if((h|0)==21){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else if((h|0)==30){t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}else if((h|0)==39){t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}else if((h|0)==41){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}}t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}function nF(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+8>>2]|0)==0:0){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(t[o>>2]|0)w=t[(t[o>>2]|0)+8>>2]|0;else w=0;t[b>>2]=BF(t[a>>2]|0,t[c>>2]|0,w,0)|0;if(!(t[b>>2]|0)){t[u>>2]=PF(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,0)|0;h=t[u>>2]|0;s=f;return h|0}if((t[(t[b>>2]|0)+40>>2]|0)==2){YM(t[(t[a>>2]|0)+32>>2]|0,t[b>>2]|0)|0;t[(t[b>>2]|0)+40>>2]=2}if(t[(t[b>>2]|0)+12>>2]|0)ty(t[(t[b>>2]|0)+12>>2]|0);t[(t[b>>2]|0)+12>>2]=0;t[(t[b>>2]|0)+16>>2]=0;t[(t[b>>2]|0)+36>>2]=t[o>>2];e:do if(t[l>>2]|0){if((ls(t[l>>2]|0)|0)==0?(DF(1303,t[(t[a>>2]|0)+32>>2]|0,0),(t[(t[a>>2]|0)+32>>2]|0)!=0):0){o=Yl(75792)|0;t[(t[(t[a>>2]|0)+32>>2]|0)+60>>2]=o}o=ay(t[(t[a>>2]|0)+32>>2]|0,t[l>>2]|0)|0;t[(t[b>>2]|0)+12>>2]=o;t[(t[b>>2]|0)+16>>2]=0;t[k>>2]=t[(t[b>>2]|0)+12>>2];while(1){if(!(t[k>>2]|0))break e;t[(t[k>>2]|0)+20>>2]=t[b>>2];if(!(t[(t[k>>2]|0)+24>>2]|0))t[(t[b>>2]|0)+16>>2]=t[k>>2];t[k>>2]=t[(t[k>>2]|0)+24>>2]}}while(0);if((t[(t[b>>2]|0)+40>>2]|0)==2)zM(0,t[(t[a>>2]|0)+32>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;t[u>>2]=t[b>>2];h=t[u>>2]|0;s=f;return h|0}function fF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+4>>2]|0)!=18:0){while(1){if(!(t[n>>2]|0)){u=8;break}t[f>>2]=tF(t[n>>2]|0,75640,75176)|0;if(t[f>>2]|0){u=6;break}t[n>>2]=t[(t[n>>2]|0)+20>>2]}if((u|0)==6){t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}else if((u|0)==8){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}}t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}function tF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=BF(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[18946]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=YF(t[c>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function uF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+4>>2]|0)==1:0){while(1){if(!(t[n>>2]|0)){u=11;break}t[f>>2]=tF(t[n>>2]|0,75648,75176)|0;if(t[f>>2]|0){if(Xl(t[f>>2]|0,75664)|0){u=7;break}e=(Xl(t[f>>2]|0,75656)|0)!=0;pAi[t[135736>>2]&511](t[f>>2]|0);if(e){u=9;break}}t[n>>2]=t[(t[n>>2]|0)+20>>2]}if((u|0)==7){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}else if((u|0)==9){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}else if((u|0)==11){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}}t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}function aF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}switch(t[(t[n>>2]|0)+4>>2]|0){case 9:case 21:case 13:{t[o>>2]=t[n>>2];if(t[(t[o>>2]|0)+72>>2]|0)pAi[t[135736>>2]&511](t[(t[o>>2]|0)+72>>2]|0);if(!(t[f>>2]|0)){t[(t[o>>2]|0)+72>>2]=0;s=r;return}else{i=XA(t[f>>2]|0)|0;t[(t[o>>2]|0)+72>>2]=i;s=r;return}break}case 20:case 19:case 18:case 6:case 5:case 7:case 17:case 16:case 15:case 14:case 12:case 11:case 10:case 8:case 4:case 3:{s=r;return}default:{t[u>>2]=rF(t[(t[n>>2]|0)+32>>2]|0,t[n>>2]|0,75176)|0;if(!(t[u>>2]|0)){s=r;return}t[a>>2]=XA(t[f>>2]|0)|0;i=t[n>>2]|0;n=t[u>>2]|0;if(t[a>>2]|0){nF(i,n,75680,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);s=r;return}else{nF(i,n,75680,t[f>>2]|0)|0;s=r;return}}}}function oF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((t[u>>2]|0)==0&(t[f>>2]|0)==0){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)==18:0){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if(!(t[f>>2]|0))t[f>>2]=t[(t[u>>2]|0)+32>>2];if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)==13:0){t[u>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0)){k=22;break}if(!(t[(t[u>>2]|0)+8>>2]|0)){k=22;break}i=t[u>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)!=1){t[u>>2]=t[i+24>>2];continue}e=(Ql(t[i+8>>2]|0,75688)|0)!=0;i=t[u>>2]|0;if(!e){t[u>>2]=t[i+12>>2];continue}e=(Ql(t[i+8>>2]|0,75696)|0)!=0;i=t[u>>2]|0;if(!e){t[u>>2]=t[i+12>>2];continue}e=(Ql(t[i+8>>2]|0,75680)|0)!=0;h=t[u>>2]|0;if(!e){k=20;break}t[u>>2]=t[h+24>>2]}if((k|0)==20){t[n>>2]=cF(h,75704)|0;b=t[n>>2]|0;s=r;return b|0}else if((k|0)==22){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}while(1){if(!(t[u>>2]|0)){k=38;break}w=t[u>>2]|0;if((t[(t[u>>2]|0)+4>>2]|0)==17){k=25;break}if((t[w+4>>2]|0)==1?(t[o>>2]=tF(t[u>>2]|0,75680,75176)|0,(t[o>>2]|0)!=0):0){if(t[a>>2]|0){t[c>>2]=GA(t[a>>2]|0,t[o>>2]|0)|0;h=(t[c>>2]|0)!=0;pAi[t[135736>>2]&511](t[a>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);if(!h){k=31;break}t[a>>2]=t[c>>2]}else t[a>>2]=t[o>>2];if(!(Jl(t[a>>2]|0,75712,7)|0)){k=36;break}if(!(Jl(t[a>>2]|0,75720,6)|0)){k=36;break}if(!(Jl(t[a>>2]|0,75728,4)|0)){k=36;break}}t[u>>2]=t[(t[u>>2]|0)+20>>2]}if((k|0)==25){t[l>>2]=w;t[n>>2]=Yl(t[(t[l>>2]|0)+64>>2]|0)|0;b=t[n>>2]|0;s=r;return b|0}else if((k|0)==31){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}else if((k|0)==36){t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}else if((k|0)==38){if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+72>>2]|0)!=0:0)if(!(t[a>>2]|0)){t[n>>2]=Yl(t[(t[f>>2]|0)+72>>2]|0)|0;b=t[n>>2]|0;s=r;return b|0}else{t[c>>2]=GA(t[a>>2]|0,t[(t[f>>2]|0)+72>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}return 0}function cF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=dF(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=YF(t[a>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}return 0}function lF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;if((t[u>>2]|0)==0|(t[f>>2]|0)==0){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}e:do switch(t[(t[u>>2]|0)+4>>2]|0){case 1:case 11:{t[a>>2]=t[u>>2];i:while(1){if(!(t[a>>2]|0))break e;i=t[(t[a>>2]|0)+4>>2]|0;if((i|0)==5)lF(t[f>>2]|0,t[a>>2]|0)|0;else if((i|0)==3|(i|0)==4?(t[(t[a>>2]|0)+40>>2]|0)!=0:0)Is(t[f>>2]|0,t[(t[a>>2]|0)+40>>2]|0)|0;if((t[(t[a>>2]|0)+12>>2]|0)!=0?(t[(t[(t[a>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0){t[a>>2]=t[(t[a>>2]|0)+12>>2];continue}if((t[a>>2]|0)==(t[u>>2]|0))break e;if(t[(t[a>>2]|0)+24>>2]|0){t[a>>2]=t[(t[a>>2]|0)+24>>2];continue}while(1){t[a>>2]=t[(t[a>>2]|0)+20>>2];if(!(t[a>>2]|0))continue i;if((t[a>>2]|0)==(t[u>>2]|0)){h=19;break}w=t[a>>2]|0;if(t[(t[a>>2]|0)+24>>2]|0){h=21;break}if(!w)continue i}if((h|0)==19){h=0;t[a>>2]=0;continue}else if((h|0)==21){h=0;t[a>>2]=t[w+24>>2];continue}}break}case 3:case 4:{Is(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0)|0;break}case 9:case 21:case 13:{t[u>>2]=t[(t[u>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0))break e;if(!(((t[(t[u>>2]|0)+4>>2]|0)!=1?(t[(t[u>>2]|0)+4>>2]|0)!=3:0)?(t[(t[u>>2]|0)+4>>2]|0)!=4:0))lF(t[f>>2]|0,t[u>>2]|0)|0;t[u>>2]=t[(t[u>>2]|0)+24>>2]}break}case 18:{Is(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;break}case 2:{t[o>>2]=t[u>>2];t[c>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break e;i=t[f>>2]|0;e=t[c>>2]|0;if((t[(t[c>>2]|0)+4>>2]|0)==3)Is(i,t[e+40>>2]|0)|0;else lF(i,e)|0;t[c>>2]=t[(t[c>>2]|0)+24>>2]}break}case 7:case 8:{Is(t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0)|0;break}case 5:{t[l>>2]=h_(t[(t[u>>2]|0)+32>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;if(!(t[l>>2]|0)){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}t[b>>2]=t[(t[l>>2]|0)+12>>2];while(1){if(!(t[b>>2]|0))break e;lF(t[f>>2]|0,t[b>>2]|0)|0;t[b>>2]=t[(t[b>>2]|0)+24>>2]}break}default:{}}while(0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}function sF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+48|0;r=i+36|0;n=i+32|0;f=i+28|0;u=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[n>>2]=e;e:do if(!(t[n>>2]|0))t[r>>2]=0;else do switch(t[(t[n>>2]|0)+4>>2]|0){case 13:case 21:case 9:{t[l>>2]=ds()|0;if(!(t[l>>2]|0)){t[r>>2]=0;break e}else{lF(t[l>>2]|0,t[n>>2]|0)|0;t[b>>2]=ms(t[l>>2]|0)|0;Ss(t[l>>2]|0);t[r>>2]=t[b>>2];break e}break}case 2:{t[r>>2]=YF(t[n>>2]|0)|0;break e;break}case 5:{t[a>>2]=h_(t[(t[n>>2]|0)+32>>2]|0,t[(t[n>>2]|0)+8>>2]|0)|0;if(!(t[a>>2]|0)){t[r>>2]=0;break e}t[o>>2]=ds()|0;if(!(t[o>>2]|0)){t[r>>2]=0;break e}else{lF(t[o>>2]|0,t[n>>2]|0)|0;t[c>>2]=ms(t[o>>2]|0)|0;Ss(t[o>>2]|0);t[r>>2]=t[c>>2];break e}break}case 1:case 11:{t[f>>2]=vs(64)|0;if(!(t[f>>2]|0)){t[r>>2]=0;break e}else{lF(t[f>>2]|0,t[n>>2]|0)|0;t[u>>2]=ms(t[f>>2]|0)|0;Ss(t[f>>2]|0);t[r>>2]=t[u>>2];break e}break}case 15:{t[r>>2]=0;break e;break}case 3:case 4:{if(t[(t[n>>2]|0)+40>>2]|0){t[r>>2]=Yl(t[(t[n>>2]|0)+40>>2]|0)|0;break e}else{t[r>>2]=0;break e}break}case 18:{t[k>>2]=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[r>>2]=t[k>>2];break e;break}case 17:{t[r>>2]=0;break e;break}case 20:case 19:case 14:case 12:case 10:case 6:{t[r>>2]=0;break e;break}case 16:{t[r>>2]=0;break e;break}case 7:case 8:{if(t[(t[n>>2]|0)+40>>2]|0){t[r>>2]=Yl(t[(t[n>>2]|0)+40>>2]|0)|0;break e}else{t[r>>2]=0;break e}break}default:{t[r>>2]=0;break e}}while(0);while(0);s=i;return t[r>>2]|0}function bF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if((t[f>>2]|0)==0|(t[a>>2]|0)<=0){s=n;return}switch(t[(t[f>>2]|0)+4>>2]|0){case 8:case 7:case 6:case 5:case 4:case 3:case 12:{if(!(t[u>>2]|0)){s=n;return}do if((t[(t[f>>2]|0)+40>>2]|0)!=((t[f>>2]|0)+44|0)){if(((t[(t[f>>2]|0)+32>>2]|0)!=0?(t[(t[(t[f>>2]|0)+32>>2]|0)+80>>2]|0)!=0:0)?(wz(t[(t[(t[f>>2]|0)+32>>2]|0)+80>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0)!=0:0)break;r=fs(t[(t[f>>2]|0)+40>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=r;s=n;return}while(0);r=ts(t[(t[f>>2]|0)+40>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=r;t[(t[f>>2]|0)+44>>2]=0;t[(t[f>>2]|0)+48>>2]=0;s=n;return}case 1:case 11:{t[o>>2]=t[(t[f>>2]|0)+16>>2];t[c>>2]=Oy(t[u>>2]|0,t[a>>2]|0)|0;if(!(t[c>>2]|0)){s=n;return}t[l>>2]=Hy(t[f>>2]|0,t[c>>2]|0)|0;if(!((t[o>>2]|0)!=0?(t[l>>2]|0)==(t[c>>2]|0):0)){s=n;return}if((t[(t[o>>2]|0)+24>>2]|0)!=(t[c>>2]|0)){s=n;return}kF(t[o>>2]|0,t[c>>2]|0)|0;s=n;return}default:{s=n;return}}}function kF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;i=t[u>>2]|0;do if(t[f>>2]|0){e=t[f>>2]|0;if(!i){t[n>>2]=e;break}if((t[e+4>>2]|0)!=3){t[n>>2]=t[f>>2];break}if((t[(t[u>>2]|0)+4>>2]|0)!=3){t[n>>2]=t[f>>2];break}e=t[f>>2]|0;if((t[(t[u>>2]|0)+8>>2]|0)!=(t[(t[f>>2]|0)+8>>2]|0)){t[n>>2]=e;break}else{Dy(e,t[(t[u>>2]|0)+40>>2]|0);iy(t[u>>2]|0);ry(t[u>>2]|0);t[n>>2]=t[f>>2];break}}else t[n>>2]=i;while(0);s=r;return t[n>>2]|0}function hF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[r+24>>2]=e;t[f>>2]=i;t[a>>2]=0;t[o>>2]=0;t[c>>2]=10;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=18:0){e:while(1){if(!(t[f>>2]|0)){b=24;break}i:do if((t[(t[f>>2]|0)+4>>2]|0)==1){t[u>>2]=t[(t[f>>2]|0)+48>>2];while(1){if(!(t[u>>2]|0))break i;if(!(t[a>>2]|0)){t[a>>2]=gAi[t[135744>>2]&511]((t[c>>2]|0)+1<<2)|0;if(!(t[a>>2]|0)){b=10;break e}t[(t[a>>2]|0)+(t[o>>2]<<2)>>2]=0}t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[o>>2]|0))break;if((t[(t[u>>2]|0)+12>>2]|0)==(t[(t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0)+12>>2]|0))break;if(Xl(t[(t[u>>2]|0)+12>>2]|0,t[(t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0)+12>>2]|0)|0)break;t[l>>2]=(t[l>>2]|0)+1}if((t[l>>2]|0)>=(t[o>>2]|0)){if((t[o>>2]|0)>=(t[c>>2]|0)?(t[c>>2]=t[c>>2]<<1,t[a>>2]=MAi[t[135760>>2]&511](t[a>>2]|0,(t[c>>2]|0)+1<<2)|0,(t[a>>2]|0)==0):0){b=20;break e}i=t[u>>2]|0;e=t[o>>2]|0;t[o>>2]=e+1;t[(t[a>>2]|0)+(e<<2)>>2]=i;t[(t[a>>2]|0)+(t[o>>2]<<2)>>2]=0}t[u>>2]=t[t[u>>2]>>2]}}while(0);t[f>>2]=t[(t[f>>2]|0)+20>>2]}if((b|0)==10){LF(75736);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else if((b|0)==20){LF(75736);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else if((b|0)==24){t[n>>2]=t[a>>2];k=t[n>>2]|0;s=r;return k|0}}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}function wF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=t[a>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)!=18:0){if((t[o>>2]|0)!=0?(Xl(t[o>>2]|0,75168)|0)!=0:0){if((t[u>>2]|0)==0?(t[(t[a>>2]|0)+4>>2]|0)==1:0){t[c>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[c>>2]|0)){LF(75760);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}else{r=t[c>>2]|0;t[r+0>>2]=0;t[r+4>>2]=0;t[r+8>>2]=0;t[r+12>>2]=0;t[r+16>>2]=0;t[r+20>>2]=0;t[(t[c>>2]|0)+4>>2]=18;r=Yl(75176)|0;t[(t[c>>2]|0)+8>>2]=r;r=Yl(75168)|0;t[(t[c>>2]|0)+12>>2]=r;t[t[c>>2]>>2]=t[(t[a>>2]|0)+48>>2];t[(t[a>>2]|0)+48>>2]=t[c>>2];t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}}if((t[u>>2]|0)==0?(t[u>>2]=t[(t[a>>2]|0)+32>>2],(t[u>>2]|0)==0):0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}r=t[u>>2]|0;if(!(t[(t[u>>2]|0)+52>>2]|0)){t[f>>2]=VF(r)|0;b=t[f>>2]|0;s=n;return b|0}else{t[f>>2]=t[r+52>>2];b=t[f>>2]|0;s=n;return b|0}}e:while(1){if(!(t[a>>2]|0)){k=43;break}if((t[(t[a>>2]|0)+4>>2]|0)==5){k=21;break}if((t[(t[a>>2]|0)+4>>2]|0)==6){k=21;break}if((t[(t[a>>2]|0)+4>>2]|0)==17){k=21;break}if((t[(t[a>>2]|0)+4>>2]|0)==1){t[c>>2]=t[(t[a>>2]|0)+48>>2];while(1){if(!(t[c>>2]|0))break;if(((t[o>>2]|0)==0?(t[(t[c>>2]|0)+12>>2]|0)==0:0)?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){k=27;break e}if((((t[o>>2]|0)!=0?(t[(t[c>>2]|0)+12>>2]|0)!=0:0)?(t[(t[c>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+12>>2]|0,t[o>>2]|0)|0)!=0:0){k=31;break e}t[c>>2]=t[t[c>>2]>>2]}if((t[l>>2]|0)!=(t[a>>2]|0)?(t[c>>2]=t[(t[a>>2]|0)+36>>2],(t[c>>2]|0)!=0):0){if(((t[o>>2]|0)==0?(t[(t[c>>2]|0)+12>>2]|0)==0:0)?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){k=37;break}if((((t[o>>2]|0)!=0?(t[(t[c>>2]|0)+12>>2]|0)!=0:0)?(t[(t[c>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+12>>2]|0,t[o>>2]|0)|0)!=0:0){k=41;break}}}t[a>>2]=t[(t[a>>2]|0)+20>>2]}if((k|0)==21){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}else if((k|0)==27){t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}else if((k|0)==31){t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}else if((k|0)==37){t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}else if((k|0)==41){t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}else if((k|0)==43){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}}t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}function dF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?!((t[u>>2]|0)==0?1:(t[(t[f>>2]|0)+4>>2]|0)!=1):0){t[a>>2]=t[(t[f>>2]|0)+44>>2];while(1){if(!(t[a>>2]|0))break;i=(Xl(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0)!=0;l=t[a>>2]|0;if(i){b=7;break}t[a>>2]=t[l+24>>2]}if((b|0)==7){t[n>>2]=l;k=t[n>>2]|0;s=r;return k|0}if(!(t[18946]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[o>>2]=t[(t[f>>2]|0)+32>>2];if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+44>>2]|0)!=0:0){t[c>>2]=qM(t[(t[o>>2]|0)+44>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[u>>2]|0)|0;if((t[c>>2]|0)==0?(t[(t[o>>2]|0)+48>>2]|0)!=0:0)t[c>>2]=qM(t[(t[o>>2]|0)+48>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[u>>2]|0)|0;if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+48>>2]|0)!=0:0){t[n>>2]=t[c>>2];k=t[n>>2]|0;s=r;return k|0}}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}function vF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=BF(t[f>>2]|0,t[u>>2]|0,0,t[18946]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=YF(t[a>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}return 0}function mF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=BF(t[f>>2]|0,t[u>>2]|0,0,0)|0;if(!(t[a>>2]|0)){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}else{iy(t[a>>2]|0);vy(t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}return 0}function _F(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0){t[l>>2]=jg(t[a>>2]|0,c)|0;if(t[l>>2]|0){t[k>>2]=ql(t[a>>2]|0,t[c>>2]|0)|0;t[b>>2]=wF(t[(t[u>>2]|0)+32>>2]|0,t[u>>2]|0,t[k>>2]|0)|0;if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[b>>2]|0){t[f>>2]=nF(t[u>>2]|0,t[b>>2]|0,t[l>>2]|0,t[o>>2]|0)|0;h=t[f>>2]|0;s=n;return h|0}}t[f>>2]=nF(t[u>>2]|0,0,t[a>>2]|0,t[o>>2]|0)|0;h=t[f>>2]|0;s=n;return h|0}t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}function pF(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0)if((t[(t[n>>2]|0)+4>>2]|0)==3){t[r>>2]=1;break}else{t[r>>2]=0;break}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function EF(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}if((t[(t[n>>2]|0)+4>>2]|0)!=3?(t[(t[n>>2]|0)+4>>2]|0)!=4:0){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}if(!(t[(t[n>>2]|0)+40>>2]|0)){t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}t[f>>2]=t[(t[n>>2]|0)+40>>2];e:while(1){if(!(u[t[f>>2]>>0]|0)){o=16;break}do if((u[t[f>>2]>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13){o=14;break e}}while(0);t[f>>2]=(t[f>>2]|0)+1}if((o|0)==14){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==16){t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}return 0}function SF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}if((((t[(t[u>>2]|0)+4>>2]|0)!=3?(t[(t[u>>2]|0)+4>>2]|0)!=4:0)?(t[(t[u>>2]|0)+4>>2]|0)!=8:0)?(t[(t[u>>2]|0)+4>>2]|0)!=7:0){
	t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}do if((t[(t[u>>2]|0)+40>>2]|0)==((t[u>>2]|0)+44|0))l=12;else{if(((t[(t[u>>2]|0)+32>>2]|0)!=0?(t[(t[(t[u>>2]|0)+32>>2]|0)+80>>2]|0)!=0:0)?(wz(t[(t[(t[u>>2]|0)+32>>2]|0)+80>>2]|0,t[(t[u>>2]|0)+40>>2]|0)|0)!=0:0){l=12;break}r=fs(t[(t[u>>2]|0)+40>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[(t[u>>2]|0)+40>>2]=r}while(0);if((l|0)==12){l=ts(t[(t[u>>2]|0)+40>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[(t[u>>2]|0)+40>>2]=l}t[(t[u>>2]|0)+44>>2]=0;if(!(t[(t[u>>2]|0)+40>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}return 0}function gF(){var e=0,i=0,r=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[r>>2]|0)){LF(75808);t[i>>2]=0;f=t[i>>2]|0;s=e;return f|0}t[(t[r>>2]|0)+4>>2]=0;t[(t[r>>2]|0)+8>>2]=t[33950];t[(t[r>>2]|0)+12>>2]=t[33948];u=gAi[t[135752>>2]&511](t[(t[r>>2]|0)+8>>2]|0)|0;t[t[r>>2]>>2]=u;if(!(t[t[r>>2]>>2]|0)){LF(75808);pAi[t[135736>>2]&511](t[r>>2]|0);t[i>>2]=0;f=t[i>>2]|0;s=e;return f|0}else{n[t[t[r>>2]>>2]>>0]=0;t[(t[r>>2]|0)+16>>2]=0;t[i>>2]=t[r>>2];f=t[i>>2]|0;s=e;return f|0}return 0}function yF(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+12>>2]|0)==3?(t[(t[r>>2]|0)+16>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);else n=5;if(((n|0)==5?(t[t[r>>2]>>2]|0)!=0:0)?(t[(t[r>>2]|0)+12>>2]|0)!=2:0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function FF(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[u>>2]=e;t[a>>2]=i;t[c>>2]=0;if(!(t[u>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}if((t[(t[u>>2]|0)+12>>2]|0)==2){t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}if((t[a>>2]|0)>>>0<(t[(t[u>>2]|0)+8>>2]|0)>>>0){t[f>>2]=1;b=t[f>>2]|0;s=r;return b|0}i=t[(t[u>>2]|0)+12>>2]|0;e:do if((i|0)==4){if((t[(t[u>>2]|0)+4>>2]|0)>>>0<4096){t[o>>2]=t[a>>2];break}t[o>>2]=t[(t[u>>2]|0)+8>>2]<<1;while(1){if((t[a>>2]|0)>>>0<=(t[o>>2]|0)>>>0)break e;if((t[o>>2]|0)>>>0>2147483647)break;t[o>>2]=t[o>>2]<<1}LF(75824);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else if((i|0)==1)t[o>>2]=(t[a>>2]|0)+10;else if((i|0)==0|(i|0)==3){if(t[(t[u>>2]|0)+8>>2]|0)k=t[(t[u>>2]|0)+8>>2]<<1;else k=(t[a>>2]|0)+10|0;t[o>>2]=k;while(1){if((t[a>>2]|0)>>>0<=(t[o>>2]|0)>>>0)break e;if((t[o>>2]|0)>>>0>2147483647)break;t[o>>2]=t[o>>2]<<1}LF(75824);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else t[o>>2]=(t[a>>2]|0)+10;while(0);do if((t[(t[u>>2]|0)+12>>2]|0)==3?(t[(t[u>>2]|0)+16>>2]|0)!=0:0){t[l>>2]=(t[t[u>>2]>>2]|0)-(t[(t[u>>2]|0)+16>>2]|0);if((t[l>>2]|0)>>>0>(t[o>>2]|0)>>>0){GY(t[(t[u>>2]|0)+16>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0;t[t[u>>2]>>2]=t[(t[u>>2]|0)+16>>2];n[(t[t[u>>2]>>2]|0)+(t[(t[u>>2]|0)+4>>2]|0)>>0]=0;a=(t[u>>2]|0)+8|0;t[a>>2]=(t[a>>2]|0)+(t[l>>2]|0);break}t[c>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+16>>2]|0,(t[l>>2]|0)+(t[o>>2]|0)|0)|0;if(t[c>>2]|0){t[(t[u>>2]|0)+16>>2]=t[c>>2];t[t[u>>2]>>2]=(t[c>>2]|0)+(t[l>>2]|0);break}LF(75824);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}else h=32;while(0);do if((h|0)==32){do if(t[t[u>>2]>>2]|0){if(((t[(t[u>>2]|0)+8>>2]|0)-(t[(t[u>>2]|0)+4>>2]|0)|0)>>>0<100){t[c>>2]=MAi[t[135760>>2]&511](t[t[u>>2]>>2]|0,t[o>>2]|0)|0;break}t[c>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;if(t[c>>2]|0){YY(t[c>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0;pAi[t[135736>>2]&511](t[t[u>>2]>>2]|0);n[(t[c>>2]|0)+(t[(t[u>>2]|0)+4>>2]|0)>>0]=0}}else t[c>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;while(0);if(t[c>>2]|0){t[t[u>>2]>>2]=t[c>>2];break}LF(75824);t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}while(0);t[(t[u>>2]|0)+8>>2]=t[o>>2];t[f>>2]=1;b=t[f>>2]|0;s=r;return b|0}function OF(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;do if((t[o>>2]|0)==0|(t[a>>2]|0)==0)t[u>>2]=-1;else{if((t[(t[a>>2]|0)+12>>2]|0)==2){t[u>>2]=-1;break}if((t[c>>2]|0)<-1){t[u>>2]=-1;break}if(!(t[c>>2]|0)){t[u>>2]=0;break}if((t[c>>2]|0)<0)t[c>>2]=rs(t[o>>2]|0)|0;if((t[c>>2]|0)<0){t[u>>2]=-1;break}if(!(t[c>>2]|0)){t[u>>2]=0;break}t[l>>2]=(t[(t[a>>2]|0)+4>>2]|0)+(t[c>>2]|0)+2;if((t[l>>2]|0)>>>0>(t[(t[a>>2]|0)+8>>2]|0)>>>0?(FF(t[a>>2]|0,t[l>>2]|0)|0)==0:0){LF(75824);t[u>>2]=2;break}GY((t[t[a>>2]>>2]|0)+(t[(t[a>>2]|0)+4>>2]|0)|0,t[o>>2]|0,t[c>>2]|0)|0;r=(t[a>>2]|0)+4|0;t[r>>2]=(t[r>>2]|0)+(t[c>>2]|0);n[(t[t[a>>2]>>2]|0)+(t[(t[a>>2]|0)+4>>2]|0)>>0]=0;t[u>>2]=0}while(0);s=f;return t[u>>2]|0}function AF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){if((t[(t[f>>2]|0)+12>>2]|0)==2){t[n>>2]=-1;break}if(!(t[u>>2]|0)){t[n>>2]=-1;break}else{t[n>>2]=OF(t[f>>2]|0,t[u>>2]|0,-1)|0;break}}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function MF(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if(!(t[u>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}if((t[(t[u>>2]|0)+12>>2]|0)==2){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}if(!(t[a>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=t[a>>2];while(1){l=t[(t[u>>2]|0)+4>>2]|0;if(!(n[t[o>>2]>>0]|0)){b=13;break}if((l+10|0)>>>0>=(t[(t[u>>2]|0)+8>>2]|0)>>>0?(FF(t[u>>2]|0,(t[(t[u>>2]|0)+4>>2]|0)+10|0)|0)==0:0){b=11;break}a=n[t[o>>2]>>0]|0;i=(t[u>>2]|0)+4|0;e=t[i>>2]|0;t[i>>2]=e+1;n[(t[t[u>>2]>>2]|0)+e>>0]=a;t[o>>2]=(t[o>>2]|0)+1}if((b|0)==11){LF(75824);t[f>>2]=2;c=t[f>>2]|0;s=r;return c|0}else if((b|0)==13){n[(t[t[u>>2]>>2]|0)+l>>0]=0;t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}return 0}function RF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+12>>2]|0)==2){s=r;return}AF(t[n>>2]|0,t[f>>2]|0)|0;s=r;return}function NF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+12>>2]|0)==2){s=r;return}MF(t[n>>2]|0,t[f>>2]|0)|0;s=r;return}function TF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+12>>2]|0)==2){s=r;return}if(!(es(t[f>>2]|0,34)|0)){MF(t[n>>2]|0,75840)|0;AF(t[n>>2]|0,t[f>>2]|0)|0;MF(t[n>>2]|0,75840)|0;s=r;return}i=(es(t[f>>2]|0,39)|0)!=0;e=t[n>>2]|0;if(!i){MF(e,75856)|0;AF(t[n>>2]|0,t[f>>2]|0)|0;MF(t[n>>2]|0,75856)|0;s=r;return}MF(e,75840)|0;e=t[f>>2]|0;t[a>>2]=e;t[o>>2]=e;while(1){if(!(u[t[a>>2]>>0]|0))break;if((u[t[a>>2]>>0]|0|0)!=34){t[a>>2]=(t[a>>2]|0)+1;continue}if((t[o>>2]|0)!=(t[a>>2]|0))OF(t[n>>2]|0,t[o>>2]|0,(t[a>>2]|0)-(t[o>>2]|0)|0)|0;OF(t[n>>2]|0,75848,6)|0;t[a>>2]=(t[a>>2]|0)+1;t[o>>2]=t[a>>2]}if((t[o>>2]|0)!=(t[a>>2]|0))OF(t[n>>2]|0,t[o>>2]|0,(t[a>>2]|0)-(t[o>>2]|0)|0)|0;MF(t[n>>2]|0,75840)|0;s=r;return}function LF(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;dp(2,2,0,0,t[r>>2]|0);s=i;return}function DF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;r=t[f>>2]|0;if((r|0)==1302)t[o>>2]=76032;else if((r|0)==1300)t[o>>2]=75952;else if((r|0)==1301)t[o>>2]=75992;else if((r|0)==1303)t[o>>2]=76072;else t[o>>2]=76096;dp(2,t[f>>2]|0,t[u>>2]|0,t[o>>2]|0,t[a>>2]|0);s=n;return}function CF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(((t[a>>2]|0)!=0?!((t[o>>2]|0)==0?1:(t[(t[a>>2]|0)+4>>2]|0)!=2):0)?(t[(t[o>>2]|0)+4>>2]|0)==2:0){if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)!=2:0)break;r=t[(t[a>>2]|0)+20>>2]|0;i=t[(t[o>>2]|0)+8>>2]|0;if(!(t[(t[o>>2]|0)+36>>2]|0))t[c>>2]=xy(r,i,0)|0;else t[c>>2]=xy(r,i,t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0)|0;if((t[(t[o>>2]|0)+32>>2]|0)!=(t[(t[a>>2]|0)+32>>2]|0))Ny(t[o>>2]|0,t[(t[a>>2]|0)+32>>2]|0);t[(t[o>>2]|0)+20>>2]=t[(t[a>>2]|0)+20>>2];t[(t[o>>2]|0)+28>>2]=t[u>>2];if(t[u>>2]|0){t[(t[o>>2]|0)+24>>2]=t[(t[u>>2]|0)+24>>2];t[(t[u>>2]|0)+24>>2]=t[o>>2];if(t[(t[o>>2]|0)+24>>2]|0)t[(t[(t[o>>2]|0)+24>>2]|0)+28>>2]=t[o>>2]}else{t[(t[o>>2]|0)+24>>2]=t[a>>2];t[(t[a>>2]|0)+28>>2]=t[o>>2]}if((t[(t[o>>2]|0)+28>>2]|0)==0?(t[(t[o>>2]|0)+20>>2]|0)!=0:0)t[(t[(t[o>>2]|0)+20>>2]|0)+44>>2]=t[o>>2];if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)!=16:0)my(t[c>>2]|0)|0;t[f>>2]=t[o>>2];l=t[f>>2]|0;s=n;return l|0}while(0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}function PF(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)!=1:0){do if((t[k>>2]|0)==1){if((t[(t[o>>2]|0)+32>>2]|0)!=0?(wz(t[(t[(t[o>>2]|0)+32>>2]|0)+80>>2]|0,t[l>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[l>>2]|0)}while(0);t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}t[h>>2]=gAi[t[135744>>2]&511](48)|0;if(!(t[h>>2]|0)){do if((t[k>>2]|0)==1){if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+32>>2]|0)!=0:0)?(wz(t[(t[(t[o>>2]|0)+32>>2]|0)+80>>2]|0,t[l>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[l>>2]|0)}while(0);LF(75320);t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}f=(t[h>>2]|0)+0|0;n=f+48|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(n|0));t[(t[h>>2]|0)+4>>2]=2;t[(t[h>>2]|0)+20>>2]=t[o>>2];if(t[o>>2]|0){t[w>>2]=t[(t[o>>2]|0)+32>>2];t[(t[h>>2]|0)+32>>2]=t[w>>2]}t[(t[h>>2]|0)+36>>2]=t[c>>2];do if(!(t[k>>2]|0)){if((t[w>>2]|0)!=0?(t[(t[w>>2]|0)+80>>2]|0)!=0:0){c=kz(t[(t[w>>2]|0)+80>>2]|0,t[l>>2]|0,-1)|0;t[(t[h>>2]|0)+8>>2]=c;break}c=Yl(t[l>>2]|0)|0;t[(t[h>>2]|0)+8>>2]=c}else t[(t[h>>2]|0)+8>>2]=t[l>>2];while(0);e:do if(t[b>>2]|0){if((ls(t[b>>2]|0)|0)==0?(DF(1303,t[w>>2]|0,0),(t[w>>2]|0)!=0):0){l=Yl(75792)|0;t[(t[w>>2]|0)+60>>2]=l}l=ay(t[w>>2]|0,t[b>>2]|0)|0;t[(t[h>>2]|0)+12>>2]=l;t[(t[h>>2]|0)+16>>2]=0;t[d>>2]=t[(t[h>>2]|0)+12>>2];while(1){if(!(t[d>>2]|0))break e;t[(t[d>>2]|0)+20>>2]=t[h>>2];if(!(t[(t[d>>2]|0)+24>>2]|0))t[(t[h>>2]|0)+16>>2]=t[d>>2];t[d>>2]=t[(t[d>>2]|0)+24>>2]}}while(0);do if(t[o>>2]|0){if(!(t[(t[o>>2]|0)+44>>2]|0)){t[(t[o>>2]|0)+44>>2]=t[h>>2];break}t[v>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[(t[v>>2]|0)+24>>2]|0))break;t[v>>2]=t[(t[v>>2]|0)+24>>2]}t[(t[v>>2]|0)+24>>2]=t[h>>2];t[(t[h>>2]|0)+28>>2]=t[v>>2]}while(0);if((t[b>>2]|0)!=0&(t[o>>2]|0)!=0?(VM(t[(t[o>>2]|0)+32>>2]|0,t[o>>2]|0,t[h>>2]|0)|0)==1:0)zM(0,t[(t[o>>2]|0)+32>>2]|0,t[b>>2]|0,t[h>>2]|0)|0;if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[h>>2]|0);t[a>>2]=t[h>>2];m=t[a>>2]|0;s=u;return m|0}function BF(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;f=s;s=s+48|0;u=f+44|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+8|0;v=f+4|0;m=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)!=0?!((t[o>>2]|0)==0?1:(t[(t[a>>2]|0)+4>>2]|0)!=1):0){e:do if(t[(t[a>>2]|0)+44>>2]|0){t[b>>2]=t[(t[a>>2]|0)+44>>2];if(!(t[c>>2]|0)){while(1){if((t[(t[b>>2]|0)+36>>2]|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,t[o>>2]|0)|0)!=0:0)break;t[b>>2]=t[(t[b>>2]|0)+24>>2];if(!(t[b>>2]|0))break e}t[u>>2]=t[b>>2];_=t[u>>2]|0;s=f;return _|0}while(1){if((t[(t[b>>2]|0)+36>>2]|0)!=0?(Xl(t[(t[b>>2]|0)+8>>2]|0,t[o>>2]|0)|0)!=0:0){if((t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0)==(t[c>>2]|0))break;if(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[c>>2]|0)|0)break}t[b>>2]=t[(t[b>>2]|0)+24>>2];if(!(t[b>>2]|0))break e}t[u>>2]=t[b>>2];_=t[u>>2]|0;s=f;return _|0}while(0);if(!(t[l>>2]|0)){t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}if((t[(t[a>>2]|0)+32>>2]|0)!=0?(t[(t[(t[a>>2]|0)+32>>2]|0)+44>>2]|0)!=0:0){t[k>>2]=t[(t[a>>2]|0)+32>>2];t[h>>2]=0;t[d>>2]=0;do if((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[d>>2]=Yl(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)|0;t[d>>2]=us(t[d>>2]|0,75864)|0;t[d>>2]=us(t[d>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if(t[d>>2]|0){t[w>>2]=t[d>>2];break}t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}else p=25;while(0);if((p|0)==25)t[w>>2]=t[(t[a>>2]|0)+8>>2];if(!(t[c>>2]|0)){t[h>>2]=QM(t[(t[k>>2]|0)+44>>2]|0,t[w>>2]|0,t[o>>2]|0,0)|0;if((t[h>>2]|0)==0?(t[(t[k>>2]|0)+48>>2]|0)!=0:0)t[h>>2]=QM(t[(t[k>>2]|0)+48>>2]|0,t[w>>2]|0,t[o>>2]|0,0)|0}else{t[v>>2]=hF(t[(t[a>>2]|0)+32>>2]|0,t[a>>2]|0)|0;if(!(t[v>>2]|0)){if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[m>>2]=t[v>>2];while(1){if(!(t[t[m>>2]>>2]|0))break;if(Xl(t[(t[t[m>>2]>>2]|0)+8>>2]|0,t[c>>2]|0)|0){t[h>>2]=QM(t[(t[k>>2]|0)+44>>2]|0,t[w>>2]|0,t[o>>2]|0,t[(t[t[m>>2]>>2]|0)+12>>2]|0)|0;if(t[h>>2]|0)break;if((t[(t[k>>2]|0)+48>>2]|0)!=0?(t[h>>2]=QM(t[(t[k>>2]|0)+48>>2]|0,t[w>>2]|0,t[o>>2]|0,t[(t[t[m>>2]>>2]|0)+12>>2]|0)|0,(t[h>>2]|0)!=0):0)break}t[m>>2]=(t[m>>2]|0)+4}pAi[t[135736>>2]&511](t[v>>2]|0)}if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);if((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+48>>2]|0)!=0:0){t[u>>2]=t[h>>2];_=t[u>>2]|0;s=f;return _|0}}t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}t[u>>2]=0;_=t[u>>2]|0;s=f;return _|0}function IF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[o>>2]|0)){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)!=1:0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}do if(!(t[a>>2]|0)){if(t[u>>2]|0){t[c>>2]=wy(t[u>>2]|0,t[(t[o>>2]|0)+8>>2]|0,0)|0;break}r=t[o>>2]|0;if(t[(t[o>>2]|0)+20>>2]|0){t[c>>2]=wy(t[(t[r+20>>2]|0)+32>>2]|0,t[(t[o>>2]|0)+8>>2]|0,0)|0;break}i=t[o>>2]|0;if(t[r+12>>2]|0){t[c>>2]=wy(t[(t[i+12>>2]|0)+32>>2]|0,t[(t[o>>2]|0)+8>>2]|0,0)|0;break}else{t[c>>2]=wy(0,t[i+8>>2]|0,0)|0;break}}else t[c>>2]=wy(t[(t[a>>2]|0)+32>>2]|0,t[(t[o>>2]|0)+8>>2]|0,0)|0;while(0);if(!(t[c>>2]|0)){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[(t[c>>2]|0)+20>>2]=t[a>>2];do if((t[a>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0){t[l>>2]=wF(t[(t[a>>2]|0)+32>>2]|0,t[a>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(t[l>>2]|0)if(Xl(t[(t[l>>2]|0)+8>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0)|0){t[(t[c>>2]|0)+36>>2]=t[l>>2];break}else{u=GF(t[(t[a>>2]|0)+32>>2]|0,t[a>>2]|0,t[(t[o>>2]|0)+36>>2]|0)|0;t[(t[c>>2]|0)+36>>2]=u;break}t[l>>2]=wF(t[(t[o>>2]|0)+32>>2]|0,t[(t[o>>2]|0)+20>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(t[l>>2]|0){t[b>>2]=t[a>>2];t[k>>2]=0;while(1){v=t[b>>2]|0;if(!(t[(t[b>>2]|0)+20>>2]|0))break;t[k>>2]=v;t[b>>2]=t[(t[b>>2]|0)+20>>2]}if((v|0)==(t[(t[a>>2]|0)+32>>2]|0))t[b>>2]=t[k>>2];u=Wg(t[b>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0;t[(t[c>>2]|0)+36>>2]=u}}else t[(t[c>>2]|0)+36>>2]=0;while(0);e:do if(t[(t[o>>2]|0)+12>>2]|0){l=xF(t[(t[o>>2]|0)+12>>2]|0,t[(t[c>>2]|0)+32>>2]|0,t[c>>2]|0)|0;t[(t[c>>2]|0)+12>>2]=l;t[(t[c>>2]|0)+16>>2]=0;t[h>>2]=t[(t[c>>2]|0)+12>>2];while(1){if(!(t[h>>2]|0))break e;if(!(t[(t[h>>2]|0)+24>>2]|0))t[(t[c>>2]|0)+16>>2]=t[h>>2];t[h>>2]=t[(t[h>>2]|0)+24>>2]}}while(0);if(((((((t[a>>2]|0)!=0&(t[o>>2]|0)!=0?(t[(t[a>>2]|0)+32>>2]|0)!=0:0)?(t[(t[o>>2]|0)+32>>2]|0)!=0:0)?(t[(t[(t[o>>2]|0)+32>>2]|0)+64>>2]|0)!=0:0)?(t[(t[o>>2]|0)+20>>2]|0)!=0:0)?(VM(t[(t[o>>2]|0)+32>>2]|0,t[(t[o>>2]|0)+20>>2]|0,t[o>>2]|0)|0)!=0:0)?(t[w>>2]=sy(t[(t[o>>2]|0)+32>>2]|0,t[(t[o>>2]|0)+12>>2]|0,1)|0,(t[w>>2]|0)!=0):0){zM(0,t[(t[a>>2]|0)+32>>2]|0,t[w>>2]|0,t[c>>2]|0)|0;pAi[t[135736>>2]&511](t[w>>2]|0)}t[f>>2]=t[c>>2];d=t[f>>2]|0;s=n;return d|0}function HF(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;if(!(t[o>>2]|0)){t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}switch(t[(t[o>>2]|0)+4>>2]|0){case 18:{t[a>>2]=Vy(t[o>>2]|0)|0;m=t[a>>2]|0;s=u;return m|0}case 10:case 12:case 14:case 15:case 16:case 17:{t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}case 2:{t[a>>2]=IF(t[c>>2]|0,t[l>>2]|0,t[o>>2]|0)|0;m=t[a>>2]|0;s=u;return m|0}case 9:case 13:case 21:{t[a>>2]=Jy(t[o>>2]|0,t[b>>2]|0)|0;m=t[a>>2]|0;s=u;return m|0}default:{t[k>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[k>>2]|0)){LF(75936);t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}n=(t[k>>2]|0)+0|0;r=n+60|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));t[(t[k>>2]|0)+4>>2]=t[(t[o>>2]|0)+4>>2];t[(t[k>>2]|0)+32>>2]=t[c>>2];t[(t[k>>2]|0)+20>>2]=t[l>>2];do if((t[(t[o>>2]|0)+8>>2]|0)!=75104){if((t[(t[o>>2]|0)+8>>2]|0)==75112){t[(t[k>>2]|0)+8>>2]=75112;break}if((t[(t[o>>2]|0)+8>>2]|0)==75128){t[(t[k>>2]|0)+8>>2]=75128;break}if(t[(t[o>>2]|0)+8>>2]|0){if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+80>>2]|0)!=0:0){n=kz(t[(t[c>>2]|0)+80>>2]|0,t[(t[o>>2]|0)+8>>2]|0,-1)|0;t[(t[k>>2]|0)+8>>2]=n;break}n=Yl(t[(t[o>>2]|0)+8>>2]|0)|0;t[(t[k>>2]|0)+8>>2]=n}}else t[(t[k>>2]|0)+8>>2]=75104;while(0);if(((((t[(t[o>>2]|0)+4>>2]|0)!=1?(t[(t[o>>2]|0)+40>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)!=5:0)?(t[(t[o>>2]|0)+4>>2]|0)!=20:0)?(t[(t[o>>2]|0)+4>>2]|0)!=19:0){n=Yl(t[(t[o>>2]|0)+40>>2]|0)|0;t[(t[k>>2]|0)+40>>2]=n}else _=27;if((_|0)==27?(t[(t[o>>2]|0)+4>>2]|0)==1:0)f[(t[k>>2]|0)+56>>1]=f[(t[o>>2]|0)+56>>1]|0;if(t[l>>2]|0){if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[k>>2]|0);t[h>>2]=Hy(t[l>>2]|0,t[k>>2]|0)|0;if((t[h>>2]|0)!=(t[k>>2]|0)){t[a>>2]=t[h>>2];m=t[a>>2]|0;s=u;return m|0}}do if(t[b>>2]|0){if(!((t[(t[o>>2]|0)+4>>2]|0)!=1?(t[(t[o>>2]|0)+4>>2]|0)!=19:0))_=37;if((_|0)==37?(t[(t[o>>2]|0)+48>>2]|0)!=0:0){h=Vy(t[(t[o>>2]|0)+48>>2]|0)|0;t[(t[k>>2]|0)+48>>2]=h}do if(t[(t[o>>2]|0)+36>>2]|0){t[w>>2]=wF(t[c>>2]|0,t[k>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(t[w>>2]|0){t[(t[k>>2]|0)+36>>2]=t[w>>2];break}t[w>>2]=wF(t[(t[o>>2]|0)+32>>2]|0,t[o>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(!(t[w>>2]|0)){h=GF(t[c>>2]|0,t[k>>2]|0,t[(t[o>>2]|0)+36>>2]|0)|0;t[(t[k>>2]|0)+36>>2]=h;break}t[d>>2]=t[k>>2];while(1){p=t[d>>2]|0;if(!(t[(t[d>>2]|0)+20>>2]|0))break;t[d>>2]=t[p+20>>2]}h=Wg(p,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+12>>2]|0)|0;t[(t[k>>2]|0)+36>>2]=h}while(0);if(!((t[(t[o>>2]|0)+4>>2]|0)!=1?(t[(t[o>>2]|0)+4>>2]|0)!=19:0))_=50;if((_|0)==50?(t[(t[o>>2]|0)+44>>2]|0)!=0:0){h=Yy(t[k>>2]|0,t[(t[o>>2]|0)+44>>2]|0)|0;t[(t[k>>2]|0)+44>>2]=h}if((t[(t[o>>2]|0)+4>>2]|0)==5){if((t[c>>2]|0)!=0?(t[(t[o>>2]|0)+32>>2]|0)==(t[c>>2]|0):0)t[(t[k>>2]|0)+12>>2]=t[(t[o>>2]|0)+12>>2];else{h=h_(t[c>>2]|0,t[(t[k>>2]|0)+8>>2]|0)|0;t[(t[k>>2]|0)+12>>2]=h}t[(t[k>>2]|0)+16>>2]=t[(t[k>>2]|0)+12>>2];break}if(((t[b>>2]|0)!=2?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)?(h=xF(t[(t[o>>2]|0)+12>>2]|0,t[c>>2]|0,t[k>>2]|0)|0,t[(t[k>>2]|0)+12>>2]=h,(t[k>>2]|0)!=0):0){t[v>>2]=t[(t[k>>2]|0)+12>>2];if(!(t[v>>2]|0)){t[(t[k>>2]|0)+16>>2]=0;break}while(1){h=(t[(t[v>>2]|0)+24>>2]|0)!=0;t[(t[v>>2]|0)+20>>2]=t[k>>2];E=t[v>>2]|0;if(!h)break;t[v>>2]=t[E+24>>2]}t[(t[k>>2]|0)+16>>2]=E}}while(0);if((t[l>>2]|0)==0&(t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[k>>2]|0);t[a>>2]=t[k>>2];m=t[a>>2]|0;s=u;return m|0}}return 0}function xF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[l>>2]=0;e:while(1){if(!(t[u>>2]|0)){k=19;break}do if((t[(t[u>>2]|0)+4>>2]|0)==14){if(!(t[a>>2]|0)){t[u>>2]=t[(t[u>>2]|0)+24>>2];continue e}if(t[(t[a>>2]|0)+44>>2]|0){t[b>>2]=t[(t[a>>2]|0)+44>>2];Hy(t[o>>2]|0,t[b>>2]|0)|0;break}t[b>>2]=Zy(t[u>>2]|0)|0;if(!(t[b>>2]|0)){k=8;break e}t[(t[b>>2]|0)+32>>2]=t[a>>2];t[(t[b>>2]|0)+20>>2]=t[o>>2];t[(t[a>>2]|0)+44>>2]=t[b>>2];Hy(t[o>>2]|0,t[b>>2]|0)|0}else t[b>>2]=HF(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,1)|0;while(0);if(!(t[b>>2]|0)){k=13;break}if(t[c>>2]|0){if((t[l>>2]|0)!=(t[b>>2]|0)){t[(t[l>>2]|0)+24>>2]=t[b>>2];t[(t[b>>2]|0)+28>>2]=t[l>>2];t[l>>2]=t[b>>2]}}else{t[(t[b>>2]|0)+28>>2]=0;r=t[b>>2]|0;t[l>>2]=r;t[c>>2]=r}t[u>>2]=t[(t[u>>2]|0)+24>>2]}if((k|0)==8){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}else if((k|0)==13){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}else if((k|0)==19){t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}return 0}function UF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+48>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+48>>2];t[n>>2]=rO(t[a>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function zF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+60>>2]|0)!=0:0){t[a>>2]=t[(t[f>>2]|0)+60>>2];t[n>>2]=rO(t[a>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function jF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=-1;if((t[u>>2]|0)>=5){t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}if(!(t[f>>2]|0)){t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}e:do if((((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=3:0)?(t[(t[f>>2]|0)+4>>2]|0)!=8:0)?(t[(t[f>>2]|0)+4>>2]|0)!=7:0){do if(t[(t[f>>2]|0)+28>>2]|0){if((((t[(t[(t[f>>2]|0)+28>>2]|0)+4>>2]|0)!=1?(t[(t[(t[f>>2]|0)+28>>2]|0)+4>>2]|0)!=3:0)?(t[(t[(t[f>>2]|0)+28>>2]|0)+4>>2]|0)!=8:0)?(t[(t[(t[f>>2]|0)+28>>2]|0)+4>>2]|0)!=7:0)break;t[o>>2]=jF(t[(t[f>>2]|0)+28>>2]|0,(t[u>>2]|0)+1|0)|0;break e}while(0);if((t[(t[f>>2]|0)+20>>2]|0)!=0?(t[(t[(t[f>>2]|0)+20>>2]|0)+4>>2]|0)==1:0)t[o>>2]=jF(t[(t[f>>2]|0)+20>>2]|0,(t[u>>2]|0)+1|0)|0}else l=9;while(0);if((l|0)==9){do if((a[(t[f>>2]|0)+56>>1]|0|0)==65535){if((t[(t[f>>2]|0)+4>>2]|0)==3?(t[(t[f>>2]|0)+52>>2]|0)!=0:0){t[o>>2]=t[(t[f>>2]|0)+52>>2];break}if((t[(t[f>>2]|0)+4>>2]|0)==1?(t[(t[f>>2]|0)+12>>2]|0)!=0:0){t[o>>2]=jF(t[(t[f>>2]|0)+12>>2]|0,(t[u>>2]|0)+1|0)|0;break}l=t[f>>2]|0;if(t[(t[f>>2]|0)+24>>2]|0){t[o>>2]=jF(t[l+24>>2]|0,(t[u>>2]|0)+1|0)|0;break}if(t[l+28>>2]|0)t[o>>2]=jF(t[(t[f>>2]|0)+28>>2]|0,(t[u>>2]|0)+1|0)|0}while(0);if((t[o>>2]|0)==-1|(t[o>>2]|0)==65535)t[o>>2]=a[(t[f>>2]|0)+56>>1]}t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}function VF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if(t[(t[n>>2]|0)+52>>2]|0){t[r>>2]=t[(t[n>>2]|0)+52>>2];u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[f>>2]|0)){LF(75904);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;t[(t[f>>2]|0)+4>>2]=18;e=Yl(75176)|0;t[(t[f>>2]|0)+8>>2]=e;e=Yl(75168)|0;t[(t[f>>2]|0)+12>>2]=e;t[(t[n>>2]|0)+52>>2]=t[f>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function qF(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+20|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[f+16>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;e:while(1){if(t[a>>2]|0)b=(t[a>>2]|0)!=(t[o>>2]|0);else b=0;k=t[a>>2]|0;if(!b){h=19;break}if((t[k+4>>2]|0)==5){h=8;break}if((t[(t[a>>2]|0)+4>>2]|0)==6){h=8;break}if((t[(t[a>>2]|0)+4>>2]|0)==17){h=8;break}i:do if((t[(t[a>>2]|0)+4>>2]|0)==1){t[l>>2]=t[(t[a>>2]|0)+48>>2];while(1){if(!(t[l>>2]|0))break i;if((t[c>>2]|0)==0?(t[(t[l>>2]|0)+12>>2]|0)==0:0){h=13;break e}if(((t[c>>2]|0)!=0?(t[(t[l>>2]|0)+12>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+12>>2]|0,t[c>>2]|0)|0)!=0:0){h=16;break e}t[l>>2]=t[t[l>>2]>>2]}}while(0);t[a>>2]=t[(t[a>>2]|0)+20>>2]}if((h|0)==8){t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}else if((h|0)==13){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}else if((h|0)==16){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}else if((h|0)==19)if((k|0)!=(t[o>>2]|0)){t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}else{t[u>>2]=1;w=t[u>>2]|0;s=f;return w|0}return 0}function YF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[n>>2]|0;if((t[(t[n>>2]|0)+4>>2]|0)!=2)if((t[e+4>>2]|0)==16){t[r>>2]=Yl(t[(t[n>>2]|0)+48>>2]|0)|0;u=t[r>>2]|0;s=i;return u|0}else{t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if(t[e+12>>2]|0){do if(!(t[(t[(t[n>>2]|0)+12>>2]|0)+24>>2]|0)){if((t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)!=3?(t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)!=4:0)break;t[r>>2]=Yl(t[(t[(t[n>>2]|0)+12>>2]|0)+40>>2]|0)|0;u=t[r>>2]|0;s=i;return u|0}while(0);t[f>>2]=sy(t[(t[n>>2]|0)+32>>2]|0,t[(t[n>>2]|0)+12>>2]|0,1)|0;if(t[f>>2]|0){t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}}t[r>>2]=Yl(75312)|0;u=t[r>>2]|0;s=i;return u|0}function GF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+96|0;f=n;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+32|0;k=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[k>>2]=1;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)==1:0){if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==18:0){t[l>>2]=rF(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0;if(t[l>>2]|0){t[u>>2]=t[l>>2];h=t[u>>2]|0;s=n;return h|0}if(!(t[(t[c>>2]|0)+12>>2]|0))SY(b,50,75656,f)|0;else{t[f>>2]=t[(t[c>>2]|0)+12>>2];SY(b,50,75872,f)|0}t[l>>2]=wF(t[a>>2]|0,t[o>>2]|0,b)|0;while(1){if(!(t[l>>2]|0)){w=20;break}if((t[k>>2]|0)>1e3){w=15;break}if(!(t[(t[c>>2]|0)+12>>2]|0)){r=t[k>>2]|0;t[k>>2]=r+1;t[f>>2]=r;SY(b,50,75880,f)|0}else{r=t[(t[c>>2]|0)+12>>2]|0;i=t[k>>2]|0;t[k>>2]=i+1;t[f>>2]=r;t[f+4>>2]=i;SY(b,50,75896,f)|0}t[l>>2]=wF(t[a>>2]|0,t[o>>2]|0,b)|0}if((w|0)==15){t[u>>2]=0;h=t[u>>2]|0;s=n;return h|0}else if((w|0)==20){t[l>>2]=Wg(t[o>>2]|0,t[(t[c>>2]|0)+8>>2]|0,b)|0;t[u>>2]=t[l>>2];h=t[u>>2]|0;s=n;return h|0}}t[u>>2]=0;h=t[u>>2]|0;s=n;return h|0}t[u>>2]=0;h=t[u>>2]|0;s=n;return h|0}function WF(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[n>>2]=(t[n>>2]|0)<=0?256:e;t[f>>2]=gAi[t[135744>>2]&511](20)|0;do if(t[f>>2]|0){t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+4>>2]=t[n>>2];t[(t[f>>2]|0)+8>>2]=0;e=gAi[t[135744>>2]&511]((t[n>>2]|0)*24|0)|0;t[t[f>>2]>>2]=e;if(!(t[t[f>>2]>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);break}VY(t[t[f>>2]>>2]|0,0,(t[n>>2]|0)*24|0)|0;e=oz()|0;t[(t[f>>2]|0)+16>>2]=e;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}while(0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function KF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=WF(t[n>>2]|0)|0;if(!(t[u>>2]|0)){a=t[u>>2]|0;s=r;return a|0}t[(t[u>>2]|0)+12>>2]=t[f>>2];sz(t[f>>2]|0)|0;a=t[u>>2]|0;s=r;return a|0}function XF(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;t[c>>2]=0;if(!(t[n>>2]|0)){s=r;return}if(t[t[n>>2]>>2]|0){t[l>>2]=t[(t[n>>2]|0)+8>>2];t[u>>2]=0;while(1){if(!((t[l>>2]|0)>0?(t[u>>2]|0)<(t[(t[n>>2]|0)+4>>2]|0):0))break;t[a>>2]=(t[t[n>>2]>>2]|0)+((t[u>>2]|0)*24|0);e:do if(t[(t[a>>2]|0)+20>>2]|0){t[c>>2]=1;while(1){if(!(t[a>>2]|0))break e;t[o>>2]=t[t[a>>2]>>2];if((t[f>>2]|0)!=0?(t[(t[a>>2]|0)+16>>2]|0)!=0:0)EAi[t[f>>2]&511](t[(t[a>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+4>>2]|0);if(!(t[(t[n>>2]|0)+12>>2]|0)){if(t[(t[a>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+4>>2]|0);if(t[(t[a>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+8>>2]|0);if(t[(t[a>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+12>>2]|0)}t[(t[a>>2]|0)+16>>2]=0;if(!(t[c>>2]|0))pAi[t[135736>>2]&511](t[a>>2]|0);t[l>>2]=(t[l>>2]|0)+-1;t[c>>2]=0;t[a>>2]=t[o>>2]}}while(0);t[u>>2]=(t[u>>2]|0)+1}pAi[t[135736>>2]&511](t[t[n>>2]>>2]|0)}if(t[(t[n>>2]|0)+12>>2]|0)bz(t[(t[n>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0);s=r;return}function ZF(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=JF(t[f>>2]|0,t[u>>2]|0,0,0,t[a>>2]|0)|0;s=n;return r|0}function JF(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+48|0;a=u+36|0;o=u+32|0;c=u+28|0;l=u+24|0;b=u+20|0;k=u+16|0;h=u+12|0;w=u+8|0;d=u+4|0;v=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(t[(t[o>>2]|0)+12>>2]|0){if((wz(t[(t[o>>2]|0)+12>>2]|0,t[c>>2]|0)|0)==0?(t[c>>2]=kz(t[(t[o>>2]|0)+12>>2]|0,t[c>>2]|0,-1)|0,(t[c>>2]|0)==0):0){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(((t[l>>2]|0)!=0?(wz(t[(t[o>>2]|0)+12>>2]|0,t[l>>2]|0)|0)==0:0)?(t[l>>2]=kz(t[(t[o>>2]|0)+12>>2]|0,t[l>>2]|0,-1)|0,(t[l>>2]|0)==0):0){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(((t[b>>2]|0)!=0?(wz(t[(t[o>>2]|0)+12>>2]|0,t[b>>2]|0)|0)==0:0)?(t[b>>2]=kz(t[(t[o>>2]|0)+12>>2]|0,t[b>>2]|0,-1)|0,(t[b>>2]|0)==0):0){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}}t[h>>2]=dO(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;do if(t[(t[t[o>>2]>>2]|0)+((t[h>>2]|0)*24|0)+20>>2]|0){f=(t[(t[o>>2]|0)+12>>2]|0)!=0;t[v>>2]=(t[t[o>>2]>>2]|0)+((t[h>>2]|0)*24|0);if(f){while(1){_=(t[(t[v>>2]|0)+4>>2]|0)==(t[c>>2]|0);if(!(t[t[v>>2]>>2]|0))break;if((_?(t[(t[v>>2]|0)+8>>2]|0)==(t[l>>2]|0):0)?(t[(t[v>>2]|0)+12>>2]|0)==(t[b>>2]|0):0){p=22;break}t[w>>2]=(t[w>>2]|0)+1;t[v>>2]=t[t[v>>2]>>2]}if((p|0)==22){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(!_)break;if((t[(t[v>>2]|0)+8>>2]|0)!=(t[l>>2]|0))break;if((t[(t[v>>2]|0)+12>>2]|0)!=(t[b>>2]|0))break;t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}else{while(1){f=(t[t[v>>2]>>2]|0)!=0;E=(Xl(t[(t[v>>2]|0)+4>>2]|0,t[c>>2]|0)|0)!=0;if(!f)break;if((E?(Xl(t[(t[v>>2]|0)+8>>2]|0,t[l>>2]|0)|0)!=0:0)?(Xl(t[(t[v>>2]|0)+12>>2]|0,t[b>>2]|0)|0)!=0:0){p=32;break}t[w>>2]=(t[w>>2]|0)+1;t[v>>2]=t[t[v>>2]>>2]}if((p|0)==32){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}if(!E)break;if(!(Xl(t[(t[v>>2]|0)+8>>2]|0,t[l>>2]|0)|0))break;if(!(Xl(t[(t[v>>2]|0)+12>>2]|0,t[b>>2]|0)|0))break;t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}}else t[v>>2]=0;while(0);if(t[v>>2]|0){t[d>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[d>>2]|0)){t[a>>2]=-1;m=t[a>>2]|0;s=u;return m|0}}else t[d>>2]=(t[t[o>>2]>>2]|0)+((t[h>>2]|0)*24|0);h=t[c>>2]|0;if(t[(t[o>>2]|0)+12>>2]|0){t[(t[d>>2]|0)+4>>2]=h;t[(t[d>>2]|0)+8>>2]=t[l>>2];t[(t[d>>2]|0)+12>>2]=t[b>>2]}else{c=Yl(h)|0;t[(t[d>>2]|0)+4>>2]=c;c=Yl(t[l>>2]|0)|0;t[(t[d>>2]|0)+8>>2]=c;c=Yl(t[b>>2]|0)|0;t[(t[d>>2]|0)+12>>2]=c}t[(t[d>>2]|0)+16>>2]=t[k>>2];t[t[d>>2]>>2]=0;t[(t[d>>2]|0)+20>>2]=1;if(t[v>>2]|0)t[t[v>>2]>>2]=t[d>>2];d=(t[o>>2]|0)+8|0;t[d>>2]=(t[d>>2]|0)+1;if((t[w>>2]|0)>>>0>8)vO(t[o>>2]|0,t[(t[o>>2]|0)+4>>2]<<3)|0;t[a>>2]=0;m=t[a>>2]|0;s=u;return m|0}function QF(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=JF(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,0,t[c>>2]|0)|0;s=f;return n|0}function $F(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=eO(t[u>>2]|0,t[a>>2]|0,0,0,t[o>>2]|0,t[c>>2]|0)|0;s=f;return n|0}function eO(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if((t[c>>2]|0)==0|(t[l>>2]|0)==0){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}if(t[(t[c>>2]|0)+12>>2]|0){if((wz(t[(t[c>>2]|0)+12>>2]|0,t[l>>2]|0)|0)==0?(t[l>>2]=kz(t[(t[c>>2]|0)+12>>2]|0,t[l>>2]|0,-1)|0,(t[l>>2]|0)==0):0){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}if(((t[b>>2]|0)!=0?(wz(t[(t[c>>2]|0)+12>>2]|0,t[b>>2]|0)|0)==0:0)?(t[b>>2]=kz(t[(t[c>>2]|0)+12>>2]|0,t[b>>2]|0,-1)|0,(t[b>>2]|0)==0):0){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}if(((t[k>>2]|0)!=0?(wz(t[(t[c>>2]|0)+12>>2]|0,t[k>>2]|0)|0)==0:0)?(t[k>>2]=kz(t[(t[c>>2]|0)+12>>2]|0,t[k>>2]|0,-1)|0,(t[k>>2]|0)==0):0){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}}t[d>>2]=dO(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;do if(t[(t[t[c>>2]>>2]|0)+((t[d>>2]|0)*24|0)+20>>2]|0){u=(t[(t[c>>2]|0)+12>>2]|0)!=0;t[m>>2]=(t[t[c>>2]>>2]|0)+((t[d>>2]|0)*24|0);if(u){while(1){p=(t[(t[m>>2]|0)+4>>2]|0)==(t[l>>2]|0);if(!(t[t[m>>2]>>2]|0))break;if((p?(t[(t[m>>2]|0)+8>>2]|0)==(t[b>>2]|0):0)?(t[(t[m>>2]|0)+12>>2]|0)==(t[k>>2]|0):0){E=22;break}t[m>>2]=t[t[m>>2]>>2]}if((E|0)==22){if(t[w>>2]|0)EAi[t[w>>2]&511](t[(t[m>>2]|0)+16>>2]|0,t[(t[m>>2]|0)+4>>2]|0);t[(t[m>>2]|0)+16>>2]=t[h>>2];t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}if(!p)break;if((t[(t[m>>2]|0)+8>>2]|0)!=(t[b>>2]|0))break;if((t[(t[m>>2]|0)+12>>2]|0)!=(t[k>>2]|0))break;if(t[w>>2]|0)EAi[t[w>>2]&511](t[(t[m>>2]|0)+16>>2]|0,t[(t[m>>2]|0)+4>>2]|0);t[(t[m>>2]|0)+16>>2]=t[h>>2];t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}else{while(1){u=(t[t[m>>2]>>2]|0)!=0;S=(Xl(t[(t[m>>2]|0)+4>>2]|0,t[l>>2]|0)|0)!=0;if(!u)break;if((S?(Xl(t[(t[m>>2]|0)+8>>2]|0,t[b>>2]|0)|0)!=0:0)?(Xl(t[(t[m>>2]|0)+12>>2]|0,t[k>>2]|0)|0)!=0:0){E=36;break}t[m>>2]=t[t[m>>2]>>2]}if((E|0)==36){if(t[w>>2]|0)EAi[t[w>>2]&511](t[(t[m>>2]|0)+16>>2]|0,t[(t[m>>2]|0)+4>>2]|0);t[(t[m>>2]|0)+16>>2]=t[h>>2];t[o>>2]=0;
	_=t[o>>2]|0;s=a;return _|0}if(!S)break;if(!(Xl(t[(t[m>>2]|0)+8>>2]|0,t[b>>2]|0)|0))break;if(!(Xl(t[(t[m>>2]|0)+12>>2]|0,t[k>>2]|0)|0))break;if(t[w>>2]|0)EAi[t[w>>2]&511](t[(t[m>>2]|0)+16>>2]|0,t[(t[m>>2]|0)+4>>2]|0);t[(t[m>>2]|0)+16>>2]=t[h>>2];t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}}else t[m>>2]=0;while(0);if(t[m>>2]|0){t[v>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[v>>2]|0)){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}}else t[v>>2]=(t[t[c>>2]>>2]|0)+((t[d>>2]|0)*24|0);d=t[l>>2]|0;if(t[(t[c>>2]|0)+12>>2]|0){t[(t[v>>2]|0)+4>>2]=d;t[(t[v>>2]|0)+8>>2]=t[b>>2];t[(t[v>>2]|0)+12>>2]=t[k>>2]}else{l=Yl(d)|0;t[(t[v>>2]|0)+4>>2]=l;l=Yl(t[b>>2]|0)|0;t[(t[v>>2]|0)+8>>2]=l;l=Yl(t[k>>2]|0)|0;t[(t[v>>2]|0)+12>>2]=l}t[(t[v>>2]|0)+16>>2]=t[h>>2];t[t[v>>2]>>2]=0;t[(t[v>>2]|0)+20>>2]=1;h=(t[c>>2]|0)+8|0;t[h>>2]=(t[h>>2]|0)+1;if(t[m>>2]|0)t[t[m>>2]>>2]=t[v>>2];t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}function iO(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0;u=s;s=s+32|0;a=u+16|0;o=u+12|0;c=u+8|0;l=u+4|0;b=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;f=eO(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,0,t[l>>2]|0,t[b>>2]|0)|0;s=u;return f|0}function rO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=nO(t[n>>2]|0,t[f>>2]|0,0,0)|0;s=r;return i|0}function nO(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(!(t[o>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}t[b>>2]=dO(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;if(!(t[(t[t[a>>2]>>2]|0)+((t[b>>2]|0)*24|0)+20>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}e:do if(t[(t[a>>2]|0)+12>>2]|0){t[k>>2]=(t[t[a>>2]>>2]|0)+((t[b>>2]|0)*24|0);while(1){if(!(t[k>>2]|0))break e;if(((t[(t[k>>2]|0)+4>>2]|0)==(t[o>>2]|0)?(t[(t[k>>2]|0)+8>>2]|0)==(t[c>>2]|0):0)?(t[(t[k>>2]|0)+12>>2]|0)==(t[l>>2]|0):0)break;t[k>>2]=t[t[k>>2]>>2]}t[u>>2]=t[(t[k>>2]|0)+16>>2];h=t[u>>2]|0;s=f;return h|0}while(0);t[k>>2]=(t[t[a>>2]>>2]|0)+((t[b>>2]|0)*24|0);while(1){if(!(t[k>>2]|0)){w=22;break}if(((Xl(t[(t[k>>2]|0)+4>>2]|0,t[o>>2]|0)|0)!=0?(Xl(t[(t[k>>2]|0)+8>>2]|0,t[c>>2]|0)|0)!=0:0)?(Xl(t[(t[k>>2]|0)+12>>2]|0,t[l>>2]|0)|0)!=0:0){w=20;break}t[k>>2]=t[t[k>>2]>>2]}if((w|0)==20){t[u>>2]=t[(t[k>>2]|0)+16>>2];h=t[u>>2]|0;s=f;return h|0}else if((w|0)==22){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}return 0}function fO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=nO(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0)|0;s=n;return r|0}function tO(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;o=s;s=s+48|0;c=o+36|0;l=o+32|0;b=o+28|0;k=o+24|0;h=o+20|0;w=o+16|0;d=o+12|0;v=o+8|0;m=o+4|0;_=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;if(!(t[l>>2]|0)){t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}if(!(t[k>>2]|0)){t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}t[m>>2]=mO(t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0)|0;if(!(t[(t[t[l>>2]>>2]|0)+((t[m>>2]|0)*24|0)+20>>2]|0)){t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}t[_>>2]=(t[t[l>>2]>>2]|0)+((t[m>>2]|0)*24|0);while(1){if(!(t[_>>2]|0)){E=14;break}if(((Zl(t[b>>2]|0,t[k>>2]|0,t[(t[_>>2]|0)+4>>2]|0)|0)!=0?(Zl(t[h>>2]|0,t[w>>2]|0,t[(t[_>>2]|0)+8>>2]|0)|0)!=0:0)?(Zl(t[d>>2]|0,t[v>>2]|0,t[(t[_>>2]|0)+12>>2]|0)|0)!=0:0){E=12;break}t[_>>2]=t[t[_>>2]>>2]}if((E|0)==12){t[c>>2]=t[(t[_>>2]|0)+16>>2];p=t[c>>2]|0;s=o;return p|0}else if((E|0)==14){t[c>>2]=0;p=t[c>>2]|0;s=o;return p|0}return 0}function uO(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0;u=s;s=s+32|0;a=u+16|0;o=u+12|0;c=u+8|0;l=u+4|0;b=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;f=tO(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,0,0)|0;s=u;return f|0}function aO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o+4>>2]=t[a>>2];t[o>>2]=t[u>>2];oO(t[f>>2]|0,229,o);s=n;return}function oO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){s=n;return}if(!(t[t[f>>2]>>2]|0)){s=n;return}t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[f>>2]|0)+4>>2]|0))break;e:do if(t[(t[t[f>>2]>>2]|0)+((t[o>>2]|0)*24|0)+20>>2]|0){t[l>>2]=(t[t[f>>2]>>2]|0)+((t[o>>2]|0)*24|0);while(1){if(!(t[l>>2]|0))break e;t[b>>2]=t[t[l>>2]>>2];t[c>>2]=t[(t[f>>2]|0)+8>>2];if((t[u>>2]|0)!=0?(t[(t[l>>2]|0)+16>>2]|0)!=0:0)mAi[t[u>>2]&511](t[(t[l>>2]|0)+16>>2]|0,t[a>>2]|0,t[(t[l>>2]|0)+4>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+12>>2]|0);if((t[c>>2]|0)==(t[(t[f>>2]|0)+8>>2]|0)){t[l>>2]=t[b>>2];continue}if((t[l>>2]|0)!=((t[t[f>>2]>>2]|0)+((t[o>>2]|0)*24|0)|0)){t[l>>2]=t[b>>2];continue}if(!(t[(t[t[f>>2]>>2]|0)+((t[o>>2]|0)*24|0)+20>>2]|0))t[l>>2]=0;if((t[(t[t[f>>2]>>2]|0)+((t[o>>2]|0)*24|0)>>2]|0)==(t[b>>2]|0))continue;t[l>>2]=(t[t[f>>2]>>2]|0)+((t[o>>2]|0)*24|0)}}while(0);t[o>>2]=(t[o>>2]|0)+1}s=n;return}function cO(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;lO(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0);s=a;return}function lO(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;if((t[o>>2]|0)==0|(t[k>>2]|0)==0){s=a;return}if(!(t[t[o>>2]>>2]|0)){s=a;return}t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[(t[o>>2]|0)+4>>2]|0))break;e:do if(t[(t[t[o>>2]>>2]|0)+((t[w>>2]|0)*24|0)+20>>2]|0){t[d>>2]=(t[t[o>>2]>>2]|0)+((t[w>>2]|0)*24|0);while(1){if(!(t[d>>2]|0))break e;t[v>>2]=t[t[d>>2]>>2];if(!((t[c>>2]|0)!=0?(Xl(t[c>>2]|0,t[(t[d>>2]|0)+4>>2]|0)|0)==0:0))m=10;do if((m|0)==10){m=0;if((t[l>>2]|0)!=0?(Xl(t[l>>2]|0,t[(t[d>>2]|0)+8>>2]|0)|0)==0:0)break;if((t[b>>2]|0)!=0?(Xl(t[b>>2]|0,t[(t[d>>2]|0)+12>>2]|0)|0)==0:0)break;if(t[(t[d>>2]|0)+16>>2]|0)mAi[t[k>>2]&511](t[(t[d>>2]|0)+16>>2]|0,t[h>>2]|0,t[(t[d>>2]|0)+4>>2]|0,t[(t[d>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+12>>2]|0)}while(0);t[d>>2]=t[v>>2]}}while(0);t[w>>2]=(t[w>>2]|0)+1}s=a;return}function sO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if(!(t[u>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[l>>2]=WF(t[(t[f>>2]|0)+4>>2]|0)|0;if(!(t[l>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}e:do if(t[t[f>>2]>>2]|0){t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[f>>2]|0)+4>>2]|0))break e;i:do if(t[(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)+20>>2]|0){t[o>>2]=(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0);while(1){if(!(t[o>>2]|0))break i;t[c>>2]=t[t[o>>2]>>2];i=t[l>>2]|0;e=t[(t[o>>2]|0)+4>>2]|0;k=t[(t[o>>2]|0)+8>>2]|0;h=t[(t[o>>2]|0)+12>>2]|0;JF(i,e,k,h,MAi[t[u>>2]&511](t[(t[o>>2]|0)+16>>2]|0,t[(t[o>>2]|0)+4>>2]|0)|0)|0;t[o>>2]=t[c>>2]}}while(0);t[a>>2]=(t[a>>2]|0)+1}}while(0);t[(t[l>>2]|0)+8>>2]=t[(t[f>>2]|0)+8>>2];t[n>>2]=t[l>>2];b=t[n>>2]|0;s=r;return b|0}function bO(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0))t[r>>2]=-1;else t[r>>2]=t[(t[n>>2]|0)+8>>2];s=i;return t[r>>2]|0}function kO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=hO(t[f>>2]|0,t[u>>2]|0,0,0,t[a>>2]|0)|0;s=n;return r|0}function hO(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;u=s;s=s+48|0;a=u+32|0;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;w=u+4|0;d=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[d>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}t[h>>2]=dO(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;if(!(t[(t[t[o>>2]>>2]|0)+((t[h>>2]|0)*24|0)+20>>2]|0)){t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}t[w>>2]=(t[t[o>>2]>>2]|0)+((t[h>>2]|0)*24|0);while(1){if(!(t[w>>2]|0)){m=27;break}if(((Xl(t[(t[w>>2]|0)+4>>2]|0,t[c>>2]|0)|0)!=0?(Xl(t[(t[w>>2]|0)+8>>2]|0,t[l>>2]|0)|0)!=0:0)?(Xl(t[(t[w>>2]|0)+12>>2]|0,t[b>>2]|0)|0)!=0:0)break;t[d>>2]=t[w>>2];t[w>>2]=t[t[w>>2]>>2]}if((m|0)==27){t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}if((t[k>>2]|0)!=0?(t[(t[w>>2]|0)+16>>2]|0)!=0:0)EAi[t[k>>2]&511](t[(t[w>>2]|0)+16>>2]|0,t[(t[w>>2]|0)+4>>2]|0);t[(t[w>>2]|0)+16>>2]=0;if(!(t[(t[o>>2]|0)+12>>2]|0)){if(t[(t[w>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[w>>2]|0)+4>>2]|0);if(t[(t[w>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[w>>2]|0)+8>>2]|0);if(t[(t[w>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[w>>2]|0)+12>>2]|0)}k=t[t[w>>2]>>2]|0;do if(!(t[d>>2]|0)){m=t[w>>2]|0;if(!k){t[m+20>>2]=0;break}else{t[w>>2]=t[m>>2];m=(t[t[o>>2]>>2]|0)+((t[h>>2]|0)*24|0)|0;b=t[w>>2]|0;t[m+0>>2]=t[b+0>>2];t[m+4>>2]=t[b+4>>2];t[m+8>>2]=t[b+8>>2];t[m+12>>2]=t[b+12>>2];t[m+16>>2]=t[b+16>>2];t[m+20>>2]=t[b+20>>2];pAi[t[135736>>2]&511](t[w>>2]|0);break}}else{t[t[d>>2]>>2]=k;pAi[t[135736>>2]&511](t[w>>2]|0)}while(0);w=(t[o>>2]|0)+8|0;t[w>>2]=(t[w>>2]|0)+-1;t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}function wO(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=hO(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,0,t[c>>2]|0)|0;s=f;return n|0}function dO(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;a=s;s=s+32|0;o=a+16|0;c=a+12|0;l=a+8|0;b=a+4|0;k=a;h=a+20|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;t[k>>2]=0;t[k>>2]=t[(t[o>>2]|0)+16>>2];e:do if(t[c>>2]|0){t[k>>2]=(t[k>>2]|0)+((u[t[c>>2]>>0]|0)*30|0);while(1){f=t[c>>2]|0;t[c>>2]=f+1;r=n[f>>0]|0;n[h>>0]=r;if(!(r<<24>>24))break e;t[k>>2]=t[k>>2]^(t[k>>2]<<5)+((t[k>>2]|0)>>>3)+(n[h>>0]|0)}}while(0);t[k>>2]=t[k>>2]^(t[k>>2]<<5)+((t[k>>2]|0)>>>3);e:do if(t[l>>2]|0)while(1){c=t[l>>2]|0;t[l>>2]=c+1;r=n[c>>0]|0;n[h>>0]=r;if(!(r<<24>>24))break e;t[k>>2]=t[k>>2]^(t[k>>2]<<5)+((t[k>>2]|0)>>>3)+(n[h>>0]|0)}while(0);t[k>>2]=t[k>>2]^(t[k>>2]<<5)+((t[k>>2]|0)>>>3);if(!(t[b>>2]|0)){w=t[k>>2]|0;d=t[o>>2]|0;v=d+4|0;m=t[v>>2]|0;_=(w>>>0)%(m>>>0)|0;s=a;return _|0}while(1){l=t[b>>2]|0;t[b>>2]=l+1;r=n[l>>0]|0;n[h>>0]=r;if(!(r<<24>>24))break;t[k>>2]=t[k>>2]^(t[k>>2]<<5)+((t[k>>2]|0)>>>3)+(n[h>>0]|0)}w=t[k>>2]|0;d=t[o>>2]|0;v=d+4|0;m=t[v>>2]|0;_=(w>>>0)%(m>>>0)|0;s=a;return _|0}function vO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}if((t[u>>2]|0)<8){t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}if((t[u>>2]|0)>16384){t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}t[o>>2]=t[(t[f>>2]|0)+4>>2];t[k>>2]=t[t[f>>2]>>2];if(!(t[k>>2]|0)){t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}i=gAi[t[135744>>2]&511]((t[u>>2]|0)*24|0)|0;t[t[f>>2]>>2]=i;if(!(t[t[f>>2]>>2]|0)){t[t[f>>2]>>2]=t[k>>2];t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}VY(t[t[f>>2]>>2]|0,0,(t[u>>2]|0)*24|0)|0;t[(t[f>>2]|0)+4>>2]=t[u>>2];t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[o>>2]|0))break;if(t[(t[k>>2]|0)+((t[c>>2]|0)*24|0)+20>>2]|0){t[a>>2]=dO(t[f>>2]|0,t[(t[k>>2]|0)+((t[c>>2]|0)*24|0)+4>>2]|0,t[(t[k>>2]|0)+((t[c>>2]|0)*24|0)+8>>2]|0,t[(t[k>>2]|0)+((t[c>>2]|0)*24|0)+12>>2]|0)|0;u=(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)|0;i=(t[k>>2]|0)+((t[c>>2]|0)*24|0)|0;t[u+0>>2]=t[i+0>>2];t[u+4>>2]=t[i+4>>2];t[u+8>>2]=t[i+8>>2];t[u+12>>2]=t[i+12>>2];t[u+16>>2]=t[i+16>>2];t[u+20>>2]=t[i+20>>2];t[(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)>>2]=0}t[c>>2]=(t[c>>2]|0)+1}t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[o>>2]|0))break;t[l>>2]=t[(t[k>>2]|0)+((t[c>>2]|0)*24|0)>>2];while(1){if(!(t[l>>2]|0))break;t[b>>2]=t[t[l>>2]>>2];t[a>>2]=dO(t[f>>2]|0,t[(t[l>>2]|0)+4>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+12>>2]|0)|0;i=(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)|0;if(!(t[(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)+20>>2]|0)){u=t[l>>2]|0;t[i+0>>2]=t[u+0>>2];t[i+4>>2]=t[u+4>>2];t[i+8>>2]=t[u+8>>2];t[i+12>>2]=t[u+12>>2];t[i+16>>2]=t[u+16>>2];t[i+20>>2]=t[u+20>>2];t[(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)>>2]=0;pAi[t[135736>>2]&511](t[l>>2]|0)}else{t[t[l>>2]>>2]=t[i>>2];t[(t[t[f>>2]>>2]|0)+((t[a>>2]|0)*24|0)>>2]=t[l>>2]}t[l>>2]=t[b>>2]}t[c>>2]=(t[c>>2]|0)+1}pAi[t[135736>>2]&511](t[k>>2]|0);t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}function mO(e,i,r,f,a,o,c){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;l=s;s=s+48|0;b=l+28|0;k=l+24|0;h=l+20|0;w=l+16|0;d=l+12|0;v=l+8|0;m=l+4|0;_=l;p=l+32|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=f;t[d>>2]=a;t[v>>2]=o;t[m>>2]=c;t[_>>2]=0;t[_>>2]=t[(t[b>>2]|0)+16>>2];if(t[k>>2]|0)t[_>>2]=(t[_>>2]|0)+((u[t[k>>2]>>0]|0)*30|0);else t[_>>2]=(t[_>>2]|0)+((u[t[h>>2]>>0]|0)*30|0);if(t[k>>2]|0){while(1){c=t[k>>2]|0;t[k>>2]=c+1;o=n[c>>0]|0;n[p>>0]=o;E=t[_>>2]|0;S=(t[_>>2]<<5)+((t[_>>2]|0)>>>3)|0;if(!(o<<24>>24))break;t[_>>2]=E^S+(n[p>>0]|0)}t[_>>2]=E^S+58}e:do if(t[h>>2]|0)while(1){S=t[h>>2]|0;t[h>>2]=S+1;E=n[S>>0]|0;n[p>>0]=E;if(!(E<<24>>24))break e;t[_>>2]=t[_>>2]^(t[_>>2]<<5)+((t[_>>2]|0)>>>3)+(n[p>>0]|0)}while(0);t[_>>2]=t[_>>2]^(t[_>>2]<<5)+((t[_>>2]|0)>>>3);if(t[w>>2]|0){while(1){h=t[w>>2]|0;t[w>>2]=h+1;E=n[h>>0]|0;n[p>>0]=E;g=t[_>>2]|0;y=(t[_>>2]<<5)+((t[_>>2]|0)>>>3)|0;if(!(E<<24>>24))break;t[_>>2]=g^y+(n[p>>0]|0)}t[_>>2]=g^y+58}e:do if(t[d>>2]|0)while(1){y=t[d>>2]|0;t[d>>2]=y+1;g=n[y>>0]|0;n[p>>0]=g;if(!(g<<24>>24))break e;t[_>>2]=t[_>>2]^(t[_>>2]<<5)+((t[_>>2]|0)>>>3)+(n[p>>0]|0)}while(0);t[_>>2]=t[_>>2]^(t[_>>2]<<5)+((t[_>>2]|0)>>>3);if(t[v>>2]|0){while(1){d=t[v>>2]|0;t[v>>2]=d+1;g=n[d>>0]|0;n[p>>0]=g;F=t[_>>2]|0;O=(t[_>>2]<<5)+((t[_>>2]|0)>>>3)|0;if(!(g<<24>>24))break;t[_>>2]=F^O+(n[p>>0]|0)}t[_>>2]=F^O+58}if(!(t[m>>2]|0)){A=t[_>>2]|0;M=t[b>>2]|0;R=M+4|0;N=t[R>>2]|0;T=(A>>>0)%(N>>>0)|0;s=l;return T|0}while(1){O=t[m>>2]|0;t[m>>2]=O+1;F=n[O>>0]|0;n[p>>0]=F;if(!(F<<24>>24))break;t[_>>2]=t[_>>2]^(t[_>>2]<<5)+((t[_>>2]|0)>>>3)+(n[p>>0]|0)}A=t[_>>2]|0;M=t[b>>2]|0;R=M+4|0;N=t[R>>2]|0;T=(A>>>0)%(N>>>0)|0;s=l;return T|0}function _O(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0;u=s;s=s+32|0;a=u+20|0;o=u+16|0;c=u+12|0;l=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[u+8>>2]=n;t[u+4>>2]=f;t[l>>2]=t[o>>2];yAi[t[t[l>>2]>>2]&511](t[a>>2]|0,t[(t[l>>2]|0)+4>>2]|0,t[c>>2]|0);s=u;return}function pO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;do if(!(t[u>>2]|0)){if(!(t[(ii()|0)>>2]|0)){t[u>>2]=0;break}if((t[(ii()|0)>>2]|0)==13){t[u>>2]=1501;break}if((t[(ii()|0)>>2]|0)==11){t[u>>2]=1502;break}if((t[(ii()|0)>>2]|0)==9){t[u>>2]=1503;break}if((t[(ii()|0)>>2]|0)==74){t[u>>2]=1504;break}if((t[(ii()|0)>>2]|0)==16){t[u>>2]=1505;break}if((t[(ii()|0)>>2]|0)==125){t[u>>2]=1506;break}if((t[(ii()|0)>>2]|0)==10){t[u>>2]=1507;break}if((t[(ii()|0)>>2]|0)==35){t[u>>2]=1508;break}if((t[(ii()|0)>>2]|0)==33){t[u>>2]=1509;break}if((t[(ii()|0)>>2]|0)==17){t[u>>2]=1510;break}if((t[(ii()|0)>>2]|0)==14){t[u>>2]=1511;break}if((t[(ii()|0)>>2]|0)==27){t[u>>2]=1512;break}if((t[(ii()|0)>>2]|0)==115){t[u>>2]=1513;break}if((t[(ii()|0)>>2]|0)==4){t[u>>2]=1514;break}if((t[(ii()|0)>>2]|0)==22){t[u>>2]=1515;break}if((t[(ii()|0)>>2]|0)==5){t[u>>2]=1516;break}if((t[(ii()|0)>>2]|0)==21){t[u>>2]=1517;break}if((t[(ii()|0)>>2]|0)==24){t[u>>2]=1518;break}if((t[(ii()|0)>>2]|0)==31){t[u>>2]=1519;break}if((t[(ii()|0)>>2]|0)==90){t[u>>2]=1520;break}if((t[(ii()|0)>>2]|0)==36){t[u>>2]=1521;break}if((t[(ii()|0)>>2]|0)==23){t[u>>2]=1522;break}if((t[(ii()|0)>>2]|0)==19){t[u>>2]=1523;break}if((t[(ii()|0)>>2]|0)==2){t[u>>2]=1524;break}if((t[(ii()|0)>>2]|0)==8){t[u>>2]=1525;break}if((t[(ii()|0)>>2]|0)==37){t[u>>2]=1526;break}if((t[(ii()|0)>>2]|0)==12){t[u>>2]=1527;break}if((t[(ii()|0)>>2]|0)==28){t[u>>2]=1528;break}if((t[(ii()|0)>>2]|0)==38){t[u>>2]=1529;break}if((t[(ii()|0)>>2]|0)==20){t[u>>2]=1530;break}if((t[(ii()|0)>>2]|0)==39){t[u>>2]=1531;break}if((t[(ii()|0)>>2]|0)==95){t[u>>2]=1532;break}if((t[(ii()|0)>>2]|0)==25){t[u>>2]=1533;break}if((t[(ii()|0)>>2]|0)==6){t[u>>2]=1534;break}if((t[(ii()|0)>>2]|0)==1){t[u>>2]=1535;break}if((t[(ii()|0)>>2]|0)==32){t[u>>2]=1536;break}if((t[(ii()|0)>>2]|0)==34){t[u>>2]=1537;break}if((t[(ii()|0)>>2]|0)==30){t[u>>2]=1538;break}if((t[(ii()|0)>>2]|0)==29){t[u>>2]=1539;break}if((t[(ii()|0)>>2]|0)==3){t[u>>2]=1540;break}if((t[(ii()|0)>>2]|0)==110){t[u>>2]=1541;break}if((t[(ii()|0)>>2]|0)==18){t[u>>2]=1542;break}if((t[(ii()|0)>>2]|0)==88){t[u>>2]=1550;break}if((t[(ii()|0)>>2]|0)==106){t[u>>2]=1551;break}if((t[(ii()|0)>>2]|0)==111){t[u>>2]=1552;break}if((t[(ii()|0)>>2]|0)==110){t[u>>2]=1541;break}if((t[(ii()|0)>>2]|0)==101){t[u>>2]=1553;break}if((t[(ii()|0)>>2]|0)==98){t[u>>2]=1554;break}if((t[(ii()|0)>>2]|0)==115){t[u>>2]=1513;break}if((t[(ii()|0)>>2]|0)==114){t[u>>2]=1555;break}if((t[(ii()|0)>>2]|0)==97){t[u>>2]=1556;break}else{t[u>>2]=1500;break}}while(0);t[o>>2]=0;if((t[u>>2]|0)>=1500)t[o>>2]=(t[u>>2]|0)-1500;if((t[o>>2]|0)>>>0<57){c=t[f>>2]|0;l=t[u>>2]|0;b=t[o>>2]|0;k=76128+(b<<2)|0;h=t[k>>2]|0;w=t[a>>2]|0;dp(c,l,0,h,w);s=n;return}t[o>>2]=0;c=t[f>>2]|0;l=t[u>>2]|0;b=t[o>>2]|0;k=76128+(b<<2)|0;h=t[k>>2]|0;w=t[a>>2]|0;dp(c,l,0,h,w);s=n;return}function EO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+48|0;f=n;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[u>>2];t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;t[h>>2]=2;if(((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+212>>2]|0)!=0:0)?(t[(t[c>>2]|0)+172>>2]|0)==-1:0){s=n;return}if((t[c>>2]|0)!=0?(t[t[c>>2]>>2]|0)!=0:0){u=t[t[c>>2]>>2]|0;if(t[(t[c>>2]|0)+104>>2]|0){t[b>>2]=t[u+88>>2];t[h>>2]=2}else{t[b>>2]=t[u+84>>2];t[h>>2]=1}if((t[(t[t[c>>2]>>2]|0)+108>>2]|0)==-554844497)t[l>>2]=t[(t[t[c>>2]>>2]|0)+124>>2];t[k>>2]=t[(t[c>>2]|0)+4>>2]}u=t[l>>2]|0;l=t[b>>2]|0;b=t[k>>2]|0;k=t[c>>2]|0;c=t[h>>2]|0;h=t[o>>2]|0;r=t[a>>2]|0;t[f>>2]=t[o>>2];cp(u,l,b,k,0,8,1549,c,0,0,h,0,0,0,0,r,f);s=n;return}function SO(){var e=0,i=0;e=s;s=s+16|0;i=e;if(!(t[19090]|0)){s=e;return}t[i>>2]=(t[19092]|0)-1;while(1){if((t[i>>2]|0)<0)break;t[76376+(t[i>>2]<<4)>>2]=0;t[76380+(t[i>>2]<<4)>>2]=0;t[76384+(t[i>>2]<<4)>>2]=0;t[76388+(t[i>>2]<<4)>>2]=0;t[i>>2]=(t[i>>2]|0)+-1}t[19092]=0;t[19090]=0;s=e;return}function gO(){var e=0,i=0;e=s;s=s+16|0;i=e;if(!(t[19154]|0)){s=e;return}t[i>>2]=(t[19156]|0)-1;while(1){if((t[i>>2]|0)<0)break;t[76632+(t[i>>2]<<4)>>2]=0;t[76636+(t[i>>2]<<4)>>2]=0;t[76640+(t[i>>2]<<4)>>2]=0;t[76644+(t[i>>2]<<4)>>2]=0;t[i>>2]=(t[i>>2]|0)+-1}t[19156]=0;t[19154]=0;s=e;return}function yO(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+96|0;r=i+80|0;n=i+76|0;f=i;t[n>>2]=e;do if(t[n>>2]|0){if((ri(t[n>>2]|0,f|0)|0)==-1){t[r>>2]=0;break}if((t[f+12>>2]&61440|0)==16384){t[r>>2]=2;break}else{t[r>>2]=1;break}}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function FO(){return 0}function OO(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return 1}function AO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[f>>2]=cA(t[r>>2]|0)|0;if(t[f>>2]|0){u=t[f>>2]|0;s=i;return u|0}t[n>>2]=VA(t[r>>2]|0,0,0)|0;if(!(t[n>>2]|0)){u=t[f>>2]|0;s=i;return u|0}t[f>>2]=cA(t[n>>2]|0)|0;pAi[t[135736>>2]&511](t[n>>2]|0);u=t[f>>2]|0;s=i;return u|0}function MO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=Re(t[a>>2]|0,1,t[o>>2]|0,t[u>>2]|0)|0;if((t[c>>2]|0)<0)lA(0,76872);t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function RO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}t[f>>2]=t[n>>2];if((t[f>>2]|0)!=(t[_>>2]|0)?(t[f>>2]|0)!=(t[v>>2]|0):0){if((t[f>>2]|0)==(t[m>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}e=(Qe(t[n>>2]|0)|0)==-1;t[u>>2]=e?-1:0;if((t[u>>2]|0)<0)lA(0,76896);t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}t[u>>2]=Pe(t[f>>2]|0)|0;if((t[u>>2]|0)<0)lA(0,76880);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}function NO(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[19092]|0)>=15){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}else{t[76376+(t[19092]<<4)>>2]=t[a>>2];t[76380+(t[19092]<<4)>>2]=t[o>>2];t[76384+(t[19092]<<4)>>2]=t[c>>2];t[76388+(t[19092]<<4)>>2]=t[l>>2];t[19090]=1;l=t[19092]|0;t[19092]=l+1;t[u>>2]=l;b=t[u>>2]|0;s=f;return b|0}return 0}function TO(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[19156]|0)>=15){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}else{t[76632+(t[19156]<<4)>>2]=t[a>>2];t[76636+(t[19156]<<4)>>2]=t[o>>2];t[76640+(t[19156]<<4)>>2]=t[c>>2];t[76644+(t[19156]<<4)>>2]=t[l>>2];t[19154]=1;l=t[19156]|0;t[19156]=l+1;t[u>>2]=l;b=t[u>>2]|0;s=f;return b|0}return 0}function LO(){var e=0;e=s;if(t[19090]|0){s=e;return}NO(230,231,232,233)|0;t[19090]=1;s=e;return}function DO(){var e=0;e=s;if(t[19154]|0){s=e;return}TO(230,234,235,233)|0;t[19154]=1;s=e;return}function CO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[f>>2]|0)){kA(76912);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+36|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));e=vs(t[33950]<<1)|0;t[(t[f>>2]|0)+16>>2]=e;if(!(t[(t[f>>2]|0)+16>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}Es(t[(t[f>>2]|0)+16>>2]|0,0)|0;e=j_(t[n>>2]|0)|0;t[(t[f>>2]|0)+12>>2]=e;if(t[(t[f>>2]|0)+12>>2]|0){e=vs(t[33950]<<1)|0;t[(t[f>>2]|0)+20>>2]=e}else t[(t[f>>2]|0)+20>>2]=0;t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=0;t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+24>>2]=-1;t[(t[f>>2]|0)+32>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function PO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[f>>2]|0)){kA(76936);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;t[e+24>>2]=0;t[e+28>>2]=0;e=ds()|0;t[(t[f>>2]|0)+16>>2]=e;if(!(t[(t[f>>2]|0)+16>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if((ps(t[(t[f>>2]|0)+16>>2]|0)|0)==1)Es(t[(t[f>>2]|0)+16>>2]|0,0)|0;t[(t[f>>2]|0)+12>>2]=t[n>>2];do if(t[n>>2]|0){e=vs(4e3)|0;t[(t[f>>2]|0)+20>>2]=e;if(t[(t[f>>2]|0)+20>>2]|0){G_(t[f>>2]|0,1)|0;break}pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else t[(t[f>>2]|0)+20>>2]=0;while(0);t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=0;t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+24>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function BO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[f>>2]|0)){kA(76936);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;t[e+24>>2]=0;t[e+28>>2]=0;e=ds()|0;t[(t[f>>2]|0)+16>>2]=e;if(!(t[(t[f>>2]|0)+16>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}Es(t[(t[f>>2]|0)+16>>2]|0,3)|0;t[(t[f>>2]|0)+12>>2]=t[n>>2];do if(t[n>>2]|0){e=vs(4e3)|0;t[(t[f>>2]|0)+20>>2]=e;if(t[(t[f>>2]|0)+20>>2]|0){G_(t[f>>2]|0,1)|0;break}pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else t[(t[f>>2]|0)+20>>2]=0;while(0);t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=0;t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+24>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function IO(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+20>>2]|0){Ss(t[(t[r>>2]|0)+20>>2]|0);t[(t[r>>2]|0)+20>>2]=0}if(t[(t[r>>2]|0)+12>>2]|0)W_(t[(t[r>>2]|0)+12>>2]|0)|0;if(t[(t[r>>2]|0)+8>>2]|0)gAi[t[(t[r>>2]|0)+8>>2]&511](t[t[r>>2]>>2]|0)|0;if(t[(t[r>>2]|0)+16>>2]|0){Ss(t[(t[r>>2]|0)+16>>2]|0);t[(t[r>>2]|0)+16>>2]=0}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function HO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[u>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}if(t[(t[n>>2]|0)+4>>2]|0)xO(t[n>>2]|0)|0;if(t[(t[n>>2]|0)+8>>2]|0)t[u>>2]=gAi[t[(t[n>>2]|0)+8>>2]&511](t[t[n>>2]>>2]|0)|0;t[f>>2]=t[(t[n>>2]|0)+24>>2];if(t[(t[n>>2]|0)+20>>2]|0){Ss(t[(t[n>>2]|0)+20>>2]|0);t[(t[n>>2]|0)+20>>2]=0}if(t[(t[n>>2]|0)+12>>2]|0)W_(t[(t[n>>2]|0)+12>>2]|0)|0;if(t[(t[n>>2]|0)+16>>2]|0){Ss(t[(t[n>>2]|0)+16>>2]|0);t[(t[n>>2]|0)+16>>2]=0}if(t[(t[n>>2]|0)+28>>2]|0)t[u>>2]=-1;pAi[t[135736>>2]&511](t[n>>2]|0);t[r>>2]=(t[u>>2]|0)==0?t[f>>2]|0:t[u>>2]|0;a=t[r>>2]|0;s=i;return a|0}function xO(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=0;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+28>>2]|0)==0:0){e:do if((t[(t[n>>2]|0)+20>>2]|0)!=0?(t[(t[n>>2]|0)+12>>2]|0)!=0:0){while(1){t[f>>2]=G_(t[n>>2]|0,0)|0;if((t[f>>2]|0)<0)break;if(!(t[f>>2]|0))break e}lA(1544,0);t[(t[n>>2]|0)+28>>2]=1544;t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}while(0);if(((t[(t[n>>2]|0)+20>>2]|0)!=0?(t[(t[n>>2]|0)+12>>2]|0)!=0:0)?(t[(t[n>>2]|0)+4>>2]|0)!=0:0){f=t[(t[n>>2]|0)+4>>2]|0;e=t[t[n>>2]>>2]|0;o=Os(t[(t[n>>2]|0)+20>>2]|0)|0;c=Ts(t[(t[n>>2]|0)+20>>2]|0)|0;t[u>>2]=dAi[f&511](e,o,c)|0;if((t[u>>2]|0)>=0)ys(t[(t[n>>2]|0)+20>>2]|0,t[u>>2]|0)|0}else l=14;if(((l|0)==14?(t[(t[n>>2]|0)+4>>2]|0)!=0:0)?(l=t[(t[n>>2]|0)+4>>2]|0,c=t[t[n>>2]>>2]|0,o=Os(t[(t[n>>2]|0)+16>>2]|0)|0,e=Ts(t[(t[n>>2]|0)+16>>2]|0)|0,t[u>>2]=dAi[l&511](c,o,e)|0,(t[u>>2]|0)>=0):0)ys(t[(t[n>>2]|0)+16>>2]|0,t[u>>2]|0)|0;if((t[u>>2]|0)<0){lA(1545,0);t[(t[n>>2]|0)+28>>2]=1545;t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}else{e=(t[n>>2]|0)+24|0;t[e>>2]=(t[e>>2]|0)+(t[u>>2]|0);t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}}t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}function UO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[c>>2]=0;if(!(t[19090]|0))LO();if(!(t[f>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}e:do if(!(t[c>>2]|0)){t[o>>2]=(t[19092]|0)-1;while(1){if((t[o>>2]|0)<0)break e;if(((t[76376+(t[o>>2]<<4)>>2]|0)!=0?(gAi[t[76376+(t[o>>2]<<4)>>2]&511](t[f>>2]|0)|0)!=0:0)?(t[c>>2]=gAi[t[76376+(t[o>>2]<<4)+4>>2]&511](t[f>>2]|0)|0,(t[c>>2]|0)!=0):0)break e;t[o>>2]=(t[o>>2]|0)+-1}}while(0);if(!(t[c>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=CO(t[u>>2]|0)|0;if(t[a>>2]|0){t[t[a>>2]>>2]=t[c>>2];t[(t[a>>2]|0)+4>>2]=t[76384+(t[o>>2]<<4)>>2];t[(t[a>>2]|0)+8>>2]=t[76388+(t[o>>2]<<4)>>2]}else gAi[t[76376+(t[o>>2]<<4)+12>>2]&511](t[c>>2]|0)|0;t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}function zO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(t[33972]|0){t[n>>2]=MAi[t[135888>>2]&511](t[f>>2]|0,t[u>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=UO(t[f>>2]|0,t[u>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}return 0}function jO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[n+20>>2]=r;t[l>>2]=0;t[b>>2]=0;t[k>>2]=0;if(!(t[19154]|0))DO();if(!(t[u>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[c>>2]=IA(t[u>>2]|0)|0;if(t[c>>2]|0){if(!((t[t[c>>2]>>2]|0)!=0?(Xl(t[t[c>>2]>>2]|0,76960)|0)==0:0))t[k>>2]=VA(t[u>>2]|0,0,0)|0;xA(t[c>>2]|0)}if(t[k>>2]|0){t[l>>2]=(t[19156]|0)-1;while(1){if((t[l>>2]|0)<0)break;if(((t[76632+(t[l>>2]<<4)>>2]|0)!=0?(gAi[t[76632+(t[l>>2]<<4)>>2]&511](t[k>>2]|0)|0)!=0:0)?(t[b>>2]=gAi[t[76632+(t[l>>2]<<4)+4>>2]&511](t[k>>2]|0)|0,(t[b>>2]|0)!=0):0)break;t[l>>2]=(t[l>>2]|0)+-1}pAi[t[135736>>2]&511](t[k>>2]|0)}e:do if(!(t[b>>2]|0)){t[l>>2]=(t[19156]|0)-1;while(1){if((t[l>>2]|0)<0)break e;if(((t[76632+(t[l>>2]<<4)>>2]|0)!=0?(gAi[t[76632+(t[l>>2]<<4)>>2]&511](t[u>>2]|0)|0)!=0:0)?(t[b>>2]=gAi[t[76632+(t[l>>2]<<4)+4>>2]&511](t[u>>2]|0)|0,(t[b>>2]|0)!=0):0)break e;t[l>>2]=(t[l>>2]|0)+-1}}while(0);if(!(t[b>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[o>>2]=BO(t[a>>2]|0)|0;if(t[o>>2]|0){t[t[o>>2]>>2]=t[b>>2];t[(t[o>>2]|0)+4>>2]=t[76640+(t[l>>2]<<4)>>2];t[(t[o>>2]|0)+8>>2]=t[76644+(t[l>>2]<<4)>>2]}t[f>>2]=t[o>>2];h=t[f>>2]|0;s=n;return h|0}function VO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(t[33974]|0){t[f>>2]=dAi[t[135896>>2]&511](t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=jO(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}return 0}function qO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[19154]|0))DO();if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=BO(t[u>>2]|0)|0;if(t[a>>2]|0){t[t[a>>2]>>2]=t[f>>2];t[(t[a>>2]|0)+4>>2]=235;t[(t[a>>2]|0)+8>>2]=236}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function YO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)<0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=CO(t[u>>2]|0)|0;if(t[a>>2]|0){t[t[a>>2]>>2]=t[f>>2];t[(t[a>>2]|0)+4>>2]=237;t[(t[a>>2]|0)+8>>2]=238}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function GO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[a>>2]|0)<=0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}if(!(t[u>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=CO(t[o>>2]|0)|0;if((t[c>>2]|0)!=0?(t[t[c>>2]>>2]=t[u>>2],t[(t[c>>2]|0)+4>>2]=227,t[(t[c>>2]|0)+8>>2]=0,t[l>>2]=Ps(t[(t[c>>2]|0)+16>>2]|0,t[u>>2]|0,t[a>>2]|0)|0,(t[l>>2]|0)!=0):0){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function WO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[a>>2]|0)<=0){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if(!(t[u>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[c>>2]|0)){kA(76912);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=(t[c>>2]|0)+0|0;i=r+36|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));r=_s(t[u>>2]|0,t[a>>2]|0)|0;t[(t[c>>2]|0)+16>>2]=r;if(!(t[(t[c>>2]|0)+16>>2]|0)){pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=j_(t[o>>2]|0)|0;t[(t[c>>2]|0)+12>>2]=r;if(t[(t[c>>2]|0)+12>>2]|0){r=vs(t[33950]<<1)|0;t[(t[c>>2]|0)+20>>2]=r}else t[(t[c>>2]|0)+20>>2]=0;t[(t[c>>2]|0)+24>>2]=-1;t[t[c>>2]>>2]=t[u>>2];t[(t[c>>2]|0)+4>>2]=0;t[(t[c>>2]|0)+8>>2]=0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function KO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)<0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=BO(t[u>>2]|0)|0;if(t[a>>2]|0){t[t[a>>2]>>2]=t[f>>2];t[(t[a>>2]|0)+4>>2]=239;t[(t[a>>2]|0)+8>>2]=0}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function XO(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[b>>2]=CO(t[l>>2]|0)|0;if(t[b>>2]|0){t[t[b>>2]>>2]=t[c>>2];t[(t[b>>2]|0)+4>>2]=t[a>>2];t[(t[b>>2]|0)+8>>2]=t[o>>2]}t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}function ZO(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)<0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+28>>2]|0)==0:0){do if(!(t[(t[u>>2]|0)+12>>2]|0)){t[c>>2]=t[a>>2];t[l>>2]=Ps(t[(t[u>>2]|0)+16>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;if(t[l>>2]|0){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}}else{if(!(t[(t[u>>2]|0)+20>>2]|0)){r=ds()|0;t[(t[u>>2]|0)+20>>2]=r}t[l>>2]=Ps(t[(t[u>>2]|0)+20>>2]|0,t[o>>2]|0,t[a>>2]|0)|0;
	if(t[l>>2]|0){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}t[b>>2]=Ts(t[(t[u>>2]|0)+20>>2]|0)|0;t[c>>2]=Y_(t[u>>2]|0,1)|0;if((t[c>>2]|0)>=0){r=t[b>>2]|0;i=r-(Ts(t[(t[u>>2]|0)+20>>2]|0)|0)|0;r=(t[u>>2]|0)+32|0;t[r>>2]=(t[r>>2]|0)+i;break}lA(1544,0);t[(t[u>>2]|0)+28>>2]=1544;t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}while(0);t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}function JO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+28>>2]|0)==0:0){if((t[u>>2]|0)<=4e3&(t[u>>2]|0)!=4)t[u>>2]=4e3;if((Ls(t[(t[f>>2]|0)+16>>2]|0)|0)>>>0<=0){lA(1548,0);t[(t[f>>2]|0)+28>>2]=1548;t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}if((Fs(t[(t[f>>2]|0)+16>>2]|0,(t[u>>2]|0)+1|0)|0)<0){kA(76968);t[(t[f>>2]|0)+28>>2]=2;t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[a>>2]=As(t[(t[f>>2]|0)+16>>2]|0)|0;if(!(t[(t[f>>2]|0)+4>>2]|0)){lA(1547,0);t[(t[f>>2]|0)+28>>2]=1547;t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[o>>2]=dAi[t[(t[f>>2]|0)+4>>2]&511](t[t[f>>2]>>2]|0,t[a>>2]|0,t[u>>2]|0)|0;if((t[o>>2]|0)<=0)t[(t[f>>2]|0)+4>>2]=240;if((t[o>>2]|0)<0){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[u>>2]=t[o>>2];do if(t[(t[f>>2]|0)+12>>2]|0){if(!(t[(t[f>>2]|0)+20>>2]|0)){i=ds()|0;t[(t[f>>2]|0)+20>>2]=i}t[o>>2]=Ps(t[(t[f>>2]|0)+20>>2]|0,t[a>>2]|0,t[u>>2]|0)|0;if(t[o>>2]|0){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[l>>2]=Ts(t[(t[f>>2]|0)+20>>2]|0)|0;t[c>>2]=Y_(t[f>>2]|0,1)|0;if((t[c>>2]|0)>=0){i=t[l>>2]|0;e=i-(Ts(t[(t[f>>2]|0)+20>>2]|0)|0)|0;i=(t[f>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+e;break}lA(1544,0);t[(t[f>>2]|0)+28>>2]=1544;t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}else{t[c>>2]=t[u>>2];Ms(t[(t[f>>2]|0)+16>>2]|0,t[c>>2]|0)|0}while(0);t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}function QO(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+28>>2]|0)==0:0){i=t[f>>2]|0;if(t[(t[f>>2]|0)+4>>2]|0){t[n>>2]=JO(i,t[u>>2]|0)|0;break}if((ps(t[i+16>>2]|0)|0)==2){t[n>>2]=0;break}else{t[n>>2]=-1;break}}else a=3;while(0);if((a|0)==3)t[n>>2]=-1;s=r;return t[n>>2]|0}function $O(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[b>>2]=0;if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+28>>2]|0)==0:0){if((t[a>>2]|0)<0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(t[(t[u>>2]|0)+28>>2]|0){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}while(1){r=t[a>>2]|0;t[k>>2]=r;t[k>>2]=(t[k>>2]|0)>16e3?16e3:r;r=t[u>>2]|0;if(t[(t[u>>2]|0)+12>>2]|0){if(!(t[r+20>>2]|0)){i=ds()|0;t[(t[u>>2]|0)+20>>2]=i}t[l>>2]=Ps(t[(t[u>>2]|0)+16>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;if(t[l>>2]|0){w=12;break}if((Ts(t[(t[u>>2]|0)+16>>2]|0)|0)>>>0<4e3?(t[k>>2]|0)==(t[a>>2]|0):0){w=32;break}t[l>>2]=G_(t[u>>2]|0,0)|0;if((t[l>>2]|0)<0&(t[l>>2]|0)!=-3){w=16;break}t[c>>2]=Ts(t[(t[u>>2]|0)+20>>2]|0)|0}else{t[l>>2]=Ps(t[r+16>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;if(t[l>>2]|0){w=19;break}t[c>>2]=Ts(t[(t[u>>2]|0)+16>>2]|0)|0}t[o>>2]=(t[o>>2]|0)+(t[k>>2]|0);t[a>>2]=(t[a>>2]|0)-(t[k>>2]|0);if((t[c>>2]|0)<4e3&(t[a>>2]|0)<=0){w=32;break}if(t[(t[u>>2]|0)+4>>2]|0){r=t[(t[u>>2]|0)+4>>2]|0;i=t[t[u>>2]>>2]|0;e=t[u>>2]|0;if(t[(t[u>>2]|0)+12>>2]|0){d=Os(t[e+20>>2]|0)|0;t[l>>2]=dAi[r&511](i,d,t[c>>2]|0)|0;if((t[l>>2]|0)>=0)ys(t[(t[u>>2]|0)+20>>2]|0,t[l>>2]|0)|0}else{d=Os(t[e+16>>2]|0)|0;t[l>>2]=dAi[r&511](i,d,t[c>>2]|0)|0;if((t[l>>2]|0)>=0)ys(t[(t[u>>2]|0)+16>>2]|0,t[l>>2]|0)|0}if((t[l>>2]|0)<0){w=29;break}d=(t[u>>2]|0)+24|0;t[d>>2]=(t[d>>2]|0)+(t[l>>2]|0)}t[b>>2]=(t[b>>2]|0)+(t[c>>2]|0);if((t[a>>2]|0)<=0){w=32;break}}if((w|0)==12){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}else if((w|0)==16){lA(1544,0);t[(t[u>>2]|0)+28>>2]=1544;t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}else if((w|0)==19){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}else if((w|0)==29){lA(1546,0);t[(t[u>>2]|0)+28>>2]=1546;t[f>>2]=t[l>>2];h=t[f>>2]|0;s=n;return h|0}else if((w|0)==32){t[f>>2]=t[b>>2];h=t[f>>2]|0;s=n;return h|0}}t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}function eA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[b>>2]=0;t[k>>2]=0;if((((t[u>>2]|0)!=0?!((t[a>>2]|0)==0?1:(t[(t[u>>2]|0)+28>>2]|0)!=0):0)?(t[(t[u>>2]|0)+16>>2]|0)!=0:0)?(ps(t[(t[u>>2]|0)+16>>2]|0)|0)!=2:0){t[w>>2]=HY(t[a>>2]|0)|0;if((t[w>>2]|0)<0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if(t[(t[u>>2]|0)+28>>2]|0){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}if(!(t[o>>2]|0))t[o>>2]=241;while(1){t[k>>2]=t[b>>2];t[d>>2]=t[w>>2];t[h>>2]=(Ls(t[(t[u>>2]|0)+16>>2]|0)|0)-1;r=t[u>>2]|0;if((t[h>>2]|0)<40){if((Fs(t[r+16>>2]|0,100)|0)<0){m=14;break}t[k>>2]=-1}else{if(t[r+12>>2]|0){if(!(t[(t[u>>2]|0)+20>>2]|0)){r=ds()|0;t[(t[u>>2]|0)+20>>2]=r}r=t[o>>2]|0;i=As(t[(t[u>>2]|0)+16>>2]|0)|0;t[l>>2]=OAi[r&511](i,h,t[a>>2]|0,d)|0;if((t[l>>2]|0)<0|(t[h>>2]|0)==0){m=20;break}Ms(t[(t[u>>2]|0)+16>>2]|0,t[h>>2]|0)|0;if((Ts(t[(t[u>>2]|0)+16>>2]|0)|0)>>>0<4e3?(t[d>>2]|0)==(t[w>>2]|0):0){m=44;break}t[l>>2]=G_(t[u>>2]|0,0)|0;if((t[l>>2]|0)<0&(t[l>>2]|0)!=-3){m=24;break}t[c>>2]=Ts(t[(t[u>>2]|0)+20>>2]|0)|0}else{i=t[o>>2]|0;r=As(t[(t[u>>2]|0)+16>>2]|0)|0;t[l>>2]=OAi[i&511](r,h,t[a>>2]|0,d)|0;if((t[l>>2]|0)<0|(t[h>>2]|0)==0){m=27;break}Ms(t[(t[u>>2]|0)+16>>2]|0,t[h>>2]|0)|0;t[c>>2]=Ts(t[(t[u>>2]|0)+16>>2]|0)|0}t[a>>2]=(t[a>>2]|0)+(t[d>>2]|0);t[w>>2]=(t[w>>2]|0)-(t[d>>2]|0);if((t[c>>2]|0)<4e3&(t[w>>2]|0)<=0){m=44;break}r=t[u>>2]|0;if(!(t[(t[u>>2]|0)+4>>2]|0)){if((Ls(t[r+16>>2]|0)|0)>>>0<4e3)Fs(t[(t[u>>2]|0)+16>>2]|0,4e3)|0}else{i=t[(t[u>>2]|0)+4>>2]|0;e=t[t[u>>2]>>2]|0;_=t[u>>2]|0;if(t[r+12>>2]|0){r=Os(t[_+20>>2]|0)|0;t[l>>2]=dAi[i&511](e,r,t[c>>2]|0)|0;if((t[l>>2]|0)>=0)ys(t[(t[u>>2]|0)+20>>2]|0,t[l>>2]|0)|0}else{r=Os(t[_+16>>2]|0)|0;t[l>>2]=dAi[i&511](e,r,t[c>>2]|0)|0;if((t[l>>2]|0)>=0)ys(t[(t[u>>2]|0)+16>>2]|0,t[l>>2]|0)|0}if((t[l>>2]|0)<0){m=37;break}r=(t[u>>2]|0)+24|0;t[r>>2]=(t[r>>2]|0)+(t[l>>2]|0)}t[b>>2]=(t[b>>2]|0)+(t[c>>2]|0)}if((t[w>>2]|0)<=0){m=44;break}if((t[k>>2]|0)==(t[b>>2]|0)){m=44;break}}if((m|0)==14){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==20){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==24){lA(1544,0);t[(t[u>>2]|0)+28>>2]=1544;t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==27){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==37){lA(1546,0);t[(t[u>>2]|0)+28>>2]=1546;t[f>>2]=t[l>>2];v=t[f>>2]|0;s=n;return v|0}else if((m|0)==44){t[f>>2]=t[b>>2];v=t[f>>2]|0;s=n;return v|0}}t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}function iA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+28>>2]|0)==0:0){if(!(t[u>>2]|0)){t[n>>2]=-1;break}t[a>>2]=HY(t[u>>2]|0)|0;if((t[a>>2]|0)>0){t[n>>2]=$O(t[f>>2]|0,t[a>>2]|0,t[u>>2]|0)|0;break}else{t[n>>2]=t[a>>2];break}}else o=3;while(0);if((o|0)==3)t[n>>2]=-1;s=r;return t[n>>2]|0}function rA(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+1040|0;r=i+12|0;f=i+8|0;u=i+4|0;a=i+16|0;o=i;t[f>>2]=e;t[u>>2]=0;if(!(t[19090]|0))LO();if(!(t[f>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}zY(a|0,t[f>>2]|0,1023)|0;n[a+1023>>0]=0;t[o>>2]=a+(HY(a|0)|0);while(1){if((t[o>>2]|0)>>>0<=a>>>0)break;if((n[t[o>>2]>>0]|0)==47)break;t[o>>2]=(t[o>>2]|0)+-1}if((n[t[o>>2]>>0]|0)!=47){if(Me(a|0,1024)|0){n[a+1023>>0]=0;t[u>>2]=gAi[t[135768>>2]&511](a)|0}}else{if((t[o>>2]|0)==(a|0))n[a+1>>0]=0;else n[t[o>>2]>>0]=0;t[u>>2]=gAi[t[135768>>2]&511](a)|0}t[r>>2]=t[u>>2];c=t[r>>2]|0;s=i;return c|0}function nA(e,i){e=e|0;i=i|0;var r=0,n=0;r=s;s=s+16|0;n=r;t[r+4>>2]=e;t[n>>2]=i;s=r;return t[n>>2]|0}function fA(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;t[19248]=t[r>>2];s=i;return}function tA(){return t[19248]|0}function uA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)!=0?(pA(t[u>>2]|0)|0)==0:0){t[c>>2]=KA(t[u>>2]|0)|0;if(!(t[c>>2]|0)){kA(77e3);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}else{t[l>>2]=dAi[t[76992>>2]&511](t[c>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}}t[f>>2]=dAi[t[76992>>2]&511](t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;b=t[f>>2]|0;s=n;return b|0}function aA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[l>>2]=0;t[l>>2]=EA(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0))t[l>>2]=t[u>>2];do if(t[l>>2]|0){if(($l(t[l>>2]|0,77032,6)|0)!=0?($l(t[l>>2]|0,77040,7)|0)!=0:0)break;lA(1543,t[l>>2]|0);if((t[l>>2]|0)!=(t[u>>2]|0))pAi[t[135736>>2]&511](t[l>>2]|0);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}while(0);t[c>>2]=oA(t[l>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if((t[l>>2]|0)!=(t[u>>2]|0))pAi[t[135736>>2]&511](t[l>>2]|0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function oA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[l>>2]=0;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+360>>2]&2048|0)!=0:0){t[b>>2]=t[(t[o>>2]|0)+360>>2];r=(t[o>>2]|0)+360|0;t[r>>2]=(t[r>>2]|0)-2048;t[c>>2]=aA(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[(t[o>>2]|0)+360>>2]=t[b>>2];t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}t[l>>2]=EA(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0))t[l>>2]=t[u>>2];if(!(t[l>>2]|0)){if(!(t[a>>2]|0))t[a>>2]=77048;EO(t[o>>2]|0,77056,t[a>>2]|0);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[c>>2]=Ip(t[o>>2]|0,t[l>>2]|0)|0;if((t[l>>2]|0)!=0?(t[l>>2]|0)!=(t[u>>2]|0):0)pAi[t[135736>>2]&511](t[l>>2]|0);t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}function cA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(!(t[n>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}if(!(MY(t[n>>2]|0,77176)|0)){t[u>>2]=t[m>>2];t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}e=($l(t[n>>2]|0,77096,17)|0)!=0;o=t[n>>2]|0;do if(e){c=($l(o,77120,8)|0)!=0;l=t[n>>2]|0;if(!c){t[f>>2]=l+7;break}if(!($l(l,77192,6)|0))t[f>>2]=(t[n>>2]|0)+5}else t[f>>2]=o+16;while(0);if(!(yO(t[f>>2]|0)|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[u>>2]=mi(t[f>>2]|0,77200)|0;if(!(t[u>>2]|0))lA(0,t[f>>2]|0);t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}function lA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;pO(8,t[n>>2]|0,t[f>>2]|0);s=r;return}function sA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;if(!(MY(t[n>>2]|0,77176)|0)){t[u>>2]=t[_>>2];t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}e=($l(t[n>>2]|0,77096,17)|0)!=0;o=t[n>>2]|0;do if(e){c=($l(o,77120,8)|0)!=0;l=t[n>>2]|0;if(c){t[f>>2]=l;break}else{t[f>>2]=l+7;break}}else t[f>>2]=o+16;while(0);if(!(t[f>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[u>>2]=mi(t[f>>2]|0,77184)|0;if(!(t[u>>2]|0))lA(0,t[f>>2]|0);t[r>>2]=t[u>>2];a=t[r>>2]|0;s=i;return a|0}function bA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=si(t[a>>2]|0,t[o>>2]|0,1,t[u>>2]|0)|0;if((t[c>>2]|0)==0?(We(t[u>>2]|0)|0)!=0:0){lA(0,77160);t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[f>>2]=te(t[c>>2]|0,t[o>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}function kA(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;dp(8,2,0,0,t[r>>2]|0);s=i;return}function hA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}e=(Pe(t[n>>2]|0)|0)==-1;t[f>>2]=e?-1:0;if((t[f>>2]|0)<0)lA(0,76880);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function wA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=ai(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;if((t[o>>2]|0)>=0){c=t[o>>2]|0;s=n;return c|0}lA(0,77152);c=t[o>>2]|0;s=n;return c|0}function dA(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=Ge(t[r>>2]|0)|0;if((t[n>>2]|0)<0)lA(0,77144);s=i;return t[n>>2]|0}function vA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;if((t[a>>2]|0)>0?(t[o>>2]=$e(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0)|0,(t[o>>2]|0)<0):0)lA(0,77136);s=n;return t[o>>2]|0}function mA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0;n=s;s=s+16|0;t[n+8>>2]=e;t[n+4>>2]=i;t[n>>2]=r;s=n;return 0}function _A(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=f;t[k>>2]=t[o>>2];t[h>>2]=t[l>>2];t[w>>2]=(t[o>>2]|0)+(t[t[c>>2]>>2]|0);t[d>>2]=(t[l>>2]|0)+(t[t[b>>2]>>2]|0);e:while(1){if((t[l>>2]|0)>>>0>=(t[d>>2]|0)>>>0)break;if((t[o>>2]|0)>>>0>=(t[w>>2]|0)>>>0)break;do if((u[t[l>>2]>>0]|0|0)==60){if(((t[w>>2]|0)-(t[o>>2]|0)|0)<4)break e;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=38;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=108;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=116;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=59}else{if((u[t[l>>2]>>0]|0|0)==62){if(((t[w>>2]|0)-(t[o>>2]|0)|0)<4)break e;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=38;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=103;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=116;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=59;break}if((u[t[l>>2]>>0]|0|0)==38){if(((t[w>>2]|0)-(t[o>>2]|0)|0)<5)break e;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=38;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=97;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=109;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=112;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=59;break}if((u[t[l>>2]>>0]|0|0)!=13){f=n[t[l>>2]>>0]|0;r=t[o>>2]|0;t[o>>2]=r+1;n[r>>0]=f;break}if(((t[w>>2]|0)-(t[o>>2]|0)|0)<5)break e;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=38;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=35;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=49;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=51;f=t[o>>2]|0;t[o>>2]=f+1;n[f>>0]=59}while(0);t[l>>2]=(t[l>>2]|0)+1}t[t[c>>2]>>2]=(t[o>>2]|0)-(t[k>>2]|0);t[t[b>>2]>>2]=(t[l>>2]|0)-(t[h>>2]|0);s=a;return 0}function pA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=($l(t[n>>2]|0,77096,17)|0)!=0;a=t[n>>2]|0;do if(e){o=($l(a,77120,8)|0)!=0;c=t[n>>2]|0;if(o){t[f>>2]=c;break}else{t[f>>2]=c+7;break}}else t[f>>2]=a+16;while(0);t[r>>2]=yO(t[f>>2]|0)|0;u=t[r>>2]|0;s=i;return u|0}function EA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;t[c>>2]=sc()|0;if(!(t[c>>2]|0)){b=t[o>>2]|0;s=n;return b|0}if(pA(t[f>>2]|0)|0){b=t[o>>2]|0;s=n;return b|0}if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+284>>2]|0)!=0:0)?(t[c>>2]|0)==3|(t[c>>2]|0)==2:0)t[o>>2]=hc(t[(t[a>>2]|0)+284>>2]|0,t[u>>2]|0,t[f>>2]|0)|0;if((t[o>>2]|0)==0?(t[c>>2]|0)==3|(t[c>>2]|0)==1:0)t[o>>2]=cc(t[u>>2]|0,t[f>>2]|0)|0;if((t[o>>2]|0)==0&(t[f>>2]|0)!=0)t[o>>2]=Yl(t[f>>2]|0)|0;if(!(t[o>>2]|0)){b=t[o>>2]|0;s=n;return b|0}if(pA(t[o>>2]|0)|0){b=t[o>>2]|0;s=n;return b|0}t[l>>2]=0;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+284>>2]|0)!=0:0)?(t[c>>2]|0)==3|(t[c>>2]|0)==2:0)t[l>>2]=wc(t[(t[a>>2]|0)+284>>2]|0,t[o>>2]|0)|0;if((t[l>>2]|0)==0?(t[c>>2]|0)==3|(t[c>>2]|0)==1:0)t[l>>2]=lc(t[o>>2]|0)|0;if(!(t[l>>2]|0)){b=t[o>>2]|0;s=n;return b|0}pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=t[l>>2];b=t[o>>2]|0;s=n;return b|0}function SA(){var e=0,i=0,r=0,n=0;e=s;s=s+16|0;i=e;r=t[33976]|0;n=t[33980]|0;t[i>>2]=t[19636];yAi[r&511](n,78496,i);s=e;return}function gA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if(!(t[19638]|0))yA()|0;t[l>>2]=Xq(24+(t[a>>2]|0)|0)|0;if(!(t[l>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,78560,f);FA();t[u>>2]=0;k=t[u>>2]|0;s=n;return k|0}t[t[l>>2]>>2]=23205;t[(t[l>>2]|0)+12>>2]=t[a>>2];t[(t[l>>2]|0)+4>>2]=1;t[(t[l>>2]|0)+16>>2]=t[o>>2];t[(t[l>>2]|0)+20>>2]=t[c>>2];Zc(t[19650]|0);c=(t[19652]|0)+1|0;t[19652]=c;t[(t[l>>2]|0)+8>>2]=c;t[19654]=(t[19654]|0)+(t[a>>2]|0);t[19656]=(t[19656]|0)+1;if((t[19654]|0)>>>0>(t[19658]|0)>>>0)t[19658]=t[19654];Jc(t[19650]|0);if((t[19636]|0)==(t[(t[l>>2]|0)+8>>2]|0))SA();t[b>>2]=(t[l>>2]|0)+24;if((t[19660]|0)==(t[b>>2]|0)){l=t[33976]|0;c=t[33980]|0;o=t[a>>2]|0;t[f>>2]=t[19660];t[f+4>>2]=o;yAi[l&511](c,78648,f);SA()}t[u>>2]=t[b>>2];k=t[u>>2]|0;s=n;return k|0}function yA(){var e=0,i=0,r=0,n=0,f=0,u=0;e=s;s=s+16|0;i=e;r=e+8|0;n=e+4|0;if(t[19638]|0){t[r>>2]=-1;f=t[r>>2]|0;s=e;return f|0}t[19638]=1;t[19650]=Kc()|0;t[n>>2]=ti(78864)|0;if(t[n>>2]|0){u=t[n>>2]|0;t[i>>2]=78544;jq(u,78888,i)|0}t[n>>2]=ti(78896)|0;if(t[n>>2]|0){u=t[n>>2]|0;t[i>>2]=78640;jq(u,78912,i)|0}t[r>>2]=0;f=t[r>>2]|0;s=e;return f|0}function FA(){return}function OA(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=gA(t[r>>2]|0,78672,0)|0;s=i;return e|0}function AA(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+48|0;u=f;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;if(!(t[o>>2]|0)){t[a>>2]=gA(t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;d=t[a>>2]|0;s=f;return d|0}if(!(t[19638]|0))yA()|0;t[k>>2]=(t[o>>2]|0)+-24;t[w>>2]=t[(t[k>>2]|0)+8>>2];if((t[19636]|0)==(t[w>>2]|0))SA();n=t[k>>2]|0;do if((t[t[k>>2]>>2]|0)!=23205)BA(n);else{t[n>>2]=-23206;Zc(t[19650]|0);t[19654]=(t[19654]|0)-(t[(t[k>>2]|0)+12>>2]|0);t[19656]=(t[19656]|0)+-1;Jc(t[19650]|0);t[h>>2]=Jq(t[k>>2]|0,24+(t[c>>2]|0)|0)|0;if(!(t[h>>2]|0)){Zq(t[k>>2]|0);break}t[k>>2]=t[h>>2];if((t[19660]|0)==(t[o>>2]|0)){r=t[33976]|0;i=t[33980]|0;e=t[(t[k>>2]|0)+12>>2]|0;v=t[c>>2]|0;t[u>>2]=t[19660];t[u+4>>2]=e;t[u+8>>2]=v;yAi[r&511](i,78680,u);SA()}t[t[k>>2]>>2]=23205;t[(t[k>>2]|0)+8>>2]=t[w>>2];t[(t[k>>2]|0)+4>>2]=2;t[(t[k>>2]|0)+12>>2]=t[c>>2];t[(t[k>>2]|0)+16>>2]=t[l>>2];t[(t[k>>2]|0)+20>>2]=t[b>>2];Zc(t[19650]|0);t[19654]=(t[19654]|0)+(t[c>>2]|0);t[19656]=(t[19656]|0)+1;if((t[19654]|0)>>>0>(t[19658]|0)>>>0)t[19658]=t[19654];Jc(t[19650]|0);t[a>>2]=(t[k>>2]|0)+24;d=t[a>>2]|0;s=f;return d|0}while(0);t[a>>2]=0;d=t[a>>2]|0;s=f;return d|0}function MA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=AA(t[n>>2]|0,t[f>>2]|0,78672,0)|0;s=r;return i|0}function RA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i;n=i+12|0;f=i+8|0;u=i+4|0;t[n>>2]=e;if(!(t[n>>2]|0)){s=i;return}do if((t[n>>2]|0)==(-1|0))yAi[t[135904>>2]&511](t[33980]|0,78712,r);else{if((t[19660]|0)==(t[n>>2]|0)){e=t[33976]|0;a=t[33980]|0;t[r>>2]=t[19660];yAi[e&511](a,78752,r);SA()}t[u>>2]=t[n>>2];t[f>>2]=(t[n>>2]|0)+-24;if((t[t[f>>2]>>2]|0)!=23205){BA(t[f>>2]|0);break}if((t[19636]|0)==(t[(t[f>>2]|0)+8>>2]|0))SA();t[t[f>>2]>>2]=-23206;VY(t[u>>2]|0,-1,t[(t[f>>2]|0)+12>>2]|0)|0;Zc(t[19650]|0);t[19654]=(t[19654]|0)-(t[(t[f>>2]|0)+12>>2]|0);t[19656]=(t[19656]|0)+-1;Jc(t[19650]|0);Zq(t[f>>2]|0);s=i;return}while(0);f=t[33976]|0;u=t[33980]|0;t[r>>2]=t[n>>2];yAi[f&511](u,78768,r);SA();s=i;return}function NA(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=(HY(t[a>>2]|0)|0)+1;if(!(t[19638]|0))yA()|0;t[k>>2]=Xq(24+(t[b>>2]|0)|0)|0;if(!(t[k>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=n;return h|0}t[t[k>>2]>>2]=23205;t[(t[k>>2]|0)+12>>2]=t[b>>2];t[(t[k>>2]|0)+4>>2]=3;t[(t[k>>2]|0)+16>>2]=t[o>>2];t[(t[k>>2]|0)+20>>2]=t[c>>2];Zc(t[19650]|0);c=(t[19652]|0)+1|0;t[19652]=c;t[(t[k>>2]|0)+8>>2]=c;t[19654]=(t[19654]|0)+(t[b>>2]|0);t[19656]=(t[19656]|0)+1;if((t[19654]|0)>>>0>(t[19658]|0)>>>0)t[19658]=t[19654];Jc(t[19650]|0);t[l>>2]=(t[k>>2]|0)+24;if((t[19636]|0)==(t[(t[k>>2]|0)+8>>2]|0))SA();WY(t[l>>2]|0,t[a>>2]|0)|0;if((t[19660]|0)==(t[l>>2]|0)){a=t[33976]|0;k=t[33980]|0;t[f>>2]=t[19660];yAi[a&511](k,78792,f);SA()}t[u>>2]=t[l>>2];h=t[u>>2]|0;s=n;return h|0}function TA(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=NA(t[r>>2]|0,78672,0)|0;s=i;return e|0}function LA(){return t[19654]|0}function DA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r;f=r+12|0;t[f>>2]=e;t[r+8>>2]=i;if(!(t[f>>2]|0)){s=r;return}i=t[f>>2]|0;f=t[19658]|0;t[n>>2]=t[19654];t[n+4>>2]=f;xe(i|0,78816,n|0)|0;s=r;return}function CA(){var e=0;e=s;if(!(t[19638]|0)){s=e;return}Xc(t[19650]|0);t[19650]=0;t[19638]=0;s=e;return}function PA(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;do if(t[a>>2]|0){if(!(t[o>>2]|0)){t[u>>2]=-1;break}if(!(t[c>>2]|0)){t[u>>2]=-1;break}if(!(t[l>>2]|0)){t[u>>2]=-1;break}else{t[33934]=t[a>>2];t[33936]=t[o>>2];t[33938]=t[o>>2];t[33940]=t[c>>2];t[33942]=t[l>>2];t[u>>2]=0;break}}else t[u>>2]=-1;while(0);s=f;return t[u>>2]|0}function BA(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;e=t[33976]|0;f=t[33980]|0;t[r>>2]=t[n>>2];yAi[e&511](f,78920,r);s=i;return}function IA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[f>>2]=HA()|0;if((t[f>>2]|0)!=0?(t[u>>2]=ZA(t[f>>2]|0,t[n>>2]|0)|0,(t[u>>2]|0)!=0):0){xA(t[f>>2]|0);t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}function HA(){var e=0,i=0,r=0,n=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[r>>2]|0)){JA(78960);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{f=(t[r>>2]|0)+0|0;u=f+44|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(u|0));t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function xA(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+32>>2]|0);if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0);if(t[(t[r>>2]|0)+40>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function UA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=ZA(t[n>>2]|0,t[f>>2]|0)|0;s=r;return i|0}function zA(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0;i=s;s=s+112|0;r=i;f=i+100|0;a=i+96|0;o=i+92|0;c=i+88|0;l=i+84|0;b=i+80|0;k=i+76|0;h=i+72|0;w=i+68|0;d=i+64|0;v=i+60|0;m=i+56|0;_=i+52|0;p=i+48|0;E=i+44|0;S=i+40|0;g=i+36|0;y=i+32|0;F=i+28|0;O=i+24|0;A=i+20|0;M=i+16|0;R=i+12|0;N=i+8|0;T=i+4|0;t[a>>2]=e;t[o>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=0;L=t[f>>2]|0;s=i;return L|0}t[k>>2]=80;t[o>>2]=gAi[t[135752>>2]&511]((t[k>>2]|0)+1|0)|0;if(!(t[o>>2]|0)){JA(78984);t[f>>2]=0;L=t[f>>2]|0;s=i;return L|0}t[b>>2]=0;e:do if(t[t[a>>2]>>2]|0){t[l>>2]=t[t[a>>2]>>2];while(1){D=(t[b>>2]|0)>=(t[k>>2]|0);if(!(n[t[l>>2]>>0]|0))break;if(D){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}e=t[l>>2]|0;t[l>>2]=e+1;C=n[e>>0]|0;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=C}if(D){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break;t[o>>2]=t[c>>2]}C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=58;P=16}else P=16;while(0);e:do if((P|0)==16){D=t[a>>2]|0;i:do if(!(t[(t[a>>2]|0)+4>>2]|0)){r:do if((t[D+12>>2]|0)==0?(t[(t[a>>2]|0)+20>>2]|0)!=-1:0){if(!(t[(t[a>>2]|0)+8>>2]|0)){if(!(t[t[a>>2]>>2]|0))break;if(((t[b>>2]|0)+3|0)<(t[k>>2]|0))break;t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2];break}if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=47;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=47;t[l>>2]=t[(t[a>>2]|0)+8>>2];n:while(1){if(!(n[t[l>>2]>>0]|0))break r;if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}if(!((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0))P=113;do if((P|0)==113){P=0;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=95:0){if((n[t[l>>2]>>0]|0)==46)break;if((n[t[l>>2]>>0]|0)==33)break;if((n[t[l>>2]>>0]|0)==126)break;if((n[t[l>>2]>>0]|0)==42)break;if((n[t[l>>2]>>0]|0)==39)break;if((n[t[l>>2]>>0]|0)==40)break;if((n[t[l>>2]>>0]|0)==41)break;if((n[t[l>>2]>>0]|0)==36)break;if((n[t[l>>2]>>0]|0)==44)break;if((n[t[l>>2]>>0]|0)==59)break;if((n[t[l>>2]>>0]|0)==58)break;if((n[t[l>>2]>>0]|0)==64)break;if((n[t[l>>2]>>0]|0)==38)break;if((n[t[l>>2]>>0]|0)==61)break;if((n[t[l>>2]>>0]|0)==43)break;C=t[l>>2]|0;t[l>>2]=C+1;t[p>>2]=u[C>>0];t[E>>2]=(t[p>>2]|0)/16|0;t[S>>2]=(t[p>>2]|0)%16|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=37;C=(t[E>>2]|0)+((t[E>>2]|0)>9?55:48)&255;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=C;C=(t[S>>2]|0)+((t[S>>2]|0)>9?55:48)&255;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=C;continue n}}while(0);C=t[l>>2]|0;t[l>>2]=C+1;e=n[C>>0]|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=e}}else P=53;while(0);if((P|0)==53){if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=47;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=47;if(t[(t[a>>2]|0)+16>>2]|0){t[l>>2]=t[(t[a>>2]|0)+16>>2];r:while(1){B=((t[b>>2]|0)+3|0)>=(t[k>>2]|0);if(!(n[t[l>>2]>>0]|0))break;if(B){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}if(!((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0))P=64;do if((P|0)==64){P=0;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=95:0){if((n[t[l>>2]>>0]|0)==46)break;if((n[t[l>>2]>>0]|0)==33)break;if((n[t[l>>2]>>0]|0)==126)break;if((n[t[l>>2]>>0]|0)==42)break;if((n[t[l>>2]>>0]|0)==39)break;if((n[t[l>>2]>>0]|0)==40)break;if((n[t[l>>2]>>0]|0)==41)break;if((n[t[l>>2]>>0]|0)==59)break;if((n[t[l>>2]>>0]|0)==58)break;if((n[t[l>>2]>>0]|0)==38)break;if((n[t[l>>2]>>0]|0)==61)break;if((n[t[l>>2]>>0]|0)==43)break;if((n[t[l>>2]>>0]|0)==36)break;if((n[t[l>>2]>>0]|0)==44)break;e=t[l>>2]|0;t[l>>2]=e+1;t[v>>2]=u[e>>0];t[m>>2]=(t[v>>2]|0)/16|0;t[_>>2]=(t[v>>2]|0)%16|0;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=37;e=(t[m>>2]|0)+((t[m>>2]|0)>9?55:48)&255;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=e;e=(t[_>>2]|0)+((t[_>>2]|0)>9?55:48)&255;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=e;continue r}}while(0);e=t[l>>2]|0;t[l>>2]=e+1;C=n[e>>0]|0;e=t[b>>2]|0;t[b>>2]=e+1;n[(t[o>>2]|0)+e>>0]=C}if(B){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=64}if(t[(t[a>>2]|0)+12>>2]|0){t[l>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(n[t[l>>2]>>0]|0))break;if((t[b>>2]|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}C=t[l>>2]|0;t[l>>2]=C+1;e=n[C>>0]|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=e}if((t[(t[a>>2]|0)+20>>2]|0)>0){if(((t[b>>2]|0)+10|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}e=(t[o>>2]|0)+(t[b>>2]|0)|0;C=(t[k>>2]|0)-(t[b>>2]|0)|0;t[r>>2]=t[(t[a>>2]|0)+20>>2];I=SY(e,C,79e3,r)|0;t[b>>2]=(t[b>>2]|0)+I}}}r:do if(t[(t[a>>2]|0)+24>>2]|0){t[l>>2]=t[(t[a>>2]|0)+24>>2];do if((t[t[a>>2]>>2]|0)!=0?(n[t[l>>2]>>0]|0)==47:0){if(!((n[(t[l>>2]|0)+1>>0]|0)>=97?(n[(t[l>>2]|0)+1>>0]|0)<=122:0)){if((n[(t[l>>2]|0)+1>>0]|0)<65)break;if((n[(t[l>>2]|0)+1>>0]|0)>90)break}if((n[(t[l>>2]|0)+2>>0]|0)==58?(Xl(t[t[a>>2]>>2]|0,79008)|0)!=0:0){if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}I=t[l>>2]|0;t[l>>2]=I+1;C=n[I>>0]|0;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C;C=t[l>>2]|0;t[l>>2]=C+1;I=n[C>>0]|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=I;I=t[l>>2]|0;t[l>>2]=I+1;C=n[I>>0]|0;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C}}while(0);n:while(1){if(!(n[t[l>>2]>>0]|0))break r;if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}if(!((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0))P=159;do if((P|0)==159){P=0;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if(((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=95:0)?(n[t[l>>2]>>0]|0)!=46:0){if((n[t[l>>2]>>0]|0)==33)break;if((n[t[l>>2]>>0]|0)==126)break;if((n[t[l>>2]>>0]|0)==42)break;if((n[t[l>>2]>>0]|0)==39)break;if((n[t[l>>2]>>0]|0)==40)break;if((n[t[l>>2]>>0]|0)==41)break;if((n[t[l>>2]>>0]|0)==47)break;if((n[t[l>>2]>>0]|0)==59)break;if((n[t[l>>2]>>0]|0)==64)break;if((n[t[l>>2]>>0]|0)==38)break;if((n[t[l>>2]>>0]|0)==61)break;if((n[t[l>>2]>>0]|0)==43)break;if((n[t[l>>2]>>0]|0)==36)break;if((n[t[l>>2]>>0]|0)==44)break;C=t[l>>2]|0;t[l>>2]=C+1;t[g>>2]=u[C>>0];t[y>>2]=(t[g>>2]|0)/16|0;t[F>>2]=(t[g>>2]|0)%16|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=37;C=(t[y>>2]|0)+((t[y>>2]|0)>9?55:48)&255;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C;C=(t[F>>2]|0)+((t[F>>2]|0)>9?55:48)&255;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C;continue n}}while(0);C=t[l>>2]|0;t[l>>2]=C+1;I=n[C>>0]|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=I}}while(0);if(t[(t[a>>2]|0)+40>>2]|0){if(((t[b>>2]|0)+1|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=63;t[l>>2]=t[(t[a>>2]|0)+40>>2];while(1){if(!(n[t[l>>2]>>0]|0))break i;if(((t[b>>2]|0)+1|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}I=t[l>>2]|0;t[l>>2]=I+1;C=n[I>>0]|0;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C}}if(t[(t[a>>2]|0)+28>>2]|0){if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=63;t[l>>2]=t[(t[a>>2]|0)+28>>2];r:while(1){if(!(n[t[l>>2]>>0]|0))break i;if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}if(!((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0))P=203;do if((P|0)==203){P=0;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=95:0){if((n[t[l>>2]>>0]|0)==46)break;if((n[t[l>>2]>>0]|0)==33)break;if((n[t[l>>2]>>0]|0)==126)break;if((n[t[l>>2]>>0]|0)==42)break;if((n[t[l>>2]>>0]|0)==39)break;if((n[t[l>>2]>>0]|0)==40)break;if((n[t[l>>2]>>0]|0)==41)break;if((n[t[l>>2]>>0]|0)==59)break;if((n[t[l>>2]>>0]|0)==47)break;if((n[t[l>>2]>>0]|0)==63)break;if((n[t[l>>2]>>0]|0)==58)break;if((n[t[l>>2]>>0]|0)==64)break;if((n[t[l>>2]>>0]|0)==38)break;if((n[t[l>>2]>>0]|0)==61)break;if((n[t[l>>2]>>0]|0)==43)break;if((n[t[l>>2]>>0]|0)==36)break;if((n[t[l>>2]>>0]|0)==44)break;if((n[t[l>>2]>>0]|0)==91)break;if((n[t[l>>2]>>0]|0)==93)break;C=t[l>>2]|0;t[l>>2]=C+1;t[O>>2]=u[C>>0];t[A>>2]=(t[O>>2]|0)/16|0;t[M>>2]=(t[O>>2]|0)%16|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=37;C=(t[A>>2]|0)+((t[A>>2]|0)>9?55:48)&255;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C;C=(t[M>>2]|0)+((t[M>>2]|0)>9?55:48)&255;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C;continue r}}while(0);C=t[l>>2]|0;t[l>>2]=C+1;I=n[C>>0]|0;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=I}}}else{t[l>>2]=t[D+4>>2];r:while(1){if(!(n[t[l>>2]>>0]|0))break i;if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}do if((((((((((n[t[l>>2]>>0]|0)!=59?(n[t[l>>2]>>0]|0)!=47:0)?(n[t[l>>2]>>0]|0)!=63:0)?(n[t[l>>2]>>0]|0)!=58:0)?(n[t[l>>2]>>0]|0)!=64:0)?(n[t[l>>2]>>0]|0)!=38:0)?(n[t[l>>2]>>0]|0)!=61:0)?(n[t[l>>2]>>0]|0)!=43:0)?(n[t[l>>2]>>0]|0)!=36:0)?(n[t[l>>2]>>0]|0)!=44:0){if((n[t[l>>2]>>0]|0)==91)break;if((n[t[l>>2]>>0]|0)==93)break;if((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0)break;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;
	if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if((n[t[l>>2]>>0]|0)==45)break;if((n[t[l>>2]>>0]|0)==95)break;if((n[t[l>>2]>>0]|0)==46)break;if((n[t[l>>2]>>0]|0)==33)break;if((n[t[l>>2]>>0]|0)==126)break;if((n[t[l>>2]>>0]|0)==42)break;if((n[t[l>>2]>>0]|0)==39)break;if((n[t[l>>2]>>0]|0)==40)break;if((n[t[l>>2]>>0]|0)==41)break;I=t[l>>2]|0;t[l>>2]=I+1;t[h>>2]=u[I>>0];t[w>>2]=(t[h>>2]|0)/16|0;t[d>>2]=(t[h>>2]|0)%16|0;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=37;I=(t[w>>2]|0)+((t[w>>2]|0)>9?55:48)&255;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=I;I=(t[d>>2]|0)+((t[d>>2]|0)>9?55:48)&255;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=I;continue r}while(0);I=t[l>>2]|0;t[l>>2]=I+1;C=n[I>>0]|0;I=t[b>>2]|0;t[b>>2]=I+1;n[(t[o>>2]|0)+I>>0]=C}}while(0);i:do if(t[(t[a>>2]|0)+32>>2]|0){if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}D=t[b>>2]|0;t[b>>2]=D+1;n[(t[o>>2]|0)+D>>0]=35;t[l>>2]=t[(t[a>>2]|0)+32>>2];r:while(1){if(!(n[t[l>>2]>>0]|0))break i;if(((t[b>>2]|0)+3|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break e;t[o>>2]=t[c>>2]}if(!((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0))P=241;do if((P|0)==241){P=0;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if(((((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=95:0)?(n[t[l>>2]>>0]|0)!=46:0)?(n[t[l>>2]>>0]|0)!=33:0)?(n[t[l>>2]>>0]|0)!=126:0){if((n[t[l>>2]>>0]|0)==42)break;if((n[t[l>>2]>>0]|0)==39)break;if((n[t[l>>2]>>0]|0)==40)break;if((n[t[l>>2]>>0]|0)==41)break;if((n[t[l>>2]>>0]|0)==59)break;if((n[t[l>>2]>>0]|0)==47)break;if((n[t[l>>2]>>0]|0)==63)break;if((n[t[l>>2]>>0]|0)==58)break;if((n[t[l>>2]>>0]|0)==64)break;if((n[t[l>>2]>>0]|0)==38)break;if((n[t[l>>2]>>0]|0)==61)break;if((n[t[l>>2]>>0]|0)==43)break;if((n[t[l>>2]>>0]|0)==36)break;if((n[t[l>>2]>>0]|0)==44)break;if((n[t[l>>2]>>0]|0)==91)break;if((n[t[l>>2]>>0]|0)==93)break;D=t[l>>2]|0;t[l>>2]=D+1;t[R>>2]=u[D>>0];t[N>>2]=(t[R>>2]|0)/16|0;t[T>>2]=(t[R>>2]|0)%16|0;D=t[b>>2]|0;t[b>>2]=D+1;n[(t[o>>2]|0)+D>>0]=37;D=(t[N>>2]|0)+((t[N>>2]|0)>9?55:48)&255;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=D;D=(t[T>>2]|0)+((t[T>>2]|0)>9?55:48)&255;C=t[b>>2]|0;t[b>>2]=C+1;n[(t[o>>2]|0)+C>>0]=D;continue r}}while(0);D=t[l>>2]|0;t[l>>2]=D+1;C=n[D>>0]|0;D=t[b>>2]|0;t[b>>2]=D+1;n[(t[o>>2]|0)+D>>0]=C}}while(0);if((t[b>>2]|0)>=(t[k>>2]|0)){t[c>>2]=QA(t[o>>2]|0,k)|0;if(!(t[c>>2]|0))break;t[o>>2]=t[c>>2]}n[(t[o>>2]|0)+(t[b>>2]|0)>>0]=0;t[f>>2]=t[o>>2];L=t[f>>2]|0;s=i;return L|0}while(0);pAi[t[135736>>2]&511](t[o>>2]|0);t[f>>2]=0;L=t[f>>2]|0;s=i;return L|0}function jA(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;i=s;s=s+32|0;r=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[f>>2]=e;if(!(t[f>>2]|0)){t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}t[u>>2]=t[f>>2];while(1){b=t[u>>2]|0;if((n[t[u>>2]>>0]|0)!=47)break;t[u>>2]=b+1}if(!(n[b>>0]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}t[a>>2]=t[u>>2];e:while(1){if(!(n[t[u>>2]>>0]|0))break;if((n[t[u>>2]>>0]|0)==46?(n[(t[u>>2]|0)+1>>0]|0)==47:0){t[u>>2]=(t[u>>2]|0)+2;while(1){if((n[t[u>>2]>>0]|0)!=47)continue e;t[u>>2]=(t[u>>2]|0)+1}}if((n[t[u>>2]>>0]|0)==46?(n[(t[u>>2]|0)+1>>0]|0)==0:0)break;while(1){if((n[t[u>>2]>>0]|0)==47)break;if(!(n[t[u>>2]>>0]|0))break e;b=t[u>>2]|0;t[u>>2]=b+1;e=n[b>>0]|0;b=t[a>>2]|0;t[a>>2]=b+1;n[b>>0]=e}do{if((n[t[u>>2]>>0]|0)==47)k=(n[(t[u>>2]|0)+1>>0]|0)==47;else k=0;h=t[u>>2]|0;t[u>>2]=h+1}while(k);e=n[h>>0]|0;b=t[a>>2]|0;t[a>>2]=b+1;n[b>>0]=e}n[t[a>>2]>>0]=0;t[u>>2]=t[f>>2];while(1){w=t[u>>2]|0;if((n[t[u>>2]>>0]|0)!=47)break;t[u>>2]=w+1}if(!(n[w>>0]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}e:while(1){t[o>>2]=t[u>>2];while(1){if((n[t[o>>2]>>0]|0)!=47)d=(n[t[o>>2]>>0]|0)!=0;else d=0;v=t[o>>2]|0;if(!d)break;t[o>>2]=v+1}if(!(n[v>>0]|0))break;t[o>>2]=(t[o>>2]|0)+1;if(!(((n[t[u>>2]>>0]|0)==46?(n[(t[u>>2]|0)+1>>0]|0)==46:0)?(t[o>>2]|0)==((t[u>>2]|0)+3|0):0))m=38;do if(((m|0)==38?(m=0,(n[t[o>>2]>>0]|0)==46):0)?(n[(t[o>>2]|0)+1>>0]|0)==46:0){if((n[(t[o>>2]|0)+2>>0]|0)!=47?(n[(t[o>>2]|0)+2>>0]|0)!=0:0)break;_=t[u>>2]|0;if(!(n[(t[o>>2]|0)+2>>0]|0)){m=44;break e}t[c>>2]=_;t[o>>2]=(t[o>>2]|0)+3;do{w=t[o>>2]|0;t[o>>2]=w+1;h=n[w>>0]|0;w=t[c>>2]|0;t[c>>2]=w+1;n[w>>0]=h}while((h<<24>>24|0)!=0);t[o>>2]=t[u>>2];do{if((t[o>>2]|0)>>>0<=(t[f>>2]|0)>>>0)break;h=(t[o>>2]|0)+-1|0;t[o>>2]=h}while((n[h>>0]|0)==47);if((t[o>>2]|0)==(t[f>>2]|0))continue e;t[u>>2]=t[o>>2];while(1){if((t[u>>2]|0)>>>0<=(t[f>>2]|0)>>>0)continue e;if((n[(t[u>>2]|0)+-1>>0]|0)==47)continue e;t[u>>2]=(t[u>>2]|0)+-1}}while(0);t[u>>2]=t[o>>2]}if((m|0)==44)n[_>>0]=0;n[t[a>>2]>>0]=0;if((n[t[f>>2]>>0]|0)==47){t[u>>2]=t[f>>2];while(1){if(((n[t[u>>2]>>0]|0)==47?(n[(t[u>>2]|0)+1>>0]|0)==46:0)?(n[(t[u>>2]|0)+2>>0]|0)==46:0)if((n[(t[u>>2]|0)+3>>0]|0)==47)p=1;else p=(n[(t[u>>2]|0)+3>>0]|0)==0;else p=0;E=t[u>>2]|0;if(!p)break;t[u>>2]=E+3}if((E|0)!=(t[f>>2]|0)){t[a>>2]=t[f>>2];while(1){if(!(n[t[u>>2]>>0]|0))break;f=t[u>>2]|0;t[u>>2]=f+1;E=n[f>>0]|0;f=t[a>>2]|0;t[a>>2]=f+1;n[f>>0]=E}n[t[a>>2]>>0]=0}}t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}function VA(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if(!(t[a>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if((t[o>>2]|0)<=0)t[o>>2]=HY(t[a>>2]|0)|0;if((t[o>>2]|0)<0){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(!(t[c>>2]|0)){t[l>>2]=gAi[t[135752>>2]&511]((t[o>>2]|0)+1|0)|0;if(!(t[l>>2]|0)){JA(79016);t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}}else t[l>>2]=t[c>>2];t[k>>2]=t[a>>2];t[b>>2]=t[l>>2];while(1){if((t[o>>2]|0)<=0)break;if((((t[o>>2]|0)>2?(n[t[k>>2]>>0]|0)==37:0)?($A(n[(t[k>>2]|0)+1>>0]|0)|0)!=0:0)?($A(n[(t[k>>2]|0)+2>>0]|0)|0)!=0:0){t[k>>2]=(t[k>>2]|0)+1;if((n[t[k>>2]>>0]|0)>=48?(n[t[k>>2]>>0]|0)<=57:0)n[t[b>>2]>>0]=(n[t[k>>2]>>0]|0)-48;else w=20;do if((w|0)==20){w=0;if((n[t[k>>2]>>0]|0)>=97?(n[t[k>>2]>>0]|0)<=102:0){n[t[b>>2]>>0]=(n[t[k>>2]>>0]|0)-97+10;break}if((n[t[k>>2]>>0]|0)>=65?(n[t[k>>2]>>0]|0)<=70:0)n[t[b>>2]>>0]=(n[t[k>>2]>>0]|0)-65+10}while(0);t[k>>2]=(t[k>>2]|0)+1;if((n[t[k>>2]>>0]|0)>=48?(n[t[k>>2]>>0]|0)<=57:0)n[t[b>>2]>>0]=(n[t[b>>2]>>0]<<4)+((n[t[k>>2]>>0]|0)-48);else w=29;do if((w|0)==29){w=0;if((n[t[k>>2]>>0]|0)>=97?(n[t[k>>2]>>0]|0)<=102:0){n[t[b>>2]>>0]=(n[t[b>>2]>>0]<<4)+((n[t[k>>2]>>0]|0)-97)+10;break}if((n[t[k>>2]>>0]|0)>=65?(n[t[k>>2]>>0]|0)<=70:0)n[t[b>>2]>>0]=(n[t[b>>2]>>0]<<4)+((n[t[k>>2]>>0]|0)-65)+10}while(0);t[k>>2]=(t[k>>2]|0)+1;t[o>>2]=(t[o>>2]|0)-3;t[b>>2]=(t[b>>2]|0)+1;continue}a=t[k>>2]|0;t[k>>2]=a+1;c=n[a>>0]|0;a=t[b>>2]|0;t[b>>2]=a+1;n[a>>0]=c;t[o>>2]=(t[o>>2]|0)+-1}n[t[b>>2]>>0]=0;t[u>>2]=t[l>>2];h=t[u>>2]|0;s=f;return h|0}function qA(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;r=s;s=s+48|0;f=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+33|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;d=r+32|0;t[a>>2]=e;t[o>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}i=t[a>>2]|0;if(!(u[t[a>>2]>>0]|0)){t[f>>2]=Yl(i)|0;v=t[f>>2]|0;s=r;return v|0}t[h>>2]=rs(i)|0;if((t[h>>2]|0)<=0){t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}t[h>>2]=(t[h>>2]|0)+20;t[c>>2]=gAi[t[135752>>2]&511](t[h>>2]|0)|0;if(!(t[c>>2]|0)){JA(79040);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}t[k>>2]=t[a>>2];t[w>>2]=0;e:while(1){if(!(u[t[k>>2]>>0]|0)){m=40;break}if(((t[h>>2]|0)-(t[w>>2]|0)|0)<=3){t[b>>2]=QA(t[c>>2]|0,h)|0;if(!(t[b>>2]|0)){m=13;break}t[c>>2]=t[b>>2]}n[l>>0]=n[t[k>>2]>>0]|0;do if((u[l>>0]|0|0)!=64){if((u[l>>0]|0|0)>=97?(u[l>>0]|0|0)<=122:0)break;if((u[l>>0]|0|0)>=65?(u[l>>0]|0|0)<=90:0)break;if((u[l>>0]|0|0)>=48?(u[l>>0]|0|0)<=57:0)break;if((((((((u[l>>0]|0|0)!=45?(u[l>>0]|0|0)!=95:0)?(u[l>>0]|0|0)!=46:0)?(u[l>>0]|0|0)!=33:0)?(u[l>>0]|0|0)!=126:0)?(u[l>>0]|0|0)!=42:0)?(u[l>>0]|0|0)!=39:0)?(u[l>>0]|0|0)!=40:0){if((u[l>>0]|0|0)==41)break;if(es(t[o>>2]|0,n[l>>0]|0)|0)break;a=t[w>>2]|0;t[w>>2]=a+1;n[(t[c>>2]|0)+a>>0]=37;n[d>>0]=(u[l>>0]|0)>>4;a=u[d>>0]|0;if((u[d>>0]|0|0)<=9){i=t[w>>2]|0;t[w>>2]=i+1;n[(t[c>>2]|0)+i>>0]=48+a}else{i=t[w>>2]|0;t[w>>2]=i+1;n[(t[c>>2]|0)+i>>0]=65+a-10}n[d>>0]=(u[l>>0]|0)&15;a=u[d>>0]|0;if((u[d>>0]|0|0)<=9){i=t[w>>2]|0;t[w>>2]=i+1;n[(t[c>>2]|0)+i>>0]=48+a}else{i=t[w>>2]|0;t[w>>2]=i+1;n[(t[c>>2]|0)+i>>0]=65+a-10}t[k>>2]=(t[k>>2]|0)+1;continue e}}while(0);a=t[k>>2]|0;t[k>>2]=a+1;i=n[a>>0]|0;a=t[w>>2]|0;t[w>>2]=a+1;n[(t[c>>2]|0)+a>>0]=i}if((m|0)==13){JA(79040);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;v=t[f>>2]|0;s=r;return v|0}else if((m|0)==40){n[(t[c>>2]|0)+(t[w>>2]|0)>>0]=0;t[f>>2]=t[c>>2];v=t[f>>2]|0;s=r;return v|0}return 0}function YA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+48|0;r=i;n=i+24|0;f=i+20|0;u=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i+28|0;t[f>>2]=e;t[a>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}t[o>>2]=HA()|0;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]=1,t[c>>2]=UA(t[o>>2]|0,t[f>>2]|0)|0,(t[c>>2]|0)!=0):0){xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}if(!(t[o>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}t[u>>2]=0;do if(t[t[o>>2]>>2]|0){t[a>>2]=qA(t[t[o>>2]>>2]|0,79064)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;t[u>>2]=us(t[u>>2]|0,79072)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}while(0);do if(t[(t[o>>2]|0)+8>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+8>>2]|0,79080)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,79088)|0;t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}while(0);do if(t[(t[o>>2]|0)+16>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+16>>2]|0,79096)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,79088)|0;t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;t[u>>2]=us(t[u>>2]|0,79104)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}while(0);if(t[(t[o>>2]|0)+12>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+12>>2]|0,79080)|0;if(!(t[a>>2]|0)){JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}if(!(t[(t[o>>2]|0)+16>>2]|0))t[u>>2]=us(t[u>>2]|0,79088)|0;t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0)}if(t[(t[o>>2]|0)+20>>2]|0){t[r>>2]=t[(t[o>>2]|0)+20>>2];SY(l,10,79112,r)|0;t[u>>2]=us(t[u>>2]|0,79072)|0;t[u>>2]=us(t[u>>2]|0,l)|0}do if(t[(t[o>>2]|0)+24>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+24>>2]|0,79120)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}while(0);do if(!(t[(t[o>>2]|0)+40>>2]|0)){if(t[(t[o>>2]|0)+28>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+28>>2]|0,79144)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,79136)|0;t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}}else{t[u>>2]=us(t[u>>2]|0,79136)|0;t[u>>2]=us(t[u>>2]|0,t[(t[o>>2]|0)+40>>2]|0)|0}while(0);do if(t[(t[o>>2]|0)+4>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+4>>2]|0,79160)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}while(0);do if(t[(t[o>>2]|0)+32>>2]|0){t[a>>2]=qA(t[(t[o>>2]|0)+32>>2]|0,79168)|0;if(t[a>>2]|0){t[u>>2]=us(t[u>>2]|0,79168)|0;t[u>>2]=us(t[u>>2]|0,t[a>>2]|0)|0;pAi[t[135736>>2]&511](t[a>>2]|0);break}JA(79040);xA(t[o>>2]|0);t[n>>2]=0;b=t[n>>2]|0;s=i;return b|0}while(0);xA(t[o>>2]|0);t[n>>2]=t[u>>2];b=t[n>>2]|0;s=i;return b|0}function GA(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;r=s;s=s+48|0;f=r+40|0;u=r+36|0;a=r+32|0;o=r+28|0;c=r+24|0;l=r+20|0;b=r+16|0;k=r+12|0;h=r+8|0;w=r+4|0;d=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;do if(t[f>>2]|0){if(!(n[t[f>>2]>>0]|0)){t[o>>2]=0;v=7;break}t[h>>2]=HA()|0;if(t[h>>2]|0){t[o>>2]=UA(t[h>>2]|0,t[f>>2]|0)|0;v=7}}else{t[o>>2]=-1;v=7}while(0);e:do if((v|0)==7?(t[o>>2]|0)==0:0){if((t[h>>2]|0)!=0?(t[t[h>>2]>>2]|0)!=0:0){t[a>>2]=Yl(t[f>>2]|0)|0;break}if(!(t[u>>2]|0))t[o>>2]=-1;else{t[w>>2]=HA()|0;if(!(t[w>>2]|0))break;t[o>>2]=UA(t[w>>2]|0,t[u>>2]|0)|0}i=t[h>>2]|0;if(t[o>>2]|0){if(!i)break;t[a>>2]=zA(t[h>>2]|0)|0;break}if(!i){if(t[(t[w>>2]|0)+32>>2]|0){pAi[t[135736>>2]&511](t[(t[w>>2]|0)+32>>2]|0);t[(t[w>>2]|0)+32>>2]=0}t[a>>2]=zA(t[w>>2]|0)|0;break}t[d>>2]=HA()|0;if(t[d>>2]|0){if((((t[t[h>>2]>>2]|0)==0?(t[(t[h>>2]|0)+24>>2]|0)==0:0)?(t[(t[h>>2]|0)+8>>2]|0)==0:0)?(t[(t[h>>2]|0)+12>>2]|0)==0:0){if(t[t[w>>2]>>2]|0){i=gAi[t[135768>>2]&511](t[t[w>>2]>>2]|0)|0;t[t[d>>2]>>2]=i}if(!(t[(t[w>>2]|0)+8>>2]|0)){if(t[(t[w>>2]|0)+12>>2]|0){i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+12>>2]|0)|0;t[(t[d>>2]|0)+12>>2]=i;if(t[(t[w>>2]|0)+16>>2]|0){i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+16>>2]|0)|0;t[(t[d>>2]|0)+16>>2]=i}t[(t[d>>2]|0)+20>>2]=t[(t[w>>2]|0)+20>>2]}}else{i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+8>>2]|0)|0;t[(t[d>>2]|0)+8>>2]=i}if(t[(t[w>>2]|0)+24>>2]|0){i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+24>>2]|0)|0;t[(t[d>>2]|0)+24>>2]=i}do if(t[(t[h>>2]|0)+40>>2]|0){i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+40>>2]|0)|0;t[(t[d>>2]|0)+40>>2]=i}else{if(t[(t[h>>2]|0)+28>>2]|0){i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+28>>2]|0)|0;t[(t[d>>2]|0)+28>>2]=i;break}if(t[(t[w>>2]|0)+40>>2]|0){i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+40>>2]|0)|0;t[(t[d>>2]|0)+40>>2]=i;break}if(!(t[(t[w>>2]|0)+28>>2]|0))break;i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+28>>2]|0)|0;t[(t[d>>2]|0)+28>>2]=i}while(0);if(t[(t[h>>2]|0)+32>>2]|0){i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+32>>2]|0)|0;t[(t[d>>2]|0)+32>>2]=i}}else v=47;i:do if((v|0)==47){if(t[t[h>>2]>>2]|0){t[a>>2]=zA(t[h>>2]|0)|0;break e}if(t[t[w>>2]>>2]|0){i=gAi[t[135768>>2]&511](t[t[w>>2]>>2]|0)|0;t[t[d>>2]>>2]=i}if(!(t[(t[h>>2]|0)+40>>2]|0)){if(t[(t[h>>2]|0)+28>>2]|0){i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+28>>2]|0)|0;t[(t[d>>2]|0)+28>>2]=i}}else{i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+40>>2]|0)|0;t[(t[d>>2]|0)+40>>2]=i}if(t[(t[h>>2]|0)+32>>2]|0){i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+32>>2]|0)|0;t[(t[d>>2]|0)+32>>2]=i}if((t[(t[h>>2]|0)+8>>2]|0)==0?(t[(t[h>>2]|0)+12>>2]|0)==0:0){if(!(t[(t[w>>2]|0)+8>>2]|0)){if(t[(t[w>>2]|0)+12>>2]|0){i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+12>>2]|0)|0;t[(t[d>>2]|0)+12>>2]=i;if(t[(t[w>>2]|0)+16>>2]|0){i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+16>>2]|0)|0;t[(t[d>>2]|0)+16>>2]=i}t[(t[d>>2]|0)+20>>2]=t[(t[w>>2]|0)+20>>2]}}else{i=gAi[t[135768>>2]&511](t[(t[w>>2]|0)+8>>2]|0)|0;t[(t[d>>2]|0)+8>>2]=i}do if(t[(t[h>>2]|0)+24>>2]|0){if((n[t[(t[h>>2]|0)+24>>2]>>0]|0)!=47)break;i=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+24>>2]|0)|0;t[(t[d>>2]|0)+24>>2]=i;break i}while(0);t[c>>2]=2;if(t[(t[h>>2]|0)+24>>2]|0){i=HY(t[(t[h>>2]|0)+24>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+i}if(t[(t[w>>2]|0)+24>>2]|0){i=HY(t[(t[w>>2]|0)+24>>2]|0)|0;t[c>>2]=(t[c>>2]|0)+i}i=gAi[t[135752>>2]&511](t[c>>2]|0)|0;t[(t[d>>2]|0)+24>>2]=i;if(!(t[(t[d>>2]|0)+24>>2]|0)){JA(79176);break e}n[t[(t[d>>2]|0)+24>>2]>>0]=0;t[b>>2]=0;t[k>>2]=0;r:do if(t[(t[w>>2]|0)+24>>2]|0)n:while(1){if(!(n[(t[(t[w>>2]|0)+24>>2]|0)+(t[b>>2]|0)>>0]|0))break r;while(1){if(n[(t[(t[w>>2]|0)+24>>2]|0)+(t[b>>2]|0)>>0]|0)m=(n[(t[(t[w>>2]|0)+24>>2]|0)+(t[b>>2]|0)>>0]|0)!=47;else m=0;_=t[b>>2]|0;if(!m)break;t[b>>2]=_+1}if(!(n[(t[(t[w>>2]|0)+24>>2]|0)+_>>0]|0))break r;t[b>>2]=(t[b>>2]|0)+1;while(1){if((t[k>>2]|0)>=(t[b>>2]|0))continue n;n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]=n[(t[(t[w>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]|0;t[k>>2]=(t[k>>2]|0)+1}}while(0);n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]=0;r:do if(t[(t[h>>2]|0)+24>>2]|0){if(!(n[t[(t[h>>2]|0)+24>>2]>>0]|0))break;t[l>>2]=0;do if(!(t[k>>2]|0)){if(!(t[(t[w>>2]|0)+12>>2]|0))break;i=t[k>>2]|0;t[k>>2]=i+1;n[(t[(t[d>>2]|0)+24>>2]|0)+i>>0]=47}while(0);while(1){if(!(n[(t[(t[h>>2]|0)+24>>2]|0)+(t[l>>2]|0)>>0]|0))break r;i=t[l>>2]|0;t[l>>2]=i+1;e=n[(t[(t[h>>2]|0)+24>>2]|0)+i>>0]|0;i=t[k>>2]|0;t[k>>2]=i+1;n[(t[(t[d>>2]|0)+24>>2]|0)+i>>0]=e}}while(0);n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]=0;jA(t[(t[d>>2]|0)+24>>2]|0)|0;break}e=t[33942]|0;i=t[h>>2]|0;if(t[(t[h>>2]|0)+8>>2]|0){p=gAi[e&511](t[i+8>>2]|0)|0;t[(t[d>>2]|0)+8>>2]=p}else{p=gAi[e&511](t[i+12>>2]|0)|0;t[(t[d>>2]|0)+12>>2]=p;if(t[(t[h>>2]|0)+16>>2]|0){p=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+16>>2]|0)|0;t[(t[d>>2]|0)+16>>2]=p}t[(t[d>>2]|0)+20>>2]=t[(t[h>>2]|0)+20>>2]}if(t[(t[h>>2]|0)+24>>2]|0){p=gAi[t[135768>>2]&511](t[(t[h>>2]|0)+24>>2]|0)|0;t[(t[d>>2]|0)+24>>2]=p}}while(0);t[a>>2]=zA(t[d>>2]|0)|0}}while(0);if(t[h>>2]|0)xA(t[h>>2]|0);if(t[w>>2]|0)xA(t[w>>2]|0);if(!(t[d>>2]|0)){E=t[a>>2]|0;s=r;return E|0}xA(t[d>>2]|0);E=t[a>>2]|0;s=r;return E|0}function WA(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;r=s;s=s+64|0;f=r+56|0;a=r+52|0;o=r+48|0;c=r+44|0;l=r+40|0;b=r+36|0;k=r+32|0;h=r+28|0;w=r+24|0;d=r+20|0;v=r+16|0;m=r+12|0;_=r+8|0;p=r+4|0;E=r;t[a>>2]=e;t[o>>2]=i;t[c>>2]=0;t[k>>2]=0;t[h>>2]=0;t[d>>2]=0;t[v>>2]=0;t[E>>2]=0;if((t[a>>2]|0)!=0?(u[t[a>>2]>>0]|0)!=0:0){t[d>>2]=HA()|0;if(!(t[d>>2]|0)){t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}if((u[t[a>>2]>>0]|0)!=46){t[l>>2]=UA(t[d>>2]|0,t[a>>2]|0)|0;if(!(t[l>>2]|0))g=9}else{i=Yl(t[a>>2]|0)|0;t[(t[d>>2]|0)+24>>2]=i;g=9}e:do if((g|0)==9){if((t[o>>2]|0)!=0?(u[t[o>>2]>>0]|0)!=0:0){t[v>>2]=HA()|0;if(!(t[v>>2]|0))break;if((u[t[o>>2]>>0]|0)!=46){t[l>>2]=UA(t[v>>2]|0,t[o>>2]|0)|0;if(t[l>>2]|0)break}else{i=Yl(t[o>>2]|0)|0;t[(t[v>>2]|0)+24>>2]=i}do if(t[t[d>>2]>>2]|0){if(((t[t[v>>2]>>2]|0)!=0?(Kl(t[t[v>>2]>>2]|0,t[t[d>>2]>>2]|0)|0)==0:0)?(Kl(t[(t[v>>2]|0)+12>>2]|0,t[(t[d>>2]|0)+12>>2]|0)|0)==0:0)break;t[c>>2]=Yl(t[a>>2]|0)|0;break e}while(0);if(Xl(t[(t[v>>2]|0)+24>>2]|0,t[(t[d>>2]|0)+24>>2]|0)|0){t[c>>2]=Yl(79160)|0;break}i=t[(t[d>>2]|0)+24>>2]|0;if(!(t[(t[v>>2]|0)+24>>2]|0)){t[c>>2]=Yl(i)|0;break}if(!i){t[(t[d>>2]|0)+24>>2]=79208;t[E>>2]=1}if(!(t[(t[v>>2]|0)+24>>2]|0)){if(!(t[(t[d>>2]|0)+24>>2]|0))break;t[_>>2]=t[(t[d>>2]|0)+24>>2];if((u[t[_>>2]>>0]|0)==47)t[_>>2]=(t[_>>2]|0)+1;t[c>>2]=qA(t[_>>2]|0,79216)|0;break}t[m>>2]=t[(t[v>>2]|0)+24>>2];if(!(t[(t[d>>2]|0)+24>>2]|0)){t[b>>2]=0;while(1){if(!(u[(t[m>>2]|0)+(t[b>>2]|0)>>0]|0))break;if((u[(t[m>>2]|0)+(t[b>>2]|0)>>0]|0)==47)t[h>>2]=(t[h>>2]|0)+1;t[b>>2]=(t[b>>2]|0)+1}t[_>>2]=0;t[w>>2]=1}else{do if((n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]|0)==46){if((n[(t[(t[d>>2]|0)+24>>2]|0)+((t[k>>2]|0)+1)>>0]|0)!=47)break;t[k>>2]=(t[k>>2]|0)+2}while(0);do if((u[t[m>>2]>>0]|0)==46){if((u[(t[m>>2]|0)+1>>0]|0)!=47){g=45;break}t[m>>2]=(t[m>>2]|0)+2}else g=45;while(0);do if((g|0)==45){if((u[t[m>>2]>>0]|0)!=47)break;if((n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]|0)==47)break;t[m>>2]=(t[m>>2]|0)+1}while(0);while(1){if((u[(t[m>>2]|0)+(t[k>>2]|0)>>0]|0)==(n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]|0))y=(u[(t[m>>2]|0)+(t[k>>2]|0)>>0]|0)!=0;else y=0;F=t[k>>2]|0;if(!y)break;t[k>>2]=F+1}if((u[(t[m>>2]|0)+F>>0]|0)==(n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]|0)){t[c>>2]=Yl(79160)|0;break}t[b>>2]=t[k>>2];i=t[b>>2]|0;do if((t[b>>2]|0)>0?(n[(t[(t[d>>2]|0)+24>>2]|0)+(t[b>>2]|0)>>0]|0)==47:0)t[b>>2]=i+-1;else{if(!((t[b>>2]|0)>1?(n[(t[(t[d>>2]|0)+24>>2]|0)+i>>0]|0)==0:0))break;if((n[(t[(t[d>>2]|0)+24>>2]|0)+((t[b>>2]|0)-1)>>0]|0)!=47)break;t[b>>2]=(t[b>>2]|0)-2}while(0);while(1){if((t[b>>2]|0)<=0)break;if((n[(t[(t[d>>2]|0)+24>>2]|0)+(t[b>>2]|0)>>0]|0)==47)break;t[b>>2]=(t[b>>2]|0)+-1}if(!(t[b>>2]|0))t[_>>2]=t[(t[d>>2]|0)+24>>2];else{t[b>>2]=(t[b>>2]|0)+1;t[_>>2]=(t[(t[d>>2]|0)+24>>2]|0)+(t[b>>2]|0)}i:do if((u[(t[m>>2]|0)+(t[k>>2]|0)>>0]|0)!=(n[(t[(t[d>>2]|0)+24>>2]|0)+(t[k>>2]|0)>>0]|0))while(1){if(!(u[(t[m>>2]|0)+(t[b>>2]|0)>>0]|0))break i;if((u[(t[m>>2]|0)+(t[b>>2]|0)>>0]|0)==47)t[h>>2]=(t[h>>2]|0)+1;t[b>>2]=(t[b>>2]|0)+1}while(0);t[w>>2]=(rs(t[_>>2]|0)|0)+1}if(!(t[h>>2]|0)){if(!(t[_>>2]|0))break;t[c>>2]=qA(t[_>>2]|0,79216)|0;break}t[c>>2]=gAi[t[135744>>2]&511]((t[w>>2]|0)+((t[h>>2]|0)*3|0)|0)|0;if(!(t[c>>2]|0)){JA(79224);break}t[p>>2]=t[c>>2];while(1){if((t[h>>2]|0)<=0)break;i=t[p>>2]|0;t[p>>2]=i+1;n[i>>0]=46;i=t[p>>2]|0;t[p>>2]=i+1;n[i>>0]=46;i=t[p>>2]|0;t[p>>2]=i+1;n[i>>0]=47;t[h>>2]=(t[h>>2]|0)+-1}i:do if(t[_>>2]|0){do if((t[w>>2]|0)>0?(t[p>>2]|0)>>>0>(t[c>>2]|0)>>>0:0){if((u[t[_>>2]>>0]|0)!=47)break;if((u[(t[p>>2]|0)+-1>>0]|0)!=47)break;YY(t[p>>2]|0,(t[_>>2]|0)+1|0,(t[w>>2]|0)-1|0)|0;n[(t[p>>2]|0)+((t[w>>2]|0)-2)>>0]=0;break i}while(0);YY(t[p>>2]|0,t[_>>2]|0,t[w>>2]|0)|0;n[(t[p>>2]|0)+((t[w>>2]|0)-1)>>0]=0}else n[(t[p>>2]|0)+((t[w>>2]|0)-1)>>0]=0;while(0);t[p>>2]=t[c>>2];t[c>>2]=qA(t[p>>2]|0,79216)|0;pAi[t[135736>>2]&511](t[p>>2]|0);break}t[c>>2]=Yl(t[a>>2]|0)|0}while(0);if(t[E>>2]|0)t[(t[d>>2]|0)+24>>2]=0;if(t[d>>2]|0)xA(t[d>>2]|0);if(t[v>>2]|0)xA(t[v>>2]|0);t[f>>2]=t[c>>2];S=t[f>>2]|0;s=r;return S|0}t[f>>2]=0;S=t[f>>2]|0;s=r;return S|0}function KA(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+48|0;r=i+28|0;f=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i+32|0;h=i;t[f>>2]=e;if(!(t[f>>2]|0)){t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}if(((u[t[f>>2]>>0]|0|0)==47?(u[(t[f>>2]|0)+1>>0]|0|0)==47:0)?(u[(t[f>>2]|0)+2>>0]|0|0)!=47:0)t[f>>2]=(t[f>>2]|0)+1;e=IA(t[f>>2]|0)|0;t[a>>2]=e;if(e){xA(t[a>>2]|0);t[r>>2]=Yl(t[f>>2]|0)|0;w=t[r>>2]|0;s=i;return w|0}t[c>>2]=is(t[f>>2]|0,79248)|0;e:do if((t[c>>2]|0)!=0?(t[l>>2]=(t[c>>2]|0)-(t[f>>2]|0),!((t[l>>2]|0)<=0|(t[l>>2]|0)>20)):0){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;n[k>>0]=n[(t[f>>2]|0)+(t[b>>2]|0)>>0]|0;if(!((u[k>>0]|0|0)>=97?(u[k>>0]|0|0)<=122:0)){if((u[k>>0]|0|0)<65)break e;if((u[k>>0]|0|0)>90)break e}t[b>>2]=(t[b>>2]|0)+1}t[h>>2]=qA(t[f>>2]|0,79256)|0;if((t[h>>2]|0)!=0?(t[a>>2]=IA(t[h>>2]|0)|0,(t[a>>2]|0)!=0):0){xA(t[a>>2]|0);t[r>>2]=t[h>>2];w=t[r>>2]|0;s=i;return w|0}}while(0);t[o>>2]=Yl(t[f>>2]|0)|0;t[r>>2]=t[o>>2];w=t[r>>2]|0;s=i;return w|0}function XA(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+64|0;r=i+60|0;n=i+56|0;f=i+52|0;u=i+8|0;a=i+4|0;o=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}e=IA(t[n>>2]|0)|0;t[f>>2]=e;if(e){xA(t[f>>2]|0);t[r>>2]=Yl(t[n>>2]|0)|0;c=t[r>>2]|0;s=i;return c|0}t[o>>2]=KA(t[n>>2]|0)|0;if(!(t[o>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else{n=u+0|0;f=n+44|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(f|0));t[u+24>>2]=t[o>>2];t[a>>2]=zA(u)|0;pAi[t[135736>>2]&511](t[o>>2]|0);t[r>>2]=t[a>>2];c=t[r>>2]|0;s=i;return c|0}return 0}function ZA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}eM(t[f>>2]|0);t[a>>2]=iM(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)!=0?(eM(t[f>>2]|0),t[a>>2]=rM(t[f>>2]|0,t[u>>2]|0)|0,(t[a>>2]|0)!=0):0){eM(t[f>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function JA(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;n=i+4|0;t[n>>2]=e;if(t[n>>2]|0){e=t[n>>2]|0;t[r>>2]=t[n>>2];cp(0,0,0,0,0,30,2,3,0,0,e,0,0,0,0,79320,r);s=i;return}else{cp(0,0,0,0,0,30,2,3,0,0,0,0,0,0,0,79352,r);s=i;return}}function QA(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((t[t[u>>2]>>2]|0)>1048576){JA(79272);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[o>>2]=t[t[u>>2]>>2]<<1;t[a>>2]=MAi[t[135760>>2]&511](t[f>>2]|0,(t[o>>2]|0)+1|0)|0;if(!(t[a>>2]|0)){JA(78984);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[t[u>>2]>>2]=t[o>>2];t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}return 0}function $A(e){e=e|0;var i=0,r=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i;f=i+4|0;n[f>>0]=e;if(!((n[f>>0]|0)>=48?(n[f>>0]|0)<=57:0))u=3;do if((u|0)==3){if((n[f>>0]|0)>=97?(n[f>>0]|0)<=102:0)break;if((n[f>>0]|0)>=65?(n[f>>0]|0)<=70:0)break;t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}while(0);t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}function eM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);t[t[r>>2]>>2]=0;if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);t[(t[r>>2]|0)+12>>2]=0;if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);t[(t[r>>2]|0)+16>>2]=0;if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);t[(t[r>>2]|0)+24>>2]=0;if(t[(t[r>>2]|0)+32>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+32>>2]|0);t[(t[r>>2]|0)+32>>2]=0;if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);t[(t[r>>2]|0)+4>>2]=0;if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);t[(t[r>>2]|0)+8>>2]=0;if(t[(t[r>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0);t[(t[r>>2]|0)+28>>2]=0;if(t[(t[r>>2]|0)+40>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+40>>2]|0);t[(t[r>>2]|0)+40>>2]=0;s=i;return}function iM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=nM(t[u>>2]|0,a)|0;do if(!(t[o>>2]|0)){if((n[t[a>>2]>>0]|0)!=58){t[f>>2]=1;break}t[a>>2]=(t[a>>2]|0)+1;t[o>>2]=fM(t[u>>2]|0,a)|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];break}if((n[t[a>>2]>>0]|0)==63?(t[a>>2]=(t[a>>2]|0)+1,t[o>>2]=tM(t[u>>2]|0,a)|0,(t[o>>2]|0)!=0):0){t[f>>2]=t[o>>2];break}if((n[t[a>>2]>>0]|0)==35?(t[a>>2]=(t[a>>2]|0)+1,t[o>>2]=uM(t[u>>2]|0,a)|0,(t[o>>2]|0)!=0):0){t[f>>2]=t[o>>2];break}if(n[t[a>>2]>>0]|0){eM(t[u>>2]|0);t[f>>2]=1;break}else{t[f>>2]=0;break}}else t[f>>2]=t[o>>2];while(0);s=r;return t[f>>2]|0}function rM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if((n[t[a>>2]>>0]|0)==47?(n[(t[a>>2]|0)+1>>0]|0)==47:0){t[a>>2]=(t[a>>2]|0)+2;t[o>>2]=aM(t[u>>2]|0,a)|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}t[o>>2]=oM(t[u>>2]|0,a)|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}}else l=7;e:do if((l|0)==7){if((n[t[a>>2]>>0]|0)==47){t[o>>2]=cM(t[u>>2]|0,a)|0;if(!(t[o>>2]|0))break;t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}if(!((n[t[a>>2]>>0]|0)>=97?(n[t[a>>2]>>0]|0)<=122:0))l=12;i:do if((l|0)==12){if((n[t[a>>2]>>0]|0)>=65?(n[t[a>>2]>>0]|0)<=90:0)break;if((n[t[a>>2]>>0]|0)>=48?(n[t[a>>2]>>0]|0)<=57:0)break;if((((n[t[a>>2]>>0]|0)!=45?(n[t[a>>2]>>0]|0)!=46:0)?(n[t[a>>2]>>0]|0)!=95:0)?(n[t[a>>2]>>0]|0)!=126:0){r:do if((n[t[a>>2]>>0]|0)==37){if(!((n[(t[a>>2]|0)+1>>0]|0)>=48?(n[(t[a>>2]|0)+1>>0]|0)<=57:0))l=23;do if((l|0)==23){if((n[(t[a>>2]|0)+1>>0]|0)>=97?(n[(t[a>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[a>>2]|0)+1>>0]|0)<65)break r;if((n[(t[a>>2]|0)+1>>0]|0)>70)break r}while(0);if((n[(t[a>>2]|0)+2>>0]|0)>=48?(n[(t[a>>2]|0)+2>>0]|0)<=57:0)break i;if((n[(t[a>>2]|0)+2>>0]|0)>=97?(n[(t[a>>2]|0)+2>>0]|0)<=102:0)break i;if((n[(t[a>>2]|0)+2>>0]|0)>=65?(n[(t[a>>2]|0)+2>>0]|0)<=70:0)break i}while(0);if((((((((n[t[a>>2]>>0]|0)!=33?(n[t[a>>2]>>0]|0)!=36:0)?(n[t[a>>2]>>0]|0)!=38:0)?(n[t[a>>2]>>0]|0)!=40:0)?(n[t[a>>2]>>0]|0)!=41:0)?(n[t[a>>2]>>0]|0)!=42:0)?(n[t[a>>2]>>0]|0)!=43:0)?(n[t[a>>2]>>0]|0)!=44:0){if((n[t[a>>2]>>0]|0)==59)break;if((n[t[a>>2]>>0]|0)==61)break;if((n[t[a>>2]>>0]|0)==39)break;if((n[t[a>>2]>>0]|0)==58)break;if((n[t[a>>2]>>0]|0)==64)break;if(!(t[u>>2]|0))break e;if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);t[(t[u>>2]|0)+24>>2]=0;break e}}}while(0);t[o>>2]=lM(t[u>>2]|0,a)|0;if(t[o>>2]|0){t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}}while(0);if((n[t[a>>2]>>0]|0)==63?(t[a>>2]=(t[a>>2]|0)+1,t[o>>2]=tM(t[u>>2]|0,a)|0,(t[o>>2]|0)!=0):0){t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}if((n[t[a>>2]>>0]|0)==35?(t[a>>2]=(t[a>>2]|0)+1,t[o>>2]=uM(t[u>>2]|0,a)|0,(t[o>>2]|0)!=0):0){t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}if(n[t[a>>2]>>0]|0){eM(t[u>>2]|0);t[f>>2]=1;c=t[f>>2]|0;s=r;return c|0}else{t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}return 0}function nM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=t[t[a>>2]>>2];if(!((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0))l=5;do if((l|0)==5){if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0)break;t[f>>2]=2;c=t[f>>2]|0;s=r;return c|0}while(0);t[o>>2]=(t[o>>2]|0)+1;e:while(1){if(!((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0))l=11;do if((l|0)==11){l=0;if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0)break;if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0)break;if(((n[t[o>>2]>>0]|0)!=43?(n[t[o>>2]>>0]|0)!=45:0)?(n[t[o>>2]>>0]|0)!=46:0)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}if(t[u>>2]|0){if(t[t[u>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[u>>2]>>2]|0);l=ql(t[t[a>>2]>>2]|0,(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0)|0;t[t[u>>2]>>2]=l}t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}function fM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];if((n[t[o>>2]>>0]|0)==47?(n[(t[o>>2]|0)+1>>0]|0)==47:0){t[o>>2]=(t[o>>2]|0)+2;t[c>>2]=aM(t[u>>2]|0,o)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}if(!(t[(t[u>>2]|0)+12>>2]|0))t[(t[u>>2]|0)+20>>2]=-1;t[c>>2]=oM(t[u>>2]|0,o)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}else{t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}}e:do if((n[t[o>>2]>>0]|0)==47){t[c>>2]=cM(t[u>>2]|0,o)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}}else{if(!((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0))b=15;i:do if((b|0)==15){if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0)break;if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0)break;if((((n[t[o>>2]>>0]|0)!=45?(n[t[o>>2]>>0]|0)!=46:0)?(n[t[o>>2]>>0]|0)!=95:0)?(n[t[o>>2]>>0]|0)!=126:0){r:do if((n[t[o>>2]>>0]|0)==37){if(!((n[(t[o>>2]|0)+1>>0]|0)>=48?(n[(t[o>>2]|0)+1>>0]|0)<=57:0))b=26;do if((b|0)==26){if((n[(t[o>>2]|0)+1>>0]|0)>=97?(n[(t[o>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[o>>2]|0)+1>>0]|0)<65)break r;if((n[(t[o>>2]|0)+1>>0]|0)>70)break r}while(0);if((n[(t[o>>2]|0)+2>>0]|0)>=48?(n[(t[o>>2]|0)+2>>0]|0)<=57:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=97?(n[(t[o>>2]|0)+2>>0]|0)<=102:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=65?(n[(t[o>>2]|0)+2>>0]|0)<=70:0)break i}while(0);if((((((((n[t[o>>2]>>0]|0)!=33?(n[t[o>>2]>>0]|0)!=36:0)?(n[t[o>>2]>>0]|0)!=38:0)?(n[t[o>>2]>>0]|0)!=40:0)?(n[t[o>>2]>>0]|0)!=41:0)?(n[t[o>>2]>>0]|0)!=42:0)?(n[t[o>>2]>>0]|0)!=43:0)?(n[t[o>>2]>>0]|0)!=44:0){if((n[t[o>>2]>>0]|0)==59)break;if((n[t[o>>2]>>0]|0)==61)break;if((n[t[o>>2]>>0]|0)==39)break;if((n[t[o>>2]>>0]|0)==58)break;if((n[t[o>>2]>>0]|0)==64)break;if(!(t[u>>2]|0))break e;if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);t[(t[u>>2]|0)+24>>2]=0;break e}}}while(0);t[c>>2]=sM(t[u>>2]|0,o)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}function tM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=t[t[a>>2]>>2];e:while(1){if(!((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0))l=6;i:do if((l|0)==6){l=0;if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0)break;if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0)break;if((((n[t[o>>2]>>0]|0)!=45?(n[t[o>>2]>>0]|0)!=46:0)?(n[t[o>>2]>>0]|0)!=95:0)?(n[t[o>>2]>>0]|0)!=126:0){r:do if((n[t[o>>2]>>0]|0)==37){if(!((n[(t[o>>2]|0)+1>>0]|0)>=48?(n[(t[o>>2]|0)+1>>0]|0)<=57:0))l=17;do if((l|0)==17){l=0;if((n[(t[o>>2]|0)+1>>0]|0)>=97?(n[(t[o>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[o>>2]|0)+1>>0]|0)<65)break r;if((n[(t[o>>2]|0)+1>>0]|0)>70)break r}while(0);if((n[(t[o>>2]|0)+2>>0]|0)>=48?(n[(t[o>>2]|0)+2>>0]|0)<=57:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=97?(n[(t[o>>2]|0)+2>>0]|0)<=102:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=65?(n[(t[o>>2]|0)+2>>0]|0)<=70:0)break i}while(0);if(((((((((n[t[o>>2]>>0]|0)!=33?(n[t[o>>2]>>0]|0)!=36:0)?(n[t[o>>2]>>0]|0)!=38:0)?(n[t[o>>2]>>0]|0)!=40:0)?(n[t[o>>2]>>0]|0)!=41:0)?(n[t[o>>2]>>0]|0)!=42:0)?(n[t[o>>2]>>0]|0)!=43:0)?(n[t[o>>2]>>0]|0)!=44:0)?(n[t[o>>2]>>0]|0)!=59:0){if((n[t[o>>2]>>0]|0)==61)break;if((n[t[o>>2]>>0]|0)==39)break;if((n[t[o>>2]>>0]|0)==58)break;if((n[t[o>>2]>>0]|0)==64)break;if((n[t[o>>2]>>0]|0)==47)break;if((n[t[o>>2]>>0]|0)==63)break;if(!(t[u>>2]|0))break e;if(!(t[(t[u>>2]|0)+36>>2]&1))break e;if((n[t[o>>2]>>0]|0)==123)break;if((n[t[o>>2]>>0]|0)==125)break;if((n[t[o>>2]>>0]|0)==124)break;if((n[t[o>>2]>>0]|0)==92)break;if((n[t[o>>2]>>0]|0)==94)break;if((n[t[o>>2]>>0]|0)==91)break;if((n[t[o>>2]>>0]|0)==93)break;if((n[t[o>>2]>>0]|0)!=96)break e}}}while(0);i=t[o>>2]|0;if((n[t[o>>2]>>0]|0)==37){t[o>>2]=i+3;continue}else{t[o>>2]=i+1;continue}}if(t[u>>2]|0){if(t[(t[u>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+28>>2]|0);
	l=t[t[a>>2]>>2]|0;i=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[(t[u>>2]|0)+36>>2]&2){e=ql(l,i)|0;t[(t[u>>2]|0)+28>>2]=e}else{e=VA(l,i,0)|0;t[(t[u>>2]|0)+28>>2]=e}if(t[(t[u>>2]|0)+40>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+40>>2]|0);e=ql(t[t[a>>2]>>2]|0,(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0)|0;t[(t[u>>2]|0)+40>>2]=e}t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}function uM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;if(!(t[a>>2]|0)){t[f>>2]=-1;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=t[t[a>>2]>>2];e:while(1){if(!((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0))l=6;i:do if((l|0)==6){l=0;if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0)break;if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0)break;if((((n[t[o>>2]>>0]|0)!=45?(n[t[o>>2]>>0]|0)!=46:0)?(n[t[o>>2]>>0]|0)!=95:0)?(n[t[o>>2]>>0]|0)!=126:0){r:do if((n[t[o>>2]>>0]|0)==37){if(!((n[(t[o>>2]|0)+1>>0]|0)>=48?(n[(t[o>>2]|0)+1>>0]|0)<=57:0))l=17;do if((l|0)==17){l=0;if((n[(t[o>>2]|0)+1>>0]|0)>=97?(n[(t[o>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[o>>2]|0)+1>>0]|0)<65)break r;if((n[(t[o>>2]|0)+1>>0]|0)>70)break r}while(0);if((n[(t[o>>2]|0)+2>>0]|0)>=48?(n[(t[o>>2]|0)+2>>0]|0)<=57:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=97?(n[(t[o>>2]|0)+2>>0]|0)<=102:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=65?(n[(t[o>>2]|0)+2>>0]|0)<=70:0)break i}while(0);if(((((((((n[t[o>>2]>>0]|0)!=33?(n[t[o>>2]>>0]|0)!=36:0)?(n[t[o>>2]>>0]|0)!=38:0)?(n[t[o>>2]>>0]|0)!=40:0)?(n[t[o>>2]>>0]|0)!=41:0)?(n[t[o>>2]>>0]|0)!=42:0)?(n[t[o>>2]>>0]|0)!=43:0)?(n[t[o>>2]>>0]|0)!=44:0)?(n[t[o>>2]>>0]|0)!=59:0){if((n[t[o>>2]>>0]|0)==61)break;if((n[t[o>>2]>>0]|0)==39)break;if((n[t[o>>2]>>0]|0)==58)break;if((n[t[o>>2]>>0]|0)==64)break;if((n[t[o>>2]>>0]|0)==47)break;if((n[t[o>>2]>>0]|0)==63)break;if((n[t[o>>2]>>0]|0)==91)break;if((n[t[o>>2]>>0]|0)==93)break;if(!(t[u>>2]|0))break e;if(!(t[(t[u>>2]|0)+36>>2]&1))break e;if((n[t[o>>2]>>0]|0)==123)break;if((n[t[o>>2]>>0]|0)==125)break;if((n[t[o>>2]>>0]|0)==124)break;if((n[t[o>>2]>>0]|0)==92)break;if((n[t[o>>2]>>0]|0)==94)break;if((n[t[o>>2]>>0]|0)==91)break;if((n[t[o>>2]>>0]|0)==93)break;if((n[t[o>>2]>>0]|0)!=96)break e}}}while(0);i=t[o>>2]|0;if((n[t[o>>2]>>0]|0)==37){t[o>>2]=i+3;continue}else{t[o>>2]=i+1;continue}}do if(t[u>>2]|0){if(t[(t[u>>2]|0)+32>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+32>>2]|0);l=t[t[a>>2]>>2]|0;i=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[(t[u>>2]|0)+36>>2]&2){e=ql(l,i)|0;t[(t[u>>2]|0)+32>>2]=e;break}else{e=VA(l,i,0)|0;t[(t[u>>2]|0)+32>>2]=e;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}function aM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[c>>2]=bM(t[u>>2]|0,o)|0;if((t[c>>2]|0)==0?(n[t[o>>2]>>0]|0)==64:0)t[o>>2]=(t[o>>2]|0)+1;else t[o>>2]=t[t[a>>2]>>2];t[c>>2]=kM(t[u>>2]|0,o)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}if((n[t[o>>2]>>0]|0)==58?(t[o>>2]=(t[o>>2]|0)+1,t[c>>2]=hM(t[u>>2]|0,o)|0,(t[c>>2]|0)!=0):0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}function oM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];while(1){if((n[t[o>>2]>>0]|0)!=47)break;t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=wM(o,0,1)|0;if(t[c>>2]|0){l=4;break}}if((l|0)==4){t[f>>2]=t[c>>2];b=t[f>>2]|0;s=r;return b|0}do if(t[u>>2]|0){if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);c=t[u>>2]|0;if((t[t[a>>2]>>2]|0)==(t[o>>2]|0)){t[c+24>>2]=0;break}l=t[t[a>>2]>>2]|0;i=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[c+36>>2]&2){c=ql(l,i)|0;t[(t[u>>2]|0)+24>>2]=c;break}else{c=VA(l,i,0)|0;t[(t[u>>2]|0)+24>>2]=c;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;b=t[f>>2]|0;s=r;return b|0}function cM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];if((n[t[o>>2]>>0]|0)!=47){t[f>>2]=1;l=t[f>>2]|0;s=r;return l|0}t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=wM(o,0,0)|0;e:do if(!(t[c>>2]|0)){do{if((n[t[o>>2]>>0]|0)!=47)break e;t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=wM(o,0,1)|0}while((t[c>>2]|0)==0);t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}while(0);do if(t[u>>2]|0){if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);c=t[u>>2]|0;if((t[o>>2]|0)==(t[t[a>>2]>>2]|0)){t[c+24>>2]=0;break}i=t[t[a>>2]>>2]|0;e=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[c+36>>2]&2){c=ql(i,e)|0;t[(t[u>>2]|0)+24>>2]=c;break}else{c=VA(i,e,0)|0;t[(t[u>>2]|0)+24>>2]=c;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}function lM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[c>>2]=wM(o,58,0)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}while(1){if((n[t[o>>2]>>0]|0)!=47)break;t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=wM(o,0,1)|0;if(t[c>>2]|0){b=5;break}}if((b|0)==5){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}do if(t[u>>2]|0){if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);c=t[u>>2]|0;if((t[o>>2]|0)==(t[t[a>>2]>>2]|0)){t[c+24>>2]=0;break}b=t[t[a>>2]>>2]|0;i=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[c+36>>2]&2){c=ql(b,i)|0;t[(t[u>>2]|0)+24>>2]=c;break}else{c=VA(b,i,0)|0;t[(t[u>>2]|0)+24>>2]=c;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}function sM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[c>>2]=wM(o,0,0)|0;if(t[c>>2]|0){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}while(1){if((n[t[o>>2]>>0]|0)!=47)break;t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=wM(o,0,1)|0;if(t[c>>2]|0){b=5;break}}if((b|0)==5){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=r;return l|0}do if(t[u>>2]|0){if(t[(t[u>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);c=t[u>>2]|0;if((t[o>>2]|0)==(t[t[a>>2]>>2]|0)){t[c+24>>2]=0;break}b=t[t[a>>2]>>2]|0;i=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[c+36>>2]&2){c=ql(b,i)|0;t[(t[u>>2]|0)+24>>2]=c;break}else{c=VA(b,i,0)|0;t[(t[u>>2]|0)+24>>2]=c;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;l=t[f>>2]|0;s=r;return l|0}function bM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];while(1){if((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0)c=1;else l=4;e:do if((l|0)==4){l=0;if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0){c=1;break}if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0){c=1;break}if((((n[t[o>>2]>>0]|0)!=45?(n[t[o>>2]>>0]|0)!=46:0)?(n[t[o>>2]>>0]|0)!=95:0)?(n[t[o>>2]>>0]|0)!=126:0){i:do if((n[t[o>>2]>>0]|0)==37){if(!((n[(t[o>>2]|0)+1>>0]|0)>=48?(n[(t[o>>2]|0)+1>>0]|0)<=57:0))l=15;do if((l|0)==15){l=0;if((n[(t[o>>2]|0)+1>>0]|0)>=97?(n[(t[o>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[o>>2]|0)+1>>0]|0)<65)break i;if((n[(t[o>>2]|0)+1>>0]|0)>70)break i}while(0);if((n[(t[o>>2]|0)+2>>0]|0)>=48?(n[(t[o>>2]|0)+2>>0]|0)<=57:0){c=1;break e}if((n[(t[o>>2]|0)+2>>0]|0)>=97?(n[(t[o>>2]|0)+2>>0]|0)<=102:0){c=1;break e}if((n[(t[o>>2]|0)+2>>0]|0)>=65?(n[(t[o>>2]|0)+2>>0]|0)<=70:0){c=1;break e}}while(0);if((((((((((n[t[o>>2]>>0]|0)!=33?(n[t[o>>2]>>0]|0)!=36:0)?(n[t[o>>2]>>0]|0)!=38:0)?(n[t[o>>2]>>0]|0)!=40:0)?(n[t[o>>2]>>0]|0)!=41:0)?(n[t[o>>2]>>0]|0)!=42:0)?(n[t[o>>2]>>0]|0)!=43:0)?(n[t[o>>2]>>0]|0)!=44:0)?(n[t[o>>2]>>0]|0)!=59:0)?(n[t[o>>2]>>0]|0)!=61:0){if((n[t[o>>2]>>0]|0)==39){c=1;break}c=(n[t[o>>2]>>0]|0)==58}else c=1}else c=1}while(0);b=n[t[o>>2]>>0]|0;if(!c)break;i=t[o>>2]|0;if((b|0)==37){t[o>>2]=i+3;continue}else{t[o>>2]=i+1;continue}}if((b|0)!=64){t[f>>2]=1;k=t[f>>2]|0;s=r;return k|0}do if(t[u>>2]|0){if(t[(t[u>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+16>>2]|0);b=t[t[a>>2]>>2]|0;c=(t[o>>2]|0)-(t[t[a>>2]>>2]|0)|0;if(t[(t[u>>2]|0)+36>>2]&2){l=ql(b,c)|0;t[(t[u>>2]|0)+16>>2]=l;break}else{l=VA(b,c,0)|0;t[(t[u>>2]|0)+16>>2]=l;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}function kM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[c>>2]=t[o>>2];i=t[o>>2]|0;e:do if((n[t[o>>2]>>0]|0)==91){t[o>>2]=i+1;while(1){if((n[t[o>>2]>>0]|0)!=93)l=(n[t[o>>2]>>0]|0)!=0;else l=0;b=t[o>>2]|0;if(!l)break;t[o>>2]=b+1}if((n[b>>0]|0)==93){t[o>>2]=(t[o>>2]|0)+1;break}t[f>>2]=1;k=t[f>>2]|0;s=r;return k|0}else{if((n[i>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0){if(((((((dM(o)|0)==0?(n[t[o>>2]>>0]|0)==46:0)?(t[o>>2]=(t[o>>2]|0)+1,(dM(o)|0)==0):0)?(n[t[o>>2]>>0]|0)==46:0)?(dM(o)|0)==0:0)?(n[t[o>>2]>>0]|0)==46:0)?(dM(o)|0)==0:0)break;t[o>>2]=t[t[a>>2]>>2]}while(1){if(!((n[t[o>>2]>>0]|0)>=97?(n[t[o>>2]>>0]|0)<=122:0))h=22;i:do if((h|0)==22){h=0;if((n[t[o>>2]>>0]|0)>=65?(n[t[o>>2]>>0]|0)<=90:0)break;if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0)break;if((((n[t[o>>2]>>0]|0)!=45?(n[t[o>>2]>>0]|0)!=46:0)?(n[t[o>>2]>>0]|0)!=95:0)?(n[t[o>>2]>>0]|0)!=126:0){r:do if((n[t[o>>2]>>0]|0)==37){if(!((n[(t[o>>2]|0)+1>>0]|0)>=48?(n[(t[o>>2]|0)+1>>0]|0)<=57:0))h=33;do if((h|0)==33){h=0;if((n[(t[o>>2]|0)+1>>0]|0)>=97?(n[(t[o>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[o>>2]|0)+1>>0]|0)<65)break r;if((n[(t[o>>2]|0)+1>>0]|0)>70)break r}while(0);if((n[(t[o>>2]|0)+2>>0]|0)>=48?(n[(t[o>>2]|0)+2>>0]|0)<=57:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=97?(n[(t[o>>2]|0)+2>>0]|0)<=102:0)break i;if((n[(t[o>>2]|0)+2>>0]|0)>=65?(n[(t[o>>2]|0)+2>>0]|0)<=70:0)break i}while(0);if(((((((n[t[o>>2]>>0]|0)!=33?(n[t[o>>2]>>0]|0)!=36:0)?(n[t[o>>2]>>0]|0)!=38:0)?(n[t[o>>2]>>0]|0)!=40:0)?(n[t[o>>2]>>0]|0)!=41:0)?(n[t[o>>2]>>0]|0)!=42:0)?(n[t[o>>2]>>0]|0)!=43:0){if((n[t[o>>2]>>0]|0)==44)break;if((n[t[o>>2]>>0]|0)==59)break;if((n[t[o>>2]>>0]|0)==61)break;if((n[t[o>>2]>>0]|0)!=39)break e}}}while(0);e=t[o>>2]|0;if((n[t[o>>2]>>0]|0)==37){t[o>>2]=e+3;continue}else{t[o>>2]=e+1;continue}}}while(0);do if(t[u>>2]|0){if(t[(t[u>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+8>>2]|0);t[(t[u>>2]|0)+8>>2]=0;if(t[(t[u>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[u>>2]|0)+12>>2]|0);h=t[u>>2]|0;if((t[o>>2]|0)==(t[c>>2]|0)){t[h+12>>2]=0;break}i=t[c>>2]|0;b=(t[o>>2]|0)-(t[c>>2]|0)|0;if(t[h+36>>2]&2){h=ql(i,b)|0;t[(t[u>>2]|0)+12>>2]=h;break}else{h=VA(i,b,0)|0;t[(t[u>>2]|0)+12>>2]=h;break}}while(0);t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;k=t[f>>2]|0;s=r;return k|0}function hM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];if((n[t[o>>2]>>0]|0)>=48?(n[t[o>>2]>>0]|0)<=57:0){if(t[u>>2]|0)t[(t[u>>2]|0)+20>>2]=0;while(1){if((n[t[o>>2]>>0]|0)<48)break;if((n[t[o>>2]>>0]|0)>57)break;if(t[u>>2]|0)t[(t[u>>2]|0)+20>>2]=((t[(t[u>>2]|0)+20>>2]|0)*10|0)+((n[t[o>>2]>>0]|0)-48);t[o>>2]=(t[o>>2]|0)+1}t[t[a>>2]>>2]=t[o>>2];t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[f>>2]=1;c=t[f>>2]|0;s=r;return c|0}function wM(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+12|0;a=f+8|0;o=f+16|0;c=f+4|0;l=f;t[a>>2]=e;n[o>>0]=i;t[c>>2]=r;t[l>>2]=t[t[a>>2]>>2];if(!((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0))b=3;e:do if((b|0)==3){if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0)break;if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0)break;if((((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=46:0)?(n[t[l>>2]>>0]|0)!=95:0)?(n[t[l>>2]>>0]|0)!=126:0){i:do if((n[t[l>>2]>>0]|0)==37){if(!((n[(t[l>>2]|0)+1>>0]|0)>=48?(n[(t[l>>2]|0)+1>>0]|0)<=57:0))b=14;do if((b|0)==14){if((n[(t[l>>2]|0)+1>>0]|0)>=97?(n[(t[l>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[l>>2]|0)+1>>0]|0)<65)break i;if((n[(t[l>>2]|0)+1>>0]|0)>70)break i}while(0);if((n[(t[l>>2]|0)+2>>0]|0)>=48?(n[(t[l>>2]|0)+2>>0]|0)<=57:0)break e;if((n[(t[l>>2]|0)+2>>0]|0)>=97?(n[(t[l>>2]|0)+2>>0]|0)<=102:0)break e;if((n[(t[l>>2]|0)+2>>0]|0)>=65?(n[(t[l>>2]|0)+2>>0]|0)<=70:0)break e}while(0);if(((((((((((n[t[l>>2]>>0]|0)!=33?(n[t[l>>2]>>0]|0)!=36:0)?(n[t[l>>2]>>0]|0)!=38:0)?(n[t[l>>2]>>0]|0)!=40:0)?(n[t[l>>2]>>0]|0)!=41:0)?(n[t[l>>2]>>0]|0)!=42:0)?(n[t[l>>2]>>0]|0)!=43:0)?(n[t[l>>2]>>0]|0)!=44:0)?(n[t[l>>2]>>0]|0)!=59:0)?(n[t[l>>2]>>0]|0)!=61:0)?(n[t[l>>2]>>0]|0)!=39:0){if((n[t[l>>2]>>0]|0)==58)break;if((n[t[l>>2]>>0]|0)==64)break;if(t[c>>2]|0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}else{t[u>>2]=1;k=t[u>>2]|0;s=f;return k|0}}}}while(0);while(1){if((n[t[l>>2]>>0]|0)>=97?(n[t[l>>2]>>0]|0)<=122:0)b=76;else b=42;e:do if((b|0)==42){b=0;if((n[t[l>>2]>>0]|0)>=65?(n[t[l>>2]>>0]|0)<=90:0){b=76;break}if((n[t[l>>2]>>0]|0)>=48?(n[t[l>>2]>>0]|0)<=57:0){b=76;break}if((((n[t[l>>2]>>0]|0)!=45?(n[t[l>>2]>>0]|0)!=46:0)?(n[t[l>>2]>>0]|0)!=95:0)?(n[t[l>>2]>>0]|0)!=126:0){i:do if((n[t[l>>2]>>0]|0)==37){if(!((n[(t[l>>2]|0)+1>>0]|0)>=48?(n[(t[l>>2]|0)+1>>0]|0)<=57:0))b=53;do if((b|0)==53){b=0;if((n[(t[l>>2]|0)+1>>0]|0)>=97?(n[(t[l>>2]|0)+1>>0]|0)<=102:0)break;if((n[(t[l>>2]|0)+1>>0]|0)<65)break i;if((n[(t[l>>2]|0)+1>>0]|0)>70)break i}while(0);if((n[(t[l>>2]|0)+2>>0]|0)>=48?(n[(t[l>>2]|0)+2>>0]|0)<=57:0){b=76;break e}if((n[(t[l>>2]|0)+2>>0]|0)>=97?(n[(t[l>>2]|0)+2>>0]|0)<=102:0){b=76;break e}if((n[(t[l>>2]|0)+2>>0]|0)>=65?(n[(t[l>>2]|0)+2>>0]|0)<=70:0){b=76;break e}}while(0);if(((((((((n[t[l>>2]>>0]|0)!=33?(n[t[l>>2]>>0]|0)!=36:0)?(n[t[l>>2]>>0]|0)!=38:0)?(n[t[l>>2]>>0]|0)!=40:0)?(n[t[l>>2]>>0]|0)!=41:0)?(n[t[l>>2]>>0]|0)!=42:0)?(n[t[l>>2]>>0]|0)!=43:0)?(n[t[l>>2]>>0]|0)!=44:0)?(n[t[l>>2]>>0]|0)!=59:0){if((n[t[l>>2]>>0]|0)==61){b=76;break}if((n[t[l>>2]>>0]|0)==39){b=76;break}if((n[t[l>>2]>>0]|0)==58){b=76;break}if((n[t[l>>2]>>0]|0)!=64)h=0;else b=76}else b=76}else b=76}while(0);if((b|0)==76){b=0;h=(n[t[l>>2]>>0]|0)!=(n[o>>0]|0)}w=t[l>>2]|0;if(!h)break;c=t[l>>2]|0;if((n[w>>0]|0)==37){t[l>>2]=c+3;continue}else{t[l>>2]=c+1;continue}}t[t[a>>2]>>2]=w;t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}function dM(e){e=e|0;var i=0,r=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;u=i;t[f>>2]=e;t[u>>2]=t[t[f>>2]>>2];if((n[t[u>>2]>>0]|0)>=48?(n[t[u>>2]>>0]|0)<=57:0){e:do if((n[(t[u>>2]|0)+1>>0]|0)>=48?(n[(t[u>>2]|0)+1>>0]|0)<=57:0){do if(((n[t[u>>2]>>0]|0)!=48?(n[(t[u>>2]|0)+1>>0]|0)>=48:0)?(n[(t[u>>2]|0)+1>>0]|0)<=57:0){if((n[(t[u>>2]|0)+2>>0]|0)>=48?(n[(t[u>>2]|0)+2>>0]|0)<=57:0)break;t[u>>2]=(t[u>>2]|0)+2;break e}while(0);if(((((n[t[u>>2]>>0]|0)==49?(n[(t[u>>2]|0)+1>>0]|0)>=48:0)?(n[(t[u>>2]|0)+1>>0]|0)<=57:0)?(n[(t[u>>2]|0)+2>>0]|0)>=48:0)?(n[(t[u>>2]|0)+2>>0]|0)<=57:0){t[u>>2]=(t[u>>2]|0)+3;break}if(((((n[t[u>>2]>>0]|0)==50?(n[(t[u>>2]|0)+1>>0]|0)>=48:0)?(n[(t[u>>2]|0)+1>>0]|0)<=52:0)?(n[(t[u>>2]|0)+2>>0]|0)>=48:0)?(n[(t[u>>2]|0)+2>>0]|0)<=57:0){t[u>>2]=(t[u>>2]|0)+3;break}if((((n[t[u>>2]>>0]|0)==50?(n[(t[u>>2]|0)+1>>0]|0)==53:0)?(n[(t[u>>2]|0)+2>>0]|0)>=48:0)?(n[(t[u>>2]|0)+1>>0]|0)<=53:0){t[u>>2]=(t[u>>2]|0)+3;break}t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}else o=6;while(0);if((o|0)==6)t[u>>2]=(t[u>>2]|0)+1;t[t[f>>2]>>2]=t[u>>2];t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[r>>2]=1;a=t[r>>2]|0;s=i;return a|0}function vM(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+5024|0;f=r+8|0;u=r+4|0;a=r;o=r+16|0;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if((t[(t[a>>2]|0)+4>>2]|0)!=15){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}if((t[(t[a>>2]|0)+36>>2]|0)!=4){t[f>>2]=1;c=t[f>>2]|0;s=r;return c|0}if(t[(t[a>>2]|0)+52>>2]|0)if(ib(t[(t[a>>2]|0)+52>>2]|0)|0){t[f>>2]=1;c=t[f>>2]|0;s=r;return c|0}else{t[(t[u>>2]|0)+36>>2]=0;t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}i=rb()|0;t[(t[u>>2]|0)+56>>2]=i;i=t[u>>2]|0;if(!(t[(t[u>>2]|0)+56>>2]|0)){ER(i,t[a>>2]|0,1,79384,t[(t[a>>2]|0)+8>>2]|0,0,0);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}e=ub(t[i+56>>2]|0)|0;t[(t[u>>2]|0)+60>>2]=e;SR(t[(t[a>>2]|0)+40>>2]|0,t[u>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;ab(t[(t[u>>2]|0)+56>>2]|0,t[(t[u>>2]|0)+60>>2]|0)|0;e=_b(t[(t[u>>2]|0)+56>>2]|0)|0;t[(t[a>>2]|0)+52>>2]=e;if((ib(t[(t[a>>2]|0)+52>>2]|0)|0)!=1){n[o>>0]=0;mM(o,5e3,t[(t[a>>2]|0)+40>>2]|0,1);ER(t[u>>2]|0,t[a>>2]|0,505,79424,t[(t[a>>2]|0)+8>>2]|0,o,0);t[(t[u>>2]|0)+36>>2]=0;t[(t[u>>2]|0)+60>>2]=0;nb(t[(t[u>>2]|0)+56>>2]|0);t[(t[u>>2]|0)+56>>2]=0;t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}else{t[(t[u>>2]|0)+60>>2]=0;nb(t[(t[u>>2]|0)+56>>2]|0);t[(t[u>>2]|0)+56>>2]=0;t[f>>2]=1;c=t[f>>2]|0;s=r;return c|0}return 0}function mM(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u+16|0;o=u+12|0;c=u+8|0;l=u+4|0;b=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=f;if(!(t[c>>2]|0)){s=u;return}t[b>>2]=HY(t[a>>2]|0)|0;if(((t[o>>2]|0)-(t[b>>2]|0)|0)<50){if(((t[o>>2]|0)-(t[b>>2]|0)|0)<=4){s=u;return}if((n[(t[a>>2]|0)+((t[b>>2]|0)-1)>>0]|0)==46){s=u;return}xY(t[a>>2]|0,79624)|0;s=u;return}if(t[l>>2]|0)xY(t[a>>2]|0,79632)|0;f=t[t[c>>2]>>2]|0;do if((f|0)==4){if((t[t[(t[c>>2]|0)+12>>2]>>2]|0)!=4?(t[t[(t[c>>2]|0)+12>>2]>>2]|0)!=3:0)mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+12>>2]|0,0);else mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+12>>2]|0,1);t[b>>2]=HY(t[a>>2]|0)|0;if(((t[o>>2]|0)-(t[b>>2]|0)|0)>=50){xY(t[a>>2]|0,79664)|0;if(!((t[t[(t[c>>2]|0)+16>>2]>>2]|0)!=3?(t[(t[(t[c>>2]|0)+16>>2]|0)+4>>2]|0)==1:0))k=41;if((k|0)==41?(t[t[(t[c>>2]|0)+16>>2]>>2]|0)!=2:0){mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+16>>2]|0,1);break}mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+16>>2]|0,0);break}if(((t[o>>2]|0)-(t[b>>2]|0)|0)<=4){s=u;return}if((n[(t[a>>2]|0)+((t[b>>2]|0)-1)>>0]|0)==46){s=u;return}xY(t[a>>2]|0,79624)|0;s=u;return}else if((f|0)==1)xY(t[a>>2]|0,79640)|0;else if((f|0)==3){if((t[t[(t[c>>2]|0)+12>>2]>>2]|0)!=4?(t[t[(t[c>>2]|0)+12>>2]>>2]|0)!=3:0)mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+12>>2]|0,0);else mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+12>>2]|0,1);t[b>>2]=HY(t[a>>2]|0)|0;if(((t[o>>2]|0)-(t[b>>2]|0)|0)>=50){xY(t[a>>2]|0,79656)|0;if(!((t[t[(t[c>>2]|0)+16>>2]>>2]|0)!=4?(t[(t[(t[c>>2]|0)+16>>2]|0)+4>>2]|0)==1:0))k=28;if((k|0)==28?(t[t[(t[c>>2]|0)+16>>2]>>2]|0)!=2:0){mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+16>>2]|0,1);break}mM(t[a>>2]|0,t[o>>2]|0,t[(t[c>>2]|0)+16>>2]|0,0);break}if(((t[o>>2]|0)-(t[b>>2]|0)|0)<=4){s=u;return}if((n[(t[a>>2]|0)+((t[b>>2]|0)-1)>>0]|0)==46){s=u;return}xY(t[a>>2]|0,79624)|0;s=u;return}else if((f|0)==2){do if(t[(t[c>>2]|0)+24>>2]|0){r=(t[o>>2]|0)-(t[b>>2]|0)|0;i=(r|0)<((rs(t[(t[c>>2]|0)+24>>2]|0)|0)+10|0);r=t[a>>2]|0;if(!i){xY(r|0,t[(t[c>>2]|0)+24>>2]|0)|0;xY(t[a>>2]|0,79648)|0;break}xY(r|0,79624)|0;s=u;return}while(0);r=(t[o>>2]|0)-(t[b>>2]|0)|0;if((r|0)<((rs(t[(t[c>>2]|0)+8>>2]|0)|0)+10|0)){xY(t[a>>2]|0,79624)|0;s=u;return}else{if(!(t[(t[c>>2]|0)+8>>2]|0))break;xY(t[a>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0;break}}while(0);if(t[l>>2]|0)xY(t[a>>2]|0,79672)|0;l=t[(t[c>>2]|0)+4>>2]|0;if((l|0)==3){xY(t[a>>2]|0,79688)|0;s=u;return}else if((l|0)==4){xY(t[a>>2]|0,79696)|0;s=u;return}else if((l|0)==2){xY(t[a>>2]|0,79680)|0;s=u;return}else{s=u;return}}function _M(){var e=0,i=0,r=0,n=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;n=gAi[t[135744>>2]&511](64)|0;t[r>>2]=n;if(!n){gR(0,79472);t[i>>2]=0;f=t[i>>2]|0;s=e;return f|0}else{n=(t[r>>2]|0)+0|0;u=n+64|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(u|0));t[i>>2]=t[r>>2];f=t[i>>2]|0;s=e;return f|0}return 0}function pM(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[(t[r>>2]|0)+52>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0);if(!(t[(t[r>>2]|0)+24>>2]|0)){n=t[33934]|0;f=t[r>>2]|0;pAi[n&511](f);s=i;return}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);n=t[33934]|0;f=t[r>>2]|0;pAi[n&511](f);s=i;return}function EM(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if(t[u>>2]|0)t[l>>2]=t[(t[u>>2]|0)+80>>2];u=t[o>>2]|0;if((u|0)==4|(u|0)==3|(u|0)==1){if(t[a>>2]|0)yR(0,1,79528,0)}else if((u|0)==2){if(!(t[a>>2]|0))yR(0,1,79488,0)}else{yR(0,1,79568,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[c>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[c>>2]|0)){gR(0,79472);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}u=t[c>>2]|0;t[u+0>>2]=0;t[u+4>>2]=0;t[u+8>>2]=0;t[u+12>>2]=0;t[u+16>>2]=0;t[u+20>>2]=0;t[u+24>>2]=0;t[t[c>>2]>>2]=t[o>>2];t[(t[c>>2]|0)+4>>2]=1;do if(t[a>>2]|0){t[k>>2]=jg(t[a>>2]|0,b)|0;o=(t[l>>2]|0)==0;if(!(t[k>>2]|0))if(o){u=Yl(t[a>>2]|0)|0;t[(t[c>>2]|0)+8>>2]=u;break}else{u=kz(t[l>>2]|0,t[a>>2]|0,-1)|0;t[(t[c>>2]|0)+8>>2]=u;break}else if(o){o=ql(t[a>>2]|0,t[b>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=o;o=Yl(t[k>>2]|0)|0;t[(t[c>>2]|0)+8>>2]=o;break}else{o=kz(t[l>>2]|0,t[a>>2]|0,t[b>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=o;o=kz(t[l>>2]|0,t[k>>2]|0,-1)|0;t[(t[c>>2]|0)+8>>2]=o;break}}while(0);t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}function SM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;t[l>>2]=0;if(!(t[u>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if(t[f>>2]|0)t[l>>2]=t[(t[f>>2]|0)+80>>2];t[a>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[a>>2]|0)){gR(0,79472);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}i=t[a>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[i+8>>2]=0;t[i+12>>2]=0;t[i+16>>2]=0;t[i+20>>2]=0;t[i+24>>2]=0;t[t[a>>2]>>2]=t[t[u>>2]>>2];t[(t[a>>2]|0)+4>>2]=t[(t[u>>2]|0)+4>>2];do if(t[(t[u>>2]|0)+8>>2]|0)if(t[l>>2]|0){i=kz(t[l>>2]|0,t[(t[u>>2]|0)+8>>2]|0,-1)|0;t[(t[a>>2]|0)+8>>2]=i;break}else{i=Yl(t[(t[u>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=i;break}while(0);do if(t[(t[u>>2]|0)+24>>2]|0)if(t[l>>2]|0){i=kz(t[l>>2]|0,t[(t[u>>2]|0)+24>>2]|0,-1)|0;t[(t[a>>2]|0)+24>>2]=i;break}else{i=Yl(t[(t[u>>2]|0)+24>>2]|0)|0;t[(t[a>>2]|0)+24>>2]=i;break}while(0);if(t[(t[u>>2]|0)+12>>2]|0){i=SM(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0;t[(t[a>>2]|0)+12>>2]=i}if(t[(t[a>>2]|0)+12>>2]|0)t[(t[(t[a>>2]|0)+12>>2]|0)+20>>2]=t[a>>2];e:do if(t[(t[u>>2]|0)+16>>2]|0){t[o>>2]=t[a>>2];t[u>>2]=t[(t[u>>2]|0)+16>>2];while(1){if(!(t[u>>2]|0))break e;t[c>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[c>>2]|0))break;i=t[c>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[i+8>>2]=0;t[i+12>>2]=0;t[i+16>>2]=0;t[i+20>>2]=0;t[i+24>>2]=0;t[t[c>>2]>>2]=t[t[u>>2]>>2];t[(t[c>>2]|0)+4>>2]=t[(t[u>>2]|0)+4>>2];t[(t[o>>2]|0)+16>>2]=t[c>>2];do if(t[(t[u>>2]|0)+8>>2]|0)if(t[l>>2]|0){i=kz(t[l>>2]|0,t[(t[u>>2]|0)+8>>2]|0,-1)|0;t[(t[c>>2]|0)+8>>2]=i;break}else{i=Yl(t[(t[u>>2]|0)+8>>2]|0)|0;t[(t[c>>2]|0)+8>>2]=i;break}while(0);do if(t[(t[u>>2]|0)+24>>2]|0)if(t[l>>2]|0){i=kz(t[l>>2]|0,t[(t[u>>2]|0)+24>>2]|0,-1)|0;t[(t[c>>2]|0)+24>>2]=i;break}else{i=Yl(t[(t[u>>2]|0)+24>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=i;break}while(0);if(t[(t[u>>2]|0)+12>>2]|0){i=SM(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0;t[(t[c>>2]|0)+12>>2]=i}if(t[(t[c>>2]|0)+12>>2]|0)t[(t[(t[c>>2]|0)+12>>2]|0)+20>>2]=t[a>>2];t[o>>2]=t[c>>2];t[u>>2]=t[(t[u>>2]|0)+16>>2]}gR(0,79472);t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}while(0);t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}function gM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=SM(0,t[r>>2]|0)|0;s=i;return e|0}function yM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=0;if(t[n>>2]|0)t[a>>2]=t[(t[n>>2]|0)+80>>2];while(1){if(!(t[f>>2]|0)){o=20;break}t[u>>2]=t[(t[f>>2]|0)+16>>2];if(((t[t[f>>2]>>2]|0)+-1|0)>>>0>=4)break;if(t[(t[f>>2]|0)+12>>2]|0)yM(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);i=(t[(t[f>>2]|0)+8>>2]|0)!=0;if(t[a>>2]|0){if(i?(wz(t[a>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0);if((t[(t[f>>2]|0)+24>>2]|0)!=0?(wz(t[a>>2]|0,t[(t[f>>2]|0)+24>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+24>>2]|0)}else{if(i)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0);if(t[(t[f>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+24>>2]|0)}pAi[t[135736>>2]&511](t[f>>2]|0);t[f>>2]=t[u>>2]}if((o|0)==20){s=r;return}yR(0,1,79568,0);s=r;return}function FM(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+48|0;a=u+44|0;o=u+40|0;c=u+36|0;l=u+32|0;b=u+28|0;k=u+24|0;h=u+20|0;w=u+16|0;d=u+12|0;v=u+8|0;m=u+4|0;_=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[d>>2]=0;if(!(t[c>>2]|0)){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}if(!(t[l>>2]|0)){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}f=t[b>>2]|0;if((f|0)==1){if(t[k>>2]|0){yR(t[o>>2]|0,1,79704,0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else if((f|0)==4){if(!(t[k>>2]|0)){yR(t[o>>2]|0,1,79848,0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else if((f|0)==3){if(!(t[k>>2]|0)){yR(t[o>>2]|0,1,79800,0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else if((f|0)==2){if(t[k>>2]|0){yR(t[o>>2]|0,1,79752,0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else{yR(t[o>>2]|0,1,79896,0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}t[m>>2]=zg(t[l>>2]|0,v)|0;if(t[m>>2]|0)t[l>>2]=t[m>>2];t[w>>2]=t[(t[c>>2]|0)+40>>2];if(!(t[w>>2]|0)){t[_>>2]=0;if(t[(t[c>>2]|0)+32>>2]|0)t[_>>2]=t[(t[(t[c>>2]|0)+32>>2]|0)+80>>2];t[w>>2]=KF(0,t[_>>2]|0)|0;t[(t[c>>2]|0)+40>>2]=t[w>>2]}if(!(t[w>>2]|0)){gR(t[o>>2]|0,79944);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}if((((t[(t[c>>2]|0)+32>>2]|0)!=0?(t[(t[(t[c>>2]|0)+32>>2]|0)+44>>2]|0)!=0:0)?(t[h>>2]=fO(t[(t[(t[(t[c>>2]|0)+32>>2]|0)+44>>2]|0)+40>>2]|0,t[l>>2]|0,t[v>>2]|0)|0,(t[h>>2]|0)!=0):0)?(t[(t[h>>2]|0)+36>>2]|0)==0:0){t[d>>2]=t[(t[h>>2]|0)+44>>2];t[(t[h>>2]|0)+44>>2]=0;wO(t[(t[(t[(t[c>>2]|0)+32>>2]|0)+44>>2]|0)+40>>2]|0,t[l>>2]|0,t[v>>2]|0,0)|0;FR(t[h>>2]|0)}t[h>>2]=fO(t[w>>2]|0,t[l>>2]|0,t[v>>2]|0)|0;do if(!(t[h>>2]|0)){t[h>>2]=gAi[t[135744>>2]&511](56)|0;if(!(t[h>>2]|0)){gR(t[o>>2]|0,79472);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}_=(t[h>>2]|0)+0|0;f=_+56|0;do{t[_>>2]=0;_=_+4|0}while((_|0)<(f|0));t[(t[h>>2]|0)+4>>2]=15;_=Yl(t[l>>2]|0)|0;t[(t[h>>2]|0)+8>>2]=_;if(!(t[(t[h>>2]|0)+8>>2]|0)){gR(t[o>>2]|0,79472);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);pAi[t[135736>>2]&511](t[h>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}else{t[(t[h>>2]|0)+48>>2]=t[v>>2];if(!(QF(t[w>>2]|0,t[l>>2]|0,t[v>>2]|0,t[h>>2]|0)|0)){t[(t[h>>2]|0)+44>>2]=t[d>>2];break}ER(t[o>>2]|0,t[c>>2]|0,509,79992,t[l>>2]|0,0,0);FR(t[h>>2]|0);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}}else{if(!(t[(t[h>>2]|0)+36>>2]|0)){if(!(t[v>>2]|0))break;pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0;break}ER(t[o>>2]|0,t[c>>2]|0,509,79992,t[l>>2]|0,0,0);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}while(0);t[(t[h>>2]|0)+36>>2]=t[b>>2];do if(t[o>>2]|0){if((t[(t[o>>2]|0)+28>>2]|0)!=-1412623820?(t[(t[o>>2]|0)+28>>2]|0)!=-1412623819:0){E=63;break}t[(t[h>>2]|0)+40>>2]=t[k>>2];if(t[k>>2]|0)t[(t[k>>2]|0)+20>>2]=1}else E=63;while(0);if((E|0)==63){E=SM(t[(t[c>>2]|0)+32>>2]|0,t[k>>2]|0)|0;t[(t[h>>2]|0)+40>>2]=E}t[(t[h>>2]|0)+20>>2]=t[c>>2];t[(t[h>>2]|0)+32>>2]=t[(t[c>>2]|0)+32>>2];E=t[h>>2]|0;k=(t[c>>2]|0)+16|0;if(!(t[(t[c>>2]|0)+16>>2]|0)){t[k>>2]=E;t[(t[c>>2]|0)+12>>2]=E}else{t[(t[k>>2]|0)+24>>2]=E;t[(t[h>>2]|0)+28>>2]=t[(t[c>>2]|0)+16>>2];t[(t[c>>2]|0)+16>>2]=t[h>>2]}if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);t[a>>2]=t[h>>2];p=t[a>>2]|0;s=u;return p|0}function OM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,242);s=i;return}function AM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=sO(t[r>>2]|0,243)|0;s=i;return e|0}function MM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}i=t[(t[f>>2]|0)+36>>2]|0;if((i|0)==3){NF(t[n>>2]|0,80024);if(t[(t[f>>2]|0)+48>>2]|0){RF(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0);NF(t[n>>2]|0,79648)}RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);NF(t[n>>2]|0,80064);AR(t[n>>2]|0,t[(t[f>>2]|0)+40>>2]|0,1);NF(t[n>>2]|0,80072);s=r;return}else if((i|0)==4){NF(t[n>>2]|0,80024);if(t[(t[f>>2]|0)+48>>2]|0){RF(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0);NF(t[n>>2]|0,79648)}RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);NF(t[n>>2]|0,80064);AR(t[n>>2]|0,t[(t[f>>2]|0)+40>>2]|0,1);NF(t[n>>2]|0,80072);s=r;return}else if((i|0)==1){NF(t[n>>2]|0,80024);if(t[(t[f>>2]|0)+48>>2]|0){RF(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0);NF(t[n>>2]|0,79648)}RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);NF(t[n>>2]|0,80040);s=r;return}else if((i|0)==2){NF(t[n>>2]|0,80024);if(t[(t[f>>2]|0)+48>>2]|0){RF(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0);NF(t[n>>2]|0,79648)}RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);NF(t[n>>2]|0,80056);s=r;return}else{yR(0,1,80080,0);s=r;return}}function RM(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[f>>2]|0)){gR(0,79472);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;if(t[n>>2]|0){e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+4>>2]=e}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function NM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)NM(t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function TM(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=RM(t[(t[n>>2]|0)+4>>2]|0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if(t[t[n>>2]>>2]|0){e=TM(t[t[n>>2]>>2]|0)|0;t[t[f>>2]>>2]=e}else t[t[f>>2]>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function LM(e,i,r,n,f,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;l=s;s=s+64|0;b=l+56|0;k=l+52|0;h=l+48|0;w=l+44|0;d=l+40|0;v=l+36|0;m=l+32|0;_=l+28|0;p=l+24|0;E=l+20|0;S=l+16|0;g=l+12|0;y=l+8|0;F=l+4|0;O=l;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=n;t[v>>2]=f;t[m>>2]=u;t[_>>2]=a;t[p>>2]=o;t[E>>2]=c;t[F>>2]=0;if(!(t[h>>2]|0)){NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}if(!(t[d>>2]|0)){NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}if(!(t[w>>2]|0)){NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}if(t[(t[h>>2]|0)+32>>2]|0)t[F>>2]=t[(t[(t[h>>2]|0)+32>>2]|0)+80>>2];if(((t[m>>2]|0)+-1|0)>>>0>=10){yR(t[k>>2]|0,1,80136,0);NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}if(((t[p>>2]|0)!=0?(MR(t[(t[h>>2]|0)+32>>2]|0,t[m>>2]|0,t[p>>2]|0)|0)==0:0)?(ER(t[k>>2]|0,t[h>>2]|0,500,80192,t[w>>2]|0,t[d>>2]|0,t[p>>2]|0),t[p>>2]=0,(t[k>>2]|0)!=0):0)t[(t[k>>2]|0)+36>>2]=0;if(((((t[(t[h>>2]|0)+32>>2]|0)!=0?(t[(t[(t[h>>2]|0)+32>>2]|0)+48>>2]|0)==(t[h>>2]|0):0)?(t[(t[(t[h>>2]|0)+32>>2]|0)+44>>2]|0)!=0:0)?(t[(t[(t[(t[h>>2]|0)+32>>2]|0)+44>>2]|0)+44>>2]|0)!=0:0)?(t[S>>2]=nO(t[(t[(t[(t[h>>2]|0)+32>>2]|0)+44>>2]|0)+44>>2]|0,t[d>>2]|0,t[v>>2]|0,t[w>>2]|0)|0,(t[S>>2]|0)!=0):0){NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}t[g>>2]=t[(t[h>>2]|0)+44>>2];if(!(t[g>>2]|0)){t[g>>2]=KF(0,t[F>>2]|0)|0;t[(t[h>>2]|0)+44>>2]=t[g>>2]}if(!(t[g>>2]|0)){gR(t[k>>2]|0,80240);NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}t[S>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[S>>2]|0)){gR(t[k>>2]|0,79472);NM(t[E>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}c=(t[S>>2]|0)+0|0;o=c+64|0;do{t[c>>2]=0;c=c+4|0}while((c|0)<(o|0));t[(t[S>>2]|0)+4>>2]=16;t[(t[S>>2]|0)+40>>2]=t[m>>2];t[(t[S>>2]|0)+32>>2]=t[(t[h>>2]|0)+32>>2];if(t[F>>2]|0){c=kz(t[F>>2]|0,t[d>>2]|0,-1)|0;t[(t[S>>2]|0)+8>>2]=c;c=kz(t[F>>2]|0,t[v>>2]|0,-1)|0;t[(t[S>>2]|0)+56>>2]=c;c=kz(t[F>>2]|0,t[w>>2]|0,-1)|0;t[(t[S>>2]|0)+60>>2]=c}else{c=Yl(t[d>>2]|0)|0;t[(t[S>>2]|0)+8>>2]=c;c=Yl(t[v>>2]|0)|0;t[(t[S>>2]|0)+56>>2]=c;c=Yl(t[w>>2]|0)|0;t[(t[S>>2]|0)+60>>2]=c}t[(t[S>>2]|0)+44>>2]=t[_>>2];t[(t[S>>2]|0)+52>>2]=t[E>>2];do if(t[p>>2]|0)if(t[F>>2]|0){E=kz(t[F>>2]|0,t[p>>2]|0,-1)|0;t[(t[S>>2]|0)+48>>2]=E;break}else{E=Yl(t[p>>2]|0)|0;t[(t[S>>2]|0)+48>>2]=E;break}while(0);if((JF(t[g>>2]|0,t[(t[S>>2]|0)+8>>2]|0,t[(t[S>>2]|0)+56>>2]|0,t[(t[S>>2]|0)+60>>2]|0,t[S>>2]|0)|0)<0){RR(t[k>>2]|0,t[h>>2]|0,501,80288,t[d>>2]|0,t[w>>2]|0,0);NR(t[S>>2]|0);t[b>>2]=0;A=t[b>>2]|0;s=l;return A|0}t[y>>2]=TR(t[h>>2]|0,t[w>>2]|0,1)|0;e:do if(t[y>>2]|0){if(((t[m>>2]|0)==2?(LR(0,t[y>>2]|0,1)|0)!=0:0)?(ER(t[k>>2]|0,t[h>>2]|0,520,80336,t[w>>2]|0,t[d>>2]|0,0),(t[k>>2]|0)!=0):0)t[(t[k>>2]|0)+36>>2]=0;do if(!(Xl(t[(t[S>>2]|0)+8>>2]|0,80392)|0)){if((t[(t[S>>2]|0)+56>>2]|0)!=0?(Xl(t[(t[S>>2]|0)+56>>2]|0,80392)|0)!=0:0)break;t[O>>2]=t[(t[y>>2]|0)+44>>2];while(1){if(!(t[O>>2]|0))break;if(!(Xl(t[(t[O>>2]|0)+8>>2]|0,80392)|0)){if(!(t[(t[S>>2]|0)+56>>2]|0))break;if(!(Xl(t[(t[S>>2]|0)+56>>2]|0,80392)|0))break}if(!(t[(t[O>>2]|0)+36>>2]|0))break;
	t[O>>2]=t[(t[O>>2]|0)+36>>2]}if(t[O>>2]|0){t[(t[S>>2]|0)+36>>2]=t[(t[O>>2]|0)+36>>2];t[(t[O>>2]|0)+36>>2]=t[S>>2];break e}else{t[(t[S>>2]|0)+36>>2]=t[(t[y>>2]|0)+44>>2];t[(t[y>>2]|0)+44>>2]=t[S>>2];break e}}while(0);t[(t[S>>2]|0)+36>>2]=t[(t[y>>2]|0)+44>>2];t[(t[y>>2]|0)+44>>2]=t[S>>2]}while(0);t[(t[S>>2]|0)+20>>2]=t[h>>2];y=t[S>>2]|0;O=(t[h>>2]|0)+16|0;if(!(t[(t[h>>2]|0)+16>>2]|0)){t[O>>2]=y;t[(t[h>>2]|0)+12>>2]=y}else{t[(t[O>>2]|0)+24>>2]=y;t[(t[S>>2]|0)+28>>2]=t[(t[h>>2]|0)+16>>2];t[(t[h>>2]|0)+16>>2]=t[S>>2]}t[b>>2]=t[S>>2];A=t[b>>2]|0;s=l;return A|0}function DM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,244);s=i;return}function CM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=sO(t[r>>2]|0,245)|0;s=i;return e|0}function PM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}NF(t[n>>2]|0,80400);RF(t[n>>2]|0,t[(t[f>>2]|0)+60>>2]|0);NF(t[n>>2]|0,80064);if(t[(t[f>>2]|0)+56>>2]|0){RF(t[n>>2]|0,t[(t[f>>2]|0)+56>>2]|0);NF(t[n>>2]|0,79648)}RF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0);do switch(t[(t[f>>2]|0)+40>>2]|0){case 9:{NF(t[n>>2]|0,80504);CR(t[n>>2]|0,t[(t[f>>2]|0)+52>>2]|0);break}case 5:{NF(t[n>>2]|0,80448);break}case 6:{NF(t[n>>2]|0,80456);break}case 7:{NF(t[n>>2]|0,80472);break}case 2:{NF(t[n>>2]|0,80424);break}case 10:{NF(t[n>>2]|0,80512);CR(t[n>>2]|0,t[(t[f>>2]|0)+52>>2]|0);break}case 4:{NF(t[n>>2]|0,80440);break}case 8:{NF(t[n>>2]|0,80488);break}case 1:{NF(t[n>>2]|0,80416);break}case 3:{NF(t[n>>2]|0,80432);break}default:yR(0,1,80136,0)}while(0);i=t[(t[f>>2]|0)+44>>2]|0;if((i|0)==2)NF(t[n>>2]|0,80528);else if((i|0)==3)NF(t[n>>2]|0,80544);else if((i|0)==4)NF(t[n>>2]|0,80560);else if((i|0)!=1)yR(0,1,80568,0);if(t[(t[f>>2]|0)+48>>2]|0){NF(t[n>>2]|0,80064);TF(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0)}NF(t[n>>2]|0,80072);s=r;return}function BM(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;u=s;s=s+48|0;a=u+32|0;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;w=u+4|0;d=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(!(t[c>>2]|0)){t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}if(!(t[l>>2]|0)){t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}if((t[b>>2]|0)==0&(t[k>>2]|0)==0){t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}t[w>>2]=t[(t[c>>2]|0)+36>>2];if(!(t[w>>2]|0)){t[d>>2]=0;if(t[(t[c>>2]|0)+32>>2]|0)t[d>>2]=t[(t[(t[c>>2]|0)+32>>2]|0)+80>>2];f=KF(0,t[d>>2]|0)|0;t[w>>2]=f;t[(t[c>>2]|0)+36>>2]=f}if(!(t[w>>2]|0)){gR(t[o>>2]|0,80624);t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}t[h>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[h>>2]|0)){gR(t[o>>2]|0,79472);t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}o=t[h>>2]|0;t[o+0>>2]=0;t[o+4>>2]=0;t[o+8>>2]=0;o=Yl(t[l>>2]|0)|0;t[t[h>>2]>>2]=o;if(t[k>>2]|0){o=Yl(t[k>>2]|0)|0;t[(t[h>>2]|0)+8>>2]=o}if(t[b>>2]|0){o=Yl(t[b>>2]|0)|0;t[(t[h>>2]|0)+4>>2]=o}if(ZF(t[w>>2]|0,t[l>>2]|0,t[h>>2]|0)|0){yR(0,526,80672,t[l>>2]|0);PR(t[h>>2]|0);t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}else{t[a>>2]=t[h>>2];v=t[a>>2]|0;s=u;return v|0}return 0}function IM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,246);s=i;return}function HM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=sO(t[r>>2]|0,247)|0;s=i;return e|0}function xM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}NF(t[n>>2]|0,80712);RF(t[n>>2]|0,t[t[f>>2]>>2]|0);i=t[n>>2]|0;if(t[(t[f>>2]|0)+4>>2]|0){NF(i,80728);TF(t[n>>2]|0,t[(t[f>>2]|0)+4>>2]|0);if(t[(t[f>>2]|0)+8>>2]|0){NF(t[n>>2]|0,80064);TF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0)}}else{NF(i,80744);TF(t[n>>2]|0,t[(t[f>>2]|0)+8>>2]|0)}NF(t[n>>2]|0,80760);s=r;return}function UM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}aO(t[f>>2]|0,248,t[n>>2]|0);s=r;return}function zM(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[o>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(!(t[c>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(!(t[l>>2]|0)){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}t[k>>2]=t[(t[o>>2]|0)+64>>2];if(!(t[k>>2]|0)){n=KF(0,t[(t[o>>2]|0)+80>>2]|0)|0;t[k>>2]=n;t[(t[o>>2]|0)+64>>2]=n}if(!(t[k>>2]|0)){gR(t[a>>2]|0,80768);t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}t[b>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[b>>2]|0)){gR(t[a>>2]|0,79472);t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}n=Yl(t[c>>2]|0)|0;t[(t[b>>2]|0)+4>>2]=n;t[(t[b>>2]|0)+20>>2]=t[o>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+44>>2]|0)!=0:0){if(t[(t[o>>2]|0)+80>>2]|0){n=kz(t[(t[o>>2]|0)+80>>2]|0,t[(t[l>>2]|0)+8>>2]|0,-1)|0;t[(t[b>>2]|0)+12>>2]=n}else{n=Yl(t[(t[l>>2]|0)+8>>2]|0)|0;t[(t[b>>2]|0)+12>>2]=n}t[(t[b>>2]|0)+8>>2]=0}else{t[(t[b>>2]|0)+8>>2]=t[l>>2];t[(t[b>>2]|0)+12>>2]=0}n=Qy(t[(t[l>>2]|0)+20>>2]|0)|0;t[(t[b>>2]|0)+16>>2]=n;if((ZF(t[k>>2]|0,t[c>>2]|0,t[b>>2]|0)|0)<0){ER(t[a>>2]|0,t[(t[l>>2]|0)+20>>2]|0,513,80808,t[c>>2]|0,0,0);HR(t[b>>2]|0);t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}if(t[l>>2]|0)t[(t[l>>2]|0)+40>>2]=2;t[u>>2]=t[b>>2];h=t[u>>2]|0;s=f;return h|0}function jM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,249);s=i;return}function VM(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+128|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+78|0;b=n+28|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+8>>2]|0)!=0:0){if((((t[(t[o>>2]|0)+36>>2]|0)!=0?(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)?(MY(t[(t[o>>2]|0)+8>>2]|0,80832)|0)==0:0)?(MY(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0,80840)|0)==0:0){t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}if(!(t[u>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if(((t[(t[u>>2]|0)+44>>2]|0)==0?(t[(t[u>>2]|0)+48>>2]|0)==0:0)?(t[(t[u>>2]|0)+4>>2]|0)!=13:0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[u>>2]|0)+4>>2]|0)==13){do if(!(Xl(80832,t[(t[o>>2]|0)+8>>2]|0)|0)){if(Xl(80848,t[(t[o>>2]|0)+8>>2]|0)|0){if(!(t[a>>2]|0))break;if(Xl(t[(t[a>>2]|0)+8>>2]|0,80856)|0)break}t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}while(0);t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}if(!(t[a>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[c>>2]=0;if((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)d=Ug(t[(t[a>>2]|0)+8>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0,l,50)|0;else d=t[(t[a>>2]|0)+8>>2]|0;t[k>>2]=d;if((t[(t[o>>2]|0)+36>>2]|0)!=0?(t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)v=Ug(t[(t[o>>2]|0)+8>>2]|0,t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0,b,50)|0;else v=t[(t[o>>2]|0)+8>>2]|0;t[h>>2]=v;if(((t[k>>2]|0)!=0&(t[h>>2]|0)!=0?(t[c>>2]=qM(t[(t[u>>2]|0)+44>>2]|0,t[k>>2]|0,t[h>>2]|0)|0,(t[c>>2]|0)==0):0)?(t[(t[u>>2]|0)+48>>2]|0)!=0:0)t[c>>2]=qM(t[(t[u>>2]|0)+48>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;if((t[h>>2]|0)!=(b|0)?(t[h>>2]|0)!=(t[(t[o>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[h>>2]|0);if((t[k>>2]|0)!=(l|0)?(t[k>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[k>>2]|0);if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+40>>2]|0)==2:0){t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}function qM(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;t[k>>2]=0;if(!(t[u>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(!(t[(t[u>>2]|0)+44>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[c>>2]=t[(t[u>>2]|0)+44>>2];if(!(t[c>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[b>>2]=zg(t[o>>2]|0,k)|0;u=t[c>>2]|0;if(t[b>>2]|0){t[l>>2]=nO(u,t[b>>2]|0,t[k>>2]|0,t[a>>2]|0)|0;if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0)}else t[l>>2]=nO(u,t[o>>2]|0,0,t[a>>2]|0)|0;t[f>>2]=t[l>>2];h=t[f>>2]|0;s=n;return h|0}function YM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}if(!(t[u>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=t[(t[f>>2]|0)+64>>2];if(!(t[a>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[c>>2]=sy(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,1)|0;if(!(t[c>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=rO(t[a>>2]|0,t[c>>2]|0)|0;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+8>>2]|0)==(t[u>>2]|0):0){kO(t[a>>2]|0,t[c>>2]|0,249)|0;pAi[t[135736>>2]&511](t[c>>2]|0);t[(t[u>>2]|0)+40>>2]=0;t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}pAi[t[135736>>2]&511](t[c>>2]|0);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}function GM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){if(!(t[u>>2]|0)){t[n>>2]=0;break}t[a>>2]=t[(t[f>>2]|0)+64>>2];if(!(t[a>>2]|0)){t[n>>2]=0;break}t[o>>2]=rO(t[a>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=0;break}if(!(t[(t[o>>2]|0)+8>>2]|0)){t[n>>2]=t[f>>2];break}else{t[n>>2]=t[(t[o>>2]|0)+8>>2];break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function WM(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[o>>2]|0)){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if(!(t[c>>2]|0)){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if(!(t[l>>2]|0)){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}t[k>>2]=t[(t[o>>2]|0)+68>>2];if(!(t[k>>2]|0)){n=KF(0,t[(t[o>>2]|0)+80>>2]|0)|0;t[k>>2]=n;t[(t[o>>2]|0)+68>>2]=n}if(!(t[k>>2]|0)){gR(t[a>>2]|0,80864);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}t[b>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[b>>2]|0)){gR(t[a>>2]|0,79472);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}n=Yl(t[c>>2]|0)|0;t[(t[b>>2]|0)+4>>2]=n;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+44>>2]|0)!=0:0){a=Yl(t[(t[l>>2]|0)+8>>2]|0)|0;t[(t[b>>2]|0)+12>>2]=a;t[(t[b>>2]|0)+8>>2]=0}else{t[(t[b>>2]|0)+12>>2]=0;t[(t[b>>2]|0)+8>>2]=t[l>>2]}a=Qy(t[(t[l>>2]|0)+20>>2]|0)|0;t[(t[b>>2]|0)+16>>2]=a;a=rO(t[k>>2]|0,t[c>>2]|0)|0;t[h>>2]=a;do if(!a){l=Eq(250,251)|0;t[h>>2]=l;if(!l){yR(0,1,80904,0);break}if((ZF(t[k>>2]|0,t[c>>2]|0,t[h>>2]|0)|0)<0){Fq(t[h>>2]|0);yR(0,1,80952,0)}else d=22}else d=22;while(0);do if((d|0)==22){if(yq(t[h>>2]|0,t[b>>2]|0)|0){yR(0,1,80952,0);break}t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}while(0);if(t[b>>2]|0){if(t[(t[b>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[b>>2]|0)+4>>2]|0);if(t[(t[b>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[b>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0)}t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function KM(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,252);s=i;return}function XM(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[o>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[u>>2]|0)==0?(t[u>>2]=t[(t[o>>2]|0)+32>>2],(t[u>>2]|0)==0):0){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+44>>2]|0)==0?(t[(t[u>>2]|0)+48>>2]|0)==0:0){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if((t[(t[u>>2]|0)+4>>2]|0)==13){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if(!(t[a>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=qM(t[(t[u>>2]|0)+44>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0;if((t[c>>2]|0)==0?(t[(t[u>>2]|0)+48>>2]|0)!=0:0)t[c>>2]=qM(t[(t[u>>2]|0)+48>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0;do if(t[c>>2]|0){if((t[(t[c>>2]|0)+40>>2]|0)!=3?(t[(t[c>>2]|0)+40>>2]|0)!=4:0)break;t[f>>2]=1;l=t[f>>2]|0;s=n;return l|0}while(0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}function ZM(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;t[l>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if(!(t[(t[f>>2]|0)+40>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[a>>2]=t[(t[f>>2]|0)+40>>2];t[c>>2]=zg(t[u>>2]|0,l)|0;if(t[c>>2]|0)t[u>>2]=t[c>>2];t[o>>2]=fO(t[a>>2]|0,t[u>>2]|0,t[l>>2]|0)|0;if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);t[n>>2]=t[o>>2];b=t[n>>2]|0;s=r;return b|0}function JM(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}if(!(t[(t[u>>2]|0)+40>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[c>>2]=t[(t[u>>2]|0)+40>>2];t[f>>2]=fO(t[c>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function QM(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if(!(t[(t[a>>2]|0)+44>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}else{t[b>>2]=t[(t[a>>2]|0)+44>>2];t[u>>2]=nO(t[b>>2]|0,t[c>>2]|0,t[l>>2]|0,t[o>>2]|0)|0;k=t[u>>2]|0;s=f;return k|0}return 0}function $M(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0)if(!(t[(t[f>>2]|0)+36>>2]|0)){t[n>>2]=0;break}else{t[a>>2]=t[(t[f>>2]|0)+36>>2];t[n>>2]=rO(t[a>>2]|0,t[u>>2]|0)|0;break}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function eR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[a>>2]|0)!=0?!((t[o>>2]|0)==0?1:(t[(t[a>>2]|0)+44>>2]|0)==0):0){t[c>>2]=$M(t[(t[a>>2]|0)+44>>2]|0,t[o>>2]|0)|0;if((t[c>>2]|0)==0?(t[(t[a>>2]|0)+48>>2]|0)!=0:0)t[c>>2]=$M(t[(t[a>>2]|0)+48>>2]|0,t[o>>2]|0)|0;if((t[c>>2]|0)==0&(t[u>>2]|0)!=0){ER(t[u>>2]|0,t[a>>2]|0,537,81e3,t[o>>2]|0,0,0);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=1;l=t[f>>2]|0;s=n;return l|0}}t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}function iR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+44>>2]|0)!=0:0){t[a>>2]=ZM(t[(t[f>>2]|0)+44>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)==0?(t[(t[f>>2]|0)+48>>2]|0)!=0:0)t[a>>2]=ZM(t[(t[f>>2]|0)+48>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=-1;break}switch(t[(t[a>>2]|0)+36>>2]|0){case 4:{t[n>>2]=0;break e;break}case 0:{t[n>>2]=-1;break e;break}case 3:case 2:case 1:{t[n>>2]=1;break e;break}default:{t[n>>2]=1;break e}}}else o=3;while(0);if((o|0)==3)t[n>>2]=-1;s=r;return t[n>>2]|0}function rR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0;n=s;s=s+16|0;f=n;t[n+12>>2]=e;t[n+8>>2]=i;t[n+4>>2]=r;t[f>>2]=1;s=n;return t[f>>2]|0}function nR(e,i,r,f,a){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;o=s;s=s+112|0;c=o+44|0;l=o+40|0;b=o+36|0;k=o+32|0;h=o+28|0;w=o+24|0;d=o+20|0;v=o+16|0;m=o+12|0;_=o+8|0;p=o+4|0;E=o+48|0;S=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=a;t[_>>2]=0;t[p>>2]=0;if(!(t[b>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}if(!(t[k>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}if(!(t[h>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}if(!(t[w>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}if((t[(t[k>>2]|0)+36>>2]|0)!=0?(t[(t[(t[k>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[S>>2]=Ug(t[(t[k>>2]|0)+8>>2]|0,t[(t[(t[k>>2]|0)+36>>2]|0)+12>>2]|0,E,50)|0;if(!(t[S>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}t[_>>2]=qM(t[(t[b>>2]|0)+44>>2]|0,t[S>>2]|0,t[h>>2]|0)|0;if(((t[_>>2]|0)==0?(t[(t[b>>2]|0)+48>>2]|0)!=0:0)?(t[_>>2]=qM(t[(t[b>>2]|0)+48>>2]|0,t[S>>2]|0,t[h>>2]|0)|0,(t[_>>2]|0)!=0):0)t[p>>2]=1;if((t[S>>2]|0)!=(E|0)?(t[S>>2]|0)!=(t[(t[k>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[S>>2]|0)}if((t[_>>2]|0)==0?(t[(t[b>>2]|0)+44>>2]|0)!=0:0)t[_>>2]=qM(t[(t[b>>2]|0)+44>>2]|0,t[(t[k>>2]|0)+8>>2]|0,t[h>>2]|0)|0;if(((t[_>>2]|0)==0?(t[(t[b>>2]|0)+48>>2]|0)!=0:0)?(t[_>>2]=qM(t[(t[b>>2]|0)+48>>2]|0,t[(t[k>>2]|0)+8>>2]|0,t[h>>2]|0)|0,(t[_>>2]|0)!=0):0)t[p>>2]=1;if(!(t[_>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}if((t[(t[_>>2]|0)+40>>2]|0)==1){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}t[d>>2]=Yl(t[w>>2]|0)|0;if(!(t[d>>2]|0)){t[c>>2]=0;g=t[c>>2]|0;s=o;return g|0}t[m>>2]=t[w>>2];t[v>>2]=t[d>>2];while(1){if((u[t[m>>2]>>0]|0|0)!=32)break;t[m>>2]=(t[m>>2]|0)+1}while(1){if(!(u[t[m>>2]>>0]|0))break;if((u[t[m>>2]>>0]|0|0)!=32){_=t[m>>2]|0;t[m>>2]=_+1;S=n[_>>0]|0;_=t[v>>2]|0;t[v>>2]=_+1;n[_>>0]=S;continue}while(1){y=t[m>>2]|0;if((u[t[m>>2]>>0]|0|0)!=32)break;t[m>>2]=y+1}if(!(u[y>>0]|0))continue;S=t[v>>2]|0;t[v>>2]=S+1;n[S>>0]=32}n[t[v>>2]>>0]=0;if(((t[p>>2]|0)==1?(t[(t[b>>2]|0)+40>>2]|0)!=0:0)?(Xl(t[w>>2]|0,t[d>>2]|0)|0)==0:0){ER(t[l>>2]|0,t[k>>2]|0,530,81032,t[h>>2]|0,t[(t[k>>2]|0)+8>>2]|0,0);t[(t[l>>2]|0)+36>>2]=0}t[c>>2]=t[d>>2];g=t[c>>2]|0;s=o;return g|0}function fR(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+96|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a+40|0;_=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[v>>2]=0;if(!(t[c>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}if(!(t[l>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}if(!(t[b>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}if(!(t[k>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}if((t[(t[l>>2]|0)+36>>2]|0)!=0?(t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[_>>2]=Ug(t[(t[l>>2]|0)+8>>2]|0,t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0,m,50)|0;if(!(t[_>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}if((t[_>>2]|0)!=(m|0)?(t[_>>2]|0)!=(t[(t[l>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[_>>2]|0)}t[v>>2]=qM(t[(t[c>>2]|0)+44>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[b>>2]|0)|0;if((t[v>>2]|0)==0?(t[(t[c>>2]|0)+48>>2]|0)!=0:0)t[v>>2]=qM(t[(t[c>>2]|0)+48>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[b>>2]|0)|0;if(!(t[v>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}if((t[(t[v>>2]|0)+40>>2]|0)==1){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}t[h>>2]=Yl(t[k>>2]|0)|0;if(!(t[h>>2]|0)){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}t[d>>2]=t[k>>2];t[w>>2]=t[h>>2];while(1){if((u[t[d>>2]>>0]|0|0)!=32)break;t[d>>2]=(t[d>>2]|0)+1}while(1){if(!(u[t[d>>2]>>0]|0))break;if((u[t[d>>2]>>0]|0|0)!=32){k=t[d>>2]|0;t[d>>2]=k+1;v=n[k>>0]|0;k=t[w>>2]|0;t[w>>2]=k+1;n[k>>0]=v;continue}while(1){E=t[d>>2]|0;if((u[t[d>>2]>>0]|0|0)!=32)break;t[d>>2]=E+1}if(!(u[E>>0]|0))continue;v=t[w>>2]|0;t[w>>2]=v+1;n[v>>0]=32}n[t[w>>2]>>0]=0;t[o>>2]=t[h>>2];p=t[o>>2]|0;s=a;return p|0}function tR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=1;if(!(t[a>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if((t[(t[a>>2]|0)+44>>2]|0)==0?(t[(t[a>>2]|0)+48>>2]|0)==0:0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if(!(t[o>>2]|0)){t[f>>2]=1;v=t[f>>2]|0;s=n;return v|0}if(t[(t[o>>2]|0)+48>>2]|0){t[l>>2]=MR(t[a>>2]|0,t[(t[o>>2]|0)+40>>2]|0,t[(t[o>>2]|0)+48>>2]|0)|0;if(!(t[l>>2]|0))ER(t[u>>2]|0,t[o>>2]|0,500,81120,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+60>>2]|0,0);t[c>>2]=t[c>>2]&t[l>>2]}if(((t[(t[o>>2]|0)+40>>2]|0)==2?(t[(t[o>>2]|0)+44>>2]|0)!=3:0)?(t[(t[o>>2]|0)+44>>2]|0)!=2:0){ER(t[u>>2]|0,t[o>>2]|0,512,81184,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+60>>2]|0,0);t[c>>2]=0}do if((t[(t[o>>2]|0)+40>>2]|0)==2){t[k>>2]=ZM(t[(t[a>>2]|0)+44>>2]|0,t[(t[o>>2]|0)+60>>2]|0)|0;if(!(t[k>>2]|0)){t[b>>2]=0;if(t[(t[a>>2]|0)+44>>2]|0){t[h>>2]=t[(t[(t[a>>2]|0)+44>>2]|0)+44>>2];cO(t[h>>2]|0,0,0,t[(t[o>>2]|0)+60>>2]|0,253,b)}}else t[b>>2]=LR(0,t[k>>2]|0,0)|0;if((t[b>>2]|0)>1){WR(t[u>>2]|0,t[o>>2]|0,514,81256,t[(t[o>>2]|0)+60>>2]|0,t[b>>2]|0,t[(t[o>>2]|0)+8>>2]|0);break}if(t[(t[a>>2]|0)+48>>2]|0){t[w>>2]=0;t[k>>2]=ZM(t[(t[a>>2]|0)+48>>2]|0,t[(t[o>>2]|0)+60>>2]|0)|0;if(t[k>>2]|0)t[w>>2]=LR(0,t[k>>2]|0,0)|0;if((t[w>>2]|0)>1){WR(t[u>>2]|0,t[o>>2]|0,514,81328,t[(t[o>>2]|0)+60>>2]|0,t[w>>2]|0,t[(t[o>>2]|0)+8>>2]|0);break}if(((t[w>>2]|0)+(t[b>>2]|0)|0)>1)ER(t[u>>2]|0,t[o>>2]|0,514,81400,t[(t[o>>2]|0)+60>>2]|0,t[(t[o>>2]|0)+8>>2]|0,0)}}while(0);if((t[(t[o>>2]|0)+48>>2]|0)!=0?(t[(t[o>>2]|0)+52>>2]|0)!=0:0){t[d>>2]=t[(t[o>>2]|0)+52>>2];while(1){if(!(t[d>>2]|0))break;if(Xl(t[(t[d>>2]|0)+4>>2]|0,t[(t[o>>2]|0)+48>>2]|0)|0)break;t[d>>2]=t[t[d>>2]>>2]}if(!(t[d>>2]|0)){ER(t[u>>2]|0,t[o>>2]|0,502,81480,t[(t[o>>2]|0)+48>>2]|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+60>>2]|0);t[c>>2]=0}}t[f>>2]=t[c>>2];v=t[f>>2]|0;s=n;return v|0}function uR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=1;if(!(t[a>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[a>>2]|0)+44>>2]|0)==0?(t[(t[a>>2]|0)+48>>2]|0)==0:0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if(!(t[o>>2]|0)){t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}e:do if((t[(t[o>>2]|0)+36>>2]|0)==3){t[b>>2]=t[(t[o>>2]|0)+40>>2];while(1){if(!(t[b>>2]|0))break e;if((t[t[b>>2]>>2]|0)!=4)break e;if(!(t[(t[b>>2]|0)+12>>2]|0))break e;i:do if((t[t[(t[b>>2]|0)+12>>2]>>2]|0)==2){t[h>>2]=t[(t[(t[b>>2]|0)+12>>2]|0)+8>>2];t[k>>2]=t[(t[b>>2]|0)+16>>2];while(1){if(!(t[k>>2]|0))break i;d=t[k>>2]|0;if((t[t[k>>2]>>2]|0)==2)break;if(!(t[d+12>>2]|0))break i;if((t[t[(t[k>>2]|0)+12>>2]>>2]|0)!=2)break i;if((Xl(t[(t[(t[k>>2]|0)+12>>2]|0)+8>>2]|0,t[h>>2]|0)|0)!=0?(Xl(t[(t[(t[k>>2]|0)+12>>2]|0)+24>>2]|0,t[(t[(t[b>>2]|0)+12>>2]|0)+24>>2]|0)|0)!=0:0){r=t[u>>2]|0;i=t[o>>2]|0;e=t[(t[o>>2]|0)+8>>2]|0;if(!(t[(t[(t[b>>2]|0)+12>>2]|0)+24>>2]|0))ER(r,i,503,81672,e,t[h>>2]|0,0);else ER(r,i,503,81728,e,t[(t[(t[b>>2]|0)+12>>2]|0)+24>>2]|0,t[h>>2]|0);t[c>>2]=0}t[k>>2]=t[(t[k>>2]|0)+16>>2]}if((Xl(t[d+8>>2]|0,t[h>>2]|0)|0)!=0?(Xl(t[(t[k>>2]|0)+24>>2]|0,t[(t[(t[b>>2]|0)+12>>2]|0)+24>>2]|0)|0)!=0:0){e=t[u>>2]|0;i=t[o>>2]|0;r=t[(t[o>>2]|0)+8>>2]|0;if(!(t[(t[(t[b>>2]|0)+12>>2]|0)+24>>2]|0))ER(e,i,503,81560,r,t[h>>2]|0,0);else ER(e,i,503,81616,r,t[(t[(t[b>>2]|0)+12>>2]|0)+24>>2]|0,t[h>>2]|0);t[c>>2]=0}}while(0);t[b>>2]=t[(t[b>>2]|0)+16>>2]}}while(0);t[l>>2]=ZM(t[(t[a>>2]|0)+44>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0;do if((t[l>>2]|0)!=0?(t[l>>2]|0)!=(t[o>>2]|0):0){if((t[(t[l>>2]|0)+48>>2]|0)!=(t[(t[o>>2]|0)+48>>2]|0)?(Xl(t[(t[l>>2]|0)+48>>2]|0,t[(t[o>>2]|0)+48>>2]|0)|0)==0:0)break;if(t[(t[l>>2]|0)+36>>2]|0){ER(t[u>>2]|0,t[o>>2]|0,509,79992,t[(t[o>>2]|0)+8>>2]|0,0,0);t[c>>2]=0}}while(0);t[l>>2]=ZM(t[(t[a>>2]|0)+48>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0;do if((t[l>>2]|0)!=0?(t[l>>2]|0)!=(t[o>>2]|0):0){if((t[(t[l>>2]|0)+48>>2]|0)!=(t[(t[o>>2]|0)+48>>2]|0)?(Xl(t[(t[l>>2]|0)+48>>2]|0,t[(t[o>>2]|0)+48>>2]|0)|0)==0:0)break;if(t[(t[l>>2]|0)+36>>2]|0){ER(t[u>>2]|0,t[o>>2]|0,509,79992,t[(t[o>>2]|0)+8>>2]|0,0,0);t[c>>2]=0}}while(0);t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}function aR(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;u=s;s=s+112|0;a=u+48|0;o=u+44|0;c=u+40|0;l=u+36|0;b=u+32|0;k=u+28|0;h=u+24|0;w=u+20|0;d=u+16|0;v=u+52|0;m=u+12|0;_=u+8|0;p=u+4|0;E=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;t[d>>2]=1;if(!(t[c>>2]|0)){t[a>>2]=0;S=t[a>>2]|0;s=u;return S|0}if((t[(t[c>>2]|0)+44>>2]|0)==0?(t[(t[c>>2]|0)+48>>2]|0)==0:0){t[a>>2]=0;S=t[a>>2]|0;s=u;return S|0}if((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+8>>2]|0)!=0:0){if((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+8>>2]|0)!=0:0){if((t[(t[l>>2]|0)+36>>2]|0)!=0?(t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[m>>2]=Ug(t[(t[l>>2]|0)+8>>2]|0,t[(t[(t[l>>2]|0)+36>>2]|0)+12>>2]|0,v,50)|0;if(!(t[m>>2]|0)){t[a>>2]=0;S=t[a>>2]|0;s=u;return S|0}f=t[(t[c>>2]|0)+44>>2]|0;n=t[m>>2]|0;r=t[(t[b>>2]|0)+8>>2]|0;if(t[(t[b>>2]|0)+36>>2]|0){t[h>>2]=QM(f,n,r,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;if((t[h>>2]|0)==0?(t[(t[c>>2]|0)+48>>2]|0)!=0:0)t[h>>2]=QM(t[(t[c>>2]|0)+48>>2]|0,t[m>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0}else{t[h>>2]=qM(f,n,r)|0;if((t[h>>2]|0)==0?(t[(t[c>>2]|0)+48>>2]|0)!=0:0)t[h>>2]=qM(t[(t[c>>2]|0)+48>>2]|0,t[m>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0}if((t[m>>2]|0)!=(v|0)?(t[m>>2]|0)!=(t[(t[l>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[m>>2]|0)}do if(!(t[h>>2]|0)){m=t[(t[c>>2]|0)+44>>2]|0;v=t[(t[l>>2]|0)+8>>2]|0;r=t[(t[b>>2]|0)+8>>2]|0;if(t[(t[b>>2]|0)+36>>2]|0){t[h>>2]=QM(m,v,r,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(t[h>>2]|0)break;if(!(t[(t[c>>2]|0)+48>>2]|0))break;t[h>>2]=QM(t[(t[c>>2]|0)+48>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;break}else{t[h>>2]=qM(m,v,r)|0;if(t[h>>2]|0)break;if(!(t[(t[c>>2]|0)+48>>2]|0))break;t[h>>2]=qM(t[(t[c>>2]|0)+48>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;break}}while(0);if(!(t[h>>2]|0)){ER(t[o>>2]|0,t[l>>2]|0,533,81784,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0,0);t[a>>2]=0;S=t[a>>2]|0;s=u;return S|0}t[(t[b>>2]|0)+40>>2]=t[(t[h>>2]|0)+40>>2];t[w>>2]=MR(t[c>>2]|0,t[(t[h>>2]|0)+40>>2]|0,t[k>>2]|0)|0;if(!(t[w>>2]|0)){ER(t[o>>2]|0,t[l>>2]|0,502,81832,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0,0);t[d>>2]=0}if((t[(t[h>>2]|0)+44>>2]|0)==4?(Xl(t[k>>2]|0,t[(t[h>>2]|0)+48>>2]|0)|0)==0:0){ER(t[o>>2]|0,t[l>>2]|0,500,81888,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+48>>2]|0);t[d>>2]=0}if((t[(t[h>>2]|0)+40>>2]|0)==2?(zM(t[o>>2]|0,t[c>>2]|0,t[k>>2]|0,t[b>>2]|0)|0)==0:0)t[d>>2]=0;if(!((t[(t[h>>2]|0)+40>>2]|0)!=3?(t[(t[h>>2]|0)+40>>2]|0)!=4:0))g=46;if((g|0)==46?(WM(t[o>>2]|0,t[c>>2]|0,t[k>>2]|0,t[b>>2]|0)|0)==0:0)t[d>>2]=0;if((t[(t[h>>2]|0)+40>>2]|0)==10){t[_>>2]=t[(t[h>>2]|0)+52>>2];t[p>>2]=$M(t[(t[c>>2]|0)+44>>2]|0,t[k>>2]|0)|0;if(!(t[p>>2]|0))t[p>>2]=$M(t[(t[c>>2]|0)+48>>2]|0,t[k>>2]|0)|0;if(!(t[p>>2]|0)){ER(t[o>>2]|0,t[l>>2]|0,537,81952,t[k>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0);t[d>>2]=0}while(1){if(!(t[_>>2]|0))break;if(Xl(t[(t[_>>2]|0)+4>>2]|0,t[k>>2]|0)|0)break;t[_>>2]=t[t[_>>2]>>2]}if(!(t[_>>2]|0)){ER(t[o>>2]|0,t[l>>2]|0,527,82016,t[k>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0);t[d>>2]=0}}if((t[(t[h>>2]|0)+40>>2]|0)==9){t[E>>2]=t[(t[h>>2]|0)+52>>2];while(1){if(!(t[E>>2]|0))break;if(Xl(t[(t[E>>2]|0)+4>>2]|0,t[k>>2]|0)|0)break;t[E>>2]=t[t[E>>2]>>2]}if(!(t[E>>2]|0)){ER(t[o>>2]|0,t[l>>2]|0,502,82096,t[k>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0);t[d>>2]=0}}if((t[(t[h>>2]|0)+44>>2]|0)==4?(Xl(t[(t[h>>2]|0)+48>>2]|0,t[k>>2]|0)|0)==0:0){ER(t[o>>2]|0,t[l>>2]|0,502,82168,t[(t[b>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+48>>2]|0);t[d>>2]=0}l=KR(t[o>>2]|0,t[c>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+40>>2]|0,t[k>>2]|0)|0;t[d>>2]=t[d>>2]&l;t[a>>2]=t[d>>2];S=t[a>>2]|0;s=u;return S|0}t[a>>2]=0;S=t[a>>2]|0;s=u;return S|0}t[a>>2]=0;S=t[a>>2]|0;s=u;return S|0}function oR(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;a=s;s=s+112|0;o=a+52|0;c=a+48|0;l=a+44|0;b=a+40|0;k=a+36|0;h=a+32|0;w=a+28|0;d=a+24|0;v=a+20|0;m=a+16|0;_=a+56|0;p=a+12|0;E=a+8|0;S=a+4|0;g=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;t[m>>2]=1;if(!(t[l>>2]|0)){t[o>>2]=0;y=t[o>>2]|0;s=a;return y|0}if((t[(t[l>>2]|0)+44>>2]|0)==0?(t[(t[l>>2]|0)+48>>2]|0)==0:0){t[o>>2]=0;y=t[o>>2]|0;s=a;return y|0}if((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+8>>2]|0)!=0:0){if((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+8>>2]|0)!=0:0){if(t[k>>2]|0){t[p>>2]=Ug(t[(t[b>>2]|0)+8>>2]|0,t[k>>2]|0,_,50)|0;if(!(t[p>>2]|0)){gR(t[c>>2]|0,82216);t[o>>2]=0;y=t[o>>2]|0;s=a;return y|0}k=t[(t[l>>2]|0)+44>>2]|0;u=t[p>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0){t[d>>2]=QM(k,u,t[(t[h>>2]|0)+12>>2]|0,80392)|0;if((t[d>>2]|0)==0?(t[(t[l>>2]|0)+48>>2]|0)!=0:0)t[d>>2]=QM(t[(t[l>>2]|0)+48>>2]|0,t[p>>2]|0,t[(t[h>>2]|0)+12>>2]|0,80392)|0}else{t[d>>2]=qM(k,u,80392)|0;if((t[d>>2]|0)==0?(t[(t[l>>2]|0)+48>>2]|0)!=0:0)t[d>>2]=qM(t[(t[l>>2]|0)+48>>2]|0,t[p>>2]|0,80392)|0}if((t[p>>2]|0)!=(_|0)?(t[p>>2]|0)!=(t[(t[b>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[p>>2]|0)}do if(!(t[d>>2]|0)){p=t[(t[l>>2]|0)+44>>2]|0;_=t[(t[b>>2]|0)+8>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0){t[d>>2]=QM(p,_,t[(t[h>>2]|0)+12>>2]|0,80392)|0;if(t[d>>2]|0)break;if(!(t[(t[l>>2]|0)+48>>2]|0))break;t[d>>2]=QM(t[(t[l>>2]|0)+48>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+12>>2]|0,80392)|0;break}else{t[d>>2]=qM(p,_,80392)|0;if(t[d>>2]|0)break;if(!(t[(t[l>>2]|0)+48>>2]|0))break;t[d>>2]=qM(t[(t[l>>2]|0)+48>>2]|0,t[(t[b>>2]|0)+8>>2]|0,80392)|0;break}}while(0);if(!(t[d>>2]|0)){_=t[c>>2]|0;p=t[b>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(_,p,533,82240,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0,0);else ER(_,p,533,82296,t[(t[b>>2]|0)+8>>2]|0,0,0);t[o>>2]=0;y=t[o>>2]|0;s=a;return y|0}t[v>>2]=MR(t[l>>2]|0,t[(t[d>>2]|0)+40>>2]|0,t[w>>2]|0)|0;if(!(t[v>>2]|0)){v=t[c>>2]|0;p=t[b>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(v,p,516,82352,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0,0);else ER(v,p,516,82416,t[(t[b>>2]|0)+8>>2]|0,0,0);t[m>>2]=0}if((t[(t[d>>2]|0)+44>>2]|0)==4?(Xl(t[w>>2]|0,t[(t[d>>2]|0)+48>>2]|0)|0)==0:0){p=t[c>>2]|0;v=t[b>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(p,v,500,82472,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+48>>2]|0);else ER(p,v,500,82544,t[(t[b>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+48>>2]|0,0);t[m>>2]=0}if((t[(t[d>>2]|0)+40>>2]|0)==2?(zM(t[c>>2]|0,t[l>>2]|0,t[w>>2]|0,t[h>>2]|0)|0)==0:0)t[m>>2]=0;if(!((t[(t[d>>2]|0)+40>>2]|0)!=3?(t[(t[d>>2]|0)+40>>2]|0)!=4:0))F=54;if((F|0)==54?(WM(t[c>>2]|0,t[l>>2]|0,t[w>>2]|0,t[h>>2]|0)|0)==0:0)t[m>>2]=0;if((t[(t[d>>2]|0)+40>>2]|0)==10){t[E>>2]=t[(t[d>>2]|0)+52>>2];t[S>>2]=$M(t[(t[l>>2]|0)+44>>2]|0,t[w>>2]|0)|0;if(!(t[S>>2]|0))t[S>>2]=$M(t[(t[l>>2]|0)+48>>2]|0,t[w>>2]|0)|0;if(!(t[S>>2]|0)){S=t[c>>2]|0;F=t[b>>2]|0;v=t[w>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(S,F,537,82608,v,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0);else ER(S,F,537,82680,v,t[(t[b>>2]|0)+8>>2]|0,0);t[m>>2]=0}while(1){if(!(t[E>>2]|0))break;if(Xl(t[(t[E>>2]|0)+4>>2]|0,t[w>>2]|0)|0)break;t[E>>2]=t[t[E>>2]>>2]}if(!(t[E>>2]|0)){E=t[c>>2]|0;v=t[b>>2]|0;F=t[w>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(E,v,527,82752,F,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0);else ER(E,v,527,82832,F,t[(t[b>>2]|0)+8>>2]|0,0);t[m>>2]=0}}if((t[(t[d>>2]|0)+40>>2]|0)==9){t[g>>2]=t[(t[d>>2]|0)+52>>2];while(1){if(!(t[g>>2]|0))break;if(Xl(t[(t[g>>2]|0)+4>>2]|0,t[w>>2]|0)|0)break;t[g>>2]=t[t[g>>2]>>2]}if(!(t[g>>2]|0)){g=t[c>>2]|0;F=t[b>>2]|0;v=t[w>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(g,F,502,82912,v,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0);else ER(g,F,502,82992,v,t[(t[b>>2]|0)+8>>2]|0,0);t[m>>2]=0}}if((t[(t[d>>2]|0)+44>>2]|0)==4?(Xl(t[(t[d>>2]|0)+48>>2]|0,t[w>>2]|0)|0)==0:0){v=t[c>>2]|0;F=t[b>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0)ER(v,F,508,83064,t[(t[h>>2]|0)+12>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+48>>2]|0);else ER(v,F,508,83120,t[(t[b>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+48>>2]|0,0);t[m>>2]=0}b=t[c>>2]|0;c=t[l>>2]|0;if(t[(t[h>>2]|0)+12>>2]|0){l=KR(b,c,t[(t[h>>2]|0)+12>>2]|0,t[(t[d>>2]|0)+40>>2]|0,t[w>>2]|0)|0;t[m>>2]=t[m>>2]&l}else{l=KR(b,c,80392,t[(t[d>>2]|0)+40>>2]|0,t[w>>2]|0)|0;t[m>>2]=t[m>>2]&l}t[o>>2]=t[m>>2];y=t[o>>2]|0;s=a;return y|0}t[o>>2]=0;y=t[o>>2]|0;s=a;return y|0}t[o>>2]=0;y=t[o>>2]|0;s=a;return y|0}function cR(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+48|0;u=f+36|0;a=f+32|0;o=f+28|0;c=f+24|0;l=f+20|0;b=f+16|0;k=f+12|0;h=f+8|0;w=f+4|0;d=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=1;t[h>>2]=0;if(!(t[a>>2]|0)){t[u>>2]=0;v=t[u>>2]|0;s=f;return v|0}do if(((t[(t[a>>2]|0)+44>>2]|0)>0?(t[(t[a>>2]|0)+40>>2]|0)!=0:0)?(t[w>>2]=t[(t[a>>2]|0)+40>>2],(t[t[w>>2]>>2]|0)!=0):0){t[d>>2]=t[t[w>>2]>>2];n=t[(t[d>>2]|0)+36>>2]|0;if((n|0)==4){if(!(t[(t[w>>2]|0)+8>>2]|0))break;t[b>>2]=Xs(t[(t[w>>2]|0)+8>>2]|0,t[l>>2]|0,0)|0;if((t[b>>2]|0)<0){ER(t[a>>2]|0,t[(t[w>>2]|0)+4>>2]|0,504,83352,t[(t[(t[w>>2]|0)+4>>2]|0)+8>>2]|0,t[l>>2]|0,0);t[b>>2]=0;break}else{t[b>>2]=1;break}}else if((n|0)==1){ER(t[a>>2]|0,t[(t[w>>2]|0)+4>>2]|0,528,83168,t[(t[(t[w>>2]|0)+4>>2]|0)+8>>2]|0,0,0);t[b>>2]=0;break}else if((n|0)==3){if((t[(t[d>>2]|0)+40>>2]|0)!=0?(t[t[(t[d>>2]|0)+40>>2]>>2]|0)==1:0){ER(t[a>>2]|0,t[(t[w>>2]|0)+4>>2]|0,529,83224,t[(t[(t[w>>2]|0)+4>>2]|0)+8>>2]|0,0,0);t[b>>2]=0;break}t[b>>2]=XR(t[a>>2]|0,t[(t[d>>2]|0)+40>>2]|0,t[l>>2]|0)|0;if((t[b>>2]|0)==1)break;ER(t[a>>2]|0,t[(t[w>>2]|0)+4>>2]|0,515,83288,t[l>>2]|0,t[(t[(t[w>>2]|0)+4>>2]|0)+8>>2]|0,0);break}else if(!n){t[b>>2]=0;break}else break}while(0);t[k>>2]=ZR(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,h)|0;JR(t[a>>2]|0,t[k>>2]|0,t[c>>2]|0)|0;t[u>>2]=t[b>>2];v=t[u>>2]|0;s=f;return v|0}function lR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;
	t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=1;if(!(t[a>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[c>>2]|0)<=0){t[f>>2]=t[l>>2];w=t[f>>2]|0;s=n;return w|0}e:do if(((t[(t[a>>2]|0)+44>>2]|0)>0?(t[(t[a>>2]|0)+40>>2]|0)!=0:0)?(t[b>>2]=t[(t[a>>2]|0)+40>>2],(t[t[b>>2]>>2]|0)!=0):0){t[k>>2]=t[t[b>>2]>>2];r=t[(t[k>>2]|0)+36>>2]|0;if((r|0)==1){ER(t[a>>2]|0,t[(t[b>>2]|0)+4>>2]|0,528,83168,t[(t[(t[b>>2]|0)+4>>2]|0)+8>>2]|0,0,0);t[l>>2]=0;break}else if(!r){t[l>>2]=0;break}else if((r|0)==4){if((t[c>>2]|0)<=0)break;t[h>>2]=0;i:while(1){if((t[h>>2]|0)>=(t[c>>2]|0))break e;do if((u[(t[o>>2]|0)+(t[h>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[o>>2]|0)+(t[h>>2]|0)>>0]|0|0)?(u[(t[o>>2]|0)+(t[h>>2]|0)>>0]|0|0)<=10:0)break;if((u[(t[o>>2]|0)+(t[h>>2]|0)>>0]|0|0)!=13)break i}while(0);t[h>>2]=(t[h>>2]|0)+1}ER(t[a>>2]|0,t[(t[b>>2]|0)+4>>2]|0,504,83416,t[(t[(t[b>>2]|0)+4>>2]|0)+8>>2]|0,0,0);t[l>>2]=0;break}else break}while(0);t[f>>2]=t[l>>2];w=t[f>>2]|0;s=n;return w|0}function sR(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[f+20>>2]=i;t[f+16>>2]=r;t[f+12>>2]=n;t[o>>2]=1;if(!(t[a>>2]|0)){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}if((t[(t[a>>2]|0)+44>>2]|0)>0?(t[(t[a>>2]|0)+40>>2]|0)!=0:0){t[c>>2]=t[(t[a>>2]|0)+40>>2];do if(((t[t[c>>2]>>2]|0)!=0?(t[l>>2]=t[t[c>>2]>>2],(t[(t[l>>2]|0)+36>>2]|0)==4):0)?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){t[o>>2]=Xs(t[(t[c>>2]|0)+8>>2]|0,0,0)|0;if(!(t[o>>2]|0)){ER(t[a>>2]|0,t[(t[c>>2]|0)+4>>2]|0,504,83480,t[(t[(t[c>>2]|0)+4>>2]|0)+8>>2]|0,0,0);break}else{t[o>>2]=1;break}}while(0);QR(t[a>>2]|0)|0}t[u>>2]=t[o>>2];b=t[u>>2]|0;s=f;return b|0}function bR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0;n=s;s=s+144|0;f=n+80|0;a=n+76|0;o=n+72|0;c=n+68|0;l=n+64|0;b=n+60|0;k=n+56|0;h=n+52|0;w=n+48|0;d=n+44|0;v=n+40|0;m=n+36|0;_=n+84|0;p=n+32|0;E=n+28|0;S=n+24|0;g=n+20|0;y=n+16|0;F=n+12|0;O=n+8|0;A=n+4|0;M=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;t[w>>2]=1;t[m>>2]=0;if(!(t[o>>2]|0)){t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}if((t[(t[o>>2]|0)+44>>2]|0)==0?(t[(t[o>>2]|0)+48>>2]|0)==0:0){t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}if(!(t[c>>2]|0)){t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}do switch(t[(t[c>>2]|0)+4>>2]|0){case 8:case 7:case 5:case 4:{t[f>>2]=1;R=t[f>>2]|0;s=n;return R|0}case 6:{ER(t[a>>2]|0,t[c>>2]|0,1,83680,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}case 11:case 10:case 9:{ER(t[a>>2]|0,t[c>>2]|0,1,83744,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}case 20:case 19:{t[f>>2]=1;R=t[f>>2]|0;s=n;return R|0}case 1:{t[l>>2]=ZR(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,m)|0;if(!(t[l>>2]|0)){t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}e:do if(!(t[(t[a>>2]|0)+44>>2]|0)){r=t[(t[l>>2]|0)+36>>2]|0;if(!r){ER(t[a>>2]|0,t[c>>2]|0,534,83832,t[(t[c>>2]|0)+8>>2]|0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}else if((r|0)==4){i:do if((t[m>>2]|0)==1?(t[(t[o>>2]|0)+40>>2]|0)==1:0){t[h>>2]=t[(t[c>>2]|0)+12>>2];while(1){if(!(t[h>>2]|0))break i;if((t[(t[h>>2]|0)+4>>2]|0)==3){t[E>>2]=t[(t[h>>2]|0)+40>>2];while(1){do if((u[t[E>>2]>>0]|0|0)==32)N=1;else{if(9<=(u[t[E>>2]>>0]|0|0)?(u[t[E>>2]>>0]|0|0)<=10:0){N=1;break}N=(u[t[E>>2]>>0]|0|0)==13}while(0);T=t[E>>2]|0;if(!N)break;t[E>>2]=T+1}if(!(u[T>>0]|0))break}t[h>>2]=t[(t[h>>2]|0)+24>>2]}ER(t[a>>2]|0,t[c>>2]|0,532,83904,t[(t[c>>2]|0)+8>>2]|0,0,0);t[w>>2]=0}while(0);t[h>>2]=t[(t[c>>2]|0)+12>>2];t[b>>2]=t[(t[l>>2]|0)+40>>2];t[d>>2]=eN(t[a>>2]|0,t[h>>2]|0,t[l>>2]|0,1,t[c>>2]|0)|0;if((t[d>>2]|0)>0)break;t[w>>2]=t[d>>2];break}else if((r|0)==3){if((t[(t[l>>2]|0)+40>>2]|0)!=0?(t[t[(t[l>>2]|0)+40>>2]>>2]|0)==1:0){t[w>>2]=$R(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;if(t[w>>2]|0)break;ER(t[a>>2]|0,t[c>>2]|0,529,83224,t[(t[c>>2]|0)+8>>2]|0,0,0);break}t[h>>2]=t[(t[c>>2]|0)+12>>2];i:while(1){if(!(t[h>>2]|0))break e;do if((t[(t[h>>2]|0)+4>>2]|0)==1){t[v>>2]=t[(t[h>>2]|0)+8>>2];if((t[(t[h>>2]|0)+36>>2]|0)!=0?(t[(t[(t[h>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[p>>2]=Ug(t[(t[h>>2]|0)+8>>2]|0,t[(t[(t[h>>2]|0)+36>>2]|0)+12>>2]|0,_,50)|0;if(!(t[p>>2]|0))break i;t[b>>2]=t[(t[l>>2]|0)+40>>2];r:while(1){if(!(t[b>>2]|0))break;i=t[b>>2]|0;n:do if((t[t[b>>2]>>2]|0)==2){if(Xl(t[i+8>>2]|0,t[p>>2]|0)|0)break r}else{do if((t[i>>2]|0)==4){if(!(t[(t[b>>2]|0)+12>>2]|0))break;if((t[t[(t[b>>2]|0)+12>>2]>>2]|0)!=2)break;if(Xl(t[(t[(t[b>>2]|0)+12>>2]|0)+8>>2]|0,t[p>>2]|0)|0)break r;else break n}while(0);if((t[t[b>>2]>>2]|0)!=4){L=53;break r}if(!(t[(t[b>>2]|0)+12>>2]|0)){L=53;break r}if((t[t[(t[b>>2]|0)+12>>2]>>2]|0)!=1){L=53;break r}}while(0);t[b>>2]=t[(t[b>>2]|0)+16>>2]}if((L|0)==53){L=0;yR(0,519,83864,0)}if((t[p>>2]|0)!=(_|0)?(t[p>>2]|0)!=(t[(t[h>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[p>>2]|0);if(t[b>>2]|0)break}t[b>>2]=t[(t[l>>2]|0)+40>>2];r:while(1){if(!(t[b>>2]|0))break;i=t[b>>2]|0;n:do if((t[t[b>>2]>>2]|0)==2){if(Xl(t[i+8>>2]|0,t[v>>2]|0)|0)break r}else{do if((t[i>>2]|0)==4){if(!(t[(t[b>>2]|0)+12>>2]|0))break;if((t[t[(t[b>>2]|0)+12>>2]>>2]|0)!=2)break;if(Xl(t[(t[(t[b>>2]|0)+12>>2]|0)+8>>2]|0,t[v>>2]|0)|0)break r;else break n}while(0);if((t[t[b>>2]>>2]|0)!=4){L=70;break r}if(!(t[(t[b>>2]|0)+12>>2]|0)){L=70;break r}if((t[t[(t[b>>2]|0)+12>>2]>>2]|0)!=1){L=70;break r}}while(0);t[b>>2]=t[(t[b>>2]|0)+16>>2]}if((L|0)==70){L=0;yR(t[a>>2]|0,519,83864,0)}if(!(t[b>>2]|0)){ER(t[a>>2]|0,t[c>>2]|0,515,83288,t[v>>2]|0,t[(t[c>>2]|0)+8>>2]|0,0);t[w>>2]=0}}while(0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}else if((r|0)==1){if(!(t[(t[c>>2]|0)+12>>2]|0))break;ER(t[a>>2]|0,t[c>>2]|0,528,83168,t[(t[c>>2]|0)+8>>2]|0,0,0);t[w>>2]=0;break}else break}while(0);t[k>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[k>>2]|0))break;e:do if((t[(t[k>>2]|0)+44>>2]|0)==2){t[S>>2]=-1;i:do if((t[(t[k>>2]|0)+56>>2]|0)==0?(Xl(t[(t[k>>2]|0)+8>>2]|0,80392)|0)!=0:0){t[g>>2]=t[(t[c>>2]|0)+48>>2];while(1){if(!(t[g>>2]|0))break i;if(!(t[(t[g>>2]|0)+12>>2]|0))break e;t[g>>2]=t[t[g>>2]>>2]}}else L=100;while(0);i:do if((L|0)==100){L=0;i=(Xl(t[(t[k>>2]|0)+56>>2]|0,80392)|0)!=0;e=t[c>>2]|0;if(i){t[y>>2]=t[e+48>>2];while(1){if(!(t[y>>2]|0))break i;if(Xl(t[(t[k>>2]|0)+8>>2]|0,t[(t[y>>2]|0)+12>>2]|0)|0)break e;t[y>>2]=t[t[y>>2]>>2]}}t[F>>2]=t[e+44>>2];while(1){if(!(t[F>>2]|0))break i;do if(Xl(t[(t[F>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+8>>2]|0)|0){if(!(t[(t[k>>2]|0)+56>>2]|0))break e;t[O>>2]=t[(t[F>>2]|0)+36>>2];if(!(t[O>>2]|0))t[O>>2]=t[(t[c>>2]|0)+36>>2];if(!(t[O>>2]|0)){if((t[S>>2]|0)>=0)break;t[S>>2]=0;break}if(Xl(t[(t[O>>2]|0)+12>>2]|0,t[(t[k>>2]|0)+56>>2]|0)|0)break e;if((t[S>>2]|0)>=1)break;t[S>>2]=1}while(0);t[F>>2]=t[(t[F>>2]|0)+24>>2]}}while(0);if((t[S>>2]|0)==-1){e=t[a>>2]|0;i=t[c>>2]|0;D=t[(t[c>>2]|0)+8>>2]|0;C=t[k>>2]|0;if(!(t[(t[k>>2]|0)+56>>2]|0)){ER(e,i,518,83984,D,t[C+8>>2]|0,0);t[w>>2]=0;break}else{ER(e,i,518,84024,D,t[C+56>>2]|0,t[(t[k>>2]|0)+8>>2]|0);t[w>>2]=0;break}}if(!(t[S>>2]|0)){RR(t[a>>2]|0,t[c>>2]|0,524,84072,t[(t[c>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+56>>2]|0,t[(t[k>>2]|0)+8>>2]|0);break}if((t[S>>2]|0)==1)RR(t[a>>2]|0,t[c>>2]|0,506,84128,t[(t[c>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+56>>2]|0,t[(t[k>>2]|0)+8>>2]|0)}else if((t[(t[k>>2]|0)+44>>2]|0)==4){if((t[(t[k>>2]|0)+56>>2]|0)==0?(Xl(t[(t[k>>2]|0)+8>>2]|0,80392)|0)!=0:0){t[A>>2]=t[(t[c>>2]|0)+48>>2];while(1){if(!(t[A>>2]|0))break e;if(!(t[(t[A>>2]|0)+12>>2]|0))break;t[A>>2]=t[t[A>>2]>>2]}if(Xl(t[(t[k>>2]|0)+48>>2]|0,t[(t[A>>2]|0)+8>>2]|0)|0)break;ER(t[a>>2]|0,t[c>>2]|0,507,84192,t[(t[c>>2]|0)+8>>2]|0,0,0);t[w>>2]=0;break}if(Xl(t[(t[k>>2]|0)+56>>2]|0,80392)|0){t[M>>2]=t[(t[c>>2]|0)+48>>2];while(1){if(!(t[M>>2]|0))break e;if(Xl(t[(t[k>>2]|0)+8>>2]|0,t[(t[M>>2]|0)+12>>2]|0)|0)break;t[M>>2]=t[t[M>>2]>>2]}if(!(Xl(t[(t[k>>2]|0)+48>>2]|0,t[(t[M>>2]|0)+8>>2]|0)|0)){ER(t[a>>2]|0,t[c>>2]|0,508,84264,t[(t[c>>2]|0)+8>>2]|0,t[(t[M>>2]|0)+12>>2]|0,0);t[w>>2]=0}}}while(0);t[k>>2]=t[(t[k>>2]|0)+36>>2]}t[f>>2]=t[w>>2];R=t[f>>2]|0;s=n;return R|0}case 3:{if(t[(t[c>>2]|0)+12>>2]|0){ER(t[a>>2]|0,t[c>>2]|0,1,83584,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}if(t[(t[c>>2]|0)+36>>2]|0){ER(t[a>>2]|0,t[c>>2]|0,1,83616,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}if(!(t[(t[c>>2]|0)+40>>2]|0)){ER(t[a>>2]|0,t[c>>2]|0,1,83648,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}else{t[f>>2]=1;R=t[f>>2]|0;s=n;return R|0}break}case 2:{ER(t[a>>2]|0,t[c>>2]|0,1,83552,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}case 13:{ER(t[a>>2]|0,t[c>>2]|0,1,83776,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}case 12:{ER(t[a>>2]|0,t[c>>2]|0,1,83712,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}default:{ER(t[a>>2]|0,t[c>>2]|0,1,83808,0,0,0);t[f>>2]=0;R=t[f>>2]|0;s=n;return R|0}}while(0);return 0}function kR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+80|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r+24|0;l=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[a>>2]=eF(t[u>>2]|0)|0;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+8>>2]|0)!=0:0){do if(((t[(t[u>>2]|0)+44>>2]|0)!=0?(t[(t[(t[u>>2]|0)+44>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+44>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0)==0:0){if((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[l>>2]=Ug(t[(t[a>>2]|0)+8>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0,c,50)|0;if(!(t[l>>2]|0)){gR(t[f>>2]|0,0);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[o>>2]=Xl(t[(t[(t[u>>2]|0)+44>>2]|0)+8>>2]|0,t[l>>2]|0)|0;if((t[l>>2]|0)!=(c|0)?(t[l>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[l>>2]|0);if((t[o>>2]|0)==1)break}if((Xl(t[(t[(t[u>>2]|0)+44>>2]|0)+8>>2]|0,84352)|0)!=0?(Xl(t[(t[a>>2]|0)+8>>2]|0,84360)|0)!=0:0)break;ER(t[f>>2]|0,t[a>>2]|0,531,84368,t[(t[a>>2]|0)+8>>2]|0,t[(t[(t[u>>2]|0)+44>>2]|0)+8>>2]|0,0);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}while(0);t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}yR(t[f>>2]|0,525,84328,0);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}function hR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[h>>2]=1;if(!(t[o>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if(((t[(t[o>>2]|0)+4>>2]|0)!=19?(t[(t[o>>2]|0)+4>>2]|0)!=20:0)?(t[(t[o>>2]|0)+4>>2]|0)!=18:0){if(!(t[a>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[a>>2]|0)+44>>2]|0)==0?(t[(t[a>>2]|0)+48>>2]|0)==0:0){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if((t[(t[o>>2]|0)+4>>2]|0)==5){t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}r=bR(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[h>>2]=t[h>>2]&r;e:do if((t[(t[o>>2]|0)+4>>2]|0)==1){t[l>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[l>>2]|0))break;t[k>>2]=sy(t[a>>2]|0,t[(t[l>>2]|0)+12>>2]|0,0)|0;r=aR(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[l>>2]|0,t[k>>2]|0)|0;t[h>>2]=t[h>>2]&r;if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);t[l>>2]=t[(t[l>>2]|0)+24>>2]}t[b>>2]=t[(t[o>>2]|0)+48>>2];while(1){if(!(t[b>>2]|0))break e;r=t[u>>2]|0;i=t[a>>2]|0;e=t[o>>2]|0;if(!(t[(t[o>>2]|0)+36>>2]|0)){d=oR(r,i,e,0,t[b>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;t[h>>2]=t[h>>2]&d}else{d=oR(r,i,e,t[(t[(t[o>>2]|0)+36>>2]|0)+12>>2]|0,t[b>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;t[h>>2]=t[h>>2]&d}t[b>>2]=t[t[b>>2]>>2]}}while(0);t[c>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break;o=hR(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;t[h>>2]=t[h>>2]&o;t[c>>2]=t[(t[c>>2]|0)+24>>2]}t[f>>2]=t[h>>2];w=t[f>>2]|0;s=n;return w|0}t[f>>2]=1;w=t[f>>2]|0;s=n;return w|0}function wR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}i=t[f>>2]|0;if(!(t[u>>2]|0)){yR(i,521,84416,0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[o>>2]=t[i+28>>2];t[(t[f>>2]|0)+28>>2]=0;t[a>>2]=t[(t[u>>2]|0)+68>>2];t[(t[f>>2]|0)+32>>2]=t[u>>2];t[(t[f>>2]|0)+36>>2]=1;aO(t[a>>2]|0,254,t[f>>2]|0);t[(t[f>>2]|0)+28>>2]=t[o>>2];t[n>>2]=t[(t[f>>2]|0)+36>>2];c=t[n>>2]|0;s=r;return c|0}return 0}function dR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[o>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(!(t[a>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[l>>2]=t[(t[a>>2]|0)+48>>2];t[b>>2]=t[(t[a>>2]|0)+44>>2];t[(t[a>>2]|0)+48>>2]=t[o>>2];t[(t[a>>2]|0)+44>>2]=0;t[c>>2]=kR(t[u>>2]|0,t[a>>2]|0)|0;if(!(t[c>>2]|0)){t[(t[a>>2]|0)+48>>2]=t[l>>2];t[(t[a>>2]|0)+44>>2]=t[b>>2];t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}if(t[(t[a>>2]|0)+64>>2]|0){jM(t[(t[a>>2]|0)+64>>2]|0);t[(t[a>>2]|0)+64>>2]=0}if(t[(t[a>>2]|0)+68>>2]|0){KM(t[(t[a>>2]|0)+68>>2]|0);t[(t[a>>2]|0)+68>>2]=0}t[k>>2]=eF(t[a>>2]|0)|0;t[c>>2]=hR(t[u>>2]|0,t[a>>2]|0,t[k>>2]|0)|0;k=wR(t[u>>2]|0,t[a>>2]|0)|0;t[c>>2]=t[c>>2]&k;t[(t[a>>2]|0)+48>>2]=t[l>>2];t[(t[a>>2]|0)+44>>2]=t[b>>2];t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}function vR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if((t[u>>2]|0)==0|(t[f>>2]|0)==0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if((t[(t[u>>2]|0)+44>>2]|0)==0?(t[(t[u>>2]|0)+48>>2]|0)==0:0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[(t[f>>2]|0)+32>>2]=t[u>>2];t[(t[f>>2]|0)+36>>2]=1;t[a>>2]=t[(t[u>>2]|0)+44>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+44>>2]|0)!=0:0){t[o>>2]=t[(t[a>>2]|0)+44>>2];aO(t[o>>2]|0,255,t[f>>2]|0)}if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+48>>2]|0)!=0:0){t[c>>2]=t[(t[a>>2]|0)+48>>2];aO(t[c>>2]|0,256,t[f>>2]|0)}t[a>>2]=t[(t[u>>2]|0)+48>>2];if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+44>>2]|0)!=0:0){t[o>>2]=t[(t[a>>2]|0)+44>>2];aO(t[o>>2]|0,255,t[f>>2]|0)}if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+48>>2]|0)!=0:0){t[c>>2]=t[(t[a>>2]|0)+48>>2];aO(t[c>>2]|0,256,t[f>>2]|0)}t[n>>2]=t[(t[f>>2]|0)+36>>2];l=t[n>>2]|0;s=r;return l|0}function mR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if((t[(t[u>>2]|0)+44>>2]|0)==0?(t[(t[u>>2]|0)+48>>2]|0)==0:0){yR(t[f>>2]|0,522,84456,0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}do if(t[(t[u>>2]|0)+44>>2]|0){if((t[(t[(t[u>>2]|0)+44>>2]|0)+56>>2]|0)==0?(t[(t[(t[u>>2]|0)+44>>2]|0)+52>>2]|0)==0:0)break;if(!(t[(t[u>>2]|0)+48>>2]|0)){if(t[(t[(t[u>>2]|0)+44>>2]|0)+56>>2]|0){t[c>>2]=GA(t[(t[(t[u>>2]|0)+44>>2]|0)+56>>2]|0,t[(t[u>>2]|0)+72>>2]|0)|0;if(!(t[c>>2]|0)){yR(t[f>>2]|0,517,84472,t[(t[(t[u>>2]|0)+44>>2]|0)+56>>2]|0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}}else t[c>>2]=0;i=aS(t[(t[(t[u>>2]|0)+44>>2]|0)+52>>2]|0,t[c>>2]|0)|0;t[(t[u>>2]|0)+48>>2]=i;if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);if(!(t[(t[u>>2]|0)+48>>2]|0)){i=t[f>>2]|0;e=t[(t[u>>2]|0)+44>>2]|0;if(t[(t[(t[u>>2]|0)+44>>2]|0)+56>>2]|0)yR(i,517,84520,t[e+56>>2]|0);else yR(i,517,84520,t[e+52>>2]|0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}}}while(0);if(t[(t[u>>2]|0)+64>>2]|0){jM(t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0}if(t[(t[u>>2]|0)+68>>2]|0){KM(t[(t[u>>2]|0)+68>>2]|0);t[(t[u>>2]|0)+68>>2]=0}t[a>>2]=vR(t[f>>2]|0,t[u>>2]|0)|0;if(kR(t[f>>2]|0,t[u>>2]|0)|0){t[o>>2]=eF(t[u>>2]|0)|0;c=hR(t[f>>2]|0,t[u>>2]|0,t[o>>2]|0)|0;t[a>>2]=t[a>>2]&c;c=wR(t[f>>2]|0,t[u>>2]|0)|0;t[a>>2]=t[a>>2]&c;t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}return 0}function _R(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if((t[t[c>>2]>>2]|0)>=(t[l>>2]|0)){t[u>>2]=t[t[c>>2]>>2];k=t[u>>2]|0;s=f;return k|0}n=t[t[a>>2]>>2]|0;do if((n|0)==4){_R(t[(t[a>>2]|0)+12>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;_R(t[(t[a>>2]|0)+16>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0}else if((n|0)==2){t[b>>2]=0;while(1){h=t[(t[a>>2]|0)+8>>2]|0;if((t[b>>2]|0)>=(t[t[c>>2]>>2]|0)){w=17;break}if(Xl(h,t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0)|0)break;t[b>>2]=(t[b>>2]|0)+1}if((w|0)==17){r=t[c>>2]|0;i=t[r>>2]|0;t[r>>2]=i+1;t[(t[o>>2]|0)+(i<<2)>>2]=h;break}t[u>>2]=t[t[c>>2]>>2];k=t[u>>2]|0;s=f;return k|0}else if((n|0)==1){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[t[c>>2]>>2]|0)){w=11;break}if(Xl(79640,t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0)|0)break;t[b>>2]=(t[b>>2]|0)+1}if((w|0)==11){i=t[c>>2]|0;r=t[i>>2]|0;t[i>>2]=r+1;t[(t[o>>2]|0)+(r<<2)>>2]=79640;break}t[u>>2]=t[t[c>>2]>>2];k=t[u>>2]|0;s=f;return k|0}else if((n|0)==3){_R(t[(t[a>>2]|0)+12>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;_R(t[(t[a>>2]|0)+16>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0}while(0);t[u>>2]=t[t[c>>2]>>2];k=t[u>>2]|0;s=f;return k|0}function pR(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;f=s;s=s+1168|0;u=f+1160|0;a=f+1156|0;o=f+1152|0;c=f+1148|0;l=f+1144|0;b=f+1080|0;k=f+1072|0;h=f+48|0;w=f+44|0;d=f+40|0;v=f+36|0;m=f+32|0;_=f+28|0;p=f+24|0;E=f+20|0;S=f+16|0;g=f+12|0;y=f+8|0;F=f+4|0;O=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;VY(h|0,0,1024)|0;t[w>>2]=0;if((t[a>>2]|0)==0&(t[o>>2]|0)==0){t[u>>2]=-1;A=t[u>>2]|0;s=f;return A|0}if(!(t[c>>2]|0)){t[u>>2]=-1;A=t[u>>2]|0;s=f;return A|0}if((t[l>>2]|0)<=0){t[u>>2]=-1;A=t[u>>2]|0;s=f;return A|0}n=b+0|0;r=n+64|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));t[b+4>>2]=257;t[k>>2]=0;t[m>>2]=(t[a>>2]|0)!=0?t[a>>2]|0:t[o>>2]|0;t[_>>2]=t[(t[m>>2]|0)+20>>2];t[F>>2]=ZM(t[(t[(t[_>>2]|0)+32>>2]|0)+44>>2]|0,t[(t[_>>2]|0)+8>>2]|0)|0;if((t[F>>2]|0)==0?(t[(t[(t[_>>2]|0)+32>>2]|0)+48>>2]|0)!=0:0)t[F>>2]=ZM(t[(t[(t[_>>2]|0)+32>>2]|0)+48>>2]|0,t[(t[_>>2]|0)+8>>2]|0)|0;if(!(t[F>>2]|0)){t[u>>2]=-1;A=t[u>>2]|0;s=f;return A|0}if(t[a>>2]|0)M=t[(t[a>>2]|0)+24>>2]|0;else M=0;t[E>>2]=M;if(t[o>>2]|0)R=t[(t[o>>2]|0)+28>>2]|0;else R=0;t[S>>2]=R;t[g>>2]=t[(t[_>>2]|0)+12>>2];t[y>>2]=t[(t[_>>2]|0)+16>>2];t[p>>2]=Sy(t[(t[m>>2]|0)+32>>2]|0,0,84568,0)|0;if(!(t[p>>2]|0)){t[u>>2]=-1;A=t[u>>2]|0;s=f;return A|0}t[(t[p>>2]|0)+20>>2]=t[_>>2];t[(t[p>>2]|0)+28>>2]=t[a>>2];t[(t[p>>2]|0)+24>>2]=t[o>>2];t[v>>2]=t[(t[p>>2]|0)+8>>2];m=t[p>>2]|0;if(t[a>>2]|0)t[(t[a>>2]|0)+24>>2]=m;else t[(t[_>>2]|0)+12>>2]=m;m=t[p>>2]|0;if(t[o>>2]|0)t[(t[o>>2]|0)+28>>2]=m;else t[(t[_>>2]|0)+16>>2]=m;t[w>>2]=_R(t[(t[F>>2]|0)+40>>2]|0,h,w,256)|0;t[d>>2]=0;while(1){if((t[d>>2]|0)>=(t[w>>2]|0))break;t[(t[p>>2]|0)+8>>2]=t[h+(t[d>>2]<<2)>>2];if(bR(b,t[(t[_>>2]|0)+32>>2]|0,t[_>>2]|0)|0){t[O>>2]=0;while(1){if((t[O>>2]|0)>=(t[k>>2]|0))break;if(Xl(t[h+(t[d>>2]<<2)>>2]|0,t[(t[c>>2]|0)+(t[O>>2]<<2)>>2]|0)|0)break;t[O>>2]=(t[O>>2]|0)+1}F=t[h+(t[d>>2]<<2)>>2]|0;m=t[k>>2]|0;t[k>>2]=m+1;t[(t[c>>2]|0)+(m<<2)>>2]=F;if((t[k>>2]|0)>=(t[l>>2]|0))break}t[d>>2]=(t[d>>2]|0)+1}if(t[a>>2]|0)t[(t[a>>2]|0)+24>>2]=t[E>>2];if(t[o>>2]|0)t[(t[o>>2]|0)+28>>2]=t[S>>2];t[(t[_>>2]|0)+12>>2]=t[g>>2];t[(t[_>>2]|0)+16>>2]=t[y>>2];t[(t[p>>2]|0)+8>>2]=t[v>>2];ry(t[p>>2]|0);t[u>>2]=t[k>>2];A=t[u>>2]|0;s=f;return A|0}function ER(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;o=s;s=s+64|0;c=o;l=o+56|0;b=o+52|0;k=o+48|0;h=o+44|0;w=o+40|0;d=o+36|0;v=o+32|0;m=o+28|0;_=o+24|0;p=o+20|0;E=o+16|0;S=o+12|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;t[E>>2]=0;do if(t[l>>2]|0){t[_>>2]=t[(t[l>>2]|0)+4>>2];t[E>>2]=t[t[l>>2]>>2];if((t[(t[l>>2]|0)+28>>2]|0)!=-1412623820?(t[(t[l>>2]|0)+28>>2]|0)!=-1412623819:0)break;t[S>>2]=(t[l>>2]|0)-(t[t[l>>2]>>2]|0);if((t[S>>2]|0)>0&(t[S>>2]|0)<250)t[p>>2]=t[t[l>>2]>>2]}while(0);l=t[m>>2]|0;m=t[_>>2]|0;_=t[E>>2]|0;E=t[p>>2]|0;p=t[b>>2]|0;b=t[k>>2]|0;k=t[w>>2]|0;S=t[w>>2]|0;a=t[v>>2]|0;u=t[h>>2]|0;h=t[d>>2]|0;d=t[v>>2]|0;t[c>>2]=t[w>>2];t[c+4>>2]=h;t[c+8>>2]=d;cp(l,m,_,E,p,23,b,2,0,0,k,S,a,0,0,u,c);s=o;return}function SR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+112|0;f=n+44|0;u=n+40|0;a=n+36|0;o=n+32|0;c=n+28|0;l=n+48|0;b=n+24|0;k=n+20|0;h=n+16|0;w=n+12|0;d=n+8|0;v=n+4|0;m=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){ER(t[a>>2]|0,0,1,85712,t[o>>2]|0,0,0);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}r=t[t[u>>2]>>2]|0;do if((r|0)==2){t[c>>2]=t[(t[a>>2]|0)+60>>2];t[b>>2]=Ug(t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+24>>2]|0,l,50)|0;if(!(t[b>>2]|0)){gR(t[a>>2]|0,85800);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}i=t[(t[u>>2]|0)+4>>2]|0;if((i|0)==4){e=ob(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,0,t[b>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=e;ob(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,t[(t[a>>2]|0)+60>>2]|0,t[b>>2]|0,0)|0}else if((i|0)==1){e=ob(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,0,t[b>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=e}else if((i|0)==2){e=ob(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,0,t[b>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=e;hb(t[(t[a>>2]|0)+56>>2]|0,t[c>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0}else if((i|0)==3){i=hb(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=i;ob(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,t[(t[a>>2]|0)+60>>2]|0,t[b>>2]|0,0)|0}if((t[b>>2]|0)!=(l|0)?(t[b>>2]|0)!=(t[(t[u>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[b>>2]|0)}else if((r|0)==4){t[m>>2]=t[(t[u>>2]|0)+4>>2];if((t[m>>2]|0)==4|(t[m>>2]|0)==3){i=hb(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=i}t[d>>2]=t[(t[a>>2]|0)+60>>2];t[v>>2]=kb(t[(t[a>>2]|0)+56>>2]|0)|0;do{t[(t[a>>2]|0)+60>>2]=t[d>>2];SR(t[(t[u>>2]|0)+12>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;hb(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,t[v>>2]|0)|0;t[u>>2]=t[(t[u>>2]|0)+16>>2];if((t[t[u>>2]>>2]|0)!=4)break}while((t[(t[u>>2]|0)+4>>2]|0)==1);t[(t[a>>2]|0)+60>>2]=t[d>>2];SR(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;hb(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+60>>2]|0,t[v>>2]|0)|0;i=hb(t[(t[a>>2]|0)+56>>2]|0,t[v>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=i;i=t[m>>2]|0;if((i|0)==3){hb(t[(t[a>>2]|0)+56>>2]|0,t[d>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;hb(t[(t[a>>2]|0)+56>>2]|0,t[v>>2]|0,t[d>>2]|0)|0;break}else if((i|0)==4){hb(t[(t[a>>2]|0)+56>>2]|0,t[v>>2]|0,t[d>>2]|0)|0;break}else if((i|0)==2){hb(t[(t[a>>2]|0)+56>>2]|0,t[d>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;break}else break}else if((r|0)==1){ER(t[a>>2]|0,0,1,85760,t[o>>2]|0,0,0);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}else if((r|0)==3){t[k>>2]=t[(t[a>>2]|0)+60>>2];t[w>>2]=t[(t[u>>2]|0)+4>>2];if((t[w>>2]|0)!=1){i=hb(t[(t[a>>2]|0)+56>>2]|0,t[k>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=i;t[k>>2]=t[(t[a>>2]|0)+60>>2]}do{SR(t[(t[u>>2]|0)+12>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[u>>2]=t[(t[u>>2]|0)+16>>2];if((t[t[u>>2]>>2]|0)!=3)break}while((t[(t[u>>2]|0)+4>>2]|0)==1);SR(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[h>>2]=t[(t[a>>2]|0)+60>>2];i=hb(t[(t[a>>2]|0)+56>>2]|0,t[h>>2]|0,0)|0;t[(t[a>>2]|0)+60>>2]=i;i=t[w>>2]|0;if((i|0)==3){hb(t[(t[a>>2]|0)+56>>2]|0,t[k>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;hb(t[(t[a>>2]|0)+56>>2]|0,t[h>>2]|0,t[k>>2]|0)|0;break}else if((i|0)==2){hb(t[(t[a>>2]|0)+56>>2]|0,t[k>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;break}else if((i|0)==4){hb(t[(t[a>>2]|0)+56>>2]|0,t[h>>2]|0,t[k>>2]|0)|0;break}else break}else{yR(t[a>>2]|0,1,85824,t[o>>2]|0);t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}while(0);t[f>>2]=1;_=t[f>>2]|0;s=n;return _|0}function gR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;do if(t[f>>2]|0){t[a>>2]=t[(t[f>>2]|0)+4>>2];t[c>>2]=t[t[f>>2]>>2];if((t[(t[f>>2]|0)+28>>2]|0)!=-1412623820?(t[(t[f>>2]|0)+28>>2]|0)!=-1412623819:0)break;t[l>>2]=(t[f>>2]|0)-(t[t[f>>2]>>2]|0);if((t[l>>2]|0)>0&(t[l>>2]|0)<250)t[o>>2]=t[t[f>>2]>>2]}while(0);f=t[a>>2]|0;a=t[c>>2]|0;c=t[o>>2]|0;if(t[u>>2]|0){o=t[u>>2]|0;t[n>>2]=t[u>>2];cp(0,f,a,c,0,23,2,3,0,0,o,0,0,0,0,85648,n);s=r;return}else{cp(0,f,a,c,0,23,2,3,0,0,0,0,0,0,0,85680,n);s=r;return}}function yR(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+48|0;u=f;a=f+32|0;o=f+28|0;c=f+24|0;l=f+20|0;b=f+16|0;k=f+12|0;h=f+8|0;w=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;do if(t[a>>2]|0){t[b>>2]=t[(t[a>>2]|0)+4>>2];t[h>>2]=t[t[a>>2]>>2];if((t[(t[a>>2]|0)+28>>2]|0)!=-1412623820?(t[(t[a>>2]|0)+28>>2]|0)!=-1412623819:0)break;t[w>>2]=(t[a>>2]|0)-(t[t[a>>2]>>2]|0);if((t[w>>2]|0)>0&(t[w>>2]|0)<250)t[k>>2]=t[t[a>>2]>>2]}while(0);a=t[b>>2]|0;b=t[h>>2]|0;h=t[k>>2]|0;k=t[o>>2]|0;if(t[l>>2]|0){o=t[l>>2]|0;w=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,a,b,h,0,23,k,2,0,0,o,0,0,0,0,w,u);s=f;return}else{t[u>>2]=t[c>>2];cp(0,a,b,h,0,23,k,2,0,0,0,0,0,0,0,85640,u);s=f;return}}function FR(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}iy(t[r>>2]|0);yM(t[(t[r>>2]|0)+32>>2]|0,t[(t[r>>2]|0)+40>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+48>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)fb(t[(t[r>>2]|0)+52>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function OR(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](56)|0;if(!(t[f>>2]|0)){gR(0,79472);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+56|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=15;t[(t[f>>2]|0)+36>>2]=t[(t[n>>2]|0)+36>>2];if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[f>>2]|0)+8>>2]=e}else t[(t[f>>2]|0)+8>>2]=0;if(t[(t[n>>2]|0)+48>>2]|0){e=Yl(t[(t[n>>2]|0)+48>>2]|0)|0;t[(t[f>>2]|0)+48>>2]=e}else t[(t[f>>2]|0)+48>>2]=0;e=gM(t[(t[n>>2]|0)+40>>2]|0)|0;t[(t[f>>2]|0)+40>>2]=e;t[(t[f>>2]|0)+44>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function AR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[u>>2]|0)){s=n;return}if(t[a>>2]|0)NF(t[f>>2]|0,79632);r=t[t[u>>2]>>2]|0;e:do if((r|0)==1)NF(t[f>>2]|0,79640);else if((r|0)==4){if((t[t[(t[u>>2]|0)+12>>2]>>2]|0)!=4?(t[t[(t[u>>2]|0)+12>>2]>>2]|0)!=3:0)AR(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,0);else AR(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,1);NF(t[f>>2]|0,79664);do if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)!=3){if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)==4?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=1:0)break;AR(t[f>>2]|0,t[(t[u>>2]|0)+16>>2]|0,0);break e}while(0);AR(t[f>>2]|0,t[(t[u>>2]|0)+16>>2]|0,1)}else if((r|0)==2){if(t[(t[u>>2]|0)+24>>2]|0){RF(t[f>>2]|0,t[(t[u>>2]|0)+24>>2]|0);NF(t[f>>2]|0,79648)}RF(t[f>>2]|0,t[(t[u>>2]|0)+8>>2]|0)}else if((r|0)==3){if((t[t[(t[u>>2]|0)+12>>2]>>2]|0)!=4?(t[t[(t[u>>2]|0)+12>>2]>>2]|0)!=3:0)AR(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,0);else AR(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,1);NF(t[f>>2]|0,79656);do if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)!=4){if((t[t[(t[u>>2]|0)+16>>2]>>2]|0)==3?(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)!=1:0)break;AR(t[f>>2]|0,t[(t[u>>2]|0)+16>>2]|0,0);break e}while(0);AR(t[f>>2]|0,t[(t[u>>2]|0)+16>>2]|0,1)}else yR(0,1,79568,0);while(0);if(t[a>>2]|0)NF(t[f>>2]|0,79672);a=t[(t[u>>2]|0)+4>>2]|0;if((a|0)==2){NF(t[f>>2]|0,79680);s=n;return}else if((a|0)==3){NF(t[f>>2]|0,79688);s=n;return}else if((a|0)==4){NF(t[f>>2]|0,79696);s=n;return}else{s=n;return}}function MR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;switch(t[a>>2]|0){case 10:case 2:case 3:case 5:{t[f>>2]=jR(t[u>>2]|0,t[o>>2]|0)|0;break}case 7:{t[f>>2]=qR(t[u>>2]|0,t[o>>2]|0)|0;break}case 4:case 6:{t[f>>2]=VR(t[u>>2]|0,t[o>>2]|0)|0;break}case 9:case 8:{t[f>>2]=YR(t[u>>2]|0,t[o>>2]|0)|0;break}default:t[f>>2]=1}s=n;return t[f>>2]|0}function RR(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;o=s;s=s+64|0;c=o;l=o+56|0;b=o+52|0;k=o+48|0;h=o+44|0;w=o+40|0;d=o+36|0;v=o+32|0;m=o+28|0;_=o+24|0;p=o+20|0;E=o+16|0;S=o+12|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;t[E>>2]=0;do if(t[l>>2]|0){t[_>>2]=t[(t[l>>2]|0)+8>>2];t[E>>2]=t[t[l>>2]>>2];if((t[(t[l>>2]|0)+28>>2]|0)!=-1412623820?(t[(t[l>>2]|0)+28>>2]|0)!=-1412623819:0)break;t[S>>2]=(t[l>>2]|0)-(t[t[l>>2]>>2]|0);if((t[S>>2]|0)>0&(t[S>>2]|0)<250)t[p>>2]=t[t[l>>2]>>2]}while(0);l=t[m>>2]|0;m=t[_>>2]|0;_=t[E>>2]|0;E=t[p>>2]|0;p=t[b>>2]|0;b=t[k>>2]|0;k=t[w>>2]|0;S=t[w>>2]|0;a=t[v>>2]|0;u=t[h>>2]|0;h=t[d>>2]|0;d=t[v>>2]|0;t[c>>2]=t[w>>2];t[c+4>>2]=h;t[c+8>>2]=d;cp(l,m,_,E,p,23,b,1,0,0,k,S,a,0,0,u,c);s=o;return}function NR(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+32>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+32>>2]|0)+80>>2];else t[n>>2]=0;iy(t[r>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)NM(t[(t[r>>2]|0)+52>>2]|0);e=(t[(t[r>>2]|0)+60>>2]|0)!=0;if(t[n>>2]|0){if(e?(wz(t[n>>2]|0,t[(t[r>>2]|0)+60>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+60>>2]|0);if((t[(t[r>>2]|0)+8>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+8>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if((t[(t[r>>2]|0)+56>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+56>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0);if((t[(t[r>>2]|0)+48>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+48>>2]|0)|0)==0:0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0)}else{if(e)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+60>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+48>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+48>>2]|0);if(t[(t[r>>2]|0)+56>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function TR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;t[k>>2]=0;if(!(t[u>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}if(!(t[(t[u>>2]|0)+40>>2]|0)){t[h>>2]=0;if(t[(t[u>>2]|0)+32>>2]|0)t[h>>2]=t[(t[(t[u>>2]|0)+32>>2]|0)+80>>2];if(!(t[o>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[c>>2]=t[(t[u>>2]|0)+40>>2];if(!(t[c>>2]|0)){t[c>>2]=KF(0,t[h>>2]|0)|0;t[(t[u>>2]|0)+40>>2]=t[c>>2]}if(!(t[c>>2]|0)){gR(0,85552);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}}t[c>>2]=t[(t[u>>2]|0)+40>>2];t[b>>2]=zg(t[a>>2]|0,k)|0;if(t[b>>2]|0)t[a>>2]=t[b>>2];t[l>>2]=fO(t[c>>2]|0,t[a>>2]|0,t[k>>2]|0)|0;do if((t[l>>2]|0)==0&(t[o>>2]|0)!=0){t[l>>2]=gAi[t[135744>>2]&511](56)|0;if(t[l>>2]|0){u=(t[l>>2]|0)+0|0;h=u+56|0;do{t[u>>2]=0;u=u+4|0}while((u|0)<(h|0));t[(t[l>>2]|0)+4>>2]=15;u=Yl(t[a>>2]|0)|0;t[(t[l>>2]|0)+8>>2]=u;u=Yl(t[k>>2]|0)|0;t[(t[l>>2]|0)+48>>2]=u;t[(t[l>>2]|0)+36>>2]=0;QF(t[c>>2]|0,t[a>>2]|0,t[k>>2]|0,t[l>>2]|0)|0;break}gR(0,79472);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}while(0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=t[l>>2];w=t[f>>2]|0;s=n;return w|0}function LR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=t[(t[a>>2]|0)+44>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+40>>2]|0)==2?(t[l>>2]=(t[l>>2]|0)+1,(t[l>>2]|0)>1&(t[o>>2]|0)!=0):0)ER(t[u>>2]|0,t[a>>2]|0,520,85584,t[(t[a>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0,0);t[c>>2]=t[(t[c>>2]|0)+36>>2]}t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}function DR(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[f>>2]|0)){gR(0,79472);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+64|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+4>>2]=16;t[(t[f>>2]|0)+40>>2]=t[(t[n>>2]|0)+40>>2];t[(t[f>>2]|0)+44>>2]=t[(t[n>>2]|0)+44>>2];e=TM(t[(t[n>>2]|0)+52>>2]|0)|0;t[(t[f>>2]|0)+52>>2]=e;if(t[(t[n>>2]|0)+60>>2]|0){e=Yl(t[(t[n>>2]|0)+60>>2]|0)|0;t[(t[f>>2]|0)+60>>2]=e}if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[f>>2]|0)+8>>2]=e}if(t[(t[n>>2]|0)+56>>2]|0){e=Yl(t[(t[n>>2]|0)+56>>2]|0)|0;t[(t[f>>2]|0)+56>>2]=e}if(t[(t[n>>2]|0)+48>>2]|0){e=Yl(t[(t[n>>2]|0)+48>>2]|0)|0;t[(t[f>>2]|0)+48>>2]=e}t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function CR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}RF(t[n>>2]|0,t[(t[f>>2]|0)+4>>2]|0);i=t[n>>2]|0;if(!(t[t[f>>2]>>2]|0)){NF(i,79672);s=r;return}else{NF(i,79664);CR(t[n>>2]|0,t[t[f>>2]>>2]|0);s=r;return}}function PR(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[t[r>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);
	if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function BR(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[f>>2]|0)){gR(0,79472);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if(t[t[n>>2]>>2]|0){e=Yl(t[t[n>>2]>>2]|0)|0;t[t[f>>2]>>2]=e}else t[t[f>>2]>>2]=0;if(t[(t[n>>2]|0)+4>>2]|0){e=Yl(t[(t[n>>2]|0)+4>>2]|0)|0;t[(t[f>>2]|0)+4>>2]=e}else t[(t[f>>2]|0)+4>>2]=0;if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[f>>2]|0)+8>>2]=e}else t[(t[f>>2]|0)+8>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function IR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;xM(t[f>>2]|0,t[n>>2]|0);s=r;return}function HR(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+20>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+20>>2]|0)+80>>2];do if((t[(t[r>>2]|0)+4>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)!=0:0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+4>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0)}while(0);do if((t[(t[r>>2]|0)+12>>2]|0)!=0?(t[(t[r>>2]|0)+12>>2]|0)!=0:0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+12>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0)}while(0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function xR(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=Aq(t[r>>2]|0)|0;if(!(t[n>>2]|0)){s=i;return}if(t[(t[n>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+4>>2]|0);if(t[(t[n>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0);s=i;return}function UR(e,i){e=e|0;i=i|0;var r=0;r=s;s=s+16|0;t[r+4>>2]=e;t[r>>2]=i;s=r;return 0}function zR(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}Fq(t[r>>2]|0);s=i;return}function jR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=t[u>>2];t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);if(!(tN(t[f>>2]|0,t[o>>2]|0)|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);while(1){if(!(uN(t[f>>2]|0,t[o>>2]|0)|0))break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}if(t[o>>2]|0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}return 0}function VR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=t[u>>2];t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);if(!(tN(t[f>>2]|0,t[o>>2]|0)|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);while(1){if(!(uN(t[f>>2]|0,t[o>>2]|0)|0))break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}e:while(1){if((t[o>>2]|0)!=32)break;while(1){if((t[o>>2]|0)!=32)break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}if(!(tN(t[f>>2]|0,t[o>>2]|0)|0)){b=12;break}t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);while(1){if(!(uN(t[f>>2]|0,t[o>>2]|0)|0))continue e;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}}if((b|0)==12){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}if(t[o>>2]|0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}return 0}function qR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=t[u>>2];t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);if(!(uN(t[f>>2]|0,t[o>>2]|0)|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);while(1){if(!(uN(t[f>>2]|0,t[o>>2]|0)|0))break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}if(t[o>>2]|0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}return 0}function YR(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=t[u>>2];t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);while(1){if((t[o>>2]|0)<256){if((t[o>>2]|0)!=32?!(9<=(t[o>>2]|0)&(t[o>>2]|0)<=10):0)b=(t[o>>2]|0)==13;else b=1;k=b&1}else k=0;if(!k)break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}if(!(uN(t[f>>2]|0,t[o>>2]|0)|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}while(1){if(!(uN(t[f>>2]|0,t[o>>2]|0)|0))break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}e:while(1){if((t[o>>2]|0)!=32){h=25;break}while(1){if((t[o>>2]|0)!=32)break;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}if(!(t[o>>2]|0)){h=19;break}if(!(uN(t[f>>2]|0,t[o>>2]|0)|0)){h=21;break}t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0);while(1){if(!(uN(t[f>>2]|0,t[o>>2]|0)|0))continue e;t[o>>2]=Mp(0,t[a>>2]|0,c)|0;t[a>>2]=(t[a>>2]|0)+(t[c>>2]|0)}}if((h|0)==19){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((h|0)==21){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else if((h|0)==25)if(t[o>>2]|0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}return 0}function GR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;t[f>>2]=e;t[u>>2]=i;t[n>>2]=r;if((t[(t[f>>2]|0)+40>>2]|0)!=2){s=n;return}f=t[u>>2]|0;t[f>>2]=(t[f>>2]|0)+1;s=n;return}function WR(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;o=s;s=s+64|0;c=o;l=o+56|0;b=o+52|0;k=o+48|0;h=o+44|0;w=o+40|0;d=o+36|0;v=o+32|0;m=o+28|0;_=o+24|0;p=o+20|0;E=o+16|0;S=o+12|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;t[E>>2]=0;do if(t[l>>2]|0){t[_>>2]=t[(t[l>>2]|0)+4>>2];t[E>>2]=t[t[l>>2]>>2];if((t[(t[l>>2]|0)+28>>2]|0)!=-1412623820?(t[(t[l>>2]|0)+28>>2]|0)!=-1412623819:0)break;t[S>>2]=(t[l>>2]|0)-(t[t[l>>2]>>2]|0);if((t[S>>2]|0)>0&(t[S>>2]|0)<250)t[p>>2]=t[t[l>>2]>>2]}while(0);l=t[m>>2]|0;m=t[_>>2]|0;_=t[E>>2]|0;E=t[p>>2]|0;p=t[b>>2]|0;b=t[k>>2]|0;k=t[w>>2]|0;S=t[v>>2]|0;a=t[d>>2]|0;u=t[h>>2]|0;h=t[d>>2]|0;d=t[v>>2]|0;t[c>>2]=t[w>>2];t[c+4>>2]=h;t[c+8>>2]=d;cp(l,m,_,E,p,23,b,2,0,0,k,S,0,a,0,u,c);s=o;return}function KR(e,i,r,f,a){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;o=s;s=s+64|0;c=o+48|0;l=o+44|0;b=o+40|0;k=o+36|0;h=o+32|0;w=o+28|0;d=o+24|0;v=o+20|0;m=o+16|0;_=o+12|0;p=o+8|0;E=o+52|0;S=o+4|0;g=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=a;t[d>>2]=1;a=t[h>>2]|0;do if((a|0)==5){t[v>>2]=h_(t[b>>2]|0,t[w>>2]|0)|0;if((t[v>>2]|0)==0?(t[(t[b>>2]|0)+40>>2]|0)==1:0){t[(t[b>>2]|0)+40>>2]=0;t[v>>2]=h_(t[b>>2]|0,t[w>>2]|0)|0}if(!(t[v>>2]|0)){ER(t[l>>2]|0,t[b>>2]|0,535,85248,t[k>>2]|0,t[w>>2]|0,0);t[d>>2]=0;break}if((t[(t[v>>2]|0)+48>>2]|0)!=3){ER(t[l>>2]|0,t[b>>2]|0,511,85304,t[k>>2]|0,t[w>>2]|0,0);t[d>>2]=0}}else if((a|0)==10){t[g>>2]=$M(t[(t[b>>2]|0)+44>>2]|0,t[w>>2]|0)|0;if((t[g>>2]|0)==0?(t[(t[b>>2]|0)+48>>2]|0)!=0:0)t[g>>2]=$M(t[(t[b>>2]|0)+48>>2]|0,t[w>>2]|0)|0;if(!(t[g>>2]|0)){ER(t[l>>2]|0,t[b>>2]|0,537,85488,t[k>>2]|0,t[w>>2]|0,0);t[d>>2]=0}}else if((a|0)==6){t[_>>2]=0;t[m>>2]=Yl(t[w>>2]|0)|0;if(!(t[m>>2]|0)){t[c>>2]=0;y=t[c>>2]|0;s=o;return y|0}t[p>>2]=t[m>>2];e:while(1){if(!(u[t[p>>2]>>0]|0))break;t[_>>2]=t[p>>2];while(1){if(u[t[p>>2]>>0]|0){do if((u[t[p>>2]>>0]|0|0)==32)F=1;else{if(9<=(u[t[p>>2]>>0]|0|0)?(u[t[p>>2]>>0]|0|0)<=10:0){F=1;break}F=(u[t[p>>2]>>0]|0|0)==13}while(0);O=F^1}else O=0;A=t[p>>2]|0;if(!O)break;t[p>>2]=A+1}n[E>>0]=n[A>>0]|0;n[t[p>>2]>>0]=0;t[S>>2]=h_(t[b>>2]|0,t[_>>2]|0)|0;if(t[S>>2]|0){if((t[(t[S>>2]|0)+48>>2]|0)!=3){ER(t[l>>2]|0,t[b>>2]|0,511,85424,t[k>>2]|0,t[_>>2]|0,0);t[d>>2]=0}}else{ER(t[l>>2]|0,t[b>>2]|0,535,85368,t[k>>2]|0,t[_>>2]|0,0);t[d>>2]=0}if(!(u[E>>0]|0))break;n[t[p>>2]>>0]=n[E>>0]|0;while(1){do if((u[t[p>>2]>>0]|0|0)!=32){if(9<=(u[t[p>>2]>>0]|0|0)?(u[t[p>>2]>>0]|0|0)<=10:0)break;if((u[t[p>>2]>>0]|0|0)!=13)continue e}while(0);t[p>>2]=(t[p>>2]|0)+1}}pAi[t[135736>>2]&511](t[m>>2]|0)}while(0);t[c>>2]=t[d>>2];y=t[c>>2]|0;s=o;return y|0}function XR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=jg(t[o>>2]|0,l)|0;e:do if(!(t[c>>2]|0)){i:while(1){if(!(t[a>>2]|0))break e;r=t[a>>2]|0;do if((t[t[a>>2]>>2]|0)==2){if((t[r+24>>2]|0)==0?(Xl(t[(t[a>>2]|0)+8>>2]|0,t[o>>2]|0)|0)!=0:0){b=6;break i}}else{if(((t[r>>2]|0)==4?(t[(t[a>>2]|0)+12>>2]|0)!=0:0)?(t[t[(t[a>>2]|0)+12>>2]>>2]|0)==2:0){if(t[(t[(t[a>>2]|0)+12>>2]|0)+24>>2]|0)break;if(Xl(t[(t[(t[a>>2]|0)+12>>2]|0)+8>>2]|0,t[o>>2]|0)|0){b=12;break i}else break}if((t[t[a>>2]>>2]|0)!=4){b=16;break i}if(!(t[(t[a>>2]|0)+12>>2]|0)){b=16;break i}if((t[t[(t[a>>2]|0)+12>>2]>>2]|0)!=1){b=16;break i}}while(0);t[a>>2]=t[(t[a>>2]|0)+16>>2]}if((b|0)==6){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else if((b|0)==12){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else if((b|0)==16){yR(0,519,83864,0);break}}else{i:while(1){if(!(t[a>>2]|0))break e;r=t[a>>2]|0;do if((t[t[a>>2]>>2]|0)==2){if(((t[r+24>>2]|0)!=0?(Jl(t[(t[a>>2]|0)+24>>2]|0,t[o>>2]|0,t[l>>2]|0)|0)==0:0)?(Xl(t[(t[a>>2]|0)+8>>2]|0,t[c>>2]|0)|0)!=0:0){b=23;break i}}else{if(((t[r>>2]|0)==4?(t[(t[a>>2]|0)+12>>2]|0)!=0:0)?(t[t[(t[a>>2]|0)+12>>2]>>2]|0)==2:0){if(!(t[(t[(t[a>>2]|0)+12>>2]|0)+24>>2]|0))break;if(Jl(t[(t[(t[a>>2]|0)+12>>2]|0)+24>>2]|0,t[o>>2]|0,t[l>>2]|0)|0)break;if(Xl(t[(t[(t[a>>2]|0)+12>>2]|0)+8>>2]|0,t[c>>2]|0)|0){b=30;break i}else break}if((t[t[a>>2]>>2]|0)!=4){b=34;break i}if(!(t[(t[a>>2]|0)+12>>2]|0)){b=34;break i}if((t[t[(t[a>>2]|0)+12>>2]>>2]|0)!=1){b=34;break i}}while(0);t[a>>2]=t[(t[a>>2]|0)+16>>2]}if((b|0)==23){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else if((b|0)==30){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else if((b|0)==34){yR(t[u>>2]|0,519,83864,0);break}}while(0);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}function ZR(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;t[k>>2]=0;if(!((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0)?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){if(t[l>>2]|0)t[t[l>>2]>>2]=0;if((t[(t[c>>2]|0)+36>>2]|0)!=0?(t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)t[k>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+12>>2];if((((t[k>>2]|0)!=0?(t[b>>2]=JM(t[(t[o>>2]|0)+44>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[k>>2]|0)|0,(t[b>>2]|0)==0):0)?(t[(t[o>>2]|0)+48>>2]|0)!=0:0)?(t[b>>2]=JM(t[(t[o>>2]|0)+48>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[k>>2]|0)|0,(t[b>>2]|0)!=0&(t[l>>2]|0)!=0):0)t[t[l>>2]>>2]=1;if((((t[b>>2]|0)==0?(t[b>>2]=ZM(t[(t[o>>2]|0)+44>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0,(t[b>>2]|0)==0):0)?(t[(t[o>>2]|0)+48>>2]|0)!=0:0)?(t[b>>2]=ZM(t[(t[o>>2]|0)+48>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0,(t[b>>2]|0)!=0&(t[l>>2]|0)!=0):0)t[t[l>>2]>>2]=1;if(!(t[b>>2]|0))ER(t[a>>2]|0,t[c>>2]|0,534,83832,t[(t[c>>2]|0)+8>>2]|0,0,0);t[u>>2]=t[b>>2];h=t[u>>2]|0;s=f;return h|0}t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}function JR(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!((t[(t[u>>2]|0)+48>>2]|0)!=0?(t[(t[u>>2]|0)+52>>2]|0)!=0:0))l=3;if((l|0)==3?(t[(t[u>>2]|0)+48>>2]=10,l=gAi[t[135744>>2]&511]((t[(t[u>>2]|0)+48>>2]|0)*12|0)|0,t[(t[u>>2]|0)+52>>2]=l,(t[(t[u>>2]|0)+52>>2]|0)==0):0){gR(t[u>>2]|0,79472);t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}do if((t[(t[u>>2]|0)+44>>2]|0)>=(t[(t[u>>2]|0)+48>>2]|0)){t[c>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+52>>2]|0,(t[(t[u>>2]|0)+48>>2]<<1)*12|0)|0;l=t[u>>2]|0;if(t[c>>2]|0){r=l+48|0;t[r>>2]=t[r>>2]<<1;t[(t[u>>2]|0)+52>>2]=t[c>>2];break}gR(l,85184);t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}while(0);t[(t[u>>2]|0)+40>>2]=(t[(t[u>>2]|0)+52>>2]|0)+((t[(t[u>>2]|0)+44>>2]|0)*12|0);t[(t[(t[u>>2]|0)+52>>2]|0)+((t[(t[u>>2]|0)+44>>2]|0)*12|0)>>2]=t[a>>2];t[(t[(t[u>>2]|0)+52>>2]|0)+((t[(t[u>>2]|0)+44>>2]|0)*12|0)+4>>2]=t[o>>2];do if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)==4:0){if(!(t[(t[a>>2]|0)+52>>2]|0))vM(t[u>>2]|0,t[a>>2]|0)|0;if(t[(t[a>>2]|0)+52>>2]|0){c=Ws(t[(t[a>>2]|0)+52>>2]|0,0,0)|0;t[(t[(t[u>>2]|0)+52>>2]|0)+((t[(t[u>>2]|0)+44>>2]|0)*12|0)+8>>2]=c;break}else{t[(t[(t[u>>2]|0)+52>>2]|0)+((t[(t[u>>2]|0)+44>>2]|0)*12|0)+8>>2]=0;ER(t[u>>2]|0,t[a>>2]|0,1,85200,t[(t[o>>2]|0)+8>>2]|0,0,0);break}}while(0);o=(t[u>>2]|0)+44|0;u=t[o>>2]|0;t[o>>2]=u+1;t[f>>2]=u;b=t[f>>2]|0;s=n;return b|0}function QR(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+44>>2]|0)<1){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+44|0;t[e>>2]=(t[e>>2]|0)+-1;t[f>>2]=t[(t[(t[n>>2]|0)+52>>2]|0)+((t[(t[n>>2]|0)+44>>2]|0)*12|0)>>2];t[(t[(t[n>>2]|0)+52>>2]|0)+((t[(t[n>>2]|0)+44>>2]|0)*12|0)>>2]=0;t[(t[(t[n>>2]|0)+52>>2]|0)+((t[(t[n>>2]|0)+44>>2]|0)*12|0)+4>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)==4:0)Ks(t[(t[(t[n>>2]|0)+52>>2]|0)+((t[(t[n>>2]|0)+44>>2]|0)*12|0)+8>>2]|0);t[(t[(t[n>>2]|0)+52>>2]|0)+((t[(t[n>>2]|0)+44>>2]|0)*12|0)+8>>2]=0;f=t[n>>2]|0;if((t[(t[n>>2]|0)+44>>2]|0)>=1)t[(t[n>>2]|0)+40>>2]=(t[(t[n>>2]|0)+52>>2]|0)+(((t[f+44>>2]|0)-1|0)*12|0);else t[f+40>>2]=0;t[r>>2]=t[(t[n>>2]|0)+44>>2];u=t[r>>2]|0;s=i;return u|0}function $R(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=1;if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0){t[b>>2]=t[(t[o>>2]|0)+12>>2];t[l>>2]=t[b>>2];e:while(1){if(!(t[l>>2]|0))break;switch(t[(t[l>>2]|0)+4>>2]|0){case 4:case 3:case 7:case 8:break;case 5:{if((t[(t[l>>2]|0)+12>>2]|0)!=0?(t[(t[(t[l>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){aN(t[u>>2]|0,t[l>>2]|0)|0;t[l>>2]=t[(t[(t[l>>2]|0)+12>>2]|0)+12>>2];continue e}break}default:{k=10;break e}}t[l>>2]=t[(t[l>>2]|0)+24>>2];while(1){if(t[l>>2]|0)continue e;t[l>>2]=oN(t[u>>2]|0)|0;if(!(t[l>>2]|0))continue e;t[l>>2]=t[(t[l>>2]|0)+24>>2]}}if((k|0)==10)t[c>>2]=0;t[(t[u>>2]|0)+20>>2]=0;t[(t[u>>2]|0)+16>>2]=0;if(t[(t[u>>2]|0)+24>>2]|0){pAi[t[135736>>2]&511](t[(t[u>>2]|0)+24>>2]|0);t[(t[u>>2]|0)+24>>2]=0}t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}function eN(e,i,r,f,u){e=e|0;i=i|0;r=r|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;a=s;s=s+10112|0;o=a+44|0;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;_=a+4|0;p=a+10048|0;E=a;S=a+5048|0;g=a+48|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=u;t[w>>2]=1;if((t[b>>2]|0)==0|(t[h>>2]|0)==0|(t[c>>2]|0)==0){t[o>>2]=-1;y=t[o>>2]|0;s=a;return y|0}t[v>>2]=t[(t[b>>2]|0)+40>>2];t[m>>2]=t[(t[b>>2]|0)+8>>2];if(!(t[(t[b>>2]|0)+52>>2]|0))t[w>>2]=vM(t[c>>2]|0,t[b>>2]|0)|0;if(!(t[(t[b>>2]|0)+52>>2]|0)){t[o>>2]=-1;y=t[o>>2]|0;s=a;return y|0}if(!(ib(t[(t[b>>2]|0)+52>>2]|0)|0)){t[o>>2]=-1;y=t[o>>2]|0;s=a;return y|0}t[(t[c>>2]|0)+20>>2]=0;t[(t[c>>2]|0)+16>>2]=0;t[(t[c>>2]|0)+24>>2]=0;t[_>>2]=Ws(t[(t[b>>2]|0)+52>>2]|0,0,0)|0;if(t[_>>2]|0){t[d>>2]=t[l>>2];e:while(1){if(!(t[d>>2]|0)){F=31;break}b=t[(t[d>>2]|0)+4>>2]|0;do if((b|0)==3){if(!(EF(t[d>>2]|0)|0)){F=17;break e}}else if((b|0)==1){if((t[(t[d>>2]|0)+36>>2]|0)!=0?(t[(t[(t[d>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[E>>2]=Ug(t[(t[d>>2]|0)+8>>2]|0,t[(t[(t[d>>2]|0)+36>>2]|0)+12>>2]|0,p,50)|0;if(!(t[E>>2]|0)){F=22;break e}t[w>>2]=Xs(t[_>>2]|0,t[E>>2]|0,0)|0;if((t[E>>2]|0)==(p|0))break;if((t[E>>2]|0)==(t[(t[d>>2]|0)+8>>2]|0))break;pAi[t[135736>>2]&511](t[E>>2]|0);break}t[w>>2]=Xs(t[_>>2]|0,t[(t[d>>2]|0)+8>>2]|0,0)|0}else if((b|0)==4){F=18;break e}else if(((b|0)==5?(t[(t[d>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[d>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){aN(t[c>>2]|0,t[d>>2]|0)|0;t[d>>2]=t[(t[(t[d>>2]|0)+12>>2]|0)+12>>2];continue e}while(0);t[d>>2]=t[(t[d>>2]|0)+24>>2];while(1){if(t[d>>2]|0)continue e;t[d>>2]=oN(t[c>>2]|0)|0;if(!(t[d>>2]|0))continue e;t[d>>2]=t[(t[d>>2]|0)+24>>2]}}if((F|0)==17)t[w>>2]=0;else if((F|0)==18)t[w>>2]=0;else if((F|0)==22)t[w>>2]=-1;else if((F|0)==31)t[w>>2]=Xs(t[_>>2]|0,0,0)|0;Ks(t[_>>2]|0)}if((t[k>>2]|0)!=0&(t[w>>2]|0)!=1&(t[w>>2]|0)!=-3){do if(t[c>>2]|0){n[S>>0]=0;mM(S,5e3,t[v>>2]|0,1);n[g>>0]=0;cN(g,5e3,t[l>>2]|0,1);k=t[c>>2]|0;_=t[h>>2]|0;if(t[m>>2]|0){ER(k,_,504,84936,t[m>>2]|0,S,g);break}else{ER(k,_,504,85008,S,g,0);break}}else{_=t[c>>2]|0;k=t[h>>2]|0;if(t[m>>2]|0){ER(_,k,504,85072,t[m>>2]|0,0,0);break}else{ER(_,k,504,85120,0,0,0);break}}while(0);t[w>>2]=0}if((t[w>>2]|0)==-3)t[w>>2]=1;t[(t[c>>2]|0)+20>>2]=0;t[(t[c>>2]|0)+16>>2]=0;if(t[(t[c>>2]|0)+24>>2]|0){pAi[t[135736>>2]&511](t[(t[c>>2]|0)+24>>2]|0);t[(t[c>>2]|0)+24>>2]=0}t[o>>2]=t[w>>2];y=t[o>>2]|0;s=a;return y|0}function iN(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}t[o>>2]=t[u>>2];t[o+4>>2]=t[a>>2];Mq(t[f>>2]|0,258,o);s=n;return}function rN(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[f>>2]=e;t[u>>2]=i;t[n+16>>2]=r;t[c>>2]=0;if(!(t[f>>2]|0)){s=n;return}r=t[(t[f>>2]|0)+40>>2]|0;e:do if((r|0)==5|(r|0)==6|(r|0)==10){if(((t[(t[f>>2]|0)+48>>2]|0)!=0?(t[a>>2]=KR(t[u>>2]|0,t[(t[u>>2]|0)+32>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+40>>2]|0,t[(t[f>>2]|0)+48>>2]|0)|0,(t[a>>2]|0)==0):0)?(t[(t[u>>2]|0)+36>>2]|0)==1:0)t[(t[u>>2]|0)+36>>2]=0;if(t[(t[f>>2]|0)+52>>2]|0){t[l>>2]=t[(t[f>>2]|0)+52>>2];while(1){if(!(t[l>>2]|0))break e;t[a>>2]=KR(t[u>>2]|0,t[(t[u>>2]|0)+32>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+40>>2]|0,t[(t[l>>2]|0)+4>>2]|0)|0;if((t[a>>2]|0)==0?(t[(t[u>>2]|0)+36>>2]|0)==1:0)t[(t[u>>2]|0)+36>>2]=0;t[l>>2]=t[t[l>>2]>>2]}}}while(0);if((t[(t[f>>2]|0)+40>>2]|0)!=10){s=n;return}t[o>>2]=t[(t[f>>2]|0)+32>>2];if(!(t[(t[f>>2]|0)+60>>2]|0)){yR(t[u>>2]|0,1,84584,t[(t[f>>2]|0)+8>>2]|0);s=n;return}if(t[o>>2]|0)t[c>>2]=ZM(t[(t[o>>2]|0)+44>>2]|0,t[(t[f>>2]|0)+60>>2]|0)|0;if((t[c>>2]|0)==0&(t[o>>2]|0)!=0)t[c>>2]=ZM(t[(t[o>>2]|0)+48>>2]|0,t[(t[f>>2]|0)+60>>2]|0)|0;if(((t[c>>2]|0)==0?(t[(t[f>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+20>>2]|0)+4>>2]|0)==14:0)t[c>>2]=ZM(t[(t[f>>2]|0)+20>>2]|0,t[(t[f>>2]|0)+60>>2]|0)|0;if(!(t[c>>2]|0)){ER(t[u>>2]|0,0,534,84640,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+60>>2]|0,0);s=n;return}if((t[(t[c>>2]|0)+36>>2]|0)!=1){s=n;return}ER(t[u>>2]|0,0,510,84696,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+60>>2]|0,0);t[(t[u>>2]|0)+36>>2]=0;s=n;return}function nN(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[n+8>>2]=r;if(!(t[f>>2]|0)){s=n;return}if((t[(t[f>>2]|0)+48>>2]|0)!=3){s=n;return}t[a>>2]=t[(t[f>>2]|0)+40>>2];if(!(t[a>>2]|0)){s=n;return}t[o>>2]=eR(t[u>>2]|0,t[(t[f>>2]|0)+32>>2]|0,t[a>>2]|0)|0;if((t[o>>2]|0)==1){s=n;return}t[(t[u>>2]|0)+36>>2]=0;s=n;return}function fN(e,i,r){e=e|0;i=i|0;r=r|0;r=s;s=s+16|0;t[r+4>>2]=e;t[r>>2]=i;s=r;return}function tN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+92>>2]&4|0)!=0:0){i=t[u>>2]|0;if((t[u>>2]|0)<256){if(((!(65<=(i|0)&(t[u>>2]|0)<=90)?!(97<=(t[u>>2]|0)&(t[u>>2]|0)<=122):0)?!(192<=(t[u>>2]|0)&(t[u>>2]|0)<=214):0)?!(216<=(t[u>>2]|0)&(t[u>>2]|0)<=246|248<=(t[u>>2]|0)):0)a=24}else if(!(dj(i,199744)|0))a=24;do if((a|0)==24){i=t[u>>2]|0;if((t[u>>2]|0)<256)if((i|0)==95|(t[u>>2]|0)==58)break;else break e;if(!(19968<=(i|0)&(t[u>>2]|0)<=40869|(t[u>>2]|0)==12295)?!(12321<=(t[u>>2]|0)&(t[u>>2]|0)<=12329|(t[u>>2]|0)==95|(t[u>>2]|0)==58):0)break e}while(0);t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}else a=3;while(0);do if((a|0)==3){if(((((((((((((!((t[u>>2]|0)>=97&(t[u>>2]|0)<=122)?!((t[u>>2]|0)>=65&(t[u>>2]|0)<=90|(t[u>>2]|0)==95|(t[u>>2]|0)==58):0)?!((t[u>>2]|0)>=192&(t[u>>2]|0)<=214):0)?!((t[u>>2]|0)>=216&(t[u>>2]|0)<=246):0)?!((t[u>>2]|0)>=248&(t[u>>2]|0)<=767):0)?!((t[u>>2]|0)>=880&(t[u>>2]|0)<=893):0)?!((t[u>>2]|0)>=895&(t[u>>2]|0)<=8191):0)?!((t[u>>2]|0)>=8204&(t[u>>2]|0)<=8205):0)?!((t[u>>2]|0)>=8304&(t[u>>2]|0)<=8591):0)?!((t[u>>2]|0)>=11264&(t[u>>2]|0)<=12271):0)?!((t[u>>2]|0)>=12289&(t[u>>2]|0)<=55295):0)?!((t[u>>2]|0)>=63744&(t[u>>2]|0)<=64975):0)?!((t[u>>2]|0)>=65008&(t[u>>2]|0)<=65533):0)?!((t[u>>2]|0)>=65536&(t[u>>2]|0)<=983039):0)break;t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}while(0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function uN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;e:do if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+92>>2]&4|0)!=0:0){i=t[u>>2]|0;if((t[u>>2]|0)<256){if(((!(65<=(i|0)&(t[u>>2]|0)<=90)?!(97<=(t[u>>2]|0)&(t[u>>2]|0)<=122):0)?!(192<=(t[u>>2]|0)&(t[u>>2]|0)<=214):0)?!(216<=(t[u>>2]|0)&(t[u>>2]|0)<=246|248<=(t[u>>2]|0)):0)a=27}else if(!(dj(i,199744)|0))a=27;do if((a|0)==27){if((t[u>>2]|0)>=256){if(19968<=(t[u>>2]|0)&(t[u>>2]|0)<=40869|(t[u>>2]|0)==12295)break;if(12321<=(t[u>>2]|0)&(t[u>>2]|0)<=12329)break}i=t[u>>2]|0;if((t[u>>2]|0)<256){if(48<=(i|0)&(t[u>>2]|0)<=57|(t[u>>2]|0)==46|(t[u>>2]|0)==45|(t[u>>2]|0)==95|(t[u>>2]|0)==58)break}else{e=(dj(i,200216)|0)!=0;if(e|(t[u>>2]|0)==46|(t[u>>2]|0)==45|(t[u>>2]|0)==95|(t[u>>2]|0)==58)break}if((t[u>>2]|0)>=256?(dj(t[u>>2]|0,200144)|0)!=0:0)break;e=t[u>>2]|0;if((t[u>>2]|0)<256)if((e|0)==183)break;else break e;else if(dj(e,200272)|0)break;else break e}while(0);t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}else a=3;while(0);do if((a|0)==3){if((((((((((((((((!((t[u>>2]|0)>=97&(t[u>>2]|0)<=122)?!((t[u>>2]|0)>=65&(t[u>>2]|0)<=90):0)?!((t[u>>2]|0)>=48&(t[u>>2]|0)<=57|(t[u>>2]|0)==95|(t[u>>2]|0)==58|(t[u>>2]|0)==45|(t[u>>2]|0)==46|(t[u>>2]|0)==183):0)?!((t[u>>2]|0)>=192&(t[u>>2]|0)<=214):0)?!((t[u>>2]|0)>=216&(t[u>>2]|0)<=246):0)?!((t[u>>2]|0)>=248&(t[u>>2]|0)<=767):0)?!((t[u>>2]|0)>=768&(t[u>>2]|0)<=879):0)?!((t[u>>2]|0)>=880&(t[u>>2]|0)<=893):0)?!((t[u>>2]|0)>=895&(t[u>>2]|0)<=8191):0)?!((t[u>>2]|0)>=8204&(t[u>>2]|0)<=8205):0)?!((t[u>>2]|0)>=8255&(t[u>>2]|0)<=8256):0)?!((t[u>>2]|0)>=8304&(t[u>>2]|0)<=8591):0)?!((t[u>>2]|0)>=11264&(t[u>>2]|0)<=12271):0)?!((t[u>>2]|0)>=12289&(t[u>>2]|0)<=55295):0)?!((t[u>>2]|0)>=63744&(t[u>>2]|0)<=64975):0)?!((t[u>>2]|0)>=65008&(t[u>>2]|0)<=65533):0)?!((t[u>>2]|0)>=65536&(t[u>>2]|0)<=983039):0)break;t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}while(0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function aN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[f>>2]|0)+20>>2]|0)<=0?(t[(t[f>>2]|0)+20>>2]=4,i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+20>>2]<<2)|0,t[(t[f>>2]|0)+24>>2]=i,(t[(t[f>>2]|0)+24>>2]|0)==0):0){gR(t[f>>2]|0,79472);t[(t[f>>2]|0)+20>>2]=0;t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}do if((t[(t[f>>2]|0)+16>>2]|0)>=(t[(t[f>>2]|0)+20>>2]|0)){t[a>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+24>>2]|0,t[(t[f>>2]|0)+20>>2]<<1<<2)|0;i=t[f>>2]|0;if(t[a>>2]|0){e=i+20|0;t[e>>2]=t[e>>2]<<1;t[(t[f>>2]|0)+24>>2]=t[a>>2];break}gR(i,85184);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}while(0);t[(t[(t[f>>2]|0)+24>>2]|0)+(t[(t[f>>2]|0)+16>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+12>>2]=t[u>>2];u=(t[f>>2]|0)+16|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;o=t[n>>2]|0;s=r;return o|0}function oN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+16>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+16>>2]|0)>0)t[(t[n>>2]|0)+12>>2]=t[(t[(t[n>>2]|0)+24>>2]|0)+((t[e+16>>2]|0)-1<<2)>>2];else t[e+12>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+24>>2]|0)+(t[(t[n>>2]|0)+16>>2]<<2)>>2];t[(t[(t[n>>2]|0)+24>>2]|0)+(t[(t[n>>2]|0)+16>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function cN(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+20|0;o=u+16|0;c=u+12|0;l=u+8|0;b=u+4|0;k=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=f;if(!(t[c>>2]|0)){s=u;return}if(t[l>>2]|0)xY(t[a>>2]|0,79632)|0;t[b>>2]=t[c>>2];e:while(1){if(!(t[b>>2]|0)){h=30;break}t[k>>2]=HY(t[a>>2]|0)|0;if(((t[o>>2]|0)-(t[k>>2]|0)|0)<50){h=7;break}switch(t[(t[b>>2]|0)+4>>2]|0){case 3:{if(!(EF(t[b>>2]|0)|0))h=25;break}case 1:{if((t[(t[b>>2]|0)+36>>2]|0)!=0?(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c=(t[o>>2]|0)-(t[k>>2]|0)|0;if((c|0)<((rs(t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0)+10|0)){h=14;break e}xY(t[a>>2]|0,t[(t[(t[b>>2]|0)+36>>2]|0)+12>>2]|0)|0;xY(t[a>>2]|0,79648)|0}if(((t[o>>2]|0)-(t[k>>2]|0)|0)<((rs(t[(t[b>>2]|0)+8>>2]|0)|0)+10|0)){h=19;break e}xY(t[a>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0;if(t[(t[b>>2]|0)+24>>2]|0)xY(t[a>>2]|0,80064)|0;break}case 18:case 12:case 11:case 10:case 13:case 21:case 9:case 2:{xY(t[a>>2]|0,85176)|0;if(t[(t[b>>2]|0)+24>>2]|0)xY(t[a>>2]|0,80064)|0;break}case 5:case 4:{h=25;break}default:{}}if((h|0)==25?(h=0,xY(t[a>>2]|0,85168)|0,(t[(t[b>>2]|0)+24>>2]|0)!=0):0)xY(t[a>>2]|0,80064)|0;t[b>>2]=t[(t[b>>2]|0)+24>>2]}if((h|0)==7){if(((t[o>>2]|0)-(t[k>>2]|0)|0)<=4){s=u;return}if((n[(t[a>>2]|0)+((t[k>>2]|0)-1)>>0]|0)==46){s=u;return}xY(t[a>>2]|0,79624)|0;s=u;return}else if((h|0)==14){if(((t[o>>2]|0)-(t[k>>2]|0)|0)<=4){s=u;return}if((n[(t[a>>2]|0)+((t[k>>2]|0)-1)>>0]|0)==46){s=u;return}xY(t[a>>2]|0,79624)|0;s=u;return}else if((h|0)==19){if(((t[o>>2]|0)-(t[k>>2]|0)|0)<=4){s=u;return}if((n[(t[a>>2]|0)+((t[k>>2]|0)-1)>>0]|0)==46){s=u;return}xY(t[a>>2]|0,79624)|0;s=u;return}else if((h|0)==30){if(!(t[l>>2]|0)){s=u;return}xY(t[a>>2]|0,79672)|0;s=u;return}}function lN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[f>>2];sN(t[n>>2]|0,t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+4>>2]|0);s=r;return 1}function sN(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;f=s;s=s+48|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+45|0;v=f+8|0;m=f+4|0;_=f;p=f+44|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if(!(t[a>>2]|0)){s=f;return}if((t[(t[a>>2]|0)+8>>2]|0)==0?(t[(t[a>>2]|0)+12>>2]|0)==0:0){s=f;return}t[b>>2]=t[(t[a>>2]|0)+8>>2];if(!(t[b>>2]|0)){t[h>>2]=0;t[k>>2]=Yl(t[c>>2]|0)|0;if(!(t[k>>2]|0)){t[(t[o>>2]|0)+36>>2]=0;s=f;return}t[w>>2]=t[k>>2];e:while(1){if(!(u[t[w>>2]>>0]|0))break;t[h>>2]=t[w>>2];while(1){if(u[t[w>>2]>>0]|0){do if((u[t[w>>2]>>0]|0|0)==32)E=1;else{if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0){E=1;break}E=(u[t[w>>2]>>0]|0|0)==13}while(0);S=E^1}else S=0;g=t[w>>2]|0;if(!S)break;t[w>>2]=g+1}n[d>>0]=n[g>>0]|0;n[t[w>>2]>>0]=0;t[l>>2]=GM(t[(t[o>>2]|0)+32>>2]|0,t[h>>2]|0)|0;if(!(t[l>>2]|0)){WR(t[o>>2]|0,0,536,84752,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0,t[h>>2]|0);t[(t[o>>2]|0)+36>>2]=0}if(!(u[d>>0]|0))break;n[t[w>>2]>>0]=n[d>>0]|0;while(1){do if((u[t[w>>2]>>0]|0|0)!=32){if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0)break;if((u[t[w>>2]>>0]|0|0)!=13)continue e}while(0);t[w>>2]=(t[w>>2]|0)+1}}pAi[t[135736>>2]&511](t[k>>2]|0);s=f;return}if((t[(t[b>>2]|0)+40>>2]|0)==3){t[l>>2]=GM(t[(t[o>>2]|0)+32>>2]|0,t[c>>2]|0)|0;if(t[l>>2]|0){s=f;return}ER(t[o>>2]|0,t[(t[b>>2]|0)+20>>2]|0,536,84808,t[(t[b>>2]|0)+8>>2]|0,t[c>>2]|0,0);t[(t[o>>2]|0)+36>>2]=0;s=f;return}if((t[(t[b>>2]|0)+40>>2]|0)!=4){s=f;return}t[m>>2]=0;t[v>>2]=Yl(t[c>>2]|0)|0;if(!(t[v>>2]|0)){gR(t[o>>2]|0,84864);t[(t[o>>2]|0)+36>>2]=0;s=f;return}t[_>>2]=t[v>>2];e:while(1){if(!(u[t[_>>2]>>0]|0))break;t[m>>2]=t[_>>2];while(1){if(u[t[_>>2]>>0]|0){do if((u[t[_>>2]>>0]|0|0)==32)y=1;else{if(9<=(u[t[_>>2]>>0]|0|0)?(u[t[_>>2]>>0]|0|0)<=10:0){y=1;break}y=(u[t[_>>2]>>0]|0|0)==13}while(0);F=y^1}else F=0;O=t[_>>2]|0;if(!F)break;t[_>>2]=O+1}n[p>>0]=n[O>>0]|0;n[t[_>>2]>>0]=0;t[l>>2]=GM(t[(t[o>>2]|0)+32>>2]|0,t[m>>2]|0)|0;if(!(t[l>>2]|0)){ER(t[o>>2]|0,t[(t[b>>2]|0)+20>>2]|0,536,84880,t[(t[b>>2]|0)+8>>2]|0,t[m>>2]|0,0);t[(t[o>>2]|0)+36>>2]=0}if(!(u[p>>0]|0))break;n[t[_>>2]>>0]=n[p>>0]|0;while(1){do if((u[t[_>>2]>>0]|0|0)!=32){if(9<=(u[t[_>>2]>>0]|0|0)?(u[t[_>>2]>>0]|0|0)<=10:0)break;if((u[t[_>>2]>>0]|0|0)!=13)continue e}while(0);t[_>>2]=(t[_>>2]|0)+1}}pAi[t[135736>>2]&511](t[v>>2]|0);s=f;return}function bN(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=0;if(t[21466]|0){s=e;return}t[i>>2]=0;while(1){if((t[i>>2]|0)>=100)break;t[85872+(t[i>>2]<<2)>>2]=0;t[i>>2]=(t[i>>2]|0)+1}t[i>>2]=0;e:while(1){if(!((t[i>>2]|0)<99?(t[86272+(t[r>>2]<<2)>>2]|0)!=0:0))break;n=86272+(t[r>>2]<<2)|0;f=t[i>>2]|0;t[i>>2]=f+1;t[85872+(f<<2)>>2]=n;while(1){n=(t[86272+(t[r>>2]<<2)>>2]|0)!=0;t[r>>2]=(t[r>>2]|0)+1;if(!n)continue e}}t[21466]=1;s=e;return}function kN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;while(1){if((t[f>>2]|0)>>>0>=92){u=6;break}e=(Ql(t[n>>2]|0,t[87848+((t[f>>2]|0)*36|0)>>2]|0)|0)!=0;a=t[f>>2]|0;if(!e){u=4;break}t[f>>2]=a+1}if((u|0)==4){t[r>>2]=87848+(a*36|0);o=t[r>>2]|0;s=i;return o|0}else if((u|0)==6){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}return 0}function hN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;while(1){if((t[f>>2]|0)>>>0>=253){u=6;break}e=(Xl(t[n>>2]|0,t[91164+((t[f>>2]|0)*12|0)>>2]|0)|0)!=0;a=t[f>>2]|0;if(e){u=4;break}t[f>>2]=a+1}if((u|0)==4){t[r>>2]=91160+(a*12|0);o=t[r>>2]|0;s=i;return o|0}else if((u|0)==6){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}return 0}function wN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;while(1){if((t[f>>2]|0)>>>0>=253)break;u=t[f>>2]|0;if((t[91160+((t[f>>2]|0)*12|0)>>2]|0)>>>0>=(t[n>>2]|0)>>>0){a=4;break}t[f>>2]=u+1}if((a|0)==4?(t[91160+(u*12|0)>>2]|0)>>>0<=(t[n>>2]|0)>>>0:0){t[r>>2]=91160+((t[f>>2]|0)*12|0);o=t[r>>2]|0;s=i;return o|0}t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}function dN(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;a=s;s=s+96|0;o=a;c=a+64|0;l=a+60|0;b=a+56|0;k=a+52|0;h=a+48|0;w=a+44|0;d=a+40|0;v=a+36|0;m=a+32|0;_=a+28|0;p=a+24|0;E=a+20|0;S=a+16|0;g=a+12|0;y=a+8|0;F=a+4|0;O=a+72|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=t[k>>2];t[v>>2]=t[l>>2];t[m>>2]=t[k>>2];if((t[l>>2]|0)==0|(t[b>>2]|0)==0|(t[h>>2]|0)==0){t[c>>2]=-1;A=t[c>>2]|0;s=a;return A|0}if(!(t[k>>2]|0)){t[t[b>>2]>>2]=0;t[t[h>>2]>>2]=0;t[c>>2]=0;A=t[c>>2]|0;s=a;return A|0}t[_>>2]=(t[k>>2]|0)+(t[t[h>>2]>>2]|0);t[d>>2]=(t[l>>2]|0)+(t[t[b>>2]>>2]|0);e:while(1){if((t[k>>2]|0)>>>0>=(t[_>>2]|0)>>>0){M=32;break}f=t[k>>2]|0;t[k>>2]=f+1;t[E>>2]=u[f>>0];f=t[E>>2]|0;do if((t[E>>2]|0)>>>0<128){t[p>>2]=f;t[S>>2]=0}else{if(f>>>0<192){M=10;break e}r=t[E>>2]|0;if((t[E>>2]|0)>>>0<224){t[p>>2]=r&31;t[S>>2]=1;break}i=t[E>>2]|0;if(r>>>0<240){t[p>>2]=i&15;t[S>>2]=2;break}if(i>>>0>=248){M=17;break e}t[p>>2]=t[E>>2]&7;t[S>>2]=3}while(0);if(((t[_>>2]|0)-(t[k>>2]|0)|0)<(t[S>>2]|0)){M=32;break}while(1){if(!(t[S>>2]|0))break;if((t[k>>2]|0)>>>0>=(t[_>>2]|0)>>>0)break;f=t[k>>2]|0;t[k>>2]=f+1;i=u[f>>0]|0;t[E>>2]=i;if((i&192|0)!=128)break;t[p>>2]=t[p>>2]<<6;t[p>>2]=t[p>>2]|t[E>>2]&63;t[S>>2]=(t[S>>2]|0)+-1}if((t[p>>2]|0)>>>0<128){if(((t[l>>2]|0)+1|0)>>>0>=(t[d>>2]|0)>>>0){M=32;break}i=t[p>>2]&255;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=i}else{t[y>>2]=wN(t[p>>2]|0)|0;if(!(t[y>>2]|0)){t[o>>2]=t[p>>2];SY(O,16,94200,o)|0;t[F>>2]=O}else t[F>>2]=t[(t[y>>2]|0)+4>>2];t[g>>2]=HY(t[F>>2]|0)|0;if(((t[l>>2]|0)+2+(t[g>>2]|0)|0)>>>0>=(t[d>>2]|0)>>>0){M=32;break}i=t[l>>2]|0;t[l>>2]=i+1;n[i>>0]=38;YY(t[l>>2]|0,t[F>>2]|0,t[g>>2]|0)|0;t[l>>2]=(t[l>>2]|0)+(t[g>>2]|0);i=t[l>>2]|0;t[l>>2]=i+1;n[i>>0]=59}t[w>>2]=t[k>>2]}if((M|0)==10){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[v>>2]|0);t[t[h>>2]>>2]=(t[w>>2]|0)-(t[m>>2]|0);t[c>>2]=-2;A=t[c>>2]|0;s=a;return A|0}else if((M|0)==17){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[v>>2]|0);t[t[h>>2]>>2]=(t[w>>2]|0)-(t[m>>2]|0);t[c>>2]=-2;A=t[c>>2]|0;s=a;return A|0}else if((M|0)==32){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[v>>2]|0);t[t[h>>2]>>2]=(t[w>>2]|0)-(t[m>>2]|0);t[c>>2]=0;A=t[c>>2]|0;s=a;return A|0}return 0}function vN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](96)|0;if(!(t[a>>2]|0)){CN(0,94208);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+96|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));
	t[(t[a>>2]|0)+4>>2]=13;t[(t[a>>2]|0)+56>>2]=0;t[(t[a>>2]|0)+44>>2]=0;t[(t[a>>2]|0)+32>>2]=t[a>>2];t[(t[a>>2]|0)+8>>2]=0;t[(t[a>>2]|0)+12>>2]=0;t[(t[a>>2]|0)+48>>2]=0;t[(t[a>>2]|0)+52>>2]=0;t[(t[a>>2]|0)+60>>2]=0;t[(t[a>>2]|0)+40>>2]=1;t[(t[a>>2]|0)+36>>2]=0;t[(t[a>>2]|0)+64>>2]=0;t[(t[a>>2]|0)+68>>2]=0;t[t[a>>2]>>2]=0;t[(t[a>>2]|0)+76>>2]=1;t[(t[a>>2]|0)+92>>2]=160;if((t[u>>2]|0)!=0|(t[f>>2]|0)!=0)$g(t[a>>2]|0,94240,t[u>>2]|0,t[f>>2]|0)|0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function mN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=0;if(t[a>>2]|0)t[t[a>>2]>>2]=0;if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0){do if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38){Op(t[f>>2]|0);t[o>>2]=PN(t[f>>2]|0)|0;i=t[f>>2]|0;if(!(t[o>>2]|0)){BN(i,68,94336,0,0);break}if((t[i+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[f>>2]|0)+36>>2]|0,250)|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=59){BN(t[f>>2]|0,23,94368,0,0);if(!(t[a>>2]|0))break;t[t[a>>2]>>2]=t[o>>2];break}if(t[a>>2]|0)t[t[a>>2]>>2]=t[o>>2];t[c>>2]=hN(t[o>>2]|0)|0;if(t[c>>2]|0)Op(t[f>>2]|0)}while(0);t[n>>2]=t[c>>2];l=t[n>>2]|0;s=r;return l|0}t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}function _N(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=0;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+36>>2]|0)!=0:0){do if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0){if((u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=120?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=88:0){a=23;break}e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+3;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+3;e:while(1){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=48?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=57:0)t[f>>2]=(t[f>>2]<<4)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);else a=13;do if((a|0)==13){a=0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=97?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=102:0){t[f>>2]=(t[f>>2]<<4)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-97)+10;break}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<65){a=19;break e}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>70){a=19;break e}t[f>>2]=(t[f>>2]<<4)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-65)+10}while(0);Op(t[n>>2]|0)}if((a|0)==19)BN(t[n>>2]|0,6,94448,0,0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)Op(t[n>>2]|0)}else a=23;while(0);do if((a|0)==23){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0){e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+2;e=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+2;while(1){if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<48){a=30;break}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>57){a=30;break}t[f>>2]=((t[f>>2]|0)*10|0)+((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);Op(t[n>>2]|0)}if((a|0)==30)BN(t[n>>2]|0,7,94448,0,0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=59)break;Op(t[n>>2]|0);break}BN(t[n>>2]|0,8,94488,0,0)}while(0);e=t[f>>2]|0;if((t[f>>2]|0)<256)if(9<=(e|0)&(t[f>>2]|0)<=10|(t[f>>2]|0)==13|32<=(t[f>>2]|0))a=39;else a=40;else if((!(256<=(e|0)&(t[f>>2]|0)<=55295)?!(57344<=(t[f>>2]|0)&(t[f>>2]|0)<=65533):0)?!(65536<=(t[f>>2]|0)&(t[f>>2]|0)<=1114111):0)a=40;else a=39;if((a|0)==39){t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}else if((a|0)==40){IN(t[n>>2]|0,9,94528,t[f>>2]|0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}}BN(t[n>>2]|0,1,94408,0,0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}function pN(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}zN(t[r>>2]|0);s=i;return}function EN(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+32|0;r=i+12|0;f=i+8|0;a=i+16|0;o=i+4|0;c=i;t[f>>2]=e;rS();fj();if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0){t[(t[f>>2]|0)+32>>2]=1;t[(t[f>>2]|0)+280>>2]=1;if((t[(t[f>>2]|0)+292>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[f>>2]|0)+36>>2]|0,250)|0;if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+44>>2]|0)!=0:0)EAi[t[(t[t[f>>2]>>2]|0)+44>>2]&511](t[(t[f>>2]|0)+4>>2]|0,136080);if((t[(t[f>>2]|0)+24>>2]|0)==0?((t[(t[(t[f>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0){if(t[(t[f>>2]|0)+176>>2]|0)l=-1;else l=u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;n[a>>0]=l;n[a+1>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;n[a+2>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;n[a+3>>0]=n[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;t[o>>2]=L_(a,4)|0;if(t[o>>2]|0)Tp(t[f>>2]|0,t[o>>2]|0)|0}jN(t[f>>2]|0)|0;if(!(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))BN(t[f>>2]|0,4,94672,0,0);if(((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+48>>2]|0)!=0:0)?(t[(t[f>>2]|0)+212>>2]|0)==0:0)pAi[t[(t[t[f>>2]>>2]|0)+48>>2]&511](t[(t[f>>2]|0)+4>>2]|0);while(1){if((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)b=1;else if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60)b=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63;else b=0;k=t[f>>2]|0;if(!b)break;VN(k);qN(t[f>>2]|0);jN(t[f>>2]|0)|0}if(((((((((u[t[(t[k+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)==80:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)==69:0)YN(t[f>>2]|0);jN(t[f>>2]|0)|0;while(1){if((((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)h=1;else if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60)h=(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63;else h=0;w=t[f>>2]|0;if(!h)break;VN(w);qN(t[f>>2]|0);jN(t[f>>2]|0)|0}zN(w);if(!(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))UN(t[f>>2]|0);if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+52>>2]|0)!=0:0)pAi[t[(t[t[f>>2]>>2]|0)+52>>2]&511](t[(t[f>>2]|0)+4>>2]|0);if(((t[(t[f>>2]|0)+360>>2]&4|0)==0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0)?(t[c>>2]=Qg(t[(t[f>>2]|0)+8>>2]|0)|0,(t[c>>2]|0)==0):0){c=$g(t[(t[f>>2]|0)+8>>2]|0,94240,94296,94248)|0;t[(t[(t[f>>2]|0)+8>>2]|0)+44>>2]=c}if(t[(t[f>>2]|0)+12>>2]|0){t[r>>2]=0;d=t[r>>2]|0;s=i;return d|0}else{t[r>>2]=-1;d=t[r>>2]|0;s=i;return d|0}}BN(t[f>>2]|0,1,94632,0,0);t[r>>2]=1;d=t[r>>2]|0;s=i;return d|0}function SN(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;Up(t[r>>2]|0);s=i;return}function gN(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](472)|0;do if(t[r>>2]|0){VY(t[r>>2]|0,0,472)|0;n=(GN(t[r>>2]|0)|0)<0;f=t[r>>2]|0;if(n){SN(f);t[i>>2]=0;break}else{t[i>>2]=f;break}}else{CN(0,94696);t[i>>2]=0}while(0);s=e;return t[i>>2]|0}function yN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){if((t[u>>2]|0)<=0){t[n>>2]=0;break}t[a>>2]=gN()|0;if(!(t[a>>2]|0)){t[n>>2]=0;break}t[c>>2]=GO(t[f>>2]|0,t[u>>2]|0,0)|0;if(!(t[c>>2]|0)){t[n>>2]=0;break}t[o>>2]=Cp(t[a>>2]|0)|0;if(!(t[o>>2]|0)){Up(t[a>>2]|0);t[n>>2]=0;break}else{t[(t[o>>2]|0)+4>>2]=0;t[t[o>>2]>>2]=t[c>>2];zs(t[(t[c>>2]|0)+16>>2]|0,t[o>>2]|0)|0;eE(t[a>>2]|0,t[o>>2]|0)|0;t[n>>2]=t[a>>2];break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function FN(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;f=s;s=s+48|0;u=f+44|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+8|0;v=f+4|0;m=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)!=0:0){do if((((t[c>>2]|0)>0&(t[o>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[a>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)!=-1:0){t[b>>2]=js(t[(t[t[(t[a>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+36>>2]|0)|0;t[k>>2]=(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0);t[h>>2]=ZO(t[t[(t[a>>2]|0)+36>>2]>>2]|0,t[c>>2]|0,t[o>>2]|0)|0;n=t[a>>2]|0;if((t[h>>2]|0)>=0){Vs(t[(t[t[n+36>>2]>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+36>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;break}t[n+84>>2]=-1;t[(t[a>>2]|0)+212>>2]=1;t[u>>2]=-1;_=t[u>>2]|0;s=f;return _|0}else p=11;while(0);do if(((((((p|0)==11?(t[(t[a>>2]|0)+172>>2]|0)!=-1:0)?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[a>>2]|0)+36>>2]>>2]|0)!=0:0)?(t[w>>2]=t[t[(t[a>>2]|0)+36>>2]>>2],(t[(t[w>>2]|0)+12>>2]|0)!=0):0)?(t[(t[w>>2]|0)+16>>2]|0)!=0:0)?(t[(t[w>>2]|0)+20>>2]|0)!=0:0){t[v>>2]=js(t[(t[w>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+36>>2]|0)|0;t[m>>2]=(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0);t[d>>2]=Y_(t[w>>2]|0,t[l>>2]|0)|0;if((t[d>>2]|0)>=0){Vs(t[(t[w>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+36>>2]|0,t[v>>2]|0,t[m>>2]|0)|0;break}BN(t[a>>2]|0,81,94760,0,0);t[u>>2]=81;_=t[u>>2]|0;s=f;return _|0}while(0);WN(t[a>>2]|0,t[l>>2]|0)|0;if(t[l>>2]|0){if(((t[(t[a>>2]|0)+172>>2]|0)!=-1?(t[(t[a>>2]|0)+172>>2]|0)!=14:0)?(t[(t[a>>2]|0)+172>>2]|0)!=1:0){t[(t[a>>2]|0)+84>>2]=5;t[(t[a>>2]|0)+12>>2]=0}if(((t[(t[a>>2]|0)+172>>2]|0)!=-1?(t[t[a>>2]>>2]|0)!=0:0)?(t[(t[t[a>>2]>>2]|0)+52>>2]|0)!=0:0)pAi[t[(t[t[a>>2]>>2]|0)+52>>2]&511](t[(t[a>>2]|0)+4>>2]|0);t[(t[a>>2]|0)+172>>2]=-1}t[u>>2]=t[(t[a>>2]|0)+84>>2];_=t[u>>2]|0;s=f;return _|0}BN(t[a>>2]|0,1,94728,0,0);t[u>>2]=1;_=t[u>>2]|0;s=f;return _|0}function ON(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+48|0;o=a+44|0;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;_=a+4|0;p=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;rS();t[m>>2]=CO(t[w>>2]|0)|0;if(!(t[m>>2]|0)){t[o>>2]=0;E=t[o>>2]|0;s=a;return E|0}t[d>>2]=gN()|0;if(!(t[d>>2]|0)){IO(t[m>>2]|0);t[o>>2]=0;E=t[o>>2]|0;s=a;return E|0}if(!((t[w>>2]|0)!=1?(t[(t[m>>2]|0)+12>>2]|0)==0:0))t[(t[d>>2]|0)+256>>2]=1;do if(t[c>>2]|0){if((t[t[d>>2]>>2]|0)!=136096)pAi[t[135736>>2]&511](t[t[d>>2]>>2]|0);w=gAi[t[135744>>2]&511](128)|0;t[t[d>>2]>>2]=w;if(!(t[t[d>>2]>>2]|0)){pAi[t[135736>>2]&511](t[m>>2]|0);pAi[t[135736>>2]&511](t[d>>2]|0);t[o>>2]=0;E=t[o>>2]|0;s=a;return E|0}else{w=(t[t[d>>2]>>2]|0)+0|0;u=(t[c>>2]|0)+0|0;f=w+128|0;do{t[w>>2]=t[u>>2];w=w+4|0;u=u+4|0}while((w|0)<(f|0));if(!(t[l>>2]|0))break;t[(t[d>>2]|0)+4>>2]=t[l>>2];break}}while(0);if(!(t[h>>2]|0))t[(t[d>>2]|0)+180>>2]=0;else{l=rA(t[h>>2]|0)|0;t[(t[d>>2]|0)+180>>2]=l}t[v>>2]=KN(t[d>>2]|0)|0;if(!(t[v>>2]|0)){Up(t[d>>2]|0);pAi[t[135736>>2]&511](t[m>>2]|0);t[o>>2]=0;E=t[o>>2]|0;s=a;return E|0}if(!(t[h>>2]|0))t[(t[v>>2]|0)+4>>2]=0;else{l=KA(t[h>>2]|0)|0;t[(t[v>>2]|0)+4>>2]=l}t[t[v>>2]>>2]=t[m>>2];zs(t[(t[m>>2]|0)+16>>2]|0,t[v>>2]|0)|0;eE(t[d>>2]|0,t[v>>2]|0)|0;if(((t[k>>2]|0)>0&(t[b>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(t[t[(t[d>>2]|0)+36>>2]>>2]|0)!=0:0){t[_>>2]=js(t[(t[t[(t[d>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[d>>2]|0)+36>>2]|0)|0;t[p>>2]=(t[(t[(t[d>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[d>>2]|0)+36>>2]|0)+12>>2]|0);ZO(t[t[(t[d>>2]|0)+36>>2]>>2]|0,t[k>>2]|0,t[b>>2]|0)|0;Vs(t[(t[t[(t[d>>2]|0)+36>>2]>>2]|0)+16>>2]|0,t[(t[d>>2]|0)+36>>2]|0,t[_>>2]|0,t[p>>2]|0)|0}t[(t[d>>2]|0)+292>>2]=1;t[o>>2]=t[d>>2];E=t[o>>2]|0;s=a;return E|0}function AN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;t[u>>2]=e;t[a>>2]=i;t[k>>2]=94776;if(!(t[u>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}t[o>>2]=gN()|0;if(!(t[o>>2]|0)){t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}t[l>>2]=KA(t[u>>2]|0)|0;if(!(t[l>>2]|0)){if(t[34014]|0)yAi[t[135968+88>>2]&511](0,94792,n);Up(t[o>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}t[c>>2]=uA(t[l>>2]|0,0,t[o>>2]|0)|0;pAi[t[135736>>2]&511](t[l>>2]|0);l=t[o>>2]|0;if(!(t[c>>2]|0)){Up(l);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}eE(l,t[c>>2]|0)|0;if(((t[a>>2]|0)!=0?(t[h>>2]=HY(t[a>>2]|0)|0,(t[h>>2]|0)>>>0<1e3):0)?(c=t[33938]|0,l=rs(t[k>>2]|0)|0,t[b>>2]=gAi[c&511](l+(t[h>>2]|0)+1|0)|0,(t[b>>2]|0)!=0):0){WY(t[b>>2]|0,t[k>>2]|0)|0;xY(t[b>>2]|0,t[a>>2]|0)|0;XN(t[o>>2]|0,t[b>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0)}t[f>>2]=t[o>>2];w=t[f>>2]|0;s=r;return w|0}function MN(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[h>>2]=0;rS();t[k>>2]=AN(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[k>>2]|0)){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if(t[c>>2]|0){t[h>>2]=t[t[k>>2]>>2];t[t[k>>2]>>2]=t[c>>2];t[(t[k>>2]|0)+4>>2]=t[l>>2]}EN(t[k>>2]|0)|0;t[b>>2]=t[(t[k>>2]|0)+8>>2];if(t[c>>2]|0){t[t[k>>2]>>2]=t[h>>2];t[(t[k>>2]|0)+4>>2]=0}SN(t[k>>2]|0);t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}function RN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=MN(t[n>>2]|0,t[f>>2]|0,0,0)|0;s=r;return i|0}function NN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if(t[u>>2]&64){t[(t[t[f>>2]>>2]|0)+84>>2]=0;t[(t[f>>2]|0)+116>>2]=0;t[u>>2]=(t[u>>2]|0)-64;i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|64}if(t[u>>2]&32){t[(t[t[f>>2]>>2]|0)+88>>2]=0;t[(t[f>>2]|0)+112>>2]=0;t[(t[t[f>>2]>>2]|0)+92>>2]=0;t[u>>2]=(t[u>>2]|0)-32;i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|32}i=(t[f>>2]|0)+268|0;if(t[u>>2]&128){t[i>>2]=1;t[u>>2]=(t[u>>2]|0)-128;e=(t[f>>2]|0)+360|0;t[e>>2]=t[e>>2]|128}else t[i>>2]=0;i=(t[f>>2]|0)+208|0;if(t[u>>2]&256){t[i>>2]=0;t[(t[t[f>>2]>>2]|0)+72>>2]=65;t[u>>2]=(t[u>>2]|0)-256;e=(t[f>>2]|0)+360|0;t[e>>2]=t[e>>2]|256}else t[i>>2]=1;i=(t[f>>2]|0)+288|0;if(t[u>>2]&1){t[i>>2]=1;t[u>>2]=(t[u>>2]|0)-1}else t[i>>2]=0;if(t[u>>2]&65536){i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|65536;t[u>>2]=(t[u>>2]|0)-65536}if(t[u>>2]&524288){i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|524288;t[u>>2]=(t[u>>2]|0)-524288}if(t[u>>2]&4){i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|4;t[u>>2]=(t[u>>2]|0)-4}if(t[u>>2]&2097152){i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|2097152;t[u>>2]=(t[u>>2]|0)-2097152}if(t[u>>2]&8192){i=(t[f>>2]|0)+360|0;t[i>>2]=t[i>>2]|8192;t[u>>2]=(t[u>>2]|0)-8192}t[(t[f>>2]|0)+364>>2]=0;t[n>>2]=t[u>>2];a=t[n>>2]|0;s=r;return a|0}function TN(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;rS();t[c>>2]=AN(t[u>>2]|0,t[a>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=ZN(t[c>>2]|0,0,0,t[o>>2]|0,0)|0;l=t[f>>2]|0;s=n;return l|0}return 0}function LN(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;rS();t[h>>2]=lS(t[o>>2]|0,t[c>>2]|0)|0;if(!(t[h>>2]|0)){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}fj();if(t[t[h>>2]>>2]|0){c=(t[t[h>>2]>>2]|0)+0|0;o=136096|0;f=c+112|0;do{t[c>>2]=t[o>>2];c=c+4|0;o=o+4|0}while((c|0)<(f|0))}t[a>>2]=ZN(t[h>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,0)|0;w=t[a>>2]|0;s=u;return w|0}function DN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;if(!(t[21466]|0))bN();t[o>>2]=0;while(1){if((t[o>>2]|0)>=100)break;t[c>>2]=t[85872+(t[o>>2]<<2)>>2];if(!(t[c>>2]|0)){l=6;break}if(Xl(t[t[c>>2]>>2]|0,t[f>>2]|0)|0)break;t[o>>2]=(t[o>>2]|0)+1}if((l|0)==6){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[a>>2]=((t[c>>2]|0)-86272|0)/4|0;t[a>>2]=(t[a>>2]|0)+1;while(1){if(!(t[86272+(t[a>>2]<<2)>>2]|0)){l=14;break}if(Xl(t[86272+(t[a>>2]<<2)>>2]|0,t[u>>2]|0)|0){l=12;break}t[a>>2]=(t[a>>2]|0)+1}if((l|0)==12){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else if((l|0)==14){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}return 0}function CN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r;f=r+8|0;u=r+4|0;t[f>>2]=e;t[u>>2]=i;if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+212>>2]|0)!=0:0)?(t[(t[f>>2]|0)+172>>2]|0)==-1:0){s=r;return}if(t[f>>2]|0){t[(t[f>>2]|0)+84>>2]=2;t[(t[f>>2]|0)+172>>2]=-1;t[(t[f>>2]|0)+212>>2]=1}i=t[f>>2]|0;if(t[u>>2]|0){f=t[u>>2]|0;t[n>>2]=t[u>>2];cp(0,0,0,i,0,1,2,3,0,0,f,0,0,0,0,98040,n);s=r;return}else{cp(0,0,0,i,0,1,2,3,0,0,0,0,0,0,0,98072,n);s=r;return}}function PN(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[o>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[n>>2]|0)+36>>2]|0,250)|0;t[f>>2]=t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2];if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)c=10;else c=6;do if((c|0)==6){if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){c=10;break}if(!((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=58:0))c=10}while(0);if((c|0)==10){t[f>>2]=(t[f>>2]|0)+1;while(1){if((u[t[f>>2]>>0]|0|0)>=97?(u[t[f>>2]>>0]|0|0)<=122:0)l=1;else c=13;do if((c|0)==13){c=0;if((u[t[f>>2]>>0]|0|0)>=65?(u[t[f>>2]>>0]|0|0)<=90:0){l=1;break}if((u[t[f>>2]>>0]|0|0)>=48?(u[t[f>>2]>>0]|0|0)<=57:0){l=1;break}if(((u[t[f>>2]>>0]|0|0)!=95?(u[t[f>>2]>>0]|0|0)!=45:0)?(u[t[f>>2]>>0]|0|0)!=58:0)l=(u[t[f>>2]>>0]|0|0)==46;else l=1}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if((u[b>>0]|0|0)>0?(u[t[f>>2]>>0]|0|0)<128:0){t[o>>2]=(t[f>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0);t[a>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0,t[o>>2]|0)|0;t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]=t[f>>2];f=(t[n>>2]|0)+200|0;t[f>>2]=(t[f>>2]|0)+(t[o>>2]|0);f=(t[(t[n>>2]|0)+36>>2]|0)+32|0;t[f>>2]=(t[f>>2]|0)+(t[o>>2]|0);t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}}t[r>>2]=JN(t[n>>2]|0)|0;k=t[r>>2]|0;s=i;return k|0}function BN(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(t[o>>2]|0)t[(t[o>>2]|0)+84>>2]=t[c>>2];f=t[o>>2]|0;n=t[c>>2]|0;c=t[b>>2]|0;r=t[k>>2]|0;i=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(0,0,0,f,0,5,n,2,0,0,c,r,0,0,0,i,a);if(!(t[o>>2]|0)){s=u;return}t[(t[o>>2]|0)+12>>2]=0;s=u;return}function IN(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+212>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)==-1:0){s=f;return}if(t[a>>2]|0)t[(t[a>>2]|0)+84>>2]=t[o>>2];n=t[a>>2]|0;r=t[o>>2]|0;o=t[l>>2]|0;i=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,0,5,r,2,0,0,0,0,0,o,0,i,u);if(!(t[a>>2]|0)){s=f;return}t[(t[a>>2]|0)+12>>2]=0;s=f;return}function HN(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;i=s;s=s+64|0;r=i+52|0;n=i+48|0;f=i+44|0;a=i+40|0;o=i+36|0;c=i+32|0;l=i+28|0;b=i+24|0;k=i+20|0;h=i+16|0;w=i+12|0;d=i+8|0;v=i+4|0;m=i;t[n>>2]=e;t[l>>2]=0;t[k>>2]=0;t[w>>2]=0;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+36>>2]|0)!=0:0){if((t[(t[n>>2]|0)+172>>2]|0)==-1){t[r>>2]=-1;_=t[r>>2]|0;s=i;return _|0}if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){t[r>>2]=-1;_=t[r>>2]|0;s=i;return _|0}Op(t[n>>2]|0);t[c>>2]=t[(t[n>>2]|0)+300>>2];t[b>>2]=t[(t[n>>2]|0)+304>>2];if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[n>>2]|0)+36>>2]|0,250)|0;t[f>>2]=QN(t[n>>2]|0)|0;if(!(t[f>>2]|0)){BN(t[n>>2]|0,68,97520,0,0);while(1){if(!(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))p=15;if(((p|0)==15?(p=0,(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((t[(t[n>>2]|0)+172>>2]|0)==-1)break;Op(t[n>>2]|0)}t[r>>2]=-1;_=t[r>>2]|0;s=i;return _|0}if(Xl(t[f>>2]|0,96200)|0)t[k>>2]=1;$N(t[n>>2]|0,t[f>>2]|0);eT(t[n>>2]|0,t[f>>2]|0);if((t[(t[n>>2]|0)+188>>2]|0)>0?(Xl(t[f>>2]|0,94240)|0)!=0:0){BN(t[n>>2]|0,800,97656,t[f>>2]|0,0);t[w>>2]=1;e=(t[n>>2]|0)+248|0;t[e>>2]=(t[e>>2]|0)+1}if((t[(t[n>>2]|0)+188>>2]|0)!=1?(Xl(t[f>>2]|0,95656)|0)!=0:0){BN(t[n>>2]|0,800,97704,t[f>>2]|0,0);t[w>>2]=1;e=(t[n>>2]|0)+248|0;t[e>>2]=(t[e>>2]|0)+1}e:do if(Xl(t[f>>2]|0,95648)|0){t[d>>2]=0;while(1){if((t[d>>2]|0)>=(t[(t[n>>2]|0)+188>>2]|0))break e;if(Xl(t[(t[(t[n>>2]|0)+196>>2]|0)+(t[d>>2]<<2)>>2]|0,95648)|0){BN(t[n>>2]|0,800,97752,t[f>>2]|0,0);t[w>>2]=1;e=(t[n>>2]|0)+248|0;t[e>>2]=(t[e>>2]|0)+1}t[d>>2]=(t[d>>2]|0)+1}}while(0);jN(t[n>>2]|0)|0;while(1){if(!(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))p=38;if(((p|0)==38?(p=0,(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break;t[v>>2]=t[(t[n>>2]|0)+200>>2];if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[n>>2]|0)+36>>2]|0,250)|0;t[a>>2]=iT(t[n>>2]|0,o)|0;e:do if(t[a>>2]|0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[l>>2]|0))break;if(Xl(t[(t[c>>2]|0)+(t[h>>2]<<2)>>2]|0,t[a>>2]|0)|0){p=50;break}t[h>>2]=(t[h>>2]|0)+2}if((p|0)==50){p=0;BN(t[n>>2]|0,42,97800,t[a>>2]|0,0);if(!(t[o>>2]|0))break;pAi[t[135736>>2]&511](t[o>>2]|0);break}do if(!(t[c>>2]|0)){t[b>>2]=22;t[c>>2]=gAi[t[135744>>2]&511](t[b>>2]<<2)|0;if(t[c>>2]|0){t[(t[n>>2]|0)+300>>2]=t[c>>2];t[(t[n>>2]|0)+304>>2]=t[b>>2];break}CN(t[n>>2]|0,0);if(!(t[o>>2]|0))break e;pAi[t[135736>>2]&511](t[o>>2]|0);break e}else{if(((t[l>>2]|0)+4|0)<=(t[b>>2]|0))break;t[b>>2]=t[b>>2]<<1;t[m>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,t[b>>2]<<2)|0;if(t[m>>2]|0){t[c>>2]=t[m>>2];t[(t[n>>2]|0)+300>>2]=t[c>>2];t[(t[n>>2]|0)+304>>2]=t[b>>2];break}CN(t[n>>2]|0,0);if(!(t[o>>2]|0))break e;pAi[t[135736>>2]&511](t[o>>2]|0);break e}while(0);d=t[a>>2]|0;e=t[l>>2]|0;t[l>>2]=e+1;t[(t[c>>2]|0)+(e<<2)>>2]=d;d=t[o>>2]|0;e=t[l>>2]|0;t[l>>2]=e+1;t[(t[c>>2]|0)+(e<<2)>>2]=d;t[(t[c>>2]|0)+(t[l>>2]<<2)>>2]=0;t[(t[c>>2]|0)+((t[l>>2]|0)+1<<2)>>2]=0}else{if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);while(1){if(!(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))p=68;do if((p|0)==68){p=0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;if(32>(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0))break e}while(0);if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==32)break e;if(9<=(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break e;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break e;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break e;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(u[(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break e;Op(t[n>>2]|0)}}while(0);jN(t[n>>2]|0)|0;if((t[v>>2]|0)==(t[(t[n>>2]|0)+200>>2]|0)){p=79;break}}if((p|0)==79)BN(t[n>>2]|0,1,97824,0,0);if((t[k>>2]|0)!=0&(t[l>>2]|0)!=0)rT(t[n>>2]|0,t[c>>2]|0);do if(((t[w>>2]|0)==0?(nT(t[n>>2]|0,t[f>>2]|0)|0,(t[t[n>>2]>>2]|0)!=0):0)?(t[(t[t[n>>2]>>2]|0)+56>>2]|0)!=0:0){k=t[(t[t[n>>2]>>2]|0)+56>>2]|0;p=t[(t[n>>2]|0)+4>>2]|0;v=t[f>>2]|0;if(t[l>>2]|0){yAi[k&511](p,v,t[c>>2]|0);break}else{yAi[k&511](p,v,0);break}}while(0);e:do if(t[c>>2]|0){t[h>>2]=1;while(1){if((t[h>>2]|0)>=(t[l>>2]|0))break e;if(t[(t[c>>2]|0)+(t[h>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[c>>2]|0)+(t[h>>2]<<2)>>2]|0);t[h>>2]=(t[h>>2]|0)+2}}while(0);t[r>>2]=t[w>>2];_=t[r>>2]|0;s=i;return _|0}BN(t[n>>2]|0,1,97616,0,0);t[r>>2]=-1;_=t[r>>2]|0;s=i;return _|0}function xN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+188>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+188|0;t[e>>2]=(t[e>>2]|0)+-1;if((t[(t[n>>2]|0)+188>>2]|0)<0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[n>>2]|0;if((t[(t[n>>2]|0)+188>>2]|0)>0)t[(t[n>>2]|0)+184>>2]=t[(t[(t[n>>2]|0)+196>>2]|0)+((t[e+188>>2]|0)-1<<2)>>2];else t[e+184>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+196>>2]|0)+(t[(t[n>>2]|0)+188>>2]<<2)>>2];t[(t[(t[n>>2]|0)+196>>2]|0)+(t[(t[n>>2]|0)+188>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function UN(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[(t[r>>2]|0)+188>>2]|0)){s=i;return}t[n>>2]=(t[(t[r>>2]|0)+188>>2]|0)-1;while(1){if((t[n>>2]|0)<0)break;if((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[r>>2]>>2]|0)+60>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[(t[r>>2]|0)+184>>2]|0);xN(t[r>>2]|0)|0;t[n>>2]=(t[n>>2]|0)+-1}s=i;return}function zN(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[r>>2]=e;t[n>>2]=Yl(t[(t[r>>2]|0)+184>>2]|0)|0;t[f>>2]=t[(t[r>>2]|0)+188>>2];e:while(1){t[o>>2]=t[(t[r>>2]|0)+200>>2];if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;if((t[(t[r>>2]|0)+172>>2]|0)==-1)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){if(!(gi(t[r>>2]|0)|0))continue;if((t[n>>2]|0)==0?(t[(t[r>>2]|0)+188>>2]|0)!=0:0)continue;if(t[n>>2]|0)pAi[t[135736>>2]&511](t[n>>2]|0);t[n>>2]=Yl(t[(t[r>>2]|0)+184>>2]|0)|0;t[f>>2]=t[(t[r>>2]|0)+188>>2];continue}i:do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if(!(65<=(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=90:0))c=17;do if((c|0)==17){c=0;if(97<=(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=122:0)break;if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=95?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=58:0)break i}while(0);t[a>>2]=yi(t[r>>2]|0)|0;e=t[r>>2]|0;if(t[a>>2]|0){if(!(t[e+184>>2]|0))break;if((DN(t[a>>2]|0,t[(t[r>>2]|0)+184>>2]|0)|0)!=1)break;$N(t[r>>2]|0,t[a>>2]|0);continue e}BN(e,68,97520,0,0);while(1){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)c=27;else if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)l=0;else c=27;if((c|0)==27){c=0;l=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62}b=t[r>>2]|0;if(!l)break;Op(b)}Mi(b);if(t[n>>2]|0)pAi[t[135736>>2]&511](t[n>>2]|0);t[n>>2]=Yl(t[(t[r>>2]|0)+184>>2]|0)|0;t[f>>2]=t[(t[r>>2]|0)+188>>2];continue e}while(0);if(((t[(t[r>>2]|0)+188>>2]|0)>0?(t[f>>2]|0)>=(t[(t[r>>2]|0)+188>>2]|0):0)?(Xl(t[n>>2]|0,t[(t[r>>2]|0)+184>>2]|0)|0)==0:0){Mi(t[r>>2]|0);if(t[n>>2]|0)pAi[t[135736>>2]&511](t[n>>2]|0);t[n>>2]=Yl(t[(t[r>>2]|0)+184>>2]|0)|0;t[f>>2]=t[(t[r>>2]|0)+188>>2];continue}do if(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0){if((Xl(t[n>>2]|0,94992)|0)==0?(Xl(t[n>>2]|0,95e3)|0)==0:0){c=46;break}Fi(t[r>>2]|0)}else c=46;while(0);if((c|0)==46){c=0;if(((((((((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)==80:0)?(Pq(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)==69:0){BN(t[r>>2]|0,800,95008,95040,0);YN(t[r>>2]|0)}if((((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)VN(t[r>>2]|0);else c=61;do if((c|0)==61){c=0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0){qN(t[r>>2]|0);break}e=t[r>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){Ri(e);if(t[n>>2]|0)pAi[t[135736>>2]&511](t[n>>2]|0);t[n>>2]=Yl(t[(t[r>>2]|0)+184>>2]|0)|0;t[f>>2]=t[(t[r>>2]|0)+188>>2];break}k=t[r>>2]|0;if((u[t[(t[e+36>>2]|0)+16>>2]>>0]|0|0)==38){Oi(k);break}h=t[r>>2]|0;if(!(u[t[(t[k+36>>2]|0)+16>>2]>>0]|0)){c=71;break e}Ai(h)}while(0);if((t[o>>2]|0)==(t[(t[r>>2]|0)+200>>2]|0)){c=74;break}}if(t[(t[r>>2]|0)+292>>2]|0)continue;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;yp(t[(t[r>>2]|0)+36>>2]|0,250)|0}if((c|0)==71)UN(h);else if((c|0)==74?(t[(t[r>>2]|0)+52>>2]|0)!=0:0)BN(t[r>>2]|0,1,95064,0,0);if(!(t[n>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[n>>2]|0);s=i;return}function jN(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;e:while(1){do if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)break e}while(0);if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(yp(t[(t[r>>2]|0)+36>>2]|0,250)|0)<=0:0)aE(t[r>>2]|0)|0;else{e=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){f=e+28|0;t[f>>2]=(t[f>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{f=e+32|0;t[f>>2]=(t[f>>2]|0)+1}f=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[f>>2]=(t[f>>2]|0)+1;f=(t[r>>2]|0)+200|0;t[f>>2]=(t[f>>2]|0)+1;if(!(u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0))yp(t[(t[r>>2]|0)+36>>2]|0,250)|0}t[n>>2]=(t[n>>2]|0)+1}s=i;return t[n>>2]|0}function VN(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;i=s;s=s+48|0;r=i+44|0;f=i+40|0;a=i+36|0;o=i+32|0;c=i+28|0;l=i+24|0;b=i+20|0;k=i+16|0;h=i+12|0;w=i+8|0;d=i+4|0;v=i;t[r>>2]=e;t[f>>2]=0;t[o>>2]=100;if(t[(t[r>>2]|0)+176>>2]|0)m=-1;else m=u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((m|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=45){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=45){s=i;return}t[d>>2]=t[(t[r>>2]|0)+172>>2];t[(t[r>>2]|0)+172>>2]=5;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);m=(t[r>>2]|0)+200|0;t[m>>2]=(t[m>>2]|0)+4;m=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[m>>2]=(t[m>>2]|0)+4;m=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[m>>2]=(t[m>>2]|0)+4;t[f>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;m=t[r>>2]|0;if(!(t[f>>2]|0)){CN(m,97424);t[(t[r>>2]|0)+172>>2]=t[d>>2];s=i;return}t[c>>2]=Ni(m,l)|0;m=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=m+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{e=m+32|0;t[e>>2]=(t[e>>2]|0)+1}t[(t[r>>2]|0)+176>>2]=0;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[l>>2]|0);e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;t[b>>2]=Ni(t[r>>2]|0,k)|0;e=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){m=e+28|0;t[m>>2]=(t[m>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{m=e+32|0;t[m>>2]=(t[m>>2]|0)+1}t[(t[r>>2]|0)+176>>2]=0;m=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[m>>2]=(t[m>>2]|0)+(t[k>>2]|0);m=(t[r>>2]|0)+200|0;t[m>>2]=(t[m>>2]|0)+1;t[h>>2]=Ni(t[r>>2]|0,w)|0;t[a>>2]=0;while(1){m=t[h>>2]|0;if((t[h>>2]|0)<256)if(9<=(m|0)&(t[h>>2]|0)<=10|(t[h>>2]|0)==13|32<=(t[h>>2]|0))_=24;else p=0;else if((!(256<=(m|0)&(t[h>>2]|0)<=55295)?!(57344<=(t[h>>2]|0)&(t[h>>2]|0)<=65533):0)?!(65536<=(t[h>>2]|0)&(t[h>>2]|0)<=1114111):0)p=0;else _=24;
	if((_|0)==24){_=0;if((t[h>>2]|0)!=62|(t[b>>2]|0)!=45)p=1;else p=(t[c>>2]|0)!=45}E=t[a>>2]|0;if(!p)break;if((E+5|0)>=(t[o>>2]|0)){t[o>>2]=t[o>>2]<<1;t[v>>2]=MAi[t[135760>>2]&511](t[f>>2]|0,t[o>>2]|0)|0;if(!(t[v>>2]|0)){_=29;break}t[f>>2]=t[v>>2]}if((t[l>>2]|0)==1){m=t[c>>2]&255;e=t[a>>2]|0;t[a>>2]=e+1;n[(t[f>>2]|0)+e>>0]=m}else{m=Np(t[l>>2]|0,(t[f>>2]|0)+(t[a>>2]|0)|0,t[c>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+m}t[c>>2]=t[b>>2];t[l>>2]=t[k>>2];t[b>>2]=t[h>>2];t[k>>2]=t[w>>2];m=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=m+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{e=m+32|0;t[e>>2]=(t[e>>2]|0)+1}t[(t[r>>2]|0)+176>>2]=0;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[w>>2]|0);e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;t[h>>2]=Ni(t[r>>2]|0,w)|0;if(t[h>>2]|0)continue;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;t[h>>2]=Ni(t[r>>2]|0,w)|0}if((_|0)==29){pAi[t[135736>>2]&511](t[f>>2]|0);CN(t[r>>2]|0,97456);t[(t[r>>2]|0)+172>>2]=t[d>>2];s=i;return}n[(t[f>>2]|0)+E>>0]=0;E=t[h>>2]|0;if((t[h>>2]|0)<256)if(9<=(E|0)&(t[h>>2]|0)<=10|(t[h>>2]|0)==13|32<=(t[h>>2]|0))_=51;else _=50;else if((!(256<=(E|0)&(t[h>>2]|0)<=55295)?!(57344<=(t[h>>2]|0)&(t[h>>2]|0)<=65533):0)?!(65536<=(t[h>>2]|0)&(t[h>>2]|0)<=1114111):0)_=50;else _=51;if((_|0)==50){BN(t[r>>2]|0,45,97480,t[f>>2]|0,0);pAi[t[135736>>2]&511](t[f>>2]|0)}else if((_|0)==51){Op(t[r>>2]|0);if(((t[t[r>>2]>>2]|0)!=0?(t[(t[t[r>>2]>>2]|0)+80>>2]|0)!=0:0)?(t[(t[r>>2]|0)+212>>2]|0)==0:0)EAi[t[(t[t[r>>2]>>2]|0)+80>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[f>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0)}t[(t[r>>2]|0)+172>>2]=t[d>>2];s=i;return}function qN(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;i=s;s=s+48|0;r=i+36|0;f=i+32|0;a=i+28|0;o=i+24|0;c=i+20|0;l=i+16|0;b=i+12|0;k=i+8|0;h=i+4|0;w=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=0;t[o>>2]=100;t[h>>2]=0;if(t[(t[r>>2]|0)+176>>2]|0)d=-1;else d=u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((d|0)!=60){s=i;return}if((u[(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=63){s=i;return}t[k>>2]=t[(t[r>>2]|0)+172>>2];t[(t[r>>2]|0)+172>>2]=2;d=(t[r>>2]|0)+200|0;t[d>>2]=(t[d>>2]|0)+2;d=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[d>>2]=(t[d>>2]|0)+2;d=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[d>>2]=(t[d>>2]|0)+2;if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fp(t[(t[r>>2]|0)+36>>2]|0);t[b>>2]=PN(t[r>>2]|0)|0;d=t[r>>2]|0;if(t[b>>2]|0){if(t[d+176>>2]|0)v=-1;else v=u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((v|0)==62){v=(t[r>>2]|0)+200|0;t[v>>2]=(t[v>>2]|0)+1;v=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[v>>2]=(t[v>>2]|0)+1;v=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[v>>2]=(t[v>>2]|0)+1;if(((t[t[r>>2]>>2]|0)!=0?(t[(t[r>>2]|0)+212>>2]|0)==0:0)?(t[(t[t[r>>2]>>2]|0)+76>>2]|0)!=0:0)yAi[t[(t[t[r>>2]>>2]|0)+76>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[b>>2]|0,0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}t[f>>2]=gAi[t[135752>>2]&511](t[o>>2]|0)|0;v=t[r>>2]|0;if(!(t[f>>2]|0)){CN(v,0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}t[c>>2]=u[t[(t[v+36>>2]|0)+16>>2]>>0];if((t[c>>2]|0)<256){if((t[c>>2]|0)!=32?!(9<=(t[c>>2]|0)&(t[c>>2]|0)<=10|(t[c>>2]|0)==13):0)m=22}else m=22;if((m|0)==22)BN(t[r>>2]|0,65,97328,t[b>>2]|0,0);jN(t[r>>2]|0)|0;t[c>>2]=Ni(t[r>>2]|0,l)|0;while(1){v=t[c>>2]|0;if((t[c>>2]|0)<256)if(9<=(v|0)&(t[c>>2]|0)<=10|(t[c>>2]|0)==13|32<=(t[c>>2]|0))m=29;else _=0;else if((!(256<=(v|0)&(t[c>>2]|0)<=55295)?!(57344<=(t[c>>2]|0)&(t[c>>2]|0)<=65533):0)?!(65536<=(t[c>>2]|0)&(t[c>>2]|0)<=1114111):0)_=0;else m=29;if((m|0)==29){m=0;_=(t[c>>2]|0)!=62}p=t[a>>2]|0;if(!_)break;if((p+5|0)>=(t[o>>2]|0)){t[o>>2]=t[o>>2]<<1;t[w>>2]=MAi[t[135760>>2]&511](t[f>>2]|0,t[o>>2]|0)|0;if(!(t[w>>2]|0)){m=33;break}t[f>>2]=t[w>>2]}t[h>>2]=(t[h>>2]|0)+1;if((t[h>>2]|0)>50){if((t[(t[r>>2]|0)+292>>2]|0)==0?((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[r>>2]|0)+36>>2]|0,250)|0;t[h>>2]=0}if((t[l>>2]|0)==1){v=t[c>>2]&255;e=t[a>>2]|0;t[a>>2]=e+1;n[(t[f>>2]|0)+e>>0]=v}else{v=Np(t[l>>2]|0,(t[f>>2]|0)+(t[a>>2]|0)|0,t[c>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+v}v=t[(t[r>>2]|0)+36>>2]|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=v+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[r>>2]|0)+36>>2]|0)+32>>2]=1}else{e=v+32|0;t[e>>2]=(t[e>>2]|0)+1}t[(t[r>>2]|0)+176>>2]=0;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[l>>2]|0);e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;t[c>>2]=Ni(t[r>>2]|0,l)|0;if(t[c>>2]|0)continue;do if(((t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=500)break;Fp(t[(t[r>>2]|0)+36>>2]|0)}while(0);do if(!(t[(t[r>>2]|0)+292>>2]|0)){if(((t[(t[(t[r>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;yp(t[(t[r>>2]|0)+36>>2]|0,250)|0}while(0);t[c>>2]=Ni(t[r>>2]|0,l)|0}if((m|0)==33){CN(t[r>>2]|0,0);pAi[t[135736>>2]&511](t[f>>2]|0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}n[(t[f>>2]|0)+p>>0]=0;p=t[r>>2]|0;if((t[c>>2]|0)==62){c=p+200|0;t[c>>2]=(t[c>>2]|0)+1;c=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[c>>2]=(t[c>>2]|0)+1;c=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[c>>2]=(t[c>>2]|0)+1;if(((t[t[r>>2]>>2]|0)!=0?(t[(t[r>>2]|0)+212>>2]|0)==0:0)?(t[(t[t[r>>2]>>2]|0)+76>>2]|0)!=0:0)yAi[t[(t[t[r>>2]>>2]|0)+76>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[b>>2]|0,t[f>>2]|0)}else BN(p,47,97360,t[b>>2]|0,0);pAi[t[135736>>2]&511](t[f>>2]|0)}else BN(d,46,97392,0,0);t[(t[r>>2]|0)+172>>2]=t[k>>2];s=i;return}function YN(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[f>>2]=0;t[a>>2]=0;e=(t[r>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+9;e=(t[(t[r>>2]|0)+36>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+9;jN(t[r>>2]|0)|0;t[n>>2]=PN(t[r>>2]|0)|0;if(!(t[n>>2]|0))BN(t[r>>2]|0,68,96976,0,0);jN(t[r>>2]|0)|0;t[a>>2]=Ti(t[r>>2]|0,f)|0;jN(t[r>>2]|0)|0;if((u[t[(t[(t[r>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)BN(t[r>>2]|0,61,97024,0,0);Op(t[r>>2]|0);if(((t[t[r>>2]>>2]|0)!=0?(t[t[t[r>>2]>>2]>>2]|0)!=0:0)?(t[(t[r>>2]|0)+212>>2]|0)==0:0)NAi[t[t[t[r>>2]>>2]>>2]&511](t[(t[r>>2]|0)+4>>2]|0,t[n>>2]|0,t[f>>2]|0,t[a>>2]|0);if(t[a>>2]|0)pAi[t[135736>>2]&511](t[a>>2]|0);if(!(t[f>>2]|0)){s=i;return}pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}function GN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}VY(t[n>>2]|0,0,472)|0;e=lz()|0;t[(t[n>>2]|0)+296>>2]=e;if(!(t[(t[n>>2]|0)+296>>2]|0)){CN(0,96936);t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](128)|0;if(!(t[f>>2]|0)){CN(0,96936);t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+128|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));o=gAi[t[135744>>2]&511](20)|0;t[(t[n>>2]|0)+48>>2]=o;if(!(t[(t[n>>2]|0)+48>>2]|0)){CN(0,96936);t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=5;t[(t[n>>2]|0)+36>>2]=0;t[(t[n>>2]|0)+20>>2]=0;t[(t[n>>2]|0)+24>>2]=0;t[(t[n>>2]|0)+28>>2]=-1;t[(t[n>>2]|0)+172>>2]=0;o=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+64>>2]=o;if(!(t[(t[n>>2]|0)+64>>2]|0)){CN(0,96936);t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+60>>2]=0;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+60>>2]=10;t[(t[n>>2]|0)+52>>2]=0;o=gAi[t[135744>>2]&511](40)|0;t[(t[n>>2]|0)+196>>2]=o;if(!(t[(t[n>>2]|0)+196>>2]|0)){CN(0,96936);t[(t[n>>2]|0)+188>>2]=0;t[(t[n>>2]|0)+192>>2]=0;t[(t[n>>2]|0)+184>>2]=0;t[(t[n>>2]|0)+56>>2]=0;t[(t[n>>2]|0)+60>>2]=0;t[(t[n>>2]|0)+52>>2]=0;t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+44>>2]=0;t[(t[n>>2]|0)+36>>2]=0;t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}t[(t[n>>2]|0)+188>>2]=0;t[(t[n>>2]|0)+192>>2]=10;t[(t[n>>2]|0)+184>>2]=0;t[(t[n>>2]|0)+460>>2]=0;t[(t[n>>2]|0)+452>>2]=0;t[(t[n>>2]|0)+456>>2]=0;if(!(t[f>>2]|0))t[t[n>>2]>>2]=136096;else{t[t[n>>2]>>2]=t[f>>2];e=(t[f>>2]|0)+0|0;f=136096|0;a=e+112|0;do{t[e>>2]=t[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(a|0))}t[(t[n>>2]|0)+4>>2]=t[n>>2];t[(t[n>>2]|0)+8>>2]=0;t[(t[n>>2]|0)+12>>2]=1;t[(t[n>>2]|0)+16>>2]=0;t[(t[n>>2]|0)+280>>2]=t[33962];t[(t[n>>2]|0)+32>>2]=1;t[(t[n>>2]|0)+136>>2]=-1412623820;t[(t[n>>2]|0)+108>>2]=t[n>>2];t[(t[n>>2]|0)+112>>2]=224;t[(t[n>>2]|0)+116>>2]=225;t[(t[n>>2]|0)+68>>2]=0;t[(t[n>>2]|0)+104>>2]=0;t[(t[n>>2]|0)+200>>2]=0;t[(t[n>>2]|0)+204>>2]=0;t[(t[n>>2]|0)+284>>2]=0;xp((t[n>>2]|0)+72|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function WN(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;r=s;s=s+80|0;f=r+60|0;a=r+56|0;o=r+52|0;c=r+48|0;l=r+44|0;b=r+69|0;k=r+68|0;h=r+24|0;w=r+20|0;d=r+16|0;v=r+12|0;m=r+8|0;_=r+66|0;p=r+4|0;E=r+64|0;S=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;t[l>>2]=0;e:while(1){t[c>>2]=t[(t[f>>2]|0)+36>>2];if(!(t[c>>2]|0))break;i=t[c>>2]|0;if(!(t[t[c>>2]>>2]|0))t[l>>2]=(t[i+24>>2]|0)-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0));else{e=Ts(t[(t[i>>2]|0)+16>>2]|0)|0;t[l>>2]=e-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0))}if(((((t[l>>2]|0)==0&(t[a>>2]|0)!=0?(UN(t[f>>2]|0),(t[(t[f>>2]|0)+188>>2]|0)==0):0)?(t[(t[f>>2]|0)+172>>2]|0)!=-1:0)?(t[(t[f>>2]|0)+172>>2]=-1,(t[t[f>>2]>>2]|0)!=0):0)?(t[(t[t[f>>2]>>2]|0)+52>>2]|0)!=0:0)pAi[t[(t[t[f>>2]>>2]|0)+52>>2]&511](t[(t[f>>2]|0)+4>>2]|0);if((t[l>>2]|0)<1)break;n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;e=t[f>>2]|0;if(!(u[b>>0]|0)){i=e+200|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+1;i=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+1;continue}do switch(t[e+172>>2]|0){case 1:{jN(t[f>>2]|0)|0;i=t[c>>2]|0;if(!(t[t[c>>2]>>2]|0))t[l>>2]=(t[i+24>>2]|0)-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0));else{g=Ts(t[(t[i>>2]|0)+16>>2]|0)|0;t[l>>2]=g-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0))}if((t[l>>2]|0)<1)break e;if((t[l>>2]|0)<2){if(!(t[a>>2]|0))break e;n[k>>0]=32}else n[k>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0;n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;if((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,45,45,62,1,1)|0)<0:0)break e;VN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=1;continue e}if((u[b>>0]|0)==60?(u[k>>0]|0)==63:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;qN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=1;continue e}do if(((((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0){if((Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)!=80)break;if((Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)!=69)break;if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;YN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=4;continue e}while(0);if((u[b>>0]|0)==60?(u[k>>0]|0)==33&(t[l>>2]|0)<9:0)break e;t[(t[f>>2]|0)+172>>2]=6;continue e;break}case 9:{if((t[l>>2]|0)<2)break e;if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;gi(t[f>>2]|0)|0;g=(t[f>>2]|0)+172|0;if(!(t[(t[f>>2]|0)+188>>2]|0))t[g>>2]=14;else t[g>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 8:{BN(t[f>>2]|0,1,95104,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 3:{BN(t[f>>2]|0,1,95144,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 7:{if(t[(t[f>>2]|0)+176>>2]|0){n[_+0>>0]=0;n[_+1>>0]=0;n[_>>0]=t[(t[f>>2]|0)+176>>2];Ci(t[f>>2]|0)|0;if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+68>>2]|0)!=0:0)yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,_,1);t[(t[f>>2]|0)+176>>2]=0;t[(t[f>>2]|0)+204>>2]=0}if(((t[l>>2]|0)==1&(t[a>>2]|0)!=0?(n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0,(u[b>>0]|0)!=60):0)?(u[b>>0]|0)!=38:0){i:do if(t[t[f>>2]>>2]|0){do if((u[b>>0]|0)!=32){if(9<=(u[b>>0]|0)?(u[b>>0]|0)<=10:0)break;if((u[b>>0]|0)!=13){Ci(t[f>>2]|0)|0;if(!(t[(t[t[f>>2]>>2]|0)+68>>2]|0))break i;yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,b,1);break i}}while(0);g=t[t[f>>2]>>2]|0;if(t[(t[f>>2]|0)+208>>2]|0){if(!(t[g+68>>2]|0))break;yAi[t[(t[t[f>>2]>>2]|0)+68>>2]&511](t[(t[f>>2]|0)+4>>2]|0,b,1);break}else{if(!(t[g+72>>2]|0))break;yAi[t[(t[t[f>>2]>>2]|0)+72>>2]&511](t[(t[f>>2]|0)+4>>2]|0,b,1);break}}while(0);t[(t[f>>2]|0)+176>>2]=0;t[(t[f>>2]|0)+204>>2]=0;g=(t[c>>2]|0)+16|0;t[g>>2]=(t[g>>2]|0)+1;continue e}if((t[l>>2]|0)<2)break e;n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;n[k>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0;t[m>>2]=t[(t[f>>2]|0)+200>>2];i:do if((Xl(t[(t[f>>2]|0)+184>>2]|0,94992)|0)==0?(Xl(t[(t[f>>2]|0)+184>>2]|0,95e3)|0)==0:0){do if((((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0){if((Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)!=89)break;if((Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)!=80)break;if((Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)!=69)break;if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;BN(t[f>>2]|0,800,95008,95040,0);YN(t[f>>2]|0);break i}while(0);if((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,45,45,62,1,1)|0)<0:0)break e;VN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=7;break}if((u[b>>0]|0)==60?(u[k>>0]|0)==63:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;qN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=7;break}if((u[b>>0]|0)==60?(u[k>>0]|0)==33&(t[l>>2]|0)<4:0)break e;if((u[b>>0]|0)==60?(u[k>>0]|0)==47:0){t[(t[f>>2]|0)+172>>2]=9;t[(t[f>>2]|0)+204>>2]=0;continue e}if((u[b>>0]|0)==60){t[(t[f>>2]|0)+172>>2]=6;t[(t[f>>2]|0)+204>>2]=0;continue e}g=(t[a>>2]|0)!=0;if((u[b>>0]|0)==38){if(!g?(Pi(t[f>>2]|0,95048,4)|0)<0:0)break e;Oi(t[f>>2]|0);break}else{if(!g?(Pi(t[f>>2]|0,95056,2)|0)<0:0)break e;t[(t[f>>2]|0)+204>>2]=0;Ai(t[f>>2]|0);break}}else y=187;while(0);if((y|0)==187){y=0;if(!(t[a>>2]|0)){t[p>>2]=Li(t[f>>2]|0,60,47,0,0,0)|0;if((t[p>>2]|0)<0)break e;n[E>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+((t[p>>2]|0)+2)>>0]|0;if(!(u[E>>0]|0))break e}Fi(t[f>>2]|0);if((u[b>>0]|0)==60?(u[k>>0]|0)==47:0){t[(t[f>>2]|0)+172>>2]=9;t[(t[f>>2]|0)+204>>2]=0;continue e}}if((t[m>>2]|0)!=(t[(t[f>>2]|0)+200>>2]|0))continue e;if(t[(t[f>>2]|0)+52>>2]|0)BN(t[f>>2]|0,1,95064,0,0);Op(t[f>>2]|0);continue e;break}case 6:{if((t[l>>2]|0)<1)break e;if((t[l>>2]|0)<2){if(!(t[a>>2]|0))break e;n[k>>0]=32}else n[k>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0;n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;if((u[b>>0]|0)!=60){t[(t[f>>2]|0)+172>>2]=7;continue e}if((u[k>>0]|0)==47){t[(t[f>>2]|0)+172>>2]=9;t[(t[f>>2]|0)+204>>2]=0;continue e}if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;if(t[(t[f>>2]|0)+68>>2]|0){t[h+4>>2]=(t[(t[(t[f>>2]|0)+36>>2]|0)+36>>2]|0)+((t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0));t[h+8>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2]}t[d>>2]=HN(t[f>>2]|0)|0;t[w>>2]=t[(t[f>>2]|0)+184>>2];if((t[d>>2]|0)==-1|(t[w>>2]|0)==0){if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62)continue e;Op(t[f>>2]|0);continue e}t[v>>2]=kN(t[w>>2]|0)|0;if(!(t[v>>2]|0))BN(t[f>>2]|0,801,94576,t[w>>2]|0,0);if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)==47?(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)==62:0){g=(t[f>>2]|0)+200|0;t[g>>2]=(t[g>>2]|0)+2;g=(t[(t[f>>2]|0)+36>>2]|0)+16|0;t[g>>2]=(t[g>>2]|0)+2;g=(t[(t[f>>2]|0)+36>>2]|0)+32|0;t[g>>2]=(t[g>>2]|0)+2;do if(t[t[f>>2]>>2]|0){if(!(t[(t[t[f>>2]>>2]|0)+60>>2]|0))break;EAi[t[(t[t[f>>2]>>2]|0)+60>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[w>>2]|0)}while(0);xN(t[f>>2]|0)|0;t[(t[f>>2]|0)+172>>2]=7;continue e}g=t[f>>2]|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62){BN(g,73,94592,t[w>>2]|0,0);if(Xl(t[w>>2]|0,t[(t[f>>2]|0)+184>>2]|0)|0){nE(t[f>>2]|0)|0;xN(t[f>>2]|0)|0}if(t[(t[f>>2]|0)+68>>2]|0)Di(t[f>>2]|0,h)|0;t[(t[f>>2]|0)+172>>2]=7;continue e}Op(g);if((t[v>>2]|0)!=0?(n[(t[v>>2]|0)+7>>0]|0)!=0:0){do if(t[t[f>>2]>>2]|0){if(!(t[(t[t[f>>2]>>2]|0)+60>>2]|0))break;EAi[t[(t[t[f>>2]>>2]|0)+60>>2]&511](t[(t[f>>2]|0)+4>>2]|0,t[w>>2]|0)}while(0);xN(t[f>>2]|0)|0}if(t[(t[f>>2]|0)+68>>2]|0)Di(t[f>>2]|0,h)|0;t[(t[f>>2]|0)+172>>2]=7;continue e;break}case 0:{n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;do if((u[b>>0]|0)!=32){if(9<=(u[b>>0]|0)?(u[b>>0]|0)<=10:0){y=20;break}if((u[b>>0]|0)==13)y=20}else y=20;while(0);do if((y|0)==20){y=0;jN(t[f>>2]|0)|0;g=t[c>>2]|0;if(!(t[t[c>>2]>>2]|0)){t[l>>2]=(t[g+24>>2]|0)-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0));break}else{i=Ts(t[(t[g>>2]|0)+16>>2]|0)|0;t[l>>2]=i-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0));break}}while(0);if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+44>>2]|0)!=0:0)EAi[t[(t[t[f>>2]>>2]|0)+44>>2]&511](t[(t[f>>2]|0)+4>>2]|0,136080);if(((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+48>>2]|0)!=0:0)?(t[(t[f>>2]|0)+212>>2]|0)==0:0)pAi[t[(t[t[f>>2]>>2]|0)+48>>2]&511](t[(t[f>>2]|0)+4>>2]|0);n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;n[k>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0;if(((((((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)==80:0)?(Pq(u[(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)==69:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;YN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=4;continue e}t[(t[f>>2]|0)+172>>2]=1;continue e;break}case 14:{i=t[c>>2]|0;if(!(t[t[c>>2]>>2]|0))t[l>>2]=(t[i+24>>2]|0)-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0));else{g=Ts(t[(t[i>>2]|0)+16>>2]|0)|0;t[l>>2]=g-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0))}if((t[l>>2]|0)<1)break e;n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;if((u[b>>0]|0)==32){y=105;break e}if(9<=(u[b>>0]|0)?(u[b>>0]|0)<=10:0){y=105;break e}if((u[b>>0]|0)==13){y=105;break e}if((t[l>>2]|0)<2)break e;n[k>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0;if((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,45,45,62,1,1)|0)<0:0)break e;VN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=14;continue e}if((u[b>>0]|0)!=60){y=119;break e}if((u[k>>0]|0)!=63){y=119;break e}if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;qN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=14;continue e;break}case 4:{jN(t[f>>2]|0)|0;g=t[c>>2]|0;if(!(t[t[c>>2]>>2]|0))t[l>>2]=(t[g+24>>2]|0)-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0));else{i=Ts(t[(t[g>>2]|0)+16>>2]|0)|0;t[l>>2]=i-((t[(t[c>>2]|0)+16>>2]|0)-(t[(t[c>>2]|0)+12>>2]|0))}if((t[l>>2]|0)<2)break e;n[b>>0]=n[t[(t[c>>2]|0)+16>>2]>>0]|0;n[k>>0]=n[(t[(t[c>>2]|0)+16>>2]|0)+1>>0]|0;if((((u[b>>0]|0)==60?(u[k>>0]|0)==33:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(u[(t[(t[c>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,45,45,62,1,1)|0)<0:0)break e;VN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=4;continue e}if((u[b>>0]|0)==60?(u[k>>0]|0)==63:0){if((t[a>>2]|0)==0?(Li(t[f>>2]|0,62,0,0,0,1)|0)<0:0)break e;qN(t[f>>2]|0);t[(t[f>>2]|0)+172>>2]=4;continue e}if((u[b>>0]|0)==60?(u[k>>0]|0)==33&(t[l>>2]|0)<4:0)break e;t[(t[f>>2]|0)+172>>2]=6;continue e;break}case 5:{BN(t[f>>2]|0,1,95184,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 2:{BN(t[f>>2]|0,1,95224,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 10:{BN(t[f>>2]|0,1,95264,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 11:{BN(t[f>>2]|0,1,95312,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 12:{BN(t[f>>2]|0,1,95360,0,0);t[(t[f>>2]|0)+172>>2]=6;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 13:{BN(t[f>>2]|0,1,95408,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 15:{BN(t[f>>2]|0,1,95472,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case 16:{BN(t[f>>2]|0,1,95528,0,0);t[(t[f>>2]|0)+172>>2]=7;t[(t[f>>2]|0)+204>>2]=0;continue e;break}case-1:{break e;break}default:continue e}while(0)}do if((y|0)==105)Ai(t[f>>2]|0);else if((y|0)==119){if((u[b>>0]|0)==60?(u[k>>0]|0)==33&(t[l>>2]|0)<4:0)break;t[(t[f>>2]|0)+84>>2]=5;t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+172>>2]=-1;if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+52>>2]|0)!=0:0)pAi[t[(t[t[f>>2]>>2]|0)+52>>2]&511](t[(t[f>>2]|0)+4>>2]|0)}while(0);if(((((t[l>>2]|0)==0&(t[a>>2]|0)!=0?(UN(t[f>>2]|0),(t[(t[f>>2]|0)+188>>2]|0)==0):0)?(t[(t[f>>2]|0)+172>>2]|0)!=-1:0)?(t[(t[f>>2]|0)+172>>2]=-1,(t[t[f>>2]>>2]|0)!=0):0)?(t[(t[t[f>>2]>>2]|0)+52>>2]|0)!=0:0)pAi[t[(t[t[f>>2]>>2]|0)+52>>2]&511](t[(t[f>>2]|0)+4>>2]|0);if(t[(t[f>>2]|0)+360>>2]&4){F=t[o>>2]|0;s=r;return F|0}if(!(t[(t[f>>2]|0)+8>>2]|0)){F=t[o>>2]|0;s=r;return F|0}if(((t[a>>2]|0)==0?(t[(t[f>>2]|0)+172>>2]|0)!=-1:0)?(t[(t[f>>2]|0)+172>>2]|0)!=14:0){F=t[o>>2]|0;s=r;return F|0}t[S>>2]=Qg(t[(t[f>>2]|0)+8>>2]|0)|0;if(t[S>>2]|0){F=t[o>>2]|0;s=r;return F|0}S=$g(t[(t[f>>2]|0)+8>>2]|0,94240,94296,94248)|0;t[(t[(t[f>>2]|0)+8>>2]|0)+44>>2]=S;F=t[o>>2]|0;s=r;return F|0}function KN(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[f>>2]|0)){CN(t[n>>2]|0,94952);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{n=(t[f>>2]|0)+0|0;e=n+60|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(e|0));t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=0;t[(t[f>>2]|0)+12>>2]=0;t[(t[f>>2]|0)+16>>2]=0;t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+28>>2]=1;t[(t[f>>2]|0)+32>>2]=1;t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+40>>2]=0;t[(t[f>>2]|0)+48>>2]=0;t[(t[f>>2]|0)+36>>2]=0;t[(t[f>>2]|0)+24>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function XN(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}t[a>>2]=ns(t[f>>2]|0,94816)|0;if(t[a>>2]|0)t[a>>2]=(t[a>>2]|0)+7;e:do if(t[a>>2]|0){do if((u[t[a>>2]>>0]|0|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)!=13)break e}while(0);t[a>>2]=ns(t[f>>2]|0,94824)|0}while(0);if(!(t[a>>2]|0)){s=r;return}if((u[t[a>>2]>>0]|0|0)!=61){s=r;return}t[a>>2]=(t[a>>2]|0)+1;Bi(t[n>>2]|0,t[a>>2]|0);s=r;return}function ZN(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;NN(t[a>>2]|0,t[l>>2]|0)|0;t[(t[a>>2]|0)+32>>2]=1;if((t[c>>2]|0)!=0?(t[h>>2]=V_(t[c>>2]|0)|0,(t[h>>2]|0)!=0):0){Lp(t[a>>2]|0,t[h>>2]|0)|0;if(t[(t[(t[a>>2]|0)+36>>2]|0)+44>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[a>>2]|0)+36>>2]|0)+44>>2]|0);h=Yl(t[c>>2]|0)|0;t[(t[(t[a>>2]|0)+36>>2]|0)+44>>2]=h}if(((t[o>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)==0:0){h=Yl(t[o>>2]|0)|0;t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=h}EN(t[a>>2]|0)|0;t[k>>2]=t[(t[a>>2]|0)+8>>2];t[(t[a>>2]|0)+8>>2]=0;if(t[b>>2]|0){w=t[k>>2]|0;s=u;return w|0}if(((t[k>>2]|0)!=0?(t[(t[a>>2]|0)+364>>2]|0)!=0:0)?(t[(t[k>>2]|0)+80>>2]|0)==(t[(t[a>>2]|0)+296>>2]|0):0)t[(t[a>>2]|0)+296>>2]=0;Up(t[a>>2]|0);w=t[k>>2]|0;s=u;return w|0}function JN(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[f>>2]=0;t[c>>2]=0;if((t[(t[n>>2]|0)+292>>2]|0)==0?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[n>>2]|0)+36>>2]|0,250)|0;t[o>>2]=Ni(t[n>>2]|0,a)|0;e:do if(!((t[o>>2]|0)==32|(t[o>>2]|0)==62|(t[o>>2]|0)==47)){e=t[o>>2]|0;if((t[o>>2]|0)<256){if(((!(65<=(e|0)&(t[o>>2]|0)<=90)?!(97<=(t[o>>2]|0)&(t[o>>2]|0)<=122):0)?!(192<=(t[o>>2]|0)&(t[o>>2]|0)<=214):0)?!(216<=(t[o>>2]|0)&(t[o>>2]|0)<=246|248<=(t[o>>2]|0)):0)l=11}else if(!(dj(e,199744)|0))l=11;do if((l|0)==11){e=t[o>>2]|0;if((t[o>>2]|0)<256)if((e|0)!=95&(t[o>>2]|0)!=58)break e;else break;if(!(19968<=(e|0)&(t[o>>2]|0)<=40869|(t[o>>2]|0)==12295)?(12321<=(t[o>>2]|0)&(t[o>>2]|0)<=12329^1)&(t[o>>2]|0)!=95&(t[o>>2]|0)!=58:0)break e}while(0);i:while(1){if(!((t[o>>2]|0)!=32&(t[o>>2]|0)!=62&(t[o>>2]|0)!=47))break;e=t[o>>2]|0;if((t[o>>2]|0)<256){if(((!(65<=(e|0)&(t[o>>2]|0)<=90)?!(97<=(t[o>>2]|0)&(t[o>>2]|0)<=122):0)?!(192<=(t[o>>2]|0)&(t[o>>2]|0)<=214):0)?!(216<=(t[o>>2]|0)&(t[o>>2]|0)<=246|248<=(t[o>>2]|0)):0)l=23}else if(!(dj(e,199744)|0))l=23;do if((l|0)==23){l=0;if((t[o>>2]|0)>=256){if(19968<=(t[o>>2]|0)&(t[o>>2]|0)<=40869|(t[o>>2]|0)==12295)break;if(12321<=(t[o>>2]|0)&(t[o>>2]|0)<=12329)break}e=t[o>>2]|0;if((t[o>>2]|0)<256){if(48<=(e|0)&(t[o>>2]|0)<=57|(t[o>>2]|0)==46|(t[o>>2]|0)==45|(t[o>>2]|0)==95|(t[o>>2]|0)==58)break}else{b=(dj(e,200216)|0)!=0;if(b|(t[o>>2]|0)==46|(t[o>>2]|0)==45|(t[o>>2]|0)==95|(t[o>>2]|0)==58)break}if((t[o>>2]|0)>=256?(dj(t[o>>2]|0,200144)|0)!=0:0)break;b=t[o>>2]|0;if((t[o>>2]|0)<256)k=(b|0)==183&1;else k=dj(b,200272)|0;if(!k)break i}while(0);b=t[c>>2]|0;t[c>>2]=b+1;if(((b|0)>100?(t[c>>2]=0,(t[(t[n>>2]|0)+292>>2]|0)==0):0)?((t[(t[(t[n>>2]|0)+36>>2]|0)+20>>2]|0)-(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)yp(t[(t[n>>2]|0)+36>>2]|0,250)|0;t[f>>2]=(t[f>>2]|0)+(t[a>>2]|0);b=t[(t[n>>2]|0)+36>>2]|0;if((u[t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=b+28|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[(t[n>>2]|0)+36>>2]|0)+32>>2]=1}else{e=b+32|0;t[e>>2]=(t[e>>2]|0)+1}t[(t[n>>2]|0)+176>>2]=0;e=(t[(t[n>>2]|0)+36>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+(t[a>>2]|0);e=(t[n>>2]|0)+200|0;t[e>>2]=(t[e>>2]|0)+1;t[o>>2]=Ni(t[n>>2]|0,a)|0}t[r>>2]=kz(t[(t[n>>2]|0)+296>>2]|0,(t[(t[(t[n>>2]|0)+36>>2]|0)+16>>2]|0)+(0-(t[f>>2]|0))|0,t[f>>2]|0)|0;h=t[r>>2]|0;s=i;return h|0}while(0);t[r>>2]=0;h=t[r>>2]|0;s=i;return h|0}function QN(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+112|0;r=i+8|0;f=i+4|0;a=i;o=i+12|0;t[f>>2]=e;t[a>>2]=0;if(!(65<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=90:0))c=3;do if((c|0)==3){if(97<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=122:0)break;if(((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=95?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=58:0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=46:0){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}}while(0);while(1){do if((t[a>>2]|0)<100){if(65<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=90:0){b=1;break}if(97<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=122:0){b=1;break}if(48<=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=57:0){b=1;break}if(((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=58?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=45:0)?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=95:0)b=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==46;else b=1}else b=0;while(0);k=t[f>>2]|0;if(!b)break;if((u[t[(t[k+36>>2]|0)+16>>2]>>0]|0|0)>=65?(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=90:0)n[o+(t[a>>2]|0)>>0]=(u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)+32;else n[o+(t[a>>2]|0)>>0]=u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;t[a>>2]=(t[a>>2]|0)+1;Op(t[f>>2]|0)}t[r>>2]=kz(t[k+296>>2]|0,o,t[a>>2]|0)|0;l=t[r>>2]|0;s=i;return l|0}function $N(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;if(!(t[(t[n>>2]|0)+184>>2]|0))break;if(!(DN(t[f>>2]|0,t[(t[n>>2]|0)+184>>2]|0)|0))break;if((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[n>>2]>>2]|0)+60>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[(t[n>>2]|0)+184>>2]|0);xN(t[n>>2]|0)|0}if(!(t[f>>2]|0)){UN(t[n>>2]|0);s=r;return}while(1){if(t[f>>2]|0){u=20;break}if(!(t[(t[n>>2]|0)+184>>2]|0)){u=20;break}if(((Xl(t[(t[n>>2]|0)+184>>2]|0,95656)|0)==0?(Xl(t[(t[n>>2]|0)+184>>2]|0,95648)|0)==0:0)?(Xl(t[(t[n>>2]|0)+184>>2]|0,94240)|0)==0:0){u=20;break}if((t[t[n>>2]>>2]|0)!=0?(t[(t[t[n>>2]>>2]|0)+60>>2]|0)!=0:0)EAi[t[(t[t[n>>2]>>2]|0)+60>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[(t[n>>2]|0)+184>>2]|0);xN(t[n>>2]|0)|0}if((u|0)==20){s=r;return}}function eT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!((t[23702]|0)!=0?(t[(t[n>>2]|0)+360>>2]&8192|0)==0:0)){s=r;return}if(Xl(t[f>>2]|0,94240)|0){s=r;return}if(((t[(t[n>>2]|0)+188>>2]|0)<=0?(nT(t[n>>2]|0,94240)|0,(t[t[n>>2]>>2]|0)!=0):0)?(t[(t[t[n>>2]>>2]|0)+56>>2]|0)!=0:0)yAi[t[(t[t[n>>2]>>2]|0)+56>>2]&511](t[(t[n>>2]|0)+4>>2]|0,94240,0);if(Xl(t[f>>2]|0,95648)|0){s=r;return}if(Xl(t[f>>2]|0,95656)|0){s=r;return}do if((t[(t[n>>2]|0)+188>>2]|0)<=1){if((((((Xl(t[f>>2]|0,94992)|0)==0?(Xl(t[f>>2]|0,95e3)|0)==0:0)?(Xl(t[f>>2]|0,96200)|0)==0:0)?(Xl(t[f>>2]|0,96208)|0)==0:0)?(Xl(t[f>>2]|0,96216)|0)==0:0)?(Xl(t[f>>2]|0,96224)|0)==0:0)break;if((t[(t[n>>2]|0)+32>>2]|0)>=3){s=r;return}nT(t[n>>2]|0,95656)|0;if(!(t[t[n>>2]>>2]|0)){s=r;return}if(!(t[(t[t[n>>2]>>2]|0)+56>>2]|0)){s=r;return}yAi[t[(t[t[n>>2]>>2]|0)+56>>2]&511](t[(t[n>>2]|0)+4>>2]|0,95656,0);s=r;return}while(0);if(Xl(t[f>>2]|0,96232)|0){s=r;return}if(Xl(t[f>>2]|0,96248)|0){s=r;return}if(Xl(t[f>>2]|0,96256)|0){s=r;return}if((t[(t[n>>2]|0)+32>>2]|0)>=10){s=r;return}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[n>>2]|0)+188>>2]|0)){a=29;break}if(Xl(t[(t[(t[n>>2]|0)+196>>2]|0)+(t[u>>2]<<2)>>2]|0,95648)|0){a=32;break}if(Xl(t[(t[(t[n>>2]|0)+196>>2]|0)+(t[u>>2]<<2)>>2]|0,95656)|0){a=32;break}t[u>>2]=(t[u>>2]|0)+1}if((a|0)==29){nT(t[n>>2]|0,95648)|0;if(!(t[t[n>>2]>>2]|0)){s=r;return}if(!(t[(t[t[n>>2]>>2]|0)+56>>2]|0)){s=r;return}yAi[t[(t[t[n>>2]>>2]|0)+56>>2]&511](t[(t[n>>2]|0)+4>>2]|0,95648,0);s=r;return}else if((a|0)==32){s=r;return}}function iT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[a>>2]=i;t[c>>2]=0;t[t[a>>2]>>2]=0;t[o>>2]=QN(t[f>>2]|0)|0;i=t[f>>2]|0;if(!(t[o>>2]|0)){BN(i,68,97912,0,0);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}jN(i)|0;if((u[t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==61){Op(t[f>>2]|0);jN(t[f>>2]|0)|0;t[c>>2]=Ii(t[f>>2]|0)|0}t[t[a>>2]>>2]=t[c>>2];t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}function rT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;t[c>>2]=0;t[l>>2]=0;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}t[u>>2]=0;i=t[u>>2]|0;t[u>>2]=i+1;t[a>>2]=t[(t[f>>2]|0)+(i<<2)>>2];while(1){if(!(t[a>>2]|0))break;i=t[u>>2]|0;t[u>>2]=i+1;t[o>>2]=t[(t[f>>2]|0)+(i<<2)>>2];if(((t[o>>2]|0)!=0?(Ql(t[a>>2]|0,97872)|0)==0:0)?(Ql(t[o>>2]|0,97888)|0)==0:0)t[c>>2]=1;else b=8;do if((b|0)==8){b=0;if((t[o>>2]|0)!=0?(Ql(t[a>>2]|0,94816)|0)==0:0){Bi(t[n>>2]|0,t[o>>2]|0);break}if((t[o>>2]|0)!=0?(Ql(t[a>>2]|0,97904)|0)==0:0)t[l>>2]=t[o>>2]}while(0);i=t[u>>2]|0;t[u>>2]=i+1;t[a>>2]=t[(t[f>>2]|0)+(i<<2)>>2]}if(!((t[c>>2]|0)!=0&(t[l>>2]|0)!=0)){s=r;return}XN(t[n>>2]|0,t[l>>2]|0);s=r;return}function nT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[f>>2]|0)+32>>2]|0)<3?(Xl(t[u>>2]|0,95656)|0)!=0:0)t[(t[f>>2]|0)+32>>2]=3;if((t[(t[f>>2]|0)+32>>2]|0)<10?(Xl(t[u>>2]|0,95648)|0)!=0:0)t[(t[f>>2]|0)+32>>2]=10;if((t[(t[f>>2]|0)+188>>2]|0)>=(t[(t[f>>2]|0)+192>>2]|0)?(i=(t[f>>2]|0)+192|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+196>>2]|0,t[(t[f>>2]|0)+192>>2]<<2)|0,t[(t[f>>2]|0)+196>>2]=i,(t[(t[f>>2]|0)+196>>2]|0)==0):0){CN(t[f>>2]|0,0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[(t[(t[f>>2]|0)+196>>2]|0)+(t[(t[f>>2]|0)+188>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+184>>2]=t[u>>2];u=(t[f>>2]|0)+188|0;
	f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;a=t[n>>2]|0;s=r;return a|0}function fT(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0;i=s;s=s+80|0;r=i+64|0;n=i+60|0;f=i+56|0;u=i+52|0;a=i+48|0;o=i+44|0;c=i+40|0;l=i+36|0;b=i+32|0;k=i+28|0;h=i+24|0;w=i+20|0;d=i+16|0;v=i+12|0;m=i+8|0;_=i+4|0;p=i;t[n>>2]=e;t[f>>2]=t[(t[(t[n>>2]|0)+108>>2]|0)+56>>2];e:while(1){if(!(t[f>>2]|0)){E=48;break}i:do if(((t[(t[f>>2]|0)+20>>2]|0)==24?(t[(t[f>>2]|0)+32>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+32>>2]|0)+4>>2]|0)!=0:0){t[d>>2]=0;t[b>>2]=t[(t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2];t[u>>2]=t[(t[(t[n>>2]|0)+108>>2]|0)+52>>2];while(1){if(!(t[u>>2]|0))break;if((t[(t[(t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0)+36>>2]|0)+4>>2]|0)==(t[(t[u>>2]|0)+4>>2]|0))break;t[u>>2]=t[t[u>>2]>>2]}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+20>>2]|0)!=0:0)S=(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)!=0;else S=0;t[k>>2]=S?1:0;t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[(t[f>>2]|0)+32>>2]|0)+4>>2]|0))break i;t[l>>2]=0;t[d>>2]=t[(t[t[(t[f>>2]|0)+32>>2]>>2]|0)+(t[a>>2]<<2)>>2];r:do if(t[u>>2]|0){t[h>>2]=t[(t[d>>2]|0)+4>>2];t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[u>>2]|0)+12>>2]|0))break;t[w>>2]=t[(t[(t[(t[u>>2]|0)+8>>2]|0)+(t[o>>2]<<2)>>2]|0)+4>>2];t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[b>>2]|0))break;t[l>>2]=Od(t[(t[(t[w>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0,t[(t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0)|0;if(!(t[l>>2]|0))break;if((t[l>>2]|0)==-1){E=22;break e}t[c>>2]=(t[c>>2]|0)+1}if((t[l>>2]|0)==1)break;t[o>>2]=(t[o>>2]|0)+1}if((t[l>>2]|0)==0&(t[k>>2]|0)!=0){t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0))break r;t[w>>2]=t[(t[(t[t[(t[u>>2]|0)+20>>2]>>2]|0)+(t[o>>2]<<2)>>2]|0)+4>>2];t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[b>>2]|0))break;t[l>>2]=Od(t[(t[(t[w>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0,t[(t[(t[h>>2]|0)+(t[c>>2]<<2)>>2]|0)+4>>2]|0)|0;if(!(t[l>>2]|0))break;if((t[l>>2]|0)==-1){E=33;break e}t[c>>2]=(t[c>>2]|0)+1}if((t[l>>2]|0)==1)break;t[o>>2]=(t[o>>2]|0)+1}t[v>>2]=0;t[m>>2]=0;e=t[n>>2]|0;g=t[d>>2]|0;y=t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0;F=UL(t[n>>2]|0,v,t[(t[d>>2]|0)+4>>2]|0,t[b>>2]|0)|0;YL(e,1877,g,y,142400,F,Rd(m,t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(t[v>>2]|0){pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0}if(t[m>>2]|0){pAi[t[135736>>2]&511](t[m>>2]|0);t[m>>2]=0}}}while(0);if(!(t[l>>2]|0)){t[_>>2]=0;t[p>>2]=0;F=t[n>>2]|0;y=t[d>>2]|0;g=t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0;e=UL(t[n>>2]|0,_,t[(t[d>>2]|0)+4>>2]|0,t[b>>2]|0)|0;YL(F,1877,y,g,142464,e,Rd(p,t[(t[(t[f>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(t[_>>2]|0){pAi[t[135736>>2]&511](t[_>>2]|0);t[_>>2]=0}if(t[p>>2]|0){pAi[t[135736>>2]&511](t[p>>2]|0);t[p>>2]=0}}t[a>>2]=(t[a>>2]|0)+1}}while(0);t[f>>2]=t[(t[f>>2]|0)+8>>2]}if((E|0)==22){t[r>>2]=-1;O=t[r>>2]|0;s=i;return O|0}else if((E|0)==33){t[r>>2]=-1;O=t[r>>2]|0;s=i;return O|0}else if((E|0)==48){t[r>>2]=0;O=t[r>>2]|0;s=i;return O|0}return 0}function tT(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;i=s;s=s+80|0;r=i+64|0;n=i+60|0;f=i+56|0;u=i+52|0;a=i+48|0;o=i+44|0;c=i+40|0;l=i+36|0;b=i+32|0;k=i+28|0;h=i+24|0;w=i+20|0;d=i+16|0;v=i+12|0;m=i+8|0;_=i+4|0;p=i;t[n>>2]=e;t[a>>2]=0;t[c>>2]=0;t[v>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+108>>2]|0)+52>>2];if(!(t[f>>2]|0)){t[r>>2]=0;E=t[r>>2]|0;s=i;return E|0}t[u>>2]=(t[(t[(t[n>>2]|0)+100>>2]|0)+((t[(t[n>>2]|0)+96>>2]|0)-1<<2)>>2]|0)+52;e:while(1){if(!(t[f>>2]|0)){S=87;break}if(!(t[(t[f>>2]|0)+12>>2]|0)){if((t[(t[f>>2]|0)+20>>2]|0)!=0?(t[(t[(t[f>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0)S=8}else S=8;i:do if((S|0)==8){S=0;r:do if(!(t[(t[n>>2]|0)+188>>2]|0)){t[k>>2]=t[(t[n>>2]|0)+112>>2];while(1){g=t[k>>2]|0;if((t[(t[k>>2]|0)+4>>2]|0)==(t[(t[f>>2]|0)+4>>2]|0))break;t[k>>2]=t[g>>2];if(!(t[k>>2]|0))break r}if((t[g+8>>2]|0)==-1)break i;if((t[(t[k>>2]|0)+8>>2]|0)>=(t[(t[n>>2]|0)+96>>2]|0))break i}while(0);if(t[u>>2]|0)t[a>>2]=t[t[u>>2]>>2];while(1){if(!(t[a>>2]|0))break;if((t[(t[a>>2]|0)+4>>2]|0)==(t[(t[f>>2]|0)+4>>2]|0))break;t[a>>2]=t[t[a>>2]>>2]}if(!(t[a>>2]|0)){t[a>>2]=GL(t[(t[f>>2]|0)+4>>2]|0)|0;if(!(t[a>>2]|0))break e;do if(t[(t[f>>2]|0)+12>>2]|0){if(!(t[(t[n>>2]|0)+192>>2]|0)){t[(t[a>>2]|0)+8>>2]=t[(t[f>>2]|0)+8>>2];t[(t[f>>2]|0)+8>>2]=0;t[(t[a>>2]|0)+16>>2]=t[(t[f>>2]|0)+16>>2];t[(t[f>>2]|0)+16>>2]=0;t[(t[a>>2]|0)+12>>2]=t[(t[f>>2]|0)+12>>2];t[(t[f>>2]|0)+12>>2]=0;break}e=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+12>>2]<<2)|0;t[(t[a>>2]|0)+8>>2]=e;if(!(t[(t[a>>2]|0)+8>>2]|0)){S=76;break e}t[(t[a>>2]|0)+16>>2]=t[(t[f>>2]|0)+12>>2];t[(t[a>>2]|0)+12>>2]=t[(t[f>>2]|0)+12>>2];YY(t[(t[a>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+12>>2]<<2|0)|0}while(0);if(t[(t[f>>2]|0)+20>>2]|0){if(t[(t[a>>2]|0)+20>>2]|0)Wk(t[(t[a>>2]|0)+20>>2]|0);t[(t[a>>2]|0)+20>>2]=t[(t[f>>2]|0)+20>>2];t[(t[f>>2]|0)+20>>2]=0}if(!(t[u>>2]|0))break;if(!(t[t[u>>2]>>2]|0)){t[t[u>>2]>>2]=t[a>>2];break}else{t[t[a>>2]>>2]=t[t[u>>2]>>2];t[t[u>>2]>>2]=t[a>>2];break}}t[_>>2]=t[(t[a>>2]|0)+12>>2];if((t[(t[a>>2]|0)+20>>2]|0)!=0?(t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0){t[p>>2]=t[(t[(t[a>>2]|0)+20>>2]|0)+4>>2];t[l>>2]=t[t[(t[a>>2]|0)+20>>2]>>2]}else{t[l>>2]=0;t[p>>2]=0}t[b>>2]=t[(t[a>>2]|0)+8>>2];t[m>>2]=t[(t[(t[f>>2]|0)+4>>2]|0)+32>>2];t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[(t[f>>2]|0)+12>>2]|0))break i;t[o>>2]=t[(t[(t[f>>2]|0)+8>>2]|0)+(t[h>>2]<<2)>>2];do if(t[o>>2]|0){if(t[p>>2]|0){t[w>>2]=0;r:while(1){if((t[w>>2]|0)>=(t[p>>2]|0))break;n:do if((t[m>>2]|0)==1){t[v>>2]=Od(t[(t[t[(t[o>>2]|0)+4>>2]>>2]|0)+4>>2]|0,t[(t[t[(t[(t[l>>2]|0)+(t[w>>2]<<2)>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((t[v>>2]|0)==-1)break e;if(t[v>>2]|0)break;t[w>>2]=(t[w>>2]|0)+1;continue r}else{t[c>>2]=t[(t[l>>2]|0)+(t[w>>2]<<2)>>2];t[d>>2]=0;while(1){if((t[d>>2]|0)>=(t[m>>2]|0))break n;t[v>>2]=Od(t[(t[(t[(t[o>>2]|0)+4>>2]|0)+(t[d>>2]<<2)>>2]|0)+4>>2]|0,t[(t[(t[(t[c>>2]|0)+4>>2]|0)+(t[d>>2]<<2)>>2]|0)+4>>2]|0)|0;if((t[v>>2]|0)==-1)break e;if(!(t[v>>2]|0))break n;t[d>>2]=(t[d>>2]|0)+1}}while(0);if((t[v>>2]|0)==1)break;t[w>>2]=(t[w>>2]|0)+1}if(!((t[_>>2]|0)!=0?(t[w>>2]|0)==(t[p>>2]|0):0))break}else if(!(t[_>>2]|0))break;t[w>>2]=0;r:while(1){if((t[w>>2]|0)>=(t[_>>2]|0))break;t[c>>2]=t[(t[b>>2]|0)+(t[w>>2]<<2)>>2];n:do if((t[m>>2]|0)==1){t[v>>2]=Od(t[(t[t[(t[o>>2]|0)+4>>2]>>2]|0)+4>>2]|0,t[(t[t[(t[c>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((t[v>>2]|0)==-1)break e;if(!(t[v>>2]|0)){t[w>>2]=(t[w>>2]|0)+1;continue r}}else{t[d>>2]=0;while(1){if((t[d>>2]|0)>=(t[m>>2]|0))break n;t[v>>2]=Od(t[(t[(t[(t[o>>2]|0)+4>>2]|0)+(t[d>>2]<<2)>>2]|0)+4>>2]|0,t[(t[(t[(t[c>>2]|0)+4>>2]|0)+(t[d>>2]<<2)>>2]|0)+4>>2]|0)|0;if((t[v>>2]|0)==-1)break e;if(!(t[v>>2]|0))break n;t[d>>2]=(t[d>>2]|0)+1}}while(0);if((t[v>>2]|0)==1)break;t[w>>2]=(t[w>>2]|0)+1}if((t[w>>2]|0)!=(t[_>>2]|0)){t[_>>2]=(t[_>>2]|0)+-1;e=(t[a>>2]|0)+12|0;t[e>>2]=(t[e>>2]|0)+-1;t[(t[b>>2]|0)+(t[w>>2]<<2)>>2]=t[(t[b>>2]|0)+(t[_>>2]<<2)>>2];if((t[(t[a>>2]|0)+12>>2]|0)!=(t[_>>2]|0))t[(t[b>>2]|0)+(t[_>>2]<<2)>>2]=t[(t[b>>2]|0)+(t[(t[a>>2]|0)+12>>2]<<2)>>2];if((t[(t[a>>2]|0)+20>>2]|0)==0?(e=hh()|0,t[(t[a>>2]|0)+20>>2]=e,(t[(t[a>>2]|0)+20>>2]|0)==0):0)break e;Cd(t[(t[a>>2]|0)+20>>2]|0,t[c>>2]|0)|0;break}if(t[(t[a>>2]|0)+8>>2]|0){if((t[(t[a>>2]|0)+12>>2]|0)>=(t[(t[a>>2]|0)+16>>2]|0)?(e=(t[a>>2]|0)+16|0,t[e>>2]=t[e>>2]<<1,e=MAi[t[135760>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+16>>2]<<2)|0,t[(t[a>>2]|0)+8>>2]=e,(t[(t[a>>2]|0)+8>>2]|0)==0):0){S=68;break e}}else{e=gAi[t[135744>>2]&511](40)|0;t[(t[a>>2]|0)+8>>2]=e;if(!(t[(t[a>>2]|0)+8>>2]|0)){S=64;break e}t[(t[a>>2]|0)+16>>2]=1}t[b>>2]=t[(t[a>>2]|0)+8>>2];e=t[o>>2]|0;y=(t[a>>2]|0)+12|0;F=t[y>>2]|0;t[y>>2]=F+1;t[(t[b>>2]|0)+(F<<2)>>2]=e}while(0);t[h>>2]=(t[h>>2]|0)+1}}while(0);t[f>>2]=t[t[f>>2]>>2]}if((S|0)==64)kh(0,142168,0);else if((S|0)==68)kh(0,142208,0);else if((S|0)==76){kh(0,142256,0);_d(t[a>>2]|0)}else if((S|0)==87){t[r>>2]=0;E=t[r>>2]|0;s=i;return E|0}t[r>>2]=-1;E=t[r>>2]|0;s=i;return E|0}function uT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=Zk()|0;if(!(t[a>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[(t[a>>2]|0)+80>>2]=t[u>>2];sz(t[u>>2]|0)|0;if(t[f>>2]|0){i=kz(t[u>>2]|0,t[f>>2]|0,-1)|0;t[(t[a>>2]|0)+44>>2]=i}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function aT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[u>>2]|0)){kh(t[f>>2]|0,141168,0);s=r;return}t[(t[u>>2]|0)+8>>2]=-1;t[(t[u>>2]|0)+4>>2]=t[n>>2];t[t[u>>2]>>2]=0;if(!(t[(t[f>>2]|0)+112>>2]|0))t[(t[f>>2]|0)+112>>2]=t[u>>2];else{t[t[u>>2]>>2]=t[(t[f>>2]|0)+112>>2];t[(t[f>>2]|0)+112>>2]=t[u>>2]}if(t[(t[f>>2]|0)+184>>2]|0){s=r;return}if((t[t[n>>2]>>2]|0)!=24){s=r;return}t[(t[f>>2]|0)+184>>2]=1;s=r;return}function oT(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[(t[r>>2]|0)+8>>2];if(t[(t[r>>2]|0)+24>>2]|0){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[r>>2]|0)+28>>2]|0))break;if(t[(t[(t[r>>2]|0)+24>>2]|0)+(t[f>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[r>>2]|0)+24>>2]|0)+(t[f>>2]<<2)>>2]|0);t[f>>2]=(t[f>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0)}if(t[(t[r>>2]|0)+32>>2]|0){e:do if((t[(t[r>>2]|0)+20>>2]|0)==24){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[(t[r>>2]|0)+32>>2]|0)+4>>2]|0))break e;t[a>>2]=t[(t[t[(t[r>>2]|0)+32>>2]>>2]|0)+(t[u>>2]<<2)>>2];pAi[t[135736>>2]&511](t[(t[a>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);t[u>>2]=(t[u>>2]|0)+1}}while(0);Wk(t[(t[r>>2]|0)+32>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function cT(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(t[t[r>>2]>>2]|0){pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);t[t[r>>2]>>2]=0}t[(t[r>>2]|0)+4>>2]=0;t[(t[r>>2]|0)+8>>2]=0;s=i;return}function lT(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do switch(t[n>>2]|0){case 18:{t[r>>2]=143832;break}case 17:{t[r>>2]=143776;break}case 24:{t[r>>2]=144e3;break}case 6:{t[r>>2]=143856;break}case 8:{t[r>>2]=143904;break}case 22:{t[r>>2]=143944;break}case 23:{t[r>>2]=143976;break}case 16:{t[r>>2]=143800;break}case 26:{t[r>>2]=143736;break}case 14:{t[r>>2]=143712;break}case 1:{t[r>>2]=143688;break}case 2e3:{t[r>>2]=144048;break}case 7:{t[r>>2]=143880;break}case 2001:{t[r>>2]=144088;break}case 4:{t[r>>2]=143688;break}case 25:{t[r>>2]=143928;break}case 5:{t[r>>2]=143664;break}case 2:{t[r>>2]=144032;break}case 15:{t[r>>2]=143752;break}default:t[r>>2]=144136}while(0);s=i;return t[r>>2]|0}function sT(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;o=s;s=s+32|0;c=o+24|0;l=o+20|0;b=o+16|0;k=o+12|0;h=o+8|0;w=o+4|0;d=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;Ld(t[c>>2]|0,2,t[l>>2]|0,t[b>>2]|0,0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,0);s=o;return}function bT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+24|0;o=n+20|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;t[h>>2]=0;if(t[t[a>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[a>>2]>>2]|0);t[t[a>>2]>>2]=0;e:while(1){t[l>>2]=Ed(t[(t[o>>2]|0)+64>>2]|0)|0;t[c>>2]=t[(t[o>>2]|0)+68>>2];while(1){if(!(t[c>>2]|0))break;if((t[t[c>>2]>>2]|0)==1007){t[h>>2]=1;t[k>>2]=WL(t[(t[c>>2]|0)+32>>2]|0,t[l>>2]|0,b)|0;if((t[k>>2]|0)==-1)break e;if(!(t[t[a>>2]>>2]|0)){r=Yl(142568)|0;t[t[a>>2]>>2]=r}else{r=us(t[t[a>>2]>>2]|0,157648)|0;t[t[a>>2]>>2]=r}r=us(t[t[a>>2]>>2]|0,t[b>>2]|0)|0;t[t[a>>2]>>2]=r;r=us(t[t[a>>2]>>2]|0,142568)|0;t[t[a>>2]>>2]=r;if(t[b>>2]|0){pAi[t[135736>>2]&511](t[b>>2]|0);t[b>>2]=0}}t[c>>2]=t[(t[c>>2]|0)+4>>2]}if(t[h>>2]|0){w=20;break}t[o>>2]=t[(t[o>>2]|0)+64>>2];if(!(t[o>>2]|0)){w=20;break}if((t[t[o>>2]>>2]|0)==1){w=20;break}}if((w|0)==20){t[f>>2]=t[t[a>>2]>>2];d=t[f>>2]|0;s=n;return d|0}rh(t[u>>2]|0,157568,157600);if(t[t[a>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[a>>2]>>2]|0);t[t[a>>2]>>2]=0;t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}function kT(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do switch(t[t[n>>2]>>2]|0){case 14:{t[r>>2]=t[(t[n>>2]|0)+52>>2];break}case 2e3:{t[r>>2]=t[(t[n>>2]|0)+16>>2];break}case 15:{t[r>>2]=t[(t[n>>2]|0)+56>>2];break}case 18:{t[r>>2]=t[(t[n>>2]|0)+16>>2];break}case 26:{if(t[(t[n>>2]|0)+12>>2]|0)t[r>>2]=kT(t[(t[n>>2]|0)+12>>2]|0)|0;else f=13;break}case 24:case 22:case 23:{t[r>>2]=t[(t[n>>2]|0)+20>>2];break}case 1:{t[r>>2]=142520;break}case 16:{t[r>>2]=t[(t[n>>2]|0)+52>>2];break}case 5:case 4:{t[r>>2]=t[(t[n>>2]|0)+112>>2];break}case 17:{t[r>>2]=t[(t[n>>2]|0)+20>>2];break}default:f=13}while(0);if((f|0)==13)t[r>>2]=0;s=i;return t[r>>2]|0}function hT(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e:do switch(t[t[n>>2]>>2]|0){case 17:{t[r>>2]=t[(t[n>>2]|0)+16>>2];break}case 18:{t[r>>2]=t[(t[n>>2]|0)+4>>2];break}case 14:{t[r>>2]=t[(t[n>>2]|0)+8>>2];break}case 16:{t[r>>2]=t[(t[n>>2]|0)+8>>2];break}case 5:case 4:case 1:{t[r>>2]=t[(t[n>>2]|0)+8>>2];break}case 2e3:{t[r>>2]=t[(t[n>>2]|0)+12>>2];break}case 26:{if(t[(t[n>>2]|0)+12>>2]|0){t[r>>2]=hT(t[(t[n>>2]|0)+12>>2]|0)|0;break e}else{t[r>>2]=0;break e}break}case 15:{t[r>>2]=t[(t[n>>2]|0)+8>>2];break}case 24:case 22:case 23:{t[r>>2]=t[(t[n>>2]|0)+16>>2];break}default:t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function wT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[o>>2]=KL(t[u>>2]|0)|0;t[a>>2]=Vg(t[o>>2]|0,1)|0;do if(!(t[a>>2]|0)){if((t[(t[u>>2]|0)+40>>2]|0)!=2){t[l>>2]=TD(t[o>>2]|0)|0;if(t[l>>2]|0){pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=t[l>>2]}t[c>>2]=zM(0,t[(t[u>>2]|0)+32>>2]|0,t[o>>2]|0,t[u>>2]|0)|0;if(!(t[c>>2]|0)){t[a>>2]=3037;i=t[f>>2]|0;e=t[u>>2]|0;k=ED(23)|0;Ud(i,3037,0,e,k,0,0,161408,t[o>>2]|0,0);break}else{t[(t[u>>2]|0)+40>>2]=2;break}}}else if((t[a>>2]|0)>0){t[a>>2]=3037;k=t[f>>2]|0;e=t[u>>2]|0;i=ED(23)|0;Ud(k,3037,0,e,i,0,0,161456,t[o>>2]|0,0)}while(0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}function dT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if((t[o>>2]|0)==0|(t[k>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=-1;w=t[a>>2]|0;s=u;return w|0}if((t[t[k>>2]>>2]|0)!=1){rh(t[o>>2]|0,162480,162512);t[a>>2]=-1;w=t[a>>2]|0;s=u;return w|0}switch(t[(t[k>>2]|0)+88>>2]|0){case 17:case 16:case 29:case 21:case 22:break;default:{rh(t[o>>2]|0,162480,162552);t[a>>2]=-1;w=t[a>>2]|0;s=u;return w|0}}t[h>>2]=LD(t[k>>2]|0,t[b>>2]|0,0,t[l>>2]|0)|0;if((t[h>>2]|0)<0){rh(t[o>>2]|0,162480,162624);t[a>>2]=-1;w=t[a>>2]|0;s=u;return w|0}if((t[h>>2]|0)>0){if(t[(t[k>>2]|0)+48>>2]&64)t[h>>2]=1825;else t[h>>2]=1824;Ud(t[o>>2]|0,t[h>>2]|0,t[c>>2]|0,t[l>>2]|0,t[k>>2]|0,0,t[b>>2]|0,0,0,0)}t[a>>2]=t[h>>2];w=t[a>>2]|0;s=u;return w|0}function vT(e,i,r,n,f,u,a,o,c,l,b,k){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;b=b|0;k=k|0;var h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0;h=s;s=s+80|0;w=h;d=h+76|0;v=h+72|0;m=h+68|0;_=h+64|0;p=h+60|0;E=h+56|0;S=h+52|0;g=h+48|0;y=h+44|0;F=h+40|0;O=h+36|0;A=h+32|0;M=h+28|0;R=h+24|0;N=h+20|0;t[d>>2]=e;t[v>>2]=i;t[m>>2]=r;t[_>>2]=n;t[p>>2]=f;t[E>>2]=u;t[S>>2]=a;t[g>>2]=o;t[y>>2]=c;t[F>>2]=l;t[O>>2]=b;t[A>>2]=k;t[M>>2]=0;t[R>>2]=0;t[N>>2]=0;if(t[d>>2]|0){k=(t[d>>2]|0)+20|0;t[k>>2]=(t[k>>2]|0)+1;t[(t[d>>2]|0)+16>>2]=t[m>>2];t[M>>2]=t[(t[d>>2]|0)+8>>2];t[N>>2]=t[(t[d>>2]|0)+4>>2];t[R>>2]=t[(t[d>>2]|0)+24>>2]}k=t[R>>2]|0;R=t[M>>2]|0;M=t[N>>2]|0;N=t[d>>2]|0;d=t[v>>2]|0;v=t[m>>2]|0;m=t[_>>2]|0;_=t[p>>2]|0;p=t[E>>2]|0;E=t[S>>2]|0;S=t[y>>2]|0;y=t[F>>2]|0;F=t[O>>2]|0;O=t[A>>2]|0;t[w>>2]=t[g>>2];t[w+4>>2]=S;t[w+8>>2]=y;t[w+12>>2]=F;t[w+16>>2]=O;cp(k,R,M,N,d,16,v,2,0,0,m,_,p,0,0,E,w);s=h;return}function mT(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[a>>2]|0)){Qh(t[f>>2]|0,168864,t[u>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{f=t[a>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[(t[a>>2]|0)+4>>2]=t[u>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function _T(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[f+12>>2]=r;t[o>>2]=n;t[c>>2]=0;t[l>>2]=0;bw(c,t[u>>2]|0,t[(t[o>>2]|0)+20>>2]|0)|0;n=t[u>>2]|0;u=t[a>>2]|0;a=t[o>>2]|0;r=t[c>>2]|0;kw(n,u,a,163216,r,XL(l,t[(t[o>>2]|0)+36>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0,0,0);if(t[c>>2]|0){pAi[t[135736>>2]&511](t[c>>2]|0);t[c>>2]=0}if(!(t[l>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0;s=f;return}function pT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if((t[c>>2]|0)==0|(t[h>>2]|0)==0){if(t[w>>2]|0)t[t[w>>2]>>2]=0;t[o>>2]=-1;v=t[o>>2]|0;s=a;return v|0}if((t[t[h>>2]>>2]|0)!=1){if(t[w>>2]|0)t[t[w>>2]>>2]=0;pw(t[c>>2]|0,t[b>>2]|0,3069,168672,t[(t[h>>2]|0)+8>>2]|0,0);t[o>>2]=-1;v=t[o>>2]|0;s=a;return v|0}t[d>>2]=Bd(t[b>>2]|0,t[k>>2]|0)|0;if(t[d>>2]|0){t[o>>2]=Id(t[c>>2]|0,t[l>>2]|0,t[d>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;v=t[o>>2]|0;s=a;return v|0}if(t[w>>2]|0)t[t[w>>2]>>2]=0;t[o>>2]=0;v=t[o>>2]|0;s=a;return v|0}function ET(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=t[(t[u>>2]|0)+44>>2];while(1){if(!(t[c>>2]|0)){b=10;break}if(((t[(t[c>>2]|0)+36>>2]|0)!=0?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[o>>2]|0)|0)!=0:0)?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[a>>2]|0)|0)!=0:0){b=8;break}t[c>>2]=t[(t[c>>2]|0)+24>>2]}if((b|0)==8){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}else if((b|0)==10){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}return 0}function ST(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(t[a>>2]|0){if(!(t[o>>2]|0)){t[f>>2]=t[a>>2];k=t[f>>2]|0;s=n;return k|0}t[b>>2]=0;t[c>>2]=oF(t[(t[o>>2]|0)+32>>2]|0,t[o>>2]|0)|0;r=t[a>>2]|0;if(!(t[c>>2]|0))t[l>>2]=GA(r,t[(t[(t[o>>2]|0)+32>>2]|0)+72>>2]|0)|0;else{t[l>>2]=GA(r,t[c>>2]|0)|0;pAi[t[135736>>2]&511](t[c>>2]|0)}if(t[l>>2]|0){t[b>>2]=kz(t[u>>2]|0,t[l>>2]|0,-1)|0;pAi[t[135736>>2]&511](t[l>>2]|0);t[f>>2]=t[b>>2];k=t[f>>2]|0;s=n;return k|0}}t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}function gT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if(!(t[o>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}if(t[(t[o>>2]|0)+32>>2]|0){rh(t[u>>2]|0,168128,168152);t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}r=t[u>>2]|0;if(!(t[(t[o>>2]|0)+20>>2]|0)){rh(r,168128,168176);t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}if(!(t[r+28>>2]|0)){rh(t[u>>2]|0,168128,155336);t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=uT(t[(t[o>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+80>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}t[(t[c>>2]|0)+28>>2]=t[(t[u>>2]|0)+28>>2];t[(t[c>>2]|0)+36>>2]=t[a>>2];Dk(t[c>>2]|0,t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+12>>2]|0,t[(t[u>>2]|0)+4>>2]|0);Pk(t[c>>2]|0,t[(t[u>>2]|0)+24>>2]|0,t[(t[u>>2]|0)+4>>2]|0);t[(t[c>>2]|0)+40>>2]=t[(t[u>>2]|0)+40>>2];t[l>>2]=sh(t[c>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(t[l>>2]|0)t[(t[u>>2]|0)+16>>2]=t[l>>2];o=(t[u>>2]|0)+20|0;t[o>>2]=(t[o>>2]|0)+(t[(t[c>>2]|0)+20>>2]|0);t[(t[u>>2]|0)+40>>2]=t[(t[c>>2]|0)+40>>2];t[(t[c>>2]|0)+28>>2]=0;Rk(t[c>>2]|0);t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}function yT(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f+40|0;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;d=f+4|0;v=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;t[k>>2]=0;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}t[h>>2]=ZL(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,k,t[l>>2]|0)|0;if(t[h>>2]|0){t[u>>2]=t[h>>2];m=t[u>>2]|0;s=f;return m|0}t[h>>2]=lh(t[a>>2]|0,t[l>>2]|0,t[k>>2]|0,0,0,0,t[c>>2]|0,t[(t[a>>2]|0)+112>>2]|0,0,v)|0;if(t[h>>2]|0){t[u>>2]=t[h>>2];m=t[u>>2]|0;s=f;return m|0}e:do if((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+20>>2]|0)!=0:0){n=t[(t[a>>2]|0)+112>>2]|0;do if(t[(t[v>>2]|0)+12>>2]|0){if(!n){th(t[a>>2]|0,3050,t[c>>2]|0,0,167648,t[k>>2]|0,0);break}if(Xl(t[(t[v>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+112>>2]|0)|0)break e;iL(t[a>>2]|0,3050,0,t[c>>2]|0,167792,t[(t[v>>2]|0)+12>>2]|0,t[k>>2]|0,t[(t[a>>2]|0)+112>>2]|0)}else{if(!n)break e;t[w>>2]=1;if((t[(t[v>>2]|0)+32>>2]|0)!=0?(t[(t[v>>2]|0)+12>>2]|0)!=0:0){th(t[a>>2]|0,3050,t[c>>2]|0,0,167912,t[k>>2]|0,0);break}t[(t[v>>2]|0)+16>>2]=t[(t[a>>2]|0)+112>>2];break e}while(0);t[u>>2]=t[(t[a>>2]|0)+16>>2];m=t[u>>2]|0;s=f;return m|0}else _=9;while(0);do if((_|0)==9)if((t[l>>2]|0)==2){t[h>>2]=3050;th(t[a>>2]|0,t[h>>2]|0,t[c>>2]|0,0,167544,t[k>>2]|0,0);break}else{t[h>>2]=3081;th(t[a>>2]|0,t[h>>2]|0,t[c>>2]|0,0,167592,t[k>>2]|0,0);break}while(0);if(((t[v>>2]|0)!=0?(t[(t[v>>2]|0)+32>>2]|0)==0:0)?(t[(t[v>>2]|0)+20>>2]|0)!=0:0){do if(t[w>>2]|0)if(!(t[(t[o>>2]|0)+24>>2]&512)){k=(t[o>>2]|0)+24|0;t[k>>2]=t[k>>2]|512;break}else{t[d>>2]=1;break}while(0);gT(t[a>>2]|0,t[o>>2]|0,t[v>>2]|0)|0;if(!((t[w>>2]|0)==0|(t[d>>2]|0)!=0)){d=(t[o>>2]|0)+24|0;t[d>>2]=t[d>>2]^512}}t[b>>2]=t[(t[c>>2]|0)+12>>2];if((t[l>>2]|0)!=3){if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)t[b>>2]=t[(t[b>>2]|0)+24>>2]}else{t[(t[a>>2]|0)+116>>2]=t[v>>2];t[(t[a>>2]|0)+100>>2]=1;e:while(1){if(!((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0))_=37;do if((_|0)==37){_=0;if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if(!(t[b>>2]|0))break e;if(!(t[(t[b>>2]|0)+36>>2]|0))break e;if(!(Xl(t[(t[b>>2]|0)+8>>2]|0,161064)|0))break e;if(!(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break e}while(0);if(!((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0))_=57;do if((_|0)==57){_=0;if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Wd(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0,1)|0;break}if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Gd(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0,1)|0;break}if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){Jd(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0)|0;break}if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161064)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)Zd(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0)|0}while(0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}t[(t[a>>2]|0)+116>>2]=0;t[(t[a>>2]|0)+100>>2]=0}do if(t[b>>2]|0){t[h>>2]=3033;o=t[a>>2]|0;_=t[h>>2]|0;v=t[c>>2]|0;d=t[b>>2]|0;if((t[l>>2]|0)==3){$d(o,_,0,v,d,0,168056);break}else{$d(o,_,0,v,d,0,161392);break}}while(0);t[u>>2]=t[h>>2];m=t[u>>2]|0;s=f;return m|0}function FT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=0;sw(w,0,t[l>>2]|0,t[b>>2]|0)|0;l=t[o>>2]|0;o=t[b>>2]|0;b=t[c>>2]|0;c=t[w>>2]|0;if(t[h>>2]|0)pw(l,o,b,161256,c,t[h>>2]|0);else pw(l,o,b,163272,c,t[k>>2]|0);if(!(t[w>>2]|0)){s=a;return}pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0;s=a;return}function OT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;t[c>>2]=0;t[o>>2]=sF(t[a>>2]|0)|0;do if(!(Xl(t[o>>2]|0,165504)|0)){if(Xl(t[o>>2]|0,165512)|0){t[c>>2]=0;break}if(Xl(t[o>>2]|0,161736)|0){t[c>>2]=1;break}if(Xl(t[o>>2]|0,165520)|0){t[c>>2]=0;break}else{r=t[f>>2]|0;i=t[u>>2]|0;e=t[a>>2]|0;l=ED(15)|0;Ud(r,1714,i,e,l,0,t[o>>2]|0,0,0,0);break}}else t[c>>2]=1;while(0);if(!(t[o>>2]|0)){b=t[c>>2]|0;s=n;return b|0}pAi[t[135736>>2]&511](t[o>>2]|0);b=t[c>>2]|0;s=n;return b|0}function AT(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}t[t[l>>2]>>2]=0;t[b>>2]=t[(t[a>>2]|0)+84>>2];t[(t[b>>2]|0)+52>>2]=4;t[h>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;n=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if(!(Xl(t[n+8>>2]|0,161384)|0))_T(t[a>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;t[k>>2]=t[(t[c>>2]|0)+12>>2];if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=t[b>>2]|0;JL(h,jd(t[a>>2]|0,t[k>>2]|0,1)|0)|0;t[k>>2]=t[(t[k>>2]|0)+24>>2]}if(!(t[k>>2]|0))$d(t[a>>2]|0,3034,0,t[c>>2]|0,0,0,167392);if(!(t[k>>2]|0))$d(t[a>>2]|0,3034,0,t[c>>2]|0,0,0,167392);if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,165456)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){DT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,9)|0;t[t[l>>2]>>2]=1;t[k>>2]=t[(t[k>>2]|0)+24>>2]}else d=25;if(((((d|0)==25?(t[k>>2]|0)!=0:0)?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,165440)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){QL(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,9)|0;t[t[l>>2]>>2]=1;t[k>>2]=t[(t[k>>2]|0)+24>>2]}if(t[k>>2]|0)$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[k>>2]|0,0,167392);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function MT(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}t[t[l>>2]>>2]=0;t[b>>2]=t[(t[a>>2]|0)+84>>2];t[h>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;n=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if((Xl(t[n+8>>2]|0,161384)|0)==0?(Xl(t[(t[h>>2]|0)+8>>2]|0,167064)|0)==0:0)_T(t[a>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;if((WT(t[a>>2]|0,t[c>>2]|0,167064,0)|0)!=0?(t[(t[b>>2]|0)+48>>2]&1|0)==0:0){h=(t[b>>2]|0)+48|0;t[h>>2]=t[h>>2]|1}t[k>>2]=t[(t[c>>2]|0)+12>>2];if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=t[b>>2]|0;JL(h,jd(t[a>>2]|0,t[k>>2]|0,1)|0)|0;t[k>>2]=t[(t[k>>2]|0)+24>>2]}if(!(t[k>>2]|0))$d(t[a>>2]|0,3034,0,t[c>>2]|0,0,0,167392);if(!(t[k>>2]|0))$d(t[a>>2]|0,3034,0,t[c>>2]|0,0,0,167392);if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,165456)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){DT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,10)|0;t[t[l>>2]>>2]=1;t[k>>2]=t[(t[k>>2]|0)+24>>2]}else d=29;if(((((d|0)==29?(t[k>>2]|0)!=0:0)?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,165440)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){QL(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,10)|0;t[t[l>>2]>>2]=1;t[k>>2]=t[(t[k>>2]|0)+24>>2]}if(t[k>>2]|0)$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[k>>2]|0,0,167392);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function RT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;u=s;s=s+80|0;a=u+76|0;o=u+72|0;c=u+68|0;l=u+64|0;b=u+60|0;k=u+56|0;h=u+52|0;w=u+48|0;d=u+44|0;v=u+40|0;m=u+36|0;_=u+32|0;p=u+28|0;E=u+24|0;S=u+20|0;g=u+16|0;y=u+12|0;F=u+8|0;O=u+4|0;A=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;t[d>>2]=0;t[m>>2]=1;t[_>>2]=1;t[E>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=0;M=t[a>>2]|0;s=u;return M|0}t[h>>2]=Rv(t[o>>2]|0,t[c>>2]|0,t[b>>2]|0,t[l>>2]|0)|0;if(!(t[h>>2]|0)){t[a>>2]=0;M=t[a>>2]|0;s=u;return M|0}e:do if(t[k>>2]|0){f=t[o>>2]|0;n=t[l>>2]|0;if((t[b>>2]|0)==8){t[m>>2]=BT(f,n,0,1,1,161728)|0;t[_>>2]=IT(t[o>>2]|0,t[l>>2]|0,1,1,1,161736)|0}else{t[m>>2]=BT(f,n,0,-1,1,161744)|0;t[_>>2]=IT(t[o>>2]|0,t[l>>2]|0,0,1073741824,1,161768)|0}HT(t[o>>2]|0,0,t[l>>2]|0,t[m>>2]|0,t[_>>2]|0)|0;t[w>>2]=Mv(t[o>>2]|0,t[l>>2]|0,t[m>>2]|0,t[_>>2]|0)|0;if(!(t[w>>2]|0)){t[a>>2]=0;M=t[a>>2]|0;s=u;return M|0}t[(t[w>>2]|0)+12>>2]=t[h>>2];t[v>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[v>>2]|0))break e;n=t[v>>2]|0;if(!(t[(t[v>>2]|0)+36>>2]|0)){if(((Xl(t[n+8>>2]|0,161384)|0)==0?(Xl(t[(t[v>>2]|0)+8>>2]|0,161808)|0)==0:0)?(Xl(t[(t[v>>2]|0)+8>>2]|0,161824)|0)==0:0)_T(t[o>>2]|0,3035,0,t[v>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[o>>2]|0,3035,0,t[v>>2]|0);t[v>>2]=t[(t[v>>2]|0)+24>>2]}}else{t[v>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[v>>2]|0))break e;n=t[v>>2]|0;if(!(t[(t[v>>2]|0)+36>>2]|0)){if(!(Xl(t[n+8>>2]|0,161384)|0))_T(t[o>>2]|0,3035,0,t[v>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[o>>2]|0,3035,0,t[v>>2]|0);t[v>>2]=t[(t[v>>2]|0)+24>>2]}}while(0);Pd(t[o>>2]|0,t[l>>2]|0,161384)|0;t[d>>2]=t[(t[l>>2]|0)+12>>2];if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){v=jd(t[o>>2]|0,t[d>>2]|0,1)|0;t[(t[h>>2]|0)+4>>2]=v;t[d>>2]=t[(t[d>>2]|0)+24>>2]}if((t[b>>2]|0)==8){t[g>>2]=0;while(1){if(!(t[d>>2]|0))break;if(!(t[(t[d>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[d>>2]|0)+8>>2]|0,161040)|0))break;if(!(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break;t[S>>2]=Kd(t[o>>2]|0,t[c>>2]|0,t[d>>2]|0,p,0)|0;if(t[S>>2]|0){if(t[p>>2]|0)t[E>>2]=(t[E>>2]|0)+1;if((t[(t[S>>2]|0)+16>>2]|0)>1){sv(t[o>>2]|0,3091,0,t[d>>2]|0,161840,0);t[(t[S>>2]|0)+16>>2]=1}if((t[(t[S>>2]|0)+20>>2]|0)>1){sv(t[o>>2]|0,3091,0,t[d>>2]|0,161888,0);t[(t[S>>2]|0)+20>>2]=1}b=t[S>>2]|0;if(!(t[g>>2]|0))t[(t[h>>2]|0)+12>>2]=b;else t[(t[g>>2]|0)+8>>2]=b;t[g>>2]=t[S>>2]}t[d>>2]=t[(t[d>>2]|0)+24>>2]}if(t[d>>2]|0)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[d>>2]|0,0,161936)}else{t[y>>2]=0;t[F>>2]=0;while(1){if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161040)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)R=1;else N=59;do if((N|0)==59){N=0;if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){R=1;break}if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161976)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){R=1;break}if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){R=1;break}if(((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161664)|0)!=0:0)R=(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0;else R=0}while(0);T=(t[d>>2]|0)!=0;if(!R)break;if(((T?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161040)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){
	t[y>>2]=Kd(t[o>>2]|0,t[c>>2]|0,t[d>>2]|0,p,0)|0;if((t[y>>2]|0)!=0&(t[p>>2]|0)!=0)t[E>>2]=(t[E>>2]|0)+1}else N=82;do if((N|0)==82){N=0;if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[y>>2]=NT(t[o>>2]|0,t[c>>2]|0,t[d>>2]|0)|0;if(t[y>>2]|0)t[E>>2]=(t[E>>2]|0)+1;if(!(t[(t[o>>2]|0)+100>>2]|0))break;if(!(t[(t[o>>2]|0)+120>>2]|0))break;if(!((t[y>>2]|0)!=0?(t[t[(t[(t[o>>2]|0)+120>>2]|0)+4>>2]>>2]|0)==17:0))break;if(!(t[(t[y>>2]|0)+12>>2]|0))break;if((t[(t[(t[y>>2]|0)+12>>2]|0)+12>>2]|0)!=(t[(t[(t[o>>2]|0)+120>>2]|0)+16>>2]|0))break;if((t[(t[(t[y>>2]|0)+12>>2]|0)+16>>2]|0)!=(t[(t[(t[o>>2]|0)+120>>2]|0)+20>>2]|0))break;do if(t[(t[o>>2]|0)+124>>2]|0){t[O>>2]=0;S=t[o>>2]|0;g=t[d>>2]|0;th(S,3081,g,0,161984,uh(O,t[(t[(t[o>>2]|0)+120>>2]|0)+20>>2]|0,t[(t[(t[o>>2]|0)+120>>2]|0)+16>>2]|0)|0,0);if(t[O>>2]|0){pAi[t[135736>>2]&511](t[O>>2]|0);t[O>>2]=0}t[y>>2]=0}else{if((t[(t[y>>2]|0)+16>>2]|0)==1?(t[(t[y>>2]|0)+20>>2]|0)==1:0)break;t[A>>2]=0;g=t[o>>2]|0;S=t[d>>2]|0;th(g,3081,S,0,162096,uh(A,t[(t[(t[o>>2]|0)+120>>2]|0)+20>>2]|0,t[(t[(t[o>>2]|0)+120>>2]|0)+16>>2]|0)|0,0);if(t[A>>2]|0){pAi[t[135736>>2]&511](t[A>>2]|0);t[A>>2]=0}t[y>>2]=0}while(0);t[(t[(t[o>>2]|0)+120>>2]|0)+8>>2]=t[y>>2];S=(t[o>>2]|0)+124|0;t[S>>2]=(t[S>>2]|0)+1;break}if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161976)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[y>>2]=$L(t[o>>2]|0,t[c>>2]|0,t[d>>2]|0)|0;break}if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[y>>2]=RT(t[o>>2]|0,t[c>>2]|0,t[d>>2]|0,7,1)|0;break}if((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)t[y>>2]=RT(t[o>>2]|0,t[c>>2]|0,t[d>>2]|0,6,1)|0}while(0);if(t[y>>2]|0){S=t[y>>2]|0;if(!(t[F>>2]|0))t[(t[h>>2]|0)+12>>2]=S;else t[(t[F>>2]|0)+8>>2]=S;t[F>>2]=t[y>>2]}t[d>>2]=t[(t[d>>2]|0)+24>>2]}if(T)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[d>>2]|0,0,162240)}if((t[_>>2]|0)==0&(t[m>>2]|0)==0){t[a>>2]=0;M=t[a>>2]|0;s=u;return M|0}if(t[E>>2]|0)qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[h>>2]|0)|0;if(t[k>>2]|0){t[a>>2]=t[w>>2];M=t[a>>2]|0;s=u;return M|0}else{t[a>>2]=t[h>>2];M=t[a>>2]|0;s=u;return M|0}return 0}function NT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;t[k>>2]=0;t[h>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[b>>2]=Bd(t[o>>2]|0,160064)|0;r=t[u>>2]|0;if(!(t[b>>2]|0)){FT(r,3036,0,t[o>>2]|0,160064,0);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if(xT(r,t[a>>2]|0,0,t[b>>2]|0,h,k)|0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}UT(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[b>>2]|0,t[h>>2]|0)|0;t[w>>2]=BT(t[u>>2]|0,t[o>>2]|0,0,-1,1,161744)|0;t[d>>2]=IT(t[u>>2]|0,t[o>>2]|0,0,1073741824,1,161768)|0;t[b>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;a=t[b>>2]|0;if(!(t[(t[b>>2]|0)+36>>2]|0)){if((((Xl(t[a+8>>2]|0,160064)|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,161384)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161824)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161808)|0)==0:0)_T(t[u>>2]|0,3035,0,t[b>>2]|0)}else if(Xl(t[(t[a+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[b>>2]|0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[c>>2]=Mv(t[u>>2]|0,t[o>>2]|0,t[w>>2]|0,t[d>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}b=VT(t[u>>2]|0,17,t[k>>2]|0,t[h>>2]|0)|0;t[(t[c>>2]|0)+12>>2]=b;HT(t[u>>2]|0,t[c>>2]|0,t[o>>2]|0,t[w>>2]|0,t[d>>2]|0)|0;t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=jd(t[u>>2]|0,t[l>>2]|0,1)|0;t[(t[c>>2]|0)+4>>2]=b;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if(t[l>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[l>>2]|0,0,161392);if((t[w>>2]|0)==0&(t[d>>2]|0)==0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else{t[f>>2]=t[c>>2];v=t[f>>2]|0;s=n;return v|0}return 0}function TT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;while(1){if(!((((t[t[b>>2]>>2]|0)!=0?(t[(t[t[b>>2]>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[t[b>>2]>>2]|0)+8>>2]|0,161048)|0)!=0:0)?(Xl(t[(t[(t[t[b>>2]>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)){if(!(t[t[b>>2]>>2]|0)){v=24;break}if(!(t[(t[t[b>>2]>>2]|0)+36>>2]|0)){v=24;break}if(!(Xl(t[(t[t[b>>2]>>2]|0)+8>>2]|0,161064)|0)){v=24;break}if(!(Xl(t[(t[(t[t[b>>2]>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)){v=24;break}}if((((t[t[b>>2]>>2]|0)!=0?(t[(t[t[b>>2]>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[t[b>>2]>>2]|0)+8>>2]|0,161048)|0)!=0:0)?(Xl(t[(t[(t[t[b>>2]>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)t[d>>2]=eD(t[c>>2]|0,t[l>>2]|0,t[t[b>>2]>>2]|0,t[t[k>>2]>>2]|0,t[h>>2]|0)|0;else v=15;if((v|0)==15?(v=0,t[d>>2]=iD(t[c>>2]|0,t[l>>2]|0,t[t[b>>2]>>2]|0)|0,(t[d>>2]|0)!=0&(t[w>>2]|0)!=0):0)t[t[w>>2]>>2]=1;if(t[d>>2]|0){if((t[t[k>>2]>>2]|0)==0?(u=hh()|0,t[t[k>>2]>>2]=u,(t[t[k>>2]>>2]|0)==0):0){v=20;break}if((rL(t[t[k>>2]>>2]|0,2,t[d>>2]|0)|0)==-1){v=22;break}}t[t[b>>2]>>2]=t[(t[t[b>>2]>>2]|0)+24>>2]}if((v|0)==20){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}else if((v|0)==22){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}else if((v|0)==24){t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}return 0}function LT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[c>>2]=nL(t[u>>2]|0,t[a>>2]|0,21,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[b>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;r=t[b>>2]|0;if(!(t[(t[b>>2]|0)+36>>2]|0)){if(((Xl(t[r+8>>2]|0,161384)|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,162304)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,162320)|0)==0:0)_T(t[u>>2]|0,3035,0,t[b>>2]|0)}else if(Xl(t[(t[r+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[b>>2]|0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;if(rD(t[u>>2]|0,t[a>>2]|0,t[c>>2]|0,t[o>>2]|0)|0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){a=jd(t[u>>2]|0,t[l>>2]|0,1)|0;t[(t[c>>2]|0)+8>>2]=a;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if(t[l>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[l>>2]|0,0,161392);t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}function DT(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;f=s;s=s+64|0;u=f+52|0;a=f+48|0;o=f+44|0;c=f+40|0;l=f+36|0;b=f+32|0;k=f+28|0;h=f+24|0;w=f+20|0;d=f+16|0;v=f+12|0;m=f+8|0;_=f+4|0;p=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}t[b>>2]=t[(t[a>>2]|0)+84>>2];n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|4;t[h>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;n=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if((Xl(t[n+8>>2]|0,161384)|0)==0?(Xl(t[(t[h>>2]|0)+8>>2]|0,151424)|0)==0:0)_T(t[a>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;do if(!(GT(t[a>>2]|0,t[o>>2]|0,0,t[c>>2]|0,151424,(t[b>>2]|0)+60|0,(t[b>>2]|0)+56|0)|0)){if((t[(t[b>>2]|0)+56>>2]|0)==0?(t[t[b>>2]>>2]|0)==5:0){FT(t[a>>2]|0,3036,0,t[c>>2]|0,151424,0);break}if((t[(t[a>>2]|0)+100>>2]|0)!=0?(t[(t[b>>2]|0)+48>>2]&8|0)!=0:0){if(!(t[(t[b>>2]|0)+56>>2]|0)){FT(t[a>>2]|0,3036,0,t[c>>2]|0,151424,0);break}if((Xl(t[(t[b>>2]|0)+56>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0)!=0?(Xl(t[(t[b>>2]|0)+60>>2]|0,t[(t[b>>2]|0)+112>>2]|0)|0)!=0:0)break;t[w>>2]=0;t[d>>2]=0;h=t[a>>2]|0;n=t[c>>2]|0;r=uh(w,t[(t[b>>2]|0)+60>>2]|0,t[(t[b>>2]|0)+56>>2]|0)|0;iL(h,3081,0,n,166112,r,uh(d,t[(t[b>>2]|0)+112>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0,0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}if(t[d>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0}t[(t[b>>2]|0)+56>>2]=0;t[(t[b>>2]|0)+60>>2]=0}}while(0);t[k>>2]=t[(t[c>>2]|0)+12>>2];if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){d=t[b>>2]|0;JL(d,jd(t[a>>2]|0,t[k>>2]|0,1)|0)|0;t[k>>2]=t[(t[k>>2]|0)+24>>2]}do if((t[l>>2]|0)==4){if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){d=t[a>>2]|0;if(t[(t[b>>2]|0)+56>>2]|0)$d(d,3005,0,t[c>>2]|0,t[k>>2]|0,166232,0);else{w=Wd(d,t[o>>2]|0,t[k>>2]|0,0)|0;t[(t[b>>2]|0)+64>>2]=w}t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if(!(t[(t[b>>2]|0)+56>>2]|0))$d(t[a>>2]|0,3005,0,t[c>>2]|0,t[k>>2]|0,166304,0)}else{if((t[l>>2]|0)!=10){if(!((t[l>>2]|0)==9&(t[k>>2]|0)!=0))break;if(!(t[(t[k>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[k>>2]|0)+8>>2]|0,161024)|0))break;if(!(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break;w=Wd(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,0)|0;t[(t[b>>2]|0)+104>>2]=w;if(t[(t[b>>2]|0)+104>>2]|0){t[k>>2]=t[(t[k>>2]|0)+24>>2];break}t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){w=RT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,8,1)|0;t[(t[b>>2]|0)+28>>2]=w;t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){w=RT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,7,1)|0;t[(t[b>>2]|0)+28>>2]=w;t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){w=RT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,6,1)|0;t[(t[b>>2]|0)+28>>2]=w;t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){w=NT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;t[(t[b>>2]|0)+28>>2]=w;t[k>>2]=t[(t[k>>2]|0)+24>>2]}}while(0);e:do if((t[l>>2]|0)==4|(t[l>>2]|0)==9){t[m>>2]=0;i:while(1){if(!((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157848)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0))S=77;r:do if((S|0)==77){S=0;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157832)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157816)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157800)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157936)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157952)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157792)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157880)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,157864)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)break;do if((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0){if(!(Xl(t[(t[k>>2]|0)+8>>2]|0,157896)|0))break;if(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)break r}while(0);do if(t[k>>2]|0){if(!(t[(t[k>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[k>>2]|0)+8>>2]|0,157904)|0))break;if(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)break r}while(0);if(!(t[k>>2]|0))break i;if(!(t[(t[k>>2]|0)+36>>2]|0))break i;if(!(Xl(t[(t[k>>2]|0)+8>>2]|0,157920)|0))break i;if(!(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break i}while(0);t[v>>2]=nD(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;if(t[v>>2]|0){w=t[v>>2]|0;if(!(t[m>>2]|0))t[(t[b>>2]|0)+68>>2]=w;else t[(t[m>>2]|0)+4>>2]=w;t[m>>2]=t[v>>2];t[(t[m>>2]|0)+4>>2]=0}t[k>>2]=t[(t[k>>2]|0)+24>>2]}if(t[(t[b>>2]|0)+68>>2]|0){t[p>>2]=0;t[v>>2]=t[(t[b>>2]|0)+68>>2];while(1){t[_>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[_>>2]|0))break;t[(t[_>>2]|0)+4>>2]=t[v>>2];t[t[_>>2]>>2]=0;w=t[_>>2]|0;if(!(t[p>>2]|0))t[(t[b>>2]|0)+96>>2]=w;else t[t[p>>2]>>2]=w;t[p>>2]=t[_>>2];t[v>>2]=t[(t[v>>2]|0)+4>>2];if(!(t[v>>2]|0))break e}Qh(t[a>>2]|0,166376,0);pAi[t[135736>>2]&511](t[_>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}}while(0);if((t[t[b>>2]>>2]|0)==5){if((TT(t[a>>2]|0,t[o>>2]|0,k,(t[b>>2]|0)+116|0,12,0)|0)==-1){t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){_=LT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;t[(t[b>>2]|0)+84>>2]=_;t[k>>2]=t[(t[k>>2]|0)+24>>2]}}do if(t[k>>2]|0){if((t[l>>2]|0)==10){$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[k>>2]|0,0,166400);break}_=t[a>>2]|0;b=t[c>>2]|0;o=t[k>>2]|0;if((t[l>>2]|0)==9){$d(_,3033,0,b,o,0,166504);break}else{$d(_,3033,0,b,o,0,166752);break}}while(0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}function CT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[c>>2]=t[(t[u>>2]|0)+84>>2];r=(t[c>>2]|0)+48|0;t[r>>2]=t[r>>2]|64;r=ED(46)|0;t[(t[c>>2]|0)+64>>2]=r;t[b>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;r=t[b>>2]|0;if(!(t[(t[b>>2]|0)+36>>2]|0)){if((Xl(t[r+8>>2]|0,161384)|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,160400)|0)==0:0)_T(t[u>>2]|0,3035,0,t[b>>2]|0)}else if(Xl(t[(t[r+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[b>>2]|0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;GT(t[u>>2]|0,t[a>>2]|0,0,t[o>>2]|0,160400,(t[c>>2]|0)+60|0,(t[c>>2]|0)+56|0)|0;t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=t[c>>2]|0;JL(b,jd(t[u>>2]|0,t[l>>2]|0,1)|0)|0;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=t[u>>2]|0;if(t[(t[c>>2]|0)+56>>2]|0)sv(b,3e3,0,t[o>>2]|0,165952,0);else{r=Wd(b,t[a>>2]|0,t[l>>2]|0,0)|0;t[(t[c>>2]|0)+28>>2]=r}t[l>>2]=t[(t[l>>2]|0)+24>>2]}else h=25;if((h|0)==25?(t[(t[c>>2]|0)+56>>2]|0)==0:0)sv(t[u>>2]|0,3e3,0,t[o>>2]|0,166032,0);if(t[l>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[l>>2]|0,0,164200);if(((t[(t[c>>2]|0)+56>>2]|0)==0?(t[(t[c>>2]|0)+28>>2]|0)==0:0)?(Bd(t[o>>2]|0,160400)|0)==0:0)sv(t[u>>2]|0,3e3,0,t[o>>2]|0,166032,0);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}function PT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;n=s;s=s+80|0;f=n+64|0;a=n+60|0;o=n+56|0;c=n+52|0;l=n+48|0;b=n+44|0;k=n+40|0;h=n+36|0;w=n+32|0;d=n+28|0;v=n+24|0;m=n+20|0;_=n+16|0;p=n+12|0;E=n+8|0;S=n+4|0;g=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=0;t[h>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[f>>2]=-1;y=t[f>>2]|0;s=n;return y|0}t[l>>2]=t[(t[a>>2]|0)+84>>2];r=(t[l>>2]|0)+48|0;t[r>>2]=t[r>>2]|128;r=ED(46)|0;t[(t[l>>2]|0)+64>>2]=r;t[k>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[k>>2]|0))break;r=t[k>>2]|0;if(!(t[(t[k>>2]|0)+36>>2]|0)){if((Xl(t[r+8>>2]|0,161384)|0)==0?(Xl(t[(t[k>>2]|0)+8>>2]|0,160512)|0)==0:0)_T(t[a>>2]|0,3035,0,t[k>>2]|0)}else if(Xl(t[(t[r+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[k>>2]|0);t[k>>2]=t[(t[k>>2]|0)+24>>2]}Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;t[k>>2]=Bd(t[c>>2]|0,160512)|0;e:do if(t[k>>2]|0){t[p>>2]=0;t[h>>2]=Hd(t[a>>2]|0,t[k>>2]|0)|0;t[(t[l>>2]|0)+56>>2]=t[h>>2];while(1){do if((u[t[h>>2]>>0]|0|0)==32)F=1;else{if(9<=(u[t[h>>2]>>0]|0|0)?(u[t[h>>2]>>0]|0|0)<=10:0){F=1;break}F=(u[t[h>>2]>>0]|0|0)==13}while(0);r=t[h>>2]|0;if(F){t[h>>2]=r+1;continue}t[w>>2]=r;while(1){if(u[t[w>>2]>>0]|0){do if((u[t[w>>2]>>0]|0|0)==32)O=1;else{if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0){O=1;break}O=(u[t[w>>2]>>0]|0|0)==13}while(0);A=O^1}else A=0;M=t[w>>2]|0;if(!A)break;t[w>>2]=M+1}if((M|0)==(t[h>>2]|0))break e;t[d>>2]=ql(t[h>>2]|0,(t[w>>2]|0)-(t[h>>2]|0)|0)|0;if(!(fD(t[a>>2]|0,t[o>>2]|0,0,t[k>>2]|0,t[d>>2]|0,m,v)|0)){t[_>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[_>>2]|0)){R=32;break}t[(t[_>>2]|0)+4>>2]=0;t[t[_>>2]>>2]=0;r=t[_>>2]|0;if(!(t[p>>2]|0))t[(t[l>>2]|0)+92>>2]=r;else t[t[p>>2]>>2]=r;t[p>>2]=t[_>>2];t[E>>2]=VT(t[a>>2]|0,4,t[v>>2]|0,t[m>>2]|0)|0;if(!(t[E>>2]|0))break;t[(t[_>>2]|0)+4>>2]=t[E>>2]}if(t[d>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0}t[h>>2]=t[w>>2];if(!(u[t[h>>2]>>0]|0))break e}if((R|0)==32){Qh(t[a>>2]|0,165784,0);t[f>>2]=-1;y=t[f>>2]|0;s=n;return y|0}if(t[d>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0}t[f>>2]=-1;y=t[f>>2]|0;s=n;return y|0}while(0);t[b>>2]=t[(t[c>>2]|0)+12>>2];if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){d=t[l>>2]|0;JL(d,jd(t[a>>2]|0,t[b>>2]|0,1)|0)|0;t[b>>2]=t[(t[b>>2]|0)+24>>2]}e:do if((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[g>>2]=0;while(1){if(!(t[b>>2]|0))break e;if(!(t[(t[b>>2]|0)+36>>2]|0))break e;if(!(Xl(t[(t[b>>2]|0)+8>>2]|0,161024)|0))break e;if(!(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break e;t[S>>2]=Wd(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0,0)|0;if(t[S>>2]|0){d=t[S>>2]|0;if(!(t[g>>2]|0)){t[(t[l>>2]|0)+28>>2]=d;t[g>>2]=t[S>>2]}else{t[(t[g>>2]|0)+4>>2]=d;t[g>>2]=t[S>>2]}t[(t[g>>2]|0)+4>>2]=0}t[b>>2]=t[(t[b>>2]|0)+24>>2]}}while(0);if(t[b>>2]|0)$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[b>>2]|0,0,165832);if((t[k>>2]|0)==0?(t[(t[l>>2]|0)+28>>2]|0)==0:0)sv(t[a>>2]|0,3007,0,t[c>>2]|0,165864,0);t[f>>2]=0;y=t[f>>2]|0;s=n;return y|0}function BT(e,i,r,n,f,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;o=s;s=s+48|0;c=o+40|0;l=o+36|0;b=o+32|0;k=o+28|0;h=o+24|0;w=o+20|0;d=o+16|0;v=o+12|0;m=o+8|0;_=o+4|0;p=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=a;t[_>>2]=0;t[p>>2]=Bd(t[b>>2]|0,161824)|0;if(!(t[p>>2]|0)){t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}t[v>>2]=Hd(t[l>>2]|0,t[p>>2]|0)|0;t[m>>2]=t[v>>2];while(1){do if((u[t[m>>2]>>0]|0|0)==32)S=1;else{if(9<=(u[t[m>>2]>>0]|0|0)?(u[t[m>>2]>>0]|0|0)<=10:0){S=1;break}S=(u[t[m>>2]>>0]|0|0)==13}while(0);g=t[m>>2]|0;if(!S)break;t[m>>2]=g+1}if(!(u[g>>0]|0)){Ud(t[l>>2]|0,3037,0,t[p>>2]|0,0,t[d>>2]|0,t[v>>2]|0,0,0,0);t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}while(1){if((u[t[m>>2]>>0]|0|0)<48)break;if((u[t[m>>2]>>0]|0|0)>57)break;t[_>>2]=((t[_>>2]|0)*10|0)+((u[t[m>>2]>>0]|0)-48);t[m>>2]=(t[m>>2]|0)+1}while(1){do if((u[t[m>>2]>>0]|0|0)==32)y=1;else{if(9<=(u[t[m>>2]>>0]|0|0)?(u[t[m>>2]>>0]|0|0)<=10:0){y=1;break}y=(u[t[m>>2]>>0]|0|0)==13}while(0);F=t[m>>2]|0;if(!y)break;t[m>>2]=F+1}do if((u[F>>0]|0|0)==0?(t[_>>2]|0)>=(t[k>>2]|0):0){if((t[h>>2]|0)!=-1?(t[_>>2]|0)>(t[h>>2]|0):0)break;t[c>>2]=t[_>>2];E=t[c>>2]|0;s=o;return E|0}while(0);Ud(t[l>>2]|0,3037,0,t[p>>2]|0,0,t[d>>2]|0,t[v>>2]|0,0,0,0);t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}function IT(e,i,r,n,f,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;o=s;s=s+48|0;c=o+40|0;l=o+36|0;b=o+32|0;k=o+28|0;h=o+24|0;w=o+20|0;d=o+16|0;v=o+12|0;m=o+8|0;_=o+4|0;p=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=a;t[_>>2]=0;t[p>>2]=Bd(t[b>>2]|0,161808)|0;if(!(t[p>>2]|0)){t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}t[v>>2]=Hd(t[l>>2]|0,t[p>>2]|0)|0;if(Xl(t[v>>2]|0,163200)|0)if((t[h>>2]|0)!=1073741824){Ud(t[l>>2]|0,3037,0,t[p>>2]|0,0,t[d>>2]|0,t[v>>2]|0,0,0,0);t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}else{t[c>>2]=1073741824;E=t[c>>2]|0;s=o;return E|0}t[m>>2]=t[v>>2];while(1){do if((u[t[m>>2]>>0]|0|0)==32)S=1;else{if(9<=(u[t[m>>2]>>0]|0|0)?(u[t[m>>2]>>0]|0|0)<=10:0){S=1;break}S=(u[t[m>>2]>>0]|0|0)==13}while(0);g=t[m>>2]|0;if(!S)break;t[m>>2]=g+1}if(!(u[g>>0]|0)){Ud(t[l>>2]|0,3037,0,t[p>>2]|0,0,t[d>>2]|0,t[v>>2]|0,0,0,0);t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}while(1){if((u[t[m>>2]>>0]|0|0)<48)break;if((u[t[m>>2]>>0]|0|0)>57)break;t[_>>2]=((t[_>>2]|0)*10|0)+((u[t[m>>2]>>0]|0)-48);t[m>>2]=(t[m>>2]|0)+1}while(1){do if((u[t[m>>2]>>0]|0|0)==32)y=1;else{if(9<=(u[t[m>>2]>>0]|0|0)?(u[t[m>>2]>>0]|0|0)<=10:0){y=1;break}y=(u[t[m>>2]>>0]|0|0)==13}while(0);F=t[m>>2]|0;if(!y)break;t[m>>2]=F+1}do if((u[F>>0]|0|0)==0?(t[_>>2]|0)>=(t[k>>2]|0):0){if((t[h>>2]|0)!=-1?(t[_>>2]|0)>(t[h>>2]|0):0)break;t[c>>2]=t[_>>2];E=t[c>>2]|0;s=o;return E|0}while(0);Ud(t[l>>2]|0,3037,0,t[p>>2]|0,0,t[d>>2]|0,t[v>>2]|0,0,0,0);t[c>>2]=t[w>>2];E=t[c>>2]|0;s=o;return E|0}function HT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u+20|0;o=u+16|0;c=u+8|0;l=u+4|0;b=u;t[o>>2]=e;t[u+12>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;if((t[b>>2]|0)==0&(t[l>>2]|0)==0){t[a>>2]=0;k=t[a>>2]|0;s=u;return k|0}if((t[b>>2]|0)!=1073741824){if((t[b>>2]|0)<1){f=t[o>>2]|0;jT(f,3044,0,0,Bd(t[c>>2]|0,161808)|0,163048);t[a>>2]=3044;k=t[a>>2]|0;s=u;return k|0}if((t[l>>2]|0)>(t[b>>2]|0)){b=t[o>>2]|0;jT(b,3043,0,0,Bd(t[c>>2]|0,161824)|0,163096);t[a>>2]=3043;k=t[a>>2]|0;s=u;return k|0}}t[a>>2]=0;k=t[a>>2]|0;s=u;return k|0}function xT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=Hd(t[o>>2]|0,t[b>>2]|0)|0;u=fD(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[w>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;s=a;return u|0}function UT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;u=s;s=s+32|0;a=u+28|0;o=u+24|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[u+20>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;if(Xl(t[(t[o>>2]|0)+112>>2]|0,t[b>>2]|0)|0){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}if(Xl(t[38526]|0,t[b>>2]|0)|0){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}e:do if(t[(t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)+24>>2]|0){t[k>>2]=t[(t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)+24>>2];while(1){if(!((t[(t[k>>2]|0)+4>>2]|0)!=0?(t[(t[k>>2]|0)+4>>2]|0)!=1:0))d=9;if((d|0)==9?(d=0,(Xl(t[b>>2]|0,t[(t[k>>2]|0)+8>>2]|0)|0)!=0):0)break;t[k>>2]=t[t[k>>2]>>2];if(!(t[k>>2]|0))break e}t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}while(0);if(t[l>>2]|0)v=t[l>>2]|0;else v=t[c>>2]|0;t[h>>2]=v;v=t[o>>2]|0;o=t[h>>2]|0;if(!(t[b>>2]|0))th(v,3004,o,0,162704,0,0);else th(v,3004,o,0,162824,t[b>>2]|0,0);t[a>>2]=3004;w=t[a>>2]|0;s=u;return w|0}function zT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=0;sw(w,0,t[l>>2]|0,t[(t[b>>2]|0)+20>>2]|0)|0;vT(t[o>>2]|0,t[b>>2]|0,t[c>>2]|0,0,0,0,164296,t[w>>2]|0,t[k>>2]|0,t[h>>2]|0,0,0);if(!(t[w>>2]|0)){s=a;return}pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0;s=a;return}function jT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=0;do if(t[l>>2]|0){u=t[l>>2]|0;if(!(t[t[l>>2]>>2]|0)){sw(u,0,t[b>>2]|0,t[(t[k>>2]|0)+20>>2]|0)|0;t[w>>2]=t[t[l>>2]>>2];break}else{t[w>>2]=t[u>>2];break}}else sw(w,0,t[b>>2]|0,t[(t[k>>2]|0)+20>>2]|0)|0;while(0);b=t[o>>2]|0;if(!(t[k>>2]|0))vT(b,0,t[c>>2]|0,0,0,0,163160,t[w>>2]|0,163192,t[h>>2]|0,0,0);else vT(b,t[k>>2]|0,t[c>>2]|0,0,0,0,163160,t[w>>2]|0,t[(t[k>>2]|0)+8>>2]|0,t[h>>2]|0,0,0);if(!((t[l>>2]|0)==0&(t[w>>2]|0)!=0)){s=a;return}pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0;s=a;return}function VT(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[b>>2]|0)){Qh(t[a>>2]|0,162672,0);t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}else{t[(t[b>>2]|0)+20>>2]=0;t[t[b>>2]>>2]=2e3;t[(t[b>>2]|0)+12>>2]=t[c>>2];t[(t[b>>2]|0)+16>>2]=t[l>>2];t[(t[b>>2]|0)+4>>2]=0;t[(t[b>>2]|0)+8>>2]=t[o>>2];qT((t[(t[(t[a>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,t[b>>2]|0)|0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}return 0}function qT(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[t[u>>2]>>2]|0)==0?(r=hh()|0,t[t[u>>2]>>2]=r,(t[t[u>>2]>>2]|0)==0):0){t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}rL(t[t[u>>2]>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}function YT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}t[h>>2]=gAi[t[135744>>2]&511](104)|0;if(!(t[h>>2]|0)){Qh(t[o>>2]|0,165528,0);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}f=(t[h>>2]|0)+0|0;n=f+104|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(n|0));t[t[h>>2]>>2]=14;t[(t[h>>2]|0)+8>>2]=t[c>>2];t[(t[h>>2]|0)+52>>2]=t[l>>2];t[(t[h>>2]|0)+36>>2]=t[b>>2];b=t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0;if(t[k>>2]|0)qT(b+44|0,5,t[h>>2]|0)|0;else qT(b+48|0,10,t[h>>2]|0)|0;qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[h>>2]|0)|0;t[a>>2]=t[h>>2];w=t[a>>2]|0;s=u;return w|0}function GT(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+24|0;k=o+20|0;h=o+16|0;w=o+12|0;d=o+8|0;v=o+4|0;m=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=Bd(t[h>>2]|0,t[w>>2]|0)|0;if(!(t[m>>2]|0)){t[t[v>>2]>>2]=0;t[t[d>>2]>>2]=0;t[c>>2]=0;_=t[c>>2]|0;s=o;return _|0}else{t[c>>2]=xT(t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[m>>2]|0,t[d>>2]|0,t[v>>2]|0)|0;_=t[c>>2]|0;s=o;return _|0}return 0}function WT(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=Sw(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;if(!(t[b>>2]|0)){t[u>>2]=t[l>>2];k=t[u>>2]|0;s=f;return k|0}do if(!(Xl(t[b>>2]|0,165504)|0)){if(Xl(t[b>>2]|0,165512)|0){t[l>>2]=0;break}if(Xl(t[b>>2]|0,161736)|0){t[l>>2]=1;break}if(Xl(t[b>>2]|0,165520)|0){t[l>>2]=0;break}else{n=t[a>>2]|0;r=Bd(t[o>>2]|0,t[c>>2]|0)|0;i=ED(15)|0;Ud(n,1714,0,r,i,0,t[b>>2]|0,0,0,0);break}}else t[l>>2]=1;while(0);t[u>>2]=t[l>>2];k=t[u>>2]|0;s=f;return k|0}function KT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;u=s;s=s+48|0;a=u+44|0;o=u+40|0;c=u+36|0;l=u+32|0;b=u+28|0;k=u+24|0;h=u+20|0;w=u+16|0;d=u+12|0;v=u+8|0;m=u+4|0;_=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;t[w>>2]=0;t[v>>2]=0;t[m>>2]=0;t[_>>2]=0;t[d>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[d>>2]|0))break;f=t[d>>2]|0;do if(!(t[(t[d>>2]|0)+36>>2]|0)){if((Xl(t[f+8>>2]|0,161384)|0)==0?(Xl(t[(t[d>>2]|0)+8>>2]|0,161352)|0)==0:0){if((t[b>>2]|0)==24?(Xl(t[(t[d>>2]|0)+8>>2]|0,160144)|0)!=0:0)break;_T(t[o>>2]|0,3035,0,t[d>>2]|0)}}else if(Xl(t[(t[f+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[o>>2]|0,3035,0,t[d>>2]|0);while(0);t[d>>2]=t[(t[d>>2]|0)+24>>2]}t[d>>2]=Bd(t[l>>2]|0,161352)|0;f=t[o>>2]|0;if(!(t[d>>2]|0)){FT(f,3036,0,t[l>>2]|0,161352,0);t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}n=t[d>>2]|0;if(Id(f,0,n,ED(22)|0,v)|0){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}t[h>>2]=tD(t[o>>2]|0,t[c>>2]|0,t[v>>2]|0,t[k>>2]|0,t[b>>2]|0,t[l>>2]|0)|0;if(!(t[h>>2]|0)){t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}Pd(t[o>>2]|0,t[l>>2]|0,161384)|0;do if((t[b>>2]|0)==24){t[d>>2]=Bd(t[l>>2]|0,160144)|0;k=t[o>>2]|0;if(!(t[d>>2]|0)){FT(k,3036,0,t[l>>2]|0,160144,0);break}v=VT(k,23,0,0)|0;t[(t[h>>2]|0)+36>>2]=v;if(t[(t[h>>2]|0)+36>>2]|0){xT(t[o>>2]|0,t[c>>2]|0,0,t[d>>2]|0,(t[(t[h>>2]|0)+36>>2]|0)+16|0,(t[(t[h>>2]|0)+36>>2]|0)+12|0)|0;UT(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[d>>2]|0,t[(t[(t[h>>2]|0)+36>>2]|0)+16>>2]|0)|0;break}t[a>>2]=0;p=t[a>>2]|0;s=u;return p|0}while(0);t[w>>2]=t[(t[l>>2]|0)+12>>2];if((((t[w>>2]|0)!=0?(t[(t[w>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[w>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){d=jd(t[o>>2]|0,t[w>>2]|0,1)|0;t[(t[h>>2]|0)+4>>2]=d;t[w>>2]=t[(t[w>>2]|0)+24>>2]}if(!(t[w>>2]|0))$d(t[o>>2]|0,3034,0,t[l>>2]|0,t[w>>2]|0,164808,164840);e:do if((((t[w>>2]|0)!=0?(t[(t[w>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,164880)|0)!=0:0)?(Xl(t[(t[(t[w>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){d=uD(t[o>>2]|0,t[h>>2]|0,t[w>>2]|0,0)|0;t[(t[h>>2]|0)+24>>2]=d;t[w>>2]=t[(t[w>>2]|0)+24>>2];if((((t[w>>2]|0)!=0?(t[(t[w>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,164896)|0)!=0:0)?(Xl(t[(t[(t[w>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)while(1){t[m>>2]=uD(t[o>>2]|0,t[h>>2]|0,t[w>>2]|0,1)|0;if(t[m>>2]|0){t[(t[m>>2]|0)+8>>2]=t[(t[h>>2]|0)+32>>2];d=(t[h>>2]|0)+32|0;t[d>>2]=(t[d>>2]|0)+1;d=t[m>>2]|0;if(t[_>>2]|0)t[t[_>>2]>>2]=d;else t[(t[h>>2]|0)+28>>2]=d;t[_>>2]=t[m>>2]}t[w>>2]=t[(t[w>>2]|0)+24>>2];if(!(t[w>>2]|0))break e;if(!(t[(t[w>>2]|0)+36>>2]|0))break e;if(!(Xl(t[(t[w>>2]|0)+8>>2]|0,164896)|0))break e;if(!(Xl(t[(t[(t[w>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0))break e}$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[w>>2]|0,0,164840)}while(0);if(t[w>>2]|0)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[w>>2]|0,0,164840);t[a>>2]=t[h>>2];p=t[a>>2]|0;s=u;return p|0}function XT(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;if((t[c>>2]|0)==0|(t[l>>2]|0)==0){t[o>>2]=0;v=t[o>>2]|0;s=a;return v|0}t[d>>2]=gAi[t[135744>>2]&511](76)|0;if(!(t[d>>2]|0)){Qh(t[c>>2]|0,164272,0);t[o>>2]=0;v=t[o>>2]|0;s=a;return v|0}l=(t[d>>2]|0)+0|0;u=l+76|0;do{t[l>>2]=0;l=l+4|0}while((l|0)<(u|0));t[t[d>>2]>>2]=15;t[(t[d>>2]|0)+52>>2]=t[h>>2];t[(t[d>>2]|0)+8>>2]=t[b>>2];t[(t[d>>2]|0)+56>>2]=t[k>>2];k=t[(t[(t[c>>2]|0)+28>>2]|0)+16>>2]|0;if(t[w>>2]|0)qT(k+44|0,5,t[d>>2]|0)|0;else qT(k+48|0,10,t[d>>2]|0)|0;qT((t[(t[c>>2]|0)+28>>2]|0)+20|0,10,t[d>>2]|0)|0;t[o>>2]=t[d>>2];v=t[o>>2]|0;s=a;return v|0}function ZT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+12|0;l=u+8|0;b=u+4|0;k=u;t[o>>2]=e;t[u+16>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;t[k>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=0;h=t[a>>2]|0;s=u;return h|0}t[k>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[k>>2]|0)){Qh(t[o>>2]|0,164360,0);t[a>>2]=0;h=t[a>>2]|0;s=u;return h|0}f=(t[k>>2]|0)+0|0;n=f+60|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(n|0));t[t[k>>2]>>2]=16;t[(t[k>>2]|0)+8>>2]=t[c>>2];t[(t[k>>2]|0)+52>>2]=t[l>>2];t[(t[k>>2]|0)+32>>2]=t[b>>2];b=(t[k>>2]|0)+36|0;t[b>>2]=t[b>>2]|2;do if(t[(t[o>>2]|0)+100>>2]|0){b=_L(t[o>>2]|0,t[(t[o>>2]|0)+116>>2]|0,t[k>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;t[(t[o>>2]|0)+120>>2]=b;if(t[(t[o>>2]|0)+120>>2]|0){t[(t[o>>2]|0)+124>>2]=0;break}pAi[t[135736>>2]&511](t[k>>2]|0);t[a>>2]=0;h=t[a>>2]|0;s=u;return h|0}while(0);qT((t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,t[k>>2]|0)|0;qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[k>>2]|0)|0;
	t[a>>2]=t[k>>2];h=t[a>>2]|0;s=u;return h|0}function JT(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}t[h>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[h>>2]|0)){Qh(t[o>>2]|0,163256,0);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}c=t[h>>2]|0;t[c+0>>2]=0;t[c+4>>2]=0;t[c+8>>2]=0;t[c+12>>2]=0;t[c+16>>2]=0;t[c+20>>2]=0;t[c+24>>2]=0;t[c+28>>2]=0;t[(t[h>>2]|0)+16>>2]=t[l>>2];t[t[h>>2]>>2]=17;t[(t[h>>2]|0)+24>>2]=t[k>>2];t[(t[h>>2]|0)+20>>2]=t[b>>2];do if(t[(t[o>>2]|0)+100>>2]|0){k=_L(t[o>>2]|0,t[(t[o>>2]|0)+116>>2]|0,t[h>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;t[(t[o>>2]|0)+120>>2]=k;if(t[(t[o>>2]|0)+120>>2]|0){t[(t[o>>2]|0)+124>>2]=0;break}pAi[t[135736>>2]&511](t[h>>2]|0);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}while(0);qT((t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,t[h>>2]|0)|0;qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[h>>2]|0)|0;t[a>>2]=t[h>>2];w=t[a>>2]|0;s=u;return w|0}function QT(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;o=s;s=s+32|0;c=o+24|0;l=o+20|0;b=o+16|0;k=o+12|0;h=o+8|0;w=o+4|0;d=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;a=t[c>>2]|0;if(t[b>>2]|0){pw(a,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0);s=o;return}else{pw(a,t[l>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0);s=o;return}}function $T(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[u+4>>2]=f;t[k>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=0;h=t[a>>2]|0;s=u;return h|0}t[k>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[k>>2]|0)){Qh(t[o>>2]|0,161632,0);t[a>>2]=0;h=t[a>>2]|0;s=u;return h|0}else{c=t[k>>2]|0;t[c+0>>2]=0;t[c+4>>2]=0;t[c+8>>2]=0;t[c+12>>2]=0;t[c+16>>2]=0;t[t[k>>2]>>2]=18;t[(t[k>>2]|0)+4>>2]=t[l>>2];t[(t[k>>2]|0)+16>>2]=t[b>>2];qT((t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,t[k>>2]|0)|0;t[a>>2]=t[k>>2];h=t[a>>2]|0;s=u;return h|0}return 0}function eL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[a>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}do if(t[u>>2]|0){if((Xl(t[o>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0)!=0?(t[c>>2]=rO(t[(t[u>>2]|0)+56>>2]|0,t[a>>2]|0)|0,(t[c>>2]|0)!=0):0)break;if((bO(t[(t[u>>2]|0)+48>>2]|0)|0)>1){r=t[(t[u>>2]|0)+48>>2]|0;if(!(t[o>>2]|0))t[l>>2]=rO(r,145792)|0;else t[l>>2]=rO(r,t[o>>2]|0)|0;if(t[l>>2]|0)t[c>>2]=rO(t[(t[(t[l>>2]|0)+52>>2]|0)+56>>2]|0,t[a>>2]|0)|0}}while(0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function iL(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;c=s;s=s+48|0;l=c+36|0;b=c+32|0;k=c+28|0;h=c+24|0;w=c+20|0;d=c+16|0;v=c+12|0;m=c+8|0;_=c+4|0;p=c;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=o;t[_>>2]=0;t[p>>2]=0;sw(_,0,t[k>>2]|0,t[h>>2]|0)|0;t[p>>2]=Yl(147824)|0;t[p>>2]=us(t[p>>2]|0,t[w>>2]|0)|0;t[p>>2]=us(t[p>>2]|0,142704)|0;if((t[h>>2]|0)==0&(t[k>>2]|0)!=0)t[h>>2]=lw(t[k>>2]|0)|0;vT(t[l>>2]|0,t[h>>2]|0,t[b>>2]|0,0,0,0,t[p>>2]|0,t[_>>2]|0,t[d>>2]|0,t[v>>2]|0,t[m>>2]|0,0);if(t[_>>2]|0){pAi[t[135736>>2]&511](t[_>>2]|0);t[_>>2]=0}if(!(t[p>>2]|0)){s=c;return}pAi[t[135736>>2]&511](t[p>>2]|0);t[p>>2]=0;s=c;return}function rL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(t[t[u>>2]>>2]|0){if((t[(t[u>>2]|0)+8>>2]|0)<=(t[(t[u>>2]|0)+4>>2]|0)?(r=(t[u>>2]|0)+8|0,t[r>>2]=t[r>>2]<<1,r=MAi[t[135760>>2]&511](t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+8>>2]<<2)|0,t[t[u>>2]>>2]=r,(t[t[u>>2]>>2]|0)==0):0){Qh(0,142376,0);t[(t[u>>2]|0)+8>>2]=0;t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}}else{if((t[a>>2]|0)<=0)t[a>>2]=1;r=gAi[t[135744>>2]&511](t[a>>2]<<2)|0;t[t[u>>2]>>2]=r;if(t[t[u>>2]>>2]|0){t[(t[u>>2]|0)+8>>2]=t[a>>2];break}Qh(0,142344,0);t[f>>2]=-1;c=t[f>>2]|0;s=n;return c|0}while(0);a=t[o>>2]|0;o=(t[u>>2]|0)+4|0;r=t[o>>2]|0;t[o>>2]=r+1;t[(t[t[u>>2]>>2]|0)+(r<<2)>>2]=a;t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}function nL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}t[b>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[b>>2]|0)){Qh(t[a>>2]|0,153064,0);t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}else{o=(t[b>>2]|0)+0|0;n=o+44|0;do{t[o>>2]=0;o=o+4|0}while((o|0)<(n|0));t[t[b>>2]>>2]=t[c>>2];t[(t[b>>2]|0)+12>>2]=t[l>>2];qT((t[(t[(t[a>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,t[b>>2]|0)|0;t[u>>2]=t[b>>2];k=t[u>>2]|0;s=f;return k|0}return 0}function fL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[o>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}t[(t[a>>2]|0)+28>>2]=t[(t[o>>2]|0)+28>>2];t[c>>2]=t[(t[o>>2]|0)+32>>2];t[b>>2]=0;while(1){if(!(t[c>>2]|0))break;t[l>>2]=aD(t[u>>2]|0)|0;if(!(t[l>>2]|0)){h=6;break}t[(t[l>>2]|0)+4>>2]=t[(t[c>>2]|0)+4>>2];r=t[l>>2]|0;if(!(t[b>>2]|0))t[(t[a>>2]|0)+32>>2]=r;else t[t[b>>2]>>2]=r;t[b>>2]=t[l>>2];t[c>>2]=t[t[c>>2]>>2]}if((h|0)==6){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}if(t[(t[a>>2]|0)+36>>2]|0)Gk(t[(t[a>>2]|0)+36>>2]|0);do if(t[(t[o>>2]|0)+36>>2]|0){h=aD(t[u>>2]|0)|0;t[(t[a>>2]|0)+36>>2]=h;if(t[(t[a>>2]|0)+36>>2]|0){t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2];break}t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else t[(t[a>>2]|0)+36>>2]=0;while(0);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}function tL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(((t[(t[a>>2]|0)+28>>2]|0)==(t[(t[o>>2]|0)+28>>2]|0)?((t[(t[a>>2]|0)+32>>2]|0)==0|0)==((t[(t[o>>2]|0)+32>>2]|0)==0|0):0)?((t[(t[a>>2]|0)+36>>2]|0)==0|0)==((t[(t[o>>2]|0)+36>>2]|0)==0|0):0){if((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0):0)break;if(!(t[(t[a>>2]|0)+32>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[h>>2]=0;t[c>>2]=t[(t[a>>2]|0)+32>>2];while(1){if(!(t[c>>2]|0))break;t[h>>2]=0;t[l>>2]=t[(t[o>>2]|0)+32>>2];while(1){if(!(t[l>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==(t[(t[l>>2]|0)+4>>2]|0)){m=12;break}t[l>>2]=t[t[l>>2]>>2]}if((m|0)==12){m=0;t[h>>2]=1}if(!(t[h>>2]|0))break;t[c>>2]=t[t[c>>2]>>2]}if(t[h>>2]|0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}}while(0);if((t[(t[a>>2]|0)+28>>2]|0)!=(t[(t[o>>2]|0)+28>>2]|0)?(t[(t[a>>2]|0)+28>>2]|0)!=0:0)if((fL(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)==-1){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}else{t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if(!((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[o>>2]|0)+32>>2]|0)!=0:0))m=26;do if((m|0)==26){if((t[(t[o>>2]|0)+36>>2]|0)!=0?(t[(t[a>>2]|0)+32>>2]|0)!=0:0)break;if((t[(t[a>>2]|0)+32>>2]|0)!=0?(t[(t[o>>2]|0)+32>>2]|0)!=0:0){t[c>>2]=t[(t[a>>2]|0)+32>>2];t[b>>2]=0;while(1){if(!(t[c>>2]|0))break;t[d>>2]=0;t[l>>2]=t[(t[o>>2]|0)+32>>2];while(1){if(!(t[l>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==(t[(t[l>>2]|0)+4>>2]|0)){m=57;break}t[l>>2]=t[t[l>>2]>>2]}if((m|0)==57){m=0;t[d>>2]=1}if(t[d>>2]|0){t[b>>2]=t[c>>2];t[c>>2]=t[t[c>>2]>>2];continue}h=t[t[c>>2]>>2]|0;if(!(t[b>>2]|0))t[(t[a>>2]|0)+32>>2]=h;else t[t[b>>2]>>2]=h;t[k>>2]=t[t[c>>2]>>2];pAi[t[135736>>2]&511](t[c>>2]|0);t[c>>2]=t[k>>2]}t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}if(((((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0):0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0)?(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){pw(t[u>>2]|0,t[(t[a>>2]|0)+12>>2]|0,1793,153008,0,0);t[f>>2]=1793;v=t[f>>2]|0;s=n;return v|0}if((((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0):0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)==0:0)t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2];t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}while(0);if(!(t[(t[a>>2]|0)+32>>2]|0)){t[w>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2];if((fL(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)==-1){t[f>>2]=-1;v=t[f>>2]|0;s=n;return v|0}}else t[w>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2];t[b>>2]=0;t[c>>2]=t[(t[a>>2]|0)+32>>2];while(1){if(!(t[c>>2]|0))break;if(!(t[(t[c>>2]|0)+4>>2]|0)){m=35;break}t[b>>2]=t[c>>2];t[c>>2]=t[t[c>>2]>>2]}if((m|0)==35){m=t[t[c>>2]>>2]|0;if(!(t[b>>2]|0))t[(t[a>>2]|0)+32>>2]=m;else t[t[b>>2]>>2]=m;pAi[t[135736>>2]&511](t[c>>2]|0)}e:do if(t[w>>2]|0){t[b>>2]=0;t[c>>2]=t[(t[a>>2]|0)+32>>2];while(1){if(!(t[c>>2]|0))break e;if((t[(t[c>>2]|0)+4>>2]|0)==(t[w>>2]|0))break;t[b>>2]=t[c>>2];t[c>>2]=t[t[c>>2]>>2]}m=t[t[c>>2]>>2]|0;if(!(t[b>>2]|0))t[(t[a>>2]|0)+32>>2]=m;else t[t[b>>2]>>2]=m;pAi[t[135736>>2]&511](t[c>>2]|0)}while(0);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}function uL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(t[t[u>>2]>>2]|0){if((t[(t[u>>2]|0)+8>>2]|0)<=(t[(t[u>>2]|0)+4>>2]|0)?(r=(t[u>>2]|0)+8|0,t[r>>2]=t[r>>2]<<1,r=MAi[t[135760>>2]&511](t[t[u>>2]>>2]|0,t[(t[u>>2]|0)+8>>2]<<2)|0,t[t[u>>2]>>2]=r,(t[t[u>>2]>>2]|0)==0):0){Qh(0,142376,0);t[(t[u>>2]|0)+8>>2]=0;t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}}else{r=gAi[t[135744>>2]&511](80)|0;t[t[u>>2]>>2]=r;if(t[t[u>>2]>>2]|0){t[(t[u>>2]|0)+8>>2]=20;break}Qh(0,142344,0);t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}while(0);if((t[o>>2]|0)>=(t[(t[u>>2]|0)+4>>2]|0)){r=t[a>>2]|0;i=(t[u>>2]|0)+4|0;e=t[i>>2]|0;t[i>>2]=e+1;t[(t[t[u>>2]>>2]|0)+(e<<2)>>2]=r}else{t[c>>2]=t[(t[u>>2]|0)+4>>2];while(1){if((t[c>>2]|0)<=(t[o>>2]|0))break;t[(t[t[u>>2]>>2]|0)+(t[c>>2]<<2)>>2]=t[(t[t[u>>2]>>2]|0)+((t[c>>2]|0)-1<<2)>>2];t[c>>2]=(t[c>>2]|0)+-1}t[(t[t[u>>2]>>2]|0)+(t[o>>2]<<2)>>2]=t[a>>2];a=(t[u>>2]|0)+4|0;t[a>>2]=(t[a>>2]|0)+1}t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}function aL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0)if(t[(t[f>>2]|0)+48>>2]&t[u>>2]){t[n>>2]=1;break}else{t[n>>2]=0;break}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function oL(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;t[k>>2]=0;t[h>>2]=0;sw(k,0,t[c>>2]|0,t[(t[c>>2]|0)+36>>2]|0)|0;f=t[a>>2]|0;a=t[(t[c>>2]|0)+36>>2]|0;c=t[o>>2]|0;o=t[k>>2]|0;n=fh(t[t[b>>2]>>2]|0)|0;vT(f,a,c,0,0,0,149488,o,n,sw(h,0,t[l>>2]|0,0)|0,0,0);if(t[k>>2]|0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}if(!(t[h>>2]|0)){s=u;return}pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=0;s=u;return}function cL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=0;sw(l,0,t[o>>2]|0,t[(t[o>>2]|0)+36>>2]|0)|0;n=t[u>>2]|0;u=t[(t[o>>2]|0)+36>>2]|0;o=t[a>>2]|0;a=t[l>>2]|0;pw(n,u,o,149448,a,fh(t[t[c>>2]>>2]|0)|0);if(!(t[l>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0;s=f;return}function lL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[o>>2]|0)==(t[c>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if(((t[t[o>>2]>>2]|0)!=1?(t[(t[o>>2]|0)+48>>2]&4194304|0)==0:0)?(wv(t[o>>2]|0,t[a>>2]|0)|0)==-1:0){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if(((t[t[c>>2]>>2]|0)!=1?(t[(t[c>>2]|0)+48>>2]&4194304|0)==0:0)?(wv(t[c>>2]|0,t[a>>2]|0)|0)==-1:0){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}if((t[l>>2]&1|0)==0?(aL(t[(t[o>>2]|0)+64>>2]|0,1024)|0)==0:0){if((t[(t[o>>2]|0)+64>>2]|0)==(t[c>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if(!((t[t[(t[o>>2]|0)+64>>2]>>2]|0)==1?(t[(t[(t[o>>2]|0)+64>>2]|0)+88>>2]|0)==45:0))h=18;if((h|0)==18?(lL(t[a>>2]|0,t[(t[o>>2]|0)+64>>2]|0,t[c>>2]|0,t[l>>2]|0)|0)==0:0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}do if((t[t[c>>2]>>2]|0)==1?(t[(t[c>>2]|0)+88>>2]|0)==46:0){if((t[(t[o>>2]|0)+48>>2]&64|0)==0?(t[(t[o>>2]|0)+48>>2]&128|0)==0:0)break;t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}while(0);e:do if(t[(t[c>>2]|0)+48>>2]&128){t[b>>2]=t[(t[c>>2]|0)+92>>2];while(1){if(!(t[b>>2]|0))break e;if(((t[t[(t[b>>2]|0)+4>>2]>>2]|0)!=1?(t[(t[(t[b>>2]|0)+4>>2]|0)+48>>2]&4194304|0)==0:0)?(wv(t[(t[b>>2]|0)+4>>2]|0,t[a>>2]|0)|0)==-1:0){h=31;break}if(!(lL(t[a>>2]|0,t[o>>2]|0,t[(t[b>>2]|0)+4>>2]|0,t[l>>2]|0)|0)){h=33;break}t[b>>2]=t[t[b>>2]>>2]}if((h|0)==31){t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}else if((h|0)==33){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}}while(0);t[u>>2]=3032;k=t[u>>2]|0;s=f;return k|0}t[u>>2]=3031;k=t[u>>2]|0;s=f;return k|0}function sL(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(!(t[(t[n>>2]|0)+92>>2]|0)){e=Ik(0)|0;t[(t[n>>2]|0)+92>>2]=e;e=t[n>>2]|0;if(t[(t[n>>2]|0)+92>>2]|0){Ck(t[e+92>>2]|0,t[(t[n>>2]|0)+8>>2]|0,t[(t[n>>2]|0)+12>>2]|0,t[(t[n>>2]|0)+4>>2]|0);Bk(t[(t[n>>2]|0)+92>>2]|0,t[(t[n>>2]|0)+24>>2]|0,t[(t[n>>2]|0)+4>>2]|0);break}pw(e,0,3069,148224,0,0);t[r>>2]=-1;f=t[r>>2]|0;s=i;return f|0}while(0);t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function bL(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=0;t[w>>2]=Yl(142568)|0;u=t[w>>2]|0;t[w>>2]=us(u,fh(t[t[c>>2]>>2]|0)|0)|0;t[w>>2]=us(t[w>>2]|0,147720)|0;if(!(t[b>>2]|0))t[w>>2]=us(t[w>>2]|0,147736)|0;u=t[w>>2]|0;if((t[b>>2]|0)==1)t[w>>2]=us(u,147752)|0;else t[w>>2]=us(u,147768)|0;if(t[k>>2]|0)t[w>>2]=us(t[w>>2]|0,147784)|0;t[w>>2]=us(t[w>>2]|0,143656)|0;k=t[w>>2]|0;t[w>>2]=us(k,fh(t[t[l>>2]>>2]|0)|0)|0;l=t[w>>2]|0;if(t[h>>2]|0)t[w>>2]=us(l,147800)|0;else t[w>>2]=us(l,142568)|0;sv(t[o>>2]|0,1717,t[c>>2]|0,0,t[w>>2]|0,0);if(!(t[w>>2]|0)){s=a;return}pAi[t[135736>>2]&511](t[w>>2]|0);s=a;return}function kL(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;dp(16,2,0,0,t[r>>2]|0);s=i;return}function hL(e,i,r,n,f,u,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;b=s;s=s+48|0;k=b+44|0;h=b+40|0;w=b+36|0;d=b+32|0;v=b+28|0;m=b+24|0;_=b+20|0;p=b+16|0;E=b+12|0;S=b+8|0;g=b+4|0;y=b;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=n;t[v>>2]=f;t[m>>2]=u;t[_>>2]=a;t[p>>2]=o;t[E>>2]=c;t[S>>2]=l;t[g>>2]=0;t[y>>2]=0;sw(y,0,t[d>>2]|0,0)|0;t[y>>2]=us(t[y>>2]|0,144448)|0;d=t[y>>2]|0;t[y>>2]=us(d,sw(g,0,t[v>>2]|0,0)|0)|0;if(t[g>>2]|0){pAi[t[135736>>2]&511](t[g>>2]|0);t[g>>2]=0}t[y>>2]=us(t[y>>2]|0,152080)|0;t[y>>2]=us(t[y>>2]|0,t[m>>2]|0)|0;t[y>>2]=us(t[y>>2]|0,142704)|0;kw(t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[y>>2]|0,t[_>>2]|0,t[p>>2]|0,t[E>>2]|0,t[S>>2]|0);pAi[t[135736>>2]&511](t[y>>2]|0);s=b;return}function wL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[t[o>>2]>>2]=0;t[t[c>>2]>>2]=0;if(t[l>>2]|0)t[t[l>>2]>>2]=0;n=t[a>>2]|0;if(t[(t[a>>2]|0)+28>>2]|0){t[t[c>>2]>>2]=t[n+28>>2];if(t[l>>2]|0)t[t[l>>2]>>2]=t[(t[a>>2]|0)+32>>2];if(t[(t[a>>2]|0)+16>>2]&1)t[t[o>>2]>>2]=1;t[u>>2]=1;b=t[u>>2]|0;s=f;return b|0}if((t[n+12>>2]|0)!=0?(t[(t[(t[a>>2]|0)+12>>2]|0)+44>>2]|0)!=0:0){t[t[c>>2]>>2]=t[(t[(t[a>>2]|0)+12>>2]|0)+44>>2];if(t[l>>2]|0)t[t[l>>2]>>2]=t[(t[(t[a>>2]|0)+12>>2]|0)+68>>2];if(t[(t[(t[a>>2]|0)+12>>2]|0)+60>>2]&512)t[t[o>>2]>>2]=1;t[u>>2]=1;b=t[u>>2]|0;s=f;return b|0}t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}function dL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}if(t[(t[f>>2]|0)+28>>2]|0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=t[f>>2]|0;e:do if(!(t[(t[f>>2]|0)+32>>2]|0)){if((t[i+36>>2]|0)!=0&(t[u>>2]|0)!=0?(Xl(t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]|0,t[u>>2]|0)|0)==0:0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}}else{t[a>>2]=t[i+32>>2];while(1){if(!(t[a>>2]|0))break e;if(Xl(t[(t[a>>2]|0)+4>>2]|0,t[u>>2]|0)|0)break;t[a>>2]=t[t[a>>2]>>2]}t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}while(0);t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}function vL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;if(t[(t[u>>2]|0)+28>>2]|0){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if(((t[(t[f>>2]|0)+36>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2]|0)==(t[(t[(t[u>>2]|0)+36>>2]|0)+4>>2]|0):0){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}do if(t[(t[f>>2]|0)+32>>2]|0){if(!(t[(t[u>>2]|0)+32>>2]|0)){if(!(t[(t[u>>2]|0)+36>>2]|0))break;t[l>>2]=t[(t[f>>2]|0)+32>>2];while(1){if(!(t[l>>2]|0)){k=27;break}if((t[(t[l>>2]|0)+4>>2]|0)==(t[(t[(t[u>>2]|0)+36>>2]|0)+4>>2]|0)){k=25;break}t[l>>2]=t[t[l>>2]>>2]}if((k|0)==25){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}else if((k|0)==27){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}t[c>>2]=0;t[a>>2]=t[(t[f>>2]|0)+32>>2];while(1){if(!(t[a>>2]|0))break;t[c>>2]=0;t[o>>2]=t[(t[u>>2]|0)+32>>2];while(1){if(!(t[o>>2]|0))break;if((t[(t[a>>2]|0)+4>>2]|0)==(t[(t[o>>2]|0)+4>>2]|0)){k=14;break}t[o>>2]=t[t[o>>2]>>2]}if((k|0)==14){k=0;t[c>>2]=1}if(!(t[c>>2]|0)){k=17;break}t[a>>2]=t[t[a>>2]>>2]}if((k|0)==17){t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}if(t[c>>2]|0){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}}while(0);t[n>>2]=1;b=t[n>>2]|0;s=r;return b|0}function mL(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+16>>2]|0)!=0:0)?(t[(t[n>>2]|0)+12>>2]|0)!=0:0){if(!(((t[t[(t[n>>2]|0)+12>>2]>>2]|0)!=6?(t[t[(t[n>>2]|0)+12>>2]>>2]|0)!=7:0)?(t[t[(t[n>>2]|0)+12>>2]>>2]|0)!=8:0))f=8;if((f|0)==8?(oD(t[n>>2]|0)|0)==0:0){t[r>>2]=1;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=1;u=t[r>>2]|0;s=i;return u|0}function _L(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[h>>2]|0)){Qh(t[o>>2]|0,153320,0);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}f=t[h>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[f+12>>2]=0;t[f+16>>2]=0;t[f+20>>2]=0;t[f+24>>2]=0;t[(t[h>>2]|0)+4>>2]=t[l>>2];t[(t[h>>2]|0)+24>>2]=t[c>>2];t[(t[h>>2]|0)+16>>2]=t[b>>2];t[(t[h>>2]|0)+20>>2]=t[k>>2];k=t[h>>2]|0;b=t[(t[o>>2]|0)+28>>2]|0;if(!(t[(t[(t[o>>2]|0)+28>>2]|0)+28>>2]|0))t[b+28>>2]=k;else t[t[b+32>>2]>>2]=k;t[(t[(t[o>>2]|0)+28>>2]|0)+32>>2]=t[h>>2];t[a>>2]=t[h>>2];w=t[a>>2]|0;s=u;return w|0}function pL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+48|0;f=n+44|0;u=n+40|0;a=n+36|0;o=n+32|0;c=n+28|0;l=n+24|0;b=n+20|0;k=n+16|0;h=n+12|0;w=n+8|0;d=n+4|0;v=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if(((t[(t[a>>2]|0)+28>>2]|0)==(t[(t[o>>2]|0)+28>>2]|0)?((t[(t[a>>2]|0)+32>>2]|0)==0|0)==((t[(t[o>>2]|0)+32>>2]|0)==0|0):0)?((t[(t[a>>2]|0)+36>>2]|0)==0|0)==((t[(t[o>>2]|0)+36>>2]|0)==0|0):0){if((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0):0)break;if(!(t[(t[a>>2]|0)+32>>2]|0)){t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}t[k>>2]=0;t[c>>2]=t[(t[a>>2]|0)+32>>2];while(1){if(!(t[c>>2]|0))break;t[k>>2]=0;t[l>>2]=t[(t[o>>2]|0)+32>>2];while(1){if(!(t[l>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==(t[(t[l>>2]|0)+4>>2]|0)){_=12;break}t[l>>2]=t[t[l>>2]>>2]}if((_|0)==12){_=0;t[k>>2]=1}if(!(t[k>>2]|0))break;t[c>>2]=t[t[c>>2]>>2]}if(t[k>>2]|0){t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}}while(0);k=t[a>>2]|0;if((t[(t[a>>2]|0)+28>>2]|0)!=(t[(t[o>>2]|0)+28>>2]|0)){if(!(t[k+28>>2]|0)){t[(t[a>>2]|0)+28>>2]=1;if(t[(t[a>>2]|0)+32>>2]|0){Gk(t[(t[a>>2]|0)+32>>2]|0);t[(t[a>>2]|0)+32>>2]=0}if(t[(t[a>>2]|0)+36>>2]|0){pAi[t[135736>>2]&511](t[(t[a>>2]|0)+36>>2]|0);t[(t[a>>2]|0)+36>>2]=0}}t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}if((t[k+32>>2]|0)!=0?(t[(t[o>>2]|0)+32>>2]|0)!=0:0){t[c>>2]=t[(t[o>>2]|0)+32>>2];t[w>>2]=t[(t[a>>2]|0)+32>>2];while(1){if(!(t[c>>2]|0)){_=40;break}t[h>>2]=0;t[l>>2]=t[w>>2];while(1){if(!(t[l>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==(t[(t[l>>2]|0)+4>>2]|0)){_=33;break}t[l>>2]=t[t[l>>2]>>2]}if((_|0)==33){_=0;t[h>>2]=1}if(!(t[h>>2]|0)){t[b>>2]=aD(t[u>>2]|0)|0;if(!(t[b>>2]|0)){_=37;break}t[(t[b>>2]|0)+4>>2]=t[(t[c>>2]|0)+4>>2];t[t[b>>2]>>2]=t[(t[a>>2]|0)+32>>2];t[(t[a>>2]|0)+32>>2]=t[b>>2]}t[c>>2]=t[t[c>>2]>>2]}if((_|0)==37){t[f>>2]=-1;m=t[f>>2]|0;s=n;return m|0}else if((_|0)==40){t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}}if(((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0):0){t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=0;t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}if(!(((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0)?(t[(t[o>>2]|0)+32>>2]|0)!=0:0))_=48;do if((_|0)==48){if(((t[(t[o>>2]|0)+36>>2]|0)!=0?(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0)?(t[(t[a>>2]|0)+32>>2]|0)!=0:0)break;if(!(((t[(t[a>>2]|0)+36>>2]|0)!=0?(t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]|0)==0:0)?(t[(t[o>>2]|0)+32>>2]|0)!=0:0))_=87;do if((_|0)==87){if(((t[(t[o>>2]|0)+36>>2]|0)!=0?(t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2]|0)==0:0)?(t[(t[a>>2]|0)+32>>2]|0)!=0:0)break;t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}while(0);if(t[(t[a>>2]|0)+32>>2]|0)t[c>>2]=t[(t[a>>2]|0)+32>>2];else t[c>>2]=t[(t[o>>2]|0)+32>>2];while(1){if(!(t[c>>2]|0))break;if(!(t[(t[c>>2]|0)+4>>2]|0)){_=95;break}t[c>>2]=t[t[c>>2]>>2]}if((_|0)==95){t[(t[a>>2]|0)+28>>2]=1;if(t[(t[a>>2]|0)+32>>2]|0){Gk(t[(t[a>>2]|0)+32>>2]|0);t[(t[a>>2]|0)+32>>2]=0}if(t[(t[a>>2]|0)+36>>2]|0){pAi[t[135736>>2]&511](t[(t[a>>2]|0)+36>>2]|0);t[(t[a>>2]|0)+36>>2]=0}t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}do if(!(t[(t[a>>2]|0)+36>>2]|0)){if(t[(t[a>>2]|0)+32>>2]|0){Gk(t[(t[a>>2]|0)+32>>2]|0);t[(t[a>>2]|0)+32>>2]=0}b=aD(t[u>>2]|0)|0;t[(t[a>>2]|0)+36>>2]=b;if(t[(t[a>>2]|0)+36>>2]|0){t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=0;break}t[f>>2]=-1;m=t[f>>2]|0;s=n;return m|0}while(0);t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}while(0);t[v>>2]=0;if(t[(t[a>>2]|0)+32>>2]|0){t[c>>2]=t[(t[a>>2]|0)+32>>2];t[l>>2]=t[(t[o>>2]|0)+36>>2]}else{t[c>>2]=t[(t[o>>2]|0)+32>>2];t[l>>2]=t[(t[a>>2]|0)+36>>2]}t[d>>2]=0;while(1){if(!(t[c>>2]|0))break;if(t[(t[c>>2]|0)+4>>2]|0){if((t[(t[c>>2]|0)+4>>2]|0)==(t[(t[l>>2]|0)+4>>2]|0))t[d>>2]=1}else t[v>>2]=1;if((t[d>>2]|0)!=0&(t[v>>2]|0)!=0)break;t[c>>2]=t[t[c>>2]>>2]}do if((t[d>>2]|0)!=0&(t[v>>2]|0)!=0){t[(t[a>>2]|0)+28>>2]=1;if(t[(t[a>>2]|0)+32>>2]|0){Gk(t[(t[a>>2]|0)+32>>2]|0);t[(t[a>>2]|0)+32>>2]=0}if(t[(t[a>>2]|0)+36>>2]|0){pAi[t[135736>>2]&511](t[(t[a>>2]|0)+36>>2]|0);t[(t[a>>2]|0)+36>>2]=0}}else{if(!((t[d>>2]|0)==0|(t[v>>2]|0)!=0)){if(t[(t[a>>2]|0)+32>>2]|0){Gk(t[(t[a>>2]|0)+32>>2]|0);t[(t[a>>2]|0)+32>>2]=0}if((t[(t[a>>2]|0)+36>>2]|0)==0?(c=aD(t[u>>2]|0)|0,t[(t[a>>2]|0)+36>>2]=c,(t[(t[a>>2]|0)+36>>2]|0)==0):0){t[f>>2]=-1;m=t[f>>2]|0;s=n;return m|0}t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=0;break}if((t[d>>2]|0)==0&(t[v>>2]|0)!=0){pw(t[u>>2]|0,t[(t[a>>2]|0)+12>>2]|0,1794,152712,0,0);t[f>>2]=1794;m=t[f>>2]|0;s=n;return m|0}if(!((t[d>>2]|0)!=0|(t[v>>2]|0)!=0)?(t[(t[a>>2]|0)+36>>2]|0)==0:0){if(t[(t[a>>2]|0)+32>>2]|0){Gk(t[(t[a>>2]|0)+32>>2]|0);t[(t[a>>2]|0)+32>>2]=0}c=aD(t[u>>2]|0)|0;t[(t[a>>2]|0)+36>>2]=c;if(t[(t[a>>2]|0)+36>>2]|0){t[(t[(t[a>>2]|0)+36>>2]|0)+4>>2]=t[(t[(t[o>>2]|0)+36>>2]|0)+4>>2];break}t[f>>2]=-1;m=t[f>>2]|0;s=n;return m|0}}while(0);t[f>>2]=0;m=t[f>>2]|0;s=n;return m|0}function EL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+40|0;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[u>>2]=i;do if(t[(t[u>>2]|0)+64>>2]|0){if((t[t[(t[u>>2]|0)+64>>2]>>2]|0)!=4){if((t[t[(t[u>>2]|0)+64>>2]>>2]|0)!=1)break;if((t[(t[(t[u>>2]|0)+64>>2]|0)+88>>2]|0)==45)break}if(!(t[(t[u>>2]|0)+48>>2]&2)){th(t[f>>2]|0,3076,0,t[u>>2]|0,152344,0,0);t[n>>2]=3076;d=t[n>>2]|0;s=r;return d|0}}while(0);e:do if((t[(t[u>>2]|0)+116>>2]|0)!=0?(t[(t[(t[u>>2]|0)+116>>2]|0)+4>>2]|0)>1:0){t[a>>2]=t[(t[u>>2]|0)+116>>2];t[k>>2]=0;t[l>>2]=(t[(t[a>>2]|0)+4>>2]|0)-1;i:while(1){if((t[l>>2]|0)<0)break e;t[o>>2]=t[(t[t[a>>2]>>2]|0)+(t[l>>2]<<2)>>2];r:do if((t[l>>2]|0)>0){t[b>>2]=(t[l>>2]|0)-1;while(1){if((t[b>>2]|0)<0){v=20;break r}t[c>>2]=t[(t[t[a>>2]>>2]|0)+(t[b>>2]<<2)>>2];if((t[(t[(t[o>>2]|0)+12>>2]|0)+8>>2]|0)==(t[(t[(t[c>>2]|0)+12>>2]|0)+8>>2]|0)?(t[(t[(t[o>>2]|0)+12>>2]|0)+56>>2]|0)==(t[(t[(t[c>>2]|0)+12>>2]|0)+56>>2]|0):0)break;t[b>>2]=(t[b>>2]|0)+-1}t[h>>2]=0;i=t[f>>2]|0;e=t[u>>2]|0;th(i,3087,0,e,152424,Nd(h,t[o>>2]|0)|0,0);if(t[h>>2]|0){pAi[t[135736>>2]&511](t[h>>2]|0);t[h>>2]=0}if((yv(t[a>>2]|0,t[l>>2]|0)|0)==-1)break i}else v=20;while(0);if(((v|0)==20?(v=0,(t[(t[(t[o>>2]|0)+12>>2]|0)+48>>2]|0)!=0):0)?(gv(t[(t[(t[o>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)!=0:0){if(t[k>>2]|0){t[w>>2]=0;e=t[f>>2]|0;i=t[u>>2]|0;th(e,3087,0,i,152440,Nd(w,t[o>>2]|0)|0,0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}if((yv(t[a>>2]|0,t[l>>2]|0)|0)==-1)break}t[k>>2]=1}t[l>>2]=(t[l>>2]|0)+-1}t[n>>2]=-1;d=t[n>>2]|0;s=r;return d|0}while(0);t[n>>2]=0;d=t[n>>2]|0;s=r;return d|0}function SL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[u>>2]|0)+64>>2];if((t[t[a>>2]>>2]|0)!=5?(t[(t[a>>2]|0)+88>>2]|0)!=45:0){if((t[(t[u>>2]|0)+104>>2]|0)!=(t[a>>2]|0)){sv(t[f>>2]|0,3063,t[u>>2]|0,0,152296,0);t[n>>2]=3063;o=t[n>>2]|0;s=r;return o|0}if(t[(t[a>>2]|0)+48>>2]&512){sv(t[f>>2]|0,3063,t[u>>2]|0,0,152088,0);t[n>>2]=3063;o=t[n>>2]|0;s=r;return o|0}}else c=3;do if((c|0)==3){if(t[(t[a>>2]|0)+48>>2]&512){sv(t[f>>2]|0,3063,t[u>>2]|0,0,152088,0);t[n>>2]=3063;o=t[n>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+104>>2]|0)!=0?(t[(t[u>>2]|0)+104>>2]|0)==(t[(t[a>>2]|0)+104>>2]|0):0)break;if((t[(t[u>>2]|0)+52>>2]|0)==1?(t[(t[a>>2]|0)+52>>2]|0)==1:0)break;if(!(t[(t[u>>2]|0)+28>>2]|0)){sv(t[f>>2]|0,3063,t[u>>2]|0,0,152152,0);t[n>>2]=3063;o=t[n>>2]|0;s=r;return o|0}if((t[(t[a>>2]|0)+52>>2]|0)!=1){if((t[(t[u>>2]|0)+52>>2]|0)==(t[(t[a>>2]|0)+52>>2]|0)){if((t[(t[u>>2]|0)+52>>2]|0)==3)break;if((t[(t[u>>2]|0)+52>>2]|0)==2)break}sv(t[f>>2]|0,3063,t[u>>2]|0,0,152200,0);t[n>>2]=3063;o=t[n>>2]|0;s=r;return o|0}}while(0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function gL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[u>>2]|0)+64>>2];if((t[t[a>>2]>>2]|0)!=5?(t[(t[a>>2]|0)+88>>2]|0)!=45:0){th(t[f>>2]|0,1787,t[(t[u>>2]|0)+36>>2]|0,t[u>>2]|0,150744,0,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}i=t[f>>2]|0;if(t[(t[a>>2]|0)+48>>2]&1024){th(i,1787,t[(t[u>>2]|0)+36>>2]|0,t[u>>2]|0,150784,0,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}if((Fv(i,0,t[u>>2]|0,t[a>>2]|0,t[(t[u>>2]|0)+116>>2]|0,t[(t[a>>2]|0)+116>>2]|0,t[(t[u>>2]|0)+84>>2]|0,t[(t[a>>2]|0)+84>>2]|0)|0)==-1){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}do if((t[(t[a>>2]|0)+88>>2]|0)!=45){if((t[(t[u>>2]|0)+52>>2]|0)!=4?(t[(t[u>>2]|0)+52>>2]|0)!=6:0){if((t[(t[u>>2]|0)+52>>2]|0)==1){if((t[(t[a>>2]|0)+52>>2]|0)==1)break;if(!((t[(t[a>>2]|0)+52>>2]|0)!=2?(t[(t[a>>2]|0)+52>>2]|0)!=3:0))k=28;if((k|0)==28?(mL(t[(t[a>>2]|0)+28>>2]|0)|0)!=0:0)break;sv(t[f>>2]|0,1787,t[u>>2]|0,0,151040,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}if((t[(t[u>>2]|0)+52>>2]|0)!=2?(t[(t[u>>2]|0)+52>>2]|0)!=3:0){sv(t[f>>2]|0,1787,t[u>>2]|0,0,151256,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}if((t[(t[u>>2]|0)+52>>2]|0)!=3)break;if((t[(t[a>>2]|0)+52>>2]|0)==3)break;sv(t[f>>2]|0,1787,t[u>>2]|0,0,151160,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}if((t[(t[a>>2]|0)+52>>2]|0)!=4?(t[(t[a>>2]|0)+52>>2]|0)!=6:0){if((t[(t[a>>2]|0)+52>>2]|0)==3?(mL(t[(t[a>>2]|0)+28>>2]|0)|0)!=0:0)break;sv(t[f>>2]|0,1787,t[u>>2]|0,0,150936,0);t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}t[o>>2]=lL(t[f>>2]|0,t[(t[u>>2]|0)+104>>2]|0,t[(t[a>>2]|0)+104>>2]|0,0)|0;if(t[o>>2]|0){t[c>>2]=0;t[l>>2]=0;if((t[o>>2]|0)==-1){t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}i=t[f>>2]|0;e=t[u>>2]|0;h=Nd(c,t[(t[u>>2]|0)+104>>2]|0)|0;th(i,1787,0,e,150848,h,Nd(l,t[(t[a>>2]|0)+104>>2]|0)|0);if(t[c>>2]|0){pAi[t[135736>>2]&511](t[c>>2]|0);t[c>>2]=0}if(t[l>>2]|0){pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0}t[n>>2]=t[(t[f>>2]|0)+16>>2];b=t[n>>2]|0;s=r;return b|0}}while(0);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}function yL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[(t[u>>2]|0)+80>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=t[u>>2]|0;if((t[(t[u>>2]|0)+80>>2]|0)==(t[f>>2]|0)){t[n>>2]=i;o=t[n>>2]|0;s=r;return o|0}if(t[(t[i+80>>2]|0)+48>>2]&512){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{i=(t[(t[u>>2]|0)+80>>2]|0)+48|0;t[i>>2]=t[i>>2]|512;t[a>>2]=yL(t[f>>2]|0,t[(t[u>>2]|0)+80>>2]|0)|0;f=(t[(t[u>>2]|0)+80>>2]|0)+48|0;t[f>>2]=t[f>>2]^512;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function FL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;do if((t[t[o>>2]>>2]|0)!=4){if((t[t[o>>2]>>2]|0)==1?(t[(t[o>>2]|0)+88>>2]|0)!=45:0)break;t[u>>2]=cD(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;b=t[u>>2]|0;s=f;return b|0}while(0);t[u>>2]=lL(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;b=t[u>>2]|0;s=f;return b|0}function OL(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if(!((t[t[l>>2]>>2]|0)!=5?(t[(t[l>>2]|0)+88>>2]|0)!=45:0))w=3;do if(((w|0)==3?(t[(t[l>>2]|0)+52>>2]|0)!=4:0)?(t[(t[l>>2]|0)+52>>2]|0)!=6:0){if((t[(t[l>>2]|0)+52>>2]|0)==3?(mL(t[(t[l>>2]|0)+28>>2]|0)|0)!=0:0)break;sv(t[o>>2]|0,3059,t[l>>2]|0,t[(t[l>>2]|0)+36>>2]|0,159240,0);t[a>>2]=3059;d=t[a>>2]|0;s=u;return d|0}while(0);do if((t[t[l>>2]>>2]|0)==4)w=11;else{if((t[t[l>>2]>>2]|0)==1?(t[(t[l>>2]|0)+88>>2]|0)!=45:0){w=11;break}if((t[(t[l>>2]|0)+52>>2]|0)!=4?(t[(t[l>>2]|0)+52>>2]|0)!=6:0){t[a>>2]=t[h>>2];d=t[a>>2]|0;s=u;return d|0}t[h>>2]=nh(t[o>>2]|0,t[c>>2]|0,t[(t[l>>2]|0)+104>>2]|0,t[b>>2]|0,t[k>>2]|0,1,1,0)|0}while(0);if((w|0)==11)t[h>>2]=nh(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,1,1,0)|0;if((t[h>>2]|0)<0)rh(t[o>>2]|0,159384,141832);t[a>>2]=t[h>>2];d=t[a>>2]|0;s=u;return d|0}function AL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=lD(t[u>>2]|0,t[a>>2]|0)|0;if(!(t[c>>2]|0))t[c>>2]=sD(t[u>>2]|0,t[a>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}if((Cd(t[(t[c>>2]|0)+4>>2]|0,t[o>>2]|0)|0)==-1){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}return 0}function ML(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[(t[(t[u>>2]|0)+12>>2]|0)+48>>2]&131072)){t[o>>2]=t[(t[u>>2]|0)+12>>2];if(t[(t[o>>2]|0)+48>>2]&16){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}do if((t[(t[u>>2]|0)+20>>2]|0)==1){t[c>>2]=t[(t[f>>2]|0)+76>>2];i=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[o>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i}else{if((t[(t[u>>2]|0)+20>>2]|0)>=1073741824?(t[(t[u>>2]|0)+16>>2]|0)<2:0){t[c>>2]=t[(t[f>>2]|0)+76>>2];i=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[o>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i;i=cb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[o>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i;
	break}if((t[(t[u>>2]|0)+20>>2]|0)==1073741824)w=1073741824;else w=(t[(t[u>>2]|0)+20>>2]|0)-1|0;t[b>>2]=w;if((t[(t[u>>2]|0)+16>>2]|0)<1)d=0;else d=(t[(t[u>>2]|0)+16>>2]|0)-1|0;t[k>>2]=d;t[c>>2]=hb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,0)|0;t[l>>2]=db(t[(t[f>>2]|0)+64>>2]|0,t[k>>2]|0,t[b>>2]|0)|0;i=cb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[o>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i;vb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;i=mb(t[(t[f>>2]|0)+64>>2]|0,t[(t[f>>2]|0)+76>>2]|0,0,t[l>>2]|0)|0;t[(t[f>>2]|0)+76>>2]=i}while(0);if(!(t[(t[u>>2]|0)+16>>2]|0)){hb(t[(t[f>>2]|0)+64>>2]|0,t[c>>2]|0,t[(t[f>>2]|0)+76>>2]|0)|0;t[a>>2]=1}}else t[a>>2]=RL(t[f>>2]|0,t[u>>2]|0,-1,0)|0;t[n>>2]=t[a>>2];h=t[n>>2]|0;s=r;return h|0}function RL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;f=s;s=s+64|0;u=f+56|0;a=f+52|0;o=f+48|0;c=f+44|0;l=f+40|0;b=f+36|0;k=f+32|0;h=f+28|0;w=f+24|0;d=f+20|0;v=f+16|0;m=f+12|0;_=f+8|0;p=f+4|0;E=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[m>>2]=0;t[h>>2]=t[(t[o>>2]|0)+12>>2];t[b>>2]=t[(t[a>>2]|0)+76>>2];if(!(t[l>>2]|0))t[l>>2]=kb(t[(t[a>>2]|0)+64>>2]|0)|0;t[d>>2]=lD(t[a>>2]|0,t[h>>2]|0)|0;if(!(t[d>>2]|0)){n=t[a>>2]|0;r=lw(t[o>>2]|0)|0;pw(n,r,3069,158280,t[(t[h>>2]|0)+8>>2]|0,0);t[u>>2]=0;S=t[u>>2]|0;s=f;return S|0}e:do if((t[c>>2]|0)>=0){t[k>>2]=vb(t[(t[a>>2]|0)+64>>2]|0,t[b>>2]|0,0,t[c>>2]|0)|0;cb(t[(t[a>>2]|0)+64>>2]|0,t[k>>2]|0,t[l>>2]|0,t[(t[h>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+52>>2]|0,t[h>>2]|0)|0;t[v>>2]=0;while(1){if((t[v>>2]|0)>=(t[(t[(t[d>>2]|0)+4>>2]|0)+4>>2]|0))break e;t[w>>2]=t[(t[t[(t[d>>2]|0)+4>>2]>>2]|0)+(t[v>>2]<<2)>>2];cb(t[(t[a>>2]|0)+64>>2]|0,t[k>>2]|0,t[l>>2]|0,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+52>>2]|0,t[w>>2]|0)|0;t[v>>2]=(t[v>>2]|0)+1}}else{if((t[(t[o>>2]|0)+20>>2]|0)==1){r=t[(t[a>>2]|0)+64>>2]|0;n=cb(t[(t[a>>2]|0)+64>>2]|0,t[b>>2]|0,0,t[(t[h>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+52>>2]|0,t[h>>2]|0)|0;hb(r,n,t[l>>2]|0)|0;t[v>>2]=0;while(1){if((t[v>>2]|0)>=(t[(t[(t[d>>2]|0)+4>>2]|0)+4>>2]|0))break e;t[w>>2]=t[(t[t[(t[d>>2]|0)+4>>2]>>2]|0)+(t[v>>2]<<2)>>2];t[k>>2]=cb(t[(t[a>>2]|0)+64>>2]|0,t[b>>2]|0,0,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+52>>2]|0,t[w>>2]|0)|0;hb(t[(t[a>>2]|0)+64>>2]|0,t[k>>2]|0,t[l>>2]|0)|0;t[v>>2]=(t[v>>2]|0)+1}}if((t[(t[o>>2]|0)+20>>2]|0)==1073741824)g=1073741824;else g=(t[(t[o>>2]|0)+20>>2]|0)-1|0;t[p>>2]=g;if((t[(t[o>>2]|0)+16>>2]|0)<1)y=0;else y=(t[(t[o>>2]|0)+16>>2]|0)-1|0;t[E>>2]=y;t[c>>2]=db(t[(t[a>>2]|0)+64>>2]|0,t[E>>2]|0,t[p>>2]|0)|0;t[_>>2]=kb(t[(t[a>>2]|0)+64>>2]|0)|0;n=t[(t[a>>2]|0)+64>>2]|0;r=cb(t[(t[a>>2]|0)+64>>2]|0,t[b>>2]|0,0,t[(t[h>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+52>>2]|0,t[h>>2]|0)|0;hb(n,r,t[_>>2]|0)|0;t[v>>2]=0;while(1){if((t[v>>2]|0)>=(t[(t[(t[d>>2]|0)+4>>2]|0)+4>>2]|0))break;t[w>>2]=t[(t[t[(t[d>>2]|0)+4>>2]>>2]|0)+(t[v>>2]<<2)>>2];r=t[(t[a>>2]|0)+64>>2]|0;n=cb(t[(t[a>>2]|0)+64>>2]|0,t[b>>2]|0,0,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+52>>2]|0,t[w>>2]|0)|0;hb(r,n,t[_>>2]|0)|0;t[v>>2]=(t[v>>2]|0)+1}vb(t[(t[a>>2]|0)+64>>2]|0,t[_>>2]|0,t[b>>2]|0,t[c>>2]|0)|0;mb(t[(t[a>>2]|0)+64>>2]|0,t[_>>2]|0,t[l>>2]|0,t[c>>2]|0)|0}while(0);if(!(t[(t[o>>2]|0)+16>>2]|0)){hb(t[(t[a>>2]|0)+64>>2]|0,t[b>>2]|0,t[l>>2]|0)|0;t[m>>2]=1}t[(t[a>>2]|0)+76>>2]=t[l>>2];t[u>>2]=t[m>>2];S=t[u>>2]|0;s=f;return S|0}function NL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if(!(t[(t[f>>2]|0)+168>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[f>>2]|0)+168>>2]|0)){l=8;break}t[o>>2]=t[(t[(t[f>>2]|0)+164>>2]|0)+(t[a>>2]<<2)>>2];if((t[(t[o>>2]|0)+48>>2]|0)==(t[u>>2]|0)){l=6;break}t[a>>2]=(t[a>>2]|0)+1}if((l|0)==6){t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}else if((l|0)==8){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}return 0}function TL(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;u=s;s=s+48|0;a=u+32|0;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;w=u+4|0;d=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;t[d>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}f=t[o>>2]|0;if(!(t[(t[o>>2]|0)+88>>2]|0)){rh(f,155272,155304);t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}t[w>>2]=t[f+88>>2];f=t[w>>2]|0;if(!(t[(t[w>>2]|0)+28>>2]|0)){rh(f,155272,155336);t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}t[k>>2]=ST(t[f+80>>2]|0,t[k>>2]|0,t[l>>2]|0)|0;t[h>>2]=lh(t[w>>2]|0,1,t[k>>2]|0,0,0,0,t[l>>2]|0,0,t[b>>2]|0,d)|0;if(t[h>>2]|0){t[a>>2]=t[h>>2];v=t[a>>2]|0;s=u;return v|0}if(!(t[d>>2]|0)){mw(t[o>>2]|0,1879,t[l>>2]|0,0,155352,t[k>>2]|0,0,0);t[a>>2]=t[h>>2];v=t[a>>2]|0;s=u;return v|0}if((t[d>>2]|0)!=0?(t[(t[(t[w>>2]|0)+28>>2]|0)+16>>2]|0)==0:0)t[(t[(t[w>>2]|0)+28>>2]|0)+16>>2]=t[d>>2];if(((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+20>>2]|0)!=0:0)?(t[(t[d>>2]|0)+32>>2]|0)==0:0){t[(t[w>>2]|0)+20>>2]=0;t[(t[w>>2]|0)+16>>2]=0;t[(t[w>>2]|0)+48>>2]=t[(t[d>>2]|0)+20>>2];t[h>>2]=sh(t[w>>2]|0,t[c>>2]|0,t[d>>2]|0)|0;if((t[h>>2]|0)==-1){t[(t[w>>2]|0)+48>>2]=0;t[(t[w>>2]|0)+48>>2]=0;t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}if((t[h>>2]|0)==0?(t[(t[w>>2]|0)+20>>2]|0)!=0:0)t[h>>2]=t[(t[w>>2]|0)+16>>2];c=t[w>>2]|0;if(!(t[(t[w>>2]|0)+20>>2]|0)){bh(c,t[d>>2]|0)|0;t[h>>2]=t[(t[w>>2]|0)+16>>2];if((t[h>>2]|0)!=0?(t[(t[o>>2]|0)+52>>2]|0)==0:0)t[(t[o>>2]|0)+52>>2]=t[h>>2];d=(t[o>>2]|0)+56|0;t[d>>2]=(t[d>>2]|0)+(t[(t[w>>2]|0)+20>>2]|0)}else{d=(t[o>>2]|0)+56|0;t[d>>2]=(t[d>>2]|0)+(t[c+20>>2]|0)}t[(t[w>>2]|0)+48>>2]=0;t[a>>2]=t[h>>2];v=t[a>>2]|0;s=u;return v|0}t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}function LL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;f=s;s=s+48|0;u=f+40|0;a=f+36|0;o=f+32|0;c=f+28|0;l=f+24|0;b=f+20|0;k=f+16|0;h=f+12|0;w=f+8|0;d=f+4|0;v=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if(!(t[c>>2]|0)){t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}t[t[c>>2]>>2]=0;if(!(t[o>>2]|0)){t[u>>2]=0;m=t[u>>2]|0;s=f;return m|0}t[k>>2]=0;t[h>>2]=0;t[(t[a>>2]|0)+108>>2]=t[o>>2];t[b>>2]=bD(t[a>>2]|0,t[(t[o>>2]|0)+20>>2]|0,k,h)|0;do if(t[b>>2]|0){if((t[b>>2]|0)<0){rh(t[a>>2]|0,146768,146808);t[(t[a>>2]|0)+108>>2]=t[(t[(t[a>>2]|0)+100>>2]|0)+(t[(t[a>>2]|0)+96>>2]<<2)>>2];t[u>>2]=-1;m=t[u>>2]|0;s=f;return m|0}}else{o=iv(t[(t[a>>2]|0)+20>>2]|0,t[h>>2]|0,t[k>>2]|0)|0;t[t[c>>2]>>2]=o;if(!(t[t[c>>2]>>2]|0)){t[w>>2]=0;o=t[a>>2]|0;n=ED(21)|0;th(o,1851,0,n,146880,uh(w,t[k>>2]|0,t[h>>2]|0)|0,0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}t[b>>2]=t[(t[a>>2]|0)+52>>2];break}if(t[l>>2]|0){t[d>>2]=0;if(!((t[(t[l>>2]|0)+48>>2]&2048|0)==0?(t[(t[(t[l>>2]|0)+28>>2]|0)+48>>2]&262144|0)==0:0))t[d>>2]=t[d>>2]|2;if(!((t[(t[l>>2]|0)+48>>2]&4096|0)==0?(t[(t[(t[l>>2]|0)+28>>2]|0)+48>>2]&524288|0)==0:0))t[d>>2]=t[d>>2]|1;if(FL(t[a>>2]|0,t[t[c>>2]>>2]|0,t[(t[l>>2]|0)+28>>2]|0,t[d>>2]|0)|0){t[v>>2]=0;n=t[a>>2]|0;th(n,1852,0,0,146968,uh(v,t[(t[t[c>>2]>>2]|0)+112>>2]|0,t[(t[t[c>>2]>>2]|0)+8>>2]|0)|0,0);if(t[v>>2]|0){pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0}t[b>>2]=t[(t[a>>2]|0)+52>>2];t[t[c>>2]>>2]=0}}}while(0);t[(t[a>>2]|0)+108>>2]=t[(t[(t[a>>2]|0)+100>>2]|0)+(t[(t[a>>2]|0)+96>>2]<<2)>>2];t[u>>2]=t[b>>2];m=t[u>>2]|0;s=f;return m|0}function DL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[c>>2]=t[(t[u>>2]|0)+100>>2];if(!(t[c>>2]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}if(t[(t[(t[f>>2]|0)+108>>2]|0)+56>>2]|0){rh(t[f>>2]|0,146584,146616);t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}e:while(1){do if((t[t[c>>2]>>2]|0)==24?(t[l>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+4>>2],(t[l>>2]|0)!=0):0){t[(t[(t[f>>2]|0)+108>>2]|0)+76>>2]=1;t[b>>2]=t[(t[f>>2]|0)+112>>2];while(1){if(!(t[b>>2]|0))break;if((t[(t[b>>2]|0)+4>>2]|0)==(t[l>>2]|0))break;t[b>>2]=t[t[b>>2]>>2]}if(!(t[b>>2]|0)){h=12;break e}if((t[(t[b>>2]|0)+8>>2]|0)!=-1?(t[(t[f>>2]|0)+96>>2]|0)>=(t[(t[b>>2]|0)+8>>2]|0):0)break;t[(t[b>>2]|0)+8>>2]=t[(t[f>>2]|0)+96>>2]}while(0);t[b>>2]=t[(t[f>>2]|0)+112>>2];while(1){if(!(t[b>>2]|0))break;if((t[(t[b>>2]|0)+4>>2]|0)==(t[c>>2]|0))break;t[b>>2]=t[t[b>>2]>>2]}w=t[f>>2]|0;if(!(t[b>>2]|0)){h=21;break}if(t[w+124>>2]|0){t[a>>2]=t[(t[f>>2]|0)+124>>2];t[(t[f>>2]|0)+124>>2]=t[(t[a>>2]|0)+12>>2];t[(t[a>>2]|0)+12>>2]=0}else{t[a>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[a>>2]|0)){h=25;break}u=(t[a>>2]|0)+0|0;i=u+36|0;do{t[u>>2]=0;u=u+4|0}while((u|0)<(i|0))}u=t[a>>2]|0;if(!(t[o>>2]|0))t[(t[(t[f>>2]|0)+108>>2]|0)+56>>2]=u;else t[(t[o>>2]|0)+8>>2]=u;t[o>>2]=t[a>>2];t[t[a>>2]>>2]=0;t[(t[a>>2]|0)+4>>2]=t[(t[f>>2]|0)+96>>2];t[(t[a>>2]|0)+16>>2]=t[b>>2];t[(t[a>>2]|0)+20>>2]=t[t[(t[b>>2]|0)+4>>2]>>2];if((CL(t[f>>2]|0,t[a>>2]|0,t[(t[c>>2]|0)+24>>2]|0,1)|0)==-1){h=31;break}t[c>>2]=t[(t[c>>2]|0)+8>>2];if(!(t[c>>2]|0)){h=33;break}}if((h|0)==12){rh(t[f>>2]|0,146584,146672);t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==21){rh(w,146584,146672);t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==25){kh(t[f>>2]|0,146736,0);t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==31){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==33){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}return 0}function CL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;do if(t[(t[a>>2]|0)+120>>2]|0){t[b>>2]=t[(t[a>>2]|0)+120>>2];t[(t[a>>2]|0)+120>>2]=t[(t[b>>2]|0)+4>>2];t[(t[b>>2]|0)+4>>2]=0}else{t[b>>2]=gAi[t[135744>>2]&511](36)|0;if(t[b>>2]|0){n=(t[b>>2]|0)+0|0;r=n+36|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));break}kh(0,146088,0);t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}while(0);if(t[(t[a>>2]|0)+116>>2]|0)t[(t[b>>2]|0)+4>>2]=t[(t[a>>2]|0)+116>>2];t[(t[a>>2]|0)+116>>2]=t[b>>2];if(t[(t[b>>2]|0)+32>>2]|0)_j(t[(t[b>>2]|0)+32>>2]|0);n=Aj(t[(t[c>>2]|0)+16>>2]|0)|0;t[(t[b>>2]|0)+32>>2]=n;if(!(t[(t[b>>2]|0)+32>>2]|0)){rh(t[a>>2]|0,146120,146152);t[u>>2]=-1;k=t[u>>2]|0;s=f;return k|0}else{t[t[b>>2]>>2]=t[l>>2];t[(t[b>>2]|0)+8>>2]=t[(t[a>>2]|0)+96>>2];t[(t[b>>2]|0)+24>>2]=t[o>>2];t[(t[b>>2]|0)+28>>2]=t[c>>2];t[(t[b>>2]|0)+16>>2]=0;t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}return 0}function PL(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if(!(t[(t[n>>2]|0)+116>>2]|0)){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}t[f>>2]=t[(t[n>>2]|0)+116>>2];while(1){t[u>>2]=gj(t[(t[f>>2]|0)+32>>2]|0)|0;if((t[u>>2]|0)==-1){o=5;break}t[f>>2]=t[(t[f>>2]|0)+4>>2];if(!(t[f>>2]|0)){o=7;break}}if((o|0)==5){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==7){t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}return 0}function BL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=0;t[b>>2]=0;bw(l,t[u>>2]|0,t[c>>2]|0)|0;t[l>>2]=us(t[l>>2]|0,145232)|0;n=t[u>>2]|0;u=t[a>>2]|0;a=t[c>>2]|0;r=t[l>>2]|0;pd(n,u,a,r,kD(b,t[o>>2]|0,t[c>>2]|0)|0,0);if(t[b>>2]|0){pAi[t[135736>>2]&511](t[b>>2]|0);t[b>>2]=0}if(!(t[l>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[l>>2]|0);t[l>>2]=0;s=f;return}function IL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=Nd(t[n>>2]|0,t[f>>2]|0)|0;s=r;return i|0}function HL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(t[(t[f>>2]|0)+140>>2]|0){if((t[(t[f>>2]|0)+148>>2]|0)<=(t[(t[f>>2]|0)+144>>2]|0)?(i=(t[f>>2]|0)+148|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+140>>2]|0,t[(t[f>>2]|0)+148>>2]<<2)|0,t[(t[f>>2]|0)+140>>2]=i,(t[(t[f>>2]|0)+140>>2]|0)==0):0){kh(t[f>>2]|0,143616,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}}else{i=gAi[t[135744>>2]&511](160)|0;t[(t[f>>2]|0)+140>>2]=i;i=t[f>>2]|0;if(t[(t[f>>2]|0)+140>>2]|0){t[i+148>>2]=40;break}kh(i,143576,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}while(0);i=t[u>>2]|0;u=(t[f>>2]|0)+144|0;e=t[u>>2]|0;t[u>>2]=e+1;t[(t[(t[f>>2]|0)+140>>2]|0)+(e<<2)>>2]=i;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function xL(e,i){e=e|0;i=i|0;var r=0,n=0;r=s;s=s+16|0;n=r;t[r+4>>2]=e;t[n>>2]=i;if(!(t[(t[n>>2]|0)+32>>2]|0)){i=hh()|0;t[(t[n>>2]|0)+32>>2]=i}s=r;return t[(t[n>>2]|0)+32>>2]|0}function UL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[k>>2]=0;n=Yl(142560)|0;t[t[a>>2]>>2]=n;t[l>>2]=0;while(1){h=t[t[a>>2]>>2]|0;if((t[l>>2]|0)>=(t[c>>2]|0))break;n=us(h,142568)|0;t[t[a>>2]>>2]=n;n=t[(t[(t[o>>2]|0)+(t[l>>2]<<2)>>2]|0)+4>>2]|0;t[b>>2]=WL(n,Ed(t[t[(t[o>>2]|0)+(t[l>>2]<<2)>>2]>>2]|0)|0,k)|0;if(!(t[b>>2]|0)){n=us(t[t[a>>2]>>2]|0,t[k>>2]|0)|0;t[t[a>>2]>>2]=n}else{rh(t[u>>2]|0,142576,142608);n=us(t[t[a>>2]>>2]|0,142648)|0;t[t[a>>2]>>2]=n}n=t[t[a>>2]>>2]|0;if((t[l>>2]|0)<((t[c>>2]|0)-1|0)){r=us(n,142656)|0;t[t[a>>2]>>2]=r}else{r=us(n,142568)|0;t[t[a>>2]>>2]=r}if(t[k>>2]|0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}t[l>>2]=(t[l>>2]|0)+1}l=us(h,142664)|0;t[t[a>>2]>>2]=l;s=f;return t[t[a>>2]>>2]|0}function zL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(t[(t[f>>2]|0)+128>>2]|0){if((t[(t[f>>2]|0)+136>>2]|0)<=(t[(t[f>>2]|0)+132>>2]|0)?(i=(t[f>>2]|0)+136|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+128>>2]|0,t[(t[f>>2]|0)+136>>2]<<2)|0,t[(t[f>>2]|0)+128>>2]=i,(t[(t[f>>2]|0)+128>>2]|0)==0):0){kh(t[f>>2]|0,143528,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}}else{i=gAi[t[135744>>2]&511](80)|0;t[(t[f>>2]|0)+128>>2]=i;i=t[f>>2]|0;if(t[(t[f>>2]|0)+128>>2]|0){t[i+136>>2]=20;break}kh(i,143488,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}while(0);i=t[u>>2]|0;u=(t[f>>2]|0)+132|0;e=t[u>>2]|0;t[u>>2]=e+1;t[(t[(t[f>>2]|0)+128>>2]|0)+(e<<2)>>2]=i;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function jL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[a>>2]=kz(t[(t[u>>2]|0)+156>>2]|0,t[a>>2]|0,-1)|0;if(!(t[a>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}if((t[o>>2]|0)!=0?(t[o>>2]=kz(t[(t[u>>2]|0)+156>>2]|0,t[o>>2]|0,-1)|0,(t[o>>2]|0)==0):0){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[(t[(t[u>>2]|0)+180>>2]|0)+4>>2]|0)){b=12;break}if((t[(t[t[(t[u>>2]|0)+180>>2]>>2]|0)+(t[c>>2]<<2)>>2]|0)==(t[a>>2]|0)?(t[(t[t[(t[u>>2]|0)+180>>2]>>2]|0)+((t[c>>2]|0)+1<<2)>>2]|0)==(t[o>>2]|0):0){b=10;break}t[c>>2]=(t[c>>2]|0)+2}if((b|0)==10){t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}else if((b|0)==12){t[c>>2]=t[(t[(t[u>>2]|0)+180>>2]|0)+4>>2];Cd(t[(t[u>>2]|0)+180>>2]|0,t[a>>2]|0)|0;Cd(t[(t[u>>2]|0)+180>>2]|0,t[o>>2]|0)|0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}return 0}function VL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[(t[f>>2]|0)+100>>2]|0)+(t[(t[u>>2]|0)+4>>2]<<2)>>2];if(!(t[(t[a>>2]|0)+52>>2]|0)){f=GL(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)|0;t[(t[a>>2]|0)+52>>2]=f;if(!(t[(t[a>>2]|0)+52>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[n>>2]=t[(t[a>>2]|0)+52>>2];c=t[n>>2]|0;s=r;return c|0}}t[o>>2]=0;t[o>>2]=t[(t[a>>2]|0)+52>>2];while(1){l=t[o>>2]|0;if((t[(t[o>>2]|0)+4>>2]|0)==(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)){b=7;break}if(!(t[l>>2]|0)){b=9;break}t[o>>2]=t[t[o>>2]>>2];if(!(t[o>>2]|0)){b=13;break}}if((b|0)==7){t[n>>2]=l;c=t[n>>2]|0;s=r;return c|0}else if((b|0)==9){l=GL(t[(t[(t[u>>2]|0)+16>>2]|0)+4>>2]|0)|0;t[t[o>>2]>>2]=l;if(!(t[t[o>>2]>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[n>>2]=t[t[o>>2]>>2];c=t[n>>2]|0;s=r;return c|0}}else if((b|0)==13){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}return 0}function qL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;i=(t[f>>2]|0)+16|0;if(!(t[(t[f>>2]|0)+8>>2]|0)){t[i>>2]=10;e=gAi[t[135744>>2]&511](40)|0;t[(t[f>>2]|0)+8>>2]=e;if(!(t[(t[f>>2]|0)+8>>2]|0)){kh(0,142256,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}}else if((t[i>>2]|0)<=(t[(t[f>>2]|0)+12>>2]|0)?(i=(t[f>>2]|0)+16|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+16>>2]<<2)|0,t[(t[f>>2]|0)+8>>2]=i,(t[(t[f>>2]|0)+8>>2]|0)==0):0){kh(0,142712,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}i=t[u>>2]|0;u=(t[f>>2]|0)+12|0;e=t[u>>2]|0;t[u>>2]=e+1;t[(t[(t[f>>2]|0)+8>>2]|0)+(e<<2)>>2]=i;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function YL(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+24|0;k=o+16|0;h=o+12|0;w=o+8|0;d=o+4|0;v=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[o+20>>2]=n;t[k>>2]=f;t[h>>2]=u;t[w>>2]=a;t[d>>2]=0;t[v>>2]=0;t[d>>2]=Yl(142688)|0;t[d>>2]=us(t[d>>2]|0,t[k>>2]|0)|0;t[d>>2]=us(t[d>>2]|0,142704)|0;k=t[c>>2]|0;a=t[l>>2]|0;l=t[(t[b>>2]|0)+8>>2]|0;u=t[d>>2]|0;f=uh(v,t[(t[t[(t[c>>2]|0)+180>>2]>>2]|0)+((t[(t[b>>2]|0)+12>>2]|0)+1<<2)>>2]|0,t[(t[t[(t[c>>2]|0)+180>>2]>>2]|0)+(t[(t[b>>2]|0)+12>>2]<<2)>>2]|0)|0;Ld(k,2,a,0,l,u,f,t[h>>2]|0,t[w>>2]|0,0);if(t[v>>2]|0){pAi[t[135736>>2]&511](t[v>>2]|0);t[v>>2]=0}if(!(t[d>>2]|0)){s=o;return}pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0;s=o;return}function GL(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[f>>2]|0)){kh(0,142304,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;t[(t[f>>2]|0)+4>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function WL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[k>>2]=0;if((t[o>>2]|0)==0|(t[u>>2]|0)==0){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}r=(gD(t[u>>2]|0)|0)!=0;t[c>>2]=r?1:0;t[t[o>>2]>>2]=0;while(1){t[b>>2]=0;t[l>>2]=qD(t[u>>2]|0)|0;r=t[l>>2]|0;if((r|0)==46|(r|0)==2|(r|0)==1){t[b>>2]=yD(t[u>>2]|0)|0;if(t[b>>2]|0){if((t[a>>2]|0)!=3){if((t[a>>2]|0)==2)t[k>>2]=ND(t[b>>2]|0)|0}else t[k>>2]=TD(t[b>>2]|0)|0;if(t[k>>2]|0)t[b>>2]=t[k>>2]}}else{r=(VD(t[u>>2]|0,k)|0)==-1;w=t[k>>2]|0;if(r)break;t[b>>2]=w}r=t[b>>2]|0;do if(!(t[t[o>>2]>>2]|0)){if(r){i=Yl(t[b>>2]|0)|0;t[t[o>>2]>>2]=i;break}if(!(t[c>>2]|0)){i=Yl(142672)|0;t[t[o>>2]>>2]=i}}else if(r){i=us(t[t[o>>2]>>2]|0,142680)|0;t[t[o>>2]>>2]=i;i=us(t[t[o>>2]>>2]|0,t[b>>2]|0)|0;t[t[o>>2]>>2]=i}while(0);if(t[k>>2]|0){pAi[t[135736>>2]&511](t[k>>2]|0);t[k>>2]=0}t[u>>2]=gD(t[u>>2]|0)|0;if(!(t[u>>2]|0)){d=26;break}}if((d|0)==26){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(w)pAi[t[135736>>2]&511](t[k>>2]|0);if(t[t[o>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[o>>2]>>2]|0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}function KL(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=sF(t[r>>2]|0)|0;s=i;return e|0}function XL(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;r=t[u>>2]|0;if(t[a>>2]|0){t[f>>2]=uh(r,t[(t[a>>2]|0)+8>>2]|0,t[o>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=uh(r,0,t[o>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}return 0}function ZL(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;u=s;s=s+48|0;a=u+32|0;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;w=u+4|0;d=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[b>>2]|0)==0){t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}t[t[b>>2]>>2]=0;t[h>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;c=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if((Xl(t[c+8>>2]|0,161384)|0)==0?(Xl(t[(t[h>>2]|0)+8>>2]|0,155456)|0)==0:0)_T(t[o>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[c+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[o>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}Pd(t[o>>2]|0,t[l>>2]|0,161384)|0;t[h>>2]=Bd(t[l>>2]|0,155456)|0;do if(t[h>>2]|0){t[w>>2]=0;t[d>>2]=0;c=t[o>>2]|0;f=t[h>>2]|0;n=ED(29)|0;if(!(Id(c,0,f,n,t[b>>2]|0)|0)){t[w>>2]=oF(t[(t[l>>2]|0)+32>>2]|0,t[l>>2]|0)|0;n=t[t[b>>2]>>2]|0;if(!(t[w>>2]|0))t[d>>2]=GA(n,t[(t[(t[l>>2]|0)+32>>2]|0)+72>>2]|0)|0;else{t[d>>2]=GA(n,t[w>>2]|0)|0;pAi[t[135736>>2]&511](t[w>>2]|0)}n=t[o>>2]|0;if(!(t[d>>2]|0)){rh(n,168224,168256);t[a>>2]=-1;v=t[a>>2]|0;s=u;return v|0}f=kz(t[n+80>>2]|0,t[d>>2]|0,-1)|0;t[t[b>>2]>>2]=f;pAi[t[135736>>2]&511](t[d>>2]|0);if(!(Xl(t[t[b>>2]>>2]|0,t[(t[o>>2]|0)+44>>2]|0)|0)){t[a>>2]=0;v=t[a>>2]|0;s=u;return v|0}f=t[o>>2]|0;n=t[l>>2]|0;c=t[t[b>>2]>>2]|0;if((t[k>>2]|0)==3){sv(f,3081,0,n,168304,c);break}else{sv(f,3050,0,n,168360,c);break}}}else FT(t[o>>2]|0,3036,0,t[l>>2]|0,155456,0);while(0);t[a>>2]=t[(t[o>>2]|0)+16>>2];v=t[a>>2]|0;s=u;return v|0}function JL(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0;r=s;s=s+96|0;n=r+88|0;f=r+84|0;u=r+80|0;a=r+76|0;o=r+72|0;c=r+68|0;l=r+64|0;b=r+60|0;k=r+56|0;h=r+52|0;w=r+48|0;d=r+44|0;v=r+40|0;m=r+36|0;_=r+32|0;p=r+28|0;E=r+24|0;S=r+20|0;g=r+16|0;y=r+12|0;F=r+8|0;O=r+4|0;A=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;M=t[n>>2]|0;s=r;return M|0}do switch(t[t[f>>2]>>2]|0){case 16:{t[d>>2]=t[f>>2];t[v>>2]=t[(t[d>>2]|0)+24>>2];if(!(t[(t[d>>2]|0)+24>>2]|0)){t[(t[d>>2]|0)+24>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[v>>2]=t[(t[d>>2]|0)+24>>2];if(t[t[v>>2]>>2]|0)t[v>>2]=t[t[v>>2]>>2];t[t[v>>2]>>2]=t[u>>2];break}case 2:case 21:{t[b>>2]=t[f>>2];t[k>>2]=t[(t[b>>2]|0)+8>>2];if(!(t[(t[b>>2]|0)+8>>2]|0)){t[(t[b>>2]|0)+8>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[k>>2]=t[(t[b>>2]|0)+8>>2];if(t[t[k>>2]>>2]|0)t[k>>2]=t[t[k>>2]>>2];t[t[k>>2]>>2]=t[u>>2];break}case 18:{t[m>>2]=t[f>>2];t[_>>2]=t[(t[m>>2]|0)+8>>2];if(!(t[(t[m>>2]|0)+8>>2]|0)){t[(t[m>>2]|0)+8>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[_>>2]=t[(t[m>>2]|0)+8>>2];if(t[t[_>>2]>>2]|0)t[_>>2]=t[t[_>>2]>>2];t[t[_>>2]>>2]=t[u>>2];break}case 5:case 4:{t[S>>2]=t[f>>2];t[g>>2]=t[(t[S>>2]|0)+24>>2];if(!(t[(t[S>>2]|0)+24>>2]|0)){t[(t[S>>2]|0)+24>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[g>>2]=t[(t[S>>2]|0)+24>>2];if(t[t[g>>2]>>2]|0)t[g>>2]=t[t[g>>2]>>2];t[t[g>>2]>>2]=t[u>>2];break}case 1011:case 1010:case 1009:case 1008:case 1007:case 1006:case 1005:case 1004:case 1003:case 1002:case 1001:case 1e3:{t[p>>2]=t[f>>2];t[E>>2]=t[(t[p>>2]|0)+16>>2];if(!(t[(t[p>>2]|0)+16>>2]|0)){t[(t[p>>2]|0)+16>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[E>>2]=t[(t[p>>2]|0)+16>>2];if(t[t[E>>2]>>2]|0)t[E>>2]=t[t[E>>2]>>2];t[t[E>>2]>>2]=t[u>>2];break}case 17:{t[y>>2]=t[f>>2];t[F>>2]=t[(t[y>>2]|0)+4>>2];if(!(t[(t[y>>2]|0)+4>>2]|0)){t[(t[y>>2]|0)+4>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[F>>2]=t[(t[y>>2]|0)+4>>2];if(t[t[F>>2]>>2]|0)t[F>>2]=t[t[F>>2]>>2];t[t[F>>2]>>2]=t[u>>2];break}case 15:{t[c>>2]=t[f>>2];t[l>>2]=t[(t[c>>2]|0)+32>>2];if(!(t[(t[c>>2]|0)+32>>2]|0)){t[(t[c>>2]|0)+32>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[l>>2]=t[(t[c>>2]|0)+32>>2];if(t[t[l>>2]>>2]|0)t[l>>2]=t[t[l>>2]>>2];t[t[l>>2]>>2]=t[u>>2];break}case 22:case 24:case 23:case 25:{t[h>>2]=t[f>>2];t[w>>2]=t[(t[h>>2]|0)+4>>2];if(!(t[(t[h>>2]|0)+4>>2]|0)){t[(t[h>>2]|0)+4>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[w>>2]=t[(t[h>>2]|0)+4>>2];if(t[t[w>>2]>>2]|0)t[w>>2]=t[t[w>>2]>>2];t[t[w>>2]>>2]=t[u>>2];break}case 8:case 7:case 6:{t[O>>2]=t[f>>2];t[A>>2]=t[(t[O>>2]|0)+4>>2];if(!(t[(t[O>>2]|0)+4>>2]|0)){t[(t[O>>2]|0)+4>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[A>>2]=t[(t[O>>2]|0)+4>>2];if(t[t[A>>2]>>2]|0)t[A>>2]=t[t[A>>2]>>2];t[t[A>>2]>>2]=t[u>>2];break}case 14:{t[a>>2]=t[f>>2];t[o>>2]=t[(t[a>>2]|0)+24>>2];if(!(t[(t[a>>2]|0)+24>>2]|0)){t[(t[a>>2]|0)+24>>2]=t[u>>2];t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}t[o>>2]=t[(t[a>>2]|0)+24>>2];if(t[t[o>>2]>>2]|0)t[o>>2]=t[t[o>>2]>>2];t[t[o>>2]>>2]=t[u>>2];break}default:sv(0,3069,0,0,165080,0)}while(0);t[n>>2]=t[u>>2];M=t[n>>2]|0;s=r;return M|0}function QL(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}t[b>>2]=t[(t[a>>2]|0)+84>>2];n=(t[b>>2]|0)+48|0;t[n>>2]=t[n>>2]|2;t[h>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;n=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if((Xl(t[n+8>>2]|0,161384)|0)==0?(Xl(t[(t[h>>2]|0)+8>>2]|0,151424)|0)==0:0)_T(t[a>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;if((GT(t[a>>2]|0,t[o>>2]|0,0,t[c>>2]|0,151424,(t[b>>2]|0)+60|0,(t[b>>2]|0)+56|0)|0)==0?(t[(t[b>>2]|0)+56>>2]|0)==0:0)FT(t[a>>2]|0,3036,0,t[c>>2]|0,151424,0);t[k>>2]=t[(t[c>>2]|0)+12>>2];if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=t[b>>2]|0;JL(h,jd(t[a>>2]|0,t[k>>2]|0,1)|0)|0;t[k>>2]=t[(t[k>>2]|0)+24>>2]}do if((t[l>>2]|0)==10){if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=RT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,8,1)|0;t[(t[b>>2]|0)+28>>2]=h;t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=RT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,7,1)|0;t[(t[b>>2]|0)+28>>2]=h;t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=RT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,6,1)|0;t[(t[b>>2]|0)+28>>2]=h;t[k>>2]=t[(t[k>>2]|0)+24>>2];break}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){h=NT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;t[(t[b>>2]|0)+28>>2]=h;t[k>>2]=t[(t[k>>2]|0)+24>>2]}}while(0);if(t[k>>2]|0){if((TT(t[a>>2]|0,t[o>>2]|0,k,(t[b>>2]|0)+116|0,13,0)|0)==-1){t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){b=LT(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0)|0;t[(t[(t[a>>2]|0)+84>>2]|0)+84>>2]=b;t[k>>2]=t[(t[k>>2]|0)+24>>2]}}do if(t[k>>2]|0){b=t[a>>2]|0;o=t[c>>2]|0;h=t[k>>2]|0;if((t[l>>2]|0)==10){$d(b,3033,0,o,h,0,167440);break}else{$d(b,3033,0,o,h,0,163344);break}}while(0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function $L(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;t[d>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[w>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[w>>2]|0))break;r=t[w>>2]|0;if(!(t[(t[w>>2]|0)+36>>2]|0)){if(((((Xl(t[r+8>>2]|0,161384)|0)==0?(Xl(t[(t[w>>2]|0)+8>>2]|0,161824)|0)==0:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,161808)|0)==0:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,162304)|0)==0:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,162320)|0)==0:0)_T(t[u>>2]|0,3035,0,t[w>>2]|0)}else if(Xl(t[(t[r+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[w>>2]|0);t[w>>2]=t[(t[w>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[h>>2]=IT(t[u>>2]|0,t[o>>2]|0,0,1073741824,1,161768)|0;t[k>>2]=BT(t[u>>2]|0,t[o>>2]|0,0,-1,1,161744)|0;HT(t[u>>2]|0,0,t[o>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;t[b>>2]=nL(t[u>>2]|0,t[a>>2]|0,2,t[o>>2]|0)|0;if(!(t[b>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}rD(t[u>>2]|0,t[a>>2]|0,t[b>>2]|0,t[o>>2]|0)|0;t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[d>>2]=jd(t[u>>2]|0,t[l>>2]|0,1)|0;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if(t[l>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[l>>2]|0,0,161392);if((t[k>>2]|0)==0&(t[h>>2]|0)==0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[c>>2]=Mv(t[u>>2]|0,t[o>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else{t[(t[c>>2]|0)+4>>2]=t[d>>2];t[(t[c>>2]|0)+12>>2]=t[b>>2];t[f>>2]=t[c>>2];v=t[f>>2]|0;s=n;return v|0}return 0}function eD(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0;u=s;s=s+112|0;a=u+96|0;o=u+92|0;c=u+88|0;l=u+84|0;b=u+80|0;k=u+76|0;h=u+72|0;w=u+68|0;d=u+64|0;v=u+60|0;m=u+56|0;_=u+52|0;p=u+48|0;E=u+44|0;S=u+40|0;g=u+36|0;y=u+32|0;F=u+28|0;O=u+24|0;A=u+20|0;M=u+16|0;R=u+12|0;N=u+8|0;T=u+4|0;L=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;t[p>>2]=0;t[E>>2]=0;t[S>>2]=0;t[g>>2]=0;t[y>>2]=2;t[O>>2]=0;t[A>>2]=0;if((t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}t[_>>2]=Bd(t[l>>2]|0,160064)|0;do if(t[_>>2]|0){if(xT(t[o>>2]|0,t[c>>2]|0,0,t[_>>2]|0,p,E)|0){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(!(UT(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[_>>2]|0,t[p>>2]|0)|0)){t[g>>2]=1;break}t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}while(0);t[F>>2]=t[(t[o>>2]|0)+20>>2];t[_>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[_>>2]|0))break;e:do if(!(t[(t[_>>2]|0)+36>>2]|0)){f=t[(t[_>>2]|0)+8>>2]|0;do if(t[g>>2]|0)if(!(Xl(f,161384)|0))if(Xl(t[(t[_>>2]|0)+8>>2]|0,160064)|0)break e;else break;else{wT(t[o>>2]|0,t[_>>2]|0)|0;break e}else{if(Xl(f,161352)|0)break e;if(Xl(t[(t[_>>2]|0)+8>>2]|0,161384)|0){wT(t[o>>2]|0,t[_>>2]|0)|0;break e}if(Xl(t[(t[_>>2]|0)+8>>2]|0,155448)|0){xT(t[o>>2]|0,t[c>>2]|0,0,t[_>>2]|0,p,E)|0;break e}if(Xl(t[(t[_>>2]|0)+8>>2]|0,163528)|0){t[O>>2]=1;t[h>>2]=Hd(t[o>>2]|0,t[_>>2]|0)|0;if(Xl(t[h>>2]|0,163536)|0){t[d>>2]=t[(t[o>>2]|0)+112>>2];break e}if(Xl(t[h>>2]|0,163552)|0)break e;Ud(t[o>>2]|0,3037,0,t[_>>2]|0,0,163568,t[h>>2]|0,0,0,0);break e}}while(0);if(Xl(t[(t[_>>2]|0)+8>>2]|0,163600)|0){t[h>>2]=Hd(t[o>>2]|0,t[_>>2]|0)|0;if(Xl(t[h>>2]|0,163608)|0){t[y>>2]=2;break}if(Xl(t[h>>2]|0,163624)|0){t[y>>2]=0;break}if(Xl(t[h>>2]|0,163640)|0){t[y>>2]=1;break}else{Ud(t[o>>2]|0,1774,0,t[_>>2]|0,0,163656,t[h>>2]|0,0,0,0);break}}if(Xl(t[(t[_>>2]|0)+8>>2]|0,159128)|0){f=t[o>>2]|0;n=t[_>>2]|0;if(t[S>>2]|0){zT(f,3051,0,n,159128,159120);break}else{t[S>>2]=Hd(f,n)|0;t[A>>2]=1;break}}if(Xl(t[(t[_>>2]|0)+8>>2]|0,159120)|0){n=t[o>>2]|0;f=t[_>>2]|0;if(t[S>>2]|0){zT(n,3051,0,f,159128,159120);break}else{t[S>>2]=Hd(n,f)|0;t[A>>2]=2;break}}else C=43}else if(Xl(t[(t[(t[_>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)C=43;while(0);if((C|0)==43){C=0;_T(t[o>>2]|0,3035,0,t[_>>2]|0)}t[_>>2]=t[(t[_>>2]|0)+24>>2]}if((t[A>>2]|0)==1&(t[y>>2]|0)!=2)Ud(t[o>>2]|0,3052,0,t[l>>2]|0,0,163656,0,163696,0,0);if((t[F>>2]|0)!=(t[(t[o>>2]|0)+20>>2]|0)){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(t[g>>2]|0){if(t[y>>2]|0){t[v>>2]=hD(t[o>>2]|0,t[l>>2]|0)|0;if(!(t[v>>2]|0)){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[v>>2]|0)|0;t[(t[v>>2]|0)+24>>2]=t[y>>2];t[R>>2]=VT(t[o>>2]|0,15,t[E>>2]|0,t[p>>2]|0)|0;if(!(t[R>>2]|0)){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}t[(t[v>>2]|0)+12>>2]=t[R>>2];if(t[S>>2]|0)t[(t[v>>2]|0)+28>>2]=t[S>>2];if((t[A>>2]|0)==2){R=(t[v>>2]|0)+16|0;t[R>>2]=t[R>>2]|1}}}else{if((t[O>>2]|0)==0?(t[(t[c>>2]|0)+24>>2]&2|0)!=0:0)t[d>>2]=t[(t[o>>2]|0)+112>>2];if(Xl(t[d>>2]|0,t[38860]|0)|0)th(t[o>>2]|0,3057,t[l>>2]|0,0,163792,t[38860]|0,0);t[_>>2]=Bd(t[l>>2]|0,161352)|0;O=t[o>>2]|0;if(!(t[_>>2]|0)){FT(O,3036,0,t[l>>2]|0,161352,0);t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}R=t[_>>2]|0;if(Id(O,0,R,ED(22)|0,w)|0){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(Xl(t[w>>2]|0,163840)|0){R=t[o>>2]|0;O=t[_>>2]|0;Ud(R,3056,0,O,ED(22)|0,0,0,163848,0,0);t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(t[y>>2]|0){t[v>>2]=hD(t[o>>2]|0,t[l>>2]|0)|0;if(!(t[v>>2]|0)){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}t[(t[v>>2]|0)+24>>2]=t[y>>2];t[M>>2]=XT(t[o>>2]|0,t[c>>2]|0,t[w>>2]|0,t[d>>2]|0,t[l>>2]|0,0)|0;if(!(t[M>>2]|0)){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(t[E>>2]|0){t[(t[M>>2]|0)+24>>2]=t[E>>2];t[(t[M>>2]|0)+28>>2]=t[p>>2]}t[(t[v>>2]|0)+12>>2]=t[M>>2];
	if((t[S>>2]|0)!=0?(t[(t[M>>2]|0)+44>>2]=t[S>>2],(t[A>>2]|0)==2):0){A=(t[M>>2]|0)+60|0;t[A>>2]=t[A>>2]|512}}}t[m>>2]=t[(t[l>>2]|0)+12>>2];A=(t[m>>2]|0)!=0;if(t[y>>2]|0){if(((A?(t[(t[m>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){y=jd(t[o>>2]|0,t[m>>2]|0,1)|0;t[(t[v>>2]|0)+4>>2]=y;t[m>>2]=t[(t[m>>2]|0)+24>>2]}y=(t[m>>2]|0)!=0;do if(t[g>>2]|0){if(y){if((((t[m>>2]|0)!=0?(t[(t[m>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){$d(t[o>>2]|0,3054,0,t[l>>2]|0,t[m>>2]|0,0,161392);break}$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[m>>2]|0,0,161392)}}else{if(((y?(t[(t[m>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(Xl(t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){M=t[o>>2]|0;if(t[(t[(t[v>>2]|0)+12>>2]|0)+24>>2]|0)$d(M,3055,0,t[l>>2]|0,t[m>>2]|0,164128,0);else{S=Wd(M,t[c>>2]|0,t[m>>2]|0,0)|0;t[(t[(t[v>>2]|0)+12>>2]|0)+48>>2]=S}t[m>>2]=t[(t[m>>2]|0)+24>>2]}if(t[m>>2]|0)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[m>>2]|0,0,164200)}while(0);t[a>>2]=t[v>>2];D=t[a>>2]|0;s=u;return D|0}if(((A?(t[(t[m>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[m>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){jd(t[o>>2]|0,t[m>>2]|0,0)|0;t[m>>2]=t[(t[m>>2]|0)+24>>2]}if(t[m>>2]|0)$d(t[o>>2]|0,3033,0,t[l>>2]|0,t[m>>2]|0,0,161392);if((t[k>>2]|0)==16){mw(t[o>>2]|0,3086,t[l>>2]|0,0,163904,0,0,0);t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if((t[k>>2]|0)==13){mw(t[o>>2]|0,3086,t[l>>2]|0,0,163992,0,0,0);t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}if(!(t[g>>2]|0)){t[E>>2]=t[w>>2];t[p>>2]=t[d>>2]}e:do if(t[b>>2]|0){t[T>>2]=0;while(1){if((t[T>>2]|0)>=(t[(t[b>>2]|0)+4>>2]|0))break e;t[v>>2]=t[(t[t[b>>2]>>2]|0)+(t[T>>2]<<2)>>2];if(((t[t[v>>2]>>2]|0)==2001?(t[E>>2]|0)==(t[(t[v>>2]|0)+8>>2]|0):0)?(t[p>>2]|0)==(t[(t[v>>2]|0)+12>>2]|0):0)break;t[T>>2]=(t[T>>2]|0)+1}t[L>>2]=0;d=t[o>>2]|0;w=t[l>>2]|0;mw(d,3086,w,0,164072,uh(L,t[p>>2]|0,t[E>>2]|0)|0,0,0);if(t[L>>2]|0){pAi[t[135736>>2]&511](t[L>>2]|0);t[L>>2]=0}t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}while(0);t[N>>2]=wD(t[o>>2]|0)|0;if(!(t[N>>2]|0)){t[a>>2]=0;D=t[a>>2]|0;s=u;return D|0}t[(t[N>>2]|0)+4>>2]=t[l>>2];t[(t[N>>2]|0)+8>>2]=t[E>>2];t[(t[N>>2]|0)+12>>2]=t[p>>2];if(t[g>>2]|0)qT((t[(t[o>>2]|0)+28>>2]|0)+20|0,10,t[N>>2]|0)|0;t[a>>2]=t[N>>2];D=t[a>>2]|0;s=u;return D|0}function iD(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+36|0;u=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;t[k>>2]=0;t[h>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[b>>2]=Bd(t[o>>2]|0,160064)|0;r=t[u>>2]|0;if(!(t[b>>2]|0)){FT(r,3036,0,t[o>>2]|0,160064,0);t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}xT(r,t[a>>2]|0,0,t[b>>2]|0,k,h)|0;if(UT(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[b>>2]|0,t[k>>2]|0)|0){t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}t[b>>2]=t[(t[o>>2]|0)+44>>2];while(1){if(!(t[b>>2]|0))break;a=t[b>>2]|0;if(!(t[(t[b>>2]|0)+36>>2]|0)){if((Xl(t[a+8>>2]|0,160064)|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,161384)|0)==0:0)_T(t[u>>2]|0,3035,0,t[b>>2]|0)}else if(Xl(t[(t[a+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[u>>2]|0,3035,0,t[b>>2]|0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){jd(t[u>>2]|0,t[l>>2]|0,0)|0;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if(t[l>>2]|0)$d(t[u>>2]|0,3033,0,t[o>>2]|0,t[l>>2]|0,0,161392);do if(((((t[(t[u>>2]|0)+100>>2]|0)!=0?(t[(t[u>>2]|0)+120>>2]|0)!=0:0)?(t[t[(t[(t[u>>2]|0)+120>>2]|0)+4>>2]>>2]|0)==16:0)?(t[h>>2]|0)==(t[(t[(t[u>>2]|0)+120>>2]|0)+16>>2]|0):0)?(t[k>>2]|0)==(t[(t[(t[u>>2]|0)+120>>2]|0)+20>>2]|0):0)if(t[(t[u>>2]|0)+124>>2]|0){t[w>>2]=0;l=t[u>>2]|0;b=t[o>>2]|0;th(l,3081,b,0,163408,uh(w,t[k>>2]|0,t[h>>2]|0)|0,0);if(t[w>>2]|0){pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=0}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}else{b=(t[u>>2]|0)+124|0;t[b>>2]=(t[b>>2]|0)+1;t[c>>2]=VT(t[u>>2]|0,16,t[h>>2]|0,t[k>>2]|0)|0;if(t[c>>2]|0){t[(t[c>>2]|0)+20>>2]=t[o>>2];t[(t[(t[u>>2]|0)+120>>2]|0)+8>>2]=t[c>>2];break}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}else v=35;while(0);do if((v|0)==35){t[c>>2]=VT(t[u>>2]|0,16,t[h>>2]|0,t[k>>2]|0)|0;if(t[c>>2]|0){t[(t[c>>2]|0)+20>>2]=t[o>>2];qT((t[(t[u>>2]|0)+28>>2]|0)+20|0,10,t[c>>2]|0)|0;break}t[f>>2]=0;d=t[f>>2]|0;s=n;return d|0}while(0);t[f>>2]=t[c>>2];d=t[f>>2]|0;s=n;return d|0}function rD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;f=s;s=s+64|0;a=f+56|0;o=f+52|0;c=f+44|0;l=f+40|0;b=f+36|0;k=f+32|0;h=f+28|0;w=f+24|0;d=f+20|0;v=f+16|0;m=f+12|0;_=f+8|0;p=f+4|0;E=f;t[o>>2]=e;t[f+48>>2]=i;t[c>>2]=r;t[l>>2]=n;t[w>>2]=0;t[m>>2]=0;t[b>>2]=Sw(t[o>>2]|0,t[l>>2]|0,162320)|0;do if((t[b>>2]|0)!=0?(Xl(t[b>>2]|0,148184)|0)==0:0){if(Xl(t[b>>2]|0,148168)|0){t[(t[c>>2]|0)+24>>2]=1;break}if(Xl(t[b>>2]|0,148176)|0){t[(t[c>>2]|0)+24>>2]=2;break}else{Ud(t[o>>2]|0,3037,0,t[l>>2]|0,0,162336,t[b>>2]|0,0,0,0);t[(t[c>>2]|0)+24>>2]=3;t[w>>2]=3037;break}}else S=3;while(0);if((S|0)==3)t[(t[c>>2]|0)+24>>2]=3;t[_>>2]=Bd(t[l>>2]|0,162304)|0;t[k>>2]=Hd(t[o>>2]|0,t[_>>2]|0)|0;e:do if((t[_>>2]|0)!=0?(Xl(t[k>>2]|0,162360)|0)==0:0){if(Xl(t[k>>2]|0,144400)|0){l=aD(t[o>>2]|0)|0;t[(t[c>>2]|0)+36>>2]=l;if(t[(t[c>>2]|0)+36>>2]|0){t[(t[(t[c>>2]|0)+36>>2]|0)+4>>2]=t[(t[o>>2]|0)+112>>2];break}t[a>>2]=-1;g=t[a>>2]|0;s=f;return g|0}t[E>>2]=t[k>>2];while(1){do if((u[t[E>>2]>>0]|0|0)==32)y=1;else{if(9<=(u[t[E>>2]>>0]|0|0)?(u[t[E>>2]>>0]|0|0)<=10:0){y=1;break}y=(u[t[E>>2]>>0]|0|0)==13}while(0);l=t[E>>2]|0;if(y){t[E>>2]=l+1;continue}t[p>>2]=l;while(1){if(u[t[p>>2]>>0]|0){do if((u[t[p>>2]>>0]|0|0)==32)F=1;else{if(9<=(u[t[p>>2]>>0]|0|0)?(u[t[p>>2]>>0]|0|0)<=10:0){F=1;break}F=(u[t[p>>2]>>0]|0|0)==13}while(0);O=F^1}else O=0;A=t[p>>2]|0;if(!O)break;t[p>>2]=A+1}if((A|0)==(t[E>>2]|0))break e;t[d>>2]=ql(t[E>>2]|0,(t[p>>2]|0)-(t[E>>2]|0)|0)|0;if((Xl(t[d>>2]|0,144400)|0)==0?(Xl(t[d>>2]|0,162360)|0)==0:0){do if(!(Xl(t[d>>2]|0,162448)|0))if(Xl(t[d>>2]|0,162472)|0){t[h>>2]=0;break}else{l=t[o>>2]|0;b=t[_>>2]|0;n=t[d>>2]|0;dT(l,0,b,n,ED(29)|0)|0;t[h>>2]=kz(t[(t[o>>2]|0)+80>>2]|0,t[d>>2]|0,-1)|0;break}else t[h>>2]=t[(t[o>>2]|0)+112>>2];while(0);t[v>>2]=t[(t[c>>2]|0)+32>>2];while(1){if(!(t[v>>2]|0))break;if((t[h>>2]|0)==(t[(t[v>>2]|0)+4>>2]|0))break;t[v>>2]=t[t[v>>2]>>2]}if(!(t[v>>2]|0)){t[v>>2]=aD(t[o>>2]|0)|0;if(!(t[v>>2]|0))break;t[(t[v>>2]|0)+4>>2]=t[h>>2];t[t[v>>2]>>2]=0;if(t[(t[c>>2]|0)+32>>2]|0){if(t[m>>2]|0)t[t[m>>2]>>2]=t[v>>2]}else t[(t[c>>2]|0)+32>>2]=t[v>>2];t[m>>2]=t[v>>2]}}else{Ud(t[o>>2]|0,1792,0,t[_>>2]|0,0,162368,t[d>>2]|0,0,0,0);t[w>>2]=1792}pAi[t[135736>>2]&511](t[d>>2]|0);t[E>>2]=t[p>>2];if(!(u[t[E>>2]>>0]|0))break e}pAi[t[135736>>2]&511](t[d>>2]|0);t[a>>2]=-1;g=t[a>>2]|0;s=f;return g|0}else S=11;while(0);if((S|0)==11)t[(t[c>>2]|0)+28>>2]=1;t[a>>2]=t[w>>2];g=t[a>>2]|0;s=f;return g|0}function nD(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[c>>2]=gk()|0;if(!(t[c>>2]|0)){Qh(t[u>>2]|0,166944,t[o>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[(t[c>>2]|0)+20>>2]=t[o>>2];t[b>>2]=Sw(t[u>>2]|0,t[o>>2]|0,166968)|0;if(!(t[b>>2]|0)){QT(t[u>>2]|0,t[o>>2]|0,t[l>>2]|0,1708,166976,t[(t[o>>2]|0)+8>>2]|0,0);Fk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157848)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0)t[t[c>>2]>>2]=1e3;else w=12;do if((w|0)==12){if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157832)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1001;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157816)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1002;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157800)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1003;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157936)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1004;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157952)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1005;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157792)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1006;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157880)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1007;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157864)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1008;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157896)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1009;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157904)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1010;break}if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,157920)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){t[t[c>>2]>>2]=1011;break}QT(t[u>>2]|0,t[o>>2]|0,t[l>>2]|0,1741,167e3,t[(t[o>>2]|0)+8>>2]|0,0);Fk(t[c>>2]|0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}while(0);Pd(t[u>>2]|0,t[o>>2]|0,161384)|0;t[(t[c>>2]|0)+8>>2]=t[b>>2];if((((t[t[c>>2]>>2]|0)!=1006?(t[t[c>>2]>>2]|0)!=1007:0)?(t[k>>2]=Sw(t[u>>2]|0,t[o>>2]|0,159120)|0,(t[k>>2]|0)!=0):0)?(Xl(t[k>>2]|0,165504)|0)!=0:0)t[(t[c>>2]|0)+24>>2]=1;t[l>>2]=t[(t[o>>2]|0)+12>>2];if((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){k=jd(t[u>>2]|0,t[l>>2]|0,1)|0;t[(t[c>>2]|0)+16>>2]=k;t[l>>2]=t[(t[l>>2]|0)+24>>2]}if(t[l>>2]|0)QT(t[u>>2]|0,t[o>>2]|0,t[l>>2]|0,1740,167024,t[(t[o>>2]|0)+8>>2]|0,0);t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}function fD(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;o=s;s=s+48|0;c=o+44|0;l=o+40|0;b=o+36|0;k=o+32|0;h=o+28|0;w=o+24|0;d=o+20|0;v=o+16|0;m=o+12|0;_=o+8|0;p=o+4|0;E=o;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[t[d>>2]>>2]=0;t[t[v>>2]>>2]=0;t[E>>2]=qg(t[w>>2]|0,1)|0;if((t[E>>2]|0)>0){a=t[l>>2]|0;u=t[k>>2]|0;f=t[h>>2]|0;n=ED(21)|0;Ud(a,3037,u,f,n,0,t[w>>2]|0,0,0,0);t[t[v>>2]>>2]=t[w>>2];t[c>>2]=t[(t[l>>2]|0)+16>>2];S=t[c>>2]|0;s=o;return S|0}if((t[E>>2]|0)<0){t[c>>2]=-1;S=t[c>>2]|0;s=o;return S|0}if(Yq(t[w>>2]|0,58)|0){E=jg(t[w>>2]|0,p)|0;t[t[v>>2]>>2]=E;E=kz(t[(t[l>>2]|0)+80>>2]|0,t[t[v>>2]>>2]|0,-1)|0;t[t[v>>2]>>2]=E;t[m>>2]=kz(t[(t[l>>2]|0)+80>>2]|0,t[w>>2]|0,t[p>>2]|0)|0;t[_>>2]=wF(t[(t[h>>2]|0)+32>>2]|0,t[(t[h>>2]|0)+20>>2]|0,t[m>>2]|0)|0;m=t[l>>2]|0;if(!(t[_>>2]|0)){p=t[k>>2]|0;k=t[h>>2]|0;E=ED(21)|0;Ud(m,3037,p,k,E,0,t[w>>2]|0,162952,t[w>>2]|0,0);t[c>>2]=t[(t[l>>2]|0)+16>>2];S=t[c>>2]|0;s=o;return S|0}else{E=kz(t[m+80>>2]|0,t[(t[_>>2]|0)+8>>2]|0,-1)|0;t[t[d>>2]>>2]=E;t[c>>2]=0;S=t[c>>2]|0;s=o;return S|0}}t[_>>2]=wF(t[(t[h>>2]|0)+32>>2]|0,t[(t[h>>2]|0)+20>>2]|0,0)|0;if(!(t[_>>2]|0)){if(t[(t[b>>2]|0)+24>>2]&512)t[t[d>>2]>>2]=t[(t[l>>2]|0)+112>>2]}else{b=kz(t[(t[l>>2]|0)+80>>2]|0,t[(t[_>>2]|0)+8>>2]|0,-1)|0;t[t[d>>2]>>2]=b}b=kz(t[(t[l>>2]|0)+80>>2]|0,t[w>>2]|0,-1)|0;t[t[v>>2]>>2]=b;t[c>>2]=0;S=t[c>>2]|0;s=o;return S|0}function tD(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;a=s;s=s+32|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;if((t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[b>>2]|0)==0){t[o>>2]=0;v=t[o>>2]|0;s=a;return v|0}t[d>>2]=gAi[t[135744>>2]&511](40)|0;if(!(t[d>>2]|0)){Qh(t[c>>2]|0,165384,0);t[o>>2]=0;v=t[o>>2]|0;s=a;return v|0}l=(t[d>>2]|0)+0|0;u=l+40|0;do{t[l>>2]=0;l=l+4|0}while((l|0)<(u|0));t[(t[d>>2]|0)+20>>2]=t[k>>2];t[(t[d>>2]|0)+16>>2]=t[b>>2];t[t[d>>2]>>2]=t[h>>2];t[(t[d>>2]|0)+12>>2]=t[w>>2];qT((t[(t[(t[c>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,t[d>>2]|0)|0;if((t[h>>2]|0)==24)qT((t[(t[c>>2]|0)+28>>2]|0)+20|0,10,t[d>>2]|0)|0;t[o>>2]=t[d>>2];v=t[o>>2]|0;s=a;return v|0}function uD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[k>>2]=0;t[h>>2]=t[(t[c>>2]|0)+44>>2];while(1){if(!(t[h>>2]|0))break;n=t[h>>2]|0;if(!(t[(t[h>>2]|0)+36>>2]|0)){if((Xl(t[n+8>>2]|0,161384)|0)==0?(Xl(t[(t[h>>2]|0)+8>>2]|0,164904)|0)==0:0)_T(t[a>>2]|0,3035,0,t[h>>2]|0)}else if(Xl(t[(t[n+36>>2]|0)+8>>2]|0,t[38526]|0)|0)_T(t[a>>2]|0,3035,0,t[h>>2]|0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}t[b>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[b>>2]|0)){Qh(t[a>>2]|0,164912,0);t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}n=t[b>>2]|0;t[n+0>>2]=0;t[n+4>>2]=0;t[n+8>>2]=0;t[n+12>>2]=0;t[n+16>>2]=0;t[h>>2]=Bd(t[c>>2]|0,164904)|0;n=t[a>>2]|0;if(t[h>>2]|0){r=Hd(n,t[h>>2]|0)|0;t[(t[b>>2]|0)+12>>2]=r;if((dD(t[a>>2]|0,t[o>>2]|0,t[b>>2]|0,t[h>>2]|0,t[l>>2]|0)|0)==-1)pw(t[a>>2]|0,t[h>>2]|0,3069,164976,0,0)}else FT(n,3036,0,t[c>>2]|0,161352,0);Pd(t[a>>2]|0,t[c>>2]|0,161384)|0;t[k>>2]=t[(t[c>>2]|0)+12>>2];if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[38526]|0)|0)!=0:0){n=t[o>>2]|0;JL(n,jd(t[a>>2]|0,t[k>>2]|0,1)|0)|0;t[k>>2]=t[(t[k>>2]|0)+24>>2]}if(t[k>>2]|0)$d(t[a>>2]|0,3033,0,t[c>>2]|0,t[k>>2]|0,0,161392);t[u>>2]=t[b>>2];w=t[u>>2]|0;s=f;return w|0}function aD(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[f>>2]|0)){Qh(t[n>>2]|0,152760,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[(t[f>>2]|0)+4>>2]=0;t[t[f>>2]>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function oD(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;if((t[(t[n>>2]|0)+12>>2]|0)!=0?(t[(t[n>>2]|0)+16>>2]|0)!=0:0){if((t[t[(t[n>>2]|0)+12>>2]>>2]|0)!=7){t[o>>2]=0;t[c>>2]=t[(t[(t[n>>2]|0)+12>>2]|0)+12>>2];if(!(t[c>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}do{if((t[t[(t[c>>2]|0)+12>>2]>>2]|0)!=14?(t[t[(t[c>>2]|0)+12>>2]>>2]|0)!=2:0){e=oD(t[c>>2]|0)|0;t[o>>2]=(t[o>>2]|0)+e}else t[o>>2]=(t[o>>2]|0)+(t[(t[c>>2]|0)+16>>2]|0);t[c>>2]=t[(t[c>>2]|0)+8>>2]}while((t[c>>2]|0)!=0);t[r>>2]=te(t[(t[n>>2]|0)+16>>2]|0,t[o>>2]|0)|0;l=t[r>>2]|0;s=i;return l|0}t[f>>2]=-1;t[a>>2]=t[(t[(t[n>>2]|0)+12>>2]|0)+12>>2];if(!(t[a>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}while(1){if(!(t[a>>2]|0)){b=17;break}if((t[t[(t[a>>2]|0)+12>>2]>>2]|0)!=14?(t[t[(t[a>>2]|0)+12>>2]>>2]|0)!=2:0)t[u>>2]=oD(t[a>>2]|0)|0;else t[u>>2]=t[(t[a>>2]|0)+16>>2];if(!(t[u>>2]|0)){b=13;break}if((t[f>>2]|0)==-1?1:(t[f>>2]|0)>(t[u>>2]|0))t[f>>2]=t[u>>2];t[a>>2]=t[(t[a>>2]|0)+8>>2]}if((b|0)==13){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}else if((b|0)==17){t[r>>2]=te(t[(t[n>>2]|0)+16>>2]|0,t[f>>2]|0)|0;l=t[r>>2]|0;s=i;return l|0}}t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}function cD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=vD(t[o>>2]|0,t[c>>2]|0)|0;if(t[b>>2]|0){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if(!((t[l>>2]&2|0)!=0?(t[(t[o>>2]|0)+48>>2]&2|0)!=0:0))h=4;do if((h|0)==4){if((t[l>>2]&1|0)!=0?(t[(t[o>>2]|0)+48>>2]&4|0)!=0:0)break;if((t[(t[o>>2]|0)+64>>2]|0)==(t[c>>2]|0)){t[u>>2]=0;k=t[u>>2]|0;s=f;return k|0}if((t[t[(t[o>>2]|0)+64>>2]>>2]|0)==1?(t[(t[(t[o>>2]|0)+64>>2]|0)+88>>2]|0)==45:0){t[u>>2]=1;k=t[u>>2]|0;s=f;return k|0}if((t[t[(t[o>>2]|0)+64>>2]>>2]|0)!=5?(t[(t[(t[o>>2]|0)+64>>2]|0)+88>>2]|0)!=45:0){t[u>>2]=lL(t[a>>2]|0,t[(t[o>>2]|0)+64>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;k=t[u>>2]|0;s=f;return k|0}t[u>>2]=cD(t[a>>2]|0,t[(t[o>>2]|0)+64>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;k=t[u>>2]|0;s=f;return k|0}while(0);t[u>>2]=1;k=t[u>>2]|0;s=f;return k|0}function lD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!(t[(t[(t[f>>2]|0)+28>>2]|0)+24>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=fO(t[(t[(t[f>>2]|0)+28>>2]|0)+24>>2]|0,t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+52>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}return 0}function sD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[(t[f>>2]|0)+28>>2]|0)+24>>2]|0)==0?(i=KF(10,t[(t[f>>2]|0)+80>>2]|0)|0,t[(t[(t[f>>2]|0)+28>>2]|0)+24>>2]=i,(t[(t[(t[f>>2]|0)+28>>2]|0)+24>>2]|0)==0):0){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](8)|0;if(!(t[a>>2]|0)){Qh(0,158408,0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=t[a>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[t[a>>2]>>2]=t[u>>2];i=hh()|0;t[(t[a>>2]|0)+4>>2]=i;if(!(t[(t[a>>2]|0)+4>>2]|0)){$h(t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}if(QF(t[(t[(t[f>>2]|0)+28>>2]|0)+24>>2]|0,t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+52>>2]|0,t[a>>2]|0)|0){rh(t[f>>2]|0,158456,158480);$h(t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function bD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;if((t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}t[t[c>>2]>>2]=0;t[t[l>>2]>>2]=0;t[b>>2]=qg(t[o>>2]|0,1)|0;if((t[b>>2]|0)==-1){t[u>>2]=-1;w=t[u>>2]|0;s=f;return w|0}if((t[b>>2]|0)>0){b=t[a>>2]|0;n=t[o>>2]|0;ow(b,1824,0,n,ED(21)|0,1);t[u>>2]=1;w=t[u>>2]|0;s=f;return w|0}t[k>>2]=0;t[k>>2]=zg(t[o>>2]|0,h)|0;n=t[(t[a>>2]|0)+156>>2]|0;if(!(t[k>>2]|0)){b=kz(n,t[o>>2]|0,-1)|0;t[t[l>>2]>>2]=b}else{b=kz(n,t[k>>2]|0,-1)|0;t[t[l>>2]>>2]=b;pAi[t[135736>>2]&511](t[k>>2]|0)}k=Sd(t[a>>2]|0,t[h>>2]|0)|0;t[t[c>>2]>>2]=k;if((t[h>>2]|0)!=0?(pAi[t[135736>>2]&511](t[h>>2]|0),(t[t[c>>2]>>2]|0)==0):0){c=t[a>>2]|0;a=ED(21)|0;th(c,1824,0,a,154112,t[o>>2]|0,0);t[u>>2]=2;w=t[u>>2]|0;s=f;return w|0}t[u>>2]=0;w=t[u>>2]|0;s=f;return w|0}function kD(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(t[o>>2]|0){r=t[u>>2]|0;i=t[o>>2]|0;if(t[(t[o>>2]|0)+36>>2]|0){t[f>>2]=uh(r,t[(t[i+36>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+8>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=uh(r,0,t[i+8>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}}else if(t[a>>2]|0){t[f>>2]=uh(t[u>>2]|0,t[(t[a>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+12>>2]|0)|0;c=t[f>>2]|0;s=n;return c|0}else{t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}return 0}function hD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[a>>2]|0)){Qh(t[f>>2]|0,164272,0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{i=(t[a>>2]|0)+0|0;e=i+36|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[t[a>>2]>>2]=26;t[(t[a>>2]|0)+20>>2]=t[u>>2];qT((t[(t[(t[f>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,t[a>>2]|0)|0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function wD(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[f>>2]|0)){Qh(t[n>>2]|0,164232,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[t[f>>2]>>2]=2001;qT((t[(t[(t[n>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,t[f>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function dD(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;u=s;s=s+48|0;a=u+40|0;o=u+36|0;c=u+32|0;l=u+28|0;b=u+24|0;k=u+20|0;h=u+16|0;w=u+12|0;d=u+8|0;v=u+4|0;m=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(!(t[l>>2]|0)){pw(t[o>>2]|0,t[(t[c>>2]|0)+12>>2]|0,3069,165168,0,0);t[a>>2]=-1;_=t[a>>2]|0;s=u;return _|0}if(!(t[b>>2]|0))t[h>>2]=t[(t[c>>2]|0)+12>>2];else t[h>>2]=t[b>>2];if(!(t[(t[l>>2]|0)+12>>2]|0)){sv(t[o>>2]|0,3037,0,t[h>>2]|0,165248,0);t[a>>2]=3037;_=t[a>>2]|0;s=u;return _|0}t[w>>2]=0;t[d>>2]=0;if(!(t[b>>2]|0))t[d>>2]=0;else t[d>>2]=hF(t[(t[b>>2]|0)+32>>2]|0,t[(t[b>>2]|0)+20>>2]|0)|0;if(t[d>>2]|0){t[m>>2]=0;t[v>>2]=0;while(1){if(!(t[(t[d>>2]|0)+(t[v>>2]<<2)>>2]|0))break;t[m>>2]=(t[m>>2]|0)+1;t[v>>2]=(t[v>>2]|0)+1}t[w>>2]=gAi[t[135744>>2]&511]((t[m>>2]<<1)+1<<2)|0;if(!(t[w>>2]|0)){Qh(t[o>>2]|0,165304,0);pAi[t[135736>>2]&511](t[d>>2]|0);t[a>>2]=-1;_=t[a>>2]|0;s=u;return _|0}t[v>>2]=0;while(1){if((t[v>>2]|0)>=(t[m>>2]|0))break;t[(t[w>>2]|0)+(t[v>>2]<<1<<2)>>2]=t[(t[(t[d>>2]|0)+(t[v>>2]<<2)>>2]|0)+8>>2];t[(t[w>>2]|0)+((t[v>>2]<<1)+1<<2)>>2]=t[(t[(t[d>>2]|0)+(t[v>>2]<<2)>>2]|0)+12>>2];t[v>>2]=(t[v>>2]|0)+1}t[(t[w>>2]|0)+(t[m>>2]<<1<<2)>>2]=0;pAi[t[135736>>2]&511](t[d>>2]|0)}d=t[(t[l>>2]|0)+12>>2]|0;m=t[w>>2]|0;if(t[k>>2]|0){k=Fj(d,0,4,m)|0;t[(t[l>>2]|0)+16>>2]=k}else{k=Fj(d,0,2,m)|0;t[(t[l>>2]|0)+16>>2]=k}if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);if(!(t[(t[l>>2]|0)+16>>2]|0)){sv(t[o>>2]|0,3037,0,t[h>>2]|0,165336,t[(t[l>>2]|0)+12>>2]|0);t[a>>2]=3037;_=t[a>>2]|0;s=u;return _|0}else{t[a>>2]=0;_=t[a>>2]|0;s=u;return _|0}return 0}function vD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=(t[f>>2]|0)==(t[u>>2]|0)&1;a=t[n>>2]|0;s=r;return a|0}return 0}function mD(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+8|0;r=e+4|0;n=e;if(t[42590]|0){s=e;return}t[42592]=WF(40)|0;t[42596]=YD(170376,45,0)|0;t[(t[42596]|0)+64>>2]=t[42596];t[(t[42596]|0)+52>>2]=3;t[(t[42596]|0)+52>>2]=3;t[i>>2]=GD()|0;if(!(t[i>>2]|0)){s=e;return}t[(t[42596]|0)+28>>2]=t[i>>2];t[r>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[r>>2]|0)){WD(0,170392);s=e;return}f=t[r>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[f+12>>2]=0;t[f+16>>2]=0;t[t[r>>2]>>2]=6;t[(t[i>>2]|0)+12>>2]=t[r>>2];t[i>>2]=GD()|0;if(!(t[i>>2]|0)){s=e;return}t[(t[i>>2]|0)+16>>2]=0;t[(t[i>>2]|0)+20>>2]=1073741824;t[(t[r>>2]|0)+12>>2]=t[i>>2];t[n>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[n>>2]|0)){WD(0,170432);s=e;return}r=(t[n>>2]|0)+0|0;f=r+44|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(f|0));t[t[n>>2]>>2]=2;t[(t[n>>2]|0)+28>>2]=1;t[(t[n>>2]|0)+24>>2]=2;t[(t[i>>2]|0)+12>>2]=t[n>>2];t[n>>2]=gAi[t[135744>>2]&511](44)|0;if(!(t[n>>2]|0)){WD(0,170464);s=e;return}else{r=(t[n>>2]|0)+0|0;f=r+44|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(f|0));t[(t[n>>2]|0)+28>>2]=1;t[(t[n>>2]|0)+24>>2]=2;t[(t[42596]|0)+84>>2]=t[n>>2];t[42634]=YD(170520,46,t[42596]|0)|0;t[42638]=YD(170544,1,t[42634]|0)|0;t[42642]=YD(170560,3,t[42634]|0)|0;t[42646]=YD(170576,10,t[42634]|0)|0;t[42652]=YD(170592,11,t[42634]|0)|0;t[42656]=YD(170616,4,t[42634]|0)|0;t[42660]=YD(170632,8,t[42634]|0)|0;t[42666]=YD(170648,9,t[42634]|0)|0;t[42670]=YD(170672,6,t[42634]|0)|0;t[42676]=YD(170688,7,t[42634]|0)|0;t[42680]=YD(170712,5,t[42634]|0)|0;t[42686]=YD(170728,12,t[42634]|0)|0;t[42690]=YD(170752,13,t[42634]|0)|0;t[42694]=YD(170768,14,t[42634]|0)|0;t[42698]=YD(170784,15,t[42634]|0)|0;t[42702]=YD(170800,29,t[42634]|0)|0;t[42708]=YD(170816,43,t[42634]|0)|0;t[42714]=YD(170840,44,t[42634]|0)|0;t[42720]=YD(170864,28,t[42634]|0)|0;t[42724]=YD(170888,21,t[42634]|0)|0;t[42728]=YD(170904,30,t[42642]|0)|0;t[42736]=YD(170920,31,t[42728]|0)|0;t[42742]=YD(170952,32,t[42736]|0)|0;t[42746]=YD(170976,37,t[42728]|0)|0;t[42750]=YD(170992,35,t[42746]|0)|0;t[42754]=YD(171008,39,t[42750]|0)|0;t[42758]=YD(171024,41,t[42754]|0)|0;t[42766]=YD(171040,33,t[42728]|0)|0;t[42772]=YD(171072,38,t[42766]|0)|0;t[42778]=YD(171096,36,t[42772]|0)|0;t[42784]=YD(171120,40,t[42778]|0)|0;t[42790]=YD(171144,42,t[42784]|0)|0;t[42796]=YD(171168,34,t[42766]|0)|0;t[42804]=YD(171192,2,t[42638]|0)|0;t[42808]=YD(171224,16,t[42804]|0)|0;t[42814]=YD(171240,17,t[42808]|0)|0;t[42818]=YD(171264,20,t[42808]|0)|0;t[42822]=YD(171280,18,t[42808]|0)|0;t[42826]=YD(171296,22,t[42818]|0)|0;t[42830]=YD(171312,23,t[42826]|0)|0;t[42834]=YD(171328,24,t[42826]|0)|0;t[42838]=YD(171344,26,t[42826]|0)|0;t[42844]=YD(171360,27,t[42634]|0)|0;t[(t[42844]|0)+28>>2]=t[42838];t[42848]=YD(171384,25,t[42634]|0)|0;t[(t[42848]|0)+28>>2]=t[42834];t[42854]=YD(171400,19,t[42634]|0)|0;t[(t[42854]|0)+28>>2]=t[42822];t[42590]=1;s=e;return}}function _D(){var e=0,i=0;e=s;s=s+16|0;i=e;if(!(t[42590]|0)){s=e;return}yk(t[(t[42596]|0)+84>>2]|0);t[i>>2]=t[(t[42596]|0)+28>>2];yk(t[(t[(t[(t[i>>2]|0)+12>>2]|0)+12>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[(t[(t[i>>2]|0)+12>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[(t[i>>2]|0)+12>>2]|0);pAi[t[135736>>2]&511](t[i>>2]|0);t[(t[42596]|0)+28>>2]=0;XF(t[42592]|0,360);t[42590]=0;s=e;return}function pD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;e:do if(!(t[f>>2]|0))t[n>>2]=-1;else{if((t[t[f>>2]>>2]|0)!=1){t[n>>2]=-1;break}switch(t[(t[f>>2]|0)+88>>2]|0){case 15:{if((t[u>>2]|0)==1006|(t[u>>2]|0)==1008){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 3:{if((t[u>>2]|0)==1004|(t[u>>2]|0)==1005|(t[u>>2]|0)==1006|(t[u>>2]|0)==1008|(t[u>>2]|0)==1007|(t[u>>2]|0)==1002|(t[u>>2]|0)==1003|(t[u>>2]|0)==1e3|(t[u>>2]|0)==1001){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 14:case 13:case 12:case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{if((t[u>>2]|0)==1006|(t[u>>2]|0)==1007|(t[u>>2]|0)==1008|(t[u>>2]|0)==1002|(t[u>>2]|0)==1003|(t[u>>2]|0)==1e3|(t[u>>2]|0)==1001){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}case 43:case 44:case 29:case 21:case 28:case 1:{if((t[u>>2]|0)==1009|(t[u>>2]|0)==1011|(t[u>>2]|0)==1010|(t[u>>2]|0)==1006|(t[u>>2]|0)==1007|(t[u>>2]|0)==1008){t[n>>2]=1;break e}else{t[n>>2]=0;break e}break}default:{t[n>>2]=0;break e}}}while(0);s=r;return t[n>>2]|0}function ED(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[42590]|0))mD();do switch(t[n>>2]|0){case 46:{t[r>>2]=t[42634];break}case 38:{t[r>>2]=t[42772];break}case 23:{t[r>>2]=t[42830];break}case 22:{t[r>>2]=t[42826];break}case 3:{t[r>>2]=t[42642];break}case 34:{t[r>>2]=t[42796];break}case 36:{t[r>>2]=t[42778];break}case 16:{t[r>>2]=t[42808];break}case 37:{t[r>>2]=t[42746];break}case 44:{t[r>>2]=t[42714];break}case 26:{t[r>>2]=t[42838];break}case 29:{t[r>>2]=t[42702];break}case 32:{t[r>>2]=t[42742];break}case 15:{t[r>>2]=t[42698];break}case 10:{t[r>>2]=t[42646];break}case 18:{t[r>>2]=t[42822];break}case 8:{t[r>>2]=t[42660];break}case 5:{t[r>>2]=t[42680];break}case 12:{t[r>>2]=t[42686];break}case 24:{t[r>>2]=t[42834];break}case 11:{t[r>>2]=t[42652];break}case 30:{t[r>>2]=t[42728];break}case 1:{t[r>>2]=t[42638];break}case 17:{t[r>>2]=t[42814];break}case 21:{t[r>>2]=t[42724];break}case 28:{t[r>>2]=t[42720];break}case 35:{t[r>>2]=t[42750];break}case 2:{t[r>>2]=t[42804];break}case 6:{t[r>>2]=t[42670];break}case 27:{t[r>>2]=t[42844];break}case 39:{t[r>>2]=t[42754];break}case 33:{t[r>>2]=t[42766];break}case 42:{t[r>>2]=t[42790];break}case 4:{t[r>>2]=t[42656];break}case 41:{t[r>>2]=t[42758];break}case 9:{t[r>>2]=t[42666];break}case 31:{t[r>>2]=t[42736];break}case 45:{t[r>>2]=t[42596];break}case 40:{t[r>>2]=t[42784];break}case 43:{t[r>>2]=t[42708];break}case 19:{t[r>>2]=t[42854];break}case 7:{t[r>>2]=t[42676];break}case 13:{t[r>>2]=t[42690];break}case 20:{t[r>>2]=t[42818];break}case 25:{t[r>>2]=t[42848];break}case 14:{t[r>>2]=t[42694];break}default:t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function SD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{t[(t[f>>2]|0)+4>>2]=t[u>>2];t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}return 0}function gD(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0))t[r>>2]=0;else t[r>>2]=t[(t[n>>2]|0)+4>>2];s=i;return t[r>>2]|0}function yD(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e:do if(!(t[n>>2]|0))t[r>>2]=0;else switch(t[t[n>>2]>>2]|0){case 29:case 26:case 24:case 23:case 22:case 20:case 18:case 17:case 16:case 46:case 2:case 1:{t[r>>2]=t[(t[n>>2]|0)+8>>2];break e;break}default:{t[r>>2]=0;break e}}while(0);s=i;return t[r>>2]|0}function FD(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[t[n>>2]>>2]|0)==15:0){t[r>>2]=t[(t[n>>2]|0)+8>>2];f=t[r>>2]|0;s=i;return f|0}t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}function OD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=KD(28)|0;if(!(t[a>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[(t[a>>2]|0)+8>>2]=t[f>>2];if(t[u>>2]|0)t[(t[a>>2]|0)+12>>2]=t[u>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function AD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=KD(21)|0;if(!(t[a>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[(t[a>>2]|0)+8>>2]=t[u>>2];t[(t[a>>2]|0)+12>>2]=t[f>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function MD(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;switch(t[t[r>>2]>>2]|0){case 46:case 29:case 27:case 26:case 25:case 24:case 23:case 22:case 20:case 19:case 18:case 17:case 16:case 2:case 1:{if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);break}case 21:case 28:{if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);break}case 44:{if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);break}case 43:{if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);break}default:{}}t[n>>2]=t[r>>2];t[r>>2]=t[(t[r>>2]|0)+4>>2];pAi[t[135736>>2]&511](t[n>>2]|0)}s=i;return}function RD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!(t[42590]|0))mD();if(!(t[f>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}else{t[n>>2]=fO(t[42592]|0,t[f>>2]|0,t[u>>2]|0)|0;a=t[n>>2]|0;s=r;return a|0}return 0}function ND(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[f>>2]=e;t[a>>2]=t[f>>2];t[o>>2]=0;if(!(t[f>>2]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}while(1){if(((u[t[a>>2]>>0]|0|0)!=0?(u[t[a>>2]>>0]|0|0)!=13:0)?(u[t[a>>2]>>0]|0|0)!=9:0)b=(u[t[a>>2]>>0]|0|0)!=10;else b=0;k=t[a>>2]|0;if(!b)break;t[a>>2]=k+1}if(!(u[k>>0]|0)){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}t[o>>2]=Yl(t[f>>2]|0)|0;t[c>>2]=(t[o>>2]|0)+((t[a>>2]|0)-(t[f>>2]|0));do{if(!(((u[t[c>>2]>>0]|0|0)!=13?(u[t[c>>2]>>0]|0|0)!=9:0)?(u[t[c>>2]>>0]|0|0)!=10:0))n[t[c>>2]>>0]=32;t[c>>2]=(t[c>>2]|0)+1}while((u[t[c>>2]>>0]|0|0)!=0);t[r>>2]=t[o>>2];l=t[r>>2]|0;s=i;return l|0}function TD(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;i=s;s=s+32|0;r=i+24|0;f=i+20|0;a=i+16|0;o=i+12|0;c=i+8|0;l=i+4|0;b=i;t[f>>2]=e;t[a>>2]=t[f>>2];t[b>>2]=0;if(!(t[f>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}while(1){do if(u[t[a>>2]>>0]|0)if((u[t[a>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[a>>2]>>0]|0|0)==13}else h=0;while(0);w=t[a>>2]|0;if(!h)break;t[a>>2]=w+1}t[o>>2]=w;while(1){if(!(u[t[o>>2]>>0]|0))break;if((u[t[o>>2]>>0]|0|0)==32){if((u[(t[o>>2]|0)+1>>0]|0|0)==32){d=17;break}if(9<=(u[(t[o>>2]|0)+1>>0]|0|0)?(u[(t[o>>2]|0)+1>>0]|0|0)<=10:0){d=17;break}if((u[(t[o>>2]|0)+1>>0]|0|0)==13){d=17;break}}if((u[t[o>>2]>>0]|0|0)==10){d=21;break}if((u[t[o>>2]>>0]|0|0)==9){d=21;break}if((u[t[o>>2]>>0]|0|0)==13){d=21;break}t[o>>2]=(t[o>>2]|0)+1;
	}if((d|0)==17)t[b>>2]=(t[o>>2]|0)-(t[a>>2]|0);else if((d|0)==21)t[b>>2]=(t[o>>2]|0)-(t[a>>2]|0);if(!(t[b>>2]|0)){t[c>>2]=t[o>>2];t[o>>2]=(t[o>>2]|0)+-1;while(1){do if((t[o>>2]|0)>>>0>(t[a>>2]|0)>>>0)if((u[t[o>>2]>>0]|0|0)==32)v=1;else{if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0){v=1;break}v=(u[t[o>>2]>>0]|0|0)==13}else v=0;while(0);m=t[o>>2]|0;if(!v)break;t[o>>2]=m+-1}t[o>>2]=m+1;if((t[a>>2]|0)==(t[f>>2]|0)?(t[c>>2]|0)==(t[o>>2]|0):0){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[r>>2]=ql(t[a>>2]|0,(t[o>>2]|0)-(t[a>>2]|0)|0)|0;k=t[r>>2]|0;s=i;return k|0}t[a>>2]=Yl(t[a>>2]|0)|0;if(!(t[a>>2]|0)){t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[l>>2]=(t[a>>2]|0)+(t[b>>2]|0);t[o>>2]=t[l>>2];e:while(1){if(!(u[t[o>>2]>>0]|0))break;do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13){b=t[o>>2]|0;t[o>>2]=b+1;c=n[b>>0]|0;b=t[l>>2]|0;t[l>>2]=b+1;n[b>>0]=c;continue e}}while(0);t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[o>>2]>>0]|0|0)==32)_=1;else{if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0){_=1;break}_=(u[t[o>>2]>>0]|0|0)==13}while(0);p=t[o>>2]|0;if(!_)break;t[o>>2]=p+1}if(!(u[p>>0]|0))continue;c=t[l>>2]|0;t[l>>2]=c+1;n[c>>0]=32}n[t[l>>2]>>0]=0;t[r>>2]=t[a>>2];k=t[r>>2]|0;s=i;return k|0}function LD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=XD(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,0,0,1,1,0)|0;s=f;return n|0}function DD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=XD(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,1,0,1,0,1)|0;s=f;return n|0}function CD(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=LD(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0)|0;s=n;return r|0}function PD(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;t[f>>2]=0;t[u>>2]=0;e:while(1){if(!(t[n>>2]|0)){o=20;break}switch(t[t[n>>2]>>2]|0){case 43:{t[a>>2]=ZD(t[n>>2]|0)|0;if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=e}break}case 29:case 18:case 26:case 24:case 23:case 22:case 20:case 17:case 16:case 2:case 1:case 46:{t[a>>2]=ZD(t[n>>2]|0)|0;if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=e}break}case 19:case 27:case 25:case 45:{o=4;break e;break}case 28:case 21:{t[a>>2]=ZD(t[n>>2]|0)|0;if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=e}if(t[(t[n>>2]|0)+12>>2]|0){e=Yl(t[(t[n>>2]|0)+12>>2]|0)|0;t[(t[a>>2]|0)+12>>2]=e}break}case 44:{t[a>>2]=ZD(t[n>>2]|0)|0;if(t[(t[n>>2]|0)+8>>2]|0){e=Yl(t[(t[n>>2]|0)+8>>2]|0)|0;t[(t[a>>2]|0)+8>>2]=e}break}default:t[a>>2]=ZD(t[n>>2]|0)|0}e=t[a>>2]|0;if(!(t[f>>2]|0))t[f>>2]=e;else t[(t[u>>2]|0)+4>>2]=e;t[u>>2]=t[a>>2];t[n>>2]=t[(t[n>>2]|0)+4>>2]}if((o|0)==4){MD(t[f>>2]|0);t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else if((o|0)==20){t[r>>2]=t[f>>2];c=t[r>>2]|0;s=i;return c|0}return 0}function BD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-2;c=t[n>>2]|0;s=r;return c|0}do if((t[t[f>>2]>>2]|0)!=1)if((t[t[f>>2]>>2]|0)==2){t[a>>2]=2;break}else{t[a>>2]=3;break}else t[a>>2]=1;while(0);do if((t[t[u>>2]>>2]|0)!=1)if((t[t[u>>2]>>2]|0)==2){t[o>>2]=2;break}else{t[o>>2]=3;break}else t[o>>2]=1;while(0);t[n>>2]=JD(t[t[f>>2]>>2]|0,t[f>>2]|0,0,t[a>>2]|0,t[t[u>>2]>>2]|0,t[u>>2]|0,0,t[o>>2]|0)|0;c=t[n>>2]|0;s=r;return c|0}function ID(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[c>>2]|0)==0){t[u>>2]=-2;b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=JD(t[t[a>>2]>>2]|0,t[a>>2]|0,0,t[o>>2]|0,t[t[c>>2]>>2]|0,t[c>>2]|0,0,t[l>>2]|0)|0;b=t[u>>2]|0;s=f;return b|0}return 0}function HD(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}else{t[r>>2]=t[(t[(t[n>>2]|0)+32>>2]|0)+8>>2];f=t[r>>2]|0;s=i;return f|0}return 0}function xD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}do if((t[t[a>>2]>>2]|0)==1009){if((t[c>>2]|0)!=(t[(t[(t[a>>2]|0)+32>>2]|0)+8>>2]|0)){if(t[l>>2]|0)t[t[l>>2]>>2]=t[(t[(t[a>>2]|0)+32>>2]|0)+8>>2];t[u>>2]=1830;b=t[u>>2]|0;s=f;return b|0}}else{if((t[t[a>>2]>>2]|0)==1011){if((t[c>>2]|0)>>>0>=(t[(t[(t[a>>2]|0)+32>>2]|0)+8>>2]|0)>>>0)break;if(t[l>>2]|0)t[t[l>>2]>>2]=t[(t[(t[a>>2]|0)+32>>2]|0)+8>>2];t[u>>2]=1831;b=t[u>>2]|0;s=f;return b|0}if((t[t[a>>2]>>2]|0)!=1010){t[u>>2]=UD(0,t[a>>2]|0,t[o>>2]|0,0)|0;b=t[u>>2]|0;s=f;return b|0}if((t[c>>2]|0)>>>0>(t[(t[(t[a>>2]|0)+32>>2]|0)+8>>2]|0)>>>0){if(t[l>>2]|0)t[t[l>>2]>>2]=t[(t[(t[a>>2]|0)+32>>2]|0)+8>>2];t[u>>2]=1832;b=t[u>>2]|0;s=f;return b|0}}while(0);t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}function UD(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+16|0;a=f+12|0;o=f+8|0;c=f+4|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(t[l>>2]|0){t[u>>2]=QD(t[o>>2]|0,0,t[t[l>>2]>>2]|0,t[c>>2]|0,t[l>>2]|0,0)|0;b=t[u>>2]|0;s=f;return b|0}if(t[a>>2]|0){t[u>>2]=QD(t[o>>2]|0,0,t[(t[a>>2]|0)+88>>2]|0,t[c>>2]|0,t[l>>2]|0,0)|0;b=t[u>>2]|0;s=f;return b|0}else{t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}return 0}function zD(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;u=$D(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;s=a;return u|0}function jD(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;u=QD(t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;s=a;return u|0}function VD(e,i){e=e|0;i=i|0;var r=0,u=0,o=0,b=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,W=0,K=0;r=s;s=s+512|0;u=r+16|0;o=r+148|0;b=r+144|0;h=r+140|0;w=r+120|0;d=r+116|0;v=r+112|0;m=r+108|0;_=r+104|0;p=r+100|0;E=r+80|0;S=r+76|0;g=r+400|0;y=r+72|0;F=r+68|0;O=r+64|0;A=r+60|0;M=r+56|0;R=r+8|0;N=r;T=r+368|0;L=r+332|0;D=r+302|0;C=r+52|0;P=r+272|0;B=r+48|0;I=r+222|0;H=r+44|0;x=r+192|0;U=r+152|0;t[b>>2]=e;t[h>>2]=i;if((t[h>>2]|0)==0|(t[b>>2]|0)==0){t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}t[t[h>>2]>>2]=0;e:do switch(t[t[b>>2]>>2]|0){case 9:{i=t[(t[b>>2]|0)+8>>2]|0;if((t[(t[b>>2]|0)+8>>2]|0)<0){e=G(i|0)|0;j=t[(t[b>>2]|0)+12>>2]&15;t[u>>2]=e;t[u+4>>2]=j;SY(L,35,171648,u)|0}else{j=t[(t[b>>2]|0)+12>>2]&15;t[u>>2]=i;t[u+4>>2]=j;SY(L,35,171664,u)|0}j=Yl(L)|0;t[t[h>>2]>>2]=j;break}case 8:{t[u>>2]=t[(t[b>>2]|0)+8>>2];SY(T,30,171608,u)|0;j=Yl(T)|0;t[t[h>>2]>>2]=j;break}case 2:{if(!(t[(t[b>>2]|0)+8>>2]|0)){j=Yl(171424)|0;t[t[h>>2]>>2]=j;break e}j=ND(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=j;if(!(t[t[h>>2]>>2]|0)){j=Yl(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=j}break}case 3:{if(((a[(t[b>>2]|0)+24>>1]|0)>>>8&65535|0)==1?(t[(t[b>>2]|0)+8>>2]|0)==0:0){j=Yl(171448)|0;t[t[h>>2]>>2]=j;break e}j=(t[b>>2]|0)+8|0;t[w+0>>2]=t[j+0>>2];t[w+4>>2]=t[j+4>>2];t[w+8>>2]=t[j+8>>2];t[w+12>>2]=t[j+12>>2];t[w+16>>2]=t[j+16>>2];t[v>>2]=0;t[d>>2]=((a[w+16>>1]|0)>>>8&65535)+2;if(f[w+16>>1]&1)t[d>>2]=(t[d>>2]|0)+1;if(!(((a[w+16>>1]|0)>>>1&127|0)!=0?((a[w+16>>1]|0)>>>1&127|0)!=((a[w+16>>1]|0)>>>8&65535|0):0))t[d>>2]=(t[d>>2]|0)+1;t[v>>2]=gAi[t[135744>>2]&511](t[d>>2]|0)|0;if(!(t[v>>2]|0)){t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}t[m>>2]=t[v>>2];if(f[w+16>>1]&1){j=t[m>>2]|0;t[m>>2]=j+1;n[j>>0]=45}if(((a[w+16>>1]|0)>>>1&127|0)==((a[w+16>>1]|0)>>>8&65535|0)){j=t[m>>2]|0;t[m>>2]=j+1;n[j>>0]=48;j=t[m>>2]|0;t[m>>2]=j+1;n[j>>0]=46}do if(!(t[w+8>>2]|0)){j=t[m>>2]|0;i=(t[d>>2]|0)-((t[m>>2]|0)-(t[v>>2]|0))|0;if(t[w+4>>2]|0){e=t[w>>2]|0;t[u>>2]=t[w+4>>2];t[u+4>>2]=e;SY(j,i,171472,u)|0;break}else{t[u>>2]=t[w>>2];SY(j,i,171480,u)|0;break}}else{i=t[m>>2]|0;j=(t[d>>2]|0)-((t[m>>2]|0)-(t[v>>2]|0))|0;e=t[w+4>>2]|0;V=t[w>>2]|0;t[u>>2]=t[w+8>>2];t[u+4>>2]=e;t[u+8>>2]=V;SY(i,j,171456,u)|0}while(0);do if((a[w+16>>1]|0)>>>1&127){if(((a[w+16>>1]|0)>>>1&127|0)!=((a[w+16>>1]|0)>>>8&65535|0)){t[_>>2]=((a[w+16>>1]|0)>>>8&65535)-((a[w+16>>1]|0)>>>1&127);GY((t[m>>2]|0)+(t[_>>2]|0)+1|0,(t[m>>2]|0)+(t[_>>2]|0)|0,((a[w+16>>1]|0)>>>1&127)+1|0)|0;n[(t[m>>2]|0)+(t[_>>2]|0)>>0]=46;break}t[p>>2]=0;while(1){q=t[p>>2]|0;if(!(n[(t[m>>2]|0)+(t[p>>2]|0)>>0]|0))break;t[p>>2]=q+1}if(q>>>0<((a[w+16>>1]|0)>>>8&65535)>>>0){GY((t[m>>2]|0)+(((a[w+16>>1]|0)>>>8&65535)-(t[p>>2]|0))|0,t[m>>2]|0,(t[p>>2]|0)+1|0)|0;VY(t[m>>2]|0,48,((a[w+16>>1]|0)>>>8&65535)-(t[p>>2]|0)|0)|0}}else{t[m>>2]=(t[v>>2]|0)+(t[d>>2]|0)+-1;j=t[m>>2]|0;t[m>>2]=j+-1;n[j>>0]=0;j=t[m>>2]|0;t[m>>2]=j+-1;n[j>>0]=48;j=t[m>>2]|0;t[m>>2]=j+-1;n[j>>0]=46}while(0);t[t[h>>2]>>2]=t[v>>2];break}case 7:{j=gAi[t[135744>>2]&511](8)|0;t[t[h>>2]>>2]=j;if(t[t[h>>2]>>2]|0){j=t[t[h>>2]>>2]|0;i=(t[(t[b>>2]|0)+12>>2]|0)>>>4&31;t[u>>2]=t[(t[b>>2]|0)+12>>2]&15;t[u+4>>2]=i;SY(j,8,171632,u)|0;break e}t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}case 15:{if(t[(t[b>>2]|0)+8>>2]|0){j=Yl(171528)|0;t[t[h>>2]>>2]=j;break e}else{j=Yl(171536)|0;t[t[h>>2]>>2]=j;break e}break}case 5:{j=gAi[t[135744>>2]&511](6)|0;t[t[h>>2]>>2]=j;if(t[t[h>>2]>>2]|0){j=t[t[h>>2]>>2]|0;t[u>>2]=(t[(t[b>>2]|0)+12>>2]|0)>>>4&31;SY(j,6,171624,u)|0;break e}t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}case 42:case 40:case 38:case 36:case 35:case 39:case 41:case 37:case 33:case 32:case 31:case 34:case 30:{if(((a[(t[b>>2]|0)+24>>1]|0)>>>8&65535|0)==1?(t[(t[b>>2]|0)+8>>2]|0)==0:0){j=Yl(171488)|0;t[t[h>>2]>>2]=j;break e}j=(t[b>>2]|0)+8|0;t[E+0>>2]=t[j+0>>2];t[E+4>>2]=t[j+4>>2];t[E+8>>2]=t[j+8>>2];t[E+12>>2]=t[j+12>>2];t[E+16>>2]=t[j+16>>2];t[S>>2]=((a[E+16>>1]|0)>>>8&65535)+1;if(f[E+16>>1]&1)t[S>>2]=(t[S>>2]|0)+1;j=gAi[t[135744>>2]&511](t[S>>2]|0)|0;t[t[h>>2]>>2]=j;if(!(t[t[h>>2]>>2]|0)){t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}if(t[E+8>>2]|0){j=t[t[h>>2]>>2]|0;i=t[S>>2]|0;V=t[E+8>>2]|0;e=t[E+4>>2]|0;W=t[E>>2]|0;if(f[E+16>>1]&1){t[u>>2]=V;t[u+4>>2]=e;t[u+8>>2]=W;SY(j,i,171496,u)|0;break e}else{t[u>>2]=V;t[u+4>>2]=e;t[u+8>>2]=W;SY(j,i,171456,u)|0;break e}}i=(f[E+16>>1]&1|0)!=0;j=t[t[h>>2]>>2]|0;W=t[S>>2]|0;if(t[E+4>>2]|0){e=t[E+4>>2]|0;V=t[E>>2]|0;if(i){t[u>>2]=e;t[u+4>>2]=V;SY(j,W,171512,u)|0;break e}else{t[u>>2]=e;t[u+4>>2]=V;SY(j,W,171472,u)|0;break e}}else{V=t[E>>2]|0;if(i){t[u>>2]=V;SY(j,W,171520,u)|0;break e}else{t[u>>2]=V;SY(j,W,171480,u)|0;break e}}break}case 12:{t[A>>2]=0;t[M>>2]=0;l[R>>3]=0;t[y>>2]=~~+Y(+(+(G(t[(t[b>>2]|0)+8>>2]|0)|0)/12))>>>0;W=G(t[(t[b>>2]|0)+8>>2]|0)|0;t[F>>2]=W-((t[y>>2]|0)*12|0);t[O>>2]=~~+Y(+(+G(+ +l[(t[b>>2]|0)+16>>3])/86400))>>>0;K=+G(+ +l[(t[b>>2]|0)+16>>3]);l[N>>3]=K-+(((t[O>>2]|0)*86400|0)>>>0);if(+l[N>>3]>0?(t[A>>2]=~~+Y(+(+l[N>>3]/3600))>>>0,l[N>>3]=+l[N>>3]-+(((t[A>>2]|0)*3600|0)>>>0),+l[N>>3]>0):0){t[M>>2]=~~+Y(+(+l[N>>3]/60))>>>0;l[R>>3]=+l[N>>3]-+(((t[M>>2]|0)*60|0)>>>0)}if((t[(t[b>>2]|0)+8>>2]|0)>=0?!(+l[(t[b>>2]|0)+16>>3]<0):0){W=t[F>>2]|0;j=t[O>>2]|0;V=t[A>>2]|0;i=t[M>>2]|0;K=+l[R>>3];t[u>>2]=t[y>>2];t[u+4>>2]=W;t[u+8>>2]=j;t[u+12>>2]=V;t[u+16>>2]=i;i=u+20|0;l[k>>3]=K;t[i>>2]=t[k>>2];t[i+4>>2]=t[k+4>>2];SY(g,100,171576,u)|0}else{i=t[F>>2]|0;V=t[O>>2]|0;j=t[A>>2]|0;W=t[M>>2]|0;K=+l[R>>3];t[u>>2]=t[y>>2];t[u+4>>2]=i;t[u+8>>2]=V;t[u+12>>2]=j;t[u+16>>2]=W;W=u+20|0;l[k>>3]=K;t[W>>2]=t[k>>2];t[W+4>>2]=t[k+4>>2];SY(g,100,171544,u)|0}W=Yl(g)|0;t[t[h>>2]>>2]=W;break}case 10:{do if(f[(t[b>>2]|0)+24>>1]&1){t[B>>2]=eC(t[b>>2]|0,0)|0;if(t[B>>2]|0){W=t[(t[B>>2]|0)+12>>2]&15;j=(t[(t[B>>2]|0)+12>>2]|0)>>>4&31;t[u>>2]=t[(t[B>>2]|0)+8>>2];t[u+4>>2]=W;t[u+8>>2]=j;SY(P,30,171728,u)|0;MD(t[B>>2]|0);break}t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}else{j=t[(t[b>>2]|0)+12>>2]&15;W=(t[(t[b>>2]|0)+12>>2]|0)>>>4&31;t[u>>2]=t[(t[b>>2]|0)+8>>2];t[u+4>>2]=j;t[u+8>>2]=W;SY(P,30,171752,u)|0}while(0);W=Yl(P)|0;t[t[h>>2]>>2]=W;break}case 29:case 28:case 26:case 24:case 23:case 22:case 20:case 18:case 17:case 16:{if(!(t[(t[b>>2]|0)+8>>2]|0)){t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}else{W=TD(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=W;if(t[t[h>>2]>>2]|0)break e;W=Yl(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=W;break e}break}case 4:{do if(f[(t[b>>2]|0)+24>>1]&1){t[C>>2]=eC(t[b>>2]|0,0)|0;if(t[C>>2]|0){W=(t[(t[C>>2]|0)+12>>2]|0)>>>14&63;K=+l[(t[C>>2]|0)+16>>3];t[u>>2]=(t[(t[C>>2]|0)+12>>2]|0)>>>9&31;t[u+4>>2]=W;W=u+8|0;l[k>>3]=K;t[W>>2]=t[k>>2];t[W+4>>2]=t[k+4>>2];SY(D,30,171680,u)|0;MD(t[C>>2]|0);break}t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}else{W=(t[(t[b>>2]|0)+12>>2]|0)>>>14&63;K=+l[(t[b>>2]|0)+16>>3];t[u>>2]=(t[(t[b>>2]|0)+12>>2]|0)>>>9&31;t[u+4>>2]=W;W=u+8|0;l[k>>3]=K;t[W>>2]=t[k>>2];t[W+4>>2]=t[k+4>>2];SY(D,30,171704,u)|0}while(0);W=Yl(D)|0;t[t[h>>2]>>2]=W;break}case 6:{W=gAi[t[135744>>2]&511](6)|0;t[t[h>>2]>>2]=W;if(t[t[h>>2]>>2]|0){W=t[t[h>>2]>>2]|0;t[u>>2]=t[(t[b>>2]|0)+12>>2]&15;SY(W,6,171616,u)|0;break e}t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}case 43:{W=Yl(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=W;break}case 44:{W=Yl(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=W;break}case 13:{l[k>>3]=+c[(t[b>>2]|0)+8>>2];t[u>>2]=t[k>>2];t[u+4>>2]=t[k+4>>2];SY(x,30,171848,u)|0;W=Yl(x)|0;t[t[h>>2]>>2]=W;break}case 14:{l[k>>3]=+l[(t[b>>2]|0)+8>>3];t[u>>2]=t[k>>2];t[u+4>>2]=t[k+4>>2];SY(U,40,171848,u)|0;W=Yl(U)|0;t[t[h>>2]>>2]=W;break}case 11:{do if(f[(t[b>>2]|0)+24>>1]&1){t[H>>2]=eC(t[b>>2]|0,0)|0;if(t[H>>2]|0){W=t[(t[H>>2]|0)+12>>2]&15;j=(t[(t[H>>2]|0)+12>>2]|0)>>>4&31;V=(t[(t[H>>2]|0)+12>>2]|0)>>>9&31;i=(t[(t[H>>2]|0)+12>>2]|0)>>>14&63;K=+l[(t[H>>2]|0)+16>>3];t[u>>2]=t[(t[H>>2]|0)+8>>2];t[u+4>>2]=W;t[u+8>>2]=j;t[u+12>>2]=V;t[u+16>>2]=i;i=u+20|0;l[k>>3]=K;t[i>>2]=t[k>>2];t[i+4>>2]=t[k+4>>2];SY(I,50,171768,u)|0;MD(t[H>>2]|0);break}t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}else{i=t[(t[b>>2]|0)+12>>2]&15;V=(t[(t[b>>2]|0)+12>>2]|0)>>>4&31;j=(t[(t[b>>2]|0)+12>>2]|0)>>>9&31;W=(t[(t[b>>2]|0)+12>>2]|0)>>>14&63;K=+l[(t[b>>2]|0)+16>>3];t[u>>2]=t[(t[b>>2]|0)+8>>2];t[u+4>>2]=i;t[u+8>>2]=V;t[u+12>>2]=j;t[u+16>>2]=W;W=u+20|0;l[k>>3]=K;t[W>>2]=t[k>>2];t[W+4>>2]=t[k+4>>2];SY(I,50,171808,u)|0}while(0);W=Yl(I)|0;t[t[h>>2]>>2]=W;break}case 1:{if(!(t[(t[b>>2]|0)+8>>2]|0)){W=Yl(171424)|0;t[t[h>>2]>>2]=W;break e}else{W=Yl(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=W;break e}break}case 21:{if(t[(t[b>>2]|0)+12>>2]|0){W=Yl(171432)|0;t[t[h>>2]>>2]=W;W=us(t[t[h>>2]>>2]|0,t[(t[b>>2]|0)+12>>2]|0)|0;t[t[h>>2]>>2]=W;W=us(t[t[h>>2]>>2]|0,171440)|0;t[t[h>>2]>>2]=W;W=us(t[t[h>>2]>>2]|0,t[(t[b>>2]|0)+12>>2]|0)|0;t[t[h>>2]>>2]=W;break e}W=Yl(t[(t[b>>2]|0)+8>>2]|0)|0;t[t[h>>2]>>2]=W;t[o>>2]=0;z=t[o>>2]|0;s=r;return z|0}default:{W=Yl(171856)|0;t[t[h>>2]>>2]=W;t[o>>2]=1;z=t[o>>2]|0;s=r;return z|0}}while(0);if(!(t[t[h>>2]>>2]|0)){t[o>>2]=-1;z=t[o>>2]|0;s=r;return z|0}else{t[o>>2]=0;z=t[o>>2]|0;s=r;return z|0}return 0}function qD(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0))t[r>>2]=0;else t[r>>2]=t[t[n>>2]>>2];s=i;return t[r>>2]|0}function YD(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=gAi[t[135744>>2]&511](120)|0;if(!(t[c>>2]|0)){WD(0,172376);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}r=(t[c>>2]|0)+0|0;i=r+120|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));t[(t[c>>2]|0)+8>>2]=t[u>>2];t[(t[c>>2]|0)+112>>2]=172416;t[t[c>>2]>>2]=1;t[(t[c>>2]|0)+64>>2]=t[o>>2];t[(t[c>>2]|0)+52>>2]=6;switch(t[a>>2]|0){case 28:case 21:case 44:case 43:case 29:case 15:case 14:case 13:case 12:case 5:case 7:case 6:case 9:case 8:case 4:case 11:case 10:case 3:case 1:{o=(t[c>>2]|0)+48|0;t[o>>2]=t[o>>2]|16384;break}default:{}}switch(t[a>>2]|0){case 46:case 45:break;case 27:case 19:case 25:{o=(t[c>>2]|0)+48|0;t[o>>2]=t[o>>2]|64;o=iC(1)|0;t[(t[c>>2]|0)+68>>2]=o;o=(t[c>>2]|0)+48|0;t[o>>2]=t[o>>2]|134217728;break}default:{o=(t[c>>2]|0)+48|0;t[o>>2]=t[o>>2]|256}}QF(t[42592]|0,t[(t[c>>2]|0)+8>>2]|0,172416,t[c>>2]|0)|0;t[(t[c>>2]|0)+88>>2]=t[a>>2];t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}function GD(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=0;t[r>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[r>>2]|0)){WD(0,172344);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{f=t[r>>2]|0;t[f+0>>2]=0;t[f+4>>2]=0;t[f+8>>2]=0;t[f+12>>2]=0;t[f+16>>2]=0;t[f+20>>2]=0;t[f+24>>2]=0;t[t[r>>2]>>2]=25;t[(t[r>>2]|0)+16>>2]=1;t[(t[r>>2]|0)+20>>2]=1;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function WD(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;dp(15,2,t[n>>2]|0,0,t[f>>2]|0);s=r;return}function KD(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;t[e+24>>2]=0;t[e+28>>2]=0;t[t[f>>2]>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function XD(e,i,r,a,o,b,k,h,w){e=e|0;i=i|0;r=r|0;a=a|0;o=o|0;b=b|0;k=k|0;h=h|0;w=w|0;var d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,te=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0,ke=0,he=0,we=0,de=0,ve=0,me=0,_e=0,pe=0,Ee=0,Se=0,ge=0,ye=0,Fe=0,Oe=0,Ae=0,Me=0,Re=0,Ne=0,Te=0,Le=0,De=0,Ce=0,Pe=0,Be=0,Ie=0,He=0,xe=0,Ue=0,ze=0,je=0,Ve=0,qe=0,Ye=0,Ge=0,We=0,Ke=0,Xe=0,Ze=0,Je=0,Qe=0,$e=0,ei=0;d=s;s=s+352|0;v=d;m=d+316|0;_=d+312|0;p=d+308|0;E=d+304|0;S=d+300|0;g=d+296|0;y=d+292|0;F=d+288|0;O=d+284|0;A=d+280|0;M=d+276|0;R=d+272|0;N=d+268|0;T=d+264|0;L=d+260|0;D=d+256|0;C=d+252|0;P=d+248|0;B=d+244|0;I=d+240|0;H=d+320|0;x=d+236|0;U=d+232|0;z=d+228|0;j=d+224|0;V=d+220|0;q=d+216|0;Y=d+212|0;G=d+208|0;W=d+204|0;K=d+200|0;X=d+196|0;Z=d+192|0;J=d+188|0;Q=d+184|0;$=d+180|0;ee=d+176|0;ie=d+172|0;re=d+168|0;ne=d+164|0;fe=d+160|0;te=d+156|0;ue=d+152|0;ae=d+148|0;oe=d+144|0;ce=d+140|0;le=d+136|0;se=d+132|0;be=d+128|0;ke=d+124|0;he=d+120|0;we=d+116|0;de=d+112|0;ve=d+108|0;me=d+104|0;_e=d+100|0;pe=d+96|0;Ee=d+92|0;Se=d+88|0;ge=d+84|0;ye=d+80|0;Fe=d+76|0;Oe=d+72|0;Ae=d+68|0;Me=d+64|0;Re=d+60|0;Ne=d+56|0;Te=d+52|0;Le=d+48|0;De=d+44|0;Ce=d+40|0;Pe=d+36|0;Be=d+32|0;Ie=d+28|0;He=d+24|0;xe=d+20|0;Ue=d+16|0;ze=d+12|0;je=d+8|0;t[_>>2]=e;t[p>>2]=i;t[E>>2]=r;t[S>>2]=a;t[g>>2]=o;t[y>>2]=b;t[F>>2]=k;t[O>>2]=h;t[A>>2]=w;t[R>>2]=0;t[N>>2]=0;if(!(t[42590]|0))mD();if(!(t[_>>2]|0)){t[m>>2]=-1;Ve=t[m>>2]|0;s=d;return Ve|0}if(!(t[p>>2]|0))t[p>>2]=171424;if(t[E>>2]|0)t[t[E>>2]>>2]=0;if((((t[g>>2]|0)==0&(t[p>>2]|0)!=0?(t[(t[_>>2]|0)+88>>2]|0)!=1:0)?(t[(t[_>>2]|0)+88>>2]|0)!=45:0)?(t[(t[_>>2]|0)+88>>2]|0)!=46:0){g=t[p>>2]|0;if((t[(t[_>>2]|0)+88>>2]|0)==2)t[R>>2]=ND(g)|0;else t[R>>2]=TD(g)|0;if(t[R>>2]|0)t[p>>2]=t[R>>2]}e:do switch(t[(t[_>>2]|0)+88>>2]|0){case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{t[N>>2]=nC(t[(t[_>>2]|0)+88>>2]|0,t[p>>2]|0,t[E>>2]|0,t[F>>2]|0)|0;qe=571;break}case 14:case 13:{t[U>>2]=t[p>>2];t[z>>2]=0;t[j>>2]=0;t[V>>2]=0;i:do if(t[F>>2]|0)while(1){do if((u[t[U>>2]>>0]|0)!=32){if(9<=(u[t[U>>2]>>0]|0)?(u[t[U>>2]>>0]|0)<=10:0)break;if((u[t[U>>2]>>0]|0)!=13)break i}while(0);t[U>>2]=(t[U>>2]|0)+1}while(0);if(((u[t[U>>2]>>0]|0)==78?(u[(t[U>>2]|0)+1>>0]|0)==97:0)?(u[(t[U>>2]|0)+2>>0]|0)==78:0){t[U>>2]=(t[U>>2]|0)+3;if(u[t[U>>2]>>0]|0){qe=577;break e}if(!(t[E>>2]|0)){qe=580;break e}do if((t[_>>2]|0)==(t[42690]|0)){t[M>>2]=KD(13)|0;if(t[M>>2]|0){c[(t[M>>2]|0)+8>>2]=+l[15984];break}else{MD(t[M>>2]|0);qe=583;break e}}else{t[M>>2]=KD(14)|0;if(t[M>>2]|0){l[(t[M>>2]|0)+8>>3]=+l[15984];break}else{MD(t[M>>2]|0);qe=583;break e}}while(0);t[t[E>>2]>>2]=t[M>>2];qe=580;break e}if((u[t[U>>2]>>0]|0)==45){t[z>>2]=1;t[U>>2]=(t[U>>2]|0)+1}if(((u[t[U>>2]>>0]|0)==73?(u[(t[U>>2]|0)+1>>0]|0)==78:0)?(u[(t[U>>2]|0)+2>>0]|0)==70:0){t[U>>2]=(t[U>>2]|0)+3;if(u[t[U>>2]>>0]|0){qe=577;break e}if(!(t[E>>2]|0)){qe=580;break e}do if((t[_>>2]|0)==(t[42690]|0)){t[M>>2]=KD(13)|0;if(!(t[M>>2]|0)){MD(t[M>>2]|0);qe=583;break e}if(t[z>>2]|0){c[(t[M>>2]|0)+8>>2]=+l[15986];break}else{c[(t[M>>2]|0)+8>>2]=+l[15985];break}}else{t[M>>2]=KD(14)|0;if(!(t[M>>2]|0)){MD(t[M>>2]|0);qe=583;break e}if(t[z>>2]|0){l[(t[M>>2]|0)+8>>3]=+l[15986];break}else{l[(t[M>>2]|0)+8>>3]=+l[15985];break}}while(0);t[t[E>>2]>>2]=t[M>>2];qe=580;break e}if((t[z>>2]|0)==0?(u[t[U>>2]>>0]|0)==43:0)t[U>>2]=(t[U>>2]|0)+1;if(((u[t[U>>2]>>0]|0)!=0?(u[t[U>>2]>>0]|0)!=43:0)?(u[t[U>>2]>>0]|0)!=45:0){while(1){if((u[t[U>>2]>>0]|0)>=48)Ye=(u[t[U>>2]>>0]|0)<=57;else Ye=0;Ge=t[U>>2]|0;if(!Ye)break;t[U>>2]=Ge+1;t[j>>2]=(t[j>>2]|0)+1}i:do if((u[Ge>>0]|0)==46){t[U>>2]=(t[U>>2]|0)+1;while(1){if((u[t[U>>2]>>0]|0)<48)break i;if((u[t[U>>2]>>0]|0)>57)break i;t[U>>2]=(t[U>>2]|0)+1;t[V>>2]=(t[V>>2]|0)+1}}while(0);if(!((t[j>>2]|0)==0&(t[V>>2]|0)==0)){if(!((u[t[U>>2]>>0]|0)!=101?(u[t[U>>2]>>0]|0)!=69:0))qe=168;i:do if((qe|0)==168){t[U>>2]=(t[U>>2]|0)+1;if(!((u[t[U>>2]>>0]|0)!=45?(u[t[U>>2]>>0]|0)!=43:0))t[U>>2]=(t[U>>2]|0)+1;while(1){if((u[t[U>>2]>>0]|0)<48)break i;if((u[t[U>>2]>>0]|0)>57)break i;t[U>>2]=(t[U>>2]|0)+1}}while(0);i:do if(t[F>>2]|0)while(1){do if((u[t[U>>2]>>0]|0)!=32){if(9<=(u[t[U>>2]>>0]|0)?(u[t[U>>2]>>0]|0)<=10:0)break;if((u[t[U>>2]>>0]|0)!=13)break i}while(0);t[U>>2]=(t[U>>2]|0)+1}while(0);if(!(u[t[U>>2]>>0]|0))if(t[E>>2]|0)if((t[_>>2]|0)==(t[42690]|0)){t[M>>2]=KD(13)|0;if(!(t[M>>2]|0)){qe=583;break e}g=t[p>>2]|0;t[v>>2]=(t[M>>2]|0)+8;w=(jq(g,172216,v)|0)==1;g=t[M>>2]|0;if(w){t[t[E>>2]>>2]=g;qe=580;break e}else{MD(g);qe=577;break e}}else{t[M>>2]=KD(14)|0;if(!(t[M>>2]|0)){qe=583;break e}g=t[p>>2]|0;t[v>>2]=(t[M>>2]|0)+8;w=(jq(g,172224,v)|0)==1;g=t[M>>2]|0;if(w){t[t[E>>2]>>2]=g;qe=580;break e}else{MD(g);qe=577;break e}}else qe=580;else qe=577}else qe=577}else qe=577;break}case 2:{i:do if(t[F>>2]|0){if(t[O>>2]|0){g=t[p>>2]|0;if((t[y>>2]|0)==3)t[R>>2]=TD(g)|0;else t[R>>2]=ND(g)|0;if(t[R>>2]|0)t[p>>2]=t[R>>2]}}else{t[L>>2]=t[p>>2];while(1){if(!(u[t[L>>2]>>0]|0))break i;if((u[t[L>>2]>>0]|0)==13){qe=577;break e}if((u[t[L>>2]>>0]|0)==10){qe=577;break e}if((u[t[L>>2]>>0]|0)==9){qe=577;break e}t[L>>2]=(t[L>>2]|0)+1}}while(0);if(t[E>>2]|0){t[M>>2]=KD(2)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;break}case 46:case 45:{if((t[A>>2]|0)!=0&(t[E>>2]|0)!=0){t[M>>2]=KD(46)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;break}case 3:{t[D>>2]=t[p>>2];t[x>>2]=H;if((t[D>>2]|0)!=0?(u[t[D>>2]>>0]|0)!=0:0){i:do if(t[F>>2]|0)while(1){do if((u[t[D>>2]>>0]|0)!=32){if(9<=(u[t[D>>2]>>0]|0)?(u[t[D>>2]>>0]|0)<=10:0)break;if((u[t[D>>2]>>0]|0)!=13)break i}while(0);t[D>>2]=(t[D>>2]|0)+1}while(0);t[P>>2]=0;if((u[t[D>>2]>>0]|0)!=45){if((u[t[D>>2]>>0]|0)==43)t[D>>2]=(t[D>>2]|0)+1}else{t[P>>2]=1;t[D>>2]=(t[D>>2]|0)+1}if(u[t[D>>2]>>0]|0){t[C>>2]=0;t[B>>2]=-1;t[I>>2]=0;while(1){We=t[D>>2]|0;if((u[t[D>>2]>>0]|0)!=48)break;t[D>>2]=We+1;t[I>>2]=1}i:do if(u[We>>0]|0){while(1){if((u[t[D>>2]>>0]|0)<48)break;if((u[t[D>>2]>>0]|0)>57)break;g=t[D>>2]|0;t[D>>2]=g+1;w=n[g>>0]|0;g=t[x>>2]|0;t[x>>2]=g+1;n[g>>0]=w;t[C>>2]=(t[C>>2]|0)+1;if((t[C>>2]|0)>>>0>=24)break i}if((u[t[D>>2]>>0]|0)==46){t[D>>2]=(t[D>>2]|0)+1;t[B>>2]=t[C>>2];do{if((u[t[D>>2]>>0]|0)<48)break;if((u[t[D>>2]>>0]|0)>57)break;w=t[D>>2]|0;t[D>>2]=w+1;g=n[w>>0]|0;w=t[x>>2]|0;t[x>>2]=w+1;n[w>>0]=g;t[C>>2]=(t[C>>2]|0)+1}while((t[C>>2]|0)>>>0<24);if(!((t[C>>2]|0)!=0|(t[I>>2]|0)!=0)){qe=577;break e}}}while(0);i:do if(t[F>>2]|0)while(1){do if((u[t[D>>2]>>0]|0)!=32){if(9<=(u[t[D>>2]>>0]|0)?(u[t[D>>2]>>0]|0)<=10:0)break;if((u[t[D>>2]>>0]|0)!=13)break i}while(0);t[D>>2]=(t[D>>2]|0)+1}while(0);if(!(u[t[D>>2]>>0]|0))if((t[E>>2]|0)!=0?(t[M>>2]=KD(3)|0,(t[M>>2]|0)!=0):0){if(t[C>>2]|0){i:do if((t[B>>2]|0)!=-1)while(1){if((t[C>>2]|0)==(t[B>>2]|0))break i;if((u[(t[x>>2]|0)+-1>>0]|0)!=48)break i;t[x>>2]=(t[x>>2]|0)+-1;t[C>>2]=(t[C>>2]|0)+-1}while(0);if(t[C>>2]|0){n[t[x>>2]>>0]=0;t[x>>2]=H;rC(x,(t[M>>2]|0)+8|0,(t[M>>2]|0)+12|0,(t[M>>2]|0)+16|0)|0}}g=(t[M>>2]|0)+24|0;f[g>>1]=f[g>>1]&-2|t[P>>2]&1;do if(t[C>>2]|0){g=(t[M>>2]|0)+24|0;f[g>>1]=f[g>>1]&255|(t[C>>2]&255)<<8&65535;if((t[B>>2]|0)==-1){g=(t[M>>2]|0)+24|0;f[g>>1]=f[g>>1]&-255;break}else{g=(t[M>>2]|0)+24|0;f[g>>1]=f[g>>1]&-255|((t[C>>2]|0)-(t[B>>2]|0)&127)<<1&65535;break}}else{g=(t[M>>2]|0)+24|0;f[g>>1]=f[g>>1]&255|256}while(0);t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=580;else qe=577}else qe=577}else qe=577;break}case 1:{i:do if(!(t[F>>2]|0)){t[T>>2]=t[p>>2];if((t[y>>2]|0)==2)while(1){if(!(u[t[T>>2]>>0]|0))break i;if((u[t[T>>2]>>0]|0)==13){qe=577;break e}if((u[t[T>>2]>>0]|0)==10){qe=577;break e}if((u[t[T>>2]>>0]|0)==9){qe=577;break e}t[T>>2]=(t[T>>2]|0)+1}if((t[y>>2]|0)==3)while(1){if(!(u[t[T>>2]>>0]|0))break i;if((u[t[T>>2]>>0]|0)==13){qe=577;break e}if((u[t[T>>2]>>0]|0)==10){qe=577;break e}if((u[t[T>>2]>>0]|0)==9){qe=577;break e}g=(u[t[T>>2]>>0]|0)==32;t[T>>2]=(t[T>>2]|0)+1;if(!g)continue;if((u[t[T>>2]>>0]|0)==32){qe=577;break e}}}while(0);if((t[A>>2]|0)!=0&(t[E>>2]|0)!=0){if(t[O>>2]|0){if((t[y>>2]|0)!=3){if((t[y>>2]|0)==2)t[R>>2]=ND(t[p>>2]|0)|0}else t[R>>2]=TD(t[p>>2]|0)|0;if(t[R>>2]|0)t[p>>2]=t[R>>2]}t[M>>2]=KD(1)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;break}case 12:{t[N>>2]=fC(t[_>>2]|0,t[p>>2]|0,t[E>>2]|0,t[F>>2]|0)|0;qe=571;break}case 15:{t[q>>2]=t[p>>2];do if(t[F>>2]|0){while(1){do if((u[t[q>>2]>>0]|0)==32)Ke=1;else{if(9<=(u[t[q>>2]>>0]|0)?(u[t[q>>2]>>0]|0)<=10:0){Ke=1;break}Ke=(u[t[q>>2]>>0]|0)==13}while(0);Xe=t[q>>2]|0;if(!Ke)break;t[q>>2]=Xe+1}do if((u[Xe>>0]|0)==48){t[N>>2]=0;t[q>>2]=(t[q>>2]|0)+1}else{if((u[t[q>>2]>>0]|0)==49){t[N>>2]=1;t[q>>2]=(t[q>>2]|0)+1;break}g=t[q>>2]|0;if((u[t[q>>2]>>0]|0)==116){t[q>>2]=g+1;w=t[q>>2]|0;t[q>>2]=w+1;if((u[w>>0]|0)!=114){qe=577;break e}w=t[q>>2]|0;t[q>>2]=w+1;if((u[w>>0]|0)!=117){qe=577;break e}w=t[q>>2]|0;t[q>>2]=w+1;if((u[w>>0]|0)!=101){qe=577;break e}t[N>>2]=1;break}if((u[g>>0]|0)!=102){qe=577;break e}t[q>>2]=(t[q>>2]|0)+1;g=t[q>>2]|0;t[q>>2]=g+1;if((u[g>>0]|0)!=97){qe=577;break e}g=t[q>>2]|0;t[q>>2]=g+1;if((u[g>>0]|0)!=108){qe=577;break e}g=t[q>>2]|0;t[q>>2]=g+1;if((u[g>>0]|0)!=115){qe=577;break e}g=t[q>>2]|0;t[q>>2]=g+1;if((u[g>>0]|0)!=101){qe=577;break e}t[N>>2]=0}while(0);if(u[t[q>>2]>>0]|0){while(1){do if((u[t[q>>2]>>0]|0)==32)Ze=1;else{if(9<=(u[t[q>>2]>>0]|0)?(u[t[q>>2]>>0]|0)<=10:0){Ze=1;break}Ze=(u[t[q>>2]>>0]|0)==13}while(0);Je=t[q>>2]|0;if(!Ze)break;t[q>>2]=Je+1}if(u[Je>>0]|0){qe=577;break e}}}else{if((u[t[q>>2]>>0]|0)==48?(u[(t[q>>2]|0)+1>>0]|0)==0:0){t[N>>2]=0;break}if((u[t[q>>2]>>0]|0)==49?(u[(t[q>>2]|0)+1>>0]|0)==0:0){t[N>>2]=1;break}if(((((u[t[q>>2]>>0]|0)==116?(u[(t[q>>2]|0)+1>>0]|0)==114:0)?(u[(t[q>>2]|0)+2>>0]|0)==117:0)?(u[(t[q>>2]|0)+3>>0]|0)==101:0)?(u[(t[q>>2]|0)+4>>0]|0)==0:0){t[N>>2]=1;break}if((u[t[q>>2]>>0]|0)!=102){qe=577;break e}if((u[(t[q>>2]|0)+1>>0]|0)!=97){qe=577;break e}if((u[(t[q>>2]|0)+2>>0]|0)!=108){qe=577;break e}if((u[(t[q>>2]|0)+3>>0]|0)!=115){qe=577;break e}if((u[(t[q>>2]|0)+4>>0]|0)!=101){qe=577;break e}if(u[(t[q>>2]|0)+5>>0]|0){qe=577;break e}t[N>>2]=0}while(0);if(t[E>>2]|0){t[M>>2]=KD(15)|0;if(t[M>>2]|0){t[(t[M>>2]|0)+8>>2]=t[N>>2];t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;break}case 16:{t[Y>>2]=t[p>>2];i:do if(!(t[F>>2]|0))while(1){if(!(u[t[Y>>2]>>0]|0))break i;if((u[t[Y>>2]>>0]|0)==13){qe=577;break e}if((u[t[Y>>2]>>0]|0)==10){qe=577;break e}if((u[t[Y>>2]>>0]|0)==9){qe=577;break e}g=(u[t[Y>>2]>>0]|0)==32;t[Y>>2]=(t[Y>>2]|0)+1;if(!g)continue;if(!(u[t[Y>>2]>>0]|0)){qe=577;break e}if((u[t[Y>>2]>>0]|0)==32){qe=577;break e}}while(0);if(t[E>>2]|0){t[M>>2]=KD(16)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;break}case 17:{if((t[F>>2]|0)!=0?(t[R>>2]=TD(t[p>>2]|0)|0,(t[R>>2]|0)!=0):0)t[p>>2]=t[R>>2];if(($p(t[p>>2]|0)|0)==1)if(t[E>>2]|0){t[M>>2]=KD(17)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;else qe=577;break}case 18:{if(!(Gg(t[p>>2]|0,1)|0))if(t[E>>2]|0){t[M>>2]=KD(18)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=583}else qe=580;else qe=577;break}case 20:{t[N>>2]=Yg(t[p>>2]|0,1)|0;if((t[N>>2]|0)==0&(t[E>>2]|0)!=0&(t[p>>2]|0)!=0){t[M>>2]=KD(20)|0;if(t[M>>2]|0){t[G>>2]=t[p>>2];while(1){do if((u[t[G>>2]>>0]|0)==32)Qe=1;else{if(9<=(u[t[G>>2]>>0]|0)?(u[t[G>>2]>>0]|0)<=10:0){Qe=1;break}Qe=(u[t[G>>2]>>0]|0)==13}while(0);$e=t[G>>2]|0;if(!Qe)break;t[G>>2]=$e+1}t[W>>2]=$e;while(1){if(!(u[t[W>>2]>>0]|0))break;do if((u[t[W>>2]>>0]|0)==32)ei=1;else{if(9<=(u[t[W>>2]>>0]|0)?(u[t[W>>2]>>0]|0)<=10:0){ei=1;break}ei=(u[t[W>>2]>>0]|0)==13}while(0);if(!(ei^1))break;t[W>>2]=(t[W>>2]|0)+1}g=ql(t[G>>2]|0,(t[W>>2]|0)-(t[G>>2]|0)|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=571}else qe=583}else qe=571;break}case 19:{t[N>>2]=tC(t[42822]|0,t[p>>2]|0,t[E>>2]|0,t[S>>2]|0)|0;if((t[N>>2]|0)>0){t[N>>2]=0;qe=571;break e}else{t[N>>2]=1;qe=571;break e}break}case 21:{t[K>>2]=0;t[X>>2]=0;t[N>>2]=qg(t[p>>2]|0,1)|0;if(t[N>>2]|0)qe=571;else{if(t[S>>2]|0){t[X>>2]=zg(t[p>>2]|0,Z)|0;t[J>>2]=wF(t[(t[S>>2]|0)+32>>2]|0,t[S>>2]|0,t[Z>>2]|0)|0;if((t[J>>2]|0)==0&(t[Z>>2]|0)!=0){pAi[t[135736>>2]&511](t[Z>>2]|0);if(!(t[X>>2]|0)){qe=577;break e}pAi[t[135736>>2]&511](t[X>>2]|0);qe=577;break e}if(t[J>>2]|0)t[K>>2]=t[(t[J>>2]|0)+8>>2];if(t[Z>>2]|0)pAi[t[135736>>2]&511](t[Z>>2]|0)}if(!(t[E>>2]|0)){if(!(t[X>>2]|0)){qe=571;break e}pAi[t[135736>>2]&511](t[X>>2]|0);qe=571;break e}t[M>>2]=KD(21)|0;g=(t[X>>2]|0)!=0;if(!(t[M>>2]|0)){if(!g){qe=583;break e}pAi[t[135736>>2]&511](t[X>>2]|0);qe=583;break e}if(g)t[(t[M>>2]|0)+8>>2]=t[X>>2];else{g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g}if(t[K>>2]|0){g=Yl(t[K>>2]|0)|0;t[(t[M>>2]|0)+12>>2]=g}t[t[E>>2]>>2]=t[M>>2];qe=571}break}case 23:{t[N>>2]=Vg(t[p>>2]|0,1)|0;if((t[N>>2]|0)==0&(t[E>>2]|0)!=0){t[M>>2]=KD(23)|0;if(!(t[M>>2]|0)){qe=583;break e}g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2]}if(((t[N>>2]|0)==0&(t[S>>2]|0)!=0?(t[(t[S>>2]|0)+4>>2]|0)==2:0)?(t[Q>>2]=t[S>>2],(t[(t[Q>>2]|0)+40>>2]|0)!=2):0){t[ee>>2]=uC(t[p>>2]|0)|0;g=t[(t[S>>2]|0)+32>>2]|0;if(t[ee>>2]|0){t[$>>2]=zM(0,g,t[ee>>2]|0,t[Q>>2]|0)|0;pAi[t[135736>>2]&511](t[ee>>2]|0)}else t[$>>2]=zM(0,g,t[p>>2]|0,t[Q>>2]|0)|0;if(!(t[$>>2]|0)){t[N>>2]=2;qe=571;break e}else{t[(t[Q>>2]|0)+40>>2]=2;qe=571;break e}}else qe=571;break}case 22:{t[N>>2]=Vg(t[p>>2]|0,1)|0;if((t[N>>2]|0)==0&(t[E>>2]|0)!=0){t[M>>2]=KD(22)|0;if(t[M>>2]|0){g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2];qe=571}else qe=583}else qe=571;break}case 24:{t[N>>2]=Vg(t[p>>2]|0,1)|0;if((t[N>>2]|0)==0&(t[E>>2]|0)!=0){t[M>>2]=KD(24)|0;if(!(t[M>>2]|0)){qe=583;break e}g=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=g;t[t[E>>2]>>2]=t[M>>2]}if((t[N>>2]|0)==0&(t[S>>2]|0)!=0?(t[(t[S>>2]|0)+4>>2]|0)==2:0){t[ie>>2]=t[S>>2];t[re>>2]=uC(t[p>>2]|0)|0;g=t[(t[S>>2]|0)+32>>2]|0;if(t[re>>2]|0){WM(0,g,t[re>>2]|0,t[ie>>2]|0)|0;pAi[t[135736>>2]&511](t[re>>2]|0)}else WM(0,g,t[p>>2]|0,t[ie>>2]|0)|0;t[(t[ie>>2]|0)+40>>2]=3;qe=571}else qe=571;break}case 25:{t[N>>2]=tC(t[42834]|0,t[p>>2]|0,t[E>>2]|0,t[S>>2]|0)|0;if((t[N>>2]|0)<0)t[N>>2]=2;else t[N>>2]=0;if((t[N>>2]|0)==0&(t[S>>2]|0)!=0?(t[(t[S>>2]|0)+4>>2]|0)==2:0){t[ne>>2]=t[S>>2];t[(t[ne>>2]|0)+40>>2]=4;qe=571}else qe=571;break}case 26:{t[N>>2]=Vg(t[p>>2]|0,1)|0;if(!((t[S>>2]|0)!=0?(t[(t[S>>2]|0)+32>>2]|0)!=0:0))t[N>>2]=3;do if(!(t[N>>2]|0)){t[fe>>2]=uC(t[p>>2]|0)|0;g=t[(t[S>>2]|0)+32>>2]|0;if(t[fe>>2]|0){t[te>>2]=h_(g,t[fe>>2]|0)|0;pAi[t[135736>>2]&511](t[fe>>2]|0)}else t[te>>2]=h_(g,t[p>>2]|0)|0;if((t[te>>2]|0)!=0?(t[(t[te>>2]|0)+48>>2]|0)==3:0)break;t[N>>2]=4}while(0);if((t[N>>2]|0)==0&(t[E>>2]|0)!=0){g=t[33976]|0;w=t[33980]|0;t[v>>2]=171992;t[v+4>>2]=2831;yAi[g&511](w,171960,v)}if((t[N>>2]|0)==0&(t[S>>2]|0)!=0?(t[(t[S>>2]|0)+4>>2]|0)==2:0){t[ue>>2]=t[S>>2];t[(t[ue>>2]|0)+40>>2]=5;qe=571}else qe=571;break}case 27:{if((t[S>>2]|0)!=0?(t[(t[S>>2]|0)+32>>2]|0)!=0:0){
	t[N>>2]=tC(t[42838]|0,t[p>>2]|0,t[E>>2]|0,t[S>>2]|0)|0;if((t[N>>2]|0)<=0)t[N>>2]=1;else t[N>>2]=0;if(!((t[N>>2]|0)==0&(t[S>>2]|0)!=0)){qe=571;break e}if((t[(t[S>>2]|0)+4>>2]|0)!=2){qe=571;break e}t[ae>>2]=t[S>>2];t[(t[ae>>2]|0)+40>>2]=6;qe=571;break e}if(t[R>>2]|0)pAi[t[135736>>2]&511](t[R>>2]|0);t[m>>2]=3;Ve=t[m>>2]|0;s=d;return Ve|0}case 28:{t[oe>>2]=0;t[ce>>2]=0;t[N>>2]=qg(t[p>>2]|0,1)|0;if((t[N>>2]|0)==0&(t[S>>2]|0)!=0){t[ce>>2]=zg(t[p>>2]|0,le)|0;do if(t[le>>2]|0){t[se>>2]=wF(t[(t[S>>2]|0)+32>>2]|0,t[S>>2]|0,t[le>>2]|0)|0;if(!(t[se>>2]|0)){t[N>>2]=1;break}if(t[E>>2]|0)t[oe>>2]=Yl(t[(t[se>>2]|0)+8>>2]|0)|0}while(0);if((t[ce>>2]|0)!=0?(t[E>>2]|0)==0|(t[N>>2]|0)!=0:0)pAi[t[135736>>2]&511](t[ce>>2]|0);if(t[le>>2]|0)pAi[t[135736>>2]&511](t[le>>2]|0)}if(!((t[S>>2]|0)!=0?(t[(t[S>>2]|0)+32>>2]|0)!=0:0))t[N>>2]=3;do if(!(t[N>>2]|0)){t[N>>2]=eR(0,t[(t[S>>2]|0)+32>>2]|0,t[p>>2]|0)|0;if((t[N>>2]|0)==1){t[N>>2]=0;break}else{t[N>>2]=1;break}}while(0);if((t[N>>2]|0)==0&(t[E>>2]|0)!=0){t[M>>2]=KD(28)|0;w=(t[ce>>2]|0)!=0;if(!(t[M>>2]|0)){if(w)pAi[t[135736>>2]&511](t[ce>>2]|0);if(!(t[oe>>2]|0)){qe=583;break e}pAi[t[135736>>2]&511](t[oe>>2]|0);qe=583;break e}if(w)t[(t[M>>2]|0)+8>>2]=t[ce>>2];else{w=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=w}if(t[oe>>2]|0)t[(t[M>>2]|0)+12>>2]=t[oe>>2];t[t[E>>2]>>2]=t[M>>2];qe=571}else qe=571;break}case 29:{if(u[t[p>>2]>>0]|0){if((t[F>>2]|0)!=0?(t[R>>2]=TD(t[p>>2]|0)|0,(t[R>>2]|0)!=0):0)t[p>>2]=t[R>>2];t[ke>>2]=Yl(t[p>>2]|0)|0;t[he>>2]=t[ke>>2];while(1){if(!(n[t[he>>2]>>0]|0))break;do if((((((((u[t[he>>2]>>0]|0)>=32?(u[t[he>>2]>>0]|0)<127:0)?(u[t[he>>2]>>0]|0)!=32:0)?(u[t[he>>2]>>0]|0)!=60:0)?(u[t[he>>2]>>0]|0)!=62:0)?(u[t[he>>2]>>0]|0)!=34:0)?(u[t[he>>2]>>0]|0)!=123:0)?(u[t[he>>2]>>0]|0)!=125:0){if((u[t[he>>2]>>0]|0)==124){qe=409;break}if((u[t[he>>2]>>0]|0)==92){qe=409;break}if((u[t[he>>2]>>0]|0)==94){qe=409;break}if((u[t[he>>2]>>0]|0)==96){qe=409;break}if((u[t[he>>2]>>0]|0)==39)qe=409}else qe=409;while(0);if((qe|0)==409){qe=0;n[t[he>>2]>>0]=95}t[he>>2]=(t[he>>2]|0)+1}t[be>>2]=IA(t[ke>>2]|0)|0;pAi[t[135736>>2]&511](t[ke>>2]|0);if(!(t[be>>2]|0)){qe=577;break e}xA(t[be>>2]|0)}if(t[E>>2]|0){t[M>>2]=KD(29)|0;if(!(t[M>>2]|0))qe=583;else{w=Yl(t[p>>2]|0)|0;t[(t[M>>2]|0)+8>>2]=w;t[t[E>>2]>>2]=t[M>>2];qe=580}}else qe=580;break}case 43:{t[we>>2]=t[p>>2];t[_e>>2]=0;if(t[we>>2]|0){i:do if(t[F>>2]|0)while(1){do if((u[t[we>>2]>>0]|0)!=32){if(9<=(u[t[we>>2]>>0]|0)?(u[t[we>>2]>>0]|0)<=10:0)break;if((u[t[we>>2]>>0]|0)!=13)break i}while(0);t[we>>2]=(t[we>>2]|0)+1}while(0);t[de>>2]=t[we>>2];i:while(1){if(!((u[t[we>>2]>>0]|0)>=48?(u[t[we>>2]>>0]|0)<=57:0))qe=426;do if((qe|0)==426){qe=0;if((u[t[we>>2]>>0]|0)>=65?(u[t[we>>2]>>0]|0)<=70:0)break;if((u[t[we>>2]>>0]|0)<97)break i;if((u[t[we>>2]>>0]|0)>102)break i}while(0);t[_e>>2]=(t[_e>>2]|0)+1;t[we>>2]=(t[we>>2]|0)+1}i:do if(t[F>>2]|0)while(1){do if((u[t[we>>2]>>0]|0)!=32){if(9<=(u[t[we>>2]>>0]|0)?(u[t[we>>2]>>0]|0)<=10:0)break;if((u[t[we>>2]>>0]|0)!=13)break i}while(0);t[we>>2]=(t[we>>2]|0)+1}while(0);if((u[t[we>>2]>>0]|0)==0?((t[_e>>2]|0)%2|0|0)==0:0)if(t[E>>2]|0){t[M>>2]=KD(43)|0;if(!(t[M>>2]|0))qe=583;else{t[we>>2]=ql(t[de>>2]|0,t[_e>>2]|0)|0;if(!(t[we>>2]|0)){WD(t[S>>2]|0,172232);pAi[t[135736>>2]&511](t[M>>2]|0);qe=577;break e}t[me>>2]=(t[_e>>2]|0)/2|0;t[ve>>2]=t[we>>2];while(1){w=t[_e>>2]|0;t[_e>>2]=w+-1;if((w|0)<=0)break;if((u[t[ve>>2]>>0]|0)>=97)n[t[ve>>2]>>0]=(u[t[ve>>2]>>0]|0)-32;t[ve>>2]=(t[ve>>2]|0)+1}t[(t[M>>2]|0)+8>>2]=t[we>>2];t[(t[M>>2]|0)+12>>2]=t[me>>2];t[t[E>>2]>>2]=t[M>>2];qe=580}}else qe=580;else qe=577}else qe=577;break}case 44:{t[pe>>2]=t[p>>2];t[ge>>2]=0;t[ye>>2]=0;if(t[pe>>2]|0){while(1){if(!(n[t[pe>>2]>>0]|0))break;t[Fe>>2]=aC(n[t[pe>>2]>>0]|0)|0;if((t[Fe>>2]|0)>=0){if((t[Fe>>2]|0)>=64)break;t[ge>>2]=(t[ge>>2]|0)+1}t[pe>>2]=(t[pe>>2]|0)+1}while(1){if(!(n[t[pe>>2]>>0]|0))break;t[Oe>>2]=aC(n[t[pe>>2]>>0]|0)|0;if((t[Oe>>2]|0)>=0&(t[Oe>>2]|0)<64){qe=577;break e}if((t[Oe>>2]|0)==64)t[ye>>2]=(t[ye>>2]|0)+1;t[pe>>2]=(t[pe>>2]|0)+1}t[Se>>2]=((t[ge>>2]|0)/4|0)*3;do if(!(t[ye>>2]|0)){if((t[ge>>2]|0)%4|0){qe=577;break e}}else{if((t[ye>>2]|0)==1){if(((t[ge>>2]|0)%4|0|0)!=3){qe=577;break e}t[Ae>>2]=aC(n[t[pe>>2]>>0]|0)|0;while(1){if(!((t[Ae>>2]|0)<0|(t[Ae>>2]|0)>63))break;t[pe>>2]=(t[pe>>2]|0)+-1;t[Ae>>2]=aC(n[t[pe>>2]>>0]|0)|0}if(t[Ae>>2]&-61){qe=577;break e}t[Se>>2]=(t[Se>>2]|0)+2;break}if((t[ye>>2]|0)!=2){qe=577;break e}if(((t[ge>>2]|0)%4|0|0)!=2){qe=577;break e}t[Me>>2]=aC(n[t[pe>>2]>>0]|0)|0;while(1){if(!((t[Me>>2]|0)<0|(t[Me>>2]|0)>63))break;t[pe>>2]=(t[pe>>2]|0)+-1;t[Me>>2]=aC(n[t[pe>>2]>>0]|0)|0}if(t[Me>>2]&-49){qe=577;break e}t[Se>>2]=(t[Se>>2]|0)+1}while(0);if(t[E>>2]|0){t[M>>2]=KD(44)|0;if(!(t[M>>2]|0))qe=583;else{t[Ee>>2]=gAi[t[135752>>2]&511]((t[ge>>2]|0)+(t[ye>>2]|0)+1|0)|0;if(!(t[Ee>>2]|0)){WD(t[S>>2]|0,172256);pAi[t[135736>>2]&511](t[M>>2]|0);qe=577;break e}t[(t[M>>2]|0)+8>>2]=t[Ee>>2];t[pe>>2]=t[p>>2];while(1){if(!(n[t[pe>>2]>>0]|0))break;if((aC(n[t[pe>>2]>>0]|0)|0)>=0){n[t[Ee>>2]>>0]=n[t[pe>>2]>>0]|0;t[Ee>>2]=(t[Ee>>2]|0)+1}t[pe>>2]=(t[pe>>2]|0)+1}n[t[Ee>>2]>>0]=0;t[(t[M>>2]|0)+12>>2]=t[Se>>2];t[t[E>>2]>>2]=t[M>>2];qe=580}}else qe=580}else qe=577;break}case 33:case 32:case 31:case 34:case 30:{t[Re>>2]=t[p>>2];t[De>>2]=0;if(t[Re>>2]|0){i:do if(t[F>>2]|0)while(1){do if((u[t[Re>>2]>>0]|0)!=32){if(9<=(u[t[Re>>2]>>0]|0)?(u[t[Re>>2]>>0]|0)<=10:0)break;if((u[t[Re>>2]>>0]|0)!=13)break i}while(0);t[Re>>2]=(t[Re>>2]|0)+1}while(0);if((u[t[Re>>2]>>0]|0)!=45){if((u[t[Re>>2]>>0]|0)==43)t[Re>>2]=(t[Re>>2]|0)+1}else{t[De>>2]=1;t[Re>>2]=(t[Re>>2]|0)+1}t[N>>2]=rC(Re,Ne,Te,Le)|0;if((t[N>>2]|0)>=0){i:do if(t[F>>2]|0)while(1){do if((u[t[Re>>2]>>0]|0)!=32){if(9<=(u[t[Re>>2]>>0]|0)?(u[t[Re>>2]>>0]|0)<=10:0)break;if((u[t[Re>>2]>>0]|0)!=13)break i}while(0);t[Re>>2]=(t[Re>>2]|0)+1}while(0);if(!(u[t[Re>>2]>>0]|0)){do if((t[(t[_>>2]|0)+88>>2]|0)==31){if((t[De>>2]|0)==0?(t[Le>>2]|0)!=0|(t[Te>>2]|0)!=0|(t[Ne>>2]|0)!=0:0){qe=577;break e}}else{if((t[(t[_>>2]|0)+88>>2]|0)==34){if((t[De>>2]|0)==1){qe=577;break e}if((t[Le>>2]|0)==0&(t[Te>>2]|0)==0&(t[Ne>>2]|0)==0){qe=577;break e}else break}if((t[(t[_>>2]|0)+88>>2]|0)==32){if(!(t[De>>2]|0)){qe=577;break e}if((t[Le>>2]|0)==0&(t[Te>>2]|0)==0&(t[Ne>>2]|0)==0){qe=577;break e}else break}else{if(!((t[De>>2]|0)==1?(t[(t[_>>2]|0)+88>>2]|0)==33:0))break;if((t[Le>>2]|0)!=0|(t[Te>>2]|0)!=0|(t[Ne>>2]|0)!=0){qe=577;break e}else break}}while(0);if((t[E>>2]|0)!=0?(t[M>>2]=KD(t[(t[_>>2]|0)+88>>2]|0)|0,(t[M>>2]|0)!=0):0){if(!(t[N>>2]|0))t[N>>2]=(t[N>>2]|0)+1;t[(t[M>>2]|0)+8>>2]=t[Ne>>2];t[(t[M>>2]|0)+12>>2]=t[Te>>2];t[(t[M>>2]|0)+16>>2]=t[Le>>2];w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&-2|t[De>>2]&1;w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&-255;w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&255|(t[N>>2]&255)<<8&65535;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=580}else qe=577}else qe=577}else qe=577;break}case 35:case 39:case 41:case 37:{t[Ce>>2]=t[p>>2];t[He>>2]=0;if(t[Ce>>2]|0){if((u[t[Ce>>2]>>0]|0)!=45){if((u[t[Ce>>2]>>0]|0)==43)t[Ce>>2]=(t[Ce>>2]|0)+1}else{t[He>>2]=1;t[Ce>>2]=(t[Ce>>2]|0)+1}t[N>>2]=rC(Ce,Pe,Be,Ie)|0;if((t[N>>2]|0)>=0?(u[t[Ce>>2]>>0]|0)==0:0){do if((t[(t[_>>2]|0)+88>>2]|0)==37){if((t[Ie>>2]|0)>>>0>=922){if((t[Ie>>2]|0)>>>0>922){qe=577;break e}if((t[Be>>2]|0)>>>0>=33720368){if((t[Be>>2]|0)>>>0>33720368){qe=577;break e}if((t[He>>2]|0)==0&(t[Pe>>2]|0)>>>0>54775807){qe=577;break e}if((t[He>>2]|0)==1&(t[Pe>>2]|0)>>>0>54775808){qe=577;break e}}}}else{if((t[(t[_>>2]|0)+88>>2]|0)==35){if(t[Ie>>2]|0){qe=577;break e}if((t[Be>>2]|0)>>>0<21)break;if((t[Be>>2]|0)>>>0>21){qe=577;break e}if((t[He>>2]|0)==0&(t[Pe>>2]|0)>>>0>47483647){qe=577;break e}if((t[He>>2]|0)==1&(t[Pe>>2]|0)>>>0>47483648){qe=577;break e}else break}if((t[(t[_>>2]|0)+88>>2]|0)==39){if((t[Be>>2]|0)!=0|(t[Ie>>2]|0)!=0){qe=577;break e}if((t[He>>2]|0)==1&(t[Pe>>2]|0)>>>0>32768){qe=577;break e}if((t[He>>2]|0)==0&(t[Pe>>2]|0)>>>0>32767){qe=577;break e}else break}if((t[(t[_>>2]|0)+88>>2]|0)==41){if((t[Be>>2]|0)!=0|(t[Ie>>2]|0)!=0){qe=577;break e}if((t[He>>2]|0)==1&(t[Pe>>2]|0)>>>0>128){qe=577;break e}if((t[He>>2]|0)==0&(t[Pe>>2]|0)>>>0>127){qe=577;break e}}}while(0);if((t[E>>2]|0)!=0?(t[M>>2]=KD(t[(t[_>>2]|0)+88>>2]|0)|0,(t[M>>2]|0)!=0):0){t[(t[M>>2]|0)+8>>2]=t[Pe>>2];t[(t[M>>2]|0)+12>>2]=t[Be>>2];t[(t[M>>2]|0)+16>>2]=t[Ie>>2];w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&-2|t[He>>2]&1;w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&-255;w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&255|(t[N>>2]&255)<<8&65535;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=580}else qe=577}else qe=577;break}case 42:case 40:case 38:case 36:{t[xe>>2]=t[p>>2];if(((t[xe>>2]|0)!=0?(t[N>>2]=rC(xe,Ue,ze,je)|0,(t[N>>2]|0)>=0):0)?(u[t[xe>>2]>>0]|0)==0:0){do if((t[(t[_>>2]|0)+88>>2]|0)==38){if((t[je>>2]|0)>>>0>=1844){if((t[je>>2]|0)>>>0>1844){qe=577;break e}if((t[ze>>2]|0)>>>0>=67440737?(t[ze>>2]|0)>>>0>67440737|(t[Ue>>2]|0)>>>0>9551615:0){qe=577;break e}}}else{if((t[(t[_>>2]|0)+88>>2]|0)==36){if(t[je>>2]|0){qe=577;break e}if((t[ze>>2]|0)>>>0<42)break;if((t[ze>>2]|0)>>>0>42|(t[Ue>>2]|0)>>>0>94967295){qe=577;break e}else break}if((t[(t[_>>2]|0)+88>>2]|0)==40)if((t[ze>>2]|0)!=0|(t[je>>2]|0)!=0|(t[Ue>>2]|0)>>>0>65535){qe=577;break e}else break;if((t[(t[_>>2]|0)+88>>2]|0)==42?(t[ze>>2]|0)!=0|(t[je>>2]|0)!=0|(t[Ue>>2]|0)>>>0>255:0){qe=577;break e}}while(0);if((t[E>>2]|0)!=0?(t[M>>2]=KD(t[(t[_>>2]|0)+88>>2]|0)|0,(t[M>>2]|0)!=0):0){t[(t[M>>2]|0)+8>>2]=t[Ue>>2];t[(t[M>>2]|0)+12>>2]=t[ze>>2];t[(t[M>>2]|0)+16>>2]=t[je>>2];w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&-2;w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&-255;w=(t[M>>2]|0)+24|0;f[w>>1]=f[w>>1]&255|(t[N>>2]&255)<<8&65535;t[t[E>>2]>>2]=t[M>>2];qe=580}else qe=580}else qe=577;break}case 0:{qe=583;break}default:qe=571}while(0);if((qe|0)==571){if(t[R>>2]|0)pAi[t[135736>>2]&511](t[R>>2]|0);t[m>>2]=t[N>>2];Ve=t[m>>2]|0;s=d;return Ve|0}else if((qe|0)==577){if(t[R>>2]|0)pAi[t[135736>>2]&511](t[R>>2]|0);t[m>>2]=1;Ve=t[m>>2]|0;s=d;return Ve|0}else if((qe|0)==580){if(t[R>>2]|0)pAi[t[135736>>2]&511](t[R>>2]|0);t[m>>2]=0;Ve=t[m>>2]|0;s=d;return Ve|0}else if((qe|0)==583){if(t[R>>2]|0)pAi[t[135736>>2]&511](t[R>>2]|0);t[m>>2]=-1;Ve=t[m>>2]|0;s=d;return Ve|0}return 0}function ZD(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=KD(t[t[n>>2]>>2]|0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=t[f>>2]|0;a=t[n>>2]|0;t[e+0>>2]=t[a+0>>2];t[e+4>>2]=t[a+4>>2];t[e+8>>2]=t[a+8>>2];t[e+12>>2]=t[a+12>>2];t[e+16>>2]=t[a+16>>2];t[e+20>>2]=t[a+20>>2];t[e+24>>2]=t[a+24>>2];t[e+28>>2]=t[a+28>>2];t[(t[f>>2]|0)+4>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function JD(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;c=s;s=s+64|0;l=c;b=c+56|0;k=c+52|0;h=c+48|0;w=c+44|0;d=c+40|0;v=c+36|0;m=c+32|0;_=c+28|0;p=c+24|0;E=c+20|0;S=c+16|0;g=c+12|0;y=c+8|0;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=n;t[v>>2]=f;t[m>>2]=u;t[_>>2]=a;t[p>>2]=o;e:do switch(t[k>>2]|0){case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)==11|(t[v>>2]|0)==4|(t[v>>2]|0)==5|(t[v>>2]|0)==6|(t[v>>2]|0)==7|(t[v>>2]|0)==8|(t[v>>2]|0)==10|(t[v>>2]|0)==9){t[b>>2]=lC(t[h>>2]|0,t[m>>2]|0)|0;break e}else{t[b>>2]=-2;break e}break}case 12:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)==12){t[b>>2]=cC(t[h>>2]|0,t[m>>2]|0)|0;break e}else{t[b>>2]=-2;break e}break}case 28:case 21:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if(!((t[v>>2]|0)==21|(t[v>>2]|0)==28)){t[b>>2]=-2;break e}if((Xl(t[(t[h>>2]|0)+8>>2]|0,t[(t[m>>2]|0)+8>>2]|0)|0)!=0?(Xl(t[(t[h>>2]|0)+12>>2]|0,t[(t[m>>2]|0)+12>>2]|0)|0)!=0:0){t[b>>2]=0;break e}t[b>>2]=2;break}case 3:case 42:case 41:case 40:case 39:case 38:case 37:case 36:case 35:case 34:case 33:case 32:case 31:case 30:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)==(t[k>>2]|0)){t[b>>2]=oC(t[h>>2]|0,t[m>>2]|0)|0;break e}if((t[v>>2]|0)==3|(t[v>>2]|0)==30|(t[v>>2]|0)==31|(t[v>>2]|0)==32|(t[v>>2]|0)==33|(t[v>>2]|0)==34|(t[v>>2]|0)==35|(t[v>>2]|0)==36|(t[v>>2]|0)==37|(t[v>>2]|0)==38|(t[v>>2]|0)==39|(t[v>>2]|0)==40|(t[v>>2]|0)==41|(t[v>>2]|0)==42){t[b>>2]=oC(t[h>>2]|0,t[m>>2]|0)|0;break e}else{t[b>>2]=-2;break e}break}case 14:case 13:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)==13|(t[v>>2]|0)==14){t[b>>2]=dC(t[h>>2]|0,t[m>>2]|0)|0;break e}else{t[b>>2]=-2;break e}break}case 44:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)!=44){t[b>>2]=-2;break e}o=(t[h>>2]|0)+8|0;if((t[(t[h>>2]|0)+12>>2]|0)!=(t[(t[m>>2]|0)+12>>2]|0))if((t[o+4>>2]|0)>>>0>(t[(t[m>>2]|0)+12>>2]|0)>>>0){t[b>>2]=1;break e}else{t[b>>2]=-1;break e}t[y>>2]=Kl(t[o>>2]|0,t[(t[m>>2]|0)+8>>2]|0)|0;if((t[y>>2]|0)>0){t[b>>2]=1;break e}if(!(t[y>>2]|0)){t[b>>2]=0;break e}else{t[b>>2]=-1;break e}break}case 29:case 26:case 24:case 23:case 22:case 20:case 18:case 17:case 16:case 2:case 1:case 46:{if(!(t[h>>2]|0))t[E>>2]=t[w>>2];else t[E>>2]=t[(t[h>>2]|0)+8>>2];if(!(t[m>>2]|0))t[S>>2]=t[_>>2];else t[S>>2]=t[(t[m>>2]|0)+8>>2];if((t[v>>2]|0)==21){o=t[33976]|0;a=t[33980]|0;t[l>>2]=171992;t[l+4>>2]=4781;yAi[o&511](a,171960,l);t[b>>2]=-2;break e}do if((t[v>>2]|0)==46|(t[v>>2]|0)==1|(t[v>>2]|0)==2|(t[v>>2]|0)==16|(t[v>>2]|0)==17|(t[v>>2]|0)==18|(t[v>>2]|0)==20|(t[v>>2]|0)==22|(t[v>>2]|0)==23|(t[v>>2]|0)==24|(t[v>>2]|0)==26|(t[v>>2]|0)==29){if((t[d>>2]|0)==1){if((t[p>>2]|0)==1)if(Xl(t[E>>2]|0,t[S>>2]|0)|0){t[b>>2]=0;break e}else{t[b>>2]=2;break e}if((t[p>>2]|0)==2){t[b>>2]=sC(t[E>>2]|0,t[S>>2]|0,0)|0;break e}if((t[p>>2]|0)!=3)break;t[b>>2]=bC(t[E>>2]|0,t[S>>2]|0,0)|0;break e}if((t[d>>2]|0)==2){if((t[p>>2]|0)==1){t[b>>2]=sC(t[S>>2]|0,t[E>>2]|0,1)|0;break e}if((t[p>>2]|0)==2){t[b>>2]=kC(t[E>>2]|0,t[S>>2]|0)|0;break e}if((t[p>>2]|0)!=3)break;t[b>>2]=hC(t[E>>2]|0,t[S>>2]|0,0)|0;break e}if((t[d>>2]|0)!=3){t[b>>2]=-2;break e}if((t[p>>2]|0)==1){t[b>>2]=bC(t[S>>2]|0,t[E>>2]|0,1)|0;break e}if((t[p>>2]|0)==2){t[b>>2]=hC(t[S>>2]|0,t[E>>2]|0,1)|0;break e}if((t[p>>2]|0)==3){t[b>>2]=wC(t[E>>2]|0,t[S>>2]|0)|0;break e}}while(0);t[b>>2]=-2;break}case 45:case 0:{t[b>>2]=-2;break}case 19:case 27:case 25:{a=t[33976]|0;o=t[33980]|0;t[l>>2]=171992;t[l+4>>2]=4906;yAi[a&511](o,171960,l);F=102;break}case 43:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)!=43){t[b>>2]=-2;break e}o=(t[h>>2]|0)+8|0;if((t[(t[h>>2]|0)+12>>2]|0)==(t[(t[m>>2]|0)+12>>2]|0)){t[g>>2]=Kl(t[o>>2]|0,t[(t[m>>2]|0)+8>>2]|0)|0;if((t[g>>2]|0)>0){t[b>>2]=1;break e}if(!(t[g>>2]|0)){t[b>>2]=0;break e}}else if((t[o+4>>2]|0)>>>0>(t[(t[m>>2]|0)+12>>2]|0)>>>0){t[b>>2]=1;break e}t[b>>2]=-1;break}case 15:{if((t[h>>2]|0)==0|(t[m>>2]|0)==0){t[b>>2]=-2;break e}if((t[v>>2]|0)!=15){t[b>>2]=-2;break e}if((t[(t[h>>2]|0)+8>>2]|0)==(t[(t[m>>2]|0)+8>>2]|0)){t[b>>2]=0;break e}if(!(t[(t[h>>2]|0)+8>>2]|0)){t[b>>2]=-1;break e}else{t[b>>2]=1;break e}break}default:F=102}while(0);if((F|0)==102)t[b>>2]=-2;s=c;return t[b>>2]|0}function QD(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;o=s;s=s+48|0;c=o;l=o+40|0;b=o+36|0;k=o+32|0;h=o+28|0;w=o+24|0;d=o+20|0;v=o+16|0;m=o+12|0;_=o+8|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;e:do if(!(t[b>>2]|0))t[l>>2]=-1;else{i:do switch(t[t[b>>2]>>2]|0){case 1008:{t[l>>2]=0;break e;break}case 1006:{if(!(t[w>>2]|0)){t[l>>2]=-1;break e}t[m>>2]=eb(t[(t[b>>2]|0)+36>>2]|0,t[w>>2]|0)|0;if((t[m>>2]|0)==1){t[l>>2]=0;break e}if(!(t[m>>2]|0)){t[l>>2]=1839;break e}else{t[l>>2]=t[m>>2];break e}break}case 1007:{u=t[b>>2]|0;if(!(t[v>>2]|0)){if((t[u+8>>2]|0)!=0?(Xl(t[(t[b>>2]|0)+8>>2]|0,t[w>>2]|0)|0)!=0:0){t[l>>2]=0;break e}}else{t[m>>2]=vC(t[t[u+32>>2]>>2]|0,t[(t[b>>2]|0)+32>>2]|0,t[(t[b>>2]|0)+8>>2]|0,t[k>>2]|0,t[h>>2]|0,t[d>>2]|0,t[w>>2]|0,t[v>>2]|0)|0;if((t[m>>2]|0)==-2){t[l>>2]=-1;break e}if(!(t[m>>2]|0)){t[l>>2]=0;break e}}t[l>>2]=1840;break e;break}case 1011:case 1010:{p=43;break}case 1009:{if((t[h>>2]|0)==21|(t[h>>2]|0)==28){t[l>>2]=0;break e}else p=43;break}case 1005:case 1004:{do if(t[(t[b>>2]|0)+32>>2]|0){if((t[t[(t[b>>2]|0)+32>>2]>>2]|0)!=34?(t[t[(t[b>>2]|0)+32>>2]>>2]|0)!=33:0)break;if(!((a[(t[(t[b>>2]|0)+32>>2]|0)+24>>1]|0)>>>1&127)){r:do if(t[d>>2]|0){do if((((((((((t[t[d>>2]>>2]|0)!=3?(t[t[d>>2]>>2]|0)!=30:0)?(t[t[d>>2]>>2]|0)!=31:0)?(t[t[d>>2]>>2]|0)!=32:0)?(t[t[d>>2]>>2]|0)!=33:0)?(t[t[d>>2]>>2]|0)!=34:0)?(t[t[d>>2]>>2]|0)!=35:0)?(t[t[d>>2]>>2]|0)!=36:0)?(t[t[d>>2]>>2]|0)!=37:0)?(t[t[d>>2]>>2]|0)!=38:0){if((t[t[d>>2]>>2]|0)==39)break;if((t[t[d>>2]>>2]|0)==40)break;if((t[t[d>>2]>>2]|0)==41)break;if((t[t[d>>2]>>2]|0)!=42)break r}while(0);if((t[t[b>>2]>>2]|0)==1004){if(((a[(t[d>>2]|0)+24>>1]|0)>>>8&65535)>>>0<=(t[(t[(t[b>>2]|0)+32>>2]|0)+8>>2]|0)>>>0)break i;t[l>>2]=1837;break e}if((t[t[b>>2]>>2]|0)!=1005)break i;if(((a[(t[d>>2]|0)+24>>1]|0)>>>1&127)>>>0<=(t[(t[(t[b>>2]|0)+32>>2]|0)+8>>2]|0)>>>0)break i;t[l>>2]=1838;break e}while(0);t[l>>2]=-1;break e}}while(0);t[l>>2]=-1;break e;break}case 1e3:{t[m>>2]=BD(t[d>>2]|0,t[(t[b>>2]|0)+32>>2]|0)|0;if((t[m>>2]|0)==-2){t[l>>2]=-1;break e}if((t[m>>2]|0)==1|(t[m>>2]|0)==0){t[l>>2]=0;break e}else{t[l>>2]=1833;break e}break}case 1002:{t[m>>2]=BD(t[d>>2]|0,t[(t[b>>2]|0)+32>>2]|0)|0;if((t[m>>2]|0)==-2){t[l>>2]=-1;break e}if((t[m>>2]|0)==-1|(t[m>>2]|0)==0){t[l>>2]=0;break e}else{t[l>>2]=1834;break e}break}case 1001:{t[m>>2]=BD(t[d>>2]|0,t[(t[b>>2]|0)+32>>2]|0)|0;if((t[m>>2]|0)==-2){t[l>>2]=-1;break e}if((t[m>>2]|0)==1){t[l>>2]=0;break e}else{t[l>>2]=1835;break e}break}case 1003:{t[m>>2]=BD(t[d>>2]|0,t[(t[b>>2]|0)+32>>2]|0)|0;if((t[m>>2]|0)==-2){t[l>>2]=-1;break e}if((t[m>>2]|0)==-1){t[l>>2]=0;break e}else{t[l>>2]=1836;break e}break}default:{u=t[33976]|0;f=t[33980]|0;t[c>>2]=171992;t[c+4>>2]=5498;yAi[u&511](f,171960,c)}}while(0);i:do if((p|0)==43){t[_>>2]=0;if((t[h>>2]|0)==21|(t[h>>2]|0)==28){t[l>>2]=0;break e}do if(t[(t[b>>2]|0)+32>>2]|0){if((t[t[(t[b>>2]|0)+32>>2]>>2]|0)!=3?(t[t[(t[b>>2]|0)+32>>2]>>2]|0)!=33:0)break;if(!((a[(t[(t[b>>2]|0)+32>>2]|0)+24>>1]|0)>>>1&127)){if((t[d>>2]|0)!=0?(t[t[d>>2]>>2]|0)==43:0)t[_>>2]=t[(t[d>>2]|0)+12>>2];else p=53;r:do if((p|0)==53){if((t[d>>2]|0)!=0?(t[t[d>>2]>>2]|0)==44:0){t[_>>2]=t[(t[d>>2]|0)+12>>2];break}switch(t[h>>2]|0){case 29:case 23:case 22:case 20:case 18:case 17:case 16:case 24:{if(!(t[w>>2]|0))break r;t[_>>2]=mC(t[w>>2]|0)|0;break r;break}case 2:case 1:{if(!(t[v>>2]|0)){f=t[w>>2]|0;if((t[h>>2]|0)==1){t[_>>2]=os(f)|0;break r}else{t[_>>2]=mC(f)|0;break r}}if(!(t[w>>2]|0))break r;f=t[w>>2]|0;if((t[v>>2]|0)==3){t[_>>2]=mC(f)|0;break r}else{t[_>>2]=os(f)|0;break r}break}default:{f=t[33976]|0;u=t[33980]|0;t[c>>2]=171992;t[c+4>>2]=5447;yAi[f&511](u,171960,c);break r}}}while(0);if((t[t[b>>2]>>2]|0)==1009){if((t[_>>2]|0)==(t[(t[(t[b>>2]|0)+32>>2]|0)+8>>2]|0))break i;t[l>>2]=1830;break e}u=t[_>>2]|0;f=t[(t[(t[b>>2]|0)+32>>2]|0)+8>>2]|0;if((t[t[b>>2]>>2]|0)==1011){if(u>>>0>=f>>>0)break i;t[l>>2]=1831;break e}else{if(u>>>0<=f>>>0)break i;t[l>>2]=1832;break e}}}while(0);t[l>>2]=-1;break e}while(0);t[l>>2]=0}while(0);s=o;return t[l>>2]|0}function $D(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;o=s;s=s+48|0;c=o;l=o+36|0;b=o+32|0;k=o+28|0;h=o+24|0;w=o+20|0;d=o+16|0;v=o+12|0;m=o+8|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=0;if((t[d>>2]|0)==0|(t[b>>2]|0)==0){t[l>>2]=-1;_=t[l>>2]|0;s=o;return _|0}t[t[d>>2]>>2]=0;if(((t[t[b>>2]>>2]|0)!=1009?(t[t[b>>2]>>2]|0)!=1010:0)?(t[t[b>>2]>>2]|0)!=1011:0){t[l>>2]=-1;_=t[l>>2]|0;s=o;return _|0}do if(t[(t[b>>2]|0)+32>>2]|0){if((t[t[(t[b>>2]|0)+32>>2]>>2]|0)!=3?(t[t[(t[b>>2]|0)+32>>2]>>2]|0)!=33:0)break;if(!((a[(t[(t[b>>2]|0)+32>>2]|0)+24>>1]|0)>>>1&127)){if((t[w>>2]|0)!=0?(t[t[w>>2]>>2]|0)==43:0)t[m>>2]=t[(t[w>>2]|0)+12>>2];else p=15;e:do if((p|0)==15){if((t[w>>2]|0)!=0?(t[t[w>>2]>>2]|0)==44:0){t[m>>2]=t[(t[w>>2]|0)+12>>2];break}switch(t[k>>2]|0){case 28:case 21:{t[l>>2]=0;_=t[l>>2]|0;s=o;return _|0}case 29:case 23:case 22:case 20:case 18:case 17:case 16:case 24:{if(!(t[h>>2]|0))break e;t[m>>2]=mC(t[h>>2]|0)|0;break e;break}case 2:case 1:{if(!(t[v>>2]|0)){u=t[h>>2]|0;if((t[k>>2]|0)==1){t[m>>2]=os(u)|0;break e}else{t[m>>2]=mC(u)|0;break e}}if(!(t[h>>2]|0))break e;u=t[h>>2]|0;if((t[v>>2]|0)==3){t[m>>2]=mC(u)|0;break e}else{t[m>>2]=os(u)|0;break e}break}default:{u=t[33976]|0;f=t[33980]|0;t[c>>2]=171992;t[c+4>>2]=5207;yAi[u&511](f,171960,c);break e}}}while(0);t[t[d>>2]>>2]=t[m>>2];do if((t[t[b>>2]>>2]|0)==1009){if((t[m>>2]|0)!=(t[(t[(t[b>>2]|0)+32>>2]|0)+8>>2]|0)){t[l>>2]=1830;_=t[l>>2]|0;s=o;return _|0}}else{f=t[m>>2]|0;u=t[(t[(t[b>>2]|0)+32>>2]|0)+8>>2]|0;if((t[t[b>>2]>>2]|0)==1011){if(f>>>0>=u>>>0)break;t[l>>2]=1831;_=t[l>>2]|0;s=o;return _|0}else{if(f>>>0<=u>>>0)break;t[l>>2]=1832;_=t[l>>2]|0;s=o;return _|0}}while(0);t[l>>2]=0;_=t[l>>2]|0;s=o;return _|0}}while(0);t[l>>2]=-1;_=t[l>>2]|0;s=o;return _|0}function eC(e,i){e=e|0;i=+i;var r=0,n=0,u=0,a=0,o=0,c=0,b=0,k=0;r=s;s=s+32|0;n=r+20|0;u=r+16|0;a=r;o=r+12|0;c=r+8|0;t[u>>2]=e;l[a>>3]=i;if(!(t[u>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if(!(((t[t[u>>2]>>2]|0)!=4?(t[t[u>>2]>>2]|0)!=11:0)?(t[t[u>>2]>>2]|0)!=10:0))k=6;if((k|0)==6?((f[(t[u>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16|0)!=0:0){t[o>>2]=KD(12)|0;if(!(t[o>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}k=(t[o>>2]|0)+16|0;l[k>>3]=+l[k>>3]-+l[a>>3];t[c>>2]=_C(t[u>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}else{MD(t[o>>2]|0);t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}}t[n>>2]=ZD(t[u>>2]|0)|0;b=t[n>>2]|0;s=r;return b|0}function iC(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gk()|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[t[f>>2]>>2]=1011;e=KD(33)|0;t[(t[f>>2]|0)+32>>2]=e;if(!(t[(t[f>>2]|0)+32>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[(t[(t[f>>2]|0)+32>>2]|0)+8>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function rC(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;f=s;s=s+48|0;a=f+44|0;o=f+40|0;c=f+36|0;l=f+32|0;b=f+28|0;k=f+24|0;h=f+20|0;w=f+16|0;d=f+12|0;v=f+8|0;m=f+4|0;_=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=0;t[h>>2]=0;t[w>>2]=0;t[v>>2]=t[t[o>>2]>>2];t[m>>2]=0;t[_>>2]=0;if((u[t[v>>2]>>0]|0|0)>=48?(u[t[v>>2]>>0]|0|0)<=57:0){while(1){p=t[v>>2]|0;if((u[t[v>>2]>>0]|0|0)!=48)break;t[v>>2]=p+1}t[d>>2]=p;while(1){if((u[t[d>>2]>>0]|0|0)!=0?(u[t[d>>2]>>0]|0|0)>=48:0)E=(u[t[d>>2]>>0]|0|0)<=57;else E=0;S=t[_>>2]|0;if(!E)break;t[_>>2]=S+1;t[d>>2]=(t[d>>2]|0)+1;t[m>>2]=(t[m>>2]|0)+1}if((S|0)>24){t[t[o>>2]>>2]=t[d>>2];t[a>>2]=-1;g=t[a>>2]|0;s=f;return g|0}while(1){if((t[_>>2]|0)<=16)break;d=(t[w>>2]|0)*10|0;S=t[v>>2]|0;t[v>>2]=S+1;t[w>>2]=d+((u[S>>0]|0)-48);t[_>>2]=(t[_>>2]|0)+-1}while(1){if((t[_>>2]|0)<=8)break;S=(t[h>>2]|0)*10|0;d=t[v>>2]|0;t[v>>2]=d+1;t[h>>2]=S+((u[d>>0]|0)-48);t[_>>2]=(t[_>>2]|0)+-1}while(1){if((t[_>>2]|0)<=0)break;d=(t[k>>2]|0)*10|0;S=t[v>>2]|0;t[v>>2]=S+1;t[k>>2]=d+((u[S>>0]|0)-48);t[_>>2]=(t[_>>2]|0)+-1}t[t[o>>2]>>2]=t[v>>2];t[t[c>>2]>>2]=t[k>>2];t[t[l>>2]>>2]=t[h>>2];t[t[b>>2]>>2]=t[w>>2];t[a>>2]=t[m>>2];g=t[a>>2]|0;s=f;return g|0}t[a>>2]=-2;g=t[a>>2]|0;s=f;return g|0}function nC(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;a=s;s=s+48|0;o=a+32|0;c=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[v>>2]=t[b>>2];if(!(t[b>>2]|0)){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}e:do if(t[h>>2]|0)while(1){do if((u[t[v>>2]>>0]|0|0)!=32){if(9<=(u[t[v>>2]>>0]|0|0)?(u[t[v>>2]>>0]|0|0)<=10:0)break;if((u[t[v>>2]>>0]|0|0)!=13)break e}while(0);t[v>>2]=(t[v>>2]|0)+1}while(0);if(((u[t[v>>2]>>0]|0|0)!=45?(u[t[v>>2]>>0]|0|0)<48:0)?(u[t[v>>2]>>0]|0|0)>57:0){t[o>>2]=1;_=t[o>>2]|0;s=a;return _|0}t[w>>2]=KD(0)|0;if(!(t[w>>2]|0)){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}e:do if((u[t[v>>2]>>0]|0|0)==45?(u[(t[v>>2]|0)+1>>0]|0|0)==45:0){t[v>>2]=(t[v>>2]|0)+2;if((u[t[v>>2]>>0]|0|0)==45){if((t[c>>2]|0)==6)break;t[v>>2]=(t[v>>2]|0)+1;t[d>>2]=pC((t[w>>2]|0)+8|0,v)|0;if(t[d>>2]|0)break;if((((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)!=90:0)?(u[t[v>>2]>>0]|0|0)!=43:0)?(u[t[v>>2]>>0]|0|0)!=45:0)break;t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0;if(t[d>>2]|0)break;if(u[t[v>>2]>>0]|0)break;t[t[w>>2]>>2]=5;p=123;break}t[d>>2]=SC((t[w>>2]|0)+8|0,v)|0;if(!(t[d>>2]|0)){if((u[t[v>>2]>>0]|0|0)==45){t[m>>2]=t[v>>2];t[v>>2]=(t[v>>2]|0)+1;t[d>>2]=pC((t[w>>2]|0)+8|0,v)|0;do if(!(t[d>>2]|0)){if((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)==58:0)break;if(((t[(t[w>>2]|0)+8>>2]|0)%4|0|0)==0?((t[(t[w>>2]|0)+8>>2]|0)%100|0|0)!=0:0)p=35;else if((t[(t[w>>2]|0)+8>>2]|0)%400|0){if(((t[(t[w>>2]|0)+12>>2]|0)>>>4&31)>>>0>(t[171912+((t[(t[w>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0)break}else p=35;if((p|0)==35?((t[(t[w>>2]|0)+12>>2]|0)>>>4&31)>>>0>(t[171864+((t[(t[w>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0:0)break;if((((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)!=90:0)?(u[t[v>>2]>>0]|0|0)!=43:0)?(u[t[v>>2]>>0]|0|0)!=45:0)break e;t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0;if(t[d>>2]|0)break e;if(u[t[v>>2]>>0]|0)break e;t[t[w>>2]>>2]=7;p=123;break e}while(0);t[v>>2]=t[m>>2]}if((((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)!=90:0)?(u[t[v>>2]>>0]|0|0)!=43:0)?(u[t[v>>2]>>0]|0|0)!=45:0)break;t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0;if((t[d>>2]|0)==0?(u[t[v>>2]>>0]|0|0)==0:0){t[t[w>>2]>>2]=6;p=123}}}else p=52;while(0);e:do if((p|0)==52){do if(((u[t[v>>2]>>0]|0|0)>=48?(u[t[v>>2]>>0]|0|0)<=57:0)?(t[d>>2]=gC((t[w>>2]|0)+8|0,v)|0,(t[d>>2]|0)==0):0){if((((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)!=90:0)?(u[t[v>>2]>>0]|0|0)!=43:0)?(u[t[v>>2]>>0]|0|0)!=45:0)break;t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0;if(!(t[d>>2]|0)){if(u[t[v>>2]>>0]|0)break e;t[t[w>>2]>>2]=4;p=123;break e}}while(0);t[v>>2]=t[b>>2];t[d>>2]=yC((t[w>>2]|0)+8|0,v)|0;if(!(t[d>>2]|0)){if(!((((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)!=90:0)?(u[t[v>>2]>>0]|0|0)!=43:0)?(u[t[v>>2]>>0]|0|0)!=45:0))p=67;if((p|0)==67?(t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0,(t[d>>2]|0)==0):0){if(u[t[v>>2]>>0]|0)break;t[t[w>>2]>>2]=8;p=123;break}if((u[t[v>>2]>>0]|0|0)==45?(t[v>>2]=(t[v>>2]|0)+1,t[d>>2]=SC((t[w>>2]|0)+8|0,v)|0,(t[d>>2]|0)==0):0){if(!((((u[t[v>>2]>>0]|0|0)!=0?(u[t[v>>2]>>0]|0|0)!=90:0)?(u[t[v>>2]>>0]|0|0)!=43:0)?(u[t[v>>2]>>0]|0|0)!=45:0))p=76;if((p|0)==76?(t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0,(t[d>>2]|0)==0):0){if(u[t[v>>2]>>0]|0)break;t[t[w>>2]>>2]=9;p=123;break}if(((((u[t[v>>2]>>0]|0|0)==45?(t[v>>2]=(t[v>>2]|0)+1,t[d>>2]=pC((t[w>>2]|0)+8|0,v)|0,(t[d>>2]|0)==0):0)?(t[(t[w>>2]|0)+8>>2]|0)!=0:0)?(t[(t[w>>2]|0)+12>>2]&15|0)>=1:0)?(t[(t[w>>2]|0)+12>>2]&15|0)<=12:0){if(((t[(t[w>>2]|0)+8>>2]|0)%4|0|0)==0?((t[(t[w>>2]|0)+8>>2]|0)%100|0|0)!=0:0)p=87;else if((t[(t[w>>2]|0)+8>>2]|0)%400|0){if(((t[(t[w>>2]|0)+12>>2]|0)>>>4&31)>>>0>(t[171912+((t[(t[w>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0)break}else p=87;if((p|0)==87?((t[(t[w>>2]|0)+12>>2]|0)>>>4&31)>>>0>(t[171864+((t[(t[w>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0:0)break;do if(u[t[v>>2]>>0]|0){if((u[t[v>>2]>>0]|0|0)==90){p=93;break}if((u[t[v>>2]>>0]|0|0)==43){p=93;break}if((u[t[v>>2]>>0]|0|0)==45)p=93}else p=93;while(0);do if((p|0)==93){t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0;if(t[d>>2]|0)break;if(u[t[v>>2]>>0]|0)break e;t[t[w>>2]>>2]=10;p=123;break e}while(0);if((u[t[v>>2]>>0]|0|0)==84){t[v>>2]=(t[v>>2]|0)+1;t[d>>2]=gC((t[w>>2]|0)+8|0,v)|0;if(t[d>>2]|0)break;t[d>>2]=EC((t[w>>2]|0)+8|0,v)|0;i:do if(t[h>>2]|0)while(1){do if((u[t[v>>2]>>0]|0|0)!=32){if(9<=(u[t[v>>2]>>0]|0|0)?(u[t[v>>2]>>0]|0|0)<=10:0)break;if((u[t[v>>2]>>0]|0|0)!=13)break i}while(0);t[v>>2]=(t[v>>2]|0)+1}while(0);if(t[d>>2]|0)break;if(u[t[v>>2]>>0]|0)break;if(!(t[(t[w>>2]|0)+8>>2]|0))break;if((t[(t[w>>2]|0)+12>>2]&15|0)<1)break;if((t[(t[w>>2]|0)+12>>2]&15|0)>12)break;if(((t[(t[w>>2]|0)+8>>2]|0)%4|0|0)==0?((t[(t[w>>2]|0)+8>>2]|0)%100|0|0)!=0:0)p=112;else p=111;do if((p|0)==111){if(!((t[(t[w>>2]|0)+8>>2]|0)%400|0)){p=112;break}if(((t[(t[w>>2]|0)+12>>2]|0)>>>4&31)>>>0>(t[171912+((t[(t[w>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0)break e}while(0);if((p|0)==112?((t[(t[w>>2]|0)+12>>2]|0)>>>4&31)>>>0>(t[171864+((t[(t[w>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0:0)break;if(((t[(t[w>>2]|0)+12>>2]|0)>>>9&31|0)<0)break;if(((t[(t[w>>2]|0)+12>>2]|0)>>>9&31|0)>23)break;if(((t[(t[w>>2]|0)+12>>2]|0)>>>14&63|0)<0)break;if(((t[(t[w>>2]|0)+12>>2]|0)>>>14&63|0)>59)break;if(!(+l[(t[w>>2]|0)+16>>3]>=0))break;if(!(+l[(t[w>>2]|0)+16>>3]<60))break;if(((f[(t[w>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16|0)<=-840)break;if(((f[(t[w>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16|0)>=840)break;t[t[w>>2]>>2]=11;p=123}}}}}while(0);do if((p|0)==123){if((t[c>>2]|0)!=0?(t[c>>2]|0)!=(t[t[w>>2]>>2]|0):0)break;v=t[w>>2]|0;if(t[k>>2]|0)t[t[k>>2]>>2]=v;else MD(v);t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}while(0);if(t[w>>2]|0)MD(t[w>>2]|0);t[o>>2]=1;_=t[o>>2]|0;s=a;return _|0}function fC(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;f=s;s=s+64|0;a=f+52|0;o=f+44|0;c=f+40|0;b=f+36|0;k=f+32|0;h=f+28|0;w=f+24|0;d=f+20|0;v=f+8|0;m=f+16|0;_=f;t[f+48>>2]=e;t[o>>2]=i;t[c>>2]=r;t[b>>2]=n;t[k>>2]=t[o>>2];t[w>>2]=0;t[d>>2]=0;t[m>>2]=0;if(!(t[o>>2]|0)){t[a>>2]=-1;p=t[a>>2]|0;s=f;return p|0}e:do if(t[b>>2]|0)while(1){do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)break e}while(0);t[k>>2]=(t[k>>2]|0)+1}while(0);if((u[t[k>>2]>>0]|0|0)==45){t[w>>2]=1;t[k>>2]=(t[k>>2]|0)+1}o=t[k>>2]|0;t[k>>2]=o+1;if((u[o>>0]|0|0)!=80){t[a>>2]=1;p=t[a>>2]|0;s=f;return p|0}if(!(u[t[k>>2]>>0]|0)){t[a>>2]=1;p=t[a>>2]|0;s=f;return p|0}t[h>>2]=KD(12)|0;if(!(t[h>>2]|0)){t[a>>2]=-1;p=t[a>>2]|0;s=f;return p|0}e:while(1){if(!(u[t[k>>2]>>0]|0)){E=55;break}if((t[d>>2]|0)>>>0>=6){E=61;break}o=t[d>>2]|0;if((u[t[k>>2]>>0]|0|0)!=84){if((o|0)==3){E=61;break}}else{if(o>>>0>3){E=22;break}t[d>>2]=3;t[k>>2]=(t[k>>2]|0)+1}l[v>>3]=0;i:do if((u[t[k>>2]>>0]|0|0)>=48?(u[t[k>>2]>>0]|0|0)<=57:0)while(1){if((u[t[k>>2]>>0]|0|0)<48)break i;if((u[t[k>>2]>>0]|0|0)>57)break i;l[v>>3]=+l[v>>3]*10+ +((u[t[k>>2]>>0]|0)-48|0);t[k>>2]=(t[k>>2]|0)+1}else E=26;while(0);if((E|0)==26){E=0;t[m>>2]=-1}i:do if((t[m>>2]|0)==0?(u[t[k>>2]>>0]|0|0)==46:0){l[_>>3]=1;t[k>>2]=(t[k>>2]|0)+1;if((u[t[k>>2]>>0]|0|0)>=48?(u[t[k>>2]>>0]|0|0)<=57:0)t[m>>2]=1;else t[m>>2]=-1;while(1){if((u[t[k>>2]>>0]|0|0)<48)break i;if((u[t[k>>2]>>0]|0|0)>57)break i;l[_>>3]=+l[_>>3]/10;l[v>>3]=+l[v>>3]+ +((u[t[k>>2]>>0]|0)-48|0)*+l[_>>3];t[k>>2]=(t[k>>2]|0)+1}}while(0);if((t[m>>2]|0)==-1){E=61;break}if(!(u[t[k>>2]>>0]|0)){E=61;break}while(1){if((t[d>>2]|0)>>>0>=6)break;if((u[t[k>>2]>>0]|0|0)==(u[172280+(t[d>>2]|0)>>0]|0|0)){E=43;break}o=(t[d>>2]|0)+1|0;t[d>>2]=o;if((o|0)==3|(t[d>>2]|0)==6){E=61;break e}}do if((E|0)==43){E=0;if((t[m>>2]|0)!=0&(t[d>>2]|0)>>>0<5){E=61;break e}o=t[d>>2]|0;if((o|0)==1){n=(t[h>>2]|0)+8|0;t[n>>2]=(t[n>>2]|0)+~~+l[v>>3];break}else if(!o){t[(t[h>>2]|0)+8>>2]=~~+l[v>>3]*12;break}else{o=(t[h>>2]|0)+16|0;l[o>>3]=+l[o>>3]+ +l[v>>3]*+l[172288+(t[d>>2]<<3)>>3];t[d>>2]=(t[d>>2]|0)+1;break}}while(0);t[k>>2]=(t[k>>2]|0)+1;if(!(t[b>>2]|0))continue;while(1){do if((u[t[k>>2]>>0]|0|0)!=32){if(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0)break;if((u[t[k>>2]>>0]|0|0)!=13)continue e}while(0);t[k>>2]=(t[k>>2]|0)+1}}if((E|0)==22){t[a>>2]=1;p=t[a>>2]|0;s=f;return p|0}else if((E|0)==55){if(t[w>>2]|0){t[(t[h>>2]|0)+8>>2]=0-(t[(t[h>>2]|0)+8>>2]|0);t[(t[h>>2]|0)+12>>2]=0-(t[(t[h>>2]|0)+12>>2]|0);l[(t[h>>2]|0)+16>>3]=-+l[(t[h>>2]|0)+16>>3]}w=t[h>>2]|0;if(t[c>>2]|0)t[t[c>>2]>>2]=w;else MD(w);t[a>>2]=0;p=t[a>>2]|0;s=f;return p|0}else if((E|0)==61){if(t[h>>2]|0)MD(t[h>>2]|0);t[a>>2]=1;p=t[a>>2]|0;s=f;return p|0}return 0}function tC(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[v>>2]=0;t[m>>2]=0;if(!(t[l>>2]|0)){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}t[h>>2]=Yl(t[l>>2]|0)|0;if(!(t[h>>2]|0)){t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}if(t[b>>2]|0)t[t[b>>2]>>2]=0;t[w>>2]=t[h>>2];e:while(1){do if((u[t[w>>2]>>0]|0|0)!=32){if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0)break;if((u[t[w>>2]>>0]|0|0)!=13)break e}while(0);b=t[w>>2]|0;t[w>>2]=b+1;n[b>>0]=0}e:while(1){if(!(u[t[w>>2]>>0]|0))break;do if((u[t[w>>2]>>0]|0|0)!=32){
	if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0)break;if((u[t[w>>2]>>0]|0|0)!=13){t[v>>2]=(t[v>>2]|0)+1;t[w>>2]=(t[w>>2]|0)+1;while(1){if(!(u[t[w>>2]>>0]|0))continue e;do if((u[t[w>>2]>>0]|0|0)==32)p=1;else{if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0){p=1;break}p=(u[t[w>>2]>>0]|0|0)==13}while(0);if(!(p^1))continue e;t[w>>2]=(t[w>>2]|0)+1}}}while(0);n[t[w>>2]>>0]=0;t[w>>2]=(t[w>>2]|0)+1;while(1){do if((u[t[w>>2]>>0]|0|0)!=32){if(9<=(u[t[w>>2]>>0]|0|0)?(u[t[w>>2]>>0]|0|0)<=10:0)break;if((u[t[w>>2]>>0]|0|0)!=13)continue e}while(0);b=t[w>>2]|0;t[w>>2]=b+1;n[b>>0]=0}}if(!(t[v>>2]|0)){pAi[t[135736>>2]&511](t[h>>2]|0);t[o>>2]=t[v>>2];_=t[o>>2]|0;s=a;return _|0}t[d>>2]=t[w>>2];t[w>>2]=t[h>>2];while(1){if(u[t[w>>2]>>0]|0)break;if((t[w>>2]|0)==(t[d>>2]|0))break;t[w>>2]=(t[w>>2]|0)+1}e:while(1){if((t[w>>2]|0)==(t[d>>2]|0))break;t[m>>2]=LD(t[c>>2]|0,t[w>>2]|0,0,t[k>>2]|0)|0;if(t[m>>2]|0)break;while(1){if(!(u[t[w>>2]>>0]|0))break;t[w>>2]=(t[w>>2]|0)+1}while(1){if(u[t[w>>2]>>0]|0)continue e;if((t[w>>2]|0)==(t[d>>2]|0))continue e;t[w>>2]=(t[w>>2]|0)+1}}pAi[t[135736>>2]&511](t[h>>2]|0);if(!(t[m>>2]|0)){t[o>>2]=t[v>>2];_=t[o>>2]|0;s=a;return _|0}else{t[o>>2]=-1;_=t[o>>2]|0;s=a;return _|0}return 0}function uC(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[f>>2]=t[n>>2];if(!(t[n>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}while(1){do if(u[t[f>>2]>>0]|0)if((u[t[f>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[f>>2]>>0]|0|0)==13}else l=0;while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}t[a>>2]=b;while(1){k=t[a>>2]|0;if(!(u[t[a>>2]>>0]|0))break;t[a>>2]=k+1}t[o>>2]=k;t[a>>2]=(t[a>>2]|0)+-1;while(1){do if((t[a>>2]|0)>>>0>(t[f>>2]|0)>>>0)if((u[t[a>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[a>>2]>>0]|0|0)==13}else h=0;while(0);w=t[a>>2]|0;if(!h)break;t[a>>2]=w+-1}t[a>>2]=w+1;if((t[f>>2]|0)==(t[n>>2]|0)?(t[o>>2]|0)==(t[a>>2]|0):0){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[r>>2]=ql(t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;c=t[r>>2]|0;s=i;return c|0}function aC(e){e=e|0;var i=0,r=0,f=0,a=0;i=s;s=s+16|0;r=i;f=i+4|0;n[f>>0]=e;if(65<=(u[f>>0]|0|0)?(u[f>>0]|0|0)<=90:0)t[r>>2]=(u[f>>0]|0)-65;else a=4;do if((a|0)==4){if(97<=(u[f>>0]|0|0)?(u[f>>0]|0|0)<=122:0){t[r>>2]=(u[f>>0]|0)-97+26;break}if(48<=(u[f>>0]|0|0)?(u[f>>0]|0|0)<=57:0){t[r>>2]=(u[f>>0]|0)-48+52;break}if(43==(u[f>>0]|0|0)){t[r>>2]=62;break}if(47==(u[f>>0]|0|0)){t[r>>2]=63;break}if(61==(u[f>>0]|0|0)){t[r>>2]=64;break}else{t[r>>2]=-1;break}}while(0);s=i;return t[r>>2]|0}function oC(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0;r=s;s=s+64|0;n=r+48|0;u=r+44|0;o=r+40|0;c=r+36|0;l=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+12|0;v=r+8|0;m=r+4|0;_=r;t[u>>2]=e;t[o>>2]=i;t[l>>2]=1;e:do if(f[(t[u>>2]|0)+24>>1]&1){if(((t[(t[u>>2]|0)+8>>2]|0)==0?(t[(t[u>>2]|0)+12>>2]|0)==0:0)?(t[(t[u>>2]|0)+16>>2]|0)==0:0){p=11;break}do if(f[(t[o>>2]|0)+24>>1]&1){if(((t[(t[o>>2]|0)+8>>2]|0)==0?(t[(t[o>>2]|0)+12>>2]|0)==0:0)?(t[(t[o>>2]|0)+16>>2]|0)==0:0)break;t[l>>2]=-1;break e}while(0);t[n>>2]=-1;E=t[n>>2]|0;s=r;return E|0}else p=11;while(0);do if((p|0)==11?(f[(t[o>>2]|0)+24>>1]&1|0)!=0:0){if(((t[(t[o>>2]|0)+8>>2]|0)==0?(t[(t[o>>2]|0)+12>>2]|0)==0:0)?(t[(t[o>>2]|0)+16>>2]|0)==0:0)break;t[n>>2]=1;E=t[n>>2]|0;s=r;return E|0}while(0);t[b>>2]=((a[(t[u>>2]|0)+24>>1]|0)>>>8&65535)-((a[(t[u>>2]|0)+24>>1]|0)>>>1&127);t[k>>2]=((a[(t[o>>2]|0)+24>>1]|0)>>>8&65535)-((a[(t[o>>2]|0)+24>>1]|0)>>>1&127);if((t[b>>2]|0)==1?(t[(t[u>>2]|0)+8>>2]|0)==0:0){if((t[k>>2]|0)!=1){t[n>>2]=0-(t[l>>2]|0);E=t[n>>2]|0;s=r;return E|0}if(t[(t[o>>2]|0)+8>>2]|0){t[n>>2]=0-(t[l>>2]|0);E=t[n>>2]|0;s=r;return E|0}else{t[n>>2]=0;E=t[n>>2]|0;s=r;return E|0}}if((t[k>>2]|0)==1?(t[(t[o>>2]|0)+8>>2]|0)==0:0){if((t[b>>2]|0)!=1){t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}if(t[(t[u>>2]|0)+8>>2]|0){t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}else{t[n>>2]=0;E=t[n>>2]|0;s=r;return E|0}}if((t[b>>2]|0)>(t[k>>2]|0)){t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}if((t[k>>2]|0)>(t[b>>2]|0)){t[n>>2]=0-(t[l>>2]|0);E=t[n>>2]|0;s=r;return E|0}t[h>>2]=((a[(t[u>>2]|0)+24>>1]|0)>>>8&65535)-((a[(t[o>>2]|0)+24>>1]|0)>>>8&65535);if((t[h>>2]|0)<0){t[c>>2]=t[u>>2];t[w>>2]=t[(t[o>>2]|0)+16>>2];t[d>>2]=t[(t[o>>2]|0)+12>>2];t[v>>2]=t[(t[o>>2]|0)+8>>2];t[h>>2]=0-(t[h>>2]|0);t[l>>2]=0-(t[l>>2]|0)}else{t[c>>2]=t[o>>2];t[w>>2]=t[(t[u>>2]|0)+16>>2];t[d>>2]=t[(t[u>>2]|0)+12>>2];t[v>>2]=t[(t[u>>2]|0)+8>>2]}while(1){if((t[h>>2]|0)<=8)break;t[v>>2]=t[d>>2];t[d>>2]=t[w>>2];t[w>>2]=0;t[h>>2]=(t[h>>2]|0)-8}while(1){S=t[w>>2]|0;if((t[h>>2]|0)<=0)break;t[m>>2]=te((S>>>0)%10|0,1e8)|0;t[w>>2]=((t[w>>2]|0)>>>0)/10|0;t[_>>2]=te(((t[d>>2]|0)>>>0)%10|0,1e8)|0;t[d>>2]=(((t[d>>2]|0)+(t[m>>2]|0)|0)>>>0)/10|0;t[v>>2]=(((t[v>>2]|0)+(t[_>>2]|0)|0)>>>0)/10|0;t[h>>2]=(t[h>>2]|0)+-1}if(S>>>0>(t[(t[c>>2]|0)+16>>2]|0)>>>0){t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}if((t[w>>2]|0)==(t[(t[c>>2]|0)+16>>2]|0)){if((t[d>>2]|0)>>>0>(t[(t[c>>2]|0)+12>>2]|0)>>>0){t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}if((t[d>>2]|0)==(t[(t[c>>2]|0)+12>>2]|0)){if((t[v>>2]|0)>>>0>(t[(t[c>>2]|0)+8>>2]|0)>>>0){t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}if((t[v>>2]|0)==(t[(t[c>>2]|0)+8>>2]|0))if(((a[(t[u>>2]|0)+24>>1]|0)>>>8&65535|0)==((a[(t[o>>2]|0)+24>>1]|0)>>>8&65535|0)){t[n>>2]=0;E=t[n>>2]|0;s=r;return E|0}else{t[n>>2]=t[l>>2];E=t[n>>2]|0;s=r;return E|0}}}t[n>>2]=0-(t[l>>2]|0);E=t[n>>2]|0;s=r;return E|0}function cC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+64|0;n=r+52|0;f=r+48|0;u=r+44|0;a=r+40|0;o=r+36|0;c=r+32|0;b=r;k=r+28|0;h=r+24|0;w=r+20|0;d=r+16|0;v=r+12|0;m=r+8|0;t[f>>2]=e;t[u>>2]=i;t[k>>2]=1;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-2;_=t[n>>2]|0;s=r;return _|0}t[o>>2]=(t[(t[f>>2]|0)+8>>2]|0)-(t[(t[u>>2]|0)+8>>2]|0);l[b>>3]=+l[(t[f>>2]|0)+16>>3]-+l[(t[u>>2]|0)+16>>3];t[a>>2]=~~(+l[b>>3]/86400);l[b>>3]=+l[b>>3]-+(t[a>>2]|0)*86400;t[c>>2]=(t[(t[f>>2]|0)+12>>2]|0)-(t[(t[u>>2]|0)+12>>2]|0)+(t[a>>2]|0);if(!(t[o>>2]|0)){if(t[c>>2]|0)if((t[c>>2]|0)<0){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}else{t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}if(+l[b>>3]==0){t[n>>2]=0;_=t[n>>2]|0;s=r;return _|0}if(+l[b>>3]<0){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}else{t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}}a=t[c>>2]|0;do if((t[o>>2]|0)>0){if(!((a|0)>=0&+l[b>>3]>=0)){t[h>>2]=t[o>>2];t[w>>2]=0-(t[c>>2]|0);break}t[n>>2]=1;_=t[n>>2]|0;s=r;return _|0}else{if(!((a|0)<=0&+l[b>>3]<=0)){t[k>>2]=-1;t[h>>2]=0-(t[o>>2]|0);t[w>>2]=t[c>>2];break}t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}while(0);t[d>>2]=(t[h>>2]|0)/12|0;if(!(t[d>>2]|0)){t[v>>2]=0;t[m>>2]=0}else{t[m>>2]=((((t[d>>2]|0)+3|0)/4|0)*366|0)+((((t[d>>2]|0)-1|0)%4|0)*365|0);t[v>>2]=(t[m>>2]|0)-1}t[h>>2]=(t[h>>2]|0)%12|0;t[v>>2]=(t[v>>2]|0)+(t[172120+(t[h>>2]<<2)>>2]|0);t[m>>2]=(t[m>>2]|0)+(t[172168+(t[h>>2]<<2)>>2]|0);if((t[m>>2]|0)==(t[v>>2]|0)?(t[m>>2]|0)==(t[w>>2]|0):0){t[n>>2]=0;_=t[n>>2]|0;s=r;return _|0}if((t[m>>2]|0)<(t[w>>2]|0)){t[n>>2]=0-(t[k>>2]|0);_=t[n>>2]|0;s=r;return _|0}if((t[v>>2]|0)>(t[w>>2]|0)){t[n>>2]=t[k>>2];_=t[n>>2]|0;s=r;return _|0}else{t[n>>2]=2;_=t[n>>2]|0;s=r;return _|0}return 0}function lC(e,i){e=e|0;i=i|0;var r=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0;r=s;s=s+96|0;a=r+76|0;o=r+72|0;c=r+68|0;b=r+83|0;k=r+82|0;h=r+81|0;w=r+80|0;d=r+64|0;v=r+60|0;m=r+56|0;_=r+52|0;p=r+48|0;E=r+44|0;S=r+40|0;g=r+36|0;y=r+16|0;F=r+32|0;O=r+8|0;A=r+28|0;M=r+24|0;R=r;t[o>>2]=e;t[c>>2]=i;if((t[o>>2]|0)==0|(t[c>>2]|0)==0){t[a>>2]=-2;N=t[a>>2]|0;s=r;return N|0}i=(f[(t[c>>2]|0)+24>>1]&1|0)!=0;do if(f[(t[o>>2]|0)+24>>1]&1){if(!i){t[d>>2]=eC(t[o>>2]|0,0)|0;e=FC(t[d>>2]|0)|0;t[p>>2]=e+((t[(t[d>>2]|0)+12>>2]|0)>>>4&31);t[m>>2]=eC(t[c>>2]|0,50400)|0;e=FC(t[m>>2]|0)|0;t[S>>2]=e+((t[(t[m>>2]|0)+12>>2]|0)>>>4&31);if((t[p>>2]|0)<(t[S>>2]|0)){MD(t[d>>2]|0);MD(t[m>>2]|0);t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}e=t[d>>2]|0;if((t[p>>2]|0)!=(t[S>>2]|0)){MD(e);MD(t[m>>2]|0);break}l[y>>3]=+((((t[e+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[d>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[d>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[d>>2]|0)+16>>3]-(+((((t[(t[m>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[m>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[m>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[m>>2]|0)+16>>3]);if(+l[y>>3]<0){MD(t[d>>2]|0);MD(t[m>>2]|0);t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}t[F>>2]=0;t[_>>2]=eC(t[c>>2]|0,-50400)|0;e=FC(t[_>>2]|0)|0;t[g>>2]=e+((t[(t[_>>2]|0)+12>>2]|0)>>>4&31);do if((t[p>>2]|0)<=(t[g>>2]|0)){if((t[p>>2]|0)==(t[g>>2]|0)){l[y>>3]=+((((t[(t[d>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[d>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[d>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[d>>2]|0)+16>>3]-(+((((t[(t[_>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[_>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[_>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[_>>2]|0)+16>>3]);if(+l[y>>3]>0){t[F>>2]=1;break}else{t[F>>2]=2;break}}}else t[F>>2]=1;while(0);MD(t[d>>2]|0);MD(t[m>>2]|0);MD(t[_>>2]|0);if(t[F>>2]|0){t[a>>2]=t[F>>2];N=t[a>>2]|0;s=r;return N|0}}}else if(i){t[m>>2]=eC(t[c>>2]|0,0)|0;e=FC(t[m>>2]|0)|0;t[S>>2]=e+((t[(t[m>>2]|0)+12>>2]|0)>>>4&31);t[d>>2]=eC(t[o>>2]|0,-50400)|0;e=FC(t[d>>2]|0)|0;t[p>>2]=e+((t[(t[d>>2]|0)+12>>2]|0)>>>4&31);if((t[p>>2]|0)<(t[S>>2]|0)){MD(t[d>>2]|0);MD(t[m>>2]|0);t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}e=t[d>>2]|0;if((t[p>>2]|0)!=(t[S>>2]|0)){MD(e);MD(t[m>>2]|0);break}l[O>>3]=+((((t[e+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[d>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[d>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[d>>2]|0)+16>>3]-(+((((t[(t[m>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[m>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[m>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[m>>2]|0)+16>>3]);if(+l[O>>3]<0){MD(t[d>>2]|0);MD(t[m>>2]|0);t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}t[A>>2]=0;t[v>>2]=eC(t[o>>2]|0,50400)|0;e=FC(t[v>>2]|0)|0;t[E>>2]=e+((t[(t[v>>2]|0)+12>>2]|0)>>>4&31);do if((t[E>>2]|0)<=(t[S>>2]|0)){if((t[E>>2]|0)==(t[S>>2]|0)){l[O>>3]=+((((t[(t[v>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[v>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[v>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[v>>2]|0)+16>>3]-(+((((t[(t[m>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[m>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[m>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[m>>2]|0)+16>>3]);if(+l[O>>3]>0){t[A>>2]=1;break}else{t[A>>2]=2;break}}}else t[A>>2]=1;while(0);MD(t[d>>2]|0);MD(t[m>>2]|0);MD(t[v>>2]|0);if(t[A>>2]|0){t[a>>2]=t[A>>2];N=t[a>>2]|0;s=r;return N|0}}while(0);if((t[t[o>>2]>>2]|0)==(t[t[c>>2]>>2]|0)){t[M>>2]=0;t[m>>2]=eC(t[c>>2]|0,0)|0;A=FC(t[m>>2]|0)|0;t[S>>2]=A+((t[(t[m>>2]|0)+12>>2]|0)>>>4&31);t[d>>2]=eC(t[o>>2]|0,0)|0;A=FC(t[d>>2]|0)|0;t[p>>2]=A+((t[(t[d>>2]|0)+12>>2]|0)>>>4&31);do if((t[p>>2]|0)>=(t[S>>2]|0)){if((t[p>>2]|0)>(t[S>>2]|0)){t[M>>2]=1;break}l[R>>3]=+((((t[(t[d>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[d>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[d>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[d>>2]|0)+16>>3]-(+((((t[(t[m>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((t[(t[m>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((f[(t[m>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +l[(t[m>>2]|0)+16>>3]);if(+l[R>>3]<0){t[M>>2]=-1;break}if(+l[R>>3]>0)t[M>>2]=1}else t[M>>2]=-1;while(0);MD(t[d>>2]|0);MD(t[m>>2]|0);t[a>>2]=t[M>>2];N=t[a>>2]|0;s=r;return N|0}switch(t[t[o>>2]>>2]|0){case 6:{n[b>>0]=2;break}case 5:{n[b>>0]=3;break}case 9:{n[b>>0]=3;break}case 7:{n[b>>0]=6;break}case 4:{n[b>>0]=8;break}case 11:{n[b>>0]=15;break}case 10:{n[b>>0]=7;break}case 8:{n[b>>0]=1;break}default:n[b>>0]=0}switch(t[t[c>>2]>>2]|0){case 11:{n[k>>0]=15;break}case 10:{n[k>>0]=7;break}case 8:{n[k>>0]=1;break}case 6:{n[k>>0]=2;break}case 5:{n[k>>0]=3;break}case 9:{n[k>>0]=3;break}case 7:{n[k>>0]=6;break}case 4:{n[k>>0]=8;break}default:n[k>>0]=0}n[h>>0]=(u[b>>0]|0)^(u[k>>0]|0);n[w>>0]=(u[b>>0]|0)&(u[k>>0]|0);if((u[h>>0]|0)&1){t[a>>2]=2;N=t[a>>2]|0;s=r;return N|0}if((u[w>>0]|0)&1){if((t[(t[o>>2]|0)+8>>2]|0)<(t[(t[c>>2]|0)+8>>2]|0)){t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}if((t[(t[o>>2]|0)+8>>2]|0)>(t[(t[c>>2]|0)+8>>2]|0)){t[a>>2]=1;N=t[a>>2]|0;s=r;return N|0}}if((u[h>>0]|0)&2){t[a>>2]=2;N=t[a>>2]|0;s=r;return N|0}if((u[w>>0]|0)&2){if((t[(t[o>>2]|0)+12>>2]&15|0)<(t[(t[c>>2]|0)+12>>2]&15|0)){t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}if((t[(t[o>>2]|0)+12>>2]&15|0)>(t[(t[c>>2]|0)+12>>2]&15|0)){t[a>>2]=1;N=t[a>>2]|0;s=r;return N|0}}if((u[h>>0]|0)&4){t[a>>2]=2;N=t[a>>2]|0;s=r;return N|0}if((u[w>>0]|0)&4){if(((t[(t[o>>2]|0)+12>>2]|0)>>>4&31|0)<((t[(t[c>>2]|0)+12>>2]|0)>>>4&31|0)){t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}if(((t[(t[o>>2]|0)+12>>2]|0)>>>4&31|0)>((t[(t[c>>2]|0)+12>>2]|0)>>>4&31|0)){t[a>>2]=1;N=t[a>>2]|0;s=r;return N|0}}if((u[h>>0]|0)&8){t[a>>2]=2;N=t[a>>2]|0;s=r;return N|0}if((u[w>>0]|0)&8){if(((t[(t[o>>2]|0)+12>>2]|0)>>>9&31|0)<((t[(t[c>>2]|0)+12>>2]|0)>>>9&31|0)){t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}if(((t[(t[o>>2]|0)+12>>2]|0)>>>9&31|0)>((t[(t[c>>2]|0)+12>>2]|0)>>>9&31|0)){t[a>>2]=1;N=t[a>>2]|0;s=r;return N|0}if(((t[(t[o>>2]|0)+12>>2]|0)>>>14&63|0)<((t[(t[c>>2]|0)+12>>2]|0)>>>14&63|0)){t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}if(((t[(t[o>>2]|0)+12>>2]|0)>>>14&63|0)>((t[(t[c>>2]|0)+12>>2]|0)>>>14&63|0)){t[a>>2]=1;N=t[a>>2]|0;s=r;return N|0}if(+l[(t[o>>2]|0)+16>>3]<+l[(t[c>>2]|0)+16>>3]){t[a>>2]=-1;N=t[a>>2]|0;s=r;return N|0}if(+l[(t[o>>2]|0)+16>>3]>+l[(t[c>>2]|0)+16>>3]){t[a>>2]=1;N=t[a>>2]|0;s=r;return N|0}}t[a>>2]=0;N=t[a>>2]|0;s=r;return N|0}function sC(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;while(1){if(!(u[t[a>>2]>>0]|0)){b=24;break}if(!(u[t[o>>2]>>0]|0)){b=24;break}if(((u[t[o>>2]>>0]|0|0)!=9?(u[t[o>>2]>>0]|0|0)!=10:0)?(u[t[o>>2]>>0]|0|0)!=13:0){t[l>>2]=(u[t[a>>2]>>0]|0)-(u[t[o>>2]>>0]|0);if((t[l>>2]|0)<0){b=16;break}if((t[l>>2]|0)>0){b=20;break}}else b=7;if((b|0)==7?(b=0,(u[t[a>>2]>>0]|0|0)!=32):0){b=8;break}t[a>>2]=(t[a>>2]|0)+1;t[o>>2]=(t[o>>2]|0)+1}do if((b|0)==8){l=(t[c>>2]|0)!=0;if(((u[t[a>>2]>>0]|0)-32|0)<0)if(l){t[f>>2]=1;break}else{t[f>>2]=-1;break}else if(l){t[f>>2]=-1;break}else{t[f>>2]=1;break}}else if((b|0)==16)if(t[c>>2]|0){t[f>>2]=1;break}else{t[f>>2]=-1;break}else if((b|0)==20)if(t[c>>2]|0){t[f>>2]=-1;break}else{t[f>>2]=1;break}else if((b|0)==24){if(u[t[a>>2]>>0]|0)if(t[c>>2]|0){t[f>>2]=-1;break}else{t[f>>2]=1;break}if(!(u[t[o>>2]>>0]|0)){t[f>>2]=0;break}if(t[c>>2]|0){t[f>>2]=1;break}else{t[f>>2]=-1;break}}while(0);s=n;return t[f>>2]|0}function bC(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;e:while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}e:while(1){if(!(u[t[a>>2]>>0]|0)){b=35;break}if(!(u[t[o>>2]>>0]|0)){b=35;break}do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13){r=t[a>>2]|0;t[a>>2]=r+1;i=u[r>>0]|0;r=t[o>>2]|0;t[o>>2]=r+1;t[l>>2]=i-(u[r>>0]|0);if((t[l>>2]|0)<0){b=28;break e}if((t[l>>2]|0)>0){b=32;break e}else continue e}}while(0);k=t[a>>2]|0;if((u[t[a>>2]>>0]|0|0)!=32){b=14;break}t[a>>2]=k+1;t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)continue e}while(0);t[o>>2]=(t[o>>2]|0)+1}}do if((b|0)==14){l=(t[c>>2]|0)!=0;if(((u[k>>0]|0)-32|0)<0)if(l){t[f>>2]=1;break}else{t[f>>2]=-1;break}else if(l){t[f>>2]=-1;break}else{t[f>>2]=1;break}}else if((b|0)==28)if(t[c>>2]|0){t[f>>2]=1;break}else{t[f>>2]=-1;break}else if((b|0)==32)if(t[c>>2]|0){t[f>>2]=-1;break}else{t[f>>2]=1;break}else if((b|0)==35){if(u[t[a>>2]>>0]|0)if(t[c>>2]|0){t[f>>2]=-1;break}else{t[f>>2]=1;break}if(u[t[o>>2]>>0]|0){while(1){do if((u[t[o>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[o>>2]>>0]|0|0)==13}while(0);w=t[o>>2]|0;if(!h)break;t[o>>2]=w+1}if(u[w>>0]|0)if(t[c>>2]|0){t[f>>2]=1;break}else{t[f>>2]=-1;break}}t[f>>2]=0}while(0);s=n;return t[f>>2]|0}function kC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;e:while(1){if(!(u[t[f>>2]>>0]|0)){c=27;break}if(!(u[t[a>>2]>>0]|0)){c=27;break}do if((u[t[a>>2]>>0]|0|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){c=8;break}if((u[t[a>>2]>>0]|0|0)!=13){if((u[t[f>>2]>>0]|0|0)==32){c=19;break e}if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){c=19;break e}if((u[t[f>>2]>>0]|0|0)==13){c=19;break e}t[o>>2]=(u[t[f>>2]>>0]|0)-(u[t[a>>2]>>0]|0);if((t[o>>2]|0)<0){c=23;break e}if((t[o>>2]|0)>0){c=25;break e}}else c=8}else c=8;while(0);do if((c|0)==8?(c=0,(u[t[f>>2]>>0]|0|0)!=32):0){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13){c=12;break e}}while(0);t[f>>2]=(t[f>>2]|0)+1;t[a>>2]=(t[a>>2]|0)+1}if((c|0)==12)if(((u[t[f>>2]>>0]|0)-32|0)<0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((c|0)==19)if((32-(u[t[a>>2]>>0]|0)|0)<0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((c|0)==23){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else if((c|0)==25){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((c|0)==27){if(u[t[f>>2]>>0]|0){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}if(u[t[a>>2]>>0]|0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}}return 0}function hC(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;e:while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}e:while(1){if(!(u[t[a>>2]>>0]|0)){b=45;break}if(!(u[t[o>>2]>>0]|0)){b=45;break}do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13){if((u[t[a>>2]>>0]|0|0)==32){b=34;break e}if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){b=34;break e}if((u[t[a>>2]>>0]|0|0)==13){b=34;break e}r=t[a>>2]|0;t[a>>2]=r+1;i=u[r>>0]|0;r=t[o>>2]|0;t[o>>2]=r+1;t[l>>2]=i-(u[r>>0]|0);if((t[l>>2]|0)<0){b=42;break e}if((t[l>>2]|0)>0){b=44;break e}else continue e}}while(0);do if((u[t[a>>2]>>0]|0|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)!=13){b=17;break e}}while(0);t[a>>2]=(t[a>>2]|0)+1;t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)continue e}while(0);t[o>>2]=(t[o>>2]|0)+1}}if((b|0)==17){l=(t[c>>2]|0)!=0;if(((u[t[a>>2]>>0]|0)-32|0)<0)if(l){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else if(l){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}}else if((b|0)==34){l=(t[c>>2]|0)!=0;if((32-(u[t[o>>2]>>0]|0)|0)<0)if(l){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else if(l){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}}else if((b|0)==42){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else if((b|0)==44){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else if((b|0)==45){if(u[t[a>>2]>>0]|0)if(t[c>>2]|0){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}if(u[t[o>>2]>>0]|0){while(1){do if((u[t[o>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[o>>2]>>0]|0|0)==13}while(0);w=t[o>>2]|0;if(!h)break;t[o>>2]=w+1}if(u[w>>0]|0)if(t[c>>2]|0){t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}else{t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}}t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}return 0}function wC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[a>>2]=i;e:while(1){do if((u[t[f>>2]>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13)break e}while(0);t[f>>2]=(t[f>>2]|0)+1}e:while(1){do if((u[t[a>>2]>>0]|0|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)!=13)break e}while(0);t[a>>2]=(t[a>>2]|0)+1}e:while(1){if(u[t[f>>2]>>0]|0)c=(u[t[a>>2]>>0]|0|0)!=0;else c=0;l=u[t[f>>2]>>0]|0;if(!c){b=38;break}do if((l|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13){i=t[f>>2]|0;t[f>>2]=i+1;e=u[i>>0]|0;i=t[a>>2]|0;t[a>>2]=i+1;t[o>>2]=e-(u[i>>0]|0);if((t[o>>2]|0)<0){b=35;break e}if((t[o>>2]|0)>0){b=37;break e}else continue e}}while(0);do if((u[t[a>>2]>>0]|0|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)!=13){b=23;break e}}while(0);i:while(1){do if((u[t[f>>2]>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13)break i}while(0);t[f>>2]=(t[f>>2]|0)+1}while(1){do if((u[t[a>>2]>>0]|0|0)!=32){if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0)break;if((u[t[a>>2]>>0]|0|0)!=13)continue e}while(0);t[a>>2]=(t[a>>2]|0)+1}}if((b|0)==23){t[o>>2]=(u[t[f>>2]>>0]|0)-(u[t[a>>2]>>0]|0);t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}else if((b|0)==35){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((b|0)==37){t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}else if((b|0)==38){if(l){while(1){do if((u[t[f>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[f>>2]>>0]|0|0)==13}while(0);w=t[f>>2]|0;if(!h)break;t[f>>2]=w+1}if(u[w>>0]|0){t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}}if(u[t[a>>2]>>0]|0){while(1){do if((u[t[a>>2]>>0]|0|0)==32)d=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){d=1;break}d=(u[t[a>>2]>>0]|0|0)==13}while(0);v=t[a>>2]|0;if(!d)break;t[a>>2]=v+1}if(u[v>>0]|0){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}}t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}return 0}function dC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+8|0;o=r;t[f>>2]=e;t[u>>2]=i;e:do if(!((t[f>>2]|0)==0|(t[u>>2]|0)==0)){i=t[f>>2]|0;do if((t[t[f>>2]>>2]|0)!=14)if((t[i>>2]|0)==13){l[a>>3]=+c[(t[f>>2]|0)+8>>2];break}else{t[n>>2]=-2;break e}else l[a>>3]=+l[i+8>>3];while(0);i=t[u>>2]|0;do if((t[t[u>>2]>>2]|0)!=14)if((t[i>>2]|0)==13){l[o>>3]=+c[(t[u>>2]|0)+8>>2];break}else{t[n>>2]=-2;break e}else l[o>>3]=+l[i+8>>3];while(0);i=(hn(+l[a>>3])|0)!=0;e=(hn(+l[o>>3])|0)!=0;if(i)if(e){t[n>>2]=0;break}else{t[n>>2]=1;break}if(e){t[n>>2]=-1;break}e=+l[o>>3]==+l[15985];if(+l[a>>3]==+l[15985])if(e){t[n>>2]=0;break}else{t[n>>2]=1;break}if(e){t[n>>2]=-1;break}e=+l[o>>3]==+l[15986];if(+l[a>>3]==+l[15986])if(e){t[n>>2]=0;break}else{t[n>>2]=-1;break}if(e){t[n>>2]=1;break}if(+l[a>>3]<+l[o>>3]){t[n>>2]=-1;break}if(+l[a>>3]>+l[o>>3]){t[n>>2]=1;break}if(+l[a>>3]==+l[o>>3]){t[n>>2]=0;break}else{t[n>>2]=2;break}}else t[n>>2]=-2;while(0);s=r;return t[n>>2]|0}function vC(e,i,r,n,f,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;o=o|0;var c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;c=s;s=s+32|0;l=c+28|0;b=c+24|0;k=c+20|0;h=c+16|0;w=c+12|0;d=c+8|0;v=c+4|0;m=c;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=n;t[w>>2]=f;t[d>>2]=u;t[v>>2]=a;t[m>>2]=o;o=JD(t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,t[m>>2]|0)|0;s=c;return o|0}function mC(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;a=i;t[n>>2]=e;t[a>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}t[f>>2]=t[n>>2];e:while(1){do if((u[t[f>>2]>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13)break e}while(0);t[f>>2]=(t[f>>2]|0)+1}e:while(1){if(!(u[t[f>>2]>>0]|0)){c=36;break}n=t[f>>2]|0;i:do if(!((u[t[f>>2]>>0]|0)&128)){do if((u[n>>0]|0|0)!=32){if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0)break;if((u[t[f>>2]>>0]|0|0)!=13){t[f>>2]=(t[f>>2]|0)+1;break i}}while(0);while(1){do if((u[t[f>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[f>>2]>>0]|0|0)?(u[t[f>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[f>>2]>>0]|0|0)==13}while(0);b=t[f>>2]|0;if(!l)break;t[f>>2]=b+1}if(!(u[b>>0]|0)){c=36;break e}}else{if(((u[n+1>>0]|0)&192|0)!=128){c=12;break e}e=(t[f>>2]|0)+2|0;if(((u[t[f>>2]>>0]|0)&224|0)!=224){t[f>>2]=e;break}if(((u[e>>0]|0)&192|0)!=128){c=15;break e}e=t[f>>2]|0;if(((u[t[f>>2]>>0]|0)&240|0)!=240){t[f>>2]=e+3;break}if(((u[e>>0]|0)&248|0)!=240){c=19;break e}if(((u[(t[f>>2]|0)+3>>0]|0)&192|0)!=128){c=19;break e}t[f>>2]=(t[f>>2]|0)+4}while(0);t[a>>2]=(t[a>>2]|0)+1}if((c|0)==12){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}else if((c|0)==15){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}else if((c|0)==19){t[r>>2]=-1;o=t[r>>2]|0;s=i;return o|0}else if((c|0)==36){t[r>>2]=t[a>>2];o=t[r>>2]|0;s=i;return o|0}return 0}function _C(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0;r=s;s=s+64|0;n=r+48|0;u=r+44|0;a=r+40|0;o=r+36|0;c=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+12|0;v=r+8|0;m=r+4|0;_=r;t[u>>2]=e;t[a>>2]=i;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}t[o>>2]=KD(t[t[u>>2]>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}t[c>>2]=ZD(t[u>>2]|0)|0;u=t[o>>2]|0;if(!(t[c>>2]|0)){MD(u);t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}t[w>>2]=u+8;t[d>>2]=(t[c>>2]|0)+8;t[v>>2]=(t[a>>2]|0)+8;if(!(t[(t[d>>2]|0)+4>>2]&15)){a=(t[d>>2]|0)+4|0;t[a>>2]=t[a>>2]&-16|1}a=(t[v>>2]|0)+8|0;l[a>>3]=+l[a>>3]-+(((f[(t[d>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0);a=(t[d>>2]|0)+16|0;f[a>>1]=f[a>>1]&-8191;if(!((t[(t[d>>2]|0)+4>>2]|0)>>>4&31)){a=(t[d>>2]|0)+4|0;t[a>>2]=t[a>>2]&-497|16}t[b>>2]=(t[(t[d>>2]|0)+4>>2]&15)+(t[t[v>>2]>>2]|0);a=~~(+((t[b>>2]|0)-1|0)-+Y(+(+((t[b>>2]|0)-1|0)/12))*12+1)>>>0;u=(t[w>>2]|0)+4|0;t[u>>2]=t[u>>2]&-16|a&15;t[b>>2]=~~+Y(+(+((t[b>>2]|0)-1|0)/12));t[t[w>>2]>>2]=(t[t[d>>2]>>2]|0)+(t[b>>2]|0);do if(!(t[t[w>>2]>>2]|0)){a=t[w>>2]|0;u=t[a>>2]|0;if((t[t[d>>2]>>2]|0)>0){t[a>>2]=u+-1;break}else{t[a>>2]=u+1;break}}while(0);u=(t[w>>2]|0)+16|0;f[u>>1]=f[u>>1]&-8191|((f[(t[d>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16&4095)<<1&65535;u=(t[w>>2]|0)+16|0;f[u>>1]=f[u>>1]&-2|f[(t[d>>2]|0)+16>>1]&1;l[(t[w>>2]|0)+8>>3]=+l[(t[d>>2]|0)+8>>3]+ +l[(t[v>>2]|0)+8>>3];t[b>>2]=~~+Y(+(+(~~+l[(t[w>>2]|0)+8>>3]|0)/60));if(+l[(t[w>>2]|0)+8>>3]!=0){E=+l[(t[w>>2]|0)+8>>3]-+Y(+(+l[(t[w>>2]|0)+8>>3]/60))*60;l[(t[w>>2]|0)+8>>3]=E}t[b>>2]=(t[b>>2]|0)+((t[(t[d>>2]|0)+4>>2]|0)>>>14&63);u=~~(+(t[b>>2]|0)-+Y(+(+(t[b>>2]|0)/60))*60)>>>0;a=(t[w>>2]|0)+4|0;t[a>>2]=t[a>>2]&-1032193|(u&63)<<14;t[b>>2]=~~+Y(+(+(t[b>>2]|0)/60));t[b>>2]=(t[b>>2]|0)+((t[(t[d>>2]|0)+4>>2]|0)>>>9&31);u=~~(+(t[b>>2]|0)-+Y(+(+(t[b>>2]|0)/24))*24)>>>0;a=(t[w>>2]|0)+4|0;t[a>>2]=t[a>>2]&-15873|(u&31)<<9;t[b>>2]=~~+Y(+(+(t[b>>2]|0)/24));if(((t[t[w>>2]>>2]|0)!=0?(t[(t[w>>2]|0)+4>>2]&15|0)>=1:0)?(t[(t[w>>2]|0)+4>>2]&15|0)<=12:0){u=(t[(t[d>>2]|0)+4>>2]|0)>>>4&31;if(((t[t[w>>2]>>2]|0)%4|0|0)==0?((t[t[w>>2]>>2]|0)%100|0|0)!=0:0)S=23;else if(!((t[t[w>>2]>>2]|0)%400|0))S=23;else g=t[171912+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((S|0)==23)g=t[171864+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if(u>>>0>g>>>0){if(((t[t[w>>2]>>2]|0)%4|0|0)==0?((t[t[w>>2]>>2]|0)%100|0|0)!=0:0)S=29;else if(!((t[t[w>>2]>>2]|0)%400|0))S=29;else y=t[171912+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((S|0)==29)y=t[171864+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0;t[k>>2]=y}else S=32}else S=32;do if((S|0)==32)if(((t[(t[d>>2]|0)+4>>2]|0)>>>4&31|0)<1){t[k>>2]=1;break}else{t[k>>2]=(t[(t[d>>2]|0)+4>>2]|0)>>>4&31;break}while(0);t[k>>2]=(t[k>>2]|0)+((t[(t[v>>2]|0)+4>>2]|0)+(t[b>>2]|0));while(1){v=t[w>>2]|0;if((t[k>>2]|0)<1){t[m>>2]=~~(+((t[v+4>>2]&15)-1-1|0)-+Y(+(+((t[(t[w>>2]|0)+4>>2]&15)-1-1|0)/12))*12+1);t[_>>2]=(t[t[w>>2]>>2]|0)+~~+Y(+(+((t[(t[w>>2]|0)+4>>2]&15)-1-1|0)/12));if(!(t[_>>2]|0))t[_>>2]=(t[_>>2]|0)+-1;if((t[m>>2]|0)<1)t[m>>2]=1;if((t[m>>2]|0)>12)t[m>>2]=12;if(((t[_>>2]|0)%4|0|0)==0?((t[_>>2]|0)%100|0|0)!=0:0)S=46;else if(!((t[_>>2]|0)%400|0))S=46;else F=t[171912+((t[m>>2]|0)-1<<2)>>2]|0;if((S|0)==46){S=0;F=t[171864+((t[m>>2]|0)-1<<2)>>2]|0}t[k>>2]=(t[k>>2]|0)+F;t[b>>2]=-1}else{if(!(t[v>>2]|0))break;if((t[(t[w>>2]|0)+4>>2]&15|0)<1)break;if((t[(t[w>>2]|0)+4>>2]&15|0)>12)break;v=t[k>>2]|0;if(((t[t[w>>2]>>2]|0)%4|0|0)==0?((t[t[w>>2]>>2]|0)%100|0|0)!=0:0)S=55;else if(!((t[t[w>>2]>>2]|0)%400|0))S=55;else O=t[171912+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((S|0)==55){S=0;O=t[171864+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0}if((v|0)<=(O|0))break;v=t[k>>2]|0;if(((t[t[w>>2]>>2]|0)%4|0|0)==0?((t[t[w>>2]>>2]|0)%100|0|0)!=0:0)S=61;else if(!((t[t[w>>2]>>2]|0)%400|0))S=61;else A=t[171912+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((S|0)==61){S=0;A=t[171864+((t[(t[w>>2]|0)+4>>2]&15)-1<<2)>>2]|0}t[k>>2]=v-A;t[b>>2]=1}t[h>>2]=(t[(t[w>>2]|0)+4>>2]&15)+(t[b>>2]|0);v=~~(+((t[h>>2]|0)-1|0)-+Y(+(+((t[h>>2]|0)-1|0)/12))*12+1)>>>0;d=(t[w>>2]|0)+4|0;t[d>>2]=t[d>>2]&-16|v&15;v=(t[t[w>>2]>>2]|0)+(~~+Y(+(+((t[h>>2]|0)-1|0)/12))>>>0)|0;t[t[w>>2]>>2]=v;if(t[t[w>>2]>>2]|0)continue;v=t[w>>2]|0;d=t[v>>2]|0;if((t[h>>2]|0)<1){t[v>>2]=d+-1;continue}else{t[v>>2]=d+1;continue}}h=(t[w>>2]|0)+4|0;t[h>>2]=t[h>>2]&-497|(t[k>>2]&31)<<4;do if((t[t[o>>2]>>2]|0)!=11){if((((t[(t[w>>2]|0)+4>>2]|0)>>>9&31|0)==0?((t[(t[w>>2]|0)+4>>2]|0)>>>14&63|0)==0:0)?!(+l[(t[w>>2]|0)+8>>3]!=0):0){if((t[t[o>>2]>>2]|0)==10)break;if((t[(t[w>>2]|0)+4>>2]&15|0)!=1?((t[(t[w>>2]|0)+4>>2]|0)>>>4&31|0)!=1:0){t[t[o>>2]>>2]=10;break}if((t[t[o>>2]>>2]|0)==9)break;if((t[(t[w>>2]|0)+4>>2]&15|0)==1)break;t[t[o>>2]>>2]=9;break}t[t[o>>2]>>2]=11}while(0);MD(t[c>>2]|0);t[n>>2]=t[o>>2];p=t[n>>2]|0;s=r;return p|0}function pC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[c>>2]=0;t[l>>2]=0;if((((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0)?(u[(t[o>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[o>>2]|0)+1>>0]|0|0)<=57:0)t[l>>2]=(((u[t[o>>2]>>0]|0)-48|0)*10|0)+((u[(t[o>>2]|0)+1>>0]|0)-48);else t[c>>2]=1;t[o>>2]=(t[o>>2]|0)+2;if(t[c>>2]|0){t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}if((t[l>>2]|0)>>>0>=1&(t[l>>2]|0)>>>0<=31){c=(t[f>>2]|0)+4|0;t[c>>2]=t[c>>2]&-497|(t[l>>2]&31)<<4;t[t[a>>2]>>2]=t[o>>2];t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=2;b=t[n>>2]|0;s=r;return b|0}return 0}function EC(e,i){e=e|0;i=i|0;var r=0,n=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[a>>2]=e;t[o>>2]=i;t[l>>2]=0;if(!(t[o>>2]|0)){t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}t[c>>2]=t[t[o>>2]>>2];i=u[t[c>>2]>>0]|0;do if((i|0)==45|(i|0)==43){t[b>>2]=0;t[k>>2]=0;t[b>>2]=(u[t[c>>2]>>0]|0|0)==45&1;t[c>>2]=(t[c>>2]|0)+1;if((((u[t[c>>2]>>0]|0|0)>=48?(u[t[c>>2]>>0]|0|0)<=57:0)?(u[(t[c>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[c>>2]|0)+1>>0]|0|0)<=57:0)t[k>>2]=(((u[t[c>>2]>>0]|0)-48|0)*10|0)+((u[(t[c>>2]|0)+1>>0]|0)-48);else t[l>>2]=1;t[c>>2]=(t[c>>2]|0)+2;if(t[l>>2]|0){t[n>>2]=t[l>>2];h=t[n>>2]|0;s=r;return h|0}if(!((t[k>>2]|0)>=0&(t[k>>2]|0)<=23)){t[n>>2]=2;h=t[n>>2]|0;s=r;return h|0}if((u[t[c>>2]>>0]|0|0)!=58){t[n>>2]=1;h=t[n>>2]|0;s=r;return h|0}t[c>>2]=(t[c>>2]|0)+1;e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-8191|((t[k>>2]|0)*60&4095)<<1&65535;if((((u[t[c>>2]>>0]|0|0)>=48?(u[t[c>>2]>>0]|0|0)<=57:0)?(u[(t[c>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[c>>2]|0)+1>>0]|0|0)<=57:0)t[k>>2]=(((u[t[c>>2]>>0]|0)-48|0)*10|0)+((u[(t[c>>2]|0)+1>>0]|0)-48);else t[l>>2]=1;t[c>>2]=(t[c>>2]|0)+2;if(t[l>>2]|0){t[n>>2]=t[l>>2];h=t[n>>2]|0;s=r;return h|0}if(!((t[k>>2]|0)>=0&(t[k>>2]|0)<=59)){t[n>>2]=2;h=t[n>>2]|0;s=r;return h|0}e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-8191|(((f[e>>1]<<3&65535)<<16>>16>>4<<16>>16)+(t[k>>2]|0)&4095)<<1&65535;if(t[b>>2]|0){e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-8191|(0-((f[(t[a>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16)&4095)<<1&65535}if(((f[(t[a>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)>-840?((f[(t[a>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)<840:0){e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-2|1;break}t[n>>2]=2;h=t[n>>2]|0;s=r;return h|0}else if(!i){e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-2;e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-8191}else if((i|0)==90){
	e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-2|1;e=(t[a>>2]|0)+16|0;f[e>>1]=f[e>>1]&-8191;t[c>>2]=(t[c>>2]|0)+1}else{t[n>>2]=1;h=t[n>>2]|0;s=r;return h|0}while(0);t[t[o>>2]>>2]=t[c>>2];t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}function SC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[c>>2]=0;t[l>>2]=0;if((((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0)?(u[(t[o>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[o>>2]|0)+1>>0]|0|0)<=57:0)t[l>>2]=(((u[t[o>>2]>>0]|0)-48|0)*10|0)+((u[(t[o>>2]|0)+1>>0]|0)-48);else t[c>>2]=1;t[o>>2]=(t[o>>2]|0)+2;if(t[c>>2]|0){t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}if((t[l>>2]|0)>>>0>=1&(t[l>>2]|0)>>>0<=12){c=(t[f>>2]|0)+4|0;t[c>>2]=t[c>>2]&-16|t[l>>2]&15;t[t[a>>2]>>2]=t[o>>2];t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}else{t[n>>2]=2;b=t[n>>2]|0;s=r;return b|0}return 0}function gC(e,i){e=e|0;i=i|0;var r=0,n=0,a=0,o=0,c=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;b=r+12|0;k=r+8|0;h=r;t[a>>2]=e;t[o>>2]=i;t[c>>2]=t[t[o>>2]>>2];t[b>>2]=0;t[k>>2]=0;if((((u[t[c>>2]>>0]|0|0)>=48?(u[t[c>>2]>>0]|0|0)<=57:0)?(u[(t[c>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[c>>2]|0)+1>>0]|0|0)<=57:0)t[k>>2]=(((u[t[c>>2]>>0]|0)-48|0)*10|0)+((u[(t[c>>2]|0)+1>>0]|0)-48);else t[b>>2]=1;t[c>>2]=(t[c>>2]|0)+2;if(t[b>>2]|0){t[n>>2]=t[b>>2];w=t[n>>2]|0;s=r;return w|0}if((u[t[c>>2]>>0]|0|0)!=58){t[n>>2]=1;w=t[n>>2]|0;s=r;return w|0}if(!((t[k>>2]|0)>=0&(t[k>>2]|0)<=23)){t[n>>2]=2;w=t[n>>2]|0;s=r;return w|0}t[c>>2]=(t[c>>2]|0)+1;i=(t[a>>2]|0)+4|0;t[i>>2]=t[i>>2]&-15873|(t[k>>2]&31)<<9;if((((u[t[c>>2]>>0]|0|0)>=48?(u[t[c>>2]>>0]|0|0)<=57:0)?(u[(t[c>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[c>>2]|0)+1>>0]|0|0)<=57:0)t[k>>2]=(((u[t[c>>2]>>0]|0)-48|0)*10|0)+((u[(t[c>>2]|0)+1>>0]|0)-48);else t[b>>2]=1;t[c>>2]=(t[c>>2]|0)+2;if(t[b>>2]|0){t[n>>2]=t[b>>2];w=t[n>>2]|0;s=r;return w|0}if(!((t[k>>2]|0)>=0&(t[k>>2]|0)<=59)){t[n>>2]=2;w=t[n>>2]|0;s=r;return w|0}i=(t[a>>2]|0)+4|0;t[i>>2]=t[i>>2]&-1032193|(t[k>>2]&63)<<14;if((u[t[c>>2]>>0]|0|0)!=58){t[n>>2]=1;w=t[n>>2]|0;s=r;return w|0}t[c>>2]=(t[c>>2]|0)+1;if((((u[t[c>>2]>>0]|0|0)>=48?(u[t[c>>2]>>0]|0|0)<=57:0)?(u[(t[c>>2]|0)+1>>0]|0|0)>=48:0)?(u[(t[c>>2]|0)+1>>0]|0|0)<=57:0)l[(t[a>>2]|0)+8>>3]=+((((u[t[c>>2]>>0]|0)-48|0)*10|0)+((u[(t[c>>2]|0)+1>>0]|0)-48)|0);else t[b>>2]=1;t[c>>2]=(t[c>>2]|0)+2;e:do if((t[b>>2]|0)==0?(u[t[c>>2]>>0]|0|0)==46:0){l[h>>3]=1;t[c>>2]=(t[c>>2]|0)+1;if(!((u[t[c>>2]>>0]|0|0)>=48?(u[t[c>>2]>>0]|0|0)<=57:0))t[b>>2]=1;while(1){if((u[t[c>>2]>>0]|0|0)<48)break e;if((u[t[c>>2]>>0]|0|0)>57)break e;l[h>>3]=+l[h>>3]/10;k=(t[a>>2]|0)+8|0;l[k>>3]=+l[k>>3]+ +((u[t[c>>2]>>0]|0)-48|0)*+l[h>>3];t[c>>2]=(t[c>>2]|0)+1}}while(0);if(t[b>>2]|0){t[n>>2]=t[b>>2];w=t[n>>2]|0;s=r;return w|0}if(((+l[(t[a>>2]|0)+8>>3]>=0?+l[(t[a>>2]|0)+8>>3]<60:0)?((f[(t[a>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)>-840:0)?((f[(t[a>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)<840:0){t[t[o>>2]>>2]=t[c>>2];t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}t[n>>2]=2;w=t[n>>2]|0;s=r;return w|0}function yC(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=t[t[a>>2]>>2];t[l>>2]=0;t[b>>2]=0;if(!((u[t[o>>2]>>0]|0|0)>=48?(u[t[o>>2]>>0]|0|0)<=57:0))k=3;if(((k|0)==3?(u[t[o>>2]>>0]|0|0)!=45:0)?(u[t[o>>2]>>0]|0|0)!=43:0){t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}if((u[t[o>>2]>>0]|0|0)==45){t[l>>2]=1;t[o>>2]=(t[o>>2]|0)+1}t[c>>2]=t[o>>2];while(1){if((u[t[o>>2]>>0]|0|0)<48)break;if((u[t[o>>2]>>0]|0|0)>57)break;t[t[f>>2]>>2]=((t[t[f>>2]>>2]|0)*10|0)+((u[t[o>>2]>>0]|0)-48);t[o>>2]=(t[o>>2]|0)+1;t[b>>2]=(t[b>>2]|0)+1}do if((t[b>>2]|0)>=4){if((t[b>>2]|0)>4?(u[t[c>>2]>>0]|0|0)==48:0)break;if(t[l>>2]|0)t[t[f>>2]>>2]=0-(t[t[f>>2]>>2]|0);if(t[t[f>>2]>>2]|0){t[t[a>>2]>>2]=t[o>>2];t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}else{t[n>>2]=2;h=t[n>>2]|0;s=r;return h|0}}while(0);t[n>>2]=1;h=t[n>>2]|0;s=r;return h|0}function FC(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;e=t[(t[r>>2]|0)+12>>2]&15;t[f>>2]=e;t[f>>2]=(t[f>>2]|0)<=0?1:e;e=t[(t[r>>2]|0)+8>>2]|0;if((t[(t[r>>2]|0)+8>>2]|0)<=0){u=(e*365|0)+((((t[(t[r>>2]|0)+8>>2]|0)+1|0)/4|0)-(((t[(t[r>>2]|0)+8>>2]|0)+1|0)/100|0)+(((t[(t[r>>2]|0)+8>>2]|0)+1|0)/400|0))|0;if(((t[(t[r>>2]|0)+8>>2]|0)%4|0|0)==0?((t[(t[r>>2]|0)+8>>2]|0)%100|0|0)!=0:0)a=5;else if(!((t[(t[r>>2]|0)+8>>2]|0)%400|0))a=5;else o=t[172072+((t[f>>2]|0)-1<<2)>>2]|0;if((a|0)==5)o=t[172024+((t[f>>2]|0)-1<<2)>>2]|0;t[n>>2]=u+(o+0);c=t[n>>2]|0;s=i;return c|0}else{o=((e-1|0)*365|0)+((((t[(t[r>>2]|0)+8>>2]|0)-1|0)/4|0)-(((t[(t[r>>2]|0)+8>>2]|0)-1|0)/100|0)+(((t[(t[r>>2]|0)+8>>2]|0)-1|0)/400|0))|0;if(((t[(t[r>>2]|0)+8>>2]|0)%4|0|0)==0?((t[(t[r>>2]|0)+8>>2]|0)%100|0|0)!=0:0)a=11;else if(!((t[(t[r>>2]|0)+8>>2]|0)%400|0))a=11;else l=t[172072+((t[f>>2]|0)-1<<2)>>2]|0;if((a|0)==11)l=t[172024+((t[f>>2]|0)-1<<2)>>2]|0;t[n>>2]=o+(l+0);c=t[n>>2]|0;s=i;return c|0}return 0}function OC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65792)n=(t[r>>2]|0)<=65855;else n=0;s=i;return n&1|0}function AC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=64256)n=(t[r>>2]|0)<=64335;else n=0;s=i;return n&1|0}function MC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1536)n=(t[r>>2]|0)<=1791;else n=0;s=i;return n&1|0}function RC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=64336)n=(t[r>>2]|0)<=65023;else n=0;s=i;return n&1|0}function NC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65136)n=(t[r>>2]|0)<=65279;else n=0;s=i;return n&1|0}function TC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1328)n=(t[r>>2]|0)<=1423;else n=0;s=i;return n&1|0}function LC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8592)n=(t[r>>2]|0)<=8703;else n=0;s=i;return n&1|0}function DC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=0)n=(t[r>>2]|0)<=127;else n=0;s=i;return n&1|0}function CC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=2432)n=(t[r>>2]|0)<=2559;else n=0;s=i;return n&1|0}function PC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9600)n=(t[r>>2]|0)<=9631;else n=0;s=i;return n&1|0}function BC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12544)n=(t[r>>2]|0)<=12591;else n=0;s=i;return n&1|0}function IC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12704)n=(t[r>>2]|0)<=12735;else n=0;s=i;return n&1|0}function HC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9472)n=(t[r>>2]|0)<=9599;else n=0;s=i;return n&1|0}function xC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=10240)n=(t[r>>2]|0)<=10495;else n=0;s=i;return n&1|0}function UC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5952)n=(t[r>>2]|0)<=5983;else n=0;s=i;return n&1|0}function zC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=118784)n=(t[r>>2]|0)<=119039;else n=0;s=i;return n&1|0}function jC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=13056)n=(t[r>>2]|0)<=13311;else n=0;s=i;return n&1|0}function VC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65072)n=(t[r>>2]|0)<=65103;else n=0;s=i;return n&1|0}function qC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=63744)n=(t[r>>2]|0)<=64255;else n=0;s=i;return n&1|0}function YC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=194560)n=(t[r>>2]|0)<=195103;else n=0;s=i;return n&1|0}function GC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=11904)n=(t[r>>2]|0)<=12031;else n=0;s=i;return n&1|0}function WC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12288)n=(t[r>>2]|0)<=12351;else n=0;s=i;return n&1|0}function KC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=19968)n=(t[r>>2]|0)<=40959;else n=0;s=i;return n&1|0}function XC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=13312)n=(t[r>>2]|0)<=19903;else n=0;s=i;return n&1|0}function ZC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=131072)n=(t[r>>2]|0)<=173791;else n=0;s=i;return n&1|0}function JC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5024)n=(t[r>>2]|0)<=5119;else n=0;s=i;return n&1|0}function QC(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=768)n=(t[r>>2]|0)<=879;else n=0;s=i;return n&1|0}function $C(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8400)n=(t[r>>2]|0)<=8447;else n=0;s=i;return n&1|0}function eP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65056)n=(t[r>>2]|0)<=65071;else n=0;s=i;return n&1|0}function iP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8400)n=(t[r>>2]|0)<=8447;else n=0;s=i;return n&1|0}function rP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9216)n=(t[r>>2]|0)<=9279;else n=0;s=i;return n&1|0}function nP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8352)n=(t[r>>2]|0)<=8399;else n=0;s=i;return n&1|0}function fP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=67584)n=(t[r>>2]|0)<=67647;else n=0;s=i;return n&1|0}function tP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1024)n=(t[r>>2]|0)<=1279;else n=0;s=i;return n&1|0}function uP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1280)n=(t[r>>2]|0)<=1327;else n=0;s=i;return n&1|0}function aP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=66560)n=(t[r>>2]|0)<=66639;else n=0;s=i;return n&1|0}function oP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=2304)n=(t[r>>2]|0)<=2431;else n=0;s=i;return n&1|0}function cP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9984)n=(t[r>>2]|0)<=10175;else n=0;s=i;return n&1|0}function lP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9312)n=(t[r>>2]|0)<=9471;else n=0;s=i;return n&1|0}function sP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12800)n=(t[r>>2]|0)<=13055;else n=0;s=i;return n&1|0}function bP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=4608)n=(t[r>>2]|0)<=4991;else n=0;s=i;return n&1|0}function kP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8192)n=(t[r>>2]|0)<=8303;else n=0;s=i;return n&1|0}function hP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9632)n=(t[r>>2]|0)<=9727;else n=0;s=i;return n&1|0}function wP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=4256)n=(t[r>>2]|0)<=4351;else n=0;s=i;return n&1|0}function dP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=66352)n=(t[r>>2]|0)<=66383;else n=0;s=i;return n&1|0}function vP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=880)n=(t[r>>2]|0)<=1023;else n=0;s=i;return n&1|0}function mP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=7936)n=(t[r>>2]|0)<=8191;else n=0;s=i;return n&1|0}function _P(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=880)n=(t[r>>2]|0)<=1023;else n=0;s=i;return n&1|0}function pP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=2688)n=(t[r>>2]|0)<=2815;else n=0;s=i;return n&1|0}function EP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=2560)n=(t[r>>2]|0)<=2687;else n=0;s=i;return n&1|0}function SP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65280)n=(t[r>>2]|0)<=65519;else n=0;s=i;return n&1|0}function gP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12592)n=(t[r>>2]|0)<=12687;else n=0;s=i;return n&1|0}function yP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=4352)n=(t[r>>2]|0)<=4607;else n=0;s=i;return n&1|0}function FP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=44032)n=(t[r>>2]|0)<=55215;else n=0;s=i;return n&1|0}function OP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5920)n=(t[r>>2]|0)<=5951;else n=0;s=i;return n&1|0}function AP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1424)n=(t[r>>2]|0)<=1535;else n=0;s=i;return n&1|0}function MP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=56192)n=(t[r>>2]|0)<=56319;else n=0;s=i;return n&1|0}function RP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=55296)n=(t[r>>2]|0)<=56191;else n=0;s=i;return n&1|0}function NP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12352)n=(t[r>>2]|0)<=12447;else n=0;s=i;return n&1|0}function TP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=592)n=(t[r>>2]|0)<=687;else n=0;s=i;return n&1|0}function LP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12272)n=(t[r>>2]|0)<=12287;else n=0;s=i;return n&1|0}function DP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12688)n=(t[r>>2]|0)<=12703;else n=0;s=i;return n&1|0}function CP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12032)n=(t[r>>2]|0)<=12255;else n=0;s=i;return n&1|0}function PP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3200)n=(t[r>>2]|0)<=3327;else n=0;s=i;return n&1|0}function BP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12448)n=(t[r>>2]|0)<=12543;else n=0;s=i;return n&1|0}function IP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=12784)n=(t[r>>2]|0)<=12799;else n=0;s=i;return n&1|0}function HP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=6016)n=(t[r>>2]|0)<=6143;else n=0;s=i;return n&1|0}function xP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=6624)n=(t[r>>2]|0)<=6655;else n=0;s=i;return n&1|0}function UP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3712)n=(t[r>>2]|0)<=3839;else n=0;s=i;return n&1|0}function zP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=128)n=(t[r>>2]|0)<=255;else n=0;s=i;return n&1|0}function jP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=256)n=(t[r>>2]|0)<=383;else n=0;s=i;return n&1|0}function VP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=384)n=(t[r>>2]|0)<=591;else n=0;s=i;return n&1|0}function qP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=7680)n=(t[r>>2]|0)<=7935;else n=0;s=i;return n&1|0}function YP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8448)n=(t[r>>2]|0)<=8527;else n=0;s=i;return n&1|0}function GP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=6400)n=(t[r>>2]|0)<=6479;else n=0;s=i;return n&1|0}function WP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65664)n=(t[r>>2]|0)<=65791;else n=0;s=i;return n&1|0}function KP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65536)n=(t[r>>2]|0)<=65663;else n=0;s=i;return n&1|0}function XP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=56320)n=(t[r>>2]|0)<=57343;else n=0;s=i;return n&1|0}function ZP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3328)n=(t[r>>2]|0)<=3455;else n=0;s=i;return n&1|0}function JP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=119808)n=(t[r>>2]|0)<=120831;else n=0;s=i;return n&1|0}function QP(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8704)n=(t[r>>2]|0)<=8959;else n=0;s=i;return n&1|0}function $P(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=10176)n=(t[r>>2]|0)<=10223;else n=0;s=i;return n&1|0}function eB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=10624)n=(t[r>>2]|0)<=10751;else n=0;s=i;return n&1|0}function iB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9728)n=(t[r>>2]|0)<=9983;else n=0;s=i;return n&1|0}function rB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=11008)n=(t[r>>2]|0)<=11263;else n=0;s=i;return n&1|0}function nB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8960)n=(t[r>>2]|0)<=9215;else n=0;s=i;return n&1|0}function fB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=6144)n=(t[r>>2]|0)<=6319;else n=0;s=i;return n&1|0}function tB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=119040)n=(t[r>>2]|0)<=119295;else n=0;s=i;return n&1|0}function uB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=4096)n=(t[r>>2]|0)<=4255;else n=0;s=i;return n&1|0}function aB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8528)n=(t[r>>2]|0)<=8591;else n=0;s=i;return n&1|0}function oB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5760)n=(t[r>>2]|0)<=5791;else n=0;s=i;return n&1|0}function cB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=66304)n=(t[r>>2]|0)<=66351;else n=0;s=i;return n&1|0}function lB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=9280)n=(t[r>>2]|0)<=9311;else n=0;s=i;return n&1|0}function sB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=2816)n=(t[r>>2]|0)<=2943;else n=0;s=i;return n&1|0}function bB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=66688)n=(t[r>>2]|0)<=66735;else n=0;s=i;return n&1|0}function kB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=7424)n=(t[r>>2]|0)<=7551;else n=0;s=i;return n&1|0}function hB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!((t[r>>2]|0)>=57344&(t[r>>2]|0)<=63743)?!((t[r>>2]|0)>=983040&(t[r>>2]|0)<=1048575):0)if((t[r>>2]|0)>=1048576)n=(t[r>>2]|0)<=1114111;else n=0;else n=1;s=i;return n&1|0}function wB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=57344)n=(t[r>>2]|0)<=63743;else n=0;s=i;return n&1|0}function dB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5792)n=(t[r>>2]|0)<=5887;else n=0;s=i;return n&1|0}function vB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=66640)n=(t[r>>2]|0)<=66687;else n=0;s=i;return n&1|0}function mB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3456)n=(t[r>>2]|0)<=3583;else n=0;s=i;return n&1|0}function _B(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65104)n=(t[r>>2]|0)<=65135;else n=0;s=i;return n&1|0}function pB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=688)n=(t[r>>2]|0)<=767;else n=0;s=i;return n&1|0}function EB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65520)n=(t[r>>2]|0)<=65535;else n=0;s=i;return n&1|0}function SB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=8304)n=(t[r>>2]|0)<=8351;else n=0;s=i;return n&1|0}function gB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=10224)n=(t[r>>2]|0)<=10239;else n=0;s=i;return n&1|0}function yB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=10496)n=(t[r>>2]|0)<=10623;else n=0;s=i;return n&1|0}function FB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=10752)n=(t[r>>2]|0)<=11007;else n=0;s=i;return n&1|0}function OB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=983040)n=(t[r>>2]|0)<=1048575;else n=0;s=i;return n&1|0}function AB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1048576)n=(t[r>>2]|0)<=1114111;else n=0;s=i;return n&1|0}function MB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1792)n=(t[r>>2]|0)<=1871;else n=0;s=i;return n&1|0}function RB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5888)n=(t[r>>2]|0)<=5919;else n=0;s=i;return n&1|0}function NB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5984)n=(t[r>>2]|0)<=6015;else n=0;s=i;return n&1|0}function TB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=917504)n=(t[r>>2]|0)<=917631;else n=0;s=i;return n&1|0}function LB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=6480)n=(t[r>>2]|0)<=6527;else n=0;s=i;return n&1|0}function DB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=119552)n=(t[r>>2]|0)<=119647;else n=0;s=i;return n&1|0}function CB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=2944)n=(t[r>>2]|0)<=3071;else n=0;s=i;return n&1|0}function PB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3072)n=(t[r>>2]|0)<=3199;else n=0;s=i;return n&1|0}function BB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=1920)n=(t[r>>2]|0)<=1983;else n=0;s=i;return n&1|0}function IB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3584)n=(t[r>>2]|0)<=3711;else n=0;s=i;return n&1|0}function HB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=3840)n=(t[r>>2]|0)<=4095;else n=0;s=i;return n&1|0}function xB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=66432)n=(t[r>>2]|0)<=66463;else n=0;s=i;return n&1|0}function UB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=5120)n=(t[r>>2]|0)<=5759;else n=0;s=i;return n&1|0}function zB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=65024)n=(t[r>>2]|0)<=65039;else n=0;s=i;return n&1|0}function jB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=917760)n=(t[r>>2]|0)<=917999;else n=0;s=i;return n&1|0}function VB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=42128)n=(t[r>>2]|0)<=42191;else n=0;s=i;return n&1|0}function qB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=40960)n=(t[r>>2]|0)<=42127;else n=0;s=i;return n&1|0}function YB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)>=19904)n=(t[r>>2]|0)<=19967;else n=0;s=i;return n&1|0}function GB(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=MI(172456,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=gAi[t[a>>2]&511](t[f>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}return 0}function WB(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172464)|0;s=i;return e|0}function KB(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!((t[r>>2]|0)>=0&(t[r>>2]|0)<=31))if((t[r>>2]|0)>=127)n=(t[r>>2]|0)<=159;else n=0;else n=1;s=i;return n&1|0}function XB(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172480)|0;s=i;return e|0}function ZB(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)==57344|(t[r>>2]|0)==63743|(t[r>>2]|0)==983040|(t[r>>2]|0)==1048573|(t[r>>2]|0)==1048576){n=1;f=n&1;s=i;return f|0}n=(t[r>>2]|0)==1114109;f=n&1;s=i;return f|0}function JB(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172496)|0;s=i;return e|0}function QB(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172512)|0;s=i;return e|0}function $B(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172528)|0;s=i;return e|0}function eI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172544)|0;s=i;return e|0}function iI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172560)|0;s=i;return e|0}function rI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172576)|0;s=i;return e|0}function nI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172592)|0;s=i;return e|0}function fI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172608)|0;s=i;return e|0}function tI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!((t[r>>2]|0)>=1160&(t[r>>2]|0)<=1161|(t[r>>2]|0)==1758)?!((t[r>>2]|0)>=8413&(t[r>>2]|0)<=8416):0)if((t[r>>2]|0)>=8418)n=(t[r>>2]|0)<=8420;else n=0;else n=1;s=i;return n&1|0}function uI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172624)|0;s=i;return e|0}function aI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172640)|0;s=i;return e|0}function oI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172656)|0;s=i;return e|0}function cI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(((!((t[r>>2]|0)>=5870&(t[r>>2]|0)<=5872)?!((t[r>>2]|0)>=8544&(t[r>>2]|0)<=8579|(t[r>>2]|0)==12295):0)?!((t[r>>2]|0)>=12321&(t[r>>2]|0)<=12329):0)?!((t[r>>2]|0)>=12344&(t[r>>2]|0)<=12346):0)n=(t[r>>2]|0)==66378;else n=1;s=i;return n&1|0}function lI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172672)|0;s=i;return e|0}function sI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172688)|0;s=i;return e|0}function bI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((((t[r>>2]|0)!=95?!((t[r>>2]|0)>=8255&(t[r>>2]|0)<=8256|(t[r>>2]|0)==8276|(t[r>>2]|0)==12539):0)?!((t[r>>2]|0)>=65075&(t[r>>2]|0)<=65076):0)?!((t[r>>2]|0)>=65101&(t[r>>2]|0)<=65103|(t[r>>2]|0)==65343):0)n=(t[r>>2]|0)==65381;else n=1;s=i;return n&1|0}function kI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172704)|0;s=i;return e|0}function hI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172720)|0;s=i;return e|0}function wI(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)==187|(t[r>>2]|0)==8217|(t[r>>2]|0)==8221){n=1;f=n&1;s=i;return f|0}n=(t[r>>2]|0)==8250;f=n&1;s=i;return f|0}function dI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!((t[r>>2]|0)==171|(t[r>>2]|0)==8216)?!((t[r>>2]|0)>=8219&(t[r>>2]|0)<=8220|(t[r>>2]|0)==8223):0)n=(t[r>>2]|0)==8249;else n=1;s=i;return n&1|0}function vI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172736)|0;s=i;return e|0}function mI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172752)|0;s=i;return e|0}function _I(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172768)|0;s=i;return e|0}function pI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172784)|0;s=i;return e|0}function EI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172800)|0;s=i;return e|0}function SI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172816)|0;s=i;return e|0}function gI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172832)|0;s=i;return e|0}function yI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;e=dj(t[r>>2]|0,172848)|0;s=i;return e|0}function FI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;s=i;return(t[r>>2]|0)==8232|0}function OI(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;s=i;return(t[r>>2]|0)==8233|0}function AI(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if((t[r>>2]|0)==32|(t[r>>2]|0)==160|(t[r>>2]|0)==5760|(t[r>>2]|0)==6158){n=1;f=n&1;s=i;return f|0}if((t[r>>2]|0)>=8192&(t[r>>2]|0)<=8202|(t[r>>2]|0)==8239|(t[r>>2]|0)==8287){n=1;f=n&1;s=i;return f|0}n=(t[r>>2]|0)==12288;f=n&1;s=i;return f|0}function MI(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[a>>2]=0;t[o>>2]=(t[(t[f>>2]|0)+4>>2]|0)-1;t[b>>2]=t[t[f>>2]>>2];while(1){if((t[a>>2]|0)>(t[o>>2]|0)){h=10;break}t[c>>2]=((t[a>>2]|0)+(t[o>>2]|0)|0)/2|0;f=MY(t[u>>2]|0,t[(t[b>>2]|0)+(t[c>>2]<<3)>>2]|0)|0;t[l>>2]=f;if(!f){h=6;break}f=t[c>>2]|0;if((t[l>>2]|0)<0){t[o>>2]=f-1;continue}else{t[a>>2]=f+1;continue}}if((h|0)==6){t[n>>2]=t[(t[b>>2]|0)+(t[c>>2]<<3)+4>>2];k=t[n>>2]|0;s=r;return k|0}else if((h|0)==10){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}return 0}function RI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;i=s;s=s+48|0;r=i+36|0;n=i+32|0;f=i+28|0;u=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+4|0;h=i;t[n>>2]=e;t[u>>2]=0;t[o>>2]=0;t[c>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}t[(t[n>>2]|0)+68>>2]=0;e=t[n>>2]|0;if(t[(t[n>>2]|0)+4>>2]|0){t[r>>2]=$I(e)|0;w=t[r>>2]|0;s=i;return w|0}if(!(t[e+20>>2]|0)){t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}e=t[n>>2]|0;if(!(t[t[n>>2]>>2]|0)){t[e>>2]=1;do{t[f>>2]=eH(t[n>>2]|0)|0;d=t[n>>2]|0;if((t[f>>2]|0)<0){v=10;break}if(t[(t[d+20>>2]|0)+52>>2]|0)break;if((t[t[n>>2]>>2]|0)==3)break}while((t[(t[n>>2]|0)+16>>2]|0)!=5);if((v|0)==10){t[d>>2]=2;t[(t[n>>2]|0)+16>>2]=6;t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}d=(t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0)!=0;do if(!(t[(t[(t[n>>2]|0)+20>>2]|0)+52>>2]|0)){if(d)t[(t[n>>2]|0)+64>>2]=t[(t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0)+12>>2];m=t[n>>2]|0;if(t[(t[n>>2]|0)+64>>2]|0){t[m+16>>2]=1;break}t[m>>2]=2;t[(t[n>>2]|0)+16>>2]=6;t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else{if(d)t[(t[n>>2]|0)+64>>2]=t[(t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0)+12>>2];if(!(t[(t[n>>2]|0)+64>>2]|0))t[(t[n>>2]|0)+64>>2]=t[t[(t[(t[n>>2]|0)+20>>2]|0)+64>>2]>>2];t[(t[n>>2]|0)+16>>2]=1}while(0);t[(t[n>>2]|0)+72>>2]=0;t[(t[(t[n>>2]|0)+20>>2]|0)+436>>2]=5;v=108}else{t[o>>2]=t[e+16>>2];t[u>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+56>>2];t[c>>2]=t[(t[n>>2]|0)+64>>2]}e:while(1){if((v|0)==108){v=0;do if((t[(t[n>>2]|0)+64>>2]|0)!=0?(t[(t[(t[n>>2]|0)+64>>2]|0)+24>>2]|0)==0:0){if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=3?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=4:0)break;if(!(NI(t[n>>2]|0)|0)){v=113;break e}}while(0);do if((((t[(t[n>>2]|0)+156>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+36>>2]|0)!=0:0){if((Xl(t[(t[(t[(t[n>>2]|0)+64>>2]|0)+36>>2]|0)+8>>2]|0,187376)|0)==0?(Xl(t[(t[(t[(t[n>>2]|0)+64>>2]|0)+36>>2]|0)+8>>2]|0,187408)|0)==0:0)break;if(!(t[(t[n>>2]|0)+164>>2]|0)){e=Eo(t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0)|0;t[(t[n>>2]|0)+164>>2]=e;go(t[(t[n>>2]|0)+164>>2]|0,t[(t[n>>2]|0)+188>>2]&-32769)|0}if(!(NI(t[n>>2]|0)|0)){v=123;break e}Ao(t[(t[n>>2]|0)+164>>2]|0,t[(t[n>>2]|0)+64>>2]|0)|0}while(0);if((t[(t[n>>2]|0)+64>>2]|0)!=0?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==19:0){e=(t[n>>2]|0)+168|0;t[e>>2]=(t[e>>2]|0)+1;continue}if((t[(t[n>>2]|0)+64>>2]|0)!=0?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==20:0){e=(t[n>>2]|0)+168|0;t[e>>2]=(t[e>>2]|0)+-1;continue}if((((t[(t[n>>2]|0)+64>>2]|0)!=0?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==5:0)?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+20>>2]|0)+16>>2]|0)==1:0){if(((t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)==0?(t[t[(t[n>>2]|0)+20>>2]>>2]|0)!=0:0)?(t[(t[t[(t[n>>2]|0)+20>>2]>>2]|0)+20>>2]|0)!=0:0){e=MAi[t[(t[t[(t[n>>2]|0)+20>>2]>>2]|0)+20>>2]&511](t[(t[n>>2]|0)+20>>2]|0,t[(t[(t[n>>2]|0)+64>>2]|0)+8>>2]|0)|0;t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]=e}if(((t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)!=0?(t[(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)+4>>2]|0)==17:0)?(t[(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){nH(t[n>>2]|0,t[(t[n>>2]|0)+64>>2]|0)|0;t[(t[n>>2]|0)+64>>2]=t[(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)+12>>2]}}else v=143;if(((((v|0)==143?(v=0,(t[(t[n>>2]|0)+64>>2]|0)!=0):0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==5:0)?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)?(t[(t[n>>2]|0)+8>>2]|0)!=0:0)fH(t[n>>2]|0);if(!(t[(t[n>>2]|0)+64>>2]|0)){v=153;break}if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=17){v=153;break}if(!(t[(t[n>>2]|0)+92>>2]|0)){v=153;break}if((t[(t[(t[n>>2]|0)+92>>2]|0)+12>>2]|0)!=(t[(t[n>>2]|0)+64>>2]|0)){v=153;break}e=tH(t[n>>2]|0)|0;t[(t[n>>2]|0)+64>>2]=e;e=(t[n>>2]|0)+72|0;t[e>>2]=(t[e>>2]|0)+1}if(!(t[(t[n>>2]|0)+64>>2]|0)){v=28;break}i:while(1){if(!(t[(t[n>>2]|0)+64>>2]|0))break;if(t[(t[(t[n>>2]|0)+64>>2]|0)+24>>2]|0)break;if((t[(t[(t[n>>2]|0)+20>>2]|0)+56>>2]|0)!=(t[u>>2]|0))break;do if(((t[o>>2]|0)!=4?(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=5:0){if(((t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)!=0?(t[(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(t[(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)+24>>2]|0)==0:0)break;if(((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=14?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=9:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=13:0)break i}while(0);if(((t[(t[(t[n>>2]|0)+20>>2]|0)+52>>2]|0)!=0?(t[(t[(t[n>>2]|0)+20>>2]|0)+52>>2]|0)!=(t[(t[n>>2]|0)+64>>2]|0):0)?(t[(t[(t[n>>2]|0)+20>>2]|0)+52>>2]|0)!=(t[(t[(t[n>>2]|0)+64>>2]|0)+20>>2]|0):0)break;
	if((t[(t[(t[n>>2]|0)+20>>2]|0)+172>>2]|0)==-1)break;t[f>>2]=eH(t[n>>2]|0)|0;_=t[n>>2]|0;if((t[f>>2]|0)<0){v=48;break e}if(!(t[_+64>>2]|0))break e}if(((((t[o>>2]|0)!=4?(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=5:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=19:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=14:0){t[(t[n>>2]|0)+64>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2];e=(t[n>>2]|0)+72|0;t[e>>2]=(t[e>>2]|0)+1;t[(t[n>>2]|0)+16>>2]=1;v=108;continue}e=(t[o>>2]|0)==1;if(t[(t[(t[n>>2]|0)+64>>2]|0)+24>>2]|0){if((((e?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)==0:0)?((a[(t[(t[n>>2]|0)+64>>2]|0)+58>>1]|0)&1|0)==0:0)?(t[(t[n>>2]|0)+168>>2]|0)<=0:0){t[(t[n>>2]|0)+16>>2]=2;v=108;continue}if((t[(t[n>>2]|0)+8>>2]|0)!=0?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)iH(t[n>>2]|0);if((t[(t[n>>2]|0)+184>>2]|0)>0?((a[(t[(t[n>>2]|0)+64>>2]|0)+58>>1]|0)&4|0)!=0:0){d=(t[n>>2]|0)+184|0;t[d>>2]=(t[d>>2]|0)+-1}t[(t[n>>2]|0)+64>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+24>>2];t[(t[n>>2]|0)+16>>2]=1;if(t[(t[n>>2]|0)+184>>2]|0){v=108;continue}if(t[(t[n>>2]|0)+168>>2]|0){v=108;continue}if(t[(t[n>>2]|0)+96>>2]|0){v=108;continue}if(!(t[(t[(t[n>>2]|0)+64>>2]|0)+28>>2]|0)){v=108;continue}if((t[(t[(t[(t[n>>2]|0)+64>>2]|0)+28>>2]|0)+4>>2]|0)==14){v=108;continue}t[l>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+28>>2];if((a[(t[l>>2]|0)+58>>1]|0)&2){v=108;continue}iy(t[l>>2]|0);rH(t[n>>2]|0,t[l>>2]|0);v=108;continue}if(((e?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0)==0:0)?((a[(t[(t[n>>2]|0)+64>>2]|0)+58>>1]|0)&1|0)==0:0){t[(t[n>>2]|0)+16>>2]=2;v=108;continue}if((t[(t[n>>2]|0)+8>>2]|0)!=0?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)iH(t[n>>2]|0);if((t[(t[n>>2]|0)+184>>2]|0)>0?((a[(t[(t[n>>2]|0)+64>>2]|0)+58>>1]|0)&4|0)!=0:0){e=(t[n>>2]|0)+184|0;t[e>>2]=(t[e>>2]|0)+-1}t[(t[n>>2]|0)+64>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+20>>2];if(!(t[(t[n>>2]|0)+64>>2]|0)){v=91;break}if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==9){v=91;break}if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==21){v=91;break}if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==13){v=91;break}do if((((t[(t[n>>2]|0)+184>>2]|0)==0?(t[(t[n>>2]|0)+168>>2]|0)==0:0)?(t[(t[n>>2]|0)+96>>2]|0)==0:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+16>>2]|0)!=0:0){if((a[(t[(t[(t[n>>2]|0)+64>>2]|0)+16>>2]|0)+58>>1]|0)&2)break;t[b>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+16>>2];iy(t[b>>2]|0);rH(t[n>>2]|0,t[b>>2]|0)}while(0);e=(t[n>>2]|0)+72|0;t[e>>2]=(t[e>>2]|0)+-1;t[(t[n>>2]|0)+16>>2]=4;v=108}if((v|0)==28)if((t[t[n>>2]>>2]|0)==3){t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}else{t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else if((v|0)==48){t[_>>2]=2;t[(t[n>>2]|0)+16>>2]=6;t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else if((v|0)==91){if((t[t[n>>2]>>2]|0)!=3?(t[f>>2]=nS(t[(t[n>>2]|0)+20>>2]|0,187368,0,1)|0,t[(t[n>>2]|0)+16>>2]=5,(t[f>>2]|0)!=0):0){t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}t[(t[n>>2]|0)+64>>2]=0;t[(t[n>>2]|0)+72>>2]=-1;if((((((t[c>>2]|0)!=0?(t[(t[n>>2]|0)+184>>2]|0)==0:0)?(t[(t[n>>2]|0)+168>>2]|0)==0:0)?(t[(t[n>>2]|0)+96>>2]|0)==0:0)?(t[(t[c>>2]|0)+4>>2]|0)!=14:0)?((a[(t[c>>2]|0)+58>>1]|0)&2|0)==0:0){iy(t[c>>2]|0);rH(t[n>>2]|0,t[c>>2]|0)}}else if((v|0)==113){t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else if((v|0)==123){t[r>>2]=-1;w=t[r>>2]|0;s=i;return w|0}else if((v|0)==153){do if((t[(t[n>>2]|0)+8>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0){t[k>>2]=t[(t[n>>2]|0)+64>>2];if(((t[(t[k>>2]|0)+4>>2]|0)==1?(t[(t[n>>2]|0)+16>>2]|0)!=2:0)?(t[(t[n>>2]|0)+16>>2]|0)!=4:0){uH(t[n>>2]|0);break}if((t[(t[k>>2]|0)+4>>2]|0)!=3?(t[(t[k>>2]|0)+4>>2]|0)!=4:0)break;v=t[n>>2]|0;c=t[(t[k>>2]|0)+40>>2]|0;aH(v,c,rs(t[(t[k>>2]|0)+40>>2]|0)|0)}while(0);e:do if(((t[(t[n>>2]|0)+172>>2]|0)>0?(t[(t[n>>2]|0)+16>>2]|0)!=2:0)?(t[(t[n>>2]|0)+16>>2]|0)!=4:0){t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[(t[n>>2]|0)+172>>2]|0))break e;if((Oj(t[(t[(t[n>>2]|0)+180>>2]|0)+(t[h>>2]<<2)>>2]|0,t[(t[n>>2]|0)+64>>2]|0)|0)==1)break;t[h>>2]=(t[h>>2]|0)+1}TI(t[n>>2]|0)|0}while(0);if(((t[(t[n>>2]|0)+8>>2]|0)==4?(t[(t[n>>2]|0)+148>>2]|0)==0:0)?(t[(t[n>>2]|0)+140>>2]|0)!=0:0){h=((xk(t[(t[n>>2]|0)+140>>2]|0)|0)!=0^1)&1;t[(t[n>>2]|0)+148>>2]=h}t[r>>2]=1;w=t[r>>2]|0;s=i;return w|0}t[(t[n>>2]|0)+16>>2]=5;t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}function NI(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0){e=t[n>>2]|0;if(t[(t[n>>2]|0)+4>>2]|0){t[r>>2]=t[e+64>>2];break}if(!(t[e+20>>2]|0)){t[r>>2]=0;break}if((oH(t[n>>2]|0)|0)<0){t[r>>2]=0;break}else{t[r>>2]=t[(t[n>>2]|0)+64>>2];break}}else f=3;while(0);if((f|0)==3)t[r>>2]=0;s=i;return t[r>>2]|0}function TI(e){e=e|0;var i=0,r=0,n=0,u=0,o=0,c=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;u=i+4|0;o=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0)t[u>>2]=t[e+68>>2];else t[u>>2]=t[e+64>>2];if(!(t[u>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}if((t[(t[u>>2]|0)+4>>2]|0)!=9?(t[(t[u>>2]|0)+4>>2]|0)!=14:0){e=(t[u>>2]|0)+58|0;f[e>>1]=a[e>>1]|0|2;e=(t[u>>2]|0)+58|0;f[e>>1]=a[e>>1]|0|4}e=(t[n>>2]|0)+184|0;t[e>>2]=(t[e>>2]|0)+1;t[o>>2]=t[(t[u>>2]|0)+20>>2];while(1){if(!(t[o>>2]|0))break;if((t[(t[o>>2]|0)+4>>2]|0)==1){e=(t[o>>2]|0)+58|0;f[e>>1]=a[e>>1]|0|2}t[o>>2]=t[(t[o>>2]|0)+20>>2]}t[r>>2]=t[u>>2];c=t[r>>2]|0;s=i;return c|0}function LI(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[u>>2]=e;t[a>>2]=i;if(!(t[u>>2]|0)){t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[o>>2]=gAi[t[135744>>2]&511](196)|0;if(!(t[o>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187440,n);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}VY(t[o>>2]|0,0,196)|0;t[(t[o>>2]|0)+4>>2]=0;t[(t[o>>2]|0)+104>>2]=0;t[(t[o>>2]|0)+100>>2]=0;t[(t[o>>2]|0)+96>>2]=0;t[(t[o>>2]|0)+28>>2]=t[u>>2];i=vs(100)|0;t[(t[o>>2]|0)+84>>2]=i;if(!(t[(t[o>>2]|0)+84>>2]|0)){pAi[t[135736>>2]&511](t[o>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,187440,n);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}i=gAi[t[135744>>2]&511](128)|0;t[(t[o>>2]|0)+24>>2]=i;i=t[o>>2]|0;if(!(t[(t[o>>2]|0)+24>>2]|0)){Ss(t[i+84>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);yAi[t[135904>>2]&511](t[33980]|0,187440,n);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}ij(t[i+24>>2]|0,2)|0;t[(t[o>>2]|0)+32>>2]=t[(t[(t[o>>2]|0)+24>>2]|0)+56>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+56>>2]=361;t[(t[o>>2]|0)+36>>2]=t[(t[(t[o>>2]|0)+24>>2]|0)+60>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+60>>2]=362;i=t[o>>2]|0;if((t[(t[(t[o>>2]|0)+24>>2]|0)+108>>2]|0)==-554844497){t[(t[o>>2]|0)+40>>2]=t[(t[i+24>>2]|0)+116>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+116>>2]=363;t[(t[o>>2]|0)+44>>2]=t[(t[(t[o>>2]|0)+24>>2]|0)+120>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+120>>2]=364}else{t[i+40>>2]=0;t[(t[o>>2]|0)+44>>2]=0}t[(t[o>>2]|0)+48>>2]=t[(t[(t[o>>2]|0)+24>>2]|0)+68>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+68>>2]=365;t[(t[(t[o>>2]|0)+24>>2]|0)+72>>2]=365;t[(t[o>>2]|0)+52>>2]=t[(t[(t[o>>2]|0)+24>>2]|0)+100>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+100>>2]=366;t[t[o>>2]>>2]=0;t[(t[o>>2]|0)+64>>2]=0;t[(t[o>>2]|0)+68>>2]=0;if((Ts(t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0<4)QO(t[u>>2]|0,4)|0;u=(Ts(t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0>=4;i=t[(t[o>>2]|0)+24>>2]|0;if(u){u=Os(t[(t[(t[o>>2]|0)+28>>2]|0)+16>>2]|0)|0;e=fS(i,0,u,4,t[a>>2]|0)|0;t[(t[o>>2]|0)+20>>2]=e;t[(t[o>>2]|0)+56>>2]=0;t[(t[o>>2]|0)+60>>2]=4}else{e=fS(i,0,0,0,t[a>>2]|0)|0;t[(t[o>>2]|0)+20>>2]=e;t[(t[o>>2]|0)+56>>2]=0;t[(t[o>>2]|0)+60>>2]=0}if(!(t[(t[o>>2]|0)+20>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187440,n);Ss(t[(t[o>>2]|0)+84>>2]|0);pAi[t[135736>>2]&511](t[(t[o>>2]|0)+24>>2]|0);pAi[t[135736>>2]&511](t[o>>2]|0);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}else{t[(t[(t[o>>2]|0)+20>>2]|0)+436>>2]=5;t[(t[(t[o>>2]|0)+20>>2]|0)+272>>2]=t[o>>2];t[(t[(t[o>>2]|0)+20>>2]|0)+280>>2]=1;t[(t[(t[o>>2]|0)+20>>2]|0)+364>>2]=1;t[(t[o>>2]|0)+12>>2]=2;t[(t[(t[o>>2]|0)+20>>2]|0)+308>>2]=1;t[(t[o>>2]|0)+88>>2]=t[(t[(t[o>>2]|0)+20>>2]|0)+296>>2];t[(t[o>>2]|0)+156>>2]=0;t[(t[o>>2]|0)+176>>2]=0;t[(t[o>>2]|0)+180>>2]=0;t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}return 0}function DI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;a=i;t[n>>2]=e;t[a>>2]=0;t[f>>2]=zO(t[n>>2]|0,0)|0;if(!(t[f>>2]|0)){t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}t[u>>2]=LI(t[f>>2]|0,t[n>>2]|0)|0;if(!(t[u>>2]|0)){IO(t[f>>2]|0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}f=(t[u>>2]|0)+12|0;t[f>>2]=t[f>>2]|1;if(!(t[(t[(t[u>>2]|0)+20>>2]|0)+180>>2]|0))t[a>>2]=rA(t[n>>2]|0)|0;if((t[a>>2]|0)!=0?(t[(t[(t[u>>2]|0)+20>>2]|0)+180>>2]|0)==0:0){n=Yl(t[a>>2]|0)|0;t[(t[(t[u>>2]|0)+20>>2]|0)+180>>2]=n}if(t[a>>2]|0)pAi[t[135736>>2]&511](t[a>>2]|0);t[r>>2]=t[u>>2];o=t[r>>2]|0;s=i;return o|0}function CI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+116>>2]|0){CH(t[(t[r>>2]|0)+116>>2]|0);t[(t[r>>2]|0)+116>>2]=0}if(t[(t[r>>2]|0)+120>>2]|0){if(!(t[(t[r>>2]|0)+124>>2]|0))GH(t[(t[r>>2]|0)+120>>2]|0);t[(t[r>>2]|0)+120>>2]=0}if(t[(t[r>>2]|0)+152>>2]|0){jk(t[(t[r>>2]|0)+152>>2]|0)|0;t[(t[r>>2]|0)+152>>2]=0}if(t[(t[r>>2]|0)+140>>2]|0){if(!(t[(t[r>>2]|0)+144>>2]|0))Nk(t[(t[r>>2]|0)+140>>2]|0);t[(t[r>>2]|0)+140>>2]=0}if(t[(t[r>>2]|0)+136>>2]|0){Ak(t[(t[r>>2]|0)+136>>2]|0);t[(t[r>>2]|0)+136>>2]=0}if(t[(t[r>>2]|0)+164>>2]|0)So(t[(t[r>>2]|0)+164>>2]|0);if(t[(t[r>>2]|0)+180>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+172>>2]|0))break;if(t[(t[(t[r>>2]|0)+180>>2]|0)+(t[n>>2]<<2)>>2]|0)vj(t[(t[(t[r>>2]|0)+180>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+180>>2]|0)}if(t[(t[r>>2]|0)+76>>2]|0)ry(t[(t[r>>2]|0)+76>>2]|0);if(t[(t[r>>2]|0)+20>>2]|0){if((t[(t[r>>2]|0)+88>>2]|0)==(t[(t[(t[r>>2]|0)+20>>2]|0)+296>>2]|0))t[(t[r>>2]|0)+88>>2]=0;if(t[(t[(t[r>>2]|0)+20>>2]|0)+8>>2]|0){if(!(t[(t[r>>2]|0)+80>>2]|0))wH(t[r>>2]|0,t[(t[(t[r>>2]|0)+20>>2]|0)+8>>2]|0);t[(t[(t[r>>2]|0)+20>>2]|0)+8>>2]=0}if((t[(t[(t[r>>2]|0)+20>>2]|0)+160>>2]|0)!=0?(t[(t[(t[r>>2]|0)+20>>2]|0)+156>>2]|0)>0:0){pAi[t[135736>>2]&511](t[(t[(t[r>>2]|0)+20>>2]|0)+160>>2]|0);t[(t[(t[r>>2]|0)+20>>2]|0)+160>>2]=0;t[(t[(t[r>>2]|0)+20>>2]|0)+156>>2]=0}if(t[(t[r>>2]|0)+12>>2]&2)Up(t[(t[r>>2]|0)+20>>2]|0)}if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);if((t[(t[r>>2]|0)+28>>2]|0)!=0?(t[(t[r>>2]|0)+12>>2]&1|0)!=0:0)IO(t[(t[r>>2]|0)+28>>2]|0);if(t[(t[r>>2]|0)+84>>2]|0)Ss(t[(t[r>>2]|0)+84>>2]|0);if(t[(t[r>>2]|0)+104>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+104>>2]|0);if(t[(t[r>>2]|0)+88>>2]|0)bz(t[(t[r>>2]|0)+88>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function PI(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){if(!(t[(t[f>>2]|0)+64>>2]|0)){t[n>>2]=0;break}t[a>>2]=wF(t[(t[(t[f>>2]|0)+64>>2]|0)+32>>2]|0,t[(t[f>>2]|0)+64>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;break}else{t[n>>2]=Yl(t[(t[a>>2]|0)+8>>2]|0)|0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function BI(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;e:do if(!(t[n>>2]|0))t[r>>2]=-1;else{if(!(t[(t[n>>2]|0)+64>>2]|0)){t[r>>2]=0;break}e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0)t[f>>2]=t[e+68>>2];else t[f>>2]=t[e+64>>2];do switch(t[(t[f>>2]|0)+4>>2]|0){case 7:{t[r>>2]=7;break e;break}case 2:case 18:{t[r>>2]=2;break e;break}case 1:{if((t[(t[n>>2]|0)+16>>2]|0)!=2?(t[(t[n>>2]|0)+16>>2]|0)!=4:0){t[r>>2]=1;break e}t[r>>2]=15;break e;break}case 5:{t[r>>2]=5;break e;break}case 12:{t[r>>2]=12;break e;break}case 21:case 13:case 9:{t[r>>2]=9;break e;break}case 6:{t[r>>2]=6;break e;break}case 11:{t[r>>2]=11;break e;break}case 3:{if(!(EF(t[(t[n>>2]|0)+64>>2]|0)|0)){t[r>>2]=3;break e}if(uF(t[(t[n>>2]|0)+64>>2]|0)|0){t[r>>2]=14;break e}else{t[r>>2]=13;break e}break}case 14:case 10:{t[r>>2]=10;break e;break}case 4:{t[r>>2]=4;break e;break}case 20:case 19:case 17:case 16:case 15:{t[r>>2]=0;break e;break}case 8:{t[r>>2]=8;break e;break}default:{t[r>>2]=-1;break e}}while(0)}while(0);s=i;return t[r>>2]|0}function II(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0){if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=1){t[r>>2]=0;break}if(t[(t[n>>2]|0)+68>>2]|0){t[r>>2]=0;break}if(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0){t[r>>2]=0;break}if((t[(t[n>>2]|0)+16>>2]|0)==2){t[r>>2]=0;break}if(t[(t[n>>2]|0)+4>>2]|0){t[r>>2]=1;break}if((t[(t[n>>2]|0)+168>>2]|0)>0){t[r>>2]=1;break}else{t[r>>2]=((a[(t[(t[n>>2]|0)+64>>2]|0)+58>>1]|0)&1|0)!=0&1;break}}else f=3;while(0);if((f|0)==3)t[r>>2]=-1;s=i;return t[r>>2]|0}function HI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0){e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0)t[f>>2]=t[e+68>>2];else t[f>>2]=t[e+64>>2];e=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==18){t[u>>2]=e;if(!(t[(t[u>>2]|0)+12>>2]|0)){t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187480,-1)|0;a=t[r>>2]|0;s=i;return a|0}else{t[r>>2]=t[(t[u>>2]|0)+12>>2];a=t[r>>2]|0;s=i;return a|0}}if((t[e+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=2:0){t[r>>2]=xI(t[n>>2]|0)|0;a=t[r>>2]|0;s=i;return a|0}t[r>>2]=t[(t[f>>2]|0)+8>>2];a=t[r>>2]|0;s=i;return a|0}t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}function xI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;e:do if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0){e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0)t[f>>2]=t[e+68>>2];else t[f>>2]=t[e+64>>2];do switch(t[(t[f>>2]|0)+4>>2]|0){case 20:case 19:case 17:case 16:case 15:{t[r>>2]=0;break e;break}case 11:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187584,-1)|0;break e;break}case 18:{t[u>>2]=t[f>>2];e=t[(t[n>>2]|0)+88>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){t[r>>2]=kz(e,187480,-1)|0;break e}else{t[r>>2]=hz(e,187480,t[(t[u>>2]|0)+12>>2]|0)|0;break e}break}case 21:case 13:case 9:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187568,-1)|0;break e;break}case 4:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187536,-1)|0;break e;break}case 2:case 1:{if((t[(t[f>>2]|0)+36>>2]|0)!=0?(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[r>>2]=hz(t[(t[n>>2]|0)+88>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;break e}t[r>>2]=t[(t[f>>2]|0)+8>>2];break e;break}case 12:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,t[(t[f>>2]|0)+8>>2]|0,-1)|0;break e;break}case 5:case 6:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,t[(t[f>>2]|0)+8>>2]|0,-1)|0;break e;break}case 3:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187528,-1)|0;break e;break}case 8:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187552,-1)|0;break e;break}case 7:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,t[(t[f>>2]|0)+8>>2]|0,-1)|0;break e;break}case 14:case 10:{t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,t[(t[f>>2]|0)+8>>2]|0,-1)|0;break e;break}default:{t[r>>2]=0;break e}}while(0)}else a=3;while(0);if((a|0)==3)t[r>>2]=0;s=i;return t[r>>2]|0}function UI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0){e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0)t[f>>2]=t[e+68>>2];else t[f>>2]=t[e+64>>2];if((t[(t[f>>2]|0)+4>>2]|0)==18){t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,187488,-1)|0;u=t[r>>2]|0;s=i;return u|0}if((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=2:0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}if(t[(t[f>>2]|0)+36>>2]|0){t[r>>2]=kz(t[(t[n>>2]|0)+88>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+8>>2]|0,-1)|0;u=t[r>>2]|0;s=i;return u|0}else{t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function zI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(!(t[n>>2]|0))t[r>>2]=-1;else{if(!(t[(t[n>>2]|0)+64>>2]|0)){t[r>>2]=0;break}e=t[n>>2]|0;if(!(t[(t[n>>2]|0)+68>>2]|0)){t[r>>2]=t[e+72>>2];break}if((t[(t[e+68>>2]|0)+4>>2]|0)!=2?(t[(t[(t[n>>2]|0)+68>>2]|0)+4>>2]|0)!=18:0){t[r>>2]=(t[(t[n>>2]|0)+72>>2]|0)+2;break}t[r>>2]=(t[(t[n>>2]|0)+72>>2]|0)+1}while(0);s=i;return t[r>>2]|0}function jI(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;e:do if(!(t[n>>2]|0))t[r>>2]=-1;else{if(!(t[(t[n>>2]|0)+64>>2]|0)){t[r>>2]=0;break}e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0)t[f>>2]=t[e+68>>2];else t[f>>2]=t[e+64>>2];switch(t[(t[f>>2]|0)+4>>2]|0){case 18:case 8:case 7:case 4:case 3:case 2:{t[r>>2]=1;break e;break}default:{t[r>>2]=0;break e}}}while(0);s=i;return t[r>>2]|0}function VI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;t[f>>2]=e;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=i;return o|0}if(!(t[(t[f>>2]|0)+64>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=i;return o|0}e=t[f>>2]|0;if(t[(t[f>>2]|0)+68>>2]|0)t[u>>2]=t[e+68>>2];else t[u>>2]=t[e+64>>2];switch(t[(t[u>>2]|0)+4>>2]|0){case 8:case 7:case 4:case 3:{t[n>>2]=t[(t[u>>2]|0)+40>>2];o=t[n>>2]|0;s=i;return o|0}case 2:{t[a>>2]=t[u>>2];if(((t[(t[a>>2]|0)+12>>2]|0)!=0?(t[(t[(t[a>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(t[(t[(t[a>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){t[n>>2]=t[(t[(t[a>>2]|0)+12>>2]|0)+40>>2];o=t[n>>2]|0;s=i;return o|0}if(!(t[(t[f>>2]|0)+84>>2]|0)){a=vs(100)|0;t[(t[f>>2]|0)+84>>2]=a;if(!(t[(t[f>>2]|0)+84>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187608,r);t[n>>2]=0;o=t[n>>2]|0;s=i;return o|0}}else gs(t[(t[f>>2]|0)+84>>2]|0);lF(t[(t[f>>2]|0)+84>>2]|0,t[u>>2]|0)|0;t[n>>2]=Os(t[(t[f>>2]|0)+84>>2]|0)|0;o=t[n>>2]|0;s=i;return o|0}case 18:{t[n>>2]=t[(t[u>>2]|0)+8>>2];o=t[n>>2]|0;s=i;return o|0}default:{t[n>>2]=0;o=t[n>>2]|0;s=i;return o|0}}return 0}function qI(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[a>>2];e:do if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+20>>2]|0)!=0:0){t[l>>2]=t[(t[u>>2]|0)+20>>2];a=t[c>>2]|0;if((a|0)==4){r=(t[l>>2]|0)+16|0;if(t[o>>2]|0)t[r>>2]=1;else t[r>>2]=0;t[f>>2]=0;break}else if((a|0)==2){r=(t[l>>2]|0)+276|0;i=t[r>>2]|0;if(!(t[o>>2]|0)){if(i&4){e=(t[l>>2]|0)+276|0;t[e>>2]=(t[e>>2]|0)-4}}else t[r>>2]=i|4;t[f>>2]=0;break}else if((a|0)==1){i=(t[l>>2]|0)+276|0;do if(t[o>>2]|0){if(!(t[i>>2]|0))if(t[t[u>>2]>>2]|0){t[f>>2]=-1;break e}else{t[(t[l>>2]|0)+276>>2]=2;break}}else t[i>>2]=0;while(0);t[f>>2]=0;break}else if((a|0)==3){i=(t[l>>2]|0)+104|0;if(t[o>>2]|0){t[i>>2]=1;t[(t[u>>2]|0)+8>>2]=1}else t[i>>2]=0;t[f>>2]=0;break}else{t[f>>2]=-1;break}}else b=3;while(0);if((b|0)==3)t[f>>2]=-1;s=n;return t[f>>2]|0}function YI(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0){e=t[n>>2]|0;if(t[(t[n>>2]|0)+68>>2]|0){t[r>>2]=t[e+68>>2];break}else{t[r>>2]=t[e+64>>2];break}}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function GI(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=pH(t[n>>2]|0,t[f>>2]|0,0,0)|0;s=r;return i|0}function WI(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=EH(t[n>>2]|0,t[f>>2]|0,0,0)|0;s=r;return i|0}function KI(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(!(t[n>>2]|0))t[r>>2]=-1;else{e=t[n>>2]|0;if((t[(t[n>>2]|0)+8>>2]|0)==2){t[r>>2]=(t[e+128>>2]|0)==0&1;break}f=t[n>>2]|0;if((t[e+8>>2]|0)==4){t[r>>2]=(t[f+148>>2]|0)==0&1;break}if((t[f+20>>2]|0)!=0?(t[(t[(t[n>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){t[r>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+100>>2];break}t[r>>2]=0}while(0);s=i;return t[r>>2]|0}function XI(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;u=s;s=s+48|0;a=u;o=u+40|0;c=u+36|0;l=u+32|0;b=u+28|0;k=u+24|0;h=u+20|0;w=u+16|0;d=u+12|0;v=u+8|0;m=u+4|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;if(!(t[c>>2]|0)){if(t[l>>2]|0)IO(t[l>>2]|0);t[o>>2]=-1;_=t[o>>2]|0;s=u;return _|0}t[h>>2]=t[h>>2]|65536;t[(t[c>>2]|0)+4>>2]=0;t[(t[c>>2]|0)+96>>2]=0;t[(t[c>>2]|0)+188>>2]=t[h>>2];t[(t[c>>2]|0)+8>>2]=0;if(((t[l>>2]|0)!=0?(t[(t[c>>2]|0)+28>>2]|0)!=0:0)?(t[(t[c>>2]|0)+12>>2]&1|0)!=0:0){IO(t[(t[c>>2]|0)+28>>2]|0);t[(t[c>>2]|0)+28>>2]=0;f=(t[c>>2]|0)+12|0;t[f>>2]=(t[f>>2]|0)-1}if(t[l>>2]|0){t[(t[c>>2]|0)+28>>2]=t[l>>2];f=(t[c>>2]|0)+12|0;t[f>>2]=t[f>>2]|1}if(!(t[(t[c>>2]|0)+84>>2]|0)){f=vs(100)|0;t[(t[c>>2]|0)+84>>2]=f}if(!(t[(t[c>>2]|0)+84>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187608,a);t[o>>2]=-1;_=t[o>>2]|0;s=u;return _|0}if(!(t[(t[c>>2]|0)+24>>2]|0)){f=gAi[t[135744>>2]&511](128)|0;t[(t[c>>2]|0)+24>>2]=f}if(!(t[(t[c>>2]|0)+24>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187608,a);t[o>>2]=-1;_=t[o>>2]|0;s=u;return _|0}ij(t[(t[c>>2]|0)+24>>2]|0,2)|0;t[(t[c>>2]|0)+32>>2]=t[(t[(t[c>>2]|0)+24>>2]|0)+56>>2];t[(t[(t[c>>2]|0)+24>>2]|0)+56>>2]=361;t[(t[c>>2]|0)+36>>2]=t[(t[(t[c>>2]|0)+24>>2]|0)+60>>2];t[(t[(t[c>>2]|0)+24>>2]|0)+60>>2]=362;f=t[c>>2]|0;if((t[(t[(t[c>>2]|0)+24>>2]|0)+108>>2]|0)==-554844497){t[(t[c>>2]|0)+40>>2]=t[(t[f+24>>2]|0)+116>>2];t[(t[(t[c>>2]|0)+24>>2]|0)+116>>2]=363;t[(t[c>>2]|0)+44>>2]=t[(t[(t[c>>2]|0)+24>>2]|0)+120>>2];t[(t[(t[c>>2]|0)+24>>2]|0)+120>>2]=364}else{t[f+40>>2]=0;t[(t[c>>2]|0)+44>>2]=0}t[(t[c>>2]|0)+48>>2]=t[(t[(t[c>>2]|0)+24>>2]|0)+68>>2];t[(t[(t[c>>2]|0)+24>>2]|0)+68>>2]=365;t[(t[(t[c>>2]|0)+24>>2]|0)+72>>2]=365;t[(t[c>>2]|0)+52>>2]=t[(t[(t[c>>2]|0)+24>>2]|0)+100>>2];t[(t[(t[c>>2]|0)+24>>2]|0)+100>>2]=366;t[t[c>>2]>>2]=0;t[(t[c>>2]|0)+64>>2]=0;t[(t[c>>2]|0)+68>>2]=0;if(t[l>>2]|0){if((Ts(t[(t[(t[c>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0<4)QO(t[l>>2]|0,4)|0;do if(!(t[(t[c>>2]|0)+20>>2]|0)){l=(Ts(t[(t[(t[c>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0>=4;f=t[(t[c>>2]|0)+24>>2]|0;if(l){l=Os(t[(t[(t[c>>2]|0)+28>>2]|0)+16>>2]|0)|0;n=fS(f,0,l,4,t[b>>2]|0)|0;t[(t[c>>2]|0)+20>>2]=n;t[(t[c>>2]|0)+56>>2]=0;t[(t[c>>2]|0)+60>>2]=4;break}else{n=fS(f,0,0,0,t[b>>2]|0)|0;t[(t[c>>2]|0)+20>>2]=n;t[(t[c>>2]|0)+56>>2]=0;t[(t[c>>2]|0)+60>>2]=0;break}}else{t[v>>2]=0;vS(t[(t[c>>2]|0)+20>>2]|0);t[d>>2]=CO(t[v>>2]|0)|0;if(!(t[d>>2]|0)){t[o>>2]=-1;_=t[o>>2]|0;s=u;return _|0}t[w>>2]=Cp(t[(t[c>>2]|0)+20>>2]|0)|0;if(!(t[w>>2]|0)){IO(t[d>>2]|0);t[o>>2]=-1;_=t[o>>2]|0;s=u;return _|0}if(!(t[b>>2]|0))t[(t[w>>2]|0)+4>>2]=0;else{n=KA(t[b>>2]|0)|0;t[(t[w>>2]|0)+4>>2]=n}t[t[w>>2]>>2]=t[d>>2];zs(t[(t[d>>2]|0)+16>>2]|0,t[w>>2]|0)|0;eE(t[(t[c>>2]|0)+20>>2]|0,t[w>>2]|0)|0;t[(t[c>>2]|0)+60>>2]=0}while(0);if(!(t[(t[c>>2]|0)+20>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187608,a);t[o>>2]=-1;_=t[o>>2]|0;s=u;return _|0}}a=t[(t[(t[c>>2]|0)+20>>2]|0)+296>>2]|0;do if(t[(t[c>>2]|0)+88>>2]|0){w=t[(t[c>>2]|0)+88>>2]|0;d=(t[(t[c>>2]|0)+20>>2]|0)+296|0;if(!a){t[d>>2]=w;break}if((w|0)!=(t[d>>2]|0)){bz(t[(t[c>>2]|0)+88>>2]|0);t[(t[c>>2]|0)+88>>2]=t[(t[(t[c>>2]|0)+20>>2]|0)+296>>2]}}else{if(!a){d=lz()|0;t[(t[(t[c>>2]|0)+20>>2]|0)+296>>2]=d}t[(t[c>>2]|0)+88>>2]=t[(t[(t[c>>2]|0)+20>>2]|0)+296>>2]}while(0);t[(t[(t[c>>2]|0)+20>>2]|0)+272>>2]=t[c>>2];t[(t[(t[c>>2]|0)+20>>2]|0)+280>>2]=1;t[(t[(t[c>>2]|0)+20>>2]|0)+364>>2]=1;t[(t[(t[c>>2]|0)+20>>2]|0)+308>>2]=1;t[(t[(t[c>>2]|0)+20>>2]|0)+436>>2]=5;if(t[(t[c>>2]|0)+164>>2]|0){So(t[(t[c>>2]|0)+164>>2]|0);t[(t[c>>2]|0)+164>>2]=0}a=(t[c>>2]|0)+156|0;if(t[h>>2]&1024){t[a>>2]=1;d=kz(t[(t[c>>2]|0)+88>>2]|0,187696,-1)|0;t[(t[c>>2]|0)+160>>2]=d;t[h>>2]=(t[h>>2]|0)-1024}else t[a>>2]=0;t[(t[c>>2]|0)+168>>2]=0;if(!(t[(t[c>>2]|0)+180>>2]|0)){t[(t[c>>2]|0)+172>>2]=0;t[(t[c>>2]|0)+176>>2]=0}while(1){if((t[(t[c>>2]|0)+172>>2]|0)<=0)break;a=(t[c>>2]|0)+172|0;t[a>>2]=(t[a>>2]|0)+-1;if(!(t[(t[(t[c>>2]|0)+180>>2]|0)+(t[(t[c>>2]|0)+172>>2]<<2)>>2]|0))continue;vj(t[(t[(t[c>>2]|0)+180>>2]|0)+(t[(t[c>>2]|0)+172>>2]<<2)>>2]|0);t[(t[(t[c>>2]|0)+180>>2]|0)+(t[(t[c>>2]|0)+172>>2]<<2)>>2]=0}if(t[h>>2]&16)t[(t[c>>2]|0)+8>>2]=1;mS(t[(t[c>>2]|0)+20>>2]|0,t[h>>2]|0)|0;if((t[k>>2]|0)!=0?(t[m>>2]=V_(t[k>>2]|0)|0,(t[m>>2]|0)!=0):0)Lp(t[(t[c>>2]|0)+20>>2]|0,t[m>>2]|0)|0;if(((t[b>>2]|0)!=0?(t[(t[(t[c>>2]|0)+20>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[(t[c>>2]|0)+20>>2]|0)+36>>2]|0)+4>>2]|0)==0:0){m=Yl(t[b>>2]|0)|0;t[(t[(t[(t[c>>2]|0)+20>>2]|0)+36>>2]|0)+4>>2]=m}t[(t[c>>2]|0)+4>>2]=0;t[o>>2]=0;_=t[o>>2]|0;s=u;return _|0}function ZI(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](196)|0;if(!(t[f>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,187440,i);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{VY(t[f>>2]|0,0,196)|0;t[(t[f>>2]|0)+96>>2]=0;t[(t[f>>2]|0)+28>>2]=0;t[t[f>>2]>>2]=0;t[(t[f>>2]|0)+64>>2]=0;t[(t[f>>2]|0)+68>>2]=0;t[(t[f>>2]|0)+56>>2]=0;t[(t[f>>2]|0)+60>>2]=0;t[(t[f>>2]|0)+12>>2]=2;t[(t[f>>2]|0)+4>>2]=t[n>>2];t[(t[f>>2]|0)+16>>2]=0;n=lz()|0;t[(t[f>>2]|0)+88>>2]=n;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function JI(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;u=s;s=s+32|0;a=u+28|0;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;h=u+4|0;w=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=WO(t[o>>2]|0,t[c>>2]|0,0)|0;if(!(t[w>>2]|0)){t[a>>2]=0;d=t[a>>2]|0;s=u;return d|0}t[h>>2]=LI(t[w>>2]|0,t[l>>2]|0)|0;if(!(t[h>>2]|0)){IO(t[w>>2]|0);t[a>>2]=0;d=t[a>>2]|0;s=u;return d|0}else{w=(t[h>>2]|0)+12|0;t[w>>2]=t[w>>2]|1;XI(t[h>>2]|0,0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;t[a>>2]=t[h>>2];d=t[a>>2]|0;s=u;return d|0}return 0}function QI(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=DI(t[u>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{XI(t[c>>2]|0,0,0,t[a>>2]|0,t[o>>2]|0)|0;t[f>>2]=t[c>>2];l=t[f>>2]|0;s=n;return l|0}return 0}function $I(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[(t[n>>2]|0)+16>>2]|0)==2){t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}e:while(1){e=t[n>>2]|0;do if(!(t[(t[n>>2]|0)+64>>2]|0)){u=t[n>>2]|0;if(!(t[(t[e+4>>2]|0)+12>>2]|0)){a=5;break e}t[(t[n>>2]|0)+64>>2]=t[(t[u+4>>2]|0)+12>>2];t[(t[n>>2]|0)+16>>2]=0}else{if((((t[e+16>>2]|0)!=4?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=14:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=19:0)?(t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=5:0){o=t[(t[n>>2]|0)+64>>2]|0;if(t[(t[(t[n>>2]|0)+64>>2]|0)+12>>2]|0){t[(t[n>>2]|0)+64>>2]=t[o+12>>2];c=(t[n>>2]|0)+72|0;t[c>>2]=(t[c>>2]|0)+1;t[(t[n>>2]|0)+16>>2]=0;break}if((t[o+4>>2]|0)==2){t[(t[n>>2]|0)+16>>2]=4;break}}o=t[(t[n>>2]|0)+64>>2]|0;if(t[(t[(t[n>>2]|0)+64>>2]|0)+24>>2]|0){t[(t[n>>2]|0)+64>>2]=t[o+24>>2];t[(t[n>>2]|0)+16>>2]=0;break}c=t[n>>2]|0;if(!(t[o+20>>2]|0)){t[c+16>>2]=2;break}if((t[(t[(t[c+64>>2]|0)+20>>2]|0)+4>>2]|0)==9){a=20;break e}if((t[(t[(t[(t[n>>2]|0)+64>>2]|0)+20>>2]|0)+4>>2]|0)==13){a=20;break e}t[(t[n>>2]|0)+64>>2]=t[(t[(t[n>>2]|0)+64>>2]|0)+20>>2];c=(t[n>>2]|0)+72|0;t[c>>2]=(t[c>>2]|0)+-1;t[(t[n>>2]|0)+16>>2]=4}while(0);if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)==19)continue;if((t[(t[(t[n>>2]|0)+64>>2]|0)+4>>2]|0)!=20){a=25;break}}if((a|0)==5){t[u+16>>2]=2;t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}else if((a|0)==20){t[(t[n>>2]|0)+16>>2]=2;t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}else if((a|0)==25){t[r>>2]=1;f=t[r>>2]|0;s=i;return f|0}return 0}function eH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;if((t[(t[n>>2]|0)+28>>2]|0)!=0?(t[(t[(t[n>>2]|0)+28>>2]|0)+16>>2]|0)!=0:0){t[o>>2]=t[(t[n>>2]|0)+16>>2];t[(t[n>>2]|0)+16>>2]=-1;t[f>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+16>>2];t[c>>2]=ps(t[f>>2]|0)|0;e:do{if((t[(t[n>>2]|0)+16>>2]|0)!=-1)break;e=Ts(t[f>>2]|0)|0;do if(e>>>0<((t[(t[n>>2]|0)+60>>2]|0)+512|0)>>>0){if((t[t[n>>2]>>2]|0)==3)break e;t[u>>2]=QO(t[(t[n>>2]|0)+28>>2]|0,4096)|0;if((t[u>>2]|0)==0&(t[c>>2]|0)==2){l=Ts(t[f>>2]|0)|0;if((l|0)!=(t[(t[n>>2]|0)+60>>2]|0))break;t[t[n>>2]>>2]=3;t[(t[n>>2]|0)+16>>2]=t[o>>2];break}if((t[u>>2]|0)>=0)if(!(t[u>>2]|0)){b=16;break e}else break;t[t[n>>2]>>2]=3;t[(t[n>>2]|0)+16>>2]=t[o>>2];if(t[o>>2]|0){b=14;break e}if(t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0){b=14;break e}}while(0);e=Ts(t[f>>2]|0)|0;if(e>>>0<((t[(t[n>>2]|0)+60>>2]|0)+512|0)>>>0){b=21;break}e=t[(t[n>>2]|0)+20>>2]|0;l=Os(t[f>>2]|0)|0;t[u>>2]=nS(e,l+(t[(t[n>>2]|0)+60>>2]|0)|0,512,0)|0;l=(t[n>>2]|0)+60|0;t[l>>2]=(t[l>>2]|0)+512;if(t[u>>2]|0)t[(t[(t[n>>2]|0)+20>>2]|0)+12>>2]=0}while((t[(t[(t[n>>2]|0)+20>>2]|0)+12>>2]|0)!=0);if((b|0)==14){t[r>>2]=t[u>>2];k=t[r>>2]|0;s=i;return k|0}else if((b|0)==16)t[t[n>>2]>>2]=3;else if((b|0)==21?(b=Ts(t[f>>2]|0)|0,t[a>>2]=b-(t[(t[n>>2]|0)+60>>2]|0),b=t[(t[n>>2]|0)+20>>2]|0,l=Os(t[f>>2]|0)|0,t[u>>2]=nS(b,l+(t[(t[n>>2]|0)+60>>2]|0)|0,t[a>>2]|0,0)|0,l=(t[n>>2]|0)+60|0,t[l>>2]=(t[l>>2]|0)+(t[a>>2]|0),(t[u>>2]|0)!=0):0)t[(t[(t[n>>2]|0)+20>>2]|0)+12>>2]=0;do if((t[t[n>>2]>>2]|0)==1){if((((t[c>>2]|0)!=2?(t[(t[n>>2]|0)+60>>2]|0)>>>0>=4096:0)?(l=Ts(t[f>>2]|0)|0,(l-(t[(t[n>>2]|0)+60>>2]|0)|0)>>>0<=512):0)?(t[u>>2]=ys(t[f>>2]|0,t[(t[n>>2]|0)+60>>2]|0)|0,(t[u>>2]|0)>=0):0){l=(t[n>>2]|0)+60|0;t[l>>2]=(t[l>>2]|0)-(t[u>>2]|0)}}else if(((t[t[n>>2]>>2]|0)==3?(t[(t[n>>2]|0)+16>>2]|0)!=5:0)?(l=Ts(t[f>>2]|0)|0,t[a>>2]=l-(t[(t[n>>2]|0)+60>>2]|0),l=t[(t[n>>2]|0)+20>>2]|0,b=Os(t[f>>2]|0)|0,t[u>>2]=nS(l,b+(t[(t[n>>2]|0)+60>>2]|0)|0,t[a>>2]|0,1)|0,b=Ts(t[f>>2]|0)|0,t[(t[n>>2]|0)+60>>2]=b,t[(t[n>>2]|0)+16>>2]=5,(t[u>>2]|0)!=0):0){if(t[(t[(t[n>>2]|0)+20>>2]|0)+12>>2]|0){t[(t[(t[n>>2]|0)+20>>2]|0)+12>>2]=0;break}t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}while(0);t[(t[n>>2]|0)+16>>2]=t[o>>2];if(!(t[(t[(t[n>>2]|0)+20>>2]|0)+12>>2]|0)){t[t[n>>2]>>2]=3;t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}else{t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}}t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}function iH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[r>>2]=e;t[n>>2]=t[(t[r>>2]|0)+64>>2];do if(((t[(t[r>>2]|0)+8>>2]|0)==1?(t[(t[r>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[r>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){if((t[(t[n>>2]|0)+36>>2]|0)!=0?(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[f>>2]=Yl(t[(t[(t[n>>2]|0)+36>>2]|0)+12>>2]|0)|0;t[f>>2]=us(t[f>>2]|0,187520)|0;t[f>>2]=us(t[f>>2]|0,t[(t[n>>2]|0)+8>>2]|0)|0;e=sR((t[(t[r>>2]|0)+20>>2]|0)+108|0,t[(t[(t[r>>2]|0)+20>>2]|0)+8>>2]|0,t[n>>2]|0,t[f>>2]|0)|0;a=(t[(t[r>>2]|0)+20>>2]|0)+100|0;t[a>>2]=t[a>>2]&e;if(!(t[f>>2]|0))break;pAi[t[135736>>2]&511](t[f>>2]|0);break}e=sR((t[(t[r>>2]|0)+20>>2]|0)+108|0,t[(t[(t[r>>2]|0)+20>>2]|0)+8>>2]|0,t[n>>2]|0,t[(t[n>>2]|0)+8>>2]|0)|0;a=(t[(t[r>>2]|0)+20>>2]|0)+100|0;t[a>>2]=t[a>>2]&e}while(0);if((t[(t[r>>2]|0)+8>>2]|0)!=2){s=i;return}if(!(t[(t[r>>2]|0)+120>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+132>>2]|0){if((t[n>>2]|0)!=(t[(t[r>>2]|0)+132>>2]|0)){s=i;return}t[(t[r>>2]|0)+132>>2]=0;s=i;return}else{t[u>>2]=VH(t[(t[r>>2]|0)+120>>2]|0,t[(t[(t[r>>2]|0)+20>>2]|0)+8>>2]|0,t[n>>2]|0)|0;if((t[u>>2]|0)==1){s=i;return}u=(t[r>>2]|0)+128|0;t[u>>2]=(t[u>>2]|0)+1;s=i;return}}function rH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)t[u>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+296>>2];else t[u>>2]=0;i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==14){ey(i);s=r;return}e=t[f>>2]|0;if((t[i+4>>2]|0)==18){Kg(e);s=r;return}if((t[e+4>>2]|0)==2){FH(t[n>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+12>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=5:0){if((t[(t[(t[f>>2]|0)+12>>2]|0)+20>>2]|0)==(t[f>>2]|0))OH(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);t[(t[f>>2]|0)+12>>2]=0}if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[f>>2]|0);if(!(((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0))a=21;if((a|0)==21?(t[(t[f>>2]|0)+44>>2]|0)!=0:0)AH(t[n>>2]|0,t[(t[f>>2]|0)+44>>2]|0);do if((((((t[(t[f>>2]|0)+40>>2]|0)!=((t[f>>2]|0)+44|0)?(t[(t[f>>2]|0)+4>>2]|0)!=1:0)?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0)?(t[(t[f>>2]|0)+4>>2]|0)!=5:0)?(t[(t[f>>2]|0)+40>>2]|0)!=0:0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+40>>2]|0)}while(0);if(!(((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0))a=35;if((a|0)==35?(t[(t[f>>2]|0)+48>>2]|0)!=0:0)Zg(t[(t[f>>2]|0)+48>>2]|0);do if(((t[(t[f>>2]|0)+4>>2]|0)!=3?(t[(t[f>>2]|0)+4>>2]|0)!=8:0)?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0)}while(0);if((t[(t[f>>2]|0)+4>>2]|0)==1){if(t[n>>2]|0)a=46}else if((t[n>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)==3:0)a=46;if(((a|0)==46?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+20>>2]|0)+368>>2]|0)<100:0){t[(t[f>>2]|0)+24>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+372>>2];t[(t[(t[n>>2]|0)+20>>2]|0)+372>>2]=t[f>>2];a=(t[(t[n>>2]|0)+20>>2]|0)+368|0;t[a>>2]=(t[a>>2]|0)+1;s=r;return}pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}function nH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r;f=r+12|0;u=r+8|0;a=r+4|0;t[u>>2]=e;t[a>>2]=i;
	if((t[(t[u>>2]|0)+100>>2]|0)<=0?(t[(t[u>>2]|0)+100>>2]=10,i=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+100>>2]<<2)|0,t[(t[u>>2]|0)+104>>2]=i,(t[(t[u>>2]|0)+104>>2]|0)==0):0){yAi[t[135904>>2]&511](t[33980]|0,187648,n);t[f>>2]=0;o=t[f>>2]|0;s=r;return o|0}if((t[(t[u>>2]|0)+96>>2]|0)>=(t[(t[u>>2]|0)+100>>2]|0)?(i=(t[u>>2]|0)+100|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+104>>2]|0,t[(t[u>>2]|0)+100>>2]<<2)|0,t[(t[u>>2]|0)+104>>2]=i,(t[(t[u>>2]|0)+104>>2]|0)==0):0){yAi[t[135904>>2]&511](t[33980]|0,187672,n);t[f>>2]=0;o=t[f>>2]|0;s=r;return o|0}t[(t[(t[u>>2]|0)+104>>2]|0)+(t[(t[u>>2]|0)+96>>2]<<2)>>2]=t[a>>2];t[(t[u>>2]|0)+92>>2]=t[a>>2];a=(t[u>>2]|0)+96|0;u=t[a>>2]|0;t[a>>2]=u+1;t[f>>2]=u;o=t[f>>2]|0;s=r;return o|0}function fH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;f=i+8|0;u=i+4|0;o=i;t[r>>2]=e;t[n>>2]=t[(t[r>>2]|0)+64>>2];t[f>>2]=t[(t[r>>2]|0)+64>>2];t[u>>2]=t[(t[r>>2]|0)+20>>2];e:while(1){e=t[f>>2]|0;do if((t[(t[f>>2]|0)+4>>2]|0)==5){if(((t[e+12>>2]|0)==0?(t[t[u>>2]>>2]|0)!=0:0)?(t[(t[t[u>>2]>>2]|0)+20>>2]|0)!=0:0){c=MAi[t[(t[t[u>>2]>>2]|0)+20>>2]&511](t[u>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;t[(t[f>>2]|0)+12>>2]=c}if(((t[(t[f>>2]|0)+12>>2]|0)!=0?(t[(t[(t[f>>2]|0)+12>>2]|0)+4>>2]|0)==17:0)?(t[(t[(t[f>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){nH(t[r>>2]|0,t[f>>2]|0)|0;t[f>>2]=t[(t[(t[f>>2]|0)+12>>2]|0)+12>>2];break}if((t[f>>2]|0)==(t[n>>2]|0)){l=41;break e}t[f>>2]=t[(t[f>>2]|0)+24>>2];l=18}else{c=t[f>>2]|0;if((t[e+4>>2]|0)==1){t[(t[r>>2]|0)+64>>2]=c;uH(t[r>>2]|0);l=18;break}if((t[c+4>>2]|0)!=3?(t[(t[f>>2]|0)+4>>2]|0)!=4:0){l=18;break}c=t[r>>2]|0;b=t[(t[f>>2]|0)+40>>2]|0;aH(c,b,rs(t[(t[f>>2]|0)+40>>2]|0)|0);l=18}while(0);i:do if((l|0)==18){l=0;e=t[f>>2]|0;if(t[(t[f>>2]|0)+12>>2]|0){t[f>>2]=t[e+12>>2];break}if((t[e+4>>2]|0)==1)iH(t[r>>2]|0);if(t[(t[f>>2]|0)+24>>2]|0){t[f>>2]=t[(t[f>>2]|0)+24>>2];break}while(1){t[f>>2]=t[(t[f>>2]|0)+20>>2];if((t[(t[f>>2]|0)+4>>2]|0)==1){r:do if(!(t[(t[r>>2]|0)+96>>2]|0))while(1){e=t[(t[f>>2]|0)+16>>2]|0;t[o>>2]=e;if(!e)break r;if((a[(t[o>>2]|0)+58>>1]|0)&2)break r;iy(t[o>>2]|0);rH(t[r>>2]|0,t[o>>2]|0)}while(0);t[(t[r>>2]|0)+64>>2]=t[f>>2];iH(t[r>>2]|0)}if(((t[(t[f>>2]|0)+4>>2]|0)==17?(t[(t[r>>2]|0)+92>>2]|0)!=0:0)?(t[(t[(t[r>>2]|0)+92>>2]|0)+12>>2]|0)==(t[f>>2]|0):0)t[f>>2]=tH(t[r>>2]|0)|0;if((t[f>>2]|0)==(t[n>>2]|0))break i;k=t[f>>2]|0;if(t[(t[f>>2]|0)+24>>2]|0)break;if(!k)break i;if((t[f>>2]|0)==(t[n>>2]|0))break i}t[f>>2]=t[k+24>>2]}while(0);if(!(t[f>>2]|0)){l=41;break}if((t[f>>2]|0)==(t[n>>2]|0)){l=41;break}}if((l|0)==41){t[(t[r>>2]|0)+64>>2]=t[n>>2];s=i;return}}function tH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+96>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+96|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+96>>2]|0)>0)t[(t[n>>2]|0)+92>>2]=t[(t[(t[n>>2]|0)+104>>2]|0)+((t[e+96>>2]|0)-1<<2)>>2];else t[e+92>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+104>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2];t[(t[(t[n>>2]|0)+104>>2]|0)+(t[(t[n>>2]|0)+96>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function uH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;t[n>>2]=e;t[f>>2]=t[(t[n>>2]|0)+64>>2];do if(((t[(t[n>>2]|0)+8>>2]|0)==1?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){if((t[(t[f>>2]|0)+36>>2]|0)!=0?(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[u>>2]=Yl(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;t[u>>2]=us(t[u>>2]|0,187520)|0;t[u>>2]=us(t[u>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;e=cR((t[(t[n>>2]|0)+20>>2]|0)+108|0,t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0,t[f>>2]|0,t[u>>2]|0)|0;o=(t[(t[n>>2]|0)+20>>2]|0)+100|0;t[o>>2]=t[o>>2]&e;if(!(t[u>>2]|0))break;pAi[t[135736>>2]&511](t[u>>2]|0);break}e=cR((t[(t[n>>2]|0)+20>>2]|0)+108|0,t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0,t[f>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;o=(t[(t[n>>2]|0)+20>>2]|0)+100|0;t[o>>2]=t[o>>2]&e}while(0);if((t[(t[n>>2]|0)+8>>2]|0)!=2){s=i;return}if(!(t[(t[n>>2]|0)+120>>2]|0)){s=i;return}if(t[(t[n>>2]|0)+132>>2]|0){s=i;return}t[a>>2]=zH(t[(t[n>>2]|0)+120>>2]|0,t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0,t[f>>2]|0)|0;do if(!(t[a>>2]|0)){t[f>>2]=NI(t[n>>2]|0)|0;if(!(t[f>>2]|0)){Je(187736,r|0)|0;t[a>>2]=-1;break}else{t[a>>2]=qH(t[(t[n>>2]|0)+120>>2]|0,t[(t[(t[n>>2]|0)+20>>2]|0)+8>>2]|0,t[f>>2]|0)|0;t[(t[n>>2]|0)+132>>2]=t[f>>2];break}}while(0);if((t[a>>2]|0)==1){s=i;return}a=(t[n>>2]|0)+128|0;t[a>>2]=(t[a>>2]|0)+1;s=i;return}function aH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(((t[(t[f>>2]|0)+8>>2]|0)==1?(t[(t[f>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){r=lR((t[(t[f>>2]|0)+20>>2]|0)+108|0,t[u>>2]|0,t[a>>2]|0)|0;i=(t[(t[f>>2]|0)+20>>2]|0)+100|0;t[i>>2]=t[i>>2]&r}if((t[(t[f>>2]|0)+8>>2]|0)!=2){s=n;return}if(!(t[(t[f>>2]|0)+120>>2]|0)){s=n;return}if(t[(t[f>>2]|0)+132>>2]|0){s=n;return}t[o>>2]=jH(t[(t[f>>2]|0)+120>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;if((t[o>>2]|0)==1){s=n;return}o=(t[f>>2]|0)+128|0;t[o>>2]=(t[o>>2]|0)+1;s=n;return}function oH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;do if(((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0)?(t[(t[n>>2]|0)+20>>2]|0)!=0:0){while(1){if((t[(t[(t[n>>2]|0)+20>>2]|0)+172>>2]|0)==-1){u=6;break}if(MH(t[(t[n>>2]|0)+64>>2]|0)|0){u=8;break}if((t[(t[(t[n>>2]|0)+20>>2]|0)+56>>2]|0)<(t[(t[n>>2]|0)+72>>2]|0)){u=10;break}if((t[t[n>>2]>>2]|0)==3){u=12;break}t[f>>2]=eH(t[n>>2]|0)|0;a=t[n>>2]|0;if((t[f>>2]|0)<0){u=14;break}if((t[a>>2]|0)==3){u=16;break}}if((u|0)==6){t[r>>2]=1;break}else if((u|0)==8){t[r>>2]=1;break}else if((u|0)==10){t[r>>2]=1;break}else if((u|0)==12){t[r>>2]=1;break}else if((u|0)==14){t[a>>2]=2;t[r>>2]=-1;break}else if((u|0)==16){t[r>>2]=1;break}}else u=4;while(0);if((u|0)==4)t[r>>2]=-1;s=i;return t[r>>2]|0}function cH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=t[a>>2];t[b>>2]=t[(t[l>>2]|0)+272>>2];if(((((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+32>>2]|0)!=0:0)?(yAi[t[(t[b>>2]|0)+32>>2]&511](t[a>>2]|0,t[o>>2]|0,t[c>>2]|0),(t[(t[l>>2]|0)+52>>2]|0)!=0):0)?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)!=0:0)?(u[t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47:0)?(u[(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)f[(t[(t[l>>2]|0)+52>>2]|0)+58>>1]=1;if(!(t[b>>2]|0)){s=n;return}t[(t[b>>2]|0)+16>>2]=1;s=n;return}function lH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[n>>2];t[a>>2]=t[(t[u>>2]|0)+272>>2];if(!(t[a>>2]|0)){s=r;return}if(!(t[(t[a>>2]|0)+36>>2]|0)){s=r;return}EAi[t[(t[a>>2]|0)+36>>2]&511](t[n>>2]|0,t[f>>2]|0);s=r;return}function sH(e,i,r,n,a,o,c,l,b){e=e|0;i=i|0;r=r|0;n=n|0;a=a|0;o=o|0;c=c|0;l=l|0;b=b|0;var k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;k=s;s=s+48|0;h=k+40|0;w=k+36|0;d=k+32|0;v=k+28|0;m=k+24|0;_=k+20|0;p=k+16|0;E=k+12|0;S=k+8|0;g=k+4|0;y=k;t[h>>2]=e;t[w>>2]=i;t[d>>2]=r;t[v>>2]=n;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=l;t[S>>2]=b;t[g>>2]=t[h>>2];t[y>>2]=t[(t[g>>2]|0)+272>>2];if(((((((t[y>>2]|0)!=0?(t[(t[y>>2]|0)+40>>2]|0)!=0:0)?(FAi[t[(t[y>>2]|0)+40>>2]&511](t[h>>2]|0,t[w>>2]|0,t[d>>2]|0,t[v>>2]|0,t[m>>2]|0,t[_>>2]|0,t[p>>2]|0,t[E>>2]|0,t[S>>2]|0),(t[(t[g>>2]|0)+52>>2]|0)!=0):0)?(t[(t[g>>2]|0)+36>>2]|0)!=0:0)?(t[(t[(t[g>>2]|0)+36>>2]|0)+16>>2]|0)!=0:0)?(u[t[(t[(t[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47:0)?(u[(t[(t[(t[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)f[(t[(t[g>>2]|0)+52>>2]|0)+58>>1]=1;if(!(t[y>>2]|0)){s=k;return}t[(t[y>>2]|0)+16>>2]=1;s=k;return}function bH(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];t[b>>2]=t[(t[l>>2]|0)+272>>2];if(!(t[b>>2]|0)){s=f;return}if(!(t[(t[b>>2]|0)+44>>2]|0)){s=f;return}NAi[t[(t[b>>2]|0)+44>>2]&511](t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0);s=f;return}function kH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];t[c>>2]=t[(t[o>>2]|0)+272>>2];if(!(t[c>>2]|0)){s=n;return}if(!(t[(t[c>>2]|0)+48>>2]|0)){s=n;return}yAi[t[(t[c>>2]|0)+48>>2]&511](t[f>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function hH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];t[c>>2]=t[(t[o>>2]|0)+272>>2];if(!(t[c>>2]|0)){s=n;return}if(!(t[(t[c>>2]|0)+52>>2]|0)){s=n;return}yAi[t[(t[c>>2]|0)+52>>2]&511](t[f>>2]|0,t[u>>2]|0,t[a>>2]|0);s=n;return}function wH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[f>>2]|0);if(t[(t[f>>2]|0)+64>>2]|0)RH(t[(t[f>>2]|0)+64>>2]|0);t[(t[f>>2]|0)+64>>2]=0;if(t[(t[f>>2]|0)+68>>2]|0)KM(t[(t[f>>2]|0)+68>>2]|0);t[(t[f>>2]|0)+68>>2]=0;t[u>>2]=t[(t[f>>2]|0)+48>>2];t[a>>2]=t[(t[f>>2]|0)+44>>2];if((t[a>>2]|0)==(t[u>>2]|0))t[u>>2]=0;if(t[u>>2]|0){iy(t[(t[f>>2]|0)+48>>2]|0);t[(t[f>>2]|0)+48>>2]=0;ey(t[u>>2]|0)}if(t[a>>2]|0){iy(t[(t[f>>2]|0)+44>>2]|0);t[(t[f>>2]|0)+44>>2]=0;ey(t[a>>2]|0)}if(t[(t[f>>2]|0)+12>>2]|0)OH(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);if(t[(t[f>>2]|0)+56>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+56>>2]|0);if(t[(t[f>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0);if(t[(t[f>>2]|0)+60>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+60>>2]|0);if(t[(t[f>>2]|0)+52>>2]|0)Zg(t[(t[f>>2]|0)+52>>2]|0);if(t[(t[f>>2]|0)+72>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+72>>2]|0);if(t[(t[f>>2]|0)+80>>2]|0)bz(t[(t[f>>2]|0)+80>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}function dH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+48|0;f=n;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[u>>2];t[l>>2]=r;t[c>>2]=NH(t[a>>2]|0,l)|0;if(t[(t[o>>2]|0)+108>>2]|0)NAi[t[(t[o>>2]|0)+108>>2]&511](t[(t[o>>2]|0)+112>>2]|0,t[c>>2]|0,2,0);else{o=t[u>>2]|0;t[f>>2]=t[c>>2];SH(o,187728,f)}if(!(t[c>>2]|0)){s=n;return}pAi[t[135736>>2]&511](t[c>>2]|0);s=n;return}function vH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+48|0;f=n;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=t[u>>2];t[l>>2]=r;t[c>>2]=NH(t[a>>2]|0,l)|0;if(t[(t[o>>2]|0)+108>>2]|0)NAi[t[(t[o>>2]|0)+108>>2]&511](t[(t[o>>2]|0)+112>>2]|0,t[c>>2]|0,1,0);else{o=t[u>>2]|0;t[f>>2]=t[c>>2];gH(o,187728,f)}if(!(t[c>>2]|0)){s=n;return}pAi[t[135736>>2]&511](t[c>>2]|0);s=n;return}function mH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[n>>2];n=t[u>>2]|0;if(t[(t[u>>2]|0)+192>>2]|0){EAi[t[n+192>>2]&511](t[(t[u>>2]|0)+112>>2]|0,t[f>>2]|0);s=r;return}else{yH(n,t[f>>2]|0);s=r;return}}function _H(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[u>>2]|0)!=0?!((t[a>>2]|0)==0&(t[o>>2]|0)==0):0){if(t[a>>2]|0)t[t[a>>2]>>2]=0;if(t[o>>2]|0)t[t[o>>2]>>2]=0;t[c>>2]=t[u>>2];if((t[(t[c>>2]|0)+20>>2]|0)!=0?(t[(t[(t[c>>2]|0)+20>>2]|0)+36>>2]|0)!=0:0){if(t[a>>2]|0)t[t[a>>2]>>2]=t[(t[(t[(t[c>>2]|0)+20>>2]|0)+36>>2]|0)+4>>2];if(t[o>>2]|0)t[t[o>>2]>>2]=t[(t[(t[(t[c>>2]|0)+20>>2]|0)+36>>2]|0)+28>>2];t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(!(t[(t[c>>2]|0)+64>>2]|0)){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}t[b>>2]=0;do if(t[o>>2]|0){t[l>>2]=Qy(t[(t[c>>2]|0)+64>>2]|0)|0;if((t[l>>2]|0)>0){t[t[o>>2]>>2]=t[l>>2];break}else{t[b>>2]=-1;break}}while(0);do if(t[a>>2]|0){t[k>>2]=t[(t[(t[c>>2]|0)+64>>2]|0)+32>>2];if((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+72>>2]|0)!=0:0){t[t[a>>2]>>2]=t[(t[k>>2]|0)+72>>2];break}t[b>>2]=-1}while(0);t[f>>2]=t[b>>2];h=t[f>>2]|0;s=n;return h|0}t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}function pH(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[f+4>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if((t[o>>2]|0)!=0&(t[c>>2]|0)!=0){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}do if((t[o>>2]|0)!=0|(t[c>>2]|0)!=0){if((t[t[a>>2]>>2]|0)==0?(t[(t[a>>2]|0)+20>>2]|0)!=0:0)break;t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}while(0);if(t[(t[a>>2]|0)+152>>2]|0){jk(t[(t[a>>2]|0)+152>>2]|0)|0;t[(t[a>>2]|0)+152>>2]=0}if(t[(t[a>>2]|0)+140>>2]|0){if(!(t[(t[a>>2]|0)+144>>2]|0))Nk(t[(t[a>>2]|0)+140>>2]|0);t[(t[a>>2]|0)+140>>2]=0}t[(t[a>>2]|0)+144>>2]=0;if(t[(t[a>>2]|0)+136>>2]|0){Ak(t[(t[a>>2]|0)+136>>2]|0);t[(t[a>>2]|0)+136>>2]=0}if((t[o>>2]|0)==0&(t[c>>2]|0)==0){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}if(t[o>>2]|0){t[l>>2]=Mk(t[o>>2]|0)|0;if(t[(t[a>>2]|0)+108>>2]|0)Dk(t[l>>2]|0,367,368,t[a>>2]|0);o=Lk(t[l>>2]|0)|0;t[(t[a>>2]|0)+136>>2]=o;Rk(t[l>>2]|0);if(!(t[(t[a>>2]|0)+136>>2]|0)){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}l=Ik(t[(t[a>>2]|0)+136>>2]|0)|0;t[(t[a>>2]|0)+140>>2]=l;l=t[a>>2]|0;if(!(t[(t[a>>2]|0)+140>>2]|0)){Ak(t[l+136>>2]|0);t[(t[a>>2]|0)+136>>2]=0;t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}o=zk(t[l+140>>2]|0,t[(t[a>>2]|0)+20>>2]|0,(t[(t[a>>2]|0)+20>>2]|0)+4|0)|0;t[(t[a>>2]|0)+152>>2]=o;if(!(t[(t[a>>2]|0)+152>>2]|0)){Ak(t[(t[a>>2]|0)+136>>2]|0);t[(t[a>>2]|0)+136>>2]=0;Nk(t[(t[a>>2]|0)+140>>2]|0);t[(t[a>>2]|0)+140>>2]=0;t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}}else{t[(t[a>>2]|0)+140>>2]=t[c>>2];t[(t[a>>2]|0)+144>>2]=1;c=zk(t[(t[a>>2]|0)+140>>2]|0,t[(t[a>>2]|0)+20>>2]|0,(t[(t[a>>2]|0)+20>>2]|0)+4|0)|0;t[(t[a>>2]|0)+152>>2]=c;if(!(t[(t[a>>2]|0)+152>>2]|0)){t[(t[a>>2]|0)+140>>2]=0;t[(t[a>>2]|0)+144>>2]=0;t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}}Vk(t[(t[a>>2]|0)+140>>2]|0,369,t[a>>2]|0);if(t[(t[a>>2]|0)+108>>2]|0)Ck(t[(t[a>>2]|0)+140>>2]|0,367,368,t[a>>2]|0);if(t[(t[a>>2]|0)+192>>2]|0)Bk(t[(t[a>>2]|0)+140>>2]|0,370,t[a>>2]|0);t[(t[a>>2]|0)+148>>2]=0;t[(t[a>>2]|0)+8>>2]=4;t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}function EH(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[f+4>>2]=n;if(!(t[a>>2]|0)){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}if((t[o>>2]|0)!=0&(t[c>>2]|0)!=0){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}do if((t[o>>2]|0)!=0|(t[c>>2]|0)!=0){if((t[t[a>>2]>>2]|0)==0?(t[(t[a>>2]|0)+20>>2]|0)!=0:0)break;t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}while(0);if(t[(t[a>>2]|0)+120>>2]|0){if(!(t[(t[a>>2]|0)+124>>2]|0))GH(t[(t[a>>2]|0)+120>>2]|0);t[(t[a>>2]|0)+120>>2]=0}t[(t[a>>2]|0)+124>>2]=0;if(t[(t[a>>2]|0)+116>>2]|0){CH(t[(t[a>>2]|0)+116>>2]|0);t[(t[a>>2]|0)+116>>2]=0}if((t[o>>2]|0)==0&(t[c>>2]|0)==0){t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}if(t[o>>2]|0){t[l>>2]=IH(t[o>>2]|0)|0;if(t[(t[a>>2]|0)+108>>2]|0)UH(t[l>>2]|0,367,368,t[a>>2]|0);if(t[(t[a>>2]|0)+192>>2]|0)KH(t[(t[a>>2]|0)+120>>2]|0,370,t[a>>2]|0);o=xH(t[l>>2]|0)|0;t[(t[a>>2]|0)+116>>2]=o;HH(t[l>>2]|0);if(!(t[(t[a>>2]|0)+116>>2]|0)){t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}l=YH(t[(t[a>>2]|0)+116>>2]|0)|0;t[(t[a>>2]|0)+120>>2]=l;if(!(t[(t[a>>2]|0)+120>>2]|0)){CH(t[(t[a>>2]|0)+116>>2]|0);t[(t[a>>2]|0)+116>>2]=0;t[u>>2]=-1;b=t[u>>2]|0;s=f;return b|0}}else{t[(t[a>>2]|0)+120>>2]=t[c>>2];t[(t[a>>2]|0)+124>>2]=1}if(t[(t[a>>2]|0)+108>>2]|0)WH(t[(t[a>>2]|0)+120>>2]|0,367,368,t[a>>2]|0);if(t[(t[a>>2]|0)+192>>2]|0)KH(t[(t[a>>2]|0)+120>>2]|0,370,t[a>>2]|0);t[(t[a>>2]|0)+128>>2]=0;t[(t[a>>2]|0)+132>>2]=0;t[(t[a>>2]|0)+8>>2]=2;t[u>>2]=0;b=t[u>>2]|0;s=f;return b|0}function SH(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+8|0;c=f;t[u>>2]=e;t[a>>2]=i;t[c>>2]=rs(t[a>>2]|0)|0;if((t[c>>2]|0)<=1){s=f;return}if((n[(t[a>>2]|0)+((t[c>>2]|0)-2)>>0]|0)==58){s=f;return}t[o>>2]=r;r=t[u>>2]|0;TH(r,2,NH(t[a>>2]|0,o)|0);s=f;return}function gH(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+8|0;c=f;t[u>>2]=e;t[a>>2]=i;t[c>>2]=rs(t[a>>2]|0)|0;if(!(t[c>>2]|0)){s=f;return}if((n[(t[a>>2]|0)+((t[c>>2]|0)-1)>>0]|0)==58){s=f;return}t[o>>2]=r;r=t[u>>2]|0;TH(r,1,NH(t[a>>2]|0,o)|0);s=f;return}function yH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[n>>2];t[a>>2]=t[(t[u>>2]|0)+272>>2];if(!(t[f>>2]|0)){s=r;return}if(!(t[(t[a>>2]|0)+192>>2]|0)){s=r;return}EAi[t[(t[a>>2]|0)+192>>2]&511](t[(t[a>>2]|0)+112>>2]|0,t[f>>2]|0);s=r;return}function FH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)t[u>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+296>>2];else t[u>>2]=0;if(!(t[f>>2]|0)){s=r;return}if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[f>>2]|0);do if((t[(t[f>>2]|0)+20>>2]|0)!=0?(t[(t[(t[f>>2]|0)+20>>2]|0)+32>>2]|0)!=0:0){if((t[(t[(t[(t[f>>2]|0)+20>>2]|0)+32>>2]|0)+44>>2]|0)==0?(t[(t[(t[(t[f>>2]|0)+20>>2]|0)+32>>2]|0)+48>>2]|0)==0:0)break;if(VM(t[(t[(t[f>>2]|0)+20>>2]|0)+32>>2]|0,t[(t[f>>2]|0)+20>>2]|0,t[f>>2]|0)|0)LH(t[(t[(t[f>>2]|0)+20>>2]|0)+32>>2]|0,t[f>>2]|0)|0}while(0);if(t[(t[f>>2]|0)+12>>2]|0)OH(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);do if(t[(t[f>>2]|0)+8>>2]|0){if((t[u>>2]|0)!=0?(wz(t[u>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0)}while(0);if(((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+20>>2]|0)+376>>2]|0)<100:0){t[(t[f>>2]|0)+24>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+380>>2];t[(t[(t[n>>2]|0)+20>>2]|0)+380>>2]=t[f>>2];u=(t[(t[n>>2]|0)+20>>2]|0)+376|0;t[u>>2]=(t[u>>2]|0)+1;s=r;return}pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}function OH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+20>>2]|0)!=0:0)t[a>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+296>>2];else t[a>>2]=0;if(!(t[f>>2]|0)){s=r;return}i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==18){Zg(i);s=r;return}if((t[i+4>>2]|0)!=9?(t[(t[f>>2]|0)+4>>2]|0)!=13:0){while(1){if(!(t[f>>2]|0))break;t[u>>2]=t[(t[f>>2]|0)+24>>2];do if((t[(t[f>>2]|0)+4>>2]|0)!=14){if((t[(t[f>>2]|0)+12>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)!=5:0){if((t[(t[(t[f>>2]|0)+12>>2]|0)+20>>2]|0)==(t[f>>2]|0))OH(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);t[(t[f>>2]|0)+12>>2]=0}if((t[18774]|0)!=0&(t[33970]|0)!=0)pAi[t[135880>>2]&511](t[f>>2]|0);if(!(((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0))o=23;if((o|0)==23?(o=0,(t[(t[f>>2]|0)+44>>2]|0)!=0):0)AH(t[n>>2]|0,t[(t[f>>2]|0)+44>>2]|0);do if((((((t[(t[f>>2]|0)+40>>2]|0)!=((t[f>>2]|0)+44|0)?(t[(t[f>>2]|0)+4>>2]|0)!=1:0)?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0)?(t[(t[f>>2]|0)+4>>2]|0)!=5:0)?(t[(t[f>>2]|0)+40>>2]|0)!=0:0){if((t[a>>2]|0)!=0?(wz(t[a>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+40>>2]|0)}while(0);if(!(((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0))o=37;if((o|0)==37?(o=0,(t[(t[f>>2]|0)+48>>2]|0)!=0):0)Zg(t[(t[f>>2]|0)+48>>2]|0);do if(((t[(t[f>>2]|0)+4>>2]|0)!=3?(t[(t[f>>2]|0)+4>>2]|0)!=8:0)?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){if((t[a>>2]|0)!=0?(wz(t[a>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0)}while(0);if((t[(t[f>>2]|0)+4>>2]|0)==1){if(t[n>>2]|0)o=48}else if((t[n>>2]|0)!=0?(t[(t[f>>2]|0)+4>>2]|0)==3:0)o=48;if(((o|0)==48?(o=0,(t[(t[n>>2]|0)+20>>2]|0)!=0):0)?(t[(t[(t[n>>2]|0)+20>>2]|0)+368>>2]|0)<100:0){t[(t[f>>2]|0)+24>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+372>>2];t[(t[(t[n>>2]|0)+20>>2]|0)+372>>2]=t[f>>2];i=(t[(t[n>>2]|0)+20>>2]|0)+368|0;t[i>>2]=(t[i>>2]|0)+1;break}pAi[t[135736>>2]&511](t[f>>2]|0)}while(0);t[f>>2]=t[u>>2]}s=r;return}fy(t[f>>2]|0);s=r;return}function AH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;t[u>>2]=t[(t[f>>2]|0)+24>>2];FH(t[n>>2]|0,t[f>>2]|0);t[f>>2]=t[u>>2]}s=r;return}function MH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0){if(t[(t[n>>2]|0)+24>>2]|0){t[r>>2]=t[(t[n>>2]|0)+24>>2];break}while(1){t[n>>2]=t[(t[n>>2]|0)+20>>2];if(!(t[n>>2]|0)){f=9;break}u=t[n>>2]|0;if(t[(t[n>>2]|0)+24>>2]|0){f=7;break}if(!u){f=9;break}}if((f|0)==7){t[r>>2]=t[u+24>>2];break}else if((f|0)==9){t[r>>2]=t[n>>2];break}}else t[r>>2]=0;while(0);s=i;return t[r>>2]|0}function RH(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;XF(t[r>>2]|0,371);s=i;return}function NH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+64|0;n=r;f=r+48|0;u=r+44|0;a=r+40|0;o=r+36|0;c=r+32|0;l=r+28|0;b=r+24|0;k=r+8|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;t[b>>2]=0;while(1){t[k>>2]=t[t[a>>2]>>2];t[c>>2]=yY(t[b>>2]|0,t[o>>2]|0,t[u>>2]|0,k)|0;if((t[c>>2]|0)<0){h=3;break}if((t[o>>2]|0)==64e3?1:(t[c>>2]|0)<(t[o>>2]|0)){h=15;break}if((t[c>>2]|0)<64e3)t[o>>2]=(t[c>>2]|0)+1;else t[o>>2]=64e3;i=MAi[t[135760>>2]&511](t[b>>2]|0,t[o>>2]|0)|0;t[l>>2]=i;if(!i){h=11;break}t[b>>2]=t[l>>2]}if((h|0)==3){yAi[t[135904>>2]&511](t[33980]|0,187704,n);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}else if((h|0)==11){yAi[t[135904>>2]&511](t[33980]|0,187672,n);if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=r;return w|0}else if((h|0)==15){t[f>>2]=t[b>>2];w=t[f>>2]|0;s=r;return w|0}return 0}function TH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];t[c>>2]=t[(t[o>>2]|0)+272>>2];if(!(t[a>>2]|0)){s=n;return}if(t[(t[c>>2]|0)+108>>2]|0)NAi[t[(t[c>>2]|0)+108>>2]&511](t[(t[c>>2]|0)+112>>2]|0,t[a>>2]|0,t[u>>2]|0,t[o>>2]|0);pAi[t[135736>>2]&511](t[a>>2]|0);s=n;return}function LH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;do if(!(t[f>>2]|0))t[n>>2]=-1;else{if(!(t[u>>2]|0)){t[n>>2]=-1;break}t[a>>2]=t[(t[f>>2]|0)+64>>2];if(!(t[a>>2]|0)){t[n>>2]=-1;break}t[c>>2]=sy(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,1)|0;if(!(t[c>>2]|0)){t[n>>2]=-1;break}t[o>>2]=rO(t[a>>2]|0,t[c>>2]|0)|0;pAi[t[135736>>2]&511](t[c>>2]|0);if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+8>>2]|0)==(t[u>>2]|0):0){t[(t[o>>2]|0)+12>>2]=t[(t[u>>2]|0)+8>>2];t[(t[o>>2]|0)+8>>2]=0;t[n>>2]=0;break}t[n>>2]=-1}while(0);s=r;return t[n>>2]|0}function DH(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=0;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+20>>2]|0)t[n>>2]=t[(t[(t[r>>2]|0)+20>>2]|0)+80>>2];do if((t[(t[r>>2]|0)+4>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)!=0:0){if((t[n>>2]|0)!=0?(wz(t[n>>2]|0,t[(t[r>>2]|0)+4>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0)}while(0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function CH(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)ZH(t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)JH(t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0)QH(t[(t[r>>2]|0)+28>>2]|0);if(t[(t[r>>2]|0)+36>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+32>>2]|0))break;$H(t[(t[(t[r>>2]|0)+36>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+36>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function PH(){var e=0,i=0,r=0;e=s;s=s+16|0;i=e+4|0;if(t[46940]|0){t[i>>2]=0;r=t[i>>2]|0;s=e;return r|0}t[46942]=WF(10)|0;if(!(t[46942]|0)){yAi[t[135904>>2]&511](t[33980]|0,187776,e);t[i>>2]=-1;r=t[i>>2]|0;s=e;return r|0}else{tx(187824,0,372,373,374,375,376)|0;tx(t[46968]|0,0,377,378,379,0,0)|0;t[46940]=1;t[i>>2]=0;r=t[i>>2]|0;s=e;return r|0}return 0}function BH(){var e=0;e=s;_D();if(!(t[46940]|0)){s=e;return}XF(t[46942]|0,380);t[46940]=0;s=e;return}function IH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](148)|0;if(!(t[f>>2]|0)){lx(0,187880);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{VY(t[f>>2]|0,0,148)|0;e=Yl(t[n>>2]|0)|0;t[(t[f>>2]|0)+68>>2]=e;t[(t[f>>2]|0)+4>>2]=t[33976];t[t[f>>2]>>2]=t[33980];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function HH(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+68>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+68>>2]|0);if(t[(t[r>>2]|0)+96>>2]|0)sx(t[(t[r>>2]|0)+96>>2]|0);if(t[(t[r>>2]|0)+56>>2]|0)XF(t[(t[r>>2]|0)+56>>2]|0,0);if(t[(t[r>>2]|0)+60>>2]|0)JH(t[(t[r>>2]|0)+60>>2]|0);if(t[(t[r>>2]|0)+64>>2]|0)QH(t[(t[r>>2]|0)+64>>2]|0);if(t[(t[r>>2]|0)+108>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+108>>2]|0);if(t[(t[r>>2]|0)+124>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+124>>2]|0);if(t[(t[r>>2]|0)+84>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+76>>2]|0))break;$H(t[(t[(t[r>>2]|0)+84>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+84>>2]|0)}if((t[(t[r>>2]|0)+72>>2]|0)!=0?(t[(t[r>>2]|0)+144>>2]|0)!=0:0)fy(t[(t[r>>2]|0)+72>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function xH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;o=i;t[n>>2]=e;t[f>>2]=0;PH()|0;if(!(t[n>>2]|0)){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}e=t[n>>2]|0;do if(t[(t[n>>2]|0)+68>>2]|0){t[u>>2]=_S(t[e+68>>2]|0,0,0)|0;if(!(t[u>>2]|0)){bx(t[n>>2]|0,0,1065,187904,t[(t[n>>2]|0)+68>>2]|0,0);t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}}else{l=t[n>>2]|0;if(t[e+88>>2]|0){t[u>>2]=pS(t[l+88>>2]|0,t[(t[n>>2]|0)+92>>2]|0,0,0,0)|0;if(t[u>>2]|0){b=Yl(187992)|0;t[(t[u>>2]|0)+72>>2]=b;b=Yl(187992)|0;t[(t[n>>2]|0)+68>>2]=b;break}bx(t[n>>2]|0,0,1065,187944,0,0);t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}else{b=t[n>>2]|0;if(t[l+72>>2]|0){t[u>>2]=t[b+72>>2];break}bx(b,0,1022,188016,0,0);t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}}while(0);t[(t[n>>2]|0)+72>>2]=t[u>>2];t[u>>2]=kx(t[n>>2]|0,t[u>>2]|0)|0;if(!(t[u>>2]|0)){fy(t[(t[n>>2]|0)+72>>2]|0);t[(t[n>>2]|0)+72>>2]=0;t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[a>>2]=eF(t[u>>2]|0)|0;e=t[n>>2]|0;if(!(t[a>>2]|0)){if(t[(t[n>>2]|0)+68>>2]|0)k=t[(t[n>>2]|0)+68>>2]|0;else k=188088;bx(e,t[u>>2]|0,1022,188056,k,0);fy(t[(t[n>>2]|0)+72>>2]|0);t[(t[n>>2]|0)+72>>2]=0;t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[f>>2]=hx(e,t[a>>2]|0)|0;a=t[n>>2]|0;if(!(t[f>>2]|0)){fy(t[a+72>>2]|0);t[(t[n>>2]|0)+72>>2]=0;t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}if(t[a+56>>2]|0)aO(t[(t[n>>2]|0)+56>>2]|0,381,t[n>>2]|0);a=t[f>>2]|0;if((t[(t[n>>2]|0)+36>>2]|0)>0){CH(a);t[(t[n>>2]|0)+72>>2]=0;fy(t[u>>2]|0);t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}if((t[a+4>>2]|0)!=0?(t[(t[(t[f>>2]|0)+4>>2]|0)+12>>2]|0)!=0:0){if((t[t[(t[(t[f>>2]|0)+4>>2]|0)+12>>2]>>2]|0)!=20?(t[o>>2]=dx(t[n>>2]|0,0)|0,(t[o>>2]|0)!=0):0){t[t[o>>2]>>2]=20;t[(t[o>>2]|0)+24>>2]=t[(t[(t[f>>2]|0)+4>>2]|0)+12>>2];t[(t[(t[f>>2]|0)+4>>2]|0)+12>>2]=t[o>>2]}vx(t[n>>2]|0,t[(t[(t[f>>2]|0)+4>>2]|0)+12>>2]|0)|0}t[(t[f>>2]|0)+8>>2]=t[u>>2];t[(t[n>>2]|0)+72>>2]=0;t[(t[f>>2]|0)+24>>2]=t[(t[n>>2]|0)+60>>2];t[(t[n>>2]|0)+60>>2]=0;t[(t[f>>2]|0)+28>>2]=t[(t[n>>2]|0)+64>>2];t[(t[n>>2]|0)+64>>2]=0;t[(t[f>>2]|0)+32>>2]=t[(t[n>>2]|0)+76>>2];t[(t[f>>2]|0)+36>>2]=t[(t[n>>2]|0)+84>>2];t[(t[n>>2]|0)+84>>2]=0;if((t[(t[n>>2]|0)+128>>2]|0)==1)t[(t[f>>2]|0)+12>>2]=1;t[r>>2]=t[f>>2];c=t[r>>2]|0;s=i;return c|0}function UH(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[u>>2]|0)){s=f;return}t[(t[u>>2]|0)+4>>2]=t[a>>2];t[(t[u>>2]|0)+8>>2]=t[o>>2];t[(t[u>>2]|0)+12>>2]=0;t[t[u>>2]>>2]=t[c>>2];s=f;return}function zH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+48|0;f=n+32|0;u=n+28|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[n+24>>2]=i;t[a>>2]=r;t[o>>2]=1;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}do if(!(t[(t[u>>2]|0)+84>>2]|0)){t[c>>2]=t[(t[u>>2]|0)+20>>2];if(!(t[c>>2]|0)){mx(t[u>>2]|0,34,0,0,0);t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}t[l>>2]=t[(t[c>>2]|0)+4>>2];if((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+12>>2]|0)!=0:0){t[k>>2]=t[(t[l>>2]|0)+12>>2];r=t[k>>2]|0;if(!(t[(t[k>>2]|0)+52>>2]|0)){t[(t[u>>2]|0)+108>>2]=r;t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[b>>2]=Ws(t[r+52>>2]|0,382,t[u>>2]|0)|0;if(t[b>>2]|0){px(t[u>>2]|0,t[b>>2]|0)|0;break}t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}mx(t[u>>2]|0,34,0,0,0);t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}while(0);t[(t[u>>2]|0)+104>>2]=t[a>>2];t[(t[u>>2]|0)+100>>2]=0;b=t[(t[u>>2]|0)+84>>2]|0;k=t[(t[a>>2]|0)+8>>2]|0;if(t[(t[a>>2]|0)+36>>2]|0)t[o>>2]=Zs(b,k,t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0,t[u>>2]|0)|0;else t[o>>2]=Xs(b,k,t[u>>2]|0)|0;k=t[u>>2]|0;do if((t[o>>2]|0)>=0){if(!(t[k+100>>2]|0)){t[o>>2]=0;break}if((t[(t[u>>2]|0)+100>>2]|0)<0){t[o>>2]=-1;break}else{t[o>>2]=1;break}}else mx(k,38,t[(t[a>>2]|0)+8>>2]|0,0,0);while(0);t[f>>2]=t[o>>2];h=t[f>>2]|0;s=n;return h|0}function jH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n;t[a>>2]=e;t[o>>2]=i;t[n+4>>2]=r;t[c>>2]=1;if((t[a>>2]|0)!=0?!((t[o>>2]|0)==0?1:(t[(t[a>>2]|0)+84>>2]|0)==0):0){e:while(1){if(!(u[t[o>>2]>>0]|0))break;do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}if(!(u[t[o>>2]>>0]|0)){t[f>>2]=1;l=t[f>>2]|0;s=n;return l|0}t[c>>2]=Xs(t[(t[a>>2]|0)+84>>2]|0,188096,t[a>>2]|0)|0;if((t[c>>2]|0)<0){mx(t[a>>2]|0,39,188104,0,0);t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=1;l=t[f>>2]|0;s=n;return l|0}}t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}function VH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[n+12>>2]=i;t[a>>2]=r;if((t[u>>2]|0)!=0?!((t[a>>2]|0)==0?1:(t[(t[u>>2]|0)+84>>2]|0)==0):0){t[c>>2]=Ex(t[u>>2]|0)|0;t[o>>2]=Xs(t[c>>2]|0,0,0)|0;do if(t[o>>2]|0)if((t[o>>2]|0)<0){t[o>>2]=-1;break}else{t[o>>2]=1;break}else{mx(t[u>>2]|0,22,188112,0,0);t[o>>2]=-1}while(0);Ks(t[c>>2]|0);t[f>>2]=t[o>>2];l=t[f>>2]|0;s=n;return l|0}t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}function qH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[n+12>>2]=i;t[a>>2]=r;if((t[u>>2]|0)!=0?!((t[a>>2]|0)==0?1:(t[(t[u>>2]|0)+108>>2]|0)==0):0){t[c>>2]=Sx(t[u>>2]|0,t[(t[a>>2]|0)+20>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}t[(t[c>>2]|0)+4>>2]=t[a>>2];t[(t[u>>2]|0)+60>>2]=t[c>>2];t[(t[u>>2]|0)+40>>2]=0;t[o>>2]=gx(t[u>>2]|0,t[(t[u>>2]|0)+108>>2]|0)|0;if((t[o>>2]|0)==0?(t[(t[u>>2]|0)+40>>2]|0)==0:0)t[o>>2]=1;else t[o>>2]=-1;yx(t[u>>2]|0,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=0;t[f>>2]=t[o>>2];l=t[f>>2]|0;s=n;return l|0}t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}function YH(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](116)|0;if(!(t[f>>2]|0)){Fx(0,188120);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+116|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+20>>2]=t[n>>2];t[(t[f>>2]|0)+4>>2]=t[33976];t[t[f>>2]>>2]=t[33980];t[(t[f>>2]|0)+48>>2]=0;t[(t[f>>2]|0)+52>>2]=0;t[(t[f>>2]|0)+44>>2]=0;t[(t[f>>2]|0)+56>>2]=0;if(t[n>>2]|0)t[(t[f>>2]|0)+36>>2]=t[(t[n>>2]|0)+12>>2];t[(t[f>>2]|0)+64>>2]=0;t[(t[f>>2]|0)+68>>2]=0;t[(t[f>>2]|0)+80>>2]=0;t[(t[f>>2]|0)+40>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function GH(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+64>>2]|0)Ox(0,t[(t[r>>2]|0)+64>>2]|0);if(t[(t[r>>2]|0)+68>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[t[(t[r>>2]|0)+68>>2]>>2]|0))break;yx(0,t[(t[(t[(t[r>>2]|0)+68>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}Ox(0,t[(t[r>>2]|0)+68>>2]|0)}if(t[(t[r>>2]|0)+80>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+72>>2]|0))break;Ox(0,t[(t[(t[r>>2]|0)+80>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+80>>2]|0)}if(t[(t[r>>2]|0)+56>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+56>>2]|0);if(t[(t[r>>2]|0)+96>>2]|0){t[f>>2]=Ex(t[r>>2]|0)|0;while(1){if(!(t[f>>2]|0))break;Ks(t[f>>2]|0);t[f>>2]=Ex(t[r>>2]|0)|0}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+96>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function WH(e,i,r,n){e=e|0;i=i|0;r=r|0;
	n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;if(!(t[u>>2]|0)){s=f;return}t[(t[u>>2]|0)+4>>2]=t[a>>2];t[(t[u>>2]|0)+8>>2]=t[o>>2];t[t[u>>2]>>2]=t[c>>2];t[(t[u>>2]|0)+12>>2]=0;s=f;return}function KH(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(!(t[f>>2]|0)){s=n;return}t[(t[f>>2]|0)+12>>2]=t[u>>2];t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=0;t[t[f>>2]>>2]=t[a>>2];s=n;return}function XH(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}t[(t[f>>2]|0)+24>>2]=t[u>>2];t[a>>2]=Ax(t[f>>2]|0,t[u>>2]|0)|0;Mx(t[u>>2]|0);if((t[a>>2]|0)==-1){t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function ZH(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)ZH(t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)ZH(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0)XF(t[(t[r>>2]|0)+28>>2]|0,0);if(t[(t[r>>2]|0)+24>>2]|0)XF(t[(t[r>>2]|0)+24>>2]|0,0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function JH(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];sx(t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function QH(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];Rx(t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function $H(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((((t[t[r>>2]>>2]|0)==7?(t[(t[r>>2]|0)+36>>2]|0)!=0:0)?(t[n>>2]=t[(t[r>>2]|0)+20>>2],(t[n>>2]|0)!=0):0)?(t[(t[n>>2]|0)+24>>2]|0)!=0:0)EAi[t[(t[n>>2]|0)+24>>2]&511](t[(t[n>>2]|0)+4>>2]|0,t[(t[r>>2]|0)+36>>2]|0);if((t[(t[r>>2]|0)+20>>2]|0)!=0?(t[t[r>>2]>>2]|0)==19:0)Nx(t[(t[r>>2]|0)+20>>2]|0);if((t[(t[r>>2]|0)+20>>2]|0)!=0?(t[t[r>>2]>>2]|0)==17:0)XF(t[(t[r>>2]|0)+20>>2]|0,0);if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)fb(t[(t[r>>2]|0)+52>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function ex(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+12|0;f=r+4|0;u=r;t[r+8>>2]=e;t[f>>2]=i;do if(t[f>>2]|0){t[u>>2]=RD(t[f>>2]|0,196728)|0;if(!(t[u>>2]|0)){t[n>>2]=0;break}else{t[n>>2]=1;break}}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function ix(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+28|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[u+24>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;do if(!((t[o>>2]|0)==0|(t[c>>2]|0)==0)){t[k>>2]=RD(t[o>>2]|0,196728)|0;if(!(t[k>>2]|0)){t[a>>2]=-1;break}t[h>>2]=LD(t[k>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;if((t[h>>2]|0)==2){t[a>>2]=2;break}if(!(t[h>>2]|0)){t[a>>2]=1;break}if((t[h>>2]|0)>0){t[a>>2]=0;break}else{t[a>>2]=-1;break}}else t[a>>2]=-1;while(0);s=u;return t[a>>2]|0}function rx(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;o=s;s=s+48|0;c=o+44|0;l=o+36|0;b=o+32|0;k=o+28|0;h=o+24|0;w=o+20|0;d=o+16|0;v=o+12|0;m=o+8|0;_=o+4|0;p=o;t[o+40>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;t[_>>2]=0;t[p>>2]=0;if((t[l>>2]|0)==0|(t[b>>2]|0)==0|(t[w>>2]|0)==0){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}t[m>>2]=RD(t[l>>2]|0,196728)|0;if(!(t[m>>2]|0)){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}if(!(t[h>>2]|0)){t[v>>2]=LD(t[m>>2]|0,t[b>>2]|0,_,t[k>>2]|0)|0;if(t[v>>2]|0){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}if(!(t[_>>2]|0)){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}}else t[_>>2]=t[h>>2];t[v>>2]=LD(t[m>>2]|0,t[w>>2]|0,p,t[d>>2]|0)|0;d=t[_>>2]|0;if(t[v>>2]|0){if((d|0)!=(t[h>>2]|0))MD(t[_>>2]|0);t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}t[v>>2]=BD(d,t[p>>2]|0)|0;if((t[_>>2]|0)!=(t[h>>2]|0))MD(t[_>>2]|0);MD(t[p>>2]|0);if((t[v>>2]|0)==-2){t[c>>2]=-1;E=t[c>>2]|0;s=o;return E|0}if(!(t[v>>2]|0)){t[c>>2]=1;E=t[c>>2]|0;s=o;return E|0}else{t[c>>2]=0;E=t[c>>2]|0;s=o;return E|0}return 0}function nx(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a+36|0;c=a+28|0;l=a+24|0;b=a+20|0;k=a+16|0;h=a+12|0;w=a+8|0;d=a+4|0;v=a;t[a+32>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;if((t[c>>2]|0)==0|(t[k>>2]|0)==0){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[d>>2]=RD(t[c>>2]|0,196728)|0;if(!(t[d>>2]|0)){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[w>>2]=gk()|0;if(!(t[w>>2]|0)){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}do if(Xl(t[l>>2]|0,196768)|0)t[t[w>>2]>>2]=1e3;else{if(Xl(t[l>>2]|0,196784)|0){t[t[w>>2]>>2]=1001;break}if(Xl(t[l>>2]|0,196800)|0){t[t[w>>2]>>2]=1002;break}if(Xl(t[l>>2]|0,196816)|0){t[t[w>>2]>>2]=1003;break}if(Xl(t[l>>2]|0,196832)|0){t[t[w>>2]>>2]=1004;break}if(Xl(t[l>>2]|0,196848)|0){t[t[w>>2]>>2]=1005;break}if(Xl(t[l>>2]|0,196864)|0){t[t[w>>2]>>2]=1006;break}if(Xl(t[l>>2]|0,196872)|0){t[t[w>>2]>>2]=1007;break}if(Xl(t[l>>2]|0,196888)|0){t[t[w>>2]>>2]=1008;break}if(Xl(t[l>>2]|0,196904)|0){t[t[w>>2]>>2]=1009;break}if(Xl(t[l>>2]|0,196912)|0){t[t[w>>2]>>2]=1010;break}u=(Xl(t[l>>2]|0,196928)|0)!=0;f=t[w>>2]|0;if(u){t[f>>2]=1011;break}Fk(f);t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}while(0);t[(t[w>>2]|0)+8>>2]=t[b>>2];t[v>>2]=Tk(t[w>>2]|0,t[d>>2]|0,0,t[c>>2]|0)|0;if(t[v>>2]|0){Fk(t[w>>2]|0);t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}t[v>>2]=UD(t[d>>2]|0,t[w>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;Fk(t[w>>2]|0);if(t[v>>2]|0){t[o>>2]=-1;m=t[o>>2]|0;s=a;return m|0}else{t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}return 0}function fx(e,i){e=e|0;i=i|0;var r=0,n=0;r=s;s=s+16|0;n=r;t[r+4>>2]=e;t[n>>2]=i;MD(t[n>>2]|0);s=r;return}function tx(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;o=s;s=s+48|0;c=o;l=o+40|0;b=o+36|0;k=o+32|0;h=o+28|0;w=o+24|0;d=o+20|0;v=o+16|0;m=o+12|0;_=o+8|0;p=o+4|0;t[b>>2]=e;t[k>>2]=i;t[h>>2]=r;t[w>>2]=n;t[d>>2]=f;t[v>>2]=u;t[m>>2]=a;if((t[46942]|0)==0|(t[b>>2]|0)==0|(t[w>>2]|0)==0|(t[d>>2]|0)==0){t[l>>2]=-1;E=t[l>>2]|0;s=o;return E|0}if(rO(t[46942]|0,t[b>>2]|0)|0){a=t[33976]|0;u=t[33980]|0;t[c>>2]=t[b>>2];yAi[a&511](u,196944,c);t[l>>2]=-1;E=t[l>>2]|0;s=o;return E|0}t[_>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[_>>2]|0)){Fx(0,196992);t[l>>2]=-1;E=t[l>>2]|0;s=o;return E|0}u=t[_>>2]|0;t[u+0>>2]=0;t[u+4>>2]=0;t[u+8>>2]=0;t[u+12>>2]=0;t[u+16>>2]=0;t[u+20>>2]=0;t[u+24>>2]=0;u=Yl(t[b>>2]|0)|0;t[t[_>>2]>>2]=u;t[(t[_>>2]|0)+4>>2]=t[k>>2];t[(t[_>>2]|0)+8>>2]=t[h>>2];t[(t[_>>2]|0)+16>>2]=t[d>>2];t[(t[_>>2]|0)+12>>2]=t[w>>2];t[(t[_>>2]|0)+20>>2]=t[v>>2];t[(t[_>>2]|0)+24>>2]=t[m>>2];t[p>>2]=ZF(t[46942]|0,t[b>>2]|0,t[_>>2]|0)|0;if((t[p>>2]|0)<0){p=t[33976]|0;m=t[33980]|0;t[c>>2]=t[b>>2];yAi[p&511](m,197016,c);cx(t[_>>2]|0,t[b>>2]|0);t[l>>2]=-1;E=t[l>>2]|0;s=o;return E|0}else{t[l>>2]=0;E=t[l>>2]|0;s=o;return E|0}return 0}function ux(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+8|0;f=r;t[r+4>>2]=e;t[f>>2]=i;do if(t[f>>2]|0){if(Xl(t[f>>2]|0,196712)|0){t[n>>2]=1;break}if(Xl(t[f>>2]|0,196720)|0){t[n>>2]=1;break}else{t[n>>2]=0;break}}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function ax(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0;u=s;s=s+32|0;a=u+20|0;o=u+12|0;c=u+8|0;t[u+16>>2]=e;t[o>>2]=i;t[c>>2]=r;t[u+4>>2]=n;t[u>>2]=f;do if(t[c>>2]|0){if(Xl(t[o>>2]|0,196712)|0){t[a>>2]=1;break}if(Xl(t[o>>2]|0,196720)|0){t[a>>2]=1;break}else{t[a>>2]=0;break}}else t[a>>2]=-1;while(0);s=u;return t[a>>2]|0}function ox(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;o=s;s=s+48|0;c=o+32|0;l=o+28|0;b=o+16|0;k=o+8|0;h=o+4|0;w=o;t[o+36>>2]=e;t[c>>2]=i;t[l>>2]=r;t[o+24>>2]=n;t[o+20>>2]=f;t[b>>2]=u;t[o+12>>2]=a;t[k>>2]=-1;if(Xl(t[c>>2]|0,196712)|0){t[k>>2]=Xl(t[l>>2]|0,t[b>>2]|0)|0;d=t[k>>2]|0;s=o;return d|0}if(!(Xl(t[c>>2]|0,196720)|0)){d=t[k>>2]|0;s=o;return d|0}if(Xl(t[l>>2]|0,t[b>>2]|0)|0){t[k>>2]=1;d=t[k>>2]|0;s=o;return d|0}t[h>>2]=Tx(0,t[l>>2]|0)|0;t[w>>2]=Tx(0,t[b>>2]|0)|0;do if(!((t[h>>2]|0)==0|(t[w>>2]|0)==0))if(Xl(t[h>>2]|0,t[w>>2]|0)|0){t[k>>2]=1;break}else{t[k>>2]=0;break}else t[k>>2]=-1;while(0);if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);if(!(t[w>>2]|0)){d=t[k>>2]|0;s=o;return d|0}pAi[t[135736>>2]&511](t[w>>2]|0);d=t[k>>2]|0;s=o;return d|0}function cx(e,i){e=e|0;i=i|0;var r=0,n=0;r=s;s=s+16|0;n=r+4|0;t[n>>2]=e;t[r>>2]=i;if(!(t[n>>2]|0)){s=r;return}if(t[t[n>>2]>>2]|0)pAi[t[135736>>2]&511](t[t[n>>2]>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0);s=r;return}function lx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;if(t[f>>2]|0){i=t[f>>2]|0;if(t[(t[f>>2]|0)+12>>2]|0)t[a>>2]=t[i+12>>2];else t[o>>2]=t[i+4>>2];t[c>>2]=t[t[f>>2]>>2];i=(t[f>>2]|0)+36|0;t[i>>2]=(t[i>>2]|0)+1}i=t[a>>2]|0;a=t[o>>2]|0;o=t[c>>2]|0;if(t[u>>2]|0){c=t[u>>2]|0;t[n>>2]=t[u>>2];cp(i,a,o,0,0,18,2,3,0,0,c,0,0,0,0,189400,n);s=r;return}else{cp(i,a,o,0,0,18,2,3,0,0,0,0,0,0,0,189432,n);s=r;return}}function sx(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)Lx(t[(t[r>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function bx(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;if(t[c>>2]|0){u=t[c>>2]|0;if(t[(t[c>>2]|0)+12>>2]|0)t[d>>2]=t[u+12>>2];else t[v>>2]=t[u+4>>2];t[m>>2]=t[t[c>>2]>>2];u=(t[c>>2]|0)+36|0;t[u>>2]=(t[u>>2]|0)+1}u=t[d>>2]|0;d=t[v>>2]|0;v=t[m>>2]|0;m=t[l>>2]|0;l=t[b>>2]|0;b=t[h>>2]|0;c=t[w>>2]|0;f=t[k>>2]|0;k=t[w>>2]|0;t[o>>2]=t[h>>2];t[o+4>>2]=k;cp(u,d,v,0,m,18,l,2,0,0,b,c,0,0,0,f,o);s=a;return}function kx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=eF(t[u>>2]|0)|0;i=t[f>>2]|0;if(!(t[a>>2]|0)){bx(i,t[u>>2]|0,1022,188056,t[(t[f>>2]|0)+68>>2]|0,0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{Dx(i,t[a>>2]|0);t[n>>2]=t[u>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function hx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[a>>2]=Cx(t[f>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[o>>2]=t[(t[f>>2]|0)+44>>2];t[(t[f>>2]|0)+44>>2]=0;if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,190264)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){i=Px(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0;t[(t[a>>2]|0)+4>>2]=i;if(!(t[(t[a>>2]|0)+4>>2]|0)){CH(t[a>>2]|0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}}else{i=Bx(t[f>>2]|0)|0;t[b>>2]=i;t[(t[a>>2]|0)+4>>2]=i;if(!(t[(t[a>>2]|0)+4>>2]|0)){CH(t[a>>2]|0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[t[b>>2]>>2]=t[(t[f>>2]|0)+24>>2];do if(t[(t[f>>2]|0)+24>>2]|0){t[l>>2]=t[(t[(t[f>>2]|0)+24>>2]|0)+4>>2];if(!(t[l>>2]|0)){t[(t[(t[f>>2]|0)+24>>2]|0)+4>>2]=t[b>>2];break}while(1){if(!(t[(t[l>>2]|0)+8>>2]|0))break;t[l>>2]=t[(t[l>>2]|0)+8>>2]}t[(t[l>>2]|0)+8>>2]=t[b>>2]}while(0);t[c>>2]=t[(t[f>>2]|0)+24>>2];t[(t[f>>2]|0)+24>>2]=t[b>>2];Ix(t[f>>2]|0,t[u>>2]|0)|0;if(t[c>>2]|0)t[(t[f>>2]|0)+24>>2]=t[c>>2]}t[(t[f>>2]|0)+44>>2]=t[o>>2];if((t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0)!=0?(Hx(t[f>>2]|0,t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0,0)|0,(t[(t[f>>2]|0)+32>>2]&128|0)==0):0){xx(t[f>>2]|0,t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0,0);while(1){if(!(t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0))break;if((t[t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]>>2]|0)!=-1)break;if(!(t[(t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0)+32>>2]|0))break;t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]=t[(t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0)+24>>2]}Ux(t[f>>2]|0,t[(t[(t[a>>2]|0)+4>>2]|0)+12>>2]|0,16,-1)|0}t[n>>2]=t[a>>2];k=t[n>>2]|0;s=r;return k|0}function wx(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;n=s;s=s+64|0;a=n+60|0;o=n+56|0;c=n+48|0;l=n+44|0;b=n+40|0;k=n+36|0;h=n+32|0;w=n+28|0;d=n+24|0;v=n+20|0;m=n+16|0;_=n+12|0;p=n+8|0;E=n+4|0;S=n;t[a>>2]=e;t[o>>2]=i;t[n+52>>2]=r;t[b>>2]=0;t[k>>2]=0;t[_>>2]=0;t[p>>2]=0;t[E>>2]=0;t[S>>2]=1;if(t[(t[o>>2]|0)+36>>2]|0){s=n;return}t[c>>2]=t[(t[a>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break;t[p>>2]=(t[p>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+32>>2]}t[k>>2]=gAi[t[135744>>2]&511](t[p>>2]<<2)|0;e:do if(t[k>>2]|0){t[c>>2]=t[(t[a>>2]|0)+24>>2];while(1){g=t[33936]|0;if(!(t[c>>2]|0))break;p=gAi[g&511](12)|0;t[(t[k>>2]|0)+(t[_>>2]<<2)>>2]=p;if(!(t[(t[k>>2]|0)+(t[_>>2]<<2)>>2]|0))break e;if((t[t[c>>2]>>2]|0)==3)t[E>>2]=(t[E>>2]|0)+1;t[t[(t[k>>2]|0)+(t[_>>2]<<2)>>2]>>2]=t[c>>2];p=zx(t[o>>2]|0,t[c>>2]|0,0)|0;t[(t[(t[k>>2]|0)+(t[_>>2]<<2)>>2]|0)+4>>2]=p;p=zx(t[o>>2]|0,t[c>>2]|0,1)|0;t[(t[(t[k>>2]|0)+(t[_>>2]<<2)>>2]|0)+8>>2]=p;t[_>>2]=(t[_>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+32>>2]}t[b>>2]=gAi[g&511](16)|0;if(t[b>>2]|0){p=t[b>>2]|0;t[p+0>>2]=0;t[p+4>>2]=0;t[p+8>>2]=0;t[p+12>>2]=0;t[t[b>>2]>>2]=t[_>>2];p=WF(t[_>>2]|0)|0;t[(t[b>>2]|0)+4>>2]=p;t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[_>>2]|0))break;t[h>>2]=t[(t[k>>2]|0)+(t[w>>2]<<2)>>2];t[d>>2]=(t[w>>2]|0)+1;while(1){if((t[d>>2]|0)>=(t[_>>2]|0))break;if(t[(t[k>>2]|0)+(t[d>>2]<<2)>>2]|0){t[v>>2]=jx(t[o>>2]|0,t[(t[h>>2]|0)+4>>2]|0,t[(t[(t[k>>2]|0)+(t[d>>2]<<2)>>2]|0)+4>>2]|0)|0;if(!(t[v>>2]|0))bx(t[o>>2]|0,t[(t[a>>2]|0)+4>>2]|0,1021,190104,0,0);t[v>>2]=jx(t[o>>2]|0,t[(t[h>>2]|0)+8>>2]|0,t[(t[(t[k>>2]|0)+(t[d>>2]<<2)>>2]|0)+8>>2]|0)|0;if(!(t[v>>2]|0))bx(t[o>>2]|0,t[(t[a>>2]|0)+4>>2]|0,1001,190152,0,0)}t[d>>2]=(t[d>>2]|0)+1}t[l>>2]=t[(t[h>>2]|0)+4>>2];i:do if((t[l>>2]|0)!=0?(t[t[l>>2]>>2]|0)!=0:0)while(1){if(!(t[t[l>>2]>>2]|0))break i;do if((t[t[t[l>>2]>>2]>>2]|0)==3){t[m>>2]=QF(t[(t[b>>2]|0)+4>>2]|0,188096,0,(t[w>>2]|0)+1|0)|0;if(t[m>>2]|0)t[S>>2]=-1}else{if((t[t[t[l>>2]>>2]>>2]|0)==4?(t[(t[t[l>>2]>>2]|0)+8>>2]|0)!=0:0){if((t[(t[t[l>>2]>>2]|0)+12>>2]|0)!=0?(u[t[(t[t[l>>2]>>2]|0)+12>>2]>>0]|0)!=0:0)t[m>>2]=QF(t[(t[b>>2]|0)+4>>2]|0,t[(t[t[l>>2]>>2]|0)+8>>2]|0,t[(t[t[l>>2]>>2]|0)+12>>2]|0,(t[w>>2]|0)+1|0)|0;else t[m>>2]=QF(t[(t[b>>2]|0)+4>>2]|0,t[(t[t[l>>2]>>2]|0)+8>>2]|0,0,(t[w>>2]|0)+1|0)|0;if(!(t[m>>2]|0))break;t[S>>2]=-1;break}if((t[t[t[l>>2]>>2]>>2]|0)!=4){t[S>>2]=-1;break}if((t[(t[t[l>>2]>>2]|0)+12>>2]|0)!=0?(u[t[(t[t[l>>2]>>2]|0)+12>>2]>>0]|0)!=0:0)t[m>>2]=QF(t[(t[b>>2]|0)+4>>2]|0,189536,t[(t[t[l>>2]>>2]|0)+12>>2]|0,(t[w>>2]|0)+1|0)|0;else t[m>>2]=QF(t[(t[b>>2]|0)+4>>2]|0,189536,0,(t[w>>2]|0)+1|0)|0;if(t[(t[t[l>>2]>>2]|0)+40>>2]|0)t[S>>2]=2;if(t[m>>2]|0)t[S>>2]=-1}while(0);t[l>>2]=(t[l>>2]|0)+4}else y=48;while(0);if((y|0)==48){y=0;t[S>>2]=0}t[w>>2]=(t[w>>2]|0)+1}t[(t[b>>2]|0)+12>>2]=t[k>>2];t[(t[a>>2]|0)+20>>2]=t[b>>2];if(t[E>>2]|0){p=(t[a>>2]|0)+50|0;f[p>>1]=f[p>>1]|8}if((t[S>>2]|0)==1)t[(t[b>>2]|0)+8>>2]=1;if((t[S>>2]|0)!=2){s=n;return}t[(t[b>>2]|0)+8>>2]=3;s=n;return}}while(0);lx(t[o>>2]|0,190192);if(t[k>>2]|0){t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[_>>2]|0))break;if(t[(t[k>>2]|0)+(t[w>>2]<<2)>>2]|0){if(t[(t[(t[k>>2]|0)+(t[w>>2]<<2)>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[(t[k>>2]|0)+(t[w>>2]<<2)>>2]|0)+4>>2]|0);pAi[t[135736>>2]&511](t[(t[k>>2]|0)+(t[w>>2]<<2)>>2]|0)}t[w>>2]=(t[w>>2]|0)+1}pAi[t[135736>>2]&511](t[k>>2]|0)}Nx(t[b>>2]|0);s=n;return}function dx(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;i=(t[u>>2]|0)+80|0;do if(!(t[(t[u>>2]|0)+80>>2]|0)){t[i>>2]=16;t[(t[u>>2]|0)+76>>2]=0;e=gAi[t[135744>>2]&511](t[(t[u>>2]|0)+80>>2]<<2)|0;t[(t[u>>2]|0)+84>>2]=e;if(!(t[(t[u>>2]|0)+84>>2]|0)){lx(t[u>>2]|0,190080);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}}else if((t[i>>2]|0)<=(t[(t[u>>2]|0)+76>>2]|0)){e=(t[u>>2]|0)+80|0;t[e>>2]=t[e>>2]<<1;t[c>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+84>>2]|0,t[(t[u>>2]|0)+80>>2]<<2)|0;if(t[c>>2]|0){t[(t[u>>2]|0)+84>>2]=t[c>>2];break}lx(t[u>>2]|0,190080);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}while(0);t[o>>2]=gAi[t[135744>>2]&511](56)|0;if(!(t[o>>2]|0)){lx(t[u>>2]|0,190080);t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else{c=(t[o>>2]|0)+0|0;i=c+56|0;do{t[c>>2]=0;c=c+4|0}while((c|0)<(i|0));c=t[o>>2]|0;i=(t[u>>2]|0)+76|0;e=t[i>>2]|0;t[i>>2]=e+1;t[(t[(t[u>>2]|0)+84>>2]|0)+(e<<2)>>2]=c;t[(t[o>>2]|0)+4>>2]=t[a>>2];f[(t[o>>2]|0)+48>>1]=-1;t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}return 0}function vx(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}if(!((t[t[a>>2]>>2]|0)!=20?(t[t[a>>2]>>2]|0)!=4:0))b=5;if(((b|0)==5?(t[o>>2]=Vx(t[a>>2]|0)|0,(f[(t[a>>2]|0)+50>>1]&64|0)!=0):0)?(f[(t[a>>2]|0)+48>>1]|0)!=-25:0){t[(t[u>>2]|0)+132>>2]=0;t[o>>2]=qx(t[u>>2]|0,t[a>>2]|0)|0;t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}e:do switch(t[t[a>>2]>>2]|0){case 4:case 0:case 7:case 6:case 8:case 5:case 3:{t[o>>2]=0;break}case 13:case 12:case 11:case 20:case 10:case 18:case 17:case 16:case 15:case 14:{t[c>>2]=t[(t[a>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break e;t[o>>2]=vx(t[u>>2]|0,t[c>>2]|0)|0;if(t[o>>2]|0)break e;t[c>>2]=t[(t[c>>2]|0)+32>>2]}break}case-1:{t[o>>2]=vx(t[u>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0;break}case 1:case 19:case 9:case 2:{t[o>>2]=0;break}default:{}}while(0);t[n>>2]=t[o>>2];l=t[n>>2]|0;s=r;return l|0}function mx(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;if(!(t[a>>2]|0)){s=u;return}if(t[(t[a>>2]|0)+28>>2]&8){s=u;return}if((t[(t[a>>2]|0)+28>>2]&1|0)!=0?(t[(t[a>>2]|0)+28>>2]&2|0)==0:0){Wx(t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;s=u;return}if(t[(t[a>>2]|0)+48>>2]|0)Yx(t[a>>2]|0);if(t[(t[a>>2]|0)+60>>2]|0){t[k>>2]=t[t[(t[a>>2]|0)+60>>2]>>2];t[h>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]}else{t[h>>2]=0;t[k>>2]=0}if((t[k>>2]|0)==0&(t[h>>2]|0)==0)t[k>>2]=t[(t[a>>2]|0)+104>>2];Gx(t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,t[h>>2]|0,t[c>>2]|0,t[l>>2]|0);s=u;return}function _x(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;f=s;s=s+64|0;a=f;o=f+52|0;c=f+48|0;l=f+44|0;b=f+40|0;k=f+36|0;h=f+32|0;w=f+28|0;d=f+24|0;m=f+20|0;_=f+16|0;p=f+12|0;E=f+8|0;S=f+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=t[b>>2];t[h>>2]=t[l>>2];t[_>>2]=0;if(!(t[k>>2]|0)){l=t[v>>2]|0;t[a>>2]=t[c>>2];xe(l|0,189616,a|0)|0;s=f;return}t[m>>2]=t[(t[k>>2]|0)+104>>2];t[(t[k>>2]|0)+100>>2]=1;if(!(t[h>>2]|0)){if((u[t[c>>2]>>0]|0|0)==35){s=f;return}l=t[v>>2]|0;t[a>>2]=t[c>>2];xe(l|0,189648,a|0)|0;if((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+40>>2]|0)==0:0)t[(t[k>>2]|0)+40>>2]=37;t[(t[k>>2]|0)+100>>2]=-1;s=f;return}if((t[k>>2]|0)==0|(t[h>>2]|0)==0){l=t[v>>2]|0;t[a>>2]=t[c>>2];xe(l|0,189680,a|0)|0;if((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+40>>2]|0)==0:0)t[(t[k>>2]|0)+40>>2]=37;t[(t[k>>2]|0)+100>>2]=-1;s=f;return}if((t[t[h>>2]>>2]|0)!=4){l=t[v>>2]|0;t[a>>2]=t[c>>2];xe(l|0,189712,a|0)|0;if(!(t[(t[k>>2]|0)+40>>2]|0))t[(t[k>>2]|0)+40>>2]=37;t[(t[k>>2]|0)+100>>2]=-1;s=f;return}if((t[(t[m>>2]|0)+4>>2]|0)!=1){mx(t[k>>2]|0,23,0,0,0);if(!(t[(t[k>>2]|0)+28>>2]&1))Yx(t[k>>2]|0);t[(t[k>>2]|0)+100>>2]=-1;s=f;return}if(!(t[(t[h>>2]|0)+52>>2]|0)){t[(t[k>>2]|0)+100>>2]=0;t[(t[k>>2]|0)+108>>2]=t[h>>2];s=f;return}t[o>>2]=Ws(t[(t[h>>2]|0)+52>>2]|0,382,t[k>>2]|0)|0;a=t[k>>2]|0;if(!(t[o>>2]|0)){t[a+100>>2]=-1;s=f;return}px(a,t[o>>2]|0)|0;t[w>>2]=Sx(t[k>>2]|0,t[m>>2]|0)|0;o=t[k>>2]|0;if(!(t[w>>2]|0)){t[o+100>>2]=-1;s=f;return}t[d>>2]=t[o+60>>2];t[(t[k>>2]|0)+60>>2]=t[w>>2];if((t[(t[h>>2]|0)+36>>2]|0)!=0?(t[_>>2]=Kx(t[k>>2]|0,t[(t[h>>2]|0)+36>>2]|0)|0,(t[_>>2]|0)!=0):0){t[(t[k>>2]|0)+100>>2]=-1;mx(t[k>>2]|0,24,t[(t[m>>2]|0)+8>>2]|0,0,0)}m=t[k>>2]|0;if(!(t[(t[k>>2]|0)+60>>2]|0)){if(t[m+64>>2]|0){t[E>>2]=-1;t[p>>2]=t[(t[k>>2]|0)+28>>2];t[S>>2]=0;while(1){if((t[S>>2]|0)>=(t[t[(t[k>>2]|0)+64>>2]>>2]|0))break;t[w>>2]=t[(t[(t[(t[k>>2]|0)+64>>2]|0)+8>>2]|0)+(t[S>>2]<<2)>>2];t[(t[k>>2]|0)+60>>2]=t[w>>2];t[(t[(t[k>>2]|0)+60>>2]|0)+4>>2]=0;if(!(Xx(t[k>>2]|0,0)|0)){g=39;break}t[S>>2]=(t[S>>2]|0)+1}if((g|0)==39)t[E>>2]=0;if(t[E>>2]|0){g=(t[k>>2]|0)+28|0;t[g>>2]=t[g>>2]|1;Zx(t[k>>2]|0)}t[S>>2]=0;while(1){y=t[k>>2]|0;if((t[S>>2]|0)>=(t[t[(t[k>>2]|0)+64>>2]>>2]|0))break;yx(y,t[(t[(t[(t[k>>2]|0)+64>>2]|0)+8>>2]|0)+(t[S>>2]<<2)>>2]|0);t[S>>2]=(t[S>>2]|0)+1}Ox(y,t[(t[k>>2]|0)+64>>2]|0);t[(t[k>>2]|0)+64>>2]=0;if((t[_>>2]|0)==0&(t[E>>2]|0)==-1)t[(t[k>>2]|0)+100>>2]=-1;t[(t[k>>2]|0)+28>>2]=t[p>>2]}}else{t[(t[m+60>>2]|0)+4>>2]=0;t[_>>2]=Xx(t[k>>2]|0,1)|0;if(t[_>>2]|0)t[(t[k>>2]|0)+100>>2]=-1;yx(t[k>>2]|0,t[(t[k>>2]|0)+60>>2]|0)}if((t[(t[k>>2]|0)+100>>2]|0)==-1?(t[(t[k>>2]|0)+28>>2]&1|0)==0:0)Yx(t[k>>2]|0);t[(t[k>>2]|0)+60>>2]=t[d>>2];s=f;return}function px(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[f>>2]|0)+96>>2]|0)==0?(t[(t[f>>2]|0)+92>>2]=10,i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+92>>2]<<2)|0,t[(t[f>>2]|0)+96>>2]=i,(t[(t[f>>2]|0)+96>>2]|0)==0):0){Fx(t[f>>2]|0,189544);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}if((t[(t[f>>2]|0)+88>>2]|0)>=(t[(t[f>>2]|0)+92>>2]|0)?(i=(t[f>>2]|0)+92|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+96>>2]|0,t[(t[f>>2]|0)+92>>2]<<2)|0,t[(t[f>>2]|0)+96>>2]=i,(t[(t[f>>2]|0)+96>>2]|0)==0):0){Fx(t[f>>2]|0,189544);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}i=t[u>>2]|0;e=(t[f>>2]|0)+88|0;o=t[e>>2]|0;t[e>>2]=o+1;t[(t[(t[f>>2]|0)+96>>2]|0)+(o<<2)>>2]=i;t[(t[f>>2]|0)+84>>2]=t[u>>2];t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function Ex(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+88>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+88|0;t[e>>2]=(t[e>>2]|0)+-1;t[f>>2]=t[(t[(t[n>>2]|0)+96>>2]|0)+(t[(t[n>>2]|0)+88>>2]<<2)>>2];t[(t[(t[n>>2]|0)+96>>2]|0)+(t[(t[n>>2]|0)+88>>2]<<2)>>2]=0;e=t[n>>2]|0;if((t[(t[n>>2]|0)+88>>2]|0)>0)t[(t[n>>2]|0)+84>>2]=t[(t[(t[n>>2]|0)+96>>2]|0)+((t[e+88>>2]|0)-1<<2)>>2];else t[e+84>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function Sx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+128|0;n=r+112|0;f=r+108|0;u=r+104|0;a=r+100|0;o=r+96|0;c=r+16|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[l>>2]=0;t[b>>2]=0;e:do if(!(t[u>>2]|0)){t[b>>2]=eF(t[(t[f>>2]|0)+24>>2]|0)|0;if(!(t[b>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}}else{t[o>>2]=t[(t[u>>2]|0)+44>>2];while(1){if(!(t[o>>2]|0))break e;if((t[l>>2]|0)<20){i=t[o>>2]|0;e=t[l>>2]|0;t[l>>2]=e+1;t[c+(e<<2)>>2]=i}else t[l>>2]=(t[l>>2]|0)+1;t[o>>2]=t[(t[o>>2]|0)+24>>2]}}while(0);if((t[(t[f>>2]|0)+68>>2]|0)!=0?(t[t[(t[f>>2]|0)+68>>2]>>2]|0)>0:0){i=t[(t[f>>2]|0)+68>>2]|0;t[i>>2]=(t[i>>2]|0)+-1;t[a>>2]=t[(t[(t[(t[f>>2]|0)+68>>2]|0)+8>>2]|0)+(t[t[(t[f>>2]|0)+68>>2]>>2]<<2)>>2]}else w=13;do if((w|0)==13){t[a>>2]=gAi[t[135744>>2]&511](32)|0;if(t[a>>2]|0){i=t[a>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[i+8>>2]=0;t[i+12>>2]=0;t[i+16>>2]=0;t[i+20>>2]=0;t[i+24>>2]=0;t[i+28>>2]=0;break}Fx(t[f>>2]|0,189568);t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}while(0);t[(t[a>>2]|0)+20>>2]=0;t[(t[a>>2]|0)+24>>2]=0;if(!(t[u>>2]|0)){t[t[a>>2]>>2]=t[(t[f>>2]|0)+24>>2];t[(t[a>>2]|0)+4>>2]=t[b>>2]}else{t[t[a>>2]>>2]=t[u>>2];t[(t[a>>2]|0)+4>>2]=t[(t[u>>2]|0)+12>>2]}t[(t[a>>2]|0)+8>>2]=0;e:do if((t[l>>2]|0)>0){do if(!(t[(t[a>>2]|0)+28>>2]|0)){if((t[l>>2]|0)<4)t[(t[a>>2]|0)+12>>2]=4;else t[(t[a>>2]|0)+12>>2]=t[l>>2];b=gAi[t[135744>>2]&511](t[(t[a>>2]|0)+12>>2]<<2)|0;t[(t[a>>2]|0)+28>>2]=b;if(!(t[(t[a>>2]|0)+28>>2]|0)){Fx(t[f>>2]|0,189568);t[n>>2]=t[a>>2];h=t[n>>2]|0;s=r;return h|0}}else if((t[(t[a>>2]|0)+12>>2]|0)<(t[l>>2]|0)){t[k>>2]=MAi[t[135760>>2]&511](t[(t[a>>2]|0)+28>>2]|0,t[l>>2]<<2)|0;if(t[k>>2]|0){t[(t[a>>2]|0)+28>>2]=t[k>>2];t[(t[a>>2]|0)+12>>2]=t[l>>2];break}Fx(t[f>>2]|0,189568);t[n>>2]=t[a>>2];h=t[n>>2]|0;s=r;return h|0}while(0);t[(t[a>>2]|0)+8>>2]=t[l>>2];if((t[l>>2]|0)<20){YY(t[(t[a>>2]|0)+28>>2]|0,c|0,t[l>>2]<<2|0)|0;break}t[o>>2]=t[(t[u>>2]|0)+44>>2];t[l>>2]=0;while(1){if(!(t[o>>2]|0))break e;b=t[o>>2]|0;w=t[l>>2]|0;t[l>>2]=w+1;t[(t[(t[a>>2]|0)+28>>2]|0)+(w<<2)>>2]=b;t[o>>2]=t[(t[o>>2]|0)+24>>2]}}while(0);t[(t[a>>2]|0)+16>>2]=t[(t[a>>2]|0)+8>>2];t[n>>2]=t[a>>2];h=t[n>>2]|0;s=r;return h|0}function gx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+48|0;n=r;f=r+44|0;u=r+40|0;a=r+36|0;o=r+32|0;c=r+28|0;l=r+24|0;b=r+20|0;k=r+16|0;h=r+12|0;w=r+8|0;t[u>>2]=e;t[a>>2]=i;if((t[(t[u>>2]|0)+60>>2]|0)!=0?(t[(t[u>>2]|0)+64>>2]|0)!=0:0){i=t[33976]|0;e=t[33980]|0;t[n>>2]=189496;t[n+4>>2]=10608;yAi[i&511](e,189464,n);yx(t[u>>2]|0,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=0}if((t[(t[u>>2]|0)+64>>2]|0)!=0?(t[t[(t[u>>2]|0)+64>>2]>>2]|0)!=1:0){t[o>>2]=t[(t[u>>2]|0)+64>>2];t[(t[u>>2]|0)+64>>2]=0;t[c>>2]=0;t[b>>2]=0;t[w>>2]=t[(t[u>>2]|0)+28>>2];e=(t[u>>2]|0)+28|0;t[e>>2]=t[e>>2]|1;t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[t[o>>2]>>2]|0))break;t[(t[u>>2]|0)+60>>2]=t[(t[(t[o>>2]|0)+8>>2]|0)+(t[l>>2]<<2)>>2];t[(t[u>>2]|0)+64>>2]=0;t[h>>2]=Jx(t[u>>2]|0,t[a>>2]|0)|0;if((t[(t[u>>2]|0)+60>>2]|0)!=0?(t[(t[u>>2]|0)+64>>2]|0)!=0:0){e=t[33976]|0;i=t[33980]|0;t[n>>2]=189496;t[n+4>>2]=10645;yAi[e&511](i,189464,n);yx(t[u>>2]|0,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=0}i=t[u>>2]|0;e:do if(t[h>>2]|0){e=t[u>>2]|0;if(t[i+60>>2]|0){yx(e,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=0;break}if(t[e+64>>2]|0){t[k>>2]=0;while(1){d=t[u>>2]|0;if((t[k>>2]|0)>=(t[t[(t[u>>2]|0)+64>>2]>>2]|0))break;yx(d,t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[k>>2]<<2)>>2]|0);t[k>>2]=(t[k>>2]|0)+1}Ox(d,t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0}}else{e=t[c>>2]|0;if(!(t[i+64>>2]|0)){v=t[u>>2]|0;if(e){Qx(v,t[c>>2]|0,t[(t[u>>2]|0)+60>>2]|0)|0;t[(t[u>>2]|0)+60>>2]=0;break}else{m=t[v+60>>2]|0;v=t[b>>2]|0;t[b>>2]=v+1;t[(t[(t[o>>2]|0)+8>>2]|0)+(v<<2)>>2]=m;t[(t[u>>2]|0)+60>>2]=0;break}}if(!e){t[c>>2]=t[(t[u>>2]|0)+64>>2];t[(t[u>>2]|0)+64>>2]=0;t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[b>>2]|0))break e;Qx(t[u>>2]|0,t[c>>2]|0,t[(t[(t[o>>2]|0)+8>>2]|0)+(t[k>>2]<<2)>>2]|0)|0;t[k>>2]=(t[k>>2]|0)+1}}t[k>>2]=0;while(1){_=t[u>>2]|0;if((t[k>>2]|0)>=(t[t[(t[u>>2]|0)+64>>2]>>2]|0))break;Qx(_,t[c>>2]|0,t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[k>>2]<<2)>>2]|0)|0;t[k>>2]=(t[k>>2]|0)+1}Ox(_,t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0}while(0);t[l>>2]=(t[l>>2]|0)+1}t[(t[u>>2]|0)+28>>2]=t[w>>2];do if(!(t[c>>2]|0)){w=t[b>>2]|0;if((t[b>>2]|0)>1){t[t[o>>2]>>2]=w;t[(t[u>>2]|0)+64>>2]=t[o>>2];t[h>>2]=0;break}if((w|0)==1){t[(t[u>>2]|0)+60>>2]=t[t[(t[o>>2]|0)+8>>2]>>2];Ox(t[u>>2]|0,t[o>>2]|0);t[h>>2]=0;break}t[h>>2]=-1;Ox(t[u>>2]|0,t[o>>2]|0);if(t[(t[u>>2]|0)+64>>2]|0){Ox(t[u>>2]|0,t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0}}else{Ox(t[u>>2]|0,t[o>>2]|0);t[(t[u>>2]|0)+64>>2]=t[c>>2];t[h>>2]=0}while(0);if((t[(t[u>>2]|0)+60>>2]|0)!=0?(t[(t[u>>2]|0)+64>>2]|0)!=0:0){c=t[33976]|0;o=t[33980]|0;t[n>>2]=189496;t[n+4>>2]=10711;yAi[c&511](o,189464,n);yx(t[u>>2]|0,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=0}t[f>>2]=t[h>>2];p=t[f>>2]|0;s=r;return p|0}if(t[(t[u>>2]|0)+64>>2]|0){t[(t[u>>2]|0)+60>>2]=t[t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]>>2];Ox(t[u>>2]|0,t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0}t[h>>2]=Jx(t[u>>2]|0,t[a>>2]|0)|0;if((t[(t[u>>2]|0)+60>>2]|0)!=0?(t[(t[u>>2]|0)+64>>2]|0)!=0:0){a=t[33976]|0;o=t[33980]|0;t[n>>2]=189496;t[n+4>>2]=10620;yAi[a&511](o,189464,n);yx(t[u>>2]|0,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=0}if((t[(t[u>>2]|0)+64>>2]|0)!=0?(t[t[(t[u>>2]|0)+64>>2]>>2]|0)==1:0){t[(t[u>>2]|0)+60>>2]=t[t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]>>2];Ox(t[u>>2]|0,t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0}t[f>>2]=t[h>>2];p=t[f>>2]|0;s=r;return p|0}function yx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+68>>2]|0)==0:0){i=$x(t[n>>2]|0,40)|0;t[(t[n>>2]|0)+68>>2]=i}if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+68>>2]|0)!=0:0){eU(t[n>>2]|0,t[(t[n>>2]|0)+68>>2]|0,t[f>>2]|0)|0;s=r;return}if(t[(t[f>>2]|0)+28>>2]|0)pAi[t[135736>>2]&511](t[(t[f>>2]|0)+28>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}function Fx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;if(t[f>>2]|0){i=t[f>>2]|0;if(t[(t[f>>2]|0)+12>>2]|0)t[a>>2]=t[i+12>>2];else t[o>>2]=t[i+4>>2];t[c>>2]=t[t[f>>2]>>2];i=(t[f>>2]|0)+16|0;t[i>>2]=(t[i>>2]|0)+1}i=t[a>>2]|0;a=t[o>>2]|0;o=t[c>>2]|0;if(t[u>>2]|0){c=t[u>>2]|0;t[n>>2]=t[u>>2];cp(i,a,o,0,0,19,2,3,0,0,c,0,0,0,0,189400,n);s=r;return}else{cp(i,a,o,0,0,19,2,3,0,0,0,0,0,0,0,189432,n);s=r;return}}function Ox(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+80>>2]|0)==0:0){t[(t[n>>2]|0)+76>>2]=40;t[(t[n>>2]|0)+72>>2]=0;i=gAi[t[135744>>2]&511](t[(t[n>>2]|0)+76>>2]<<2)|0;t[(t[n>>2]|0)+80>>2]=i;if(!(t[(t[n>>2]|0)+80>>2]|0))Fx(t[n>>2]|0,189384)}else a=6;do if(((a|0)==6?(t[n>>2]|0)!=0:0)?(t[(t[n>>2]|0)+72>>2]|0)>=(t[(t[n>>2]|0)+76>>2]|0):0){t[u>>2]=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+80>>2]|0,t[(t[n>>2]|0)+76>>2]<<1<<2)|0;if(t[u>>2]|0){t[(t[n>>2]|0)+80>>2]=t[u>>2];i=(t[n>>2]|0)+76|0;t[i>>2]=t[i>>2]<<1;break}Fx(t[n>>2]|0,189384);pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}while(0);if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+80>>2]|0)!=0:0){u=t[f>>2]|0;a=(t[n>>2]|0)+72|0;i=t[a>>2]|0;t[a>>2]=i+1;t[(t[(t[n>>2]|0)+80>>2]|0)+(i<<2)>>2]=u;s=r;return}pAi[t[135736>>2]&511](t[(t[f>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[f>>2]|0);s=r;return}function Ax(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+112|0;n=r+100|0;f=r+96|0;u=r+92|0;a=r+88|0;o=r+84|0;c=r+80|0;l=r+76|0;b=r+72|0;k=r+68|0;h=r+64|0;w=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)!=0?!((t[u>>2]|0)==0?1:(t[(t[f>>2]|0)+20>>2]|0)==0):0){t[(t[f>>2]|0)+40>>2]=0;t[o>>2]=t[(t[f>>2]|0)+20>>2];t[c>>2]=t[(t[o>>2]|0)+4>>2];o=t[f>>2]|0;if(!(t[c>>2]|0)){mx(o,34,0,0,0);t[n>>2]=-1;d=t[n>>2]|0;s=r;return d|0}t[l>>2]=Sx(o,0)|0;t[(t[f>>2]|0)+60>>2]=t[l>>2];t[a>>2]=gx(t[f>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0;if((t[(t[f>>2]|0)+60>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)!=0:0){t[l>>2]=t[(t[f>>2]|0)+60>>2];t[b>>2]=t[(t[l>>2]|0)+4>>2];t[b>>2]=iU(t[f>>2]|0,t[b>>2]|0)|0;if((t[b>>2]|0)!=0&(t[a>>2]|0)!=-1){mx(t[f>>2]|0,35,0,0,0);t[a>>2]=-1}}else v=10;if((v|0)==10?(t[(t[f>>2]|0)+64>>2]|0)!=0:0){t[h>>2]=-1;t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[t[(t[f>>2]|0)+64>>2]>>2]|0))break;t[l>>2]=t[(t[(t[(t[f>>2]|0)+64>>2]|0)+8>>2]|0)+(t[k>>2]<<2)>>2];t[b>>2]=t[(t[l>>2]|0)+4>>2];t[b>>2]=iU(t[f>>2]|0,t[b>>2]|0)|0;if(!(t[b>>2]|0))t[h>>2]=0;yx(t[f>>2]|0,t[l>>2]|0);t[k>>2]=(t[k>>2]|0)+1}if((t[h>>2]|0)==-1&(t[a>>2]|0)!=-1){mx(t[f>>2]|0,35,0,0,0);t[a>>2]=-1}}if(t[(t[f>>2]|0)+60>>2]|0){yx(t[f>>2]|0,t[(t[f>>2]|0)+60>>2]|0);t[(t[f>>2]|0)+60>>2]=0}if(t[a>>2]|0)Yx(t[f>>2]|0);if((t[(t[f>>2]|0)+36>>2]|0)==1){h=w+0|0;k=h+64|0;do{t[h>>2]=0;h=h+4|0}while((h|0)<(k|0));t[w+36>>2]=1;t[w+4>>2]=t[(t[f>>2]|0)+4>>2];t[w+8>>2]=t[(t[f>>2]|0)+8>>2];t[w>>2]=t[t[f>>2]>>2];if((wR(w,t[u>>2]|0)|0)!=1)t[a>>2]=-1}if((t[a>>2]|0)==0?(t[(t[f>>2]|0)+40>>2]|0)!=0:0)t[a>>2]=-1;t[n>>2]=t[a>>2];d=t[n>>2]|0;s=r;return d|0}t[n>>2]=-1;d=t[n>>2]|0;s=r;return d|0}function Mx(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(((t[(t[r>>2]|0)+4>>2]|0)!=1?(t[(t[r>>2]|0)+4>>2]|0)!=9:0)?(t[(t[r>>2]|0)+4>>2]|0)!=13:0){s=i;return}if((t[(t[r>>2]|0)+4>>2]|0)==1)t[(t[r>>2]|0)+52>>2]=0;t[n>>2]=t[(t[r>>2]|0)+12>>2];e:while(1){if(!(t[n>>2]|0))break;if((t[(t[n>>2]|0)+4>>2]|0)==1?(t[(t[n>>2]|0)+52>>2]=0,(t[(t[n>>2]|0)+12>>2]|0)!=0):0){t[n>>2]=t[(t[n>>2]|0)+12>>2];continue}if(t[(t[n>>2]|0)+24>>2]|0){t[n>>2]=t[(t[n>>2]|0)+24>>2];continue}while(1){t[n>>2]=t[(t[n>>2]|0)+20>>2];if(!(t[n>>2]|0))continue e;
	if((t[n>>2]|0)==(t[r>>2]|0)){f=16;break}u=t[n>>2]|0;if(t[(t[n>>2]|0)+24>>2]|0){f=18;break}if(!u)continue e}if((f|0)==16){f=0;t[n>>2]=0;continue}else if((f|0)==18){f=0;t[n>>2]=t[u+24>>2];continue}}s=i;return}function Rx(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)CH(t[(t[r>>2]|0)+16>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Nx(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+12>>2]|0){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[t[r>>2]>>2]|0))break;t[n>>2]=t[(t[(t[r>>2]|0)+12>>2]|0)+(t[f>>2]<<2)>>2];if(t[n>>2]|0){if(t[(t[n>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+4>>2]|0);if(t[(t[n>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[n>>2]|0)}t[f>>2]=(t[f>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0)}if(t[(t[r>>2]|0)+4>>2]|0)XF(t[(t[r>>2]|0)+4>>2]|0,0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Tx(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+32|0;f=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[a>>2]=e;t[o>>2]=i;if(!(t[o>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[b>>2]=t[o>>2];while(1){w=t[b>>2]|0;if(!(u[t[b>>2]>>0]|0))break;t[b>>2]=w+1}t[k>>2]=w-(t[o>>2]|0);t[c>>2]=gAi[t[135752>>2]&511]((t[k>>2]|0)+1|0)|0;if(!(t[c>>2]|0)){Fx(t[a>>2]|0,189544);t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[l>>2]=t[c>>2];e:while(1){do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13)break e}while(0);t[o>>2]=(t[o>>2]|0)+1}e:while(1){if(!(u[t[o>>2]>>0]|0))break;do if((u[t[o>>2]>>0]|0|0)!=32){if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0)break;if((u[t[o>>2]>>0]|0|0)!=13){a=t[o>>2]|0;t[o>>2]=a+1;k=n[a>>0]|0;a=t[l>>2]|0;t[l>>2]=a+1;n[a>>0]=k;continue e}}while(0);while(1){do if((u[t[o>>2]>>0]|0|0)==32)d=1;else{if(9<=(u[t[o>>2]>>0]|0|0)?(u[t[o>>2]>>0]|0|0)<=10:0){d=1;break}d=(u[t[o>>2]>>0]|0|0)==13}while(0);v=t[o>>2]|0;if(!d)break;t[o>>2]=v+1}if(!(u[v>>0]|0))break;k=t[l>>2]|0;t[l>>2]=k+1;n[k>>0]=32}n[t[l>>2]>>0]=0;t[f>>2]=t[c>>2];h=t[f>>2]|0;s=r;return h|0}function Lx(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+36>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+32>>2]|0))break;$H(t[(t[(t[r>>2]|0)+36>>2]|0)+(t[n>>2]<<2)>>2]|0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+36>>2]|0)}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Dx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0;r=s;s=s+144|0;n=r+128|0;f=r+124|0;u=r+120|0;a=r+116|0;o=r+112|0;c=r+108|0;l=r+104|0;b=r+100|0;k=r+96|0;h=r+92|0;w=r+88|0;d=r+84|0;v=r+80|0;m=r+76|0;_=r+72|0;p=r+68|0;E=r+64|0;S=r+60|0;g=r+56|0;y=r+52|0;F=r+48|0;O=r+44|0;A=r+40|0;M=r+36|0;R=r+32|0;N=r+28|0;T=r+24|0;L=r+20|0;D=r+16|0;C=r+12|0;P=r+8|0;B=r+4|0;I=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=0;t[u>>2]=t[f>>2];e:while(1){H=(t[a>>2]|0)!=0;if(!(t[u>>2]|0))break;if(H){iy(t[a>>2]|0);ry(t[a>>2]|0);t[a>>2]=0}i=t[u>>2]|0;i:do if((t[(t[u>>2]|0)+4>>2]|0)!=1){if((t[i+4>>2]|0)!=3?(t[(t[u>>2]|0)+4>>2]|0)!=4:0){t[a>>2]=t[u>>2];break}if(tU(t[(t[u>>2]|0)+40>>2]|0)|0){if((t[(t[u>>2]|0)+20>>2]|0)!=0?(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)==1:0){if(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,189888)|0){x=158;break}if(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,190064)|0){x=158;break}t[a>>2]=t[u>>2];x=158;break}t[a>>2]=t[u>>2]}else x=158}else{if((t[i+36>>2]|0)!=0?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){rU(t[n>>2]|0,t[u>>2]|0);e=(Xl(t[(t[u>>2]|0)+8>>2]|0,189936)|0)!=0;U=t[u>>2]|0;r:do if(e){t[c>>2]=cF(U,192672)|0;n:do if(!(t[c>>2]|0)){t[h>>2]=t[(t[u>>2]|0)+20>>2];while(1){if(!(t[h>>2]|0))break n;if((t[(t[h>>2]|0)+4>>2]|0)!=1)break n;t[c>>2]=cF(t[h>>2]|0,192672)|0;if(t[c>>2]|0)break n;t[h>>2]=t[(t[h>>2]|0)+20>>2]}}while(0);t[o>>2]=cF(t[u>>2]|0,195400)|0;if(!(t[o>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1052,195408,0,0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);t[a>>2]=t[u>>2];break i}t[w>>2]=IA(t[o>>2]|0)|0;if(!(t[w>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1041,195464,t[o>>2]|0,0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);t[a>>2]=t[u>>2];break i}if(t[(t[w>>2]|0)+32>>2]|0){bx(t[n>>2]|0,t[u>>2]|0,1041,195504,t[o>>2]|0,0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);xA(t[w>>2]|0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);t[a>>2]=t[u>>2];break i}xA(t[w>>2]|0);t[l>>2]=oF(t[(t[u>>2]|0)+32>>2]|0,t[u>>2]|0)|0;t[b>>2]=GA(t[o>>2]|0,t[l>>2]|0)|0;if(!(t[b>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1041,195552,t[o>>2]|0,0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[a>>2]=t[u>>2];break i}if(t[o>>2]|0)pAi[t[135736>>2]&511](t[o>>2]|0);if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[k>>2]=nU(t[n>>2]|0,t[b>>2]|0,t[c>>2]|0)|0;if(!(t[k>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1032,195600,t[b>>2]|0,0);if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[a>>2]=t[u>>2];break i}else{if(t[c>>2]|0)pAi[t[135736>>2]&511](t[c>>2]|0);pAi[t[135736>>2]&511](t[b>>2]|0);t[(t[u>>2]|0)+52>>2]=t[k>>2];break}}else{z=(Xl(t[U+8>>2]|0,195024)|0)!=0;j=t[u>>2]|0;if(z){t[d>>2]=cF(j,195400)|0;if(!(t[d>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1052,195632,0,0);t[a>>2]=t[u>>2];break i}t[m>>2]=oF(t[(t[u>>2]|0)+32>>2]|0,t[u>>2]|0)|0;t[_>>2]=GA(t[d>>2]|0,t[m>>2]|0)|0;if(!(t[_>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1041,195680,t[d>>2]|0,0);if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);t[a>>2]=t[u>>2];break i}if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);t[v>>2]=cF(t[u>>2]|0,192672)|0;n:do if(!(t[v>>2]|0)){t[E>>2]=t[(t[u>>2]|0)+20>>2];while(1){if(!(t[E>>2]|0))break n;if((t[(t[E>>2]|0)+4>>2]|0)!=1)break n;t[v>>2]=cF(t[E>>2]|0,192672)|0;if(t[v>>2]|0)break n;t[E>>2]=t[(t[E>>2]|0)+20>>2]}}while(0);t[p>>2]=fU(t[n>>2]|0,t[_>>2]|0,t[u>>2]|0,t[v>>2]|0)|0;if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if(!(t[p>>2]|0)){bx(t[n>>2]|0,t[u>>2]|0,1043,195720,t[_>>2]|0,0);pAi[t[135736>>2]&511](t[_>>2]|0);t[a>>2]=t[u>>2];break i}else{pAi[t[135736>>2]&511](t[_>>2]|0);t[(t[u>>2]|0)+52>>2]=t[p>>2];break}}if((Xl(t[j+8>>2]|0,189864)|0)==0?(Xl(t[(t[u>>2]|0)+8>>2]|0,189904)|0)==0:0){if(((Xl(t[(t[u>>2]|0)+8>>2]|0,192176)|0)==0?(Xl(t[(t[u>>2]|0)+8>>2]|0,193592)|0)==0:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189888)|0)==0:0){do if(Xl(t[(t[u>>2]|0)+8>>2]|0,189848)|0){if((t[u>>2]|0)==(t[f>>2]|0))break;t[L>>2]=t[(t[n>>2]|0)+32>>2];do if(t[(t[u>>2]|0)+20>>2]|0){if(!(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,193584)|0))break;z=(t[n>>2]|0)+32|0;t[z>>2]=t[z>>2]|256;Dx(t[n>>2]|0,t[u>>2]|0);t[(t[n>>2]|0)+32>>2]=t[L>>2];break i}while(0);if(!(t[(t[u>>2]|0)+20>>2]|0))break r;if(!(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,193592)|0))break r;z=(t[n>>2]|0)+32|0;t[z>>2]=t[z>>2]|512;Dx(t[n>>2]|0,t[u>>2]|0);t[(t[n>>2]|0)+32>>2]=t[L>>2];break i}while(0);if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,193584)|0))break;j=t[n>>2]|0;if(t[(t[n>>2]|0)+32>>2]&256){bx(j,t[u>>2]|0,1066,195896,0,0);break}if(!(t[j+32>>2]&512))break;bx(t[n>>2]|0,t[u>>2]|0,1084,195952,0,0);break}do if(!(dF(t[u>>2]|0,192672)|0)){t[A>>2]=0;t[O>>2]=t[(t[u>>2]|0)+20>>2];while(1){if(!(t[O>>2]|0))break;if((t[(t[O>>2]|0)+4>>2]|0)!=1)break;t[A>>2]=cF(t[O>>2]|0,192672)|0;if(t[A>>2]|0)break;t[O>>2]=t[(t[O>>2]|0)+20>>2]}j=t[u>>2]|0;if(!(t[A>>2]|0)){_F(j,192672,188112)|0;break}else{_F(j,192672,t[A>>2]|0)|0;pAi[t[135736>>2]&511](t[A>>2]|0);break}}while(0);if((Xl(t[(t[u>>2]|0)+8>>2]|0,192176)|0)!=0?(t[M>>2]=sF(t[u>>2]|0)|0,(t[M>>2]|0)!=0):0){t[R>>2]=zg(t[M>>2]|0,N)|0;if(t[R>>2]|0){t[T>>2]=wF(t[(t[u>>2]|0)+32>>2]|0,t[u>>2]|0,t[N>>2]|0)|0;if(!(t[T>>2]|0))bx(t[n>>2]|0,t[u>>2]|0,1097,195792,t[N>>2]|0,0);else{_F(t[u>>2]|0,192672,t[(t[T>>2]|0)+8>>2]|0)|0;Cy(t[u>>2]|0,t[R>>2]|0)}pAi[t[135736>>2]&511](t[R>>2]|0);pAi[t[135736>>2]&511](t[N>>2]|0)}pAi[t[135736>>2]&511](t[M>>2]|0)}if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,193592)|0))break;if(!(t[(t[n>>2]|0)+32>>2]&512))break;bx(t[n>>2]|0,t[u>>2]|0,1085,195840,0,0);break}t[y>>2]=0;t[S>>2]=cF(t[u>>2]|0,192176)|0;if(t[S>>2]|0){j=t[u>>2]|0;if(t[(t[u>>2]|0)+12>>2]|0){t[F>>2]=Sy(t[j+32>>2]|0,t[(t[u>>2]|0)+36>>2]|0,192176,0)|0;if(t[F>>2]|0){Py(t[(t[u>>2]|0)+12>>2]|0,t[F>>2]|0)|0;t[y>>2]=yy(t[S>>2]|0)|0;Hy(t[F>>2]|0,t[y>>2]|0)|0;t[y>>2]=t[F>>2]}}else t[y>>2]=Ly(j,t[(t[u>>2]|0)+36>>2]|0,192176,t[S>>2]|0)|0;if(!(t[y>>2]|0))bx(t[n>>2]|0,t[u>>2]|0,1008,195752,t[S>>2]|0,0);mF(t[u>>2]|0,192176)|0;pAi[t[135736>>2]&511](t[S>>2]|0);t[g>>2]=cF(t[u>>2]|0,192672)|0;if(!(t[g>>2]|0)){if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,189904)|0))break;_F(t[y>>2]|0,192672,188112)|0;break}if(t[y>>2]|0)_F(t[y>>2]|0,192672,t[g>>2]|0)|0;pAi[t[135736>>2]&511](t[g>>2]|0)}}while(0);if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,196008)|0)){x=158;break}t[D>>2]=cF(t[u>>2]|0,192672)|0;t[C>>2]=t[(t[u>>2]|0)+12>>2];t[P>>2]=t[u>>2];while(1){V=(t[D>>2]|0)!=0;if(!(t[C>>2]|0))break;if(V?(dF(t[C>>2]|0,192672)|0)==0:0)_F(t[C>>2]|0,192672,t[D>>2]|0)|0;t[B>>2]=t[(t[C>>2]|0)+24>>2];iy(t[C>>2]|0);t[P>>2]=oy(t[P>>2]|0,t[C>>2]|0)|0;t[C>>2]=t[B>>2]}if(V)pAi[t[135736>>2]&511](t[D>>2]|0);if((t[(t[u>>2]|0)+48>>2]|0)!=0?(t[(t[u>>2]|0)+20>>2]|0)!=0:0){t[I>>2]=(t[(t[u>>2]|0)+20>>2]|0)+48;while(1){if(!(t[t[I>>2]>>2]|0))break;t[I>>2]=t[t[I>>2]>>2]}t[t[I>>2]>>2]=t[(t[u>>2]|0)+48>>2];t[(t[u>>2]|0)+48>>2]=0}t[a>>2]=t[u>>2];break}do if((t[(t[u>>2]|0)+20>>2]|0)!=0?(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)==1:0){if(((Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,192176)|0)==0?(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,189888)|0)==0:0)?(Xl(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,190064)|0)==0:0)break;bx(t[n>>2]|0,t[u>>2]|0,1035,195352,t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0,0)}while(0);t[a>>2]=t[u>>2]}while(0);if(((((x|0)==158?(x=0,(t[(t[u>>2]|0)+12>>2]|0)!=0):0)?(t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)!=5:0)?(t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)!=6:0){t[u>>2]=t[(t[u>>2]|0)+12>>2];continue}if(t[(t[u>>2]|0)+24>>2]|0){t[u>>2]=t[(t[u>>2]|0)+24>>2];continue}while(1){t[u>>2]=t[(t[u>>2]|0)+20>>2];if(!(t[u>>2]|0))continue e;if((t[u>>2]|0)==(t[f>>2]|0)){x=167;break}q=t[u>>2]|0;if(t[(t[u>>2]|0)+24>>2]|0){x=169;break}if(!q)continue e}if((x|0)==167){x=0;t[u>>2]=0;continue}else if((x|0)==169){x=0;t[u>>2]=t[q+24>>2];continue}}if(!H){s=r;return}iy(t[a>>2]|0);ry(t[a>>2]|0);t[a>>2]=0;s=r;return}function Cx(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](40)|0;if(!(t[f>>2]|0)){lx(t[n>>2]|0,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{n=(t[f>>2]|0)+0|0;e=n+40|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(e|0));t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Px(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=Bx(t[f>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}t[t[a>>2]>>2]=t[(t[f>>2]|0)+24>>2];do if(t[(t[f>>2]|0)+24>>2]|0){t[o>>2]=t[(t[(t[f>>2]|0)+24>>2]|0)+4>>2];if(!(t[o>>2]|0)){t[(t[(t[f>>2]|0)+24>>2]|0)+4>>2]=t[a>>2];break}while(1){if(!(t[(t[o>>2]|0)+8>>2]|0))break;t[o>>2]=t[(t[o>>2]|0)+8>>2]}t[(t[o>>2]|0)+8>>2]=t[a>>2]}while(0);t[c>>2]=t[(t[f>>2]|0)+24>>2];t[(t[f>>2]|0)+24>>2]=t[a>>2];uU(t[f>>2]|0,t[u>>2]|0)|0;t[(t[f>>2]|0)+24>>2]=t[a>>2];o=t[f>>2]|0;if(t[(t[f>>2]|0)+24>>2]|0){if(!(t[(t[o+24>>2]|0)+12>>2]|0))bx(t[f>>2]|0,t[u>>2]|0,1039,194360,0,0)}else bx(o,t[u>>2]|0,1036,194320,0,0);aU(t[f>>2]|0,t[a>>2]|0);if(t[(t[a>>2]|0)+24>>2]|0)aO(t[(t[a>>2]|0)+24>>2]|0,383,t[f>>2]|0);if(t[(t[a>>2]|0)+28>>2]|0)aO(t[(t[a>>2]|0)+28>>2]|0,384,t[f>>2]|0);t[(t[f>>2]|0)+24>>2]=t[c>>2];t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}function Bx(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[f>>2]|0)){lx(t[n>>2]|0,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{n=t[f>>2]|0;t[n+0>>2]=0;t[n+4>>2]=0;t[n+8>>2]=0;t[n+12>>2]=0;t[n+16>>2]=0;t[n+20>>2]=0;t[n+24>>2]=0;t[n+28>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Ix(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;if(!(t[u>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1106,191968,0,0);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}do if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189824)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[o>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[t[o>>2]>>2]=0;if(!(t[(t[u>>2]|0)+12>>2]|0))break;bx(t[f>>2]|0,t[u>>2]|0,1024,191992,0,0);break}}else b=12;while(0);do if((b|0)==12){if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189832)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[o>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[t[o>>2]>>2]=1;if(!(t[(t[u>>2]|0)+12>>2]|0))break;bx(t[f>>2]|0,t[u>>2]|0,1055,192024,0,0);break}}t[o>>2]=lU(t[f>>2]|0,t[u>>2]|0,1)|0}while(0);if(t[(t[(t[f>>2]|0)+24>>2]|0)+12>>2]|0){t[c>>2]=t[(t[(t[f>>2]|0)+24>>2]|0)+12>>2];while(1){if(!(t[(t[c>>2]|0)+32>>2]|0))break;t[c>>2]=t[(t[c>>2]|0)+32>>2]}t[(t[c>>2]|0)+32>>2]=t[o>>2]}else t[(t[(t[f>>2]|0)+24>>2]|0)+12>>2]=t[o>>2];t[u>>2]=t[(t[u>>2]|0)+24>>2];if(t[u>>2]|0){bx(t[f>>2]|0,t[u>>2]|0,1105,192064,0,0);t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}else{t[n>>2]=t[a>>2];l=t[n>>2]|0;s=r;return l|0}return 0}function Hx(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=0;e:while(1){if(!((t[l>>2]|0)==0&(t[o>>2]|0)!=0)){b=13;break}do if((t[t[o>>2]>>2]|0)!=11?(t[t[o>>2]>>2]|0)!=13:0){r=t[a>>2]|0;i=t[(t[o>>2]|0)+24>>2]|0;e=t[c>>2]|0;if((t[t[o>>2]>>2]|0)==4){t[l>>2]=Hx(r,i,e+1|0)|0;break}else{t[l>>2]=Hx(r,i,e)|0;break}}else b=5;while(0);do if((b|0)==5){b=0;e=t[c>>2]|0;if((f[(t[o>>2]|0)+48>>1]|0)!=-1)if((e|0)==(f[(t[o>>2]|0)+48>>1]|0)){b=8;break e}else break;else{f[(t[o>>2]|0)+48>>1]=e;t[l>>2]=Hx(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[c>>2]|0)|0;f[(t[o>>2]|0)+48>>1]=-2;break}}while(0);t[o>>2]=t[(t[o>>2]|0)+32>>2]}if((b|0)==8){bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1099,191928,t[(t[o>>2]|0)+8>>2]|0,0);t[u>>2]=-1;k=t[u>>2]|0;s=n;return k|0}else if((b|0)==13){t[u>>2]=t[l>>2];k=t[u>>2]|0;s=n;return k|0}return 0}function xx(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;e:while(1){if(!(t[a>>2]|0)){h=87;break}i:do if((t[t[a>>2]>>2]|0)!=11?(t[t[a>>2]>>2]|0)!=13:0){if((t[t[a>>2]>>2]|0)==1){t[(t[a>>2]|0)+28>>2]=t[o>>2];if(t[o>>2]|0){if((t[t[o>>2]>>2]|0)==9){h=15;break e}if((t[t[o>>2]>>2]|0)==8){h=15;break e}if((t[t[o>>2]>>2]|0)==18){h=15;break e}if((t[t[o>>2]>>2]|0)==19){h=15;break e}if((t[t[o>>2]>>2]|0)==16){h=15;break e}if((t[t[o>>2]>>2]|0)==15){h=15;break e}}if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)==17:0){t[c>>2]=sU(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break}t[c>>2]=t[a>>2];break}r=(t[t[a>>2]>>2]|0)==0;t[(t[a>>2]|0)+28>>2]=t[o>>2];if(r){if(t[o>>2]|0){if((t[t[o>>2]>>2]|0)==16){h=24;break e}if((t[t[o>>2]>>2]|0)==15){h=24;break e}}do if(t[o>>2]|0){if((t[t[o>>2]>>2]|0)!=18?(t[t[o>>2]>>2]|0)!=19:0)break;t[c>>2]=sU(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break i}while(0);t[c>>2]=t[a>>2];break}if(t[(t[a>>2]|0)+24>>2]|0)xx(t[u>>2]|0,t[(t[a>>2]|0)+24>>2]|0,t[a>>2]|0);if((t[t[a>>2]>>2]|0)!=7?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)xx(t[u>>2]|0,t[(t[a>>2]|0)+36>>2]|0,t[a>>2]|0);if(t[(t[a>>2]|0)+40>>2]|0)xx(t[u>>2]|0,t[(t[a>>2]|0)+40>>2]|0,t[a>>2]|0);r:do if((t[t[a>>2]>>2]|0)==4){while(1){if(!(t[(t[a>>2]|0)+24>>2]|0))break;t[l>>2]=bU(t[u>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0;if((t[l>>2]|0)!=1)break;t[b>>2]=t[(t[a>>2]|0)+24>>2];t[(t[a>>2]|0)+24>>2]=t[(t[b>>2]|0)+32>>2];t[(t[b>>2]|0)+32>>2]=t[(t[a>>2]|0)+36>>2];t[(t[a>>2]|0)+36>>2]=t[b>>2]}t[k>>2]=t[(t[a>>2]|0)+24>>2];while(1){if(!(t[k>>2]|0))break r;if(!(t[(t[k>>2]|0)+32>>2]|0))break r;t[b>>2]=t[(t[k>>2]|0)+32>>2];t[l>>2]=bU(t[u>>2]|0,t[b>>2]|0)|0;r=t[b>>2]|0;if((t[l>>2]|0)==1){t[(t[k>>2]|0)+32>>2]=t[r+32>>2];t[(t[b>>2]|0)+32>>2]=t[(t[a>>2]|0)+36>>2];t[(t[a>>2]|0)+36>>2]=t[b>>2];continue}else{t[k>>2]=r;continue}}}while(0);if(!((t[t[a>>2]>>2]|0)!=18?(t[t[a>>2]>>2]|0)!=19:0))h=49;do if((h|0)==49){h=0;r=t[a>>2]|0;if(!(t[(t[a>>2]|0)+24>>2]|0)){t[r>>2]=0;break}if(!(t[(t[r+24>>2]|0)+32>>2]|0)){if((t[o>>2]|0)==0&(t[c>>2]|0)==0){t[t[a>>2]>>2]=-1;break}r=t[a>>2]|0;if(!(t[c>>2]|0)){t[(t[o>>2]|0)+24>>2]=t[r+24>>2];t[(t[(t[a>>2]|0)+24>>2]|0)+32>>2]=t[(t[a>>2]|0)+32>>2];t[a>>2]=t[(t[a>>2]|0)+24>>2];break}else{t[(t[(t[a>>2]|0)+24>>2]|0)+32>>2]=t[r+32>>2];t[(t[c>>2]|0)+32>>2]=t[(t[a>>2]|0)+24>>2];t[a>>2]=t[(t[a>>2]|0)+24>>2];break}}}while(0);if(((t[t[a>>2]>>2]|0)==2?(t[(t[a>>2]|0)+24>>2]|0)!=0:0)?(t[t[(t[a>>2]|0)+24>>2]>>2]|0)==1:0){t[c>>2]=sU(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break}if((t[t[a>>2]>>2]|0)==1){if(t[o>>2]|0){if((t[t[o>>2]>>2]|0)==9){h=69;break e}if((t[t[o>>2]>>2]|0)==8){h=69;break e}if((t[t[o>>2]>>2]|0)==18){h=69;break e}if((t[t[o>>2]>>2]|0)==19){h=69;break e}if((t[t[o>>2]>>2]|0)==16){h=69;break e}if((t[t[o>>2]>>2]|0)==15){h=69;break e}}if((t[o>>2]|0)!=0?(t[t[o>>2]>>2]|0)==17:0){t[c>>2]=sU(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break}t[c>>2]=t[a>>2];break}else{if(t[t[a>>2]>>2]|0){t[c>>2]=t[a>>2];break}if(t[o>>2]|0){if((t[t[o>>2]>>2]|0)==16){h=78;break e}if((t[t[o>>2]>>2]|0)==15){h=78;break e}}r:do if(t[o>>2]|0){do if((t[t[o>>2]>>2]|0)!=18){if((t[t[o>>2]>>2]|0)==19)break;if((t[t[o>>2]>>2]|0)!=17)break r}while(0);t[c>>2]=sU(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break i}while(0);t[c>>2]=t[a>>2];break}}else h=5;while(0);if((h|0)==5?(h=0,(f[(t[a>>2]|0)+48>>1]|0)!=-3):0){f[(t[a>>2]|0)+48>>1]=-3;xx(t[u>>2]|0,t[(t[a>>2]|0)+24>>2]|0,t[a>>2]|0)}t[a>>2]=t[(t[a>>2]|0)+32>>2]}if((h|0)==15){t[t[o>>2]>>2]=1;s=n;return}else if((h|0)==24){t[t[o>>2]>>2]=0;s=n;return}else if((h|0)==69){t[t[o>>2]>>2]=1;s=n;return}else if((h|0)==78){t[t[o>>2]>>2]=0;s=n;return}else if((h|0)==87){s=n;return}}function Ux(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;u=s;s=s+32|0;a=u+28|0;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;h=u+4|0;w=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[w>>2]=0;while(1){if(!(t[o>>2]|0))break;t[k>>2]=0;do if((t[t[o>>2]>>2]|0)!=11?(t[t[o>>2]>>2]|0)!=13:0){if((t[t[o>>2]>>2]|0)==4){kU(t[a>>2]|0,t[o>>2]|0);if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1070,190416,0,0);if(t[c>>2]&4)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1079,190472,0,0);if(t[c>>2]&1)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1068,190520,0,0);if(t[c>>2]&1)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1068,190520,0,0);t[b>>2]=0;t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+36>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;if(t[k>>2]|0)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1015,190576,t[(t[o>>2]|0)+8>>2]|0,0);t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;if((t[k>>2]|0)==-1){bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1016,190632,t[(t[o>>2]|0)+8>>2]|0,0);break}else{t[k>>2]=2;break}}if((t[t[o>>2]>>2]|0)==9){if(t[c>>2]&1)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1067,190672,0,0);if(t[c>>2]&4)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1078,190720,0,0);if(t[c>>2]&32)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1086,190768,0,0);if(t[c>>2]&64)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1087,190824,0,0);if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1069,190888,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1088,190936,0,0);do if((t[c>>2]&2|0)==0?(t[(t[o>>2]|0)+8>>2]|0)==0:0){n=t[a>>2]|0;r=t[(t[o>>2]|0)+4>>2]|0;if(!(t[(t[o>>2]|0)+12>>2]|0)){bx(n,r,1e3,190984,0,0);break}else{bx(n,r,1056,191040,0,0);break}}while(0);t[b>>2]=t[c>>2]|1;Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;t[k>>2]=0;break}if((t[t[o>>2]>>2]|0)!=16?(t[t[o>>2]>>2]|0)!=15:0){if((t[t[o>>2]>>2]|0)==8){if(t[c>>2]&4)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1081,191192,0,0);if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1074,191232,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1093,191280,0,0);t[b>>2]=t[c>>2]|4;t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;break}if((t[t[o>>2]>>2]|0)==18){if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1072,191320,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1091,191368,0,0);r=t[c>>2]|0;if(t[c>>2]&2)t[b>>2]=r|32;else t[b>>2]=r;t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;kU(t[a>>2]|0,t[o>>2]|0);break}if((t[t[o>>2]>>2]|0)==19){if(t[c>>2]&4)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1080,191408,0,0);if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1073,191456,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1073,191512,0,0);r=t[c>>2]|0;if(t[c>>2]&2)t[b>>2]=r|64;else t[b>>2]=r;t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;break}r=t[o>>2]|0;if((t[t[o>>2]>>2]|0)==2){if((t[r+28>>2]|0)!=0?(t[t[(t[o>>2]|0)+28>>2]>>2]|0)==5:0)t[b>>2]=t[c>>2]|8;else t[b>>2]=t[c>>2];t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;break}if((t[r>>2]|0)==5){if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1089,191560,0,0);Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[c>>2]|0,t[t[o>>2]>>2]|0)|0;t[k>>2]=1;break}if((t[t[o>>2]>>2]|0)==7){if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1096,191600,0,0);Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[c>>2]|0,t[t[o>>2]>>2]|0)|0;t[k>>2]=1;break}if((t[t[o>>2]>>2]|0)==3){if(t[c>>2]&4)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1083,191640,0,0);if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1077,191680,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1095,191728,0,0);t[k>>2]=2;break}if(t[t[o>>2]>>2]|0){r=t[a>>2]|0;n=t[o>>2]|0;if((t[t[o>>2]>>2]|0)==17){wU(r,n);t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[c>>2]|0,t[t[o>>2]>>2]|0)|0;break}else{t[k>>2]=Ux(r,t[n+24>>2]|0,t[c>>2]|0,t[t[o>>2]>>2]|0)|0;break}}if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1071,191768,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1090,191816,0,0);t[k>>2]=0;break}if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1075,191096,0,0);if(t[c>>2]&16)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1094,191144,0,0);t[b>>2]=t[c>>2]|2;t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[b>>2]|0,t[t[o>>2]>>2]|0)|0;t[k>>2]=hU(t[k>>2]|0,t[k>>2]|0)|0}else d=5;while(0);do if((d|0)==5){d=0;if(t[c>>2]&8)bx(t[a>>2]|0,t[(t[o>>2]|0)+4>>2]|0,1076,190272,0,0);do if(!(t[(t[o>>2]|0)+24>>2]|0)){n=t[a>>2]|0;r=t[(t[o>>2]|0)+4>>2]|0;if((t[t[o>>2]>>2]|0)==13){bx(n,r,1101,190320,0,0);break}if(t[(t[o>>2]|0)+8>>2]|0)v=t[(t[o>>2]|0)+8>>2]|0;else v=190408;bx(n,r,1101,190368,v,0)}while(0);r=(t[o>>2]|0)+48|0;if((f[(t[o>>2]|0)+48>>1]|0)>-4){f[r>>1]=-4;t[k>>2]=Ux(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0,t[c>>2]|0,t[t[o>>2]>>2]|0)|0;f[(t[o>>2]|0)+48>>1]=(t[k>>2]|0)-15;break}if((f[r>>1]|0)==-4){t[k>>2]=2;break}else{t[k>>2]=(f[(t[o>>2]|0)+48>>1]|0)+15;break}}while(0);t[o>>2]=t[(t[o>>2]|0)+32>>2];if((t[l>>2]|0)==18){t[w>>2]=hU(t[w>>2]|0,t[k>>2]|0)|0;continue}if((t[l>>2]|0)==19){t[h>>2]=hU(t[w>>2]|0,t[k>>2]|0)|0;if((t[h>>2]|0)==-1)continue;t[h>>2]=dU(t[w>>2]|0,t[k>>2]|0)|0;continue}if((t[l>>2]|0)==17){t[w>>2]=dU(t[w>>2]|0,t[k>>2]|0)|0;continue}if((t[l>>2]|0)==8){t[w>>2]=1;continue}if((t[l>>2]|0)!=2){t[w>>2]=hU(t[w>>2]|0,t[k>>2]|0)|0;continue}if((t[k>>2]|0)==-1){t[w>>2]=-1;continue}else{t[w>>2]=1;continue}}s=u;return t[w>>2]|0}function zx(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;n=s;s=s+48|0;f=n+40|0;u=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[h>>2]=0;t[w>>2]=0;if(t[(t[u>>2]|0)+36>>2]|0){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[l>>2]=0;t[b>>2]=t[a>>2];e:while(1){if(!(t[b>>2]|0)){m=41;break}if(!(t[o>>2]|0))if((t[t[b>>2]>>2]|0)!=4?(t[t[b>>2]>>2]|0)!=3:0)m=8;else m=10;else m=8;do if((m|0)==8){m=0;if((t[o>>2]|0)==1?(t[t[b>>2]>>2]|0)==9:0){m=10;break}if((((((((((t[t[b>>2]>>2]|0)!=17?(t[t[b>>2]>>2]|0)!=19:0)?(t[t[b>>2]>>2]|0)!=18:0)?(t[t[b>>2]>>2]|0)!=16:0)?(t[t[b>>2]>>2]|0)!=15:0)?(t[t[b>>2]>>2]|0)!=14:0)?(t[t[b>>2]>>2]|0)!=13:0)?(t[t[b>>2]>>2]|0)!=11:0)?(t[t[b>>2]>>2]|0)!=10:0)?(t[t[b>>2]>>2]|0)!=12:0)break;if(t[(t[b>>2]|0)+24>>2]|0){t[l>>2]=t[b>>2];t[b>>2]=t[(t[b>>2]|0)+24>>2];t[k>>2]=t[b>>2];while(1){if(!(t[k>>2]|0))continue e;t[(t[k>>2]|0)+28>>2]=t[l>>2];t[k>>2]=t[(t[k>>2]|0)+32>>2]}}}while(0);if((m|0)==10){m=0;if(!(t[c>>2]|0)){t[w>>2]=10;t[c>>2]=gAi[t[135744>>2]&511]((t[w>>2]|0)+1<<2)|0;if(!(t[c>>2]|0)){m=12;break}}else if((t[w>>2]|0)<=(t[h>>2]|0)){t[w>>2]=t[w>>2]<<1;t[d>>2]=MAi[t[135760>>2]&511](t[c>>2]|0,(t[w>>2]|0)+1<<2)|0;if(!(t[d>>2]|0)){m=15;break}t[c>>2]=t[d>>2]}r=t[b>>2]|0;i=t[h>>2]|0;t[h>>2]=i+1;t[(t[c>>2]|0)+(i<<2)>>2]=r;t[(t[c>>2]|0)+(t[h>>2]<<2)>>2]=0}if((t[b>>2]|0)==(t[a>>2]|0)){m=41;break}if(t[(t[b>>2]|0)+32>>2]|0){t[b>>2]=t[(t[b>>2]|0)+32>>2];continue}while(1){t[b>>2]=t[(t[b>>2]|0)+28>>2];if(!(t[b>>2]|0))continue e;if((t[b>>2]|0)==(t[a>>2]|0)){m=37;break e}_=t[b>>2]|0;if(t[(t[b>>2]|0)+32>>2]|0)break;if(!_)continue e}t[b>>2]=t[_+32>>2]}if((m|0)==12){lx(t[u>>2]|0,190240);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==15){lx(t[u>>2]|0,190240);pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}else if((m|0)==37){t[f>>2]=t[c>>2];v=t[f>>2]|0;s=n;return v|0}else if((m|0)==41){t[f>>2]=t[c>>2];v=t[f>>2]|0;s=n;return v|0}return 0}function jx(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+8|0;a=n+4|0;o=n;t[n+12>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[a>>2];if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=1;c=t[f>>2]|0;s=n;return c|0}if((t[t[u>>2]>>2]|0)!=0?(t[t[a>>2]>>2]|0)!=0:0){e:while(1){if(!(t[t[u>>2]>>2]|0)){l=12;break}while(1){if(!(t[t[a>>2]>>2]|0))break;if(!(vU(t[t[u>>2]>>2]|0,t[t[a>>2]>>2]|0)|0)){l=9;break e}t[a>>2]=(t[a>>2]|0)+4}t[a>>2]=t[o>>2];t[u>>2]=(t[u>>2]|0)+4}if((l|0)==9){t[f>>2]=0;c=t[f>>2]|0;s=n;return c|0}else if((l|0)==12){t[f>>2]=1;c=t[f>>2]|0;s=n;return c|0}}t[f>>2]=1;c=t[f>>2]|0;s=n;return c|0}function Vx(e){e=e|0;var i=0,r=0,n=0,u=0,a=0,o=0,c=0,l=0,b=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[u>>2]=-1;if(!(t[n>>2]|0)){t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}if((t[t[n>>2]>>2]|0)!=4?(f[(t[n>>2]|0)+50>>1]&64|0)!=0:0){t[r>>2]=1;l=t[r>>2]|0;s=i;return l|0}if((t[t[n>>2]>>2]|0)!=4?(f[(t[n>>2]|0)+50>>1]&128|0)!=0:0){t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}e:do switch(t[t[n>>2]>>2]|0){case 1:case 7:case 6:case 8:case 5:case 19:case 9:case 2:{t[u>>2]=0;break}case 13:case 12:case 11:{if((f[(t[n>>2]|0)+48>>1]|0)==-20){t[r>>2]=1;l=t[r>>2]|0;s=i;return l|0}f[(t[n>>2]|0)+48>>1]=-20;t[o>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[o>>2]|0))break e;t[u>>2]=Vx(t[o>>2]|0)|0;if((t[u>>2]|0)!=1)break e;t[o>>2]=t[(t[o>>2]|0)+32>>2]}break}case 4:{if((f[(t[n>>2]|0)+50>>1]&128|0)==0?(f[(t[n>>2]|0)+50>>1]&64|0)==0:0){t[a>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[a>>2]|0))break;t[u>>2]=Vx(t[a>>2]|0)|0;if((t[u>>2]|0)!=1)break;t[a>>2]=t[(t[a>>2]|0)+32>>2]}if(!(t[u>>2]|0)){e=(t[n>>2]|0)+50|0;f[e>>1]=f[e>>1]&-65;e=(t[n>>2]|0)+50|0;f[e>>1]=f[e>>1]|128}if((t[u>>2]|0)==1?(e=(t[n>>2]|0)+50|0,b=f[e>>1]&128,f[e>>1]=b,b<<16>>16==0):0){b=(t[n>>2]|0)+50|0;f[b>>1]=f[b>>1]|64}}if((t[(t[n>>2]|0)+40>>2]|0)==0?(t[(t[n>>2]|0)+8>>2]|0)!=0:0)t[u>>2]=1;else t[u>>2]=0;t[r>>2]=t[u>>2];l=t[r>>2]|0;s=i;return l|0}case 10:case 18:case 17:case 16:case 15:case 14:case 20:{t[c>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break e;t[u>>2]=Vx(t[c>>2]|0)|0;if((t[u>>2]|0)!=1)break e;t[c>>2]=t[(t[c>>2]|0)+32>>2]}break}case-1:{t[u>>2]=Vx(t[(t[n>>2]|0)+24>>2]|0)|0;break}case 0:case 3:{t[u>>2]=1;break}default:{}}while(0);if(!(t[u>>2]|0)){c=(t[n>>2]|0)+50|0;f[c>>1]=f[c>>1]|128}if((t[u>>2]|0)==1){c=(t[n>>2]|0)+50|0;f[c>>1]=f[c>>1]|64}t[r>>2]=t[u>>2];l=t[r>>2]|0;s=i;return l|0}function qx(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0;r=s;s=s+80|0;n=r;u=r+64|0;a=r+60|0;o=r+56|0;c=r+52|0;l=r+48|0;b=r+44|0;k=r+40|0;h=r+36|0;w=r+32|0;d=r+28|0;m=r+24|0;_=r+20|0;p=r+16|0;E=r+12|0;S=r+8|0;g=r+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=0;if((t[a>>2]|0)==0|(t[o>>2]|0)==0){t[u>>2]=-1;y=t[u>>2]|0;s=r;return y|0}e:do switch(t[t[o>>2]>>2]|0){case-1:{t[c>>2]=qx(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;break}case 14:{t[m>>2]=t[(t[a>>2]|0)+136>>2];t[l>>2]=t[(t[o>>2]|0)+24>>2];while(1){F=t[a>>2]|0;if(!(t[l>>2]|0))break;qx(F,t[l>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2]}hb(t[F+132>>2]|0,t[m>>2]|0,t[(t[a>>2]|0)+136>>2]|0)|0;break}case 17:{t[E>>2]=0;t[S>>2]=t[(t[a>>2]|0)+136>>2];t[l>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!(t[l>>2]|0))break;t[(t[a>>2]|0)+136>>2]=t[S>>2];t[c>>2]=qx(t[a>>2]|0,t[l>>2]|0)|0;if(t[c>>2]|0)break;i=t[a>>2]|0;if(!(t[E>>2]|0))t[E>>2]=t[i+136>>2];else hb(t[i+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,t[E>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2]}t[(t[a>>2]|0)+136>>2]=t[E>>2];break}case 20:{if((Vx(t[o>>2]|0)|0)==1?(f[(t[o>>2]|0)+48>>1]|0)!=-25:0){t[b>>2]=t[(t[a>>2]|0)+132>>2];t[k>>2]=t[(t[a>>2]|0)+136>>2];f[(t[o>>2]|0)+48>>1]=-25;t[l>>2]=t[(t[o>>2]|0)+24>>2];i=rb()|0;t[(t[a>>2]|0)+132>>2]=i;if(!(t[(t[a>>2]|0)+132>>2]|0)){t[u>>2]=-1;y=t[u>>2]|0;s=r;return y|0}tb(t[(t[a>>2]|0)+132>>2]|0,1);i=ub(t[(t[a>>2]|0)+132>>2]|0)|0;t[(t[a>>2]|0)+136>>2]=i;while(1){O=t[a>>2]|0;if(!(t[l>>2]|0))break;qx(O,t[l>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2]}ab(t[O+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0)|0;if(pb(t[(t[a>>2]|0)+132>>2]|0)|0){i=_b(t[(t[a>>2]|0)+132>>2]|0)|0;t[(t[o>>2]|0)+52>>2]=i}nb(t[(t[a>>2]|0)+132>>2]|0);t[(t[a>>2]|0)+136>>2]=t[k>>2];t[(t[a>>2]|0)+132>>2]=t[b>>2]}break}case 3:{i=hb(t[(t[a>>2]|0)+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,0)|0;t[(t[a>>2]|0)+136>>2]=i;t[g>>2]=t[(t[a>>2]|0)+136>>2];qx(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;ob(t[(t[a>>2]|0)+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,t[(t[a>>2]|0)+136>>2]|0,188096,0)|0;i=hb(t[(t[a>>2]|0)+132>>2]|0,t[g>>2]|0,0)|0;t[(t[a>>2]|0)+136>>2]=i;break}case 10:case 18:case 13:case 12:case 11:{t[l>>2]=t[(t[o>>2]|0)+24>>2];while(1){if(!(t[l>>2]|0))break e;t[c>>2]=qx(t[a>>2]|0,t[l>>2]|0)|0;if(t[c>>2]|0)break e;t[l>>2]=t[(t[l>>2]|0)+32>>2]}break}case 0:{i=hb(t[(t[a>>2]|0)+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,0)|0;t[(t[a>>2]|0)+136>>2]=i;break}case 4:{if((t[(t[a>>2]|0)+132>>2]|0)!=0?(t[(t[o>>2]|0)+8>>2]|0)!=0:0){i=cb(t[(t[a>>2]|0)+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+12>>2]|0,t[o>>2]|0)|0;t[(t[a>>2]|0)+136>>2]=i}if((f[(t[o>>2]|0)+50>>1]&64|0)!=0?(f[(t[o>>2]|0)+48>>1]|0)!=-25:0){t[h>>2]=t[(t[a>>2]|0)+132>>2];t[w>>2]=t[(t[a>>2]|0)+136>>2];f[(t[o>>2]|0)+48>>1]=-25;t[l>>2]=t[(t[o>>2]|0)+24>>2];i=rb()|0;t[(t[a>>2]|0)+132>>2]=i;if(!(t[(t[a>>2]|0)+132>>2]|0)){t[u>>2]=-1;y=t[u>>2]|0;s=r;return y|0}tb(t[(t[a>>2]|0)+132>>2]|0,1);i=ub(t[(t[a>>2]|0)+132>>2]|0)|0;t[(t[a>>2]|0)+136>>2]=i;while(1){A=t[a>>2]|0;if(!(t[l>>2]|0))break;qx(A,t[l>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2]}ab(t[A+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0)|0;i=_b(t[(t[a>>2]|0)+132>>2]|0)|0;t[(t[o>>2]|0)+52>>2]=i;if(!(ib(t[(t[o>>2]|0)+52>>2]|0)|0)){fb(t[(t[o>>2]|0)+52>>2]|0);t[(t[o>>2]|0)+52>>2]=0}nb(t[(t[a>>2]|0)+132>>2]|0);t[(t[a>>2]|0)+136>>2]=t[w>>2];t[(t[a>>2]|0)+132>>2]=t[h>>2];break e}t[d>>2]=t[(t[a>>2]|0)+132>>2];t[c>>2]=vx(t[a>>2]|0,t[o>>2]|0)|0;t[(t[a>>2]|0)+132>>2]=t[d>>2];break}case 7:case 6:case 8:case 5:case 1:case 19:case 9:case 2:{i=t[v>>2]|0;t[n>>2]=mU(t[o>>2]|0)|0;xe(i|0,189768,n|0)|0;break}case 15:{i=hb(t[(t[a>>2]|0)+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,0)|0;t[(t[a>>2]|0)+136>>2]=i;t[_>>2]=t[(t[a>>2]|0)+136>>2];t[l>>2]=t[(t[o>>2]|0)+24>>2];while(1){M=t[a>>2]|0;if(!(t[l>>2]|0))break;qx(M,t[l>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2]}hb(t[M+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,t[_>>2]|0)|0;i=hb(t[(t[a>>2]|0)+132>>2]|0,t[_>>2]|0,0)|0;t[(t[a>>2]|0)+136>>2]=i;break}case 16:{t[l>>2]=t[(t[o>>2]|0)+24>>2];while(1){R=t[a>>2]|0;if(!(t[l>>2]|0))break;qx(R,t[l>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2];
	}t[p>>2]=t[R+136>>2];t[l>>2]=t[(t[o>>2]|0)+24>>2];while(1){N=t[a>>2]|0;if(!(t[l>>2]|0))break;qx(N,t[l>>2]|0)|0;t[l>>2]=t[(t[l>>2]|0)+32>>2]}hb(t[N+132>>2]|0,t[(t[a>>2]|0)+136>>2]|0,t[p>>2]|0)|0;i=hb(t[(t[a>>2]|0)+132>>2]|0,t[p>>2]|0,0)|0;t[(t[a>>2]|0)+136>>2]=i;break}default:{}}while(0);t[u>>2]=t[c>>2];y=t[u>>2]|0;s=r;return y|0}function Yx(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;u=i+8|0;a=i+4|0;o=i;t[r>>2]=e;t[n>>2]=0;t[u>>2]=0;while(1){if((t[n>>2]|0)>=(t[(t[r>>2]|0)+48>>2]|0))break;t[a>>2]=(t[(t[r>>2]|0)+56>>2]|0)+((t[n>>2]|0)*24|0);e:do if((t[u>>2]|0)<5){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[n>>2]|0))break;t[o>>2]=(t[(t[r>>2]|0)+56>>2]|0)+((t[f>>2]|0)*24|0);if((((t[t[a>>2]>>2]|0)==(t[t[o>>2]>>2]|0)?(t[(t[a>>2]|0)+8>>2]|0)==(t[(t[o>>2]|0)+8>>2]|0):0)?(Xl(t[(t[a>>2]|0)+16>>2]|0,t[(t[o>>2]|0)+16>>2]|0)|0)!=0:0)?(Xl(t[(t[a>>2]|0)+20>>2]|0,t[(t[o>>2]|0)+20>>2]|0)|0)!=0:0)break e;t[f>>2]=(t[f>>2]|0)+1}Gx(t[r>>2]|0,t[t[a>>2]>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+12>>2]|0,t[(t[a>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+20>>2]|0);t[u>>2]=(t[u>>2]|0)+1}while(0);if(t[(t[a>>2]|0)+4>>2]&1){if(t[(t[a>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+16>>2]|0);t[(t[a>>2]|0)+16>>2]=0;if(t[(t[a>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+20>>2]|0);t[(t[a>>2]|0)+20>>2]=0;t[(t[a>>2]|0)+4>>2]=0}t[n>>2]=(t[n>>2]|0)+1}t[(t[r>>2]|0)+48>>2]=0;s=i;return}function Gx(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;if(t[(t[o>>2]|0)+28>>2]&8){s=a;return}t[w>>2]=_U(t[c>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;if(!(t[w>>2]|0)){s=a;return}if(!(t[(t[o>>2]|0)+40>>2]|0))t[(t[o>>2]|0)+40>>2]=t[c>>2];pU(t[o>>2]|0,(t[b>>2]|0)==0?t[l>>2]|0:t[b>>2]|0,t[c>>2]|0,t[w>>2]|0,t[k>>2]|0,t[h>>2]|0);pAi[t[135736>>2]&511](t[w>>2]|0);s=a;return}function Wx(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;do if(!(t[(t[o>>2]|0)+56>>2]|0)){t[(t[o>>2]|0)+52>>2]=8;t[(t[o>>2]|0)+48>>2]=0;f=gAi[t[135744>>2]&511]((t[(t[o>>2]|0)+52>>2]|0)*24|0)|0;t[(t[o>>2]|0)+56>>2]=f;f=t[o>>2]|0;if(t[(t[o>>2]|0)+56>>2]|0){t[f+44>>2]=0;break}Fx(f,189752);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}while(0);do if((t[(t[o>>2]|0)+48>>2]|0)>=(t[(t[o>>2]|0)+52>>2]|0)){f=(t[o>>2]|0)+52|0;t[f>>2]=t[f>>2]<<1;f=MAi[t[135760>>2]&511](t[(t[o>>2]|0)+56>>2]|0,(t[(t[o>>2]|0)+52>>2]|0)*24|0)|0;t[(t[o>>2]|0)+56>>2]=f;f=t[o>>2]|0;if(t[(t[o>>2]|0)+56>>2]|0){t[(t[o>>2]|0)+44>>2]=(t[(t[o>>2]|0)+56>>2]|0)+(((t[f+48>>2]|0)-1|0)*24|0);break}Fx(f,189752);t[a>>2]=0;w=t[a>>2]|0;s=u;return w|0}while(0);if((((t[(t[o>>2]|0)+44>>2]|0)!=0?(t[(t[o>>2]|0)+60>>2]|0)!=0:0)?(t[(t[(t[o>>2]|0)+44>>2]|0)+8>>2]|0)==(t[t[(t[o>>2]|0)+60>>2]>>2]|0):0)?(t[t[(t[o>>2]|0)+44>>2]>>2]|0)==(t[c>>2]|0):0){t[a>>2]=t[(t[o>>2]|0)+48>>2];w=t[a>>2]|0;s=u;return w|0}t[h>>2]=(t[(t[o>>2]|0)+56>>2]|0)+((t[(t[o>>2]|0)+48>>2]|0)*24|0);t[t[h>>2]>>2]=t[c>>2];c=t[l>>2]|0;if(t[k>>2]|0){k=Yl(c)|0;t[(t[h>>2]|0)+16>>2]=k;k=Yl(t[b>>2]|0)|0;t[(t[h>>2]|0)+20>>2]=k;t[(t[h>>2]|0)+4>>2]=1}else{t[(t[h>>2]|0)+16>>2]=c;t[(t[h>>2]|0)+20>>2]=t[b>>2];t[(t[h>>2]|0)+4>>2]=0}if(t[(t[o>>2]|0)+60>>2]|0){t[(t[h>>2]|0)+8>>2]=t[t[(t[o>>2]|0)+60>>2]>>2];t[(t[h>>2]|0)+12>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+4>>2]}else{t[(t[h>>2]|0)+8>>2]=0;t[(t[h>>2]|0)+12>>2]=0}t[(t[o>>2]|0)+44>>2]=t[h>>2];h=(t[o>>2]|0)+48|0;o=t[h>>2]|0;t[h>>2]=o+1;t[a>>2]=o;w=t[a>>2]|0;s=u;return w|0}function Kx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[c>>2]=0;t[l>>2]=t[u>>2];while(1){if(!(t[l>>2]|0))break;if((t[t[l>>2]>>2]|0)==9){if(EU(t[f>>2]|0,t[l>>2]|0)|0)t[a>>2]=-1}else t[c>>2]=1;t[l>>2]=t[(t[l>>2]|0)+32>>2]}if(!(t[c>>2]|0)){t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}t[l>>2]=t[u>>2];while(1){if(!(t[l>>2]|0)){k=20;break}if((t[t[l>>2]>>2]|0)!=9){if((t[(t[f>>2]|0)+60>>2]|0)==0?(t[(t[f>>2]|0)+64>>2]|0)==0:0){k=17;break}t[o>>2]=gx(t[f>>2]|0,t[l>>2]|0)|0;if((t[o>>2]|0)<0)t[a>>2]=-1;if((t[o>>2]|0)==-1){k=20;break}}t[l>>2]=t[(t[l>>2]|0)+32>>2]}if((k|0)==17){mx(t[f>>2]|0,6,0,0,0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}else if((k|0)==20){t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}return 0}function Xx(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=t[(t[f>>2]|0)+60>>2];if((t[(t[o>>2]|0)+4>>2]|0)!=0?(i=iU(t[f>>2]|0,t[(t[o>>2]|0)+4>>2]|0)|0,t[(t[o>>2]|0)+4>>2]=i,(t[(t[o>>2]|0)+4>>2]|0)!=0):0){if(t[u>>2]|0)mx(t[f>>2]|0,26,t[(t[t[o>>2]>>2]|0)+8>>2]|0,t[(t[(t[o>>2]|0)+4>>2]|0)+8>>2]|0,0);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[o>>2]|0)+8>>2]|0)){l=13;break}if(t[(t[(t[o>>2]|0)+28>>2]|0)+(t[a>>2]<<2)>>2]|0)break;t[a>>2]=(t[a>>2]|0)+1}if((l|0)==13){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(t[u>>2]|0)mx(t[f>>2]|0,27,t[(t[(t[(t[o>>2]|0)+28>>2]|0)+(t[a>>2]<<2)>>2]|0)+8>>2]|0,t[(t[t[o>>2]>>2]|0)+8>>2]|0,0);t[n>>2]=-1-(t[a>>2]|0);c=t[n>>2]|0;s=r;return c|0}function Zx(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(!(t[(t[r>>2]|0)+64>>2]|0)){s=i;return}if((t[t[(t[r>>2]|0)+64>>2]>>2]|0)<=0){s=i;return}t[n>>2]=SU(t[r>>2]|0)|0;if((t[n>>2]|0)<0){s=i;return}if((t[n>>2]|0)>=(t[t[(t[r>>2]|0)+64>>2]>>2]|0)){s=i;return}t[(t[r>>2]|0)+60>>2]=t[(t[(t[(t[r>>2]|0)+64>>2]|0)+8>>2]|0)+(t[n>>2]<<2)>>2];Xx(t[r>>2]|0,1)|0;s=i;return}function Jx(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0;r=s;s=s+144|0;n=r;u=r+136|0;a=r+132|0;o=r+128|0;c=r+124|0;l=r+120|0;b=r+116|0;k=r+112|0;h=r+108|0;w=r+104|0;d=r+100|0;v=r+96|0;m=r+92|0;_=r+88|0;p=r+84|0;E=r+80|0;S=r+76|0;g=r+72|0;y=r+68|0;F=r+64|0;O=r+60|0;A=r+56|0;M=r+52|0;R=r+48|0;N=r+44|0;T=r+40|0;L=r+36|0;D=r+32|0;C=r+28|0;P=r+24|0;B=r+20|0;I=r+16|0;H=r+12|0;x=r+8|0;t[a>>2]=e;t[o>>2]=i;t[l>>2]=0;t[d>>2]=0;i=t[a>>2]|0;if(!(t[o>>2]|0)){mx(i,7,0,0,0);t[u>>2]=-1;U=t[u>>2]|0;s=r;return U|0}if(t[i+60>>2]|0)t[c>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2];else t[c>>2]=0;i=(t[a>>2]|0)+32|0;t[i>>2]=(t[i>>2]|0)+1;e:do switch(t[t[o>>2]>>2]|0){case 1:{t[l>>2]=-1;break}case 3:{while(1){if(t[c>>2]|0)if(((t[(t[c>>2]|0)+4>>2]|0)!=3?(t[(t[c>>2]|0)+4>>2]|0)!=8:0)?(t[(t[c>>2]|0)+4>>2]|0)!=7:0)z=(t[(t[c>>2]|0)+4>>2]|0)==4;else z=1;else z=0;j=t[c>>2]|0;if(!z)break;t[c>>2]=t[j+24>>2]}t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=j;break}case 0:{t[c>>2]=iU(t[a>>2]|0,t[c>>2]|0)|0;t[l>>2]=0;break}case 16:{t[w>>2]=t[(t[a>>2]|0)+48>>2];t[l>>2]=AU(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;if(!(t[l>>2]|0))if((t[(t[a>>2]|0)+48>>2]|0)>(t[w>>2]|0)){gU(t[a>>2]|0,t[w>>2]|0);V=124}else V=124;break}case 15:{V=124;break}case 14:{t[w>>2]=t[(t[a>>2]|0)+48>>2];t[h>>2]=t[(t[a>>2]|0)+28>>2];i=(t[a>>2]|0)+28|0;t[i>>2]=t[i>>2]|1;t[d>>2]=MU(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;t[l>>2]=AU(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;i=t[a>>2]|0;if(t[l>>2]|0){if(t[i+60>>2]|0)yx(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0);t[(t[a>>2]|0)+60>>2]=t[d>>2];t[(t[a>>2]|0)+28>>2]=t[h>>2];t[l>>2]=0;if((t[(t[a>>2]|0)+48>>2]|0)<=(t[w>>2]|0))break e;gU(t[a>>2]|0,t[w>>2]|0);break e}e=t[a>>2]|0;do if(t[i+64>>2]|0)Qx(e,t[(t[a>>2]|0)+64>>2]|0,t[d>>2]|0)|0;else{q=$x(e,1)|0;t[(t[a>>2]|0)+64>>2]=q;q=t[a>>2]|0;if(t[(t[a>>2]|0)+64>>2]|0){Qx(q,t[(t[a>>2]|0)+64>>2]|0,t[d>>2]|0)|0;Qx(t[a>>2]|0,t[(t[a>>2]|0)+64>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=0;break}yx(q,t[d>>2]|0);t[(t[a>>2]|0)+28>>2]=t[h>>2];t[l>>2]=-1;if((t[(t[a>>2]|0)+48>>2]|0)<=(t[w>>2]|0))break e;gU(t[a>>2]|0,t[w>>2]|0);break e}while(0);t[(t[a>>2]|0)+28>>2]=t[h>>2];t[l>>2]=0;if((t[(t[a>>2]|0)+48>>2]|0)>(t[w>>2]|0))gU(t[a>>2]|0,t[w>>2]|0);break}case 4:{t[w>>2]=t[(t[a>>2]|0)+48>>2];t[c>>2]=iU(t[a>>2]|0,t[c>>2]|0)|0;if(!(t[c>>2]|0)){mx(t[a>>2]|0,22,t[(t[o>>2]|0)+8>>2]|0,0,0);t[l>>2]=-1;if(t[(t[a>>2]|0)+28>>2]&1)break e;Yx(t[a>>2]|0);break e}if((t[(t[c>>2]|0)+4>>2]|0)!=1){mx(t[a>>2]|0,23,0,0,0);t[l>>2]=-1;if(t[(t[a>>2]|0)+28>>2]&1)break e;Yx(t[a>>2]|0);break e}e=t[a>>2]|0;if((t[(t[c>>2]|0)+52>>2]|0)==(t[o>>2]|0)){i=iU(e,t[(t[c>>2]|0)+24>>2]|0)|0;t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=i;if((t[(t[a>>2]|0)+48>>2]|0)>(t[w>>2]|0))gU(t[a>>2]|0,t[w>>2]|0);if(!(t[(t[a>>2]|0)+48>>2]|0))break e;while(1){if(!(t[(t[a>>2]|0)+44>>2]|0))break e;if(!((t[t[(t[a>>2]|0)+44>>2]>>2]|0)==13?(Xl(t[(t[(t[a>>2]|0)+44>>2]|0)+20>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)!=0:0))V=30;do if((V|0)==30){V=0;if((t[t[(t[a>>2]|0)+44>>2]>>2]|0)==19?(Xl(t[(t[(t[a>>2]|0)+44>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)!=0:0)break;if((t[t[(t[a>>2]|0)+44>>2]>>2]|0)!=22?(t[t[(t[a>>2]|0)+44>>2]>>2]|0)!=23:0)break e}while(0);yU(t[a>>2]|0)}}t[l>>2]=FU(e,t[o>>2]|0,t[c>>2]|0)|0;if((t[l>>2]|0)<=0){t[l>>2]=-1;if(t[(t[a>>2]|0)+28>>2]&1)break e;Yx(t[a>>2]|0);break e}t[l>>2]=0;i:do if(t[(t[a>>2]|0)+48>>2]|0){if((t[(t[a>>2]|0)+48>>2]|0)>(t[w>>2]|0))gU(t[a>>2]|0,t[w>>2]|0);while(1){if(!(t[(t[a>>2]|0)+44>>2]|0))break i;if(!((t[t[(t[a>>2]|0)+44>>2]>>2]|0)==13?(Xl(t[(t[(t[a>>2]|0)+44>>2]|0)+20>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)!=0:0))V=44;do if((V|0)==44){V=0;if((t[t[(t[a>>2]|0)+44>>2]>>2]|0)==19?(Xl(t[(t[(t[a>>2]|0)+44>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)!=0:0)break;if((t[t[(t[a>>2]|0)+44>>2]>>2]|0)!=22?(t[t[(t[a>>2]|0)+44>>2]>>2]|0)!=23:0)break i}while(0);yU(t[a>>2]|0)}}while(0);t[w>>2]=t[(t[a>>2]|0)+48>>2];t[h>>2]=t[(t[a>>2]|0)+28>>2];if(t[(t[a>>2]|0)+28>>2]&4){e=(t[a>>2]|0)+28|0;t[e>>2]=(t[e>>2]|0)-4}t[v>>2]=Sx(t[a>>2]|0,t[c>>2]|0)|0;if(!(t[v>>2]|0)){t[l>>2]=-1;if(t[(t[a>>2]|0)+28>>2]&1)break e;Yx(t[a>>2]|0);break e}t[d>>2]=t[(t[a>>2]|0)+60>>2];t[(t[a>>2]|0)+60>>2]=t[v>>2];if((t[(t[o>>2]|0)+36>>2]|0)!=0?(t[k>>2]=Kx(t[a>>2]|0,t[(t[o>>2]|0)+36>>2]|0)|0,(t[k>>2]|0)!=0):0){t[l>>2]=-1;mx(t[a>>2]|0,24,t[(t[c>>2]|0)+8>>2]|0,0,0)}do if(t[(t[o>>2]|0)+52>>2]|0){t[_>>2]=t[(t[a>>2]|0)+60>>2];t[p>>2]=t[(t[a>>2]|0)+64>>2];t[m>>2]=Sx(t[a>>2]|0,t[c>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=t[m>>2];t[(t[a>>2]|0)+64>>2]=0;t[k>>2]=OU(t[a>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]|0)|0;t[E>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2];t[(t[a>>2]|0)+60>>2]=t[_>>2];t[(t[a>>2]|0)+64>>2]=t[p>>2];yx(t[a>>2]|0,t[m>>2]|0);if(t[k>>2]|0)t[l>>2]=-1;if(!(t[(t[a>>2]|0)+64>>2]|0)){t[v>>2]=t[(t[a>>2]|0)+60>>2];if(t[(t[a>>2]|0)+60>>2]|0)t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=t[E>>2];if(!(t[l>>2]|0))t[l>>2]=Xx(t[a>>2]|0,1)|0;yx(t[a>>2]|0,t[v>>2]|0);break}t[k>>2]=-1;t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;t[v>>2]=t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2];t[(t[a>>2]|0)+60>>2]=t[v>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=t[E>>2];if(!(Xx(t[a>>2]|0,0)|0)){V=64;break}t[b>>2]=(t[b>>2]|0)+1}if((V|0)==64)t[k>>2]=0;if(t[k>>2]|0){e=(t[a>>2]|0)+28|0;t[e>>2]=t[e>>2]|1;Zx(t[a>>2]|0)}t[b>>2]=0;while(1){Y=t[a>>2]|0;if((t[b>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;yx(Y,t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2]|0);t[b>>2]=(t[b>>2]|0)+1}Ox(Y,t[(t[a>>2]|0)+64>>2]|0);t[(t[a>>2]|0)+28>>2]=t[h>>2];t[(t[a>>2]|0)+64>>2]=0;if((t[l>>2]|0)==0&(t[k>>2]|0)==-1)t[l>>2]=-1}else{do if((t[(t[o>>2]|0)+24>>2]|0)!=0?(t[k>>2]=AU(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0,(t[k>>2]|0)!=0):0){t[l>>2]=-1;if(!(t[(t[a>>2]|0)+60>>2]|0)){t[(t[a>>2]|0)+60>>2]=t[d>>2];mx(t[a>>2]|0,25,t[(t[c>>2]|0)+8>>2]|0,0,0);t[(t[a>>2]|0)+60>>2]=0;break}else{mx(t[a>>2]|0,25,t[(t[c>>2]|0)+8>>2]|0,0,0);break}}while(0);if(!(t[(t[a>>2]|0)+64>>2]|0)){t[v>>2]=t[(t[a>>2]|0)+60>>2];if(!(t[l>>2]|0))t[l>>2]=Xx(t[a>>2]|0,1)|0;yx(t[a>>2]|0,t[v>>2]|0);break}t[k>>2]=-1;t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;t[v>>2]=t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2];t[(t[a>>2]|0)+60>>2]=t[v>>2];if(!(Xx(t[a>>2]|0,0)|0)){V=87;break}t[b>>2]=(t[b>>2]|0)+1}if((V|0)==87)t[k>>2]=0;if(t[k>>2]|0){e=(t[a>>2]|0)+28|0;t[e>>2]=t[e>>2]|1;Zx(t[a>>2]|0)}t[b>>2]=0;while(1){G=t[a>>2]|0;if((t[b>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;yx(G,t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2]|0);t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2]=0;t[b>>2]=(t[b>>2]|0)+1}Ox(G,t[(t[a>>2]|0)+64>>2]|0);t[(t[a>>2]|0)+28>>2]=t[h>>2];t[(t[a>>2]|0)+64>>2]=0;if((t[l>>2]|0)==0&(t[k>>2]|0)==-1)t[l>>2]=-1}while(0);if(!(t[l>>2]|0))t[(t[c>>2]|0)+52>>2]=t[o>>2];t[(t[a>>2]|0)+28>>2]=t[h>>2];t[(t[a>>2]|0)+60>>2]=t[d>>2];if(t[d>>2]|0){e=iU(t[a>>2]|0,t[(t[c>>2]|0)+24>>2]|0)|0;t[(t[d>>2]|0)+4>>2]=e}e=t[a>>2]|0;if(t[l>>2]|0){if(t[e+28>>2]&1)break e;Yx(t[a>>2]|0);t[l>>2]=0;break e}else{if((t[e+48>>2]|0)<=(t[w>>2]|0))break e;gU(t[a>>2]|0,t[w>>2]|0);break e}break}case 18:case 10:{t[l>>2]=AU(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;break}case 19:{t[l>>2]=RU(t[a>>2]|0,t[o>>2]|0)|0;break}case 9:{t[l>>2]=EU(t[a>>2]|0,t[o>>2]|0)|0;break}case 13:case 12:case 11:case-1:case 20:{t[l>>2]=gx(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;break}case 5:{t[T>>2]=0;t[N>>2]=t[c>>2];while(1){if(!(t[N>>2]|0))break;if((t[(t[N>>2]|0)+4>>2]|0)==1){V=222;break}if(!((t[(t[N>>2]|0)+4>>2]|0)!=3?(t[(t[N>>2]|0)+4>>2]|0)!=4:0))t[T>>2]=us(t[T>>2]|0,t[(t[N>>2]|0)+40>>2]|0)|0;t[N>>2]=t[(t[N>>2]|0)+24>>2]}if((V|0)==222){mx(t[a>>2]|0,28,t[(t[(t[c>>2]|0)+20>>2]|0)+8>>2]|0,0,0);t[l>>2]=-1}e=t[T>>2]|0;if((t[l>>2]|0)==-1){if(!e)break e;pAi[t[135736>>2]&511](t[T>>2]|0);break e}if((e|0)==0?(t[T>>2]=Yl(188112)|0,(t[T>>2]|0)==0):0){Fx(t[a>>2]|0,189544);t[l>>2]=-1;break e}t[l>>2]=NU(t[a>>2]|0,t[T>>2]|0,t[o>>2]|0,t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]|0)|0;if((t[l>>2]|0)!=-1){if(!(t[l>>2]|0))t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=0}else mx(t[a>>2]|0,31,t[(t[o>>2]|0)+8>>2]|0,0,0);if(t[T>>2]|0)pAi[t[135736>>2]&511](t[T>>2]|0);break}case 7:{t[L>>2]=0;t[C>>2]=t[c>>2];while(1){if(!(t[C>>2]|0))break;if((t[(t[C>>2]|0)+4>>2]|0)==1){V=242;break}if(!((t[(t[C>>2]|0)+4>>2]|0)!=3?(t[(t[C>>2]|0)+4>>2]|0)!=4:0))t[L>>2]=us(t[L>>2]|0,t[(t[C>>2]|0)+40>>2]|0)|0;t[C>>2]=t[(t[C>>2]|0)+24>>2]}if((V|0)==242){mx(t[a>>2]|0,29,t[(t[(t[c>>2]|0)+20>>2]|0)+8>>2]|0,0,0);t[l>>2]=-1}e=t[L>>2]|0;if((t[l>>2]|0)==-1){if(!e)break e;pAi[t[135736>>2]&511](t[L>>2]|0);break e}if((e|0)==0?(t[L>>2]=Yl(188112)|0,(t[L>>2]|0)==0):0){Fx(t[a>>2]|0,189544);t[l>>2]=-1;break e}t[D>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2]=t[L>>2];t[l>>2]=TU(t[a>>2]|0,t[o>>2]|0)|0;t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2]=t[D>>2];if((t[l>>2]|0)!=-1){if(!(t[l>>2]|0))t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=0}else mx(t[a>>2]|0,32,t[(t[o>>2]|0)+8>>2]|0,0,0);if(t[L>>2]|0)pAi[t[135736>>2]&511](t[L>>2]|0);break}case 8:{t[P>>2]=0;t[B>>2]=t[c>>2];while(1){if(!(t[B>>2]|0))break;if((t[(t[B>>2]|0)+4>>2]|0)==1){V=262;break}if(!((t[(t[B>>2]|0)+4>>2]|0)!=3?(t[(t[B>>2]|0)+4>>2]|0)!=4:0))t[P>>2]=us(t[P>>2]|0,t[(t[B>>2]|0)+40>>2]|0)|0;t[B>>2]=t[(t[B>>2]|0)+24>>2]}if((V|0)==262){mx(t[a>>2]|0,30,t[(t[(t[c>>2]|0)+20>>2]|0)+8>>2]|0,0,0);t[l>>2]=-1}e=t[P>>2]|0;if((t[l>>2]|0)==-1){if(!e)break e;pAi[t[135736>>2]&511](t[P>>2]|0);break e}if((e|0)==0?(t[P>>2]=Yl(188112)|0,(t[P>>2]|0)==0):0){Fx(t[a>>2]|0,189544);t[l>>2]=-1;break e}t[x>>2]=rs(t[P>>2]|0)|0;t[I>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2];t[H>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+24>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2]=t[P>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+24>>2]=(t[P>>2]|0)+(t[x>>2]|0);t[l>>2]=TU(t[a>>2]|0,t[o>>2]|0)|0;t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2]=t[I>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+24>>2]=t[H>>2];if((t[l>>2]|0)!=-1){if((t[l>>2]|0)==0&(t[c>>2]|0)!=0)t[(t[(t[a>>2]|0)+60>>2]|0)+4>>2]=t[(t[c>>2]|0)+24>>2]}else mx(t[a>>2]|0,33,0,0,0);if(t[P>>2]|0)pAi[t[135736>>2]&511](t[P>>2]|0);break}case 6:case 2:{e=t[33976]|0;i=t[33980]|0;t[n>>2]=189496;t[n+4>>2]=10569;yAi[e&511](i,189464,n);t[l>>2]=-1;break}case 17:{t[A>>2]=0;t[M>>2]=0;t[c>>2]=iU(t[a>>2]|0,t[c>>2]|0)|0;t[w>>2]=t[(t[a>>2]|0)+48>>2];if((f[(t[o>>2]|0)+50>>1]&16|0)!=0?(t[c>>2]|0)!=0?(t[(t[o>>2]|0)+20>>2]|0)!=0:0:0){t[R>>2]=t[(t[o>>2]|0)+20>>2];if((t[(t[c>>2]|0)+4>>2]|0)!=3?(t[(t[c>>2]|0)+4>>2]|0)!=4:0){if((t[(t[c>>2]|0)+4>>2]|0)==1){i=t[R>>2]|0;e=t[(t[c>>2]|0)+8>>2]|0;if(t[(t[c>>2]|0)+36>>2]|0){t[A>>2]=fO(i,e,t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0)|0;if(!(t[A>>2]|0))t[A>>2]=fO(t[R>>2]|0,189536,t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0)|0}else t[A>>2]=fO(i,e,0)|0;if(!(t[A>>2]|0))t[A>>2]=fO(t[R>>2]|0,189536,0)|0}}else t[A>>2]=fO(t[R>>2]|0,188096,0)|0;if(!(t[A>>2]|0)){t[l>>2]=-1;mx(t[a>>2]|0,38,t[(t[c>>2]|0)+8>>2]|0,0,0);break e}else{t[l>>2]=gx(t[a>>2]|0,t[A>>2]|0)|0;break e}}t[A>>2]=t[(t[o>>2]|0)+24>>2];t[h>>2]=t[(t[a>>2]|0)+28>>2];e=(t[a>>2]|0)+28|0;t[e>>2]=t[e>>2]|1;while(1){if(!(t[A>>2]|0))break;t[d>>2]=MU(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;t[l>>2]=gx(t[a>>2]|0,t[A>>2]|0)|0;do if(!(t[l>>2]|0)){if(!(t[M>>2]|0))t[M>>2]=$x(t[a>>2]|0,1)|0;e=t[a>>2]|0;if(t[(t[a>>2]|0)+60>>2]|0){Qx(e,t[M>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;break}if(t[e+64>>2]|0){t[b>>2]=0;while(1){W=t[a>>2]|0;if((t[b>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;Qx(W,t[M>>2]|0,t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2]|0)|0;t[b>>2]=(t[b>>2]|0)+1}Ox(W,t[(t[a>>2]|0)+64>>2]|0);t[(t[a>>2]|0)+64>>2]=0}}else yx(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0);while(0);t[(t[a>>2]|0)+60>>2]=t[d>>2];t[A>>2]=t[(t[A>>2]|0)+32>>2]}e=t[a>>2]|0;if(t[M>>2]|0){yx(e,t[d>>2]|0);t[(t[a>>2]|0)+64>>2]=t[M>>2];t[(t[a>>2]|0)+60>>2]=0;t[l>>2]=0}else t[e+64>>2]=0;t[(t[a>>2]|0)+28>>2]=t[h>>2];e=t[a>>2]|0;if(t[l>>2]|0){if(t[e+28>>2]&1)break e;Yx(t[a>>2]|0);break e}else{if((t[e+48>>2]|0)<=(t[w>>2]|0))break e;gU(t[a>>2]|0,t[w>>2]|0);break e}break}default:{}}while(0);do if((V|0)==124){t[g>>2]=0;t[y>>2]=0;t[w>>2]=t[(t[a>>2]|0)+48>>2];t[y>>2]=$x(t[a>>2]|0,1)|0;if(!(t[y>>2]|0)){t[l>>2]=-1;break}e:do if(t[(t[a>>2]|0)+60>>2]|0){M=t[a>>2]|0;d=t[y>>2]|0;Qx(M,d,MU(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0)|0}else{t[O>>2]=0;while(1){if((t[O>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break e;d=t[a>>2]|0;M=t[y>>2]|0;Qx(d,M,MU(t[a>>2]|0,t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[O>>2]<<2)>>2]|0)|0)|0;t[O>>2]=(t[O>>2]|0)+1}}while(0);t[h>>2]=t[(t[a>>2]|0)+28>>2];M=(t[a>>2]|0)+28|0;t[M>>2]=t[M>>2]|1;e:do{t[S>>2]=0;t[F>>2]=t[t[y>>2]>>2];M=t[a>>2]|0;i:do if(!(t[(t[a>>2]|0)+64>>2]|0)){t[l>>2]=AU(M,t[(t[o>>2]|0)+24>>2]|0)|0;if(t[l>>2]|0){yx(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0);t[(t[a>>2]|0)+60>>2]=0;break}t[F>>2]=t[t[y>>2]>>2];d=t[a>>2]|0;if(t[(t[a>>2]|0)+60>>2]|0){t[k>>2]=Qx(d,t[y>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=0;if((t[k>>2]|0)!=1)break;t[S>>2]=1;break}if(t[d+64>>2]|0){t[O>>2]=0;while(1){if((t[O>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;t[k>>2]=Qx(t[a>>2]|0,t[y>>2]|0,t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[O>>2]<<2)>>2]|0)|0;if((t[k>>2]|0)==1)t[S>>2]=1;t[O>>2]=(t[O>>2]|0)+1}d=t[a>>2]|0;if(!(t[g>>2]|0))t[g>>2]=t[d+64>>2];else Ox(d,t[(t[a>>2]|0)+64>>2]|0);t[(t[a>>2]|0)+64>>2]=0}}else{t[g>>2]=t[M+64>>2];t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[t[g>>2]>>2]|0))break i;t[(t[a>>2]|0)+60>>2]=t[(t[(t[g>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2];t[(t[a>>2]|0)+64>>2]=0;t[l>>2]=AU(t[a>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;d=(t[(t[a>>2]|0)+60>>2]|0)!=0;do if(!(t[l>>2]|0)){A=t[a>>2]|0;if(d){t[k>>2]=Qx(A,t[y>>2]|0,t[(t[a>>2]|0)+60>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=0;if((t[k>>2]|0)!=1)break;t[S>>2]=1;break}if(t[A+64>>2]|0){t[O>>2]=0;while(1){K=t[a>>2]|0;if((t[O>>2]|0)>=(t[t[(t[a>>2]|0)+64>>2]>>2]|0))break;t[k>>2]=Qx(K,t[y>>2]|0,t[(t[(t[(t[a>>2]|0)+64>>2]|0)+8>>2]|0)+(t[O>>2]<<2)>>2]|0)|0;if((t[k>>2]|0)==1)t[S>>2]=1;t[O>>2]=(t[O>>2]|0)+1}Ox(K,t[(t[a>>2]|0)+64>>2]|0);t[(t[a>>2]|0)+64>>2]=0}}else if(d){yx(t[a>>2]|0,t[(t[a>>2]|0)+60>>2]|0);t[(t[a>>2]|0)+60>>2]=0}while(0);t[b>>2]=(t[b>>2]|0)+1}}while(0);do if(t[S>>2]|0){if(((t[t[y>>2]>>2]|0)-(t[F>>2]|0)|0)==1){M=MU(t[a>>2]|0,t[(t[(t[y>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)|0;t[(t[a>>2]|0)+60>>2]=M;break}if((t[g>>2]|0)==0?($x(t[a>>2]|0,(t[t[y>>2]>>2]|0)-(t[F>>2]|0)|0)|0,t[g>>2]=t[(t[a>>2]|0)+64>>2],(t[g>>2]|0)==0):0){V=169;break e}t[t[g>>2]>>2]=0;t[b>>2]=t[F>>2];while(1){if((t[b>>2]|0)>=(t[t[y>>2]>>2]|0))break;M=t[a>>2]|0;d=t[g>>2]|0;Qx(M,d,MU(t[a>>2]|0,t[(t[(t[y>>2]|0)+8>>2]|0)+(t[b>>2]<<2)>>2]|0)|0)|0;t[b>>2]=(t[b>>2]|0)+1}t[(t[a>>2]|0)+64>>2]=t[g>>2]}while(0)}while((t[S>>2]|0)==1);if((V|0)==169)t[S>>2]=0;if(t[g>>2]|0)Ox(t[a>>2]|0,t[g>>2]|0);t[(t[a>>2]|0)+64>>2]=t[y>>2];t[(t[a>>2]|0)+28>>2]=t[h>>2];t[l>>2]=0}while(0);h=(t[a>>2]|0)+32|0;t[h>>2]=(t[h>>2]|0)+-1;t[u>>2]=t[l>>2];U=t[u>>2]|0;s=r;return U|0}function Qx(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if((t[o>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}do if((t[t[a>>2]>>2]|0)>=(t[(t[a>>2]|0)+4>>2]|0)){t[b>>2]=t[(t[a>>2]|0)+4>>2]<<1;t[l>>2]=MAi[t[135760>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[b>>2]<<2)|0;if(t[l>>2]|0){t[(t[a>>2]|0)+8>>2]=t[l>>2];t[(t[a>>2]|0)+4>>2]=t[b>>2];break}Fx(t[u>>2]|0,189520);t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}while(0);t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[t[a>>2]>>2]|0)){h=12;break}if(LU(t[u>>2]|0,t[o>>2]|0,t[(t[(t[a>>2]|0)+8>>2]|0)+(t[c>>2]<<2)>>2]|0)|0){h=10;break}t[c>>2]=(t[c>>2]|0)+1}if((h|0)==10){yx(t[u>>2]|0,t[o>>2]|0);t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}else if((h|0)==12){h=t[o>>2]|0;o=t[a>>2]|0;u=t[o>>2]|0;t[o>>2]=u+1;t[(t[(t[a>>2]|0)+8>>2]|0)+(u<<2)>>2]=h;t[f>>2]=1;k=t[f>>2]|0;s=n;return k|0}return 0}function $x(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+80>>2]|0)!=0:0)?(t[(t[f>>2]|0)+72>>2]|0)>0:0){i=(t[f>>2]|0)+72|0;t[i>>2]=(t[i>>2]|0)+-1;t[a>>2]=t[(t[(t[f>>2]|0)+80>>2]|0)+(t[(t[f>>2]|0)+72>>2]<<2)>>2];t[t[a>>2]>>2]=0;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}if((t[u>>2]|0)<16)t[u>>2]=16;t[a>>2]=gAi[t[135744>>2]&511](12+((t[u>>2]|0)-1<<2)|0)|0;if(!(t[a>>2]|0)){Fx(t[f>>2]|0,189568);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[t[a>>2]>>2]=0;t[(t[a>>2]|0)+4>>2]=t[u>>2];i=gAi[t[135744>>2]&511](t[u>>2]<<2)|0;t[(t[a>>2]|0)+8>>2]=i;if(!(t[(t[a>>2]|0)+8>>2]|0)){Fx(t[f>>2]|0,189568);pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function eU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[o>>2]|0)){t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}do if((t[t[a>>2]>>2]|0)>=(t[(t[a>>2]|0)+4>>2]|0)){t[l>>2]=t[(t[a>>2]|0)+4>>2]<<1;t[c>>2]=MAi[t[135760>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[l>>2]<<2)|0;if(t[c>>2]|0){t[(t[a>>2]|0)+8>>2]=t[c>>2];t[(t[a>>2]|0)+4>>2]=t[l>>2];break}Fx(t[u>>2]|0,189520);t[f>>2]=-1;b=t[f>>2]|0;s=n;return b|0}while(0);u=t[o>>2]|0;o=t[a>>2]|0;l=t[o>>2]|0;t[o>>2]=l+1;t[(t[(t[a>>2]|0)+8>>2]|0)+(l<<2)>>2]=u;t[f>>2]=1;b=t[f>>2]|0;s=n;return b|0}function iU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){do if(t[f>>2]|0)if((((t[(t[f>>2]|0)+4>>2]|0)!=8?(t[(t[f>>2]|0)+4>>2]|0)!=7:0)?(t[(t[f>>2]|0)+4>>2]|0)!=19:0)?(t[(t[f>>2]|0)+4>>2]|0)!=20:0){if((t[(t[f>>2]|0)+4>>2]|0)!=3?(t[(t[f>>2]|0)+4>>2]|0)!=4:0){u=0;break}if(!(t[(t[n>>2]|0)+28>>2]&4))u=(tU(t[(t[f>>2]|0)+40>>2]|0)|0)!=0;else u=1}else u=1;else u=0;while(0);a=t[f>>2]|0;if(!u)break;t[f>>2]=t[a+24>>2]}s=r;return a|0}function rU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=t[(t[f>>2]|0)+44>>2];while(1){if(!(t[a>>2]|0))break;t[o>>2]=t[(t[a>>2]|0)+24>>2];if(!((t[(t[a>>2]|0)+36>>2]|0)!=0?(Xl(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)==0:0))b=5;do if((b|0)==5){b=0;if(Xl(t[(t[a>>2]|0)+8>>2]|0,192176)|0){if(Xl(t[(t[f>>2]|0)+8>>2]|0,189864)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,189904)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,189928)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,189952)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,190064)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,195016)|0)break;bx(t[n>>2]|0,t[f>>2]|0,1034,196520,t[(t[a>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+8>>2]|0);break}if(Xl(t[(t[a>>2]|0)+8>>2]|0,192784)|0){if(Xl(t[(t[f>>2]|0)+8>>2]|0,189888)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,192360)|0)break;bx(t[n>>2]|0,t[f>>2]|0,1034,196520,t[(t[a>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+8>>2]|0);break}if(Xl(t[(t[a>>2]|0)+8>>2]|0,195400)|0){if(Xl(t[(t[f>>2]|0)+8>>2]|0,189936)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,195024)|0)break;bx(t[n>>2]|0,t[f>>2]|0,1034,196520,t[(t[a>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+8>>2]|0);break}if(Xl(t[(t[a>>2]|0)+8>>2]|0,194568)|0){if(Xl(t[(t[f>>2]|0)+8>>2]|0,190048)|0)break;if(Xl(t[(t[f>>2]|0)+8>>2]|0,195016)|0)break;bx(t[n>>2]|0,t[f>>2]|0,1034,196520,t[(t[a>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+8>>2]|0);break}if(!(Xl(t[(t[a>>2]|0)+8>>2]|0,193160)|0)){if(Xl(t[(t[a>>2]|0)+8>>2]|0,192672)|0)break;bx(t[n>>2]|0,t[f>>2]|0,1113,196680,t[(t[a>>2]|0)+8>>2]|0,t[(t[f>>2]|0)+8>>2]|0);break}t[c>>2]=sy(t[(t[f>>2]|0)+32>>2]|0,t[(t[a>>2]|0)+12>>2]|0,1)|0;if(t[c>>2]|0){do if(u[t[c>>2]>>0]|0){t[l>>2]=IA(t[c>>2]|0)|0;if(!(t[l>>2]|0)){bx(t[n>>2]|0,t[f>>2]|0,1050,196560,t[(t[a>>2]|0)+8>>2]|0,t[c>>2]|0);break}if(!(t[t[l>>2]>>2]|0))bx(t[n>>2]|0,t[f>>2]|0,1118,196600,t[(t[a>>2]|0)+8>>2]|0,t[c>>2]|0);if(t[(t[l>>2]|0)+32>>2]|0)bx(t[n>>2]|0,t[f>>2]|0,1117,196640,t[(t[a>>2]|0)+8>>2]|0,t[c>>2]|0);xA(t[l>>2]|0)}while(0);pAi[t[135736>>2]&511](t[c>>2]|0)}}while(0);t[a>>2]=t[o>>2]}s=r;return}function nU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[(t[u>>2]|0)+100>>2]|0))break;if(Xl(t[(t[(t[(t[u>>2]|0)+108>>2]|0)+(t[k>>2]<<2)>>2]|0)+4>>2]|0,t[a>>2]|0)|0){h=4;break}t[k>>2]=(t[k>>2]|0)+1}if((h|0)==4){bx(t[u>>2]|0,0,1033,196408,t[a>>2]|0,0);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[l>>2]=_S(t[a>>2]|0,0,0)|0;if(!(t[l>>2]|0)){bx(t[u>>2]|0,0,1065,196056,t[a>>2]|0,0);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}t[c>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[c>>2]|0)){bx(t[u>>2]|0,t[l>>2]|0,2,196456,t[a>>2]|0,0);fy(t[l>>2]|0);t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}h=t[c>>2]|0;t[h+0>>2]=0;t[h+4>>2]=0;t[h+8>>2]=0;t[h+12>>2]=0;t[h+16>>2]=0;t[h+20>>2]=0;t[(t[c>>2]|0)+8>>2]=t[l>>2];h=Yl(t[a>>2]|0)|0;t[(t[c>>2]|0)+4>>2]=h;t[t[c>>2]>>2]=t[(t[u>>2]|0)+60>>2];t[(t[c>>2]|0)+20>>2]=1;t[(t[u>>2]|0)+60>>2]=t[c>>2];if(((t[o>>2]|0)!=0?(t[b>>2]=eF(t[l>>2]|0)|0,(t[b>>2]|0)!=0):0)?(dF(t[b>>2]|0,192672)|0)==0:0)_F(t[b>>2]|0,192672,t[o>>2]|0)|0;DU(t[u>>2]|0,t[c>>2]|0)|0;t[l>>2]=kx(t[u>>2]|0,t[l>>2]|0)|0;o=t[u>>2]|0;if(!(t[l>>2]|0)){t[o+96>>2]=0;t[f>>2]=0;w=t[f>>2]|0;s=n;return w|0}else{CU(o)|0;t[f>>2]=t[c>>2];w=t[f>>2]|0;s=n;return w|0}return 0}function fU(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;f=s;s=s+64|0;u=f+48|0;a=f+44|0;o=f+40|0;c=f+36|0;l=f+32|0;b=f+28|0;k=f+24|0;h=f+20|0;w=f+16|0;d=f+12|0;v=f+8|0;m=f+4|0;_=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=0;t[h>>2]=0;while(1){if((t[h>>2]|0)>=(t[(t[a>>2]|0)+116>>2]|0))break;if(Xl(t[(t[(t[(t[a>>2]|0)+124>>2]|0)+(t[h>>2]<<2)>>2]|0)+4>>2]|0,t[o>>2]|0)|0){p=4;break}t[h>>2]=(t[h>>2]|0)+1}if((p|0)==4){bx(t[a>>2]|0,0,1044,196016,t[o>>2]|0,0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}t[k>>2]=_S(t[o>>2]|0,0,0)|0;if(!(t[k>>2]|0)){bx(t[a>>2]|0,t[c>>2]|0,1065,196056,t[o>>2]|0,0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}t[b>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[b>>2]|0)){lx(t[a>>2]|0,196088);fy(t[k>>2]|0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}h=t[b>>2]|0;t[h+0>>2]=0;t[h+4>>2]=0;t[h+8>>2]=0;t[h+12>>2]=0;t[h+16>>2]=0;t[(t[b>>2]|0)+8>>2]=t[k>>2];h=Yl(t[o>>2]|0)|0;t[(t[b>>2]|0)+4>>2]=h;t[t[b>>2]>>2]=t[(t[a>>2]|0)+64>>2];t[(t[a>>2]|0)+64>>2]=t[b>>2];if(((t[l>>2]|0)!=0?(t[w>>2]=eF(t[k>>2]|0)|0,(t[w>>2]|0)!=0):0)?(dF(t[w>>2]|0,192672)|0)==0:0)_F(t[w>>2]|0,192672,t[l>>2]|0)|0;PU(t[a>>2]|0,t[b>>2]|0)|0;t[k>>2]=kx(t[a>>2]|0,t[k>>2]|0)|0;l=t[a>>2]|0;if(!(t[k>>2]|0)){t[l+112>>2]=0;t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}BU(l)|0;t[w>>2]=eF(t[k>>2]|0)|0;if(!(t[w>>2]|0)){bx(t[a>>2]|0,t[c>>2]|0,1022,196112,t[o>>2]|0,0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}if(((((t[w>>2]|0)!=0?(t[(t[w>>2]|0)+36>>2]|0)!=0:0)?(t[(t[w>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[w>>2]|0)+8>>2]|0,190264)|0)!=0:0)?(Xl(t[(t[(t[w>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[d>>2]=t[(t[c>>2]|0)+12>>2];while(1){if(!(t[d>>2]|0))break;if(((((t[d>>2]|0)!=0?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(t[(t[d>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,190048)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[v>>2]=0;t[v>>2]=IU(t[a>>2]|0,t[o>>2]|0,t[(t[w>>2]|0)+12>>2]|0,0)|0;if(!(t[v>>2]|0))bx(t[a>>2]|0,t[c>>2]|0,1107,196216,t[o>>2]|0,0)}else p=33;do if((((((p|0)==33?(p=0,(t[d>>2]|0)!=0):0)?(t[(t[d>>2]|0)+36>>2]|0)!=0:0)?(t[(t[d>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[d>>2]|0)+8>>2]|0,195016)|0)!=0:0)?(Xl(t[(t[(t[d>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[m>>2]=cF(t[d>>2]|0,192176)|0;if(!(t[m>>2]|0)){bx(t[a>>2]|0,t[c>>2]|0,1053,196288,t[o>>2]|0,0);break}HU(t[m>>2]|0);t[_>>2]=IU(t[a>>2]|0,t[o>>2]|0,t[(t[w>>2]|0)+12>>2]|0,t[m>>2]|0)|0;if(!(t[_>>2]|0))bx(t[a>>2]|0,t[c>>2]|0,1013,196336,t[o>>2]|0,t[m>>2]|0);pAi[t[135736>>2]&511](t[m>>2]|0)}while(0);t[d>>2]=t[(t[d>>2]|0)+24>>2]}t[u>>2]=t[b>>2];E=t[u>>2]|0;s=f;return E|0}bx(t[a>>2]|0,t[c>>2]|0,1038,196160,t[o>>2]|0,0);t[u>>2]=0;E=t[u>>2]|0;s=f;return E|0}function tU(e){e=e|0;var i=0,r=0,n=0,f=0,a=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=1;f=t[r>>2]|0;s=i;return f|0}e:while(1){if(!(u[t[n>>2]>>0]|0)){a=10;break}do if((u[t[n>>2]>>0]|0|0)!=32){if(9<=(u[t[n>>2]>>0]|0|0)?(u[t[n>>2]>>0]|0|0)<=10:0)break;if((u[t[n>>2]>>0]|0|0)!=13){a=8;break e}}while(0);t[n>>2]=(t[n>>2]|0)+1}if((a|0)==8){t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}else if((a|0)==10){t[r>>2]=1;f=t[r>>2]|0;s=i;return f|0}return 0}function uU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[u>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1037,194984,0,0);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}while(1){if(!(t[u>>2]|0))break;do if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,190048)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){i=t[f>>2]|0;e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(i,e,1106,191968,0,0);break}t[o>>2]=Ix(i,t[e+12>>2]|0)|0;if(t[o>>2]|0)t[a>>2]=-1}else l=13;while(0);do if((l|0)==13){l=0;if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,195016)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[o>>2]=xU(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0))break;t[a>>2]=-1;break}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,195024)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[o>>2]=UU(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0))break;t[a>>2]=-1;break}bx(t[f>>2]|0,t[u>>2]|0,1036,195032,t[(t[u>>2]|0)+8>>2]|0,0);t[a>>2]=-1}while(0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}function aU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+64|0;n=r;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r+32|0;t[f>>2]=e;t[u>>2]=i;t[c>>2]=-1;t[l>>2]=0;t[a>>2]=t[(t[u>>2]|0)+12>>2];if(!(t[a>>2]|0)){s=r;return}if(!(t[(t[a>>2]|0)+32>>2]|0)){s=r;return}t[b>>2]=t[a>>2];while(1){if(!(t[b>>2]|0))break;if(((t[(t[b>>2]|0)+4>>2]|0)!=0?(t[(t[(t[b>>2]|0)+4>>2]|0)+20>>2]|0)!=0:0)?(Xl(t[(t[(t[(t[b>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]|0,190048)|0)!=0:0)t[o>>2]=cF(t[(t[(t[b>>2]|0)+4>>2]|0)+20>>2]|0,194568)|0;else{t[o>>2]=0;bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1107,194784,0,0)}do if(!(t[o>>2]|0))if(!(t[l>>2]|0)){t[l>>2]=1;break}else{bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1054,194928,0,0);break}else{do if(Xl(t[o>>2]|0,190016)|0){if((t[c>>2]|0)==-1){t[c>>2]=1;break}if(!(t[c>>2]|0))bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1104,194832,0,0)}else{if(!(Xl(t[o>>2]|0,190032)|0)){bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1114,194880,t[o>>2]|0,0);break}if((t[c>>2]|0)==-1){t[c>>2]=0;break}if((t[c>>2]|0)==1)bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1104,194832,0,0)}while(0);pAi[t[135736>>2]&511](t[o>>2]|0)}while(0);t[b>>2]=t[(t[b>>2]|0)+32>>2];
	}if((t[c>>2]|0)==-1)t[c>>2]=0;t[b>>2]=dx(t[f>>2]|0,t[(t[a>>2]|0)+4>>2]|0)|0;if(!(t[b>>2]|0)){s=r;return}a=t[b>>2]|0;if(!(t[c>>2]|0))t[a>>2]=19;else t[a>>2]=17;t[(t[b>>2]|0)+24>>2]=t[(t[u>>2]|0)+12>>2];t[(t[u>>2]|0)+12>>2]=t[b>>2];if(t[c>>2]|0){s=r;return}if(!(t[(t[f>>2]|0)+56>>2]|0)){c=WF(10)|0;t[(t[f>>2]|0)+56>>2]=c}if(!(t[(t[f>>2]|0)+56>>2]|0)){bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1046,194736,0,0);s=r;return}c=(t[f>>2]|0)+52|0;u=t[c>>2]|0;t[c>>2]=u+1;t[n>>2]=u;SY(k,32,192704,n)|0;if((ZF(t[(t[f>>2]|0)+56>>2]|0,k,t[b>>2]|0)|0)>=0){s=r;return}bx(t[f>>2]|0,t[(t[b>>2]|0)+4>>2]|0,1046,192720,k,0);s=r;return}function oU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+80|0;f=n;u=n+40|0;a=n+36|0;o=n+32|0;c=n+28|0;l=n+24|0;b=n+20|0;k=n+16|0;h=n+12|0;w=n+8|0;d=n+4|0;v=n+48|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=-1;t[b>>2]=0;if(!(t[(t[u>>2]|0)+44>>2]|0)){s=n;return}t[k>>2]=t[u>>2];while(1){if(!(t[k>>2]|0))break;t[c>>2]=cF(t[(t[k>>2]|0)+4>>2]|0,194568)|0;do if(!(t[c>>2]|0))if(!(t[b>>2]|0)){t[b>>2]=1;break}else{bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1054,194680,t[o>>2]|0,0);break}else{do if(Xl(t[c>>2]|0,190016)|0){if((t[l>>2]|0)==-1){t[l>>2]=1;break}if(!(t[l>>2]|0))bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1010,194576,t[o>>2]|0,0)}else{if(!(Xl(t[c>>2]|0,190032)|0)){bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1114,194632,t[o>>2]|0,t[c>>2]|0);break}if((t[l>>2]|0)==-1){t[l>>2]=0;break}if((t[l>>2]|0)==1)bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1010,194576,t[o>>2]|0,0)}while(0);pAi[t[135736>>2]&511](t[c>>2]|0)}while(0);t[k>>2]=t[(t[k>>2]|0)+44>>2]}if((t[l>>2]|0)==-1)t[l>>2]=0;t[k>>2]=dx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0)|0;if(!(t[k>>2]|0)){s=n;return}c=t[k>>2]|0;if(!(t[l>>2]|0))t[c>>2]=19;else t[c>>2]=17;t[w>>2]=t[u>>2];t[h>>2]=0;while(1){if(!(t[w>>2]|0))break;if(t[(t[w>>2]|0)+24>>2]|0){if(t[(t[(t[w>>2]|0)+24>>2]|0)+32>>2]|0){t[d>>2]=dx(t[a>>2]|0,t[(t[(t[w>>2]|0)+24>>2]|0)+4>>2]|0)|0;if(!(t[d>>2]|0))break;t[t[d>>2]>>2]=18;t[(t[d>>2]|0)+24>>2]=t[(t[w>>2]|0)+24>>2]}else t[d>>2]=t[(t[w>>2]|0)+24>>2];c=t[d>>2]|0;if(!(t[h>>2]|0))t[(t[k>>2]|0)+24>>2]=c;else t[(t[h>>2]|0)+32>>2]=c;t[h>>2]=t[d>>2]}t[(t[w>>2]|0)+24>>2]=t[k>>2];t[w>>2]=t[(t[w>>2]|0)+44>>2]}t[(t[u>>2]|0)+24>>2]=t[k>>2];if(t[l>>2]|0){s=n;return}if(!(t[(t[a>>2]|0)+56>>2]|0)){l=WF(10)|0;t[(t[a>>2]|0)+56>>2]=l}if(!(t[(t[a>>2]|0)+56>>2]|0)){bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1046,194736,0,0);s=n;return}l=(t[a>>2]|0)+52|0;w=t[l>>2]|0;t[l>>2]=w+1;t[f>>2]=w;SY(v,32,192704,f)|0;if((ZF(t[(t[a>>2]|0)+56>>2]|0,v,t[k>>2]|0)|0)>=0){s=n;return}bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1046,192720,v,0);s=n;return}function cU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(f[(t[u>>2]|0)+50>>1]&256){s=n;return}t[c>>2]=t[(t[a>>2]|0)+24>>2];if(!(t[c>>2]|0)){bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1,194400,t[o>>2]|0,0);s=n;return}if(t[(t[u>>2]|0)+24>>2]|0){bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1,194456,t[o>>2]|0,0);s=n;return}if(!(t[(t[c>>2]|0)+24>>2]|0)){bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1101,194520,t[o>>2]|0,0);s=n;return}t[l>>2]=rO(t[(t[c>>2]|0)+24>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){bx(t[a>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1101,194520,t[o>>2]|0,0);s=n;return}t[b>>2]=t[u>>2];while(1){if(!(t[b>>2]|0))break;t[(t[b>>2]|0)+24>>2]=t[l>>2];t[b>>2]=t[(t[b>>2]|0)+44>>2]}s=n;return}function lU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+24|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;t[c>>2]=0;t[b>>2]=t[(t[f>>2]|0)+48>>2];while(1){if(!(t[u>>2]|0))break;if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189864)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[l>>2]=zU(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0)){r=t[l>>2]|0;t[c>>2]=r;t[o>>2]=r}else{if(((t[a>>2]|0)==1?(t[t[o>>2]>>2]|0)==4:0)?(t[o>>2]|0)==(t[c>>2]|0):0){t[o>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;t[t[o>>2]>>2]=18;t[(t[o>>2]|0)+24>>2]=t[c>>2]}t[(t[c>>2]|0)+32>>2]=t[l>>2];t[c>>2]=t[l>>2]}t[(t[l>>2]|0)+28>>2]=t[b>>2]}else k=16;do if((k|0)==16?(k=0,t[l>>2]=jU(t[f>>2]|0,t[u>>2]|0)|0,(t[l>>2]|0)!=0):0){r=t[l>>2]|0;if(!(t[o>>2]|0)){t[c>>2]=r;t[o>>2]=r;break}else{t[(t[c>>2]|0)+32>>2]=r;t[c>>2]=t[l>>2];break}}while(0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}s=n;return t[o>>2]|0}function sU(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0;f=s;s=s+16|0;u=f+8|0;a=f+4|0;o=f;t[f+12>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=n;do if(!(t[o>>2]|0)){if(!(t[a>>2]|0)){t[t[u>>2]>>2]=-1;t[o>>2]=t[u>>2];break}if((t[(t[a>>2]|0)+24>>2]|0)==(t[u>>2]|0)){t[(t[a>>2]|0)+24>>2]=t[(t[u>>2]|0)+32>>2];break}if((t[(t[a>>2]|0)+36>>2]|0)==(t[u>>2]|0)){t[(t[a>>2]|0)+36>>2]=t[(t[u>>2]|0)+32>>2];break}if((t[(t[a>>2]|0)+40>>2]|0)==(t[u>>2]|0))t[(t[a>>2]|0)+40>>2]=t[(t[u>>2]|0)+32>>2]}else t[(t[o>>2]|0)+32>>2]=t[(t[u>>2]|0)+32>>2];while(0);s=f;return t[o>>2]|0}function bU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;if(t[(t[f>>2]|0)+36>>2]|0){t[n>>2]=-1;l=t[n>>2]|0;s=r;return l|0}t[a>>2]=0;t[o>>2]=t[u>>2];e:while(1){if(!(t[o>>2]|0)){b=36;break}if((t[t[o>>2]>>2]|0)==4){b=12;break}if((t[t[o>>2]>>2]|0)==3){b=12;break}if((t[t[o>>2]>>2]|0)==5){b=12;break}if((t[t[o>>2]>>2]|0)==6){b=12;break}if((t[t[o>>2]>>2]|0)==8){b=12;break}if((t[t[o>>2]>>2]|0)==7){b=12;break}if(!(t[t[o>>2]>>2]|0)){b=12;break}if(!((((((((((t[t[o>>2]>>2]|0)!=17?(t[t[o>>2]>>2]|0)!=19:0)?(t[t[o>>2]>>2]|0)!=18:0)?(t[t[o>>2]>>2]|0)!=16:0)?(t[t[o>>2]>>2]|0)!=15:0)?(t[t[o>>2]>>2]|0)!=14:0)?(t[t[o>>2]>>2]|0)!=13:0)?(t[t[o>>2]>>2]|0)!=12:0)?(t[t[o>>2]>>2]|0)!=11:0)?(t[t[o>>2]>>2]|0)!=10:0))b=23;if((b|0)==23?(b=0,(t[(t[o>>2]|0)+24>>2]|0)!=0):0){t[a>>2]=t[o>>2];t[o>>2]=t[(t[o>>2]|0)+24>>2];t[c>>2]=t[o>>2];while(1){if(!(t[c>>2]|0))continue e;t[(t[c>>2]|0)+28>>2]=t[a>>2];t[c>>2]=t[(t[c>>2]|0)+32>>2]}}if((t[o>>2]|0)==(t[u>>2]|0)){b=36;break}if(t[(t[o>>2]|0)+32>>2]|0){t[o>>2]=t[(t[o>>2]|0)+32>>2];continue}while(1){t[o>>2]=t[(t[o>>2]|0)+28>>2];if(!(t[o>>2]|0))continue e;if((t[o>>2]|0)==(t[u>>2]|0)){b=32;break e}k=t[o>>2]|0;if(t[(t[o>>2]|0)+32>>2]|0)break;if(!k)continue e}t[o>>2]=t[k+32>>2]}if((b|0)==12){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}else if((b|0)==32){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((b|0)==36){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}return 0}function kU(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[n>>2]=e;t[u>>2]=i;t[c>>2]=0;if(!(t[u>>2]|0)){s=r;return}if((t[t[u>>2]>>2]|0)!=18?(t[t[u>>2]>>2]|0)!=4:0){s=r;return}if(f[(t[u>>2]|0)+50>>1]&32){s=r;return}if(t[(t[n>>2]|0)+36>>2]|0){s=r;return}t[o>>2]=t[(t[u>>2]|0)+36>>2];while(1){if(!(t[o>>2]|0))break;t[c>>2]=(t[c>>2]|0)+1;t[o>>2]=t[(t[o>>2]|0)+32>>2]}t[o>>2]=t[(t[u>>2]|0)+24>>2];while(1){if(!(t[o>>2]|0))break;t[c>>2]=(t[c>>2]|0)+1;t[o>>2]=t[(t[o>>2]|0)+32>>2]}t[a>>2]=gAi[t[135744>>2]&511](t[c>>2]<<2)|0;if(!(t[a>>2]|0)){lx(t[n>>2]|0,191880);s=r;return}t[l>>2]=0;t[o>>2]=t[(t[u>>2]|0)+36>>2];while(1){if(!(t[o>>2]|0))break;i=zx(t[n>>2]|0,t[o>>2]|0,1)|0;t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]=i;t[l>>2]=(t[l>>2]|0)+1;t[o>>2]=t[(t[o>>2]|0)+32>>2]}t[o>>2]=t[(t[u>>2]|0)+24>>2];while(1){if(!(t[o>>2]|0))break;i=zx(t[n>>2]|0,t[o>>2]|0,1)|0;t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]=i;t[l>>2]=(t[l>>2]|0)+1;t[o>>2]=t[(t[o>>2]|0)+32>>2]}t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[c>>2]|0))break;e:do if(t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0){t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break e;if((t[(t[a>>2]|0)+(t[b>>2]<<2)>>2]|0)!=0?(t[k>>2]=jx(t[n>>2]|0,t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0,t[(t[a>>2]|0)+(t[b>>2]<<2)>>2]|0)|0,(t[k>>2]|0)==0):0)bx(t[n>>2]|0,t[(t[u>>2]|0)+4>>2]|0,1040,191896,0,0);t[b>>2]=(t[b>>2]|0)+1}}while(0);t[l>>2]=(t[l>>2]|0)+1}t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[c>>2]|0))break;if(t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+(t[l>>2]<<2)>>2]|0);t[l>>2]=(t[l>>2]|0)+1}pAi[t[135736>>2]&511](t[a>>2]|0);a=(t[u>>2]|0)+50|0;f[a>>1]=f[a>>1]|32;s=r;return}function hU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(!((t[f>>2]|0)==-1|(t[u>>2]|0)==-1)){i=t[u>>2]|0;if(!(t[f>>2]|0)){t[n>>2]=i;break}e=t[f>>2]|0;if(!i){t[n>>2]=e;break}if((e|0)==2&(t[u>>2]|0)==2){t[n>>2]=2;break}else{t[n>>2]=-1;break}}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function wU(e,i){e=e|0;i=i|0;var r=0,n=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;r=s;s=s+64|0;n=r+52|0;a=r+48|0;o=r+44|0;c=r+40|0;l=r+36|0;b=r+32|0;k=r+28|0;h=r+24|0;w=r+20|0;d=r+16|0;v=r+12|0;m=r+8|0;_=r+4|0;p=r;t[n>>2]=e;t[a>>2]=i;t[l>>2]=0;t[w>>2]=0;t[d>>2]=0;t[v>>2]=0;t[m>>2]=1;if(!(t[a>>2]|0)){s=r;return}if((t[t[a>>2]>>2]|0)!=17){s=r;return}if(f[(t[a>>2]|0)+50>>1]&32){s=r;return}if(t[(t[n>>2]|0)+36>>2]|0){s=r;return}t[w>>2]=VU(t[a>>2]|0)|0;t[c>>2]=t[(t[a>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break;t[l>>2]=(t[l>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+32>>2]}t[o>>2]=gAi[t[135744>>2]&511](t[l>>2]<<2)|0;if(!(t[o>>2]|0)){lx(t[n>>2]|0,191856);s=r;return}t[b>>2]=0;if(!(t[w>>2]|0))t[v>>2]=WF(10)|0;else t[m>>2]=0;t[c>>2]=t[(t[a>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break;w=zx(t[n>>2]|0,t[c>>2]|0,0)|0;t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]=w;e:do if((t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0)!=0?(t[t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]>>2]|0)!=0:0){if((t[m>>2]|0)==1){t[_>>2]=t[(t[o>>2]|0)+(t[b>>2]<<2)>>2];while(1){if(!((t[m>>2]|0)==1?(t[t[_>>2]>>2]|0)!=0:0))break e;do if((t[t[t[_>>2]>>2]>>2]|0)==3){t[p>>2]=QF(t[v>>2]|0,188096,0,t[c>>2]|0)|0;if(t[p>>2]|0)t[m>>2]=-1}else{if((t[t[t[_>>2]>>2]>>2]|0)==4?(t[(t[t[_>>2]>>2]|0)+8>>2]|0)!=0:0){do if(!(t[(t[t[_>>2]>>2]|0)+12>>2]|0))E=28;else{if(!(u[t[(t[t[_>>2]>>2]|0)+12>>2]>>0]|0)){E=28;break}t[p>>2]=QF(t[v>>2]|0,t[(t[t[_>>2]>>2]|0)+8>>2]|0,t[(t[t[_>>2]>>2]|0)+12>>2]|0,t[c>>2]|0)|0}while(0);if((E|0)==28){E=0;t[p>>2]=QF(t[v>>2]|0,t[(t[t[_>>2]>>2]|0)+8>>2]|0,0,t[c>>2]|0)|0}if(!(t[p>>2]|0))break;t[m>>2]=-1;break}if((t[t[t[_>>2]>>2]>>2]|0)!=4){t[m>>2]=-1;break}do if(!(t[(t[t[_>>2]>>2]|0)+12>>2]|0))E=35;else{if(!(u[t[(t[t[_>>2]>>2]|0)+12>>2]>>0]|0)){E=35;break}t[p>>2]=QF(t[v>>2]|0,189536,t[(t[t[_>>2]>>2]|0)+12>>2]|0,t[c>>2]|0)|0}while(0);if((E|0)==35){E=0;t[p>>2]=QF(t[v>>2]|0,189536,0,t[c>>2]|0)|0}if(t[p>>2]|0)t[m>>2]=-1}while(0);t[_>>2]=(t[_>>2]|0)+4}}}else E=17;while(0);if((E|0)==17){E=0;t[m>>2]=0}t[b>>2]=(t[b>>2]|0)+1;t[c>>2]=t[(t[c>>2]|0)+32>>2]}t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;e:do if(t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0){t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[b>>2]|0))break e;if((t[(t[o>>2]|0)+(t[k>>2]<<2)>>2]|0)!=0?(t[h>>2]=jx(t[n>>2]|0,t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0,t[(t[o>>2]|0)+(t[k>>2]<<2)>>2]|0)|0,(t[h>>2]|0)==0):0)t[d>>2]=1;t[k>>2]=(t[k>>2]|0)+1}}while(0);t[b>>2]=(t[b>>2]|0)+1}t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[l>>2]|0))break;if(t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0)pAi[t[135736>>2]&511](t[(t[o>>2]|0)+(t[b>>2]<<2)>>2]|0);t[b>>2]=(t[b>>2]|0)+1}pAi[t[135736>>2]&511](t[o>>2]|0);if(t[d>>2]|0){d=(t[a>>2]|0)+50|0;f[d>>1]=f[d>>1]|4}if((t[m>>2]|0)!=1){if(t[v>>2]|0)XF(t[v>>2]|0,0)}else{m=(t[a>>2]|0)+50|0;f[m>>1]=f[m>>1]|16;t[(t[a>>2]|0)+20>>2]=t[v>>2]}v=(t[a>>2]|0)+50|0;f[v>>1]=f[v>>1]|32;s=r;return}function dU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if(!((t[f>>2]|0)==-1|(t[u>>2]|0)==-1)){if((t[f>>2]|0)==1|(t[u>>2]|0)==1){t[n>>2]=1;break}if((t[f>>2]|0)==2|(t[u>>2]|0)==2){t[n>>2]=2;break}else{t[n>>2]=0;break}}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function vU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+240|0;n=r;f=r+224|0;a=r+220|0;o=r+216|0;c=r+212|0;l=r+152|0;b=r+128|0;k=r+8|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=1;i=k+0|0;e=i+116|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[k+28>>2]=9;do if((t[t[a>>2]>>2]|0)!=4?(t[t[a>>2]>>2]|0)!=9:0){if((t[t[a>>2]>>2]|0)!=3){i=t[33976]|0;e=t[33980]|0;if((t[t[a>>2]>>2]|0)==2){t[n>>2]=189496;t[n+4>>2]=3822;yAi[i&511](e,189464,n);t[c>>2]=0;break}else{t[n>>2]=189496;t[n+4>>2]=3824;yAi[i&511](e,189464,n);t[c>>2]=0;break}}if((t[t[o>>2]>>2]|0)==3){t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}else{t[f>>2]=1;h=t[f>>2]|0;s=r;return h|0}}else w=3;while(0);do if((w|0)==3){if((t[t[o>>2]>>2]|0)==3){t[f>>2]=1;h=t[f>>2]|0;s=r;return h|0}if(t[(t[a>>2]|0)+8>>2]|0)t[l+8>>2]=t[(t[a>>2]|0)+8>>2];else t[l+8>>2]=t[47556];do if(t[(t[a>>2]|0)+12>>2]|0){e=l+36|0;if(!(u[t[(t[a>>2]|0)+12>>2]>>0]|0)){t[e>>2]=0;break}else{t[e>>2]=b;t[b+8>>2]=t[(t[a>>2]|0)+12>>2];break}}else t[l+36>>2]=0;while(0);if(!(FU(k,t[o>>2]|0,l)|0)){t[c>>2]=1;break}if(t[(t[a>>2]|0)+40>>2]|0){t[c>>2]=vU(t[(t[a>>2]|0)+40>>2]|0,t[o>>2]|0)|0;break}else{t[c>>2]=0;break}}while(0);if(!(t[c>>2]|0)){t[f>>2]=t[c>>2];h=t[f>>2]|0;s=r;return h|0}if((t[t[o>>2]>>2]|0)!=4?(t[t[o>>2]>>2]|0)!=9:0){e=t[33976]|0;i=t[33980]|0;t[n>>2]=189496;t[n+4>>2]=3855;yAi[e&511](i,189464,n);t[c>>2]=0}else w=29;do if((w|0)==29){if(t[(t[o>>2]|0)+8>>2]|0)t[l+8>>2]=t[(t[o>>2]|0)+8>>2];else t[l+8>>2]=t[47556];t[l+36>>2]=b;do if(t[(t[o>>2]|0)+12>>2]|0)if(!(u[t[(t[o>>2]|0)+12>>2]>>0]|0)){t[l+36>>2]=0;break}else{t[b+8>>2]=t[(t[o>>2]|0)+12>>2];break}else t[b+8>>2]=t[47556];while(0);if(!(FU(k,t[a>>2]|0,l)|0)){t[c>>2]=1;break}if(t[(t[o>>2]|0)+40>>2]|0){t[c>>2]=vU(t[(t[o>>2]|0)+40>>2]|0,t[a>>2]|0)|0;break}else{t[c>>2]=0;break}}while(0);t[f>>2]=t[c>>2];h=t[f>>2]|0;s=r;return h|0}function mU(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e:do if(!(t[n>>2]|0))t[r>>2]=189816;else do switch(t[t[n>>2]>>2]|0){case 10:{t[r>>2]=189920;break e;break}case 5:{t[r>>2]=189872;break e;break}case 17:{t[r>>2]=190016;break e;break}case 16:{t[r>>2]=19e4;break e;break}case 8:{t[r>>2]=189896;break e;break}case 13:{t[r>>2]=189952;break e;break}case 12:{t[r>>2]=189936;break e;break}case 6:{t[r>>2]=190064;break e;break}case 2:{t[r>>2]=189848;break e;break}case 19:{t[r>>2]=190032;break e;break}case 0:{t[r>>2]=189824;break e;break}case 15:{t[r>>2]=189984;break e;break}case 18:{t[r>>2]=190024;break e;break}case 11:{t[r>>2]=189928;break e;break}case 20:{t[r>>2]=190048;break e;break}case 9:{t[r>>2]=189904;break e;break}case-1:{t[r>>2]=190056;break e;break}case 3:{t[r>>2]=189856;break e;break}case 1:{t[r>>2]=189832;break e;break}case 14:{t[r>>2]=189968;break e;break}case 7:{t[r>>2]=189888;break e;break}case 4:{t[r>>2]=189864;break e;break}default:{t[r>>2]=190072;break e}}while(0);while(0);s=i;return t[r>>2]|0}function _U(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;f=s;s=s+1024|0;u=f;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+24|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;if(!(t[c>>2]|0))t[c>>2]=188112;if(!(t[l>>2]|0))t[l>>2]=188112;n[b>>0]=0;do switch(t[o>>2]|0){case 34:{t[a>>2]=Wl(189280)|0;k=t[a>>2]|0;s=f;return k|0}case 6:{t[a>>2]=Wl(188288)|0;k=t[a>>2]|0;s=f;return k|0}case 11:{t[a>>2]=Wl(188440)|0;k=t[a>>2]|0;s=f;return k|0}case 19:{t[u>>2]=t[c>>2];SY(b,1e3,188712,u)|0;break}case 13:{r=t[l>>2]|0;t[u>>2]=t[c>>2];t[u+4>>2]=r;SY(b,1e3,188504,u)|0;break}case 12:{t[u>>2]=t[c>>2];SY(b,1e3,188472,u)|0;break}case 27:{r=t[l>>2]|0;t[u>>2]=t[c>>2];t[u+4>>2]=r;SY(b,1e3,188992,u)|0;break}case 4:{t[u>>2]=t[c>>2];SY(b,1e3,188232,u)|0;break}case 8:{t[u>>2]=t[c>>2];SY(b,1e3,188376,u)|0;break}case 23:{t[a>>2]=Wl(188832)|0;k=t[a>>2]|0;s=f;return k|0}case 37:{t[u>>2]=t[c>>2];SY(b,1e3,188352,u)|0;break}case 29:{t[u>>2]=t[c>>2];SY(b,1e3,189112,u)|0;break}case 21:{t[u>>2]=t[c>>2];SY(b,1e3,188752,u)|0;break}case 28:{t[u>>2]=t[c>>2];SY(b,1e3,189072,u)|0;break}case 0:{t[a>>2]=0;k=t[a>>2]|0;s=f;return k|0}case 17:{r=t[l>>2]|0;t[u>>2]=t[c>>2];t[u+4>>2]=r;SY(b,1e3,188576,u)|0;break}case 35:{t[a>>2]=Wl(189304)|0;k=t[a>>2]|0;s=f;return k|0}case 32:{t[u>>2]=t[c>>2];SY(b,1e3,189224,u)|0;break}case 25:{t[u>>2]=t[c>>2];SY(b,1e3,188912,u)|0;break}case 36:{t[u>>2]=t[c>>2];SY(b,1e3,189032,u)|0;break}case 15:{t[u>>2]=t[c>>2];SY(b,1e3,188536,u)|0;break}case 39:{t[u>>2]=t[c>>2];SY(b,1e3,188664,u)|0;break}case 7:{t[a>>2]=Wl(188320)|0;k=t[a>>2]|0;s=f;return k|0}case 33:{t[a>>2]=Wl(189256)|0;k=t[a>>2]|0;s=f;return k|0}case 30:{t[u>>2]=t[c>>2];SY(b,1e3,189152,u)|0;break}case 38:{t[u>>2]=t[c>>2];SY(b,1e3,188624,u)|0;break}case 5:{t[u>>2]=t[c>>2];SY(b,1e3,188256,u)|0;break}case 22:{t[u>>2]=t[c>>2];SY(b,1e3,188792,u)|0;break}case 1:{t[a>>2]=Wl(188144)|0;k=t[a>>2]|0;s=f;return k|0}case 10:{t[a>>2]=Wl(188400)|0;k=t[a>>2]|0;s=f;return k|0}case 31:{t[u>>2]=t[c>>2];SY(b,1e3,189192,u)|0;break}case 3:{r=t[l>>2]|0;t[u>>2]=t[c>>2];t[u+4>>2]=r;SY(b,1e3,188192,u)|0;break}case 2:{t[u>>2]=t[c>>2];SY(b,1e3,188160,u)|0;break}case 24:{t[u>>2]=t[c>>2];SY(b,1e3,188864,u)|0;break}case 26:{r=t[l>>2]|0;t[u>>2]=t[c>>2];t[u+4>>2]=r;SY(b,1e3,188952,u)|0;break}default:{t[a>>2]=Wl(189336)|0;k=t[a>>2]|0;s=f;return k|0}}while(0);if(!(n[b>>0]|0)){t[u>>2]=t[o>>2];SY(b,1e3,189360,u)|0}n[b+999>>0]=0;t[a>>2]=Yl(b)|0;k=t[a>>2]|0;s=f;return k|0}function pU(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;if(t[c>>2]|0){u=t[c>>2]|0;if(t[(t[c>>2]|0)+12>>2]|0)t[d>>2]=t[u+12>>2];else t[v>>2]=t[u+4>>2];t[m>>2]=t[t[c>>2]>>2];u=(t[c>>2]|0)+16|0;t[u>>2]=(t[u>>2]|0)+1}u=t[d>>2]|0;d=t[v>>2]|0;v=t[m>>2]|0;m=t[l>>2]|0;l=t[b>>2]|0;b=t[h>>2]|0;c=t[w>>2]|0;f=t[k>>2]|0;k=t[w>>2]|0;t[o>>2]=t[h>>2];t[o+4>>2]=k;cp(u,d,v,0,m,19,l,2,0,0,b,c,0,0,0,f,o);s=a;return}function EU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;r=s;s=s+48|0;n=r+36|0;f=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[f>>2]=e;t[a>>2]=i;t[o>>2]=0;t[k>>2]=0;if((t[(t[(t[f>>2]|0)+60>>2]|0)+16>>2]|0)<=0){t[n>>2]=-1;d=t[n>>2]|0;s=r;return d|0}i=(t[(t[a>>2]|0)+8>>2]|0)!=0;t[c>>2]=0;do if(i){while(1){if((t[c>>2]|0)>=(t[(t[(t[f>>2]|0)+60>>2]|0)+8>>2]|0))break;t[h>>2]=t[(t[(t[(t[f>>2]|0)+60>>2]|0)+28>>2]|0)+(t[c>>2]<<2)>>2];if((t[h>>2]|0)!=0?(Xl(t[(t[a>>2]|0)+8>>2]|0,t[(t[h>>2]|0)+8>>2]|0)|0)!=0:0){if(!((t[(t[a>>2]|0)+12>>2]|0)!=0?(u[t[(t[a>>2]|0)+12>>2]>>0]|0|0)!=0:0))v=9;if((v|0)==9?(v=0,(t[(t[h>>2]|0)+36>>2]|0)==0):0){v=12;break}if((t[(t[h>>2]|0)+36>>2]|0)!=0?(Xl(t[(t[a>>2]|0)+12>>2]|0,t[(t[(t[h>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0){v=12;break}}t[c>>2]=(t[c>>2]|0)+1}if((v|0)==12)t[k>>2]=t[h>>2];if(!(t[k>>2]|0)){t[o>>2]=-1;break}t[l>>2]=sy(t[(t[k>>2]|0)+32>>2]|0,t[(t[k>>2]|0)+12>>2]|0,1)|0;t[b>>2]=t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2];t[w>>2]=t[(t[(t[f>>2]|0)+60>>2]|0)+4>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+4>>2]=t[k>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2]=t[l>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+24>>2]=0;t[o>>2]=qU(t[f>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0;if(t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2]|0)t[l>>2]=t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2];if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2]=t[b>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+4>>2]=t[w>>2];if(!(t[o>>2]|0)){t[(t[(t[(t[f>>2]|0)+60>>2]|0)+28>>2]|0)+(t[c>>2]<<2)>>2]=0;e=(t[(t[f>>2]|0)+60>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+-1}}else{while(1){if((t[c>>2]|0)>=(t[(t[(t[f>>2]|0)+60>>2]|0)+8>>2]|0))break;t[h>>2]=t[(t[(t[(t[f>>2]|0)+60>>2]|0)+28>>2]|0)+(t[c>>2]<<2)>>2];if((t[h>>2]|0)!=0?(YU(t[f>>2]|0,t[a>>2]|0,t[h>>2]|0)|0)==1:0){v=25;break}t[c>>2]=(t[c>>2]|0)+1}if((v|0)==25)t[k>>2]=t[h>>2];if(!(t[k>>2]|0)){t[o>>2]=-1;break}t[l>>2]=sy(t[(t[k>>2]|0)+32>>2]|0,t[(t[k>>2]|0)+12>>2]|0,1)|0;t[b>>2]=t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2];t[w>>2]=t[(t[(t[f>>2]|0)+60>>2]|0)+4>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+4>>2]=t[k>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2]=t[l>>2];t[o>>2]=qU(t[f>>2]|0,t[(t[a>>2]|0)+24>>2]|0)|0;if(t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2]|0)t[l>>2]=t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2];if(t[l>>2]|0)pAi[t[135736>>2]&511](t[l>>2]|0);t[(t[(t[f>>2]|0)+60>>2]|0)+20>>2]=t[b>>2];t[(t[(t[f>>2]|0)+60>>2]|0)+4>>2]=t[w>>2];if(!(t[o>>2]|0)){t[(t[(t[(t[f>>2]|0)+60>>2]|0)+28>>2]|0)+(t[c>>2]<<2)>>2]=0;e=(t[(t[f>>2]|0)+60>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+-1}}while(0);t[n>>2]=t[o>>2];d=t[n>>2]|0;s=r;return d|0}function SU(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;t[o>>2]=-1;t[c>>2]=1e6;if(((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+64>>2]|0)!=0:0)?(t[t[(t[n>>2]|0)+64>>2]>>2]|0)>0:0){t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[t[(t[n>>2]|0)+64>>2]>>2]|0))break;t[f>>2]=t[(t[(t[(t[n>>2]|0)+64>>2]|0)+8>>2]|0)+(t[u>>2]<<2)>>2];do if(t[f>>2]|0){if(t[(t[f>>2]|0)+4>>2]|0){if(!((t[o>>2]|0)==-1|(t[c>>2]|0)>1e5))break;t[c>>2]=1e5;t[o>>2]=t[u>>2];break}t[a>>2]=t[(t[f>>2]|0)+16>>2];if((t[o>>2]|0)!=-1?(t[c>>2]|0)<=(t[a>>2]|0):0)break;t[c>>2]=t[a>>2];t[o>>2]=t[u>>2]}while(0);t[u>>2]=(t[u>>2]|0)+1}t[r>>2]=t[o>>2];l=t[r>>2]|0;s=i;return l|0}t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}function gU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[f>>2];while(1){if((t[u>>2]|0)>=(t[(t[n>>2]|0)+48>>2]|0))break;t[a>>2]=(t[(t[n>>2]|0)+56>>2]|0)+((t[u>>2]|0)*24|0);if(t[(t[a>>2]|0)+4>>2]&1){if(t[(t[a>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+16>>2]|0);t[(t[a>>2]|0)+16>>2]=0;if(t[(t[a>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[a>>2]|0)+20>>2]|0);t[(t[a>>2]|0)+20>>2]=0;t[(t[a>>2]|0)+4>>2]=0}t[u>>2]=(t[u>>2]|0)+1}t[(t[n>>2]|0)+48>>2]=t[f>>2];if((t[(t[n>>2]|0)+48>>2]|0)>0){s=r;return}t[(t[n>>2]|0)+44>>2]=0;s=r;return}function yU(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;e=t[r>>2]|0;if((t[(t[r>>2]|0)+48>>2]|0)<=0){t[e+44>>2]=0;s=i;return}f=e+48|0;t[f>>2]=(t[f>>2]|0)+-1;f=t[r>>2]|0;if((t[(t[r>>2]|0)+48>>2]|0)>0)t[(t[r>>2]|0)+44>>2]=(t[(t[r>>2]|0)+56>>2]|0)+(((t[f+48>>2]|0)-1|0)*24|0);else t[f+44>>2]=0;t[n>>2]=(t[(t[r>>2]|0)+56>>2]|0)+((t[(t[r>>2]|0)+48>>2]|0)*24|0);if(!(t[(t[n>>2]|0)+4>>2]&1)){s=i;return}if(t[(t[n>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+16>>2]|0);t[(t[n>>2]|0)+16>>2]=0;if(t[(t[n>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+20>>2]|0);t[(t[n>>2]|0)+20>>2]=0;t[(t[n>>2]|0)+4>>2]=0;s=i;return}function FU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;n=s;s=s+48|0;f=n;a=n+36|0;o=n+32|0;c=n+28|0;l=n+24|0;b=n+20|0;k=n+16|0;h=n+12|0;w=n+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=0;t[k>>2]=0;if((t[(t[c>>2]|0)+8>>2]|0)!=0?(Xl(t[(t[l>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+8>>2]|0)|0)==0:0){mx(t[o>>2]|0,13,t[(t[c>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0,0);t[a>>2]=0;d=t[a>>2]|0;s=n;return d|0}if((t[(t[c>>2]|0)+12>>2]|0)!=0?(u[t[(t[c>>2]|0)+12>>2]>>0]|0|0)!=0:0){if(!(t[(t[l>>2]|0)+36>>2]|0)){mx(t[o>>2]|0,15,t[(t[l>>2]|0)+8>>2]|0,0,0);t[a>>2]=0;d=t[a>>2]|0;s=n;return d|0}if(!(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+12>>2]|0)|0)){mx(t[o>>2]|0,17,t[(t[l>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+12>>2]|0,0);t[a>>2]=0;d=t[a>>2]|0;s=n;return d|0}}else{if(((t[(t[l>>2]|0)+36>>2]|0)!=0?(t[(t[c>>2]|0)+12>>2]|0)!=0:0)?(t[(t[c>>2]|0)+8>>2]|0)==0:0){mx(t[o>>2]|0,19,t[(t[l>>2]|0)+8>>2]|0,0,0);t[a>>2]=0;d=t[a>>2]|0;s=n;return d|0}if((t[(t[l>>2]|0)+36>>2]|0)!=0?(t[(t[c>>2]|0)+8>>2]|0)!=0:0){mx(t[o>>2]|0,19,t[(t[c>>2]|0)+8>>2]|0,0,0);t[a>>2]=0;d=t[a>>2]|0;s=n;return d|0}}if(!(t[(t[c>>2]|0)+40>>2]|0)){t[a>>2]=1;d=t[a>>2]|0;s=n;return d|0}t[c>>2]=t[(t[c>>2]|0)+40>>2];do if((t[t[c>>2]>>2]|0)==2){if(t[o>>2]|0){t[k>>2]=t[(t[o>>2]|0)+28>>2];r=(t[o>>2]|0)+28|0;t[r>>2]=t[r>>2]|1}t[h>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[h>>2]|0)){v=33;break}t[b>>2]=FU(t[o>>2]|0,t[h>>2]|0,t[l>>2]|0)|0;if((t[b>>2]|0)==1){v=25;break}if((t[b>>2]|0)<0){v=29;break}t[h>>2]=t[(t[h>>2]|0)+32>>2]}if((v|0)==25){if(t[o>>2]|0)t[(t[o>>2]|0)+28>>2]=t[k>>2];t[a>>2]=0;d=t[a>>2]|0;s=n;return d|0}else if((v|0)==29){if(t[o>>2]|0)t[(t[o>>2]|0)+28>>2]=t[k>>2];t[a>>2]=t[b>>2];d=t[a>>2]|0;s=n;return d|0}else if((v|0)==33){t[b>>2]=1;if(!(t[o>>2]|0))break;t[(t[o>>2]|0)+28>>2]=t[k>>2];break}}else{if((t[t[c>>2]>>2]|0)!=17){r=t[33976]|0;i=t[33980]|0;t[f>>2]=189496;t[f+4>>2]=9708;yAi[r&511](i,189464,f);t[b>>2]=-1;break}if(t[o>>2]|0){t[k>>2]=t[(t[o>>2]|0)+28>>2];i=(t[o>>2]|0)+28|0;t[i>>2]=t[i>>2]|1}t[w>>2]=t[(t[c>>2]|0)+40>>2];while(1){m=t[o>>2]|0;if(!(t[w>>2]|0)){v=49;break}t[b>>2]=FU(m,t[w>>2]|0,t[l>>2]|0)|0;if((t[b>>2]|0)==1){v=41;break}if((t[b>>2]|0)<0){v=45;break}t[w>>2]=t[(t[w>>2]|0)+32>>2]}if((v|0)==41){if(t[o>>2]|0)t[(t[o>>2]|0)+28>>2]=t[k>>2];t[a>>2]=1;d=t[a>>2]|0;s=n;return d|0}else if((v|0)==45){if(t[o>>2]|0)t[(t[o>>2]|0)+28>>2]=t[k>>2];t[a>>2]=t[b>>2];d=t[a>>2]|0;s=n;return d|0}else if((v|0)==49){do if(m){i=t[o>>2]|0;if(t[b>>2]|0){if(t[i+28>>2]&1)break;Yx(t[o>>2]|0);break}else{if((t[i+48>>2]|0)<=0)break;gU(t[o>>2]|0,0);break}}while(0);t[b>>2]=0;if(!(t[o>>2]|0))break;t[(t[o>>2]|0)+28>>2]=t[k>>2];break}}while(0);t[a>>2]=t[b>>2];d=t[a>>2]|0;s=n;return d|0}function OU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=-1;h=t[f>>2]|0;s=n;return h|0}t[k>>2]=t[(t[u>>2]|0)+112>>2];t[c>>2]=Ws(t[a>>2]|0,385,t[u>>2]|0)|0;t[(t[u>>2]|0)+112>>2]=0;t[l>>2]=t[o>>2];while(1){if(!(t[l>>2]|0))break;t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=t[l>>2];o=t[(t[l>>2]|0)+4>>2]|0;if((o|0)==1){a=t[c>>2]|0;r=t[(t[l>>2]|0)+8>>2]|0;if(t[(t[l>>2]|0)+36>>2]|0)t[b>>2]=Zs(a,r,t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[u>>2]|0)|0;else t[b>>2]=Xs(a,r,t[u>>2]|0)|0;if((t[b>>2]|0)<0)mx(t[u>>2]|0,38,t[(t[l>>2]|0)+8>>2]|0,0,0)}else if(((o|0)==4|(o|0)==3?(EF(t[l>>2]|0)|0)==0:0)?(t[b>>2]=Xs(t[c>>2]|0,188096,t[u>>2]|0)|0,(t[b>>2]|0)<0):0)mx(t[u>>2]|0,39,t[(t[(t[l>>2]|0)+20>>2]|0)+8>>2]|0,0,0);if((t[b>>2]|0)<0)break;t[l>>2]=t[(t[l>>2]|0)+24>>2]}t[b>>2]=Xs(t[c>>2]|0,0,0)|0;do if((t[b>>2]|0)!=1){if(t[b>>2]|0){t[b>>2]=-1;break}mx(t[u>>2]|0,22,188112,0,0);t[b>>2]=-1;if(!(t[(t[u>>2]|0)+28>>2]&1))Yx(t[u>>2]|0)}else{t[b>>2]=0;t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=0}while(0);Ks(t[c>>2]|0);if((t[b>>2]|0)==0?(t[(t[u>>2]|0)+112>>2]|0)!=0:0)t[b>>2]=t[(t[u>>2]|0)+112>>2];t[(t[u>>2]|0)+112>>2]=t[k>>2];t[f>>2]=t[b>>2];h=t[f>>2]|0;s=n;return h|0}function AU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[u>>2]|0)){mx(t[f>>2]|0,37,189592,0,0);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}while(1){if(!(t[u>>2]|0)){l=11;break}if((t[(t[f>>2]|0)+60>>2]|0)==0?(t[(t[f>>2]|0)+64>>2]|0)==0:0){l=8;break}t[o>>2]=gx(t[f>>2]|0,t[u>>2]|0)|0;if((t[o>>2]|0)<0)t[a>>2]=-1;if((t[o>>2]|0)==-1){l=11;break}t[u>>2]=t[(t[u>>2]|0)+32>>2]}if((l|0)==8){mx(t[f>>2]|0,6,0,0,0);t[n>>2]=-1;c=t[n>>2]|0;s=r;return c|0}else if((l|0)==11){t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}return 0}function MU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}if((t[(t[f>>2]|0)+68>>2]|0)!=0?(t[t[(t[f>>2]|0)+68>>2]>>2]|0)>0:0){i=t[(t[f>>2]|0)+68>>2]|0;t[i>>2]=(t[i>>2]|0)+-1;t[a>>2]=t[(t[(t[(t[f>>2]|0)+68>>2]|0)+8>>2]|0)+(t[t[(t[f>>2]|0)+68>>2]>>2]<<2)>>2]}else k=6;do if((k|0)==6){t[a>>2]=gAi[t[135744>>2]&511](32)|0;if(t[a>>2]|0){i=t[a>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[i+8>>2]=0;t[i+12>>2]=0;t[i+16>>2]=0;t[i+20>>2]=0;t[i+24>>2]=0;t[i+28>>2]=0;break}Fx(t[f>>2]|0,189568);t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}while(0);t[c>>2]=t[(t[a>>2]|0)+28>>2];t[o>>2]=t[(t[a>>2]|0)+12>>2];k=t[a>>2]|0;i=t[u>>2]|0;t[k+0>>2]=t[i+0>>2];t[k+4>>2]=t[i+4>>2];t[k+8>>2]=t[i+8>>2];t[k+12>>2]=t[i+12>>2];t[k+16>>2]=t[i+16>>2];t[k+20>>2]=t[i+20>>2];t[k+24>>2]=t[i+24>>2];t[k+28>>2]=t[i+28>>2];t[(t[a>>2]|0)+28>>2]=t[c>>2];t[(t[a>>2]|0)+12>>2]=t[o>>2];if((t[(t[u>>2]|0)+8>>2]|0)>0){do if(!(t[(t[a>>2]|0)+28>>2]|0)){t[(t[a>>2]|0)+12>>2]=t[(t[u>>2]|0)+12>>2];o=gAi[t[135744>>2]&511](t[(t[a>>2]|0)+12>>2]<<2)|0;t[(t[a>>2]|0)+28>>2]=o;if(!(t[(t[a>>2]|0)+28>>2]|0)){Fx(t[f>>2]|0,189568);t[(t[a>>2]|0)+8>>2]=0;t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}}else if((t[(t[a>>2]|0)+12>>2]|0)<(t[(t[u>>2]|0)+8>>2]|0)){t[l>>2]=MAi[t[135760>>2]&511](t[(t[a>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+12>>2]<<2)|0;if(t[l>>2]|0){t[(t[a>>2]|0)+12>>2]=t[(t[u>>2]|0)+12>>2];t[(t[a>>2]|0)+28>>2]=t[l>>2];break}Fx(t[f>>2]|0,189568);t[(t[a>>2]|0)+8>>2]=0;t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}while(0);YY(t[(t[a>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+28>>2]|0,t[(t[u>>2]|0)+8>>2]<<2|0)|0}t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}function RU(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0;r=s;s=s+96|0;n=r+88|0;u=r+84|0;a=r+80|0;o=r+76|0;c=r+72|0;l=r+68|0;b=r+64|0;k=r+60|0;h=r+56|0;w=r+52|0;d=r+48|0;v=r+44|0;m=r+40|0;_=r+36|0;p=r+32|0;E=r+28|0;S=r+24|0;g=r+20|0;y=r+16|0;F=r+12|0;O=r+8|0;A=r+4|0;M=r;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;t[b>>2]=t[(t[u>>2]|0)+48>>2];t[d>>2]=0;t[_>>2]=0;t[p>>2]=0;t[S>>2]=0;t[g>>2]=0;if(!(t[(t[a>>2]|0)+20>>2]|0)){mx(t[u>>2]|0,10,0,0,0);t[n>>2]=-1;R=t[n>>2]|0;s=r;return R|0}t[w>>2]=t[(t[a>>2]|0)+20>>2];t[l>>2]=t[t[w>>2]>>2];t[k>>2]=t[(t[u>>2]|0)+28>>2];if((f[(t[a>>2]|0)+50>>1]&8|0)!=0?(a=(t[u>>2]|0)+28|0,t[a>>2]=t[a>>2]|4,(t[l>>2]|0)==2):0){if(t[(t[u>>2]|0)+60>>2]|0){a=iU(t[u>>2]|0,t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]|0)|0;t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=a}a=t[u>>2]|0;i=t[(t[w>>2]|0)+12>>2]|0;if((t[t[t[t[(t[w>>2]|0)+12>>2]>>2]>>2]>>2]|0)==3)t[o>>2]=gx(a,t[t[i+4>>2]>>2]|0)|0;else t[o>>2]=gx(a,t[t[i>>2]>>2]|0)|0;if((t[o>>2]|0)==0?(t[(t[u>>2]|0)+60>>2]|0)!=0:0){i=iU(t[u>>2]|0,t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]|0)|0;t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=i}t[(t[u>>2]|0)+28>>2]=t[k>>2];t[n>>2]=t[o>>2];R=t[n>>2]|0;s=r;return R|0}t[S>>2]=gAi[t[135744>>2]&511](t[l>>2]<<2)|0;if(!(t[S>>2]|0)){Fx(t[u>>2]|0,189544);t[n>>2]=-1;R=t[n>>2]|0;s=r;return R|0}VY(t[S>>2]|0,0,t[l>>2]<<2|0)|0;t[g>>2]=gAi[t[135744>>2]&511](t[l>>2]<<2)|0;if(!(t[g>>2]|0)){Fx(t[u>>2]|0,189544);t[n>>2]=-1;R=t[n>>2]|0;s=r;return R|0}VY(t[g>>2]|0,0,t[l>>2]<<2|0)|0;t[v>>2]=t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2];t[v>>2]=iU(t[u>>2]|0,t[v>>2]|0)|0;t[m>>2]=t[v>>2];while(1){if(!(t[v>>2]|0))break;t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=t[v>>2];do if((t[(t[w>>2]|0)+4>>2]|0)!=0?(t[(t[w>>2]|0)+8>>2]&1|0)!=0:0){t[y>>2]=0;if((t[(t[v>>2]|0)+4>>2]|0)!=3?(t[(t[v>>2]|0)+4>>2]|0)!=4:0){if((t[(t[v>>2]|0)+4>>2]|0)==1){i=t[(t[w>>2]|0)+4>>2]|0;a=t[(t[v>>2]|0)+8>>2]|0;if(t[(t[v>>2]|0)+36>>2]|0){t[y>>2]=fO(i,a,t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0)|0;if(!(t[y>>2]|0))t[y>>2]=fO(t[(t[w>>2]|0)+4>>2]|0,189536,t[(t[(t[v>>2]|0)+36>>2]|0)+8>>2]|0)|0}else t[y>>2]=fO(i,a,0)|0;if(!(t[y>>2]|0))t[y>>2]=fO(t[(t[w>>2]|0)+4>>2]|0,189536,0)|0}}else t[y>>2]=fO(t[(t[w>>2]|0)+4>>2]|0,188096,0)|0;if(!(t[y>>2]|0)){t[c>>2]=t[l>>2];break}t[c>>2]=(t[y>>2]|0)-1;if((t[(t[w>>2]|0)+8>>2]&2|0)!=0?(t[d>>2]=t[(t[(t[w>>2]|0)+12>>2]|0)+(t[c>>2]<<2)>>2],(WU(t[v>>2]|0,t[(t[d>>2]|0)+4>>2]|0)|0)==0):0)t[c>>2]=t[l>>2]}else N=37;while(0);e:do if((N|0)==37){N=0;t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[l>>2]|0))break e;t[d>>2]=t[(t[(t[w>>2]|0)+12>>2]|0)+(t[c>>2]<<2)>>2];if((t[d>>2]|0)!=0?(WU(t[v>>2]|0,t[(t[d>>2]|0)+4>>2]|0)|0)!=0:0)break e;t[c>>2]=(t[c>>2]|0)+1}}while(0);if((t[c>>2]|0)>=(t[l>>2]|0))break;a=t[v>>2]|0;i=t[c>>2]|0;if(t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]|0){t[(t[(t[g>>2]|0)+(i<<2)>>2]|0)+24>>2]=a;t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]=t[v>>2]}else{t[(t[S>>2]|0)+(i<<2)>>2]=a;t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]=t[v>>2]}a=t[v>>2]|0;if(t[(t[v>>2]|0)+24>>2]|0)t[p>>2]=t[a+24>>2];else t[p>>2]=a;t[v>>2]=iU(t[u>>2]|0,t[(t[v>>2]|0)+24>>2]|0)|0}do if(!(t[o>>2]|0)){t[E>>2]=t[v>>2];t[h>>2]=t[(t[u>>2]|0)+60>>2];t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[l>>2]|0))break;y=MU(t[u>>2]|0,t[h>>2]|0)|0;t[(t[u>>2]|0)+60>>2]=y;if(!(t[(t[u>>2]|0)+60>>2]|0)){N=55;break}t[d>>2]=t[(t[(t[w>>2]|0)+12>>2]|0)+(t[c>>2]<<2)>>2];if(t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]|0){t[_>>2]=t[(t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]|0)+24>>2];t[(t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]|0)+24>>2]=0}t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=t[(t[S>>2]|0)+(t[c>>2]<<2)>>2];t[o>>2]=gx(t[u>>2]|0,t[t[d>>2]>>2]|0)|0;if(t[o>>2]|0)break;y=t[u>>2]|0;if(t[(t[u>>2]|0)+60>>2]|0){t[v>>2]=t[(t[y+60>>2]|0)+4>>2];t[v>>2]=iU(t[u>>2]|0,t[v>>2]|0)|0;yx(t[u>>2]|0,t[h>>2]|0);t[h>>2]=t[(t[u>>2]|0)+60>>2];t[(t[u>>2]|0)+60>>2]=0;if(t[v>>2]|0){N=61;break}}else{if(!(t[y+64>>2]|0)){N=89;break}t[O>>2]=0;t[A>>2]=-1;t[M>>2]=-1;t[F>>2]=0;e:while(1){if((t[F>>2]|0)>=(t[t[(t[u>>2]|0)+64>>2]>>2]|0))break;
	t[v>>2]=t[(t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)+4>>2];t[v>>2]=iU(t[u>>2]|0,t[v>>2]|0)|0;y=(t[O>>2]|0)==0;do if(!(t[v>>2]|0)){if(y){t[M>>2]=t[(t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)+16>>2];t[A>>2]=t[F>>2]}t[O>>2]=1;if((t[(t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)+16>>2]|0)<=(t[M>>2]|0)){t[M>>2]=t[(t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)+16>>2];t[A>>2]=t[F>>2]}if(!(t[M>>2]|0))break e}else if(y){a=t[(t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)+16>>2]|0;if((t[M>>2]|0)==-1){t[M>>2]=a;t[A>>2]=t[F>>2];break}if((a|0)>(t[M>>2]|0))break;t[M>>2]=t[(t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0)+16>>2];t[A>>2]=t[F>>2]}while(0);t[F>>2]=(t[F>>2]|0)+1}do if((t[t[(t[u>>2]|0)+64>>2]>>2]|0)>0){yx(t[u>>2]|0,t[h>>2]|0);if((t[A>>2]|0)!=-1){t[h>>2]=t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[A>>2]<<2)>>2];t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[A>>2]<<2)>>2]=0;break}else{t[h>>2]=t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+((t[t[(t[u>>2]|0)+64>>2]>>2]|0)-1<<2)>>2];t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+((t[t[(t[u>>2]|0)+64>>2]>>2]|0)-1<<2)>>2]=0;y=t[(t[u>>2]|0)+64>>2]|0;t[y>>2]=(t[y>>2]|0)+-1;break}}while(0);t[F>>2]=0;while(1){T=t[u>>2]|0;if((t[F>>2]|0)>=(t[t[(t[u>>2]|0)+64>>2]>>2]|0))break;yx(T,t[(t[(t[(t[u>>2]|0)+64>>2]|0)+8>>2]|0)+(t[F>>2]<<2)>>2]|0);t[F>>2]=(t[F>>2]|0)+1}Ox(T,t[(t[u>>2]|0)+64>>2]|0);t[(t[u>>2]|0)+64>>2]=0;if(!(t[O>>2]|0)){N=85;break}}if(t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]|0)t[(t[(t[g>>2]|0)+(t[c>>2]<<2)>>2]|0)+24>>2]=t[_>>2];t[c>>2]=(t[c>>2]|0)+1}if((N|0)==55)t[o>>2]=-1;else if((N|0)==61){mx(t[u>>2]|0,12,t[(t[v>>2]|0)+8>>2]|0,0,0);t[o>>2]=-1;t[(t[u>>2]|0)+60>>2]=t[h>>2];break}else if((N|0)==85){y=t[u>>2]|0;if(!(t[v>>2]|0))mx(y,12,189560,0,0);else mx(y,12,t[(t[v>>2]|0)+8>>2]|0,0,0);t[o>>2]=-1;t[(t[u>>2]|0)+60>>2]=t[h>>2];break}else if((N|0)==89)t[o>>2]=-1;if(t[(t[u>>2]|0)+60>>2]|0)yx(t[u>>2]|0,t[(t[u>>2]|0)+60>>2]|0);t[(t[u>>2]|0)+60>>2]=t[h>>2];t[(t[(t[u>>2]|0)+60>>2]|0)+4>>2]=t[E>>2];if(t[o>>2]|0){mx(t[u>>2]|0,11,0,0,0);t[o>>2]=-1}}else{mx(t[u>>2]|0,11,0,0,0);t[o>>2]=-1}while(0);t[(t[u>>2]|0)+28>>2]=t[k>>2];t[v>>2]=t[p>>2];while(1){if(!(t[v>>2]|0))break;if((t[v>>2]|0)==(t[m>>2]|0))break;if(!(t[(t[v>>2]|0)+28>>2]|0))break;t[(t[(t[v>>2]|0)+28>>2]|0)+24>>2]=t[v>>2];t[v>>2]=t[(t[v>>2]|0)+28>>2]}if((t[o>>2]|0)==0?(t[(t[u>>2]|0)+48>>2]|0)>(t[b>>2]|0):0)gU(t[u>>2]|0,t[b>>2]|0);pAi[t[135736>>2]&511](t[S>>2]|0);pAi[t[135736>>2]&511](t[g>>2]|0);t[n>>2]=t[o>>2];R=t[n>>2]|0;s=r;return R|0}function NU(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;u=f+44|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+8|0;v=f+4|0;m=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[w>>2]=0;if((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+20>>2]|0)!=0:0){t[h>>2]=t[(t[c>>2]|0)+20>>2];do if(t[(t[h>>2]|0)+12>>2]|0){if((t[(t[c>>2]|0)+36>>2]|0)!=0?(t[t[(t[c>>2]|0)+36>>2]>>2]|0)==6:0){t[b>>2]=RAi[t[(t[h>>2]|0)+12>>2]&511](t[(t[h>>2]|0)+4>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[o>>2]|0,w,t[l>>2]|0)|0;break}t[b>>2]=RAi[t[(t[h>>2]|0)+12>>2]&511](t[(t[h>>2]|0)+4>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[o>>2]|0,0,t[l>>2]|0)|0}else t[b>>2]=-1;while(0);if((t[b>>2]|0)<0){mx(t[a>>2]|0,2,t[(t[c>>2]|0)+8>>2]|0,0,0);if((t[w>>2]|0)!=0&(t[h>>2]|0)!=0?(t[(t[h>>2]|0)+24>>2]|0)!=0:0)EAi[t[(t[h>>2]|0)+24>>2]&511](t[(t[h>>2]|0)+4>>2]|0,t[w>>2]|0);t[u>>2]=-1;_=t[u>>2]|0;s=f;return _|0}do if((t[b>>2]|0)!=1){l=t[a>>2]|0;if((t[b>>2]|0)==2){mx(l,4,t[o>>2]|0,0,1);break}else{mx(l,3,t[(t[c>>2]|0)+8>>2]|0,t[o>>2]|0,1);t[b>>2]=-1;break}}else t[b>>2]=0;while(0);t[d>>2]=t[(t[c>>2]|0)+36>>2];while(1){if(!((t[b>>2]|0)==0&(t[d>>2]|0)!=0))break;if((t[t[d>>2]>>2]|0)!=6)break;if((t[(t[h>>2]|0)+20>>2]|0)!=0?(t[k>>2]=SAi[t[(t[h>>2]|0)+20>>2]&511](t[(t[h>>2]|0)+4>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+8>>2]|0,t[(t[d>>2]|0)+16>>2]|0,t[o>>2]|0,t[w>>2]|0)|0,(t[k>>2]|0)!=0):0)t[b>>2]=-1;t[d>>2]=t[(t[d>>2]|0)+32>>2]}if((t[b>>2]|0)==0?(t[(t[c>>2]|0)+24>>2]|0)!=0:0){t[v>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2];t[m>>2]=t[(t[(t[a>>2]|0)+60>>2]|0)+24>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2]=t[o>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+24>>2]=0;t[b>>2]=TU(t[a>>2]|0,t[(t[c>>2]|0)+24>>2]|0)|0;t[(t[(t[a>>2]|0)+60>>2]|0)+20>>2]=t[v>>2];t[(t[(t[a>>2]|0)+60>>2]|0)+24>>2]=t[m>>2]}if((t[w>>2]|0)!=0&(t[h>>2]|0)!=0?(t[(t[h>>2]|0)+24>>2]|0)!=0:0)EAi[t[(t[h>>2]|0)+24>>2]&511](t[(t[h>>2]|0)+4>>2]|0,t[w>>2]|0);t[u>>2]=t[b>>2];_=t[u>>2]|0;s=f;return _|0}t[u>>2]=-1;_=t[u>>2]|0;s=f;return _|0}function TU(e,i){e=e|0;i=i|0;var r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0;r=s;s=s+96|0;f=r;a=r+92|0;o=r+88|0;c=r+84|0;l=r+80|0;b=r+76|0;k=r+72|0;h=r+68|0;w=r+64|0;d=r+60|0;v=r+56|0;m=r+52|0;_=r+48|0;p=r+44|0;E=r+40|0;S=r+36|0;g=r+32|0;y=r+28|0;F=r+24|0;O=r+20|0;A=r+16|0;M=r+12|0;R=r+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=0;t[k>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2];e:do switch(t[t[c>>2]>>2]|0){case 17:{t[m>>2]=t[(t[c>>2]|0)+24>>2];t[b>>2]=t[(t[o>>2]|0)+28>>2];i=(t[o>>2]|0)+28|0;t[i>>2]=t[i>>2]|1;t[_>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2];while(1){if(!(t[m>>2]|0))break;t[l>>2]=TU(t[o>>2]|0,t[m>>2]|0)|0;if(!(t[l>>2]|0))break;t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]=t[_>>2];t[m>>2]=t[(t[m>>2]|0)+32>>2]}t[(t[o>>2]|0)+28>>2]=t[b>>2];i=t[o>>2]|0;if(t[l>>2]|0){if(t[i+28>>2]&1)break e;Yx(t[o>>2]|0);break e}else{if((t[i+48>>2]|0)<=0)break e;gU(t[o>>2]|0,0);break e}break}case 5:{t[l>>2]=NU(t[o>>2]|0,t[k>>2]|0,t[c>>2]|0,t[(t[(t[o>>2]|0)+60>>2]|0)+4>>2]|0)|0;if(!(t[l>>2]|0))KU(t[o>>2]|0)|0;break}case 16:{t[l>>2]=XU(t[o>>2]|0,t[(t[c>>2]|0)+24>>2]|0)|0;if(!(t[l>>2]|0))N=78;break}case 15:{N=78;break}case 8:{t[p>>2]=t[(t[c>>2]|0)+24>>2];t[E>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2];t[S>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2];t[g>>2]=Yl(t[E>>2]|0)|0;if(!(t[g>>2]|0))t[g>>2]=Yl(188112)|0;if(!(t[g>>2]|0)){mx(t[o>>2]|0,6,0,0,0);t[a>>2]=-1;T=t[a>>2]|0;s=r;return T|0}t[y>>2]=t[g>>2];i:while(1){L=t[y>>2]|0;if(!(u[t[y>>2]>>0]|0))break;do if((u[L>>0]|0|0)!=32){if(9<=(u[t[y>>2]>>0]|0|0)?(u[t[y>>2]>>0]|0|0)<=10:0)break;if((u[t[y>>2]>>0]|0|0)!=13){t[y>>2]=(t[y>>2]|0)+1;continue i}}while(0);n[t[y>>2]>>0]=0;t[y>>2]=(t[y>>2]|0)+1;while(1){do if((u[t[y>>2]>>0]|0|0)!=32){if(9<=(u[t[y>>2]>>0]|0|0)?(u[t[y>>2]>>0]|0|0)<=10:0)break;if((u[t[y>>2]>>0]|0|0)!=13)continue i}while(0);i=t[y>>2]|0;t[y>>2]=i+1;n[i>>0]=0}}t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2]=L;t[y>>2]=t[g>>2];while(1){if(!(u[t[y>>2]>>0]|0))D=(t[y>>2]|0)!=(t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2]|0);else D=0;C=t[y>>2]|0;if(!D)break;t[y>>2]=C+1}t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]=C;while(1){if(!(t[p>>2]|0))break;if((t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]|0)==(t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2]|0))t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]=0;t[l>>2]=TU(t[o>>2]|0,t[p>>2]|0)|0;if(t[l>>2]|0)break;t[p>>2]=t[(t[p>>2]|0)+32>>2]}if(((t[l>>2]|0)==0?(t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]|0)!=0:0)?(t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]|0)!=(t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2]|0):0){mx(t[o>>2]|0,8,t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]|0,0,0);t[l>>2]=-1}pAi[t[135736>>2]&511](t[g>>2]|0);t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]=t[E>>2];t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2]=t[S>>2];break}case 7:{do if(!(Xl(t[k>>2]|0,t[(t[c>>2]|0)+16>>2]|0)|0)){if(!(t[(t[c>>2]|0)+8>>2]|0)){t[d>>2]=Tx(t[o>>2]|0,t[(t[c>>2]|0)+16>>2]|0)|0;t[v>>2]=Tx(t[o>>2]|0,t[k>>2]|0)|0;if(!(!((t[d>>2]|0)==0|(t[v>>2]|0)==0)?(Xl(t[d>>2]|0,t[v>>2]|0)|0)!=0:0))t[l>>2]=-1;if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);if(!(t[v>>2]|0))break;pAi[t[135736>>2]&511](t[v>>2]|0);break}t[w>>2]=t[(t[c>>2]|0)+20>>2];if((t[w>>2]|0)!=0?(t[(t[w>>2]|0)+16>>2]|0)!=0:0)t[l>>2]=wAi[t[(t[w>>2]|0)+16>>2]&511](t[(t[w>>2]|0)+4>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[(t[c>>2]|0)+16>>2]|0,t[(t[c>>2]|0)+4>>2]|0,t[(t[c>>2]|0)+36>>2]|0,t[k>>2]|0,t[t[(t[o>>2]|0)+60>>2]>>2]|0)|0;else t[l>>2]=-1;if((t[l>>2]|0)<0){mx(t[o>>2]|0,5,t[(t[c>>2]|0)+8>>2]|0,0,0);t[a>>2]=-1;T=t[a>>2]|0;s=r;return T|0}if((t[l>>2]|0)==1){t[l>>2]=0;break}else{t[l>>2]=-1;break}}while(0);if(!(t[l>>2]|0))KU(t[o>>2]|0)|0;break}case 0:{if((t[k>>2]|0)!=0?(u[t[k>>2]>>0]|0|0)!=0:0){t[h>>2]=0;while(1){do if((u[(t[k>>2]|0)+(t[h>>2]|0)>>0]|0|0)==32)P=1;else{if(9<=(u[(t[k>>2]|0)+(t[h>>2]|0)>>0]|0|0)?(u[(t[k>>2]|0)+(t[h>>2]|0)>>0]|0|0)<=10:0){P=1;break}P=(u[(t[k>>2]|0)+(t[h>>2]|0)>>0]|0|0)==13}while(0);B=t[h>>2]|0;if(!P)break;t[h>>2]=B+1}if(u[(t[k>>2]|0)+B>>0]|0)t[l>>2]=-1}break}case 18:case 10:{t[R>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[R>>2]|0))break e;t[l>>2]=TU(t[o>>2]|0,t[R>>2]|0)|0;if(t[l>>2]|0)break;t[l>>2]=0;t[R>>2]=t[(t[R>>2]|0)+32>>2]}t[l>>2]=-1;break}case 13:case 11:{i=t[o>>2]|0;if(!(t[(t[c>>2]|0)+24>>2]|0)){mx(i,7,0,0,0);t[l>>2]=-1;break e}else{t[l>>2]=TU(i,t[(t[c>>2]|0)+24>>2]|0)|0;break e}break}case 3:break;case 2:{t[M>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[M>>2]|0))break e;t[l>>2]=TU(t[o>>2]|0,t[M>>2]|0)|0;if(!(t[l>>2]|0))break;t[l>>2]=0;t[M>>2]=t[(t[M>>2]|0)+32>>2]}t[l>>2]=-1;break}case 14:{if((t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]|0)!=0?(u[t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]>>0]|0|0)!=0:0){t[b>>2]=t[(t[o>>2]|0)+28>>2];i=(t[o>>2]|0)+28|0;t[i>>2]=t[i>>2]|1;t[A>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2];t[l>>2]=TU(t[o>>2]|0,t[(t[c>>2]|0)+24>>2]|0)|0;t[(t[o>>2]|0)+28>>2]=t[b>>2];if(!(t[l>>2]|0)){if((t[(t[o>>2]|0)+48>>2]|0)<=0)break e;gU(t[o>>2]|0,0);break e}t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]=t[A>>2];if((t[(t[o>>2]|0)+48>>2]|0)>0)gU(t[o>>2]|0,0);t[l>>2]=0;break e}t[l>>2]=0;break}default:{i=t[33976]|0;e=t[33980]|0;t[f>>2]=189496;t[f+4>>2]=8982;yAi[i&511](e,189464,f);t[l>>2]=-1}}while(0);do if((N|0)==78){if((t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]|0)!=0?(u[t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]>>0]|0|0)!=0:0){t[b>>2]=t[(t[o>>2]|0)+28>>2];f=(t[o>>2]|0)+28|0;t[f>>2]=t[f>>2]|1;t[F>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2];t[O>>2]=0;while(1){if(!(t[F>>2]|0))break;if((t[F>>2]|0)==(t[(t[(t[o>>2]|0)+60>>2]|0)+24>>2]|0))break;if((t[O>>2]|0)==(t[F>>2]|0))break;t[O>>2]=t[F>>2];t[l>>2]=XU(t[o>>2]|0,t[(t[c>>2]|0)+24>>2]|0)|0;if(t[l>>2]|0){N=86;break}t[F>>2]=t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]}if((N|0)==86){t[(t[(t[o>>2]|0)+60>>2]|0)+20>>2]=t[O>>2];t[l>>2]=0}t[(t[o>>2]|0)+28>>2]=t[b>>2];if((t[(t[o>>2]|0)+48>>2]|0)<=0)break;gU(t[o>>2]|0,0);break}t[l>>2]=0}while(0);t[a>>2]=t[l>>2];T=t[a>>2]|0;s=r;return T|0}function LU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+32|0;f=n+16|0;u=n+8|0;a=n+4|0;o=n;t[n+12>>2]=e;t[u>>2]=i;t[a>>2]=r;do if(!((t[u>>2]|0)==0|(t[a>>2]|0)==0)){if((t[u>>2]|0)==(t[a>>2]|0)){t[f>>2]=1;break}if((t[t[u>>2]>>2]|0)!=(t[t[a>>2]>>2]|0)){t[f>>2]=0;break}if((t[(t[u>>2]|0)+4>>2]|0)!=(t[(t[a>>2]|0)+4>>2]|0)){t[f>>2]=0;break}if((t[(t[u>>2]|0)+16>>2]|0)!=(t[(t[a>>2]|0)+16>>2]|0)){t[f>>2]=0;break}if((t[(t[u>>2]|0)+8>>2]|0)!=(t[(t[a>>2]|0)+8>>2]|0)){t[f>>2]=0;break}if((t[(t[u>>2]|0)+24>>2]|0)!=(t[(t[a>>2]|0)+24>>2]|0)){t[f>>2]=0;break}if((t[(t[u>>2]|0)+20>>2]|0)!=(t[(t[a>>2]|0)+20>>2]|0)?(Xl(t[(t[u>>2]|0)+20>>2]|0,t[(t[a>>2]|0)+20>>2]|0)|0)==0:0){t[f>>2]=0;break}t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[u>>2]|0)+8>>2]|0)){c=23;break}if((t[(t[(t[u>>2]|0)+28>>2]|0)+(t[o>>2]<<2)>>2]|0)!=(t[(t[(t[a>>2]|0)+28>>2]|0)+(t[o>>2]<<2)>>2]|0)){c=21;break}t[o>>2]=(t[o>>2]|0)+1}if((c|0)==21){t[f>>2]=0;break}else if((c|0)==23){t[f>>2]=1;break}}else t[f>>2]=0;while(0);s=n;return t[f>>2]|0}function DU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[f>>2]|0)+108>>2]|0)==0?(t[(t[f>>2]|0)+104>>2]=4,t[(t[f>>2]|0)+100>>2]=0,i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+104>>2]<<2)|0,t[(t[f>>2]|0)+108>>2]=i,(t[(t[f>>2]|0)+108>>2]|0)==0):0){lx(t[f>>2]|0,196496);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[f>>2]|0)+100>>2]|0)>=(t[(t[f>>2]|0)+104>>2]|0)?(i=(t[f>>2]|0)+104|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+108>>2]|0,t[(t[f>>2]|0)+104>>2]<<2)|0,t[(t[f>>2]|0)+108>>2]=i,(t[(t[f>>2]|0)+108>>2]|0)==0):0){lx(t[f>>2]|0,196496);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[(t[(t[f>>2]|0)+108>>2]|0)+(t[(t[f>>2]|0)+100>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+96>>2]=t[u>>2];u=(t[f>>2]|0)+100|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;a=t[n>>2]|0;s=r;return a|0}function CU(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+100>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+100|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+100>>2]|0)>0)t[(t[n>>2]|0)+96>>2]=t[(t[(t[n>>2]|0)+108>>2]|0)+((t[e+100>>2]|0)-1<<2)>>2];else t[e+96>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+108>>2]|0)+(t[(t[n>>2]|0)+100>>2]<<2)>>2];t[(t[(t[n>>2]|0)+108>>2]|0)+(t[(t[n>>2]|0)+100>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function PU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if((t[(t[f>>2]|0)+124>>2]|0)==0?(t[(t[f>>2]|0)+120>>2]=4,t[(t[f>>2]|0)+116>>2]=0,i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+120>>2]<<2)|0,t[(t[f>>2]|0)+124>>2]=i,(t[(t[f>>2]|0)+124>>2]|0)==0):0){lx(t[f>>2]|0,196088);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if((t[(t[f>>2]|0)+116>>2]|0)>=(t[(t[f>>2]|0)+120>>2]|0)?(i=(t[f>>2]|0)+120|0,t[i>>2]=t[i>>2]<<1,i=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+124>>2]|0,t[(t[f>>2]|0)+120>>2]<<2)|0,t[(t[f>>2]|0)+124>>2]=i,(t[(t[f>>2]|0)+124>>2]|0)==0):0){lx(t[f>>2]|0,196088);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}t[(t[(t[f>>2]|0)+124>>2]|0)+(t[(t[f>>2]|0)+116>>2]<<2)>>2]=t[u>>2];t[(t[f>>2]|0)+112>>2]=t[u>>2];u=(t[f>>2]|0)+116|0;f=t[u>>2]|0;t[u>>2]=f+1;t[n>>2]=f;a=t[n>>2]|0;s=r;return a|0}function BU(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if((t[(t[n>>2]|0)+116>>2]|0)<=0){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[n>>2]|0)+116|0;t[e>>2]=(t[e>>2]|0)+-1;e=t[n>>2]|0;if((t[(t[n>>2]|0)+116>>2]|0)>0)t[(t[n>>2]|0)+112>>2]=t[(t[(t[n>>2]|0)+124>>2]|0)+((t[e+116>>2]|0)-1<<2)>>2];else t[e+112>>2]=0;t[f>>2]=t[(t[(t[n>>2]|0)+124>>2]|0)+(t[(t[n>>2]|0)+116>>2]<<2)>>2];t[(t[(t[n>>2]|0)+124>>2]|0)+(t[(t[n>>2]|0)+116>>2]<<2)>>2]=0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}function IU(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;u=f+36|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[u>>2]=e;t[f+32>>2]=i;t[a>>2]=r;t[o>>2]=n;t[c>>2]=0;t[l>>2]=t[a>>2];while(1){if(!(t[l>>2]|0))break;t[b>>2]=t[(t[l>>2]|0)+24>>2];if(((((t[o>>2]|0)==0&(t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(t[(t[l>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,190048)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[c>>2]=1;iy(t[l>>2]|0);ry(t[l>>2]|0)}else d=9;do if((d|0)==9){d=0;if(((((t[o>>2]|0)!=0&(t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(t[(t[l>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,195016)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[k>>2]=cF(t[l>>2]|0,192176)|0;HU(t[k>>2]|0);if(!(t[k>>2]|0))break;if(Xl(t[o>>2]|0,t[k>>2]|0)|0){t[c>>2]=1;iy(t[l>>2]|0);ry(t[l>>2]|0)}pAi[t[135736>>2]&511](t[k>>2]|0);break}if((((((((((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)?(t[(t[l>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,195024)|0)!=0:0)?(Xl(t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)?(t[h>>2]=0,t[w>>2]=t[(t[l>>2]|0)+52>>2],(t[w>>2]|0)!=0):0)?(t[(t[w>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[w>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(Xl(t[(t[(t[(t[w>>2]|0)+8>>2]|0)+12>>2]|0)+8>>2]|0,190264)|0)!=0:0)?(a=t[u>>2]|0,n=t[h>>2]|0,r=t[(eF(t[(t[w>>2]|0)+8>>2]|0)|0)+12>>2]|0,(IU(a,n,r,t[o>>2]|0)|0)==1):0)t[c>>2]=1}while(0);t[l>>2]=t[b>>2]}s=f;return t[c>>2]|0}function HU(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;a=i;t[r>>2]=e;t[f>>2]=t[r>>2];t[a>>2]=t[r>>2];if(!(t[r>>2]|0)){s=i;return}while(1){do if((u[t[a>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[a>>2]>>0]|0|0)==13}while(0);c=t[a>>2]|0;if(!o)break;t[a>>2]=c+1}if((c|0)==(t[f>>2]|0)){while(1){if(u[t[a>>2]>>0]|0){do if((u[t[a>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[a>>2]>>0]|0|0)==13}while(0);b=l^1}else b=0;c=t[a>>2]|0;if(b){t[a>>2]=c+1;continue}if(!(u[c>>0]|0)){k=46;break}t[f>>2]=t[a>>2];while(1){do if((u[t[a>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[a>>2]>>0]|0|0)==13}while(0);w=t[a>>2]|0;if(!h)break;t[a>>2]=w+1}if(!(u[w>>0]|0))break}if((k|0)==46){s=i;return}n[t[f>>2]>>0]=0;s=i;return}while(1){if(u[t[a>>2]>>0]|0){do if((u[t[a>>2]>>0]|0|0)==32)d=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){d=1;break}d=(u[t[a>>2]>>0]|0|0)==13}while(0);v=d^1}else v=0;w=t[a>>2]|0;if(v){t[a>>2]=w+1;h=n[w>>0]|0;b=t[f>>2]|0;t[f>>2]=b+1;n[b>>0]=h;continue}if(!(u[w>>0]|0)){k=36;break}while(1){do if((u[t[a>>2]>>0]|0|0)==32)m=1;else{if(9<=(u[t[a>>2]>>0]|0|0)?(u[t[a>>2]>>0]|0|0)<=10:0){m=1;break}m=(u[t[a>>2]>>0]|0|0)==13}while(0);_=t[a>>2]|0;if(!m)break;t[a>>2]=_+1}if(!(u[_>>0]|0)){k=44;break}w=t[a>>2]|0;t[a>>2]=w+1;h=n[w>>0]|0;w=t[f>>2]|0;t[f>>2]=w+1;n[w>>0]=h}if((k|0)==36){n[t[f>>2]>>0]=0;s=i;return}else if((k|0)==44){n[t[f>>2]>>0]=0;s=i;return}}function xU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[a>>2]=cF(t[u>>2]|0,192176)|0;do if(t[a>>2]|0){HU(t[a>>2]|0);if(Vg(t[a>>2]|0,0)|0)bx(t[f>>2]|0,t[u>>2]|0,1049,195200,t[a>>2]|0,0);t[l>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[l>>2]|0)){pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}t[t[l>>2]>>2]=10;t[(t[l>>2]|0)+8>>2]=t[a>>2];i=t[f>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0))bx(i,t[u>>2]|0,1012,195240,0,0);else{t[b>>2]=t[i+44>>2];t[(t[f>>2]|0)+44>>2]=t[a>>2];i=lU(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0,0)|0;t[(t[l>>2]|0)+24>>2]=i;t[(t[f>>2]|0)+44>>2]=t[b>>2]}if(!(t[(t[(t[f>>2]|0)+24>>2]|0)+24>>2]|0)){i=WF(10)|0;t[(t[(t[f>>2]|0)+24>>2]|0)+24>>2]=i}i=t[f>>2]|0;if(!(t[(t[(t[f>>2]|0)+24>>2]|0)+24>>2]|0)){bx(i,t[u>>2]|0,1011,195264,0,0);t[o>>2]=-1;break}t[c>>2]=ZF(t[(t[i+24>>2]|0)+24>>2]|0,t[a>>2]|0,t[l>>2]|0)|0;if((t[c>>2]|0)<0){t[k>>2]=rO(t[(t[(t[f>>2]|0)+24>>2]|0)+24>>2]|0,t[a>>2]|0)|0;if(!(t[k>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1011,195304,t[a>>2]|0,0);t[o>>2]=-1;break}while(1){if(!(t[(t[k>>2]|0)+44>>2]|0))break;t[k>>2]=t[(t[k>>2]|0)+44>>2]}t[(t[k>>2]|0)+44>>2]=t[l>>2]}}else bx(t[f>>2]|0,t[u>>2]|0,1014,195176,0,0);while(0);t[n>>2]=t[o>>2];h=t[n>>2]|0;s=r;return h|0}function UU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[c>>2]=0;t[a>>2]=t[(t[u>>2]|0)+52>>2];if(!(t[a>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1042,195072,0,0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}t[o>>2]=eF(t[(t[a>>2]|0)+8>>2]|0)|0;if(!(t[o>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1022,195104,0,0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}if(!(Xl(t[(t[o>>2]|0)+8>>2]|0,190264)|0)){bx(t[f>>2]|0,t[u>>2]|0,1038,195136,0,0);t[n>>2]=-1;b=t[n>>2]|0;s=r;return b|0}if((t[(t[o>>2]|0)+12>>2]|0)!=0?(t[l>>2]=uU(t[f>>2]|0,t[(t[o>>2]|0)+12>>2]|0)|0,(t[l>>2]|0)!=0):0)t[c>>2]=-1;if((t[(t[u>>2]|0)+12>>2]|0)!=0?(t[l>>2]=uU(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0,(t[l>>2]|0)!=0):0)t[c>>2]=-1;t[n>>2]=t[c>>2];b=t[n>>2]|0;s=r;return b|0}function zU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}t[t[a>>2]>>2]=4;t[(t[a>>2]|0)+28>>2]=t[(t[f>>2]|0)+48>>2];t[l>>2]=t[(t[u>>2]|0)+12>>2];i=t[f>>2]|0;if(!(t[l>>2]|0)){bx(i,t[u>>2]|0,1017,194024,0,0);t[n>>2]=t[a>>2];k=t[n>>2]|0;s=r;return k|0}t[o>>2]=ZU(i,t[l>>2]|0,t[a>>2]|0)|0;if(t[o>>2]|0)t[l>>2]=t[(t[l>>2]|0)+24>>2];i=t[f>>2]|0;if(!(t[l>>2]|0)){bx(i,t[u>>2]|0,1020,194080,0,0);t[n>>2]=t[a>>2];k=t[n>>2]|0;s=r;return k|0}t[b>>2]=t[i+44>>2];t[(t[f>>2]|0)+44>>2]=0;t[c>>2]=0;while(1){if(!(t[l>>2]|0))break;t[o>>2]=jU(t[f>>2]|0,t[l>>2]|0)|0;e:do if(t[o>>2]|0){t[(t[o>>2]|0)+28>>2]=t[a>>2];switch(t[t[o>>2]>>2]|0){case 20:{bx(t[f>>2]|0,t[u>>2]|0,1018,194128,0,0);break e;break}case 9:{t[(t[o>>2]|0)+32>>2]=t[(t[a>>2]|0)+36>>2];t[(t[a>>2]|0)+36>>2]=t[o>>2];break e;break}case 19:case 18:case 17:case 14:case 16:case 15:case 10:case 12:case 13:case 11:case 8:case 7:case 5:case 4:case 3:case 1:case 0:{if(!(t[c>>2]|0)){i=t[o>>2]|0;t[c>>2]=i;t[(t[a>>2]|0)+24>>2]=i;break e}do if((t[t[c>>2]>>2]|0)==4?(t[(t[a>>2]|0)+24>>2]|0)==(t[c>>2]|0):0){i=dx(t[f>>2]|0,t[u>>2]|0)|0;t[(t[a>>2]|0)+24>>2]=i;if(t[(t[a>>2]|0)+24>>2]|0){t[t[(t[a>>2]|0)+24>>2]>>2]=18;t[(t[(t[a>>2]|0)+24>>2]|0)+24>>2]=t[c>>2];break}else{t[(t[a>>2]|0)+24>>2]=t[c>>2];break}}while(0);t[(t[c>>2]|0)+32>>2]=t[o>>2];t[c>>2]=t[o>>2];break e;break}case-1:{bx(t[f>>2]|0,t[u>>2]|0,1018,194272,0,0);break e;break}case 6:{bx(t[f>>2]|0,t[u>>2]|0,1018,194176,0,0);break e;break}case 2:{bx(t[f>>2]|0,t[u>>2]|0,1018,194224,0,0);break e;break}default:break e}}while(0);t[l>>2]=t[(t[l>>2]|0)+24>>2]}t[(t[f>>2]|0)+44>>2]=t[b>>2];t[n>>2]=t[a>>2];k=t[n>>2]|0;s=r;return k|0}function jU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+48|0;n=r+44|0;f=r+40|0;u=r+36|0;a=r+32|0;o=r+28|0;c=r+24|0;l=r+20|0;b=r+16|0;k=r+12|0;h=r+8|0;w=r+4|0;d=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if(!(t[u>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189864)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)t[a>>2]=zU(t[f>>2]|0,t[u>>2]|0)|0;else m=9;e:do if((m|0)==9){if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189904)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=JU(t[f>>2]|0,t[u>>2]|0)|0;break}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189824)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}else{t[t[a>>2]>>2]=0;if(!(t[(t[u>>2]|0)+12>>2]|0))break;bx(t[f>>2]|0,t[u>>2]|0,1025,192096,0,0);break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189856)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}else{t[t[a>>2]>>2]=3;if(!(t[(t[u>>2]|0)+12>>2]|0))break;bx(t[f>>2]|0,t[u>>2]|0,1109,192128,0,0);break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189984)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=15;i=t[f>>2]|0;e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(i,e,1023,192152,t[(t[u>>2]|0)+8>>2]|0,0);break}else{_=lU(i,t[e+12>>2]|0,1)|0;t[(t[a>>2]|0)+24>>2]=_;break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,19e4)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=16;_=t[f>>2]|0;e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(_,e,1023,192152,t[(t[u>>2]|0)+8>>2]|0,0);break}else{i=lU(_,t[e+12>>2]|0,1)|0;t[(t[a>>2]|0)+24>>2]=i;break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189968)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=14;i=t[f>>2]|0;e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(i,e,1023,192152,t[(t[u>>2]|0)+8>>2]|0,0);break}else{_=lU(i,t[e+12>>2]|0,1)|0;t[(t[a>>2]|0)+24>>2]=_;break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,190016)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=17;_=t[f>>2]|0;e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(_,e,1023,192152,t[(t[u>>2]|0)+8>>2]|0,0);break}else{i=lU(_,t[e+12>>2]|0,0)|0;t[(t[a>>2]|0)+24>>2]=i;break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,190024)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=18;i=t[f>>2]|0;e=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(i,e,1023,192152,t[(t[u>>2]|0)+8>>2]|0,0);break}else{_=lU(i,t[e+12>>2]|0,0)|0;t[(t[a>>2]|0)+24>>2]=_;break}}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189928)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=11;_=cF(t[u>>2]|0,192176)|0;t[(t[a>>2]|0)+8>>2]=_;do if(!(t[(t[a>>2]|0)+8>>2]|0))bx(t[f>>2]|0,t[u>>2]|0,1102,192184,0,0);else{HU(t[(t[a>>2]|0)+8>>2]|0);if(!(Vg(t[(t[a>>2]|0)+8>>2]|0,0)|0))break;bx(t[f>>2]|0,t[u>>2]|0,1100,192208,t[(t[a>>2]|0)+8>>2]|0,0)}while(0);if(t[(t[u>>2]|0)+12>>2]|0)bx(t[f>>2]|0,t[u>>2]|0,1103,192240,0,0);if(!(t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]|0)){_=WF(10)|0;t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]=_}_=t[f>>2]|0;if(!(t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]|0)){bx(_,t[u>>2]|0,1098,192264,0,0);t[a>>2]=0;break}t[o>>2]=ZF(t[(t[_+24>>2]|0)+28>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[a>>2]|0)|0;if((t[o>>2]|0)>=0)break;t[c>>2]=rO(t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if(t[c>>2]|0){t[(t[a>>2]|0)+44>>2]=t[(t[c>>2]|0)+44>>2];t[(t[c>>2]|0)+44>>2]=t[a>>2];break}_=t[f>>2]|0;e=t[u>>2]|0;if(t[(t[a>>2]|0)+8>>2]|0)bx(_,e,1098,192304,t[(t[a>>2]|0)+8>>2]|0,0);else bx(_,e,1098,192336,0,0);t[a>>2]=0;break}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,192360)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=QU(t[f>>2]|0,t[u>>2]|0)|0;break}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189888)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=$U(t[f>>2]|0,t[u>>2]|0)|0;break}if(((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,189896)|0)!=0:0)?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=8;e=t[f>>2]|0;_=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(e,_,1023,192152,t[(t[u>>2]|0)+8>>2]|0,0);break}else{i=lU(e,t[_+12>>2]|0,0)|0;t[(t[a>>2]|0)+24>>2]=i;break}}do if((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,190032)|0)!=0:0){if(!(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0))break;t[a>>2]=ez(t[f>>2]|0,t[u>>2]|0)|0;break e}while(0);do if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(t[(t[u>>2]|0)+4>>2]|0)==1:0){if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,189936)|0))break;if(!(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0))break;t[a>>2]=iz(t[f>>2]|0,t[u>>2]|0)|0;break e}while(0);do if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+36>>2]|0)!=0:0){if((t[(t[u>>2]|0)+4>>2]|0)!=1)break;if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,189832)|0))break;if(!(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0))break;t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}else{t[t[a>>2]>>2]=1;if(!(t[(t[u>>2]|0)+12>>2]|0))break e;bx(t[f>>2]|0,t[u>>2]|0,1055,192368,0,0);break e}}while(0);do if(t[u>>2]|0){if(!(t[(t[u>>2]|0)+36>>2]|0))break;if((t[(t[u>>2]|0)+4>>2]|0)!=1)break;if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,190264)|0))break;if(!(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0))break;t[k>>2]=t[(t[f>>2]|0)+28>>2];t[b>>2]=t[(t[f>>2]|0)+24>>2];t[(t[f>>2]|0)+28>>2]=t[b>>2];t[l>>2]=Px(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0;if(t[b>>2]|0){t[(t[f>>2]|0)+24>>2]=t[b>>2];t[(t[f>>2]|0)+28>>2]=t[k>>2]}if(t[l>>2]|0){t[a>>2]=t[(t[l>>2]|0)+12>>2];break e}else{t[a>>2]=0;break e}}while(0);do if(t[u>>2]|0){if(!(t[(t[u>>2]|0)+36>>2]|0))break;if((t[(t[u>>2]|0)+4>>2]|0)!=1)break;if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,189952)|0))break;if(!(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0))break;i=t[f>>2]|0;_=t[u>>2]|0;if(!(t[(t[f>>2]|0)+28>>2]|0)){bx(i,_,1063,192424,0,0);t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[a>>2]=dx(i,_)|0;if(!(t[a>>2]|0)){t[n>>2]=0;v=t[n>>2]|0;s=r;return v|0}t[t[a>>2]>>2]=13;_=cF(t[u>>2]|0,192176)|0;t[(t[a>>2]|0)+8>>2]=_;do if(!(t[(t[a>>2]|0)+8>>2]|0))bx(t[f>>2]|0,t[u>>2]|0,1062,192472,0,0);else{HU(t[(t[a>>2]|0)+8>>2]|0);if(!(Vg(t[(t[a>>2]|0)+8>>2]|0,0)|0))break;bx(t[f>>2]|0,t[u>>2]|0,1061,192496,t[(t[a>>2]|0)+8>>2]|0,0)}while(0);if(t[(t[u>>2]|0)+12>>2]|0)bx(t[f>>2]|0,t[u>>2]|0,1064,192536,0,0);if(!(t[(t[(t[f>>2]|0)+28>>2]|0)+28>>2]|0)){_=WF(10)|0;t[(t[(t[f>>2]|0)+28>>2]|0)+28>>2]=_}if(!(t[(t[(t[f>>2]|0)+28>>2]|0)+28>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1060,192264,0,0);t[a>>2]=0;break e}if(!(t[(t[a>>2]|0)+8>>2]|0))break e;t[h>>2]=ZF(t[(t[(t[f>>2]|0)+28>>2]|0)+28>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[a>>2]|0)|0;if((t[h>>2]|0)>=0)break e;t[w>>2]=rO(t[(t[(t[f>>2]|0)+28>>2]|0)+28>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if(!(t[w>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1060,192560,t[(t[a>>2]|0)+8>>2]|0,0);t[a>>2]=0;break e}else{t[(t[a>>2]|0)+44>>2]=t[(t[w>>2]|0)+44>>2];t[(t[w>>2]|0)+44>>2]=t[a>>2];break e}}while(0);do if(t[u>>2]|0){if(!(t[(t[u>>2]|0)+36>>2]|0))break;if((t[(t[u>>2]|0)+4>>2]|0)!=1)break;if(!(Xl(t[(t[u>>2]|0)+8>>2]|0,192608)|0))break;if(!(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0))break;_=t[f>>2]|0;i=t[u>>2]|0;if(!(t[(t[u>>2]|0)+12>>2]|0)){bx(_,i,1023,192616,0,0);t[a>>2]=0;break e}t[a>>2]=ez(_,i)|0;if(!(t[a>>2]|0))break e;do if(t[(t[a>>2]|0)+24>>2]|0){if(!(t[(t[(t[a>>2]|0)+24>>2]|0)+32>>2]|0))break;t[d>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[d>>2]|0))break;t[t[d>>2]>>2]=18;t[(t[d>>2]|0)+24>>2]=t[(t[a>>2]|0)+24>>2];t[(t[a>>2]|0)+24>>2]=t[d>>2]}while(0);t[d>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(t[d>>2]|0){t[t[d>>2]>>2]=3;t[(t[d>>2]|0)+32>>2]=t[(t[a>>2]|0)+24>>2];t[(t[a>>2]|0)+24>>2]=t[d>>2];break e}t[n>>2]=t[a>>2];v=t[n>>2]|0;s=r;return v|0}while(0);bx(t[f>>2]|0,t[u>>2]|0,1115,192632,t[(t[u>>2]|0)+8>>2]|0,0);t[a>>2]=0}while(0);t[n>>2]=t[a>>2];v=t[n>>2]|0;s=r;return v|0}function VU(e){e=e|0;var i=0,r=0,n=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+16|0;n=i+12|0;u=i+8|0;a=i+4|0;o=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}if(f[(t[n>>2]|0)+50>>1]&1){t[r>>2]=1;c=t[r>>2]|0;s=i;return c|0}if(f[(t[n>>2]|0)+50>>1]&2){t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}e:do switch(t[t[n>>2]>>2]|0){case 16:case 13:case 12:case 11:case 10:case-1:{t[u>>2]=VU(t[(t[n>>2]|0)+24>>2]|0)|0;break}case 9:case 8:case 7:case 6:case 5:case 4:case 1:case 2:{t[u>>2]=0;break}case 3:case 0:{t[u>>2]=1;break}case 18:case 19:case 20:{t[o>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[o>>2]|0))break;t[u>>2]=VU(t[o>>2]|0)|0;if((t[u>>2]|0)!=1)break e;t[o>>2]=t[(t[o>>2]|0)+32>>2]}t[r>>2]=1;c=t[r>>2]|0;s=i;return c|0}case 17:{t[a>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[a>>2]|0))break;t[u>>2]=VU(t[a>>2]|0)|0;if(t[u>>2]|0)break e;t[a>>2]=t[(t[a>>2]|0)+32>>2]}t[u>>2]=0;break}default:{t[r>>2]=-1;c=t[r>>2]|0;s=i;return c|0}}while(0);if(!(t[u>>2]|0)){a=(t[n>>2]|0)+50|0;f[a>>1]=f[a>>1]|2}if((t[u>>2]|0)==1){a=(t[n>>2]|0)+50|0;f[a>>1]=f[a>>1]|1}t[r>>2]=t[u>>2];c=t[r>>2]|0;s=i;return c|0}function qU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=0;while(1){if(!(t[f>>2]|0)){a=5;break}t[u>>2]=TU(t[n>>2]|0,t[f>>2]|0)|0;if(t[u>>2]|0){a=5;break}t[f>>2]=t[(t[f>>2]|0)+32>>2]}if((a|0)==5){s=r;return t[u>>2]|0}return 0}function YU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;n=s;s=s+48|0;f=n;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;if((t[(t[c>>2]|0)+8>>2]|0)!=0?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[(t[l>>2]|0)+8>>2]|0)|0)==0:0){t[a>>2]=0;
	w=t[a>>2]|0;s=n;return w|0}do if(t[(t[c>>2]|0)+12>>2]|0){r=t[(t[l>>2]|0)+36>>2]|0;if(!(u[t[(t[c>>2]|0)+12>>2]>>0]|0)){if(!r)break;t[a>>2]=0;w=t[a>>2]|0;s=n;return w|0}if((r|0)!=0?(Xl(t[(t[c>>2]|0)+12>>2]|0,t[(t[(t[l>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)break;t[a>>2]=0;w=t[a>>2]|0;s=n;return w|0}while(0);if(!(t[(t[c>>2]|0)+40>>2]|0)){t[a>>2]=1;w=t[a>>2]|0;s=n;return w|0}t[c>>2]=t[(t[c>>2]|0)+40>>2];r=t[c>>2]|0;e:do if((t[t[c>>2]>>2]|0)==2){t[k>>2]=t[r+24>>2];while(1){if(!(t[k>>2]|0))break e;t[b>>2]=YU(t[o>>2]|0,t[k>>2]|0,t[l>>2]|0)|0;if((t[b>>2]|0)==1){d=17;break}if((t[b>>2]|0)<0){d=19;break}t[k>>2]=t[(t[k>>2]|0)+32>>2]}if((d|0)==17){t[a>>2]=0;w=t[a>>2]|0;s=n;return w|0}else if((d|0)==19){t[a>>2]=t[b>>2];w=t[a>>2]|0;s=n;return w|0}}else{if((t[r>>2]|0)!=17){i=t[33976]|0;e=t[33980]|0;t[f>>2]=189496;t[f+4>>2]=9070;yAi[i&511](e,189464,f);break}t[h>>2]=t[(t[c>>2]|0)+40>>2];while(1){if(!(t[h>>2]|0)){d=29;break}t[b>>2]=YU(t[o>>2]|0,t[h>>2]|0,t[l>>2]|0)|0;if((t[b>>2]|0)==1){d=25;break}if((t[b>>2]|0)<0){d=27;break}t[h>>2]=t[(t[h>>2]|0)+32>>2]}if((d|0)==25){t[a>>2]=1;w=t[a>>2]|0;s=n;return w|0}else if((d|0)==27){t[a>>2]=t[b>>2];w=t[a>>2]|0;s=n;return w|0}else if((d|0)==29){t[a>>2]=0;w=t[a>>2]|0;s=n;return w|0}}while(0);t[a>>2]=1;w=t[a>>2]|0;s=n;return w|0}function GU(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;a=f;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+4|0;t[f+28>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=t[l>>2];t[k>>2]=t[c>>2];if(!(t[b>>2]|0)){c=t[v>>2]|0;t[a>>2]=t[o>>2];xe(c|0,189616,a|0)|0;s=f;return}if(!(t[k>>2]|0)){if((u[t[o>>2]>>0]|0|0)==35){s=f;return}c=t[v>>2]|0;t[a>>2]=t[o>>2];xe(c|0,189648,a|0)|0;if(!(t[b>>2]|0)){s=f;return}if(t[(t[b>>2]|0)+40>>2]|0){s=f;return}t[(t[b>>2]|0)+40>>2]=37;s=f;return}if((t[b>>2]|0)==0|(t[k>>2]|0)==0){c=t[v>>2]|0;t[a>>2]=t[o>>2];xe(c|0,189680,a|0)|0;if(!(t[b>>2]|0)){s=f;return}if(t[(t[b>>2]|0)+40>>2]|0){s=f;return}t[(t[b>>2]|0)+40>>2]=37;s=f;return}if((t[t[k>>2]>>2]|0)!=4){c=t[v>>2]|0;t[a>>2]=t[o>>2];xe(c|0,189712,a|0)|0;if(t[(t[b>>2]|0)+40>>2]|0){s=f;return}t[(t[b>>2]|0)+40>>2]=37;s=f;return}else{t[h>>2]=gx(t[b>>2]|0,t[k>>2]|0)|0;if(!(t[h>>2]|0)){s=f;return}t[(t[b>>2]|0)+112>>2]=t[h>>2];s=f;return}}function WU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}i=t[o>>2]|0;t[o>>2]=i+1;t[a>>2]=t[(t[u>>2]|0)+(i<<2)>>2];e:while(1){if(!(t[a>>2]|0)){b=14;break}if((t[(t[f>>2]|0)+4>>2]|0)==1?(t[t[a>>2]>>2]|0)==4:0){t[c>>2]=FU(0,t[a>>2]|0,t[f>>2]|0)|0;if((t[c>>2]|0)==1){b=8;break}}else b=9;do if((b|0)==9){b=0;if((t[(t[f>>2]|0)+4>>2]|0)!=3?(t[(t[f>>2]|0)+4>>2]|0)!=4:0)break;if((t[t[a>>2]>>2]|0)==3){b=12;break e}}while(0);i=t[o>>2]|0;t[o>>2]=i+1;t[a>>2]=t[(t[u>>2]|0)+(i<<2)>>2]}if((b|0)==8){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((b|0)==12){t[n>>2]=1;l=t[n>>2]|0;s=r;return l|0}else if((b|0)==14){t[n>>2]=0;l=t[n>>2]|0;s=r;return l|0}return 0}function KU(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[(t[(t[n>>2]|0)+60>>2]|0)+20>>2];if((t[f>>2]|0)!=0?(t[(t[(t[n>>2]|0)+60>>2]|0)+24>>2]|0)!=0:0){while(1){if(!(u[t[f>>2]>>0]|0))break;t[f>>2]=(t[f>>2]|0)+1}while(1){if((t[f>>2]|0)!=(t[(t[(t[n>>2]|0)+60>>2]|0)+24>>2]|0))a=(u[t[f>>2]>>0]|0|0)==0;else a=0;o=t[f>>2]|0;if(!a)break;t[f>>2]=o+1}if((o|0)==(t[(t[(t[n>>2]|0)+60>>2]|0)+24>>2]|0))t[(t[(t[n>>2]|0)+60>>2]|0)+20>>2]=0;else t[(t[(t[n>>2]|0)+60>>2]|0)+20>>2]=t[f>>2];t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}t[(t[(t[n>>2]|0)+60>>2]|0)+20>>2]=0;t[(t[(t[n>>2]|0)+60>>2]|0)+24>>2]=0;t[r>>2]=0;c=t[r>>2]|0;s=i;return c|0}function XU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=0;while(1){if(!(t[f>>2]|0)){a=5;break}t[u>>2]=TU(t[n>>2]|0,t[f>>2]|0)|0;if(t[u>>2]|0){a=5;break}t[f>>2]=t[(t[f>>2]|0)+32>>2]}if((a|0)==5){s=r;return t[u>>2]|0}return 0}function ZU(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;n=s;s=s+48|0;f=n+32|0;a=n+28|0;o=n+24|0;c=n+20|0;l=n+16|0;b=n+12|0;k=n+8|0;h=n+4|0;w=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=t[c>>2];if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,192176)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)d=16;else d=6;do if((d|0)==6){if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,193584)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){d=16;break}if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,193592)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)d=16}while(0);do if(((d|0)==16?(t[t[c>>2]>>2]|0)!=4:0)?(t[t[c>>2]>>2]|0)!=9:0){t[l>>2]=dx(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[(t[l>>2]|0)+28>>2]=t[c>>2];r=t[l>>2]|0;if(t[(t[a>>2]|0)+32>>2]&1){t[r>>2]=9;break}else{t[r>>2]=4;break}}while(0);if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,192176)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[k>>2]=sF(t[o>>2]|0)|0;HU(t[k>>2]|0);do if(Vg(t[k>>2]|0,0)|0){r=t[a>>2]|0;i=t[o>>2]|0;if(t[(t[o>>2]|0)+20>>2]|0){bx(r,i,1019,193600,t[(t[(t[o>>2]|0)+20>>2]|0)+8>>2]|0,t[k>>2]|0);break}else{bx(r,i,1019,193640,t[k>>2]|0,0);break}}while(0);t[(t[l>>2]|0)+8>>2]=t[k>>2];t[k>>2]=cF(t[o>>2]|0,192672)|0;t[(t[l>>2]|0)+12>>2]=t[k>>2];if(((t[k>>2]|0)!=0?(t[(t[a>>2]|0)+32>>2]&1|0)!=0:0)?(Xl(t[k>>2]|0,193672)|0)!=0:0)bx(t[a>>2]|0,t[o>>2]|0,1122,193704,t[k>>2]|0,0);if((((t[k>>2]|0)!=0?(t[(t[a>>2]|0)+32>>2]&1|0)!=0:0)?(u[t[k>>2]>>0]|0|0)==0:0)?(Xl(t[(t[l>>2]|0)+8>>2]|0,193752)|0)!=0:0)bx(t[a>>2]|0,t[o>>2]|0,1121,193760,t[k>>2]|0,0)}else d=39;e:do if((d|0)==39){if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,193584)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[(t[l>>2]|0)+8>>2]=0;t[(t[l>>2]|0)+12>>2]=0;if(!(t[(t[o>>2]|0)+12>>2]|0))break;k=rz(t[a>>2]|0,t[(t[o>>2]|0)+12>>2]|0,(t[t[c>>2]>>2]|0)==9&1)|0;t[(t[l>>2]|0)+40>>2]=k;break}if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,193592)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[(t[l>>2]|0)+8>>2]=0;k=cF(t[o>>2]|0,192672)|0;t[(t[l>>2]|0)+12>>2]=k;if(!(t[(t[l>>2]|0)+12>>2]|0))bx(t[a>>2]|0,t[o>>2]|0,1057,193808,0,0);if(((t[(t[a>>2]|0)+32>>2]&1|0)!=0?(t[(t[l>>2]|0)+12>>2]|0)!=0:0)?(Xl(t[(t[l>>2]|0)+12>>2]|0,193672)|0)!=0:0)bx(t[a>>2]|0,t[o>>2]|0,1122,193704,t[(t[l>>2]|0)+12>>2]|0,0);if(!(t[(t[o>>2]|0)+12>>2]|0))break;k=rz(t[a>>2]|0,t[(t[o>>2]|0)+12>>2]|0,(t[t[c>>2]>>2]|0)==9&1)|0;t[(t[l>>2]|0)+40>>2]=k;break}if(((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,190016)|0)!=0:0)?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){t[w>>2]=0;t[l>>2]=dx(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}t[(t[l>>2]|0)+28>>2]=t[c>>2];t[t[l>>2]>>2]=17;if(!(t[(t[o>>2]|0)+12>>2]|0)){bx(t[a>>2]|0,t[o>>2]|0,1007,193840,0,0);break}t[h>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[h>>2]|0))break e;t[b>>2]=ZU(t[a>>2]|0,t[h>>2]|0,t[l>>2]|0)|0;do if(t[b>>2]|0){k=t[b>>2]|0;if(!(t[w>>2]|0)){t[(t[l>>2]|0)+40>>2]=k;t[w>>2]=k;break}else{t[(t[w>>2]|0)+32>>2]=k;t[w>>2]=t[b>>2];break}}while(0);t[h>>2]=t[(t[h>>2]|0)+24>>2]}}if(!(t[o>>2]|0))m=193928;else m=t[(t[o>>2]|0)+8>>2]|0;bx(t[a>>2]|0,t[o>>2]|0,1006,193872,m,0);t[f>>2]=0;v=t[f>>2]|0;s=n;return v|0}while(0);do if((t[l>>2]|0)!=(t[c>>2]|0)){if(!(t[(t[c>>2]|0)+40>>2]|0)){t[(t[c>>2]|0)+40>>2]=t[l>>2];break}t[b>>2]=t[(t[c>>2]|0)+40>>2];while(1){if(!(t[(t[b>>2]|0)+32>>2]|0))break;t[b>>2]=t[(t[b>>2]|0)+32>>2]}t[(t[b>>2]|0)+32>>2]=t[l>>2]}while(0);t[f>>2]=t[l>>2];v=t[f>>2]|0;s=n;return v|0}function JU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;c=r+4|0;l=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;b=t[n>>2]|0;s=r;return b|0}t[t[a>>2]>>2]=9;t[(t[a>>2]|0)+28>>2]=t[(t[f>>2]|0)+48>>2];t[c>>2]=t[(t[u>>2]|0)+12>>2];i=t[f>>2]|0;if(!(t[c>>2]|0)){bx(i,t[u>>2]|0,1004,193408,0,0);t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}t[l>>2]=t[i+32>>2];i=(t[f>>2]|0)+32|0;t[i>>2]=t[i>>2]|1;t[o>>2]=ZU(t[f>>2]|0,t[c>>2]|0,t[a>>2]|0)|0;if(t[o>>2]|0)t[c>>2]=t[(t[c>>2]|0)+24>>2];if(t[c>>2]|0){t[o>>2]=jU(t[f>>2]|0,t[c>>2]|0)|0;e:do if(t[o>>2]|0)switch(t[t[o>>2]>>2]|0){case-1:{bx(t[f>>2]|0,t[u>>2]|0,1005,193496,0,0);break e;break}case 2:case 6:case 20:{bx(t[f>>2]|0,t[u>>2]|0,1003,193464,0,0);break e;break}case 9:case 19:case 18:case 17:case 14:case 15:case 16:case 10:case 12:case 13:case 11:case 8:case 7:case 5:case 4:case 3:case 1:case 0:{t[(t[a>>2]|0)+24>>2]=t[o>>2];t[(t[o>>2]|0)+28>>2]=t[a>>2];break e;break}default:break e}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}if(t[c>>2]|0)bx(t[f>>2]|0,t[u>>2]|0,1002,193544,0,0);t[(t[f>>2]|0)+32>>2]=t[l>>2];t[n>>2]=t[a>>2];b=t[n>>2]|0;s=r;return b|0}function QU(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+64|0;n=r+56|0;f=r+52|0;u=r+48|0;a=r+44|0;o=r+40|0;c=r+36|0;l=r+32|0;b=r+28|0;k=r+24|0;h=r+20|0;w=r+16|0;d=r+12|0;v=r+8|0;m=r+4|0;_=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[l>>2]=0;t[k>>2]=cF(t[u>>2]|0,192784)|0;if(!(t[k>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1110,193184,0,0);t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}HU(t[k>>2]|0);if(Vg(t[k>>2]|0,0)|0)bx(t[f>>2]|0,t[u>>2]|0,1112,193208,t[k>>2]|0,0);t[h>>2]=nz(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[h>>2]|0))t[h>>2]=Yl(192832)|0;t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){pAi[t[135736>>2]&511](t[k>>2]|0);t[n>>2]=0;p=t[n>>2]|0;s=r;return p|0}t[t[a>>2]>>2]=5;t[(t[a>>2]|0)+8>>2]=t[k>>2];t[(t[a>>2]|0)+12>>2]=t[h>>2];t[b>>2]=rO(t[46942]|0,t[h>>2]|0)|0;do if(t[b>>2]|0){t[(t[a>>2]|0)+20>>2]=t[b>>2];if(!(t[(t[b>>2]|0)+8>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1026,192912,t[h>>2]|0,0);break}t[d>>2]=MAi[t[(t[b>>2]|0)+8>>2]&511](t[(t[b>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if((t[d>>2]|0)!=1){bx(t[f>>2]|0,t[u>>2]|0,1111,192968,t[(t[a>>2]|0)+8>>2]|0,t[h>>2]|0);break}if(Xl(t[h>>2]|0,187824)|0){if((Xl(t[(t[a>>2]|0)+8>>2]|0,193248)|0)==0?(Xl(t[(t[a>>2]|0)+8>>2]|0,193256)|0)==0:0)break;t[(t[f>>2]|0)+128>>2]=1}}else{bx(t[f>>2]|0,t[u>>2]|0,1116,192872,t[h>>2]|0,0);t[(t[a>>2]|0)+20>>2]=0}while(0);t[w>>2]=t[(t[u>>2]|0)+12>>2];e:while(1){if(!(t[w>>2]|0))break;if(!(Xl(t[(t[w>>2]|0)+8>>2]|0,190064)|0))break;d=(Xl(t[h>>2]|0,192832)|0)!=0;b=t[f>>2]|0;k=t[u>>2]|0;if(d){bx(b,k,1058,193264,t[h>>2]|0,0);t[w>>2]=t[(t[w>>2]|0)+24>>2];while(1){if(!(t[w>>2]|0))continue e;if(!(Xl(t[(t[w>>2]|0)+8>>2]|0,190064)|0))continue e;t[w>>2]=t[(t[w>>2]|0)+24>>2]}}t[c>>2]=dx(b,k)|0;if(t[c>>2]|0){t[t[c>>2]>>2]=6;d=cF(t[w>>2]|0,192176)|0;t[(t[c>>2]|0)+8>>2]=d;if(!(t[(t[c>>2]|0)+8>>2]|0))bx(t[f>>2]|0,t[u>>2]|0,1059,193320,0,0);d=sF(t[w>>2]|0)|0;t[(t[c>>2]|0)+16>>2]=d;d=t[c>>2]|0;if(!(t[l>>2]|0)){t[l>>2]=d;t[(t[a>>2]|0)+36>>2]=d}else{t[(t[l>>2]|0)+32>>2]=d;t[l>>2]=t[c>>2]}}t[w>>2]=t[(t[w>>2]|0)+24>>2]}if((t[w>>2]|0)!=0?(Xl(t[(t[w>>2]|0)+8>>2]|0,189848)|0)!=0:0){t[_>>2]=0;t[o>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0)){t[n>>2]=t[a>>2];p=t[n>>2]|0;s=r;return p|0}t[t[o>>2]>>2]=2;t[v>>2]=t[(t[w>>2]|0)+12>>2];t[(t[a>>2]|0)+24>>2]=t[o>>2];if(!(t[v>>2]|0))bx(t[f>>2]|0,t[w>>2]|0,1030,193344,0,0);while(1){if(!(t[v>>2]|0))break;t[m>>2]=jU(t[f>>2]|0,t[v>>2]|0)|0;do if(t[m>>2]|0){u=t[m>>2]|0;if(!(t[_>>2]|0)){t[_>>2]=u;t[(t[o>>2]|0)+24>>2]=u;break}else{t[(t[_>>2]|0)+32>>2]=u;t[_>>2]=t[m>>2];break}}while(0);t[v>>2]=t[(t[v>>2]|0)+24>>2]}t[w>>2]=t[(t[w>>2]|0)+24>>2]}if(t[w>>2]|0)bx(t[f>>2]|0,t[w>>2]|0,1009,193368,t[(t[w>>2]|0)+8>>2]|0,0);t[n>>2]=t[a>>2];p=t[n>>2]|0;s=r;return p|0}function $U(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=0;t[b>>2]=0;t[a>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[a>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}t[t[a>>2]>>2]=7;t[c>>2]=cF(t[u>>2]|0,192784)|0;do if(t[c>>2]|0){HU(t[c>>2]|0);if(Vg(t[c>>2]|0,0)|0)bx(t[f>>2]|0,t[u>>2]|0,1112,192792,t[c>>2]|0,0);t[l>>2]=nz(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[l>>2]|0))t[l>>2]=Yl(192832)|0;t[(t[a>>2]|0)+8>>2]=t[c>>2];t[(t[a>>2]|0)+12>>2]=t[l>>2];t[o>>2]=rO(t[46942]|0,t[l>>2]|0)|0;if(!(t[o>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1116,192872,t[l>>2]|0,0);t[(t[a>>2]|0)+20>>2]=0;break}t[(t[a>>2]|0)+20>>2]=t[o>>2];if(!(t[(t[o>>2]|0)+8>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1026,192912,t[l>>2]|0,0);break}t[b>>2]=MAi[t[(t[o>>2]|0)+8>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0;if((t[b>>2]|0)!=1)bx(t[f>>2]|0,t[u>>2]|0,1111,192968,t[(t[a>>2]|0)+8>>2]|0,t[l>>2]|0)}while(0);do if(!(t[(t[u>>2]|0)+12>>2]|0)){l=Yl(188112)|0;t[(t[a>>2]|0)+16>>2]=l}else{if(!((t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)!=3?(t[(t[(t[u>>2]|0)+12>>2]|0)+4>>2]|0)!=4:0))w=18;if((w|0)==18?(t[(t[(t[u>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){if(!(t[a>>2]|0))break;l=sF(t[u>>2]|0)|0;t[(t[a>>2]|0)+16>>2]=l;if(!(t[(t[a>>2]|0)+16>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1120,193080,0,0);break}if(!(t[o>>2]|0))break;if(!((t[b>>2]|0)==1?(t[(t[o>>2]|0)+12>>2]|0)!=0:0))break;t[k>>2]=0;t[b>>2]=RAi[t[(t[o>>2]|0)+12>>2]&511](t[(t[o>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0,t[(t[a>>2]|0)+16>>2]|0,k,t[u>>2]|0)|0;if((t[b>>2]|0)!=1){bx(t[f>>2]|0,t[u>>2]|0,1051,193112,t[(t[a>>2]|0)+16>>2]|0,t[(t[a>>2]|0)+8>>2]|0);break}if(!(t[k>>2]|0))break;t[(t[a>>2]|0)+36>>2]=t[k>>2];break}bx(t[f>>2]|0,t[u>>2]|0,1108,193024,0,0)}while(0);t[n>>2]=t[a>>2];h=t[n>>2]|0;s=r;return h|0}function ez(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+64|0;n=r;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r+32|0;t[u>>2]=e;t[a>>2]=i;t[o>>2]=0;t[c>>2]=0;t[o>>2]=dx(t[u>>2]|0,t[a>>2]|0)|0;if(!(t[o>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=r;return h|0}t[t[o>>2]>>2]=19;if(!(t[(t[u>>2]|0)+56>>2]|0)){i=WF(10)|0;t[(t[u>>2]|0)+56>>2]=i}if(t[(t[u>>2]|0)+56>>2]|0){i=(t[u>>2]|0)+52|0;e=t[i>>2]|0;t[i>>2]=e+1;t[n>>2]=e;SY(k,32,192704,n)|0;if((ZF(t[(t[u>>2]|0)+56>>2]|0,k,t[o>>2]|0)|0)<0)bx(t[u>>2]|0,t[a>>2]|0,1045,192720,k,0)}else lx(t[u>>2]|0,192680);t[b>>2]=t[(t[a>>2]|0)+12>>2];if(!(t[b>>2]|0))bx(t[u>>2]|0,t[a>>2]|0,1048,192752,0,0);while(1){if(!(t[b>>2]|0))break;if(((((t[b>>2]|0)!=0?(t[(t[b>>2]|0)+36>>2]|0)!=0:0)?(t[(t[b>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,189864)|0)!=0:0)?(Xl(t[(t[(t[b>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)t[l>>2]=zU(t[u>>2]|0,t[b>>2]|0)|0;else t[l>>2]=jU(t[u>>2]|0,t[b>>2]|0)|0;do if(t[l>>2]|0){t[(t[l>>2]|0)+28>>2]=t[o>>2];a=t[l>>2]|0;if(!(t[c>>2]|0)){t[c>>2]=a;t[(t[o>>2]|0)+24>>2]=a;break}else{t[(t[c>>2]|0)+32>>2]=a;t[c>>2]=t[l>>2];break}}while(0);t[b>>2]=t[(t[b>>2]|0)+24>>2]}t[f>>2]=t[o>>2];h=t[f>>2]|0;s=r;return h|0}function iz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+48|0;n=r+36|0;f=r+32|0;u=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+12|0;b=r+8|0;k=r+4|0;h=r;t[f>>2]=e;t[u>>2]=i;t[b>>2]=0;t[a>>2]=t[(t[u>>2]|0)+52>>2];if(t[a>>2]|0){t[h>>2]=dx(t[f>>2]|0,t[u>>2]|0)|0;if(!(t[h>>2]|0)){t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}t[t[h>>2]>>2]=12;if(!(t[(t[a>>2]|0)+12>>2]|0)){t[o>>2]=eF(t[(t[a>>2]|0)+8>>2]|0)|0;if(!(t[o>>2]|0)){bx(t[f>>2]|0,t[u>>2]|0,1031,188056,t[(t[f>>2]|0)+68>>2]|0,0);t[n>>2]=0;w=t[n>>2]|0;s=r;return w|0}t[l>>2]=cF(t[o>>2]|0,192672)|0;if(!(t[l>>2]|0)){t[c>>2]=t[u>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)!=1)break;t[l>>2]=cF(t[c>>2]|0,192672)|0;if(t[l>>2]|0)break;t[c>>2]=t[(t[c>>2]|0)+20>>2]}if(t[l>>2]|0){_F(t[o>>2]|0,192672,t[l>>2]|0)|0;t[b>>2]=1;pAi[t[135736>>2]&511](t[l>>2]|0)}}else pAi[t[135736>>2]&511](t[l>>2]|0);t[k>>2]=t[(t[f>>2]|0)+32>>2];l=(t[f>>2]|0)+32|0;t[l>>2]=t[l>>2]|128;l=hx(t[f>>2]|0,t[o>>2]|0)|0;t[(t[a>>2]|0)+16>>2]=l;t[(t[f>>2]|0)+32>>2]=t[k>>2];if(((t[(t[a>>2]|0)+16>>2]|0)!=0?(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(t[(t[a>>2]|0)+12>>2]=t[(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)+12>>2],(t[(t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)+28>>2]|0)!=0):0)fz(t[f>>2]|0,t[(t[(t[a>>2]|0)+16>>2]|0)+4>>2]|0)|0;if((t[b>>2]|0)==1)mF(t[o>>2]|0,192672)|0}t[(t[h>>2]|0)+24>>2]=t[(t[a>>2]|0)+12>>2]}else t[h>>2]=0;t[n>>2]=t[h>>2];w=t[n>>2]|0;s=r;return w|0}function rz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if(((((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)?(t[(t[a>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[a>>2]|0)+8>>2]|0,189848)|0)!=0:0)?(Xl(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0){if(t[(t[a>>2]|0)+24>>2]|0)bx(t[u>>2]|0,t[a>>2]|0,1029,193968,0,0);r=t[u>>2]|0;i=t[a>>2]|0;if(!(t[(t[a>>2]|0)+12>>2]|0)){bx(r,i,1027,193344,0,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[c>>2]=dx(r,i)|0;if(!(t[c>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}t[t[c>>2]>>2]=2;t[k>>2]=t[(t[a>>2]|0)+12>>2];while(1){if(!(t[k>>2]|0))break;t[l>>2]=dx(t[u>>2]|0,t[k>>2]|0)|0;if(!(t[l>>2]|0))break;i=t[l>>2]|0;if(t[o>>2]|0)t[i>>2]=9;else t[i>>2]=4;if(ZU(t[u>>2]|0,t[k>>2]|0,t[l>>2]|0)|0){i=t[l>>2]|0;if(!(t[b>>2]|0))t[(t[c>>2]|0)+24>>2]=i;else t[(t[b>>2]|0)+32>>2]=i;t[b>>2]=t[l>>2]}t[k>>2]=t[(t[k>>2]|0)+24>>2]}t[f>>2]=t[c>>2];h=t[f>>2]|0;s=n;return h|0}bx(t[u>>2]|0,t[a>>2]|0,1028,193936,0,0);t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}function nz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+16|0;f=r+8|0;a=r+4|0;o=r;t[r+12>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(((((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0)?(t[(t[f>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[f>>2]|0)+8>>2]|0,192360)|0)!=0:0)?(Xl(t[(t[(t[f>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)l=13;else l=8;if((((((l|0)==8?(t[f>>2]|0)!=0:0)?(t[(t[f>>2]|0)+36>>2]|0)!=0:0)?(t[(t[f>>2]|0)+4>>2]|0)==1:0)?(Xl(t[(t[f>>2]|0)+8>>2]|0,189888)|0)!=0:0)?(Xl(t[(t[(t[f>>2]|0)+36>>2]|0)+8>>2]|0,t[46968]|0)|0)!=0:0)l=13;if((l|0)==13?(t[a>>2]=cF(t[f>>2]|0,193160)|0,(t[a>>2]|0)!=0):0){if(!(u[t[a>>2]>>0]|0)){pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[o>>2]=qA(t[a>>2]|0,193176)|0;if(!(t[o>>2]|0)){t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}else{pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}}t[f>>2]=t[(t[f>>2]|0)+20>>2];while(1){if(!(t[f>>2]|0)){l=29;break}if((t[(t[f>>2]|0)+4>>2]|0)!=1){l=29;break}t[a>>2]=cF(t[f>>2]|0,193160)|0;if(t[a>>2]|0)break;t[f>>2]=t[(t[f>>2]|0)+20>>2]}if((l|0)==29){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}if(!(u[t[a>>2]>>0]|0)){pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[o>>2]=qA(t[a>>2]|0,193176)|0;if(!(t[o>>2]|0)){t[n>>2]=t[a>>2];c=t[n>>2]|0;s=r;return c|0}else{pAi[t[135736>>2]&511](t[a>>2]|0);t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}return 0}function fz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!((t[f>>2]|0)==0|(t[u>>2]|0)==0)?(t[(t[f>>2]|0)+24>>2]|0)!=0:0){if(!(t[(t[u>>2]|0)+28>>2]|0)){t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}if(!(t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]|0)){i=WF(10)|0;t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]=i}if(!(t[(t[(t[f>>2]|0)+24>>2]|0)+28>>2]|0)){bx(t[f>>2]|0,0,1098,192264,0,0);t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}else{aO(t[(t[u>>2]|0)+28>>2]|0,386,t[f>>2]|0);t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}function tz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[a>>2];t[l>>2]=t[u>>2];u=(t[l>>2]|0)+50|0;f[u>>1]=f[u>>1]|256;t[b>>2]=ZF(t[(t[(t[c>>2]|0)+24>>2]|0)+28>>2]|0,t[o>>2]|0,t[l>>2]|0)|0;if((t[b>>2]|0)>=0){s=n;return}t[k>>2]=rO(t[(t[(t[c>>2]|0)+24>>2]|0)+28>>2]|0,t[(t[l>>2]|0)+8>>2]|0)|0;if(t[k>>2]|0){t[(t[l>>2]|0)+44>>2]=t[(t[k>>2]|0)+44>>2];t[(t[k>>2]|0)+44>>2]=t[l>>2];s=n;return}k=t[c>>2]|0;if(t[(t[l>>2]|0)+8>>2]|0){bx(k,0,1098,192304,t[(t[l>>2]|0)+8>>2]|0,0);s=n;return}else{bx(k,0,1098,192336,0,0);s=n;return}}function uz(){return 0}function az(){var e=0,i=0,r=0;e=s;s=s+16|0;i=e;do if(!(t[49266]|0)){r=Qc()|0;t[49268]=r;if(!r){t[i>>2]=0;break}else{el(t[49268]|0);t[49270]=bi(0)|0;vY(197080)|0;t[49266]=1;il(t[49268]|0);t[i>>2]=1;break}}else t[i>>2]=1;while(0);s=e;return t[i>>2]|0}function oz(){var e=0,i=0;e=s;s=s+16|0;i=e;if(!(t[49266]|0))az()|0;el(t[49268]|0);t[i>>2]=vY(197080)|0;il(t[49268]|0);s=e;return t[i>>2]|0}function cz(){var e=0;e=s;if(!(t[49266]|0)){s=e;return}$c(t[49268]|0);t[49266]=0;s=e;return}function lz(){var e=0,i=0,r=0,n=0,f=0;e=s;s=s+16|0;i=e+4|0;r=e;if((t[49266]|0)==0?(az()|0)==0:0){t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}t[r>>2]=gAi[t[135744>>2]&511](32)|0;do if(t[r>>2]|0){t[t[r>>2]>>2]=1;t[(t[r>>2]|0)+28>>2]=0;t[(t[r>>2]|0)+8>>2]=128;t[(t[r>>2]|0)+12>>2]=0;f=gAi[t[135744>>2]&511](2560)|0;t[(t[r>>2]|0)+4>>2]=f;t[(t[r>>2]|0)+16>>2]=0;t[(t[r>>2]|0)+20>>2]=0;if(!(t[(t[r>>2]|0)+4>>2]|0)){pAi[t[135736>>2]&511](t[r>>2]|0);break}VY(t[(t[r>>2]|0)+4>>2]|0,0,2560)|0;f=oz()|0;t[(t[r>>2]|0)+24>>2]=f;t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}while(0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}function sz(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if((t[49266]|0)==0?(az()|0)==0:0)t[r>>2]=-1;else f=4;do if((f|0)==4)if(!(t[n>>2]|0)){t[r>>2]=-1;break}else{el(t[49268]|0);e=t[n>>2]|0;t[e>>2]=(t[e>>2]|0)+1;il(t[49268]|0);t[r>>2]=0;break}while(0);s=i;return t[r>>2]|0}function bz(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[r>>2]=e;t[a>>2]=0;if(!(t[r>>2]|0)){s=i;return}if((t[49266]|0)==0?(az()|0)==0:0){s=i;return}el(t[49268]|0);e=t[r>>2]|0;t[e>>2]=(t[e>>2]|0)+-1;e=(t[t[r>>2]>>2]|0)>0;il(t[49268]|0);if(e){s=i;return}if(t[(t[r>>2]|0)+20>>2]|0)bz(t[(t[r>>2]|0)+20>>2]|0);if(t[(t[r>>2]|0)+4>>2]|0){t[n>>2]=0;while(1){if((t[n>>2]|0)>>>0>=(t[(t[r>>2]|0)+8>>2]|0)>>>0)break;if((t[(t[r>>2]|0)+12>>2]|0)>>>0<=0)break;t[f>>2]=(t[(t[r>>2]|0)+4>>2]|0)+((t[n>>2]|0)*20|0);e:do if(t[(t[f>>2]|0)+12>>2]|0){t[a>>2]=1;while(1){if(!(t[f>>2]|0))break e;t[u>>2]=t[t[f>>2]>>2];if(!(t[a>>2]|0))pAi[t[135736>>2]&511](t[f>>2]|0);e=(t[r>>2]|0)+12|0;t[e>>2]=(t[e>>2]|0)+-1;t[a>>2]=0;t[f>>2]=t[u>>2]}}while(0);t[n>>2]=(t[n>>2]|0)+1}pAi[t[135736>>2]&511](t[(t[r>>2]|0)+4>>2]|0)}t[o>>2]=t[(t[r>>2]|0)+16>>2];while(1){if(!(t[o>>2]|0))break;t[c>>2]=t[t[o>>2]>>2];pAi[t[135736>>2]&511](t[o>>2]|0);t[o>>2]=t[c>>2]}pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function kz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;n=s;s=s+64|0;f=n+48|0;u=n+44|0;a=n+40|0;o=n+36|0;c=n+32|0;l=n+28|0;b=n+24|0;k=n+20|0;h=n+16|0;w=n+12|0;d=n+8|0;v=n+4|0;m=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if((t[o>>2]|0)<0)t[d>>2]=HY(t[a>>2]|0)|0;else t[d>>2]=t[o>>2];o=t[d>>2]|0;if((t[(t[u>>2]|0)+28>>2]|0)>>>0>0){if((t[d>>2]|0)>>>0>1073741823?1:o>>>0>=(t[(t[u>>2]|0)+28>>2]|0)>>>0)p=9}else if(o>>>0>1073741823)p=9;if((p|0)==9){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}o=t[a>>2]|0;r=t[d>>2]|0;i=t[(t[u>>2]|0)+24>>2]|0;if((t[(t[u>>2]|0)+8>>2]|0)==128)E=vz(o,r,i)|0;else E=mz(o,r,i)|0;t[l>>2]=E;t[c>>2]=((t[l>>2]|0)>>>0)%((t[(t[u>>2]|0)+8>>2]|0)>>>0)|0;if(t[(t[(t[u>>2]|0)+4>>2]|0)+((t[c>>2]|0)*20|0)+12>>2]|0){t[h>>2]=(t[(t[u>>2]|0)+4>>2]|0)+((t[c>>2]|0)*20|0);while(1){S=(t[(t[h>>2]|0)+16>>2]|0)==(t[l>>2]|0);if(!(t[t[h>>2]>>2]|0))break;if((S?(t[(t[h>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(AY(t[(t[h>>2]|0)+4>>2]|0,t[a>>2]|0,t[d>>2]|0)|0)==0:0){p=20;break}t[b>>2]=(t[b>>2]|0)+1;t[h>>2]=t[t[h>>2]>>2]}if((p|0)==20){t[f>>2]=t[(t[h>>2]|0)+4>>2];_=t[f>>2]|0;s=n;return _|0}if((S?(t[(t[h>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(AY(t[(t[h>>2]|0)+4>>2]|0,t[a>>2]|0,t[d>>2]|0)|0)==0:0){t[f>>2]=t[(t[h>>2]|0)+4>>2];_=t[f>>2]|0;s=n;return _|0}}else t[h>>2]=0;if(t[(t[u>>2]|0)+20>>2]|0){if((t[(t[u>>2]|0)+8>>2]|0)==128?(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)!=128:0)p=31;else p=29;do if((p|0)==29){if((t[(t[u>>2]|0)+8>>2]|0)!=128?(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)==128:0){p=31;break}t[v>>2]=t[l>>2]}while(0);if((p|0)==31){S=t[a>>2]|0;E=t[d>>2]|0;i=t[(t[(t[u>>2]|0)+20>>2]|0)+24>>2]|0;if((t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)==128)g=vz(S,E,i)|0;else g=mz(S,E,i)|0;t[v>>2]=g}t[c>>2]=((t[v>>2]|0)>>>0)%((t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)>>>0)|0;if(t[(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)+((t[c>>2]|0)*20|0)+12>>2]|0){t[m>>2]=(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)+((t[c>>2]|0)*20|0);while(1){y=(t[(t[m>>2]|0)+16>>2]|0)==(t[v>>2]|0);if(!(t[t[m>>2]>>2]|0))break;if((y?(t[(t[m>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(AY(t[(t[m>>2]|0)+4>>2]|0,t[a>>2]|0,t[d>>2]|0)|0)==0:0){p=42;break}t[b>>2]=(t[b>>2]|0)+1;t[m>>2]=t[t[m>>2]>>2]}if((p|0)==42){t[f>>2]=t[(t[m>>2]|0)+4>>2];_=t[f>>2]|0;s=n;return _|0}if((y?(t[(t[m>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(AY(t[(t[m>>2]|0)+4>>2]|0,t[a>>2]|0,t[d>>2]|0)|0)==0:0){t[f>>2]=t[(t[m>>2]|0)+4>>2];_=t[f>>2]|0;s=n;return _|0}}t[c>>2]=((t[l>>2]|0)>>>0)%((t[(t[u>>2]|0)+8>>2]|0)>>>0)|0}t[w>>2]=_z(t[u>>2]|0,t[a>>2]|0,t[d>>2]|0)|0;if(!(t[w>>2]|0)){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}if(t[h>>2]|0){t[k>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[k>>2]|0)){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}}else t[k>>2]=(t[(t[u>>2]|0)+4>>2]|0)+((t[c>>2]|0)*20|0);t[(t[k>>2]|0)+4>>2]=t[w>>2];t[(t[k>>2]|0)+8>>2]=t[d>>2];t[t[k>>2]>>2]=0;t[(t[k>>2]|0)+12>>2]=1;t[(t[k>>2]|0)+16>>2]=t[l>>2];if(t[h>>2]|0)t[t[h>>2]>>2]=t[k>>2];k=(t[u>>2]|0)+12|0;t[k>>2]=(t[k>>2]|0)+1;if(((t[b>>2]|0)>>>0>3?(t[(t[u>>2]|0)+8>>2]|0)>>>0<=2730:0)?(pz(t[u>>2]|0,(t[(t[u>>2]|0)+8>>2]|0)*6|0)|0)!=0:0){t[f>>2]=0;_=t[f>>2]|0;s=n;return _|0}t[f>>2]=t[w>>2];_=t[f>>2]|0;s=n;return _|0}function hz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;n=s;s=s+64|0;f=n+56|0;u=n+52|0;a=n+48|0;o=n+44|0;c=n+40|0;l=n+36|0;b=n+32|0;k=n+28|0;h=n+24|0;w=n+20|0;d=n+16|0;v=n+12|0;m=n+8|0;_=n+4|0;p=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[b>>2]=0;if((t[u>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;E=t[f>>2]|0;s=n;return E|0}if(!(t[a>>2]|0)){t[f>>2]=kz(t[u>>2]|0,t[o>>2]|0,-1)|0;E=t[f>>2]|0;s=n;return E|0}r=HY(t[o>>2]|0)|0;t[d>>2]=r;t[m>>2]=r;t[v>>2]=HY(t[a>>2]|0)|0;t[d>>2]=(t[d>>2]|0)+(1+(t[v>>2]|0));r=(t[(t[u>>2]|0)+8>>2]|0)==128;do if(!(t[a>>2]|0)){i=t[o>>2]|0;e=t[m>>2]|0;S=t[(t[u>>2]|0)+24>>2]|0;if(r){g=vz(i,e,S)|0;break}else{g=mz(i,e,S)|0;break}}else{S=t[a>>2]|0;e=t[v>>2]|0;i=t[o>>2]|0;y=t[m>>2]|0;F=t[(t[u>>2]|0)+24>>2]|0;if(r){g=Ez(S,e,i,y,F)|0;break}else{g=Sz(S,e,i,y,F)|0;break}}while(0);t[c>>2]=g;t[l>>2]=((t[c>>2]|0)>>>0)%((t[(t[u>>2]|0)+8>>2]|0)>>>0)|0;if(t[(t[(t[u>>2]|0)+4>>2]|0)+((t[l>>2]|0)*20|0)+12>>2]|0){t[h>>2]=(t[(t[u>>2]|0)+4>>2]|0)+((t[l>>2]|0)*20|0);while(1){O=(t[(t[h>>2]|0)+16>>2]|0)==(t[c>>2]|0);if(!(t[t[h>>2]>>2]|0))break;if((O?(t[(t[h>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(Zl(t[a>>2]|0,t[o>>2]|0,t[(t[h>>2]|0)+4>>2]|0)|0)!=0:0){A=19;break}t[b>>2]=(t[b>>2]|0)+1;t[h>>2]=t[t[h>>2]>>2]}if((A|0)==19){t[f>>2]=t[(t[h>>2]|0)+4>>2];E=t[f>>2]|0;s=n;return E|0}if((O?(t[(t[h>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(Zl(t[a>>2]|0,t[o>>2]|0,t[(t[h>>2]|0)+4>>2]|0)|0)!=0:0){t[f>>2]=t[(t[h>>2]|0)+4>>2];E=t[f>>2]|0;s=n;return E|0}}else t[h>>2]=0;if(t[(t[u>>2]|0)+20>>2]|0){if((t[(t[u>>2]|0)+8>>2]|0)==128?(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)!=128:0)A=30;else A=28;do if((A|0)==28){if((t[(t[u>>2]|0)+8>>2]|0)!=128?(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)==128:0){A=30;break}t[_>>2]=t[c>>2]}while(0);if((A|0)==30){O=(t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)==128;do if(!(t[a>>2]|0)){g=t[o>>2]|0;r=t[m>>2]|0;F=t[(t[(t[u>>2]|0)+20>>2]|0)+24>>2]|0;if(O){M=vz(g,r,F)|0;break}else{M=mz(g,r,F)|0;break}}else{F=t[a>>2]|0;r=t[v>>2]|0;g=t[o>>2]|0;y=t[m>>2]|0;i=t[(t[(t[u>>2]|0)+20>>2]|0)+24>>2]|0;if(O){M=Ez(F,r,g,y,i)|0;break}else{M=Sz(F,r,g,y,i)|0;break}}while(0);t[_>>2]=M}t[l>>2]=((t[_>>2]|0)>>>0)%((t[(t[(t[u>>2]|0)+20>>2]|0)+8>>2]|0)>>>0)|0;if(t[(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)+((t[l>>2]|0)*20|0)+12>>2]|0){t[p>>2]=(t[(t[(t[u>>2]|0)+20>>2]|0)+4>>2]|0)+((t[l>>2]|0)*20|0);while(1){R=(t[(t[p>>2]|0)+16>>2]|0)==(t[_>>2]|0);if(!(t[t[p>>2]>>2]|0))break;if((R?(t[(t[p>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(Zl(t[a>>2]|0,t[o>>2]|0,t[(t[p>>2]|0)+4>>2]|0)|0)!=0:0){A=45;break}t[b>>2]=(t[b>>2]|0)+1;t[p>>2]=t[t[p>>2]>>2]}if((A|0)==45){t[f>>2]=t[(t[p>>2]|0)+4>>2];E=t[f>>2]|0;s=n;return E|0}if((R?(t[(t[p>>2]|0)+8>>2]|0)==(t[d>>2]|0):0)?(Zl(t[a>>2]|0,t[o>>2]|0,t[(t[p>>2]|0)+4>>2]|0)|0)!=0:0){t[f>>2]=t[(t[p>>2]|0)+4>>2];E=t[f>>2]|0;s=n;return E|0}}t[l>>2]=((t[c>>2]|0)>>>0)%((t[(t[u>>2]|0)+8>>2]|0)>>>0)|0}t[w>>2]=gz(t[u>>2]|0,t[a>>2]|0,t[v>>2]|0,t[o>>2]|0,t[m>>2]|0)|0;if(!(t[w>>2]|0)){t[f>>2]=0;E=t[f>>2]|0;s=n;return E|0}if(t[h>>2]|0){t[k>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[k>>2]|0)){t[f>>2]=0;E=t[f>>2]|0;s=n;return E|0}}else t[k>>2]=(t[(t[u>>2]|0)+4>>2]|0)+((t[l>>2]|0)*20|0);t[(t[k>>2]|0)+4>>2]=t[w>>2];t[(t[k>>2]|0)+8>>2]=t[d>>2];t[t[k>>2]>>2]=0;t[(t[k>>2]|0)+12>>2]=1;t[(t[k>>2]|0)+16>>2]=t[c>>2];if(t[h>>2]|0)t[t[h>>2]>>2]=t[k>>2];k=(t[u>>2]|0)+12|0;t[k>>2]=(t[k>>2]|0)+1;if((t[b>>2]|0)>>>0>3?(t[(t[u>>2]|0)+8>>2]|0)>>>0<=2730:0)pz(t[u>>2]|0,(t[(t[u>>2]|0)+8>>2]|0)*6|0)|0;t[f>>2]=t[w>>2];E=t[f>>2]|0;s=n;return E|0}function wz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=t[(t[f>>2]|0)+16>>2];while(1){if(!(t[a>>2]|0))break;if((t[u>>2]|0)>>>0>=((t[a>>2]|0)+20|0)>>>0?(t[u>>2]|0)>>>0<=(t[(t[a>>2]|0)+4>>2]|0)>>>0:0){c=7;break}t[a>>2]=t[t[a>>2]>>2]}if((c|0)==7){t[n>>2]=1;o=t[n>>2]|0;s=r;return o|0}if(t[(t[f>>2]|0)+20>>2]|0){t[n>>2]=wz(t[(t[f>>2]|0)+20>>2]|0,t[u>>2]|0)|0;o=t[n>>2]|0;s=r;return o|0}else{t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}return 0}function dz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}else{t[a>>2]=t[(t[f>>2]|0)+28>>2];t[(t[f>>2]|0)+28>>2]=t[u>>2];t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function vz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=t[c>>2];if(!(t[a>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[l>>2]=u[t[a>>2]>>0];t[l>>2]=t[l>>2]<<5;if((t[o>>2]|0)>10){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+((t[o>>2]|0)-1)>>0]|0);t[o>>2]=10}switch(t[o>>2]|0){case 7:{k=9;break}case 6:{k=10;break}case 9:{k=7;break}case 3:{k=13;break}case 8:{k=8;break}case 10:{t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+9>>0]|0);k=7;break}case 2:{k=14;break}case 4:{k=12;break}case 5:{k=11;break}default:{}}if((k|0)==7){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+8>>0]|0);k=8}if((k|0)==8){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+7>>0]|0);k=9}if((k|0)==9){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+6>>0]|0);k=10}if((k|0)==10){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+5>>0]|0);k=11}if((k|0)==11){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+4>>0]|0);k=12}if((k|0)==12){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+3>>0]|0);k=13}if((k|0)==13){t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+2>>0]|0);k=14}if((k|0)==14)t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+1>>0]|0);t[f>>2]=t[l>>2];b=t[f>>2]|0;s=n;return b|0}function mz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;if((t[o>>2]|0)<=0|(t[a>>2]|0)==0){t[f>>2]=0;k=t[f>>2]|0;s=n;return k|0}t[l>>2]=t[c>>2];t[b>>2]=0;while(1){if((t[b>>2]|0)>=(t[o>>2]|0))break;t[l>>2]=(t[l>>2]|0)+(u[(t[a>>2]|0)+(t[b>>2]|0)>>0]|0);t[l>>2]=(t[l>>2]|0)+(t[l>>2]<<10);t[l>>2]=t[l>>2]^(t[l>>2]|0)>>>6;t[b>>2]=(t[b>>2]|0)+1}t[l>>2]=(t[l>>2]|0)+(t[l>>2]<<3);t[l>>2]=t[l>>2]^(t[l>>2]|0)>>>11;t[l>>2]=(t[l>>2]|0)+(t[l>>2]<<15);t[f>>2]=t[l>>2];k=t[f>>2]|0;s=n;return k|0}function _z(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[k>>2]=0;t[h>>2]=0;t[l>>2]=t[(t[a>>2]|0)+16>>2];while(1){w=t[l>>2]|0;
	if(!(t[l>>2]|0)){d=7;break}if(((t[w+8>>2]|0)-(t[(t[l>>2]|0)+4>>2]|0)|0)>>>0>(t[c>>2]|0)>>>0)break;if((t[(t[l>>2]|0)+12>>2]|0)>>>0>(t[k>>2]|0)>>>0)t[k>>2]=t[(t[l>>2]|0)+12>>2];t[h>>2]=(t[h>>2]|0)+(t[(t[l>>2]|0)+12>>2]|0);t[l>>2]=t[t[l>>2]>>2]}do if((d|0)==7?(w|0)==0:0){if((t[(t[a>>2]|0)+28>>2]|0)>>>0>0?(t[h>>2]|0)>>>0>(t[(t[a>>2]|0)+28>>2]|0)>>>0:0){t[u>>2]=0;v=t[u>>2]|0;s=f;return v|0}if(!(t[k>>2]|0))t[k>>2]=1e3;else t[k>>2]=t[k>>2]<<2;if((t[k>>2]|0)>>>0<t[c>>2]<<2>>>0)t[k>>2]=t[c>>2]<<2;t[l>>2]=gAi[t[135744>>2]&511](24+(t[k>>2]|0)|0)|0;if(t[l>>2]|0){t[(t[l>>2]|0)+12>>2]=t[k>>2];t[(t[l>>2]|0)+16>>2]=0;t[(t[l>>2]|0)+4>>2]=(t[l>>2]|0)+20;t[(t[l>>2]|0)+8>>2]=(t[l>>2]|0)+20+(t[k>>2]|0);t[t[l>>2]>>2]=t[(t[a>>2]|0)+16>>2];t[(t[a>>2]|0)+16>>2]=t[l>>2];break}t[u>>2]=0;v=t[u>>2]|0;s=f;return v|0}while(0);t[b>>2]=t[(t[l>>2]|0)+4>>2];YY(t[(t[l>>2]|0)+4>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;o=(t[l>>2]|0)+4|0;t[o>>2]=(t[o>>2]|0)+(t[c>>2]|0);c=(t[l>>2]|0)+4|0;o=t[c>>2]|0;t[c>>2]=o+1;n[o>>0]=0;o=(t[l>>2]|0)+16|0;t[o>>2]=(t[o>>2]|0)+1;t[u>>2]=t[b>>2];v=t[u>>2]|0;s=f;return v|0}function pz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+64|0;n=r+48|0;f=r+44|0;u=r+40|0;a=r+36|0;o=r+32|0;c=r+28|0;l=r+24|0;b=r+20|0;k=r+16|0;h=r+12|0;w=r+8|0;d=r+4|0;v=r;t[f>>2]=e;t[u>>2]=i;t[w>>2]=0;t[d>>2]=1;if(!(t[f>>2]|0)){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}if((t[u>>2]|0)>>>0<8){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}if((t[u>>2]|0)>>>0>16384){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}t[c>>2]=t[(t[f>>2]|0)+8>>2];t[h>>2]=t[(t[f>>2]|0)+4>>2];if(!(t[h>>2]|0)){t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}if((t[c>>2]|0)==128)t[d>>2]=0;i=gAi[t[135744>>2]&511]((t[u>>2]|0)*20|0)|0;t[(t[f>>2]|0)+4>>2]=i;if(!(t[(t[f>>2]|0)+4>>2]|0)){t[(t[f>>2]|0)+4>>2]=t[h>>2];t[n>>2]=-1;m=t[n>>2]|0;s=r;return m|0}VY(t[(t[f>>2]|0)+4>>2]|0,0,(t[u>>2]|0)*20|0)|0;t[(t[f>>2]|0)+8>>2]=t[u>>2];t[l>>2]=0;while(1){if((t[l>>2]|0)>>>0>=(t[c>>2]|0)>>>0)break;do if(t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)+12>>2]|0){if(t[d>>2]|0)t[o>>2]=t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)+16>>2];else{u=t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)+4>>2]|0;i=t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)+8>>2]|0;e=t[(t[f>>2]|0)+24>>2]|0;if((t[(t[f>>2]|0)+8>>2]|0)==128)_=vz(u,i,e)|0;else _=mz(u,i,e)|0;t[o>>2]=_}t[a>>2]=((t[o>>2]|0)>>>0)%((t[(t[f>>2]|0)+8>>2]|0)>>>0)|0;if(!(t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)+12>>2]|0)){e=(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)|0;i=(t[h>>2]|0)+((t[l>>2]|0)*20|0)|0;t[e+0>>2]=t[i+0>>2];t[e+4>>2]=t[i+4>>2];t[e+8>>2]=t[i+8>>2];t[e+12>>2]=t[i+12>>2];t[e+16>>2]=t[i+16>>2];t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)>>2]=0;t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)+16>>2]=t[o>>2];break}t[v>>2]=gAi[t[135744>>2]&511](20)|0;if(t[v>>2]|0){t[(t[v>>2]|0)+4>>2]=t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)+4>>2];t[(t[v>>2]|0)+8>>2]=t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)+8>>2];t[(t[v>>2]|0)+16>>2]=t[o>>2];t[t[v>>2]>>2]=t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)>>2];t[(t[v>>2]|0)+12>>2]=1;t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)>>2]=t[v>>2];break}else{t[w>>2]=-1;break}}while(0);t[l>>2]=(t[l>>2]|0)+1}t[l>>2]=0;while(1){if((t[l>>2]|0)>>>0>=(t[c>>2]|0)>>>0)break;t[b>>2]=t[(t[h>>2]|0)+((t[l>>2]|0)*20|0)>>2];while(1){if(!(t[b>>2]|0))break;t[k>>2]=t[t[b>>2]>>2];if(t[d>>2]|0)t[o>>2]=t[(t[b>>2]|0)+16>>2];else{v=t[(t[b>>2]|0)+4>>2]|0;_=t[(t[b>>2]|0)+8>>2]|0;i=t[(t[f>>2]|0)+24>>2]|0;if((t[(t[f>>2]|0)+8>>2]|0)==128)p=vz(v,_,i)|0;else p=mz(v,_,i)|0;t[o>>2]=p}t[a>>2]=((t[o>>2]|0)>>>0)%((t[(t[f>>2]|0)+8>>2]|0)>>>0)|0;i=(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)|0;if(!(t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)+12>>2]|0)){_=t[b>>2]|0;t[i+0>>2]=t[_+0>>2];t[i+4>>2]=t[_+4>>2];t[i+8>>2]=t[_+8>>2];t[i+12>>2]=t[_+12>>2];t[i+16>>2]=t[_+16>>2];t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)>>2]=0;t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)+12>>2]=1;t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)+16>>2]=t[o>>2];pAi[t[135736>>2]&511](t[b>>2]|0)}else{t[t[b>>2]>>2]=t[i>>2];t[(t[b>>2]|0)+16>>2]=t[o>>2];t[(t[(t[f>>2]|0)+4>>2]|0)+((t[a>>2]|0)*20|0)>>2]=t[b>>2]}t[b>>2]=t[k>>2]}t[l>>2]=(t[l>>2]|0)+1}pAi[t[135736>>2]&511](t[h>>2]|0);t[n>>2]=t[w>>2];m=t[n>>2]|0;s=r;return m|0}function Ez(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;a=s;s=s+32|0;o=a+20|0;c=a+16|0;l=a+12|0;b=a+8|0;k=a+4|0;h=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=t[k>>2];if(!(t[c>>2]|0))t[h>>2]=(t[h>>2]|0)+1740;else t[h>>2]=(t[h>>2]|0)+((u[t[o>>2]>>0]|0)*30|0);if((t[b>>2]|0)>10?(t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+((t[b>>2]|0)-((t[c>>2]|0)+2))>>0]|0),t[b>>2]=10,(t[c>>2]|0)>10):0)t[c>>2]=10;switch(t[c>>2]|0){case 9:{w=9;break}case 10:{t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+9>>0]|0);w=9;break}case 5:{w=13;break}case 1:{w=17;break}case 2:{w=16;break}case 8:{w=10;break}case 4:{w=14;break}case 3:{w=15;break}case 7:{w=11;break}case 6:{w=12;break}default:{}}if((w|0)==9){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+8>>0]|0);w=10}if((w|0)==10){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+7>>0]|0);w=11}if((w|0)==11){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+6>>0]|0);w=12}if((w|0)==12){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+5>>0]|0);w=13}if((w|0)==13){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+4>>0]|0);w=14}if((w|0)==14){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+3>>0]|0);w=15}if((w|0)==15){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+2>>0]|0);w=16}if((w|0)==16){t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+1>>0]|0);w=17}if((w|0)==17)t[h>>2]=(t[h>>2]|0)+(u[t[o>>2]>>0]|0);t[b>>2]=(t[b>>2]|0)-(t[c>>2]|0);if((t[b>>2]|0)>0){t[h>>2]=(t[h>>2]|0)+58;t[b>>2]=(t[b>>2]|0)+-1}switch(t[b>>2]|0){case 10:{t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+9>>0]|0);w=22;break}case 3:{w=28;break}case 1:break;case 9:{w=22;break}case 5:{w=26;break}case 8:{w=23;break}case 6:{w=25;break}case 7:{w=24;break}case 2:{w=29;break}case 4:{w=27;break}default:{d=t[h>>2]|0;s=a;return d|0}}if((w|0)==22){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+8>>0]|0);w=23}if((w|0)==23){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+7>>0]|0);w=24}if((w|0)==24){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+6>>0]|0);w=25}if((w|0)==25){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+5>>0]|0);w=26}if((w|0)==26){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+4>>0]|0);w=27}if((w|0)==27){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+3>>0]|0);w=28}if((w|0)==28){t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+2>>0]|0);w=29}if((w|0)==29)t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+1>>0]|0);t[h>>2]=(t[h>>2]|0)+(u[t[l>>2]>>0]|0);d=t[h>>2]|0;s=a;return d|0}function Sz(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;l=a+16|0;b=a+12|0;k=a+8|0;h=a+4|0;w=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=t[k>>2];t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[c>>2]|0))break;t[h>>2]=(t[h>>2]|0)+(u[(t[o>>2]|0)+(t[w>>2]|0)>>0]|0);t[h>>2]=(t[h>>2]|0)+(t[h>>2]<<10);t[h>>2]=t[h>>2]^(t[h>>2]|0)>>>6;t[w>>2]=(t[w>>2]|0)+1}t[h>>2]=(t[h>>2]|0)+58;t[h>>2]=(t[h>>2]|0)+(t[h>>2]<<10);t[h>>2]=t[h>>2]^(t[h>>2]|0)>>>6;t[w>>2]=0;while(1){if((t[w>>2]|0)>=(t[b>>2]|0))break;t[h>>2]=(t[h>>2]|0)+(u[(t[l>>2]|0)+(t[w>>2]|0)>>0]|0);t[h>>2]=(t[h>>2]|0)+(t[h>>2]<<10);t[h>>2]=t[h>>2]^(t[h>>2]|0)>>>6;t[w>>2]=(t[w>>2]|0)+1}t[h>>2]=(t[h>>2]|0)+(t[h>>2]<<3);t[h>>2]=t[h>>2]^(t[h>>2]|0)>>>11;t[h>>2]=(t[h>>2]|0)+(t[h>>2]<<15);s=a;return t[h>>2]|0}function gz(e,i,r,f,u){e=e|0;i=i|0;r=r|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=f;t[h>>2]=u;t[v>>2]=0;t[m>>2]=0;u=t[c>>2]|0;if(!(t[l>>2]|0)){t[o>>2]=_z(u,t[k>>2]|0,t[h>>2]|0)|0;_=t[o>>2]|0;s=a;return _|0}t[w>>2]=t[u+16>>2];while(1){p=t[w>>2]|0;if(!(t[w>>2]|0)){E=9;break}if(((t[p+8>>2]|0)-(t[(t[w>>2]|0)+4>>2]|0)|0)>>>0>((t[h>>2]|0)+(t[b>>2]|0)+1|0)>>>0)break;if((t[(t[w>>2]|0)+12>>2]|0)>>>0>(t[v>>2]|0)>>>0)t[v>>2]=t[(t[w>>2]|0)+12>>2];t[m>>2]=(t[m>>2]|0)+(t[(t[w>>2]|0)+12>>2]|0);t[w>>2]=t[t[w>>2]>>2]}do if((E|0)==9?(p|0)==0:0){if((t[(t[c>>2]|0)+28>>2]|0)>>>0>0?(t[m>>2]|0)>>>0>(t[(t[c>>2]|0)+28>>2]|0)>>>0:0){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}if(!(t[v>>2]|0))t[v>>2]=1e3;else t[v>>2]=t[v>>2]<<2;if((t[v>>2]|0)>>>0<(t[h>>2]|0)+(t[b>>2]|0)+1<<2>>>0)t[v>>2]=(t[h>>2]|0)+(t[b>>2]|0)+1<<2;t[w>>2]=gAi[t[135744>>2]&511](24+(t[v>>2]|0)|0)|0;if(t[w>>2]|0){t[(t[w>>2]|0)+12>>2]=t[v>>2];t[(t[w>>2]|0)+16>>2]=0;t[(t[w>>2]|0)+4>>2]=(t[w>>2]|0)+20;t[(t[w>>2]|0)+8>>2]=(t[w>>2]|0)+20+(t[v>>2]|0);t[t[w>>2]>>2]=t[(t[c>>2]|0)+16>>2];t[(t[c>>2]|0)+16>>2]=t[w>>2];break}t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}while(0);t[d>>2]=t[(t[w>>2]|0)+4>>2];YY(t[(t[w>>2]|0)+4>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;l=(t[w>>2]|0)+4|0;t[l>>2]=(t[l>>2]|0)+(t[b>>2]|0);b=(t[w>>2]|0)+4|0;l=t[b>>2]|0;t[b>>2]=l+1;n[l>>0]=58;YY(t[(t[w>>2]|0)+4>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;k=(t[w>>2]|0)+4|0;t[k>>2]=(t[k>>2]|0)+(t[h>>2]|0);h=(t[w>>2]|0)+4|0;k=t[h>>2]|0;t[h>>2]=k+1;n[k>>0]=0;k=(t[w>>2]|0)+16|0;t[k>>2]=(t[k>>2]|0)+1;t[o>>2]=t[d>>2];_=t[o>>2]|0;s=a;return _|0}function yz(e){e=e|0;var i=0;i=s;s=s+16|0;t[i>>2]=e;s=i;return 0}function Fz(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if((t[n>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0){t[r>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+4>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Oz(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if((t[n>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0){t[r>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Az(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if((t[n>>2]|0)!=0?(t[(t[f>>2]|0)+36>>2]|0)!=0:0){t[r>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+32>>2];u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Mz(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if((t[n>>2]|0)!=0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){t[r>>2]=(t[(t[(t[f>>2]|0)+8>>2]|0)+40>>2]|0)==1&1;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Rz(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){t[r>>2]=(t[(t[(t[f>>2]|0)+8>>2]|0)+44>>2]|0)!=0&1;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Nz(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[n>>2];if((t[f>>2]|0)!=0?(t[(t[f>>2]|0)+8>>2]|0)!=0:0){t[r>>2]=(t[(t[(t[f>>2]|0)+8>>2]|0)+48>>2]|0)!=0&1;u=t[r>>2]|0;s=i;return u|0}t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}function Tz(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[u>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}t[b>>2]=Qg(t[(t[l>>2]|0)+8>>2]|0)|0;do if(t[b>>2]|0)if(t[(t[l>>2]|0)+32>>2]|0){s=f;return}else{iy(t[b>>2]|0);ey(t[b>>2]|0);t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]=0;break}while(0);b=$g(t[(t[l>>2]|0)+8>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]=b;if(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0){s=f;return}tj(t[l>>2]|0,197088);s=f;return}function Lz(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;f=s;s=s+64|0;u=f+48|0;a=f+44|0;o=f+40|0;c=f+36|0;l=f+32|0;b=f+28|0;k=f+24|0;h=f+20|0;w=f+16|0;d=f+12|0;v=f+8|0;m=f+4|0;_=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];if(!(t[u>>2]|0)){s=f;return}if(!((t[o>>2]|0)!=0|(t[c>>2]|0)!=0)){s=f;return}if((t[(t[l>>2]|0)+104>>2]|0)==0?(t[(t[l>>2]|0)+276>>2]|0)==0:0){s=f;return}if(!(t[(t[l>>2]|0)+12>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}t[d>>2]=0;if((t[t[l>>2]>>2]|0)!=0?(t[(t[t[l>>2]>>2]|0)+16>>2]|0)!=0:0)t[d>>2]=dAi[t[(t[t[l>>2]>>2]|0)+16>>2]&511](t[(t[l>>2]|0)+4>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;if(!(t[d>>2]|0)){s=f;return}Jg(t[(t[l>>2]|0)+8>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;t[b>>2]=t[(t[l>>2]|0)+36>>2];t[k>>2]=t[(t[l>>2]|0)+40>>2];t[h>>2]=t[(t[l>>2]|0)+44>>2];t[w>>2]=t[(t[l>>2]|0)+48>>2];t[m>>2]=t[(t[l>>2]|0)+256>>2];t[_>>2]=t[(t[l>>2]|0)+24>>2];t[(t[l>>2]|0)+24>>2]=0;a=gAi[t[135744>>2]&511](20)|0;t[(t[l>>2]|0)+48>>2]=a;a=t[l>>2]|0;if(!(t[(t[l>>2]|0)+48>>2]|0)){tj(a,197112);t[(t[l>>2]|0)+36>>2]=t[b>>2];t[(t[l>>2]|0)+40>>2]=t[k>>2];t[(t[l>>2]|0)+44>>2]=t[h>>2];t[(t[l>>2]|0)+48>>2]=t[w>>2];t[(t[l>>2]|0)+256>>2]=t[m>>2];t[(t[l>>2]|0)+24>>2]=t[_>>2];s=f;return}t[a+40>>2]=0;t[(t[l>>2]|0)+44>>2]=5;t[(t[l>>2]|0)+36>>2]=0;cE(t[l>>2]|0,t[d>>2]|0)|0;if((t[(t[(t[l>>2]|0)+36>>2]|0)+24>>2]|0)>=4){t[v>>2]=L_(t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2]|0,4)|0;Tp(t[l>>2]|0,t[v>>2]|0)|0}if(!(t[(t[d>>2]|0)+4>>2]|0)){v=KA(t[c>>2]|0)|0;t[(t[d>>2]|0)+4>>2]=v}t[(t[d>>2]|0)+28>>2]=1;t[(t[d>>2]|0)+32>>2]=1;t[(t[d>>2]|0)+12>>2]=t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2];t[(t[d>>2]|0)+16>>2]=t[(t[(t[l>>2]|0)+36>>2]|0)+16>>2];t[(t[d>>2]|0)+40>>2]=0;zE(t[l>>2]|0,t[o>>2]|0,t[c>>2]|0);while(1){p=t[l>>2]|0;if((t[(t[l>>2]|0)+40>>2]|0)<=1)break;aE(p)|0}Dp(t[p+36>>2]|0);pAi[t[135736>>2]&511](t[(t[l>>2]|0)+48>>2]|0);t[(t[l>>2]|0)+36>>2]=t[b>>2];t[(t[l>>2]|0)+40>>2]=t[k>>2];t[(t[l>>2]|0)+44>>2]=t[h>>2];t[(t[l>>2]|0)+48>>2]=t[w>>2];t[(t[l>>2]|0)+256>>2]=t[m>>2];do if(t[(t[l>>2]|0)+24>>2]|0){if((t[(t[l>>2]|0)+296>>2]|0)!=0?(wz(t[(t[l>>2]|0)+296>>2]|0,t[(t[l>>2]|0)+24>>2]|0)|0)!=0:0)break;pAi[t[135736>>2]&511](t[(t[l>>2]|0)+24>>2]|0)}while(0);t[(t[l>>2]|0)+24>>2]=t[_>>2];s=f;return}function Dz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+28|0;u=n+24|0;a=n+20|0;o=n+16|0;c=n+12|0;l=n+8|0;b=n+4|0;k=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[u>>2];t[k>>2]=0;if(!(t[u>>2]|0)){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}if(t[(t[c>>2]|0)+36>>2]|0)t[k>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+4>>2];if(!(t[k>>2]|0))t[k>>2]=t[(t[c>>2]|0)+180>>2];t[b>>2]=GA(t[o>>2]|0,t[k>>2]|0)|0;t[l>>2]=uA(t[b>>2]|0,t[a>>2]|0,t[c>>2]|0)|0;if(t[b>>2]|0)pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=t[l>>2];h=t[f>>2]|0;s=n;return h|0}function Cz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[f>>2];t[o>>2]=0;if(!(t[f>>2]|0)){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}if((t[(t[a>>2]|0)+216>>2]|0)==0?(t[o>>2]=l_(t[u>>2]|0)|0,(t[o>>2]|0)!=0):0){t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}do if((t[(t[a>>2]|0)+8>>2]|0)!=0?(t[(t[(t[a>>2]|0)+8>>2]|0)+40>>2]|0)==1:0){f=t[(t[a>>2]|0)+8>>2]|0;if((t[(t[a>>2]|0)+216>>2]|0)==2){t[f+40>>2]=0;t[o>>2]=h_(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0;t[(t[(t[a>>2]|0)+8>>2]|0)+40>>2]=1;break}t[o>>2]=h_(f,t[u>>2]|0)|0;if(!(t[o>>2]|0)){t[(t[(t[a>>2]|0)+8>>2]|0)+40>>2]=0;t[o>>2]=h_(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0;if(t[o>>2]|0)uj(t[a>>2]|0,103,197136,t[u>>2]|0,0);t[(t[(t[a>>2]|0)+8>>2]|0)+40>>2]=1}}else h=14;while(0);if((h|0)==14)t[o>>2]=h_(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0;do if(t[o>>2]|0){if((t[(t[a>>2]|0)+104>>2]|0)==0?(t[(t[a>>2]|0)+16>>2]|0)==0:0)break;if((t[(t[o>>2]|0)+12>>2]|0)==0?(t[(t[o>>2]|0)+48>>2]|0)==2:0){t[b>>2]=t[(t[a>>2]|0)+440>>2];t[c>>2]=oS(t[a>>2]|0,t[(t[o>>2]|0)+64>>2]|0,t[(t[o>>2]|0)+52>>2]|0,l)|0;if(t[c>>2]|0){uj(t[a>>2]|0,104,197208,t[u>>2]|0,0);t[(t[a>>2]|0)+104>>2]=0;t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}Iy(t[o>>2]|0,t[l>>2]|0)|0;t[(t[o>>2]|0)+68>>2]=1;if(((t[(t[o>>2]|0)+72>>2]|0)==0?(t[(t[o>>2]|0)+72>>2]=(t[(t[a>>2]|0)+440>>2]|0)-(t[b>>2]|0)+1<<1,(t[(t[o>>2]|0)+40>>2]|0)!=0):0)?(es(t[(t[o>>2]|0)+40>>2]|0,60)|0)!=0:0){h=(t[o>>2]|0)+72|0;t[h>>2]=t[h>>2]|1}}}while(0);t[n>>2]=t[o>>2];k=t[n>>2]|0;s=r;return k|0}function Pz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[f>>2];if(!(t[f>>2]|0)){t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}else{t[o>>2]=k_(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0;t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}return 0}function Bz(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+64|0;o=a;c=a+48|0;l=a+44|0;b=a+40|0;k=a+36|0;h=a+32|0;w=a+28|0;d=a+24|0;v=a+20|0;m=a+16|0;_=a+12|0;p=a+8|0;E=a+4|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[v>>2]=t[c>>2];if(!(t[c>>2]|0)){s=a;return}c=t[v>>2]|0;if((t[(t[v>>2]|0)+216>>2]|0)==1){t[d>>2]=b_(t[c+8>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;if((t[d>>2]|0)==0?(t[(t[v>>2]|0)+268>>2]|0)!=0:0)aj(t[v>>2]|0,107,197240,t[l>>2]|0);if(!(t[d>>2]|0)){s=a;return}if(!((t[h>>2]|0)!=0?(t[(t[d>>2]|0)+64>>2]|0)==0:0)){s=a;return}t[_>>2]=0;if(t[(t[v>>2]|0)+36>>2]|0)t[_>>2]=t[(t[(t[v>>2]|0)+36>>2]|0)+4>>2];if(!(t[_>>2]|0))t[_>>2]=t[(t[v>>2]|0)+180>>2];t[m>>2]=GA(t[h>>2]|0,t[_>>2]|0)|0;t[(t[d>>2]|0)+64>>2]=t[m>>2];s=a;return}m=t[v>>2]|0;if((t[c+216>>2]|0)!=2){uj(m,104,197352,t[l>>2]|0,0);s=a;return}t[d>>2]=s_(t[m+8>>2]|0,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0)|0;if((((t[d>>2]|0)==0?(t[(t[v>>2]|0)+268>>2]|0)!=0:0)?(t[t[v>>2]>>2]|0)!=0:0)?(t[(t[t[v>>2]>>2]|0)+84>>2]|0)!=0:0){w=t[(t[t[v>>2]>>2]|0)+84>>2]|0;k=t[(t[v>>2]|0)+4>>2]|0;t[o>>2]=t[l>>2];yAi[w&511](k,197296,o)}if(!(t[d>>2]|0)){s=a;return}if(!((t[h>>2]|0)!=0?(t[(t[d>>2]|0)+64>>2]|0)==0:0)){s=a;return}t[E>>2]=0;if(t[(t[v>>2]|0)+36>>2]|0)t[E>>2]=t[(t[(t[v>>2]|0)+36>>2]|0)+4>>2];if(!(t[E>>2]|0))t[E>>2]=t[(t[v>>2]|0)+180>>2];t[p>>2]=GA(t[h>>2]|0,t[E>>2]|0)|0;t[(t[d>>2]|0)+64>>2]=t[p>>2];s=a;return}function Iz(e,i,r,n,f,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;o=s;s=s+48|0;c=o+44|0;l=o+40|0;b=o+36|0;k=o+32|0;h=o+28|0;w=o+24|0;d=o+20|0;v=o+16|0;m=o+12|0;_=o+8|0;p=o+4|0;E=o;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=a;t[v>>2]=t[c>>2];t[_>>2]=0;t[p>>2]=0;if(!(t[v>>2]|0)){s=o;return}if(!(t[(t[v>>2]|0)+8>>2]|0)){s=o;return}c=(Xl(t[b>>2]|0,197408)|0)!=0;if(c&(t[k>>2]|0)!=2){t[E>>2]=t[(t[v>>2]|0)+100>>2];oj(t[v>>2]|0,540,197416,0,0);t[(t[v>>2]|0)+100>>2]=t[E>>2]}t[_>>2]=wE(t[v>>2]|0,t[b>>2]|0,p)|0;t[(t[v>>2]|0)+144>>2]=1;b=t[v>>2]|0;do if((t[(t[v>>2]|0)+216>>2]|0)==1)t[m>>2]=LM(b+108|0,t[(t[(t[v>>2]|0)+8>>2]|0)+44>>2]|0,t[l>>2]|0,t[_>>2]|0,t[p>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0)|0;else{E=t[v>>2]|0;if((t[b+216>>2]|0)==2){t[m>>2]=LM(E+108|0,t[(t[(t[v>>2]|0)+8>>2]|0)+48>>2]|0,t[l>>2]|0,t[_>>2]|0,t[p>>2]|0,t[k>>2]|0,t[h>>2]|0,t[w>>2]|0,t[d>>2]|0)|0;break}uj(E,1,197456,t[_>>2]|0,0);NM(t[d>>2]|0);s=o;return}while(0);if(!(t[(t[v>>2]|0)+144>>2]|0))t[(t[v>>2]|0)+100>>2]=0;if((((t[m>>2]|0)!=0?(t[(t[v>>2]|0)+104>>2]|0)!=0:0)?(t[(t[v>>2]|0)+12>>2]|0)!=0:0)?(t[(t[(t[v>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){d=tR((t[v>>2]|0)+108|0,t[(t[v>>2]|0)+8>>2]|0,t[m>>2]|0)|0;m=(t[v>>2]|0)+100|0;t[m>>2]=t[m>>2]&d}if(t[p>>2]|0)pAi[t[135736>>2]&511](t[p>>2]|0);if(!(t[_>>2]|0)){s=o;return}pAi[t[135736>>2]&511](t[_>>2]|0);s=o;return}function Hz(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];t[b>>2]=0;if(!(t[l>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}u=t[l>>2]|0;do if((t[(t[l>>2]|0)+216>>2]|0)==1)t[b>>2]=FM(u+108|0,t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;else{n=t[l>>2]|0;if((t[u+216>>2]|0)==2){t[b>>2]=FM(n+108|0,t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break}uj(n,1,197520,t[a>>2]|0,0);s=f;return}while(0);if(!(t[b>>2]|0))t[(t[l>>2]|0)+100>>2]=0;if(!(t[(t[l>>2]|0)+104>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+12>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}if(!(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)){s=f;return}a=uR((t[l>>2]|0)+108|0,t[(t[l>>2]|0)+8>>2]|0,t[b>>2]|0)|0;b=(t[l>>2]|0)+100|0;t[b>>2]=t[b>>2]&a;s=f;return}function xz(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+32|0;u=f+20|0;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;b=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[l>>2]=t[u>>2];t[b>>2]=0;if(!(t[l>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=f;return}u=t[l>>2]|0;if((t[o>>2]|0)==0&(t[c>>2]|0)==0){uj(u,105,197576,t[a>>2]|0,0);s=f;return}n=t[l>>2]|0;do if((t[u+216>>2]|0)==1)t[b>>2]=BM(n+108|0,t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;else{r=t[l>>2]|0;if((t[n+216>>2]|0)==2){t[b>>2]=BM(r+108|0,t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;break}uj(r,105,197640,t[a>>2]|0,0);s=f;return}while(0);if(!(t[b>>2]|0))t[(t[l>>2]|0)+100>>2]=0;if(!(t[(t[l>>2]|0)+104>>2]|0)){s=f;return}if(!(t[(t[l>>2]|0)+12>>2]|0)){s=f;return}if(!(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)){s=f;return}a=rR((t[l>>2]|0)+108|0,t[(t[l>>2]|0)+8>>2]|0,t[b>>2]|0)|0;b=(t[l>>2]|0)+100|0;t[b>>2]=t[b>>2]&a;s=f;return}function Uz(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;u=s;s=s+48|0;a=u;o=u+44|0;c=u+40|0;l=u+36|0;b=u+32|0;k=u+28|0;h=u+24|0;w=u+20|0;d=u+16|0;v=u+12|0;m=u+8|0;_=u+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=t[o>>2];if(!(t[o>>2]|0)){s=u;return}o=t[w>>2]|0;if((t[(t[w>>2]|0)+216>>2]|0)==1){t[h>>2]=b_(t[o+8>>2]|0,t[c>>2]|0,3,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;if((((t[h>>2]|0)==0?(t[(t[w>>2]|0)+268>>2]|0)!=0:0)?(t[t[w>>2]>>2]|0)!=0:0)?(t[(t[t[w>>2]>>2]|0)+84>>2]|0)!=0:0){f=t[(t[t[w>>2]>>2]|0)+84>>2]|0;n=t[(t[w>>2]|0)+4>>2]|0;t[a>>2]=t[c>>2];yAi[f&511](n,197240,a)}if(!(t[h>>2]|0)){s=u;return}if(!((t[b>>2]|0)!=0?(t[(t[h>>2]|0)+64>>2]|0)==0:0)){s=u;return}t[v>>2]=0;if(t[(t[w>>2]|0)+36>>2]|0)t[v>>2]=t[(t[(t[w>>2]|0)+36>>2]|0)+4>>2];if(!(t[v>>2]|0))t[v>>2]=t[(t[w>>2]|0)+180>>2];t[d>>2]=GA(t[b>>2]|0,t[v>>2]|0)|0;t[(t[h>>2]|0)+64>>2]=t[d>>2];s=u;return}d=t[w>>2]|0;if((t[o+216>>2]|0)!=2){uj(d,1,197696,t[c>>2]|0,0);s=u;return}t[h>>2]=s_(t[d+8>>2]|0,t[c>>2]|0,3,t[l>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;if((((t[h>>2]|0)==0?(t[(t[w>>2]|0)+268>>2]|0)!=0:0)?(t[t[w>>2]>>2]|0)!=0:0)?(t[(t[t[w>>2]>>2]|0)+84>>2]|0)!=0:0){k=t[(t[t[w>>2]>>2]|0)+84>>2]|0;l=t[(t[w>>2]|0)+4>>2]|0;t[a>>2]=t[c>>2];yAi[k&511](l,197296,a)}if(!(t[h>>2]|0)){s=u;return}if(!((t[b>>2]|0)!=0?(t[(t[h>>2]|0)+64>>2]|0)==0:0)){s=u;return}t[_>>2]=0;if(t[(t[w>>2]|0)+36>>2]|0)t[_>>2]=t[(t[(t[w>>2]|0)+36>>2]|0)+4>>2];if(!(t[_>>2]|0))t[_>>2]=t[(t[w>>2]|0)+180>>2];t[m>>2]=GA(t[b>>2]|0,t[_>>2]|0)|0;t[(t[h>>2]|0)+64>>2]=t[m>>2];s=u;return}function zz(e,i){e=e|0;i=i|0;var r=0;r=s;s=s+16|0;t[r+4>>2]=e;t[r>>2]=i;s=r;return}function jz(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;t[n>>2]=t[r>>2];if(!(t[r>>2]|0)){s=i;return}r=t[n>>2]|0;do if(!(t[(t[n>>2]|0)+32>>2]|0)){e=ny(t[r+20>>2]|0)|0;t[(t[n>>2]|0)+8>>2]=e;t[f>>2]=e;if(!(t[f>>2]|0)){tj(t[n>>2]|0,197760);s=i;return}t[(t[f>>2]|0)+92>>2]=0;if(t[(t[n>>2]|0)+360>>2]&131072){e=(t[f>>2]|0)+92|0;t[e>>2]=t[e>>2]|4}t[(t[f>>2]|0)+88>>2]=t[(t[n>>2]|0)+360>>2];if(t[(t[n>>2]|0)+24>>2]|0){e=Yl(t[(t[n>>2]|0)+24>>2]|0)|0;t[(t[f>>2]|0)+60>>2]=e}else t[(t[f>>2]|0)+60>>2]=0;t[(t[f>>2]|0)+40>>2]=t[(t[n>>2]|0)+28>>2];if((t[f>>2]|0)!=0?(t[(t[n>>2]|0)+364>>2]|0)!=0:0){t[(t[f>>2]|0)+80>>2]=t[(t[n>>2]|0)+296>>2];sz(t[(t[f>>2]|0)+80>>2]|0)|0}}else{if(!(t[r+8>>2]|0)){e=vN(0,0)|0;t[(t[n>>2]|0)+8>>2]=e}e=t[n>>2]|0;if(t[(t[n>>2]|0)+8>>2]|0){t[(t[e+8>>2]|0)+92>>2]=128;t[(t[(t[n>>2]|0)+8>>2]|0)+88>>2]=t[(t[n>>2]|0)+360>>2];break}tj(e,197760);s=i;return}while(0);if(!(t[(t[n>>2]|0)+8>>2]|0)){s=i;return}if(t[(t[(t[n>>2]|0)+8>>2]|0)+72>>2]|0){s=i;return}if(!(t[(t[n>>2]|0)+36>>2]|0)){s=i;return}if(!(t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2]|0)){s=i;return}r=XA(t[(t[(t[n>>2]|0)+36>>2]|0)+4>>2]|0)|0;t[(t[(t[n>>2]|0)+8>>2]|0)+72>>2]=r;if(t[(t[(t[n>>2]|0)+8>>2]|0)+72>>2]|0){s=i;return}tj(t[n>>2]|0,197760);s=i;return}function Vz(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[r>>2];if(!(t[r>>2]|0)){s=i;return}if((((t[(t[n>>2]|0)+104>>2]|0)!=0?(t[(t[n>>2]|0)+12>>2]|0)!=0:0)?(t[(t[n>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){r=wR((t[n>>2]|0)+108|0,t[(t[n>>2]|0)+8>>2]|0)|0;e=(t[n>>2]|0)+100|0;t[e>>2]=t[e>>2]&r}if(((t[(t[n>>2]|0)+24>>2]|0)!=0?(t[(t[n>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+8>>2]|0)+60>>2]|0)==0:0){t[(t[(t[n>>2]|0)+8>>2]|0)+60>>2]=t[(t[n>>2]|0)+24>>2];t[(t[n>>2]|0)+24>>2]=0}if((((((t[(t[n>>2]|0)+48>>2]|0)!=0?(t[(t[n>>2]|0)+40>>2]|0)>0:0)?(t[t[(t[n>>2]|0)+48>>2]>>2]|0)!=0:0)?(t[(t[t[(t[n>>2]|0)+48>>2]>>2]|0)+44>>2]|0)!=0:0)?(t[(t[n>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[n>>2]|0)+8>>2]|0)+60>>2]|0)==0:0){r=Yl(t[(t[t[(t[n>>2]|0)+48>>2]>>2]|0)+44>>2]|0)|0;t[(t[(t[n>>2]|0)+8>>2]|0)+60>>2]=r}if(!(t[(t[n>>2]|0)+256>>2]|0)){s=i;return}if(!(t[(t[n>>2]|0)+8>>2]|0)){s=i;return}if(t[(t[(t[n>>2]|0)+8>>2]|0)+76>>2]|0){s=i;return}t[(t[(t[n>>2]|0)+8>>2]|0)+76>>2]=t[(t[n>>2]|0)+256>>2];s=i;return}function qz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;n=s;s=s+64|0;a=n+48|0;o=n+44|0;c=n+40|0;l=n+36|0;b=n+32|0;k=n+28|0;h=n+24|0;w=n+20|0;d=n+16|0;v=n+12|0;m=n+8|0;_=n+4|0;p=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=t[a>>2];if((t[a>>2]|0)==0|(t[o>>2]|0)==0){s=n;return}if(!(t[(t[l>>2]|0)+8>>2]|0)){s=n;return}t[k>>2]=t[(t[l>>2]|0)+52>>2];do if((t[(t[l>>2]|0)+104>>2]|0)!=0?(t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2]|0)==0:0){if(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0){if(t[(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)+36>>2]|0)break;if(t[(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)+40>>2]|0)break;if(t[(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)+44>>2]|0)break;if(t[(t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)+48>>2]|0)break}oj(t[l>>2]|0,94,197784,0,0);t[(t[l>>2]|0)+104>>2]=0}while(0);t[w>>2]=wE(t[l>>2]|0,t[o>>2]|0,d)|0;t[b>>2]=gy(t[(t[l>>2]|0)+8>>2]|0,0,t[w>>2]|0,0)|0;if(!(t[b>>2]|0)){if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);tj(t[l>>2]|0,197824);s=n;return}if(t[(t[(t[l>>2]|0)+8>>2]|0)+12>>2]|0){if(!(t[k>>2]|0))t[k>>2]=t[(t[(t[l>>2]|0)+8>>2]|0)+12>>2]}else Hy(t[(t[l>>2]|0)+8>>2]|0,t[b>>2]|0)|0;t[(t[l>>2]|0)+264>>2]=-1;do if((t[(t[l>>2]|0)+280>>2]|0)!=0?(t[(t[l>>2]|0)+36>>2]|0)!=0:0)if((t[(t[(t[l>>2]|0)+36>>2]|0)+28>>2]|0)<65535){f[(t[b>>2]|0)+56>>1]=t[(t[(t[l>>2]|0)+36>>2]|0)+28>>2];break}else{f[(t[b>>2]|0)+56>>1]=-1;break}while(0);rE(t[l>>2]|0,t[b>>2]|0)|0;do if(t[k>>2]|0){o=t[k>>2]|0;a=t[b>>2]|0;if((t[(t[k>>2]|0)+4>>2]|0)==1){Hy(o,a)|0;break}else{By(o,a)|0;break}}while(0);do if(!(t[(t[l>>2]|0)+32>>2]|0)){if((t[(t[(t[l>>2]|0)+8>>2]|0)+44>>2]|0)==0?(t[(t[(t[l>>2]|0)+8>>2]|0)+48>>2]|0)==0:0)break;cj(t[l>>2]|0,t[w>>2]|0,t[d>>2]|0,t[c>>2]|0)}while(0);if((t[c>>2]|0)!=0?(t[_>>2]=0,w=t[_>>2]|0,t[_>>2]=w+1,t[v>>2]=t[(t[c>>2]|0)+(w<<2)>>2],w=t[_>>2]|0,t[_>>2]=w+1,t[m>>2]=t[(t[c>>2]|0)+(w<<2)>>2],((t[v>>2]|0)!=0?(t[(t[l>>2]|0)+32>>2]|0)==0:0)&(t[m>>2]|0)!=0):0)do{if(((((u[t[v>>2]>>0]|0|0)==120?(u[(t[v>>2]|0)+1>>0]|0|0)==109:0)?(u[(t[v>>2]|0)+2>>0]|0|0)==108:0)?(u[(t[v>>2]|0)+3>>0]|0|0)==110:0)?(u[(t[v>>2]|0)+4>>0]|0|0)==115:0)lj(t[l>>2]|0,t[v>>2]|0,t[m>>2]|0,t[d>>2]|0);w=t[_>>2]|0;t[_>>2]=w+1;t[v>>2]=t[(t[c>>2]|0)+(w<<2)>>2];w=t[_>>2]|0;t[_>>2]=w+1;t[m>>2]=t[(t[c>>2]|0)+(w<<2)>>2]}while((t[v>>2]|0)!=0&(t[m>>2]|0)!=0);t[h>>2]=wF(t[(t[l>>2]|0)+8>>2]|0,t[b>>2]|0,t[d>>2]|0)|0;if((t[h>>2]|0)==0&(t[k>>2]|0)!=0)t[h>>2]=wF(t[(t[l>>2]|0)+8>>2]|0,t[k>>2]|0,t[d>>2]|0)|0;if((t[d>>2]|0)!=0&(t[h>>2]|0)==0){t[h>>2]=Wg(t[b>>2]|0,0,t[d>>2]|0)|0;sj(t[l>>2]|0,201,197848,t[d>>2]|0,0)}do if((t[h>>2]|0)!=0?(t[(t[h>>2]|0)+8>>2]|0)!=0:0){if((u[t[(t[h>>2]|0)+8>>2]>>0]|0|0)==0?(t[(t[h>>2]|0)+12>>2]|0)==0:0)break;Xg(t[b>>2]|0,t[h>>2]|0)}while(0);e:do if(t[c>>2]|0){t[_>>2]=0;h=t[_>>2]|0;t[_>>2]=h+1;t[v>>2]=t[(t[c>>2]|0)+(h<<2)>>2];h=t[_>>2]|0;t[_>>2]=h+1;t[m>>2]=t[(t[c>>2]|0)+(h<<2)>>2];if(t[(t[l>>2]|0)+32>>2]|0)while(1){if(!(t[v>>2]|0))break e;lj(t[l>>2]|0,t[v>>2]|0,t[m>>2]|0,0);h=t[_>>2]|0;t[_>>2]=h+1;t[v>>2]=t[(t[c>>2]|0)+(h<<2)>>2];h=t[_>>2]|0;t[_>>2]=h+1;t[m>>2]=t[(t[c>>2]|0)+(h<<2)>>2]}while(1){if(!((t[v>>2]|0)!=0&(t[m>>2]|0)!=0))break e;do if((u[t[v>>2]>>0]|0|0)==120?(u[(t[v>>2]|0)+1>>0]|0|0)==109:0){if((u[(t[v>>2]|0)+2>>0]|0|0)!=108){E=60;break}if((u[(t[v>>2]|0)+3>>0]|0|0)!=110){E=60;break}if((u[(t[v>>2]|0)+4>>0]|0|0)!=115)E=60}else E=60;while(0);if((E|0)==60){E=0;lj(t[l>>2]|0,t[v>>2]|0,t[m>>2]|0,0)}h=t[_>>2]|0;t[_>>2]=h+1;t[v>>2]=t[(t[c>>2]|0)+(h<<2)>>2];h=t[_>>2]|0;t[_>>2]=h+1;t[m>>2]=t[(t[c>>2]|0)+(h<<2)>>2]}}while(0);if((t[(t[l>>2]|0)+104>>2]|0)!=0?(t[(t[l>>2]|0)+136>>2]|0)==-1412623820:0){t[p>>2]=vR((t[l>>2]|0)+108|0,t[(t[l>>2]|0)+8>>2]|0)|0;if((t[p>>2]|0)<=0)t[(t[l>>2]|0)+100>>2]=0;if((t[p>>2]|0)<0)t[(t[l>>2]|0)+12>>2]=0;p=kR((t[l>>2]|0)+108|0,t[(t[l>>2]|0)+8>>2]|0)|0;c=(t[l>>2]|0)+100|0;t[c>>2]=t[c>>2]&p;t[(t[l>>2]|0)+136>>2]=-1412623819}if(!(t[d>>2]|0)){s=n;return}pAi[t[135736>>2]&511](t[d>>2]|0);s=n;return}function Yz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+12|0;f=r+4|0;u=r;t[n>>2]=e;t[r+8>>2]=i;t[f>>2]=t[n>>2];if(!(t[n>>2]|0)){s=r;return}t[u>>2]=t[(t[f>>2]|0)+52>>2];if((t[u>>2]|0)!=0?(t[(t[f>>2]|0)+68>>2]|0)!=0:0){t[(t[(t[f>>2]|0)+448>>2]|0)+12>>2]=(t[(t[(t[f>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0);t[(t[(t[f>>2]|0)+448>>2]|0)+16>>2]=t[(t[(t[f>>2]|0)+36>>2]|0)+28>>2];t[t[(t[f>>2]|0)+448>>2]>>2]=t[u>>2];Vp(t[f>>2]|0,t[(t[f>>2]|0)+448>>2]|0)}t[(t[f>>2]|0)+264>>2]=-1;if((((t[(t[f>>2]|0)+104>>2]|0)!=0?(t[(t[f>>2]|0)+12>>2]|0)!=0:0)?(t[(t[f>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){n=bR((t[f>>2]|0)+108|0,t[(t[f>>2]|0)+8>>2]|0,t[u>>2]|0)|0;u=(t[f>>2]|0)+100|0;t[u>>2]=t[u>>2]&n}nE(t[f>>2]|0)|0;s=r;return}function Gz(e,i,r,n,u,a,o,c,l){e=e|0;i=i|0;r=r|0;n=n|0;u=u|0;a=a|0;o=o|0;c=c|0;l=l|0;var b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0;b=s;s=s+96|0;k=b+84|0;h=b+80|0;w=b+76|0;d=b+72|0;v=b+68|0;m=b+64|0;_=b+60|0;p=b+56|0;E=b+52|0;S=b+48|0;g=b+44|0;y=b+40|0;F=b+36|0;O=b+32|0;A=b+28|0;M=b+24|0;R=b+20|0;N=b+16|0;T=b+12|0;L=b+8|0;D=b+4|0;C=b;t[k>>2]=e;t[h>>2]=i;t[w>>2]=r;t[d>>2]=n;t[v>>2]=u;t[m>>2]=a;t[_>>2]=o;t[p>>2]=c;t[E>>2]=l;t[S>>2]=t[k>>2];t[F>>2]=0;t[R>>2]=0;if(!(t[k>>2]|0)){s=b;return}t[y>>2]=t[(t[S>>2]|0)+52>>2];do if((t[(t[S>>2]|0)+104>>2]|0)!=0?(t[(t[(t[S>>2]|0)+8>>2]|0)+48>>2]|0)==0:0){if(t[(t[(t[S>>2]|0)+8>>2]|0)+44>>2]|0){if(t[(t[(t[(t[S>>2]|0)+8>>2]|0)+44>>2]|0)+36>>2]|0)break;if(t[(t[(t[(t[S>>2]|0)+8>>2]|0)+44>>2]|0)+40>>2]|0)break;if(t[(t[(t[(t[S>>2]|0)+8>>2]|0)+44>>2]|0)+44>>2]|0)break;if(t[(t[(t[(t[S>>2]|0)+8>>2]|0)+44>>2]|0)+48>>2]|0)break}oj(t[S>>2]|0,522,197784,0,0);t[(t[S>>2]|0)+104>>2]=0}while(0);do if((t[w>>2]|0)!=0&(t[d>>2]|0)==0){if(!(t[(t[S>>2]|0)+364>>2]|0)){t[R>>2]=Ug(t[h>>2]|0,t[w>>2]|0,0,0)|0;break}t[L>>2]=hz(t[(t[S>>2]|0)+296>>2]|0,t[w>>2]|0,t[h>>2]|0)|0;if(t[L>>2]|0)t[h>>2]=t[L>>2]}while(0);L=t[S>>2]|0;if(t[(t[S>>2]|0)+372>>2]|0){t[g>>2]=t[L+372>>2];t[(t[S>>2]|0)+372>>2]=t[(t[g>>2]|0)+24>>2];k=(t[S>>2]|0)+368|0;t[k>>2]=(t[k>>2]|0)+-1;k=(t[g>>2]|0)+0|0;l=k+60|0;do{t[k>>2]=0;k=k+4|0}while((k|0)<(l|0));t[(t[g>>2]|0)+4>>2]=1;if(!(t[(t[S>>2]|0)+364>>2]|0)){if(!(t[R>>2]|0)){k=Yl(t[h>>2]|0)|0;t[(t[g>>2]|0)+8>>2]=k}else t[(t[g>>2]|0)+8>>2]=t[R>>2];if(!(t[(t[g>>2]|0)+8>>2]|0)){tj(t[S>>2]|0,197888);s=b;return}}else t[(t[g>>2]|0)+8>>2]=t[h>>2];if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[g>>2]|0)}else{do if(!(t[L+364>>2]|0)){k=t[(t[S>>2]|0)+8>>2]|0;if(!(t[R>>2]|0)){t[g>>2]=Sy(k,0,t[h>>2]|0,0)|0;break}else{t[g>>2]=gy(k,0,t[R>>2]|0,0)|0;break}}else t[g>>2]=gy(t[(t[S>>2]|0)+8>>2]|0,0,t[h>>2]|0,0)|0;while(0);if(!(t[g>>2]|0)){tj(t[S>>2]|0,197888);s=b;return}}do if((t[(t[S>>2]|0)+280>>2]|0)!=0?(t[(t[S>>2]|0)+36>>2]|0)!=0:0)if((t[(t[(t[S>>2]|0)+36>>2]|0)+28>>2]|0)<65535){f[(t[g>>2]|0)+56>>1]=t[(t[(t[S>>2]|0)+36>>2]|0)+28>>2];break}else{f[(t[g>>2]|0)+56>>1]=-1;break}while(0);if(!(t[y>>2]|0))Hy(t[(t[S>>2]|0)+8>>2]|0,t[g>>2]|0)|0;t[N>>2]=0;t[T>>2]=0;while(1){if((t[T>>2]|0)>=(t[v>>2]|0))break;h=t[N>>2]|0;t[N>>2]=h+1;t[M>>2]=t[(t[m>>2]|0)+(h<<2)>>2];h=t[N>>2]|0;t[N>>2]=h+1;t[A>>2]=t[(t[m>>2]|0)+(h<<2)>>2];t[O>>2]=Wg(0,t[A>>2]|0,t[M>>2]|0)|0;if(t[O>>2]|0){h=t[O>>2]|0;if(!(t[F>>2]|0)){t[F>>2]=h;t[(t[g>>2]|0)+48>>2]=h}else{t[t[F>>2]>>2]=h;t[F>>2]=t[O>>2]}if((t[d>>2]|0)!=0?(t[w>>2]|0)==(t[M>>2]|0):0)t[(t[g>>2]|0)+36>>2]=t[O>>2];if(((((t[(t[S>>2]|0)+32>>2]|0)==0?(t[(t[S>>2]|0)+104>>2]|0)!=0:0)?(t[(t[S>>2]|0)+12>>2]|0)!=0:0)?(t[(t[S>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[S>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){h=oR((t[S>>2]|0)+108|0,t[(t[S>>2]|0)+8>>2]|0,t[g>>2]|0,t[w>>2]|0,t[O>>2]|0,t[A>>2]|0)|0;L=(t[S>>2]|0)+100|0;t[L>>2]=t[L>>2]&h}}t[T>>2]=(t[T>>2]|0)+1;
	}t[(t[S>>2]|0)+264>>2]=-1;rE(t[S>>2]|0,t[g>>2]|0)|0;do if(t[y>>2]|0){A=t[y>>2]|0;M=t[g>>2]|0;if((t[(t[y>>2]|0)+4>>2]|0)==1){Hy(A,M)|0;break}else{By(A,M)|0;break}}while(0);if((t[p>>2]|0)!=0?(t[(t[S>>2]|0)+276>>2]&4|0)==0:0)t[_>>2]=(t[_>>2]|0)-(t[p>>2]|0);do if((t[d>>2]|0)!=0?(t[(t[g>>2]|0)+36>>2]|0)==0:0){p=wF(t[(t[S>>2]|0)+8>>2]|0,t[y>>2]|0,t[w>>2]|0)|0;t[(t[g>>2]|0)+36>>2]=p;if((t[(t[g>>2]|0)+36>>2]|0)==0?(Xl(t[w>>2]|0,197912)|0)!=0:0){p=wF(t[(t[S>>2]|0)+8>>2]|0,t[g>>2]|0,t[w>>2]|0)|0;t[(t[g>>2]|0)+36>>2]=p}if(!(t[(t[g>>2]|0)+36>>2]|0)){t[O>>2]=Wg(t[g>>2]|0,0,t[w>>2]|0)|0;if(!(t[O>>2]|0)){tj(t[S>>2]|0,197888);s=b;return}p=t[S>>2]|0;if(t[w>>2]|0){sj(p,201,197920,t[w>>2]|0,0);break}else{sj(p,201,197960,0,0);break}}}while(0);e:do if((t[_>>2]|0)>0){t[T>>2]=0;t[N>>2]=0;while(1){if((t[N>>2]|0)>=(t[_>>2]|0))break e;do if((t[(t[E>>2]|0)+((t[T>>2]|0)+1<<2)>>2]|0)!=0?(t[(t[E>>2]|0)+((t[T>>2]|0)+2<<2)>>2]|0)==0:0)if(t[(t[S>>2]|0)+364>>2]|0){t[D>>2]=hz(t[(t[S>>2]|0)+296>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+1<<2)>>2]|0,t[(t[E>>2]|0)+(t[T>>2]<<2)>>2]|0)|0;if(!(t[D>>2]|0)){P=83;break}bj(t[S>>2]|0,t[D>>2]|0,0,t[(t[E>>2]|0)+((t[T>>2]|0)+3<<2)>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+4<<2)>>2]|0);break}else{t[R>>2]=Ug(t[(t[E>>2]|0)+(t[T>>2]<<2)>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+1<<2)>>2]|0,0,0)|0;if(!(t[R>>2]|0)){P=83;break}bj(t[S>>2]|0,t[R>>2]|0,0,t[(t[E>>2]|0)+((t[T>>2]|0)+3<<2)>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+4<<2)>>2]|0);pAi[t[135736>>2]&511](t[R>>2]|0);break}else P=83;while(0);if((P|0)==83){P=0;bj(t[S>>2]|0,t[(t[E>>2]|0)+(t[T>>2]<<2)>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+1<<2)>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+3<<2)>>2]|0,t[(t[E>>2]|0)+((t[T>>2]|0)+4<<2)>>2]|0)}t[N>>2]=(t[N>>2]|0)+1;t[T>>2]=(t[T>>2]|0)+5}}while(0);if(!(t[(t[S>>2]|0)+104>>2]|0)){s=b;return}if((t[(t[S>>2]|0)+136>>2]|0)!=-1412623820){s=b;return}t[C>>2]=vR((t[S>>2]|0)+108|0,t[(t[S>>2]|0)+8>>2]|0)|0;if((t[C>>2]|0)<=0)t[(t[S>>2]|0)+100>>2]=0;if((t[C>>2]|0)<0)t[(t[S>>2]|0)+12>>2]=0;C=kR((t[S>>2]|0)+108|0,t[(t[S>>2]|0)+8>>2]|0)|0;T=(t[S>>2]|0)+100|0;t[T>>2]=t[T>>2]&C;t[(t[S>>2]|0)+136>>2]=-1412623819;s=b;return}function Wz(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+48|0;u=f+40|0;a=f+24|0;o=f+4|0;c=f;t[u>>2]=e;t[f+36>>2]=i;t[f+32>>2]=r;t[f+28>>2]=n;t[a>>2]=t[u>>2];if(!(t[u>>2]|0)){s=f;return}t[c>>2]=t[(t[a>>2]|0)+52>>2];if((t[c>>2]|0)!=0?(t[(t[a>>2]|0)+68>>2]|0)!=0:0){t[o+12>>2]=(t[(t[(t[a>>2]|0)+36>>2]|0)+16>>2]|0)-(t[(t[(t[a>>2]|0)+36>>2]|0)+12>>2]|0);t[o+16>>2]=t[(t[(t[a>>2]|0)+36>>2]|0)+28>>2];t[o>>2]=t[c>>2];Vp(t[a>>2]|0,o)}t[(t[a>>2]|0)+264>>2]=-1;if((((t[(t[a>>2]|0)+104>>2]|0)!=0?(t[(t[a>>2]|0)+12>>2]|0)!=0:0)?(t[(t[a>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[a>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){o=bR((t[a>>2]|0)+108|0,t[(t[a>>2]|0)+8>>2]|0,t[c>>2]|0)|0;c=(t[a>>2]|0)+100|0;t[c>>2]=t[c>>2]&o}nE(t[a>>2]|0)|0;s=f;return}function Kz(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;a=r+4|0;o=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=t[n>>2];if(!(t[n>>2]|0)){s=r;return}n=t[(t[a>>2]|0)+8>>2]|0;i=t[f>>2]|0;if((u[t[f>>2]>>0]|0|0)==35)t[o>>2]=Fy(n,i)|0;else t[o>>2]=cy(n,i)|0;if(Hy(t[(t[a>>2]|0)+52>>2]|0,t[o>>2]|0)|0){s=r;return}ry(t[o>>2]|0);s=r;return}function Xz(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;s=s+32|0;u=f+28|0;a=f+24|0;o=f+20|0;c=f+16|0;l=f+12|0;b=f+8|0;k=f+4|0;h=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[u>>2];if(!(t[u>>2]|0)){s=f;return}if(!(t[(t[c>>2]|0)+52>>2]|0)){s=f;return}t[l>>2]=t[(t[(t[c>>2]|0)+52>>2]|0)+16>>2];if(!(t[l>>2]|0)){t[l>>2]=kj(t[c>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(t[l>>2]|0){t[(t[(t[c>>2]|0)+52>>2]|0)+12>>2]=t[l>>2];t[(t[(t[c>>2]|0)+52>>2]|0)+16>>2]=t[l>>2];t[(t[l>>2]|0)+20>>2]=t[(t[c>>2]|0)+52>>2];t[(t[l>>2]|0)+32>>2]=t[(t[(t[c>>2]|0)+52>>2]|0)+32>>2];t[(t[c>>2]|0)+260>>2]=t[o>>2];t[(t[c>>2]|0)+264>>2]=(t[o>>2]|0)+1;s=f;return}else{tj(t[c>>2]|0,198e3);s=f;return}}if((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)==3:0)w=(t[(t[l>>2]|0)+8>>2]|0)==75104;else w=0;t[b>>2]=w&1;if((t[b>>2]|0)!=0?(t[(t[c>>2]|0)+264>>2]|0)!=0:0){if((t[(t[l>>2]|0)+40>>2]|0)!=((t[l>>2]|0)+44|0)){if((t[(t[c>>2]|0)+264>>2]|0)==((t[(t[c>>2]|0)+260>>2]|0)+1|0)?(wz(t[(t[c>>2]|0)+296>>2]|0,t[(t[l>>2]|0)+40>>2]|0)|0)!=0:0){w=Yl(t[(t[l>>2]|0)+40>>2]|0)|0;t[(t[l>>2]|0)+40>>2]=w}}else{w=Yl(t[(t[l>>2]|0)+40>>2]|0)|0;t[(t[l>>2]|0)+40>>2]=w;t[(t[l>>2]|0)+44>>2]=0}w=t[c>>2]|0;if(!(t[(t[l>>2]|0)+40>>2]|0)){tj(w,198024);s=f;return}if(((t[w+260>>2]|0)+(t[o>>2]|0)|0)>>>0>1e7?(t[(t[c>>2]|0)+360>>2]&524288|0)==0:0){tj(t[c>>2]|0,198072);s=f;return}if((t[(t[c>>2]|0)+260>>2]|0)>>>0<=(-1-(t[o>>2]|0)|0)>>>0?((t[(t[c>>2]|0)+264>>2]|0)+(t[o>>2]|0)|0)>>>0<=2147483647:0){do if(((t[(t[c>>2]|0)+260>>2]|0)+(t[o>>2]|0)|0)>=(t[(t[c>>2]|0)+264>>2]|0)){t[h>>2]=(t[(t[c>>2]|0)+264>>2]|0)+(t[o>>2]|0);t[h>>2]=t[h>>2]<<1;t[k>>2]=MAi[t[135760>>2]&511](t[(t[l>>2]|0)+40>>2]|0,t[h>>2]|0)|0;if(t[k>>2]|0){t[(t[c>>2]|0)+264>>2]=t[h>>2];t[(t[l>>2]|0)+40>>2]=t[k>>2];break}tj(t[c>>2]|0,198e3);s=f;return}while(0);YY((t[(t[l>>2]|0)+40>>2]|0)+(t[(t[c>>2]|0)+260>>2]|0)|0,t[a>>2]|0,t[o>>2]|0)|0;k=(t[c>>2]|0)+260|0;t[k>>2]=(t[k>>2]|0)+(t[o>>2]|0);n[(t[(t[l>>2]|0)+40>>2]|0)+(t[(t[c>>2]|0)+260>>2]|0)>>0]=0;s=f;return}tj(t[c>>2]|0,198112);s=f;return}if(t[b>>2]|0){if(SF(t[l>>2]|0,t[a>>2]|0,t[o>>2]|0)|0)tj(t[c>>2]|0,198e3);if(!(t[(t[(t[c>>2]|0)+52>>2]|0)+12>>2]|0)){s=f;return}b=rs(t[(t[l>>2]|0)+40>>2]|0)|0;t[(t[c>>2]|0)+260>>2]=b;t[(t[c>>2]|0)+264>>2]=(t[(t[c>>2]|0)+260>>2]|0)+1;s=f;return}else{t[l>>2]=kj(t[c>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){s=f;return}Hy(t[(t[c>>2]|0)+52>>2]|0,t[l>>2]|0)|0;if(!(t[(t[(t[c>>2]|0)+52>>2]|0)+12>>2]|0)){s=f;return}t[(t[c>>2]|0)+260>>2]=t[o>>2];t[(t[c>>2]|0)+264>>2]=(t[o>>2]|0)+1;s=f;return}}function Zz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0;n=s;s=s+16|0;t[n+8>>2]=e;t[n+4>>2]=i;t[n>>2]=r;s=n;return}function Jz(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;u=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=t[u>>2];if(!(t[u>>2]|0)){s=n;return}t[b>>2]=t[(t[c>>2]|0)+52>>2];t[l>>2]=_y(t[(t[c>>2]|0)+8>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){s=n;return}do if((t[(t[c>>2]|0)+280>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)if((t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2]|0)<65535){f[(t[l>>2]|0)+56>>1]=t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2];break}else{f[(t[l>>2]|0)+56>>1]=-1;break}while(0);o=t[c>>2]|0;if((t[(t[c>>2]|0)+216>>2]|0)==1){Hy(t[(t[o+8>>2]|0)+44>>2]|0,t[l>>2]|0)|0;s=n;return}if((t[o+216>>2]|0)==2){Hy(t[(t[(t[c>>2]|0)+8>>2]|0)+48>>2]|0,t[l>>2]|0)|0;s=n;return}if(!(t[b>>2]|0)){Hy(t[(t[c>>2]|0)+8>>2]|0,t[l>>2]|0)|0;s=n;return}c=t[b>>2]|0;o=t[l>>2]|0;if((t[(t[b>>2]|0)+4>>2]|0)==1){Hy(c,o)|0;s=n;return}else{By(c,o)|0;s=n;return}}function Qz(e,i){e=e|0;i=i|0;var r=0,n=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[u>>2]=i;t[a>>2]=t[n>>2];if(!(t[n>>2]|0)){s=r;return}t[c>>2]=t[(t[a>>2]|0)+52>>2];t[o>>2]=Ry(t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0;if(!(t[o>>2]|0)){s=r;return}do if((t[(t[a>>2]|0)+280>>2]|0)!=0?(t[(t[a>>2]|0)+36>>2]|0)!=0:0)if((t[(t[(t[a>>2]|0)+36>>2]|0)+28>>2]|0)<65535){f[(t[o>>2]|0)+56>>1]=t[(t[(t[a>>2]|0)+36>>2]|0)+28>>2];break}else{f[(t[o>>2]|0)+56>>1]=-1;break}while(0);u=t[a>>2]|0;if((t[(t[a>>2]|0)+216>>2]|0)==1){Hy(t[(t[u+8>>2]|0)+44>>2]|0,t[o>>2]|0)|0;s=r;return}if((t[u+216>>2]|0)==2){Hy(t[(t[(t[a>>2]|0)+8>>2]|0)+48>>2]|0,t[o>>2]|0)|0;s=r;return}if(!(t[c>>2]|0)){Hy(t[(t[a>>2]|0)+8>>2]|0,t[o>>2]|0)|0;s=r;return}a=t[c>>2]|0;u=t[o>>2]|0;if((t[(t[c>>2]|0)+4>>2]|0)==1){Hy(a,u)|0;s=r;return}else{By(a,u)|0;s=r;return}}function $z(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=t[f>>2];if(!(t[f>>2]|0)){s=n;return}t[l>>2]=Uy(t[(t[o>>2]|0)+52>>2]|0)|0;if((t[l>>2]|0)!=0?(t[(t[l>>2]|0)+4>>2]|0)==4:0){SF(t[l>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;s=n;return}t[c>>2]=My(t[(t[o>>2]|0)+8>>2]|0,t[u>>2]|0,t[a>>2]|0)|0;Hy(t[(t[o>>2]|0)+52>>2]|0,t[c>>2]|0)|0;s=n;return}function ej(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=t[49538];if((t[n>>2]|0)!=1&(t[n>>2]|0)!=2){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}else{t[49538]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function ij(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}do if((t[u>>2]|0)==2){t[(t[f>>2]|0)+56>>2]=0;t[(t[f>>2]|0)+60>>2]=0;t[(t[f>>2]|0)+116>>2]=387;t[(t[f>>2]|0)+120>>2]=388;t[(t[f>>2]|0)+124>>2]=0;t[(t[f>>2]|0)+108>>2]=-554844497}else{if((t[u>>2]|0)==1){t[(t[f>>2]|0)+56>>2]=50;t[(t[f>>2]|0)+60>>2]=51;t[(t[f>>2]|0)+108>>2]=1;break}t[n>>2]=-1;a=t[n>>2]|0;s=r;return a|0}while(0);t[t[f>>2]>>2]=36;t[(t[f>>2]|0)+104>>2]=60;t[(t[f>>2]|0)+4>>2]=37;t[(t[f>>2]|0)+8>>2]=38;t[(t[f>>2]|0)+12>>2]=39;t[(t[f>>2]|0)+16>>2]=40;t[(t[f>>2]|0)+20>>2]=41;t[(t[f>>2]|0)+96>>2]=58;t[(t[f>>2]|0)+24>>2]=42;t[(t[f>>2]|0)+32>>2]=44;t[(t[f>>2]|0)+36>>2]=45;t[(t[f>>2]|0)+28>>2]=43;t[(t[f>>2]|0)+40>>2]=46;t[(t[f>>2]|0)+44>>2]=47;t[(t[f>>2]|0)+48>>2]=48;t[(t[f>>2]|0)+52>>2]=49;t[(t[f>>2]|0)+64>>2]=52;t[(t[f>>2]|0)+68>>2]=53;t[(t[f>>2]|0)+100>>2]=59;t[(t[f>>2]|0)+72>>2]=53;t[(t[f>>2]|0)+76>>2]=54;t[(t[f>>2]|0)+80>>2]=55;t[(t[f>>2]|0)+84>>2]=56;t[(t[f>>2]|0)+88>>2]=57;t[(t[f>>2]|0)+92>>2]=57;t[n>>2]=0;a=t[n>>2]|0;s=r;return a|0}function rj(){var e=0;e=s;ij(135968,1)|0;s=e;return}function nj(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+108>>2]|0){s=i;return}t[t[r>>2]>>2]=36;t[(t[r>>2]|0)+104>>2]=0;t[(t[r>>2]|0)+4>>2]=0;t[(t[r>>2]|0)+8>>2]=0;t[(t[r>>2]|0)+12>>2]=0;t[(t[r>>2]|0)+16>>2]=0;t[(t[r>>2]|0)+20>>2]=41;t[(t[r>>2]|0)+96>>2]=0;t[(t[r>>2]|0)+24>>2]=0;t[(t[r>>2]|0)+32>>2]=0;t[(t[r>>2]|0)+36>>2]=0;t[(t[r>>2]|0)+28>>2]=0;t[(t[r>>2]|0)+40>>2]=0;t[(t[r>>2]|0)+44>>2]=47;t[(t[r>>2]|0)+48>>2]=48;t[(t[r>>2]|0)+52>>2]=49;t[(t[r>>2]|0)+56>>2]=50;t[(t[r>>2]|0)+60>>2]=51;t[(t[r>>2]|0)+64>>2]=0;t[(t[r>>2]|0)+68>>2]=53;t[(t[r>>2]|0)+100>>2]=59;t[(t[r>>2]|0)+72>>2]=65;t[(t[r>>2]|0)+76>>2]=54;t[(t[r>>2]|0)+80>>2]=55;t[(t[r>>2]|0)+84>>2]=56;t[(t[r>>2]|0)+88>>2]=57;t[(t[r>>2]|0)+92>>2]=57;t[(t[r>>2]|0)+108>>2]=1;s=i;return}function fj(){var e=0;e=s;nj(136096);s=e;return}function tj(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;r=s;s=s+32|0;n=r;f=r+20|0;u=r+16|0;a=r+12|0;o=r+8|0;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=198680;if(!(t[f>>2]|0)){i=t[a>>2]|0;e=t[f>>2]|0;c=t[o>>2]|0;l=t[u>>2]|0;t[n>>2]=t[o>>2];t[n+4>>2]=0;cp(i,0,0,e,0,1,2,2,0,0,c,0,0,0,0,l,n);s=r;return}t[(t[f>>2]|0)+84>>2]=2;if((t[t[f>>2]>>2]|0)!=0?(t[(t[t[f>>2]>>2]|0)+108>>2]|0)==-554844497:0)t[a>>2]=t[(t[t[f>>2]>>2]|0)+124>>2];l=t[a>>2]|0;a=t[(t[f>>2]|0)+112>>2]|0;c=t[(t[f>>2]|0)+108>>2]|0;e=t[f>>2]|0;i=t[o>>2]|0;b=t[u>>2]|0;t[n>>2]=t[o>>2];t[n+4>>2]=0;cp(l,a,c,e,0,1,2,2,0,0,i,0,0,0,0,b,n);t[(t[f>>2]|0)+84>>2]=2;t[(t[f>>2]|0)+172>>2]=-1;t[(t[f>>2]|0)+212>>2]=1;s=r;return}function uj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(t[o>>2]|0)t[(t[o>>2]|0)+84>>2]=t[c>>2];f=t[o>>2]|0;n=t[c>>2]|0;c=t[b>>2]|0;r=t[k>>2]|0;i=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(0,0,0,f,0,1,n,3,0,0,c,r,0,0,0,i,a);if(!(t[o>>2]|0)){s=u;return}t[(t[o>>2]|0)+12>>2]=0;t[(t[o>>2]|0)+100>>2]=0;if(t[(t[o>>2]|0)+288>>2]|0){s=u;return}t[(t[o>>2]|0)+212>>2]=1;s=u;return}function aj(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0;f=s;s=s+32|0;u=f;a=f+16|0;o=f+12|0;c=f+8|0;l=f+4|0;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+212>>2]|0)!=0:0)?(t[(t[a>>2]|0)+172>>2]|0)==-1:0){s=f;return}if(t[a>>2]|0)t[(t[a>>2]|0)+84>>2]=t[o>>2];n=t[a>>2]|0;a=t[o>>2]|0;o=t[l>>2]|0;r=t[c>>2]|0;t[u>>2]=t[l>>2];cp(0,0,0,n,0,1,a,1,0,0,o,0,0,0,0,r,u);s=f;return}function oj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;u=s;s=s+32|0;a=u;o=u+28|0;c=u+24|0;l=u+20|0;b=u+16|0;k=u+12|0;h=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=0;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(!(t[o>>2]|0)){f=t[h>>2]|0;n=t[o>>2]|0;r=t[c>>2]|0;i=t[b>>2]|0;e=t[k>>2]|0;w=t[l>>2]|0;d=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=d;cp(f,0,0,n,0,4,r,2,0,0,i,e,0,0,0,w,a);s=u;return}t[(t[o>>2]|0)+84>>2]=t[c>>2];if((t[t[o>>2]>>2]|0)!=0?(t[(t[t[o>>2]>>2]|0)+108>>2]|0)==-554844497:0)t[h>>2]=t[(t[t[o>>2]>>2]|0)+124>>2];w=t[h>>2]|0;h=t[(t[o>>2]|0)+112>>2]|0;e=t[(t[o>>2]|0)+108>>2]|0;i=t[o>>2]|0;r=t[c>>2]|0;c=t[b>>2]|0;n=t[k>>2]|0;f=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(w,h,e,i,0,4,r,2,0,0,c,n,0,0,0,f,a);t[(t[o>>2]|0)+100>>2]=0;s=u;return}function cj(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;f=s;s=s+112|0;u=f+44|0;a=f+40|0;o=f+36|0;c=f+32|0;l=f+28|0;b=f+24|0;k=f+20|0;h=f+16|0;w=f+12|0;d=f+8|0;v=f+4|0;m=f+48|0;_=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;t[k>>2]=1;t[l>>2]=JM(t[(t[(t[u>>2]|0)+8>>2]|0)+44>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;if(!(t[l>>2]|0)){t[l>>2]=JM(t[(t[(t[u>>2]|0)+8>>2]|0)+48>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[k>>2]=0}e:while(1){if(!(t[l>>2]|0)){p=48;break}t[w>>2]=t[(t[l>>2]|0)+44>>2];i:do if(((t[(t[(t[u>>2]|0)+8>>2]|0)+40>>2]|0)==1?(t[(t[(t[u>>2]|0)+8>>2]|0)+48>>2]|0)!=0:0)?(t[w>>2]|0)!=0?(t[(t[u>>2]|0)+104>>2]|0)!=0:0:0){while(1){if(((t[(t[w>>2]|0)+48>>2]|0)!=0?(n=QM(t[(t[(t[u>>2]|0)+8>>2]|0)+48>>2]|0,t[(t[w>>2]|0)+60>>2]|0,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+56>>2]|0)|0,(n|0)==(t[w>>2]|0)):0)?(QM(t[(t[(t[u>>2]|0)+8>>2]|0)+44>>2]|0,t[(t[w>>2]|0)+60>>2]|0,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+56>>2]|0)|0)==0:0){n=t[w>>2]|0;if(t[(t[w>>2]|0)+56>>2]|0){t[d>>2]=Yl(t[n+56>>2]|0)|0;t[d>>2]=us(t[d>>2]|0,198608)|0;t[d>>2]=us(t[d>>2]|0,t[(t[w>>2]|0)+8>>2]|0)|0}else t[d>>2]=Yl(t[n+8>>2]|0)|0;if(!(t[d>>2]|0))break;t[b>>2]=0;r:do if(t[c>>2]|0){t[h>>2]=0;t[b>>2]=t[(t[c>>2]|0)+(t[h>>2]<<2)>>2];while(1){if(!(t[b>>2]|0))break r;if(Xl(t[b>>2]|0,t[d>>2]|0)|0)break r;t[h>>2]=(t[h>>2]|0)+2;t[b>>2]=t[(t[c>>2]|0)+(t[h>>2]<<2)>>2]}}while(0);if(!(t[b>>2]|0))oj(t[u>>2]|0,538,198616,t[d>>2]|0,t[(t[w>>2]|0)+60>>2]|0);pAi[t[135736>>2]&511](t[d>>2]|0)}t[w>>2]=t[(t[w>>2]|0)+36>>2];if(!(t[w>>2]|0))break i}tj(t[u>>2]|0,197824)}while(0);t[w>>2]=t[(t[l>>2]|0)+44>>2];while(1){if(!(t[w>>2]|0))break;i:do if(t[(t[w>>2]|0)+48>>2]|0){if(!((t[(t[w>>2]|0)+56>>2]|0)!=0?(Xl(t[(t[w>>2]|0)+56>>2]|0,198248)|0)!=0:0))p=29;do if((p|0)==29){p=0;if((t[(t[w>>2]|0)+56>>2]|0)==0?(Xl(t[(t[w>>2]|0)+8>>2]|0,198248)|0)!=0:0)break;if(!(t[(t[u>>2]|0)+276>>2]&4))break i}while(0);t[v>>2]=QM(t[(t[(t[u>>2]|0)+8>>2]|0)+44>>2]|0,t[(t[w>>2]|0)+60>>2]|0,t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+56>>2]|0)|0;if((t[v>>2]|0)==0?1:(t[v>>2]|0)==(t[w>>2]|0)){t[_>>2]=Ug(t[(t[w>>2]|0)+8>>2]|0,t[(t[w>>2]|0)+56>>2]|0,m,50)|0;if(!(t[_>>2]|0)){p=34;break e}t[b>>2]=0;r:do if(t[c>>2]|0){t[h>>2]=0;t[b>>2]=t[(t[c>>2]|0)+(t[h>>2]<<2)>>2];while(1){if(!(t[b>>2]|0))break r;if(Xl(t[b>>2]|0,t[_>>2]|0)|0)break r;t[h>>2]=(t[h>>2]|0)+2;t[b>>2]=t[(t[c>>2]|0)+(t[h>>2]<<2)>>2]}}while(0);if(!(t[b>>2]|0))lj(t[u>>2]|0,t[_>>2]|0,t[(t[w>>2]|0)+48>>2]|0,t[o>>2]|0);if((t[_>>2]|0)!=(m|0)?(t[_>>2]|0)!=(t[(t[w>>2]|0)+8>>2]|0):0)pAi[t[135736>>2]&511](t[_>>2]|0)}}while(0);t[w>>2]=t[(t[w>>2]|0)+36>>2]}if((t[k>>2]|0)!=1){p=48;break}t[l>>2]=JM(t[(t[(t[u>>2]|0)+8>>2]|0)+48>>2]|0,t[a>>2]|0,t[o>>2]|0)|0;t[k>>2]=0}if((p|0)==34){tj(t[u>>2]|0,197824);s=f;return}else if((p|0)==48){s=f;return}}function lj(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0;f=s;s=s+96|0;a=f;o=f+80|0;c=f+76|0;l=f+72|0;b=f+68|0;k=f+64|0;h=f+60|0;w=f+56|0;d=f+52|0;v=f+48|0;m=f+44|0;_=f+40|0;p=f+36|0;E=f+32|0;S=f+28|0;g=f+24|0;y=f+20|0;F=f+16|0;O=f+12|0;A=f+8|0;M=f+4|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=t[o>>2];if(!(t[(t[k>>2]|0)+32>>2]|0)){t[w>>2]=wE(t[k>>2]|0,t[c>>2]|0,d)|0;if((t[w>>2]|0)!=0?(u[t[w>>2]>>0]|0|0)==0:0){o=(Xl(t[d>>2]|0,198248)|0)!=0;n=t[k>>2]|0;r=t[c>>2]|0;if(o)hj(n,35,198256,r,0);else sj(n,106,198296,r,0);if(t[d>>2]|0)pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=0;pAi[t[135736>>2]&511](t[w>>2]|0);t[w>>2]=Yl(t[c>>2]|0)|0}}else{t[w>>2]=Yl(t[c>>2]|0)|0;t[d>>2]=0;t[m>>2]=0}r=t[k>>2]|0;if(!(t[w>>2]|0)){tj(r,197824);if(!(t[d>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[d>>2]|0);s=f;return}if((t[r+32>>2]|0)!=0&(t[l>>2]|0)==0?(Ki(t[c>>2]|0)|0)!=0:0){t[v>>2]=Yl(t[c>>2]|0)|0;t[l>>2]=t[v>>2]}else{t[(t[k>>2]|0)+144>>2]=1;t[v>>2]=nR((t[k>>2]|0)+108|0,t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[c>>2]|0,t[l>>2]|0)|0;if((t[(t[k>>2]|0)+144>>2]|0)!=1)t[(t[k>>2]|0)+100>>2]=0;if(t[v>>2]|0)t[l>>2]=t[v>>2]}if((((((((t[d>>2]|0)==0?(t[(t[k>>2]|0)+32>>2]|0)==0:0)?(u[t[w>>2]>>0]|0|0)==120:0)?(u[(t[w>>2]|0)+1>>0]|0|0)==109:0)?(u[(t[w>>2]|0)+2>>0]|0|0)==108:0)?(u[(t[w>>2]|0)+3>>0]|0|0)==110:0)?(u[(t[w>>2]|0)+4>>0]|0|0)==115:0)?(u[(t[w>>2]|0)+5>>0]|0|0)==0:0){if(!(t[(t[k>>2]|0)+16>>2]|0)){r=(t[k>>2]|0)+248|0;t[r>>2]=(t[r>>2]|0)+1;t[p>>2]=hE(t[k>>2]|0,t[l>>2]|0,1,0,0,0)|0;r=(t[k>>2]|0)+248|0;t[r>>2]=(t[r>>2]|0)+-1;if(!(t[p>>2]|0)){tj(t[k>>2]|0,197824);if(!(t[w>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[w>>2]|0);s=f;return}}else t[p>>2]=t[l>>2];do if(u[t[p>>2]>>0]|0){t[E>>2]=IA(t[p>>2]|0)|0;if(!(t[E>>2]|0)){if(!(t[t[k>>2]>>2]|0))break;if(!(t[(t[t[k>>2]>>2]|0)+84>>2]|0))break;r=t[(t[t[k>>2]>>2]|0)+84>>2]|0;n=t[(t[k>>2]|0)+4>>2]|0;t[a>>2]=t[p>>2];yAi[r&511](n,198344,a);break}if(((t[t[E>>2]>>2]|0)==0?(t[t[k>>2]>>2]|0)!=0:0)?(t[(t[t[k>>2]>>2]|0)+84>>2]|0)!=0:0){n=t[(t[t[k>>2]>>2]|0)+84>>2]|0;r=t[(t[k>>2]|0)+4>>2]|0;t[a>>2]=t[p>>2];yAi[n&511](r,198376,a)}xA(t[E>>2]|0)}while(0);t[_>>2]=Wg(t[(t[k>>2]|0)+52>>2]|0,t[p>>2]|0,0)|0;if(((((t[_>>2]|0)!=0?(t[(t[k>>2]|0)+104>>2]|0)!=0:0)?(t[(t[k>>2]|0)+12>>2]|0)!=0:0)?(t[(t[k>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){E=oR((t[k>>2]|0)+108|0,t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[b>>2]|0,t[_>>2]|0,t[p>>2]|0)|0;_=(t[k>>2]|0)+100|0;t[_>>2]=t[_>>2]&E}if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if((t[p>>2]|0)==(t[l>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[p>>2]|0);s=f;return}if((((((((t[d>>2]|0)!=0?(t[(t[k>>2]|0)+32>>2]|0)==0:0)?(u[t[d>>2]>>0]|0|0)==120:0)?(u[(t[d>>2]|0)+1>>0]|0|0)==109:0)?(u[(t[d>>2]|0)+2>>0]|0|0)==108:0)?(u[(t[d>>2]|0)+3>>0]|0|0)==110:0)?(u[(t[d>>2]|0)+4>>0]|0|0)==115:0)?(u[(t[d>>2]|0)+5>>0]|0|0)==0:0){if(!(t[(t[k>>2]|0)+16>>2]|0)){p=(t[k>>2]|0)+248|0;t[p>>2]=(t[p>>2]|0)+1;t[g>>2]=hE(t[k>>2]|0,t[l>>2]|0,1,0,0,0)|0;p=(t[k>>2]|0)+248|0;t[p>>2]=(t[p>>2]|0)+-1;if(!(t[g>>2]|0)){tj(t[k>>2]|0,197824);pAi[t[135736>>2]&511](t[d>>2]|0);if(!(t[w>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[w>>2]|0);s=f;return}}else t[g>>2]=t[l>>2];if(!(u[t[g>>2]>>0]|0))hj(t[k>>2]|0,204,198408,t[w>>2]|0,0);do if((t[(t[k>>2]|0)+268>>2]|0)!=0?(u[t[g>>2]>>0]|0|0)!=0:0){t[y>>2]=IA(t[g>>2]|0)|0;if(!(t[y>>2]|0)){sj(t[k>>2]|0,99,198448,t[w>>2]|0,t[l>>2]|0);break}if(!(t[t[y>>2]>>2]|0))sj(t[k>>2]|0,100,198480,t[w>>2]|0,t[l>>2]|0);xA(t[y>>2]|0)}while(0);t[S>>2]=Wg(t[(t[k>>2]|0)+52>>2]|0,t[g>>2]|0,t[w>>2]|0)|0;pAi[t[135736>>2]&511](t[d>>2]|0);do if((((t[S>>2]|0)!=0?(t[(t[k>>2]|0)+104>>2]|0)!=0:0)?(t[(t[k>>2]|0)+12>>2]|0)!=0:0)?(t[(t[k>>2]|0)+8>>2]|0)!=0:0){if(!(t[(t[(t[k>>2]|0)+8>>2]|0)+44>>2]|0))break;y=oR((t[k>>2]|0)+108|0,t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[b>>2]|0,t[S>>2]|0,t[l>>2]|0)|0;p=(t[k>>2]|0)+100|0;t[p>>2]=t[p>>2]&y}while(0);if(t[w>>2]|0)pAi[t[135736>>2]&511](t[w>>2]|0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if((t[g>>2]|0)==(t[l>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[g>>2]|0);s=f;return}e:do if(t[d>>2]|0){t[m>>2]=wF(t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[d>>2]|0)|0;g=t[k>>2]|0;if(!(t[m>>2]|0)){hj(g,201,198520,t[d>>2]|0,t[w>>2]|0);R=101;break}t[F>>2]=t[(t[g+52>>2]|0)+44>>2];while(1){if(!(t[F>>2]|0)){R=101;break e}if((t[(t[F>>2]|0)+36>>2]|0)!=0?(Xl(t[w>>2]|0,t[(t[F>>2]|0)+8>>2]|0)|0)!=0:0){if((t[m>>2]|0)==(t[(t[F>>2]|0)+36>>2]|0))break;if(Xl(t[(t[m>>2]|0)+8>>2]|0,t[(t[(t[F>>2]|0)+36>>2]|0)+8>>2]|0)|0)break}t[F>>2]=t[(t[F>>2]|0)+24>>2]}hj(t[k>>2]|0,42,198576,t[w>>2]|0,t[(t[m>>2]|0)+8>>2]|0);t[(t[k>>2]|0)+12>>2]=0;if(!(t[(t[k>>2]|0)+288>>2]|0))t[(t[k>>2]|0)+212>>2]=1}else{t[m>>2]=0;R=101}while(0);do if((R|0)==101){t[h>>2]=hy(t[(t[k>>2]|0)+52>>2]|0,t[m>>2]|0,t[w>>2]|0,0)|0;e:do if(t[h>>2]|0){if((t[(t[k>>2]|0)+16>>2]|0)==0?(t[(t[k>>2]|0)+32>>2]|0)==0:0){F=ly(t[(t[k>>2]|0)+8>>2]|0,t[l>>2]|0)|0;t[(t[h>>2]|0)+12>>2]=F;t[O>>2]=t[(t[h>>2]|0)+12>>2];while(1){if(!(t[O>>2]|0))break e;t[(t[O>>2]|0)+20>>2]=t[h>>2];if(!(t[(t[O>>2]|0)+24>>2]|0))t[(t[h>>2]|0)+16>>2]=t[O>>2];t[O>>2]=t[(t[O>>2]|0)+24>>2]}}if((t[l>>2]|0)!=0?(F=ay(t[(t[k>>2]|0)+8>>2]|0,t[l>>2]|0)|0,t[(t[h>>2]|0)+12>>2]=F,t[(t[h>>2]|0)+16>>2]=t[(t[h>>2]|0)+12>>2],(t[(t[h>>2]|0)+12>>2]|0)!=0):0)t[(t[(t[h>>2]|0)+12>>2]|0)+20>>2]=t[h>>2]}while(0);if(((((t[(t[k>>2]|0)+32>>2]|0)==0?(t[(t[k>>2]|0)+104>>2]|0)!=0:0)?(t[(t[k>>2]|0)+12>>2]|0)!=0:0)?(t[(t[k>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[k>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){F=t[k>>2]|0;if(t[(t[k>>2]|0)+16>>2]|0){g=aR(F+108|0,t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[h>>2]|0,t[l>>2]|0)|0;S=(t[k>>2]|0)+100|0;t[S>>2]=t[S>>2]&g;break}g=F+248|0;t[g>>2]=(t[g>>2]|0)+1;t[A>>2]=hE(t[k>>2]|0,t[l>>2]|0,1,0,0,0)|0;g=(t[k>>2]|0)+248|0;t[g>>2]=(t[g>>2]|0)+-1;g=t[k>>2]|0;if(!(t[A>>2]|0)){F=aR(g+108|0,t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[h>>2]|0,t[l>>2]|0)|0;S=(t[k>>2]|0)+100|0;t[S>>2]=t[S>>2]&F;break}t[M>>2]=fR(t[g+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[c>>2]|0,t[A>>2]|0)|0;if(t[M>>2]|0){pAi[t[135736>>2]&511](t[A>>2]|0);t[A>>2]=t[M>>2]}g=aR((t[k>>2]|0)+108|0,t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[h>>2]|0,t[A>>2]|0)|0;F=(t[k>>2]|0)+100|0;t[F>>2]=t[F>>2]&g;pAi[t[135736>>2]&511](t[A>>2]|0);break}if(!(t[(t[k>>2]|0)+276>>2]&8)){if(!((t[(t[k>>2]|0)+16>>2]|0)==0?(t[(t[k>>2]|0)+96>>2]|0)!=2:0)){if(!(t[(t[k>>2]|0)+16>>2]|0))break;if(t[(t[k>>2]|0)+216>>2]|0)break}if(Xl(t[c>>2]|0,197408)|0){if(Vg(t[l>>2]|0,1)|0)oj(t[k>>2]|0,539,198200,t[l>>2]|0,0);zM((t[k>>2]|0)+108|0,t[(t[k>>2]|0)+8>>2]|0,t[l>>2]|0,t[h>>2]|0)|0;break}g=(VM(t[(t[k>>2]|0)+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[h>>2]|0)|0)!=0;F=t[k>>2]|0;if(g){zM(F+108|0,t[(t[k>>2]|0)+8>>2]|0,t[l>>2]|0,t[h>>2]|0)|0;break}if(XM(t[F+8>>2]|0,t[(t[k>>2]|0)+52>>2]|0,t[h>>2]|0)|0)WM((t[k>>2]|0)+108|0,t[(t[k>>2]|0)+8>>2]|0,t[l>>2]|0,t[h>>2]|0)|0}}while(0);if(t[v>>2]|0)pAi[t[135736>>2]&511](t[v>>2]|0);if(!(t[d>>2]|0)){s=f;return}pAi[t[135736>>2]&511](t[d>>2]|0);s=f;return}function sj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(t[o>>2]|0)t[(t[o>>2]|0)+84>>2]=t[c>>2];f=t[o>>2]|0;o=t[c>>2]|0;c=t[b>>2]|0;n=t[k>>2]|0;r=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(0,0,0,f,0,3,o,1,0,0,c,n,0,0,0,r,a);s=u;return}function bj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;a=s;s=s+112|0;o=a+48|0;c=a+44|0;l=a+40|0;b=a+36|0;k=a+32|0;h=a+28|0;w=a+24|0;d=a+20|0;v=a+16|0;m=a+12|0;_=a+8|0;p=a+4|0;E=a+52|0;S=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[w>>2]=0;t[d>>2]=0;if(t[l>>2]|0)t[w>>2]=wF(t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[l>>2]|0)|0;f=t[o>>2]|0;if(t[(t[o>>2]|0)+380>>2]|0){t[h>>2]=t[f+380>>2];t[(t[o>>2]|0)+380>>2]=t[(t[h>>2]|0)+24>>2];n=(t[o>>2]|0)+376|0;t[n>>2]=(t[n>>2]|0)+-1;n=(t[h>>2]|0)+0|0;r=n+48|0;do{t[n>>2]=0;n=n+4|0}while((n|0)<(r|0));t[(t[h>>2]|0)+4>>2]=2;t[(t[h>>2]|0)+20>>2]=t[(t[o>>2]|0)+52>>2];t[(t[h>>2]|0)+32>>2]=t[(t[o>>2]|0)+8>>2];t[(t[h>>2]|0)+36>>2]=t[w>>2];n=t[c>>2]|0;if(t[(t[o>>2]|0)+364>>2]|0)t[(t[h>>2]|0)+8>>2]=n;else{r=Yl(n)|0;t[(t[h>>2]|0)+8>>2]=r}if(!(t[(t[(t[o>>2]|0)+52>>2]|0)+44>>2]|0))t[(t[(t[o>>2]|0)+52>>2]|0)+44>>2]=t[h>>2];else{t[v>>2]=t[(t[(t[o>>2]|0)+52>>2]|0)+44>>2];while(1){if(!(t[(t[v>>2]|0)+24>>2]|0))break;t[v>>2]=t[(t[v>>2]|0)+24>>2]}t[(t[v>>2]|0)+24>>2]=t[h>>2];t[(t[h>>2]|0)+28>>2]=t[v>>2]}if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[h>>2]|0)}else{v=t[(t[o>>2]|0)+52>>2]|0;r=t[w>>2]|0;w=t[c>>2]|0;if(t[f+364>>2]|0)t[h>>2]=hy(v,r,w,0)|0;else t[h>>2]=ky(v,r,w,0)|0;if(!(t[h>>2]|0)){Sp(t[o>>2]|0,198176);s=a;return}}e:do if((t[(t[o>>2]|0)+16>>2]|0)==0?(t[(t[o>>2]|0)+32>>2]|0)==0:0){w=t[o>>2]|0;if(u[t[k>>2]>>0]|0){t[m>>2]=kj(w,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;t[(t[h>>2]|0)+12>>2]=t[m>>2];t[(t[h>>2]|0)+16>>2]=t[m>>2];if(!(t[m>>2]|0))break;t[(t[m>>2]|0)+32>>2]=t[(t[h>>2]|0)+32>>2];t[(t[m>>2]|0)+20>>2]=t[h>>2];break}r=uy(t[w+8>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;t[(t[h>>2]|0)+12>>2]=r;t[m>>2]=t[(t[h>>2]|0)+12>>2];while(1){if(!(t[m>>2]|0))break e;t[(t[m>>2]|0)+32>>2]=t[(t[h>>2]|0)+32>>2];t[(t[m>>2]|0)+20>>2]=t[h>>2];if(!(t[(t[m>>2]|0)+24>>2]|0))t[(t[h>>2]|0)+16>>2]=t[m>>2];t[m>>2]=t[(t[m>>2]|0)+24>>2]}}else g=30;while(0);if(((g|0)==30?(t[b>>2]|0)!=0:0)?(t[_>>2]=kj(t[o>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0,t[(t[h>>2]|0)+12>>2]=t[_>>2],t[(t[h>>2]|0)+16>>2]=t[_>>2],(t[_>>2]|0)!=0):0){t[(t[_>>2]|0)+32>>2]=t[(t[h>>2]|0)+32>>2];t[(t[_>>2]|0)+20>>2]=t[h>>2]}do if(((((t[(t[o>>2]|0)+32>>2]|0)==0?(t[(t[o>>2]|0)+104>>2]|0)!=0:0)?(t[(t[o>>2]|0)+12>>2]|0)!=0:0)?(t[(t[o>>2]|0)+8>>2]|0)!=0:0)?(t[(t[(t[o>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){if(t[(t[o>>2]|0)+16>>2]|0){t[d>>2]=ql(t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;_=aR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[h>>2]|0,t[d>>2]|0)|0;m=(t[o>>2]|0)+100|0;t[m>>2]=t[m>>2]&_;break}t[d>>2]=wj(t[o>>2]|0,t[b>>2]|0,t[k>>2]|0)|0;if(!(t[d>>2]|0))if(!(u[t[k>>2]>>0]|0)){_=aR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[h>>2]|0,t[b>>2]|0)|0;m=(t[o>>2]|0)+100|0;t[m>>2]=t[m>>2]&_;break}else{t[d>>2]=ql(t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;_=aR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[h>>2]|0,t[d>>2]|0)|0;m=(t[o>>2]|0)+100|0;t[m>>2]=t[m>>2]&_;break}if((t[(t[o>>2]|0)+352>>2]|0)!=0?(t[S>>2]=Ug(t[c>>2]|0,t[l>>2]|0,E,50)|0,(t[S>>2]|0)!=0):0){t[(t[o>>2]|0)+144>>2]=1;t[p>>2]=nR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[S>>2]|0,t[d>>2]|0)|0;if((t[(t[o>>2]|0)+144>>2]|0)!=1)t[(t[o>>2]|0)+100>>2]=0;if((t[S>>2]|0)!=(E|0)?(t[S>>2]|0)!=(t[c>>2]|0):0)pAi[t[135736>>2]&511](t[S>>2]|0);if(t[p>>2]|0){pAi[t[135736>>2]&511](t[d>>2]|0);t[d>>2]=t[p>>2]}}_=aR((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[h>>2]|0,t[d>>2]|0)|0;m=(t[o>>2]|0)+100|0;t[m>>2]=t[m>>2]&_}else g=54;while(0);do if((g|0)==54?(t[(t[o>>2]|0)+276>>2]&8|0)==0:0){if(!((t[(t[o>>2]|0)+16>>2]|0)==0?(t[(t[o>>2]|0)+96>>2]|0)!=2:0)){if(!(t[(t[o>>2]|0)+16>>2]|0))break;if(t[(t[o>>2]|0)+216>>2]|0)break}if((((t[l>>2]|0)==(t[(t[o>>2]|0)+312>>2]|0)?(u[t[c>>2]>>0]|0|0)==105:0)?(u[(t[c>>2]|0)+1>>0]|0|0)==100:0)?(u[(t[c>>2]|0)+2>>0]|0|0)==0:0){if(!(t[d>>2]|0))t[d>>2]=ql(t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;if(Vg(t[d>>2]|0,1)|0)oj(t[o>>2]|0,539,198200,t[d>>2]|0,0);zM((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[d>>2]|0,t[h>>2]|0)|0;break}if(VM(t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[h>>2]|0)|0){if(!(t[d>>2]|0))t[d>>2]=ql(t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;zM((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[d>>2]|0,t[h>>2]|0)|0;break}if(XM(t[(t[o>>2]|0)+8>>2]|0,t[(t[o>>2]|0)+52>>2]|0,t[h>>2]|0)|0){if(!(t[d>>2]|0))t[d>>2]=ql(t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;WM((t[o>>2]|0)+108|0,t[(t[o>>2]|0)+8>>2]|0,t[d>>2]|0,t[h>>2]|0)|0}}while(0);if(!(t[d>>2]|0)){s=a;return}pAi[t[135736>>2]&511](t[d>>2]|0);s=a;return}function kj(e,i,r){e=e|0;i=i|0;r=r|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;a=s;s=s+48|0;o=a+28|0;c=a+24|0;l=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+32|0;d=a+4|0;v=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[h>>2]=0;if(t[(t[c>>2]|0)+372>>2]|0){t[k>>2]=t[(t[c>>2]|0)+372>>2];t[(t[c>>2]|0)+372>>2]=t[(t[k>>2]|0)+24>>2];r=(t[c>>2]|0)+368|0;t[r>>2]=(t[r>>2]|0)+-1}else t[k>>2]=gAi[t[135744>>2]&511](60)|0;if(!(t[k>>2]|0)){Sp(t[c>>2]|0,198e3);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}r=(t[k>>2]|0)+0|0;i=r+60|0;do{t[r>>2]=0;r=r+4|0}while((r|0)<(i|0));e:do if(t[(t[c>>2]|0)+364>>2]|0){n[w>>0]=n[(t[l>>2]|0)+(t[b>>2]|0)>>0]|0;if((t[b>>2]|0)<8?(t[(t[c>>2]|0)+360>>2]&65536|0)!=0:0){t[d>>2]=(t[k>>2]|0)+44;YY(t[d>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;n[(t[d>>2]|0)+(t[b>>2]|0)>>0]=0;t[h>>2]=t[d>>2];break}do if((t[b>>2]|0)<=3){if((u[w>>0]|0|0)!=34?(u[w>>0]|0|0)!=39:0){if((u[w>>0]|0|0)!=60)break;if((u[(t[l>>2]|0)+((t[b>>2]|0)+1)>>0]|0|0)==33)break}t[h>>2]=kz(t[(t[c>>2]|0)+296>>2]|0,t[l>>2]|0,t[b>>2]|0)|0;break e}while(0);do if((u[t[l>>2]>>0]|0|0)!=32){if(9<=(u[t[l>>2]>>0]|0|0)?(u[t[l>>2]>>0]|0|0)<=10:0){_=20;break}if(!((t[b>>2]|0)<60?(u[t[l>>2]>>0]|0|0)==13:0))break e}else _=20;while(0);if((_|0)==20?(t[b>>2]|0)>=60:0)break;if((u[w>>0]|0|0)==60?(u[(t[l>>2]|0)+((t[b>>2]|0)+1)>>0]|0|0)!=33:0){t[v>>2]=1;while(1){if((t[v>>2]|0)>=(t[b>>2]|0))break;do if((u[(t[l>>2]|0)+(t[v>>2]|0)>>0]|0|0)!=32){if(9<=(u[(t[l>>2]|0)+(t[v>>2]|0)>>0]|0|0)?(u[(t[l>>2]|0)+(t[v>>2]|0)>>0]|0|0)<=10:0)break;if((u[(t[l>>2]|0)+(t[v>>2]|0)>>0]|0|0)!=13)break e}while(0);t[v>>2]=(t[v>>2]|0)+1}t[h>>2]=kz(t[(t[c>>2]|0)+296>>2]|0,t[l>>2]|0,t[b>>2]|0)|0}}while(0);t[(t[k>>2]|0)+4>>2]=3;t[(t[k>>2]|0)+8>>2]=75104;if(!(t[h>>2]|0)){v=ql(t[l>>2]|0,t[b>>2]|0)|0;t[(t[k>>2]|0)+40>>2]=v;if(!(t[(t[k>>2]|0)+40>>2]|0)){tj(t[c>>2]|0,198160);pAi[t[135736>>2]&511](t[k>>2]|0);t[o>>2]=0;m=t[o>>2]|0;s=a;return m|0}}else t[(t[k>>2]|0)+40>>2]=t[h>>2];do if((t[(t[c>>2]|0)+280>>2]|0)!=0?(t[(t[c>>2]|0)+36>>2]|0)!=0:0){if((t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2]|0)<65535){f[(t[k>>2]|0)+56>>1]=t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2];break}f[(t[k>>2]|0)+56>>1]=-1;if(t[(t[c>>2]|0)+360>>2]&4194304)t[(t[k>>2]|0)+52>>2]=t[(t[(t[c>>2]|0)+36>>2]|0)+28>>2]}while(0);if((t[18774]|0)!=0&(t[33968]|0)!=0)pAi[t[135872>>2]&511](t[k>>2]|0);t[o>>2]=t[k>>2];m=t[o>>2]|0;s=a;return m|0}function hj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0;u=s;s=s+32|0;a=u;o=u+24|0;c=u+20|0;l=u+16|0;b=u+12|0;k=u+8|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if(((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+212>>2]|0)!=0:0)?(t[(t[o>>2]|0)+172>>2]|0)==-1:0){s=u;return}if(t[o>>2]|0)t[(t[o>>2]|0)+84>>2]=t[c>>2];f=t[o>>2]|0;o=t[c>>2]|0;c=t[b>>2]|0;n=t[k>>2]|0;r=t[l>>2]|0;l=t[k>>2]|0;t[a>>2]=t[b>>2];t[a+4>>2]=l;cp(0,0,0,f,0,3,o,2,0,0,c,n,0,0,0,r,a);s=u;return}function wj(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;n=s;s=s+32|0;f=n+20|0;a=n+16|0;o=n+12|0;c=n+8|0;l=n+4|0;b=n;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=t[o>>2];while(1){if((t[l>>2]|0)>>>0>=(t[c>>2]|0)>>>0){k=4;break}r=t[l>>2]|0;t[l>>2]=r+1;if((u[r>>0]|0|0)==38){k=5;break}}if((k|0)==4){t[f>>2]=0;h=t[f>>2]|0;s=n;return h|0}else if((k|0)==5){k=(t[a>>2]|0)+248|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=kE(t[a>>2]|0,t[o>>2]|0,(t[c>>2]|0)-(t[o>>2]|0)|0,1,0,0,0)|0;o=(t[a>>2]|0)+248|0;t[o>>2]=(t[o>>2]|0)+-1;t[f>>2]=t[b>>2];h=t[f>>2]|0;s=n;return h|0}return 0}function dj(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;u=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;if(!(t[u>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}i=t[u>>2]|0;e:do if((t[f>>2]|0)>>>0<65536){if(!(t[i>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}t[o>>2]=0;t[c>>2]=(t[t[u>>2]>>2]|0)-1;t[b>>2]=t[(t[u>>2]|0)+8>>2];while(1){if((t[o>>2]|0)>(t[c>>2]|0))break e;t[l>>2]=((t[o>>2]|0)+(t[c>>2]|0)|0)/2|0;if((t[f>>2]&65535|0)<(a[(t[b>>2]|0)+(t[l>>2]<<2)>>1]|0|0)){t[c>>2]=(t[l>>2]|0)-1;continue}if((t[f>>2]&65535|0)<=(a[(t[b>>2]|0)+(t[l>>2]<<2)+2>>1]|0|0))break;t[o>>2]=(t[l>>2]|0)+1}t[n>>2]=1;h=t[n>>2]|0;s=r;return h|0}else{if(!(t[i+4>>2]|0)){t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}t[o>>2]=0;t[c>>2]=(t[(t[u>>2]|0)+4>>2]|0)-1;t[k>>2]=t[(t[u>>2]|0)+12>>2];while(1){if((t[o>>2]|0)>(t[c>>2]|0))break e;t[l>>2]=((t[o>>2]|0)+(t[c>>2]|0)|0)/2|0;if((t[f>>2]|0)>>>0<(t[(t[k>>2]|0)+(t[l>>2]<<3)>>2]|0)>>>0){t[c>>2]=(t[l>>2]|0)-1;continue}if((t[f>>2]|0)>>>0<=(t[(t[k>>2]|0)+(t[l>>2]<<3)+4>>2]|0)>>>0)break;t[o>>2]=(t[l>>2]|0)+1}t[n>>2]=1;
	h=t[n>>2]|0;s=r;return h|0}while(0);t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}function vj(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+8>>2]|0)vj(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+32>>2]|0)Lj(t[(t[r>>2]|0)+32>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+28>>2]|0){e:do if(!(t[(t[r>>2]|0)+4>>2]|0)){t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[r>>2]|0)+20>>2]|0))break e;t[n>>2]=(t[(t[r>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0);if(t[(t[n>>2]|0)+4>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+4>>2]|0);if(t[(t[n>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[n>>2]|0)+8>>2]|0);t[f>>2]=(t[f>>2]|0)+1}}while(0);pAi[t[135736>>2]&511](t[(t[r>>2]|0)+28>>2]|0)}if(t[(t[r>>2]|0)+4>>2]|0)bz(t[(t[r>>2]|0)+4>>2]|0);f=(t[r>>2]|0)+0|0;n=f+36|0;do{t[f>>2]=-1;f=f+4|0}while((f|0)<(n|0));pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function mj(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[r>>2];t[r>>2]=t[(t[r>>2]|0)+8>>2];t[(t[n>>2]|0)+8>>2]=0;vj(t[n>>2]|0)}s=i;return}function _j(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];if(t[(t[r>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function pj(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=Dj(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,1)|0;s=n;return r|0}function Ej(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;n=Dj(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0)|0;s=f;return n|0}function Sj(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=Dj(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,2)|0;s=n;return r|0}function gj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}while(1){if(!(t[n>>2]|0))break;if((t[(t[n>>2]|0)+28>>2]|0)==(t[(t[n>>2]|0)+16>>2]|0))t[(t[n>>2]|0)+28>>2]=-1;if(t[(t[n>>2]|0)+16>>2]|0){e=(t[n>>2]|0)+16|0;t[e>>2]=(t[e>>2]|0)+-1}t[f>>2]=(t[(t[n>>2]|0)+8>>2]|0)-1;while(1){if((t[f>>2]|0)<0)break;t[u>>2]=t[(t[(t[n>>2]|0)+20>>2]|0)+((t[f>>2]<<1)+1<<2)>>2];if((t[u>>2]|0)>(t[(t[n>>2]|0)+16>>2]|0)){e=(t[n>>2]|0)+8|0;t[e>>2]=(t[e>>2]|0)+-1}if((t[u>>2]|0)<=(t[(t[n>>2]|0)+16>>2]|0))break;t[f>>2]=(t[f>>2]|0)+-1}t[n>>2]=t[t[n>>2]>>2]}t[r>>2]=0;a=t[r>>2]|0;s=i;return a|0}function yj(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0){while(1){if(!(t[n>>2]|0)){f=7;break}if(t[(t[(t[n>>2]|0)+4>>2]|0)+16>>2]&16384){f=5;break}t[n>>2]=t[t[n>>2]>>2]}if((f|0)==5){t[r>>2]=1;break}else if((f|0)==7){t[r>>2]=0;break}}else t[r>>2]=-1;while(0);s=i;return t[r>>2]|0}function Fj(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;f=s;s=s+64|0;a=f+48|0;o=f+44|0;c=f+40|0;l=f+36|0;b=f+32|0;k=f+28|0;h=f+24|0;w=f+20|0;d=f+16|0;v=f+12|0;m=f+8|0;_=f+4|0;p=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=0;t[w>>2]=0;t[m>>2]=0;t[_>>2]=0;t[p>>2]=1;if(!(t[o>>2]|0)){t[a>>2]=0;E=t[a>>2]|0;s=f;return E|0}t[v>>2]=t[o>>2];t[d>>2]=t[v>>2];while(1){if(!(u[t[d>>2]>>0]|0)){S=41;break}t[m>>2]=0;while(1){if(u[t[d>>2]>>0]|0)g=(u[t[d>>2]>>0]|0|0)!=124;else g=0;y=t[d>>2]|0;if(!g)break;t[d>>2]=y+1}o=t[v>>2]|0;if(!(u[y>>0]|0))t[w>>2]=Cj(o,t[c>>2]|0,t[b>>2]|0)|0;else{t[m>>2]=ql(o,(t[d>>2]|0)-(t[v>>2]|0)|0)|0;if(t[m>>2]|0)t[w>>2]=Cj(t[m>>2]|0,t[c>>2]|0,t[b>>2]|0)|0;t[d>>2]=(t[d>>2]|0)+1}if(!(t[w>>2]|0)){S=48;break}t[h>>2]=Pj()|0;if(!(t[h>>2]|0)){S=48;break}if(t[c>>2]|0){t[(t[h>>2]|0)+4>>2]=t[c>>2];sz(t[c>>2]|0)|0}if(!(t[k>>2]|0))t[k>>2]=t[h>>2];else{t[(t[h>>2]|0)+8>>2]=t[(t[k>>2]|0)+8>>2];t[(t[k>>2]|0)+8>>2]=t[h>>2]}t[(t[h>>2]|0)+16>>2]=t[l>>2];t[(t[w>>2]|0)+16>>2]=t[h>>2];o=t[w>>2]|0;if(t[(t[h>>2]|0)+16>>2]&6)Bj(o);else Ij(o);if(t[(t[w>>2]|0)+8>>2]|0){S=48;break}Hj(t[w>>2]|0);t[w>>2]=0;do if(t[p>>2]|0){if(!(t[_>>2]|0)){t[_>>2]=t[(t[h>>2]|0)+16>>2]&768;break}if((t[_>>2]|0)==256){if(!(t[(t[h>>2]|0)+16>>2]&512))break;t[p>>2]=0;break}if((t[_>>2]|0)==512?(t[(t[h>>2]|0)+16>>2]&256|0)!=0:0)t[p>>2]=0}while(0);if(t[p>>2]|0)xj(t[h>>2]|0)|0;if((Uj(t[h>>2]|0)|0)<0){S=48;break}if(t[m>>2]|0){pAi[t[135736>>2]&511](t[m>>2]|0);t[m>>2]=0}t[v>>2]=t[d>>2]}if((S|0)==41){e:do if(!(t[p>>2]|0)){t[h>>2]=t[k>>2];while(1){if(!(t[h>>2]|0))break e;if(t[(t[h>>2]|0)+32>>2]|0){Lj(t[(t[h>>2]|0)+32>>2]|0);t[(t[h>>2]|0)+32>>2]=0}t[h>>2]=t[(t[h>>2]|0)+8>>2]}}while(0);t[a>>2]=t[k>>2];E=t[a>>2]|0;s=f;return E|0}else if((S|0)==48){if(t[w>>2]|0)Hj(t[w>>2]|0);if(t[k>>2]|0)vj(t[k>>2]|0);if(t[m>>2]|0)pAi[t[135736>>2]&511](t[m>>2]|0);t[a>>2]=0;E=t[a>>2]|0;s=f;return E|0}return 0}function Oj(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(1){if(!(t[f>>2]|0)){c=7;break}t[a>>2]=zj(t[f>>2]|0,t[u>>2]|0)|0;if(t[a>>2]|0){c=5;break}t[f>>2]=t[(t[f>>2]|0)+8>>2]}if((c|0)==5){t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}else if((c|0)==7){t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function Aj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+32>>2]|0)!=0:0){while(1){if(!(t[n>>2]|0)){a=11;break}if(!(t[(t[n>>2]|0)+32>>2]|0)){a=12;break}t[u>>2]=jj(t[(t[n>>2]|0)+32>>2]|0)|0;if(!(t[u>>2]|0)){a=12;break}if(!(t[f>>2]|0))t[f>>2]=t[u>>2];else{t[t[u>>2]>>2]=t[t[f>>2]>>2];t[t[f>>2]>>2]=t[u>>2]}t[(t[u>>2]|0)+24>>2]=t[(t[n>>2]|0)+16>>2];t[n>>2]=t[(t[n>>2]|0)+8>>2]}if((a|0)==11){t[r>>2]=t[f>>2];o=t[r>>2]|0;s=i;return o|0}else if((a|0)==12){_j(t[f>>2]|0);t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}}t[r>>2]=0;o=t[r>>2]|0;s=i;return o|0}function Mj(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0){while(1){if(!(t[n>>2]|0)){f=7;break}if(!(t[(t[n>>2]|0)+32>>2]|0)){f=5;break}t[n>>2]=t[(t[n>>2]|0)+8>>2]}if((f|0)==5){t[r>>2]=0;break}else if((f|0)==7){t[r>>2]=1;break}}else t[r>>2]=-1;while(0);s=i;return t[r>>2]|0}function Rj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0;i=s;s=s+16|0;r=i+12|0;n=i+8|0;f=i+4|0;u=i;t[n>>2]=e;t[f>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}e:while(1){if(!(t[n>>2]|0)){o=14;break}if(!(t[(t[n>>2]|0)+32>>2]|0)){o=5;break}t[u>>2]=0;while(1){if((t[u>>2]|0)>=(t[(t[(t[n>>2]|0)+32>>2]|0)+4>>2]|0))break;if(t[(t[(t[(t[n>>2]|0)+32>>2]|0)+12>>2]|0)+(t[u>>2]<<4)>>2]&1){o=9;break e}t[u>>2]=(t[u>>2]|0)+1}if((t[(t[(t[n>>2]|0)+32>>2]|0)+4>>2]|0)>(t[f>>2]|0))t[f>>2]=t[(t[(t[n>>2]|0)+32>>2]|0)+4>>2];t[n>>2]=t[(t[n>>2]|0)+8>>2]}if((o|0)==5){t[r>>2]=-1;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==9){t[r>>2]=-2;a=t[r>>2]|0;s=i;return a|0}else if((o|0)==14){t[r>>2]=t[f>>2];a=t[r>>2]|0;s=i;return a|0}return 0}function Nj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=12345678;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}while(1){if(!(t[n>>2]|0)){a=11;break}if(!(t[(t[n>>2]|0)+32>>2]|0)){a=5;break}if((t[(t[(t[n>>2]|0)+32>>2]|0)+4>>2]|0)<(t[f>>2]|0))t[f>>2]=t[(t[(t[n>>2]|0)+32>>2]|0)+4>>2];if(!(t[f>>2]|0)){a=9;break}t[n>>2]=t[(t[n>>2]|0)+8>>2]}if((a|0)==5){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}else if((a|0)==9){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else if((a|0)==11){t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Tj(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0){while(1){if(!(t[n>>2]|0)){f=9;break}if(!(t[(t[n>>2]|0)+32>>2]|0)){f=5;break}if(t[(t[n>>2]|0)+16>>2]&256){f=7;break}t[n>>2]=t[(t[n>>2]|0)+8>>2]}if((f|0)==5){t[r>>2]=-1;break}else if((f|0)==7){t[r>>2]=1;break}else if((f|0)==9){t[r>>2]=0;break}}else t[r>>2]=-1;while(0);s=i;return t[r>>2]|0}function Lj(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[t[r>>2]>>2]|0)bz(t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Dj(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0;f=s;s=s+80|0;a=f+72|0;o=f+68|0;c=f+64|0;l=f+60|0;b=f+56|0;k=f+52|0;h=f+48|0;w=f+44|0;d=f+40|0;v=f+36|0;m=f+32|0;_=f+28|0;p=f+24|0;E=f+20|0;S=f+16|0;g=f;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=0;t[h>>2]=0;t[w>>2]=0;if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+8>>2]|0)>=0:0){e:while(1){if(!(t[o>>2]|0))break;t[S>>2]=t[(t[o>>2]|0)+4>>2];if((t[b>>2]|0)==1&(t[c>>2]|0)==0&(t[l>>2]|0)==0){t[(t[o>>2]|0)+8>>2]=0;t[(t[o>>2]|0)+16>>2]=0;t[(t[o>>2]|0)+28>>2]=-1;do if(t[(t[S>>2]|0)+16>>2]&32768){if(!(t[(t[S>>2]|0)+4>>2]|0)){t[k>>2]=1;break}if(((t[(t[S>>2]|0)+4>>2]|0)==1?(t[(t[(t[S>>2]|0)+12>>2]|0)+12>>2]|0)==100:0)?(t[t[(t[S>>2]|0)+12>>2]>>2]&1|0)!=0:0){t[k>>2]=1;break}if((t[t[(t[S>>2]|0)+12>>2]>>2]&4|0)!=0?(t[d>>2]=Vj(t[o>>2]|0,0,0)|0,(t[d>>2]|0)<0):0)t[h>>2]=(t[h>>2]|0)+1}while(0);t[o>>2]=t[t[o>>2]>>2];continue}n=t[o>>2]|0;i:do if(t[(t[S>>2]|0)+4>>2]|0){if((t[n+28>>2]|0)!=-1){r=(t[o>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+1;break}if((t[b>>2]|0)!=1&(t[b>>2]|0)!=2?(t[(t[S>>2]|0)+16>>2]&16384|0)==0:0){r=(t[o>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+1;break}t[v>>2]=0;t[m>>2]=t[(t[o>>2]|0)+8>>2];while(1){if((t[v>>2]|0)>=(t[m>>2]|0))break;if(t[(t[S>>2]|0)+16>>2]&65536){t[p>>2]=t[(t[(t[o>>2]|0)+20>>2]|0)+(t[v>>2]<<1<<2)>>2];if(((t[p>>2]|0)>=0?(t[d>>2]=t[(t[(t[o>>2]|0)+20>>2]|0)+((t[v>>2]<<1)+1<<2)>>2],(t[d>>2]|0)<=(t[(t[o>>2]|0)+16>>2]|0)):0)?(t[E>>2]=t[(t[(t[S>>2]|0)+12>>2]|0)+(t[p>>2]<<4)>>2]&1,(t[E>>2]|0)!=0?1:(t[d>>2]|0)>=(t[(t[o>>2]|0)+16>>2]|0)):0)y=39}else{t[p>>2]=t[(t[(t[o>>2]|0)+20>>2]|0)+((t[(t[o>>2]|0)+8>>2]|0)-1<<1<<2)>>2];if((t[(t[(t[o>>2]|0)+20>>2]|0)+(((t[(t[o>>2]|0)+8>>2]|0)-1<<1)+1<<2)>>2]|0)<(t[(t[o>>2]|0)+16>>2]|0)){y=34;break e}t[E>>2]=0;t[v>>2]=t[m>>2];y=39}r:do if((y|0)==39){y=0;r=(t[(t[S>>2]|0)+12>>2]|0)+(t[p>>2]<<4)|0;t[g+0>>2]=t[r+0>>2];t[g+4>>2]=t[r+4>>2];t[g+8>>2]=t[r+8>>2];t[g+12>>2]=t[r+12>>2];do if((t[g+12>>2]|0)!=(t[b>>2]|0)){if((t[g+12>>2]|0)!=2)if((t[g+12>>2]|0)!=100)break r;else break;if(t[(t[S>>2]|0)+16>>2]&65536)break r;t[(t[o>>2]|0)+28>>2]=(t[(t[o>>2]|0)+16>>2]|0)+1;break r}while(0);t[_>>2]=0;do if((t[g+12>>2]|0)!=100){r=t[g+8>>2]|0;if(!(t[g+4>>2]|0)){if(!r){t[_>>2]=1;break}if(!(t[l>>2]|0))break;t[_>>2]=Xl(t[g+8>>2]|0,t[l>>2]|0)|0;break}if(((t[c>>2]|0)!=0?((r|0)!=0|0)==((t[l>>2]|0)!=0|0):0)?(u[t[g+4>>2]>>0]|0|0)==(u[t[c>>2]>>0]|0|0):0){if(!(Xl(t[g+4>>2]|0,t[c>>2]|0)|0))break;if((t[g+8>>2]|0)!=(t[l>>2]|0)?(Xl(t[g+8>>2]|0,t[l>>2]|0)|0)==0:0)break;t[_>>2]=1}}else t[_>>2]=1;while(0);do if(t[_>>2]|0){t[w>>2]=t[g>>2]&2;r=(t[w>>2]|0)!=0;do if(t[E>>2]|0)if(r){t[k>>2]=1;break}else{Vj(t[o>>2]|0,(t[p>>2]|0)+1|0,(t[(t[o>>2]|0)+16>>2]|0)+1|0)|0;break}else if(r){t[k>>2]=1;break}else{Vj(t[o>>2]|0,(t[p>>2]|0)+1|0,(t[(t[o>>2]|0)+16>>2]|0)+1|0)|0;break}while(0);if((t[k>>2]|0)!=1){if(!(t[g>>2]&32))break;t[k>>2]=1}}while(0);if((t[(t[S>>2]|0)+16>>2]&65536|0)==0?(t[_>>2]|0)==0|(t[w>>2]|0)!=0:0)t[(t[o>>2]|0)+28>>2]=(t[(t[o>>2]|0)+16>>2]|0)+1}while(0);t[v>>2]=(t[v>>2]|0)+1}r=(t[o>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+1;r=t[(t[S>>2]|0)+12>>2]|0;t[g+0>>2]=t[r+0>>2];t[g+4>>2]=t[r+4>>2];t[g+8>>2]=t[r+8>>2];t[g+12>>2]=t[r+12>>2];if(!(t[g>>2]&4)){t[E>>2]=t[g>>2]&1;do if(t[(t[o>>2]|0)+24>>2]&7){if((t[(t[o>>2]|0)+16>>2]|0)==1)if(t[(t[o>>2]|0)+24>>2]&6)break i;else break;if(!(t[E>>2]|0)){if((t[(t[o>>2]|0)+16>>2]|0)!=2)break i;if(!(t[(t[o>>2]|0)+24>>2]&6))break i}}while(0);if((t[g+12>>2]|0)!=(t[b>>2]|0)){if((t[b>>2]|0)==2)break;if((t[g+12>>2]|0)!=100)break}t[_>>2]=0;do if((t[g+12>>2]|0)!=100){r=t[g+8>>2]|0;if(!(t[g+4>>2]|0)){if(!r){t[_>>2]=1;break}if(!(t[l>>2]|0))break;t[_>>2]=Xl(t[g+8>>2]|0,t[l>>2]|0)|0;break}if((((t[c>>2]|0)!=0?((r|0)!=0|0)==((t[l>>2]|0)!=0|0):0)?(u[t[g+4>>2]>>0]|0|0)==(u[t[c>>2]>>0]|0|0):0)?(Xl(t[g+4>>2]|0,t[c>>2]|0)|0)!=0:0){if((t[g+8>>2]|0)!=(t[l>>2]|0)?(Xl(t[g+8>>2]|0,t[l>>2]|0)|0)==0:0)break;t[_>>2]=1}}else t[_>>2]=1;while(0);t[w>>2]=t[g>>2]&2;if(t[_>>2]|0){if(t[w>>2]|0)t[k>>2]=1;else Vj(t[o>>2]|0,1,t[(t[o>>2]|0)+16>>2]|0)|0;if((t[k>>2]|0)!=1?(t[g>>2]&32|0)!=0:0)t[k>>2]=1}if((t[(t[S>>2]|0)+16>>2]&65536|0)==0?(t[_>>2]|0)==0|(t[w>>2]|0)!=0:0)t[(t[o>>2]|0)+28>>2]=t[(t[o>>2]|0)+16>>2]}}else{if(t[n+24>>2]&1){t[o>>2]=t[t[o>>2]>>2];continue e}do if((t[b>>2]|0)!=2){if((t[(t[o>>2]|0)+24>>2]&7|0)!=0?(t[(t[o>>2]|0)+16>>2]|0)!=0:0)break;t[k>>2]=1}while(0);r=(t[o>>2]|0)+16|0;t[r>>2]=(t[r>>2]|0)+1}while(0);t[o>>2]=t[t[o>>2]>>2]}if((y|0)==34){t[a>>2]=-1;F=t[a>>2]|0;s=f;return F|0}if((t[h>>2]|0)>0)t[k>>2]=-1;t[a>>2]=t[k>>2];F=t[a>>2]|0;s=f;return F|0}t[a>>2]=-1;F=t[a>>2]|0;s=f;return F|0}function Cj(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;if(!(t[u>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[c>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[c>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}r=t[c>>2]|0;t[r+0>>2]=0;t[r+4>>2]=0;t[r+8>>2]=0;t[r+12>>2]=0;t[r+16>>2]=0;t[r+20>>2]=0;t[r+24>>2]=0;t[r+28>>2]=0;t[(t[c>>2]|0)+12>>2]=t[a>>2];t[t[c>>2]>>2]=t[u>>2];t[(t[c>>2]|0)+4>>2]=t[u>>2];if(t[o>>2]|0){t[l>>2]=0;while(1){k=t[l>>2]|0;if(!(t[(t[o>>2]|0)+(t[l>>2]<<1<<2)>>2]|0))break;t[l>>2]=k+1}t[(t[c>>2]|0)+28>>2]=k}else t[(t[c>>2]|0)+28>>2]=0;t[(t[c>>2]|0)+24>>2]=t[o>>2];t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function Pj(){var e=0,i=0,r=0,n=0,f=0,u=0;e=s;s=s+16|0;i=e+4|0;r=e;t[r>>2]=gAi[t[135744>>2]&511](36)|0;if(!(t[r>>2]|0)){t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}f=(t[r>>2]|0)+0|0;u=f+36|0;do{t[f>>2]=0;f=f+4|0}while((f|0)<(u|0));t[(t[r>>2]|0)+24>>2]=10;f=gAi[t[135744>>2]&511]((t[(t[r>>2]|0)+24>>2]|0)*12|0)|0;t[(t[r>>2]|0)+28>>2]=f;if(!(t[(t[r>>2]|0)+28>>2]|0)){pAi[t[135736>>2]&511](t[r>>2]|0);t[i>>2]=0;n=t[i>>2]|0;s=e;return n|0}else{t[i>>2]=t[r>>2];n=t[i>>2]|0;s=e;return n|0}return 0}function Bj(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+16|0;r=i;t[r>>2]=e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);f=u[t[t[r>>2]>>2]>>0]|0;if(!n)break;e=t[r>>2]|0;if(!f)continue;t[e>>2]=(t[e>>2]|0)+1}e:do if((f|0)!=47){n=(t[(t[r>>2]|0)+16>>2]|0)+16|0;t[n>>2]=t[n>>2]|512;if((u[t[t[r>>2]>>2]>>0]|0|0)==46){n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)a=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){a=1;break}a=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);o=u[t[t[r>>2]>>2]>>0]|0;if(!a)break;n=t[r>>2]|0;if(!o)continue;t[n>>2]=(t[n>>2]|0)+1}n=t[r>>2]|0;if(!o){if(qj(n,t[(t[r>>2]|0)+16>>2]|0,2,0,0)|0)break;s=i;return}if((u[t[n>>2]>>0]|0|0)!=47)break;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)c=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){c=1;break}c=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);l=u[t[t[r>>2]>>2]>>0]|0;if(!c)break;n=t[r>>2]|0;if(!l)continue;t[n>>2]=(t[n>>2]|0)+1}i:do if((l|0)==47){if((u[(t[t[r>>2]>>2]|0)+-1>>0]|0|0)==32)break e;if(9<=(u[(t[t[r>>2]>>2]|0)+-1>>0]|0|0)?(u[(t[t[r>>2]>>2]|0)+-1>>0]|0|0)<=10:0)break e;if((u[(t[t[r>>2]>>2]|0)+-1>>0]|0|0)==13)break e;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,6,0,0)|0)break e;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break i}while(0);n=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[n>>2]=(t[n>>2]|0)+1}}while(0);if(u[t[t[r>>2]>>2]>>0]|0)b=47}else b=47;i:do if((b|0)==47){while(1){b=0;Yj(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)break e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);h=u[t[t[r>>2]>>2]>>0]|0;if(!k)break;n=t[r>>2]|0;if(!h)continue;t[n>>2]=(t[n>>2]|0)+1}if((h|0)!=47)break;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,5,0,0)|0)break e;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)w=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){w=1;break}w=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);d=u[t[t[r>>2]>>2]>>0]|0;if(!w)break;n=t[r>>2]|0;if(!d)continue;t[n>>2]=(t[n>>2]|0)+1}if((d|0)==47)break e;if(!(u[t[t[r>>2]>>2]>>0]|0))break i;if(u[t[t[r>>2]>>2]>>0]|0)b=47;else break}if(!(u[t[t[r>>2]>>2]>>0]|0)){s=i;return}t[(t[r>>2]|0)+8>>2]=1;s=i;return}while(0);t[(t[r>>2]|0)+8>>2]=1;s=i;return}while(0);t[(t[r>>2]|0)+8>>2]=1;s=i;return}function Ij(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;i=s;s=s+16|0;r=i;t[r>>2]=e;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);f=u[t[t[r>>2]>>2]>>0]|0;if(!n)break;e=t[r>>2]|0;if(!f)continue;t[e>>2]=(t[e>>2]|0)+1}n=t[r>>2]|0;do if((f|0)==47){e=(t[n+16>>2]|0)+16|0;t[e>>2]=t[e>>2]|256}else{if((u[t[n>>2]>>0]|0|0)!=46?(t[(t[(t[r>>2]|0)+16>>2]|0)+16>>2]&7|0)==0:0)break;e=(t[(t[r>>2]|0)+16>>2]|0)+16|0;t[e>>2]=t[e>>2]|512}while(0);if((u[t[t[r>>2]>>2]>>0]|0|0)==47?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==47:0){if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,6,0,0)|0){s=i;return}n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1}else a=21;if((((a|0)==21?(u[t[t[r>>2]>>2]>>0]|0|0)==46:0)?(u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)==47:0)?(u[(t[t[r>>2]>>2]|0)+2>>0]|0|0)==47:0){if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,6,0,0)|0){s=i;return}n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;n=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[n>>2]=(t[n>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);c=u[t[t[r>>2]>>2]>>0]|0;if(!o)break;n=t[r>>2]|0;if(!c)continue;t[n>>2]=(t[n>>2]|0)+1}if(!c){t[(t[r>>2]|0)+8>>2]=1;s=i;return}}c=u[t[t[r>>2]>>2]>>0]|0;e:do if((u[t[t[r>>2]>>2]>>0]|0|0)==64){o=t[r>>2]|0;if(c)t[o>>2]=(t[o>>2]|0)+1;Gj(t[r>>2]|0);while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);b=(u[t[t[r>>2]>>2]>>0]|0|0)!=0;if(!l)break;o=t[r>>2]|0;if(!b)continue;t[o>>2]=(t[o>>2]|0)+1}if(b?(Yj(t[r>>2]|0),(t[(t[r>>2]|0)+8>>2]|0)!=0):0){s=i;return}}else{if((c|0)==47){if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,1,0,0)|0){s=i;return}o=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[o>>2]=(t[o>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);h=u[t[t[r>>2]>>2]>>0]|0;if(!k)break;o=t[r>>2]|0;if(!h)continue;t[o>>2]=(t[o>>2]|0)+1}if(!h){t[(t[r>>2]|0)+8>>2]=1;s=i;return}}Yj(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0){s=i;return}i:while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break i}while(0);o=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[o>>2]=(t[o>>2]|0)+1}while(1){if((u[t[t[r>>2]>>2]>>0]|0|0)!=47)break e;o=t[r>>2]|0;n=t[(t[r>>2]|0)+16>>2]|0;if((u[(t[t[r>>2]>>2]|0)+1>>0]|0|0)!=47){if(qj(o,n,5,0,0)|0){a=103;break}f=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)w=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){w=1;break}w=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);d=u[t[t[r>>2]>>2]>>0]|0;if(!w)break;f=t[r>>2]|0;if(!d)continue;t[f>>2]=(t[f>>2]|0)+1}v=t[r>>2]|0;if(!d){a=99;break}Yj(v);if(t[(t[r>>2]|0)+8>>2]|0){a=103;break}else continue}if(qj(o,n,6,0,0)|0){a=103;break}f=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;f=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[f>>2]=(t[f>>2]|0)+1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)m=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);_=t[r>>2]|0;if(!m)break;f=t[r>>2]|0;if(!(u[t[_>>2]>>0]|0))continue;t[f>>2]=(t[f>>2]|0)+1}Yj(_);if(t[(t[r>>2]|0)+8>>2]|0){a=103;break}}if((a|0)==99){t[v+8>>2]=1;s=i;return}else if((a|0)==103){s=i;return}}while(0);if(!(u[t[t[r>>2]>>2]>>0]|0)){s=i;return}t[(t[r>>2]|0)+8>>2]=1;s=i;return}function Hj(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}e=t[r>>2]|0;t[e+0>>2]=-1;t[e+4>>2]=-1;t[e+8>>2]=-1;t[e+12>>2]=-1;t[e+16>>2]=-1;t[e+20>>2]=-1;t[e+24>>2]=-1;t[e+28>>2]=-1;pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function xj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;i=s;s=s+48|0;r=i+40|0;n=i+36|0;f=i+32|0;u=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i;t[n>>2]=e;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;t[l>>2]=-1;if((t[n>>2]|0)!=0?(t[(t[n>>2]|0)+28>>2]|0)!=0:0){if((((t[(t[n>>2]|0)+20>>2]|0)==1?(t[t[(t[n>>2]|0)+28>>2]>>2]|0)==2:0)?(t[(t[(t[n>>2]|0)+28>>2]|0)+4>>2]|0)==0:0)?(t[(t[(t[n>>2]|0)+28>>2]|0)+8>>2]|0)==0:0){t[f>>2]=Wj(0)|0;if(!(t[f>>2]|0)){t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}else{e=(t[f>>2]|0)+16|0;t[e>>2]=t[e>>2]|16384;t[(t[n>>2]|0)+32>>2]=t[f>>2];t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}}t[f>>2]=Wj(((t[(t[n>>2]|0)+20>>2]|0)/2|0)+1|0)|0;if(!(t[f>>2]|0)){t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}if(t[(t[n>>2]|0)+4>>2]|0){t[t[f>>2]>>2]=t[(t[n>>2]|0)+4>>2];sz(t[t[f>>2]>>2]|0)|0}t[u>>2]=0;if(t[(t[n>>2]|0)+16>>2]&256){e=(t[f>>2]|0)+16|0;t[e>>2]=t[e>>2]|32768}e:while(1){if((t[u>>2]|0)>=(t[(t[n>>2]|0)+20>>2]|0)){h=43;break}e=(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)|0;t[b+0>>2]=t[e+0>>2];t[b+4>>2]=t[e+4>>2];t[b+8>>2]=t[e+8>>2];i:do switch(t[b>>2]|0){case 1:{if(t[u>>2]|0)break e;t[o>>2]=1;break}case 2:{if((t[b+4>>2]|0)==0?(t[b+8>>2]|0)==0:0){if((t[(t[n>>2]|0)+20>>2]|0)!=((t[u>>2]|0)+1|0))break i;if(!(t[c>>2]&1))break i;if((t[(t[n>>2]|0)+20>>2]|0)==((t[u>>2]|0)+1|0)){e=(t[f>>2]|0)+16|0;t[e>>2]=t[e>>2]|16384}t[c>>2]=t[c>>2]|16;t[a>>2]=Kj(t[f>>2]|0,0,0,100,t[c>>2]|0)|0;if((t[a>>2]|0)<0)break e;t[c>>2]=0;if((t[l>>2]|0)==-1)break i;e=(t[(t[f>>2]|0)+12>>2]|0)+(t[l>>2]<<4)|0;t[e>>2]=t[e>>2]|32;t[l>>2]=-1;break i}t[a>>2]=Kj(t[f>>2]|0,t[b+4>>2]|0,t[b+8>>2]|0,1,t[c>>2]|0)|0;if((t[a>>2]|0)<0)break e;t[l>>2]=t[a>>2];t[c>>2]=0;break}case 6:{if((t[c>>2]&1|0)==0?(t[c>>2]=t[c>>2]|1,(t[(t[f>>2]|0)+16>>2]&65536|0)==0):0){e=(t[f>>2]|0)+16|0;t[e>>2]=t[e>>2]|65536}break}case 4:{t[c>>2]=t[c>>2]|8;t[l>>2]=-1;t[a>>2]=Kj(t[f>>2]|0,t[b+4>>2]|0,t[b+8>>2]|0,2,t[c>>2]|0)|0;t[c>>2]=0;if((t[a>>2]|0)<0)break e;break}case 8:{t[a>>2]=Kj(t[f>>2]|0,0,0,1,t[c>>2]|0)|0;if((t[a>>2]|0)<0)break e;t[l>>2]=t[a>>2];t[c>>2]=0;break}case 7:{t[a>>2]=Kj(t[f>>2]|0,0,t[b+4>>2]|0,1,t[c>>2]|0)|0;if((t[a>>2]|0)<0)break e;t[l>>2]=t[a>>2];t[c>>2]=0;break}case 3:{t[a>>2]=Kj(t[f>>2]|0,t[b+4>>2]|0,t[b+8>>2]|0,1,t[c>>2]|0)|0;if((t[a>>2]|0)<0)break e;t[l>>2]=t[a>>2];t[c>>2]=0;break}default:{}}while(0);t[u>>2]=(t[u>>2]|0)+1}if((h|0)==43){if((t[o>>2]|0)==0?(t[(t[n>>2]|0)+16>>2]&7|0)==0:0){if(!(t[(t[f>>2]|0)+16>>2]&65536)){h=(t[f>>2]|0)+16|0;t[h>>2]=t[h>>2]|65536}if((t[(t[f>>2]|0)+4>>2]|0)>0?(t[t[(t[f>>2]|0)+12>>2]>>2]&1|0)==0:0){h=t[(t[f>>2]|0)+12>>2]|0;t[h>>2]=t[h>>2]|1}}if((t[(t[f>>2]|0)+4>>2]|0)>(t[a>>2]|0)){h=(t[(t[f>>2]|0)+12>>2]|0)+(t[a>>2]<<4)|0;t[h>>2]=t[h>>2]|2;if(t[o>>2]|0){o=t[(t[f>>2]|0)+12>>2]|0;t[o>>2]=t[o>>2]|4}t[(t[n>>2]|0)+32>>2]=t[f>>2];t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}}Lj(t[f>>2]|0);t[r>>2]=0;k=t[r>>2]|0;s=i;return k|0}t[r>>2]=-1;k=t[r>>2]|0;s=i;return k|0}function Uj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;u=i+12|0;a=i+8|0;o=i+4|0;c=i;t[n>>2]=e;if((t[(t[n>>2]|0)+20>>2]|0)>0?(t[t[(t[n>>2]|0)+28>>2]>>2]|0)==6:0){t[f>>2]=0;t[u>>2]=1;while(1){if((t[u>>2]|0)>=(t[(t[n>>2]|0)+20>>2]|0))break;t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)+4>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)+4>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)+8>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)+8>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)>>2];t[f>>2]=(t[f>>2]|0)+1;t[u>>2]=(t[u>>2]|0)+1}e=(t[n>>2]|0)+20|0;t[e>>2]=(t[e>>2]|0)+-1}do if((t[(t[n>>2]|0)+20>>2]|0)>=(t[(t[n>>2]|0)+24>>2]|0)){t[a>>2]=MAi[t[135760>>2]&511](t[(t[n>>2]|0)+28>>2]|0,(t[(t[n>>2]|0)+24>>2]<<1)*12|0)|0;if(t[a>>2]|0){t[(t[n>>2]|0)+28>>2]=t[a>>2];e=(t[n>>2]|0)+24|0;t[e>>2]=t[e>>2]<<1;break}t[r>>2]=-1;l=t[r>>2]|0;s=i;return l|0}while(0);t[f>>2]=0;t[u>>2]=(t[(t[n>>2]|0)+20>>2]|0)-1;while(1){if((t[u>>2]|0)<=(t[f>>2]|0))break;t[o>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)+4>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)+4>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)+4>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)+4>>2]=t[o>>2];t[o>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)+8>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)+8>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)+8>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)+8>>2]=t[o>>2];t[c>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[f>>2]|0)*12|0)>>2]=t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)>>2];t[(t[(t[n>>2]|0)+28>>2]|0)+((t[u>>2]|0)*12|0)>>2]=t[c>>2];t[u>>2]=(t[u>>2]|0)+-1;t[f>>2]=(t[f>>2]|0)+1}t[(t[(t[n>>2]|0)+28>>2]|0)+((t[(t[n>>2]|0)+20>>2]|0)*12|0)+4>>2]=0;t[(t[(t[n>>2]|0)+28>>2]|0)+((t[(t[n>>2]|0)+20>>2]|0)*12|0)+8>>2]=0;f=(t[n>>2]|0)+20|0;u=t[f>>2]|0;t[f>>2]=u+1;t[(t[(t[n>>2]|0)+28>>2]|0)+(u*12|0)>>2]=0;t[r>>2]=0;l=t[r>>2]|0;s=i;return l|0}function zj(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;a=r+24|0;o=r+20|0;c=r+16|0;l=r+4|0;b=r;t[f>>2]=e;t[a>>2]=i;t[l+0>>2]=0;t[l+4>>2]=0;t[l+8>>2]=0;if((t[f>>2]|0)==0|(t[a>>2]|0)==0){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}t[o>>2]=0;e:while(1){if((t[o>>2]|0)>=(t[(t[f>>2]|0)+20>>2]|0)){h=84;break}t[c>>2]=(t[(t[f>>2]|0)+28>>2]|0)+((t[o>>2]|0)*12|0);i:do switch(t[t[c>>2]>>2]|0){case 8:{if((t[(t[a>>2]|0)+4>>2]|0)==1)h=83;break}case 3:{if((((t[(t[a>>2]|0)+4>>2]|0)!=1?(t[(t[a>>2]|0)+4>>2]|0)!=9:0)?(t[(t[a>>2]|0)+4>>2]|0)!=21:0)?(t[(t[a>>2]|0)+4>>2]|0)!=13:0)break i;t[b>>2]=t[(t[a>>2]|0)+12>>2];if(t[(t[c>>2]|0)+4>>2]|0){while(1){if(!(t[b>>2]|0))break;if(((t[(t[b>>2]|0)+4>>2]|0)==1?(u[t[(t[c>>2]|0)+4>>2]>>0]|0|0)==(u[t[(t[b>>2]|0)+8>>2]>>0]|0|0):0)?(Xl(t[(t[c>>2]|0)+4>>2]|0,t[(t[b>>2]|0)+8>>2]|0)|0)!=0:0)break;t[b>>2]=t[(t[b>>2]|0)+24>>2]}if(t[b>>2]|0)h=83}break}case 2:{if((t[(t[a>>2]|0)+4>>2]|0)==1)if(t[(t[c>>2]|0)+4>>2]|0){if((u[t[(t[c>>2]|0)+4>>2]>>0]|0|0)==(u[t[(t[a>>2]|0)+8>>2]>>0]|0|0)?(Xl(t[(t[c>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0)!=0:0){if(!(t[(t[a>>2]|0)+36>>2]|0))if(t[(t[c>>2]|0)+8>>2]|0)break i;else{h=83;break i}if(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0){if((t[(t[c>>2]|0)+8>>2]|0)!=0?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)h=83}else h=83}}else h=83;break}case 5:{if(((((t[(t[a>>2]|0)+4>>2]|0)!=9?(t[(t[a>>2]|0)+4>>2]|0)!=13:0)?(t[(t[a>>2]|0)+4>>2]|0)!=21:0)?(t[(t[a>>2]|0)+4>>2]|0)!=18:0)?(t[a>>2]=t[(t[a>>2]|0)+20>>2],(t[a>>2]|0)!=0):0)if(t[(t[c>>2]|0)+4>>2]|0){if((u[t[(t[c>>2]|0)+4>>2]>>0]|0|0)==(u[t[(t[a>>2]|0)+8>>2]>>0]|0|0)?(Xl(t[(t[c>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0)!=0:0){if(!(t[(t[a>>2]|0)+36>>2]|0))if(t[(t[c>>2]|0)+8>>2]|0)break i;else{h=83;break i}if(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0){if((t[(t[c>>2]|0)+8>>2]|0)!=0?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)h=83}else h=83}}else h=83;break}case 6:{if(!(t[(t[c>>2]|0)+4>>2]|0)){t[o>>2]=(t[o>>2]|0)+1;t[c>>2]=(t[(t[f>>2]|0)+28>>2]|0)+((t[o>>2]|0)*12|0);if((t[t[c>>2]>>2]|0)==1){h=84;break e}if((t[t[c>>2]>>2]|0)!=2)break i;if(!(t[(t[c>>2]|0)+4>>2]|0)){h=55;break e}}if(((((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+4>>2]|0)!=9:0)?(t[(t[a>>2]|0)+4>>2]|0)!=13:0)?(t[(t[a>>2]|0)+4>>2]|0)!=21:0)?(t[(t[a>>2]|0)+4>>2]|0)!=18:0){t[a>>2]=t[(t[a>>2]|0)+20>>2];r:while(1){if(!(t[a>>2]|0))break;do if(((t[(t[a>>2]|0)+4>>2]|0)==1?(u[t[(t[c>>2]|0)+4>>2]>>0]|0|0)==(u[t[(t[a>>2]|0)+8>>2]>>0]|0|0):0)?(Xl(t[(t[c>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0)!=0:0){if(!(t[(t[a>>2]|0)+36>>2]|0))if(!(t[(t[c>>2]|0)+8>>2]|0))break r;else break;if(((t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0)!=0?(t[(t[c>>2]|0)+8>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)break r}while(0);t[a>>2]=t[(t[a>>2]|0)+20>>2]}if(t[a>>2]|0){i=t[o>>2]|0;if((t[t[c>>2]>>2]|0)==6){Xj(l,i,t[a>>2]|0)|0;h=83;break i}else{Xj(l,i-1|0,t[a>>2]|0)|0;h=83;break i}}}break}case 1:{if((t[(t[a>>2]|0)+4>>2]|0)!=18){t[a>>2]=t[(t[a>>2]|0)+20>>2];if(!(((t[(t[a>>2]|0)+4>>2]|0)!=9?(t[(t[a>>2]|0)+4>>2]|0)!=21:0)?(t[(t[a>>2]|0)+4>>2]|0)!=13:0))h=83}break}case 4:{if((t[(t[a>>2]|0)+4>>2]|0)==2){if(t[(t[c>>2]|0)+4>>2]|0){if((u[t[(t[c>>2]|0)+4>>2]>>0]|0|0)!=(u[t[(t[a>>2]|0)+8>>2]>>0]|0|0))break i;if(!(Xl(t[(t[c>>2]|0)+4>>2]|0,t[(t[a>>2]|0)+8>>2]|0)|0))break i}i=(t[(t[c>>2]|0)+8>>2]|0)!=0;if(!(t[(t[a>>2]|0)+36>>2]|0))if(i)break i;else{h=83;break i}if(!(i?(Xl(t[(t[c>>2]|0)+8>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0)|0)==0:0))h=83}break}case 7:{if((t[(t[a>>2]|0)+4>>2]|0)==1){if(!(t[(t[a>>2]|0)+36>>2]|0))if(t[(t[c>>2]|0)+4>>2]|0)break i;else{h=83;break i}if(t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0){if((t[(t[c>>2]|0)+4>>2]|0)!=0?(Xl(t[(t[c>>2]|0)+4>>2]|0,t[(t[(t[a>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)h=83}else h=83}break}case 0:{h=84;break e;break}default:h=83}while(0);if((h|0)==83){h=0;t[o>>2]=(t[o>>2]|0)+1;continue}if(!(t[l+8>>2]|0)){h=88;break}if((t[l>>2]|0)<=0){h=90;break}t[l>>2]=(t[l>>2]|0)+-1;t[o>>2]=t[(t[l+8>>2]|0)+(t[l>>2]<<3)>>2];t[a>>2]=t[(t[l+8>>2]|0)+(t[l>>2]<<3)+4>>2]}if((h|0)==55){t[n>>2]=-1;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==84){if(t[l+8>>2]|0)pAi[t[135736>>2]&511](t[l+8>>2]|0);t[n>>2]=1;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==88){t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}else if((h|0)==90){pAi[t[135736>>2]&511](t[l+8>>2]|0);t[n>>2]=0;k=t[n>>2]|0;s=r;return k|0}return 0}function jj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](32)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;t[e+20>>2]=0;t[e+24>>2]=0;t[e+28>>2]=0;e=gAi[t[135744>>2]&511](32)|0;t[(t[f>>2]|0)+20>>2]=e;if(!(t[(t[f>>2]|0)+20>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[(t[f>>2]|0)+8>>2]=0;t[(t[f>>2]|0)+12>>2]=4;t[(t[f>>2]|0)+16>>2]=0;t[(t[f>>2]|0)+4>>2]=t[n>>2];t[(t[f>>2]|0)+28>>2]=-1;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Vj(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;while(1){if((t[c>>2]|0)>=(t[(t[u>>2]|0)+8>>2]|0))break;if((t[(t[(t[u>>2]|0)+20>>2]|0)+(t[c>>2]<<1<<2)>>2]|0)<0){b=4;break}t[c>>2]=(t[c>>2]|0)+1}if((b|0)==4){t[(t[(t[u>>2]|0)+20>>2]|0)+(t[c>>2]<<1<<2)>>2]=t[a>>2];t[(t[(t[u>>2]|0)+20>>2]|0)+((t[c>>2]<<1)+1<<2)>>2]=t[o>>2];t[f>>2]=t[c>>2];k=t[f>>2]|0;s=n;return k|0}do if((t[(t[u>>2]|0)+8>>2]|0)>=(t[(t[u>>2]|0)+12>>2]|0)){t[l>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+20>>2]|0,t[(t[u>>2]|0)+12>>2]<<2<<2)|0;if(t[l>>2]|0){t[(t[u>>2]|0)+20>>2]=t[l>>2];c=(t[u>>2]|0)+12|0;t[c>>2]=t[c>>2]<<1;break}t[f>>2]=-1;k=t[f>>2]|0;s=n;return k|0}while(0);t[(t[(t[u>>2]|0)+20>>2]|0)+(t[(t[u>>2]|0)+8>>2]<<1<<2)>>2]=t[a>>2];a=t[o>>2]|0;o=(t[u>>2]|0)+8|0;l=t[o>>2]|0;t[o>>2]=l+1;t[(t[(t[u>>2]|0)+20>>2]|0)+((l<<1)+1<<2)>>2]=a;t[f>>2]=(t[(t[u>>2]|0)+8>>2]|0)-1;k=t[f>>2]|0;s=n;return k|0}function qj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;u=s;s=s+32|0;a=u+24|0;o=u+16|0;c=u+12|0;l=u+8|0;b=u+4|0;k=u;t[u+20>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;do if((t[(t[o>>2]|0)+20>>2]|0)>=(t[(t[o>>2]|0)+24>>2]|0)){t[k>>2]=MAi[t[135760>>2]&511](t[(t[o>>2]|0)+28>>2]|0,(t[(t[o>>2]|0)+24>>2]<<1)*12|0)|0;if(t[k>>2]|0){
	t[(t[o>>2]|0)+28>>2]=t[k>>2];f=(t[o>>2]|0)+24|0;t[f>>2]=t[f>>2]<<1;break}t[a>>2]=-1;h=t[a>>2]|0;s=u;return h|0}while(0);t[(t[(t[o>>2]|0)+28>>2]|0)+((t[(t[o>>2]|0)+20>>2]|0)*12|0)>>2]=t[c>>2];t[(t[(t[o>>2]|0)+28>>2]|0)+((t[(t[o>>2]|0)+20>>2]|0)*12|0)+4>>2]=t[l>>2];t[(t[(t[o>>2]|0)+28>>2]|0)+((t[(t[o>>2]|0)+20>>2]|0)*12|0)+8>>2]=t[b>>2];b=(t[o>>2]|0)+20|0;t[b>>2]=(t[b>>2]|0)+1;t[a>>2]=0;h=t[a>>2]|0;s=u;return h|0}function Yj(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;i=s;s=s+48|0;r=i+32|0;n=i+28|0;f=i+24|0;a=i+20|0;o=i+16|0;c=i+12|0;l=i+8|0;b=i+4|0;k=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;t[a>>2]=0;t[o>>2]=0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);w=u[t[t[r>>2]>>2]>>0]|0;if(!h)break;e=t[r>>2]|0;if(!w)continue;t[e>>2]=(t[e>>2]|0)+1}h=u[t[t[r>>2]>>2]>>0]|0;e:do if((w|0)==46){e=t[r>>2]|0;if(h)t[e>>2]=(t[e>>2]|0)+1;if(!(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,2,0,0)|0)){s=i;return}}else{e=t[r>>2]|0;if((h|0)==64){d=t[r>>2]|0;if(t[(t[e+16>>2]|0)+16>>2]&2){t[d+8>>2]=1;s=i;return}v=t[r>>2]|0;if(u[t[d>>2]>>0]|0)t[v>>2]=(t[v>>2]|0)+1;Gj(t[r>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)break;s=i;return}t[f>>2]=Zj(e)|0;e=u[t[t[r>>2]>>2]>>0]|0;if(!(t[f>>2]|0)){v=t[r>>2]|0;if((e|0)!=42){t[v+8>>2]=1;s=i;return}d=t[r>>2]|0;if(u[t[v>>2]>>0]|0)t[d>>2]=(t[d>>2]|0)+1;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,8,0,0)|0)break;s=i;return}do if((e|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){m=29;break}if((u[t[t[r>>2]>>2]>>0]|0|0)==13)m=29}else m=29;while(0);i:do if((m|0)==29){t[o>>2]=1;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13)break i}while(0);e=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}}while(0);e=u[t[t[r>>2]>>2]>>0]|0;if((u[t[t[r>>2]>>2]>>0]|0|0)!=58){if((e|0)!=42){if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,2,t[f>>2]|0,0)|0)break;s=i;return}d=t[r>>2]|0;if(t[f>>2]|0){t[d+8>>2]=1;break}v=t[r>>2]|0;if(u[t[d>>2]>>0]|0)t[v>>2]=(t[v>>2]|0)+1;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,8,t[n>>2]|0,0)|0)break;s=i;return}v=t[r>>2]|0;if(e)t[v>>2]=(t[v>>2]|0)+1;if((u[t[t[r>>2]>>2]>>0]|0|0)!=58){t[c>>2]=t[f>>2];do if((t[o>>2]|0)==0?(u[t[t[r>>2]>>2]>>0]|0|0)!=32:0){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13){t[n>>2]=Jj(t[r>>2]|0)|0;do if((((u[t[c>>2]>>0]|0|0)==120?(u[(t[c>>2]|0)+1>>0]|0|0)==109:0)?(u[(t[c>>2]|0)+2>>0]|0|0)==108:0)?(u[(t[c>>2]|0)+3>>0]|0|0)==0:0)if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){t[a>>2]=kz(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0,200288,-1)|0;break}else{t[a>>2]=Yl(200288)|0;break}else m=53;while(0);if((m|0)==53){t[l>>2]=0;while(1){if((t[l>>2]|0)>=(t[(t[r>>2]|0)+28>>2]|0))break;if(Xl(t[(t[(t[r>>2]|0)+24>>2]|0)+((t[l>>2]<<1)+1<<2)>>2]|0,t[c>>2]|0)|0){m=56;break}t[l>>2]=(t[l>>2]|0)+1}do if((m|0)==56)if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){t[a>>2]=kz(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0,t[(t[(t[r>>2]|0)+24>>2]|0)+(t[l>>2]<<1<<2)>>2]|0,-1)|0;break}else{t[a>>2]=Yl(t[(t[(t[r>>2]|0)+24>>2]|0)+(t[l>>2]<<1<<2)>>2]|0)|0;break}while(0);if((t[l>>2]|0)>=(t[(t[r>>2]|0)+28>>2]|0)){t[(t[r>>2]|0)+8>>2]=1;break e}}if(!(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0))pAi[t[135736>>2]&511](t[c>>2]|0);t[f>>2]=0;v=t[r>>2]|0;if(t[n>>2]|0){if(qj(v,t[(t[r>>2]|0)+16>>2]|0,2,t[n>>2]|0,t[a>>2]|0)|0)break e;s=i;return}e=t[r>>2]|0;if((u[t[v>>2]>>0]|0|0)!=42){t[e+8>>2]=1;break e}v=t[r>>2]|0;if(u[t[e>>2]>>0]|0)t[v>>2]=(t[v>>2]|0)+1;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,7,t[a>>2]|0,0)|0)break e;s=i;return}}while(0);t[(t[r>>2]|0)+8>>2]=1;break}v=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[v>>2]=(t[v>>2]|0)+1;if(!(Xl(t[f>>2]|0,200328)|0)){v=(Xl(t[f>>2]|0,200336)|0)!=0;e=t[r>>2]|0;if(!v){t[e+8>>2]=1;break}if(!(t[(t[e+16>>2]|0)+4>>2]|0))pAi[t[135736>>2]&511](t[f>>2]|0);t[f>>2]=0;e=t[r>>2]|0;if(t[(t[(t[r>>2]|0)+16>>2]|0)+16>>2]&2){t[e+8>>2]=1;break}Gj(e);if(t[(t[r>>2]|0)+8>>2]|0)break;s=i;return}if(!(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0))pAi[t[135736>>2]&511](t[f>>2]|0);t[f>>2]=Jj(t[r>>2]|0)|0;e=u[t[t[r>>2]>>2]>>0]|0;if(!(t[f>>2]|0)){v=t[r>>2]|0;if((e|0)!=42){t[v+8>>2]=1;break}d=t[r>>2]|0;if(u[t[v>>2]>>0]|0)t[d>>2]=(t[d>>2]|0)+1;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,8,0,0)|0)break;s=i;return}if((e|0)!=58){if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,3,t[f>>2]|0,0)|0)break;s=i;return}t[b>>2]=t[f>>2];e=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13){t[n>>2]=Jj(t[r>>2]|0)|0;do if((u[t[b>>2]>>0]|0|0)==120){if((u[(t[b>>2]|0)+1>>0]|0|0)!=109){m=97;break}if((u[(t[b>>2]|0)+2>>0]|0|0)!=108){m=97;break}if(u[(t[b>>2]|0)+3>>0]|0){m=97;break}if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){t[a>>2]=kz(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0,200288,-1)|0;break}else{t[a>>2]=Yl(200288)|0;break}}else m=97;while(0);do if((m|0)==97){t[k>>2]=0;while(1){if((t[k>>2]|0)>=(t[(t[r>>2]|0)+28>>2]|0))break;if(Xl(t[(t[(t[r>>2]|0)+24>>2]|0)+((t[k>>2]<<1)+1<<2)>>2]|0,t[b>>2]|0)|0){m=100;break}t[k>>2]=(t[k>>2]|0)+1}do if((m|0)==100)if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){t[a>>2]=kz(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0,t[(t[(t[r>>2]|0)+24>>2]|0)+(t[k>>2]<<1<<2)>>2]|0,-1)|0;break}else{t[a>>2]=Yl(t[(t[(t[r>>2]|0)+24>>2]|0)+(t[k>>2]<<1<<2)>>2]|0)|0;break}while(0);if((t[k>>2]|0)<(t[(t[r>>2]|0)+28>>2]|0))break;t[(t[r>>2]|0)+8>>2]=1;break e}while(0);if(!(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0))pAi[t[135736>>2]&511](t[b>>2]|0);t[f>>2]=0;e=t[r>>2]|0;if(t[n>>2]|0){if(qj(e,t[(t[r>>2]|0)+16>>2]|0,3,t[n>>2]|0,t[a>>2]|0)|0)break e;s=i;return}d=t[r>>2]|0;if((u[t[e>>2]>>0]|0|0)!=42){t[d+8>>2]=1;break e}e=t[r>>2]|0;if(u[t[d>>2]>>0]|0)t[e>>2]=(t[e>>2]|0)+1;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,7,t[a>>2]|0,0)|0)break e;s=i;return}}while(0);t[(t[r>>2]|0)+8>>2]=1}while(0);if((t[a>>2]|0)!=0?(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0)==0:0)pAi[t[135736>>2]&511](t[a>>2]|0);if((t[n>>2]|0)!=0?(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0)==0:0)pAi[t[135736>>2]&511](t[n>>2]|0);if(!(t[f>>2]|0)){s=i;return}if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){s=i;return}pAi[t[135736>>2]&511](t[f>>2]|0);s=i;return}function Gj(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0;i=s;s=s+32|0;r=i+20|0;n=i+16|0;f=i+12|0;a=i+8|0;o=i+4|0;c=i;t[r>>2]=e;t[n>>2]=0;t[f>>2]=0;t[a>>2]=0;while(1){do if((u[t[t[r>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(u[t[t[r>>2]>>2]>>0]|0|0)==13}while(0);b=t[r>>2]|0;if(!l)break;e=t[r>>2]|0;if(!(u[t[b>>2]>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}t[f>>2]=Zj(b)|0;b=u[t[t[r>>2]>>2]>>0]|0;e:do if(!(t[f>>2]|0)){l=t[r>>2]|0;if((b|0)!=42){t[l+8>>2]=1;s=i;return}if(!(qj(l,t[(t[r>>2]|0)+16>>2]|0,4,0,0)|0)){l=t[r>>2]|0;if(!(u[t[t[r>>2]>>2]>>0]|0)){s=i;return}t[l>>2]=(t[l>>2]|0)+1;s=i;return}}else{if((b|0)!=58){if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,4,t[f>>2]|0,0)|0)break;s=i;return}t[c>>2]=t[f>>2];l=t[r>>2]|0;if(u[t[t[r>>2]>>2]>>0]|0)t[l>>2]=(t[l>>2]|0)+1;do if((u[t[t[r>>2]>>2]>>0]|0|0)!=32){if(9<=(u[t[t[r>>2]>>2]>>0]|0|0)?(u[t[t[r>>2]>>2]>>0]|0|0)<=10:0)break;if((u[t[t[r>>2]>>2]>>0]|0|0)!=13){t[n>>2]=Jj(t[r>>2]|0)|0;do if((((u[t[c>>2]>>0]|0|0)==120?(u[(t[c>>2]|0)+1>>0]|0|0)==109:0)?(u[(t[c>>2]|0)+2>>0]|0|0)==108:0)?(u[(t[c>>2]|0)+3>>0]|0|0)==0:0)if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){t[a>>2]=kz(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0,200288,-1)|0;break}else{t[a>>2]=Yl(200288)|0;break}else k=32;while(0);if((k|0)==32){t[o>>2]=0;while(1){if((t[o>>2]|0)>=(t[(t[r>>2]|0)+28>>2]|0))break;if(Xl(t[(t[(t[r>>2]|0)+24>>2]|0)+((t[o>>2]<<1)+1<<2)>>2]|0,t[c>>2]|0)|0){k=35;break}t[o>>2]=(t[o>>2]|0)+1}do if((k|0)==35)if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){t[a>>2]=kz(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0,t[(t[(t[r>>2]|0)+24>>2]|0)+(t[o>>2]<<1<<2)>>2]|0,-1)|0;break}else{t[a>>2]=Yl(t[(t[(t[r>>2]|0)+24>>2]|0)+(t[o>>2]<<1<<2)>>2]|0)|0;break}while(0);if((t[o>>2]|0)>=(t[(t[r>>2]|0)+28>>2]|0)){t[(t[r>>2]|0)+8>>2]=1;break e}}if(!(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0))pAi[t[135736>>2]&511](t[c>>2]|0);l=t[r>>2]|0;if(t[n>>2]|0){if(qj(l,t[(t[r>>2]|0)+16>>2]|0,4,t[n>>2]|0,t[a>>2]|0)|0)break e;s=i;return}e=t[r>>2]|0;if((u[t[l>>2]>>0]|0|0)!=42){t[e+8>>2]=1;break e}l=t[r>>2]|0;if(u[t[e>>2]>>0]|0)t[l>>2]=(t[l>>2]|0)+1;if(qj(t[r>>2]|0,t[(t[r>>2]|0)+16>>2]|0,4,0,t[a>>2]|0)|0)break e;s=i;return}}while(0);if(!(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0))pAi[t[135736>>2]&511](t[c>>2]|0);t[(t[r>>2]|0)+8>>2]=1}while(0);if((t[a>>2]|0)!=0?(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0)==0:0)pAi[t[135736>>2]&511](t[a>>2]|0);if(!(t[n>>2]|0)){s=i;return}if(t[(t[(t[r>>2]|0)+16>>2]|0)+4>>2]|0){s=i;return}pAi[t[135736>>2]&511](t[n>>2]|0);s=i;return}function Wj(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[n>>2]=(t[n>>2]|0)<4?4:e;t[f>>2]=gAi[t[135744>>2]&511](20)|0;if(!(t[f>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=t[f>>2]|0;t[e+0>>2]=0;t[e+4>>2]=0;t[e+8>>2]=0;t[e+12>>2]=0;t[e+16>>2]=0;e=gAi[t[135744>>2]&511](t[n>>2]<<4)|0;t[(t[f>>2]|0)+12>>2]=e;if(!(t[(t[f>>2]|0)+12>>2]|0)){pAi[t[135736>>2]&511](t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[(t[f>>2]|0)+4>>2]=0;t[(t[f>>2]|0)+8>>2]=t[n>>2];t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function Kj(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+32|0;a=u+24|0;o=u+20|0;c=u+16|0;l=u+12|0;b=u+8|0;k=u+4|0;h=u;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;do if((t[(t[o>>2]|0)+4>>2]|0)>=(t[(t[o>>2]|0)+8>>2]|0)){t[h>>2]=MAi[t[135760>>2]&511](t[(t[o>>2]|0)+12>>2]|0,t[(t[o>>2]|0)+8>>2]<<1<<4)|0;if(t[h>>2]|0){t[(t[o>>2]|0)+12>>2]=t[h>>2];f=(t[o>>2]|0)+8|0;t[f>>2]=t[f>>2]<<1;break}t[a>>2]=-1;w=t[a>>2]|0;s=u;return w|0}while(0);f=(t[o>>2]|0)+4|0;n=t[f>>2]|0;t[f>>2]=n+1;t[h>>2]=(t[(t[o>>2]|0)+12>>2]|0)+(n<<4);t[t[h>>2]>>2]=t[k>>2];t[(t[h>>2]|0)+4>>2]=t[c>>2];t[(t[h>>2]|0)+8>>2]=t[l>>2];t[(t[h>>2]|0)+12>>2]=t[b>>2];t[a>>2]=(t[(t[o>>2]|0)+4>>2]|0)-1;w=t[a>>2]|0;s=u;return w|0}function Xj(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;do if((t[(t[u>>2]|0)+8>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)>0:0){if((t[(t[u>>2]|0)+4>>2]|0)<=(t[t[u>>2]>>2]|0)){t[c>>2]=MAi[t[135760>>2]&511](t[(t[u>>2]|0)+8>>2]|0,t[(t[u>>2]|0)+4>>2]<<1<<3)|0;if(t[c>>2]|0){t[(t[u>>2]|0)+8>>2]=t[c>>2];r=(t[u>>2]|0)+4|0;t[r>>2]=t[r>>2]<<1;break}t[f>>2]=-1;l=t[f>>2]|0;s=n;return l|0}}else b=3;while(0);if((b|0)==3){t[(t[u>>2]|0)+4>>2]=4;t[t[u>>2]>>2]=0;b=gAi[t[135744>>2]&511](32)|0;t[(t[u>>2]|0)+8>>2]=b}t[(t[(t[u>>2]|0)+8>>2]|0)+(t[t[u>>2]>>2]<<3)>>2]=t[a>>2];a=t[o>>2]|0;o=t[u>>2]|0;b=t[o>>2]|0;t[o>>2]=b+1;t[(t[(t[u>>2]|0)+8>>2]|0)+(b<<3)+4>>2]=a;t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}function Zj(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[n>>2]=e;t[o>>2]=0;while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)==32)b=1;else{if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0){b=1;break}b=(u[t[t[n>>2]>>2]>>0]|0|0)==13}while(0);k=t[t[n>>2]>>2]|0;if(!b)break;e=t[n>>2]|0;if(!(u[k>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}t[f>>2]=k;t[a>>2]=k;t[c>>2]=Mp(0,t[a>>2]|0,l)|0;k=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(k|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)h=15}else if(!(dj(k,199744)|0))h=15;do if((h|0)==15){k=t[c>>2]|0;if((t[c>>2]|0)<256){if((k|0)==95)break}else{if(19968<=(k|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(!((12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329^1)&(t[c>>2]|0)!=95))break}t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}while(0);e:while(1){k=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(k|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)h=26}else if(!(dj(k,199744)|0))h=26;do if((h|0)==26){h=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}k=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(k|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{b=(dj(k,200216)|0)!=0;if(b|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;b=t[c>>2]|0;if((t[c>>2]|0)<256)d=(b|0)==183&1;else d=dj(b,200272)|0;if(!d)break e}while(0);t[a>>2]=(t[a>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[a>>2]|0,l)|0}if(t[(t[n>>2]|0)+12>>2]|0)t[o>>2]=kz(t[(t[n>>2]|0)+12>>2]|0,t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;else t[o>>2]=ql(t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;t[t[n>>2]>>2]=t[a>>2];t[r>>2]=t[o>>2];w=t[r>>2]|0;s=i;return w|0}function Jj(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;i=s;s=s+32|0;r=i+24|0;n=i+20|0;f=i+16|0;a=i+12|0;o=i+8|0;c=i+4|0;l=i;t[n>>2]=e;t[o>>2]=0;while(1){do if((u[t[t[n>>2]>>2]>>0]|0|0)==32)b=1;else{if(9<=(u[t[t[n>>2]>>2]>>0]|0|0)?(u[t[t[n>>2]>>2]>>0]|0|0)<=10:0){b=1;break}b=(u[t[t[n>>2]>>2]>>0]|0|0)==13}while(0);k=t[t[n>>2]>>2]|0;if(!b)break;e=t[n>>2]|0;if(!(u[k>>0]|0))continue;t[e>>2]=(t[e>>2]|0)+1}t[f>>2]=k;t[a>>2]=k;t[c>>2]=Mp(0,t[a>>2]|0,l)|0;k=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(k|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)h=15}else if(!(dj(k,199744)|0))h=15;do if((h|0)==15){k=t[c>>2]|0;if((t[c>>2]|0)<256){if(!((k|0)!=95&(t[c>>2]|0)!=58))break}else{if(19968<=(k|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(!((12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329^1)&(t[c>>2]|0)!=95&(t[c>>2]|0)!=58))break}t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}while(0);e:while(1){k=t[c>>2]|0;if((t[c>>2]|0)<256){if(((!(65<=(k|0)&(t[c>>2]|0)<=90)?!(97<=(t[c>>2]|0)&(t[c>>2]|0)<=122):0)?!(192<=(t[c>>2]|0)&(t[c>>2]|0)<=214):0)?!(216<=(t[c>>2]|0)&(t[c>>2]|0)<=246|248<=(t[c>>2]|0)):0)h=26}else if(!(dj(k,199744)|0))h=26;do if((h|0)==26){h=0;if((t[c>>2]|0)>=256){if(19968<=(t[c>>2]|0)&(t[c>>2]|0)<=40869|(t[c>>2]|0)==12295)break;if(12321<=(t[c>>2]|0)&(t[c>>2]|0)<=12329)break}k=t[c>>2]|0;if((t[c>>2]|0)<256){if(48<=(k|0)&(t[c>>2]|0)<=57|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}else{b=(dj(k,200216)|0)!=0;if(b|(t[c>>2]|0)==46|(t[c>>2]|0)==45|(t[c>>2]|0)==95)break}if((t[c>>2]|0)>=256?(dj(t[c>>2]|0,200144)|0)!=0:0)break;b=t[c>>2]|0;if((t[c>>2]|0)<256)d=(b|0)==183&1;else d=dj(b,200272)|0;if(!d)break e}while(0);t[a>>2]=(t[a>>2]|0)+(t[l>>2]|0);t[c>>2]=Mp(0,t[a>>2]|0,l)|0}if(t[(t[n>>2]|0)+12>>2]|0)t[o>>2]=kz(t[(t[n>>2]|0)+12>>2]|0,t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;else t[o>>2]=ql(t[f>>2]|0,(t[a>>2]|0)-(t[f>>2]|0)|0)|0;t[t[n>>2]>>2]=t[a>>2];t[r>>2]=t[o>>2];w=t[r>>2]|0;s=i;return w|0}function Qj(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)==0&(t[u>>2]|0)==0)t[n>>2]=-1;else{if(t[u>>2]|0){if(Xl(t[u>>2]|0,200352)|0){t[n>>2]=1;break}if(Xl(t[u>>2]|0,200392)|0){t[n>>2]=1;break}if(Xl(t[u>>2]|0,200432)|0){t[n>>2]=1;break}}if(t[f>>2]|0){if(Xl(t[f>>2]|0,200472)|0){t[n>>2]=1;break}if(Xl(t[f>>2]|0,200528)|0){t[n>>2]=1;break}if(Xl(t[f>>2]|0,200584)|0){t[n>>2]=1;break}}t[n>>2]=0}while(0);s=r;return t[n>>2]|0}function $j(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=gF()|0;if(!(t[u>>2]|0)){s=r;return}UM(t[u>>2]|0,t[f>>2]|0);Us(t[n>>2]|0,t[u>>2]|0)|0;s=r;return}function eV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=gF()|0;if(!(t[u>>2]|0)){s=r;return}MM(t[u>>2]|0,t[f>>2]|0);Us(t[n>>2]|0,t[u>>2]|0)|0;s=r;return}function iV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=gF()|0;if(!(t[u>>2]|0)){s=r;return}PM(t[u>>2]|0,t[f>>2]|0);Us(t[n>>2]|0,t[u>>2]|0)|0;s=r;return}function rV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=gF()|0;if(!(t[u>>2]|0)){s=r;return}__(t[u>>2]|0,t[f>>2]|0);Us(t[n>>2]|0,t[u>>2]|0)|0;s=r;return}function nV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;gV(t[n>>2]|0,t[f>>2]|0,0);t[f>>2]=t[t[f>>2]>>2]}s=r;return}function fV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0;n=s;s=s+32|0;f=n+16|0;u=n+12|0;a=n+8|0;o=n+4|0;c=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=yV(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}o=KO(t[u>>2]|0,t[(t[c>>2]|0)+20>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=o;o=t[c>>2]|0;if(!(t[(t[c>>2]|0)+24>>2]|0)){FV(o);t[f>>2]=0;l=t[f>>2]|0;s=n;return l|0}else{t[f>>2]=o;l=t[f>>2]|0;s=n;return l|0}return 0}function tV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;t[c>>2]=yV(t[a>>2]|0,t[o>>2]|0)|0;if(!(t[c>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}o=VO(t[u>>2]|0,t[(t[c>>2]|0)+20>>2]|0,t[l>>2]|0)|0;t[(t[c>>2]|0)+24>>2]=o;o=t[c>>2]|0;if(!(t[(t[c>>2]|0)+24>>2]|0)){FV(o);t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}else{t[f>>2]=o;b=t[f>>2]|0;s=n;return b|0}return 0}function uV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;do if(!((t[f>>2]|0)==0|(t[u>>2]|0)==0))if((OV(t[f>>2]|0,t[u>>2]|0)|0)<0){t[n>>2]=-1;break}else{t[n>>2]=t[a>>2];break}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function aV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}else{AV(t[f>>2]|0,t[u>>2]|0);t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}return 0}function oV(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;do if(t[n>>2]|0)if(!(t[(t[n>>2]|0)+24>>2]|0)){t[r>>2]=-1;break}else{t[r>>2]=xO(t[(t[n>>2]|0)+24>>2]|0)|0;break}else t[r>>2]=-1;while(0);s=i;return t[r>>2]|0}function cV(e){e=e|0;var i=0,r=0,n=0,f=0,u=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=-1;u=t[r>>2]|0;s=i;return u|0}else{t[f>>2]=oV(t[n>>2]|0)|0;FV(t[n>>2]|0);t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function lV(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+48|0;a=f+28|0;o=f+24|0;c=f+20|0;l=f+16|0;b=f+12|0;k=f+8|0;h=f+32|0;w=f+4|0;d=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if(!(t[l>>2]|0)){s=f;return}n=t[l>>2]|0;t[k>>2]=n;t[b>>2]=n;e:while(1){if(!(u[t[k>>2]>>0]|0))break;if((u[t[k>>2]>>0]|0|0)==10){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200640,5)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}if((u[t[k>>2]>>0]|0|0)==13){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200648,5)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}if((u[t[k>>2]>>0]|0|0)==9){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200656,4)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}if((u[t[k>>2]>>0]|0|0)==34){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200664,6)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}if((u[t[k>>2]>>0]|0|0)==60){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200672,4)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}if((u[t[k>>2]>>0]|0|0)==62){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200680,4)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}if((u[t[k>>2]>>0]|0|0)==38){if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;Ps(t[a>>2]|0,200688,5)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue}do if((u[t[k>>2]>>0]|0|0)>=128){if((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+60>>2]|0)!=0:0)break;t[w>>2]=0;t[d>>2]=1;if((t[b>>2]|0)!=(t[k>>2]|0))Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;if((u[t[k>>2]>>0]|0|0)<192){MV(1400,t[c>>2]|0,0);if(t[o>>2]|0){n=Yl(200696)|0;t[(t[o>>2]|0)+60>>2]=n}RV(h,u[t[k>>2]>>0]|0)|0;Ps(t[a>>2]|0,h,-1)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue e}n=t[k>>2]|0;do if((u[t[k>>2]>>0]|0|0)>=224){l=t[k>>2]|0;if((u[n>>0]|0|0)<240){t[w>>2]=(u[l>>0]|0)&15;t[w>>2]=t[w>>2]<<6;t[w>>2]=t[w>>2]|(u[(t[k>>2]|0)+1>>0]|0)&63;t[w>>2]=t[w>>2]<<6;t[w>>2]=t[w>>2]|(u[(t[k>>2]|0)+2>>0]|0)&63;t[d>>2]=3;break}if((u[l>>0]|0|0)<248){t[w>>2]=(u[t[k>>2]>>0]|0)&7;t[w>>2]=t[w>>2]<<6;t[w>>2]=t[w>>2]|(u[(t[k>>2]|0)+1>>0]|0)&63;t[w>>2]=t[w>>2]<<6;t[w>>2]=t[w>>2]|(u[(t[k>>2]|0)+2>>0]|0)&63;t[w>>2]=t[w>>2]<<6;t[w>>2]=t[w>>2]|(u[(t[k>>2]|0)+3>>0]|0)&63;t[d>>2]=4}}else{t[w>>2]=(u[n>>0]|0)&31;t[w>>2]=t[w>>2]<<6;t[w>>2]=t[w>>2]|(u[(t[k>>2]|0)+1>>0]|0)&63;t[d>>2]=2}while(0);i:do if((t[d>>2]|0)!=1){n=t[w>>2]|0;do if((t[w>>2]|0)<256){if(!(9<=(n|0)&(t[w>>2]|0)<=10|(t[w>>2]|0)==13|32<=(t[w>>2]|0)))break i}else{if(256<=(n|0)&(t[w>>2]|0)<=55295)break;if(57344<=(t[w>>2]|0)&(t[w>>2]|0)<=65533)break;if(!(65536<=(t[w>>2]|0)&(t[w>>2]|0)<=1114111))break i}while(0);RV(h,t[w>>2]|0)|0;Ps(t[a>>2]|0,h,-1)|0;t[k>>2]=(t[k>>2]|0)+(t[d>>2]|0);t[b>>2]=t[k>>2];continue e}while(0);MV(1401,t[c>>2]|0,0);if(t[o>>2]|0){n=Yl(200696)|0;t[(t[o>>2]|0)+60>>2]=n}RV(h,u[t[k>>2]>>0]|0)|0;Ps(t[a>>2]|0,h,-1)|0;t[k>>2]=(t[k>>2]|0)+1;t[b>>2]=t[k>>2];continue e}while(0);t[k>>2]=(t[k>>2]|0)+1}if((t[b>>2]|0)==(t[k>>2]|0)){s=f;return}Ps(t[a>>2]|0,t[b>>2]|0,(t[k>>2]|0)-(t[b>>2]|0)|0)|0;s=f;return}function sV(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;a=s;s=s+160|0;o=a+152|0;c=a+148|0;l=a+144|0;b=a+140|0;k=a+136|0;h=a+132|0;w=a+8|0;d=a+4|0;v=a;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;t[h>>2]=u;t[v>>2]=0;rS();if((t[o>>2]|0)==0|(t[l>>2]|0)==0){s=a;return}if(!(t[h>>2]|0))t[h>>2]=200728;u=w+0|0;f=u+124|0;do{t[u>>2]=0;u=u+4|0}while((u|0)<(f|0));t[w+28>>2]=t[c>>2];t[w+24>>2]=t[o>>2];t[w+36>>2]=t[b>>2];t[w+40>>2]=(t[k>>2]|0)!=0?1:0;t[w+16>>2]=t[h>>2];TV(w);h=w+32|0;t[h>>2]=t[h>>2]|32;t[d>>2]=Qg(t[c>>2]|0)|0;if(t[d>>2]|0){c=Qj(t[(t[d>>2]|0)+56>>2]|0,t[(t[d>>2]|0)+52>>2]|0)|0;t[v>>2]=c;t[v>>2]=(t[v>>2]|0)<0?0:c}c=t[l>>2]|0;if(t[v>>2]|0){LV(w,c);s=a;return}else{AV(w,c);s=a;return}}function bV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;rS();if(!(t[a>>2]|0)){s=n;return}t[o>>2]=qO(t[f>>2]|0,0)|0;if(!(t[o>>2]|0)){s=n;return}if((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)==13:0)er(t[o>>2]|0,t[u>>2]|0,t[a>>2]|0,0);else sV(t[o>>2]|0,t[u>>2]|0,t[a>>2]|0,0,1,0);HO(t[o>>2]|0)|0;s=n;return}function kV(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;u=s;s=s+160|0;a=u+152|0;o=u+148|0;c=u+144|0;l=u+140|0;b=u+136|0;k=u+12|0;h=u+8|0;w=u+4|0;d=u;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[b>>2]=f;t[h>>2]=0;t[w>>2]=0;t[d>>2]=0;if(!(t[c>>2]|0))t[c>>2]=h;if(!(t[o>>2]|0)){t[t[c>>2]>>2]=0;s=u;return}t[t[o>>2]>>2]=0;t[t[c>>2]>>2]=0;if(!(t[a>>2]|0)){s=u;return}if(!(t[l>>2]|0))t[l>>2]=t[(t[a>>2]|0)+60>>2];if((t[l>>2]|0)!=0?(t[d>>2]=V_(t[l>>2]|0)|0,(t[d>>2]|0)==0):0){MV(1403,t[a>>2]|0,t[l>>2]|0);s=u;return}h=PO(t[d>>2]|0)|0;t[w>>2]=h;if(!h){NV(200712);s=u;return}h=k+0|0;d=h+124|0;do{t[h>>2]=0;h=h+4|0}while((h|0)<(d|0));t[k+28>>2]=t[a>>2];t[k+24>>2]=t[w>>2];t[k+36>>2]=0;t[k+40>>2]=(t[b>>2]|0)!=0?1:0;t[k+16>>2]=t[l>>2];TV(k);l=k+32|0;t[l>>2]=t[l>>2]|32;OV(k,t[a>>2]|0)|0;xO(t[w>>2]|0)|0;a=t[w>>2]|0;if(t[(t[w>>2]|0)+20>>2]|0){k=Ts(t[a+20>>2]|0)|0;t[t[c>>2]>>2]=k;k=Os(t[(t[w>>2]|0)+20>>2]|0)|0;l=ql(k,t[t[c>>2]>>2]|0)|0;t[t[o>>2]>>2]=l}else{l=Ts(t[a+16>>2]|0)|0;t[t[c>>2]>>2]=l;l=Os(t[(t[w>>2]|0)+16>>2]|0)|0;a=ql(l,t[t[c>>2]>>2]|0)|0;t[t[o>>2]>>2]=a}HO(t[w>>2]|0)|0;if(t[t[o>>2]>>2]|0){s=u;return}if((t[t[c>>2]>>2]|0)<=0){s=u;return}t[t[c>>2]>>2]=0;NV(200736);s=u;return}function hV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;kV(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0,0);s=n;return}function wV(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;kV(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,0,t[c>>2]|0);s=f;return}function dV(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0;f=s;s=s+16|0;u=f+12|0;a=f+8|0;o=f+4|0;c=f;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=n;kV(t[u>>2]|0,t[a>>2]|0,t[o>>2]|0,t[c>>2]|0,0);s=f;return}function vV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;n=s;s=s+160|0;f=n+152|0;u=n+148|0;a=n+144|0;o=n+140|0;c=n+16|0;l=n+12|0;b=n+8|0;k=n+4|0;h=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[k>>2]=0;if(!(t[a>>2]|0)){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}t[b>>2]=t[(t[a>>2]|0)+60>>2];if((t[b>>2]|0)!=0?(t[k>>2]=V_(t[b>>2]|0)|0,(t[k>>2]|0)==0):0){pAi[t[135736>>2]&511](t[(t[a>>2]|0)+60>>2]|0);t[(t[a>>2]|0)+60>>2]=0;t[b>>2]=0}t[l>>2]=qO(t[u>>2]|0,t[k>>2]|0)|0;if(!(t[l>>2]|0)){t[f>>2]=-1;w=t[f>>2]|0;s=n;return w|0}else{k=c+0|0;u=k+124|0;do{t[k>>2]=0;k=k+4|0}while((k|0)<(u|0));t[c+28>>2]=t[a>>2];t[c+24>>2]=t[l>>2];t[c+36>>2]=0;t[c+40>>2]=(t[o>>2]|0)!=0?1:0;t[c+16>>2]=t[b>>2];TV(c);b=c+32|0;t[b>>2]=t[b>>2]|32;OV(c,t[a>>2]|0)|0;t[h>>2]=HO(t[l>>2]|0)|0;t[f>>2]=t[h>>2];w=t[f>>2]|0;s=n;return w|0}return 0}function mV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=vV(t[n>>2]|0,t[f>>2]|0,0)|0;s=r;return i|0}function _V(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;f=s;s=s+160|0;u=f+152|0;a=f+148|0;o=f+144|0;c=f+140|0;l=f+136|0;b=f+12|0;k=f+8|0;h=f+4|0;w=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;t[h>>2]=0;if(!(t[o>>2]|0)){t[u>>2]=-1;d=t[u>>2]|0;s=f;return d|0}if(!(t[c>>2]|0))t[c>>2]=t[(t[o>>2]|0)+60>>2];if((t[c>>2]|0)!=0?(t[h>>2]=V_(t[c>>2]|0)|0,(t[h>>2]|0)==0):0){t[u>>2]=-1;d=t[u>>2]|0;s=f;return d|0}t[k>>2]=VO(t[a>>2]|0,t[h>>2]|0,t[(t[o>>2]|0)+36>>2]|0)|0;if(!(t[k>>2]|0)){t[u>>2]=-1;d=t[u>>2]|0;s=f;return d|0}else{h=b+0|0;a=h+124|0;do{t[h>>2]=0;h=h+4|0}while((h|0)<(a|0));t[b+28>>2]=t[o>>2];t[b+24>>2]=t[k>>2];t[b+36>>2]=0;t[b+40>>2]=(t[l>>2]|0)!=0?1:0;t[b+16>>2]=t[c>>2];TV(b);c=b+32|0;t[c>>2]=t[c>>2]|32;OV(b,t[o>>2]|0)|0;t[w>>2]=HO(t[k>>2]|0)|0;t[u>>2]=t[w>>2];d=t[u>>2]|0;s=f;return d|0}return 0}function pV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=_V(t[f>>2]|0,t[u>>2]|0,t[a>>2]|0,0)|0;s=n;return r|0}function EV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=_V(t[f>>2]|0,t[u>>2]|0,0,t[a>>2]|0)|0;s=n;return r|0}function SV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;i=_V(t[n>>2]|0,t[f>>2]|0,0,0)|0;s=r;return i|0}function gV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if((t[u>>2]|0)==0|(t[f>>2]|0)==0){s=n;return}if((t[(t[u>>2]|0)+4>>2]|0)!=18){s=n;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=n;return}if(Xl(t[(t[u>>2]|0)+12>>2]|0,201224)|0){s=n;return}if((t[a>>2]|0)!=0?(t[(t[a>>2]|0)+40>>2]|0)==2:0)DV(t[a>>2]|0,2);else $O(t[f>>2]|0,1,200760)|0;a=t[f>>2]|0;if(t[(t[u>>2]|0)+12>>2]|0){$O(a,6,201752)|0;iA(t[f>>2]|0,t[(t[u>>2]|0)+12>>2]|0)|0}else $O(a,5,201760)|0;$O(t[f>>2]|0,1,201768)|0;xs(t[(t[f>>2]|0)+16>>2]|0,t[(t[u>>2]|0)+8>>2]|0)|0;s=n;return}function yV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=gAi[t[135744>>2]&511](124)|0;if(!(t[a>>2]|0)){NV(201728);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}i=(t[a>>2]|0)+0|0;e=i+124|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));do if(t[f>>2]|0){i=V_(t[f>>2]|0)|0;t[(t[a>>2]|0)+20>>2]=i;i=t[f>>2]|0;if(t[(t[a>>2]|0)+20>>2]|0){e=Yl(i)|0;t[(t[a>>2]|0)+16>>2]=e;t[(t[a>>2]|0)+116>>2]=0;break}MV(1403,0,i);FV(t[a>>2]|0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}while(0);TV(t[a>>2]|0);if((t[(t[a>>2]|0)+32>>2]&4|0)!=0?(t[u>>2]&4|0)==0:0)t[u>>2]=t[u>>2]|4;t[(t[a>>2]|0)+32>>2]=t[u>>2];if(!(t[u>>2]&1)){if(t[u>>2]&128)t[(t[a>>2]|0)+40>>2]=2}else t[(t[a>>2]|0)+40>>2]=1;t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function FV(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+16>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)HO(t[(t[r>>2]|0)+24>>2]|0)|0;pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function OV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;r=s;s=s+64|0;n=r+52|0;f=r+48|0;u=r+44|0;a=r+40|0;o=r+36|0;c=r+32|0;l=r+28|0;b=r+24|0;k=r+20|0;h=r+16|0;w=r+12|0;d=r+8|0;v=r+4|0;m=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=0;t[c>>2]=t[(t[u>>2]|0)+60>>2];t[l>>2]=t[(t[f>>2]|0)+16>>2];t[b>>2]=t[(t[f>>2]|0)+16>>2];t[k>>2]=t[(t[f>>2]|0)+116>>2];t[h>>2]=t[(t[f>>2]|0)+120>>2];t[w>>2]=t[(t[f>>2]|0)+24>>2];t[v>>2]=0;rS();if((t[(t[u>>2]|0)+4>>2]|0)!=13?(t[(t[u>>2]|0)+4>>2]|0)!=9:0){t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}do if(!(t[(t[f>>2]|0)+16>>2]|0)){i=t[u>>2]|0;if(t[(t[u>>2]|0)+60>>2]|0){t[b>>2]=t[i+60>>2];break}if((t[i+76>>2]|0)!=1)t[b>>2]=I_(t[(t[u>>2]|0)+76>>2]|0)|0}else t[(t[u>>2]|0)+60>>2]=t[(t[f>>2]|0)+16>>2];while(0);if(!(((t[(t[u>>2]|0)+4>>2]|0)==13?(t[(t[f>>2]|0)+32>>2]&32|0)==0:0)?(t[(t[f>>2]|0)+32>>2]&16|0)==0:0))p=13;if((p|0)==13?(t[(t[f>>2]|0)+32>>2]&64|0)==0:0){if(!(((t[(t[u>>2]|0)+4>>2]|0)!=9?(t[(t[f>>2]|0)+32>>2]&32|0)==0:0)?(t[(t[f>>2]|0)+32>>2]&16|0)==0:0))p=34;e:do if((p|0)==34){t[d>>2]=B_(t[b>>2]|0)|0;if((((t[b>>2]|0)!=0&(t[l>>2]|0)==0?(t[(t[w>>2]|0)+12>>2]|0)==0:0)?(t[(t[w>>2]|0)+20>>2]|0)==0:0)?(t[(t[f>>2]|0)+32>>2]&2|0)==0:0){do if((t[d>>2]|0)!=1&(t[d>>2]|0)!=0&(t[d>>2]|0)!=22){if((CV(t[f>>2]|0,t[b>>2]|0)|0)>=0){t[v>>2]=1;break}t[(t[u>>2]|0)+60>>2]=t[c>>2];t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}while(0);if((t[(t[f>>2]|0)+116>>2]|0)==389)t[(t[f>>2]|0)+116>>2]=0;if((t[(t[f>>2]|0)+120>>2]|0)==389)t[(t[f>>2]|0)+120>>2]=0}if(!(t[(t[f>>2]|0)+32>>2]&2)){$O(t[w>>2]|0,14,201632)|0;i=t[w>>2]|0;if(t[(t[u>>2]|0)+56>>2]|0)xs(t[i+16>>2]|0,t[(t[u>>2]|0)+56>>2]|0)|0;else $O(i,5,201648)|0;if(t[b>>2]|0){$O(t[w>>2]|0,10,201656)|0;xs(t[(t[w>>2]|0)+16>>2]|0,t[b>>2]|0)|0}i=t[(t[u>>2]|0)+40>>2]|0;if((i|0)==1)$O(t[w>>2]|0,17,201696)|0;else if(!i)$O(t[w>>2]|0,16,201672)|0;$O(t[w>>2]|0,3,201720)|0}if(t[(t[f>>2]|0)+32>>2]&16)t[o>>2]=1;if((t[(t[f>>2]|0)+32>>2]&8|0)==0?(t[a>>2]=Qg(t[u>>2]|0)|0,(t[a>>2]|0)!=0):0){i=Qj(t[(t[a>>2]|0)+56>>2]|0,t[(t[a>>2]|0)+52>>2]|0)|0;t[o>>2]=i;t[o>>2]=(t[o>>2]|0)<0?0:i}if(t[(t[u>>2]|0)+12>>2]|0){t[m>>2]=t[(t[u>>2]|0)+12>>2];while(1){if(!(t[m>>2]|0))break e;t[(t[f>>2]|0)+36>>2]=0;i=t[f>>2]|0;e=t[m>>2]|0;if(t[o>>2]|0)LV(i,e);else AV(i,e);$O(t[w>>2]|0,1,200976)|0;t[m>>2]=t[(t[m>>2]|0)+24>>2]}}}while(0);if((t[v>>2]|0)!=0&(t[l>>2]|0)==0){BV(t[f>>2]|0)|0;t[(t[f>>2]|0)+116>>2]=t[k>>2];t[(t[f>>2]|0)+120>>2]=t[h>>2]}t[(t[u>>2]|0)+60>>2]=t[c>>2];t[n>>2]=0;_=t[n>>2]|0;s=r;return _|0}if(t[b>>2]|0)Wi(t[u>>2]|0,t[b>>2]|0)|0;if(!(t[b>>2]|0))t[b>>2]=Gi(t[u>>2]|0)|0;if(!(t[b>>2]|0))t[b>>2]=201592;if((((t[b>>2]|0)!=0&(t[l>>2]|0)==0?(t[(t[w>>2]|0)+12>>2]|0)==0:0)?(t[(t[w>>2]|0)+20>>2]|0)==0:0)?(CV(t[f>>2]|0,t[b>>2]|0)|0)<0:0){t[(t[u>>2]|0)+60>>2]=t[c>>2];t[n>>2]=-1;_=t[n>>2]|0;s=r;return _|0}l=t[w>>2]|0;w=t[u>>2]|0;h=t[b>>2]|0;if(t[(t[f>>2]|0)+32>>2]&1)Qi(l,w,h,1);else Qi(l,w,h,0);if(t[(t[f>>2]|0)+16>>2]|0)t[(t[u>>2]|0)+60>>2]=t[c>>2];t[n>>2]=0;_=t[n>>2]|0;s=r;return _|0}function AV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;r=s;s=s+32|0;n=r+24|0;f=r+20|0;a=r+16|0;o=r+12|0;c=r+8|0;l=r+4|0;b=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}t[b>>2]=t[(t[n>>2]|0)+24>>2];if((t[(t[f>>2]|0)+4>>2]|0)==19){s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==20){s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)!=9?(t[(t[f>>2]|0)+4>>2]|0)!=13:0){if(t[(t[n>>2]|0)+32>>2]&16){LV(t[n>>2]|0,t[f>>2]|0);s=r;return}if(!((((t[(t[f>>2]|0)+4>>2]|0)!=18?(t[(t[f>>2]|0)+32>>2]|0)!=0:0)?(t[(t[(t[f>>2]|0)+32>>2]|0)+4>>2]|0)==13:0)?(t[(t[n>>2]|0)+32>>2]&32|0)==0:0))k=13;if((k|0)==13?(t[(t[n>>2]|0)+32>>2]&64|0)==0:0){if((t[(t[f>>2]|0)+4>>2]|0)==14){HV(t[n>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==11){xV(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==15){
	eV(t[(t[b>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==16){iV(t[(t[b>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==17){rV(t[(t[b>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==3){if(!(t[i+40>>2]|0)){s=r;return}e=t[b>>2]|0;h=t[(t[f>>2]|0)+40>>2]|0;if((t[(t[f>>2]|0)+8>>2]|0)!=75112){eA(e,h,t[(t[n>>2]|0)+116>>2]|0)|0;s=r;return}else{iA(e,h)|0;s=r;return}}h=t[f>>2]|0;if((t[i+4>>2]|0)==7){i=(t[h+40>>2]|0)!=0;$O(t[b>>2]|0,2,200752)|0;iA(t[b>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if(!i){if((t[(t[n>>2]|0)+40>>2]|0)==2)DV(t[n>>2]|0,0);$O(t[b>>2]|0,2,200768)|0;s=r;return}if(t[(t[f>>2]|0)+40>>2]|0){if((t[(t[n>>2]|0)+40>>2]|0)==2)DV(t[n>>2]|0,0);else $O(t[b>>2]|0,1,200760)|0;iA(t[b>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0}$O(t[b>>2]|0,2,200768)|0;s=r;return}i=t[f>>2]|0;if((t[h+4>>2]|0)==8){if(!(t[i+40>>2]|0)){s=r;return}$O(t[b>>2]|0,4,200776)|0;iA(t[b>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0;$O(t[b>>2]|0,3,200784)|0;s=r;return}if((t[i+4>>2]|0)==5){$O(t[b>>2]|0,1,200792)|0;iA(t[b>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;$O(t[b>>2]|0,1,200800)|0;s=r;return}i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==4){do if(t[i+40>>2]|0){if(!(u[t[(t[f>>2]|0)+40>>2]>>0]|0))break;h=t[(t[f>>2]|0)+40>>2]|0;t[l>>2]=h;t[c>>2]=h;while(1){if(!(u[t[l>>2]>>0]|0))break;do if((u[t[l>>2]>>0]|0|0)==93){if((u[(t[l>>2]|0)+1>>0]|0|0)!=93)break;if((u[(t[l>>2]|0)+2>>0]|0|0)!=62)break;t[l>>2]=(t[l>>2]|0)+2;$O(t[b>>2]|0,9,200824)|0;$O(t[b>>2]|0,(t[l>>2]|0)-(t[c>>2]|0)|0,t[c>>2]|0)|0;$O(t[b>>2]|0,3,200840)|0;t[c>>2]=t[l>>2]}while(0);t[l>>2]=(t[l>>2]|0)+1}if((t[c>>2]|0)==(t[l>>2]|0)){s=r;return}$O(t[b>>2]|0,9,200824)|0;iA(t[b>>2]|0,t[c>>2]|0)|0;$O(t[b>>2]|0,3,200840)|0;s=r;return}while(0);$O(t[b>>2]|0,12,200808)|0;s=r;return}if((t[i+4>>2]|0)==2){UV(t[n>>2]|0,t[f>>2]|0);s=r;return}i=t[n>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==18){zV(i,t[f>>2]|0);s=r;return}t[a>>2]=t[i+40>>2];e:do if((t[a>>2]|0)==1){t[o>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[o>>2]|0))break e;if((t[(t[o>>2]|0)+4>>2]|0)==3)break;if((t[(t[o>>2]|0)+4>>2]|0)==4)break;if((t[(t[o>>2]|0)+4>>2]|0)==5)break;t[o>>2]=t[(t[o>>2]|0)+24>>2]}t[(t[n>>2]|0)+40>>2]=0}while(0);$O(t[b>>2]|0,1,200848)|0;do if(t[(t[f>>2]|0)+36>>2]|0){if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[b>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;$O(t[b>>2]|0,1,200856)|0}while(0);iA(t[b>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if(t[(t[f>>2]|0)+48>>2]|0)jV(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0);if(t[(t[f>>2]|0)+44>>2]|0)VV(t[n>>2]|0,t[(t[f>>2]|0)+44>>2]|0);if(!((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+40>>2]|0)!=0:0))k=80;do if((k|0)==80){if(t[(t[f>>2]|0)+12>>2]|0)break;if(t[(t[n>>2]|0)+32>>2]&4)break;if((t[(t[n>>2]|0)+40>>2]|0)==2)DV(t[n>>2]|0,0);$O(t[b>>2]|0,2,201584)|0;t[(t[n>>2]|0)+40>>2]=t[a>>2];s=r;return}while(0);if((t[(t[n>>2]|0)+40>>2]|0)==2)DV(t[n>>2]|0,1);$O(t[b>>2]|0,1,200968)|0;do if((t[(t[f>>2]|0)+4>>2]|0)!=1){if(!(t[(t[f>>2]|0)+40>>2]|0))break;eA(t[b>>2]|0,t[(t[f>>2]|0)+40>>2]|0,t[(t[n>>2]|0)+116>>2]|0)|0}while(0);do if(t[(t[f>>2]|0)+12>>2]|0){if((t[(t[n>>2]|0)+40>>2]|0)==1)$O(t[b>>2]|0,1,200976)|0;if((t[(t[n>>2]|0)+36>>2]|0)>=0){k=(t[n>>2]|0)+36|0;t[k>>2]=(t[k>>2]|0)+1}xV(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);if((t[(t[n>>2]|0)+36>>2]|0)>0){k=(t[n>>2]|0)+36|0;t[k>>2]=(t[k>>2]|0)+-1}if(!(t[33984]|0))break;if((t[(t[n>>2]|0)+40>>2]|0)!=1)break;k=t[n>>2]|0;if((t[(t[n>>2]|0)+36>>2]|0)>(t[(t[n>>2]|0)+108>>2]|0))w=t[k+108>>2]|0;else w=t[k+36>>2]|0;k=te(t[(t[n>>2]|0)+112>>2]|0,w)|0;$O(t[b>>2]|0,k,(t[n>>2]|0)+44|0)|0}while(0);$O(t[b>>2]|0,2,201056)|0;do if(t[(t[f>>2]|0)+36>>2]|0){if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[b>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;$O(t[b>>2]|0,1,200856)|0}while(0);iA(t[b>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if((t[(t[n>>2]|0)+40>>2]|0)==2)DV(t[n>>2]|0,0);$O(t[b>>2]|0,1,200968)|0;t[(t[n>>2]|0)+40>>2]=t[a>>2];s=r;return}IV(t[n>>2]|0,t[f>>2]|0)|0;s=r;return}OV(t[n>>2]|0,t[f>>2]|0)|0;s=r;return}function MV(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;t[o>>2]=0;r=t[f>>2]|0;if((r|0)==1400)t[o>>2]=201440;else if((r|0)==1403)t[o>>2]=201496;else if((r|0)==1401)t[o>>2]=201464;else if((r|0)==1402)t[o>>2]=201520;else t[o>>2]=201552;dp(7,t[f>>2]|0,t[u>>2]|0,t[o>>2]|0,t[a>>2]|0);s=n;return}function RV(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0;r=s;s=s+16|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;i=t[f>>2]|0;t[f>>2]=i+1;n[i>>0]=38;i=t[f>>2]|0;t[f>>2]=i+1;n[i>>0]=35;i=t[f>>2]|0;t[f>>2]=i+1;n[i>>0]=120;do if((t[u>>2]|0)>=16){if((t[u>>2]|0)<256){t[a>>2]=(t[f>>2]|0)+1;break}if((t[u>>2]|0)<4096){t[a>>2]=(t[f>>2]|0)+2;break}if((t[u>>2]|0)<65536){t[a>>2]=(t[f>>2]|0)+3;break}i=t[f>>2]|0;if((t[u>>2]|0)<1048576){t[a>>2]=i+4;break}else{t[a>>2]=i+5;break}}else t[a>>2]=t[f>>2];while(0);t[f>>2]=(t[a>>2]|0)+1;while(1){if((t[u>>2]|0)<=0)break;do switch(t[u>>2]&15|0){case 14:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=69;break}case 10:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=65;break}case 2:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=50;break}case 7:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=55;break}case 9:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=57;break}case 5:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=53;break}case 12:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=67;break}case 0:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=48;break}case 3:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=51;break}case 11:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=66;break}case 15:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=70;break}case 13:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=68;break}case 6:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=54;break}case 8:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=56;break}case 4:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=52;break}case 1:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=49;break}default:{i=t[a>>2]|0;t[a>>2]=i+-1;n[i>>0]=48}}while(0);t[u>>2]=t[u>>2]>>4}u=t[f>>2]|0;t[f>>2]=u+1;n[u>>0]=59;n[t[f>>2]>>0]=0;s=r;return t[f>>2]|0}function NV(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;dp(7,2,0,0,t[r>>2]|0);s=i;return}function TV(e){e=e|0;var i=0,r=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;f=i+4|0;u=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+16>>2]|0)==0?(t[(t[r>>2]|0)+116>>2]|0)==0:0)t[(t[r>>2]|0)+116>>2]=389;t[u>>2]=rs(t[33988]|0)|0;if((t[33988]|0)==0|(t[u>>2]|0)==0){e=(t[r>>2]|0)+44|0;a=e+61|0;do{n[e>>0]=0;e=e+1|0}while((e|0)<(a|0))}else{t[(t[r>>2]|0)+112>>2]=t[u>>2];t[(t[r>>2]|0)+108>>2]=60/(t[(t[r>>2]|0)+112>>2]|0)|0;t[f>>2]=0;while(1){if((t[f>>2]|0)>=(t[(t[r>>2]|0)+108>>2]|0))break;u=te(t[f>>2]|0,t[(t[r>>2]|0)+112>>2]|0)|0;YY((t[r>>2]|0)+44+u|0,t[33988]|0,t[(t[r>>2]|0)+112>>2]|0)|0;t[f>>2]=(t[f>>2]|0)+1}f=te(t[(t[r>>2]|0)+108>>2]|0,t[(t[r>>2]|0)+112>>2]|0)|0;n[(t[r>>2]|0)+44+f>>0]=0}if(!(t[33990]|0)){s=i;return}f=(t[r>>2]|0)+32|0;t[f>>2]=t[f>>2]|4;s=i;return}function LV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;r=s;s=s+48|0;n=r+36|0;f=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;h=r+4|0;w=r;t[n>>2]=e;t[f>>2]=i;t[o>>2]=0;if(!(t[f>>2]|0)){s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)!=9?(t[(t[f>>2]|0)+4>>2]|0)!=13:0){if((t[(t[f>>2]|0)+4>>2]|0)==19){s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==20){s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==18){zV(t[n>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==14){HV(t[n>>2]|0,t[f>>2]|0);s=r;return}i=t[n>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==11){qV(i,t[(t[f>>2]|0)+12>>2]|0);s=r;return}t[k>>2]=t[i+24>>2];if((t[(t[f>>2]|0)+4>>2]|0)==15){eV(t[(t[k>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==16){iV(t[(t[k>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}if((t[(t[f>>2]|0)+4>>2]|0)==17){rV(t[(t[k>>2]|0)+16>>2]|0,t[f>>2]|0);s=r;return}i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==3){if(!(t[i+40>>2]|0)){s=r;return}if((t[(t[f>>2]|0)+8>>2]|0)!=75104?(t[(t[f>>2]|0)+8>>2]|0)==75112:0){iA(t[k>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0;s=r;return}eA(t[k>>2]|0,t[(t[f>>2]|0)+40>>2]|0,t[(t[n>>2]|0)+116>>2]|0)|0;s=r;return}e=t[f>>2]|0;if((t[i+4>>2]|0)==7){i=(t[e+40>>2]|0)!=0;$O(t[k>>2]|0,2,200752)|0;iA(t[k>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if(!i){$O(t[k>>2]|0,2,200768)|0;s=r;return}if(t[(t[f>>2]|0)+40>>2]|0){$O(t[k>>2]|0,1,200760)|0;iA(t[k>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0}$O(t[k>>2]|0,2,200768)|0;s=r;return}i=t[f>>2]|0;if((t[e+4>>2]|0)==8){if(!(t[i+40>>2]|0)){s=r;return}$O(t[k>>2]|0,4,200776)|0;iA(t[k>>2]|0,t[(t[f>>2]|0)+40>>2]|0)|0;$O(t[k>>2]|0,3,200784)|0;s=r;return}if((t[i+4>>2]|0)==5){$O(t[k>>2]|0,1,200792)|0;iA(t[k>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;$O(t[k>>2]|0,1,200800)|0;s=r;return}i=t[f>>2]|0;if((t[(t[f>>2]|0)+4>>2]|0)==4){do if(t[i+40>>2]|0){if(!(u[t[(t[f>>2]|0)+40>>2]>>0]|0))break;e=t[(t[f>>2]|0)+40>>2]|0;t[b>>2]=e;t[l>>2]=e;while(1){if(!(u[t[b>>2]>>0]|0))break;do if((u[t[b>>2]>>0]|0|0)==93){if((u[(t[b>>2]|0)+1>>0]|0|0)!=93)break;if((u[(t[b>>2]|0)+2>>0]|0|0)!=62)break;t[b>>2]=(t[b>>2]|0)+2;$O(t[k>>2]|0,9,200824)|0;$O(t[k>>2]|0,(t[b>>2]|0)-(t[l>>2]|0)|0,t[l>>2]|0)|0;$O(t[k>>2]|0,3,200840)|0;t[l>>2]=t[b>>2]}while(0);t[b>>2]=(t[b>>2]|0)+1}if((t[l>>2]|0)==(t[b>>2]|0)){s=r;return}$O(t[k>>2]|0,9,200824)|0;iA(t[k>>2]|0,t[l>>2]|0)|0;$O(t[k>>2]|0,3,200840)|0;s=r;return}while(0);$O(t[k>>2]|0,12,200808)|0;s=r;return}l=t[n>>2]|0;if((t[i+4>>2]|0)==2){UV(l,t[f>>2]|0);s=r;return}t[a>>2]=t[l+40>>2];e:do if((t[a>>2]|0)==1){t[c>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break e;if((t[(t[c>>2]|0)+4>>2]|0)==3)break;if((t[(t[c>>2]|0)+4>>2]|0)==5)break;t[c>>2]=t[(t[c>>2]|0)+24>>2]}t[a>>2]=0}while(0);$O(t[k>>2]|0,1,200848)|0;do if(t[(t[f>>2]|0)+36>>2]|0){if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[k>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;$O(t[k>>2]|0,1,200856)|0}while(0);iA(t[k>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if(t[(t[f>>2]|0)+48>>2]|0)jV(t[n>>2]|0,t[(t[f>>2]|0)+48>>2]|0);do if(Xl(t[(t[f>>2]|0)+8>>2]|0,200864)|0){if(t[(t[f>>2]|0)+36>>2]|0)break;if(t[(t[f>>2]|0)+48>>2]|0)break;iA(t[k>>2]|0,200872)|0}while(0);if(t[(t[f>>2]|0)+44>>2]|0)YV(t[n>>2]|0,t[(t[f>>2]|0)+44>>2]|0);do if((t[(t[f>>2]|0)+4>>2]|0)==1){if(!(t[(t[f>>2]|0)+20>>2]|0))break;if((t[(t[(t[f>>2]|0)+20>>2]|0)+20>>2]|0)!=(t[(t[f>>2]|0)+32>>2]|0))break;if(!(Xl(t[(t[f>>2]|0)+8>>2]|0,200912)|0))break;if(!(Xl(t[(t[(t[f>>2]|0)+20>>2]|0)+8>>2]|0,200864)|0))break;t[c>>2]=t[(t[f>>2]|0)+12>>2];e:while(1){if(!(t[c>>2]|0))break;do if(Xl(t[(t[c>>2]|0)+8>>2]|0,200920)|0){t[h>>2]=cF(t[c>>2]|0,200928)|0;if(!(t[h>>2]|0))break;l=(Ql(t[h>>2]|0,200944)|0)==0;pAi[t[135736>>2]&511](t[h>>2]|0);if(l)break e}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}if(t[c>>2]|0)break;t[o>>2]=1}while(0);do if((t[(t[f>>2]|0)+4>>2]|0)==1){if(t[(t[f>>2]|0)+12>>2]|0)break;if(!((t[(t[f>>2]|0)+36>>2]|0)!=0?(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0))d=86;do if((d|0)==86){c=(GV(t[f>>2]|0)|0)==1;if(!(c&(t[o>>2]|0)==0))break;$O(t[k>>2]|0,3,200960)|0;s=r;return}while(0);c=(t[o>>2]|0)==1;$O(t[k>>2]|0,1,200968)|0;do if(c){do if((t[(t[n>>2]|0)+40>>2]|0)==1){$O(t[k>>2]|0,1,200976)|0;if(!(t[33984]|0))break;h=t[n>>2]|0;if(((t[(t[n>>2]|0)+36>>2]|0)+1|0)>(t[(t[n>>2]|0)+108>>2]|0))v=t[h+108>>2]|0;else v=(t[h+36>>2]|0)+1|0;h=te(t[(t[n>>2]|0)+112>>2]|0,v)|0;$O(t[k>>2]|0,h,(t[n>>2]|0)+44|0)|0}while(0);iA(t[k>>2]|0,200984)|0;h=t[k>>2]|0;if(t[(t[n>>2]|0)+16>>2]|0)iA(h,t[(t[n>>2]|0)+16>>2]|0)|0;else $O(h,5,200728)|0;$O(t[k>>2]|0,4,201048)|0;if((t[(t[n>>2]|0)+40>>2]|0)!=1)break;$O(t[k>>2]|0,1,200976)|0}while(0);$O(t[k>>2]|0,2,201056)|0;do if(t[(t[f>>2]|0)+36>>2]|0){if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[k>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;$O(t[k>>2]|0,1,200856)|0}while(0);iA(t[k>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;$O(t[k>>2]|0,1,200968)|0;s=r;return}while(0);$O(t[k>>2]|0,1,200968)|0;if((t[o>>2]|0)==1){do if((t[(t[n>>2]|0)+40>>2]|0)==1){$O(t[k>>2]|0,1,200976)|0;if(!(t[33984]|0))break;o=t[n>>2]|0;if(((t[(t[n>>2]|0)+36>>2]|0)+1|0)>(t[(t[n>>2]|0)+108>>2]|0))m=t[o+108>>2]|0;else m=(t[o+36>>2]|0)+1|0;o=te(t[(t[n>>2]|0)+112>>2]|0,m)|0;$O(t[k>>2]|0,o,(t[n>>2]|0)+44|0)|0}while(0);iA(t[k>>2]|0,200984)|0;m=t[k>>2]|0;if(t[(t[n>>2]|0)+16>>2]|0)iA(m,t[(t[n>>2]|0)+16>>2]|0)|0;else $O(m,5,200728)|0;$O(t[k>>2]|0,4,201048)|0}do if((t[(t[f>>2]|0)+4>>2]|0)!=1){if(!(t[(t[f>>2]|0)+40>>2]|0))break;eA(t[k>>2]|0,t[(t[f>>2]|0)+40>>2]|0,t[(t[n>>2]|0)+116>>2]|0)|0}while(0);do if(t[(t[f>>2]|0)+12>>2]|0){t[w>>2]=t[(t[n>>2]|0)+40>>2];if((t[a>>2]|0)==1)$O(t[k>>2]|0,1,200976)|0;if((t[(t[n>>2]|0)+36>>2]|0)>=0){m=(t[n>>2]|0)+36|0;t[m>>2]=(t[m>>2]|0)+1}t[(t[n>>2]|0)+40>>2]=t[a>>2];qV(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);if((t[(t[n>>2]|0)+36>>2]|0)>0){m=(t[n>>2]|0)+36|0;t[m>>2]=(t[m>>2]|0)+-1}t[(t[n>>2]|0)+40>>2]=t[w>>2];if(!((t[33984]|0)!=0&(t[a>>2]|0)==1))break;m=t[n>>2]|0;if((t[(t[n>>2]|0)+36>>2]|0)>(t[(t[n>>2]|0)+108>>2]|0))_=t[m+108>>2]|0;else _=t[m+36>>2]|0;m=te(t[(t[n>>2]|0)+112>>2]|0,_)|0;$O(t[k>>2]|0,m,(t[n>>2]|0)+44|0)|0}while(0);$O(t[k>>2]|0,2,201056)|0;do if(t[(t[f>>2]|0)+36>>2]|0){if(!(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0))break;iA(t[k>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;$O(t[k>>2]|0,1,200856)|0}while(0);iA(t[k>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;$O(t[k>>2]|0,1,200968)|0;s=r;return}OV(t[n>>2]|0,t[f>>2]|0)|0;s=r;return}function DV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[n>>2]|0)){s=r;return}if(!(t[(t[n>>2]|0)+24>>2]|0)){s=r;return}$O(t[(t[n>>2]|0)+24>>2]|0,1,200976)|0;t[u>>2]=0;while(1){if((t[u>>2]|0)>=((t[(t[n>>2]|0)+36>>2]|0)+(t[f>>2]|0)|0))break;i=t[n>>2]|0;if(((t[(t[n>>2]|0)+36>>2]|0)+(t[f>>2]|0)-(t[u>>2]|0)|0)>(t[(t[n>>2]|0)+108>>2]|0))a=t[i+108>>2]|0;else a=(t[i+36>>2]|0)+(t[f>>2]|0)-(t[u>>2]|0)|0;i=te(t[(t[n>>2]|0)+112>>2]|0,a)|0;$O(t[(t[n>>2]|0)+24>>2]|0,i,(t[n>>2]|0)+44|0)|0;t[u>>2]=(t[u>>2]|0)+(t[(t[n>>2]|0)+108>>2]|0)}s=r;return}function CV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=t[(t[f>>2]|0)+24>>2];do if(((t[u>>2]|0)!=0?(t[(t[a>>2]|0)+12>>2]|0)==0:0)?(t[(t[a>>2]|0)+20>>2]|0)==0:0){f=V_(t[u>>2]|0)|0;t[(t[a>>2]|0)+12>>2]=f;if(!(t[(t[a>>2]|0)+12>>2]|0)){MV(1403,0,t[u>>2]|0);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}f=ds()|0;t[(t[a>>2]|0)+20>>2]=f;f=t[a>>2]|0;if(t[(t[a>>2]|0)+20>>2]|0){G_(f,1)|0;break}W_(t[f+12>>2]|0)|0;NV(201600);t[n>>2]=-1;o=t[n>>2]|0;s=r;return o|0}while(0);t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}function PV(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;_=a+4|0;t[l>>2]=e;t[b>>2]=i;t[k>>2]=r;t[h>>2]=f;t[w>>2]=t[l>>2];t[d>>2]=t[k>>2];t[v>>2]=(t[l>>2]|0)+(t[t[b>>2]>>2]|0);t[m>>2]=(t[k>>2]|0)+(t[t[h>>2]>>2]|0);e:while(1){if((t[k>>2]|0)>>>0>=(t[m>>2]|0)>>>0){p=46;break}if((t[l>>2]|0)>>>0>=(t[v>>2]|0)>>>0){p=46;break}if((u[t[k>>2]>>0]|0|0)==60){if(((t[v>>2]|0)-(t[l>>2]|0)|0)<4){p=46;break}f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=38;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=108;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=116;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=59;t[k>>2]=(t[k>>2]|0)+1;continue}if((u[t[k>>2]>>0]|0|0)==62){if(((t[v>>2]|0)-(t[l>>2]|0)|0)<4){p=46;break}f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=38;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=103;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=116;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=59;t[k>>2]=(t[k>>2]|0)+1;continue}if((u[t[k>>2]>>0]|0|0)==38){if(((t[v>>2]|0)-(t[l>>2]|0)|0)<5){p=46;break}f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=38;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=97;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=109;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=112;f=t[l>>2]|0;t[l>>2]=f+1;n[f>>0]=59;t[k>>2]=(t[k>>2]|0)+1;continue}if(!((u[t[k>>2]>>0]|0|0)>=32?(u[t[k>>2]>>0]|0|0)<128:0))p=15;if(((p|0)==15?(p=0,(u[t[k>>2]>>0]|0|0)!=10):0)?(u[t[k>>2]>>0]|0|0)!=9:0){if((u[t[k>>2]>>0]|0|0)<128){if(!(9<=(u[t[k>>2]>>0]|0|0)?(u[t[k>>2]>>0]|0|0)<=10:0))p=41;if(((p|0)==41?(p=0,(u[t[k>>2]>>0]|0|0)!=13):0)?32>(u[t[k>>2]>>0]|0|0):0){p=45;break}if(((t[v>>2]|0)-(t[l>>2]|0)|0)<6){p=46;break}f=t[l>>2]|0;r=t[k>>2]|0;t[k>>2]=r+1;t[l>>2]=RV(f,u[r>>0]|0)|0;continue}if(((t[v>>2]|0)-(t[l>>2]|0)|0)<11){p=46;break}if((u[t[k>>2]>>0]|0|0)<192){p=21;break}do if((u[t[k>>2]>>0]|0|0)<224){if(((t[m>>2]|0)-(t[k>>2]|0)|0)<2){p=46;break e}t[_>>2]=(u[t[k>>2]>>0]|0)&31;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|(u[(t[k>>2]|0)+1>>0]|0)&63;t[k>>2]=(t[k>>2]|0)+2}else{if((u[t[k>>2]>>0]|0|0)<240){if(((t[m>>2]|0)-(t[k>>2]|0)|0)<3){p=46;break e}t[_>>2]=(u[t[k>>2]>>0]|0)&15;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|(u[(t[k>>2]|0)+1>>0]|0)&63;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|(u[(t[k>>2]|0)+2>>0]|0)&63;t[k>>2]=(t[k>>2]|0)+3;break}if((u[t[k>>2]>>0]|0|0)>=248){p=31;break e}if(((t[m>>2]|0)-(t[k>>2]|0)|0)<4){p=46;break e}t[_>>2]=(u[t[k>>2]>>0]|0)&7;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|(u[(t[k>>2]|0)+1>>0]|0)&63;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|(u[(t[k>>2]|0)+2>>0]|0)&63;t[_>>2]=t[_>>2]<<6;t[_>>2]=t[_>>2]|(u[(t[k>>2]|0)+3>>0]|0)&63;t[k>>2]=(t[k>>2]|0)+4}while(0);r=t[_>>2]|0;if((t[_>>2]|0)<256){if(!(9<=(r|0)&(t[_>>2]|0)<=10|(t[_>>2]|0)==13|32<=(t[_>>2]|0))){p=37;break}}else if((!(256<=(r|0)&(t[_>>2]|0)<=55295)?!(57344<=(t[_>>2]|0)&(t[_>>2]|0)<=65533):0)?!(65536<=(t[_>>2]|0)&(t[_>>2]|0)<=1114111):0){p=37;break}t[l>>2]=RV(t[l>>2]|0,t[_>>2]|0)|0;continue}r=t[k>>2]|0;t[k>>2]=r+1;f=n[r>>0]|0;r=t[l>>2]|0;t[l>>2]=r+1;n[r>>0]=f}if((p|0)==21){MV(1400,0,0);t[k>>2]=(t[k>>2]|0)+1}else if((p|0)==31){MV(1401,0,0);t[k>>2]=(t[k>>2]|0)+1}else if((p|0)==37){MV(1401,0,0);t[k>>2]=(t[k>>2]|0)+1}else if((p|0)==45){yAi[t[135904>>2]&511](t[33980]|0,201400,o);t[k>>2]=(t[k>>2]|0)+1}else if((p|0)==46){t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[k>>2]|0)-(t[d>>2]|0);t[c>>2]=0;E=t[c>>2]|0;s=a;return E|0}t[t[b>>2]>>2]=(t[l>>2]|0)-(t[w>>2]|0);t[t[h>>2]>>2]=(t[k>>2]|0)-(t[d>>2]|0);t[c>>2]=-1;E=t[c>>2]|0;s=a;return E|0}function BV(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;t[n>>2]=t[(t[r>>2]|0)+24>>2];xO(t[n>>2]|0)|0;W_(t[(t[n>>2]|0)+12>>2]|0)|0;Ss(t[(t[n>>2]|0)+20>>2]|0);t[(t[n>>2]|0)+12>>2]=0;t[(t[n>>2]|0)+20>>2]=0;s=i;return 0}function IV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+48|0;n=r+32|0;f=r+28|0;u=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[f>>2]=e;t[u>>2]=i;t[a>>2]=0;t[o>>2]=t[(t[f>>2]|0)+16>>2];t[c>>2]=t[(t[f>>2]|0)+16>>2];t[l>>2]=t[(t[f>>2]|0)+24>>2];t[b>>2]=0;rS();t[k>>2]=t[(t[u>>2]|0)+32>>2];do if(t[k>>2]|0){t[a>>2]=t[(t[k>>2]|0)+60>>2];if(t[(t[f>>2]|0)+16>>2]|0){t[(t[k>>2]|0)+60>>2]=t[(t[f>>2]|0)+16>>2];break}if(t[(t[k>>2]|0)+60>>2]|0)t[c>>2]=t[(t[k>>2]|0)+60>>2]}while(0);if((t[c>>2]|0)!=0&(t[k>>2]|0)!=0)Wi(t[k>>2]|0,t[c>>2]|0)|0;if((t[c>>2]|0)==0&(t[k>>2]|0)!=0)t[c>>2]=Gi(t[k>>2]|0)|0;if(!(t[c>>2]|0))t[c>>2]=201592;do if(((t[c>>2]|0)!=0&(t[o>>2]|0)==0?(t[(t[l>>2]|0)+12>>2]|0)==0:0)?(t[(t[l>>2]|0)+20>>2]|0)==0:0){if((CV(t[f>>2]|0,t[c>>2]|0)|0)>=0){t[b>>2]=1;break}t[(t[k>>2]|0)+60>>2]=t[a>>2];t[n>>2]=-1;h=t[n>>2]|0;s=r;return h|0}while(0);i=t[l>>2]|0;l=t[k>>2]|0;e=t[u>>2]|0;u=t[c>>2]|0;if(t[(t[f>>2]|0)+32>>2]&1)Zi(i,l,e,u,1);else Zi(i,l,e,u,0);if((t[b>>2]|0)!=0&(t[o>>2]|0)==0)BV(t[f>>2]|0)|0;if(t[k>>2]|0)t[(t[k>>2]|0)+60>>2]=t[a>>2];t[n>>2]=0;h=t[n>>2]|0;s=r;return h|0}function HV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;if((t[f>>2]|0)==0|(t[n>>2]|0)==0){s=r;return}if(!(t[(t[n>>2]|0)+24>>2]|0)){s=r;return}t[u>>2]=t[(t[n>>2]|0)+24>>2];$O(t[u>>2]|0,10,201336)|0;iA(t[u>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;if(!(t[(t[f>>2]|0)+52>>2]|0)){if(t[(t[f>>2]|0)+56>>2]|0){$O(t[u>>2]|0,8,201368)|0;xs(t[(t[u>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+56>>2]|0)|0}}else{$O(t[u>>2]|0,8,201352)|0;xs(t[(t[u>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+52>>2]|0)|0;$O(t[u>>2]|0,1,200760)|0;xs(t[(t[u>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+56>>2]|0)|0}if(((((t[(t[f>>2]|0)+48>>2]|0)==0?(t[(t[f>>2]|0)+40>>2]|0)==0:0)?(t[(t[f>>2]|0)+44>>2]|0)==0:0)?(t[(t[f>>2]|0)+36>>2]|0)==0:0)?(t[(t[f>>2]|0)+60>>2]|0)==0:0){$O(t[u>>2]|0,1,200968)|0;s=r;return}$O(t[u>>2]|0,3,201384)|0;do if(t[(t[f>>2]|0)+36>>2]|0){if((t[(t[f>>2]|0)+32>>2]|0)!=0?(t[(t[(t[f>>2]|0)+32>>2]|0)+44>>2]|0)!=(t[f>>2]|0):0)break;$j(t[(t[u>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+36>>2]|0)}while(0);t[a>>2]=t[(t[n>>2]|0)+40>>2];t[o>>2]=t[(t[n>>2]|0)+36>>2];t[c>>2]=t[(t[n>>2]|0)+28>>2];t[(t[n>>2]|0)+40>>2]=0;t[(t[n>>2]|0)+36>>2]=-1;t[(t[n>>2]|0)+28>>2]=t[(t[f>>2]|0)+32>>2];xV(t[n>>2]|0,t[(t[f>>2]|0)+12>>2]|0);t[(t[n>>2]|0)+40>>2]=t[a>>2];t[(t[n>>2]|0)+36>>2]=t[o>>2];t[(t[n>>2]|0)+28>>2]=t[c>>2];$O(t[u>>2]|0,2,201392)|0;s=r;return}function xV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}t[u>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[f>>2]|0))break;do if((t[33984]|0)!=0?(t[(t[n>>2]|0)+40>>2]|0)==1:0){if(((t[(t[f>>2]|0)+4>>2]|0)!=1?(t[(t[f>>2]|0)+4>>2]|0)!=8:0)?(t[(t[f>>2]|0)+4>>2]|0)!=7:0)break;i=t[n>>2]|0;if((t[(t[n>>2]|0)+36>>2]|0)>(t[(t[n>>2]|0)+108>>2]|0))a=t[i+108>>2]|0;else a=t[i+36>>2]|0;i=te(t[(t[n>>2]|0)+112>>2]|0,a)|0;$O(t[u>>2]|0,i,(t[n>>2]|0)+44|0)|0}while(0);AV(t[n>>2]|0,t[f>>2]|0);if((t[(t[n>>2]|0)+40>>2]|0)==1)$O(t[u>>2]|0,1,200976)|0;t[f>>2]=t[(t[f>>2]|0)+24>>2]}s=r;return}function UV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}t[u>>2]=t[(t[n>>2]|0)+24>>2];if(!(t[u>>2]|0)){s=r;return}if((t[(t[n>>2]|0)+40>>2]|0)==2)DV(t[n>>2]|0,2);else $O(t[u>>2]|0,1,200760)|0;if((t[(t[f>>2]|0)+36>>2]|0)!=0?(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){iA(t[u>>2]|0,t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;$O(t[u>>2]|0,1,200856)|0}iA(t[u>>2]|0,t[(t[f>>2]|0)+8>>2]|0)|0;$O(t[u>>2]|0,2,201328)|0;WV(t[u>>2]|0,t[f>>2]|0);$O(t[u>>2]|0,1,201296)|0;s=r;return}function zV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;gV(t[(t[n>>2]|0)+24>>2]|0,t[f>>2]|0,t[n>>2]|0);s=r;return}function jV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;while(1){if(!(t[f>>2]|0))break;gV(t[(t[n>>2]|0)+24>>2]|0,t[f>>2]|0,t[n>>2]|0);t[f>>2]=t[t[f>>2]>>2]}s=r;return}function VV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;if(!((t[f>>2]|0)!=0&(t[f>>2]|0)!=0)){s=r;return}do{UV(t[n>>2]|0,t[f>>2]|0);t[f>>2]=t[(t[f>>2]|0)+24>>2]}while((t[f>>2]|0)!=0);s=r;return}function qV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;if(!(t[f>>2]|0)){s=r;return}t[u>>2]=t[(t[n>>2]|0)+24>>2];while(1){if(!(t[f>>2]|0))break;if(((t[33984]|0)!=0?(t[(t[n>>2]|0)+40>>2]|0)==1:0)?(t[(t[f>>2]|0)+4>>2]|0)==1:0){i=t[n>>2]|0;if((t[(t[n>>2]|0)+36>>2]|0)>(t[(t[n>>2]|0)+108>>2]|0))a=t[i+108>>2]|0;else a=t[i+36>>2]|0;i=te(t[(t[n>>2]|0)+112>>2]|0,a)|0;$O(t[u>>2]|0,i,(t[n>>2]|0)+44|0)|0}LV(t[n>>2]|0,t[f>>2]|0);if((t[(t[n>>2]|0)+40>>2]|0)==1)$O(t[u>>2]|0,1,200976)|0;t[f>>2]=t[(t[f>>2]|0)+24>>2]}s=r;return}function YV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;r=s;s=s+32|0;n=r+28|0;f=r+24|0;a=r+20|0;o=r+16|0;c=r+12|0;l=r+8|0;b=r+4|0;k=r;t[n>>2]=e;t[f>>2]=i;t[a>>2]=0;t[o>>2]=0;t[c>>2]=0;t[l>>2]=0;if(!(t[f>>2]|0)){s=r;return}t[k>>2]=t[(t[n>>2]|0)+24>>2];t[b>>2]=t[(t[f>>2]|0)+20>>2];while(1){if(!(t[f>>2]|0))break;if((t[(t[f>>2]|0)+36>>2]|0)==0?(Xl(t[(t[f>>2]|0)+8>>2]|0,201200)|0)!=0:0)t[l>>2]=t[f>>2];else h=7;do if((h|0)==7){h=0;if((t[(t[f>>2]|0)+36>>2]|0)==0?(Xl(t[(t[f>>2]|0)+8>>2]|0,201208)|0)!=0:0){t[c>>2]=t[f>>2];break}if((t[(t[f>>2]|0)+36>>2]|0)==0?(Xl(t[(t[f>>2]|0)+8>>2]|0,201216)|0)!=0:0){t[o>>2]=t[f>>2];break}if(((t[(t[f>>2]|0)+36>>2]|0)!=0?(Xl(t[(t[f>>2]|0)+8>>2]|0,201216)|0)!=0:0)?(Xl(t[(t[(t[f>>2]|0)+36>>2]|0)+12>>2]|0,201224)|0)!=0:0){t[a>>2]=t[f>>2];break}if(!(t[(t[f>>2]|0)+36>>2]|0)){if(((t[(t[f>>2]|0)+12>>2]|0)!=0?(t[(t[(t[f>>2]|0)+12>>2]|0)+40>>2]|0)!=0:0)?(u[t[(t[(t[f>>2]|0)+12>>2]|0)+40>>2]>>0]|0|0)!=0:0)break;if(Ki(t[(t[f>>2]|0)+8>>2]|0)|0){if(t[(t[f>>2]|0)+12>>2]|0)ry(t[(t[f>>2]|0)+12>>2]|0);i=yy(t[(t[f>>2]|0)+8>>2]|0)|0;t[(t[f>>2]|0)+12>>2]=i;if(t[(t[f>>2]|0)+12>>2]|0)t[(t[(t[f>>2]|0)+12>>2]|0)+20>>2]=t[f>>2]}}}while(0);UV(t[n>>2]|0,t[f>>2]|0);t[f>>2]=t[(t[f>>2]|0)+24>>2]}do if((t[c>>2]|0)!=0&(t[l>>2]|0)==0&(t[b>>2]|0)!=0?(t[(t[b>>2]|0)+8>>2]|0)!=0:0){if(((((((((Xl(t[(t[b>>2]|0)+8>>2]|0,201232)|0)==0?(Xl(t[(t[b>>2]|0)+8>>2]|0,201240)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201248)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201160)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201256)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201264)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201272)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201144)|0)==0:0)?(Xl(t[(t[b>>2]|0)+8>>2]|0,201280)|0)==0:0)break;$O(t[k>>2]|0,5,201288)|0;WV(t[k>>2]|0,t[c>>2]|0);$O(t[k>>2]|0,1,201296)|0}while(0);if((t[o>>2]|0)!=0&(t[a>>2]|0)==0){$O(t[k>>2]|0,11,201304)|0;WV(t[k>>2]|0,t[o>>2]|0);$O(t[k>>2]|0,1,201296)|0;s=r;return}if(!((t[a>>2]|0)!=0&(t[o>>2]|0)==0)){s=r;return}$O(t[k>>2]|0,7,201320)|0;WV(t[k>>2]|0,t[a>>2]|0);$O(t[k>>2]|0,1,201296)|0;s=r;return}function GV(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;e:do if(!(t[n>>2]|0))t[r>>2]=-1;else{if((t[(t[n>>2]|0)+4>>2]|0)!=1){t[r>>2]=0;break}if((t[(t[n>>2]|0)+36>>2]|0)!=0?(Xl(t[(t[(t[n>>2]|0)+36>>2]|0)+8>>2]|0,201064)|0)==0:0){t[r>>2]=0;break}if(t[(t[n>>2]|0)+12>>2]|0){t[r>>2]=0;break}do switch(u[t[(t[n>>2]|0)+8>>2]>>0]|0|0){case 98:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201104)|0){t[r>>2]=1;break e}if(Xl(t[(t[n>>2]|0)+8>>2]|0,201112)|0){t[r>>2]=1;break e}if(Xl(t[(t[n>>2]|0)+8>>2]|0,201120)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 99:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201136)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 97:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201096)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 109:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,200920)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 102:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201144)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 105:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201160)|0){t[r>>2]=1;break e}if(Xl(t[(t[n>>2]|0)+8>>2]|0,201168)|0){t[r>>2]=1;break e}if(Xl(t[(t[n>>2]|0)+8>>2]|0,201176)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 104:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201152)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 112:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201192)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}case 108:{if(Xl(t[(t[n>>2]|0)+8>>2]|0,201184)|0){t[r>>2]=1;break e}else{t[r>>2]=0;break e}break}default:{t[r>>2]=0;break e}}while(0)}while(0);s=i;return t[r>>2]|0}function WV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[n>>2]=e;t[f>>2]=i;t[u>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0))break;i=t[(t[u>>2]|0)+4>>2]|0;if((i|0)==5){Ps(t[(t[n>>2]|0)+16>>2]|0,200792,1)|0;e=t[(t[n>>2]|0)+16>>2]|0;a=t[(t[u>>2]|0)+8>>2]|0;Ps(e,a,rs(t[(t[u>>2]|0)+8>>2]|0)|0)|0;Ps(t[(t[n>>2]|0)+16>>2]|0,200800,1)|0}else if((i|0)==3)lV(t[(t[n>>2]|0)+16>>2]|0,t[(t[f>>2]|0)+32>>2]|0,t[f>>2]|0,t[(t[u>>2]|0)+40>>2]|0);t[u>>2]=t[(t[u>>2]|0)+24>>2]}s=r;return}function KV(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+8>>2]|0)!=0?(t[(t[r>>2]|0)+4>>2]|0)==0:0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0);iq(t[(t[r>>2]|0)+40>>2]|0);rq(t[(t[r>>2]|0)+36>>2]|0);bz(t[(t[r>>2]|0)+20>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function XV(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;if(!(t[n>>2]|0)){t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}t[f>>2]=gAi[t[135744>>2]&511](84)|0;if(!(t[f>>2]|0)){nq(0,201776,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}e=(t[f>>2]|0)+0|0;a=e+84|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[t[f>>2]>>2]=1;e=lz()|0;t[(t[f>>2]|0)+24>>2]=e;e=kz(t[(t[f>>2]|0)+24>>2]|0,t[n>>2]|0,-1)|0;t[(t[f>>2]|0)+4>>2]=e;t[(t[f>>2]|0)+64>>2]=0;e=wf(0)|0;t[(t[f>>2]|0)+36>>2]=e;if(!(t[(t[f>>2]|0)+36>>2]|0)){nq(0,201816,0);ZV(t[f>>2]|0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{t[(t[(t[f>>2]|0)+36>>2]|0)+196>>2]=1;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function ZV(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if((t[(t[r>>2]|0)+8>>2]|0)!=0?(t[(t[r>>2]|0)+12>>2]|0)==0:0)fy(t[(t[r>>2]|0)+8>>2]|0);if(t[(t[r>>2]|0)+36>>2]|0)vf(t[(t[r>>2]|0)+36>>2]|0);if(t[(t[r>>2]|0)+52>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+52>>2]|0);bz(t[(t[r>>2]|0)+24>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function JV(e){e=e|0;var i=0,r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;i=s;s=s+48|0;r=i+36|0;n=i+32|0;f=i+28|0;a=i+24|0;o=i+20|0;c=i+16|0;l=i+12|0;b=i+8|0;k=i+4|0;h=i;t[n>>2]=e;t[f>>2]=0;t[l>>2]=0;if(!(t[n>>2]|0)){t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}t[(t[n>>2]|0)+28>>2]=0;e=t[n>>2]|0;do if(!(t[(t[n>>2]|0)+4>>2]|0)){d=t[n>>2]|0;if(t[e+16>>2]|0){t[a>>2]=pS(t[d+16>>2]|0,t[(t[n>>2]|0)+20>>2]|0,0,0,2)|0;if(t[a>>2]|0){v=Yl(201944)|0;t[(t[a>>2]|0)+72>>2]=v;v=kz(t[(t[n>>2]|0)+24>>2]|0,201944,-1)|0;t[(t[n>>2]|0)+4>>2]=v;t[(t[n>>2]|0)+12>>2]=0;break}fq(t[n>>2]|0,0,1766,201904,0,0);t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}else{v=t[n>>2]|0;if(t[d+8>>2]|0){t[a>>2]=t[v+8>>2];t[l>>2]=1;t[(t[n>>2]|0)+12>>2]=1;break}fq(v,0,1758,201904,0,0);t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}}else{t[a>>2]=_S(t[e+4>>2]|0,0,2)|0;v=t[n>>2]|0;if(t[a>>2]|0){t[v+12>>2]=0;break}fq(v,0,1757,201856,t[(t[n>>2]|0)+4>>2]|0,0);t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}while(0);t[o>>2]=eF(t[a>>2]|0)|0;if(!(t[o>>2]|0)){fq(t[n>>2]|0,t[a>>2]|0,1759,201968,0,0);if(!(t[l>>2]|0))fy(t[a>>2]|0);t[r>>2]=0;w=t[r>>2]|0;s=i;return w|0}do if((((t[o>>2]|0)!=0?(t[(t[o>>2]|0)+4>>2]|0)==1:0)?(t[(t[o>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[o>>2]|0)+8>>2]|0,202008)|0)!=0:0){if((Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[o>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0){m=24;break}t[f>>2]=tq(t[n>>2]|0)|0;if(t[f>>2]|0){t[(t[n>>2]|0)+40>>2]=t[f>>2];t[c>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+36>>2]|0)!=0:0){if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)break;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)break}t[c>>2]=t[(t[c>>2]|0)+24>>2]}e:do if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==1:0)?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,202088)|0)!=0:0){if((Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0)break;t[b>>2]=sF(t[c>>2]|0)|0;if(t[b>>2]|0){e=kz(t[(t[f>>2]|0)+20>>2]|0,t[b>>2]|0,-1)|0;t[(t[f>>2]|0)+24>>2]=e;pAi[t[135736>>2]&511](t[b>>2]|0)}t[c>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))break e;do if((t[(t[c>>2]|0)+4>>2]|0)==1){if(!(t[(t[c>>2]|0)+36>>2]|0))break;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)break e;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)break e}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}}while(0);e:while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)!=1)break;if(!(t[(t[c>>2]|0)+36>>2]|0))break;if(!(Xl(t[(t[c>>2]|0)+8>>2]|0,202096)|0))break;if((Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0)break;t[k>>2]=vF(t[c>>2]|0,202104)|0;t[h>>2]=vF(t[c>>2]|0,202112)|0;if(!((t[h>>2]|0)!=0?(u[t[h>>2]>>0]|0|0)!=0:0))fq(t[n>>2]|0,t[c>>2]|0,1759,202120,0,0);if(!((t[k>>2]|0)!=0?(u[t[k>>2]>>0]|0|0)!=0:0))fq(t[n>>2]|0,t[c>>2]|0,1759,202144,0,0);if((t[k>>2]|0)!=0&(t[h>>2]|0)!=0){Kn(t[(t[n>>2]|0)+36>>2]|0,t[k>>2]|0,t[h>>2]|0)|0;uq(t[n>>2]|0,t[k>>2]|0,t[h>>2]|0);e=(t[f>>2]|0)+28|0;t[e>>2]=(t[e>>2]|0)+1}if(t[h>>2]|0)pAi[t[135736>>2]&511](t[h>>2]|0);if(t[k>>2]|0)pAi[t[135736>>2]&511](t[k>>2]|0);t[c>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))continue e;do if((t[(t[c>>2]|0)+4>>2]|0)==1){if(!(t[(t[c>>2]|0)+36>>2]|0))break;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)continue e;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)continue e}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2]}}e:while(1){if(!(t[c>>2]|0))break;do if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==1:0)?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,202176)|0)!=0:0){if((Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0){m=81;break}aq(t[n>>2]|0,t[c>>2]|0);e=(t[f>>2]|0)+32|0;t[e>>2]=(t[e>>2]|0)+1}else m=81;while(0);if((m|0)==81){m=0;fq(t[n>>2]|0,t[c>>2]|0,1759,202184,t[(t[c>>2]|0)+8>>2]|0,0)}t[c>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))continue e;if((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+36>>2]|0)!=0:0){if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)continue e;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)continue e;
	}t[c>>2]=t[(t[c>>2]|0)+24>>2]}}if(!(t[(t[f>>2]|0)+32>>2]|0)){fq(t[n>>2]|0,t[o>>2]|0,1759,202232,t[(t[n>>2]|0)+4>>2]|0,0);break}t[(t[f>>2]|0)+8>>2]=t[a>>2];if(t[l>>2]|0)t[(t[f>>2]|0)+4>>2]=1;t[l>>2]=1}}else m=24;while(0);if((m|0)==24)fq(t[n>>2]|0,t[o>>2]|0,1759,202032,t[(t[n>>2]|0)+4>>2]|0,0);if(!(t[l>>2]|0))fy(t[a>>2]|0);do if(t[f>>2]|0)if(t[(t[n>>2]|0)+28>>2]|0){KV(t[f>>2]|0);t[f>>2]=0;break}else{t[(t[f>>2]|0)+52>>2]=t[(t[n>>2]|0)+52>>2];t[(t[f>>2]|0)+44>>2]=t[(t[n>>2]|0)+44>>2];t[(t[n>>2]|0)+52>>2]=0;break}while(0);t[r>>2]=t[f>>2];w=t[r>>2]|0;s=i;return w|0}function QV(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+16|0;f=r+12|0;u=r+8|0;a=r+4|0;o=r;t[f>>2]=e;t[u>>2]=i;t[o>>2]=gAi[t[135744>>2]&511](64)|0;if(!(t[o>>2]|0)){oq(0,202280,0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}i=(t[o>>2]|0)+0|0;e=i+64|0;do{t[i>>2]=0;i=i+4|0}while((i|0)<(e|0));t[t[o>>2]>>2]=2;t[(t[o>>2]|0)+20>>2]=t[f>>2];i=wf(0)|0;t[(t[o>>2]|0)+24>>2]=i;t[(t[o>>2]|0)+4>>2]=t[u>>2];if(!(t[(t[o>>2]|0)+24>>2]|0)){nq(0,201816,0);$V(t[o>>2]|0);t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=0;while(1){if((t[a>>2]|0)>=(t[(t[f>>2]|0)+44>>2]|0))break;if(!(t[(t[(t[f>>2]|0)+52>>2]|0)+(t[a>>2]<<1<<2)>>2]|0))break;if(!(t[(t[(t[f>>2]|0)+52>>2]|0)+((t[a>>2]<<1)+1<<2)>>2]|0))break;Kn(t[(t[o>>2]|0)+24>>2]|0,t[(t[(t[f>>2]|0)+52>>2]|0)+((t[a>>2]<<1)+1<<2)>>2]|0,t[(t[(t[f>>2]|0)+52>>2]|0)+(t[a>>2]<<1<<2)>>2]|0)|0;t[a>>2]=(t[a>>2]|0)+1}t[n>>2]=t[o>>2];c=t[n>>2]|0;s=r;return c|0}function $V(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}if(t[(t[r>>2]|0)+24>>2]|0)vf(t[(t[r>>2]|0)+24>>2]|0);if(t[(t[r>>2]|0)+8>>2]|0)bz(t[(t[r>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function eq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0;r=s;s=s+48|0;n=r;f=r+36|0;u=r+32|0;a=r+28|0;o=r+24|0;c=r+20|0;l=r+16|0;b=r+12|0;k=r+8|0;t[u>>2]=e;t[a>>2]=i;if(((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+20>>2]|0)!=0:0)?!((t[a>>2]|0)==0?1:(t[(t[(t[u>>2]|0)+20>>2]|0)+40>>2]|0)==0):0){t[(t[u>>2]|0)+12>>2]=0;t[c>>2]=eF(t[a>>2]|0)|0;if(!(t[c>>2]|0)){i=t[33976]|0;e=t[33980]|0;t[n>>2]=202344;t[n+4>>2]=1679;yAi[i&511](e,202312,n);n=(t[u>>2]|0)+12|0;t[n>>2]=(t[n>>2]|0)+1;t[f>>2]=1;h=t[f>>2]|0;s=r;return h|0}e:do if((t[(t[u>>2]|0)+4>>2]&1|0)==0?(t[(t[u>>2]|0)+4>>2]|0)!=0:0){t[l>>2]=t[(t[(t[u>>2]|0)+20>>2]|0)+36>>2];while(1){if(!(t[l>>2]|0))break e;sq(t[u>>2]|0,t[l>>2]|0);t[o>>2]=t[c>>2];while(1){w=t[l>>2]|0;if(!(t[o>>2]|0))break;t[b>>2]=t[w+4>>2];while(1){if(!(t[b>>2]|0))break;i:do if((Oj(t[(t[b>>2]|0)+20>>2]|0,t[o>>2]|0)|0)==1){t[k>>2]=t[(t[b>>2]|0)+16>>2];while(1){if(!(t[k>>2]|0))break i;cq(t[u>>2]|0,t[k>>2]|0,t[a>>2]|0,t[o>>2]|0,t[l>>2]|0)|0;t[k>>2]=t[t[k>>2]>>2]}}while(0);t[b>>2]=t[(t[b>>2]|0)+4>>2]}t[o>>2]=lq(t[o>>2]|0)|0}t[l>>2]=t[w>>2]}}else d=9;while(0);e:do if((d|0)==9){t[o>>2]=t[c>>2];while(1){if(!(t[o>>2]|0))break e;t[b>>2]=t[(t[(t[u>>2]|0)+20>>2]|0)+40>>2];while(1){if(!(t[b>>2]|0))break;i:do if((Oj(t[(t[b>>2]|0)+20>>2]|0,t[o>>2]|0)|0)==1){t[k>>2]=t[(t[b>>2]|0)+16>>2];while(1){if(!(t[k>>2]|0))break i;cq(t[u>>2]|0,t[k>>2]|0,t[a>>2]|0,t[o>>2]|0,t[(t[b>>2]|0)+20>>2]|0)|0;t[k>>2]=t[t[k>>2]>>2]}}while(0);t[b>>2]=t[t[b>>2]>>2]}t[o>>2]=lq(t[o>>2]|0)|0}}while(0);t[f>>2]=t[(t[u>>2]|0)+12>>2];h=t[f>>2]|0;s=r;return h|0}t[f>>2]=-1;h=t[f>>2]|0;s=r;return h|0}function iq(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];if(t[(t[r>>2]|0)+16>>2]|0)bq(t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+20>>2]|0)vj(t[(t[r>>2]|0)+20>>2]|0);if(t[(t[r>>2]|0)+24>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+24>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function rq(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];if(t[(t[r>>2]|0)+8>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+8>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function nq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(t[f>>2]|0){r=(t[f>>2]|0)+28|0;t[r>>2]=(t[r>>2]|0)+1}dp(16,2,t[a>>2]|0,0,t[u>>2]|0);s=n;return}function fq(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0;a=s;s=s+48|0;o=a;c=a+40|0;l=a+36|0;b=a+32|0;k=a+28|0;h=a+24|0;w=a+20|0;d=a+16|0;v=a+12|0;m=a+8|0;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;t[d>>2]=0;t[v>>2]=0;t[m>>2]=0;if(t[c>>2]|0){u=(t[c>>2]|0)+28|0;t[u>>2]=(t[u>>2]|0)+1;t[d>>2]=t[(t[c>>2]|0)+72>>2];t[m>>2]=t[(t[c>>2]|0)+68>>2];t[v>>2]=t[(t[c>>2]|0)+80>>2]}u=t[v>>2]|0;v=t[d>>2]|0;d=t[m>>2]|0;m=t[c>>2]|0;c=t[l>>2]|0;l=t[b>>2]|0;b=t[h>>2]|0;f=t[w>>2]|0;n=t[k>>2]|0;k=t[w>>2]|0;t[o>>2]=t[h>>2];t[o+4>>2]=k;cp(u,v,d,m,c,16,l,2,0,0,b,f,0,0,0,n,o);s=a;return}function tq(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[n>>2]=e;t[f>>2]=gAi[t[135744>>2]&511](56)|0;if(!(t[f>>2]|0)){nq(t[n>>2]|0,203040,0);t[r>>2]=0;u=t[r>>2]|0;s=i;return u|0}else{e=(t[f>>2]|0)+0|0;a=e+56|0;do{t[e>>2]=0;e=e+4|0}while((e|0)<(a|0));t[(t[f>>2]|0)+20>>2]=t[(t[n>>2]|0)+24>>2];sz(t[(t[f>>2]|0)+20>>2]|0)|0;t[r>>2]=t[f>>2];u=t[r>>2]|0;s=i;return u|0}return 0}function uq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;r=t[f>>2]|0;do if(t[(t[f>>2]|0)+52>>2]|0){if(((t[r+44>>2]|0)+2|0)>=(t[(t[f>>2]|0)+48>>2]|0)){t[o>>2]=MAi[t[135760>>2]&511](t[(t[f>>2]|0)+52>>2]|0,t[(t[f>>2]|0)+48>>2]<<2<<2)|0;if(t[o>>2]|0){t[(t[f>>2]|0)+52>>2]=t[o>>2];i=(t[f>>2]|0)+48|0;t[i>>2]=t[i>>2]<<1;break}nq(0,203008,0);s=n;return}}else{t[r+48>>2]=10;i=gAi[t[135744>>2]&511](t[(t[f>>2]|0)+48>>2]<<1<<2)|0;t[(t[f>>2]|0)+52>>2]=i;if(t[(t[f>>2]|0)+52>>2]|0){t[(t[f>>2]|0)+44>>2]=0;break}nq(0,203008,0);s=n;return}while(0);r=kz(t[(t[f>>2]|0)+24>>2]|0,t[a>>2]|0,-1)|0;t[(t[(t[f>>2]|0)+52>>2]|0)+(t[(t[f>>2]|0)+44>>2]<<1<<2)>>2]=r;r=kz(t[(t[f>>2]|0)+24>>2]|0,t[u>>2]|0,-1)|0;t[(t[(t[f>>2]|0)+52>>2]|0)+((t[(t[f>>2]|0)+44>>2]<<1)+1<<2)>>2]=r;r=(t[f>>2]|0)+44|0;t[r>>2]=(t[r>>2]|0)+1;t[(t[(t[f>>2]|0)+52>>2]|0)+(t[(t[f>>2]|0)+44>>2]<<1<<2)>>2]=0;t[(t[(t[f>>2]|0)+52>>2]|0)+((t[(t[f>>2]|0)+44>>2]<<1)+1<<2)>>2]=0;s=n;return}function aq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;c=r;t[n>>2]=e;t[f>>2]=i;t[o>>2]=0;if((t[n>>2]|0)==0|(t[f>>2]|0)==0){s=r;return}t[c>>2]=vF(t[f>>2]|0,202488)|0;if(!(t[c>>2]|0))t[c>>2]=vF(t[f>>2]|0,202464)|0;t[a>>2]=kq(t[n>>2]|0,t[(t[n>>2]|0)+40>>2]|0,t[f>>2]|0,t[c>>2]|0)|0;if(!(t[a>>2]|0)){if(!(t[c>>2]|0)){s=r;return}pAi[t[135736>>2]&511](t[c>>2]|0);s=r;return}t[u>>2]=t[(t[f>>2]|0)+12>>2];while(1){if(!(t[u>>2]|0))break;if((t[(t[u>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+36>>2]|0)!=0:0){if(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)break;if(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)break}t[u>>2]=t[(t[u>>2]|0)+24>>2]}e:while(1){if(!(t[u>>2]|0))break;do if((((t[u>>2]|0)!=0?(t[(t[u>>2]|0)+4>>2]|0)==1:0)?(t[(t[u>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[u>>2]|0)+8>>2]|0,202496)|0)!=0:0){if((Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0){l=22;break}hq(t[n>>2]|0,t[a>>2]|0,t[u>>2]|0);t[o>>2]=(t[o>>2]|0)+1}else l=22;while(0);if((l|0)==22){l=0;fq(t[n>>2]|0,t[u>>2]|0,1759,202504,t[(t[u>>2]|0)+8>>2]|0,0)}t[u>>2]=t[(t[u>>2]|0)+24>>2];while(1){if(!(t[u>>2]|0))continue e;if((t[(t[u>>2]|0)+4>>2]|0)==1?(t[(t[u>>2]|0)+36>>2]|0)!=0:0){if(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)continue e;if(Xl(t[(t[(t[u>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)continue e}t[u>>2]=t[(t[u>>2]|0)+24>>2]}}if(t[o>>2]|0){s=r;return}fq(t[n>>2]|0,t[f>>2]|0,1759,202544,0,0);s=r;return}function oq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+16|0;f=n+8|0;u=n+4|0;a=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if(t[f>>2]|0){r=(t[f>>2]|0)+12|0;t[r>>2]=(t[r>>2]|0)+1;t[(t[f>>2]|0)+16>>2]=1818}dp(17,2,t[a>>2]|0,0,t[u>>2]|0);s=n;return}function cq(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var a=0,o=0,c=0,b=0,k=0,h=0,w=0,d=0,v=0;a=s;s=s+32|0;o=a+24|0;c=a+20|0;b=a+16|0;k=a+12|0;h=a+8|0;w=a+4|0;d=a;t[o>>2]=e;t[c>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[d>>2]=0;t[t[(t[o>>2]|0)+24>>2]>>2]=t[b>>2];t[(t[(t[o>>2]|0)+24>>2]|0)+4>>2]=t[k>>2];t[w>>2]=_t(t[(t[c>>2]|0)+16>>2]|0,t[(t[o>>2]|0)+24>>2]|0)|0;if(!(t[w>>2]|0))t[d>>2]=1;else{e:do switch(t[t[w>>2]>>2]|0){case 4:{if((t[(t[w>>2]|0)+24>>2]|0)!=0?(u[t[(t[w>>2]|0)+24>>2]>>0]|0|0)!=0:0)break e;t[d>>2]=1;break}case 3:{if((hn(+l[(t[w>>2]|0)+16>>3])|0)==0?!(+l[(t[w>>2]|0)+16>>3]==0):0)break e;t[d>>2]=1;break}case 8:case 7:case 6:case 5:case 0:{t[d>>2]=1;break}case 2:{t[d>>2]=((t[(t[w>>2]|0)+8>>2]|0)!=0^1)&1;break}case 1:case 9:{if((t[(t[w>>2]|0)+4>>2]|0)!=0?(t[t[(t[w>>2]|0)+4>>2]>>2]|0)!=0:0)break e;t[d>>2]=1;break}default:{}}while(0);_n(t[w>>2]|0)}if((t[d>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==1:0){w=(t[o>>2]|0)+12|0;t[w>>2]=(t[w>>2]|0)+1}else v=19;if(((v|0)==19?(t[d>>2]|0)==0:0)?(t[(t[c>>2]|0)+4>>2]|0)==2:0){v=(t[o>>2]|0)+12|0;t[v>>2]=(t[v>>2]|0)+1}wq(t[o>>2]|0,t[c>>2]|0,t[k>>2]|0,t[h>>2]|0,((t[d>>2]|0)!=0^1)&1);s=a;return((t[d>>2]|0)!=0^1)&1|0}function lq(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(((t[(t[n>>2]|0)+12>>2]|0)!=0?(t[(t[(t[n>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(t[n>>2]=t[(t[n>>2]|0)+12>>2],(t[(t[n>>2]|0)+4>>2]|0)!=14):0){t[r>>2]=t[n>>2];f=t[r>>2]|0;s=i;return f|0}while(1){if(!(t[(t[n>>2]|0)+24>>2]|0))break;t[n>>2]=t[(t[n>>2]|0)+24>>2];if((t[(t[n>>2]|0)+4>>2]|0)==17)continue;if((t[(t[n>>2]|0)+4>>2]|0)!=14){u=8;break}}if((u|0)==8){t[r>>2]=t[n>>2];f=t[r>>2]|0;s=i;return f|0}while(1){t[n>>2]=t[(t[n>>2]|0)+20>>2];if(!(t[n>>2]|0)){u=15;break}if((t[(t[n>>2]|0)+4>>2]|0)==9){u=11;break}a=t[n>>2]|0;if(t[(t[n>>2]|0)+24>>2]|0){u=13;break}if(!a){u=15;break}}if((u|0)==11){t[r>>2]=0;f=t[r>>2]|0;s=i;return f|0}else if((u|0)==13){t[n>>2]=t[a+24>>2];t[r>>2]=t[n>>2];f=t[r>>2]|0;s=i;return f|0}else if((u|0)==15){t[r>>2]=t[n>>2];f=t[r>>2]|0;s=i;return f|0}return 0}function sq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+1024|0;n=r;f=r+12|0;u=r+8|0;a=r+16|0;t[f>>2]=e;t[u>>2]=i;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){s=r;return}if(t[(t[f>>2]|0)+4>>2]&1){s=r;return}if(t[(t[f>>2]|0)+4>>2]&8){s=r;return}if(t[(t[f>>2]|0)+4>>2]&4){i=t[33976]|0;e=t[33980]|0;t[n>>2]=202344;t[n+4>>2]=1457;yAi[i&511](e,202312,n);s=r;return}if(!(t[(t[u>>2]|0)+8>>2]|0)){s=r;return}t[n>>2]=t[(t[u>>2]|0)+8>>2];SY(a,999,202368,n)|0;dq(t[f>>2]|0,0,a);s=r;return}function bq(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[r>>2]=e;while(1){if(!(t[r>>2]|0))break;t[n>>2]=t[t[r>>2]>>2];if(t[(t[r>>2]|0)+12>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+12>>2]|0);if(t[(t[r>>2]|0)+16>>2]|0)mn(t[(t[r>>2]|0)+16>>2]|0);if(t[(t[r>>2]|0)+20>>2]|0)pAi[t[135736>>2]&511](t[(t[r>>2]|0)+20>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);t[r>>2]=t[n>>2]}s=i;return}function kq(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0;f=s;s=s+32|0;u=f+24|0;a=f+20|0;o=f+16|0;c=f+12|0;l=f+8|0;b=f+4|0;k=f;t[a>>2]=e;t[o>>2]=i;t[c>>2]=r;t[l>>2]=n;if((t[a>>2]|0)==0|(t[o>>2]|0)==0|(t[c>>2]|0)==0|(t[l>>2]|0)==0){t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}t[b>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[b>>2]|0)){nq(t[a>>2]|0,202976,t[c>>2]|0);t[u>>2]=0;h=t[u>>2]|0;s=f;return h|0}c=t[b>>2]|0;t[c+0>>2]=0;t[c+4>>2]=0;t[c+8>>2]=0;t[(t[b>>2]|0)+8>>2]=t[l>>2];t[t[b>>2]>>2]=0;if(!(t[(t[o>>2]|0)+36>>2]|0))t[(t[o>>2]|0)+36>>2]=t[b>>2];else{t[k>>2]=t[(t[o>>2]|0)+36>>2];while(1){if(!(t[t[k>>2]>>2]|0))break;t[k>>2]=t[t[k>>2]>>2]}t[t[k>>2]>>2]=t[b>>2]}t[u>>2]=t[b>>2];h=t[u>>2]|0;s=f;return h|0}function hq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+48|0;f=n+36|0;a=n+32|0;o=n+28|0;c=n+24|0;l=n+20|0;b=n+16|0;k=n+12|0;h=n+8|0;w=n+4|0;d=n;t[f>>2]=e;t[a>>2]=i;t[o>>2]=r;t[l>>2]=0;if((t[f>>2]|0)==0|(t[o>>2]|0)==0){s=n;return}t[k>>2]=vF(t[o>>2]|0,202576)|0;if(!(t[k>>2]|0)){fq(t[f>>2]|0,t[o>>2]|0,1759,202584,0,0);s=n;return}r=t[f>>2]|0;if(!(u[t[k>>2]>>0]|0)){fq(r,t[o>>2]|0,1759,202616,0,0);pAi[t[135736>>2]&511](t[k>>2]|0);s=n;return}t[w>>2]=vq(r,t[(t[f>>2]|0)+40>>2]|0,t[a>>2]|0,t[o>>2]|0,t[k>>2]|0,0)|0;if(!(t[w>>2]|0)){pAi[t[135736>>2]&511](t[k>>2]|0);s=n;return}t[c>>2]=t[(t[o>>2]|0)+12>>2];while(1){if(!(t[c>>2]|0))break;if((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+36>>2]|0)!=0:0){if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)break;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)break}t[c>>2]=t[(t[c>>2]|0)+24>>2]}e:while(1){if(!(t[c>>2]|0))break;do if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==1:0)?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,202656)|0)!=0:0){if((Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0){v=28;break}t[l>>2]=(t[l>>2]|0)+1;t[b>>2]=vF(t[c>>2]|0,202664)|0;if(!(t[b>>2]|0)){fq(t[f>>2]|0,t[c>>2]|0,1759,202672,0,0);break}if(!(u[t[b>>2]>>0]|0)){fq(t[f>>2]|0,t[c>>2]|0,1759,202704,0,0);pAi[t[135736>>2]&511](t[b>>2]|0);break}t[h>>2]=sF(t[c>>2]|0)|0;t[d>>2]=mq(t[f>>2]|0,1,t[w>>2]|0,t[c>>2]|0,t[b>>2]|0,t[h>>2]|0)|0;if(!(t[d>>2]|0))pAi[t[135736>>2]&511](t[b>>2]|0)}else v=28;while(0);i:do if((v|0)==28){v=0;do if((((t[c>>2]|0)!=0?(t[(t[c>>2]|0)+4>>2]|0)==1:0)?(t[(t[c>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[c>>2]|0)+8>>2]|0,202744)|0)!=0:0){if((Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0)break;t[l>>2]=(t[l>>2]|0)+1;t[b>>2]=vF(t[c>>2]|0,202664)|0;if(!(t[b>>2]|0)){fq(t[f>>2]|0,t[c>>2]|0,1759,202672,0,0);break i}if(!(u[t[b>>2]>>0]|0)){fq(t[f>>2]|0,t[c>>2]|0,1759,202704,0,0);pAi[t[135736>>2]&511](t[b>>2]|0);break i}t[h>>2]=sF(t[c>>2]|0)|0;t[d>>2]=mq(t[f>>2]|0,2,t[w>>2]|0,t[c>>2]|0,t[b>>2]|0,t[h>>2]|0)|0;if(t[d>>2]|0)break i;pAi[t[135736>>2]&511](t[b>>2]|0);break i}while(0);fq(t[f>>2]|0,t[c>>2]|0,1759,202752,t[(t[c>>2]|0)+8>>2]|0,0)}while(0);t[c>>2]=t[(t[c>>2]|0)+24>>2];while(1){if(!(t[c>>2]|0))continue e;if((t[(t[c>>2]|0)+4>>2]|0)==1?(t[(t[c>>2]|0)+36>>2]|0)!=0:0){if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)continue e;if(Xl(t[(t[(t[c>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)continue e}t[c>>2]=t[(t[c>>2]|0)+24>>2]}}if(t[l>>2]|0){s=n;return}fq(t[f>>2]|0,t[o>>2]|0,1759,202808,0,0);s=n;return}function wq(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+1056|0;a=u;o=u+52|0;c=u+48|0;l=u+44|0;b=u+40|0;k=u+36|0;h=u+32|0;w=u+56|0;d=u+28|0;v=u+24|0;m=u+20|0;_=u+16|0;p=u+12|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=n;t[k>>2]=f;if((t[o>>2]|0)==0|(t[l>>2]|0)==0|(t[c>>2]|0)==0){s=u;return}if(((t[(t[o>>2]|0)+4>>2]&1|0)!=0?(t[(t[o>>2]|0)+4>>2]&4|0)==0:0)?(t[(t[c>>2]|0)+4>>2]|0)==2:0){s=u;return}if(t[(t[o>>2]|0)+4>>2]&4){f=t[33976]|0;n=t[33980]|0;t[a>>2]=202344;t[a+4>>2]=1380;yAi[f&511](n,202312,a);s=u;return}t[v>>2]=0;if((t[(t[c>>2]|0)+4>>2]|0)==2&(((t[k>>2]|0)!=0^1)&1)){s=u;return}if((t[(t[c>>2]|0)+4>>2]|0)==1&t[k>>2]){s=u;return}t[d>>2]=Qy(t[l>>2]|0)|0;t[h>>2]=$y(t[l>>2]|0)|0;if(!(t[h>>2]|0))t[h>>2]=t[(t[l>>2]|0)+8>>2];if(t[(t[c>>2]|0)+8>>2]|0)t[v>>2]=_q(t[o>>2]|0,t[(t[c>>2]|0)+8>>2]|0,t[l>>2]|0)|0;do if(!(t[v>>2]|0))if((t[(t[c>>2]|0)+4>>2]|0)==1){t[v>>2]=Yl(202392)|0;break}else{t[v>>2]=Yl(202416)|0;break}while(0);k=t[d>>2]|0;n=t[v>>2]|0;t[a>>2]=t[h>>2];t[a+4>>2]=k;t[a+8>>2]=n;SY(w,999,202440,a)|0;if(t[(t[o>>2]|0)+4>>2]&8){t[m>>2]=0;t[_>>2]=0;t[p>>2]=0;if(t[o>>2]|0){n=t[o>>2]|0;if(t[(t[o>>2]|0)+60>>2]|0)t[m>>2]=t[n+60>>2];else t[_>>2]=t[n+52>>2];t[p>>2]=t[(t[o>>2]|0)+48>>2]}n=t[m>>2]|0;m=t[_>>2]|0;_=t[p>>2]|0;p=t[l>>2]|0;k=(t[(t[c>>2]|0)+4>>2]|0)==1?4e3:4001;c=t[d>>2]|0;if(!(t[b>>2]|0))E=0;else E=t[(t[b>>2]|0)+8>>2]|0;b=t[h>>2]|0;d=t[v>>2]|0;t[a>>2]=w;cp(n,m,_,0,p,28,k,2,0,c,E,b,d,0,0,202384,a)}else dq(t[o>>2]|0,t[l>>2]|0,w);pAi[t[135736>>2]&511](t[v>>2]|0);if(!(t[h>>2]|0)){s=u;return}if((t[h>>2]|0)==(t[(t[l>>2]|0)+8>>2]|0)){s=u;return}pAi[t[135736>>2]&511](t[h>>2]|0);s=u;return}function dq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0;n=s;s=s+16|0;f=n;u=n+4|0;t[n+12>>2]=e;t[n+8>>2]=i;t[u>>2]=r;r=t[v>>2]|0;t[f>>2]=t[u>>2];xe(r|0,202384,f|0)|0;s=n;return}function vq(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;a=s;s=s+48|0;o=a+40|0;c=a+36|0;l=a+32|0;b=a+28|0;k=a+24|0;h=a+20|0;w=a+16|0;d=a+12|0;v=a+8|0;m=a+4|0;_=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if((t[c>>2]|0)==0|(t[l>>2]|0)==0|(t[k>>2]|0)==0|(t[h>>2]|0)==0){t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}t[v>>2]=Fj(t[h>>2]|0,t[(t[c>>2]|0)+24>>2]|0,1,t[(t[c>>2]|0)+52>>2]|0)|0;if(!(t[v>>2]|0))fq(t[c>>2]|0,t[k>>2]|0,1759,202912,t[h>>2]|0,0);t[d>>2]=gAi[t[135744>>2]&511](28)|0;if(!(t[d>>2]|0)){nq(t[c>>2]|0,202952,t[k>>2]|0);t[o>>2]=0;p=t[o>>2]|0;s=a;return p|0}c=t[d>>2]|0;t[c+0>>2]=0;t[c+4>>2]=0;t[c+8>>2]=0;t[c+12>>2]=0;t[c+16>>2]=0;t[c+20>>2]=0;t[c+24>>2]=0;t[(t[d>>2]|0)+8>>2]=t[k>>2];t[(t[d>>2]|0)+12>>2]=t[h>>2];t[(t[d>>2]|0)+20>>2]=t[v>>2];t[(t[d>>2]|0)+24>>2]=t[w>>2];t[t[d>>2]>>2]=0;if(!(t[(t[l>>2]|0)+40>>2]|0))t[(t[l>>2]|0)+40>>2]=t[d>>2];else{t[m>>2]=t[(t[l>>2]|0)+40>>2];while(1){if(!(t[t[m>>2]>>2]|0))break;t[m>>2]=t[t[m>>2]>>2]}t[t[m>>2]>>2]=t[d>>2]}t[(t[d>>2]|0)+4>>2]=0;if(!(t[(t[b>>2]|0)+4>>2]|0))t[(t[b>>2]|0)+4>>2]=t[d>>2];else{t[_>>2]=t[(t[b>>2]|0)+4>>2];while(1){if(!(t[(t[_>>2]|0)+4>>2]|0))break;t[_>>2]=t[(t[_>>2]|0)+4>>2]}t[(t[_>>2]|0)+4>>2]=t[d>>2]}t[o>>2]=t[d>>2];p=t[o>>2]|0;s=a;return p|0}function mq(e,i,r,n,f,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u=u|0;var a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;a=s;s=s+48|0;o=a+36|0;c=a+32|0;l=a+28|0;b=a+24|0;k=a+20|0;h=a+16|0;w=a+12|0;d=a+8|0;v=a+4|0;m=a;t[c>>2]=e;t[l>>2]=i;t[b>>2]=r;t[k>>2]=n;t[h>>2]=f;t[w>>2]=u;if((t[c>>2]|0)==0|(t[b>>2]|0)==0|(t[k>>2]|0)==0|(t[h>>2]|0)==0){t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}t[v>>2]=mt(t[(t[c>>2]|0)+36>>2]|0,t[h>>2]|0)|0;if(!(t[v>>2]|0)){fq(t[c>>2]|0,t[k>>2]|0,1759,202848,t[h>>2]|0,0);t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}t[d>>2]=gAi[t[135744>>2]&511](24)|0;if(!(t[d>>2]|0)){nq(t[c>>2]|0,202888,t[k>>2]|0);t[o>>2]=0;_=t[o>>2]|0;s=a;return _|0}c=t[d>>2]|0;t[c+0>>2]=0;t[c+4>>2]=0;t[c+8>>2]=0;t[c+12>>2]=0;t[c+16>>2]=0;t[c+20>>2]=0;t[(t[d>>2]|0)+4>>2]=t[l>>2];t[(t[d>>2]|0)+8>>2]=t[k>>2];t[(t[d>>2]|0)+12>>2]=t[h>>2];t[(t[d>>2]|0)+16>>2]=t[v>>2];t[(t[d>>2]|0)+20>>2]=t[w>>2];t[t[d>>2]>>2]=0;if(!(t[(t[b>>2]|0)+16>>2]|0))t[(t[b>>2]|0)+16>>2]=t[d>>2];else{t[m>>2]=t[(t[b>>2]|0)+16>>2];while(1){if(!(t[t[m>>2]>>2]|0))break;t[m>>2]=t[t[m>>2]>>2]}t[t[m>>2]>>2]=t[d>>2]}t[o>>2]=t[d>>2];_=t[o>>2]|0;s=a;return _|0}function _q(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0;f=s;s=s+48|0;a=f+32|0;o=f+28|0;c=f+24|0;l=f+20|0;b=f+16|0;k=f+12|0;h=f+8|0;w=f+4|0;d=f;v=f+36|0;t[o>>2]=e;t[c>>2]=i;t[l>>2]=r;t[b>>2]=0;if((t[c>>2]|0)==0|(t[l>>2]|0)==0){t[a>>2]=t[b>>2];m=t[a>>2]|0;s=f;return m|0}t[k>>2]=t[(t[c>>2]|0)+12>>2];e:while(1){if(!(t[k>>2]|0))break;i:do if((t[(t[k>>2]|0)+4>>2]|0)!=3?(t[(t[k>>2]|0)+4>>2]|0)!=4:0){do if((((t[k>>2]|0)!=0?(t[(t[k>>2]|0)+4>>2]|0)==1:0)?(t[(t[k>>2]|0)+36>>2]|0)!=0:0)?(Xl(t[(t[k>>2]|0)+8>>2]|0,202464)|0)!=0:0){if((Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[50504]|0)|0)==0?(Xl(t[(t[(t[k>>2]|0)+36>>2]|0)+8>>2]|0,t[50506]|0)|0)==0:0)break;t[w>>2]=vF(t[k>>2]|0,202472)|0;t[h>>2]=t[l>>2];if(t[w>>2]|0){t[h>>2]=pq(t[o>>2]|0,t[l>>2]|0,t[w>>2]|0)|0;if(!(t[h>>2]|0))t[h>>2]=t[l>>2];pAi[t[135736>>2]&511](t[w>>2]|0)}if((t[(t[h>>2]|0)+36>>2]|0)!=0?(t[(t[(t[h>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){t[b>>2]=us(t[b>>2]|0,t[(t[(t[h>>2]|0)+36>>2]|0)+12>>2]|0)|0;t[b>>2]=us(t[b>>2]|0,202480)|0;t[b>>2]=us(t[b>>2]|0,t[(t[h>>2]|0)+8>>2]|0)|0;break i}t[b>>2]=us(t[b>>2]|0,t[(t[h>>2]|0)+8>>2]|0)|0;break i}while(0);t[k>>2]=t[(t[k>>2]|0)+24>>2];continue e}else _=7;while(0);if((_|0)==7){_=0;t[b>>2]=us(t[b>>2]|0,t[(t[k>>2]|0)+40>>2]|0)|0}do if((t[b>>2]|0)!=0?(t[d>>2]=rs(t[b>>2]|0)|0,(t[d>>2]|0)>0):0){n[v>>0]=n[(t[b>>2]|0)+((t[d>>2]|0)-1)>>0]|0;if((((u[v>>0]|0|0)!=32?(u[v>>0]|0|0)!=10:0)?(u[v>>0]|0|0)!=13:0)?(u[v>>0]|0|0)!=9:0)break;while(1){if((((u[v>>0]|0|0)!=32?(u[v>>0]|0|0)!=10:0)?(u[v>>0]|0|0)!=13:0)?(u[v>>0]|0|0)!=9:0)break;t[d>>2]=(t[d>>2]|0)+-1;if(!(t[d>>2]|0))break;n[v>>0]=n[(t[b>>2]|0)+((t[d>>2]|0)-1)>>0]|0}n[(t[b>>2]|0)+(t[d>>2]|0)>>0]=32;n[(t[b>>2]|0)+((t[d>>2]|0)+1)>>0]=0}while(0);t[k>>2]=t[(t[k>>2]|0)+24>>2]}t[a>>2]=t[b>>2];m=t[a>>2]|0;s=f;return m|0}function pq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0;n=s;s=s+32|0;f=n+20|0;u=n+16|0;a=n+12|0;o=n+8|0;c=n+4|0;l=n;t[u>>2]=e;t[a>>2]=i;t[o>>2]=r;t[c>>2]=0;if((t[u>>2]|0)==0|(t[a>>2]|0)==0|(t[o>>2]|0)==0){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}t[t[(t[u>>2]|0)+24>>2]>>2]=t[(t[a>>2]|0)+32>>2];t[(t[(t[u>>2]|0)+24>>2]|0)+4>>2]=t[a>>2];t[l>>2]=Et(t[o>>2]|0,t[(t[u>>2]|0)+24>>2]|0)|0;if(!(t[l>>2]|0)){t[f>>2]=0;b=t[f>>2]|0;s=n;return b|0}if(((t[t[l>>2]>>2]|0)==1?(t[(t[l>>2]|0)+4>>2]|0)!=0:0)?(t[t[(t[l>>2]|0)+4>>2]>>2]|0)>0:0)t[c>>2]=t[t[(t[(t[l>>2]|0)+4>>2]|0)+8>>2]>>2];_n(t[l>>2]|0);t[f>>2]=t[c>>2];b=t[f>>2]|0;s=n;return b|0}function Eq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[u>>2]=e;t[a>>2]=i;i=gAi[t[135744>>2]&511](12)|0;t[o>>2]=i;if(!i){yAi[t[135904>>2]&511](t[33980]|0,203144,n);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}i=t[o>>2]|0;t[i+0>>2]=0;t[i+4>>2]=0;t[i+8>>2]=0;i=gAi[t[135744>>2]&511](12)|0;t[t[o>>2]>>2]=i;if(!i){yAi[t[135904>>2]&511](t[33980]|0,203184,n);pAi[t[135736>>2]&511](t[o>>2]|0);t[f>>2]=0;c=t[f>>2]|0;s=r;return c|0}t[t[t[o>>2]>>2]>>2]=t[t[o>>2]>>2];t[(t[t[o>>2]>>2]|0)+4>>2]=t[t[o>>2]>>2];t[(t[t[o>>2]>>2]|0)+8>>2]=0;if(t[u>>2]|0)t[(t[o>>2]|0)+4>>2]=t[u>>2];if(t[a>>2]|0)t[(t[o>>2]|0)+8>>2]=t[a>>2];else t[(t[o>>2]|0)+8>>2]=390;t[f>>2]=t[o>>2];c=t[f>>2]|0;s=r;return c|0}function Sq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){t[a>>2]=Nq(t[f>>2]|0,t[u>>2]|0)|0;if(t[a>>2]|0){t[n>>2]=t[(t[a>>2]|0)+8>>2];break}else{t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function gq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=Tq(t[f>>2]|0,t[u>>2]|0)|0;t[o>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[o>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,203224,r);t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}else{t[(t[o>>2]|0)+8>>2]=t[u>>2];t[a>>2]=t[(t[a>>2]|0)+4>>2];t[t[o>>2]>>2]=t[t[a>>2]>>2];t[(t[t[a>>2]>>2]|0)+4>>2]=t[o>>2];t[t[a>>2]>>2]=t[o>>2];t[(t[o>>2]|0)+4>>2]=t[a>>2];t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}return 0}function yq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0;r=s;s=s+32|0;n=r+20|0;f=r+16|0;u=r+12|0;a=r+8|0;o=r+4|0;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}t[a>>2]=Lq(t[f>>2]|0,t[u>>2]|0)|0;t[o>>2]=gAi[t[135744>>2]&511](12)|0;if(!(t[o>>2]|0)){yAi[t[135904>>2]&511](t[33980]|0,203224,r);t[n>>2]=1;c=t[n>>2]|0;s=r;return c|0}else{t[(t[o>>2]|0)+8>>2]=t[u>>2];t[t[o>>2]>>2]=t[t[a>>2]>>2];t[(t[t[a>>2]>>2]|0)+4>>2]=t[o>>2];t[t[a>>2]>>2]=t[o>>2];t[(t[o>>2]|0)+4>>2]=t[a>>2];t[n>>2]=0;c=t[n>>2]|0;s=r;return c|0}return 0}function Fq(e){e=e|0;var i=0,r=0;i=s;s=s+16|0;r=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}Oq(t[r>>2]|0);pAi[t[135736>>2]&511](t[t[r>>2]>>2]|0);pAi[t[135736>>2]&511](t[r>>2]|0);s=i;return}function Oq(e){e=e|0;var i=0,r=0,n=0,f=0;i=s;s=s+16|0;r=i+8|0;n=i+4|0;f=i;t[r>>2]=e;if(!(t[r>>2]|0)){s=i;return}t[n>>2]=t[t[t[r>>2]>>2]>>2];while(1){if((t[n>>2]|0)==(t[t[r>>2]>>2]|0))break;t[f>>2]=t[t[n>>2]>>2];Dq(t[r>>2]|0,t[n>>2]|0);t[n>>2]=t[f>>2]}s=i;return}function Aq(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i+4|0;n=i;t[n>>2]=e;if(!(t[n>>2]|0))t[r>>2]=0;else t[r>>2]=t[(t[n>>2]|0)+8>>2];s=i;return t[r>>2]|0}function Mq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;s=s+16|0;f=n+12|0;u=n+8|0;a=n+4|0;o=n;t[f>>2]=e;t[u>>2]=i;t[a>>2]=r;if((t[f>>2]|0)==0|(t[u>>2]|0)==0){s=n;return}t[o>>2]=t[t[t[f>>2]>>2]>>2];while(1){if((t[o>>2]|0)==(t[t[f>>2]>>2]|0)){c=6;break}if(!(MAi[t[u>>2]&511](t[(t[o>>2]|0)+8>>2]|0,t[a>>2]|0)|0)){c=6;break}t[o>>2]=t[t[o>>2]>>2]}if((c|0)==6){s=n;return}}function Rq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;s=s+16|0;n=r+8|0;f=r+4|0;u=r;t[f>>2]=e;t[u>>2]=i;do if((t[f>>2]|0)>>>0>=(t[u>>2]|0)>>>0)if((t[f>>2]|0)==(t[u>>2]|0)){t[n>>2]=0;break}else{t[n>>2]=1;break}else t[n>>2]=-1;while(0);s=r;return t[n>>2]|0}function Nq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;do if(t[f>>2]|0){t[a>>2]=Tq(t[f>>2]|0,t[u>>2]|0)|0;if((t[a>>2]|0)==(t[t[f>>2]>>2]|0)){t[n>>2]=0;break}if(!(MAi[t[(t[f>>2]|0)+8>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0)){t[n>>2]=t[a>>2];break}else{t[n>>2]=0;break}}else t[n>>2]=0;while(0);s=r;return t[n>>2]|0}function Tq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=t[t[t[f>>2]>>2]>>2];while(1){if((t[a>>2]|0)==(t[t[f>>2]>>2]|0))break;if((MAi[t[(t[f>>2]|0)+8>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0)>=0)break;t[a>>2]=t[t[a>>2]>>2]}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Lq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;s=s+16|0;n=r+12|0;f=r+8|0;u=r+4|0;a=r;t[f>>2]=e;t[u>>2]=i;if(!(t[f>>2]|0)){t[n>>2]=0;o=t[n>>2]|0;s=r;return o|0}t[a>>2]=t[(t[t[f>>2]>>2]|0)+4>>2];while(1){if((t[a>>2]|0)==(t[t[f>>2]>>2]|0))break;if((MAi[t[(t[f>>2]|0)+8>>2]&511](t[(t[a>>2]|0)+8>>2]|0,t[u>>2]|0)|0)<=0)break;t[a>>2]=t[(t[a>>2]|0)+4>>2]}t[n>>2]=t[a>>2];o=t[n>>2]|0;s=r;return o|0}function Dq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0;r=s;s=s+16|0;n=r+4|0;f=r;t[n>>2]=e;t[f>>2]=i;t[t[(t[f>>2]|0)+4>>2]>>2]=t[t[f>>2]>>2];t[(t[t[f>>2]>>2]|0)+4>>2]=t[(t[f>>2]|0)+4>>2];if(!(t[(t[n>>2]|0)+4>>2]|0)){u=t[33934]|0;a=t[f>>2]|0;pAi[u&511](a);s=r;return}pAi[t[(t[n>>2]|0)+4>>2]&511](t[f>>2]|0);u=t[33934]|0;a=t[f>>2]|0;pAi[u&511](a);s=r;return}function Cq(e){e=e|0;return(e+-97|0)>>>0<26|0}function Pq(e){e=e|0;var i=0,r=0;i=s;r=(Cq(e)|0)==0;s=i;return(r?e:e&95)|0}function Bq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0;r=s;n=Wq(e)|0;if(((n|0)!=-1?(e=Wq(i)|0,(e|0)!=-1):0)?(u[203264+n>>0]|0)<=207:0){f=e<<16|n;s=r;return f|0}t[(ii()|0)>>2]=22;f=-1;s=r;return f|0}function Iq(e){e=e|0;return 0}function Hq(e,i,r,o,c){e=e|0;i=i|0;r=r|0;o=o|0;c=c|0;var l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,te=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0,ke=0,he=0,we=0,de=0,ve=0,me=0,_e=0,pe=0,Ee=0,Se=0,ge=0,ye=0,Fe=0,Oe=0,Ae=0,Me=0,Re=0,Ne=0,Te=0,Le=0,De=0,Ce=0;l=s;s=s+32|0;b=l;k=l+16|0;h=l+12|0;w=l+8|0;d=l+20|0;v=e;e=v&65535;m=v>>>16;v=m+1|0;_=e+1|0;p=b;t[p>>2]=0;t[p+4>>2]=0;p=n[203264+m>>0]|0;E=n[203264+e>>0]|0;if(!i){S=0;s=l;return S|0}g=t[i>>2]|0;if(!g){S=0;s=l;return S|0}y=t[r>>2]|0;if(!y){S=0;s=l;return S|0}F=p&255;O=F+128|0;A=m+2|0;m=F&3;M=m^1;R=m^2;N=m^3;T=F&1;L=T^1;D=(F&254|0)==196;C=T|2;P=L|2;B=p<<24>>24==-38;I=p<<24>>24==-40;H=E&255;x=H+-192|0;U=x>>>0>8;z=e;j=281312+x|0;x=H+128|0;V=128-H|0;q=E<<24>>24==-128;E=e+2|0;e=(p&-2)<<24>>24==-60;p=H&1;Y=p^1;G=p|2;W=Y|2;K=H&3;X=K^1;Z=K^2;J=K^3;Q=(F+-192|0)>>>0<7;$=g;g=y;y=0;e:while(1){ee=n[$>>0]|0;ie=ee&255;i:do if(ee<<24>>24<0|Q){do switch(F|0){case 208:{if(g>>>0<2){re=22;break e}ne=u[$+1>>0]|0;if(ee<<24>>24!=-114){fe=ie+-161|0;te=ne+-161|0;if(fe>>>0>83|te>>>0>93){ue=84;ae=114;break e}oe=f[207296+(fe*188|0)+(te<<1)>>1]|0;if(!(oe<<16>>16)){ue=84;ae=114;break e}else{ce=oe&65535;le=2;ae=89;break i}}else{if((ne+-161|0)>>>0>62){ue=84;ae=114;break e}ce=ne+65216|0;le=2;ae=89;break i}break}case 198:{if(g>>>0<4){re=22;break e}se=t[$>>2]|0;ae=14;break}case 200:{ne=xq(k,$,g,b)|0;if(!ne)be=1;else if((ne|0)==-1){ue=84;ae=114;break e}else if((ne|0)==-2){re=22;break e}else be=ne;ce=t[k>>2]|0;le=be;ae=89;break i;break}case 224:{if(g>>>0<2){re=22;break e}ne=u[$+1>>0]|0;oe=ne+-64|0;if(oe>>>0>190|(ne+-127|0)>>>0<34){ue=84;ae=114;break e}te=oe>>>0>62?ne+-98|0:oe;oe=ie+-161|0;if(oe>>>0<=88){ne=a[281352+(oe*314|0)+(te<<1)>>1]|0;if((oe|0)==39?(te|0)==66|(te|0)==58|(te|0)==60:0)ke=131072;else ke=0;oe=ke|ne;if(!oe){ue=84;ae=114;break e}else{ce=oe;le=2;ae=89;break i}}oe=ie+-135|0;if(oe>>>0>119){ue=84;ae=114;break e}ne=te+(((ee&255)<161?oe:ie+-224|0)*157|0)|0;oe=a[270968+(ne<<1)>>1]|0;te=oe|(((a[270968+((ne>>>4)+4867<<1)>>1]|0)>>>(ne&15)|0)%2|0)<<17;if((te&-65792|0)!=56320)if(!te){ue=84;ae=114;break e}else{ce=te;le=2;ae=89;break i}if(U)he=2;else he=n[j>>0]|0;if(he>>>0>(t[c>>2]|0)>>>0){ue=7;ae=114;break e}t[h>>2]=281328+(oe&255);t[w>>2]=4;we=2;de=(Hq(z,h,w,o,c)|0)+y|0;break i;break}case 218:{if((ee&255)<161){ue=84;ae=114;break e}break}case 216:case 217:break;case 193:case 194:case 197:case 196:{if(g>>>0<2){re=22;break e}oe=u[$+T>>0]<<8;te=oe|u[$+L>>0];ne=oe&64512;if((ne|0)==56320){ue=84;ae=114;break e}else if((ne|0)!=55296){ce=te;le=2;ae=89;break i}if(D){ue=84;ae=114;break e}if(g>>>0<4){re=22;break e}ne=(u[$+C>>0]<<8|u[$+P>>0])+-56320|0;if(ne>>>0>1023){ue=84;ae=114;break e}ce=(te<<10)+-56557568+ne|0;le=4;ae=89;break i;break}case 195:case 192:{if(g>>>0<4){re=22;break e}se=u[$+M>>0]<<16|u[$+m>>0]<<24|u[$+R>>0]<<8|u[$+N>>0];ae=14;break}case 232:{if(g>>>0<2){re=22;break e}ne=n[$+1>>0]|0;te=ne&255;oe=ie+-161|0;fe=te+-161|0;if(!(oe>>>0>92|fe>>>0>93)){ve=f[309304+(oe*188|0)+(fe<<1)>>1]|0;if(!(ve<<16>>16)){ue=84;ae=114;break e}else{ce=ve&65535;le=2;ae=89;break i}}ve=ie+-129|0;if(ve>>>0>92){ue=84;ae=114;break e}if(ve>>>0>68&(ne&255)>82){ue=84;ae=114;break e}ne=te+-65|0;do if(ne>>>0<26)me=ne;else{if((te+-97|0)>>>0<26){me=te+-71|0;break}if((te+-129|0)>>>0>=126){ue=84;ae=114;break e}me=te+-77|0}while(0);if(ve>>>0<32)_e=ve*178|0;else _e=(oe*84|0)+5696|0;te=me+44032+_e|0;if(te>>>0<44032){ce=te;le=2;ae=89;break i}else{pe=te;Ee=44032}while(1){te=pe-Ee|0;ne=0;fe=0;while(1){Se=0;ge=fe;do{ge=(((a[309304+(ne*188|0)+(Se<<1)>>1]|0)-Ee|0)>>>0<=te>>>0&1)+ge|0;Se=Se+1|0}while((Se|0)!=94);ne=ne+1|0;if((ne|0)==93)break;else fe=ge}Ee=pe+1|0;fe=ge+pe|0;if(fe>>>0<Ee>>>0){ce=fe;le=2;ae=89;break i}else pe=fe}break}case 209:{if((ie+-161|0)>>>0<63){ce=ie+65216|0;le=1;ae=89;break i}if(g>>>0<2){re=22;break e}oe=n[$+1>>0]|0;ve=oe&255;fe=ie+-129|0;if(fe>>>0<31)ye=fe;else{if((ie&240|0)!=224){ue=84;ae=114;break e}ye=ie+-193|0}fe=ye<<1;ne=ve+-64|0;if(ne>>>0<95){if(oe<<24>>24==127){ue=84;ae=114;break e}Fe=fe;Oe=ne+(oe<<24>>24>>7<<24>>24)|0}else{oe=ve+-159|0;ne=oe>>>0<94;Fe=fe|ne&1;Oe=ne?oe:ve}ve=f[207296+(Fe*188|0)+(Oe<<1)>>1]|0;if(!(ve<<16>>16)){ue=84;ae=114;break e}else{ce=ve&65535;le=2;ae=89;break i}break}case 199:{ue=84;ae=114;break e;break}default:{if(ie>>>0<O>>>0){ce=ie;le=1;ae=89;break i}ve=ie-O|0;oe=(ve*5|0)>>>2;ne=ve<<1&6;ve=u[203264+(A+oe)>>0]<<8-ne&1023|(u[203264+(oe+v)>>0]|0)>>>ne;ne=(ve|0)==0?ie:a[326792+(ve<<1)>>1]|0;if((ne|0)==1){ue=84;ae=114;break e}else{ce=ne;le=1;ae=89;break i}}}while(0);if((ae|0)==14){ae=0;if((se&-2048|0)==55296|se>>>0>1114111){ue=84;ae=114;break e}else{ce=se;le=4;ae=89;break}}ne=ie+-129|0;if(ne>>>0>125){ue=84;ae=114;break e}if(g>>>0<2){re=22;break e}ve=n[$+1>>0]|0;oe=ve&255;if((ve&255)<161&B){ue=84;ae=114;break e}fe=oe+-64|0;if(!(fe>>>0>190|ve<<24>>24==127)){ce=a[223088+(ne*380|0)+((fe>>>0>63?oe+-65|0:fe)<<1)>>1]|0;le=2;ae=89;break}if(!((oe+-48|0)>>>0<10&I)){ue=84;ae=114;break e}if(g>>>0<4){re=22;break e}fe=(u[$+2>>0]|0)+-129|0;if(fe>>>0>126){ue=84;ae=114;break e}ve=(u[$+3>>0]|0)+-48|0;if(ve>>>0>9){ue=84;ae=114;break e}te=((oe+(ne*10|0)|0)*1260|0)+-60352+(fe*10|0)+ve|0;ve=0;while(1){fe=te-ve|0;ne=0;oe=0;while(1){Se=0;Ae=oe;do{Ae=(((a[223088+(ne*380|0)+(Se<<1)>>1]|0)-ve|0)>>>0<=fe>>>0&1)+Ae|0;Se=Se+1|0}while((Se|0)!=190);ne=ne+1|0;if((ne|0)==126)break;else oe=Ae}ve=te+1|0;oe=Ae+te|0;if(oe>>>0<ve>>>0){ce=oe;le=4;ae=89;break}else te=oe}}else{ce=ie;le=1;ae=89}while(0);i:do if((ae|0)==89){ae=0;switch(H|0){case 195:case 192:{if((t[c>>2]|0)>>>0<4){ue=7;ae=114;break e}ie=t[o>>2]|0;n[ie+K>>0]=ce>>>24;n[ie+X>>0]=ce>>>16;n[ie+Z>>0]=ce>>>8;n[ie+J>>0]=ce;t[o>>2]=ie+4;t[c>>2]=(t[c>>2]|0)+-4;we=le;de=y;break i;break}case 199:{if(ce>>>0>127){Me=y;ae=98}else{Re=ce;Ne=y}break}case 200:{if((t[c>>2]|0)>>>0<4){
	ie=wY(d,ce)|0;if((t[c>>2]|0)>>>0<ie>>>0){ue=7;ae=114;break e}ee=t[o>>2]|0;YY(ee|0,d|0,ie|0)|0;Te=ee;Le=ie}else{ie=t[o>>2]|0;Te=ie;Le=wY(ie,ce)|0}t[o>>2]=Te+Le;t[c>>2]=(t[c>>2]|0)-Le;we=le;de=y;break i;break}case 193:case 194:case 197:case 196:{if(ce>>>0<65536|e){ie=ce>>>0>65535?65533:ce;if((t[c>>2]|0)>>>0<2){ue=7;ae=114;break e}ee=t[o>>2]|0;n[ee+p>>0]=ie>>>8;n[ee+Y>>0]=ie;t[o>>2]=ee+2;t[c>>2]=(t[c>>2]|0)+-2;we=le;de=y;break i}else{if((t[c>>2]|0)>>>0<4){ue=7;ae=114;break e}ee=ce+-65536|0;ie=t[o>>2]|0;n[ie+p>>0]=ee>>>18|216;n[ie+Y>>0]=ee>>>10;n[ie+G>>0]=ee>>>8&3|220;n[ie+W>>0]=ee;t[o>>2]=ie+4;t[c>>2]=(t[c>>2]|0)+-4;we=le;de=y;break i}break}case 198:{if((t[c>>2]|0)>>>0<4){ue=7;ae=114;break e}ie=t[o>>2]|0;t[ie>>2]=ce;t[o>>2]=ie+4;t[c>>2]=(t[c>>2]|0)+-4;we=le;de=y;break i;break}default:{Re=ce;Ne=y}}r:while(1){if((ae|0)==98){ae=0;Re=42;Ne=Me+1|0}if(!(t[c>>2]|0)){ue=7;ae=114;break e}if(Re>>>0<x>>>0){De=Re;break}if(q){Me=Ne;ae=98;continue}else Ce=0;while(1){ie=(Ce*5|0)>>>2;ee=Ce<<1&6;te=Ce+1|0;if((Re|0)==(a[326792+((u[203264+(E+ie)>>0]<<8-ee&1023|(u[203264+(ie+_)>>0]|0)>>>ee)<<1)>>1]|0)){ae=105;break r}if(te>>>0<V>>>0)Ce=te;else{Me=Ne;ae=98;continue r}}}if((ae|0)==105){ae=0;De=Ce+128|0}te=t[o>>2]|0;t[o>>2]=te+1;n[te>>0]=De;t[c>>2]=(t[c>>2]|0)+-1;we=le;de=Ne}while(0);$=(t[i>>2]|0)+we|0;t[i>>2]=$;te=g;g=g-we|0;t[r>>2]=g;if((te|0)==(we|0)){S=de;ae=116;break}else y=de}if((ae|0)==114)re=ue;else if((ae|0)==116){s=l;return S|0}t[(ii()|0)>>2]=re;S=-1;s=l;return S|0}function xq(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0;u=s;s=s+16|0;a=u;t[a>>2]=e;o=(f|0)==0?328248:f;f=t[o>>2]|0;e:do if(!i){if(!f){c=0;s=u;return c|0}}else{if(!e){t[a>>2]=a;l=a}else l=e;if(!r){c=-2;s=u;return c|0}do if(!f){b=n[i>>0]|0;k=b&255;if(b<<24>>24>-1){t[l>>2]=k;c=b<<24>>24!=0&1;s=u;return c|0}else{b=k+-194|0;if(b>>>0>50)break e;h=r+-1|0;w=t[328040+(b<<2)>>2]|0;d=i+1|0;break}}else{h=r;w=f;d=i}while(0);i:do if(!h)v=w;else{b=n[d>>0]|0;k=(b&255)>>>3;if((k+-16|k+(w>>26))>>>0>7)break e;else{m=h;_=b;p=w;E=d}while(1){E=E+1|0;p=(_&255)+-128|p<<6;m=m+-1|0;if((p|0)>=0)break;if(!m){v=p;break i}_=n[E>>0]|0;if((_&-64)<<24>>24!=-128)break e}t[o>>2]=0;t[l>>2]=p;c=r-m|0;s=u;return c|0}while(0);t[o>>2]=v;c=-2;s=u;return c|0}while(0);t[o>>2]=0;t[(ii()|0)>>2]=84;c=-1;s=u;return c|0}function Uq(e){e=e|0;var i=0;if(!e)i=1;else i=(t[e>>2]|0)==0;return i&1|0}function zq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0;n=s;f=e+84|0;u=t[f>>2]|0;a=r+256|0;o=OY(u,0,a)|0;if(!o)c=a;else c=o-u|0;o=c>>>0<r>>>0?c:r;YY(i|0,u|0,o|0)|0;t[e+4>>2]=u+o;i=u+c|0;t[e+8>>2]=i;t[f>>2]=i;s=n;return o|0}function jq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0;n=s;s=s+16|0;f=n;t[f>>2]=r;r=qq(e,i,f)|0;s=n;return r|0}function Vq(e,i,r){e=e|0;i=i|0;r=r|0;var a=0,o=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,te=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0,ke=0,he=0,we=0,de=0,ve=0,me=0,_e=0,pe=0,Ee=0,Se=0,ge=0,ye=0,Fe=0,Oe=0,Ae=0,Me=0,Re=0,Ne=0,Te=0,Le=0,De=0,Ce=0,Pe=0,Be=0,Ie=0,He=0,xe=0,Ue=0,ze=0,je=0,Ve=0,qe=0,Ye=0,Ge=0,We=0,Ke=0,Xe=0,Ze=0,Je=0,Qe=0,$e=0,ei=0,ii=0,ri=0,ni=0;a=s;s=s+304|0;o=a+16|0;b=a+8|0;k=a+33|0;h=a;w=a+32|0;d=n[i>>0]|0;if(!(d<<24>>24)){v=0;s=a;return v|0}m=e+4|0;_=e+100|0;p=e+108|0;E=e+8|0;S=k+10|0;g=k+33|0;y=b+4|0;F=k+46|0;O=k+94|0;A=d;d=0;M=i;i=0;R=0;N=0;e:while(1){i:do if(!($q(A&255)|0)){T=(n[M>>0]|0)==37;r:do if(T){L=M+1|0;D=n[L>>0]|0;do if(D<<24>>24==37)break r;else if(D<<24>>24==42){C=0;B=M+2|0}else{I=(D&255)+-48|0;if(I>>>0<10?(n[M+2>>0]|0)==36:0){t[o>>2]=t[r>>2];H=I;while(1){I=t[o>>2]|0;x=t[I>>2]|0;t[o>>2]=I+4;if(H>>>0>1)H=H+-1|0;else break}C=x;B=M+3|0;break}H=t[r>>2]|0;I=t[H>>2]|0;t[r>>2]=H+4;C=I;B=L}while(0);L=n[B>>0]|0;D=L&255;if((D+-48|0)>>>0<10){I=D;D=B;H=0;while(1){U=(H*10|0)+-48+I|0;z=D+1|0;j=n[z>>0]|0;I=j&255;if((I+-48|0)>>>0>=10){V=j;q=z;Y=U;break}else{D=z;H=U}}}else{V=L;q=B;Y=0}if(V<<24>>24==109){H=q+1|0;G=n[H>>0]|0;W=(C|0)!=0&1;K=H;X=0;Z=0}else{G=V;W=0;K=q;X=R;Z=N}H=K+1|0;switch(G&255|0){case 76:{J=H;Q=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{J=K;Q=0;break}case 108:{D=(n[H>>0]|0)==108;J=D?K+2|0:H;Q=D?3:1;break}case 104:{D=(n[H>>0]|0)==104;J=D?K+2|0:H;Q=D?-2:-1;break}case 116:case 122:{J=H;Q=1;break}case 106:{J=H;Q=3;break}default:{$=W;ee=X;ie=Z;re=162;break e}}H=u[J>>0]|0;D=(H&47|0)==3;I=D?H|32:H;H=D?1:Q;if((I|0)==91){ne=i;fe=Y}else if((I|0)==99){ne=i;fe=(Y|0)<1?1:Y}else if((I|0)==110){if(!C){te=d;ue=J;ae=i;oe=X;ce=Z;break i}switch(H|0){case-1:{f[C>>1]=i;te=d;ue=J;ae=i;oe=X;ce=Z;break i;break}case-2:{n[C>>0]=i;te=d;ue=J;ae=i;oe=X;ce=Z;break i;break}case 3:{D=C;t[D>>2]=i;t[D+4>>2]=((i|0)<0)<<31>>31;te=d;ue=J;ae=i;oe=X;ce=Z;break i;break}case 0:{t[C>>2]=i;te=d;ue=J;ae=i;oe=X;ce=Z;break i;break}case 1:{t[C>>2]=i;te=d;ue=J;ae=i;oe=X;ce=Z;break i;break}default:{te=d;ue=J;ae=i;oe=X;ce=Z;break i}}}else{rY(e,0);do{D=t[m>>2]|0;if(D>>>0<(t[_>>2]|0)>>>0){t[m>>2]=D+1;le=u[D>>0]|0}else le=nY(e)|0}while(($q(le)|0)!=0);L=t[m>>2]|0;if(!(t[_>>2]|0))se=L;else{D=L+-1|0;t[m>>2]=D;se=D}ne=(t[p>>2]|0)+i+se-(t[E>>2]|0)|0;fe=Y}rY(e,fe);D=t[m>>2]|0;L=t[_>>2]|0;if(D>>>0<L>>>0){t[m>>2]=D+1;be=L}else{if((nY(e)|0)<0){$=W;ee=X;ie=Z;re=162;break e}be=t[_>>2]|0}if(be)t[m>>2]=(t[m>>2]|0)+-1;n:do switch(I|0){case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{ke=+iY(e,H,0);if((t[p>>2]|0)==((t[E>>2]|0)-(t[m>>2]|0)|0)){he=W;we=d;de=X;ve=Z;break e}if(C)if(!H){c[C>>2]=ke;me=J;_e=X;pe=Z;break n}else if((H|0)==1){l[C>>3]=ke;me=J;_e=X;pe=Z;break n}else if((H|0)==2){l[C>>3]=ke;me=J;_e=X;pe=Z;break n}else{me=J;_e=X;pe=Z;break n}else{me=J;_e=X;pe=Z}break}case 111:{Ee=8;re=144;break}case 117:case 100:{Ee=10;re=144;break}case 105:{Ee=0;re=144;break}case 91:case 99:case 115:{L=(I|0)==99;f:do if((I&239|0)==99){VY(k|0,-1,257)|0;n[k>>0]=0;if((I|0)==115){n[g>>0]=0;n[S+0>>0]=0;n[S+1>>0]=0;n[S+2>>0]=0;n[S+3>>0]=0;n[S+4>>0]=0;Se=J}else Se=J}else{D=J+1|0;U=(n[D>>0]|0)==94;z=U&1;j=U?J+2|0:D;VY(k|0,U&1|0,257)|0;n[k>>0]=0;U=n[j>>0]|0;if(U<<24>>24==45){D=(z^1)&255;n[F>>0]=D;ge=D;ye=j+1|0}else if(U<<24>>24==93){U=(z^1)&255;n[O>>0]=U;ge=U;ye=j+1|0}else{ge=(z^1)&255;ye=j}j=ye;while(1){z=n[j>>0]|0;if(!(z<<24>>24)){$=W;ee=X;ie=Z;re=162;break e}else if(z<<24>>24==93){Se=j;break f}else if(z<<24>>24==45){U=j+1|0;D=n[U>>0]|0;if(!(D<<24>>24==93|D<<24>>24==0)){Fe=n[j+-1>>0]|0;if((Fe&255)<(D&255)){Oe=Fe&255;do{Oe=Oe+1|0;n[k+Oe>>0]=ge;Fe=n[U>>0]|0}while((Oe|0)<(Fe&255|0));Ae=Fe;Me=U}else{Ae=D;Me=U}}else{Ae=45;Me=j}}else{Ae=z;Me=j}n[k+((Ae&255)+1)>>0]=ge;j=Me+1|0}}while(0);j=L?fe+1|0:31;Oe=(H|0)==1;Fe=(W|0)!=0;f:do if(Oe){if(Fe){Re=Xq(j<<2)|0;if(!Re){$=W;ee=0;ie=Re;re=162;break e}else Ne=Re}else Ne=C;t[b>>2]=0;t[y>>2]=0;Re=0;Te=j;Le=Ne;t:while(1){if(!Le)while(1){De=t[m>>2]|0;if(De>>>0<(t[_>>2]|0)>>>0){t[m>>2]=De+1;Ce=u[De>>0]|0}else Ce=nY(e)|0;if(!(n[k+(Ce+1)>>0]|0)){Pe=Re;Be=0;break t}n[w>>0]=Ce;De=xq(h,w,1,b)|0;if((De|0)==-2)continue;else if((De|0)==-1){$=W;ee=0;ie=0;re=162;break e}if(Fe&(Re|0)==(Te|0)){Ie=Re;break}}else{if(Fe)He=Re;else{xe=Re;re=98;break}while(1){while(1){z=t[m>>2]|0;if(z>>>0<(t[_>>2]|0)>>>0){t[m>>2]=z+1;Ue=u[z>>0]|0}else Ue=nY(e)|0;if(!(n[k+(Ue+1)>>0]|0)){Pe=He;Be=Le;break t}n[w>>0]=Ue;z=xq(h,w,1,b)|0;if((z|0)==-1){$=W;ee=0;ie=Le;re=162;break e}else if((z|0)!=-2)break}t[Le+(He<<2)>>2]=t[h>>2];He=He+1|0;if((He|0)==(Te|0)){Ie=Te;break}}}z=Te<<1|1;U=Jq(Le,z<<2)|0;if(!U){$=W;ee=0;ie=Le;re=162;break e}Re=Ie;Te=z;Le=U}t:do if((re|0)==98)while(1){re=0;while(1){Te=t[m>>2]|0;if(Te>>>0<(t[_>>2]|0)>>>0){t[m>>2]=Te+1;ze=u[Te>>0]|0}else ze=nY(e)|0;if(!(n[k+(ze+1)>>0]|0)){Pe=xe;Be=Le;break t}n[w>>0]=ze;Te=xq(h,w,1,b)|0;if((Te|0)==-1){$=0;ee=0;ie=Le;re=162;break e}else if((Te|0)!=-2)break}t[Le+(xe<<2)>>2]=t[h>>2];xe=xe+1|0;re=98}while(0);if(!(Uq(b)|0)){$=W;ee=0;ie=Be;re=162;break e}else{je=Pe;Ve=0;qe=Be}}else{if(Fe){Le=Xq(j)|0;if(!Le){$=W;ee=0;ie=0;re=162;break e}else{Ye=0;Ge=j;We=Le}while(1){Le=Ye;do{Te=t[m>>2]|0;if(Te>>>0<(t[_>>2]|0)>>>0){t[m>>2]=Te+1;Ke=u[Te>>0]|0}else Ke=nY(e)|0;if(!(n[k+(Ke+1)>>0]|0)){je=Le;Ve=We;qe=0;break f}n[We+Le>>0]=Ke;Le=Le+1|0}while((Le|0)!=(Ge|0));Le=Ge<<1|1;Te=Jq(We,Le)|0;if(!Te){$=W;ee=We;ie=0;re=162;break e}else{Re=Ge;Ge=Le;We=Te;Ye=Re}}}if(!C){Re=be;while(1){Te=t[m>>2]|0;if(Te>>>0<Re>>>0){t[m>>2]=Te+1;Xe=u[Te>>0]|0}else Xe=nY(e)|0;if(!(n[k+(Xe+1)>>0]|0)){je=0;Ve=0;qe=0;break f}Re=t[_>>2]|0}}else{Re=be;Te=0;while(1){Le=t[m>>2]|0;if(Le>>>0<Re>>>0){t[m>>2]=Le+1;Ze=u[Le>>0]|0}else Ze=nY(e)|0;if(!(n[k+(Ze+1)>>0]|0)){je=Te;Ve=C;qe=0;break f}n[C+Te>>0]=Ze;Re=t[_>>2]|0;Te=Te+1|0}}}while(0);j=t[m>>2]|0;if(!(t[_>>2]|0))Je=j;else{Te=j+-1|0;t[m>>2]=Te;Je=Te}Te=Je-(t[E>>2]|0)+(t[p>>2]|0)|0;if(!Te){he=W;we=d;de=Ve;ve=qe;break e}if(!((Te|0)==(fe|0)|L^1)){he=W;we=d;de=Ve;ve=qe;break e}do if(Fe)if(Oe){t[C>>2]=qe;break}else{t[C>>2]=Ve;break}while(0);if(!L){if(qe)t[qe+(je<<2)>>2]=0;if(!Ve){me=Se;_e=0;pe=qe}else{n[Ve+je>>0]=0;me=Se;_e=Ve;pe=qe}}else{me=Se;_e=Ve;pe=qe}break}case 120:case 88:case 112:{Ee=16;re=144;break}default:{me=J;_e=X;pe=Z}}while(0);n:do if((re|0)==144){re=0;Oe=eY(e,Ee,0,-1,-1)|0;if((t[p>>2]|0)==((t[E>>2]|0)-(t[m>>2]|0)|0)){he=W;we=d;de=X;ve=Z;break e}if((I|0)==112&(C|0)!=0){t[C>>2]=Oe;me=J;_e=X;pe=Z;break}if(!C){me=J;_e=X;pe=Z}else switch(H|0){case-2:{n[C>>0]=Oe;me=J;_e=X;pe=Z;break n;break}case-1:{f[C>>1]=Oe;me=J;_e=X;pe=Z;break n;break}case 0:{t[C>>2]=Oe;me=J;_e=X;pe=Z;break n;break}case 1:{t[C>>2]=Oe;me=J;_e=X;pe=Z;break n;break}case 3:{Fe=C;t[Fe>>2]=Oe;t[Fe+4>>2]=P;me=J;_e=X;pe=Z;break n;break}default:{me=J;_e=X;pe=Z;break n}}}while(0);te=((C|0)!=0&1)+d|0;ue=me;ae=(t[p>>2]|0)+ne+(t[m>>2]|0)-(t[E>>2]|0)|0;oe=_e;ce=pe;break i}while(0);H=M+(T&1)|0;rY(e,0);I=t[m>>2]|0;if(I>>>0<(t[_>>2]|0)>>>0){t[m>>2]=I+1;Qe=u[I>>0]|0}else Qe=nY(e)|0;if((Qe|0)!=(u[H>>0]|0)){re=19;break e}te=d;ue=H;ae=i+1|0;oe=R;ce=N}else{H=M;while(1){I=H+1|0;if(!($q(u[I>>0]|0)|0))break;else H=I}rY(e,0);do{T=t[m>>2]|0;if(T>>>0<(t[_>>2]|0)>>>0){t[m>>2]=T+1;$e=u[T>>0]|0}else $e=nY(e)|0}while(($q($e)|0)!=0);T=t[m>>2]|0;if(!(t[_>>2]|0))ei=T;else{I=T+-1|0;t[m>>2]=I;ei=I}te=d;ue=H;ae=(t[p>>2]|0)+i+ei-(t[E>>2]|0)|0;oe=R;ce=N}while(0);M=ue+1|0;A=n[M>>0]|0;if(!(A<<24>>24)){v=te;re=166;break}else{d=te;i=ae;R=oe;N=ce}}if((re|0)==19){if(t[_>>2]|0)t[m>>2]=(t[m>>2]|0)+-1;if((Qe|0)>-1|(d|0)!=0){v=d;s=a;return v|0}else{ii=0;ri=R;ni=N;re=163}}else if((re|0)==162)if(!d){ii=$;ri=ee;ni=ie;re=163}else{he=$;we=d;de=ee;ve=ie}else if((re|0)==166){s=a;return v|0}if((re|0)==163){he=ii;we=-1;de=ri;ve=ni}if(!he){v=we;s=a;return v|0}Zq(de);Zq(ve);v=we;s=a;return v|0}function qq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;s=s+112|0;f=n;u=f+0|0;a=u+112|0;do{t[u>>2]=0;u=u+4|0}while((u|0)<(a|0));t[f+32>>2]=391;t[f+44>>2]=e;t[f+76>>2]=-1;t[f+84>>2]=e;e=Vq(f,i,r)|0;s=n;return e|0}function Yq(e,i){e=e|0;i=i|0;var r=0,f=0;r=s;f=Gq(e,i)|0;s=r;return((n[f>>0]|0)==(i&255)<<24>>24?f:0)|0}function Gq(e,i){e=e|0;i=i|0;var r=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0;r=s;f=i&255;if(!f){u=e+(HY(e|0)|0)|0;s=r;return u|0}e:do if(!(e&3))a=e;else{o=i&255;c=e;while(1){l=n[c>>0]|0;b=c+1|0;if(l<<24>>24==0?1:l<<24>>24==o<<24>>24){u=c;break}if(!(b&3)){a=b;break e}else c=b}s=r;return u|0}while(0);e=te(f,16843009)|0;f=t[a>>2]|0;e:do if(!((f&-2139062144^-2139062144)&f+-16843009)){c=f;o=a;while(1){b=c^e;l=o+4|0;if((b&-2139062144^-2139062144)&b+-16843009){k=o;break e}c=t[l>>2]|0;if((c&-2139062144^-2139062144)&c+-16843009){k=l;break}else o=l}}else k=a;while(0);a=i&255;i=k;while(1){k=n[i>>0]|0;if(k<<24>>24==0?1:k<<24>>24==a<<24>>24){u=i;break}else i=i+1|0}s=r;return u|0}function Wq(e){e=e|0;var i=0,r=0,f=0,t=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0;i=s;r=n[e>>0]|0;e:do if(r<<24>>24){f=203264;while(1){t=e;u=f;a=r;while(1){o=n[u>>0]|0;if(!(o<<24>>24)){c=u;l=a;b=16;break}i:do if(!(a<<24>>24)){k=t;h=0}else{w=t;d=a&255;v=a;while(1){m=w+1|0;if(!(((d|32)+-97|0)>>>0>26&(d+-48|0)>>>0>10)){k=w;h=v;break i}_=n[m>>0]|0;if(!(_<<24>>24)){k=m;h=0;break}else{w=m;d=_&255;v=_}}}while(0);if((h&255|32|0)!=(o&255|0))break;t=k+1|0;v=u+1|0;a=n[t>>0]|0;if(!(a<<24>>24)){c=v;l=0;b=16;break}else u=v}if((b|0)==16?(b=0,l<<24>>24==(n[c>>0]|0)):0)break;u=HY(f|0)|0;a=f+(u+1)|0;do if(!(n[a>>0]|0)){t=n[f+(u+2)>>0]|0;if((t&255)>128){p=f+(u+3)|0;break}else{p=f+(u+3+(((128-(t&255)|0)>>>2)*5|0))|0;break}}else p=a;while(0);if(!(n[p>>0]|0)){E=-1;b=25;break}else f=p}if((b|0)==25){s=i;return E|0}if(!(n[f>>0]|0))S=f;else{a=f;while(1){u=a+((HY(a|0)|0)+1)|0;if(!(n[u>>0]|0)){S=u;break}else a=u}}}else{a=203264;while(1){if(!(n[a>>0]|0)){S=a;break e}f=HY(a|0)|0;u=a+(f+1)|0;do if(!(n[u>>0]|0)){t=n[a+(f+2)>>0]|0;if((t&255)>128){g=a+(f+3)|0;break}else{g=a+(f+3+(((128-(t&255)|0)>>>2)*5|0))|0;break}}else g=u;while(0);if(!(n[g>>0]|0)){E=-1;break}else a=g}s=i;return E|0}while(0);E=S+1-203264|0;s=i;return E|0}function Kq(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0;n=s;f=zq(e,i,r)|0;s=n;return f|0}function Xq(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,te=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0,ke=0,he=0,we=0,de=0,ve=0,me=0,_e=0,pe=0,Ee=0,Se=0,ge=0,ye=0,Fe=0,Oe=0,Ae=0,Me=0,Re=0,Ne=0,Te=0,Le=0,De=0,Ce=0,Pe=0,Be=0,Ie=0;i=s;do if(e>>>0<245){if(e>>>0<11)r=16;else r=e+11&-8;n=r>>>3;f=t[82064]|0;u=f>>>n;if(u&3){a=(u&1^1)+n|0;o=a<<1;c=328296+(o<<2)|0;l=328296+(o+2<<2)|0;o=t[l>>2]|0;b=o+8|0;k=t[b>>2]|0;do if((c|0)!=(k|0)){if(k>>>0<(t[82068]|0)>>>0)li();h=k+12|0;if((t[h>>2]|0)==(o|0)){t[h>>2]=c;t[l>>2]=k;break}else li()}else t[82064]=f&~(1<<a);while(0);k=a<<3;t[o+4>>2]=k|3;l=o+(k|4)|0;t[l>>2]=t[l>>2]|1;w=b;s=i;return w|0}l=t[82066]|0;if(r>>>0>l>>>0){if(u){k=2<<n;c=u<<n&(k|0-k);k=(c&0-c)+-1|0;c=k>>>12&16;h=k>>>c;k=h>>>5&8;d=h>>>k;h=d>>>2&4;v=d>>>h;d=v>>>1&2;m=v>>>d;v=m>>>1&1;_=(k|c|h|d|v)+(m>>>v)|0;v=_<<1;m=328296+(v<<2)|0;d=328296+(v+2<<2)|0;v=t[d>>2]|0;h=v+8|0;c=t[h>>2]|0;do if((m|0)!=(c|0)){if(c>>>0<(t[82068]|0)>>>0)li();k=c+12|0;if((t[k>>2]|0)==(v|0)){t[k>>2]=m;t[d>>2]=c;p=t[82066]|0;break}else li()}else{t[82064]=f&~(1<<_);p=l}while(0);l=_<<3;f=l-r|0;t[v+4>>2]=r|3;c=v+r|0;t[v+(r|4)>>2]=f|1;t[v+l>>2]=f;if(p){l=t[82069]|0;d=p>>>3;m=d<<1;n=328296+(m<<2)|0;u=t[82064]|0;b=1<<d;if(u&b){d=328296+(m+2<<2)|0;o=t[d>>2]|0;if(o>>>0<(t[82068]|0)>>>0)li();else{E=d;S=o}}else{t[82064]=u|b;E=328296+(m+2<<2)|0;S=n}t[E>>2]=l;t[S+12>>2]=l;t[l+8>>2]=S;t[l+12>>2]=n}t[82066]=f;t[82069]=c;w=h;s=i;return w|0}c=t[82065]|0;if(c){f=(c&0-c)+-1|0;c=f>>>12&16;n=f>>>c;f=n>>>5&8;l=n>>>f;n=l>>>2&4;m=l>>>n;l=m>>>1&2;b=m>>>l;m=b>>>1&1;u=t[328560+((f|c|n|l|m)+(b>>>m)<<2)>>2]|0;m=(t[u+4>>2]&-8)-r|0;b=u;l=u;while(1){u=t[b+16>>2]|0;if(!u){n=t[b+20>>2]|0;if(!n)break;else g=n}else g=u;u=(t[g+4>>2]&-8)-r|0;n=u>>>0<m>>>0;m=n?u:m;b=g;l=n?g:l}b=t[82068]|0;if(l>>>0<b>>>0)li();h=l+r|0;if(l>>>0>=h>>>0)li();v=t[l+24>>2]|0;_=t[l+12>>2]|0;do if((_|0)==(l|0)){n=l+20|0;u=t[n>>2]|0;if(!u){c=l+16|0;f=t[c>>2]|0;if(!f){y=0;break}else{F=f;O=c}}else{F=u;O=n}while(1){n=F+20|0;u=t[n>>2]|0;if(u){F=u;O=n;continue}n=F+16|0;u=t[n>>2]|0;if(!u)break;else{F=u;O=n}}if(O>>>0<b>>>0)li();else{t[O>>2]=0;y=F;break}}else{n=t[l+8>>2]|0;if(n>>>0<b>>>0)li();u=n+12|0;if((t[u>>2]|0)!=(l|0))li();c=_+8|0;if((t[c>>2]|0)==(l|0)){t[u>>2]=_;t[c>>2]=n;y=_;break}else li()}while(0);do if(v){_=t[l+28>>2]|0;b=328560+(_<<2)|0;if((l|0)==(t[b>>2]|0)){t[b>>2]=y;if(!y){t[82065]=t[82065]&~(1<<_);break}}else{if(v>>>0<(t[82068]|0)>>>0)li();_=v+16|0;if((t[_>>2]|0)==(l|0))t[_>>2]=y;else t[v+20>>2]=y;if(!y)break}_=t[82068]|0;if(y>>>0<_>>>0)li();t[y+24>>2]=v;b=t[l+16>>2]|0;do if(b)if(b>>>0<_>>>0)li();else{t[y+16>>2]=b;t[b+24>>2]=y;break}while(0);b=t[l+20>>2]|0;if(b)if(b>>>0<(t[82068]|0)>>>0)li();else{t[y+20>>2]=b;t[b+24>>2]=y;break}}while(0);if(m>>>0<16){v=m+r|0;t[l+4>>2]=v|3;b=l+(v+4)|0;t[b>>2]=t[b>>2]|1}else{t[l+4>>2]=r|3;t[l+(r|4)>>2]=m|1;t[l+(m+r)>>2]=m;b=t[82066]|0;if(b){v=t[82069]|0;_=b>>>3;b=_<<1;n=328296+(b<<2)|0;c=t[82064]|0;u=1<<_;if(c&u){_=328296+(b+2<<2)|0;f=t[_>>2]|0;if(f>>>0<(t[82068]|0)>>>0)li();else{A=_;M=f}}else{t[82064]=c|u;A=328296+(b+2<<2)|0;M=n}t[A>>2]=v;t[M+12>>2]=v;t[v+8>>2]=M;t[v+12>>2]=n}t[82066]=m;t[82069]=h}w=l+8|0;s=i;return w|0}else R=r}else R=r}else if(e>>>0<=4294967231){n=e+11|0;v=n&-8;b=t[82065]|0;if(b){u=0-v|0;c=n>>>8;if(c)if(v>>>0>16777215)N=31;else{n=(c+1048320|0)>>>16&8;f=c<<n;c=(f+520192|0)>>>16&4;_=f<<c;f=(_+245760|0)>>>16&2;o=14-(c|n|f)+(_<<f>>>15)|0;N=v>>>(o+7|0)&1|o<<1}else N=0;o=t[328560+(N<<2)>>2]|0;e:do if(!o){T=u;L=0;D=0}else{if((N|0)==31)C=0;else C=25-(N>>>1)|0;f=u;_=0;n=v<<C;c=o;d=0;while(1){a=t[c+4>>2]&-8;k=a-v|0;if(k>>>0<f>>>0)if((a|0)==(v|0)){T=k;L=c;D=c;break e}else{P=k;B=c}else{P=f;B=d}k=t[c+20>>2]|0;c=t[c+(n>>>31<<2)+16>>2]|0;a=(k|0)==0|(k|0)==(c|0)?_:k;if(!c){T=P;L=a;D=B;break}else{f=P;_=a;n=n<<1;d=B}}}while(0);if((L|0)==0&(D|0)==0){o=2<<N;u=b&(o|0-o);if(!u){R=v;break}o=(u&0-u)+-1|0;u=o>>>12&16;l=o>>>u;o=l>>>5&8;h=l>>>o;l=h>>>2&4;m=h>>>l;h=m>>>1&2;d=m>>>h;m=d>>>1&1;I=t[328560+((o|u|l|h|m)+(d>>>m)<<2)>>2]|0}else I=L;if(!I){H=T;x=D}else{m=T;d=I;h=D;while(1){l=(t[d+4>>2]&-8)-v|0;u=l>>>0<m>>>0;o=u?l:m;l=u?d:h;u=t[d+16>>2]|0;if(u){m=o;d=u;h=l;continue}d=t[d+20>>2]|0;if(!d){H=o;x=l;break}else{m=o;h=l}}}if((x|0)!=0?H>>>0<((t[82066]|0)-v|0)>>>0:0){h=t[82068]|0;if(x>>>0<h>>>0)li();m=x+v|0;if(x>>>0>=m>>>0)li();d=t[x+24>>2]|0;b=t[x+12>>2]|0;do if((b|0)==(x|0)){l=x+20|0;o=t[l>>2]|0;if(!o){u=x+16|0;n=t[u>>2]|0;if(!n){U=0;break}else{z=n;j=u}}else{z=o;j=l}while(1){l=z+20|0;o=t[l>>2]|0;if(o){z=o;j=l;continue}l=z+16|0;o=t[l>>2]|0;if(!o)break;else{z=o;j=l}}if(j>>>0<h>>>0)li();else{t[j>>2]=0;U=z;break}}else{l=t[x+8>>2]|0;if(l>>>0<h>>>0)li();o=l+12|0;if((t[o>>2]|0)!=(x|0))li();u=b+8|0;if((t[u>>2]|0)==(x|0)){t[o>>2]=b;t[u>>2]=l;U=b;break}else li()}while(0);do if(d){b=t[x+28>>2]|0;h=328560+(b<<2)|0;if((x|0)==(t[h>>2]|0)){t[h>>2]=U;if(!U){t[82065]=t[82065]&~(1<<b);break}}else{if(d>>>0<(t[82068]|0)>>>0)li();b=d+16|0;if((t[b>>2]|0)==(x|0))t[b>>2]=U;else t[d+20>>2]=U;if(!U)break}b=t[82068]|0;if(U>>>0<b>>>0)li();t[U+24>>2]=d;h=t[x+16>>2]|0;do if(h)if(h>>>0<b>>>0)li();else{t[U+16>>2]=h;t[h+24>>2]=U;break}while(0);h=t[x+20>>2]|0;if(h)if(h>>>0<(t[82068]|0)>>>0)li();else{t[U+20>>2]=h;t[h+24>>2]=U;break}}while(0);e:do if(H>>>0>=16){t[x+4>>2]=v|3;t[x+(v|4)>>2]=H|1;t[x+(H+v)>>2]=H;d=H>>>3;if(H>>>0<256){h=d<<1;b=328296+(h<<2)|0;l=t[82064]|0;u=1<<d;do if(!(l&u)){t[82064]=l|u;V=328296+(h+2<<2)|0;q=b}else{d=328296+(h+2<<2)|0;o=t[d>>2]|0;if(o>>>0>=(t[82068]|0)>>>0){V=d;q=o;break}li()}while(0);t[V>>2]=m;t[q+12>>2]=m;t[x+(v+8)>>2]=q;t[x+(v+12)>>2]=b;break}h=H>>>8;if(h)if(H>>>0>16777215)Y=31;else{u=(h+1048320|0)>>>16&8;l=h<<u;h=(l+520192|0)>>>16&4;o=l<<h;l=(o+245760|0)>>>16&2;d=14-(h|u|l)+(o<<l>>>15)|0;Y=H>>>(d+7|0)&1|d<<1}else Y=0;d=328560+(Y<<2)|0;t[x+(v+28)>>2]=Y;t[x+(v+20)>>2]=0;t[x+(v+16)>>2]=0;l=t[82065]|0;o=1<<Y;if(!(l&o)){t[82065]=l|o;t[d>>2]=m;t[x+(v+24)>>2]=d;t[x+(v+12)>>2]=m;t[x+(v+8)>>2]=m;break}o=t[d>>2]|0;if((Y|0)==31)G=0;else G=25-(Y>>>1)|0;i:do if((t[o+4>>2]&-8|0)!=(H|0)){d=H<<G;l=o;while(1){W=l+(d>>>31<<2)+16|0;u=t[W>>2]|0;if(!u)break;if((t[u+4>>2]&-8|0)==(H|0)){K=u;break i}else{d=d<<1;l=u}}if(W>>>0<(t[82068]|0)>>>0)li();else{t[W>>2]=m;t[x+(v+24)>>2]=l;t[x+(v+12)>>2]=m;t[x+(v+8)>>2]=m;break e}}else K=o;while(0);o=K+8|0;b=t[o>>2]|0;d=t[82068]|0;if(K>>>0>=d>>>0&b>>>0>=d>>>0){t[b+12>>2]=m;t[o>>2]=m;t[x+(v+8)>>2]=b;t[x+(v+12)>>2]=K;t[x+(v+24)>>2]=0;break}else li()}else{b=H+v|0;t[x+4>>2]=b|3;o=x+(b+4)|0;t[o>>2]=t[o>>2]|1}while(0);w=x+8|0;s=i;return w|0}else R=v}else R=v}else R=-1;while(0);x=t[82066]|0;if(x>>>0>=R>>>0){H=x-R|0;K=t[82069]|0;if(H>>>0>15){t[82069]=K+R;t[82066]=H;t[K+(R+4)>>2]=H|1;t[K+x>>2]=H;t[K+4>>2]=R|3}else{t[82066]=0;t[82069]=0;t[K+4>>2]=x|3;H=K+(x+4)|0;t[H>>2]=t[H>>2]|1}w=K+8|0;s=i;return w|0}K=t[82067]|0;if(K>>>0>R>>>0){H=K-R|0;t[82067]=H;K=t[82070]|0;t[82070]=K+R;t[K+(R+4)>>2]=H|1;t[K+4>>2]=R|3;w=K+8|0;s=i;return w|0}do if(!(t[82182]|0)){K=ui(30)|0;if(!(K+-1&K)){t[82184]=K;t[82183]=K;t[82185]=-1;t[82186]=-1;t[82187]=0;t[82175]=0;t[82182]=(bi(0)|0)&-16^1431655768;break}else li()}while(0);K=R+48|0;H=t[82184]|0;x=R+47|0;W=H+x|0;G=0-H|0;H=W&G;if(H>>>0<=R>>>0){w=0;s=i;return w|0}Y=t[82174]|0;if((Y|0)!=0?(q=t[82172]|0,V=q+H|0,V>>>0<=q>>>0|V>>>0>Y>>>0):0){w=0;s=i;return w|0}e:do if(!(t[82175]&4)){Y=t[82070]|0;i:do if(Y){V=328704|0;while(1){q=t[V>>2]|0;if(q>>>0<=Y>>>0?(X=V+4|0,(q+(t[X>>2]|0)|0)>>>0>Y>>>0):0)break;q=t[V+8>>2]|0;if(!q){Z=181;break i}else V=q}if(V){q=W-(t[82067]|0)&G;if(q>>>0<2147483647){U=ze(q|0)|0;if((U|0)==((t[V>>2]|0)+(t[X>>2]|0)|0)){J=U;Q=q;Z=190}else{$=U;ee=q;Z=191}}else ie=0}else Z=181}else Z=181;while(0);do if((Z|0)==181){Y=ze(0)|0;if((Y|0)!=(-1|0)){v=Y;q=t[82183]|0;U=q+-1|0;if(!(U&v))re=H;else re=H-v+(U+v&0-q)|0;q=t[82172]|0;v=q+re|0;if(re>>>0>R>>>0&re>>>0<2147483647){U=t[82174]|0;if((U|0)!=0?v>>>0<=q>>>0|v>>>0>U>>>0:0){ie=0;break}U=ze(re|0)|0;if((U|0)==(Y|0)){J=Y;Q=re;Z=190}else{$=U;ee=re;Z=191}}else ie=0}else ie=0}while(0);i:do if((Z|0)==190)if((J|0)==(-1|0))ie=Q;else{ne=J;fe=Q;Z=201;break e}else if((Z|0)==191){U=0-ee|0;do if(($|0)!=(-1|0)&ee>>>0<2147483647&K>>>0>ee>>>0?(Y=t[82184]|0,v=x-ee+Y&0-Y,v>>>0<2147483647):0)if((ze(v|0)|0)==(-1|0)){ze(U|0)|0;ie=0;break i}else{te=v+ee|0;break}else te=ee;while(0);if(($|0)==(-1|0))ie=0;else{ne=$;fe=te;Z=201;break e}}while(0);t[82175]=t[82175]|4;ue=ie;Z=198}else{ue=0;Z=198}while(0);if((((Z|0)==198?H>>>0<2147483647:0)?(ie=ze(H|0)|0,H=ze(0)|0,(ie|0)!=(-1|0)&(H|0)!=(-1|0)&ie>>>0<H>>>0):0)?(te=H-ie|0,H=te>>>0>(R+40|0)>>>0,H):0){ne=ie;fe=H?te:ue;Z=201}if((Z|0)==201){ue=(t[82172]|0)+fe|0;t[82172]=ue;if(ue>>>0>(t[82173]|0)>>>0)t[82173]=ue;ue=t[82070]|0;e:do if(ue){te=328704|0;while(1){ae=t[te>>2]|0;oe=te+4|0;ce=t[oe>>2]|0;if((ne|0)==(ae+ce|0)){Z=213;break}H=t[te+8>>2]|0;if(!H)break;else te=H}if(((Z|0)==213?(t[te+12>>2]&8|0)==0:0)?ue>>>0>=ae>>>0&ue>>>0<ne>>>0:0){t[oe>>2]=ce+fe;H=(t[82067]|0)+fe|0;ie=ue+8|0;if(!(ie&7))le=0;else le=0-ie&7;ie=H-le|0;t[82070]=ue+le;t[82067]=ie;t[ue+(le+4)>>2]=ie|1;t[ue+(H+4)>>2]=40;t[82071]=t[82186];break}H=t[82068]|0;if(ne>>>0<H>>>0){t[82068]=ne;se=ne}else se=H;H=ne+fe|0;ie=328704|0;while(1){if((t[ie>>2]|0)==(H|0)){Z=223;break}$=t[ie+8>>2]|0;if(!$)break;else ie=$}if((Z|0)==223?(t[ie+12>>2]&8|0)==0:0){t[ie>>2]=ne;H=ie+4|0;t[H>>2]=(t[H>>2]|0)+fe;H=ne+8|0;if(!(H&7))be=0;else be=0-H&7;H=ne+(fe+8)|0;if(!(H&7))ke=0;else ke=0-H&7;H=ne+(ke+fe)|0;te=be+R|0;$=ne+te|0;ee=H-(ne+be)-R|0;t[ne+(be+4)>>2]=R|3;i:do if((H|0)!=(ue|0)){if((H|0)==(t[82069]|0)){x=(t[82066]|0)+ee|0;t[82066]=x;t[82069]=$;t[ne+(te+4)>>2]=x|1;t[ne+(x+te)>>2]=x;break}x=fe+4|0;K=t[ne+(x+ke)>>2]|0;if((K&3|0)==1){Q=K&-8;J=K>>>3;r:do if(K>>>0>=256){re=t[ne+((ke|24)+fe)>>2]|0;X=t[ne+(fe+12+ke)>>2]|0;do if((X|0)==(H|0)){G=ke|16;W=ne+(x+G)|0;U=t[W>>2]|0;if(!U){V=ne+(G+fe)|0;G=t[V>>2]|0;if(!G){he=0;break}else{we=G;de=V}}else{we=U;de=W}while(1){W=we+20|0;U=t[W>>2]|0;if(U){we=U;de=W;continue}W=we+16|0;U=t[W>>2]|0;if(!U)break;else{we=U;de=W}}if(de>>>0<se>>>0)li();else{t[de>>2]=0;he=we;break}}else{W=t[ne+((ke|8)+fe)>>2]|0;if(W>>>0<se>>>0)li();U=W+12|0;if((t[U>>2]|0)!=(H|0))li();V=X+8|0;if((t[V>>2]|0)==(H|0)){t[U>>2]=X;t[V>>2]=W;he=X;break}else li()}while(0);if(!re)break;X=t[ne+(fe+28+ke)>>2]|0;l=328560+(X<<2)|0;do if((H|0)!=(t[l>>2]|0)){if(re>>>0<(t[82068]|0)>>>0)li();W=re+16|0;if((t[W>>2]|0)==(H|0))t[W>>2]=he;else t[re+20>>2]=he;if(!he)break r}else{t[l>>2]=he;if(he)break;t[82065]=t[82065]&~(1<<X);break r}while(0);X=t[82068]|0;if(he>>>0<X>>>0)li();t[he+24>>2]=re;l=ke|16;W=t[ne+(l+fe)>>2]|0;do if(W)if(W>>>0<X>>>0)li();else{t[he+16>>2]=W;t[W+24>>2]=he;break}while(0);W=t[ne+(x+l)>>2]|0;if(!W)break;if(W>>>0<(t[82068]|0)>>>0)li();else{t[he+20>>2]=W;t[W+24>>2]=he;break}}else{W=t[ne+((ke|8)+fe)>>2]|0;X=t[ne+(fe+12+ke)>>2]|0;re=328296+(J<<1<<2)|0;do if((W|0)!=(re|0)){if(W>>>0<se>>>0)li();if((t[W+12>>2]|0)==(H|0))break;li()}while(0);if((X|0)==(W|0)){t[82064]=t[82064]&~(1<<J);break}do if((X|0)==(re|0))ve=X+8|0;else{if(X>>>0<se>>>0)li();l=X+8|0;if((t[l>>2]|0)==(H|0)){ve=l;break}li()}while(0);t[W+12>>2]=X;t[ve>>2]=W}while(0);me=ne+((Q|ke)+fe)|0;_e=Q+ee|0}else{me=H;_e=ee}J=me+4|0;t[J>>2]=t[J>>2]&-2;t[ne+(te+4)>>2]=_e|1;t[ne+(_e+te)>>2]=_e;J=_e>>>3;if(_e>>>0<256){x=J<<1;K=328296+(x<<2)|0;re=t[82064]|0;l=1<<J;do if(!(re&l)){t[82064]=re|l;pe=328296+(x+2<<2)|0;Ee=K}else{J=328296+(x+2<<2)|0;V=t[J>>2]|0;if(V>>>0>=(t[82068]|0)>>>0){pe=J;Ee=V;break}li()}while(0);t[pe>>2]=$;t[Ee+12>>2]=$;t[ne+(te+8)>>2]=Ee;t[ne+(te+12)>>2]=K;break}x=_e>>>8;do if(!x)Se=0;else{if(_e>>>0>16777215){Se=31;break}l=(x+1048320|0)>>>16&8;re=x<<l;Q=(re+520192|0)>>>16&4;V=re<<Q;re=(V+245760|0)>>>16&2;J=14-(Q|l|re)+(V<<re>>>15)|0;Se=_e>>>(J+7|0)&1|J<<1}while(0);x=328560+(Se<<2)|0;t[ne+(te+28)>>2]=Se;t[ne+(te+20)>>2]=0;t[ne+(te+16)>>2]=0;K=t[82065]|0;J=1<<Se;if(!(K&J)){t[82065]=K|J;t[x>>2]=$;t[ne+(te+24)>>2]=x;t[ne+(te+12)>>2]=$;t[ne+(te+8)>>2]=$;break}J=t[x>>2]|0;if((Se|0)==31)ge=0;else ge=25-(Se>>>1)|0;r:do if((t[J+4>>2]&-8|0)!=(_e|0)){x=_e<<ge;K=J;while(1){ye=K+(x>>>31<<2)+16|0;re=t[ye>>2]|0;if(!re)break;if((t[re+4>>2]&-8|0)==(_e|0)){Fe=re;break r}else{x=x<<1;K=re}}if(ye>>>0<(t[82068]|0)>>>0)li();else{t[ye>>2]=$;t[ne+(te+24)>>2]=K;t[ne+(te+12)>>2]=$;t[ne+(te+8)>>2]=$;break i}}else Fe=J;while(0);J=Fe+8|0;x=t[J>>2]|0;W=t[82068]|0;if(Fe>>>0>=W>>>0&x>>>0>=W>>>0){t[x+12>>2]=$;t[J>>2]=$;t[ne+(te+8)>>2]=x;t[ne+(te+12)>>2]=Fe;t[ne+(te+24)>>2]=0;break}else li()}else{x=(t[82067]|0)+ee|0;t[82067]=x;t[82070]=$;t[ne+(te+4)>>2]=x|1}while(0);w=ne+(be|8)|0;s=i;return w|0}te=328704|0;while(1){Oe=t[te>>2]|0;if(Oe>>>0<=ue>>>0?(Ae=t[te+4>>2]|0,Me=Oe+Ae|0,Me>>>0>ue>>>0):0)break;te=t[te+8>>2]|0}te=Oe+(Ae+-39)|0;if(!(te&7))Re=0;else Re=0-te&7;te=Oe+(Ae+-47+Re)|0;$=te>>>0<(ue+16|0)>>>0?ue:te;te=$+8|0;ee=ne+8|0;if(!(ee&7))Ne=0;else Ne=0-ee&7;ee=fe+-40-Ne|0;t[82070]=ne+Ne;t[82067]=ee;t[ne+(Ne+4)>>2]=ee|1;t[ne+(fe+-36)>>2]=40;t[82071]=t[82186];t[$+4>>2]=27;t[te+0>>2]=t[82176];t[te+4>>2]=t[82177];t[te+8>>2]=t[82178];t[te+12>>2]=t[82179];t[82176]=ne;t[82177]=fe;t[82179]=0;t[82178]=te;te=$+28|0;t[te>>2]=7;if(($+32|0)>>>0<Me>>>0){ee=te;do{te=ee;ee=ee+4|0;t[ee>>2]=7}while((te+8|0)>>>0<Me>>>0)}if(($|0)!=(ue|0)){ee=$-ue|0;te=ue+(ee+4)|0;t[te>>2]=t[te>>2]&-2;t[ue+4>>2]=ee|1;t[ue+ee>>2]=ee;te=ee>>>3;if(ee>>>0<256){H=te<<1;ie=328296+(H<<2)|0;x=t[82064]|0;J=1<<te;do if(!(x&J)){t[82064]=x|J;Te=328296+(H+2<<2)|0;Le=ie}else{te=328296+(H+2<<2)|0;W=t[te>>2]|0;if(W>>>0>=(t[82068]|0)>>>0){Te=te;Le=W;break}li()}while(0);t[Te>>2]=ue;t[Le+12>>2]=ue;t[ue+8>>2]=Le;t[ue+12>>2]=ie;break}H=ee>>>8;if(H)if(ee>>>0>16777215)De=31;else{J=(H+1048320|0)>>>16&8;x=H<<J;H=(x+520192|0)>>>16&4;$=x<<H;x=($+245760|0)>>>16&2;W=14-(H|J|x)+($<<x>>>15)|0;De=ee>>>(W+7|0)&1|W<<1}else De=0;W=328560+(De<<2)|0;t[ue+28>>2]=De;t[ue+20>>2]=0;t[ue+16>>2]=0;x=t[82065]|0;$=1<<De;if(!(x&$)){t[82065]=x|$;t[W>>2]=ue;t[ue+24>>2]=W;t[ue+12>>2]=ue;t[ue+8>>2]=ue;break}$=t[W>>2]|0;if((De|0)==31)Ce=0;else Ce=25-(De>>>1)|0;i:do if((t[$+4>>2]&-8|0)!=(ee|0)){W=ee<<Ce;x=$;while(1){Pe=x+(W>>>31<<2)+16|0;J=t[Pe>>2]|0;if(!J)break;if((t[J+4>>2]&-8|0)==(ee|0)){Be=J;break i}else{W=W<<1;x=J}}if(Pe>>>0<(t[82068]|0)>>>0)li();else{t[Pe>>2]=ue;t[ue+24>>2]=x;t[ue+12>>2]=ue;t[ue+8>>2]=ue;break e}}else Be=$;while(0);$=Be+8|0;ee=t[$>>2]|0;ie=t[82068]|0;if(Be>>>0>=ie>>>0&ee>>>0>=ie>>>0){t[ee+12>>2]=ue;t[$>>2]=ue;t[ue+8>>2]=ee;t[ue+12>>2]=Be;t[ue+24>>2]=0;break}else li()}}else{ee=t[82068]|0;if((ee|0)==0|ne>>>0<ee>>>0)t[82068]=ne;t[82176]=ne;t[82177]=fe;t[82179]=0;t[82073]=t[82182];t[82072]=-1;ee=0;do{$=ee<<1;ie=328296+($<<2)|0;t[328296+($+3<<2)>>2]=ie;t[328296+($+2<<2)>>2]=ie;ee=ee+1|0}while((ee|0)!=32);ee=ne+8|0;if(!(ee&7))Ie=0;else Ie=0-ee&7;ee=fe+-40-Ie|0;t[82070]=ne+Ie;t[82067]=ee;t[ne+(Ie+4)>>2]=ee|1;t[ne+(fe+-36)>>2]=40;t[82071]=t[82186]}while(0);fe=t[82067]|0;if(fe>>>0>R>>>0){ne=fe-R|0;t[82067]=ne;fe=t[82070]|0;t[82070]=fe+R;t[fe+(R+4)>>2]=ne|1;t[fe+4>>2]=R|3;w=fe+8|0;s=i;return w|0}}t[(ii()|0)>>2]=12;w=0;s=i;return w|0}function Zq(e){e=e|0;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,P=0,B=0;i=s;if(!e){s=i;return}r=e+-8|0;n=t[82068]|0;if(r>>>0<n>>>0)li();f=t[e+-4>>2]|0;u=f&3;if((u|0)==1)li();a=f&-8;o=e+(a+-8)|0;do if(!(f&1)){c=t[r>>2]|0;if(!u){s=i;return}l=-8-c|0;b=e+l|0;k=c+a|0;if(b>>>0<n>>>0)li();if((b|0)==(t[82069]|0)){h=e+(a+-4)|0;w=t[h>>2]|0;if((w&3|0)!=3){d=b;v=k;break}t[82066]=k;t[h>>2]=w&-2;t[e+(l+4)>>2]=k|1;t[o>>2]=k;s=i;return}w=c>>>3;if(c>>>0<256){c=t[e+(l+8)>>2]|0;h=t[e+(l+12)>>2]|0;m=328296+(w<<1<<2)|0;if((c|0)!=(m|0)){if(c>>>0<n>>>0)li();if((t[c+12>>2]|0)!=(b|0))li()}if((h|0)==(c|0)){t[82064]=t[82064]&~(1<<w);d=b;v=k;break}if((h|0)!=(m|0)){if(h>>>0<n>>>0)li();m=h+8|0;if((t[m>>2]|0)==(b|0))_=m;else li()}else _=h+8|0;t[c+12>>2]=h;t[_>>2]=c;d=b;v=k;break}c=t[e+(l+24)>>2]|0;h=t[e+(l+12)>>2]|0;do if((h|0)==(b|0)){m=e+(l+20)|0;w=t[m>>2]|0;if(!w){p=e+(l+16)|0;E=t[p>>2]|0;if(!E){S=0;break}else{g=E;y=p}}else{g=w;y=m}while(1){m=g+20|0;w=t[m>>2]|0;if(w){g=w;y=m;continue}m=g+16|0;w=t[m>>2]|0;if(!w)break;else{g=w;y=m}}if(y>>>0<n>>>0)li();else{t[y>>2]=0;S=g;break}}else{m=t[e+(l+8)>>2]|0;if(m>>>0<n>>>0)li();w=m+12|0;if((t[w>>2]|0)!=(b|0))li();p=h+8|0;if((t[p>>2]|0)==(b|0)){t[w>>2]=h;t[p>>2]=m;S=h;break}else li()}while(0);if(c){h=t[e+(l+28)>>2]|0;m=328560+(h<<2)|0;if((b|0)==(t[m>>2]|0)){t[m>>2]=S;if(!S){t[82065]=t[82065]&~(1<<h);d=b;v=k;break}}else{if(c>>>0<(t[82068]|0)>>>0)li();h=c+16|0;if((t[h>>2]|0)==(b|0))t[h>>2]=S;else t[c+20>>2]=S;if(!S){d=b;v=k;break}}h=t[82068]|0;if(S>>>0<h>>>0)li();t[S+24>>2]=c;m=t[e+(l+16)>>2]|0;do if(m)if(m>>>0<h>>>0)li();else{t[S+16>>2]=m;t[m+24>>2]=S;break}while(0);m=t[e+(l+20)>>2]|0;if(m)if(m>>>0<(t[82068]|0)>>>0)li();else{t[S+20>>2]=m;t[m+24>>2]=S;d=b;v=k;break}else{d=b;v=k}}else{d=b;v=k}}else{d=r;v=a}while(0);if(d>>>0>=o>>>0)li();r=e+(a+-4)|0;S=t[r>>2]|0;if(!(S&1))li();if(!(S&2)){if((o|0)==(t[82070]|0)){n=(t[82067]|0)+v|0;t[82067]=n;t[82070]=d;t[d+4>>2]=n|1;if((d|0)!=(t[82069]|0)){s=i;return}t[82069]=0;t[82066]=0;s=i;return}if((o|0)==(t[82069]|0)){n=(t[82066]|0)+v|0;t[82066]=n;t[82069]=d;t[d+4>>2]=n|1;t[d+n>>2]=n;s=i;return}n=(S&-8)+v|0;g=S>>>3;do if(S>>>0>=256){y=t[e+(a+16)>>2]|0;_=t[e+(a|4)>>2]|0;do if((_|0)==(o|0)){u=e+(a+12)|0;f=t[u>>2]|0;if(!f){m=e+(a+8)|0;h=t[m>>2]|0;if(!h){F=0;break}else{O=h;A=m}}else{O=f;A=u}while(1){u=O+20|0;f=t[u>>2]|0;if(f){O=f;A=u;continue}u=O+16|0;f=t[u>>2]|0;if(!f)break;else{O=f;A=u}}if(A>>>0<(t[82068]|0)>>>0)li();else{t[A>>2]=0;F=O;break}}else{u=t[e+a>>2]|0;if(u>>>0<(t[82068]|0)>>>0)li();f=u+12|0;if((t[f>>2]|0)!=(o|0))li();m=_+8|0;if((t[m>>2]|0)==(o|0)){t[f>>2]=_;t[m>>2]=u;F=_;break}else li()}while(0);if(y){_=t[e+(a+20)>>2]|0;k=328560+(_<<2)|0;if((o|0)==(t[k>>2]|0)){t[k>>2]=F;if(!F){t[82065]=t[82065]&~(1<<_);break}}else{if(y>>>0<(t[82068]|0)>>>0)li();_=y+16|0;if((t[_>>2]|0)==(o|0))t[_>>2]=F;else t[y+20>>2]=F;if(!F)break}_=t[82068]|0;if(F>>>0<_>>>0)li();t[F+24>>2]=y;k=t[e+(a+8)>>2]|0;do if(k)if(k>>>0<_>>>0)li();else{t[F+16>>2]=k;t[k+24>>2]=F;break}while(0);k=t[e+(a+12)>>2]|0;if(k)if(k>>>0<(t[82068]|0)>>>0)li();else{t[F+20>>2]=k;t[k+24>>2]=F;break}}}else{k=t[e+a>>2]|0;_=t[e+(a|4)>>2]|0;y=328296+(g<<1<<2)|0;if((k|0)!=(y|0)){if(k>>>0<(t[82068]|0)>>>0)li();if((t[k+12>>2]|0)!=(o|0))li()}if((_|0)==(k|0)){t[82064]=t[82064]&~(1<<g);break}if((_|0)!=(y|0)){if(_>>>0<(t[82068]|0)>>>0)li();y=_+8|0;if((t[y>>2]|0)==(o|0))M=y;else li()}else M=_+8|0;t[k+12>>2]=_;t[M>>2]=k}while(0);t[d+4>>2]=n|1;t[d+n>>2]=n;if((d|0)==(t[82069]|0)){t[82066]=n;s=i;return}else R=n}else{t[r>>2]=S&-2;t[d+4>>2]=v|1;t[d+v>>2]=v;R=v}v=R>>>3;if(R>>>0<256){S=v<<1;r=328296+(S<<2)|0;n=t[82064]|0;M=1<<v;if(n&M){v=328296+(S+2<<2)|0;o=t[v>>2]|0;if(o>>>0<(t[82068]|0)>>>0)li();else{N=v;T=o}}else{t[82064]=n|M;N=328296+(S+2<<2)|0;T=r}t[N>>2]=d;t[T+12>>2]=d;t[d+8>>2]=T;t[d+12>>2]=r;s=i;return}r=R>>>8;if(r)if(R>>>0>16777215)L=31;else{T=(r+1048320|0)>>>16&8;N=r<<T;r=(N+520192|0)>>>16&4;S=N<<r;N=(S+245760|0)>>>16&2;M=14-(r|T|N)+(S<<N>>>15)|0;L=R>>>(M+7|0)&1|M<<1}else L=0;M=328560+(L<<2)|0;t[d+28>>2]=L;t[d+20>>2]=0;t[d+16>>2]=0;N=t[82065]|0;S=1<<L;e:do if(N&S){T=t[M>>2]|0;
	if((L|0)==31)D=0;else D=25-(L>>>1)|0;i:do if((t[T+4>>2]&-8|0)!=(R|0)){r=R<<D;n=T;while(1){C=n+(r>>>31<<2)+16|0;o=t[C>>2]|0;if(!o)break;if((t[o+4>>2]&-8|0)==(R|0)){P=o;break i}else{r=r<<1;n=o}}if(C>>>0<(t[82068]|0)>>>0)li();else{t[C>>2]=d;t[d+24>>2]=n;t[d+12>>2]=d;t[d+8>>2]=d;break e}}else P=T;while(0);T=P+8|0;r=t[T>>2]|0;o=t[82068]|0;if(P>>>0>=o>>>0&r>>>0>=o>>>0){t[r+12>>2]=d;t[T>>2]=d;t[d+8>>2]=r;t[d+12>>2]=P;t[d+24>>2]=0;break}else li()}else{t[82065]=N|S;t[M>>2]=d;t[d+24>>2]=M;t[d+12>>2]=d;t[d+8>>2]=d}while(0);d=(t[82072]|0)+-1|0;t[82072]=d;if(!d)B=328712|0;else{s=i;return}while(1){d=t[B>>2]|0;if(!d)break;else B=d+8|0}t[82072]=-1;s=i;return}function Jq(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;do if(e){if(i>>>0>4294967231){t[(ii()|0)>>2]=12;n=0;break}if(i>>>0<11)f=16;else f=i+11&-8;u=TY(e+-8|0,f)|0;if(u){n=u+8|0;break}u=Xq(i)|0;if(!u)n=0;else{a=t[e+-4>>2]|0;o=(a&-8)-((a&3|0)==0?8:4)|0;YY(u|0,e|0,(o>>>0<i>>>0?o:i)|0)|0;Zq(e);n=u}}else n=Xq(i)|0;while(0);s=r;return n|0}function Qq(e){e=e|0;return(e+-48|0)>>>0<10|0}function $q(e){e=e|0;var i=0;if((e|0)==32)i=1;else i=(e+-9|0)>>>0<5;return i&1|0}function eY(e,i,r,f,a){e=e|0;i=i|0;r=r|0;f=f|0;a=a|0;var o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,ue=0;o=s;if(i>>>0>36){t[(ii()|0)>>2]=22;c=0;l=0;P=c;s=o;return l|0}b=e+4|0;k=e+100|0;do{h=t[b>>2]|0;if(h>>>0<(t[k>>2]|0)>>>0){t[b>>2]=h+1;w=u[h>>0]|0}else w=nY(e)|0}while(($q(w)|0)!=0);do if((w|0)==43|(w|0)==45){h=((w|0)==45)<<31>>31;d=t[b>>2]|0;if(d>>>0<(t[k>>2]|0)>>>0){t[b>>2]=d+1;v=u[d>>0]|0;m=h;break}else{v=nY(e)|0;m=h;break}}else{v=w;m=0}while(0);w=(i|0)==0;do if((i&-17|0)==0&(v|0)==48){h=t[b>>2]|0;if(h>>>0<(t[k>>2]|0)>>>0){t[b>>2]=h+1;_=u[h>>0]|0}else _=nY(e)|0;if((_|32|0)!=120)if(w){p=8;E=_;S=46;break}else{g=i;y=_;S=32;break}h=t[b>>2]|0;if(h>>>0<(t[k>>2]|0)>>>0){t[b>>2]=h+1;F=u[h>>0]|0}else F=nY(e)|0;if((u[F+328753>>0]|0)>15){h=(t[k>>2]|0)==0;if(!h)t[b>>2]=(t[b>>2]|0)+-1;if(!r){rY(e,0);c=0;l=0;P=c;s=o;return l|0}if(h){c=0;l=0;P=c;s=o;return l|0}t[b>>2]=(t[b>>2]|0)+-1;c=0;l=0;P=c;s=o;return l|0}else{p=16;E=F;S=46}}else{h=w?10:i;if((u[v+328753>>0]|0)>>>0<h>>>0){g=h;y=v;S=32}else{if(t[k>>2]|0)t[b>>2]=(t[b>>2]|0)+-1;rY(e,0);t[(ii()|0)>>2]=22;c=0;l=0;P=c;s=o;return l|0}}while(0);if((S|0)==32)if((g|0)==10){v=y+-48|0;if(v>>>0<10){i=v;v=0;do{v=(v*10|0)+i|0;w=t[b>>2]|0;if(w>>>0<(t[k>>2]|0)>>>0){t[b>>2]=w+1;O=u[w>>0]|0}else O=nY(e)|0;i=O+-48|0}while(i>>>0<10&v>>>0<429496729);A=v;M=0;R=O}else{A=0;M=0;R=y}O=R+-48|0;if(O>>>0<10){v=A;i=M;w=O;O=R;while(1){R=$Y(v|0,i|0,10,0)|0;F=P;r=((w|0)<0)<<31>>31;_=~r;if(F>>>0>_>>>0|(F|0)==(_|0)&R>>>0>~w>>>0){N=w;T=v;L=i;D=O;break}_=jY(R|0,F|0,w|0,r|0)|0;r=P;F=t[b>>2]|0;if(F>>>0<(t[k>>2]|0)>>>0){t[b>>2]=F+1;C=u[F>>0]|0}else C=nY(e)|0;F=C+-48|0;if(F>>>0<10&(r>>>0<429496729|(r|0)==429496729&_>>>0<2576980378)){v=_;i=r;w=F;O=C}else{N=F;T=_;L=r;D=C;break}}if(N>>>0>9){B=L;I=T}else{H=10;x=T;U=L;z=D;S=72}}else{B=M;I=A}}else{p=g;E=y;S=46}e:do if((S|0)==46){if(!(p+-1&p)){y=n[329016+((p*23|0)>>>5&7)>>0]|0;g=n[E+328753>>0]|0;A=g&255;if(A>>>0<p>>>0){M=A;A=0;do{A=M|A<<y;D=t[b>>2]|0;if(D>>>0<(t[k>>2]|0)>>>0){t[b>>2]=D+1;j=u[D>>0]|0}else j=nY(e)|0;V=n[j+328753>>0]|0;M=V&255}while(M>>>0<p>>>0&A>>>0<134217728);q=V;Y=0;G=A;W=j}else{q=g;Y=0;G=0;W=E}M=qY(-1,-1,y|0)|0;D=P;if((q&255)>>>0>=p>>>0|(Y>>>0>D>>>0|(Y|0)==(D|0)&G>>>0>M>>>0)){H=p;x=G;U=Y;z=W;S=72;break}else{K=G;X=Y;Z=q}while(1){L=UY(K|0,X|0,y|0)|0;T=P;N=Z&255|L;L=t[b>>2]|0;if(L>>>0<(t[k>>2]|0)>>>0){t[b>>2]=L+1;J=u[L>>0]|0}else J=nY(e)|0;Z=n[J+328753>>0]|0;if((Z&255)>>>0>=p>>>0|(T>>>0>D>>>0|(T|0)==(D|0)&N>>>0>M>>>0)){H=p;x=N;U=T;z=J;S=72;break e}else{K=N;X=T}}}M=n[E+328753>>0]|0;D=M&255;if(D>>>0<p>>>0){y=D;D=0;do{D=y+(te(D,p)|0)|0;g=t[b>>2]|0;if(g>>>0<(t[k>>2]|0)>>>0){t[b>>2]=g+1;Q=u[g>>0]|0}else Q=nY(e)|0;$=n[Q+328753>>0]|0;y=$&255}while(y>>>0<p>>>0&D>>>0<119304647);ee=$;ie=D;re=0;ne=Q}else{ee=M;ie=0;re=0;ne=E}if((ee&255)>>>0<p>>>0){y=eG(-1,-1,p|0,0)|0;g=P;A=re;T=ie;N=ee;L=ne;while(1){if(A>>>0>g>>>0|(A|0)==(g|0)&T>>>0>y>>>0){H=p;x=T;U=A;z=L;S=72;break e}C=$Y(T|0,A|0,p|0,0)|0;O=P;w=N&255;if(O>>>0>4294967295|(O|0)==-1&C>>>0>~w>>>0){H=p;x=T;U=A;z=L;S=72;break e}i=jY(w|0,0,C|0,O|0)|0;O=P;C=t[b>>2]|0;if(C>>>0<(t[k>>2]|0)>>>0){t[b>>2]=C+1;fe=u[C>>0]|0}else fe=nY(e)|0;N=n[fe+328753>>0]|0;if((N&255)>>>0>=p>>>0){H=p;x=i;U=O;z=fe;S=72;break}else{A=O;T=i;L=fe}}}else{H=p;x=ie;U=re;z=ne;S=72}}while(0);if((S|0)==72)if((u[z+328753>>0]|0)>>>0<H>>>0){do{z=t[b>>2]|0;if(z>>>0<(t[k>>2]|0)>>>0){t[b>>2]=z+1;ue=u[z>>0]|0}else ue=nY(e)|0}while((u[ue+328753>>0]|0)>>>0<H>>>0);t[(ii()|0)>>2]=34;B=a;I=f}else{B=U;I=x}if(t[k>>2]|0)t[b>>2]=(t[b>>2]|0)+-1;if(!(B>>>0<a>>>0|(B|0)==(a|0)&I>>>0<f>>>0)){if(!((f&1|0)!=0|0!=0|(m|0)!=0)){t[(ii()|0)>>2]=34;b=jY(f|0,a|0,-1,-1)|0;c=P;l=b;P=c;s=o;return l|0}if(B>>>0>a>>>0|(B|0)==(a|0)&I>>>0>f>>>0){t[(ii()|0)>>2]=34;c=a;l=f;P=c;s=o;return l|0}}f=((m|0)<0)<<31>>31;a=BY(I^m|0,B^f|0,m|0,f|0)|0;c=P;l=a;P=c;s=o;return l|0}function iY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0,ke=0,he=0,we=0,de=0,ve=0,me=0,_e=0,pe=0,Ee=0,Se=0,ge=0,ye=0,Fe=0,Oe=0,Ae=0,Me=0,Re=0,Ne=0,Te=0,Le=0,De=0,Ce=0,Pe=0,Be=0,Ie=0,He=0,xe=0,Ue=0,ze=0,je=0,Ve=0,qe=0,Ye=0,Ge=0,We=0,Ke=0,Xe=0,Ze=0,Je=0,Qe=0,$e=0,ei=0,ri=0,ni=0,fi=0,ti=0,ui=0,ai=0,oi=0,ci=0,li=0,si=0,bi=0,ki=0,hi=0,wi=0,di=0,vi=0,mi=0,_i=0,pi=0,Ei=0,Si=0,gi=0,yi=0,Fi=0,Oi=0,Ai=0,Mi=0,Ri=0,Ni=0,Ti=0,Li=0,Di=0,Ci=0,Pi=0,Bi=0,Ii=0,Hi=0,xi=0,Ui=0,zi=0,ji=0,Vi=0,qi=0,Yi=0,Gi=0,Wi=0,Ki=0,Xi=0,Zi=0,Ji=0,Qi=0,$i=0,er=0,ir=0,rr=0,nr=0,fr=0,tr=0,ur=0,ar=0,or=0,cr=0,lr=0,sr=0,br=0,kr=0,hr=0,wr=0,dr=0,vr=0,mr=0,_r=0,pr=0,Er=0,Sr=0,gr=0,yr=0,Fr=0,Or=0,Ar=0,Mr=0,Rr=0,Nr=0,Tr=0,Lr=0,Dr=0,Cr=0,Pr=0,Br=0,Ir=0,Hr=0,xr=0,Ur=0,zr=0,jr=0,Vr=0,qr=0,Yr=0,Gr=0,Wr=0,Kr=0;f=s;s=s+512|0;a=f;if(!i){o=24;c=-149}else if((i|0)==1){o=53;c=-1074}else if((i|0)==2){o=53;c=-1074}else{l=0;s=f;return+l}i=e+4|0;b=e+100|0;do{k=t[i>>2]|0;if(k>>>0<(t[b>>2]|0)>>>0){t[i>>2]=k+1;h=u[k>>0]|0}else h=nY(e)|0}while(($q(h)|0)!=0);do if((h|0)==43|(h|0)==45){k=1-(((h|0)==45&1)<<1)|0;w=t[i>>2]|0;if(w>>>0<(t[b>>2]|0)>>>0){t[i>>2]=w+1;d=u[w>>0]|0;v=k;break}else{d=nY(e)|0;v=k;break}}else{d=h;v=1}while(0);h=d;d=0;while(1){if((h|32|0)!=(n[329032+d>>0]|0)){m=h;_=d;break}do if(d>>>0<7){k=t[i>>2]|0;if(k>>>0<(t[b>>2]|0)>>>0){t[i>>2]=k+1;p=u[k>>0]|0;break}else{p=nY(e)|0;break}}else p=h;while(0);k=d+1|0;if(k>>>0<8){h=p;d=k}else{m=p;_=k;break}}do if((_|0)==3)E=23;else if((_|0)!=8){p=(r|0)!=0;if(_>>>0>3&p)if((_|0)==8)break;else{E=23;break}e:do if(!_){d=m;h=0;while(1){if((d|32|0)!=(n[329048+h>>0]|0)){S=d;g=h;break e}do if(h>>>0<2){k=t[i>>2]|0;if(k>>>0<(t[b>>2]|0)>>>0){t[i>>2]=k+1;O=u[k>>0]|0;break}else{O=nY(e)|0;break}}else O=d;while(0);k=h+1|0;if(k>>>0<3){d=O;h=k}else{S=O;g=k;break}}}else{S=m;g=_}while(0);if((g|0)==3){h=t[i>>2]|0;if(h>>>0<(t[b>>2]|0)>>>0){t[i>>2]=h+1;A=u[h>>0]|0}else A=nY(e)|0;if((A|0)==40)M=1;else{if(!(t[b>>2]|0)){l=y;s=f;return+l}t[i>>2]=(t[i>>2]|0)+-1;l=y;s=f;return+l}while(1){h=t[i>>2]|0;if(h>>>0<(t[b>>2]|0)>>>0){t[i>>2]=h+1;R=u[h>>0]|0}else R=nY(e)|0;if(!((R+-48|0)>>>0<10|(R+-65|0)>>>0<26)?!((R+-97|0)>>>0<26|(R|0)==95):0)break;M=M+1|0}if((R|0)==41){l=y;s=f;return+l}h=(t[b>>2]|0)==0;if(!h)t[i>>2]=(t[i>>2]|0)+-1;if(!p){t[(ii()|0)>>2]=22;rY(e,0);l=0;s=f;return+l}if((M|0)==0|h){l=y;s=f;return+l}else N=M;do{N=N+-1|0;t[i>>2]=(t[i>>2]|0)+-1}while((N|0)!=0);l=y;s=f;return+l}else if(!g){do if((S|0)==48){p=t[i>>2]|0;if(p>>>0<(t[b>>2]|0)>>>0){t[i>>2]=p+1;T=u[p>>0]|0}else T=nY(e)|0;if((T|32|0)!=120){if(!(t[b>>2]|0)){L=48;break}t[i>>2]=(t[i>>2]|0)+-1;L=48;break}p=t[i>>2]|0;if(p>>>0<(t[b>>2]|0)>>>0){t[i>>2]=p+1;D=u[p>>0]|0;C=0}else{D=nY(e)|0;C=0}while(1){if((D|0)==46){E=70;break}else if((D|0)!=48){B=0;I=0;H=0;x=0;U=D;z=C;j=0;V=0;q=1;Y=0;W=0;break}p=t[i>>2]|0;if(p>>>0<(t[b>>2]|0)>>>0){t[i>>2]=p+1;D=u[p>>0]|0;C=1;continue}else{D=nY(e)|0;C=1;continue}}if((E|0)==70){p=t[i>>2]|0;if(p>>>0<(t[b>>2]|0)>>>0){t[i>>2]=p+1;K=u[p>>0]|0}else K=nY(e)|0;if((K|0)==48){p=0;h=0;while(1){d=t[i>>2]|0;if(d>>>0<(t[b>>2]|0)>>>0){t[i>>2]=d+1;X=u[d>>0]|0}else X=nY(e)|0;d=jY(p|0,h|0,-1,-1)|0;k=P;if((X|0)==48){p=d;h=k}else{B=0;I=0;H=d;x=k;U=X;z=1;j=1;V=0;q=1;Y=0;W=0;break}}}else{B=0;I=0;H=0;x=0;U=K;z=C;j=1;V=0;q=1;Y=0;W=0}}e:while(1){h=U+-48|0;do if(h>>>0>=10){p=U|32;k=(U|0)==46;if(!((p+-97|0)>>>0<6|k)){Z=U;break e}if(k)if(!j){J=I;Q=B;$=I;ee=B;ie=z;re=1;ne=V;fe=q;ue=Y;ae=W;break}else{Z=46;break e}else{oe=(U|0)>57?p+-87|0:h;E=83;break}}else{oe=h;E=83}while(0);if((E|0)==83){E=0;do if(!((B|0)<0|(B|0)==0&I>>>0<8)){if((B|0)<0|(B|0)==0&I>>>0<14){ce=q*.0625;le=V;se=ce;be=Y;ke=W+ce*+(oe|0);break}if((oe|0)==0|(V|0)!=0){le=V;se=q;be=Y;ke=W}else{le=1;se=q;be=Y;ke=W+q*.5}}else{le=V;se=q;be=oe+(Y<<4)|0;ke=W}while(0);h=jY(I|0,B|0,1,0)|0;J=H;Q=x;$=h;ee=P;ie=1;re=j;ne=le;fe=se;ue=be;ae=ke}h=t[i>>2]|0;if(h>>>0<(t[b>>2]|0)>>>0){t[i>>2]=h+1;B=ee;I=$;H=J;x=Q;U=u[h>>0]|0;z=ie;j=re;V=ne;q=fe;Y=ue;W=ae;continue}else{B=ee;I=$;H=J;x=Q;U=nY(e)|0;z=ie;j=re;V=ne;q=fe;Y=ue;W=ae;continue}}if(!z){h=(t[b>>2]|0)==0;if(!h)t[i>>2]=(t[i>>2]|0)+-1;if(r){if(!h?(h=t[i>>2]|0,t[i>>2]=h+-1,(j|0)!=0):0)t[i>>2]=h+-2}else rY(e,0);l=+(v|0)*0;s=f;return+l}h=(j|0)==0;p=h?I:H;k=h?B:x;if((B|0)<0|(B|0)==0&I>>>0<8){h=I;d=B;w=Y;while(1){he=w<<4;h=jY(h|0,d|0,1,0)|0;d=P;if(!((d|0)<0|(d|0)==0&h>>>0<8)){we=he;break}else w=he}}else we=Y;do if((Z|32|0)==112){w=DY(e,r)|0;h=P;if((w|0)==0&(h|0)==-2147483648)if(!r){rY(e,0);l=0;s=f;return+l}else{if(!(t[b>>2]|0)){de=0;ve=0;break}t[i>>2]=(t[i>>2]|0)+-1;de=0;ve=0;break}else{de=w;ve=h}}else if(!(t[b>>2]|0)){de=0;ve=0}else{t[i>>2]=(t[i>>2]|0)+-1;de=0;ve=0}while(0);h=UY(p|0,k|0,2)|0;w=jY(h|0,P|0,-32,-1)|0;h=jY(w|0,P|0,de|0,ve|0)|0;w=P;if(!we){l=+(v|0)*0;s=f;return+l}if((w|0)>0|(w|0)==0&h>>>0>(0-c|0)>>>0){t[(ii()|0)>>2]=34;l=+(v|0)*1.7976931348623157e308*1.7976931348623157e308;s=f;return+l}d=c+-106|0;he=((d|0)<0)<<31>>31;if((w|0)<(he|0)|(w|0)==(he|0)&h>>>0<d>>>0){t[(ii()|0)>>2]=34;l=+(v|0)*2.2250738585072014e-308*2.2250738585072014e-308;s=f;return+l}if((we|0)>-1){d=h;he=w;me=we;ce=W;while(1){_e=me<<1;if(!(ce>=.5)){pe=ce;Ee=_e}else{pe=ce+-1;Ee=_e|1}Se=ce+pe;_e=jY(d|0,he|0,-1,-1)|0;ge=P;if((Ee|0)>-1){d=_e;he=ge;me=Ee;ce=Se}else{ye=_e;Fe=ge;Oe=Ee;Ae=Se;break}}}else{ye=h;Fe=w;Oe=we;Ae=W}me=BY(32,0,c|0,((c|0)<0)<<31>>31|0)|0;he=jY(ye|0,Fe|0,me|0,P|0)|0;me=P;if(0>(me|0)|0==(me|0)&o>>>0>he>>>0)if((he|0)<0){Me=0;E=126}else{Re=he;E=124}else{Re=o;E=124}if((E|0)==124)if((Re|0)<53){Me=Re;E=126}else{Ne=Re;Te=+(v|0);Le=0}if((E|0)==126){ce=+(v|0);Ne=Me;Te=ce;Le=+uY(+kY(1,84-Me|0),ce)}he=(Ne|0)<32&Ae!=0&(Oe&1|0)==0;ce=Te*(he?0:Ae)+(Le+Te*+(((he&1)+Oe|0)>>>0))-Le;if(!(ce!=0))t[(ii()|0)>>2]=34;l=+hY(ce,ye);s=f;return+l}else L=S;while(0);he=c+o|0;me=0-he|0;d=L;k=0;while(1){if((d|0)==46){E=137;break}else if((d|0)!=48){De=d;Ce=0;Pe=0;Be=k;Ie=0;break}p=t[i>>2]|0;if(p>>>0<(t[b>>2]|0)>>>0){t[i>>2]=p+1;d=u[p>>0]|0;k=1;continue}else{d=nY(e)|0;k=1;continue}}if((E|0)==137){d=t[i>>2]|0;if(d>>>0<(t[b>>2]|0)>>>0){t[i>>2]=d+1;He=u[d>>0]|0}else He=nY(e)|0;if((He|0)==48){d=0;p=0;while(1){ge=jY(d|0,p|0,-1,-1)|0;_e=P;xe=t[i>>2]|0;if(xe>>>0<(t[b>>2]|0)>>>0){t[i>>2]=xe+1;Ue=u[xe>>0]|0}else Ue=nY(e)|0;if((Ue|0)==48){d=ge;p=_e}else{De=Ue;Ce=ge;Pe=_e;Be=1;Ie=1;break}}}else{De=He;Ce=0;Pe=0;Be=k;Ie=1}}t[a>>2]=0;p=De+-48|0;d=(De|0)==46;e:do if(p>>>0<10|d){_e=a+496|0;ge=De;xe=0;ze=0;je=d;Ve=p;qe=Ce;Ye=Pe;Ge=Be;We=Ie;Ke=0;Xe=0;Ze=0;i:while(1){do if(je)if(!We){Je=xe;Qe=ze;$e=xe;ei=ze;ri=Ge;ni=1;fi=Ke;ti=Xe;ui=Ze}else break i;else{ai=jY(xe|0,ze|0,1,0)|0;oi=P;ci=(ge|0)!=48;if((Xe|0)>=125){if(!ci){Je=qe;Qe=Ye;$e=ai;ei=oi;ri=Ge;ni=We;fi=Ke;ti=Xe;ui=Ze;break}t[_e>>2]=t[_e>>2]|1;Je=qe;Qe=Ye;$e=ai;ei=oi;ri=Ge;ni=We;fi=Ke;ti=Xe;ui=Ze;break}li=a+(Xe<<2)|0;if(!Ke)si=Ve;else si=ge+-48+((t[li>>2]|0)*10|0)|0;t[li>>2]=si;li=Ke+1|0;bi=(li|0)==9;Je=qe;Qe=Ye;$e=ai;ei=oi;ri=1;ni=We;fi=bi?0:li;ti=(bi&1)+Xe|0;ui=ci?ai:Ze}while(0);ai=t[i>>2]|0;if(ai>>>0<(t[b>>2]|0)>>>0){t[i>>2]=ai+1;ki=u[ai>>0]|0}else ki=nY(e)|0;Ve=ki+-48|0;je=(ki|0)==46;if(!(Ve>>>0<10|je)){hi=ki;wi=Je;di=$e;vi=Qe;mi=ei;_i=ri;pi=ni;Ei=fi;Si=ti;gi=ui;E=160;break e}else{ge=ki;xe=$e;ze=ei;qe=Je;Ye=Qe;Ge=ri;We=ni;Ke=fi;Xe=ti;Ze=ui}}yi=xe;Fi=ze;Oi=qe;Ai=Ye;Mi=(Ge|0)!=0;Ri=Ke;Ni=Xe;Ti=Ze;E=168}else{hi=De;wi=Ce;di=0;vi=Pe;mi=0;_i=Be;pi=Ie;Ei=0;Si=0;gi=0;E=160}while(0);do if((E|0)==160){p=(pi|0)==0;d=p?di:wi;k=p?mi:vi;p=(_i|0)!=0;if(!(p&(hi|32|0)==101))if((hi|0)>-1){yi=di;Fi=mi;Oi=d;Ai=k;Mi=p;Ri=Ei;Ni=Si;Ti=gi;E=168;break}else{Li=di;Di=mi;Ci=p;Pi=d;Bi=k;Ii=Ei;Hi=Si;xi=gi;E=170;break}p=DY(e,r)|0;We=P;do if((p|0)==0&(We|0)==-2147483648)if(!r){rY(e,0);l=0;s=f;return+l}else{if(!(t[b>>2]|0)){Ui=0;zi=0;break}t[i>>2]=(t[i>>2]|0)+-1;Ui=0;zi=0;break}else{Ui=p;zi=We}while(0);We=jY(Ui|0,zi|0,d|0,k|0)|0;ji=We;Vi=di;qi=P;Yi=mi;Gi=Ei;Wi=Si;Ki=gi}while(0);if((E|0)==168)if(t[b>>2]|0){t[i>>2]=(t[i>>2]|0)+-1;if(Mi){ji=Oi;Vi=yi;qi=Ai;Yi=Fi;Gi=Ri;Wi=Ni;Ki=Ti}else E=171}else{Li=yi;Di=Fi;Ci=Mi;Pi=Oi;Bi=Ai;Ii=Ri;Hi=Ni;xi=Ti;E=170}if((E|0)==170)if(Ci){ji=Pi;Vi=Li;qi=Bi;Yi=Di;Gi=Ii;Wi=Hi;Ki=xi}else E=171;if((E|0)==171){t[(ii()|0)>>2]=22;rY(e,0);l=0;s=f;return+l}We=t[a>>2]|0;if(!We){l=+(v|0)*0;s=f;return+l}if((ji|0)==(Vi|0)&(qi|0)==(Yi|0)&((Yi|0)<0|(Yi|0)==0&Vi>>>0<10)?o>>>0>30|(We>>>o|0)==0:0){l=+(v|0)*+(We>>>0);s=f;return+l}We=(c|0)/-2|0;p=((We|0)<0)<<31>>31;if((qi|0)>(p|0)|(qi|0)==(p|0)&ji>>>0>We>>>0){t[(ii()|0)>>2]=34;l=+(v|0)*1.7976931348623157e308*1.7976931348623157e308;s=f;return+l}We=c+-106|0;p=((We|0)<0)<<31>>31;if((qi|0)<(p|0)|(qi|0)==(p|0)&ji>>>0<We>>>0){t[(ii()|0)>>2]=34;l=+(v|0)*2.2250738585072014e-308*2.2250738585072014e-308;s=f;return+l}if(!Gi)Xi=Wi;else{if((Gi|0)<9){We=a+(Wi<<2)|0;p=t[We>>2]|0;Ze=Gi;do{p=p*10|0;Ze=Ze+1|0}while((Ze|0)!=9);t[We>>2]=p}Xi=Wi+1|0}if((Ki|0)<9?(Ki|0)<=(ji|0)&(ji|0)<18:0){if((ji|0)==9){l=+(v|0)*+((t[a>>2]|0)>>>0);s=f;return+l}if((ji|0)<9){l=+(v|0)*+((t[a>>2]|0)>>>0)/+(t[329064+(8-ji<<2)>>2]|0);s=f;return+l}Ze=o+27+(te(ji,-3)|0)|0;Xe=t[a>>2]|0;if((Ze|0)>30|(Xe>>>Ze|0)==0){l=+(v|0)*+(Xe>>>0)*+(t[329064+(ji+-10<<2)>>2]|0);s=f;return+l}}Xe=(ji|0)%9|0;if(!Xe){Zi=0;Ji=0;Qi=ji;$i=Xi}else{Ze=(ji|0)>-1?Xe:Xe+9|0;Xe=t[329064+(8-Ze<<2)>>2]|0;if(Xi){Ke=1e9/(Xe|0)|0;Ge=0;Ye=0;qe=0;ze=ji;while(1){xe=a+(qe<<2)|0;ge=t[xe>>2]|0;je=((ge>>>0)/(Xe>>>0)|0)+Ye|0;t[xe>>2]=je;Ye=te((ge>>>0)%(Xe>>>0)|0,Ke)|0;ge=qe;qe=qe+1|0;if((ge|0)==(Ge|0)&(je|0)==0){er=qe&127;ir=ze+-9|0}else{er=Ge;ir=ze}if((qe|0)==(Xi|0))break;else{Ge=er;ze=ir}}if(!Ye){rr=er;nr=ir;fr=Xi}else{t[a+(Xi<<2)>>2]=Ye;rr=er;nr=ir;fr=Xi+1|0}}else{rr=0;nr=ji;fr=0}Zi=rr;Ji=0;Qi=9-Ze+nr|0;$i=fr}e:while(1){ze=a+(Zi<<2)|0;if((Qi|0)<18){Ge=Ji;qe=$i;while(1){Ke=0;Xe=qe+127|0;p=qe;while(1){We=Xe&127;je=a+(We<<2)|0;ge=UY(t[je>>2]|0,0,29)|0;xe=jY(ge|0,P|0,Ke|0,0)|0;ge=P;if(ge>>>0>0|(ge|0)==0&xe>>>0>1e9){Ve=eG(xe|0,ge|0,1e9,0)|0;_e=iG(xe|0,ge|0,1e9,0)|0;tr=_e;ur=Ve}else{tr=xe;ur=0}t[je>>2]=tr;je=(We|0)==(Zi|0);if((We|0)!=(p+127&127|0)|je)ar=p;else ar=(tr|0)==0?We:p;if(je)break;else{Ke=ur;Xe=We+-1|0;p=ar}}p=Ge+-29|0;if(!ur){Ge=p;qe=ar}else{or=p;cr=ur;lr=ar;break}}}else{if((Qi|0)==18){sr=Ji;br=$i}else{kr=Zi;hr=Ji;wr=Qi;dr=$i;break}while(1){if((t[ze>>2]|0)>>>0>=9007199){kr=Zi;hr=sr;wr=18;dr=br;break e}qe=0;Ge=br+127|0;k=br;while(1){d=Ge&127;p=a+(d<<2)|0;Xe=UY(t[p>>2]|0,0,29)|0;Ke=jY(Xe|0,P|0,qe|0,0)|0;Xe=P;if(Xe>>>0>0|(Xe|0)==0&Ke>>>0>1e9){We=eG(Ke|0,Xe|0,1e9,0)|0;je=iG(Ke|0,Xe|0,1e9,0)|0;vr=je;mr=We}else{vr=Ke;mr=0}t[p>>2]=vr;p=(d|0)==(Zi|0);if((d|0)!=(k+127&127|0)|p)_r=k;else _r=(vr|0)==0?d:k;if(p)break;else{qe=mr;Ge=d+-1|0;k=_r}}k=sr+-29|0;if(!mr){sr=k;br=_r}else{or=k;cr=mr;lr=_r;break}}}ze=Zi+127&127;if((ze|0)==(lr|0)){k=lr+127&127;Ge=a+((lr+126&127)<<2)|0;t[Ge>>2]=t[Ge>>2]|t[a+(k<<2)>>2];pr=k}else pr=lr;t[a+(ze<<2)>>2]=cr;Zi=ze;Ji=or;Qi=Qi+9|0;$i=pr}e:while(1){Er=dr+1&127;Ze=a+((dr+127&127)<<2)|0;Ye=kr;ze=hr;k=wr;while(1){Ge=(k|0)==18;qe=(k|0)>27?9:1;Sr=Ye;gr=ze;while(1){d=0;while(1){p=d+Sr&127;if((p|0)==(dr|0)){yr=2;break}Ke=t[a+(p<<2)>>2]|0;p=t[329056+(d<<2)>>2]|0;if(Ke>>>0<p>>>0){yr=2;break}We=d+1|0;if(Ke>>>0>p>>>0){yr=d;break}if((We|0)<2)d=We;else{yr=We;break}}if((yr|0)==2&Ge)break e;Fr=qe+gr|0;if((Sr|0)==(dr|0)){Sr=dr;gr=Fr}else break}Ge=(1<<qe)+-1|0;d=1e9>>>qe;Or=Sr;Ar=0;We=Sr;Mr=k;do{p=a+(We<<2)|0;Ke=t[p>>2]|0;je=(Ke>>>qe)+Ar|0;t[p>>2]=je;Ar=te(Ke&Ge,d)|0;Ke=(We|0)==(Or|0)&(je|0)==0;We=We+1&127;Mr=Ke?Mr+-9|0:Mr;Or=Ke?We:Or}while((We|0)!=(dr|0));if(!Ar){Ye=Or;ze=Fr;k=Mr;continue}if((Er|0)!=(Or|0))break;t[Ze>>2]=t[Ze>>2]|1;Ye=Or;ze=Fr;k=Mr}t[a+(dr<<2)>>2]=Ar;kr=Or;hr=Fr;wr=Mr;dr=Er}k=Sr&127;if((k|0)==(dr|0)){t[a+(Er+-1<<2)>>2]=0;Rr=Er}else Rr=dr;ce=+((t[a+(k<<2)>>2]|0)>>>0);k=Sr+1&127;if((k|0)==(Rr|0)){ze=Rr+1&127;t[a+(ze+-1<<2)>>2]=0;Nr=ze}else Nr=Rr;Se=+(v|0);Tr=Se*(ce*1e9+ +((t[a+(k<<2)>>2]|0)>>>0));k=gr+53|0;ze=k-c|0;if((ze|0)<(o|0))if((ze|0)<0){Lr=0;Dr=1;E=244}else{Cr=ze;Pr=1;E=243}else{Cr=o;Pr=0;E=243}if((E|0)==243)if((Cr|0)<53){Lr=Cr;Dr=Pr;E=244}else{Br=Cr;Ir=0;Hr=Pr;xr=0;Ur=Tr}if((E|0)==244){ce=+uY(+kY(1,105-Lr|0),Tr);zr=+oY(Tr,+kY(1,53-Lr|0));Br=Lr;Ir=ce;Hr=Dr;xr=zr;Ur=ce+(Tr-zr)}Ye=Sr+2&127;do if((Ye|0)==(Nr|0))jr=xr;else{Ze=t[a+(Ye<<2)>>2]|0;do if(Ze>>>0>=5e8){if(Ze>>>0>5e8){Vr=Se*.75+xr;break}if((Sr+3&127|0)==(Nr|0)){Vr=Se*.5+xr;break}else{Vr=Se*.75+xr;break}}else{if((Ze|0)==0?(Sr+3&127|0)==(Nr|0):0){Vr=xr;break}Vr=Se*.25+xr}while(0);if((53-Br|0)<=1){jr=Vr;break}if(+oY(Vr,1)!=0){jr=Vr;break}jr=Vr+1}while(0);Se=Ur+jr-Ir;do if((k&2147483647|0)>(-2-he|0)){if(!(+G(+Se)>=9007199254740992)){qr=Hr;Yr=gr;Gr=Se}else{qr=(Hr|0)!=0&(Br|0)==(ze|0)?0:Hr;Yr=gr+1|0;Gr=Se*.5}if((Yr+50|0)<=(me|0)?!((qr|0)!=0&jr!=0):0){Wr=Yr;Kr=Gr;break}t[(ii()|0)>>2]=34;Wr=Yr;Kr=Gr}else{Wr=gr;Kr=Se}while(0);l=+hY(Kr,Wr);s=f;return+l}else{if(t[b>>2]|0)t[i>>2]=(t[i>>2]|0)+-1;t[(ii()|0)>>2]=22;rY(e,0);l=0;s=f;return+l}}while(0);if((E|0)==23){E=(t[b>>2]|0)==0;if(!E)t[i>>2]=(t[i>>2]|0)+-1;if(!(_>>>0<4|(r|0)==0|E)){E=_;do{t[i>>2]=(t[i>>2]|0)+-1;E=E+-1|0}while(E>>>0>3)}}l=+(v|0)*F;s=f;return+l}function rY(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0;r=s;t[e+104>>2]=i;n=t[e+8>>2]|0;f=t[e+4>>2]|0;u=n-f|0;t[e+108>>2]=u;if((i|0)!=0&(u|0)>(i|0)){t[e+100>>2]=f+i;s=r;return}else{t[e+100>>2]=n;s=r;return}}function nY(e){e=e|0;var i=0,r=0,f=0,a=0,o=0,c=0,l=0;i=s;r=e+104|0;f=t[r>>2]|0;if(!((f|0)!=0?(t[e+108>>2]|0)>=(f|0):0))a=3;if((a|0)==3?(a=pY(e)|0,(a|0)>=0):0){f=t[r>>2]|0;r=t[e+8>>2]|0;if((f|0)!=0?(o=t[e+4>>2]|0,c=f-(t[e+108>>2]|0)+-1|0,(r-o|0)>(c|0)):0)t[e+100>>2]=o+c;else t[e+100>>2]=r;c=t[e+4>>2]|0;if(r){o=e+108|0;t[o>>2]=r+1-c+(t[o>>2]|0)}o=c+-1|0;if((u[o>>0]|0|0)==(a|0)){l=a;s=i;return l|0}n[o>>0]=a;l=a;s=i;return l|0}t[e+100>>2]=0;l=-1;s=i;return l|0}function fY(e){e=+e;var i=0,r=0,n=0,f=0,u=0,a=0;i=s;l[k>>3]=e;r=t[k>>2]|0;n=t[k+4>>2]|0;f=qY(r|0,n|0,52)|0;u=f&2047;if((u|0)==2047){a=(r|0)==0&(n&1048575|0)==0&1;s=i;return a|0}else if(!u){a=(r|0)!=0|(n&2147483647|0)!=0?3:2;s=i;return a|0}else{a=4;s=i;return a|0}return 0}function tY(e,i){e=+e;i=+i;var r=0,n=0,f=0,u=0;r=s;l[k>>3]=e;n=t[k>>2]|0;f=t[k+4>>2]|0;l[k>>3]=i;u=t[k+4>>2]&-2147483648|f&2147483647;t[k>>2]=n;t[k+4>>2]=u;i=+l[k>>3];s=r;return+i}function uY(e,i){e=+e;i=+i;var r=0,n=0;r=s;n=+tY(e,i);s=r;return+n}function aY(e,i){e=+e;i=+i;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0;r=s;l[k>>3]=e;n=t[k>>2]|0;f=t[k+4>>2]|0;l[k>>3]=i;u=t[k>>2]|0;a=t[k+4>>2]|0;o=qY(n|0,f|0,52)|0;c=o&2047;o=qY(u|0,a|0,52)|0;b=o&2047;o=f&-2147483648;h=UY(u|0,a|0,1)|0;w=P;if(!((h|0)==0&(w|0)==0)?(d=a&2147483647,!(d>>>0>2146435072|(d|0)==2146435072&u>>>0>0|(c|0)==2047)):0){d=UY(n|0,f|0,1)|0;v=P;if(!(v>>>0>w>>>0|(v|0)==(w|0)&d>>>0>h>>>0)){if(!((d|0)==(h|0)&(v|0)==(w|0))){m=e;s=r;return+m}m=e*0;s=r;return+m}if(!c){w=UY(n|0,f|0,12)|0;v=P;if((v|0)>-1|(v|0)==-1&w>>>0>4294967295){h=w;w=v;v=0;while(1){d=v+-1|0;h=UY(h|0,w|0,1)|0;w=P;if(!((w|0)>-1|(w|0)==-1&h>>>0>4294967295)){_=d;break}else v=d}}else _=0;v=UY(n|0,f|0,1-_|0)|0;p=v;E=P;S=_}else{p=n;E=f&1048575|1048576;S=c}if(!b){c=UY(u|0,a|0,12)|0;f=P;if((f|0)>-1|(f|0)==-1&c>>>0>4294967295){n=c;c=f;f=0;while(1){_=f+-1|0;n=UY(n|0,c|0,1)|0;c=P;if(!((c|0)>-1|(c|0)==-1&n>>>0>4294967295)){g=_;break}else f=_}}else g=0;f=UY(u|0,a|0,1-g|0)|0;y=f;F=P;O=g}else{y=u;F=a&1048575|1048576;O=b}b=BY(p|0,E|0,y|0,F|0)|0;a=P;u=(a|0)>-1|(a|0)==-1&b>>>0>4294967295;e:do if((S|0)>(O|0)){g=u;f=b;n=a;c=p;_=E;v=S;while(1){if(g)if((c|0)==(y|0)&(_|0)==(F|0))break;else{A=f;M=n}else{A=c;M=_}h=UY(A|0,M|0,1)|0;w=P;d=v+-1|0;R=BY(h|0,w|0,y|0,F|0)|0;N=P;T=(N|0)>-1|(N|0)==-1&R>>>0>4294967295;if((d|0)>(O|0)){g=T;f=R;n=N;c=h;_=w;v=d}else{L=T;D=h;C=w;B=R;I=N;H=d;break e}}m=e*0;s=r;return+m}else{L=u;D=p;C=E;B=b;I=a;H=S}while(0);if(L)if((D|0)==(y|0)&(C|0)==(F|0)){m=e*0;s=r;return+m}else{x=I;U=B}else{x=C;U=D}if(x>>>0<1048576|(x|0)==1048576&U>>>0<0){D=U;C=x;B=H;while(1){I=UY(D|0,C|0,1)|0;F=P;y=B+-1|0;if(F>>>0<1048576|(F|0)==1048576&I>>>0<0){D=I;C=F;B=y}else{z=I;j=F;V=y;break}}}else{z=U;j=x;V=H}if((V|0)>0){H=jY(z|0,j|0,0,-1048576)|0;x=P;U=UY(V|0,0,52)|0;q=x|P;Y=H|U}else{U=qY(z|0,j|0,1-V|0)|0;q=P;Y=U}t[k>>2]=Y;t[k+4>>2]=q|o;m=+l[k>>3];s=r;return+m}G=e*i;m=G/G;s=r;return+m}function oY(e,i){e=+e;i=+i;var r=0,n=0;r=s;n=+aY(e,i);s=r;return+n}function cY(e,i){e=+e;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,h=0;r=s;l[k>>3]=e;n=t[k>>2]|0;f=t[k+4>>2]|0;u=qY(n|0,f|0,52)|0;a=u&2047;if(!a){if(e!=0){o=+cY(e*0x10000000000000000,i);c=o;b=(t[i>>2]|0)+-64|0}else{c=e;b=0}t[i>>2]=b;h=c;s=r;return+h}else if((a|0)==2047){h=e;s=r;return+h}else{t[i>>2]=a+-1022;t[k>>2]=n;t[k+4>>2]=f&-2146435073|1071644672;h=+l[k>>3];s=r;return+h}return+0}function lY(e,i){e=+e;i=i|0;var r=0,n=0;r=s;n=+cY(e,i);s=r;return+n}function sY(e){e=+e;var i=0,r=0,n=0,f=0,u=0,a=0,o=0,c=0,b=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0;i=s;l[k>>3]=e;r=t[k>>2]|0;n=t[k+4>>2]|0;f=(n|0)<0;do if(!(n>>>0<1048576|f)){if(n>>>0>2146435071){u=e;s=i;return+u}if((n|0)==1072693248&((r|0)==0&0==0)){u=0;s=i;return+u}else{a=r;o=n;c=n;b=-1023}}else{if((r|0)==0&(n&2147483647|0)==0){u=-1/(e*e);s=i;return+u}if(!f){l[k>>3]=e*0x40000000000000;h=t[k+4>>2]|0;a=t[k>>2]|0;o=h;c=h;b=-1077;break}u=(e-e)/0;s=i;return+u}while(0);o=c+614242|0;t[k>>2]=a;t[k+4>>2]=(o&1048575)+1072079006;e=+l[k>>3]+-1;w=e*(e*.5);d=e/(e+2);v=d*d;m=v*v;l[k>>3]=e-w;a=t[k+4>>2]|0;t[k>>2]=0;t[k+4>>2]=a;_=+l[k>>3];p=d*(w+(m*(m*(m*.15313837699209373+.22222198432149784)+.3999999999940942)+v*(m*(m*(m*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+(e-_-w);w=_*.4342944818781689;e=+(b+(o>>>20)|0);m=e*.30102999566361177;v=m+w;u=v+(w+(m-v)+(p*.4342944818781689+(e*3.694239077158931e-13+(_+p)*2.5082946711645275e-11)));s=i;return+u}function bY(e){e=e|0;return+y}function kY(e,i){e=+e;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0;r=s;if((i|0)>1023){n=e*8.98846567431158e307;f=i+-1023|0;if((f|0)>1023){u=i+-2046|0;a=(u|0)>1023?1023:u;o=n*8.98846567431158e307}else{a=f;o=n}}else if((i|0)<-1022){n=e*2.2250738585072014e-308;f=i+1022|0;if((f|0)<-1022){u=i+2044|0;a=(u|0)<-1022?-1022:u;o=n*2.2250738585072014e-308}else{a=f;o=n}}else{a=i;o=e}i=UY(a+1023|0,0,52)|0;a=P;t[k>>2]=i;t[k+4>>2]=a;e=o*+l[k>>3];s=r;return+e}function hY(e,i){e=+e;i=i|0;var r=0,n=0;r=s;n=+kY(e,i);s=r;return+n}function wY(e,i){e=e|0;i=i|0;var r=0,n=0;r=s;if(!e)n=0;else n=dY(e,i,0)|0;s=r;return n|0}function dY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0;r=s;if(!e){f=1;s=r;return f|0}if(i>>>0<128){n[e>>0]=i;f=1;s=r;return f|0}if(i>>>0<2048){n[e>>0]=i>>>6|192;n[e+1>>0]=i&63|128;f=2;s=r;return f|0}if(i>>>0<55296|(i&-8192|0)==57344){n[e>>0]=i>>>12|224;n[e+1>>0]=i>>>6&63|128;n[e+2>>0]=i&63|128;f=3;s=r;return f|0}if((i+-65536|0)>>>0<1048576){n[e>>0]=i>>>18|240;n[e+1>>0]=i>>>12&63|128;n[e+2>>0]=i>>>6&63|128;n[e+3>>0]=i&63|128;f=4;s=r;return f|0}else{t[(ii()|0)>>2]=84;f=-1;s=r;return f|0}return 0}function vY(e){e=e|0;var i=0;i=(te(t[e>>2]|0,1103515245)|0)+12345|0;t[e>>2]=i;e=i>>>11^i;i=e<<7&-1658038656^e;e=i<<15&-272236544^i;return(e>>>18^e)>>>1|0}function mY(e){e=e|0;var i=0,r=0,f=0,u=0,a=0;i=s;r=e+74|0;f=n[r>>0]|0;n[r>>0]=f+255|f;f=e+20|0;r=e+44|0;if((t[f>>2]|0)>>>0>(t[r>>2]|0)>>>0)dAi[t[e+36>>2]&511](e,0,0)|0;t[e+16>>2]=0;t[e+28>>2]=0;t[f>>2]=0;f=t[e>>2]|0;if(!(f&20)){u=t[r>>2]|0;t[e+8>>2]=u;t[e+4>>2]=u;a=0;s=i;return a|0}if(!(f&4)){a=-1;s=i;return a|0}t[e>>2]=f|32;a=-1;s=i;return a|0}function _Y(e){e=e|0;var i=0,r=0,f=0,u=0;i=s;r=e+74|0;f=n[r>>0]|0;n[r>>0]=f+255|f;f=t[e>>2]|0;if(!(f&8)){t[e+8>>2]=0;t[e+4>>2]=0;r=t[e+44>>2]|0;t[e+28>>2]=r;t[e+20>>2]=r;t[e+16>>2]=r+(t[e+48>>2]|0);u=0;s=i;return u|0}else{t[e>>2]=f|32;u=-1;s=i;return u|0}return 0}function pY(e){e=e|0;var i=0,r=0,n=0;i=s;s=s+16|0;r=i;if((t[e+8>>2]|0)==0?(mY(e)|0)!=0:0)n=-1;else if((dAi[t[e+32>>2]&511](e,r,1)|0)==1)n=u[r>>0]|0;else n=-1;s=i;return n|0}function EY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;u=r+16|0;a=t[u>>2]|0;do if(!a)if(!(_Y(r)|0)){o=t[u>>2]|0;break}else{c=0;s=f;return c|0}else o=a;while(0);a=r+20|0;u=t[a>>2]|0;if((o-u|0)>>>0<i>>>0){c=dAi[t[r+36>>2]&511](r,e,i)|0;s=f;return c|0}e:do if((n[r+75>>0]|0)>-1){o=i;while(1){if(!o){l=i;b=e;k=u;h=0;break e}w=o+-1|0;if((n[e+w>>0]|0)==10)break;else o=w}if((dAi[t[r+36>>2]&511](r,e,o)|0)>>>0<o>>>0){c=o;s=f;return c|0}else{l=i-o|0;b=e+o|0;k=t[a>>2]|0;h=o;break}}else{l=i;b=e;k=u;h=0}while(0);YY(k|0,b|0,l|0)|0;t[a>>2]=(t[a>>2]|0)+l;c=h+l|0;s=f;return c|0}function SY(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0;f=s;s=s+16|0;u=f;t[u>>2]=n;n=yY(e,i,r,u)|0;s=f;return n|0}function gY(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;n=s;s=s+224|0;f=n+120|0;u=n+80|0;a=n;o=n+136|0;c=u+0|0;l=c+40|0;do{t[c>>2]=0;c=c+4|0}while((c|0)<(l|0));t[f>>2]=t[r>>2];if((CY(0,i,f,a,u)|0)<0){b=-1;s=n;return b|0}r=e+48|0;if(!(t[r>>2]|0)){c=e+44|0;l=t[c>>2]|0;t[c>>2]=o;k=e+28|0;t[k>>2]=o;h=e+20|0;t[h>>2]=o;t[r>>2]=80;w=e+16|0;t[w>>2]=o+80;o=CY(e,i,f,a,u)|0;if(!l)d=o;else{dAi[t[e+36>>2]&511](e,0,0)|0;v=(t[h>>2]|0)==0?-1:o;t[c>>2]=l;t[r>>2]=0;t[w>>2]=0;t[k>>2]=0;t[h>>2]=0;d=v}}else d=CY(e,i,f,a,u)|0;b=d;s=n;return b|0}function yY(e,i,r,f){e=e|0;i=i|0;r=r|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;u=s;s=s+128|0;a=u+112|0;o=u;c=o+0|0;l=329664|0;b=c+112|0;do{t[c>>2]=t[l>>2];c=c+4|0;l=l+4|0}while((c|0)<(b|0));if((i+-1|0)>>>0>2147483646)if(!i){k=a;h=1}else{t[(ii()|0)>>2]=75;w=-1;s=u;return w|0}else{k=e;h=i}i=-2-k|0;e=h>>>0>i>>>0?i:h;t[o+48>>2]=e;h=o+20|0;t[h>>2]=k;t[o+44>>2]=k;i=k+e|0;k=o+16|0;t[k>>2]=i;t[o+28>>2]=i;i=gY(o,r,f)|0;if(!e){w=i;s=u;return w|0}e=t[h>>2]|0;n[e+(((e|0)==(t[k>>2]|0))<<31>>31)>>0]=0;w=i;s=u;return w|0}function FY(e){e=e|0;var i=0,r=0,f=0,t=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0;i=s;r=e;while(1){f=r+1|0;if(!($q(n[r>>0]|0)|0))break;else r=f}e=n[r>>0]|0;t=e<<24>>24;if((t|0)==43){u=0;a=5}else if((t|0)==45){u=1;a=5}else{o=r;c=e;l=0}if((a|0)==5){o=f;c=n[f>>0]|0;l=u}if(!(Qq(c<<24>>24)|0)){b=0;k=(l|0)!=0;h=0-b|0;w=k?b:h;s=i;return w|0}else{d=o;v=0}while(1){o=(v*10|0)+48-(n[d>>0]|0)|0;d=d+1|0;if(!(Qq(n[d>>0]|0)|0)){b=o;break}else v=o}k=(l|0)!=0;h=0-b|0;w=k?b:h;s=i;return w|0}function OY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;f=s;u=i&255;a=(r|0)!=0;e:do if((e&3|0)!=0&a){o=i&255;c=r;l=e;while(1){if((n[l>>0]|0)==o<<24>>24){b=c;k=l;h=6;break e}w=l+1|0;d=c+-1|0;v=(d|0)!=0;if((w&3|0)!=0&v){c=d;l=w}else{m=d;_=v;p=w;h=5;break}}}else{m=r;_=a;p=e;h=5}while(0);if((h|0)==5)if(_){b=m;k=p;h=6}else{E=0;S=p}e:do if((h|0)==6){p=i&255;if((n[k>>0]|0)!=p<<24>>24){m=te(u,16843009)|0;i:do if(b>>>0>3){_=b;e=k;while(1){a=t[e>>2]^m;if((a&-2139062144^-2139062144)&a+-16843009){g=_;y=e;break i}a=e+4|0;r=_+-4|0;if(r>>>0>3){_=r;e=a}else{g=r;y=a;break}}}else{g=b;y=k}while(0);if(!g){E=0;S=y}else{m=g;e=y;while(1){if((n[e>>0]|0)==p<<24>>24){E=m;S=e;break e}_=e+1|0;m=m+-1|0;if(!m){E=0;S=_;break}else e=_}}}else{E=b;S=k}}while(0);s=f;return((E|0)!=0?S:0)|0}function AY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,t=0,u=0,a=0,o=0,c=0,l=0;f=s;e:do if(!r)t=0;else{u=r;a=e;o=i;while(1){c=n[a>>0]|0;l=n[o>>0]|0;if(c<<24>>24!=l<<24>>24)break;u=u+-1|0;if(!u){t=0;break e}else{a=a+1|0;o=o+1|0}}t=(c&255)-(l&255)|0}while(0);s=f;return t|0}function MY(e,i){e=e|0;i=i|0;var r=0,f=0,t=0,u=0,a=0;r=s;f=n[e>>0]|0;t=n[i>>0]|0;if(f<<24>>24==0?1:f<<24>>24!=t<<24>>24){u=f;a=t}else{t=e;e=i;do{t=t+1|0;e=e+1|0;i=n[t>>0]|0;f=n[e>>0]|0}while(!(i<<24>>24==0?1:i<<24>>24!=f<<24>>24));u=i;a=f}s=r;return(u&255)-(a&255)|0}function RY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,t=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0;f=s;if(!r){t=0;s=f;return t|0}a=n[e>>0]|0;e:do if(!(a<<24>>24)){o=0;c=i}else{l=r;b=a;k=e;h=i;while(1){l=l+-1|0;w=n[h>>0]|0;if(!(w<<24>>24!=0&(l|0)!=0&b<<24>>24==w<<24>>24)){o=b;c=h;break e}k=k+1|0;w=h+1|0;b=n[k>>0]|0;if(!(b<<24>>24)){o=0;c=w;break}else h=w}}while(0);t=(o&255)-(u[c>>0]|0)|0;s=f;return t|0}function NY(e,i,r){e=e|0;i=i|0;r=r|0;var n=0,f=0,u=0,a=0;n=s;f=e+20|0;u=t[f>>2]|0;a=(t[e+16>>2]|0)-u|0;e=a>>>0>r>>>0?r:a;YY(u|0,i|0,e|0)|0;t[f>>2]=(t[f>>2]|0)+e;s=n;return r|0}function TY(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;r=s;n=e+4|0;f=t[n>>2]|0;u=f&-8;a=e+u|0;o=t[82068]|0;c=f&3;if(!((c|0)!=1&e>>>0>=o>>>0&e>>>0<a>>>0))li();l=e+(u|4)|0;b=t[l>>2]|0;if(!(b&1))li();if(!c){if(i>>>0<256){k=0;s=r;return k|0}if(u>>>0>=(i+4|0)>>>0?(u-i|0)>>>0<=t[82184]<<1>>>0:0){k=e;s=r;return k|0}k=0;s=r;return k|0}if(u>>>0>=i>>>0){c=u-i|0;if(c>>>0<=15){k=e;s=r;return k|0}t[n>>2]=f&1|i|2;t[e+(i+4)>>2]=c|3;t[l>>2]=t[l>>2]|1;LY(e+i|0,c);k=e;s=r;return k|0}if((a|0)==(t[82070]|0)){c=(t[82067]|0)+u|0;if(c>>>0<=i>>>0){k=0;s=r;return k|0}l=c-i|0;t[n>>2]=f&1|i|2;t[e+(i+4)>>2]=l|1;t[82070]=e+i;t[82067]=l;k=e;s=r;return k|0}if((a|0)==(t[82069]|0)){l=(t[82066]|0)+u|0;if(l>>>0<i>>>0){k=0;s=r;return k|0}c=l-i|0;if(c>>>0>15){t[n>>2]=f&1|i|2;t[e+(i+4)>>2]=c|1;t[e+l>>2]=c;h=e+(l+4)|0;t[h>>2]=t[h>>2]&-2;w=e+i|0;d=c}else{t[n>>2]=f&1|l|2;c=e+(l+4)|0;t[c>>2]=t[c>>2]|1;w=0;d=0}t[82066]=d;t[82069]=w;k=e;s=r;return k|0}if(b&2){k=0;s=r;return k|0}w=(b&-8)+u|0;if(w>>>0<i>>>0){k=0;s=r;return k|0}d=w-i|0;c=b>>>3;do if(b>>>0>=256){l=t[e+(u+24)>>2]|0;h=t[e+(u+12)>>2]|0;do if((h|0)==(a|0)){v=e+(u+20)|0;m=t[v>>2]|0;if(!m){_=e+(u+16)|0;p=t[_>>2]|0;if(!p){E=0;break}else{S=p;g=_}}else{S=m;g=v}while(1){v=S+20|0;m=t[v>>2]|0;if(m){S=m;g=v;continue}v=S+16|0;m=t[v>>2]|0;if(!m)break;else{S=m;g=v}}if(g>>>0<o>>>0)li();else{t[g>>2]=0;E=S;break}}else{v=t[e+(u+8)>>2]|0;if(v>>>0<o>>>0)li();m=v+12|0;if((t[m>>2]|0)!=(a|0))li();_=h+8|0;if((t[_>>2]|0)==(a|0)){t[m>>2]=h;t[_>>2]=v;E=h;break}else li()}while(0);if(l){h=t[e+(u+28)>>2]|0;v=328560+(h<<2)|0;if((a|0)==(t[v>>2]|0)){t[v>>2]=E;if(!E){t[82065]=t[82065]&~(1<<h);break}}else{if(l>>>0<(t[82068]|0)>>>0)li();h=l+16|0;if((t[h>>2]|0)==(a|0))t[h>>2]=E;else t[l+20>>2]=E;if(!E)break}h=t[82068]|0;if(E>>>0<h>>>0)li();t[E+24>>2]=l;v=t[e+(u+16)>>2]|0;do if(v)if(v>>>0<h>>>0)li();else{t[E+16>>2]=v;t[v+24>>2]=E;break}while(0);v=t[e+(u+20)>>2]|0;if(v)if(v>>>0<(t[82068]|0)>>>0)li();else{t[E+20>>2]=v;t[v+24>>2]=E;break}}}else{v=t[e+(u+8)>>2]|0;h=t[e+(u+12)>>2]|0;l=328296+(c<<1<<2)|0;if((v|0)!=(l|0)){if(v>>>0<o>>>0)li();if((t[v+12>>2]|0)!=(a|0))li()}if((h|0)==(v|0)){t[82064]=t[82064]&~(1<<c);break}if((h|0)!=(l|0)){if(h>>>0<o>>>0)li();l=h+8|0;if((t[l>>2]|0)==(a|0))y=l;else li()}else y=h+8|0;t[v+12>>2]=h;t[y>>2]=v}while(0);if(d>>>0<16){t[n>>2]=w|f&1|2;y=e+(w|4)|0;t[y>>2]=t[y>>2]|1;k=e;s=r;return k|0}else{t[n>>2]=f&1|i|2;t[e+(i+4)>>2]=d|3;f=e+(w|4)|0;t[f>>2]=t[f>>2]|1;LY(e+i|0,d);k=e;s=r;return k|0}return 0}function LY(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,u=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0;r=s;n=e+i|0;f=t[e+4>>2]|0;do if(!(f&1)){u=t[e>>2]|0;if(!(f&3)){s=r;return}a=e+(0-u)|0;o=u+i|0;c=t[82068]|0;if(a>>>0<c>>>0)li();if((a|0)==(t[82069]|0)){l=e+(i+4)|0;b=t[l>>2]|0;if((b&3|0)!=3){k=a;h=o;break}t[82066]=o;t[l>>2]=b&-2;t[e+(4-u)>>2]=o|1;t[n>>2]=o;s=r;return}b=u>>>3;if(u>>>0<256){l=t[e+(8-u)>>2]|0;w=t[e+(12-u)>>2]|0;d=328296+(b<<1<<2)|0;if((l|0)!=(d|0)){if(l>>>0<c>>>0)li();if((t[l+12>>2]|0)!=(a|0))li()}if((w|0)==(l|0)){t[82064]=t[82064]&~(1<<b);
	k=a;h=o;break}if((w|0)!=(d|0)){if(w>>>0<c>>>0)li();d=w+8|0;if((t[d>>2]|0)==(a|0))v=d;else li()}else v=w+8|0;t[l+12>>2]=w;t[v>>2]=l;k=a;h=o;break}l=t[e+(24-u)>>2]|0;w=t[e+(12-u)>>2]|0;do if((w|0)==(a|0)){d=16-u|0;b=e+(d+4)|0;m=t[b>>2]|0;if(!m){_=e+d|0;d=t[_>>2]|0;if(!d){p=0;break}else{E=d;S=_}}else{E=m;S=b}while(1){b=E+20|0;m=t[b>>2]|0;if(m){E=m;S=b;continue}b=E+16|0;m=t[b>>2]|0;if(!m)break;else{E=m;S=b}}if(S>>>0<c>>>0)li();else{t[S>>2]=0;p=E;break}}else{b=t[e+(8-u)>>2]|0;if(b>>>0<c>>>0)li();m=b+12|0;if((t[m>>2]|0)!=(a|0))li();_=w+8|0;if((t[_>>2]|0)==(a|0)){t[m>>2]=w;t[_>>2]=b;p=w;break}else li()}while(0);if(l){w=t[e+(28-u)>>2]|0;c=328560+(w<<2)|0;if((a|0)==(t[c>>2]|0)){t[c>>2]=p;if(!p){t[82065]=t[82065]&~(1<<w);k=a;h=o;break}}else{if(l>>>0<(t[82068]|0)>>>0)li();w=l+16|0;if((t[w>>2]|0)==(a|0))t[w>>2]=p;else t[l+20>>2]=p;if(!p){k=a;h=o;break}}w=t[82068]|0;if(p>>>0<w>>>0)li();t[p+24>>2]=l;c=16-u|0;b=t[e+c>>2]|0;do if(b)if(b>>>0<w>>>0)li();else{t[p+16>>2]=b;t[b+24>>2]=p;break}while(0);b=t[e+(c+4)>>2]|0;if(b)if(b>>>0<(t[82068]|0)>>>0)li();else{t[p+20>>2]=b;t[b+24>>2]=p;k=a;h=o;break}else{k=a;h=o}}else{k=a;h=o}}else{k=e;h=i}while(0);p=t[82068]|0;if(n>>>0<p>>>0)li();E=e+(i+4)|0;S=t[E>>2]|0;if(!(S&2)){if((n|0)==(t[82070]|0)){v=(t[82067]|0)+h|0;t[82067]=v;t[82070]=k;t[k+4>>2]=v|1;if((k|0)!=(t[82069]|0)){s=r;return}t[82069]=0;t[82066]=0;s=r;return}if((n|0)==(t[82069]|0)){v=(t[82066]|0)+h|0;t[82066]=v;t[82069]=k;t[k+4>>2]=v|1;t[k+v>>2]=v;s=r;return}v=(S&-8)+h|0;f=S>>>3;do if(S>>>0>=256){b=t[e+(i+24)>>2]|0;w=t[e+(i+12)>>2]|0;do if((w|0)==(n|0)){u=e+(i+20)|0;l=t[u>>2]|0;if(!l){_=e+(i+16)|0;m=t[_>>2]|0;if(!m){g=0;break}else{y=m;F=_}}else{y=l;F=u}while(1){u=y+20|0;l=t[u>>2]|0;if(l){y=l;F=u;continue}u=y+16|0;l=t[u>>2]|0;if(!l)break;else{y=l;F=u}}if(F>>>0<p>>>0)li();else{t[F>>2]=0;g=y;break}}else{u=t[e+(i+8)>>2]|0;if(u>>>0<p>>>0)li();l=u+12|0;if((t[l>>2]|0)!=(n|0))li();_=w+8|0;if((t[_>>2]|0)==(n|0)){t[l>>2]=w;t[_>>2]=u;g=w;break}else li()}while(0);if(b){w=t[e+(i+28)>>2]|0;o=328560+(w<<2)|0;if((n|0)==(t[o>>2]|0)){t[o>>2]=g;if(!g){t[82065]=t[82065]&~(1<<w);break}}else{if(b>>>0<(t[82068]|0)>>>0)li();w=b+16|0;if((t[w>>2]|0)==(n|0))t[w>>2]=g;else t[b+20>>2]=g;if(!g)break}w=t[82068]|0;if(g>>>0<w>>>0)li();t[g+24>>2]=b;o=t[e+(i+16)>>2]|0;do if(o)if(o>>>0<w>>>0)li();else{t[g+16>>2]=o;t[o+24>>2]=g;break}while(0);o=t[e+(i+20)>>2]|0;if(o)if(o>>>0<(t[82068]|0)>>>0)li();else{t[g+20>>2]=o;t[o+24>>2]=g;break}}}else{o=t[e+(i+8)>>2]|0;w=t[e+(i+12)>>2]|0;b=328296+(f<<1<<2)|0;if((o|0)!=(b|0)){if(o>>>0<p>>>0)li();if((t[o+12>>2]|0)!=(n|0))li()}if((w|0)==(o|0)){t[82064]=t[82064]&~(1<<f);break}if((w|0)!=(b|0)){if(w>>>0<p>>>0)li();b=w+8|0;if((t[b>>2]|0)==(n|0))O=b;else li()}else O=w+8|0;t[o+12>>2]=w;t[O>>2]=o}while(0);t[k+4>>2]=v|1;t[k+v>>2]=v;if((k|0)==(t[82069]|0)){t[82066]=v;s=r;return}else A=v}else{t[E>>2]=S&-2;t[k+4>>2]=h|1;t[k+h>>2]=h;A=h}h=A>>>3;if(A>>>0<256){S=h<<1;E=328296+(S<<2)|0;v=t[82064]|0;O=1<<h;if(v&O){h=328296+(S+2<<2)|0;n=t[h>>2]|0;if(n>>>0<(t[82068]|0)>>>0)li();else{M=h;R=n}}else{t[82064]=v|O;M=328296+(S+2<<2)|0;R=E}t[M>>2]=k;t[R+12>>2]=k;t[k+8>>2]=R;t[k+12>>2]=E;s=r;return}E=A>>>8;if(E)if(A>>>0>16777215)N=31;else{R=(E+1048320|0)>>>16&8;M=E<<R;E=(M+520192|0)>>>16&4;S=M<<E;M=(S+245760|0)>>>16&2;O=14-(E|R|M)+(S<<M>>>15)|0;N=A>>>(O+7|0)&1|O<<1}else N=0;O=328560+(N<<2)|0;t[k+28>>2]=N;t[k+20>>2]=0;t[k+16>>2]=0;M=t[82065]|0;S=1<<N;if(!(M&S)){t[82065]=M|S;t[O>>2]=k;t[k+24>>2]=O;t[k+12>>2]=k;t[k+8>>2]=k;s=r;return}S=t[O>>2]|0;if((N|0)==31)T=0;else T=25-(N>>>1)|0;e:do if((t[S+4>>2]&-8|0)==(A|0))L=S;else{N=A<<T;O=S;while(1){D=O+(N>>>31<<2)+16|0;M=t[D>>2]|0;if(!M)break;if((t[M+4>>2]&-8|0)==(A|0)){L=M;break e}else{N=N<<1;O=M}}if(D>>>0<(t[82068]|0)>>>0)li();t[D>>2]=k;t[k+24>>2]=O;t[k+12>>2]=k;t[k+8>>2]=k;s=r;return}while(0);D=L+8|0;A=t[D>>2]|0;S=t[82068]|0;if(!(L>>>0>=S>>>0&A>>>0>=S>>>0))li();t[A+12>>2]=k;t[D>>2]=k;t[k+8>>2]=A;t[k+12>>2]=L;t[k+24>>2]=0;s=r;return}function DY(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,a=0,o=0,c=0,l=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0;r=s;n=e+4|0;f=t[n>>2]|0;a=e+100|0;if(f>>>0<(t[a>>2]|0)>>>0){t[n>>2]=f+1;o=u[f>>0]|0}else o=nY(e)|0;if((o|0)==43|(o|0)==45){f=t[n>>2]|0;c=(o|0)==45&1;if(f>>>0<(t[a>>2]|0)>>>0){t[n>>2]=f+1;l=u[f>>0]|0}else l=nY(e)|0;if((l+-48|0)>>>0>9&(i|0)!=0?(t[a>>2]|0)!=0:0){t[n>>2]=(t[n>>2]|0)+-1;b=l;k=c}else{b=l;k=c}}else{b=o;k=0}if((b+-48|0)>>>0>9){if(!(t[a>>2]|0)){h=-2147483648;w=0;P=h;s=r;return w|0}t[n>>2]=(t[n>>2]|0)+-1;h=-2147483648;w=0;P=h;s=r;return w|0}else{d=b;v=0}while(1){v=d+-48+(v*10|0)|0;b=t[n>>2]|0;if(b>>>0<(t[a>>2]|0)>>>0){t[n>>2]=b+1;m=u[b>>0]|0}else m=nY(e)|0;if(!((m+-48|0)>>>0<10&(v|0)<214748364))break;else d=m}d=((v|0)<0)<<31>>31;if((m+-48|0)>>>0<10){b=v;o=d;c=m;while(1){l=$Y(b|0,o|0,10,0)|0;i=P;f=jY(c|0,((c|0)<0)<<31>>31|0,-48,-1)|0;_=jY(f|0,P|0,l|0,i|0)|0;i=P;l=t[n>>2]|0;if(l>>>0<(t[a>>2]|0)>>>0){t[n>>2]=l+1;p=u[l>>0]|0}else p=nY(e)|0;if((p+-48|0)>>>0<10&((i|0)<21474836|(i|0)==21474836&_>>>0<2061584302)){b=_;o=i;c=p}else{E=_;S=i;g=p;break}}}else{E=v;S=d;g=m}if((g+-48|0)>>>0<10)do{g=t[n>>2]|0;if(g>>>0<(t[a>>2]|0)>>>0){t[n>>2]=g+1;y=u[g>>0]|0}else y=nY(e)|0}while((y+-48|0)>>>0<10);if(t[a>>2]|0)t[n>>2]=(t[n>>2]|0)+-1;n=(k|0)!=0;k=BY(0,0,E|0,S|0)|0;h=n?P:S;w=n?k:E;P=h;s=r;return w|0}function CY(e,i,r,a,o){e=e|0;i=i|0;r=r|0;a=a|0;o=o|0;var c=0,b=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0,D=0,C=0,B=0,I=0,H=0,x=0,U=0,z=0,j=0,V=0,q=0,Y=0,G=0,W=0,K=0,X=0,Z=0,J=0,Q=0,$=0,ee=0,ie=0,re=0,ne=0,fe=0,ue=0,ae=0,oe=0,ce=0,le=0,se=0,be=0,ke=0,he=0,we=0,de=0,ve=0,me=0,_e=0,pe=0,Ee=0,Se=0,ge=0,ye=0,Fe=0,Oe=0,Ae=0,Me=0,Re=0,Ne=0,Te=0,Le=0,De=0,Ce=0,Pe=0,Be=0,Ie=0,He=0,xe=0,Ue=0,ze=0,je=0,Ve=0,qe=0,Ye=0,Ge=0,We=0,Ke=0,Xe=0,Ze=0,Je=0,Qe=0,$e=0,ei=0,ri=0,ni=0,fi=0,ti=0,ui=0,ai=0,oi=0,ci=0,li=0,si=0,bi=0,ki=0,wi=0,di=0,vi=0,mi=0,_i=0,pi=0,Ei=0,Si=0,gi=0,yi=0,Fi=0,Oi=0,Ai=0,Mi=0,Ri=0,Ni=0,Ti=0,Li=0,Di=0,Ci=0,Pi=0,Bi=0,Ii=0,Hi=0,xi=0,Ui=0,zi=0,ji=0,Vi=0,qi=0,Yi=0,Gi=0,Wi=0,Ki=0,Xi=0,Zi=0,Ji=0,Qi=0,$i=0,er=0,ir=0,rr=0,nr=0,fr=0,tr=0,ur=0,ar=0,or=0,cr=0,lr=0,sr=0,br=0,kr=0,hr=0,wr=0,dr=0,vr=0,mr=0,_r=0,pr=0,Er=0,Sr=0,gr=0,yr=0,Fr=0,Or=0,Ar=0,Mr=0,Rr=0,Nr=0,Tr=0,Lr=0,Dr=0,Cr=0,Pr=0,Br=0,Ir=0,Hr=0,xr=0,Ur=0,zr=0,jr=0,Vr=0,qr=0,Yr=0,Gr=0,Wr=0,Kr=0,Xr=0,Zr=0,Jr=0,Qr=0,$r=0,en=0,rn=0,nn=0,fn=0,tn=0,un=0,an=0,on=0,cn=0,ln=0,sn=0,bn=0,kn=0,hn=0,wn=0,dn=0,vn=0,mn=0,_n=0,pn=0,En=0,Sn=0,gn=0;c=s;s=s+864|0;b=c+16|0;h=c+8|0;w=c+836|0;d=w;v=c+824|0;m=c+568|0;_=c+528|0;p=c;E=c+520|0;S=(e|0)!=0;g=_+40|0;y=g;F=_+39|0;_=p+4|0;O=p;A=v+12|0;M=v+11|0;v=A;R=v-d|0;N=-2-d|0;T=v+2|0;L=b+288|0;D=w+9|0;C=D;B=w+8|0;I=0;H=0;x=i;i=0;U=0;z=0;e:while(1){do if((i|0)>-1)if((U|0)>(2147483647-i|0)){t[(ii()|0)>>2]=75;j=-1;break}else{j=U+i|0;break}else j=i;while(0);V=n[x>>0]|0;if(!(V<<24>>24)){q=352;break}else{Y=V;G=x}while(1){if(Y<<24>>24==37){W=G;K=G;q=9;break}else if(!(Y<<24>>24)){X=G;Z=G;break}V=G+1|0;Y=n[V>>0]|0;G=V}i:do if((q|0)==9)while(1){q=0;if((n[W+1>>0]|0)!=37){X=W;Z=K;break i}V=K+1|0;J=W+2|0;if((n[J>>0]|0)==37){W=J;K=V;q=9}else{X=J;Z=V;break}}while(0);V=Z-x|0;if(S)EY(x,V,e)|0;if((Z|0)!=(x|0)){x=X;i=j;U=V;continue}J=X+1|0;Q=n[J>>0]|0;$=(Q<<24>>24)+-48|0;if($>>>0<10?(n[X+2>>0]|0)==36:0){ee=X+3|0;ie=n[ee>>0]|0;re=$;ne=1;fe=ee}else{ie=Q;re=-1;ne=z;fe=J}J=ie<<24>>24;i:do if((J&-32|0)==32){Q=ie;ee=J;$=0;ue=fe;while(1){ae=1<<ee+-32;if(!(ae&75913)){oe=Q;ce=$;le=ue;break i}se=ae|$;ae=ue+1|0;be=n[ae>>0]|0;ee=be<<24>>24;if((ee&-32|0)!=32){oe=be;ce=se;le=ae;break}else{Q=be;$=se;ue=ae}}}else{oe=ie;ce=0;le=fe}while(0);do if(oe<<24>>24==42){J=le+1|0;ue=(n[J>>0]|0)+-48|0;if(ue>>>0<10?(n[le+2>>0]|0)==36:0){t[o+(ue<<2)>>2]=10;ke=1;he=le+3|0;we=t[a+((n[J>>0]|0)+-48<<3)>>2]|0}else{if(ne){de=-1;q=370;break e}if(!S){ve=J;me=ce;_e=0;pe=0;break}ue=t[r>>2]|0;$=t[ue>>2]|0;t[r>>2]=ue+4;ke=0;he=J;we=$}if((we|0)<0){ve=he;me=ce|8192;_e=ke;pe=0-we|0}else{ve=he;me=ce;_e=ke;pe=we}}else{$=oe<<24>>24;if(($+-48|0)>>>0<10){J=$;$=le;ue=0;do{ue=J+-48+(ue*10|0)|0;$=$+1|0;J=n[$>>0]|0}while((J+-48|0)>>>0<10);if((ue|0)<0){de=-1;q=370;break e}else{ve=$;me=ce;_e=ne;pe=ue}}else{ve=le;me=ce;_e=ne;pe=0}}while(0);i:do if((n[ve>>0]|0)==46){J=ve+1|0;Q=n[J>>0]|0;if(Q<<24>>24!=42){ee=Q<<24>>24;if((ee+-48|0)>>>0<10){Ee=ee;Se=J;ge=0}else{ye=J;Fe=0;break}while(1){J=Ee+-48+(ge*10|0)|0;ee=Se+1|0;Ee=n[ee>>0]|0;if((Ee+-48|0)>>>0>=10){ye=ee;Fe=J;break i}else{Se=ee;ge=J}}}ue=ve+2|0;$=(n[ue>>0]|0)+-48|0;if($>>>0<10?(n[ve+3>>0]|0)==36:0){t[o+($<<2)>>2]=10;ye=ve+4|0;Fe=t[a+((n[ue>>0]|0)+-48<<3)>>2]|0;break}if(_e){de=-1;q=370;break e}if(S){$=t[r>>2]|0;J=t[$>>2]|0;t[r>>2]=$+4;ye=ue;Fe=J}else{ye=ue;Fe=0}}else{ye=ve;Fe=-1}while(0);ue=ye;J=0;while(1){Oe=n[ue>>0]|0;$=(Oe<<24>>24)+-65|0;if($>>>0>57){de=-1;q=370;break e}Ae=ue+1|0;Me=n[329096+(J*58|0)+$>>0]|0;Re=Me&255;if((Re+-1|0)>>>0<8){ue=Ae;J=Re}else break}if(!(Me<<24>>24)){de=-1;q=370;break}$=(re|0)>-1;i:do if(Me<<24>>24==19)if($){de=-1;q=370;break e}else{Ne=I;Te=H;q=63}else{if($){t[o+(re<<2)>>2]=Re;ee=a+(re<<3)|0;Ne=t[ee>>2]|0;Te=t[ee+4>>2]|0;q=63;break}if(!S){de=0;q=370;break e}if((Me&255)>20){Le=Oe;De=I;Ce=H}else do switch(Re|0){case 16:{ee=t[r>>2]|0;Q=t[ee>>2]|0;t[r>>2]=ee+4;Pe=0;Be=Q&255;q=64;break i;break}case 11:{Q=t[r>>2]|0;ee=t[Q>>2]|0;t[r>>2]=Q+4;Pe=0;Be=ee;q=64;break i;break}case 12:{ee=t[r>>2]|0;Q=ee;ae=t[Q>>2]|0;se=t[Q+4>>2]|0;t[r>>2]=ee+8;Pe=se;Be=ae;q=64;break i;break}case 14:{ae=t[r>>2]|0;se=t[ae>>2]|0;t[r>>2]=ae+4;Pe=0;Be=se&65535;q=64;break i;break}case 13:{se=t[r>>2]|0;ae=t[se>>2]|0;t[r>>2]=se+4;Pe=(((ae&65535)<<16>>16|0)<0)<<31>>31;Be=ae<<16>>16;q=64;break i;break}case 17:{ae=t[r>>2]|0;t[k>>2]=t[ae>>2];t[k+4>>2]=t[ae+4>>2];Ie=+l[k>>3];t[r>>2]=ae+8;l[k>>3]=Ie;Pe=t[k+4>>2]|0;Be=t[k>>2]|0;q=64;break i;break}case 10:{ae=t[r>>2]|0;se=t[ae>>2]|0;t[r>>2]=ae+4;Pe=((se|0)<0)<<31>>31;Be=se;q=64;break i;break}case 15:{se=t[r>>2]|0;ae=t[se>>2]|0;t[r>>2]=se+4;Pe=(((ae&255)<<24>>24|0)<0)<<31>>31;Be=ae<<24>>24;q=64;break i;break}case 18:{ae=t[r>>2]|0;t[k>>2]=t[ae>>2];t[k+4>>2]=t[ae+4>>2];Ie=+l[k>>3];t[r>>2]=ae+8;l[k>>3]=Ie;Ne=t[k>>2]|0;Te=t[k+4>>2]|0;q=63;break i;break}case 9:{ae=t[r>>2]|0;se=t[ae>>2]|0;t[r>>2]=ae+4;Pe=H;Be=se;q=64;break i;break}default:{Pe=H;Be=I;q=64;break i}}while(0)}while(0);if((q|0)==63){q=0;if(S){Pe=Te;Be=Ne;q=64}else{I=Ne;H=Te;x=Ae;i=j;U=V;z=_e;continue}}if((q|0)==64){q=0;Le=n[ue>>0]|0;De=Be;Ce=Pe}$=Le<<24>>24;se=(J|0)!=0&($&15|0)==3?$&-33:$;$=me&-65537;ae=(me&8192|0)==0?me:$;i:do switch(se|0){case 110:{switch(J|0){case 7:{ee=De;t[ee>>2]=j;t[ee+4>>2]=((j|0)<0)<<31>>31;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}case 3:{f[De>>1]=j;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}case 4:{n[De>>0]=j;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}case 6:{t[De>>2]=j;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}case 1:{t[De>>2]=j;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}case 0:{t[De>>2]=j;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}case 2:{ee=De;t[ee>>2]=j;t[ee+4>>2]=((j|0)<0)<<31>>31;I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e;break}default:{I=De;H=Ce;x=Ae;i=j;U=V;z=_e;continue e}}break}case 109:{He=hi(t[(ii()|0)>>2]|0)|0;q=96;break}case 105:case 100:{if((Ce|0)<0){ee=BY(0,0,De|0,Ce|0)|0;xe=P;Ue=ee;ze=1;je=329560;q=86;break i}if(!(ae&2048)){ee=ae&1;xe=Ce;Ue=De;ze=ee;je=(ee|0)==0?329560:329562;q=86}else{xe=Ce;Ue=De;ze=1;je=329561;q=86}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{t[k>>2]=De;t[k+4>>2]=Ce;Ie=+l[k>>3];t[h>>2]=0;if((Ce|0)>=0)if(!(ae&2048)){ee=ae&1;Ve=Ie;qe=ee;Ye=(ee|0)==0?329585:329590}else{Ve=Ie;qe=1;Ye=329587}else{Ve=-Ie;qe=1;Ye=329584}l[k>>3]=Ve;ee=t[k+4>>2]&2146435072;if(!(ee>>>0<2146435072|(ee|0)==2146435072&0<0)){ee=(se&32|0)!=0;if(Ve!=Ve|0!=0){Ge=0;We=ee?329624:329632}else{Ge=qe;We=ee?329608:329616}ee=Ge+3|0;Q=(pe|0)>(ee|0);if((ae&8192|0)==0&Q){be=pe-ee|0;VY(m|0,32,(be>>>0>256?256:be)|0)|0;if(be>>>0>255){Ke=be;do{EY(m,256,e)|0;Ke=Ke+-256|0}while(Ke>>>0>255);Xe=be&255}else Xe=be;EY(m,Xe,e)|0}EY(Ye,Ge,e)|0;EY(We,3,e)|0;if((ae&73728|0)==8192&Q){Ke=pe-ee|0;VY(m|0,32,(Ke>>>0>256?256:Ke)|0)|0;if(Ke>>>0>255){Ze=Ke;do{EY(m,256,e)|0;Ze=Ze+-256|0}while(Ze>>>0>255);Je=Ke&255}else Je=Ke;EY(m,Je,e)|0}I=De;H=Ce;x=Ae;i=j;U=Q?pe:ee;z=_e;continue e}Ie=+lY(Ve,h)*2;Ze=Ie!=0;if(Ze)t[h>>2]=(t[h>>2]|0)+-1;be=se|32;if((be|0)==97){Qe=se&32;$e=(Qe|0)==0?Ye:Ye+9|0;ei=qe|2;ri=Fe>>>0>11?0:12-Fe|0;do if(ri){ni=ri;fi=8;do{ni=ni+-1|0;fi=fi*16}while((ni|0)!=0);if((n[$e>>0]|0)==45){ti=-(fi+(-Ie-fi));break}else{ti=Ie+fi-fi;break}}else ti=Ie;while(0);ri=t[h>>2]|0;ee=(ri|0)<0?0-ri|0:ri;if((ee|0)<0){ri=A;Q=ee;Ke=((ee|0)<0)<<31>>31;while(1){ni=iG(Q|0,Ke|0,10,0)|0;ri=ri+-1|0;n[ri>>0]=ni|48;ni=Q;Q=eG(Q|0,Ke|0,10,0)|0;if(!(Ke>>>0>9|(Ke|0)==9&ni>>>0>4294967295))break;else Ke=P}ui=ri;ai=Q}else{ui=A;ai=ee}if(!ai)oi=ui;else{Ke=ui;ni=ai;while(1){ci=Ke+-1|0;n[ci>>0]=(ni>>>0)%10|0|48;if(ni>>>0<10){oi=ci;break}else{Ke=ci;ni=(ni>>>0)/10|0}}}if((oi|0)==(A|0)){n[M>>0]=48;li=M}else li=oi;n[li+-1>>0]=(t[h>>2]>>31&2)+43;ni=li+-2|0;n[ni>>0]=se+15;if((Fe|0)<1)if(!(ae&8)){si=ti;Ke=w;while(1){ee=~~si;Q=Ke+1|0;n[Ke>>0]=u[329640+ee>>0]|Qe;si=(si-+(ee|0))*16;if((Q-d|0)!=1|si==0)bi=Q;else{n[Q>>0]=46;bi=Ke+2|0}if(!(si!=0)){ki=bi;break}else Ke=bi}}else{si=ti;Ke=w;while(1){Q=~~si;ee=Ke+1|0;n[Ke>>0]=u[329640+Q>>0]|Qe;si=(si-+(Q|0))*16;if((ee-d|0)==1){n[ee>>0]=46;wi=Ke+2|0}else wi=ee;if(!(si!=0)){ki=wi;break}else Ke=wi}}else{si=ti;Ke=w;while(1){ee=~~si;Q=Ke+1|0;n[Ke>>0]=u[329640+ee>>0]|Qe;si=(si-+(ee|0))*16;if((Q-d|0)==1){n[Q>>0]=46;di=Ke+2|0}else di=Q;if(!(si!=0)){ki=di;break}else Ke=di}}Ke=ki;Qe=ni;if((Fe|0)!=0&(N+Ke|0)<(Fe|0))vi=T+Fe-Qe|0;else vi=R-Qe+Ke|0;Qe=vi+ei|0;Q=ae&73728;ee=(pe|0)>(Qe|0);if((Q|0)==0&ee){ri=pe-Qe|0;VY(m|0,32,(ri>>>0>256?256:ri)|0)|0;if(ri>>>0>255){ci=ri;do{EY(m,256,e)|0;ci=ci+-256|0}while(ci>>>0>255);mi=ri&255}else mi=ri;EY(m,mi,e)|0}EY($e,ei,e)|0;if((Q|0)==65536&ee){ci=pe-Qe|0;VY(m|0,48,(ci>>>0>256?256:ci)|0)|0;if(ci>>>0>255){_i=ci;do{EY(m,256,e)|0;_i=_i+-256|0}while(_i>>>0>255);pi=ci&255}else pi=ci;EY(m,pi,e)|0}_i=Ke-d|0;EY(w,_i,e)|0;ei=v-ni|0;$e=vi-ei-_i|0;if(($e|0)>0){VY(m|0,48,($e>>>0>256?256:$e)|0)|0;if($e>>>0>255){_i=$e;do{EY(m,256,e)|0;_i=_i+-256|0}while(_i>>>0>255);Ei=$e&255}else Ei=$e;EY(m,Ei,e)|0}EY(ni,ei,e)|0;if((Q|0)==8192&ee){_i=pe-Qe|0;VY(m|0,32,(_i>>>0>256?256:_i)|0)|0;if(_i>>>0>255){Ke=_i;do{EY(m,256,e)|0;Ke=Ke+-256|0}while(Ke>>>0>255);Si=_i&255}else Si=_i;EY(m,Si,e)|0}I=De;H=Ce;x=Ae;i=j;U=ee?pe:Qe;z=_e;continue e}Ke=(Fe|0)<0?6:Fe;if(Ze){Q=(t[h>>2]|0)+-28|0;t[h>>2]=Q;gi=Ie*268435456;yi=Q}else{gi=Ie;yi=t[h>>2]|0}Q=(yi|0)<0?b:L;ei=Q;si=gi;ni=Q;do{$e=~~si>>>0;t[ni>>2]=$e;ni=ni+4|0;si=(si-+($e>>>0))*1e9}while(si!=0);Ze=t[h>>2]|0;if((Ze|0)>0){Qe=Ze;ee=Q;_i=ni;while(1){$e=(Qe|0)>29?29:Qe;ci=_i+-4|0;do if(ci>>>0<ee>>>0)Fi=ee;else{ri=0;Oi=ci;do{Ai=UY(t[Oi>>2]|0,0,$e|0)|0;Mi=jY(Ai|0,P|0,ri|0,0)|0;Ai=P;Ri=iG(Mi|0,Ai|0,1e9,0)|0;t[Oi>>2]=Ri;ri=eG(Mi|0,Ai|0,1e9,0)|0;Oi=Oi+-4|0}while(Oi>>>0>=ee>>>0);if(!ri){Fi=ee;break}Oi=ee+-4|0;t[Oi>>2]=ri;Fi=Oi}while(0);ci=_i;while(1){if(ci>>>0<=Fi>>>0)break;Oi=ci+-4|0;if(!(t[Oi>>2]|0))ci=Oi;else break}Oi=(t[h>>2]|0)-$e|0;t[h>>2]=Oi;if((Oi|0)>0){Qe=Oi;ee=Fi;_i=ci}else{Ni=Oi;Ti=Fi;Li=ci;break}}}else{Ni=Ze;Ti=Q;Li=ni}r:do if((Ni|0)<0){_i=((Ke+25|0)/9|0)+1|0;if((be|0)==102){ee=Q+(_i<<2)|0;Qe=Ni;Oi=Ti;Ai=Li;while(1){Mi=0-Qe|0;Ri=(Mi|0)>9?9:Mi;do if(Oi>>>0<Ai>>>0){Mi=(1<<Ri)+-1|0;Di=1e9>>>Ri;Ci=0;Pi=Oi;do{Bi=t[Pi>>2]|0;t[Pi>>2]=(Bi>>>Ri)+Ci;Ci=te(Bi&Mi,Di)|0;Pi=Pi+4|0}while(Pi>>>0<Ai>>>0);Pi=(t[Oi>>2]|0)==0?Oi+4|0:Oi;if(!Ci){Ii=Pi;Hi=Ai;break}t[Ai>>2]=Ci;Ii=Pi;Hi=Ai+4|0}else{Ii=(t[Oi>>2]|0)==0?Oi+4|0:Oi;Hi=Ai}while(0);ri=(Hi-ei>>2|0)>(_i|0)?ee:Hi;Qe=(t[h>>2]|0)+Ri|0;t[h>>2]=Qe;if((Qe|0)>=0){xi=Ii;Ui=ri;break r}else{Oi=Ii;Ai=ri}}}else{zi=Ni;ji=Ti;Vi=Li}while(1){Ai=0-zi|0;Oi=(Ai|0)>9?9:Ai;do if(ji>>>0<Vi>>>0){Ai=(1<<Oi)+-1|0;Qe=1e9>>>Oi;ee=0;ci=ji;do{$e=t[ci>>2]|0;t[ci>>2]=($e>>>Oi)+ee;ee=te($e&Ai,Qe)|0;ci=ci+4|0}while(ci>>>0<Vi>>>0);ci=(t[ji>>2]|0)==0?ji+4|0:ji;if(!ee){qi=ci;Yi=Vi;break}t[Vi>>2]=ee;qi=ci;Yi=Vi+4|0}else{qi=(t[ji>>2]|0)==0?ji+4|0:ji;Yi=Vi}while(0);if((Yi-qi>>2|0)>(_i|0))Gi=qi+(_i<<2)|0;else Gi=Yi;zi=(t[h>>2]|0)+Oi|0;t[h>>2]=zi;if((zi|0)>=0){xi=qi;Ui=Gi;break}else{ji=qi;Vi=Gi}}}else{xi=Ti;Ui=Li}while(0);do if(xi>>>0<Ui>>>0){ni=(ei-xi>>2)*9|0;Ze=t[xi>>2]|0;if(Ze>>>0<10){Wi=ni;break}else{Ki=ni;Xi=10}while(1){Xi=Xi*10|0;ni=Ki+1|0;if(Ze>>>0<Xi>>>0){Wi=ni;break}else Ki=ni}}else Wi=0;while(0);Ze=(be|0)==103;ni=Ke-((be|0)!=102?Wi:0)+((Ze&(Ke|0)!=0)<<31>>31)|0;if((ni|0)<(((Ui-ei>>2)*9|0)+-9|0)){_i=ni+9216|0;ni=(_i|0)/9|0;Ri=Q+(ni+-1023<<2)|0;ci=((_i|0)%9|0)+1|0;if((ci|0)<9){_i=10;Qe=ci;while(1){ci=_i*10|0;Qe=Qe+1|0;if((Qe|0)==9){Zi=ci;break}else _i=ci}}else Zi=10;_i=t[Ri>>2]|0;Qe=(_i>>>0)%(Zi>>>0)|0;if((Qe|0)==0?(Q+(ni+-1022<<2)|0)==(Ui|0):0){Ji=xi;Qi=Ri;$i=Wi}else q=232;do if((q|0)==232){q=0;fi=(((_i>>>0)/(Zi>>>0)|0)&1|0)==0?9007199254740992:9007199254740994;be=(Zi|0)/2|0;do if(Qe>>>0<be>>>0)er=.5;else{if((Qe|0)==(be|0)?(Q+(ni+-1022<<2)|0)==(Ui|0):0){er=1;break}er=1.5}while(0);do if(!qe){ir=fi;rr=er}else{if((n[Ye>>0]|0)!=45){ir=fi;rr=er;break}ir=fi*-1;rr=er*-1}while(0);be=_i-Qe|0;t[Ri>>2]=be;if(!(ir+rr!=ir)){Ji=xi;Qi=Ri;$i=Wi;break}ci=be+Zi|0;t[Ri>>2]=ci;if(ci>>>0>999999999){ci=xi;be=Ri;while(1){Ai=be+-4|0;t[be>>2]=0;if(Ai>>>0<ci>>>0){Ci=ci+-4|0;t[Ci>>2]=0;nr=Ci}else nr=ci;Ci=(t[Ai>>2]|0)+1|0;t[Ai>>2]=Ci;if(Ci>>>0>999999999){ci=nr;be=Ai}else{fr=nr;tr=Ai;break}}}else{fr=xi;tr=Ri}be=(ei-fr>>2)*9|0;ci=t[fr>>2]|0;if(ci>>>0<10){Ji=fr;Qi=tr;$i=be;break}else{ur=be;ar=10}while(1){ar=ar*10|0;be=ur+1|0;if(ci>>>0<ar>>>0){Ji=fr;Qi=tr;$i=be;break}else ur=be}}while(0);Ri=Qi+4|0;or=Ji;cr=$i;lr=Ui>>>0>Ri>>>0?Ri:Ui}else{or=xi;cr=Wi;lr=Ui}Ri=0-cr|0;Qe=lr;while(1){if(Qe>>>0<=or>>>0){sr=0;break}_i=Qe+-4|0;if(!(t[_i>>2]|0))Qe=_i;else{sr=1;break}}do if(Ze){_i=((Ke|0)==0&1)+Ke|0;if((_i|0)>(cr|0)&(cr|0)>-5){br=se+-1|0;kr=_i+-1-cr|0}else{br=se+-2|0;kr=_i+-1|0}if(ae&8){hr=br;wr=kr;break}do if(sr){_i=t[Qe+-4>>2]|0;if(!_i){dr=9;break}if(!((_i>>>0)%10|0)){vr=10;mr=0}else{dr=0;break}while(1){vr=vr*10|0;ni=mr+1|0;if((_i>>>0)%(vr>>>0)|0){dr=ni;break}else mr=ni}}else dr=9;while(0);_i=((Qe-ei>>2)*9|0)+-9|0;if((br|32|0)==102){Oi=_i-dr|0;ni=(Oi|0)<0?0:Oi;hr=br;wr=(kr|0)<(ni|0)?kr:ni;break}else{ni=_i+cr-dr|0;_i=(ni|0)<0?0:ni;hr=br;wr=(kr|0)<(_i|0)?kr:_i;break}}else{hr=se;wr=Ke}while(0);Ke=(wr|0)!=0;if(Ke)_r=1;else _r=(ae&8|0)!=0;ei=_r&1;Ze=(hr|32|0)==102;if(Ze){pr=(cr|0)>0?cr:0;Er=0}else{_i=(cr|0)<0?Ri:cr;if((_i|0)<0){ni=A;Oi=_i;ci=((_i|0)<0)<<31>>31;while(1){be=iG(Oi|0,ci|0,10,0)|0;ni=ni+-1|0;n[ni>>0]=be|48;be=Oi;Oi=eG(Oi|0,ci|0,10,0)|0;if(!(ci>>>0>9|(ci|0)==9&be>>>0>4294967295))break;else ci=P}Sr=ni;gr=Oi}else{Sr=A;gr=_i}if(!gr)yr=Sr;else{ci=Sr;Ri=gr;while(1){be=ci+-1|0;n[be>>0]=(Ri>>>0)%10|0|48;if(Ri>>>0<10){yr=be;break}else{ci=be;Ri=(Ri>>>0)/10|0}}}if((v-yr|0)<2){Ri=yr;while(1){ci=Ri+-1|0;n[ci>>0]=48;if((v-ci|0)<2)Ri=ci;else{Fr=ci;break}}}else Fr=yr;n[Fr+-1>>0]=(cr>>31&2)+43;Ri=Fr+-2|0;n[Ri>>0]=hr;pr=v-Ri|0;Er=Ri}Ri=qe+1+wr+ei+pr|0;ci=ae&73728;_i=(pe|0)>(Ri|0);if((ci|0)==0&_i){Oi=pe-Ri|0;VY(m|0,32,(Oi>>>0>256?256:Oi)|0)|0;if(Oi>>>0>255){ni=Oi;do{EY(m,256,e)|0;ni=ni+-256|0}while(ni>>>0>255);Or=Oi&255}else Or=Oi;EY(m,Or,e)|0}EY(Ye,qe,e)|0;if((ci|0)==65536&_i){ni=pe-Ri|0;VY(m|0,48,(ni>>>0>256?256:ni)|0)|0;if(ni>>>0>255){ei=ni;do{EY(m,256,e)|0;ei=ei+-256|0}while(ei>>>0>255);Ar=ni&255}else Ar=ni;EY(m,Ar,e)|0}do if(Ze){ei=or>>>0>Q>>>0?Q:or;Oi=ei;do{be=t[Oi>>2]|0;if(!be)Mr=D;else{Ai=D;Ci=be;while(1){be=Ai+-1|0;n[be>>0]=(Ci>>>0)%10|0|48;if(Ci>>>0<10){Mr=be;break}else{Ai=be;Ci=(Ci>>>0)/10|0}}}do if((Oi|0)==(ei|0)){if((Mr|0)!=(D|0)){Rr=Mr;break}n[B>>0]=48;Rr=B}else{if(Mr>>>0>w>>>0)Nr=Mr;else{Rr=Mr;break}while(1){Ci=Nr+-1|0;n[Ci>>0]=48;if(Ci>>>0>w>>>0)Nr=Ci;else{Rr=Ci;break}}}while(0);EY(Rr,C-Rr|0,e)|0;Oi=Oi+4|0}while(Oi>>>0<=Q>>>0);if(!((ae&8|0)==0&(Ke^1)))EY(329656,1,e)|0;if(Oi>>>0<Qe>>>0&(wr|0)>0){ei=wr;ee=Oi;while(1){Ci=t[ee>>2]|0;if(Ci){Ai=D;be=Ci;while(1){Ai=Ai+-1|0;n[Ai>>0]=(be>>>0)%10|0|48;if(be>>>0<10)break;else be=(be>>>0)/10|0}if(Ai>>>0>w>>>0){Tr=Ai;q=301}else Lr=Ai}else{Tr=D;q=301}if((q|0)==301)while(1){q=0;be=Tr+-1|0;n[be>>0]=48;if(be>>>0>w>>>0){Tr=be;q=301}else{Lr=be;break}}EY(Lr,(ei|0)>9?9:ei,e)|0;ee=ee+4|0;Ai=ei+-9|0;if(!(ee>>>0<Qe>>>0&(Ai|0)>0)){Dr=Ai;break}else ei=Ai}}else Dr=wr;if((Dr|0)<=0)break;VY(m|0,48,(Dr>>>0>256?256:Dr)|0)|0;if(Dr>>>0>255){ei=Dr;do{EY(m,256,e)|0;ei=ei+-256|0}while(ei>>>0>255);Cr=Dr&255}else Cr=Dr;EY(m,Cr,e)|0}else{ei=sr?Qe:or+4|0;do if((wr|0)>-1){ee=(ae&8|0)==0;Oi=wr;Ai=or;do{be=t[Ai>>2]|0;if(be){Ci=D;$e=be;while(1){Ci=Ci+-1|0;n[Ci>>0]=($e>>>0)%10|0|48;if($e>>>0<10)break;else $e=($e>>>0)/10|0}if((Ci|0)!=(D|0))Pr=Ci;else q=313}else q=313;if((q|0)==313){q=0;n[B>>0]=48;Pr=B}do if((Ai|0)==(or|0)){$e=Pr+1|0;EY(Pr,1,e)|0;if((Oi|0)<1&ee){Br=$e;break}EY(329656,1,e)|0;Br=$e}else{if(Pr>>>0>w>>>0)Ir=Pr;else{Br=Pr;break}while(1){$e=Ir+-1|0;n[$e>>0]=48;if($e>>>0>w>>>0)Ir=$e;else{Br=$e;break}}}while(0);Ci=C-Br|0;EY(Br,(Oi|0)>(Ci|0)?Ci:Oi,e)|0;Oi=Oi-Ci|0;Ai=Ai+4|0}while(Ai>>>0<ei>>>0&(Oi|0)>-1);if((Oi|0)<=0)break;VY(m|0,48,(Oi>>>0>256?256:Oi)|0)|0;if(Oi>>>0>255){Ai=Oi;do{EY(m,256,e)|0;Ai=Ai+-256|0}while(Ai>>>0>255);Hr=Oi&255}else Hr=Oi;EY(m,Hr,e)|0}while(0);EY(Er,v-Er|0,e)|0}while(0);if((ci|0)==8192&_i){Qe=pe-Ri|0;VY(m|0,32,(Qe>>>0>256?256:Qe)|0)|0;if(Qe>>>0>255){Ke=Qe;do{EY(m,256,e)|0;Ke=Ke+-256|0}while(Ke>>>0>255);xr=Qe&255}else xr=Qe;EY(m,xr,e)|0}I=De;H=Ce;x=Ae;i=j;U=_i?pe:Ri;z=_e;continue e;break}case 117:{xe=Ce;Ue=De;ze=0;je=329560;q=86;break}case 88:case 120:{Ur=ae;zr=Fe;jr=se;q=75;break}case 99:{n[F>>0]=De;Vr=De;qr=Ce;Yr=F;Gr=$;Wr=1;Kr=0;Xr=329560;Zr=g;break}case 111:{Ke=(De|0)==0&(Ce|0)==0;if(Ke)Jr=g;else{ci=g;Q=De;Ze=Ce;while(1){ni=ci+-1|0;n[ni>>0]=Q&7|48;Q=qY(Q|0,Ze|0,3)|0;Ze=P;if((Q|0)==0&(Ze|0)==0){Jr=ni;break}else ci=ni}}ci=(ae&8|0)==0|Ke;Qr=De;$r=Ce;en=Jr;rn=ae;nn=Fe;fn=ci&1^1;tn=ci?329560:329565;q=91;break}case 67:{t[p>>2]=De;t[_>>2]=0;un=p;an=O;on=-1;q=101;break}case 83:{ci=De;if(!Fe){cn=De;ln=ci;sn=0;q=106}else{un=ci;an=De;on=Fe;q=101}break}case 112:{Ur=ae|8;zr=Fe>>>0>8?Fe:8;jr=120;q=75;break}case 115:{He=(De|0)==0?329576:De;q=96;break}default:{Vr=De;qr=Ce;Yr=x;Gr=ae;Wr=Fe;Kr=0;Xr=329560;Zr=g}}while(0);do if((q|0)==75){q=0;se=jr&32;if(!((De|0)==0&(Ce|0)==0)){V=g;J=De;ue=Ce;do{V=V+-1|0;n[V>>0]=u[329640+(J&15)>>0]|se;J=qY(J|0,ue|0,4)|0;ue=P}while(!((J|0)==0&(ue|0)==0));if(!(Ur&8)){Qr=De;$r=Ce;en=V;rn=Ur;nn=zr;fn=0;tn=329560;q=91}else{Qr=De;$r=Ce;en=V;rn=Ur;nn=zr;fn=2;tn=329560+(jr>>4)|0;q=91}}else{Qr=De;$r=Ce;en=g;rn=Ur;nn=zr;fn=0;tn=329560;q=91}}else if((q|0)==86){q=0;if(xe>>>0>0|(xe|0)==0&Ue>>>0>4294967295){ue=g;J=Ue;se=xe;while(1){Ke=iG(J|0,se|0,10,0)|0;ue=ue+-1|0;n[ue>>0]=Ke|48;Ke=J;J=eG(J|0,se|0,10,0)|0;if(!(se>>>0>9|(se|0)==9&Ke>>>0>4294967295))break;else se=P}bn=ue;kn=J}else{bn=g;kn=Ue}if(!kn){Qr=Ue;$r=xe;en=bn;rn=ae;nn=Fe;fn=ze;tn=je;q=91}else{se=bn;V=kn;while(1){Ke=se+-1|0;n[Ke>>0]=(V>>>0)%10|0|48;if(V>>>0<10){Qr=Ue;$r=xe;en=Ke;rn=ae;nn=Fe;fn=ze;tn=je;q=91;break}else{se=Ke;V=(V>>>0)/10|0}}}}else if((q|0)==96){q=0;V=OY(He,0,Fe)|0;if(!V){Vr=De;qr=Ce;Yr=He;Gr=$;Wr=Fe;Kr=0;Xr=329560;Zr=He+Fe|0;break}else{Vr=De;qr=Ce;Yr=He;Gr=$;Wr=V-He|0;Kr=0;Xr=329560;Zr=V;break}}else if((q|0)==101){q=0;V=0;se=0;J=un;while(1){ue=t[J>>2]|0;if(!ue){hn=V;wn=se;break}Ke=wY(E,ue)|0;if((Ke|0)<0|Ke>>>0>(on-V|0)>>>0){hn=V;wn=Ke;break}ue=Ke+V|0;if(on>>>0>ue>>>0){V=ue;se=Ke;J=J+4|0}else{hn=ue;wn=Ke;break}}if((wn|0)<0){de=-1;q=370;break e}else{cn=an;ln=un;sn=hn;q=106}}while(0);if((q|0)==91){q=0;$=(nn|0)>-1?rn&-65537:rn;J=(Qr|0)!=0|($r|0)!=0;if(J|(nn|0)!=0){se=(J&1^1)+(y-en)|0;Vr=Qr;qr=$r;Yr=en;Gr=$;Wr=(nn|0)>(se|0)?nn:se;Kr=fn;Xr=tn;Zr=g}else{Vr=Qr;qr=$r;Yr=g;Gr=$;Wr=0;Kr=fn;Xr=tn;Zr=g}}else if((q|0)==106){q=0;$=ae&73728;se=(pe|0)>(sn|0);if(($|0)==0&se){J=pe-sn|0;VY(m|0,32,(J>>>0>256?256:J)|0)|0;if(J>>>0>255){V=J;do{EY(m,256,e)|0;V=V+-256|0}while(V>>>0>255);dn=J&255}else dn=J;EY(m,dn,e)|0}i:do if(sn){V=0;ae=ln;while(1){Ke=t[ae>>2]|0;if(!Ke)break i;ue=wY(E,Ke)|0;V=ue+V|0;if((V|0)>(sn|0))break i;EY(E,ue,e)|0;if(V>>>0>=sn>>>0)break;else ae=ae+4|0}}while(0);if(($|0)==8192&se){J=pe-sn|0;VY(m|0,32,(J>>>0>256?256:J)|0)|0;if(J>>>0>255){ae=J;do{EY(m,256,e)|0;ae=ae+-256|0}while(ae>>>0>255);vn=J&255}else vn=J;EY(m,vn,e)|0}I=cn;H=Ce;x=Ae;i=j;U=se?pe:sn;z=_e;continue}ae=Zr-Yr|0;$=(Wr|0)<(ae|0)?ae:Wr;V=Kr+$|0;ue=(pe|0)<(V|0)?V:pe;Ke=Gr&73728;ci=(ue|0)>(V|0);if((Ke|0)==0&ci){Ze=ue-V|0;VY(m|0,32,(Ze>>>0>256?256:Ze)|0)|0;if(Ze>>>0>255){Q=Ze;do{EY(m,256,e)|0;Q=Q+-256|0}while(Q>>>0>255);mn=Ze&255}else mn=Ze;EY(m,mn,e)|0}EY(Xr,Kr,e)|0;if((Ke|0)==65536&ci){Q=ue-V|0;VY(m|0,48,(Q>>>0>256?256:Q)|0)|0;if(Q>>>0>255){se=Q;do{EY(m,256,e)|0;se=se+-256|0}while(se>>>0>255);_n=Q&255}else _n=Q;EY(m,_n,e)|0}if(($|0)>(ae|0)){se=$-ae|0;VY(m|0,48,(se>>>0>256?256:se)|0)|0;if(se>>>0>255){Ze=se;do{EY(m,256,e)|0;Ze=Ze+-256|0}while(Ze>>>0>255);pn=se&255}else pn=se;EY(m,pn,e)|0}EY(Yr,ae,e)|0;if(!((Ke|0)==8192&ci)){I=Vr;H=qr;x=Ae;i=j;U=ue;z=_e;continue}Ze=ue-V|0;VY(m|0,32,(Ze>>>0>256?256:Ze)|0)|0;if(Ze>>>0>255){$=Ze;do{EY(m,256,e)|0;$=$+-256|0}while($>>>0>255);En=Ze&255}else En=Ze;EY(m,En,e)|0;I=Vr;H=qr;x=Ae;i=j;U=ue;z=_e}if((q|0)==352){if(e){de=j;s=c;return de|0}if(!z){de=0;s=c;return de|0}else Sn=1;while(1){z=t[o+(Sn<<2)>>2]|0;if(!z){gn=Sn;break}j=a+(Sn<<3)|0;e:do if(z>>>0<=20)do switch(z|0){case 9:{e=t[r>>2]|0;_e=t[e>>2]|0;t[r>>2]=e+4;t[j>>2]=_e;break e;break}case 10:{_e=t[r>>2]|0;e=t[_e>>2]|0;t[r>>2]=_e+4;_e=j;t[_e>>2]=e;t[_e+4>>2]=((e|0)<0)<<31>>31;break e;break}case 11:{e=t[r>>2]|0;_e=t[e>>2]|0;t[r>>2]=e+4;e=j;t[e>>2]=_e;t[e+4>>2]=0;break e;break}case 12:{e=t[r>>2]|0;_e=e;U=t[_e>>2]|0;i=t[_e+4>>2]|0;t[r>>2]=e+8;e=j;t[e>>2]=U;t[e+4>>2]=i;break e;break}case 13:{i=t[r>>2]|0;e=t[i>>2]|0;t[r>>2]=i+4;i=(e&65535)<<16>>16;e=j;t[e>>2]=i;t[e+4>>2]=((i|0)<0)<<31>>31;break e;break}case 14:{i=t[r>>2]|0;e=t[i>>2]|0;t[r>>2]=i+4;i=j;t[i>>2]=e&65535;t[i+4>>2]=0;break e;break}case 15:{i=t[r>>2]|0;e=t[i>>2]|0;t[r>>2]=i+4;i=(e&255)<<24>>24;e=j;t[e>>2]=i;t[e+4>>2]=((i|0)<0)<<31>>31;break e;break}case 16:{i=t[r>>2]|0;e=t[i>>2]|0;t[r>>2]=i+4;i=j;t[i>>2]=e&255;t[i+4>>2]=0;break e;break}case 17:{i=t[r>>2]|0;t[k>>2]=t[i>>2];t[k+4>>2]=t[i+4>>2];ir=+l[k>>3];t[r>>2]=i+8;l[j>>3]=ir;break e;break}case 18:{i=t[r>>2]|0;t[k>>2]=t[i>>2];t[k+4>>2]=t[i+4>>2];ir=+l[k>>3];t[r>>2]=i+8;l[j>>3]=ir;break e;break}default:break e}while(0);while(0);Sn=Sn+1|0;if((Sn|0)>=10){de=1;q=370;break}}if((q|0)==370){s=c;return de|0}while(1){if(t[o+(gn<<2)>>2]|0){de=-1;q=370;break}gn=gn+1|0;if((gn|0)>=10){de=1;q=370;break}}if((q|0)==370){s=c;return de|0}}else if((q|0)==370){s=c;return de|0}return 0}function PY(){}function BY(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0;f=i-n>>>0;f=i-n-(r>>>0>e>>>0|0)>>>0;return(P=f,e-r>>>0|0)|0}function IY(e,i,r){e=e|0;i=i|0;r=r|0;if((r|0)<32){P=i>>r;return e>>>r|(i&(1<<r)-1)<<32-r}P=(i|0)<0?-1:0;return i>>r-32|0}function HY(e){e=e|0;var i=0;i=e;while(n[i>>0]|0)i=i+1|0;return i-e|0}function xY(e,i){e=e|0;i=i|0;var r=0,f=0;r=e+(HY(e)|0)|0;do{n[r+f>>0]=n[i+f>>0];f=f+1|0}while(n[i+(f-1)>>0]|0);return e|0}function UY(e,i,r){e=e|0;i=i|0;r=r|0;if((r|0)<32){P=i<<r|(e&(1<<r)-1<<32-r)>>>32-r;return e<<r}P=e<<r-32;return 0}function zY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,t=0;while((f|0)<(r|0)){n[e+f>>0]=t?0:n[i+f>>0]|0;t=t?1:(n[i+f>>0]|0)==0;f=f+1|0}return e|0}function jY(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0;f=e+r>>>0;return(P=i+n+(f>>>0<e>>>0|0)>>>0,f|0)|0}function VY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0,u=0,a=0,o=0;f=e+r|0;if((r|0)>=20){i=i&255;u=e&3;a=i|i<<8|i<<16|i<<24;o=f&~3;if(u){u=e+4-u|0;while((e|0)<(u|0)){n[e>>0]=i;e=e+1|0}}while((e|0)<(o|0)){t[e>>2]=a;e=e+4|0}}while((e|0)<(f|0)){n[e>>0]=i;e=e+1|0}return e-r|0}function qY(e,i,r){e=e|0;i=i|0;r=r|0;if((r|0)<32){P=i>>>r;return e>>>r|(i&(1<<r)-1)<<32-r}P=0;return i>>>r-32|0}function YY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0;if((r|0)>=4096)return je(e|0,i|0,r|0)|0;f=e|0;if((e&3)==(i&3)){while(e&3){if(!r)return f|0;n[e>>0]=n[i>>0]|0;e=e+1|0;i=i+1|0;r=r-1|0}while((r|0)>=4){t[e>>2]=t[i>>2];e=e+4|0;i=i+4|0;r=r-4|0}}while((r|0)>0){n[e>>0]=n[i>>0]|0;e=e+1|0;i=i+1|0;r=r-1|0}return f|0}function GY(e,i,r){e=e|0;i=i|0;r=r|0;var f=0;if((i|0)<(e|0)&(e|0)<(i+r|0)){f=e;i=i+r|0;e=e+r|0;while((r|0)>0){e=e-1|0;i=i-1|0;r=r-1|0;n[e>>0]=n[i>>0]|0}e=f}else YY(e,i,r)|0;return e|0}function WY(e,i){e=e|0;i=i|0;var r=0;do{n[e+r>>0]=n[i+r>>0];r=r+1|0}while(n[i+(r-1)>>0]|0);return e|0}function KY(e){e=e|0;var i=0;i=n[d+(e>>>24)>>0]|0;if((i|0)<8)return i|0;i=n[d+(e>>16&255)>>0]|0;if((i|0)<8)return i+8|0;i=n[d+(e>>8&255)>>0]|0;if((i|0)<8)return i+16|0;return(n[d+(e&255)>>0]|0)+24|0}function XY(e){e=e|0;var i=0;i=n[w+(e&255)>>0]|0;if((i|0)<8)return i|0;i=n[w+(e>>8&255)>>0]|0;if((i|0)<8)return i+8|0;i=n[w+(e>>16&255)>>0]|0;if((i|0)<8)return i+16|0;return(n[w+(e>>>24)>>0]|0)+24|0}function ZY(e,i){e=e|0;i=i|0;var r=0,n=0,f=0,t=0;r=e&65535;n=i&65535;f=te(n,r)|0;t=e>>>16;e=(f>>>16)+(te(n,t)|0)|0;n=i>>>16;i=te(n,r)|0;return(P=(e>>>16)+(te(n,t)|0)+(((e&65535)+i|0)>>>16)|0,e+i<<16|f&65535|0)|0}function JY(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,t=0,u=0,a=0,o=0;f=i>>31|((i|0)<0?-1:0)<<1;t=((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1;u=n>>31|((n|0)<0?-1:0)<<1;a=((n|0)<0?-1:0)>>31|((n|0)<0?-1:0)<<1;o=BY(f^e,t^i,f,t)|0;i=P;e=u^f;f=a^t;t=BY((rG(o,i,BY(u^r,a^n,u,a)|0,P,0)|0)^e,P^f,e,f)|0;return t|0}function QY(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0,a=0,o=0,c=0,l=0,b=0;f=s;s=s+8|0;u=f|0;a=i>>31|((i|0)<0?-1:0)<<1;o=((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1;c=n>>31|((n|0)<0?-1:0)<<1;l=((n|0)<0?-1:0)>>31|((n|0)<0?-1:0)<<1;b=BY(a^e,o^i,a,o)|0;i=P;rG(b,i,BY(c^r,l^n,c,l)|0,P,u)|0;l=BY(t[u>>2]^a,t[u+4>>2]^o,a,o)|0;o=P;s=f;return(P=o,l)|0}function $Y(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,t=0;f=e;e=r;r=ZY(f,e)|0;t=P;return(P=(te(i,e)|0)+(te(n,f)|0)+t|t&0,r|0|0)|0}function eG(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0;f=rG(e,i,r,n,0)|0;return f|0}function iG(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;var f=0,u=0;f=s;s=s+8|0;u=f|0;rG(e,i,r,n,u)|0;s=f;return(P=t[u+4>>2]|0,t[u>>2]|0)|0}function rG(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;var u=0,a=0,o=0,c=0,l=0,s=0,b=0,k=0,h=0,w=0,d=0,v=0,m=0,_=0,p=0,E=0,S=0,g=0,y=0,F=0,O=0,A=0,M=0,R=0,N=0,T=0,L=0;u=e;a=i;o=a;c=r;l=n;s=l;if(!o){b=(f|0)!=0;if(!s){if(b){t[f>>2]=(u>>>0)%(c>>>0);t[f+4>>2]=0}k=0;h=(u>>>0)/(c>>>0)>>>0;return(P=k,h)|0}else{if(!b){k=0;h=0;return(P=k,h)|0}t[f>>2]=e|0;t[f+4>>2]=i&0;k=0;h=0;return(P=k,h)|0}}b=(s|0)==0;do if(c){if(!b){w=(KY(s|0)|0)-(KY(o|0)|0)|0;if(w>>>0<=31){d=w+1|0;v=31-w|0;m=w-31>>31;_=d;p=u>>>(d>>>0)&m|o<<v;E=o>>>(d>>>0)&m;S=0;g=u<<v;break}if(!f){k=0;h=0;return(P=k,h)|0}t[f>>2]=e|0;t[f+4>>2]=a|i&0;k=0;h=0;return(P=k,h)|0}v=c-1|0;if(v&c){m=(KY(c|0)|0)+33-(KY(o|0)|0)|0;d=64-m|0;w=32-m|0;y=w>>31;F=m-32|0;O=F>>31;_=m;p=w-1>>31&o>>>(F>>>0)|(o<<w|u>>>(m>>>0))&O;E=O&o>>>(m>>>0);S=u<<d&y;g=(o<<d|u>>>(F>>>0))&y|u<<w&m-33>>31;break}if(f){t[f>>2]=v&u;t[f+4>>2]=0}if((c|0)==1){k=a|i&0;h=e|0|0;return(P=k,h)|0}else{v=XY(c|0)|0;k=o>>>(v>>>0)|0;h=o<<32-v|u>>>(v>>>0)|0;return(P=k,h)|0}}else{if(b){if(f){t[f>>2]=(o>>>0)%(c>>>0);t[f+4>>2]=0}k=0;h=(o>>>0)/(c>>>0)>>>0;return(P=k,h)|0}if(!u){if(f){t[f>>2]=0;t[f+4>>2]=(o>>>0)%(s>>>0)}k=0;h=(o>>>0)/(s>>>0)>>>0;return(P=k,h)|0}v=s-1|0;if(!(v&s)){if(f){t[f>>2]=e|0;t[f+4>>2]=v&o|i&0}k=0;h=o>>>((XY(s|0)|0)>>>0);return(P=k,h)|0}v=(KY(s|0)|0)-(KY(o|0)|0)|0;if(v>>>0<=30){m=v+1|0;w=31-v|0;_=m;p=o<<w|u>>>(m>>>0);E=o>>>(m>>>0);S=0;g=u<<w;break}if(!f){k=0;h=0;return(P=k,h)|0}t[f>>2]=e|0;t[f+4>>2]=a|i&0;k=0;h=0;return(P=k,h)|0}while(0);if(!_){A=g;M=S;R=E;N=p;T=0;L=0}else{i=r|0|0;r=l|n&0;n=jY(i,r,-1,-1)|0;l=P;a=g;g=S;S=E;E=p;p=_;_=0;do{e=a;a=g>>>31|a<<1;g=_|g<<1;u=E<<1|e>>>31|0;e=E>>>31|S<<1|0;BY(n,l,u,e)|0;o=P;s=o>>31|((o|0)<0?-1:0)<<1;_=s&1;E=BY(u,e,s&i,(((o|0)<0?-1:0)>>31|((o|0)<0?-1:0)<<1)&r)|0;S=P;p=p-1|0}while((p|0)!=0);A=a;M=g;R=S;N=E;T=0;L=_}_=M;M=0;if(f){t[f>>2]=N;t[f+4>>2]=R}k=(_|0)>>>31|(A|M)<<1|(M<<1|_>>>31)&0|T;h=(_<<1|0>>>31)&-2|L;return(P=k,h)|0}function nG(e,i,r,n,f,t,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;return wAi[e&511](i|0,r|0,n|0,f|0,t|0,u|0,a|0)|0}function fG(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return dAi[e&511](i|0,r|0,n|0)|0}function tG(e,i,r,n,f,t,u,a){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;vAi[e&511](i|0,r|0,n|0,f|0,t|0,u|0,a|0)}function uG(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;mAi[e&511](i|0,r|0,n|0,f|0,t|0)}function aG(e){e=e|0;return _Ai[e&511]()|0}function oG(e,i){e=e|0;i=i|0;pAi[e&511](i|0);
	}function cG(e,i,r){e=e|0;i=i|0;r=r|0;EAi[e&511](i|0,r|0)}function lG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return SAi[e&511](i|0,r|0,n|0,f|0,t|0,u|0)|0}function sG(e,i){e=e|0;i=i|0;return gAi[e&511](i|0)|0}function bG(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;yAi[e&511](i|0,r|0,n|0)}function kG(e,i,r,n,f,t,u,a,o,c){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;c=c|0;FAi[e&511](i|0,r|0,n|0,f|0,t|0,u|0,a|0,o|0,c|0)}function hG(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return OAi[e&511](i|0,r|0,n|0,f|0)|0}function wG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;AAi[e&511](i|0,r|0,n|0,f|0,t|0,u|0)}function dG(e,i,r){e=e|0;i=i|0;r=r|0;return MAi[e&511](i|0,r|0)|0}function vG(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return RAi[e&511](i|0,r|0,n|0,f|0,t|0)|0}function mG(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;NAi[e&511](i|0,r|0,n|0,f|0)}function _G(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ue(0);return 0}function pG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function EG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Pm(e|0)|0}function SG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Bm(e|0)|0}function gG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Im(e|0)|0}function yG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Hm(e|0,i|0,r|0)|0}function FG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return xm(e|0,i|0)|0}function OG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function AG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function MG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function RG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function NG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function TG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function LG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function DG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function CG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function PG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function BG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function IG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function HG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function xG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function UG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function zG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function jG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function VG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function qG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return r_(e|0,i|0)|0}function YG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function GG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function WG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function KG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function XG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return oA(e|0,i|0,r|0)|0}function ZG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function JG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Xq(e|0)|0}function QG(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Jq(e|0,i|0)|0}function $G(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Yl(e|0)|0}function eW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function iW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function rW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Mz(e|0)|0}function nW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Rz(e|0)|0}function fW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Nz(e|0)|0}function tW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Dz(e|0,i|0,r|0)|0}function uW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Cz(e|0,i|0)|0}function aW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function oW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function cW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function lW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function sW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function bW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function kW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function hW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function wW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function dW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function vW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function mW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function _W(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function pW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function EW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function SW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function gW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Pz(e|0,i|0)|0}function yW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function FW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function OW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return yz(e|0)|0}function AW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Fz(e|0)|0}function MW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Oz(e|0)|0}function RW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Az(e|0)|0}function NW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function TW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return OC(e|0)|0}function LW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return AC(e|0)|0}function DW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return MC(e|0)|0}function CW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return RC(e|0)|0}function PW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return NC(e|0)|0}function BW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return TC(e|0)|0}function IW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return LC(e|0)|0}function HW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return DC(e|0)|0}function xW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return CC(e|0)|0}function UW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return PC(e|0)|0}function zW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return BC(e|0)|0}function jW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return IC(e|0)|0}function VW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return HC(e|0)|0}function qW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return xC(e|0)|0}function YW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return UC(e|0)|0}function GW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return zC(e|0)|0}function WW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return jC(e|0)|0}function KW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return VC(e|0)|0}function XW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return qC(e|0)|0}function ZW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return YC(e|0)|0}function JW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return GC(e|0)|0}function QW(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return WC(e|0)|0}function $W(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return KC(e|0)|0}function eK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return XC(e|0)|0}function iK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ZC(e|0)|0}function rK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return JC(e|0)|0}function nK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return QC(e|0)|0}function fK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return $C(e|0)|0}function tK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return eP(e|0)|0}function uK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return iP(e|0)|0}function aK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return rP(e|0)|0}function oK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return nP(e|0)|0}function cK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return fP(e|0)|0}function lK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return tP(e|0)|0}function sK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return uP(e|0)|0}function bK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return aP(e|0)|0}function kK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return oP(e|0)|0}function hK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return cP(e|0)|0}function wK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return lP(e|0)|0}function dK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return sP(e|0)|0}function vK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return bP(e|0)|0}function mK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return kP(e|0)|0}function _K(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return hP(e|0)|0}function pK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return wP(e|0)|0}function EK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return dP(e|0)|0}function SK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return vP(e|0)|0}function gK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return mP(e|0)|0}function yK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return _P(e|0)|0}function FK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return pP(e|0)|0}function OK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return EP(e|0)|0}function AK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return SP(e|0)|0}function MK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return gP(e|0)|0}function RK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return yP(e|0)|0}function NK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return FP(e|0)|0}function TK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return OP(e|0)|0}function LK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return AP(e|0)|0}function DK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return MP(e|0)|0}function CK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return RP(e|0)|0}function PK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return NP(e|0)|0}function BK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return TP(e|0)|0}function IK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return LP(e|0)|0}function HK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return DP(e|0)|0}function xK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return CP(e|0)|0}function UK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return PP(e|0)|0}function zK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return BP(e|0)|0}function jK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return IP(e|0)|0}function VK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return HP(e|0)|0}function qK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return xP(e|0)|0}function YK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return UP(e|0)|0}function GK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return zP(e|0)|0}function WK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return jP(e|0)|0}function KK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return VP(e|0)|0}function XK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return qP(e|0)|0}function ZK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return YP(e|0)|0}function JK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return GP(e|0)|0}function QK(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return WP(e|0)|0}function $K(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return KP(e|0)|0}function eX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return XP(e|0)|0}function iX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ZP(e|0)|0}function rX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return JP(e|0)|0}function nX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return QP(e|0)|0}function fX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return $P(e|0)|0}function tX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return eB(e|0)|0}function uX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return iB(e|0)|0}function aX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return rB(e|0)|0}function oX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return nB(e|0)|0}function cX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return fB(e|0)|0}function lX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return tB(e|0)|0}function sX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return uB(e|0)|0}function bX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return aB(e|0)|0}function kX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return oB(e|0)|0}function hX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return cB(e|0)|0}function wX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return lB(e|0)|0}function dX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return sB(e|0)|0}function vX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return bB(e|0)|0}function mX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return kB(e|0)|0}function _X(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return hB(e|0)|0}function pX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return wB(e|0)|0}function EX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return dB(e|0)|0}function SX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return vB(e|0)|0}function gX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return mB(e|0)|0}function yX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return _B(e|0)|0}function FX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return pB(e|0)|0}function OX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return EB(e|0)|0}function AX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return SB(e|0)|0}function MX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return gB(e|0)|0}function RX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return yB(e|0)|0}function NX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return FB(e|0)|0}function TX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return OB(e|0)|0}function LX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return AB(e|0)|0}function DX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return MB(e|0)|0}function CX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return RB(e|0)|0}function PX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return NB(e|0)|0}function BX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return TB(e|0)|0}function IX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return LB(e|0)|0}function HX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return DB(e|0)|0}function xX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return CB(e|0)|0}function UX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return PB(e|0)|0}function zX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return BB(e|0)|0}function jX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return IB(e|0)|0}function VX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return HB(e|0)|0}function qX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return xB(e|0)|0}function YX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return UB(e|0)|0}function GX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return zB(e|0)|0}function WX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return jB(e|0)|0}function KX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return VB(e|0)|0}function XX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return qB(e|0)|0}function ZX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return YB(e|0)|0}function JX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return NY(e|0,i|0,r|0)|0}function QX(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function $X(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return om(e|0)|0}function eZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return cm(e|0,i|0)|0}function iZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return lm(e|0)|0}function rZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return aA(e|0,i|0,r|0)|0}function nZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function fZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function tZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return hm(e|0,i|0,r|0)|0}function uZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return xe(e|0,i|0,r|0)|0}function aZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return pm(e|0,i|0,r|0)|0}function oZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function cZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function lZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function sZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function bZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function kZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Am(e|0)|0}function hZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function wZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return A_(e|0)|0}function dZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Z_(e|0,i|0,r|0,n|0)|0}function vZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return J_(e|0,i|0,r|0,n|0)|0}function mZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Q_(e|0,i|0,r|0,n|0)|0}function _Z(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return $_(e|0,i|0,r|0,n|0)|0}function pZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ep(e|0,i|0,r|0,n|0)|0}function EZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ip(e|0,i|0,r|0,n|0)|0}function SZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return N_(e|0,i|0,r|0,n|0)|0}function gZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return T_(e|0,i|0,r|0,n|0)|0}function yZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return rp(e|0,i|0,r|0,n|0)|0}function FZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return np(e|0,i|0,r|0,n|0)|0}function OZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return dN(e|0,i|0,r|0,n|0)|0}function AZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function MZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function RZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function NZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return FO()|0}function TZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function LZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function DZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return OO(e|0)|0}function CZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return AO(e|0)|0}function PZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return MO(e|0,i|0,r|0)|0}function BZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return RO(e|0)|0}function IZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return sA(e|0)|0}function HZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return bA(e|0,i|0,r|0)|0}function xZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return hA(e|0)|0}function UZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return wA(e|0,i|0,r|0)|0}function zZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return dA(e|0)|0}function jZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return vA(e|0,i|0,r|0)|0}function VZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return mA(e|0,i|0,r|0)|0}function qZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return _A(e|0,i|0,r|0,n|0)|0}function YZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function GZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return OR(e|0)|0}function WZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function KZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return DR(e|0)|0}function XZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function ZZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return BR(e|0)|0}function JZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function QZ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function $Z(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function eJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return UR(e|0,i|0)|0}function iJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function rJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function nJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function fJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function tJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function uJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function aJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return lN(e|0,i|0)|0}function oJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function cJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function lJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function sJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function bJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function kJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function hJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function wJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function dJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function vJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function mJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function _J(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function pJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function EJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function SJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function gJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function yJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function FJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function OJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function AJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function MJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function RJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function NJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function TJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function LJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function DJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function CJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function PJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function BJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function IJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function HJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Qu(e|0,i|0,r|0)|0}function xJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Pf(e|0,i|0)|0}function UJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Bf(e|0,i|0)|0}function zJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return zf(e|0,i|0)|0}function jJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return $u(e|0,i|0,r|0)|0}function VJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ea(e|0,i|0)|0}function qJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Tf(e|0,i|0)|0}function YJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Lf(e|0,i|0)|0}function GJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Df(e|0,i|0)|0}function WJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return xf(e|0,i|0)|0}function KJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return If(e|0,i|0)|0}function XJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Uf(e|0,i|0)|0}function ZJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Cf(e|0,i|0)|0}function JJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ia(e|0,i|0)|0}function QJ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Hf(e|0,i|0)|0}function $J(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Nf(e|0,i|0)|0}function eQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Cn(e|0,i|0)|0}function iQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function rQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function nQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function fQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function tQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function uQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function aQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function oQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function cQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function lQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function sQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function bQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return wl(e|0,i|0,r|0)|0}function kQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Ll(e|0,i|0)|0}function hQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Bl(e|0,i|0)|0}function wQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Hl(e|0,i|0)|0}function dQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return jl(e|0,i|0)|0}function vQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function mQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function _Q(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function pQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function EQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function SQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function gQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function yQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Sh(e|0)|0}function FQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return gh(e|0)|0}function OQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return yh(e|0)|0}function AQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Fh(e|0,i|0,r|0)|0}function MQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Oh(e|0,i|0)|0}function RQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function NQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function TQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function LQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function DQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function CQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function PQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function BQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function IQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function HQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function xQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function UQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function zQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function jQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Uh(e|0,i|0)|0}function VQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function qQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function YQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function GQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function WQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function KQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function XQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function ZQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Zh(e|0,i|0,r|0)|0}function JQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function QQ(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function $Q(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function e$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function i$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function r$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function n$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function f$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function t$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function u$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function a$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function o$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function c$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function l$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return _H(e|0,i|0,r|0)|0}function s$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function b$(e,i,r,n,f,t,u){e=e|0;
	i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function k$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ex(e|0,i|0)|0}function h$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ix(e|0,i|0,r|0,n|0,f|0)|0}function w$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return nx(e|0,i|0,r|0,n|0,f|0,t|0)|0}function d$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function v$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ux(e|0,i|0)|0}function m$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return ax(e|0,i|0,r|0,n|0,f|0)|0}function _$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function p$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function E$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function S$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function g$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function y$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function F$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function O$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function A$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return 0}function M$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return PV(e|0,i|0,r|0,n|0)|0}function R$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Rq(e|0,i|0)|0}function N$(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;return Kq(e|0,i|0,r|0)|0}function T$(e,i,r){e=e|0;i=i|0;r=r|0;ue(1);return 0}function L$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function D$(e,i,r){e=e|0;i=i|0;r=r|0;return Pm(e|0)|0}function C$(e,i,r){e=e|0;i=i|0;r=r|0;return Bm(e|0)|0}function P$(e,i,r){e=e|0;i=i|0;r=r|0;return Im(e|0)|0}function B$(e,i,r){e=e|0;i=i|0;r=r|0;return xm(e|0,i|0)|0}function I$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function H$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function x$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function U$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function z$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function j$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function V$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function q$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Y$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function G$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function W$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function K$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function X$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Z$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function J$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Q$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function $$(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function e0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function i0(e,i,r){e=e|0;i=i|0;r=r|0;return r_(e|0,i|0)|0}function r0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function n0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function f0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function t0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function u0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function a0(e,i,r){e=e|0;i=i|0;r=r|0;return Xq(e|0)|0}function o0(e,i,r){e=e|0;i=i|0;r=r|0;return Jq(e|0,i|0)|0}function c0(e,i,r){e=e|0;i=i|0;r=r|0;return Yl(e|0)|0}function l0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function s0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function b0(e,i,r){e=e|0;i=i|0;r=r|0;return Mz(e|0)|0}function k0(e,i,r){e=e|0;i=i|0;r=r|0;return Rz(e|0)|0}function h0(e,i,r){e=e|0;i=i|0;r=r|0;return Nz(e|0)|0}function w0(e,i,r){e=e|0;i=i|0;r=r|0;return Cz(e|0,i|0)|0}function d0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function v0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function m0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function _0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function p0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function E0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function S0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function g0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function y0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function F0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function O0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function A0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function M0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function R0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function N0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function T0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function L0(e,i,r){e=e|0;i=i|0;r=r|0;return Pz(e|0,i|0)|0}function D0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function C0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function P0(e,i,r){e=e|0;i=i|0;r=r|0;return yz(e|0)|0}function B0(e,i,r){e=e|0;i=i|0;r=r|0;return Fz(e|0)|0}function I0(e,i,r){e=e|0;i=i|0;r=r|0;return Oz(e|0)|0}function H0(e,i,r){e=e|0;i=i|0;r=r|0;return Az(e|0)|0}function x0(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function U0(e,i,r){e=e|0;i=i|0;r=r|0;return OC(e|0)|0}function z0(e,i,r){e=e|0;i=i|0;r=r|0;return AC(e|0)|0}function j0(e,i,r){e=e|0;i=i|0;r=r|0;return MC(e|0)|0}function V0(e,i,r){e=e|0;i=i|0;r=r|0;return RC(e|0)|0}function q0(e,i,r){e=e|0;i=i|0;r=r|0;return NC(e|0)|0}function Y0(e,i,r){e=e|0;i=i|0;r=r|0;return TC(e|0)|0}function G0(e,i,r){e=e|0;i=i|0;r=r|0;return LC(e|0)|0}function W0(e,i,r){e=e|0;i=i|0;r=r|0;return DC(e|0)|0}function K0(e,i,r){e=e|0;i=i|0;r=r|0;return CC(e|0)|0}function X0(e,i,r){e=e|0;i=i|0;r=r|0;return PC(e|0)|0}function Z0(e,i,r){e=e|0;i=i|0;r=r|0;return BC(e|0)|0}function J0(e,i,r){e=e|0;i=i|0;r=r|0;return IC(e|0)|0}function Q0(e,i,r){e=e|0;i=i|0;r=r|0;return HC(e|0)|0}function $0(e,i,r){e=e|0;i=i|0;r=r|0;return xC(e|0)|0}function e1(e,i,r){e=e|0;i=i|0;r=r|0;return UC(e|0)|0}function i1(e,i,r){e=e|0;i=i|0;r=r|0;return zC(e|0)|0}function r1(e,i,r){e=e|0;i=i|0;r=r|0;return jC(e|0)|0}function n1(e,i,r){e=e|0;i=i|0;r=r|0;return VC(e|0)|0}function f1(e,i,r){e=e|0;i=i|0;r=r|0;return qC(e|0)|0}function t1(e,i,r){e=e|0;i=i|0;r=r|0;return YC(e|0)|0}function u1(e,i,r){e=e|0;i=i|0;r=r|0;return GC(e|0)|0}function a1(e,i,r){e=e|0;i=i|0;r=r|0;return WC(e|0)|0}function o1(e,i,r){e=e|0;i=i|0;r=r|0;return KC(e|0)|0}function c1(e,i,r){e=e|0;i=i|0;r=r|0;return XC(e|0)|0}function l1(e,i,r){e=e|0;i=i|0;r=r|0;return ZC(e|0)|0}function s1(e,i,r){e=e|0;i=i|0;r=r|0;return JC(e|0)|0}function b1(e,i,r){e=e|0;i=i|0;r=r|0;return QC(e|0)|0}function k1(e,i,r){e=e|0;i=i|0;r=r|0;return $C(e|0)|0}function h1(e,i,r){e=e|0;i=i|0;r=r|0;return eP(e|0)|0}function w1(e,i,r){e=e|0;i=i|0;r=r|0;return iP(e|0)|0}function d1(e,i,r){e=e|0;i=i|0;r=r|0;return rP(e|0)|0}function v1(e,i,r){e=e|0;i=i|0;r=r|0;return nP(e|0)|0}function m1(e,i,r){e=e|0;i=i|0;r=r|0;return fP(e|0)|0}function _1(e,i,r){e=e|0;i=i|0;r=r|0;return tP(e|0)|0}function p1(e,i,r){e=e|0;i=i|0;r=r|0;return uP(e|0)|0}function E1(e,i,r){e=e|0;i=i|0;r=r|0;return aP(e|0)|0}function S1(e,i,r){e=e|0;i=i|0;r=r|0;return oP(e|0)|0}function g1(e,i,r){e=e|0;i=i|0;r=r|0;return cP(e|0)|0}function y1(e,i,r){e=e|0;i=i|0;r=r|0;return lP(e|0)|0}function F1(e,i,r){e=e|0;i=i|0;r=r|0;return sP(e|0)|0}function O1(e,i,r){e=e|0;i=i|0;r=r|0;return bP(e|0)|0}function A1(e,i,r){e=e|0;i=i|0;r=r|0;return kP(e|0)|0}function M1(e,i,r){e=e|0;i=i|0;r=r|0;return hP(e|0)|0}function R1(e,i,r){e=e|0;i=i|0;r=r|0;return wP(e|0)|0}function N1(e,i,r){e=e|0;i=i|0;r=r|0;return dP(e|0)|0}function T1(e,i,r){e=e|0;i=i|0;r=r|0;return vP(e|0)|0}function L1(e,i,r){e=e|0;i=i|0;r=r|0;return mP(e|0)|0}function D1(e,i,r){e=e|0;i=i|0;r=r|0;return _P(e|0)|0}function C1(e,i,r){e=e|0;i=i|0;r=r|0;return pP(e|0)|0}function P1(e,i,r){e=e|0;i=i|0;r=r|0;return EP(e|0)|0}function B1(e,i,r){e=e|0;i=i|0;r=r|0;return SP(e|0)|0}function I1(e,i,r){e=e|0;i=i|0;r=r|0;return gP(e|0)|0}function H1(e,i,r){e=e|0;i=i|0;r=r|0;return yP(e|0)|0}function x1(e,i,r){e=e|0;i=i|0;r=r|0;return FP(e|0)|0}function U1(e,i,r){e=e|0;i=i|0;r=r|0;return OP(e|0)|0}function z1(e,i,r){e=e|0;i=i|0;r=r|0;return AP(e|0)|0}function j1(e,i,r){e=e|0;i=i|0;r=r|0;return MP(e|0)|0}function V1(e,i,r){e=e|0;i=i|0;r=r|0;return RP(e|0)|0}function q1(e,i,r){e=e|0;i=i|0;r=r|0;return NP(e|0)|0}function Y1(e,i,r){e=e|0;i=i|0;r=r|0;return TP(e|0)|0}function G1(e,i,r){e=e|0;i=i|0;r=r|0;return LP(e|0)|0}function W1(e,i,r){e=e|0;i=i|0;r=r|0;return DP(e|0)|0}function K1(e,i,r){e=e|0;i=i|0;r=r|0;return CP(e|0)|0}function X1(e,i,r){e=e|0;i=i|0;r=r|0;return PP(e|0)|0}function Z1(e,i,r){e=e|0;i=i|0;r=r|0;return BP(e|0)|0}function J1(e,i,r){e=e|0;i=i|0;r=r|0;return IP(e|0)|0}function Q1(e,i,r){e=e|0;i=i|0;r=r|0;return HP(e|0)|0}function $1(e,i,r){e=e|0;i=i|0;r=r|0;return xP(e|0)|0}function e2(e,i,r){e=e|0;i=i|0;r=r|0;return UP(e|0)|0}function i2(e,i,r){e=e|0;i=i|0;r=r|0;return zP(e|0)|0}function r2(e,i,r){e=e|0;i=i|0;r=r|0;return jP(e|0)|0}function n2(e,i,r){e=e|0;i=i|0;r=r|0;return VP(e|0)|0}function f2(e,i,r){e=e|0;i=i|0;r=r|0;return qP(e|0)|0}function t2(e,i,r){e=e|0;i=i|0;r=r|0;return YP(e|0)|0}function u2(e,i,r){e=e|0;i=i|0;r=r|0;return GP(e|0)|0}function a2(e,i,r){e=e|0;i=i|0;r=r|0;return WP(e|0)|0}function o2(e,i,r){e=e|0;i=i|0;r=r|0;return KP(e|0)|0}function c2(e,i,r){e=e|0;i=i|0;r=r|0;return XP(e|0)|0}function l2(e,i,r){e=e|0;i=i|0;r=r|0;return ZP(e|0)|0}function s2(e,i,r){e=e|0;i=i|0;r=r|0;return JP(e|0)|0}function b2(e,i,r){e=e|0;i=i|0;r=r|0;return QP(e|0)|0}function k2(e,i,r){e=e|0;i=i|0;r=r|0;return $P(e|0)|0}function h2(e,i,r){e=e|0;i=i|0;r=r|0;return eB(e|0)|0}function w2(e,i,r){e=e|0;i=i|0;r=r|0;return iB(e|0)|0}function d2(e,i,r){e=e|0;i=i|0;r=r|0;return rB(e|0)|0}function v2(e,i,r){e=e|0;i=i|0;r=r|0;return nB(e|0)|0}function m2(e,i,r){e=e|0;i=i|0;r=r|0;return fB(e|0)|0}function _2(e,i,r){e=e|0;i=i|0;r=r|0;return tB(e|0)|0}function p2(e,i,r){e=e|0;i=i|0;r=r|0;return uB(e|0)|0}function E2(e,i,r){e=e|0;i=i|0;r=r|0;return aB(e|0)|0}function S2(e,i,r){e=e|0;i=i|0;r=r|0;return oB(e|0)|0}function g2(e,i,r){e=e|0;i=i|0;r=r|0;return cB(e|0)|0}function y2(e,i,r){e=e|0;i=i|0;r=r|0;return lB(e|0)|0}function F2(e,i,r){e=e|0;i=i|0;r=r|0;return sB(e|0)|0}function O2(e,i,r){e=e|0;i=i|0;r=r|0;return bB(e|0)|0}function A2(e,i,r){e=e|0;i=i|0;r=r|0;return kB(e|0)|0}function M2(e,i,r){e=e|0;i=i|0;r=r|0;return hB(e|0)|0}function R2(e,i,r){e=e|0;i=i|0;r=r|0;return wB(e|0)|0}function N2(e,i,r){e=e|0;i=i|0;r=r|0;return dB(e|0)|0}function T2(e,i,r){e=e|0;i=i|0;r=r|0;return vB(e|0)|0}function L2(e,i,r){e=e|0;i=i|0;r=r|0;return mB(e|0)|0}function D2(e,i,r){e=e|0;i=i|0;r=r|0;return _B(e|0)|0}function C2(e,i,r){e=e|0;i=i|0;r=r|0;return pB(e|0)|0}function P2(e,i,r){e=e|0;i=i|0;r=r|0;return EB(e|0)|0}function B2(e,i,r){e=e|0;i=i|0;r=r|0;return SB(e|0)|0}function I2(e,i,r){e=e|0;i=i|0;r=r|0;return gB(e|0)|0}function H2(e,i,r){e=e|0;i=i|0;r=r|0;return yB(e|0)|0}function x2(e,i,r){e=e|0;i=i|0;r=r|0;return FB(e|0)|0}function U2(e,i,r){e=e|0;i=i|0;r=r|0;return OB(e|0)|0}function z2(e,i,r){e=e|0;i=i|0;r=r|0;return AB(e|0)|0}function j2(e,i,r){e=e|0;i=i|0;r=r|0;return MB(e|0)|0}function V2(e,i,r){e=e|0;i=i|0;r=r|0;return RB(e|0)|0}function q2(e,i,r){e=e|0;i=i|0;r=r|0;return NB(e|0)|0}function Y2(e,i,r){e=e|0;i=i|0;r=r|0;return TB(e|0)|0}function G2(e,i,r){e=e|0;i=i|0;r=r|0;return LB(e|0)|0}function W2(e,i,r){e=e|0;i=i|0;r=r|0;return DB(e|0)|0}function K2(e,i,r){e=e|0;i=i|0;r=r|0;return CB(e|0)|0}function X2(e,i,r){e=e|0;i=i|0;r=r|0;return PB(e|0)|0}function Z2(e,i,r){e=e|0;i=i|0;r=r|0;return BB(e|0)|0}function J2(e,i,r){e=e|0;i=i|0;r=r|0;return IB(e|0)|0}function Q2(e,i,r){e=e|0;i=i|0;r=r|0;return HB(e|0)|0}function $2(e,i,r){e=e|0;i=i|0;r=r|0;return xB(e|0)|0}function e3(e,i,r){e=e|0;i=i|0;r=r|0;return UB(e|0)|0}function i3(e,i,r){e=e|0;i=i|0;r=r|0;return zB(e|0)|0}function r3(e,i,r){e=e|0;i=i|0;r=r|0;return jB(e|0)|0}function n3(e,i,r){e=e|0;i=i|0;r=r|0;return VB(e|0)|0}function f3(e,i,r){e=e|0;i=i|0;r=r|0;return qB(e|0)|0}function t3(e,i,r){e=e|0;i=i|0;r=r|0;return YB(e|0)|0}function u3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function a3(e,i,r){e=e|0;i=i|0;r=r|0;return om(e|0)|0}function o3(e,i,r){e=e|0;i=i|0;r=r|0;return cm(e|0,i|0)|0}function c3(e,i,r){e=e|0;i=i|0;r=r|0;return lm(e|0)|0}function l3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function s3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function b3(e,i,r){e=e|0;i=i|0;r=r|0;return xe(e|0,i|0,r|0)|0}function k3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function h3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function w3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function d3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function v3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function m3(e,i,r){e=e|0;i=i|0;r=r|0;return Am(e|0)|0}function _3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function p3(e,i,r){e=e|0;i=i|0;r=r|0;return A_(e|0)|0}function E3(e,i,r){e=e|0;i=i|0;r=r|0;return Z_(e|0,i|0,r|0,0)|0}function S3(e,i,r){e=e|0;i=i|0;r=r|0;return J_(e|0,i|0,r|0,0)|0}function g3(e,i,r){e=e|0;i=i|0;r=r|0;return Q_(e|0,i|0,r|0,0)|0}function y3(e,i,r){e=e|0;i=i|0;r=r|0;return $_(e|0,i|0,r|0,0)|0}function F3(e,i,r){e=e|0;i=i|0;r=r|0;return ep(e|0,i|0,r|0,0)|0}function O3(e,i,r){e=e|0;i=i|0;r=r|0;return ip(e|0,i|0,r|0,0)|0}function A3(e,i,r){e=e|0;i=i|0;r=r|0;return N_(e|0,i|0,r|0,0)|0}function M3(e,i,r){e=e|0;i=i|0;r=r|0;return T_(e|0,i|0,r|0,0)|0}function R3(e,i,r){e=e|0;i=i|0;r=r|0;return rp(e|0,i|0,r|0,0)|0}function N3(e,i,r){e=e|0;i=i|0;r=r|0;return np(e|0,i|0,r|0,0)|0}function T3(e,i,r){e=e|0;i=i|0;r=r|0;return dN(e|0,i|0,r|0,0)|0}function L3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function D3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function C3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function P3(e,i,r){e=e|0;i=i|0;r=r|0;return FO()|0}function B3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function I3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function H3(e,i,r){e=e|0;i=i|0;r=r|0;return OO(e|0)|0}function x3(e,i,r){e=e|0;i=i|0;r=r|0;return AO(e|0)|0}function U3(e,i,r){e=e|0;i=i|0;r=r|0;return RO(e|0)|0}function z3(e,i,r){e=e|0;i=i|0;r=r|0;return sA(e|0)|0}function j3(e,i,r){e=e|0;i=i|0;r=r|0;return hA(e|0)|0}function V3(e,i,r){e=e|0;i=i|0;r=r|0;return dA(e|0)|0}function q3(e,i,r){e=e|0;i=i|0;r=r|0;return _A(e|0,i|0,r|0,0)|0}function Y3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function G3(e,i,r){e=e|0;i=i|0;r=r|0;return OR(e|0)|0}function W3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function K3(e,i,r){e=e|0;i=i|0;r=r|0;return DR(e|0)|0}function X3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Z3(e,i,r){e=e|0;i=i|0;r=r|0;return BR(e|0)|0}function J3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Q3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function $3(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function e4(e,i,r){e=e|0;i=i|0;r=r|0;return UR(e|0,i|0)|0}function i4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function r4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function n4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function f4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function t4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function u4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function a4(e,i,r){e=e|0;i=i|0;r=r|0;return lN(e|0,i|0)|0}function o4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function c4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function l4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function s4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function b4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function k4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function h4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function w4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function d4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function v4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function m4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function _4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function p4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function E4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function S4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function g4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function y4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function F4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function O4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function A4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function M4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function R4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function N4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function T4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function L4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function D4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function C4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function P4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function B4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function I4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function H4(e,i,r){e=e|0;i=i|0;r=r|0;return Pf(e|0,i|0)|0}function x4(e,i,r){e=e|0;i=i|0;r=r|0;return Bf(e|0,i|0)|0}function U4(e,i,r){e=e|0;i=i|0;r=r|0;return zf(e|0,i|0)|0}function z4(e,i,r){e=e|0;i=i|0;r=r|0;return ea(e|0,i|0)|0}function j4(e,i,r){e=e|0;i=i|0;r=r|0;return Tf(e|0,i|0)|0}function V4(e,i,r){e=e|0;i=i|0;r=r|0;return Lf(e|0,i|0)|0}function q4(e,i,r){e=e|0;i=i|0;r=r|0;return Df(e|0,i|0)|0}function Y4(e,i,r){e=e|0;i=i|0;r=r|0;return xf(e|0,i|0)|0}function G4(e,i,r){e=e|0;i=i|0;r=r|0;return If(e|0,i|0)|0}function W4(e,i,r){e=e|0;i=i|0;r=r|0;return Uf(e|0,i|0)|0}function K4(e,i,r){e=e|0;i=i|0;r=r|0;return Cf(e|0,i|0)|0}function X4(e,i,r){e=e|0;i=i|0;r=r|0;return ia(e|0,i|0)|0}function Z4(e,i,r){e=e|0;i=i|0;r=r|0;return Hf(e|0,i|0)|0}function J4(e,i,r){e=e|0;i=i|0;r=r|0;return Nf(e|0,i|0)|0}function Q4(e,i,r){e=e|0;i=i|0;r=r|0;return Cn(e|0,i|0)|0}function $4(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function e8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function i8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function r8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function n8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function f8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function t8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function u8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function a8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function o8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function c8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function l8(e,i,r){e=e|0;i=i|0;r=r|0;return Ll(e|0,i|0)|0}function s8(e,i,r){e=e|0;i=i|0;r=r|0;return Bl(e|0,i|0)|0}function b8(e,i,r){e=e|0;i=i|0;r=r|0;return Hl(e|0,i|0)|0}function k8(e,i,r){e=e|0;i=i|0;r=r|0;return jl(e|0,i|0)|0}function h8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function w8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function d8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function v8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function m8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function _8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function p8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function E8(e,i,r){e=e|0;i=i|0;r=r|0;return Sh(e|0)|0}function S8(e,i,r){e=e|0;i=i|0;r=r|0;return gh(e|0)|0}function g8(e,i,r){e=e|0;i=i|0;r=r|0;return yh(e|0)|0}function y8(e,i,r){e=e|0;i=i|0;r=r|0;return Oh(e|0,i|0)|0}function F8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function O8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function A8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function M8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function R8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function N8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function T8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function L8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function D8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function C8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function P8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function B8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function I8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function H8(e,i,r){e=e|0;i=i|0;r=r|0;return Uh(e|0,i|0)|0}function x8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function U8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function z8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function j8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function V8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function q8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Y8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function G8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function W8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function K8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function X8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Z8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function J8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function Q8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function $8(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function e6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function i6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function r6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function n6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function f6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function t6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function u6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function a6(e,i,r){e=e|0;i=i|0;r=r|0;return ex(e|0,i|0)|0}function o6(e,i,r){e=e|0;i=i|0;r=r|0;return ix(e|0,i|0,r|0,0,0)|0}function c6(e,i,r){e=e|0;i=i|0;r=r|0;return rx(e|0,i|0,r|0,0,0,0,0)|0}function l6(e,i,r){e=e|0;i=i|0;r=r|0;return nx(e|0,i|0,r|0,0,0,0)|0}function s6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function b6(e,i,r){e=e|0;i=i|0;r=r|0;return ux(e|0,i|0)|0}function k6(e,i,r){e=e|0;i=i|0;r=r|0;return ax(e|0,i|0,r|0,0,0)|0}function h6(e,i,r){e=e|0;i=i|0;r=r|0;return ox(e|0,i|0,r|0,0,0,0,0)|0}function w6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function d6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function v6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function m6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function _6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function p6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function E6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function S6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function g6(e,i,r){e=e|0;i=i|0;r=r|0;return 0}function y6(e,i,r){e=e|0;i=i|0;r=r|0;return PV(e|0,i|0,r|0,0)|0}function F6(e,i,r){e=e|0;i=i|0;r=r|0;return Rq(e|0,i|0)|0}function O6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ue(2)}function A6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Cm(e|0,i|0,r|0,n|0)}function M6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Pm(e|0)|0}function R6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Bm(e|0)|0}function N6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Im(e|0)|0}function T6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Hm(e|0,i|0,r|0)|0}function L6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xm(e|0,i|0)|0}function D6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Um(e|0,i|0,r|0,n|0,f|0,t|0)}function C6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zm(e|0,i|0,r|0,n|0)}function P6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Vm(e|0,i|0,r|0,n|0)}function B6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qm(e|0,i|0,r|0,n|0,f|0)}function I6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ym(e|0,i|0)}function H6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Gm(e|0)}function x6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Wm(e|0)}function U6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;o_(e|0,i|0,r|0)}function z6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;c_(e|0,i|0)}function j6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Km(e|0,i|0)}function V6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xm(e|0,i|0,r|0)}function q6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Zm(e|0,i|0,r|0)}function Y6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Jm(e|0,i|0,r|0)}function G6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Qm(e|0,i|0)}function W6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$m(e|0,i|0,r|0)}function K6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;e_(e|0,i|0,r|0)}function X6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;i_(e|0,i|0,r|0)}function Z6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;r_(e|0,i|0)|0}function J6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;n_(e|0,i|0,r|0)}function Q6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;f_(e|0,i|0,r|0,n|0)}function $6(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;t_(e|0,i|0,r|0,n|0,f|0,t|0,u|0,0,0)}function e5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;u_(e|0,i|0,r|0,n|0)}function i5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;oA(e|0,i|0,r|0)|0}function r5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Zq(e|0)}function n5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xq(e|0)|0}function f5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Jq(e|0,i|0)|0}function t5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Yl(e|0)|0}function u5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;tp(e|0,i|0,r|0)}function a5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Tz(e|0,i|0,r|0,n|0)}function o5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Mz(e|0)|0}function c5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Rz(e|0)|0}function l5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Nz(e|0)|0}function s5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Dz(e|0,i|0,r|0)|0}function b5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Cz(e|0,i|0)|0}function k5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Bz(e|0,i|0,r|0,n|0,f|0,t|0)}function h5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xz(e|0,i|0,r|0,n|0)}function w5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Hz(e|0,i|0,r|0,n|0)}function d5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Uz(e|0,i|0,r|0,n|0,f|0)}function v5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zz(e|0,i|0)}function m5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;jz(e|0)}function _5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Vz(e|0)}function p5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qz(e|0,i|0,r|0)}function E5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Yz(e|0,i|0)}function S5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Kz(e|0,i|0)}function g5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xz(e|0,i|0,r|0)}function y5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Jz(e|0,i|0,r|0)}function F5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Qz(e|0,i|0)}function O5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;kp(e|0,i|0,r|0)}function A5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bp(e|0,i|0,r|0)}function M5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Pz(e|0,i|0)|0}function R5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$z(e|0,i|0,r|0)}function N5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Lz(e|0,i|0,r|0,n|0)}function T5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;yz(e|0)|0}function L5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Fz(e|0)|0}function D5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Oz(e|0)|0}function C5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Az(e|0)|0}function P5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Zz(e|0,i|0,r|0)}function B5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;OC(e|0)|0}function I5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;AC(e|0)|0}function H5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;MC(e|0)|0}function x5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;RC(e|0)|0}function U5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;NC(e|0)|0}function z5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;TC(e|0)|0}function j5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;LC(e|0)|0}function V5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;DC(e|0)|0}function q5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;CC(e|0)|0}function Y5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;PC(e|0)|0}function G5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;BC(e|0)|0}function W5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;IC(e|0)|0}function K5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;HC(e|0)|0}function X5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xC(e|0)|0}function Z5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;UC(e|0)|0}function J5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zC(e|0)|0}function Q5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;jC(e|0)|0}function $5(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;VC(e|0)|0}function e9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qC(e|0)|0}function i9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;YC(e|0)|0}function r9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;GC(e|0)|0}function n9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;WC(e|0)|0}function f9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;KC(e|0)|0}function t9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;XC(e|0)|0}function u9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ZC(e|0)|0}function a9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;JC(e|0)|0}function o9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;QC(e|0)|0}function c9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$C(e|0)|0}function l9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;eP(e|0)|0}function s9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;iP(e|0)|0}function b9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;rP(e|0)|0}function k9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;nP(e|0)|0}function h9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;fP(e|0)|0}function w9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;tP(e|0)|0}function d9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;uP(e|0)|0}function v9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;aP(e|0)|0}function m9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;oP(e|0)|0}function _9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;cP(e|0)|0}function p9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;lP(e|0)|0}function E9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;sP(e|0)|0}function S9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bP(e|0)|0}function g9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;kP(e|0)|0}function y9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;hP(e|0)|0}function F9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;wP(e|0)|0}function O9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;dP(e|0)|0}function A9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;vP(e|0)|0}function M9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;mP(e|0)|0}function R9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_P(e|0)|0}function N9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;pP(e|0)|0}function T9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;EP(e|0)|0}function L9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;SP(e|0)|0}function D9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;gP(e|0)|0}function C9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;yP(e|0)|0}function P9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;FP(e|0)|0}function B9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;OP(e|0)|0}function I9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;AP(e|0)|0}function H9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;MP(e|0)|0}function x9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;RP(e|0)|0}function U9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;NP(e|0)|0}function z9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;TP(e|0)|0}function j9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;LP(e|0)|0}function V9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;DP(e|0)|0}function q9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;CP(e|0)|0}function Y9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;PP(e|0)|0}function G9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;BP(e|0)|0}function W9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;IP(e|0)|0}function K9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;HP(e|0)|0}function X9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xP(e|0)|0}function Z9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;UP(e|0)|0}function J9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zP(e|0)|0}function Q9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;jP(e|0)|0}function $9(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;VP(e|0)|0}function e7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qP(e|0)|0}function i7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;YP(e|0)|0}function r7(e,i,r,n,f,t,u){
	e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;GP(e|0)|0}function n7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;WP(e|0)|0}function f7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;KP(e|0)|0}function t7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;XP(e|0)|0}function u7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ZP(e|0)|0}function a7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;JP(e|0)|0}function o7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;QP(e|0)|0}function c7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$P(e|0)|0}function l7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;eB(e|0)|0}function s7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;iB(e|0)|0}function b7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;rB(e|0)|0}function k7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;nB(e|0)|0}function h7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;fB(e|0)|0}function w7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;tB(e|0)|0}function d7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;uB(e|0)|0}function v7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;aB(e|0)|0}function m7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;oB(e|0)|0}function _7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;cB(e|0)|0}function p7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;lB(e|0)|0}function E7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;sB(e|0)|0}function S7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bB(e|0)|0}function g7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;kB(e|0)|0}function y7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;hB(e|0)|0}function F7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;wB(e|0)|0}function O7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;dB(e|0)|0}function A7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;vB(e|0)|0}function M7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;mB(e|0)|0}function R7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_B(e|0)|0}function N7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;pB(e|0)|0}function T7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;EB(e|0)|0}function L7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;SB(e|0)|0}function D7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;gB(e|0)|0}function C7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;yB(e|0)|0}function P7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;FB(e|0)|0}function B7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;OB(e|0)|0}function I7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;AB(e|0)|0}function H7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;MB(e|0)|0}function x7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;RB(e|0)|0}function U7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;NB(e|0)|0}function z7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;TB(e|0)|0}function j7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;LB(e|0)|0}function V7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;DB(e|0)|0}function q7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;CB(e|0)|0}function Y7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;PB(e|0)|0}function G7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;BB(e|0)|0}function W7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;IB(e|0)|0}function K7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;HB(e|0)|0}function X7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xB(e|0)|0}function Z7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;UB(e|0)|0}function J7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zB(e|0)|0}function Q7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;jB(e|0)|0}function $7(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;VB(e|0)|0}function eee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qB(e|0)|0}function iee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;YB(e|0)|0}function ree(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;NY(e|0,i|0,r|0)|0}function nee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;am(e|0)}function fee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;om(e|0)|0}function tee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;cm(e|0,i|0)|0}function uee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;lm(e|0)|0}function aee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;aA(e|0,i|0,r|0)|0}function oee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bm(e|0)}function cee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;km(e|0)}function lee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;hm(e|0,i|0,r|0)|0}function see(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xe(e|0,i|0,r|0)|0}function bee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;pm(e|0,i|0,r|0)|0}function kee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Em(e|0)}function hee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Sm(e|0,i|0,r|0)}function wee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;gm(e|0,i|0,r|0)}function dee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ym(e|0,i|0,r|0)}function vee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Fm(e|0,i|0,r|0)}function mee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Am(e|0)|0}function _ee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;O_(e|0,i|0)}function pee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;A_(e|0)|0}function Eee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Z_(e|0,i|0,r|0,n|0)|0}function See(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;J_(e|0,i|0,r|0,n|0)|0}function gee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Q_(e|0,i|0,r|0,n|0)|0}function yee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$_(e|0,i|0,r|0,n|0)|0}function Fee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ep(e|0,i|0,r|0,n|0)|0}function Oee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ip(e|0,i|0,r|0,n|0)|0}function Aee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;N_(e|0,i|0,r|0,n|0)|0}function Mee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;T_(e|0,i|0,r|0,n|0)|0}function Ree(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;rp(e|0,i|0,r|0,n|0)|0}function Nee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;np(e|0,i|0,r|0,n|0)|0}function Tee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;dN(e|0,i|0,r|0,n|0)|0}function Lee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;hp(e|0,i|0,r|0)}function Dee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;wp(e|0,i|0,r|0)}function Cee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;LS(e|0)}function Pee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;FO()|0}function Bee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Tg(e|0,i|0,r|0,n|0,f|0)}function Iee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_O(e|0,i|0,r|0,n|0,f|0)}function Hee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;OO(e|0)|0}function xee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;AO(e|0)|0}function Uee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;MO(e|0,i|0,r|0)|0}function zee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;RO(e|0)|0}function jee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;sA(e|0)|0}function Vee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bA(e|0,i|0,r|0)|0}function qee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;hA(e|0)|0}function Yee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;wA(e|0,i|0,r|0)|0}function Gee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;dA(e|0)|0}function Wee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;vA(e|0,i|0,r|0)|0}function Kee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;mA(e|0,i|0,r|0)|0}function Xee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_A(e|0,i|0,r|0,n|0)|0}function Zee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;FR(e|0)}function Jee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;OR(e|0)|0}function Qee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;NR(e|0)}function $ee(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;DR(e|0)|0}function eie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;PR(e|0)}function iie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;BR(e|0)|0}function rie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;IR(e|0,i|0)}function nie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;HR(e|0)}function fie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xR(e|0)}function tie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;UR(e|0,i|0)|0}function uie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zR(e|0)}function aie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;GR(e|0,i|0,r|0)}function oie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;iN(e|0,i|0,r|0)}function cie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;rN(e|0,i|0,r|0)}function lie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;nN(e|0,i|0,r|0)}function sie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;fN(e|0,i|0,r|0)}function bie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;lN(e|0,i|0)|0}function kie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xr(e|0,i|0)}function hie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_n(e|0)}function wie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;tt(e|0,i|0)}function die(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bt(e|0,i|0)}function vie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Yf(e|0,i|0)}function mie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Jf(e|0,i|0)}function _ie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Qf(e|0,i|0)}function pie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Gf(e|0,i|0)}function Eie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ot(e|0,i|0)}function Sie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;st(e|0,i|0)}function gie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Vf(e|0,i|0)}function yie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ct(e|0,i|0)}function Fie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Wf(e|0,i|0)}function Oie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ut(e|0,i|0)}function Aie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Yt(e|0,i|0)}function Mie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Kf(e|0,i|0)}function Rie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;nt(e|0,i|0)}function Nie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;gf(e|0,i|0)}function Tie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qf(e|0,i|0)}function Lie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;kt(e|0,i|0)}function Die(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xf(e|0,i|0)}function Cie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Zf(e|0,i|0)}function Pie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$f(e|0,i|0)}function Bie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;et(e|0,i|0)}function Iie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;it(e|0,i|0)}function Hie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;rt(e|0,i|0)}function xie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;lt(e|0,i|0)}function Uie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;at(e|0,i|0)}function zie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ft(e|0,i|0)}function jie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Gt(e|0,i|0)}function Vie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Qu(e|0,i|0,r|0)|0}function qie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Pf(e|0,i|0)|0}function Yie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Bf(e|0,i|0)|0}function Gie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zf(e|0,i|0)|0}function Wie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$u(e|0,i|0,r|0)|0}function Kie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ea(e|0,i|0)|0}function Xie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Tf(e|0,i|0)|0}function Zie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Lf(e|0,i|0)|0}function Jie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Df(e|0,i|0)|0}function Qie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xf(e|0,i|0)|0}function $ie(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;If(e|0,i|0)|0}function ere(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Uf(e|0,i|0)|0}function ire(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Cf(e|0,i|0)|0}function rre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ia(e|0,i|0)|0}function nre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Hf(e|0,i|0)|0}function fre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Nf(e|0,i|0)|0}function tre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Cn(e|0,i|0)|0}function ure(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;za(e|0,i|0)}function are(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Wa(e|0,i|0)}function ore(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ka(e|0,i|0)}function cre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xa(e|0,i|0)}function lre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Za(e|0,i|0)}function sre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ja(e|0,i|0)}function bre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Qa(e|0,i|0)}function kre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$a(e|0,i|0)}function hre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Qo(e|0,i|0,r|0)}function wre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;vc(e|0)}function dre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Rc(e|0)}function vre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;wl(e|0,i|0,r|0)|0}function mre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ll(e|0,i|0)|0}function _re(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Bl(e|0,i|0)|0}function pre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Hl(e|0,i|0)|0}function Ere(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;jl(e|0,i|0)|0}function Sre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Xk(e|0)}function gre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;dh(e|0,i|0,r|0,n|0,f|0,t|0,u|0,0,0)}function yre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;vh(e|0,i|0,r|0,n|0)}function Fre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;mh(e|0,i|0,r|0)}function Ore(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_h(e|0,i|0,r|0)}function Are(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ph(e|0,i|0)}function Mre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Eh(e|0,i|0,r|0,n|0)}function Rre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Sh(e|0)|0}function Nre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;gh(e|0)|0}function Tre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;yh(e|0)|0}function Lre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Fh(e|0,i|0,r|0)|0}function Dre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Oh(e|0,i|0)|0}function Cre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ah(e|0,i|0,r|0,n|0,f|0,t|0)}function Pre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Mh(e|0,i|0,r|0,n|0)}function Bre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Nh(e|0,i|0,r|0,n|0)}function Ire(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Th(e|0,i|0,r|0,n|0,f|0)}function Hre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Lh(e|0,i|0)}function xre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Dh(e|0)}function Ure(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ch(e|0)}function zre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ph(e|0,i|0,r|0)}function jre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Bh(e|0,i|0)}function Vre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ih(e|0,i|0,r|0)}function qre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Hh(e|0,i|0,r|0)}function Yre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;xh(e|0,i|0,r|0)}function Gre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Uh(e|0,i|0)|0}function Wre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;zh(e|0,i|0,r|0,n|0)}function Kre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;jh(e|0,i|0,r|0)}function Xre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Vh(e|0,i|0,r|0)}function Zre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qh(e|0,i|0,r|0)}function Jre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Yh(e|0,i|0)}function Qre(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Gh(e|0,i|0,r|0,n|0,f|0,t|0,u|0,0,0)}function $re(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Wh(e|0,i|0,r|0,n|0)}function ene(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Zh(e|0,i|0,r|0)|0}function ine(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;$h(e|0)}function rne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;td(e|0,i|0)}function nne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;qv(e|0,i|0,r|0,n|0)}function fne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;aT(e|0,i|0)}function tne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Ok(e|0)}function une(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;cH(e|0,i|0,r|0)}function ane(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;lH(e|0,i|0)}function one(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;sH(e|0,i|0,r|0,n|0,f|0,t|0,u|0,0,0)}function cne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;bH(e|0,i|0,r|0,n|0)}function lne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;kH(e|0,i|0,r|0)}function sne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;hH(e|0,i|0,r|0)}function bne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;dH(e|0,i|0,r|0)}function kne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;vH(e|0,i|0,r|0)}function hne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_H(e|0,i|0,r|0)|0}function wne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;mH(e|0,i|0)}function dne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;DH(e|0)}function vne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ex(e|0,i|0)|0}function mne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ix(e|0,i|0,r|0,n|0,f|0)|0}function _ne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;rx(e|0,i|0,r|0,n|0,f|0,t|0,u|0)|0}function pne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;nx(e|0,i|0,r|0,n|0,f|0,t|0)|0}function Ene(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;fx(e|0,i|0)}function Sne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ux(e|0,i|0)|0}function gne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ax(e|0,i|0,r|0,n|0,f|0)|0}function yne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;ox(e|0,i|0,r|0,n|0,f|0,t|0,u|0)|0}function Fne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;cx(e|0,i|0)}function One(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;wx(e|0,i|0,r|0)}function Ane(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;_x(e|0,i|0,r|0,n|0)}function Mne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;oU(e|0,i|0,r|0)}function Rne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;cU(e|0,i|0,r|0)}function Nne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;GU(e|0,i|0,r|0,n|0)}function Tne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;tz(e|0,i|0,r|0)}function Lne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Gz(e|0,i|0,r|0,n|0,f|0,t|0,u|0,0,0)}function Dne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Wz(e|0,i|0,r|0,n|0)}function Cne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;PV(e|0,i|0,r|0,n|0)|0}function Pne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Rq(e|0,i|0)|0}function Bne(e,i,r,n,f,t,u){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;Kq(e|0,i|0,r|0)|0}function Ine(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ue(3)}function Hne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Cm(e|0,i|0,r|0,n|0)}function xne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Pm(e|0)|0}function Une(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Bm(e|0)|0}function zne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Im(e|0)|0}function jne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Hm(e|0,i|0,r|0)|0}function Vne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xm(e|0,i|0)|0}function qne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Um(e|0,i|0,r|0,n|0,f|0,0)}function Yne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zm(e|0,i|0,r|0,n|0)}function Gne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jm(e|0,i|0,r|0,n|0,f|0,0,0)}function Wne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Vm(e|0,i|0,r|0,n|0)}function Kne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ym(e|0,i|0)}function Xne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Gm(e|0)}function Zne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Wm(e|0)}function Jne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;o_(e|0,i|0,r|0)}function Qne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;c_(e|0,i|0)}function $ne(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Km(e|0,i|0)}function efe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xm(e|0,i|0,r|0)}function ife(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Zm(e|0,i|0,r|0)}function rfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Jm(e|0,i|0,r|0)}function nfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Qm(e|0,i|0)}function ffe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$m(e|0,i|0,r|0)}function tfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;e_(e|0,i|0,r|0)}function ufe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;i_(e|0,i|0,r|0)}function afe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;r_(e|0,i|0)|0}function ofe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;n_(e|0,i|0,r|0)}function cfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;f_(e|0,i|0,r|0,n|0)}function lfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t_(e|0,i|0,r|0,n|0,f|0,0,0,0,0)}function sfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;u_(e|0,i|0,r|0,n|0)}function bfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;oA(e|0,i|0,r|0)|0}function kfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Zq(e|0)}function hfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xq(e|0)|0}function wfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Jq(e|0,i|0)|0}function dfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Yl(e|0)|0}function vfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;tp(e|0,i|0,r|0)}function mfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Tz(e|0,i|0,r|0,n|0)}function _fe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Mz(e|0)|0}function pfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Rz(e|0)|0}function Efe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Nz(e|0)|0}function Sfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Dz(e|0,i|0,r|0)|0}function gfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Cz(e|0,i|0)|0}function yfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Bz(e|0,i|0,r|0,n|0,f|0,0)}function Ffe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xz(e|0,i|0,r|0,n|0)}function Ofe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Iz(e|0,i|0,r|0,n|0,f|0,0,0)}function Afe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Hz(e|0,i|0,r|0,n|0)}function Mfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zz(e|0,i|0)}function Rfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jz(e|0)}function Nfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Vz(e|0)}function Tfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qz(e|0,i|0,r|0)}function Lfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Yz(e|0,i|0)}function Dfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Kz(e|0,i|0)}function Cfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xz(e|0,i|0,r|0)}function Pfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Jz(e|0,i|0,r|0)}function Bfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Qz(e|0,i|0)}function Ife(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;kp(e|0,i|0,r|0)}function Hfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bp(e|0,i|0,r|0)}function xfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Pz(e|0,i|0)|0}function Ufe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$z(e|0,i|0,r|0)}function zfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Lz(e|0,i|0,r|0,n|0)}function jfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;yz(e|0)|0}function Vfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Fz(e|0)|0}function qfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Oz(e|0)|0}function Yfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Az(e|0)|0}function Gfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Zz(e|0,i|0,r|0)}function Wfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;OC(e|0)|0}function Kfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;AC(e|0)|0}function Xfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;MC(e|0)|0}function Zfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;RC(e|0)|0}function Jfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;NC(e|0)|0}function Qfe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;TC(e|0)|0}function $fe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;LC(e|0)|0}function ete(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;DC(e|0)|0}function ite(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;CC(e|0)|0}function rte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;PC(e|0)|0}function nte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;BC(e|0)|0}function fte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;IC(e|0)|0}function tte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;HC(e|0)|0}function ute(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xC(e|0)|0}function ate(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;UC(e|0)|0}function ote(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zC(e|0)|0}function cte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jC(e|0)|0}function lte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;VC(e|0)|0}function ste(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qC(e|0)|0}function bte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;YC(e|0)|0}function kte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;GC(e|0)|0}function hte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;WC(e|0)|0}function wte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;KC(e|0)|0}function dte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;XC(e|0)|0}function vte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ZC(e|0)|0}function mte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;JC(e|0)|0}function _te(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;QC(e|0)|0}function pte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$C(e|0)|0}function Ete(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;eP(e|0)|0}function Ste(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;iP(e|0)|0}function gte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;rP(e|0)|0}function yte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;nP(e|0)|0}function Fte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;fP(e|0)|0}function Ote(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;tP(e|0)|0}function Ate(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;uP(e|0)|0}function Mte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;aP(e|0)|0}function Rte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;oP(e|0)|0}function Nte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;cP(e|0)|0}function Tte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;lP(e|0)|0}function Lte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;sP(e|0)|0}function Dte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bP(e|0)|0}function Cte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;kP(e|0)|0}function Pte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;hP(e|0)|0}function Bte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;wP(e|0)|0}function Ite(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;dP(e|0)|0}function Hte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;vP(e|0)|0}function xte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;mP(e|0)|0}function Ute(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_P(e|0)|0}function zte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;pP(e|0)|0}function jte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;EP(e|0)|0}function Vte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;SP(e|0)|0}function qte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;gP(e|0)|0}function Yte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;yP(e|0)|0}function Gte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;FP(e|0)|0}function Wte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;OP(e|0)|0}function Kte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;AP(e|0)|0}function Xte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;MP(e|0)|0}function Zte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;RP(e|0)|0}function Jte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;NP(e|0)|0}function Qte(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;TP(e|0)|0}function $te(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;LP(e|0)|0}function eue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;DP(e|0)|0}function iue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;CP(e|0)|0}function rue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;PP(e|0)|0}function nue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;BP(e|0)|0}function fue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;IP(e|0)|0}function tue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;HP(e|0)|0}function uue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xP(e|0)|0}function aue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;UP(e|0)|0}function oue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zP(e|0)|0}function cue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jP(e|0)|0}function lue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;VP(e|0)|0}function sue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qP(e|0)|0}function bue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;YP(e|0)|0}function kue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;GP(e|0)|0}function hue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;WP(e|0)|0}function wue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;KP(e|0)|0}function due(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;XP(e|0)|0}function vue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ZP(e|0)|0}function mue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;JP(e|0)|0}function _ue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;QP(e|0)|0}function pue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$P(e|0)|0}function Eue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;eB(e|0)|0}function Sue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;iB(e|0)|0}function gue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;rB(e|0)|0}function yue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;nB(e|0)|0}function Fue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;fB(e|0)|0}function Oue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;tB(e|0)|0}function Aue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;uB(e|0)|0}function Mue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;aB(e|0)|0}function Rue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;oB(e|0)|0}function Nue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;cB(e|0)|0}function Tue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;lB(e|0)|0}function Lue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;sB(e|0)|0}function Due(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bB(e|0)|0}function Cue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;kB(e|0)|0}function Pue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;hB(e|0)|0}function Bue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;wB(e|0)|0}function Iue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;dB(e|0)|0}function Hue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;vB(e|0)|0}function xue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;mB(e|0)|0}function Uue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_B(e|0)|0}function zue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;
	f=f|0;pB(e|0)|0}function jue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;EB(e|0)|0}function Vue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;SB(e|0)|0}function que(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;gB(e|0)|0}function Yue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;yB(e|0)|0}function Gue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;FB(e|0)|0}function Wue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;OB(e|0)|0}function Kue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;AB(e|0)|0}function Xue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;MB(e|0)|0}function Zue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;RB(e|0)|0}function Jue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;NB(e|0)|0}function Que(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;TB(e|0)|0}function $ue(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;LB(e|0)|0}function eae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;DB(e|0)|0}function iae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;CB(e|0)|0}function rae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;PB(e|0)|0}function nae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;BB(e|0)|0}function fae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;IB(e|0)|0}function tae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;HB(e|0)|0}function uae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xB(e|0)|0}function aae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;UB(e|0)|0}function oae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zB(e|0)|0}function cae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jB(e|0)|0}function lae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;VB(e|0)|0}function sae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qB(e|0)|0}function bae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;YB(e|0)|0}function kae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;NY(e|0,i|0,r|0)|0}function hae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;am(e|0)}function wae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;om(e|0)|0}function dae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;cm(e|0,i|0)|0}function vae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;lm(e|0)|0}function mae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;aA(e|0,i|0,r|0)|0}function _ae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bm(e|0)}function pae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;km(e|0)}function Eae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;hm(e|0,i|0,r|0)|0}function Sae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xe(e|0,i|0,r|0)|0}function gae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;pm(e|0,i|0,r|0)|0}function yae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Em(e|0)}function Fae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Sm(e|0,i|0,r|0)}function Oae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;gm(e|0,i|0,r|0)}function Aae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ym(e|0,i|0,r|0)}function Mae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Fm(e|0,i|0,r|0)}function Rae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Am(e|0)|0}function Nae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;O_(e|0,i|0)}function Tae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;A_(e|0)|0}function Lae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Z_(e|0,i|0,r|0,n|0)|0}function Dae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;J_(e|0,i|0,r|0,n|0)|0}function Cae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Q_(e|0,i|0,r|0,n|0)|0}function Pae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$_(e|0,i|0,r|0,n|0)|0}function Bae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ep(e|0,i|0,r|0,n|0)|0}function Iae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ip(e|0,i|0,r|0,n|0)|0}function Hae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;N_(e|0,i|0,r|0,n|0)|0}function xae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;T_(e|0,i|0,r|0,n|0)|0}function Uae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;rp(e|0,i|0,r|0,n|0)|0}function zae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;np(e|0,i|0,r|0,n|0)|0}function jae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;dN(e|0,i|0,r|0,n|0)|0}function Vae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;hp(e|0,i|0,r|0)}function qae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;wp(e|0,i|0,r|0)}function Yae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;LS(e|0)}function Gae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;FO()|0}function Wae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;OO(e|0)|0}function Kae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;AO(e|0)|0}function Xae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;MO(e|0,i|0,r|0)|0}function Zae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;RO(e|0)|0}function Jae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;sA(e|0)|0}function Qae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bA(e|0,i|0,r|0)|0}function $ae(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;hA(e|0)|0}function eoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;wA(e|0,i|0,r|0)|0}function ioe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;dA(e|0)|0}function roe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;vA(e|0,i|0,r|0)|0}function noe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;mA(e|0,i|0,r|0)|0}function foe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_A(e|0,i|0,r|0,n|0)|0}function toe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;FR(e|0)}function uoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;OR(e|0)|0}function aoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;NR(e|0)}function ooe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;DR(e|0)|0}function coe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;PR(e|0)}function loe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;BR(e|0)|0}function soe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;IR(e|0,i|0)}function boe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;HR(e|0)}function koe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xR(e|0)}function hoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;UR(e|0,i|0)|0}function woe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zR(e|0)}function doe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;GR(e|0,i|0,r|0)}function voe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;iN(e|0,i|0,r|0)}function moe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;rN(e|0,i|0,r|0)}function _oe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;nN(e|0,i|0,r|0)}function poe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;fN(e|0,i|0,r|0)}function Eoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;lN(e|0,i|0)|0}function Soe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xr(e|0,i|0)}function goe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_n(e|0)}function yoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;tt(e|0,i|0)}function Foe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bt(e|0,i|0)}function Ooe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Yf(e|0,i|0)}function Aoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Jf(e|0,i|0)}function Moe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Qf(e|0,i|0)}function Roe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Gf(e|0,i|0)}function Noe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ot(e|0,i|0)}function Toe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;st(e|0,i|0)}function Loe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Vf(e|0,i|0)}function Doe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ct(e|0,i|0)}function Coe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Wf(e|0,i|0)}function Poe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ut(e|0,i|0)}function Boe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Yt(e|0,i|0)}function Ioe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Kf(e|0,i|0)}function Hoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;nt(e|0,i|0)}function xoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;gf(e|0,i|0)}function Uoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qf(e|0,i|0)}function zoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;kt(e|0,i|0)}function joe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xf(e|0,i|0)}function Voe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Zf(e|0,i|0)}function qoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$f(e|0,i|0)}function Yoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;et(e|0,i|0)}function Goe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;it(e|0,i|0)}function Woe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;rt(e|0,i|0)}function Koe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;lt(e|0,i|0)}function Xoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;at(e|0,i|0)}function Zoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ft(e|0,i|0)}function Joe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Gt(e|0,i|0)}function Qoe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Qu(e|0,i|0,r|0)|0}function $oe(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Pf(e|0,i|0)|0}function ece(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Bf(e|0,i|0)|0}function ice(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zf(e|0,i|0)|0}function rce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$u(e|0,i|0,r|0)|0}function nce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ea(e|0,i|0)|0}function fce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Tf(e|0,i|0)|0}function tce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Lf(e|0,i|0)|0}function uce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Df(e|0,i|0)|0}function ace(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xf(e|0,i|0)|0}function oce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;If(e|0,i|0)|0}function cce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Uf(e|0,i|0)|0}function lce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Cf(e|0,i|0)|0}function sce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ia(e|0,i|0)|0}function bce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Hf(e|0,i|0)|0}function kce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Nf(e|0,i|0)|0}function hce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Cn(e|0,i|0)|0}function wce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;za(e|0,i|0)}function dce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Wa(e|0,i|0)}function vce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ka(e|0,i|0)}function mce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xa(e|0,i|0)}function _ce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Za(e|0,i|0)}function pce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ja(e|0,i|0)}function Ece(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Qa(e|0,i|0)}function Sce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$a(e|0,i|0)}function gce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Qo(e|0,i|0,r|0)}function yce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;vc(e|0)}function Fce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Rc(e|0)}function Oce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;wl(e|0,i|0,r|0)|0}function Ace(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ll(e|0,i|0)|0}function Mce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Bl(e|0,i|0)|0}function Rce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Hl(e|0,i|0)|0}function Nce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jl(e|0,i|0)|0}function Tce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Xk(e|0)}function Lce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;dh(e|0,i|0,r|0,n|0,f|0,0,0,0,0)}function Dce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;vh(e|0,i|0,r|0,n|0)}function Cce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;mh(e|0,i|0,r|0)}function Pce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_h(e|0,i|0,r|0)}function Bce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ph(e|0,i|0)}function Ice(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Eh(e|0,i|0,r|0,n|0)}function Hce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Sh(e|0)|0}function xce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;gh(e|0)|0}function Uce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;yh(e|0)|0}function zce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Fh(e|0,i|0,r|0)|0}function jce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Oh(e|0,i|0)|0}function Vce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ah(e|0,i|0,r|0,n|0,f|0,0)}function qce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Mh(e|0,i|0,r|0,n|0)}function Yce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Rh(e|0,i|0,r|0,n|0,f|0,0,0)}function Gce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Nh(e|0,i|0,r|0,n|0)}function Wce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Lh(e|0,i|0)}function Kce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Dh(e|0)}function Xce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ch(e|0)}function Zce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ph(e|0,i|0,r|0)}function Jce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Bh(e|0,i|0)}function Qce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ih(e|0,i|0,r|0)}function $ce(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Hh(e|0,i|0,r|0)}function ele(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;xh(e|0,i|0,r|0)}function ile(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Uh(e|0,i|0)|0}function rle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;zh(e|0,i|0,r|0,n|0)}function nle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;jh(e|0,i|0,r|0)}function fle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Vh(e|0,i|0,r|0)}function tle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qh(e|0,i|0,r|0)}function ule(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Yh(e|0,i|0)}function ale(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Gh(e|0,i|0,r|0,n|0,f|0,0,0,0,0)}function ole(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Wh(e|0,i|0,r|0,n|0)}function cle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Zh(e|0,i|0,r|0)|0}function lle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;$h(e|0)}function sle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;td(e|0,i|0)}function ble(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;qv(e|0,i|0,r|0,n|0)}function kle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;aT(e|0,i|0)}function hle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Ok(e|0)}function wle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;cH(e|0,i|0,r|0)}function dle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;lH(e|0,i|0)}function vle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;sH(e|0,i|0,r|0,n|0,f|0,0,0,0,0)}function mle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;bH(e|0,i|0,r|0,n|0)}function _le(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;kH(e|0,i|0,r|0)}function ple(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;hH(e|0,i|0,r|0)}function Ele(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;dH(e|0,i|0,r|0)}function Sle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;vH(e|0,i|0,r|0)}function gle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_H(e|0,i|0,r|0)|0}function yle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;mH(e|0,i|0)}function Fle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;DH(e|0)}function Ole(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ex(e|0,i|0)|0}function Ale(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ix(e|0,i|0,r|0,n|0,f|0)|0}function Mle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;rx(e|0,i|0,r|0,n|0,f|0,0,0)|0}function Rle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;nx(e|0,i|0,r|0,n|0,f|0,0)|0}function Nle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;fx(e|0,i|0)}function Tle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ux(e|0,i|0)|0}function Lle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ax(e|0,i|0,r|0,n|0,f|0)|0}function Dle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ox(e|0,i|0,r|0,n|0,f|0,0,0)|0}function Cle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;cx(e|0,i|0)}function Ple(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;wx(e|0,i|0,r|0)}function Ble(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;_x(e|0,i|0,r|0,n|0)}function Ile(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;oU(e|0,i|0,r|0)}function Hle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;cU(e|0,i|0,r|0)}function xle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;GU(e|0,i|0,r|0,n|0)}function Ule(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;tz(e|0,i|0,r|0)}function zle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Gz(e|0,i|0,r|0,n|0,f|0,0,0,0,0)}function jle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Wz(e|0,i|0,r|0,n|0)}function Vle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;PV(e|0,i|0,r|0,n|0)|0}function qle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Rq(e|0,i|0)|0}function Yle(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;Kq(e|0,i|0,r|0)|0}function Gle(){ue(4);return 0}function Wle(){return 0}function Kle(){return Pm(0)|0}function Xle(){return Bm(0)|0}function Zle(){return Im(0)|0}function Jle(){return Hm(0,0,0)|0}function Qle(){return xm(0,0)|0}function $le(){return 0}function ese(){return 0}function ise(){return 0}function rse(){return 0}function nse(){return 0}function fse(){return 0}function tse(){return 0}function use(){return 0}function ase(){return 0}function ose(){return 0}function cse(){return 0}function lse(){return 0}function sse(){return 0}function bse(){return 0}function kse(){return 0}function hse(){return 0}function wse(){return 0}function dse(){return 0}function vse(){return r_(0,0)|0}function mse(){return 0}function _se(){return 0}function pse(){return 0}function Ese(){return 0}function Sse(){return oA(0,0,0)|0}function gse(){return 0}function yse(){return Xq(0)|0}function Fse(){return Jq(0,0)|0}function Ose(){return Yl(0)|0}function Ase(){return 0}function Mse(){return 0}function Rse(){return Mz(0)|0}function Nse(){return Rz(0)|0}function Tse(){return Nz(0)|0}function Lse(){return Dz(0,0,0)|0}function Dse(){return Cz(0,0)|0}function Cse(){return 0}function Pse(){return 0}function Bse(){return 0}function Ise(){return 0}function Hse(){return 0}function xse(){return 0}function Use(){return 0}function zse(){return 0}function jse(){return 0}function Vse(){return 0}function qse(){return 0}function Yse(){return 0}function Gse(){return 0}function Wse(){return 0}function Kse(){return 0}function Xse(){return 0}function Zse(){return Pz(0,0)|0}function Jse(){return 0}function Qse(){return 0}function $se(){return yz(0)|0}function ebe(){return Fz(0)|0}function ibe(){return Oz(0)|0}function rbe(){return Az(0)|0}function nbe(){return 0}function fbe(){return OC(0)|0}function tbe(){return AC(0)|0}function ube(){return MC(0)|0}function abe(){return RC(0)|0}function obe(){return NC(0)|0}function cbe(){return TC(0)|0}function lbe(){return LC(0)|0}function sbe(){return DC(0)|0}function bbe(){return CC(0)|0}function kbe(){return PC(0)|0}function hbe(){return BC(0)|0}function wbe(){return IC(0)|0}function dbe(){return HC(0)|0}function vbe(){return xC(0)|0}function mbe(){return UC(0)|0}function _be(){return zC(0)|0}function pbe(){return jC(0)|0}function Ebe(){return VC(0)|0}function Sbe(){return qC(0)|0}function gbe(){return YC(0)|0}function ybe(){return GC(0)|0}function Fbe(){return WC(0)|0}function Obe(){return KC(0)|0}function Abe(){return XC(0)|0}function Mbe(){return ZC(0)|0}function Rbe(){return JC(0)|0}function Nbe(){return QC(0)|0}function Tbe(){return $C(0)|0}function Lbe(){return eP(0)|0}function Dbe(){return iP(0)|0}function Cbe(){return rP(0)|0}function Pbe(){return nP(0)|0}function Bbe(){return fP(0)|0}function Ibe(){return tP(0)|0}function Hbe(){return uP(0)|0}function xbe(){return aP(0)|0}function Ube(){return oP(0)|0}function zbe(){return cP(0)|0}function jbe(){return lP(0)|0}function Vbe(){return sP(0)|0}function qbe(){return bP(0)|0}function Ybe(){return kP(0)|0}function Gbe(){return hP(0)|0}function Wbe(){return wP(0)|0}function Kbe(){return dP(0)|0}function Xbe(){return vP(0)|0}function Zbe(){return mP(0)|0}function Jbe(){return _P(0)|0}function Qbe(){return pP(0)|0}function $be(){return EP(0)|0}function eke(){return SP(0)|0}function ike(){return gP(0)|0}function rke(){return yP(0)|0}function nke(){return FP(0)|0}function fke(){return OP(0)|0}function tke(){return AP(0)|0}function uke(){return MP(0)|0}function ake(){return RP(0)|0}function oke(){return NP(0)|0}function cke(){return TP(0)|0}function lke(){return LP(0)|0}function ske(){return DP(0)|0}function bke(){return CP(0)|0}function kke(){return PP(0)|0}function hke(){return BP(0)|0}function wke(){return IP(0)|0}function dke(){return HP(0)|0}function vke(){return xP(0)|0}function mke(){return UP(0)|0}function _ke(){return zP(0)|0}function pke(){return jP(0)|0}function Eke(){return VP(0)|0}function Ske(){return qP(0)|0}function gke(){return YP(0)|0}function yke(){return GP(0)|0}function Fke(){return WP(0)|0}function Oke(){return KP(0)|0}function Ake(){return XP(0)|0}function Mke(){return ZP(0)|0}function Rke(){return JP(0)|0}function Nke(){return QP(0)|0}function Tke(){return $P(0)|0}function Lke(){return eB(0)|0}function Dke(){return iB(0)|0}function Cke(){return rB(0)|0}function Pke(){return nB(0)|0}function Bke(){return fB(0)|0}function Ike(){return tB(0)|0}function Hke(){return uB(0)|0}function xke(){return aB(0)|0}function Uke(){return oB(0)|0}function zke(){return cB(0)|0}function jke(){return lB(0)|0}function Vke(){return sB(0)|0}function qke(){return bB(0)|0}function Yke(){return kB(0)|0}function Gke(){return hB(0)|0}function Wke(){return wB(0)|0}function Kke(){return dB(0)|0}function Xke(){return vB(0)|0}function Zke(){return mB(0)|0}function Jke(){return _B(0)|0}function Qke(){return pB(0)|0}function $ke(){return EB(0)|0}function ehe(){return SB(0)|0}function ihe(){return gB(0)|0}function rhe(){return yB(0)|0}function nhe(){return FB(0)|0}function fhe(){return OB(0)|0}function the(){return AB(0)|0}function uhe(){return MB(0)|0}function ahe(){return RB(0)|0}function ohe(){return NB(0)|0}function che(){return TB(0)|0}function lhe(){return LB(0)|0}function she(){return DB(0)|0}function bhe(){return CB(0)|0}function khe(){return PB(0)|0}function hhe(){return BB(0)|0}function whe(){return IB(0)|0}function dhe(){return HB(0)|0}function vhe(){return xB(0)|0}function mhe(){return UB(0)|0}function _he(){return zB(0)|0}function phe(){return jB(0)|0}function Ehe(){return VB(0)|0}function She(){return qB(0)|0}function ghe(){return YB(0)|0}function yhe(){return NY(0,0,0)|0}function Fhe(){return 0}function Ohe(){return om(0)|0}function Ahe(){return cm(0,0)|0}function Mhe(){return lm(0)|0}function Rhe(){return aA(0,0,0)|0}function Nhe(){return 0}function The(){return 0}function Lhe(){return hm(0,0,0)|0}function Dhe(){return xe(0,0,0)|0}function Che(){return pm(0,0,0)|0}function Phe(){return 0}function Bhe(){return 0}function Ihe(){return 0}function Hhe(){return 0}function xhe(){return 0}function Uhe(){return Am(0)|0}function zhe(){return 0}function jhe(){return A_(0)|0}function Vhe(){return Z_(0,0,0,0)|0}function qhe(){return J_(0,0,0,0)|0}function Yhe(){return Q_(0,0,0,0)|0}function Ghe(){return $_(0,0,0,0)|0}function Whe(){return ep(0,0,0,0)|0}function Khe(){return ip(0,0,0,0)|0}function Xhe(){return N_(0,0,0,0)|0}function Zhe(){return T_(0,0,0,0)|0}function Jhe(){return rp(0,0,0,0)|0}function Qhe(){return np(0,0,0,0)|0}function $he(){return dN(0,0,0,0)|0}function ewe(){return 0}function iwe(){return 0}function rwe(){return 0}function nwe(){return 0}function fwe(){return 0}function twe(){return OO(0)|0}function uwe(){return AO(0)|0}function awe(){return MO(0,0,0)|0}function owe(){return RO(0)|0}function cwe(){return sA(0)|0}function lwe(){return bA(0,0,0)|0}function swe(){return hA(0)|0}function bwe(){return wA(0,0,0)|0}function kwe(){return dA(0)|0}function hwe(){return vA(0,0,0)|0}function wwe(){return mA(0,0,0)|0}function dwe(){return _A(0,0,0,0)|0}function vwe(){return 0}function mwe(){return OR(0)|0}function _we(){return 0}function pwe(){return DR(0)|0}function Ewe(){return 0}function Swe(){return BR(0)|0}function gwe(){return 0}function ywe(){return 0}function Fwe(){return 0}function Owe(){return UR(0,0)|0}function Awe(){return 0}function Mwe(){return 0}function Rwe(){return 0}function Nwe(){return 0}function Twe(){return 0}function Lwe(){return 0}function Dwe(){return lN(0,0)|0}function Cwe(){return 0}function Pwe(){return 0}function Bwe(){return 0}function Iwe(){return 0}function Hwe(){return 0}function xwe(){return 0}function Uwe(){return 0}function zwe(){return 0}function jwe(){return 0}function Vwe(){return 0}function qwe(){return 0}function Ywe(){return 0}function Gwe(){return 0}function Wwe(){return 0}function Kwe(){return 0}function Xwe(){return 0}function Zwe(){return 0}function Jwe(){return 0}function Qwe(){return 0}function $we(){return 0}function ede(){return 0}function ide(){return 0}function rde(){return 0}function nde(){return 0}function fde(){return 0}function tde(){return 0}function ude(){return 0}function ade(){return 0}function ode(){return 0}function cde(){return 0}function lde(){return Qu(0,0,0)|0}function sde(){return Pf(0,0)|0}function bde(){return Bf(0,0)|0}function kde(){return zf(0,0)|0}function hde(){return $u(0,0,0)|0}function wde(){return ea(0,0)|0}function dde(){return Tf(0,0)|0}function vde(){return Lf(0,0)|0}function mde(){return Df(0,0)|0}function _de(){return xf(0,0)|0}function pde(){return If(0,0)|0}function Ede(){return Uf(0,0)|0}function Sde(){return Cf(0,0)|0}function gde(){return ia(0,0)|0}function yde(){return Hf(0,0)|0}function Fde(){return Nf(0,0)|0}function Ode(){return Cn(0,0)|0}function Ade(){return 0}function Mde(){return 0}function Rde(){return 0}function Nde(){return 0}function Tde(){return 0}function Lde(){return 0}function Dde(){return 0}function Cde(){return 0}function Pde(){return 0}function Bde(){return 0}function Ide(){return 0}function Hde(){return wl(0,0,0)|0}function xde(){return Ll(0,0)|0}function Ude(){return Bl(0,0)|0}function zde(){return Hl(0,0)|0}function jde(){return jl(0,0)|0}function Vde(){return 0}function qde(){return 0}function Yde(){return 0}function Gde(){return 0}function Wde(){return 0}function Kde(){return 0}function Xde(){return 0}function Zde(){return Sh(0)|0}function Jde(){return gh(0)|0}function Qde(){return yh(0)|0}function $de(){return Fh(0,0,0)|0}function eve(){return Oh(0,0)|0}function ive(){return 0}function rve(){return 0}function nve(){return 0}function fve(){return 0}function tve(){return 0}function uve(){return 0}function ave(){return 0}function ove(){return 0}function cve(){return 0}function lve(){return 0}function sve(){return 0}function bve(){return 0}function kve(){return 0}function hve(){return Uh(0,0)|0}function wve(){return 0}function dve(){return 0}function vve(){return 0}function mve(){return 0}function _ve(){return 0}function pve(){return 0}function Eve(){return 0}function Sve(){return Zh(0,0,0)|0}function gve(){return 0}function yve(){return 0}function Fve(){return 0}function Ove(){return 0}function Ave(){return 0}function Mve(){return 0}function Rve(){return 0}function Nve(){return 0}function Tve(){return 0}function Lve(){return 0}function Dve(){return 0}function Cve(){return 0}function Pve(){return 0}function Bve(){return _H(0,0,0)|0}function Ive(){return 0}function Hve(){return 0}function xve(){return ex(0,0)|0}function Uve(){return ix(0,0,0,0,0)|0}function zve(){return rx(0,0,0,0,0,0,0)|0}function jve(){return nx(0,0,0,0,0,0)|0}function Vve(){return 0}function qve(){return ux(0,0)|0}function Yve(){return ax(0,0,0,0,0)|0}function Gve(){return ox(0,0,0,0,0,0,0)|0}function Wve(){return 0}function Kve(){return 0}function Xve(){return 0}function Zve(){return 0}function Jve(){return 0}function Qve(){return 0}function $ve(){return 0}function eme(){return 0}function ime(){return 0}function rme(){return PV(0,0,0,0)|0}function nme(){return Rq(0,0)|0}function fme(){return Kq(0,0,0)|0}function tme(e){e=e|0;ue(5)}function ume(e){e=e|0;Cm(e|0,0,0,0)}function ame(e){e=e|0;Pm(e|0)|0}function ome(e){e=e|0;Bm(e|0)|0}function cme(e){e=e|0;Im(e|0)|0}function lme(e){e=e|0;Hm(e|0,0,0)|0}function sme(e){e=e|0;xm(e|0,0)|0}function bme(e){e=e|0;Um(e|0,0,0,0,0,0)}function kme(e){e=e|0;zm(e|0,0,0,0)}function hme(e){e=e|0;jm(e|0,0,0,0,0,0,0)}function wme(e){e=e|0;Vm(e|0,0,0,0)}function dme(e){e=e|0;qm(e|0,0,0,0,0)}function vme(e){e=e|0;Ym(e|0,0)}function mme(e){e=e|0;o_(e|0,0,0)}function _me(e){e=e|0;c_(e|0,0)}function pme(e){e=e|0;Km(e|0,0)}function Eme(e){e=e|0;Xm(e|0,0,0)}function Sme(e){e=e|0;Zm(e|0,0,0)}function gme(e){e=e|0;Jm(e|0,0,0)}function yme(e){e=e|0;Qm(e|0,0)}function Fme(e){e=e|0;$m(e|0,0,0)}function Ome(e){e=e|0;e_(e|0,0,0)}function Ame(e){e=e|0;i_(e|0,0,0)}function Mme(e){e=e|0;r_(e|0,0)|0}function Rme(e){e=e|0;n_(e|0,0,0)}function Nme(e){e=e|0;f_(e|0,0,0,0)}function Tme(e){e=e|0;t_(e|0,0,0,0,0,0,0,0,0)}function Lme(e){e=e|0;u_(e|0,0,0,0)}function Dme(e){e=e|0;oA(e|0,0,0)|0}function Cme(e){e=e|0;Xq(e|0)|0}function Pme(e){e=e|0;Jq(e|0,0)|0}function Bme(e){e=e|0;Yl(e|0)|0}function Ime(e){e=e|0;tp(e|0,0,0)}function Hme(e){e=e|0;Tz(e|0,0,0,0)}function xme(e){e=e|0;Mz(e|0)|0}function Ume(e){e=e|0;Rz(e|0)|0}function zme(e){e=e|0;Nz(e|0)|0}function jme(e){e=e|0;Dz(e|0,0,0)|0}function Vme(e){e=e|0;Cz(e|0,0)|0}function qme(e){e=e|0;Bz(e|0,0,0,0,0,0)}function Yme(e){e=e|0;xz(e|0,0,0,0)}function Gme(e){e=e|0;Iz(e|0,0,0,0,0,0,0)}function Wme(e){e=e|0;Hz(e|0,0,0,0)}function Kme(e){e=e|0;Uz(e|0,0,0,0,0)}function Xme(e){e=e|0;zz(e|0,0)}function Zme(e){e=e|0;qz(e|0,0,0)}function Jme(e){e=e|0;Yz(e|0,0)}function Qme(e){e=e|0;Kz(e|0,0)}function $me(e){e=e|0;Xz(e|0,0,0)}function e_e(e){e=e|0;Jz(e|0,0,0)}function i_e(e){e=e|0;Qz(e|0,0)}function r_e(e){e=e|0;kp(e|0,0,0)}function n_e(e){e=e|0;bp(e|0,0,0)}function f_e(e){e=e|0;Pz(e|0,0)|0}function t_e(e){e=e|0;$z(e|0,0,0)}function u_e(e){e=e|0;Lz(e|0,0,0,0)}function a_e(e){e=e|0;yz(e|0)|0}function o_e(e){e=e|0;Fz(e|0)|0}function c_e(e){e=e|0;Oz(e|0)|0}function l_e(e){e=e|0;Az(e|0)|0}function s_e(e){e=e|0;Zz(e|0,0,0)}function b_e(e){e=e|0;OC(e|0)|0}function k_e(e){e=e|0;AC(e|0)|0}function h_e(e){e=e|0;MC(e|0)|0}function w_e(e){e=e|0;RC(e|0)|0}function d_e(e){e=e|0;NC(e|0)|0}function v_e(e){e=e|0;TC(e|0)|0}function m_e(e){e=e|0;LC(e|0)|0}function __e(e){e=e|0;DC(e|0)|0}function p_e(e){e=e|0;CC(e|0)|0}function E_e(e){e=e|0;PC(e|0)|0}function S_e(e){e=e|0;BC(e|0)|0}function g_e(e){e=e|0;IC(e|0)|0}function y_e(e){e=e|0;HC(e|0)|0}function F_e(e){e=e|0;xC(e|0)|0}function O_e(e){e=e|0;UC(e|0)|0}function A_e(e){e=e|0;zC(e|0)|0}function M_e(e){e=e|0;jC(e|0)|0}function R_e(e){e=e|0;VC(e|0)|0}function N_e(e){e=e|0;qC(e|0)|0}function T_e(e){e=e|0;YC(e|0)|0}function L_e(e){e=e|0;GC(e|0)|0}function D_e(e){e=e|0;WC(e|0)|0}function C_e(e){e=e|0;KC(e|0)|0}function P_e(e){e=e|0;XC(e|0)|0}function B_e(e){e=e|0;ZC(e|0)|0}function I_e(e){e=e|0;JC(e|0)|0}function H_e(e){e=e|0;QC(e|0)|0}function x_e(e){e=e|0;$C(e|0)|0}function U_e(e){e=e|0;eP(e|0)|0}function z_e(e){e=e|0;iP(e|0)|0}function j_e(e){e=e|0;rP(e|0)|0}function V_e(e){e=e|0;nP(e|0)|0}function q_e(e){e=e|0;fP(e|0)|0}function Y_e(e){e=e|0;tP(e|0)|0}function G_e(e){e=e|0;uP(e|0)|0}function W_e(e){e=e|0;aP(e|0)|0}function K_e(e){e=e|0;oP(e|0)|0}function X_e(e){e=e|0;cP(e|0)|0}function Z_e(e){e=e|0;lP(e|0)|0}function J_e(e){e=e|0;sP(e|0)|0}function Q_e(e){e=e|0;bP(e|0)|0}function $_e(e){e=e|0;kP(e|0)|0}function epe(e){e=e|0;hP(e|0)|0}function ipe(e){e=e|0;wP(e|0)|0}function rpe(e){e=e|0;dP(e|0)|0}function npe(e){e=e|0;vP(e|0)|0}function fpe(e){e=e|0;mP(e|0)|0}function tpe(e){e=e|0;_P(e|0)|0}function upe(e){e=e|0;pP(e|0)|0}function ape(e){e=e|0;EP(e|0)|0}function ope(e){e=e|0;SP(e|0)|0}function cpe(e){e=e|0;gP(e|0)|0}function lpe(e){e=e|0;yP(e|0)|0}function spe(e){e=e|0;FP(e|0)|0}function bpe(e){e=e|0;OP(e|0)|0}function kpe(e){e=e|0;AP(e|0)|0}function hpe(e){e=e|0;MP(e|0)|0}function wpe(e){e=e|0;RP(e|0)|0}function dpe(e){e=e|0;NP(e|0)|0}function vpe(e){e=e|0;TP(e|0)|0}function mpe(e){e=e|0;LP(e|0)|0}function _pe(e){e=e|0;DP(e|0)|0}function ppe(e){e=e|0;CP(e|0)|0}function Epe(e){e=e|0;PP(e|0)|0}function Spe(e){e=e|0;BP(e|0)|0}function gpe(e){e=e|0;IP(e|0)|0}function ype(e){e=e|0;HP(e|0)|0}function Fpe(e){e=e|0;xP(e|0)|0}function Ope(e){e=e|0;UP(e|0)|0}function Ape(e){e=e|0;zP(e|0)|0}function Mpe(e){e=e|0;jP(e|0)|0}function Rpe(e){e=e|0;VP(e|0)|0}function Npe(e){e=e|0;qP(e|0)|0}function Tpe(e){e=e|0;YP(e|0)|0}function Lpe(e){e=e|0;GP(e|0)|0}function Dpe(e){e=e|0;WP(e|0)|0}function Cpe(e){e=e|0;KP(e|0)|0}function Ppe(e){e=e|0;XP(e|0)|0}function Bpe(e){e=e|0;ZP(e|0)|0}function Ipe(e){e=e|0;JP(e|0)|0}function Hpe(e){e=e|0;QP(e|0)|0}function xpe(e){e=e|0;$P(e|0)|0}function Upe(e){e=e|0;eB(e|0)|0}function zpe(e){e=e|0;iB(e|0)|0}function jpe(e){e=e|0;rB(e|0)|0}function Vpe(e){e=e|0;nB(e|0)|0}function qpe(e){e=e|0;fB(e|0)|0}function Ype(e){e=e|0;tB(e|0)|0}function Gpe(e){e=e|0;uB(e|0)|0}function Wpe(e){e=e|0;aB(e|0)|0}function Kpe(e){e=e|0;oB(e|0)|0}function Xpe(e){e=e|0;cB(e|0)|0}function Zpe(e){e=e|0;lB(e|0)|0}function Jpe(e){e=e|0;sB(e|0)|0}function Qpe(e){e=e|0;bB(e|0)|0}function $pe(e){e=e|0;kB(e|0)|0}function eEe(e){e=e|0;hB(e|0)|0}function iEe(e){e=e|0;wB(e|0)|0}function rEe(e){e=e|0;dB(e|0)|0}function nEe(e){e=e|0;vB(e|0)|0}function fEe(e){e=e|0;mB(e|0)|0}function tEe(e){e=e|0;_B(e|0)|0}function uEe(e){e=e|0;pB(e|0)|0}function aEe(e){e=e|0;EB(e|0)|0}function oEe(e){e=e|0;SB(e|0)|0}function cEe(e){e=e|0;gB(e|0)|0}function lEe(e){e=e|0;yB(e|0)|0}function sEe(e){e=e|0;FB(e|0)|0}function bEe(e){e=e|0;OB(e|0)|0}function kEe(e){e=e|0;AB(e|0)|0}function hEe(e){e=e|0;MB(e|0)|0}function wEe(e){e=e|0;RB(e|0)|0}function dEe(e){e=e|0;NB(e|0)|0}function vEe(e){e=e|0;TB(e|0)|0}function mEe(e){e=e|0;LB(e|0)|0}function _Ee(e){e=e|0;DB(e|0)|0}function pEe(e){e=e|0;CB(e|0)|0}function EEe(e){e=e|0;PB(e|0)|0}function SEe(e){e=e|0;BB(e|0)|0}function gEe(e){e=e|0;IB(e|0)|0;
	}function yEe(e){e=e|0;HB(e|0)|0}function FEe(e){e=e|0;xB(e|0)|0}function OEe(e){e=e|0;UB(e|0)|0}function AEe(e){e=e|0;zB(e|0)|0}function MEe(e){e=e|0;jB(e|0)|0}function REe(e){e=e|0;VB(e|0)|0}function NEe(e){e=e|0;qB(e|0)|0}function TEe(e){e=e|0;YB(e|0)|0}function LEe(e){e=e|0;NY(e|0,0,0)|0}function DEe(e){e=e|0;om(e|0)|0}function CEe(e){e=e|0;cm(e|0,0)|0}function PEe(e){e=e|0;lm(e|0)|0}function BEe(e){e=e|0;aA(e|0,0,0)|0}function IEe(e){e=e|0;hm(e|0,0,0)|0}function HEe(e){e=e|0;xe(e|0,0,0)|0}function xEe(e){e=e|0;pm(e|0,0,0)|0}function UEe(e){e=e|0;Sm(e|0,0,0)}function zEe(e){e=e|0;gm(e|0,0,0)}function jEe(e){e=e|0;ym(e|0,0,0)}function VEe(e){e=e|0;Fm(e|0,0,0)}function qEe(e){e=e|0;Am(e|0)|0}function YEe(e){e=e|0;O_(e|0,0)}function GEe(e){e=e|0;A_(e|0)|0}function WEe(e){e=e|0;Z_(e|0,0,0,0)|0}function KEe(e){e=e|0;J_(e|0,0,0,0)|0}function XEe(e){e=e|0;Q_(e|0,0,0,0)|0}function ZEe(e){e=e|0;$_(e|0,0,0,0)|0}function JEe(e){e=e|0;ep(e|0,0,0,0)|0}function QEe(e){e=e|0;ip(e|0,0,0,0)|0}function $Ee(e){e=e|0;N_(e|0,0,0,0)|0}function eSe(e){e=e|0;T_(e|0,0,0,0)|0}function iSe(e){e=e|0;rp(e|0,0,0,0)|0}function rSe(e){e=e|0;np(e|0,0,0,0)|0}function nSe(e){e=e|0;dN(e|0,0,0,0)|0}function fSe(e){e=e|0;hp(e|0,0,0)}function tSe(e){e=e|0;wp(e|0,0,0)}function uSe(e){e=e|0;FO()|0}function aSe(e){e=e|0;Tg(e|0,0,0,0,0)}function oSe(e){e=e|0;_O(e|0,0,0,0,0)}function cSe(e){e=e|0;OO(e|0)|0}function lSe(e){e=e|0;AO(e|0)|0}function sSe(e){e=e|0;MO(e|0,0,0)|0}function bSe(e){e=e|0;RO(e|0)|0}function kSe(e){e=e|0;sA(e|0)|0}function hSe(e){e=e|0;bA(e|0,0,0)|0}function wSe(e){e=e|0;hA(e|0)|0}function dSe(e){e=e|0;wA(e|0,0,0)|0}function vSe(e){e=e|0;dA(e|0)|0}function mSe(e){e=e|0;vA(e|0,0,0)|0}function _Se(e){e=e|0;mA(e|0,0,0)|0}function pSe(e){e=e|0;_A(e|0,0,0,0)|0}function ESe(e){e=e|0;OR(e|0)|0}function SSe(e){e=e|0;DR(e|0)|0}function gSe(e){e=e|0;BR(e|0)|0}function ySe(e){e=e|0;IR(e|0,0)}function FSe(e){e=e|0;UR(e|0,0)|0}function OSe(e){e=e|0;GR(e|0,0,0)}function ASe(e){e=e|0;iN(e|0,0,0)}function MSe(e){e=e|0;rN(e|0,0,0)}function RSe(e){e=e|0;nN(e|0,0,0)}function NSe(e){e=e|0;fN(e|0,0,0)}function TSe(e){e=e|0;lN(e|0,0)|0}function LSe(e){e=e|0;Xr(e|0,0)}function DSe(e){e=e|0;tt(e|0,0)}function CSe(e){e=e|0;bt(e|0,0)}function PSe(e){e=e|0;Yf(e|0,0)}function BSe(e){e=e|0;Jf(e|0,0)}function ISe(e){e=e|0;Qf(e|0,0)}function HSe(e){e=e|0;Gf(e|0,0)}function xSe(e){e=e|0;ot(e|0,0)}function USe(e){e=e|0;st(e|0,0)}function zSe(e){e=e|0;Vf(e|0,0)}function jSe(e){e=e|0;ct(e|0,0)}function VSe(e){e=e|0;Wf(e|0,0)}function qSe(e){e=e|0;ut(e|0,0)}function YSe(e){e=e|0;Yt(e|0,0)}function GSe(e){e=e|0;Kf(e|0,0)}function WSe(e){e=e|0;nt(e|0,0)}function KSe(e){e=e|0;gf(e|0,0)}function XSe(e){e=e|0;qf(e|0,0)}function ZSe(e){e=e|0;kt(e|0,0)}function JSe(e){e=e|0;Xf(e|0,0)}function QSe(e){e=e|0;Zf(e|0,0)}function $Se(e){e=e|0;$f(e|0,0)}function ege(e){e=e|0;et(e|0,0)}function ige(e){e=e|0;it(e|0,0)}function rge(e){e=e|0;rt(e|0,0)}function nge(e){e=e|0;lt(e|0,0)}function fge(e){e=e|0;at(e|0,0)}function tge(e){e=e|0;ft(e|0,0)}function uge(e){e=e|0;Gt(e|0,0)}function age(e){e=e|0;Qu(e|0,0,0)|0}function oge(e){e=e|0;Pf(e|0,0)|0}function cge(e){e=e|0;Bf(e|0,0)|0}function lge(e){e=e|0;zf(e|0,0)|0}function sge(e){e=e|0;$u(e|0,0,0)|0}function bge(e){e=e|0;ea(e|0,0)|0}function kge(e){e=e|0;Tf(e|0,0)|0}function hge(e){e=e|0;Lf(e|0,0)|0}function wge(e){e=e|0;Df(e|0,0)|0}function dge(e){e=e|0;xf(e|0,0)|0}function vge(e){e=e|0;If(e|0,0)|0}function mge(e){e=e|0;Uf(e|0,0)|0}function _ge(e){e=e|0;Cf(e|0,0)|0}function pge(e){e=e|0;ia(e|0,0)|0}function Ege(e){e=e|0;Hf(e|0,0)|0}function Sge(e){e=e|0;Nf(e|0,0)|0}function gge(e){e=e|0;Cn(e|0,0)|0}function yge(e){e=e|0;za(e|0,0)}function Fge(e){e=e|0;Wa(e|0,0)}function Oge(e){e=e|0;Ka(e|0,0)}function Age(e){e=e|0;Xa(e|0,0)}function Mge(e){e=e|0;Za(e|0,0)}function Rge(e){e=e|0;Ja(e|0,0)}function Nge(e){e=e|0;Qa(e|0,0)}function Tge(e){e=e|0;$a(e|0,0)}function Lge(e){e=e|0;Qo(e|0,0,0)}function Dge(e){e=e|0;wl(e|0,0,0)|0}function Cge(e){e=e|0;Ll(e|0,0)|0}function Pge(e){e=e|0;Bl(e|0,0)|0}function Bge(e){e=e|0;Hl(e|0,0)|0}function Ige(e){e=e|0;jl(e|0,0)|0}function Hge(e){e=e|0;dh(e|0,0,0,0,0,0,0,0,0)}function xge(e){e=e|0;vh(e|0,0,0,0)}function Uge(e){e=e|0;mh(e|0,0,0)}function zge(e){e=e|0;_h(e|0,0,0)}function jge(e){e=e|0;ph(e|0,0)}function Vge(e){e=e|0;Eh(e|0,0,0,0)}function qge(e){e=e|0;Sh(e|0)|0}function Yge(e){e=e|0;gh(e|0)|0}function Gge(e){e=e|0;yh(e|0)|0}function Wge(e){e=e|0;Fh(e|0,0,0)|0}function Kge(e){e=e|0;Oh(e|0,0)|0}function Xge(e){e=e|0;Ah(e|0,0,0,0,0,0)}function Zge(e){e=e|0;Mh(e|0,0,0,0)}function Jge(e){e=e|0;Rh(e|0,0,0,0,0,0,0)}function Qge(e){e=e|0;Nh(e|0,0,0,0)}function $ge(e){e=e|0;Th(e|0,0,0,0,0)}function eye(e){e=e|0;Lh(e|0,0)}function iye(e){e=e|0;Ph(e|0,0,0)}function rye(e){e=e|0;Bh(e|0,0)}function nye(e){e=e|0;Ih(e|0,0,0)}function fye(e){e=e|0;Hh(e|0,0,0)}function tye(e){e=e|0;xh(e|0,0,0)}function uye(e){e=e|0;Uh(e|0,0)|0}function aye(e){e=e|0;zh(e|0,0,0,0)}function oye(e){e=e|0;jh(e|0,0,0)}function cye(e){e=e|0;Vh(e|0,0,0)}function lye(e){e=e|0;qh(e|0,0,0)}function sye(e){e=e|0;Yh(e|0,0)}function bye(e){e=e|0;Gh(e|0,0,0,0,0,0,0,0,0)}function kye(e){e=e|0;Wh(e|0,0,0,0)}function hye(e){e=e|0;Zh(e|0,0,0)|0}function wye(e){e=e|0;td(e|0,0)}function dye(e){e=e|0;qv(e|0,0,0,0)}function vye(e){e=e|0;aT(e|0,0)}function mye(e){e=e|0;cH(e|0,0,0)}function _ye(e){e=e|0;lH(e|0,0)}function pye(e){e=e|0;sH(e|0,0,0,0,0,0,0,0,0)}function Eye(e){e=e|0;bH(e|0,0,0,0)}function Sye(e){e=e|0;kH(e|0,0,0)}function gye(e){e=e|0;hH(e|0,0,0)}function yye(e){e=e|0;dH(e|0,0,0)}function Fye(e){e=e|0;vH(e|0,0,0)}function Oye(e){e=e|0;_H(e|0,0,0)|0}function Aye(e){e=e|0;mH(e|0,0)}function Mye(e){e=e|0;ex(e|0,0)|0}function Rye(e){e=e|0;ix(e|0,0,0,0,0)|0}function Nye(e){e=e|0;rx(e|0,0,0,0,0,0,0)|0}function Tye(e){e=e|0;nx(e|0,0,0,0,0,0)|0}function Lye(e){e=e|0;fx(e|0,0)}function Dye(e){e=e|0;ux(e|0,0)|0}function Cye(e){e=e|0;ax(e|0,0,0,0,0)|0}function Pye(e){e=e|0;ox(e|0,0,0,0,0,0,0)|0}function Bye(e){e=e|0;cx(e|0,0)}function Iye(e){e=e|0;wx(e|0,0,0)}function Hye(e){e=e|0;_x(e|0,0,0,0)}function xye(e){e=e|0;oU(e|0,0,0)}function Uye(e){e=e|0;cU(e|0,0,0)}function zye(e){e=e|0;GU(e|0,0,0,0)}function jye(e){e=e|0;tz(e|0,0,0)}function Vye(e){e=e|0;Gz(e|0,0,0,0,0,0,0,0,0)}function qye(e){e=e|0;Wz(e|0,0,0,0)}function Yye(e){e=e|0;PV(e|0,0,0,0)|0}function Gye(e){e=e|0;Rq(e|0,0)|0}function Wye(e){e=e|0;Kq(e|0,0,0)|0}function Kye(e,i){e=e|0;i=i|0;ue(6)}function Xye(e,i){e=e|0;i=i|0;Cm(e|0,i|0,0,0)}function Zye(e,i){e=e|0;i=i|0;Pm(e|0)|0}function Jye(e,i){e=e|0;i=i|0;Bm(e|0)|0}function Qye(e,i){e=e|0;i=i|0;Im(e|0)|0}function $ye(e,i){e=e|0;i=i|0;Hm(e|0,i|0,0)|0}function eFe(e,i){e=e|0;i=i|0;xm(e|0,i|0)|0}function iFe(e,i){e=e|0;i=i|0;Um(e|0,i|0,0,0,0,0)}function rFe(e,i){e=e|0;i=i|0;zm(e|0,i|0,0,0)}function nFe(e,i){e=e|0;i=i|0;jm(e|0,i|0,0,0,0,0,0)}function fFe(e,i){e=e|0;i=i|0;Vm(e|0,i|0,0,0)}function tFe(e,i){e=e|0;i=i|0;qm(e|0,i|0,0,0,0)}function uFe(e,i){e=e|0;i=i|0;Gm(e|0)}function aFe(e,i){e=e|0;i=i|0;Wm(e|0)}function oFe(e,i){e=e|0;i=i|0;o_(e|0,i|0,0)}function cFe(e,i){e=e|0;i=i|0;Xm(e|0,i|0,0)}function lFe(e,i){e=e|0;i=i|0;Zm(e|0,i|0,0)}function sFe(e,i){e=e|0;i=i|0;Jm(e|0,i|0,0)}function bFe(e,i){e=e|0;i=i|0;$m(e|0,i|0,0)}function kFe(e,i){e=e|0;i=i|0;e_(e|0,i|0,0)}function hFe(e,i){e=e|0;i=i|0;i_(e|0,i|0,0)}function wFe(e,i){e=e|0;i=i|0;r_(e|0,i|0)|0}function dFe(e,i){e=e|0;i=i|0;n_(e|0,i|0,0)}function vFe(e,i){e=e|0;i=i|0;f_(e|0,i|0,0,0)}function mFe(e,i){e=e|0;i=i|0;t_(e|0,i|0,0,0,0,0,0,0,0)}function _Fe(e,i){e=e|0;i=i|0;u_(e|0,i|0,0,0)}function pFe(e,i){e=e|0;i=i|0;oA(e|0,i|0,0)|0}function EFe(e,i){e=e|0;i=i|0;Zq(e|0)}function SFe(e,i){e=e|0;i=i|0;Xq(e|0)|0}function gFe(e,i){e=e|0;i=i|0;Jq(e|0,i|0)|0}function yFe(e,i){e=e|0;i=i|0;Yl(e|0)|0}function FFe(e,i){e=e|0;i=i|0;tp(e|0,i|0,0)}function OFe(e,i){e=e|0;i=i|0;Tz(e|0,i|0,0,0)}function AFe(e,i){e=e|0;i=i|0;Mz(e|0)|0}function MFe(e,i){e=e|0;i=i|0;Rz(e|0)|0}function RFe(e,i){e=e|0;i=i|0;Nz(e|0)|0}function NFe(e,i){e=e|0;i=i|0;Dz(e|0,i|0,0)|0}function TFe(e,i){e=e|0;i=i|0;Cz(e|0,i|0)|0}function LFe(e,i){e=e|0;i=i|0;Bz(e|0,i|0,0,0,0,0)}function DFe(e,i){e=e|0;i=i|0;xz(e|0,i|0,0,0)}function CFe(e,i){e=e|0;i=i|0;Iz(e|0,i|0,0,0,0,0,0)}function PFe(e,i){e=e|0;i=i|0;Hz(e|0,i|0,0,0)}function BFe(e,i){e=e|0;i=i|0;Uz(e|0,i|0,0,0,0)}function IFe(e,i){e=e|0;i=i|0;jz(e|0)}function HFe(e,i){e=e|0;i=i|0;Vz(e|0)}function xFe(e,i){e=e|0;i=i|0;qz(e|0,i|0,0)}function UFe(e,i){e=e|0;i=i|0;Xz(e|0,i|0,0)}function zFe(e,i){e=e|0;i=i|0;Jz(e|0,i|0,0)}function jFe(e,i){e=e|0;i=i|0;kp(e|0,i|0,0)}function VFe(e,i){e=e|0;i=i|0;bp(e|0,i|0,0)}function qFe(e,i){e=e|0;i=i|0;Pz(e|0,i|0)|0}function YFe(e,i){e=e|0;i=i|0;$z(e|0,i|0,0)}function GFe(e,i){e=e|0;i=i|0;Lz(e|0,i|0,0,0)}function WFe(e,i){e=e|0;i=i|0;yz(e|0)|0}function KFe(e,i){e=e|0;i=i|0;Fz(e|0)|0}function XFe(e,i){e=e|0;i=i|0;Oz(e|0)|0}function ZFe(e,i){e=e|0;i=i|0;Az(e|0)|0}function JFe(e,i){e=e|0;i=i|0;Zz(e|0,i|0,0)}function QFe(e,i){e=e|0;i=i|0;OC(e|0)|0}function $Fe(e,i){e=e|0;i=i|0;AC(e|0)|0}function eOe(e,i){e=e|0;i=i|0;MC(e|0)|0}function iOe(e,i){e=e|0;i=i|0;RC(e|0)|0}function rOe(e,i){e=e|0;i=i|0;NC(e|0)|0}function nOe(e,i){e=e|0;i=i|0;TC(e|0)|0}function fOe(e,i){e=e|0;i=i|0;LC(e|0)|0}function tOe(e,i){e=e|0;i=i|0;DC(e|0)|0}function uOe(e,i){e=e|0;i=i|0;CC(e|0)|0}function aOe(e,i){e=e|0;i=i|0;PC(e|0)|0}function oOe(e,i){e=e|0;i=i|0;BC(e|0)|0}function cOe(e,i){e=e|0;i=i|0;IC(e|0)|0}function lOe(e,i){e=e|0;i=i|0;HC(e|0)|0}function sOe(e,i){e=e|0;i=i|0;xC(e|0)|0}function bOe(e,i){e=e|0;i=i|0;UC(e|0)|0}function kOe(e,i){e=e|0;i=i|0;zC(e|0)|0}function hOe(e,i){e=e|0;i=i|0;jC(e|0)|0}function wOe(e,i){e=e|0;i=i|0;VC(e|0)|0}function dOe(e,i){e=e|0;i=i|0;qC(e|0)|0}function vOe(e,i){e=e|0;i=i|0;YC(e|0)|0}function mOe(e,i){e=e|0;i=i|0;GC(e|0)|0}function _Oe(e,i){e=e|0;i=i|0;WC(e|0)|0}function pOe(e,i){e=e|0;i=i|0;KC(e|0)|0}function EOe(e,i){e=e|0;i=i|0;XC(e|0)|0}function SOe(e,i){e=e|0;i=i|0;ZC(e|0)|0}function gOe(e,i){e=e|0;i=i|0;JC(e|0)|0}function yOe(e,i){e=e|0;i=i|0;QC(e|0)|0}function FOe(e,i){e=e|0;i=i|0;$C(e|0)|0}function OOe(e,i){e=e|0;i=i|0;eP(e|0)|0}function AOe(e,i){e=e|0;i=i|0;iP(e|0)|0}function MOe(e,i){e=e|0;i=i|0;rP(e|0)|0}function ROe(e,i){e=e|0;i=i|0;nP(e|0)|0}function NOe(e,i){e=e|0;i=i|0;fP(e|0)|0}function TOe(e,i){e=e|0;i=i|0;tP(e|0)|0}function LOe(e,i){e=e|0;i=i|0;uP(e|0)|0}function DOe(e,i){e=e|0;i=i|0;aP(e|0)|0}function COe(e,i){e=e|0;i=i|0;oP(e|0)|0}function POe(e,i){e=e|0;i=i|0;cP(e|0)|0}function BOe(e,i){e=e|0;i=i|0;lP(e|0)|0}function IOe(e,i){e=e|0;i=i|0;sP(e|0)|0}function HOe(e,i){e=e|0;i=i|0;bP(e|0)|0}function xOe(e,i){e=e|0;i=i|0;kP(e|0)|0}function UOe(e,i){e=e|0;i=i|0;hP(e|0)|0}function zOe(e,i){e=e|0;i=i|0;wP(e|0)|0}function jOe(e,i){e=e|0;i=i|0;dP(e|0)|0}function VOe(e,i){e=e|0;i=i|0;vP(e|0)|0}function qOe(e,i){e=e|0;i=i|0;mP(e|0)|0}function YOe(e,i){e=e|0;i=i|0;_P(e|0)|0}function GOe(e,i){e=e|0;i=i|0;pP(e|0)|0}function WOe(e,i){e=e|0;i=i|0;EP(e|0)|0}function KOe(e,i){e=e|0;i=i|0;SP(e|0)|0}function XOe(e,i){e=e|0;i=i|0;gP(e|0)|0}function ZOe(e,i){e=e|0;i=i|0;yP(e|0)|0}function JOe(e,i){e=e|0;i=i|0;FP(e|0)|0}function QOe(e,i){e=e|0;i=i|0;OP(e|0)|0}function $Oe(e,i){e=e|0;i=i|0;AP(e|0)|0}function eAe(e,i){e=e|0;i=i|0;MP(e|0)|0}function iAe(e,i){e=e|0;i=i|0;RP(e|0)|0}function rAe(e,i){e=e|0;i=i|0;NP(e|0)|0}function nAe(e,i){e=e|0;i=i|0;TP(e|0)|0}function fAe(e,i){e=e|0;i=i|0;LP(e|0)|0}function tAe(e,i){e=e|0;i=i|0;DP(e|0)|0}function uAe(e,i){e=e|0;i=i|0;CP(e|0)|0}function aAe(e,i){e=e|0;i=i|0;PP(e|0)|0}function oAe(e,i){e=e|0;i=i|0;BP(e|0)|0}function cAe(e,i){e=e|0;i=i|0;IP(e|0)|0}function lAe(e,i){e=e|0;i=i|0;HP(e|0)|0}function sAe(e,i){e=e|0;i=i|0;xP(e|0)|0}function bAe(e,i){e=e|0;i=i|0;UP(e|0)|0}function kAe(e,i){e=e|0;i=i|0;zP(e|0)|0}function hAe(e,i){e=e|0;i=i|0;jP(e|0)|0}function wAe(e,i){e=e|0;i=i|0;VP(e|0)|0}function dAe(e,i){e=e|0;i=i|0;qP(e|0)|0}function vAe(e,i){e=e|0;i=i|0;YP(e|0)|0}function mAe(e,i){e=e|0;i=i|0;GP(e|0)|0}function _Ae(e,i){e=e|0;i=i|0;WP(e|0)|0}function pAe(e,i){e=e|0;i=i|0;KP(e|0)|0}function EAe(e,i){e=e|0;i=i|0;XP(e|0)|0}function SAe(e,i){e=e|0;i=i|0;ZP(e|0)|0}function gAe(e,i){e=e|0;i=i|0;JP(e|0)|0}function yAe(e,i){e=e|0;i=i|0;QP(e|0)|0}function FAe(e,i){e=e|0;i=i|0;$P(e|0)|0}function OAe(e,i){e=e|0;i=i|0;eB(e|0)|0}function AAe(e,i){e=e|0;i=i|0;iB(e|0)|0}function MAe(e,i){e=e|0;i=i|0;rB(e|0)|0}function RAe(e,i){e=e|0;i=i|0;nB(e|0)|0}function NAe(e,i){e=e|0;i=i|0;fB(e|0)|0}function TAe(e,i){e=e|0;i=i|0;tB(e|0)|0}function LAe(e,i){e=e|0;i=i|0;uB(e|0)|0}function DAe(e,i){e=e|0;i=i|0;aB(e|0)|0}function CAe(e,i){e=e|0;i=i|0;oB(e|0)|0}function PAe(e,i){e=e|0;i=i|0;cB(e|0)|0}function BAe(e,i){e=e|0;i=i|0;lB(e|0)|0}function IAe(e,i){e=e|0;i=i|0;sB(e|0)|0}function HAe(e,i){e=e|0;i=i|0;bB(e|0)|0}function xAe(e,i){e=e|0;i=i|0;kB(e|0)|0}function UAe(e,i){e=e|0;i=i|0;hB(e|0)|0}function zAe(e,i){e=e|0;i=i|0;wB(e|0)|0}function jAe(e,i){e=e|0;i=i|0;dB(e|0)|0}function VAe(e,i){e=e|0;i=i|0;vB(e|0)|0}function qAe(e,i){e=e|0;i=i|0;mB(e|0)|0}function YAe(e,i){e=e|0;i=i|0;_B(e|0)|0}function GAe(e,i){e=e|0;i=i|0;pB(e|0)|0}function WAe(e,i){e=e|0;i=i|0;EB(e|0)|0}function KAe(e,i){e=e|0;i=i|0;SB(e|0)|0}function XAe(e,i){e=e|0;i=i|0;gB(e|0)|0}function ZAe(e,i){e=e|0;i=i|0;yB(e|0)|0}function JAe(e,i){e=e|0;i=i|0;FB(e|0)|0}function QAe(e,i){e=e|0;i=i|0;OB(e|0)|0}function $Ae(e,i){e=e|0;i=i|0;AB(e|0)|0}function eMe(e,i){e=e|0;i=i|0;MB(e|0)|0}function iMe(e,i){e=e|0;i=i|0;RB(e|0)|0}function rMe(e,i){e=e|0;i=i|0;NB(e|0)|0}function nMe(e,i){e=e|0;i=i|0;TB(e|0)|0}function fMe(e,i){e=e|0;i=i|0;LB(e|0)|0}function tMe(e,i){e=e|0;i=i|0;DB(e|0)|0}function uMe(e,i){e=e|0;i=i|0;CB(e|0)|0}function aMe(e,i){e=e|0;i=i|0;PB(e|0)|0}function oMe(e,i){e=e|0;i=i|0;BB(e|0)|0}function cMe(e,i){e=e|0;i=i|0;IB(e|0)|0}function lMe(e,i){e=e|0;i=i|0;HB(e|0)|0}function sMe(e,i){e=e|0;i=i|0;xB(e|0)|0}function bMe(e,i){e=e|0;i=i|0;UB(e|0)|0}function kMe(e,i){e=e|0;i=i|0;zB(e|0)|0}function hMe(e,i){e=e|0;i=i|0;jB(e|0)|0}function wMe(e,i){e=e|0;i=i|0;VB(e|0)|0}function dMe(e,i){e=e|0;i=i|0;qB(e|0)|0}function vMe(e,i){e=e|0;i=i|0;YB(e|0)|0}function mMe(e,i){e=e|0;i=i|0;NY(e|0,i|0,0)|0}function _Me(e,i){e=e|0;i=i|0;am(e|0)}function pMe(e,i){e=e|0;i=i|0;om(e|0)|0}function EMe(e,i){e=e|0;i=i|0;cm(e|0,i|0)|0}function SMe(e,i){e=e|0;i=i|0;lm(e|0)|0}function gMe(e,i){e=e|0;i=i|0;aA(e|0,i|0,0)|0}function yMe(e,i){e=e|0;i=i|0;bm(e|0)}function FMe(e,i){e=e|0;i=i|0;km(e|0)}function OMe(e,i){e=e|0;i=i|0;hm(e|0,i|0,0)|0}function AMe(e,i){e=e|0;i=i|0;xe(e|0,i|0,0)|0}function MMe(e,i){e=e|0;i=i|0;pm(e|0,i|0,0)|0}function RMe(e,i){e=e|0;i=i|0;Em(e|0)}function NMe(e,i){e=e|0;i=i|0;Sm(e|0,i|0,0)}function TMe(e,i){e=e|0;i=i|0;gm(e|0,i|0,0)}function LMe(e,i){e=e|0;i=i|0;ym(e|0,i|0,0)}function DMe(e,i){e=e|0;i=i|0;Fm(e|0,i|0,0)}function CMe(e,i){e=e|0;i=i|0;Am(e|0)|0}function PMe(e,i){e=e|0;i=i|0;A_(e|0)|0}function BMe(e,i){e=e|0;i=i|0;Z_(e|0,i|0,0,0)|0}function IMe(e,i){e=e|0;i=i|0;J_(e|0,i|0,0,0)|0}function HMe(e,i){e=e|0;i=i|0;Q_(e|0,i|0,0,0)|0}function xMe(e,i){e=e|0;i=i|0;$_(e|0,i|0,0,0)|0}function UMe(e,i){e=e|0;i=i|0;ep(e|0,i|0,0,0)|0}function zMe(e,i){e=e|0;i=i|0;ip(e|0,i|0,0,0)|0}function jMe(e,i){e=e|0;i=i|0;N_(e|0,i|0,0,0)|0}function VMe(e,i){e=e|0;i=i|0;T_(e|0,i|0,0,0)|0}function qMe(e,i){e=e|0;i=i|0;rp(e|0,i|0,0,0)|0}function YMe(e,i){e=e|0;i=i|0;np(e|0,i|0,0,0)|0}function GMe(e,i){e=e|0;i=i|0;dN(e|0,i|0,0,0)|0}function WMe(e,i){e=e|0;i=i|0;hp(e|0,i|0,0)}function KMe(e,i){e=e|0;i=i|0;wp(e|0,i|0,0)}function XMe(e,i){e=e|0;i=i|0;LS(e|0)}function ZMe(e,i){e=e|0;i=i|0;FO()|0}function JMe(e,i){e=e|0;i=i|0;Tg(e|0,i|0,0,0,0)}function QMe(e,i){e=e|0;i=i|0;_O(e|0,i|0,0,0,0)}function $Me(e,i){e=e|0;i=i|0;OO(e|0)|0}function eRe(e,i){e=e|0;i=i|0;AO(e|0)|0}function iRe(e,i){e=e|0;i=i|0;MO(e|0,i|0,0)|0}function rRe(e,i){e=e|0;i=i|0;RO(e|0)|0}function nRe(e,i){e=e|0;i=i|0;sA(e|0)|0}function fRe(e,i){e=e|0;i=i|0;bA(e|0,i|0,0)|0}function tRe(e,i){e=e|0;i=i|0;hA(e|0)|0}function uRe(e,i){e=e|0;i=i|0;wA(e|0,i|0,0)|0}function aRe(e,i){e=e|0;i=i|0;dA(e|0)|0}function oRe(e,i){e=e|0;i=i|0;vA(e|0,i|0,0)|0}function cRe(e,i){e=e|0;i=i|0;mA(e|0,i|0,0)|0}function lRe(e,i){e=e|0;i=i|0;_A(e|0,i|0,0,0)|0}function sRe(e,i){e=e|0;i=i|0;FR(e|0)}function bRe(e,i){e=e|0;i=i|0;OR(e|0)|0}function kRe(e,i){e=e|0;i=i|0;NR(e|0)}function hRe(e,i){e=e|0;i=i|0;DR(e|0)|0}function wRe(e,i){e=e|0;i=i|0;PR(e|0)}function dRe(e,i){e=e|0;i=i|0;BR(e|0)|0}function vRe(e,i){e=e|0;i=i|0;HR(e|0)}function mRe(e,i){e=e|0;i=i|0;xR(e|0)}function _Re(e,i){e=e|0;i=i|0;UR(e|0,i|0)|0}function pRe(e,i){e=e|0;i=i|0;zR(e|0)}function ERe(e,i){e=e|0;i=i|0;GR(e|0,i|0,0)}function SRe(e,i){e=e|0;i=i|0;iN(e|0,i|0,0)}function gRe(e,i){e=e|0;i=i|0;rN(e|0,i|0,0)}function yRe(e,i){e=e|0;i=i|0;nN(e|0,i|0,0)}function FRe(e,i){e=e|0;i=i|0;fN(e|0,i|0,0)}function ORe(e,i){e=e|0;i=i|0;lN(e|0,i|0)|0}function ARe(e,i){e=e|0;i=i|0;_n(e|0)}function MRe(e,i){e=e|0;i=i|0;Qu(e|0,i|0,0)|0}function RRe(e,i){e=e|0;i=i|0;Pf(e|0,i|0)|0}function NRe(e,i){e=e|0;i=i|0;Bf(e|0,i|0)|0}function TRe(e,i){e=e|0;i=i|0;zf(e|0,i|0)|0}function LRe(e,i){e=e|0;i=i|0;$u(e|0,i|0,0)|0}function DRe(e,i){e=e|0;i=i|0;ea(e|0,i|0)|0}function CRe(e,i){e=e|0;i=i|0;Tf(e|0,i|0)|0}function PRe(e,i){e=e|0;i=i|0;Lf(e|0,i|0)|0}function BRe(e,i){e=e|0;i=i|0;Df(e|0,i|0)|0}function IRe(e,i){e=e|0;i=i|0;xf(e|0,i|0)|0}function HRe(e,i){e=e|0;i=i|0;If(e|0,i|0)|0}function xRe(e,i){e=e|0;i=i|0;Uf(e|0,i|0)|0}function URe(e,i){e=e|0;i=i|0;Cf(e|0,i|0)|0}function zRe(e,i){e=e|0;i=i|0;ia(e|0,i|0)|0}function jRe(e,i){e=e|0;i=i|0;Hf(e|0,i|0)|0}function VRe(e,i){e=e|0;i=i|0;Nf(e|0,i|0)|0}function qRe(e,i){e=e|0;i=i|0;Cn(e|0,i|0)|0}function YRe(e,i){e=e|0;i=i|0;Qo(e|0,i|0,0)}function GRe(e,i){e=e|0;i=i|0;vc(e|0)}function WRe(e,i){e=e|0;i=i|0;Rc(e|0)}function KRe(e,i){e=e|0;i=i|0;wl(e|0,i|0,0)|0}function XRe(e,i){e=e|0;i=i|0;Ll(e|0,i|0)|0}function ZRe(e,i){e=e|0;i=i|0;Bl(e|0,i|0)|0}function JRe(e,i){e=e|0;i=i|0;Hl(e|0,i|0)|0}function QRe(e,i){e=e|0;i=i|0;jl(e|0,i|0)|0}function $Re(e,i){e=e|0;i=i|0;Xk(e|0)}function eNe(e,i){e=e|0;i=i|0;dh(e|0,i|0,0,0,0,0,0,0,0)}function iNe(e,i){e=e|0;i=i|0;vh(e|0,i|0,0,0)}function rNe(e,i){e=e|0;i=i|0;mh(e|0,i|0,0)}function nNe(e,i){e=e|0;i=i|0;_h(e|0,i|0,0)}function fNe(e,i){e=e|0;i=i|0;Eh(e|0,i|0,0,0)}function tNe(e,i){e=e|0;i=i|0;Sh(e|0)|0}function uNe(e,i){e=e|0;i=i|0;gh(e|0)|0}function aNe(e,i){e=e|0;i=i|0;yh(e|0)|0}function oNe(e,i){e=e|0;i=i|0;Fh(e|0,i|0,0)|0}function cNe(e,i){e=e|0;i=i|0;Oh(e|0,i|0)|0}function lNe(e,i){e=e|0;i=i|0;Ah(e|0,i|0,0,0,0,0)}function sNe(e,i){e=e|0;i=i|0;Mh(e|0,i|0,0,0)}function bNe(e,i){e=e|0;i=i|0;Rh(e|0,i|0,0,0,0,0,0)}function kNe(e,i){e=e|0;i=i|0;Nh(e|0,i|0,0,0)}function hNe(e,i){e=e|0;i=i|0;Th(e|0,i|0,0,0,0)}function wNe(e,i){e=e|0;i=i|0;Dh(e|0)}function dNe(e,i){e=e|0;i=i|0;Ch(e|0)}function vNe(e,i){e=e|0;i=i|0;Ph(e|0,i|0,0)}function mNe(e,i){e=e|0;i=i|0;Ih(e|0,i|0,0)}function _Ne(e,i){e=e|0;i=i|0;Hh(e|0,i|0,0)}function pNe(e,i){e=e|0;i=i|0;xh(e|0,i|0,0)}function ENe(e,i){e=e|0;i=i|0;Uh(e|0,i|0)|0}function SNe(e,i){e=e|0;i=i|0;zh(e|0,i|0,0,0)}function gNe(e,i){e=e|0;i=i|0;jh(e|0,i|0,0)}function yNe(e,i){e=e|0;i=i|0;Vh(e|0,i|0,0)}function FNe(e,i){e=e|0;i=i|0;qh(e|0,i|0,0)}function ONe(e,i){e=e|0;i=i|0;Gh(e|0,i|0,0,0,0,0,0,0,0)}function ANe(e,i){e=e|0;i=i|0;Wh(e|0,i|0,0,0)}function MNe(e,i){e=e|0;i=i|0;Zh(e|0,i|0,0)|0}function RNe(e,i){e=e|0;i=i|0;$h(e|0)}function NNe(e,i){e=e|0;i=i|0;qv(e|0,i|0,0,0)}function TNe(e,i){e=e|0;i=i|0;Ok(e|0)}function LNe(e,i){e=e|0;i=i|0;cH(e|0,i|0,0)}function DNe(e,i){e=e|0;i=i|0;sH(e|0,i|0,0,0,0,0,0,0,0)}function CNe(e,i){e=e|0;i=i|0;bH(e|0,i|0,0,0)}function PNe(e,i){e=e|0;i=i|0;kH(e|0,i|0,0)}function BNe(e,i){e=e|0;i=i|0;hH(e|0,i|0,0)}function INe(e,i){e=e|0;i=i|0;dH(e|0,i|0,0)}function HNe(e,i){e=e|0;i=i|0;vH(e|0,i|0,0)}function xNe(e,i){e=e|0;i=i|0;_H(e|0,i|0,0)|0}function UNe(e,i){e=e|0;i=i|0;DH(e|0)}function zNe(e,i){e=e|0;i=i|0;ex(e|0,i|0)|0}function jNe(e,i){e=e|0;i=i|0;ix(e|0,i|0,0,0,0)|0}function VNe(e,i){e=e|0;i=i|0;rx(e|0,i|0,0,0,0,0,0)|0}function qNe(e,i){e=e|0;i=i|0;nx(e|0,i|0,0,0,0,0)|0}function YNe(e,i){e=e|0;i=i|0;ux(e|0,i|0)|0}function GNe(e,i){e=e|0;i=i|0;ax(e|0,i|0,0,0,0)|0}function WNe(e,i){e=e|0;i=i|0;ox(e|0,i|0,0,0,0,0,0)|0}function KNe(e,i){e=e|0;i=i|0;wx(e|0,i|0,0)}function XNe(e,i){e=e|0;i=i|0;_x(e|0,i|0,0,0)}function ZNe(e,i){e=e|0;i=i|0;oU(e|0,i|0,0)}function JNe(e,i){e=e|0;i=i|0;cU(e|0,i|0,0)}function QNe(e,i){e=e|0;i=i|0;GU(e|0,i|0,0,0)}function $Ne(e,i){e=e|0;i=i|0;tz(e|0,i|0,0)}function eTe(e,i){e=e|0;i=i|0;Gz(e|0,i|0,0,0,0,0,0,0,0)}function iTe(e,i){e=e|0;i=i|0;Wz(e|0,i|0,0,0)}function rTe(e,i){e=e|0;i=i|0;PV(e|0,i|0,0,0)|0}function nTe(e,i){e=e|0;i=i|0;Rq(e|0,i|0)|0}function fTe(e,i){e=e|0;i=i|0;Kq(e|0,i|0,0)|0}function tTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ue(7);return 0}function uTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function aTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Pm(e|0)|0}function oTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Bm(e|0)|0}function cTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Im(e|0)|0}function lTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Hm(e|0,i|0,r|0)|0}function sTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return xm(e|0,i|0)|0}function bTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function kTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function hTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function wTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function dTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function vTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function mTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function _Te(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function pTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ETe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function STe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function gTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function yTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function FTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function OTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ATe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function MTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function RTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function NTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return r_(e|0,i|0)|0}function TTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function LTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function DTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function CTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function PTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return oA(e|0,i|0,r|0)|0}function BTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ITe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Xq(e|0)|0}function HTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Jq(e|0,i|0)|0}function xTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Yl(e|0)|0}function UTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function zTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function jTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Mz(e|0)|0}function VTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Rz(e|0)|0}function qTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Nz(e|0)|0}function YTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Dz(e|0,i|0,r|0)|0}function GTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Cz(e|0,i|0)|0}function WTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function KTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function XTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ZTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function JTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function QTe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function $Te(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function eLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function iLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function rLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function nLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function fLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function tLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function uLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function aLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function oLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function cLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Pz(e|0,i|0)|0}function lLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function sLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function bLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return yz(e|0)|0}function kLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Fz(e|0)|0}function hLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Oz(e|0)|0}function wLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Az(e|0)|0}function dLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function vLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return OC(e|0)|0}function mLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return AC(e|0)|0}function _Le(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return MC(e|0)|0}function pLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return RC(e|0)|0}function ELe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return NC(e|0)|0}function SLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return TC(e|0)|0}function gLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return LC(e|0)|0}function yLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return DC(e|0)|0}function FLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return CC(e|0)|0}function OLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return PC(e|0)|0}function ALe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return BC(e|0)|0}function MLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return IC(e|0)|0}function RLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return HC(e|0)|0}function NLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return xC(e|0)|0}function TLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return UC(e|0)|0}function LLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return zC(e|0)|0}function DLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return jC(e|0)|0}function CLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return VC(e|0)|0}function PLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return qC(e|0)|0}function BLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return YC(e|0)|0}function ILe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return GC(e|0)|0}function HLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return WC(e|0)|0}function xLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return KC(e|0)|0}function ULe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return XC(e|0)|0}function zLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ZC(e|0)|0}function jLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return JC(e|0)|0}function VLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return QC(e|0)|0}function qLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return $C(e|0)|0}function YLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return eP(e|0)|0}function GLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return iP(e|0)|0}function WLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return rP(e|0)|0}function KLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return nP(e|0)|0}function XLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return fP(e|0)|0}function ZLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return tP(e|0)|0}function JLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return uP(e|0)|0}function QLe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return aP(e|0)|0}function $Le(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return oP(e|0)|0}function eDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return cP(e|0)|0}function iDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return lP(e|0)|0}function rDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return sP(e|0)|0}function nDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return bP(e|0)|0}function fDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return kP(e|0)|0}function tDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return hP(e|0)|0}function uDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return wP(e|0)|0}function aDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return dP(e|0)|0}function oDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return vP(e|0)|0}function cDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return mP(e|0)|0}function lDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return _P(e|0)|0}function sDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return pP(e|0)|0}function bDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return EP(e|0)|0}function kDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return SP(e|0)|0}function hDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return gP(e|0)|0}function wDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return yP(e|0)|0}function dDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return FP(e|0)|0}function vDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return OP(e|0)|0}function mDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return AP(e|0)|0}function _De(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return MP(e|0)|0}function pDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return RP(e|0)|0}function EDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return NP(e|0)|0}function SDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return TP(e|0)|0}function gDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return LP(e|0)|0}function yDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return DP(e|0)|0}function FDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return CP(e|0)|0}function ODe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return PP(e|0)|0}function ADe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return BP(e|0)|0}function MDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return IP(e|0)|0}function RDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return HP(e|0)|0}function NDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return xP(e|0)|0}function TDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return UP(e|0)|0}function LDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return zP(e|0)|0}function DDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return jP(e|0)|0}function CDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return VP(e|0)|0}function PDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return qP(e|0)|0}function BDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return YP(e|0)|0}function IDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return GP(e|0)|0}function HDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return WP(e|0)|0}function xDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return KP(e|0)|0}function UDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return XP(e|0)|0}function zDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ZP(e|0)|0}function jDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return JP(e|0)|0}function VDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return QP(e|0)|0}function qDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return $P(e|0)|0;
	}function YDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return eB(e|0)|0}function GDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return iB(e|0)|0}function WDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return rB(e|0)|0}function KDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return nB(e|0)|0}function XDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return fB(e|0)|0}function ZDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return tB(e|0)|0}function JDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return uB(e|0)|0}function QDe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return aB(e|0)|0}function $De(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return oB(e|0)|0}function eCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return cB(e|0)|0}function iCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return lB(e|0)|0}function rCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return sB(e|0)|0}function nCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return bB(e|0)|0}function fCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return kB(e|0)|0}function tCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return hB(e|0)|0}function uCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return wB(e|0)|0}function aCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return dB(e|0)|0}function oCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return vB(e|0)|0}function cCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return mB(e|0)|0}function lCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return _B(e|0)|0}function sCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return pB(e|0)|0}function bCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return EB(e|0)|0}function kCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return SB(e|0)|0}function hCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return gB(e|0)|0}function wCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return yB(e|0)|0}function dCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return FB(e|0)|0}function vCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return OB(e|0)|0}function mCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return AB(e|0)|0}function _Ce(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return MB(e|0)|0}function pCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return RB(e|0)|0}function ECe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return NB(e|0)|0}function SCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return TB(e|0)|0}function gCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return LB(e|0)|0}function yCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return DB(e|0)|0}function FCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return CB(e|0)|0}function OCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return PB(e|0)|0}function ACe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return BB(e|0)|0}function MCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return IB(e|0)|0}function RCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return HB(e|0)|0}function NCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return xB(e|0)|0}function TCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return UB(e|0)|0}function LCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return zB(e|0)|0}function DCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return jB(e|0)|0}function CCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return VB(e|0)|0}function PCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return qB(e|0)|0}function BCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return YB(e|0)|0}function ICe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return NY(e|0,i|0,r|0)|0}function HCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function xCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return om(e|0)|0}function UCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return cm(e|0,i|0)|0}function zCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return lm(e|0)|0}function jCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return aA(e|0,i|0,r|0)|0}function VCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function qCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function YCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return hm(e|0,i|0,r|0)|0}function GCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return xe(e|0,i|0,r|0)|0}function WCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return pm(e|0,i|0,r|0)|0}function KCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function XCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ZCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function JCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function QCe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function $Ce(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Am(e|0)|0}function ePe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function iPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return A_(e|0)|0}function rPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Z_(e|0,i|0,r|0,n|0)|0}function nPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return J_(e|0,i|0,r|0,n|0)|0}function fPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Q_(e|0,i|0,r|0,n|0)|0}function tPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return $_(e|0,i|0,r|0,n|0)|0}function uPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ep(e|0,i|0,r|0,n|0)|0}function aPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ip(e|0,i|0,r|0,n|0)|0}function oPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return N_(e|0,i|0,r|0,n|0)|0}function cPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return T_(e|0,i|0,r|0,n|0)|0}function lPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return rp(e|0,i|0,r|0,n|0)|0}function sPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return np(e|0,i|0,r|0,n|0)|0}function bPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return dN(e|0,i|0,r|0,n|0)|0}function kPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function hPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function wPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function dPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return FO()|0}function vPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function mPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function _Pe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return OO(e|0)|0}function pPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return AO(e|0)|0}function EPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return MO(e|0,i|0,r|0)|0}function SPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return RO(e|0)|0}function gPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return sA(e|0)|0}function yPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return bA(e|0,i|0,r|0)|0}function FPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return hA(e|0)|0}function OPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return wA(e|0,i|0,r|0)|0}function APe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return dA(e|0)|0}function MPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return vA(e|0,i|0,r|0)|0}function RPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return mA(e|0,i|0,r|0)|0}function NPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return _A(e|0,i|0,r|0,n|0)|0}function TPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function LPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return OR(e|0)|0}function DPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function CPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return DR(e|0)|0}function PPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function BPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return BR(e|0)|0}function IPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function HPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function xPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function UPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return UR(e|0,i|0)|0}function zPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function jPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function VPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function qPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function YPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function GPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function WPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return lN(e|0,i|0)|0}function KPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function XPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ZPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function JPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function QPe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function $Pe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function eBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function iBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function rBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function nBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function fBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function tBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function uBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function aBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function oBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function cBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function lBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function sBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function bBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function kBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function hBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function wBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function dBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function vBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function mBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function _Be(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function pBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function EBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function SBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function gBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function yBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Qu(e|0,i|0,r|0)|0}function FBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Pf(e|0,i|0)|0}function OBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Bf(e|0,i|0)|0}function ABe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return zf(e|0,i|0)|0}function MBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return $u(e|0,i|0,r|0)|0}function RBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ea(e|0,i|0)|0}function NBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Tf(e|0,i|0)|0}function TBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Lf(e|0,i|0)|0}function LBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Df(e|0,i|0)|0}function DBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return xf(e|0,i|0)|0}function CBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return If(e|0,i|0)|0}function PBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Uf(e|0,i|0)|0}function BBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Cf(e|0,i|0)|0}function IBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ia(e|0,i|0)|0}function HBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Hf(e|0,i|0)|0}function xBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Nf(e|0,i|0)|0}function UBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Cn(e|0,i|0)|0}function zBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function jBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function VBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function qBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function YBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function GBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function WBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function KBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function XBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ZBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function JBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function QBe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return wl(e|0,i|0,r|0)|0}function $Be(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Ll(e|0,i|0)|0}function eIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Bl(e|0,i|0)|0}function iIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Hl(e|0,i|0)|0}function rIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return jl(e|0,i|0)|0}function nIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function fIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function tIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function uIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function aIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function oIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function cIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function lIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Sh(e|0)|0}function sIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return gh(e|0)|0}function bIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return yh(e|0)|0}function kIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Fh(e|0,i|0,r|0)|0}function hIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Oh(e|0,i|0)|0}function wIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function dIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function vIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function mIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function _Ie(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function pIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function EIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function SIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function gIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function yIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function FIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function OIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function AIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function MIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Uh(e|0,i|0)|0}function RIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function NIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function TIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function LIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function DIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function CIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function PIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function BIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Zh(e|0,i|0,r|0)|0}function IIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function HIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function xIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function UIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function zIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function jIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function VIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function qIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function YIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function GIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function WIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function KIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function XIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function ZIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return _H(e|0,i|0,r|0)|0}function JIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function QIe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function $Ie(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ex(e|0,i|0)|0}function eHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ix(e|0,i|0,r|0,n|0,f|0)|0}function iHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return rx(e|0,i|0,r|0,n|0,f|0,t|0,0)|0}function rHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function nHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ux(e|0,i|0)|0}function fHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ax(e|0,i|0,r|0,n|0,f|0)|0}function tHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return ox(e|0,i|0,r|0,n|0,f|0,t|0,0)|0}function uHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function aHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function oHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function cHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function lHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function sHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function bHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function kHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function hHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return 0}function wHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return PV(e|0,i|0,r|0,n|0)|0}function dHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Rq(e|0,i|0)|0}function vHe(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;return Kq(e|0,i|0,r|0)|0}function mHe(e){e=e|0;ue(8);return 0}function _He(e){e=e|0;return 0}function pHe(e){e=e|0;return Hm(e|0,0,0)|0}function EHe(e){e=e|0;return xm(e|0,0)|0}function SHe(e){e=e|0;return 0}function gHe(e){e=e|0;return 0}function yHe(e){e=e|0;return 0}function FHe(e){e=e|0;return 0}function OHe(e){e=e|0;return 0}function AHe(e){e=e|0;return 0}function MHe(e){e=e|0;return 0}function RHe(e){e=e|0;return 0}function NHe(e){e=e|0;return 0}function THe(e){e=e|0;return 0}function LHe(e){e=e|0;return 0}function DHe(e){e=e|0;return 0}function CHe(e){e=e|0;return 0}function PHe(e){e=e|0;return 0}function BHe(e){e=e|0;return 0}function IHe(e){e=e|0;return 0}function HHe(e){e=e|0;return 0}function xHe(e){e=e|0;return 0}function UHe(e){e=e|0;return r_(e|0,0)|0}function zHe(e){e=e|0;return 0}function jHe(e){e=e|0;return 0}function VHe(e){e=e|0;return 0}function qHe(e){e=e|0;return 0}function YHe(e){e=e|0;return oA(e|0,0,0)|0}function GHe(e){e=e|0;return 0}function WHe(e){e=e|0;return Jq(e|0,0)|0}function KHe(e){e=e|0;return 0}function XHe(e){e=e|0;return 0}function ZHe(e){e=e|0;return Dz(e|0,0,0)|0}function JHe(e){e=e|0;return Cz(e|0,0)|0}function QHe(e){e=e|0;return 0}function $He(e){e=e|0;return 0}function exe(e){e=e|0;return 0}function ixe(e){e=e|0;return 0}function rxe(e){e=e|0;return 0}function nxe(e){e=e|0;return 0}function fxe(e){e=e|0;return 0}function txe(e){e=e|0;return 0}function uxe(e){e=e|0;return 0}function axe(e){e=e|0;return 0}function oxe(e){e=e|0;return 0}function cxe(e){e=e|0;return 0}function lxe(e){e=e|0;return 0}function sxe(e){e=e|0;return 0}function bxe(e){e=e|0;return 0}function kxe(e){e=e|0;return 0}function hxe(e){e=e|0;return Pz(e|0,0)|0}function wxe(e){e=e|0;return 0}function dxe(e){e=e|0;return 0}function vxe(e){e=e|0;return 0}function mxe(e){e=e|0;return NY(e|0,0,0)|0}function _xe(e){e=e|0;return 0}function pxe(e){e=e|0;return cm(e|0,0)|0}function Exe(e){e=e|0;return aA(e|0,0,0)|0}function Sxe(e){e=e|0;return 0}function gxe(e){e=e|0;return 0}function yxe(e){e=e|0;return hm(e|0,0,0)|0}function Fxe(e){e=e|0;return xe(e|0,0,0)|0}function Oxe(e){e=e|0;return pm(e|0,0,0)|0}function Axe(e){e=e|0;return 0}function Mxe(e){e=e|0;return 0}function Rxe(e){e=e|0;return 0}function Nxe(e){e=e|0;return 0}function Txe(e){e=e|0;return 0}function Lxe(e){e=e|0;return 0}function Dxe(e){e=e|0;return Z_(e|0,0,0,0)|0}function Cxe(e){e=e|0;return J_(e|0,0,0,0)|0}function Pxe(e){e=e|0;return Q_(e|0,0,0,0)|0}function Bxe(e){e=e|0;return $_(e|0,0,0,0)|0}function Ixe(e){e=e|0;return ep(e|0,0,0,0)|0}function Hxe(e){e=e|0;return ip(e|0,0,0,0)|0}function xxe(e){e=e|0;return N_(e|0,0,0,0)|0}function Uxe(e){e=e|0;return T_(e|0,0,0,0)|0}function zxe(e){e=e|0;return rp(e|0,0,0,0)|0}function jxe(e){e=e|0;return np(e|0,0,0,0)|0}function Vxe(e){e=e|0;return dN(e|0,0,0,0)|0}function qxe(e){e=e|0;return 0}function Yxe(e){e=e|0;return 0}function Gxe(e){e=e|0;return 0}function Wxe(e){e=e|0;return FO()|0}function Kxe(e){e=e|0;return 0}function Xxe(e){e=e|0;return 0}function Zxe(e){e=e|0;return MO(e|0,0,0)|0}function Jxe(e){e=e|0;return bA(e|0,0,0)|0}function Qxe(e){e=e|0;return wA(e|0,0,0)|0}function $xe(e){e=e|0;return vA(e|0,0,0)|0}function eUe(e){e=e|0;return mA(e|0,0,0)|0}function iUe(e){e=e|0;return _A(e|0,0,0,0)|0}function rUe(e){e=e|0;return 0}function nUe(e){e=e|0;return 0}function fUe(e){e=e|0;return 0}function tUe(e){e=e|0;return 0}function uUe(e){e=e|0;return 0}function aUe(e){e=e|0;return 0}function oUe(e){e=e|0;return UR(e|0,0)|0}function cUe(e){e=e|0;return 0}function lUe(e){e=e|0;return 0}function sUe(e){e=e|0;return 0}function bUe(e){e=e|0;return 0}function kUe(e){e=e|0;return 0}function hUe(e){e=e|0;return 0}function wUe(e){e=e|0;return lN(e|0,0)|0}function dUe(e){e=e|0;return 0}function vUe(e){e=e|0;return 0}function mUe(e){e=e|0;return 0}function _Ue(e){e=e|0;return 0}function pUe(e){e=e|0;return 0}function EUe(e){e=e|0;return 0}function SUe(e){e=e|0;return 0}function gUe(e){e=e|0;return 0}function yUe(e){e=e|0;return 0}function FUe(e){e=e|0;return 0}function OUe(e){e=e|0;return 0}function AUe(e){e=e|0;return 0}function MUe(e){e=e|0;return 0}function RUe(e){e=e|0;return 0}function NUe(e){e=e|0;return 0}function TUe(e){e=e|0;return 0}function LUe(e){e=e|0;return 0}function DUe(e){e=e|0;return 0}function CUe(e){e=e|0;return 0}function PUe(e){e=e|0;return 0}function BUe(e){e=e|0;return 0}function IUe(e){e=e|0;return 0}function HUe(e){e=e|0;return 0}function xUe(e){e=e|0;return 0}function UUe(e){e=e|0;return 0}function zUe(e){e=e|0;return 0}function jUe(e){e=e|0;return 0}function VUe(e){e=e|0;return 0}function qUe(e){e=e|0;return 0}function YUe(e){e=e|0;return 0}function GUe(e){e=e|0;return Qu(e|0,0,0)|0}function WUe(e){e=e|0;return Pf(e|0,0)|0}function KUe(e){e=e|0;return Bf(e|0,0)|0}function XUe(e){e=e|0;return zf(e|0,0)|0}function ZUe(e){e=e|0;return $u(e|0,0,0)|0}function JUe(e){e=e|0;return ea(e|0,0)|0}function QUe(e){e=e|0;return Tf(e|0,0)|0}function $Ue(e){e=e|0;return Lf(e|0,0)|0}function eze(e){e=e|0;return Df(e|0,0)|0}function ize(e){e=e|0;return xf(e|0,0)|0}function rze(e){e=e|0;return If(e|0,0)|0}function nze(e){e=e|0;return Uf(e|0,0)|0}function fze(e){e=e|0;return Cf(e|0,0)|0}function tze(e){e=e|0;return ia(e|0,0)|0}function uze(e){e=e|0;return Hf(e|0,0)|0}function aze(e){e=e|0;return Nf(e|0,0)|0}function oze(e){e=e|0;return Cn(e|0,0)|0}function cze(e){e=e|0;return 0}function lze(e){e=e|0;return 0}function sze(e){e=e|0;return 0}function bze(e){e=e|0;return 0}function kze(e){e=e|0;return 0}function hze(e){e=e|0;return 0}function wze(e){e=e|0;return 0}function dze(e){e=e|0;return 0}function vze(e){e=e|0;return 0}function mze(e){e=e|0;return 0}function _ze(e){e=e|0;return 0}function pze(e){e=e|0;return wl(e|0,0,0)|0}function Eze(e){e=e|0;return Ll(e|0,0)|0}function Sze(e){e=e|0;return Bl(e|0,0)|0}function gze(e){e=e|0;return Hl(e|0,0)|0}function yze(e){e=e|0;return jl(e|0,0)|0}function Fze(e){e=e|0;return 0}function Oze(e){e=e|0;return 0}function Aze(e){e=e|0;return 0}function Mze(e){e=e|0;return 0}function Rze(e){e=e|0;return 0}function Nze(e){e=e|0;return 0}function Tze(e){e=e|0;return 0}function Lze(e){e=e|0;return Fh(e|0,0,0)|0}function Dze(e){e=e|0;return Oh(e|0,0)|0}function Cze(e){e=e|0;return 0}function Pze(e){e=e|0;return 0}function Bze(e){e=e|0;return 0}function Ize(e){e=e|0;return 0}function Hze(e){e=e|0;return 0}function xze(e){e=e|0;return 0}function Uze(e){e=e|0;return 0}function zze(e){e=e|0;return 0}function jze(e){e=e|0;return 0}function Vze(e){e=e|0;return 0}function qze(e){e=e|0;return 0}function Yze(e){e=e|0;return 0}function Gze(e){e=e|0;return 0}function Wze(e){e=e|0;return Uh(e|0,0)|0}function Kze(e){e=e|0;return 0}function Xze(e){e=e|0;return 0}function Zze(e){e=e|0;return 0}function Jze(e){e=e|0;return 0}function Qze(e){e=e|0;return 0}function $ze(e){e=e|0;return 0}function eje(e){e=e|0;return 0}function ije(e){e=e|0;return Zh(e|0,0,0)|0}function rje(e){e=e|0;return 0}function nje(e){e=e|0;return 0}function fje(e){e=e|0;return 0}function tje(e){e=e|0;return 0}function uje(e){e=e|0;return 0}function aje(e){e=e|0;return 0}function oje(e){e=e|0;return 0}function cje(e){e=e|0;return 0}function lje(e){e=e|0;return 0}function sje(e){e=e|0;return 0}function bje(e){e=e|0;return 0}function kje(e){e=e|0;return 0}function hje(e){e=e|0;return 0}function wje(e){e=e|0;return _H(e|0,0,0)|0}function dje(e){e=e|0;return 0}function vje(e){e=e|0;return 0}function mje(e){e=e|0;return ex(e|0,0)|0}function _je(e){e=e|0;return ix(e|0,0,0,0,0)|0}function pje(e){e=e|0;return rx(e|0,0,0,0,0,0,0)|0}function Eje(e){e=e|0;return nx(e|0,0,0,0,0,0)|0}function Sje(e){e=e|0;return 0}function gje(e){e=e|0;return ux(e|0,0)|0}function yje(e){e=e|0;return ax(e|0,0,0,0,0)|0}function Fje(e){e=e|0;return ox(e|0,0,0,0,0,0,0)|0}function Oje(e){e=e|0;return 0}function Aje(e){e=e|0;return 0}function Mje(e){e=e|0;return 0}function Rje(e){e=e|0;return 0}function Nje(e){e=e|0;return 0}function Tje(e){e=e|0;return 0}function Lje(e){e=e|0;return 0}function Dje(e){e=e|0;return 0}function Cje(e){e=e|0;return 0}function Pje(e){e=e|0;return PV(e|0,0,0,0)|0}function Bje(e){e=e|0;return Rq(e|0,0)|0}function Ije(e){e=e|0;return Kq(e|0,0,0)|0}function Hje(e,i,r){e=e|0;i=i|0;r=r|0;ue(9)}function xje(e,i,r){e=e|0;i=i|0;r=r|0;Cm(e|0,i|0,r|0,0)}function Uje(e,i,r){e=e|0;i=i|0;r=r|0;Pm(e|0)|0}function zje(e,i,r){e=e|0;i=i|0;r=r|0;Bm(e|0)|0}function jje(e,i,r){e=e|0;i=i|0;r=r|0;Im(e|0)|0}function Vje(e,i,r){e=e|0;i=i|0;r=r|0;Hm(e|0,i|0,r|0)|0}function qje(e,i,r){e=e|0;i=i|0;r=r|0;xm(e|0,i|0)|0}function Yje(e,i,r){e=e|0;i=i|0;r=r|0;Um(e|0,i|0,r|0,0,0,0)}function Gje(e,i,r){e=e|0;i=i|0;r=r|0;zm(e|0,i|0,r|0,0)}function Wje(e,i,r){e=e|0;i=i|0;r=r|0;jm(e|0,i|0,r|0,0,0,0,0)}function Kje(e,i,r){e=e|0;i=i|0;r=r|0;Vm(e|0,i|0,r|0,0)}function Xje(e,i,r){e=e|0;i=i|0;r=r|0;qm(e|0,i|0,r|0,0,0)}function Zje(e,i,r){e=e|0;i=i|0;r=r|0;Ym(e|0,i|0)}function Jje(e,i,r){e=e|0;i=i|0;r=r|0;Gm(e|0)}function Qje(e,i,r){e=e|0;i=i|0;r=r|0;Wm(e|0)}function $je(e,i,r){e=e|0;i=i|0;r=r|0;c_(e|0,i|0)}function eVe(e,i,r){e=e|0;i=i|0;r=r|0;Km(e|0,i|0)}function iVe(e,i,r){e=e|0;i=i|0;r=r|0;Qm(e|0,i|0)}function rVe(e,i,r){e=e|0;i=i|0;r=r|0;r_(e|0,i|0)|0}function nVe(e,i,r){e=e|0;i=i|0;r=r|0;f_(e|0,i|0,r|0,0)}function fVe(e,i,r){e=e|0;i=i|0;r=r|0;t_(e|0,i|0,r|0,0,0,0,0,0,0)}function tVe(e,i,r){e=e|0;i=i|0;r=r|0;u_(e|0,i|0,r|0,0)}function uVe(e,i,r){e=e|0;i=i|0;r=r|0;oA(e|0,i|0,r|0)|0}function aVe(e,i,r){e=e|0;i=i|0;r=r|0;Zq(e|0)}function oVe(e,i,r){e=e|0;i=i|0;r=r|0;Xq(e|0)|0}function cVe(e,i,r){e=e|0;i=i|0;r=r|0;Jq(e|0,i|0)|0}function lVe(e,i,r){e=e|0;i=i|0;r=r|0;Yl(e|0)|0}function sVe(e,i,r){e=e|0;i=i|0;r=r|0;Tz(e|0,i|0,r|0,0)}function bVe(e,i,r){e=e|0;i=i|0;r=r|0;Mz(e|0)|0}function kVe(e,i,r){e=e|0;i=i|0;r=r|0;Rz(e|0)|0}function hVe(e,i,r){e=e|0;i=i|0;r=r|0;Nz(e|0)|0}function wVe(e,i,r){e=e|0;i=i|0;r=r|0;Dz(e|0,i|0,r|0)|0}function dVe(e,i,r){e=e|0;i=i|0;r=r|0;Cz(e|0,i|0)|0}function vVe(e,i,r){e=e|0;i=i|0;r=r|0;Bz(e|0,i|0,r|0,0,0,0)}function mVe(e,i,r){e=e|0;i=i|0;r=r|0;xz(e|0,i|0,r|0,0)}function _Ve(e,i,r){e=e|0;i=i|0;r=r|0;Iz(e|0,i|0,r|0,0,0,0,0)}function pVe(e,i,r){e=e|0;i=i|0;r=r|0;Hz(e|0,i|0,r|0,0)}function EVe(e,i,r){e=e|0;i=i|0;r=r|0;Uz(e|0,i|0,r|0,0,0)}function SVe(e,i,r){e=e|0;i=i|0;r=r|0;zz(e|0,i|0)}function gVe(e,i,r){e=e|0;i=i|0;r=r|0;jz(e|0)}function yVe(e,i,r){e=e|0;i=i|0;r=r|0;Vz(e|0)}function FVe(e,i,r){e=e|0;i=i|0;r=r|0;Yz(e|0,i|0)}function OVe(e,i,r){e=e|0;i=i|0;r=r|0;Kz(e|0,i|0)}function AVe(e,i,r){e=e|0;i=i|0;r=r|0;Qz(e|0,i|0)}function MVe(e,i,r){e=e|0;i=i|0;r=r|0;Pz(e|0,i|0)|0}function RVe(e,i,r){e=e|0;i=i|0;r=r|0;Lz(e|0,i|0,r|0,0)}function NVe(e,i,r){e=e|0;i=i|0;r=r|0;yz(e|0)|0}function TVe(e,i,r){e=e|0;i=i|0;r=r|0;Fz(e|0)|0}function LVe(e,i,r){e=e|0;i=i|0;r=r|0;Oz(e|0)|0}function DVe(e,i,r){e=e|0;i=i|0;r=r|0;Az(e|0)|0}function CVe(e,i,r){e=e|0;i=i|0;r=r|0;OC(e|0)|0}function PVe(e,i,r){e=e|0;i=i|0;r=r|0;AC(e|0)|0}function BVe(e,i,r){e=e|0;i=i|0;r=r|0;MC(e|0)|0}function IVe(e,i,r){e=e|0;i=i|0;r=r|0;RC(e|0)|0}function HVe(e,i,r){e=e|0;i=i|0;r=r|0;NC(e|0)|0}function xVe(e,i,r){e=e|0;i=i|0;r=r|0;TC(e|0)|0}function UVe(e,i,r){e=e|0;i=i|0;r=r|0;LC(e|0)|0}function zVe(e,i,r){e=e|0;i=i|0;r=r|0;DC(e|0)|0}function jVe(e,i,r){e=e|0;i=i|0;r=r|0;CC(e|0)|0}function VVe(e,i,r){e=e|0;i=i|0;r=r|0;PC(e|0)|0}function qVe(e,i,r){e=e|0;i=i|0;r=r|0;BC(e|0)|0}function YVe(e,i,r){e=e|0;i=i|0;r=r|0;IC(e|0)|0}function GVe(e,i,r){e=e|0;i=i|0;r=r|0;HC(e|0)|0}function WVe(e,i,r){e=e|0;i=i|0;r=r|0;xC(e|0)|0}function KVe(e,i,r){e=e|0;i=i|0;r=r|0;UC(e|0)|0}function XVe(e,i,r){e=e|0;i=i|0;r=r|0;zC(e|0)|0}function ZVe(e,i,r){e=e|0;i=i|0;r=r|0;jC(e|0)|0}function JVe(e,i,r){e=e|0;i=i|0;r=r|0;VC(e|0)|0}function QVe(e,i,r){e=e|0;i=i|0;r=r|0;qC(e|0)|0}function $Ve(e,i,r){e=e|0;i=i|0;r=r|0;YC(e|0)|0}function eqe(e,i,r){e=e|0;i=i|0;r=r|0;GC(e|0)|0}function iqe(e,i,r){e=e|0;i=i|0;r=r|0;WC(e|0)|0}function rqe(e,i,r){e=e|0;i=i|0;r=r|0;KC(e|0)|0}function nqe(e,i,r){e=e|0;i=i|0;r=r|0;XC(e|0)|0}function fqe(e,i,r){e=e|0;i=i|0;r=r|0;ZC(e|0)|0}function tqe(e,i,r){e=e|0;i=i|0;r=r|0;JC(e|0)|0}function uqe(e,i,r){e=e|0;i=i|0;r=r|0;QC(e|0)|0}function aqe(e,i,r){e=e|0;i=i|0;r=r|0;$C(e|0)|0}function oqe(e,i,r){e=e|0;i=i|0;r=r|0;eP(e|0)|0}function cqe(e,i,r){e=e|0;i=i|0;r=r|0;iP(e|0)|0}function lqe(e,i,r){e=e|0;i=i|0;r=r|0;rP(e|0)|0}function sqe(e,i,r){e=e|0;i=i|0;r=r|0;nP(e|0)|0}function bqe(e,i,r){e=e|0;i=i|0;r=r|0;fP(e|0)|0}function kqe(e,i,r){e=e|0;i=i|0;r=r|0;tP(e|0)|0}function hqe(e,i,r){e=e|0;i=i|0;r=r|0;uP(e|0)|0}function wqe(e,i,r){e=e|0;i=i|0;r=r|0;aP(e|0)|0}function dqe(e,i,r){e=e|0;i=i|0;r=r|0;oP(e|0)|0}function vqe(e,i,r){e=e|0;i=i|0;r=r|0;cP(e|0)|0}function mqe(e,i,r){e=e|0;i=i|0;r=r|0;lP(e|0)|0}function _qe(e,i,r){e=e|0;i=i|0;r=r|0;sP(e|0)|0}function pqe(e,i,r){e=e|0;i=i|0;r=r|0;bP(e|0)|0}function Eqe(e,i,r){e=e|0;i=i|0;r=r|0;kP(e|0)|0}function Sqe(e,i,r){e=e|0;i=i|0;r=r|0;hP(e|0)|0}function gqe(e,i,r){e=e|0;i=i|0;r=r|0;wP(e|0)|0}function yqe(e,i,r){e=e|0;i=i|0;r=r|0;dP(e|0)|0}function Fqe(e,i,r){e=e|0;i=i|0;r=r|0;vP(e|0)|0}function Oqe(e,i,r){e=e|0;i=i|0;r=r|0;mP(e|0)|0}function Aqe(e,i,r){e=e|0;i=i|0;r=r|0;_P(e|0)|0}function Mqe(e,i,r){e=e|0;i=i|0;r=r|0;pP(e|0)|0}function Rqe(e,i,r){e=e|0;i=i|0;r=r|0;EP(e|0)|0}function Nqe(e,i,r){e=e|0;i=i|0;r=r|0;SP(e|0)|0}function Tqe(e,i,r){e=e|0;i=i|0;r=r|0;gP(e|0)|0}function Lqe(e,i,r){
	e=e|0;i=i|0;r=r|0;yP(e|0)|0}function Dqe(e,i,r){e=e|0;i=i|0;r=r|0;FP(e|0)|0}function Cqe(e,i,r){e=e|0;i=i|0;r=r|0;OP(e|0)|0}function Pqe(e,i,r){e=e|0;i=i|0;r=r|0;AP(e|0)|0}function Bqe(e,i,r){e=e|0;i=i|0;r=r|0;MP(e|0)|0}function Iqe(e,i,r){e=e|0;i=i|0;r=r|0;RP(e|0)|0}function Hqe(e,i,r){e=e|0;i=i|0;r=r|0;NP(e|0)|0}function xqe(e,i,r){e=e|0;i=i|0;r=r|0;TP(e|0)|0}function Uqe(e,i,r){e=e|0;i=i|0;r=r|0;LP(e|0)|0}function zqe(e,i,r){e=e|0;i=i|0;r=r|0;DP(e|0)|0}function jqe(e,i,r){e=e|0;i=i|0;r=r|0;CP(e|0)|0}function Vqe(e,i,r){e=e|0;i=i|0;r=r|0;PP(e|0)|0}function qqe(e,i,r){e=e|0;i=i|0;r=r|0;BP(e|0)|0}function Yqe(e,i,r){e=e|0;i=i|0;r=r|0;IP(e|0)|0}function Gqe(e,i,r){e=e|0;i=i|0;r=r|0;HP(e|0)|0}function Wqe(e,i,r){e=e|0;i=i|0;r=r|0;xP(e|0)|0}function Kqe(e,i,r){e=e|0;i=i|0;r=r|0;UP(e|0)|0}function Xqe(e,i,r){e=e|0;i=i|0;r=r|0;zP(e|0)|0}function Zqe(e,i,r){e=e|0;i=i|0;r=r|0;jP(e|0)|0}function Jqe(e,i,r){e=e|0;i=i|0;r=r|0;VP(e|0)|0}function Qqe(e,i,r){e=e|0;i=i|0;r=r|0;qP(e|0)|0}function $qe(e,i,r){e=e|0;i=i|0;r=r|0;YP(e|0)|0}function eYe(e,i,r){e=e|0;i=i|0;r=r|0;GP(e|0)|0}function iYe(e,i,r){e=e|0;i=i|0;r=r|0;WP(e|0)|0}function rYe(e,i,r){e=e|0;i=i|0;r=r|0;KP(e|0)|0}function nYe(e,i,r){e=e|0;i=i|0;r=r|0;XP(e|0)|0}function fYe(e,i,r){e=e|0;i=i|0;r=r|0;ZP(e|0)|0}function tYe(e,i,r){e=e|0;i=i|0;r=r|0;JP(e|0)|0}function uYe(e,i,r){e=e|0;i=i|0;r=r|0;QP(e|0)|0}function aYe(e,i,r){e=e|0;i=i|0;r=r|0;$P(e|0)|0}function oYe(e,i,r){e=e|0;i=i|0;r=r|0;eB(e|0)|0}function cYe(e,i,r){e=e|0;i=i|0;r=r|0;iB(e|0)|0}function lYe(e,i,r){e=e|0;i=i|0;r=r|0;rB(e|0)|0}function sYe(e,i,r){e=e|0;i=i|0;r=r|0;nB(e|0)|0}function bYe(e,i,r){e=e|0;i=i|0;r=r|0;fB(e|0)|0}function kYe(e,i,r){e=e|0;i=i|0;r=r|0;tB(e|0)|0}function hYe(e,i,r){e=e|0;i=i|0;r=r|0;uB(e|0)|0}function wYe(e,i,r){e=e|0;i=i|0;r=r|0;aB(e|0)|0}function dYe(e,i,r){e=e|0;i=i|0;r=r|0;oB(e|0)|0}function vYe(e,i,r){e=e|0;i=i|0;r=r|0;cB(e|0)|0}function mYe(e,i,r){e=e|0;i=i|0;r=r|0;lB(e|0)|0}function _Ye(e,i,r){e=e|0;i=i|0;r=r|0;sB(e|0)|0}function pYe(e,i,r){e=e|0;i=i|0;r=r|0;bB(e|0)|0}function EYe(e,i,r){e=e|0;i=i|0;r=r|0;kB(e|0)|0}function SYe(e,i,r){e=e|0;i=i|0;r=r|0;hB(e|0)|0}function gYe(e,i,r){e=e|0;i=i|0;r=r|0;wB(e|0)|0}function yYe(e,i,r){e=e|0;i=i|0;r=r|0;dB(e|0)|0}function FYe(e,i,r){e=e|0;i=i|0;r=r|0;vB(e|0)|0}function OYe(e,i,r){e=e|0;i=i|0;r=r|0;mB(e|0)|0}function AYe(e,i,r){e=e|0;i=i|0;r=r|0;_B(e|0)|0}function MYe(e,i,r){e=e|0;i=i|0;r=r|0;pB(e|0)|0}function RYe(e,i,r){e=e|0;i=i|0;r=r|0;EB(e|0)|0}function NYe(e,i,r){e=e|0;i=i|0;r=r|0;SB(e|0)|0}function TYe(e,i,r){e=e|0;i=i|0;r=r|0;gB(e|0)|0}function LYe(e,i,r){e=e|0;i=i|0;r=r|0;yB(e|0)|0}function DYe(e,i,r){e=e|0;i=i|0;r=r|0;FB(e|0)|0}function CYe(e,i,r){e=e|0;i=i|0;r=r|0;OB(e|0)|0}function PYe(e,i,r){e=e|0;i=i|0;r=r|0;AB(e|0)|0}function BYe(e,i,r){e=e|0;i=i|0;r=r|0;MB(e|0)|0}function IYe(e,i,r){e=e|0;i=i|0;r=r|0;RB(e|0)|0}function HYe(e,i,r){e=e|0;i=i|0;r=r|0;NB(e|0)|0}function xYe(e,i,r){e=e|0;i=i|0;r=r|0;TB(e|0)|0}function UYe(e,i,r){e=e|0;i=i|0;r=r|0;LB(e|0)|0}function zYe(e,i,r){e=e|0;i=i|0;r=r|0;DB(e|0)|0}function jYe(e,i,r){e=e|0;i=i|0;r=r|0;CB(e|0)|0}function VYe(e,i,r){e=e|0;i=i|0;r=r|0;PB(e|0)|0}function qYe(e,i,r){e=e|0;i=i|0;r=r|0;BB(e|0)|0}function YYe(e,i,r){e=e|0;i=i|0;r=r|0;IB(e|0)|0}function GYe(e,i,r){e=e|0;i=i|0;r=r|0;HB(e|0)|0}function WYe(e,i,r){e=e|0;i=i|0;r=r|0;xB(e|0)|0}function KYe(e,i,r){e=e|0;i=i|0;r=r|0;UB(e|0)|0}function XYe(e,i,r){e=e|0;i=i|0;r=r|0;zB(e|0)|0}function ZYe(e,i,r){e=e|0;i=i|0;r=r|0;jB(e|0)|0}function JYe(e,i,r){e=e|0;i=i|0;r=r|0;VB(e|0)|0}function QYe(e,i,r){e=e|0;i=i|0;r=r|0;qB(e|0)|0}function $Ye(e,i,r){e=e|0;i=i|0;r=r|0;YB(e|0)|0}function eGe(e,i,r){e=e|0;i=i|0;r=r|0;NY(e|0,i|0,r|0)|0}function iGe(e,i,r){e=e|0;i=i|0;r=r|0;am(e|0)}function rGe(e,i,r){e=e|0;i=i|0;r=r|0;om(e|0)|0}function nGe(e,i,r){e=e|0;i=i|0;r=r|0;cm(e|0,i|0)|0}function fGe(e,i,r){e=e|0;i=i|0;r=r|0;lm(e|0)|0}function tGe(e,i,r){e=e|0;i=i|0;r=r|0;aA(e|0,i|0,r|0)|0}function uGe(e,i,r){e=e|0;i=i|0;r=r|0;bm(e|0)}function aGe(e,i,r){e=e|0;i=i|0;r=r|0;km(e|0)}function oGe(e,i,r){e=e|0;i=i|0;r=r|0;hm(e|0,i|0,r|0)|0}function cGe(e,i,r){e=e|0;i=i|0;r=r|0;xe(e|0,i|0,r|0)|0}function lGe(e,i,r){e=e|0;i=i|0;r=r|0;pm(e|0,i|0,r|0)|0}function sGe(e,i,r){e=e|0;i=i|0;r=r|0;Em(e|0)}function bGe(e,i,r){e=e|0;i=i|0;r=r|0;Am(e|0)|0}function kGe(e,i,r){e=e|0;i=i|0;r=r|0;O_(e|0,i|0)}function hGe(e,i,r){e=e|0;i=i|0;r=r|0;A_(e|0)|0}function wGe(e,i,r){e=e|0;i=i|0;r=r|0;Z_(e|0,i|0,r|0,0)|0}function dGe(e,i,r){e=e|0;i=i|0;r=r|0;J_(e|0,i|0,r|0,0)|0}function vGe(e,i,r){e=e|0;i=i|0;r=r|0;Q_(e|0,i|0,r|0,0)|0}function mGe(e,i,r){e=e|0;i=i|0;r=r|0;$_(e|0,i|0,r|0,0)|0}function _Ge(e,i,r){e=e|0;i=i|0;r=r|0;ep(e|0,i|0,r|0,0)|0}function pGe(e,i,r){e=e|0;i=i|0;r=r|0;ip(e|0,i|0,r|0,0)|0}function EGe(e,i,r){e=e|0;i=i|0;r=r|0;N_(e|0,i|0,r|0,0)|0}function SGe(e,i,r){e=e|0;i=i|0;r=r|0;T_(e|0,i|0,r|0,0)|0}function gGe(e,i,r){e=e|0;i=i|0;r=r|0;rp(e|0,i|0,r|0,0)|0}function yGe(e,i,r){e=e|0;i=i|0;r=r|0;np(e|0,i|0,r|0,0)|0}function FGe(e,i,r){e=e|0;i=i|0;r=r|0;dN(e|0,i|0,r|0,0)|0}function OGe(e,i,r){e=e|0;i=i|0;r=r|0;LS(e|0)}function AGe(e,i,r){e=e|0;i=i|0;r=r|0;FO()|0}function MGe(e,i,r){e=e|0;i=i|0;r=r|0;Tg(e|0,i|0,r|0,0,0)}function RGe(e,i,r){e=e|0;i=i|0;r=r|0;_O(e|0,i|0,r|0,0,0)}function NGe(e,i,r){e=e|0;i=i|0;r=r|0;OO(e|0)|0}function TGe(e,i,r){e=e|0;i=i|0;r=r|0;AO(e|0)|0}function LGe(e,i,r){e=e|0;i=i|0;r=r|0;MO(e|0,i|0,r|0)|0}function DGe(e,i,r){e=e|0;i=i|0;r=r|0;RO(e|0)|0}function CGe(e,i,r){e=e|0;i=i|0;r=r|0;sA(e|0)|0}function PGe(e,i,r){e=e|0;i=i|0;r=r|0;bA(e|0,i|0,r|0)|0}function BGe(e,i,r){e=e|0;i=i|0;r=r|0;hA(e|0)|0}function IGe(e,i,r){e=e|0;i=i|0;r=r|0;wA(e|0,i|0,r|0)|0}function HGe(e,i,r){e=e|0;i=i|0;r=r|0;dA(e|0)|0}function xGe(e,i,r){e=e|0;i=i|0;r=r|0;vA(e|0,i|0,r|0)|0}function UGe(e,i,r){e=e|0;i=i|0;r=r|0;mA(e|0,i|0,r|0)|0}function zGe(e,i,r){e=e|0;i=i|0;r=r|0;_A(e|0,i|0,r|0,0)|0}function jGe(e,i,r){e=e|0;i=i|0;r=r|0;FR(e|0)}function VGe(e,i,r){e=e|0;i=i|0;r=r|0;OR(e|0)|0}function qGe(e,i,r){e=e|0;i=i|0;r=r|0;NR(e|0)}function YGe(e,i,r){e=e|0;i=i|0;r=r|0;DR(e|0)|0}function GGe(e,i,r){e=e|0;i=i|0;r=r|0;PR(e|0)}function WGe(e,i,r){e=e|0;i=i|0;r=r|0;BR(e|0)|0}function KGe(e,i,r){e=e|0;i=i|0;r=r|0;IR(e|0,i|0)}function XGe(e,i,r){e=e|0;i=i|0;r=r|0;HR(e|0)}function ZGe(e,i,r){e=e|0;i=i|0;r=r|0;xR(e|0)}function JGe(e,i,r){e=e|0;i=i|0;r=r|0;UR(e|0,i|0)|0}function QGe(e,i,r){e=e|0;i=i|0;r=r|0;zR(e|0)}function $Ge(e,i,r){e=e|0;i=i|0;r=r|0;lN(e|0,i|0)|0}function eWe(e,i,r){e=e|0;i=i|0;r=r|0;Xr(e|0,i|0)}function iWe(e,i,r){e=e|0;i=i|0;r=r|0;_n(e|0)}function rWe(e,i,r){e=e|0;i=i|0;r=r|0;tt(e|0,i|0)}function nWe(e,i,r){e=e|0;i=i|0;r=r|0;bt(e|0,i|0)}function fWe(e,i,r){e=e|0;i=i|0;r=r|0;Yf(e|0,i|0)}function tWe(e,i,r){e=e|0;i=i|0;r=r|0;Jf(e|0,i|0)}function uWe(e,i,r){e=e|0;i=i|0;r=r|0;Qf(e|0,i|0)}function aWe(e,i,r){e=e|0;i=i|0;r=r|0;Gf(e|0,i|0)}function oWe(e,i,r){e=e|0;i=i|0;r=r|0;ot(e|0,i|0)}function cWe(e,i,r){e=e|0;i=i|0;r=r|0;st(e|0,i|0)}function lWe(e,i,r){e=e|0;i=i|0;r=r|0;Vf(e|0,i|0)}function sWe(e,i,r){e=e|0;i=i|0;r=r|0;ct(e|0,i|0)}function bWe(e,i,r){e=e|0;i=i|0;r=r|0;Wf(e|0,i|0)}function kWe(e,i,r){e=e|0;i=i|0;r=r|0;ut(e|0,i|0)}function hWe(e,i,r){e=e|0;i=i|0;r=r|0;Yt(e|0,i|0)}function wWe(e,i,r){e=e|0;i=i|0;r=r|0;Kf(e|0,i|0)}function dWe(e,i,r){e=e|0;i=i|0;r=r|0;nt(e|0,i|0)}function vWe(e,i,r){e=e|0;i=i|0;r=r|0;gf(e|0,i|0)}function mWe(e,i,r){e=e|0;i=i|0;r=r|0;qf(e|0,i|0)}function _We(e,i,r){e=e|0;i=i|0;r=r|0;kt(e|0,i|0)}function pWe(e,i,r){e=e|0;i=i|0;r=r|0;Xf(e|0,i|0)}function EWe(e,i,r){e=e|0;i=i|0;r=r|0;Zf(e|0,i|0)}function SWe(e,i,r){e=e|0;i=i|0;r=r|0;$f(e|0,i|0)}function gWe(e,i,r){e=e|0;i=i|0;r=r|0;et(e|0,i|0)}function yWe(e,i,r){e=e|0;i=i|0;r=r|0;it(e|0,i|0)}function FWe(e,i,r){e=e|0;i=i|0;r=r|0;rt(e|0,i|0)}function OWe(e,i,r){e=e|0;i=i|0;r=r|0;lt(e|0,i|0)}function AWe(e,i,r){e=e|0;i=i|0;r=r|0;at(e|0,i|0)}function MWe(e,i,r){e=e|0;i=i|0;r=r|0;ft(e|0,i|0)}function RWe(e,i,r){e=e|0;i=i|0;r=r|0;Gt(e|0,i|0)}function NWe(e,i,r){e=e|0;i=i|0;r=r|0;Qu(e|0,i|0,r|0)|0}function TWe(e,i,r){e=e|0;i=i|0;r=r|0;Pf(e|0,i|0)|0}function LWe(e,i,r){e=e|0;i=i|0;r=r|0;Bf(e|0,i|0)|0}function DWe(e,i,r){e=e|0;i=i|0;r=r|0;zf(e|0,i|0)|0}function CWe(e,i,r){e=e|0;i=i|0;r=r|0;$u(e|0,i|0,r|0)|0}function PWe(e,i,r){e=e|0;i=i|0;r=r|0;ea(e|0,i|0)|0}function BWe(e,i,r){e=e|0;i=i|0;r=r|0;Tf(e|0,i|0)|0}function IWe(e,i,r){e=e|0;i=i|0;r=r|0;Lf(e|0,i|0)|0}function HWe(e,i,r){e=e|0;i=i|0;r=r|0;Df(e|0,i|0)|0}function xWe(e,i,r){e=e|0;i=i|0;r=r|0;xf(e|0,i|0)|0}function UWe(e,i,r){e=e|0;i=i|0;r=r|0;If(e|0,i|0)|0}function zWe(e,i,r){e=e|0;i=i|0;r=r|0;Uf(e|0,i|0)|0}function jWe(e,i,r){e=e|0;i=i|0;r=r|0;Cf(e|0,i|0)|0}function VWe(e,i,r){e=e|0;i=i|0;r=r|0;ia(e|0,i|0)|0}function qWe(e,i,r){e=e|0;i=i|0;r=r|0;Hf(e|0,i|0)|0}function YWe(e,i,r){e=e|0;i=i|0;r=r|0;Nf(e|0,i|0)|0}function GWe(e,i,r){e=e|0;i=i|0;r=r|0;Cn(e|0,i|0)|0}function WWe(e,i,r){e=e|0;i=i|0;r=r|0;za(e|0,i|0)}function KWe(e,i,r){e=e|0;i=i|0;r=r|0;Wa(e|0,i|0)}function XWe(e,i,r){e=e|0;i=i|0;r=r|0;Ka(e|0,i|0)}function ZWe(e,i,r){e=e|0;i=i|0;r=r|0;Xa(e|0,i|0)}function JWe(e,i,r){e=e|0;i=i|0;r=r|0;Za(e|0,i|0)}function QWe(e,i,r){e=e|0;i=i|0;r=r|0;Ja(e|0,i|0)}function $We(e,i,r){e=e|0;i=i|0;r=r|0;Qa(e|0,i|0)}function eKe(e,i,r){e=e|0;i=i|0;r=r|0;$a(e|0,i|0)}function iKe(e,i,r){e=e|0;i=i|0;r=r|0;vc(e|0)}function rKe(e,i,r){e=e|0;i=i|0;r=r|0;Rc(e|0)}function nKe(e,i,r){e=e|0;i=i|0;r=r|0;wl(e|0,i|0,r|0)|0}function fKe(e,i,r){e=e|0;i=i|0;r=r|0;Ll(e|0,i|0)|0}function tKe(e,i,r){e=e|0;i=i|0;r=r|0;Bl(e|0,i|0)|0}function uKe(e,i,r){e=e|0;i=i|0;r=r|0;Hl(e|0,i|0)|0}function aKe(e,i,r){e=e|0;i=i|0;r=r|0;jl(e|0,i|0)|0}function oKe(e,i,r){e=e|0;i=i|0;r=r|0;Xk(e|0)}function cKe(e,i,r){e=e|0;i=i|0;r=r|0;dh(e|0,i|0,r|0,0,0,0,0,0,0)}function lKe(e,i,r){e=e|0;i=i|0;r=r|0;vh(e|0,i|0,r|0,0)}function sKe(e,i,r){e=e|0;i=i|0;r=r|0;ph(e|0,i|0)}function bKe(e,i,r){e=e|0;i=i|0;r=r|0;Eh(e|0,i|0,r|0,0)}function kKe(e,i,r){e=e|0;i=i|0;r=r|0;Sh(e|0)|0}function hKe(e,i,r){e=e|0;i=i|0;r=r|0;gh(e|0)|0}function wKe(e,i,r){e=e|0;i=i|0;r=r|0;yh(e|0)|0}function dKe(e,i,r){e=e|0;i=i|0;r=r|0;Fh(e|0,i|0,r|0)|0}function vKe(e,i,r){e=e|0;i=i|0;r=r|0;Oh(e|0,i|0)|0}function mKe(e,i,r){e=e|0;i=i|0;r=r|0;Ah(e|0,i|0,r|0,0,0,0)}function _Ke(e,i,r){e=e|0;i=i|0;r=r|0;Mh(e|0,i|0,r|0,0)}function pKe(e,i,r){e=e|0;i=i|0;r=r|0;Rh(e|0,i|0,r|0,0,0,0,0)}function EKe(e,i,r){e=e|0;i=i|0;r=r|0;Nh(e|0,i|0,r|0,0)}function SKe(e,i,r){e=e|0;i=i|0;r=r|0;Th(e|0,i|0,r|0,0,0)}function gKe(e,i,r){e=e|0;i=i|0;r=r|0;Lh(e|0,i|0)}function yKe(e,i,r){e=e|0;i=i|0;r=r|0;Dh(e|0)}function FKe(e,i,r){e=e|0;i=i|0;r=r|0;Ch(e|0)}function OKe(e,i,r){e=e|0;i=i|0;r=r|0;Bh(e|0,i|0)}function AKe(e,i,r){e=e|0;i=i|0;r=r|0;Uh(e|0,i|0)|0}function MKe(e,i,r){e=e|0;i=i|0;r=r|0;zh(e|0,i|0,r|0,0)}function RKe(e,i,r){e=e|0;i=i|0;r=r|0;Yh(e|0,i|0)}function NKe(e,i,r){e=e|0;i=i|0;r=r|0;Gh(e|0,i|0,r|0,0,0,0,0,0,0)}function TKe(e,i,r){e=e|0;i=i|0;r=r|0;Wh(e|0,i|0,r|0,0)}function LKe(e,i,r){e=e|0;i=i|0;r=r|0;Zh(e|0,i|0,r|0)|0}function DKe(e,i,r){e=e|0;i=i|0;r=r|0;$h(e|0)}function CKe(e,i,r){e=e|0;i=i|0;r=r|0;td(e|0,i|0)}function PKe(e,i,r){e=e|0;i=i|0;r=r|0;qv(e|0,i|0,r|0,0)}function BKe(e,i,r){e=e|0;i=i|0;r=r|0;aT(e|0,i|0)}function IKe(e,i,r){e=e|0;i=i|0;r=r|0;Ok(e|0)}function HKe(e,i,r){e=e|0;i=i|0;r=r|0;lH(e|0,i|0)}function xKe(e,i,r){e=e|0;i=i|0;r=r|0;sH(e|0,i|0,r|0,0,0,0,0,0,0)}function UKe(e,i,r){e=e|0;i=i|0;r=r|0;bH(e|0,i|0,r|0,0)}function zKe(e,i,r){e=e|0;i=i|0;r=r|0;_H(e|0,i|0,r|0)|0}function jKe(e,i,r){e=e|0;i=i|0;r=r|0;mH(e|0,i|0)}function VKe(e,i,r){e=e|0;i=i|0;r=r|0;DH(e|0)}function qKe(e,i,r){e=e|0;i=i|0;r=r|0;ex(e|0,i|0)|0}function YKe(e,i,r){e=e|0;i=i|0;r=r|0;ix(e|0,i|0,r|0,0,0)|0}function GKe(e,i,r){e=e|0;i=i|0;r=r|0;rx(e|0,i|0,r|0,0,0,0,0)|0}function WKe(e,i,r){e=e|0;i=i|0;r=r|0;nx(e|0,i|0,r|0,0,0,0)|0}function KKe(e,i,r){e=e|0;i=i|0;r=r|0;fx(e|0,i|0)}function XKe(e,i,r){e=e|0;i=i|0;r=r|0;ux(e|0,i|0)|0}function ZKe(e,i,r){e=e|0;i=i|0;r=r|0;ax(e|0,i|0,r|0,0,0)|0}function JKe(e,i,r){e=e|0;i=i|0;r=r|0;ox(e|0,i|0,r|0,0,0,0,0)|0}function QKe(e,i,r){e=e|0;i=i|0;r=r|0;cx(e|0,i|0)}function $Ke(e,i,r){e=e|0;i=i|0;r=r|0;_x(e|0,i|0,r|0,0)}function eXe(e,i,r){e=e|0;i=i|0;r=r|0;GU(e|0,i|0,r|0,0)}function iXe(e,i,r){e=e|0;i=i|0;r=r|0;Gz(e|0,i|0,r|0,0,0,0,0,0,0)}function rXe(e,i,r){e=e|0;i=i|0;r=r|0;Wz(e|0,i|0,r|0,0)}function nXe(e,i,r){e=e|0;i=i|0;r=r|0;PV(e|0,i|0,r|0,0)|0}function fXe(e,i,r){e=e|0;i=i|0;r=r|0;Rq(e|0,i|0)|0}function tXe(e,i,r){e=e|0;i=i|0;r=r|0;Kq(e|0,i|0,r|0)|0}function uXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ue(10)}function aXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Cm(e|0,i|0,r|0,n|0)}function oXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Pm(e|0)|0}function cXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Bm(e|0)|0}function lXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Im(e|0)|0}function sXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Hm(e|0,i|0,r|0)|0}function bXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xm(e|0,i|0)|0}function kXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Um(e|0,i|0,r|0,n|0,f|0,t|0)}function hXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zm(e|0,i|0,r|0,n|0)}function wXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jm(e|0,i|0,r|0,n|0,f|0,t|0,u|0)}function dXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Vm(e|0,i|0,r|0,n|0)}function vXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qm(e|0,i|0,r|0,n|0,f|0)}function mXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ym(e|0,i|0)}function _Xe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Gm(e|0)}function pXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Wm(e|0)}function EXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;o_(e|0,i|0,r|0)}function SXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;c_(e|0,i|0)}function gXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Km(e|0,i|0)}function yXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xm(e|0,i|0,r|0)}function FXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Zm(e|0,i|0,r|0)}function OXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Jm(e|0,i|0,r|0)}function AXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Qm(e|0,i|0)}function MXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$m(e|0,i|0,r|0)}function RXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;e_(e|0,i|0,r|0)}function NXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;i_(e|0,i|0,r|0)}function TXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;r_(e|0,i|0)|0}function LXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;n_(e|0,i|0,r|0)}function DXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;f_(e|0,i|0,r|0,n|0)}function CXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;u_(e|0,i|0,r|0,n|0)}function PXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;oA(e|0,i|0,r|0)|0}function BXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Zq(e|0)}function IXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xq(e|0)|0}function HXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Jq(e|0,i|0)|0}function xXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Yl(e|0)|0}function UXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;tp(e|0,i|0,r|0)}function zXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Tz(e|0,i|0,r|0,n|0)}function jXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Mz(e|0)|0}function VXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Rz(e|0)|0}function qXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Nz(e|0)|0}function YXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Dz(e|0,i|0,r|0)|0}function GXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Cz(e|0,i|0)|0}function WXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Bz(e|0,i|0,r|0,n|0,f|0,t|0)}function KXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xz(e|0,i|0,r|0,n|0)}function XXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Iz(e|0,i|0,r|0,n|0,f|0,t|0,u|0)}function ZXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Hz(e|0,i|0,r|0,n|0)}function JXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Uz(e|0,i|0,r|0,n|0,f|0)}function QXe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zz(e|0,i|0)}function $Xe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jz(e|0)}function eZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Vz(e|0)}function iZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qz(e|0,i|0,r|0)}function rZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Yz(e|0,i|0)}function nZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Kz(e|0,i|0)}function fZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xz(e|0,i|0,r|0)}function tZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Jz(e|0,i|0,r|0)}function uZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Qz(e|0,i|0)}function aZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;kp(e|0,i|0,r|0)}function oZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bp(e|0,i|0,r|0)}function cZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Pz(e|0,i|0)|0}function lZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$z(e|0,i|0,r|0)}function sZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Lz(e|0,i|0,r|0,n|0)}function bZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;yz(e|0)|0}function kZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Fz(e|0)|0}function hZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Oz(e|0)|0}function wZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Az(e|0)|0}function dZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Zz(e|0,i|0,r|0)}function vZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;OC(e|0)|0}function mZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;AC(e|0)|0}function _Ze(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;MC(e|0)|0}function pZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;RC(e|0)|0}function EZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;NC(e|0)|0}function SZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;TC(e|0)|0}function gZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;LC(e|0)|0}function yZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;DC(e|0)|0}function FZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;CC(e|0)|0}function OZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;PC(e|0)|0}function AZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;BC(e|0)|0}function MZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;IC(e|0)|0}function RZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;HC(e|0)|0}function NZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xC(e|0)|0}function TZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;UC(e|0)|0}function LZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zC(e|0)|0}function DZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jC(e|0)|0}function CZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;VC(e|0)|0}function PZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qC(e|0)|0}function BZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;YC(e|0)|0}function IZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;GC(e|0)|0}function HZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;WC(e|0)|0}function xZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;KC(e|0)|0}function UZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;XC(e|0)|0}function zZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ZC(e|0)|0}function jZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;JC(e|0)|0}function VZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;QC(e|0)|0}function qZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$C(e|0)|0}function YZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;eP(e|0)|0}function GZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;iP(e|0)|0}function WZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;rP(e|0)|0}function KZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;nP(e|0)|0}function XZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;fP(e|0)|0}function ZZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;tP(e|0)|0}function JZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;uP(e|0)|0}function QZe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;aP(e|0)|0}function $Ze(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;oP(e|0)|0}function eJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;cP(e|0)|0}function iJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;lP(e|0)|0}function rJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;sP(e|0)|0}function nJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bP(e|0)|0}function fJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;kP(e|0)|0}function tJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;hP(e|0)|0}function uJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;wP(e|0)|0}function aJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;dP(e|0)|0}function oJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;vP(e|0)|0}function cJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;mP(e|0)|0}function lJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_P(e|0)|0}function sJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;pP(e|0)|0}function bJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;EP(e|0)|0}function kJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;SP(e|0)|0}function hJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;gP(e|0)|0}function wJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;yP(e|0)|0}function dJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;FP(e|0)|0}function vJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;OP(e|0)|0}function mJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;AP(e|0)|0}function _Je(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;MP(e|0)|0}function pJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;RP(e|0)|0}function EJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;NP(e|0)|0}function SJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;TP(e|0)|0}function gJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;LP(e|0)|0}function yJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;DP(e|0)|0}function FJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;CP(e|0)|0}function OJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;PP(e|0)|0}function AJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;BP(e|0)|0}function MJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;IP(e|0)|0}function RJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;HP(e|0)|0}function NJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xP(e|0)|0}function TJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;UP(e|0)|0}function LJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zP(e|0)|0}function DJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jP(e|0)|0}function CJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;VP(e|0)|0}function PJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qP(e|0)|0}function BJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;YP(e|0)|0}function IJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;GP(e|0)|0}function HJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;WP(e|0)|0}function xJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;KP(e|0)|0}function UJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;XP(e|0)|0}function zJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ZP(e|0)|0}function jJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;JP(e|0)|0}function VJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;QP(e|0)|0}function qJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$P(e|0)|0}function YJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;eB(e|0)|0}function GJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;iB(e|0)|0}function WJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;rB(e|0)|0}function KJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;nB(e|0)|0}function XJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;fB(e|0)|0}function ZJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;tB(e|0)|0}function JJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;uB(e|0)|0}function QJe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;aB(e|0)|0}function $Je(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;oB(e|0)|0}function eQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;cB(e|0)|0}function iQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;lB(e|0)|0}function rQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;sB(e|0)|0}function nQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bB(e|0)|0}function fQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;kB(e|0)|0}function tQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;hB(e|0)|0}function uQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;wB(e|0)|0}function aQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;dB(e|0)|0}function oQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;vB(e|0)|0}function cQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;mB(e|0)|0}function lQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_B(e|0)|0}function sQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;pB(e|0)|0}function bQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;EB(e|0)|0}function kQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;SB(e|0)|0}function hQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;gB(e|0)|0}function wQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;yB(e|0)|0}function dQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;FB(e|0)|0}function vQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;OB(e|0)|0}function mQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;AB(e|0)|0}function _Qe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;MB(e|0)|0}function pQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;RB(e|0)|0}function EQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;NB(e|0)|0}function SQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;TB(e|0)|0}function gQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;LB(e|0)|0}function yQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;DB(e|0)|0}function FQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;CB(e|0)|0}function OQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;PB(e|0)|0}function AQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;BB(e|0)|0}function MQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;IB(e|0)|0}function RQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;HB(e|0)|0}function NQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xB(e|0)|0}function TQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;UB(e|0)|0}function LQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zB(e|0)|0}function DQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jB(e|0)|0}function CQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;VB(e|0)|0}function PQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qB(e|0)|0}function BQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;YB(e|0)|0}function IQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;NY(e|0,i|0,r|0)|0}function HQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;am(e|0)}function xQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;om(e|0)|0}function UQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;cm(e|0,i|0)|0}function zQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;lm(e|0)|0}function jQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;aA(e|0,i|0,r|0)|0}function VQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bm(e|0)}function qQe(e,i,r,n,f,t,u,a,o){e=e|0;
	i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;km(e|0)}function YQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;hm(e|0,i|0,r|0)|0}function GQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xe(e|0,i|0,r|0)|0}function WQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;pm(e|0,i|0,r|0)|0}function KQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Em(e|0)}function XQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Sm(e|0,i|0,r|0)}function ZQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;gm(e|0,i|0,r|0)}function JQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ym(e|0,i|0,r|0)}function QQe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Fm(e|0,i|0,r|0)}function $Qe(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Am(e|0)|0}function e$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;O_(e|0,i|0)}function i$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;A_(e|0)|0}function r$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Z_(e|0,i|0,r|0,n|0)|0}function n$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;J_(e|0,i|0,r|0,n|0)|0}function f$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Q_(e|0,i|0,r|0,n|0)|0}function t$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$_(e|0,i|0,r|0,n|0)|0}function u$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ep(e|0,i|0,r|0,n|0)|0}function a$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ip(e|0,i|0,r|0,n|0)|0}function o$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;N_(e|0,i|0,r|0,n|0)|0}function c$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;T_(e|0,i|0,r|0,n|0)|0}function l$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;rp(e|0,i|0,r|0,n|0)|0}function s$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;np(e|0,i|0,r|0,n|0)|0}function b$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;dN(e|0,i|0,r|0,n|0)|0}function k$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;hp(e|0,i|0,r|0)}function h$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;wp(e|0,i|0,r|0)}function w$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;LS(e|0)}function d$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;FO()|0}function v$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Tg(e|0,i|0,r|0,n|0,f|0)}function m$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_O(e|0,i|0,r|0,n|0,f|0)}function _$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;OO(e|0)|0}function p$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;AO(e|0)|0}function E$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;MO(e|0,i|0,r|0)|0}function S$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;RO(e|0)|0}function g$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;sA(e|0)|0}function y$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bA(e|0,i|0,r|0)|0}function F$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;hA(e|0)|0}function O$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;wA(e|0,i|0,r|0)|0}function A$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;dA(e|0)|0}function M$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;vA(e|0,i|0,r|0)|0}function R$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;mA(e|0,i|0,r|0)|0}function N$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_A(e|0,i|0,r|0,n|0)|0}function T$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;FR(e|0)}function L$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;OR(e|0)|0}function D$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;NR(e|0)}function C$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;DR(e|0)|0}function P$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;PR(e|0)}function B$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;BR(e|0)|0}function I$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;IR(e|0,i|0)}function H$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;HR(e|0)}function x$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xR(e|0)}function U$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;UR(e|0,i|0)|0}function z$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zR(e|0)}function j$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;GR(e|0,i|0,r|0)}function V$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;iN(e|0,i|0,r|0)}function q$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;rN(e|0,i|0,r|0)}function Y$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;nN(e|0,i|0,r|0)}function G$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;fN(e|0,i|0,r|0)}function W$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;lN(e|0,i|0)|0}function K$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xr(e|0,i|0)}function X$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_n(e|0)}function Z$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;tt(e|0,i|0)}function J$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bt(e|0,i|0)}function Q$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Yf(e|0,i|0)}function $$e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Jf(e|0,i|0)}function e0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Qf(e|0,i|0)}function i0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Gf(e|0,i|0)}function r0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ot(e|0,i|0)}function n0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;st(e|0,i|0)}function f0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Vf(e|0,i|0)}function t0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ct(e|0,i|0)}function u0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Wf(e|0,i|0)}function a0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ut(e|0,i|0)}function o0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Yt(e|0,i|0)}function c0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Kf(e|0,i|0)}function l0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;nt(e|0,i|0)}function s0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;gf(e|0,i|0)}function b0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qf(e|0,i|0)}function k0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;kt(e|0,i|0)}function h0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xf(e|0,i|0)}function w0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Zf(e|0,i|0)}function d0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$f(e|0,i|0)}function v0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;et(e|0,i|0)}function m0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;it(e|0,i|0)}function _0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;rt(e|0,i|0)}function p0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;lt(e|0,i|0)}function E0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;at(e|0,i|0)}function S0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ft(e|0,i|0)}function g0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Gt(e|0,i|0)}function y0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Qu(e|0,i|0,r|0)|0}function F0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Pf(e|0,i|0)|0}function O0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Bf(e|0,i|0)|0}function A0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zf(e|0,i|0)|0}function M0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$u(e|0,i|0,r|0)|0}function R0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ea(e|0,i|0)|0}function N0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Tf(e|0,i|0)|0}function T0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Lf(e|0,i|0)|0}function L0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Df(e|0,i|0)|0}function D0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xf(e|0,i|0)|0}function C0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;If(e|0,i|0)|0}function P0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Uf(e|0,i|0)|0}function B0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Cf(e|0,i|0)|0}function I0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ia(e|0,i|0)|0}function H0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Hf(e|0,i|0)|0}function x0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Nf(e|0,i|0)|0}function U0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Cn(e|0,i|0)|0}function z0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;za(e|0,i|0)}function j0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Wa(e|0,i|0)}function V0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ka(e|0,i|0)}function q0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xa(e|0,i|0)}function Y0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Za(e|0,i|0)}function G0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ja(e|0,i|0)}function W0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Qa(e|0,i|0)}function K0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$a(e|0,i|0)}function X0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Qo(e|0,i|0,r|0)}function Z0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;vc(e|0)}function J0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Rc(e|0)}function Q0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;wl(e|0,i|0,r|0)|0}function $0e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ll(e|0,i|0)|0}function e1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Bl(e|0,i|0)|0}function i1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Hl(e|0,i|0)|0}function r1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jl(e|0,i|0)|0}function n1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Xk(e|0)}function f1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;vh(e|0,i|0,r|0,n|0)}function t1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;mh(e|0,i|0,r|0)}function u1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_h(e|0,i|0,r|0)}function a1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ph(e|0,i|0)}function o1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Eh(e|0,i|0,r|0,n|0)}function c1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Sh(e|0)|0}function l1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;gh(e|0)|0}function s1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;yh(e|0)|0}function b1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Fh(e|0,i|0,r|0)|0}function k1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Oh(e|0,i|0)|0}function h1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ah(e|0,i|0,r|0,n|0,f|0,t|0)}function w1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Mh(e|0,i|0,r|0,n|0)}function d1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Rh(e|0,i|0,r|0,n|0,f|0,t|0,u|0)}function v1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Nh(e|0,i|0,r|0,n|0)}function m1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Th(e|0,i|0,r|0,n|0,f|0)}function _1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Lh(e|0,i|0)}function p1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Dh(e|0)}function E1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ch(e|0)}function S1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ph(e|0,i|0,r|0)}function g1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Bh(e|0,i|0)}function y1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ih(e|0,i|0,r|0)}function F1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Hh(e|0,i|0,r|0)}function O1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;xh(e|0,i|0,r|0)}function A1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Uh(e|0,i|0)|0}function M1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;zh(e|0,i|0,r|0,n|0)}function R1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;jh(e|0,i|0,r|0)}function N1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Vh(e|0,i|0,r|0)}function T1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qh(e|0,i|0,r|0)}function L1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Yh(e|0,i|0)}function D1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Wh(e|0,i|0,r|0,n|0)}function C1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Zh(e|0,i|0,r|0)|0}function P1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;$h(e|0)}function B1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;td(e|0,i|0)}function I1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;qv(e|0,i|0,r|0,n|0)}function H1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;aT(e|0,i|0)}function x1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Ok(e|0)}function U1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;cH(e|0,i|0,r|0)}function z1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;lH(e|0,i|0)}function j1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;bH(e|0,i|0,r|0,n|0)}function V1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;kH(e|0,i|0,r|0)}function q1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;hH(e|0,i|0,r|0)}function Y1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;dH(e|0,i|0,r|0)}function G1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;vH(e|0,i|0,r|0)}function W1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_H(e|0,i|0,r|0)|0}function K1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;mH(e|0,i|0)}function X1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;DH(e|0)}function Z1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ex(e|0,i|0)|0}function J1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ix(e|0,i|0,r|0,n|0,f|0)|0}function Q1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;rx(e|0,i|0,r|0,n|0,f|0,t|0,u|0)|0}function $1e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;nx(e|0,i|0,r|0,n|0,f|0,t|0)|0}function e2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;fx(e|0,i|0)}function i2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ux(e|0,i|0)|0}function r2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ax(e|0,i|0,r|0,n|0,f|0)|0}function n2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;ox(e|0,i|0,r|0,n|0,f|0,t|0,u|0)|0}function f2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;cx(e|0,i|0)}function t2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;wx(e|0,i|0,r|0)}function u2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;_x(e|0,i|0,r|0,n|0)}function a2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;oU(e|0,i|0,r|0)}function o2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;cU(e|0,i|0,r|0)}function c2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;GU(e|0,i|0,r|0,n|0)}function l2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;tz(e|0,i|0,r|0)}function s2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Wz(e|0,i|0,r|0,n|0)}function b2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;PV(e|0,i|0,r|0,n|0)|0}function k2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Rq(e|0,i|0)|0}function h2e(e,i,r,n,f,t,u,a,o){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u=u|0;a=a|0;o=o|0;Kq(e|0,i|0,r|0)|0}function w2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ue(11);return 0}function d2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function v2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Pm(e|0)|0}function m2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Bm(e|0)|0}function _2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Im(e|0)|0}function p2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Hm(e|0,i|0,r|0)|0}function E2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return xm(e|0,i|0)|0}function S2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function g2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function y2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function F2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function O2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function A2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function M2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function R2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function N2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function T2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function L2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function D2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function C2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function P2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function B2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function I2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function H2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function x2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function U2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return r_(e|0,i|0)|0}function z2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function j2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function V2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function q2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Y2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return oA(e|0,i|0,r|0)|0}function G2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function W2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Xq(e|0)|0}function K2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Jq(e|0,i|0)|0}function X2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Yl(e|0)|0}function Z2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function J2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Q2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Mz(e|0)|0}function $2e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Rz(e|0)|0}function e3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Nz(e|0)|0}function i3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Dz(e|0,i|0,r|0)|0}function r3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Cz(e|0,i|0)|0}function n3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function f3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function t3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function u3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function a3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function o3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function c3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function l3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function s3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function b3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function k3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function h3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function w3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function d3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function v3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function m3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function _3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Pz(e|0,i|0)|0}function p3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function E3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function S3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return yz(e|0)|0}function g3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Fz(e|0)|0}function y3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Oz(e|0)|0}function F3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Az(e|0)|0}function O3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function A3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return OC(e|0)|0}function M3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return AC(e|0)|0}function R3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return MC(e|0)|0}function N3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return RC(e|0)|0}function T3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return NC(e|0)|0}function L3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return TC(e|0)|0}function D3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return LC(e|0)|0}function C3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return DC(e|0)|0}function P3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return CC(e|0)|0}function B3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return PC(e|0)|0}function I3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return BC(e|0)|0}function H3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return IC(e|0)|0}function x3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return HC(e|0)|0}function U3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return xC(e|0)|0}function z3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return UC(e|0)|0}function j3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return zC(e|0)|0}function V3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return jC(e|0)|0}function q3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return VC(e|0)|0}function Y3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return qC(e|0)|0}function G3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return YC(e|0)|0}function W3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return GC(e|0)|0}function K3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return WC(e|0)|0}function X3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return KC(e|0)|0}function Z3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return XC(e|0)|0}function J3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ZC(e|0)|0}function Q3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return JC(e|0)|0}function $3e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return QC(e|0)|0}function e4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return $C(e|0)|0}function i4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return eP(e|0)|0}function r4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return iP(e|0)|0}function n4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return rP(e|0)|0}function f4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return nP(e|0)|0}function t4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return fP(e|0)|0}function u4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return tP(e|0)|0}function a4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return uP(e|0)|0}function o4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return aP(e|0)|0}function c4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return oP(e|0)|0}function l4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return cP(e|0)|0}function s4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return lP(e|0)|0}function b4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return sP(e|0)|0}function k4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return bP(e|0)|0}function h4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return kP(e|0)|0}function w4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return hP(e|0)|0}function d4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return wP(e|0)|0}function v4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return dP(e|0)|0}function m4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return vP(e|0)|0}function _4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return mP(e|0)|0}function p4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return _P(e|0)|0}function E4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return pP(e|0)|0}function S4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return EP(e|0)|0}function g4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return SP(e|0)|0}function y4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return gP(e|0)|0}function F4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return yP(e|0)|0}function O4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return FP(e|0)|0}function A4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return OP(e|0)|0}function M4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return AP(e|0)|0}function R4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return MP(e|0)|0}function N4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return RP(e|0)|0}function T4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return NP(e|0)|0}function L4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return TP(e|0)|0}function D4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return LP(e|0)|0}function C4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return DP(e|0)|0}function P4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return CP(e|0)|0}function B4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return PP(e|0)|0}function I4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return BP(e|0)|0}function H4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return IP(e|0)|0}function x4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return HP(e|0)|0}function U4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return xP(e|0)|0}function z4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return UP(e|0)|0}function j4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return zP(e|0)|0}function V4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return jP(e|0)|0}function q4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return VP(e|0)|0}function Y4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return qP(e|0)|0}function G4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return YP(e|0)|0}function W4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return GP(e|0)|0}function K4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return WP(e|0)|0}function X4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return KP(e|0)|0}function Z4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return XP(e|0)|0}function J4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ZP(e|0)|0}function Q4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return JP(e|0)|0}function $4e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return QP(e|0)|0}function e8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return $P(e|0)|0}function i8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return eB(e|0)|0}function r8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return iB(e|0)|0}function n8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return rB(e|0)|0}function f8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return nB(e|0)|0}function t8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return fB(e|0)|0}function u8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return tB(e|0)|0}function a8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return uB(e|0)|0}function o8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return aB(e|0)|0}function c8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return oB(e|0)|0}function l8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return cB(e|0)|0}function s8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return lB(e|0)|0}function b8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return sB(e|0)|0}function k8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return bB(e|0)|0}function h8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return kB(e|0)|0}function w8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return hB(e|0)|0}function d8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return wB(e|0)|0}function v8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return dB(e|0)|0}function m8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return vB(e|0)|0}function _8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return mB(e|0)|0}function p8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return _B(e|0)|0}function E8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return pB(e|0)|0}function S8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return EB(e|0)|0}function g8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return SB(e|0)|0}function y8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return gB(e|0)|0}function F8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return yB(e|0)|0}function O8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return FB(e|0)|0}function A8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return OB(e|0)|0}function M8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return AB(e|0)|0}function R8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return MB(e|0)|0}function N8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return RB(e|0)|0}function T8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return NB(e|0)|0}function L8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return TB(e|0)|0}function D8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return LB(e|0)|0}function C8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return DB(e|0)|0}function P8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return CB(e|0)|0}function B8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return PB(e|0)|0}function I8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return BB(e|0)|0}function H8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return IB(e|0)|0}function x8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return HB(e|0)|0}function U8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return xB(e|0)|0}function z8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return UB(e|0)|0}function j8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return zB(e|0)|0}function V8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return jB(e|0)|0}function q8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return VB(e|0)|0}function Y8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return qB(e|0)|0}function G8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return YB(e|0)|0}function W8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return NY(e|0,i|0,r|0)|0}function K8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function X8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return om(e|0)|0}function Z8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return cm(e|0,i|0)|0}function J8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return lm(e|0)|0}function Q8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return aA(e|0,i|0,r|0)|0}function $8e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function e6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function i6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return hm(e|0,i|0,r|0)|0}function r6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return xe(e|0,i|0,r|0)|0}function n6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return pm(e|0,i|0,r|0)|0}function f6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function t6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function u6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function a6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function o6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function c6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Am(e|0)|0}function l6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function s6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return A_(e|0)|0}function b6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function k6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0;
	}function h6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function w6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return FO()|0}function d6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function v6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function m6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return OO(e|0)|0}function _6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return AO(e|0)|0}function p6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return MO(e|0,i|0,r|0)|0}function E6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return RO(e|0)|0}function S6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return sA(e|0)|0}function g6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return bA(e|0,i|0,r|0)|0}function y6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return hA(e|0)|0}function F6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return wA(e|0,i|0,r|0)|0}function O6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return dA(e|0)|0}function A6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return vA(e|0,i|0,r|0)|0}function M6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return mA(e|0,i|0,r|0)|0}function R6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function N6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return OR(e|0)|0}function T6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function L6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return DR(e|0)|0}function D6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function C6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return BR(e|0)|0}function P6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function B6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function I6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function H6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return UR(e|0,i|0)|0}function x6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function U6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function z6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function j6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function V6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function q6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Y6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return lN(e|0,i|0)|0}function G6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function W6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function K6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function X6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Z6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function J6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Q6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function $6e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function e5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function i5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function r5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function n5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function f5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function t5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function u5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function a5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function o5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function c5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function l5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function s5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function b5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function k5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function h5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function w5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function d5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function v5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function m5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function _5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function p5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function E5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function S5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Qu(e|0,i|0,r|0)|0}function g5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Pf(e|0,i|0)|0}function y5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Bf(e|0,i|0)|0}function F5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return zf(e|0,i|0)|0}function O5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return $u(e|0,i|0,r|0)|0}function A5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ea(e|0,i|0)|0}function M5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Tf(e|0,i|0)|0}function R5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Lf(e|0,i|0)|0}function N5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Df(e|0,i|0)|0}function T5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return xf(e|0,i|0)|0}function L5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return If(e|0,i|0)|0}function D5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Uf(e|0,i|0)|0}function C5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Cf(e|0,i|0)|0}function P5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ia(e|0,i|0)|0}function B5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Hf(e|0,i|0)|0}function I5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Nf(e|0,i|0)|0}function H5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Cn(e|0,i|0)|0}function x5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function U5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function z5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function j5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function V5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function q5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Y5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function G5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function W5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function K5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function X5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Z5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return wl(e|0,i|0,r|0)|0}function J5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Ll(e|0,i|0)|0}function Q5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Bl(e|0,i|0)|0}function $5e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Hl(e|0,i|0)|0}function e9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return jl(e|0,i|0)|0}function i9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function r9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function n9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function f9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function t9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function u9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function a9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function o9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Sh(e|0)|0}function c9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return gh(e|0)|0}function l9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return yh(e|0)|0}function s9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Fh(e|0,i|0,r|0)|0}function b9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Oh(e|0,i|0)|0}function k9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function h9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function w9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function d9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function v9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function m9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function _9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function p9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function E9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function S9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function g9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function y9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function F9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function O9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Uh(e|0,i|0)|0}function A9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function M9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function R9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function N9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function T9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function L9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function D9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function C9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Zh(e|0,i|0,r|0)|0}function P9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function B9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function I9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function H9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function x9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function U9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function z9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function j9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function V9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function q9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Y9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function G9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function W9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function K9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return _H(e|0,i|0,r|0)|0}function X9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function Z9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function J9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ex(e|0,i|0)|0}function Q9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ix(e|0,i|0,r|0,n|0,0)|0}function $9e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return rx(e|0,i|0,r|0,n|0,0,0,0)|0}function e7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return nx(e|0,i|0,r|0,n|0,0,0)|0}function i7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function r7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ux(e|0,i|0)|0}function n7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ax(e|0,i|0,r|0,n|0,0)|0}function f7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return ox(e|0,i|0,r|0,n|0,0,0,0)|0}function t7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function u7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function a7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function o7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function c7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function l7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function s7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function b7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function k7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return 0}function h7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Rq(e|0,i|0)|0}function w7e(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;return Kq(e|0,i|0,r|0)|0}function d7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ue(12)}function v7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Cm(e|0,i|0,r|0,n|0)}function m7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Pm(e|0)|0}function _7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Bm(e|0)|0}function p7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Im(e|0)|0}function E7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Hm(e|0,i|0,r|0)|0}function S7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xm(e|0,i|0)|0}function g7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zm(e|0,i|0,r|0,n|0)}function y7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jm(e|0,i|0,r|0,n|0,f|0,t|0,0)}function F7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Vm(e|0,i|0,r|0,n|0)}function O7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qm(e|0,i|0,r|0,n|0,f|0)}function A7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ym(e|0,i|0)}function M7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Gm(e|0)}function R7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Wm(e|0)}function N7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;o_(e|0,i|0,r|0)}function T7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;c_(e|0,i|0)}function L7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Km(e|0,i|0)}function D7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xm(e|0,i|0,r|0)}function C7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Zm(e|0,i|0,r|0)}function P7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Jm(e|0,i|0,r|0)}function B7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Qm(e|0,i|0)}function I7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$m(e|0,i|0,r|0)}function H7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;e_(e|0,i|0,r|0)}function x7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;i_(e|0,i|0,r|0)}function U7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;r_(e|0,i|0)|0}function z7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;n_(e|0,i|0,r|0)}function j7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;f_(e|0,i|0,r|0,n|0)}function V7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;t_(e|0,i|0,r|0,n|0,f|0,t|0,0,0,0)}function q7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;u_(e|0,i|0,r|0,n|0)}function Y7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;oA(e|0,i|0,r|0)|0}function G7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Zq(e|0)}function W7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xq(e|0)|0}function K7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Jq(e|0,i|0)|0}function X7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Yl(e|0)|0}function Z7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;tp(e|0,i|0,r|0)}function J7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Tz(e|0,i|0,r|0,n|0)}function Q7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Mz(e|0)|0}function $7e(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Rz(e|0)|0}function eei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Nz(e|0)|0}function iei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Dz(e|0,i|0,r|0)|0}function rei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Cz(e|0,i|0)|0}function nei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xz(e|0,i|0,r|0,n|0)}function fei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Iz(e|0,i|0,r|0,n|0,f|0,t|0,0)}function tei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Hz(e|0,i|0,r|0,n|0)}function uei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Uz(e|0,i|0,r|0,n|0,f|0)}function aei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zz(e|0,i|0)}function oei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jz(e|0)}function cei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Vz(e|0)}function lei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qz(e|0,i|0,r|0)}function sei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Yz(e|0,i|0)}function bei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Kz(e|0,i|0)}function kei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xz(e|0,i|0,r|0)}function hei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Jz(e|0,i|0,r|0)}function wei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Qz(e|0,i|0)}function dei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;kp(e|0,i|0,r|0)}function vei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bp(e|0,i|0,r|0)}function mei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Pz(e|0,i|0)|0}function _ei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$z(e|0,i|0,r|0)}function pei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Lz(e|0,i|0,r|0,n|0)}function Eei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;yz(e|0)|0}function Sei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Fz(e|0)|0}function gei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Oz(e|0)|0}function yei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Az(e|0)|0}function Fei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Zz(e|0,i|0,r|0)}function Oei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;OC(e|0)|0}function Aei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;AC(e|0)|0}function Mei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;MC(e|0)|0}function Rei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;RC(e|0)|0}function Nei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;NC(e|0)|0}function Tei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;TC(e|0)|0}function Lei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;LC(e|0)|0}function Dei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;DC(e|0)|0}function Cei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;CC(e|0)|0}function Pei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;PC(e|0)|0}function Bei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;BC(e|0)|0}function Iei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;IC(e|0)|0}function Hei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;HC(e|0)|0}function xei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xC(e|0)|0}function Uei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;UC(e|0)|0}function zei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zC(e|0)|0}function jei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jC(e|0)|0}function Vei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;VC(e|0)|0}function qei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qC(e|0)|0}function Yei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;YC(e|0)|0}function Gei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;GC(e|0)|0}function Wei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;WC(e|0)|0}function Kei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;KC(e|0)|0}function Xei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;XC(e|0)|0}function Zei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ZC(e|0)|0}function Jei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;JC(e|0)|0}function Qei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;QC(e|0)|0}function $ei(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$C(e|0)|0}function eii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;eP(e|0)|0}function iii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;iP(e|0)|0}function rii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;rP(e|0)|0}function nii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;nP(e|0)|0}function fii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;fP(e|0)|0}function tii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;tP(e|0)|0}function uii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;uP(e|0)|0}function aii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;aP(e|0)|0}function oii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;oP(e|0)|0}function cii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;cP(e|0)|0}function lii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;lP(e|0)|0}function sii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;sP(e|0)|0}function bii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bP(e|0)|0}function kii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;kP(e|0)|0}function hii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;hP(e|0)|0}function wii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;wP(e|0)|0}function dii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;dP(e|0)|0}function vii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;vP(e|0)|0}function mii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;mP(e|0)|0}function _ii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_P(e|0)|0}function pii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;pP(e|0)|0}function Eii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;EP(e|0)|0}function Sii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;SP(e|0)|0}function gii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;gP(e|0)|0}function yii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;yP(e|0)|0}function Fii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;FP(e|0)|0}function Oii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;OP(e|0)|0}function Aii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;AP(e|0)|0}function Mii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;MP(e|0)|0}function Rii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;RP(e|0)|0}function Nii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;NP(e|0)|0}function Tii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;TP(e|0)|0}function Lii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;LP(e|0)|0}function Dii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;DP(e|0)|0}function Cii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;CP(e|0)|0}function Pii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;PP(e|0)|0}function Bii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;BP(e|0)|0}function Iii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;IP(e|0)|0}function Hii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;HP(e|0)|0}function xii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xP(e|0)|0}function Uii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;UP(e|0)|0}function zii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zP(e|0)|0}function jii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jP(e|0)|0}function Vii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;VP(e|0)|0}function qii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qP(e|0)|0}function Yii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;YP(e|0)|0}function Gii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;GP(e|0)|0}function Wii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;WP(e|0)|0}function Kii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;KP(e|0)|0}function Xii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;XP(e|0)|0}function Zii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ZP(e|0)|0}function Jii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;JP(e|0)|0}function Qii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;QP(e|0)|0}function $ii(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$P(e|0)|0}function eri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;eB(e|0)|0}function iri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;iB(e|0)|0}function rri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;rB(e|0)|0}function nri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;nB(e|0)|0}function fri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;fB(e|0)|0}function tri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;tB(e|0)|0}function uri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;uB(e|0)|0}function ari(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;aB(e|0)|0}function ori(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;oB(e|0)|0}function cri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;cB(e|0)|0}function lri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;lB(e|0)|0}function sri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;sB(e|0)|0}function bri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bB(e|0)|0}function kri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;kB(e|0)|0}function hri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;hB(e|0)|0}function wri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;wB(e|0)|0}function dri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;dB(e|0)|0}function vri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;vB(e|0)|0}function mri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;mB(e|0)|0}function _ri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_B(e|0)|0}function pri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;pB(e|0)|0}function Eri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;EB(e|0)|0}function Sri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;SB(e|0)|0}function gri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;gB(e|0)|0}function yri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;yB(e|0)|0}function Fri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;FB(e|0)|0}function Ori(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;OB(e|0)|0}function Ari(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;AB(e|0)|0}function Mri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;MB(e|0)|0}function Rri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;RB(e|0)|0}function Nri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;NB(e|0)|0}function Tri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;TB(e|0)|0}function Lri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;LB(e|0)|0}function Dri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;DB(e|0)|0}function Cri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;CB(e|0)|0}function Pri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;PB(e|0)|0}function Bri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;BB(e|0)|0}function Iri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;IB(e|0)|0}function Hri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;HB(e|0)|0}function xri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xB(e|0)|0}function Uri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;UB(e|0)|0}function zri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zB(e|0)|0}function jri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jB(e|0)|0}function Vri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;VB(e|0)|0}function qri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qB(e|0)|0}function Yri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;YB(e|0)|0}function Gri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;NY(e|0,i|0,r|0)|0}function Wri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;am(e|0)}function Kri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;om(e|0)|0}function Xri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;cm(e|0,i|0)|0}function Zri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;lm(e|0)|0}function Jri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;aA(e|0,i|0,r|0)|0}function Qri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bm(e|0)}function $ri(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;km(e|0)}function eni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;hm(e|0,i|0,r|0)|0}function ini(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xe(e|0,i|0,r|0)|0}function rni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;pm(e|0,i|0,r|0)|0}function nni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Em(e|0)}function fni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Sm(e|0,i|0,r|0)}function tni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;gm(e|0,i|0,r|0)}function uni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ym(e|0,i|0,r|0)}function ani(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Fm(e|0,i|0,r|0)}function oni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Am(e|0)|0}function cni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;O_(e|0,i|0)}function lni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;A_(e|0)|0}function sni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Z_(e|0,i|0,r|0,n|0)|0}function bni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;J_(e|0,i|0,r|0,n|0)|0}function kni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Q_(e|0,i|0,r|0,n|0)|0}function hni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$_(e|0,i|0,r|0,n|0)|0}function wni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ep(e|0,i|0,r|0,n|0)|0}function dni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ip(e|0,i|0,r|0,n|0)|0}function vni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;N_(e|0,i|0,r|0,n|0)|0}function mni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;T_(e|0,i|0,r|0,n|0)|0}function _ni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;rp(e|0,i|0,r|0,n|0)|0}function pni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;np(e|0,i|0,r|0,n|0)|0}function Eni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;dN(e|0,i|0,r|0,n|0)|0}function Sni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;hp(e|0,i|0,r|0)}function gni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;wp(e|0,i|0,r|0)}function yni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;LS(e|0)}function Fni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;FO()|0}function Oni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Tg(e|0,i|0,r|0,n|0,f|0)}function Ani(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_O(e|0,i|0,r|0,n|0,f|0)}function Mni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;OO(e|0)|0}function Rni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;AO(e|0)|0}function Nni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;MO(e|0,i|0,r|0)|0}function Tni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;RO(e|0)|0}function Lni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;sA(e|0)|0}function Dni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bA(e|0,i|0,r|0)|0}function Cni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;hA(e|0)|0}function Pni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;wA(e|0,i|0,r|0)|0}function Bni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;dA(e|0)|0}function Ini(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;vA(e|0,i|0,r|0)|0}function Hni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;mA(e|0,i|0,r|0)|0}function xni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_A(e|0,i|0,r|0,n|0)|0}function Uni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;FR(e|0)}function zni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;OR(e|0)|0}function jni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;NR(e|0)}function Vni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;DR(e|0)|0}function qni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;PR(e|0)}function Yni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;BR(e|0)|0}function Gni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;IR(e|0,i|0)}function Wni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;HR(e|0)}function Kni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xR(e|0)}function Xni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;UR(e|0,i|0)|0}function Zni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zR(e|0)}function Jni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;GR(e|0,i|0,r|0)}function Qni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;iN(e|0,i|0,r|0)}function $ni(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;rN(e|0,i|0,r|0)}function efi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;nN(e|0,i|0,r|0)}function ifi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;fN(e|0,i|0,r|0)}function rfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;lN(e|0,i|0)|0}function nfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xr(e|0,i|0)}function ffi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_n(e|0)}function tfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;tt(e|0,i|0)}function ufi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bt(e|0,i|0)}function afi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Yf(e|0,i|0)}function ofi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Jf(e|0,i|0)}function cfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Qf(e|0,i|0)}function lfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Gf(e|0,i|0)}function sfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ot(e|0,i|0)}function bfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;st(e|0,i|0)}function kfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Vf(e|0,i|0)}function hfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ct(e|0,i|0)}function wfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Wf(e|0,i|0)}function dfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ut(e|0,i|0)}function vfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Yt(e|0,i|0)}function mfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Kf(e|0,i|0)}function _fi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;nt(e|0,i|0)}function pfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;gf(e|0,i|0)}function Efi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qf(e|0,i|0)}function Sfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;kt(e|0,i|0)}function gfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xf(e|0,i|0)}function yfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Zf(e|0,i|0)}function Ffi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$f(e|0,i|0)}function Ofi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;et(e|0,i|0)}function Afi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;it(e|0,i|0)}function Mfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;rt(e|0,i|0)}function Rfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;lt(e|0,i|0)}function Nfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;at(e|0,i|0)}function Tfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ft(e|0,i|0)}function Lfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Gt(e|0,i|0)}function Dfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Qu(e|0,i|0,r|0)|0}function Cfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Pf(e|0,i|0)|0}function Pfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Bf(e|0,i|0)|0}function Bfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zf(e|0,i|0)|0}function Ifi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$u(e|0,i|0,r|0)|0}function Hfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ea(e|0,i|0)|0}function xfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Tf(e|0,i|0)|0}function Ufi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Lf(e|0,i|0)|0}function zfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Df(e|0,i|0)|0}function jfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xf(e|0,i|0)|0}function Vfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;If(e|0,i|0)|0}function qfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;
	Uf(e|0,i|0)|0}function Yfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Cf(e|0,i|0)|0}function Gfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ia(e|0,i|0)|0}function Wfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Hf(e|0,i|0)|0}function Kfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Nf(e|0,i|0)|0}function Xfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Cn(e|0,i|0)|0}function Zfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;za(e|0,i|0)}function Jfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Wa(e|0,i|0)}function Qfi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ka(e|0,i|0)}function $fi(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xa(e|0,i|0)}function eti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Za(e|0,i|0)}function iti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ja(e|0,i|0)}function rti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Qa(e|0,i|0)}function nti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$a(e|0,i|0)}function fti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Qo(e|0,i|0,r|0)}function tti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;vc(e|0)}function uti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Rc(e|0)}function ati(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;wl(e|0,i|0,r|0)|0}function oti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ll(e|0,i|0)|0}function cti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Bl(e|0,i|0)|0}function lti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Hl(e|0,i|0)|0}function sti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jl(e|0,i|0)|0}function bti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Xk(e|0)}function kti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;dh(e|0,i|0,r|0,n|0,f|0,t|0,0,0,0)}function hti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;vh(e|0,i|0,r|0,n|0)}function wti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;mh(e|0,i|0,r|0)}function dti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_h(e|0,i|0,r|0)}function vti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ph(e|0,i|0)}function mti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Eh(e|0,i|0,r|0,n|0)}function _ti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Sh(e|0)|0}function pti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;gh(e|0)|0}function Eti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;yh(e|0)|0}function Sti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Fh(e|0,i|0,r|0)|0}function gti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Oh(e|0,i|0)|0}function yti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Mh(e|0,i|0,r|0,n|0)}function Fti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Rh(e|0,i|0,r|0,n|0,f|0,t|0,0)}function Oti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Nh(e|0,i|0,r|0,n|0)}function Ati(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Th(e|0,i|0,r|0,n|0,f|0)}function Mti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Lh(e|0,i|0)}function Rti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Dh(e|0)}function Nti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ch(e|0)}function Tti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ph(e|0,i|0,r|0)}function Lti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Bh(e|0,i|0)}function Dti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ih(e|0,i|0,r|0)}function Cti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Hh(e|0,i|0,r|0)}function Pti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;xh(e|0,i|0,r|0)}function Bti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Uh(e|0,i|0)|0}function Iti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;zh(e|0,i|0,r|0,n|0)}function Hti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;jh(e|0,i|0,r|0)}function xti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Vh(e|0,i|0,r|0)}function Uti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qh(e|0,i|0,r|0)}function zti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Yh(e|0,i|0)}function jti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Gh(e|0,i|0,r|0,n|0,f|0,t|0,0,0,0)}function Vti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Wh(e|0,i|0,r|0,n|0)}function qti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Zh(e|0,i|0,r|0)|0}function Yti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;$h(e|0)}function Gti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;td(e|0,i|0)}function Wti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;qv(e|0,i|0,r|0,n|0)}function Kti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;aT(e|0,i|0)}function Xti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Ok(e|0)}function Zti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;cH(e|0,i|0,r|0)}function Jti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;lH(e|0,i|0)}function Qti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;sH(e|0,i|0,r|0,n|0,f|0,t|0,0,0,0)}function $ti(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;bH(e|0,i|0,r|0,n|0)}function eui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;kH(e|0,i|0,r|0)}function iui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;hH(e|0,i|0,r|0)}function rui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;dH(e|0,i|0,r|0)}function nui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;vH(e|0,i|0,r|0)}function fui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_H(e|0,i|0,r|0)|0}function tui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;mH(e|0,i|0)}function uui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;DH(e|0)}function aui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ex(e|0,i|0)|0}function oui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ix(e|0,i|0,r|0,n|0,f|0)|0}function cui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;rx(e|0,i|0,r|0,n|0,f|0,t|0,0)|0}function lui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;nx(e|0,i|0,r|0,n|0,f|0,t|0)|0}function sui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;fx(e|0,i|0)}function bui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ux(e|0,i|0)|0}function kui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ax(e|0,i|0,r|0,n|0,f|0)|0}function hui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;ox(e|0,i|0,r|0,n|0,f|0,t|0,0)|0}function wui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;cx(e|0,i|0)}function dui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;wx(e|0,i|0,r|0)}function vui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;_x(e|0,i|0,r|0,n|0)}function mui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;oU(e|0,i|0,r|0)}function _ui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;cU(e|0,i|0,r|0)}function pui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;GU(e|0,i|0,r|0,n|0)}function Eui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;tz(e|0,i|0,r|0)}function Sui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Gz(e|0,i|0,r|0,n|0,f|0,t|0,0,0,0)}function gui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Wz(e|0,i|0,r|0,n|0)}function yui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;PV(e|0,i|0,r|0,n|0)|0}function Fui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Rq(e|0,i|0)|0}function Oui(e,i,r,n,f,t){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;t=t|0;Kq(e|0,i|0,r|0)|0}function Aui(e,i){e=e|0;i=i|0;ue(13);return 0}function Mui(e,i){e=e|0;i=i|0;return 0}function Rui(e,i){e=e|0;i=i|0;return Pm(e|0)|0}function Nui(e,i){e=e|0;i=i|0;return Bm(e|0)|0}function Tui(e,i){e=e|0;i=i|0;return Im(e|0)|0}function Lui(e,i){e=e|0;i=i|0;return Hm(e|0,i|0,0)|0}function Dui(e,i){e=e|0;i=i|0;return 0}function Cui(e,i){e=e|0;i=i|0;return 0}function Pui(e,i){e=e|0;i=i|0;return 0}function Bui(e,i){e=e|0;i=i|0;return 0}function Iui(e,i){e=e|0;i=i|0;return 0}function Hui(e,i){e=e|0;i=i|0;return 0}function xui(e,i){e=e|0;i=i|0;return 0}function Uui(e,i){e=e|0;i=i|0;return 0}function zui(e,i){e=e|0;i=i|0;return 0}function jui(e,i){e=e|0;i=i|0;return 0}function Vui(e,i){e=e|0;i=i|0;return 0}function qui(e,i){e=e|0;i=i|0;return 0}function Yui(e,i){e=e|0;i=i|0;return 0}function Gui(e,i){e=e|0;i=i|0;return 0}function Wui(e,i){e=e|0;i=i|0;return 0}function Kui(e,i){e=e|0;i=i|0;return 0}function Xui(e,i){e=e|0;i=i|0;return 0}function Zui(e,i){e=e|0;i=i|0;return 0}function Jui(e,i){e=e|0;i=i|0;return 0}function Qui(e,i){e=e|0;i=i|0;return 0}function $ui(e,i){e=e|0;i=i|0;return 0}function eai(e,i){e=e|0;i=i|0;return 0}function iai(e,i){e=e|0;i=i|0;return oA(e|0,i|0,0)|0}function rai(e,i){e=e|0;i=i|0;return 0}function nai(e,i){e=e|0;i=i|0;return Xq(e|0)|0}function fai(e,i){e=e|0;i=i|0;return Yl(e|0)|0}function tai(e,i){e=e|0;i=i|0;return 0}function uai(e,i){e=e|0;i=i|0;return 0}function aai(e,i){e=e|0;i=i|0;return Mz(e|0)|0}function oai(e,i){e=e|0;i=i|0;return Rz(e|0)|0}function cai(e,i){e=e|0;i=i|0;return Nz(e|0)|0}function lai(e,i){e=e|0;i=i|0;return Dz(e|0,i|0,0)|0}function sai(e,i){e=e|0;i=i|0;return 0}function bai(e,i){e=e|0;i=i|0;return 0}function kai(e,i){e=e|0;i=i|0;return 0}function hai(e,i){e=e|0;i=i|0;return 0}function wai(e,i){e=e|0;i=i|0;return 0}function dai(e,i){e=e|0;i=i|0;return 0}function vai(e,i){e=e|0;i=i|0;return 0}function mai(e,i){e=e|0;i=i|0;return 0}function _ai(e,i){e=e|0;i=i|0;return 0}function pai(e,i){e=e|0;i=i|0;return 0}function Eai(e,i){e=e|0;i=i|0;return 0}function Sai(e,i){e=e|0;i=i|0;return 0}function gai(e,i){e=e|0;i=i|0;return 0}function yai(e,i){e=e|0;i=i|0;return 0}function Fai(e,i){e=e|0;i=i|0;return 0}function Oai(e,i){e=e|0;i=i|0;return 0}function Aai(e,i){e=e|0;i=i|0;return 0}function Mai(e,i){e=e|0;i=i|0;return 0}function Rai(e,i){e=e|0;i=i|0;return yz(e|0)|0}function Nai(e,i){e=e|0;i=i|0;return Fz(e|0)|0}function Tai(e,i){e=e|0;i=i|0;return Oz(e|0)|0}function Lai(e,i){e=e|0;i=i|0;return Az(e|0)|0}function Dai(e,i){e=e|0;i=i|0;return 0}function Cai(e,i){e=e|0;i=i|0;return OC(e|0)|0}function Pai(e,i){e=e|0;i=i|0;return AC(e|0)|0}function Bai(e,i){e=e|0;i=i|0;return MC(e|0)|0}function Iai(e,i){e=e|0;i=i|0;return RC(e|0)|0}function Hai(e,i){e=e|0;i=i|0;return NC(e|0)|0}function xai(e,i){e=e|0;i=i|0;return TC(e|0)|0}function Uai(e,i){e=e|0;i=i|0;return LC(e|0)|0}function zai(e,i){e=e|0;i=i|0;return DC(e|0)|0}function jai(e,i){e=e|0;i=i|0;return CC(e|0)|0}function Vai(e,i){e=e|0;i=i|0;return PC(e|0)|0}function qai(e,i){e=e|0;i=i|0;return BC(e|0)|0}function Yai(e,i){e=e|0;i=i|0;return IC(e|0)|0}function Gai(e,i){e=e|0;i=i|0;return HC(e|0)|0}function Wai(e,i){e=e|0;i=i|0;return xC(e|0)|0}function Kai(e,i){e=e|0;i=i|0;return UC(e|0)|0}function Xai(e,i){e=e|0;i=i|0;return zC(e|0)|0}function Zai(e,i){e=e|0;i=i|0;return jC(e|0)|0}function Jai(e,i){e=e|0;i=i|0;return VC(e|0)|0}function Qai(e,i){e=e|0;i=i|0;return qC(e|0)|0}function $ai(e,i){e=e|0;i=i|0;return YC(e|0)|0}function eoi(e,i){e=e|0;i=i|0;return GC(e|0)|0}function ioi(e,i){e=e|0;i=i|0;return WC(e|0)|0}function roi(e,i){e=e|0;i=i|0;return KC(e|0)|0}function noi(e,i){e=e|0;i=i|0;return XC(e|0)|0}function foi(e,i){e=e|0;i=i|0;return ZC(e|0)|0}function toi(e,i){e=e|0;i=i|0;return JC(e|0)|0}function uoi(e,i){e=e|0;i=i|0;return QC(e|0)|0}function aoi(e,i){e=e|0;i=i|0;return $C(e|0)|0}function ooi(e,i){e=e|0;i=i|0;return eP(e|0)|0}function coi(e,i){e=e|0;i=i|0;return iP(e|0)|0}function loi(e,i){e=e|0;i=i|0;return rP(e|0)|0}function soi(e,i){e=e|0;i=i|0;return nP(e|0)|0}function boi(e,i){e=e|0;i=i|0;return fP(e|0)|0}function koi(e,i){e=e|0;i=i|0;return tP(e|0)|0}function hoi(e,i){e=e|0;i=i|0;return uP(e|0)|0}function woi(e,i){e=e|0;i=i|0;return aP(e|0)|0}function doi(e,i){e=e|0;i=i|0;return oP(e|0)|0}function voi(e,i){e=e|0;i=i|0;return cP(e|0)|0}function moi(e,i){e=e|0;i=i|0;return lP(e|0)|0}function _oi(e,i){e=e|0;i=i|0;return sP(e|0)|0}function poi(e,i){e=e|0;i=i|0;return bP(e|0)|0}function Eoi(e,i){e=e|0;i=i|0;return kP(e|0)|0}function Soi(e,i){e=e|0;i=i|0;return hP(e|0)|0}function goi(e,i){e=e|0;i=i|0;return wP(e|0)|0}function yoi(e,i){e=e|0;i=i|0;return dP(e|0)|0}function Foi(e,i){e=e|0;i=i|0;return vP(e|0)|0}function Ooi(e,i){e=e|0;i=i|0;return mP(e|0)|0}function Aoi(e,i){e=e|0;i=i|0;return _P(e|0)|0}function Moi(e,i){e=e|0;i=i|0;return pP(e|0)|0}function Roi(e,i){e=e|0;i=i|0;return EP(e|0)|0}function Noi(e,i){e=e|0;i=i|0;return SP(e|0)|0}function Toi(e,i){e=e|0;i=i|0;return gP(e|0)|0}function Loi(e,i){e=e|0;i=i|0;return yP(e|0)|0}function Doi(e,i){e=e|0;i=i|0;return FP(e|0)|0}function Coi(e,i){e=e|0;i=i|0;return OP(e|0)|0}function Poi(e,i){e=e|0;i=i|0;return AP(e|0)|0}function Boi(e,i){e=e|0;i=i|0;return MP(e|0)|0}function Ioi(e,i){e=e|0;i=i|0;return RP(e|0)|0}function Hoi(e,i){e=e|0;i=i|0;return NP(e|0)|0}function xoi(e,i){e=e|0;i=i|0;return TP(e|0)|0}function Uoi(e,i){e=e|0;i=i|0;return LP(e|0)|0}function zoi(e,i){e=e|0;i=i|0;return DP(e|0)|0}function joi(e,i){e=e|0;i=i|0;return CP(e|0)|0}function Voi(e,i){e=e|0;i=i|0;return PP(e|0)|0}function qoi(e,i){e=e|0;i=i|0;return BP(e|0)|0}function Yoi(e,i){e=e|0;i=i|0;return IP(e|0)|0}function Goi(e,i){e=e|0;i=i|0;return HP(e|0)|0}function Woi(e,i){e=e|0;i=i|0;return xP(e|0)|0}function Koi(e,i){e=e|0;i=i|0;return UP(e|0)|0}function Xoi(e,i){e=e|0;i=i|0;return zP(e|0)|0}function Zoi(e,i){e=e|0;i=i|0;return jP(e|0)|0}function Joi(e,i){e=e|0;i=i|0;return VP(e|0)|0}function Qoi(e,i){e=e|0;i=i|0;return qP(e|0)|0}function $oi(e,i){e=e|0;i=i|0;return YP(e|0)|0}function eci(e,i){e=e|0;i=i|0;return GP(e|0)|0}function ici(e,i){e=e|0;i=i|0;return WP(e|0)|0}function rci(e,i){e=e|0;i=i|0;return KP(e|0)|0}function nci(e,i){e=e|0;i=i|0;return XP(e|0)|0}function fci(e,i){e=e|0;i=i|0;return ZP(e|0)|0}function tci(e,i){e=e|0;i=i|0;return JP(e|0)|0}function uci(e,i){e=e|0;i=i|0;return QP(e|0)|0}function aci(e,i){e=e|0;i=i|0;return $P(e|0)|0}function oci(e,i){e=e|0;i=i|0;return eB(e|0)|0}function cci(e,i){e=e|0;i=i|0;return iB(e|0)|0}function lci(e,i){e=e|0;i=i|0;return rB(e|0)|0}function sci(e,i){e=e|0;i=i|0;return nB(e|0)|0}function bci(e,i){e=e|0;i=i|0;return fB(e|0)|0}function kci(e,i){e=e|0;i=i|0;return tB(e|0)|0}function hci(e,i){e=e|0;i=i|0;return uB(e|0)|0}function wci(e,i){e=e|0;i=i|0;return aB(e|0)|0}function dci(e,i){e=e|0;i=i|0;return oB(e|0)|0}function vci(e,i){e=e|0;i=i|0;return cB(e|0)|0}function mci(e,i){e=e|0;i=i|0;return lB(e|0)|0}function _ci(e,i){e=e|0;i=i|0;return sB(e|0)|0}function pci(e,i){e=e|0;i=i|0;return bB(e|0)|0}function Eci(e,i){e=e|0;i=i|0;return kB(e|0)|0}function Sci(e,i){e=e|0;i=i|0;return hB(e|0)|0}function gci(e,i){e=e|0;i=i|0;return wB(e|0)|0}function yci(e,i){e=e|0;i=i|0;return dB(e|0)|0}function Fci(e,i){e=e|0;i=i|0;return vB(e|0)|0}function Oci(e,i){e=e|0;i=i|0;return mB(e|0)|0}function Aci(e,i){e=e|0;i=i|0;return _B(e|0)|0}function Mci(e,i){e=e|0;i=i|0;return pB(e|0)|0}function Rci(e,i){e=e|0;i=i|0;return EB(e|0)|0}function Nci(e,i){e=e|0;i=i|0;return SB(e|0)|0}function Tci(e,i){e=e|0;i=i|0;return gB(e|0)|0}function Lci(e,i){e=e|0;i=i|0;return yB(e|0)|0}function Dci(e,i){e=e|0;i=i|0;return FB(e|0)|0}function Cci(e,i){e=e|0;i=i|0;return OB(e|0)|0}function Pci(e,i){e=e|0;i=i|0;return AB(e|0)|0}function Bci(e,i){e=e|0;i=i|0;return MB(e|0)|0}function Ici(e,i){e=e|0;i=i|0;return RB(e|0)|0}function Hci(e,i){e=e|0;i=i|0;return NB(e|0)|0}function xci(e,i){e=e|0;i=i|0;return TB(e|0)|0}function Uci(e,i){e=e|0;i=i|0;return LB(e|0)|0}function zci(e,i){e=e|0;i=i|0;return DB(e|0)|0}function jci(e,i){e=e|0;i=i|0;return CB(e|0)|0}function Vci(e,i){e=e|0;i=i|0;return PB(e|0)|0}function qci(e,i){e=e|0;i=i|0;return BB(e|0)|0}function Yci(e,i){e=e|0;i=i|0;return IB(e|0)|0}function Gci(e,i){e=e|0;i=i|0;return HB(e|0)|0}function Wci(e,i){e=e|0;i=i|0;return xB(e|0)|0}function Kci(e,i){e=e|0;i=i|0;return UB(e|0)|0}function Xci(e,i){e=e|0;i=i|0;return zB(e|0)|0}function Zci(e,i){e=e|0;i=i|0;return jB(e|0)|0}function Jci(e,i){e=e|0;i=i|0;return VB(e|0)|0}function Qci(e,i){e=e|0;i=i|0;return qB(e|0)|0}function $ci(e,i){e=e|0;i=i|0;return YB(e|0)|0}function eli(e,i){e=e|0;i=i|0;return NY(e|0,i|0,0)|0}function ili(e,i){e=e|0;i=i|0;return 0}function rli(e,i){e=e|0;i=i|0;return om(e|0)|0}function nli(e,i){e=e|0;i=i|0;return lm(e|0)|0}function fli(e,i){e=e|0;i=i|0;return aA(e|0,i|0,0)|0}function tli(e,i){e=e|0;i=i|0;return 0}function uli(e,i){e=e|0;i=i|0;return 0}function ali(e,i){e=e|0;i=i|0;return hm(e|0,i|0,0)|0}function oli(e,i){e=e|0;i=i|0;return xe(e|0,i|0,0)|0}function cli(e,i){e=e|0;i=i|0;return pm(e|0,i|0,0)|0}function lli(e,i){e=e|0;i=i|0;return 0}function sli(e,i){e=e|0;i=i|0;return 0}function bli(e,i){e=e|0;i=i|0;return 0}function kli(e,i){e=e|0;i=i|0;return 0}function hli(e,i){e=e|0;i=i|0;return 0}function wli(e,i){e=e|0;i=i|0;return Am(e|0)|0}function dli(e,i){e=e|0;i=i|0;return 0}function vli(e,i){e=e|0;i=i|0;return A_(e|0)|0}function mli(e,i){e=e|0;i=i|0;return Z_(e|0,i|0,0,0)|0}function _li(e,i){e=e|0;i=i|0;return J_(e|0,i|0,0,0)|0}function pli(e,i){e=e|0;i=i|0;return Q_(e|0,i|0,0,0)|0}function Eli(e,i){e=e|0;i=i|0;return $_(e|0,i|0,0,0)|0}function Sli(e,i){e=e|0;i=i|0;return ep(e|0,i|0,0,0)|0}function gli(e,i){e=e|0;i=i|0;return ip(e|0,i|0,0,0)|0}function yli(e,i){e=e|0;i=i|0;return N_(e|0,i|0,0,0)|0}function Fli(e,i){e=e|0;i=i|0;return T_(e|0,i|0,0,0)|0}function Oli(e,i){e=e|0;i=i|0;return rp(e|0,i|0,0,0)|0}function Ali(e,i){e=e|0;i=i|0;return np(e|0,i|0,0,0)|0}function Mli(e,i){e=e|0;i=i|0;return dN(e|0,i|0,0,0)|0}function Rli(e,i){e=e|0;i=i|0;return 0}function Nli(e,i){e=e|0;i=i|0;return 0}function Tli(e,i){e=e|0;i=i|0;return 0}function Lli(e,i){e=e|0;i=i|0;return FO()|0}function Dli(e,i){e=e|0;i=i|0;return 0}function Cli(e,i){e=e|0;i=i|0;return 0}function Pli(e,i){e=e|0;i=i|0;return OO(e|0)|0}function Bli(e,i){e=e|0;i=i|0;return AO(e|0)|0}function Ili(e,i){e=e|0;i=i|0;return MO(e|0,i|0,0)|0}function Hli(e,i){e=e|0;i=i|0;return RO(e|0)|0}function xli(e,i){e=e|0;i=i|0;return sA(e|0)|0}function Uli(e,i){e=e|0;i=i|0;return bA(e|0,i|0,0)|0}function zli(e,i){e=e|0;i=i|0;return hA(e|0)|0}function jli(e,i){e=e|0;i=i|0;return wA(e|0,i|0,0)|0}function Vli(e,i){e=e|0;i=i|0;return dA(e|0)|0}function qli(e,i){e=e|0;i=i|0;return vA(e|0,i|0,0)|0}function Yli(e,i){e=e|0;i=i|0;return mA(e|0,i|0,0)|0}function Gli(e,i){e=e|0;i=i|0;return _A(e|0,i|0,0,0)|0}function Wli(e,i){e=e|0;i=i|0;return 0}function Kli(e,i){e=e|0;i=i|0;return OR(e|0)|0}function Xli(e,i){e=e|0;i=i|0;return 0}function Zli(e,i){e=e|0;i=i|0;return DR(e|0)|0}function Jli(e,i){e=e|0;i=i|0;return 0}function Qli(e,i){e=e|0;i=i|0;return BR(e|0)|0}function $li(e,i){e=e|0;i=i|0;return 0}function esi(e,i){e=e|0;i=i|0;return 0}function isi(e,i){e=e|0;i=i|0;return 0}function rsi(e,i){e=e|0;i=i|0;return 0}function nsi(e,i){e=e|0;i=i|0;return 0}function fsi(e,i){e=e|0;i=i|0;return 0}function tsi(e,i){e=e|0;i=i|0;return 0}function usi(e,i){e=e|0;i=i|0;return 0}function asi(e,i){e=e|0;i=i|0;return 0}function osi(e,i){e=e|0;i=i|0;return 0}function csi(e,i){e=e|0;i=i|0;return 0}function lsi(e,i){e=e|0;i=i|0;return 0}function ssi(e,i){e=e|0;i=i|0;return 0}function bsi(e,i){e=e|0;i=i|0;return 0}function ksi(e,i){e=e|0;i=i|0;return 0}function hsi(e,i){e=e|0;i=i|0;return 0}function wsi(e,i){e=e|0;i=i|0;return 0}function dsi(e,i){e=e|0;i=i|0;return 0}function vsi(e,i){e=e|0;i=i|0;return 0}function msi(e,i){e=e|0;i=i|0;return 0}function _si(e,i){e=e|0;i=i|0;return 0}function psi(e,i){e=e|0;i=i|0;return 0}function Esi(e,i){e=e|0;i=i|0;return 0}function Ssi(e,i){e=e|0;i=i|0;return 0}function gsi(e,i){e=e|0;i=i|0;return 0}function ysi(e,i){e=e|0;i=i|0;return 0}function Fsi(e,i){e=e|0;i=i|0;return 0}function Osi(e,i){e=e|0;i=i|0;return 0}function Asi(e,i){e=e|0;i=i|0;return 0}function Msi(e,i){e=e|0;i=i|0;return 0}function Rsi(e,i){e=e|0;i=i|0;return 0}function Nsi(e,i){e=e|0;i=i|0;return 0}function Tsi(e,i){e=e|0;i=i|0;return 0}function Lsi(e,i){e=e|0;i=i|0;return 0}function Dsi(e,i){e=e|0;i=i|0;return 0}function Csi(e,i){e=e|0;i=i|0;return 0}function Psi(e,i){e=e|0;i=i|0;return 0}function Bsi(e,i){e=e|0;i=i|0;return 0}function Isi(e,i){e=e|0;i=i|0;return 0}function Hsi(e,i){e=e|0;i=i|0;return Qu(e|0,i|0,0)|0}function xsi(e,i){e=e|0;i=i|0;return $u(e|0,i|0,0)|0}function Usi(e,i){e=e|0;i=i|0;return 0}function zsi(e,i){e=e|0;i=i|0;return 0}function jsi(e,i){e=e|0;i=i|0;return 0}function Vsi(e,i){e=e|0;i=i|0;return 0}function qsi(e,i){e=e|0;i=i|0;return 0}function Ysi(e,i){e=e|0;i=i|0;return 0}function Gsi(e,i){e=e|0;i=i|0;return 0}function Wsi(e,i){e=e|0;i=i|0;return 0}function Ksi(e,i){e=e|0;i=i|0;return 0}function Xsi(e,i){e=e|0;i=i|0;return 0}function Zsi(e,i){e=e|0;i=i|0;return 0}function Jsi(e,i){e=e|0;i=i|0;return wl(e|0,i|0,0)|0}function Qsi(e,i){e=e|0;i=i|0;return 0}function $si(e,i){e=e|0;i=i|0;return 0}function ebi(e,i){e=e|0;i=i|0;return 0}function ibi(e,i){e=e|0;i=i|0;return 0}function rbi(e,i){e=e|0;i=i|0;return 0}function nbi(e,i){e=e|0;i=i|0;return 0}function fbi(e,i){e=e|0;i=i|0;return 0}function tbi(e,i){e=e|0;i=i|0;return Sh(e|0)|0}function ubi(e,i){e=e|0;i=i|0;return gh(e|0)|0}function abi(e,i){e=e|0;i=i|0;return yh(e|0)|0}function obi(e,i){e=e|0;i=i|0;return Fh(e|0,i|0,0)|0}function cbi(e,i){e=e|0;i=i|0;return 0}function lbi(e,i){e=e|0;i=i|0;return 0}function sbi(e,i){e=e|0;i=i|0;return 0}function bbi(e,i){e=e|0;i=i|0;return 0}function kbi(e,i){e=e|0;i=i|0;return 0}function hbi(e,i){e=e|0;i=i|0;return 0}function wbi(e,i){e=e|0;i=i|0;return 0}function dbi(e,i){e=e|0;i=i|0;return 0}function vbi(e,i){e=e|0;i=i|0;return 0}function mbi(e,i){e=e|0;i=i|0;return 0}function _bi(e,i){e=e|0;i=i|0;return 0}function pbi(e,i){e=e|0;i=i|0;return 0}function Ebi(e,i){e=e|0;i=i|0;return 0}function Sbi(e,i){e=e|0;i=i|0;return 0}function gbi(e,i){e=e|0;i=i|0;return 0}function ybi(e,i){e=e|0;i=i|0;return 0}function Fbi(e,i){e=e|0;i=i|0;return 0}function Obi(e,i){e=e|0;i=i|0;return 0}function Abi(e,i){e=e|0;i=i|0;return 0}function Mbi(e,i){e=e|0;i=i|0;return 0}function Rbi(e,i){e=e|0;i=i|0;return Zh(e|0,i|0,0)|0}function Nbi(e,i){e=e|0;i=i|0;return 0}function Tbi(e,i){e=e|0;i=i|0;return 0}function Lbi(e,i){e=e|0;i=i|0;return 0}function Dbi(e,i){e=e|0;i=i|0;return 0}function Cbi(e,i){e=e|0;i=i|0;return 0}function Pbi(e,i){e=e|0;i=i|0;return 0}function Bbi(e,i){e=e|0;i=i|0;return 0}function Ibi(e,i){e=e|0;i=i|0;return 0}function Hbi(e,i){e=e|0;i=i|0;return 0}function xbi(e,i){e=e|0;i=i|0;return 0}function Ubi(e,i){e=e|0;i=i|0;return 0}function zbi(e,i){e=e|0;i=i|0;return 0}function jbi(e,i){e=e|0;i=i|0;return 0}function Vbi(e,i){e=e|0;i=i|0;return _H(e|0,i|0,0)|0}function qbi(e,i){e=e|0;i=i|0;return 0}function Ybi(e,i){e=e|0;i=i|0;return 0}function Gbi(e,i){e=e|0;i=i|0;return ix(e|0,i|0,0,0,0)|0}function Wbi(e,i){e=e|0;i=i|0;return rx(e|0,i|0,0,0,0,0,0)|0}function Kbi(e,i){e=e|0;i=i|0;return nx(e|0,i|0,0,0,0,0)|0}function Xbi(e,i){e=e|0;i=i|0;return 0}function Zbi(e,i){e=e|0;i=i|0;return ax(e|0,i|0,0,0,0)|0}function Jbi(e,i){e=e|0;i=i|0;return ox(e|0,i|0,0,0,0,0,0)|0}function Qbi(e,i){e=e|0;i=i|0;return 0}function $bi(e,i){e=e|0;i=i|0;return 0}function eki(e,i){e=e|0;i=i|0;return 0}function iki(e,i){e=e|0;i=i|0;return 0}function rki(e,i){e=e|0;i=i|0;return 0}function nki(e,i){e=e|0;i=i|0;return 0}function fki(e,i){e=e|0;i=i|0;return 0}function tki(e,i){e=e|0;i=i|0;return 0}function uki(e,i){e=e|0;i=i|0;return 0}function aki(e,i){e=e|0;i=i|0;return PV(e|0,i|0,0,0)|0}function oki(e,i){e=e|0;i=i|0;return Kq(e|0,i|0,0)|0}function cki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;ue(14);return 0}function lki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ski(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Pm(e|0)|0}function bki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Bm(e|0)|0}function kki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Im(e|0)|0}function hki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Hm(e|0,i|0,r|0)|0}function wki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return xm(e|0,i|0)|0}function dki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function vki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function mki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function _ki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function pki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Eki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Ski(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function gki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function yki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Fki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Oki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Aki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Mki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Rki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Nki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Tki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Lki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Dki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Cki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return r_(e|0,i|0)|0}function Pki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Bki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Iki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Hki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function xki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return oA(e|0,i|0,r|0)|0}function Uki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function zki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Xq(e|0)|0}function jki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Jq(e|0,i|0)|0}function Vki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Yl(e|0)|0}function qki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Yki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Gki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Mz(e|0)|0}function Wki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Rz(e|0)|0}function Kki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Nz(e|0)|0}function Xki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Dz(e|0,i|0,r|0)|0}function Zki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Cz(e|0,i|0)|0}function Jki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Qki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function $ki(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ehi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ihi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function rhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function nhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function fhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function thi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function uhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ahi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ohi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function chi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function lhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function shi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function bhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function khi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Pz(e|0,i|0)|0}function hhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function whi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function dhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return yz(e|0)|0}function vhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Fz(e|0)|0}function mhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Oz(e|0)|0}function _hi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Az(e|0)|0}function phi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Ehi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return OC(e|0)|0}function Shi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return AC(e|0)|0}function ghi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return MC(e|0)|0}function yhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return RC(e|0)|0}function Fhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return NC(e|0)|0}function Ohi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return TC(e|0)|0}function Ahi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return LC(e|0)|0}function Mhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return DC(e|0)|0}function Rhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return CC(e|0)|0}function Nhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return PC(e|0)|0}function Thi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return BC(e|0)|0}function Lhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return IC(e|0)|0}function Dhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return HC(e|0)|0}function Chi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return xC(e|0)|0}function Phi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return UC(e|0)|0}function Bhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return zC(e|0)|0}function Ihi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return jC(e|0)|0}function Hhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return VC(e|0)|0}function xhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return qC(e|0)|0}function Uhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return YC(e|0)|0}function zhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return GC(e|0)|0}function jhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return WC(e|0)|0}function Vhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return KC(e|0)|0}function qhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return XC(e|0)|0}function Yhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ZC(e|0)|0}function Ghi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return JC(e|0)|0}function Whi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return QC(e|0)|0}function Khi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return $C(e|0)|0}function Xhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return eP(e|0)|0}function Zhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return iP(e|0)|0}function Jhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return rP(e|0)|0}function Qhi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return nP(e|0)|0}function $hi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return fP(e|0)|0}function ewi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return tP(e|0)|0}function iwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return uP(e|0)|0}function rwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return aP(e|0)|0}function nwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return oP(e|0)|0}function fwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return cP(e|0)|0}function twi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return lP(e|0)|0}function uwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return sP(e|0)|0}function awi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return bP(e|0)|0}function owi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return kP(e|0)|0}function cwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return hP(e|0)|0}function lwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return wP(e|0)|0}function swi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return dP(e|0)|0}function bwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return vP(e|0)|0}function kwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return mP(e|0)|0}function hwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return _P(e|0)|0}function wwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return pP(e|0)|0}function dwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return EP(e|0)|0}function vwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return SP(e|0)|0}function mwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return gP(e|0)|0}function _wi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return yP(e|0)|0}function pwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return FP(e|0)|0}function Ewi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return OP(e|0)|0}function Swi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return AP(e|0)|0}function gwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return MP(e|0)|0}function ywi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return RP(e|0)|0}function Fwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return NP(e|0)|0}function Owi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return TP(e|0)|0}function Awi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return LP(e|0)|0}function Mwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return DP(e|0)|0}function Rwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return CP(e|0)|0}function Nwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return PP(e|0)|0}function Twi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return BP(e|0)|0}function Lwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return IP(e|0)|0;
	}function Dwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return HP(e|0)|0}function Cwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return xP(e|0)|0}function Pwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return UP(e|0)|0}function Bwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return zP(e|0)|0}function Iwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return jP(e|0)|0}function Hwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return VP(e|0)|0}function xwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return qP(e|0)|0}function Uwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return YP(e|0)|0}function zwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return GP(e|0)|0}function jwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return WP(e|0)|0}function Vwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return KP(e|0)|0}function qwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return XP(e|0)|0}function Ywi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ZP(e|0)|0}function Gwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return JP(e|0)|0}function Wwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return QP(e|0)|0}function Kwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return $P(e|0)|0}function Xwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return eB(e|0)|0}function Zwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return iB(e|0)|0}function Jwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return rB(e|0)|0}function Qwi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return nB(e|0)|0}function $wi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return fB(e|0)|0}function edi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return tB(e|0)|0}function idi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return uB(e|0)|0}function rdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return aB(e|0)|0}function ndi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return oB(e|0)|0}function fdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return cB(e|0)|0}function tdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return lB(e|0)|0}function udi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return sB(e|0)|0}function adi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return bB(e|0)|0}function odi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return kB(e|0)|0}function cdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return hB(e|0)|0}function ldi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return wB(e|0)|0}function sdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return dB(e|0)|0}function bdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return vB(e|0)|0}function kdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return mB(e|0)|0}function hdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return _B(e|0)|0}function wdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return pB(e|0)|0}function ddi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return EB(e|0)|0}function vdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return SB(e|0)|0}function mdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return gB(e|0)|0}function _di(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return yB(e|0)|0}function pdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return FB(e|0)|0}function Edi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return OB(e|0)|0}function Sdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return AB(e|0)|0}function gdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return MB(e|0)|0}function ydi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return RB(e|0)|0}function Fdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return NB(e|0)|0}function Odi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return TB(e|0)|0}function Adi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return LB(e|0)|0}function Mdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return DB(e|0)|0}function Rdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return CB(e|0)|0}function Ndi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return PB(e|0)|0}function Tdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return BB(e|0)|0}function Ldi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return IB(e|0)|0}function Ddi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return HB(e|0)|0}function Cdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return xB(e|0)|0}function Pdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return UB(e|0)|0}function Bdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return zB(e|0)|0}function Idi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return jB(e|0)|0}function Hdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return VB(e|0)|0}function xdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return qB(e|0)|0}function Udi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return YB(e|0)|0}function zdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return NY(e|0,i|0,r|0)|0}function jdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Vdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return om(e|0)|0}function qdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return cm(e|0,i|0)|0}function Ydi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return lm(e|0)|0}function Gdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return aA(e|0,i|0,r|0)|0}function Wdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Kdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Xdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return hm(e|0,i|0,r|0)|0}function Zdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return xe(e|0,i|0,r|0)|0}function Jdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return pm(e|0,i|0,r|0)|0}function Qdi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function $di(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function evi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ivi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function rvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function nvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Am(e|0)|0}function fvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function tvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return A_(e|0)|0}function uvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Z_(e|0,i|0,r|0,n|0)|0}function avi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return J_(e|0,i|0,r|0,n|0)|0}function ovi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Q_(e|0,i|0,r|0,n|0)|0}function cvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return $_(e|0,i|0,r|0,n|0)|0}function lvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ep(e|0,i|0,r|0,n|0)|0}function svi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ip(e|0,i|0,r|0,n|0)|0}function bvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return N_(e|0,i|0,r|0,n|0)|0}function kvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return T_(e|0,i|0,r|0,n|0)|0}function hvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return rp(e|0,i|0,r|0,n|0)|0}function wvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return np(e|0,i|0,r|0,n|0)|0}function dvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return dN(e|0,i|0,r|0,n|0)|0}function vvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function mvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function _vi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function pvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return FO()|0}function Evi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Svi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function gvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return OO(e|0)|0}function yvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return AO(e|0)|0}function Fvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return MO(e|0,i|0,r|0)|0}function Ovi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return RO(e|0)|0}function Avi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return sA(e|0)|0}function Mvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return bA(e|0,i|0,r|0)|0}function Rvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return hA(e|0)|0}function Nvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return wA(e|0,i|0,r|0)|0}function Tvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return dA(e|0)|0}function Lvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return vA(e|0,i|0,r|0)|0}function Dvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return mA(e|0,i|0,r|0)|0}function Cvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return _A(e|0,i|0,r|0,n|0)|0}function Pvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Bvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return OR(e|0)|0}function Ivi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Hvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return DR(e|0)|0}function xvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Uvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return BR(e|0)|0}function zvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function jvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Vvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function qvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return UR(e|0,i|0)|0}function Yvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Gvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Wvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Kvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Xvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Zvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Jvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return lN(e|0,i|0)|0}function Qvi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function $vi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function emi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function imi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function rmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function nmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function fmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function tmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function umi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ami(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function omi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function cmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function lmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function smi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function bmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function kmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function hmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function wmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function dmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function vmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function mmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function _mi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function pmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Emi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Smi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function gmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function ymi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Fmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Omi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Ami(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Mmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Qu(e|0,i|0,r|0)|0}function Rmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Pf(e|0,i|0)|0}function Nmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Bf(e|0,i|0)|0}function Tmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return zf(e|0,i|0)|0}function Lmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return $u(e|0,i|0,r|0)|0}function Dmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ea(e|0,i|0)|0}function Cmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Tf(e|0,i|0)|0}function Pmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Lf(e|0,i|0)|0}function Bmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Df(e|0,i|0)|0}function Imi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return xf(e|0,i|0)|0}function Hmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return If(e|0,i|0)|0}function xmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Uf(e|0,i|0)|0}function Umi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Cf(e|0,i|0)|0}function zmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ia(e|0,i|0)|0}function jmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Hf(e|0,i|0)|0}function Vmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Nf(e|0,i|0)|0}function qmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Cn(e|0,i|0)|0}function Ymi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Gmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Wmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Kmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Xmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Zmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Jmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Qmi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function $mi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function e_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function i_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function r_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return wl(e|0,i|0,r|0)|0}function n_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Ll(e|0,i|0)|0}function f_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Bl(e|0,i|0)|0}function t_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Hl(e|0,i|0)|0}function u_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return jl(e|0,i|0)|0}function a_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function o_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function c_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function l_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function s_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function b_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function k_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function h_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Sh(e|0)|0}function w_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return gh(e|0)|0}function d_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return yh(e|0)|0}function v_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Fh(e|0,i|0,r|0)|0}function m_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Oh(e|0,i|0)|0}function __i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function p_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function E_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function S_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function g_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function y_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function F_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function O_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function A_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function M_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function R_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function N_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function T_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function L_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Uh(e|0,i|0)|0}function D_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function C_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function P_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function B_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function I_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function H_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function x_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function U_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Zh(e|0,i|0,r|0)|0}function z_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function j_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function V_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function q_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Y_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function G_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function W_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function K_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function X_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Z_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function J_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function Q_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function $_i(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function epi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return _H(e|0,i|0,r|0)|0}function ipi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function rpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function npi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ex(e|0,i|0)|0}function fpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return rx(e|0,i|0,r|0,n|0,f|0,0,0)|0}function tpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return nx(e|0,i|0,r|0,n|0,f|0,0)|0}function upi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function api(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ux(e|0,i|0)|0}function opi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return ox(e|0,i|0,r|0,n|0,f|0,0,0)|0}function cpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function lpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function spi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function bpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function kpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function hpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function wpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function dpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function vpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return 0}function mpi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return PV(e|0,i|0,r|0,n|0)|0}function _pi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Rq(e|0,i|0)|0}function ppi(e,i,r,n,f){e=e|0;i=i|0;r=r|0;n=n|0;f=f|0;return Kq(e|0,i|0,r|0)|0}function Epi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ue(15)}function Spi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Pm(e|0)|0}function gpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Bm(e|0)|0}function ypi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Im(e|0)|0}function Fpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Hm(e|0,i|0,r|0)|0}function Opi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xm(e|0,i|0)|0}function Api(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Um(e|0,i|0,r|0,n|0,0,0)}function Mpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jm(e|0,i|0,r|0,n|0,0,0,0)}function Rpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qm(e|0,i|0,r|0,n|0,0)}function Npi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ym(e|0,i|0)}function Tpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Gm(e|0)}function Lpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Wm(e|0)}function Dpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;o_(e|0,i|0,r|0)}function Cpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;c_(e|0,i|0)}function Ppi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Km(e|0,i|0)}function Bpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xm(e|0,i|0,r|0)}function Ipi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Zm(e|0,i|0,r|0)}function Hpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Jm(e|0,i|0,r|0)}function xpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Qm(e|0,i|0)}function Upi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$m(e|0,i|0,r|0)}function zpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;e_(e|0,i|0,r|0)}function jpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;i_(e|0,i|0,r|0)}function Vpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;r_(e|0,i|0)|0}function qpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;n_(e|0,i|0,r|0)}function Ypi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;t_(e|0,i|0,r|0,n|0,0,0,0,0,0)}function Gpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;oA(e|0,i|0,r|0)|0}function Wpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Zq(e|0)}function Kpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xq(e|0)|0}function Xpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Jq(e|0,i|0)|0}function Zpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Yl(e|0)|0}function Jpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;tp(e|0,i|0,r|0)}function Qpi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Mz(e|0)|0}function $pi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Rz(e|0)|0}function eEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Nz(e|0)|0}function iEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Dz(e|0,i|0,r|0)|0}function rEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Cz(e|0,i|0)|0}function nEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Bz(e|0,i|0,r|0,n|0,0,0)}function fEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Iz(e|0,i|0,r|0,n|0,0,0,0)}function tEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Uz(e|0,i|0,r|0,n|0,0)}function uEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;zz(e|0,i|0)}function aEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jz(e|0)}function oEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Vz(e|0)}function cEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qz(e|0,i|0,r|0)}function lEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Yz(e|0,i|0)}function sEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Kz(e|0,i|0)}function bEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xz(e|0,i|0,r|0)}function kEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Jz(e|0,i|0,r|0)}function hEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Qz(e|0,i|0)}function wEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;kp(e|0,i|0,r|0)}function dEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;bp(e|0,i|0,r|0)}function vEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Pz(e|0,i|0)|0}function mEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$z(e|0,i|0,r|0)}function _Ei(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;yz(e|0)|0}function pEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Fz(e|0)|0}function EEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Oz(e|0)|0}function SEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Az(e|0)|0}function gEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Zz(e|0,i|0,r|0)}function yEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;OC(e|0)|0}function FEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;AC(e|0)|0}function OEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;MC(e|0)|0}function AEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;RC(e|0)|0}function MEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;NC(e|0)|0}function REi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;TC(e|0)|0}function NEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;LC(e|0)|0}function TEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;DC(e|0)|0}function LEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;CC(e|0)|0}function DEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;PC(e|0)|0}function CEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;BC(e|0)|0}function PEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;IC(e|0)|0}function BEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;HC(e|0)|0}function IEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xC(e|0)|0}function HEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;UC(e|0)|0}function xEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;zC(e|0)|0}function UEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jC(e|0)|0}function zEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;VC(e|0)|0}function jEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qC(e|0)|0}function VEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;YC(e|0)|0}function qEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;GC(e|0)|0}function YEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;WC(e|0)|0}function GEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;KC(e|0)|0}function WEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;XC(e|0)|0}function KEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ZC(e|0)|0}function XEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;JC(e|0)|0}function ZEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;QC(e|0)|0}function JEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$C(e|0)|0}function QEi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;eP(e|0)|0}function $Ei(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;iP(e|0)|0}function eSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;rP(e|0)|0}function iSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;nP(e|0)|0}function rSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;fP(e|0)|0}function nSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;tP(e|0)|0}function fSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;uP(e|0)|0}function tSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;aP(e|0)|0}function uSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;oP(e|0)|0}function aSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;cP(e|0)|0}function oSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;lP(e|0)|0}function cSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;sP(e|0)|0}function lSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;bP(e|0)|0}function sSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;kP(e|0)|0}function bSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;hP(e|0)|0}function kSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;wP(e|0)|0}function hSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;dP(e|0)|0}function wSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;vP(e|0)|0}function dSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;mP(e|0)|0}function vSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_P(e|0)|0}function mSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;pP(e|0)|0}function _Si(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;EP(e|0)|0}function pSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;SP(e|0)|0}function ESi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;gP(e|0)|0}function SSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;yP(e|0)|0}function gSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;FP(e|0)|0}function ySi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;OP(e|0)|0}function FSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;AP(e|0)|0}function OSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;MP(e|0)|0}function ASi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;RP(e|0)|0}function MSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;NP(e|0)|0}function RSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;TP(e|0)|0}function NSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;LP(e|0)|0}function TSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;DP(e|0)|0}function LSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;CP(e|0)|0}function DSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;PP(e|0)|0}function CSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;BP(e|0)|0}function PSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;IP(e|0)|0}function BSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;HP(e|0)|0}function ISi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xP(e|0)|0}function HSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;UP(e|0)|0}function xSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;zP(e|0)|0}function USi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jP(e|0)|0}function zSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;VP(e|0)|0}function jSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qP(e|0)|0}function VSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;YP(e|0)|0}function qSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;GP(e|0)|0}function YSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;WP(e|0)|0}function GSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;KP(e|0)|0}function WSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;XP(e|0)|0}function KSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ZP(e|0)|0}function XSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;JP(e|0)|0}function ZSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;QP(e|0)|0}function JSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$P(e|0)|0}function QSi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;eB(e|0)|0}function $Si(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;iB(e|0)|0}function egi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;rB(e|0)|0}function igi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;nB(e|0)|0}function rgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;fB(e|0)|0}function ngi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;tB(e|0)|0}function fgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;uB(e|0)|0}function tgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;aB(e|0)|0}function ugi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;oB(e|0)|0}function agi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;cB(e|0)|0}function ogi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;lB(e|0)|0}function cgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;sB(e|0)|0}function lgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;bB(e|0)|0}function sgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;kB(e|0)|0}function bgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;hB(e|0)|0}function kgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;wB(e|0)|0}function hgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;dB(e|0)|0}function wgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;vB(e|0)|0}function dgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;mB(e|0)|0}function vgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_B(e|0)|0}function mgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;pB(e|0)|0}function _gi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;EB(e|0)|0}function pgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;SB(e|0)|0}function Egi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;gB(e|0)|0}function Sgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;yB(e|0)|0}function ggi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;FB(e|0)|0}function ygi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;OB(e|0)|0}function Fgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;AB(e|0)|0}function Ogi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;MB(e|0)|0}function Agi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;RB(e|0)|0}function Mgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;NB(e|0)|0}function Rgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;TB(e|0)|0}function Ngi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;LB(e|0)|0}function Tgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;DB(e|0)|0}function Lgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;CB(e|0)|0}function Dgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;PB(e|0)|0}function Cgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;BB(e|0)|0}function Pgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;IB(e|0)|0}function Bgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;HB(e|0)|0}function Igi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xB(e|0)|0}function Hgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;UB(e|0)|0}function xgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;zB(e|0)|0}function Ugi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jB(e|0)|0}function zgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;VB(e|0)|0}function jgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qB(e|0)|0}function Vgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;YB(e|0)|0}function qgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;NY(e|0,i|0,r|0)|0}function Ygi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;am(e|0)}function Ggi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;om(e|0)|0}function Wgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;cm(e|0,i|0)|0}function Kgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;lm(e|0)|0}function Xgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;aA(e|0,i|0,r|0)|0}function Zgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;bm(e|0)}function Jgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;km(e|0)}function Qgi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;hm(e|0,i|0,r|0)|0}function $gi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xe(e|0,i|0,r|0)|0}function eyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;pm(e|0,i|0,r|0)|0}function iyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Em(e|0)}function ryi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Sm(e|0,i|0,r|0)}function nyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;gm(e|0,i|0,r|0)}function fyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ym(e|0,i|0,r|0)}function tyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Fm(e|0,i|0,r|0)}function uyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Am(e|0)|0}function ayi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;O_(e|0,i|0)}function oyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;A_(e|0)|0}function cyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Z_(e|0,i|0,r|0,n|0)|0}function lyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;J_(e|0,i|0,r|0,n|0)|0}function syi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Q_(e|0,i|0,r|0,n|0)|0}function byi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$_(e|0,i|0,r|0,n|0)|0}function kyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ep(e|0,i|0,r|0,n|0)|0}function hyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ip(e|0,i|0,r|0,n|0)|0}function wyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;N_(e|0,i|0,r|0,n|0)|0}function dyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;T_(e|0,i|0,r|0,n|0)|0}function vyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;rp(e|0,i|0,r|0,n|0)|0}function myi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;np(e|0,i|0,r|0,n|0)|0}function _yi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;dN(e|0,i|0,r|0,n|0)|0}function pyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;hp(e|0,i|0,r|0)}function Eyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;wp(e|0,i|0,r|0)}function Syi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;LS(e|0)}function gyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;FO()|0}function yyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Tg(e|0,i|0,r|0,n|0,0)}function Fyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_O(e|0,i|0,r|0,n|0,0)}function Oyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;OO(e|0)|0}function Ayi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;AO(e|0)|0}function Myi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;MO(e|0,i|0,r|0)|0}function Ryi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;RO(e|0)|0}function Nyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;sA(e|0)|0}function Tyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;bA(e|0,i|0,r|0)|0}function Lyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;hA(e|0)|0}function Dyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;wA(e|0,i|0,r|0)|0}function Cyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;dA(e|0)|0}function Pyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;vA(e|0,i|0,r|0)|0}function Byi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;mA(e|0,i|0,r|0)|0}function Iyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_A(e|0,i|0,r|0,n|0)|0}function Hyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;FR(e|0)}function xyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;OR(e|0)|0}function Uyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;NR(e|0)}function zyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;DR(e|0)|0}function jyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;PR(e|0)}function Vyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;BR(e|0)|0}function qyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;IR(e|0,i|0)}function Yyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;HR(e|0)}function Gyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xR(e|0)}function Wyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;UR(e|0,i|0)|0}function Kyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;zR(e|0);
	}function Xyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;GR(e|0,i|0,r|0)}function Zyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;iN(e|0,i|0,r|0)}function Jyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;rN(e|0,i|0,r|0)}function Qyi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;nN(e|0,i|0,r|0)}function $yi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;fN(e|0,i|0,r|0)}function eFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;lN(e|0,i|0)|0}function iFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xr(e|0,i|0)}function rFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_n(e|0)}function nFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;tt(e|0,i|0)}function fFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;bt(e|0,i|0)}function tFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Yf(e|0,i|0)}function uFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Jf(e|0,i|0)}function aFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Qf(e|0,i|0)}function oFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Gf(e|0,i|0)}function cFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ot(e|0,i|0)}function lFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;st(e|0,i|0)}function sFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Vf(e|0,i|0)}function bFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ct(e|0,i|0)}function kFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Wf(e|0,i|0)}function hFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ut(e|0,i|0)}function wFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Yt(e|0,i|0)}function dFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Kf(e|0,i|0)}function vFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;nt(e|0,i|0)}function mFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;gf(e|0,i|0)}function _Fi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qf(e|0,i|0)}function pFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;kt(e|0,i|0)}function EFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xf(e|0,i|0)}function SFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Zf(e|0,i|0)}function gFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$f(e|0,i|0)}function yFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;et(e|0,i|0)}function FFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;it(e|0,i|0)}function OFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;rt(e|0,i|0)}function AFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;lt(e|0,i|0)}function MFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;at(e|0,i|0)}function RFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ft(e|0,i|0)}function NFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Gt(e|0,i|0)}function TFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Qu(e|0,i|0,r|0)|0}function LFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Pf(e|0,i|0)|0}function DFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Bf(e|0,i|0)|0}function CFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;zf(e|0,i|0)|0}function PFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$u(e|0,i|0,r|0)|0}function BFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ea(e|0,i|0)|0}function IFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Tf(e|0,i|0)|0}function HFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Lf(e|0,i|0)|0}function xFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Df(e|0,i|0)|0}function UFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xf(e|0,i|0)|0}function zFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;If(e|0,i|0)|0}function jFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Uf(e|0,i|0)|0}function VFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Cf(e|0,i|0)|0}function qFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ia(e|0,i|0)|0}function YFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Hf(e|0,i|0)|0}function GFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Nf(e|0,i|0)|0}function WFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Cn(e|0,i|0)|0}function KFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;za(e|0,i|0)}function XFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Wa(e|0,i|0)}function ZFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ka(e|0,i|0)}function JFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xa(e|0,i|0)}function QFi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Za(e|0,i|0)}function $Fi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ja(e|0,i|0)}function eOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Qa(e|0,i|0)}function iOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$a(e|0,i|0)}function rOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Qo(e|0,i|0,r|0)}function nOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;vc(e|0)}function fOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Rc(e|0)}function tOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;wl(e|0,i|0,r|0)|0}function uOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ll(e|0,i|0)|0}function aOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Bl(e|0,i|0)|0}function oOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Hl(e|0,i|0)|0}function cOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jl(e|0,i|0)|0}function lOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Xk(e|0)}function sOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;dh(e|0,i|0,r|0,n|0,0,0,0,0,0)}function bOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;mh(e|0,i|0,r|0)}function kOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_h(e|0,i|0,r|0)}function hOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ph(e|0,i|0)}function wOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Sh(e|0)|0}function dOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;gh(e|0)|0}function vOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;yh(e|0)|0}function mOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Fh(e|0,i|0,r|0)|0}function _Oi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Oh(e|0,i|0)|0}function pOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ah(e|0,i|0,r|0,n|0,0,0)}function EOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Rh(e|0,i|0,r|0,n|0,0,0,0)}function SOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Th(e|0,i|0,r|0,n|0,0)}function gOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Lh(e|0,i|0)}function yOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Dh(e|0)}function FOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ch(e|0)}function OOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ph(e|0,i|0,r|0)}function AOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Bh(e|0,i|0)}function MOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ih(e|0,i|0,r|0)}function ROi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Hh(e|0,i|0,r|0)}function NOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;xh(e|0,i|0,r|0)}function TOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Uh(e|0,i|0)|0}function LOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;jh(e|0,i|0,r|0)}function DOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Vh(e|0,i|0,r|0)}function COi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;qh(e|0,i|0,r|0)}function POi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Yh(e|0,i|0)}function BOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Gh(e|0,i|0,r|0,n|0,0,0,0,0,0)}function IOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Zh(e|0,i|0,r|0)|0}function HOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;$h(e|0)}function xOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;td(e|0,i|0)}function UOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;aT(e|0,i|0)}function zOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Ok(e|0)}function jOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;cH(e|0,i|0,r|0)}function VOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;lH(e|0,i|0)}function qOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;sH(e|0,i|0,r|0,n|0,0,0,0,0,0)}function YOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;kH(e|0,i|0,r|0)}function GOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;hH(e|0,i|0,r|0)}function WOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;dH(e|0,i|0,r|0)}function KOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;vH(e|0,i|0,r|0)}function XOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;_H(e|0,i|0,r|0)|0}function ZOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;mH(e|0,i|0)}function JOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;DH(e|0)}function QOi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ex(e|0,i|0)|0}function $Oi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ix(e|0,i|0,r|0,n|0,0)|0}function eAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;rx(e|0,i|0,r|0,n|0,0,0,0)|0}function iAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;nx(e|0,i|0,r|0,n|0,0,0)|0}function rAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;fx(e|0,i|0)}function nAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ux(e|0,i|0)|0}function fAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ax(e|0,i|0,r|0,n|0,0)|0}function tAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;ox(e|0,i|0,r|0,n|0,0,0,0)|0}function uAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;cx(e|0,i|0)}function aAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;wx(e|0,i|0,r|0)}function oAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;oU(e|0,i|0,r|0)}function cAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;cU(e|0,i|0,r|0)}function lAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;tz(e|0,i|0,r|0)}function sAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Gz(e|0,i|0,r|0,n|0,0,0,0,0,0)}function bAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;PV(e|0,i|0,r|0,n|0)|0}function kAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Rq(e|0,i|0)|0}function hAi(e,i,r,n){e=e|0;i=i|0;r=r|0;n=n|0;Kq(e|0,i|0,r|0)|0}var wAi=[_G,pG,EG,SG,gG,yG,FG,OG,AG,MG,RG,NG,TG,LG,DG,CG,PG,BG,IG,HG,xG,UG,zG,jG,VG,qG,YG,GG,WG,KG,XG,ZG,JG,QG,$G,eW,iW,rW,nW,fW,tW,uW,aW,oW,cW,lW,sW,bW,kW,hW,wW,dW,vW,mW,_W,pW,EW,SW,gW,yW,FW,OW,AW,MW,RW,NW,TW,LW,DW,CW,PW,BW,IW,HW,xW,UW,zW,jW,VW,qW,YW,GW,WW,KW,XW,ZW,JW,QW,$W,eK,iK,rK,nK,fK,tK,uK,aK,oK,cK,lK,sK,bK,kK,hK,wK,dK,vK,mK,_K,pK,EK,SK,gK,yK,FK,OK,AK,MK,RK,NK,TK,LK,DK,CK,PK,BK,IK,HK,xK,UK,zK,jK,VK,qK,YK,GK,WK,KK,XK,ZK,JK,QK,$K,eX,iX,rX,nX,fX,tX,uX,aX,oX,cX,lX,sX,bX,kX,hX,wX,dX,vX,mX,_X,pX,EX,SX,gX,yX,FX,OX,AX,MX,RX,NX,TX,LX,DX,CX,PX,BX,IX,HX,xX,UX,zX,jX,VX,qX,YX,GX,WX,KX,XX,ZX,JX,QX,$X,eZ,iZ,rZ,nZ,fZ,tZ,uZ,aZ,oZ,cZ,lZ,sZ,bZ,kZ,hZ,wZ,dZ,vZ,mZ,_Z,pZ,EZ,SZ,gZ,yZ,FZ,OZ,AZ,MZ,RZ,NZ,TZ,LZ,DZ,CZ,PZ,BZ,IZ,HZ,xZ,UZ,zZ,jZ,VZ,qZ,YZ,GZ,WZ,KZ,XZ,ZZ,JZ,QZ,$Z,eJ,iJ,rJ,nJ,fJ,tJ,uJ,aJ,oJ,cJ,lJ,sJ,bJ,kJ,hJ,wJ,dJ,vJ,mJ,_J,pJ,EJ,SJ,gJ,yJ,FJ,OJ,AJ,MJ,RJ,NJ,TJ,LJ,DJ,CJ,PJ,BJ,IJ,HJ,xJ,UJ,zJ,jJ,VJ,qJ,YJ,GJ,WJ,KJ,XJ,ZJ,JJ,QJ,$J,eQ,iQ,rQ,nQ,fQ,tQ,uQ,aQ,oQ,cQ,lQ,sQ,bQ,kQ,hQ,wQ,dQ,vQ,mQ,_Q,pQ,EQ,SQ,gQ,yQ,FQ,OQ,AQ,MQ,RQ,NQ,TQ,LQ,DQ,CQ,PQ,BQ,IQ,HQ,xQ,UQ,zQ,jQ,VQ,qQ,YQ,GQ,WQ,KQ,XQ,ZQ,JQ,QQ,$Q,e$,i$,r$,n$,f$,t$,u$,a$,o$,c$,l$,s$,b$,k$,h$,rx,w$,d$,v$,m$,ox,_$,p$,E$,S$,g$,y$,F$,O$,A$,M$,R$,N$,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G,_G];var dAi=[T$,L$,D$,C$,P$,Hm,B$,I$,H$,x$,U$,z$,j$,V$,q$,Y$,G$,W$,K$,X$,Z$,J$,Q$,$$,e0,i0,r0,n0,f0,t0,oA,u0,a0,o0,c0,l0,s0,b0,k0,h0,Dz,w0,d0,v0,m0,_0,p0,E0,S0,g0,y0,F0,O0,A0,M0,R0,N0,T0,L0,D0,C0,P0,B0,I0,H0,x0,U0,z0,j0,V0,q0,Y0,G0,W0,K0,X0,Z0,J0,Q0,$0,e1,i1,r1,n1,f1,t1,u1,a1,o1,c1,l1,s1,b1,k1,h1,w1,d1,v1,m1,_1,p1,E1,S1,g1,y1,F1,O1,A1,M1,R1,N1,T1,L1,D1,C1,P1,B1,I1,H1,x1,U1,z1,j1,V1,q1,Y1,G1,W1,K1,X1,Z1,J1,Q1,$1,e2,i2,r2,n2,f2,t2,u2,a2,o2,c2,l2,s2,b2,k2,h2,w2,d2,v2,m2,_2,p2,E2,S2,g2,y2,F2,O2,A2,M2,R2,N2,T2,L2,D2,C2,P2,B2,I2,H2,x2,U2,z2,j2,V2,q2,Y2,G2,W2,K2,X2,Z2,J2,Q2,$2,e3,i3,r3,n3,f3,t3,NY,u3,a3,o3,c3,aA,l3,s3,hm,b3,pm,k3,h3,w3,d3,v3,m3,_3,p3,E3,S3,g3,y3,F3,O3,A3,M3,R3,N3,T3,L3,D3,C3,P3,B3,I3,H3,x3,MO,U3,z3,bA,j3,wA,V3,vA,mA,q3,Y3,G3,W3,K3,X3,Z3,J3,Q3,$3,e4,i4,r4,n4,f4,t4,u4,a4,o4,c4,l4,s4,b4,k4,h4,w4,d4,v4,m4,_4,p4,E4,S4,g4,y4,F4,O4,A4,M4,R4,N4,T4,L4,D4,C4,P4,B4,I4,Qu,H4,x4,U4,$u,z4,j4,V4,q4,Y4,G4,W4,K4,X4,Z4,J4,Q4,$4,e8,i8,r8,n8,f8,t8,u8,a8,o8,c8,wl,l8,s8,b8,k8,h8,w8,d8,v8,m8,_8,p8,E8,S8,g8,Fh,y8,F8,O8,A8,M8,R8,N8,T8,L8,D8,C8,P8,B8,I8,H8,x8,U8,z8,j8,V8,q8,Y8,Zh,G8,W8,K8,X8,Z8,J8,Q8,$8,e6,i6,r6,n6,f6,_H,t6,u6,a6,o6,c6,l6,s6,b6,k6,h6,w6,d6,v6,m6,_6,p6,E6,S6,g6,y6,F6,Kq,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$,T$];var vAi=[O6,A6,M6,R6,N6,T6,L6,D6,C6,jm,P6,B6,I6,H6,x6,U6,z6,j6,V6,q6,Y6,G6,W6,K6,X6,Z6,J6,Q6,$6,e5,i5,r5,n5,f5,t5,u5,a5,o5,c5,l5,s5,b5,k5,h5,Iz,w5,d5,v5,m5,_5,p5,E5,S5,g5,y5,F5,O5,A5,M5,R5,N5,T5,L5,D5,C5,P5,B5,I5,H5,x5,U5,z5,j5,V5,q5,Y5,G5,W5,K5,X5,Z5,J5,Q5,$5,e9,i9,r9,n9,f9,t9,u9,a9,o9,c9,l9,s9,b9,k9,h9,w9,d9,v9,m9,_9,p9,E9,S9,g9,y9,F9,O9,A9,M9,R9,N9,T9,L9,D9,C9,P9,B9,I9,H9,x9,U9,z9,j9,V9,q9,Y9,G9,W9,K9,X9,Z9,J9,Q9,$9,e7,i7,r7,n7,f7,t7,u7,a7,o7,c7,l7,s7,b7,k7,h7,w7,d7,v7,m7,_7,p7,E7,S7,g7,y7,F7,O7,A7,M7,R7,N7,T7,L7,D7,C7,P7,B7,I7,H7,x7,U7,z7,j7,V7,q7,Y7,G7,W7,K7,X7,Z7,J7,Q7,$7,eee,iee,ree,nee,fee,tee,uee,aee,oee,cee,lee,see,bee,kee,hee,wee,dee,vee,mee,_ee,pee,Eee,See,gee,yee,Fee,Oee,Aee,Mee,Ree,Nee,Tee,Lee,Dee,Cee,Pee,Bee,Iee,Hee,xee,Uee,zee,jee,Vee,qee,Yee,Gee,Wee,Kee,Xee,Zee,Jee,Qee,$ee,eie,iie,rie,nie,fie,tie,uie,aie,oie,cie,lie,sie,bie,kie,hie,wie,die,vie,mie,_ie,pie,Eie,Sie,gie,yie,Fie,Oie,Aie,Mie,Rie,Nie,Tie,Lie,Die,Cie,Pie,Bie,Iie,Hie,xie,Uie,zie,jie,Vie,qie,Yie,Gie,Wie,Kie,Xie,Zie,Jie,Qie,$ie,ere,ire,rre,nre,fre,tre,ure,are,ore,cre,lre,sre,bre,kre,hre,wre,dre,vre,mre,_re,pre,Ere,Sre,gre,yre,Fre,Ore,Are,Mre,Rre,Nre,Tre,Lre,Dre,Cre,Pre,Rh,Bre,Ire,Hre,xre,Ure,zre,jre,Vre,qre,Yre,Gre,Wre,Kre,Xre,Zre,Jre,Qre,$re,ene,ine,rne,nne,fne,tne,une,ane,one,cne,lne,sne,bne,kne,hne,wne,dne,vne,mne,_ne,pne,Ene,Sne,gne,yne,Fne,One,Ane,Mne,Rne,Nne,Tne,Lne,Dne,Cne,Pne,Bne,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6,O6];var mAi=[Ine,Hne,xne,Une,zne,jne,Vne,qne,Yne,Gne,Wne,qm,Kne,Xne,Zne,Jne,Qne,$ne,efe,ife,rfe,nfe,ffe,tfe,ufe,afe,ofe,cfe,lfe,sfe,bfe,kfe,hfe,wfe,dfe,vfe,mfe,_fe,pfe,Efe,Sfe,gfe,yfe,Ffe,Ofe,Afe,Uz,Mfe,Rfe,Nfe,Tfe,Lfe,Dfe,Cfe,Pfe,Bfe,Ife,Hfe,xfe,Ufe,zfe,jfe,Vfe,qfe,Yfe,Gfe,Wfe,Kfe,Xfe,Zfe,Jfe,Qfe,$fe,ete,ite,rte,nte,fte,tte,ute,ate,ote,cte,lte,ste,bte,kte,hte,wte,dte,vte,mte,_te,pte,Ete,Ste,gte,yte,Fte,Ote,Ate,Mte,Rte,Nte,Tte,Lte,Dte,Cte,Pte,Bte,Ite,Hte,xte,Ute,zte,jte,Vte,qte,Yte,Gte,Wte,Kte,Xte,Zte,Jte,Qte,$te,eue,iue,rue,nue,fue,tue,uue,aue,oue,cue,lue,sue,bue,kue,hue,wue,due,vue,mue,_ue,pue,Eue,Sue,gue,yue,Fue,Oue,Aue,Mue,Rue,Nue,Tue,Lue,Due,Cue,Pue,Bue,Iue,Hue,xue,Uue,zue,jue,Vue,que,Yue,Gue,Wue,Kue,Xue,Zue,Jue,Que,$ue,eae,iae,rae,nae,fae,tae,uae,aae,oae,cae,lae,sae,bae,kae,hae,wae,dae,vae,mae,_ae,pae,Eae,Sae,gae,yae,Fae,Oae,Aae,Mae,Rae,Nae,Tae,Lae,Dae,Cae,Pae,Bae,Iae,Hae,xae,Uae,zae,jae,Vae,qae,Yae,Gae,Tg,_O,Wae,Kae,Xae,Zae,Jae,Qae,$ae,eoe,ioe,roe,noe,foe,toe,uoe,aoe,ooe,coe,loe,soe,boe,koe,hoe,woe,doe,voe,moe,_oe,poe,Eoe,Soe,goe,yoe,Foe,Ooe,Aoe,Moe,Roe,Noe,Toe,Loe,Doe,Coe,Poe,Boe,Ioe,Hoe,xoe,Uoe,zoe,joe,Voe,qoe,Yoe,Goe,Woe,Koe,Xoe,Zoe,Joe,Qoe,$oe,ece,ice,rce,nce,fce,tce,uce,ace,oce,cce,lce,sce,bce,kce,hce,wce,dce,vce,mce,_ce,pce,Ece,Sce,gce,yce,Fce,Oce,Ace,Mce,Rce,Nce,Tce,Lce,Dce,Cce,Pce,Bce,Ice,Hce,xce,Uce,zce,jce,Vce,qce,Yce,Gce,Th,Wce,Kce,Xce,Zce,Jce,Qce,$ce,ele,ile,rle,nle,fle,tle,ule,ale,ole,cle,lle,sle,ble,kle,hle,wle,dle,vle,mle,_le,ple,Ele,Sle,gle,yle,Fle,Ole,Ale,Mle,Rle,Nle,Tle,Lle,Dle,Cle,Ple,Ble,Ile,Hle,xle,Ule,zle,jle,Vle,qle,Yle,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine,Ine];var _Ai=[Gle,Wle,Kle,Xle,Zle,Jle,Qle,$le,ese,ise,rse,nse,fse,tse,use,ase,ose,cse,lse,sse,bse,kse,hse,wse,dse,vse,mse,_se,pse,Ese,Sse,gse,yse,Fse,Ose,Ase,Mse,Rse,Nse,Tse,Lse,Dse,Cse,Pse,Bse,Ise,Hse,xse,Use,zse,jse,Vse,qse,Yse,Gse,Wse,Kse,Xse,Zse,Jse,Qse,$se,ebe,ibe,rbe,nbe,fbe,tbe,ube,abe,obe,cbe,lbe,sbe,bbe,kbe,hbe,wbe,dbe,vbe,mbe,_be,pbe,Ebe,Sbe,gbe,ybe,Fbe,Obe,Abe,Mbe,Rbe,Nbe,Tbe,Lbe,Dbe,Cbe,Pbe,Bbe,Ibe,Hbe,xbe,Ube,zbe,jbe,Vbe,qbe,Ybe,Gbe,Wbe,Kbe,Xbe,Zbe,Jbe,Qbe,$be,eke,ike,rke,nke,fke,tke,uke,ake,oke,cke,lke,ske,bke,kke,hke,wke,dke,vke,mke,_ke,pke,Eke,Ske,gke,yke,Fke,Oke,Ake,Mke,Rke,Nke,Tke,Lke,Dke,Cke,Pke,Bke,Ike,Hke,xke,Uke,zke,jke,Vke,qke,Yke,Gke,Wke,Kke,Xke,Zke,Jke,Qke,$ke,ehe,ihe,rhe,nhe,fhe,the,uhe,ahe,ohe,che,lhe,she,bhe,khe,hhe,whe,dhe,vhe,mhe,_he,phe,Ehe,She,ghe,yhe,Fhe,Ohe,Ahe,Mhe,Rhe,Nhe,The,Lhe,Dhe,Che,Phe,Bhe,Ihe,Hhe,xhe,Uhe,zhe,jhe,Vhe,qhe,Yhe,Ghe,Whe,Khe,Xhe,Zhe,Jhe,Qhe,$he,ewe,iwe,rwe,FO,nwe,fwe,twe,uwe,awe,owe,cwe,lwe,swe,bwe,kwe,hwe,wwe,dwe,vwe,mwe,_we,pwe,Ewe,Swe,gwe,ywe,Fwe,Owe,Awe,Mwe,Rwe,Nwe,Twe,Lwe,Dwe,Cwe,Pwe,Bwe,Iwe,Hwe,xwe,Uwe,zwe,jwe,Vwe,qwe,Ywe,Gwe,Wwe,Kwe,Xwe,Zwe,Jwe,Qwe,$we,ede,ide,rde,nde,fde,tde,ude,ade,ode,cde,lde,sde,bde,kde,hde,wde,dde,vde,mde,_de,pde,Ede,Sde,gde,yde,Fde,Ode,Ade,Mde,Rde,Nde,Tde,Lde,Dde,Cde,Pde,Bde,Ide,Hde,xde,Ude,zde,jde,Vde,qde,Yde,Gde,Wde,Kde,Xde,Zde,Jde,Qde,$de,eve,ive,rve,nve,fve,tve,uve,ave,ove,cve,lve,sve,bve,kve,hve,wve,dve,vve,mve,_ve,pve,Eve,Sve,gve,yve,Fve,Ove,Ave,Mve,Rve,Nve,Tve,Lve,Dve,Cve,Pve,Bve,Ive,Hve,xve,Uve,zve,jve,Vve,qve,Yve,Gve,Wve,Kve,Xve,Zve,Jve,Qve,$ve,eme,ime,rme,nme,fme,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle,Gle];var pAi=[tme,ume,ame,ome,cme,lme,sme,bme,kme,hme,wme,dme,vme,Gm,Wm,mme,_me,pme,Eme,Sme,gme,yme,Fme,Ome,Ame,Mme,Rme,Nme,Tme,Lme,Dme,Zq,Cme,Pme,Bme,Ime,Hme,xme,Ume,zme,jme,Vme,qme,Yme,Gme,Wme,Kme,Xme,jz,Vz,Zme,Jme,Qme,$me,e_e,i_e,r_e,n_e,f_e,t_e,u_e,a_e,o_e,c_e,l_e,s_e,b_e,k_e,h_e,w_e,d_e,v_e,m_e,__e,p_e,E_e,S_e,g_e,y_e,F_e,O_e,A_e,M_e,R_e,N_e,T_e,L_e,D_e,C_e,P_e,B_e,I_e,H_e,x_e,U_e,z_e,j_e,V_e,q_e,Y_e,G_e,W_e,K_e,X_e,Z_e,J_e,Q_e,$_e,epe,ipe,rpe,npe,fpe,tpe,upe,ape,ope,cpe,lpe,spe,bpe,kpe,hpe,wpe,dpe,vpe,mpe,_pe,ppe,Epe,Spe,gpe,ype,Fpe,Ope,Ape,Mpe,Rpe,Npe,Tpe,Lpe,Dpe,Cpe,Ppe,Bpe,Ipe,Hpe,xpe,Upe,zpe,jpe,Vpe,qpe,Ype,Gpe,Wpe,Kpe,Xpe,Zpe,Jpe,Qpe,$pe,eEe,iEe,rEe,nEe,fEe,tEe,uEe,aEe,oEe,cEe,lEe,sEe,bEe,kEe,hEe,wEe,dEe,vEe,mEe,_Ee,pEe,EEe,SEe,gEe,yEe,FEe,OEe,AEe,MEe,REe,NEe,TEe,LEe,am,DEe,CEe,PEe,BEe,bm,km,IEe,HEe,xEe,Em,UEe,zEe,jEe,VEe,qEe,YEe,GEe,WEe,KEe,XEe,ZEe,JEe,QEe,$Ee,eSe,iSe,rSe,nSe,fSe,tSe,LS,uSe,aSe,oSe,cSe,lSe,sSe,bSe,kSe,hSe,wSe,dSe,vSe,mSe,_Se,pSe,FR,ESe,NR,SSe,PR,gSe,ySe,HR,xR,FSe,zR,OSe,ASe,MSe,RSe,NSe,TSe,LSe,_n,DSe,CSe,PSe,BSe,ISe,HSe,xSe,USe,zSe,jSe,VSe,qSe,YSe,GSe,WSe,KSe,XSe,ZSe,JSe,QSe,$Se,ege,ige,rge,nge,fge,tge,uge,age,oge,cge,lge,sge,bge,kge,hge,wge,dge,vge,mge,_ge,pge,Ege,Sge,gge,yge,Fge,Oge,Age,Mge,Rge,Nge,Tge,Lge,vc,Rc,Dge,Cge,Pge,Bge,Ige,Xk,Hge,xge,Uge,zge,jge,Vge,qge,Yge,Gge,Wge,Kge,Xge,Zge,Jge,Qge,$ge,eye,Dh,Ch,iye,rye,nye,fye,tye,uye,aye,oye,cye,lye,sye,bye,kye,hye,$h,wye,dye,vye,Ok,mye,_ye,pye,Eye,Sye,gye,yye,Fye,Oye,Aye,DH,Mye,Rye,Nye,Tye,Lye,Dye,Cye,Pye,Bye,Iye,Hye,xye,Uye,zye,jye,Vye,qye,Yye,Gye,Wye,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme,tme];var EAi=[Kye,Xye,Zye,Jye,Qye,$ye,eFe,iFe,rFe,nFe,fFe,tFe,Ym,uFe,aFe,oFe,c_,Km,cFe,lFe,sFe,Qm,bFe,kFe,hFe,wFe,dFe,vFe,mFe,_Fe,pFe,EFe,SFe,gFe,yFe,FFe,OFe,AFe,MFe,RFe,NFe,TFe,LFe,DFe,CFe,PFe,BFe,zz,IFe,HFe,xFe,Yz,Kz,UFe,zFe,Qz,jFe,VFe,qFe,YFe,GFe,WFe,KFe,XFe,ZFe,JFe,QFe,$Fe,eOe,iOe,rOe,nOe,fOe,tOe,uOe,aOe,oOe,cOe,lOe,sOe,bOe,kOe,hOe,wOe,dOe,vOe,mOe,_Oe,pOe,EOe,SOe,gOe,yOe,FOe,OOe,AOe,MOe,ROe,NOe,TOe,LOe,DOe,COe,POe,BOe,IOe,HOe,xOe,UOe,zOe,jOe,VOe,qOe,YOe,GOe,WOe,KOe,XOe,ZOe,JOe,QOe,$Oe,eAe,iAe,rAe,nAe,fAe,tAe,uAe,aAe,oAe,cAe,lAe,sAe,bAe,kAe,hAe,wAe,dAe,vAe,mAe,_Ae,pAe,EAe,SAe,gAe,yAe,FAe,OAe,AAe,MAe,RAe,NAe,TAe,LAe,DAe,CAe,PAe,BAe,IAe,HAe,xAe,UAe,zAe,jAe,VAe,qAe,YAe,GAe,WAe,KAe,XAe,ZAe,JAe,QAe,$Ae,eMe,iMe,rMe,nMe,fMe,tMe,uMe,aMe,oMe,cMe,lMe,sMe,bMe,kMe,hMe,wMe,dMe,vMe,mMe,_Me,pMe,EMe,SMe,gMe,yMe,FMe,OMe,AMe,MMe,RMe,NMe,TMe,LMe,DMe,CMe,O_,PMe,BMe,IMe,HMe,xMe,UMe,zMe,jMe,VMe,qMe,YMe,GMe,WMe,KMe,XMe,ZMe,JMe,QMe,$Me,eRe,iRe,rRe,nRe,fRe,tRe,uRe,aRe,oRe,cRe,lRe,sRe,bRe,kRe,hRe,wRe,dRe,IR,vRe,mRe,_Re,pRe,ERe,SRe,gRe,yRe,FRe,ORe,Xr,ARe,tt,bt,Yf,Jf,Qf,Gf,ot,st,Vf,ct,Wf,ut,Yt,Kf,nt,gf,qf,kt,Xf,Zf,$f,et,it,rt,lt,at,ft,Gt,MRe,RRe,NRe,TRe,LRe,DRe,CRe,PRe,BRe,IRe,HRe,xRe,URe,zRe,jRe,VRe,qRe,za,Wa,Ka,Xa,Za,Ja,Qa,$a,YRe,GRe,WRe,KRe,XRe,ZRe,JRe,QRe,$Re,eNe,iNe,rNe,nNe,ph,fNe,tNe,uNe,aNe,oNe,cNe,lNe,sNe,bNe,kNe,hNe,Lh,wNe,dNe,vNe,Bh,mNe,_Ne,pNe,ENe,SNe,gNe,yNe,FNe,Yh,ONe,ANe,MNe,RNe,td,NNe,aT,TNe,LNe,lH,DNe,CNe,PNe,BNe,INe,HNe,xNe,mH,UNe,zNe,jNe,VNe,qNe,fx,YNe,GNe,WNe,cx,KNe,XNe,ZNe,JNe,QNe,$Ne,eTe,iTe,rTe,nTe,fTe,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye,Kye];var SAi=[tTe,uTe,aTe,oTe,cTe,lTe,sTe,bTe,kTe,hTe,wTe,dTe,vTe,mTe,_Te,pTe,ETe,STe,gTe,yTe,FTe,OTe,ATe,MTe,RTe,NTe,TTe,LTe,DTe,CTe,PTe,BTe,ITe,HTe,xTe,UTe,zTe,jTe,VTe,qTe,YTe,GTe,WTe,KTe,XTe,ZTe,JTe,QTe,$Te,eLe,iLe,rLe,nLe,fLe,tLe,uLe,aLe,oLe,cLe,lLe,sLe,bLe,kLe,hLe,wLe,dLe,vLe,mLe,_Le,pLe,ELe,SLe,gLe,yLe,FLe,OLe,ALe,MLe,RLe,NLe,TLe,LLe,DLe,CLe,PLe,BLe,ILe,HLe,xLe,ULe,zLe,jLe,VLe,qLe,YLe,GLe,WLe,KLe,XLe,ZLe,JLe,QLe,$Le,eDe,iDe,rDe,nDe,fDe,tDe,uDe,aDe,oDe,cDe,lDe,sDe,bDe,kDe,hDe,wDe,dDe,vDe,mDe,_De,pDe,EDe,SDe,gDe,yDe,FDe,ODe,ADe,MDe,RDe,NDe,TDe,LDe,DDe,CDe,PDe,BDe,IDe,HDe,xDe,UDe,zDe,jDe,VDe,qDe,YDe,GDe,WDe,KDe,XDe,ZDe,JDe,QDe,$De,eCe,iCe,rCe,nCe,fCe,tCe,uCe,aCe,oCe,cCe,lCe,sCe,bCe,kCe,hCe,wCe,dCe,vCe,mCe,_Ce,pCe,ECe,SCe,gCe,yCe,FCe,OCe,ACe,MCe,RCe,NCe,TCe,LCe,DCe,CCe,PCe,BCe,ICe,HCe,xCe,UCe,zCe,jCe,VCe,qCe,YCe,GCe,WCe,KCe,XCe,ZCe,JCe,QCe,$Ce,ePe,iPe,rPe,nPe,fPe,tPe,uPe,aPe,oPe,cPe,lPe,sPe,bPe,kPe,hPe,wPe,dPe,vPe,mPe,_Pe,pPe,EPe,SPe,gPe,yPe,FPe,OPe,APe,MPe,RPe,NPe,TPe,LPe,DPe,CPe,PPe,BPe,IPe,HPe,xPe,UPe,zPe,jPe,VPe,qPe,YPe,GPe,WPe,KPe,XPe,ZPe,JPe,QPe,$Pe,eBe,iBe,rBe,nBe,fBe,tBe,uBe,aBe,oBe,cBe,lBe,sBe,bBe,kBe,hBe,wBe,dBe,vBe,mBe,_Be,pBe,EBe,SBe,gBe,yBe,FBe,OBe,ABe,MBe,RBe,NBe,TBe,LBe,DBe,CBe,PBe,BBe,IBe,HBe,xBe,UBe,zBe,jBe,VBe,qBe,YBe,GBe,WBe,KBe,XBe,ZBe,JBe,QBe,$Be,eIe,iIe,rIe,nIe,fIe,tIe,uIe,aIe,oIe,cIe,lIe,sIe,bIe,kIe,hIe,wIe,dIe,vIe,mIe,_Ie,pIe,EIe,SIe,gIe,yIe,FIe,OIe,AIe,MIe,RIe,NIe,TIe,LIe,DIe,CIe,PIe,BIe,IIe,HIe,xIe,UIe,zIe,jIe,VIe,qIe,YIe,GIe,WIe,KIe,XIe,ZIe,JIe,QIe,$Ie,eHe,iHe,nx,rHe,nHe,fHe,tHe,uHe,aHe,oHe,cHe,lHe,sHe,bHe,kHe,hHe,wHe,dHe,vHe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe,tTe];var gAi=[mHe,_He,Pm,Bm,Im,pHe,EHe,SHe,gHe,yHe,FHe,OHe,AHe,MHe,RHe,NHe,THe,LHe,DHe,CHe,PHe,BHe,IHe,HHe,xHe,UHe,zHe,jHe,VHe,qHe,YHe,GHe,Xq,WHe,Yl,KHe,XHe,Mz,Rz,Nz,ZHe,JHe,QHe,$He,exe,ixe,rxe,nxe,fxe,txe,uxe,axe,oxe,cxe,lxe,sxe,bxe,kxe,hxe,wxe,dxe,yz,Fz,Oz,Az,vxe,OC,AC,MC,RC,NC,TC,LC,DC,CC,PC,BC,IC,HC,xC,UC,zC,jC,VC,qC,YC,GC,WC,KC,XC,ZC,JC,QC,$C,eP,iP,rP,nP,fP,tP,uP,aP,oP,cP,lP,sP,bP,kP,hP,wP,dP,vP,mP,_P,pP,EP,SP,gP,yP,FP,OP,AP,MP,RP,NP,TP,LP,DP,CP,PP,BP,IP,HP,xP,UP,zP,jP,VP,qP,YP,GP,WP,KP,XP,ZP,JP,QP,$P,eB,iB,rB,nB,fB,tB,uB,aB,oB,cB,lB,sB,bB,kB,hB,wB,dB,vB,mB,_B,pB,EB,SB,gB,yB,FB,OB,AB,MB,RB,NB,TB,LB,DB,CB,PB,BB,IB,HB,xB,UB,zB,jB,VB,qB,YB,mxe,_xe,om,pxe,lm,Exe,Sxe,gxe,yxe,Fxe,Oxe,Axe,Mxe,Rxe,Nxe,Txe,Am,Lxe,A_,Dxe,Cxe,Pxe,Bxe,Ixe,Hxe,xxe,Uxe,zxe,jxe,Vxe,qxe,Yxe,Gxe,Wxe,Kxe,Xxe,OO,AO,Zxe,RO,sA,Jxe,hA,Qxe,dA,$xe,eUe,iUe,rUe,OR,nUe,DR,fUe,BR,tUe,uUe,aUe,oUe,cUe,lUe,sUe,bUe,kUe,hUe,wUe,dUe,vUe,mUe,_Ue,pUe,EUe,SUe,gUe,yUe,FUe,OUe,AUe,MUe,RUe,NUe,TUe,LUe,DUe,CUe,PUe,BUe,IUe,HUe,xUe,UUe,zUe,jUe,VUe,qUe,YUe,GUe,WUe,KUe,XUe,ZUe,JUe,QUe,$Ue,eze,ize,rze,nze,fze,tze,uze,aze,oze,cze,lze,sze,bze,kze,hze,wze,dze,vze,mze,_ze,pze,Eze,Sze,gze,yze,Fze,Oze,Aze,Mze,Rze,Nze,Tze,Sh,gh,yh,Lze,Dze,Cze,Pze,Bze,Ize,Hze,xze,Uze,zze,jze,Vze,qze,Yze,Gze,Wze,Kze,Xze,Zze,Jze,Qze,$ze,eje,ije,rje,nje,fje,tje,uje,aje,oje,cje,lje,sje,bje,kje,hje,wje,dje,vje,mje,_je,pje,Eje,Sje,gje,yje,Fje,Oje,Aje,Mje,Rje,Nje,Tje,Lje,Dje,Cje,Pje,Bje,Ije,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe,mHe];var yAi=[Hje,xje,Uje,zje,jje,Vje,qje,Yje,Gje,Wje,Kje,Xje,Zje,Jje,Qje,o_,$je,eVe,Xm,Zm,Jm,iVe,$m,e_,i_,rVe,n_,nVe,fVe,tVe,uVe,aVe,oVe,cVe,lVe,tp,sVe,bVe,kVe,hVe,wVe,dVe,vVe,mVe,_Ve,pVe,EVe,SVe,gVe,yVe,qz,FVe,OVe,Xz,Jz,AVe,kp,bp,MVe,$z,RVe,NVe,TVe,LVe,DVe,Zz,CVe,PVe,BVe,IVe,HVe,xVe,UVe,zVe,jVe,VVe,qVe,YVe,GVe,WVe,KVe,XVe,ZVe,JVe,QVe,$Ve,eqe,iqe,rqe,nqe,fqe,tqe,uqe,aqe,oqe,cqe,lqe,sqe,bqe,kqe,hqe,wqe,dqe,vqe,mqe,_qe,pqe,Eqe,Sqe,gqe,yqe,Fqe,Oqe,Aqe,Mqe,Rqe,Nqe,Tqe,Lqe,Dqe,Cqe,Pqe,Bqe,Iqe,Hqe,xqe,Uqe,zqe,jqe,Vqe,qqe,Yqe,Gqe,Wqe,Kqe,Xqe,Zqe,Jqe,Qqe,$qe,eYe,iYe,rYe,nYe,fYe,tYe,uYe,aYe,oYe,cYe,lYe,sYe,bYe,kYe,hYe,wYe,dYe,vYe,mYe,_Ye,pYe,EYe,SYe,gYe,yYe,FYe,OYe,AYe,MYe,RYe,NYe,TYe,LYe,DYe,CYe,PYe,BYe,IYe,HYe,xYe,UYe,zYe,jYe,VYe,qYe,YYe,GYe,WYe,KYe,XYe,ZYe,JYe,QYe,$Ye,eGe,iGe,rGe,nGe,fGe,tGe,uGe,aGe,oGe,cGe,lGe,sGe,Sm,gm,ym,Fm,bGe,kGe,hGe,wGe,dGe,vGe,mGe,_Ge,pGe,EGe,SGe,gGe,yGe,FGe,hp,wp,OGe,AGe,MGe,RGe,NGe,TGe,LGe,DGe,CGe,PGe,BGe,IGe,HGe,xGe,UGe,zGe,jGe,VGe,qGe,YGe,GGe,WGe,KGe,XGe,ZGe,JGe,QGe,GR,iN,rN,nN,fN,$Ge,eWe,iWe,rWe,nWe,fWe,tWe,uWe,aWe,oWe,cWe,lWe,sWe,bWe,kWe,hWe,wWe,dWe,vWe,mWe,_We,pWe,EWe,SWe,gWe,yWe,FWe,OWe,AWe,MWe,RWe,NWe,TWe,LWe,DWe,CWe,PWe,BWe,IWe,HWe,xWe,UWe,zWe,jWe,VWe,qWe,YWe,GWe,WWe,KWe,XWe,ZWe,JWe,QWe,$We,eKe,Qo,iKe,rKe,nKe,fKe,tKe,uKe,aKe,oKe,cKe,lKe,mh,_h,sKe,bKe,kKe,hKe,wKe,dKe,vKe,mKe,_Ke,pKe,EKe,SKe,gKe,yKe,FKe,Ph,OKe,Ih,Hh,xh,AKe,MKe,jh,Vh,qh,RKe,NKe,TKe,LKe,DKe,CKe,PKe,BKe,IKe,cH,HKe,xKe,UKe,kH,hH,dH,vH,zKe,jKe,VKe,qKe,YKe,GKe,WKe,KKe,XKe,ZKe,JKe,QKe,wx,$Ke,oU,cU,eXe,tz,iXe,rXe,nXe,fXe,tXe,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje,Hje];var FAi=[uXe,aXe,oXe,cXe,lXe,sXe,bXe,kXe,hXe,wXe,dXe,vXe,mXe,_Xe,pXe,EXe,SXe,gXe,yXe,FXe,OXe,AXe,MXe,RXe,NXe,TXe,LXe,DXe,t_,CXe,PXe,BXe,IXe,HXe,xXe,UXe,zXe,jXe,VXe,qXe,YXe,GXe,WXe,KXe,XXe,ZXe,JXe,QXe,$Xe,eZe,iZe,rZe,nZe,fZe,tZe,uZe,aZe,oZe,cZe,lZe,sZe,bZe,kZe,hZe,wZe,dZe,vZe,mZe,_Ze,pZe,EZe,SZe,gZe,yZe,FZe,OZe,AZe,MZe,RZe,NZe,TZe,LZe,DZe,CZe,PZe,BZe,IZe,HZe,xZe,UZe,zZe,jZe,VZe,qZe,YZe,GZe,WZe,KZe,XZe,ZZe,JZe,QZe,$Ze,eJe,iJe,rJe,nJe,fJe,tJe,uJe,aJe,oJe,cJe,lJe,sJe,bJe,kJe,hJe,wJe,dJe,vJe,mJe,_Je,pJe,EJe,SJe,gJe,yJe,FJe,OJe,AJe,MJe,RJe,NJe,TJe,LJe,DJe,CJe,PJe,BJe,IJe,HJe,xJe,UJe,zJe,jJe,VJe,qJe,YJe,GJe,WJe,KJe,XJe,ZJe,JJe,QJe,$Je,eQe,iQe,rQe,nQe,fQe,tQe,uQe,aQe,oQe,cQe,lQe,sQe,bQe,kQe,hQe,wQe,dQe,vQe,mQe,_Qe,pQe,EQe,SQe,gQe,yQe,FQe,OQe,AQe,MQe,RQe,NQe,TQe,LQe,DQe,CQe,PQe,BQe,IQe,HQe,xQe,UQe,zQe,jQe,VQe,qQe,YQe,GQe,WQe,KQe,XQe,ZQe,JQe,QQe,$Qe,e$e,i$e,r$e,n$e,f$e,t$e,u$e,a$e,o$e,c$e,l$e,s$e,b$e,k$e,h$e,w$e,d$e,v$e,m$e,_$e,p$e,E$e,S$e,g$e,y$e,F$e,O$e,A$e,M$e,R$e,N$e,T$e,L$e,D$e,C$e,P$e,B$e,I$e,H$e,x$e,U$e,z$e,j$e,V$e,q$e,Y$e,G$e,W$e,K$e,X$e,Z$e,J$e,Q$e,$$e,e0e,i0e,r0e,n0e,f0e,t0e,u0e,a0e,o0e,c0e,l0e,s0e,b0e,k0e,h0e,w0e,d0e,v0e,m0e,_0e,p0e,E0e,S0e,g0e,y0e,F0e,O0e,A0e,M0e,R0e,N0e,T0e,L0e,D0e,C0e,P0e,B0e,I0e,H0e,x0e,U0e,z0e,j0e,V0e,q0e,Y0e,G0e,W0e,K0e,X0e,Z0e,J0e,Q0e,$0e,e1e,i1e,r1e,n1e,dh,f1e,t1e,u1e,a1e,o1e,c1e,l1e,s1e,b1e,k1e,h1e,w1e,d1e,v1e,m1e,_1e,p1e,E1e,S1e,g1e,y1e,F1e,O1e,A1e,M1e,R1e,N1e,T1e,L1e,Gh,D1e,C1e,P1e,B1e,I1e,H1e,x1e,U1e,z1e,sH,j1e,V1e,q1e,Y1e,G1e,W1e,K1e,X1e,Z1e,J1e,Q1e,$1e,e2e,i2e,r2e,n2e,f2e,t2e,u2e,a2e,o2e,c2e,l2e,Gz,s2e,b2e,k2e,h2e,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe,uXe];var OAi=[w2e,d2e,v2e,m2e,_2e,p2e,E2e,S2e,g2e,y2e,F2e,O2e,A2e,M2e,R2e,N2e,T2e,L2e,D2e,C2e,P2e,B2e,I2e,H2e,x2e,U2e,z2e,j2e,V2e,q2e,Y2e,G2e,W2e,K2e,X2e,Z2e,J2e,Q2e,$2e,e3e,i3e,r3e,n3e,f3e,t3e,u3e,a3e,o3e,c3e,l3e,s3e,b3e,k3e,h3e,w3e,d3e,v3e,m3e,_3e,p3e,E3e,S3e,g3e,y3e,F3e,O3e,A3e,M3e,R3e,N3e,T3e,L3e,D3e,C3e,P3e,B3e,I3e,H3e,x3e,U3e,z3e,j3e,V3e,q3e,Y3e,G3e,W3e,K3e,X3e,Z3e,J3e,Q3e,$3e,e4e,i4e,r4e,n4e,f4e,t4e,u4e,a4e,o4e,c4e,l4e,s4e,b4e,k4e,h4e,w4e,d4e,v4e,m4e,_4e,p4e,E4e,S4e,g4e,y4e,F4e,O4e,A4e,M4e,R4e,N4e,T4e,L4e,D4e,C4e,P4e,B4e,I4e,H4e,x4e,U4e,z4e,j4e,V4e,q4e,Y4e,G4e,W4e,K4e,X4e,Z4e,J4e,Q4e,$4e,e8e,i8e,r8e,n8e,f8e,t8e,u8e,a8e,o8e,c8e,l8e,s8e,b8e,k8e,h8e,w8e,d8e,v8e,m8e,_8e,p8e,E8e,S8e,g8e,y8e,F8e,O8e,A8e,M8e,R8e,N8e,T8e,L8e,D8e,C8e,P8e,B8e,I8e,H8e,x8e,U8e,z8e,j8e,V8e,q8e,Y8e,G8e,W8e,K8e,X8e,Z8e,J8e,Q8e,$8e,e6e,i6e,r6e,n6e,f6e,t6e,u6e,a6e,o6e,c6e,l6e,s6e,Z_,J_,Q_,$_,ep,ip,N_,T_,rp,np,dN,b6e,k6e,h6e,w6e,d6e,v6e,m6e,_6e,p6e,E6e,S6e,g6e,y6e,F6e,O6e,A6e,M6e,_A,R6e,N6e,T6e,L6e,D6e,C6e,P6e,B6e,I6e,H6e,x6e,U6e,z6e,j6e,V6e,q6e,Y6e,G6e,W6e,K6e,X6e,Z6e,J6e,Q6e,$6e,e5e,i5e,r5e,n5e,f5e,t5e,u5e,a5e,o5e,c5e,l5e,s5e,b5e,k5e,h5e,w5e,d5e,v5e,m5e,_5e,p5e,E5e,S5e,g5e,y5e,F5e,O5e,A5e,M5e,R5e,N5e,T5e,L5e,D5e,C5e,P5e,B5e,I5e,H5e,x5e,U5e,z5e,j5e,V5e,q5e,Y5e,G5e,W5e,K5e,X5e,Z5e,J5e,Q5e,$5e,e9e,i9e,r9e,n9e,f9e,t9e,u9e,a9e,o9e,c9e,l9e,s9e,b9e,k9e,h9e,w9e,d9e,v9e,m9e,_9e,p9e,E9e,S9e,g9e,y9e,F9e,O9e,A9e,M9e,R9e,N9e,T9e,L9e,D9e,C9e,P9e,B9e,I9e,H9e,x9e,U9e,z9e,j9e,V9e,q9e,Y9e,G9e,W9e,K9e,X9e,Z9e,J9e,Q9e,$9e,e7e,i7e,r7e,n7e,f7e,t7e,u7e,a7e,o7e,c7e,l7e,s7e,b7e,k7e,PV,h7e,w7e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e,w2e];var AAi=[d7e,v7e,m7e,_7e,p7e,E7e,S7e,Um,g7e,y7e,F7e,O7e,A7e,M7e,R7e,N7e,T7e,L7e,D7e,C7e,P7e,B7e,I7e,H7e,x7e,U7e,z7e,j7e,V7e,q7e,Y7e,G7e,W7e,K7e,X7e,Z7e,J7e,Q7e,$7e,eei,iei,rei,Bz,nei,fei,tei,uei,aei,oei,cei,lei,sei,bei,kei,hei,wei,dei,vei,mei,_ei,pei,Eei,Sei,gei,yei,Fei,Oei,Aei,Mei,Rei,Nei,Tei,Lei,Dei,Cei,Pei,Bei,Iei,Hei,xei,Uei,zei,jei,Vei,qei,Yei,Gei,Wei,Kei,Xei,Zei,Jei,Qei,$ei,eii,iii,rii,nii,fii,tii,uii,aii,oii,cii,lii,sii,bii,kii,hii,wii,dii,vii,mii,_ii,pii,Eii,Sii,gii,yii,Fii,Oii,Aii,Mii,Rii,Nii,Tii,Lii,Dii,Cii,Pii,Bii,Iii,Hii,xii,Uii,zii,jii,Vii,qii,Yii,Gii,Wii,Kii,Xii,Zii,Jii,Qii,$ii,eri,iri,rri,nri,fri,tri,uri,ari,ori,cri,lri,sri,bri,kri,hri,wri,dri,vri,mri,_ri,pri,Eri,Sri,gri,yri,Fri,Ori,Ari,Mri,Rri,Nri,Tri,Lri,Dri,Cri,Pri,Bri,Iri,Hri,xri,Uri,zri,jri,Vri,qri,Yri,Gri,Wri,Kri,Xri,Zri,Jri,Qri,$ri,eni,ini,rni,nni,fni,tni,uni,ani,oni,cni,lni,sni,bni,kni,hni,wni,dni,vni,mni,_ni,pni,Eni,Sni,gni,yni,Fni,Oni,Ani,Mni,Rni,Nni,Tni,Lni,Dni,Cni,Pni,Bni,Ini,Hni,xni,Uni,zni,jni,Vni,qni,Yni,Gni,Wni,Kni,Xni,Zni,Jni,Qni,$ni,efi,ifi,rfi,nfi,ffi,tfi,ufi,afi,ofi,cfi,lfi,sfi,bfi,kfi,hfi,wfi,dfi,vfi,mfi,_fi,pfi,Efi,Sfi,gfi,yfi,Ffi,Ofi,Afi,Mfi,Rfi,Nfi,Tfi,Lfi,Dfi,Cfi,Pfi,Bfi,Ifi,Hfi,xfi,Ufi,zfi,jfi,Vfi,qfi,Yfi,Gfi,Wfi,Kfi,Xfi,Zfi,Jfi,Qfi,$fi,eti,iti,rti,nti,fti,tti,uti,ati,oti,cti,lti,sti,bti,kti,hti,wti,dti,vti,mti,_ti,pti,Eti,Sti,gti,Ah,yti,Fti,Oti,Ati,Mti,Rti,Nti,Tti,Lti,Dti,Cti,Pti,Bti,Iti,Hti,xti,Uti,zti,jti,Vti,qti,Yti,Gti,Wti,Kti,Xti,Zti,Jti,Qti,$ti,eui,iui,rui,nui,fui,tui,uui,aui,oui,cui,lui,sui,bui,kui,hui,wui,dui,vui,mui,_ui,pui,Eui,Sui,gui,yui,Fui,Oui,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e,d7e];
	var MAi=[Aui,Mui,Rui,Nui,Tui,Lui,xm,Dui,Cui,Pui,Bui,Iui,Hui,xui,Uui,zui,jui,Vui,qui,Yui,Gui,Wui,Kui,Xui,Zui,r_,Jui,Qui,$ui,eai,iai,rai,nai,Jq,fai,tai,uai,aai,oai,cai,lai,Cz,sai,bai,kai,hai,wai,dai,vai,mai,_ai,pai,Eai,Sai,gai,yai,Fai,Oai,Pz,Aai,Mai,Rai,Nai,Tai,Lai,Dai,Cai,Pai,Bai,Iai,Hai,xai,Uai,zai,jai,Vai,qai,Yai,Gai,Wai,Kai,Xai,Zai,Jai,Qai,$ai,eoi,ioi,roi,noi,foi,toi,uoi,aoi,ooi,coi,loi,soi,boi,koi,hoi,woi,doi,voi,moi,_oi,poi,Eoi,Soi,goi,yoi,Foi,Ooi,Aoi,Moi,Roi,Noi,Toi,Loi,Doi,Coi,Poi,Boi,Ioi,Hoi,xoi,Uoi,zoi,joi,Voi,qoi,Yoi,Goi,Woi,Koi,Xoi,Zoi,Joi,Qoi,$oi,eci,ici,rci,nci,fci,tci,uci,aci,oci,cci,lci,sci,bci,kci,hci,wci,dci,vci,mci,_ci,pci,Eci,Sci,gci,yci,Fci,Oci,Aci,Mci,Rci,Nci,Tci,Lci,Dci,Cci,Pci,Bci,Ici,Hci,xci,Uci,zci,jci,Vci,qci,Yci,Gci,Wci,Kci,Xci,Zci,Jci,Qci,$ci,eli,ili,rli,cm,nli,fli,tli,uli,ali,oli,cli,lli,sli,bli,kli,hli,wli,dli,vli,mli,_li,pli,Eli,Sli,gli,yli,Fli,Oli,Ali,Mli,Rli,Nli,Tli,Lli,Dli,Cli,Pli,Bli,Ili,Hli,xli,Uli,zli,jli,Vli,qli,Yli,Gli,Wli,Kli,Xli,Zli,Jli,Qli,$li,esi,isi,UR,rsi,nsi,fsi,tsi,usi,asi,lN,osi,csi,lsi,ssi,bsi,ksi,hsi,wsi,dsi,vsi,msi,_si,psi,Esi,Ssi,gsi,ysi,Fsi,Osi,Asi,Msi,Rsi,Nsi,Tsi,Lsi,Dsi,Csi,Psi,Bsi,Isi,Hsi,Pf,Bf,zf,xsi,ea,Tf,Lf,Df,xf,If,Uf,Cf,ia,Hf,Nf,Cn,Usi,zsi,jsi,Vsi,qsi,Ysi,Gsi,Wsi,Ksi,Xsi,Zsi,Jsi,Ll,Bl,Hl,jl,Qsi,$si,ebi,ibi,rbi,nbi,fbi,tbi,ubi,abi,obi,Oh,cbi,lbi,sbi,bbi,kbi,hbi,wbi,dbi,vbi,mbi,_bi,pbi,Ebi,Uh,Sbi,gbi,ybi,Fbi,Obi,Abi,Mbi,Rbi,Nbi,Tbi,Lbi,Dbi,Cbi,Pbi,Bbi,Ibi,Hbi,xbi,Ubi,zbi,jbi,Vbi,qbi,Ybi,ex,Gbi,Wbi,Kbi,Xbi,ux,Zbi,Jbi,Qbi,$bi,eki,iki,rki,nki,fki,tki,uki,aki,Rq,oki,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui,Aui];var RAi=[cki,lki,ski,bki,kki,hki,wki,dki,vki,mki,_ki,pki,Eki,Ski,gki,yki,Fki,Oki,Aki,Mki,Rki,Nki,Tki,Lki,Dki,Cki,Pki,Bki,Iki,Hki,xki,Uki,zki,jki,Vki,qki,Yki,Gki,Wki,Kki,Xki,Zki,Jki,Qki,$ki,ehi,ihi,rhi,nhi,fhi,thi,uhi,ahi,ohi,chi,lhi,shi,bhi,khi,hhi,whi,dhi,vhi,mhi,_hi,phi,Ehi,Shi,ghi,yhi,Fhi,Ohi,Ahi,Mhi,Rhi,Nhi,Thi,Lhi,Dhi,Chi,Phi,Bhi,Ihi,Hhi,xhi,Uhi,zhi,jhi,Vhi,qhi,Yhi,Ghi,Whi,Khi,Xhi,Zhi,Jhi,Qhi,$hi,ewi,iwi,rwi,nwi,fwi,twi,uwi,awi,owi,cwi,lwi,swi,bwi,kwi,hwi,wwi,dwi,vwi,mwi,_wi,pwi,Ewi,Swi,gwi,ywi,Fwi,Owi,Awi,Mwi,Rwi,Nwi,Twi,Lwi,Dwi,Cwi,Pwi,Bwi,Iwi,Hwi,xwi,Uwi,zwi,jwi,Vwi,qwi,Ywi,Gwi,Wwi,Kwi,Xwi,Zwi,Jwi,Qwi,$wi,edi,idi,rdi,ndi,fdi,tdi,udi,adi,odi,cdi,ldi,sdi,bdi,kdi,hdi,wdi,ddi,vdi,mdi,_di,pdi,Edi,Sdi,gdi,ydi,Fdi,Odi,Adi,Mdi,Rdi,Ndi,Tdi,Ldi,Ddi,Cdi,Pdi,Bdi,Idi,Hdi,xdi,Udi,zdi,jdi,Vdi,qdi,Ydi,Gdi,Wdi,Kdi,Xdi,Zdi,Jdi,Qdi,$di,evi,ivi,rvi,nvi,fvi,tvi,uvi,avi,ovi,cvi,lvi,svi,bvi,kvi,hvi,wvi,dvi,vvi,mvi,_vi,pvi,Evi,Svi,gvi,yvi,Fvi,Ovi,Avi,Mvi,Rvi,Nvi,Tvi,Lvi,Dvi,Cvi,Pvi,Bvi,Ivi,Hvi,xvi,Uvi,zvi,jvi,Vvi,qvi,Yvi,Gvi,Wvi,Kvi,Xvi,Zvi,Jvi,Qvi,$vi,emi,imi,rmi,nmi,fmi,tmi,umi,ami,omi,cmi,lmi,smi,bmi,kmi,hmi,wmi,dmi,vmi,mmi,_mi,pmi,Emi,Smi,gmi,ymi,Fmi,Omi,Ami,Mmi,Rmi,Nmi,Tmi,Lmi,Dmi,Cmi,Pmi,Bmi,Imi,Hmi,xmi,Umi,zmi,jmi,Vmi,qmi,Ymi,Gmi,Wmi,Kmi,Xmi,Zmi,Jmi,Qmi,$mi,e_i,i_i,r_i,n_i,f_i,t_i,u_i,a_i,o_i,c_i,l_i,s_i,b_i,k_i,h_i,w_i,d_i,v_i,m_i,__i,p_i,E_i,S_i,g_i,y_i,F_i,O_i,A_i,M_i,R_i,N_i,T_i,L_i,D_i,C_i,P_i,B_i,I_i,H_i,x_i,U_i,z_i,j_i,V_i,q_i,Y_i,G_i,W_i,K_i,X_i,Z_i,J_i,Q_i,$_i,epi,ipi,rpi,npi,ix,fpi,tpi,upi,api,ax,opi,cpi,lpi,spi,bpi,kpi,hpi,wpi,dpi,vpi,mpi,_pi,ppi,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki,cki];var NAi=[Epi,Cm,Spi,gpi,ypi,Fpi,Opi,Api,zm,Mpi,Vm,Rpi,Npi,Tpi,Lpi,Dpi,Cpi,Ppi,Bpi,Ipi,Hpi,xpi,Upi,zpi,jpi,Vpi,qpi,f_,Ypi,u_,Gpi,Wpi,Kpi,Xpi,Zpi,Jpi,Tz,Qpi,$pi,eEi,iEi,rEi,nEi,xz,fEi,Hz,tEi,uEi,aEi,oEi,cEi,lEi,sEi,bEi,kEi,hEi,wEi,dEi,vEi,mEi,Lz,_Ei,pEi,EEi,SEi,gEi,yEi,FEi,OEi,AEi,MEi,REi,NEi,TEi,LEi,DEi,CEi,PEi,BEi,IEi,HEi,xEi,UEi,zEi,jEi,VEi,qEi,YEi,GEi,WEi,KEi,XEi,ZEi,JEi,QEi,$Ei,eSi,iSi,rSi,nSi,fSi,tSi,uSi,aSi,oSi,cSi,lSi,sSi,bSi,kSi,hSi,wSi,dSi,vSi,mSi,_Si,pSi,ESi,SSi,gSi,ySi,FSi,OSi,ASi,MSi,RSi,NSi,TSi,LSi,DSi,CSi,PSi,BSi,ISi,HSi,xSi,USi,zSi,jSi,VSi,qSi,YSi,GSi,WSi,KSi,XSi,ZSi,JSi,QSi,$Si,egi,igi,rgi,ngi,fgi,tgi,ugi,agi,ogi,cgi,lgi,sgi,bgi,kgi,hgi,wgi,dgi,vgi,mgi,_gi,pgi,Egi,Sgi,ggi,ygi,Fgi,Ogi,Agi,Mgi,Rgi,Ngi,Tgi,Lgi,Dgi,Cgi,Pgi,Bgi,Igi,Hgi,xgi,Ugi,zgi,jgi,Vgi,qgi,Ygi,Ggi,Wgi,Kgi,Xgi,Zgi,Jgi,Qgi,$gi,eyi,iyi,ryi,nyi,fyi,tyi,uyi,ayi,oyi,cyi,lyi,syi,byi,kyi,hyi,wyi,dyi,vyi,myi,_yi,pyi,Eyi,Syi,gyi,yyi,Fyi,Oyi,Ayi,Myi,Ryi,Nyi,Tyi,Lyi,Dyi,Cyi,Pyi,Byi,Iyi,Hyi,xyi,Uyi,zyi,jyi,Vyi,qyi,Yyi,Gyi,Wyi,Kyi,Xyi,Zyi,Jyi,Qyi,$yi,eFi,iFi,rFi,nFi,fFi,tFi,uFi,aFi,oFi,cFi,lFi,sFi,bFi,kFi,hFi,wFi,dFi,vFi,mFi,_Fi,pFi,EFi,SFi,gFi,yFi,FFi,OFi,AFi,MFi,RFi,NFi,TFi,LFi,DFi,CFi,PFi,BFi,IFi,HFi,xFi,UFi,zFi,jFi,VFi,qFi,YFi,GFi,WFi,KFi,XFi,ZFi,JFi,QFi,$Fi,eOi,iOi,rOi,nOi,fOi,tOi,uOi,aOi,oOi,cOi,lOi,sOi,vh,bOi,kOi,hOi,Eh,wOi,dOi,vOi,mOi,_Oi,pOi,Mh,EOi,Nh,SOi,gOi,yOi,FOi,OOi,AOi,MOi,ROi,NOi,TOi,zh,LOi,DOi,COi,POi,BOi,Wh,IOi,HOi,xOi,qv,UOi,zOi,jOi,VOi,qOi,bH,YOi,GOi,WOi,KOi,XOi,ZOi,JOi,QOi,$Oi,eAi,iAi,rAi,nAi,fAi,tAi,uAi,aAi,_x,oAi,cAi,GU,lAi,sAi,Wz,bAi,kAi,hAi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi,Epi];return{_i64Subtract:BY,_strcat:xY,_free:Zq,_main:fm,_realloc:Jq,_strncpy:zY,_memmove:GY,_bitshift64Ashr:IY,_strlen:HY,_memset:VY,_malloc:Xq,_i64Add:jY,_memcpy:YY,_llvm_ctlz_i32:KY,_bitshift64Lshr:qY,_strcpy:WY,_bitshift64Shl:UY,runPostSets:PY,stackAlloc:Zv,stackSave:Jv,stackRestore:Qv,setThrew:$v,setTempRet0:rm,getTempRet0:nm,dynCall_iiiiiiii:nG,dynCall_iiii:fG,dynCall_viiiiiii:tG,dynCall_viiiii:uG,dynCall_i:aG,dynCall_vi:oG,dynCall_vii:cG,dynCall_iiiiiii:lG,dynCall_ii:sG,dynCall_viii:bG,dynCall_viiiiiiiii:kG,dynCall_iiiii:hG,dynCall_viiiiii:wG,dynCall_iii:dG,dynCall_iiiiii:vG,dynCall_viiii:mG}}(Module.asmGlobalArg,Module.asmLibraryArg,buffer),_i64Subtract=Module._i64Subtract=asm._i64Subtract,_strcat=Module._strcat=asm._strcat,_free=Module._free=asm._free,_main=Module._main=asm._main,_realloc=Module._realloc=asm._realloc,_strncpy=Module._strncpy=asm._strncpy,_memmove=Module._memmove=asm._memmove,_bitshift64Ashr=Module._bitshift64Ashr=asm._bitshift64Ashr,_strlen=Module._strlen=asm._strlen,_memset=Module._memset=asm._memset,_malloc=Module._malloc=asm._malloc,_i64Add=Module._i64Add=asm._i64Add,_memcpy=Module._memcpy=asm._memcpy,_llvm_ctlz_i32=Module._llvm_ctlz_i32=asm._llvm_ctlz_i32,_bitshift64Lshr=Module._bitshift64Lshr=asm._bitshift64Lshr,_strcpy=Module._strcpy=asm._strcpy,_bitshift64Shl=Module._bitshift64Shl=asm._bitshift64Shl,runPostSets=Module.runPostSets=asm.runPostSets,dynCall_iiiiiiii=Module.dynCall_iiiiiiii=asm.dynCall_iiiiiiii,dynCall_iiii=Module.dynCall_iiii=asm.dynCall_iiii,dynCall_viiiiiii=Module.dynCall_viiiiiii=asm.dynCall_viiiiiii,dynCall_viiiii=Module.dynCall_viiiii=asm.dynCall_viiiii,dynCall_i=Module.dynCall_i=asm.dynCall_i,dynCall_vi=Module.dynCall_vi=asm.dynCall_vi,dynCall_vii=Module.dynCall_vii=asm.dynCall_vii,dynCall_iiiiiii=Module.dynCall_iiiiiii=asm.dynCall_iiiiiii,dynCall_ii=Module.dynCall_ii=asm.dynCall_ii,dynCall_viii=Module.dynCall_viii=asm.dynCall_viii,dynCall_viiiiiiiii=Module.dynCall_viiiiiiiii=asm.dynCall_viiiiiiiii,dynCall_iiiii=Module.dynCall_iiiii=asm.dynCall_iiiii,dynCall_viiiiii=Module.dynCall_viiiiii=asm.dynCall_viiiiii,dynCall_iii=Module.dynCall_iii=asm.dynCall_iii,dynCall_iiiiii=Module.dynCall_iiiiii=asm.dynCall_iiiiii,dynCall_viiii=Module.dynCall_viiii=asm.dynCall_viiii;Runtime.stackAlloc=asm.stackAlloc,Runtime.stackSave=asm.stackSave,Runtime.stackRestore=asm.stackRestore,Runtime.setTempRet0=asm.setTempRet0,Runtime.getTempRet0=asm.getTempRet0;var i64Math=function(){function e(e,i,r){null!=e&&("number"==typeof e?this.fromNumber(e,i,r):null==i&&"string"!=typeof e?this.fromString(e,256):this.fromString(e,i))}function i(){return new e(null)}function r(e,i,r,n,f,t){for(;--t>=0;){var u=i*this[e++]+r[n]+f;f=Math.floor(u/67108864),r[n++]=67108863&u}return f}function n(e,i,r,n,f,t){for(var u=32767&i,a=i>>15;--t>=0;){var o=32767&this[e],c=this[e++]>>15,l=a*o+c*u;o=u*o+((32767&l)<<15)+r[n]+(1073741823&f),f=(o>>>30)+(l>>>15)+a*c+(f>>>30),r[n++]=1073741823&o}return f}function f(e,i,r,n,f,t){for(var u=16383&i,a=i>>14;--t>=0;){var o=16383&this[e],c=this[e++]>>14,l=a*o+c*u;o=u*o+((16383&l)<<14)+r[n]+f,f=(o>>28)+(l>>14)+a*c,r[n++]=268435455&o}return f}function t(e){return te.charAt(e)}function u(e,i){var r=ue[e.charCodeAt(i)];return null==r?-1:r}function a(e){for(var i=this.t-1;i>=0;--i)e[i]=this[i];e.t=this.t,e.s=this.s}function o(e){this.t=1,this.s=e<0?-1:0,e>0?this[0]=e:e<-1?this[0]=e+DV:this.t=0}function c(e){var r=i();return r.fromInt(e),r}function l(i,r){var n;if(16==r)n=4;else if(8==r)n=3;else if(256==r)n=8;else if(2==r)n=1;else if(32==r)n=5;else{if(4!=r)return void this.fromRadix(i,r);n=2}this.t=0,this.s=0;for(var f=i.length,t=!1,a=0;--f>=0;){var o=8==n?255&i[f]:u(i,f);o<0?"-"==i.charAt(f)&&(t=!0):(t=!1,0==a?this[this.t++]=o:a+n>this.DB?(this[this.t-1]|=(o&(1<<this.DB-a)-1)<<a,this[this.t++]=o>>this.DB-a):this[this.t-1]|=o<<a,a+=n,a>=this.DB&&(a-=this.DB))}8==n&&0!=(128&i[0])&&(this.s=-1,a>0&&(this[this.t-1]|=(1<<this.DB-a)-1<<a)),this.clamp(),t&&e.ZERO.subTo(this,this)}function s(){for(var e=this.s&this.DM;this.t>0&&this[this.t-1]==e;)--this.t}function b(e){if(this.s<0)return"-"+this.negate().toString(e);var i;if(16==e)i=4;else if(8==e)i=3;else if(2==e)i=1;else if(32==e)i=5;else{if(4!=e)return this.toRadix(e);i=2}var r,n=(1<<i)-1,f=!1,u="",a=this.t,o=this.DB-a*this.DB%i;if(a-- >0)for(o<this.DB&&(r=this[a]>>o)>0&&(f=!0,u=t(r));a>=0;)o<i?(r=(this[a]&(1<<o)-1)<<i-o,r|=this[--a]>>(o+=this.DB-i)):(r=this[a]>>(o-=i)&n,o<=0&&(o+=this.DB,--a)),r>0&&(f=!0),f&&(u+=t(r));return f?u:"0"}function k(){var r=i();return e.ZERO.subTo(this,r),r}function h(){return this.s<0?this.negate():this}function w(e){var i=this.s-e.s;if(0!=i)return i;var r=this.t;if(i=r-e.t,0!=i)return this.s<0?-i:i;for(;--r>=0;)if(0!=(i=this[r]-e[r]))return i;return 0}function d(e){var i,r=1;return 0!=(i=e>>>16)&&(e=i,r+=16),0!=(i=e>>8)&&(e=i,r+=8),0!=(i=e>>4)&&(e=i,r+=4),0!=(i=e>>2)&&(e=i,r+=2),0!=(i=e>>1)&&(e=i,r+=1),r}function v(){return this.t<=0?0:this.DB*(this.t-1)+d(this[this.t-1]^this.s&this.DM)}function m(e,i){var r;for(r=this.t-1;r>=0;--r)i[r+e]=this[r];for(r=e-1;r>=0;--r)i[r]=0;i.t=this.t+e,i.s=this.s}function _(e,i){for(var r=e;r<this.t;++r)i[r-e]=this[r];i.t=Math.max(this.t-e,0),i.s=this.s}function p(e,i){var r,n=e%this.DB,f=this.DB-n,t=(1<<f)-1,u=Math.floor(e/this.DB),a=this.s<<n&this.DM;for(r=this.t-1;r>=0;--r)i[r+u+1]=this[r]>>f|a,a=(this[r]&t)<<n;for(r=u-1;r>=0;--r)i[r]=0;i[u]=a,i.t=this.t+u+1,i.s=this.s,i.clamp()}function E(e,i){i.s=this.s;var r=Math.floor(e/this.DB);if(r>=this.t)return void(i.t=0);var n=e%this.DB,f=this.DB-n,t=(1<<n)-1;i[0]=this[r]>>n;for(var u=r+1;u<this.t;++u)i[u-r-1]|=(this[u]&t)<<f,i[u-r]=this[u]>>n;n>0&&(i[this.t-r-1]|=(this.s&t)<<f),i.t=this.t-r,i.clamp()}function S(e,i){for(var r=0,n=0,f=Math.min(e.t,this.t);r<f;)n+=this[r]-e[r],i[r++]=n&this.DM,n>>=this.DB;if(e.t<this.t){for(n-=e.s;r<this.t;)n+=this[r],i[r++]=n&this.DM,n>>=this.DB;n+=this.s}else{for(n+=this.s;r<e.t;)n-=e[r],i[r++]=n&this.DM,n>>=this.DB;n-=e.s}i.s=n<0?-1:0,n<-1?i[r++]=this.DV+n:n>0&&(i[r++]=n),i.t=r,i.clamp()}function g(i,r){var n=this.abs(),f=i.abs(),t=n.t;for(r.t=t+f.t;--t>=0;)r[t]=0;for(t=0;t<f.t;++t)r[t+n.t]=n.am(0,f[t],r,t,0,n.t);r.s=0,r.clamp(),this.s!=i.s&&e.ZERO.subTo(r,r)}function y(e){for(var i=this.abs(),r=e.t=2*i.t;--r>=0;)e[r]=0;for(r=0;r<i.t-1;++r){var n=i.am(r,i[r],e,2*r,0,1);(e[r+i.t]+=i.am(r+1,2*i[r],e,2*r+1,n,i.t-r-1))>=i.DV&&(e[r+i.t]-=i.DV,e[r+i.t+1]=1)}e.t>0&&(e[e.t-1]+=i.am(r,i[r],e,2*r,0,1)),e.s=0,e.clamp()}function F(r,n,f){var t=r.abs();if(!(t.t<=0)){var u=this.abs();if(u.t<t.t)return null!=n&&n.fromInt(0),void(null!=f&&this.copyTo(f));null==f&&(f=i());var a=i(),o=this.s,c=r.s,l=this.DB-d(t[t.t-1]);l>0?(t.lShiftTo(l,a),u.lShiftTo(l,f)):(t.copyTo(a),u.copyTo(f));var s=a.t,b=a[s-1];if(0!=b){var k=b*(1<<this.F1)+(s>1?a[s-2]>>this.F2:0),h=this.FV/k,w=(1<<this.F1)/k,v=1<<this.F2,m=f.t,_=m-s,p=null==n?i():n;for(a.dlShiftTo(_,p),f.compareTo(p)>=0&&(f[f.t++]=1,f.subTo(p,f)),e.ONE.dlShiftTo(s,p),p.subTo(a,a);a.t<s;)a[a.t++]=0;for(;--_>=0;){var E=f[--m]==b?this.DM:Math.floor(f[m]*h+(f[m-1]+v)*w);if((f[m]+=a.am(0,E,f,_,0,s))<E)for(a.dlShiftTo(_,p),f.subTo(p,f);f[m]<--E;)f.subTo(p,f)}null!=n&&(f.drShiftTo(s,n),o!=c&&e.ZERO.subTo(n,n)),f.t=s,f.clamp(),l>0&&f.rShiftTo(l,f),o<0&&e.ZERO.subTo(f,f)}}}function O(r){var n=i();return this.abs().divRemTo(r,null,n),this.s<0&&n.compareTo(e.ZERO)>0&&r.subTo(n,n),n}function A(e){this.m=e}function M(e){return e.s<0||e.compareTo(this.m)>=0?e.mod(this.m):e}function R(e){return e}function N(e){e.divRemTo(this.m,null,e)}function T(e,i,r){e.multiplyTo(i,r),this.reduce(r)}function L(e,i){e.squareTo(i),this.reduce(i)}function D(){if(this.t<1)return 0;var e=this[0];if(0==(1&e))return 0;var i=3&e;return i=i*(2-(15&e)*i)&15,i=i*(2-(255&e)*i)&255,i=i*(2-((65535&e)*i&65535))&65535,i=i*(2-e*i%this.DV)%this.DV,i>0?this.DV-i:-i}function C(e){this.m=e,this.mp=e.invDigit(),this.mpl=32767&this.mp,this.mph=this.mp>>15,this.um=(1<<e.DB-15)-1,this.mt2=2*e.t}function P(r){var n=i();return r.abs().dlShiftTo(this.m.t,n),n.divRemTo(this.m,null,n),r.s<0&&n.compareTo(e.ZERO)>0&&this.m.subTo(n,n),n}function B(e){var r=i();return e.copyTo(r),this.reduce(r),r}function I(e){for(;e.t<=this.mt2;)e[e.t++]=0;for(var i=0;i<this.m.t;++i){var r=32767&e[i],n=r*this.mpl+((r*this.mph+(e[i]>>15)*this.mpl&this.um)<<15)&e.DM;for(r=i+this.m.t,e[r]+=this.m.am(0,n,e,i,0,this.m.t);e[r]>=e.DV;)e[r]-=e.DV,e[++r]++}e.clamp(),e.drShiftTo(this.m.t,e),e.compareTo(this.m)>=0&&e.subTo(this.m,e)}function H(e,i){e.squareTo(i),this.reduce(i)}function x(e,i,r){e.multiplyTo(i,r),this.reduce(r)}function U(){return 0==(this.t>0?1&this[0]:this.s)}function z(r,n){if(r>4294967295||r<1)return e.ONE;var f=i(),t=i(),u=n.convert(this),a=d(r)-1;for(u.copyTo(f);--a>=0;)if(n.sqrTo(f,t),(r&1<<a)>0)n.mulTo(t,u,f);else{var o=f;f=t,t=o}return n.revert(f)}function j(e,i){var r;return r=e<256||i.isEven()?new A(i):new C(i),this.exp(e,r)}function V(i,r){this.fromInt(0),null==r&&(r=10);for(var n=this.chunkSize(r),f=Math.pow(r,n),t=!1,a=0,o=0,c=0;c<i.length;++c){var l=u(i,c);l<0?"-"==i.charAt(c)&&0==this.signum()&&(t=!0):(o=r*o+l,++a>=n&&(this.dMultiply(f),this.dAddOffset(o,0),a=0,o=0))}a>0&&(this.dMultiply(Math.pow(r,a)),this.dAddOffset(o,0)),t&&e.ZERO.subTo(this,this)}function q(e){return Math.floor(Math.LN2*this.DB/Math.log(e))}function Y(){return this.s<0?-1:this.t<=0||1==this.t&&this[0]<=0?0:1}function G(e){this[this.t]=this.am(0,e-1,this,0,0,this.t),++this.t,this.clamp()}function W(e,i){if(0!=e){for(;this.t<=i;)this[this.t++]=0;for(this[i]+=e;this[i]>=this.DV;)this[i]-=this.DV,++i>=this.t&&(this[this.t++]=0),++this[i]}}function K(e){if(null==e&&(e=10),0==this.signum()||e<2||e>36)return"0";var r=this.chunkSize(e),n=Math.pow(e,r),f=c(n),t=i(),u=i(),a="";for(this.divRemTo(f,t,u);t.signum()>0;)a=(n+u.intValue()).toString(e).substr(1)+a,t.divRemTo(f,t,u);return u.intValue().toString(e)+a}function X(){if(this.s<0){if(1==this.t)return this[0]-this.DV;if(0==this.t)return-1}else{if(1==this.t)return this[0];if(0==this.t)return 0}return(this[1]&(1<<32-this.DB)-1)<<this.DB|this[0]}function Z(e,i){for(var r=0,n=0,f=Math.min(e.t,this.t);r<f;)n+=this[r]+e[r],i[r++]=n&this.DM,n>>=this.DB;if(e.t<this.t){for(n+=e.s;r<this.t;)n+=this[r],i[r++]=n&this.DM,n>>=this.DB;n+=this.s}else{for(n+=this.s;r<e.t;)n+=e[r],i[r++]=n&this.DM,n>>=this.DB;n+=e.s}i.s=n<0?-1:0,n>0?i[r++]=n:n<-1&&(i[r++]=this.DV+n),i.t=r,i.clamp()}var J={math:{}};J.math.Long=function(e,i){this.low_=0|e,this.high_=0|i},J.math.Long.IntCache_={},J.math.Long.fromInt=function(e){if(-128<=e&&e<128){var i=J.math.Long.IntCache_[e];if(i)return i}var r=new J.math.Long(0|e,e<0?-1:0);return-128<=e&&e<128&&(J.math.Long.IntCache_[e]=r),r},J.math.Long.fromNumber=function(e){return isNaN(e)||!isFinite(e)?J.math.Long.ZERO:e<=-J.math.Long.TWO_PWR_63_DBL_?J.math.Long.MIN_VALUE:e+1>=J.math.Long.TWO_PWR_63_DBL_?J.math.Long.MAX_VALUE:e<0?J.math.Long.fromNumber(-e).negate():new J.math.Long(e%J.math.Long.TWO_PWR_32_DBL_|0,e/J.math.Long.TWO_PWR_32_DBL_|0)},J.math.Long.fromBits=function(e,i){return new J.math.Long(e,i)},J.math.Long.fromString=function(e,i){if(0==e.length)throw Error("number format error: empty string");var r=i||10;if(r<2||36<r)throw Error("radix out of range: "+r);if("-"==e.charAt(0))return J.math.Long.fromString(e.substring(1),r).negate();if(e.indexOf("-")>=0)throw Error('number format error: interior "-" character: '+e);for(var n=J.math.Long.fromNumber(Math.pow(r,8)),f=J.math.Long.ZERO,t=0;t<e.length;t+=8){var u=Math.min(8,e.length-t),a=parseInt(e.substring(t,t+u),r);if(u<8){var o=J.math.Long.fromNumber(Math.pow(r,u));f=f.multiply(o).add(J.math.Long.fromNumber(a))}else f=f.multiply(n),f=f.add(J.math.Long.fromNumber(a))}return f},J.math.Long.TWO_PWR_16_DBL_=65536,J.math.Long.TWO_PWR_24_DBL_=1<<24,J.math.Long.TWO_PWR_32_DBL_=J.math.Long.TWO_PWR_16_DBL_*J.math.Long.TWO_PWR_16_DBL_,J.math.Long.TWO_PWR_31_DBL_=J.math.Long.TWO_PWR_32_DBL_/2,J.math.Long.TWO_PWR_48_DBL_=J.math.Long.TWO_PWR_32_DBL_*J.math.Long.TWO_PWR_16_DBL_,J.math.Long.TWO_PWR_64_DBL_=J.math.Long.TWO_PWR_32_DBL_*J.math.Long.TWO_PWR_32_DBL_,J.math.Long.TWO_PWR_63_DBL_=J.math.Long.TWO_PWR_64_DBL_/2,J.math.Long.ZERO=J.math.Long.fromInt(0),J.math.Long.ONE=J.math.Long.fromInt(1),J.math.Long.NEG_ONE=J.math.Long.fromInt(-1),J.math.Long.MAX_VALUE=J.math.Long.fromBits(-1,2147483647),J.math.Long.MIN_VALUE=J.math.Long.fromBits(0,-2147483648),J.math.Long.TWO_PWR_24_=J.math.Long.fromInt(1<<24),J.math.Long.prototype.toInt=function(){return this.low_},J.math.Long.prototype.toNumber=function(){return this.high_*J.math.Long.TWO_PWR_32_DBL_+this.getLowBitsUnsigned()},J.math.Long.prototype.toString=function(e){var i=e||10;if(i<2||36<i)throw Error("radix out of range: "+i);if(this.isZero())return"0";if(this.isNegative()){if(this.equals(J.math.Long.MIN_VALUE)){var r=J.math.Long.fromNumber(i),n=this.div(r),f=n.multiply(r).subtract(this);return n.toString(i)+f.toInt().toString(i)}return"-"+this.negate().toString(i)}for(var t=J.math.Long.fromNumber(Math.pow(i,6)),f=this,u="";;){var a=f.div(t),o=f.subtract(a.multiply(t)).toInt(),c=o.toString(i);if(f=a,f.isZero())return c+u;for(;c.length<6;)c="0"+c;u=""+c+u}},J.math.Long.prototype.getHighBits=function(){return this.high_},J.math.Long.prototype.getLowBits=function(){return this.low_},J.math.Long.prototype.getLowBitsUnsigned=function(){return this.low_>=0?this.low_:J.math.Long.TWO_PWR_32_DBL_+this.low_},J.math.Long.prototype.getNumBitsAbs=function(){if(this.isNegative())return this.equals(J.math.Long.MIN_VALUE)?64:this.negate().getNumBitsAbs();for(var e=0!=this.high_?this.high_:this.low_,i=31;i>0&&0==(e&1<<i);i--);return 0!=this.high_?i+33:i+1},J.math.Long.prototype.isZero=function(){return 0==this.high_&&0==this.low_},J.math.Long.prototype.isNegative=function(){return this.high_<0},J.math.Long.prototype.isOdd=function(){return 1==(1&this.low_)},J.math.Long.prototype.equals=function(e){return this.high_==e.high_&&this.low_==e.low_},J.math.Long.prototype.notEquals=function(e){return this.high_!=e.high_||this.low_!=e.low_},J.math.Long.prototype.lessThan=function(e){return this.compare(e)<0},J.math.Long.prototype.lessThanOrEqual=function(e){return this.compare(e)<=0},J.math.Long.prototype.greaterThan=function(e){return this.compare(e)>0},J.math.Long.prototype.greaterThanOrEqual=function(e){return this.compare(e)>=0},J.math.Long.prototype.compare=function(e){if(this.equals(e))return 0;var i=this.isNegative(),r=e.isNegative();return i&&!r?-1:!i&&r?1:this.subtract(e).isNegative()?-1:1},J.math.Long.prototype.negate=function(){return this.equals(J.math.Long.MIN_VALUE)?J.math.Long.MIN_VALUE:this.not().add(J.math.Long.ONE)},J.math.Long.prototype.add=function(e){var i=this.high_>>>16,r=65535&this.high_,n=this.low_>>>16,f=65535&this.low_,t=e.high_>>>16,u=65535&e.high_,a=e.low_>>>16,o=65535&e.low_,c=0,l=0,s=0,b=0;return b+=f+o,s+=b>>>16,b&=65535,s+=n+a,l+=s>>>16,s&=65535,l+=r+u,c+=l>>>16,l&=65535,c+=i+t,c&=65535,J.math.Long.fromBits(s<<16|b,c<<16|l)},J.math.Long.prototype.subtract=function(e){return this.add(e.negate())},J.math.Long.prototype.multiply=function(e){if(this.isZero())return J.math.Long.ZERO;if(e.isZero())return J.math.Long.ZERO;if(this.equals(J.math.Long.MIN_VALUE))return e.isOdd()?J.math.Long.MIN_VALUE:J.math.Long.ZERO;if(e.equals(J.math.Long.MIN_VALUE))return this.isOdd()?J.math.Long.MIN_VALUE:J.math.Long.ZERO;if(this.isNegative())return e.isNegative()?this.negate().multiply(e.negate()):this.negate().multiply(e).negate();if(e.isNegative())return this.multiply(e.negate()).negate();if(this.lessThan(J.math.Long.TWO_PWR_24_)&&e.lessThan(J.math.Long.TWO_PWR_24_))return J.math.Long.fromNumber(this.toNumber()*e.toNumber());var i=this.high_>>>16,r=65535&this.high_,n=this.low_>>>16,f=65535&this.low_,t=e.high_>>>16,u=65535&e.high_,a=e.low_>>>16,o=65535&e.low_,c=0,l=0,s=0,b=0;return b+=f*o,s+=b>>>16,b&=65535,s+=n*o,l+=s>>>16,s&=65535,s+=f*a,l+=s>>>16,s&=65535,l+=r*o,c+=l>>>16,l&=65535,l+=n*a,c+=l>>>16,l&=65535,l+=f*u,c+=l>>>16,l&=65535,c+=i*o+r*a+n*u+f*t,c&=65535,J.math.Long.fromBits(s<<16|b,c<<16|l)},J.math.Long.prototype.div=function(e){if(e.isZero())throw Error("division by zero");if(this.isZero())return J.math.Long.ZERO;if(this.equals(J.math.Long.MIN_VALUE)){if(e.equals(J.math.Long.ONE)||e.equals(J.math.Long.NEG_ONE))return J.math.Long.MIN_VALUE;if(e.equals(J.math.Long.MIN_VALUE))return J.math.Long.ONE;var i=this.shiftRight(1),r=i.div(e).shiftLeft(1);if(r.equals(J.math.Long.ZERO))return e.isNegative()?J.math.Long.ONE:J.math.Long.NEG_ONE;var n=this.subtract(e.multiply(r)),f=r.add(n.div(e));return f}if(e.equals(J.math.Long.MIN_VALUE))return J.math.Long.ZERO;if(this.isNegative())return e.isNegative()?this.negate().div(e.negate()):this.negate().div(e).negate();if(e.isNegative())return this.div(e.negate()).negate();for(var t=J.math.Long.ZERO,n=this;n.greaterThanOrEqual(e);){for(var r=Math.max(1,Math.floor(n.toNumber()/e.toNumber())),u=Math.ceil(Math.log(r)/Math.LN2),a=u<=48?1:Math.pow(2,u-48),o=J.math.Long.fromNumber(r),c=o.multiply(e);c.isNegative()||c.greaterThan(n);)r-=a,o=J.math.Long.fromNumber(r),c=o.multiply(e);o.isZero()&&(o=J.math.Long.ONE),t=t.add(o),n=n.subtract(c)}return t},J.math.Long.prototype.modulo=function(e){return this.subtract(this.div(e).multiply(e))},J.math.Long.prototype.not=function(){return J.math.Long.fromBits(~this.low_,~this.high_)},J.math.Long.prototype.and=function(e){return J.math.Long.fromBits(this.low_&e.low_,this.high_&e.high_)},J.math.Long.prototype.or=function(e){return J.math.Long.fromBits(this.low_|e.low_,this.high_|e.high_)},J.math.Long.prototype.xor=function(e){return J.math.Long.fromBits(this.low_^e.low_,this.high_^e.high_)},J.math.Long.prototype.shiftLeft=function(e){if(e&=63,0==e)return this;var i=this.low_;if(e<32){var r=this.high_;return J.math.Long.fromBits(i<<e,r<<e|i>>>32-e)}return J.math.Long.fromBits(0,i<<e-32)},J.math.Long.prototype.shiftRight=function(e){if(e&=63,0==e)return this;var i=this.high_;if(e<32){var r=this.low_;return J.math.Long.fromBits(r>>>e|i<<32-e,i>>e)}return J.math.Long.fromBits(i>>e-32,i>=0?0:-1)},J.math.Long.prototype.shiftRightUnsigned=function(e){if(e&=63,0==e)return this;var i=this.high_;if(e<32){var r=this.low_;return J.math.Long.fromBits(r>>>e|i<<32-e,i>>>e)}return 32==e?J.math.Long.fromBits(i,0):J.math.Long.fromBits(i>>>e-32,0)};var Q,$={appName:"Modern Browser"},ee=0xdeadbeefcafe,ie=15715070==(16777215&ee);ie&&"Microsoft Internet Explorer"==$.appName?(e.prototype.am=n,Q=30):ie&&"Netscape"!=$.appName?(e.prototype.am=r,Q=26):(e.prototype.am=f,Q=28),e.prototype.DB=Q,e.prototype.DM=(1<<Q)-1,e.prototype.DV=1<<Q;var re=52;e.prototype.FV=Math.pow(2,re),e.prototype.F1=re-Q,e.prototype.F2=2*Q-re;var ne,fe,te="0123456789abcdefghijklmnopqrstuvwxyz",ue=new Array;for(ne="0".charCodeAt(0),fe=0;fe<=9;++fe)ue[ne++]=fe;for(ne="a".charCodeAt(0),fe=10;fe<36;++fe)ue[ne++]=fe;for(ne="A".charCodeAt(0),fe=10;fe<36;++fe)ue[ne++]=fe;A.prototype.convert=M,A.prototype.revert=R,A.prototype.reduce=N,A.prototype.mulTo=T,A.prototype.sqrTo=L,C.prototype.convert=P,C.prototype.revert=B,C.prototype.reduce=I,C.prototype.mulTo=x,C.prototype.sqrTo=H,e.prototype.copyTo=a,e.prototype.fromInt=o,e.prototype.fromString=l,e.prototype.clamp=s,e.prototype.dlShiftTo=m,e.prototype.drShiftTo=_,e.prototype.lShiftTo=p,e.prototype.rShiftTo=E,e.prototype.subTo=S,e.prototype.multiplyTo=g,e.prototype.squareTo=y,e.prototype.divRemTo=F,e.prototype.invDigit=D,e.prototype.isEven=U,e.prototype.exp=z,e.prototype.toString=b,e.prototype.negate=k,e.prototype.abs=h,e.prototype.compareTo=w,e.prototype.bitLength=v,e.prototype.mod=O,e.prototype.modPowInt=j,e.ZERO=c(0),e.ONE=c(1),e.prototype.fromRadix=V,e.prototype.chunkSize=q,e.prototype.signum=Y,e.prototype.dMultiply=G,e.prototype.dAddOffset=W,e.prototype.toRadix=K,e.prototype.intValue=X,e.prototype.addTo=Z;var ae={abs:function(e,i){var r,n=new J.math.Long(e,i);r=n.isNegative()?n.negate():n,HEAP32[tempDoublePtr>>2]=r.low_,HEAP32[tempDoublePtr+4>>2]=r.high_},ensureTemps:function(){ae.ensuredTemps||(ae.ensuredTemps=!0,ae.two32=new e,ae.two32.fromString("4294967296",10),ae.two64=new e,ae.two64.fromString("18446744073709551616",10),ae.temp1=new e,ae.temp2=new e)},lh2bignum:function(i,r){var n=new e;n.fromString(r.toString(),10);var f=new e;n.multiplyTo(ae.two32,f);var t=new e;t.fromString(i.toString(),10);var u=new e;return t.addTo(f,u),u},stringify:function(i,r,n){var f=new J.math.Long(i,r).toString();if(n&&"-"==f[0]){ae.ensureTemps();var t=new e;t.fromString(f,10),f=new e,ae.two64.addTo(t,f),f=f.toString(10)}return f},fromString:function(i,r,n,f,t){ae.ensureTemps();var u=new e;u.fromString(i,r);var a=new e;a.fromString(n,10);var o=new e;if(o.fromString(f,10),t&&u.compareTo(e.ZERO)<0){var c=new e;u.addTo(ae.two64,c),u=c}var l=!1;u.compareTo(a)<0?(u=a,l=!0):u.compareTo(o)>0&&(u=o,l=!0);var s=J.math.Long.fromString(u.toString());if(HEAP32[tempDoublePtr>>2]=s.low_,HEAP32[tempDoublePtr+4>>2]=s.high_,l)throw"range error"}};return ae}();memoryInitializer&&("function"==typeof Module.locateFile?memoryInitializer=Module.locateFile(memoryInitializer):Module.memoryInitializerPrefixURL&&(memoryInitializer=Module.memoryInitializerPrefixURL+memoryInitializer),addRunDependency("memory initializer"),Browser.asyncLoad(memoryInitializer,function(e){HEAPU8.set(e,STATIC_BASE),removeRunDependency("memory initializer")},function(e){throw"could not load memory initializer "+memoryInitializer})),ExitStatus.prototype=new Error,ExitStatus.prototype.constructor=ExitStatus;var initialStackTop,preloadStartTime=null,calledMain=!1;if(dependenciesFulfilled=function e(){!Module.calledRun&&shouldRunNow&&run(),Module.calledRun||(dependenciesFulfilled=e)},Module.callMain=Module.callMain=function(e){function i(){for(var e=0;e<3;e++)n.push(0)}assert(0==runDependencies,"cannot call main when async dependencies remain! (listen on __ATMAIN__)"),assert(0==__ATPRERUN__.length,"cannot call main when preRun functions remain to be called"),e=e||[],ensureInitRuntime();var r=e.length+1,n=[allocate(intArrayFromString(Module.thisProgram),"i8",ALLOC_NORMAL)];i();for(var f=0;f<r-1;f+=1)n.push(allocate(intArrayFromString(e[f]),"i8",ALLOC_NORMAL)),i();n.push(0),n=allocate(n,"i32",ALLOC_NORMAL),initialStackTop=STACKTOP;try{var t=Module._main(r,n,0);exit(t)}catch(e){if(e instanceof ExitStatus)return;if("SimulateInfiniteLoop"==e)return void(Module.noExitRuntime=!0);throw e&&"object"==typeof e&&e.stack&&Module.printErr("exception thrown: "+[e,e.stack]),e}finally{calledMain=!0}},Module.run=Module.run=run,Module.exit=Module.exit=exit,Module.abort=Module.abort=abort,Module.preInit)for("function"==typeof Module.preInit&&(Module.preInit=[Module.preInit]);Module.preInit.length>0;)Module.preInit.pop()();var shouldRunNow=!0;return Module.noInitialRun&&(shouldRunNow=!1),run(),Module.return=Module.return.split("\n").slice(0,-2),{errors:Module.return.length?Module.return:null}}}(),module.exports=xmllint;
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2).Buffer))

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer, global) {/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */
	/* eslint-disable no-proto */

	'use strict'

	var base64 = __webpack_require__(5)
	var ieee754 = __webpack_require__(3)
	var isArray = __webpack_require__(4)

	exports.Buffer = Buffer
	exports.SlowBuffer = SlowBuffer
	exports.INSPECT_MAX_BYTES = 50
	Buffer.poolSize = 8192 // not used by this implementation

	var rootParent = {}

	/**
	 * If `Buffer.TYPED_ARRAY_SUPPORT`:
	 *   === true    Use Uint8Array implementation (fastest)
	 *   === false   Use Object implementation (most compatible, even IE6)
	 *
	 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
	 * Opera 11.6+, iOS 4.2+.
	 *
	 * Due to various browser bugs, sometimes the Object implementation will be used even
	 * when the browser supports typed arrays.
	 *
	 * Note:
	 *
	 *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
	 *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
	 *
	 *   - Safari 5-7 lacks support for changing the `Object.prototype.constructor` property
	 *     on objects.
	 *
	 *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
	 *
	 *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
	 *     incorrect length in some situations.

	 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
	 * get the Object implementation, which is slower but behaves correctly.
	 */
	Buffer.TYPED_ARRAY_SUPPORT = global.TYPED_ARRAY_SUPPORT !== undefined
	  ? global.TYPED_ARRAY_SUPPORT
	  : typedArraySupport()

	function typedArraySupport () {
	  function Bar () {}
	  try {
	    var arr = new Uint8Array(1)
	    arr.foo = function () { return 42 }
	    arr.constructor = Bar
	    return arr.foo() === 42 && // typed array instances can be augmented
	        arr.constructor === Bar && // constructor can be set
	        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
	        arr.subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
	  } catch (e) {
	    return false
	  }
	}

	function kMaxLength () {
	  return Buffer.TYPED_ARRAY_SUPPORT
	    ? 0x7fffffff
	    : 0x3fffffff
	}

	/**
	 * Class: Buffer
	 * =============
	 *
	 * The Buffer constructor returns instances of `Uint8Array` that are augmented
	 * with function properties for all the node `Buffer` API functions. We use
	 * `Uint8Array` so that square bracket notation works as expected -- it returns
	 * a single octet.
	 *
	 * By augmenting the instances, we can avoid modifying the `Uint8Array`
	 * prototype.
	 */
	function Buffer (arg) {
	  if (!(this instanceof Buffer)) {
	    // Avoid going through an ArgumentsAdaptorTrampoline in the common case.
	    if (arguments.length > 1) return new Buffer(arg, arguments[1])
	    return new Buffer(arg)
	  }

	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    this.length = 0
	    this.parent = undefined
	  }

	  // Common case.
	  if (typeof arg === 'number') {
	    return fromNumber(this, arg)
	  }

	  // Slightly less common case.
	  if (typeof arg === 'string') {
	    return fromString(this, arg, arguments.length > 1 ? arguments[1] : 'utf8')
	  }

	  // Unusual.
	  return fromObject(this, arg)
	}

	function fromNumber (that, length) {
	  that = allocate(that, length < 0 ? 0 : checked(length) | 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < length; i++) {
	      that[i] = 0
	    }
	  }
	  return that
	}

	function fromString (that, string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') encoding = 'utf8'

	  // Assumption: byteLength() return value is always < kMaxLength.
	  var length = byteLength(string, encoding) | 0
	  that = allocate(that, length)

	  that.write(string, encoding)
	  return that
	}

	function fromObject (that, object) {
	  if (Buffer.isBuffer(object)) return fromBuffer(that, object)

	  if (isArray(object)) return fromArray(that, object)

	  if (object == null) {
	    throw new TypeError('must start with number, buffer, array or string')
	  }

	  if (typeof ArrayBuffer !== 'undefined') {
	    if (object.buffer instanceof ArrayBuffer) {
	      return fromTypedArray(that, object)
	    }
	    if (object instanceof ArrayBuffer) {
	      return fromArrayBuffer(that, object)
	    }
	  }

	  if (object.length) return fromArrayLike(that, object)

	  return fromJsonObject(that, object)
	}

	function fromBuffer (that, buffer) {
	  var length = checked(buffer.length) | 0
	  that = allocate(that, length)
	  buffer.copy(that, 0, 0, length)
	  return that
	}

	function fromArray (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	// Duplicate of fromArray() to keep fromArray() monomorphic.
	function fromTypedArray (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  // Truncating the elements is probably not what people expect from typed
	  // arrays with BYTES_PER_ELEMENT > 1 but it's compatible with the behavior
	  // of the old Buffer constructor.
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	function fromArrayBuffer (that, array) {
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    array.byteLength
	    that = Buffer._augment(new Uint8Array(array))
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that = fromTypedArray(that, new Uint8Array(array))
	  }
	  return that
	}

	function fromArrayLike (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	// Deserialize { type: 'Buffer', data: [1,2,3,...] } into a Buffer object.
	// Returns a zero-length buffer for inputs that don't conform to the spec.
	function fromJsonObject (that, object) {
	  var array
	  var length = 0

	  if (object.type === 'Buffer' && isArray(object.data)) {
	    array = object.data
	    length = checked(array.length) | 0
	  }
	  that = allocate(that, length)

	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	if (Buffer.TYPED_ARRAY_SUPPORT) {
	  Buffer.prototype.__proto__ = Uint8Array.prototype
	  Buffer.__proto__ = Uint8Array
	} else {
	  // pre-set for values that may exist in the future
	  Buffer.prototype.length = undefined
	  Buffer.prototype.parent = undefined
	}

	function allocate (that, length) {
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = Buffer._augment(new Uint8Array(length))
	    that.__proto__ = Buffer.prototype
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that.length = length
	    that._isBuffer = true
	  }

	  var fromPool = length !== 0 && length <= Buffer.poolSize >>> 1
	  if (fromPool) that.parent = rootParent

	  return that
	}

	function checked (length) {
	  // Note: cannot use `length < kMaxLength` here because that fails when
	  // length is NaN (which is otherwise coerced to zero.)
	  if (length >= kMaxLength()) {
	    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
	                         'size: 0x' + kMaxLength().toString(16) + ' bytes')
	  }
	  return length | 0
	}

	function SlowBuffer (subject, encoding) {
	  if (!(this instanceof SlowBuffer)) return new SlowBuffer(subject, encoding)

	  var buf = new Buffer(subject, encoding)
	  delete buf.parent
	  return buf
	}

	Buffer.isBuffer = function isBuffer (b) {
	  return !!(b != null && b._isBuffer)
	}

	Buffer.compare = function compare (a, b) {
	  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
	    throw new TypeError('Arguments must be Buffers')
	  }

	  if (a === b) return 0

	  var x = a.length
	  var y = b.length

	  var i = 0
	  var len = Math.min(x, y)
	  while (i < len) {
	    if (a[i] !== b[i]) break

	    ++i
	  }

	  if (i !== len) {
	    x = a[i]
	    y = b[i]
	  }

	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}

	Buffer.isEncoding = function isEncoding (encoding) {
	  switch (String(encoding).toLowerCase()) {
	    case 'hex':
	    case 'utf8':
	    case 'utf-8':
	    case 'ascii':
	    case 'binary':
	    case 'base64':
	    case 'raw':
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return true
	    default:
	      return false
	  }
	}

	Buffer.concat = function concat (list, length) {
	  if (!isArray(list)) throw new TypeError('list argument must be an Array of Buffers.')

	  if (list.length === 0) {
	    return new Buffer(0)
	  }

	  var i
	  if (length === undefined) {
	    length = 0
	    for (i = 0; i < list.length; i++) {
	      length += list[i].length
	    }
	  }

	  var buf = new Buffer(length)
	  var pos = 0
	  for (i = 0; i < list.length; i++) {
	    var item = list[i]
	    item.copy(buf, pos)
	    pos += item.length
	  }
	  return buf
	}

	function byteLength (string, encoding) {
	  if (typeof string !== 'string') string = '' + string

	  var len = string.length
	  if (len === 0) return 0

	  // Use a for loop to avoid recursion
	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'ascii':
	      case 'binary':
	      // Deprecated
	      case 'raw':
	      case 'raws':
	        return len
	      case 'utf8':
	      case 'utf-8':
	        return utf8ToBytes(string).length
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return len * 2
	      case 'hex':
	        return len >>> 1
	      case 'base64':
	        return base64ToBytes(string).length
	      default:
	        if (loweredCase) return utf8ToBytes(string).length // assume utf8
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}
	Buffer.byteLength = byteLength

	function slowToString (encoding, start, end) {
	  var loweredCase = false

	  start = start | 0
	  end = end === undefined || end === Infinity ? this.length : end | 0

	  if (!encoding) encoding = 'utf8'
	  if (start < 0) start = 0
	  if (end > this.length) end = this.length
	  if (end <= start) return ''

	  while (true) {
	    switch (encoding) {
	      case 'hex':
	        return hexSlice(this, start, end)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Slice(this, start, end)

	      case 'ascii':
	        return asciiSlice(this, start, end)

	      case 'binary':
	        return binarySlice(this, start, end)

	      case 'base64':
	        return base64Slice(this, start, end)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return utf16leSlice(this, start, end)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = (encoding + '').toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	Buffer.prototype.toString = function toString () {
	  var length = this.length | 0
	  if (length === 0) return ''
	  if (arguments.length === 0) return utf8Slice(this, 0, length)
	  return slowToString.apply(this, arguments)
	}

	Buffer.prototype.equals = function equals (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return true
	  return Buffer.compare(this, b) === 0
	}

	Buffer.prototype.inspect = function inspect () {
	  var str = ''
	  var max = exports.INSPECT_MAX_BYTES
	  if (this.length > 0) {
	    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
	    if (this.length > max) str += ' ... '
	  }
	  return '<Buffer ' + str + '>'
	}

	Buffer.prototype.compare = function compare (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return 0
	  return Buffer.compare(this, b)
	}

	Buffer.prototype.indexOf = function indexOf (val, byteOffset) {
	  if (byteOffset > 0x7fffffff) byteOffset = 0x7fffffff
	  else if (byteOffset < -0x80000000) byteOffset = -0x80000000
	  byteOffset >>= 0

	  if (this.length === 0) return -1
	  if (byteOffset >= this.length) return -1

	  // Negative offsets start from the end of the buffer
	  if (byteOffset < 0) byteOffset = Math.max(this.length + byteOffset, 0)

	  if (typeof val === 'string') {
	    if (val.length === 0) return -1 // special case: looking for empty string always fails
	    return String.prototype.indexOf.call(this, val, byteOffset)
	  }
	  if (Buffer.isBuffer(val)) {
	    return arrayIndexOf(this, val, byteOffset)
	  }
	  if (typeof val === 'number') {
	    if (Buffer.TYPED_ARRAY_SUPPORT && Uint8Array.prototype.indexOf === 'function') {
	      return Uint8Array.prototype.indexOf.call(this, val, byteOffset)
	    }
	    return arrayIndexOf(this, [ val ], byteOffset)
	  }

	  function arrayIndexOf (arr, val, byteOffset) {
	    var foundIndex = -1
	    for (var i = 0; byteOffset + i < arr.length; i++) {
	      if (arr[byteOffset + i] === val[foundIndex === -1 ? 0 : i - foundIndex]) {
	        if (foundIndex === -1) foundIndex = i
	        if (i - foundIndex + 1 === val.length) return byteOffset + foundIndex
	      } else {
	        foundIndex = -1
	      }
	    }
	    return -1
	  }

	  throw new TypeError('val must be string, number or Buffer')
	}

	// `get` is deprecated
	Buffer.prototype.get = function get (offset) {
	  console.log('.get() is deprecated. Access using array indexes instead.')
	  return this.readUInt8(offset)
	}

	// `set` is deprecated
	Buffer.prototype.set = function set (v, offset) {
	  console.log('.set() is deprecated. Access using array indexes instead.')
	  return this.writeUInt8(v, offset)
	}

	function hexWrite (buf, string, offset, length) {
	  offset = Number(offset) || 0
	  var remaining = buf.length - offset
	  if (!length) {
	    length = remaining
	  } else {
	    length = Number(length)
	    if (length > remaining) {
	      length = remaining
	    }
	  }

	  // must be an even number of digits
	  var strLen = string.length
	  if (strLen % 2 !== 0) throw new Error('Invalid hex string')

	  if (length > strLen / 2) {
	    length = strLen / 2
	  }
	  for (var i = 0; i < length; i++) {
	    var parsed = parseInt(string.substr(i * 2, 2), 16)
	    if (isNaN(parsed)) throw new Error('Invalid hex string')
	    buf[offset + i] = parsed
	  }
	  return i
	}

	function utf8Write (buf, string, offset, length) {
	  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
	}

	function asciiWrite (buf, string, offset, length) {
	  return blitBuffer(asciiToBytes(string), buf, offset, length)
	}

	function binaryWrite (buf, string, offset, length) {
	  return asciiWrite(buf, string, offset, length)
	}

	function base64Write (buf, string, offset, length) {
	  return blitBuffer(base64ToBytes(string), buf, offset, length)
	}

	function ucs2Write (buf, string, offset, length) {
	  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
	}

	Buffer.prototype.write = function write (string, offset, length, encoding) {
	  // Buffer#write(string)
	  if (offset === undefined) {
	    encoding = 'utf8'
	    length = this.length
	    offset = 0
	  // Buffer#write(string, encoding)
	  } else if (length === undefined && typeof offset === 'string') {
	    encoding = offset
	    length = this.length
	    offset = 0
	  // Buffer#write(string, offset[, length][, encoding])
	  } else if (isFinite(offset)) {
	    offset = offset | 0
	    if (isFinite(length)) {
	      length = length | 0
	      if (encoding === undefined) encoding = 'utf8'
	    } else {
	      encoding = length
	      length = undefined
	    }
	  // legacy write(string, encoding, offset, length) - remove in v0.13
	  } else {
	    var swap = encoding
	    encoding = offset
	    offset = length | 0
	    length = swap
	  }

	  var remaining = this.length - offset
	  if (length === undefined || length > remaining) length = remaining

	  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
	    throw new RangeError('attempt to write outside buffer bounds')
	  }

	  if (!encoding) encoding = 'utf8'

	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'hex':
	        return hexWrite(this, string, offset, length)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Write(this, string, offset, length)

	      case 'ascii':
	        return asciiWrite(this, string, offset, length)

	      case 'binary':
	        return binaryWrite(this, string, offset, length)

	      case 'base64':
	        // Warning: maxLength not taken into account in base64Write
	        return base64Write(this, string, offset, length)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return ucs2Write(this, string, offset, length)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	Buffer.prototype.toJSON = function toJSON () {
	  return {
	    type: 'Buffer',
	    data: Array.prototype.slice.call(this._arr || this, 0)
	  }
	}

	function base64Slice (buf, start, end) {
	  if (start === 0 && end === buf.length) {
	    return base64.fromByteArray(buf)
	  } else {
	    return base64.fromByteArray(buf.slice(start, end))
	  }
	}

	function utf8Slice (buf, start, end) {
	  end = Math.min(buf.length, end)
	  var res = []

	  var i = start
	  while (i < end) {
	    var firstByte = buf[i]
	    var codePoint = null
	    var bytesPerSequence = (firstByte > 0xEF) ? 4
	      : (firstByte > 0xDF) ? 3
	      : (firstByte > 0xBF) ? 2
	      : 1

	    if (i + bytesPerSequence <= end) {
	      var secondByte, thirdByte, fourthByte, tempCodePoint

	      switch (bytesPerSequence) {
	        case 1:
	          if (firstByte < 0x80) {
	            codePoint = firstByte
	          }
	          break
	        case 2:
	          secondByte = buf[i + 1]
	          if ((secondByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)
	            if (tempCodePoint > 0x7F) {
	              codePoint = tempCodePoint
	            }
	          }
	          break
	        case 3:
	          secondByte = buf[i + 1]
	          thirdByte = buf[i + 2]
	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)
	            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
	              codePoint = tempCodePoint
	            }
	          }
	          break
	        case 4:
	          secondByte = buf[i + 1]
	          thirdByte = buf[i + 2]
	          fourthByte = buf[i + 3]
	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)
	            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
	              codePoint = tempCodePoint
	            }
	          }
	      }
	    }

	    if (codePoint === null) {
	      // we did not generate a valid codePoint so insert a
	      // replacement char (U+FFFD) and advance only 1 byte
	      codePoint = 0xFFFD
	      bytesPerSequence = 1
	    } else if (codePoint > 0xFFFF) {
	      // encode to utf16 (surrogate pair dance)
	      codePoint -= 0x10000
	      res.push(codePoint >>> 10 & 0x3FF | 0xD800)
	      codePoint = 0xDC00 | codePoint & 0x3FF
	    }

	    res.push(codePoint)
	    i += bytesPerSequence
	  }

	  return decodeCodePointsArray(res)
	}

	// Based on http://stackoverflow.com/a/22747272/680742, the browser with
	// the lowest limit is Chrome, with 0x10000 args.
	// We go 1 magnitude less, for safety
	var MAX_ARGUMENTS_LENGTH = 0x1000

	function decodeCodePointsArray (codePoints) {
	  var len = codePoints.length
	  if (len <= MAX_ARGUMENTS_LENGTH) {
	    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
	  }

	  // Decode in chunks to avoid "call stack size exceeded".
	  var res = ''
	  var i = 0
	  while (i < len) {
	    res += String.fromCharCode.apply(
	      String,
	      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
	    )
	  }
	  return res
	}

	function asciiSlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; i++) {
	    ret += String.fromCharCode(buf[i] & 0x7F)
	  }
	  return ret
	}

	function binarySlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; i++) {
	    ret += String.fromCharCode(buf[i])
	  }
	  return ret
	}

	function hexSlice (buf, start, end) {
	  var len = buf.length

	  if (!start || start < 0) start = 0
	  if (!end || end < 0 || end > len) end = len

	  var out = ''
	  for (var i = start; i < end; i++) {
	    out += toHex(buf[i])
	  }
	  return out
	}

	function utf16leSlice (buf, start, end) {
	  var bytes = buf.slice(start, end)
	  var res = ''
	  for (var i = 0; i < bytes.length; i += 2) {
	    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
	  }
	  return res
	}

	Buffer.prototype.slice = function slice (start, end) {
	  var len = this.length
	  start = ~~start
	  end = end === undefined ? len : ~~end

	  if (start < 0) {
	    start += len
	    if (start < 0) start = 0
	  } else if (start > len) {
	    start = len
	  }

	  if (end < 0) {
	    end += len
	    if (end < 0) end = 0
	  } else if (end > len) {
	    end = len
	  }

	  if (end < start) end = start

	  var newBuf
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    newBuf = Buffer._augment(this.subarray(start, end))
	  } else {
	    var sliceLen = end - start
	    newBuf = new Buffer(sliceLen, undefined)
	    for (var i = 0; i < sliceLen; i++) {
	      newBuf[i] = this[i + start]
	    }
	  }

	  if (newBuf.length) newBuf.parent = this.parent || this

	  return newBuf
	}

	/*
	 * Need to make sure that buffer isn't trying to write out of bounds.
	 */
	function checkOffset (offset, ext, length) {
	  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
	  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
	}

	Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }

	  return val
	}

	Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    checkOffset(offset, byteLength, this.length)
	  }

	  var val = this[offset + --byteLength]
	  var mul = 1
	  while (byteLength > 0 && (mul *= 0x100)) {
	    val += this[offset + --byteLength] * mul
	  }

	  return val
	}

	Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  return this[offset]
	}

	Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return this[offset] | (this[offset + 1] << 8)
	}

	Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return (this[offset] << 8) | this[offset + 1]
	}

	Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return ((this[offset]) |
	      (this[offset + 1] << 8) |
	      (this[offset + 2] << 16)) +
	      (this[offset + 3] * 0x1000000)
	}

	Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] * 0x1000000) +
	    ((this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    this[offset + 3])
	}

	Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var i = byteLength
	  var mul = 1
	  var val = this[offset + --i]
	  while (i > 0 && (mul *= 0x100)) {
	    val += this[offset + --i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  if (!(this[offset] & 0x80)) return (this[offset])
	  return ((0xff - this[offset] + 1) * -1)
	}

	Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset] | (this[offset + 1] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset + 1] | (this[offset] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset]) |
	    (this[offset + 1] << 8) |
	    (this[offset + 2] << 16) |
	    (this[offset + 3] << 24)
	}

	Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] << 24) |
	    (this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    (this[offset + 3])
	}

	Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, true, 23, 4)
	}

	Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, false, 23, 4)
	}

	Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, true, 52, 8)
	}

	Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, false, 52, 8)
	}

	function checkInt (buf, value, offset, ext, max, min) {
	  if (!Buffer.isBuffer(buf)) throw new TypeError('buffer must be a Buffer instance')
	  if (value > max || value < min) throw new RangeError('value is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('index out of range')
	}

	Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)

	  var mul = 1
	  var i = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)

	  var i = byteLength - 1
	  var mul = 1
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  this[offset] = (value & 0xff)
	  return offset + 1
	}

	function objectWriteUInt16 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; i++) {
	    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
	      (littleEndian ? i : 1 - i) * 8
	  }
	}

	Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = (value & 0xff)
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	function objectWriteUInt32 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffffffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; i++) {
	    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
	  }
	}

	Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset + 3] = (value >>> 24)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 1] = (value >>> 8)
	    this[offset] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = 0
	  var mul = 1
	  var sub = value < 0 ? 1 : 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = byteLength - 1
	  var mul = 1
	  var sub = value < 0 ? 1 : 0
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  if (value < 0) value = 0xff + value + 1
	  this[offset] = (value & 0xff)
	  return offset + 1
	}

	Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = (value & 0xff)
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value & 0xff)
	    this[offset + 1] = (value >>> 8)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 3] = (value >>> 24)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (value < 0) value = 0xffffffff + value + 1
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = (value & 0xff)
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	function checkIEEE754 (buf, value, offset, ext, max, min) {
	  if (value > max || value < min) throw new RangeError('value is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('index out of range')
	  if (offset < 0) throw new RangeError('index out of range')
	}

	function writeFloat (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 23, 4)
	  return offset + 4
	}

	Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, false, noAssert)
	}

	function writeDouble (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 52, 8)
	  return offset + 8
	}

	Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, false, noAssert)
	}

	// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
	Buffer.prototype.copy = function copy (target, targetStart, start, end) {
	  if (!start) start = 0
	  if (!end && end !== 0) end = this.length
	  if (targetStart >= target.length) targetStart = target.length
	  if (!targetStart) targetStart = 0
	  if (end > 0 && end < start) end = start

	  // Copy 0 bytes; we're done
	  if (end === start) return 0
	  if (target.length === 0 || this.length === 0) return 0

	  // Fatal error conditions
	  if (targetStart < 0) {
	    throw new RangeError('targetStart out of bounds')
	  }
	  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
	  if (end < 0) throw new RangeError('sourceEnd out of bounds')

	  // Are we oob?
	  if (end > this.length) end = this.length
	  if (target.length - targetStart < end - start) {
	    end = target.length - targetStart + start
	  }

	  var len = end - start
	  var i

	  if (this === target && start < targetStart && targetStart < end) {
	    // descending copy from end
	    for (i = len - 1; i >= 0; i--) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
	    // ascending copy from start
	    for (i = 0; i < len; i++) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else {
	    target._set(this.subarray(start, start + len), targetStart)
	  }

	  return len
	}

	// fill(value, start=0, end=buffer.length)
	Buffer.prototype.fill = function fill (value, start, end) {
	  if (!value) value = 0
	  if (!start) start = 0
	  if (!end) end = this.length

	  if (end < start) throw new RangeError('end < start')

	  // Fill 0 bytes; we're done
	  if (end === start) return
	  if (this.length === 0) return

	  if (start < 0 || start >= this.length) throw new RangeError('start out of bounds')
	  if (end < 0 || end > this.length) throw new RangeError('end out of bounds')

	  var i
	  if (typeof value === 'number') {
	    for (i = start; i < end; i++) {
	      this[i] = value
	    }
	  } else {
	    var bytes = utf8ToBytes(value.toString())
	    var len = bytes.length
	    for (i = start; i < end; i++) {
	      this[i] = bytes[i % len]
	    }
	  }

	  return this
	}

	/**
	 * Creates a new `ArrayBuffer` with the *copied* memory of the buffer instance.
	 * Added in Node 0.12. Only available in browsers that support ArrayBuffer.
	 */
	Buffer.prototype.toArrayBuffer = function toArrayBuffer () {
	  if (typeof Uint8Array !== 'undefined') {
	    if (Buffer.TYPED_ARRAY_SUPPORT) {
	      return (new Buffer(this)).buffer
	    } else {
	      var buf = new Uint8Array(this.length)
	      for (var i = 0, len = buf.length; i < len; i += 1) {
	        buf[i] = this[i]
	      }
	      return buf.buffer
	    }
	  } else {
	    throw new TypeError('Buffer.toArrayBuffer not supported in this browser')
	  }
	}

	// HELPER FUNCTIONS
	// ================

	var BP = Buffer.prototype

	/**
	 * Augment a Uint8Array *instance* (not the Uint8Array class!) with Buffer methods
	 */
	Buffer._augment = function _augment (arr) {
	  arr.constructor = Buffer
	  arr._isBuffer = true

	  // save reference to original Uint8Array set method before overwriting
	  arr._set = arr.set

	  // deprecated
	  arr.get = BP.get
	  arr.set = BP.set

	  arr.write = BP.write
	  arr.toString = BP.toString
	  arr.toLocaleString = BP.toString
	  arr.toJSON = BP.toJSON
	  arr.equals = BP.equals
	  arr.compare = BP.compare
	  arr.indexOf = BP.indexOf
	  arr.copy = BP.copy
	  arr.slice = BP.slice
	  arr.readUIntLE = BP.readUIntLE
	  arr.readUIntBE = BP.readUIntBE
	  arr.readUInt8 = BP.readUInt8
	  arr.readUInt16LE = BP.readUInt16LE
	  arr.readUInt16BE = BP.readUInt16BE
	  arr.readUInt32LE = BP.readUInt32LE
	  arr.readUInt32BE = BP.readUInt32BE
	  arr.readIntLE = BP.readIntLE
	  arr.readIntBE = BP.readIntBE
	  arr.readInt8 = BP.readInt8
	  arr.readInt16LE = BP.readInt16LE
	  arr.readInt16BE = BP.readInt16BE
	  arr.readInt32LE = BP.readInt32LE
	  arr.readInt32BE = BP.readInt32BE
	  arr.readFloatLE = BP.readFloatLE
	  arr.readFloatBE = BP.readFloatBE
	  arr.readDoubleLE = BP.readDoubleLE
	  arr.readDoubleBE = BP.readDoubleBE
	  arr.writeUInt8 = BP.writeUInt8
	  arr.writeUIntLE = BP.writeUIntLE
	  arr.writeUIntBE = BP.writeUIntBE
	  arr.writeUInt16LE = BP.writeUInt16LE
	  arr.writeUInt16BE = BP.writeUInt16BE
	  arr.writeUInt32LE = BP.writeUInt32LE
	  arr.writeUInt32BE = BP.writeUInt32BE
	  arr.writeIntLE = BP.writeIntLE
	  arr.writeIntBE = BP.writeIntBE
	  arr.writeInt8 = BP.writeInt8
	  arr.writeInt16LE = BP.writeInt16LE
	  arr.writeInt16BE = BP.writeInt16BE
	  arr.writeInt32LE = BP.writeInt32LE
	  arr.writeInt32BE = BP.writeInt32BE
	  arr.writeFloatLE = BP.writeFloatLE
	  arr.writeFloatBE = BP.writeFloatBE
	  arr.writeDoubleLE = BP.writeDoubleLE
	  arr.writeDoubleBE = BP.writeDoubleBE
	  arr.fill = BP.fill
	  arr.inspect = BP.inspect
	  arr.toArrayBuffer = BP.toArrayBuffer

	  return arr
	}

	var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g

	function base64clean (str) {
	  // Node strips out invalid characters like \n and \t from the string, base64-js does not
	  str = stringtrim(str).replace(INVALID_BASE64_RE, '')
	  // Node converts strings with length < 2 to ''
	  if (str.length < 2) return ''
	  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
	  while (str.length % 4 !== 0) {
	    str = str + '='
	  }
	  return str
	}

	function stringtrim (str) {
	  if (str.trim) return str.trim()
	  return str.replace(/^\s+|\s+$/g, '')
	}

	function toHex (n) {
	  if (n < 16) return '0' + n.toString(16)
	  return n.toString(16)
	}

	function utf8ToBytes (string, units) {
	  units = units || Infinity
	  var codePoint
	  var length = string.length
	  var leadSurrogate = null
	  var bytes = []

	  for (var i = 0; i < length; i++) {
	    codePoint = string.charCodeAt(i)

	    // is surrogate component
	    if (codePoint > 0xD7FF && codePoint < 0xE000) {
	      // last char was a lead
	      if (!leadSurrogate) {
	        // no lead yet
	        if (codePoint > 0xDBFF) {
	          // unexpected trail
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else if (i + 1 === length) {
	          // unpaired lead
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        }

	        // valid lead
	        leadSurrogate = codePoint

	        continue
	      }

	      // 2 leads in a row
	      if (codePoint < 0xDC00) {
	        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	        leadSurrogate = codePoint
	        continue
	      }

	      // valid surrogate pair
	      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000
	    } else if (leadSurrogate) {
	      // valid bmp char, but last char was a lead
	      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	    }

	    leadSurrogate = null

	    // encode utf8
	    if (codePoint < 0x80) {
	      if ((units -= 1) < 0) break
	      bytes.push(codePoint)
	    } else if (codePoint < 0x800) {
	      if ((units -= 2) < 0) break
	      bytes.push(
	        codePoint >> 0x6 | 0xC0,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x10000) {
	      if ((units -= 3) < 0) break
	      bytes.push(
	        codePoint >> 0xC | 0xE0,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x110000) {
	      if ((units -= 4) < 0) break
	      bytes.push(
	        codePoint >> 0x12 | 0xF0,
	        codePoint >> 0xC & 0x3F | 0x80,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else {
	      throw new Error('Invalid code point')
	    }
	  }

	  return bytes
	}

	function asciiToBytes (str) {
	  var byteArray = []
	  for (var i = 0; i < str.length; i++) {
	    // Node's code seems to be doing this and not & 0x7F..
	    byteArray.push(str.charCodeAt(i) & 0xFF)
	  }
	  return byteArray
	}

	function utf16leToBytes (str, units) {
	  var c, hi, lo
	  var byteArray = []
	  for (var i = 0; i < str.length; i++) {
	    if ((units -= 2) < 0) break

	    c = str.charCodeAt(i)
	    hi = c >> 8
	    lo = c % 256
	    byteArray.push(lo)
	    byteArray.push(hi)
	  }

	  return byteArray
	}

	function base64ToBytes (str) {
	  return base64.toByteArray(base64clean(str))
	}

	function blitBuffer (src, dst, offset, length) {
	  for (var i = 0; i < length; i++) {
	    if ((i + offset >= dst.length) || (i >= src.length)) break
	    dst[i + offset] = src[i]
	  }
	  return i
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2).Buffer, (function() { return this; }())))

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	exports.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var nBits = -7
	  var i = isLE ? (nBytes - 1) : 0
	  var d = isLE ? -1 : 1
	  var s = buffer[offset + i]

	  i += d

	  e = s & ((1 << (-nBits)) - 1)
	  s >>= (-nBits)
	  nBits += eLen
	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & ((1 << (-nBits)) - 1)
	  e >>= (-nBits)
	  nBits += mLen
	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen)
	    e = e - eBias
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	}

	exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
	  var i = isLE ? 0 : (nBytes - 1)
	  var d = isLE ? 1 : -1
	  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

	  value = Math.abs(value)

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0
	    e = eMax
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2)
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--
	      c *= 2
	    }
	    if (e + eBias >= 1) {
	      value += rt / c
	    } else {
	      value += rt * Math.pow(2, 1 - eBias)
	    }
	    if (value * c >= 2) {
	      e++
	      c /= 2
	    }

	    if (e + eBias >= eMax) {
	      m = 0
	      e = eMax
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen)
	      e = e + eBias
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
	      e = 0
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = (e << mLen) | m
	  eLen += mLen
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128
	}


/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	var toString = {}.toString;

	module.exports = Array.isArray || function (arr) {
	  return toString.call(arr) == '[object Array]';
	};


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	var lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

	;(function (exports) {
		'use strict';

	  var Arr = (typeof Uint8Array !== 'undefined')
	    ? Uint8Array
	    : Array

		var PLUS   = '+'.charCodeAt(0)
		var SLASH  = '/'.charCodeAt(0)
		var NUMBER = '0'.charCodeAt(0)
		var LOWER  = 'a'.charCodeAt(0)
		var UPPER  = 'A'.charCodeAt(0)
		var PLUS_URL_SAFE = '-'.charCodeAt(0)
		var SLASH_URL_SAFE = '_'.charCodeAt(0)

		function decode (elt) {
			var code = elt.charCodeAt(0)
			if (code === PLUS ||
			    code === PLUS_URL_SAFE)
				return 62 // '+'
			if (code === SLASH ||
			    code === SLASH_URL_SAFE)
				return 63 // '/'
			if (code < NUMBER)
				return -1 //no match
			if (code < NUMBER + 10)
				return code - NUMBER + 26 + 26
			if (code < UPPER + 26)
				return code - UPPER
			if (code < LOWER + 26)
				return code - LOWER + 26
		}

		function b64ToByteArray (b64) {
			var i, j, l, tmp, placeHolders, arr

			if (b64.length % 4 > 0) {
				throw new Error('Invalid string. Length must be a multiple of 4')
			}

			// the number of equal signs (place holders)
			// if there are two placeholders, than the two characters before it
			// represent one byte
			// if there is only one, then the three characters before it represent 2 bytes
			// this is just a cheap hack to not do indexOf twice
			var len = b64.length
			placeHolders = '=' === b64.charAt(len - 2) ? 2 : '=' === b64.charAt(len - 1) ? 1 : 0

			// base64 is 4/3 + up to two characters of the original data
			arr = new Arr(b64.length * 3 / 4 - placeHolders)

			// if there are placeholders, only get up to the last complete 4 chars
			l = placeHolders > 0 ? b64.length - 4 : b64.length

			var L = 0

			function push (v) {
				arr[L++] = v
			}

			for (i = 0, j = 0; i < l; i += 4, j += 3) {
				tmp = (decode(b64.charAt(i)) << 18) | (decode(b64.charAt(i + 1)) << 12) | (decode(b64.charAt(i + 2)) << 6) | decode(b64.charAt(i + 3))
				push((tmp & 0xFF0000) >> 16)
				push((tmp & 0xFF00) >> 8)
				push(tmp & 0xFF)
			}

			if (placeHolders === 2) {
				tmp = (decode(b64.charAt(i)) << 2) | (decode(b64.charAt(i + 1)) >> 4)
				push(tmp & 0xFF)
			} else if (placeHolders === 1) {
				tmp = (decode(b64.charAt(i)) << 10) | (decode(b64.charAt(i + 1)) << 4) | (decode(b64.charAt(i + 2)) >> 2)
				push((tmp >> 8) & 0xFF)
				push(tmp & 0xFF)
			}

			return arr
		}

		function uint8ToBase64 (uint8) {
			var i,
				extraBytes = uint8.length % 3, // if we have 1 byte left, pad 2 bytes
				output = "",
				temp, length

			function encode (num) {
				return lookup.charAt(num)
			}

			function tripletToBase64 (num) {
				return encode(num >> 18 & 0x3F) + encode(num >> 12 & 0x3F) + encode(num >> 6 & 0x3F) + encode(num & 0x3F)
			}

			// go through the array every three bytes, we'll deal with trailing stuff later
			for (i = 0, length = uint8.length - extraBytes; i < length; i += 3) {
				temp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2])
				output += tripletToBase64(temp)
			}

			// pad the end with zeros, but make sure to not forget the extra bytes
			switch (extraBytes) {
				case 1:
					temp = uint8[uint8.length - 1]
					output += encode(temp >> 2)
					output += encode((temp << 4) & 0x3F)
					output += '=='
					break
				case 2:
					temp = (uint8[uint8.length - 2] << 8) + (uint8[uint8.length - 1])
					output += encode(temp >> 10)
					output += encode((temp >> 4) & 0x3F)
					output += encode((temp << 2) & 0x3F)
					output += '='
					break
			}

			return output
		}

		exports.toByteArray = b64ToByteArray
		exports.fromByteArray = uint8ToBase64
	}(typeof exports === 'undefined' ? (this.base64js = {}) : exports))


/***/ }
/******/ ])
});

!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t(require("typescript"),function(){try{return require("RAML.JsonValidation")}catch(e){}}(),function(){try{return require("RAML.XmlValidation")}catch(e){}}()):"function"==typeof define&&define.amd?define(["typescript","RAML.JsonValidation","RAML.XmlValidation"],t):"object"==typeof exports?exports.Parser=t(require("typescript"),function(){try{return require("RAML.JsonValidation")}catch(e){}}(),function(){try{return require("RAML.XmlValidation")}catch(e){}}()):(e.RAML=e.RAML||{},e.RAML.Parser=t(e.typescript,e["RAML.JsonValidation"],e["RAML.XmlValidation"]))}(this,function(__WEBPACK_EXTERNAL_MODULE_152__,__WEBPACK_EXTERNAL_MODULE_176__,__WEBPACK_EXTERNAL_MODULE_177__){return function(e){function t(r){if(n[r])return n[r].exports;var i=n[r]={exports:{},id:r,loaded:!1};return e[r].call(i.exports,i,i.exports,t),i.loaded=!0,i.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){"use strict";function r(e,t){return h.load(e,t)}function i(e,t){return h.loadSync(e,t)}function a(e,t,n){return h.loadApi(e,t,n).getOrElse(null)}function o(e,t,n){return h.loadApi(e,t,n).getOrElse(null)}function s(e,t,n){return{fsResolver:{content:function(r){return r===(n||y.resolve("/","#local.raml")).replace(/\\/,"/")?e:t&&t.fsResolver?t.fsResolver.content(r):void 0},contentAsync:function(r){return r===(n||y.resolve("/","#local.raml")).replace(/\\/,"/")?Promise.resolve(e):t&&t.fsResolver?t.fsResolver.contentAsync(r):void 0}},httpResolver:t?t.httpResolver:null,rejectOnErrors:t?t.rejectOnErrors:!1,attributeDefaults:t?t.attributeDefaults:!0}}function u(e,t){var n=null;return t&&t.filePath&&(n=t.filePath),h.loadApi(n||"/#local.raml",[],s(e,t,n)).getOrElse(null)}function l(e,t){var n=null;return t&&t.filePath&&(n=t.filePath),h.loadApiAsync(n||"/#local.raml",[],s(e,t,n))}function p(e,t,n){return h.loadApiAsync(e,t,n)}function c(e,t,n){return h.loadRAMLAsync(e,t,n)}function f(e){return h.getLanguageElementByRuntimeType(e)}function d(e){return t.api10.isFragment(e)}function m(e){return t.api10.asFragment(e)}var h=n(8),y=n(15),v=n(23);t.api10=n(11),t.api08=n(12),t.load=r,t.loadSync=i,t.loadApiSync=a,t.loadRAMLSync=o,t.parseRAMLSync=u,t.parseRAML=l,t.loadApi=p,t.loadRAML=c,t.getLanguageElementByRuntimeType=f,t.isFragment=d,t.asFragment=m,t.hl=n(9),t.ll=n(10),t.search=n(13),t.stubs=n(1),t.utils=n(2),t.project=n(3),t.universeHelpers=n(14),t.ds=n(39),t.schema=n(4),t.universes=t.ds.universesInfo,t.parser=n(5),t.expander=n(6),t.wrapperHelper=n(7),"undefined"==typeof Promise&&"undefined"!=typeof window&&(window.Promise=v)},function(e,t,n){"use strict";function r(e,t,n,r){return void 0===n&&(n=null),T.createStubNode(e,t,n,r)}function i(e,t,n){return T.createStub(e,t,n)}function a(e,t,n){return T.createStub0(e,t,n)}function o(e,t){return T.createResourceStub(e,t)}function s(e,t){return T.createMethodStub(e,t)}function u(e,t){return T.createResponseStub(e,t)}function l(e,t){return T.createBodyStub(e,t)}function p(e,t){return T.createUriParameterStub(e,t)}function c(e,t){return T.createQueryParameterStub(e,t)}function f(e,t,n,r,i){return void 0===i&&(i=!1),new S.ASTPropImpl(e,t,n,r,i)}function d(e,t,n,r){return new S.ASTNodeImpl(e,t,n,r)}function m(e,t,n,r){return new b(e,t,n,r)}function h(e,t,n,r){return new N(e,t,n,r)}function y(e,t){return E.createMapping(e,t)}function v(){return E.createMap([])}function g(e,t){return T.createAttr(e,t)}var A=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},S=n(16),E=n(24),T=n(17);t.createStubNode=r,t.createStub=i,t.createStubNoParentPatch=a,t.createResourceStub=o,t.createMethodStub=s,t.createResponseStub=u,t.createBodyStub=l,t.createUriParameterStub=p,t.createQueryParameterStub=c,t.createASTPropImpl=f,t.createASTNodeImpl=d,t.createVirtualASTPropImpl=m,t.createVirtualNodeImpl=h;var b=function(e){function t(){e.apply(this,arguments)}return A(t,e),t.prototype.value=function(){return""},t}(S.ASTPropImpl),N=function(e){function t(){e.apply(this,arguments)}return A(t,e),t.prototype.value=function(){return""},t}(S.ASTNodeImpl);t.createMapping=y,t.createMap=v,t.createAttr=g},function(e,t,n){"use strict";function r(){return l.hasAsyncRequests()}function i(e){l.addLoadCallback(e)}function a(){return d.getTransformNames()}function o(e){return p.getFragmentDefenitionName(e)}function s(e,t,n){if(c.ReferenceType.isInstance(n.range())){var r=(n.range(),f.createNode(e));return new p.StructuredValue(r,t,n)}return e}function u(e){return(new m.UrlParameterNameValidator).parseUrl(e)}var l=n(25),p=n(16),c=n(39),f=n(24),d=n(27),m=n(28),h=n(29),y=n(18);t.hasAsyncRequests=r,t.addLoadCallback=i,t.getTransformerNames=a,t.updateType=function(e){var t=h.doDescrimination(e);null==t&&e.property()&&(t=e.property().range()),t&&e.patchType(t)},t.getFragmentDefenitionName=o,t.genStructuredValue=s,t.parseUrl=u;var v=function(){function e(e,t){this.node=e,this.targetUnitRoot=t}return e}();t.UnitLink=v;var g=function(){function e(e,t){this.errors=e,this.primaryUnitRoot=t}return e.prototype.accept=function(e){this.transformIssue(e),this.errors.push(e)},e.prototype.transformIssue=function(e){var t=this,n=null,r=this.findIssueTail(e);r.node&&(n=r.node.lowLevel().unit());var i=this.primaryUnitRoot.lowLevel().unit();if(n&&i&&n!=i){var a=this.findPathToNodeUnit(this.primaryUnitRoot,r.node);if(a&&a.length>0){var o=a.map(function(n){return t.convertConnectingNodeToError(n,e)});if(o&&o.length>0)for(var s=r,u=o.length-1;u>=0;u--){var l=o[u];s.extras=[],s.extras.push(l),s=l}}}},e.prototype.begin=function(){},e.prototype.end=function(){},e.prototype.acceptUnique=function(e){for(var t=0,n=this.errors;t<n.length;t++){var r=n[t];if(r.start==e.start&&r.message==e.message)return}this.accept(e)},e.prototype.findPathToNodeUnit=function(e,t){return t.lowLevel()&&t.lowLevel().unit()?this.findPathToNodeUnitRecursively(e,t.lowLevel().unit()):[]},e.prototype.findPathToNodeUnitRecursively=function(e,t){for(var n=this.findUnitLinks(e),r=0;r<n.length;r++){var i=n[r];if(i.targetUnitRoot&&i.targetUnitRoot.lowLevel()&&i.targetUnitRoot.lowLevel().unit()==t)return[i.node];var a=this.findPathToNodeUnitRecursively(i.targetUnitRoot,t);if(a)return a.unshift(i.node),a}return null},e.prototype.findUnitLinks=function(e){var t=[];return t=t.concat(this.findMasterLinks(e))},e.prototype.findMasterLinks=function(e){if(!e.getMaster)return[];var t=e.getMaster();if(!t)return[];var n=e.asElement().attr(y.Universe10.Extension.properties["extends"].name);return n&&n.value()?[new v(n,t)]:[]},e.prototype.convertConnectingNodeToError=function(e,t){if(!e)return null;var n=e.lowLevel(),r=n.start(),i=n.end(),a=this.generateLinkMessageByNode(e,t);return{code:t.code,isWarning:t.isWarning,message:a,node:e,start:r,end:i,path:n.unit()?n.unit().path():"",extras:[],unit:n.unit()}},e.prototype.generateLinkMessageByNode=function(e,t){return e.property().nameId()==y.Universe10.Extension.properties["extends"].name?"Error in the master file: "+t.message:t.message},e.prototype.findIssueTail=function(e){return e.extras&&0!=e.extras.length?this.findIssueTail(e.extras[0]):e},e}();t.PointOfViewValidationAcceptorImpl=g},function(e,t,n){"use strict";function r(e,t,n){return new i.Project(e,t,n)}var i=n(24);t.createProject=r},function(e,t,n){"use strict";function r(e,t){var n=n.createProject(h.dirname(e)),r={$ref:t},i=JSON.stringify(r),a=n.setCachedUnitContent(h.basename(e),i),s=o(i,a);return s.jsonSchema.$ref}function i(e,t){return v.createSchema(e,new y.ContentProvider(t))}function a(e){return v.getXMLSchema(e)}function o(e,t){return v.getJSONSchema(e,new y.ContentProvider(t))}function s(e,t,n){return d.completeReference(e,t,n)}function u(e){return d.getIncludePath(e)}function l(e){return d.getIncludeReference(e)}function p(){return new m.SchemaToModelGenerator}function c(){return new m.ModelToSchemaGenerator}var f=n(39),d=n(26),m=n(19),h=n(15),y=n(31),v=f.getSchemaUtils();t.dereference=r,t.createSchema=i,t.getXMLSchema=a,t.getJSONSchema=o,t.completeReference=s,t.getIncludePath=u,t.getIncludeReference=l,t.createSchemaModelGenerator=p,t.createModelToSchemaGenerator=c},function(e,t,n){"use strict";t.modify=n(20)},function(e,t,n){"use strict";function r(e){return i.expandTraitsAndResourceTypes(e)}var i=n(27);t.expandTraitsAndResourceTypes=r},function(e,t,n){"use strict";function r(e){return i.completeRelativeUri(e)}var i=n(36);t.completeRelativeUri=r},function(e,t,n){"use strict";function r(e,t){return t=t||{},c(e).then(function(e){var n;return n=!t.hasOwnProperty("expandLibraries")||t.expandLibraries?M.expandLibrariesHL(e):M.expandTraitsAndResourceTypesHL(e),C.dump(n,{rootNodeDetails:!0,attributeDefaults:!0,serializeMetadata:!0})})}function i(e,t){t=t||{};var n,r=u(e);return n=!t.hasOwnProperty("expandLibraries")||t.expandLibraries?M.expandLibrariesHL(r)||r:M.expandTraitsAndResourceTypesHL(r)||r,C.dump(n,{rootNodeDetails:!0,attributeDefaults:!0,serializeMetadata:!0})}function a(e,t,n){var r=u(e,t,n);if(!r)return T.empty();var i=r.wrapperNode(),a=Array.isArray(t)?n:t;return A(i,a),new T(i)}function o(e,t,n){var r=u(e,t,n);if(!r)return T.empty();var i=r.wrapperNode(),a=Array.isArray(t)?n:t;return A(i,a),new T(i)}function s(e,t,n){var r=u(e,t,n);return r?new T(r):T.empty()}function u(e,t,n){var r=Array.isArray(t),i=r?t:null,a=r?n:t;a=a||{};var o=m(e,a),s=e.indexOf("://"),u=-1!=s&&6>s?e:E.basename(e),l=o.unit(u);n&&!i&&(i=null);var p;if(l)if(i&&i.length>0){var c=[];i.forEach(function(e){if(!e||0==e.trim().length)throw new Error("Extensions and overlays list should contain legal file paths")}),i.forEach(function(e){c.push(o.unit(e,E.isAbsolute(e)))}),c.forEach(function(e){return h(e,a)}),p=h(w.mergeAPIs(l,c,N.OverlayMergeMode.MERGE),a)}else p=h(l,a),p.setMergeMode(N.OverlayMergeMode.MERGE);if(!l)throw new Error("Can not resolve :"+e);if(a.rejectOnErrors&&p&&p.errors().filter(function(e){return!e.isWarning}).length)throw y(p);return p}function l(e,t,n){var r=p(e,t,n);return r.then(function(e){return e})}function p(e,t,n){return c(e,t,n).then(function(e){if(!e)return null;for(var r=Array.isArray(t),i=r?n:t,a=e;null!=a;){var o=a.wrapperNode();A(o,i);var s=a.getMaster();a=s?s.asElement():null}return e.wrapperNode()})}function c(e,t,n){var r=Array.isArray(t),i=r?t:null,a=r?n:t;a=a||{};var o=m(e,a),s=e.indexOf("://"),u=-1!=s&&6>s?e:E.basename(e);return n&&!i&&(i=null),i&&0!=i.length?(i.forEach(function(e){if(!e||0==e.trim().length)throw new Error("Extensions and overlays list should contain legal file paths")}),d(o,u,a).then(function(e){var t=[];return i.forEach(function(e){t.push(d(o,e,a))}),Promise.all(t).then(function(t){var n=[];t.forEach(function(e){return n.push(e.lowLevel().unit())});var r=w.mergeAPIs(e.lowLevel().unit(),n,N.OverlayMergeMode.MERGE);return r}).then(function(e){return h(e,a)})})):d(o,u,a).then(function(e){return e.setMergeMode(N.OverlayMergeMode.MERGE),e})}function f(e){if(null==e)return null;var t=e.getAdapter(R.RAMLService).getDeclaringNode();return null==t?null:t.wrapperNode()}function d(e,t,n){return _.fetchIncludesAndMasterAsync(e,t).then(function(e){try{var t=h(e,n);return n.rejectOnErrors&&t&&t.errors().filter(function(e){return!e.isWarning}).length?Promise.reject(y(t)):t}catch(r){return Promise.reject(r)}})}function m(e,t){t=t||{};var n,r=t.fsResolver,i=t.httpResolver,a=t.reusedNode;if(a)n=a.lowLevel().unit().project(),n.deleteUnit(E.basename(e)),r&&n.setFSResolver(r),i&&n.setHTTPResolver(i);else{var o=E.dirname(e);n=new b.Project(o,r,i)}return n}function h(e,t,n){if(void 0===n&&(n=!1),t=t||{},!e)return null;var r=null,i=null;e.isRAMLUnit?r=e:(i=e,r=i.lowLevel().unit());var a=r.contents(),o=N.ramlFirstLine(a);if(!o)throw new Error("Invalid first line. A RAML document is expected to start with '#%RAML <version> <?fragment type>'.");var s,u,l=o[1];o[2];if("0.8"==l?u="RAML08":"1.0"==l&&(u="RAML10"),!u)throw new Error("Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'");if("RAML08"==u&&n)throw new Error("Extensions and overlays are not supported in RAML 0.8.");var p=O(u);p.type(s);return i||(i=N.fromUnit(r),t.reusedNode&&t.reusedNode.lowLevel().unit().absolutePath()==r.absolutePath()&&g(i,t.reusedNode)&&i.setReusedNode(t.reusedNode)),i}function y(e){var t=new Error("Api contains errors.");return t.parserErrors=N.toParserErrors(e.errors(),e),t}function v(e,t,n){void 0===t&&(t=!1),void 0===n&&(n=!0);var r=O("RAML10"),i=r.type(I.Universe10.Api.name),a=new b.Project(e),o=[];return a.units().forEach(function(e){var r=e.ast();t&&(r=_.toChildCachingNode(r));var a=new S.ApiImpl(new N.ASTNodeImpl(r,null,i,null));n&&(a=w.expandTraitsAndResourceTypes(a)),o.push(a)}),o}function g(e,t){if(!t)return!1;for(var n=e.lowLevel().unit().contents(),r=t.lowLevel().unit().contents(),i=Math.min(n.length,r.length),a=-1,o=0;i>o;o++)if(n.charAt(o)!=r.charAt(o)){a=o;break}for(;a>0&&""==n.charAt(a).replace(/\s/,"");)a--;0>a&&n.length!=r.length&&(a=i);var s=P.deepFindNode(t,a,a+1);if(!s)return!0;if(s.lowLevel().unit().absolutePath()!=e.lowLevel().unit().absolutePath())return!0;var u=s.isElement()?s.asElement():s.parent();if(!u)return!0;var l=u.property();if(!l)return!0;if(L.isAnnotationsProperty(l)&&(u=u.parent()),!u)return!0;for(var p=u;p;){var c=p.definition();if(L.isResourceTypeType(c)||L.isTraitType(c))return!1;var f=p.property();if(!f)return!0;if(L.isTypeDeclarationDescendant(c)&&(L.isTypesProperty(f)||L.isAnnotationTypesProperty(f)))return!1;var d=f.range();if(L.isResourceTypeRefType(d)||L.isTraitRefType(d))return!1;p=p.parent()}return!0}function A(e,t){t=t||{},null!=t.attributeDefaults&&e?e.setAttributeDefaults(t.attributeDefaults):e&&e.setAttributeDefaults(!0)}var S=n(21),E=n(15),T=n(22),b=n(24),N=n(16),_=n(24),w=n(27),M=n(30),I=n(18),R=n(37),C=n(32),L=n(14),P=n(13),O=n(38);t.load=r,t.loadSync=i,t.loadApi=a,t.loadRAML=o,t.loadRAMLHL=s,t.loadApiAsync=l,t.loadRAMLAsync=p,t.loadRAMLAsyncHL=c,t.getLanguageElementByRuntimeType=f,t.toError=y,t.loadApis1=v},function(e,t,n){(function(e){"use strict";function n(e){return e.asElement&&e.getKind&&e.asAttr&&e.lowLevel}function r(){var t=e.ramlValidation;if(t){var n=t.nodeValidators;if(Array.isArray(n))return n}return[]}function i(){var t=e.ramlValidation;if(t){var n=t.astAnnotationValidators;if(Array.isArray(n))return n}return[]}!function(e){e[e.BASIC=0]="BASIC",e[e.NODE=1]="NODE",e[e.ATTRIBUTE=2]="ATTRIBUTE"}(t.NodeKind||(t.NodeKind={}));t.NodeKind;!function(e){e[e.RAML10=0]="RAML10",e[e.RAML08=1]="RAML08"}(t.RAMLVersion||(t.RAMLVersion={}));t.RAMLVersion;t.isParseResult=n,function(e){e[e.UNRESOLVED_REFERENCE=0]="UNRESOLVED_REFERENCE",e[e.YAML_ERROR=1]="YAML_ERROR",e[e.UNKNOWN_NODE=2]="UNKNOWN_NODE",e[e.MISSING_REQUIRED_PROPERTY=3]="MISSING_REQUIRED_PROPERTY",e[e.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE=4]="PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE",e[e.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT=5]="KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT",e[e.UNABLE_TO_RESOLVE_INCLUDE_FILE=6]="UNABLE_TO_RESOLVE_INCLUDE_FILE",e[e.INVALID_VALUE_SCHEMA=7]="INVALID_VALUE_SCHEMA",e[e.MISSED_CONTEXT_REQUIREMENT=8]="MISSED_CONTEXT_REQUIREMENT",e[e.NODE_HAS_VALUE=9]="NODE_HAS_VALUE",e[e.ONLY_OVERRIDE_ALLOWED=10]="ONLY_OVERRIDE_ALLOWED",e[e.ILLEGAL_PROPERTY_VALUE=11]="ILLEGAL_PROPERTY_VALUE",e[e.ILLEGAL_PROPERTY=12]="ILLEGAL_PROPERTY",e[e.INVALID_PROPERTY=13]="INVALID_PROPERTY"}(t.IssueCode||(t.IssueCode={}));t.IssueCode;t.getNodeValidationPlugins=r,t.getNodeAnnotationValidationPlugins=i}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(e,t){return new S(v.CHANGE_VALUE,e,t,-1)}function i(e,t){return new S(v.CHANGE_VALUE,e,t.lowLevel(),-1)}function a(e,t){return new S(v.CHANGE_KEY,e,t,-1)}function o(e,t){return new S(v.REMOVE_CHILD,e,t,-1)}function s(e,t,n,r){void 0===n&&(n=null),void 0===r&&(r=!1);var i=new S(v.ADD_CHILD,e,t,-1);return i.insertionPoint=n,i.toSeq=r,i}function u(e,t){return new S(v.INIT_RAML_FILE,e,t,-1)}function l(e,t,n){if(d.isAbsolute(e)){var r=d.extname(t);".xsd"!=r&&(e=e.substr(1),t=p(n,d.basename(t)))}return c(e)||d.isAbsolute(e)?e:c(t)||d.isAbsolute(t)?p(d.dirname(t),e):p(d.dirname(p(n,t)),e)}function p(e,t){if(c(t))return t;var n;if(c(e)){var r=h.stringEndsWith(e,"/")?e:e+"/";n=m.resolve(r,t).replace(/\\/g,"/")}else n=d.resolve(e,t).replace(/\\/g,"/");return n}function c(e){return null==e?!1:h.stringStartsWith(e,"http://")||h.stringStartsWith(e,"https://")}function f(e){return e.start&&e.end&&e.unit&&e.key&&e.value&&e.children&&e.includePath}var d=n(15),m=n(40),h=n(33),y=function(){function e(){}return e}();t.ASTDelta=y,function(e){e[e.ADD_CHILD=0]="ADD_CHILD",e[e.REMOVE_CHILD=1]="REMOVE_CHILD",e[e.MOVE_CHILD=2]="MOVE_CHILD",e[e.CHANGE_KEY=3]="CHANGE_KEY",e[e.CHANGE_VALUE=4]="CHANGE_VALUE",e[e.INIT_RAML_FILE=5]="INIT_RAML_FILE"}(t.CommandKind||(t.CommandKind={}));var v=t.CommandKind,g=function(){function e(e,t,n,r,i){void 0===i&&(i=null),this.offset=e,this.replacementLength=t,this.text=n,this.unit=r,this.target=i}return e}();t.TextChangeCommand=g;var A=function(){function e(){this.commands=[]}return e}();t.CompositeCommand=A,function(e){e[e.NONE=0]="NONE",e[e.START=1]="START",e[e.END=2]="END",e[e.POINT=3]="POINT"}(t.InsertionPointType||(t.InsertionPointType={}));var S=(t.InsertionPointType,function(){function e(e,t,n,r){this.toSeq=!1,this.kind=e,this.target=t,this.value=n,this.position=r}return e}());t.ASTChangeCommand=S,t.setAttr=r,t.setAttrStructured=i,t.setKey=a,t.removeNode=o,t.insertNode=s,t.initRamlFile=u;var E=function(){function e(e,t){this.content=e,this.absPath=t}return e.prototype.position=function(e){var t=e;this.initMapping();for(var n=0;n<this.mapping.length;n++){var r=this.mapping[n];if(r>t)return{line:n,column:t,position:e};t-=r}if(0==t)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1],position:this.content.length};if(1==t)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1]-1,position:e-1};throw new Error("Character position exceeds text length: "+e+" > + "+this.content.length+".\nUnit path: "+this.absPath)},e.prototype.initMapping=function(){if(null==this.mapping){if(null==this.content)throw new Error("Line Mapper has been given null content"+(null!=this.absPath?". Path: "+this.absPath:" and null path."));this.mapping=[];for(var e=0,t=this.content.length,n=0;t>n;n++)"\r"==this.content.charAt(n)?t-1>n&&"\n"==this.content.charAt(n+1)?(this.mapping.push(n-e+2),e=n+2,n++):(this.mapping.push(n-e+1),e=n+1):"\n"==this.content.charAt(n)&&(this.mapping.push(n-e+1),e=n+1);this.mapping.push(t-e)}},e}();t.LineMapperImpl=E,t.buildPath=l,t.toAbsolutePath=p,t.isWebPath=c,t.isLowLevelNode=f},function(e,t,n){"use strict";function r(e){return"Api"==e.kind()&&"RAML10"==e.RAMLVersion()}function i(e){return"LibraryBase"==e.kind()&&"RAML10"==e.RAMLVersion()}function a(e){return"Annotable"==e.kind()&&"RAML10"==e.RAMLVersion()}function o(e){return"AnnotationRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function s(e){return"Reference"==e.kind()&&"RAML10"==e.RAMLVersion()}function u(e){return"ValueType"==e.kind()&&"RAML10"==e.RAMLVersion()}function l(e){return"StringType"==e.kind()&&"RAML10"==e.RAMLVersion()}function p(e){return"UriTemplate"==e.kind()&&"RAML10"==e.RAMLVersion()}function c(e){return"RelativeUriString"==e.kind()&&"RAML10"==e.RAMLVersion()}function f(e){return"FullUriTemplateString"==e.kind()&&"RAML10"==e.RAMLVersion()}function d(e){return"StatusCodeString"==e.kind()&&"RAML10"==e.RAMLVersion()}function m(e){return"FixedUriString"==e.kind()&&"RAML10"==e.RAMLVersion()}function h(e){return"ContentType"==e.kind()&&"RAML10"==e.RAMLVersion()}function y(e){return"MarkdownString"==e.kind()&&"RAML10"==e.RAMLVersion()}function v(e){return"SchemaString"==e.kind()&&"RAML10"==e.RAMLVersion()}function g(e){return"MimeType"==e.kind()&&"RAML10"==e.RAMLVersion()}function A(e){return"AnyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function S(e){return"NumberType"==e.kind()&&"RAML10"==e.RAMLVersion()}function E(e){return"IntegerType"==e.kind()&&"RAML10"==e.RAMLVersion()}function T(e){return"NullType"==e.kind()&&"RAML10"==e.RAMLVersion()}function b(e){return"TimeOnlyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function N(e){return"DateOnlyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function _(e){return"DateTimeOnlyType"==e.kind()&&"RAML10"==e.RAMLVersion()}function w(e){return"DateTimeType"==e.kind()&&"RAML10"==e.RAMLVersion()}function M(e){return"FileType"==e.kind()&&"RAML10"==e.RAMLVersion()}function I(e){return"BooleanType"==e.kind()&&"RAML10"==e.RAMLVersion()}function R(e){return"AnnotationTarget"==e.kind()&&"RAML10"==e.RAMLVersion()}function C(e){return"TraitRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function L(e){return"Trait"==e.kind()&&"RAML10"==e.RAMLVersion()}function P(e){return"MethodBase"==e.kind()&&"RAML10"==e.RAMLVersion()}function O(e){return"Operation"==e.kind()&&"RAML10"==e.RAMLVersion()}function D(e){return"TypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function x(e){return"ModelLocation"==e.kind()&&"RAML10"==e.RAMLVersion()}function U(e){return"LocationKind"==e.kind()&&"RAML10"==e.RAMLVersion()}function k(e){return"ExampleSpec"==e.kind()&&"RAML10"==e.RAMLVersion()}function F(e){return"UsesDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function B(e){return"XMLFacetInfo"==e.kind()&&"RAML10"==e.RAMLVersion()}function K(e){return"ArrayTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function V(e){return"UnionTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function j(e){return"ObjectTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function W(e){return"StringTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function q(e){return"BooleanTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function Y(e){return"NumberTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function H(e){return"IntegerTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function $(e){return"DateOnlyTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function G(e){return"TimeOnlyTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function X(e){return"DateTimeOnlyTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function z(e){return"DateTimeTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function J(e){return"FileTypeDeclaration"==e.kind()&&"RAML10"==e.RAMLVersion()}function Q(e){return"Response"==e.kind()&&"RAML10"==e.RAMLVersion()}function Z(e){return"SecuritySchemePart"==e.kind()&&"RAML10"==e.RAMLVersion()}function ee(e){return"SecuritySchemeRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function te(e){return"AbstractSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function ne(e){return"SecuritySchemeSettings"==e.kind()&&"RAML10"==e.RAMLVersion()}function re(e){return"OAuth1SecuritySchemeSettings"==e.kind()&&"RAML10"==e.RAMLVersion()}function ie(e){return"OAuth2SecuritySchemeSettings"==e.kind()&&"RAML10"==e.RAMLVersion()}function ae(e){return"OAuth2SecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function oe(e){return"OAuth1SecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function se(e){return"PassThroughSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function ue(e){return"BasicSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function le(e){return"DigestSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function pe(e){return"CustomSecurityScheme"==e.kind()&&"RAML10"==e.RAMLVersion()}function ce(e){return"Method"==e.kind()&&"RAML10"==e.RAMLVersion()}function fe(e){return"ResourceTypeRef"==e.kind()&&"RAML10"==e.RAMLVersion()}function de(e){return"ResourceType"==e.kind()&&"RAML10"==e.RAMLVersion()}function me(e){return"ResourceBase"==e.kind()&&"RAML10"==e.RAMLVersion()}function he(e){return"Resource"==e.kind()&&"RAML10"==e.RAMLVersion()}function ye(e){return"DocumentationItem"==e.kind()&&"RAML10"==e.RAMLVersion()}function ve(e){return"Library"==e.kind()&&"RAML10"==e.RAMLVersion()}function ge(e){return"Overlay"==e.kind()&&"RAML10"==e.RAMLVersion()}function Ae(e){return"Extension"==e.kind()&&"RAML10"==e.RAMLVersion()}function Se(e){return null==e.highLevel().parent()}function Ee(e){return Se(e)?e:null}t.isApi=r,t.isLibraryBase=i,t.isAnnotable=a,t.isAnnotationRef=o,t.isReference=s,t.isValueType=u,t.isStringType=l,t.isUriTemplate=p,t.isRelativeUriString=c,t.isFullUriTemplateString=f,t.isStatusCodeString=d,t.isFixedUriString=m,t.isContentType=h,t.isMarkdownString=y,t.isSchemaString=v,t.isMimeType=g,t.isAnyType=A,t.isNumberType=S,t.isIntegerType=E,t.isNullType=T,t.isTimeOnlyType=b,t.isDateOnlyType=N,t.isDateTimeOnlyType=_,t.isDateTimeType=w,t.isFileType=M,t.isBooleanType=I,t.isAnnotationTarget=R,t.isTraitRef=C,t.isTrait=L,t.isMethodBase=P,t.isOperation=O,t.isTypeDeclaration=D,t.isModelLocation=x,t.isLocationKind=U,t.isExampleSpec=k,t.isUsesDeclaration=F,t.isXMLFacetInfo=B,t.isArrayTypeDeclaration=K,t.isUnionTypeDeclaration=V,t.isObjectTypeDeclaration=j,t.isStringTypeDeclaration=W,t.isBooleanTypeDeclaration=q,t.isNumberTypeDeclaration=Y,t.isIntegerTypeDeclaration=H,t.isDateOnlyTypeDeclaration=$,t.isTimeOnlyTypeDeclaration=G,t.isDateTimeOnlyTypeDeclaration=X,t.isDateTimeTypeDeclaration=z,t.isFileTypeDeclaration=J,t.isResponse=Q,t.isSecuritySchemePart=Z,t.isSecuritySchemeRef=ee,t.isAbstractSecurityScheme=te,t.isSecuritySchemeSettings=ne,t.isOAuth1SecuritySchemeSettings=re,t.isOAuth2SecuritySchemeSettings=ie,t.isOAuth2SecurityScheme=ae,t.isOAuth1SecurityScheme=oe,t.isPassThroughSecurityScheme=se,t.isBasicSecurityScheme=ue,t.isDigestSecurityScheme=le,t.isCustomSecurityScheme=pe,t.isMethod=ce,t.isResourceTypeRef=fe,t.isResourceType=de,t.isResourceBase=me,t.isResource=he,t.isDocumentationItem=ye,t.isLibrary=ve,t.isOverlay=ge,t.isExtension=Ae,t.isFragment=Se,t.asFragment=Ee},function(e,t,n){"use strict";function r(e){return"Api"==e.kind()&&"RAML08"==e.RAMLVersion()}function i(e){return"FullUriTemplateString"==e.kind()&&"RAML08"==e.RAMLVersion()}function a(e){return"UriTemplate"==e.kind()&&"RAML08"==e.RAMLVersion()}function o(e){return"StringType"==e.kind()&&"RAML08"==e.RAMLVersion()}function s(e){return"ValueType"==e.kind()&&"RAML08"==e.RAMLVersion()}function u(e){return"AnyType"==e.kind()&&"RAML08"==e.RAMLVersion()}function l(e){return"NumberType"==e.kind()&&"RAML08"==e.RAMLVersion()}function p(e){return"BooleanType"==e.kind()&&"RAML08"==e.RAMLVersion()}function c(e){return"Reference"==e.kind()&&"RAML08"==e.RAMLVersion()}function f(e){return"ResourceTypeRef"==e.kind()&&"RAML08"==e.RAMLVersion()}function d(e){return"ResourceType"==e.kind()&&"RAML08"==e.RAMLVersion()}function m(e){return"Method"==e.kind()&&"RAML08"==e.RAMLVersion()}function h(e){return"MethodBase"==e.kind()&&"RAML08"==e.RAMLVersion()}function y(e){return"Response"==e.kind()&&"RAML08"==e.RAMLVersion()}function v(e){return"StatusCodeString"==e.kind()&&"RAML08"==e.RAMLVersion()}function g(e){return"Parameter"==e.kind()&&"RAML08"==e.RAMLVersion()}function A(e){return"ParameterLocation"==e.kind()&&"RAML08"==e.RAMLVersion()}function S(e){return"MarkdownString"==e.kind()&&"RAML08"==e.RAMLVersion()}function E(e){return"StringTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function T(e){return"BooleanTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function b(e){return"NumberTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function N(e){return"IntegerTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function _(e){return"DateTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function w(e){return"FileTypeDeclaration"==e.kind()&&"RAML08"==e.RAMLVersion()}function M(e){return"BodyLike"==e.kind()&&"RAML08"==e.RAMLVersion()}function I(e){return"SchemaString"==e.kind()&&"RAML08"==e.RAMLVersion()}function R(e){return"JSonSchemaString"==e.kind()&&"RAML08"==e.RAMLVersion()}function C(e){return"XMLSchemaString"==e.kind()&&"RAML08"==e.RAMLVersion()}function L(e){return"ExampleString"==e.kind()&&"RAML08"==e.RAMLVersion()}function P(e){return"JSONExample"==e.kind()&&"RAML08"==e.RAMLVersion()}function O(e){return"XMLExample"==e.kind()&&"RAML08"==e.RAMLVersion()}function D(e){return"XMLBody"==e.kind()&&"RAML08"==e.RAMLVersion()}function x(e){return"JSONBody"==e.kind()&&"RAML08"==e.RAMLVersion()}function U(e){return"SecuritySchemeRef"==e.kind()&&"RAML08"==e.RAMLVersion()}function k(e){return"AbstractSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function F(e){return"SecuritySchemePart"==e.kind()&&"RAML08"==e.RAMLVersion()}function B(e){return"TraitRef"==e.kind()&&"RAML08"==e.RAMLVersion()}function K(e){return"Trait"==e.kind()&&"RAML08"==e.RAMLVersion()}function V(e){return"SecuritySchemeSettings"==e.kind()&&"RAML08"==e.RAMLVersion()}function j(e){return"OAuth1SecuritySchemeSettings"==e.kind()&&"RAML08"==e.RAMLVersion()}function W(e){return"FixedUri"==e.kind()&&"RAML08"==e.RAMLVersion()}function q(e){return"OAuth2SecuritySchemeSettings"==e.kind()&&"RAML08"==e.RAMLVersion()}function Y(e){return"OAuth2SecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function H(e){return"OAuth1SecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function $(e){return"BasicSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function G(e){return"DigestSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function X(e){return"CustomSecurityScheme"==e.kind()&&"RAML08"==e.RAMLVersion()}function z(e){return"MimeType"==e.kind()&&"RAML08"==e.RAMLVersion()}function J(e){return"RelativeUriString"==e.kind()&&"RAML08"==e.RAMLVersion()}function Q(e){return"GlobalSchema"==e.kind()&&"RAML08"==e.RAMLVersion()}function Z(e){return"RAMLSimpleElement"==e.kind()&&"RAML08"==e.RAMLVersion()}function ee(e){return"DocumentationItem"==e.kind()&&"RAML08"==e.RAMLVersion()}function te(e){return"Resource"==e.kind()&&"RAML08"==e.RAMLVersion()}t.isApi=r,t.isFullUriTemplateString=i,t.isUriTemplate=a,t.isStringType=o,t.isValueType=s,t.isAnyType=u,t.isNumberType=l,t.isBooleanType=p,t.isReference=c,t.isResourceTypeRef=f,t.isResourceType=d,t.isMethod=m,t.isMethodBase=h,t.isResponse=y,t.isStatusCodeString=v,t.isParameter=g,t.isParameterLocation=A,t.isMarkdownString=S,t.isStringTypeDeclaration=E,t.isBooleanTypeDeclaration=T,t.isNumberTypeDeclaration=b,t.isIntegerTypeDeclaration=N,t.isDateTypeDeclaration=_,t.isFileTypeDeclaration=w,t.isBodyLike=M,t.isSchemaString=I,t.isJSonSchemaString=R,t.isXMLSchemaString=C,t.isExampleString=L,t.isJSONExample=P,t.isXMLExample=O,t.isXMLBody=D,t.isJSONBody=x,t.isSecuritySchemeRef=U,t.isAbstractSecurityScheme=k,t.isSecuritySchemePart=F,t.isTraitRef=B,t.isTrait=K,t.isSecuritySchemeSettings=V,t.isOAuth1SecuritySchemeSettings=j,t.isFixedUri=W,t.isOAuth2SecuritySchemeSettings=q,t.isOAuth2SecurityScheme=Y,t.isOAuth1SecurityScheme=H,t.isBasicSecurityScheme=$,t.isDigestSecurityScheme=G,t.isCustomSecurityScheme=X,t.isMimeType=z,t.isRelativeUriString=J,t.isGlobalSchema=Q,t.isRAMLSimpleElement=Z,t.isDocumentationItem=ee,t.isResource=te},function(e,t,n){"use strict";function r(e,t,n){return N.findDeclaration(e,t,n)}function i(e,t){return N.findUsages(e,t)}function a(e){return N.globalDeclarations(e)}function o(e,t,n){N.refFinder(e,t,n)}function s(e,t){return N.findDeclarationByNode(e,t)}function u(e,t){return N.determineCompletionKind(e,t)}function l(e,t){return N.enumValues(e,t)}function p(e,t){return _.qName(e,t)}function c(e,t){return N.subTypesWithLocals(e,t)}function f(e,t){return N.nodesDeclaringType(e,t)}function d(e){return N.isExampleNodeContent(e)}function m(e){return N.findExampleContentType(e)}function h(e,t){return N.parseDocumentationContent(e,t)}function y(e,t){return N.parseStructuredExample(e,t)}function v(e){return N.isExampleNode(e)}function g(e,t){return N.referenceTargets(e,t)}function A(e){return w.getNominalTypeSource(e)}function S(e,t){return N.findAllSubTypes(e,t)}function E(e){return N.declRoot(e)}function T(e,t,n,r,i){return void 0===r&&(r=!0),void 0===i&&(i=!0),N.deepFindNode(e,t,n,r,i)}function b(e){return N.allChildren(e)}var N=n(34),_=n(16),w=n(35);t.findDeclaration=r,t.findUsages=i,t.globalDeclarations=a,t.refFinder=o,t.findDeclarationByNode=s,function(e){e[e.VALUE_COMPLETION=0]="VALUE_COMPLETION",
e[e.KEY_COMPLETION=1]="KEY_COMPLETION",e[e.PATH_COMPLETION=2]="PATH_COMPLETION",e[e.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",e[e.VERSION_COMPLETION=4]="VERSION_COMPLETION",e[e.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",e[e.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",e[e.INCOMMENT=7]="INCOMMENT"}(t.LocationKind||(t.LocationKind={}));t.LocationKind;t.determineCompletionKind=u,t.enumValues=l,t.qName=p,t.subTypesWithLocals=c,t.nodesDeclaringType=f,t.isExampleNodeContent=d,t.findExampleContentType=m,t.parseDocumentationContent=h,t.parseStructuredExample=y,t.isExampleNode=v,t.referenceTargets=g,t.getNominalTypeSource=A,t.findAllSubTypes=S,t.declRoot=E,t.deepFindNode=T,t.allChildren=b},function(e,t,n){"use strict";function r(e){return e?e.nameId()===qe.Universe10.Api.properties.documentation.name||e.nameId()===qe.Universe08.Api.properties.documentation.name:!1}function i(e){return e===qe.Universe10.Trait.properties.usage.name||e===qe.Universe08.Trait.properties.usage.name||e===qe.Universe10.ResourceType.properties.usage.name||e===qe.Universe08.ResourceType.properties.usage.name||e===qe.Universe10.Library.properties.usage.name||e===qe.Universe10.Overlay.properties.usage.name||e===qe.Universe10.Extension.properties.usage.name}function a(e){return e?i(e.nameId()):!1}function o(e){return e?e.nameId()==qe.Universe10.Overlay.properties["extends"].name||e.nameId()==qe.Universe10.Extension.properties["extends"].name:!1}function s(e){return e===qe.Universe10.TypeDeclaration.properties.description.name||"description"===e}function u(e){return e?s(e.nameId()):!1}function l(e){return e===qe.Universe10.TypeDeclaration.properties.required.name||e===qe.Universe08.Parameter.properties.required.name||"required"===e}function p(e){return e===qe.Universe10.TypeDeclaration.properties.displayName.name||"displayName"===e}function c(e){return e?p(e.nameId()):!1}function f(e){return e?l(e.nameId()):!1}function d(e){return e===qe.Universe10.Api.properties.title.name||e===qe.Universe08.Api.properties.title.name||e===qe.Universe10.DocumentationItem.properties.title.name||e===qe.Universe08.DocumentationItem.properties.title.name||e===qe.Universe10.Overlay.properties.title.name||e===qe.Universe10.Extension.properties.title.name}function m(e){return e?d(e.nameId()):!1}function h(e){return e?y(e.nameId()):!1}function y(e){return e===qe.Universe08.MethodBase.properties.headers.name||e===qe.Universe08.Response.properties.headers.name||e===qe.Universe08.SecuritySchemePart.properties.headers.name||e===qe.Universe10.MethodBase.properties.headers.name||e===qe.Universe10.Response.properties.headers.name}function v(e){return e?g(e.nameId()):!1}function g(e){return e===qe.Universe08.BodyLike.properties.formParameters.name}function A(e){return e?S(e.nameId()):!1}function S(e){return e===qe.Universe08.MethodBase.properties.queryParameters.name||e===qe.Universe08.SecuritySchemePart.properties.queryParameters.name||e===qe.Universe10.MethodBase.properties.queryParameters.name}function E(e){return e?e.nameId()===qe.Universe10.Api.properties.annotations.name||e.nameId()===qe.Universe10.TypeDeclaration.properties.annotations.name||e.nameId()===qe.Universe10.Response.properties.annotations.name:!1}function T(e){return e?e.nameId()===qe.Universe10.AnnotationRef.properties.annotation.name:!1}function b(e){return e?e.nameId()===qe.Universe10.MethodBase.properties.is.name||e.nameId()===qe.Universe08.Method.properties.is.name||e.nameId()===qe.Universe10.ResourceBase.properties.is.name||e.nameId()===qe.Universe08.ResourceType.properties.is.name||e.nameId()===qe.Universe08.Resource.properties.is.name:!1}function N(e){return e?e.nameId()===qe.Universe10.Api.properties.securedBy.name||e.nameId()===qe.Universe08.Api.properties.securedBy.name||e.nameId()===qe.Universe10.MethodBase.properties.securedBy.name||e.nameId()===qe.Universe08.MethodBase.properties.securedBy.name||e.nameId()===qe.Universe08.ResourceType.properties.securedBy.name||e.nameId()===qe.Universe08.Resource.properties.securedBy.name||e.nameId()===qe.Universe10.ResourceBase.properties.securedBy.name:!1}function _(e){return e?e.nameId()===qe.Universe10.LibraryBase.properties.securitySchemes.name||e.nameId()===qe.Universe08.Api.properties.securitySchemes.name:!1}function w(e){return e?e.nameId()===qe.Universe10.SecuritySchemeRef.properties.securityScheme.name||e.nameId()===qe.Universe08.SecuritySchemeRef.properties.securityScheme.name:!1}function M(e){return e?e.nameId()===qe.Universe10.AbstractSecurityScheme.properties.type.name||e.nameId()===qe.Universe08.AbstractSecurityScheme.properties.type.name||e.nameId()===qe.Universe08.ResourceType.properties.type.name||e.nameId()===qe.Universe08.Resource.properties.type.name||e.nameId()===qe.Universe08.Parameter.properties.type.name||e.nameId()===qe.Universe10.ResourceBase.properties.type.name||e.nameId()===qe.Universe10.TypeDeclaration.properties.type.name:!1}function I(e){return e?e.nameId()===qe.Universe10.ArrayTypeDeclaration.properties.items.name:!1}function R(e){return e?e.nameId()===qe.Universe10.ArrayTypeDeclaration.properties.structuredItems.name:!1}function C(e){return e?e.nameId()===qe.Universe10.ObjectTypeDeclaration.properties.properties.name:!1}function L(e){return e?e.nameId()===qe.Universe10.MethodBase.properties.responses.name||e.nameId()===qe.Universe08.MethodBase.properties.responses.name:!1}function P(e){return e?e.nameId()===qe.Universe10.Api.properties.protocols.name||e.nameId()===qe.Universe08.Api.properties.protocols.name||e.nameId()===qe.Universe10.MethodBase.properties.protocols.name:!1}function O(e){return e?e.nameId()===qe.Universe10.TypeDeclaration.properties.name.name||e.nameId()===qe.Universe10.TypeDeclaration.properties.name.name||e.nameId()===qe.Universe08.AbstractSecurityScheme.properties.name.name||e.nameId()===qe.Universe10.AbstractSecurityScheme.properties.name.name||e.nameId()===qe.Universe08.Trait.properties.name.name||e.nameId()===qe.Universe10.Trait.properties.name.name||"name"===e.nameId():!1}function D(e){return e?e.nameId()===qe.Universe10.MethodBase.properties.body.name||e.nameId()===qe.Universe08.MethodBase.properties.body.name||e.nameId()===qe.Universe10.Response.properties.body.name||e.nameId()===qe.Universe08.Response.properties.body.name:!1}function x(e){return e?e.nameId()===qe.Universe10.TypeDeclaration.properties["default"].name||e.nameId()===qe.Universe08.Parameter.properties["default"].name:!1}function U(e){return e?e.nameId()===qe.Universe08.BodyLike.properties.schema.name||e.nameId()===qe.Universe08.XMLBody.properties.schema.name||e.nameId()===qe.Universe08.JSONBody.properties.schema.name||e.nameId()===qe.Universe10.TypeDeclaration.properties.schema.name:!1}function k(e){return e?e.nameId()===qe.Universe08.Api.properties.traits.name||e.nameId()===qe.Universe10.LibraryBase.properties.traits.name:!1}function F(e){return e?e.nameId()===qe.Universe08.TraitRef.properties.trait.name||e.nameId()===qe.Universe10.TraitRef.properties.trait.name:!1}function B(e){return e?e.nameId()===qe.Universe08.Api.properties.resourceTypes.name||e.nameId()===qe.Universe10.LibraryBase.properties.resourceTypes.name:!1}function K(e){return e?e.nameId()===qe.Universe08.ResourceTypeRef.properties.resourceType.name||e.nameId()===qe.Universe10.ResourceTypeRef.properties.resourceType.name:!1}function V(e){return e?e.nameId()===qe.Universe10.TypeDeclaration.properties.facets.name:!1}function j(e){return e?e.nameId()===qe.Universe08.Api.properties.schemas.name||e.nameId()===qe.Universe10.LibraryBase.properties.schemas.name:!1}function W(e){return e?e.nameId()===qe.Universe10.Api.properties.resources.name||e.nameId()===qe.Universe08.Api.properties.resources.name||e.nameId()===qe.Universe10.Resource.properties.resources.name||e.nameId()===qe.Universe08.Resource.properties.resources.name:!1}function q(e){return e?e.nameId()===qe.Universe10.ResourceBase.properties.methods.name||e.nameId()===qe.Universe08.Resource.properties.methods.name||e.nameId()===qe.Universe08.ResourceType.properties.methods.name:!1}function Y(e){return e&&e.nameId()===qe.Universe10.LibraryBase.properties.types.name}function H(e){return e?e.nameId()===qe.Universe10.TypeDeclaration.properties.example.name||"example"===e.nameId():!1}function $(e){return e?e.nameId()===qe.Universe10.StringTypeDeclaration.properties["enum"].name||e.nameId()===qe.Universe10.NumberTypeDeclaration.properties["enum"].name||e.nameId()===qe.Universe08.StringTypeDeclaration.properties["enum"].name:!1}function G(e){return e?e.nameId()===qe.Universe10.TypeDeclaration.properties.example.name||e.nameId()===qe.Universe10.TypeDeclaration.properties.examples.name:!1}function X(e){return e?e.nameId()===qe.Universe08.GlobalSchema.properties.value.name:!1}function z(e){return e?e.nameId()===qe.Universe08.Api.properties.uriParameters.name||e.nameId()===qe.Universe08.ResourceType.properties.uriParameters.name||e.nameId()===qe.Universe08.Resource.properties.uriParameters.name||e.nameId()===qe.Universe10.ResourceBase.properties.uriParameters.name:!1}function J(e){return e?e.nameId()===qe.Universe08.Resource.properties.baseUriParameters.name||e.nameId()===qe.Universe08.Api.properties.baseUriParameters.name||e.nameId()===qe.Universe10.Api.properties.baseUriParameters.name:!1}function Q(e){return e?e.nameId()===qe.Universe08.Api.properties.RAMLVersion.name||e.nameId()===qe.Universe10.Api.properties.RAMLVersion.name:!1}function Z(e){return e?e.nameId()===qe.Universe10.FragmentDeclaration.properties.uses.name:!1}function ee(e){return e?e.nameId()===qe.Universe10.LibraryBase.properties.annotationTypes.name:!1}function te(e){return e.key()==qe.Universe10.Method||e.key()==qe.Universe08.Method}function ne(e){return e.key()==qe.Universe10.Api||e.key()==qe.Universe08.Api}function re(e){return e.key()==qe.Universe10.BooleanType||e.key()==qe.Universe08.BooleanType}function ie(e){return e.key()==qe.Universe10.MarkdownString||e.key()==qe.Universe08.MarkdownString}function ae(e){return e.key()==qe.Universe10.Resource||e.key()==qe.Universe08.Resource}function oe(e){return e.key()==qe.Universe10.Trait||e.key()==qe.Universe08.Trait}function se(e){return e.key()==qe.Universe10.TraitRef||e.key()==qe.Universe08.TraitRef}function ue(e){return e.key()==qe.Universe10.ResourceTypeRef||e.key()==qe.Universe08.ResourceTypeRef}function le(e){return e.key()==qe.Universe08.GlobalSchema}function pe(e){return e.key()==qe.Universe10.AbstractSecurityScheme||e.key()==qe.Universe08.AbstractSecurityScheme}function ce(e){return e.isAssignableFrom(qe.Universe10.AbstractSecurityScheme.name)}function fe(e){return e.key()==qe.Universe10.SecuritySchemeRef||e.key()==qe.Universe08.SecuritySchemeRef}function de(e){return e.key()==qe.Universe10.TypeDeclaration}function me(e){return e.key()==qe.Universe10.Response||e.key()==qe.Universe08.Response}function he(e){return e.key()==qe.Universe08.BodyLike}function ye(e){return e.key()==qe.Universe10.Overlay}function ve(e){return!1}function ge(e){return e.key()==qe.Universe10.ResourceType||e.key()==qe.Universe08.ResourceType}function Ae(e){return e.key()==qe.Universe10.SchemaString||e.key()==qe.Universe08.SchemaString}function Se(e){return e.key()==qe.Universe10.MethodBase||e.key()==qe.Universe08.MethodBase}function Ee(e){return e.key()==qe.Universe10.Library}function Te(e){return e.key()==qe.Universe10.StringType||e.key()==qe.Universe08.StringType}function be(e){return e.key()==qe.Universe10.ExampleSpec}function Ne(e){return e.key()==qe.Universe10.Extension}function _e(e){return e.isAssignableFrom(qe.Universe10.TypeDeclaration.name)}function we(e){return e.key()==qe.Universe10.DocumentationItem||e.key()==qe.Universe08.DocumentationItem}function Me(e){return e.isAssignableFrom(qe.Universe10.AnnotationRef.name)}function Ie(e){return e.isAssignableFrom(qe.Universe10.Api.name)||e.isAssignableFrom(qe.Universe08.Api.name)}function Re(e){return e.isAssignableFrom(qe.Universe10.LibraryBase.name)}function Ce(e){return e.isAssignableFrom(qe.Universe10.ResourceBase.name)||e.isAssignableFrom(qe.Universe08.Resource.name)}function Le(e){return e.isAssignableFrom(qe.Universe10.ObjectTypeDeclaration.name)}function Pe(e){return e.isAssignableFrom(qe.Universe10.TypeDeclaration.name)}function Oe(e){return e.isAssignableFrom(qe.Universe10.StringTypeDeclaration.name)}function De(e){return e.isAssignableFrom(qe.Universe10.TypeDeclaration.name)}function xe(e){return e.isAssignableFrom(qe.Universe10.MethodBase.name)||e.isAssignableFrom(qe.Universe08.MethodBase.name)}function Ue(e){return e.key()==qe.Universe10.SecuritySchemePart||e.key()==qe.Universe08.SecuritySchemePart}function ke(e){return e.nameId()===qe.Universe08.Api.properties.mediaType.name||e.nameId()===qe.Universe10.Api.properties.mediaType.name}function Fe(e){return"RAML08"==e.universe().version()}function Be(e){return"RAML10"==e.universe().version()}function Ke(e){return Fe(e.definition())}function Ve(e){return Fe(e.definition())}function je(e){return Be(e.definition())}function We(e){return Be(e.definition())}var qe=n(18);t.isDocumentationProperty=r,t.isUsagePropertyName=i,t.isUsageProperty=a,t.isMasterRefProperty=o,t.isDescriptionPropertyName=s,t.isDescriptionProperty=u,t.isRequiredPropertyName=l,t.isDisplayNamePropertyName=p,t.isDisplayNameProperty=c,t.isRequiredProperty=f,t.isTitlePropertyName=d,t.isTitleProperty=m,t.isHeadersProperty=h,t.isHeadersPropertyName=y,t.isFormParametersProperty=v,t.isFormParametersPropertyName=g,t.isQueryParametersProperty=A,t.isQueryParametersPropertyName=S,t.isAnnotationsProperty=E,t.isAnnotationProperty=T,t.isIsProperty=b,t.isSecuredByProperty=N,t.isSecuritySchemesProperty=_,t.isSecuritySchemeProperty=w,t.isTypeProperty=M,t.isItemsProperty=I,t.isStructuredItemsProperty=R,t.isPropertiesProperty=C,t.isResponsesProperty=L,t.isProtocolsProperty=P,t.isNameProperty=O,t.isBodyProperty=D,t.isDefaultValue=x,t.isSchemaProperty=U,t.isTraitsProperty=k,t.isTraitProperty=F,t.isResourceTypesProperty=B,t.isResourceTypeProperty=K,t.isFacetsProperty=V,t.isSchemasProperty=j,t.isResourcesProperty=W,t.isMethodsProperty=q,t.isTypesProperty=Y,t.isExampleProperty=H,t.isEnumProperty=$,t.isExamplesProperty=G,t.isValueProperty=X,t.isUriParametersProperty=z,t.isBaseUriParametersProperty=J,t.isRAMLVersionProperty=Q,t.isUsesProperty=Z,t.isAnnotationTypesProperty=ee,t.isMethodType=te,t.isApiType=ne,t.isBooleanTypeType=re,t.isMarkdownStringType=ie,t.isResourceType=ae,t.isTraitType=oe,t.isTraitRefType=se,t.isResourceTypeRefType=ue,t.isGlobalSchemaType=le,t.isSecuritySchemaType=pe,t.isSecuritySchemaTypeDescendant=ce,t.isSecuritySchemeRefType=fe,t.isTypeDeclarationType=de,t.isResponseType=me,t.isBodyLikeType=he,t.isOverlayType=ye,t.isAnnotationTypeType=ve,t.isResourceTypeType=ge,t.isSchemaStringType=Ae,t.isMethodBaseType=Se,t.isLibraryType=Ee,t.isStringTypeType=Te,t.isExampleSpecType=be,t.isExtensionType=Ne,t.isTypeDeclarationTypeOrDescendant=_e,t.isDocumentationType=we,t.isAnnotationRefTypeOrDescendant=Me,t.isApiSibling=Ie,t.isLibraryBaseSibling=Re,t.isResourceBaseSibling=Ce,t.isObjectTypeDeclarationSibling=Le,t.isTypeDeclarationDescendant=Pe,t.isStringTypeDeclarationDescendant=Oe,t.isTypeDeclarationSibling=De,t.isMethodBaseSibling=xe,t.isSecuritySchemePartType=Ue,t.isMediaTypeProperty=ke,t.isRAML08Type=Fe,t.isRAML10Type=Be,t.isRAML08Node=Ke,t.isRAML08Attribute=Ve,t.isRAML10Node=je,t.isRAML10Attribute=We},function(e,t,n){(function(e){function n(e,t){for(var n=0,r=e.length-1;r>=0;r--){var i=e[r];"."===i?e.splice(r,1):".."===i?(e.splice(r,1),n++):n&&(e.splice(r,1),n--)}if(t)for(;n--;n)e.unshift("..");return e}function r(e,t){if(e.filter)return e.filter(t);for(var n=[],r=0;r<e.length;r++)t(e[r],r,e)&&n.push(e[r]);return n}var i=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,a=function(e){return i.exec(e).slice(1)};t.resolve=function(){for(var t="",i=!1,a=arguments.length-1;a>=-1&&!i;a--){var o=a>=0?arguments[a]:e.cwd();if("string"!=typeof o)throw new TypeError("Arguments to path.resolve must be strings");o&&(t=o+"/"+t,i="/"===o.charAt(0))}return t=n(r(t.split("/"),function(e){return!!e}),!i).join("/"),(i?"/":"")+t||"."},t.normalize=function(e){var i=t.isAbsolute(e),a="/"===o(e,-1);return e=n(r(e.split("/"),function(e){return!!e}),!i).join("/"),e||i||(e="."),e&&a&&(e+="/"),(i?"/":"")+e},t.isAbsolute=function(e){return"/"===e.charAt(0)},t.join=function(){var e=Array.prototype.slice.call(arguments,0);return t.normalize(r(e,function(e,t){if("string"!=typeof e)throw new TypeError("Arguments to path.join must be strings");return e}).join("/"))},t.relative=function(e,n){function r(e){for(var t=0;t<e.length&&""===e[t];t++);for(var n=e.length-1;n>=0&&""===e[n];n--);return t>n?[]:e.slice(t,n-t+1)}e=t.resolve(e).substr(1),n=t.resolve(n).substr(1);for(var i=r(e.split("/")),a=r(n.split("/")),o=Math.min(i.length,a.length),s=o,u=0;o>u;u++)if(i[u]!==a[u]){s=u;break}for(var l=[],u=s;u<i.length;u++)l.push("..");return l=l.concat(a.slice(s)),l.join("/")},t.sep="/",t.delimiter=":",t.dirname=function(e){var t=a(e),n=t[0],r=t[1];return n||r?(r&&(r=r.substr(0,r.length-1)),n+r):"."},t.basename=function(e,t){var n=a(e)[2];return t&&n.substr(-1*t.length)===t&&(n=n.substr(0,n.length-t.length)),n},t.extname=function(e){return a(e)[3]};var o="b"==="ab".substr(-1)?function(e,t,n){return e.substr(t,n)}:function(e,t,n){return 0>t&&(t=e.length+t),e.substr(t,n)}}).call(t,n(64))},function(e,t,n){"use strict";function r(e,t){var n=e.name();if(T.LowLevelProxyNode.isInstance(t.lowLevel())){if(T.LowLevelProxyNode.isInstance(e.lowLevel()))return n;var r=t.root().lowLevel().unit(),i=r.project().namespaceResolver(),a=e.lowLevel().unit(),o=i.resolveNamespace(r,a);if(null!=o){var s=o.namespace();if(null!=s)return s+"."+n}}if(e.lowLevel().unit()!=t.lowLevel().unit())for(var u=t;;){if(u.lowLevel().includePath()||null==u.parent()){u.unitMap||(u.unitMap={},u.asElement().elements().forEach(function(e){if(e.definition().key()==C.Universe10.UsesDeclaration){var t=e.attr("value");if(t){var n=e.root().lowLevel().unit().resolve(t.value());if(null!=n){var r=e.attr("key");r&&(u.unitMap[n.absolutePath()]=r.value())}}}}));var l=u.unitMap[e.lowLevel().unit().absolutePath()];if(l)return l+"."+n}if(!u.parent())break;u=u.parent()}return n}function i(e){var t=e;return t&&t.valueName&&t.toHighLevel&&t.toHighLevel2}function a(e){var t=e;return t&&t.isString&&t.isFromKey&&t.isEmbedded}function o(e){var t=D.newMap([D.newMapping(D.newScalar("example"),e.lowLevel().actual())]),n=D.newMapping(D.newScalar("types"),D.newMap([D.newMapping(D.newScalar("__AUX_TYPE__"),t)])),r=D.newMap([n]),i=new L.ASTNode(r,e.lowLevel().unit(),null,null,null),a=K.parseFromAST(new G(i,e)),o=K.toNominal(a.types()[0],function(e){return null});return o}function s(e){return e.match(/^\s*#%RAML\s+(\d\.\d)\s*(\w*)\s*$/m)}function u(e){var t=e.lowLevel()&&e.lowLevel().unit()&&e.lowLevel().unit().contents();return null==t?null:J(t,e.lowLevel()).ptype}function l(e){if(null==e)return null;var t=e.contents(),n=e.ast(),r=J(t,n),i=r.ptype,a=r.localUniverse,o=a.type(i);o||(o=a.type("Api"));var s=new z(n,null,o,null);s.setUniverse(a);var u=o&&o.universe();return u&&"RAML10"==u.version()?o.isAssignableFrom(b.universesInfo.Universe10.LibraryBase.name)||s.children():s.children(),s}function p(e,t){if(t){var n=t.root().lowLevel().unit();return n?new j.PointOfViewValidationAcceptorImpl(e,t.root()):{accept:function(t){e.push(t)},begin:function(){},end:function(){},acceptUnique:function(t){for(var n=0,r=e;n<r.length;n++){var i=r[n];if(i.start==t.start&&i.message==t.message)return}this.accept(t)}}}}function c(e){if(null!=e.parent())return!1;var t=e.lowLevel().unit();if(null==t)return!1;var n=t.contents(),r=s(n);return r.length<3?!1:"AnnotationTypeDeclaration"==r[2]}function f(e,t,n){var r=e.validationIssue;if(!r){var i=e.issueCode||t,a=e.node||n,o=e.message||"The "+t+" plugin reports an error",s=e.isWarning;r=M.createIssue(i,o,a,s)}return r}function d(e){for(var t=[],n=S.getNodeValidationPlugins(),r=0,i=n;r<i.length;r++){var a=i[r],o=a.process(e);o&&o.forEach(function(n){var r=f(n,a.id(),e);t.push(r)})}return t}function m(e){for(var t=new Q(e),n=[],r=S.getNodeAnnotationValidationPlugins(),i=0,a=r;i<a.length;i++){var o=a[i],s=o.process(t);s&&s.forEach(function(t){var r=f(t,o.id(),e);n.push(r)})}return n}function h(e,t){var n=e.map(function(e){return v(e,t)}),r=y(n);return r}function y(e){var t=[],n={};e.map(function(e){n[JSON.stringify(e)]=e});for(var r=Object.keys(n),i=0;i<r.length;i++)t.push(n[r[i]]);return t}function v(e,t){var n=e.node&&e.node.lowLevel()&&e.node.lowLevel().unit().lineMapper()||t.lowLevel().unit().lineMapper(),r=null;try{r=n.position(e.start)}catch(i){console.warn(i)}var a=null;try{a=n.position(e.end)}catch(i){console.warn(i)}var o;o=e.path?e.path:e.node?e.node.lowLevel().unit().path():_.declRoot(t).lowLevel().unit().path();var s={code:e.code,message:e.message,path:o,range:{start:r,end:a},isWarning:e.isWarning};return e.extras&&e.extras.length>0&&(s.trace=e.extras.map(function(e){return v(e,t)})),s}var g=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},A=n(39),S=n(9),E=n(65),T=n(41),b=A,N=n(29),_=n(13),w=n(42),M=n(28),I=n(27),R=n(43),C=n(18),L=n(24),P=n(44),O=b,D=n(73),x=n(36),U=n(45),k=n(46),F=n(14),B=n(25),K=A.rt,V=n(31),j=n(2);t.qName=r;var W=function(){function e(e,t){this._node=e,this._parent=t,this._implicit=!1,this.values={},e&&e.setHighLevelParseResult(this)}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&E.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.getKind=function(){return S.NodeKind.BASIC},e.prototype.asAttr=function(){return null},e.prototype.asElement=function(){return null},e.prototype.hashkey=function(){return this._hashkey||(this._hashkey=this.parent()?this.parent().hashkey()+"/"+this.name():this.name()),this._hashkey},e.prototype.root=function(){return this.parent()?this.parent().root():this},e.prototype.version=function(){return""},e.prototype.getLowLevelStart=function(){return this.lowLevel().kind()===L.Kind.SCALAR?this.lowLevel().start():this.lowLevel().keyStart()},e.prototype.getLowLevelEnd=function(){return this.lowLevel().kind()===L.Kind.SCALAR?this.lowLevel().end():this.lowLevel().keyEnd()},e.prototype.isSameNode=function(e){return e&&e.lowLevel().actual()==this.lowLevel().actual()?!0:!1},e.prototype.checkContextValue=function(e,t,n){var r=this.computedValue(e);return r&&-1!=r.indexOf(t)?!0:t==r||"false"==t},e.prototype.printDetails=function(e){return(e?e:"")+"Unkown\n"},e.prototype.testSerialize=function(e){return(e?e:"")+"Unkown\n"},e.prototype.errors=function(){var e=[],t=p(e,this);return this.validate(t),e},e.prototype.markCh=function(){for(var e=this.lowLevel();T.LowLevelProxyNode.isInstance(e);)e=e.originalNode();return e=e._node?e._node:e,e.markCh?!0:void(e.markCh=1)},e.prototype.unmarkCh=function(){for(var e=this.lowLevel();T.LowLevelProxyNode.isInstance(e);)e=e.originalNode();e=e._node?e._node:e,delete e.markCh},e.prototype.validate=function(e){M.validate(this,e);for(var t=0,n=d(this);t<n.length;t++){var r=n[t];e.accept(r)}for(var i=0,a=m(this);i<a.length;i++){var r=a[i];e.accept(r)}},e.prototype.allowRecursive=function(){return!1},e.prototype.setComputed=function(e,t){this.values[e]=t},e.prototype.computedValue=function(e){var t=this.values[e];return!t&&this.parent()?this.parent().computedValue(e):t},e.prototype.lowLevel=function(){return this._node},e.prototype.name=function(){var e=this.lowLevel().key();return e?e:""},e.prototype.optional=function(){var e=this.lowLevel(),t=e.optional();if(null!=e.key())return t;var n=this.property();if(!n||!n.isMultiValue())return t;for(var r=e.parent();r&&null==r.highLevelNode();){if(r.kind()==D.Kind.MAPPING)return r.optional();r=r.parent()}return t},e.prototype.parent=function(){return this._parent},e.prototype.setParent=function(e){this._parent=e},e.prototype.isElement=function(){return!1},e.prototype.directChildren=function(){return this.children()},e.prototype.children=function(){return[]},e.prototype.isAttached=function(){return null!=this.parent()},e.prototype.isImplicit=function(){return this._implicit},e.prototype.isAttr=function(){return!1},e.prototype.isUnknown=function(){return!0},e.prototype.id=function(){var e=this;if(this.cachedId)return this.cachedId;if(this._parent){var t=this.parent().id();t+="."+this.name();var n=this.parent().directChildren().filter(function(t){return t.name()==e.name()});if(n.length>1){var r=n.indexOf(this);t+="["+r+"]"}return this.cachedId=t,t}return this.cachedId="",this.cachedId},e.prototype.localId=function(){return this.name()},e.prototype.resetIDs=function(){this.cachedId=null,this.cachedFullId=null},e.prototype.fullLocalId=function(){var e=this;if(this.cachedFullId)return this.cachedFullId;if(this._parent){var t=".";t+=null!=this.property()&&F.isAnnotationsProperty(this.property())?this.lowLevel().key():this.name();var n=this.parent().directChildren().filter(function(t){return t.name()==e.name()});if(n.length>1){var r=n.indexOf(this);t+="["+r+"]"}return this.cachedFullId=t,t}return this.cachedFullId=this.localId(),this.cachedFullId},e.prototype.property=function(){return null},e.prototype.reuseMode=function(){return this._reuseMode},e.prototype.setReuseMode=function(e){this._reuseMode=e},e.prototype.isReused=function(){return this._isReused},e.prototype.setReused=function(e){this._isReused=e,this.children().forEach(function(t){return t.setReused(e)})},e.prototype.setJSON=function(e){this._jsonCache=e},e.prototype.getJSON=function(){return this._jsonCache},e.CLASS_IDENTIFIER="highLevelImpl.BasicASTNode",e}();t.BasicASTNode=W;var q=function(){function e(e,t,n,r){void 0===r&&(r=null),this.node=e,this._parent=t,this.kv=r,this._pr=n}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&E.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.valueName=function(){var e=null;return this.kv&&(e=this.kv),e=this.node.key(),this._pr&&this._pr.isAnnotation()&&e&&"("==e.charAt(0)&&(e=e.substring(1,e.length-1)),e},e.prototype.children=function(){return this.node.children().map(function(t){return new e(t,null,null)})},e.prototype.lowLevel=function(){return this.node},e.prototype.toHighLevel=function(e){if(!e&&this._parent&&(e=this._parent),this._hl)return this._hl;var t=this.valueName(),n=_.referenceTargets(this._pr,e).filter(function(n){return r(n,e)==t});if(n&&n[0]){var i=n[0].localType(),a=new z(this.node,e,i,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(e){a.setComputed(e.name,e.value)}),this._hl=a,a}return null},e.prototype.toHighLevel2=function(e){!e&&this._parent&&(e=this._parent);var t=this.valueName(),n=_.referenceTargets(this._pr,e).filter(function(n){return r(n,e)==t});if(n&&n[0]){var i=n[0].localType(),a=new z(this.node,e,i,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(e){a.setComputed(e.name,e.value)}),a}if(this._pr.range()){var a=new z(this.node.parent(),e,this._pr.range(),this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(e){a.setComputed(e.name,e.value)}),a}return null},e.prototype.resetHighLevelNode=function(){this._hl=null},e.CLASS_IDENTIFIER="highLevelImpl.StructuredValue",e}();t.StructuredValue=q,t.isStructuredValue=i;var Y=function(e){function t(t,n,r,i,a){void 0===a&&(a=!1),e.call(this,t,n),this._def=r,this._prop=i,this.fromKey=a}return g(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&E.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ASTPropImpl)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_ASTPropImpl)},t.prototype.definition=function(){return this._def},t.prototype.asAttr=function(){return this},t.prototype.errors=function(){var e=[],t=p(e,this);return this.parent().validate(t),e},t.prototype.isString=function(){return!this._def||this._def.key()!==C.Universe08.StringType&&this._def.key()!=C.Universe10.StringType?!1:!0},t.prototype.isAnnotatedScalar=function(){return this.property().isAnnotation()||this.property().isKey()?!1:this.lowLevel().isAnnotatedScalar()},t.prototype.annotations=function(){var e=this.lowLevel().children(),n=[],r=this.definition().universe().type(C.Universe10.Annotable.name);if(!r)return n;for(var i=r.property("annotations"),a=0;a<e.length;a++){var o=e[a],s=o.key();if(null!=s&&"("==s[0]&&")"==s[s.length-1]){var u=new t(o,this.parent(),i.range(),i);n.push(u)}}return n},t.prototype.getKind=function(){return S.NodeKind.ATTRIBUTE},t.prototype.owningWrapper=function(){return{node:this.parent().wrapperNode(),property:this.name()}},t.prototype.patchType=function(e){this._def=e},t.prototype.findReferenceDeclaration=function(){var e=this,t=_.referenceTargets(this.property(),this.parent()),n=this.value();if(q.isInstance(n))var i=n,a=i.valueName();else var a=""+n;var o=E.find(t,function(t){return r(t,e.parent())==a});return o},t.prototype.findReferencedValue=function(){var e=this.findReferenceDeclaration();if(e){var t=e.attr("value"),n=e.definition().key();if(n===C.Universe08.GlobalSchema){if(t){var r=t.value();if(r){var i=M.isValid(this._def,this.parent(),r,t.property(),t);return i}}return null}}return e},t.prototype.isElement=function(){return!1},t.prototype.property=function(){return this._prop},t.prototype.convertMultivalueToString=function(e){for(var t=0,n=2;" "==e[n];)t++,n++;var r=P.splitOnLines(e);return r=r.map(function(e){return e.substring(t,e.length)}),r.join("")},t.prototype.overrideValue=function(e){this._value=e},t.prototype.value=function(){return this._value?this._value:(this._value=this.calcValue(),this._value)},t.prototype.calcValue=function(){if(this._computed)return this.computedValue(this.property().nameId());if(this.fromKey){var e=this.parent(),t=e.definition();if("RAML08"==t.universe().version())return this._node.key();if(F.isNameProperty(this.property())&&t.isAssignableFrom(C.Universe10.TypeDeclaration.name)){var n=e.attr("required");if(n&&null!=n.value())return this._node.optional()?this._node.key()+"?":this._node.key()}return this._node.key()}if(this.property().isAnnotation()&&this._node.key()&&"annotations"!=this._node.key())return new q(this._node,this.parent(),this._prop);var r=null!=this.property()&&!(null==this.parent()||null==this.parent().definition()||F.isTypeProperty(this.property())&&F.isTypeDeclarationSibling(this.parent().definition()))&&F.isStringTypeType(this.property().range()),i=this._node.value(r);if(this.property().isSelfNode()&&(!i||L.ASTNode.isInstance(i))&&(i=this._node,0==i.children().length&&(i=null)),L.ASTNode.isInstance(i)||T.LowLevelProxyNode.isInstance(i)){var a=!1;if(this.property().range().hasStructure()||this._node.isAnnotatedScalar()&&this._node.children().forEach(function(e){"value"===e.key()&&(i=e.value(r),a=!0)}),!a)return this._sval?this._sval:(this._sval=new q(i,this.parent(),this._prop),this._sval)}if("string"==typeof i&&P.isMultiLineValue(i)){var o=this.convertMultivalueToString(i);return o}return null==i&&this._node.children().length>0&&this.property()&&(F.isTypeProperty(this.property())||F.isItemsProperty(this.property()))&&this.parent()&&F.isTypeDeclarationSibling(this.parent().definition())?new q(this._node,this.parent(),this._prop):i},t.prototype.name=function(){return this._prop.nameId()},t.prototype.printDetails=function(e){var t=this.definition().nameId(),n=this.property().range().nameId(),r=(e?e:"")+(this.name()+" : "+t+"["+n+"]  =  "+this.value())+(this.property().isKey()&&this.optional()?"?":"")+"\n";if(q.isInstance(this.value())){var i=this.value().toHighLevel();i&&i.printDetails&&(r+=i.printDetails(e+"	"))}return r},t.prototype.testSerialize=function(e){
var t=this.definition().nameId(),n=(e?e:"")+(this.name()+" : "+t+"  =  "+this.value())+"\n";if(q.isInstance(this.value())){var r=this.value().toHighLevel();if(r&&r.testSerialize)n+=r.testSerialize((e?e:"")+"  ");else{var i=this.value().lowLevel(),a=i.dumpToObject(),o=JSON.stringify(a),s="",u=o.split("\n");u.forEach(function(t){return s+=(e?e:"")+"  "+t+"\n"}),n+=s+"\n"}}return n},t.prototype.isAttr=function(){return!0},t.prototype.isUnknown=function(){return!1},t.prototype.setValue=function(e){w.setValue(this,e),this._value=null},t.prototype.setKey=function(e){w.setKey(this,e),this._value=null},t.prototype.children=function(){return[]},t.prototype.addStringValue=function(e){w.addStringValue(this,e),this._value=null},t.prototype.addStructuredValue=function(e){w.addStructuredValue(this,e),this._value=null},t.prototype.addValue=function(e){if(!this.property().isMultiValue())throw new Error("setValue(string) only apply to multi-values properties");"string"==typeof e?this.addStringValue(e):this.addStructuredValue(e),this._value=null},t.prototype.isEmbedded=function(){var e=this.lowLevel().asMapping().key.value;return this.property().canBeValue()&&e!=this.property().nameId()},t.prototype.remove=function(){w.removeAttr(this)},t.prototype.setValues=function(e){w.setValues(this,e),this._value=null},t.prototype.isEmpty=function(){if(!this.property().isMultiValue())throw new Error("isEmpty() only apply to multi-values attributes");var e=this.parent(),t=(e.lowLevel(),e.attributes(this.name()));if(0==t.length)return!0;if(1==t.length){var n=t[0].lowLevel();return n.isMapping()&&null==n.value()?!0:!1}return!1},t.prototype.isFromKey=function(){return this.fromKey},t.CLASS_IDENTIFIER_ASTPropImpl="highLevelImpl.ASTPropImpl",t}(W);t.ASTPropImpl=Y,t.isASTPropImpl=a;var H=new N.BasicNodeBuilder;!function(e){e[e.MERGE=0]="MERGE",e[e.AGGREGATE=1]="AGGREGATE"}(t.OverlayMergeMode||(t.OverlayMergeMode={}));var $=t.OverlayMergeMode,G=function(e){function t(n,r){e.call(this),this._node=n,this._highLevelRoot=r;var i=r.root(),a=i.getMaster();if(a&&this._node===r.lowLevel()){var o=r.getMasterCounterPart();o&&(this._toMerge=new t(o.lowLevel(),o))}}return g(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&E.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_LowLevelWrapperForTypeSystem)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_LowLevelWrapperForTypeSystem)},t.prototype.contentProvider=function(){var e=this._node&&this._node.includeBaseUnit()&&(this._node.includePath&&this._node.includePath()?this._node.includeBaseUnit().resolve(this._node.includePath()):this._node.includeBaseUnit());return new V.ContentProvider(e)},t.prototype.key=function(){var e=this._node.key();return this._node.optional()&&(e+="?"),e},t.prototype.value=function(){var e=this._node.valueKind();if(e===D.Kind.SEQ)return this.children().map(function(e){return e.value()});if(e===D.Kind.MAP||e===D.Kind.ANCHOR_REF){var n=this._node.dumpToObject(!1);return n[this.key()]}if(this._node.kind()==D.Kind.MAP){var n=this._node.dumpToObject(!1);return n}if(e===D.Kind.INCLUDE_REF){var r=null,i=this._node.includePath();try{r=this._node.unit().resolve(i)}catch(a){}if(null!=r&&r.isRAMLUnit()){var o=r.ast(),s=new t(o,r.highLevel().asElement());return o.kind()==D.Kind.SEQ?s.children().map(function(e){return e.value()}):s.value()}}var u=this._node.value();return u},t.prototype.children=function(){var e=this;if(this._children)return this._children;"uses"!=this.key()||this._node.parent().parent()?this._children=this._node.children().map(function(n){return new t(n,e._highLevelRoot)}):this._children=this._node.children().map(function(t){return new X(t,e._highLevelRoot)}),this.childByKey={};for(var n=0;n<this._children.length;n++){var r=this._children[n];this.childByKey[r.key()]=r}if(this._toMerge)for(var i=this._toMerge.children(),n=0;n<i.length;n++){var r=i[n],a=this.childByKey[r.key()];a?a._toMerge=r:(this._children.push(r),this.childByKey[r.key()]=r)}return this._children},t.prototype.childWithKey=function(e){return this._children||this.children(),this.childByKey[e]},t.prototype.kind=function(){var e=this._node.valueKind();if(e==D.Kind.MAPPING||null===e)return K.NodeKind.MAP;if(e==D.Kind.MAP)return K.NodeKind.MAP;var t=this._node.kind();return t==D.Kind.MAP?K.NodeKind.MAP:e==D.Kind.SEQ?K.NodeKind.ARRAY:(e==D.Kind.INCLUDE_REF||e==D.Kind.ANCHOR_REF)&&this._node.children().length>0?K.NodeKind.MAP:K.NodeKind.SCALAR},t.prototype.getSource=function(){if(!this._node)return null;var e=this._node.highLevelNode();if(!e){var t=this._node.start(),n=_.deepFindNode(this._highLevelRoot,t,t,!0,!1);return n&&(this._node.setHighLevelParseResult(n),z.isInstance(n)&&this._node.setHighLevelNode(n)),n}return e},t.prototype.node=function(){return this._node},t.CLASS_IDENTIFIER_LowLevelWrapperForTypeSystem="highLevelImpl.LowLevelWrapperForTypeSystem",t}(A.SourceProvider);t.LowLevelWrapperForTypeSystem=G;var X=function(e){function t(){e.apply(this,arguments)}return g(t,e),t.prototype.children=function(){var e=this._node.unit().resolve(this.value());return e&&e.isRAMLUnit()&&e.contents().trim().length>0?new G(e.ast(),this._highLevelRoot).children():[]},t.prototype.anchor=function(){return this._node.actual()},t.prototype.childWithKey=function(e){for(var t=this.children(),n=0;n<t.length;n++)if(t[n].key()==e)return t[n];return null},t}(G);t.UsesNodeWrapperFoTypeSystem=X,t.auxiliaryTypeForExample=o;var z=function(e){function t(t,n,r,i){e.call(this,t,n),this._def=r,this._prop=i,this._expanded=!1,this._allowQuestion=!1,this._subTypesCache=null,this._auxChecked=!1,this.overlayMergeMode=$.MERGE,t&&t.setHighLevelNode(this),T.LowLevelProxyNode.isInstance(t)&&(this._expanded=!0)}return g(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&E.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ASTNodeImpl)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_ASTNodeImpl)},t.prototype.createIssue=function(e){return M.toIssue(e,this)},t.prototype.validate=function(t){var n=this.definition().key();if((n==C.Universe10.Api||n==C.Universe08.Api||n==C.Universe10.Extension)&&!this.isExpanded()){var r=I.expandTraitsAndResourceTypes(this.wrapperNode()),i=r.highLevel();return i.resetChildren(),i.children(),i._expanded=!0,i.clearTypesCache(),void i.validate(t)}(n==C.Universe10.Overlay||n==C.Universe10.Extension)&&this.clearTypesCache(),e.prototype.validate.call(this,t)},t.prototype.clearTypesCache=function(){if(this._types=null,this.lowLevel()){var e=this.lowLevel().actual();e.types=null}},t.prototype.types=function(){var e=this;if(!this._types){if(this.parent()&&this.definition().key()!==C.Universe10.Library)return this.parent().types();var t=this.lowLevel().actual();if(t.types)return t.types;this._types=K.parseFromAST(new G(this.lowLevel(),this)),this._types.types().forEach(function(t){var n=R.convertType(e,t);n.putExtra(A.USER_DEFINED_EXTRA,!0)}),t.types=this._types}return this._types},t.prototype.setTypes=function(e){this._types=e},t.prototype.parsedType=function(){if(!this._ptype){if(this.property()&&this.property().nameId()==C.Universe10.MethodBase.properties.body.name){var e=this.isParametrizedType();this._ptype=K.parseTypeFromAST(this.name(),new G(this.lowLevel(),this),this.types(),!0,!1,!1,e)}else{var t=this.property()&&this.property().nameId()==C.Universe10.LibraryBase.properties.annotationTypes.name,n=!this.property()||this.property().nameId()==C.Universe10.LibraryBase.properties.types.name||this.property().nameId()==C.Universe10.LibraryBase.properties.schemas.name;if(!t&&null==this.parent()){var r=this.universe();r&&r.getOriginalTopLevelText()&&"AnnotationTypeDeclaration"==r.getOriginalTopLevelText()&&(t=!0)}this._ptype=K.parseTypeFromAST(this.name(),new G(this.lowLevel(),this),this.types(),!1,t,n)}this.property()&&F.isTypesProperty(this.property())&&this.parent()&&F.isApiType(this.parent().definition())&&this._ptype.putExtra&&this._ptype.putExtra(A.DEFINED_IN_TYPES_EXTRA,!0);var i=this._ptype;i.putExtra(A.USER_DEFINED_EXTRA,!0),this._ptype.putExtra(A.SOURCE_EXTRA,this)}return this._ptype},t.prototype.isParametrizedType=function(){var e=!1,t=this.attr(C.Universe10.TypeDeclaration.properties.type.name);if(t){var n=t.value();if("string"==typeof n&&n.indexOf("<<")>=0)for(var r=this.parent();null!=r;){if(F.isResourceTypeType(r.definition())||F.isTraitType(r.definition())){e=!0;break}r=r.parent()}}return e},t.prototype.localType=function(){return R.typeFromNode(this)},t.prototype.patchProp=function(e){this._prop=e},t.prototype.getKind=function(){return S.NodeKind.NODE},t.prototype.wrapperNode=function(){if(!this._wrapperNode){if(F.isExampleSpecType(this.definition())){var e=o(this),t=x.examplesFromNominal(e,this,!0,!1);return t[0]}var n=this.definition()&&this.definition().universe();n&&"RAML10"==n.version()?this.definition()&&this.definition().isAssignableFrom(b.universesInfo.Universe10.LibraryBase.name)||this.children():this.children(),this._wrapperNode=this.buildWrapperNode()}return this._wrapperNode},t.prototype.asElement=function(){return this},t.prototype.buildWrapperNode=function(){var e=this.definition().universe().version();return"RAML10"==e?U.buildWrapperNode(this):"RAML08"==e?k.buildWrapperNode(this):null},t.prototype.propertiesAllowedToUse=function(){var e=this;return this.definition().allProperties().filter(function(t){return e.isAllowedToUse(t)})},t.prototype.isAllowedToUse=function(e){var t=this,n=!0;return e.getAdapter(O.RAMLPropertyService).isSystem()?!1:(e.getContextRequirements().forEach(function(e){if(-1!=e.name.indexOf("("))return!0;var r=t.computedValue(e.name);r?n=n&&r==e.value:e.value&&(n=!1)}),n)},t.prototype.allowRecursive=function(){return this.definition().getAdapter(O.RAMLService).isUserDefined()?!0:!1},t.prototype.setWrapperNode=function(e){this._wrapperNode=e},t.prototype.setAssociatedType=function(e){this._associatedDef=e},t.prototype.associatedType=function(){return this._associatedDef},t.prototype.knownIds=function(){return this.isAuxilary(),this._knownIds?this._knownIds:{}},t.prototype.findById=function(e){var t=this,n=this.root();if(n!=this)return n.findById(e);if(!this._knownIds){this._knownIds={};var r=_.allChildren(this);r.forEach(function(e){return t._knownIds[e.id()]=e})}if(this.isAuxilary()){if(!this._slaveIds){this._slaveIds={};var r=_.allChildren(this);r.forEach(function(e){return t._slaveIds[e.id()]=e})}var i=this._slaveIds[e];if(i)return i}return this._knownIds[e]},t.prototype.isAuxilary=function(){if(this._isAux)return!0;if(this._auxChecked)return!1;this._auxChecked=!0;var e=this.getMaster();return e?(this._isAux=!0,this.initilizeKnownIDs(e),!0):!1},t.prototype.initilizeKnownIDs=function(e){var t=this;this._knownIds={};var n=_.allChildren(e);n.forEach(function(e){return t._knownIds[e.id()]=e}),this._knownIds[""]=e},t.prototype.getMaster=function(){if(this.masterApi)return this.masterApi;var e=this.calculateMasterByRef();return e&&e.setSlave(this),e},t.prototype.overrideMaster=function(e){this.masterApi=e,this.resetAuxilaryState(),e&&e.setSlave(this)},t.prototype.setSlave=function(e){this.slave=e},t.prototype.setMergeMode=function(e){this.overlayMergeMode=e,this.resetAuxilaryState()},t.prototype.getMergeMode=function(){return this.overlayMergeMode},t.prototype.calculateMasterByRef=function(){var e=this.lowLevel().unit();if(!e)return null;var t=e.getMasterReferenceNode();if(!t||!t.value())return null;var n=this.lowLevel();if(n.master)return n.master;var r=t.value(),i=this.lowLevel().unit().project().resolve(this.lowLevel().unit().path(),r);if(!i)return null;var a=i.expandedHighLevel();return a.setMergeMode(this.overlayMergeMode),n.master=a,a},t.prototype.resetAuxilaryState=function(){this._isAux=!1,this._auxChecked=!1,this._knownIds=null,this.clearChildrenCache()},t.prototype.printDetails=function(e){var t="";e||(e="");var n=this.definition().nameId(),r=this.property()?this.property().range().nameId():"",i=this.property()?this.property().nameId():"";return t+=e+n+"["+r+"] <--- "+i+"\n",this.children().forEach(function(n){t+=n.printDetails(e+"	")}),t},t.prototype.testSerialize=function(e){var t="";e||(e="");var n=this.definition().nameId(),r=this.property()?this.property().nameId():"";return t+=e+n+" <-- "+r+"\n",this.children().forEach(function(n){n.testSerialize&&(t+=n.testSerialize(e+"  "))}),t},t.prototype.getExtractedChildren=function(){var e=this.root();if(e.isAuxilary()){if(e._knownIds){var t=e._knownIds[this.id()];if(t){var n=t.children();return n}}return[]}return[]},t.prototype.getMasterCounterPart=function(){var e=this.root();if(e.isAuxilary()){if(e._knownIds){var t=e._knownIds[this.id()];return t}return null}return null},t.prototype.getExtractedLowLevelChildren=function(e){var t=this.root();if(t.isAuxilary()){if(t._knownLowLevelIds){var n=t._knownLowLevelIds[this.id()];if(n)return n.children()}return[]}return[]},t.prototype.allowsQuestion=function(){return this._allowQuestion||this.definition().getAdapter(O.RAMLService).getAllowQuestion()},t.prototype.findReferences=function(){var e=this,t=[];_.refFinder(this.root(),this,t),t.length>1&&(t=t.filter(function(t){return t!=e&&t.parent()!=e}));var n=[];return t.forEach(function(e){E.find(n,function(t){return t==e})||n.push(e)}),n},t.prototype.setNamePatch=function(e){this._patchedName=e},t.prototype.isNamePatch=function(){return this._patchedName},t.prototype.name=function(){if(this._patchedName)return this._patchedName;var t=E.find(this.directChildren(),function(e){return e.property()&&e.property().getAdapter(O.RAMLPropertyService).isKey()});if(t&&Y.isInstance(t)){var n=null,r=this.definition(),i=r.universe().version();if(r&&"RAML10"==i&&t.isFromKey()){var a=this._node.key();n=this._node.optional()?a+"?":a}else n=t.value();return n}return e.prototype.name.call(this)},t.prototype.findElementAtOffset=function(e){return this._findNode(this,e,e)},t.prototype.isElement=function(){return!0},t.prototype.universe=function(){return this._universe?this._universe:this.definition().universe()},t.prototype.setUniverse=function(e){this._universe=e},t.prototype._findNode=function(e,t,n){var r=this;if(null==e)return null;if(e.lowLevel()&&e.lowLevel().start()<=t&&e.lowLevel().end()>=n){var i=e;return e.elements().forEach(function(a){if(a.lowLevel().unit()==e.lowLevel().unit()){var o=r._findNode(a,t,n);o&&(i=o)}}),i}return null},t.prototype.isStub=function(){return!this.lowLevel().unit()||this.lowLevel().unit().isStubUnit()},t.prototype.add=function(e){w.addToNode(this,e)},t.prototype.remove=function(e){w.removeNodeFrom(this,e)},t.prototype.dump=function(e){return this._node.dump()},t.prototype.patchType=function(e){this._def=e;this._associatedDef;this._associatedDef=null,this._children=null,this._mergedChildren=null},t.prototype.children=function(){var e=this.lowLevel();return e&&e.isValueInclude&&e.isValueInclude()&&B.isWaitingFor(e.includePath())?(this._children=null,[]):this._children?this._mergedChildren?this._mergedChildren:(this._mergedChildren=this.mergeChildren(this._children,this.getExtractedChildren()),this._mergedChildren):this._node?(this._children=H.process(this,this._node.children()),this._children=this._children.filter(function(e){return null!=e}),this.mergeChildren(this._children,this.getExtractedChildren())):[]},t.prototype.mergeChildren=function(e,t){var n=this,r=this.root();if(r.overlayMergeMode==$.AGGREGATE)return e.concat(t);if(r.overlayMergeMode==$.MERGE){var i=[];return e.forEach(function(e){var r=E.find(t,function(t){return t.fullLocalId()==e.fullLocalId()});r?n.mergeChild(i,e,r):i.push(e)}),t.forEach(function(t){var n=E.find(e,function(e){return t.fullLocalId()==e.fullLocalId()});n||i.push(t)}),i}return null},t.prototype.mergeLowLevelChildren=function(e,t){var n=this,r=this.root();if(r.overlayMergeMode==$.AGGREGATE)return e.concat(t);if(r.overlayMergeMode==$.MERGE){var i=[];return e.forEach(function(e){var r=E.find(t,function(t){return t.key()==e.key()});r?n.mergeLowLevelChild(i,e,r):i.push(e)}),t.forEach(function(t){var n=E.find(e,function(e){return t.key()==e.key()});n||i.push(t)}),i}return null},t.prototype.mergeLowLevelChild=function(e,t,n){return t.kind()!=n.kind()?(e.push(t),void e.push(n)):void e.push(t)},t.prototype.mergeChild=function(e,t,n){return t.getKind()!=n.getKind()?(e.push(t),void e.push(n)):t.getKind()==S.NodeKind.NODE?void e.push(t):t.getKind()==S.NodeKind.ATTRIBUTE?void e.push(t):t.getKind()==S.NodeKind.BASIC?(e.push(t),void e.push(n)):void 0},t.prototype.directChildren=function(){return this._children?this._children:this._node?(this._children=H.process(this,this._node.children()),this._mergedChildren=null,this._children):[]},t.prototype.resetChildren=function(){this._children=null,this._mergedChildren=null},t.prototype.isEmptyRamlFile=function(){var e=this.lowLevel().root();return e.isScalar()},t.prototype.initRamlFile=function(){w.initEmptyRAMLFile(this)},t.prototype.createAttr=function(e,t){w.createAttr(this,e,t)},t.prototype.isAttr=function(){return!1},t.prototype.isUnknown=function(){return!1},t.prototype.value=function(){return this._node.value()},t.prototype.valuesOf=function(e){var t=this._def.property(e);return null!=t?this.elements().filter(function(e){return e.property()==t}):[]},t.prototype.attr=function(e){return E.find(this.attrs(),function(t){return t.name()==e})},t.prototype.attrOrCreate=function(e){var t=this.attr(e);return t||this.createAttr(e,""),this.attr(e)},t.prototype.attrValue=function(e){var t=this.attr(e);return t?t.value():null},t.prototype.attributes=function(e){return E.filter(this.attrs(),function(t){return t.name()==e})},t.prototype.attrs=function(){var e=this.children().filter(function(e){return e.isAttr()});if(this._patchedName){var t=E.find(this.definition().allProperties(),function(e){return e.getAdapter(O.RAMLPropertyService).isKey()});if(t){var n=new Y(this.lowLevel(),this,t.range(),t,!0);return n._value=this._patchedName,[n].concat(e)}}return e},t.prototype.elements=function(){return this.children().filter(function(e){return!e.isAttr()&&!e.isUnknown()})},t.prototype.element=function(e){var t=this.elementsOfKind(e);return t.length>0?t[0]:null},t.prototype.elementsOfKind=function(e){var t=this.elements().filter(function(t){return t.property().nameId()==e});return t},t.prototype.definition=function(){return this._def},t.prototype.property=function(){return this._prop},t.prototype.isExpanded=function(){return this._expanded},t.prototype.copy=function(){return new t(this.lowLevel().copy(),this.parent(),this.definition(),this.property())},t.prototype.clearChildrenCache=function(){this._children=null,this._mergedChildren=null},t.prototype.optionalProperties=function(){var e=this.definition();if(null==e)return[];var t=[],n={},r=this.lowLevel().children();r.forEach(function(e){e.optional()&&(n[e.key()]=!0)});var i=e.allProperties();return i.forEach(function(e){var r=e;n[r.nameId()]&&t.push(r.nameId())}),t},t.prototype.setReuseMode=function(e){this._reuseMode=e,this._children&&this.lowLevel().valueKind()!=D.Kind.SEQ&&this._children.forEach(function(t){return t.setReuseMode(e)})},t.prototype.reusedNode=function(){return this._reusedNode},t.prototype.setReusedNode=function(e){this._reusedNode=e},t.prototype.resetRuntimeTypes=function(){delete this._associatedDef,this.elements().forEach(function(e){return e.resetRuntimeTypes()})},t.CLASS_IDENTIFIER_ASTNodeImpl="highLevelImpl.ASTNodeImpl",t}(W);t.ASTNodeImpl=z,t.universeProvider=n(38);var J=function(e,n){var r=s(e),i=r&&r[1]||"",a=r&&r.length>2&&r[2]||"Api",o=r&&r.length>2&&r[2],u="1.0"==i?new b.Universe(null,"RAML10",t.universeProvider("RAML10"),"RAML10"):new b.Universe(null,"RAML08",t.universeProvider("RAML08"));return"API"==a?a="Api":"NamedExample"==a?a="ExampleSpec":"DataType"==a?a="TypeDeclaration":"SecurityScheme"==a?a="AbstractSecurityScheme":"AnnotationTypeDeclaration"==a&&(a="TypeDeclaration"),u.setOriginalTopLevelText(o),u.setTopLevel(a),u.setTypedVersion(i),{ptype:a,localUniverse:u}};t.ramlFirstLine=s,t.getFragmentDefenitionName=u,t.fromUnit=l,t.createBasicValidationAcceptor=p,t.isAnnotationTypeFragment=c;var Q=function(){function e(e){this._node=e}return e.prototype.kind=function(){return"AnnotatedNode"},e.prototype.annotationsMap=function(){var e=this;return this._annotationsMap||(this._annotationsMap={},this.annotations().forEach(function(t){var n=t.name(),r=n.lastIndexOf(".");r>=0&&(n=n.substring(r+1)),e._annotationsMap[n]=t})),this._annotationsMap},e.prototype.annotations=function(){if(!this._annotations){var e=[];this._node.isElement()?e=this._node.asElement().attributes(b.universesInfo.Universe10.Annotable.properties.annotations.name):this._node.isAttr()&&(e=this._node.asAttr().annotations()),this._annotations=e.map(function(e){return new Z(e)})}return this._annotations},e.prototype.value=function(){if(this._node.isElement())return this._node.asElement().wrapperNode().toJSON();if(this._node.isAttr()){var e=this._node.asAttr().value();return q.isInstance(e)?e.lowLevel().dump():e}return this._node.lowLevel().dump()},e.prototype.name=function(){return this._node.name()},e.prototype.entry=function(){return this._node},e}();t.AnnotatedNode=Q;var Z=function(){function e(e){this.attr=e}return e.prototype.name=function(){return this.attr.value().valueName()},e.prototype.value=function(){var e=this.attr.value();if(q.isInstance(e)){var t=e.lowLevel().dumpToObject(),n=Object.keys(t)[0];return t[n]}return e},e.prototype.definition=function(){var e=this.attr.parent(),t=this.name(),n=_.referenceTargets(this.attr.property(),e).filter(function(n){return r(n,e)==t});return 0==n.length?null:n[0].parsedType()},e}();t.AnnotationInstance=Z,t.applyNodeValidationPlugins=d,t.applyNodeAnnotationValidationPlugins=m,t.toParserErrors=h},function(e,t,n){"use strict";function r(e,t,n){var r=e.definition().property(t);if(!r)return null;var i=r.range(),a=d(i,r,n);return a}function i(e,t,n,r){var i=y.newMap(n.map(function(e){return y.newMapping(y.newScalar(e.key),y.newScalar(e.value))})),a=new m.ASTNode(i,r?r.lowLevel().unit():null,r?r.lowLevel():null,null,null);return new h.StructuredValue(a,r,r?r.definition().property(e):null,t)}function a(e,t,n){var r=e.definition().property(t);if(!r)return null;var i=r.range(),a=e.lowLevel().unit().stub(),o=d(i,r,n,a);return o.isInEdit=!0,o.lowLevel()._unit=a,o._parent=e.copy(),o._parent.lowLevel()._unit=a,o}function o(e,t){return a(e,"resources",t)}function s(e,t){return a(e,"methods",t)}function u(e,t){return a(e,"responses",t)}function l(e,t){return a(e,"body",t)}function p(e,t){return a(e,"uriParameters",t)}function c(e,t){return a(e,"queryParameters",t)}function f(e,t){var n=m.createMapping(e.nameId(),t),r=new h.ASTPropImpl(n,null,e.range(),e);return r}function d(e,t,n,r){void 0===n&&(n=null);var i=m.createNode(n?n:"key",null,r),a=new h.ASTNodeImpl(i,null,e,t);return i.unit()||(i._unit=r),a.children(),a}var m=n(24),h=n(16),y=n(73);t.createStub0=r,t.genStructuredValue=i,t.createStub=a,t.createResourceStub=o,t.createMethodStub=s,t.createResponseStub=u,t.createBodyStub=l,t.createUriParameterStub=p,t.createQueryParameterStub=c,t.createAttr=f,t.createStubNode=d},function(e,t,n){"use strict";var r=n(39);e.exports=r.universesInfo},function(e,t,n){"use strict";var r=n(65),i=n(44),a=n(21),o=function(){function e(){}return e.prototype.generateText=function(e){var t=this,n=JSON.parse(e),r=n.items;if(!r)return"";var i="",a=r instanceof Array?r:[r];return i+="types:\n",a.forEach(function(e){i+="  - "+e.title+":\n",i+=t.generateObj(e,3)}),i},e.prototype.generateObj=function(e,t){var n="";if(n+=i.indent(t,"type: "+e.type)+"\n",e.properties){n+=i.indent(t,"properties:\n");for(var r in e.properties){var a=e.properties[r];n+=i.indent(t+1,r+":\n"),n+="object"==a.type?this.generateObj(a,t+2):i.indent(t+2,"type: "+a.type)+"\n"}return n}},e.prototype.generateTo=function(e,t,n){var r=this,i=JSON.parse(t),o=i.items;if(o){var s=o instanceof Array?o:[o],u=[];return s.forEach(function(t){var n=new a.ObjectTypeDeclarationImpl(t.title);r.generateObjTo(n,t),new a.BasicSecuritySchemeImpl(e).addToProp(n,"types"),u.push(t.title)}),u}i.title&&(n=i.title);var l=new a.ObjectTypeDeclarationImpl(n);return this.generateObjTo(l,i),new a.BasicSecuritySchemeImpl(e).addToProp(l,"types"),[n]},e.prototype.generateObjTo=function(e,t){if(e.setType(t.type),t.properties)for(var n in t.properties){var r=t.properties[n],i=this.makeTypeField(n,r);"array"==r.type,e.addToProp(i,"properties")}},e.prototype.makeTypeField=function(e,t){var n=this.makeType(e,t.type);if(t.type&&n.setType(t.type),"number"==t.type){var r=n;void 0!=t.minimum&&r.setMinimum(t.minimum),void 0!=t.maximum&&r.setMaximum(t.maximum)}if("array"==t.type){var i=t.items.type;n.setType(i+"[]");var a=n;void 0!=t.minItems&&a.setMinItems(t.minItems),void 0!=t.maxItems&&a.setMaxItems(t.maxItems),void 0!=t.uniqueItems&&a.setUniqueItems(t.uniqueItems)}return"object"==t.type&&this.generateObjTo(n,t),n},e.prototype.makeType=function(e,t){return"number"==t?new a.NumberTypeDeclarationImpl(e):"string"==t?new a.StringTypeDeclarationImpl(e):"array"==t?new a.ArrayTypeDeclarationImpl(e):new a.ObjectTypeDeclarationImpl(e)},e.prototype.generateItemsTo=function(e,t){var n=t.items;if(n){var r=n instanceof Array?n:[n];r.forEach(function(e){})}},e}();t.SchemaToModelGenerator=o;var s=function(){function e(){}return e.prototype.generateSchema=function(e){var t=this.generateType(e);return t.$schema="http://json-schema.org/draft-04/schema#",t},e.prototype.isSimpleType=function(e){return"string"==e||"number"==e||"boolean"==e||"object"==e},e.prototype.generateType=function(e){var t=this.allTypes(e),n={};n.title=e.attrValue("name");if(e.attrValue("type")){var i=e.attributes("type"),a=!1,o=!1;for(var s in i){var u=i[s].value(),l=i[s].lowLevel();if(n.type="",l.isValueInclude()){var p=JSON.parse(u);n.type="object",n.properties=p.properties}else if(this.isSimpleType(u)){if(n.type=u,o=!0,a)throw new Error("couldn't mix user defined and basic types in inheritance")}else{var c=this.resolveType(e,u);if(c){var f=this.generateTypeExp(u,t);if(n.properties?r.extend(n.properties,f.properties):n.properties=f.properties,n.type="object",a=!0,o)throw new Error("couldn't mix user defined and basic types in inheritance")}else{var f=this.generateTypeExp(u,t);n.type="object",a=!0,f.anyOf&&(n.anyOf=f.anyOf)}}}}else n.type="object";var d=this.generateProperties(e);return n.properties?r.extend(n.properties,d):n.properties=d,n},e.prototype.makeUnion=function(e,t){var n=this,r=[];return e.forEach(function(e){e=e.trim(),t[e]?r.push({type:"object",properties:n.generateType(t[e]).properties}):r.push({type:e})}),r},e.prototype.generateTypeExp=function(e,t){var n={};if(i.endsWith(e,"[]"))n.type="array",n.items={type:e.substring(0,e.length-2)};else if(e.indexOf("|")>0){var r=e.split("|");n.anyOf=this.makeUnion(r,t)}else if(t[e]){var a=this.generateType(t[e]);n.type="object",n.properties=a.properties}else n.type=e;return n},e.prototype.allTypes=function(e){var t=e.root(),n=t.elementsOfKind("types"),r={};return n.forEach(function(e){r[e.name()]=e}),r},e.prototype.resolveType=function(e,t){var n=this.allTypes(e);return n[t]},e.prototype.generateProperty=function(e,t){var n=this,i=this.allTypes(e),a={},o=e.definition().allProperties();o.forEach(function(t){if("name"!=t.nameId()){var o=e.attrValue(t.nameId());if(null!=o&&void 0!=o&&"undefined"!=o)if("type"==t.nameId()){var s=n.generateTypeExp(o,i);r.extend(a,s)}else if("enum"==t.nameId()){var u=e.attributes("enum"),l=u.map(function(e){return e.value()});a["enum"]=l}else a[t.nameId()]=o}}),t&&(a.required=!1);var s=(e.elements(),this.generateProperties(e));return Object.getOwnPropertyNames(s).length>0&&(a.properties=s),a},e.prototype.generateProperties=function(e){var t=this,n={},r=e.elements(),i=!0;return r.forEach(function(e){var r=e.attrValue("name");if("string"==typeof r){r=r.trim();var a=e.optional();n[r]=t.generateProperty(e,a),i=!1}}),n},e}();t.ModelToSchemaGenerator=s},function(e,t,n){"use strict";function r(e){return new u.TypeDeclarationImpl(e)}function i(e){return new u.ObjectTypeDeclarationImpl(e)}function a(e,t){e.setSchema(t)}function o(e,t){var n=(l.getUniverse("RAML10").type(l.universesInfo.Universe10.ExampleSpec.name),l.universesInfo.Universe10.TypeDeclaration.properties.example.name),r=e.highLevel(),i=r.lowLevel(),a=r.children().filter(function(e){return e.lowLevel().key()==n}),o=p.createNode(n);c.setAttr(o,t),a.length>0&&(c.removeNode(i,a[0].lowLevel()),a[0]._node=o,c.insertNode(i,o)),r.createAttr&&r.createAttr(n,t)}function s(e,t){e.add(t)}var u=n(21),l=n(39),p=n(24),c=n(10);t.createTypeDeclaration=r,t.createObjectTypeDeclaration=i,t.setTypeDeclarationSchema=a,t.setTypeDeclarationExample=o,t.addChild=s},function(e,t,n){"use strict";function r(e){var t=J.getUniverse("RAML10"),n=t.type("Api"),r=z.createStubNode(n,null,e);return r}function i(e){var t=J.getUniverse("RAML10"),n=t.type("LibraryBase"),r=z.createStubNode(n,null,e);return r}function a(e){var t=J.getUniverse("RAML10"),n=t.type("FragmentDeclaration"),r=z.createStubNode(n,null,e);return r}function o(e){var t=J.getUniverse("RAML10"),n=t.type("Trait"),r=z.createStubNode(n,null,e);return r}function s(e){var t=J.getUniverse("RAML10"),n=t.type("MethodBase"),r=z.createStubNode(n,null,e);return r}function u(e){var t=J.getUniverse("RAML10"),n=t.type("Operation"),r=z.createStubNode(n,null,e);return r}function l(e){var t=J.getUniverse("RAML10"),n=t.type("TypeDeclaration"),r=z.createStubNode(n,null,e);return r}function p(e){var t=J.getUniverse("RAML10"),n=t.type("UsesDeclaration"),r=z.createStubNode(n,null,e);return r}function c(e){var t=J.getUniverse("RAML10"),n=t.type("XMLFacetInfo"),r=z.createStubNode(n,null,e);return r}function f(e){var t=J.getUniverse("RAML10"),n=t.type("ArrayTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function d(e){var t=J.getUniverse("RAML10"),n=t.type("UnionTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function m(e){var t=J.getUniverse("RAML10"),n=t.type("ObjectTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function h(e){var t=J.getUniverse("RAML10"),n=t.type("StringTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function y(e){var t=J.getUniverse("RAML10"),n=t.type("BooleanTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function v(e){var t=J.getUniverse("RAML10"),n=t.type("NumberTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function g(e){var t=J.getUniverse("RAML10"),n=t.type("IntegerTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function A(e){var t=J.getUniverse("RAML10"),n=t.type("DateOnlyTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function S(e){var t=J.getUniverse("RAML10"),n=t.type("TimeOnlyTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function E(e){var t=J.getUniverse("RAML10"),n=t.type("DateTimeOnlyTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function T(e){var t=J.getUniverse("RAML10"),n=t.type("DateTimeTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function b(e){var t=J.getUniverse("RAML10"),n=t.type("FileTypeDeclaration"),r=z.createStubNode(n,null,e);return r}function N(e){var t=J.getUniverse("RAML10"),n=t.type("Response"),r=z.createStubNode(n,null,e);return r}function _(e){var t=J.getUniverse("RAML10"),n=t.type("SecuritySchemePart"),r=z.createStubNode(n,null,e);return r}function w(e){var t=J.getUniverse("RAML10"),n=t.type("AbstractSecurityScheme"),r=z.createStubNode(n,null,e);return r}function M(e){var t=J.getUniverse("RAML10"),n=t.type("SecuritySchemeSettings"),r=z.createStubNode(n,null,e);return r}function I(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth1SecuritySchemeSettings"),r=z.createStubNode(n,null,e);return r}function R(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth2SecuritySchemeSettings"),r=z.createStubNode(n,null,e);return r}function C(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth2SecurityScheme"),r=z.createStubNode(n,null,e);
return r}function L(e){var t=J.getUniverse("RAML10"),n=t.type("OAuth1SecurityScheme"),r=z.createStubNode(n,null,e);return r}function P(e){var t=J.getUniverse("RAML10"),n=t.type("PassThroughSecurityScheme"),r=z.createStubNode(n,null,e);return r}function O(e){var t=J.getUniverse("RAML10"),n=t.type("BasicSecurityScheme"),r=z.createStubNode(n,null,e);return r}function D(e){var t=J.getUniverse("RAML10"),n=t.type("DigestSecurityScheme"),r=z.createStubNode(n,null,e);return r}function x(e){var t=J.getUniverse("RAML10"),n=t.type("CustomSecurityScheme"),r=z.createStubNode(n,null,e);return r}function U(e){var t=J.getUniverse("RAML10"),n=t.type("Method"),r=z.createStubNode(n,null,e);return r}function k(e){var t=J.getUniverse("RAML10"),n=t.type("ResourceType"),r=z.createStubNode(n,null,e);return r}function F(e){var t=J.getUniverse("RAML10"),n=t.type("ResourceBase"),r=z.createStubNode(n,null,e);return r}function B(e){var t=J.getUniverse("RAML10"),n=t.type("Resource"),r=z.createStubNode(n,null,e);return r}function K(e){var t=J.getUniverse("RAML10"),n=t.type("DocumentationItem"),r=z.createStubNode(n,null,e);return r}function V(e){var t=J.getUniverse("RAML10"),n=t.type("Library"),r=z.createStubNode(n,null,e);return r}function j(e){var t=J.getUniverse("RAML10"),n=t.type("Overlay"),r=z.createStubNode(n,null,e);return r}function W(e){var t=J.getUniverse("RAML10"),n=t.type("Extension"),r=z.createStubNode(n,null,e);return r}function q(e,t,n){return Z.loadApi(e,t,n).getOrElse(null)}function Y(e,t,n){return Z.loadApi(e,t,n).getOrElse(null)}function H(e,t,n){return Z.loadApiAsync(e,t,n)}function $(e,t,n){return Z.loadRAMLAsync(e,t,n)}function G(e){return Z.getLanguageElementByRuntimeType(e)}var X=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},z=n(17),J=n(39),Q=n(49),Z=n(8),ee=n(36),te=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Ct(e)})},t.prototype.wrapperClassName=function(){return"AnnotableImpl"},t.prototype.kind=function(){return"Annotable"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Annotable")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnnotableImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnnotableImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Q.BasicNodeImpl);t.AnnotableImpl=te;var ne=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"ValueTypeImpl"},t.prototype.kind=function(){return"ValueType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ValueType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("undefined.ValueTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("undefined.ValueTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"undefined"},t.prototype.value=function(){return this.attr.value()},t}(Q.AttributeNodeImpl);t.ValueTypeImpl=ne;var re=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"StringTypeImpl"},t.prototype.kind=function(){return"StringType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.StringTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.StringTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return this.attr.value()},t}(ne);t.StringTypeImpl=re;var ie=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"UriTemplateImpl"},t.prototype.kind=function(){return"UriTemplate"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UriTemplate")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.UriTemplateImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.UriTemplateImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.UriTemplateImpl=ie;var ae=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},t.prototype.kind=function(){return"RelativeUriString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("RelativeUriString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.RelativeUriStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.RelativeUriStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ie);t.RelativeUriStringImpl=ae;var oe=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},t.prototype.kind=function(){return"FullUriTemplateString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FullUriTemplateString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FullUriTemplateStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FullUriTemplateStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ie);t.FullUriTemplateStringImpl=oe;var se=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},t.prototype.kind=function(){return"StatusCodeString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StatusCodeString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.StatusCodeStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.StatusCodeStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.StatusCodeStringImpl=se;var ue=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"FixedUriStringImpl"},t.prototype.kind=function(){return"FixedUriString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FixedUriString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FixedUriStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FixedUriStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.FixedUriStringImpl=ue;var le=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"ContentTypeImpl"},t.prototype.kind=function(){return"ContentType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ContentType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ContentTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ContentTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.ContentTypeImpl=le;var pe=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},t.prototype.kind=function(){return"MarkdownString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MarkdownString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MarkdownStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MarkdownStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.MarkdownStringImpl=pe;var ce=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"SchemaStringImpl"},t.prototype.kind=function(){return"SchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.SchemaStringImpl=ce;var fe=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"MimeTypeImpl"},t.prototype.kind=function(){return"MimeType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MimeType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MimeTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MimeTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(re);t.MimeTypeImpl=fe;var de=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"AnyTypeImpl"},t.prototype.kind=function(){return"AnyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.AnyTypeImpl=de;var me=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"NumberTypeImpl"},t.prototype.kind=function(){return"NumberType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.NumberTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.NumberTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return this.attr.value()},t}(ne);t.NumberTypeImpl=me;var he=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"IntegerTypeImpl"},t.prototype.kind=function(){return"IntegerType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("IntegerType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.IntegerTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.IntegerTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.IntegerTypeImpl=he;var ye=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"NullTypeImpl"},t.prototype.kind=function(){return"NullType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NullType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.NullTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.NullTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.NullTypeImpl=ye;var ve=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"TimeOnlyTypeImpl"},t.prototype.kind=function(){return"TimeOnlyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TimeOnlyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TimeOnlyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TimeOnlyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.TimeOnlyTypeImpl=ve;var ge=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"DateOnlyTypeImpl"},t.prototype.kind=function(){return"DateOnlyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateOnlyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateOnlyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateOnlyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.DateOnlyTypeImpl=ge;var Ae=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeImpl"},t.prototype.kind=function(){return"DateTimeOnlyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeOnlyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeOnlyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeOnlyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.DateTimeOnlyTypeImpl=Ae;var Se=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"DateTimeTypeImpl"},t.prototype.kind=function(){return"DateTimeType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.DateTimeTypeImpl=Se;var Ee=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"FileTypeImpl"},t.prototype.kind=function(){return"FileType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FileType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FileTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FileTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.FileTypeImpl=Ee;var Te=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},t.prototype.kind=function(){return"BooleanType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.BooleanTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.BooleanTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return this.attr.value()},t}(ne);t.BooleanTypeImpl=Te;var be=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"AnnotationTargetImpl"},t.prototype.kind=function(){return"AnnotationTarget"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnnotationTarget")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnnotationTargetImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnnotationTargetImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(ne);t.AnnotationTargetImpl=be;var Ne=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"ReferenceImpl"},t.prototype.kind=function(){return"Reference"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Reference")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ReferenceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ReferenceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.value=function(){return Q.toStructuredValue(this.attr)},t.prototype.structuredValue=function(){return ee.structuredValue(this)},t.prototype.name=function(){return ee.referenceName(this)},t}(Q.AttributeNodeImpl);t.ReferenceImpl=Ne;var _e=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"TraitRefImpl"},t.prototype.kind=function(){return"TraitRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TraitRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TraitRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TraitRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.trait=function(){return ee.referencedTrait(this)},t}(Ne);t.TraitRefImpl=_e;var we=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?u(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.queryParameters=function(){return e.prototype.elements.call(this,"queryParameters")},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.queryString=function(){return e.prototype.element.call(this,"queryString")},t.prototype.responses=function(){return e.prototype.elements.call(this,"responses")},t.prototype.wrapperClassName=function(){return"OperationImpl"},t.prototype.kind=function(){return"Operation"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Operation")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OperationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OperationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(te);t.OperationImpl=we;var Me=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?l(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.facets=function(){return e.prototype.elements.call(this,"facets")},t.prototype.schema_original=function(){return e.prototype.attributes.call(this,"schema",this.toString)},t.prototype.setSchema=function(e){return this.highLevel().attrOrCreate("schema").setValue(""+e),this},t.prototype.type_original=function(){return e.prototype.attributes.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.location=function(){return e.prototype.attribute.call(this,"location",function(e){return new Ie(e)})},t.prototype.locationKind=function(){return e.prototype.attribute.call(this,"locationKind",function(e){return new Re(e)})},t.prototype["default"]=function(){return e.prototype.attribute.call(this,"default",this.toAny)},t.prototype.setDefault=function(e){return this.highLevel().attrOrCreate("default").setValue(""+e),this},t.prototype.example_original=function(){return e.prototype.element.call(this,"example")},t.prototype.examples_original=function(){return e.prototype.elements.call(this,"examples")},t.prototype.required=function(){return e.prototype.attribute.call(this,"required",this.toBoolean)},t.prototype.setRequired=function(e){return this.highLevel().attrOrCreate("required").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.xml=function(){return e.prototype.element.call(this,"xml")},t.prototype.allowedTargets=function(){return e.prototype.attributes.call(this,"allowedTargets",function(e){return new be(e)})},t.prototype.isAnnotation=function(){return e.prototype.attribute.call(this,"isAnnotation",this.toBoolean)},t.prototype.setIsAnnotation=function(e){return this.highLevel().attrOrCreate("isAnnotation").setValue(""+e),this},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Ct(e)})},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"TypeDeclarationImpl"},t.prototype.kind=function(){return"TypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.runtimeType=function(){return ee.runtimeType(this)},t.prototype.validateInstance=function(e){return ee.validateInstance(this,e)},t.prototype.validateInstanceWithDetailedStatuses=function(e){return ee.validateInstanceWithDetailedStatuses(this,e)},t.prototype.example=function(){return ee.getTypeExample(this)},t.prototype.examples=function(){return ee.getTypeExamples(this)},t.prototype.fixedFacets=function(){return ee.typeFixedFacets(this)},t.prototype.type=function(){return ee.typeValue(this)},t.prototype.schema=function(){return ee.schemaValue(this)},t.prototype.structuredType=function(){return ee.typeStructuredValue(this)},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new xe(this.highLevel())},t}(te);t.TypeDeclarationImpl=Me;var Ie=function(){function e(e){this.attr=e}return e.prototype.wrapperClassName=function(){return"ModelLocationImpl"},e.prototype.kind=function(){return"ModelLocation"},e.prototype.allKinds=function(){return["ModelLocation"]},e.prototype.allWrapperClassNames=function(){return["RAML10.ModelLocationImpl"]},e.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ModelLocationImpl"==r)return!0}return!1},e.prototype.RAMLVersion=function(){return"RAML10"},e}();t.ModelLocationImpl=Ie;var Re=function(){function e(e){this.attr=e}return e.prototype.wrapperClassName=function(){return"LocationKindImpl"},e.prototype.kind=function(){return"LocationKind"},e.prototype.allKinds=function(){return["LocationKind"]},e.prototype.allWrapperClassNames=function(){return["RAML10.LocationKindImpl"]},e.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.LocationKindImpl"==r)return!0}return!1},e.prototype.RAMLVersion=function(){return"RAML10"},e}();t.LocationKindImpl=Re;var Ce=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?p(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.key=function(){return e.prototype.attribute.call(this,"key",this.toString)},t.prototype.setKey=function(e){return this.highLevel().attrOrCreate("key").setValue(""+e),this},t.prototype.value=function(){return e.prototype.attribute.call(this,"value",this.toString)},t.prototype.setValue=function(e){return this.highLevel().attrOrCreate("value").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"UsesDeclarationImpl"},t.prototype.kind=function(){return"UsesDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UsesDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.UsesDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.UsesDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.ast=function(){return ee.referencedNode(this)},t.prototype.scalarsAnnotations=function(){return new Le(this.highLevel())},t}(te);t.UsesDeclarationImpl=Ce;var Le=function(){function e(e){this.node=e}return e.prototype.value=function(){var e=this.node.attr("value");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.UsesDeclarationScalarsAnnotationsImpl=Le;var Pe=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?c(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.attribute=function(){return e.prototype.attribute.call(this,"attribute",this.toBoolean)},t.prototype.setAttribute=function(e){return this.highLevel().attrOrCreate("attribute").setValue(""+e),this},t.prototype.wrapped=function(){return e.prototype.attribute.call(this,"wrapped",this.toBoolean)},t.prototype.setWrapped=function(e){return this.highLevel().attrOrCreate("wrapped").setValue(""+e),this},t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.namespace=function(){return e.prototype.attribute.call(this,"namespace",this.toString)},t.prototype.setNamespace=function(e){return this.highLevel().attrOrCreate("namespace").setValue(""+e),this},t.prototype.prefix=function(){return e.prototype.attribute.call(this,"prefix",this.toString)},t.prototype.setPrefix=function(e){return this.highLevel().attrOrCreate("prefix").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"XMLFacetInfoImpl"},t.prototype.kind=function(){return"XMLFacetInfo"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLFacetInfo")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.XMLFacetInfoImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.XMLFacetInfoImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Oe(this.highLevel())},t}(te);t.XMLFacetInfoImpl=Pe;var Oe=function(){function e(e){this.node=e}return e.prototype.attribute=function(){var e=this.node.attr("attribute");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.wrapped=function(){var e=this.node.attr("wrapped");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.name=function(){var e=this.node.attr("name");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.namespace=function(){var e=this.node.attr("namespace");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.prefix=function(){var e=this.node.attr("prefix");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.XMLFacetInfoScalarsAnnotationsImpl=Oe;var De=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?f(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.uniqueItems=function(){return e.prototype.attribute.call(this,"uniqueItems",this.toBoolean)},t.prototype.setUniqueItems=function(e){return this.highLevel().attrOrCreate("uniqueItems").setValue(""+e),this},t.prototype.items_original=function(){return e.prototype.attributes.call(this,"items",this.toString)},t.prototype.setItems=function(e){return this.highLevel().attrOrCreate("items").setValue(""+e),this},t.prototype.minItems=function(){return e.prototype.attribute.call(this,"minItems",this.toNumber)},t.prototype.setMinItems=function(e){return this.highLevel().attrOrCreate("minItems").setValue(""+e),this},t.prototype.maxItems=function(){return e.prototype.attribute.call(this,"maxItems",this.toNumber)},t.prototype.setMaxItems=function(e){
return this.highLevel().attrOrCreate("maxItems").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"ArrayTypeDeclarationImpl"},t.prototype.kind=function(){return"ArrayTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ArrayTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ArrayTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ArrayTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.structuredItems=function(){return ee.itemsStructuredValue(this)},t.prototype.items=function(){return ee.getItems(this)},t.prototype.findComponentTypeDeclaration=function(){return ee.findComponentTypeDeclaration(this)},t.prototype.scalarsAnnotations=function(){return new Ue(this.highLevel())},t}(Me);t.ArrayTypeDeclarationImpl=De;var xe=function(){function e(e){this.node=e}return e.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.schema=function(){var e=this.node.attributes("schema");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.type=function(){var e=this.node.attributes("type");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.location=function(){var e=this.node.attr("location");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.locationKind=function(){var e=this.node.attr("locationKind");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype["default"]=function(){var e=this.node.attr("default");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.required=function(){var e=this.node.attr("required");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.allowedTargets=function(){var e=this.node.attributes("allowedTargets");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.isAnnotation=function(){var e=this.node.attr("isAnnotation");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.TypeDeclarationScalarsAnnotationsImpl=xe;var Ue=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.uniqueItems=function(){var e=this.node.attr("uniqueItems");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.items=function(){var e=this.node.attributes("items");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},t.prototype.minItems=function(){var e=this.node.attr("minItems");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.maxItems=function(){var e=this.node.attr("maxItems");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(xe);t.ArrayTypeDeclarationScalarsAnnotationsImpl=Ue;var ke=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?d(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"UnionTypeDeclarationImpl"},t.prototype.kind=function(){return"UnionTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UnionTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.UnionTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.UnionTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Me);t.UnionTypeDeclarationImpl=ke;var Fe=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?m(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.properties=function(){return e.prototype.elements.call(this,"properties")},t.prototype.minProperties=function(){return e.prototype.attribute.call(this,"minProperties",this.toNumber)},t.prototype.setMinProperties=function(e){return this.highLevel().attrOrCreate("minProperties").setValue(""+e),this},t.prototype.maxProperties=function(){return e.prototype.attribute.call(this,"maxProperties",this.toNumber)},t.prototype.setMaxProperties=function(e){return this.highLevel().attrOrCreate("maxProperties").setValue(""+e),this},t.prototype.additionalProperties=function(){return e.prototype.attribute.call(this,"additionalProperties",this.toBoolean)},t.prototype.setAdditionalProperties=function(e){return this.highLevel().attrOrCreate("additionalProperties").setValue(""+e),this},t.prototype.discriminator=function(){return e.prototype.attribute.call(this,"discriminator",this.toString)},t.prototype.setDiscriminator=function(e){return this.highLevel().attrOrCreate("discriminator").setValue(""+e),this},t.prototype.discriminatorValue=function(){return e.prototype.attribute.call(this,"discriminatorValue",this.toString)},t.prototype.setDiscriminatorValue=function(e){return this.highLevel().attrOrCreate("discriminatorValue").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"ObjectTypeDeclarationImpl"},t.prototype.kind=function(){return"ObjectTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ObjectTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ObjectTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ObjectTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Be(this.highLevel())},t}(Me);t.ObjectTypeDeclarationImpl=Fe;var Be=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.minProperties=function(){var e=this.node.attr("minProperties");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.maxProperties=function(){var e=this.node.attr("maxProperties");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.additionalProperties=function(){var e=this.node.attr("additionalProperties");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.discriminator=function(){var e=this.node.attr("discriminator");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.discriminatorValue=function(){var e=this.node.attr("discriminatorValue");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(xe);t.ObjectTypeDeclarationScalarsAnnotationsImpl=Be;var Ke=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?h(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.pattern=function(){return e.prototype.attribute.call(this,"pattern",this.toString)},t.prototype.setPattern=function(e){return this.highLevel().attrOrCreate("pattern").setValue(""+e),this},t.prototype.minLength=function(){return e.prototype.attribute.call(this,"minLength",this.toNumber)},t.prototype.setMinLength=function(e){return this.highLevel().attrOrCreate("minLength").setValue(""+e),this},t.prototype.maxLength=function(){return e.prototype.attribute.call(this,"maxLength",this.toNumber)},t.prototype.setMaxLength=function(e){return this.highLevel().attrOrCreate("maxLength").setValue(""+e),this},t.prototype["enum"]=function(){return e.prototype.attributes.call(this,"enum",this.toString)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},t.prototype.kind=function(){return"StringTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.StringTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.StringTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ve(this.highLevel())},t}(Me);t.StringTypeDeclarationImpl=Ke;var Ve=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.pattern=function(){var e=this.node.attr("pattern");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.minLength=function(){var e=this.node.attr("minLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.maxLength=function(){var e=this.node.attr("maxLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype["enum"]=function(){var e=this.node.attributes("enum");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},t}(xe);t.StringTypeDeclarationScalarsAnnotationsImpl=Ve;var je=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?y(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},t.prototype.kind=function(){return"BooleanTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.BooleanTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.BooleanTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Me);t.BooleanTypeDeclarationImpl=je;var We=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?v(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.minimum=function(){return e.prototype.attribute.call(this,"minimum",this.toNumber)},t.prototype.setMinimum=function(e){return this.highLevel().attrOrCreate("minimum").setValue(""+e),this},t.prototype.maximum=function(){return e.prototype.attribute.call(this,"maximum",this.toNumber)},t.prototype.setMaximum=function(e){return this.highLevel().attrOrCreate("maximum").setValue(""+e),this},t.prototype["enum"]=function(){return e.prototype.attributes.call(this,"enum",this.toString)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.format=function(){return e.prototype.attribute.call(this,"format",this.toString)},t.prototype.setFormat=function(e){return this.highLevel().attrOrCreate("format").setValue(""+e),this},t.prototype.multipleOf=function(){return e.prototype.attribute.call(this,"multipleOf",this.toNumber)},t.prototype.setMultipleOf=function(e){return this.highLevel().attrOrCreate("multipleOf").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},t.prototype.kind=function(){return"NumberTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.NumberTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.NumberTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ye(this.highLevel())},t}(Me);t.NumberTypeDeclarationImpl=We;var qe=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?g(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.format=function(){return e.prototype.attribute.call(this,"format",this.toString)},t.prototype.setFormat=function(e){return this.highLevel().attrOrCreate("format").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},t.prototype.kind=function(){return"IntegerTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("IntegerTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.IntegerTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.IntegerTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new He(this.highLevel())},t}(We);t.IntegerTypeDeclarationImpl=qe;var Ye=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.minimum=function(){var e=this.node.attr("minimum");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.maximum=function(){var e=this.node.attr("maximum");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype["enum"]=function(){var e=this.node.attributes("enum");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},t.prototype.format=function(){var e=this.node.attr("format");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.multipleOf=function(){var e=this.node.attr("multipleOf");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(xe);t.NumberTypeDeclarationScalarsAnnotationsImpl=Ye;var He=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.format=function(){var e=this.node.attr("format");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(Ye);t.IntegerTypeDeclarationScalarsAnnotationsImpl=He;var $e=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?A(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"DateOnlyTypeDeclarationImpl"},t.prototype.kind=function(){return"DateOnlyTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateOnlyTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateOnlyTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateOnlyTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Me);t.DateOnlyTypeDeclarationImpl=$e;var Ge=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?S(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"TimeOnlyTypeDeclarationImpl"},t.prototype.kind=function(){return"TimeOnlyTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TimeOnlyTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TimeOnlyTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TimeOnlyTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Me);t.TimeOnlyTypeDeclarationImpl=Ge;var Xe=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?E(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeDeclarationImpl"},t.prototype.kind=function(){return"DateTimeOnlyTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeOnlyTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeOnlyTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeOnlyTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(Me);t.DateTimeOnlyTypeDeclarationImpl=Xe;var ze=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?T(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.format=function(){return e.prototype.attribute.call(this,"format",this.toString)},t.prototype.setFormat=function(e){return this.highLevel().attrOrCreate("format").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"DateTimeTypeDeclarationImpl"},t.prototype.kind=function(){return"DateTimeTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTimeTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DateTimeTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DateTimeTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Je(this.highLevel())},t}(Me);t.DateTimeTypeDeclarationImpl=ze;var Je=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.format=function(){var e=this.node.attr("format");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(xe);t.DateTimeTypeDeclarationScalarsAnnotationsImpl=Je;var Qe=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?b(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.fileTypes=function(){return e.prototype.attributes.call(this,"fileTypes",function(e){return new le(e)})},t.prototype.minLength=function(){return e.prototype.attribute.call(this,"minLength",this.toNumber)},t.prototype.setMinLength=function(e){return this.highLevel().attrOrCreate("minLength").setValue(""+e),this},t.prototype.maxLength=function(){return e.prototype.attribute.call(this,"maxLength",this.toNumber)},t.prototype.setMaxLength=function(e){return this.highLevel().attrOrCreate("maxLength").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},t.prototype.kind=function(){return"FileTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FileTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FileTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FileTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ze(this.highLevel())},t}(Me);t.FileTypeDeclarationImpl=Qe;var Ze=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.fileTypes=function(){var e=this.node.attributes("fileTypes");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},t.prototype.minLength=function(){var e=this.node.attr("minLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.maxLength=function(){var e=this.node.attr("maxLength");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(xe);t.FileTypeDeclarationScalarsAnnotationsImpl=Ze;var et=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?N(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.code=function(){return e.prototype.attribute.call(this,"code",function(e){return new se(e)})},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Ct(e)})},t.prototype.wrapperClassName=function(){return"ResponseImpl"},t.prototype.kind=function(){return"Response"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Response")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResponseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResponseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.isOkRange=function(){return ee.isOkRange(this)},t.prototype.scalarsAnnotations=function(){return new tt(this.highLevel())},t}(te);t.ResponseImpl=et;var tt=function(){function e(e){this.node=e}return e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.ResponseScalarsAnnotationsImpl=tt;var nt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?_(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Ct(e)})},t.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},t.prototype.kind=function(){return"SecuritySchemePart"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemePart")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SecuritySchemePartImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SecuritySchemePartImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(we);t.SecuritySchemePartImpl=nt;var rt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?s(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new _e(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new it(e)})},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"MethodBaseImpl"},t.prototype.kind=function(){return"MethodBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MethodBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MethodBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MethodBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new At(this.highLevel())},t}(we);t.MethodBaseImpl=rt;var it=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},t.prototype.kind=function(){return"SecuritySchemeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SecuritySchemeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SecuritySchemeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.securitySchemeName=function(){return ee.securitySchemeName(this)},t.prototype.securityScheme=function(){return ee.securityScheme(this)},t}(Ne);t.SecuritySchemeRefImpl=it;var at=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?w(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.describedBy=function(){return e.prototype.element.call(this,"describedBy")},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},t.prototype.kind=function(){return"AbstractSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AbstractSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AbstractSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AbstractSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new vt(this.highLevel())},t}(te);t.AbstractSecuritySchemeImpl=at;var ot=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?M(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(te);t.SecuritySchemeSettingsImpl=ot;var st=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?I(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.requestTokenUri=function(){return e.prototype.attribute.call(this,"requestTokenUri",function(e){return new ue(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ue(e)})},t.prototype.tokenCredentialsUri=function(){return e.prototype.attribute.call(this,"tokenCredentialsUri",function(e){return new ue(e)})},t.prototype.signatures=function(){return e.prototype.attributes.call(this,"signatures",this.toString)},t.prototype.setSignatures=function(e){return this.highLevel().attrOrCreate("signatures").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth1SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth1SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new ut(this.highLevel())},t}(ot);t.OAuth1SecuritySchemeSettingsImpl=st;var ut=function(){function e(e){this.node=e}return e.prototype.requestTokenUri=function(){var e=this.node.attr("requestTokenUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.authorizationUri=function(){var e=this.node.attr("authorizationUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.tokenCredentialsUri=function(){var e=this.node.attr("tokenCredentialsUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.signatures=function(){var e=this.node.attributes("signatures");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e}();t.OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl=ut;var lt=function(e){
function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?R(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.accessTokenUri=function(){return e.prototype.attribute.call(this,"accessTokenUri",function(e){return new ue(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ue(e)})},t.prototype.authorizationGrants=function(){return e.prototype.attributes.call(this,"authorizationGrants",this.toString)},t.prototype.setAuthorizationGrants=function(e){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+e),this},t.prototype.scopes=function(){return e.prototype.attributes.call(this,"scopes",this.toString)},t.prototype.setScopes=function(e){return this.highLevel().attrOrCreate("scopes").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth2SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth2SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new pt(this.highLevel())},t}(ot);t.OAuth2SecuritySchemeSettingsImpl=lt;var pt=function(){function e(e){this.node=e}return e.prototype.accessTokenUri=function(){var e=this.node.attr("accessTokenUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.authorizationUri=function(){var e=this.node.attr("authorizationUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.authorizationGrants=function(){var e=this.node.attributes("authorizationGrants");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.scopes=function(){var e=this.node.attributes("scopes");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e}();t.OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl=pt;var ct=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?C(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth2SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth2SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth2SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(at);t.OAuth2SecuritySchemeImpl=ct;var ft=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?L(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth1SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OAuth1SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OAuth1SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(at);t.OAuth1SecuritySchemeImpl=ft;var dt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?P(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"PassThroughSecuritySchemeImpl"},t.prototype.kind=function(){return"PassThroughSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("PassThroughSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.PassThroughSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.PassThroughSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(at);t.PassThroughSecuritySchemeImpl=dt;var mt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?O(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},t.prototype.kind=function(){return"BasicSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BasicSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.BasicSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.BasicSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(at);t.BasicSecuritySchemeImpl=mt;var ht=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?D(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},t.prototype.kind=function(){return"DigestSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DigestSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DigestSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DigestSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(at);t.DigestSecuritySchemeImpl=ht;var yt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?x(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},t.prototype.kind=function(){return"CustomSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("CustomSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.CustomSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.CustomSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(at);t.CustomSecuritySchemeImpl=yt;var vt=function(){function e(e){this.node=e}return e.prototype.type=function(){var e=this.node.attr("type");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.AbstractSecuritySchemeScalarsAnnotationsImpl=vt;var gt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?U(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.method=function(){return e.prototype.attribute.call(this,"method",this.toString)},t.prototype.setMethod=function(e){return this.highLevel().attrOrCreate("method").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"MethodImpl"},t.prototype.kind=function(){return"Method"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Method")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.MethodImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.MethodImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.parentResource=function(){return ee.parentResource(this)},t.prototype.ownerApi=function(){return ee.ownerApi(this)},t.prototype.methodId=function(){return ee.methodId(this)},t.prototype.allSecuredBy=function(){return ee.allSecuredBy(this)},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new St(this.highLevel())},t}(rt);t.MethodImpl=gt;var At=function(){function e(e){this.node=e}return e.prototype.protocols=function(){var e=this.node.attributes("protocols");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.is=function(){var e=this.node.attributes("is");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.securedBy=function(){var e=this.node.attributes("securedBy");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.MethodBaseScalarsAnnotationsImpl=At;var St=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(At);t.MethodScalarsAnnotationsImpl=St;var Et=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?o(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"TraitImpl"},t.prototype.kind=function(){return"Trait"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Trait")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.TraitImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.TraitImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new Tt(this.highLevel())},t}(rt);t.TraitImpl=Et;var Tt=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(At);t.TraitScalarsAnnotationsImpl=Tt;var bt=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},t.prototype.kind=function(){return"ResourceTypeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceTypeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceTypeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceTypeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.resourceType=function(){return ee.referencedResourceType(this)},t}(Ne);t.ResourceTypeRefImpl=bt;var Nt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?F(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.methods=function(){return e.prototype.elements.call(this,"methods")},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new _e(e)})},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",function(e){return new bt(e)})},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new it(e)})},t.prototype.uriParameters_original=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.wrapperClassName=function(){return"ResourceBaseImpl"},t.prototype.kind=function(){return"ResourceBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.uriParameters=function(){return ee.uriParametersPrimary(this)},t.prototype.allUriParameters=function(){return ee.uriParameters(this)},t.prototype.allSecuredBy=function(){return ee.allSecuredBy(this)},t.prototype.scalarsAnnotations=function(){return new wt(this.highLevel())},t}(te);t.ResourceBaseImpl=Nt;var _t=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?B(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.relativeUri=function(){return e.prototype.attribute.call(this,"relativeUri",function(e){return new ae(e)})},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Ct(e)})},t.prototype.wrapperClassName=function(){return"ResourceImpl"},t.prototype.kind=function(){return"Resource"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Resource")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.completeRelativeUri=function(){return ee.completeRelativeUri(this)},t.prototype.absoluteUri=function(){return ee.absoluteUri(this)},t.prototype.parentResource=function(){return ee.parent(this)},t.prototype.childResource=function(e){return ee.childResource(this,e)},t.prototype.childMethod=function(e){return ee.childMethod(this,e)},t.prototype.ownerApi=function(){return ee.ownerApi(this)},t.prototype.absoluteUriParameters=function(){return ee.absoluteUriParameters(this)},t.prototype.scalarsAnnotations=function(){return new Mt(this.highLevel())},t}(Nt);t.ResourceImpl=_t;var wt=function(){function e(e){this.node=e}return e.prototype.is=function(){var e=this.node.attributes("is");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.type=function(){var e=this.node.attr("type");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.securedBy=function(){var e=this.node.attributes("securedBy");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e}();t.ResourceBaseScalarsAnnotationsImpl=wt;var Mt=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(wt);t.ResourceScalarsAnnotationsImpl=Mt;var It=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?k(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},t.prototype.kind=function(){return"ResourceType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ResourceTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ResourceTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.parametrizedProperties=function(){return ee.getTemplateParametrizedProperties(this)},t.prototype.scalarsAnnotations=function(){return new Rt(this.highLevel())},t}(Nt);t.ResourceTypeImpl=It;var Rt=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.displayName=function(){var e=this.node.attr("displayName");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(wt);t.ResourceTypeScalarsAnnotationsImpl=Rt;var Ct=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.wrapperClassName=function(){return"AnnotationRefImpl"},t.prototype.kind=function(){return"AnnotationRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnnotationRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.AnnotationRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.AnnotationRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.annotation=function(){return ee.referencedAnnotation(this)},t}(Ne);t.AnnotationRefImpl=Ct;var Lt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?K(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.content=function(){return e.prototype.attribute.call(this,"content",function(e){return new pe(e)})},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},t.prototype.kind=function(){return"DocumentationItem"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DocumentationItem")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.DocumentationItemImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.DocumentationItemImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Pt(this.highLevel())},t}(te);t.DocumentationItemImpl=Lt;var Pt=function(){function e(e){this.node=e}return e.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.content=function(){var e=this.node.attr("content");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.DocumentationItemScalarsAnnotationsImpl=Pt;var Ot=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?a(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t.prototype.wrapperClassName=function(){return"FragmentDeclarationImpl"},t.prototype.kind=function(){return"FragmentDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FragmentDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.FragmentDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.FragmentDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t}(te);t.FragmentDeclarationImpl=Ot;var Dt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?i(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.schemas=function(){return e.prototype.elements.call(this,"schemas")},t.prototype.types=function(){return e.prototype.elements.call(this,"types")},t.prototype.traits_original=function(){return e.prototype.elements.call(this,"traits")},t.prototype.resourceTypes_original=function(){return e.prototype.elements.call(this,"resourceTypes")},t.prototype.annotationTypes=function(){return e.prototype.elements.call(this,"annotationTypes")},t.prototype.securitySchemes=function(){return e.prototype.elements.call(this,"securitySchemes")},t.prototype.wrapperClassName=function(){return"LibraryBaseImpl"},t.prototype.kind=function(){return"LibraryBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("LibraryBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.LibraryBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.LibraryBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.traits=function(){return ee.traitsPrimary(this)},t.prototype.allTraits=function(){return ee.allTraits(this)},t.prototype.resourceTypes=function(){return ee.resourceTypesPrimary(this)},t.prototype.allResourceTypes=function(){return ee.allResourceTypes(this)},t}(Ot);t.LibraryBaseImpl=Dt;var xt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?V(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"LibraryImpl"},t.prototype.kind=function(){return"Library"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Library")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.LibraryImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.LibraryImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Ut(this.highLevel())},t}(Dt);t.LibraryImpl=xt;var Ut=function(){function e(e){this.node=e}return e.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e}();t.LibraryScalarsAnnotationsImpl=Ut;var kt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?r(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new pe(e)})},t.prototype.version=function(){return e.prototype.attribute.call(this,"version",this.toString)},t.prototype.setVersion=function(e){return this.highLevel().attrOrCreate("version").setValue(""+e),this},t.prototype.baseUri=function(){return e.prototype.attribute.call(this,"baseUri",function(e){return new oe(e)})},t.prototype.baseUriParameters_original=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.mediaType=function(){return e.prototype.attributes.call(this,"mediaType",function(e){return new fe(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new it(e)})},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.documentation=function(){return e.prototype.elements.call(this,"documentation")},t.prototype.annotations=function(){return e.prototype.attributes.call(this,"annotations",function(e){return new Ct(e)})},t.prototype.wrapperClassName=function(){return"ApiImpl"},t.prototype.kind=function(){return"Api"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Api")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ApiImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ApiImpl"==r)return!0}return!1},t.prototype.RAMLVersion_original=function(){return"RAML10"},t.prototype.expand=function(e){return void 0===e&&(e=!1),ee.expandSpec(this,e)},t.prototype.childResource=function(e){return ee.childResource(this,e)},t.prototype.allResources=function(){return ee.allResources(this)},t.prototype.baseUriParameters=function(){return ee.baseUriParametersPrimary(this)},t.prototype.allBaseUriParameters=function(){return ee.baseUriParameters(this)},t.prototype.allProtocols=function(){return ee.allProtocols(this)},t.prototype.RAMLVersion=function(){return ee.RAMLVersion(this)},t.prototype.scalarsAnnotations=function(){return new Bt(this.highLevel())},t}(Dt);t.ApiImpl=kt;var Ft=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?j(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype["extends"]=function(){return e.prototype.attribute.call(this,"extends",this.toString)},t.prototype.setExtends=function(e){return this.highLevel().attrOrCreate("extends").setValue(""+e),this},t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OverlayImpl"},t.prototype.kind=function(){return"Overlay"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Overlay")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.OverlayImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.OverlayImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new Kt(this.highLevel())},t}(kt);t.OverlayImpl=Ft;var Bt=function(){function e(e){this.node=e}return e.prototype.title=function(){var e=this.node.attr("title");
if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.description=function(){var e=this.node.attr("description");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.version=function(){var e=this.node.attr("version");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.baseUri=function(){var e=this.node.attr("baseUri");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},e.prototype.protocols=function(){var e=this.node.attributes("protocols");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.mediaType=function(){var e=this.node.attributes("mediaType");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e.prototype.securedBy=function(){var e=this.node.attributes("securedBy");return e.map(function(e){var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n})},e}();t.ApiScalarsAnnotationsImpl=Bt;var Kt=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype["extends"]=function(){var e=this.node.attr("extends");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(Bt);t.OverlayScalarsAnnotationsImpl=Kt;var Vt=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?W(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return X(t,e),t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype["extends"]=function(){return e.prototype.attribute.call(this,"extends",this.toString)},t.prototype.setExtends=function(e){return this.highLevel().attrOrCreate("extends").setValue(""+e),this},t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"ExtensionImpl"},t.prototype.kind=function(){return"Extension"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Extension")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML10.ExtensionImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML10.ExtensionImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML10"},t.prototype.scalarsAnnotations=function(){return new jt(this.highLevel())},t}(kt);t.ExtensionImpl=Vt;var jt=function(e){function t(){e.apply(this,arguments)}return X(t,e),t.prototype.usage=function(){var e=this.node.attr("usage");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype["extends"]=function(){var e=this.node.attr("extends");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t.prototype.title=function(){var e=this.node.attr("title");if(null==e)return[];var t=e.annotations(),n=Q.attributesToValues(t,function(e){return new Ct(e)});return n},t}(Bt);t.ExtensionScalarsAnnotationsImpl=jt,t.loadApiSync=q,t.loadRAMLSync=Y,t.loadApi=H,t.loadRAML=$,t.getLanguageElementByRuntimeType=G},function(e,t,n){"use strict";var r,i=n(71),a=function(e){return null!=e},o=function(){function e(t){var n=this;this._value=t,this._isDefined=!1,this._isEmpty=!0,this._arr=void 0,this.getOrThrow=function(){return i(n._isDefined,"Opt is empty. Use `Opt#getOrElse` or check `Opt#isDefined`."),n._value},this.value=function(){return n._value},this.isDefined=function(){return n._isDefined},this.isEmpty=function(){return n._isEmpty},this.toArray=function(){return n._arr||(n._arr=n._isDefined?[n._value]:[])},this.getOrElse=function(e){return n._isDefined?n._value:e},this.getOrElseF=function(e){return n._isDefined?n._value:e()},this.map=function(t){return n._isEmpty?e.empty():new e(t(n._value))},this.flatMap=function(t){return n.map(t).getOrElse(e.empty())},this.equals=function(t){return i(t instanceof e,"Expected other to be an `Opt`, but got `%s`",typeof t),n._isDefined===t.isDefined()&&n._value===t.value()},a(this._value)&&(this._isDefined=!0,this._isEmpty=!1)}return e.prototype.forEach=function(e){this.isDefined()&&e(this._value)},e.empty=function(){return r||(r=new e)},e}();e.exports=o},function(e,t,n){!function(t){function n(){}function r(e,t){return function(){e.apply(t,arguments)}}function i(e){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],p(e,this)}function a(e,t){for(;3===e._state;)e=e._value;return 0===e._state?void e._deferreds.push(t):(e._handled=!0,void f(function(){var n=1===e._state?t.onFulfilled:t.onRejected;if(null===n)return void(1===e._state?o:s)(t.promise,e._value);var r;try{r=n(e._value)}catch(i){return void s(t.promise,i)}o(t.promise,r)}))}function o(e,t){try{if(t===e)throw new TypeError("A promise cannot be resolved with itself.");if(t&&("object"==typeof t||"function"==typeof t)){var n=t.then;if(t instanceof i)return e._state=3,e._value=t,void u(e);if("function"==typeof n)return void p(r(n,t),e)}e._state=1,e._value=t,u(e)}catch(a){s(e,a)}}function s(e,t){e._state=2,e._value=t,u(e)}function u(e){2===e._state&&0===e._deferreds.length&&f(function(){e._handled||d(e._value)});for(var t=0,n=e._deferreds.length;n>t;t++)a(e,e._deferreds[t]);e._deferreds=null}function l(e,t,n){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof t?t:null,this.promise=n}function p(e,t){var n=!1;try{e(function(e){n||(n=!0,o(t,e))},function(e){n||(n=!0,s(t,e))})}catch(r){if(n)return;n=!0,s(t,r)}}var c=setTimeout,f="function"==typeof setImmediate&&setImmediate||function(e){c(e,0)},d=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)};i.prototype["catch"]=function(e){return this.then(null,e)},i.prototype.then=function(e,t){var r=new this.constructor(n);return a(this,new l(e,t,r)),r},i.all=function(e){var t=Array.prototype.slice.call(e);return new i(function(e,n){function r(a,o){try{if(o&&("object"==typeof o||"function"==typeof o)){var s=o.then;if("function"==typeof s)return void s.call(o,function(e){r(a,e)},n)}t[a]=o,0===--i&&e(t)}catch(u){n(u)}}if(0===t.length)return e([]);for(var i=t.length,a=0;a<t.length;a++)r(a,t[a])})},i.resolve=function(e){return e&&"object"==typeof e&&e.constructor===i?e:new i(function(t){t(e)})},i.reject=function(e){return new i(function(t,n){n(e)})},i.race=function(e){return new i(function(t,n){for(var r=0,i=e.length;i>r;r++)e[r].then(t,n)})},i._setImmediateFn=function(e){f=e},i._setUnhandledRejectionFn=function(e){d=e},"undefined"!=typeof e&&e.exports?e.exports=i:t.Promise||(t.Promise=i)}(this)},function(e,t,n){"use strict";function r(){return new W}function i(e){if(null==e)return null;switch(e.kind){case w.Kind.SCALAR:return{errors:[],startPosition:e.startPosition,endPosition:e.endPosition,value:e.value,kind:w.Kind.SCALAR,parent:e.parent};case w.Kind.MAPPING:var t=e;return{errors:[],key:i(t.key),value:i(t.value),startPosition:t.startPosition,endPosition:t.endPosition,kind:w.Kind.MAPPING,parent:t.parent};case w.Kind.MAP:var n=e;return{errors:[],startPosition:e.startPosition,endPosition:e.endPosition,mappings:n.mappings.map(function(e){return i(e)}),kind:w.Kind.MAP,parent:n.parent}}return e}function a(e){var t=e.match(/^.*((\r\n|\n|\r)|$)/gm);return t}function o(e,t){for(var n=a(e),r=[],i=0;i<n.length;i++)0==i?r.push(n[0]):r.push(n[i].substring(t.length));return r.join("")}function s(e){for(var t="",n=0;n<e.length;n++){var r=e[n];if("\r"!=r&&"\n"!=r){if(" "!=r&&"	"!=r)break;t+=r}}return t}function u(e,t){var n=e.substr(t.offset,t.replacementLength);return-1!=n.indexOf("\n")?!0:-1!=t.text.indexOf("\n")?!0:void 0}function l(e){if("null"==e)e=null;else if("~"==e)e=null;else if("true"==e)e=!0;else if("false"==e)e=!1;else{var t=parseFloat(e);isNaN(t)||(""+e).match("^[-+]?[0-9]*\\.?[0-9]+$")&&(e=t)}return e}function p(e,t,n){var r=w.newMapping(w.newScalar(e),w.newMap());return new z(r,n,t,null,null)}function c(e){var t=w.newMap(e);return new z(t,null,null,null,null)}function f(e){var t=w.newScalar(e);return new z(t,null,null,null,null)}function d(e,t,n){return new z(e,n,t,null,null)}function m(e){var t=w.newMapping(w.newScalar(e),w.newItems());return new z(t,null,null,null,null)}function h(e){var t=w.newMapping(w.newScalar(e),w.newMap());return new z(t,null,null,null,null)}function y(e,t){var n=w.newMapping(w.newScalar(e),w.newScalar(t));return new z(n,null,null,null,null)}function v(e){if(!z.isInstance(e))return null;var t=e,n=new z(t.yamlNode(),t.unit(),null,null,null,!0);return n._errors=t._errors,n}function g(e){if(!z.isInstance(e))return null;var t=e,n=new z(t.yamlNode(),t.unit(),null,null,null,!1);return n._errors=t._errors,n}function A(e){var t=e.highLevelNode();if(t)return t.definition();var n=e.parent();if(!n)return null;var r=e.key();if(!r)return null;var i=n.nodeDefinition();if(!i)return null;if(!i.property)return null;var a=i.property(r);return a?a.range():null}function S(e,t,n,r){if(e.isOverlayOrExtension()){var i=e.getMasterReferenceNode();if(i){var a=i.value();if(a){var o=b.dirname(e.absolutePath()),s=T.toAbsolutePath(o,a);if(!t[s]){if(n[s])return void i.errors().push(new F(n[a]));var u=r[s];u||(u=[],r[s]=u),u.push(i)}}}}}function E(e,t){var n={},r={},i=[],a=function(t){for(var o=[],s={};t<i.length;){var u=i[t],l=u.absolutePath();S(u,n,r,s);var p=u.getIncludeNodes();p.forEach(function(t){var i=t.includePath();if(i){var a=O.getIncludeReference(i);if(a)return void o.push(e.resolveAsync(u.absolutePath(),i));if(i){var p=T.buildPath(i,l,e.getRootPath());if(!n[p]){if(r[p]&&t.errors)return void t.errors().push(new F(r[i]));var c=s[p];c||(c=[],s[p]=c),c.push(t)}}}}),t++}var c=Object.keys(s);if(0==o.length&&0==c.length)return Promise.resolve();var f=o;return c.forEach(function(t){f.push(e.unitAsync(t,!0).then(function(e){n[e.absolutePath()]||(n[e.absolutePath()]=!0,i.push(e))},function(n){var i=e.pathToUnit[t];s[t].forEach(function(e){i||e.errors&&e.errors().push(new F(n))}),r[t]=n,e.failedUnits[t]=n,i&&(n.inner=!0)}))}),Promise.all(f).then(function(e){return a(t)})};return e.unitAsync(t,b.isAbsolute(t)).then(function(e){return i.push(e),n[e.absolutePath()]=!0,a(0)}).then(function(e){return i.length>0?i[0]:null})}var T=n(10),b=n(15),N=n(40),_=n(47),w=n(73),M=n(65),I=n(44),R=n(16),C=n(37),L=n(25),P=n(33),O=n(26),D=n(50),x=n(18),U=n(27),k=n(51),F=w.YAMLException;t.Kind={SCALAR:w.Kind.SCALAR};var B=function(){function e(e){this.text="",this.indent=e}return e.prototype.isLastNL=function(){return this.text.length>0&&"\n"==this.text[this.text.length-1]},e.prototype.addWithIndent=function(e,t){this.isLastNL()&&(this.text+=I.indent(e),this.text+=this.indent),this.text+=t},e.prototype.addChar=function(e){this.isLastNL()&&(this.text+=this.indent),this.text+=e},e.prototype.append=function(e){for(var t=0;t<e.length;t++)this.addChar(e[t])},e}();t.MarkupIndentingBuffer=B;var K=function(){function e(e,t,n,r,i){this._path=e,this._content=t,this._tl=n,this._project=r,this._apath=i,this._includedByPaths=[],this._path=null!=this._path?this._path.replace(/\\/g,"/"):null}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&M.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.highLevel=function(){return this._hl?this._hl:(this._hl=R.fromUnit(this),this._hl)},e.prototype.isStubUnit=function(){return this.stu},e.prototype.resolveAsync=function(e){var t=this._project.resolveAsync(this._path,e);return t},e.prototype.getIncludeNodes=function(){var e=this.ast(),t=[];return null==e?[]:(e.gatherIncludes(t),e.children().forEach(function(e){"uses"==e.key()&&e.children().forEach(function(e){t.push({includePath:function(){var t=e.value();return"string"!=typeof t?null:t}})})}),t)},e.prototype.cloneToProject=function(t){var n=new e(this._path,this._content,this._tl,t,this._apath);return n},e.prototype.clone=function(){var t=new e(this._path,this._content,this._tl,this.project(),this._apath);return t},e.prototype.stub=function(){var t=new e(this._path,this._content,this._tl,this.project(),this._apath);return t.stu=!0,t},e.prototype.isDirty=function(){return!1},e.prototype.expandedHighLevel=function(){if(this.expanded)return this.expanded;var e=this.highLevel().asElement(),t=U.expandTraitsAndResourceTypes(e.wrapperNode()),n=t.highLevel();return n._expanded=!0,this.expanded=n,n},e.prototype.absolutePath=function(){return this._apath},e.prototype.isRAMLUnit=function(){var e=this.absolutePath();if(T.isWebPath(e))try{e=N.parse(e).pathname}catch(t){e=this._path}var n=b.extname(e);return".raml"==n||".yaml"==n||".yml"==n},e.prototype.contents=function(){return this._content},e.prototype.resolve=function(e){"string"!=typeof e&&(e=""+e);var t=this._project.resolve(this._path,e);return t},e.prototype.path=function(){return this._path},e.prototype.lexerErrors=function(){return null==this.errors&&this.ast(),this.errors},e.prototype.ast=function(){var e=this;if(this._node)return this._node;try{var t=w.load(this._content,{ignoreDuplicateKeys:!0});return this.errors=t.errors,this.errors.forEach(function(t){t.mark&&(t.mark.filePath=e.absolutePath())}),this._node=new z(t,this,null,null,null),this._node._errors=this.errors,this._node}catch(n){return this.errors=[],this.errors.push(new F(n.message)),this._node=null,this._node}},e.prototype.isTopLevel=function(){return this._tl},e.prototype.updateContent=function(e){this._content=e,this.errors=null,this._node=null,this._lineMapper=null},e.prototype.updateContentSafe=function(e){this._content=e,this._lineMapper=null,this._hl=null},e.prototype.project=function(){return this._project},e.prototype.lineMapper=function(){return null==this._lineMapper&&(this._lineMapper=new T.LineMapperImpl(this.contents(),this.absolutePath())),this._lineMapper},e.prototype.isOverlayOrExtension=function(){for(var e=this.contents(),t="",n=null,r=0,i=0,a=0;a<e.length;a++){var o=e.charAt(a);if("\r"==o||"\n"==o){t?n=e.substring(i,a).trim():t=e.substring(0,a).trim();break}" "==o&&(r++,t||2!=r||(t=e.substring(0,a),i=a))}return"Extension"==n||"Overlay"==n},e.prototype.getMasterReferenceNode=function(){return M.find(this.ast().children(),function(e){return e.key()==x.Universe10.Overlay.properties["extends"].name})},e.prototype.addIncludedBy=function(e){this.includedByContains(e)||this._includedByPaths.push(e)},e.prototype.includedByContains=function(e){return null!=M.find(this._includedByPaths,function(t){return t==e})},e.prototype.getIncludedByPaths=function(){return this._includedByPaths},e.CLASS_IDENTIFIER="jsyaml2lowLevel.CompilationUnit",e}();t.CompilationUnit=K;var V=n(63).XMLHttpRequest,j=n(63).XMLHttpRequest,W=function(){function e(){}return e.prototype.open=function(e,t,n){this.xhr=n?new j:new V,this.async=n,this.xhr.open(e,t,n)},e.prototype.setRequestHeader=function(e,t){this.xhr.setRequestHeader(e,t)},e.prototype.getResponseHeader=function(e){return this.xhr.getResponseHeader(e)},e.prototype.getAllResponseHeaders=function(){return this.xhr.getAllResponseHeaders()},e.prototype.send=function(e){var t=this;this.xhr.onload=function(){return t.onResponse(!1)},this.xhr.onerror=function(){return t.onResponse(!0)},this.xhr.send(e)},e.prototype.onResponse=function(e){return this.statusText=this.xhr.statusText,this.responseText=this.xhr.responseText,this.responseType=this.xhr.responseType,this.status=this.xhr.status,e&&this.onerror?void this.onerror():void(this.onload&&this.onload())},e}();t.XMLHttpRequestWrapper=W,t.buildXHR=r;var q=function(){function e(){}return e.prototype.execute=function(e,t){void 0===t&&(t=!0);var n=r(),i=e.url;t&&(i=this.appendParams(e,e.url)),n.open(e.method,i,!1),this.doRequest(e,n);var a=n.status;if(a>300&&400>a){var o=n.getResponseHeader("location");if(o)return e.url=o,this.execute(e,!1)}var s={status:a,statusText:n.statusText,headers:n.getAllResponseHeaders().split("\n").map(function(e){var t=e.indexOf(":");return{name:e.substring(0,t).trim(),value:e.substring(t+1).trim()}}),content:{text:n.responseText,mimeType:n.responseType}};return s},e.prototype.appendParams=function(e,t){var n=e.queryString&&e.queryString.length>0;if(n){t+="?";var r=[];n&&(r=r.concat(e.queryString.map(function(e){return encodeURIComponent(e.name)+"="+encodeURIComponent(e.value)}))),t+=r.join("&")}return t},e.prototype.log=function(e,t){},e.prototype.executeAsync=function(e,t){void 0===t&&(t=!0);var n=r(),i=e.url;t&&(i=this.appendParams(e,e.url));var a=this;return new Promise(function(t,r){n.open(e.method,i,!0),n.onload=function(){var e=n.status,r={status:e,statusText:n.statusText,headers:n.getAllResponseHeaders().split("\n").map(function(e){var t=e.indexOf(":");return{name:e.substring(0,t).trim(),value:e.substring(t+1).trim()}}),content:{text:n.responseText,mimeType:n.responseType}};t(r)},n.onerror=function(){r(new F("Network Error"))},a.doRequest(e,n)})},e.prototype.doRequest=function(e,t){if(e.headers&&e.headers.forEach(function(e){return t.setRequestHeader(e.name,e.value)}),e.postData)if(e.postData.params){var n=e.postData.params.map(function(e){return encodeURIComponent(e.name)+"="+encodeURIComponent(e.value)}).join("&");t.send(n)}else t.send(e.postData.text);else t.send()},e}();t.SimpleExecutor=q;var Y=function(){function e(){this.executor=new q}return e.prototype.getResource=function(e){if("undefined"!=typeof atom&&null!=atom){var t=L.get(e);if(t)return t;L.addNotify(e);try{var n={content:""};return this.getResourceAsync(e).then(function(t){try{t.errorMessage?L.set(e,{content:null,errorMessage:null}):(t.errorMessage=null,L.set(e,t))}finally{n.callback&&n.callback(L.get(e)),L.removeNotity(e)}},function(t){L.set(e,{content:null,errorMessage:null}),n.callback&&n.callback(L.get(e)),L.removeNotity(e)}),n}catch(r){console.log("Error"),console.log(r)}}var i=this.executor.execute({method:"get",url:e});if(!i)throw new F("Unable to execute GET "+e);var a=this.toResponse(i,e);return a},e.prototype.getResourceAsync=function(e){var t=this;return this.executor.executeAsync({method:"get",url:e}).then(function(n){if(!n)return Promise.reject(new F("Unable to execute GET "+e));var r=t.toResponse(n,e);return r},function(t){return Promise.reject(new F("Unable to execute GET "+e))})},e.prototype.toResponse=function(e,t){var n=null;e.status>=400&&(n="GET "+t+"\nreturned error: "+e.status,e.statusText&&(n+=" "+e.statusText));var r=null;e.content&&e.content.text&&(r=e.content.text);var i={content:r,errorMessage:n};return i},e}();t.HTTPResolverImpl=Y;var H=function(){function e(){}return e.prototype.content=function(e){if("string"!=typeof e&&(e=""+e),!_.existsSync(e))return null;try{return _.readFileSync(e).toString()}catch(t){return null}},e.prototype.list=function(e){return _.readdirSync(e)},e.prototype.contentAsync=function(e){return new Promise(function(t,n){_.readFile(e,function(e,r){if(null!=e)return n(e);var i=r.toString();t(i)})})},e.prototype.listAsync=function(e){return new Promise(function(t,n){_.readdir(e,function(e,r){return null!=e?t(e):void n(r)})})},e}();t.FSResolverImpl=H;var $=function(e,t,n){if(t&&(t.startPosition>=e&&(t.startPosition+=n),t.endPosition>e&&(t.endPosition+=n),t.kind==w.Kind.MAPPING)){var r=t;$(e,r.key,n),$(e,r.value,n)}},G=function(e,t){for(var n="",r=e.start()-1;r>0;){var i=t[r];if(" "!=i&&"-"!=i)break;n=" "+n,r--}return n},X=function(){function e(e,t,n){this.rootPath=e,this.resolver=t,this._httpResolver=n,this.listeners=[],this.tlisteners=[],this.pathToUnit={},this.failedUnits={},this._fsEnabled=!0,this._namespaceResolver=new k.NamespaceResolver,null==this.resolver?this.resolver=new H:this._fsEnabled=!1,null==this._httpResolver&&(this._httpResolver=new Y)}return e.prototype.getRootPath=function(){return this.rootPath},e.prototype.setFSResolver=function(e){this.resolver=e},e.prototype.setHTTPResolver=function(e){this._httpResolver=e},e.prototype.fsEnabled=function(){return this._fsEnabled},e.prototype.cloneWithResolver=function(t,n){void 0===n&&(n=null);var r=new e(this.rootPath,t,n?n:this._httpResolver);for(var i in this.pathToUnit)r.pathToUnit[i]=this.pathToUnit[i].cloneToProject(r);return r},e.prototype.setCachedUnitContent=function(e,t,n){void 0===n&&(n=!0);var r=e,i=T.toAbsolutePath(this.rootPath,e),a=new K(r,t,n,this,i);return this.pathToUnit[i]=a,a},e.prototype.resolveAsync=function(e,t){var n=this;if(!t)return Promise.reject(new F("Unit path is null"));var r=O.getIncludeReference(t),i=t;r&&(t=r.getIncludePath());var a=T.buildPath(t,e,this.rootPath);if(r){var o,s=T.toAbsolutePath(b.dirname(T.toAbsolutePath(this.rootPath,e)),r.encodedName());this.pathToUnit[a]?Promise.resolve(o).then(function(e){return n.pathToUnit[s]=new K(r.encodedName(),O.resolveContents(i,n.pathToUnit[a].contents()),!1,n,s),n.pathToUnit[s]}):this.unitAsync(a,!0).then(function(e){return n.pathToUnit[a]=e,n.pathToUnit[s]=new K(r.encodedName(),O.resolveContents(i,n.pathToUnit[a].contents()),!1,n,s),n.pathToUnit[s]})}return this.unitAsync(a,!0)},e.prototype.resolve=function(e,t){if(!t)return null;t=t.replace(/\\/g,"/");var n=O.getIncludeReference(t),r=t;n&&(t=n.getIncludePath());var i=T.buildPath(t,e,this.rootPath);if(n){this.pathToUnit[i]||(this.pathToUnit[i]=this.unit(i,!0));var a=this.pathToUnit[i],o=T.toAbsolutePath(b.dirname(T.toAbsolutePath(this.rootPath,e)),n.encodedName());return this.pathToUnit[o]?this.pathToUnit[o]:(this.pathToUnit[o]=new K(n.encodedName(),O.resolveContents(r,a&&a.contents()),!1,this,o),this.pathToUnit[o])}return this.unit(i,!0)},e.prototype.units=function(){var e=this;if(!this.resolver.list)throw new F("Provided FSResolver is unable to list files. Please, use ExtendedFSResolver.");var t=this.resolver.list(this.rootPath).filter(function(e){return".raml"==b.extname(e)});return t.map(function(t){return e.unit(t)}).filter(function(e){return e.isTopLevel()})},e.prototype.unitsAsync=function(){var e=this;return this.resolver.listAsync?this.resolver.listAsync(this.rootPath).then(function(t){var n=t.filter(function(e){return".raml"==b.extname(e)}).map(function(t){return e.unitAsync(t).then(function(e){return e.isTopLevel()?e:null},function(e){return null})});return Promise.all(n).then(function(e){return e.filter(function(e){return null!=e})})}):Promise.reject(new F("Provided FSResolver is unable to list files. Please, use ExtendedFSResolver."))},e.prototype.lexerErrors=function(){var e=[];return this.units().forEach(function(t){e=e.concat(t.lexerErrors())}),e},e.prototype.deleteUnit=function(e,t){void 0===t&&(t=!1);var n=null;n=T.isWebPath(e)?e:t?e:T.toAbsolutePath(this.rootPath,e),delete this.pathToUnit[n]},e.prototype.unit=function(e,t){if(void 0===t&&(t=!1),t||T.isWebPath(e)){if(null!=this.failedUnits[e]&&!this.failedUnits[e].inner)return null}else{var n=T.toAbsolutePath(this.rootPath,e);if(this.failedUnits[n]&&!this.failedUnits[e].inner)return null}var r,i=null,a=e;if(T.isWebPath(e)){if(this.pathToUnit[a])return this.pathToUnit[a];if(this._httpResolver){if(r=this._httpResolver.getResource(e),r&&r.errorMessage)throw new F(r.errorMessage);i=r?r.content:null}else r=(new Y).getResource(a),i=r?r.content:null}else{"/"!=e.charAt(0)||t||(e=e.substr(1));var a=T.toAbsolutePath(this.rootPath,e);if(this.pathToUnit[a])return this.pathToUnit[a];if(T.isWebPath(a))if(this._httpResolver){var o=this._httpResolver.getResource(a);if(o&&o.errorMessage)throw new F(o.errorMessage);i=o?o.content:null}else{var s=(new Y).getResource(a);i=s?s.content:null}else i=this.resolver.content(a)}if(null==i)return null;var u=P.stringStartsWith(i,"#%RAML"),l=T.isWebPath(this.rootPath)==T.isWebPath(a)?b.relative(this.rootPath,a):a,p=new K(l,i,u,this,a);return this.pathToUnit[a]=p,r&&(r.callback=function(e){p.updateContent(e&&e.content)}),p},e.prototype.unitAsync=function(e,t){var n=this;void 0===t&&(t=!1);var r=null,i=e;if(T.isWebPath(e)){if(this.pathToUnit[i])return Promise.resolve(this.pathToUnit[i]);if(this._httpResolver){var a=this._httpResolver.getResourceAsync(i);r=a.then(function(e){return e.errorMessage?Promise.reject(new F(e.errorMessage)):e.content})}else r=(new Y).getResourceAsync(i)}else{if("/"!=e.charAt(0)||t||(e=e.substr(1)),i=t?e:T.toAbsolutePath(this.rootPath,e),this.pathToUnit[i])return Promise.resolve(this.pathToUnit[i]);if(T.isWebPath(i))if(this._httpResolver){var a=this._httpResolver.getResourceAsync(i);r=a.then(function(e){return e.errorMessage?Promise.reject(new F(e.errorMessage)):e.content})}else r=(new Y).getResourceAsync(i);else r=this.resolver.contentAsync(i)}if(null==r)return Promise.resolve(null);var o=T.isWebPath(this.rootPath)==T.isWebPath(i)?b.relative(this.rootPath,i):i;return r.then(function(e){if(null==e)return Promise.reject(new F("Can note resolve "+i));var t=P.stringStartsWith(e,"#%RAML"),r=new K(o,e,t,n,i);return n.pathToUnit[i]=r,r},function(e){return"object"==typeof e&&e instanceof F?Promise.reject(e):Promise.reject(new F(e.toString()))}).then(function(e){return e.isRAMLUnit()?e:D.isScheme(e.contents())?D.startDownloadingReferencesAsync(e.contents(),e):e})},e.prototype.visualizeNewlines=function(e){for(var t="",n=0;n<e.length;n++){var r=e[n];"\r"==r&&(r="\\r"),"\n"==r&&(r="\\n"),t+=r}return t},e.prototype.indent=function(e){var t=e.unit().contents();if(e==e.root())return"";var n=G(e,t),r=a(e.dump());if(r.length>1&&r[1].trim().length>0){var i=s(r[1]);return n+i}return n+"  "},e.prototype.startIndent=function(e){e.unit().contents();if(e==e.root())return"";var t=a(e.dump());if(t.length>0){console.log("FIRST: "+t[0]);var n=s(t[0]);return n+"  "}return""},e.prototype.canWriteInOneLine=function(e){return!1},e.prototype.isOneLine=function(e){return e.text().indexOf("\n")<0},e.prototype.recalcPositionsUp=function(e){for(var t=e;t;)t.recalcEndPositionFromChilds(),t=t.parent()},e.prototype.add2=function(e,t,n,r,i){void 0===i&&(i=!1);var a=e.unit(),o=(e.root(),null);if(r&&(z.isInstance(r)&&(o=r),Q.isInstance(r)&&(o=r.point)),e.isValueInclude()){var s=e.children();if(0==s.length)throw new F("not implemented: insert into empty include ref");var u=s[0].parent();return void this.add2(u,t,n,o,i)}var l=(new I.TextRange(a.contents(),t.start(),t.end()),new I.TextRange(a.contents(),e.start(),e.end()),e.unit().contents());e.valueKind()==w.Kind.SEQ&&(e=d(e.valueAsSeq(),e,e.unit()));var i=this.isJson(e),p=i?"":this.indent(e.isSeq()?e.parent():e),c=p,f=p.length,m=e.isSeq()||e.isMapping()&&(e.isValueSeq()||e.isValueScalar()||!e.asMapping().value);n=n,n&&(i||m&&(c+="  ",f+=2));var h=new B(c);t.markupNode(h,t._actualNode(),0,i);var y=h.text;if(n){var v=I.trimEnd(y),g=y.length-v.length;if(g>0){var A=y.length;y=y.substring(0,A-g),t.shiftNodes(A-g,-g)}}n&&!i?(t.highLevelNode(),e.isMapping(),y=e.isSeq()||e.isMapping()&&(e.isValueSeq()||e.isValueScalar()||!e.asMapping().value)?p+"- "+y:p+y):y=p+y;var S=e.end();if(o)o!=e?S=o.end():i&&n||(S=e.keyEnd()+1,S=new I.TextRange(l,S,S).extendAnyUntilNewLines().endpos());else if(i&&n){var E=e.asSeq();E&&(S=E.items.length>0?E.items[E.items.length-1].endPosition:E.endPosition-1)}else if(r&&Q.isInstance(r)){var T=r;T.type==J.START&&(S=e.keyEnd()+1,S=new I.TextRange(l,S,S).extendAnyUntilNewLines().endpos())}var b=new I.TextRange(l,0,S);if(S=b.extendToNewlines().reduceSpaces().endpos(),i&&e.isSeq()){var E=e.asSeq();E.items.length>0&&(y=", "+y,f+=2)}else S>0&&"\n"!=l[S-1]&&(y="\n"+y,f++);var N=0;n&&!i&&(y+="\n",N++);var _=l.substring(0,S)+y+l.substring(S,l.length),M=a;if(M.updateContentSafe(_),this.executeReplace(new I.TextRange(l,S,S),y,M),e.root().shiftNodes(S,f+(t.end()-t.start())+N),o){for(var s=e.children(),R=-1,C=0;C<s.length;C++){var L=s[C];if(L.start()==o.start()&&L.end()==o.end()){R=C;break}}R>=0?e.addChild(t,R+1):e.addChild(t)}else e.addChild(t);t.shiftNodes(0,S+f),this.recalcPositionsUp(e),t.setUnit(e.unit()),t.visit(function(t){var n=t;return n.setUnit(e.unit()),!0})},e.prototype.isJsonMap=function(e){if(!e.isMap())return!1;var t=e.text().trim();return t.length>=2&&"{"==t[0]&&"}"==t[t.length-1]},e.prototype.isJsonSeq=function(e){if(!e.isSeq())return!1;var t=e.text().trim();return t.length>=2&&"["==t[0]&&"]"==t[t.length-1]},e.prototype.isJson=function(e){return this.isJsonMap(e)||this.isJsonSeq(e)},e.prototype.remove=function(e,t,n){var r=n.parent();if(n._oldText=n.dump(),this.isOneLine(n)&&n.isMapping()&&n.parent().isMap()){var i=n.parent();if(1==i.asMap().mappings.length&&null!=i.parent())return void this.remove(e,i.parent(),i)}if(this.isOneLine(n)&&n.isScalar()&&n.parent().isSeq()){var a=n.parent(),o=a.asSeq();if(1==o.items.length)return void this.remove(e,a.parent(),a)}if(t.isMapping()&&n.isSeq()){var s=t.parent();return void this.remove(e,s,t)}var u=new I.TextRange(e.contents(),n.start(),n.end()),l=(new I.TextRange(e.contents(),t.start(),t.end()),new I.TextRange(e.contents(),r.start(),r.end()),u.startpos());if(t.isSeq()){var p=n.isSeq()?n:n.parentOfKind(w.Kind.SEQ);u=p&&this.isJson(p)?u.extendSpaces().extendCharIfAny(",").extendSpaces():u.extendToStartOfLine().extendAnyUntilNewLines().extendToNewlines()}t.isMap()&&(u=u.trimEnd().extendAnyUntilNewLines().extendToNewlines(),u=u.extendToStartOfLine().extendUntilNewlinesBack()),t.kind()==w.Kind.MAPPING&&(this.isJson(n)&&this.isOneLine(n)||(u=u.extendSpacesUntilNewLines(),u=u.extendToNewlines(),u=u.extendToStartOfLine().extendUntilNewlinesBack())),n.isSeq()&&(u=u.reduceSpaces());var c=e;c.updateContentSafe(u.remove()),this.executeReplace(u,"",c),n.parent().removeChild(n);var f=-u.len();t.root().shiftNodes(l,f),this.recalcPositionsUp(t)},e.prototype.changeKey=function(e,t,n){var r=new I.TextRange(t.unit().contents(),t.keyStart(),t.keyEnd());if(t.kind()==w.Kind.MAPPING){var i=t._actualNode().key;i.value=n,i.endPosition=i.startPosition+n.length}var a=e;this.executeReplace(r,n,a);var o=n.length-r.len();t.root().shiftNodes(r.startpos(),o,t),this.recalcPositionsUp(t)},e.prototype.executeReplace=function(e,t,n){var r=new T.TextChangeCommand(e.startpos(),e.endpos()-e.startpos(),t,n);n.project();try{this.tlisteners.forEach(function(e){return e(r)})}catch(i){return!1}var a=e.replace(t);return n.updateContentSafe(a),!0},e.prototype.changeValue=function(e,t,n){var r,i=new I.TextRange(t.unit().contents(),t.start(),t.end()),a=0,o=0,s=null,u=null;if(t.kind()==w.Kind.SCALAR){if("string"!=typeof n)throw new F("not implemented");t.asScalar().value=n,r=n}else if(t.kind()==w.Kind.MAPPING){if(u=t.asMapping(),t.isValueInclude()){var l=t.valueAsInclude(),p=l.value,f=p,d=t.unit().resolve(f);if(null==d)return void console.log("attr.setValue: couldn't resolve: "+f);if(d.isRAMLUnit())return;return void(O.getIncludeReference(p)||d.updateContent(n))}if(i=u.value?i.withStart(t.valueStart()).withEnd(t.valueEnd()):i.withStart(t.keyEnd()+1).withEnd(t.keyEnd()+1),i=i.reduceNewlinesEnd(),null==n)r="",u.value=null;else if("string"==typeof n||null==n){var m=n,h=this.indent(t);if(m&&I.isMultiLine(m)&&(m=""+I.makeMutiLine(m,h.length/2)),r=m,u.value){if(u.value.kind==w.Kind.SEQ){console.log("seq value");u.value.items[0];throw"assign value!!!"}if(u.value.kind==w.Kind.SCALAR){var y=u.value,v=y.value||"";y.value=m,u.value.endPosition=u.value.startPosition+m.length,
u.endPosition=u.value.endPosition,o+=m.length-v.length}}else if(console.log("no value"),u.value=w.newScalar(m),u.value.startPosition=t.keyEnd()+1,u.value.endPosition=u.value.startPosition+m.length,u.endPosition=u.value.endPosition,e.contents().length>t.keyEnd()+1){var g=t.keyEnd()+1;":"==e.contents()[g-1]&&(r=" "+r,u.value.startPosition++,u.value.endPosition++,u.endPosition++,o++)}}else{var A=n;if(A.isMapping())n=c([A.asMapping()]),A=n;else if(!A.isMap())throw new F("only MAP/MAPPING nodes allowed as values");var S=new B("");A.markupNode(S,A._actualNode(),0,!0),r=""+S.text,A.shiftNodes(0,i.startpos()+o),s=A}}else console.log("Unsupported change value case: "+t.kindName());var E=e;this.executeReplace(i,r,E);var T=r.length-i.len();t.root().shiftNodes(i.endpos()+a,T,t),s&&(u.value=s._actualNode()),this.recalcPositionsUp(t)},e.prototype.initWithRoot=function(e,t){var n=e.end();t.markup(!1),t._actualNode().startPosition=n,t._actualNode().endPosition=n,t.setUnit(e.unit())},e.prototype.execute=function(e){var t=this;e.commands.forEach(function(e){switch(e.kind){case T.CommandKind.CHANGE_VALUE:var n=e.target,r=n.value();r||(r="");var i=e.value;if(console.log("set value: "+typeof r+" ==> "+typeof i),"string"!=typeof r&&"number"!=typeof r&&"boolean"!=typeof r||"string"!=typeof i)if("string"!=typeof r&&"number"!=typeof r&&"boolean"!=typeof r||"string"==typeof i)if("string"!=typeof r&&"string"==typeof i){var a=e.value;if(r.kind()!=w.Kind.MAPPING)throw new F("unsupported case: attribute value conversion: "+typeof r+" ==> "+typeof i+" not supported");I.isMultiLine(a)?(n.children().forEach(function(e){t.remove(n.unit(),n,e)}),t.changeValue(n.unit(),n,a)):t.changeKey(n.unit(),r,a)}else{if("string"==typeof r||"string"==typeof i)throw new F("shouldn't be this case: attribute value conversion "+typeof r+" ==> "+typeof i+" not supported");var o=i;if(o.isMapping()&&(i=c([o.asMapping()])),r==i)break;var s=i;s.asMap();n.children().forEach(function(e){t.remove(n.unit(),n,e)}),s.children().forEach(function(e){}),t.changeValue(n.unit(),n,i)}else t.changeValue(n.unit(),n,i);else r!=i&&t.changeValue(n.unit(),n,i);return;case T.CommandKind.CHANGE_KEY:var n=e.target;return void t.changeKey(n.unit(),n,e.value);case T.CommandKind.ADD_CHILD:var n=e.target,u=e.value;return void t.add2(n,u,e.toSeq,e.insertionPoint);case T.CommandKind.REMOVE_CHILD:var l=e.target,s=e.value;return void t.remove(l.unit(),l,s);case T.CommandKind.INIT_RAML_FILE:var p=e.target,f=e.value;return void t.initWithRoot(p,f);default:return void console.log("UNSUPPORTED COMMAND: "+T.CommandKind[e.kind])}})},e.prototype.replaceYamlNode=function(e,t,n,r,i){var a=w.load(t,{ignoreDuplicateKeys:!0});this.updatePositions(e.start(),a),e.root().shiftNodes(n,r);var o=e.parent(),s=e._actualNode(),u=s.parent;if(a.parent=u,o&&o.kind()==w.Kind.MAP){var l=o._actualNode();l.mappings=l.mappings.map(function(e){return e!=s?e:a})}e.updateFrom(a),this.recalcPositionsUp(e)},e.prototype.executeTextChange2=function(e){var t=e.unit,n=t.contents(),r=e.target;if(r){var i=n.substring(r.start(),r.end());n=n.substr(0,e.offset)+e.text+n.substr(e.offset+e.replacementLength);var a=i.substr(0,e.offset-r.start())+e.text+i.substr(e.offset-r.start()+e.replacementLength);if(t.updateContentSafe(n),e.offset>r.start())try{var o=e.text.length-e.replacementLength,s=e.offset;r.unit().project().replaceYamlNode(r,a,s,o,e.unit)}catch(u){console.log("New node contents (causes error below): \n"+a),console.log("Reparse error: "+u.stack)}}else n=n.substr(0,e.offset)+e.text+n.substr(e.offset+e.replacementLength);t.updateContent(n),this.listeners.forEach(function(e){e(null)}),this.tlisteners.forEach(function(t){t(e)})},e.prototype.executeTextChange=function(e){(new Date).getTime();try{var t=e.unit.contents(),n=e.target;null==n&&(n=this.findNode(e.unit.ast(),e.offset,e.offset+e.replacementLength));var r=e.unit;if(n){var a=t.substring(n.start(),n.end()),o=t;t=t.substr(0,e.offset)+e.text+t.substr(e.offset+e.replacementLength);var s=a.substr(0,e.offset-n.start())+e.text+a.substr(e.offset-n.start()+e.replacementLength);r.updateContentSafe(t);u(o,e);if(e.offset>n.start())try{var l=w.load(s,{ignoreDuplicateKeys:!0});this.updatePositions(n.start(),l);var p=e.text.length-e.replacementLength;if(e.unit.ast().shiftNodes(e.offset,p),null!=l&&l.kind==w.Kind.MAP){var c=l.mappings[0],f=n._actualNode(),d=f.parent,m=new T.ASTDelta,h=e.unit;if(m.commands=[new T.ASTChangeCommand(T.CommandKind.CHANGE_VALUE,new z(i(f),h,null,null,null),new z(c,h,null,null,null),0)],d&&d.kind==w.Kind.MAP){var y=d;y.mappings=y.mappings.map(function(e){return e!=f?e:c})}return c.parent=d,this.recalcPositionsUp(n),n.updateFrom(c),this.listeners.forEach(function(e){e(m)}),void this.tlisteners.forEach(function(t){t(e)})}}catch(v){console.log("New node contents (causes error below): \n"+s),console.log("Reparse error: "+v.stack)}}else t=t.substr(0,e.offset)+e.text+t.substr(e.offset+e.replacementLength);(new Date).getTime();
//!find node in scope
r.updateContent(t),this.listeners.forEach(function(e){e(null)}),this.tlisteners.forEach(function(t){t(e)})}finally{(new Date).getTime()}},e.prototype.updatePositions=function(e,t){var n=this;if(null!=t)switch(-1==t.startPosition?t.startPosition=e:t.startPosition=e+t.startPosition,t.endPosition=e+t.endPosition,t.kind){case w.Kind.MAP:var r=t;r.mappings.forEach(function(t){return n.updatePositions(e,t)});break;case w.Kind.MAPPING:var i=t;this.updatePositions(e,i.key),this.updatePositions(e,i.value);break;case w.Kind.SCALAR:break;case w.Kind.SEQ:var a=t;a.items.forEach(function(t){return n.updatePositions(e,t)})}},e.prototype.findNode=function(e,t,n){var r=this;if(null==e)return null;var i=e;if(e.start()<=t&&e.end()>=n){var a=e;return i.directChildren().forEach(function(e){var i=r.findNode(e,t,n);i&&(a=i)}),a}return null},e.prototype.addTextChangeListener=function(e){this.tlisteners.push(e)},e.prototype.removeTextChangeListener=function(e){this.tlisteners=this.tlisteners.filter(function(t){return t!=e})},e.prototype.addListener=function(e){this.listeners.push(e)},e.prototype.removeListener=function(e){this.listeners=this.listeners.filter(function(t){return t!=e})},e.prototype.namespaceResolver=function(){return this._namespaceResolver},e}();t.Project=X;var z=function(){function e(e,t,n,r,i,a,o){void 0===a&&(a=!1),void 0===o&&(o=!1),this._node=e,this._unit=t,this._parent=n,this._anchor=r,this._include=i,this.cacheChildren=a,this._includesContents=o,this._errors=[]}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&M.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.actual=function(){return this._node},e.prototype.yamlNode=function(){return this._node},e.prototype.includesContents=function(){return this._includesContents},e.prototype.setIncludesContents=function(e){this._includesContents=e},e.prototype.gatherIncludes=function(t,n,r,i){var a=this;if(void 0===t&&(t=[]),void 0===n&&(n=null),void 0===r&&(r=null),void 0===i&&(i=!0),null!=this._node){var o=this._node.kind;if(o!=w.Kind.SCALAR)if(o==w.Kind.MAP){var s=this._node;1!=s.mappings.length||i?s.mappings.map(function(t){return new e(t,a._unit,a,r?r:a._anchor,n?n:a._include,a.cacheChildren)}).forEach(function(e){return e.gatherIncludes(t)}):new e(s.mappings[0].value,this._unit,this,n,r,this.cacheChildren).gatherIncludes(t)}else if(o==w.Kind.MAPPING){var u=this._node;null==u.value||new e(u.value,this._unit,this,r?r:this._anchor,n?n:this._include,this.cacheChildren).gatherIncludes(t)}else if(o==w.Kind.SEQ){var l=this._node;l.items.filter(function(e){return null!=e}).map(function(t){return new e(t,a._unit,a,r?r:a._anchor,n?n:a._include,a.cacheChildren)}).forEach(function(e){return e.gatherIncludes(t)})}else o==w.Kind.INCLUDE_REF&&this._unit&&t.push(this);else if(D.isScheme(this._node.value)){var p=D.getReferences(this._node.value,this.unit());p.forEach(function(n){var r=w.newScalar(n);r.kind=w.Kind.INCLUDE_REF;var i=new e(r,a.unit(),null,null,null);t.push(i)})}}},e.prototype.setHighLevelParseResult=function(e){this._highLevelParseResult=e},e.prototype.highLevelParseResult=function(){return this._highLevelParseResult},e.prototype.setHighLevelNode=function(e){this._highLevelNode=e},e.prototype.highLevelNode=function(){return this._highLevelNode},e.prototype.start=function(){return this._node.startPosition},e.prototype.errors=function(){return this._errors},e.prototype.addIncludeError=function(e){if(!M.find(this._errors,function(t){return t.message==e.message})){var t=this._node;t.includeErrors||(t.includeErrors=[]),M.find(t.includeErrors,function(t){return t.message==e.message})||(this._errors.push(e),t.includeErrors.push(e))}},e.prototype.parent=function(){return this._parent},e.prototype.recalcEndPositionFromChilds=function(){var e=(this.children(),this.children()[0]),t=this.children()[this.children().length-1];if(this.isMapping()){var n=this.asMapping();if(n.value)if(n.value.kind==w.Kind.MAP){var r=n.value;r.startPosition<0&&e&&(r.startPosition=e.start()),t&&(this._node.endPosition=t._node.endPosition),this._node.endPosition=Math.max(this._node.endPosition,n.value.endPosition)}else if(n.value.kind==w.Kind.SEQ){var i=n.value;if(i.startPosition<0&&i.items.length>0){var a=i.items[0].startPosition,o=new I.TextRange(this.unit().contents(),a,a);o=o.extendSpacesBack().extendCharIfAnyBack("-"),i.startPosition=o.startpos()}if(i.items.length>0){var s=i.items[i.items.length-1];this._node.endPosition=Math.max(this._node.endPosition,i.endPosition,s.endPosition),i.endPosition=Math.max(this._node.endPosition,i.endPosition,s.endPosition)}}else n.value.kind==w.Kind.SCALAR||t&&(this._node.endPosition=t._node.endPosition)}else t&&(this._node.endPosition=t._node.endPosition)},e.prototype.isValueLocal=function(){if(this._node.kind==w.Kind.MAPPING){var e=this._node.value.kind;return e!=w.Kind.INCLUDE_REF&&e!=w.Kind.ANCHOR_REF}return!0},e.prototype.keyStart=function(){return this._node.kind==w.Kind.MAPPING?this._node.key.startPosition:-1},e.prototype.keyEnd=function(){return this._node.kind==w.Kind.MAPPING?this._node.key.endPosition:-1},e.prototype.valueStart=function(){if(this._node.kind==w.Kind.MAPPING){var e=this.asMapping();return e.value?e.value.startPosition:e.endPosition}return this._node.kind==w.Kind.SCALAR?this.start():-1},e.prototype.valueEnd=function(){if(this._node.kind==w.Kind.MAPPING){var e=this.asMapping();return e.value?e.value.endPosition:e.endPosition}return this._node.kind==w.Kind.SCALAR?this.end():-1},e.prototype.end=function(){return this._node.endPosition},e.prototype.dump=function(){if(this._oldText)return this._oldText;if(this._unit&&this._node.startPosition>0&&this._node.endPosition>0){var e=this._unit.contents().substring(this._node.startPosition,this._node.endPosition);return e=o(e,G(this,this._unit.contents()))}return w.dump(this.dumpToObject(),{})},e.prototype.dumpToObject=function(e){return void 0===e&&(e=!1),this.dumpNode(this._node,e)},e.prototype.dumpNode=function(e,t){var n=this;if(void 0===t&&(t=!1),!e)return null;if(e.kind==w.Kind.INCLUDE_REF){if(this._unit){var r=e,i=r.value,a=null;try{a=this._unit.resolve(i)}catch(o){}if(null==a)return null;if(a.isRAMLUnit()&&this.canInclude(a)){var s=this.unit(),u=a;u.addIncludedBy(s.absolutePath()),s.getIncludedByPaths().forEach(function(e){u.addIncludedBy(e)});var p=a.ast();if(p)return p.dumpToObject(t)}else if(this.canInclude(a))return a.contents()}return null}if(e.kind==w.Kind.SEQ){var c=e,f=[];return c.items.forEach(function(e){return f.push(n.dumpNode(e,t))}),f}if(e.kind==w.Kind.ANCHOR_REF){var d=e;return this.dumpNode(d.value,t)}if(e.kind==w.Kind.MAPPING){var m=e,h={},y=m.value,v=this.dumpNode(y,t);return h[""+this.dumpNode(m.key,t)]=v,h}if(e.kind==w.Kind.SCALAR){var r=e,g=r.value;return r.plainScalar&&(g=l(g)),g}if(e.kind==w.Kind.MAP){var A=e,S={};return A.mappings&&A.mappings.forEach(function(e){var r=n.dumpNode(e.value,t);null==r&&(r=t?"!$$$novalue":r),S[n.dumpNode(e.key,t)+""]=r}),S}},e.prototype.keyKind=function(){return this._node.key?this._node.key.kind:null},e.prototype._actualNode=function(){return this._node},e.prototype.execute=function(e){this.unit()?this.unit().project().execute(e):e.commands.forEach(function(e){switch(e.kind){case T.CommandKind.CHANGE_VALUE:var t=e.target,n=e.value,r=t._actualNode();t.start();return void(r.kind==w.Kind.MAPPING&&(r.value=w.newScalar(""+n)));case T.CommandKind.CHANGE_KEY:var t=e.target,n=e.value,r=t._actualNode();if(r.kind==w.Kind.MAPPING){var i=r.key;i.value=n}return}})},e.prototype.updateFrom=function(e){this._node=e},e.prototype.isAnnotatedScalar=function(){if(!this.unit())return!1;var e;if(this.kind()==w.Kind.MAPPING&&this.valueKind()==w.Kind.MAP?e=this._node.value.mappings:null==this.key()&&this.kind()==w.Kind.MAP&&(e=this._node.mappings),e){var t=e.length>0;return e.forEach(function(e){"value"!==e.key.value&&(e.key.value&&"("==e.key.value.charAt(0)&&")"==e.key.value.charAt(e.key.value.length-1)||(t=!1))}),t}return!1},e.prototype.value=function(t){if(!this._node)return"";if(this._node.kind==w.Kind.SCALAR){if("~"===this._node.value&&null===this._node.valueObject)return t?"null":null;if(!t&&""+this._node.valueObject===this._node.value)return this._node.valueObject;var n=this._node.value;return t||this._node.plainScalar&&(n=l(n)),n}if(this._node.kind==w.Kind.ANCHOR_REF){var r=this._node;return new e(r.value,this._unit,this,null,null).value(t)}if(this._node.kind==w.Kind.MAPPING){var i=this._node;if(null==i.value)return null;if(this.isAnnotatedScalar())for(var a=new e(i.value,this._unit,this,null,null),o=a.children(),s=0;s<o.length;s++)if("value"===o[s].key())return o[s].valueKind()==w.Kind.SEQ?o[s].children().map(function(e){return e.value()}):o[s].value();return new e(i.value,this._unit,this,null,null).value(t)}if(this._node.kind==w.Kind.INCLUDE_REF){var u=this._node.value,p=u,c=null;try{c=this._unit.resolve(p)}catch(f){return"can not resolve "+p+" due to: "+f.message}if(null==c)return"can not resolve "+p;if(c.isRAMLUnit()){var d=c.ast();return d?d.value():"can not resolve "+p+" due to: file is empty"}var m=c.contents();return I.isMultiLineValue(m)&&(m=I.fromMutiLine(m)),m}if(this._node.kind==w.Kind.MAP){var h=this._node;if(1==h.mappings.length)return new e(h.mappings[0],this._unit,this,null,null);if(this.isAnnotatedScalar())for(var o=this.children(),s=0;s<o.length;s++)if("value"===o[s].key())return o[s].valueKind()==w.Kind.SEQ?o[s].children().map(function(e){return e.value()}):o[s].value()}if(this._node.kind==w.Kind.SEQ){var y=this._node;if(1==y.items.length)return new e(y.items[0],this._unit,this,null,null).value(t)}return null},e.prototype.printDetails=function(e){var t="";e||(e="");var n=this.kindName();return this.kind()==w.Kind.SCALAR?t+=e+"["+n+"] "+this.value()+"\n":this.kind()==w.Kind.MAPPING&&this._node.value&&this._node.value.kind==w.Kind.SCALAR?t+=e+"["+n+"] "+this.key()+" = "+this.value()+"\n":this.kind()==w.Kind.MAPPING?(t+=e+"["+n+"] "+this.key()+" = :\n",this.children().forEach(function(n){t+=n.printDetails(e+"	")})):(t+=e+"["+n+"] :\n",this.children().forEach(function(n){t+=n.printDetails(e+"	")})),t},e.prototype.visit=function(e){this.children().forEach(function(t){e(t)&&t.visit(e)})},e.prototype.rawKey=function(){if(!this._node)return"";if(this._node.kind==w.Kind.MAPPING){var e=this._node;if(e.key.kind==w.Kind.SEQ){var t=e.key,n="[";return t.items.forEach(function(e){return n+=e.value}),n+"]"}return e.key.value}if(this._node.kind==w.Kind.INCLUDE_REF){var r=this.children();if(1==r.length)return r[0].key()}return null},e.prototype.key=function(e){void 0===e&&(e=!1);var t=this.rawKey();return e?t:(null!=t&&P.stringEndsWith(t,"?")&&(t=t.substring(0,t.length-1)),t)},e.prototype.optional=function(){var e=this.rawKey();return null!=e&&P.stringEndsWith(e,"?")},e.prototype.addChild=function(e,t){void 0===t&&(t=-1);var n=e;if(n._parent=this,this._oldText=null,this.isMap()){var r=this.asMap();(null==r.mappings||void 0==r.mappings)&&(r.mappings=[]),t>=0?r.mappings.splice(t,0,n.asMapping()):r.mappings.push(n.asMapping())}else if(this.isMapping()){var i=this.asMapping(),a=i.value;if(!i.value&&n.isMap())return void(i.value=n._actualNode());if(i.value&&i.value.kind==w.Kind.SCALAR&&(i.value=null,a=null),a||(a=n.isScalar()||n.highLevelNode()&&n.highLevelNode().property().getAdapter(C.RAMLPropertyParserService).isEmbedMap()?w.newSeq():w.newMap(),i.value=a),a.kind==w.Kind.MAP){var r=a;(null==r.mappings||void 0==r.mappings)&&(r.mappings=[]),n.isScalar(),t>=0?r.mappings.splice(t,0,n.asMapping()):r.mappings.push(n.asMapping())}else{if(a.kind!=w.Kind.SEQ)throw new F("Insert into mapping with "+w.Kind[i.value.kind]+" value not supported");var o=a;t>=0?o.items.splice(t,0,n._actualNode()):o.items.push(n._actualNode())}}else{if(!this.isSeq())throw new F("Insert into "+this.kindName()+" not supported");var o=this.asSeq();t>=0?o.items.splice(t,0,n._actualNode()):o.items.push(n._actualNode())}},e.prototype.removeChild=function(e){this._oldText=null;var t,n,r=e;if(this.kind()==w.Kind.SEQ){var i=this.asSeq();t=r._node,n=i.items.indexOf(t),n>-1&&i.items.splice(n,1)}else if(this.kind()==w.Kind.MAP){var a=this.asMap();t=r.asMapping(),n=a.mappings.indexOf(t),n>-1&&a.mappings.splice(n,1)}else{if(this.kind()!=w.Kind.MAPPING)throw new F("Delete from "+w.Kind[this.kind()]+" unsupported");var o=this.asMapping();if(r._actualNode()==o.value)o.value=null;else{var a=o.value;t=r.asMapping(),a&&a.mappings&&(n=a.mappings.indexOf(t),n>-1&&a.mappings.splice(n,1))}}},e.prototype.hasInnerIncludeError=function(){return this.innerIncludeErrors},e.prototype.includeErrors=function(){if(this._node.kind==w.Kind.MAPPING){var t=this._node;if(null==t.value)return[];var n=new e(t.value,this._unit,this,this._anchor,this._include),r=n.includeErrors();return this.innerIncludeErrors=n.hasInnerIncludeError(),r}var i=[];if(this._node.kind==w.Kind.INCLUDE_REF){var t=this._node;if(null==t.value)return[];var a=this.includePath(),o=null;try{o=this._unit.resolve(a)}catch(s){this.innerIncludeErrors=s.inner;var u="Can not resolve "+a+" due to: "+s.message;return i.push(u),i}var l=this._node.includeErrors;if(l&&l.length>0)return this.innerIncludeErrors=!0,i=l.map(function(e){return"object"==typeof e&&e instanceof s?e.message:e.toString()});if(null==o)return i.push("Can not resolve "+a),i;if(o.isRAMLUnit()){var p=o.ast();if(p)return[];i.push(""+a+" can not be parsed")}}return i},e.prototype.joinMappingsWithFullIncludeAnchor=function(t,n,r){var i=this,a=M.find(t,function(e){return e.key&&e.value&&e.key.kind==w.Kind.SCALAR&&"<<"==e.key.value&&e.value.kind==w.Kind.ANCHOR_REF});if(!a)return t.map(function(t){return new e(t,i._unit,i,r?r:i._anchor,n?n:i._include,i.cacheChildren)});var o=M.filter(t,function(e){return!(e.key.kind==w.Kind.SCALAR&&"<<"==e.key.value&&e.value.kind==w.Kind.ANCHOR_REF)}),s=new e(a.value,this._unit,this,n,r,this.cacheChildren).children(null,null,!0),u=o.map(function(t){return new e(t,i._unit,i,r?r:i._anchor,n?n:i._include,i.cacheChildren)});return u.concat(s)},e.prototype.children=function(t,n,r){var i=this;if(void 0===t&&(t=null),void 0===n&&(n=null),void 0===r&&(r=!0),null==this._node)return[];if(this.cacheChildren&&this._children)return this._children;var a,o=this._node.kind;if(o==w.Kind.SCALAR)a=[];else if(o==w.Kind.MAP){var s=this._node;a=1!=s.mappings.length||r?this.joinMappingsWithFullIncludeAnchor(s.mappings,t,n):new e(s.mappings[0].value,this._unit,this,t,n,this.cacheChildren).children(null,null,!0)}else if(o==w.Kind.MAPPING){var u=this._node;if(null==u.value)a=[];else{var l=new e(u.value,this._unit,this,n?n:this._anchor,t?t:this._include,this.cacheChildren);a=l.children(),l.includesContents()&&this.setIncludesContents(!0)}}else if(o==w.Kind.SEQ){var p=this._node;a=p.items.filter(function(e){return null!=e}).map(function(r){return new e(r,i._unit,i,n?n:i._anchor,t?t:i._include,i.cacheChildren)})}else if(o==w.Kind.INCLUDE_REF){if(this._unit){var c=this.includePath(),f=null;try{f=this._unit.resolve(c)}catch(d){}if(null==f)a=[];else if(f.isRAMLUnit())if(this.canInclude(f)){var m=this.unit(),h=f;h.addIncludedBy(m.absolutePath()),m.getIncludedByPaths().forEach(function(e){h.addIncludedBy(e)});var y=f.ast();y&&(this.cacheChildren&&(y=v(y)),a=f.ast().children(this,null),this.setIncludesContents(!0))}else this.addIncludeError&&this.addIncludeError(new d("Recursive definition"))}a||(a=[])}else{if(o!=w.Kind.ANCHOR_REF)throw new d("Should never happen; kind : "+w.Kind[this._node.kind]);var g=this._node;a=new e(g.value,this._unit,this,null,null,this.cacheChildren).children()}return this.cacheChildren&&(this._children=a),a},e.prototype.canInclude=function(e){for(var t=this.includedFrom();null!=t;){if(t.unit().absolutePath()==e.absolutePath())return!1;t=t.includedFrom()}return!this.unit().includedByContains(e.absolutePath())},e.prototype.directChildren=function(t,n,r){var i=this;if(void 0===t&&(t=null),void 0===n&&(n=null),void 0===r&&(r=!0),this._node){switch(this._node.kind){case w.Kind.SCALAR:return[];case w.Kind.MAP:var a=this._node;return 1!=a.mappings.length||r?a.mappings.map(function(r){return new e(r,i._unit,i,n?n:i._anchor,t?t:i._include)}):new e(a.mappings[0].value,this._unit,this,t,n).directChildren(null,null,!0);case w.Kind.MAPPING:var o=this._node;return null==o.value?[]:new e(o.value,this._unit,this,n?n:this._anchor,t?t:this._include).directChildren();case w.Kind.SEQ:var s=this._node;return s.items.filter(function(e){return null!=e}).map(function(r){return new e(r,i._unit,i,n?n:i._anchor,t?t:i._include)});case w.Kind.INCLUDE_REF:return[];case w.Kind.ANCHOR_REF:return[]}throw new F("Should never happen; kind : "+w.Kind[this._node.kind])}return[]},e.prototype.anchorId=function(){return this._node.anchorId},e.prototype.unit=function(){return this._unit},e.prototype.containingUnit=function(){return this.valueKind()==w.Kind.INCLUDE_REF?this.unit().resolve(this._node.value.value):this.kind()==w.Kind.INCLUDE_REF?this.unit().resolve(this._node.value):this._unit},e.prototype.includeBaseUnit=function(){return this._unit},e.prototype.setUnit=function(e){this._unit=e},e.prototype.includePath=function(){var e=this.getIncludeString();return e?e:null},e.prototype.includeReference=function(){var e=this.getIncludeString();return e?O.getIncludeReference(e):null},e.prototype.getIncludeString=function(){if(this._node.kind==w.Kind.INCLUDE_REF){var t=this._node.value;return t}if(this._node.kind==w.Kind.MAPPING){var n=this._node;return null==n.value?null:new e(n.value,this._unit,this,null,null).getIncludeString()}return null},e.prototype.anchoredFrom=function(){return this._anchor},e.prototype.includedFrom=function(){return this._include},e.prototype.kind=function(){return this._actualNode().kind},e.prototype.valueKind=function(){if(this._node.kind!=w.Kind.MAPPING)return null;var e=this._node;return e.value?e.value.kind:null},e.prototype.anchorValueKind=function(){if(this.valueKind()==w.Kind.ANCHOR_REF){var e=this._node.value;return e.value.kind}return null},e.prototype.valueKindName=function(){var e=this.valueKind();return void 0!=e?w.Kind[e]:null},e.prototype.kindName=function(){return w.Kind[this.kind()]},e.prototype.indent=function(e,t){void 0===t&&(t="");for(var n="",r=0;e>r;r++)n+="  ";return n+t},e.prototype.replaceNewlines=function(e,t){void 0===t&&(t=null);for(var n="",r=0;r<e.length;r++){var i=e[r];"\r"==i&&(i=null==t?"\\r":t),"\n"==i&&(i=null==t?"\\n":t),n+=i}return n},e.prototype.shortText=function(e,t){void 0===t&&(t=50);var n=this.end()-this.start(),r=n,i=this.unit();!e&&i&&(e=i.contents());var a;if(e){var o=e;a=o?o.substring(this.start(),this.end()):"[no-text]"}else a="[no-unit]";return a="["+this.start()+".."+this.end()+"] "+n+" // "+a+" //",n>r&&(a+="..."),a=this.replaceNewlines(a)},e.prototype.nodeShortText=function(e,t,n){void 0===n&&(n=50);var r=e.endPosition-e.startPosition,i=r,a=this.unit();!t&&a&&(t=a.contents());var o;if(t){var s=t;o=s?s.substring(e.startPosition,e.endPosition):"[no-text]"}else o="[no-unit]";return o="["+e.startPosition+".."+e.endPosition+"] "+r+" // "+o+" //",r>i&&(o+="..."),o=this.replaceNewlines(o)},e.prototype.show=function(e,t,n){void 0===e&&(e=null),void 0===t&&(t=0),void 0===n&&(n=null),e&&0==t&&console.log(e);var r=this.children(),i=this.kindName(),a=this._actualNode().value;this.kind()==w.Kind.MAPPING&&(i+="["+this._actualNode().key.value+"]"),i+=a?"/"+w.Kind[a.kind]:"",0==r.length?(console.log(this.indent(t)+i+" // "+this.shortText(n)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(t+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,n))):(console.log(this.indent(t)+i+" { // "+this.shortText(n)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(t+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,n)),r.forEach(function(e){var r=e;r.show(null,t+1,n)}),console.log(this.indent(t)+"}"))},e.prototype.showParents=function(e,t){void 0===t&&(t=0),e&&0==t&&console.log(e);var n=0;if(this.parent()){var r=this.parent();n=r.showParents(null,t+1)}var i=this.kindName(),a=this._actualNode().value;return i+=a?"/"+w.Kind[a.kind]:"/null",console.log(this.indent(n)+i+" // "+this.shortText(null)),n+1},e.prototype.inlined=function(e){return e==w.Kind.SCALAR||e==w.Kind.INCLUDE_REF},e.prototype.markupNode=function(e,t,n,r){void 0===r&&(r=!1);var i=e.text.length;switch(t.kind){case w.Kind.MAP:r&&e.append("{");for(var o=t.mappings,s=0;s<o.length;s++)r&&s>0&&e.append(", "),this.markupNode(e,o[s],n,r);r&&e.append("}");break;case w.Kind.SEQ:for(var u=t.items,s=0;s<u.length;s++)e.append(this.indent(n,"- ")),this.markupNode(e,u[s],n+1,r);break;case w.Kind.MAPPING:var l=t,p=l.value;if(r){if(!p){e.append("\n");break}if(e.append(l.key.value),e.append(": "),p.kind==w.Kind.SCALAR){var c=p;e.append(c.value)}else{if(p.kind!=w.Kind.MAP)throw new F("markup not implemented: "+w.Kind[p.kind]);this.markupNode(e,l.value,n+1,r)}break}if(e.addWithIndent(n,l.key.value+":"),!p){e.append("\n");break}if(p.kind==w.Kind.SCALAR)var c=p;l.value?(e.append(this.inlined(l.value.kind)?" ":"\n"),this.markupNode(e,l.value,n+1,r)):e.append("\n");break;case w.Kind.SCALAR:var c=t;if(I.isMultiLine(c.value)){e.append("|\n");for(var f=a(c.value),s=0;s<f.length;s++)e.append(this.indent(n,f[s]));e.append("\n")}else e.append(c.value+"\n");break;case w.Kind.INCLUDE_REF:var d=t;e.append("!include "+d.value+"\n");break;default:throw new F("Unknown node kind: "+w.Kind[t.kind])}for(;i<e.text.length&&" "==e.text[i];)i++;t.startPosition=i,t.endPosition=e.text.length},e.prototype.markup=function(e){void 0===e&&(e=!1);var t=new B("");return this.markupNode(t,this._actualNode(),0,e),t.text},e.prototype.root=function(){for(var e=this;e.parent();){var t=e.parent();e=t}return e},e.prototype.parentOfKind=function(e){for(var t=this.parent();t;){if(t.kind()==e)return t;t=t.parent()}return null},e.prototype.find=function(e){var t=null;return this.directChildren().forEach(function(n){n.key()&&n.key()==e&&(t||(t=n))}),t},e.prototype.shiftNodes=function(e,t,n){if(this.directChildren().forEach(function(r){if(n&&n.start()==r.start()&&n.end()==r.end());else{r.shiftNodes(e,t,n)}}),n&&n.start()==this.start()&&n.end()==this.end());else{var r=this._actualNode();r&&$(e,r,t)}return null},e.prototype.isMap=function(){return this.kind()==w.Kind.MAP},e.prototype.isMapping=function(){return this.kind()==w.Kind.MAPPING},e.prototype.isSeq=function(){return this.kind()==w.Kind.SEQ},e.prototype.isScalar=function(){return this.kind()==w.Kind.SCALAR},e.prototype.asMap=function(){if(!this.isMap())throw new F("map expected instead of "+this.kindName());return this._actualNode()},e.prototype.asMapping=function(){if(!this.isMapping())throw new F("maping expected instead of "+this.kindName());return this._actualNode()},e.prototype.asSeq=function(){if(!this.isSeq())throw new F("seq expected instead of "+this.kindName());return this._actualNode()},e.prototype.asScalar=function(){if(!this.isScalar())throw new F("scalar expected instead of "+this.kindName());return this._actualNode()},e.prototype.isValueSeq=function(){return this.valueKind()==w.Kind.SEQ},e.prototype.isValueMap=function(){return this.valueKind()==w.Kind.MAP},e.prototype.isValueInclude=function(){return this.valueKind()==w.Kind.INCLUDE_REF},e.prototype.isValueScalar=function(){return this.valueKind()==w.Kind.SCALAR},e.prototype.valueAsSeq=function(){if(!this.isMapping())throw new F("mapping expected instead of "+this.kindName());if(this.valueKind()!=w.Kind.SEQ)throw new F("mappng/seq expected instead of mapping/"+this.kindName());return this.asMapping().value},e.prototype.valueAsMap=function(){if(!this.isMapping())throw new F("mapping expected instead of "+this.kindName());if(this.valueKind()!=w.Kind.MAP)throw new F("mappng/map expected instead of mapping/"+this.kindName());return this.asMapping().value},e.prototype.valueAsScalar=function(){if(!this.isMapping())throw new F("mapping expected instead of "+this.kindName());if(this.valueKind()!=w.Kind.SCALAR)throw new F("mappng/scalar expected instead of mapping/"+this.kindName());return this.asMapping().value},e.prototype.valueAsInclude=function(){if(!this.isMapping())throw new F("mapping expected instead of "+this.kindName());if(this.valueKind()!=w.Kind.INCLUDE_REF)throw new F("mappng/include expected instead of mapping/"+this.kindName());return this.asMapping().value},e.prototype.text=function(e){if(void 0===e&&(e=null),!e){if(!this.unit())return"[no-text]";e=this.unit().contents()}return e.substring(this.start(),this.end())},e.prototype.copy=function(){var t=i(this._actualNode());return new e(t,this._unit,this._parent,this._anchor,this._include,this._includesContents)},e.prototype.nodeDefinition=function(){return A(this)},e.CLASS_IDENTIFIER="jsyaml2lowLevel.ASTNode",e}();t.ASTNode=z,function(e){e[e.NONE=0]="NONE",e[e.START=1]="START",e[e.END=2]="END",e[e.POINT=3]="POINT"}(t.InsertionPointType||(t.InsertionPointType={}));var J=t.InsertionPointType,Q=function(){function e(e,t){void 0===t&&(t=null),this.type=e,this.point=t}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&M.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.after=function(t){return new e(J.POINT,t)},e.atStart=function(){return new e(J.START)},e.atEnd=function(){return new e(J.END)},e.node=function(){return new e(J.NONE)},e.prototype.show=function(e){e?(console.log(e),console.log("  insertion point type: "+J[this.type])):console.log("insertion point type: "+J[this.type]),this.type==J.POINT&&this.point&&this.point.show()},e.CLASS_IDENTIFIER="jsyaml2lowLevel.InsertionPoint",e}();t.InsertionPoint=Q,t.createNode=p,t.createMap=c,t.createScalar=f,t.createSeq=d,t.createSeqNode=m,t.createMapNode=h,t.createMapping=y,t.toChildCachingNode=v,t.toIncludingNode=g,t.getDefinitionForLowLevelNode=A,t.fetchIncludesAndMasterAsync=E},function(e,t,n){"use strict";function r(){return Object.keys(d).length>0}function i(e){f.push(e)}function a(e){d[e]=!0}function o(e){delete d[e],f.forEach(function(t){return t(e)})}function s(e){return d[e]?!0:!1}function u(e,t){c.set(e,t)}function l(e){return c.get(e)}n(66);n(67),n(75);var p=n(76),c=p(50);t.hasAsyncRequests=r,t.addLoadCallback=i;var f=[],d={};t.addNotify=a,t.removeNotity=o,t.isWaitingFor=s,t.set=u,t.get=l},function(e,t,n){"use strict";function r(e){if(!e)return e;var t=e.indexOf("#");return-1==t?e:e.substring(0,t)}function i(e){if(!e)return null;"string"!=typeof e&&(e=""+e);var t=e.indexOf("#");if(-1==t)return null;var n=t==e.length-1?"":e.substring(t+1,e.length),i=n.split("/");return 0==i.length?null:(""==i[0].trim()&&i.splice(0,1),new m(n,r(e),i))}function a(){return[new h,new v]}function o(e,t){if(!e)return t;var n=i(e);if(!n)return t;var a=r(e);return s(a,n,t).content}function s(e,t,n){var r=c.find(a(),function(t){return t.isApplicable(e,n)});return r?r.resolveReference(n,t):{content:n,validation:[]}}function u(e,t,n){if(!n)return[];var r=c.find(a(),function(t){return t.isApplicable(e,n)});return r?r.completeReference(n,t):[]}function l(e,t){return e&&t?e.lastIndexOf(t)===e.length-t.length:!1}function p(e,t){for(var n=e.getElementsByTagName(t),r=[],i=0;i<n.length;i++){var a=n[i];a.parentNode===e&&r.push(a)}return r}var c=n(65),f=n(74).DOMParser,d=n(68);t.getIncludePath=r,t.getIncludeReference=i,t.getIncludeReferenceResolvers=a,t.resolveContents=o,t.resolve=s,t.completeReference=u;var m=function(){function e(e,t,n){this.includePath=t,this.segments=n,this.originalString=e}return e.prototype.getIncludePath=function(){return this.includePath},e.prototype.getFragments=function(){return this.segments},e.prototype.asString=function(){return this.originalString},e.prototype.encodedName=function(e){return void 0===e&&(e=!0),d(this.includePath+"/"+this.asString())+(e?this.includePath.substring(this.includePath.lastIndexOf(".")):"")},e}(),h=function(){function e(){}return e.prototype.isApplicable=function(e,t){return e&&(l(e.trim(),".js")||l(e.trim(),".json"))},e.prototype.resolveReference=function(e,t){try{var n={};return n.$ref=t.getIncludePath()+"#"+t.getFragments().map(function(e){return"/"+e}).join(""),{content:JSON.stringify(n,null,2),validation:[]}}catch(r){console.log(r)}return{content:e,validation:[]}},e.prototype.completeReference=function(e,t){try{var n=JSON.parse(e),r=t.getFragments();if(!r||0==r.length)return this.getChildren(n);for(var i=n,a=t.asString().lastIndexOf("/")==t.asString().length-1,o=(a?r.length:r.length-1,0);o<r.length-1;o++){var s=r[o];if(i=this.findChild(i,s),!i)return[]}if(a)return this.getChildren(i);var u=r[r.length-1],l=[];return this.getChildren(i).forEach(function(e){0==e.indexOf(u)&&l.push(e)}),l}catch(p){console.log(p)}return[]},e.prototype.findChild=function(e,t){var n=t.replace("~1","/");return n=t.replace("~0","~"),e[n]},e.prototype.getChildren=function(e){return Object.keys(e)},e}(),y={errorHandler:{warning:function(){return null},error:function(){return null},fatalError:function(){return null}}},v=function(){function e(){}return e.prototype.isApplicable=function(e,t){return e&&(l(e.trim(),".xml")||l(e.trim(),".xsd"))},e.prototype.resolveReference=function(e,t){try{var n=new f(y).parseFromString(e),r=t.asString(),i=t.encodedName(!1),a=p(n,"xs:schema")[0],o=p(a,"xs:element"),s=p(a,"xs:complexType"),u=c.find(o,function(e){return e.getAttribute("name")===r}),l=u?c.find(s,function(e){return e.getAttribute("name")===u.getAttribute("type")}):c.find(s,function(e){return e.getAttribute("name")===r}),d=n.createElement("xs:element");d.setAttribute("name",i),l&&d.setAttribute("type",l.getAttribute("name")),u&&d.setAttribute("originalname",u.getAttribute("name")),d.setAttribute("requestedname",r),d.setAttribute("extraelement","true"),a.appendChild(d);var m=n.toString(),h=m,v=m.indexOf("?>");if(v>0&&m.length>v+2){var g=m.charAt(v+2);"\n"!=g&&(h=m.slice(0,v+2)+"\n"+m.slice(v+2))}return{content:h,validation:[]}}catch(A){console.log(A)}return{content:e,validation:[]}},e.prototype.completeReference=function(e,t){try{var n=new f(y).parseFromString(e),r=[],i=p(n,"xs:schema")[0],a=p(i,"xs:element"),o=p(i,"xs:complexType");a.forEach(function(e){return r.push(e.getAttribute("name"))}),o.forEach(function(e){return r.push(e.getAttribute("name"))});var s=0===t.asString().trim().length;return s?r:r.filter(function(e){return 0===e.indexOf(t.asString())})}catch(u){return[]}},e}()},function(e,t,n){"use strict";function r(e){return e instanceof v.ApiImpl||e instanceof g.ApiImpl?(new M).expandTraitsAndResourceTypes(e):null}function i(e){return(new I).expandLibraries(e)}function a(e,t,n){var r=d.fromUnit(e);if(!r)throw new Error("couldn't load api from "+e.absolutePath());if(!t||0==t.length)return r;for(var i=[],a=0;a<t.length;a++){var s=t[a],u=d.fromUnit(s);if(!u)throw new Error("couldn't load api from "+s.absolutePath());i.push(u)}var l=o(r,i,n);return l}function o(e,t,n,r,i){void 0===r&&(r=null),void 0===i&&(i=!1);for(var a=e,o=0,s=t;o<s.length;o++){var u=s[o];i&&y.LowLevelProxyNode.isInstance(a.lowLevel())&&(a=(new M).expandHighLevelNode(a,r,e.wrapperNode()).highLevel()),u.overrideMaster(a),u.setMergeMode(n),a=u}return a}function s(e){for(var t=[],n=0,r=e;n<r.length;n++){var i=r[n];u(t,i,!0)}return t}function u(e,t,n){void 0===n&&(n=!1);var r=n?e:e.concat([]),i=t.lowLevel().unit();if(null==i)return r;if(0==r.length)r.push(i);else{var a=r[r.length-1].absolutePath();i.absolutePath()!=a&&r.push(i)}return r}function l(e){for(var t=[];e;)t.push(e),e=e.parent();return s(t)}function p(){return C.map(function(e){return e.name})}function c(e){for(var t=[],n=e.split("|").slice(1),r=0,i=n;r<i.length;r++)for(var a=i[r],o=0;o<C.length;o++)if(a.match(C[o].regexp)){t.push(C[o].transformer);break}return t}var f=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,
new n)},d=n(16),m=n(73),h=n(33),y=n(41),v=n(21),g=n(52),A=n(77),S=n(18),E=n(65),T=n(53),b=n(51),N=n(39),_=n(14),w=n(78);t.expandTraitsAndResourceTypes=r,t.expandLibraries=i,t.mergeAPIs=a;var M=function(){function e(){this.hasGlobalTraits=!1,this.hasGlobalResourceTypes=!1,this.namespaceResolver=new b.NamespaceResolver}return e.prototype.expandTraitsAndResourceTypes=function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1),this.init(e);var r=e.highLevel().lowLevel();if(!r)return e;if(r.actual().libExpanded)return e;var i=r.unit(),a=i.project().namespaceResolver().hasFragments(i),o=this.namespaceResolver.hasTemplates(r.unit());if(!o&&!a&&!n)return e;var s=this.createHighLevelNode(e.highLevel(),!1,t);if(e.definition().key()==S.Universe10.Overlay)return s.wrapperNode();var u=this.expandHighLevelNode(s,t,e);return u},e.prototype.init=function(e){var t=e.highLevel();this.ramlVersion=t.definition().universe().version()},e.prototype.expandHighLevelNode=function(e,t,n){var r=this;this.init(n);var i=e.wrapperNode();i.setAttributeDefaults(n.getDefaultsCalculator().isEnabled()),i.highLevel().setMergeMode(n.highLevel().getMergeMode());var a=i.resources();return a.forEach(function(e){return r.processResource(e)}),"RAML10"==this.ramlVersion&&(t=t||new T.ReferencePatcher,t.process(e),e.lowLevel().actual().referencePatcher=t),i},e.prototype.getTemplate=function(e,t,n,r){var i=t.lowLevel().unit().path(),a=n[i];a||(a={},n[i]=a);var o=a[e];return void 0!==o?o:(o=null,o=E.find(r,function(n){return d.qName(n.highLevel(),t)==e}),o||(o=null),a[e]=o,o)},e.prototype.createHighLevelNode=function(e,t,n,r){void 0===t&&(t=!0),void 0===n&&(n=null),void 0===r&&(r=!1);for(var i=e,a=[],s=i;s;){var u,l=s.lowLevel();i.definition().key()!=S.Universe10.Overlay||r?(y.LowLevelCompositeNode.isInstance(l)&&(l=l.originalNode().originalNode()),u=new y.LowLevelCompositeNode(l,null,null,this.ramlVersion)):u=l;var p=s.definition(),c=new d.ASTNodeImpl(u,null,p,null);if(c.setUniverse(s.universe()),a.push(c),!t)break;s=s.getMaster()}var f=a.pop();a=a.reverse();var m=i.getMergeMode();return o(f,a,m,n,r)},e.prototype.processResource=function(e,t){var n=this;void 0===t&&(t=[]);var r=t.concat(e.highLevel()),i=this.collectResourceData(e,e,void 0,void 0,r),a=e.highLevel().lowLevel();a.preserveAnnotations(),a.takeOnlyOriginalChildrenWithKey(N.universesInfo.Universe10.ResourceBase.properties.type.name),a.takeOnlyOriginalChildrenWithKey(N.universesInfo.Universe10.FragmentDeclaration.properties.uses.name),i.filter(function(e){return null!=e.resourceType}).forEach(function(t){var n=t.resourceType.node.highLevel().lowLevel(),r=t.resourceType.transformer;r.owner=e,a.adopt(n,r)});var o=e.methods();o.forEach(function(e){var t=e.highLevel().lowLevel();y.LowLevelCompositeNode.isInstance(t)&&t.takeOnlyOriginalChildrenWithKey(N.universesInfo.Universe10.FragmentDeclaration.properties.uses.name);var n=e.method(),r=[];i.forEach(function(i){var a=i.methodTraits[n];a&&(r=r.concat(a),a.forEach(function(n){var r=n.node.highLevel().lowLevel(),i=n.transformer;i.owner=e,t.adopt(r,i)}));var o=i.traits;o&&(r=r.concat(o),o.forEach(function(n){var r=n.node.highLevel().lowLevel(),i=n.transformer;i.owner=e,t.adopt(r,i)}))})});var s=e.resources();s.forEach(function(e){return n.processResource(e,r)})},e.prototype.collectResourceData=function(e,t,n,r,i,a){var o=this;void 0===n&&(n=[]),void 0===i&&(i=[]),void 0===a&&(a={}),i=i.concat([t.highLevel()]);var u=this.extractTraits(t,r,i),l={},p=t.methods();p.forEach(function(e){var t=o.extractTraits(e,r,i);t&&t.length>0&&(l[e.method()]=t)});var c,f=t.type();if(null!=f){var m=s(i);c=this.readGenerictData(e,f,t.highLevel(),"resource type",r,m)}var h={resourceType:c,traits:u,methodTraits:l};if(n.push(h),c){var y=c.node,v=d.qName(y.highLevel(),e.highLevel());a[v]?h.resourceType=null:(a[v]=!0,this.collectResourceData(e,y,n,c.transformer,i,a))}return n},e.prototype.extractTraits=function(e,t,n,r){var i=this;void 0===r&&(r={}),n=n.concat([e.highLevel()]);for(var a=[],o=-1;o<a.length;o++){var l=0>o?null:a[o],p=l?l.node:e,c=l?l.unitsChain:s(n),f=l?l.transformer:t;p.is&&p.is().forEach(function(t){var n=u(c,t.highLevel()),o=i.readGenerictData(e,t,p.highLevel(),"trait",f,n);if(o){var s=o.name;r[s]=!0,a.push(o)}})}return a},e.prototype.readGenerictData=function(e,t,n,r,i,a){void 0===a&&(a=[]);var o=t.value(),s=A.plural(w.camelCase(r));if("string"==typeof o){i&&(o=i.transform(o).value);var u=T.getDeclaration(o,s,this.namespaceResolver,a);if(u){var l=u.wrapperNode();return{name:o,transformer:null,parentTransformer:i,node:l,ref:t,unitsChain:a}}}else if(d.StructuredValue.isInstance(o)){var p=o,c=p.valueName();i&&(c=i.transform(c).value);var f={},h={},u=T.getDeclaration(c,s,this.namespaceResolver,a);if(u){var l=u.wrapperNode();"RAML08"==this.ramlVersion?p.children().forEach(function(e){return f[e.valueName()]=e.lowLevel().value()}):p.children().forEach(function(e){var t=e.lowLevel();t.valueKind()==m.Kind.SCALAR?f[e.valueName()]=t.value():t.valueKind()==m.Kind.INCLUDE_REF&&0==t.children().length?f[e.valueName()]=t.value():h[e.valueName()]=t});var y=new O(e,null,a);Object.keys(f).forEach(function(e){var t=y.transform(f[e]);t&&"object"!=typeof t&&(f[e]=t)});var v=new P(r,c,a,f,h,i),g=new O(null,v,a);return{name:c,transformer:g,parentTransformer:i,node:l,ref:t,unitsChain:a}}}return null},e}();t.TraitsAndResourceTypesExpander=M;var I=function(){function e(){}return e.prototype.expandLibraries=function(e){var t=e;if(null==t)return null;y.LowLevelCompositeNode.isInstance(t.highLevel().lowLevel())&&(t=t.highLevel().lowLevel().unit().highLevel().asElement().wrapperNode());var n=new M,r=new T.ReferencePatcher,i=n.createHighLevelNode(t.highLevel(),!0,r,!0),a=n.expandHighLevelNode(i,r,t);return this.processNode(r,a.highLevel()),a},e.prototype.processNode=function(e,t){if(null!=t){var n=t.getMaster();this.processNode(e,n),_.isOverlayType(t.definition())&&e.process(t),e.expandLibraries(t)}},e}();t.LibraryExpander=I,t.toUnits=l;var R=function(){function e(t,n){this.name=t,this.regexp=new RegExp(e.leftTransformRegexp.source+t+e.rightTransformRegexp.source),this.transformer=n}return e.leftTransformRegexp=/\s*!\s*/,e.rightTransformRegexp=/\s*$/,e}(),C=[new R("singularize",function(e){return A.singular(e)}),new R("pluralize",function(e){return A.plural(e)}),new R("uppercase",function(e){return e?e.toUpperCase():e}),new R("lowercase",function(e){return e?e.toLowerCase():e}),new R("lowercamelcase",function(e){return e?w.camelCase(e):e}),new R("uppercamelcase",function(e){if(!e)return e;var t=w.camelCase(e);return t[0].toUpperCase()+t.substring(1,t.length)}),new R("lowerunderscorecase",function(e){if(!e)return e;var t=w.snake(e);return t.toLowerCase()}),new R("upperunderscorecase",function(e){if(!e)return e;var t=w.snake(e);return t.toUpperCase()}),new R("lowerhyphencase",function(e){if(!e)return e;var t=w.param(e);return t.toLowerCase()}),new R("upperhyphencase",function(e){if(!e)return e;var t=w.param(e);return t.toUpperCase()})];t.getTransformNames=p,t.getTransformersForOccurence=c;var L=function(){function e(){this.buf=null}return e.prototype.append=function(e){""!==e&&(null!=this.buf?null!=e&&("string"!=typeof this.buf&&(this.buf=""+this.buf),this.buf+=e):""!==e&&(this.buf=e))},e.prototype.value=function(){return null!=this.buf?this.buf:""},e}(),P=function(){function e(e,t,n,r,i,a){this.templateKind=e,this.templateName=t,this.unitsChain=n,this.params=r,this.structuredParams=i,this.vDelegate=a}return e.prototype.transform=function(e,t,n,r){var i={},a=[];if("string"==typeof e){if(this.structuredParams&&h.stringStartsWith(e,"<<")&&h.stringEndsWith(e,">>")){var o=e.substring(2,e.length-2),s=this.structuredParams[o];if(null!=s)return{value:s,errors:a}}for(var u=e,l=new L,p=0,f=u.indexOf("<<");f>=0;f=u.indexOf("<<",p)){l.append(u.substring(p,f));var d=f;if(f+="<<".length,p=this.paramUpperBound(u,f),-1==p)break;var m=u.substring(f,p);p+=">>".length;var y,o,v=u.substring(d,p),g=c(m);if(g.length>0){var A=m.indexOf("|");if(o=m.substring(0,A).trim(),y=this.params[o],y&&"string"==typeof y&&y.indexOf("<<")>=0&&this.vDelegate&&(y=this.vDelegate.transform(y,t,n,r).value),y){T.PatchedReference.isInstance(y)&&(y=y.value());for(var S=0,E=g;S<E.length;S++){var b=E[S];y=b(y)}}}else o=m.trim(),y=this.params[o],y&&"string"==typeof y&&y.indexOf("<<")>=0&&this.vDelegate&&(y=this.vDelegate.transform(y,t,n,r).value);(null===y||void 0===y)&&(i[o]=!0,y=v),l.append(y)}return l.append(u.substring(p,u.length)),{value:l.value(),errors:a}}return{value:e,errors:a}},e.prototype.paramUpperBound=function(e,t){for(var n=0,r=t;r<e.length;r++)if(h.stringStartsWith(e,"<<",r))n++,r++;else if(h.stringStartsWith(e,">>",r)){if(0==n)return r;n--,r++}return e.length},e.prototype.children=function(e){var t=this.substitutionNode(e);return t?t.children():null},e.prototype.valueKind=function(e){var t=this.substitutionNode(e);return t?t.valueKind():null},e.prototype.includePath=function(e){var t=this.substitutionNode(e);return t?t.includePath():null},e.prototype.substitutionNode=function(e){var t=this.paramName(e);return t&&this.structuredParams[t]},e.prototype.paramName=function(e){var t=null;if(e.valueKind()==m.Kind.SCALAR){var n=(""+e.value()).trim();h.stringStartsWith(n,"<<")&&h.stringEndsWith(n,">>")&&(t=n.substring(2,n.length-2))}return t},e}();t.ValueTransformer=P;var O=function(e){function t(t,n,r){e.call(this,null!=n?n.templateKind:"",null!=n?n.templateName:"",r),this.owner=t,this.delegate=n}return f(t,e),t.prototype.transform=function(t,n,r,i){if(null==t||null!=r&&!r())return{value:t,errors:[]};var a={value:t,errors:[]},o=!1;D.forEach(function(e){return o=o||t.toString().indexOf("<<"+e)>=0}),o&&(this.initParams(),a=e.prototype.transform.call(this,t,n,r,i));var s=null!=this.delegate?this.delegate.transform(a.value,n,r,i):a.value;return null!=r&&r()&&null!=i&&(s.value=i(s.value,this)),s},t.prototype.initParams=function(){for(var e,t,n="",r=this.owner.highLevel().lowLevel(),i=r,a=null;i;){var o=i.key();if(null!=o)if(h.stringStartsWith(o,"/")){if(!t)for(var s=o.split("/"),u=s.length-1;u>=0;u--){var l=s[u];if(-1==l.indexOf("{")){t=s[u];break}l.length>0&&(a=l)}n=o+n}else e=o;i=i.parent()}t||a&&(t=""),this.params={resourcePath:n,resourcePathName:t},e&&(this.params.methodName=e)},t.prototype.children=function(e){return null!=this.delegate?this.delegate.children(e):null},t.prototype.valueKind=function(e){return null!=this.delegate?this.delegate.valueKind(e):null},t.prototype.includePath=function(e){return null!=this.delegate?this.delegate.includePath(e):null},t}(P);t.DefaultTransformer=O;var D=["resourcePath","resourcePathName","methodName"]},function(e,t,n){(function(e){"use strict";function r(e,t,n){return new xe.Function(e).call(t,n)}function i(e,t){var n=e.property();return n&&n.getContextRequirements().forEach(function(r){e.checkContextValue(r.name,r.value,r.value)||t.accept(J(Pe.CONTEXT_REQUIREMENT,{name:r.name,value:r.value,propName:n.nameId()},e))}),n}function a(e,t){var n;try{n=e.lowLevel().unit().project().fsEnabled()}catch(r){n=!0}if(n&&"undefined"!=typeof he&&he){for(var i=["exists","readFile","writeFile","readdir","existsSync","readFileSync","writeFileSync","readdirSync"],a=(Object.keys(he),0);a<i.length;a++)if(!he[i[a]])return;var o=e.lowLevel().unit().absolutePath(),s=me.dirname(o),u=me.resolve(s,"raml-lint.js");Ue(u,t,e);var l=me.resolve(s,".raml");if(he.existsSync(l)){var p=he.statSync(l);if(p.isDirectory()){var c=he.readdirSync(l);c.forEach(function(n){-1!=n.indexOf("-lint.js")&&Ue(me.resolve(l,n),t,e)})}}}}function o(e){return e.nameId()==ye.Universe10.TypeDeclaration.properties.type.name||e.nameId()==ye.Universe10.TypeDeclaration.properties.schema.name}function s(e){return l(e)?e.nameId()==ye.Universe10.TypeDeclaration.properties["default"].name:!1}function u(e){return l(e)?e.nameId()==ye.Universe10.TypeDeclaration.properties.example.name:!1}function l(e){return e.domain()?e.domain().getAdapter(Ae.RAMLService).isUserDefined()?!1:!0:!1}function p(e){return l(e)?e.nameId()==ye.Universe08.MethodBase.properties.securedBy.name:!1}function c(e){for(var t=e;;){if(t.definition().getAdapter(Ae.RAMLService).isInlinedTemplates())return t.definition().nameId();var n=t.parent();if(!n)break;t=n}return null}function f(e){var n=e.parent(),r=null,i=n.definition();if(n&&fe.UserDefinedClass.isInstance(i)){var a=n.property();if(ve.isIsProperty(a)||ve.isTypeProperty(a)){var o=e.name();r=null!=t.RESERVED_TEMPLATE_PARAMETERS[o]?J(Pe.INVALID_PARAMETER_NAME,{paramName:o},e):J(Pe.UNUSED_PARAMETER,{paramName:o},e)}}if(!r){var s=e.name(),u=ge("RAML08"),l=i.universe().version()==u.version();if(l){var p=ye.Universe08.Parameter.name;ye.Universe10.TypeDeclaration.name;if(l&&i.isAssignableFrom(p)){for(var c=u.type(p).allSubTypes().filter(function(e){return null!=ye.Universe08[e.nameId()].properties[s]}),f={},d=0;d<c.length;d++){var m=c[d];if(!f[m.nameId()]){var h=m.valueRequirements();if(h&&0!=h.length){var y=h.filter(function(e){return"type"==e.name}).map(function(e){return e.value});if(0!=y.length){var v=y[0];f[m.nameId()]=v,m.allSubTypes().forEach(function(e){return c.push(e)})}}}}var g=Object.keys(f).map(function(e){return f[e]}).sort();if(g.length>0){var A=g.map(function(e,t){var n="'"+e+"'";return t==g.length-1?n:t==g.length-2?n+" or ":n+", "}).join("");r=J(Pe.INVALID_PROPERTY_OWNER_TYPE,{propName:s,namesStr:A},e)}}}}return r}function d(e,t){if(e.isElement()){if(e.invalidSequence){var n=e.property().nameId();n=Ce.sentenceCase(Le.singular(n)),t.acceptUnique(Z(Pe.SEQUENCE_NOT_ALLOWED_10,{propName:n},e.lowLevel().parent().parent(),e))}var r=e.asElement();if(r.definition().isAssignableFrom(ye.Universe10.LibraryBase.name)){var i,a=!1,o=!1;r.lowLevel().children().forEach(function(e){"schemas"==e.key()&&(a=!0,i=e),"types"==e.key()&&(o=!0)}),a&&o&&t.accept(ht(i,r,ue.IssueCode.ILLEGAL_PROPERTY_VALUE,!1,"types and schemas are mutually exclusive",!1))}r.definition().requiredProperties()&&r.definition().requiredProperties().length>0;m(e,t),(new tt).validate(r,t),(new dt).validate(r,t)}else m(e,t);(new ct).validate(e,t)}function m(e,t,n){void 0===n&&(n=!1);var r=e.parent(),i=e.lowLevel().value();if(e.lowLevel()){if(e.lowLevel().keyKind()==ce.Kind.MAP&&t.accept(J(Pe.NODE_KEY_IS_A_MAP,{},e)),e.lowLevel().keyKind()==ce.Kind.SEQ&&null==i){var a=!1;e.isElement()&&e.asElement().definition().isAssignableFrom(ye.Universe10.TypeDeclaration.name)&&(a=!0),a||t.accept(J(Pe.NODE_KEY_IS_A_SEQUENCE,{},e))}if(null==r){var o=e.lowLevel().unit().contents().length;e.lowLevel().errors().forEach(function(n){var r=n.mark?n.mark.position:0,i={code:"YAML_ERROR",message:n.message,node:null,start:r,end:r>=o?r:r+1,isWarning:!1,path:e.lowLevel().unit()==e.root().lowLevel().unit()?null:e.lowLevel().unit().path(),unit:e.lowLevel().unit()};t.accept(i)})}}if(e.isUnknown()){if(-1!=e.name().indexOf("<<")&&null!=c(r))return(new Ve).validateName(e,t),!1;if(e.needSequence&&t.accept(J(Pe.SEQUENCE_REQUIRED,{name:e.name()},e)),e.needMap)return e.knownProperty?t.accept(J(Pe.PROPERTY_MUST_BE_A_MAP_10,{propName:e.knownProperty.nameId()},e)):t.accept(J(Pe.MAP_REQUIRED,{},e)),!1;if(e.unresolvedRef&&t.accept(J(Pe.UNRESOLVED_REFERENCE,{ref:i},e)),e.knownProperty){if(0==e.lowLevel().includeErrors().length){if(c(r)&&Ne.startsWith(i,"<<")&&Ne.endsWith(i,">>"))return!1;if("body"==e.name()&&e.computedValue("mediaType"))return!1;"~"!=e.lowLevel().value()&&t.accept(J(Pe.SCALAR_PROHIBITED,{propName:e.name()},e))}}else{var s=f(e);s||(s=J(Pe.UNKNOWN_NODE,{name:e.name()},e)),t.accept(s)}}if(e.markCh()&&!e.allowRecursive())return e.property()?(t.accept(J(Pe.RECURSIVE_DEFINITION,{name:e.name()},e)),!1):!1;if(e.definition&&e.definition().isAssignableFrom(ye.Universe10.Operation.name)){var u=y(e.wrapperNode()),l=u.queryStringComesFrom,p=u.queryParamsComesFrom;l&&p&&(t.accept(h(l,e,!1)),t.accept(h(p,e,!0)))}var d=e.definition&&e.definition()&&(e.definition().key()===ye.Universe10.Overlay||e.definition().key()===ye.Universe10.Extension);return d&&T(e,t,n),!0}function h(e,t,n){var r=e,i=e,a=n?ye.Universe10.Operation.properties.queryString.name:ye.Universe10.Operation.properties.queryParameters.name;return r.unit?Z(Pe.PROPERTY_ALREADY_SPECIFIED,{propName:a},r,t):J(Pe.PROPERTY_ALREADY_SPECIFIED,{propName:a},i)}function y(e){return{queryParamsComesFrom:v(e,!0),queryStringComesFrom:v(e,!1)}}function v(e,t){if(!e)return null;var n=A(e,t);if(n)return n;var r=e.is&&e.is()||[],i=pe.find(r,function(e){return v(e.trait(),t)});if(i)return i.highLevel();var a=e.parentResource&&e.parentResource(),o=a&&g(a,t);return o?o:(a=e.parent&&e.parent(),a&&a.highLevel().definition().isAssignableFrom(ye.Universe10.ResourceBase.name)?g(a,t):null)}function g(e,t){var n=e.is(),r=pe.find(n,function(e){return v(e.trait(),t)});if(r)return r.highLevel();var i=e.type(),a=i&&i.resourceType(),o=a&&g(a,t);return o?i.highLevel():void 0}function A(e,t){return t?S(e):E(e)}function S(e){var t=e.highLevel();return t.lowLevel&&pe.find(t.lowLevel().children(),function(e){return e.key&&e.key()===ye.Universe10.Operation.properties.queryParameters.name})}function E(e){var t=e.highLevel(),n=t.element(ye.Universe10.Operation.properties.queryString.name);return n}function T(e,t,n){if(void 0===n&&(n=!1),!e.parent()){var r=e.asElement();if(r&&r.isAuxilary()){var i=r.getMaster();i&&d(i,t)}}}function b(e,t,n){if(void 0===n&&(n=!1),m(e,t,n))try{var r=e.definition&&e.definition()&&(e.definition().key()===ye.Universe10.Overlay||e.definition().key()===ye.Universe10.Extension),i=r?e.children():e.directChildren();i.filter(function(e){return!n||e.property&&e.property()&&e.property().isRequired()}).forEach(function(n){if(n&&n.errorMessage){var r=n.errorMessage;return void t.accept(J(r.entry,r.parameters,n.name()?n:e))}n.validate(t)})}finally{e.unmarkCh()}}function N(e){var t=e.value();if("string"==typeof t&&-1!=t.indexOf("<<"))return!0;for(var n=e.children(),r=0;r<n.length;r++)if(N(n[r]))return!0;return!1}function _(e,t){if(!e.parent())try{M(e,t)}finally{w(e,t)}if(e.isAttr())(new We).validate(e,t);else if(e.isElement()){if(e.invalidSequence){var n=e.property().nameId(),r=Ce.sentenceCase(Le.singular(n));t.acceptUnique(Z(Pe.SEQUENCE_NOT_ALLOWED_10,{propName:r},e.lowLevel().parent().parent(),e,!1))}var i=e.asElement();if(ve.isExampleSpecType(i.definition())){var a=i.children();if(0==a.length)return void b(e,t,!0);var o=a.filter(function(e){var t=e.lowLevel().key();return t?"("==t.charAt(0)&&")"==t.charAt(t.length-1)?!1:null==i.definition().property(t):!0});if(o.length>0)return void b(e,t,!0)}if(i.definition().isAnnotationType()||i.property()&&"annotations"==i.property().nameId())return void(new Ze).validate(i,t);if(i.definition().isAssignableFrom(ye.Universe10.UsesDeclaration.name)){var s=i.attr(ye.Universe10.UsesDeclaration.properties.value.name);if(s&&s.value()){var u=i.lowLevel().unit().resolve(s.value());if(u&&null!==u.contents()){if(!we.isWaitingFor(s.value())){var l=[];if(0===u.contents().trim().length)return void t.accept(J(Pe.EMPTY_FILE,{path:s.value()},i,!1));if(u.highLevel().validate(de.createBasicValidationAcceptor(l,u.highLevel())),l.length>0){var p=Fe(s,i);l.forEach(function(e){e.unit=null==e.unit?u:e.unit,e.path||(e.path=u.absolutePath())});for(var f=0,d=l;f<d.length;f++){for(var m=d[f],h=m;h.extras&&h.extras.length>0;)h=h.extras[0];h!=p&&(h.extras||(h.extras=[]),h.extras.push(p)),t.accept(m)}}}}else t.accept(J(Pe.INVALID_LIBRARY_PATH,{path:s.value()},i,!1))}}if(i.definition().isAssignableFrom(ye.Universe10.TypeDeclaration.name)){if(c(i)&&N(i.lowLevel()))return;return i.attrs().forEach(function(n){var r=n.property().range().key();if(r==ye.Universe08.RelativeUriString||r==ye.Universe10.RelativeUriString)return void(new He).validate(n,t);if(r==ye.Universe08.FullUriTemplateString||r==ye.Universe10.FullUriTemplateString)return void(new He).validate(n,t);if(n.property().getAdapter(Ae.RAMLPropertyService).isKey()){var a=e.property()&&e.property().nameId();if(a==ye.Universe08.Resource.properties.uriParameters.name||a==ye.Universe08.Resource.properties.baseUriParameters.name)return;if(i.property()&&i.property().nameId()==ye.Universe10.MethodBase.properties.body.name)return void(new $e).validate(n,t)}}),(new ot).validate(i,t),(new st).validate(i,t),(new it).validate(i,t),void(new et).validate(i,t)}if(i.definition().isAssignableFrom(ye.Universe10.LibraryBase.name)){var y,v=!1,g=!1;i.lowLevel().children().forEach(function(e){"schemas"==e.key()&&(v=!0,y=e),"types"==e.key()&&(g=!0)}),v&&g&&t.accept(Z(Pe.TYPES_AND_SCHEMAS_ARE_EXCLUSIVE,{},y,i))}var A=i.definition().requiredProperties()&&i.definition().requiredProperties().length>0,S=i.definition().getAdapter(Ae.RAMLService).getAllowAny();S?A&&b(e,t,!0):b(e,t),(new ft).validate(i,t),(new tt).validate(i,t),(new dt).validate(i,t)}else b(e,t);(new ct).validate(e,t)}function w(e,t){if(e.lowLevel()){var n=e.lowLevel().actual();delete n._inc,e.children().forEach(function(e){return w(e,t)})}}function M(e,t){var n=e.lowLevel();if(n){var r=n.actual();if(!r._inc){if(e.isElement()){var i=e.name();"string"==typeof i&&null!=i&&-1!=i.indexOf(" ")&&t.accept(J(Pe.SPACES_IN_KEY,{value:i},e,!0))}if(r._inc=!0,n){n.includeErrors().forEach(function(n){var r=!1;e.lowLevel().hasInnerIncludeError()&&(r=!0);var i=J(Pe.INCLUDE_ERROR,{msg:n},e,r);t.accept(i)});var a=n.includePath();if(null!=a&&!me.isAbsolute(a)&&!le.isWebPath(a)){var o=n.unit().absolutePath(),s=R(me.dirname(o),a);if(s>0){var u=J(Pe.PATH_EXCEEDS_ROOT,{},e,!0);t.accept(u)}}}e.children().forEach(function(e){return M(e,t)}),0==e.children().length&&null!=n&&n.children().forEach(function(n){return I(n,t,e)})}}}function I(e,t,n){e.includeErrors().forEach(function(r){var i=!1;e.hasInnerIncludeError()&&(i=!0);var a=Z(Pe.INCLUDE_ERROR,{msg:r},e,n,i);t.accept(a)});var r=e.includePath();if(null!=r&&!me.isAbsolute(r)&&!le.isWebPath(r)){var i=e.unit().absolutePath(),a=R(me.dirname(i),r);if(a>0){var o=Z(Pe.PATH_EXCEEDS_ROOT,{},e,n,!0);t.accept(o)}}e.children().forEach(function(e){return I(e,t,n)})}function R(e,t){for(var n=Be(e),r=Be(t),i=n.length,a=0,o=0,s=r;o<s.length;o++){var u=s[o];".."==u?(i--,0>i&&(a=Math.min(i,a))):i++}return-1*a}function C(e,t,n,r,i){return e.hasArrayInHierarchy()?L(e,t,n,r,i):e.hasValueTypeInHierarchy()?P(e,t,n,r,i):!0}function L(e,t,n,r,i){return e.arrayInHierarchy().componentType()?C(e.arrayInHierarchy().componentType(),t,n,r):!0}function P(e,t,n,r,i){try{if(e.key()==ye.Universe10.AnnotationRef){var a=Te.referenceTargets(r,t),o=pe.find(a,function(e){return de.qName(e,t)==n});if(null!=o){var s=o.attributes("allowedTargets");if(s){var u=s.map(function(e){return e.value()});if(u.length>0){var l=!1,p=t.definition().allSuperTypes();p=p.concat([t.definition()]);var c=p.map(function(e){return e.nameId()});if(u.forEach(function(e){"API"==e&&(e="Api"),"NamedExample"==e&&(e="ExampleSpec"),"SecurityScheme"==e&&(e="AbstractSecurityScheme"),"SecuritySchemeSettings"==e&&(e="SecuritySchemeSettings"),pe.find(c,function(t){return t==e})?l=!0:("Parameter"==e&&t.computedValue("location")&&(l=!0),"Field"==e&&t.computedValue("field")&&(l=!0))}),!l){var f=u.map(function(e){return"'"+e+"'"}).join(", ");return new qe(Pe.INVALID_ANNOTATION_LOCATION,{aName:n,aValues:f})}}}}return v}if(e.key()==ye.Universe08.SchemaString||e.key()==ye.Universe10.SchemaString){var d=!1;if(fe.UserDefinedProp.isInstance(r)){var m=r,h=m.node();if(h){var y=h.property();y&&(d=ve.isTypeProperty(y)||ve.isSchemaProperty(y))}}if(d)return!1;var v=Me.createSchema(n,Y(t.lowLevel(),i&&i.lowLevel()));if(!v)return v;if(v instanceof Error)v.canBeRef=!0;else{var g=!1;try{JSON.parse(n),g=!0}catch(A){}if(g)try{v.validateSelf()}catch(A){return A.isWarning=!0,A}}return v}if(e.key()==ye.Universe08.StatusCodeString||e.key()==ye.Universe10.StatusCodeString){var S=te(n);if(null!=S)return S}if(e.key()==ye.Universe08.BooleanType||e.isAssignableFrom(ye.Universe10.BooleanType.name)){if("true"!==n&&"false"!==n&&n!==!0&&n!==!1)return new qe(Pe.BOOLEAN_EXPECTED);if(i){var E=i.lowLevel().value(!0);if("true"!==E&&"false"!==E)return new qe(Pe.BOOLEAN_EXPECTED)}}if(e.key()==ye.Universe08.NumberType||e.isAssignableFrom(ye.Universe10.NumberType.name)){var T=parseFloat(n);if(isNaN(T))return new qe(Pe.NUMBER_EXPECTED,{propName:r.nameId()})}if((e.key()==ye.Universe08.StringType||e.isAssignableFrom(ye.Universe10.StringType.name))&&null===n&&t&&r){var b=t.attr(r.nameId());if(b){var N=b.lowLevel().children();if(N&&N.length>0)return new qe(Pe.STRING_EXPECTED_3,{propName:r.nameId()})}}return!0}catch(A){return A.canBeRef=!0,A}}function O(e){if(!e)return!1;var t=e.toLowerCase(),n=e.toUpperCase();return e!==t&&e!==n?!0:!1}function D(e){if(!e)return null;if(e.isElement()){var n=e,r=n.definition();if(r&&t.typeToName.hasOwnProperty(r.nameId()))return t.typeToName[r.nameId()];if(r.isAssignableFrom(ye.Universe10.TypeDeclaration.name)||r.isAssignableFrom(ye.Universe08.Parameter.name)){if(n.property()&&t.parameterPropertyToName.hasOwnProperty(n.property().nameId()))return t.parameterPropertyToName[n.property().nameId()];if(n.property()&&n.parent()&&n.property().nameId()==ye.Universe10.LibraryBase.properties.types.name&&n.parent().definition()&&n.parent().definition().isAssignableFrom(ye.Universe10.LibraryBase.name))return"type";if(n.property()&&n.parent()&&n.property().nameId()==ye.Universe10.LibraryBase.properties.securitySchemes.name&&n.parent().definition()&&n.parent().definition().isAssignableFrom(ye.Universe10.LibraryBase.name))return"security scheme"}}return null}function x(e,t,n){var r=Te.declRoot(n);r._cach||(r._cach={});var i=e.id();if(e.domain()&&(i+=e.domain().nameId()),i){var a=r._cach[i];if(a)return null!=a[t]}var o=Te.enumValues(e,n),s={};return o.forEach(function(e){return s[e]=1}),e.id()&&(r._cach[i]=s),null!=s[t]}function U(e,n,r,i){if(F(e,n,i),B(e,n,i),r&&("null"!=r||!e.isAllowNull())){var a=e.getAdapter(Ae.RAMLPropertyService),o=x(e,r,n.parent());if(o||n.lowLevel().unit().absolutePath()===n.parent().lowLevel().unit().absolutePath()||(o=x(e,r,de.fromUnit(n.lowLevel().unit()))),!o){if("string"==typeof r&&0==r.indexOf("x-")&&e.nameId()==ye.Universe10.TypeDeclaration.properties.type.name)return!0;var s=a.isReference&&a.isReference()&&a.referencesTo&&a.referencesTo()&&a.referencesTo().nameId&&a.referencesTo().nameId(),u=t.typeToName[s]||V(n),l={referencedToName:u,ref:r},p=u?Pe.UNRECOGNIZED_ELEMENT:Pe.UNRESOLVED_REFERENCE,c=K(p,e,n);return i.accept(J(c,l,n,e.range().key()===ye.Universe08.SchemaString)),!0}return k(n)&&ve.isTraitRefType(n.definition())?(i.accept(J(Pe.DUPLICATE_TRAIT_REFERENCE,{refValue:r},n)),!0):!1}}function k(e){var t,n=e.property().domain().universe().version();if(t="RAML10"==n?oe(ae.serialize(e.lowLevel())):e.value()&&e.value().valueName&&e.value().valueName(),!t)return!1;var r=e.parent&&e.parent();if(!r)return!1;var i=e.name&&e.name();if(!i)return!1;var a=r.attributes&&r.attributes(i);if(!a)return!1;if(0===a.length)return!1;var o=0;return a.forEach(function(e){var r;"RAML10"==n?t=oe(ae.serialize(e.lowLevel())):r=e.value&&e.value()&&e.value().valueName&&e.value().valueName(),r===t&&o++}),o>1}function F(e,t,n){if(ve.isIsProperty(e)){var r=t.lowLevel();if(null!=r){var i=null,a=r.parent(),o=null!=a?a.parent():null;if(r.kind()==ce.Kind.MAPPING&&r.key()&&"is"==r.key()?i=r:null!=a&&a.kind()==ce.Kind.MAPPING&&a.key()&&"is"==a.key()?i=a:null!=o&&o.kind()==ce.Kind.MAPPING&&o.key()&&"is"==o.key()&&(i=o),null!=i){null==i.value()||i.children()&&0!=i.children().length||n.accept(J(Pe.IS_IS_ARRAY,{},t));var s=!1;i.children().forEach(function(e){e.kind()!=ce.Kind.SCALAR&&e.kind()!=ce.Kind.MAP&&(s=!0)}),s&&n.accept(J(Pe.IS_IS_ARRAY,{},t))}}}}function B(e,t,n){if(ve.isTypeProperty(e)&&ve.isResourceTypeRefType(t.definition())){var r=t.lowLevel();null==t.value()&&r&&r.children()&&0==r.children().length?r.kind()==ce.Kind.MAPPING&&null!=r.valueKind()&&n.accept(J(Pe.RESOURCE_TYPE_NAME,{},t)):null==t.value()&&r&&r.children()&&r.children().length>1&&n.accept(J(Pe.MULTIPLE_RESOURCE_TYPES,{},t))}}function K(e,t,n){return"type"==t.nameId()&&"RAML08"==t.domain().universe().version()&&t.domain().isAssignableFrom(ye.Universe08.Parameter.name)?Pe.TYPES_VARIETY_RESTRICTION:null!=n.parent()&&ve.isSecuritySchemaType(n.parent().definition())?Pe.UNRECOGNIZED_SECURITY_SCHEME:e}function V(e){var t=e&&e.lowLevel()&&e.lowLevel().key();if(t===ye.Universe10.AbstractSecurityScheme.properties.type.name){var n=e.parent()&&e.parent().definition()&&e.parent().definition().nameId();if(n===ye.Universe10.AbstractSecurityScheme.name)return"security scheme type"}else if(t===ye.Universe08.BodyLike.properties.schema.name){var n=e.parent()&&e.parent().definition()&&e.parent().definition().nameId();if(n===ye.Universe08.BodyLike.name)return"schema"}}function j(e,t){var n=t.getValidationPath();return q(e,n)}function W(e){var t=e.getExtra(be.SOURCE_EXTRA);return de.LowLevelWrapperForTypeSystem.isInstance(t)?t.node():null}function q(e,t){if(!t)return e;var n=e.children().filter(function(e){return e.isAttr()&&e.asAttr().isFromKey()?!1:e.name()===t.name});if(e.isElement()&&ve.isTypeDeclarationDescendant(e.asElement().definition())){var r=e.lowLevel();n=pe.uniq(e.directChildren().concat(e.children())).filter(function(e){return e.isAttr()&&e.asAttr().isFromKey()?!1:e.name()===t.name}).sort(function(e,t){for(var n=e.lowLevel().parent();n&&n.kind()!=ce.Kind.MAPPING;)n=n.parent();for(var i=t.lowLevel().parent();i&&i.kind()!=ce.Kind.MAPPING;)i=i.parent();return n==r?-1:i==r?1:0})}var i=t.child&&"number"==typeof t.child.name?t.child.name:-1;if(i>=0&&n.length>i)return q(n[i],t.child.child);if(n.length>0)return q(n[0],t.child);if(!e.lowLevel())return e;for(var a=e.lowLevel().children(),o=0;o<a.length;o++)if(a[o].key()===t.name){var s=new de.BasicASTNode(a[o],e);return q(s,t.child)}if(!isNaN(t.name)&&a[t.name]){var u=a[t.name],s=new de.BasicASTNode(u,e);return q(s,t.child)}return e}function Y(e,t){var n=e&&e.includeBaseUnit()&&(e.includePath&&e.includePath()?e.includeBaseUnit().resolve(e.includePath()):e.includeBaseUnit());if(t){var r=t&&t.includeBaseUnit()&&(t.includePath&&t.includePath()?t.includeBaseUnit().resolve(t.includePath()):t.includeBaseUnit());r!=n&&(n=r)}return new _e.ContentProvider(n)}function H(e){return-1!=e.indexOf("json")}function $(e){return-1!=e.indexOf("xml")}function G(e){var t=X(e);if("body"==t){var n=e.root().attr("mediaType");return n?n.value():null}return t}function X(e){if(e.parent()){var t=e.parent().definition();if(t.key()==ye.Universe08.BodyLike)return e.parent().name();if(e.parent().parent()){var n=e.parent().parent().definition().key();if(n==ye.Universe08.Response||n==ye.Universe10.Response)return e.parent().property().nameId()==ye.Universe08.Response.properties.headers.name?null:e.parent().name();if(n==ye.Universe08.Method||n==ye.Universe10.Method)return e.parent().property().nameId()==ye.Universe10.MethodBase.properties.queryParameters.name||e.parent().property().nameId()==ye.Universe10.MethodBase.properties.headers.name?null:e.parent().name()}}return null}function z(e,t){return Q(e.getCode(),e.getMessage(),j(t,e),e.isWarning())}function J(e,t,n,r){void 0===r&&(r=!1);var i=ne(e,t);return Q(e.code,i,n,r)}function Q(e,t,n,r){void 0===r&&(r=!1);var i=null,a=null;if(se.LowLevelProxyNode.isInstance(n.lowLevel()))for(var o=n.lowLevel();!o.primaryNode();)i||(i=mt(n,e,r,t,!0,a)),n=n.parent(),o=n.lowLevel();var s=n;if(n&&(a=n.property(),n.lowLevel().unit()!=n.root().lowLevel().unit())){i=mt(n,e,r,t,!0,a);for(n.lowLevel().unit();n.lowLevel().unit()!=n.root().lowLevel().unit();)a=n.property(),n=n.parent()}if(i){var u=n.lowLevel().unit().project().namespaceResolver();if(u){var l=u.resolveNamespace(n.root().lowLevel().unit(),s.lowLevel().unit());if(l){var p=l.usesNodes.map(function(e){return Z(Pe.ISSUES_IN_THE_LIBRARY,{value:e.value()},e,e.unit().highLevel(),!0)});p.push(i),p=p.reverse();for(var c=0;c<p.length-1;c++)p[c].extras.push(p[c+1]);return i}}n.property()&&n.property().nameId()==ye.Universe10.FragmentDeclaration.properties.uses.name&&null!=n.parent()&&(a=n.property(),n=n.parent())}var f=mt(n,e,r,t,!1,a);if(i){if(i.extras.push(f),n.lowLevel().valueKind()==ce.Kind.INCLUDE_REF){
var d=Pe.ERROR_IN_INCLUDED_FILE;f.code=d.code,f.message=ne(d,{msg:f.message})}f=i}return f}function Z(e,t,n,r,i,a){void 0===i&&(i=!1),void 0===a&&(a=!1);var o=ne(e,t);return ee(e.code,o,n,r,i,a)}function ee(e,t,n,r,i,a){void 0===i&&(i=!1),void 0===a&&(a=!1);var o=null;if(n){var s=r.root().lowLevel().unit();if(r.lowLevel().unit()!=s){o=ht(n,r,e,i,t,!0);var u=r.lowLevel().unit();for(u&&(t=t+" "+u.path());r.lowLevel().unit()!=s;)r=r.parent()}}o&&(r.property()&&r.property().nameId()==ye.Universe10.FragmentDeclaration.properties.uses.name&&null!=r.parent()&&(r=r.parent()),n=r.lowLevel());var l=ht(n,r,e,i,t,a);return o&&(o.extras.push(l),n.valueKind()==ce.Kind.INCLUDE_REF&&(l.message="Error in the included file: "+l.message),l=o),l}function te(e){if(3!=e.length)return new qe(Pe.STATUS_MUST_BE_3NUMBER);for(var t=0;t<e.length;t++){var n=e[t];if(!pe.find(["0","1","2","3","4","5","6","7","8","9"],function(e){return e==n}))return new qe(Pe.STATUS_MUST_BE_3NUMBER)}return null}function ne(e,t){for(var n="",r=e.message,i=0,a=r.indexOf("{{");a>=0;a=r.indexOf("{{",i)){if(n+=r.substring(i,a),i=r.indexOf("}}",a),0>i){i=a;break}a+="{{".length;var o=r.substring(a,i);i+="}}".length;var s=t[o];if(void 0===s)throw new Error("Message parameter '"+o+"' has no value specified.");n+=s}return n+=r.substring(i,r.length)}var re=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},ie=n(24),ae=n(54),oe=n(70),se=n(41),ue=n(9),le=n(10),pe=n(65),ce=n(73),fe=n(39),de=n(16),me=n(15),he=n(48),ye=n(18),ve=n(14),ge=n(38),Ae=fe,Se=n(55),Ee=n(27),Te=n(13),be=fe.rt,Ne=n(44),_e=n(31),we=n(25),Me=fe.getSchemaUtils(),Ie=n(69),Re=n(56),Ce=n(78),Le=n(77),Pe=n(83),Oe=function(){function e(){this.validateNotStrictExamples=!0}return e}(),De=new Oe,xe=n(84);t.RESERVED_TEMPLATE_PARAMETERS={resourcePathName:'Part of the resource path following the rightmost "/"',methodName:"Method name",resourcePath:"Path of the resource"};var Ue=function(e,t,n){if(he.existsSync(e))try{var i=he.readFileSync(e).toString(),a=new ke(t);r(i,a,null),a.visit(n)}catch(o){console.log("Error in custom linter"),console.log(o)}},ke=function(){function e(e){this.acceptor=e,this.nodes={}}return e.prototype.error=function(e,t){this.acceptor.accept(J(Pe.INVALID_VALUE_SCHEMA,{iValue:t},e.highLevel()))},e.prototype.errorOnProperty=function(e,t,n){var r=e.highLevel().attr(t);this.acceptor.accept(J(Pe.INVALID_VALUE_SCHEMA,{iValue:n},r))},e.prototype.warningOnProperty=function(e,t,n){var r=e.highLevel().attr(t);this.acceptor.accept(J(Pe.INVALID_VALUE_SCHEMA,{iValue:n},r,!0))},e.prototype.warning=function(e,t){this.acceptor.accept(J(Pe.INVALID_VALUE_SCHEMA,{iValue:t},e.highLevel(),!0))},e.prototype.registerRule=function(e,t){var n=this.nodes[e];n||(n=[],this.nodes[e]=n),n.push(t)},e.prototype.visit=function(e){var t=this,n=e.definition();this.process(n,e),n.allSuperTypes().forEach(function(n){return t.process(n,e)}),e.elements().forEach(function(e){return t.visit(e)})},e.prototype.process=function(e,t){var n=this;if(fe.NodeClass.isInstance(e)&&!e.getAdapter(Ae.RAMLService).getDeclaringNode()){var r=this.nodes[e.nameId()];r&&r.forEach(function(e){return e(t.wrapperNode(),n)})}},e}();(function(){function e(){}return e.prototype.toString=function(){return this.prev?this.value+"."+this.prev.toString():this.value},e.prototype.last=function(){return this.prev?this.prev.last():this},e})();t.validateBasicFlat=m;(function(){function e(){}return e})();t.validateBasic=b;var Fe=function(e,t){var n=t.lowLevel().start(),r=[];if(0>n){for(var i=t.attr("key").value().split("."),a=[],o=t.parent(),s=0,u=i;s<u.length;s++){var l=u[s],p=pe.find(o.elementsOfKind("uses"),function(e){return e.attr("key")&&e.attr("key").value()==l});a.push(p),o=p.lowLevel().unit().resolve(p.attr("value").value()).highLevel().asElement()}var c=a.map(function(e){return J(Pe.ISSUES_IN_THE_LIBRARY,{value:e.attr("value").value()},e,!0)});c=c.reverse();for(var f=0;f<c.length-1;f++)c[f].extras.push(c[f+1]);return c[0]}return r.push(t),J(Pe.ISSUES_IN_THE_LIBRARY,{value:e.value()},t,!0)};t.validate=_;var Be=function(t){t=t.replace(/\\/g,"/").trim(),t.length>1&&":"==t.charAt(1)&&/^win/.test(e.platform)&&(t=t.substring(2));var n=t.split("/");return 0==n[0].length&&(n=n.slice(1)),n.length>0&&0==n[n.length-1].length&&(n=n.slice(0,n.length-1)),n},Ke=function(e,t,n){try{new RegExp(e)}catch(r){t.accept(J(Pe.ILLEGAL_PATTERN,{value:e},n))}},Ve=function(){function e(){}return e.prototype.validateName=function(e,t){var n=e.name();if(n){var r=e.lowLevel().keyStart();this.check(n,r,e,t)}},e.prototype.validateValue=function(e,t){var n=e.value();if("string"==typeof n){var r=e.lowLevel().valueStart();this.check(n,r,e,t)}},e.prototype.hasTraitOrResourceTypeParent=function(e){for(var t=e.parent();null!=t;){if(!t.definition())return!1;if(ve.isTraitType(t.definition())||ve.isResourceTypeType(t.definition()))return!0;t=t.parent()}return!1},e.prototype.check=function(e,t,n,r){if(!this.hasTraitOrResourceTypeParent(n))return[];for(var i=[],a=0,o=e.indexOf("<<");o>=0;o=e.indexOf("<<",a)){o+="<<".length,a=e.indexOf(">>",o);var s=e.substring(o,a),u=s.indexOf("|"),l=u>=0?s.substring(0,u):s;if(0==l.trim().length){var p=J(Pe.TEMPLATE_PARAMETER_NAME_MUST_CONTAIN_NONWHITESPACE_CHARACTERS,{},n);p.start=t+o,p.end=t+a,r.accept(p)}if(-1!=u){u++;for(var c=s.split("|").slice(1).map(function(e){return e.trim()}),f=Ee.getTransformNames(),d=0,m=c;d<m.length;d++){var h=m[d];if(!pe.find(f,function(e){return h===e||h==="!"+e})){var p=J(Pe.UNKNOWN_FUNCTION,{transformerName:h},n,!1);p.start=t+u,p.end=t+a,r.accept(p)}}}a+=">>".length}return i},e}(),je=function(){function e(){}return e.prototype.validate=function(t,n){var r=t.parent();if(r&&(r.definition().isAssignableFrom(ye.Universe08.Method.name)||r.definition().isAssignableFrom(ye.Universe10.Method.name))){var i=pe.find(r.lowLevel()&&r.lowLevel().children()||[],function(e){var t=e.key();return t&&(ye.Universe08.MethodBase.properties.body.name===t||ye.Universe10.MethodBase.properties.body.name===t)});i&&pe.find(e.methodsWithoutRequestBody,function(e){return r.name()===e})&&n.accept(J(Pe.REQUEST_BODY_DISABLED,{methodName:r.name()},r))}},e.methodsWithoutRequestBody=["trace"],e}(),We=function(){function e(){}return e.prototype.validate=function(e,t){var n=i(e,t),r=e.value(),a=e.parent().definition().universe().version(),l=null!=c(e.parent());if(!e.property().range().hasStructure()){if(de.StructuredValue.isInstance(r)&&!e.property().isSelfNode()){if(o(e.property())&&e.property().domain().key()==ye.Universe08.BodyLike){var f=new de.ASTNodeImpl(e.lowLevel(),e.parent(),e.parent().definition().universe().type(ye.Universe08.BodyLike.name),e.property());return void f.validate(t)}if("RAML10"==a&&l)return;t.accept(J(Pe.SCALAR_EXPECTED,{},e))}else{var d=e.lowLevel().valueKind();if(e.lowLevel().valueKind()!=ce.Kind.INCLUDE_REF&&!e.property().getAdapter(Ae.RAMLPropertyService).isKey()&&!e.property().isMultiValue()){var m=e.property().range().key();(m==ye.Universe08.StringType||m==ye.Universe08.MarkdownString||m==ye.Universe08.MimeType)&&(d!=ce.Kind.SEQ&&d!=ce.Kind.MAPPING&&d!=ce.Kind.MAP&&(!e.property().isRequired()&&"mediaType"!=e.property().nameId()||null!=d&&void 0!==d)||e.property().domain().getAdapter(Ae.RAMLService).isInlinedTemplates()||t.accept(J(Pe.STRING_EXPECTED,{propName:e.name()},e)))}}if(e.isAnnotatedScalar()){var h=new Ze;e.annotations().forEach(function(e){var n=e.value(),r=n.toHighLevel();r?h.validate(r,t):t.accept(J(Pe.UNKNOWN_ANNOTATION,{aName:n.valueName()},e))})}}var y;if("string"==typeof r?y=r:de.StructuredValue.isInstance(r)&&(y=r.valueName()),!(y&&-1!=y.indexOf("<<")&&y.indexOf(">>")>y.indexOf("<<")&&((new Ve).validateValue(e,t),l))){if((new je).validate(e,t),e.property().range().key()==ye.Universe08.MimeType||e.property().range().key()==ye.Universe10.MimeType||e.property().nameId()==ye.Universe10.TypeDeclaration.properties.name.name&&e.parent().property().nameId()==ye.Universe10.MethodBase.properties.body.name)return void(new $e).validate(e,t);if(u(e.property())||s(e.property())){if("RAML08"==a){e.lowLevel().value();if(e.lowLevel().children().length>0){var v=u(e.property())?"'example'":"'defaultValue'";t.accept(J(Pe.STRING_EXPECTED_2,{propName:v},e,!1))}}(new lt).validate(e,t)}if(p(e.property())){if("RAML08"==a){var g=e.lowLevel().parent(),A=ce.Kind.SEQ;se.LowLevelProxyNode.isInstance(e.lowLevel())?g.valueKind()!=A&&t.accept(J(Pe.SECUREDBY_LIST_08,{},e,!1)):g.kind()!=A&&t.accept(J(Pe.SECUREDBY_LIST_08,{},e,!1))}if((new lt).validate(e,t),"RAML10"==a&&de.StructuredValue.isInstance(r)){var S=r,E=S.children().filter(function(e){return"scopes"==e.valueName()});if(E.length>0){var T=e.findReferencedValue();if(T){var b=[];E.forEach(function(e){var t=e.children();if(t.length>0)t.forEach(function(e){var t=e.lowLevel().value();null==t||l&&t.indexOf("<<")>=0||b.push(e)});else{var n=e.lowLevel().value();null==n||l&&n.indexOf("<<")>=0||b.push(e)}});var N={},_=T.element(fe.universesInfo.Universe10.AbstractSecurityScheme.properties.settings.name);if(_){var w=_.attributes(fe.universesInfo.Universe10.OAuth2SecuritySchemeSettings.properties.scopes.name);w.forEach(function(e){return N[e.value()]=!0})}for(var M=0,I=b;M<I.length;M++){var R=I[M],C=R.lowLevel().value();N.hasOwnProperty(C)||t.accept(Z(Pe.INVALID_SECURITY_SCHEME_SCOPE,{invalidScope:C,securityScheme:T.name(),allowedScopes:Object.keys(N).map(function(e){return"'"+e+"'"}).join(", ")},R.lowLevel(),e,!1))}}}}}if(e.property().nameId()==ye.Universe10.TypeDeclaration.properties.name.name){var L=e.parent().property()&&e.parent().property().nameId();if(L==ye.Universe08.Resource.properties.uriParameters.name||L==ye.Universe08.Resource.properties.baseUriParameters.name)return}var P=e.property().range().key();if(P==ye.Universe08.RelativeUriString||P==ye.Universe10.RelativeUriString)return void(new He).validate(e,t);if(P==ye.Universe08.FullUriTemplateString||P==ye.Universe10.FullUriTemplateString)return void(new He).validate(e,t);if("pattern"==e.name()&&ye.Universe10.StringType==e.definition().key()&&e.parent().definition().isAssignableFrom("StringTypeDeclaration")&&Ke(e.value(),t,e),"name"==e.name()&&ye.Universe10.StringType==e.definition().key()&&"string"==typeof e.value()&&0==e.value().indexOf("[")&&e.value().lastIndexOf("]")==e.value().length-1&&de.ASTNodeImpl.isInstance(e.parent())&&ye.Universe10.ObjectTypeDeclaration.properties.properties.name==e.parent().property().nameId()&&de.ASTNodeImpl.isInstance(e.parent().parent())&&ye.Universe10.ObjectTypeDeclaration==e.parent().parent().definition().key()){var O=e.value().substr(1,e.value().length-2);Ke(O,t,e)}n.isReference()||n.isDescriminator()?(new Xe).validate(e,t):(new Ye).validate(e,t)}},e}();t.isValid=C;var qe=function(e){function t(t,n){void 0===n&&(n={}),e.call(this),this.messageEntry=t,this.parameters=n}return re(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&pe.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ValidationError)},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER_ValidationError)},t.CLASS_IDENTIFIER_ValidationError="linter.ValidationError",t}(Error),Ye=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.value(),r=e.property(),i=r.range(),a=i.getAdapter(Ae.RAMLService).getDeclaringNode();if(a&&i.isUserDefined()){var o=a.parsedType(),s=e.parent().lowLevel().dumpToObject(),u=s[e.parent().name()],l=r.canBeValue(),p=l||null===u||void 0===u?u:u[r.nameId()],c=o.validate(p,!0);c.isOk()||c.getErrors().forEach(function(n){return t.accept(Q(n.getCode(),n.getMessage(),e,!1))})}var f=t;if(e.lowLevel().keyKind()!=ce.Kind.SEQ)var d=C(r.range(),e.parent(),n,r,e);else d=!0;if(d instanceof Error&&!d.canBeRef){if(qe.isInstance(d)){var m=d;f.accept(J(m.messageEntry,m.parameters,e,d.isWarning))}else f.accept(J(Pe.SCHEMA_EXCEPTION,{msg:d.message},e,d.isWarning));return void(d=null)}if(!d||d instanceof Error)if("value"!=r.nameId()){if(!U(r,e,n,f)){if((r.nameId()==ye.Universe10.TypeDeclaration.properties.schema.name||ye.Universe10.TypeDeclaration.properties.type.name)&&n&&n.trim()&&(r.domain().key()==ye.Universe08.BodyLike||r.domain().key()==ye.Universe10.TypeDeclaration)){var h=n.trim().charAt(0);if("{"!=h&&"<"!=h)return}var y=e.findReferencedValue();if(y instanceof Error)if(qe.isInstance(y)){var m=y;f.accept(J(m.messageEntry,m.parameters,e,m.isWarning))}else f.accept(J(Pe.SCHEMA_EXCEPTION,{msg:y.message},e));if(!y){if(n&&r.nameId()==ye.Universe10.TypeDeclaration.properties.schema.name){var v=n.trim();if("{"!=v.charAt(0)&&"<"!=v.charAt(0)&&(-1!=n.indexOf("|")||-1!=n.indexOf("[]")||-1!=n.indexOf("(")))return}if(d instanceof Error&&n){if(qe.isInstance(d)){var m=d;f.accept(J(m.messageEntry,m.parameters,e,m.isWarning))}else f.accept(J(Pe.SCHEMA_EXCEPTION,{msg:d.message},e));return void(d=null)}if(e.property().isRequired()&&null==e.value())f.accept(J(Pe.EMPTY_VALUE_NOT_ALLOWED,{},e));else{var g=e.lowLevel().valueKind();(g==ce.Kind.MAP||g==ce.Kind.SEQ||g==ce.Kind.MAPPING)&&f.accept(J(Pe.EMPTY_VALUE_NOT_ALLOWED,{},e))}}}}else if(d instanceof Error){var A=d.message;f.accept(J(Pe.SCHEMA_ERROR,{msg:A},e,r.range().key()==ye.Universe08.SchemaString))}else{var n=e.value();f.accept(J(Pe.INVALID_VALUE_SCHEMA,{iValue:n},e,r.range().key()==ye.Universe08.SchemaString))}var S=r.enumOptions();if(S){var E=e.parent()&&e.parent().definition(),T=E&&E.isAssignableFrom(ye.Universe10.Api.name),b=E&&E.isAssignableFrom(ye.Universe08.Api.name),N=r.nameId()===ye.Universe08.Api.properties.protocols.name,_=r.nameId()===ye.Universe10.Api.properties.protocols.name;if("string"!=typeof n)return;!b&&!T||!N&&!_||O(n)||(n=n.toUpperCase()),"string"==typeof S?S!=n&&(n&&0==n.indexOf("x-")&&r.nameId()==ye.Universe08.AbstractSecurityScheme.properties.type.name||f.accept(J(Pe.INVALID_VALUE,{iValue:n,aValues:"'"+S+"'"},e))):S.length>0&&(pe.find(S,function(e){return e==n})||n&&0==n.indexOf("x-")&&r.nameId()==ye.Universe08.AbstractSecurityScheme.properties.type.name||f.accept(J(Pe.INVALID_VALUE,{iValue:n,aValues:S.map(function(e){return"'"+e+"'"}).join(", ")},e)))}},e}(),He=function(){function e(){}return e.prototype.validate=function(e,t){try{var n=(new Ge).parseUrl(e.value()||"");if(n.some(function(e){return"version"==e})&&"baseUri"==e.property().nameId()){var r=e.root().attr("version");r||t.accept(J(Pe.MISSING_VERSION,{},e,!1))}n.some(function(e){return 0==e.length})&&t.accept(J(Pe.URI_PARAMETER_NAME_MISSING,{},e,!1))}catch(i){t.accept(J(Pe.URI_EXCEPTION,{msg:i.message},e,!1))}},e}(),$e=function(){function e(){}return e.prototype.validate=function(e,t){try{var n=e.value();if(!n)return;if("*/*"==n)return;if(n.indexOf("/*")==n.length-2&&(n=n.substring(0,n.length-2)+"/xxx"),e.parent()&&e.parent().parent()&&e.parent().parent().definition().isAssignableFrom(ye.Universe10.Trait.name)&&n.indexOf("<<")>=0)return;if("body"==n&&e.parent().parent()){var r=e.parent().parent().definition().key();(r===ye.Universe08.Response||r===ye.Universe10.Response||e.parent().parent().definition().isAssignableFrom(ye.Universe10.MethodBase.name))&&(n=e.parent().computedValue("mediaType"))}var i=Ie.parse(n);i.type.match(/[\w\d][\w\d!#\$&\-\^_+\.]*/)||t.accept(J(Pe.INVALID_MEDIATYPE,{mediaType:i.type},e))}catch(a){t.accept(J(Pe.MEDIATYPE_EXCEPTION,{msg:a.message},e))}(e.value()&&"multipart/form-data"==e.value()||"application/x-www-form-urlencoded"==e.value())&&e.parent()&&e.parent().parent()&&e.parent().parent().property()&&e.parent().parent().property().nameId()==ye.Universe10.MethodBase.properties.responses.name&&t.accept(J(Pe.FORM_IN_RESPONSE,{},e,!0))},e}(),Ge=function(){function e(){}return e.prototype.checkBaseUri=function(e,t,n,r){var i=t.root().attr("baseUri");if(i){var a=i.value();try{var o=this.parseUrl(a);pe.find(o,function(e){return e==n})||r.accept(J(Pe.UNUSED_URL_PARAMETER,{paramName:""},e))}catch(s){}}else r.accept(J(Pe.UNUSED_URL_PARAMETER,{paramName:""},e))},e.prototype.parseUrl=function(e){for(var t=[],n="",r=!1,i=0,a=0;a<e.length;a++){var o=e[a];"{"!=o?"}"!=o?r&&(n+=o):(i--,r=!1,t.push(n),n=""):(i++,r=!0)}if(i>0)throw new Error("Invalid resource name: unmatched '{'");if(0>i)throw new Error("Invalid resource name: unmatched '}'");return t},e.prototype.validate=function(e,t){var n=e.value();if(e.parent().property().nameId()==ye.Universe10.Api.properties.baseUri.name){var r=e.parent().parent();return void this.checkBaseUri(e,r,n,t)}var r=e.parent().parent(),i=r.name();if(r.definition().key()===ye.Universe10.Api||r.definition().key()===ye.Universe08.Api)return void this.checkBaseUri(e,r,n,t);if(r.definition().key()!=ye.Universe10.ResourceType&&r.definition().key()!=ye.Universe08.ResourceType)try{var a=this.parseUrl(i),o=pe.find(a,function(e){return e==n});if(!o){var s=e.root().attr(ye.Universe10.Api.properties.baseUri.name);if(s&&e.name()===ye.Universe08.Api.properties.baseUriParameters.name){var u=s.value();if(u&&(a=this.parseUrl(u),a&&a.length>0&&pe.find(a,function(e){return e==n})))return}t.accept(J(Pe.UNUSED_URL_PARAMETER,{paramName:"'"+n+"'"},e))}}catch(l){}},e}();t.UrlParameterNameValidator=Ge,t.typeToName={},t.typeToName[ye.Universe08.Trait.name]="trait",t.typeToName[ye.Universe08.ResourceType.name]="resource type",t.typeToName[ye.Universe10.Trait.name]="trait",t.typeToName[ye.Universe10.ResourceType.name]="resource type",t.typeToName[ye.Universe10.AbstractSecurityScheme.name]="security scheme",t.typeToName[ye.Universe10.Method.name]="method",t.typeToName[ye.Universe08.Method.name]="method",t.typeToName[ye.Universe10.Resource.name]="resource",t.typeToName[ye.Universe08.Resource.name]="resource",t.typeToName[ye.Universe10.Api.name]="api",t.typeToName[ye.Universe08.Api.name]="api",t.typeToName[ye.Universe10.Response.name]="response",t.typeToName[ye.Universe08.Response.name]="response",t.typeToName[ye.Universe08.BodyLike.name]="body",t.parameterPropertyToName={},t.parameterPropertyToName[ye.Universe08.MethodBase.properties.headers.name]="header",t.parameterPropertyToName[ye.Universe08.MethodBase.properties.queryParameters.name]="query parameter",t.parameterPropertyToName[ye.Universe08.Api.properties.uriParameters.name]="uri parameter",t.parameterPropertyToName[ye.Universe08.Api.properties.baseUriParameters.name]="base uri parameter",t.parameterPropertyToName[ye.Universe08.BodyLike.properties.formParameters.name]="form parameter",t.parameterPropertyToName[ye.Universe10.MethodBase.properties.headers.name]="header",t.parameterPropertyToName[ye.Universe10.MethodBase.properties.queryParameters.name]="query parameter",t.parameterPropertyToName[ye.Universe10.ResourceBase.properties.uriParameters.name]="uri parameter",t.parameterPropertyToName[ye.Universe10.Api.properties.baseUriParameters.name]="base uri parameter",t.parameterPropertyToName[ye.Universe10.MethodBase.properties.body.name]="body",t.getHumanReadableNodeName=D;var Xe=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.value(),r=n,i=e.property();if("string"==typeof n){if(U(i,e,n,t),fe.ReferenceType.isInstance(i.range())){var a=(i.range(),ie.createNode(""+n,e.lowLevel().parent(),e.lowLevel().unit()));a._actualNode().startPosition=e.lowLevel().valueStart(),a._actualNode().endPosition=e.lowLevel().valueEnd();var o=new de.StructuredValue(a,e.parent(),e.property()),s=o.toHighLevel();s&&s.validate(t)}}else if(null!=n){var u=n;if(u){r=u.valueName();var l=u.valueName();if(!U(i,e,l,t)){var p=u.toHighLevel();p&&p.validate(t)}}else r=null}else e.definition().isAssignableFrom(ye.Universe10.Reference.name)&&U(i,e,null,t);if(r){var c=C(i.range(),e.parent(),r,i);if(c instanceof Error){if(qe.isInstance(c)){var f=c;t.accept(J(f.messageEntry,f.parameters,e,c.isWarning))}else t.accept(J(Pe.SCHEMA_EXCEPTION,{msg:c.message},e,c.isWarning));c=null}}},e}(),ze=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.universe(),r=n.getTypedVersion();if(r){if("0.8"!==r&&"1.0"!==r){var i=J(Pe.UNKNOWN_RAML_VERSION,{},e);t.accept(i)}var a=n.getOriginalTopLevelText();if(a){var o={typeName:a};if(a!=e.definition().nameId()){if("Api"==e.definition().nameId()){var i=J(Pe.UNKNOWN_TOPL_LEVEL_TYPE,o,e);t.accept(i)}}else if("Api"==n.getOriginalTopLevelText()){var i=J(Pe.REDUNDANT_FRAGMENT_NAME,o,e);t.accept(i)}}}},e}(),Je=function(){function e(){}return e.prototype.validate=function(e,t){var n=this;e.definition().getAdapter(Ae.RAMLService).getContextRequirements().forEach(function(n){if(!e.checkContextValue(n.name,n.value,n.value)){var r={v1:n.name,v2:n.value,v3:e.definition().nameId()},i=Pe.CONTEXT_REQUIREMENT_VIOLATION;"location"==n.name&&"ParameterLocation.FORM"==n.value&&(i=Pe.WEB_FORMS),t.accept(J(i,r,e))}});var r,i=e.definition().getAdapter(Ae.RAMLService).isInlinedTemplates();if(i){for(var a={},o=0,s=e.lowLevel().children();o<s.length;o++){var u=s[o];a[u.key()]=u.value(!0)}for(var l=e.definition().isAssignableFrom(ye.Universe10.Trait.name)?"trait":"resource type",p=Ee.toUnits(e),c=new Ee.ValueTransformer(l,e.definition().nameId(),p,a),f=e.parent(),d=f?f.definition():e.definition();null!=f&&!ve.isResourceType(d)&&!ve.isMethodType(d);)f=f.parent();r=new Ee.DefaultTransformer(f,c,p)}e.definition().requiredProperties().forEach(function(a){if(i){var o=a.getAdapter(Ae.RAMLPropertyService).meta("templatePaths");if(o){for(var s=e.parent(),u=!1,l=0,p=o;l<p.length;l++){var c=p[l];if(c=c.map(function(e){return r.transform(e).value}),n.checkPathSufficiency(s.lowLevel(),c,s)){u=!0;break}}if(!u)return}}var f=a.range();if(f.hasArrayInHierarchy()&&(f=f.arrayInHierarchy().componentType()),f.hasValueTypeInHierarchy()){var d=e.attr(a.nameId()),m=!1;if(null!=d&&(d.lowLevel().kind()==ce.Kind.SCALAR||d.lowLevel().valueKind()==ce.Kind.SCALAR||d.lowLevel().kind()==ce.Kind.INCLUDE_REF||d.lowLevel().valueKind()==ce.Kind.INCLUDE_REF||null===d.lowLevel().valueKind()&&!i?m=!0:0!=d.lowLevel().children().length&&(m=!0)),!m){var h={propName:a.nameId()},y=Pe.MISSING_REQUIRED_PROPERTY;i&&(y=Pe.VALUE_NOT_PROVIDED);var v=J(y,h,e);t.accept(v)}}else{var g=e.elementsOfKind(a.nameId());if(!g||0==g.length){var v=J(Pe.MISSING_REQUIRED_PROPERTY,{propName:a.nameId()},e);t.accept(v)}}})},e.prototype.checkPathSufficiency=function(e,t,n){if(null==n||null==n.definition())return!1;var r=n.definition();if(ve.isResourceTypeType(r)||ve.isTraitType(r))return!0;if(0==t.length)return!1;if(null==e)return!1;var i=t[0];if(null==i)return!1;if("/"==i)return this.checkPathSufficiency(e,t.slice(1),n);if(0==i.length)return!0;var a=e.children().filter(function(e){return e.key()==i});0==a.length&&t.indexOf("/")<0;var o=a[0];if(se.LowLevelCompositeNode.isInstance(o)&&(o=o.primaryNode()),null==o)return t.indexOf("/")<0;if("type"==o.key())return!0;if(1==t.length)return null==o||null==o.value();var s=t.slice(1);return this.checkPathSufficiency(o,s,n)},e}(),Qe=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.lowLevel().unit();e.lowLevel().visit(function(r){if(r.unit()!=n)return!1;if(r.value()&&r._node&&r._node.value&&r._node.value.doubleQuoted){var i=(r.value()+"").indexOf(":"),a=(r.value()+"").indexOf("\n");if(-1!=i&&-1!=a&&(!r.includePath()||0==r.includePath().length)){var o=J(Pe.SUSPICIOUS_DOUBLEQUOTE,{value:r.value()},e,!0);o.start=r._node.value.startPosition,o.end=r._node.value.endPosition,o.start==o.end&&o.end++,t.accept(o)}}return!0})},e}(),Ze=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.definition(),r=n.getAdapter(Ae.RAMLService).getDeclaringNode();if(r){var i=r.parsedType(),a=e.lowLevel().dumpToObject(!0);a&&(a=a[Object.keys(a)[0]]);var o=i.validate(a,!1,!1);o.isOk()||o.getErrors().forEach(function(n){return t.accept(Q(n.getCode(),n.getMessage(),j(e,n),!1))})}},e}(),et=function(){function e(){this.annotables={API:!0,DocumentationItem:!0,Resource:!0,Method:!0,Response:!0,RequestBody:!0,ResponseBody:!0,TypeDeclaration:!0,Example:!0,ResourceType:!0,Trait:!0,SecurityScheme:!0,SecuritySchemeSettings:!0,AnnotationType:!0,Library:!0,Overlay:!0,Extension:!0}}return e.prototype.validate=function(e,t){var n=(e.definition(),e.parsedType()),r=n.validateType(e.types().getAnnotationTypeRegistry());if(!r.isOk())for(var i=0,a=r.getErrors();i<a.length;i++){var o,s=a[i],u=W(s);o=u?ee(s.getCode(),s.getMessage(),u,j(e,s),s.isWarning(),!0):Q(s.getCode(),s.getMessage(),j(e,s),s.isWarning()),t.accept(o)}var l=e.lowLevel()&&pe.find(e.lowLevel().children(),function(e){return"examples"==e.key()});if(l&&l.valueKind&&l.valueKind()===ce.Kind.SEQ&&(o=Z(Pe.MAP_EXPECTED,{},l,e,!1),t.accept(o)),e.property()&&ve.isAnnotationTypesProperty(e.property())||de.isAnnotationTypeFragment(e))for(var p=e.attributes(ye.Universe10.TypeDeclaration.properties.allowedTargets.name),c=0,f=p;c<f.length;c++){var d=f[c];this.checkAnnotationTarget(d,t)}},e.prototype.checkAnnotationTarget=function(e,t){var n=e.value();if(null!=n){"string"!=typeof n&&t.accept(J(Pe.ANNOTATION_TARGET_MUST_BE_A_STRING,{},e,!1));var r=n;n.replace(/\w|\s/g,"").length>0?t.accept(J(Pe.ALLOWED_TARGETS_MUST_BE_ARRAY,{},e,!1)):this.annotables[r]||t.accept(J(Pe.UNSUPPORTED_ANNOTATION_TARGET,{aTarget:r},e,!1))}},e}(),tt=function(){function e(){}return e.prototype.validate=function(e,t){if(!e.definition().isAnnotationType()){if(e.lowLevel().keyKind()==ce.Kind.SEQ){var n=e.definition().isAssignableFrom(ye.Universe10.TypeDeclaration.name);n||t.accept(J(Pe.NODE_KEY_IS_A_SEQUENCE,{},e))}var r=e.name();if(null==r&&(r=e.lowLevel().key(),null==r&&(r="")),e.definition().key()==ye.Universe08.GlobalSchema&&e.lowLevel().valueKind()!=ce.Kind.SCALAR){var o=!1;if(e.lowLevel().valueKind()==ce.Kind.ANCHOR_REF||e.lowLevel().valueKind()==ce.Kind.INCLUDE_REF){var s=e.lowLevel().value();"string"==typeof s&&(o=!0)}o||t.accept(J(Pe.SCHEMA_NAME_MUST_BE_STRING,{name:r},e))}e.parent()||((new ze).validate(e,t),(e.definition().key()==ye.Universe08.Api||e.definition().key()==ye.Universe10.Api)&&(new Se).validateApi(e.wrapperNode(),t),(new Qe).validate(e,t),a(e,t)),(new at).validate(e,t);var u=e.definition();if(u.key()==ye.Universe08.BodyLike&&e.lowLevel().children().map(function(e){return e.key()}).some(function(e){return"formParameters"===e}))if(e.parent()&&e.parent().definition().key()==ye.Universe08.Response){var l=J(Pe.FORM_PARAMS_IN_RESPONSE,{},e);t.accept(l)}else if(e.lowLevel().children().map(function(e){return e.key()}).some(function(e){return"schema"===e||"example"===e})){var l=J(Pe.FORM_PARAMS_WITH_EXAMPLE,{},e);t.accept(l)}if(u.key()==ye.Universe10.OAuth2SecuritySchemeSettings){var p=!1;if(e.attributes("authorizationGrants").forEach(function(e){var n=e.value();if("authorization_code"===n||"implicit"===n)p=!0;else if("password"!==n&&"client_credentials"!==n&&n&&"string"==typeof n&&-1==n.indexOf("://")&&-1==n.indexOf(":")){var r=J(Pe.AUTHORIZATION_GRANTS_ENUM,{},e);t.accept(r)}}),p&&!e.attr("authorizationUri")){var l=J(Pe.AUTHORIZATION_URI_REQUIRED,{},e);t.accept(l)}}if(e.definition().isAssignableFrom(ye.Universe08.Parameter.name)||e.definition().isAssignableFrom(ye.Universe10.TypeDeclaration.name)){var c=e.attributes("enum").map(function(e){return e.value()});if(c.length!=pe.uniq(c).length){var l=J(Pe.REPEATING_COMPONENTS_IN_ENUM,{},e);t.accept(l)}if(e.definition().isAssignableFrom(ye.Universe08.NumberTypeDeclaration.name)||e.definition().isAssignableFrom(ye.Universe10.NumberTypeDeclaration.name)){var f=e.definition().isAssignableFrom(ye.Universe08.IntegerTypeDeclaration.name)||e.definition().isAssignableFrom(ye.Universe10.IntegerTypeDeclaration.name);e.attributes("enum").forEach(function(e){var n=f?parseInt(e.value()):parseFloat(e.value()),r=f?!isNaN(n)&&-1===e.value().indexOf("."):!isNaN(n);if(!r){var i=J(f?Pe.INTEGER_EXPECTED:Pe.NUMBER_EXPECTED_2,{},e);t.accept(i)}})}}ve.isResourceTypeType(e.definition())&&null==e.value()&&"null"===e.lowLevel().value(!0)&&t.accept(J(Pe.RESOURCE_TYPE_NULL,{},e)),i(e,t);var d=e.value();if(("string"==typeof d||"number"==typeof d||"boolean"==typeof d)&&!e.definition().getAdapter(Ae.RAMLService).allowValue()&&e.parent()&&"~"!=d){var l=J(Pe.SCALAR_PROHIBITED_2,{name:r},e);t.accept(l)}(new Je).validate(e,t),(new ut).validate(e,t),(new it).validate(e,t)}},e}(),nt=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.attrValue(ye.Universe10.TypeDeclaration.properties.name.name);"version"==n&&t.accept(J(Pe.VERSION_NOT_ALLOWED,{},e))},e}(),rt=function(){function e(e,t,n,r){void 0===r&&(r=!1),this.definitions=e,this.propertyName=t,this.assignableFrom=r,this.validator=n}return e.prototype.validate=function(e,t){var n=e.definition();if(null!=n){var r=!1;if(r=this.assignableFrom?this.definitions.some(function(e){return n.isAssignableFrom(e.name)}):this.definitions.some(function(e){return e===n})){if(null!=this.propertyName){if(null==e.property())return;if(e.property().nameId()!=this.propertyName)return}this.validator.validate(e,t)}}},e}(),it=function(){function e(){}return e.createRegistry=function(){var t=[];return e.registerValidator(t,[ye.Universe10.TypeDeclaration,ye.Universe08.Parameter],ye.Universe10.Api.properties.baseUriParameters.name,new nt,!0),t},e.registerValidator=function(e,t,n,r,i){void 0===i&&(i=!1);var a=new rt(t,n,r,i);e.push(a)},e.prototype.validate=function(t,n){e.entries.forEach(function(e){return e.validate(t,n)})},e.entries=e.createRegistry(),e}(),at=function(){function e(){}return e.prototype.allowsAnyChildren=function(e,t){var n=e.property(),r=e.definition();return(ve.isAnnotationTypeType(r)||ve.isTypeDeclarationTypeOrDescendant(r))&&ve.isAnnotationTypesProperty(n)?!0:e.parent()==t&&ve.isTypesProperty(n)&&ve.isTypeDeclarationTypeOrDescendant(r)?!0:ve.isSchemasProperty(n)&&ve.isTypeDeclarationTypeOrDescendant(r)?!0:e.parent()==t&&ve.isDocumentationProperty(n)&&ve.isDocumentationType(r)?!0:ve.isAnnotationsProperty(n)?!0:ve.isUsesProperty(n)?!0:ve.isExamplesProperty(n)?!0:!1},e.prototype.nodeAllowedDueToParent=function(e,t){for(var n=e;n!=t&&null!=n;){if(this.allowsAnyChildren(n,t))return!0;n=n.parent()}return!1},e.prototype.validate=function(e,t){var n=e.root();if(!n.isExpanded()||n.lowLevel().unit().absolutePath()==e.lowLevel().unit().absolutePath()){e.property(),e.definition();if(ve.isOverlayType(n.definition())){if(e==n)return void this.validateProperties(e,t);if(!this.nodeAllowedDueToParent(e,n)){var r=n.knownIds();if(r){var i=r.hasOwnProperty(e.id());return i?void this.validateProperties(e,t):void t.accept(J(Pe.INVALID_OVERLAY_NODE,{nodeId:e.id()},e))}}}}},e.prototype.validateProperties=function(e,t){var n=e.root(),r=n.lowLevel().unit().absolutePath(),i=n.isExpanded();e.attrs().forEach(function(n){i&&r!=n.lowLevel().unit().absolutePath()||n.property().getAdapter(Ae.RAMLPropertyService).isKey()||n.parent()==e&&(n.isElement()||ve.isTitlePropertyName(n.name())||ve.isDescriptionPropertyName(n.name())||ve.isDisplayNamePropertyName(n.name())||ve.isUsagePropertyName(n.name())||ve.isExampleProperty(n.property())||ve.isMasterRefProperty(n.property())||ve.isAnnotationsProperty(n.property())||ve.isUsesProperty(n.property())||t.accept(J(Pe.INVALID_OVERRIDE_IN_OVERLAY,{propName:n.name()},n)))})},e}(),ot=function(){function e(){}return e.prototype.validate=function(e,t){var n=this,r=new at;r.validate(e,t),e.directChildren().forEach(function(e){e.isElement()&&n.validate(e.asElement(),t)})},e}(),st=function(){function e(){}return e.prototype.val=function(e,t,n){var r=this;if(e.kind()==ce.Kind.MAP||e.kind()==ce.Kind.MAPPING){var i={};e.children().forEach(function(e){var r=e.key();if(r){if(i.hasOwnProperty(r)){var a=J(Pe.KEYS_SHOULD_BE_UNIQUE,{},n,!1);e.unit()==n.lowLevel().unit()&&(a.start=e.keyStart(),a.end=e.keyEnd()),t.accept(a)}i[r]=1}})}e.children().forEach(function(e){r.val(e,t,n)})},e.prototype.validate=function(e,t){this.val(e.lowLevel(),t,e)},e}(),ut=function(){function e(){}return e.prototype.validate=function(e,t){this.validateChildElements(e,t);var n=e.lowLevel().children(),r=pe.groupBy(n.filter(function(e){return null!=e.key()}),function(e){return e.key()});this.validateChildAttributes(e,r,t),this.validateUnrecognizedLowLevelChildren(e,r,t);
},e.prototype.validateChildElements=function(e,t){var n={},r=e.directChildren().filter(function(e){return e.isElement()});r.forEach(function(e){var t=e;if(!t._computed&&t.name()){var r=t.name()+t.property().nameId();n.hasOwnProperty(r)?t.isNamePatch()||n[r].push(t):n[r]=[t]}}),Object.keys(n).forEach(function(e){var r=n[e];!r||r.length<2||r.forEach(function(e){var n=D(e),r={name:e.name()},i=Pe.ALREADY_EXISTS_IN_CONTEXT;n&&(r.capitalized=Ce.upperCaseFirst(n),i=Pe.ALREADY_EXISTS);var a=J(i,r,e);t.accept(a)})})},e.prototype.validateChildAttributes=function(e,t,n){var r=this.getHighLevelAttributes(e),i=pe.groupBy(r,function(e){return e.name()}),a=this.allowsAnyAndHasRequireds(e);Object.keys(i).forEach(function(r){if(!(i[r].length<2)){var o=i[r][0].isUnknown(),s=!o&&i[r][0].property().isMultiValue();s&&(e.definition().isAssignableFrom(ye.Universe08.SecuritySchemeSettings.name)||e.definition().isAssignableFrom(ye.Universe10.SecuritySchemeSettings.name))&&(s=t[r]&&1===t[r].length),(o&&a||!s||s&&null!=t[r]&&t[r].length>1)&&i[r].forEach(function(e){var t={propName:e.property()?e.property().nameId():e.name()},r=Pe.PROPERTY_USED,i=D(e.parent());i&&(t.parent=Ce.upperCaseFirst(i),r=Pe.PARENT_PROPERTY_USED);var a=J(r,t,e);n.accept(a)})}})},e.prototype.validateUnrecognizedLowLevelChildren=function(e,t,n){var r=e.directChildren(),i=pe.groupBy(r,function(e){return e.name()});Object.keys(t).forEach(function(r){if(r&&t[r].length>1&&!i[r]){if(e.definition().isAssignableFrom(ye.Universe10.ObjectTypeDeclaration.name))return;var a={propName:r},o=Pe.PROPERTY_USED,s=D(e);s&&(a.parent=Ce.upperCaseFirst(s),o=Pe.PARENT_PROPERTY_USED),t[r].forEach(function(t){var r=Z(o,a,t,e);r.start=t.keyStart(),r.end=t.keyEnd(),n.accept(r)})}})},e.prototype.filterMultiValueAnnotations=function(e,t,n){this.getHighLevelAttributes(e);Object.keys(t).forEach(function(e){"("!==e.charAt(0)||t[e].length<2})},e.prototype.getHighLevelAttributes=function(e){var t=this.allowsAnyAndHasRequireds(e);return e.directChildren().filter(function(e){return e.isAttr()||t})},e.prototype.allowsAnyAndHasRequireds=function(e){var t=e.definition().requiredProperties(),n=t&&t.length>0,r=e.definition().getAdapter(Ae.RAMLService),i=r&&r.getAllowAny(),a=i&&n;return a},e}(),lt=function(){function e(){}return e.prototype.validate=function(e,t){var n=this.isStrict(e);if(n||De.validateNotStrictExamples){var r=this.parseObject(e,t,n);if(r){var i=this.aquireSchema(e);i&&i.validate(r,t,n)}}},e.prototype.isExampleNode=function(e){return this.isSingleExampleNode(e)||this.isExampleNodeInMultipleDecl(e)},e.prototype.isSingleExampleNode=function(e){return e.name()==ye.Universe10.TypeDeclaration.properties.example.name},e.prototype.isExampleNodeInMultipleDecl=function(e){var t=e.parent();return t?ve.isExampleSpecType(t.definition()):!1},e.prototype.findParentSchemaOrTypeAttribute=function(e){var t=e.parent().attr(ye.Universe10.TypeDeclaration.properties.schema.name);return t?t:(t=e.parent().attr(ye.Universe10.TypeDeclaration.properties.type.name))?t:e.parent()?(t=e.parent().parent().attr(ye.Universe10.TypeDeclaration.properties.schema.name))?t:(t=e.parent().parent().attr(ye.Universe10.TypeDeclaration.properties.type.name),t?t:null):null},e.prototype.aquireSchema=function(e){var t=e.parent().definition().isAssignableFrom(ye.Universe10.TypeDeclaration.name);if(this.isExampleNode(e)){var n=e;if(this.isExampleNodeInMultipleDecl(e)&&(n=e.parent()),n.parent()&&(n.parent().definition().isAssignableFrom(ye.Universe10.TypeDeclaration.name)&&null===n.parent().parent()?t=!1:n.parent().property().nameId()==ye.Universe10.LibraryBase.properties.types.name&&(t=!1),n.parent().parent())){var r=n.parent().parent().definition().key();(r==ye.Universe08.Method||r==ye.Universe10.Method)&&(n.parent().property().nameId()==ye.Universe10.MethodBase.properties.queryParameters.name||(t=!0)),(r==ye.Universe08.Response||r==ye.Universe10.Response)&&(t=!0)}}if(e.parent().definition().key()==ye.Universe08.BodyLike||t){var i=this.findParentSchemaOrTypeAttribute(e);if(i){var a=i.value();if(de.StructuredValue.isInstance(a))return null;var o=(""+a).trim(),s=null;if("{"==o.charAt(0))try{s=Me.getJSONSchema(o,Y(i.lowLevel()))}catch(u){return null}if("<"==o.charAt(0))try{s=Me.getXMLSchema(o)}catch(u){return null}if(s)return{validate:function(t,n,r){try{if(t.__$validated)return;if(s instanceof Error)return void n.accept(J(Pe.INVALID_VALUE_SCHEMA,{iValue:s.message},e,!r));s.validateObject(t)}catch(a){var o="Cannot assign to read only property '__$validated' of ";if(a.message&&0==a.message.indexOf(o)){var u=a.message.substr(o.length,a.message.length-o.length);return void n.accept(J(Pe.INVALID_JSON_SCHEMA,{propName:u},i,!r))}if("Object.keys called on non-object"==a.message)return;return void n.accept(J(Pe.EXAMPLE_SCHEMA_FAILURE,{msg:a.message},e,!r))}}};if(o.length>0){var l=e.parent(),p=l&&l.parent(),c=l&&l.definition()&&l.definition().isAssignableFrom(ye.Universe10.ObjectTypeDeclaration.name)&&l;if(c=c||p&&p.definition()&&p.definition().isAssignableFrom(ye.Universe10.ObjectTypeDeclaration.name)&&p)return this.typeValidator(c,e)}}}return this.getSchemaFromModel(e)},e.prototype.getSchemaFromModel=function(e){var t=e.parent();return this.typeValidator(t,e)},e.prototype.typeValidator=function(e,t){var n={validate:function(n,r,i){var a=e.parsedType();if(a&&!a.isUnknown()){"number"==typeof n&&a.isString()&&(n=""+n),"boolean"==typeof n&&a.isString()&&(n=""+n),a.getExtra("repeat")&&(n=[n]);var o=a.validate(n,!1);o.isOk()||o.getErrors().forEach(function(e){return r.accept(Q(e.getCode(),e.getMessage(),t,!i))})}}};return n},e.prototype.toObject=function(e,t,n){var r=t.lowLevel().dumpToObject(!0);return this.testDublication(e,t.lowLevel(),n),r.example?r.example:r.content?r.content:void 0},e.prototype.testDublication=function(e,t,n){var r=this,i={};t.children().forEach(function(t){t.key()&&(i[t.key()]&&n.accept(J(Pe.KEYS_SHOULD_BE_UNIQUE,{},new de.BasicASTNode(t,e.parent()))),i[t.key()]=t),r.testDublication(e,t,n)})},e.prototype.parseObject=function(e,t,n){var r=null,i=e.value(),a=G(e);if(de.StructuredValue.isInstance(i))r=this.toObject(e,i,t);else if(a){if(H(a))try{r=JSON.parse(i)}catch(o){return void t.accept(J(Pe.CAN_NOT_PARSE_JSON,{msg:o.message},e,!n))}if($(a))try{r=Re.parseXML(i)}catch(o){return void t.accept(J(Pe.CAN_NOT_PARSE_XML,{msg:o.message},e,!n))}}else try{if(!(i&&i.length>0)||"["!=i.trim().charAt(0)&&"{"!=i.trim().charAt(0)&&"<"!=i.trim().charAt(0)){if("true"==i)return!0;if("false"==i)return!1;var s=parseFloat(i);return isNaN(s)?i:s}r=JSON.parse(i)}catch(o){if(0!=i.trim().indexOf("<"))return i;try{r=Re.parseXML(i)}catch(o){return void t.accept(J(Pe.CAN_NOT_PARSE_XML,{msg:o.message},e,!n))}}return r},e.prototype.isStrict=function(e){if(ve.isDefaultValue(e.property()))return!0;if(ve.isExampleProperty(e.property())&&"RAML08"==e.parent().definition().universe().version())return!1;var t=!1,n=e.parent().attr("strict");return n&&"true"==n.value()&&(t=!0),t},e}();t.ExampleAndDefaultValueValidator=lt;var pt=function(e,t,n){var r=Ce.sentence(e);return t||(r=Ce.ucFirst(r)),n&&(r=Le.plural(r)),r},ct=function(){function e(){}return e.prototype.validate=function(e,t){if(e.isAttr()){if(!e.optional())return;var n=e,r=n.property();if(r.isMultiValue()||r.range().isArray())return;if(!r.isFromParentKey()){var i=c(n.parent());if(i&&r.isValueProperty()){var a=pt(i,!0,!0),o=J(Pe.OPTIONAL_SCLARAR_PROPERTIES_10,{templateNamePlural:a,propName:n.name()},n,!1);t.accept(o)}}}else if(e.isElement()){var s=e,r=s.property(),u=s.allowsQuestion();if(!u){var l=r?pt(r.nameId(),!0,!0):"API root";s.optionalProperties().forEach(function(n){s.children().forEach(function(n){var r={propName:l,oPropName:n.lowLevel().key()},i=J(Pe.OPTIONAL_PROPERTIES_10,r,e,!1);t.accept(i)})})}var p=e.asElement().definition();if(e.optional()&&"RAML10"==p.universe().version()){var r=e.property(),f=ve.isQueryParametersProperty(r)||ve.isUriParametersProperty(r)||ve.isHeadersProperty(r);if(!(ve.isMethodType(p)||ve.isTypeDeclarationType(p)&&f)){var o=J(Pe.ONLY_METHODS_CAN_BE_OPTIONAL,{},e,!1);t.accept(o)}}}},e}(),ft=function(){function e(){}return e.prototype.validate=function(e,t){var n=e.definition(),r=ye.Universe10.Api.properties.baseUri.name,i=ye.Universe10.Api.properties.baseUriParameters.name,a=ye.Universe10.Resource.properties.relativeUri.name,o=ye.Universe10.ResourceBase.properties.uriParameters.name;if(ve.isApiSibling(n))this.inspectParameters(e,t,r,i);else if(ve.isResourceType(n)){var s=e.root();this.inspectParameters(e,t,r,i,s),this.inspectParameters(e,t,a,o)}else if(ve.isResourceTypeType(n)){var s=e.root();this.inspectParameters(e,t,r,i,s)}},e.prototype.inspectParameters=function(e,t,n,r,i){i=i||e;var a="",o=i.attr(n);o&&(a=o.value(),a&&"string"==typeof a||(a=""));var s=e.elementsOfKind(r);s.forEach(function(n){var i=n.attr(ye.Universe10.TypeDeclaration.properties.name.name);if(i){var o=i.value();if(null!=o&&a.indexOf("{"+o+"}")<0){if(ve.isResourceTypeType(e.definition())&&o.indexOf("<<")>=0)return;var s=Ce.upperCaseFirst(Le.singular(Ce.sentence(r))),u=J(Pe.PROPERTY_UNUSED,{propName:s},n,!0);t.accept(u)}}})},e}(),dt=function(){function e(){this.nameProperty=ye.Universe10.ResourceType.properties.name.name}return e.prototype.validate=function(e,t){var n=e.definition();if(ve.isLibraryBaseSibling(n)||ve.isApiType(n)){var r=(ye.Universe10.LibraryBase.properties.resourceTypes.name,ye.Universe10.ResourceBase.properties.type.name),i=(ye.Universe10.LibraryBase.properties.traits.name,ye.Universe10.MethodBase.properties.is.name),a=Te.globalDeclarations(e).filter(function(e){return ve.isResourceTypeType(e.definition())}),o=Te.globalDeclarations(e).filter(function(e){return ve.isTraitType(e.definition())});this.checkCycles(a,r,t),this.checkCycles(o,i,t)}},e.prototype.checkCycles=function(e,t,n){var r=this,i={};e.forEach(function(e){var t=r.templateName(e);i[t]=e});var a={};e.forEach(function(e){var o=r.templateName(e);a[o]||r.findCyclesInDefinition(e,t,i).forEach(function(t){t.forEach(function(e){return a[e]=!0}),t=t.reverse();var r=pt(e.definition().nameId()),i=t.join(" -> "),o={typeName:r,cycle:i},s=J(Pe.CYCLE_IN_DEFINITION,o,e,!1);n.accept(s)})})},e.prototype.templateName=function(e){var t=e.attr(this.nameProperty);return t?t.value():null},e.prototype.findCyclesInDefinition=function(e,t,n,r){void 0===r&&(r={});var i=this.templateName(e);if(r[i])return[[i]];var a={};Object.keys(r).forEach(function(e){return a[e]=r[e]}),a[i]=!0;for(var o=[],s=e.attributes(t),u=0;u<s.length;u++){var l=s[u],p=l.value();if(p){var c="string"==typeof p?p:p.valueName(),f=n[c];if(null!=f){var d=this.findCyclesInDefinition(f,t,n,a);d.forEach(function(e){return o.push(e)})}}}return o.forEach(function(e){return e.push(i)}),o},e}();t.isJson=H,t.isXML=$,t.getMediaType=G;var mt=function(e,t,n,r,i,a,o){var s=o?o:e.lowLevel(),u=s.unit()&&s.unit().contents(),l=u&&u.length,p=s.start(),c=s.end();if(l&&c>l&&(c=l-1),s.key()&&s.keyStart()){var f=s.keyStart();f>0&&(p=f);var d=s.keyEnd();d>0&&(c=d)}if(p>c&&(c=p+1,e.isElement())){var m=e.definition();ve.isApiType(m)&&(p=0==l?0:l-1,c=p)}if(a&&!a.getAdapter(Ae.RAMLPropertyService).isMerged()&&null==e.parent()){var h=pe.find(s.children(),function(e){return e.key()==a.nameId()});if(h){var f=h.keyStart(),d=h.keyEnd();f>0&&d>f&&(p=f,c=d)}}return{code:t,isWarning:n,message:r,node:e,start:p,end:c,path:i?s.unit()?s.unit().path():"":null,extras:[],unit:e?s.unit():null}},ht=function(e,t,n,r,i,a){var o=e.unit()&&e.unit().contents(),s=o&&o.length,u=e.start(),l=e.end();if(s&&l>=s&&(l=s-1),e.key()&&e.keyStart()){var p=e.keyStart();p>0&&(u=p);var c=e.keyEnd();c>0&&(l=c)}return{code:n,isWarning:r,message:i,node:t,start:u,end:l,path:a?e.unit()?e.unit().path():"":null,extras:[],unit:e?e.unit():null}};t.toIssue=z,t.createIssue1=J,t.createIssue=Q,t.createLLIssue=ee,t.validateResponseString=te}).call(t,n(64))},function(e,t,n){"use strict";function r(e,t){if(void 0===t&&(t=0),t>20)return[];try{var n=[],i=e.leftType();i&&n.push(i);var a=e.rightType();if(a)if(a.hasUnionInHierarchy()){var o=r(a.unionInHierarchy(),t+1);n=n.concat(o)}else n.push(a);return n}finally{}}function i(e){var t=e.definition();if(!t||!N.isTypeDeclarationDescendant(t))return!1;var n=e.lowLevel();if(n.valueKind()!==v.Kind.SEQ)return!1;var r=n.children();if(null==r)return!1;for(var i=0,a=r;i<a.length;i++){var o=a[i];if(o.kind()!==v.Kind.SCALAR)return!1}return!0}function a(e,t){if(!t)return e.definition().universe().type(b.Universe10.StringTypeDeclaration.name);var n=e.parsedType();return n.isString()?e.definition().universe().type(b.Universe10.StringTypeDeclaration.name):n.isNumber()?n.isInteger()?e.definition().universe().type(b.Universe10.IntegerTypeDeclaration.name):e.definition().universe().type(b.Universe10.NumberTypeDeclaration.name):n.isBoolean()?e.definition().universe().type(b.Universe10.BooleanTypeDeclaration.name):n.isObject()?e.definition().universe().type(b.Universe10.ObjectTypeDeclaration.name):n.isArray()?e.definition().universe().type(b.Universe10.ArrayTypeDeclaration.name):n.isFile()?e.definition().universe().type(b.Universe10.FileTypeDeclaration.name):n.isDateTime()?e.definition().universe().type(b.Universe10.DateTimeTypeDeclaration.name):n.isDateTimeOnly()?e.definition().universe().type(b.Universe10.DateTimeOnlyTypeDeclaration.name):n.isDateOnly()?e.definition().universe().type(b.Universe10.DateOnlyTypeDeclaration.name):n.isTimeOnly()?e.definition().universe().type(b.Universe10.TimeOnlyTypeDeclaration.name):n.isUnion()?e.definition().universe().type(b.Universe10.UnionTypeDeclaration.name):e.definition().universe().type(b.Universe10.TypeDeclaration.name)}function o(e){return function(t){var n=e.type(t);if(!n){new h.UserDefinedClass("",e,null,"","")}return n}}function s(e,t){var n=e.asElement();if(null==n)return null;var r=n.elementsOfKind(b.Universe10.TypeDeclaration.properties.facets.name);return null==r||0==r.length?null:g.find(r,function(e){return t==e.attrValue(b.Universe10.TypeDeclaration.properties.name.name)})}function u(e){var t=e.owner();if(null==t)return null;var n=e.facetName();if(!n)return null;var r=t.getExtra(w.SOURCE_EXTRA);return null==r?null:A.isSourceProvider(r)||y.isParseResult(r)?{getSource:function(){if(A.isSourceProvider(r)){var e=r.getSource();if(e&&y.isParseResult(e))return s(e,n)}else if(y.isParseResult(r))return s(r,n);return null},getClassIdentifier:function(){return[h.SourceProvider.CLASS_IDENTIFIER]}}:null}function l(e,t,n){if(null==e)return null;var r=new h.NodeClass(t.name(),t.definition().universe(),"",""),i=t.parsedType();return r.addAdapter(i),i.allFacets().forEach(function(e){if(e.kind()==h.tsInterfaces.MetaInformationKind.FacetDeclaration){var i=u(e),a=null;null!=i?(a=new h.UserDefinedProp(e.facetName(),null),a.setSourceProvider(i)):a=new h.Property(e.facetName(),"");var s=null;s=n?n.definition().universe():t.definition().universe(),a.withRange(s.type("StringType")),a.withDomain(r),a.withGroupName(e.facetName()),a.withRequired(!1),e.value(),w.setPropertyConstructor(function(e){var t=new h.Property(e,"");return t.unmerge(),t}),a.withRange(w.toNominal(e.value(),o(t.definition().universe())))}}),r._superTypes.push(e),r}function p(e,t,n){var r=n.attr("type");if(r){var i=a(n,r.value()),o=l(i,n,t);return o&&0==o.superTypes().length&&o._superTypes.push(n.definition().universe().type(b.Universe10.TypeDeclaration.name)),o}var s=b.Universe10.ObjectTypeDeclaration.properties.properties.name;if(e){if("body"==e.nameId()||g.find(n.lowLevel().children(),function(e){return e.key()===s}))return n.definition().universe().type(b.Universe10.ObjectTypeDeclaration.name)}else if(!t&&n.lowLevel()&&g.find(n.lowLevel().children(),function(e){return e.key()===s}))return n.definition().universe().type(b.Universe10.ObjectTypeDeclaration.name);return n.definition().universe().type(b.Universe10.StringTypeDeclaration.name)}function c(e){try{var t=e.definition().nameId(),n=t===b.Universe10.Api.name||t===b.Universe08.Api.name;if(!n&&!e.property()&&!e.parent()&&e.definition().nameId()===S.getFragmentDefenitionName(e)){if(e.property()&&e.property().nameId()===b.Universe10.LibraryBase.properties.annotationTypes.name)return f(null,null,e);var r=null,i=e.definition().allSubTypes();return i.forEach(function(t){!r&&m(t,e,null)&&(r=t)}),r}}catch(a){}return f(e.property(),e.parent(),e)}function f(e,t,n){var r=n.lowLevel();e&&e.nameId()==b.Universe10.FragmentDeclaration.properties.uses.name&&e.range().nameId()==b.Universe10.Library.name;var i=e?e.range().nameId():n.definition().nameId();if(r._node&&r._node.descriminate)return null;r._node&&(r._node.descriminate=1);try{if(i==b.Universe10.TypeDeclaration.name){var a=p(e,t,n);if(e||!e&&!t&&n.lowLevel()){if(e&&null!=a&&(e.nameId()==b.Universe10.MethodBase.properties.body.name||e.nameId()==b.Universe10.ArrayTypeDeclaration.properties.items.name||e.nameId()==b.Universe10.Response.properties.headers.name||e.nameId()==b.Universe10.MethodBase.properties.queryParameters.name)){var o=new h.UserDefinedClass(n.lowLevel().key(),a.universe(),n,n.lowLevel().unit()?n.lowLevel().unit().path():"","");return o._superTypes.push(a),o}if(null!=a&&N.isAnnotationTypeType(n.definition())){var s=d(a),o=new h.UserDefinedClass(n.lowLevel().key(),a.universe(),n,n.lowLevel().unit()?n.lowLevel().unit().path():"","");return o._superTypes.push(s),o._superTypes.push(a),o}}if(a)return a}var u=null;if(e&&t){var l=T.findAllSubTypes(e,t);return l.length>0&&l.forEach(function(e){u||m(e,n,u)&&(u=e)}),u}}finally{r._node&&delete r._node.descriminate}}function d(e){for(var t,n=[e].concat(e.allSuperTypes()),r=0;r<n.length;r++){var i=n[r];if(!i.isUserDefined()){if(i.isUnion()){var a=i,o=a.leftType(),s=(a.leftType(),d(o)),u=d(o);if(s.isAssignableFrom(u.nameId())&&(null==t||s.isAssignableFrom(t.nameId()))){t=s;continue}if(u.isAssignableFrom(s.nameId())&&(null==t||u.isAssignableFrom(t.nameId()))){t=u;continue}t=e.universe().type(b.Universe10.UnionTypeDeclaration.name);break}if(i.isArray()){t=e.universe().type(b.Universe10.ArrayTypeDeclaration.name);break}for(var l=i.subTypes(),p=0;p<l.length;p++){var c=l[p];c.isAssignableFrom(b.Universe10.TypeDeclaration.name)&&(null==t?t=c:c.isAssignableFrom(t.nameId())&&(t=c))}}}return null!=t?t:e.universe().type(b.Universe10.TypeDeclaration.name)}function m(e,t,n){if(t.isAttr()||t.isUnknown())return!1;var r=t,i=g.find(e.superTypes(),function(t){var n=g.find(t.allProperties(),function(e){return e.isDescriminator()});if(n){var i=r.attr(n.nameId());if(i&&i.value()==e.nameId())return!0}return!1});if(i)return!0;if(0==e.valueRequirements().length)return!1;var a=!0;return e.valueRequirements().forEach(function(t){var i=r.attr(t.name);if(i)if(i.value()==t.value);else if(e.getAdapter(_.RAMLService).getConsumesRefs()){var o=i.value(),s=[];e.superTypes().forEach(function(e){return e.allSubTypes().forEach(function(e){s.push(e)})});var u=[];g.unique(s).forEach(function(e){u.push(e.nameId()),e.valueRequirements().forEach(function(e){u.push(e.value)}),e.getAdapter(_.RAMLService).getAliases().forEach(function(e){return u.push(e)})}),g.find(u,function(e){return e==o})&&(a=!1)}else a=!1;else{var l=e.getAdapter(_.RAMLService).getDefining(),p=!1;if(l.forEach(function(e){r.lowLevel().children().forEach(function(t){t.key()==e&&(p=!0)})}),p)return void(a=!0);if(n)a=!1;else{var c=e.property(t.name);c&&c.defaultValue()==t.value||(a=!1)}}}),a}var h=n(39),y=n(9),v=n(73),g=n(65),A=h,S=n(16),E=n(41),T=n(13),b=n(18),N=n(14),_=h,w=h.rt,M=n(83),I=n(69),R=function(){function e(e){this._props=e,this.parentValue=g.find(e,function(e){return e.isFromParentValue()}),this.parentKey=g.find(e,function(e){return e.isFromParentKey()}),this.canBeValue=g.find(e,function(e){return e.canBeValue()})}return e.prototype.add=function(e){this._props.push(e)},e.prototype.match=function(e){var t=this,n=null,r="";return this._props.forEach(function(i){i.getAdapter(_.RAMLPropertyService).isSystem()||i!=t.parentValue&&i!=t.parentKey&&i.matchKey(e)&&(null!=i.keyPrefix()?i.keyPrefix().length>=r.length&&(r=i.keyPrefix(),n=i):(n=i,r=i.nameId()))}),n},e}(),C=0,L=function(){function e(){this.shouldDescriminate=!1}return e.prototype.process=function(e,t){var n=this,a=e.lowLevel(),o=e;o._mergedChildren=null;var s=a._node?a._node:a;try{if(s.currentChildren)return s.currentChildren;if(!e.definition())return;if(null==e.parent()&&!this.shouldDescriminate){this.shouldDescriminate=!0;try{var u=this.process(e,t),l=e;l._children=u,l._mergedChildren=null;var p=c(e);p&&l.patchType(p);var u=this.process(e,t);l._children=u,l._mergedChildren=null}finally{this.shouldDescriminate=!1}}if(e.definition().hasUnionInHierarchy()&&e.parent()&&e.property().nameId()==b.Universe10.LibraryBase.properties.annotations.name){var f=r(e.definition().unionInHierarchy()),d=null,m=null,h=null,y=1e3,g=e;if(f.forEach(function(r){if(!d&&!r.hasUnionInHierarchy()){g.patchType(r);if(0==C){C++;try{for(var i=n.process(e,t),a=0,o=0;o<i.length;o++)i[o].isUnknown()&&a++;0==a&&(d=i),y>a&&(y=a,m=i,h=r)}finally{C--}}}}),d)return g.patchType(h),d;m&&g.patchType(h)}var A=new R(e.definition().allProperties());if(null==e.parent()||e.lowLevel().includePath()){var E=e.definition().universe();"RAML10"==E.version()&&(e.definition().property("uses")||E.type("FragmentDeclaration").allProperties().forEach(function(e){return A.add(e)}))}var T=e,w=T._allowQuestion||e.definition().getAdapter(_.RAMLService).getAllowQuestion(),I=[];if(A.parentKey){if(e.lowLevel().key()){var L=new S.ASTPropImpl(e.lowLevel(),e,A.parentKey.range(),A.parentKey,!0);I.push(L);var O=e.property()&&N.isBodyProperty(e.property())&&e.lowLevel().key()==e.property().nameId();if(O){var D=P(T);!D&&T._computedKey&&L.overrideValue(T._computedKey)}}if(e.lowLevel().valueKind()===v.Kind.SEQ&&!i(e)){var x=new S.BasicASTNode(e.lowLevel(),T);return x.errorMessage={entry:M.DEFINITION_SHOULD_BE_A_MAP,parameters:{typeName:e.definition().nameId()}},I.push(x),I}}if(null!=e.lowLevel().value(!0))if(A.parentValue)I.push(new S.ASTPropImpl(e.lowLevel(),e,A.parentValue.range(),A.parentValue));else if(A.canBeValue){var U=e.lowLevel().value();null==U&&(U=e.lowLevel().value(!0)),"string"==typeof U&&U.trim().length>0&&I.push(new S.ASTPropImpl(e.lowLevel(),e,A.canBeValue.range(),A.canBeValue))}if(T._children=I,T._mergedChildren=null,T.definition().getAdapter(_.RAMLService).isUserDefined())I=this.processChildren(t,T,I,w,A);else if(T.definition().key()==b.Universe08.Api||T.definition().key()==b.Universe10.Api){var k=t.filter(function(e){return"uses"==e.key()});I=this.processChildren(k,T,I,w,A);var F=t.filter(function(e){return"types"==e.key()});I=this.processChildren(F,T,I,w,A);var B=t.filter(function(e){return"types"!=e.key()&&"uses"!=e.key()});I=this.processChildren(B,T,I,w,A)}else I=this.processChildren(t,T,I,w,A);return T._children=I,T._mergedChildren=null,I}finally{}},e.prototype.isTypeDeclarationShortcut=function(e,t){var n=N.isTypeProperty(t),r=e.definition()&&N.isTypeDeclarationTypeOrDescendant(e.definition());return r&&n&&e.lowLevel()&&e.lowLevel().valueKind()===v.Kind.SEQ?!0:!1},e.prototype.processChildren=function(e,t,n,r,i){var a=this,o=b.Universe10.TypeDeclaration.name,s=b.Universe10.TypeDeclaration.properties.type.name,u=b.Universe10.ArrayTypeDeclaration.properties.items.name;if(t.definition()&&t.definition().isAssignableFrom(o)&&t.lowLevel()&&i.canBeValue&&(i.canBeValue.nameId()===s||i.canBeValue.nameId()===u)&&t.lowLevel()._node&&t.lowLevel()._node.value&&t.lowLevel()._node.value.kind===v.Kind.SEQ)return e.forEach(function(e){var r=new S.ASTPropImpl(e,t,i.canBeValue.range(),i.canBeValue);n.push(r)}),n;var l=t.root().lowLevel().unit();e.forEach(function(e){if(i.canBeValue&&a.isTypeDeclarationShortcut(t,i.canBeValue))return void n.push(new S.ASTPropImpl(e,t,i.canBeValue.range(),i.canBeValue));var o=e.key(),s=null!=o?i.match(o):null;if(null!=s){var u=s.range();if(s.isAnnotation()&&"annotations"!=o){var p=new S.ASTPropImpl(e,t,u,s);return void n.push(p)}var c=!1,d=s.isMultiValue();u.isArray()?(d=!0,u=u.array().componentType(),c=!0):u.hasArrayInHierarchy()&&(d=!0,c=!0);var m,y=!1;if(t.reuseMode()&&e.valueKind()!=v.Kind.SEQ){var A=t.reusedNode();if(A){var T=[e],w=t.lowLevel();!s.isMerged()&&d&&(m=[],T=e.children(),w=e);for(var R=0,C=T;R<C.length;R++){var L=C[R],O=L.containingUnit();if(O&&O.absolutePath()!=l.absolutePath()){var D=g.find(A.children(),function(e){return e.lowLevel().key()==L.key()});if(D&&D.lowLevel().unit().absolutePath()==O.absolutePath()){y=!0,n.push(D),D.setReused(!0),D.setParent(t),D.isElement()&&D.resetRuntimeTypes(),t.isExpanded()&&(w.replaceChild(L,D.lowLevel()),D.lowLevel().setTransformer(w.transformer()));continue}}m&&m.push(L)}}}if(!m){if(y)return;m=e.children()}if(u.hasValueTypeInHierarchy()){var x=m,U=e.valueKind()==v.Kind.SEQ;if((U&&x.length>0||x.length>1)&&d)if(x.length>1&&N.isTypeDeclarationSibling(t.definition())&&(N.isTypeProperty(s)||N.isItemsProperty(s))&&e.valueKind()!=v.Kind.SEQ){var p=new S.ASTPropImpl(e,t,u,s);n.push(p),t.setComputed(s.nameId(),p)}else{var k=[];x.forEach(function(e){var r=new S.ASTPropImpl(e,t,u,s);n.push(r),k.push(e.value())}),s.isInherited()&&t.setComputed(s.nameId(),k)}else{s.isInherited()&&t.setComputed(s.nameId(),e.value());var F=new S.ASTPropImpl(e,t,u,s);if(U||e.valueKind()==v.Kind.MAP){var B=s.range().nameId();s.getAdapter(_.RAMLPropertyService).isExampleProperty()||("StringType"==B&&(B="string"),"NumberType"==B&&(B="number"),"BooleanType"==B&&(B="boolean"),("string"==B||"number"==B||"boolean"==B)&&(e.isAnnotatedScalar()||(F.errorMessage={entry:M.INVALID_PROPERTY_RANGE,parameters:{propName:s.groupName(),range:B}},0==m.length&&"enum"==s.groupName()&&(F.errorMessage={entry:M.ENUM_IS_EMPTY,parameters:{}},e.valueKind()==v.Kind.MAP&&(F.errorMessage={entry:M.ENUM_MUST_BE_AN_ARRAY,parameters:{}})))))}n.push(F)}return}var K=[];if(t._children=n,t._mergedChildren=null,null!=e.value()&&("string"==typeof e.value()||"boolean"==typeof e.value()||"number"==typeof e.value())&&(""+e.value()).trim().length>0){var V=s.range();if(!V.allProperties().some(function(e){var t=e;return t?t.canBeValue()&&t.isFromParentValue():!1})){var j=new S.BasicASTNode(e,t);j.getLowLevelEnd=function(){return-1},j.getLowLevelStart=function(){return-1},j.knownProperty=s,n.push(j)}}if(s.isMerged()){var W=new S.ASTNodeImpl(e,t,u,s);W._allowQuestion=r,K.push(W)}else if(d)if(s.getAdapter(_.RAMLPropertyService).isEmbedMap()){var q=m,Y=[],H=!1;if(q.forEach(function(e){e.kind()==v.Kind.INCLUDE_REF&&"RAML08"==t.universe().version()?e.children().forEach(function(e){var n=new S.ASTNodeImpl(e,t,u,s);n._allowQuestion=r,K.push(n),H=!0}):Y.push(e)}),q=Y,0==q.length){if(s.range().key()==b.Universe08.ResourceType&&!H){var $=new S.BasicASTNode(e,t);$.errorMessage={entry:M.PROPERTY_MUST_BE_A_MAP,parameters:{propName:s.nameId()}},n.push($)}if(e.valueKind()==v.Kind.SCALAR&&s.range().key()==b.Universe08.AbstractSecurityScheme){var $=new S.BasicASTNode(e.parent(),t);$.errorMessage={entry:M.PROPERTY_MUST_BE_A_MAP,parameters:{propName:s.nameId()}},n.push($)}}if(q.forEach(function(e){var i=e.children();if(e.key()||1!=i.length)if("RAML10"==t.universe().version()){var a=new S.ASTNodeImpl(e,t,u,s);a._allowQuestion=r,K.push(a)}else{var o=new S.BasicASTNode(e,t);n.push(o),e.key()&&(o.needSequence=!0)}else if("RAML10"!=t.universe().version()||t.parent()){var a=new S.ASTNodeImpl(i[0],t,u,s);a._allowQuestion=r,K.push(a)}}),"RAML10"==t.universe().version()&&e.valueKind()==v.Kind.SEQ){var j=new S.BasicASTNode(e,t);n.push(j),j.needMap=!0,j.knownProperty=s}}else{var G={},X=[];if(h.NodeClass.isInstance(u)){var z=u;z.getAdapter(_.RAMLService).getCanInherit().length>0&&z.getAdapter(_.RAMLService).getCanInherit().forEach(function(n){for(var i=t.computedValue(n),a=Array.isArray(i)?i:[i],o=0;o<a.length;o++){var l=a[o];if(l&&s.nameId()==b.Universe10.Response.properties.body.name){for(var p=g.find(m,function(e){return e.key()==l}),c=e;c.originalNode;)c=c.originalNode();var d=g.find(c.children(),function(e){try{return I.parse(e.key()),!0}catch(t){return!1}});if(!d){var h=t.parent().definition().key(),y=new S.ASTNodeImpl(e,t,u,s);y._computedKey=l,(h==b.Universe10.MethodBase||h==b.Universe08.MethodBase)&&y.setComputed("form","true");var v=P(t),A=f(s,t,y);A&&(v||A.setName(l),y.patchType(A));var E=y.children();y._children=E.filter(function(e){return!e.isUnknown()}),y._mergedChildren=null,y._allowQuestion=r,p||X.push(y),y.children().forEach(function(e){var t=e.property();if(t&&t.getAdapter(_.RAMLPropertyService).isKey()){var n=e;return void(n._computed=!0)}if(e.isElement()&&(e.property().getAdapter(_.RAMLPropertyService).isMerged()||(G[e.property().nameId()]=!0)),e.property().isAnnotation()){var n=e,r=n.value(),i="";i=S.StructuredValue.isInstance(r)?r.valueName():""+r,G["("+i+")"]=!0}else G[e.name()]=!0});var T=y.definition().allProperties();T.forEach(function(e){e.getAdapter(_.RAMLPropertyService).isKey()||e.getAdapter(_.RAMLPropertyService).isSystem()||y.lowLevel().children().some(function(t){return t.key()==e.nameId()})&&(G[e.nameId()]=!0)}),y._computed=!0}}}})}var J=[];if(0==m.length&&e.valueKind()==v.Kind.SEQ&&s.range().key()==b.Universe08.Parameter){var $=new S.BasicASTNode(e,t);$.errorMessage={entry:M.PROPERTY_MUST_BE_A_MAP,parameters:{propName:s.nameId()}},n.push($)}if("documentation"===s.nameId()&&e.valueKind()!==v.Kind.SEQ){if(!t.definition().getAdapter(_.RAMLService).isUserDefined()){var $=new S.BasicASTNode(e,t);$.errorMessage={entry:M.PROPERTY_MUST_BE_A_SEQUENCE,parameters:{propName:s.nameId()}},n.push($)}}else m.forEach(function(e){if(!G[e.key()])if(e.valueKind()==v.Kind.SEQ){var i="RAML10"==t.definition().universe().version();if(e.children().forEach(function(n){var a=new S.ASTNodeImpl(n,t,u,s);a._allowQuestion=r,a.setNamePatch(e.key()),i&&(a.invalidSequence=!0),J.push(a)}),0==e.children().length){var a=new S.BasicASTNode(e,t);s.range().key()==b.Universe08.Parameter?a.errorMessage={entry:M.NAMED_PARAMETER_NEEDS_TYPE,parameters:{}}:a.errorMessage={entry:M.NODE_SHOULD_HAVE_VALUE,parameters:{}},n.push(a)}}else{var o=new S.ASTNodeImpl(e,t,u,s),l=s.domain().key();"body"!=s.nameId()||l!=b.Universe08.MethodBase&&l!=b.Universe10.MethodBase||o.setComputed("form","true"),o._allowQuestion=r,J.push(o)}});J.length>0?J.forEach(function(e){return K.push(e)}):X.forEach(function(e){return K.push(e)})}else K.push(new S.ASTNodeImpl(e,t,u,s));t._children=t._children.concat(K),t._mergedChildren=null,n=n.concat(K),K.forEach(function(e){var n=f(s,t,e);n&&n!=e.definition()&&e.patchType(n),e._associatedDef=null,s.childRestrictions().forEach(function(t){e.setComputed(t.name,t.value)});e.definition()})}else E.LowLevelCompositeNode.isInstance(e)&&null==e.primaryNode()||n.push(new S.BasicASTNode(e,t))});var p=t.reusedNode();if(p&&t.lowLevel().valueKind()!=v.Kind.SEQ){var c={};p.elements().forEach(function(e){return c[e.property().nameId()+"_"+e.lowLevel().key()]=e}),p.attrs().forEach(function(e){return c[e.property().nameId()+"_"+e.lowLevel().key()]=e}),n.filter(function(e){return e.isElement()||e.isAttr()}).forEach(function(e){var n=c[e.property().nameId()+"_"+e.lowLevel().key()];n&&n!=e&&e.isElement()&&e.lowLevel().parent().valueKind()!=v.Kind.SEQ&&(e.setReusedNode(n),e.setReuseMode(t.reuseMode()))})}return n},e}();t.BasicNodeBuilder=L,t.doDescrimination=c;var P=function(e){for(var t=!1,n=e;n;){var r=n.definition();if(N.isTraitType(r)||N.isResourceTypeType(r)){t=!0;break}n=n.parent()}return t}},function(e,t,n){"use strict";function r(e){if(!T.BasicNodeImpl.isInstance(e))return null;var t=e,n=i(t.highLevel());if(!n)return null;var r=n.wrapperNode();return r.setAttributeDefaults(t.getDefaultsCalculator().isEnabled()),r}function i(e){if(null==e)return null;var t=e.definition();if(!t||!w.isApiSibling(t))return null;var n=(new I).expandTraitsAndResourceTypes(e);return n}function a(e){if(!e)return null;var t=o(e.highLevel());if(!t)return null;var n=t.wrapperNode();return n.setAttributeDefaults(e.getDefaultsCalculator().isEnabled()),n}function o(e){return(new R).expandLibraries(e)}function s(e,t,n){var r=h.fromUnit(e);if(!r)throw new Error("couldn't load api from "+e.absolutePath());if(!t||0==t.length)return r.asElement();
for(var i=[],a=0;a<t.length;a++){var o=t[a],s=h.fromUnit(o);if(!s)throw new Error("couldn't load api from "+o.absolutePath());i.push(s)}var l=u(r.asElement(),i,n);return l}function u(e,t,n,r,i){void 0===r&&(r=null),void 0===i&&(i=!1);for(var a,o=e,s=0,u=t;s<u.length;s++){var l=u[s];i&&g.LowLevelProxyNode.isInstance(o.lowLevel())&&(a||(a=new I),a.expandHighLevelNode(o,r,e,i)),l.overrideMaster(o),l.setMergeMode(n),o=l}return o}function l(e){for(var t=[],n=0,r=e;n<r.length;n++){var i=r[n];p(t,i,!0)}return t}function p(e,t,n){void 0===n&&(n=!1);var r=n?e:e.concat([]),i=t.lowLevel().unit();if(null==i)return r;if(0==r.length)r.push(i);else{var a=r[r.length-1].absolutePath();i.absolutePath()!=a&&r.push(i)}return r}function c(e){for(var t=[];e;)t.push(e),e=e.parent();return l(t)}function f(){return L.map(function(e){return e.name})}function d(e){for(var t=[],n=e.split("|").slice(1),r=0,i=n;r<i.length;r++)for(var a=i[r],o=0;o<L.length;o++)if(a.match(L[o].regexp)){t.push(L[o].transformer);break}return t}var m=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},h=n(16),y=n(73),v=n(33),g=n(41),A=n(77),S=n(18),E=n(65),T=n(49),b=n(53),N=n(51),_=n(39),w=n(14),M=n(78);t.expandTraitsAndResourceTypes=r,t.expandTraitsAndResourceTypesHL=i,t.expandLibraries=a,t.expandLibrariesHL=o,t.mergeAPIs=s;var I=function(){function e(){this.namespaceResolver=new N.NamespaceResolver}return e.prototype.expandTraitsAndResourceTypes=function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1),this.init(e);var r=e.lowLevel();if(!r)return e;if(r.actual().libExpanded)return e;var i=e.lowLevel().unit(),a=this.createHighLevelNode(e,!1,t);if(e.definition().key()==S.Universe10.Overlay)return a;var o=i.project().namespaceResolver().hasFragments(i),s=this.expandHighLevelNode(a,t,e,o);return s?s:e},e.prototype.init=function(e){this.ramlVersion=e.definition().universe().version()},e.prototype.expandHighLevelNode=function(e,t,n,r){var i=this;void 0===r&&(r=!1),this.init(e),e.setMergeMode(n.getMergeMode());var a=e.elementsOfKind("resources"),o=!1;if(a.forEach(function(e){return o=i.processResource(e)||o}),!o&&!r)return null;if(h.ASTNodeImpl.isInstance(e)){var s=e;null!=s.reusedNode()&&s.setReuseMode(!0)}return"RAML10"==this.ramlVersion&&(t=t||new b.ReferencePatcher,t.process(e),e.lowLevel().actual().referencePatcher=t),e},e.prototype.getTemplate=function(e,t,n,r){var i=t.lowLevel().unit().path(),a=n[i];a||(a={},n[i]=a);var o=a[e];return void 0!==o?o:(o=null,o=E.find(r,function(n){return h.qName(n.highLevel(),t)==e}),o||(o=null),a[e]=o,o)},e.prototype.createHighLevelNode=function(e,t,n,r){void 0===t&&(t=!0),void 0===n&&(n=null),void 0===r&&(r=!1);for(var i=e,a=[],o=i;o;){var s,l=o.lowLevel();i.definition().key()!=S.Universe10.Overlay||r?(g.LowLevelCompositeNode.isInstance(l)&&(l=l.originalNode().originalNode()),s=new g.LowLevelCompositeNode(l,null,null,this.ramlVersion)):s=l;var p=o.definition(),c=new h.ASTNodeImpl(s,null,p,null);if(c.setUniverse(o.universe()),a.push(c),!t)break;o=o.getMaster()}var f=a.pop();a=a.reverse();var d=i.getMergeMode(),m=u(f,a,d,n,r);return m.setReusedNode(i.reusedNode()),m},e.prototype.processResource=function(e,t){var n=this;void 0===t&&(t=[]);var r=!1,i=t.concat(e),a=this.collectResourceData(e,e,void 0,void 0,i),o=e.lowLevel();if(!g.LowLevelProxyNode.isInstance(o))return r;o.preserveAnnotations(),o.takeOnlyOriginalChildrenWithKey(_.universesInfo.Universe10.ResourceBase.properties.type.name),o.takeOnlyOriginalChildrenWithKey(_.universesInfo.Universe10.FragmentDeclaration.properties.uses.name),a.filter(function(e){return null!=e.resourceType}).forEach(function(t){var n=t.resourceType.node.lowLevel(),i=t.resourceType.transformer;i.owner=e,o.adopt(n,i),r=!0});var s=e.elementsOfKind("methods");s.forEach(function(e){var t=e.lowLevel();g.LowLevelCompositeNode.isInstance(t)&&t.takeOnlyOriginalChildrenWithKey(_.universesInfo.Universe10.FragmentDeclaration.properties.uses.name);var n=e.attr("method").value(),i=[];a.forEach(function(a){var o=a.methodTraits[n];o&&(i=i.concat(o),o.forEach(function(n){var i=n.node.lowLevel(),a=n.transformer;a.owner=e,t.adopt(i,a),r=!0}));var s=a.traits;s&&(i=i.concat(s),s.forEach(function(n){var i=n.node.lowLevel(),a=n.transformer;a.owner=e,t.adopt(i,a),r=!0}))})});var u=e.elementsOfKind("resources");return u.forEach(function(e){return r=n.processResource(e,i)||r}),r},e.prototype.collectResourceData=function(e,t,n,r,i,a){var o=this;void 0===n&&(n=[]),void 0===i&&(i=[]),void 0===a&&(a={}),i=i.concat([t]);var s=this.extractTraits(t,r,i),u={},p=t.elementsOfKind("methods");p.forEach(function(e){var t=o.extractTraits(e,r,i);t&&t.length>0&&(u[e.attr("method").value()]=t)});var c,f=t.attr("type");if(null!=f){var d=l(i);c=this.readGenerictData(e,f,t,"resource type",r,d)}var m={resourceType:c,traits:s,methodTraits:u};if(n.push(m),c){var y=c.node,v=h.qName(y,e);a[v]?m.resourceType=null:(a[v]=!0,this.collectResourceData(e,y,n,c.transformer,i,a))}return n},e.prototype.extractTraits=function(e,t,n,r){var i=this;void 0===r&&(r={}),n=n.concat([e]);for(var a=[],o=-1;o<a.length;o++){var s=0>o?null:a[o],u=s?s.node:e,c=s?s.unitsChain:l(n),f=s?s.transformer:t;u.attributes("is").forEach(function(t){var n=p(c,t),o=i.readGenerictData(e,t,u,"trait",f,n);if(o){var s=o.name;r[s]=!0,a.push(o)}})}return a},e.prototype.readGenerictData=function(e,t,n,r,i,a){void 0===a&&(a=[]);var o,s,u=t.value(),l=A.plural(M.camelCase(r));if("string"==typeof u)s=u;else{if(!h.StructuredValue.isInstance(u))return null;o=u,s=o.valueName()}i&&(s=i.transform(s).value);var p={},c={},f=b.getDeclaration(s,l,this.namespaceResolver,a);if(f){var d=new D(e,null,a);o&&("RAML08"==this.ramlVersion?o.children().forEach(function(e){return p[e.valueName()]=e.lowLevel().value()}):o.children().forEach(function(e){var t=e.lowLevel();t.valueKind()==y.Kind.SCALAR?p[e.valueName()]=t.value():t.valueKind()==y.Kind.INCLUDE_REF&&0==t.children().length?p[e.valueName()]=t.value():c[e.valueName()]=t}),Object.keys(p).forEach(function(e){var t=d.transform(p[e]);t&&"object"!=typeof t&&(p[e]=t)}));var m=new O(r,s,a,p,c,i),v=new D(null,m,a);return{name:s,transformer:v,parentTransformer:i,node:f,ref:t,unitsChain:a}}return null},e}();t.TraitsAndResourceTypesExpander=I;var R=function(){function e(){}return e.prototype.expandLibraries=function(e){var t=e;if(null==t)return null;g.LowLevelCompositeNode.isInstance(t.lowLevel())&&(t=t.lowLevel().unit().highLevel().asElement());var n=new I,r=new b.ReferencePatcher,i=n.createHighLevelNode(t,!0,r,!0),a=n.expandHighLevelNode(i,r,t,!0);return this.processNode(r,a),a},e.prototype.processNode=function(e,t){if(null!=t){var n=t.getMaster();this.processNode(e,n),w.isOverlayType(t.definition())&&e.process(t),e.expandLibraries(t)}},e}();t.LibraryExpander=R,t.toUnits=c;var C=function(){function e(t,n){this.name=t,this.regexp=new RegExp(e.leftTransformRegexp.source+t+e.rightTransformRegexp.source),this.transformer=n}return e.leftTransformRegexp=/\s*!\s*/,e.rightTransformRegexp=/\s*$/,e}(),L=[new C("singularize",function(e){return A.singular(e)}),new C("pluralize",function(e){return A.plural(e)}),new C("uppercase",function(e){return e?e.toUpperCase():e}),new C("lowercase",function(e){return e?e.toLowerCase():e}),new C("lowercamelcase",function(e){return e?M.camelCase(e):e}),new C("uppercamelcase",function(e){if(!e)return e;var t=M.camelCase(e);return t[0].toUpperCase()+t.substring(1,t.length)}),new C("lowerunderscorecase",function(e){if(!e)return e;var t=M.snake(e);return t.toLowerCase()}),new C("upperunderscorecase",function(e){if(!e)return e;var t=M.snake(e);return t.toUpperCase()}),new C("lowerhyphencase",function(e){if(!e)return e;var t=M.param(e);return t.toLowerCase()}),new C("upperhyphencase",function(e){if(!e)return e;var t=M.param(e);return t.toUpperCase()})];t.getTransformNames=f,t.getTransformersForOccurence=d;var P=function(){function e(){this.buf=null}return e.prototype.append=function(e){""!==e&&(null!=this.buf?null!=e&&("string"!=typeof this.buf&&(this.buf=""+this.buf),this.buf+=e):""!==e&&(this.buf=e))},e.prototype.value=function(){return null!=this.buf?this.buf:""},e}(),O=function(){function e(e,t,n,r,i,a){this.templateKind=e,this.templateName=t,this.unitsChain=n,this.params=r,this.structuredParams=i,this.vDelegate=a}return e.prototype.transform=function(e,t,n,r){var i={},a=[];if("string"==typeof e){if(this.structuredParams&&v.stringStartsWith(e,"<<")&&v.stringEndsWith(e,">>")){var o=e.substring(2,e.length-2),s=this.structuredParams[o];if(null!=s)return{value:s,errors:a}}for(var u=e,l=new P,p=0,c=u.indexOf("<<");c>=0;c=u.indexOf("<<",p)){l.append(u.substring(p,c));var f=c;if(c+="<<".length,p=this.paramUpperBound(u,c),-1==p)break;var m=u.substring(c,p);p+=">>".length;var h,o,y=u.substring(f,p),g=d(m);if(g.length>0){var A=m.indexOf("|");if(o=m.substring(0,A).trim(),h=this.params[o],h&&"string"==typeof h&&h.indexOf("<<")>=0&&this.vDelegate&&(h=this.vDelegate.transform(h,t,n,r).value),h){b.PatchedReference.isInstance(h)&&(h=h.value());for(var S=0,E=g;S<E.length;S++){var T=E[S];h=T(h)}}}else o=m.trim(),h=this.params[o],h&&"string"==typeof h&&h.indexOf("<<")>=0&&this.vDelegate&&(h=this.vDelegate.transform(h,t,n,r).value);(null===h||void 0===h)&&(i[o]=!0,h=y),l.append(h)}return l.append(u.substring(p,u.length)),{value:l.value(),errors:a}}return{value:e,errors:a}},e.prototype.paramUpperBound=function(e,t){for(var n=0,r=t;r<e.length;r++)if(v.stringStartsWith(e,"<<",r))n++,r++;else if(v.stringStartsWith(e,">>",r)){if(0==n)return r;n--,r++}return e.length},e.prototype.children=function(e){var t=this.substitutionNode(e);return t?t.children():null},e.prototype.valueKind=function(e){var t=this.substitutionNode(e);return t?t.valueKind():null},e.prototype.includePath=function(e){var t=this.substitutionNode(e);return t?t.includePath():null},e.prototype.substitutionNode=function(e){var t=this.paramName(e);return t&&this.structuredParams[t]},e.prototype.paramName=function(e){var t=null;if(e.valueKind()==y.Kind.SCALAR){var n=(""+e.value()).trim();v.stringStartsWith(n,"<<")&&v.stringEndsWith(n,">>")&&(t=n.substring(2,n.length-2))}return t},e}();t.ValueTransformer=O;var D=function(e){function t(t,n,r){e.call(this,null!=n?n.templateKind:"",null!=n?n.templateName:"",r),this.owner=t,this.delegate=n}return m(t,e),t.prototype.transform=function(t,n,r,i){if(null==t||null!=r&&!r())return{value:t,errors:[]};var a={value:t,errors:[]},o=!1;x.forEach(function(e){return o=o||t.toString().indexOf("<<"+e)>=0}),o&&(this.initParams(),a=e.prototype.transform.call(this,t,n,r,i));var s=null!=this.delegate?this.delegate.transform(a.value,n,r,i):a.value;return null!=r&&r()&&null!=i&&(s.value=i(s.value,this)),s},t.prototype.initParams=function(){for(var e,t,n="",r=this.owner.lowLevel(),i=r,a=null;i;){var o=i.key();if(null!=o)if(v.stringStartsWith(o,"/")){if(!t)for(var s=o.split("/"),u=s.length-1;u>=0;u--){var l=s[u];if(-1==l.indexOf("{")){t=s[u];break}l.length>0&&(a=l)}n=o+n}else e=o;i=i.parent()}t||a&&(t=""),this.params={resourcePath:n,resourcePathName:t},e&&(this.params.methodName=e)},t.prototype.children=function(e){return null!=this.delegate?this.delegate.children(e):null},t.prototype.valueKind=function(e){return null!=this.delegate?this.delegate.valueKind(e):null},t.prototype.includePath=function(e){return null!=this.delegate?this.delegate.includePath(e):null},t}(O);t.DefaultTransformer=D;var x=["resourcePath","resourcePathName","methodName"]},function(e,t,n){"use strict";function r(e){return a.isWebPath(e)}var i=n(15),a=n(10),o=n(25),s=function(){function e(e){this.unit=e}return e.prototype.contextPath=function(){if(!this.unit)return"";var e=this.unit.absolutePath();return e||""},e.prototype.normalizePath=function(e){if(!e)return e;var t;if(r(e)){var n=0===e.toLowerCase().indexOf("https")?"https://":"http://";t=n+i.normalize(e.substring(n.length)).replace(/\\/g,"/")}else t=i.normalize(e).replace(/\\/g,"/");return t},e.prototype.content=function(e){var t=this.normalizePath(e),n=this.toRelativeIfNeeded(t),r=this.unit.resolve(n);return r?r.contents()||"":""},e.prototype.contentAsync=function(e){var t=this.normalizePath(e),n=this.toRelativeIfNeeded(t),r=this.unit.resolveAsync(n);if(!r)return Promise.resolve("");var i=r.then(function(e){return e&&e.contents()||""});return i},e.prototype.toRelativeIfNeeded=function(e){var t=e;return i.isAbsolute(e)&&!r(e)&&(t=i.relative(i.dirname(this.unit.absolutePath()),e)),t},e.prototype.hasAsyncRequests=function(){return o.hasAsyncRequests()},e.prototype.resolvePath=function(e,t){return a.buildPath(t,e,this.unit.project().getRootPath())},e.prototype.isAbsolutePath=function(e){return e?r(e)?!0:i.isAbsolute(e):!1},e.prototype.promiseResolve=function(e){return Promise.resolve(e)},e}();t.ContentProvider=s},function(e,t,n){"use strict";function r(e,t){return new w(t).dump(e)}function i(e,t,n,r,i){if(!t)return e;var a={};e&&e.arr.forEach(function(e){var t=a[e.name()];t||(t=[],a[e.name()]=t),t.push(e)});for(var o=new M(r),s=0,u={},l=!1,p=t.indexOf("{");p>=0&&(s=t.indexOf("}",++p),!(0>s));p=t.indexOf("{",s)){var f=t.substring(p,s);if(u[f]=!0,a[f])a[f].forEach(function(e){o.registerValue(e),o.registerMeta(null)});else{l=!0;var d=n.definition().universe(),m=d.type(v.Universe10.StringTypeDeclaration.name),h=E.createStubNode(m,null,f,n.lowLevel().unit());if(h.setParent(n),h.attrOrCreate("name").setValue(f),h.patchProp(r),o.registerValue(h),i){o.hasMeta=!0;var y=new c.NodeMetadataImpl;y.setCalculated(),o.registerMeta(y)}}}return l?(Object.keys(a).filter(function(e){return!u[e]}).forEach(function(e){return a[e].forEach(function(e){o.registerValue(e),o.hasMeta&&o.registerMeta(null)})}),o):e}function a(e,t,n,r){if(0==t.length)return null;var i=e.lowLevel().unit().absolutePath(),a=new M(n);return t.forEach(function(e){if(a.registerValue(e),r)if(e.lowLevel().unit().absolutePath()!=i){a.hasMeta=!0;var t=new c.NodeMetadataImpl;t.setCalculated(),a.mArr.push(t)}else a.mArr.push(null)}),a}function o(e,t,n,r){var i;if(e.isElement())i=e.asElement().definition();else if(e.isAttr()){var a=e.asAttr().property();a&&(i=a.range())}if((i instanceof d.UserDefinedClass||i.isUserDefined())&&(i=T.find(i.allSuperTypes(),function(e){return!e.isUserDefined()})),null==i)return n;var o=i.universe().version(),s=r[o];if(!s)return n;var u=s[i.nameId()];if(!u)return n;var l=t?t.nameId():"__$$anyprop__",p=u[l];if(p||(p=u.__$$anyprop__),!p)return n;for(var c=0,f=p;c<f.length;c++){var m=f[c];n=m.transform(n,e)}return n}function s(e,t){for(var n=0,r=e;n<r.length;n++){var i=r[n],a=i.registrationInfo();if(a)for(var o=0,s=Object.keys(a);o<s.length;o++){var u=s[o],l=a[u],p=t[u];null==p&&(p={},t[u]=p);for(var c=0,f=Object.keys(l);c<f.length;c++){var d=f[c],m=l[d],h=p[d];null==h&&(h={},p[d]=h);for(var y=0,v=Object.keys(m);y<v.length;y++){var g=v[y],A=h[g];if(null==A){if(A=[],"__$$anyprop__"!=g){var S=h.__$$anyprop__;S&&(A=A.concat(S))}h[g]=A}if("__$$anyprop__"==g)for(var E=0,T=Object.keys(h);E<T.length;E++){var b=T[E];h[b].push(i)}else A.push(i)}}}}}function u(e){if(0==e.length)return{};for(var t=e[0],n=1;n<e.length;n++){var r=e[n];t=l(t,r)}return t}function l(e,t){for(var n=0,r=Object.keys(t);n<r.length;n++){var i=r[n],a=e[i],o=t[i];null==a?e[i]=o:"object"==typeof a&&"object"==typeof o&&(e[i]=l(a,o))}return e}var p=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},c=n(49),f=n(41),d=n(39),m=n(16),h=n(29),y=n(14),v=n(18),g=n(33),A=n(57),S=n(58),E=n(17),T=n(65),b=n(15),N="application/raml+yaml";t.dump=r;var _=function(e){var t,n=e.root();if(n){var r=n.lowLevel();if(r){var i=r.unit();i&&(t=i.absolutePath())}}return t},w=function(){function e(e){this.options=e,this.nodePropertyTransformers=[new $,new G,new X,new J,new z,new Q,new j,new Z,new te,new ee,new ne],this.nodeTransformersMap={},this.nodePropertyTransformersMap={},this.options=this.options||{},null==this.options.serializeMetadata&&(this.options.serializeMetadata=!0),null==this.options.attributeDefaults&&(this.options.attributeDefaults=!0),this.defaultsCalculator=new A.AttributeDefaultsCalculator(!0,!0),this.nodeTransformers=[new F,new B(this.options.dumpXMLRepresentationOfExamples),new K,new V,new W,new q,new Y,new re,new H(this.options.allUriParameters)],s(this.nodeTransformers,this.nodeTransformersMap),s(this.nodePropertyTransformers,this.nodePropertyTransformersMap)}return e.prototype.init=function(e){this.helpersMap={baseUriParameters:I,uriParameters:R};var t=e.isElement();if(t){var n=e.asElement(),r=n.definition();if("RAML08"==r.universe().version()&&y.isApiType(r)){var i={};n.elementsOfKind(v.Universe08.Api.properties.schemas.name).forEach(function(e){return i[e.name()]=e}),this.helpersMap.schemaContent=new L(i)}y.isApiSibling(r)&&(this.helpersMap.traits=new C(S.allTraits(n,!1)),this.helpersMap.resourceTypes=new C(S.allResourceTypes(n,!1)))}},e.prototype.dispose=function(){delete this.helpersMap},e.prototype.dump=function(e){this.init(e);var t=e.isElement(),n=e.parent(),r=!n&&this.options.rootNodeDetails,i=_(e),a=this.dumpInternal(e,null,i,null,!0);if(r){var o=a;if(a={},a.specification=o,t){var s=e.asElement(),u=s.definition();if(u){var l=u.universe().version();a.ramlVersion=l,a.type=u.nameId()}a.errors=this.dumpErrors(c.errors(s))}}return this.dispose(),a},e.prototype.dumpInternal=function(e,t,n,r,i){var a=this;if(void 0===i&&(i=!1),null==e)return null;if(e.isReused()){var s=e.getJSON();if(null!=s)return s}var u={};if(e.isElement()){var l={},p=e.asElement(),f=p.definition();if(y.isExampleSpecType(f))if(null!=p.parent())u="";else{var E=m.auxiliaryTypeForExample(p),N=S.dumpExpandableExample(E.examples()[0],this.options.dumpXMLRepresentationOfExamples),_=p.elementsOfKind("uses").map(function(e){return a.dumpInternal(e,e.property(),n)});_.length>0&&(N.uses=_),u=N}else{for(var w={},I=p.attrs().concat(p.children().filter(function(e){return!e.isAttr()})),R=0,C=I;R<C.length;R++){var L=C[R],P=L.property();if(null!=P){var O=P.nameId(),D=l[O];null==D&&(D=new M(P),l[O]=D),D.registerValue(L)}else var x=L.lowLevel(),U=x.key()}for(var k={},F=0,B=f.allProperties().concat(f.allCustomProperties());F<B.length;F++){var K=B[F];if(!d.UserDefinedProp.isInstance(K)){var O=K.nameId();if(i||"uses"!=O||!y.isApiSibling(p.root().definition())){var D=l[O];if(y.isTypeProperty(K)){if(l.schema){var V=null==D;!V&&1==D.arr.length&&D.arr[0].isAttr()&&(V=null==D.arr[0].asAttr().value()),V&&(r=r||new c.NodeMetadataImpl,r.registerInsertedAsDefaultValue("type"));continue}if(y.isStringTypeDeclarationDescendant(f)){if(null==D){u.type="string",r=r||new c.NodeMetadataImpl,r.registerInsertedAsDefaultValue("type");continue}if(1==D.arr.length&&D.arr[0].isAttr()){var j=D.arr[0].asAttr().value();if(null==j){u.type="string",r=r||new c.NodeMetadataImpl,r.registerInsertedAsDefaultValue("type");continue}if("NULL"===j||"Null"===j){u.type="string";continue}}}}D=this.applyHelpers(D,p,K,this.options.serializeMetadata);var W=w[O],q=void 0;if(void 0!==D){if(D.isMultiValue){if(q=D.arr.map(function(e,t){var r=D.hasMeta?D.mArr[t]:null;return a.dumpInternal(e,D.prop,n,r)}),K.isValueProperty()){var Y=[],H=!1;D.arr.filter(function(e){return e.isAttr()}).map(function(e){return e.asAttr()}).filter(function(e){return e.isAnnotatedScalar()}).forEach(function(e){var t=e.annotations().map(function(e){return a.dumpInternal(e,null,n)});H=H||t.length>0,Y.push(t)}),H&&(k[O]=Y)}y.isTypeDeclarationDescendant(f)&&y.isTypeProperty(K)&&D.arr.map(function(e){return e.value()}).filter(function(e){return m.isStructuredValue(e)}).length>0&&(q=q[0])}else if(q=this.dumpInternal(D.val,D.prop,n),K.isValueProperty()){var $=D.val.asAttr();if($.isAnnotatedScalar()){var Y=$.annotations().map(function(e){return a.dumpInternal(e,null,n)});Y.length>0&&(k[O]=Y)}}}else if(void 0!==W)q=W;else if(this.options.attributeDefaults){var G=this.defaultsCalculator.attributeDefaultIfEnabled(p,K);if(null!=G){r=r||new c.NodeMetadataImpl,Array.isArray(G)?G=G.map(function(e){return m.isASTPropImpl(e)?a.dumpInternal(e,K,n):e}):m.isASTPropImpl(G)&&(G=this.dumpInternal(G,K,n)),q=G,null!=q&&K.isMultiValue()&&!Array.isArray(q)&&(q=[q]);var X=this.defaultsCalculator.insertionKind(p,K);X==A.InsertionKind.CALCULATED?r.registerCalculatedValue(O):X==A.InsertionKind.BY_DEFAULT&&r.registerInsertedAsDefaultValue(O)}}if(q=o(p,K,q,this.nodePropertyTransformersMap),null!=q){if(("type"===O||"schema"==O)&&q&&q.forEach&&"string"==typeof q[0]){var z=q[0].trim(),J="{"===z[0]&&"}"===z[z.length-1],Q="<"===z[0]&&">"===z[z.length-1];if(J||Q){var Z=p.lowLevel().includePath&&p.lowLevel().includePath();if(!Z){var ee=p.attr("type");ee||(ee=p.attr("schema")),ee&&(Z=ee.lowLevel().includePath&&ee.lowLevel().includePath())}if(Z){var te=Z.indexOf("#"),ne="";te>=0&&(ne=Z.substring(te),Z=Z.substring(0,te));var re,ie=p.lowLevel().unit().resolve(Z).absolutePath();re=g.stringStartsWith(ie,"http://")||g.stringStartsWith(ie,"https://")?ie:b.relative(p.lowLevel().unit().project().getRootPath(),ie),re=re.replace(/\\/g,"/"),u.schemaPath=re+ne}}}u[O]=q}}}}if(this.options.dumpSchemaContents&&l.schema&&l.schema.prop.range().key()==v.Universe08.SchemaString){var ae=p.root().elementsOfKind("schemas");ae.forEach(function(e){if(e.name()==u.schema){var t=e.attr("value");t&&(u.schema=t.value(),u.schemaContent=t.value())}})}this.options.serializeMetadata&&this.serializeMeta(u,p,r),Object.keys(k).length>0&&(u.scalarsAnnotations=k);var oe=S.getTemplateParametrizedProperties(p);if(oe&&(u.parametrizedProperties=oe),y.isTypeDeclarationDescendant(f)){var se=S.typeFixedFacets(p);se&&(u.fixedFacets=se)}u=o(p,t||p.property(),u,this.nodeTransformersMap)}}else if(e.isAttr()){var ue,le=e.asAttr(),ue=le.value(),P=le.property(),pe=P.range(),ce=pe.isValueType();if(ce&&le.value&&(ue=le.value()),null==ue||"number"!=typeof ue&&"string"!=typeof ue&&"boolean"!=typeof ue){if(m.isStructuredValue(ue)){var fe=ue,x=fe.lowLevel();ue=x?x.dumpToObject():null;var de=P.nameId();if(pe.isAssignableFrom("Reference")){var U=Object.keys(ue)[0],me=fe.valueName(),he=ue[U];void 0===he&&(he=null),ue={name:me,structuredValue:he}}else if("type"==de){var x=le.lowLevel(),ye=d.getUniverse("RAML10").type(v.Universe10.TypeDeclaration.name),ve=d.getUniverse("RAML10").type(v.Universe10.LibraryBase.name),ge=new m.ASTNodeImpl(x,le.parent(),ye,ve.property(v.Universe10.LibraryBase.properties.types.name));ge.patchType(h.doDescrimination(ge)),ue=this.dumpInternal(ge,t||le.property(),n,null,!0)}else if("items"==de&&"object"==typeof ue){var Ae=Array.isArray(ue),Se=!Ae;if(Ae&&(Se=null!=T.find(ue,function(e){return"object"==typeof e})),Se){ue=null;var Ee=e.parent().lowLevel();Ee.children().forEach(function(e){if("items"==e.key()){var r=d.getUniverse("RAML10").type(v.Universe10.TypeDeclaration.name),i=d.getUniverse("RAML10").type(v.Universe10.LibraryBase.name),o=new m.ASTNodeImpl(e,le.parent(),r,i.property(v.Universe10.LibraryBase.properties.types.name));o.patchType(h.doDescrimination(o)),ue=a.dumpInternal(o,t||le.property(),n,null,!0),de=e.key()}})}}}ue=o(le,t||le.property(),ue,this.nodeTransformersMap),u=ue}else u=ue}else{var x=e.lowLevel();u=x?x.dumpToObject():null}return e.setJSON(u),u},e.prototype.getDefaultsCalculator=function(){return this.defaultsCalculator},e.prototype.canBeFragment=function(e){var t=e.definition(),n=[t].concat(t.allSubTypes()),r=n.filter(function(e){return e.getAdapter(d.RAMLService).possibleInterfaces().filter(function(e){return e.nameId()==d.universesInfo.Universe10.FragmentDeclaration.name}).length>0});return r.length>0},e.prototype.dumpErrors=function(e){var t=this;return e.map(function(e){var n=t.dumpErrorBasic(e);return e.trace&&e.trace.length>0&&(n.trace=t.dumpErrors(e.trace)),n}).sort(function(e,t){return e.path!=t.path?e.path.localeCompare(t.path):e.range.start.position!=t.range.start.position?e.range.start.position-t.range.start.position:e.code-t.code})},e.prototype.dumpErrorBasic=function(e){var t={code:e.code,message:e.message,path:e.path,line:e.line,column:e.column,position:e.start,range:e.range};return e.isWarning===!0&&(t.isWarning=!0),t},e.prototype.serializeMeta=function(e,t,n){if(this.options.serializeMetadata){var r=t.definition(),i=y.isMethodType(r)&&t.optional();if(n||i){var a=n||new c.NodeMetadataImpl(!1,!1);i&&a.setOptional(),e.__METADATA__=a.toJSON()}}},e.prototype.applyHelpers=function(e,t,n,r){var i=n.nameId(),a=this.helpersMap[i];if(!a)return e;var o=a.apply(t,e,n,r);return o?o:e},e}();t.TCKDumper=w;var M=function(){function e(e){this.prop=e,this.arr=[],this.mArr=[],this.isMultiValue=e.isMultiValue()}return e.prototype.registerValue=function(e){this.isMultiValue?this.arr.push(e):this.val=e},e.prototype.registerMeta=function(e){this.isMultiValue&&this.mArr.push(e)},e}(),I={apply:function(e,t,n,r){var a=e.attr(v.Universe10.Api.properties.baseUri.name),o=a?a.value():"";return i(t,o,e,n,r)}},R={apply:function(e,t,n,r){var a=e.attr(v.Universe10.Resource.properties.relativeUri.name);if(!a)return t;var o=a.value();return i(t,o,e,n,r)}},C=function(){function e(e){this.arr=e}return e.prototype.apply=function(e,t,n,r){return a(e,this.arr,n,r)},e}(),L=function(){function e(e){this.schemasCache08=e}return e.prototype.apply=function(e,t,n,r){var i=null,a=S.schemaContent08Internal(e,this.schemasCache08);return a&&(i=new M(n),i.registerValue(a)),i},e}();t.applyTransformersMap=o;var P=function(){function e(){}return e.prototype.match=function(e,t){if(null==e)return!1;var n=this.registrationInfo(),r=e.universe().version();if((e instanceof d.UserDefinedClass||e.isUserDefined())&&(e=T.find(e.allSuperTypes(),function(e){return!e.isUserDefined()}),null==e))return null==t;var i=n[r];if(!i)return!1;var a=i[e.nameId()];if(!a)return!1;var o=null==t||a[t.nameId()]===!0||a.__$$anyprop__===!0;return o},e}(),O=function(e){function t(t,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=["RAML10","RAML08"]),e.call(this),this.typeName=t,this.propName=n,this.applyToDescendatns=r,this.restrictToUniverses=i}return p(t,e),t.prototype.registrationInfo=function(){var e=this;if(this.regInfo)return this.regInfo;for(var t={},n=[],r=0,i=this.restrictToUniverses;r<i.length;r++){var a=i[r],o={};t[a]=o,n.push(o)}for(var s=0,u=Object.keys(t);s<u.length;s++){var a=u[s],l=d.getUniverse(a).type(this.typeName);if(l){var p=t[a],c=[this.typeName];this.applyToDescendatns&&l.allSubTypes().forEach(function(e){return c.push(e.nameId())});for(var f=0,m=c;f<m.length;f++){var h=m[f],y={};null!=this.propName?y[this.propName]=!0:y.__$$anyprop__=!0,p[h]=y}}}return this.regInfo={},Object.keys(t).forEach(function(n){var r=t[n];Object.keys(r).length>0&&(e.regInfo[n]=r)}),this.regInfo},t}(P),D=function(){function e(e){this.matcher=e}return e.prototype.match=function(e,t){var n;if(e.isElement())n=e.asElement().definition();else if(e.isAttr()){var r=e.asAttr().property();r&&(n=r.range())}return n?this.matcher.match(n,t):!1},e.prototype.registrationInfo=function(){return this.matcher.registrationInfo()},e}(),x=function(e){function t(t,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=["RAML10","RAML08"]),e.call(this,new O(t,n,r,i)),this.typeName=t,this.propName=n,this.applyToDescendatns=r,this.restrictToUniverses=i}return p(t,e),t}(D),U=function(e){function t(t){e.call(this),this.matchers=t}return p(t,e),t.prototype.registrationInfo=function(){return this.regInfo?this.regInfo:(this.regInfo=u(this.matchers.map(function(e){return e.registrationInfo()})),this.regInfo)},t}(P),k=function(){function e(e,t){this.matcher=e,this.propName=t}return e.prototype.match=function(e,t){return e.isElement()&&this.matcher.match(e.asElement().definition(),t)},e.prototype.transform=function(e,t){var n=this;if(Array.isArray(e)&&e.length>0&&e[0][this.propName]){var r={};return e.forEach(function(e){var t=e["$$"+n.propName];null!=t?delete e["$$"+n.propName]:t=e[n.propName];var i=r[t];i?Array.isArray(i)?i.push(e):r[t]=[i,e]:r[t]=e}),r}return e},e.prototype.registrationInfo=function(){return this.matcher.registrationInfo()},e}(),F=function(e){function t(){e.call(this,v.Universe10.Resource.name,null,!0)}return p(t,e),t.prototype.transform=function(e,t){if(Array.isArray(e))return e;var n=e[v.Universe10.Resource.properties.relativeUri.name];if(n){for(var r=n.trim().split("/");r.length>0&&0==r[0].length;)r.shift();e.relativeUriPathSegments=r,e.absoluteUri=S.absoluteUri(t.asElement()),e.completeRelativeUri=S.completeRelativeUri(t.asElement()),y.isResourceType(t.parent().definition())?e.parentUri=S.completeRelativeUri(t.parent()):e.parentUri=""}return e},t}(x),B=function(e){function t(t){void 0===t&&(t=!1),e.call(this,v.Universe10.TypeDeclaration.name,null,!0),this.dumpXMLRepresentationOfExamples=t}return p(t,e),t.prototype.transform=function(e,t){var n=Array.isArray(e);if(n&&0==e.length)return e;var r=n?e[0]:e,i=S.typeExample(t.asElement(),this.dumpXMLRepresentationOfExamples);if(i)r.examples=[i];else{var a=S.typeExamples(t.asElement(),this.dumpXMLRepresentationOfExamples);a.length>0&&(r.examples=a)}if(delete r.example,r.hasOwnProperty("schema")){if(r.hasOwnProperty("type")){var o=r.type;Array.isArray(o)||(o=[o],r.type=o);var s=r.schema;Array.isArray(s)?s.forEach(function(e){return o.push(e)}):o.push(s)}else r.type=r.schema;delete r.schema}if(Array.isArray(r.type)||(r.type=[r.type]),1==r.type.length){var u=r.type[0];if("string"==typeof u){u=u.trim();var l=g.stringEndsWith(u,"[]");if(l){for(var p=u.substring(0,u.length-"[]".length).trim();p.length>0&&"("==p.charAt(0)&&")"==p.charAt(p.length-1);)p=p.substring(1,p.length-1);r.type[0]="array",r.items=p}}}if(r.mediaType=N,t&&t.isElement()){var c=t.asElement(),f=c.localType().isExternal()?c.localType():null;if(!f)for(var d=0,m=c.localType().allSuperTypes();d<m.length;d++){var h=m[d];h.isExternal()&&(f=h)}if(f){var v=f.external().schema().trim();g.stringStartsWith(v,"<")?r.mediaType="application/xml":r.mediaType="application/json"}}var A=t.property();if(A&&!(y.isHeadersProperty(A)||y.isQueryParametersProperty(A)||y.isUriParametersProperty(A)||y.isPropertiesProperty(A)||y.isBaseUriParametersProperty(A))){delete r.required;var E=r.__METADATA__;if(E){var T=E.primitiveValuesMeta;T&&delete T.required}}var o=r.type;if(o.forEach&&"string"==typeof o[0]){var b=t.asElement().localType();if(b&&b.hasExternalInHierarchy()){var _=o[0].trim(),w="{"===_[0]&&"}"===_[_.length-1],M="<"===_[0]&&">"===_[_.length-1];w?r.typePropertyKind="JSON":M&&(r.typePropertyKind="XML")}else r.typePropertyKind="TYPE_EXPRESSION"}else"object"==typeof o&&(r.typePropertyKind="INPLACE");return e},t}(x),K=function(e){function t(){e.call(this,new U([new O(v.Universe10.TypeDeclaration.name,v.Universe10.LibraryBase.properties.annotationTypes.name,!0,["RAML10"]),new O(v.Universe10.TypeDeclaration.name,v.Universe10.LibraryBase.properties.types.name,!0,["RAML10"]),new O(v.Universe10.Trait.name,v.Universe10.LibraryBase.properties.traits.name,!0,["RAML10"]),new O(v.Universe10.AbstractSecurityScheme.name,v.Universe10.LibraryBase.properties.securitySchemes.name,!0,["RAML10"]),new O(v.Universe10.ResourceType.name,v.Universe10.LibraryBase.properties.resourceTypes.name,!0,["RAML10"])]))}return p(t,e),t.prototype.transform=function(e,t){if(!t.parent()||!t.parent().lowLevel().libProcessed)return e;var n=t.lowLevel(),r=n.key();e.$$name=r;for(var i=n;f.LowLevelProxyNode.isInstance(i);)i=i.originalNode();var a=i.key(),o=e;return o.name=a,o.displayName==r&&(o.displayName=a),e},t}(D),V=function(e){function t(){e.call(this,new U([new O(v.Universe10.ResourceType.name,null,!0),new O(v.Universe10.Trait.name,null,!0),new O(v.Universe10.Method.name,null,!0),new O(v.Universe10.TypeDeclaration.name,null,!0)]))}return p(t,e),t.prototype.transform=function(e){if(Array.isArray(e))return e;var t=d.universesInfo.Universe10.Trait.properties.parametrizedProperties.name,n=e[t];return n&&(Object.keys(n).forEach(function(t){e[t]=n[t]}),delete e[t]),e},t}(D),j=function(e){function t(){e.call(this,new U([new O(v.Universe10.ObjectTypeDeclaration.name,v.Universe10.ObjectTypeDeclaration.properties.properties.name,!0)]),"name");
}return p(t,e),t}(k),W=function(e){function t(){e.call(this,v.Universe08.GlobalSchema.name,v.Universe08.Api.properties.schemas.name,!0,["RAML08"])}return p(t,e),t.prototype.transform=function(e){if(Array.isArray(e))return e;var t={};return t[e.key]=e.value,t},t}(x),q=function(e){function t(){e.call(this,new U([new O(v.Universe10.Api.name,v.Universe10.Api.properties.protocols.name,!0),new O(v.Universe10.MethodBase.name,v.Universe10.MethodBase.properties.protocols.name,!0)]))}return p(t,e),t.prototype.transform=function(e){return"string"==typeof e?e.toUpperCase():Array.isArray(e)?e.map(function(e){return e.toUpperCase()}):e},t}(D),Y=function(e){function t(){e.call(this,new U([new O(v.Universe10.SecuritySchemeRef.name,v.Universe10.Api.properties.securedBy.name,!0),new O(v.Universe10.TraitRef.name,v.Universe10.MethodBase.properties.is.name,!0),new O(v.Universe10.ResourceTypeRef.name,v.Universe10.ResourceBase.properties.type.name,!0)]))}return p(t,e),t.prototype.transform=function(e){return e?Array.isArray(e)?e:this.toSimpleValue(e):null},t.prototype.toSimpleValue=function(e){if("string"==typeof e)return e;var t=e.name,n=e.structuredValue;if(n){var r={};return r[t]=n,r}return t},t}(D),H=function(e){function t(t){void 0===t&&(t=!1),e.call(this,new U([new O(v.Universe10.Api.name,null,!0)])),this.enabled=t}return p(t,e),t.prototype.match=function(t,n){return this.enabled?e.prototype.match.call(this,t,n):!1},t.prototype.registrationInfo=function(){return this.enabled?e.prototype.registrationInfo.call(this):null},t.prototype.transform=function(e,n,r){var i=this,a=r,o=e[t.uriParamsPropName];if(o&&(a=[].concat(r||[]),Object.keys(o).forEach(function(e){var t=o[e];Array.isArray(t)?t.forEach(function(e){return a.push(e)}):a.push(t)})),a){e.allUriParameters=a;var s=e[t.methodsPropName];s&&Object.keys(s).forEach(function(e){return s[e].allUriParameters=a})}var u=e[t.resourcesPropName];return u&&u.forEach(function(e){return i.transform(e,null,a)}),e},t.uriParamsPropName=v.Universe10.ResourceBase.properties.uriParameters.name,t.methodsPropName=v.Universe10.ResourceBase.properties.methods.name,t.resourcesPropName=v.Universe10.Api.properties.resources.name,t}(D),$=function(e){function t(){e.call(this,new U([new O(v.Universe10.ResourceBase.name,v.Universe10.ResourceBase.properties.methods.name,!0),new O(v.Universe08.Resource.name,v.Universe08.Resource.properties.methods.name,!0),new O(v.Universe08.ResourceType.name,v.Universe08.ResourceType.properties.methods.name,!0)]),"method")}return p(t,e),t}(k),G=function(e){function t(){e.call(this,new U([new O(v.Universe10.LibraryBase.name,v.Universe10.LibraryBase.properties.types.name,!0),new O(v.Universe10.LibraryBase.name,v.Universe10.LibraryBase.properties.schemas.name,!0),new O(v.Universe10.LibraryBase.name,v.Universe10.LibraryBase.properties.annotationTypes.name,!0)]),"name")}return p(t,e),t}(k),X=function(e){function t(){e.call(this,new U([new O(v.Universe10.LibraryBase.name,v.Universe10.LibraryBase.properties.traits.name,!0),new O(v.Universe08.Api.name,v.Universe08.Api.properties.traits.name,!0)]),"name")}return p(t,e),t}(k),z=function(e){function t(){e.call(this,new U([new O(v.Universe10.LibraryBase.name,v.Universe10.LibraryBase.properties.resourceTypes.name,!0),new O(v.Universe08.Api.name,v.Universe10.Api.properties.resourceTypes.name,!0,["RAML08"])]),"name")}return p(t,e),t}(k),J=function(e){function t(){e.call(this,new U([new O(v.Universe10.LibraryBase.name,v.Universe10.LibraryBase.properties.securitySchemes.name,!0),new O(v.Universe08.Api.name,v.Universe08.Api.properties.securitySchemes.name,!0,["RAML08"])]),"name")}return p(t,e),t}(k),Q=function(e){function t(){e.call(this,new U([new O(v.Universe10.Api.name,v.Universe10.Api.properties.baseUriParameters.name,!0),new O(v.Universe10.ResourceBase.name,v.Universe10.ResourceBase.properties.uriParameters.name,!0),new O(v.Universe08.Resource.name,v.Universe08.Resource.properties.uriParameters.name,!0,["RAML08"]),new O(v.Universe10.ResourceBase.name,v.Universe10.MethodBase.properties.queryParameters.name,!0),new O(v.Universe10.MethodBase.name,v.Universe10.MethodBase.properties.queryParameters.name,!0),new O(v.Universe10.Operation.name,v.Universe10.MethodBase.properties.queryParameters.name,!0),new O(v.Universe10.Operation.name,v.Universe10.MethodBase.properties.headers.name,!0),new O(v.Universe10.MethodBase.name,v.Universe10.MethodBase.properties.headers.name,!0),new O(v.Universe08.BodyLike.name,v.Universe08.BodyLike.properties.formParameters.name)]),"name")}return p(t,e),t}(k),Z=function(e){function t(){e.call(this,new U([new O(v.Universe10.MethodBase.name,v.Universe10.MethodBase.properties.responses.name,!0)]),"code")}return p(t,e),t}(k),ee=function(e){function t(){e.call(this,new U([new O(v.Universe10.Annotable.name,v.Universe10.Annotable.properties.annotations.name,!0)]),"name")}return p(t,e),t}(k),te=function(e){function t(){e.call(this,new U([new O(v.Universe10.Response.name,v.Universe10.Response.properties.body.name),new O(v.Universe10.MethodBase.name,v.Universe10.MethodBase.properties.body.name,!0)]),"name")}return p(t,e),t}(k),ne=function(e){function t(){e.call(this,new U([new O(v.Universe10.TypeDeclaration.name,v.Universe10.TypeDeclaration.properties.facets.name,!0)]),"name")}return p(t,e),t}(k),re=function(e){function t(){e.call(this,new U([new O(v.Universe10.LibraryBase.name,null,!0,["RAML10"])]))}return p(t,e),t.prototype.transform=function(e,t){if(!e)return e;if(!e.hasOwnProperty("schemas"))return e;var n=e.schemas;if(e.hasOwnProperty("types")){var r=e.types;Object.keys(n).forEach(function(e){r.hasOwnProperty(e)||(r[e]=n[e])})}else e.types=n;return delete e.schemas,e},t}(D);t.mergeRegInfos=u},function(e,t,n){"use strict";function r(e){var t={};return e.forEach(function(e){return Object.keys(e).forEach(function(n){return t[n]=e[n]})}),t}function i(e,t){return new N(b.find(e||[],t))}function a(e){return Object.keys(e).map(function(t){return[t,e[t]]})}function o(e){var t={};return e.forEach(function(e){return t[e[0]]=e[1]}),t}function s(e,t){return t(e),e}function u(e,t){"object"==typeof e&&Object.keys(e).forEach(function(n){return t(n,e[n])})}function l(e,n,r){void 0===r&&(r=!1);var i={};return e.forEach(function(e){var a=t.shallowCopy(e);r&&delete a[n],i[e[n]]=a}),i}function p(e,t){var n=e.length-t.length;return n>=0&&e.lastIndexOf(t)===n}function c(e,t,n){return void 0===n&&(n=0),e.length-t.length>=n&&e.substring(n,n+t.length)===t}function f(e){return"_"==e[e.length-1]}function d(e,t,n){var r,i=!1;e[t]=function(){return i||(i=!0,r=n.apply(e)),r}}function m(e,n){void 0===n&&(n=f);for(var r in e)n(r)&&t.ifInstanceOf(e[r],Function,function(t){return 0===t.length?d(e,r,t):null})}function h(e,t){void 0!==e&&t(e)}function y(e){return"string"!=typeof e||""==e?!1:p(e,".raml")}function v(e){for(var t,n=[],r=new RegExp("require\\('([^']+)'\\)","gi");t=r.exec(e);)n.push(t[1]);for(var i=new RegExp('require\\("([^"]+)"\\)',"gi");t=i.exec(e);)n.push(t[1]);return n=b.unique(n).filter(function(e){return""!=e}),n.sort(),n}function g(e){return"undefined"!=typeof e&&null!=e}function A(e){return 0==e.length?e:e.charAt(0).toUpperCase()+e.substr(1)}function S(e,t,n){void 0===n&&(n=!1);var r=Object.keys(t);if(n){var i={};r.forEach(function(e){return i[e]=!0}),Object.keys(e).forEach(function(e){return i[e]=!0}),r=Object.keys(i)}r.forEach(function(n){var r=e[n];r instanceof Object?(t[n]||(t[n]={}),S(r,t[n],!0)):void 0!=r&&(t[n]=e[n])})}function E(e,t){return Object.keys(t).forEach(function(n){return e=T(e,n,t[n])}),e}function T(e,t,n){for(var r="",i=0,a=e.indexOf(t);a<e.length&&a>=0;a=e.indexOf(t,i))r+=e.substring(i,a),r+=n,i=a+t.length;return r+=e.substring(i,e.length)}var b=n(65),N=n(22);t.defined=function(e){return null!==e&&void 0!==e},t.flattenArrayOfObjects=r,t.find=i,t.isInstance=function(e,t){return e instanceof t?[e]:[]},t.ifInstanceOf=function(e,t,n){return e instanceof t?n(e):null},t.toTuples=a,t.fromTuples=o,t.collectInstancesOf=function(e,n){return s([],function(r){return e.forEach(function(e){return t.ifInstanceOf(e,n,function(e){return r.push(e)})})})},t.collectInstancesOfInMap=function(e,t){return Object.keys(e).map(function(t){return[t,e[t]]}).filter(function(e){return e[1]instanceof t}).map(function(e){return e})},t.asArray=function(e){return t.defined(e)?e instanceof Array?e:[e]:[]},t.shallowCopy=function(e){return s({},function(t){return Object.keys(e).forEach(function(n){return t[n]=e[n]})})},t.flatMap=function(e,n){return t.flatten(e.map(n))},t.flatten=function(e){return Array.prototype.concat.apply([],e)},t.takeWhile=function(e,t){return s([],function(n){for(var r=0;r<e.length&&t(e[r]);r++)n.push(e[r])})},t.tap=s,t.kv=u,t.indexed=l,t.stringEndsWith=p,t.stringStartsWith=c,t.lazypropkeyfilter=f,t.lazyprops=m,t.iff=h,t.isRAMLUrl=y,t.getAllRequiredExternalModulesFromCode=v,t.serial=function(){var e=0;return function(){return e++}}(),t.isEssential=g,t.firstToUpper=A,t.updateObject=S,t.replaceMap=E,t.replace=T},function(e,t,n){"use strict";function r(e){for(var t=[],n={};null!=e.parent();)e.lowLevel().includePath()&&(t=t.concat(a(e,n))),e=e.parent();return t=t.concat(a(e,n))}function i(e){var t=e.node();if(t&&x.isParseResult(t))return t;var n=V.getNominalPropertySource2(e);return n?n.getSource():null}function a(e,t,n){if(void 0===t&&(t={}),void 0===n&&(n=[]),!e.lowLevel())return[];var r=e.lowLevel().unit().absolutePath();if(t[r]=!0,!F.ASTNodeImpl.isInstance(e))return n;var i=!1;return e.elements().forEach(function(e){if(e.definition().key()==B.Universe10.UsesDeclaration){if(i)return;var r=e.attr("value");if(r){var o=e.root().lowLevel().unit().resolve(r.value());if(o&&j.isWaitingFor(o.absolutePath()))return void(i=!0);null!=o&&o.isRAMLUnit()&&!t[o.absolutePath()]&&o.highLevel().isElement()&&a(o.highLevel().asElement(),t,n)}}else n.push(e)}),n}function o(e,t){for(var n="",r=e-1;r>=0;r--){var i=t.charAt(r);if(" "==i||"	"==i)n?n+=i:n=i;else if("\r"==i||"\n"==i)return n}}function s(e,t,n,r,i){if(void 0===r&&(r=!0),void 0===i&&(i=!0),null==e)return null;if(e.lowLevel()&&e.lowLevel().start()<=t&&e.lowLevel().end()>=n){if(F.ASTNodeImpl.isInstance(e)){for(var a=e,o=r?a.children():a.directChildren(),u=0;u<o.length;u++)if(r||o[u].lowLevel().unit()==e.lowLevel().unit()){var l=s(o[u],t,n,r);if(l)return!i&&F.ASTPropImpl.isInstance(l)&&(l=l.parent()),l}return e}if(F.ASTPropImpl.isInstance(e)){var p=e;if(!p.property().isKey()){var c=p.value();if(F.StructuredValue.isInstance(c)){var f=c,d=f.toHighLevel2();if(d&&!r&&d.lowLevel().unit()!=e.lowLevel().unit())return null;var l=s(d,t,n,r);if(l)return!i&&F.ASTPropImpl.isInstance(l)&&(l=l.parent()),l}return i?p:p.parent()}return null}return null}return null}function u(e,t){for(var n=-1,r=t-1;r>=0;r--){var i=e.charAt(r);if("\r"==i||"\n"==i||" "==i||"	"==i||'"'==i||"'"==i||":"==i){n=r+1;break}}for(var a=-1,r=t;r<e.length;r++){var i=e.charAt(r);if("\r"==i||"\n"==i||" "==i||"	"==i||'"'==i||"'"==i||":"==i){a=r;break}}return-1!=n&&-1!=a?e.substring(n,a):""}function l(e,t){for(var n="",r=t;r>=0;r--){var i=e[r];if(" "==i||"\r"==i||"\n"==i||"|"==i||"["==i||"]"==i||":"==i||"("==i||")"==i)break;n=i+n}for(var r=t+1;r<e.length;r++){var i=e[r];if(" "==i||"\r"==i||"\n"==i||"|"==i||"["==i||"]"==i||":"==i||"("==i||")"==i||","==i)break;n+=i}return n}function p(e,t){var n=h(e,t);if(n){if(F.ASTNodeImpl.isInstance(n)){var r=n;return{node:r,results:r.findReferences()}}F.ASTPropImpl.isInstance(n)}var i=s(F.fromUnit(e),t,t,!1);if(F.ASTNodeImpl.isInstance(i))return{node:i,results:i.findReferences()};if(F.ASTPropImpl.isInstance(i)){var a=i;if(a.property().canBeValue())return{node:a.parent(),results:a.parent().findReferences()}}return{node:null,results:[]}}function c(e,t){var n=e;if(n.getAdapter(K.RAMLPropertyService).isTypeExpr()){var i=r(t).filter(function(e){var t=e.definition().key();return t===B.Universe08.GlobalSchema?!0:e.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)});return i}if(n.getAdapter(K.RAMLPropertyService).isDescriminating()){var a=w(n.range(),t);return a}if(n.isReference()){var o=n.referencesTo(),a=w(o,t);return a}if(n.range().hasValueTypeInHierarchy()){var s=n.range().getAdapter(K.RAMLService);if(s.globallyDeclaredBy().length>0){var i=r(t).filter(function(e){return null!=U.find(s.globallyDeclaredBy(),function(t){return t==e.definition()})});return i}}return[]}function f(e,t){if(t){var n=[];if(e.getAdapter(K.RAMLPropertyService).isTypeExpr()){var i=r(t).filter(function(e){var t=e.definition().key();return t===B.Universe08.GlobalSchema?!0:e.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)});n=i.map(function(e){return F.qName(e,t)});var a=t.definition().universe().type(B.Universe10.TypeDeclaration.name);if(a){var o=a.allSubTypes();n=n.concat(o.map(function(e){return e.getAdapter(K.RAMLService).descriminatorValue()}))}return n}var s=e.range().key();if((s==B.Universe08.SchemaString||s==B.Universe10.SchemaString)&&"RAML10"==e.range().universe().version()&&e.range().hasValueTypeInHierarchy()){var i=r(t).filter(function(e){return e.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)});n=i.map(function(e){return F.qName(e,t)})}if(e.getAdapter(K.RAMLPropertyService).isDescriminating()){var o=b(e.domain(),t);n=n.concat(o.map(function(e){return e.getAdapter(K.RAMLService).descriminatorValue()}))}else if(e.isReference()){var u=w(e.referencesTo(),t);n=u.map(function(e){return F.qName(e,t)})}else if(e.range().hasValueTypeInHierarchy()){var l=e.range().getAdapter(K.RAMLService);if(l.globallyDeclaredBy().length>0){var i=r(t).filter(function(e){return null!=U.find(l.globallyDeclaredBy(),function(t){return t==e.definition()})});n=n.concat(i.map(function(e){return F.qName(e,t)}))}}return e.isAllowNull()&&n.push("null"),e.enumOptions()&&(n=n.concat(e.enumOptions())),n}return e.enumOptions()&&"string"==typeof e.enumOptions()?[e.enumOptions()+""]:e.enumOptions()}function d(e){return e.isElement()&&e.asElement().definition().key()!=B.Universe10.Library?null:e.asElement().attrValue("name")}function m(e,t){var n=e.lowLevel().unit();if(!n)return null;var r=e.lowLevel().start(),i=e.lowLevel().end();if(null!=t&&t==q.KEY_COMPLETION?(r=e.lowLevel().keyStart(),i=e.lowLevel().keyEnd()):null!=t&&t==q.VALUE_COMPLETION&&(r=e.lowLevel().valueStart(),i=e.lowLevel().valueEnd()),-1==r||-1==i)return null;var a=Math.floor((r+i)/2);return h(n,a,t)}function h(e,t,n){var r=s(F.fromUnit(e),t,t,!1),a=null;if(r.isElement()&&r.asElement().definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)&&r.asElement().directChildren().forEach(function(e){if(e.isUnknown()&&e.getLowLevelStart()<t&&e.getLowLevelEnd()>t){var n=r.asElement().localType();n.allFacets().forEach(function(t){if(t.nameId()==e.lowLevel().key()&&k.UserDefinedProp.isInstance(t)){var n=i(t);a=n}})}}),!r.property())return r;if("example"==r.property().nameId()){r.parent().localType();r.lowLevel().children().forEach(function(e){"example"==e.key()&&e.children().forEach(function(e){if(e.start()<t&&e.end()>t){var n=r.parent().asElement().localType();n.allProperties().forEach(function(t){if(t.nameId()==e.key()&&k.UserDefinedProp.isInstance(t)){var n=i(t);a=n}})}})})}if(a)return a;var o=null!=n?n:E(e.contents(),t);if(o==q.VALUE_COMPLETION){var l=r;if(F.ASTPropImpl.isInstance(r)){var p=r;if(p&&p.value()){if(!F.StructuredValue.isInstance(p.value()))return W(t,e.contents(),p,l);var c=p.value(),f=c.toHighLevel();if(f){var d=U.find(f.attrs(),function(e){return e.lowLevel().start()<t&&e.lowLevel().end()>=t});if(d)return W(t,e.contents(),d,f,p.property())}}}else{var m=l.property();if(m)return W(t,e.contents(),null,l,m)}}if(o==q.KEY_COMPLETION||o==q.SEQUENCE_KEY_COPLETION){var l=r,h=r.property();if(D.UserDefinedProp.isInstance(h)){var g=h;return i(g)}if(F.ASTNodeImpl.isInstance(r)&&D.isUserDefinedClass(l.definition())){var A=l.definition();return A.isAssignableFrom("TypeDeclaration")?r:A.getAdapter(K.RAMLService).getDeclaringNode()}if(F.ASTPropImpl.isInstance(r)){var T=r;if(S(T)){var b=y(T);if(b){var N=v(T,b);if(N){var r=s(N,t,t);if(h=r.property(),D.UserDefinedProp.isInstance(h)){var g=h;return i(g)}if(F.ASTNodeImpl.isInstance(r)&&D.isUserDefinedClass(l.definition())){var A=l.definition();return A.getAdapter(K.RAMLService).getDeclaringNode()}}}}}}if(o==q.PATH_COMPLETION){var _=u(e.contents(),t);if(_){var w=e.resolve(_);return w}}}function y(e){var t=null;if(e.isElement()?t=e:e.isAttr()&&(t=e.parent()),!t.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name)){var n=t.parent();if(!n)return null;if(n.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name))t=n;else{if(n=n.parent(),null==n)return null;if(!n.definition().isAssignableFrom(B.Universe10.TypeDeclaration.name))return null;t=n}}return t.localType()}function v(e,t){return F.StructuredValue.isInstance(e.value())?new F.ASTNodeImpl(e.value().lowLevel(),e.parent(),t,e.property()):null}function g(e,t){return new F.ASTNodeImpl(e.lowLevel(),e,t,e.property())}function A(e){return e.definition().key()==B.Universe10.ExampleSpec}function S(e){var t=B.Universe10.TypeDeclaration.properties.example.name,n=B.Universe10.ObjectTypeDeclaration.name;if(!F.ASTPropImpl.isInstance(e))return!1;var r=e,i=r.parent(),a=i&&i.property();a&&a.nameId();return t===r.name()&&r.isString()&&F.ASTNodeImpl.isInstance(i)&&i.definition().isAssignableFrom(n)?!0:!1}function E(e,t){for(var n=!1,r=!1,i=!1,a=t-1;a>=0;a--){var s=e.charAt(a);if("("==s)i=!0;else{if(i){if("\r"==s||"\n"==s){for(var u=!1,l=t-1;l<e.length;l++){var p=e[l];if(")"==p&&(u=!0),"\r"==p||"\n"==p)break;if(":"==p){i=!1;break}}if(i&&u)return q.ANNOTATION_COMPLETION;break}if(" "==s||"	"==s)continue;break}if("\r"==s||"\n"==s)break;if(":"==s)break}}for(var a=t-1;a>=0;a--){var s=e.charAt(a);if("#"==s){if(0==a)return q.VERSION_COMPLETION;for(var l=a-1;l>=0;l--){var c=e.charAt(l);if("\r"==c||"\n"==c)break;if("!"==c&&e.indexOf("!include",l)==l)return q.PATH_COMPLETION}return q.INCOMMENT}if(":"==s)return n?q.DIRECTIVE_COMPLETION:q.VALUE_COMPLETION;if("\r"==s||"\n"==s){for(var f=!1,d=o(t,e),m=a;m>0;m--){if(s=e.charAt(m),":"==s){if(f){var h=o(m,e);if(h.length<d.length)return q.VALUE_COMPLETION}break}"|"!=s?(("\r"==s||"\n"==s)&&(f=!1)," "!=s&&"	"!=s&&(f=!1)):f=!0}return r?q.SEQUENCE_KEY_COPLETION:q.KEY_COMPLETION}if("-"==s&&(r=!0),"!"==s){if(e.indexOf("!include",a)==a)return q.PATH_COMPLETION;e.indexOf("!i",a)==a&&(n=!0)}}}function T(e,t){if(!t)return null;for(var n=t.split("/"),r=e,i=0;i<n.length;i++)if("#"!=n[i]){if(r=U.find(r.children(),function(e){return e.key()==n[i]}),!r)return null}else r=e.unit().ast();return r}function b(e,n){if(null==e)return[];var i=e.nameId();n=t.declRoot(n);var a=n;if(a._subTypesCache){var o=a._subTypesCache[i];if(o)return o}else a._subTypesCache={};var s=e.allSubTypes();if(e.getAdapter(K.RAMLService).getRuntimeExtenders().length>0&&n){var u=r(n),l=e.getAdapter(K.RAMLService).getRuntimeExtenders();n.root();l.forEach(function(t){var n=u.filter(function(n){var r=n.definition().allSuperTypes();r.push(n.definition());var i=n.definition()==t||null!=U.find(r,function(e){return e==t})||null!=U.find(r,function(t){return t==e});return i});s=s.concat(n.map(function(e){return e.localType()}))})}return s=U.unique(s),a._subTypesCache[i]=s,s}function N(e,n,i){n=t.declRoot(n);var a=r(n),o=U.find(a,function(t){return F.qName(t,n)==e&&t.property()&&t.property().nameId()==B.Universe10.LibraryBase.properties.types.name});return o.localType()}function _(e,n,i){n=t.declRoot(n);var a=r(n),o=U.find(a,function(t){return F.qName(t,n)==e&&t.property()&&t.property().nameId()==B.Universe10.LibraryBase.properties.schemas.name});return o.localType()}function w(e,t){var n=[],i=[e].concat(e.getAdapter(K.RAMLService).getRuntimeExtenders());if(t){var a=t;i.forEach(function(e){var t=r(a),i=t.filter(function(t){return t.definition().isAssignableFrom(e.nameId())});n=n.concat(i)})}var o=!e.hasValueTypeInHierarchy();if(o&&e.getAdapter(K.RAMLService).isInlinedTemplates()&&t){var a=t,s=r(a).filter(function(t){return t.definition()==e});n=n.concat(s)}else{var a=t,u={};e.allSubTypes().forEach(function(e){return u[e.nameId()]=!0}),u[e.nameId()]=!0;var s=r(a).filter(function(e){return u[e.definition().nameId()]});n=n.concat(s)}return n}function M(e,t){var n=e.range();return b(n,t)}function I(e,t){if(t){if(e.isDescriminator()){var n=e.range(),i=n.getAdapter(K.RAMLService).getRuntimeExtenders();if(i.length>0&&t){var a=[];return i.forEach(function(e){var n=r(t).filter(function(t){return t.definition()==e});a=a.concat(n)}),a}return[]}if(e.isReference())return w(e.referencesTo(),t);if(e.range().hasValueTypeInHierarchy()){var o=e.range().getAdapter(K.RAMLService);if(o.globallyDeclaredBy&&o.globallyDeclaredBy().length>0){var s=r(t).filter(function(e){return null!=U.find(o.globallyDeclaredBy(),function(t){return t==e.definition()})});return s}}}return[]}function R(e){var t=[];return C(e,t),t}function C(e,t){e.children().forEach(function(e){t.push(e),C(e,t)})}function L(e,t,n){e.elements().forEach(function(e){L(e,t,n);e.definition()}),e.attrs().forEach(function(r){var i=r.property(),a=r.value();if(D.UserDefinedProp.isInstance(i)){var o=i.node();o==t?n.push(r):o.lowLevel().start()==t.lowLevel().start()&&o.lowLevel().unit()==t.lowLevel().unit()&&n.push(r)}if(S(r)){var s=y(r);if(s){var u=v(r,s);u&&L(u,t,n)}}else if(i.getAdapter(K.RAMLPropertyService).isTypeExpr()&&"string"==typeof a){var l=e.localType();Y(l,r,t,n);var p=d(t);if(p&&-1!=a.indexOf(p)){var c=P(r);c&&c.lowLevel().start()==t.lowLevel().start()&&n.push(r)}}if(i.isReference()||i.isDescriminator())if("string"==typeof a){var f=I(i,e);U.find(f,function(e){return e.name()==a&&e==t})&&n.push(r);var p=d(t);if(p&&-1!=a.indexOf(p)){var c=P(r);c&&c.lowLevel().start()==t.lowLevel().start()&&n.push(r)}}else{var m=a;if(m){var h=m.valueName(),f=I(i,e);U.find(f,function(e){return e.name()==h&&e==t})&&n.push(r);var g=m.toHighLevel();g&&L(g,t,n);var p=d(t);if(p&&-1!=h.indexOf(p)){var c=P(g);c&&c.lowLevel().start()==t.lowLevel().start()&&n.push(r)}}}else{var f=I(i,e);U.find(f,function(e){return e.name()==a&&e==t})&&n.push(r)}})}function P(e){if(!e.lowLevel)return null;var t=e.lowLevel();if(!t)return null;if(t.key()){var n=Math.floor((t.keyEnd()+t.keyStart())/2),r=O(t.unit(),n);if(r)return r}if(t.value()){var n=Math.floor((t.valueEnd()+t.valueStart())/2),r=O(t.unit(),n);if(r)return r}return null}function O(e,t){var n=h(e,t);if(n&&n.isElement&&n.isElement())for(var r=n.asElement(),i=r;i;){if(i.definition().key()==B.Universe10.Library)return i;i=i.parent()}return null}var D=n(39),x=n(9),U=n(65),k=n(39),F=n(16),B=n(18),K=k,V=n(35),j=n(25);t.declRoot=function(e){for(var t=e;;){if(t.definition().key()==B.Universe10.Library)break;var n=t.parent();if(!n)break;t=n}return t},t.globalDeclarations=r,t.findDeclarations=a,t.deepFindNode=s,t.extractName=l;var W=function(e,t,n,r,a){void 0===a&&(a=n.property());var o=c(a,r),s=l(t,e),u=U.find(o,function(e){return F.qName(e,r)==s});if(u)return u;if(D.UserDefinedProp.isInstance(a)){var p=a;return i(p)}return null};t.findUsages=p,t.referenceTargets=c,t.enumValues=f,t.findDeclarationByNode=m,t.findDeclaration=h,t.findExampleContentType=y,t.parseDocumentationContent=v,t.parseStructuredExample=g,t.isExampleNode=A,t.isExampleNodeContent=S,t.determineCompletionKind=E,function(e){e[e.VALUE_COMPLETION=0]="VALUE_COMPLETION",e[e.KEY_COMPLETION=1]="KEY_COMPLETION",e[e.PATH_COMPLETION=2]="PATH_COMPLETION",e[e.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",e[e.VERSION_COMPLETION=4]="VERSION_COMPLETION",e[e.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",e[e.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",e[e.INCOMMENT=7]="INCOMMENT"}(t.LocationKind||(t.LocationKind={}));var q=t.LocationKind;t.resolveReference=T,t.subTypesWithLocals=b,t.subTypesWithName=N,t.schemasWithName=_,t.nodesDeclaringType=w,t.findAllSubTypes=M,t.allChildren=R;var Y=function(e,t,n,r){var i=e.getAdapter(K.RAMLService).getDeclaringNode();if(i&&n.isSameNode(i))return void r.push(t);if(e.isArray()&&Y(e.array().componentType(),t,n,r),e.isUnion()){var a=e.union();Y(a.leftType(),t,n,r),Y(a.rightType(),t,n,r)}e.superTypes().some(function(e){return e.nameId()==n.name()})&&r.push(t)};t.refFinder=L},function(e,t,n){"use strict";function r(e){var t=e.getExtra(p.SOURCE_EXTRA);return null==t?null:l.isSourceProvider(t)?t:f.isLowLevelNode(t)?{getSource:function(){return t.highLevelNode()}}:c.isParseResult(t)?{getSource:function(){return t}}:null}function i(e){return r(e)}function a(e){var t=e.getAdapters();return t?m.find(t,function(e){return l.rt.isParsedType(e)}):null}function o(e){if(!e)return null;var t=e.getExtra(p.SOURCE_EXTRA);if(t)return r(e);var n=a(e);return n?i(n):null}function s(e,t){var n=o(e);return n?{getSource:function(){var e=n.getSource(),r=e.asElement();if(null==r)return null;var i=r.elementsOfKind(d.Universe10.ObjectTypeDeclaration.properties.properties.name);return null==i||0==i.length?null:m.find(i,function(e){return t==e.attrValue(d.Universe10.TypeDeclaration.properties.name.name)})}}:null}function u(e){return s(e.domain(),e.nameId())}var l=n(39),p=l.rt,c=n(9),f=n(10),d=n(18),m=n(65);t.getExtraProviderSource=r,t.getRTypeSource=i,t.findRTypeByNominal=a,t.getNominalTypeSource=o,t.getNominalPropertySource=s,t.getNominalPropertySource2=u},function(e,t,n){"use strict";function r(e){return e.highLevel().localType()}function i(e){return e.highLevel().localType()}function a(e){var t=new Le.Project(Oe.dirname(e)),n=t.unit(Oe.basename(e));return n&&n.isRAMLUnit()?ge.fromUnit(n).wrapperNode():null}function o(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==be.Universe10.Resource.name);return t}function s(e,t){return void 0===t&&(t=!1),t?l(e):u(e)}function u(e){var t=e.highLevel().lowLevel();if(Ie.LowLevelProxyNode.isInstance(t))return e;var n=null!=e.highLevel().reusedNode()?Me:we;return n.expandTraitsAndResourceTypes(e)}function l(e){var t=null!=e.highLevel().reusedNode()?Me:we;return t.expandLibraries(e)}function p(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==be.Universe10.Resource.name);t=t.replace(/\/\//g,"/");var r=n.baseUri(),i=r?r.value():"";return i=i?i:"",_e.stringEndsWith(i,"/")&&(t=t.substring(1)),t=i+t}function c(e,t){return e.runtimeType().validate(t).map(function(e){return e.getMessage()})}function f(e,t){return e.runtimeType().validate(t)}function d(e){return m(e)}function m(e){return e.highLevel().lowLevel().actual().libExpanded?e.traits_original():v(e,function(e){return De.isTraitType(e)})}function h(e){return y(e)}function y(e){return e.highLevel().lowLevel().actual().libExpanded?e.resourceTypes_original():v(e,function(e){return De.isResourceTypeType(e)})}function v(e,t){var n=Ce.globalDeclarations(e.highLevel()).filter(function(e){return t(e.definition())}),r=e.highLevel().lowLevel(),i=r.includePath();i||(i=r.unit().path());var a=Ie.LowLevelProxyNode.isInstance(e.highLevel().lowLevel()),o=a?new we.TraitsAndResourceTypesExpander:null,s=n.map(function(t){var n,r=t.lowLevel().unit().path();return a&&(Ie.LowLevelProxyNode.isInstance(t.lowLevel())||(t=o.createHighLevelNode(t,!1)),(new Re.ReferencePatcher).process(t,e.highLevel(),!0,!0)),r!=i?(n=me.buildWrapperNode(t,!1),n.meta().setCalculated()):n=t.wrapperNode(),n});return s}function g(e){var t=[],n=e;do e=n,t.push(e.relativeUri().value()),n=e.parent();while(n.definition().key().name==be.Universe10.Resource.name);return t.reverse()}function A(e){return de.ResourceImpl.isInstance(e.parent())?e.parent():null}function S(e){var t=e.parent();return t.definition().key().name==be.Universe10.Resource.name?t:null}function E(e,t){if(null==e)return null;var n=e.resources();return n?(n=n.filter(function(e){return e.relativeUri().value()==t}),0==n.length?null:n[0]):null}function T(e,t){if(!e)return null;for(var n=null,r=0;r<t.length;r++){if(n=E(e,t[r]),!n)return null;e=n}return n}function b(e,t){return e?e.methods().filter(function(e){return e.method()==t}):null}function N(e,t,n){var r=T(e,t);return r?b(r,n):null}function _(e){return De.isApiSibling(e.definition())}function w(e){for(var t=e;!_(t);)t=t.parent();return t}function M(e){var t=e.parent();if(de.ResourceImpl.isInstance(t))return o(t)+" "+e.method().toLowerCase();if(de.ResourceTypeImpl.isInstance(t))return t.name()+" "+e.method().toLowerCase();throw new Error("Method is supposed to be owned by Resource or ResourceType.\nHere the method is owned by "+e.definition().key().name)}function I(e){var t=e.code().value(),n=Ae.validateResponseString(t);if(null!=n)return!1;try{if(parseInt(t.charAt(0))<4)return!0}catch(r){}return!1}function R(e){var t=[],n=function(e){t.push(e),e.resources().forEach(function(e){return n(e)})};return e.resources().forEach(function(e){return n(e)}),t}function C(e,t){for(var n={};null!=t;)P(t).forEach(function(e){return n[e.name()]=new Be(e)}),t=S(t);var r=ye.ramlPathMatch(o(t),n,{})(e);return r?new Ne(Object.keys(r.params).map(function(e){return new Fe(e,r.params[e])})):Ne.empty()}function L(e){return P(e)}function P(e){var t=e.uriParameters_original();if(!de.ResourceImpl.isInstance(e))return t;var n=e.relativeUri().value(),r=be.Universe10.ResourceBase.properties.uriParameters.name;return le(t,n,e,r)}function O(e){return D(e)}function D(e){var t=e.baseUri()?e.baseUri().value():"",n=e.baseUriParameters_original(),r=be.Universe10.Api.properties.baseUriParameters.name;return le(n,t,e,r)}function x(e){var t=[],n=e;do e=n,t=P(e).concat(t),n=e.parent();while(n.definition().key().name==be.Universe10.Resource.name);var r=n;r.baseUriParameters();return t=D(r).concat(t)}function U(e){return k(e)}function k(e){return e.protocols().map(function(e){return e.toUpperCase()})}function F(e){return B(e)}function B(e){return e.securedBy()}function K(e){var t=e.highLevel();if(!t)return"";var n=t.value();return n?n.toString():""}function V(e){var t=e.highLevel();if(!t)return null;var n=Ce.findDeclarationByNode(t,Ce.LocationKind.VALUE_COMPLETION);if(!n)return null;if(!n.getKind||n.getKind()!=ve.NodeKind.NODE)return null;var r=n.wrapperNode();return de.AbstractSecuritySchemeImpl.isInstance(r)?r:null}function j(e){return e.highLevel().definition().universe().version()}function W(e){var t=e.value().lowLevel(),n=null,r=t.highLevelParseResult();if(r){var i=null,a=!1;if(r.isAttr()?(a=De.isAnnotationsProperty(r.property()),i=r.parent().types()):r.isElement()&&(i=r.asElement().types()),i){var o=e.name(),s=o.indexOf(".")>=0;if(s){var u=a?i.getAnnotationTypeRegistry():i.getTypeRegistry();n=u.get(o)}else n=a?i.getAnnotationType(o):i.getType(o)}}return new he.TypeInstanceImpl(t,n)}function q(e){var t=e.highLevel().value();return"string"==typeof t||null==t?t:t.valueName()}function Y(e){return G(e)}function H(e){return G(e)}function $(e){return G(e)}function G(e){var t=e.highLevel(),n=t.parent(),r=e.name(),i=Ce.referenceTargets(t.property(),n).filter(function(e){return ge.qName(e,n)==r});return 0==i.length?null:i[0].wrapperNode()}function X(e,t,n,r){void 0===r&&(r=!0);var i=t.lowLevel(),a=t.definition().property(n?"example":"examples"),o=Ee.getUniverse("RAML10"),s=o.type(Te.Universe10.ExampleSpec.name),u=e.examples().filter(function(e){return null!=e&&!e.isEmpty()&&e.isSingle()==n});return u.map(function(e){var n=e.asJSON(),o=e.isSingle()?"example":null,u=i.unit(),l=new Pe.AstNode(u,n,i,null,o),p=r?new ge.ASTNodeImpl(l,t,s,a):t,c=e.annotations(),f=Ue(c,l,p,u),d=e.scalarsAnnotations(),m={};Object.keys(d).forEach(function(e){return m[e]=Ue(d[e],l,p,u)});var h=new Ke(p,e,f,{description:function(){return m.description||[]},displayName:function(){return m.displayName||[]},strict:function(){return m.strict||[]}});return h})}function z(e,t){void 0===t&&(t=!1);var n=e.runtimeDefinition();if(!n)return[];var r=e.highLevel();return X(n,r,t)}function J(e){var t=z(e,!0);return t.length>0?t[0]:null}function Q(e){return z(e)}function Z(e){var t=e.runtimeDefinition(),n=t.fixedFacets();if(e.kind()==Te.Universe10.UnionTypeDeclaration.name)for(var r=t.allFixedBuiltInFacets(),i=0,a=Object.keys(r);i<a.length;i++){var o=a[i];n[o]=r[o]}else for(var s=Object.keys(n),u=0,l=s;u<l.length;u++){
var o=l[u];null==t.facet(o)&&delete n[o]}if(0==Object.keys(n).length)return null;var p=new Pe.AstNode(null,n);return new he.TypeInstanceImpl(p)}function ee(e){var t=e.highLevel().attributes(Ee.universesInfo.Universe10.TypeDeclaration.properties.type.name),n=t.filter(function(e){return ge.StructuredValue.isInstance(e.value())});if(0==n.length)return e.type_original().map(function(e){return null===e||"NULL"===e||"Null"===e?"string":e});var r=!1,i=t.map(function(e){var t=e.value();return null==t?null:"string"==typeof t?t:(ge.StructuredValue.isInstance(t)&&(r=!0),t.toString())});return r?null:i}function te(e){var t=!1,n=e.highLevel().attributes(Ee.universesInfo.Universe10.TypeDeclaration.properties.schema.name);if(t)return null;var r=n.filter(function(e){return ge.StructuredValue.isInstance(e.value())});if(0==r.length)return e.schema_original();var i=n.map(function(e){var n=e.value();return"string"==typeof n?n:(ge.StructuredValue.isInstance(n)&&(t=!0),n.toString())});return t?null:i}function ne(e){var t=e.highLevel().attributes(Ee.universesInfo.Universe10.TypeDeclaration.properties.type.name);t=t.concat(e.highLevel().attributes(Ee.universesInfo.Universe10.TypeDeclaration.properties.schema.name));for(var n=t.map(function(e){return e.value()}),r=0,i=n;r<i.length;r++){var a=i[r];if(ge.StructuredValue.isInstance(a)){var o=new he.TypeInstanceImpl(a.lowLevel());return o}}return null}function re(e){for(var t=e.highLevel().attributes(Ee.universesInfo.Universe10.ArrayTypeDeclaration.properties.items.name),n=t.map(function(e){return e.value()}),r=0,i=n;r<i.length;r++){var a=i[r];if(ge.StructuredValue.isInstance(a)){var o=new he.TypeInstanceImpl(a.lowLevel());return o}}return null}function ie(e){var t=e.value(),n=e.highLevel().lowLevel().unit().resolve(t),r=n.highLevel(),i=r.asElement();if(i){var a=i.wrapperNode();return fe.isLibrary(a)?(a.setAttributeDefaults(e.attributeDefaults()),a):null}return null}function ae(e){var t=e.highLevel().attributes(Ee.universesInfo.Universe10.ArrayTypeDeclaration.properties.items.name),n=t.filter(function(e){return ge.StructuredValue.isInstance(e.value())});if(0==n.length)return e.items_original().map(function(e){return null===e||"NULL"===e||"Null"===e?"string":e});var r=!1,i=t.map(function(e){var t=e.value();return null==t?null:"string"==typeof t?t:(ge.StructuredValue.isInstance(t)&&(r=!0),t.toString())});return r?null:i}function oe(e){var t=e.highLevel();if(!t)return null;var n=t.attr(be.Universe10.TypeDeclaration.properties.type.name);if(null==n)return null;var r=n.lowLevel();if(null==r)return null;var i=n.value();if(!i||"string"!=typeof i)return null;var a=r.end()-i.length+1,o=n.lowLevel().unit();if(!o)return null;var s=Ce.findDeclaration(o,a);return s&&s.getKind&&s.getKind()==ve.NodeKind.NODE&&De.isTypeDeclarationSibling(s.definition())?s.wrapperNode():null}function se(e){var t=e.runtimeType();if(!t)return null;if(!t.isArray()||!t.componentType)return null;var n=t,r=n.componentType();if(!r)return null;var i=Ce.getNominalTypeSource(r);if(!i)return null;var a=i.getSource();if(!a)return null;if(!a.isElement())return null;if(!De.isTypeDeclarationSibling(a.definition()))return null;var o=a.wrapperNode();return o}function ue(e){var t=e.items_original();if(t&&"string"!=typeof t&&(!Array.isArray(t)||0!=t.length)){var n=e.highLevel(),r=Te.Universe10.ArrayTypeDeclaration.properties.items.name,i=n.attr(r),a=n.definition().universe().type(Te.Universe10.TypeDeclaration.name),o=n.definition().universe().type(Te.Universe10.ArrayTypeDeclaration.name),s=new ge.ASTNodeImpl(i.lowLevel(),n,a,o.property(r));s.patchType(xe.doDescrimination(s))}var u=se(e);return u?u:oe(e)}function le(e,t,n,r){if("string"!=typeof t)return[];var i=n.highLevel(),a=i.definition(),o=a.property(r);if(!t)return[];var s={};e.forEach(function(e){var t=s[e.name()];t||(t=[],s[e.name()]=t),t.push(e)});for(var u=[],l=0,p={},c=t.indexOf("{");c>=0&&(l=t.indexOf("}",++c),!(0>l));c=t.indexOf("{",l)){var f=t.substring(c,l);if(p[f]=!0,s[f])s[f].forEach(function(e){return u.push(e)});else{var d=a.universe(),m=d.type(Te.Universe10.StringTypeDeclaration.name),h=Se.createStubNode(m,null,f,i.lowLevel().unit()),y=me.buildWrapperNode(h),v=y.highLevel();v.setParent(i),y.meta().setCalculated(),y.setName(f),v.patchProp(o),u.push(y)}}return Object.keys(s).filter(function(e){return!p[e]}).forEach(function(e){return s[e].forEach(function(e){return u.push(e)})}),u}function pe(e){if(e.kind()==Te.Universe10.Method.name||De.isTypeDeclarationSibling(e.definition())){for(var t=!1,n=e.highLevel().parent();null!=n;){var r=n.definition();if(De.isResourceTypeType(r)||De.isTraitType(r)){t=!0;break}n=n.parent()}if(!t)return null}var i=e.highLevel();if(null==i)return null;var a=i.lowLevel();if(null==a)return null;var o=a.children().filter(function(e){var t=e.key();return t?"("==t.charAt(0)&&")"==t.charAt(t.length-1)?!1:t.indexOf("<<")>=0:!1});if(0==o.length)return null;var s=new he.TypeInstanceImpl(o);return s}var ce=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},fe=n(11),de=n(21),me=n(45),he=n(49),ye=n(59),ve=n(9),ge=n(16),Ae=n(28),Se=n(17),Ee=n(39),Te=n(18),be=n(18),Ne=n(22),_e=n(33),we=n(27),Me=n(30),Ie=n(41),Re=n(53),Ce=n(13),Le=n(24),Pe=n(54),Oe=n(15),De=n(14),xe=n(29);t.resolveType=r,t.runtimeType=i,t.load=a,t.completeRelativeUri=o,t.expandSpec=s,t.expandTraitsAndResourceTypes=u,t.expandLibraries=l,t.absoluteUri=p,t.validateInstance=c,t.validateInstanceWithDetailedStatuses=f,t.traitsPrimary=d,t.allTraits=m,t.resourceTypesPrimary=h,t.allResourceTypes=y,t.relativeUriSegments=g,t.parentResource=A,t.parent=S,t.childResource=E,t.getResource=T,t.childMethod=b,t.getMethod=N,t.ownerApi=w,t.methodId=M,t.isOkRange=I,t.allResources=R,t.matchUri=C;t.uriParametersPrimary=L,t.uriParameters=P,t.baseUriParametersPrimary=O,t.baseUriParameters=D,t.absoluteUriParameters=x,t.protocolsPrimary=U,t.allProtocols=k,t.securedByPrimary=F,t.allSecuredBy=B,t.securitySchemeName=K,t.securityScheme=V,t.RAMLVersion=j,t.structuredValue=W,t.referenceName=q,t.referencedTrait=Y,t.referencedAnnotation=H,t.referencedResourceType=$;var Ue=function(e,t,n,r){var i=[];if(e)for(var a=Ee.getUniverse("RAML10"),o=a.type("Annotable").property("annotations"),s=0,u=Object.keys(e);s<u.length;s++){var l=u[s],p=e[l],c=new Pe.AstNode(r,p.value(),t,null,"("+l+")"),f=new ge.ASTPropImpl(c,n,o.range(),o),d=new de.AnnotationRefImpl(f);i.push(d)}return i};t.examplesFromNominal=X,t.getTypeExample=J,t.getTypeExamples=Q,t.typeFixedFacets=Z,t.typeValue=ee,t.schemaValue=te,t.typeStructuredValue=ne,t.itemsStructuredValue=re,t.referencedNode=ie,t.getItems=ae,t.findComponentTypeDeclaration=ue,t.getTemplateParametrizedProperties=pe;var ke=function(){function e(e,t){this._content=e,this._name=t}return e.prototype.name=function(){return this._name},e.prototype.content=function(){return this._content},e}();t.SchemaDef=ke;var Fe=function(){function e(e,t){this.key=e,this.value=t}return e}();t.ParamValue=Fe;var Be=function(){function e(e){this._param=e,this.description=e.description()?e.description().value():this.description,this.displayName=e.displayName(),this.type=e.type().length>0?e.type()[0]:"string",this.example=e.example(),this.required=e.required(),this["default"]=e["default"]()}return e}(),Ke=function(e){function t(t,n,r,i){e.call(this,t),this.expandable=n,this._annotations=r,this._scalarAnnotations=i}return ce(t,e),t.prototype.value=function(){return this.expandable.asString()},t.prototype.structuredValue=function(){var e;e=this.expandable.isJSONString()||this.expandable.isYAML()?this.expandable.asJSON():this.expandable.original();var t=this._node.lowLevel(),n=this.expandable.isSingle()?"example":null,r=new Pe.AstNode(t.unit(),e,t,null,n);return new he.TypeInstanceImpl(r)},t.prototype.strict=function(){return this.expandable.strict()},t.prototype.description=function(){var e=this.expandable.description();if(null==e&&null!==e)return null;var t=Se.createAttr(this._node.definition().property(Te.Universe10.ExampleSpec.properties.description.name),e),n=new de.MarkdownStringImpl(t);return n},t.prototype.name=function(){return this.expandable.name()},t.prototype.displayName=function(){return this.expandable.displayName()},t.prototype.annotations=function(){return this._annotations},t.prototype.scalarsAnnotations=function(){return this._scalarAnnotations},t.prototype.uses=function(){return e.prototype.elements.call(this,"uses")},t}(he.BasicNodeImpl);t.ExampleSpecImpl=Ke},function(e,t,n){"use strict";var r=n(39);e.exports=r},function(e,t,n){"use strict";var r=n(39);e.exports=r.getUniverse},function(e,t,n){"use strict";function r(){return t.rt.getSchemaUtils()}function i(e){e.isUnion?e.addAdapter(new _(e)):e.range&&e.addAdapter(new N(e))}function a(e){return e.getSource&&"function"==typeof e.getSource}function o(e){var t=e;return t.genuineUserDefinedType&&t.isUserDefined&&t.isUserDefined()}function s(e,t,n,r,i){var a=new S(e,t);return a.withDomain(n,i).withRange(r)}var u=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};t.rt=n(85);var l=t.rt.nominalTypes;t.getSchemaUtils=r,t.TOP_LEVEL_EXTRA=t.rt.TOP_LEVEL_EXTRA,t.DEFINED_IN_TYPES_EXTRA=t.rt.DEFINED_IN_TYPES_EXTRA,t.USER_DEFINED_EXTRA=t.rt.USER_DEFINED_EXTRA,t.SOURCE_EXTRA=t.rt.SOURCE_EXTRA,t.tsInterfaces=t.rt.tsInterfaces,t.injector={inject:function(e){i(e)}},l.registerInjector(t.injector);var p=function(e){function t(){e.apply(this,arguments)}return u(t,e),t}(l.AbstractType);t.AbstractType=p;var c=function(e){function t(){e.apply(this,arguments)}return u(t,e),t}(l.ValueType);t.ValueType=c;var f=function(){function e(){}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.getSource=function(){return null},e.CLASS_IDENTIFIER="definitionSystem.SourceProvider",e}();t.SourceProvider=f,t.isSourceProvider=a;var d=function(e){function t(){e.apply(this,arguments),this.values=[]}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER)return!0}return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.CLASS_IDENTIFIER="definitionSystem.EnumType",t}(c);t.EnumType=d;var m=function(e){function t(t,n,r,i){e.call(this,t,i,n),this.referenceTo=r}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER)return!0}return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.prototype.getReferencedType=function(){return this.universe().type(this.referenceTo)},t.prototype.hasStructure=function(){return!0},t.CLASS_IDENTIFIER="definitionSystem.ReferenceType",t}(c);t.ReferenceType=m;var h=function(e){function t(t,n,r,i){void 0===i&&(i=""),e.call(this,t,n,r)}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER)return!0}return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.prototype.allProperties=function(t){return void 0===t&&(t={}),e.prototype.allProperties.call(this,t)},t.CLASS_IDENTIFIER="definitionSystem.NodeClass",t}(l.StructuredType);t.NodeClass=h;var y=function(e){function t(t,n,r,i,a){e.call(this,t,n,i,a),this.getAdapter(_).setDeclaringNode(r)}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=0,r=e.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==t.CLASS_IDENTIFIER_UserDefinedClass)return!0}return!1},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_UserDefinedClass)},t.prototype.key=function(){return null},t.prototype.isUserDefined=function(){return!0},t.prototype.typeId=function(){var e=this.nameId(),t=this.getAdapter(_).getDeclaringNode();if(t){e+=t.lowLevel().start();var n=t.lowLevel().unit();n&&(e+=n.absolutePath())}return e},t.prototype.hasValueTypeInHierarchy=function(){return this._value?!0:this.isAssignableFrom("ObjectTypeDeclaration")?!1:!1},t.prototype.isGenuineUserDefinedType=function(){return null!=this.genuineUserDefinedType()},t.prototype.genuineUserDefinedType=function(){var e=this.getAdapter(_).getDeclaringNode();return e?this:null},t.CLASS_IDENTIFIER_UserDefinedClass="definitionSystem.UserDefinedClass",t}(h);t.UserDefinedClass=y,t.isUserDefinedClass=o;var v=function(e){function t(){e.apply(this,arguments)}return u(t,e),t.prototype.allProperties=function(e){void 0===e&&(e={});var t=this.superTypes()[0].allProperties();if(0==t.length){var n=this.getAdapter(_).getDeclaringNode(),r=new E("value",n);r.withDomain(this),r.withCanBeValue(),r.withRequired(!1);this.superTypes()[0];t=[],r.withRange(r.node().asElement().definition().universe().type("string")),t.push(r)}return t},t.prototype.isAnnotationType=function(){return!0},t}(y);t.AnnotationType=v;var g=function(e){function t(t,n,r,i){void 0===n&&(n=""),void 0===r&&(r=null),void 0===i&&(i="RAML08"),e.call(this,n),this._parent=r,this._classes=[],this._uversion="RAML08",this.aMap={},this.matchedObjects=t,this._uversion=i}return u(t,e),t.prototype.matched=function(){return this.matchedObjects?this.matchedObjects:this._parent?this._parent.matched():void 0},t.prototype.setTopLevel=function(e){this._topLevel=e},t.prototype.getTopLevel=function(){return this._topLevel},t.prototype.setOriginalTopLevelText=function(e){this._originalTopLevelText=e},t.prototype.getOriginalTopLevelText=function(){return this._originalTopLevelText},t.prototype.setTypedVersion=function(e){this._typedVersion=e},t.prototype.getTypedVersion=function(){return this._typedVersion},t.prototype.version=function(){return this._uversion},t.prototype.setUniverseVersion=function(e){this._uversion=e},t.prototype.types=function(){var e=[].concat(this._classes);return null!=this._parent&&(e=e.concat(this._parent.types())),e},t.prototype.type=function(e){if(this.aMap[e])return this.aMap[e];for(var t,n=0;n<this._classes.length;n++)if(this._classes[n].nameId()==e){t=this._classes[n];break}if(null==t&&this._parent){var t=this._parent.type(e);if(t instanceof p){var r=t;r._universe=this}}return t},t.prototype.register=function(e){return this._classes.push(e),e instanceof h&&this._classes.forEach(function(t){if(t instanceof h){var n=t;n.getAdapter(_).getExtendedType()==e&&e.getAdapter(_).getRuntimeExtenders().push(t)}}),this},t.prototype.registerAlias=function(e,t){this.aMap[e]=t},t.prototype.unregister=function(e){this._classes=this._classes.filter(function(t){return t!=e});var t=e.superTypes();return t.forEach(function(t){var n=t;n._superTypes=n._superTypes.filter(function(t){return t!=e})}),t=e.subTypes(),t.forEach(function(t){var n=t;n._subTypes=n._subTypes.filter(function(t){return t!=e})}),this},t.prototype.registerSuperClass=function(e,t){var n=e,r=t;n._superTypes.push(t),r._subTypes.push(e)},t}(l.Described);t.Universe=g,t.prop=s;var A=function(){function e(e,t){this.name=e,this.value=t}return e}();t.ChildValueConstraint=A;var S=function(e){function t(){e.apply(this,arguments),this._isFromParentValue=!1,this._isFromParentKey=!1,this._key=!1,this._declaresFields=!1,this._describes=null,this._canBeDuplicator=!1,this._allowsNull=!1,this._canBeValue=!1,this._isInherited=!1,this._selfNode=!1,this._noDirectParse=!1,this._contextReq=[],this.determinesChildValues=[]}return u(t,e),t.prototype.isPrimitive=function(){return this.range().isValueType()&&!(this.range()instanceof m)},t.prototype.withNoDirectParse=function(){this._noDirectParse=!0},t.prototype.isNoDirectParse=function(){return this._noDirectParse},t.prototype.withSelfNode=function(){this._selfNode=!0},t.prototype.isSelfNode=function(){return this._selfNode},t.prototype.matchKey=function(t){return null!=this._groupName?this.isAnnotation()?"("==t.charAt(0)&&")"==t.charAt(t.length-1)?!0:!1:this._groupName==t:e.prototype.matchKey.call(this,t)},t.prototype.valueDocProvider=function(){return this._vprovider},t.prototype.setValueDocProvider=function(e){return this._vprovider=e,this},t.prototype.suggester=function(){return this._suggester},t.prototype.setValueSuggester=function(e){this._suggester=e},t.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},t.prototype.getOftenKeys=function(){return this._oftenKeys},t.prototype.withOftenKeys=function(e){return this._oftenKeys=e,this},t.prototype.withCanBeValue=function(){return this._canBeValue=!0,this},t.prototype.withInherited=function(e){this._isInherited=e},t.prototype.isInherited=function(){return this._isInherited},t.prototype.isAllowNull=function(){return this._allowsNull},t.prototype.withAllowNull=function(){this._allowsNull=!0},t.prototype.getCanBeDuplicator=function(){return this._canBeDuplicator},t.prototype.canBeValue=function(){return this._canBeValue},t.prototype.setCanBeDuplicator=function(){return this._canBeDuplicator=!0,!0},t.prototype.inheritedContextValue=function(){return this._inheritsValueFromContext},t.prototype.withInheritedContextValue=function(e){return this._inheritsValueFromContext=e,this},t.prototype.withContextRequirement=function(e,t){this._contextReq.push({name:e,value:t})},t.prototype.getContextRequirements=function(){return this._contextReq},t.prototype.withDescribes=function(e){return this._describes=e,this},t.prototype.describesAnnotation=function(){return null!=this._describes},t.prototype.describedAnnotation=function(){return this._describes},t.prototype.isReference=function(){return this.range()instanceof m},t.prototype.referencesTo=function(){return this.range().getReferencedType()},t.prototype.newInstanceName=function(){return this._newInstanceName?this._newInstanceName:this.range().nameId()},t.prototype.withThisPropertyDeclaresFields=function(e){return void 0===e&&(e=!0),this._declaresFields=e,this},t.prototype.isThisPropertyDeclaresTypeFields=function(){return this._declaresFields},t.prototype.withNewInstanceName=function(e){return this._newInstanceName=e,this},t.prototype.addChildValueConstraint=function(e){this.determinesChildValues.push(e)},t.prototype.getChildValueConstraints=function(){return this.determinesChildValues},t.prototype.childRestrictions=function(){return this.determinesChildValues},t.prototype.id=function(){return this._id?this._id:this._groupName?this.domain().getAdapter(_).getDeclaringNode()?null:(this._id=this._groupName+this.domain().nameId(),this._id):null},t.prototype.isAnnotation=function(){return"annotations"==this._groupName&&this.domain()&&!this.domain().isUserDefined()},t.prototype.withFromParentValue=function(e){return void 0===e&&(e=!0),this._isFromParentValue=e,this},t.prototype.withFromParentKey=function(e){return void 0===e&&(e=!0),this._isFromParentKey=e,this},t.prototype.isFromParentKey=function(){return this._isFromParentKey},t.prototype.isFromParentValue=function(){return this._isFromParentValue},t.prototype.withGroupName=function(e){return this._groupName=e,this},t.prototype.unmerge=function(){return this._groupName=this.nameId(),this},t.prototype.merge=function(){return this._groupName=null,this},t.prototype.withKey=function(e){return this._key=e,this},t.prototype.isKey=function(){return this._key},t.prototype.isMerged=function(){return null==this._groupName},t.prototype.groupName=function(){return this._groupName},t.prototype.key=function(){return null},t}(l.Property);t.Property=S;var E=function(e){function t(t,n){e.call(this,t),this._node=n}return u(t,e),t.isInstance=function(e){if(null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier)for(var n=e.getClassIdentifier(),r=0;r<n.length;r++)if(n[r]==t.CLASS_IDENTIFIER)return!0;return!1},t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER)},t.prototype.withDisplayName=function(e){this._displayName=e},t.prototype.getDisplayName=function(){return this._displayName},t.prototype.node=function(){return this._node||null==this.sourceProvider||(this._node=this.sourceProvider.getSource()),this._node},t.prototype.setSourceProvider=function(e){this.sourceProvider=e},t.CLASS_IDENTIFIER="definitionSystem.UserDefinedProp",t}(S);t.UserDefinedProp=E;var T=function(){function e(){}return e.prototype.setDocTableName=function(e){this._documentationTableName=e},e.prototype.docTableName=function(){return this._documentationTableName},e.prototype.setHidden=function(e){this._isHidden=e},e.prototype.isHidden=function(){return this._isHidden},e.prototype.setMarkdownDescription=function(e){this._markdownDescription=e},e.prototype.markdownDescription=function(){return this._markdownDescription},e.prototype.setValueDescription=function(e){this._valueDescription=e},e.prototype.valueDescription=function(){return this._valueDescription},e}();t.RAMLPropertyDocumentationService=T;var b=function(e){function t(){e.apply(this,arguments)}return u(t,e),t.prototype.isSystem=function(){return this._isSystemProperty},t.prototype.withSystem=function(e){return this._isSystemProperty=e,this},t.prototype.isEmbedMap=function(){return this._isEmbededMap},t.prototype.withEmbedMap=function(){return this._isEmbededMap=!0,this},t}(T);t.RAMLPropertyParserService=b;var N=function(e){function t(t){if(e.call(this),this._property=t,this._meta={},!t)throw new Error;e.call(this)}return u(t,e),t.prototype.valueDocProvider=function(){return this._property.valueDocProvider()},t.prototype.withPropertyGrammarType=function(e){this._propertyGrammarType=e},t.prototype.getPropertyGrammarType=function(){return this._propertyGrammarType},t.prototype.id=function(){return this._property.nameId()},t.prototype.range=function(){return this._property.range()},t.prototype.domain=function(){return this._property.domain()},t.prototype.isAllowNull=function(){return this._property.isAllowNull()},t.prototype.referencesTo=function(){return this._property.referencesTo()},t.prototype.isReference=function(){return this._property.isReference()},t.prototype.nameId=function(){return this._property.nameId()},t.prototype.priority=function(){return this.isKey()?128:this.isReference()?64:this.isTypeExpr()?32:"example"==this.nameId()?0:-1024},t.prototype.isKey=function(){return this._property instanceof S?this._property.isKey():!1},t.prototype.isMerged=function(){return this._property instanceof S?this._property.isMerged():!1},t.prototype.isTypeExpr=function(){return this.texpr},t.prototype.isExampleProperty=function(){return this.example},t.prototype.setExample=function(e){this.example=e},t.prototype.setTypeExpression=function(e){this.texpr=e},t.prototype.isDescriminating=function(){return this._property.isDescriminator()},t.prototype.putMeta=function(e,t){this._meta[e]=t},t.prototype.meta=function(e){return this._meta[e]},t}(b);t.RAMLPropertyService=N;var _=function(){function e(e){
//!!!
this._allowsOptionalProperties=!1,this._possibleInterfaces=[],
//!!!
this._canInherit=[],this._declaredBy=[],
//!!!
this._aliases=[],
//!!!???
this._defining=[],this._runtimeExtenders=[],
//!!!???
this._declaresType=null,
//!!!
this._isTemplate=!1,
//!!!
this._contextRequirements=[],this._type=e}return e.prototype.withAllowQuestion=function(){this._allowsOptionalProperties=!0},e.prototype.getAllowQuestion=function(){return this._allowsOptionalProperties},e.prototype.withCanInherit=function(e){this._canInherit.push(e)},e.prototype.getReferenceIs=function(){return this._referenceIs},e.prototype.withReferenceIs=function(e){this._referenceIs=e},e.prototype.descriminatorValue=function(){return 0==this.valueRequirements().length?this.nameId():this.valueRequirements()[0].value},e.prototype.getCanInherit=function(){return this._canInherit},e.prototype.withAllowAny=function(){this._allowsAnyChildren=!0},e.prototype.getAllowAny=function(){return this._allowsAnyChildren||this._type.isExternal()},e.prototype.globallyDeclaredBy=function(){return this._declaredBy},e.prototype.setGloballyDeclaredBy=function(e){this._declaredBy.push(e)},e.prototype.setDeclaringNode=function(e){this._node=e},e.prototype.nameId=function(){return this._type.nameId()},e.prototype.universe=function(){return this._type.universe()},e.prototype.isAssignableFrom=function(e){return this._type.isAssignableFrom(e)},e.prototype.setConsumesRefs=function(e){this._consumesRef=e},e.prototype.definingPropertyIsEnough=function(e){this._defining.push(e)},e.prototype.getDefining=function(){return this._defining},e.prototype.getConsumesRefs=function(){return this._consumesRef},e.prototype.addAlias=function(e){this._aliases.push(e)},e.prototype.getAliases=function(){return this._aliases},e.prototype.valueRequirements=function(){return this._type.valueRequirements()},e.prototype.isAnnotation=function(){return this._annotationChecked?this._isAnnotation:(this._annotationChecked=!0,this._isAnnotation=this._type.allSuperTypes().some(function(e){return e.key()&&"AnnotationRef"==e.key().name}),this._isAnnotation)},e.prototype.allowValue=function(){return this._allowsValueSet?this._allowsValue:this._type.allProperties().some(function(e){return e.isFromParentValue()||e.canBeValue()})?(this._allowsValue=!0,this._allowsValueSet=!0,!0):(this._allowsValueSet=!0,!1)},e.prototype.key=function(){return this._type.key()},e.prototype.getRepresentationOf=function(){return this._representationOf},e.prototype.getPath=function(){return""},e.prototype.isDeclaration=function(){return this._isTemplate?!0:this._convertsToGlobal?!0:this._declaresType?!0:this.key()&&"Library"===this.key().name?!0:!1},e.prototype.isGlobalDeclaration=function(){return this._actuallyExports?!0:this._isTemplate?!0:this._declaresType?!0:!1},e.prototype.isTypeSystemMember=function(){return null!=this._declaresType},e.prototype.getExtendedType=function(){return this.universe().type(this._declaresType)},e.prototype.setInlinedTemplates=function(e){return this._isTemplate=e,this},e.prototype.getRuntimeExtenders=function(){return this._runtimeExtenders},e.prototype.isInlinedTemplates=function(){return this._isTemplate},e.prototype.setExtendedTypeName=function(t){this._declaresType=t;var n=this.universe().type(t);if(n instanceof h){var r=n;r.getAdapter(e)._runtimeExtenders.push(this._type)}},e.prototype.getKeyProp=function(){for(var e=this._type.allProperties(),t=0;t<e.length;t++)if(e[t].getAdapter(N).isKey())return e[t];return null},e.prototype.withActuallyExports=function(e){this._actuallyExports=e},e.prototype.withConvertsToGlobal=function(e){this._convertsToGlobal=e},e.prototype.getConvertsToGlobal=function(){return this._convertsToGlobal},e.prototype.getActuallyExports=function(){return this._actuallyExports},e.prototype.isUserDefined=function(){return this._type instanceof h?this._type.isUserDefined():this._type instanceof p?this._type.isUserDefined():!1},e.prototype.withContextRequirement=function(e,t){this._contextRequirements.push({name:e,value:t})},e.prototype.getContextRequirements=function(){return this._contextRequirements},e.prototype.findMembersDeterminer=function(){for(var e=this._type.allProperties(),t=0;t<e.length;t++)if(e[t].isThisPropertyDeclaresTypeFields())return e[t];return null},e.prototype.getDeclaringNode=function(){if(this._node)return this._node;if(this._type){var e=this._type.getExtra(t.SOURCE_EXTRA);return e?e instanceof f||e.getSource&&"function"==typeof e.getSource?e.getSource():e:null}return null},e.prototype.registerSupertypes=function(e){var t=this,n=this._type.universe();e.forEach(function(e){var r=n.type(e);r&&t._type.addSuperType(r)})},e.prototype.registerPossibleInterfaces=function(e){for(var t=this._type.universe(),n=0,r=e;n<r.length;n++){var i=r[n],a=t.type(i);if(!a)return;this._possibleInterfaces.push(a)}},e.prototype.possibleInterfaces=function(){return this._possibleInterfaces},e}();t.RAMLService=_;var w={},M=n(60),I=M.universeDumps,R=n(61),C=n(62);t.universesInfo=C,t.getUniverse=function(){var e=function(e){if(w[e])return w[e];var t=I[e],n=R.toDefSystem(t,"RAML08"==e?C.Universe08:C.Universe10);return n&&(n.setUniverseVersion(e),w[e]=n),n};return e.availableUniverses=function(){return Object.keys(I)},e}()},function(e,t,n){function r(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}function i(e,t,n){if(e&&l(e)&&e instanceof r)return e;var i=new r;return i.parse(e,t,n),i}function a(e){return u(e)&&(e=i(e)),e instanceof r?e.format():r.prototype.format.call(e)}function o(e,t){return i(e,!1,!0).resolve(t)}function s(e,t){return e?i(e,!1,!0).resolveObject(t):t}function u(e){return"string"==typeof e}function l(e){return"object"==typeof e&&null!==e}function p(e){return null===e}function c(e){return null==e}var f=n(87);t.parse=i,t.resolve=o,t.resolveObject=s,t.format=a,t.Url=r;var d=/^([a-z0-9.+-]+:)/i,m=/:[0-9]*$/,h=["<",">",'"',"`"," ","\r","\n","	"],y=["{","}","|","\\","^","`"].concat(h),v=["'"].concat(y),g=["%","/","?",";","#"].concat(v),A=["/","?","#"],S=255,E=/^[a-z0-9A-Z_-]{0,63}$/,T=/^([a-z0-9A-Z_-]{0,63})(.*)$/,b={javascript:!0,"javascript:":!0},N={javascript:!0,"javascript:":!0},_={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},w=n(86);r.prototype.parse=function(e,t,n){if(!u(e))throw new TypeError("Parameter 'url' must be a string, not "+typeof e);var r=e;r=r.trim();var i=d.exec(r);if(i){i=i[0];var a=i.toLowerCase();this.protocol=a,r=r.substr(i.length)}if(n||i||r.match(/^\/\/[^@\/]+@[^@\/]+/)){var o="//"===r.substr(0,2);!o||i&&N[i]||(r=r.substr(2),this.slashes=!0)}if(!N[i]&&(o||i&&!_[i])){for(var s=-1,l=0;l<A.length;l++){var p=r.indexOf(A[l]);-1!==p&&(-1===s||s>p)&&(s=p)}var c,m;m=-1===s?r.lastIndexOf("@"):r.lastIndexOf("@",s),-1!==m&&(c=r.slice(0,m),r=r.slice(m+1),this.auth=decodeURIComponent(c)),s=-1;for(var l=0;l<g.length;l++){var p=r.indexOf(g[l]);-1!==p&&(-1===s||s>p)&&(s=p)}-1===s&&(s=r.length),this.host=r.slice(0,s),r=r.slice(s),this.parseHost(),this.hostname=this.hostname||"";var h="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!h)for(var y=this.hostname.split(/\./),l=0,M=y.length;M>l;l++){var I=y[l];if(I&&!I.match(E)){for(var R="",C=0,L=I.length;L>C;C++)R+=I.charCodeAt(C)>127?"x":I[C];if(!R.match(E)){var P=y.slice(0,l),O=y.slice(l+1),D=I.match(T);D&&(P.push(D[1]),O.unshift(D[2])),O.length&&(r="/"+O.join(".")+r),this.hostname=P.join(".");break}}}if(this.hostname.length>S?this.hostname="":this.hostname=this.hostname.toLowerCase(),!h){for(var x=this.hostname.split("."),U=[],l=0;l<x.length;++l){var k=x[l];U.push(k.match(/[^A-Za-z0-9_-]/)?"xn--"+f.encode(k):k)}this.hostname=U.join(".")}var F=this.port?":"+this.port:"",B=this.hostname||"";this.host=B+F,this.href+=this.host,h&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==r[0]&&(r="/"+r))}if(!b[a])for(var l=0,M=v.length;M>l;l++){var K=v[l],V=encodeURIComponent(K);V===K&&(V=escape(K)),r=r.split(K).join(V)}var j=r.indexOf("#");-1!==j&&(this.hash=r.substr(j),r=r.slice(0,j));var W=r.indexOf("?");if(-1!==W?(this.search=r.substr(W),this.query=r.substr(W+1),t&&(this.query=w.parse(this.query)),r=r.slice(0,W)):t&&(this.search="",this.query={}),r&&(this.pathname=r),_[a]&&this.hostname&&!this.pathname&&(this.pathname="/"),this.pathname||this.search){var F=this.pathname||"",k=this.search||"";this.path=F+k}return this.href=this.format(),this},r.prototype.format=function(){var e=this.auth||"";e&&(e=encodeURIComponent(e),e=e.replace(/%3A/i,":"),e+="@");var t=this.protocol||"",n=this.pathname||"",r=this.hash||"",i=!1,a="";this.host?i=e+this.host:this.hostname&&(i=e+(-1===this.hostname.indexOf(":")?this.hostname:"["+this.hostname+"]"),this.port&&(i+=":"+this.port)),this.query&&l(this.query)&&Object.keys(this.query).length&&(a=w.stringify(this.query));var o=this.search||a&&"?"+a||"";return t&&":"!==t.substr(-1)&&(t+=":"),this.slashes||(!t||_[t])&&i!==!1?(i="//"+(i||""),n&&"/"!==n.charAt(0)&&(n="/"+n)):i||(i=""),r&&"#"!==r.charAt(0)&&(r="#"+r),o&&"?"!==o.charAt(0)&&(o="?"+o),n=n.replace(/[?#]/g,function(e){return encodeURIComponent(e)}),o=o.replace("#","%23"),t+i+n+o+r},r.prototype.resolve=function(e){return this.resolveObject(i(e,!1,!0)).format()},r.prototype.resolveObject=function(e){if(u(e)){var t=new r;t.parse(e,!1,!0),e=t}var n=new r;if(Object.keys(this).forEach(function(e){n[e]=this[e]},this),n.hash=e.hash,""===e.href)return n.href=n.format(),n;if(e.slashes&&!e.protocol)return Object.keys(e).forEach(function(t){"protocol"!==t&&(n[t]=e[t])}),_[n.protocol]&&n.hostname&&!n.pathname&&(n.path=n.pathname="/"),n.href=n.format(),n;if(e.protocol&&e.protocol!==n.protocol){if(!_[e.protocol])return Object.keys(e).forEach(function(t){n[t]=e[t]}),n.href=n.format(),n;if(n.protocol=e.protocol,e.host||N[e.protocol])n.pathname=e.pathname;else{for(var i=(e.pathname||"").split("/");i.length&&!(e.host=i.shift()););e.host||(e.host=""),e.hostname||(e.hostname=""),""!==i[0]&&i.unshift(""),i.length<2&&i.unshift(""),n.pathname=i.join("/")}if(n.search=e.search,n.query=e.query,n.host=e.host||"",n.auth=e.auth,n.hostname=e.hostname||e.host,n.port=e.port,n.pathname||n.search){var a=n.pathname||"",o=n.search||"";n.path=a+o}return n.slashes=n.slashes||e.slashes,n.href=n.format(),n}var s=n.pathname&&"/"===n.pathname.charAt(0),l=e.host||e.pathname&&"/"===e.pathname.charAt(0),f=l||s||n.host&&e.pathname,d=f,m=n.pathname&&n.pathname.split("/")||[],i=e.pathname&&e.pathname.split("/")||[],h=n.protocol&&!_[n.protocol];if(h&&(n.hostname="",n.port=null,n.host&&(""===m[0]?m[0]=n.host:m.unshift(n.host)),n.host="",e.protocol&&(e.hostname=null,e.port=null,e.host&&(""===i[0]?i[0]=e.host:i.unshift(e.host)),e.host=null),f=f&&(""===i[0]||""===m[0])),l)n.host=e.host||""===e.host?e.host:n.host,n.hostname=e.hostname||""===e.hostname?e.hostname:n.hostname,n.search=e.search,n.query=e.query,m=i;else if(i.length)m||(m=[]),m.pop(),m=m.concat(i),n.search=e.search,n.query=e.query;else if(!c(e.search)){if(h){n.hostname=n.host=m.shift();var y=n.host&&n.host.indexOf("@")>0?n.host.split("@"):!1;y&&(n.auth=y.shift(),n.host=n.hostname=y.shift())}return n.search=e.search,n.query=e.query,p(n.pathname)&&p(n.search)||(n.path=(n.pathname?n.pathname:"")+(n.search?n.search:"")),n.href=n.format(),n}if(!m.length)return n.pathname=null,n.search?n.path="/"+n.search:n.path=null,n.href=n.format(),n;for(var v=m.slice(-1)[0],g=(n.host||e.host)&&("."===v||".."===v)||""===v,A=0,S=m.length;S>=0;S--)v=m[S],"."==v?m.splice(S,1):".."===v?(m.splice(S,1),A++):A&&(m.splice(S,1),A--);if(!f&&!d)for(;A--;A)m.unshift("..");!f||""===m[0]||m[0]&&"/"===m[0].charAt(0)||m.unshift(""),g&&"/"!==m.join("/").substr(-1)&&m.push("");var E=""===m[0]||m[0]&&"/"===m[0].charAt(0);if(h){n.hostname=n.host=E?"":m.length?m.shift():"";var y=n.host&&n.host.indexOf("@")>0?n.host.split("@"):!1;y&&(n.auth=y.shift(),n.host=n.hostname=y.shift())}return f=f||n.host&&m.length,f&&!E&&m.unshift(""),m.length?n.pathname=m.join("/"):(n.pathname=null,n.path=null),p(n.pathname)&&p(n.search)||(n.path=(n.pathname?n.pathname:"")+(n.search?n.search:"")),n.auth=e.auth||n.auth,n.slashes=n.slashes||e.slashes,n.href=n.format(),n},r.prototype.parseHost=function(){var e=this.host,t=m.exec(e);t&&(t=t[0],":"!==t&&(this.port=t.substr(1)),e=e.substr(0,e.length-t.length)),e&&(this.hostname=e)}},function(e,t,n){"use strict";function r(e){var t=e;return t.valueName&&t.toHighLevel&&t.toHighLevel2}var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},a=n(73),o=n(54),s=n(70),u=n(24),l=n(33),p=n(18),c=n(39),f=n(14),d=n(65),m=function(){function e(e,t,n){this._parent=e,this._transformer=t,this.ramlVersion=n}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&d.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.hasInnerIncludeError=function(){return this._originalNode.hasInnerIncludeError()},e.prototype.keyKind=function(){return this._originalNode.keyKind()},e.prototype.primaryNode=function(){return null},e.prototype.isAnnotatedScalar=function(){return this._originalNode.isAnnotatedScalar()},e.prototype.actual=function(){return this._originalNode?this._originalNode.actual():this},e.prototype.transformer=function(){return this._transformer},e.prototype.setTransformer=function(e){this._transformer=e},e.prototype.originalNode=function(){return this._originalNode},e.prototype.start=function(){return this._originalNode.start()},e.prototype.end=function(){return this._originalNode.end()},e.prototype.value=function(e){throw new Error("The method must be overridden")},e.prototype.includeErrors=function(){return this._originalNode.includeErrors()},e.prototype.includePath=function(){return this._originalNode.includePath()},e.prototype.includeReference=function(){return this._originalNode.includeReference()},e.prototype.setKeyOverride=function(e){this._keyOverride=e},e.prototype.setValueOverride=function(e){this._valueOverride=e},e.prototype.key=function(e){return void 0===e&&(e=!1),this._keyOverride?this._keyOverride:this._originalNode.key(e)},e.prototype.optional=function(){return this.originalNode().optional()},e.prototype.children=function(){throw new Error("The method must be overridden")},e.prototype.parent=function(){return this._parent},e.prototype.unit=function(){return this._originalNode.unit()},e.prototype.containingUnit=function(){return this._originalNode.containingUnit()},e.prototype.includeBaseUnit=function(){return this._originalNode.unit()},e.prototype.anchorId=function(){return this._originalNode.anchorId()},e.prototype.errors=function(){return this._originalNode.errors()},e.prototype.anchoredFrom=function(){return this._originalNode.anchoredFrom()},e.prototype.includedFrom=function(){return this._originalNode.includedFrom()},e.prototype.visit=function(e){e(this)&&this.children().forEach(function(t){return t.visit(e)})},e.prototype.addChild=function(e){},e.prototype.execute=function(e){},e.prototype.dump=function(){return null},e.prototype.dumpToObject=function(e){var t=o.serialize2(this,e);if(this.kind()==a.Kind.MAPPING){var n={};return n[this.key(!0)]=t,n}return t},e.prototype.keyStart=function(){return this._originalNode.keyStart()},e.prototype.keyEnd=function(){return this._originalNode.keyEnd()},e.prototype.valueStart=function(){return this._originalNode.valueStart()},e.prototype.valueEnd=function(){return this._originalNode.valueEnd()},e.prototype.isValueLocal=function(){return this._originalNode.isValueLocal()},e.prototype.kind=function(){return this._originalNode.kind()},e.prototype.valueKind=function(){return this._originalNode.valueKind()},e.prototype.anchorValueKind=function(){return this._originalNode.anchorValueKind()},e.prototype.show=function(e){this._originalNode.show(e)},e.prototype.setHighLevelParseResult=function(e){this._highLevelParseResult=e},e.prototype.highLevelParseResult=function(){return this._highLevelParseResult},e.prototype.setHighLevelNode=function(e){this._highLevelNode=e},e.prototype.highLevelNode=function(){return this._highLevelNode?this._highLevelNode:this._originalNode.highLevelNode()},e.prototype.text=function(e){throw new Error("not implemented")},e.prototype.copy=function(){throw new Error("not implemented")},e.prototype.markup=function(e){throw new Error("not implemented")},e.prototype.nodeDefinition=function(){return u.getDefinitionForLowLevelNode(this)},e.prototype.includesContents=function(){return this._originalNode.includesContents()},e.prototype.root=function(){for(var e=this;e.parent();){var t=e.parent();e=t}return e},e.prototype.find=function(e){var t=null;return this.children().forEach(function(n){n.key()&&n.key()==e&&(t||(t=n))}),t},e.prototype.isMap=function(){return this.kind()==a.Kind.MAP},e.prototype.isMapping=function(){return this.kind()==a.Kind.MAPPING},e.prototype.isSeq=function(){return this.kind()==a.Kind.SEQ},e.prototype.isScalar=function(){return this.kind()==a.Kind.SCALAR},e.prototype.isValueSeq=function(){return this.valueKind()==a.Kind.SEQ},e.prototype.isValueMap=function(){return this.valueKind()==a.Kind.MAP},e.prototype.isValueInclude=function(){return this.valueKind()==a.Kind.INCLUDE_REF},e.prototype.isValueScalar=function(){return this.valueKind()==a.Kind.SCALAR},e.CLASS_IDENTIFIER="LowLevelASTProxy.LowLevelProxyNode",e}();t.LowLevelProxyNode=m;var h=function(e){function t(t,n,r,i,a){void 0===a&&(a=!0),e.call(this,n,r,i),this.isPrimary=a,this._adoptedNodes=[],this._preserveAnnotations=!1,this.nonMergableChildren={};var o=this.parent()?this.parent().originalNode():null;y.isInstance(t)?this._originalNode=t:this._originalNode=new y(t,o,r,this.ramlVersion),this._adoptedNodes.push(this._originalNode)}return i(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&d.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_LowLevelCompositeNode)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_LowLevelCompositeNode)},t.prototype.adoptedNodes=function(){return this._adoptedNodes},t.prototype.primaryNode=function(){return this.isPrimary?this._originalNode:null},t.prototype.parent=function(){return this._parent},t.prototype.adopt=function(e,t){t||(t=this._transformer);var n=this.parent()?this.parent().originalNode():null,r=new y(e,n,t,this.ramlVersion);this._adoptedNodes.push(r),this._children&&this._children.forEach(function(e){return e._parent=null}),this._children=null,this.highLevelNode()&&this.highLevelNode().resetChildren()},t.prototype.value=function(e){if(this._valueOverride)return this._valueOverride;var t,n=this._adoptedNodes.filter(function(e){return null!=e.value()});if(t=n.length>0?n[0].value(e):this._originalNode.value(e),y.isInstance(t)){var r=t.key();if(r)for(var i=this;1==i.children().length&&(i.kind()==a.Kind.MAPPING||i.kind()==a.Kind.MAP||i.kind()==a.Kind.SEQ);)if(i=i.children()[0],i.originalNode().key()==r){t=i;break}this._valueOverride=t}return t},t.prototype.children=function(){var e=this;if(this._children)return this._children;for(var n=[],r=!1,i=!1,o=0,s=this._adoptedNodes;o<s.length;o++){var u=s[o],l=u.children();l&&l.length>0&&(i=!0,l[0].key()&&this.originalNode().valueKind()!=a.Kind.SEQ&&(r=!0))}if(r)n=this.collectChildrenWithKeys();else if(i){n=this.collectChildrenWithKeys();var p={};this._adoptedNodes.forEach(function(r){return r.children().filter(function(e){return!e.key()}).forEach(function(i){var a=r==e.primaryNode(),o=e.buildKey(i);if(a||!p[o]){p[o]=!0;var s=r.transformer()?r.transformer():e.transformer(),u=y.isInstance(i)?i.originalNode():i;n.push(new t(u,e,s,e.ramlVersion,a))}})})}else n=[];return this._children=n,this._preserveAnnotations&&this._children.forEach(function(e){return e.preserveAnnotations()}),n},t.prototype.buildKey=function(e){var t=o.serialize(e),n=this.nodeDefinition();if(n&&(n.key()==p.Universe08.TraitRef||n.key()==p.Universe08.ResourceTypeRef||n.key()==p.Universe10.TraitRef||n.key()==p.Universe10.ResourceTypeRef)&&t&&"object"==typeof t){var r=Object.keys(t);r.length>0&&(t=r[0])}return null==t?"":s(t)},t.prototype.collectChildrenWithKeys=function(){for(var e=this,n=[],r={},i=0,a=this._adoptedNodes;i<a.length;i++)for(var o=a[i],s=o==this.primaryNode(),u=0,f=o.children();u<f.length;u++){var d=f[u],m=d.originalNode().key();if(!this.nonMergableChildren[m]||o==this._originalNode){if(m&&o.transformer()){var h=null!=m&&this._preserveAnnotations&&l.stringStartsWith(m,"(")&&l.stringEndsWith(m,")");h||(m=o.transformer().transform(m).value)}if(!this.skipKey(m,s)&&m){var y=r.hasOwnProperty(m)&&r[m];y||(y=[],r[m]=y),y.push({node:d.originalNode(),transformer:o.transformer(),isPrimary:s})}}}var v=this.unit().highLevel().root().definition().universe().version(),g=this.key()&&"/"==this.key()[0],A=c.getUniverse("RAML10").type(p.Universe10.Method.name),S=A.property(p.Universe10.Method.properties.method.name).enumOptions();return Object.keys(r).forEach(function(i){var a=r[i],o=!0,s=!1,u=S.indexOf(i)>=0;if(a.forEach(function(e){var t=e.node.optional()&&("RAML10"!=v||g&&u);o=o&&t,s=s||e.isPrimary}),s){var l=[];a.filter(function(e){return e.isPrimary}).forEach(function(n){var r=n.transformer?n.transformer:e.transformer();l.push(new t(n.node,e,r,e.ramlVersion,!0))});var p=l[0];a.filter(function(e){return!e.isPrimary}).forEach(function(e){p.adopt(e.node,e.transformer)}),l.forEach(function(e){return n.push(e)})}else if(!o){for(var c=a[0].transformer?a[0].transformer:e.transformer(),p=new t(a[0].node,e,c,e.ramlVersion,!1),f=1;f<a.length;f++)p.adopt(a[f].node,a[f].transformer);n.push(p)}}),n},t.prototype.isResource=function(){return this.highLevelNode()&&f.isResourceType(this.highLevelNode().definition())},t.prototype.skipKey=function(e,t){if(t)return!1;if("RAML08"!=this.ramlVersion)return!1;p.Universe08.Method,p.Universe08.Resource;return!1},t.prototype.valueKind=function(){if(this._originalNode.kind()!=a.Kind.MAPPING)return null;for(var e=0;e<this._adoptedNodes.length;e++){var t=this._adoptedNodes[e],n=t.originalNode().actual();if(n&&null!=n.value)return t.valueKind()}return null},t.prototype.includePath=function(){for(var e=0;e<this._adoptedNodes.length;e++){var t=this._adoptedNodes[e],n=t.includePath();if(null!=n)return n}return null},t.prototype.includeBaseUnit=function(){for(var t=0;t<this._adoptedNodes.length;t++){var n=this._adoptedNodes[t],r=n.includePath();if(null!=r)return n.unit()}return e.prototype.includeBaseUnit.call(this)},t.prototype.includeReference=function(){for(var e=0;e<this._adoptedNodes.length;e++){var t=this._adoptedNodes[e];if(null!=t.value())return t.includeReference()}return null},t.prototype.optional=function(){return d.all(this._adoptedNodes,function(e){return e.optional()})},t.prototype.replaceChild=function(e,n,r,i){void 0===r&&(r=!1),void 0===i&&(i=null),this._children||(this._children=[]);var a;if(a=t.isInstance(n)?n:new t(n,this,null,this.ramlVersion),null==e)return this._children.push(a),a;var o=this._children.indexOf(e);return o>=0?this._children[o]=a:this._children.push(a),a},t.prototype.removeChild=function(e){if(this._children&&null!=e){var t=this._children.indexOf(e);if(t>=0){for(var n=t;n<this._children.length-1;n++)this._children[n]=this._children[n+1];this._children.pop()}}},t.prototype.setChildren=function(e){var n=this;return null==e?void(this._children=null):(this._children=e.map(function(e){return t.isInstance(e)?e:new t(e,n,null,n.ramlVersion)}),void(this._preserveAnnotations&&this._children.forEach(function(e){return e.preserveAnnotations()})))},t.prototype.preserveAnnotations=function(){this._preserveAnnotations=!0,this._children&&this._children.forEach(function(e){return e.preserveAnnotations()})},t.prototype.filterChildren=function(){this.children();var e={},t=[];this._children.forEach(function(n){if(null!=n.key())return void t.push(n);var r=JSON.stringify(o.serialize(n));e[r]||(e[r]=!0,t.push(n))}),this._children=t},t.prototype.containingUnit=function(){for(var e={},t=0,n=this.adoptedNodes();t<n.length;t++){var r=n[t],i=r.containingUnit();i&&(e[i.absolutePath()]=!0)}return Object.keys(e).length<=1?this._originalNode.containingUnit():null},t.prototype.takeOnlyOriginalChildrenWithKey=function(e){this.nonMergableChildren[e]=!0},t.CLASS_IDENTIFIER_LowLevelCompositeNode="LowLevelASTProxy.LowLevelCompositeNode",t}(m);t.LowLevelCompositeNode=h;var y=function(e){function t(t,n,r,i){e.call(this,n,r,i),this._originalNode=t}return i(t,e),t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&d.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_LowLevelValueTransformingNode)},t.prototype.getClassIdentifier=function(){var n=e.prototype.getClassIdentifier.call(this);return n.concat(t.CLASS_IDENTIFIER_LowLevelValueTransformingNode)},t.prototype.value=function(e){var n=this.originalNode().value(e),r=this.transformer();if(r){var i=r.transform(n,e);n=i.value}return null==n||"object"!=typeof n||Array.isArray(n)?(null!=n&&e&&(n=""+n),n):new t(n,this._parent,this._transformer,this.ramlVersion)},t.prototype.children=function(){var e=this,n=null,r=this.originalNode();if(null!=this._transformer){var i=this._transformer.children(r);null!=i&&(n=i)}return null==n&&(n=r.children()),n.map(function(n){return new t(n,e,e._transformer,e.ramlVersion)})},t.prototype.valueKind=function(){var t=this._transformer&&this._transformer.valueKind(this.originalNode());return null!=t?t:e.prototype.valueKind.call(this)},t.prototype.includePath=function(){var t=this._transformer&&this._transformer.includePath(this.originalNode());return null!=t?t:e.prototype.includePath.call(this)},t.prototype.parent=function(){return this._parent},t.prototype.key=function(t){void 0===t&&(t=!1);var n=e.prototype.key.call(this,t);if(null!=this.transformer()){var r=this.transformer().transform(n).value;return"object"==typeof r?null:r}return n},t.CLASS_IDENTIFIER_LowLevelValueTransformingNode="LowLevelASTProxy.LowLevelValueTransformingNode",t}(m);t.LowLevelValueTransformingNode=y,t.isLowLevelProxyNode=r},function(e,t,n){"use strict";function r(e){for(var t=-1,n=e.lowLevel().children(),r=0;r<n.length;r++){var i=n[r];if(i.isMapping()){var a=i.asMapping().key.value,o=e.definition().property(a);o&&(o.isFromParentValue()||o.range().hasValueTypeInHierarchy())&&(t=r)}}return t}function i(e,t,n,r){var i=null,a=n&&n.getAdapter(M.RAMLPropertyService).isEmbedMap();if(a&&T.find(e.lowLevel().children(),function(e){return e.key()==n.nameId()})&&(a=!1),r||a){var o=v(e);i=o?o:A.InsertionPoint.atStart()}return i}function a(e){for(var t=e;t.originalNode&&t.originalNode();)t=t.originalNode();return t.asMapping()}function o(e,t){e.isStub()||e.clearChildrenCache();var n=e.children(),r=t.property()&&t.property().getAdapter(M.RAMLPropertyService).isEmbedMap();r&&T.find(e.lowLevel().children(),function(e){return e.key()==t.property().nameId()})&&(r=!1);if(!t.isAttr()&&!r||w.isMethodType(e.definition())&&t.property&&w.isIsProperty(t.property())){var i=t.property().nameId(),o=e.definition(),s=(o.allProperties(),e.lowLevel().children()),u=t.property();if(w.isTraitsProperty(u)||w.isResourceTypesProperty(u))return T.find(s,function(e){return e.isMapping()?a(e).key.value===t.property().nameId():!1});var l=o.propertyIndex(i);if(0>l)return null;for(var p=0;p<s.length;p++){var c=s[p];if(c.isMapping()){var f=a(c).key.value,d=o.propertyIndex(f);if(d>l){var m=p-1;return 0>m?null:(console.log("insert to node: "+m),s[m])}}}return null}for(var h=null,p=0;p<n.length&&n[p].isAttr();p++)n[p].property&&n[p].property()&&w.isIsProperty(n[p].property())||(h=n[p].lowLevel());return null==h&&(h=e.lowLevel()),h}function s(e,t){if(e.isStub()){if(N.ASTNodeImpl.isInstance(t)){var n=t;if(n.isInEdit)return}if(!e._children)return;return void(e._children=e._children.filter(function(e){return e!=t}))}var r=new E.CompositeCommand;if(N.ASTNodeImpl.isInstance(t)){var i=t;i.property().getAdapter(M.RAMLPropertyService).isMerged()?r.commands.push(E.removeNode(e.lowLevel(),i.lowLevel())):1==e.elementsOfKind(i.property().nameId()).length?r.commands.push(E.removeNode(e.lowLevel(),i.lowLevel().parent().parent())):r.commands.push(E.removeNode(e.lowLevel(),i.lowLevel()))}else r.commands.push(E.removeNode(e.lowLevel(),t.lowLevel()));e.lowLevel().execute(r)}function u(e){var t=(e.lowLevel().root(),new E.CompositeCommand),n=A.createMap([]);t.commands.push(E.initRamlFile(e.lowLevel(),n)),e.lowLevel().execute(t);var r=e.root();r._node=n,r.clearChildrenCache()}function l(e,t){if(t!=e.value()){var n=new E.CompositeCommand;if("string"==typeof t){var r=t;e.property().isFromParentKey()||e.property().isAnnotation()?(e.property().isAnnotation()&&(r="("+r+")"),n.commands.push(E.setKey(e.lowLevel(),r))):r&&0!=r.length||e.isEmbedded()?(r||(r=""),n.commands.push(E.setAttr(e.lowLevel(),r))):(n.commands.push(E.removeNode(e.lowLevel().parent(),e.lowLevel())),e.parent().clearChildrenCache())}else{if(e.property().isFromParentKey())throw new Error("couldn't set structured value to a key: "+e.property().nameId());var i=t;n.commands.push(E.setAttrStructured(e.lowLevel(),i))}e.lowLevel().execute(n)}}function p(e,t){var n=A.createScalar(t),r=e.lowLevel();r.isScalar()?r=r.parent():r.isMapping();var i=new E.CompositeCommand;i.commands.push(E.insertNode(r,n,null,!0)),e.lowLevel().execute(i),e.parent().clearChildrenCache()}function c(e,t){var n=e.lowLevel();if(n.isScalar())n=n.parent();else if(n.isMapping()){e.lowLevel()}var r=new E.CompositeCommand;r.commands.push(E.insertNode(n,t.lowLevel(),null,!0)),e.lowLevel().execute(r),e.parent().clearChildrenCache()}function f(e){var t=e.lowLevel().parent();if(!e.property().isMultiValue()&&e.isEmbedded())e.setValue("");else{var n=new E.CompositeCommand;n.commands.push(E.removeNode(t,e.lowLevel())),e.lowLevel().execute(n),e.parent().clearChildrenCache()}}function d(e,t){if(!e.property().isMultiValue())throw new Error("setValue(string[]) only apply to multi-values properties");var n=e.parent();if(n&&h(n)){var r=new E.CompositeCommand;return r.commands.push(E.setAttr(n.lowLevel(),t[0])),void n.lowLevel().execute(r)}if(e.isEmpty());else{var i=(n.lowLevel(),n.attributes(e.name()));i.forEach(function(e){return e.remove()})}1==t.length&&e.property().isDescriminator()?n.attrOrCreate(e.name()).setValue(t[0]):t.forEach(function(t){return n.attrOrCreate(e.name()).addValue(t)})}function m(e,t){if(t!=e.name()){var n=new E.CompositeCommand;n.commands.push(E.setKey(e.lowLevel(),t)),e.lowLevel().execute(n)}}function h(e){return e.definition()&&e.definition().isAssignableFrom(_.Universe10.TypeDeclaration.name)&&e.lowLevel()&&e.lowLevel().valueKind()===b.Kind.SCALAR?!0:!1}function y(e,t,n){var a=A.createMapping(t,n);if(e.definition()&&e.definition().isAssignableFrom(_.Universe10.TypeDeclaration.name)&&e.lowLevel()&&(e.lowLevel().valueKind()===b.Kind.SCALAR||!e.lowLevel()._node.value)){var o=t,s=A.createMapping(o,e.lowLevel().value()),u=new E.CompositeCommand;u.commands.push(E.setAttr(e.lowLevel(),"")),e.lowLevel().execute(u),u=new E.CompositeCommand;var l=i(e,s,e.definition().property(o),!0);u.commands.push(E.insertNode(e.lowLevel(),s,l)),e.lowLevel().execute(u),e.resetChildren();var p=e.attr(o)&&e.attr(o).lowLevel();if(p)return u=new E.CompositeCommand,u.commands.push(E.setAttr(p,n)),p.execute(u),void e.clearChildrenCache()}if(e.isStub()){var c=r(e);e.lowLevel().addChild(a,c+1)}else{e.isEmptyRamlFile()&&e.initRamlFile();var u=new E.CompositeCommand,l=i(e,a,e.definition().property(t),!0);u.commands.push(E.insertNode(e.lowLevel(),a,l)),e.lowLevel().execute(u)}e.clearChildrenCache()}function v(e){var t=e.lowLevel().children(),n=r(e);return 0>n?null:t[n]}function g(e,t){!e.isStub()&&e.isEmptyRamlFile()&&e.initRamlFile();var n=t.lowLevel();if(e._children||(e._children=[]),!t.property()){var i=t,a=e.definition().allProperties(),s=null;if(a.forEach(function(e){var t=e.range();t==i.definition()&&(s=e);var n=T.find(i.definition().allSuperTypes(),function(e){return e==t});n&&(s=e)}),!s)throw new Error("Unable to find correct child");
i.patchProp(s)}var u=o(e,t),l=new E.CompositeCommand,p=null;if(t.property().getAdapter(M.RAMLPropertyService).isMerged()||t.property().range().hasValueTypeInHierarchy())l.commands.push(E.insertNode(e.lowLevel(),t.lowLevel(),u)),p=e.lowLevel();else{var c=t.property().nameId(),f=e.lowLevel(),d=e.lowLevel().find(c);if(p=d,d){var m=null===d.value()&&d.key&&d.key()===_.Universe10.Api.properties.types.name,h=!m&&t.property().getAdapter(M.RAMLPropertyService).isEmbedMap();l.commands.push(E.insertNode(d,t.lowLevel(),u,h))}else{var y=null;if(t.property().getAdapter(M.RAMLPropertyService).isEmbedMap()){var v="RAML10"==e.definition().universe().version();y=n.isValueMap()&&v?A.createMapNode(c):A.createSeqNode(c),y.addChild(t.lowLevel())}else y=A.createNode(c),y.addChild(t.lowLevel());l.commands.push(E.insertNode(f,y,u)),p=f}}if(e.isStub()){var g=r(e);return 0>g?e._children.push(t):e._children.splice(g,0,t),void l.commands.forEach(function(e){return p.addChild(e.value)})}e.lowLevel().execute(l),e._children.push(t),t.setParent(e)}var A=n(24),S=n(39),E=n(10),T=n(65),b=n(73),N=n(16),_=n(18),w=n(14),M=S;t.removeNodeFrom=s,t.initEmptyRAMLFile=u,t.setValue=l,t.addStringValue=p,t.addStructuredValue=c,t.removeAttr=f,t.setValues=d,t.setKey=m,t.createAttr=y,t.addToNode=g},function(e,t,n){"use strict";function r(e,t){var n=e.root().definition().universe(),i=e.lowLevel().key();if(i&&E(i,t,null,!0,n),e.children().forEach(function(e){return r(e,t)}),y.ASTPropImpl.isInstance(e)){var a=e,o=a.value();if("string"==typeof o){var s=o;E(s,t,a,!1,n)}else e.lowLevel().visit(function(e){if(e.value()){var r=e.value()+"";E(r,t,a,!0,n)}return!0})}else if(y.BasicASTNode.isInstance(e)){var o=e.lowLevel().value();if("string"==typeof o){var s=o;E(s,t,null,!1,n)}else e.lowLevel().visit(function(e){if(e.value()){var r=e.value()+"";E(r,t,null,!0,n)}return!0})}}function i(e,t,n){void 0===n&&(n=[]),e.optional()&&(n=n.concat("/"));var r=e.value();if("string"==typeof r)for(var a=r,o=S(a),s=o.parameterUsages,u=0,l=s;u<l.length;u++){var p=l[u],c=t[p];null==c&&(c=[],t[p]=c),c.push(n)}else for(var f=0,d=e.children();f<d.length;f++){var m=d[f];i(m,t,n.concat(m.key()))}}function a(e,t){var n={},a={};r(t,n),i(t.lowLevel(),a);for(var o=0,s=Object.keys(a);o<s.length;o++){var u=s[o];a[u]=m.unique(a[u])}e.getAdapter(v.RAMLService).setInlinedTemplates(!0),Object.keys(n).forEach(function(r){var i=null;n[r].length>0&&(i=n[r][0].attr);var o=new f.UserDefinedProp(r,i);o.withDomain(e);var s=a[r];o.getAdapter(v.RAMLPropertyService).putMeta("templatePaths",s);var u;if("RAML10"==t.definition().universe().version()){var l=n[r].filter(function(e){return A.isStringTypeType(e.tp)}).length>0;u=l?h.Universe10.StringType.name:h.Universe10.AnyType.name}else u=h.Universe08.StringType.name;var p=m.unique(n[r].map(function(e){return e.tp})).filter(function(e){return e&&e.nameId()!=u});o.withRange(1==p.length?p[0]:t.definition().universe().type(u)),o.withRequired(!0),1==p.length&&"RAML10"==t.definition().universe().version()&&p[0].key()==h.Universe10.SchemaString&&o.getAdapter(v.RAMLPropertyService).setTypeExpression(!0),o.unmerge()});var l=new f.UserDefinedProp("____key",t);return l.withDomain(e),l.withKey(!0),l.withFromParentKey(!0),l.withRange(t.definition().universe().type(h.Universe08.StringType.name)),e}function o(e,t){"RAML08"==t.universe().version()&&e.getAdapter(v.RAMLService).withAllowAny();var n=t.property(t.getAdapter(v.RAMLService).getReferenceIs());return n&&n.range().properties().forEach(function(t){var n=new f.Property(t.nameId());n.unmerge(),n.withDomain(e),n.withRange(t.range()),n.withMultiValue(t.isMultiValue())}),e}function s(e){if(!e)return null;if(e.associatedType())return e.associatedType();var t=e.lowLevel().unit(),n=t?t.path():"";d.setPropertyConstructor(function(t){var n=null,r=e.elementsOfKind("properties").filter(function(e){return e.name()==t});r&&(n=r[0]);var i=new f.UserDefinedProp(t,n);return i.unmerge(),i});try{var r=e.definition();if(e.property()&&e.property().nameId()==h.Universe10.LibraryBase.properties.annotationTypes.name){var i=new T(e.name(),e.definition().universe(),e,n,""),s=u(e);i._superTypes.push(s),0==e.elementsOfKind(h.Universe10.ObjectTypeDeclaration.properties.properties.name).length&&i.getAdapter(v.RAMLService).withAllowAny();var l=r.getAdapter(v.RAMLService).getExtendedType();return l&&i._superTypes.push(l),i}var i=new f.UserDefinedClass(e.name(),e.definition().universe(),e,n,"");if(e.setAssociatedType(i),r.getAdapter(v.RAMLService).isInlinedTemplates())return a(i,e);if(r.getAdapter(v.RAMLService).getReferenceIs())return o(i,r);var p=u(e);p.getAdapter(v.RAMLService).setDeclaringNode(e),e.setAssociatedType(p)}finally{d.setPropertyConstructor(null)}return p}function u(e){return d.toNominal(e.parsedType(),function(t){var n=e.definition().universe().type(t);if(!n){new f.UserDefinedClass("",e.definition().universe(),e,"","")}return n})}function l(e){return function(t){var n=e.type(t);if(!n){new f.UserDefinedClass("",e,null,"","")}return n}}function p(e,t){var n=m.find(e.elementsOfKind("types"),function(e){return e.name()==t.name()});n&&d.setPropertyConstructor(function(e){var t=n.elementsOfKind("properties").filter(function(t){return t.name()==e}),r=null;if(t&&t.length>0)r=t[0];else{var t=n.elementsOfKind("facets").filter(function(t){return t.name()==e});t&&t.length>0&&(r=t[0])}var i=new f.UserDefinedProp(e,r);return i.unmerge(),i});var r=l(e.definition().universe());return d.toNominal(t,r)}var c=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},f=n(39),d=f.rt,m=n(65),h=n(18),y=n(16),v=f,g=n(28),A=n(14);d.setPropertyConstructor(function(e){var t=new f.Property(e);return t.unmerge(),t});var S=function(e){for(var t=[],n=0;;){var r=e.indexOf("<<",n);if(-1==r)break;var i=e.indexOf(">>",r),a=0==r&&i==e.length-2,o=e.substring(r+2,i);n=r+2;var s=o.indexOf("|");-1!=s&&(o=o.substring(0,s)),o=o.trim(),t.push(o)}return{parameterUsages:t,isFull:a}},E=function(e,t,n,r,i){var a=S(e),o=a.parameterUsages,s=a.isFull,u=n?n.property().range():null;n&&(n.property().nameId()==h.Universe10.TypeDeclaration.properties.type.name||n.property().nameId()==h.Universe10.TypeDeclaration.properties.schema.name)&&n.property().domain().key()==h.Universe10.TypeDeclaration&&(u=i.type(h.Universe10.SchemaString.name)),!s||r?u=i.type(h.Universe10.StringType.name):null==u&&"RAML10"==i.version()&&(u=i.type(h.Universe10.AnyType.name));for(var l=0,p=o;l<p.length;l++){var c=p[l];if(null==g.RESERVED_TEMPLATE_PARAMETERS[c]){var f=t[c];f?f.push({tp:u,attr:n}):t[c]=[{tp:u,attr:n}]}}},T=function(e){function t(){e.apply(this,arguments)}return c(t,e),t.prototype.allProperties=function(e){void 0===e&&(e={});var t=this.superTypes()[0].allProperties();if(1==t.length&&"annotations"==t[0].nameId()){var n=this.getAdapter(f.RAMLService).getDeclaringNode(),r=new f.UserDefinedProp("value",n);r.withDomain(this),r.withCanBeValue(),r.withRequired(!1);this.superTypes()[0];t=[],r.withRange(r.node().asElement().definition().universe().type("string")),t.push(r)}return t},t.prototype.isAnnotationType=function(){return!0},t}(f.UserDefinedClass);t.typeFromNode=s,t.convertType=p},function(e,t,n){"use strict";function r(e){return e&&e.indexOf("\n")>=0}function i(e){return r(e)&&e.length>2&&"|"==e[0]&&("\n"==e[1]||"\r"==e[1]||"\n"==e[2])}function a(e,t){var n="";if(r(e)){n+="|\n";for(var i=d(e),a=0;a<i.length;a++)n+=u(t,i[a])}else n+=e;return n}function o(e){if(!i(e))return e;for(var t=null,n=d(e),r=1;r<n.length;r++){var a=n[r],o=a.substring(2);t?t+=o:t=o}return t}function s(e){if(!e)return e;for(var t=0;t<e.length;){var n=e[t];if("\r"!=n&&"\n"!=n&&" "!=n&&"	"!=n)break;t++}return e.substring(t,e.length)}function u(e,t){void 0===t&&(t="");for(var n="",r=0;e>r;r++)n+="  ";return n+t}function l(e,t){void 0===t&&(t=""),console.log(u(e,t))}function p(e,t){void 0===t&&(t=null);for(var n="",r=0;r<e.length;r++){var i=e[r];"\r"==i&&(i=null==t?"\\r":t),"\n"==i&&(i=null==t?"\\n":t),n+=i}return n}function c(e){for(var t=e.length;t>0;){var n=e[t-1];if(" "!=n&&"	"!=n&&"\r"!=n&&"\n"!=n)break;t--}return e.substring(0,t)}function f(e){return s(c(e))}function d(e){var t=e.match(/^.*((\r\n|\n|\r)|$)/gm);return t}function m(e,t){if(!e||!t||e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[n]!=t[n])return!1;return!0}function h(e,t){if(!e||!t||e.length<t.length)return!1;for(var n=0;n<t.length;n++)if(e[e.length-1-n]!=t[t.length-1-n])return!1;return!0}function y(e){return e.charAt(0).toUpperCase()+e.slice(1)}t.isMultiLine=r,t.isMultiLineValue=i,t.makeMutiLine=a,t.fromMutiLine=o,t.trimStart=s,t.indent=u,t.print=l,t.replaceNewlines=p,t.trimEnd=c,t.trim=f,t.splitOnLines=d,t.startsWith=m,t.endsWith=h,t.capitalize=y;var v=function(){function e(e,t,n){this.contents=e,this.start=t,this.end=n}return e.prototype.text=function(){return this.contents.substring(this.start,this.end)},e.prototype.startpos=function(){return this.start},e.prototype.endpos=function(){return this.end},e.prototype.len=function(){return this.end-this.start},e.prototype.unitText=function(){return this.contents},e.prototype.withStart=function(t){return new e(this.contents,t,this.end)},e.prototype.withEnd=function(t){return new e(this.contents,this.start,t)},e.prototype.sub=function(e,t){return this.contents.substring(e,t)},e.prototype.trimStart=function(){for(var t=this.start;t<this.contents.length-1;){var n=this.contents[t];if(" "!=n&&"	"!=n)break;t++}return new e(this.contents,t,this.end)},e.prototype.trimEnd=function(){for(var t=this.end;t>0;){var n=this.contents[t-1];if(" "!=n&&"	"!=n)break;t--}return new e(this.contents,this.start,t)},e.prototype.extendToStartOfLine=function(){for(var t=this.start;t>0;){var n=this.contents[t-1];if("\r"==n||"\n"==n)break;t--}return new e(this.contents,t,this.end)},e.prototype.extendAnyUntilNewLines=function(){var t=this.end;if(t>0){var n=this.contents[t-1];if("\n"==n)return this}for(;t<this.contents.length-1;){var r=this.contents[t];if("\r"==r||"\n"==r)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendSpacesUntilNewLines=function(){var t=this.end;if(t>0){var n=this.contents[t-1];if("\n"==n)return this}for(;t<this.contents.length-1;){var r=this.contents[t];if(" "!=r||"\r"==r||"\n"==r)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendSpaces=function(){for(var t=this.end;t<this.contents.length-1;){var n=this.contents[t];if(" "!=n)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendSpacesBack=function(){for(var t=this.start;t>0;){var n=this.contents[t-1];if(" "!=n)break;t--}return new e(this.contents,t,this.end)},e.prototype.extendCharIfAny=function(t){var n=this.end;return n<this.contents.length-1&&this.contents[n]==t&&n++,new e(this.contents,this.start,n)},e.prototype.extendCharIfAnyBack=function(t){var n=this.start;return n>0&&this.contents[n-1]==t&&n--,new e(this.contents,n,this.end)},e.prototype.extendToNewlines=function(){var t=this.end;if(t>0){var n=this.contents[t-1];if("\n"==n)return this}for(;t<this.contents.length-1;){var r=this.contents[t];if("\r"!=r&&"\n"!=r)break;t++}return new e(this.contents,this.start,t)},e.prototype.extendUntilNewlinesBack=function(){for(var t=this.start;t>0;){var n=this.contents[t-1];if("\r"==n||"\n"==n)break;t--}return new e(this.contents,t,this.end)},e.prototype.reduceNewlinesEnd=function(){for(var t=this.end;t>this.start;){var n=this.contents[t-1];if("\r"!=n&&"\n"!=n)break;t--}return new e(this.contents,this.start,t)},e.prototype.reduceSpaces=function(){for(var t=this.end;t>this.start;){var n=this.contents[t-1];if(" "!=n)break;t--}return new e(this.contents,this.start,t)},e.prototype.replace=function(e){return this.sub(0,this.start)+e+this.sub(this.end,this.unitText().length)},e.prototype.remove=function(){return this.sub(0,this.start)+this.sub(this.end,this.unitText().length)},e}();t.TextRange=v},function(e,t,n){"use strict";function r(e){return e.isBuiltIn()?s[e.nameId()]:null}function i(e,t){void 0===t&&(t=!0);var n=e.definition(),i=(n.nameId(),r(n));if(!i){for(var o=a(n),u=n.allSuperTypes().sort(function(e,t){return o[e.nameId()]-o[t.nameId()]}),l=null,p=0;p<u.length;p++){var c=u[p].nameId();if(i=r(u[p]),"DataElement"!=c){if("hl.BasicNode"!=c&&i)break}else l=c}i||(l=c)}return i||(i=s["hl.BasicNode"]),i(e,t)}function a(e,t,n){void 0===t&&(t={}),void 0===n&&(n={});var r=e.nameId();if(!n[r]){n[r]=!0;var i=null!=t[r]&&t[r]+1||0,o=e.superTypes();return o.forEach(function(e){var r=e.nameId(),o=t[r];(null==o||i>o)&&(t[r]=i,a(e,t,n))}),delete n[r],t}}var o=n(21);t.buildWrapperNode=i;var s={AbstractSecurityScheme:function(e,t){return new o.AbstractSecuritySchemeImpl(e,t)},Annotable:function(e,t){return new o.AnnotableImpl(e,t)},AnnotationRef:function(e){return new o.AnnotationRefImpl(e)},AnnotationTarget:function(e){return new o.AnnotationTargetImpl(e)},AnyType:function(e){return new o.AnyTypeImpl(e)},Api:function(e,t){return new o.ApiImpl(e,t)},ArrayTypeDeclaration:function(e,t){return new o.ArrayTypeDeclarationImpl(e,t)},BasicSecurityScheme:function(e,t){return new o.BasicSecuritySchemeImpl(e,t)},BooleanType:function(e){return new o.BooleanTypeImpl(e)},BooleanTypeDeclaration:function(e,t){return new o.BooleanTypeDeclarationImpl(e,t)},ContentType:function(e){return new o.ContentTypeImpl(e)},CustomSecurityScheme:function(e,t){return new o.CustomSecuritySchemeImpl(e,t)},DateOnlyType:function(e){return new o.DateOnlyTypeImpl(e)},DateOnlyTypeDeclaration:function(e,t){return new o.DateOnlyTypeDeclarationImpl(e,t)},DateTimeOnlyType:function(e){return new o.DateTimeOnlyTypeImpl(e)},DateTimeOnlyTypeDeclaration:function(e,t){return new o.DateTimeOnlyTypeDeclarationImpl(e,t)},DateTimeType:function(e){return new o.DateTimeTypeImpl(e)},DateTimeTypeDeclaration:function(e,t){return new o.DateTimeTypeDeclarationImpl(e,t)},DigestSecurityScheme:function(e,t){return new o.DigestSecuritySchemeImpl(e,t)},DocumentationItem:function(e,t){return new o.DocumentationItemImpl(e,t)},Extension:function(e,t){return new o.ExtensionImpl(e,t)},FileType:function(e){return new o.FileTypeImpl(e)},FileTypeDeclaration:function(e,t){return new o.FileTypeDeclarationImpl(e,t)},FixedUriString:function(e){return new o.FixedUriStringImpl(e)},FragmentDeclaration:function(e,t){return new o.FragmentDeclarationImpl(e,t)},FullUriTemplateString:function(e){return new o.FullUriTemplateStringImpl(e)},IntegerType:function(e){return new o.IntegerTypeImpl(e)},IntegerTypeDeclaration:function(e,t){return new o.IntegerTypeDeclarationImpl(e,t)},Library:function(e,t){return new o.LibraryImpl(e,t)},LibraryBase:function(e,t){return new o.LibraryBaseImpl(e,t)},LocationKind:function(e){return new o.LocationKindImpl(e)},MarkdownString:function(e){return new o.MarkdownStringImpl(e)},Method:function(e,t){return new o.MethodImpl(e,t)},MethodBase:function(e,t){return new o.MethodBaseImpl(e,t)},MimeType:function(e){return new o.MimeTypeImpl(e)},ModelLocation:function(e){return new o.ModelLocationImpl(e)},NullType:function(e){return new o.NullTypeImpl(e)},NumberType:function(e){return new o.NumberTypeImpl(e)},NumberTypeDeclaration:function(e,t){return new o.NumberTypeDeclarationImpl(e,t)},OAuth1SecurityScheme:function(e,t){return new o.OAuth1SecuritySchemeImpl(e,t)},OAuth1SecuritySchemeSettings:function(e,t){return new o.OAuth1SecuritySchemeSettingsImpl(e,t)},OAuth2SecurityScheme:function(e,t){return new o.OAuth2SecuritySchemeImpl(e,t)},OAuth2SecuritySchemeSettings:function(e,t){return new o.OAuth2SecuritySchemeSettingsImpl(e,t)},ObjectTypeDeclaration:function(e,t){return new o.ObjectTypeDeclarationImpl(e,t)},Operation:function(e,t){return new o.OperationImpl(e,t)},Overlay:function(e,t){return new o.OverlayImpl(e,t)},PassThroughSecurityScheme:function(e,t){return new o.PassThroughSecuritySchemeImpl(e,t)},Reference:function(e){return new o.ReferenceImpl(e)},RelativeUriString:function(e){return new o.RelativeUriStringImpl(e)},Resource:function(e,t){return new o.ResourceImpl(e,t)},ResourceBase:function(e,t){return new o.ResourceBaseImpl(e,t)},ResourceType:function(e,t){return new o.ResourceTypeImpl(e,t)},ResourceTypeRef:function(e){return new o.ResourceTypeRefImpl(e)},Response:function(e,t){return new o.ResponseImpl(e,t)},SchemaString:function(e){return new o.SchemaStringImpl(e)},SecuritySchemePart:function(e,t){return new o.SecuritySchemePartImpl(e,t)},SecuritySchemeRef:function(e){return new o.SecuritySchemeRefImpl(e)},SecuritySchemeSettings:function(e,t){return new o.SecuritySchemeSettingsImpl(e,t)},StatusCodeString:function(e){return new o.StatusCodeStringImpl(e)},StringType:function(e){return new o.StringTypeImpl(e)},StringTypeDeclaration:function(e,t){return new o.StringTypeDeclarationImpl(e,t)},TimeOnlyType:function(e){return new o.TimeOnlyTypeImpl(e)},TimeOnlyTypeDeclaration:function(e,t){return new o.TimeOnlyTypeDeclarationImpl(e,t)},Trait:function(e,t){return new o.TraitImpl(e,t)},TraitRef:function(e){return new o.TraitRefImpl(e)},TypeDeclaration:function(e,t){return new o.TypeDeclarationImpl(e,t)},UnionTypeDeclaration:function(e,t){return new o.UnionTypeDeclarationImpl(e,t)},UriTemplate:function(e){return new o.UriTemplateImpl(e)},UsesDeclaration:function(e,t){return new o.UsesDeclarationImpl(e,t)},ValueType:function(e){return new o.ValueTypeImpl(e)},XMLFacetInfo:function(e,t){return new o.XMLFacetInfoImpl(e,t)}}},function(e,t,n){"use strict";function r(e){return e.isBuiltIn()?s[e.nameId()]:null}function i(e,t){void 0===t&&(t=!0);var n=e.definition(),i=(n.nameId(),r(n));if(!i){for(var o=a(n),u=n.allSuperTypes().sort(function(e,t){return o[e.nameId()]-o[t.nameId()]}),l=null,p=0;p<u.length;p++){var c=u[p].nameId();if(i=r(u[p]),"DataElement"!=c){if("hl.BasicNode"!=c&&i)break}else l=c}i||(l=c)}return i||(i=s["hl.BasicNode"]),i(e,t)}function a(e,t,n){void 0===t&&(t={}),void 0===n&&(n={});var r=e.nameId();if(!n[r]){n[r]=!0;var i=null!=t[r]&&t[r]+1||0,o=e.superTypes();return o.forEach(function(e){var r=e.nameId(),o=t[r];(null==o||i>o)&&(t[r]=i,a(e,t,n))}),delete n[r],t}}var o=n(52);t.buildWrapperNode=i;var s={AbstractSecurityScheme:function(e,t){return new o.AbstractSecuritySchemeImpl(e,t)},AnyType:function(e){return new o.AnyTypeImpl(e)},Api:function(e,t){return new o.ApiImpl(e,t)},BasicSecurityScheme:function(e,t){return new o.BasicSecuritySchemeImpl(e,t)},BodyLike:function(e,t){return new o.BodyLikeImpl(e,t)},BooleanType:function(e){return new o.BooleanTypeImpl(e)},BooleanTypeDeclaration:function(e,t){return new o.BooleanTypeDeclarationImpl(e,t)},CustomSecurityScheme:function(e,t){return new o.CustomSecuritySchemeImpl(e,t)},DateTypeDeclaration:function(e,t){return new o.DateTypeDeclarationImpl(e,t)},DigestSecurityScheme:function(e,t){return new o.DigestSecuritySchemeImpl(e,t)},DocumentationItem:function(e,t){return new o.DocumentationItemImpl(e,t)},ExampleString:function(e){return new o.ExampleStringImpl(e)},FileTypeDeclaration:function(e,t){return new o.FileTypeDeclarationImpl(e,t)},FixedUri:function(e){return new o.FixedUriImpl(e)},FullUriTemplateString:function(e){return new o.FullUriTemplateStringImpl(e)},GlobalSchema:function(e,t){return new o.GlobalSchemaImpl(e,t)},IntegerTypeDeclaration:function(e,t){return new o.IntegerTypeDeclarationImpl(e,t)},JSONBody:function(e,t){return new o.JSONBodyImpl(e,t)},JSONExample:function(e){return new o.JSONExampleImpl(e)},JSonSchemaString:function(e){return new o.JSonSchemaStringImpl(e)},MarkdownString:function(e){return new o.MarkdownStringImpl(e)},Method:function(e,t){return new o.MethodImpl(e,t)},MethodBase:function(e,t){return new o.MethodBaseImpl(e,t)},MimeType:function(e){return new o.MimeTypeImpl(e)},NumberType:function(e){return new o.NumberTypeImpl(e)},NumberTypeDeclaration:function(e,t){return new o.NumberTypeDeclarationImpl(e,t)},OAuth1SecurityScheme:function(e,t){return new o.OAuth1SecuritySchemeImpl(e,t)},OAuth1SecuritySchemeSettings:function(e,t){return new o.OAuth1SecuritySchemeSettingsImpl(e,t)},OAuth2SecurityScheme:function(e,t){return new o.OAuth2SecuritySchemeImpl(e,t)},OAuth2SecuritySchemeSettings:function(e,t){return new o.OAuth2SecuritySchemeSettingsImpl(e,t)},Parameter:function(e,t){return new o.ParameterImpl(e,t)},ParameterLocation:function(e){return new o.ParameterLocationImpl(e)},RAMLSimpleElement:function(e,t){return new o.RAMLSimpleElementImpl(e,t)},Reference:function(e){return new o.ReferenceImpl(e)},RelativeUriString:function(e){return new o.RelativeUriStringImpl(e)},Resource:function(e,t){return new o.ResourceImpl(e,t)},ResourceType:function(e,t){return new o.ResourceTypeImpl(e,t)},ResourceTypeRef:function(e){return new o.ResourceTypeRefImpl(e)},Response:function(e,t){return new o.ResponseImpl(e,t)},SchemaString:function(e){return new o.SchemaStringImpl(e)},SecuritySchemePart:function(e,t){return new o.SecuritySchemePartImpl(e,t)},SecuritySchemeRef:function(e){return new o.SecuritySchemeRefImpl(e)},SecuritySchemeSettings:function(e,t){return new o.SecuritySchemeSettingsImpl(e,t)},StatusCodeString:function(e){return new o.StatusCodeStringImpl(e)},StringType:function(e){return new o.StringTypeImpl(e)},StringTypeDeclaration:function(e,t){return new o.StringTypeDeclarationImpl(e,t)},Trait:function(e,t){return new o.TraitImpl(e,t)},TraitRef:function(e){return new o.TraitRefImpl(e)},UriTemplate:function(e){return new o.UriTemplateImpl(e)},ValueType:function(e){return new o.ValueTypeImpl(e)},XMLBody:function(e,t){return new o.XMLBodyImpl(e,t)},XMLExample:function(e){return new o.XMLExampleImpl(e)},XMLSchemaString:function(e){return new o.XMLSchemaStringImpl(e)}}},function(e,t,n){},function(e,t,n){},function(e,t,n){"use strict";function r(e){var t=e.value();if("string"==typeof t||null==t){var n=f.createNode(t,null,e.lowLevel().unit());n._actualNode().startPosition=e.lowLevel().valueStart(),n._actualNode().endPosition=e.lowLevel().valueEnd();var r=new c.StructuredValue(n,e.parent(),e.property());return r}return t}function i(e){var t=e._meta;t.resetPrimitiveValuesMeta();var n=e.highLevel();return n.definition().allProperties().forEach(function(r){var i=r.nameId(),a=n.attributes(i),o=!1,s=!1;if(a.forEach(function(e){o=o||null!=e.value(),s=s||e.optional()}),!o){var u=e.getDefaultsCalculator(),l=u.attributeDefaultIfEnabled(n,r);if(null!=l){var p=u.insertionKind(n,r);p==d.InsertionKind.CALCULATED?t.registerCalculatedValue(i):p==d.InsertionKind.BY_DEFAULT&&t.registerInsertedAsDefaultValue(i)}}}),t}function a(e,t){return t?e.map(function(e){return t(e)}):e.map(function(e){return e.value()})}function o(e){var t=[],n=e.errors();null!=n&&(t=t.concat(n));var r=t.map(function(t){return u(e,t)}),i=s(r);return i}function s(e){var t=[],n={};e.map(function(e){n[JSON.stringify(e)]=e});for(var r=Object.keys(n),i=0;i<r.length;i++)t.push(n[r[i]]);return t}function u(e,t){var n=t.node&&t.node.lowLevel()&&t.node.lowLevel().unit().lineMapper()||e.lowLevel().unit().lineMapper(),r=null;try{r=n.position(t.start)}catch(i){console.warn(i)}var a=null;try{a=n.position(t.end)}catch(i){console.warn(i)}var o;o=t.path?t.path:t.node?t.node.lowLevel().unit().path():m.declRoot(e).lowLevel().unit().path();var s={code:t.code,message:t.message,path:o,range:{start:r,end:a},isWarning:t.isWarning};return t.extras&&t.extras.length>0&&(s.trace=t.extras.map(function(t){return u(e,t)})),s}function l(e){if(e.isScalar())return!0;for(var t=e.allSuperTypes().filter(function(e){return e.isUnion()||e.isIntersection()}),n=0,r=t;n<r.length;n++){for(var i=r[n],a=!0,o=0,s=i.allOptions();o<s.length;o++){var u=s[o];if(a=a||l(u),!a)break}if(a)return!0}return!1}var p=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},c=n(16),f=n(24),d=(n(39),n(57)),m=n(13),h=n(14),y=n(72),v=n(73),g=function(){function e(e,t){void 0===t&&(t=!0),this._node=e,this._meta=new N(!1,!1,h.isMethodType(this.highLevel().definition())&&this.optional()),t&&e.setWrapperNode(this)}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.wrapperClassName=function(){return"BasicNodeImpl"},e.prototype.kind=function(){return"BasicNode"},e.prototype.allKinds=function(){return["BasicNode"]},e.prototype.allWrapperClassNames=function(){return["BasicNodeImpl"]},e.prototype.parent=function(){var e=this._node.parent();return e?e.wrapperNode():null},e.prototype.highLevel=function(){return this._node},e.prototype.patchNode=function(e){this._node=e},e.prototype.attributes=function(e,t){var n=this._node.attributes(e);if(!n||0==n.length){var r=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(e));return null==r?[]:Array.isArray(r)?r:[r]}return a(n,t)},e.prototype.attribute=function(e,t){var n=this._node.attr(e);if(t&&t!=this.toString&&t!=this.toBoolean&&t!=this.toNumber&&t!=this.toAny)return null==n?null:t(n);var r=n?n.value():null;return null==r&&(r=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(e))),null==r?null:t?t(r):r},e.prototype.elements=function(e){var t=this._node.elementsOfKind(e);return t?t.map(function(e){return e.wrapperNode()}):null},e.prototype.element=function(e){var t=this._node.element(e);return t?t.wrapperNode():null},e.prototype.add=function(e){this.highLevel().add(e.highLevel())},e.prototype.addToProp=function(e,t){var n=e.highLevel(),r=this.highLevel().definition().property(t);n._prop=r,this.highLevel().add(n)},e.prototype.remove=function(e){this.highLevel().remove(e.highLevel())},e.prototype.dump=function(){return this.highLevel().dump("yaml")},e.prototype.toString=function(e){var t;return t=e.lowLevel&&e.property?e.value():e,null!=t?t.toString():t},e.prototype.toAny=function(e){return e},e.prototype.toBoolean=function(e){var t;return t=e.lowLevel&&e.property?e.value():e,null!=t?"true"==t.toString():t},e.prototype.toNumber=function(e){var t;if(t=e.lowLevel&&e.property?e.value():e,!t)return t;try{var n=parseFloat(t.toString());return n}catch(r){}return Number.MAX_VALUE},e.prototype.errors=function(){return o(this._node)},e.prototype.filterErrors=function(e){var t=[],n={};e.map(function(e){n[JSON.stringify(e)]=e});for(var r=Object.keys(n),i=0;i<r.length;i++)t.push(n[r[i]]);return t},e.prototype.definition=function(){return this.highLevel().definition()},e.prototype.runtimeDefinition=function(){return h.isTypeDeclarationSibling(this.highLevel().definition())?this.highLevel().localType():null},e.prototype.toJSON=function(e){var t=A;A=this.attributeDefaults();try{return new y.TCKDumper(e).dump(this)}finally{A=t}},e.prototype.optional=function(){var e=this.highLevel();return null!=e?e.optional():!1},e.prototype.optionalProperties=function(){return this.highLevel()?this.highLevel().optionalProperties():[]},e.prototype.getDefaultsCalculator=function(){return this.defaultsCalculator?this.defaultsCalculator:(this.parent()&&(this.defaultsCalculator=this.parent().getDefaultsCalculator()),this.defaultsCalculator||(this.defaultsCalculator=new d.AttributeDefaultsCalculator(A)),this.defaultsCalculator)},e.prototype.setAttributeDefaults=function(e){this.defaultsCalculator=new d.AttributeDefaultsCalculator(e)},e.prototype.attributeDefaults=function(){return this.getDefaultsCalculator()&&this.getDefaultsCalculator().isEnabled()},e.prototype.meta=function(){return i(this)},e.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},e.CLASS_IDENTIFIER="parserCore.BasicNodeImpl",e}();t.BasicNodeImpl=g;var A=!0,S=function(){function e(e){this._meta=new b,this.attr=e}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.highLevel=function(){return this.attr},e.prototype.wrapperClassName=function(){return"AttributeNodeImpl"},e.prototype.kind=function(){return"AttributeNode"},e.prototype.allKinds=function(){return["AttributeNode"]},e.prototype.allWrapperClassNames=function(){return["AttributeNodeImpl"]},e.prototype.optional=function(){var e=this.highLevel();return null!=e?e.optional():!1},e.prototype.meta=function(){return this._meta},e.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},e.prototype.parent=function(){var e=this.attr.parent();return e?e.wrapperNode():null},e.prototype.toJSON=function(e){return new y.TCKDumper(e).dump(this)},e.CLASS_IDENTIFIER="parserCore.AttributeNodeImpl",e}();t.AttributeNodeImpl=S,t.toStructuredValue=r;var E=function(){function e(e,t){this.type=t,Array.isArray(e)?this.children=e:this.node=e}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.properties=function(){return this.isArray()?[]:this.getChildren().map(function(e){return new T(e)})},e.prototype.getChildren=function(){return this.node&&this.node.children()||this.children},e.prototype.value=function(){return this.node&&this.node.value()},e.prototype.isScalar=function(){return this.node?0!=this.node.children().length?!1:this.type?l(this.type):!0:!1},e.prototype.toJSON=function(){return(new y.TCKDumper).serializeTypeInstance(this)},e.prototype.isArray=function(){return this.node?this.type?this.type.isArray():this.node&&this.node.valueKind()==v.Kind.SEQ:!1},e.prototype.items=function(){return this.isArray()?this.node.children().map(function(t){return new e(t)}):null},e.CLASS_IDENTIFIER="parserCore.TypeInstanceImpl",e}();t.TypeInstanceImpl=E;var T=function(){function e(e){this.node=e}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.name=function(){return this.node.optional()?this.node.key()+"?":this.node.key()},e.prototype.value=function(){if(this.isArray()){var e=this.node.children();return e.length>0?new E(e[0]):null}return new E(this.node)},e.prototype.values=function(){return this.isArray()?this.node.children().map(function(e){return new E(e)}):[new E(this.node)]},e.prototype.isArray=function(){var e=this.node.children();if(e.length>0&&null==e[0].key())return!0;var t=this.node.highLevelNode();if(t){var n=t.property();if(n){var r=n.range();if(r)return r.isArray()}}return this.node.valueKind()==v.Kind.SEQ},e.CLASS_IDENTIFIER="parserCore.TypeInstancePropertyImpl",e}();t.TypeInstancePropertyImpl=T;var b=function(){function e(e,t,n){void 0===e&&(e=!1),void 0===t&&(t=!1),void 0===n&&(n=!1),this._insertedAsDefault=e,this._calculated=t,this._optional=n}return e.prototype.calculated=function(){return this._calculated},e.prototype.insertedAsDefault=function(){return this._insertedAsDefault},e.prototype.setCalculated=function(){this._calculated=!0},e.prototype.setInsertedAsDefault=function(){this._insertedAsDefault=!0},e.prototype.setOptional=function(){this._optional=!0},e.prototype.optional=function(){return this._optional},e.prototype.isDefault=function(){return!(this._insertedAsDefault||this._calculated||this._optional)},e.prototype.toJSON=function(){var e={};return this._calculated&&(e.calculated=!0),this._insertedAsDefault&&(e.insertedAsDefault=!0),this._optional&&(e.optional=!0),e},e}();t.ValueMetadataImpl=b;var N=function(e){function t(){e.apply(this,arguments),this.valuesMeta={};
}return p(t,e),t.prototype.primitiveValuesMeta=function(){return this.valuesMeta},t.prototype.registerInsertedAsDefaultValue=function(e){var t=this.valuesMeta[e];null==t?this.valuesMeta[e]=new b(!0):t.setInsertedAsDefault()},t.prototype.registerCalculatedValue=function(e){var t=this.valuesMeta[e];null==t?this.valuesMeta[e]=new b(!1,!0):t.setCalculated()},t.prototype.registerOptionalValue=function(e){var t=this.valuesMeta[e];null==t?this.valuesMeta[e]=new b(!1,!1,!0):t.setOptional()},t.prototype.resetPrimitiveValuesMeta=function(){this.valuesMeta={}},t.prototype.isDefault=function(){return e.prototype.isDefault.call(this)?0==Object.keys(this.valuesMeta).length:!1},t.prototype.toJSON=function(){var t=this,n=e.prototype.toJSON.call(this),r={},i=Object.keys(this.valuesMeta);return i.length>0&&(i.forEach(function(e){var n=t.valuesMeta[e].toJSON();Object.keys(n).length>0&&(r[e]=n)}),n.primitiveValuesMeta=r),n},t}(b);t.NodeMetadataImpl=N,t.fillElementMeta=i,t.attributesToValues=a,t.errors=o,t.filterErrors=s,t.basicError=u},function(e,t,n){"use strict";function r(e){try{var t=JSON.parse(e);return t.$schema}catch(n){return s.isXmlScheme(e)}}function i(e,t){if(s.isXmlScheme(e))return p.getXMLSchema(e,new u.ContentProvider(t)).loadSchemaReferencesAsync().then(function(){return t});var n=p.getJSONSchema(e,new u.ContentProvider(t)),r=n.getMissingReferences([]).map(function(e){return n.contentAsync(e)});if(0===r.length)return Promise.resolve(t);var i=Promise.all(r),a=o(i,n);return a.then(function(){return t})}function a(e,t){var n=p.createSchema(e,new u.ContentProvider(t));return n.getMissingReferences([],!0)}function o(e,t){return e.then(function(e){if(e.length>0){var n=t.getMissingReferences(e);if(0===n.length)return[];var r=[];return n.forEach(function(e){r.push(t.contentAsync(e))}),o(Promise.all(r.concat(e)),t)}return Promise.resolve([])})}var s=n(56),u=n(31),l=n(39),p=l.getSchemaUtils();t.isScheme=r,t.startDownloadingReferencesAsync=i,t.getReferences=a},function(e,t,n){"use strict";function r(e){var t=e.ast(),n=c.find(t.children(),function(e){return e.key()==o.Universe10.Extension.properties["extends"].name});return n&&n.value()}var i=n(10),a=n(15),o=n(18),s=n(73),u=n(25),l=n(16),p=n(39),c=n(65),f=function(){function e(){this.expandedAbsToNsMap={},this._expandedNSMap={},this.byPathMap={},this.byNsMap={},this._hasFragments={},this._unitModels={}}return e.prototype.hasTemplates=function(e){var t=this.unitModel(e);if(!t.traits.isEmpty()||!t.resourceTypes.isEmpty())return!0;var n=this.expandedPathMap(e);if(n)for(var i=0,a=Object.keys(n);i<a.length;i++){var o=a[i],s=n[o].unit,u=this.unitModel(s);if(!u.traits.isEmpty()||!u.resourceTypes.isEmpty())return!0}for(var l=r(e);l;)if(e=e.resolve(l)){if(t=this.unitModel(e),!t.traits.isEmpty()||!t.resourceTypes.isEmpty())return!0;l=r(e)}else l=null;return!1},e.prototype.resolveNamespace=function(e,t){if(null==t)return null;var n=t.absolutePath(),r=this.expandedPathMap(e);if(!r)return null;var i=r[n];return i},e.prototype.expandedNSMap=function(e){var t=e.absolutePath(),n=this._expandedNSMap[t];if(void 0===n){var r=this.expandedPathMap(e);if(r){n={};for(var i=0,a=Object.keys(r);i<a.length;i++){var o=a[i],s=r[o];n[s.namespace()]=s}}else n=null;this._expandedNSMap[t]=n}return n},e.prototype.expandedPathMap=function(e){var t=e.absolutePath(),n=this.expandedAbsToNsMap[t];return void 0===n&&(n=this.calculateExpandedNamespaces(e),0==Object.keys(n).length&&(n=null),this.expandedAbsToNsMap[t]=n),n},e.prototype.calculateExpandedNamespaces=function(e){for(var t=this,n=a.dirname(e.absolutePath()),o={},c=[];e;){c.push(new d([],e,""));var f=e;e=null;var m=f.ast();if(m&&m.kind()!=s.Kind.SCALAR){var h=l.ramlFirstLine(f.contents());if(h&&3==h.length&&(h[2]==p.universesInfo.Universe10.Overlay.name||h[2]==p.universesInfo.Universe10.Extension.name)){var y=r(f);y&&(e=f.resolve(y),e&&u.isWaitingFor(e.absolutePath())&&(e=null))}}}for(var v=0;v<c.length;v++){var g={},A={},S=c[v],E=S.unit,m=E.ast();if(m&&m.kind()!=s.Kind.SCALAR){var T=S.steps()+1,b=function(e){if(e){var r=e.children();if(null==e.parent()){var s=e.unit(),u=s.absolutePath();if(g[u])return;g[u]=!0,u!=E.absolutePath()&&(t._hasFragments[E.absolutePath()]=!0);var l=t.pathMap(s);if(l)for(var p=0,f=Object.keys(l);p<f.length;p++){var m=f[p],h=l[m],y=S.namespaceSegments.concat(h.namespaceSegments),v=S.usesNodes.concat(h.usesNodes),N=o[m];if(N){if(N.steps()<T)continue;if(N.steps()==T&&t.lexLessEq(N.namespaceSegments,y))continue}var _,w=h.includePath,M=h.absolutePath();_=a.isAbsolute(S.includePath)||i.isWebPath(S.includePath)?M:a.isAbsolute(w)||i.isWebPath(w)?M:i.isWebPath(n)!=i.isWebPath(M)?M:n.length>0&&M.length>0&&n.charAt(0).toLowerCase()!=M.charAt(0).toLowerCase()?M:a.relative(n,M),_=_.replace(/\\/g,"/");var I=new d(v,h.unit,_);A[I.absolutePath()]||(o[m]=I,c.push(I),A[I.absolutePath()]=!0)}}r.forEach(function(e){e.includedFrom()&&(e=e.parent()),b(e)}),null==e.parent()&&(g[e.unit().absolutePath()]=!1)}};b(E.ast())}}for(var N={},_=0,w=Object.keys(o);_<w.length;_++){for(var M=w[_],S=o[M],I=S.namespace(),v=0;N[I];)I=S.namespace()+v++;I!=S.namespace()&&(S.namespaceSegments=I.split(".")),N[I]=!0}return o},e.prototype.pathMap=function(e){var t=e.absolutePath(),n=this.byPathMap[t];return void 0===n&&(n=this.calculateNamespaces(e),0==Object.keys(n).length&&(n=null),this.byPathMap[t]=n),n},e.prototype.nsMap=function(e){var t=e.absolutePath(),n=this.byNsMap[t];if(void 0===n){var r=this.pathMap(e);if(null==r)n=null;else{n={};for(var i=0,a=Object.keys(r);i<a.length;i++){var o=a[i],s=r[o];n[s.namespace()]=s}}this.byNsMap[t]=n}return n},e.prototype.calculateNamespaces=function(e){var t=a.dirname(e.absolutePath()),n={},r=e.ast(),u=r.children().filter(function(e){return e.key()==o.Universe10.FragmentDeclaration.properties.uses.name});if(r.actual()&&r.actual().usesNode&&(u=[r.actual().usesNode]),0==u.length)return n;for(var f=[],m=0,h=u;m<h.length;m++){var y=h[m];f=f.concat(y.children())}if(0==f.length)return n;for(var v=0,g=f;v<g.length;v++){var y=g[v],A=y.value(),S=e.resolve(A);if(null!=S){var E,u=[y],T=S.absolutePath();E=a.isAbsolute(A)||i.isWebPath(A)?S.absolutePath():a.relative(t,S.absolutePath()),E=E.replace(/\\/g,"/");var b=new d(u,S,E);n[T]=b}}var N=e.ast();if(N&&N.kind()!=s.Kind.SCALAR){var _=l.ramlFirstLine(e.contents());if(3==_.length&&(_[2]==p.universesInfo.Universe10.Overlay.name||_[2]==p.universesInfo.Universe10.Extension.name)){var w=c.find(N.children(),function(e){return e.key()==o.Universe10.Extension.properties["extends"].name});if(w){var M,I=w.value(!0);try{M=e.resolve(I)}catch(R){}if(M){var C=this.pathMap(M);if(C)for(var L=0,P=Object.keys(C);L<P.length;L++){var O=P[L];n[O]=C[O]}}}}}return n},e.prototype.lexLessEq=function(e,t){if(e.length>t.length)return!1;if(e.length<t.length)return!0;for(var n=0;n<e.length;n++){var r=e[n],i=t[n];if(i>r)return!0;if(r>i)return!1}return!0},e.prototype.hasFragments=function(e){return this.calculateExpandedNamespaces(e),this._hasFragments[e.absolutePath()]?!0:!1},e.prototype.unitModel=function(e){var t=e.absolutePath(),n=this._unitModels[t];return n||(n=new h(e),this._unitModels[t]=n),n},e}();t.NamespaceResolver=f;var d=function(){function e(e,t,n){this.usesNodes=e,this.unit=t,this.includePath=n,this.namespaceSegments=this.usesNodes.map(function(e){return e.key()})}return e.prototype.steps=function(){return this.namespaceSegments.length},e.prototype.namespace=function(){return this.namespaceSegments.join(".")},e.prototype.absolutePath=function(){return this.unit.absolutePath()},e}();t.UsesInfo=d;var m=function(){function e(e){this.name=e,this.array=[],this.map={}}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&c.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.addElement=function(e){this.array.push(e),this.map[e.key()]=e},e.prototype.hasElement=function(e){return null!=this.map[e]},e.prototype.getElement=function(e){return this.map[e]},e.prototype.isEmpty=function(){return 0==this.array.length},e.CLASS_IDENTIFIER="namespaceResolver.ElementsCollection",e}();t.ElementsCollection=m;var h=function(){function e(e){this.unit=e,this.initCollections()}return e.prototype.initCollections=function(){this.types=new m(p.universesInfo.Universe10.LibraryBase.properties.types.name),this.annotationTypes=new m(p.universesInfo.Universe10.LibraryBase.properties.annotationTypes.name),this.securitySchemes=new m(p.universesInfo.Universe10.LibraryBase.properties.securitySchemes.name),this.traits=new m(p.universesInfo.Universe10.LibraryBase.properties.traits.name),this.resourceTypes=new m(p.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name);var e=this.unit.ast();if(e&&this.isLibraryBaseDescendant(this.unit))for(var t="0.8"==l.ramlFirstLine(this.unit.contents())[1],n=0,r=e.children();n<r.length;n++){var i=r[n],a=i.key();a==p.universesInfo.Universe10.LibraryBase.properties.types.name?this.contributeCollection(this.types,i.children()):a==p.universesInfo.Universe10.LibraryBase.properties.annotationTypes.name?this.contributeCollection(this.annotationTypes,i.children()):a==p.universesInfo.Universe10.LibraryBase.properties.securitySchemes.name?this.contributeCollection(this.securitySchemes,i.children(),t):a==p.universesInfo.Universe10.LibraryBase.properties.traits.name?this.contributeCollection(this.traits,i.children(),t):a==p.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name&&this.contributeCollection(this.resourceTypes,i.children(),t)}},e.prototype.contributeCollection=function(e,t,n){void 0===n&&(n=!1);var r;n?(r=[],t.forEach(function(e){var t=e.children();t.length>0&&r.push(t[0])})):r=t,r.forEach(function(t){return e.addElement(t)})},e.prototype.isLibraryBaseDescendant=function(e){var t=this,n=l.ramlFirstLine(e.contents());if(!n)return!1;if(n.length<3||!n[2])return!0;var r=n[2];if(!this.libTypeDescendants){this.libTypeDescendants={};var i=p.getUniverse("RAML10"),a=i.type(p.universesInfo.Universe10.LibraryBase.name);[a].concat(a.allSubTypes()).forEach(function(e){return t.libTypeDescendants[e.nameId()]=!0})}return this.libTypeDescendants[r]},e}();t.UnitModel=h},function(e,t,n){"use strict";function r(e){var t=C.getUniverse("RAML08"),n=t.type("Method"),r=R.createStubNode(n,null,e);return r}function i(e){var t=C.getUniverse("RAML08"),n=t.type("StringTypeDeclaration"),r=R.createStubNode(n,null,e);return r}function a(e){var t=C.getUniverse("RAML08"),n=t.type("BooleanTypeDeclaration"),r=R.createStubNode(n,null,e);return r}function o(e){var t=C.getUniverse("RAML08"),n=t.type("NumberTypeDeclaration"),r=R.createStubNode(n,null,e);return r}function s(e){var t=C.getUniverse("RAML08"),n=t.type("IntegerTypeDeclaration"),r=R.createStubNode(n,null,e);return r}function u(e){var t=C.getUniverse("RAML08"),n=t.type("DateTypeDeclaration"),r=R.createStubNode(n,null,e);return r}function l(e){var t=C.getUniverse("RAML08"),n=t.type("FileTypeDeclaration"),r=R.createStubNode(n,null,e);return r}function p(e){var t=C.getUniverse("RAML08"),n=t.type("XMLBody"),r=R.createStubNode(n,null,e);return r}function c(e){var t=C.getUniverse("RAML08"),n=t.type("JSONBody"),r=R.createStubNode(n,null,e);return r}function f(e){var t=C.getUniverse("RAML08"),n=t.type("SecuritySchemePart"),r=R.createStubNode(n,null,e);return r}function d(e){var t=C.getUniverse("RAML08"),n=t.type("Trait"),r=R.createStubNode(n,null,e);return r}function m(e){var t=C.getUniverse("RAML08"),n=t.type("OAuth1SecuritySchemeSettings"),r=R.createStubNode(n,null,e);return r}function h(e){var t=C.getUniverse("RAML08"),n=t.type("OAuth2SecuritySchemeSettings"),r=R.createStubNode(n,null,e);return r}function y(e){var t=C.getUniverse("RAML08"),n=t.type("OAuth2SecurityScheme"),r=R.createStubNode(n,null,e);return r}function v(e){var t=C.getUniverse("RAML08"),n=t.type("OAuth1SecurityScheme"),r=R.createStubNode(n,null,e);return r}function g(e){var t=C.getUniverse("RAML08"),n=t.type("BasicSecurityScheme"),r=R.createStubNode(n,null,e);return r}function A(e){var t=C.getUniverse("RAML08"),n=t.type("DigestSecurityScheme"),r=R.createStubNode(n,null,e);return r}function S(e){var t=C.getUniverse("RAML08"),n=t.type("CustomSecurityScheme"),r=R.createStubNode(n,null,e);return r}function E(e){var t=C.getUniverse("RAML08"),n=t.type("GlobalSchema"),r=R.createStubNode(n,null,e);return r}function T(e){var t=C.getUniverse("RAML08"),n=t.type("DocumentationItem"),r=R.createStubNode(n,null,e);return r}function b(e,t,n){return P.loadApi(e,t,n).getOrElse(null)}function N(e,t,n){return P.loadApi(e,t,n).getOrElse(null)}function _(e,t,n){return P.loadApiAsync(e,t,n)}function w(e,t,n){return P.loadRAMLAsync(e,t,n)}function M(e){return P.getLanguageElementByRuntimeType(e)}var I=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},R=n(17),C=n(39),L=n(49),P=n(8),O=n(79),D=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.version=function(){return e.prototype.attribute.call(this,"version",this.toString)},t.prototype.setVersion=function(e){return this.highLevel().attrOrCreate("version").setValue(""+e),this},t.prototype.baseUri=function(){return e.prototype.attribute.call(this,"baseUri",function(e){return new Ie(e)})},t.prototype.baseUriParameters_original=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.uriParameters=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.mediaType=function(){return e.prototype.attribute.call(this,"mediaType",function(e){return new _e(e)})},t.prototype.schemas=function(){return e.prototype.elements.call(this,"schemas")},t.prototype.traits_original=function(){return e.prototype.elements.call(this,"traits")},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.securitySchemes=function(){return e.prototype.elements.call(this,"securitySchemes")},t.prototype.resourceTypes_original=function(){return e.prototype.elements.call(this,"resourceTypes")},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.documentation=function(){return e.prototype.elements.call(this,"documentation")},t.prototype.wrapperClassName=function(){return"ApiImpl"},t.prototype.kind=function(){return"Api"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Api")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ApiImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ApiImpl"==r)return!0}return!1},t.prototype.RAMLVersion_original=function(){return"RAML08"},t.prototype.expand=function(){return O.expandTraitsAndResourceTypes(this)},t.prototype.traits=function(){return O.traitsPrimary(this)},t.prototype.allTraits=function(){return O.allTraits(this)},t.prototype.resourceTypes=function(){return O.resourceTypesPrimary(this)},t.prototype.allResourceTypes=function(){return O.allResourceTypes(this)},t.prototype.childResource=function(e){return O.childResource(this,e)},t.prototype.allResources=function(){return O.allResources(this)},t.prototype.baseUriParameters=function(){return O.baseUriParametersPrimary(this)},t.prototype.allBaseUriParameters=function(){return O.baseUriParameters(this)},t.prototype.allProtocols=function(){return O.allProtocols(this)},t.prototype.RAMLVersion=function(){return O.RAMLVersion(this)},t}(L.BasicNodeImpl);t.ApiImpl=D;var x=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"ValueTypeImpl"},t.prototype.kind=function(){return"ValueType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ValueType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("undefined.ValueTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("undefined.ValueTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"undefined"},t.prototype.value=function(){return this.attr.value()},t}(L.AttributeNodeImpl);t.ValueTypeImpl=x;var U=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"AnyTypeImpl"},t.prototype.kind=function(){return"AnyType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AnyType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.AnyTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.AnyTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(x);t.AnyTypeImpl=U;var k=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"NumberTypeImpl"},t.prototype.kind=function(){return"NumberType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.NumberTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.NumberTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return this.attr.value()},t}(x);t.NumberTypeImpl=k;var F=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},t.prototype.kind=function(){return"BooleanType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BooleanTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BooleanTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return this.attr.value()},t}(x);t.BooleanTypeImpl=F;var B=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"ReferenceImpl"},t.prototype.kind=function(){return"Reference"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Reference")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ReferenceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ReferenceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return L.toStructuredValue(this.attr)},t.prototype.structuredValue=function(){return O.structuredValue(this)},t.prototype.name=function(){return O.referenceName(this)},t}(L.AttributeNodeImpl);t.ReferenceImpl=B;var K=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},t.prototype.kind=function(){return"ResourceTypeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceTypeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResourceTypeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResourceTypeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.resourceType=function(){return O.referencedResourceType(this)},t}(B);t.ResourceTypeRefImpl=K;var V=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.methods=function(){return e.prototype.elements.call(this,"methods")},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new de(e)})},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",function(e){return new K(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.uriParameters=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.baseUriParameters=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},t.prototype.kind=function(){return"ResourceType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ResourceType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResourceTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResourceTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(L.BasicNodeImpl);t.ResourceTypeImpl=V;var j=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.responses=function(){return e.prototype.elements.call(this,"responses")},t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.protocols=function(){return e.prototype.attributes.call(this,"protocols",this.toString)},t.prototype.setProtocols=function(e){return this.highLevel().attrOrCreate("protocols").setValue(""+e),this},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.baseUriParameters=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.queryParameters=function(){return e.prototype.elements.call(this,"queryParameters")},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"MethodBaseImpl"},t.prototype.kind=function(){return"MethodBase"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MethodBase")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MethodBaseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MethodBaseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(L.BasicNodeImpl);t.MethodBaseImpl=j;var W=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.code=function(){return e.prototype.attribute.call(this,"code",function(e){return new Y(e)})},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.body=function(){return e.prototype.elements.call(this,"body")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"ResponseImpl"},t.prototype.kind=function(){return"Response"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Response")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResponseImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResponseImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.isOkRange=function(){return O.isOkRange(this)},t}(L.BasicNodeImpl);t.ResponseImpl=W;var q=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"StringTypeImpl"},t.prototype.kind=function(){return"StringType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.StringTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.StringTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.value=function(){return this.attr.value()},t}(x);t.StringTypeImpl=q;var Y=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},t.prototype.kind=function(){return"StatusCodeString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StatusCodeString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.StatusCodeStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.StatusCodeStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.StatusCodeStringImpl=Y;var H=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.location=function(){return e.prototype.attribute.call(this,"location",function(e){return new $(e)})},t.prototype.required=function(){return e.prototype.attribute.call(this,"required",this.toBoolean)},t.prototype.setRequired=function(e){return this.highLevel().attrOrCreate("required").setValue(""+e),this},t.prototype["default"]=function(){return e.prototype.attribute.call(this,"default",this.toAny)},t.prototype.setDefault=function(e){return this.highLevel().attrOrCreate("default").setValue(""+e),this},t.prototype.example=function(){return e.prototype.attribute.call(this,"example",this.toString)},t.prototype.setExample=function(e){return this.highLevel().attrOrCreate("example").setValue(""+e),this},t.prototype.repeat=function(){return e.prototype.attribute.call(this,"repeat",this.toBoolean)},t.prototype.setRepeat=function(e){return this.highLevel().attrOrCreate("repeat").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"ParameterImpl"},t.prototype.kind=function(){return"Parameter"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Parameter")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ParameterImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ParameterImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(L.BasicNodeImpl);t.ParameterImpl=H;var $=function(){function e(e){this.attr=e}return e.prototype.wrapperClassName=function(){return"ParameterLocationImpl"},e.prototype.kind=function(){return"ParameterLocation"},e.prototype.allKinds=function(){return["ParameterLocation"]},e.prototype.allWrapperClassNames=function(){return["RAML08.ParameterLocationImpl"]},e.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ParameterLocationImpl"==r)return!0}return!1},e.prototype.RAMLVersion=function(){return"RAML08"},e}();t.ParameterLocationImpl=$;var G=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},t.prototype.kind=function(){return"MarkdownString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MarkdownString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MarkdownStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MarkdownStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.MarkdownStringImpl=G;var X=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?i(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.pattern=function(){return e.prototype.attribute.call(this,"pattern",this.toString)},t.prototype.setPattern=function(e){return this.highLevel().attrOrCreate("pattern").setValue(""+e),this},t.prototype["enum"]=function(){return e.prototype.attributes.call(this,"enum",this.toString)},t.prototype.setEnum=function(e){return this.highLevel().attrOrCreate("enum").setValue(""+e),this},t.prototype.minLength=function(){return e.prototype.attribute.call(this,"minLength",this.toNumber)},t.prototype.setMinLength=function(e){return this.highLevel().attrOrCreate("minLength").setValue(""+e),this},t.prototype.maxLength=function(){return e.prototype.attribute.call(this,"maxLength",this.toNumber)},t.prototype.setMaxLength=function(e){return this.highLevel().attrOrCreate("maxLength").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},t.prototype.kind=function(){return"StringTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("StringTypeDeclaration");
},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.StringTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.StringTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.StringTypeDeclarationImpl=X;var z=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?a(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},t.prototype.kind=function(){return"BooleanTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BooleanTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BooleanTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BooleanTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.BooleanTypeDeclarationImpl=z;var J=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?o(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.minimum=function(){return e.prototype.attribute.call(this,"minimum",this.toNumber)},t.prototype.setMinimum=function(e){return this.highLevel().attrOrCreate("minimum").setValue(""+e),this},t.prototype.maximum=function(){return e.prototype.attribute.call(this,"maximum",this.toNumber)},t.prototype.setMaximum=function(e){return this.highLevel().attrOrCreate("maximum").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},t.prototype.kind=function(){return"NumberTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("NumberTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.NumberTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.NumberTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.NumberTypeDeclarationImpl=J;var Q=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?s(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},t.prototype.kind=function(){return"IntegerTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("IntegerTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.IntegerTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.IntegerTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(J);t.IntegerTypeDeclarationImpl=Q;var Z=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?u(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"DateTypeDeclarationImpl"},t.prototype.kind=function(){return"DateTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DateTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.DateTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.DateTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.DateTypeDeclarationImpl=Z;var ee=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?l(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},t.prototype.kind=function(){return"FileTypeDeclaration"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FileTypeDeclaration")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.FileTypeDeclarationImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.FileTypeDeclarationImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(H);t.FileTypeDeclarationImpl=ee;var te=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.schema=function(){return e.prototype.attribute.call(this,"schema",function(e){return new ne(e)})},t.prototype.example=function(){return e.prototype.attribute.call(this,"example",function(e){return new ae(e)})},t.prototype.formParameters=function(){return e.prototype.elements.call(this,"formParameters")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"BodyLikeImpl"},t.prototype.kind=function(){return"BodyLike"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BodyLike")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BodyLikeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BodyLikeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.schemaContent=function(){return O.schemaContent(this)},t}(L.BasicNodeImpl);t.BodyLikeImpl=te;var ne=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"SchemaStringImpl"},t.prototype.kind=function(){return"SchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.SchemaStringImpl=ne;var re=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"JSonSchemaStringImpl"},t.prototype.kind=function(){return"JSonSchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("JSonSchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.JSonSchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.JSonSchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ne);t.JSonSchemaStringImpl=re;var ie=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"XMLSchemaStringImpl"},t.prototype.kind=function(){return"XMLSchemaString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLSchemaString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.XMLSchemaStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.XMLSchemaStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ne);t.XMLSchemaStringImpl=ie;var ae=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"ExampleStringImpl"},t.prototype.kind=function(){return"ExampleString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("ExampleString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ExampleStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ExampleStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.ExampleStringImpl=ae;var oe=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"JSONExampleImpl"},t.prototype.kind=function(){return"JSONExample"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("JSONExample")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.JSONExampleImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.JSONExampleImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ae);t.JSONExampleImpl=oe;var se=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"XMLExampleImpl"},t.prototype.kind=function(){return"XMLExample"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLExample")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.XMLExampleImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.XMLExampleImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ae);t.XMLExampleImpl=se;var ue=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?p(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.schema=function(){return e.prototype.attribute.call(this,"schema",function(e){return new ie(e)})},t.prototype.wrapperClassName=function(){return"XMLBodyImpl"},t.prototype.kind=function(){return"XMLBody"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("XMLBody")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.XMLBodyImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.XMLBodyImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(te);t.XMLBodyImpl=ue;var le=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?c(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.schema=function(){return e.prototype.attribute.call(this,"schema",function(e){return new re(e)})},t.prototype.wrapperClassName=function(){return"JSONBodyImpl"},t.prototype.kind=function(){return"JSONBody"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("JSONBody")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.JSONBodyImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.JSONBodyImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(te);t.JSONBodyImpl=le;var pe=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},t.prototype.kind=function(){return"SecuritySchemeRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SecuritySchemeRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SecuritySchemeRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.securitySchemeName=function(){return O.securitySchemeName(this)},t.prototype.securityScheme=function(){return O.securityScheme(this)},t}(B);t.SecuritySchemeRefImpl=pe;var ce=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",this.toString)},t.prototype.setType=function(e){return this.highLevel().attrOrCreate("type").setValue(""+e),this},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.describedBy=function(){return e.prototype.element.call(this,"describedBy")},t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},t.prototype.kind=function(){return"AbstractSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("AbstractSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.AbstractSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.AbstractSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(L.BasicNodeImpl);t.AbstractSecuritySchemeImpl=ce;var fe=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?f(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new de(e)})},t.prototype.headers=function(){return e.prototype.elements.call(this,"headers")},t.prototype.queryParameters=function(){return e.prototype.elements.call(this,"queryParameters")},t.prototype.responses=function(){return e.prototype.elements.call(this,"responses")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},t.prototype.kind=function(){return"SecuritySchemePart"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemePart")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SecuritySchemePartImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SecuritySchemePartImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(j);t.SecuritySchemePartImpl=fe;var de=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"TraitRefImpl"},t.prototype.kind=function(){return"TraitRef"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("TraitRef")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.TraitRefImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.TraitRefImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.trait=function(){return O.referencedTrait(this)},t}(B);t.TraitRefImpl=de;var me=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?d(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.name=function(){return e.prototype.attribute.call(this,"name",this.toString)},t.prototype.setName=function(e){return this.highLevel().attrOrCreate("name").setValue(""+e),this},t.prototype.usage=function(){return e.prototype.attribute.call(this,"usage",this.toString)},t.prototype.setUsage=function(e){return this.highLevel().attrOrCreate("usage").setValue(""+e),this},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"TraitImpl"},t.prototype.kind=function(){return"Trait"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Trait")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.TraitImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.TraitImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parametrizedProperties=function(){return O.getTemplateParametrizedProperties(this)},t}(j);t.TraitImpl=me;var he=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(L.BasicNodeImpl);t.SecuritySchemeSettingsImpl=he;var ye=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?m(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.requestTokenUri=function(){return e.prototype.attribute.call(this,"requestTokenUri",function(e){return new ve(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ve(e)})},t.prototype.tokenCredentialsUri=function(){return e.prototype.attribute.call(this,"tokenCredentialsUri",function(e){return new ve(e)})},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth1SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth1SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(he);t.OAuth1SecuritySchemeSettingsImpl=ye;var ve=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"FixedUriImpl"},t.prototype.kind=function(){return"FixedUri"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FixedUri")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.FixedUriImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.FixedUriImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.FixedUriImpl=ve;var ge=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?h(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.accessTokenUri=function(){return e.prototype.attribute.call(this,"accessTokenUri",function(e){return new ve(e)})},t.prototype.authorizationUri=function(){return e.prototype.attribute.call(this,"authorizationUri",function(e){return new ve(e)})},t.prototype.authorizationGrants=function(){return e.prototype.attributes.call(this,"authorizationGrants",this.toString)},t.prototype.setAuthorizationGrants=function(e){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+e),this},t.prototype.scopes=function(){return e.prototype.attributes.call(this,"scopes",this.toString)},t.prototype.setScopes=function(e){return this.highLevel().attrOrCreate("scopes").setValue(""+e),this},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},t.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecuritySchemeSettings")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth2SecuritySchemeSettingsImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth2SecuritySchemeSettingsImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(he);t.OAuth2SecuritySchemeSettingsImpl=ge;var Ae=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?y(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth2SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth2SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth2SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth2SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.OAuth2SecuritySchemeImpl=Ae;var Se=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?v(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.settings=function(){return e.prototype.element.call(this,"settings")},t.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},t.prototype.kind=function(){return"OAuth1SecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("OAuth1SecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.OAuth1SecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.OAuth1SecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.OAuth1SecuritySchemeImpl=Se;var Ee=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?g(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},t.prototype.kind=function(){return"BasicSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("BasicSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.BasicSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.BasicSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.BasicSecuritySchemeImpl=Ee;var Te=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?A(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},t.prototype.kind=function(){return"DigestSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DigestSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.DigestSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.DigestSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.DigestSecuritySchemeImpl=Te;var be=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?S(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},t.prototype.kind=function(){return"CustomSecurityScheme"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("CustomSecurityScheme")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.CustomSecuritySchemeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.CustomSecuritySchemeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(ce);t.CustomSecuritySchemeImpl=be;var Ne=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?r(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.method=function(){return e.prototype.attribute.call(this,"method",this.toString)},t.prototype.setMethod=function(e){return this.highLevel().attrOrCreate("method").setValue(""+e),this},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new de(e)})},t.prototype.wrapperClassName=function(){return"MethodImpl"},t.prototype.kind=function(){return"Method"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Method")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MethodImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MethodImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.parentResource=function(){return O.parentResource(this)},t.prototype.ownerApi=function(){return O.ownerApi(this)},t.prototype.methodId=function(){return O.methodId(this)},t.prototype.allSecuredBy=function(){return O.allSecuredBy(this)},t}(j);t.MethodImpl=Ne;var _e=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"MimeTypeImpl"},t.prototype.kind=function(){return"MimeType"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("MimeType")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.MimeTypeImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.MimeTypeImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.MimeTypeImpl=_e;var we=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"UriTemplateImpl"},t.prototype.kind=function(){return"UriTemplate"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("UriTemplate")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.UriTemplateImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.UriTemplateImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(q);t.UriTemplateImpl=we;var Me=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},t.prototype.kind=function(){return"RelativeUriString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("RelativeUriString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.RelativeUriStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.RelativeUriStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(we);t.RelativeUriStringImpl=Me;var Ie=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},t.prototype.kind=function(){return"FullUriTemplateString"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("FullUriTemplateString")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.FullUriTemplateStringImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.FullUriTemplateStringImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(we);t.FullUriTemplateStringImpl=Ie;var Re=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.wrapperClassName=function(){return"RAMLSimpleElementImpl"},t.prototype.kind=function(){return"RAMLSimpleElement"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("RAMLSimpleElement")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.RAMLSimpleElementImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.RAMLSimpleElementImpl"==r)return!0;
}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(L.BasicNodeImpl);t.RAMLSimpleElementImpl=Re;var Ce=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?T(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.title=function(){return e.prototype.attribute.call(this,"title",this.toString)},t.prototype.setTitle=function(e){return this.highLevel().attrOrCreate("title").setValue(""+e),this},t.prototype.content=function(){return e.prototype.attribute.call(this,"content",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},t.prototype.kind=function(){return"DocumentationItem"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("DocumentationItem")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.DocumentationItemImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.DocumentationItemImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(Re);t.DocumentationItemImpl=Ce;var Le=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,"string"==typeof t?E(t):t,n),this.nodeOrKey=t,this.setAsTopLevel=n}return I(t,e),t.prototype.key=function(){return e.prototype.attribute.call(this,"key",this.toString)},t.prototype.setKey=function(e){return this.highLevel().attrOrCreate("key").setValue(""+e),this},t.prototype.value=function(){return e.prototype.attribute.call(this,"value",function(e){return new ne(e)})},t.prototype.wrapperClassName=function(){return"GlobalSchemaImpl"},t.prototype.kind=function(){return"GlobalSchema"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("GlobalSchema")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.GlobalSchemaImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.GlobalSchemaImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t}(Re);t.GlobalSchemaImpl=Le;var Pe=function(e){function t(){e.apply(this,arguments)}return I(t,e),t.prototype.relativeUri=function(){return e.prototype.attribute.call(this,"relativeUri",function(e){return new Me(e)})},t.prototype.type=function(){return e.prototype.attribute.call(this,"type",function(e){return new K(e)})},t.prototype.is=function(){return e.prototype.attributes.call(this,"is",function(e){return new de(e)})},t.prototype.securedBy=function(){return e.prototype.attributes.call(this,"securedBy",function(e){return new pe(e)})},t.prototype.uriParameters_original=function(){return e.prototype.elements.call(this,"uriParameters")},t.prototype.methods=function(){return e.prototype.elements.call(this,"methods")},t.prototype.resources=function(){return e.prototype.elements.call(this,"resources")},t.prototype.displayName=function(){return e.prototype.attribute.call(this,"displayName",this.toString)},t.prototype.setDisplayName=function(e){return this.highLevel().attrOrCreate("displayName").setValue(""+e),this},t.prototype.baseUriParameters=function(){return e.prototype.elements.call(this,"baseUriParameters")},t.prototype.description=function(){return e.prototype.attribute.call(this,"description",function(e){return new G(e)})},t.prototype.wrapperClassName=function(){return"ResourceImpl"},t.prototype.kind=function(){return"Resource"},t.prototype.allKinds=function(){return e.prototype.allKinds.call(this).concat("Resource")},t.prototype.allWrapperClassNames=function(){return e.prototype.allWrapperClassNames.call(this).concat("RAML08.ResourceImpl")},t.isInstance=function(e){if(null!=e&&e.allWrapperClassNames&&"function"==typeof e.allWrapperClassNames)for(var t=0,n=e.allWrapperClassNames();t<n.length;t++){var r=n[t];if("RAML08.ResourceImpl"==r)return!0}return!1},t.prototype.RAMLVersion=function(){return"RAML08"},t.prototype.completeRelativeUri=function(){return O.completeRelativeUri(this)},t.prototype.absoluteUri=function(){return O.absoluteUri(this)},t.prototype.parentResource=function(){return O.parent(this)},t.prototype.childResource=function(e){return O.childResource(this,e)},t.prototype.childMethod=function(e){return O.childMethod(this,e)},t.prototype.ownerApi=function(){return O.ownerApi(this)},t.prototype.uriParameters=function(){return O.uriParametersPrimary(this)},t.prototype.allUriParameters=function(){return O.uriParameters(this)},t.prototype.absoluteUriParameters=function(){return O.absoluteUriParameters(this)},t.prototype.allSecuredBy=function(){return O.allSecuredBy(this)},t}(L.BasicNodeImpl);t.ResourceImpl=Pe,t.loadApiSync=b,t.loadRAMLSync=N,t.loadApi=_,t.loadRAML=w,t.getLanguageElementByRuntimeType=M},function(e,t,n){"use strict";function r(e){if(null==e||"string"!=typeof e)return{status:M.NOT_REQUIRED};for(var t="",n={},r=0,i=e.indexOf("<<");i>=0;i=e.indexOf("<<",r)){if(t+=e.substring(r,i),r=e.indexOf(">>",i),0>r)return{status:M.ERROR};r+=">>".length;var a=e.substring(i,r),o=I+i+I;n[o]=a,t+=o}return 0==t.length?{status:M.NOT_REQUIRED}:(t+=e.substring(r,e.length),{resultingString:t,substitutions:n,status:M.OK})}function i(e,t){if(null==e)return{status:M.NOT_REQUIRED};for(var n="",r=0,i=e.indexOf(I);i>=0;i=e.indexOf(I,r)){if(r=e.indexOf(I,i+1),r+=I.length,0>r)return{status:M.ERROR};var a=e.substring(i,r),o=t[a];if(null==o)return{status:M.ERROR};n+=o}return 0==n.length?{status:M.NOT_REQUIRED}:(n+=e.substring(r,e.length),{resultingString:n,substitutions:t,status:M.OK})}function a(e){for(var t=!1,n=0;n<e.length;n++){var r=e.charAt(n);if("|"==r||"("==r||"["==r){t=!0;break}}return t}function o(e,t,n){var r=e.lowLevel(),i=e.definition().universe().version(),a=u(r),o=A.Universe10.MethodBase.properties.is.name,l=S.find(r.children(),function(e){return e.key()==o}),p=l;if(null==p){var c=new h.ASTNode(m.newMapping(m.newScalar(o),m.newItems()),a.unit(),a,null,null);p=r.replaceChild(null,c)}var f=S.find(a.children(),function(e){return e.key()==o}),y=null!=f&&f.unit().absolutePath()==n?f.children():[],v=y.concat(t.map(function(e){var t=s(e.node,p);if(null!=t){var n=new g.LowLevelCompositeNode(t,p,e.transformer,i);return n}return null})).filter(function(e){return null!=e});if(0==v.length&&t.length<=1)return l;p.setChildren(v),p.filterChildren(),v=p.children();var T=e.directChildren(),b=e.definition().property("is"),N=b.range();T&&(T=T.filter(function(e){var t=e.property();return null==t||!E.isIsProperty(t)}),e._children=T.concat(v.map(function(t){return new d.ASTPropImpl(t,e,N,b)})));var _=e.children();return _&&(_=_.filter(function(e){var t=e.property();return null==t||!E.isIsProperty(t)}),e._mergedChildren=_.concat(v.map(function(t){return new d.ASTPropImpl(t,e,N,b)}))),p}function s(e,t){t=u(t),e=u(e);var n=e.actual();if(null==n)return null;if(e.key()==A.Universe10.MethodBase.properties.is.name&&(n=e.yamlNode().value),null==n)return null;if(n.kind==m.Kind.SEQ&&(n=n.items[0]),null==n)return null;var r=new h.ASTNode(n,e.unit(),t,null,null);return r}function u(e){for(var t=0;2>t&&g.LowLevelProxyNode.isInstance(e);t++)e=e.originalNode();return e}function l(e){return e?null!=e.namespace&&"function"==typeof e.namespace&&null!=e.name&&"function"==typeof e.name&&null!=e.collectionName&&"function"==typeof e.collectionName&&null!=e.referencedUnit&&"function"==typeof e.referencedUnit&&null!=e.mode&&"function"==typeof e.mode:!1}function p(e,t,n,r){if(!e)return null;var i="",a=e,o=e.lastIndexOf(".");o>=0&&(i=e.substring(0,o),a=e.substring(o+1));for(var s,u=!1,l=r.length;l>0;l--){var p=r[l-1],c=p.highLevel();if(c.isElement()&&E.isLibraryType(c.asElement().definition())){if(u)break;u=!0}var f=p;if(i){f=null;var d=n.nsMap(p);if(d){var m=d[i];m&&(f=m.unit)}}if(f){var h=f.highLevel();if(h&&h.isElement()&&(s=S.find(h.asElement().elementsOfKind(t),function(e){return e.name()==a})))break}}return s}function c(e){var t=e.indexOf("<<");if(0>t)return!1;if(0!=t)return!0;var n=e.indexOf(">>",t);return n+">>".length!=e.length?!0:!1}var f=n(10),d=n(16),m=n(73),h=n(24),y=n(54),v=n(33),g=n(41),A=n(18),S=n(65),E=n(14),T=n(51),b=n(39),N=b.rt.typeExpressions;!function(e){e[e.DEFAULT=0]="DEFAULT",e[e.PATH=1]="PATH"}(t.PatchMode||(t.PatchMode={}));var _=t.PatchMode,w=function(){function e(e){void 0===e&&(e=_.DEFAULT),this.mode=e,this._outerDependencies={},this._libModels={}}return e.prototype.process=function(e,t,n,r){var i=this;if(void 0===t&&(t=e),void 0===n&&(n=!1),void 0===r&&(r=!1),!e.lowLevel().libProcessed){var a=e.lowLevel().unit().project().namespaceResolver();this.patchReferences(e,t,a),r&&this.patchNodeName(e,t.lowLevel().unit(),a),n?this.removeUses(e):this.patchUses(e,a),e.elements().forEach(function(e){return i.removeUses(e)}),this.resetTypes(e),e.lowLevel().libProcessed=!0}},e.prototype.patchReferences=function(e,t,n,r){if(void 0===t&&(t=e),void 0===n&&(n=new T.NamespaceResolver),void 0===r&&(r=[t.lowLevel().unit()]),!e.isReused()){var i;if(null!=e.definition().property(A.Universe10.TypeDeclaration.properties.annotations.name)){var a=e.lowLevel();if(!g.LowLevelCompositeNode.isInstance(a))return;var s=A.Universe10.MethodBase.properties.is.name,u=e.attributes(s);0!=u.length&&(i=o(e,u.map(function(e){return e.lowLevel()}).map(function(e){return g.LowLevelProxyNode.isInstance(e)?{node:e,transformer:e.transformer()}:{node:e,transformer:null}}),r[0].absolutePath()))}for(var l=e.attrs(),p=0,c=l;p<c.length;p++){var f=c[p],d=this.appendUnitIfNeeded(f,r);this.patchReferenceAttr(f,t,n,r),this.popUnitIfNeeded(r,d)}if(E.isTypeDeclarationDescendant(e.definition())){var d=this.appendUnitIfNeeded(e,r);this.patchType(e,t,n,r),this.popUnitIfNeeded(r,d)}for(var m=e.elements(),h=0,y=m;h<y.length;h++){var v=y[h],d=this.appendUnitIfNeeded(v,r);this.patchReferences(v,t,n,r),this.popUnitIfNeeded(r,d)}if(i){i.filterChildren();var S=e.directChildren();S&&(e._children=this.filterTraitReferences(S));var b=e.children();b&&(e._mergedChildren=this.filterTraitReferences(b))}}},e.prototype.filterTraitReferences=function(e){for(var t=[],n={},r=0,i=e;r<i.length;r++){var a=i[r],o=a.property();if(o&&E.isIsProperty(o)){var s=JSON.stringify(y.serialize(a.lowLevel()));n[s]||(n[s]=!0,t.push(a))}else t.push(a)}return t},e.prototype.patchReferenceAttr=function(e,t,n,r,i){void 0===i&&(i=!1);var a=e.property(),o=a.range();if(i||o.isAssignableFrom(A.Universe10.Reference.name)){var s=e.value();if(null!=s){var l=e.lowLevel();if(g.LowLevelProxyNode.isInstance(l)){var p=l.transformer(),c=E.isAnnotationsProperty(a);if("string"==typeof s){var f=s;if(null!=p){var d=u(l);f=d.value()}c&&(f=f.substring(1,f.length-1));var m=this.resolveReferenceValue(f,t.lowLevel().unit(),r,n,p,o);if(null!=m){var h=c?"("+m.value()+")":m.value();e.lowLevel().setValueOverride(h),e.overrideValue(h),this.registerPatchedReference(m)}}else{var y=s,v=y.toHighLevel();if(v)for(var S=0,T=v.attrs();S<T.length;S++){var e=T[S];E.isSchemaStringType(e.definition())&&this.patchReferenceAttr(e,t,n,r,!0)}var b=y.lowLevel().key(),f=b;if(null!=p){var d=u(y.lowLevel());f=d.key()}if(null!=b){c&&(f=f.substring(1,f.length-1));var m=this.resolveReferenceValue(f,t.lowLevel().unit(),r,n,p,o);if(null!=m){var h=c?"("+m.value()+")":m.value();y.lowLevel().setKeyOverride(h),this.registerPatchedReference(m)}}}}}}},e.prototype.patchType=function(e,t,n,o){var s=this,l=e.definition(),p=e.localType();if(p.isAnnotationType()){var f=p.superTypes();f.length>0&&(p=f[0])}var m=P(p);if(!m&&p.isArray()&&(m=P(p.componentType())),!m){var h=t.lowLevel().unit(),y=(h.absolutePath(),e.attributes(A.Universe10.TypeDeclaration.properties.type.name));0==y.length&&(y=e.attributes(A.Universe10.TypeDeclaration.properties.schema.name));var v=e.attributes(A.Universe10.ArrayTypeDeclaration.properties.items.name);y=y.concat(v);for(var E=0,T=y;E<T.length;E++){var b=T[E],_=b.lowLevel();if(g.LowLevelProxyNode.isInstance(_)){var w=b.lowLevel().unit(),I=(w.absolutePath(),b.value());if(null!=I)if("string"==typeof I){var R=a(I),C=_.transformer(),L=I,O={status:M.NOT_REQUIRED},D=C?C.unitsChain:null;if(null!=C||I.indexOf("<<")>=0){var x=u(_),U=x.value();if(O=r(U),O.status==M.OK)L=R?O.resultingString:U;else{if(O.status==M.ERROR)return;C=null}}var k;if(D){k=[];for(var F=0,B=D;F<B.length;F++){var K=B[F];k.push(this.appendUnitIfNeeded(K,o))}}var V,j=this.appendUnitIfNeeded(b,o),W=void 0;try{V=R&&N.parse(L)}catch(q){V=null}if(R&&null!==V){var Y=!1,H=N.parse(L),$=!1;N.visit(H,function(e){if("name"==e.type){var t,r=e,a=r.value,u={status:M.NOT_REQUIRED};if(O.status==M.OK)if(t=O.substitutions[a],null==t){if(u=i(a,O.substitutions),u.status==M.OK)a=u.resultingString;else if(u.status==M.ERROR)return void(Y=!0)}else a=t;if(null==C&&(null!=t||u.status==M.OK))return void(r.value=a);var p=!0;a.indexOf("<<")>=0&&c(a)&&(p=!1);var f=s.resolveReferenceValue(a,h,o,n,C,l,p);null!=f&&(r.value=f.value(),$=!0,s.registerPatchedReference(f))}}),W=$&&!Y?N.serializeToString(H):I}else if(O.status!=M.OK||null!=C){L.indexOf("<<")>=0&&c(L)&&(L=I,C=null);var G=this.resolveReferenceValue(L,h,o,n,C,l);null!=G&&(this.registerPatchedReference(G),W=G.value())}if(null!=W&&(b.lowLevel().setValueOverride(W),b.overrideValue(null)),this.popUnitIfNeeded(o,j),k)for(var X=0,z=k.reverse();X<z.length;X++){var J=z[X];this.popUnitIfNeeded(o,J)}}else{var Q=b.lowLevel();if(Q.key()!=b.property().nameId()&&(Q=S.find(e.lowLevel().children(),function(e){return e.key()==b.property().nameId()})),Q){var Z=e.definition().universe().type(A.Universe10.TypeDeclaration.name),ee=new d.ASTNodeImpl(Q,null,Z,null),te=this.appendUnitIfNeeded(ee,o);this.patchReferences(ee,t,n,o),this.popUnitIfNeeded(o,te)}}}}}},e.prototype.resolveReferenceValue=function(e,t,n,r,i,a,o){var s=this;void 0===o&&(o=!0);var u,p=E.isAnnotationRefTypeOrDescendant(a);if(i&&e&&e.indexOf("<<")>=0){var c=!0,f=t.highLevel().types(),d=i.transform(e,!0,function(){return c},function(e,n){var i=s.resolveReferenceValueBasic(e,t,r,n.unitsChain,a);return null==i&&(i=new R(null,e,s.collectionName(a),t,_.DEFAULT)),c=p?null!=f.getAnnotationType(i.value())?!1:!1:null!=f.getType(i.value())?!1:!1,i});u=d.value}return void 0!==u&&l(u)||(u=this.resolveReferenceValueBasic(e,t,r,n,a)),u},e.prototype.patchNodeName=function(e,t,n){var r=e.lowLevel(),i=r.key(),a=e.definition();if(E.isTypeDeclarationSibling(a)){var o=e.localType();o.isAnnotationType()&&(a=o)}var s=this.resolveReferenceValueBasic(i,t,n,[r.unit()],a);null!=s&&(r.setKeyOverride(s.value()),e.resetIDs())},e.prototype.resolveReferenceValueBasic=function(e,t,n,r,i){if(null==e||"string"!=typeof e)return null;var a,o,s=E.isTypeDeclarationDescendant(i),u=s&&v.stringEndsWith(e,"?"),l=u?e.substring(0,e.length-1):e,p=l.lastIndexOf(".");if(p>=0){var c=l.substring(0,p);o=l.substring(p+1);for(var d=r.length;d>0;d--){var m=r[d-1],h=n.nsMap(m);if(null!=h){var y=h[c];if(null!=y&&(a=y.unit,null!=a))break}}}else{if(s&&null!=b.rt.builtInTypes().get(l))return null;o=l,a=r[r.length-1]}var g=this.collectionName(i);if(null==a||a.absolutePath()==t.absolutePath())return null;var A=n.resolveNamespace(t,a);if(null==A)return null;var S=A.namespace();if(null==S)return null;if(this.mode==_.PATH){var T=a.absolutePath().replace(/\\/g,"/");f.isWebPath(T)||(T="file://"+T),S=T+"#/"+g}return u&&(o+="?"),new R(S,o,g,a,this.mode)},e.prototype.patchUses=function(e,t){var n=e.lowLevel();if(e.children(),g.LowLevelCompositeNode.isInstance(n)){var r=n.unit(),i=t.expandedPathMap(r);if(null!=i){var a=t.pathMap(r);a||(a={});for(var o=n,s=n.children(),l=A.Universe10.FragmentDeclaration.properties.uses.name,p=s.filter(function(e){return e.key()==l}),c=u(n),f=c;g.LowLevelProxyNode.isInstance(f);)f=f.originalNode();var m,y=Object.keys(a).map(function(e){return i[e]}),v=Object.keys(i).map(function(e){return i[e]}).filter(function(e){return!a[e.absolutePath()]}),S=r.absolutePath(),T={};if(p.length>0)m=p[0],m.children().forEach(function(e){return T[e.key()]=!0});else{var b=h.createMapNode("uses");b._parent=f,b.setUnit(f.unit()),m=o.replaceChild(null,b)}for(var N=e.definition().property(l),_=N.range(),w=e._children.filter(function(e){if(e.lowLevel().unit().absolutePath()==S)return!0;var t=e.property();return!t||!E.isUsesProperty(t)}),M=e._mergedChildren.filter(function(e){if(e.lowLevel().unit().absolutePath()==S)return!0;var t=e.property();return!t||!E.isUsesProperty(t)}),I=0,R=y.concat(v);I<R.length;I++){var C=R[I];C.absolutePath();if(!T[C.namespace()]){var L=C.includePath,P=h.createMapping(C.namespace(),L);P.setUnit(f.unit());var O=new d.ASTNodeImpl(P,e,_,N);w.push(O),M.push(O),m.replaceChild(null,P)}}e._children=w,e._mergedChildren=M}}},e.prototype.removeUses=function(e){var t=e.lowLevel();if(g.LowLevelCompositeNode.isInstance(t)){var n=t,r=t.children(),i=r.filter(function(e){return e.key()==A.Universe10.FragmentDeclaration.properties.uses.name});i.length>0&&n.removeChild(i[0]),e._children=e.directChildren().filter(function(e){var t=e.property();return null==t||!E.isUsesProperty(t)}),e._mergedChildren=e.children().filter(function(e){var t=e.property();return null==t||!E.isUsesProperty(t)})}},e.prototype.resetTypes=function(e){for(var t=0,n=e.elements();t<n.length;t++){var r=n[t];this.resetTypes(r)}for(var i=0,a=e.attrs();i<a.length;i++){var o=a[i],s=o.value();d.StructuredValue.isInstance(s)&&s.resetHighLevelNode()}delete e.lowLevel().actual().types,delete e._ptype,delete e._types,e.setAssociatedType(null)},e.prototype.appendUnitIfNeeded=function(e,t){if(h.CompilationUnit.isInstance(e)){var n=e;return n.absolutePath()!=t[t.length-1].absolutePath()?(t.push(n),!0):!1}var r=u(e.lowLevel()),i=r.unit();if(r.valueKind()==m.Kind.INCLUDE_REF){var a=r.includePath(),o=i.resolve(a);return o?(t.push(o),!0):!1}return i.absolutePath()!=t[t.length-1].absolutePath()?(t.push(i),!0):!1},e.prototype.popUnitIfNeeded=function(e,t){t&&e.pop()},e.prototype.registerPatchedReference=function(e){var t=e.collectionName();if(t){var n=e.referencedUnit().absolutePath(),r=this._outerDependencies[n];null==r&&(r={},this._outerDependencies[n]=r);var i=r[t];null==i&&(i={},r[t]=i),i[e.name()]=e}},e.prototype.collectionName=function(e){var t;return E.isResourceTypeRefType(e)||E.isResourceTypeType(e)?t=b.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name:E.isTraitRefType(e)||E.isTraitType(e)?t=b.universesInfo.Universe10.LibraryBase.properties.traits.name:E.isSecuritySchemeRefType(e)||E.isSecuritySchemaTypeDescendant(e)?t=b.universesInfo.Universe10.LibraryBase.properties.securitySchemes.name:E.isAnnotationRefTypeOrDescendant(e)||e.isAnnotationType()?t=b.universesInfo.Universe10.LibraryBase.properties.annotationTypes.name:(E.isTypeDeclarationDescendant(e)||E.isSchemaStringType(e))&&(t=b.universesInfo.Universe10.LibraryBase.properties.types.name),t},e.prototype.expandLibraries=function(e){if(!e.lowLevel().actual().libExpanded){var t=e.lowLevel(),n=t.unit(),r=(n.absolutePath(),n.project()),i=[],a=t.unit().project().namespaceResolver(),o=a.expandedPathMap(n);if(null!=o){for(var s=Object.keys(o).sort(),u=0,l=s;u<l.length;u++){var p=l[u],c=this._libModels[p];if(null==c){var f=r.unit(p,!0),d=a.resolveNamespace(n,f);f&&null!=d&&null!=d.namespace()&&(c=this.extractLibModel(f))}c&&i.push(c)}for(var m=!1,h=0,y=i;h<y.length;h++)for(var c=y[h],v=0,g=Object.keys(c);v<g.length;v++){var A=g[v],S=c[A];C.isInstance(S)&&(m=this.contributeCollection(e,S)||m)}if(m){var E=!1;do E=this.patchDependencies(e);while(E);this.removeUnusedDependencies(e)}}this.removeUses(e),e.lowLevel().actual().libExpanded=!0,this.resetTypes(e)}},e.prototype.patchDependencies=function(e){for(var t=!1,n=e.lowLevel().unit().absolutePath(),r=0,i=e.children();r<i.length;r++){var a=i[r];if(a.isElement()&&!a.lowLevel().libProcessed){var o=a.asElement();this.removeUses(o);var s=a.lowLevel().unit().absolutePath();if(s!=n||null!=a.lowLevel().includePath()){var u=this._outerDependencies[s];if(null!=u){var l=o.property().nameId(),p=u[l];if(null!=p){var c=o.name();null!=p[c]&&(this.process(o,e,!0,!0),t=!0)}}}}}return t},e.prototype.removeUnusedDependencies=function(e){for(var t=e.lowLevel(),n=t.unit().absolutePath(),r=e._children,i=[],a=0,o=r;a<o.length;a++){var s=o[a],u=s.lowLevel();if(s.isElement()&&u.libProcessed)i.push(s);else{var l=u.unit().absolutePath();l!=n?u.parent().removeChild(u):i.push(s)}}e._children=i,e._mergedChildren=null},e.prototype.contributeCollection=function(e,t){var n=e.lowLevel();if(0==t.array.length)return!1;var r=t.name,i=e.definition().property(r),a=i.range(),o=S.find(n.children(),function(e){return e.key()==r});if(null==o){var s=h.createMapNode(r);o=n.replaceChild(null,s)}for(var l=!1,p=e._children,c=e._mergedChildren,f=0,m=t.array;f<m.length;f++){var y=m[f];if(!o.children().some(function(e){var t=u(e);return t.unit().absolutePath()!=y.lowLevel().unit().absolutePath()?!1:y.lowLevel().key()==t.key()&&y.lowLevel().unit().absolutePath()==t.unit().absolutePath()})){var v=o.replaceChild(null,y.lowLevel()),g=y.isElement()&&y.asElement().definition()||a,A=new d.ASTNodeImpl(v,e,g,i);p.push(A),c&&c.push(A),l=!0}}return l},e.prototype.extractLibModel=function(e){var t=this._libModels[e.absolutePath()];if(null!=t)return t;t=new L(e),this._libModels[e.absolutePath()]=t;var n=e.highLevel();if(n&&n.isElement())for(var r=0,i=["resourceTypes","traits","types","annotationTypes","securitySchemes"];r<i.length;r++){for(var a=i[r],o=new C(a),s=0,u=n.asElement().elementsOfKind(a);s<u.length;s++){var l=u[s];o.array.push(l)}t[a]=o}return t},e}();t.ReferencePatcher=w,function(e){e[e.OK=0]="OK",e[e.NOT_REQUIRED=1]="NOT_REQUIRED",e[e.ERROR=2]="ERROR"}(t.ParametersEscapingStatus||(t.ParametersEscapingStatus={}));var M=t.ParametersEscapingStatus,I="__P_A_R_A_M_E_T_E_R__";t.escapeTemplateParameters=r,t.unescapeTemplateParameters=i,t.checkExpression=a,t.patchMethodIs=o,t.prepareTraitRefNode=s;var R=function(){function e(e,t,n,r,i){this._namespace=e,this._name=t,this._collectionName=n,this._referencedUnit=r,this._mode=i,this.gotQuestion=!1;var a=this._name.length;"?"==this._name.charAt(a-1)&&(this.gotQuestion=!0,this._name=this._name.substring(0,a-1))}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&S.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER_PatchedReference)},e.prototype.getClassIdentifier=function(){return[e.CLASS_IDENTIFIER_PatchedReference]},e.prototype.namespace=function(){return this._namespace},e.prototype.name=function(){return this._name},e.prototype.collectionName=function(){return this._collectionName},e.prototype.referencedUnit=function(){return this._referencedUnit},e.prototype.mode=function(){return this._mode},e.prototype.value=function(){if(null==this._namespace)return this._name;var e=this._mode==_.PATH?"/":".";return this._namespace+e+this._name+(this.gotQuestion?"?":"")},e.CLASS_IDENTIFIER_PatchedReference="referencePatcher.PatchedReference",e}();t.PatchedReference=R,t.instanceOfPatchedReference=l;var C=function(){function e(e){this.name=e,this.array=[]}return e.isInstance=function(t){return null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier&&S.contains(t.getClassIdentifier(),e.CLASS_IDENTIFIER)},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.CLASS_IDENTIFIER="referencePatcher.ElementsCollection",e}(),L=function(){function e(e){this.unit=e}return e}();t.getDeclaration=p,t.isCompoundValue=c;var P=function(e){var t=!e||e.isExternal();if(!t)for(var n=0,r=e.superTypes();n<r.length;n++){var i=r[n];if(t=i.isExternal())break}return t}},function(e,t,n){"use strict";function r(e,t){if(void 0===t&&(t=!1),!e)return null;var n=e.kind();if(n==u.Kind.ANCHOR_REF&&(n=e.anchorValueKind()),n==u.Kind.INCLUDE_REF){if(null!=e.unit()){var i=e.includePath(),a=null;try{a=e.unit().resolve(i)}catch(o){}if(null==a)return null;if(a.isRAMLUnit()&&this.canInclude(a)){var s=a.ast();if(s)return r(s,t)}}return null}if(n==u.Kind.SEQ){for(var l=[],p=0,c=e.children();p<c.length;p++){var f=c[p];l.push(r(f,t))}return l}if(n==u.Kind.ANCHOR_REF)return r(e.anchoredFrom(),t);if(n==u.Kind.MAPPING){var d={},m=""+e.key(!0),h=e.valueKind();if(h==u.Kind.INCLUDE_REF){var y=e.children();0==y.length?d[m]=e.value():h=null==y[0].key()?u.Kind.SEQ:u.Kind.MAP}if(h==u.Kind.ANCHOR_REF&&(h=e.anchorValueKind()),h==u.Kind.SCALAR)d[m]=e.value();else if(h==u.Kind.SEQ){var l=[];d[m]=l;for(var v=0,g=e.children();v<g.length;v++){var f=g[v];l.push(r(f,t))}}else if(h==u.Kind.MAP){var A={};d[m]=A;for(var S=0,E=e.children();S<E.length;S++){var f=E[S],T=""+f.key(!0),b=r(f,t);void 0===b&&(b=t?"!$$$novalue":null),A[T]=b}}return d[m]}if(n==u.Kind.SCALAR){var N=e.value(!1);return N}if(n==u.Kind.MAP){for(var A={},_=0,w=e.children();_<w.length;_++){var f=w[_],T=""+f.key(!0),b=r(f,!0);A[T]=void 0===b?null:b}return A}}function i(e,t){if(void 0===t&&(t={}),t=t||{},0==e.children().length)return e.value();if(e.children()[0].key()){var n={};if(e.children().forEach(function(e){n[o(e.key(t.rawKey),t)]=i(e,t)}),t&&t.writeErrors){var r=a(e);null!=r&&r.length>0&&(n.__$errors__=r)}return n}var s=[];return e.children().forEach(function(e){s.push(i(e,t))}),s}function a(e){var t=[].concat(e.errors());return e.children().forEach(function(e){var n=e.children();return 0==n.length?void e.errors().forEach(function(e){return t.push(e)}):void(n[0].key()||n.forEach(function(e){0==e.children().length&&e.errors().forEach(function(e){return t.push(e)})}))}),t}function o(e,t){return t&&e&&t.escapeNumericKeys&&0==e.replace(/\d/g,"").trim().length?"__$EscapedKey$__"+e:e}function s(e,t){return e?(t=t||{},t.escapeNumericKeys&&c.stringStartsWith(e,"__$EscapedKey$__")&&0==e.substring("__$EscapedKey$__".length).replace(/\d/g,"").trim().length?e.substring("__$EscapedKey$__".length):e):e}var u=n(73),l=n(10),p=n(16),c=n(33),f=n(24),d=u.YAMLException,m=function(){function e(e,t,n,r,i,a){void 0===a&&(a={}),this._absolutePath=e,this._path=t,this._content=n,this._project=r,this._isTopoLevel=i,this.serializeOptions=a,this._node=new h(this,JSON.parse(this._content),null,a)}return e.prototype.highLevel=function(){return p.fromUnit(this)},e.prototype.absolutePath=function(){return this._absolutePath},e.prototype.clone=function(){return null},e.prototype.contents=function(){return this._content},e.prototype.lexerErrors=function(){return[]},e.prototype.path=function(){return this._content},e.prototype.isTopLevel=function(){return this._isTopoLevel},e.prototype.ast=function(){return this._node},e.prototype.expandedHighLevel=function(){return this.highLevel()},e.prototype.isDirty=function(){return!0},e.prototype.getIncludeNodes=function(){return[]},e.prototype.resolveAsync=function(e){return null},e.prototype.isRAMLUnit=function(){return!0},e.prototype.project=function(){return this._project},e.prototype.updateContent=function(e){},e.prototype.ramlVersion=function(){throw new d("not implemented")},e.prototype.lineMapper=function(){return new l.LineMapperImpl(this.contents(),this.absolutePath())},e.prototype.resolve=function(e){return null},e.prototype.isOverlayOrExtension=function(){return!1},e.prototype.getMasterReferenceNode=function(){return null},e}();t.CompilationUnit=m;var h=function(){function e(e,t,n,r,i){var a=this;void 0===r&&(r={}),this._unit=e,this._object=t,this._parent=n,this.options=r,this._key=i,this._isOptional=!1,this._object instanceof Object&&Object.keys(this._object).forEach(function(e){var t=s(e,a.options);if(t!=e){var n=a._object[e];delete a._object[e],a._object[t]=n}}),this._key&&c.stringEndsWith(this._key,"?")&&(this._isOptional=!0,this._key=this._key.substring(0,this._key.length-1))}return e.prototype.keyKind=function(){return null},e.prototype.isAnnotatedScalar=function(){return!1},e.prototype.hasInnerIncludeError=function(){return!1},e.prototype.start=function(){return-1},e.prototype.end=function(){return-1},e.prototype.value=function(){return this._object},e.prototype.actual=function(){return this._object},e.prototype.includeErrors=function(){return[]},e.prototype.includePath=function(){return null},e.prototype.includeReference=function(){return null},e.prototype.key=function(){return this._key},e.prototype.optional=function(){return this._isOptional},e.prototype.children=function(){var t=this;return this._object?Array.isArray(this._object)?this._object.map(function(n){return new e(t._unit,n,t,t.options)}):this._object instanceof Object?Object.keys(this._object).map(function(n){return new e(t._unit,t._object[n],t,t.options,n)}):[]:[]},e.prototype.parent=function(){return this._parent},e.prototype.unit=function(){return this._unit},e.prototype.containingUnit=function(){return this._unit},e.prototype.includeBaseUnit=function(){return this._unit},e.prototype.anchorId=function(){return null},e.prototype.errors=function(){return[]},e.prototype.anchoredFrom=function(){return this},e.prototype.includedFrom=function(){return this},e.prototype.visit=function(e){e(this)&&this.children().forEach(function(t){return t.visit(e)})},e.prototype.dumpToObject=function(){return this._object},e.prototype.addChild=function(e){},e.prototype.execute=function(e){},e.prototype.dump=function(){return JSON.stringify(this._object)},e.prototype.keyStart=function(){return-1},e.prototype.keyEnd=function(){return-1},e.prototype.valueStart=function(){return-1},e.prototype.valueEnd=function(){return-1},e.prototype.isValueLocal=function(){return!0},e.prototype.kind=function(){return Array.isArray(this._object)?u.Kind.SEQ:this._object instanceof Object?u.Kind.MAP:u.Kind.SCALAR},e.prototype.valueKind=function(){if(!this._object)return null;var e=typeof this._object;return Array.isArray(this._object)?u.Kind.SEQ:"object"==e?u.Kind.MAP:"string"==e||"number"==e||"boolean"==e?u.Kind.SCALAR:null},e.prototype.anchorValueKind=function(){return null},e.prototype.show=function(e){},e.prototype.setHighLevelParseResult=function(e){this._highLevelParseResult=e},e.prototype.highLevelParseResult=function(){return this._highLevelParseResult},e.prototype.setHighLevelNode=function(e){this._highLevelNode=e},e.prototype.highLevelNode=function(){return this._highLevelNode},e.prototype.text=function(e){throw new d("not implemented")},e.prototype.copy=function(){throw new d("not implemented")},e.prototype.markup=function(e){throw new d("not implemented")},e.prototype.nodeDefinition=function(){return f.getDefinitionForLowLevelNode(this)},e.prototype.includesContents=function(){return!1},e}();t.AstNode=h,t.serialize2=r,t.serialize=i},function(e,t,n){"use strict";var r=n(28),i=n(83),a=function(){function e(){this.uriToResources={},this.conflictingUriToResources={}}return e.prototype.validateApi=function(e,t){var n=this,a=e.resources();a.forEach(function(e){n.acceptResource(e);var t=e.resources();t.forEach(function(e){return n.acceptResource(e)})});for(var o in this.conflictingUriToResources){var a=this.conflictingUriToResources[o];if(a.length>1){var s={};a.forEach(function(e){var t=e.highLevel(),n="";null!=t.parent()&&(n+=t.parent().id()+"."),n+=t.localId();var r=s[n];null==r&&(r=[],s[n]=r),r.push(e)});var u=Object.keys(s);u.length>1&&a.forEach(function(e){t.accept(r.createIssue1(i.RESOURCES_SHARE_SAME_URI,{},e.highLevel(),!1))})}}},e.prototype.acceptResource=function(e){var t=e.absoluteUri(),n=this.uriToResources[t];n||(n=[],this.uriToResources[t]=n),n.push(e),n.length>1&&(this.conflictingUriToResources[t]=n)},e}();e.exports=a},function(e,t,n){"use strict";function r(e,t,n){null==n&&(n=i(e)),n.length>0&&(n+=":");for(var r=e.getElementsByTagName(n+t),a=[],o=0;o<r.length;o++){var s=r[o];s.parentNode===e&&a.push(s)}return a}function i(e){var t="";if(e){var n=e;if(e.ownerDocument&&(n=e.ownerDocument),n){var r=n.documentElement;r&&(t=r.prefix)}}return t}function a(e){try{var t=new p.DOMParser(c).parseFromString(e),n=r(t,"schema",i(t));return n.length>0}catch(a){return!1}}function o(e){var t={};if(1==e.nodeType){if(e.attributes.length>0)for(var n=0;n<e.attributes.length;n++){var r=e.attributes.item(n);t["@"+r.nodeName]=r.nodeValue;
}}else 3==e.nodeType&&(t=e.nodeValue);if(e.hasChildNodes())for(var i=0;i<e.childNodes.length;i++){var a=e.childNodes.item(i),s=a.nodeName;if(void 0!=s)if("undefined"==typeof t[s])t[s]=o(a);else{if("undefined"==typeof t[s].push){var u=t[s];t[s]=[],t[s].push(u)}t[s].push(o(a))}}return t}function s(e){if("object"==typeof e)for(var t in e)if("object"==typeof e[t]){for(var n in e[t])if("#text"==n){var r=e[t]["#text"];"string"!=typeof r&&(r=r.join("")),r=r.trim(),0==r.length&&delete e[t]["#text"]}s(e[t])}return e}function u(e){if("object"==typeof e)for(var t in e)if("object"==typeof e[t]){var n=Object.keys(e[t]);1==n.length&&"#text"==n[0]&&(e[t]=e[t]["#text"]),u(e[t])}return e}function l(e){var t=new p.DOMParser(c);if(!e||0==e.trim().indexOf("<<"))return null;var n=t.parseFromString(e);return u(s(o(n)))}var p=n(74),c={errorHandler:{warning:function(){return null},error:function(){return null},fatalError:function(){return null}}};t.isXmlScheme=a,t.parseXML=l},function(e,t,n){"use strict";var r=n(39),i=n(18),a=n(14),o=r,s=n(13),u=function(){function e(e,t){void 0===t&&(t=!1),this.enabled=e,this.toHighLevel=t,this.unconditionalValueCalculators=[new v],this.valueCalculators=[new d,new f,new c,new p,new m(this.toHighLevel),new h,new y]}return e.prototype.attributeDefaultIfEnabled=function(e,t){return this.enabled?this.getAttributeDefault(e,t):this.getUnconditionalAttributeDefault(t,e)},e.prototype.getUnconditionalAttributeDefault=function(e,t){if(!t||!e)return null;for(var n=0;n<this.unconditionalValueCalculators.length;n++){var r=this.unconditionalValueCalculators[n];if(r.matches(e,t)){var i=r.calculate(e,t);if(null!=i)return i}}return null},e.prototype.getAttributeDefault=function(e,t){if(!e||!t)return null;try{return this.getAttributeDefault2(t,e)}catch(n){return console.log(n),null}},e.prototype.getWrapperAttributeDefault=function(e,t){var n=e.highLevel();if(null==n)return null;var r=n.definition().property(t);return null==r?null:this.getAttributeDefault(n,r)},e.prototype.getAttributeDefault2=function(e,t){for(var n=0;n<this.valueCalculators.length;n++){var r=this.valueCalculators[n];if(r.matches(e,t)){var i=r.calculate(e,t);if(null!=i)return i}}return null!=e.defaultValue()?e.defaultValue():null},e.prototype.isEnabled=function(){return this.enabled},e.prototype.insertionKind=function(e,t){for(var n=0;n<this.valueCalculators.length;n++){var r=this.valueCalculators[n];if(r.matches(t,e))return r.kind()}return null!=t.defaultValue()?l.BY_DEFAULT:null},e}();t.AttributeDefaultsCalculator=u,function(e){e[e.CALCULATED=0]="CALCULATED",e[e.BY_DEFAULT=1]="BY_DEFAULT"}(t.InsertionKind||(t.InsertionKind={}));var l=t.InsertionKind,p=function(){function e(){}return e.prototype.calculate=function(e,t){var n=s.declRoot(t);if(n&&a.isApiSibling(n.definition())){var r=n.attr(i.Universe10.Api.properties.mediaType.name);if(r)return r.value()}return null},e.prototype.matches=function(e,t){if(!a.isNameProperty(e))return!1;var n=t.definition();if(!n)return!1;if(!a.isBodyLikeType(n)&&!a.isTypeDeclarationSibling(n))return!1;var r=t.parent();if(null==r)return!1;var i=r.definition();if(null==i)return!1;if(!a.isResponseType(i)&&!a.isMethodBaseSibling(i))return!1;for(var o=r;o;){var s=o.definition();if(a.isTraitType(s))return!1;if(a.isResourceTypeType(s))return!1;o=o.parent()}return!0},e.prototype.kind=function(){return l.CALCULATED},e}(),c=function(){function e(){}return e.prototype.calculate=function(e,t){var n=t.definition();if(null==n)return null;var r=n.getAdapter(o.RAMLService),i=r.getKeyProp();if(null!=i){var a=t.attrValue(i.nameId());return null!=a?a:new u(!0).getAttributeDefault(t,i)}return null},e.prototype.matches=function(e,t){var n=t.definition();return null==n?!1:(a.isTypeDeclarationSibling(n)||n.isAssignableFrom(i.Universe08.Parameter.name)||a.isResourceType(n))&&a.isDisplayNameProperty(e)},e.prototype.kind=function(){return l.CALCULATED},e}(),f=function(){function e(){}return e.prototype.calculate=function(e,t){return"object"},e.prototype.matches=function(e,t){return a.isTypeProperty(e)&&null!=t.definition()&&a.isObjectTypeDeclarationSibling(t.definition())},e.prototype.kind=function(){return l.BY_DEFAULT},e}(),d=function(){function e(){}return e.prototype.calculate=function(e,t){var n=t.definition(),r=t.property();if(null==n)return null;var i=n.getAdapter(o.RAMLService),s=i.getKeyProp();if(null!=s){var u=t.attr(s.nameId());if(null!=u&&u.optional())return!1}if(null!=r){if(a.isHeadersProperty(r)||a.isFormParametersProperty(r)||a.isQueryParametersProperty(r))return"RAML08"==e.domain().universe().version()?!1:!0;if(a.isUriParametersProperty(r)||a.isBaseUriParametersProperty(r))return!0}return null!=e.defaultValue()?e.defaultValue():null},e.prototype.matches=function(e,t){return a.isRequiredProperty(e)},e.prototype.kind=function(){return l.BY_DEFAULT},e}(),m=function(){function e(e){void 0===e&&(e=!1),this.toHighLevel=e}return e.prototype.calculate=function(e,t){if(a.isApiSibling(t.definition()))return null;var n,r=t.definition();if(a.isMethodType(r)){var i=t.parent();i&&(n=this.toHighLevel?i.attributes("securedBy"):i.wrapperNode().securedBy())}if(!n||0==n.length){for(;null!=t&&!a.isApiSibling(t.definition());)t=t.parent();t&&(n=this.toHighLevel?t.attributes("securedBy"):t.wrapperNode().securedBy())}return n&&n.length>0?n:null},e.prototype.matches=function(e,t){var n=t.definition();return null==n?!1:a.isSecuredByProperty(e)},e.prototype.kind=function(){return l.CALCULATED},e}(),h=function(){function e(){}return e.prototype.calculate=function(e,t){for(;null!=t&&!a.isApiSibling(t.definition());)t=t.parent();var n,r=t.attr(i.Universe10.Api.properties.baseUri.name);if(r){var o=r.value();if(o){var s=o.indexOf("://");s>=0&&(n=[o.substring(0,s).toUpperCase()]),n||(n=["HTTP"])}}return n},e.prototype.matches=function(e,t){if(!a.isProtocolsProperty(e))return!1;var n=t.definition(),r=!1;if(a.isApiSibling(n))r=!0;else if(a.isResourceType(n))r=!0;else if(a.isMethodType(n)){var i=t.parent();r=i&&a.isResourceType(i.definition())}return r},e.prototype.kind=function(){return l.CALCULATED},e}(),y=function(){function e(){}return e.prototype.calculate=function(e,t){for(;null!=t&&!a.isApiSibling(t.definition());)t=t.parent();var n=t.attr(i.Universe10.Api.properties.version.name);if(n){var r=n.value();if(r&&r.trim())return[r]}return null},e.prototype.matches=function(e,t){if(!a.isEnumProperty(e))return!1;var n=t.property();if(!n)return!1;if(!a.isBaseUriParametersProperty(n))return!1;var r=t.attr(i.Universe10.TypeDeclaration.properties.name.name),o=r&&r.value();return"version"!=o?!1:!0},e.prototype.kind=function(){return l.CALCULATED},e}(),v=function(){function e(){}return e.prototype.calculate=function(e,t){var n=t.definition();if(null==n)return null;var r=n.getAdapter(o.RAMLService);if(null==r)return null;var i=r.getKeyProp();if(null==i)return null;var a=t.attr(i.nameId());return null==a?null:a.optional()?!1:null},e.prototype.matches=function(e,t){return a.isRequiredProperty(e)},e.prototype.kind=function(){return l.BY_DEFAULT},e}()},function(e,t,n){"use strict";function r(e,t){void 0===t&&(t=!1);var n=N.Universe10.ResourceBase.properties.uriParameters.name,r=e.elementsOfKind(n);if(!C.isResourceType(e.definition()))return r;var i=e.attr(N.Universe10.Resource.properties.relativeUri.name).value();return a(r,i,e,n,t)}function i(e,t){void 0===t&&(t=!0);var n=e.attr(N.Universe10.Api.properties.baseUri.name),r=n?n.value():"",i=N.Universe10.Api.properties.baseUriParameters.name,o=e.elementsOfKind(i);return a(o,r,e,i,t)}function a(e,t,n,r,i){if("string"!=typeof t)return[];var a=n.definition(),o=a.property(r);if(!t)return[];var s={};e.forEach(function(e){var t=s[e.name()];t||(t=[],s[e.name()]=t),t.push(e)});for(var u=[],l=0,p={},c=t.indexOf("{");c>=0&&(l=t.indexOf("}",++c),!(0>l));c=t.indexOf("{",l)){var f=t.substring(c,l);if(p[f]=!0,s[f])s[f].forEach(function(e){return u.push(e)});else{var d=a.universe(),m=d.type(b.Universe10.StringTypeDeclaration.name),h=E.createStubNode(m,null,f,n.lowLevel().unit());h.setParent(n),i&&h.wrapperNode().meta().setCalculated(),h.attrOrCreate("name").setValue(f),h.patchProp(o),u.push(h)}}return Object.keys(s).filter(function(e){return!p[e]}).forEach(function(e){return s[e].forEach(function(e){return u.push(e)})}),u}function o(e){var t="",n=e;do e=n,t=e.attr(b.Universe10.Resource.properties.relativeUri.name).value()+t,n=e.parent();while(C.isResourceType(n.definition()));return t}function s(e){if(!C.isResourceType(e.definition()))return null;var t="",n=e;do e=n,t=e.attr(b.Universe10.Resource.properties.relativeUri.name).value()+t,n=e.parent();while(C.isResourceType(n.definition()));t=t.replace(/\/\//g,"/");var r="",i=n.attr(b.Universe10.Api.properties.baseUri.name);return i&&(r=i?i.value():""),r=r?r:"",_.stringEndsWith(r,"/")&&(t=t.substring(1)),t=r+t}function u(e,t){void 0===t&&(t=!1);var n=c(e,!0,t);return n.length>0?n[0]:null}function l(e,t){return void 0===t&&(t=!1),c(e,!1,t)}function p(e,t){void 0===t&&(t=!1);var n;n=e.isJSONString()||e.isYAML()?e.asJSON():e.original();var r={value:n,strict:e.strict(),name:e.name()};if(e.hasAnnotations()){var i=e.annotations(),a=f(i);Object.keys(a).length>0&&(r.annotations=a)}if(e.hasScalarAnnotations()){var o=e.scalarsAnnotations(),s={};Object.keys(o).forEach(function(e){var t=f(o[e]);Object.keys(t).length>0&&(s[e]=Object.keys(t).map(function(e){return t[e]}))}),Object.keys(s).length>0&&(r.scalarsAnnotations=s)}var u=e.displayName();u&&(r.displayName=u);var l=e.description();return null!=l&&(r.description=l),t&&(r.asXMLString=e.asXMLString()),r}function c(e,t,n){void 0===n&&(n=!1);var r=e.localType();r.isAnnotationType()&&(r=T.find(r.superTypes(),function(e){return e.nameId()==r.nameId()}));var i=r.examples().filter(function(e){return null!=e&&!e.isEmpty()&&e.isSingle()==t}).map(function(e){return p(e,n)});return i}function f(e){var t={};return e&&Object.keys(e).forEach(function(n){t[n]={structuredValue:e[n].value(),name:n}}),t}function d(e,t){return void 0===t&&(t=!0),e.lowLevel().actual().libExpanded?[]:h(e,function(e){return C.isTraitType(e)},t)}function m(e,t){return void 0===t&&(t=!0),e.lowLevel().actual().libExpanded?[]:h(e,function(e){return C.isResourceTypeType(e)},t)}function h(e,t,n){var r=R.globalDeclarations(e).filter(function(e){return t(e.definition())}),i=e.lowLevel(),a=i.includePath();a||(a=i.unit().path());for(var o="RAML10"==e.definition().universe().version()&&!C.isOverlayType(e.definition()),s=o?new w.TraitsAndResourceTypesExpander:null,u=[],l=new I.ReferencePatcher,p=0,c=r;p<c.length;p++){var f=c[p],d=f.lowLevel().unit().path();o&&(M.LowLevelProxyNode.isInstance(f.lowLevel())||(f=s.createHighLevelNode(f,!1)),l.process(f,e,!0,!0)),n&&d!=a&&f.wrapperNode().meta().setCalculated(),u.push(f)}return u}function y(e){return v(e)}function v(e,t){var n=e.attr(N.Universe08.BodyLike.properties.schema.name);if(!n)return null;var r=n.value();if(!r)return null;if(_.stringStartsWith(r,"{")||_.stringStartsWith(r,"[")||_.stringStartsWith(r,"<"))return n;var i;if(t)i=t[r];else{var a=e.root(),o=a.elementsOfKind(N.Universe08.Api.properties.schemas.name);i=T.find(o,function(e){return e.name()==r})}if(!i)return n;if(!i)return n;if(!i.getKind||i.getKind()!=S.NodeKind.NODE)return n;if(i.definition().key()!=N.Universe08.GlobalSchema)return n;var s=i.attr(N.Universe08.GlobalSchema.properties.value.name);return null==s?null:s}function g(e){var t=e.definition();if(C.isMethodType(t)||C.isTypeDeclarationDescendant(t)){for(var n=!1,r=e.parent();null!=r;){var i=r.definition();if(C.isResourceTypeType(i)||C.isTraitType(i)){n=!0;break}r=r.parent()}if(!n)return null}if(null==e)return null;var a=e.lowLevel();if(null==a)return null;var o=a.children().filter(function(e){var t=e.key();return t?"("==t.charAt(0)&&")"==t.charAt(t.length-1)?!1:t.indexOf("<<")>=0:!1});if(0==o.length)return null;var s={};return o.forEach(function(e){var t=e.dumpToObject();Object.keys(t).forEach(function(e){return s[e]=t[e]})}),s}function A(e){var t=e.localType(),n=t.fixedFacets(),r=Object.keys(n);if(!t.hasUnionInHierarchy())for(var i=0,a=r;i<a.length;i++){var o=a[i];null==t.facet(o)&&delete n[o]}return 0==Object.keys(n).length?null:n}var S=n(9),E=n(17),T=n(65),b=n(18),N=n(18),_=n(33),w=n(30),M=n(41),I=n(53),R=n(13),C=n(14);t.uriParameters=r,t.baseUriParameters=i,t.completeRelativeUri=o,t.absoluteUri=s,t.typeExample=u,t.typeExamples=l,t.dumpExpandableExample=p,t.allTraits=d,t.allResourceTypes=m,t.schemaContent08=y,t.schemaContent08Internal=v,t.getTemplateParametrizedProperties=g,t.typeFixedFacets=A},function(e,t,n){"use strict";function r(e,t,n,r){var i=r.end!==!1,a=r.strict,o="";r.sensitive||(o+="i");var s=e.replace(c,function(e,r,i,a){if(a)return"\\"+a;n.push({name:i,prefix:r||"/"}),r=r?"\\"+r:"";var o=t[i],s=o&&l[o.type]||"[^"+(r||"\\/")+"]+",u=o&&o.required===!1;return Array.isArray(o["enum"])&&o["enum"].length&&(s="(?:"+o["enum"].map(function(e){return String(e).replace(p,"\\$1")}).join("|")+")"),r+"("+s+")"+(u?"?":"")}),u="/"===e.charAt(e.length-1);return a||(s=(u?s.slice(0,-2):s)+"(?:\\/(?=$))?"),s+=i?"$":a&&u?"":"(?=\\/|$)",new RegExp("^"+s+(i?"$":""),o)}function i(e){try{return decodeURIComponent(e)}catch(t){var n=new Error('Failed to decode param "'+e+'"');throw n.status=400,n}}function a(e,t,n){if(n=n||{},"/"===e&&n.end===!1)return o;t=t||{};var a=[],l=r(e,t,a,n),p=s.sanitize()(t),c=u.validate()(t);return function(e){var n=l.exec(e);if(!n)return!1;if(t.mediaTypeExtension&&n.length>1&&!n[n.length-1]){var r=n[n.length-2],o=r.lastIndexOf(".");o>=0&&(n[n.length-2]=r.substring(0,o),n[n.length-1]=r.substring(o))}for(var s=n[0],u={},f=1;f<n.length;f++){var d=a[f-1],m=n[f];u[d.name]=null==m?m:i(m)}return u=p(u),c(u).valid?{path:s,params:u}:!1}}function o(e){return{path:"",params:{}}}var s=n(80),u=n(81),l={number:"[-+]?\\d+(?:\\.\\d+)?",integer:"[-+]?\\d+",date:"(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), \\d{2} (?:Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) \\d{4} (?:[0-1]\\d|2[0-3]):[0-5]\\d:[0-5]\\d GMT","boolean":"(?:true|false)"},p=/([.*+?=^!:${}()|[\]\/\\])/g,c=new RegExp(["([.\\/])?\\{([^}]+)\\}",p.source].join("|"),"g");t.ramlPathMatch=a},function(e,t,n){"use strict";function r(e){var t=e[0],n={};return e.forEach(function(e){return n[e.name]=e}),e.forEach(function(e){var t=e.imports;Object.keys(t).forEach(function(e){var r=t[e];t[e]=n[r]})}),t}t.universeDumps={RAML08:r(n(92)),RAML10:r(n(93))}},function(e,t,n){"use strict";function r(e,t){var n=new s.Universe(t,""),r={};return T(e,n,{},r),Object.keys(r).forEach(function(e){A(r[e],n)}),Object.keys(r).forEach(function(e){S(r[e],n)}),Object.keys(r).forEach(function(e){E(r[e],n)}),n.types().forEach(function(e){if(e instanceof s.NodeClass){var t=e;if(t.properties().forEach(function(e){var t=e.range(),n=e;t.hasValueTypeInHierarchy()||t.properties().forEach(function(e){if(e.getAdapter(p.RAMLPropertyService).isKey()){var t=e.keyPrefix();t&&(n.withKeyRestriction(t),n.merge());var r=e.enumOptions();r&&(n.withEnumOptions(r),n.merge())}})}),t.getAdapter(p.RAMLService).isGlobalDeclaration()){if(t.getAdapter(p.RAMLService).getActuallyExports()&&"$self"!=t.getAdapter(p.RAMLService).getActuallyExports()){var r=t.property(t.getAdapter(p.RAMLService).getActuallyExports()).range();if(r.hasValueTypeInHierarchy()){var i=r.getAdapter(p.RAMLService);i.setGloballyDeclaredBy(t)}}if(t.getAdapter(p.RAMLService).getConvertsToGlobal()){var r=n.type(t.getAdapter(p.RAMLService).getConvertsToGlobal());if(r.hasValueTypeInHierarchy()){var i=r.getAdapter(p.RAMLService);i.setGloballyDeclaredBy(t)}}}}}),n}function i(e,t,n,r,i){var a=s.prop(e.name(),"",t,n,r);e.isMultiValue()&&a.withMultiValue(!0),a.unmerge(),n||console.log(e.name()+":"+t.nameId()+" has undefined type"),n.hasValueTypeInHierarchy()||n.properties().forEach(function(e){if(e.getAdapter(p.RAMLPropertyService).isKey()){var t=e.keyPrefix();t&&(a.withKeyRestriction(t),a.merge());var n=e.enumOptions();n&&(a.withEnumOptions(n),a.merge())}}),b(e,a,i)}var a=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},o=n(96),s=n(39),u=n(94),l=n(82),p=s,c=function(){function e(e,t){this._field=e,this._clazz=t}return e.prototype.name=function(){return this._field.name},e.prototype.range=function(){return this._clazz.getModule().typeFor(this._field.type,this._clazz)},e.prototype.isMultiValue=function(){return this._field.type.typeKind==o.TypeKind.ARRAY},e.prototype.isKey=function(){return null!=u.find(this._field.annotations,function(e){return"MetaModel.key"==e.name})},e.prototype.isSimpleValue=function(){return null!=u.find(this._field.annotations,function(e){return"MetaModel.value"==e.name})},e.prototype.annotations=function(){return this._field.annotations},e}(),f=function(){function e(e,t){this._field=e,this._clazz=t}return e.prototype.name=function(){return this._field.name},e.prototype.value=function(){return this._field.valueConstraint},e}(),d=function(){function e(e,t){this._clazz=e,this.mw=t}return e.prototype.typeMeta=function(){return this._clazz.annotations},e.prototype.path=function(){return this.mw.path()},e.prototype.getModule=function(){return this.mw},e.prototype.typeArgs=function(){return this._clazz.typeParameters},e.prototype.typConstraints=function(){var e=this;return this._clazz.typeParameterConstraint.map(function(t){return t?e.mw.classForName(t):null})},e.prototype.methods=function(){return this._clazz.methods},e.prototype.name=function(){return this._clazz.name},e.prototype.members=function(){var e=this;return this._clazz.fields.filter(function(e){return null==e.valueConstraint}).map(function(t){return new c(t,e)})},e.prototype.constraints=function(){var e=this;return this._clazz.fields.filter(function(e){return null!=e.valueConstraint}).map(function(t){return new f(t,e)})},e.prototype.isSubTypeOf=function(e){if(this==e)return!0;var t=!1;return this.getAllSuperTypes().forEach(function(n){t||(t=t||n.isSubTypeOf(e))}),t},e.prototype.getExtendsClauses=function(){return this._clazz["extends"]},e.prototype.getSuperTypes=function(){var e=this,t=[];return this._clazz["extends"].forEach(function(n){var r=e.mw.classForName(n.typeName);r&&t.push(r)}),t},e.prototype.getAllSuperTypes=function(){var e=this,t=[];return this._clazz["extends"].forEach(function(n){var r=e.mw.classForName(n.typeName);if(r){var i=r.getAllSuperTypes();t.push(r),t.concat(i)}}),u.unique(t)},e.prototype.annotationOverridings=function(){return this._clazz.annotationOverridings},e}(),m=function(){function e(){}return e.prototype.members=function(){return[]},e.prototype.methods=function(){return[]},e.prototype.isSubTypeOf=function(e){return!1},e.prototype.getSuperTypes=function(){return[]},e.prototype.getAllSuperTypes=function(){return[]},e.prototype.name=function(){return null},e.prototype.constraints=function(){return[]},e.prototype.typeMeta=function(){return[]},e.prototype.getModule=function(){throw new Error("Not implemented")},e.prototype.annotationOverridings=function(){return{}},e}(),h=function(e){function t(t,n){e.call(this),this._clazz=t,this.mw=n}return a(t,e),t.prototype.getModule=function(){return this.mw},t.prototype.values=function(){return this._clazz.members},t.prototype.name=function(){return this._clazz.name},t}(m),y=function(e){function t(t,n){e.call(this),this._clazz=t,this.mw=n}return a(t,e),t.prototype.elements=function(){return this._clazz},t.prototype.name=function(){return this._clazz.map(function(e){return e.name()}).join("|")},t}(m),v=function(){function e(e){var t=this;this._univers=e,this.name2Class={},this.namespaceToMod={},this._classes=[],e.classes.forEach(function(e){var n=new d(e,t);t._classes.push(n),t.name2Class[e.name]=n,e.moduleName&&(t.name2Class[e.moduleName+"."+e.name]=n)}),e.enumDeclarations.forEach(function(e){var n=new h(e,t);t._classes.push(n),t.name2Class[e.name]=n})}return e.prototype.typeFor=function(e,t){var n=this;switch(e.typeKind){case o.TypeKind.BASIC:var r=e,i=r.typeName;"string"==i&&(i="StringType"),"number"==i&&(i="NumberType"),"boolean"==i&&(i="BooleanType"),"any"==i&&(i="AnyType");var a=u.indexOf(t.typeArgs(),i);if(-1!=a){var s=t.typConstraints()[a];return s?s:this.classForName("ValueType")}return this.classForName(i);case o.TypeKind.UNION:var l=e;return new y(l.options.map(function(e){return n.typeFor(e,t)}),this);case o.TypeKind.ARRAY:var p=e;return this.typeFor(p.base,t)}return null},e.prototype.path=function(){return this._univers.name},e.prototype.classForName=function(e,t){var n=this;if(void 0===t&&(t={}),!e)return null;var r=this.name2Class[e];if(!r&&!t[this.path()]){t[this.path()]=this;var i=e.indexOf(".");if(-1!=i){var a=this.namespaceToMod[e.substring(0,i)];if(!a)throw new Error;return a.classForName(e.substring(i+1),t)}Object.keys(this.namespaceToMod).forEach(function(i){if("MetaModel"!=i){var a=n.namespaceToMod[i].classForName(e,t);a&&(r=a)}})}return r},e.prototype.classes=function(){return this._classes},e}(),g=function(e,t){if(e){var n;if(e instanceof y){throw new Error("Union type support was removed from definition system")}return n=t.type(e.name())}},A=function(e,t){var n=e.classForName("ValueType");e.classes().forEach(function(e){if(e instanceof h){var r=new s.EnumType(e.name(),t,e.getModule().path());return r.values=e.values(),void t.register(r)}if(e.isSubTypeOf(n)){var i=e.getAllSuperTypes();i.push(e);var a=null;if(i.forEach(function(e){var t=e.getExtendsClauses();t.forEach(function(e){if(e.typeKind==o.TypeKind.BASIC){var t=e;if("Reference"==t.basicName){var n=t.typeArguments[0];a=n.typeName;var r=a.indexOf(".");-1!=r&&(a=a.substring(r+1))}}})}),a){var u=new s.ReferenceType(e.name(),e.getModule().path(),a,t);u.setBuiltIn(!0),t.register(u)}else{var l=new s.ValueType(e.name(),t,e.getModule().path());l.setBuiltIn(!0),t.register(l)}}else{var p=new s.NodeClass(e.name(),t,e.getModule().path());p.setBuiltIn(!0),t.register(p)}})},S=function(e,t){e.classes().forEach(function(e){e.getSuperTypes().forEach(function(n){var r=t.type(e.name()),i=t.type(n.name());if(!r||!i){var r=t.type(e.name()),i=t.type(n.name());throw new Error}t.registerSuperClass(r,i)})})},E=function(e,t){e.classes().forEach(function(e){var n=t.type(e.name());e.typeMeta().forEach(function(n){var r=g(e,t);l.handleTypeAnnotation(n,r)}),e.members().forEach(function(e){var r=e.range(),a=g(r,t);null==a&&console.log(r+":"+e.name());var o=e.annotations().map(function(e){return e.name}).indexOf("MetaModel.customHandling")>=0;i(e,n,a,o)}),Object.keys(e.annotationOverridings()).forEach(function(r){var a=[].concat(e.annotationOverridings()[r]),o={};a.forEach(function(e){return o[e.name]=!0});for(var s,u=e.getSuperTypes(),l={},p=0;p<u.length;p++){var c=u[p];if(!l[c.name()]){l[c.name()]=!0,c.getSuperTypes().forEach(function(e){return u.push(e)});var f=c.annotationOverridings()[r];if(f)f.filter(function(e){return!o[e.name]}).forEach(function(e){o[e.name]=!0,a.push(e)});else for(var d=c.members(),m=0;m<d.length;m++){var h=d[m];if(h.name()==r){s=h;break}}if(s){var y=s.annotations();y.filter(function(e){return!o[e.name]}).forEach(function(e){o[e.name]=!0,a.push(e)});break}}}if(s){var v=s.range(),A=g(v,t);null==A&&console.log(v+":"+e.name()),i(s,n,A,!1,a)}}),e.methods().forEach(function(e){}),e.constraints().forEach(function(e){if(e.value().isCallConstraint)throw new Error;var t=e.value();n.addRequirement(e.name(),""+t.value)})}),t.types().forEach(function(e){var n=e;n.getAdapter(p.RAMLService).getAliases().forEach(function(e){return t.registerAlias(e,n)})})},T=function(e,t,n,r){if(-1==e.name.indexOf("metamodel.ts")){if(r[e.name])return r[e.name];var i=new v(e);return n[e.name]=i,r[e.name]=i,Object.keys(e.imports).forEach(function(a){var o=e.imports[a];if(n[o.name])return void(i.namespaceToMod[a]=n[o.name]);var s=T(o,t,n,r);i.namespaceToMod[a]=s}),n[e.name]=null,i}};t.toDefSystem=r;var b=function(e,t,n){n||(n=e.annotations()),n.forEach(function(e){var n=e.name.substring(e.name.lastIndexOf(".")+1);l.annotationHandlers[n]||console.log("Can not find handler for:"),l.annotationHandlers[n](e,t)})}},function(e,t,n){"use strict";var r={Universe08:{GlobalSchema:{name:"GlobalSchema",properties:{key:{name:"key",range:"StringType",domain:"GlobalSchema"},value:{name:"value",range:"SchemaString",domain:"GlobalSchema"}}},Api:{name:"Api",properties:{title:{name:"title",range:"StringType",domain:"Api"},version:{name:"version",range:"StringType",domain:"Api"},baseUri:{name:"baseUri",range:"FullUriTemplateString",domain:"Api"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Api"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Api"},protocols:{name:"protocols",range:"StringType",domain:"Api"},mediaType:{name:"mediaType",range:"MimeType",domain:"Api"},schemas:{name:"schemas",range:"GlobalSchema",domain:"Api"},traits:{name:"traits",range:"Trait",domain:"Api"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Api"},securitySchemes:{name:"securitySchemes",range:"AbstractSecurityScheme",domain:"Api"},resourceTypes:{name:"resourceTypes",range:"ResourceType",domain:"Api"},resources:{name:"resources",range:"Resource",domain:"Api"},documentation:{name:"documentation",range:"DocumentationItem",domain:"Api"},RAMLVersion:{name:"RAMLVersion"}}},DocumentationItem:{name:"DocumentationItem",properties:{title:{name:"title",range:"StringType",domain:"DocumentationItem"},content:{name:"content",range:"MarkdownString",domain:"DocumentationItem"}}},ValueType:{name:"ValueType",properties:{}},StringType:{name:"StringType",properties:{}},AnyType:{name:"AnyType",properties:{}},NumberType:{name:"NumberType",properties:{}},BooleanType:{name:"BooleanType",properties:{}},Referencable:{name:"Referencable",properties:{}},Reference:{name:"Reference",properties:{structuredValue:{name:"structuredValue"},name:{name:"name"}}},DeclaresDynamicType:{name:"DeclaresDynamicType",properties:{}},UriTemplate:{name:"UriTemplate",properties:{}},RelativeUriString:{name:"RelativeUriString",properties:{}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{}},FixedUri:{name:"FixedUri",properties:{}},MarkdownString:{name:"MarkdownString",properties:{}},SchemaString:{name:"SchemaString",properties:{}},JSonSchemaString:{name:"JSonSchemaString",properties:{}},XMLSchemaString:{name:"XMLSchemaString",properties:{}},ExampleString:{name:"ExampleString",properties:{}},StatusCodeString:{name:"StatusCodeString",properties:{}},JSONExample:{name:"JSONExample",properties:{}},XMLExample:{name:"XMLExample",properties:{}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties",range:"TypeInstanceProperty",domain:"TypeInstance"},isScalar:{name:"isScalar",range:"BooleanType",domain:"TypeInstance"},value:{name:"value",range:"AnyType",domain:"TypeInstance"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name",range:"StringType",domain:"TypeInstanceProperty"},value:{name:"value",range:"TypeInstance",domain:"TypeInstanceProperty"},values:{name:"values",range:"TypeInstance",domain:"TypeInstanceProperty"},isArray:{name:"isArray",range:"BooleanType",domain:"TypeInstanceProperty"}}},RAMLSimpleElement:{name:"RAMLSimpleElement",properties:{}},Parameter:{name:"Parameter",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},pattern:{name:"pattern",range:"StringType",domain:"StringTypeDeclaration"},"enum":{name:"enum",range:"StringType",domain:"StringTypeDeclaration"},minLength:{name:"minLength",range:"NumberType",domain:"StringTypeDeclaration"},maxLength:{name:"maxLength",range:"NumberType",domain:"StringTypeDeclaration"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},DateTypeDeclaration:{name:"DateTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"
},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},ParameterLocation:{name:"ParameterLocation",properties:{}},MimeType:{name:"MimeType",properties:{}},BodyLike:{name:"BodyLike",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"SchemaString",domain:"BodyLike"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"},schemaContent:{name:"schemaContent"}}},XMLBody:{name:"XMLBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"XMLSchemaString",domain:"XMLBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},JSONBody:{name:"JSONBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"JSonSchemaString",domain:"JSONBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},Response:{name:"Response",properties:{code:{name:"code",range:"StatusCodeString",domain:"Response"},headers:{name:"headers",range:"Parameter",domain:"Response"},body:{name:"body",range:"BodyLike",domain:"Response"},description:{name:"description",range:"MarkdownString",domain:"Response"}}},Resource:{name:"Resource",properties:{relativeUri:{name:"relativeUri",range:"RelativeUriString",domain:"Resource"},type:{name:"type",range:"ResourceTypeRef",domain:"Resource"},is:{name:"is",range:"TraitRef",domain:"Resource"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Resource"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Resource"},methods:{name:"methods",range:"Method",domain:"Resource"},resources:{name:"resources",range:"Resource",domain:"Resource"},displayName:{name:"displayName",range:"StringType",domain:"Resource"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Resource"},description:{name:"description",range:"MarkdownString",domain:"Resource"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{resourceType:{name:"resourceType"}}},ResourceType:{name:"ResourceType",properties:{name:{name:"name",range:"StringType",domain:"ResourceType"},usage:{name:"usage",range:"StringType",domain:"ResourceType"},methods:{name:"methods",range:"Method",domain:"ResourceType"},is:{name:"is",range:"TraitRef",domain:"ResourceType"},type:{name:"type",range:"ResourceTypeRef",domain:"ResourceType"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"ResourceType"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"ResourceType"},displayName:{name:"displayName",range:"StringType",domain:"ResourceType"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"ResourceType"},description:{name:"description",range:"MarkdownString",domain:"ResourceType"},parametrizedProperties:{name:"parametrizedProperties"}}},MethodBase:{name:"MethodBase",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"}}},Method:{name:"Method",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},method:{name:"method",range:"StringType",domain:"Method"},is:{name:"is",range:"TraitRef",domain:"Method"}}},Trait:{name:"Trait",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},name:{name:"name",range:"StringType",domain:"Trait"},usage:{name:"usage",range:"StringType",domain:"Trait"},displayName:{name:"displayName",range:"StringType",domain:"Trait"},parametrizedProperties:{name:"parametrizedProperties"}}},TraitRef:{name:"TraitRef",properties:{trait:{name:"trait"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{responses:{name:"responses",range:"Response",domain:"SecuritySchemePart"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"SecuritySchemePart"},headers:{name:"headers",range:"Parameter",domain:"SecuritySchemePart"},description:{name:"description",range:"MarkdownString",domain:"SecuritySchemePart"},displayName:{name:"displayName",range:"StringType",domain:"SecuritySchemePart"},is:{name:"is",range:"TraitRef",domain:"SecuritySchemePart"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{securitySchemeName:{name:"securitySchemeName"},securityScheme:{name:"securityScheme"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{requestTokenUri:{name:"requestTokenUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},tokenCredentialsUri:{name:"tokenCredentialsUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{accessTokenUri:{name:"accessTokenUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationGrants:{name:"authorizationGrants",range:"StringType",domain:"OAuth2SecuritySchemeSettings"},scopes:{name:"scopes",range:"StringType",domain:"OAuth2SecuritySchemeSettings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth2SecuritySchemeSettings",domain:"OAuth2SecurityScheme"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth1SecuritySchemeSettings",domain:"OAuth1SecurityScheme"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}}},Universe10:{Library:{name:"Library",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},usage:{name:"usage"},name:{name:"name"}}},LibraryBase:{name:"LibraryBase",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"}}},Api:{name:"Api",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},RAMLVersion:{name:"RAMLVersion",range:"StringType",domain:"Api"}}},Overlay:{name:"Overlay",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},"extends":{name:"extends"}}},Extension:{name:"Extension",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},"extends":{name:"extends"}}},UsesDeclaration:{name:"UsesDeclaration",properties:{annotations:{name:"annotations"},key:{name:"key"},value:{name:"value"}}},FragmentDeclaration:{name:"FragmentDeclaration",properties:{annotations:{name:"annotations"},uses:{name:"uses"}}},DocumentationItem:{name:"DocumentationItem",properties:{annotations:{name:"annotations"},title:{name:"title"},content:{name:"content"}}},ValueType:{name:"ValueType",properties:{annotations:{name:"annotations"}}},StringType:{name:"StringType",properties:{annotations:{name:"annotations"}}},AnyType:{name:"AnyType",properties:{annotations:{name:"annotations"}}},NumberType:{name:"NumberType",properties:{annotations:{name:"annotations"}}},IntegerType:{name:"IntegerType",properties:{annotations:{name:"annotations"}}},NullType:{name:"NullType",properties:{annotations:{name:"annotations"}}},TimeOnlyType:{name:"TimeOnlyType",properties:{annotations:{name:"annotations"}}},DateOnlyType:{name:"DateOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeOnlyType:{name:"DateTimeOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeType:{name:"DateTimeType",properties:{annotations:{name:"annotations"}}},FileType:{name:"FileType",properties:{annotations:{name:"annotations"}}},BooleanType:{name:"BooleanType",properties:{annotations:{name:"annotations"}}},Reference:{name:"Reference",properties:{annotations:{name:"annotations"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"Reference"},name:{name:"name",range:"StringType",domain:"Reference"}}},UriTemplate:{name:"UriTemplate",properties:{annotations:{name:"annotations"}}},StatusCodeString:{name:"StatusCodeString",properties:{annotations:{name:"annotations"}}},RelativeUriString:{name:"RelativeUriString",properties:{annotations:{name:"annotations"}}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{annotations:{name:"annotations"}}},FixedUriString:{name:"FixedUriString",properties:{annotations:{name:"annotations"}}},ContentType:{name:"ContentType",properties:{annotations:{name:"annotations"}}},MarkdownString:{name:"MarkdownString",properties:{annotations:{name:"annotations"}}},SchemaString:{name:"SchemaString",properties:{annotations:{name:"annotations"}}},ExampleSpec:{name:"ExampleSpec",properties:{annotations:{name:"annotations"},value:{name:"value"},strict:{name:"strict"},name:{name:"name"},displayName:{name:"displayName"},description:{name:"description"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"ExampleSpec"}}},TypeDeclaration:{name:"TypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fixedFacets:{name:"fixedFacets",range:"TypeInstance",domain:"TypeDeclaration"},structuredType:{name:"structuredType",range:"TypeInstance",domain:"TypeDeclaration"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"TypeDeclaration"}}},XMLFacetInfo:{name:"XMLFacetInfo",properties:{annotations:{name:"annotations"},attribute:{name:"attribute"},wrapped:{name:"wrapped"},name:{name:"name"},namespace:{name:"namespace"},prefix:{name:"prefix"}}},ArrayTypeDeclaration:{name:"ArrayTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},uniqueItems:{name:"uniqueItems"},items:{name:"items"},minItems:{name:"minItems"},maxItems:{name:"maxItems"},structuredItems:{name:"structuredItems",range:"TypeInstance",domain:"ArrayTypeDeclaration"}}},UnionTypeDeclaration:{name:"UnionTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},ObjectTypeDeclaration:{name:"ObjectTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},properties:{name:"properties"},minProperties:{name:"minProperties"},maxProperties:{name:"maxProperties"},additionalProperties:{name:"additionalProperties"},discriminator:{name:"discriminator"},discriminatorValue:{name:"discriminatorValue"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},pattern:{name:"pattern"},minLength:{name:"minLength"},maxLength:{name:"maxLength"},"enum":{name:"enum"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},"enum":{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},"enum":{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},DateOnlyTypeDeclaration:{name:"DateOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},TimeOnlyTypeDeclaration:{name:"TimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeOnlyTypeDeclaration:{name:"DateTimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeTypeDeclaration:{name:"DateTimeTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},format:{name:"format"}}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties"},isScalar:{name:"isScalar"},value:{name:"value"},isArray:{name:"isArray"},items:{name:"items"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name"},value:{name:"value"},values:{name:"values"},isArray:{name:"isArray"}}},ModelLocation:{name:"ModelLocation",properties:{}},LocationKind:{name:"LocationKind",properties:{}},MimeType:{name:"MimeType",properties:{annotations:{name:"annotations"}}},Response:{name:"Response",properties:{annotations:{name:"annotations"},code:{name:"code"},headers:{name:"headers"},body:{name:"body"},description:{name:"description"}}},Annotable:{name:"Annotable",properties:{annotations:{name:"annotations"}}},AnnotationRef:{name:"AnnotationRef",properties:{annotations:{name:"annotations"},annotation:{name:"annotation",range:"TypeDeclaration",domain:"AnnotationRef"}}},AnnotationTarget:{name:"AnnotationTarget",properties:{annotations:{name:"annotations"}}},TraitRef:{name:"TraitRef",properties:{annotations:{name:"annotations"},trait:{name:"trait",range:"Trait",domain:"TraitRef"}}},Trait:{name:"Trait",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Trait"}}},MethodBase:{name:"MethodBase",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"}}},Method:{name:"Method",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},method:{name:"method"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Method"}}},Operation:{name:"Operation",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{annotations:{name:"annotations"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{annotations:{name:"annotations"},requestTokenUri:{name:"requestTokenUri"},authorizationUri:{name:"authorizationUri"},tokenCredentialsUri:{name:"tokenCredentialsUri"},signatures:{name:"signatures"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{annotations:{name:"annotations"},accessTokenUri:{name:"accessTokenUri"},authorizationUri:{name:"authorizationUri"},authorizationGrants:{name:"authorizationGrants"},scopes:{name:"scopes"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{annotations:{name:"annotations"},securitySchemeName:{name:"securitySchemeName",range:"StringType",domain:"SecuritySchemeRef"},securityScheme:{name:"securityScheme",range:"AbstractSecurityScheme",domain:"SecuritySchemeRef"}}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},PassThroughSecurityScheme:{name:"PassThroughSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{annotations:{name:"annotations"},resourceType:{name:"resourceType",range:"ResourceType",domain:"ResourceTypeRef"}}},ResourceType:{name:"ResourceType",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"ResourceType"}}},ResourceBase:{name:"ResourceBase",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"}}},Resource:{name:"Resource",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},relativeUri:{name:"relativeUri"},displayName:{name:"displayName"},resources:{name:"resources"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fileTypes:{name:"fileTypes"},minLength:{name:"minLength"},maxLength:{name:"maxLength"}}}}};e.exports=r},function(e,t,n){t.XMLHttpRequest=XMLHttpRequest},function(e,t,n){function r(){if(!s){s=!0;for(var e,t=o.length;t;){e=o,o=[];for(var n=-1;++n<t;)e[n]();t=o.length}s=!1}}function i(){}var a=e.exports={},o=[],s=!1;a.nextTick=function(e){o.push(e),s||setTimeout(r,0)},a.title="browser",a.browser=!0,a.env={},a.argv=[],a.version="",a.versions={},a.on=i,a.addListener=i,a.once=i,a.off=i,a.removeListener=i,a.removeAllListeners=i,a.emit=i,a.binding=function(e){throw new Error("process.binding is not supported")},a.cwd=function(){return"/"},a.chdir=function(e){throw new Error("process.chdir is not supported")},a.umask=function(){return 0}},function(e,t,n){var r,i;(function(){function n(e){function t(t,n,r,i,a,o){for(;a>=0&&o>a;a+=e){var s=i?i[a]:a;r=n(r,t[s],s,t)}return r}return function(n,r,i,a){r=b(r,a,4);var o=!C(n)&&T.keys(n),s=(o||n).length,u=e>0?0:s-1;return arguments.length<3&&(i=n[o?o[u]:u],u+=e),t(n,r,i,o,u,s)}}function a(e){return function(t,n,r){n=N(n,r);for(var i=R(t),a=e>0?0:i-1;a>=0&&i>a;a+=e)if(n(t[a],a,t))return a;return-1}}function o(e,t,n){return function(r,i,a){var o=0,s=R(r);if("number"==typeof a)e>0?o=a>=0?a:Math.max(a+s,o):s=a>=0?Math.min(a+1,s):a+s+1;else if(n&&a&&s)return a=n(r,i),r[a]===i?a:-1;if(i!==i)return a=t(m.call(r,o,s),T.isNaN),a>=0?a+o:-1;for(a=e>0?o:s-1;a>=0&&s>a;a+=e)if(r[a]===i)return a;return-1}}function s(e,t){var n=x.length,r=e.constructor,i=T.isFunction(r)&&r.prototype||c,a="constructor";for(T.has(e,a)&&!T.contains(t,a)&&t.push(a);n--;)a=x[n],a in e&&e[a]!==i[a]&&!T.contains(t,a)&&t.push(a)}var u=this,l=u._,p=Array.prototype,c=Object.prototype,f=Function.prototype,d=p.push,m=p.slice,h=c.toString,y=c.hasOwnProperty,v=Array.isArray,g=Object.keys,A=f.bind,S=Object.create,E=function(){},T=function(e){return e instanceof T?e:this instanceof T?void(this._wrapped=e):new T(e)};"undefined"!=typeof e&&e.exports&&(t=e.exports=T),t._=T,
T.VERSION="1.8.3";var b=function(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 2:return function(n,r){return e.call(t,n,r)};case 3:return function(n,r,i){return e.call(t,n,r,i)};case 4:return function(n,r,i,a){return e.call(t,n,r,i,a)}}return function(){return e.apply(t,arguments)}},N=function(e,t,n){return null==e?T.identity:T.isFunction(e)?b(e,t,n):T.isObject(e)?T.matcher(e):T.property(e)};T.iteratee=function(e,t){return N(e,t,1/0)};var _=function(e,t){return function(n){var r=arguments.length;if(2>r||null==n)return n;for(var i=1;r>i;i++)for(var a=arguments[i],o=e(a),s=o.length,u=0;s>u;u++){var l=o[u];t&&void 0!==n[l]||(n[l]=a[l])}return n}},w=function(e){if(!T.isObject(e))return{};if(S)return S(e);E.prototype=e;var t=new E;return E.prototype=null,t},M=function(e){return function(t){return null==t?void 0:t[e]}},I=Math.pow(2,53)-1,R=M("length"),C=function(e){var t=R(e);return"number"==typeof t&&t>=0&&I>=t};T.each=T.forEach=function(e,t,n){t=b(t,n);var r,i;if(C(e))for(r=0,i=e.length;i>r;r++)t(e[r],r,e);else{var a=T.keys(e);for(r=0,i=a.length;i>r;r++)t(e[a[r]],a[r],e)}return e},T.map=T.collect=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=Array(i),o=0;i>o;o++){var s=r?r[o]:o;a[o]=t(e[s],s,e)}return a},T.reduce=T.foldl=T.inject=n(1),T.reduceRight=T.foldr=n(-1),T.find=T.detect=function(e,t,n){var r;return r=C(e)?T.findIndex(e,t,n):T.findKey(e,t,n),void 0!==r&&-1!==r?e[r]:void 0},T.filter=T.select=function(e,t,n){var r=[];return t=N(t,n),T.each(e,function(e,n,i){t(e,n,i)&&r.push(e)}),r},T.reject=function(e,t,n){return T.filter(e,T.negate(N(t)),n)},T.every=T.all=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=0;i>a;a++){var o=r?r[a]:a;if(!t(e[o],o,e))return!1}return!0},T.some=T.any=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=0;i>a;a++){var o=r?r[a]:a;if(t(e[o],o,e))return!0}return!1},T.contains=T.includes=T.include=function(e,t,n,r){return C(e)||(e=T.values(e)),("number"!=typeof n||r)&&(n=0),T.indexOf(e,t,n)>=0},T.invoke=function(e,t){var n=m.call(arguments,2),r=T.isFunction(t);return T.map(e,function(e){var i=r?t:e[t];return null==i?i:i.apply(e,n)})},T.pluck=function(e,t){return T.map(e,T.property(t))},T.where=function(e,t){return T.filter(e,T.matcher(t))},T.findWhere=function(e,t){return T.find(e,T.matcher(t))},T.max=function(e,t,n){var r,i,a=-(1/0),o=-(1/0);if(null==t&&null!=e){e=C(e)?e:T.values(e);for(var s=0,u=e.length;u>s;s++)r=e[s],r>a&&(a=r)}else t=N(t,n),T.each(e,function(e,n,r){i=t(e,n,r),(i>o||i===-(1/0)&&a===-(1/0))&&(a=e,o=i)});return a},T.min=function(e,t,n){var r,i,a=1/0,o=1/0;if(null==t&&null!=e){e=C(e)?e:T.values(e);for(var s=0,u=e.length;u>s;s++)r=e[s],a>r&&(a=r)}else t=N(t,n),T.each(e,function(e,n,r){i=t(e,n,r),(o>i||i===1/0&&a===1/0)&&(a=e,o=i)});return a},T.shuffle=function(e){for(var t,n=C(e)?e:T.values(e),r=n.length,i=Array(r),a=0;r>a;a++)t=T.random(0,a),t!==a&&(i[a]=i[t]),i[t]=n[a];return i},T.sample=function(e,t,n){return null==t||n?(C(e)||(e=T.values(e)),e[T.random(e.length-1)]):T.shuffle(e).slice(0,Math.max(0,t))},T.sortBy=function(e,t,n){return t=N(t,n),T.pluck(T.map(e,function(e,n,r){return{value:e,index:n,criteria:t(e,n,r)}}).sort(function(e,t){var n=e.criteria,r=t.criteria;if(n!==r){if(n>r||void 0===n)return 1;if(r>n||void 0===r)return-1}return e.index-t.index}),"value")};var L=function(e){return function(t,n,r){var i={};return n=N(n,r),T.each(t,function(r,a){var o=n(r,a,t);e(i,r,o)}),i}};T.groupBy=L(function(e,t,n){T.has(e,n)?e[n].push(t):e[n]=[t]}),T.indexBy=L(function(e,t,n){e[n]=t}),T.countBy=L(function(e,t,n){T.has(e,n)?e[n]++:e[n]=1}),T.toArray=function(e){return e?T.isArray(e)?m.call(e):C(e)?T.map(e,T.identity):T.values(e):[]},T.size=function(e){return null==e?0:C(e)?e.length:T.keys(e).length},T.partition=function(e,t,n){t=N(t,n);var r=[],i=[];return T.each(e,function(e,n,a){(t(e,n,a)?r:i).push(e)}),[r,i]},T.first=T.head=T.take=function(e,t,n){return null==e?void 0:null==t||n?e[0]:T.initial(e,e.length-t)},T.initial=function(e,t,n){return m.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))},T.last=function(e,t,n){return null==e?void 0:null==t||n?e[e.length-1]:T.rest(e,Math.max(0,e.length-t))},T.rest=T.tail=T.drop=function(e,t,n){return m.call(e,null==t||n?1:t)},T.compact=function(e){return T.filter(e,T.identity)};var P=function(e,t,n,r){for(var i=[],a=0,o=r||0,s=R(e);s>o;o++){var u=e[o];if(C(u)&&(T.isArray(u)||T.isArguments(u))){t||(u=P(u,t,n));var l=0,p=u.length;for(i.length+=p;p>l;)i[a++]=u[l++]}else n||(i[a++]=u)}return i};T.flatten=function(e,t){return P(e,t,!1)},T.without=function(e){return T.difference(e,m.call(arguments,1))},T.uniq=T.unique=function(e,t,n,r){T.isBoolean(t)||(r=n,n=t,t=!1),null!=n&&(n=N(n,r));for(var i=[],a=[],o=0,s=R(e);s>o;o++){var u=e[o],l=n?n(u,o,e):u;t?(o&&a===l||i.push(u),a=l):n?T.contains(a,l)||(a.push(l),i.push(u)):T.contains(i,u)||i.push(u)}return i},T.union=function(){return T.uniq(P(arguments,!0,!0))},T.intersection=function(e){for(var t=[],n=arguments.length,r=0,i=R(e);i>r;r++){var a=e[r];if(!T.contains(t,a)){for(var o=1;n>o&&T.contains(arguments[o],a);o++);o===n&&t.push(a)}}return t},T.difference=function(e){var t=P(arguments,!0,!0,1);return T.filter(e,function(e){return!T.contains(t,e)})},T.zip=function(){return T.unzip(arguments)},T.unzip=function(e){for(var t=e&&T.max(e,R).length||0,n=Array(t),r=0;t>r;r++)n[r]=T.pluck(e,r);return n},T.object=function(e,t){for(var n={},r=0,i=R(e);i>r;r++)t?n[e[r]]=t[r]:n[e[r][0]]=e[r][1];return n},T.findIndex=a(1),T.findLastIndex=a(-1),T.sortedIndex=function(e,t,n,r){n=N(n,r,1);for(var i=n(t),a=0,o=R(e);o>a;){var s=Math.floor((a+o)/2);n(e[s])<i?a=s+1:o=s}return a},T.indexOf=o(1,T.findIndex,T.sortedIndex),T.lastIndexOf=o(-1,T.findLastIndex),T.range=function(e,t,n){null==t&&(t=e||0,e=0),n=n||1;for(var r=Math.max(Math.ceil((t-e)/n),0),i=Array(r),a=0;r>a;a++,e+=n)i[a]=e;return i};var O=function(e,t,n,r,i){if(!(r instanceof t))return e.apply(n,i);var a=w(e.prototype),o=e.apply(a,i);return T.isObject(o)?o:a};T.bind=function(e,t){if(A&&e.bind===A)return A.apply(e,m.call(arguments,1));if(!T.isFunction(e))throw new TypeError("Bind must be called on a function");var n=m.call(arguments,2),r=function(){return O(e,r,t,this,n.concat(m.call(arguments)))};return r},T.partial=function(e){var t=m.call(arguments,1),n=function(){for(var r=0,i=t.length,a=Array(i),o=0;i>o;o++)a[o]=t[o]===T?arguments[r++]:t[o];for(;r<arguments.length;)a.push(arguments[r++]);return O(e,n,this,this,a)};return n},T.bindAll=function(e){var t,n,r=arguments.length;if(1>=r)throw new Error("bindAll must be passed function names");for(t=1;r>t;t++)n=arguments[t],e[n]=T.bind(e[n],e);return e},T.memoize=function(e,t){var n=function(r){var i=n.cache,a=""+(t?t.apply(this,arguments):r);return T.has(i,a)||(i[a]=e.apply(this,arguments)),i[a]};return n.cache={},n},T.delay=function(e,t){var n=m.call(arguments,2);return setTimeout(function(){return e.apply(null,n)},t)},T.defer=T.partial(T.delay,T,1),T.throttle=function(e,t,n){var r,i,a,o=null,s=0;n||(n={});var u=function(){s=n.leading===!1?0:T.now(),o=null,a=e.apply(r,i),o||(r=i=null)};return function(){var l=T.now();s||n.leading!==!1||(s=l);var p=t-(l-s);return r=this,i=arguments,0>=p||p>t?(o&&(clearTimeout(o),o=null),s=l,a=e.apply(r,i),o||(r=i=null)):o||n.trailing===!1||(o=setTimeout(u,p)),a}},T.debounce=function(e,t,n){var r,i,a,o,s,u=function(){var l=T.now()-o;t>l&&l>=0?r=setTimeout(u,t-l):(r=null,n||(s=e.apply(a,i),r||(a=i=null)))};return function(){a=this,i=arguments,o=T.now();var l=n&&!r;return r||(r=setTimeout(u,t)),l&&(s=e.apply(a,i),a=i=null),s}},T.wrap=function(e,t){return T.partial(t,e)},T.negate=function(e){return function(){return!e.apply(this,arguments)}},T.compose=function(){var e=arguments,t=e.length-1;return function(){for(var n=t,r=e[t].apply(this,arguments);n--;)r=e[n].call(this,r);return r}},T.after=function(e,t){return function(){return--e<1?t.apply(this,arguments):void 0}},T.before=function(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),1>=e&&(t=null),n}},T.once=T.partial(T.before,2);var D=!{toString:null}.propertyIsEnumerable("toString"),x=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];T.keys=function(e){if(!T.isObject(e))return[];if(g)return g(e);var t=[];for(var n in e)T.has(e,n)&&t.push(n);return D&&s(e,t),t},T.allKeys=function(e){if(!T.isObject(e))return[];var t=[];for(var n in e)t.push(n);return D&&s(e,t),t},T.values=function(e){for(var t=T.keys(e),n=t.length,r=Array(n),i=0;n>i;i++)r[i]=e[t[i]];return r},T.mapObject=function(e,t,n){t=N(t,n);for(var r,i=T.keys(e),a=i.length,o={},s=0;a>s;s++)r=i[s],o[r]=t(e[r],r,e);return o},T.pairs=function(e){for(var t=T.keys(e),n=t.length,r=Array(n),i=0;n>i;i++)r[i]=[t[i],e[t[i]]];return r},T.invert=function(e){for(var t={},n=T.keys(e),r=0,i=n.length;i>r;r++)t[e[n[r]]]=n[r];return t},T.functions=T.methods=function(e){var t=[];for(var n in e)T.isFunction(e[n])&&t.push(n);return t.sort()},T.extend=_(T.allKeys),T.extendOwn=T.assign=_(T.keys),T.findKey=function(e,t,n){t=N(t,n);for(var r,i=T.keys(e),a=0,o=i.length;o>a;a++)if(r=i[a],t(e[r],r,e))return r},T.pick=function(e,t,n){var r,i,a={},o=e;if(null==o)return a;T.isFunction(t)?(i=T.allKeys(o),r=b(t,n)):(i=P(arguments,!1,!1,1),r=function(e,t,n){return t in n},o=Object(o));for(var s=0,u=i.length;u>s;s++){var l=i[s],p=o[l];r(p,l,o)&&(a[l]=p)}return a},T.omit=function(e,t,n){if(T.isFunction(t))t=T.negate(t);else{var r=T.map(P(arguments,!1,!1,1),String);t=function(e,t){return!T.contains(r,t)}}return T.pick(e,t,n)},T.defaults=_(T.allKeys,!0),T.create=function(e,t){var n=w(e);return t&&T.extendOwn(n,t),n},T.clone=function(e){return T.isObject(e)?T.isArray(e)?e.slice():T.extend({},e):e},T.tap=function(e,t){return t(e),e},T.isMatch=function(e,t){var n=T.keys(t),r=n.length;if(null==e)return!r;for(var i=Object(e),a=0;r>a;a++){var o=n[a];if(t[o]!==i[o]||!(o in i))return!1}return!0};var U=function(e,t,n,r){if(e===t)return 0!==e||1/e===1/t;if(null==e||null==t)return e===t;e instanceof T&&(e=e._wrapped),t instanceof T&&(t=t._wrapped);var i=h.call(e);if(i!==h.call(t))return!1;switch(i){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!==+e?+t!==+t:0===+e?1/+e===1/t:+e===+t;case"[object Date]":case"[object Boolean]":return+e===+t}var a="[object Array]"===i;if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var o=e.constructor,s=t.constructor;if(o!==s&&!(T.isFunction(o)&&o instanceof o&&T.isFunction(s)&&s instanceof s)&&"constructor"in e&&"constructor"in t)return!1}n=n||[],r=r||[];for(var u=n.length;u--;)if(n[u]===e)return r[u]===t;if(n.push(e),r.push(t),a){if(u=e.length,u!==t.length)return!1;for(;u--;)if(!U(e[u],t[u],n,r))return!1}else{var l,p=T.keys(e);if(u=p.length,T.keys(t).length!==u)return!1;for(;u--;)if(l=p[u],!T.has(t,l)||!U(e[l],t[l],n,r))return!1}return n.pop(),r.pop(),!0};T.isEqual=function(e,t){return U(e,t)},T.isEmpty=function(e){return null==e?!0:C(e)&&(T.isArray(e)||T.isString(e)||T.isArguments(e))?0===e.length:0===T.keys(e).length},T.isElement=function(e){return!(!e||1!==e.nodeType)},T.isArray=v||function(e){return"[object Array]"===h.call(e)},T.isObject=function(e){var t=typeof e;return"function"===t||"object"===t&&!!e},T.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(e){T["is"+e]=function(t){return h.call(t)==="[object "+e+"]"}}),T.isArguments(arguments)||(T.isArguments=function(e){return T.has(e,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(T.isFunction=function(e){return"function"==typeof e||!1}),T.isFinite=function(e){return isFinite(e)&&!isNaN(parseFloat(e))},T.isNaN=function(e){return T.isNumber(e)&&e!==+e},T.isBoolean=function(e){return e===!0||e===!1||"[object Boolean]"===h.call(e)},T.isNull=function(e){return null===e},T.isUndefined=function(e){return void 0===e},T.has=function(e,t){return null!=e&&y.call(e,t)},T.noConflict=function(){return u._=l,this},T.identity=function(e){return e},T.constant=function(e){return function(){return e}},T.noop=function(){},T.property=M,T.propertyOf=function(e){return null==e?function(){}:function(t){return e[t]}},T.matcher=T.matches=function(e){return e=T.extendOwn({},e),function(t){return T.isMatch(t,e)}},T.times=function(e,t,n){var r=Array(Math.max(0,e));t=b(t,n,1);for(var i=0;e>i;i++)r[i]=t(i);return r},T.random=function(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))},T.now=Date.now||function(){return(new Date).getTime()};var k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},F=T.invert(k),B=function(e){var t=function(t){return e[t]},n="(?:"+T.keys(e).join("|")+")",r=RegExp(n),i=RegExp(n,"g");return function(e){return e=null==e?"":""+e,r.test(e)?e.replace(i,t):e}};T.escape=B(k),T.unescape=B(F),T.result=function(e,t,n){var r=null==e?void 0:e[t];return void 0===r&&(r=n),T.isFunction(r)?r.call(e):r};var K=0;T.uniqueId=function(e){var t=++K+"";return e?e+t:t},T.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var V=/(.)^/,j={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},W=/\\|'|\r|\n|\u2028|\u2029/g,q=function(e){return"\\"+j[e]};T.template=function(e,t,n){!t&&n&&(t=n),t=T.defaults({},t,T.templateSettings);var r=RegExp([(t.escape||V).source,(t.interpolate||V).source,(t.evaluate||V).source].join("|")+"|$","g"),i=0,a="__p+='";e.replace(r,function(t,n,r,o,s){return a+=e.slice(i,s).replace(W,q),i=s+t.length,n?a+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":o&&(a+="';\n"+o+"\n__p+='"),t}),a+="';\n",t.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";try{var o=new Function(t.variable||"obj","_",a)}catch(s){throw s.source=a,s}var u=function(e){return o.call(this,e,T)},l=t.variable||"obj";return u.source="function("+l+"){\n"+a+"}",u},T.chain=function(e){var t=T(e);return t._chain=!0,t};var Y=function(e,t){return e._chain?T(t).chain():t};T.mixin=function(e){T.each(T.functions(e),function(t){var n=T[t]=e[t];T.prototype[t]=function(){var e=[this._wrapped];return d.apply(e,arguments),Y(this,n.apply(T,e))}})},T.mixin(T),T.each(["pop","push","reverse","shift","sort","splice","unshift"],function(e){var t=p[e];T.prototype[e]=function(){var n=this._wrapped;return t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0],Y(this,n)}}),T.each(["concat","join","slice"],function(e){var t=p[e];T.prototype[e]=function(){return Y(this,t.apply(this._wrapped,arguments))}}),T.prototype.value=function(){return this._wrapped},T.prototype.valueOf=T.prototype.toJSON=T.prototype.value,T.prototype.toString=function(){return""+this._wrapped},r=[],i=function(){return T}.apply(t,r),!(void 0!==i&&(e.exports=i))}).call(this)},function(e,t,n){"use strict";function r(e,t,n,r){if("number"!=typeof e)throw new TypeError("statusCode must be a number but was "+typeof e);if(null===t)throw new TypeError("headers cannot be null");if("object"!=typeof t)throw new TypeError("headers must be an object but was "+typeof t);this.statusCode=e,this.headers={};for(var i in t)this.headers[i.toLowerCase()]=t[i];this.body=n,this.url=r}e.exports=r,r.prototype.getBody=function(e){if(this.statusCode>=300){var t=new Error("Server responded with status code "+this.statusCode+":\n"+this.body.toString());throw t.statusCode=this.statusCode,t.headers=this.headers,t.body=this.body,t.url=this.url,t}return e?this.body.toString(e):this.body}},function(e,t,n){(function(t){function r(e,t){if(!(this instanceof r))return new r(e,t);"function"==typeof e&&(t=e,e={}),e||(e={});var n=e.encoding,i=!1;n?(n=String(n).toLowerCase(),("u8"===n||"uint8"===n)&&(n="uint8array")):i=!0,p.call(this,{objectMode:!0}),this.encoding=n,this.shouldInferEncoding=i,t&&this.on("finish",function(){t(this.getBody())}),this.body=[]}function i(e){return/Array\]$/.test(Object.prototype.toString.call(e))}function a(e){return"string"==typeof e||i(e)||e&&"function"==typeof e.subarray}function o(e){for(var n=[],r=0;r<e.length;r++){var i=e[r];"string"==typeof i?n.push(i):t.isBuffer(i)?n.push(i):a(i)?n.push(new t(i)):n.push(new t(String(i)))}return t.isBuffer(e[0])?(n=t.concat(n),n=n.toString("utf8")):n=n.join(""),n}function s(e){for(var n=[],r=0;r<e.length;r++){var i=e[r];t.isBuffer(i)?n.push(i):a(i)?n.push(new t(i)):n.push(new t(String(i)))}return t.concat(n)}function u(e){for(var t=[],n=0;n<e.length;n++)t.push.apply(t,e[n]);return t}function l(e){for(var n=0,r=0;r<e.length;r++)"string"==typeof e[r]&&(e[r]=new t(e[r])),n+=e[r].length;for(var i=new f(n),r=0,a=0;r<e.length;r++)for(var o=e[r],s=0;s<o.length;s++)i[a++]=o[s];return i}var p=n(117).Writable,c=n(119);if("undefined"==typeof Uint8Array)var f=n(111).Uint8Array;else var f=Uint8Array;e.exports=r,c(r,p),r.prototype._write=function(e,t,n){this.body.push(e),n()},r.prototype.inferEncoding=function(e){var n=void 0===e?this.body[0]:e;return t.isBuffer(n)?"buffer":"undefined"!=typeof Uint8Array&&n instanceof Uint8Array?"uint8array":Array.isArray(n)?"array":"string"==typeof n?"string":"[object Object]"===Object.prototype.toString.call(n)?"object":"buffer"},r.prototype.getBody=function(){return this.encoding||0!==this.body.length?(this.shouldInferEncoding&&(this.encoding=this.inferEncoding()),"array"===this.encoding?u(this.body):"string"===this.encoding?o(this.body):"buffer"===this.encoding?s(this.body):"uint8array"===this.encoding?l(this.body):this.body):[]};Array.isArray||function(e){return"[object Array]"==Object.prototype.toString.call(e)}}).call(t,n(97).Buffer)},function(e,t,n){(function(t){function n(e){return e.replace(/=/g,"").replace(/\+/g,"-").replace(/\//g,"_")}function r(e){t.isBuffer(e)&&(e=e.toString());var n=i(e).replace(/\-/g,"+").replace(/_/g,"/");return n}function i(e){var n=4,r=e.length,i=e.length%n;if(!i)return e;var a=r,o=n-i,s=r+o,u=t(s);for(u.write(e);o--;)u.write("=",a++);return u.toString()}function a(e,n){return t(r(e),"base64").toString(n)}function o(e,r){return n(t(e,r).toString("base64"))}function s(e){return t(r(e),"base64")}o.toBase64=r,o.fromBase64=n,o.decode=a,o.encode=o,o.toBuffer=s,e.exports=o}).call(t,n(97).Buffer)},function(e,t,n){function r(e){if(!e||"object"!=typeof e)throw new TypeError("argument obj is required");var t=e.parameters,n=e.subtype,r=e.suffix,i=e.type;if(!i||!m.test(i))throw new TypeError("invalid type");if(!n||!d.test(n))throw new TypeError("invalid subtype");var a=i+"/"+n;if(r){if(!m.test(r))throw new TypeError("invalid suffix");a+="+"+r}if(t&&"object"==typeof t)for(var s,u=Object.keys(t).sort(),l=0;l<u.length;l++){if(s=u[l],!p.test(s))throw new TypeError("invalid parameter name");a+="; "+s+"="+o(t[s])}return a}function i(e){if(!e)throw new TypeError("argument string is required");if("object"==typeof e&&(e=a(e)),"string"!=typeof e)throw new TypeError("argument string is required to be a string");var t,n,r,i=e.indexOf(";"),o=-1!==i?e.substr(0,i):e,l=s(o),p={};for(u.lastIndex=i;n=u.exec(e);){if(n.index!==i)throw new TypeError("invalid parameter format");i+=n[0].length,t=n[1].toLowerCase(),r=n[2],'"'===r[0]&&(r=r.substr(1,r.length-2).replace(c,"$1")),p[t]=r}if(-1!==i&&i!==e.length)throw new TypeError("invalid parameter format");return l.parameters=p,l}function a(e){return"function"==typeof e.getHeader?e.getHeader("content-type"):"object"==typeof e.headers?e.headers&&e.headers["content-type"]:void 0}function o(e){var t=String(e);if(p.test(t))return t;if(t.length>0&&!l.test(t))throw new TypeError("invalid parameter value");return'"'+t.replace(f,"\\$1")+'"'}function s(e){var t=h.exec(e.toLowerCase());if(!t)throw new TypeError("invalid media type");var n,r=t[1],i=t[2],a=i.lastIndexOf("+");-1!==a&&(n=i.substr(a+1),i=i.substr(0,a));var o={type:r,subtype:i,suffix:n};return o}/*!
	 * media-typer
	 * Copyright(c) 2014 Douglas Christopher Wilson
	 * MIT Licensed
	 */
var u=/; *([!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) *= *("(?:[ !\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u0020-\u007e])*"|[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) */g,l=/^[\u0020-\u007e\u0080-\u00ff]+$/,p=/^[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+$/,c=/\\([\u0000-\u007f])/g,f=/([\\"])/g,d=/^[A-Za-z0-9][A-Za-z0-9!#$&^_.-]{0,126}$/,m=/^[A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126}$/,h=/^ *([A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126})\/([A-Za-z0-9][A-Za-z0-9!#$&^_.+-]{0,126}) *$/;t.format=r,t.parse=i},function(e,t,n){var r="undefined"!=typeof JSON?JSON:n(112);e.exports=function(e,t){t||(t={}),"function"==typeof t&&(t={cmp:t});var n=t.space||"";"number"==typeof n&&(n=Array(n+1).join(" "));var o="boolean"==typeof t.cycles?t.cycles:!1,s=t.replacer||function(e,t){return t},u=t.cmp&&function(e){return function(t){return function(n,r){var i={key:n,value:t[n]},a={key:r,value:t[r]};return e(i,a)}}}(t.cmp),l=[];return function p(e,t,c,f){var d=n?"\n"+new Array(f+1).join(n):"",m=n?": ":":";if(c&&c.toJSON&&"function"==typeof c.toJSON&&(c=c.toJSON()),c=s.call(e,t,c),void 0!==c){if("object"!=typeof c||null===c)return r.stringify(c);if(i(c)){for(var h=[],y=0;y<c.length;y++){var v=p(c,y,c[y],f+1)||r.stringify(null);h.push(d+n+v)}return"["+h.join(",")+d+"]"}if(-1!==l.indexOf(c)){if(o)return r.stringify("__cycle__");throw new TypeError("Converting circular structure to JSON")}l.push(c);for(var g=a(c).sort(u&&u(c)),h=[],y=0;y<g.length;y++){var t=g[y],A=p(c,t,c[t],f+1);if(A){var S=r.stringify(t)+m+A;h.push(d+n+S)}}return l.splice(l.indexOf(c),1),"{"+h.join(",")+d+"}"}}({"":e},"",e,0)};var i=Array.isArray||function(e){return"[object Array]"==={}.toString.call(e)},a=Object.keys||function(e){var t=Object.prototype.hasOwnProperty||function(){return!0},n=[];for(var r in e)t.call(e,r)&&n.push(r);return n}},function(e,t,n){(function(t){"use strict";var n=function(e,n,r,i,a,o,s,u){if("production"!==t.env.NODE_ENV&&void 0===n)throw new Error("invariant requires an error message argument");if(!e){var l;if(void 0===n)l=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var p=[r,i,a,o,s,u],c=0;l=new Error(n.replace(/%s/g,function(){return p[c++]})),l.name="Invariant Violation"}throw l.framesToPop=1,l}};e.exports=n}).call(t,n(64))},function(e,t,n){"use strict";function r(e,t){return void 0===t&&(t=!0),new v({rootNodeDetails:!0,serializeMetadata:t}).dump(e)}var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},a=n(18),o=n(49),s=n(41),u=n(39),l=n(16),p=n(29),c=n(14),f=n(18),d=n(33),m=n(65),h=n(11),y=n(15);t.dump=r;var v=function(){function e(e){this.options=e,this.nodeTransformers=[new V,new k,new Y,new b,new L,new P,new W,new I,new R,new F,new B,new O,new q,new j],this.nodePropertyTransformers=[new T,new N,new _,new M,new w,new C,new K],this.ignore=new A([new g(c.isResponseType,c.isDisplayNameProperty),new g(c.isApiSibling,c.isDisplayNameProperty),new g(c.isAnnotationRefTypeOrDescendant,c.isAnnotationProperty),new g(c.isSecuritySchemeRefType,c.isSecuritySchemeProperty),new g(c.isTraitRefType,c.isTraitProperty),new g(c.isResourceTypeRefType,c.isResourceTypeProperty),new g(c.isApiSibling,c.isRAMLVersionProperty),new g(c.isTypeDeclarationDescendant,c.isStructuredItemsProperty)]),this.missingProperties=new H,this.options=this.options||{},null==this.options.serializeMetadata&&(this.options.serializeMetadata=!0)}return e.prototype.printMissingProperties=function(){return this.missingProperties.print()},e.prototype.dump=function(e){var t=e.highLevel(),n=t&&t.parent(),r=!n&&this.options.rootNodeDetails,i=this.dumpInternal(e,r);return i},e.prototype.dumpInternal=function(e,t,n){var r=this;if(void 0===t&&(t=!1),null==e)return null;if(o.BasicNodeImpl.isInstance(e)){var i={},a=e,s=a.highLevel().definition();s.allProperties().filter(function(e){return!r.ignore.match(a.definition(),e)}).forEach(function(e){i[e.nameId()]=e}),s.allCustomProperties().filter(function(e){return!r.ignore.match(a.definition(),e)}).forEach(function(e){i[e.nameId()]=e});var u=this.dumpProperties(i,e);if(i.schema&&this.options.dumpSchemaContents&&i.schema.range().key()==f.Universe08.SchemaString){var l=a.highLevel().root().elementsOfKind("schemas");l.forEach(function(e){if(e.name()==u.schema){var t=e.attr("value");t&&(u.schema=t.value(),u.schemaContent=t.value())}})}if(this.serializeScalarsAnnotations(u,a,i),this.serializeMeta(u,a),this.canBeFragment(e)&&h.isFragment(e)){var p=h.asFragment(e),d=p.uses();d.length>0&&(u.uses=d.map(function(e){return e.toJSON()}))}if(c.isTypeDeclarationDescendant(s)){var m=a.highLevel().property();if(m&&!(c.isHeadersProperty(m)||c.isQueryParametersProperty(m)||c.isUriParametersProperty(m)||c.isPropertiesProperty(m)||c.isBaseUriParametersProperty(m))){delete u.required;var y=u.__METADATA__;if(y){var v=y.primitiveValuesMeta;v&&delete v.required}}}this.nodeTransformers.forEach(function(t){t.match(e,n||e.highLevel().property())&&(u=t.transform(u,e))});var g={};if(t){if(s){var A=s.universe().version();g.ramlVersion=A,g.type=s.nameId()}g.specification=u,g.errors=this.dumpErrors(a.errors())}else g=u;return g}if(o.AttributeNodeImpl.isInstance(e)){var i={},S=e,s=S.highLevel().definition(),E=S.highLevel().property().range();E.isArray()&&(E=E.array().componentType()),s.allCustomProperties().filter(function(e){return!r.ignore.match(E,e)}).forEach(function(e){i[e.nameId()]=e});var T=E.isValueType();if(T&&S.value){var b=S.value();if("number"==typeof b||"string"==typeof b||"boolean"==typeof b)return b}var u=this.dumpProperties(i,e);return this.nodeTransformers.forEach(function(t){t.match(e,e.highLevel().property())&&(u=t.transform(u,e))}),this.serializeScalarsAnnotations(u,e,i),this.serializeMeta(u,S),u}return o.TypeInstanceImpl.isInstance(e)?this.serializeTypeInstance(e):o.TypeInstancePropertyImpl.isInstance(e)?this.serializeTypeInstanceProperty(e):e},e.prototype.canBeFragment=function(e){var t=e.definition(),n=[t].concat(t.allSubTypes()),r=n.filter(function(e){return e.getAdapter(u.RAMLService).possibleInterfaces().filter(function(e){return e.nameId()==u.universesInfo.Universe10.FragmentDeclaration.name}).length>0});return r.length>0},e.prototype.dumpErrors=function(e){var t=this;return e.map(function(e){var n=t.dumpErrorBasic(e);return e.trace&&e.trace.length>0&&(n.trace=t.dumpErrors(e.trace)),n}).sort(function(e,t){return e.path!=t.path?e.path.localeCompare(t.path):e.range.start.position!=t.range.start.position?e.range.start.position-t.range.start.position:e.code-t.code})},e.prototype.dumpErrorBasic=function(e){var t={code:e.code,message:e.message,path:e.path,line:e.line,column:e.column,position:e.start,range:e.range};return e.isWarning===!0&&(t.isWarning=!0),t},e.prototype.stringLooksLikeXML=function(e){return"<"===e[0]&&">"===e[e.length-1]},e.prototype.stringLooksLikeJSON=function(e){return"{"===e[0]&&"}"===e[e.length-1]},e.prototype.dumpProperties=function(e,t){var n,r=this,i={};return t.highLevel().isElement()&&(n=t.highLevel().definition()),Object.keys(e).forEach(function(s){var u;if(n&&(u=n.property(s),u||(u=m.find(n.allCustomProperties(),function(e){return e.nameId()==s}))),!t[s])return void r.missingProperties.addProperty(e[s],t.kind());var f=e[s],d=t[s]();if(d&&"structuredType"==s&&"object"==typeof d){d=null;var h=t.highLevel(),v=h.lowLevel();v.children().forEach(function(e){if("type"==e.key()||"schema"==e.key()){var t=h.definition().universe().type(a.Universe10.TypeDeclaration.name),n=h.definition().universe().type(a.Universe10.LibraryBase.name),i=new l.ASTNodeImpl(e,h,t,n.property(a.Universe10.LibraryBase.properties.types.name));i.patchType(p.doDescrimination(i)),d=r.dumpInternal(i.wrapperNode(),!1,u),s=e.key()}})}else if("items"==s&&"object"==typeof d){var g=Array.isArray(d),A=!g;if(g&&(A=null!=m.find(d,function(e){return"object"==typeof e})),A){d=null;var h=t.highLevel(),v=h.lowLevel();v.children().forEach(function(e){if("items"==e.key()){var t=h.definition().universe().type(a.Universe10.TypeDeclaration.name),n=h.definition().universe().type(a.Universe10.LibraryBase.name),i=new l.ASTNodeImpl(e,h,t,n.property(a.Universe10.LibraryBase.properties.types.name));i.patchType(p.doDescrimination(i)),d=r.dumpInternal(i.wrapperNode(),!1,u),s=e.key()}})}}if(n&&n.isAssignableFrom("TypeDeclaration")&&("type"===s||"schema"==s)&&d)if(d.forEach&&"string"==typeof d[0]){var h=t.highLevel(),S=h.localType();if(S&&S.hasExternalInHierarchy()){var E=d[0].trim(),T="{"===E[0]&&"}"===E[E.length-1],b="<"===E[0]&&">"===E[E.length-1];T?i.typePropertyKind="JSON":b&&(i.typePropertyKind="XML")}else i.typePropertyKind="TYPE_EXPRESSION"}else"object"==typeof d&&(i.typePropertyKind="INPLACE");if(("type"===s||"schema"==s)&&d&&d.forEach&&"string"==typeof d[0]){var E=d[0].trim(),T=r.stringLooksLikeJSON(E),b=r.stringLooksLikeXML(E);if(T||b){var N=t.highLevel().lowLevel().includePath&&t.highLevel().lowLevel().includePath();if(!N&&t.highLevel().isElement()){var _=t.highLevel().asElement().attr("type");_||(_=t.highLevel().asElement().attr("schema")),_&&(N=_.lowLevel().includePath&&_.lowLevel().includePath())}if(N){var w=N.indexOf("#"),M="";w>=0&&(M=N.substring(w),N=N.substring(0,w));var I,R=t.highLevel().lowLevel().unit().resolve(N).absolutePath();I=0===R.indexOf("http://")||0===R.indexOf("https://")?R:y.relative(t.highLevel().lowLevel().unit().project().getRootPath(),R),I=I.replace(/\\/g,"/"),i.schemaPath=I+M}}}if((d||"type"!=s)&&(d||"schema"!=s)&&(d||"items"!=s)){if(t.definition&&c.isTypeDeclarationSibling(t.definition())&&c.isTypeProperty(f)){var C=t[a.Universe10.TypeDeclaration.properties.schema.name]();if(null!=C&&(!Array.isArray(C)||0!=C.length))return;var h=t.highLevel(),v=h.lowLevel(),L=!1;if(v.children().forEach(function(e){return"schema"==e.key()?void(L=!0):void 0}),L)return}if(Array.isArray(d)){for(var P=[],O=0,D=d;O<D.length;O++){var x=D[O],U=r.dumpInternal(x);"examples"===s&&r.options&&r.options.dumpXMLRepresentationOfExamples&&x.expandable&&x.expandable._owner&&(U.asXMLString=x.expandable.asXMLString()),P.push(U)}if(0==P.length&&o.BasicNodeImpl.isInstance(t)&&!r.isDefined(t,s))return;for(var k=0,F=r.nodePropertyTransformers;k<F.length;k++){var B=F[k];B.match(t,f)&&(P=B.transform(P,t))}i[s]=P}else{var x=r.dumpInternal(d);if(null==x&&o.BasicNodeImpl.isInstance(t)&&!r.isDefined(t,s))return;o.BasicNodeImpl.isInstance(t)&&r.nodePropertyTransformers.forEach(function(e){e.match(t,f)&&(x=e.transform(x,t))}),i[s]=x,"example"===s&&r.options&&r.options.dumpXMLRepresentationOfExamples&&d.expandable&&d.expandable._owner&&(x.asXMLString=d.expandable.asXMLString())}}}),i},e.prototype.serializeScalarsAnnotations=function(e,t,n){var r=this;if(t.scalarsAnnotations){for(var i={},a=t.scalarsAnnotations(),o=0,s=Object.keys(n);o<s.length;o++){var u=s[o];if(a[u]){var l=a[u]();if(l.length>0)if(Array.isArray(l[0])){var p=[];l.forEach(function(e,t){p.push(e.map(function(e){return r.dumpInternal(e)}))}),p.filter(function(e){return e.length>0}).length>0&&(i[u]=p)}else i[u]=l.map(function(e){return r.dumpInternal(e)})}}Object.keys(i).length>0&&(e.scalarsAnnotations=i)}},e.prototype.serializeMeta=function(e,t){if(this.options.serializeMetadata){var n=t.meta();n.isDefault()||(e.__METADATA__=n.toJSON())}},e.prototype.serializeTypeInstance=function(e){var t=this;if(e.isScalar())return e.value();if(e.isArray())return e.items().map(function(e){return t.serializeTypeInstance(e)});var n=e.properties();if(0==n.length)return null;var r={};return n.forEach(function(e){return r[e.name()]=t.serializeTypeInstanceProperty(e)}),r},e.prototype.serializeTypeInstanceProperty=function(e){var t=this;if(e.isArray()){var n=e.values(),r=[];return n.forEach(function(e){return r.push(t.serializeTypeInstance(e))}),r}return this.serializeTypeInstance(e.value())},e.prototype.isDefined=function(e,t){var n=e.highLevel();return n.elementsOfKind(t).length>0?!0:n.attributes(t).length>0?!0:!1},e}();t.TCKDumper=v;var g=function(){function e(e,t){this.typeMatcher=e,this.propMatcher=t}return e.prototype.match=function(e,t){return(null==e||this.typeMatcher(e))&&(null==t||this.propMatcher(t))},e}(),A=function(){function e(e){this.matchers=e}return e.prototype.match=function(e,t){for(var n=this.matchers.length,r=0;n>r;r++)if(this.matchers[r].match(e,t))return!0;return!1},e}(),S=function(){function e(e,t){this.matcher=e,this.propName=t}return e.prototype.match=function(e,t){return this.matcher.match(e.definition(),t)},e.prototype.transform=function(e){var t=this;if(Array.isArray(e)&&e.length>0&&e[0][this.propName]){var n={};return e.forEach(function(e){var r=e[t.propName],i=n[r];i?Array.isArray(i)?i.push(e):n[r]=[i,e]:n[r]=e}),n}return e},e}(),E=function(){function e(e,t){this.matcher=e,this.propName=t}return e.prototype.match=function(e,t){return this.matcher.match(e.definition?e.definition():null,t)},e.prototype.transform=function(e){if(Array.isArray(e))return e;var t={};return t[e[this.propName]]=e,t},e}(),T=function(e){function t(){e.call(this,new A([new g(c.isApiSibling,c.isBaseUriParametersProperty),new g(c.isResourceBaseSibling,c.isUriParametersProperty),new g(c.isResourceBaseSibling,c.isQueryParametersProperty),new g(c.isTraitType,c.isQueryParametersProperty),new g(c.isMethodType,c.isQueryParametersProperty),new g(c.isSecuritySchemePartType,c.isQueryParametersProperty),new g(c.isTraitType,c.isHeadersProperty),new g(c.isMethodType,c.isHeadersProperty),new g(c.isSecuritySchemePartType,c.isHeadersProperty),new g(c.isBodyLikeType,c.isFormParametersProperty)]),"name")}return i(t,e),t}(S),b=function(e){function t(){e.call(this,new A([new g(c.isLibraryBaseSibling,c.isTypesProperty),new g(function(e){return c.isLibraryBaseSibling(e)&&c.isRAML10Type(e)},c.isSchemasProperty)]),"name")}return i(t,e),t.prototype.match=function(e,t){var n=null!=e.parent()&&this.matcher.match(e.parent().definition(),t);return n?!0:!1},t}(E),N=(function(e){function t(){e.call(this,new A([new g(c.isLibraryBaseSibling,c.isUsesProperty)]),"name")}return i(t,e),t}(S),function(e){function t(){e.call(this,new A([new g(c.isObjectTypeDeclarationSibling,c.isPropertiesProperty)]),"name")}return i(t,e),t}(S)),_=function(e){function t(){e.call(this,new A([new g(c.isMethodBaseSibling,c.isResponsesProperty)]),"code")}return i(t,e),t}(S),w=function(e){function t(){e.call(this,new A([new g(function(e){return!0},c.isAnnotationsProperty)]),"name")}return i(t,e),t}(S),M=function(e){function t(){e.call(this,new A([new g(c.isResponseType,c.isBodyProperty),new g(c.isMethodBaseSibling,c.isBodyProperty)]),"name")}return i(t,e),t}(S),I=function(e){function t(){e.call(this,new A([new g(c.isTraitType,c.isTraitsProperty)]),"name")}return i(t,e),t}(E),R=function(e){function t(){e.call(this,new A([new g(c.isResourceTypeType,c.isResourceTypesProperty)]),"name")}return i(t,e),t.prototype.transform=function(t){var n=f.Universe10.ResourceBase.properties.methods.name;if(Array.isArray(t))return t;var r=t[n];return r&&r.forEach(function(e){var n=Object.keys(e);if(n.length>0){var r=n[0];t[r]=e[r]}}),delete t[n],e.prototype.transform.call(this,t)},t}(E),C=function(e){function t(){e.call(this,new A([new g(c.isTypeDeclarationSibling,c.isFacetsProperty)]),"name")}return i(t,e),t}(S),L=function(e){function t(){e.call(this,null,"name")}return i(t,e),t.prototype.match=function(e,t){return null!=t&&c.isSecuritySchemesProperty(t)},t}(E),P=function(e){function t(){e.call(this,new A([new g(c.isLibraryBaseSibling,c.isAnnotationTypesProperty)]),"name")}return i(t,e),t.prototype.match=function(e,t){return null!=e.parent()&&this.matcher.match(e.parent().definition(),t)},t}(E),O=function(e){function t(){e.call(this,null,"method")}return i(t,e),t.prototype.match=function(e,t){return null!=e.parent()&&c.isResourceTypeType(e.parent().definition())&&c.isMethodsProperty(t)},t}(E),D=a.Universe10.ExampleSpec.properties.name.name,x=a.Universe10.ExampleSpec.properties.value.name,U="structuredContent",k=(function(){function e(){}return e.prototype.match=function(e,t){return c.isExampleSpecType(e.definition())},e.prototype.transform=function(e){var t=this;if(Array.isArray(e)&&e.length>0){if(e[0][D]){var n={};return e.forEach(function(e){return n[e[D]]=t.getActualExample(e)}),n}var r=e.map(function(e){return t.getActualExample(e)});return r}return e},e.prototype.getActualExample=function(e){return e[U]?e[U]:e[x]},e}(),function(){function e(){}return e.prototype.match=function(e,t){return e.definition&&c.isTypeDeclarationSibling(e.definition())},e.prototype.transform=function(e){var t=Array.isArray(e),n=t?e:[e];return n.forEach(function(e){var t=e.example;t&&(e.example=t.structuredValue,e.structuredExample=t)}),t?n:n[0]},e}()),F=function(){function e(){this.matcher=new g(function(e){return c.isApiType(e)&&c.isRAML08Type(e)},c.isSchemasProperty)}return e.prototype.match=function(e,t){return null!=e.parent()&&this.matcher.match(e.parent().definition(),t)},e.prototype.transform=function(e){if(Array.isArray(e))return e;var t={};return t[e.key]=e.value,t},e.prototype.getActualExample=function(e){return e[U]?e[U]:e[x]},e}(),B=function(){function e(){}return e.prototype.match=function(e,t){return null!=t&&c.isProtocolsProperty(t)},e.prototype.transform=function(e){return"string"==typeof e?e.toUpperCase():Array.isArray(e)?e.map(function(e){return e.toUpperCase()}):e},e}(),K=function(){function e(){this.usecases=new A([new g(c.isApiSibling,c.isMediaTypeProperty)])}return e.prototype.match=function(e,t){return this.usecases.match(e.definition(),t)},e.prototype.transform=function(e){return Array.isArray(e)&&1==e.length?e[0]:e},e}(),V=function(){function e(){}return e.prototype.match=function(e,t){return null!=t&&c.isResourcesProperty(t)},e.prototype.transform=function(e,t){if(Array.isArray(e))return e;var n=e[f.Universe10.Resource.properties.relativeUri.name];if(n){for(var r=n.trim().split("/");r.length>0&&0==r[0].length;)r.shift();e.relativeUriPathSegments=r,e.absoluteUri=t.absoluteUri()}return e},e}(),j=function(){function e(){}return e.prototype.match=function(e,t){return e.parent()&&e.parent().highLevel().lowLevel().libProcessed?c.isAnnotationTypesProperty(t)||c.isTypesProperty(t)||c.isResourceTypesProperty(t)||c.isTraitsProperty(t)||c.isSecuritySchemesProperty(t):!1},e.prototype.transform=function(e,t){for(var n=t.highLevel().lowLevel(),r=n.key(),i=n;s.LowLevelProxyNode.isInstance(i);)i=i.originalNode();var a=i.key(),o=e[Object.keys(e)[0]];return o.name=a,o.displayName==r&&(o.displayName=a),e},e}(),W=function(){function e(){}return e.prototype.match=function(e,t){var n=e.highLevel();if(!n)return!1;var r=n.definition();return r?c.isResourceTypeType(r)||c.isTraitType(r)||c.isMethodType(r)||c.isTypeDeclarationSibling(r):!1},e.prototype.transform=function(e){if(Array.isArray(e))return e;var t=a.Universe10.Trait.properties.parametrizedProperties.name,n=e[t];return n&&(Object.keys(n).forEach(function(t){e[t]=n[t]}),delete e[t]),e},e}(),q=function(){function e(){}return e.prototype.match=function(e,t){return null!=t&&(c.isSecuredByProperty(t)||c.isIsProperty(t)||null!=e.parent()&&(c.isResourceType(e.parent().highLevel().definition())||c.isResourceTypeType(e.parent().highLevel().definition()))&&c.isTypeProperty(t))},e.prototype.transform=function(e){return e?Array.isArray(e)?e:this.toSimpleValue(e):null},e.prototype.toSimpleValue=function(e){var t=e.name,n=e.structuredValue;if(n){var r={};return r[t]=n,r}return t},e}(),Y=function(){function e(){}return e.prototype.match=function(e,t){if(!o.BasicNodeImpl.isInstance(e))return!1;var n=e.highLevel(),r=n.definition();if(!c.isTypeDeclarationDescendant(r))return!1;var i=n.localType();return i&&i.isArray()?!0:!1},e.prototype.transform=function(e){var t=f.Universe10.TypeDeclaration.properties.type.name,n=f.Universe10.TypeDeclaration.properties.schema.name,r=f.Universe10.ArrayTypeDeclaration.properties.items.name,i=e[t];return i||(i=e[n]),1==i.length&&d.stringEndsWith(i[0],"[]")&&(null==e[r]&&(e[r]=i[0].substring(0,i[0].length-2)),i[0]="array"),e},e}(),H=function(){function e(){this.map={}}return e.prototype.addProperty=function(e,t){var n=this.map[t];n||(n=new $(t),this.map[t]=n),n.addProperty(e)},e.prototype.print=function(){var e=this;return Object.keys(this.map).map(function(t){return e.map[t].print()}).join("\n")+"\n"},e}(),$=function(){function e(e){this.typeName=e,this.map={}}return e.prototype.addProperty=function(e){var t=e.domain().nameId(),n=this.map[t];n||(n=new G(t),this.map[t]=n),n.addProperty(e)},e.prototype.print=function(){var e=this;return this.typeName+":\n"+Object.keys(this.map).map(function(t){return"    "+e.map[t].print()}).join("\n")},e}(),G=function(){function e(e){this.typeName=e,this.map={}}return e.prototype.addProperty=function(e){var t=e.nameId();this.map[t]=e},e.prototype.print=function(){return this.typeName+": "+Object.keys(this.map).sort().join(", ")},e}()},function(e,t,n){"use strict";function r(e,t){var n=t?t.endPosition:e.endPosition+1,r={key:e,value:t,startPosition:e.startPosition,endPosition:n,kind:f.MAPPING,parent:null,errors:[]};return r}function i(e,t,n,r){return{errors:[],referencesAnchor:e,value:r,startPosition:t,endPosition:n,kind:f.ANCHOR_REF,parent:null}}function a(e){return void 0===e&&(e=""),{errors:[],startPosition:-1,endPosition:-1,value:e,kind:f.SCALAR,parent:null,doubleQuoted:!1}}function o(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:f.SEQ,parent:null}}function s(){return o()}function u(e){return{errors:[],startPosition:-1,endPosition:-1,mappings:e?e:[],kind:f.MAP,parent:null}}var l=n(88),p=n(89),c=function(){function e(e,t){void 0===t&&(t=null),this.name="YAMLException",this.reason=e,this.mark=t,this.message=this.toString(!1)}return e.isInstance=function(t){if(null!=t&&t.getClassIdentifier&&"function"==typeof t.getClassIdentifier)for(var n=0,r=t.getClassIdentifier();n<r.length;n++){var i=r[n];if(i==e.CLASS_IDENTIFIER)return!0}return!1},e.prototype.getClassIdentifier=function(){var t=[];return t.concat(e.CLASS_IDENTIFIER)},e.prototype.toString=function(e){void 0===e&&(e=!1);var t;return t="JS-YAML: "+(this.reason||"(unknown reason)"),!e&&this.mark&&(t+=" "+this.mark.toString()),t},e.CLASS_IDENTIFIER="yaml-ast-parser.YAMLException",e}();t.YAMLException=c,function(e){e[e.SCALAR=0]="SCALAR",e[e.MAPPING=1]="MAPPING",e[e.MAP=2]="MAP",e[e.SEQ=3]="SEQ",e[e.ANCHOR_REF=4]="ANCHOR_REF",e[e.INCLUDE_REF=5]="INCLUDE_REF"}(t.Kind||(t.Kind={}));var f=t.Kind;t.newMapping=r,t.newAnchorRef=i,t.newScalar=a,t.newItems=o,t.newSeq=s,t.newMap=u,t.load=l.load,t.loadAll=l.loadAll,t.safeLoad=l.safeLoad,t.dump=p.dump,t.safeDump=p.safeDump},function(e,t,n){function r(e){this.options=e||{locator:{}}}function i(e,t,n){function r(t){var r=e[t];!r&&o&&(r=2==e.length?function(n){e(t,n)}:e),i[t]=r&&function(e){r("[xmldom "+t+"]	"+e+s(n))}||function(){}}if(!e){if(t instanceof a)return t;e=t}var i={},o=e instanceof Function;return n=n||{},r("warning"),r("error"),r("fatalError"),i}function a(){this.cdata=!1}function o(e,t){t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber}function s(e){return e?"\n@"+(e.systemId||"")+"#[line:"+e.lineNumber+",col:"+e.columnNumber+"]":void 0}function u(e,t,n){return"string"==typeof e?e.substr(t,n):e.length>=t+n||t?new java.lang.String(e,t,n)+"":e}function l(e,t){e.currentElement?e.currentElement.appendChild(t):e.doc.appendChild(t)}r.prototype.parseFromString=function(e,t){var n=this.options,r=new p,o=n.domBuilder||new a,s=n.errorHandler,u=n.locator,l=n.xmlns||{},c={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return u&&o.setDocumentLocator(u),r.errorHandler=i(s,o,u),r.domBuilder=n.domBuilder||o,/\/x?html?$/.test(t)&&(c.nbsp=" ",c.copy="©",l[""]="http://www.w3.org/1999/xhtml"),l.xml=l.xml||"http://www.w3.org/XML/1998/namespace",e?r.parse(e,l,c):r.errorHandler.error("invalid doc source"),o.doc},a.prototype={startDocument:function(){this.doc=(new c).createDocument(null,null,null),this.locator&&(this.doc.documentURI=this.locator.systemId)},startElement:function(e,t,n,r){var i=this.doc,a=i.createElementNS(e,n||t),s=r.length;l(this,a),this.currentElement=a,this.locator&&o(this.locator,a);for(var u=0;s>u;u++){var e=r.getURI(u),p=r.getValue(u),n=r.getQName(u),c=i.createAttributeNS(e,n);this.locator&&o(r.getLocator(u),c),c.value=c.nodeValue=p,a.setAttributeNode(c)}},endElement:function(e,t,n){var r=this.currentElement;r.tagName;this.currentElement=r.parentNode},startPrefixMapping:function(e,t){},endPrefixMapping:function(e){},processingInstruction:function(e,t){var n=this.doc.createProcessingInstruction(e,t);this.locator&&o(this.locator,n),l(this,n)},ignorableWhitespace:function(e,t,n){},characters:function(e,t,n){if(e=u.apply(this,arguments)){if(this.cdata)var r=this.doc.createCDATASection(e);else var r=this.doc.createTextNode(e);this.currentElement?this.currentElement.appendChild(r):/^\s*$/.test(e)&&this.doc.appendChild(r),this.locator&&o(this.locator,r)}},skippedEntity:function(e){},endDocument:function(){this.doc.normalize()},setDocumentLocator:function(e){(this.locator=e)&&(e.lineNumber=0)},comment:function(e,t,n){e=u.apply(this,arguments);var r=this.doc.createComment(e);this.locator&&o(this.locator,r),l(this,r)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(e,t,n){var r=this.doc.implementation;if(r&&r.createDocumentType){var i=r.createDocumentType(e,t,n);this.locator&&o(this.locator,i),l(this,i)}},warning:function(e){console.warn("[xmldom warning]	"+e,s(this.locator))},error:function(e){console.error("[xmldom error]	"+e,s(this.locator))},fatalError:function(e){throw console.error("[xmldom fatalError]	"+e,s(this.locator)),e}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(e){a.prototype[e]=function(){return null}});var p=n(90).XMLReader,c=t.DOMImplementation=n(91).DOMImplementation;t.XMLSerializer=n(91).XMLSerializer,t.DOMParser=r},function(e,t,n){"use strict";function r(e,t,n,s){var u=new i(function(i,u){function l(a){r(e,t,{qs:n.qs,headers:n.headers,timeout:n.timeout}).nodeify(function(e,t){var r=e||t.statusCode>=400;if("function"==typeof n.retry&&(r=n.retry(e,t,a+1)),a>=(5|n.maxRetries)&&(r=!1),r){var o=n.retryDelay;"function"==typeof n.retryDelay&&(o=n.retryDelay(e,t,a+1)),o=o||200,setTimeout(function(){l(a+1)},o)}else e?u(e):i(t)})}var p=new window.XMLHttpRequest;if("string"!=typeof e)throw new TypeError("The method must be a string.");if("string"!=typeof t)throw new TypeError("The URL/path must be a string.");if("function"==typeof n&&(s=n,n={}),(null===n||void 0===n)&&(n={}),"object"!=typeof n)throw new TypeError("Options must be an object (or null).");if("function"!=typeof s&&(s=void 0),e=e.toUpperCase(),n.headers=n.headers||{},n.retry&&"GET"===e)return l(0);var c,f=!(!(c=/^([\w-]+:)?\/\/([^\/]+)/.exec(t))||c[2]==window.location.host);if(f||(n.headers["X-Requested-With"]="XMLHttpRequest"),n.qs&&(t=o(t,n.qs)),n.json&&(n.body=JSON.stringify(n.json),n.headers["Content-Type"]="application/json"),n.timeout){p.timeout=n.timeout;var d=Date.now();p.ontimeout=function(){var e=Date.now()-d,t=new Error("Request timed out after "+e+"ms");t.timeout=!0,t.duration=e,u(t)}}p.onreadystatechange=function(){if(4===p.readyState){var e={};p.getAllResponseHeaders().split("\r\n").forEach(function(t){var n=t.split(":");n.length>1&&(e[n[0].toLowerCase()]=n.slice(1).join(":").trim())});var n=new a(p.status,e,p.responseText);n.url=t,i(n)}},p.open(e,t,!0);for(var m in n.headers)p.setRequestHeader(m,n.headers[m]);p.send(n.body?n.body:null)});return u.getBody=function(){return u.then(function(e){return e.getBody()})},u.nodeify(s)}var i=n(118),a=n(66),o=n(95);e.exports=r},function(e,t,n){var r,i,a;!function(n,o){"use strict";"object"==typeof e&&"object"==typeof e.exports?e.exports=o():(i=[],r=o,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}("object"==typeof window?window:this,function(){"use strict";function e(e){this.capacity=e>0?+e:Number.MAX_VALUE,this.data=Object.create?Object.create(null):{},this.hash=Object.create?Object.create(null):{},this.linkedList={length:0,head:null,end:null}}function t(n){return this instanceof t?void(this._LRUCacheState=new e(n)):new t(n)}function n(e,t){t!==e.head&&(e.end?e.end===t&&(e.end=t.n):e.end=t,r(t.n,t.p),r(t,e.head),e.head=t,e.head.n=null)}function r(e,t){e!==t&&(e&&(e.p=t),t&&(t.n=e))}var i=t.prototype;return i.get=function(e){var t=this._LRUCacheState,r=t.hash[e];return r?(n(t.linkedList,r),t.data[e]):void 0},i.set=function(e,t){var r=this._LRUCacheState,i=r.hash[e];return void 0===t?this:(i||(r.hash[e]={key:e},r.linkedList.length+=1,i=r.hash[e]),n(r.linkedList,i),r.data[e]=t,r.linkedList.length>r.capacity&&this.remove(r.linkedList.end.key),this)},i.update=function(e,t){this._LRUCacheState;if(this.has(e)){var n=this.get(e);this.set(e,t(n))}return this},i.remove=function(e){var t=this._LRUCacheState,n=t.hash[e];return n?(n===t.linkedList.head&&(t.linkedList.head=n.p),n===t.linkedList.end&&(t.linkedList.end=n.n),r(n.n,n.p),delete t.hash[e],delete t.data[e],t.linkedList.length-=1,this):this},i.removeAll=function(){return this._LRUCacheState=new e(this._LRUCacheState.capacity),this},i.info=function(){var e=this._LRUCacheState;return{capacity:e.capacity,length:e.linkedList.length}},i.keys=function(){for(var e=this._LRUCacheState,t=[],n=e.linkedList.head;n;)t.push(n.key),n=n.p;return t},i.has=function(e){return!!this._LRUCacheState.hash[e]},i.staleKey=function(){return this._LRUCacheState.linkedList.end&&this._LRUCacheState.linkedList.end.key},i.popStale=function(){var e=this.staleKey();if(!e)return null;var t=[e,this._LRUCacheState.data[e]];return this.remove(e),t},t.NAME="LRUCache",t.VERSION="v0.2.0",t})},function(e,t,n){!function(t,n){e.exports=n()}(this,function(){function e(e){return e.charAt(0).toUpperCase()+e.substr(1).toLowerCase()}function t(e){return"string"==typeof e?new RegExp("^"+e+"$","i"):e}function n(t,n){return t===t.toUpperCase()?n.toUpperCase():t[0]===t[0].toUpperCase()?e(n):n.toLowerCase()}function r(e,t){return e.replace(/\$(\d{1,2})/g,function(e,n){return t[n]||""})}function i(e,t,i){if(!e.length||l.hasOwnProperty(e))return t;for(var a=i.length;a--;){var o=i[a];if(o[0].test(t))return t.replace(o[0],function(e,t,i){var a=r(o[1],arguments);return""===e?n(i[t-1],a):n(e,a)})}return t}function a(e,t,r){return function(a){var o=a.toLowerCase();return t.hasOwnProperty(o)?n(a,o):e.hasOwnProperty(o)?n(a,e[o]):i(o,a,r)}}function o(e,t,n){var r=1===t?o.singular(e):o.plural(e);return(n?t+" ":"")+r}var s=[],u=[],l={},p={},c={};return o.plural=a(c,p,s),o.singular=a(p,c,u),o.addPluralRule=function(e,n){s.push([t(e),n])},o.addSingularRule=function(e,n){u.push([t(e),n])},o.addUncountableRule=function(e){return"string"==typeof e?void(l[e.toLowerCase()]=!0):(o.addPluralRule(e,"$0"),void o.addSingularRule(e,"$0"))},o.addIrregularRule=function(e,t){t=t.toLowerCase(),e=e.toLowerCase(),c[e]=t,p[t]=e},[["I","we"],["me","us"],["he","they"],["she","they"],["them","them"],["myself","ourselves"],["yourself","yourselves"],["itself","themselves"],["herself","themselves"],["himself","themselves"],["themself","themselves"],["is","are"],["this","these"],["that","those"],["echo","echoes"],["dingo","dingoes"],["volcano","volcanoes"],["tornado","tornadoes"],["torpedo","torpedoes"],["genus","genera"],["viscus","viscera"],["stigma","stigmata"],["stoma","stomata"],["dogma","dogmata"],["lemma","lemmata"],["schema","schemata"],["anathema","anathemata"],["ox","oxen"],["axe","axes"],["die","dice"],["yes","yeses"],["foot","feet"],["eave","eaves"],["goose","geese"],["tooth","teeth"],["quiz","quizzes"],["human","humans"],["proof","proofs"],["carve","carves"],["valve","valves"],["thief","thieves"],["genie","genies"],["groove","grooves"],["pickaxe","pickaxes"],["whiskey","whiskies"]].forEach(function(e){return o.addIrregularRule(e[0],e[1])}),[[/s?$/i,"s"],[/([^aeiou]ese)$/i,"$1"],[/(ax|test)is$/i,"$1es"],[/(alias|[^aou]us|tlas|gas|ris)$/i,"$1es"],[/(e[mn]u)s?$/i,"$1s"],[/([^l]ias|[aeiou]las|[emjzr]as|[iu]am)$/i,"$1"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1i"],[/(alumn|alg|vertebr)(?:a|ae)$/i,"$1ae"],[/(seraph|cherub)(?:im)?$/i,"$1im"],[/(her|at|gr)o$/i,"$1oes"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i,"$1a"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i,"$1a"],[/sis$/i,"ses"],[/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i,"$1$2ves"],[/([^aeiouy]|qu)y$/i,"$1ies"],[/([^ch][ieo][ln])ey$/i,"$1ies"],[/(x|ch|ss|sh|zz)$/i,"$1es"],[/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i,"$1ices"],[/(m|l)(?:ice|ouse)$/i,"$1ice"],[/(pe)(?:rson|ople)$/i,"$1ople"],[/(child)(?:ren)?$/i,"$1ren"],[/eaux$/i,"$0"],[/m[ae]n$/i,"men"],["thou","you"]].forEach(function(e){
return o.addPluralRule(e[0],e[1])}),[[/s$/i,""],[/(ss)$/i,"$1"],[/((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)(?:sis|ses)$/i,"$1sis"],[/(^analy)(?:sis|ses)$/i,"$1sis"],[/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i,"$1fe"],[/(ar|(?:wo|[ae])l|[eo][ao])ves$/i,"$1f"],[/([^aeiouy]|qu)ies$/i,"$1y"],[/(^[pl]|zomb|^(?:neck)?t|[aeo][lt]|cut)ies$/i,"$1ie"],[/(\b(?:mon|smil))ies$/i,"$1ey"],[/(m|l)ice$/i,"$1ouse"],[/(seraph|cherub)im$/i,"$1"],[/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|tlas|gas|(?:her|at|gr)o|ris)(?:es)?$/i,"$1"],[/(e[mn]u)s?$/i,"$1"],[/(movie|twelve)s$/i,"$1"],[/(cris|test|diagnos)(?:is|es)$/i,"$1is"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1us"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i,"$1um"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i,"$1on"],[/(alumn|alg|vertebr)ae$/i,"$1a"],[/(cod|mur|sil|vert|ind)ices$/i,"$1ex"],[/(matr|append)ices$/i,"$1ix"],[/(pe)(rson|ople)$/i,"$1rson"],[/(child)ren$/i,"$1"],[/(eau)x?$/i,"$1"],[/men$/i,"man"]].forEach(function(e){return o.addSingularRule(e[0],e[1])}),["advice","agenda","bison","bream","buffalo","carp","chassis","cod","cooperation","corps","digestion","debris","diabetes","energy","equipment","elk","excretion","expertise","flounder","gallows","garbage","graffiti","headquarters","health","herpes","highjinks","homework","information","jeans","justice","kudos","labour","machinery","mackerel","media","mews","moose","news","pike","plankton","pliers","pollution","premises","rain","rice","salmon","scissors","series","sewage","shambles","shrimp","species","staff","swine","trout","tuna","whiting","wildebeest","wildlife","you",/pox$/i,/ois$/i,/deer$/i,/fish$/i,/sheep$/i,/measles$/i,/[^aeiou]ese$/i].forEach(o.addUncountableRule),o})},function(e,t,n){t.dot=t.dotCase=n(123),t.swap=t.swapCase=n(124),t.path=t.pathCase=n(125),t.upper=t.upperCase=n(126),t.lower=t.lowerCase=n(127),t.camel=t.camelCase=n(128),t.snake=t.snakeCase=n(130),t.title=t.titleCase=n(132),t.param=t.paramCase=n(129),t.pascal=t.pascalCase=n(131),t.constant=t.constantCase=n(133),t.sentence=t.sentenceCase=n(134),t.isUpper=t.isUpperCase=n(135),t.isLower=t.isLowerCase=n(138),t.ucFirst=t.upperCaseFirst=n(136),t.lcFirst=t.lowerCaseFirst=n(137)},function(e,t,n){"use strict";function r(e){var t=new ie.Project(ae.dirname(e)),n=t.unit(ae.basename(e));return n&&n.isRAMLUnit()?X.fromUnit(n).wrapperNode():null}function i(e){var t=e.highLevel().lowLevel();if(Z.LowLevelProxyNode.isInstance(t))return e;var n=null!=e.highLevel().reusedNode()?Q:J;return n.expandTraitsAndResourceTypes(e)}function a(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==z.Universe08.Resource.name);return t}function o(e){var t="",n=e;do e=n,t=e.relativeUri().value()+t,n=e.parent();while(n.definition().key().name==z.Universe08.Resource.name);t=t.replace(/\/\//g,"/");var r=n.baseUri(),i=r?r.value():"";return i=i?i:"",te.stringEndsWith(i,"/")&&(t=t.substring(1)),t=i+t}function s(e){return X.qName(e.highLevel(),e.highLevel().root())}function u(e){return l(e)}function l(e){return f(e,function(e){return re.isTraitType(e)})}function p(e){return c(e)}function c(e){return f(e,function(e){return re.isResourceTypeType(e)})}function f(e,t){var n=ne.globalDeclarations(e.highLevel()).filter(function(e){return t(e.definition())}),r=e.highLevel().lowLevel();if(!r)return[];var i=r.includePath();i||(i=r.unit().path());var a=n.map(function(e){var t,n=e.lowLevel().unit().path();return n!=i?(t=H.buildWrapperNode(e,!1),t.meta().setCalculated()):t=e.wrapperNode(),t});return a}function d(e){var t=[],n=e;do e=n,t.push(e.relativeUri().value()),n=e.parent();while(n.definition().key().name==z.Universe08.Resource.name);return t.reverse()}function m(e){return Y.ResourceImpl.isInstance(e.parent())?e.parent():null}function h(e){var t=e.parent();return t.definition().key().name==z.Universe08.Resource.name,null}function y(e,t){if(null==e)return null;var n=e.resources();return n?(n=n.filter(function(e){return e.relativeUri().value()==t}),0==n.length?null:n[0]):null}function v(e,t){if(!e)return null;for(var n=null,r=0;r<t.length;r++){if(n=y(e,t[r]),!n)return null;e=n}return n}function g(e,t){return e?e.methods().filter(function(e){return e.method()==t}):null}function A(e,t,n){var r=v(e,t);return null==r?null:g(r,n)}function S(e){return e.definition().key().name==z.Universe08.Api.name}function E(e){for(var t=e;!S(t);)t=t.parent();return t}function T(e){var t=e.parent();if(Y.ResourceImpl.isInstance(t))return a(t)+" "+e.method().toLowerCase();if(Y.ResourceTypeImpl.isInstance(t))return t.name()+" "+e.method().toLowerCase();throw new Error("Method is supposed to be owned by Resource or ResourceType.\nHere the method is owned by "+e.definition().key().name)}function b(e){var t=e.code().value(),n=ee.validateResponseString(t);if(null!=n)return!1;try{if(parseInt(t.charAt(0))<4)return!0}catch(r){}return!1}function N(e){var t=[],n=function(e){t.push(e),e.resources().forEach(function(e){return n(e)})};return e.resources().forEach(function(e){return n(e)}),t}function _(e){return w(e)}function w(e){var t=e.relativeUri().value(),n=e.uriParameters_original(),r=z.Universe08.Resource.properties.uriParameters.name;return j(n,t,e,r)}function M(e){return I(e)}function I(e){var t=e.baseUri()?e.baseUri().value():"",n=e.baseUriParameters_original(),r=z.Universe08.Api.properties.baseUriParameters.name;return j(n,t,e,r)}function R(e){var t=[],n=e;do e=n,t=w(e).concat(t),n=e.parent();while(n.definition().key().name==z.Universe10.Resource.name);var r=n;r.baseUriParameters();return t=I(r).concat(t)}function C(e){return L(e)}function L(e){return e.protocols().map(function(e){return e.toUpperCase()})}function P(e){return O(e)}function O(e){return e.securedBy()}function D(e){var t=e.highLevel();if(!t)return"";var n=t.value();return n?n.toString():""}function x(e){var t=e.highLevel();if(!t)return null;var n=ne.findDeclarationByNode(t,ne.LocationKind.VALUE_COMPLETION);if(!n)return null;if(!n.getKind||n.getKind()!=G.NodeKind.NODE)return null;var r=n.wrapperNode();return Y.AbstractSecuritySchemeImpl.isInstance(r)?r:null}function U(e){return e.highLevel().definition().universe().version()}function k(e){var t=e.value().lowLevel();return new $.TypeInstanceImpl(t)}function F(e){var t=e.highLevel().value();return"string"==typeof t||null==t?t:t.valueName()}function B(e){return V(e)}function K(e){return V(e)}function V(e){var t=e.highLevel(),n=t.parent(),r=e.name(),i=ne.referenceTargets(t.property(),n).filter(function(e){return X.qName(e,n)==r});return 0==i.length?null:i[0].wrapperNode()}function j(e,t,n,r){var i=n.highLevel(),a=i.definition().property(r);if(!t)return[];var o={};e.forEach(function(e){var t=o[e.name()];t||(t=[],o[e.name()]=t),t.push(e)});for(var s=[],u=0,l={},p=t.indexOf("{");p>=0&&(u=t.indexOf("}",++p),!(0>u));p=t.indexOf("{",u)){var c=t.substring(p,u);if(l[c]=!0,o[c])o[c].forEach(function(e){return s.push(e)});else{var f=new Y.StringTypeDeclarationImpl(c);f.setName(c);var d=f.highLevel();d.setParent(i),f.meta().setCalculated(),d.patchProp(a),s.push(f)}}return Object.keys(o).filter(function(e){return!l[e]}).forEach(function(e){return o[e].forEach(function(e){return s.push(e)})}),s}function W(e){var t=e.schema();if(null==t)return null;var n=t.value();if(!n)return null;if(te.stringStartsWith(n,"{")||te.stringStartsWith(n,"[")||te.stringStartsWith(n,"<"))return n;var r=e.highLevel(),i=r.root(),a=i.elementsOfKind(z.Universe08.Api.properties.schemas.name),o=oe.find(a,function(e){return e.name()==n});if(!o)return n;if(!o.getKind||o.getKind()!=G.NodeKind.NODE)return n;if(o.definition().key()!=z.Universe08.GlobalSchema)return n;var s=o.attr(z.Universe08.GlobalSchema.properties.value.name);return null==s?null:s.value()}function q(e){var t=e.highLevel();if(null==t)return null;var n=t.lowLevel();if(null==n)return null;var r=n.children().filter(function(e){return e.key().indexOf("<<")>=0});if(0==r.length)return null;var i=new $.TypeInstanceImpl(r);return i}var Y=n(52),H=n(46),$=n(49),G=n(9),X=n(16),z=n(18),J=n(27),Q=n(30),Z=n(41),ee=n(28),te=n(33),ne=n(13),re=n(14),ie=n(24),ae=n(15),oe=n(65);t.load=r,t.expandTraitsAndResourceTypes=i,t.completeRelativeUri=a,t.absoluteUri=o,t.qName=s,t.traitsPrimary=u,t.allTraits=l,t.resourceTypesPrimary=p,t.allResourceTypes=c,t.relativeUriSegments=d,t.parentResource=m,t.parent=h,t.childResource=y,t.getResource=v,t.childMethod=g,t.getMethod=A,t.ownerApi=E,t.methodId=T,t.isOkRange=b,t.allResources=N;t.uriParametersPrimary=_,t.uriParameters=w,t.baseUriParametersPrimary=M,t.baseUriParameters=I,t.absoluteUriParameters=R,t.protocolsPrimary=C,t.allProtocols=L,t.securedByPrimary=P,t.allSecuredBy=O,t.securitySchemeName=D,t.securityScheme=x,t.RAMLVersion=U,t.structuredValue=k,t.referenceName=F,t.referencedTrait=B,t.referencedResourceType=K,t.schemaContent=W,t.getTemplateParametrizedProperties=q},function(e,t,n){"use strict";function r(e){return null==e}function i(e){return r(e)?"":String(e)}function a(e){return-1===[0,!1,"","0","false"].indexOf(e)}function o(e){return isFinite(e)?Number(e):null}function s(e){return e%1===0?Number(e):null}function u(e){return isNaN(Date.parse(e))?null:new Date(e)}function l(e,t,n){var i=Array.isArray(e)?e:[e],a=i.map(function(e){function i(e,t,n){for(var r=0;r<a.length;r++){var i=a[r],e=i(e,t,n);if(null!=e)return e}return null}var a=[],o=n[e.type];return"function"==typeof o&&a.push(o),Object.keys(e).filter(function(e){return"type"!==e&&"repeat"!==e&&"default"!==e}).forEach(function(n){var r=t[n];"function"==typeof r&&a.push(r(e[n],n))}),function(t,n,a){if(r(t))return null!=e["default"]?i(e["default"],n,a):e.repeat&&!e.required?[]:t;if(e.repeat){var o=Array.isArray(t)?t:[t];return o=o.map(function(e){return i(e,n,a)}),o.some(r)?null:t}if(Array.isArray(t)){if(t.length>1)return null;t=t[0]}return i(t,n,a)}});return function(e,t,n){for(var r=0;r<a.length;r++){var i=a[r],o=i(e,t,n);if(null!=o)return o}return e}}function p(){function e(e){return l(e,n,r)}var t,n={},r={string:i,number:o,integer:s,"boolean":a,date:u},p=function(e){if(!e)return function(){return{}};var t={};return Object.keys(e).forEach(function(n){t[n]=p.rule(e[n])}),function(e){e=e||{};var n={};return Object.keys(t).forEach(function(r){var i=e[r],a=t[r];Object.prototype.hasOwnProperty.call(e,r)&&(n[r]=a(i,r,e))}),n}};return t=p,t.rule=e,t.TYPES=r,t.RULES=n,t}t.sanitize=p},function(e,t,n){(function(e){"use strict";function n(e){return"[object Date]"===v.call(e)&&!isNaN(e.getTime())}function r(e){return"boolean"==typeof e}function i(e){return"string"==typeof e}function a(e){return"number"==typeof e&&e%1===0}function o(e){return"number"==typeof e&&isFinite(e)}function s(e){return function(t){return t>=e}}function u(e){return function(t){return e>=t}}function l(t){return function(n){return e.byteLength(n)>=t}}function p(t){return function(n){return e.byteLength(n)<=t}}function c(e){return e&&0!=e.length?function(t){return e.indexOf(t)>-1}:function(e){return!0}}function f(e){var t="string"==typeof e?new RegExp(e):e;return t.test.bind(t)}function d(e,t,n,r,i){return{valid:e,rule:r,attr:i,value:n,key:t}}function m(e,t){var n=[];return Object.keys(e).forEach(function(r){var i=t[r];if(i){var a=e[r];n.push([r,i(a,r),a])}}),function(e,t,r){for(var i=0;i<n.length;i++){var a=n[i],o=a[0],s=a[1],u=a[2],l=s(e,t,r);if(!l)return d(!1,t,e,o,u)}return d(!0,t,e)}}function h(e,t,n){var r=Array.isArray(e)?e:[e],i=!r.length,a=[],o=[];return r.forEach(function(e){var n=[e.type||"string",m(e,t)];e.required||(i=!0),e.repeat?o.push(n):a.push(n)}),function(e,t,r){if(null==e)return d(i,t,e,"required",!i);var s=Array.isArray(e),u=s?e:[e],l=s?o:a;if(!l.length)return d(!1,t,e,"repeat",!s);var p=null,c=e;return l.some(function(e){var i=u.every(function(i){var a=e[0],o=n[a]&&n[a](i,t,r);return o||(p=d(!1,t,c,"type",a)),o});return i?(u.every(function(n){var r=e[1];return p=r(n,t),p.valid}),!0):!1}),p}}function y(){function e(e){return h(e,m,d)}var t,d={date:n,number:o,integer:a,"boolean":r,string:i},m={minimum:s,maximum:u,minLength:l,maxLength:p,"enum":c,pattern:f},y=function(t){if(!t)return function(e){return{valid:!0,errors:[]}};var n={};return Object.keys(t).forEach(function(r){n[r]=e(t[r])}),function(e){e=e||{};var t=Object.keys(n).map(function(t){var r=e[t],i=n[t];return i(r,t,e)}).filter(function(e){return!e.valid});return{valid:0===t.length,errors:t}}};return t=y,t.rule=e,t.TYPES=d,t.RULES=m,t}var v=Object.prototype.toString;t.validate=y}).call(t,n(97).Buffer)},function(e,t,n){"use strict";function r(e,t){"MetaModel.declaresSubTypeOf"==e.name&&t.getAdapter(u.RAMLService).setExtendedTypeName(e.arguments[0]),"MetaModel.nameAtRuntime"==e.name&&t.setNameAtRuntime(e.arguments[0]),"MetaModel.description"==e.name&&t.withDescription(e.arguments[0]),"MetaModel.inlinedTemplates"==e.name&&t.getAdapter(u.RAMLService).setInlinedTemplates(!0),"MetaModel.requireValue"==e.name&&t.getAdapter(u.RAMLService).withContextRequirement(""+e.arguments[0],""+e.arguments[1]),"MetaModel.referenceIs"==e.name&&t.getAdapter(u.RAMLService).withReferenceIs(""+e.arguments[0]),"MetaModel.actuallyExports"==e.name&&t.getAdapter(u.RAMLService).withActuallyExports(""+e.arguments[0]),"MetaModel.convertsToGlobalOfType"==e.name&&t.getAdapter(u.RAMLService).withConvertsToGlobal(""+e.arguments[0]),"MetaModel.allowAny"==e.name&&t.getAdapter(u.RAMLService).withAllowAny(),"MetaModel.allowQuestion"==e.name&&t.getAdapter(u.RAMLService).withAllowQuestion(),"MetaModel.alias"==e.name&&t.getAdapter(u.RAMLService).addAlias(""+e.arguments[0]),"MetaModel.consumesRefs"==e.name&&t.getAdapter(u.RAMLService).setConsumesRefs(!0),"MetaModel.canInherit"==e.name&&t.getAdapter(u.RAMLService).withCanInherit(""+e.arguments[0]),"MetaModel.definingPropertyIsEnough"==e.name&&t.getAdapter(u.RAMLService).definingPropertyIsEnough(""+e.arguments[0]),"MetaModel.customHandling"==e.name&&t.setCustom(!0),"MetaModel.superclasses"==e.name&&t.getAdapter(u.RAMLService).registerSupertypes(e.arguments[0]),"MetaModel.possibleInterfaces"==e.name&&t.getAdapter(u.RAMLService).registerPossibleInterfaces(e.arguments[0])}function i(e,n){t.annotationHandlers[n.name](n,e)}var a=n(39),o=n(141),s=n(94),u=a;t.handleTypeAnnotation=r,t.annotationHandlers={key:function(e,t){t.withFromParentKey(),t.withKey(!0)},value:function(e,t){t.withFromParentValue()},canBeValue:function(e,t){t.withCanBeValue()},unmerged:function(e,t){t.unmerge()},startFrom:function(e,t){t.withKeyRestriction(e.arguments[0]),t.merge()},oneOf:function(e,t){t.withEnumOptions(e.arguments[0])},oftenKeys:function(e,t){t.withOftenKeys(e.arguments[0])},embeddedInMaps:function(e,t){t.getAdapter(u.RAMLPropertyParserService).withEmbedMap()},system:function(e,t){t.getAdapter(u.RAMLPropertyParserService).withSystem(!0)},required:function(e,t){"false"!=e.arguments[0]&&e.arguments[0]!==!1&&t.withRequired(!0)},noDirectParse:function(e,t){"false"!=e.arguments[0]&&e.arguments[0]!==!1&&t.withNoDirectParse()},setsContextValue:function(e,t){t.addChildValueConstraint(new a.ChildValueConstraint(""+e.arguments[0],""+e.arguments[1]))},defaultValue:function(e,t){t.setDefaultVal(""+e.arguments[0])},defaultIntegerValue:function(e,t){t.setDefaultIntegerVal(e.arguments[0])},defaultBooleanValue:function(e,t){t.setDefaultBooleanVal(e.arguments[0])},facetId:function(e,t){"minItems"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Array){var n=Number.parseInt(""+t.value());if(n>e.length)return"array should contain at least "+t.value()+" items"}return null}),"enum"==e.arguments[0]&&t.setFacetValidator(function(e,t){var n=e+"",r=t;try{if(!r.some(function(e){return e==n}))return"value should be one of :"+r.join(",")}catch(i){return}return null}),"maxItems"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Array){var n=Number.parseInt(""+t);if(n<e.length)return"array should contain not more then "+t.value()+" items"}return null}),"minProperties"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Object){var n=Number.parseInt(""+t);if(n>Object.keys(e).length)return"object should contain at least "+t.value()+" properties"}return null}),"maxProperties"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(e instanceof Object){var n=Number.parseInt(""+t);if(n<Object.keys(e).length)return"object should contain not more then "+t.value()+" properties"}return null}),"uniqueItems"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(t instanceof Array){var n=s.unique(t).length;if(n<t.length)return"array should contain only unique items"}return null}),"minLength"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(("number"==typeof e||"boolean"==typeof e)&&(e=""+e),"string"==typeof e){var n=Number.parseInt(""+t);if(n>e.length)return"string length should be at least "+n}return null}),"maxLength"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(("number"==typeof e||"boolean"==typeof e)&&(e=""+e),"string"==typeof e){var n=Number.parseInt(""+t);if(n<e.length)return"string length should be not more then "+n}return null}),"minimum"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("string"==typeof e&&(e=parseFloat(e)),"number"==typeof e){var n=parseFloat(t);if(n>e)return"value should be not less then "+n}return null}),"maximum"==e.arguments[0]&&t.setFacetValidator(function(e,t){if("string"==typeof e&&(e=parseFloat(e)),"number"==typeof e){var n=parseFloat(t);if(e>n)return"value should be not more then "+n}return null}),"pattern"==e.arguments[0]&&t.setFacetValidator(function(e,t){if(("number"==typeof e||"boolean"==typeof e)&&(e=""+e),"string"==typeof e){var n=new RegExp(t);if(!n.test(e))return"string should match to "+t}return null})},extraMetaKey:function(e,t){"statusCodes"==e.arguments[0]&&(t.withOftenKeys(o.statusCodes.filter(function(e){return e.code.indexOf("x")<0}).map(function(e){return e.code})),t.setValueDocProvider(function(e){var t=s.find(o.statusCodes,function(t){return t.code==e});return t?e+":"+t.description:null})),"headers"==e.arguments[0]&&(t.setValueSuggester(function(e){if(e.property()){var t=e.property().getChildValueConstraints();if(s.find(t,function(e){return"location"==e.name&&"Params.ParameterLocation.HEADERS"==e.value}))return o.headers.map(function(e){return e.header});if(e.property()&&"headers"==e.property().nameId())return o.headers.map(function(e){return e.header})}return null}),t.setValueDocProvider(function(e){var t=s.find(o.headers,function(t){return t.header==e});return t?e+":"+t.description:null})),"methods"==e.arguments[0]&&t.setValueDocProvider(function(e){var t=s.find(o.methods,function(t){return t.method==e.toUpperCase()});return t?e+":"+t.description:null})},requireValue:function(e,t){t.withContextRequirement(""+e.arguments[0],""+e.arguments[1])},allowMultiple:function(e,t){t.withMultiValue(!0)},constraint:function(e,t){},newInstanceName:function(e,t){t.withNewInstanceName(""+e.arguments[0])},declaringFields:function(e,t){t.withThisPropertyDeclaresFields()},describesAnnotation:function(e,t){t.withDescribes(e.arguments[0])},allowNull:function(e,t){t.withAllowNull()},descriminatingProperty:function(e,t){t.withDescriminating(!0)},description:function(e,t){t.withDescription(""+e.arguments[0])},inherited:function(e,t){t.withInherited(!0)},selfNode:function(e,t){t.withSelfNode()},grammarTokenKind:function(e,t){t.getAdapter(u.RAMLPropertyService).withPropertyGrammarType(""+e.arguments[0])},canInherit:function(e,t){t.withInheritedContextValue(""+e.arguments[0])},canBeDuplicator:function(e,t){t.setCanBeDuplicator()},example:function(e,t){t.getAdapter(u.RAMLPropertyService).setExample(!0)},typeExpression:function(e,t){t.getAdapter(u.RAMLPropertyService).setTypeExpression(!0)},hide:function(e,t){0==e.arguments.length?t.getAdapter(u.RAMLPropertyDocumentationService).setHidden(!0):t.getAdapter(u.RAMLPropertyDocumentationService).setHidden(e.arguments[0])},documentationTableLabel:function(e,t){t.getAdapter(u.RAMLPropertyDocumentationService).setDocTableName(""+e.arguments[0])},markdownDescription:function(e,t){t.getAdapter(u.RAMLPropertyDocumentationService).setMarkdownDescription(""+e.arguments[0])},valueDescription:function(e,t){t.getAdapter(u.RAMLPropertyDocumentationService).setValueDescription(null!=e.arguments[0]?""+e.arguments[0]:null)},customHandling:function(e,t){}},t.recordAnnotation=i},function(e,t,n){e.exports={34:{code:"34",message:""},1104:{code:"1104",message:""},1105:{code:"1105",message:""},1106:{code:"1106",message:""},1107:{code:"1107",message:""},1108:{code:"1108",message:""},1109:{code:"1109",message:""},1110:{code:"1110",message:""},CONTEXT_REQUIREMENT_VIOLATION:{code:"CONTEXT_REQUIREMENT_VIOLATION",message:"{{v1}} should be {{v2}} to use type {{v3}}"},INVALID_PARAMETER_NAME:{code:"INVALID_PARAMETER_NAME",message:"Invalid parameter name: '{{paramName}}' is reserved"},UNUSED_PARAMETER:{code:"UNUSED_PARAMETER",message:"Unused parameter: '{{paramName}}'"},INVALID_PROPERTY_OWNER_TYPE:{code:"INVALID_PROPERTY_OWNER_TYPE",message:"Property '{{propName}}' can only be used if type is {{namesStr}}"},NODE_KEY_IS_A_MAP:{code:"NODE_KEY_IS_A_MAP",message:"Node key can not be a map"},NODE_KEY_IS_A_SEQUENCE:{code:"NODE_KEY_IS_A_SEQUENCE",message:"Node key can not be a sequence"},SEQUENCE_REQUIRED:{code:"SEQUENCE_REQUIRED",message:"Node: '{{name}}' should be wrapped in sequence"},PROPERTY_MUST_BE_A_MAP_10:{code:"PROPERTY_MUST_BE_A_MAP_10",message:"'{{propName}}' should be a map in RAML 1.0"},PROPERTY_MUST_BE_A_MAP:{code:"PROPERTY_MUST_BE_A_MAP",message:"Property '{{propName}}' should be a map"},PROPERTY_MUST_BE_A_SEQUENCE:{code:"PROPERTY_MUST_BE_A_SEQUENCE",message:"Property '{{propName}}' should be a sequence"},INVALID_PROPERTY_RANGE:{code:"INVALID_PROPERTY_RANGE",message:"Property '{{propName}}' must be a {{range}}"},MAP_REQUIRED:{code:"MAP_REQUIRED",message:"should be a map in RAML 1.0"},UNRESOLVED_REFERENCE:{code:"UNRESOLVED_REFERENCE",message:"Reference: '{{ref}}' can not be resolved"},SCALAR_PROHIBITED:{code:"SCALAR_PROHIBITED",message:"Property '{{propName}}' can not have scalar value"},UNKNOWN_NODE:{code:"UNKNOWN_NODE",message:"Unknown node: '{{name}}'"},RECURSIVE_DEFINITION:{code:"RECURSIVE_DEFINITION",message:"Recursive definition: '{{name}}'"},PROPERTY_ALREADY_SPECIFIED:{code:"PROPERTY_ALREADY_SPECIFIED",message:"'{{propName}}' is already specified.`"},ISSUES_IN_THE_LIBRARY:{code:"ISSUES_IN_THE_LIBRARY",message:"Issues in the used library: '{{value}}'"},INVALID_LIBRARY_PATH:{code:"INVALID_LIBRARY_PATH",message:"Can not resolve library from path: '{{path}}'"},EMPTY_FILE:{code:"EMPTY_FILE",message:"Empty file: {{path}}"},SPACES_IN_KEY:{code:"SPACES_IN_KEY",message:"Keys should not have spaces '{{value}}'"},INCLUDE_ERROR:{code:"INCLUDE_ERROR",message:"{{msg}}"},PATH_EXCEEDS_ROOT:{code:"PATH_EXCEEDS_ROOT",message:"Resolved include path exceeds file system root"},ILLEGAL_PATTERN:{code:"ILLEGAL_PATTERN",message:"Illegal pattern: '{{value}}'"},UNKNOWN_FUNCTION:{code:"UNKNOWN_FUNCTION",message:"Unknown function applied to parameter: '{{transformerName}}'"},REQUEST_BODY_DISABLED:{code:"REQUEST_BODY_DISABLED",message:"Request body is disabled for '{{methodName}}' method."},SCALAR_EXPECTED:{code:"SCALAR_EXPECTED",message:"Scalar is expected here"},STRING_EXPECTED:{code:"STRING_EXPECTED",message:"Property '{{propName}}' must be a string"},UNKNOWN_ANNOTATION:{code:"UNKNOWN_ANNOTATION",message:"Unknown annotation: '{{aName}}'"},STRING_EXPECTED_2:{code:"STRING_EXPECTED_2",message:"{{propName}} value should be a string"},SECUREDBY_LIST_08:{code:"SECUREDBY_LIST_08",message:"'securedBy' should be a list in RAML08"},INVALID_ANNOTATION_LOCATION:{code:"INVALID_ANNOTATION_LOCATION",message:"Annotation '{{aName}}' can not be placed at this location, allowed targets are: {{aValues}}"},BOOLEAN_EXPECTED:{code:"BOOLEAN_EXPECTED",message:"'true' or 'false' is expected here"},NUMBER_EXPECTED:{code:"NUMBER_EXPECTED",message:"Value of '{{propName}}' must be a number"},STRING_EXPECTED_3:{code:"STRING_EXPECTED_3",message:"'{{propName}}' must be a string"},STATUS_MUST_BE_3NUMBER:{code:"STATUS_MUST_BE_3NUMBER",message:"Status code should be 3 digits number."},EMPTY_VALUE_NOT_ALLOWED:{code:"EMPTY_VALUE_NOT_ALLOWED",message:"Empty value is not allowed here"},INVALID_VALUE_SCHEMA:{code:"INVALID_VALUE_SCHEMA",message:"Invalid value schema: '{{iValue}}'"},INVALID_VALUE:{code:"INVALID_VALUE",message:"Invalid value: '{{iValue}}'. Allowed values are: {{aValues}}"},SCHEMA_EXCEPTION:{code:"SCHEMA_EXCEPTION",message:"Schema exception: {{msg}}"},SCHEMA_ERROR:{code:"SCHEMA_ERROR",message:"{{msg}}"},MISSING_VERSION:{code:"MISSING_VERSION",message:"Missing 'version'"},URI_PARAMETER_NAME_MISSING:{code:"URI_PARAMETER_NAME_MISSING",message:"URI parameter must have name specified"},URI_EXCEPTION:{code:"URI_EXCEPTION",message:"{{msg}}"},INVALID_MEDIATYPE:{code:"INVALID_MEDIATYPE",message:"Invalid media type '{{mediaType}}'"},MEDIATYPE_EXCEPTION:{code:"MEDIATYPE_EXCEPTION",message:"{{msg}}"},FORM_IN_RESPONSE:{code:"FORM_IN_RESPONSE",message:"Form related media types can not be used in responses"},UNUSED_URL_PARAMETER:{code:"UNUSED_URL_PARAMETER",message:"Unused url parameter {{paramName}}"},UNRECOGNIZED_ELEMENT:{code:"UNRECOGNIZED_ELEMENT",message:"Unrecognized {{referencedToName}}: '{{ref}}'."},TYPES_VARIETY_RESTRICTION:{code:"TYPES_VARIETY_RESTRICTION",message:"Type can be either of: string, number, integer, file, date or boolean"},UNRECOGNIZED_SECURITY_SCHEME:{code:"UNRECOGNIZED_SECURITY_SCHEME",message:"Unrecognized security scheme type: '{{ref}}'. Allowed values are: 'OAuth 1.0', 'OAuth 2.0', 'Basic Authentication', 'DigestSecurityScheme Authentication', 'x-{other}'"},DUPLICATE_TRAIT_REFERENCE:{code:"DUPLICATE_TRAIT_REFERENCE",message:"Duplicate trait reference: '{{refValue}}'."},IS_IS_ARRAY:{code:"IS_IS_ARRAY",message:"Property 'is' must be an array"},RESOURCE_TYPE_NAME:{code:"RESOURCE_TYPE_NAME",message:"Resource type name must be provided"},MULTIPLE_RESOURCE_TYPES:{code:"MULTIPLE_RESOURCE_TYPES",message:"A resource or resourceType can inherit from a single resourceType"},UNKNOWN_RAML_VERSION:{code:"UNKNOWN_RAML_VERSION",message:"Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'"},UNKNOWN_TOPL_LEVEL_TYPE:{code:"UNKNOWN_TOPL_LEVEL_TYPE",message:"Unknown top level type: '{{typeName}}'"},REDUNDANT_FRAGMENT_NAME:{code:"REDUNDANT_FRAGMENT_NAME",message:"Redundant fragment name: '{{typeName}}'"},WEB_FORMS:{code:"WEB_FORMS",message:"File type can be only used in web forms"},MISSING_REQUIRED_PROPERTY:{code:"MISSING_REQUIRED_PROPERTY",message:"Missing required property '{{propName}}'"},VALUE_NOT_PROVIDED:{code:"VALUE_NOT_PROVIDED",message:"Value is not provided for parameter: '{{propName}}'"},SUSPICIOUS_DOUBLEQUOTE:{code:"SUSPICIOUS_DOUBLEQUOTE",message:'Suspicious double quoted multiline scalar, it is likely that you forgot closing "{{value}}'},ANNOTATION_TARGET_MUST_BE_A_STRING:{code:"ANNOTATION_TARGET_MUST_BE_A_STRING",message:"Annotation target must be set by a string"},ALLOWED_TARGETS_MUST_BE_ARRAY:{code:"ALLOWED_TARGETS_MUST_BE_ARRAY",message:"'allowedTargets' property value must be an array of type names or a single type name"},UNSUPPORTED_ANNOTATION_TARGET:{code:"UNSUPPORTED_ANNOTATION_TARGET",message:"Unsupported annotation target: '{{aTarget}}'"},SCHEMA_NAME_MUST_BE_STRING:{code:"SCHEMA_NAME_MUST_BE_STRING",message:"Schema '{{name}}' must be a string"},FORM_PARAMS_IN_RESPONSE:{code:"FORM_PARAMS_IN_RESPONSE",message:"Form parameters can not be used in response"},FORM_PARAMS_WITH_EXAMPLE:{code:"FORM_PARAMS_WITH_EXAMPLE",message:"'formParameters' property cannot be used together with the 'example' or 'schema' properties"},AUTHORIZATION_GRANTS_ENUM:{code:"AUTHORIZATION_GRANTS_ENUM",message:"'authorizationGrants' value should be one of 'authorization_code', 'implicit', 'password', 'client_credentials' or to be an abolute URI"},AUTHORIZATION_URI_REQUIRED:{code:"AUTHORIZATION_URI_REQUIRED",message:"'authorizationUri' is required when `authorization_code` or `implicit` grant type are used "},REPEATING_COMPONENTS_IN_ENUM:{code:"REPEATING_COMPONENTS_IN_ENUM",message:"'enum' value contains repeating components"},INTEGER_EXPECTED:{code:"INTEGER_EXPECTED",message:"Integer is expected"},NUMBER_EXPECTED_2:{code:"NUMBER_EXPECTED_2",message:"Number is expected"},RESOURCE_TYPE_NULL:{code:"RESOURCE_TYPE_NULL",message:"Resource type can not be null"},SCALAR_PROHIBITED_2:{code:"SCALAR_PROHIBITED_2",message:"Node '{{name}}' can not be a scalar"},VERSION_NOT_ALLOWED:{code:"VERSION_NOT_ALLOWED",message:"'version' parameter not allowed here",comment:"I dont like the message, but its coming from JS 0.8 parser @Denis"},INVALID_OVERLAY_NODE:{code:"INVALID_OVERLAY_NODE",message:"The '{{nodeId}}' node does not match any node of the master api."},INVALID_OVERRIDE_IN_OVERLAY:{code:"INVALID_OVERRIDE_IN_OVERLAY",message:"Property '{{propName}}' is not allowed to be overriden or added in overlays"},KEYS_SHOULD_BE_UNIQUE:{code:"KEYS_SHOULD_BE_UNIQUE",message:"Keys should be unique"},ALREADY_EXISTS:{code:"ALREADY_EXISTS",message:"{{capitalized}} '{{name}}' already exists"},ALREADY_EXISTS_IN_CONTEXT:{code:"ALREADY_EXISTS_IN_CONTEXT",message:"{{name}}' already exists in this context"},PROPERTY_USED:{code:"PROPERTY_USED",message:"Property already used: '{{propName}}'"},PARENT_PROPERTY_USED:{code:"PARENT_PROPERTY_USED",message:"{{parent}} property already used: '{{propName}}'"},INVALID_JSON_SCHEMA:{code:"INVALID_JSON_SCHEMA",message:"Invalid JSON schema. Unexpected value '{{propName}}'"},EXAMPLE_SCHEMA_FAILURE:{code:"EXAMPLE_SCHEMA_FAILURE",message:"Example does not conform to schema: {{msg}}"},CAN_NOT_PARSE_JSON:{code:"CAN_NOT_PARSE_JSON",message:"Can not parse JSON: {{msg}}"},CAN_NOT_PARSE_XML:{code:"CAN_NOT_PARSE_XML",message:"Can not parse XML: {{msg}}"},OPTIONAL_SCLARAR_PROPERTIES_10:{code:"OPTIONAL_SCLARAR_PROPERTIES_10",message:"Optional scalar properties are not allowed in {{templateNamePlural}} and their descendants: '{{propName}}?'"},OPTIONAL_PROPERTIES_10:{code:"OPTIONAL_PROPERTIES_10",message:"Optional properties are not allowed in '{{propName}}': '{{oPropName}}'"},ONLY_METHODS_CAN_BE_OPTIONAL:{code:"ONLY_METHODS_CAN_BE_OPTIONAL",message:"Only method nodes can be optional"},PROPERTY_UNUSED:{code:"PROPERTY_UNUSED",message:"{{propName}} unused"},CYCLE_IN_DEFINITION:{code:"CYCLE_IN_DEFINITION",message:"{{typeName}} definition contains cycle: {{cycle}}"},SEQUENCE_NOT_ALLOWED_10:{code:"SEQUENCE_NOT_ALLOWED_10",message:"In RAML 1.0 {{propName}} is not allowed to have sequence as definition"},MAP_EXPECTED:{code:"MAP_EXPECTED",message:"Map is expected here"},ERROR_IN_INCLUDED_FILE:{code:"ERROR_IN_INCLUDED_FILE",message:"Error in the included file: {{msg}}"},NODE_SHOULD_HAVE_VALUE:{code:"NODE_SHOULD_HAVE_VALUE",message:"node should have at least one member value"},NAMED_PARAMETER_NEEDS_TYPE:{code:"NAMED_PARAMETER_NEEDS_TYPE",message:"named parameter needs at least one type"},ENUM_IS_EMPTY:{code:"ENUM_IS_EMPTY",message:"enum is empty"},ENUM_MUST_BE_AN_ARRAY:{code:"ENUM_MUST_BE_AN_ARRAY",message:"the value of enum must be an array"},DEFINITION_SHOULD_BE_A_MAP:{code:"DEFINITION_SHOULD_BE_A_MAP",message:"{{typeName}} definition should be a map"},RESOURCES_SHARE_SAME_URI:{code:"RESOURCES_SHARE_SAME_URI",message:"Resources share same URI"},TYPES_AND_SCHEMAS_ARE_EXCLUSIVE:{code:"TYPES_AND_SCHEMAS_ARE_EXCLUSIVE",message:"'types' and 'schemas' are mutually exclusive"},TEMPLATE_PARAMETER_NAME_MUST_CONTAIN_NONWHITESPACE_CHARACTERS:{code:"TEMPLATE_PARAMETER_NAME_MUST_CONTAIN_NONWHITESPACE_CHARACTERS",message:"Trait or resource type parameter name must contain non whitespace characters"},INVALID_SECURITY_SCHEME_SCOPE:{code:"INVALID_SECURITY_SCHEME_SCOPE",message:"The '{{invalidScope}}' scope is not allowed for the '{{securityScheme}}' security scheme. Allowed scopes are: {{allowedScopes}}."}}},function(e,t,n){(function(e){
(function(){var r,i=[].slice;r=n(120),t.allowUnsafeEval=function(t){var n;n=e.eval;try{return e.eval=function(e){return r.runInThisContext(e)},t()}finally{e.eval=n}},t.allowUnsafeNewFunction=function(n){var r;r=e.Function;try{return e.Function=t.Function,n()}finally{e.Function=r}},t.Function=function(){var e,t,n,a,o,s,u;for(n=2<=arguments.length?i.call(arguments,0,o=arguments.length-1):(o=0,[]),e=arguments[o++],a=[],s=0,u=n.length;u>s;s++)t=n[s],"string"==typeof t&&(t=t.split(/\s*,\s*/)),a.push.apply(a,t);return r.runInThisContext("(function("+a.join(", ")+") {\n  "+e+"\n})")},t.Function.prototype=e.Function.prototype}).call(this)}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(){return C}function i(e){return e instanceof T.AbstractType}function a(e,t){return void 0===t&&(t=T.builtInRegistry()),b.parseJSONTypeCollection(e,t)}function o(e){return b.parseJSON(null,e,T.builtInRegistry())}function s(e){return e.types||e.annotationTypes?b.parseJSONTypeCollection(e):b.parseJSON(null,e)}function u(e,t){return b.parseJSON(null,e,t?t.getTypeRegistry():T.builtInRegistry())}function l(e){return b.parseTypeCollection(e,T.builtInRegistry())}function p(e,t,n,r,i,a,o){if(void 0===r&&(r=!1),void 0===i&&(i=!1),void 0===a&&(a=!0),void 0===o&&(o=!1),a){var s;if(s=i?n.getAnnotationType(e):n.getType(e),null!=s)return s}return b.parse(e,t,n?n.getTypeRegistry():T.builtInRegistry(),r,i,a,o)}function c(e){return b.storeAsJSON(e)}function f(e,t,n){void 0===n&&(n=!1),T.autoCloseFlag=n;try{return t.validate(e,n)}finally{T.autoCloseFlag=!1}}function d(e,t){return e.validateType(t.getAnnotationTypeRegistry())}function m(e,t){return t.ac(e)}function h(e){return e.canDoAc()}function y(){return N.getInstance().allPrototypes()}function v(){return T.builtInRegistry()}function g(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return T.derive(e,t)}function A(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return T.union(e,t)}function S(e){R.setPropertyConstructor(e)}function E(e,t){return R.toNominal(e,t)}var T=n(100);t.tsInterfaces=n(101);var b=n(102),N=n(103),_=n(104),w=n(105),M=n(105),I=n(105),R=n(106);t.nominalTypes=n(107),t.nominalInterfaces=n(108),t.typeExpressions=n(109);var C=n(110);t.TOP_LEVEL_EXTRA=t.tsInterfaces.TOP_LEVEL_EXTRA,t.DEFINED_IN_TYPES_EXTRA=t.tsInterfaces.DEFINED_IN_TYPES_EXTRA,t.USER_DEFINED_EXTRA=t.tsInterfaces.USER_DEFINED_EXTRA,t.SOURCE_EXTRA=t.tsInterfaces.SOURCE_EXTRA,t.getSchemaUtils=r,t.isParsedType=i,t.loadTypeCollection=a,t.loadType=o,t.parse=s,t.parseType=u,function(e){e[e.SCALAR=0]="SCALAR",e[e.ARRAY=1]="ARRAY",e[e.MAP=2]="MAP"}(t.NodeKind||(t.NodeKind={}));t.NodeKind;t.parseFromAST=l,t.parseTypeFromAST=p,t.dump=c,t.validate=f,t.validateTypeDefinition=d,t.performAC=m,t.checkACStatus=h,t.builtInFacets=y,t.builtInTypes=v,t.derive=g,t.unify=A;var L=function(){function e(e){this.target=e}return e.prototype.addProperty=function(e,t,n){return this.target.declareProperty(e,t,n),this},e.prototype.closeType=function(){return this.target.addMeta(new _.KnownPropertyRestriction(!1)),this},e.prototype.annotate=function(e,t){return this.target.addMeta(new w.Annotation(e,t)),this},e.prototype.customFacet=function(e,t){return this.target.addMeta(new M.CustomFacet(e,t)),this},e.prototype.customFacetDeclaration=function(e,t,n){return void 0===n&&(n=!0),this.target.addMeta(new I.FacetDeclaration(e,t,n)),this},e.prototype.addSimpleFacet=function(e,t){return this.target.addMeta(N.getInstance().buildFacet(e,t)),this},e.prototype.getResult=function(){return this.target},e}();t.TypeConstructor=L,t.setPropertyConstructor=S,t.toNominal=E},function(e,t,n){"use strict";t.decode=t.parse=n(98),t.encode=t.stringify=n(99)},function(e,t,n){var r;(function(e,i){!function(a){function o(e){throw RangeError(P[e])}function s(e,t){for(var n=e.length,r=[];n--;)r[n]=t(e[n]);return r}function u(e,t){var n=e.split("@"),r="";n.length>1&&(r=n[0]+"@",e=n[1]),e=e.replace(L,".");var i=e.split("."),a=s(i,t).join(".");return r+a}function l(e){for(var t,n,r=[],i=0,a=e.length;a>i;)t=e.charCodeAt(i++),t>=55296&&56319>=t&&a>i?(n=e.charCodeAt(i++),56320==(64512&n)?r.push(((1023&t)<<10)+(1023&n)+65536):(r.push(t),i--)):r.push(t);return r}function p(e){return s(e,function(e){var t="";return e>65535&&(e-=65536,t+=x(e>>>10&1023|55296),e=56320|1023&e),t+=x(e)}).join("")}function c(e){return 10>e-48?e-22:26>e-65?e-65:26>e-97?e-97:E}function f(e,t){return e+22+75*(26>e)-((0!=t)<<5)}function d(e,t,n){var r=0;for(e=n?D(e/_):e>>1,e+=D(e/t);e>O*b>>1;r+=E)e=D(e/O);return D(r+(O+1)*e/(e+N))}function m(e){var t,n,r,i,a,s,u,l,f,m,h=[],y=e.length,v=0,g=M,A=w;for(n=e.lastIndexOf(I),0>n&&(n=0),r=0;n>r;++r)e.charCodeAt(r)>=128&&o("not-basic"),h.push(e.charCodeAt(r));for(i=n>0?n+1:0;y>i;){for(a=v,s=1,u=E;i>=y&&o("invalid-input"),l=c(e.charCodeAt(i++)),(l>=E||l>D((S-v)/s))&&o("overflow"),v+=l*s,f=A>=u?T:u>=A+b?b:u-A,!(f>l);u+=E)m=E-f,s>D(S/m)&&o("overflow"),s*=m;t=h.length+1,A=d(v-a,t,0==a),D(v/t)>S-g&&o("overflow"),g+=D(v/t),v%=t,h.splice(v++,0,g)}return p(h)}function h(e){var t,n,r,i,a,s,u,p,c,m,h,y,v,g,A,N=[];for(e=l(e),y=e.length,t=M,n=0,a=w,s=0;y>s;++s)h=e[s],128>h&&N.push(x(h));for(r=i=N.length,i&&N.push(I);y>r;){for(u=S,s=0;y>s;++s)h=e[s],h>=t&&u>h&&(u=h);for(v=r+1,u-t>D((S-n)/v)&&o("overflow"),n+=(u-t)*v,t=u,s=0;y>s;++s)if(h=e[s],t>h&&++n>S&&o("overflow"),h==t){for(p=n,c=E;m=a>=c?T:c>=a+b?b:c-a,!(m>p);c+=E)A=p-m,g=E-m,N.push(x(f(m+A%g,0))),p=D(A/g);N.push(x(f(p,0))),a=d(n,v,r==i),n=0,++r}++n,++t}return N.join("")}function y(e){return u(e,function(e){return R.test(e)?m(e.slice(4).toLowerCase()):e})}function v(e){return u(e,function(e){return C.test(e)?"xn--"+h(e):e})}var g=("object"==typeof t&&t&&!t.nodeType&&t,"object"==typeof e&&e&&!e.nodeType&&e,"object"==typeof i&&i);(g.global===g||g.window===g||g.self===g)&&(a=g);var A,S=2147483647,E=36,T=1,b=26,N=38,_=700,w=72,M=128,I="-",R=/^xn--/,C=/[^\x20-\x7E]/,L=/[\x2E\u3002\uFF0E\uFF61]/g,P={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},O=E-T,D=Math.floor,x=String.fromCharCode;A={version:"1.3.2",ucs2:{decode:l,encode:p},decode:m,encode:h,toASCII:v,toUnicode:y},r=function(){return A}.call(t,n,t,e),!(void 0!==r&&(e.exports=r))}(this)}).call(t,n(149)(e),function(){return this}())},function(e,t,n){"use strict";function r(e){return 10===e||13===e}function i(e){return 9===e||32===e}function a(e){return 9===e||32===e||10===e||13===e}function o(e){return 44===e||91===e||93===e||123===e||125===e}function s(e){var t;return e>=48&&57>=e?e-48:(t=32|e,t>=97&&102>=t?t-97+10:-1)}function u(e){return 120===e?2:117===e?4:85===e?8:0}function l(e){return e>=48&&57>=e?e-48:-1}function p(e){return 48===e?"\x00":97===e?"":98===e?"\b":116===e?"	":9===e?"	":110===e?"\n":118===e?"":102===e?"\f":114===e?"\r":101===e?"":32===e?" ":34===e?'"':47===e?"/":92===e?"\\":78===e?"":95===e?" ":76===e?"\u2028":80===e?"\u2029":""}function c(e){return 65535>=e?String.fromCharCode(e):String.fromCharCode((e-65536>>10)+55296,(e-65536&1023)+56320)}function f(e,t){return new j(t,new W(e.filename,e.input,e.position,e.line-1,e.position-e.lineStart))}function d(e,t,n){var r=A(e,t);if(r){var i=n+t;if(!e.errorMap[i]){var a=new W(e.filename,e.input,t,r.line-1,t-r.start),o=new j(n,a);e.errors.push(o)}}}function m(e,t){var n=f(e,t),r=n.message+n.mark.position;e.errorMap[r]||(e.errors.push(n),e.errorMap[r]=1);for(var i=e.position;;){if(e.position>=e.input.length-1)return;var a=e.input.charAt(e.position);if("\n"==a)return e.position--,void(e.position==i&&(e.position+=1));if("\r"==a)return e.position--,void(e.position==i&&(e.position+=1));e.position++}}function h(e,t){var n=f(e,t);e.onWarning&&e.onWarning.call(null,n)}function y(e,t,n,r){var i,a,o,s,u=e.result;if(-1==u.startPosition&&(u.startPosition=t),n>=t){if(s=e.input.slice(t,n),r)for(i=0,a=s.length;a>i;i+=1)o=s.charCodeAt(i),9===o||o>=32&&1114111>=o||m(e,"expected valid JSON character");u.value+=s,u.endPosition=n}}function v(e,t,n,r,i){if(null!=r){null===t&&(t={startPosition:r.startPosition,endPosition:i.endPosition,parent:null,errors:[],mappings:[],kind:K.Kind.MAP});var a=K.newMapping(r,i);return a.parent=t,r.parent=a,null!=i&&(i.parent=a),!e.ignoreDuplicateKeys&&t.mappings.forEach(function(t){t.key&&t.key.value===(a.key&&a.key.value)&&(d(e,a.key.startPosition,"duplicate key"),d(e,t.key.startPosition,"duplicate key"))}),t.mappings.push(a),t.endPosition=i?i.endPosition:r.endPosition+1,t}}function g(e){var t;t=e.input.charCodeAt(e.position),10===t?e.position++:13===t?(e.position++,10===e.input.charCodeAt(e.position)&&e.position++):m(e,"a line break is expected"),e.line+=1,e.lineStart=e.position,e.lines.push({start:e.lineStart,line:e.line})}function A(e,t){for(var n,r=0;r<e.lines.length&&!(e.lines[r].start>t);r++)n=e.lines[r];return n?n:{start:0,line:0}}function S(e,t,n){for(var a=0,o=e.input.charCodeAt(e.position);0!==o;){for(;i(o);)o=e.input.charCodeAt(++e.position);if(t&&35===o)do o=e.input.charCodeAt(++e.position);while(10!==o&&13!==o&&0!==o);if(!r(o))break;for(g(e),o=e.input.charCodeAt(e.position),a++,e.lineIndent=0;32===o;)e.lineIndent++,o=e.input.charCodeAt(++e.position)}return-1!==n&&0!==a&&e.lineIndent<n&&h(e,"deficient indentation"),a}function E(e){var t,n=e.position;return t=e.input.charCodeAt(n),45!==t&&46!==t||e.input.charCodeAt(n+1)!==t||e.input.charCodeAt(n+2)!==t||(n+=3,t=e.input.charCodeAt(n),0!==t&&!a(t))?!1:!0}function T(e,t,n){1===n?t.value+=" ":n>1&&(t.value+=V.repeat("\n",n-1))}function b(e,t,n){var s,u,l,p,c,f,d,m,h,v=e.kind,g=e.result,A=K.newScalar();if(A.plainScalar=!0,e.result=A,h=e.input.charCodeAt(e.position),a(h)||o(h)||35===h||38===h||42===h||33===h||124===h||62===h||39===h||34===h||37===h||64===h||96===h)return!1;if((63===h||45===h)&&(u=e.input.charCodeAt(e.position+1),a(u)||n&&o(u)))return!1;for(e.kind="scalar",l=p=e.position,c=!1;0!==h;){if(58===h){if(u=e.input.charCodeAt(e.position+1),a(u)||n&&o(u))break}else if(35===h){if(s=e.input.charCodeAt(e.position-1),a(s))break}else{if(e.position===e.lineStart&&E(e)||n&&o(h))break;if(r(h)){if(f=e.line,d=e.lineStart,m=e.lineIndent,S(e,!1,-1),e.lineIndent>=t){c=!0,h=e.input.charCodeAt(e.position);continue}e.position=p,e.line=f,e.lineStart=d,e.lineIndent=m;break}}if(c&&(y(e,l,p,!1),T(e,A,e.line-f),l=p=e.position,c=!1),i(h)||(p=e.position+1),h=e.input.charCodeAt(++e.position),e.position>=e.input.length)return!1}return y(e,l,p,!1),-1!=e.result.startPosition?(A.rawValue=e.input.substring(A.startPosition,A.endPosition),!0):(e.kind=v,e.result=g,!1)}function N(e,t){var n,i,a;if(n=e.input.charCodeAt(e.position),39!==n)return!1;var o=K.newScalar();for(e.kind="scalar",e.result=o,o.startPosition=e.position,e.position++,i=a=e.position;0!==(n=e.input.charCodeAt(e.position));)if(39===n){if(y(e,i,e.position,!0),n=e.input.charCodeAt(++e.position),o.endPosition=e.position,39!==n)return!0;i=a=e.position,e.position++}else r(n)?(y(e,i,a,!0),T(e,o,S(e,!1,t)),i=a=e.position):e.position===e.lineStart&&E(e)?m(e,"unexpected end of the document within a single quoted scalar"):(e.position++,a=e.position,o.endPosition=e.position);m(e,"unexpected end of the stream within a single quoted scalar")}function _(e,t){var n,i,a,o,l,p;if(p=e.input.charCodeAt(e.position),34!==p)return!1;e.kind="scalar";var f=K.newScalar();for(f.doubleQuoted=!0,e.result=f,f.startPosition=e.position,e.position++,n=i=e.position;0!==(p=e.input.charCodeAt(e.position));){if(34===p)return y(e,n,e.position,!0),e.position++,f.endPosition=e.position,f.rawValue=e.input.substring(f.startPosition,f.endPosition),!0;if(92===p){if(y(e,n,e.position,!0),p=e.input.charCodeAt(++e.position),r(p))S(e,!1,t);else if(256>p&&(e.allowAnyEscape?se[p]:ae[p]))f.value+=e.allowAnyEscape?ue[p]:oe[p],e.position++;else if((l=u(p))>0){for(a=l,o=0;a>0;a--)p=e.input.charCodeAt(++e.position),(l=s(p))>=0?o=(o<<4)+l:m(e,"expected hexadecimal character");f.value+=c(o),e.position++}else m(e,"unknown escape sequence");n=i=e.position}else r(p)?(y(e,n,i,!0),T(e,f,S(e,!1,t)),n=i=e.position):e.position===e.lineStart&&E(e)?m(e,"unexpected end of the document within a double quoted scalar"):(e.position++,i=e.position)}m(e,"unexpected end of the stream within a double quoted scalar")}function w(e,t){var n,r,i,o,s,u,l,p,c,f,d,h=!0,y=e.tag,g=e.anchor;if(d=e.input.charCodeAt(e.position),91===d)o=93,l=!1,r=K.newItems(),r.startPosition=e.position;else{if(123!==d)return!1;o=125,l=!0,r=K.newMap(),r.startPosition=e.position}for(null!==e.anchor&&(r.anchorId=e.anchor,e.anchorMap[e.anchor]=r),d=e.input.charCodeAt(++e.position);0!==d;){if(S(e,!0,t),d=e.input.charCodeAt(e.position),d===o)return e.position++,e.tag=y,e.anchor=g,e.kind=l?"mapping":"sequence",e.result=r,r.endPosition=e.position,!0;if(!h){var A=e.position;m(e,"missed comma between flow collection entries"),e.position=A+1}if(c=p=f=null,s=u=!1,63===d&&(i=e.input.charCodeAt(e.position+1),a(i)&&(s=u=!0,e.position++,S(e,!0,t))),n=e.line,O(e,t,$,!1,!0),c=e.tag,p=e.result,S(e,!0,t),d=e.input.charCodeAt(e.position),!u&&e.line!==n||58!==d||(s=!0,d=e.input.charCodeAt(++e.position),S(e,!0,t),O(e,t,$,!1,!0),f=e.result),l)v(e,r,c,p,f);else if(s){var E=v(e,null,c,p,f);E.parent=r,r.items.push(E)}else p.parent=r,r.items.push(p);r.endPosition=e.position+1,S(e,!0,t),d=e.input.charCodeAt(e.position),44===d?(h=!0,d=e.input.charCodeAt(++e.position)):h=!1}m(e,"unexpected end of the stream within a flow collection")}function M(e,t){var n,a,o,s,u=J,p=!1,c=t,f=0,d=!1;if(s=e.input.charCodeAt(e.position),124===s)a=!1;else{if(62!==s)return!1;a=!0}var h=K.newScalar();for(e.kind="scalar",e.result=h,h.startPosition=e.position;0!==s;)if(s=e.input.charCodeAt(++e.position),43===s||45===s)J===u?u=43===s?Z:Q:m(e,"repeat of a chomping mode identifier");else{if(!((o=l(s))>=0))break;0===o?m(e,"bad explicit indentation width of a block scalar; it cannot be less than one"):p?m(e,"repeat of an indentation width identifier"):(c=t+o-1,p=!0)}if(i(s)){do s=e.input.charCodeAt(++e.position);while(i(s));if(35===s)do s=e.input.charCodeAt(++e.position);while(!r(s)&&0!==s)}for(;0!==s;){for(g(e),e.lineIndent=0,s=e.input.charCodeAt(e.position);(!p||e.lineIndent<c)&&32===s;)e.lineIndent++,s=e.input.charCodeAt(++e.position);if(!p&&e.lineIndent>c&&(c=e.lineIndent),r(s))f++;else{if(e.lineIndent<c){u===Z?h.value+=V.repeat("\n",f):u===J&&p&&(h.value+="\n");break}for(a?i(s)?(d=!0,h.value+=V.repeat("\n",f+1)):d?(d=!1,h.value+=V.repeat("\n",f+1)):0===f?p&&(h.value+=" "):h.value+=V.repeat("\n",f):p&&(h.value+=V.repeat("\n",f+1)),p=!0,f=0,n=e.position;!r(s)&&0!==s;)s=e.input.charCodeAt(++e.position);y(e,n,e.position,!1)}}h.endPosition=e.position;for(var v=e.position-1,A=!1;;){var S=e.input[v];if("\r"==S||"\n"==S){A&&v--;break}if(" "!=S&&"	"!=S)break;v--}return h.endPosition=v,h.rawValue=e.input.substring(h.startPosition,h.endPosition),!0}function I(e,t){var n,r,i,o=e.tag,s=e.anchor,u=K.newItems(),l=!1;for(null!==e.anchor&&(u.anchorId=e.anchor,e.anchorMap[e.anchor]=u),u.startPosition=e.position,i=e.input.charCodeAt(e.position);0!==i&&45===i&&(r=e.input.charCodeAt(e.position+1),a(r));)if(l=!0,e.position++,S(e,!0,-1)&&e.lineIndent<=t)u.items.push(null),i=e.input.charCodeAt(e.position);else if(n=e.line,O(e,t,X,!1,!0),e.result.parent=u,u.items.push(e.result),S(e,!0,-1),i=e.input.charCodeAt(e.position),(e.line===n||e.lineIndent>t)&&0!==i)m(e,"bad indentation of a sequence entry");else if(e.lineIndent<t)break;return u.endPosition=e.position,l?(e.tag=o,e.anchor=s,e.kind="sequence",e.result=u,u.endPosition=e.position,!0):!1}function R(e,t,n){var o,s,u,l,p=e.tag,c=e.anchor,f=K.newMap(),d=null,h=null,y=null,g=!1,A=!1;for(f.startPosition=e.position,null!==e.anchor&&(f.anchorId=e.anchor,e.anchorMap[e.anchor]=f),l=e.input.charCodeAt(e.position);0!==l;){if(o=e.input.charCodeAt(e.position+1),u=e.line,63!==l&&58!==l||!a(o)){if(!O(e,n,G,!1,!0))break;if(e.line===u){for(l=e.input.charCodeAt(e.position);i(l);)l=e.input.charCodeAt(++e.position);if(58===l)l=e.input.charCodeAt(++e.position),a(l)||m(e,"a whitespace character is expected after the key-value separator within a block mapping"),g&&(v(e,f,d,h,null),d=h=y=null),A=!0,g=!1,s=!1,d=e.tag,h=e.result;else{if(!A)return e.tag=p,e.anchor=c,!0;m(e,"can not read an implicit mapping pair; a colon is missed")}}else{if(!A)return e.tag=p,e.anchor=c,!0;for(m(e,"can not read a block mapping entry; a multiline key may not be an implicit key");e.position>0;)if(l=e.input.charCodeAt(--e.position),r(l)){e.position++;break}}}else 63===l?(g&&(v(e,f,d,h,null),d=h=y=null),A=!0,g=!0,s=!0):g?(g=!1,s=!0):m(e,"incomplete explicit mapping pair; a key node is missed"),e.position+=1,l=o;if((e.line===u||e.lineIndent>t)&&(O(e,t,z,!0,s)&&(g?h=e.result:y=e.result),g||(v(e,f,d,h,y),d=h=y=null),S(e,!0,-1),l=e.input.charCodeAt(e.position)),e.lineIndent>t&&0!==l)m(e,"bad indentation of a mapping entry");else if(e.lineIndent<t)break}return g&&v(e,f,d,h,null),A&&(e.tag=p,e.anchor=c,e.kind="mapping",e.result=f),A}function C(e){var t,n,r,i,o=!1,s=!1;if(i=e.input.charCodeAt(e.position),33!==i)return!1;if(null!==e.tag&&m(e,"duplication of a tag property"),i=e.input.charCodeAt(++e.position),60===i?(o=!0,i=e.input.charCodeAt(++e.position)):33===i?(s=!0,n="!!",i=e.input.charCodeAt(++e.position)):n="!",t=e.position,o){do i=e.input.charCodeAt(++e.position);while(0!==i&&62!==i);e.position<e.length?(r=e.input.slice(t,e.position),i=e.input.charCodeAt(++e.position)):m(e,"unexpected end of the stream within a verbatim tag")}else{for(;0!==i&&!a(i);)33===i&&(s?m(e,"tag suffix cannot contain exclamation marks"):(n=e.input.slice(t-1,e.position+1),re.test(n)||m(e,"named tag handle cannot contain such characters"),s=!0,t=e.position+1)),i=e.input.charCodeAt(++e.position);r=e.input.slice(t,e.position),ne.test(r)&&m(e,"tag suffix cannot contain flow indicator characters")}return r&&!ie.test(r)&&m(e,"tag name cannot contain such characters: "+r),o?e.tag=r:H.call(e.tagMap,n)?e.tag=e.tagMap[n]+r:"!"===n?e.tag="!"+r:"!!"===n?e.tag="tag:yaml.org,2002:"+r:m(e,'undeclared tag handle "'+n+'"'),!0}function L(e){var t,n;if(n=e.input.charCodeAt(e.position),38!==n)return!1;for(null!==e.anchor&&m(e,"duplication of an anchor property"),n=e.input.charCodeAt(++e.position),t=e.position;0!==n&&!a(n)&&!o(n);)n=e.input.charCodeAt(++e.position);return e.position===t&&m(e,"name of an anchor node must contain at least one character"),e.anchor=e.input.slice(t,e.position),!0}function P(e){var t,n,r;e.length,e.input;if(r=e.input.charCodeAt(e.position),42!==r)return!1;for(r=e.input.charCodeAt(++e.position),t=e.position;0!==r&&!a(r)&&!o(r);)r=e.input.charCodeAt(++e.position);return e.position<=t&&(m(e,"name of an alias node must contain at least one character"),e.position=t+1),n=e.input.slice(t,e.position),e.anchorMap.hasOwnProperty(n)||(m(e,'unidentified alias "'+n+'"'),e.position<=t&&(e.position=t+1)),e.result=K.newAnchorRef(n,t,e.position,e.anchorMap[n]),S(e,!0,-1),!0}function O(e,t,n,r,i){var a,o,s,u,l,p,c,f,d=1,y=!1,v=!1;if(e.tag=null,e.anchor=null,e.kind=null,e.result=null,a=o=s=z===n||X===n,r&&S(e,!0,-1)&&(y=!0,e.lineIndent>t?d=1:e.lineIndent===t?d=0:e.lineIndent<t&&(d=-1)),1===d)for(;C(e)||L(e);)S(e,!0,-1)?(y=!0,s=a,e.lineIndent>t?d=1:e.lineIndent===t?d=0:e.lineIndent<t&&(d=-1)):s=!1;if(s&&(s=y||i),(1===d||z===n)&&(c=$===n||G===n?t:t+1,f=e.position-e.lineStart,1===d?s&&(I(e,f)||R(e,f,c))||w(e,c)?v=!0:(o&&M(e,c)||N(e,c)||_(e,c)?v=!0:P(e)?(v=!0,(null!==e.tag||null!==e.anchor)&&m(e,"alias node should not have any properties")):b(e,c,$===n)&&(v=!0,null===e.tag&&(e.tag="?")),null!==e.anchor&&(e.anchorMap[e.anchor]=e.result,e.result.anchorId=e.anchor)):0===d&&(v=s&&I(e,f))),null!==e.tag&&"!"!==e.tag)if("!include"==e.tag)e.result||(e.result=K.newScalar(),e.result.startPosition=e.position,e.result.endPosition=e.position,m(e,"!include without value")),e.result.kind=K.Kind.INCLUDE_REF;else if("?"===e.tag)for(u=0,l=e.implicitTypes.length;l>u;u+=1){p=e.implicitTypes[u];var g=e.result.value;if(p.resolve(g)){e.result.valueObject=p.construct(e.result.value),e.tag=p.tag,null!==e.anchor&&(e.result.anchorId=e.anchor,e.anchorMap[e.anchor]=e.result);break}}else H.call(e.typeMap,e.tag)?(p=e.typeMap[e.tag],null!==e.result&&p.kind!==e.kind&&m(e,"unacceptable node kind for !<"+e.tag+'> tag; it should be "'+p.kind+'", not "'+e.kind+'"'),p.resolve(e.result)?(e.result=p.construct(e.result),null!==e.anchor&&(e.result.anchorId=e.anchor,e.anchorMap[e.anchor]=e.result)):m(e,"cannot resolve a node with !<"+e.tag+"> explicit tag")):h(e,"unknown tag !<"+e.tag+">");return null!==e.tag||null!==e.anchor||v}function D(e){var t,n,o,s,u=e.position,l=!1;for(e.version=null,e.checkLineBreaks=e.legacy,e.tagMap={},e.anchorMap={};0!==(s=e.input.charCodeAt(e.position))&&(S(e,!0,-1),s=e.input.charCodeAt(e.position),!(e.lineIndent>0||37!==s));){for(l=!0,s=e.input.charCodeAt(++e.position),t=e.position;0!==s&&!a(s);)s=e.input.charCodeAt(++e.position);for(n=e.input.slice(t,e.position),o=[],n.length<1&&m(e,"directive name must not be less than one character in length");0!==s;){for(;i(s);)s=e.input.charCodeAt(++e.position);if(35===s){do s=e.input.charCodeAt(++e.position);while(0!==s&&!r(s));break}if(r(s))break;for(t=e.position;0!==s&&!a(s);)s=e.input.charCodeAt(++e.position);o.push(e.input.slice(t,e.position))}0!==s&&g(e),H.call(ce,n)?ce[n](e,n,o):(h(e,'unknown document directive "'+n+'"'),e.position++)}return S(e,!0,-1),0===e.lineIndent&&45===e.input.charCodeAt(e.position)&&45===e.input.charCodeAt(e.position+1)&&45===e.input.charCodeAt(e.position+2)?(e.position+=3,S(e,!0,-1)):l&&m(e,"directives end mark is expected"),O(e,e.lineIndent-1,z,!1,!0),S(e,!0,-1),e.checkLineBreaks&&te.test(e.input.slice(u,e.position))&&h(e,"non-ASCII line breaks are interpreted as content"),e.documents.push(e.result),e.position===e.lineStart&&E(e)?void(46===e.input.charCodeAt(e.position)&&(e.position+=3,S(e,!0,-1))):void(e.position<e.length-1&&m(e,"end of the stream or a document separator is expected"))}function x(e,t){e=String(e),t=t||{},0!==e.length&&(10!==e.charCodeAt(e.length-1)&&13!==e.charCodeAt(e.length-1)&&(e+="\n"),65279===e.charCodeAt(0)&&(e=e.slice(1)));var n=new pe(e,t);for(ee.test(n.input)&&m(n,"the stream contains non-printable characters"),n.input+="\x00";32===n.input.charCodeAt(n.position);)n.lineIndent+=1,n.position+=1;for(;n.position<n.length-1;){var r=n.position;if(D(n),n.position<=r)for(;n.position<n.length-1;n.position++){var i=n.input.charAt(n.position);if("\n"==i)break}}return n.documents.forEach(function(e){return e.errors=n.errors}),n.documents}function U(e,t,n){var r,i,a=x(e,n);for(r=0,i=a.length;i>r;r+=1)t(a[r])}function k(e,t){var n=x(e,t);if(0===n.length)return void 0;if(1===n.length){var r=n[0];return r.endPosition=e.length,r.startPosition>r.endPosition&&(r.startPosition=r.endPosition),r}var i=new j("expected a single document in the stream, but found more");return i.mark=new W("","",0,0,0),i.mark.position=n[0].endPosition,n[0].errors.push(i),n[0]}function F(e,t,n){U(e,t,V.extend({schema:q},n))}function B(e,t){return k(e,V.extend({schema:q},t))}for(var K=n(113),V=n(114),j=n(115),W=n(116),q=n(121),Y=n(122),H=Object.prototype.hasOwnProperty,$=1,G=2,X=3,z=4,J=1,Q=2,Z=3,ee=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uD800-\uDFFF\uFFFE\uFFFF]/,te=/[\x85\u2028\u2029]/,ne=/[,\[\]\{\}]/,re=/^(?:!|!!|![a-z\-]+!)$/i,ie=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i,ae=new Array(256),oe=new Array(256),se=new Array(256),ue=new Array(256),le=0;256>le;le++)ue[le]=oe[le]=p(le),ae[le]=oe[le]?1:0,se[le]=1,ae[le]||(ue[le]="\\"+String.fromCharCode(le));var pe=function(){function e(e,t){this.errorMap={},this.errors=[],this.lines=[],this.input=e,this.filename=t.filename||null,this.schema=t.schema||Y,this.onWarning=t.onWarning||null,this.legacy=t.legacy||!1,this.allowAnyEscape=t.allowAnyEscape||!1,this.ignoreDuplicateKeys=t.ignoreDuplicateKeys||!1,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=e.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.documents=[]}return e}(),ce={YAML:function(e,t,n){var r,i,a;null!==e.version&&m(e,"duplication of %YAML directive"),1!==n.length&&m(e,"YAML directive accepts exactly one argument"),r=/^([0-9]+)\.([0-9]+)$/.exec(n[0]),null===r&&m(e,"ill-formed argument of the YAML directive"),i=parseInt(r[1],10),a=parseInt(r[2],10),1!==i&&m(e,"found incompatible YAML document (version 1.2 is required)"),e.version=n[0],e.checkLineBreaks=2>a,2!==a&&m(e,"found incompatible YAML document (version 1.2 is required)")},TAG:function(e,t,n){var r,i;2!==n.length&&m(e,"TAG directive accepts exactly two arguments"),r=n[0],i=n[1],re.test(r)||m(e,"ill-formed tag handle (first argument) of the TAG directive"),H.call(e.tagMap,r)&&m(e,'there is a previously declared suffix for "'+r+'" tag handle'),ie.test(i)||m(e,"ill-formed tag prefix (second argument) of the TAG directive"),e.tagMap[r]=i}};(function(){function e(){}return e})();t.loadAll=U,t.load=k,t.safeLoadAll=F,t.safeLoad=B,e.exports.loadAll=U,e.exports.load=k,e.exports.safeLoadAll=F,e.exports.safeLoad=B},function(e,t,n){"use strict";function r(e,t){var n,r,i,a,o,s,u;if(null===t)return{};for(n={},r=Object.keys(t),i=0,a=r.length;a>i;i+=1)o=r[i],s=String(t[o]),"!!"===o.slice(0,2)&&(o="tag:yaml.org,2002:"+o.slice(2)),u=e.compiledTypeMap[o],u&&C.call(u.styleAliases,s)&&(s=u.styleAliases[s]),n[o]=s;return n}function i(e){var t,n,r;if(t=e.toString(16).toUpperCase(),255>=e)n="x",r=2;else if(65535>=e)n="u",r=4;else{if(!(4294967295>=e))throw new w("code point within a string may not be greater than 0xFFFFFFFF");n="U",r=8}return"\\"+n+_.repeat("0",r-t.length)+t}function a(e){this.schema=e.schema||M,this.indent=Math.max(1,e.indent||2),this.skipInvalid=e.skipInvalid||!1,this.flowLevel=_.isNothing(e.flowLevel)?-1:e.flowLevel,this.styleMap=r(this.schema,e.styles||null),this.implicitTypes=this.schema.compiledImplicit,this.explicitTypes=this.schema.compiledExplicit,this.tag=null,this.result="",this.duplicates=[],this.usedDuplicates=null}function o(e,t){for(var n,r=_.repeat(" ",t),i=0,a=-1,o="",s=e.length;s>i;)a=e.indexOf("\n",i),-1===a?(n=e.slice(i),i=s):(n=e.slice(i,a+1),i=a+1),n.length&&"\n"!==n&&(o+=r),o+=n;return o}function s(e,t){return"\n"+_.repeat(" ",e.indent*t)}function u(e,t){var n,r,i;for(n=0,r=e.implicitTypes.length;r>n;n+=1)if(i=e.implicitTypes[n],i.resolve(t))return!0;return!1}function l(e){this.source=e,this.result="",this.checkpoint=0}function p(e,t,n){var r,i,a,s,p,f,h,y,v,g,A,S,E,T,b,N,_,w,M,I,R;if(0===t.length)return void(e.dump="''");if(0==t.indexOf("!include"))return void(e.dump=""+t);if(0==t.indexOf("!$$$novalue"))return void(e.dump="");if(-1!==te.indexOf(t))return void(e.dump="'"+t+"'");for(r=!0,i=t.length?t.charCodeAt(0):0,a=D===i||D===t.charCodeAt(t.length-1),(W===i||H===i||$===i||z===i)&&(r=!1),a?(r=!1,s=!1,p=!1):(s=!0,p=!0),f=!0,h=new l(t),y=!1,v=0,g=0,A=e.indent*n,S=80,40>A?S-=A:S=40,T=0;T<t.length;T++){if(E=t.charCodeAt(T),r){if(d(E))continue;r=!1}f&&E===K&&(f=!1),b=ee[E],N=m(E),(b||N)&&(E!==P&&E!==U&&E!==K?(s=!1,p=!1):E===P&&(y=!0,f=!1,T>0&&(_=t.charCodeAt(T-1),_===D&&(p=!1,s=!1)),s&&(w=T-v,v=T,w>g&&(g=w))),E!==U&&(f=!1),h.takeUpTo(T),h.escapeChar())}if(r&&u(e,t)&&(r=!1),M="",(s||p)&&(I=0,t.charCodeAt(t.length-1)===P&&(I+=1,t.charCodeAt(t.length-2)===P&&(I+=1)),0===I?M="-":2===I&&(M="+")),p&&S>g&&(s=!1),y||(p=!1),r)e.dump=t;else if(f)e.dump="'"+t+"'";else if(s)R=c(t,S),e.dump=">"+M+"\n"+o(R,A);else if(p)M||(t=t.replace(/\n$/,"")),e.dump="|"+M+"\n"+o(t,A);else{if(!h)throw new Error("Failed to dump scalar value");h.finish(),e.dump='"'+h.result+'"'}}function c(e,t){var n,r="",i=0,a=e.length,o=/\n+$/.exec(e);for(o&&(a=o.index+1);a>i;)n=e.indexOf("\n",i),n>a||-1===n?(r&&(r+="\n\n"),r+=f(e.slice(i,a),t),i=a):(r&&(r+="\n\n"),r+=f(e.slice(i,n),t),i=n+1);return o&&"\n"!==o[0]&&(r+=o[0]),r}function f(e,t){if(""===e)return e;for(var n,r,i,a=/[^\s] [^\s]/g,o="",s=0,u=0,l=a.exec(e);l;)n=l.index,n-u>t&&(r=s!==u?s:n,o&&(o+="\n"),i=e.slice(u,r),o+=i,u=r+1),s=n+1,l=a.exec(e);return o&&(o+="\n"),o+=u!==s&&e.length-u>t?e.slice(u,s)+"\n"+e.slice(s+1):e.slice(u)}function d(e){return L!==e&&P!==e&&O!==e&&j!==e&&G!==e&&X!==e&&J!==e&&Z!==e&&k!==e&&B!==e&&V!==e&&x!==e&&Q!==e&&Y!==e&&K!==e&&U!==e&&F!==e&&q!==e&&!ee[e]&&!m(e)}function m(e){return!(e>=32&&126>=e||133===e||e>=160&&55295>=e||e>=57344&&65533>=e||e>=65536&&1114111>=e)}function h(e,t,n){var r,i,a="",o=e.tag;for(r=0,i=n.length;i>r;r+=1)S(e,t,n[r],!1,!1)&&(0!==r&&(a+=", "),a+=e.dump);e.tag=o,e.dump="["+a+"]"}function y(e,t,n,r){var i,a,o="",u=e.tag;for(i=0,a=n.length;a>i;i+=1)S(e,t+1,n[i],!0,!0)&&(r&&0===i||(o+=s(e,t)),o+="- "+e.dump);e.tag=u,e.dump=o||"[]"}function v(e,t,n){var r,i,a,o,s,u="",l=e.tag,p=Object.keys(n);for(r=0,i=p.length;i>r;r+=1)s="",0!==r&&(s+=", "),a=p[r],o=n[a],S(e,t,a,!1,!1)&&(e.dump.length>1024&&(s+="? "),s+=e.dump+": ",S(e,t,o,!1,!1)&&(s+=e.dump,u+=s));e.tag=l,e.dump="{"+u+"}"}function g(e,t,n,r){var i,a,o,u,l,p,c="",f=e.tag,d=Object.keys(n);for(i=0,a=d.length;a>i;i+=1)p="",r&&0===i||(p+=s(e,t)),o=d[i],u=n[o],S(e,t+1,o,!0,!0)&&(l=null!==e.tag&&"?"!==e.tag||e.dump&&e.dump.length>1024,l&&(p+=e.dump&&P===e.dump.charCodeAt(0)?"?":"? "),p+=e.dump,l&&(p+=s(e,t)),S(e,t+1,u,!0,l)&&(p+=e.dump&&P===e.dump.charCodeAt(0)?":":": ",p+=e.dump,c+=p));e.tag=f,e.dump=c||"{}"}function A(e,t,n){var r,i,a,o,s,u;for(i=n?e.explicitTypes:e.implicitTypes,a=0,o=i.length;o>a;a+=1)if(s=i[a],(s.instanceOf||s.predicate)&&(!s.instanceOf||"object"==typeof t&&t instanceof s.instanceOf)&&(!s.predicate||s.predicate(t))){if(e.tag=n?s.tag:"?",s.represent){if(u=e.styleMap[s.tag]||s.defaultStyle,"[object Function]"===R.call(s.represent))r=s.represent(t,u);else{if(!C.call(s.represent,u))throw new w("!<"+s.tag+'> tag resolver accepts not "'+u+'" style');r=s.represent[u](t,u)}e.dump=r}return!0}return!1}function S(e,t,n,r,i){e.tag=null,e.dump=n,A(e,n,!1)||A(e,n,!0);var a=R.call(e.dump);r&&(r=0>e.flowLevel||e.flowLevel>t),(null!==e.tag&&"?"!==e.tag||2!==e.indent&&t>0)&&(i=!1);var o,s,u="[object Object]"===a||"[object Array]"===a;if(u&&(o=e.duplicates.indexOf(n),s=-1!==o),s&&e.usedDuplicates[o])e.dump="*ref_"+o;else{if(u&&s&&!e.usedDuplicates[o]&&(e.usedDuplicates[o]=!0),"[object Object]"===a)r&&0!==Object.keys(e.dump).length?(g(e,t,e.dump,i),s&&(e.dump="&ref_"+o+(0===t?"\n":"")+e.dump)):(v(e,t,e.dump),s&&(e.dump="&ref_"+o+" "+e.dump));else if("[object Array]"===a)r&&0!==e.dump.length?(y(e,t,e.dump,i),s&&(e.dump="&ref_"+o+(0===t?"\n":"")+e.dump)):(h(e,t,e.dump),s&&(e.dump="&ref_"+o+" "+e.dump));else{if("[object String]"!==a){if(e.skipInvalid)return!1;throw new w("unacceptable kind of an object to dump "+a)}"?"!==e.tag&&p(e,e.dump,t)}null!==e.tag&&"?"!==e.tag&&(e.dump="!<"+e.tag+"> "+e.dump)}return!0}function E(e,t){var n,r,i=[],a=[];for(T(e,i,a),n=0,r=a.length;r>n;n+=1)t.duplicates.push(i[a[n]]);t.usedDuplicates=new Array(r)}function T(e,t,n){var r,i,a;R.call(e);if(null!==e&&"object"==typeof e)if(i=t.indexOf(e),-1!==i)-1===n.indexOf(i)&&n.push(i);else if(t.push(e),Array.isArray(e))for(i=0,a=e.length;a>i;i+=1)T(e[i],t,n);else for(r=Object.keys(e),i=0,a=r.length;a>i;i+=1)T(e[r[i]],t,n)}function b(e,t){t=t||{};var n=new a(t);return E(e,n),S(n,0,e,!0,!0)?n.dump+"\n":""}function N(e,t){return b(e,_.extend({schema:I},t))}var _=n(114),w=n(115),M=n(122),I=n(121),R=Object.prototype.toString,C=Object.prototype.hasOwnProperty,L=9,P=10,O=13,D=32,x=33,U=34,k=35,F=37,B=38,K=39,V=42,j=44,W=45,q=58,Y=62,H=63,$=64,G=91,X=93,z=96,J=123,Q=124,Z=125,ee={};ee[0]="\\0",ee[7]="\\a",ee[8]="\\b",ee[9]="\\t",ee[10]="\\n",ee[11]="\\v",ee[12]="\\f",ee[13]="\\r",ee[27]="\\e",ee[34]='\\"',ee[92]="\\\\",ee[133]="\\N",ee[160]="\\_",ee[8232]="\\L",ee[8233]="\\P";var te=["y","Y","yes","Yes","YES","on","On","ON","n","N","no","No","NO","off","Off","OFF"];l.prototype.takeUpTo=function(e){var t;if(e<this.checkpoint)throw t=new Error("position should be > checkpoint"),t.position=e,t.checkpoint=this.checkpoint,t;return this.result+=this.source.slice(this.checkpoint,e),this.checkpoint=e,this},l.prototype.escapeChar=function(){var e,t;return e=this.source.charCodeAt(this.checkpoint),
t=ee[e]||i(e),this.result+=t,this.checkpoint+=1,this},l.prototype.finish=function(){this.source.length>this.checkpoint&&this.takeUpTo(this.source.length)},t.dump=b,t.safeDump=N},function(e,t,n){function r(){}function i(e,t,n,r,i){function p(e){if(e>65535){e-=65536;var t=55296+(e>>10),n=56320+(1023&e);return String.fromCharCode(t,n)}return String.fromCharCode(e)}function m(e){var t=e.slice(1,-1);return t in n?n[t]:"#"===t.charAt(0)?p(parseInt(t.substr(1).replace("x","0x"))):(i.error("entity not found:"+e),e)}function h(t){if(t>b){var n=e.substring(b,t).replace(/&#?\w+;/g,m);S&&y(b),r.characters(n,0,t-b),b=t}}function y(t,n){for(;t>=g&&(n=A.exec(e));)v=n.index,g=v+n[0].length,S.lineNumber++;S.columnNumber=t-v+1}for(var v=0,g=0,A=/.*(?:\r\n?|\n)|.*$/g,S=r.locator,E=[{currentNSMap:t}],T={},b=0;;){try{var N=e.indexOf("<",b);if(0>N){if(!e.substr(b).match(/^\s*$/)){var _=r.doc,w=_.createTextNode(e.substr(b));_.appendChild(w),r.currentElement=w}return}switch(N>b&&h(N),e.charAt(N+1)){case"/":var M=e.indexOf(">",N+3),I=e.substring(N+2,M),R=E.pop();0>M?(I=e.substring(N+2).replace(/[\s<].*/,""),i.error("end tag name: "+I+" is not complete:"+R.tagName),M=N+1+I.length):I.match(/\s</)&&(I=I.replace(/[\s<].*/,""),i.error("end tag name: "+I+" maybe not complete"),M=N+1+I.length);var C=R.localNSMap,L=R.tagName==I,P=L||R.tagName&&R.tagName.toLowerCase()==I.toLowerCase();if(P){if(r.endElement(R.uri,R.localName,I),C)for(var O in C)r.endPrefixMapping(O);L||i.fatalError("end tag name: "+I+" is not match the current start tagName:"+R.tagName)}else E.push(R);M++;break;case"?":S&&y(N),M=f(e,N,r);break;case"!":S&&y(N),M=c(e,N,r,i);break;default:S&&y(N);var D=new d,x=E[E.length-1].currentNSMap,M=o(e,N,D,x,m,i),U=D.length;if(!D.closed&&l(e,M,D.tagName,T)&&(D.closed=!0,n.nbsp||i.warning("unclosed xml attribute")),S&&U){for(var k=a(S,{}),F=0;U>F;F++){var B=D[F];y(B.offset),B.locator=a(S,{})}r.locator=k,s(D,r,x)&&E.push(D),r.locator=S}else s(D,r,x)&&E.push(D);"http://www.w3.org/1999/xhtml"!==D.uri||D.closed?M++:M=u(e,M,D.tagName,m,r)}}catch(K){i.error("element parse error: "+K),M=-1}M>b?b=M:h(Math.max(N,b)+1)}}function a(e,t){return t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber,t}function o(e,t,n,r,i,a){for(var o,s,u=++t,l=A;;){var p=e.charAt(u);switch(p){case"=":if(l===S)o=e.slice(t,u),l=T;else{if(l!==E)throw new Error("attribute equal must after attrName");l=T}break;case"'":case'"':if(l===T||l===S){if(l===S&&(a.warning('attribute value must after "="'),o=e.slice(t,u)),t=u+1,u=e.indexOf(p,t),!(u>0))throw new Error("attribute value no end '"+p+"' match");s=e.slice(t,u).replace(/&#?\w+;/g,i),n.add(o,s,t-1),l=N}else{if(l!=b)throw new Error('attribute value must after "="');s=e.slice(t,u).replace(/&#?\w+;/g,i),n.add(o,s,t),a.warning('attribute "'+o+'" missed start quot('+p+")!!"),t=u+1,l=N}break;case"/":switch(l){case A:n.setTagName(e.slice(t,u));case N:case _:case w:l=w,n.closed=!0;case b:case S:case E:break;default:throw new Error("attribute invalid close char('/')")}break;case"":return a.error("unexpected end of input"),l==A&&n.setTagName(e.slice(t,u)),u;case">":switch(l){case A:n.setTagName(e.slice(t,u));case N:case _:case w:break;case b:case S:s=e.slice(t,u),"/"===s.slice(-1)&&(n.closed=!0,s=s.slice(0,-1));case E:l===E&&(s=o),l==b?(a.warning('attribute "'+s+'" missed quot(")!!'),n.add(o,s.replace(/&#?\w+;/g,i),t)):("http://www.w3.org/1999/xhtml"===r[""]&&s.match(/^(?:disabled|checked|selected)$/i)||a.warning('attribute "'+s+'" missed value!! "'+s+'" instead!!'),n.add(s,s,t));break;case T:throw new Error("attribute value missed!!")}return u;case"":p=" ";default:if(" ">=p)switch(l){case A:n.setTagName(e.slice(t,u)),l=_;break;case S:o=e.slice(t,u),l=E;break;case b:var s=e.slice(t,u).replace(/&#?\w+;/g,i);a.warning('attribute "'+s+'" missed quot(")!!'),n.add(o,s,t);case N:l=_}else switch(l){case E:n.tagName;"http://www.w3.org/1999/xhtml"===r[""]&&o.match(/^(?:disabled|checked|selected)$/i)||a.warning('attribute "'+o+'" missed value!! "'+o+'" instead2!!'),n.add(o,o,t),t=u,l=S;break;case N:a.warning('attribute space is required"'+o+'"!!');case _:l=S,t=u;break;case T:l=b,t=u;break;case w:throw new Error("elements closed character '/' and '>' must be connected to")}}u++}}function s(e,t,n){for(var r=e.tagName,i=null,a=e.length;a--;){var o=e[a],s=o.qName,u=o.value,l=s.indexOf(":");if(l>0)var c=o.prefix=s.slice(0,l),f=s.slice(l+1),d="xmlns"===c&&f;else f=s,c=null,d="xmlns"===s&&"";o.localName=f,d!==!1&&(null==i&&(i={},p(n,n={})),n[d]=i[d]=u,o.uri="http://www.w3.org/2000/xmlns/",t.startPrefixMapping(d,u))}for(var a=e.length;a--;){o=e[a];var c=o.prefix;c&&("xml"===c&&(o.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==c&&(o.uri=n[c||""]))}var l=r.indexOf(":");l>0?(c=e.prefix=r.slice(0,l),f=e.localName=r.slice(l+1)):(c=null,f=e.localName=r);var m=e.uri=n[c||""];if(t.startElement(m,f,r,e),!e.closed)return e.currentNSMap=n,e.localNSMap=i,!0;if(t.endElement(m,f,r),i)for(c in i)t.endPrefixMapping(c)}function u(e,t,n,r,i){if(/^(?:script|textarea)$/i.test(n)){var a=e.indexOf("</"+n+">",t),o=e.substring(t+1,a);if(/[&<]/.test(o))return/^script$/i.test(n)?(i.characters(o,0,o.length),a):(o=o.replace(/&#?\w+;/g,r),i.characters(o,0,o.length),a)}return t+1}function l(e,t,n,r){var i=r[n];return null==i&&(i=e.lastIndexOf("</"+n+">"),t>i&&(i=e.lastIndexOf("</"+n)),r[n]=i),t>i}function p(e,t){for(var n in e)t[n]=e[n]}function c(e,t,n,r){var i=e.charAt(t+2);switch(i){case"-":if("-"===e.charAt(t+3)){var a=e.indexOf("-->",t+4);return a>t?(n.comment(e,t+4,a-t-4),a+3):(r.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==e.substr(t+3,6)){var a=e.indexOf("]]>",t+9);return n.startCDATA(),n.characters(e,t+9,a-t-9),n.endCDATA(),a+3}var o=h(e,t),s=o.length;if(s>1&&/!doctype/i.test(o[0][0])){var u=o[1][0],l=s>3&&/^public$/i.test(o[2][0])&&o[3][0],p=s>4&&o[4][0],c=o[s-1];return n.startDTD(u,l&&l.replace(/^(['"])(.*?)\1$/,"$2"),p&&p.replace(/^(['"])(.*?)\1$/,"$2")),n.endDTD(),c.index+c[0].length}}return-1}function f(e,t,n){var r=e.indexOf("?>",t);if(r){var i=e.substring(t,r).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(i){i[0].length;return n.processingInstruction(i[1],i[2]),r+2}return-1}return-1}function d(e){}function m(e,t){return e.__proto__=t,e}function h(e,t){var n,r=[],i=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(i.lastIndex=t,i.exec(e);n=i.exec(e);)if(r.push(n),n[1])return r}var y=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,v=new RegExp("[\\-\\.0-9"+y.source.slice(1,-1)+"\\u00B7\\u0300-\\u036F\\u203F-\\u2040]"),g=new RegExp("^"+y.source+v.source+"*(?::"+y.source+v.source+"*)?$"),A=0,S=1,E=2,T=3,b=4,N=5,_=6,w=7;r.prototype={parse:function(e,t,n){var r=this.domBuilder;r.startDocument(),p(t,t={}),i(e,t,n,r,this.errorHandler),r.endDocument()}},d.prototype={setTagName:function(e){if(!g.test(e))throw new Error("invalid tagName:"+e);this.tagName=e},add:function(e,t,n){if(!g.test(e))throw new Error("invalid attribute:"+e);this[this.length++]={qName:e,value:t,offset:n}},length:0,getLocalName:function(e){return this[e].localName},getLocator:function(e){return this[e].locator},getQName:function(e){return this[e].qName},getURI:function(e){return this[e].uri},getValue:function(e){return this[e].value}},m({},m.prototype)instanceof m||(m=function(e,t){function n(){}n.prototype=t,n=new n;for(t in e)n[t]=e[t];return n}),t.XMLReader=r},function(e,t,n){function r(e,t){for(var n in e)t[n]=e[n]}function i(e,t){function n(){}var i=e.prototype;if(Object.create){var a=Object.create(t.prototype);i.__proto__=a}i instanceof t||(n.prototype=t.prototype,n=new n,r(i,n),e.prototype=i=n),i.constructor!=e&&("function"!=typeof e&&console.error("unknow Class:"+e),i.constructor=e)}function a(e,t){if(t instanceof Error)var n=t;else n=this,Error.call(this,ae[e]),this.message=ae[e],Error.captureStackTrace&&Error.captureStackTrace(this,a);return n.code=e,t&&(this.message=this.message+": "+t),n}function o(){}function s(e,t){this._node=e,this._refresh=t,u(this)}function u(e){var t=e._node._inc||e._node.ownerDocument._inc;if(e._inc!=t){var n=e._refresh(e._node);j(e,"length",n.length),r(n,e),e._inc=t}}function l(){}function p(e,t){for(var n=e.length;n--;)if(e[n]===t)return n}function c(e,t,n,r){if(r?t[p(t,r)]=n:t[t.length++]=n,e){n.ownerElement=e;var i=e.ownerDocument;i&&(r&&A(i,e,r),g(i,e,n))}}function f(e,t,n){var r=p(t,n);if(!(r>=0))throw a(se,new Error(e.tagName+"@"+n));for(var i=t.length-1;i>r;)t[r]=t[++r];if(t.length=i,e){var o=e.ownerDocument;o&&(A(o,e,n),n.ownerElement=null)}}function d(e){if(this._features={},e)for(var t in e)this._features=e[t]}function m(){}function h(e){return"<"==e&&"&lt;"||">"==e&&"&gt;"||"&"==e&&"&amp;"||'"'==e&&"&quot;"||"&#"+e.charCodeAt()+";"}function y(e,t){if(t(e))return!0;if(e=e.firstChild)do if(y(e,t))return!0;while(e=e.nextSibling)}function v(){}function g(e,t,n){e&&e._inc++;var r=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==r&&(t._nsMap[n.prefix?n.localName:""]=n.value)}function A(e,t,n,r){e&&e._inc++;var i=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==i&&delete t._nsMap[n.prefix?n.localName:""]}function S(e,t,n){if(e&&e._inc){e._inc++;var r=t.childNodes;if(n)r[r.length++]=n;else{for(var i=t.firstChild,a=0;i;)r[a++]=i,i=i.nextSibling;r.length=a}}}function E(e,t){var n=t.previousSibling,r=t.nextSibling;return n?n.nextSibling=r:e.firstChild=r,r?r.previousSibling=n:e.lastChild=n,S(e.ownerDocument,e),t}function T(e,t,n){var r=t.parentNode;if(r&&r.removeChild(t),t.nodeType===ne){var i=t.firstChild;if(null==i)return t;var a=t.lastChild}else i=a=t;var o=n?n.previousSibling:e.lastChild;i.previousSibling=o,a.nextSibling=n,o?o.nextSibling=i:e.firstChild=i,null==n?e.lastChild=a:n.previousSibling=a;do i.parentNode=e;while(i!==a&&(i=i.nextSibling));return S(e.ownerDocument||e,e),t.nodeType==ne&&(t.firstChild=t.lastChild=null),t}function b(e,t){var n=t.parentNode;if(n){var r=e.lastChild;n.removeChild(t);var r=e.lastChild}var r=e.lastChild;return t.parentNode=e,t.previousSibling=r,t.nextSibling=null,r?r.nextSibling=t:e.firstChild=t,e.lastChild=t,S(e.ownerDocument,e,t),t}function N(){this._nsMap={}}function _(){}function w(){}function M(){}function I(){}function R(){}function C(){}function L(){}function P(){}function O(){}function D(){}function x(){}function U(){}function k(e,t){var n=[],r=9==this.nodeType?this.documentElement:this,i=r.prefix,a=r.namespaceURI;if(a&&null==i){var i=r.lookupPrefix(a);if(null==i)var o=[{namespace:a,prefix:null}]}return B(this,n,e,t,o),n.join("")}function F(e,t,n){var r=e.prefix||"",i=e.namespaceURI;if(!r&&!i)return!1;if("xml"===r&&"http://www.w3.org/XML/1998/namespace"===i||"http://www.w3.org/2000/xmlns/"==i)return!1;for(var a=n.length;a--;){var o=n[a];if(o.prefix==r)return o.namespace!=i}return!0}function B(e,t,n,r,i){if(r){if(e=r(e),!e)return;if("string"==typeof e)return void t.push(e)}switch(e.nodeType){case H:i||(i=[]);var a=(i.length,e.attributes),o=a.length,s=e.firstChild,u=e.tagName;n=q===e.namespaceURI||n,t.push("<",u);for(var l=0;o>l;l++){var p=a.item(l);"xmlns"==p.prefix?i.push({prefix:p.localName,namespace:p.value}):"xmlns"==p.nodeName&&i.push({prefix:"",namespace:p.value})}for(var l=0;o>l;l++){var p=a.item(l);if(F(p,n,i)){var c=p.prefix||"",f=p.namespaceURI,d=c?" xmlns:"+c:" xmlns";t.push(d,'="',f,'"'),i.push({prefix:c,namespace:f})}B(p,t,n,r,i)}if(F(e,n,i)){var c=e.prefix||"",f=e.namespaceURI,d=c?" xmlns:"+c:" xmlns";t.push(d,'="',f,'"'),i.push({prefix:c,namespace:f})}if(s||n&&!/^(?:meta|link|img|br|hr|input)$/i.test(u)){if(t.push(">"),n&&/^script$/i.test(u))for(;s;)s.data?t.push(s.data):B(s,t,n,r,i),s=s.nextSibling;else for(;s;)B(s,t,n,r,i),s=s.nextSibling;t.push("</",u,">")}else t.push("/>");return;case ee:case ne:for(var s=e.firstChild;s;)B(s,t,n,r,i),s=s.nextSibling;return;case $:return t.push(" ",e.name,'="',e.value.replace(/[<&"]/g,h),'"');case G:return t.push(e.data.replace(/[<&]/g,h));case X:return t.push("<![CDATA[",e.data,"]]>");case Z:return t.push("<!--",e.data,"-->");case te:var m=e.publicId,y=e.systemId;if(t.push("<!DOCTYPE ",e.name),m)t.push(' PUBLIC "',m),y&&"."!=y&&t.push('" "',y),t.push('">');else if(y&&"."!=y)t.push(' SYSTEM "',y,'">');else{var v=e.internalSubset;v&&t.push(" [",v,"]"),t.push(">")}return;case Q:return t.push("<?",e.target," ",e.data,"?>");case z:return t.push("&",e.nodeName,";");default:t.push("??",e.nodeName)}}function K(e,t,n){var r;switch(t.nodeType){case H:r=t.cloneNode(!1),r.ownerDocument=e;case ne:break;case $:n=!0}if(r||(r=t.cloneNode(!1)),r.ownerDocument=e,r.parentNode=null,n)for(var i=t.firstChild;i;)r.appendChild(K(e,i,n)),i=i.nextSibling;return r}function V(e,t,n){var r=new t.constructor;for(var i in t){var a=t[i];"object"!=typeof a&&a!=r[i]&&(r[i]=a)}switch(t.childNodes&&(r.childNodes=new o),r.ownerDocument=e,r.nodeType){case H:var s=t.attributes,u=r.attributes=new l,p=s.length;u._ownerElement=r;for(var c=0;p>c;c++)r.setAttributeNode(V(e,s.item(c),!0));break;case $:n=!0}if(n)for(var f=t.firstChild;f;)r.appendChild(V(e,f,n)),f=f.nextSibling;return r}function j(e,t,n){e[t]=n}function W(e){switch(e.nodeType){case H:case ne:var t=[];for(e=e.firstChild;e;)7!==e.nodeType&&8!==e.nodeType&&t.push(W(e)),e=e.nextSibling;return t.join("");default:return e.nodeValue}}var q="http://www.w3.org/1999/xhtml",Y={},H=Y.ELEMENT_NODE=1,$=Y.ATTRIBUTE_NODE=2,G=Y.TEXT_NODE=3,X=Y.CDATA_SECTION_NODE=4,z=Y.ENTITY_REFERENCE_NODE=5,J=Y.ENTITY_NODE=6,Q=Y.PROCESSING_INSTRUCTION_NODE=7,Z=Y.COMMENT_NODE=8,ee=Y.DOCUMENT_NODE=9,te=Y.DOCUMENT_TYPE_NODE=10,ne=Y.DOCUMENT_FRAGMENT_NODE=11,re=Y.NOTATION_NODE=12,ie={},ae={},oe=(ie.INDEX_SIZE_ERR=(ae[1]="Index size error",1),ie.DOMSTRING_SIZE_ERR=(ae[2]="DOMString size error",2),ie.HIERARCHY_REQUEST_ERR=(ae[3]="Hierarchy request error",3)),se=(ie.WRONG_DOCUMENT_ERR=(ae[4]="Wrong document",4),ie.INVALID_CHARACTER_ERR=(ae[5]="Invalid character",5),ie.NO_DATA_ALLOWED_ERR=(ae[6]="No data allowed",6),ie.NO_MODIFICATION_ALLOWED_ERR=(ae[7]="No modification allowed",7),ie.NOT_FOUND_ERR=(ae[8]="Not found",8)),ue=(ie.NOT_SUPPORTED_ERR=(ae[9]="Not supported",9),ie.INUSE_ATTRIBUTE_ERR=(ae[10]="Attribute in use",10));ie.INVALID_STATE_ERR=(ae[11]="Invalid state",11),ie.SYNTAX_ERR=(ae[12]="Syntax error",12),ie.INVALID_MODIFICATION_ERR=(ae[13]="Invalid modification",13),ie.NAMESPACE_ERR=(ae[14]="Invalid namespace",14),ie.INVALID_ACCESS_ERR=(ae[15]="Invalid access",15);a.prototype=Error.prototype,r(ie,a),o.prototype={length:0,item:function(e){return this[e]||null},toString:function(e,t){for(var n=[],r=0;r<this.length;r++)B(this[r],n,e,t);return n.join("")}},s.prototype.item=function(e){return u(this),this[e]},i(s,o),l.prototype={length:0,item:o.prototype.item,getNamedItem:function(e){for(var t=this.length;t--;){var n=this[t];if(n.nodeName==e)return n}},setNamedItem:function(e){var t=e.ownerElement;if(t&&t!=this._ownerElement)throw new a(ue);var n=this.getNamedItem(e.nodeName);return c(this._ownerElement,this,e,n),n},setNamedItemNS:function(e){var t,n=e.ownerElement;if(n&&n!=this._ownerElement)throw new a(ue);return t=this.getNamedItemNS(e.namespaceURI,e.localName),c(this._ownerElement,this,e,t),t},removeNamedItem:function(e){var t=this.getNamedItem(e);return f(this._ownerElement,this,t),t},removeNamedItemNS:function(e,t){var n=this.getNamedItemNS(e,t);return f(this._ownerElement,this,n),n},getNamedItemNS:function(e,t){for(var n=this.length;n--;){var r=this[n];if(r.localName==t&&r.namespaceURI==e)return r}return null}},d.prototype={hasFeature:function(e,t){var n=this._features[e.toLowerCase()];return n&&(!t||t in n)?!0:!1},createDocument:function(e,t,n){var r=new v;if(r.implementation=this,r.childNodes=new o,r.doctype=n,n&&r.appendChild(n),t){var i=r.createElementNS(e,t);r.appendChild(i)}return r},createDocumentType:function(e,t,n){var r=new C;return r.name=e,r.nodeName=e,r.publicId=t,r.systemId=n,r}},m.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(e,t){return T(this,e,t)},replaceChild:function(e,t){this.insertBefore(e,t),t&&this.removeChild(t)},removeChild:function(e){return E(this,e)},appendChild:function(e){return this.insertBefore(e,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(e){return V(this.ownerDocument||this,this,e)},normalize:function(){for(var e=this.firstChild;e;){var t=e.nextSibling;t&&t.nodeType==G&&e.nodeType==G?(this.removeChild(t),e.appendData(t.data)):(e.normalize(),e=t)}},isSupported:function(e,t){return this.ownerDocument.implementation.hasFeature(e,t)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(e){for(var t=this;t;){var n=t._nsMap;if(n)for(var r in n)if(n[r]==e)return r;t=t.nodeType==$?t.ownerDocument:t.parentNode}return null},lookupNamespaceURI:function(e){for(var t=this;t;){var n=t._nsMap;if(n&&e in n)return n[e];t=t.nodeType==$?t.ownerDocument:t.parentNode}return null},isDefaultNamespace:function(e){var t=this.lookupPrefix(e);return null==t}},r(Y,m),r(Y,m.prototype),v.prototype={nodeName:"#document",nodeType:ee,doctype:null,documentElement:null,_inc:1,insertBefore:function(e,t){if(e.nodeType==ne){for(var n=e.firstChild;n;){var r=n.nextSibling;this.insertBefore(n,t),n=r}return e}return null==this.documentElement&&e.nodeType==H&&(this.documentElement=e),T(this,e,t),e.ownerDocument=this,e},removeChild:function(e){return this.documentElement==e&&(this.documentElement=null),E(this,e)},importNode:function(e,t){return K(this,e,t)},getElementById:function(e){var t=null;return y(this.documentElement,function(n){return n.nodeType==H&&n.getAttribute("id")==e?(t=n,!0):void 0}),t},createElement:function(e){var t=new N;t.ownerDocument=this,t.nodeName=e,t.tagName=e,t.childNodes=new o;var n=t.attributes=new l;return n._ownerElement=t,t},createDocumentFragment:function(){var e=new D;return e.ownerDocument=this,e.childNodes=new o,e},createTextNode:function(e){var t=new M;return t.ownerDocument=this,t.appendData(e),t},createComment:function(e){var t=new I;return t.ownerDocument=this,t.appendData(e),t},createCDATASection:function(e){var t=new R;return t.ownerDocument=this,t.appendData(e),t},createProcessingInstruction:function(e,t){var n=new x;return n.ownerDocument=this,n.tagName=n.target=e,n.nodeValue=n.data=t,n},createAttribute:function(e){var t=new _;return t.ownerDocument=this,t.name=e,t.nodeName=e,t.localName=e,t.specified=!0,t},createEntityReference:function(e){var t=new O;return t.ownerDocument=this,t.nodeName=e,t},createElementNS:function(e,t){var n=new N,r=t.split(":"),i=n.attributes=new l;return n.childNodes=new o,n.ownerDocument=this,n.nodeName=t,n.tagName=t,n.namespaceURI=e,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,i._ownerElement=n,n},createAttributeNS:function(e,t){var n=new _,r=t.split(":");return n.ownerDocument=this,n.nodeName=t,n.name=t,n.namespaceURI=e,n.specified=!0,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,n}},i(v,m),N.prototype={nodeType:H,hasAttribute:function(e){return null!=this.getAttributeNode(e)},getAttribute:function(e){var t=this.getAttributeNode(e);return t&&t.value||""},getAttributeNode:function(e){return this.attributes.getNamedItem(e)},setAttribute:function(e,t){var n=this.ownerDocument.createAttribute(e);n.value=n.nodeValue=""+t,this.setAttributeNode(n)},removeAttribute:function(e){var t=this.getAttributeNode(e);t&&this.removeAttributeNode(t)},appendChild:function(e){return e.nodeType===ne?this.insertBefore(e,null):b(this,e)},setAttributeNode:function(e){return this.attributes.setNamedItem(e)},setAttributeNodeNS:function(e){return this.attributes.setNamedItemNS(e)},removeAttributeNode:function(e){return this.attributes.removeNamedItem(e.nodeName)},removeAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);n&&this.removeAttributeNode(n)},hasAttributeNS:function(e,t){return null!=this.getAttributeNodeNS(e,t)},getAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);return n&&n.value||""},setAttributeNS:function(e,t,n){var r=this.ownerDocument.createAttributeNS(e,t);r.value=r.nodeValue=""+n,this.setAttributeNode(r)},getAttributeNodeNS:function(e,t){return this.attributes.getNamedItemNS(e,t)},getElementsByTagName:function(e){return new s(this,function(t){var n=[];return y(t,function(r){r===t||r.nodeType!=H||"*"!==e&&r.tagName!=e||n.push(r)}),n})},getElementsByTagNameNS:function(e,t){return new s(this,function(n){var r=[];return y(n,function(i){i===n||i.nodeType!==H||"*"!==e&&i.namespaceURI!==e||"*"!==t&&i.localName!=t||r.push(i)}),r})}},v.prototype.getElementsByTagName=N.prototype.getElementsByTagName,v.prototype.getElementsByTagNameNS=N.prototype.getElementsByTagNameNS,i(N,m),_.prototype.nodeType=$,i(_,m),w.prototype={data:"",substringData:function(e,t){return this.data.substring(e,e+t)},appendData:function(e){e=this.data+e,this.nodeValue=this.data=e,this.length=e.length},insertData:function(e,t){this.replaceData(e,0,t)},appendChild:function(e){throw new Error(ae[oe])},deleteData:function(e,t){this.replaceData(e,t,"")},replaceData:function(e,t,n){var r=this.data.substring(0,e),i=this.data.substring(e+t);n=r+n+i,this.nodeValue=this.data=n,this.length=n.length}},i(w,m),M.prototype={nodeName:"#text",nodeType:G,splitText:function(e){var t=this.data,n=t.substring(e);t=t.substring(0,e),this.data=this.nodeValue=t,this.length=t.length;var r=this.ownerDocument.createTextNode(n);return this.parentNode&&this.parentNode.insertBefore(r,this.nextSibling),r}},i(M,w),I.prototype={nodeName:"#comment",nodeType:Z},i(I,w),R.prototype={nodeName:"#cdata-section",nodeType:X},i(R,w),C.prototype.nodeType=te,i(C,m),L.prototype.nodeType=re,i(L,m),P.prototype.nodeType=J,i(P,m),O.prototype.nodeType=z,i(O,m),D.prototype.nodeName="#document-fragment",D.prototype.nodeType=ne,i(D,m),x.prototype.nodeType=Q,i(x,m),U.prototype.serializeToString=function(e,t,n){return k.call(e,t,n)},m.prototype.toString=k;try{Object.defineProperty&&(Object.defineProperty(s.prototype,"length",{get:function(){return u(this),this.$$length}}),Object.defineProperty(m.prototype,"textContent",{get:function(){return W(this)},set:function(e){switch(this.nodeType){case H:case ne:for(;this.firstChild;)this.removeChild(this.firstChild);(e||String(e))&&this.appendChild(this.ownerDocument.createTextNode(e));break;default:this.data=e,this.value=e,this.nodeValue=e}}}),j=function(e,t,n){e["$$"+t]=n})}catch(le){}t.DOMImplementation=d,t.XMLSerializer=U},function(e,t,n){e.exports=[{classes:[{name:"GlobalSchema",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the global schema, used to refer on schema content"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.actuallyExports",arguments:["value"]},{name:"MetaModel.description",arguments:["Content of the schema"]}],"extends":[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The title property is a short plain text description of the RESTful API. The value SHOULD be suitable for use as a title for the contained user documentation."]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If the RAML API definition is targeted to a specific API version, the API definition MUST contain a version property. The version property is OPTIONAL and should not be used if: The API itself is not versioned. The API definition does not change between versions. The API architect can decide whether a change to user documentation elements, but no change to the API's resources, constitutes a version change. The API architect MAY use any versioning scheme so long as version numbers retain the same format. For example, 'v3', 'v3.0', and 'V3' are all allowed, but are not considered to be equal."]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["(Optional during development; Required after implementation) A RESTful API's resources are defined relative to the API's base URI. The use of the baseUri field is OPTIONAL to allow describing APIs that have not yet been implemented. After the API is implemented (even a mock implementation) and can be accessed at a service endpoint, the API definition MUST contain a baseUri property. The baseUri property's value MUST conform to the URI specification RFC2396 or a Level 1 Template URI as defined in RFC6570. The baseUri property SHOULD only be used as a reference value."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["Base uri parameters are named parameters which described template parameters in the base uri"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["URI parameters can be further defined by using the uriParameters property. The use of uriParameters is OPTIONAL. The uriParameters property MUST be a map in which each key MUST be the name of the URI parameter as defined in the baseUri property. The uriParameters CANNOT contain a key named version because it is a reserved URI parameter name. The value of the uriParameters property is itself a map that specifies  the property's attributes as named parameters"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A RESTful API can be reached HTTP, HTTPS, or both. The protocols property MAY be used to specify the protocols that an API supports. If the protocols property is not specified, the protocol specified at the baseUri property is used. The protocols property MUST be an array of strings, of values `HTTP` and/or `HTTPS`."]}],valueConstraint:null,optional:!1},{name:"mediaType",type:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/formdata"]]},{name:"MetaModel.description",arguments:["(Optional) The media types returned by API responses, and expected from API requests that accept a body, MAY be defaulted by specifying the mediaType property. This property is specified at the root level of the API definition. The property's value MAY be a single string with a valid media type described in the specification."]},{name:"MetaModel.inherited",arguments:[]}],valueConstraint:null,optional:!1},{name:"schemas",type:{base:{typeName:"GlobalSchema",nameSpace:"",basicName:"GlobalSchema",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["To better achieve consistency and simplicity, the API definition SHOULD include an OPTIONAL schemas property in the root section. The schemas property specifies collections of schemas that could be used anywhere in the API definition. The value of the schemas property is an array of maps; in each map, the keys are the schema name, and the values are schema definitions. The schema definitions MAY be included inline or by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemes to apply to all methods, these must be defined in the securitySchemes declaration."]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemes that can be applied using securedBy"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",
basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Resources are identified by their relative URI, which MUST begin with a slash (/). A resource defined as a root-level property is called a top-level resource. Its property's key is the resource's URI relative to the baseUri. A resource defined as a child property of another resource is called a nested resource, and its property's key is its URI relative to its parent resource's URI. Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property. The key of a resource, i.e. its relative URI, MAY consist of multiple URI path fragments separated by slashes; e.g. `/bom/items` may indicate the collection of items in a bill of materials as a single resource. However, if the individual URI path fragments are themselves resources, the API definition SHOULD use nested resources to describe this structure; e.g. if `/bom` is itself a resource then `/items` should be a nested resource of `/bom`, while `/bom/items` should not be used."]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The API definition can include a variety of documents that serve as a user guides and reference documentation for the API. Such documents can clarify how the API works or provide business context. Documentation-generators MUST include all the sections in an API definition's documentation property in the documentation output, and they MUST preserve the order in which the documentation is declared. To add user documentation to the API, include the documentation property at the root of the API definition. The documentation property MUST be an array of documents. Each document MUST contain title and content attributes, both of which are REQUIRED. If the documentation property is specified, it MUST include at least one document. Documentation-generators MUST process the content field as if it was defined using Markdown."]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Referencable",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DeclaresDynamicType",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"T",nameSpace:"",basicName:"T",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUri",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["Mardown string is a string which can contain markdown as an extension this markdown should support links with RAML Pointers since 1.0"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSonSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType&&this.mediaType.isJSON()"]},{name:"MetaModel.description",arguments:["JSON schema"]}],"extends":[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["xml"]},{name:"MetaModel.description",arguments:["XSD schema"]}],"extends":[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ExampleString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONExample",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isJSON()"]}],"extends":[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLExample",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isXML()"]}],"extends":[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},{classes:[{name:"RAMLSimpleElement",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},{classes:[{name:"Parameter",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the parameter"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The type attribute specifies the primitive type of the parameter's resolved value. API clients MUST return/throw an error if the parameter's resolved value does not match the specified type. If type is not specified, it defaults to string."]},{name:"MetaModel.canBeDuplicator",arguments:[]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ParameterLocation",nameSpace:"",basicName:"ParameterLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Set to true if parameter is required"]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The default attribute specifies the default value to use for the property if the property is omitted or its value is not specified. This SHOULD NOT be interpreted as a requirement for the client to send the default attribute's value if there is no other value to send. Instead, the default attribute's value is the value the server uses if the client does not send a value."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional) The example attribute shows an example value for the property. This can be used, e.g., by documentation generators to generate sample values for the property."]}],valueConstraint:null,optional:!1},{name:"repeat",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The repeat attribute specifies that the parameter can be repeated. If the parameter can be used multiple times, the repeat parameter value MUST be set to 'true'. Otherwise, the default value is 'false' and the parameter may not be repeated."]},{name:"MetaModel.defaultBooleanValue",arguments:[!1]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The pattern attribute is a regular expression that a parameter of type string MUST match. Regular expressions MUST follow the regular expression specification from ECMA 262/Perl 5. The pattern MAY be enclosed in double quotes for readability and clarity."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The minLength attribute specifies the parameter value's minimum number of characters."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The maxLength attribute specifies the parameter value's maximum number of characters."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]}],"extends":[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a string representation of a date as defined in RFC2616 Section 3.3. "]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.requireValue",arguments:["location","ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ParameterLocation",members:["QUERY","HEADERS","URI","FORM","BURI"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"BodyLike",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Mime type of the request or response body"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.requireValue",arguments:["this.name.isForm()","false"]},{name:"MetaModel.description",arguments:["The structure of a request or response body MAY be further specified by the schema property under the appropriate media type. The schema key CANNOT be specified if a body's media type is application/x-www-form-urlencoded or multipart/form-data. All parsers of RAML MUST be able to interpret JSON Schema and XML Schema. Schema MAY be declared inline or in an external file. However, if the schema is sufficiently large so as to make it difficult for a person to read the API definition, or the schema is reused across multiple APIs or across multiple miles in the same API, the !include user-defined data type SHOULD be used instead of including the content inline. Alternatively, the value of the schema field MAY be the name of a schema specified in the root-level schemas property, or it MAY be declared in an external file and included by using the by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"Sys.ExampleString",nameSpace:"Sys",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"
},annotations:[{name:"MetaModel.description",arguments:["Documentation generators MUST use body properties' example attributes to generate example invocations."]}],valueConstraint:null,optional:!1},{name:"formParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["Web forms REQUIRE special encoding and custom declaration. If the API's media type is either application/x-www-form-urlencoded or multipart/form-data, the formParameters property MUST specify the name-value pairs that the API is expecting. The formParameters property is a map in which the key is the name of the web form parameter, and the value is itself a map the specifies the web form parameter's attributes."]}],valueConstraint:null,optional:!1},{name:"schemaContent",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns schema content for the cases when schema is inlined, when schema is included, and when schema is a reference."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Human readable description of the body"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.canInherit",arguments:["mediaType"]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"XMLBody",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"schema",type:{typeName:"Sys.XMLSchemaString",nameSpace:"Sys",basicName:"XMLSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["XSD Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isXML()"]},{name:"MetaModel.description",arguments:["Needed to set connection between xml related mime types and xsd schema"]}],"extends":[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONBody",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"schema",type:{typeName:"Sys.JSonSchemaString",nameSpace:"Sys",basicName:"JSonSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["JSON Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isJSON()"]},{name:"MetaModel.description",arguments:["Needed to set connection between json related mime types and json schema"]}],"extends":[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.HEADERS"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["An API's methods may support custom header values in responses. The custom, non-standard HTTP headers MUST be specified by the headers property. API's may include the the placeholder token {?} in a header name to indicate that any number of headers that conform to the specified format can be sent in responses. This is particularly useful for APIs that allow HTTP headers that conform to some naming convention to send arbitrary, custom data."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Each response MAY contain a body property, which conforms to the same structure as request body properties (see Body). Responses that can return more than one response code MAY therefore have multiple bodies defined. For APIs without a priori knowledge of the response types for their responses, `*/*` MAY be used to indicate that responses that do not matching other defined data types MUST be accepted. Processing applications MUST match the most descriptive media type first if `*/*` is used."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},{classes:[{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Method"]},{name:"MetaModel.description",arguments:["Methods that can be called on this resource"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Children resources"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Security.TraitRef",nameSpace:"Security",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource type"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},{classes:[{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Resource methods MAY have one or more responses. Responses MAY be described using the description property, and MAY include example attributes or schema properties."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"Bodies.BodyLike",nameSpace:"Bodies",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override an API's protocols value for that single method by setting a different value for the fields."]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemas to apply, these must be defined in the securitySchemes declaration. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme. Security schemas may also be applied to a resource with securedBy, which is equivalent to applying the security schemas to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"queryParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.QUERY"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.HEADERS"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Method object allows description of http methods"]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","patch","options","head","trace","connect"]]},{name:"MetaModel.description",arguments:["Method that can be called"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the security scheme part"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{headers:[{name:"MetaModel.markdownDescription",arguments:["Optional array of headers, documenting the possible headers that could be accepted."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the request header names and whose values describe the values."]}],queryParameters:[{name:"MetaModel.markdownDescription",arguments:["Query parameters, used by the schema in order to authorize the request. Mutually exclusive with queryString."]
},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the query parameter names and whose values describe the values."]}],queryString:[{name:"MetaModel.description",arguments:["Specifies the query string, used by the schema in order to authorize the request. Mutually exclusive with queryParameters."]},{name:"MetaModel.valueDescription",arguments:["Type name or type declaration"]}],responses:[{name:"MetaModel.description",arguments:["Optional array of responses, describing the possible responses that could be sent."]}],description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the security scheme part"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","DigestSecurityScheme Authentication","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0, <br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or refresh_token."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials <br>* implicit<br>* refresh_token."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}]},function(e,t,n){e.exports=[{classes:[{name:"Library",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why library exist"]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Namespace which the library is imported under"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"LibraryBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"schemas",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "types" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "types" property, as the "schemas" alias for that property name may be removed in a future RAML version. The "types" property allows for XML and JSON schemas.']}],valueConstraint:null,optional:!1},{name:"types",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.MODELS"]},{name:"MetaModel.description",arguments:["Declarations of (data) types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of (data) types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map type names to type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]},{name:"MetaModel.description",arguments:["Declarations of traits for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of traits for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map trait names to trait declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]},{name:"MetaModel.description",arguments:["Declarations of resource types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of resource types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map resource type names to resource type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"annotationTypes",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["decls","true"]},{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of annotation types for use by annotations"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of annotation types for use by annotations."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map annotation type names to annotation type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemas declarations"]},{name:"MetaModel.description",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.markdownDescription",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map security scheme names to security scheme declarations; or an array of such objects"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.internalClass",arguments:[]}],"extends":[{typeName:"FragmentDeclaration",nameSpace:"",basicName:"FragmentDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the API"]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The version of the API, e.g. 'v1'"]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A URI that's to be used as the base of all the resources' URIs. Often used as the base of the URL of each resource, containing the location of the API. Can be a template URI."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.BURI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Named parameters used in the baseUri (template)"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["The protocols supported by the API"]},{name:"MetaModel.valueDescription",arguments:['Array of strings, with each being "HTTP" or "HTTPS", case-insensitive']}],valueConstraint:null,optional:!1},{name:"mediaType",type:{base:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]},{name:"MetaModel.description",arguments:['The default media type to use for request and response bodies (payloads), e.g. "application/json"']},{name:"MetaModel.inherited",arguments:[]},{name:"MetaModel.valueDescription",arguments:["Media type string"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The security schemes that apply to every resource and method in the API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["The resources of the API, identified as relative URIs that begin with a slash (/). Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property, e.g.: /users, /{groupId}, etc"]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Additional overall documentation for the API"]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:['Returns RAML version. "RAML10" string is returned for RAML 1.0. "RAML08" string is returned for RAML 0.8.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this API. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"Overlay",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why overlay exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the overlay is applied to."]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Extension",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why extension exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the extension is applied to"]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"UsesDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name prefix (without dot) used to refer imported declarations"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"FragmentDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"uses",type:{base:{typeName:"UsesDeclaration",nameSpace:"",basicName:"UsesDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,
typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[{returnType:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},name:"value",start:170,end:210,text:"\n\n  value():string {\n    return null\n  }",arguments:[]}],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]},{name:"MetaModel.alias",arguments:["string"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]},{name:"MetaModel.alias",arguments:["any"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]},{name:"MetaModel.alias",arguments:["number"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["integer"]},{name:"MetaModel.alias",arguments:["integer"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NullType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["null"]},{name:"MetaModel.alias",arguments:["null"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["time-only"]},{name:"MetaModel.alias",arguments:["time-only"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["date-only"]},{name:"MetaModel.alias",arguments:["date-only"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime-only"]},{name:"MetaModel.alias",arguments:["datetime-only"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime"]},{name:"MetaModel.alias",arguments:["datetime"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["file"]},{name:"MetaModel.alias",arguments:["file"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]},{name:"MetaModel.alias",arguments:["boolean"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[{name:"structuredValue",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUriString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ContentType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["[GitHub Flavored Markdown](https://help.github.com/articles/github-flavored-markdown/)"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]},{name:"MetaModel.alias",arguments:["schema"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},{classes:[{name:"ExampleSpec",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["String representation of example"]},{name:"MetaModel.required",arguments:[]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of example, if possible"]}],valueConstraint:null,optional:!1},{name:"strict",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["By default, examples are validated against any type declaration. Set this to false to allow examples that need not validate."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Example identifier, if specified"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the example"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the example"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this example. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"TypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"facets",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.declaringFields",arguments:[]},{name:"MetaModel.description",arguments:["When extending from a type you can define new facets (which can then be set to concrete values by subtypes)."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"fixedFacets",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns facets fixed by the type. Value is an object with properties named after facets fixed. Value of each property is a value of the corresponding facet."]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "type" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "type" property, as the "schema" alias for that property name may be removed in a future RAML version. The "type" property allows for XML and JSON schemas.']},{name:"MetaModel.valueDescription",arguments:["Single string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["A base type which the current type extends, or more generally a type expression."]},{name:"MetaModel.valueDescription",arguments:["string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"structuredType",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.description",arguments:["Inlined supertype definition."]},{name:"MetaModel.valueDescription",arguments:["Inlined supertype definition"]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ModelLocation",nameSpace:"",basicName:"ModelLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"locationKind",type:{typeName:"LocationKind",nameSpace:"",basicName:"LocationKind",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Kind of location"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Provides default value for a property"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string or yaml map/sequence. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the examples property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"examples",type:{base:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the example property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.requireValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Sets if property is optional or not"]},{name:"MetaModel.describesAnnotation",arguments:["required"]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the type"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1},{name:"xml",type:{typeName:"XMLFacetInfo",nameSpace:"",basicName:"XMLFacetInfo",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"allowedTargets",type:{base:{typeName:"AnnotationTarget",nameSpace:"",basicName:"AnnotationTarget",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["API","DocumentationItem","Resource","Method","Response","RequestBody","ResponseBody","TypeDeclaration","NamedExample","ResourceType","Trait","SecurityScheme","SecuritySchemeSettings","AnnotationTypeDeclaration","Library","Overlay","Extension","Scalar"]]},{name:"MetaModel.description",arguments:["Restrictions on where annotations of this type can be applied. If this property is specified, annotations of this type may only be applied on a property corresponding to one of the target names specified as the value of this property."]},{name:"MetaModel.valueDescription",arguments:["An array, or single, of names allowed target nodes."]}],valueConstraint:null,optional:!1},{name:"isAnnotation",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type represents annotation"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in traits or resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this type. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"XMLFacetInfo",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"attribute",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If attribute is set to true, a type instance should be serialized as an XML attribute. It can only be true for scalar types."]}],valueConstraint:null,optional:!1},{name:"wrapped",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If wrapped is set to true, a type instance should be wrapped in its own XML element. It can not be true for scalar types and it can not be true at the same moment when attribute is true."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to override the name of the XML element or XML attribute in it's XML representation."]}],valueConstraint:null,optional:!1},{name:"namespace",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the name of the XML namespace."]}],valueConstraint:null,optional:!1},{name:"prefix",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the prefix which will be used during serialization to XML."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ArrayTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"array"},optional:!1},{name:"uniqueItems",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["uniqueItems"]},{name:"MetaModel.description",arguments:["Should items in array be unique"]}],valueConstraint:null,optional:!1},{name:"items",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.description",arguments:["Array component type."]},{name:"MetaModel.valueDescription",arguments:["Inline type declaration or type name."]}],valueConstraint:null,optional:!1},{name:"structuredItems",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.description",arguments:["Inlined component type definition"]},{name:"MetaModel.valueDescription",arguments:["Inlined component type definition"]}],valueConstraint:null,optional:!1},{name:"minItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minItems"]},{name:"MetaModel.description",arguments:["Minimum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to 0"]}],valueConstraint:null,optional:!1},{name:"maxItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxItems"]},{name:"MetaModel.description",arguments:["Maximum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to undefined."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.alias",arguments:["array"]
},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"UnionTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"union"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.requireValue",arguments:["locationKind","LocationKind.MODELS"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ObjectTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[{name:"MetaModel.hide",arguments:[]}],valueConstraint:{isCallConstraint:!1,value:"object"},optional:!1},{name:"properties",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["The properties that instances of this type may or must have."]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the properties' names and whose values are property declarations."]}],valueConstraint:null,optional:!1},{name:"minProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minProperties"]},{name:"MetaModel.description",arguments:["The minimum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"maxProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxProperties"]},{name:"MetaModel.description",arguments:["The maximum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"additionalProperties",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["A Boolean that indicates if an object instance has additional properties."]}],valueConstraint:null,optional:!1},{name:"discriminator",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Type property name to be used as discriminator, or boolean"]}],valueConstraint:null,optional:!1},{name:"discriminatorValue",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The value of discriminator for the type."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.definingPropertyIsEnough",arguments:["properties"]},{name:"MetaModel.setsContextValue",arguments:["field","true"]},{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["pattern"]},{name:"MetaModel.description",arguments:["Regular expression that this string should path"]},{name:"MetaModel.valueDescription",arguments:["regexp"]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minLength"]},{name:"MetaModel.description",arguments:["Minimum length of the string"]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxLength"]},{name:"MetaModel.description",arguments:["Maximum length of the string"]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minimum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maximum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","float","double","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1},{name:"multipleOf",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:['A numeric instance is valid against "multipleOf" if the result of the division of the instance by this keyword\'s value is an integer.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "full-date" notation of RFC3339, namely yyyy-mm-dd (no implications about time or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"time-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "partial-time" notation of RFC3339, namely hh:mm:ss[.ff...] (no implications about date or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['combined date-only and time-only with a separator of "T", namely yyyy-mm-ddThh:mm:ss[.ff...] (no implications about timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["rfc3339","rfc2616"]]},{name:"MetaModel.description",arguments:["Format used for this date time rfc3339 or rfc2616"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['a timestamp, either in the "date-time" notation of RFC3339, if format is omitted or is set to rfc3339, or in the format defined in RFC2616, if format is set to rfc2616.']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Indicates whether the instance is array"]}],valueConstraint:null,optional:!1},{name:"items",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Returns components of array instances"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ModelLocation",members:["QUERY","HEADERS","URI","FORM","BURI","ANNOTATION","MODEL","SECURITYSCHEMATYPE"]},{name:"LocationKind",members:["APISTRUCTURE","DECLARATIONS","MODELS"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Declarations:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["Detailed information about any response headers returned by this method"]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the response header names and whose values describe the values."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["The body of the response: a body declaration"]},{name:"MetaModel.valueDescription",arguments:["Object whose properties are either<br>* Media types and whose values are type objects describing the request body for that media type, or<br>* a type object describing the request body for the default media type specified in the root mediaType property."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the response"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the response"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this response. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},{classes:[{name:"Annotable",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"annotations",type:{base:{typeName:"Decls.AnnotationRef",nameSpace:"Decls",basicName:"AnnotationRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},typeKind:1},annotations:[{name:"MetaModel.noDirectParse",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","datamodel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["location","datamodel.ModelLocation.ANNOTATION"]},{name:"MetaModel.description",arguments:["Most of RAML model elements may have attached annotations decribing additional meta data about this element"]},{name:"MetaModel.documentationTableLabel",arguments:["(&lt;annotationName&gt;)"]},{name:"MetaModel.valueDescription",arguments:["A value corresponding to the declared type of this annotation."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},{classes:[{name:"AnnotationRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"annotation",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced annotation"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Annotations allow you to attach information to your API"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnnotationTarget",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Elements to which this Annotation can be applied (enum)"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},{classes:[{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the trait display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override the protocols specified in the resource or at the API root, by employing this property."]},{name:"MetaModel.valueDescription",arguments:["array of strings of value HTTP or HTTPS, or a single string of such kind, case-insensitive"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]
}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","options","head","patch"]]},{name:"MetaModel.description",arguments:["Method that can be called"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the method display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"Operation",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"queryParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.QUERY"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming  a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"queryString",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.description",arguments:["Specifies the query string needed by this method. Mutually exclusive with queryParameters."]}],valueConstraint:null,optional:!1},{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["response","true"]},{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Information about the expected responses to a request"]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the HTTP status codes of the responses and whose values describe the responses."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.description",arguments:['Annotations to be applied to this security scheme part. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"signatures",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HMAC-SHA1","RSA-SHA1","PLAINTEXT"]]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["List of the signature methods used by the server. Available methods: HMAC-SHA1, RSA-SHA1, PLAINTEXT"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oftenKeys",arguments:[["authorization_code","password","client_credentials","implicit"]]},{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or any absolute url."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials<br>* implicit <br>*  or any absolute url."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","Digest Authentication","Pass Through","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0,<br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* Pass Through<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]},{name:"MetaModel.description",arguments:["The description MAY be used to describe a securityScheme."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the security scheme display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"PassThroughSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Pass Through"},optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},{classes:[{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]},{name:"MetaModel.markdownDescription",arguments:["The methods available on this resource."]},{name:"MetaModel.documentationTableLabel",arguments:["get?<br>patch?<br>put?<br>post?<br>delete?<br>options?<br>head?"]},{name:"MetaModel.valueDescription",arguments:["Object describing the method"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Methods.TraitRef",nameSpace:"Methods",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the traits to apply to all methods declared (implicitly or explicitly) for this resource. Individual methods may override this declaration"]},{name:"MetaModel.valueDescription",arguments:["array, which can contain each of the following elements:<br>* name of unparametrized trait <br>* a key-value pair with trait name as key and a map of trait parameters as value<br>* inline trait declaration <br><br>(or a single element of any above kind)"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The resource type which this resource inherits."]},{name:"MetaModel.valueDescription",arguments:["one of the following elements:<br>* name of unparametrized resource type<br>* a key-value pair with resource type name as key and a map of its parameters as value<br>* inline resource type declaration"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["The security schemes that apply to all methods declared (implicitly or explicitly) for this resource."]},{name:"MetaModel.valueDescription",arguments:["array of security scheme names or a single security scheme name"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.URI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Detailed information about any URI parameters of this resource"]},{name:"MetaModel.valueDescription",arguments:["object whose property names are the URI parameter names and whose values describe the values"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]
},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:['A nested resource is identified as any property whose name begins with a slash ("/") and is therefore treated as a relative URI.']},{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.valueDescription",arguments:["object describing the nested resource"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the resource."]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this resource. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},{classes:[{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1},{name:"fileTypes",type:{base:{typeName:"Sys.ContentType",nameSpace:"Sys",basicName:"ContentType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["It should also include a new property: fileTypes, which should be a list of valid content-type strings for the file. The file type */* should be a valid value."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The minLength attribute specifies the parameter value's minimum number of bytes."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The maxLength attribute specifies the parameter value's maximum number of bytes."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}]},function(e,t,n){var r,i;(function(){function n(e){function t(t,n,r,i,a,o){for(;a>=0&&o>a;a+=e){var s=i?i[a]:a;r=n(r,t[s],s,t)}return r}return function(n,r,i,a){r=b(r,a,4);var o=!C(n)&&T.keys(n),s=(o||n).length,u=e>0?0:s-1;return arguments.length<3&&(i=n[o?o[u]:u],u+=e),t(n,r,i,o,u,s)}}function a(e){return function(t,n,r){n=N(n,r);for(var i=R(t),a=e>0?0:i-1;a>=0&&i>a;a+=e)if(n(t[a],a,t))return a;return-1}}function o(e,t,n){return function(r,i,a){var o=0,s=R(r);if("number"==typeof a)e>0?o=a>=0?a:Math.max(a+s,o):s=a>=0?Math.min(a+1,s):a+s+1;else if(n&&a&&s)return a=n(r,i),r[a]===i?a:-1;if(i!==i)return a=t(m.call(r,o,s),T.isNaN),a>=0?a+o:-1;for(a=e>0?o:s-1;a>=0&&s>a;a+=e)if(r[a]===i)return a;return-1}}function s(e,t){var n=x.length,r=e.constructor,i=T.isFunction(r)&&r.prototype||c,a="constructor";for(T.has(e,a)&&!T.contains(t,a)&&t.push(a);n--;)a=x[n],a in e&&e[a]!==i[a]&&!T.contains(t,a)&&t.push(a)}var u=this,l=u._,p=Array.prototype,c=Object.prototype,f=Function.prototype,d=p.push,m=p.slice,h=c.toString,y=c.hasOwnProperty,v=Array.isArray,g=Object.keys,A=f.bind,S=Object.create,E=function(){},T=function(e){return e instanceof T?e:this instanceof T?void(this._wrapped=e):new T(e)};"undefined"!=typeof e&&e.exports&&(t=e.exports=T),t._=T,T.VERSION="1.8.3";var b=function(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 2:return function(n,r){return e.call(t,n,r)};case 3:return function(n,r,i){return e.call(t,n,r,i)};case 4:return function(n,r,i,a){return e.call(t,n,r,i,a)}}return function(){return e.apply(t,arguments)}},N=function(e,t,n){return null==e?T.identity:T.isFunction(e)?b(e,t,n):T.isObject(e)?T.matcher(e):T.property(e)};T.iteratee=function(e,t){return N(e,t,1/0)};var _=function(e,t){return function(n){var r=arguments.length;if(2>r||null==n)return n;for(var i=1;r>i;i++)for(var a=arguments[i],o=e(a),s=o.length,u=0;s>u;u++){var l=o[u];t&&void 0!==n[l]||(n[l]=a[l])}return n}},w=function(e){if(!T.isObject(e))return{};if(S)return S(e);E.prototype=e;var t=new E;return E.prototype=null,t},M=function(e){return function(t){return null==t?void 0:t[e]}},I=Math.pow(2,53)-1,R=M("length"),C=function(e){var t=R(e);return"number"==typeof t&&t>=0&&I>=t};T.each=T.forEach=function(e,t,n){t=b(t,n);var r,i;if(C(e))for(r=0,i=e.length;i>r;r++)t(e[r],r,e);else{var a=T.keys(e);for(r=0,i=a.length;i>r;r++)t(e[a[r]],a[r],e)}return e},T.map=T.collect=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=Array(i),o=0;i>o;o++){var s=r?r[o]:o;a[o]=t(e[s],s,e)}return a},T.reduce=T.foldl=T.inject=n(1),T.reduceRight=T.foldr=n(-1),T.find=T.detect=function(e,t,n){var r;return r=C(e)?T.findIndex(e,t,n):T.findKey(e,t,n),void 0!==r&&-1!==r?e[r]:void 0},T.filter=T.select=function(e,t,n){var r=[];return t=N(t,n),T.each(e,function(e,n,i){t(e,n,i)&&r.push(e)}),r},T.reject=function(e,t,n){return T.filter(e,T.negate(N(t)),n)},T.every=T.all=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=0;i>a;a++){var o=r?r[a]:a;if(!t(e[o],o,e))return!1}return!0},T.some=T.any=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=0;i>a;a++){var o=r?r[a]:a;if(t(e[o],o,e))return!0}return!1},T.contains=T.includes=T.include=function(e,t,n,r){return C(e)||(e=T.values(e)),("number"!=typeof n||r)&&(n=0),T.indexOf(e,t,n)>=0},T.invoke=function(e,t){var n=m.call(arguments,2),r=T.isFunction(t);return T.map(e,function(e){var i=r?t:e[t];return null==i?i:i.apply(e,n)})},T.pluck=function(e,t){return T.map(e,T.property(t))},T.where=function(e,t){return T.filter(e,T.matcher(t))},T.findWhere=function(e,t){return T.find(e,T.matcher(t))},T.max=function(e,t,n){var r,i,a=-(1/0),o=-(1/0);if(null==t&&null!=e){e=C(e)?e:T.values(e);for(var s=0,u=e.length;u>s;s++)r=e[s],r>a&&(a=r)}else t=N(t,n),T.each(e,function(e,n,r){i=t(e,n,r),(i>o||i===-(1/0)&&a===-(1/0))&&(a=e,o=i)});return a},T.min=function(e,t,n){var r,i,a=1/0,o=1/0;if(null==t&&null!=e){e=C(e)?e:T.values(e);for(var s=0,u=e.length;u>s;s++)r=e[s],a>r&&(a=r)}else t=N(t,n),T.each(e,function(e,n,r){i=t(e,n,r),(o>i||i===1/0&&a===1/0)&&(a=e,o=i)});return a},T.shuffle=function(e){for(var t,n=C(e)?e:T.values(e),r=n.length,i=Array(r),a=0;r>a;a++)t=T.random(0,a),t!==a&&(i[a]=i[t]),i[t]=n[a];return i},T.sample=function(e,t,n){return null==t||n?(C(e)||(e=T.values(e)),e[T.random(e.length-1)]):T.shuffle(e).slice(0,Math.max(0,t))},T.sortBy=function(e,t,n){return t=N(t,n),T.pluck(T.map(e,function(e,n,r){return{value:e,index:n,criteria:t(e,n,r)}}).sort(function(e,t){var n=e.criteria,r=t.criteria;if(n!==r){if(n>r||void 0===n)return 1;if(r>n||void 0===r)return-1}return e.index-t.index}),"value")};var L=function(e){return function(t,n,r){var i={};return n=N(n,r),T.each(t,function(r,a){var o=n(r,a,t);e(i,r,o)}),i}};T.groupBy=L(function(e,t,n){T.has(e,n)?e[n].push(t):e[n]=[t]}),T.indexBy=L(function(e,t,n){e[n]=t}),T.countBy=L(function(e,t,n){T.has(e,n)?e[n]++:e[n]=1}),T.toArray=function(e){return e?T.isArray(e)?m.call(e):C(e)?T.map(e,T.identity):T.values(e):[]},T.size=function(e){return null==e?0:C(e)?e.length:T.keys(e).length},T.partition=function(e,t,n){t=N(t,n);var r=[],i=[];return T.each(e,function(e,n,a){(t(e,n,a)?r:i).push(e)}),[r,i]},T.first=T.head=T.take=function(e,t,n){return null==e?void 0:null==t||n?e[0]:T.initial(e,e.length-t)},T.initial=function(e,t,n){return m.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))},T.last=function(e,t,n){return null==e?void 0:null==t||n?e[e.length-1]:T.rest(e,Math.max(0,e.length-t))},T.rest=T.tail=T.drop=function(e,t,n){return m.call(e,null==t||n?1:t)},T.compact=function(e){return T.filter(e,T.identity)};var P=function(e,t,n,r){for(var i=[],a=0,o=r||0,s=R(e);s>o;o++){var u=e[o];if(C(u)&&(T.isArray(u)||T.isArguments(u))){t||(u=P(u,t,n));var l=0,p=u.length;for(i.length+=p;p>l;)i[a++]=u[l++]}else n||(i[a++]=u)}return i};T.flatten=function(e,t){return P(e,t,!1)},T.without=function(e){return T.difference(e,m.call(arguments,1))},T.uniq=T.unique=function(e,t,n,r){T.isBoolean(t)||(r=n,n=t,t=!1),null!=n&&(n=N(n,r));for(var i=[],a=[],o=0,s=R(e);s>o;o++){var u=e[o],l=n?n(u,o,e):u;t?(o&&a===l||i.push(u),a=l):n?T.contains(a,l)||(a.push(l),i.push(u)):T.contains(i,u)||i.push(u)}return i},T.union=function(){return T.uniq(P(arguments,!0,!0))},T.intersection=function(e){for(var t=[],n=arguments.length,r=0,i=R(e);i>r;r++){var a=e[r];if(!T.contains(t,a)){for(var o=1;n>o&&T.contains(arguments[o],a);o++);o===n&&t.push(a)}}return t},T.difference=function(e){var t=P(arguments,!0,!0,1);return T.filter(e,function(e){return!T.contains(t,e)})},T.zip=function(){return T.unzip(arguments)},T.unzip=function(e){for(var t=e&&T.max(e,R).length||0,n=Array(t),r=0;t>r;r++)n[r]=T.pluck(e,r);return n},T.object=function(e,t){for(var n={},r=0,i=R(e);i>r;r++)t?n[e[r]]=t[r]:n[e[r][0]]=e[r][1];return n},T.findIndex=a(1),T.findLastIndex=a(-1),T.sortedIndex=function(e,t,n,r){n=N(n,r,1);for(var i=n(t),a=0,o=R(e);o>a;){var s=Math.floor((a+o)/2);n(e[s])<i?a=s+1:o=s}return a},T.indexOf=o(1,T.findIndex,T.sortedIndex),T.lastIndexOf=o(-1,T.findLastIndex),T.range=function(e,t,n){null==t&&(t=e||0,e=0),n=n||1;for(var r=Math.max(Math.ceil((t-e)/n),0),i=Array(r),a=0;r>a;a++,e+=n)i[a]=e;return i};var O=function(e,t,n,r,i){if(!(r instanceof t))return e.apply(n,i);var a=w(e.prototype),o=e.apply(a,i);return T.isObject(o)?o:a};T.bind=function(e,t){if(A&&e.bind===A)return A.apply(e,m.call(arguments,1));if(!T.isFunction(e))throw new TypeError("Bind must be called on a function");var n=m.call(arguments,2),r=function(){return O(e,r,t,this,n.concat(m.call(arguments)))};return r},T.partial=function(e){var t=m.call(arguments,1),n=function(){for(var r=0,i=t.length,a=Array(i),o=0;i>o;o++)a[o]=t[o]===T?arguments[r++]:t[o];for(;r<arguments.length;)a.push(arguments[r++]);return O(e,n,this,this,a)};return n},T.bindAll=function(e){var t,n,r=arguments.length;if(1>=r)throw new Error("bindAll must be passed function names");for(t=1;r>t;t++)n=arguments[t],e[n]=T.bind(e[n],e);return e},T.memoize=function(e,t){var n=function(r){var i=n.cache,a=""+(t?t.apply(this,arguments):r);return T.has(i,a)||(i[a]=e.apply(this,arguments)),i[a]};return n.cache={},n},T.delay=function(e,t){var n=m.call(arguments,2);return setTimeout(function(){return e.apply(null,n)},t)},T.defer=T.partial(T.delay,T,1),T.throttle=function(e,t,n){var r,i,a,o=null,s=0;n||(n={});var u=function(){s=n.leading===!1?0:T.now(),o=null,a=e.apply(r,i),o||(r=i=null)};return function(){var l=T.now();s||n.leading!==!1||(s=l);var p=t-(l-s);return r=this,i=arguments,0>=p||p>t?(o&&(clearTimeout(o),o=null),s=l,a=e.apply(r,i),o||(r=i=null)):o||n.trailing===!1||(o=setTimeout(u,p)),a}},T.debounce=function(e,t,n){var r,i,a,o,s,u=function(){var l=T.now()-o;t>l&&l>=0?r=setTimeout(u,t-l):(r=null,n||(s=e.apply(a,i),r||(a=i=null)))};return function(){a=this,i=arguments,o=T.now();var l=n&&!r;return r||(r=setTimeout(u,t)),l&&(s=e.apply(a,i),a=i=null),s}},T.wrap=function(e,t){return T.partial(t,e)},T.negate=function(e){return function(){return!e.apply(this,arguments)}},T.compose=function(){var e=arguments,t=e.length-1;return function(){for(var n=t,r=e[t].apply(this,arguments);n--;)r=e[n].call(this,r);return r}},T.after=function(e,t){return function(){return--e<1?t.apply(this,arguments):void 0}},T.before=function(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),1>=e&&(t=null),n}},T.once=T.partial(T.before,2);var D=!{toString:null}.propertyIsEnumerable("toString"),x=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];T.keys=function(e){if(!T.isObject(e))return[];if(g)return g(e);var t=[];for(var n in e)T.has(e,n)&&t.push(n);return D&&s(e,t),t},T.allKeys=function(e){if(!T.isObject(e))return[];var t=[];for(var n in e)t.push(n);return D&&s(e,t),t},T.values=function(e){for(var t=T.keys(e),n=t.length,r=Array(n),i=0;n>i;i++)r[i]=e[t[i]];return r},T.mapObject=function(e,t,n){t=N(t,n);for(var r,i=T.keys(e),a=i.length,o={},s=0;a>s;s++)r=i[s],o[r]=t(e[r],r,e);return o},T.pairs=function(e){for(var t=T.keys(e),n=t.length,r=Array(n),i=0;n>i;i++)r[i]=[t[i],e[t[i]]];return r},T.invert=function(e){for(var t={},n=T.keys(e),r=0,i=n.length;i>r;r++)t[e[n[r]]]=n[r];return t},T.functions=T.methods=function(e){var t=[];for(var n in e)T.isFunction(e[n])&&t.push(n);return t.sort()},T.extend=_(T.allKeys),T.extendOwn=T.assign=_(T.keys),T.findKey=function(e,t,n){t=N(t,n);for(var r,i=T.keys(e),a=0,o=i.length;o>a;a++)if(r=i[a],t(e[r],r,e))return r},T.pick=function(e,t,n){var r,i,a={},o=e;if(null==o)return a;T.isFunction(t)?(i=T.allKeys(o),r=b(t,n)):(i=P(arguments,!1,!1,1),r=function(e,t,n){return t in n},o=Object(o));for(var s=0,u=i.length;u>s;s++){var l=i[s],p=o[l];r(p,l,o)&&(a[l]=p)}return a},T.omit=function(e,t,n){if(T.isFunction(t))t=T.negate(t);else{var r=T.map(P(arguments,!1,!1,1),String);t=function(e,t){return!T.contains(r,t)}}return T.pick(e,t,n)},T.defaults=_(T.allKeys,!0),T.create=function(e,t){var n=w(e);return t&&T.extendOwn(n,t),n},T.clone=function(e){return T.isObject(e)?T.isArray(e)?e.slice():T.extend({},e):e},T.tap=function(e,t){return t(e),e},T.isMatch=function(e,t){var n=T.keys(t),r=n.length;if(null==e)return!r;for(var i=Object(e),a=0;r>a;a++){var o=n[a];if(t[o]!==i[o]||!(o in i))return!1}return!0};var U=function(e,t,n,r){if(e===t)return 0!==e||1/e===1/t;if(null==e||null==t)return e===t;e instanceof T&&(e=e._wrapped),t instanceof T&&(t=t._wrapped);var i=h.call(e);if(i!==h.call(t))return!1;switch(i){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!==+e?+t!==+t:0===+e?1/+e===1/t:+e===+t;case"[object Date]":case"[object Boolean]":return+e===+t}var a="[object Array]"===i;if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var o=e.constructor,s=t.constructor;if(o!==s&&!(T.isFunction(o)&&o instanceof o&&T.isFunction(s)&&s instanceof s)&&"constructor"in e&&"constructor"in t)return!1}n=n||[],r=r||[];for(var u=n.length;u--;)if(n[u]===e)return r[u]===t;if(n.push(e),r.push(t),a){if(u=e.length,u!==t.length)return!1;for(;u--;)if(!U(e[u],t[u],n,r))return!1}else{var l,p=T.keys(e);if(u=p.length,T.keys(t).length!==u)return!1;for(;u--;)if(l=p[u],!T.has(t,l)||!U(e[l],t[l],n,r))return!1}return n.pop(),r.pop(),!0};T.isEqual=function(e,t){return U(e,t)},T.isEmpty=function(e){return null==e?!0:C(e)&&(T.isArray(e)||T.isString(e)||T.isArguments(e))?0===e.length:0===T.keys(e).length},T.isElement=function(e){return!(!e||1!==e.nodeType)},T.isArray=v||function(e){return"[object Array]"===h.call(e)},T.isObject=function(e){var t=typeof e;return"function"===t||"object"===t&&!!e},T.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(e){T["is"+e]=function(t){return h.call(t)==="[object "+e+"]"}}),T.isArguments(arguments)||(T.isArguments=function(e){return T.has(e,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(T.isFunction=function(e){return"function"==typeof e||!1}),T.isFinite=function(e){return isFinite(e)&&!isNaN(parseFloat(e))},T.isNaN=function(e){return T.isNumber(e)&&e!==+e},T.isBoolean=function(e){return e===!0||e===!1||"[object Boolean]"===h.call(e)},T.isNull=function(e){return null===e},T.isUndefined=function(e){return void 0===e},T.has=function(e,t){return null!=e&&y.call(e,t)},T.noConflict=function(){return u._=l,this},T.identity=function(e){return e},T.constant=function(e){return function(){return e}},T.noop=function(){},T.property=M,T.propertyOf=function(e){return null==e?function(){}:function(t){return e[t]}},T.matcher=T.matches=function(e){return e=T.extendOwn({},e),function(t){return T.isMatch(t,e)}},T.times=function(e,t,n){var r=Array(Math.max(0,e));t=b(t,n,1);for(var i=0;e>i;i++)r[i]=t(i);return r},T.random=function(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))},T.now=Date.now||function(){return(new Date).getTime()};var k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},F=T.invert(k),B=function(e){var t=function(t){return e[t]},n="(?:"+T.keys(e).join("|")+")",r=RegExp(n),i=RegExp(n,"g");return function(e){return e=null==e?"":""+e,r.test(e)?e.replace(i,t):e}};T.escape=B(k),T.unescape=B(F),T.result=function(e,t,n){var r=null==e?void 0:e[t];return void 0===r&&(r=n),T.isFunction(r)?r.call(e):r};var K=0;T.uniqueId=function(e){var t=++K+"";return e?e+t:t},T.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var V=/(.)^/,j={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},W=/\\|'|\r|\n|\u2028|\u2029/g,q=function(e){return"\\"+j[e]};T.template=function(e,t,n){!t&&n&&(t=n),t=T.defaults({},t,T.templateSettings);var r=RegExp([(t.escape||V).source,(t.interpolate||V).source,(t.evaluate||V).source].join("|")+"|$","g"),i=0,a="__p+='";e.replace(r,function(t,n,r,o,s){return a+=e.slice(i,s).replace(W,q),i=s+t.length,n?a+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":o&&(a+="';\n"+o+"\n__p+='"),t}),a+="';\n",t.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";try{var o=new Function(t.variable||"obj","_",a)}catch(s){throw s.source=a,s}var u=function(e){return o.call(this,e,T)},l=t.variable||"obj";return u.source="function("+l+"){\n"+a+"}",u},T.chain=function(e){var t=T(e);return t._chain=!0,t};var Y=function(e,t){return e._chain?T(t).chain():t};T.mixin=function(e){T.each(T.functions(e),function(t){var n=T[t]=e[t];T.prototype[t]=function(){var e=[this._wrapped];return d.apply(e,arguments),Y(this,n.apply(T,e))}})},T.mixin(T),T.each(["pop","push","reverse","shift","sort","splice","unshift"],function(e){var t=p[e];T.prototype[e]=function(){var n=this._wrapped;return t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0],Y(this,n)}}),T.each(["concat","join","slice"],function(e){var t=p[e];T.prototype[e]=function(){return Y(this,t.apply(this._wrapped,arguments))}}),T.prototype.value=function(){return this._wrapped},T.prototype.valueOf=T.prototype.toJSON=T.prototype.value,T.prototype.toString=function(){return""+this._wrapped},r=[],i=function(){return T}.apply(t,r),!(void 0!==i&&(e.exports=i))}).call(this)},function(e,t,n){"use strict";function r(e,t){e=e.split("?");var n=e[0],r=(e[1]||"").split("#")[0],o=e[1]&&e[1].split("#").length>1?"#"+e[1].split("#")[1]:"",s=i(r);for(var u in t)s[u]=t[u];return r=a(s),""!==r&&(r="?"+r),n+r+o}var i=n(172).parse,a=n(172).stringify;e.exports=r},function(e,t,n){"use strict";function r(e,t){return{name:e,methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:t,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}}function i(e,t,n){return a.parseStruct(e,t,n)}t.helpers=n(139);var a=n(140),o=function(){function e(){}return e}();t.EnumDeclaration=o,function(e){e[e.BASIC=0]="BASIC",e[e.ARRAY=1]="ARRAY",e[e.UNION=2]="UNION"}(t.TypeKind||(t.TypeKind={}));t.TypeKind;t.classDecl=r,t.parseStruct=i},function(e,t,n){(function(e,r){/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */
"use strict";function i(){function e(){}try{var t=new Uint8Array(1);return t.foo=function(){return 42},t.constructor=e,42===t.foo()&&t.constructor===e&&"function"==typeof t.subarray&&0===t.subarray(1,1).byteLength}catch(n){return!1}}function a(){return e.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function e(t){return this instanceof e?(e.TYPED_ARRAY_SUPPORT||(this.length=0,this.parent=void 0),"number"==typeof t?o(this,t):"string"==typeof t?s(this,t,arguments.length>1?arguments[1]:"utf8"):u(this,t)):arguments.length>1?new e(t,arguments[1]):new e(t)}function o(t,n){if(t=h(t,0>n?0:0|y(n)),!e.TYPED_ARRAY_SUPPORT)for(var r=0;n>r;r++)t[r]=0;return t}function s(e,t,n){("string"!=typeof n||""===n)&&(n="utf8");var r=0|g(t,n);return e=h(e,r),e.write(t,n),e}function u(t,n){if(e.isBuffer(n))return l(t,n);if(z(n))return p(t,n);if(null==n)throw new TypeError("must start with number, buffer, array or string");if("undefined"!=typeof ArrayBuffer){if(n.buffer instanceof ArrayBuffer)return c(t,n);if(n instanceof ArrayBuffer)return f(t,n)}return n.length?d(t,n):m(t,n)}function l(e,t){var n=0|y(t.length);return e=h(e,n),t.copy(e,0,0,n),e}function p(e,t){var n=0|y(t.length);e=h(e,n);for(var r=0;n>r;r+=1)e[r]=255&t[r];return e}function c(e,t){var n=0|y(t.length);e=h(e,n);for(var r=0;n>r;r+=1)e[r]=255&t[r];return e}function f(t,n){return e.TYPED_ARRAY_SUPPORT?(n.byteLength,t=e._augment(new Uint8Array(n))):t=c(t,new Uint8Array(n)),t}function d(e,t){var n=0|y(t.length);e=h(e,n);for(var r=0;n>r;r+=1)e[r]=255&t[r];return e}function m(e,t){var n,r=0;"Buffer"===t.type&&z(t.data)&&(n=t.data,r=0|y(n.length)),e=h(e,r);for(var i=0;r>i;i+=1)e[i]=255&n[i];return e}function h(t,n){e.TYPED_ARRAY_SUPPORT?(t=e._augment(new Uint8Array(n)),t.__proto__=e.prototype):(t.length=n,t._isBuffer=!0);var r=0!==n&&n<=e.poolSize>>>1;return r&&(t.parent=J),t}function y(e){if(e>=a())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+a().toString(16)+" bytes");return 0|e}function v(t,n){if(!(this instanceof v))return new v(t,n);var r=new e(t,n);return delete r.parent,r}function g(e,t){"string"!=typeof e&&(e=""+e);var n=e.length;if(0===n)return 0;for(var r=!1;;)switch(t){case"ascii":case"binary":case"raw":case"raws":return n;case"utf8":case"utf-8":return W(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*n;case"hex":return n>>>1;case"base64":return H(e).length;default:if(r)return W(e).length;t=(""+t).toLowerCase(),r=!0}}function A(e,t,n){var r=!1;if(t=0|t,n=void 0===n||n===1/0?this.length:0|n,e||(e="utf8"),0>t&&(t=0),n>this.length&&(n=this.length),t>=n)return"";for(;;)switch(e){case"hex":return L(this,t,n);case"utf8":case"utf-8":return M(this,t,n);case"ascii":return R(this,t,n);case"binary":return C(this,t,n);case"base64":return w(this,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return P(this,t,n);default:if(r)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),r=!0}}function S(e,t,n,r){n=Number(n)||0;var i=e.length-n;r?(r=Number(r),r>i&&(r=i)):r=i;var a=t.length;if(a%2!==0)throw new Error("Invalid hex string");r>a/2&&(r=a/2);for(var o=0;r>o;o++){var s=parseInt(t.substr(2*o,2),16);if(isNaN(s))throw new Error("Invalid hex string");e[n+o]=s}return o}function E(e,t,n,r){return $(W(t,e.length-n),e,n,r)}function T(e,t,n,r){return $(q(t),e,n,r)}function b(e,t,n,r){return T(e,t,n,r)}function N(e,t,n,r){return $(H(t),e,n,r)}function _(e,t,n,r){return $(Y(t,e.length-n),e,n,r)}function w(e,t,n){return 0===t&&n===e.length?G.fromByteArray(e):G.fromByteArray(e.slice(t,n))}function M(e,t,n){n=Math.min(e.length,n);for(var r=[],i=t;n>i;){var a=e[i],o=null,s=a>239?4:a>223?3:a>191?2:1;if(n>=i+s){var u,l,p,c;switch(s){case 1:128>a&&(o=a);break;case 2:u=e[i+1],128===(192&u)&&(c=(31&a)<<6|63&u,c>127&&(o=c));break;case 3:u=e[i+1],l=e[i+2],128===(192&u)&&128===(192&l)&&(c=(15&a)<<12|(63&u)<<6|63&l,c>2047&&(55296>c||c>57343)&&(o=c));break;case 4:u=e[i+1],l=e[i+2],p=e[i+3],128===(192&u)&&128===(192&l)&&128===(192&p)&&(c=(15&a)<<18|(63&u)<<12|(63&l)<<6|63&p,c>65535&&1114112>c&&(o=c))}}null===o?(o=65533,s=1):o>65535&&(o-=65536,r.push(o>>>10&1023|55296),o=56320|1023&o),r.push(o),i+=s}return I(r)}function I(e){var t=e.length;if(Q>=t)return String.fromCharCode.apply(String,e);for(var n="",r=0;t>r;)n+=String.fromCharCode.apply(String,e.slice(r,r+=Q));return n}function R(e,t,n){var r="";n=Math.min(e.length,n);for(var i=t;n>i;i++)r+=String.fromCharCode(127&e[i]);return r}function C(e,t,n){var r="";n=Math.min(e.length,n);for(var i=t;n>i;i++)r+=String.fromCharCode(e[i]);return r}function L(e,t,n){var r=e.length;(!t||0>t)&&(t=0),(!n||0>n||n>r)&&(n=r);for(var i="",a=t;n>a;a++)i+=j(e[a]);return i}function P(e,t,n){for(var r=e.slice(t,n),i="",a=0;a<r.length;a+=2)i+=String.fromCharCode(r[a]+256*r[a+1]);return i}function O(e,t,n){if(e%1!==0||0>e)throw new RangeError("offset is not uint");if(e+t>n)throw new RangeError("Trying to access beyond buffer length")}function D(t,n,r,i,a,o){if(!e.isBuffer(t))throw new TypeError("buffer must be a Buffer instance");if(n>a||o>n)throw new RangeError("value is out of bounds");if(r+i>t.length)throw new RangeError("index out of range")}function x(e,t,n,r){0>t&&(t=65535+t+1);for(var i=0,a=Math.min(e.length-n,2);a>i;i++)e[n+i]=(t&255<<8*(r?i:1-i))>>>8*(r?i:1-i)}function U(e,t,n,r){0>t&&(t=4294967295+t+1);for(var i=0,a=Math.min(e.length-n,4);a>i;i++)e[n+i]=t>>>8*(r?i:3-i)&255}function k(e,t,n,r,i,a){if(t>i||a>t)throw new RangeError("value is out of bounds");if(n+r>e.length)throw new RangeError("index out of range");if(0>n)throw new RangeError("index out of range")}function F(e,t,n,r,i){return i||k(e,t,n,4,3.4028234663852886e38,-3.4028234663852886e38),X.write(e,t,n,r,23,4),n+4}function B(e,t,n,r,i){return i||k(e,t,n,8,1.7976931348623157e308,-1.7976931348623157e308),X.write(e,t,n,r,52,8),n+8}function K(e){if(e=V(e).replace(ee,""),e.length<2)return"";for(;e.length%4!==0;)e+="=";return e}function V(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function j(e){return 16>e?"0"+e.toString(16):e.toString(16)}function W(e,t){t=t||1/0;for(var n,r=e.length,i=null,a=[],o=0;r>o;o++){if(n=e.charCodeAt(o),n>55295&&57344>n){if(!i){if(n>56319){(t-=3)>-1&&a.push(239,191,189);continue}if(o+1===r){(t-=3)>-1&&a.push(239,191,189);continue}i=n;continue}if(56320>n){(t-=3)>-1&&a.push(239,191,189),i=n;continue}n=(i-55296<<10|n-56320)+65536}else i&&(t-=3)>-1&&a.push(239,191,189);if(i=null,128>n){if((t-=1)<0)break;a.push(n)}else if(2048>n){if((t-=2)<0)break;a.push(n>>6|192,63&n|128)}else if(65536>n){if((t-=3)<0)break;a.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(1114112>n))throw new Error("Invalid code point");if((t-=4)<0)break;a.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return a}function q(e){for(var t=[],n=0;n<e.length;n++)t.push(255&e.charCodeAt(n));return t}function Y(e,t){for(var n,r,i,a=[],o=0;o<e.length&&!((t-=2)<0);o++)n=e.charCodeAt(o),r=n>>8,i=n%256,a.push(i),a.push(r);return a}function H(e){return G.toByteArray(K(e))}function $(e,t,n,r){for(var i=0;r>i&&!(i+n>=t.length||i>=e.length);i++)t[i+n]=e[i];return i}var G=n(186),X=n(178),z=n(179);t.Buffer=e,t.SlowBuffer=v,t.INSPECT_MAX_BYTES=50,e.poolSize=8192;var J={};e.TYPED_ARRAY_SUPPORT=void 0!==r.TYPED_ARRAY_SUPPORT?r.TYPED_ARRAY_SUPPORT:i(),e.TYPED_ARRAY_SUPPORT?(e.prototype.__proto__=Uint8Array.prototype,e.__proto__=Uint8Array):(e.prototype.length=void 0,e.prototype.parent=void 0),e.isBuffer=function(e){return!(null==e||!e._isBuffer)},e.compare=function(t,n){if(!e.isBuffer(t)||!e.isBuffer(n))throw new TypeError("Arguments must be Buffers");if(t===n)return 0;for(var r=t.length,i=n.length,a=0,o=Math.min(r,i);o>a&&t[a]===n[a];)++a;return a!==o&&(r=t[a],i=n[a]),i>r?-1:r>i?1:0},e.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},e.concat=function(t,n){if(!z(t))throw new TypeError("list argument must be an Array of Buffers.");if(0===t.length)return new e(0);var r;if(void 0===n)for(n=0,r=0;r<t.length;r++)n+=t[r].length;var i=new e(n),a=0;for(r=0;r<t.length;r++){var o=t[r];o.copy(i,a),a+=o.length}return i},e.byteLength=g,e.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?M(this,0,e):A.apply(this,arguments)},e.prototype.equals=function(t){if(!e.isBuffer(t))throw new TypeError("Argument must be a Buffer");return this===t?!0:0===e.compare(this,t)},e.prototype.inspect=function(){var e="",n=t.INSPECT_MAX_BYTES;return this.length>0&&(e=this.toString("hex",0,n).match(/.{2}/g).join(" "),this.length>n&&(e+=" ... ")),"<Buffer "+e+">"},e.prototype.compare=function(t){if(!e.isBuffer(t))throw new TypeError("Argument must be a Buffer");return this===t?0:e.compare(this,t)},e.prototype.indexOf=function(t,n){function r(e,t,n){for(var r=-1,i=0;n+i<e.length;i++)if(e[n+i]===t[-1===r?0:i-r]){if(-1===r&&(r=i),i-r+1===t.length)return n+r}else r=-1;return-1}if(n>2147483647?n=2147483647:-2147483648>n&&(n=-2147483648),n>>=0,0===this.length)return-1;if(n>=this.length)return-1;if(0>n&&(n=Math.max(this.length+n,0)),"string"==typeof t)return 0===t.length?-1:String.prototype.indexOf.call(this,t,n);if(e.isBuffer(t))return r(this,t,n);if("number"==typeof t)return e.TYPED_ARRAY_SUPPORT&&"function"===Uint8Array.prototype.indexOf?Uint8Array.prototype.indexOf.call(this,t,n):r(this,[t],n);throw new TypeError("val must be string, number or Buffer")},e.prototype.get=function(e){return console.log(".get() is deprecated. Access using array indexes instead."),this.readUInt8(e)},e.prototype.set=function(e,t){return console.log(".set() is deprecated. Access using array indexes instead."),this.writeUInt8(e,t)},e.prototype.write=function(e,t,n,r){if(void 0===t)r="utf8",n=this.length,t=0;else if(void 0===n&&"string"==typeof t)r=t,n=this.length,t=0;else if(isFinite(t))t=0|t,isFinite(n)?(n=0|n,void 0===r&&(r="utf8")):(r=n,n=void 0);else{var i=r;r=t,t=0|n,n=i}var a=this.length-t;if((void 0===n||n>a)&&(n=a),e.length>0&&(0>n||0>t)||t>this.length)throw new RangeError("attempt to write outside buffer bounds");r||(r="utf8");for(var o=!1;;)switch(r){case"hex":return S(this,e,t,n);case"utf8":case"utf-8":return E(this,e,t,n);case"ascii":return T(this,e,t,n);case"binary":return b(this,e,t,n);case"base64":return N(this,e,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return _(this,e,t,n);default:if(o)throw new TypeError("Unknown encoding: "+r);r=(""+r).toLowerCase(),o=!0}},e.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var Q=4096;e.prototype.slice=function(t,n){var r=this.length;t=~~t,n=void 0===n?r:~~n,0>t?(t+=r,0>t&&(t=0)):t>r&&(t=r),0>n?(n+=r,0>n&&(n=0)):n>r&&(n=r),t>n&&(n=t);var i;if(e.TYPED_ARRAY_SUPPORT)i=e._augment(this.subarray(t,n));else{var a=n-t;i=new e(a,void 0);for(var o=0;a>o;o++)i[o]=this[o+t]}return i.length&&(i.parent=this.parent||this),i},e.prototype.readUIntLE=function(e,t,n){e=0|e,t=0|t,n||O(e,t,this.length);for(var r=this[e],i=1,a=0;++a<t&&(i*=256);)r+=this[e+a]*i;return r},e.prototype.readUIntBE=function(e,t,n){e=0|e,t=0|t,n||O(e,t,this.length);for(var r=this[e+--t],i=1;t>0&&(i*=256);)r+=this[e+--t]*i;return r},e.prototype.readUInt8=function(e,t){return t||O(e,1,this.length),this[e]},e.prototype.readUInt16LE=function(e,t){return t||O(e,2,this.length),this[e]|this[e+1]<<8},e.prototype.readUInt16BE=function(e,t){return t||O(e,2,this.length),this[e]<<8|this[e+1]},e.prototype.readUInt32LE=function(e,t){return t||O(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},e.prototype.readUInt32BE=function(e,t){return t||O(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},e.prototype.readIntLE=function(e,t,n){e=0|e,t=0|t,n||O(e,t,this.length);for(var r=this[e],i=1,a=0;++a<t&&(i*=256);)r+=this[e+a]*i;return i*=128,r>=i&&(r-=Math.pow(2,8*t)),r},e.prototype.readIntBE=function(e,t,n){e=0|e,t=0|t,n||O(e,t,this.length);for(var r=t,i=1,a=this[e+--r];r>0&&(i*=256);)a+=this[e+--r]*i;return i*=128,a>=i&&(a-=Math.pow(2,8*t)),a},e.prototype.readInt8=function(e,t){return t||O(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},e.prototype.readInt16LE=function(e,t){t||O(e,2,this.length);var n=this[e]|this[e+1]<<8;return 32768&n?4294901760|n:n},e.prototype.readInt16BE=function(e,t){t||O(e,2,this.length);var n=this[e+1]|this[e]<<8;return 32768&n?4294901760|n:n},e.prototype.readInt32LE=function(e,t){return t||O(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},e.prototype.readInt32BE=function(e,t){return t||O(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},e.prototype.readFloatLE=function(e,t){return t||O(e,4,this.length),X.read(this,e,!0,23,4)},e.prototype.readFloatBE=function(e,t){return t||O(e,4,this.length),X.read(this,e,!1,23,4)},e.prototype.readDoubleLE=function(e,t){return t||O(e,8,this.length),X.read(this,e,!0,52,8)},e.prototype.readDoubleBE=function(e,t){return t||O(e,8,this.length),X.read(this,e,!1,52,8)},e.prototype.writeUIntLE=function(e,t,n,r){e=+e,t=0|t,n=0|n,r||D(this,e,t,n,Math.pow(2,8*n),0);var i=1,a=0;for(this[t]=255&e;++a<n&&(i*=256);)this[t+a]=e/i&255;return t+n},e.prototype.writeUIntBE=function(e,t,n,r){e=+e,t=0|t,n=0|n,r||D(this,e,t,n,Math.pow(2,8*n),0);var i=n-1,a=1;for(this[t+i]=255&e;--i>=0&&(a*=256);)this[t+i]=e/a&255;return t+n},e.prototype.writeUInt8=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,1,255,0),e.TYPED_ARRAY_SUPPORT||(t=Math.floor(t)),this[n]=255&t,n+1},e.prototype.writeUInt16LE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,2,65535,0),e.TYPED_ARRAY_SUPPORT?(this[n]=255&t,this[n+1]=t>>>8):x(this,t,n,!0),n+2},e.prototype.writeUInt16BE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,2,65535,0),e.TYPED_ARRAY_SUPPORT?(this[n]=t>>>8,this[n+1]=255&t):x(this,t,n,!1),n+2},e.prototype.writeUInt32LE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,4,4294967295,0),e.TYPED_ARRAY_SUPPORT?(this[n+3]=t>>>24,this[n+2]=t>>>16,this[n+1]=t>>>8,this[n]=255&t):U(this,t,n,!0),n+4},e.prototype.writeUInt32BE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,4,4294967295,0),e.TYPED_ARRAY_SUPPORT?(this[n]=t>>>24,this[n+1]=t>>>16,this[n+2]=t>>>8,this[n+3]=255&t):U(this,t,n,!1),n+4},e.prototype.writeIntLE=function(e,t,n,r){if(e=+e,t=0|t,!r){var i=Math.pow(2,8*n-1);D(this,e,t,n,i-1,-i)}var a=0,o=1,s=0>e?1:0;for(this[t]=255&e;++a<n&&(o*=256);)this[t+a]=(e/o>>0)-s&255;return t+n},e.prototype.writeIntBE=function(e,t,n,r){if(e=+e,t=0|t,!r){var i=Math.pow(2,8*n-1);D(this,e,t,n,i-1,-i)}var a=n-1,o=1,s=0>e?1:0;for(this[t+a]=255&e;--a>=0&&(o*=256);)this[t+a]=(e/o>>0)-s&255;return t+n},e.prototype.writeInt8=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,1,127,-128),e.TYPED_ARRAY_SUPPORT||(t=Math.floor(t)),0>t&&(t=255+t+1),this[n]=255&t,n+1},e.prototype.writeInt16LE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,2,32767,-32768),e.TYPED_ARRAY_SUPPORT?(this[n]=255&t,this[n+1]=t>>>8):x(this,t,n,!0),n+2},e.prototype.writeInt16BE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,2,32767,-32768),e.TYPED_ARRAY_SUPPORT?(this[n]=t>>>8,this[n+1]=255&t):x(this,t,n,!1),n+2},e.prototype.writeInt32LE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,4,2147483647,-2147483648),e.TYPED_ARRAY_SUPPORT?(this[n]=255&t,this[n+1]=t>>>8,this[n+2]=t>>>16,this[n+3]=t>>>24):U(this,t,n,!0),n+4},e.prototype.writeInt32BE=function(t,n,r){return t=+t,n=0|n,r||D(this,t,n,4,2147483647,-2147483648),0>t&&(t=4294967295+t+1),e.TYPED_ARRAY_SUPPORT?(this[n]=t>>>24,this[n+1]=t>>>16,this[n+2]=t>>>8,this[n+3]=255&t):U(this,t,n,!1),n+4},e.prototype.writeFloatLE=function(e,t,n){return F(this,e,t,!0,n)},e.prototype.writeFloatBE=function(e,t,n){return F(this,e,t,!1,n)},e.prototype.writeDoubleLE=function(e,t,n){return B(this,e,t,!0,n)},e.prototype.writeDoubleBE=function(e,t,n){return B(this,e,t,!1,n)},e.prototype.copy=function(t,n,r,i){if(r||(r=0),i||0===i||(i=this.length),n>=t.length&&(n=t.length),n||(n=0),i>0&&r>i&&(i=r),i===r)return 0;if(0===t.length||0===this.length)return 0;if(0>n)throw new RangeError("targetStart out of bounds");if(0>r||r>=this.length)throw new RangeError("sourceStart out of bounds");if(0>i)throw new RangeError("sourceEnd out of bounds");i>this.length&&(i=this.length),t.length-n<i-r&&(i=t.length-n+r);var a,o=i-r;if(this===t&&n>r&&i>n)for(a=o-1;a>=0;a--)t[a+n]=this[a+r];else if(1e3>o||!e.TYPED_ARRAY_SUPPORT)for(a=0;o>a;a++)t[a+n]=this[a+r];else t._set(this.subarray(r,r+o),n);return o},e.prototype.fill=function(e,t,n){if(e||(e=0),t||(t=0),n||(n=this.length),t>n)throw new RangeError("end < start");if(n!==t&&0!==this.length){if(0>t||t>=this.length)throw new RangeError("start out of bounds");if(0>n||n>this.length)throw new RangeError("end out of bounds");var r;if("number"==typeof e)for(r=t;n>r;r++)this[r]=e;else{var i=W(e.toString()),a=i.length;for(r=t;n>r;r++)this[r]=i[r%a]}return this}},e.prototype.toArrayBuffer=function(){if("undefined"!=typeof Uint8Array){if(e.TYPED_ARRAY_SUPPORT)return new e(this).buffer;for(var t=new Uint8Array(this.length),n=0,r=t.length;r>n;n+=1)t[n]=this[n];return t.buffer}throw new TypeError("Buffer.toArrayBuffer not supported in this browser")};var Z=e.prototype;e._augment=function(t){return t.constructor=e,t._isBuffer=!0,t._set=t.set,t.get=Z.get,t.set=Z.set,t.write=Z.write,t.toString=Z.toString,t.toLocaleString=Z.toString,t.toJSON=Z.toJSON,t.equals=Z.equals,t.compare=Z.compare,t.indexOf=Z.indexOf,t.copy=Z.copy,t.slice=Z.slice,t.readUIntLE=Z.readUIntLE,t.readUIntBE=Z.readUIntBE,t.readUInt8=Z.readUInt8,t.readUInt16LE=Z.readUInt16LE,t.readUInt16BE=Z.readUInt16BE,t.readUInt32LE=Z.readUInt32LE,t.readUInt32BE=Z.readUInt32BE,t.readIntLE=Z.readIntLE,t.readIntBE=Z.readIntBE,t.readInt8=Z.readInt8,t.readInt16LE=Z.readInt16LE,t.readInt16BE=Z.readInt16BE,t.readInt32LE=Z.readInt32LE,t.readInt32BE=Z.readInt32BE,t.readFloatLE=Z.readFloatLE,t.readFloatBE=Z.readFloatBE,t.readDoubleLE=Z.readDoubleLE,t.readDoubleBE=Z.readDoubleBE,t.writeUInt8=Z.writeUInt8,t.writeUIntLE=Z.writeUIntLE,t.writeUIntBE=Z.writeUIntBE,t.writeUInt16LE=Z.writeUInt16LE,t.writeUInt16BE=Z.writeUInt16BE,t.writeUInt32LE=Z.writeUInt32LE,t.writeUInt32BE=Z.writeUInt32BE,t.writeIntLE=Z.writeIntLE,t.writeIntBE=Z.writeIntBE,t.writeInt8=Z.writeInt8,t.writeInt16LE=Z.writeInt16LE,t.writeInt16BE=Z.writeInt16BE,t.writeInt32LE=Z.writeInt32LE,t.writeInt32BE=Z.writeInt32BE,t.writeFloatLE=Z.writeFloatLE,t.writeFloatBE=Z.writeFloatBE,t.writeDoubleLE=Z.writeDoubleLE,t.writeDoubleBE=Z.writeDoubleBE,t.fill=Z.fill,t.inspect=Z.inspect,t.toArrayBuffer=Z.toArrayBuffer,t};var ee=/[^+\/0-9A-Za-z-_]/g}).call(t,n(97).Buffer,function(){return this}())},function(e,t,n){"use strict";function r(e,t){return Object.prototype.hasOwnProperty.call(e,t)}e.exports=function(e,t,n,i){t=t||"&",n=n||"=";var a={};if("string"!=typeof e||0===e.length)return a;var o=/\+/g;e=e.split(t);var s=1e3;i&&"number"==typeof i.maxKeys&&(s=i.maxKeys);var u=e.length;s>0&&u>s&&(u=s);for(var l=0;u>l;++l){var p,c,f,d,m=e[l].replace(o,"%20"),h=m.indexOf(n);h>=0?(p=m.substr(0,h),c=m.substr(h+1)):(p=m,c=""),f=decodeURIComponent(p),d=decodeURIComponent(c),r(a,f)?Array.isArray(a[f])?a[f].push(d):a[f]=[a[f],d]:a[f]=d}return a}},function(e,t,n){"use strict";var r=function(e){switch(typeof e){case"string":return e;case"boolean":return e?"true":"false";case"number":return isFinite(e)?e:"";default:return""}};e.exports=function(e,t,n,i){return t=t||"&",n=n||"=",null===e&&(e=void 0),"object"==typeof e?Object.keys(e).map(function(i){var a=encodeURIComponent(r(i))+n;return Array.isArray(e[i])?e[i].map(function(e){return a+encodeURIComponent(r(e))}).join(t):a+encodeURIComponent(r(e[i]))}).join(t):i?encodeURIComponent(r(i))+n+encodeURIComponent(r(e)):""}},function(e,t,n){"use strict";function r(){return new b(b.OK,"","",null)}function i(e,t,n,r,i){void 0===n&&(n={}),void 0===r&&(r=b.ERROR),void 0===i&&(i=!1);var a=N(e,n);return new b(r,e.code,a,t,i)}function a(){return te}function o(e,t){return new Z(e,t)}function s(e,t){return new ee(e,t)}function u(e,n){var r=new J(e);return n.forEach(function(e){return r.addSuper(e)}),r.isSubTypeOf(t.NIL)&&(r.nullable=!0),r}function l(e){return u(e,[t.OBJECT])}function p(e,t,n){if(t.isScalar()&&n.isScalar()){if(-1!=t.allSubTypes().indexOf(n))return t;if(-1!=n.allSubTypes().indexOf(t))return n}var r=t.oneMeta(R.Discriminator),i=n.oneMeta(R.Discriminator);if(r&&i&&r.property===i.property){var a=t.descValue(),o=n.descValue();if(a!==o){var s=e[r.property];if(s===a)return t;if(s===o)return n}}return null}function c(e){return parseFloat(e)!=parseInt(e)||isNaN(e)?!1:!0}function f(e){for(var t=[];null!=e;){if(null!=e.name()){t.push(e.name());break}if(!(e instanceof J))break;var n=e.contextMeta();if(null==n)break;t.push(n.path()),e=n._owner}return t.reverse()}function d(e,n,a){var o=n.metaOfType(R.Discriminator);if(0==o.length)return null;var s=o[0].value(),u=S.find([n].concat(n.allSuperTypes()),function(e){return e.getExtra(t.GLOBAL)});if(!u)return null;var l=u.name(),p=n.metaOfType(R.DiscriminatorValue);if(0!=p.length&&(l=p[0].value()),l){if(e.hasOwnProperty(s)){var c=e[s];if(c!=l){var f=i(b.CODE_INCORRECT_DISCRIMINATOR,this,{rootType:u.name(),value:c,propName:s},b.WARNING);return m(f,{name:s,child:a}),f}return r()}var d=i(b.CODE_MISSING_DISCRIMINATOR,this,{rootType:u.name(),propName:s});return m(d,a),d}}function m(e,t){if(e.getValidationPath()){for(var n=h(t),r=n;r.child;)r=r.child;r.child=e.getValidationPath(),e.setValidationPath(n)}else e.setValidationPath(t);e.getSubStatuses().forEach(function(e){m(e,t)})}function h(e){if(e){for(var t=e,n=null,r=null;t;)if(n){var i={name:t.name};r.child=i,t=t.child,r=i}else n={name:t.name},r=n,t=t.child,r=n;return n}return null}function y(e){for(var t=T.getAnnotationValidationPlugins(),n=[],r=0,i=t;r<i.length;r++){var a=i[r],o=a.process(e);o&&o.forEach(function(t){n.push(g(t,a.id(),e.entry()))})}return n}function v(e,t){for(var n=T.getTypeValidationPlugins(),r=[],i=0,a=n;i<a.length;i++){var o=a[i],s=o.process(e,t);s&&s.forEach(function(t){r.push(g(t,o.id(),e))})}return r}function g(e,t,n){var r=e.isWarning?b.WARNING:b.ERROR,i=e.issueCode||t,a=e.message||"The "+t+" plugin reports an error",o=new b(r,i,a,n);return o.setValidationPath(e.path),o}var A=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},S=n(185),E=n(110),T=n(101);t.messageRegistry=n(182);var b=function(){function e(e,t,n,r,i){void 0===i&&(i=!1),this.takeNodeFromSource=i,this.subStatus=[],this.severity=e,this.code=t,this.message=n,this.source=r}return e.prototype.getValidationPath=function(){return this.vp},e.prototype.getValidationPathAsString=function(){if(!this.vp)return"";for(var e="",t=this.vp;t;)e+=t.name,t.child&&(e+="/"),t=t.child;return e},e.prototype.setValidationPath=function(e){this.vp=e},e.prototype.addSubStatus=function(t,n){if(void 0===n&&(n=null),t){n&&m(t,{name:n}),this.subStatus.push(t);var r=e.OK;t.isOk()||(t.isError()?r=e.ERROR:t.isWarning()?r=e.WARNING:t.isInfo()&&(r=e.INFO)),this.severity<r&&(this.severity=r,this.message=t.getMessage())}},e.prototype.getErrors=function(){if(this.isError()||this.isWarning()){if(this.subStatus.length>0){var e=[];return this.subStatus.forEach(function(t){return e=e.concat(t.getErrors())}),e}return[this]}return[]},e.prototype.getSubStatuses=function(){return this.subStatus},e.prototype.getSeverity=function(){return this.severity},e.prototype.getMessage=function(){return this.message},e.prototype.setMessage=function(e){this.message=e},e.prototype.getSource=function(){return this.source},e.prototype.getCode=function(){return this.code},e.prototype.setCode=function(e){this.code=e},e.prototype.isWarning=function(){return this.severity==e.WARNING},e.prototype.isError=function(){return this.severity==e.ERROR},e.prototype.isOk=function(){return this.severity===e.OK},e.prototype.isInfo=function(){return this.severity===e.INFO},e.prototype.setSource=function(e){this.source=e},e.prototype.toString=function(){return this.isOk()?"OK":this.message},e.prototype.getExtra=function(e){return this.takeNodeFromSource&&e==T.SOURCE_EXTRA&&this.source instanceof _?this.source.node():null},e.prototype.putExtra=function(e,t){},e.CODE_CONFLICTING_TYPE_KIND=4,e.CODE_INCORRECT_DISCRIMINATOR=t.messageRegistry.INCORRECT_DISCRIMINATOR,e.CODE_MISSING_DISCRIMINATOR=t.messageRegistry.MISSING_DISCRIMINATOR,e.ERROR=3,e.INFO=1,e.OK=0,e.WARNING=2,e}();t.Status=b,t.ok=r,t.SCHEMA_AND_TYPE=T.SCHEMA_AND_TYPE_EXTRA,t.GLOBAL=T.GLOBAL_EXTRA,t.TOPLEVEL=T.TOP_LEVEL_EXTRA,t.SOURCE_EXTRA=T.SOURCE_EXTRA;var N=function(e,t){for(var n="",r=e.message,i=0,a=r.indexOf("{{");a>=0;a=r.indexOf("{{",i)){if(n+=r.substring(i,a),i=r.indexOf("}}",a),0>i){i=a;break}a+="{{".length;var o=r.substring(a,i);i+="}}".length;var s=t[o];if(void 0===s)throw new Error("Message parameter '"+o+"' has no value specified.");n+=s}return n+=r.substring(i,r.length)};t.error=i;var _=function(){function e(e){this._inheritable=e,this._annotations=[]}return e.prototype.node=function(){return this._node},e.prototype.setNode=function(e){this._node=e},e.prototype.owner=function(){return this._owner},e.prototype.isInheritable=function(){return this._inheritable},e.prototype.validateSelf=function(e){for(var t=r(),n=0,i=this._annotations;n<i.length;n++){var a=i[n],o=a.validateSelf(e);o.isOk()||t.addSubStatus(o)}for(var s=new ye(this,e),u=y(s),l=0,p=u;l<p.length;l++){var c=p[l];t.addSubStatus(c)}return m(t,{name:this.facetName()}),t},e.prototype.requiredTypes=function(){return[]},e.prototype.annotations=function(){return this._annotations},e.prototype.addAnnotation=function(e){this._annotations.push(e)},e}();t.TypeInformation=_;var w=null,M=function(e){function t(t){void 0===t&&(t=!0),e.call(this,t)}return A(t,e),t.prototype.intersect=function(e,n){var r=e.id()+""+n.id();if(t.intersections.hasOwnProperty(r))return t.intersections[r];var i=s(r,[e,n]);return t.intersections[r]=i,i},t.prototype.release=function(e){delete t.intersections[e.name()]},t.prototype.nothing=function(e,t){return void 0===t&&(t="Conflicting restrictions"),new ie(w,t,e)},t.prototype.composeWith=function(e){return null},t.prototype.preoptimize=function(){null===w&&(w=new re(null,null,"top")),w=w.push(this);try{return this.innerOptimize()}finally{w=w.pop()}},t.prototype.innerOptimize=function(){return this},t.prototype.tryCompose=function(e){null===w&&(w=new re(null,null,"top")),w=w.push(this);try{return this.composeWith(e)}finally{w=w.pop()}},t.prototype.kind=function(){return T.MetaInformationKind.Constraint},t.prototype.conflictMessage=function(e,t){return null},t.intersections={},t}(_);t.Constraint=M;var I=n(104),R=n(105),C=n(103),L=n(104),P=n(105),O=n(105),D=n(104),x=n(104),U=n(142),k=n(105),F=n(104);t.autoCloseFlag=!1;var B=function(){function e(e){void 0===e&&(e=null),this._parent=e,this._types={},this.typeList=[]}return e.prototype.put=function(e,t){this._types[e]=t},e.prototype.addType=function(e){e.isAnonymous()||(this._types[e.name()]=e,this.typeList.push(e))},e.prototype.get=function(e){return this._types.hasOwnProperty(e)?this._types[e]:null!=this._parent?this._parent.get(e):null},e.prototype.types=function(){return this.typeList},e.prototype.typeMap=function(){return this._types},e.prototype.parent=function(){return this._parent},e}();t.TypeRegistry=B;var K=function(){function e(){}return e.prototype.getInfos=function(e){if(e.getExtra("PInfos"))return e.getExtra("PInfos");var t={};return e.meta().forEach(function(e){if(e instanceof I.HasProperty){var n=e.value();t[n]={name:n,type:null}}}),e.meta().forEach(function(e){if(e instanceof I.PropertyIs){var n=e.propertyName();t[n]&&(t[n].type=e.value())}}),e.putExtra("PInfos",t),t},e.prototype.validate=function(e,t){var n=this,r=this.getInfos(e),i=!1;return Object.keys(r).forEach(function(e){i=i||n.validateInfo(r[e],t)}),i},e.prototype.validateInfo=function(e,t){var n=this;if(t.some(function(t){return t==e}))return!0;if(e.type instanceof Z){var r=e.type,i=!0;return r.options().forEach(function(r){n.validate(r,[e].concat(t))||(i=!1)}),i}return e.type.isArray()?void 0:this.validate(e.type,[e].concat(t))},e.prototype.validateType=function(e){var t=this,n=this.getInfos(e),r=[];return Object.keys(n).forEach(function(e){t.validateInfo(n[e],[])&&r.push(e)}),r},e}(),V=function(e){function n(n,r,i){e.call(this,b.ERROR,t.messageRegistry.RESTRICTIONS_CONFLICT.code,null,i),this._conflicting=n,this._stack=r,this.source=i,this.computeMessage()}return A(n,e),n.prototype.computeMessage=function(){var e=null;if(null!=this._stack&&this._stack.getRestriction()instanceof I.MinMaxRestriction){var t=this._stack.getRestriction();e=this._conflicting.conflictMessage(t.facetPath(),t.value())}null==e&&(e=this._conflicting+" and "+(null!=this._stack?this._stack.getRestriction().toString():""));var n="";if(this.source instanceof W){for(var r=[],i=this._stack;i;){var a=i.getRestriction();if(a instanceof D.PropertyIs){var o={name:a.propId()};r.length>0&&(o.child=r[r.length-1]),r.push(o)}i=i.pop()}m(this,r.pop());var s=I.anotherRestrictionComponent();n=s?" between types '"+f(this.source)+"' and '"+f(s)+"'":" in type '"+f(this.source)+"'"}this.message="Restrictions conflict"+n+": "+e},n.prototype.getConflictDescription=function(){var e="";return e+="Restrictions coflict:\n",e+=this._stack.getRestriction()+" conflicts with "+this._conflicting+"\n",e+="at\n",e+=this._stack.pop()},n.prototype.getConflicting=function(){return this._conflicting},n.prototype.getStack=function(){return this._stack},n.prototype.toRestriction=function(){return new ie(this._stack,this.message,this._conflicting)},n}(b);t.RestrictionsConflict=V;var j=0;t.VALIDATED_TYPE=null;var W=function(){function e(e){this._name=e,this.metaInfo=[],this._subTypes=[],this.innerid=j++,this.extras={},this._locked=!1}return e.prototype.getExtra=function(e){return this.extras[e]},e.prototype.putExtra=function(e,t){this.extras[e]=t},e.prototype.id=function(){return this.innerid},e.prototype.knownProperties=function(){return this.metaOfType(F.MatchesProperty)},e.prototype.lock=function(){this._locked=!0},e.prototype.isLocked=function(){return this._locked},e.prototype.allFacets=function(){return this.meta()},e.prototype.declaredFacets=function(){return this.declaredMeta()},e.prototype.isSubTypeOf=function(e){return e===t.ANY||this===e||this.superTypes().some(function(t){return t.isSubTypeOf(e)})},e.prototype.isSuperTypeOf=function(e){return this===e||-1!=this.allSubTypes().indexOf(e)},e.prototype.addMeta=function(e){this.metaInfo.push(e),e._owner=this},e.prototype.name=function(){return this._name},e.prototype.label=function(){return this._name},e.prototype.subTypes=function(){return this._subTypes},e.prototype.superTypes=function(){return[]},e.prototype.addSupertypeAnnotation=function(e,t){if(e&&0!=e.length){this.supertypeAnnotations||(this.supertypeAnnotations=[]);var n=this.supertypeAnnotations[t];n||(n={},this.supertypeAnnotations[t]=n);for(var r=0,i=e;r<i.length;r++){var a=i[r];n[a.facetName()]=a}}},e.prototype.validateType=function(e){var n=this;void 0===e&&(e=a());var r=new b(b.OK,"","",this);if(this.validateHierarchy(r),this.getExtra(T.PARSE_ERROR)&&r.addSubStatus(this.getExtra(T.PARSE_ERROR)),r.isOk()){if(r.addSubStatus(this.checkConfluent()),this.isExternal()&&"external"==this.kind()){var o=this;if(o.isJSON())try{var s=E.getJSONSchema(o.schema(),o.getContentProvider&&o.getContentProvider());s&&s.validateSelf()}catch(u){if("Maximum call stack size exceeded"==u.message)return i(t.messageRegistry.CIRCULAR_REFS_IN_JSON_SCHEMA,this);if(u instanceof he){var l=u;r.addSubStatus(i(l.messageEntry,this,l.parameters,l.isWarning?b.WARNING:b.ERROR))}else r.addSubStatus(i(t.messageRegistry.JSON_SCHEMA_VALIDATION_EXCEPTION,this,{msg:u.message}))}}r.isOk()&&this.superTypes().forEach(function(t){if(t.isAnonymous()){var n=t.validateType(e);n.isOk()||(m(n,{name:"type"}),r.addSubStatus(n))}})}if(this.getExtra(t.SCHEMA_AND_TYPE)&&r.addSubStatus(i(t.messageRegistry.SCHEMA_AND_TYPE,this)),r.isOk()&&this.validateMeta(e).getErrors().forEach(function(e){
return r.addSubStatus(e)}),this.isObject()){var p={};this.restrictions().forEach(function(e){e.owner()!=n&&e instanceof I.HasProperty&&(p[e.value()]=!0)}),this.declaredMeta().forEach(function(e){e instanceof I.HasProperty&&delete p[e.value()]}),this.declaredMeta().forEach(function(e){if(e instanceof I.PropertyIs){var a=e;p.hasOwnProperty(a.propertyName())&&r.addSubStatus(i(t.messageRegistry.REQUIRED_OVERRIDE_OPTIONAL,n,{propertyName:a.propertyName()}))}});var c=(new K).validateType(this);c.length>0&&c.forEach(function(e){var a=i(t.messageRegistry.CYCLIC_DEPENDENCY,n,{typeName:e});m(a,{name:e}),r.addSubStatus(a)})}if(this.supertypeAnnotations)for(var f=0;f<this.supertypeAnnotations.length;f++)for(var d=this.supertypeAnnotations[f],h=0,g=Object.keys(d);h<g.length;h++){var A=g[h],S=d[A],N=S.validateSelf(e);N.isOk()||(m(N,{name:"type",child:{name:f}}),r.addSubStatus(N))}for(var _=v(this,e),w=0,M=_;w<M.length;w++){var R=M[w];r.addSubStatus(R)}for(var C=new ge(this,e),L=y(C),P=0,O=L;P<O.length;P++){var R=O[P];r.addSubStatus(R)}return r},e.prototype.validateHierarchy=function(e){var n=this;if(this.isAnonymous()||this.getExtra(T.TOP_LEVEL_EXTRA)&&a().get(this.name())&&e.addSubStatus(i(t.messageRegistry.REDEFINIG_BUILDTIN,this,{typeName:this.name()})),this.isSubTypeOf(t.RECURRENT)&&e.addSubStatus(i(t.messageRegistry.RECURRENT_DEFINITION,this),"type"),this.isSubTypeOf(t.UNKNOWN)&&e.addSubStatus(i(t.messageRegistry.INHERITING_UNKNOWN_TYPE,this),"type"),this.isUnion()){var r=this.typeFamily();r.some(function(e){return e.isSubTypeOf(t.RECURRENT)})&&e.addSubStatus(i(t.messageRegistry.RECURRENT_UNION_OPTION,this),"type"),r.some(function(e){return e.isSubTypeOf(t.UNKNOWN)})&&e.addSubStatus(i(t.messageRegistry.UNKNOWN_UNION_OPTION,this),"type")}if(this.isArray()){var o=this.familyWithArray(),s=this.getExtra(T.HAS_ITEMS)?"items":"type";if(-1!=o.indexOf(this)||o.some(function(e){return e===t.RECURRENT}))e.addSubStatus(i(t.messageRegistry.RECURRENT_ARRAY_DEFINITION,this),s);else if(o.some(function(e){return e===t.UNKNOWN})){var u=this.oneMeta(x.ComponentShouldBeOfType).value().name();e.addSubStatus(i(t.messageRegistry.UNKNOWN_ARRAY_COMPONENT,this,{componentTypeName:u}),s)}}var l=this.superTypes(),p=!1,c=!1;if(l.length>1&&l.forEach(function(e){e.isExternal()?p=!0:c=!0}),p&&c&&e.addSubStatus(i(t.messageRegistry.EXTERNALS_MIX,this)),this instanceof Z){var f=this;f.options().forEach(function(r){r.isExternal()&&e.addSubStatus(i(t.messageRegistry.EXTERNALS_MIX,n))})}if(this.isExternal()&&this.getExtra(T.HAS_FACETS)){var d=i(t.messageRegistry.EXTERNAL_FACET,this,{name:this.getExtra(T.HAS_FACETS)});m(d,{name:this.getExtra(T.HAS_FACETS)}),e.addSubStatus(d)}},e.prototype.familyWithArray=function(){var e=this.allSuperTypes(),t=this.oneMeta(x.ComponentShouldBeOfType);if(t){var n=t.value();e=e.concat(n.familyWithArray())}return e},e.prototype.validateMeta=function(e){var t=new b(b.OK,"","",this);return this.declaredMeta().forEach(function(n){n.validateSelf(e).getErrors().forEach(function(e){return t.addSubStatus(e)})}),this.validateFacets(t),t},e.prototype.validateFacets=function(e){var n=this,r={},a={},o={};this.meta().forEach(function(e){if(e instanceof P.FacetDeclaration){var t=e;r[t.actualName()]=t,t.isOptional()||t.owner()!==n&&(o[t.actualName()]=t),t.owner()!=n&&(a[t.actualName()]=t)}}),this.declaredMeta().forEach(function(r){if(r instanceof P.FacetDeclaration){var o=r;if(o.owner()==n){var s=o.actualName();a.hasOwnProperty(s)&&e.addSubStatus(i(t.messageRegistry.OVERRIDE_FACET,n,{name:s}));var u=C.getInstance().facetPrototypeWithName(s);(u&&u.isApplicable(n)||"type"==s||"properties"==o.facetName()||"schema"==s||"facets"==s||"uses"==s)&&e.addSubStatus(i(t.messageRegistry.OVERRIDE_BUILTIN_FACET,n,{name:s})),"("==s.charAt(0)&&e.addSubStatus(i(t.messageRegistry.FACET_START_BRACKET,n,{name:s}))}}});var s={};this.meta().forEach(function(e){e instanceof D.PropertyIs&&(s[e.propId()]=!0)});for(var u=0,l=this.meta();u<l.length;u++){var p=l[u];if(p instanceof O.CustomFacet){var c=p,f=c.facetName();if(r.hasOwnProperty(f)){var d=r[f],m=d.value();if(d.owner()==this&&c.owner()==this){var h=i(t.messageRegistry.FACET_CAN_NOT_BE_FIXED_BY_THE_DECLARING_TYPE,c);h.setValidationPath({name:f}),e.addSubStatus(h)}else e.addSubStatus(m.validateDirect(c.value(),!1,!1)),delete o[f]}else this.isExternal()?e.addSubStatus(i(t.messageRegistry.FACET_PROHIBITED_FOR_EXTERNALS,c,{facetName:f},b.ERROR,!0)):e.addSubStatus(i(t.messageRegistry.UNKNOWN_FACET,c,{facetName:f},b.ERROR,!0))}}Object.getOwnPropertyNames(o).length>0&&e.addSubStatus(i(t.messageRegistry.MISSING_REQUIRED_FACETS,this,{facetsList:Object.keys(o).map(function(e){return"'"+e+"'"}).join(",")}))},e.prototype.allSuperTypes=function(){var e=[];return this.fillSuperTypes(e),e},e.prototype.fillSuperTypes=function(e){this.superTypes().forEach(function(t){S.contains(e,t)||(e.push(t),t.fillSuperTypes(e))})},e.prototype.allSubTypes=function(){var e=[];return this.fillSubTypes(e),e},e.prototype.fillSubTypes=function(e){this.subTypes().forEach(function(t){S.contains(e,t)||(e.push(t),t.fillSubTypes(e))})},e.prototype.inherit=function(e){var t=new J(e);return t.addSuper(this),t},e.prototype.isAnonymous=function(){return!this._name||0===this._name.length},e.prototype.isEmpty=function(){return this.metaInfo.length>2?!1:0==this.metaInfo.filter(function(e){return e instanceof k.NotScalar?!1:e instanceof R.DiscriminatorValue?e.isStrict():!0}).length},e.prototype.isArray=function(){return this===t.ARRAY||-1!=this.allSuperTypes().indexOf(t.ARRAY)},e.prototype.propertySet=function(){var e=[];return this.meta().forEach(function(t){if(t instanceof D.PropertyIs){var n=t;e.push(n.propertyName())}}),S.uniq(e)},e.prototype.checkConfluent=function(){if(this.computeConfluent)return r();this.computeConfluent=!0;var e=I.anotherRestrictionComponentsCount();try{var t=I.optimize(this.restrictions()),n=S.find(t,function(e){return e instanceof ne});if(n){var i=null,a=null;if(n instanceof ie){var o=n;i=o.getStack(),a=o.another()}var s=new V(a,i,this);return s}return r()}finally{this.computeConfluent=!1,I.releaseAnotherRestrictionComponent(e)}},e.prototype.isObject=function(){return this==t.OBJECT||-1!=this.allSuperTypes().indexOf(t.OBJECT)},e.prototype.isExternal=function(){return this==t.EXTERNAL||-1!=this.allSuperTypes().indexOf(t.EXTERNAL)},e.prototype.isBoolean=function(){return this==t.BOOLEAN||-1!=this.allSuperTypes().indexOf(t.BOOLEAN)},e.prototype.isString=function(){return this==t.STRING||-1!=this.allSuperTypes().indexOf(t.STRING)},e.prototype.isNumber=function(){return this==t.NUMBER||-1!=this.allSuperTypes().indexOf(t.NUMBER)},e.prototype.isFile=function(){return this==t.FILE||-1!=this.allSuperTypes().indexOf(t.FILE)},e.prototype.isScalar=function(){return this==t.SCALAR||-1!=this.allSuperTypes().indexOf(t.SCALAR)},e.prototype.isDateTime=function(){return this==t.DATETIME||-1!=this.allSuperTypes().indexOf(t.DATETIME)},e.prototype.isDateOnly=function(){return this==t.DATE_ONLY||-1!=this.allSuperTypes().indexOf(t.DATE_ONLY)},e.prototype.isTimeOnly=function(){return this==t.TIME_ONLY||-1!=this.allSuperTypes().indexOf(t.TIME_ONLY)},e.prototype.isInteger=function(){return this==t.INTEGER||-1!=this.allSuperTypes().indexOf(t.INTEGER)},e.prototype.isDateTimeOnly=function(){return this==t.DATETIME_ONLY||-1!=this.allSuperTypes().indexOf(t.DATETIME_ONLY)},e.prototype.isUnknown=function(){return this==t.UNKNOWN||-1!=this.allSuperTypes().indexOf(t.UNKNOWN)},e.prototype.isRecurrent=function(){return this==t.RECURRENT||-1!=this.allSuperTypes().indexOf(t.RECURRENT)},e.prototype.isBuiltin=function(){return-1!=this.metaInfo.indexOf(X)},e.prototype.exampleObject=function(){return U.example(this)},e.prototype.isPolymorphic=function(){return this.meta().some(function(e){return e instanceof Y})},e.prototype.restrictions=function(e){if(void 0===e&&(e=!1),this.isUnion()){var t=[];return this.superTypes().forEach(function(e){t=t.concat(e.restrictions())}),t=t.concat(this.meta().filter(function(e){return e instanceof M}))}var n=[],r=null;return this.meta().forEach(function(t){if(t instanceof M){if(t instanceof ae&&e){if(r)return;r=t}n.push(t)}}),n},e.prototype.customFacets=function(){return this.declaredMeta().filter(function(e){return e instanceof R.CustomFacet})},e.prototype.allCustomFacets=function(){return this.meta().filter(function(e){return e instanceof R.CustomFacet})},e.prototype.isUnion=function(){var e=!1;return this.isBuiltin()?!1:(this.allSuperTypes().forEach(function(t){return e=e||t instanceof Z}),e)},e.prototype.isIntersection=function(){var e=!1;return this.isBuiltin()?!1:(this.allSuperTypes().forEach(function(t){return e=e||t instanceof ee}),e)},e.prototype.meta=function(){return[].concat(this.metaInfo)},e.prototype.validateDirect=function(e,n,r,a){var o=this;void 0===n&&(n=!1),void 0===r&&(r=!0),void 0===a&&(a=null);var s=t.VALIDATED_TYPE;try{var u=t.autoCloseFlag;n&&(t.autoCloseFlag=!0),t.VALIDATED_TYPE=this;var l=new b(b.OK,"","",this);if(!(r||null!==e&&void 0!==e||this.nullable))return i(t.messageRegistry.OBJECT_EXPECTED,this);if(this.restrictions(!0).forEach(function(t){return l.addSubStatus(t.check(e,a))}),(n||t.autoCloseFlag)&&this.isObject()&&!this.oneMeta(L.KnownPropertyRestriction)){var p=new L.KnownPropertyRestriction(!1);p.patchOwner(this),p.check(e).getErrors().forEach(function(e){var t=new b(b.WARNING,e.getCode(),e.getMessage(),o);m(t,e.getValidationPath()),l.addSubStatus(t)})}}finally{t.autoCloseFlag=u,t.VALIDATED_TYPE=s}return l},e.prototype.validate=function(e,n,a){void 0===n&&(n=!1),void 0===a&&(a=!0);var o=t.autoCloseFlag;if(!(a||null!==e&&void 0!==e||this.nullable))return i(t.messageRegistry.NULL_NOT_ALLOWED,this);n&&(t.autoCloseFlag=!0);try{for(var s,u=[],l=this.subTypes().concat(this),p=0,c=l;p<c.length;p++){var f=c[p],m=d(e,f),h=f.validateDirect(e,n||o);if(m){if(m.isOk())return h;u.push(m)}else if(h.isOk())return h;s=h}if(0==u.length)return s;var y=r();return u.forEach(function(e){return y.addSubStatus(e)}),u.pop()}finally{t.autoCloseFlag=o}},e.prototype.declareMapProperty=function(e,t){return null!=t&&this.addMeta(new I.MapPropertyIs(e,t)),t},e.prototype.closeUnknownProperties=function(){this.addMeta(new L.KnownPropertyRestriction(!1))},e.prototype.canDoAc=function(){for(var e=S.uniq(this.typeFamily()),t=new b(b.OK,"","",this),n=0;n<e.length;n++)for(var r=0;r<e.length;r++)if(n!=r){var i=e[n],a=e[r],o=this.emptyIntersectionOrDiscriminator(i,a);t.addSubStatus(o)}return t},e.prototype.emptyIntersectionOrDiscriminator=function(e,t){if(t===e)return r();if(t.isScalar()&&e.isScalar())return r();var n=s("",[e,t]),i=n.checkConfluent();return i.isOk()?this.checkDiscriminator(e,t):r()},e.prototype.checkDiscriminator=function(e,n){var a=i(t.messageRegistry.DISCRIMINATOR_NEEDED,this,{name1:e.name(),name2:n.name()}),o=e.oneMeta(R.Discriminator),s=n.oneMeta(R.Discriminator);if(null!=o&&null!=s&&o.value()===s.value()){var u=e.name(),l=n.name(),p=e.oneMeta(R.DiscriminatorValue);null!=p&&(u=p.value());var c=n.oneMeta(R.DiscriminatorValue);if(null!=c&&(l=c.value()),u!==l)return r();a=i(t.messageRegistry.SAME_DISCRIMINATOR_VALUE,this,{name1:e.name(),name2:n.name()})}return a},e.prototype.ac=function(e){if(!this.isPolymorphic()&&!this.isUnion())return this;if(this.isBuiltin())return this;var n=S.uniq(this.typeFamily());if(0==n.length)return t.NOTHING;if(this.isScalar())return this.isNumber()?"number"==typeof e?this:t.NOTHING:this.isString()?"string"==typeof e?this:t.NOTHING:this.isBoolean()?"boolean"==typeof e?this:t.NOTHING:this;if(1===n.length)return n[0];var r=[];n.forEach(function(t){var n=t.validateDirect(e,!0);n.isOk()&&r.push(t)});var i=this.discriminate(e,r);return i?i:t.NOTHING},e.prototype.declareProperty=function(e,t,n){return n||this.addMeta(new I.HasProperty(e)),null!=t&&this.addMeta(new I.PropertyIs(e,t)),this},e.prototype.discriminate=function(e,t){for(var n=[].concat(t),r=[].concat(t);n.length>1;){var i=!1;e:for(var a=0;a<r.length;a++)for(var o=0;o<r.length;o++){var s=r[a],u=r[o];if(s!=u){var l=p(e,s,u);if(l===s){r=r.filter(function(e){return e!=u}),i=!0;break e}if(l===u){r=r.filter(function(e){return e!=s}),i=!0;break e}r=r.filter(function(e){return e!=s&&e!=u}),i=!0;break e}}n=r}return 1==n.length?n[0]:null},e.prototype.oneMeta=function(e){return S.find(this.meta(),function(t){return t instanceof e})},e.prototype.metaOfType=function(e){return this.meta().filter(function(t){return t instanceof e})},e.prototype.declaredMeta=function(){return this.metaInfo},e.prototype.descValue=function(){var e=this.oneMeta(R.DiscriminatorValue);return e?e.value():this.name()},e.prototype.isAbstractOrInternal=function(){return this.metaInfo.some(function(e){return e instanceof H||e instanceof $})},e.prototype.typeFamily=function(){if(this.isUnion()){var e=[];return this.allSuperTypes().forEach(function(t){if(t instanceof Z)for(var n=t.allOptions(),r=0;r<n.length;r++)e=e.concat(n[r].typeFamily())}),S.unique(e)}var t=[];return this.isAbstractOrInternal()||t.push(this),this.allSubTypes().forEach(function(e){e.isAbstractOrInternal()||t.push(e)}),S.unique(t)},e.prototype.hasPropertiesFacet=function(){return this.metaInfo.some(function(e){return e instanceof R.HasPropertiesFacet})},e}();t.AbstractType=W;var q=function(e){function n(){e.apply(this,arguments)}return A(n,e),n.prototype.requiredType=function(){return t.ANY},n.prototype.kind=function(){return T.MetaInformationKind.Modifier},n}(_);t.Modifier=q;var Y=function(e){function t(){e.call(this,!0)}return A(t,e),t.prototype.facetName=function(){return"polymorphic"},t.prototype.value=function(){return!0},t}(q);t.Polymorphic=Y;var H=function(e){function t(){e.call(this,!1)}return A(t,e),t.prototype.value=function(){return!0},t.prototype.facetName=function(){return"abstract"},t}(q);t.Abstract=H;var $=function(e){function t(){e.call(this,!1)}return A(t,e),t.prototype.facetName=function(){return"abstract"},t.prototype.value=function(){return!0},t}(q);t.Internal=$;var G=function(e){function t(){e.call(this,!1)}return A(t,e),t.prototype.facetName=function(){return"builtIn"},t.prototype.value=function(){return!0},t}(q),X=new G,z=function(e){function t(){e.apply(this,arguments)}return A(t,e),t.prototype.kind=function(){return"root"},t}(W);t.RootType=z;var J=function(e){function t(){e.apply(this,arguments),this._superTypes=[]}return A(t,e),t.prototype.superTypes=function(){return this._superTypes},t.prototype.knownProperties=function(){var e=this.metaOfType(F.MatchesProperty);return this.superTypes().forEach(function(t){e=e.concat(t.knownProperties())}),e},t.prototype.kind=function(){return"inherited"},t.prototype.meta=function(){var t=this,n=e.prototype.meta.call(this),r=!1;return this.superTypes().forEach(function(e){e.meta().forEach(function(e){if(e instanceof L.KnownPropertyRestriction){if(r)return;var i=new L.KnownPropertyRestriction(!1);return i.patchOwner(t),void n.push(i)}e.isInheritable()&&n.push(e)})}),n},t.prototype.addSuper=function(e){this._superTypes.push(e),e.isLocked()||e._subTypes.push(this),e.nullable&&(this.nullable=!0)},t.prototype.label=function(){var t=this.metaOfType(x.ComponentShouldBeOfType);return t.length>0?t[0].value().label()+"[]":e.prototype.label.call(this)},t.prototype.contextMeta=function(){return this._contextMeta},t.prototype.setContextMeta=function(e){this._contextMeta=e},t.prototype.patch=function(e){for(var t in e)e.hasOwnProperty(t)&&(this[t]=e[t])},t}(W);t.InheritedType=J;var Q=function(e){function t(t,n){e.call(this,t),this._options=n}return A(t,e),t.prototype.allOptions=function(){var e=this,t=[];return this._options.forEach(function(n){n.kind()==e.kind()?t=t.concat(n.allOptions()):t.push(n)}),S.unique(t)},t.prototype.options=function(){return this._options},t}(W);t.DerivedType=Q;var Z=function(e){function n(t,n){var r=this;e.call(this,t,n),this.options().forEach(function(e){e.nullable&&(r.nullable=!0)})}return A(n,e),n.prototype.kind=function(){return"union"},n.prototype.isSubTypeOf=function(e){var t=!0;return this.allOptions().forEach(function(n){n.isSubTypeOf(e)||(t=!1)}),t},n.prototype.validate=function(e){return this.validateDirect(e)},n.prototype.typeFamily=function(){var e=[];return this.allOptions().forEach(function(t){e=e.concat(t.typeFamily())}),e},n.prototype.knownProperties=function(){var e=this.metaOfType(F.MatchesProperty);return this.options().forEach(function(t){e=e.concat(t.knownProperties())}),e},n.prototype.validateDirect=function(e,t){void 0===t&&(t=!1);var n=new b(b.OK,"","",this);return this.restrictions().forEach(function(t){return n.addSubStatus(t.check(e,null))}),n},n.prototype.isUnion=function(){return!0},n.prototype.restrictions=function(){return[new pe(this.allOptions().map(function(e){return new ce(e.restrictions())}),t.messageRegistry.UNION_TYPE_FAILURE,t.messageRegistry.UNION_TYPE_FAILURE_DETAILS)]},n.prototype.label=function(){return this.options().map(function(e){return e.label()}).join("|")},n}(Q);t.UnionType=Z;var ee=function(e){function t(){e.apply(this,arguments)}return A(t,e),t.prototype.kind=function(){return"intersection"},t.prototype.restrictions=function(){var e=[];return this.allOptions().forEach(function(t){return e=e.concat(t.restrictions())}),[new ce(e)]},t.prototype.label=function(){return this.options().map(function(e){return e.label()}).join("&")},t.prototype.isIntersection=function(){return!0},t}(Q);t.IntersectionType=ee;var te=new B;t.builtInRegistry=a,t.union=o,t.intersect=s,t.derive=u,t.deriveObjectType=l;var ne=function(e){function n(){e.apply(this,arguments)}return A(n,e),n.prototype.check=function(e){return null===e||void 0===e?r():i(t.messageRegistry.NOTHING,this)},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"nothing"},n.prototype.value=function(){return"!!!"},n}(M);t.NothingRestriction=ne;var re=function(){function e(e,t,n){this._previous=e,this._restriction=t,this.id=n}return e.prototype.getRestriction=function(){return this._restriction},e.prototype.pop=function(){return this._previous},e.prototype.push=function(t){return new e(this,t,t.toString())},e}();t.RestrictionStackEntry=re;var ie=function(e){function t(t,n,r){e.call(this),this._entry=t,this._message=n,this._another=r}return A(t,e),t.prototype.getMessage=function(){return this._message},t.prototype.getStack=function(){return this._entry},t.prototype.another=function(){return this._another},t}(ne);t.NothingRestrictionWithLocation=ie;var ae=function(e){function t(){e.apply(this,arguments)}return A(t,e),t}(M);t.GenericTypeOf=ae;var oe=function(e){function n(t){e.call(this),this.val=t}return A(n,e),n.prototype.check=function(e){var n=typeof e;return null===e||void 0===e?r():(Array.isArray(e)&&(n="array"),n===this.val?r():i(t.messageRegistry.TYPE_EXPECTED,this,{typeName:this.val}))},n.prototype.value=function(){return this.val},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"typeOf"},n.prototype.composeWith=function(e){if(e instanceof n){var t=e;return t.val==this.val?this:this.nothing(e)}return null},n.prototype.toString=function(){return"should be of type "+this.val},n}(ae);t.TypeOfRestriction=oe;var se=function(e){function n(){e.call(this)}return A(n,e),n.prototype.check=function(e){return"number"==typeof e&&c(e)?r():i(t.messageRegistry.INTEGER_EXPECTED,this)},n.prototype.requiredType=function(){return t.ANY},n.prototype.value=function(){return!0},n.prototype.facetName=function(){return"should be integer"},n}(ae);t.IntegerRestriction=se;var ue=function(e){function n(){e.call(this)}return A(n,e),n.prototype.check=function(e){return null===e||void 0==e||"null"===e?r():i(t.messageRegistry.NULL_EXPECTED,this)},n.prototype.requiredType=function(){return t.ANY},n.prototype.value=function(){return!0},n.prototype.facetName=function(){return"should be null"},n}(ae);t.NullRestriction=ue;var le=function(e){function n(){e.call(this)}return A(n,e),n.prototype.check=function(e){return e?"number"==typeof e||"boolean"==typeof e||"string"==typeof e?r():i(t.messageRegistry.SCALAR_EXPECTED,this):r()},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"should be scalar"},n.prototype.value=function(){return!0},n}(ae);t.ScalarRestriction=le;var pe=function(e){function n(t,n,r){e.call(this),this.val=t,this._extraMessage=n,this._extraOptionMessage=r}return A(n,e),n.prototype.check=function(e,t){for(var n=this,a=new b(b.OK,"","",this),o=[],s=0;s<this.val.length;s++){var u=this.val[s].check(e,t);if(u.isOk())return r();o.push(u)}if(o.length>0){for(var l=0,p=o;l<p.length;l++){var c=p[l],f=null,d=c.getSource();if(d instanceof _){var m=d.owner();m&&(f=m.label())}c.getErrors().forEach(function(e){var t=e.getMessage(),r=e.getCode();if(f&&(t=f+": "+t),n._extraOptionMessage){var o=i(n._extraOptionMessage,n,{msg:t});t=o.getMessage(),r=o.getCode()}e.setMessage(t),e.setCode(r),a.addSubStatus(e)})}if(this._extraMessage){var h=0;o.forEach(function(e){return h=Math.max(h,e.getSeverity())}),a.addSubStatus(new b(h,this._extraMessage.code,this._extraMessage.message,this))}}return a},n.prototype.value=function(){return this.val.map(function(e){return e.value()})},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"or"},n}(M);t.OrRestriction=pe;var ce=function(e){function n(t){e.call(this),this.val=t}return A(n,e),n.prototype.value=function(){return this.val.map(function(e){return e.value()})},n.prototype.options=function(){return this.val},n.prototype.check=function(e,t){for(var n=0;n<this.val.length;n++){var i=this.val[n].check(e,t);if(!i.isOk())return i}return r()},n.prototype.requiredType=function(){return t.ANY},n.prototype.facetName=function(){return"and"},n}(M);t.AndRestriction=ce,t.ANY=new z("any"),t.SCALAR=t.ANY.inherit("scalar"),t.OBJECT=t.ANY.inherit("object"),t.ARRAY=t.ANY.inherit("array"),t.EXTERNAL=t.ANY.inherit("external"),t.NUMBER=t.SCALAR.inherit("number"),t.INTEGER=t.NUMBER.inherit("integer"),t.BOOLEAN=t.SCALAR.inherit("boolean"),t.STRING=t.SCALAR.inherit("string"),t.NIL=t.SCALAR.inherit("nil"),t.DATE_ONLY=t.SCALAR.inherit("date-only"),t.TIME_ONLY=t.SCALAR.inherit("time-only"),t.DATETIME_ONLY=t.SCALAR.inherit("datetime-only"),t.DATETIME=t.SCALAR.inherit("datetime"),t.FILE=t.SCALAR.inherit("file"),t.NOTHING=new z("nothing"),t.UNION=t.ANY.inherit("union"),t.UNKNOWN=t.NOTHING.inherit("unknown"),t.REFERENCE=t.NOTHING.inherit("reference"),t.RECURRENT=t.NOTHING.inherit("recurrent"),t.ANY.addMeta(X),t.NIL.addMeta(X),t.UNION.addMeta(X),t.SCALAR.addMeta(X),t.OBJECT.addMeta(X),t.ARRAY.addMeta(X),t.NUMBER.addMeta(X),t.INTEGER.addMeta(X),t.BOOLEAN.addMeta(X),t.STRING.addMeta(X),t.EXTERNAL.addMeta(X),t.UNKNOWN.addMeta(X),t.RECURRENT.addMeta(X),t.DATE_ONLY.addMeta(X),t.TIME_ONLY.addMeta(X),t.DATETIME_ONLY.addMeta(X),t.DATETIME.addMeta(X),t.FILE.addMeta(X),t.UNKNOWN.addMeta(X),t.UNKNOWN.lock(),t.RECURRENT.addMeta(X),t.RECURRENT.lock(),t.EXTERNAL.lock(),t.UNION.lock(),t.REFERENCE.lock(),te.addType(t.ANY),te.addType(t.SCALAR),te.addType(t.OBJECT),te.addType(t.ARRAY),te.addType(t.NUMBER),te.addType(t.INTEGER),te.addType(t.BOOLEAN),te.addType(t.NIL),te.addType(t.STRING),te.addType(t.DATE_ONLY),te.addType(t.TIME_ONLY),te.addType(t.DATETIME_ONLY),te.addType(t.DATETIME),te.addType(t.FILE),t.NOTHING.addMeta(new ne),t.NUMBER.addMeta(new oe("number")),t.NUMBER.addMeta(new P.FacetDeclaration("format",t.STRING,!0,!0)),t.BOOLEAN.addMeta(new oe("boolean")),t.OBJECT.addMeta(new oe("object")),t.ARRAY.addMeta(new oe("array")),t.STRING.addMeta(new oe("string")),t.INTEGER.addMeta(new se),t.NIL.addMeta(new ue);var fe=n(143);t.DATE_ONLY.addMeta(new fe.DateOnlyR),t.TIME_ONLY.addMeta(new fe.TimeOnlyR),t.DATETIME_ONLY.addMeta(new fe.DateTimeOnlyR),t.DATETIME.addMeta(new fe.DateTimeR),t.FILE.addMeta(new oe("string"));var de=t.ARRAY.inherit("");de.addMeta(new x.ComponentShouldBeOfType(t.STRING)),t.FILE.addMeta(new P.FacetDeclaration("fileTypes",de,!0,!0)),t.FILE.addMeta(new P.FacetDeclaration("minLength",t.INTEGER,!0,!0)),t.FILE.addMeta(new P.FacetDeclaration("maxLength",t.INTEGER,!0,!0)),t.DATETIME.addMeta(new P.FacetDeclaration("format",t.STRING,!0,!0)),t.NIL.nullable=!0,t.SCALAR.addMeta(new le),te.types().forEach(function(e){return e.lock()});var me=function(e){function n(n,r,i,a,o){void 0===o&&(o=null),e.call(this,n),this._content=r,this.json=i,this.provider=a,this.addMeta(new I.MatchToSchema(r,o?o:a)),this.addSuper(t.EXTERNAL)}return A(n,e),n.prototype.getContentProvider=function(){return this.provider},n.prototype.setContentProvider=function(e){this.provider=e},n.prototype.kind=function(){return"external"},n.prototype.isJSON=function(){return this.json},n.prototype.schema=function(){return this._content},n}(J);t.ExternalType=me,t.typePath=f;var he=function(e){function t(t,n){void 0===n&&(n={}),e.call(this),this.messageEntry=t,this.parameters=n,this.isWarning=!1,this.message=N(t,n)}return A(t,e),t.prototype.getClassIdentifier=function(){var e=[];return e.concat(t.CLASS_IDENTIFIER_ValidationError)},t.isInstance=function(e){return null!=e&&e.getClassIdentifier&&"function"==typeof e.getClassIdentifier&&S.contains(e.getClassIdentifier(),t.CLASS_IDENTIFIER_ValidationError)},t.CLASS_IDENTIFIER_ValidationError="linter.ValidationError",t}(Error);t.ValidationError=he,t.setValidationPath=m,t.patchPath=h;var ye=function(){function e(e,t){this._facet=e,this.reg=t}return e.prototype.kind=function(){return"AnnotatedFacet"},e.prototype.annotationsMap=function(){var e=this;return this._annotationsMap||(this._annotationsMap={},this.annotations().forEach(function(t){return e._annotationsMap[t.name()]=t})),this._annotationsMap},e.prototype.annotations=function(){var e=this;return this._annotations||(this._annotations=this._facet.annotations().map(function(t){return new Ae(t,e.reg)})),this._annotations},e.prototype.value=function(){return this._facet.value()},e.prototype.name=function(){return this._facet.facetName()},e.prototype.entry=function(){return this._facet},e}();t.AnnotatedFacet=ye;var ve=n(102),ge=function(){function e(e,t){this._type=e,this.reg=t}return e.prototype.kind=function(){return"AnnotatedType"},e.prototype.annotationsMap=function(){var e=this;return this._annotationsMap||(this._annotationsMap={},this.annotations().forEach(function(t){var n=t.name(),r=n.lastIndexOf(".");r>=0&&(n=n.substring(r+1)),e._annotationsMap[n]=t})),this._annotationsMap},e.prototype.annotations=function(){var e=this;return this._annotations||(this._annotations=this._type.meta().filter(function(e){return e.kind()==T.MetaInformationKind.Annotation}).map(function(t){return new Ae(t,e.reg)})),this._annotations},e.prototype.value=function(){return ve.storeAsJSON(this._type)},e.prototype.name=function(){return this._type.name()},e.prototype.entry=function(){return this._type},e}();t.AnnotatedType=ge;var Ae=function(){function e(e,t){this.actual=e}return e.prototype.name=function(){return this.actual.facetName()},e.prototype.value=function(){return this.actual.value()},e.prototype.definition=function(){var e=te.get(this.actual.facetName());return e},e.prototype.annotation=function(){return this.actual},e}();t.AnnotationInstance=Ae,t.applyAnnotationValidationPlugins=y,t.applyTypeValidationPlugins=v},function(e,t,n){(function(e){"use strict";function n(){var t=e.ramlValidation;if(t){var n=t.typeValidators;if(Array.isArray(n))return n}return[]}function r(){var t=e.ramlValidation;if(t){var n=t.typesystemAnnotationValidators;if(Array.isArray(n))return n}return[]}t.REPEAT="repeat",t.PARSE_ERROR="parseError",t.TOP_LEVEL_EXTRA="topLevel",t.DEFINED_IN_TYPES_EXTRA="definedInTypes",t.USER_DEFINED_EXTRA="USER_DEFINED",t.SOURCE_EXTRA="SOURCE",t.SCHEMA_AND_TYPE_EXTRA="SCHEMA",t.GLOBAL_EXTRA="GLOBAL",t.HAS_FACETS="HAS_FACETS",t.HAS_ITEMS="HAS_ITEMS",function(e){e[e.Description=0]="Description",e[e.NotScalar=1]="NotScalar",e[e.DisplayName=2]="DisplayName",e[e.Usage=3]="Usage",e[e.Annotation=4]="Annotation",e[e.FacetDeclaration=5]="FacetDeclaration",e[e.CustomFacet=6]="CustomFacet",e[e.Example=7]="Example",e[e.Required=8]="Required",e[e.HasPropertiesFacet=9]="HasPropertiesFacet",e[e.AllowedTargets=10]="AllowedTargets",e[e.Examples=11]="Examples",e[e.XMLInfo=12]="XMLInfo",e[e.Default=13]="Default",e[e.Constraint=14]="Constraint",e[e.Modifier=15]="Modifier",e[e.Discriminator=16]="Discriminator",e[e.DiscriminatorValue=17]="DiscriminatorValue"}(t.MetaInformationKind||(t.MetaInformationKind={}));t.MetaInformationKind;t.getTypeValidationPlugins=n,t.getAnnotationValidationPlugins=r}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(e,t,n,r){return void 0===n&&(n=S.builtInRegistry()),v(e,new O(null,t,!1,r),n)}function i(e,t,n){return void 0===t&&(t=S.builtInRegistry()),u(new O(null,e,!1,n),t)}function a(e){return"?"==e.charAt(e.length-1)}function o(e,t){void 0===t&&(t=S.builtInRegistry());var n=e.provider&&e.provider();return u(new O(null,e,!1,n),t)}function s(e){return new k(e)}function u(e,t){var n=new x;if(e.anchor){if(e.anchor().__$$)return e.anchor().__$$;e.anchor().__$$=n}var r=e.childWithKey("types");r&&r.kind()===P.ARRAY&&(r=s(r));var i=e.childWithKey("schemas");i&&i.kind()===P.ARRAY&&(i=s(i));var a=new U(r,i,t,n);r&&r.kind()!==P.SCALAR&&r.children().filter(function(e){return e.key()&&!0}).forEach(function(e){var t=S.derive(e.key(),[S.REFERENCE]);n.add(t),a.addType(t)}),i&&i.kind()!==P.SCALAR&&i.children().filter(function(e){return e.key()&&!0}).forEach(function(e){var t=S.derive(e.key(),[S.REFERENCE]);n.add(t),a.addType(t)});var o=e.childWithKey("uses");o&&o.kind()===P.ARRAY&&(o=s(o)),o&&o.kind()===P.MAP&&o.children().forEach(function(e){n.addLibrary(e.key(),u(e,t))}),r&&r.kind()!==P.SCALAR&&r.children().filter(function(e){return e.key()&&!0}).forEach(function(e){a.get(e.key())}),i&&i.kind()!==P.SCALAR&&i.children().filter(function(e){return e.key()&&!0}).forEach(function(e){a.get(e.key())}),a.types().forEach(function(e){return n.add(e)});var r=e.childWithKey("annotationTypes");return r&&r.kind()===P.ARRAY&&(r=s(r)),null!=r&&r.kind()===P.MAP&&r.children().forEach(function(e){n.addAnnotationType(v(e.key(),e,a,!1,!0,!1))}),n}function l(e,t){var n=new D,r=!1,i=e.childWithKey("required");if(i){var o=i.value();"boolean"==typeof o&&(r=!0),o===!1&&(n.optional=!0,n.id=e.key())}var s=e.key();return!r&&a(e.key())&&(s=s.substr(0,s.length-1),n.optional=!0),0==s.length||"/.*/"===s?n.additonal=!0:"/"==s.charAt(0)&&"/"==s.charAt(s.length-1)&&(s=s.substring(1,s.length-1),n.regExp=!0),n.type=v(null,e,t,!1,!1,!1),n.id=s,n}function p(e){var t=new F;t.name=e.name(),t.superTypes=e.superTypes().map(function(e){return d(e)}),t.annotations=[],t.customFacets=[],t.facetDeclarations=[],t.basicFacets=[],t.properties=[];var n={};return e.declaredMeta().forEach(function(e){if(e instanceof M.Annotation)t.annotations.push(e);else if(e instanceof M.CustomFacet)t.customFacets.push(e);else if(e instanceof M.NotScalar)t.notAScalar=!0;else if(e instanceof I.FacetDeclaration)t.facetDeclarations.push(e);else if(e instanceof b.HasProperty)if(n.hasOwnProperty(e.value()))n[e.value()].optional=!1;else{var r=new D;r.optional=!1,r.id=e.value(),r.type=S.ANY,n[e.value()]=r}else if(e instanceof b.AdditionalPropertyIs){var r=new D;r.optional=!1,r.id="/.*/",r.additonal=!0,r.type=e.value(),n["/.*/"]=r}else if(e instanceof b.MapPropertyIs){var r=new D;r.optional=!1,r.id=e.regexpValue(),r.regExp=!0,r.type=e.value(),n[e.regexpValue()]=r}else if(e instanceof b.PropertyIs)if(n.hasOwnProperty(e.propertyName()))n[e.propertyName()].type=e.value();else{var r=new D;r.optional=!0,r.id=e.propertyName(),r.type=e.value(),n[e.propertyName()]=r}else e instanceof b.KnownPropertyRestriction?t.additionalProperties=e.value():e instanceof M.DiscriminatorValue?e.isStrict()&&t.basicFacets.push(e):e instanceof M.HasPropertiesFacet||t.basicFacets.push(e)}),Object.keys(n).forEach(function(e){return t.properties.push(n[e])}),t}function c(e){return e instanceof N.AbstractType?p(e).toJSON():f(e)}function f(e){var t={},n={};e.types().forEach(function(e){n[e.name()]=c(e)}),Object.keys(n).length>0&&(t.types=n);var n={};return e.annotationTypes().forEach(function(e){
n[e.name()]=c(e)}),Object.keys(n).length>0&&(t.annotationTypes=n),t}function d(e){if(e.isAnonymous()){if(e.isArray()){var t=e.oneMeta(b.ComponentShouldBeOfType);if(t){var n=t.value();return n.isAnonymous()&&n.isUnion()?"("+d(n)+")[]":d(n)+"[]"}}return e.isUnion()?e.options().map(function(e){return d(e)}).join(" | "):e.superTypes().map(function(e){return d(e)}).join(" , ")}return e.name()}function m(e,t){if(t===S.ANY||e===t||e.superTypes().some(function(e){return m(e,t)}))return!0;if(e.isUnion()&&e.options){var n=e.options();if(n.some(function(e){return m(e,t)}))return!0}if(t.isUnion()&&t.options){var n=t.options();if(n.some(function(t){return e==t}))return!0}return!1}function h(e,t){var n=e.requiredType(),r=e.requiredTypes();return r&&r.length>0?r.some(function(e){return m(t,e)}):m(t,n)}function y(e,t){for(var n=t.children(),r=0,i=n;r<i.length;r++){var a=i[r],o=a.key();if(o&&"("==o.charAt(0)&&")"==o.charAt(o.length-1)){var s=o.substring(1,o.length-1),u=new M.Annotation(s,a.value());u.setOwnerFacet(e),e.addAnnotation(u)}}}function v(e,t,n,r,i,a,o){void 0===n&&(n=S.builtInRegistry()),void 0===r&&(r=!1),void 0===i&&(i=!1),void 0===a&&(a=!0),void 0===o&&(o=!1);var p=t.childWithKey("uses");if(p&&(p.kind()===P.ARRAY&&(p=s(p)),p.kind()===P.MAP)){var c=new x;p.children().forEach(function(e){c.addLibrary(e.key(),u(e,S.builtInRegistry()))}),n=new U(null,null,n,c)}var f=t.contentProvider?t.contentProvider():null;if(t.kind()==P.SCALAR){var d,m=t.value();if(d=null==m||"Null"==m||"NULL"==m?S.STRING:_.parseToType(""+m,n,f),null==e)return d;var A=S.derive(e,[d]);return n instanceof U&&(A=g(A,n)),A}if(t.kind()==P.ARRAY){var b=[];t.children().forEach(function(e){b.push(_.parseToType(""+e.value(),n,f))});var A=S.derive(e,b);return n instanceof U&&(A=g(A,n)),A}var N=[],I=t.childWithKey("type"),R=!1;I?t.childWithKey("schema")&&(R=!0):I=t.childWithKey("schema");var O=[];if(!I||o)N=r?t.childWithKey("properties")?[S.OBJECT]:[S.ANY]:t.childWithKey("properties")?[S.OBJECT]:[S.STRING];else{var D=[],k=I.childWithKey("value");if(!k||k.kind()!=P.SCALAR&&k.kind()!=P.ARRAY||(D=[I.children().filter(function(e){var t=e.key();return t?"("==t.charAt(0)&&")"==t.charAt(t.length-1):!1})],I=k),I.kind()==P.SCALAR){var m=I.value();if(null==m||"Null"==m||"NULL"==m)N=[S.STRING];else{var F=I.contentProvider?I.contentProvider():null;N=[_.parseToType(""+m,n,f,F)]}}else I.kind()==P.ARRAY?N=I.children().map(function(e){var t=e.childWithKey("value");return!t||t.kind()!=P.SCALAR&&t.kind()!=P.ARRAY?D.push([]):(D.push(e.children().filter(function(e){var t=e.key();return t?"("==t.charAt(0)&&")"==t.charAt(t.length-1):!1})),e=t),e.value()}).map(function(e){return _.parseToType(""+e,n,f)}):I.kind()==P.MAP&&(N=[v("",I,n,!1,!1,!1)]);if(D.length>0&&D.filter(function(e){return e.length>0}).length>0)for(var B=0,K=D;B<K.length;B++){var V=K[B],j=[];O.push(j);for(var W=0,q=V;W<q.length;W++){var Y=q[W],H=Y.key(),$=H.substring(1,H.length-1),G=new M.Annotation($,Y.value());j.push(G)}}}for(var X=S.derive(e,N),z=0;z<O.length;z++){var J=O[z];X.addSupertypeAnnotation(J,z)}n instanceof U&&(X=g(X,n));var Q=X,Z=null;if(t.children().forEach(function(e){var t=e.key();k=e.childWithKey("value");var r=e;if("example"!=t&&k&&(r=k),t&&"type"!==t&&"uses"!==t&&"schema"!==t&&("properties"!=t&&"additionalProperties"!=t||!X.isSubTypeOf(S.OBJECT))){var a;if("items"==t){if(X.isSubTypeOf(S.ARRAY)){var o=[];if(r.kind()==P.SCALAR){var s=r.value();o=null==s||"Null"==s||"NULL"==s?[S.STRING]:[_.parseToType(""+s,n,f)]}else if(r.kind()==P.ARRAY){o=r.children().map(function(e){var t=e.childWithKey("value");return!t||t.kind()!=P.SCALAR&&t.kind()!=P.ARRAY?D.push([]):(D.push(e.children().filter(function(e){var t=e.key();return t?"("==t.charAt(0)&&")"==t.charAt(t.length-1):!1})),e=t),e.value()}).map(function(e){return _.parseToType(""+e,n,f)});var u=S.error(E.ITEMS_SHOULD_BE_REFERENCE_OR_INLINE_TYPE,Q);u.setValidationPath({name:"items"}),X.putExtra(T.PARSE_ERROR,u)}else r.kind()==P.MAP&&(o=[v("",r,n,!1,!1,!1)]);var l=1==o.length?o[0]:S.derive("",o);return a=new C.ComponentShouldBeOfType(l),Q.addMeta(a),Q.putExtra(T.HAS_ITEMS,!0),k&&y(a,e),a}}else{if("facets"===t)return void(Z=t);if("default"==t||"xml"==t||"required"==t)Z=t;else if("("==t.charAt(0)&&")"==t.charAt(t.length-1))return void X.addMeta(new M.Annotation(t.substr(1,t.length-2),r.value()));if(a=w.getInstance().buildFacet(t,r.value()),a&&("format"!=t||h(a,X)))a.setNode(r),X.addMeta(a);else if(i&&"allowedTargets"===t)X.addMeta(new M.AllowedTargets(r.value()));else{var p=new M.CustomFacet(t,r.value());p.setNode(r),X.addMeta(p)}}a&&y(a,e)}}),0==X.metaOfType(M.DiscriminatorValue).length&&X.addMeta(new M.DiscriminatorValue(X.name(),!1)),X.isSubTypeOf(S.OBJECT)){var ee=t.childWithKey("properties"),te=!1;if(ee)if(X.addMeta(new M.HasPropertiesFacet),ee.kind()==P.MAP)ee.children().forEach(function(e){te=!0,l(e,n).add(X)});else{var ne=S.error(E.PROPERTIES_MAP,Q);ne.setValidationPath({name:"properties"}),X.putExtra(T.PARSE_ERROR,ne)}var re=t.childWithKey("additionalProperties");if(re)if(k=re.childWithKey("value"),k&&(re=k),"boolean"==typeof re.value())X.addMeta(new L.KnownPropertyRestriction(re.value()));else{var ne=S.error(E.ADDITIONAL_PROPERTIES_BOOLEAN,Q);ne.setValidationPath({name:"additionalProperties"}),X.putExtra(T.PARSE_ERROR,ne)}}var ee=t.childWithKey("facets");if(ee)if(ee.kind()==P.MAP)ee.children().forEach(function(e){var t=l(e,n);X.addMeta(new M.FacetDeclaration(t.id,t.type,t.optional))});else{var ne=S.error(E.FACETS_MAP,Q);ne.setValidationPath({name:"facets"}),X.putExtra(T.PARSE_ERROR,ne)}return X.isAnonymous()&&X.isEmpty()&&1==X.superTypes().length?X.superTypes()[0]:(t.kind()!=P.SCALAR&&X.addMeta(new M.NotScalar),R&&Q.putExtra(S.SCHEMA_AND_TYPE,!0),Q.putExtra(S.GLOBAL,a),Q.putExtra(S.SOURCE_EXTRA,t),Q.putExtra(T.HAS_FACETS,Z),Q)}function g(e,t){for(var n,r=t;r&&!(n=r.typeMap()[e.name()]);)r=r.parent();return null!=n&&n.isSubTypeOf(S.REFERENCE)?null!=n&&n.isSubTypeOf(S.REFERENCE)&&(n.patch(e),e=n):t.addType(e),e.putExtra(T.TOP_LEVEL_EXTRA,!0),e}var A=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},S=n(100),E=S.messageRegistry,T=n(101),b=n(104),N=n(100),_=n(144),w=n(103),M=n(105),I=n(105),R=n(100),C=n(104),L=n(104);!function(e){e[e.SCALAR=0]="SCALAR",e[e.ARRAY=1]="ARRAY",e[e.MAP=2]="MAP"}(t.NodeKind||(t.NodeKind={}));var P=t.NodeKind,O=function(){function e(e,t,n,r){void 0===n&&(n=!1),this._key=e,this.obj=t,this.inArr=n,this.provider=r}return e.prototype.value=function(){return this.obj},e.prototype.key=function(){if(!this._key&&this.kind()===P.MAP&&this.inArr){var e=Object.keys(this.obj);if(1===e.length)return e[0]}return this._key},e.prototype.childWithKey=function(t){return null==this.obj?null:this.obj.hasOwnProperty(t)?new e(t,this.obj[t],!1,this.contentProvider()):null},e.prototype.children=function(){var t=this;return Array.isArray(this.obj)?this.obj.map(function(n){return new e(null,n,!0,t.contentProvider())}):this.obj&&"object"==typeof this.obj?Object.keys(this.obj).map(function(n){return new e(n,t.obj[n],!1,t.provider)}):[]},e.prototype.kind=function(){return this.obj?Array.isArray(this.obj)?P.ARRAY:"object"==typeof this.obj?P.MAP:P.SCALAR:P.SCALAR},e.prototype.contentProvider=function(){return this.provider},e}();t.parseJSON=r,t.parseJSONTypeCollection=i;var D=function(){function e(){}return e.prototype.add=function(e){this.optional||this.additonal||this.regExp||this.type.isSubTypeOf(S.NIL)||e.addMeta(new b.HasProperty(this.id));var t;t=this.additonal?new b.AdditionalPropertyIs(this.type):this.regExp?new b.MapPropertyIs(this.id,this.type):new b.PropertyIs(this.id,this.type,this.optional),null!=t&&(e.addMeta(t),this.type instanceof S.InheritedType&&null==this.type.name()&&this.type.setContextMeta(t))},e}();t.PropertyBean=D;var x=function(){function e(){this._types=[],this._typeMap={},this.uses={},this._annotationTypes=[],this._annotationTypeMap={}}return e.prototype.library=function(e){return this.uses[e]},e.prototype.addLibrary=function(e,t){this.uses[e]=t},e.prototype.add=function(e){this._types.push(e),this._typeMap[e.name()]=e},e.prototype.getType=function(e){return this._typeMap.hasOwnProperty(e)?this._typeMap[e]:null},e.prototype.addAnnotationType=function(e){this._annotationTypes.push(e),this._annotationTypeMap[e.name()]=e},e.prototype.getAnnotationType=function(e){return this._annotationTypeMap.hasOwnProperty(e)?this._annotationTypeMap[e]:null},e.prototype.types=function(){return this._types},e.prototype.annotationTypes=function(){return this._annotationTypes},e.prototype.getAnnotationTypeRegistry=function(){var e=this,t=new R.TypeRegistry(S.builtInRegistry());return this.annotationTypes().forEach(function(e){return t.addType(e)}),Object.keys(this.uses).forEach(function(n){e.uses[n].annotationTypes().forEach(function(e){return t.put(n+"."+e.name(),e)})}),t},e.prototype.getTypeRegistry=function(){var e=this,t=new R.TypeRegistry(S.builtInRegistry());return this.types().forEach(function(e){return t.addType(e)}),Object.keys(this.uses).forEach(function(n){e.uses[n].types().forEach(function(e){return t.put(n+"."+e.name(),e)})}),t},e}();t.TypeCollection=x;var U=function(e){function t(t,n,r,i){e.call(this,r),this.toParse=t,this.schemas=n,this._c=i,this.parsing={}}return A(t,e),t.prototype.get=function(t){var n=e.prototype.get.call(this,t);if(!n||n.isSubTypeOf(S.REFERENCE)){var r=this.toParse?this.toParse.childWithKey(t):null;if(r||(r=this.schemas?this.schemas.childWithKey(t):null),r){if(this.parsing[t]){var i=S.derive(t,[S.RECURRENT]);return n&&n.isSubTypeOf(S.REFERENCE)?n.patch(i):n=i,n}this.parsing[t]=!0;try{var a=v(t,r,this)}finally{delete this.parsing[t]}return a}var o=t.indexOf(".");if(-1!=o){var s=t.substring(0,o),u=t.substr(o+1),l=this._c.library(s);if(l){var p=l.getType(u);if(p)return p}}}return n},t}(S.TypeRegistry);t.AccumulatingRegistry=U,t.parseTypes=o;var k=function(){function e(e){this.n=e}return e.prototype.key=function(){return null},e.prototype.value=function(){return null},e.prototype.childWithKey=function(e){for(var t=this.children(),n=0;n<t.length;n++)if(t[n].key()==e)return t[n];return null},e.prototype.children=function(){return this.n.children().map(function(e){var t=e.children();return 1==t.length?t[0]:e})},e.prototype.kind=function(){return P.MAP},e}();t.parseTypeCollection=u,t.parsePropertyBean=l;var F=function(){function e(){}return e.prototype.toJSON=function(){var e={};if(this.superTypes&&this.superTypes.length>0&&(1==this.superTypes.length?e.type=this.superTypes[0]:e.type=this.superTypes),this.customFacets&&this.customFacets.forEach(function(t){return e[t.facetName()]=t.value()}),this.annotations&&this.annotations.forEach(function(t){return e["("+t.facetName()+")"]=t.value()}),this.facetDeclarations&&this.facetDeclarations.length>0){var t={};this.facetDeclarations.forEach(function(e){var n=e.facetName();e.isOptional()&&(n+="?");var r=null;r=e.type().isAnonymous()?e.type().isEmpty()?d(e.type()):p(e.type()).toJSON():d(e.type()),t[n]=r}),e.facets=t}if(this.properties&&this.properties.length>0){var n={};this.properties.forEach(function(e){var t=e.id;e.optional&&(t+="?"),e.additonal&&(t="/.*/"),e.regExp&&(t="/"+t+"/");var r=null;r=e.type.isAnonymous()?e.type.isEmpty()?d(e.type):p(e.type).toJSON():d(e.type),n[t]=r}),e.properties=n}return this.basicFacets&&this.basicFacets.forEach(function(t){e[t.facetName()]=t.value()}),1==Object.keys(e).length&&!this.notAScalar&&e.type?e.type:(void 0!==this.additionalProperties&&(e.additionalProperties=this.additionalProperties),e)},e}();t.TypeProto=F,t.toProto=p,t.storeAsJSON=c,t.parse=v},function(e,t,n){"use strict";function r(){return h?h:h=new m}var i=n(100),a=n(105),o=n(100),s=n(104),u=n(105),l=n(105),p=n(105),c=n(105),f=n(104),d=function(){function e(e,t){this._construct=e,this._constructWithValue=t}return e.prototype.isSimple=function(){return null!=this._constructWithValue},e.prototype.newInstance=function(){return this._construct()},e.prototype.createWithValue=function(e){return this._constructWithValue(e)},e.prototype.isApplicable=function(e){var t=this.newInstance(),n=t.requiredType(),r=t.requiredTypes();return r&&r.length>0?r.some(function(t){return e.isSubTypeOf(t)}):e.isSubTypeOf(n)},e.prototype.isInheritable=function(){return this.newInstance().isInheritable()},e.prototype.isConstraint=function(){return this.newInstance()instanceof i.Constraint},e.prototype.isMeta=function(){return!this.isConstraint()},e.prototype.name=function(){return this.newInstance().facetName()},e}();t.FacetPrototype=d;var m=function(){function e(){var e=this;this.constraints=[new d(function(){return new s.MinProperties(1)},function(e){return new s.MinProperties(e)}),new d(function(){return new s.MaxProperties(1)},function(e){return new s.MaxProperties(e)}),new d(function(){return new s.MinItems(1)},function(e){return new s.MinItems(e)}),new d(function(){return new s.MaxItems(1)},function(e){return new s.MaxItems(e)}),new d(function(){return new s.MinLength(1)},function(e){return new s.MinLength(e)}),new d(function(){return new s.MaxLength(1)},function(e){return new s.MaxLength(e)}),new d(function(){return new s.Minimum(1)},function(e){return new s.Minimum(e)}),new d(function(){return new f.MultipleOf(1)},function(e){return new f.MultipleOf(e)}),new d(function(){return new s.Maximum(1)},function(e){return new s.Maximum(e)}),new d(function(){return new s.Enum([""])},function(e){return new s.Enum(e)}),new d(function(){return new s.Pattern(".")},function(e){return new s.Pattern(e)}),new d(function(){return new s.Format("")},function(e){return new s.Format(e)}),new d(function(){return new s.PropertyIs("x",i.ANY)},null),new d(function(){return new s.AdditionalPropertyIs(i.ANY)},null),new d(function(){return new s.MapPropertyIs(".",i.ANY)},null),new d(function(){return new s.HasProperty("x")},null),new d(function(){return new s.UniqueItems(!0)},function(e){return new s.UniqueItems(e)}),new d(function(){return new s.ComponentShouldBeOfType(i.ANY)},null),new d(function(){return new s.KnownPropertyRestriction(!1)},function(e){return new s.KnownPropertyRestriction(e)}),new d(function(){return new s.FileTypes([""])},function(e){return new s.FileTypes(e)})],this.meta=[new d(function(){return new a.Discriminator("kind")},function(e){return new a.Discriminator(e)}),new d(function(){return new a.DiscriminatorValue("x")},function(e){return new a.DiscriminatorValue(e)}),new d(function(){return new u.Default("")},function(e){return new u.Default(e)}),new d(function(){return new c.Usage("")},function(e){return new c.Usage(e)}),new d(function(){return new u.Example("")},function(e){return new u.Example(e)}),new d(function(){return new p.Required(!0)},function(e){return new p.Required(e)}),new d(function(){return new a.Examples({})},function(e){return new a.Examples(e)}),new d(function(){return new u.Description("")},function(e){return new u.Description(e)}),new d(function(){return new u.DisplayName("")},function(e){return new u.DisplayName(e)}),new d(function(){return new o.Abstract},function(e){return new o.Abstract}),new d(function(){return new o.Polymorphic},function(e){return new o.Polymorphic}),new d(function(){return new l.XMLInfo({})},function(e){return new l.XMLInfo(e)})],this.known={},this.allPrototypes().forEach(function(t){return e.known[t.name()]=t})}return e.prototype.allPrototypes=function(){return this.meta.concat(this.constraints)},e.prototype.buildFacet=function(e,t){return this.known.hasOwnProperty(e)&&this.known[e].isSimple()?this.known[e].createWithValue(t):null},e.prototype.facetPrototypeWithName=function(e){return this.known.hasOwnProperty(e)?this.known[e]:null},e.prototype.applyableTo=function(e){return this.allPrototypes().filter(function(t){return t.isApplicable(e)})},e.prototype.allMeta=function(){return this.allPrototypes().filter(function(e){return e.isMeta()})},e}();t.Registry=m;var h;t.getInstance=r},function(e,t,n){"use strict";function r(){return T.length>0?T[T.length-1]:null}function i(e){for(var t;e;)t=e.owner(),e=t instanceof c.InheritedType?t.contextMeta():null;T.push(t)}function a(e){for(void 0===e&&(e=0);T.length>e;)T.pop()}function o(){return T.length}function s(e){return parseFloat(e)!=parseInt(e)||isNaN(e)?!1:!0}function u(e){e=e.map(function(e){return e.preoptimize()});var t=[];e.forEach(function(e){if(e instanceof h.AndRestriction){var n=e;n.options().forEach(function(e){t.push(e)})}else t.push(e)});for(var n=!0;n;){n=!1;for(var r=0;r<t.length;r++){for(var i=0;i<t.length;i++){var a=t[r],o=t[i];if(a!==o){var s=a.tryCompose(o);if(s){var u=t.filter(function(e){return e!==a&&e!==o});u.push(s),n=!0,t=u;break}}}if(n)break}}return t}function l(e){if(!e.isSubTypeOf(c.UNKNOWN))return null;if(null!=e.name())return e;for(var t=0,n=e.superTypes();t<n.length;t++){var r=n[t],i=l(r);if(null!=i)return i}return e}var p=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},c=n(100),f=c.messageRegistry,d=n(110),m=n(185),h=n(100),y=n(100),v=function(e){function t(t){e.call(this),this._type=t}return p(t,e),t.prototype.matches=function(e){return!1},t.prototype.check=function(e,t){throw new Error("Should be never called")},t.prototype.patchPath=function(e){if(e){for(var t=e,n=null,r=null;t;)if(n){var i={name:t.name};r.child=i,t=t.child,r=i}else n={name:t.name},r=n;return n.child={name:this.propId()},n}return{name:this.propId()}},t.prototype.validateProp=function(e,t,n,r){var i=e[t],a=n.validate(i,!1,!1);if(!a.isOk()){if(n.isUnknown()||n.isRecurrent()){var o=c.error(f.VALIDATING_AGAINS_UNKNOWN,this,{typeName:n.name()});return c.setValidationPath(o,this.patchPath(r)),o}var o=new y.Status(y.Status.OK,"","",this);return a.getErrors().forEach(function(e){return o.addSubStatus(e)}),c.setValidationPath(o,this.patchPath(r)),o}return c.ok()},t.prototype.validateSelf=function(e){if(this._type.isExternal()){var t=c.error(f.EXTERNAL_IN_PROPERTY_DEFINITION,this);return c.setValidationPath(t,{name:this.propId()}),t}if(this._type.isSubTypeOf(c.UNKNOWN)||this._type.isSubTypeOf(c.RECURRENT)){var n=l(this._type),t=c.error(f.UNKNOWN_IN_PROPERTY_DEFINITION,this,{propName:this.propId(),typeName:n.name()});return c.setValidationPath(t,{name:this.propId(),child:{name:"type"}}),t}if(this._type.isAnonymous()){var r=this._type.validateType(e);if(!r.isOk()){var t=c.error(f.ERROR_IN_RANGE,this,{propName:this.propId(),msg:r.getMessage()});return r.getErrors().forEach(function(e){t.addSubStatus(e)}),c.setValidationPath(t,{name:this.propId()}),t}return r}if(this._type.isUnion()){var i=m.find(this._type.typeFamily(),function(e){return e.isSubTypeOf(c.UNKNOWN)});if(i){var t=c.error(f.UNKNOWN_IN_PROPERTY_DEFINITION,this,{propName:this.propId(),typeName:i.name()});return c.setValidationPath(t,{name:this.propId()}),t}}return c.ok()},t}(c.Constraint);t.MatchesProperty=v;var g=function(e){function t(t,n){e.call(this),this._value=t,this.provider=n}return p(t,e),t.prototype.value=function(){return this._value},t.prototype.check=function(e){var t=null,n=this.value();if("{"==n.charAt(0))try{t=d.getJSONSchema(n,this.provider)}catch(r){return c.error(f.INCORRECT_SCHEMA,this,{msg:r.message})}if("<"==n.charAt(0))try{t=d.getXMLSchema(n,this.provider)}catch(r){return c.ok()}if(t)try{t.validateObject(e)}catch(r){return"!_PERF_!"==r.message?c.error(f.UNABLE_TO_VALIDATE_XML,this,{},c.Status.WARNING):"Maximum call stack size exceeded"==r.message?c.error(f.CIRCULAR_REFS_IN_JSON_SCHEMA,this):c.error(f.EXAMPLE_SCHEMA_FAILURE,this,{msg:r.message})}return c.ok()},t.prototype.facetName=function(){return"schema"},t.prototype.requiredType=function(){return c.EXTERNAL},t}(c.Constraint);t.MatchToSchema=g;var A=function(e){function t(t){e.call(this),this._value=t}return p(t,e),t.prototype.facetName=function(){return"closed"},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.value=function(){return this._value},t.prototype.patchOwner=function(e){this._owner=e},t.prototype.check=function(e){var t=this;if(this._value===!1&&e&&"object"==typeof e&&!Array.isArray(e)){var n={};Object.getOwnPropertyNames(e).forEach(function(e){return n[e]=!0});var r=this.owner().knownProperties();Object.getOwnPropertyNames(e).forEach(function(e){r.forEach(function(t){t.matches(e)&&delete n[e]})});var i=Object.keys(n);if((this.owner().hasPropertiesFacet()||r.length>0)&&i.length>0){var a=new c.Status(c.Status.OK,"","",this);return i.forEach(function(e){var n=c.error(f.UNKNOWN_PROPERTY,t,{propName:e});c.setValidationPath(n,{name:e}),a.addSubStatus(n)}),a}}return c.ok()},t.prototype.composeWith=function(e){if(!this._value)return null;if(e instanceof t){var n=e;if(m.isEqual(this.owner().propertySet(),n.owner().propertySet()))return n}if(e instanceof S){var r=e,i=r.value(),a=this.owner().propertySet();if(-1==a.indexOf(i))return this.nothing(r)}},t}(c.Constraint);t.KnownPropertyRestriction=A;var S=function(e){function t(t){e.call(this),this.name=t}return p(t,e),t.prototype.check=function(e){return e&&"object"==typeof e&&!Array.isArray(e)?e.hasOwnProperty(this.name)?c.ok():c.error(f.REQUIRED_PROPERTY_MISSING,this,{propName:this.name}):c.ok()},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.facetName=function(){return"hasProperty"},t.prototype.value=function(){return this.name},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.name===this.name)return this}return null},t}(c.Constraint);t.HasProperty=S;var E=function(e){function t(t,n,r){void 0===r&&(r=!1),e.call(this,n),this.name=t,this.type=n,this.optional=r}return p(t,e),t.prototype.matches=function(e){return e===this.name},t.prototype.path=function(){return this.name},t.prototype.check=function(e,t){if(e&&"object"==typeof e&&e.hasOwnProperty(this.name)){var n=this.validateProp(e,this.name,this.type,t);return!n.isOk()&&this.optional&&null==e[this.name]?c.ok():n}return c.ok()},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.propId=function(){return this.name},t.prototype.propertyName=function(){return this.name},t.prototype.facetName=function(){return"propertyIs"},t.prototype.value=function(){return this.type},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.name===this.name){if(-1!=this.type.typeFamily().indexOf(n.type))return n;if(-1!=n.type.typeFamily().indexOf(this.type))return this;i(e);var r=this.intersect(this.type,n.type);try{var a=r.checkConfluent();if(!a.isOk()){var o=a;return o.toRestriction()}return new t(this.name,r)}finally{this.release(r)}}}return null},t}(v);t.PropertyIs=E;var T=[];t.anotherRestrictionComponent=r,t.releaseAnotherRestrictionComponent=a,t.anotherRestrictionComponentsCount=o;var b=function(e){function t(t,n){e.call(this,n),this.regexp=t,this.type=n}return p(t,e),t.prototype.path=function(){return"/"+this.regexp+"/"},t.prototype.matches=function(e){return e.match(this.regexp)?!0:!1},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.propId=function(){return"["+this.regexp+"]"},t.prototype.facetName=function(){return"mapPropertyIs"},t.prototype.value=function(){return this.type},t.prototype.regexpValue=function(){return this.regexp},t.prototype.validateSelf=function(t){var n=this.checkValue();return n?c.error(f.INVALID_REGEXP,this,{msg:n}):e.prototype.validateSelf.call(this,t)},t.prototype.checkValue=function(){try{new RegExp(this.regexp)}catch(e){return e.message}return null},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.regexp===this.regexp){if(-1!=this.type.typeFamily().indexOf(n.type))return n;if(-1!=n.type.typeFamily().indexOf(this.type))return this;var r=this.intersect(this.type,n.type);try{var i=r.checkConfluent();if(!i.isOk()){var a=i;return a.toRestriction()}return new t(this.regexp,r)}finally{this.release(r)}}}return null},t.prototype.check=function(e,t){if(e&&"object"==typeof e){var n={};null!=this._owner&&this._owner.meta().filter(function(e){return e instanceof E}).forEach(function(e){n[e.propertyName()]=!0});for(var r=new c.Status(c.Status.OK,"","",this),i=0,a=Object.getOwnPropertyNames(e);i<a.length;i++){var o=a[i];if(!n[o]&&o.match(this.regexp)){var s=this.validateProp(e,o,this.type,t);s.isOk()||r.addSubStatus(s)}}return r}return c.ok()},t}(v);t.MapPropertyIs=b;var N=function(e){function t(t){e.call(this,t),this.type=t}return p(t,e),t.prototype.path=function(){return this.facetName()},t.prototype.matches=function(e){return!0},t.prototype.requiredType=function(){return c.OBJECT},t.prototype.propId=function(){return"[]"},t.prototype.facetName=function(){return"additionalProperties"},t.prototype.value=function(){return this.type},t.prototype.match=function(e){for(var t=this.owner().metaOfType(E),n=this.owner().metaOfType(b),r=0;r<t.length;r++)if(t[r].matches(e))return!0;for(var r=0;r<n.length;r++)if(n[r].matches(e))return!0;return!1},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(-1!=this.type.typeFamily().indexOf(n.type))return n;if(-1!=n.type.typeFamily().indexOf(this.type))return this;var r=this.intersect(this.type,n.type);try{var i=r.checkConfluent();if(!i.isOk()){var a=i;return a.toRestriction()}return new t(r)}finally{this.release(r)}}return null},t.prototype.check=function(e,t){var n=this,r=this.type,i=new c.Status(c.Status.OK,"","",this);return e&&"object"==typeof e&&Object.getOwnPropertyNames(e).forEach(function(a){if(!n.match(a)){var o=n.validateProp(e,a,r,t);o.isOk()||i.addSubStatus(o)}}),i},t}(v);t.AdditionalPropertyIs=N;var _=function(e){function t(){e.apply(this,arguments)}return p(t,e),t.prototype.requiredTypes=function(){return[]},t.prototype.checkOwner=function(e){var t=!1;if(e.isUnion())for(var n=e.typeFamily(),r=0,i=n;r<i.length;r++){var a=i[r];if(this.owner().isSubTypeOf(a)){t=!0;break}}else t=this.owner().isSubTypeOf(e);return t},t.prototype.validateSelf=function(t){var n=this,r=e.prototype.validateSelf.call(this,t),i=!1;if(this.checkOwner(this.requiredType()))if(this.requiredTypes()&&this.requiredTypes().length>0){var a=(this.owner(),m.find(this.requiredTypes(),function(e){return n.checkOwner(e)}));a&&(i=!0)}else i=!0;var o;if(i)o=this.checkValue();else{var s=this.requiredType().name();this.requiredTypes()&&this.requiredTypes().length>0&&(s="["+this.requiredTypes().map(function(e){return e.name()}).join()+"]");var o=c.error(f.FACET_USAGE_RESTRICTION,this,{facetName:this.facetName(),typeNames:s})}if(o&&!o.isOk())return c.setValidationPath(o,{name:this.facetName()}),o;var u=[r,o].filter(function(e){return e&&!e.isOk()});if(0==u.length)return c.ok();if(1==u.length)return u[0];for(var l=c.ok(),p=0,d=u;p<d.length;p++){var h=d[p];l.addSubStatus(h)}return l},t}(c.Constraint);t.FacetRestriction=_;var w=function(e){function t(t,n,r,i,a,o){e.call(this),this._facetName=t,this._value=n,this._max=r,this._opposite=i,this._requiredType=a,this._isInt=o}return p(t,e),t.prototype.facetName=function(){return this._facetName},t.prototype.isIntConstraint=function(){return this._isInt},t.prototype.isMax=function(){return this._max},t.prototype.value=function(){return this._value},t.prototype.check=function(e){var t=this.extractValue(e);if("number"==typeof t)if(this.isMax()){if(this.value()<t)return this.createError()}else if(this.value()>t)return this.createError();return c.ok()},t.prototype.createError=function(){return new y.Status(y.Status.ERROR,f.MINMAX_RESTRICTION_VIOLATION.code,this.toString(),this)},t.prototype.minValue=function(){return this._isInt?0:Number.NEGATIVE_INFINITY},t.prototype.requiredType=function(){return this._requiredType},t.prototype.checkValue=function(){return"number"!=typeof this._value?c.error(f.FACET_REQUIRE_NUMBER,this,{facetName:this.facetName()},c.Status.ERROR,!0):this.isIntConstraint()&&!s(this.value())?c.error(f.FACET_REQUIRE_INTEGER,this,{facetName:this.facetName()},c.Status.ERROR,!0):this.value()<this.minValue()?c.error(f.MIN_VALUE,this,{facetName:this.facetName(),minValue:this.minValue()},c.Status.ERROR,!0):void 0},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n.facetName()==this.facetName()&&n.isMax()==this.isMax())return this.isMax()?this.value()<n.value()?n:this:this.value()>n.value()?n:this;if(n.facetName()===this._opposite)if(this.isMax()){if(n.value()>this.value())return this.nothing(e)}else if(n.value()<this.value())return this.nothing(e)}return null},t.prototype.facetPath=function(){var e=[this.facetName()],t=this._owner;if(null!=t&&t instanceof c.InheritedType){var n=t;e=c.typePath(n).concat(e)}return e.join(".")},t.prototype.toString=function(){return"'"+this.facetPath()+"="+this.value()+"' i.e. "+this.textMessagePart()+" "+this.value()},t.prototype.conflictMessage=function(e,t){var n=this.isMax()?["less","higher"]:["higher","less"];return"['"+this.facetPath()+"="+this.value()+"' is "+n[0]+" than '"+e+"="+t+"'. The "+this._opposite+" cannot be "+n[1]+" than the "+this.facetName()+".]"},t}(_);t.MinMaxRestriction=w;var M=function(e){function t(t){e.call(this),this._value=t}return p(t,e),t.prototype.value=function(){return this._value},t.prototype.check=function(e){if("number"==typeof e){var t=e/this.value();if(!s(t))return c.error(f.EVEN_RATIO,this,{val1:e,val2:this.value()})}return c.ok()},t.prototype.composeWith=function(e){return null},t.prototype.facetName=function(){return"multipleOf"},t.prototype.checkValue=function(){return"number"!=typeof this._value?c.error(f.FACET_REQUIRE_NUMBER,this,{facetName:this.facetName()},c.Status.ERROR,!0):this._value<=0?c.error(f.VALUE_SHOULD_BE_POSITIVE,this,{facetName:this.facetName()},c.Status.ERROR,!0):null},t.prototype.requiredType=function(){return c.NUMBER},t}(_);t.MultipleOf=M;var I=function(e){function t(t){e.call(this,"maximum",t,!0,"minimum",c.NUMBER,!1)}return p(t,e),t.prototype.extractValue=function(e){return e},t.prototype.textMessagePart=function(){return"value should not be more than"},t}(w);t.Maximum=I;var R=function(e){function t(t){e.call(this,"minimum",t,!1,"maximum",c.NUMBER,!1)}return p(t,e),t.prototype.extractValue=function(e){return e},t.prototype.textMessagePart=function(){return"value should not be less than"},t}(w);t.Minimum=R;var C=function(e){function t(t){e.call(this,"maxItems",t,!0,"minItems",c.ARRAY,!0)}return p(t,e),t.prototype.extractValue=function(e){return Array.isArray(e)?e.length:void 0},t.prototype.textMessagePart=function(){return"array items count should not be more than"},t}(w);t.MaxItems=C;var L=function(e){function t(t){e.call(this,"minItems",t,!1,"maxItems",c.ARRAY,!0)}return p(t,e),t.prototype.extractValue=function(e){return Array.isArray(e)?e.length:void 0},t.prototype.textMessagePart=function(){return"array items count should not be less than"},t}(w);t.MinItems=L;var P=function(e){function t(t){e.call(this,"maxLength",t,!0,"minLength",new c.UnionType("string and file",[c.STRING,c.FILE]),!0)}return p(t,e),t.prototype.extractValue=function(e){return"string"==typeof e?e.length:0},t.prototype.textMessagePart=function(){return"string length should not be more than"},t}(w);t.MaxLength=P;var O=function(e){function t(t){e.call(this,"minLength",t,!1,"maxLength",new c.UnionType("string and file",[c.STRING,c.FILE]),!0)}return p(t,e),t.prototype.extractValue=function(e){return"string"==typeof e?e.length:0},t.prototype.textMessagePart=function(){return"string length should not be less than"},t}(w);t.MinLength=O;var D=function(e){function t(t){e.call(this,"maxProperties",t,!0,"minProperties",c.OBJECT,!0)}return p(t,e),t.prototype.extractValue=function(e){return Object.keys(e).length},t.prototype.textMessagePart=function(){return"object properties count should not be more than"},t}(w);t.MaxProperties=D;var x=function(e){function t(t){e.call(this,"minProperties",t,!1,"maxProperties",c.OBJECT,!0)}return p(t,e),t.prototype.extractValue=function(e){return Object.keys(e).length},t.prototype.textMessagePart=function(){return"object properties count should not be less than"},t}(w);t.MinProperties=x;var U=function(e){function t(t){e.call(this),this._value=t;
}return p(t,e),t.prototype.facetName=function(){return"uniqueItems"},t.prototype.requiredType=function(){return c.ARRAY},t.prototype.check=function(e){if(!this._value)return c.ok();if(Array.isArray(e)){var t=e;if(m.unique(t).length!=t.length)return c.error(f.MUST_BE_UNIQUE,this)}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(n._value==this._value)return this}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){return"boolean"!=typeof this._value?c.error(f.UNIQUE_ITEMS_BOOLEAN,this):null},t.prototype.toString=function(){return"items should be unique"},t}(_);t.UniqueItems=U;var k=function(e){function t(t){e.call(this),this.type=t}return p(t,e),t.prototype.facetName=function(){return"items"},t.prototype.requiredType=function(){return c.ARRAY},t.prototype.toString=function(){return"items should be of type "+this.type},t.prototype.check=function(e){var t=new c.Status(c.Status.OK,"","",this);if(Array.isArray(e))for(var n=e,r=0;r<n.length;r++){var i=this.type.validate(n[r],!1,!1);if(!i.isOk()){var a=this.type;if(a.isUnknown()||a.isRecurrent()){var o=c.error(f.ARRAY_AGAINST_UNKNOWN,this,{typeName:a.name()});return o}}c.setValidationPath(i,{name:""+r}),t.addSubStatus(i)}return t},t.prototype.validateSelf=function(t){var n=e.prototype.validateSelf.call(this,t);if(this.type.isAnonymous()){var r=this.type.validateType(t);return r.isOk()||n.addSubStatus(c.error(f.INVALID_COMPONENT_TYPE,this,{msg:n.getMessage()})),n}if(this.type.isExternal())n.addSubStatus(c.error(f.EXTERNAL_AS_COMPONENT,this));else if(this.type.isSubTypeOf(c.UNKNOWN)||this.type.isSubTypeOf(c.RECURRENT))n.addSubStatus(c.error(f.UNKNOWN_AS_COMPONENT,this,{typeName:this.type.name()}));else if(this.type.isUnion()){var i=m.find(this.type.typeFamily(),function(e){return e.isSubTypeOf(c.UNKNOWN)});i&&n.addSubStatus(c.error(f.UNKNOWN_AS_COMPONENT,this,{typeName:i.name()}))}return n},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;if(-1!=this.type.typeFamily().indexOf(n.type))return n;if(-1!=n.type.typeFamily().indexOf(this.type))return this;var r=this.intersect(this.type,n.type);try{var i=r.checkConfluent();if(!i.isOk()){var a=i;return a.toRestriction()}return new t(r)}finally{this.release(r)}}return null},t.prototype.checkValue=function(){return null},t.prototype.value=function(){return this.type},t}(_);t.ComponentShouldBeOfType=k;var F=function(e){function t(t){e.call(this),this._value=t}return p(t,e),t.prototype.facetName=function(){return"pattern"},t.prototype.requiredType=function(){return c.STRING},t.prototype.check=function(e){if("string"==typeof e){var t=e;try{var n=t.match(this._value),r=!1;if(n)for(var i=0,a=n;i<a.length;i++){var o=a[i];if(o.length==t.length){r=!0;break}}if(!r)return c.error(f.PATTERN_VIOLATION,this,{value:this.value()})}catch(s){}}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;return n._value===this._value?this:this.nothing(e,"pattern restrictions can not be composed at one type")}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){try{new RegExp(this._value)}catch(e){return c.error(f.INVALID_REGEXP,this,{msg:e.message},c.Status.ERROR,!0)}return null},t.prototype.toString=function(){return"should pass reg exp:"+this.value},t}(_);t.Pattern=F;var B=function(e){function t(t){e.call(this),this._value=t}return p(t,e),t.prototype.facetName=function(){return"fileTypes"},t.prototype.requiredType=function(){return c.FILE},t.prototype.check=function(e){if(!Array.isArray(e))return c.error(f.FILE_TYPES_SHOULD_BE_AN_ARRAY,this);for(var t=0,n=e;t<n.length;t++){var r=n[t];if("string"!=typeof r)return c.error(f.FILE_TYPES_SHOULD_BE_AN_ARRAY,this)}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e,r=m.intersection(this._value,n._value);return r.length>0?new t(r):this.nothing(e,"no common file types")}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){return c.ok()},t.prototype.toString=function(){return"supported file types: "+this._value.join(", ")},t}(_);t.FileTypes=B;var K=function(e){function t(t){e.call(this),this._value=t}return p(t,e),t.prototype.facetName=function(){return"format"},t.prototype.requiredType=function(){return c.SCALAR},t.prototype.requiredTypes=function(){return[c.NUMBER,c.INTEGER,c.DATETIME]},t.prototype.check=function(e){return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e;return n._value===this._value?this:this.nothing(e,"Format restrictions can not be composed at one type")}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){var e=this;try{var t=[];if(this.owner().isSubTypeOf(c.INTEGER))t=["int32","int64","int","int16","int8"];else if(this.owner().isSubTypeOf(c.NUMBER))t=["int32","int64","int","long","float","double","int16","int8"];else{if(!this.owner().isSubTypeOf(c.DATETIME))return null;t=["rfc3339","rfc2616"]}var n=m.find(t,function(t){return t==e.value()});if(!n)return c.error(f.ALLOWED_FORMAT_VALUES,this,{allowedValues:t.map(function(e){return"'"+e+"'"}).join(", ")},c.Status.ERROR,!0)}catch(r){return new y.Status(y.Status.ERROR,"",r.message,this)}return null},t.prototype.toString=function(){return"should have format:"+this.value},t}(_);t.Format=K;var V=function(e){function t(t){e.call(this),this._value=t}return p(t,e),t.prototype.facetName=function(){return"enum"},t.prototype.requiredType=function(){return c.ANY},t.prototype.check=function(e){if(!this.checkStatus){var t=this.value();if(Array.isArray(t)||(t=[t]),!t.some(function(t){return t==e})){var n=Array.isArray(this._value)?this._value.map(function(e){return"'"+e+"'"}).join(", "):"'"+this._value+"'";return c.error(f.ENUM_RESTRICTION,this,{values:n})}}return c.ok()},t.prototype.composeWith=function(e){if(e instanceof t){var n=e,r=m.intersection(this._value,n._value);return 0==r.length?this.nothing(e):new t(r)}return null},t.prototype.value=function(){return this._value},t.prototype.checkValue=function(){var e=this;if(!this.owner().isSubTypeOf(this.requiredType()))return c.error(f.ENUM_OWNER_TYPES,this,{typeNames:this.requiredType().name()},c.Status.ERROR,!0);if(this.requiredTypes()&&this.requiredTypes().length>0){var t=this.owner(),n=m.find(this.requiredTypes(),function(e){return t.isSubTypeOf(e)});if(!n){var r="["+this.requiredTypes().map(function(e){return"'"+e.name()+"'"}).join(", ")+"]";return c.error(f.ENUM_OWNER_TYPES,this,{typeNames:r},c.Status.ERROR,!0)}}if(!Array.isArray(this._value))return c.error(f.ENUM_ARRAY,this,{},c.Status.ERROR,!0);var i=c.ok();this.checkStatus=!0;try{this._value.forEach(function(t,n){var r=e.owner().validate(t);r.isOk()||(c.setValidationPath(r,{name:n}),i.addSubStatus(r))})}finally{this.checkStatus=!1}return i},t.prototype.toString=function(){var e=Array.isArray(this._value)?this._value.map(function(e){return"'"+e+"'"}).join(", "):"'"+this._value+"'";return"value should be one of: "+e},t}(_);t.Enum=V,t.optimize=u},function(e,t,n){"use strict";function r(e,t){return f.serializeToXML(e,t)}function i(e,t){if("string"==typeof e&&(t.isObject()||t.isArray()||t.isExternal()||t.isUnion())){var n=e,r=n.trim().charAt(0);if("{"==r||"["==r||"null"==n.trim())try{return JSON.parse(n)}catch(i){if(t.isObject()||t.isArray()){var a=s.error(u.CAN_NOT_PARSE_JSON,this,{msg:i.message});return a}}if("<"==r)try{var o=f.readObject(n,t),l=f.getXmlErrors(o);if(l){var p=s.error(u.INVALID_XML,null);return l.forEach(function(e){return p.addSubStatus(e)}),p}return o}catch(i){}}return t.getExtra(d.REPEAT)&&(e=[e]),e}function a(e,t,n){t?s.setValidationPath(e,{name:"examples",child:{name:n}}):s.setValidationPath(e,{name:"examples",child:{name:n,child:{name:"value"}}})}var o=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},s=n(100),u=s.messageRegistry,l=n(100),p=n(104),c=n(185),f=n(145),d=n(101),m=function(e){function t(t,n,r){void 0===r&&(r=!1),e.call(this,r),this._name=t,this._value=n}return o(t,e),t.prototype.value=function(){return this._value},t.prototype.requiredType=function(){return s.ANY},t.prototype.facetName=function(){return this._name},t.prototype.kind=function(){return null},t}(s.TypeInformation);t.MetaInfo=m;var h=function(e){function t(t){e.call(this,"description",t)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.Description},t}(m);t.Description=h;var y=function(e){function t(){e.call(this,"notScalar",!0)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.NotScalar},t}(m);t.NotScalar=y;var v=function(e){function t(t){e.call(this,"displayName",t)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.DisplayName},t}(m);t.DisplayName=v;var g=function(e){function t(t){e.call(this,"usage",t)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.Usage},t}(m);t.Usage=g;var A=function(e){function t(t,n){e.call(this,t,n)}return o(t,e),t.prototype.validateSelf=function(t,n){void 0===n&&(n=!1);var r=t.get(this.facetName());if(!r)return s.error(u.UNKNOWN_ANNOTATION,this,{facetName:this.facetName()});var i=s.ok(),a=this.value();a||r.isString()&&(a="");var o=r.metaOfType(w),l=n?"Example":"TypeDeclaration";if(o.length>0){var p=[],c=o.filter(function(e){var t=e.value();return Array.isArray(t)?(p=p.concat(t),t.indexOf(l)>=0):(p.push(t),t==l)});if(0==c.length){var f=p.map(function(e){return"'"+e+"'"}).join(", "),d=s.error(u.INVALID_ANNOTATION_LOCATION,this,{aName:e.prototype.facetName.call(this),aValues:f});i.addSubStatus(d)}}var m=r.validateDirect(a,!0,!1);if(!m.isOk()){var h=s.error(u.INVALID_ANNOTATION_VALUE,this,{msg:m.getMessage()});h.addSubStatus(m),i.addSubStatus(h)}return s.setValidationPath(i,{name:"("+this.facetName()+")"}),i},t.prototype.kind=function(){return d.MetaInformationKind.Annotation},t.prototype.ownerFacet=function(){return this._ownerFacet},t.prototype.setOwnerFacet=function(e){this._ownerFacet=e},t}(m);t.Annotation=A;var S=function(e){function t(t,n,r,i){void 0===i&&(i=!1),e.call(this,t,n,!0),this.name=t,this._type=n,this.optional=r,this.builtIn=i}return o(t,e),t.prototype.actualName=function(){return"?"==this.name.charAt(this.name.length-1)?this.name.substr(0,this.name.length-1):this.name},t.prototype.isOptional=function(){return this.optional},t.prototype.type=function(){return this._type},t.prototype.kind=function(){return d.MetaInformationKind.FacetDeclaration},t.prototype.isBuiltIn=function(){return this.builtIn},t}(m);t.FacetDeclaration=S;var E=function(e){function t(t,n){e.call(this,t,n,!0)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.CustomFacet},t}(m);t.CustomFacet=E;var T=[{propName:"strict",propType:"boolean",messageEntry:u.STRICT_BOOLEAN},{propName:"displayName",propType:"string",messageEntry:u.DISPLAY_NAME_STRING},{propName:"description",propType:"string",messageEntry:u.DESCRIPTION_STRING}],b=function(e){function t(t){e.call(this,"example",t)}return o(t,e),t.prototype.validateSelf=function(e){var t=s.ok();t.addSubStatus(this.validateValue(e));var n=this.validateAnnotations(e);return s.setValidationPath(n,{name:this.facetName()}),t.addSubStatus(n),t},t.prototype.validateValue=function(e){var t=this.value(),n=!1,r=s.ok();if("object"==typeof t&&t&&t.value){for(var a=0,o=T;a<o.length;a++){var l=o[a],p=l.propName,c=l.propType,f=t[p];if(f&&typeof f!=c&&("object"==typeof f&&Object.keys(f).forEach(function(t){if("("==t.charAt(0)&&")"==t.charAt(t.length-1)){var n=new A(t.substring(1,t.length-1),f[t]),i=n.validateSelf(e,!0);s.setValidationPath(i,{name:"example",child:{name:p,child:{name:t}}}),r.addSubStatus(i)}}),!f.value&&typeof f.value!=c)){var d=s.error(l.messageEntry,this),m=f.value?{name:"value"}:null;s.setValidationPath(d,{name:"example",child:{name:p,child:m}}),r.addSubStatus(d)}}if(t.strict===!1||"object"==typeof t.strict&&t.strict.value===!1)return r;t=t.value,n=!0}var h=i(t,this.owner());if(h instanceof s.Status&&!h.isOk())return s.setValidationPath(h,{name:"example"}),r.addSubStatus(h),r;var y=this.owner().validateDirect(h,!0,!1);if(!y.isOk()){"string"==typeof this.value();var v=s.error(u.INVALID_EXMAPLE,this,{msg:y.getMessage()});y.getErrors().forEach(function(e){v.addSubStatus(e),n?s.setValidationPath(e,{name:"example",child:{name:"value"}}):s.setValidationPath(e,{name:"example"})}),r.addSubStatus(v)}return r},t.prototype.validateAnnotations=function(e){var t=s.ok(),n=this.value();if("object"==typeof n&&n&&n.value)for(var r=Object.keys(n).filter(function(e){return e.length>2&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)}),i=0,a=r;i<a.length;i++){var o=a[i],u=n[o],l=o.substring(1,o.length-1),p=new A(l,u);t.addSubStatus(p.validateSelf(e,!0))}return t},t.prototype.example=function(){var e=this.value();return"object"==typeof e&&e&&e.value&&(e=e.value),i(e,this.owner())},t.prototype.asXMLString=function(){var e=this.value();if("string"==typeof e&&0===e.trim().indexOf("<"))return e;var t=i(e,this.owner());return r(t,this.owner())},t.prototype.kind=function(){return d.MetaInformationKind.Example},t}(m);t.Example=b;var N=function(e){function t(t){e.call(this,"required",t)}return o(t,e),t.prototype.validateSelf=function(t){var n=e.prototype.validateSelf.call(this,t);return"boolean"!=typeof this.value()&&(n=s.error(u.REQUIRED_BOOLEAN,this),s.setValidationPath(n,{name:this.facetName()})),n},t.prototype.kind=function(){return d.MetaInformationKind.Required},t}(m);t.Required=N;var _=function(e){function t(){e.call(this,"hasPropertiesFacet",null)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.HasPropertiesFacet},t}(m);t.HasPropertiesFacet=_;var w=function(e){function t(t){e.call(this,"allowedTargets",t)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.AllowedTargets},t}(m);t.AllowedTargets=w;var M=function(e){function t(t){e.call(this,"examples",t)}return o(t,e),t.prototype.examples=function(){var e=this,t=this.value(),n=[];return Object.keys(t).forEach(function(r){if("object"==typeof t[r]&&t[r]){var a=t[r].value;a||(a=t[r]);var o=i(a,e.owner());n.push(o)}}),n},t.prototype.asXMLStrings=function(){var e=this,t=this.value(),n={};return Object.keys(t).forEach(function(a){var o=t[a];if("string"==typeof o&&0===o.trim().indexOf("<"))return void(n[a]=o);var s=i(o,e.owner());n[a]=r(s,e.owner())}),n},t.prototype.validateSelf=function(e){var t=this;if("object"==typeof this.value()){var n=new l.Status(l.Status.OK,"","",this),r=this.value();return r&&Object.keys(r).forEach(function(o){var u=r[o];if(u){"object"==typeof u&&u.value&&Object.keys(u).forEach(function(t){if("("==t.charAt(0)&&")"==t.charAt(t.length-1)){var i=new A(t.substring(1,t.length-1),r[o][t]),a=i.validateSelf(e,!0);s.setValidationPath(a,{name:"examples",child:{name:o,child:{name:t}}}),n.addSubStatus(a)}});var l=u.value,p=!l;if(p)l=u;else{for(var c=0,f=T;c<f.length;c++){var d=f[c];t.checkScalarProperty(u,o,d,e,n)}if(u.strict===!1||"object"==typeof u.strict&&u.strict.value===!1)return}var m=i(l,t.owner());if(m instanceof s.Status)return a(m,p,o),void n.addSubStatus(m);var h=t.owner().validate(m,!0,!1);h.getErrors().forEach(function(e){n.addSubStatus(e),a(e,p,o)})}}),n}return s.error(u.EXMAPLES_MAP,this)},t.prototype.checkScalarProperty=function(e,t,n,r,i){var a=n.propName,o=n.propType,u=e[a];if(u&&typeof u!=o){var l=null;if("object"==typeof u&&(l={name:"value"},Object.keys(u).forEach(function(n){if("("==n.charAt(0)&&")"==n.charAt(n.length-1)){var o=new A(n.substring(1,n.length-1),e[a][n]),u=o.validateSelf(r,!0);s.setValidationPath(u,{name:"examples",child:{name:t,child:{name:a,child:{name:n}}}}),i.addSubStatus(u)}})),!u.value&&typeof u.value!=o){var p=s.error(n.messageEntry,this);s.setValidationPath(p,{name:"examples",child:{name:t,child:{name:a,child:l}}}),i.addSubStatus(p)}}},t.prototype.kind=function(){return d.MetaInformationKind.Examples},t}(m);t.Examples=M;var I=function(e){function t(t){e.call(this,"xml",t)}return o(t,e),t.prototype.kind=function(){return d.MetaInformationKind.XMLInfo},t}(m);t.XMLInfo=I;var R=function(e){function t(t){e.call(this,"default",t)}return o(t,e),t.prototype.validateSelf=function(t){var n=this,r=e.prototype.validateSelf.call(this,t),i=this.owner().validateDirect(this.value(),!0);if(!i.isOk()){var a=s.error(u.INVALID_DEFAULT_VALUE,this,{msg:i.getMessage()});i.getErrors().forEach(function(e){a.addSubStatus(e),s.setValidationPath(e,{name:n.facetName()})}),r.addSubStatus(a)}return r},t.prototype.kind=function(){return d.MetaInformationKind.Default},t}(m);t.Default=R;var C=function(e){function t(t){e.call(this,!0),this.property=t}return o(t,e),t.prototype.requiredType=function(){return s.OBJECT},t.prototype.value=function(){return this.property},t.prototype.facetName=function(){return"discriminator"},t.prototype.validateSelf=function(t){var n=this,r=e.prototype.validateSelf.call(this,t);if(this.owner().isUnion())r=s.error(u.DISCRIMINATOR_FOR_UNION,this);else if(this.owner().isSubTypeOf(s.OBJECT))if(this.owner().getExtra(s.GLOBAL)===!1)r=s.error(u.DISCRIMINATOR_FOR_INLINE,this);else{var i=c.find(this.owner().meta(),function(e){return e instanceof p.PropertyIs&&e.propertyName()==n.value()});i?i.value().isScalar()||(r=s.error(u.SCALAR_FOR_DISCRIMINATOR,this)):r=s.error(u.UNKNOWN_FOR_DISCRIMINATOR,this,{value:this.value()},s.Status.WARNING)}else r=s.error(u.DISCRIMINATOR_FOR_OBJECT,this);return r.getValidationPath()||s.setValidationPath(r,{name:this.facetName()}),r},t.prototype.kind=function(){return d.MetaInformationKind.Discriminator},t}(s.TypeInformation);t.Discriminator=C;var L=function(e){function t(t,n){void 0===n&&(n=!0),e.call(this,!1),this._value=t,this.strict=n}return o(t,e),t.prototype.check=function(e,n){var r=this.owner(),i=this.value(),a=r.metaOfType(C);if(0==a.length)return s.ok();var o=a[0].value();if(i){if(e.hasOwnProperty(o)){for(var u=this.owner().allSubTypes().concat(this.owner()),p={},c=0,f=u;c<f.length;c++){var d=f[c],m=d.metaOfType(t);m&&m.length>0&&m.forEach(function(e){return p[e.value()]=!0})}var h=e[o];if(!p[h]){var y=s.error(l.Status.CODE_INCORRECT_DISCRIMINATOR,this,{rootType:r.name(),value:h,propName:o},l.Status.WARNING);return s.setValidationPath(y,{name:o,child:n}),y}return s.ok()}var v=s.error(l.Status.CODE_MISSING_DISCRIMINATOR,this,{rootType:r.name(),propName:o});return s.setValidationPath(v,n),v}return s.ok()},t.prototype.facetName=function(){return"discriminatorValue"},t.prototype.validateSelf=function(t){var n=e.prototype.validateSelf.call(this,t);if(this.strict){var r=this.owner().oneMeta(C);if(this.owner().isSubTypeOf(s.OBJECT))if(this.owner().getExtra(s.GLOBAL)===!1)n.addSubStatus(s.error(u.DISCRIMINATOR_FOR_INLINE,this));else if(r){var i=c.find(this.owner().meta(),function(e){return e instanceof p.PropertyIs&&e.propertyName()==r.value()});if(i){var a=i.value().validate(this.value());a.isOk()||n.addSubStatus(s.error(u.INVALID_DISCRIMINATOR_VALUE,this,{msg:a.getMessage()}))}}else n.addSubStatus(s.error(u.DISCRIMINATOR_VALUE_WITHOUT_DISCRIMINATOR,this));else n.addSubStatus(s.error(u.DISCRIMINATOR_FOR_OBJECT,this))}return n.getValidationPath()||s.setValidationPath(n,{name:this.facetName()}),n},t.prototype.requiredType=function(){return s.OBJECT},t.prototype.value=function(){return this._value},t.prototype.kind=function(){return d.MetaInformationKind.DiscriminatorValue},t.prototype.isStrict=function(){return this.strict},t}(s.Constraint);t.DiscriminatorValue=L},function(e,t,n){"use strict";function r(e){o=e}function i(e,t,n){void 0===n&&(n=null);var r=null;if(e.getExtra(m))return e.getExtra(m);if(!e){var h=t("any");h||(r=new u.StructuredType(e.name()))}if(e.isBuiltin()){var y="any"!=e.name()&&"array"!=e.name()?t(e.name()):null;r=y?y:e.isScalar()?new u.ValueType(e.name(),null):new u.StructuredType(e.name())}else if(e.isObject())r=new u.StructuredType(e.name(),null);else if(e.isArray()){var v=new u.Array(e.name(),null);r=v,e.putExtra(m,r);var g=e.oneMeta(p.ComponentShouldBeOfType),A=g?g.value():s.ANY;v.setComponent(i(A,t))}else if(e instanceof s.UnionType){var S=new u.Union(e.name(),null);0==e.superTypes().length&&S._superTypes.push(i(s.UNION,t,n)),e.putExtra(m,S),e.options().forEach(function(n){if(null==S.left)S.left=i(n,t);else if(null==S.right)S.right=i(n,t);else{var r=new u.Union(e.name(),null);r.left=S.right,r.right=i(n,t),S.right=r}}),r=S}else if(e.isScalar())r=new u.ValueType(e.name(),null);else if(e instanceof s.ExternalType){var E=e,T=new u.ExternalType(E.name());T.schemaString=E.schema(),r=T}if(r||(r=new u.StructuredType(e.name())),e.superTypes().forEach(function(e){var n=i(e,t);e.isBuiltin()?r._superTypes.push(n):r.addSuperType(n)}),e.isEmpty()){if(e.isArray()&&1==e.superTypes().length&&e.superTypes()[0].isAnonymous()){var b=r.superTypes()[0];b.setName(e.name()),b._subTypes=b._subTypes.filter(function(e){return e!=r}),r=b}if(e.isUnion()&&1==e.superTypes().length&&e.superTypes()[0].isAnonymous()){var b=r.superTypes()[0];b.setName(e.name()),b._subTypes=b._subTypes.filter(function(e){return e!=r}),r=b}}e.putExtra(m,r);var N=l.toProto(e);N.properties.forEach(function(e){var n=e.regExp?"/"+e.id+"/":e.id,a=o?o(n):new u.Property(n);a.withDomain(r),a.withRange(i(e.type,t)),e.optional||a.withRequired(!0),e.regExp&&a.withKeyRegexp(n)}),N.facetDeclarations.filter(function(e){return!e.isBuiltIn()}).forEach(function(e){var n=o?o(e.facetName()):new u.Property(e.facetName());n.withRange(i(e.type(),t)),r.addFacet(n)}),e.customFacets().forEach(function(e){r.fixFacet(e.facetName(),e.value())});for(var _={example:!0,examples:!0},w=e.meta().filter(function(t){if(!(t instanceof f.Discriminator||t instanceof f.DiscriminatorValue)){if(!(t instanceof p.FacetRestriction||t instanceof f.MetaInfo||t instanceof p.KnownPropertyRestriction))return!1;if(t instanceof f.FacetDeclaration||t instanceof f.CustomFacet)return!1}var n=t.requiredType(),r=n.isUnion()?n.allOptions():[n];if(!d.some(r,function(t){return e.isSubTypeOf(t)}))return!1;var i=t.facetName();return _[i]?!1:"discriminatorValue"==i?t.isStrict():"allowedTargets"==i?!0:null!=c.getInstance().facetPrototypeWithName(i)}),M=0,I=w;M<I.length;M++){var R=I[M],C=R.facetName();"closed"==C&&(C="additionalProperties"),r.fixFacet(C,R.value(),!0)}return r.addAdapter(e),e.isEmpty()&&r.addAdapter(new u.Empty),r._validator=a(e),e.isBuiltin()?r.buildIn=!0:e.subTypes().forEach(function(e){i(e,t,n)}),r}function a(e){return function(t){return e.validate(t,!1).getErrors()}}var o,s=n(100),u=n(107),l=n(102),p=n(104),c=n(103),f=n(105),d=n(185),m="nominal";t.setPropertyConstructor=r,t.toNominal=i},function(e,t,n){"use strict";function r(e){u.push(e)}var i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},a=n(108),o=n(101),s=n(146),u=[];t.registerInjector=r;var l=function(){function e(){var e=this;this.adapters=[],u.forEach(function(t){return t.inject(e)})}return e.prototype.addAdapter=function(e){this.adapters.push(e)},e.prototype.getAdapter=function(e){var t=null;return this.adapters.forEach(function(n){n instanceof e&&(t=n)}),t},e.prototype.getAdapters=function(){return this.adapters},e}();t.Adaptable=l;var p=function(e){function t(t,n){void 0===n&&(n=""),e.call(this),this._name=t,this._description=n,this._tags=[],this._annotations=[]}return i(t,e),t.prototype.nameId=function(){return this._name},t.prototype.description=function(){return this._description},t.prototype.addAnnotation=function(e){this._annotations.push(e)},t.prototype.removeAnnotation=function(e){this._annotations=this._annotations.filter(function(t){return t!=e})},t.prototype.annotations=function(){return[].concat(this._annotations)},t.prototype.tags=function(){return this._tags},t.prototype.withDescription=function(e){return this._description=e,this},t.prototype.setName=function(e){this._name=e},t}(l);t.Described=p;var c=function(e){function t(t,n){e.call(this,t.nameId()),this.type=t,this.parameters=n}return i(t,e),t.prototype.parameterNames=function(){return Object.keys(this.parameters)},t.prototype.parameter=function(e){return this.parameters[e]},t.prototype.getType=function(){return this.type},t}(p);t.Annotation=c;var f=function(){function e(){}return e}();t.Empty=f;var d=function(){function e(){}return e.prototype.type=function(e){return null},e.prototype.version=function(){return"Empty"},e.prototype.types=function(){return[]},e.prototype.matched=function(){return{}},e}(),m=new d,h=n(142),y=function(e){function t(t,n,r){void 0===n&&(n=m),void 0===r&&(r=""),e.call(this,t),this._universe=n,this._path=r,this._customProperties=[],this._facets=[],this._superTypes=[],this._subTypes=[],this._requirements=[],this._fixedFacets={},this._fixedBuildInFacets={},this.uc=!1}return i(t,e),t.prototype.properties=function(){return[]},t.prototype.externalInHierarchy=function(){var e=this.allSuperTypes(),t=null;return e.forEach(function(e){e instanceof T&&(t=e)}),t},t.prototype.addFacet=function(e){this._facets.push(e)},t.prototype.validate=function(e){if(!this._validator)throw new Error("Validate can be used only on runtime types instances");return this._validator(e)},t.prototype.allFacets=function(e){if(void 0===e&&(e={}),this._allFacets)return this._allFacets;if(e[this.nameId()])return[];e[this.typeId()]=this;var n={};return this.superTypes().length>0&&this.superTypes().forEach(function(r){r instanceof t&&r.allFacets(e).forEach(function(e){return n[e.nameId()]=e})}),this._facets.forEach(function(e){return n[e.nameId()]=e}),this._allFacets=Object.keys(n).map(function(e){return n[e]}),this._allFacets},t.prototype.facets=function(){return[].concat(this._facets)},t.prototype.facet=function(e){return s.find(this.allFacets(),function(t){return t.nameId()==e})},t.prototype.typeId=function(){return this.nameId()},t.prototype.allProperties=function(e){if(void 0===e&&(e={}),this._props)return this._props;if(e[this.typeId()])return[];e[this.typeId()]=this;var n={};this.superTypes().length>0&&this.superTypes().forEach(function(r){r instanceof t?r.allProperties(e).forEach(function(e){return n[e.nameId()]=e}):r.allProperties().forEach(function(e){return n[e.nameId()]=e})});for(var r in this.fixedFacets())delete n[r];return this.properties().forEach(function(e){return n[e.nameId()]=e}),this._props=Object.keys(n).map(function(e){return n[e]}),this._props},t.prototype.property=function(e){return s.find(this.allProperties(),function(t){return t.nameId()==e})},t.prototype.hasValueTypeInHierarchy=function(){return null!=s.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e.hasValueTypeInHierarchy()}finally{t.uc=!1}})},t.prototype.isAnnotationType=function(){return!1},t.prototype.hasStructure=function(){return!1},t.prototype.key=function(){return this._key?this._key:this._universe&&(this._key=this.universe().matched()[this.nameId()],!this._key)?null:this._key},t.prototype.hasArrayInHierarchy=function(){var e=null!=s.find(this.allSuperTypes(),function(e){return e instanceof E});return e},t.prototype.arrayInHierarchy=function(){var e=this.allSuperTypes(),t=null;return e.forEach(function(e){e instanceof E&&(t=e)}),t},t.prototype.unionInHierarchy=function(){var e=this.allSuperTypes(),t=null;return e.forEach(function(e){e instanceof S&&(t=e)}),t},t.prototype.hasExternalInHierarchy=function(){return null!=s.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e instanceof T}finally{t.uc=!1}})},t.prototype.hasUnionInHierarchy=function(){return null!=s.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e.hasUnionInHierarchy()}finally{t.uc=!1}})},t.prototype.fixFacet=function(e,t,n){void 0===n&&(n=!1),n?this._fixedBuildInFacets[e]=t:this._fixedFacets[e]=t},t.prototype.getFixedFacets=function(){return this.fixedFacets()},t.prototype.fixedFacets=function(){return this.collectFixedFacets(!1)},t.prototype.fixedBuiltInFacets=function(){return this.collectFixedFacets(!0)},t.prototype.collectFixedFacets=function(e){for(var t=e?this._fixedBuildInFacets:this._fixedFacets,n={},r=0,i=Object.keys(t);r<i.length;r++){var a=i[r];n[a]=t[a]}return this.contributeFacets(n),n},t.prototype.allFixedFacets=function(){return this.collectAllFixedFacets(!1)},t.prototype.allFixedBuiltInFacets=function(){return this.collectAllFixedFacets(!0)},t.prototype.collectAllFixedFacets=function(e){if(e&&this._abf)return this._abf;if(!e&&this._af)return this._af;var t=this.allSuperTypes();t.push(this);var n={};return t.forEach(function(t){for(var r=e?t.fixedBuiltInFacets():t.fixedFacets(),i=0,a=Object.keys(r);i<a.length;i++){var o=a[i];n[o]=r[o]}}),this._af=n,n},t.prototype.contributeFacets=function(e){},t.prototype.getPath=function(){return this._path},t.prototype.setNameAtRuntime=function(e){this._nameAtRuntime=e},t.prototype.getNameAtRuntime=function(){return this._nameAtRuntime},t.prototype.universe=function(){return this._universe?this._universe:new d},t.prototype.superTypes=function(){return[].concat(this._superTypes)},t.prototype.isAssignableFrom=function(e){if(this.nameId()==e)return this.isUserDefined()?!1:!0;for(var t=this.allSuperTypes(),n=0;n<t.length;n++)if(t[n].nameId()==e)return!0;return!1},t.prototype.annotationType=function(){return null},t.prototype.subTypes=function(){return[].concat(this._subTypes)},t.prototype.allSubTypes=function(){var e=[];return this.subTypes().forEach(function(t){e.push(t),e=e.concat(t.allSubTypes())}),s.unique(e)},t.prototype.allSuperTypes=function(){if(this._allSupers)return this._allSupers;var e=[];return this.allSuperTypesRecurrent(this,{},e),this._allSupers=s.unique(e),this._allSupers},t.prototype.allSuperTypesRecurrent=function(e,t,n){var r=this;e.superTypes().forEach(function(e){t[e.typeId()]||(n.push(e),t[e.typeId()]=e,r.allSuperTypesRecurrent(e,t,n))})},t.prototype.addSuperType=function(e){e._subTypes.push(this),this._superTypes.push(e)},t.prototype.addRequirement=function(e,t){this._requirements.push(new a.ValueRequirement(e,t))},t.prototype.valueRequirements=function(){return this._requirements},t.prototype.requiredProperties=function(){return this.allProperties().filter(function(e){return e.isRequired()})},t.prototype.printDetails=function(e,n){var r=this;e||(e=""),n||(n={hideProperties:!1,hideSuperTypeProperties:!1,printStandardSuperclasses:!1});var i="  ",a="",o=this.getTypeClassName();a+=e+this.nameId()+"["+o+"]\n";var u=this.properties();u&&u.length>0&&!n.hideProperties&&(a+=e+i+"Properties:\n",u.forEach(function(n){var r="",o=n.range();o instanceof p&&(r+=o.nameId()),o instanceof t&&(r+="[",r+=o.getTypeClassName(),r+="]"),a+=e+i+i+n.nameId()+" : "+r+"\n"}));var l=this.superTypes(),c=l;return l&&!n.printStandardSuperclasses&&(c=s.filter(l,function(e){var n=e instanceof p?e.nameId():"",i=e instanceof t?e.getTypeClassName():"";return!r.isStandardSuperclass(n,i)})),c&&c.length>0&&(a+=e+i+"Super types:\n",c.forEach(function(t){a+=t.printDetails(e+i+i,{hideProperties:n.hideSuperTypeProperties,hideSuperTypeProperties:n.hideSuperTypeProperties,printStandardSuperclasses:n.printStandardSuperclasses})})),a},t.prototype.getTypeClassName=function(){return this.constructor.toString().match(/\w+/g)[1]},t.prototype.isStandardSuperclass=function(e,t){return"TypeDeclaration"===e&&"NodeClass"===t?!0:"ObjectTypeDeclaration"===e&&"NodeClass"===t?!0:"RAMLLanguageElement"===e&&"NodeClass"===t?!0:!1},t.prototype.examples=function(e){return h.exampleFromNominal(this,e)},t.prototype.isGenuineUserDefinedType=function(){if(this.buildIn)return!1;if(this.properties()&&this.properties().length>0)return!0;var e=this.fixedFacets();if(e&&Object.keys(e).length>0)return!0;var t=this.fixedBuiltInFacets();return t&&Object.keys(t).length>0?!0:this.isTopLevel()&&this.nameId()&&this.nameId().length>0},t.prototype.genuineUserDefinedTypeInHierarchy=function(){if(this.isGenuineUserDefinedType())return this;var e=null,t=this.allSuperTypes();return t.forEach(function(t){!e&&t.isGenuineUserDefinedType()&&(e=t);
}),e},t.prototype.hasGenuineUserDefinedTypeInHierarchy=function(){return null!=s.find(this.allSuperTypes(),function(e){var t=e;if(t.uc)return!1;t.uc=!0;try{return e.isGenuineUserDefinedType()}finally{t.uc=!1}})},t.prototype.customProperties=function(){return[].concat(this._customProperties)},t.prototype.allCustomProperties=function(){var e=[];return this.superTypes().forEach(function(t){return e=e.concat(t.allCustomProperties())}),e=e.concat(this.customProperties())},t.prototype.registerCustomProperty=function(e){if(e.domain()!=this)throw new Error("Should be already owned by this");if(-1!=this._customProperties.indexOf(e))throw new Error("Already included");this._customProperties.push(e)},t.prototype.setCustom=function(e){this._isCustom=e},t.prototype.isCustom=function(){return this._isCustom},t.prototype.isUnion=function(){return!1},t.prototype.union=function(){return null},t.prototype.isExternal=function(){return!1},t.prototype.external=function(){return null},t.prototype.isArray=function(){return!1},t.prototype.isObject=function(){if("object"==this.nameId())return!0;for(var e=0,t=this.allSuperTypes();e<t.length;e++){var n=t[e];if(n.isObject())return!0}return!1},t.prototype.array=function(){return null},t.prototype.isValueType=function(){return!1},t.prototype.kind=function(){var e=[];return this.isObject()&&e.push("object"),this.isArray()&&e.push("array"),this.isValueType()&&e.push("value"),this.isUnion()&&e.push("union"),this.isAnnotationType()&&e.push("annotation"),this.isExternal()&&e.push("external"),e},t.prototype.isBuiltIn=function(){return this.buildIn},t.prototype.setBuiltIn=function(e){this.buildIn=e},t.prototype.isTopLevel=function(){return this.getExtra(o.DEFINED_IN_TYPES_EXTRA)||this.getExtra(o.TOP_LEVEL_EXTRA)?!0:!1},t.prototype.isUserDefined=function(){return this.getExtra(o.USER_DEFINED_EXTRA)&&!this.buildIn},t.prototype.putExtra=function(e,t){var n=this.getExtraAdapter();n&&n.putExtra(e,t)},t.prototype.getExtra=function(e){var t=this.getExtraAdapter();return t?t.getExtra(e):null},t.prototype.getExtraAdapter=function(){if(this.getAdapters()){var e=s.find(this.getAdapters(),function(e){return e.getExtra&&"function"==typeof e.getExtra&&e.putExtra&&"function"==typeof e.putExtra?!0:void 0});return e}return null},t}(p);t.AbstractType=y;var v=function(e){function t(t,n,r,i){void 0===n&&(n=null),void 0===r&&(r=""),void 0===i&&(i=""),e.call(this,t,n,r)}return i(t,e),t.prototype.hasStructure=function(){return!1},t.prototype.hasValueTypeInHierarchy=function(){return!0},t.prototype.isValueType=function(){return!0},t.prototype.isUnionType=function(){return!1},t.prototype.isObject=function(){return!1},t}(y);t.ValueType=v;var g=function(e){function t(){e.apply(this,arguments),this._properties=[]}return i(t,e),t.prototype.hasStructure=function(){return!0},t.prototype.propertyIndex=function(e){for(var t=this.properties(),n=0;n<t.length;n++)if(t[n].nameId()==e)return n;return-1},t.prototype.addProperty=function(e,t){return new A(e).withDomain(this).withRange(t)},t.prototype.allPropertyIndex=function(e){for(var t=this.allProperties(),n=0;n<t.length;n++)if(t[n].nameId()==e)return n;return-1},t.prototype.properties=function(){return[].concat(this._properties)},t.prototype.registerProperty=function(e){if(e.domain()!=this)throw new Error("Should be already owned by this");if(-1!=this._properties.indexOf(e))throw new Error("Already included");this._properties.push(e)},t}(y);t.StructuredType=g;var A=function(e){function t(){e.apply(this,arguments),this._keyShouldStartFrom=null,this._isRequired=!1,this._isMultiValue=!1,this._descriminates=!1,this._defaultBooleanValue=null,this._defaultIntegerValue=null}return i(t,e),t.prototype.withMultiValue=function(e){return void 0===e&&(e=!0),this._isMultiValue=e,this},t.prototype.withDescriminating=function(e){return this._descriminates=e,this},t.prototype.withRequired=function(e){return this._isRequired=e,this},t.prototype.isRequired=function(){return this._isRequired},t.prototype.withKeyRestriction=function(e){return this._keyShouldStartFrom=e,this},t.prototype.withDomain=function(e,t){return void 0===t&&(t=!1),this._ownerClass=e,t?e.registerCustomProperty(this):e.registerProperty(this),this},t.prototype.setDefaultVal=function(e){return this._defaultValue=e,this},t.prototype.setDefaultBooleanVal=function(e){return this._defaultBooleanValue=e,this},t.prototype.setDefaultIntegerVal=function(e){return this._defaultIntegerValue=e,this},t.prototype.defaultValue=function(){return null!=this._defaultValue?this._defaultValue:null!=this._defaultBooleanValue?this._defaultBooleanValue:null!=this._defaultIntegerValue?this._defaultIntegerValue:null},t.prototype.isPrimitive=function(){return!1},t.prototype.withRange=function(e){return this._nodeRange=e,this},t.prototype.isValueProperty=function(){return this._nodeRange.hasValueTypeInHierarchy()},t.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},t.prototype.keyPrefix=function(){return this._keyShouldStartFrom},t.prototype.withEnumOptions=function(e){return this._enumOptions=e,this},t.prototype.withKeyRegexp=function(e){return this._keyRegexp=e,this},t.prototype.getKeyRegexp=function(){return this._keyRegexp},t.prototype.matchKey=function(e){if(null==e)return!1;if(null!=this._groupName)return this._groupName==e;if(null!=this._keyShouldStartFrom&&0==e.indexOf(this._keyShouldStartFrom))return!0;if(this._enumOptions&&-1!=this._enumOptions.indexOf(e))return!0;if(this.getKeyRegexp())try{if(new RegExp(this.getKeyRegexp()).test(e))return!0}catch(t){}return!1},t.prototype.getFacetValidator=function(){return this.facetValidator},t.prototype.setFacetValidator=function(e){this.facetValidator=e},t.prototype.domain=function(){return this._ownerClass},t.prototype.range=function(){return this._nodeRange},t.prototype.isMultiValue=function(){return this.range()&&this.range().hasArrayInHierarchy()?!0:this._isMultiValue},t.prototype.isDescriminator=function(){return this._descriminates},t}(p);t.Property=A;var S=function(e){function t(){e.apply(this,arguments)}return i(t,e),t.prototype.key=function(){return null},t.prototype.leftType=function(){return this.left},t.prototype.rightType=function(){return this.right},t.prototype.isUserDefined=function(){return!0},t.prototype.unionInHierarchy=function(){return this},t.prototype.union=function(){return this},t.prototype.hasUnionInHierarchy=function(){return!0},t.prototype.isUnion=function(){return!0},t.prototype.isObject=function(){return this.leftType().isObject()&&this.rightType().isObject()},t.prototype.hasArrayInHierarchy=function(){return this.left&&this.right?this.left.hasArrayInHierarchy()||this.right.hasArrayInHierarchy():this.left?this.left.hasArrayInHierarchy():this.right?this.right.hasArrayInHierarchy():void 0},t}(y);t.Union=S;var E=function(e){function t(){e.apply(this,arguments)}return i(t,e),t.prototype.hasArrayInHierarchy=function(){return!0},t.prototype.isArray=function(){return!0},t.prototype.isObject=function(){return!1},t.prototype.arrayInHierarchy=function(){return this},t.prototype.array=function(){return this},t.prototype.isUserDefined=function(){return!0},t.prototype.componentType=function(){return this.component},t.prototype.setComponent=function(e){this.component=e},t.prototype.key=function(){return null},t}(y);t.Array=E;var T=function(e){function t(){e.apply(this,arguments)}return i(t,e),t.prototype.externalInHierarchy=function(){return this},t.prototype.typeId=function(){return this.schemaString},t.prototype.schema=function(){return this.schemaString},t.prototype.isUserDefined=function(){return!0},t.prototype.hasExternalInHierarchy=function(){return!0},t.prototype.isExternal=function(){return!0},t.prototype.external=function(){return this},t}(g);t.ExternalType=T},function(e,t,n){"use strict";var r=function(){function e(e,t){this.name=e,this.value=t}return e}();t.ValueRequirement=r},function(e,t,n){"use strict";function r(e,t){o.visit(e,t)}function i(e){return o.serializeToString(e)}function a(e){return o.parse(e)}var o=n(144);t.visit=r,t.serializeToString=i,t.parse=a},function(e,t,n){(function(e){"use strict";function r(e,t){var n=_(t,e),r=y?A.getValue(n):!1;if(r&&r.provider)return r;var i=new T(e,t);return A.setValue(n,i),i}function i(e,t){var n=(_(t,e),y?A.getValue(e):!1);if(n)return n;var r=new N(e,t);return y&&A.setValue(e,r),r}function a(e,t){var n=_(t,e),r=y?A.getValue(n):!1;if(r)return r;try{var i=new T(e,t);return y&&A.setValue(n,i),i}catch(a){try{var i=new N(e,t);return y&&A.setValue(n,i),i}catch(a){return y&&A.setValue(n,new f.ValidationError(d.messageRegistry.CAN_NOT_PARSE_SCHEMA)),null}}}function o(e,t,n){null==n&&(n=s(e)),n.length>0&&(n+=":");for(var r=e.getElementsByTagName(n+t),i=[],a=0;a<r.length;a++){var o=r[a];o.parentNode===e&&i.push(o)}return i}function s(e){var t="";if(e){var n=e;if(e.ownerDocument&&(n=e.ownerDocument),n){var r=n.documentElement;r&&(t=r.prefix)}}return t}var u=n(146),l=n(147),p=n(148),c=n(183).DOMParser,f=n(100),d=n(100),m=function(){function e(){}return e}();t.ValidationResult=m;var h={errorHandler:{warning:function(){return null},error:function(){return null},fatalError:function(){return null}}},y=!0,v=5242880,g=function(){function e(){this.errors={},this.size=0}return e.prototype.getValue=function(e){var t=this.errors[e];return t?t.value:null},e.prototype.setValue=function(e,t){var n=this.errors[e];if(n)n.value=t;else for(n={key:e,value:t},this.top&&(this.top.next=n),this.top=n,this.last||(this.last=n),this.errors[e]=n,this.size+=e.length;this.size>v&&this.last;){var r=this.last.key;delete this.errors[r],this.size-=r.length,this.last=this.last.next}},e}(),A=new g;e.cleanCache=function(){A=new g};var S=function(){function e(){}return e.prototype.contextPath=function(){return""},e.prototype.normalizePath=function(e){return""},e.prototype.content=function(e){return""},e.prototype.hasAsyncRequests=function(){return!1},e.prototype.resolvePath=function(e,t){return""},e.prototype.isAbsolutePath=function(e){return!1},e.prototype.contentAsync=function(e){var t=this;return{then:function(n){return n(t.content(e))},resolve:function(){return null}}},e.prototype.promiseResolve=function(e){return{then:function(t){return t(e)},resolve:function(){return null}}},e}(),E=function(e,t,n){return"__EXAMPLE_"+e+t+n},T=function(){function e(e,t){if(this.schema=e,this.provider=t,t?this.provider=t:this.provider=new S,!e||0==e.trim().length||"{"!=e.trim().charAt(0))throw new f.ValidationError(d.messageRegistry.INVALID_JSON_SCHEMA);var r;try{var r=JSON.parse(e)}catch(i){throw new f.ValidationError(d.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,{msg:i.message})}if(r){try{var a=n(184);this.setupId(r,this.provider.contextPath());var o=""+r.$schema;-1==o.indexOf("http://json-schema.org/draft-04/")?r=a.v4(r):this.fixRequired(r)}catch(s){throw new f.ValidationError(d.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,{msg:s.message})}delete r.$schema,this.jsonSchema=r}}return e.prototype.fixRequired=function(e){},e.prototype.getType=function(){return"source.json"},e.prototype.validateObject=function(e){this.validate(JSON.stringify(e))},e.prototype.getMissingReferences=function(e,t){var n=this;void 0===t&&(t=!1);var r=[],i=p.getValidator();e.forEach(function(e){return i.setRemoteReference(e.reference,e.content||{})});var a=null;if(this.jsonSchema.id&&"string"==typeof this.jsonSchema.id){a=this.jsonSchema.id;var o=a.indexOf("#");-1!=o&&(a=a.substr(0,o))}try{i.validateSchema(this.jsonSchema)}catch(s){return[]}var r=i.getMissingRemoteReferences(),l=[];return r&&(l=u.filter(r,function(e){return!i.isResourceLoaded(e)&&e!=a})),t?l.map(function(e){return n.provider.normalizePath(e)}):l},e.prototype.getSchemaPath=function(e,t){if(void 0===t&&(t=!1),!e)return"";if(!e.id)return"";var n=e.id.trim();if(n.lastIndexOf("#")!==n.length-1)return n;var r=n.substr(0,n.length-1);return t?this.provider.normalizePath(r):r},e.prototype.patchSchema=function(e){var t=this;if(!e)return e;if(!e.id)return e;var n=e.id.trim();n.lastIndexOf("#")!==n.length-1&&(n+="#",e.id=n);var r=n.substr(0,n.length-1);if(!this.provider.isAbsolutePath(r))return e;r=this.provider.normalizePath(r);var i=[];this.collectRefContainers(e,i),i.forEach(function(e){var n=e.$ref;if("string"==typeof n&&0!==n.indexOf("#")){-1===n.indexOf("#")&&(n+="#");var i=t.provider.resolvePath(r,n);e.$ref=i}})},e.prototype.collectRefContainers=function(e,t){var n=this;Object.keys(e).forEach(function(r){return"$ref"===r?void t.push(e):void(e[r]&&"object"==typeof e[r]&&n.collectRefContainers(e[r],t))})},e.prototype.validate=function(e,t){var r=this;void 0===t&&(t=[]);var i=E(e,this.schema,this.provider.contextPath()),a=A.getValue(i);if(a){if(a instanceof Error)throw a}else{var o=p.getValidator();t.forEach(function(e){return o.setRemoteReference(e.reference,e.content)}),o.validate(JSON.parse(e),this.jsonSchema);var s=o.getMissingRemoteReferences().filter(function(e){return!u.find(t,function(t){return e===t.reference})});if(!s||0===s.length)return void this.acceptErrors(i,o.getLastErrors(),d.messageRegistry.CONTENT_DOES_NOT_MATCH_THE_SCHEMA,!0);var l=[];s.forEach(function(e){var t,i={reference:e};try{var a=n(184),o=JSON.parse(r.provider.content(e));r.setupId(o,r.provider.normalizePath(e)),t=a.v4(o),delete t.$schema,i.content=t}catch(s){i.error=s}finally{l.push(i)}}),this.provider.hasAsyncRequests()||(l.forEach(function(e){t.push(e)}),this.validate(e,t))}},e.checkIfNonObjectAssignmentFailure=function(e){var t="__$validated",n="called on non-object";if(!e)return null;if(-1!=e.indexOf(t)){var r="Cannot assign to read only property '__$validated' of ",i="Cannot create property '__$validated' on string '";return 0==e.indexOf(r)&&e.length>r.length?e.substr(r.length,e.length-r.length):0==e.indexOf(i)&&e.length>i.length+1&&"'"==e.charAt(e.length-1)?e.substr(i.length,e.length-i.length-1):""}return-1!=e.indexOf(n)?"":null},e.prototype.validateSelf=function(t){var r=this;void 0===t&&(t=[]);var i=E("__SCHEMA_VALIDATION__",this.schema,this.provider.contextPath()),a=A.getValue(i);if(a){if(a instanceof Error)throw a}else{var o=p.getValidator();t.forEach(function(e){return o.setRemoteReference(e.reference,e.content)});try{o.validateSchema(this.jsonSchema)}catch(a){var s=e.checkIfNonObjectAssignmentFailure(a.message);if(null!==s){var l=s,c="Assignment to non-object.";l&&(c="Unexpected value '"+l+"'"),this.acceptErrors(i,[{message:c,params:[]}],d.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,!0,!0)}throw a}var f=o.getMissingRemoteReferences().filter(function(e){return!u.find(t,function(t){return e===t.reference})});if(!f||0===f.length)return void this.acceptErrors(i,o.getLastErrors(),d.messageRegistry.INVALID_JSON_SCHEMA_DETAILS,!0,!0);var m=[];f.forEach(function(e){var t,i={reference:e};try{var a=n(184),o=JSON.parse(r.provider.content(e));r.setupId(o,r.provider.normalizePath(e)),t=a.v4(o),delete t.$schema,i.content=t}catch(s){i.error=s}finally{m.push(i)}}),this.provider.hasAsyncRequests()||(m.forEach(function(e){t.push(e)}),this.validateSelf(t))}},e.prototype.setupId=function(e,t){if(t&&e){if(e.id)return e.id=e.id.trim(),void(e.id.indexOf("#")<0&&(e.id=e.id+"#"));e.id=t.replace(/\\/g,"/")+"#",this.patchSchema(e)}},e.prototype.acceptErrors=function(e,t,n,r,i){if(void 0===r&&(r=!1),void 0===i&&(i=!1),t&&t.length>0){var a=t.map(function(e){return e.message+" "+e.params}).join(", "),o=new f.ValidationError(n,{msg:a});if(o.isWarning=i,o.errors=t,A.setValue(e,o),r)throw o}else A.setValue(e,1)},e.prototype.contentAsync=function(e){var t,r=this,i=n(184),a=this.provider.contentAsync(e);if(!a)return this.provider.promiseResolve({reference:e,content:null,error:new f.ValidationError(d.messageRegistry.REFERENCE_NOT_FOUND,{ref:e})});var o=a.then(function(n){var a={reference:e};try{var o=JSON.parse(n);r.setupId(o,r.provider.normalizePath(e)),t=i.v4(o),delete t.$schema,a.content=t}catch(s){a.error=s}return a});return o},e}();t.JSONSchemaObject=T;var b=10,N=function(){function e(e,t){if(this.schema=e,this.provider=t,this.extraElementData=null,this.references={},this.contentToResult={},t||(this.provider=new S),"<"!=e.charAt(0))throw new f.ValidationError(d.messageRegistry.INVALID_XML_SCHEMA);this.schemaString=this.handleReferenceElement(e)}return e.prototype.getType=function(){return"text.xml"},e.prototype.validateObject=function(e){if(this.extraElementData){var t=Object.keys(e)[0],n=new f.ValidationError(d.messageRegistry.EXTERNAL_TYPE_ERROR,{typeName:this.extraElementData.requestedName,objectName:t});if(!this.extraElementData.type&&!this.extraElementData.originalName)return void this.acceptErrors("key",[n],!0);if(this.extraElementData.originalName&&t!==this.extraElementData.originalName)return void this.acceptErrors("key",[n],!0);if(this.extraElementData.type){var r=e[t];delete e[t],e[this.extraElementData.name]=r}}this.validate(l.jsonToXml(e))},e.prototype.collectReferences=function(e,t,n){var r,i=this;r=new c(h).parseFromString(e);var a=o(r,"schema",this.namspacePrefix)[0],s=o(a,"import",this.namspacePrefix),u=o(a,"include",this.namspacePrefix),p=s.concat(u);return p.forEach(function(e){var r=e.getAttribute("schemaLocation");if(r){var a=i.provider.resolvePath(t,r),o=n[a];if(!o){var s,u=Object.keys(n).length,p=i.provider.content(a);try{s=i.collectReferences(p,a,n)}catch(c){s=p}o=l.createXmlSchemaReference(a,u,s),n[a]=o}e.setAttribute("schemaLocation","file_"+o.virtualIndex+".xsd")}}),r.toString()},e.prototype.getMissingReferences=function(){var e,t=this;e=new c(h).parseFromString(this.schemaString);var n=o(e,"schema",this.namspacePrefix)[0],r=o(n,"import",this.namspacePrefix),i=o(n,"include",this.namspacePrefix),a=r.concat(i),s=[];return a.forEach(function(e){var n=e.getAttribute("schemaLocation");if(n){var r=t.provider.resolvePath(t.provider.contextPath(),n);s.push(r)}}),s},e.prototype.collectReferencesAsync=function(e,t,n){var r,i=this;r=new c(h).parseFromString(e);var a=o(r,"schema",this.namspacePrefix)[0],s=o(a,"import",this.namspacePrefix),u=o(a,"include",this.namspacePrefix),p=s.concat(u);return Promise.all(p.map(function(e){var r=e.getAttribute("schemaLocation");if(r){var a=i.provider.resolvePath(t,r),o=n[a];return o?(e.setAttribute("schemaLocation","file_"+o.virtualIndex+".xsd"),{}):i.provider.contentAsync(a).then(function(t){return i.collectReferencesAsync(t,a,n).then(function(e){return e},function(e){return t}).then(function(t){var r=Object.keys(n).length;return o=l.createXmlSchemaReference(a,r,t),n[a]=o,e.setAttribute("schemaLocation","file_"+o.virtualIndex+".xsd"),{}})})}return{}})).then(function(e){return Promise.resolve(r.toString())})},e.prototype.loadSchemaReferencesAsync=function(){return this.collectReferencesAsync(this.schemaString,this.provider.contextPath(),{})},e.prototype.validate=function(e){try{var t=this.contentToResult[e];if(t===!1)return;if(t)throw t;var n={},r=this.collectReferences(this.schemaString,this.provider.contextPath(),n),i=l.getValidator(r);if(this.provider.hasAsyncRequests())return;var a=i.validate(e,Object.keys(n).map(function(e){return n[e]}));this.acceptErrors("key",a,!0),this.contentToResult[e]=!1,Object.keys(this.contentToResult).length>b&&(this.contentToResult={})}catch(o){throw this.contentToResult[e]=o,o}},e.prototype.handleReferenceElement=function(e){var t=new c(h).parseFromString(e);this.namspacePrefix=s(t);var n=o(t,"schema",this.namspacePrefix)[0],r=o(n,"element",this.namspacePrefix),i=u.find(r,function(e){return"true"===e.getAttribute("extraelement")});if(!i)return e;var a={};return a.name=i.getAttribute("name"),a.type=i.getAttribute("type"),a.originalName=i.getAttribute("originalname"),a.requestedName=i.getAttribute("requestedname"),a.type||n.removeChild(i),i.removeAttribute("originalname"),i.removeAttribute("requestedname"),i.removeAttribute("extraelement"),this.extraElementData=a,t.toString()},e.prototype.acceptErrors=function(e,t,n){if(void 0===n&&(n=!1),t&&t.length>0){var r=t.map(function(e){return e.message}).join(", "),i=new f.ValidationError(d.messageRegistry.CONTENT_DOES_NOT_MATCH_THE_SCHEMA,{msg:r});if(i.errors=t,A.setValue(e,i),n)throw i}else;},e}();t.XMLSchemaObject=N,t.getJSONSchema=r;var _=function(e,t){var n="";e&&(n=e.contextPath());var r="__SCHEMA_"+t+n;return r};t.getXMLSchema=i,t.createSchema=a}).call(t,function(){return this}())},function(e,t,n){function r(e){if(k&&w){var t,n=k(e);for(t=0;t<n.length;t+=1)w(e,n[t],{value:e[n[t]],writable:!1,enumerable:!1,configurable:!1})}}function i(e){function t(t){w(e,t,{get:function(){return e._getter(t)},set:function(n){e._setter(t,n)},enumerable:!0,configurable:!1})}if(w){if(e.length>I)throw new RangeError("Array too large for polyfill");var n;for(n=0;n<e.length;n+=1)t(n)}}function a(e,t){var n=32-t;return e<<n>>n}function o(e,t){var n=32-t;return e<<n>>>n}function s(e){return[255&e]}function u(e){return a(e[0],8)}function l(e){return[255&e]}function p(e){return o(e[0],8)}function c(e){return e=U(Number(e)),[0>e?0:e>255?255:255&e]}function f(e){return[e>>8&255,255&e]}function d(e){return a(e[0]<<8|e[1],16)}function m(e){return[e>>8&255,255&e]}function h(e){return o(e[0]<<8|e[1],16)}function y(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}function v(e){return a(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)}function g(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}function A(e){return o(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)}function S(e,t,n){function r(e){var t=P(e),n=e-t;return.5>n?t:n>.5?t+1:t%2?t+1:t}var i,a,o,s,u,l,p,c=(1<<t-1)-1;for(e!==e?(a=(1<<t)-1,o=x(2,n-1),i=0):e===1/0||e===-(1/0)?(a=(1<<t)-1,o=0,i=0>e?1:0):0===e?(a=0,o=0,i=1/e===-(1/0)?1:0):(i=0>e,e=L(e),e>=x(2,1-c)?(a=D(P(O(e)/C),1023),o=r(e/x(2,a)*x(2,n)),o/x(2,n)>=2&&(a+=1,o=1),a>c?(a=(1<<t)-1,o=0):(a+=c,o-=x(2,n))):(a=0,o=r(e/x(2,1-c-n)))),u=[],s=n;s;s-=1)u.push(o%2?1:0),o=P(o/2);for(s=t;s;s-=1)u.push(a%2?1:0),a=P(a/2);for(u.push(i?1:0),u.reverse(),l=u.join(""),p=[];l.length;)p.push(parseInt(l.substring(0,8),2)),l=l.substring(8);return p}function E(e,t,n){var r,i,a,o,s,u,l,p,c=[];for(r=e.length;r;r-=1)for(a=e[r-1],i=8;i;i-=1)c.push(a%2?1:0),a>>=1;return c.reverse(),o=c.join(""),s=(1<<t-1)-1,u=parseInt(o.substring(0,1),2)?-1:1,l=parseInt(o.substring(1,1+t),2),p=parseInt(o.substring(1+t),2),l===(1<<t)-1?0!==p?NaN:u*(1/0):l>0?u*x(2,l-s)*(1+p/x(2,n)):0!==p?u*x(2,-(s-1))*(p/x(2,n)):0>u?-0:0}function T(e){return E(e,11,52)}function b(e){return S(e,11,52)}function N(e){return E(e,8,23)}function _(e){return S(e,8,23)}var w,M=void 0,I=1e5,R=function(){var e=Object.prototype.toString,t=Object.prototype.hasOwnProperty;return{Class:function(t){return e.call(t).replace(/^\[object *|\]$/g,"")},HasProperty:function(e,t){return t in e},HasOwnProperty:function(e,n){return t.call(e,n)},IsCallable:function(e){return"function"==typeof e},ToInt32:function(e){return e>>0},ToUint32:function(e){return e>>>0}}}(),C=Math.LN2,L=Math.abs,P=Math.floor,O=Math.log,D=Math.min,x=Math.pow,U=Math.round;w=Object.defineProperty&&function(){try{return Object.defineProperty({},"x",{}),!0}catch(e){return!1}}()?Object.defineProperty:function(e,t,n){if(!e===Object(e))throw new TypeError("Object.defineProperty called on non-object");return R.HasProperty(n,"get")&&Object.prototype.__defineGetter__&&Object.prototype.__defineGetter__.call(e,t,n.get),R.HasProperty(n,"set")&&Object.prototype.__defineSetter__&&Object.prototype.__defineSetter__.call(e,t,n.set),R.HasProperty(n,"value")&&(e[t]=n.value),e};var k=Object.getOwnPropertyNames||function(e){if(e!==Object(e))throw new TypeError("Object.getOwnPropertyNames called on non-object");var t,n=[];for(t in e)R.HasOwnProperty(e,t)&&n.push(t);return n};!function(){function e(e,t,o){var s;return s=function(e,t,a){var o,u,l,p;if(arguments.length&&"number"!=typeof arguments[0])if("object"==typeof arguments[0]&&arguments[0].constructor===s)for(o=arguments[0],this.length=o.length,this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new n(this.byteLength),this.byteOffset=0,l=0;l<this.length;l+=1)this._setter(l,o._getter(l));else if("object"!=typeof arguments[0]||(arguments[0]instanceof n||"ArrayBuffer"===R.Class(arguments[0]))){if("object"!=typeof arguments[0]||!(arguments[0]instanceof n||"ArrayBuffer"===R.Class(arguments[0])))throw new TypeError("Unexpected argument type(s)");if(this.buffer=e,this.byteOffset=R.ToUint32(t),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");if(arguments.length<3){if(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT)throw new RangeError("length of buffer minus byteOffset not a multiple of the element size");this.length=this.byteLength/this.BYTES_PER_ELEMENT}else this.length=R.ToUint32(a),this.byteLength=this.length*this.BYTES_PER_ELEMENT;if(this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer")}else for(u=arguments[0],this.length=R.ToUint32(u.length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new n(this.byteLength),this.byteOffset=0,l=0;l<this.length;l+=1)p=u[l],this._setter(l,Number(p));else{if(this.length=R.ToInt32(arguments[0]),0>a)throw new RangeError("ArrayBufferView size is not a small enough positive integer");this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new n(this.byteLength),this.byteOffset=0}this.constructor=s,r(this),i(this)},s.prototype=new a,s.prototype.BYTES_PER_ELEMENT=e,s.prototype._pack=t,s.prototype._unpack=o,s.BYTES_PER_ELEMENT=e,s.prototype._getter=function(e){if(arguments.length<1)throw new SyntaxError("Not enough arguments");if(e=R.ToUint32(e),e>=this.length)return M;var t,n,r=[];for(t=0,n=this.byteOffset+e*this.BYTES_PER_ELEMENT;t<this.BYTES_PER_ELEMENT;t+=1,n+=1)r.push(this.buffer._bytes[n]);return this._unpack(r)},s.prototype.get=s.prototype._getter,s.prototype._setter=function(e,t){if(arguments.length<2)throw new SyntaxError("Not enough arguments");if(e=R.ToUint32(e),e>=this.length)return M;var n,r,i=this._pack(t);for(n=0,r=this.byteOffset+e*this.BYTES_PER_ELEMENT;n<this.BYTES_PER_ELEMENT;n+=1,r+=1)this.buffer._bytes[r]=i[n]},s.prototype.set=function(e,t){if(arguments.length<1)throw new SyntaxError("Not enough arguments");var n,r,i,a,o,s,u,l,p,c;if("object"==typeof arguments[0]&&arguments[0].constructor===this.constructor){if(n=arguments[0],i=R.ToUint32(arguments[1]),i+n.length>this.length)throw new RangeError("Offset plus length of array is out of range");if(l=this.byteOffset+i*this.BYTES_PER_ELEMENT,p=n.length*this.BYTES_PER_ELEMENT,n.buffer===this.buffer){for(c=[],o=0,s=n.byteOffset;p>o;o+=1,s+=1)c[o]=n.buffer._bytes[s];for(o=0,u=l;p>o;o+=1,u+=1)this.buffer._bytes[u]=c[o]}else for(o=0,s=n.byteOffset,u=l;p>o;o+=1,s+=1,u+=1)this.buffer._bytes[u]=n.buffer._bytes[s]}else{if("object"!=typeof arguments[0]||"undefined"==typeof arguments[0].length)throw new TypeError("Unexpected argument type(s)");if(r=arguments[0],a=R.ToUint32(r.length),i=R.ToUint32(arguments[1]),i+a>this.length)throw new RangeError("Offset plus length of array is out of range");for(o=0;a>o;o+=1)s=r[o],this._setter(i+o,Number(s))}},s.prototype.subarray=function(e,t){function n(e,t,n){return t>e?t:e>n?n:e}e=R.ToInt32(e),t=R.ToInt32(t),arguments.length<1&&(e=0),arguments.length<2&&(t=this.length),0>e&&(e=this.length+e),0>t&&(t=this.length+t),e=n(e,0,this.length),t=n(t,0,this.length);var r=t-e;return 0>r&&(r=0),new this.constructor(this.buffer,this.byteOffset+e*this.BYTES_PER_ELEMENT,r)},s}var n=function(e){if(e=R.ToInt32(e),0>e)throw new RangeError("ArrayBuffer size is not a small enough positive integer");this.byteLength=e,this._bytes=[],this._bytes.length=e;var t;for(t=0;t<this.byteLength;t+=1)this._bytes[t]=0;r(this)};t.ArrayBuffer=t.ArrayBuffer||n;var a=function(){},o=e(1,s,u),S=e(1,l,p),E=e(1,c,p),w=e(2,f,d),I=e(2,m,h),C=e(4,y,v),L=e(4,g,A),P=e(4,_,N),O=e(8,b,T);t.Int8Array=t.Int8Array||o,t.Uint8Array=t.Uint8Array||S,t.Uint8ClampedArray=t.Uint8ClampedArray||E,t.Int16Array=t.Int16Array||w,t.Uint16Array=t.Uint16Array||I,t.Int32Array=t.Int32Array||C,t.Uint32Array=t.Uint32Array||L,t.Float32Array=t.Float32Array||P,t.Float64Array=t.Float64Array||O}(),function(){function e(e,t){return R.IsCallable(e.get)?e.get(t):e[t]}function n(n){return function(r,i){if(r=R.ToUint32(r),r+n.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");r+=this.byteOffset;var o,s=new t.Uint8Array(this.buffer,r,n.BYTES_PER_ELEMENT),u=[];for(o=0;o<n.BYTES_PER_ELEMENT;o+=1)u.push(e(s,o));return Boolean(i)===Boolean(a)&&u.reverse(),e(new n(new t.Uint8Array(u).buffer),0)}}function i(n){return function(r,i,o){if(r=R.ToUint32(r),r+n.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");var s,u,l=new n([i]),p=new t.Uint8Array(l.buffer),c=[];for(s=0;s<n.BYTES_PER_ELEMENT;s+=1)c.push(e(p,s));Boolean(o)===Boolean(a)&&c.reverse(),u=new t.Uint8Array(this.buffer,r,n.BYTES_PER_ELEMENT),u.set(c)}}var a=function(){var n=new t.Uint16Array([4660]),r=new t.Uint8Array(n.buffer);return 18===e(r,0)}(),o=function(e,n,i){if(0===arguments.length)e=new t.ArrayBuffer(0);else if(!(e instanceof t.ArrayBuffer||"ArrayBuffer"===R.Class(e)))throw new TypeError("TypeError");if(this.buffer=e||new t.ArrayBuffer(0),this.byteOffset=R.ToUint32(n),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(arguments.length<3?this.byteLength=this.buffer.byteLength-this.byteOffset:this.byteLength=R.ToUint32(i),this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer");r(this)};o.prototype.getUint8=n(t.Uint8Array),o.prototype.getInt8=n(t.Int8Array),o.prototype.getUint16=n(t.Uint16Array),o.prototype.getInt16=n(t.Int16Array),o.prototype.getUint32=n(t.Uint32Array),o.prototype.getInt32=n(t.Int32Array),o.prototype.getFloat32=n(t.Float32Array),o.prototype.getFloat64=n(t.Float64Array),o.prototype.setUint8=i(t.Uint8Array),o.prototype.setInt8=i(t.Int8Array),o.prototype.setUint16=i(t.Uint16Array),o.prototype.setInt16=i(t.Int16Array),o.prototype.setUint32=i(t.Uint32Array),o.prototype.setInt32=i(t.Int32Array),o.prototype.setFloat32=i(t.Float32Array),o.prototype.setFloat64=i(t.Float64Array),t.DataView=t.DataView||o}()},function(e,t,n){t.parse=n(150),t.stringify=n(151)},function(e,t,n){"use strict";function r(e,t){var n=t?t.endPosition:e.endPosition+1,r={key:e,value:t,startPosition:e.startPosition,endPosition:n,kind:l.MAPPING,parent:null,errors:[]};return r}function i(e,t,n,r){return{errors:[],referencesAnchor:e,value:r,startPosition:t,endPosition:n,kind:l.ANCHOR_REF,parent:null}}function a(e){return void 0===e&&(e=""),{errors:[],startPosition:-1,endPosition:-1,value:e,kind:l.SCALAR,parent:null,doubleQuoted:!1,rawValue:e}}function o(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:l.SEQ,parent:null}}function s(){return o()}function u(e){return{errors:[],startPosition:-1,endPosition:-1,mappings:e?e:[],kind:l.MAP,parent:null}}!function(e){e[e.SCALAR=0]="SCALAR",e[e.MAPPING=1]="MAPPING",e[e.MAP=2]="MAP",e[e.SEQ=3]="SEQ",e[e.ANCHOR_REF=4]="ANCHOR_REF",e[e.INCLUDE_REF=5]="INCLUDE_REF"}(t.Kind||(t.Kind={}));var l=t.Kind;t.newMapping=r,t.newAnchorRef=i,t.newScalar=a,t.newItems=o,t.newSeq=s,t.newMap=u},function(e,t,n){"use strict";function r(e){return"undefined"==typeof e||null===e}function i(e){return"object"==typeof e&&null!==e}function a(e){return Array.isArray(e)?e:r(e)?[]:[e]}function o(e,t){var n,r,i,a;if(t)for(a=Object.keys(t),n=0,r=a.length;r>n;n+=1)i=a[n],e[i]=t[i];return e}function s(e,t){var n,r="";for(n=0;t>n;n+=1)r+=e;return r}function u(e){return 0===e&&Number.NEGATIVE_INFINITY===1/e}t.isNothing=r,t.isObject=i,t.toArray=a,t.extend=o,t.repeat=s,t.isNegativeZero=u},function(e,t,n){"use strict";var r=function(){function e(e,t){void 0===t&&(t=null),this.name="YAMLException",this.reason=e,this.mark=t,this.message=this.toString(!1)}return e.prototype.toString=function(e){
void 0===e&&(e=!1);var t;return t="JS-YAML: "+(this.reason||"(unknown reason)"),!e&&this.mark&&(t+=" "+this.mark.toString()),t},e}();e.exports=r},function(e,t,n){"use strict";var r=n(114),i=function(){function e(e,t,n,r,i){this.name=e,this.buffer=t,this.position=n,this.line=r,this.column=i}return e.prototype.getSnippet=function(e,t){void 0===e&&(e=0),void 0===t&&(t=75);var n,i,a,o,s;if(!this.buffer)return null;for(e=e||4,t=t||75,n="",i=this.position;i>0&&-1==="\x00\r\n\u2028\u2029".indexOf(this.buffer.charAt(i-1));)if(i-=1,this.position-i>t/2-1){n=" ... ",i+=5;break}for(a="",o=this.position;o<this.buffer.length&&-1==="\x00\r\n\u2028\u2029".indexOf(this.buffer.charAt(o));)if(o+=1,o-this.position>t/2-1){a=" ... ",o-=5;break}return s=this.buffer.slice(i,o),r.repeat(" ",e)+n+s+a+"\n"+r.repeat(" ",e+this.position-i+n.length)+"^"},e.prototype.toString=function(e){void 0===e&&(e=!0);var t,n="";return this.name&&(n+='in "'+this.name+'" '),n+="at line "+(this.line+1)+", column "+(this.column+1),e||(t=this.getSnippet(),t&&(n+=":\n"+t)),n},e}();e.exports=i},function(e,t,n){var r=function(){try{return n(181)}catch(e){}}();t=e.exports=n(155),t.Stream=r||t,t.Readable=t,t.Writable=n(156),t.Duplex=n(157),t.Transform=n(158),t.PassThrough=n(159)},function(e,t,n){"use strict";e.exports=n(160)},function(e,t,n){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e}},function(module,exports,__webpack_require__){function Context(){}var indexOf=__webpack_require__(192),Object_keys=function(e){if(Object.keys)return Object.keys(e);var t=[];for(var n in e)t.push(n);return t},forEach=function(e,t){if(e.forEach)return e.forEach(t);for(var n=0;n<e.length;n++)t(e[n],n,e)},defineProp=function(){try{return Object.defineProperty({},"_",{}),function(e,t,n){Object.defineProperty(e,t,{writable:!0,enumerable:!1,configurable:!0,value:n})}}catch(e){return function(e,t,n){e[t]=n}}}(),globals=["Array","Boolean","Date","Error","EvalError","Function","Infinity","JSON","Math","NaN","Number","Object","RangeError","ReferenceError","RegExp","String","SyntaxError","TypeError","URIError","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","eval","isFinite","isNaN","parseFloat","parseInt","undefined","unescape"];Context.prototype={};var Script=exports.Script=function(e){return this instanceof Script?void(this.code=e):new Script(e)};Script.prototype.runInContext=function(e){if(!(e instanceof Context))throw new TypeError("needs a 'context' argument.");var t=document.createElement("iframe");t.style||(t.style={}),t.style.display="none",document.body.appendChild(t);var n=t.contentWindow,r=n.eval,i=n.execScript;!r&&i&&(i.call(n,"null"),r=n.eval),forEach(Object_keys(e),function(t){n[t]=e[t]}),forEach(globals,function(t){e[t]&&(n[t]=e[t])});var a=Object_keys(n),o=r.call(n,this.code);return forEach(Object_keys(n),function(t){(t in e||-1===indexOf(a,t))&&(e[t]=n[t])}),forEach(globals,function(t){t in e||defineProp(e,t,n[t])}),document.body.removeChild(t),o},Script.prototype.runInThisContext=function(){return eval(this.code)},Script.prototype.runInNewContext=function(e){var t=Script.createContext(e),n=this.runInContext(t);return forEach(Object_keys(t),function(n){e[n]=t[n]}),n},forEach(Object_keys(Script.prototype),function(e){exports[e]=Script[e]=function(t){var n=Script(t);return n[e].apply(n,[].slice.call(arguments,1))}}),exports.createScript=function(e){return exports.Script(e)},exports.createContext=Script.createContext=function(e){var t=new Context;return"object"==typeof e&&forEach(Object_keys(e),function(n){t[n]=e[n]}),t}},function(e,t,n){"use strict";var r=n(153),i=new r({include:[n(154)],implicit:[n(164),n(165)],explicit:[n(166),n(167),n(168),n(169)]});e.exports=i},function(e,t,n){"use strict";var r=n(153),i=new r({include:[n(121)],explicit:[n(170),n(171)]});r.DEFAULT=i,e.exports=i},function(e,t,n){var r=n(134);e.exports=function(e,t){return r(e,t,".")}},function(e,t,n){var r=n(126),i=n(127);e.exports=function(e,t){if(null==e)return"";for(var n="",a=0;a<e.length;a++){var o=e[a],s=r(o,t);n+=s===o?i(o,t):s}return n}},function(e,t,n){var r=n(134);e.exports=function(e,t){return r(e,t,"/")}},function(e,t,n){var r={tr:{regexp:/[\u0069]/g,map:{i:"İ"}},az:{regexp:/[\u0069]/g,map:{i:"İ"}},lt:{regexp:/[\u0069\u006A\u012F]\u0307|\u0069\u0307[\u0300\u0301\u0303]/g,map:{"i̇":"I","j̇":"J","į̇":"Į","i̇̀":"Ì","i̇́":"Í","i̇̃":"Ĩ"}}};e.exports=function(e,t){var n=r[t];return e=null==e?"":String(e),n&&(e=e.replace(n.regexp,function(e){return n.map[e]})),e.toUpperCase()}},function(e,t,n){var r={tr:{regexp:/\u0130|\u0049|\u0049\u0307/g,map:{"İ":"i",I:"ı","İ":"i"}},az:{regexp:/[\u0130]/g,map:{"İ":"i",I:"ı","İ":"i"}},lt:{regexp:/[\u0049\u004A\u012E\u00CC\u00CD\u0128]/g,map:{I:"i̇",J:"j̇","Į":"į̇","Ì":"i̇̀","Í":"i̇́","Ĩ":"i̇̃"}}};e.exports=function(e,t){var n=r[t];return e=null==e?"":String(e),n&&(e=e.replace(n.regexp,function(e){return n.map[e]})),e.toLowerCase()}},function(e,t,n){var r=n(126),i=n(134);e.exports=function(e,t,n){var a=i(e,t);return n||(a=a.replace(/(\d) (?=\d)/g,"$1_")),a.replace(/ (.)/g,function(e,n){return r(n,t)})}},function(e,t,n){var r=n(134);e.exports=function(e,t){return r(e,t,"-")}},function(e,t,n){var r=n(134);e.exports=function(e,t){return r(e,t,"_")}},function(e,t,n){var r=n(128),i=n(136);e.exports=function(e,t){return i(r(e,t),t)}},function(e,t,n){var r=n(126),i=n(134);e.exports=function(e,t){return i(e,t).replace(/^.| ./g,function(e){return r(e,t)})}},function(e,t,n){var r=n(126),i=n(130);e.exports=function(e,t){return r(i(e,t),t)}},function(e,t,n){var r=n(127),i=n(173),a=n(174),o=n(175);e.exports=function(e,t,n){function s(e,t,r){return 0===t||t===r.length-e.length?"":n}return null==e?"":(n=n||" ",e=String(e).replace(a,"$1 $2").replace(o,"$1 $2").replace(i,s),r(e,t))}},function(e,t,n){var r=n(126);e.exports=function(e,t){return r(e,t)===e}},function(e,t,n){var r=n(126);e.exports=function(e,t){return null==e?"":(e=String(e),r(e.charAt(0),t)+e.substr(1))}},function(e,t,n){var r=n(127);e.exports=function(e,t){return null==e?"":(e=String(e),r(e.charAt(0),t)+e.substr(1))}},function(e,t,n){var r=n(127);e.exports=function(e,t){return r(e,t)===e}},function(e,t,n){"use strict";function r(e,t){if(e.typeKind==a.TypeKind.ARRAY)return t?[]:[r(e.base)[0]+"[]"];if(e.typeKind==a.TypeKind.BASIC){var n=e,i=n.basicName,o=n.nameSpace&&n.nameSpace.trim();return null!=o&&o.length>0&&"RamlWrapper"!=o&&(i=o+"."+i),n.typeArguments&&0!=n.typeArguments.length&&(i+="<"+n.typeArguments.map(function(e){return r(e)}).join(", ")+">"),t?n.nameSpace&&t[n.nameSpace]?[i]:[]:[i]}if(e.typeKind==a.TypeKind.UNION){var s=e,u=[];return s.options.forEach(function(e){return u=u.concat(r(e,t))}),u}return[]}function i(e){return o.getHelperMethods(e)}var a=n(96),o=n(161),s={RamlWrapper:!0},u=function(){function e(e,t,n,r,i){this.originalName=e,this.wrapperMethodName=t,this.returnType=n,this.args=r,this.meta=i}return e.prototype.targetWrappers=function(){var e=!0,t=[];return this.args.forEach(function(n){var i=r(n.type,s);if(0!=i.length)return e&&0==t.length?void(t=t.concat(i)):(t=[],void(e=!1))}),t},e.prototype.callArgs=function(){return this.args.map(function(e){return 0==r(e.type,s).length?e:{name:"this",type:null,optional:!1,defaultValue:void 0}})},e}();t.HelperMethod=u,t.flatten=r,t.getHelperMethods=i},function(e,t,n){"use strict";function r(e){return A.createSourceFile("sample.ts",e,A.ScriptTarget.ES3,!0)}function i(e,n,s){var u=r(e),l={classes:[],aliases:[],enumDeclarations:[],imports:{},name:s};n[s]=l;var p=null;return t.tsm.Matching.visit(u,function(r){if(r.kind==A.SyntaxKind.ModuleDeclaration){var u=r;p=u.name.text}if(r.kind==A.SyntaxKind.ImportEqualsDeclaration){var c=r,f=c.name.text;if("RamlWrapper"==f)return;var d=c.moduleReference,m=d.expression,h=m.text,v=S.resolve(S.dirname(s)+"/",h)+".ts";if(!S.existsSync(v))throw new Error("Path "+h+" resolve to "+v+"do not exists");if(!n[v]){var g=S.readFileSync(v);i(g,n,v)}l.imports[f]=n[v]}if(r.kind==A.SyntaxKind.TypeAliasDeclaration){var E=r;if(E.name){var N=E.name.text,_=y(E.type,s);l.aliases.push({name:N,type:_})}}if(r.kind==A.SyntaxKind.EnumDeclaration){var w=r,M=[];w.members&&w.members.forEach(function(e){M.push(e.name.text)}),w.name&&l.enumDeclarations.push({name:w.name.text,members:M})}var I=r.kind==A.SyntaxKind.InterfaceDeclaration,R=r.kind==A.SyntaxKind.ClassDeclaration;if(I||R){var C=r;if(C){var L={},P=T.classDecl(C.name.text,I);return P.moduleName=p,l.classes.push(P),C.members.forEach(function(t){if(t.kind==A.SyntaxKind.MethodDeclaration){var n=t,r=o(n,e,s);P.methods.push(r)}var i=b.doMatch(t);if(i){var u=a(i,s);if("$"==u.name)P.annotations=u.annotations;else if("$"!=u.name.charAt(0)||"$ref"==u.name)L[u.name]=u,P.fields.push(u);else{var l=u.name.substr(1),p=L[l];if(p)p.annotations=u.annotations;else if("$$"!=u.name){var c=P.annotationOverridings[l];c||(c=[]),P.annotationOverridings[l]=c.concat(u.annotations)}}}}),C.typeParameters&&C.typeParameters.forEach(function(e){P.typeParameters.push(e.name.text),null==e.constraint?P.typeParameterConstraint.push(null):P.typeParameterConstraint.push(e.constraint.typeName.text)}),C.heritageClauses&&C.heritageClauses.forEach(function(e){e.types.forEach(function(t){if(e.token==A.SyntaxKind.ExtendsKeyword)P["extends"].push(y(t,s));else{if(e.token!=A.SyntaxKind.ImplementsKeyword)throw new Error("Unknown token class heritage");P["implements"].push(y(t,s))}})}),t.tsm.Matching.SKIP}}}),l}function a(e,t){return{name:e.name.text,type:y(e.type,t),annotations:"$"==e.name.text.charAt(0)?l(e.initializer):[],valueConstraint:"$"!=e.name.text.charAt(0)?u(e.initializer):null,optional:null!=e.questionToken}}function o(e,t,n){var r=e.name.text,i=t.substring(e.pos,e.end),a=[];e.parameters.forEach(function(e){a.push(s(e,t,n))});var o={returnType:y(e.type,n),name:r,start:e.pos,end:e.end,text:i,arguments:a};return o}function s(e,t,n){var r=t.substring(e.pos,e.end);return{name:e.name.text,start:e.pos,end:e.end,text:r,type:y(e.type,n)}}function u(e){return null==e?null:e.kind==A.SyntaxKind.CallExpression?{isCallConstraint:!0,value:p(e)}:{isCallConstraint:!1,value:c(e)}}function l(e){if(null==e)return[];if(e.kind==A.SyntaxKind.ArrayLiteralExpression){var t=e,n=[];return t.elements.forEach(function(e){n.push(p(e))}),n}throw new Error("Only Array Literals supported now")}function p(e){if(e.kind==A.SyntaxKind.CallExpression){var t=e,n=f(t.expression),r={name:n,arguments:[]};return t.arguments.forEach(function(e){r.arguments.push(c(e))}),r}throw new Error("Only call expressions may be annotations")}function c(e){if(e.kind==A.SyntaxKind.StringLiteral){var t=e;return t.text}if(e.kind==A.SyntaxKind.NoSubstitutionTemplateLiteral){var n=e;return n.text}if(e.kind==A.SyntaxKind.ArrayLiteralExpression){var r=e,i=[];return r.elements.forEach(function(e){i.push(c(e))}),i}if(e.kind==A.SyntaxKind.TrueKeyword)return!0;if(e.kind==A.SyntaxKind.PropertyAccessExpression){var a=e;return c(a.expression)+"."+c(a.name)}if(e.kind==A.SyntaxKind.Identifier){var o=e;return o.text}if(e.kind==A.SyntaxKind.FalseKeyword)return!1;if(e.kind==A.SyntaxKind.NumericLiteral){var s=e;return Number(s.text)}if(e.kind==A.SyntaxKind.BinaryExpression){var u=e;if(u.operatorToken.kind=A.SyntaxKind.PlusToken)return c(u.left)+c(u.right)}throw new Error("Unknown value in annotation")}function f(e){if(e.kind==A.SyntaxKind.Identifier)return e.text;if(e.kind==A.SyntaxKind.PropertyAccessExpression){var t=e;return f(t.expression)+"."+f(t.name)}throw new Error("Only simple identifiers are supported now")}function d(e,t){var n=e.indexOf("."),r=-1!=n?e.substring(0,n):"",i=-1!=n?e.substring(n+1):e;return{typeName:e,nameSpace:r,basicName:i,typeKind:E.TypeKind.BASIC,typeArguments:[],modulePath:t}}function m(e){return{base:e,typeKind:E.TypeKind.ARRAY}}function h(e){return{options:e,typeKind:E.TypeKind.UNION}}function y(e,t){if(null==e)return null;if(e.kind==A.SyntaxKind.StringKeyword)return d("string",null);if(e.kind==A.SyntaxKind.NumberKeyword)return d("number",null);if(e.kind==A.SyntaxKind.BooleanKeyword)return d("boolean",null);if(e.kind==A.SyntaxKind.AnyKeyword)return d("any",null);if(e.kind==A.SyntaxKind.VoidKeyword)return d("void",null);if(e.kind==A.SyntaxKind.TypeReference){var n=e,r=d(g(n.typeName),t);return n.typeArguments&&n.typeArguments.forEach(function(e){r.typeArguments.push(y(e,t))}),r}if(e.kind==A.SyntaxKind.ArrayType){var i=e;return m(y(i.elementType,t))}if(e.kind==A.SyntaxKind.UnionType){var a=e;return h(a.types.map(function(e){return y(e,t)}))}if(e.kind==A.SyntaxKind.ExpressionWithTypeArguments){var o=e,r=d(v(o.expression),t);return o.typeArguments&&o.typeArguments.forEach(function(e){r.typeArguments.push(y(e,t))}),r}throw new Error("Case not supported: "+e.kind)}function v(e){return e.name?e.name.text:e.text}function g(e){if(e.kind==A.SyntaxKind.Identifier)return e.text;var t=e;return g(t.left)+"."+g(t.right)}var A=n(152);t.tsm=n(162),t.helperMethodExtractor=n(161);var S=n(163),E=n(96),T=n(96),b=t.tsm.Matching.field();t.parseStruct=i,t.parseArg=c,t.buildType=y},function(e,t,n){var r;r=function(){"use strict";var e=n(188),t={},r={},i=n(189),a=n(190),o=n(191);return e.forEach(function(e){var n,i=parseInt(e.code,10);i.toString()===e.code&&(n=e.phrase.toUpperCase().replace(/[^A-Z]/g,"_"),t[i]=e.phrase,r[n]=e.code)}),{statusCodes:e,statusCodesToPhrases:t,statusPhrasesToCodes:r,methods:i,headers:a,relations:o}}.call(t,n,t,e),!(void 0!==r&&(e.exports=r))},function(e,t,n){"use strict";function r(e){var t=e.oneMeta(l.Example);if(t)return t.example();if(e.getExtra(f))return null;e.putExtra(f,!0);try{var n=e.oneMeta(l.Examples);if(n){var i=n.examples();if(i&&i.length>0)return i[0]}var a=e.oneMeta(l.Default);if(a)return a.value();if(e.isObject()){var o={};return e.meta().forEach(function(e){if(e instanceof c.PropertyIs){var t=e,n=r(t.value());o[t.propertyName()]=n}}),e.superTypes().forEach(function(e){if(e.oneMeta(l.Example)||e.oneMeta(l.Examples)){var t=r(e);t&&"object"==typeof t&&Object.keys(t).forEach(function(e){o[e]=t[e]})}}),o}if(e.isArray()){var s=e.oneMeta(p.ComponentShouldBeOfType),u=[];return s&&u.push(r(s.value())),u}return e.isUnion()?r(e.typeFamily()[0]):e.isNumber()?1:e.isBoolean()?!0:"some value"}finally{e.putExtra(f,!1)}}function i(e,t){var n=e[t];return null!=n&&"object"==typeof n?n.value:n}function a(e){var t=[];if(!e||"object"!=typeof e)return t;for(var n=0,r=Object.keys(e).filter(function(e){return e.length>0&&"("==e.charAt(0)&&")"==e.charAt(e.length-1)});n<r.length;n++){var i=r[n],a=i.substring(1,i.length-1),o=e[i],s=new l.Annotation(a,o);t.push(s)}return t}function o(e){var t=[],n=e.oneMeta(l.Examples);if(n){var r=n.value();if(r&&"object"==typeof r){var i;Object.keys(r).forEach(function(a){var o=Array.isArray(r)?null:a,s=r[a],u=m({asXMLString:function(){return i||(i=n.asXMLStrings()),i[a]},ownerType:function(){return e}},s,o);t.push(u)})}}var a=e.oneMeta(l.Example);if(a){var o=a.example();null!=o&&t.push(m(a,a.value(),void 0,!0))}return t}function s(e,t){var n=e.getAdapter(u.InheritedType);if(n){var r=o(n);if(r&&r.length>0)return r;if(t&&e.isUserDefined()&&!e.isGenuineUserDefinedType()&&e.genuineUserDefinedTypeInHierarchy()){var i=e.genuineUserDefinedTypeInHierarchy(),a=i.getAdapter(u.InheritedType);if(a){var s=o(a);if(s&&s.length>0)return s}}}if(n){var l=new d(null,void 0,void 0,void 0,!1,void 0,void 0,!0);return l.setOwnerType(n),[l]}return[]}var u=n(100),l=n(105),p=n(104),c=n(104),f="exampleCalculation";t.example=r;var d=function(){function e(e,t,n,r,i,a,o,s){void 0===t&&(t=void 0),void 0===n&&(n=void 0),void 0===r&&(r=void 0),void 0===i&&(i=!0),void 0===o&&(o=!1),void 0===s&&(s=!1),this._value=e,this._name=t,this._displayName=n,this._description=r,this._strict=i,this._annotations=a,this._isSingle=o,this._empty=s,this.isExpanded=!1,this._scalarsAnnotations={},this._annotations?this._hasAnnotations=!0:this._annotations={}}return e.prototype.isEmpty=function(){return this._empty},e.prototype.isJSONString=function(){var e=this.firstCharacter();return"{"==e||"["==e},e.prototype.isXMLString=function(){var e=this.firstCharacter();return"<"==e},e.prototype.firstCharacter=function(){if(null==this._value)return null;if("string"!=typeof this._value)return null;var e=this._value.trim();return 0==e.length?null:e.charAt(0)},e.prototype.asXMLString=function(){return this.isXMLString()?this._value:this._owner?this._owner.asXMLString():null},e.prototype.isYAML=function(){return"string"==typeof this._value?!(this.isJSONString()||this.isXMLString()):!0},e.prototype.asString=function(){return"string"==typeof this._value?""+this._value:JSON.stringify(this._value,null,2)},e.prototype.asJSON=function(){if(this.isJSONString())try{return JSON.parse(this._value)}catch(e){return null}return this.isYAML()?this._value:this.asString()},e.prototype.original=function(){return this._value},e.prototype.expandAsString=function(){return JSON.stringify(this.expandAsJSON(),null,2)},e.prototype.expandAsJSON=function(){return this.isEmpty()?this.isExpanded?this._expandedValue:(this._expandedValue=r(this._ownerType),this.isExpanded=!0,this._expandedValue):this._value},e.prototype.isSingle=function(){return this._isSingle},e.prototype.strict=function(){return this._strict},e.prototype.description=function(){return this._description},e.prototype.displayName=function(){return this._displayName},e.prototype.annotations=function(){return this._annotations},e.prototype.name=function(){return this._name},e.prototype.scalarsAnnotations=function(){return this._scalarsAnnotations},e.prototype.registerScalarAnnotatoion=function(e,t){this._hasScalarAnnotations=!0;var n=this._scalarsAnnotations[t];n||(n={},this._scalarsAnnotations[t]=n),n[e.facetName()]=e},e.prototype.setOwner=function(e){this._owner=e},e.prototype.owner=function(){return this._owner},e.prototype.setOwnerType=function(e){this._ownerType=e},e.prototype.ownerType=function(){return this._ownerType},e.prototype.hasAnnotations=function(){return this._hasAnnotations},e.prototype.hasScalarAnnotations=function(){return this._hasScalarAnnotations},e}(),m=function(e,t,n,r){void 0===n&&(n=null),void 0===r&&(r=!1);var o;if(null!=t){var s=t.value;if(s){var u=i(t,"displayName"),l=i(t,"description"),p=i(t,"strict"),c={};a(t).forEach(function(e){c[e.facetName()]=e}),o=new d(s,n,u,l,p,c,r);for(var f=0,m=a(t.displayName);f<m.length;f++){var h=m[f];o.registerScalarAnnotatoion(h,"displayName")}for(var y=0,v=a(t.description);y<v.length;y++){var h=v[y];o.registerScalarAnnotatoion(h,"description")}for(var g=0,A=a(t.strict);g<A.length;g++){var h=A[g];o.registerScalarAnnotatoion(h,"strict")}}else s=t,o=new d(s,n,void 0,void 0,!0,void 0,r)}return o&&o.setOwner(e),o};t.exampleFromNominal=s},function(e,t,n){"use strict";function r(e){return a(e,"YYYY-MM-DD")}function i(e){var t="11 "+e.trim(),n="YY HH:mm:ss";if(!s.isValid(t,n))return!1;var r=s.parse(t,n,!1),i=s.format(r,n,!1);return i.trim()==t.trim()}function a(e,t){var n=/^(\d{4})-\d{2}-\d{2}$/,r=e.match(n);if(!r||2!=r.length)return!1;var i=parseInt(r[1]);return(70>i||i>99)&&!s.isValid(e,t)?!1:!0}var o=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},s=n(205),u=n(100),l=u.messageRegistry,p=function(e){function t(){e.apply(this,arguments)}return o(t,e),t.prototype.check=function(e){return"string"==typeof e&&r(e)?u.ok():u.error(l.INVALID_DATEONLY,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.value=function(){return!0},t.prototype.facetName=function(){return"should be date-only"},t}(u.GenericTypeOf);t.DateOnlyR=p;var c=function(e){function t(){e.apply(this,arguments)}return o(t,e),t.prototype.check=function(e){if("string"==typeof e){var t=/^([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,n=e.match(t);if(!n)return u.error(l.INVALID_TIMEONLY,this);var r=n[1];return i(r)?u.ok():u.error(l.INVALID_TIMEONLY,this)}return u.error(l.INVALID_TIMEONLY,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.value=function(){return!0},t.prototype.facetName=function(){return"should be time-only"},t}(u.GenericTypeOf);t.TimeOnlyR=c;var f=function(e){function t(){e.apply(this,arguments)}return o(t,e),t.prototype.check=function(e){if("string"==typeof e){var t=/^(\d{4}-\d{2}-\d{2})T([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,n=e.match(t);if(!n||n.length<3)return u.error(l.INVALID_DATETIMEONLY,this);var a=n[1],o=n[2];return r(a)&&i(o)?u.ok():u.error(l.INVALID_DATETIMEONLY,this)}return u.error(l.INVALID_DATETIMEONLY,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.value=function(){return!0},t.prototype.facetName=function(){return"should be datetime-only"},t}(u.GenericTypeOf);t.DateTimeOnlyR=f;var d=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+\d{2}[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{4}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,m=/(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)\,[ ]+\d{2}-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-\d{2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,h=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{1,2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,y=/^(\d{4}-\d{2}-\d{2})T(\d{2}:\d{2}:\d{2})(?:\.\d+)?((?:[\+\-]\d{2}:\d{2})|Z)$/,v=function(e){function t(){e.apply(this,arguments)}return o(t,e),t.prototype.check=function(e){var t=u.VALIDATED_TYPE,n=!1;if(t.allFacets().forEach(function(e){"format"==e.facetName()&&"rfc2616"===e.value()&&(n=!0)}),"string"==typeof e){if(!n){var a=e.match(y);if(!a||a.length<3)return u.error(l.INVALID_RFC3339,this);var o=a[1],s=a[2];return r(o)&&i(s)?u.ok():u.error(l.INVALID_RFC3339,this)}return e.match(d)||e.match(m)||e.match(h)?u.ok():u.error(l.INVALID_RFC2616,this)}return u.error(l.INVALID_DATTIME,this)},t.prototype.requiredType=function(){return u.STRING},t.prototype.value=function(){return!0},t.prototype.facetName=function(){return"should be datetime-only"},t}(u.GenericTypeOf);t.DateTimeR=v},function(e,t,n){"use strict";function r(e,t,n,r){void 0===n&&(n=null),void 0===r&&(r=null);try{var i=e.trim();if(i.length>0){var o="{"==i.charAt(0);if(o||"<"==i.charAt(0)&&i.length>1&&"<"!=i.charAt(1))return new c.ExternalType("",i,o,n,r);var s=p.parse(e),u=a(s,t);return u}return c.derive(e,[c.STRING])}catch(l){return c.derive(e,[c.UNKNOWN])}}function i(e,t){for(;e>0;){var n=c.derive("",[c.ARRAY]);n.addMeta(new f.ComponentShouldBeOfType(t)),t=n,e--}return t}function a(e,t){if("union"==e.type){var n=e;return c.union("",[a(n.first,t),a(n.rest,t)])}if("parens"==e.type){var r=e,o=a(r.expr,t);return i(r.arr,o)}var s=e;if("?"==s.value.charAt(s.value.length-1)){var u=t.get(s.value.substr(0,s.value.length-1));u||(u=c.derive(s.value,[c.UNKNOWN])),u=c.union(s.value,[u,c.NIL]);var l=s.arr;return i(l,u)}var u=t.get(s.value);u||(u=c.derive(s.value,[c.UNKNOWN]));var l=s.arr;return i(l,u)}function o(e){if(e.isSubTypeOf(c.ARRAY)){var t=e.oneMeta(f.ComponentShouldBeOfType);return t?t.value().isUnion()?"("+o(t.value())+")[]":o(t.value())+"[]":"array"}if(e instanceof c.UnionType){var n=e;return n.options().map(function(e){return o(e)}).join(" | ")}return e.isAnonymous()&&e.isEmpty()?e.superTypes().map(function(e){return o(e)}).join(" , "):e.name()}function s(e,t){if(t(e),"union"==e.type){var n=e;s(n.first,t),s(n.rest,t)}else if("parens"==e.type){var r=e;s(r.expr,t)}}function u(e){var t,n=0;if("name"==e.type){var r=e;t=r.value,n=r.arr}else if("union"==e.type){var i=e;t=u(i.first)+" | "+u(i.rest)}else if("parens"==e.type){var a=e;t="("+u(a.expr)+")",n=a.arr}for(;--n>=0;)t+="[]";return t}function l(e){return p.parse(e)}var p=n(180),c=n(100),f=n(104);t.parseToType=r,t.storeToString=o,t.visit=s,t.serializeToString=u,t.parse=l},function(e,t,n){"use strict";function r(e,t,n,r){void 0===n&&(n=0),void 0===r&&(r=!0);for(var i="<"+e,a=0;n>a;a++)i="    "+i;return t&&Object.keys(t).length>0&&Object.keys(t).forEach(function(e){"string"==typeof t[e]&&(i=i+" "+e+'="'+t[e]+'"')}),i=i+">"+(r?"\n":"")}function i(e,t){void 0===t&&(t=0);for(var n="</"+e,r=0;t>r&&r>-1;r++)n="    "+n;var n=(t>-1?"\n":"")+n+">\n";return n}function a(e,t){t=d(t);var n=R(t),a=T(t),s=r(n,o(e,a)),u={};if(u[n]=e,t.isArray()){t.meta().filter(function(e){return e instanceof x.ComponentShouldBeOfType})[0];s+=p(u,t,1,!0)}else s+=l(e,a,1);var s=s+i(n);return s}function o(e,t){var n={},r=D.filter(t,function(e){return C(e.value()).attribute});return r.forEach(function(t){var r=t.propId(),i=I(t);e[r]&&(n[i]=e[r].toString())}),n}function s(e,t,n){var a=Object.keys(e)[0],p=e[a],c=null;if(t.isScalar()){var f=T(t);c=r(a,o(p,f),n,!t.isScalar())+p.toString()}else{if(t.isUnion())return s(e,u(p,t),n);var f=T(t);c=r(a,o(p,f),n,!t.isScalar())+l(p,f,n+1)}return c+=i(a,t.isScalar()?-1:n)}function u(e,t){var n=t.typeFamily(),r=[],i=null;return n.forEach(function(t){var n=a(e,t);if(n){var i=c(n,t);if(i){var o=f(i);r.push({type:t,errors:o&&o.length||0})}}}),i=r.length>0?r[0]:{type:n[0]},r.forEach(function(e){e.errors<i.errors&&(i=e)}),i.type}function l(e,t,n){var r=D.filter(t,function(e){return!C(e.value()).attribute}),i="";return r.forEach(function(t){var r=I(t),a=t.propId(),o={};o[r]=e[a],i+=t.value().isArray()?p(o,t.value(),n):e[a]||""===e[a]?s(o,t.value(),n):""}),i}function p(e,t,n,a){void 0===a&&(a=!1);var o=Object.keys(e)[0],u=e[o],l=C(t),p=a||l.wrapped,c="",f=M(t),d=f&&f.name(),m=n;return p&&!a&&(c=r(o,null,n),m+=1),u&&P(u)&&u.forEach(function(e){var t={};t[p?d:o]=e,c+=s(t,f,m)}),p&&(c+=i(o,n)),c}function c(e,t){var n=null,r={};return r.explicitChildren=!1,r.explicitArray=!1,r.explicitRoot=h(t)||!t.isExternal(),O.parseString(e,r,function(e,t){if(n=t,e)throw new Error}),n=h(t)?n:v(n,d(t))}function f(e){var t=e[F];return delete e[F],t&&0!==t.length?t.map(function(e){return new k.Status(k.Status.ERROR,"",e,{})}):null}function d(e){return e&&m(e)&&e.superTypes()&&0!==e.superTypes().length?1===e.superTypes().length?e.superTypes()[0]:D.find(e.allSuperTypes(),function(e){return"object"===e.name()})||e:e}function m(e){return e&&D.find(B,function(t){return e.name()===t})?!0:!1}function h(e){return y(e)?!0:D.find(e.allSuperTypes(),function(e){return y(e)})?!0:!1}function y(e){return e.isExternal()&&e._content&&"string"==typeof e._content&&0===e._content.trim().indexOf("<")?!0:!1}function v(e,t){var n=Object.keys(e)[0],r=e[n],i=[],a=R(t);a!==n&&i.push('Unexpected root node "'+n+'", "'+a+'" is expected.');var o;if(t.isArray()){var s=[],u=[],l=t.meta().filter(function(e){return e instanceof x.ComponentShouldBeOfType})[0],p=l&&l.value().name();u.push(p),o=_(r,t,i,!0),E(r,i,s,u)}else o=S(r,t.isUnion()?A(r,t):t,i);return o[F]=i,o}function g(e,t){var n,r=[];n=S(e,t,r);var i=t.validateDirect(n,!0,!1).getErrors();return r.length+(i&&i.length)}function A(e,t){var n=[];if(t.typeFamily().forEach(function(t){return n.push({type:t,errors:g(JSON.parse(JSON.stringify(e)),t)})}),0===n.length)return t;var r=n[0];return n.forEach(function(e){e.errors<r.errors&&(r=e)}),r.type}function S(e,t,n){var r={};if(!t)return e;if(t.isScalar())return L(t,e,n);if(t.isUnion())return S(e,A(e,t),n);var i=T(t),a=[],o=[];return b(e,i,a).forEach(function(e){return r[Object.keys(e)[0]]=e[Object.keys(e)[0]]}),N(e,i,o,n).forEach(function(e){return r[Object.keys(e)[0]]=e[Object.keys(e)[0]]}),E(e,n,a,o),r}function E(e,t,n,r,i){if(void 0===i&&(i=!1),"object"==typeof e){e.$||(e.$={}),n.forEach(function(t){delete e.$[t]}),r.forEach(function(t){delete e[t]});var a=Object.keys(e.$);delete e.$;var o=Object.keys(e);a.forEach(function(e){t.push('Unexpected attribute "'+e+'".')}),o.forEach(function(n){t.push('Unexpected element "'+n+'".'),i&&delete e[n]})}}function T(e){return e.meta().filter(function(e){return e instanceof x.PropertyIs}).map(function(e){return e})||[]}function b(e,t,n){var r=e.$;if(!r)return[];var i=D.filter(t,function(e){return C(e.value()).attribute});return i.map(function(e){var t={},i=e.propId(),a=I(e);n.push(a);var o=r[a];return t[i]=L(e.value(),o),null===t[i]?null:t}).filter(function(e){return e})}function N(e,t,n,r){var i=D.filter(t,function(e){return!C(e.value()).attribute});return i.map(function(t){var i={},a=(C(t.value()),t.propId()),o=I(t);n.push(o);var s=e[o];return t.value().isArray()?i[a]=_(e[o],t.value(),r):i[a]=s||""===s?S(s,t.value(),r):null,null===i[a]?null:i}).filter(function(e){return e})}function _(e,t,n,r){void 0===r&&(r=!1);var i=C(t),a=r||i.wrapped,o=M(t),s=o&&o.name();if(a){var u=e;e=e&&e[s],E(u,n,[],[s],!0)}return e?(e=w(e),e=P(e)?e.map(function(e){return S(e,o,n)}):"object"==typeof e&&e||[]):[]}function w(e){return P(e)?e:"object"==typeof e?[e]:[]}function M(e){if(!e||!e.isArray())return null;var t=e.meta().filter(function(e){return e instanceof x.ComponentShouldBeOfType});return t&&t.length>0&&t[0].value()}function I(e){var t=C(e.value()),n=e.propId(),r=t.name||n;return t.namespace&&(r=t.namespace+":"+r),(t.prefix||"")+r}function R(e){var t=C(e),n=e.name();""===n&&e.isUnion()&&(n="object");var r=t.name||n;return(t.prefix||"")+r}function C(e){var t=e.meta().filter(function(e){return e instanceof U.XMLInfo}).map(function(e){return e})[0],n={attribute:!1,wrapped:!1,name:!1,namespace:!1,prefix:!1};if(!t)return n;var r=t.value();return r?(Object.keys(n).forEach(function(e){n[e]=r[e]||n[e]}),n):n}function L(e,t,n){if(void 0===n&&(n=[]),"object"==typeof t){var r=L(e,t._);return delete t._,E(t,n,[],[],!0),r}if(!t&&""!==t.trim())return null;if(e.isNumber()){var i=parseFloat(t);if(!isNaN(i))return i}if(e.isBoolean()){if("true"===t)return!0;if("false"===t)return!1}return"string"==typeof t?t:null}function P(e){return e?"object"==typeof e&&"number"==typeof e.length:!1}var O=n(208),D=n(185),x=n(104),U=n(105),k=n(100),F="@unexpected_root_attributes_and_elements",B=["application/x-www-form-urlencoded","application/json","application/xml","multipart/form-data"];t.serializeToXML=a,t.readObject=c,t.getXmlErrors=f},function(e,t,n){"use strict";function r(e,t){return o.find(e,t)}function i(e,t){return o.filter(e,t)}function a(e){return o.unique(e)}var o=n(185);t.find=r,t.filter=i,t.unique=a},function(e,t,n){"use strict";function r(e,t,n){return{originalPath:e,virtualIndex:t,patchedContent:n}}function i(e){if(!e)return"";var t=Object.keys(e)[0],n=e[t];if("#text"==t)return n;if(!n&&""!==n)return"";var r="<"+t,a=n.$||{};return Object.keys(a).forEach(function(e){r=r+" "+e+'="'+a[e]+'"'}),r+=">","string"==typeof n?r+=n:Object.keys(n).forEach(function(e){if("$"!==e)if("object"!=typeof n[e]||n[e].length)if("string"!=typeof n[e]&&n[e]){if("array"==typeof n[e]||n[e].length)for(var t=n[e],a=0;a<t.length;a++){var o=t[a],s={};s[e]=o,r+=i(s)}}else{var s={};s[e]=n[e]||"",r+=i(s)}else{var s={};s[e]=n[e],r+=i(s)}}),r=r+"</"+t+">"}function a(e){return new l(e)}function o(e){var t=e&&Object.keys(e)[0];if(t){var n=e[t];s(n)}return i(e)}function s(e){if(e&&"string"!=typeof e){var t=[];Object.keys(e).forEach(function(n){if("$"!=n)if(0===n.indexOf("@")){var r={key:n,value:e[n]};t.push(r)}else if(u(e[n])){var i=e[n];i.forEach(function(e){return s(e)})}else"string"!=typeof e[n]&&s(e[n])}),e.$||(e.$={});var n=e.$;t.forEach(function(t){delete e[t.key];var r=t.key.substring(1);n[r]=t.value})}}function u(e){return e?"object"==typeof e&&"number"==typeof e.length:!1}var l;try{l=n(177).XMLValidator}catch(p){}if(!l){var c=function(){function e(e){}return e.prototype.validate=function(e,t){return[]},e}();l=c}t.createXmlSchemaReference=r,t.getValidator=a,t.jsonToXml=o},function(e,t,n){"use strict";function r(){return new i}var i;try{i=n(176).JSONValidator}catch(a){}if(!i){var o=function(){function e(){}return e.prototype.setRemoteReference=function(e,t){},e.prototype.validateSchema=function(e){},e.prototype.getMissingRemoteReferences=function(){return[]},e.prototype.isResourceLoaded=function(e){return!0},e.prototype.validate=function(e,t){},e.prototype.getLastErrors=function(){return[]},e}();i=o}t.getValidator=r},function(e,t,n){
e.exports=function(e){return e.webpackPolyfill||(e.deprecate=function(){},e.paths=[],e.children=[],e.webpackPolyfill=1),e}},function(e,t,n){var r,i,a,o,s={'"':'"',"\\":"\\","/":"/",b:"\b",f:"\f",n:"\n",r:"\r",t:"	"},u=function(e){throw{name:"SyntaxError",message:e,at:r,text:a}},l=function(e){return e&&e!==i&&u("Expected '"+e+"' instead of '"+i+"'"),i=a.charAt(r),r+=1,i},p=function(){var e,t="";for("-"===i&&(t="-",l("-"));i>="0"&&"9">=i;)t+=i,l();if("."===i)for(t+=".";l()&&i>="0"&&"9">=i;)t+=i;if("e"===i||"E"===i)for(t+=i,l(),("-"===i||"+"===i)&&(t+=i,l());i>="0"&&"9">=i;)t+=i,l();return e=+t,isFinite(e)?e:void u("Bad number")},c=function(){var e,t,n,r="";if('"'===i)for(;l();){if('"'===i)return l(),r;if("\\"===i)if(l(),"u"===i){for(n=0,t=0;4>t&&(e=parseInt(l(),16),isFinite(e));t+=1)n=16*n+e;r+=String.fromCharCode(n)}else{if("string"!=typeof s[i])break;r+=s[i]}else r+=i}u("Bad string")},f=function(){for(;i&&" ">=i;)l()},d=function(){switch(i){case"t":return l("t"),l("r"),l("u"),l("e"),!0;case"f":return l("f"),l("a"),l("l"),l("s"),l("e"),!1;case"n":return l("n"),l("u"),l("l"),l("l"),null}u("Unexpected '"+i+"'")},m=function(){var e=[];if("["===i){if(l("["),f(),"]"===i)return l("]"),e;for(;i;){if(e.push(o()),f(),"]"===i)return l("]"),e;l(","),f()}}u("Bad array")},h=function(){var e,t={};if("{"===i){if(l("{"),f(),"}"===i)return l("}"),t;for(;i;){if(e=c(),f(),l(":"),Object.hasOwnProperty.call(t,e)&&u('Duplicate key "'+e+'"'),t[e]=o(),f(),"}"===i)return l("}"),t;l(","),f()}}u("Bad object")};o=function(){switch(f(),i){case"{":return h();case"[":return m();case'"':return c();case"-":return p();default:return i>="0"&&"9">=i?p():d()}},e.exports=function(e,t){var n;return a=e,r=0,i=" ",n=o(),f(),i&&u("Syntax error"),"function"==typeof t?function s(e,n){var r,i,a=e[n];if(a&&"object"==typeof a)for(r in a)Object.prototype.hasOwnProperty.call(a,r)&&(i=s(a,r),void 0!==i?a[r]=i:delete a[r]);return t.call(e,n,a)}({"":n},""):n}},function(e,t,n){function r(e){return u.lastIndex=0,u.test(e)?'"'+e.replace(u,function(e){var t=l[e];return"string"==typeof t?t:"\\u"+("0000"+e.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+e+'"'}function i(e,t){var n,u,l,p,c,f=a,d=t[e];switch(d&&"object"==typeof d&&"function"==typeof d.toJSON&&(d=d.toJSON(e)),"function"==typeof s&&(d=s.call(t,e,d)),typeof d){case"string":return r(d);case"number":return isFinite(d)?String(d):"null";case"boolean":case"null":return String(d);case"object":if(!d)return"null";if(a+=o,c=[],"[object Array]"===Object.prototype.toString.apply(d)){for(p=d.length,n=0;p>n;n+=1)c[n]=i(n,d)||"null";return l=0===c.length?"[]":a?"[\n"+a+c.join(",\n"+a)+"\n"+f+"]":"["+c.join(",")+"]",a=f,l}if(s&&"object"==typeof s)for(p=s.length,n=0;p>n;n+=1)u=s[n],"string"==typeof u&&(l=i(u,d),l&&c.push(r(u)+(a?": ":":")+l));else for(u in d)Object.prototype.hasOwnProperty.call(d,u)&&(l=i(u,d),l&&c.push(r(u)+(a?": ":":")+l));return l=0===c.length?"{}":a?"{\n"+a+c.join(",\n"+a)+"\n"+f+"}":"{"+c.join(",")+"}",a=f,l}}var a,o,s,u=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,l={"\b":"\\b","	":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};e.exports=function(e,t,n){var r;if(a="",o="","number"==typeof n)for(r=0;n>r;r+=1)o+=" ";else"string"==typeof n&&(o=n);if(s=t,t&&"function"!=typeof t&&("object"!=typeof t||"number"!=typeof t.length))throw new Error("JSON.stringify");return i("",{"":e})}},function(e,t,n){e.exports=__WEBPACK_EXTERNAL_MODULE_152__},function(e,t,n){"use strict";function r(e,t,n){var i=[];return e.include.forEach(function(e){n=r(e,t,n)}),e[t].forEach(function(e){n.forEach(function(t,n){t.tag===e.tag&&i.push(n)}),n.push(e)}),n.filter(function(e,t){return-1===i.indexOf(t)})}function i(){function e(e){r[e.tag]=e}var t,n,r={};for(t=0,n=arguments.length;n>t;t+=1)arguments[t].forEach(e);return r}var a=n(114),o=n(115),s=n(194),u=function(){function e(e){this.include=e.include||[],this.implicit=e.implicit||[],this.explicit=e.explicit||[],this.implicit.forEach(function(e){if(e.loadKind&&"scalar"!==e.loadKind)throw new o("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.")}),this.compiledImplicit=r(this,"implicit",[]),this.compiledExplicit=r(this,"explicit",[]),this.compiledTypeMap=i(this.compiledImplicit,this.compiledExplicit)}return e.DEFAULT=null,e.create=function(){var t,n;switch(arguments.length){case 1:t=e.DEFAULT,n=arguments[0];break;case 2:t=arguments[0],n=arguments[1];break;default:throw new o("Wrong number of arguments for Schema.create function")}if(t=a.toArray(t),n=a.toArray(n),!t.every(function(t){return t instanceof e}))throw new o("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");if(!n.every(function(e){return e instanceof s}))throw new o("Specified list of YAML types (or a single Type object) contains a non-Type object.");return new e({include:t,explicit:n})},e}();e.exports=u},function(e,t,n){"use strict";var r=n(153);e.exports=new r({include:[n(195)]})},function(e,t,n){(function(t){"use strict";function r(e,t){D=D||n(157),e=e||{},this.objectMode=!!e.objectMode,t instanceof D&&(this.objectMode=this.objectMode||!!e.readableObjectMode);var r=e.highWaterMark,i=this.objectMode?16:16384;this.highWaterMark=r||0===r?r:i,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=e.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(O||(O=n(212).StringDecoder),this.decoder=new O(e.encoding),this.encoding=e.encoding)}function i(e){return D=D||n(157),this instanceof i?(this._readableState=new r(e,this),this.readable=!0,e&&"function"==typeof e.read&&(this._read=e.read),void I.call(this)):new i(e)}function a(e,t,n,r,i){var a=l(t,n);if(a)e.emit("error",a);else if(null===n)t.reading=!1,p(e,t);else if(t.objectMode||n&&n.length>0)if(t.ended&&!i){var s=new Error("stream.push() after EOF");e.emit("error",s)}else if(t.endEmitted&&i){var s=new Error("stream.unshift() after end event");e.emit("error",s)}else{var u;!t.decoder||i||r||(n=t.decoder.write(n),u=!t.objectMode&&0===n.length),i||(t.reading=!1),u||(t.flowing&&0===t.length&&!t.sync?(e.emit("data",n),e.read(0)):(t.length+=t.objectMode?1:n.length,i?t.buffer.unshift(n):t.buffer.push(n),t.needReadable&&c(e))),d(e,t)}else i||(t.reading=!1);return o(t)}function o(e){return!e.ended&&(e.needReadable||e.length<e.highWaterMark||0===e.length)}function s(e){return e>=x?e=x:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}function u(e,t){return 0===t.length&&t.ended?0:t.objectMode?0===e?0:1:null===e||isNaN(e)?t.flowing&&t.buffer.length?t.buffer[0].length:t.length:0>=e?0:(e>t.highWaterMark&&(t.highWaterMark=s(e)),e>t.length?t.ended?t.length:(t.needReadable=!0,0):e)}function l(e,t){var n=null;return M.isBuffer(t)||"string"==typeof t||null===t||void 0===t||e.objectMode||(n=new TypeError("Invalid non-string/buffer chunk")),n}function p(e,t){if(!t.ended){if(t.decoder){var n=t.decoder.end();n&&n.length&&(t.buffer.push(n),t.length+=t.objectMode?1:n.length)}t.ended=!0,c(e)}}function c(e){var t=e._readableState;t.needReadable=!1,t.emittedReadable||(P("emitReadable",t.flowing),t.emittedReadable=!0,t.sync?_(f,e):f(e))}function f(e){P("emit readable"),e.emit("readable"),A(e)}function d(e,t){t.readingMore||(t.readingMore=!0,_(m,e,t))}function m(e,t){for(var n=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(P("maybeReadMore read 0"),e.read(0),n!==t.length);)n=t.length;t.readingMore=!1}function h(e){return function(){var t=e._readableState;P("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,0===t.awaitDrain&&R(e,"data")&&(t.flowing=!0,A(e))}}function y(e){P("readable nexttick read 0"),e.read(0)}function v(e,t){t.resumeScheduled||(t.resumeScheduled=!0,_(g,e,t))}function g(e,t){t.reading||(P("resume read 0"),e.read(0)),t.resumeScheduled=!1,e.emit("resume"),A(e),t.flowing&&!t.reading&&e.read(0)}function A(e){var t=e._readableState;if(P("flow",t.flowing),t.flowing)do var n=e.read();while(null!==n&&t.flowing)}function S(e,t){var n,r=t.buffer,i=t.length,a=!!t.decoder,o=!!t.objectMode;if(0===r.length)return null;if(0===i)n=null;else if(o)n=r.shift();else if(!e||e>=i)n=a?r.join(""):1===r.length?r[0]:M.concat(r,i),r.length=0;else if(e<r[0].length){var s=r[0];n=s.slice(0,e),r[0]=s.slice(e)}else if(e===r[0].length)n=r.shift();else{n=a?"":new M(e);for(var u=0,l=0,p=r.length;p>l&&e>u;l++){var s=r[0],c=Math.min(e-u,s.length);a?n+=s.slice(0,c):s.copy(n,u,0,c),c<s.length?r[0]=s.slice(c):r.shift(),u+=c}}return n}function E(e){var t=e._readableState;if(t.length>0)throw new Error("endReadable called on non-empty stream");t.endEmitted||(t.ended=!0,_(T,t,e))}function T(e,t){e.endEmitted||0!==e.length||(e.endEmitted=!0,t.readable=!1,t.emit("end"))}function b(e,t){for(var n=0,r=e.length;r>n;n++)t(e[n],n)}function N(e,t){for(var n=0,r=e.length;r>n;n++)if(e[n]===t)return n;return-1}e.exports=i;var _=n(209),w=n(210),M=n(97).Buffer;i.ReadableState=r;var I,R=(n(211),function(e,t){return e.listeners(t).length});!function(){try{I=n(181)}catch(e){}finally{I||(I=n(211).EventEmitter)}}();var M=n(97).Buffer,C=n(219);C.inherits=n(119);var L=n(187),P=void 0;P=L&&L.debuglog?L.debuglog("stream"):function(){};var O;C.inherits(i,I);var D,D;i.prototype.push=function(e,t){var n=this._readableState;return n.objectMode||"string"!=typeof e||(t=t||n.defaultEncoding,t!==n.encoding&&(e=new M(e,t),t="")),a(this,n,e,t,!1)},i.prototype.unshift=function(e){var t=this._readableState;return a(this,t,e,"",!0)},i.prototype.isPaused=function(){return this._readableState.flowing===!1},i.prototype.setEncoding=function(e){return O||(O=n(212).StringDecoder),this._readableState.decoder=new O(e),this._readableState.encoding=e,this};var x=8388608;i.prototype.read=function(e){P("read",e);var t=this._readableState,n=e;if(("number"!=typeof e||e>0)&&(t.emittedReadable=!1),0===e&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return P("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?E(this):c(this),null;if(e=u(e,t),0===e&&t.ended)return 0===t.length&&E(this),null;var r=t.needReadable;P("need readable",r),(0===t.length||t.length-e<t.highWaterMark)&&(r=!0,P("length less than watermark",r)),(t.ended||t.reading)&&(r=!1,P("reading or ended",r)),r&&(P("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1),r&&!t.reading&&(e=u(n,t));var i;return i=e>0?S(e,t):null,null===i&&(t.needReadable=!0,e=0),t.length-=e,0!==t.length||t.ended||(t.needReadable=!0),n!==e&&t.ended&&0===t.length&&E(this),null!==i&&this.emit("data",i),i},i.prototype._read=function(e){this.emit("error",new Error("not implemented"))},i.prototype.pipe=function(e,n){function r(e){P("onunpipe"),e===c&&a()}function i(){P("onend"),e.end()}function a(){P("cleanup"),e.removeListener("close",u),e.removeListener("finish",l),e.removeListener("drain",y),e.removeListener("error",s),e.removeListener("unpipe",r),c.removeListener("end",i),c.removeListener("end",a),c.removeListener("data",o),v=!0,!f.awaitDrain||e._writableState&&!e._writableState.needDrain||y()}function o(t){P("ondata");var n=e.write(t);!1===n&&(1!==f.pipesCount||f.pipes[0]!==e||1!==c.listenerCount("data")||v||(P("false write response, pause",c._readableState.awaitDrain),c._readableState.awaitDrain++),c.pause())}function s(t){P("onerror",t),p(),e.removeListener("error",s),0===R(e,"error")&&e.emit("error",t)}function u(){e.removeListener("finish",l),p()}function l(){P("onfinish"),e.removeListener("close",u),p()}function p(){P("unpipe"),c.unpipe(e)}var c=this,f=this._readableState;switch(f.pipesCount){case 0:f.pipes=e;break;case 1:f.pipes=[f.pipes,e];break;default:f.pipes.push(e)}f.pipesCount+=1,P("pipe count=%d opts=%j",f.pipesCount,n);var d=(!n||n.end!==!1)&&e!==t.stdout&&e!==t.stderr,m=d?i:a;f.endEmitted?_(m):c.once("end",m),e.on("unpipe",r);var y=h(c);e.on("drain",y);var v=!1;return c.on("data",o),e._events&&e._events.error?w(e._events.error)?e._events.error.unshift(s):e._events.error=[s,e._events.error]:e.on("error",s),e.once("close",u),e.once("finish",l),e.emit("pipe",c),f.flowing||(P("pipe resume"),c.resume()),e},i.prototype.unpipe=function(e){var t=this._readableState;if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes?this:(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this),this);if(!e){var n=t.pipes,r=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var i=0;r>i;i++)n[i].emit("unpipe",this);return this}var a=N(t.pipes,e);return-1===a?this:(t.pipes.splice(a,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this),this)},i.prototype.on=function(e,t){var n=I.prototype.on.call(this,e,t);if("data"===e&&!1!==this._readableState.flowing&&this.resume(),"readable"===e&&!this._readableState.endEmitted){var r=this._readableState;r.readableListening||(r.readableListening=!0,r.emittedReadable=!1,r.needReadable=!0,r.reading?r.length&&c(this,r):_(y,this))}return n},i.prototype.addListener=i.prototype.on,i.prototype.resume=function(){var e=this._readableState;return e.flowing||(P("resume"),e.flowing=!0,v(this,e)),this},i.prototype.pause=function(){return P("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(P("pause"),this._readableState.flowing=!1,this.emit("pause")),this},i.prototype.wrap=function(e){var t=this._readableState,n=!1,r=this;e.on("end",function(){if(P("wrapped end"),t.decoder&&!t.ended){var e=t.decoder.end();e&&e.length&&r.push(e)}r.push(null)}),e.on("data",function(i){if(P("wrapped data"),t.decoder&&(i=t.decoder.write(i)),(!t.objectMode||null!==i&&void 0!==i)&&(t.objectMode||i&&i.length)){var a=r.push(i);a||(n=!0,e.pause())}});for(var i in e)void 0===this[i]&&"function"==typeof e[i]&&(this[i]=function(t){return function(){return e[t].apply(e,arguments)}}(i));var a=["error","close","destroy","pause","resume"];return b(a,function(t){e.on(t,r.emit.bind(r,t))}),r._read=function(t){P("wrapped _read",t),n&&(n=!1,e.resume())},r},i._fromList=S}).call(t,n(64))},function(e,t,n){(function(t){"use strict";function r(){}function i(e,t,n){this.chunk=e,this.encoding=t,this.callback=n,this.next=null}function a(e,t){R=R||n(157),e=e||{},this.objectMode=!!e.objectMode,t instanceof R&&(this.objectMode=this.objectMode||!!e.writableObjectMode);var r=e.highWaterMark,i=this.objectMode?16:16384;this.highWaterMark=r||0===r?r:i,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var a=e.decodeStrings===!1;this.decodeStrings=!a,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){m(t,e)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new T(this),this.corkedRequestsFree.next=new T(this)}function o(e){return R=R||n(157),this instanceof o||this instanceof R?(this._writableState=new a(e,this),this.writable=!0,e&&("function"==typeof e.write&&(this._write=e.write),"function"==typeof e.writev&&(this._writev=e.writev)),void M.call(this)):new o(e)}function s(e,t){var n=new Error("write after end");e.emit("error",n),b(t,n)}function u(e,t,n,r){var i=!0;if(!_.isBuffer(n)&&"string"!=typeof n&&null!==n&&void 0!==n&&!t.objectMode){var a=new TypeError("Invalid non-string/buffer chunk");e.emit("error",a),b(r,a),i=!1}return i}function l(e,t,n){return e.objectMode||e.decodeStrings===!1||"string"!=typeof t||(t=new _(t,n)),t}function p(e,t,n,r,a){n=l(t,n,r),_.isBuffer(n)&&(r="buffer");var o=t.objectMode?1:n.length;t.length+=o;var s=t.length<t.highWaterMark;if(s||(t.needDrain=!0),t.writing||t.corked){var u=t.lastBufferedRequest;t.lastBufferedRequest=new i(n,r,a),u?u.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1}else c(e,t,!1,o,n,r,a);return s}function c(e,t,n,r,i,a,o){t.writelen=r,t.writecb=o,t.writing=!0,t.sync=!0,n?e._writev(i,t.onwrite):e._write(i,a,t.onwrite),t.sync=!1}function f(e,t,n,r,i){--t.pendingcb,n?b(i,r):i(r),e._writableState.errorEmitted=!0,e.emit("error",r)}function d(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}function m(e,t){var n=e._writableState,r=n.sync,i=n.writecb;if(d(n),t)f(e,n,r,t,i);else{var a=g(n);a||n.corked||n.bufferProcessing||!n.bufferedRequest||v(e,n),r?N(h,e,n,a,i):h(e,n,a,i)}}function h(e,t,n,r){n||y(e,t),t.pendingcb--,r(),S(e,t)}function y(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}function v(e,t){t.bufferProcessing=!0;var n=t.bufferedRequest;if(e._writev&&n&&n.next){var r=t.bufferedRequestCount,i=new Array(r),a=t.corkedRequestsFree;a.entry=n;for(var o=0;n;)i[o]=n,n=n.next,o+=1;c(e,t,!0,t.length,i,"",a.finish),t.pendingcb++,t.lastBufferedRequest=null,t.corkedRequestsFree=a.next,a.next=null}else{for(;n;){var s=n.chunk,u=n.encoding,l=n.callback,p=t.objectMode?1:s.length;if(c(e,t,!1,p,s,u,l),n=n.next,t.writing)break}null===n&&(t.lastBufferedRequest=null)}t.bufferedRequestCount=0,t.bufferedRequest=n,t.bufferProcessing=!1}function g(e){return e.ending&&0===e.length&&null===e.bufferedRequest&&!e.finished&&!e.writing}function A(e,t){t.prefinished||(t.prefinished=!0,e.emit("prefinish"))}function S(e,t){var n=g(t);return n&&(0===t.pendingcb?(A(e,t),t.finished=!0,e.emit("finish")):A(e,t)),n}function E(e,t,n){t.ending=!0,S(e,t),n&&(t.finished?b(n):e.once("finish",n)),t.ended=!0,e.writable=!1}function T(e){var t=this;this.next=null,this.entry=null,this.finish=function(n){var r=t.entry;for(t.entry=null;r;){var i=r.callback;e.pendingcb--,i(n),r=r.next}e.corkedRequestsFree?e.corkedRequestsFree.next=t:e.corkedRequestsFree=t}}e.exports=o;var b=n(209),N=!t.browser&&["v0.10","v0.9."].indexOf(t.version.slice(0,5))>-1?setImmediate:b,_=n(97).Buffer;o.WritableState=a;var w=n(219);w.inherits=n(119);var M,I={deprecate:n(218)};!function(){try{M=n(181)}catch(e){}finally{M||(M=n(211).EventEmitter)}}();var _=n(97).Buffer;w.inherits(o,M);var R;a.prototype.getBuffer=function(){for(var e=this.bufferedRequest,t=[];e;)t.push(e),e=e.next;return t},function(){try{Object.defineProperty(a.prototype,"buffer",{get:I.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")})}catch(e){}}();var R;o.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},o.prototype.write=function(e,t,n){var i=this._writableState,a=!1;return"function"==typeof t&&(n=t,t=null),_.isBuffer(e)?t="buffer":t||(t=i.defaultEncoding),"function"!=typeof n&&(n=r),i.ended?s(this,n):u(this,i,e,n)&&(i.pendingcb++,a=p(this,i,e,t,n)),a},o.prototype.cork=function(){var e=this._writableState;e.corked++},o.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,e.writing||e.corked||e.finished||e.bufferProcessing||!e.bufferedRequest||v(this,e))},o.prototype.setDefaultEncoding=function(e){if("string"==typeof e&&(e=e.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((e+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+e);this._writableState.defaultEncoding=e},o.prototype._write=function(e,t,n){n(new Error("not implemented"))},o.prototype._writev=null,o.prototype.end=function(e,t,n){var r=this._writableState;"function"==typeof e?(n=e,e=null,t=null):"function"==typeof t&&(n=t,t=null),null!==e&&void 0!==e&&this.write(e,t),r.corked&&(r.corked=1,this.uncork()),r.ending||r.finished||E(this,r,n)}}).call(t,n(64))},function(e,t,n){"use strict";function r(e){return this instanceof r?(l.call(this,e),p.call(this,e),e&&e.readable===!1&&(this.readable=!1),e&&e.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,e&&e.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",i)):new r(e)}function i(){this.allowHalfOpen||this._writableState.ended||s(a,this)}function a(e){e.end()}var o=Object.keys||function(e){var t=[];for(var n in e)t.push(n);return t};e.exports=r;var s=n(209),u=n(219);u.inherits=n(119);var l=n(155),p=n(156);u.inherits(r,l);for(var c=o(p.prototype),f=0;f<c.length;f++){var d=c[f];r.prototype[d]||(r.prototype[d]=p.prototype[d])}},function(e,t,n){"use strict";function r(e){this.afterTransform=function(t,n){return i(e,t,n)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function i(e,t,n){var r=e._transformState;r.transforming=!1;var i=r.writecb;if(!i)return e.emit("error",new Error("no writecb in Transform class"));r.writechunk=null,r.writecb=null,null!==n&&void 0!==n&&e.push(n),i(t);var a=e._readableState;a.reading=!1,(a.needReadable||a.length<a.highWaterMark)&&e._read(a.highWaterMark)}function a(e){if(!(this instanceof a))return new a(e);s.call(this,e),this._transformState=new r(this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,e&&("function"==typeof e.transform&&(this._transform=e.transform),"function"==typeof e.flush&&(this._flush=e.flush)),this.once("prefinish",function(){"function"==typeof this._flush?this._flush(function(e){o(t,e)}):o(t)})}function o(e,t){if(t)return e.emit("error",t);var n=e._writableState,r=e._transformState;if(n.length)throw new Error("calling transform done when ws.length != 0");if(r.transforming)throw new Error("calling transform done when still transforming");return e.push(null)}e.exports=a;var s=n(157),u=n(219);u.inherits=n(119),u.inherits(a,s),a.prototype.push=function(e,t){return this._transformState.needTransform=!1,s.prototype.push.call(this,e,t)},a.prototype._transform=function(e,t,n){throw new Error("not implemented")},a.prototype._write=function(e,t,n){var r=this._transformState;if(r.writecb=n,r.writechunk=e,r.writeencoding=t,!r.transforming){var i=this._readableState;(r.needTransform||i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark)}},a.prototype._read=function(e){var t=this._transformState;null!==t.writechunk&&t.writecb&&!t.transforming?(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform)):t.needTransform=!0}},function(e,t,n){"use strict";function r(e){return this instanceof r?void i.call(this,e):new r(e)}e.exports=r;var i=n(158),a=n(219);a.inherits=n(119),a.inherits(r,i),r.prototype._transform=function(e,t,n){n(null,e)}},function(e,t,n){"use strict";e.exports=n(196),n(197),n(198),n(199),n(200),n(201)},function(e,t,n){"use strict";function r(e){var t=[],n=l.readFileSync(u.resolve(e)).toString(),r=o.createSourceFile("sample.ts",n,o.ScriptTarget.ES3,!0);return s.Matching.visit(r,function(r){var s=r;if(s.kind==o.SyntaxKind.FunctionDeclaration){var u=i(s,n);if(!u)return;var l=s.name.text,f=l;u.name?f=u.name:u.name=l;var f=u.name?u.name:l,d=s.parameters?s.parameters.map(function(t){return a(t,e)}):[],m=(u.override?u.override:!1,p.buildType(s.type,e));t.push(new c.HelperMethod(l,f,m,d,u))}}),t}function i(e,t){var n=o.getLeadingCommentRanges(t,e.pos);if(!n)return null;var r=n.map(function(e){return t.substring(e.pos,e.end)}).join("\n"),i=r.indexOf("__$helperMethod__");if(0>i)return null;i+="__$helperMethod__".length;var a=r.indexOf("__$meta__");if(0>a)return{comment:f(r.substring(i))};var s=f(r.substring(i,a)),u=r.indexOf("{",a);if(0>u)return{comment:s};try{var l=JSON.parse(f(r.substring(u)));return l.comment=s.trim().length>0?s:null,l.override=l.override||!1,l.primary=l.primary||!1,l.deprecated=l.deprecated||!1,l}catch(p){console.log(p)}return{}}function a(e,t){var n,r=e.name.text,i=p.buildType(e.type,t),a=null!=e.questionToken;return null!=e.initializer&&(n=p.parseArg(e.initializer),a=!0),{name:r,type:i,defaultValue:n,optional:a}}var o=n(152),s=n(162),u=n(15),l=n(193),p=n(140),c=n(139);t.getHelperMethods=r;var f=function(e){return e.replace(/^\s*\/\*+/g,"").replace(/\*+\/\s*$/g,"").split("\n").map(function(e){return e.replace(/^\s*\/\//g,"").replace(/^\s*\* {0,1}/g,"")}).join("\n").trim()}},function(e,t,n){"use strict";var r,i=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},a=n(152);!function(e){function t(n,r){var i=r(n);if(i)return i==e.SKIP?null:i;var o=a.forEachChild(n,function(e){var n=t(e,r);return n?n:void 0});return o}function n(e,t){void 0===t&&(t=function(e){return!0});for(var n=e.split("."),i=null,a=0;a<n.length;a++){var s=n[a],u=s.indexOf("(*)"),l=!1;-1!=u&&(s=s.substr(0,u),l=!0),i=null==i?"*"==s?o():r(s):new N(i,"*"==s?o():r(s),t),l&&(i=new E(i,t))}return i}function r(e){return new A(e)}function o(){return new S}function s(e,t){return void 0===t&&(t=function(e){return!0}),new E(e,t)}function u(e,t){return void 0===t&&(t=function(e){return!0}),new g(e,t)}function l(e,t,n){return void 0===n&&(n=function(e){return!0}),new y(e,t,n)}function p(e,t,n){return void 0===n&&(n=function(e){return!0}),new v(e,t,n)}function c(){return new h}function f(){return new m}var d=function(){function e(){}return e.prototype.match=function(e){throw new Error},e.prototype.nodeType=function(){throw new Error},e.prototype.doMatch=function(e){return e?this.nodeType()==e.kind?this.match(e):void 0:null},e}();e.BasicMatcher=d;var m=function(e){function t(){e.call(this)}return i(t,e),t.prototype.match=function(e){return e},t.prototype.nodeType=function(){return a.SyntaxKind.ClassDeclaration},t}(d);e.ClassDeclarationMatcher=m;var h=function(e){function t(){e.apply(this,arguments)}return i(t,e),t.prototype.match=function(e){return e},t.prototype.nodeType=function(){return a.SyntaxKind.PropertyDeclaration},t}(d);e.FieldMatcher=h;var y=function(e){function t(t,n,r){e.call(this),this.left=t,this.right=n,this.tr=r}return i(t,e),t.prototype.match=function(e){return e.operatorToken.kind==a.SyntaxKind.EqualsToken&&this.left.doMatch(e.left)&&this.right.doMatch(e.right)?this.tr(e):null},t.prototype.nodeType=function(){return a.SyntaxKind.BinaryExpression},t}(d);e.AssignmentExpressionMatcher=y;var v=function(e){function t(t,n,r){e.call(this),this.left=t,this.right=n,this.tr=r}return i(t,e),t.prototype.match=function(e){return this.left.doMatch(e.name)&&this.right.doMatch(e.initializer)?this.tr(e):void 0},t.prototype.nodeType=function(){return a.SyntaxKind.VariableDeclaration},t}(d);e.VariableDeclarationMatcher=v;var g=function(e){function t(t,n){e.call(this),this.expression=t,this.tr=n}return i(t,e),t.prototype.match=function(e){var t=this.expression.doMatch(e.expression);if(t){var n=this.tr(e.expression);return 1==n?t:n}return null},t.prototype.nodeType=function(){return a.SyntaxKind.ExpressionStatement},t}(d),A=function(e){function t(t){e.call(this),this.val=t}return i(t,e),t.prototype.match=function(e){return e.text==this.val?!0:null},t.prototype.nodeType=function(){return a.SyntaxKind.Identifier},t}(d),S=function(){function e(){}return e.prototype.doMatch=function(e){return!0},e.prototype.nodeType=function(){return null},e}(),E=function(e){function t(t,n){e.call(this),this.calleeMatcher=t,this.tr=n}return i(t,e),t.prototype.match=function(e){return this.calleeMatcher.doMatch(e.expression)?this.tr(e):null},t.prototype.nodeType=function(){return a.SyntaxKind.CallExpression},t}(d);e.SKIP={},e.visit=t;var T=function(){function e(e,t){this._base=t,this.arguments=null,this.name=e}return e}();e.PathNode=T;var b=function(){function e(e,t){this._baseNode=t,this.path=[],this.base=e}return e.prototype.start=function(){return this._baseNode.pos},e.prototype.startLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.start())},e.prototype.endLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.end())},e.prototype.end=function(){var e=this.path[this.path.length-1]._callExpression;return e?e.end:this.start()},e.prototype.toString=function(){return this.path.map(function(e){return e.name}).join(".")},e}();e.CallPath=b;var N=function(e){function t(t,n,r){e.call(this),this.objectMatcher=t,this.propertyMatcher=n,this.tr=r}return i(t,e),t.prototype.match=function(e){return this.objectMatcher.doMatch(e.expression)&&this.propertyMatcher.doMatch(e.name)?this.tr(e):null},t.prototype.nodeType=function(){return a.SyntaxKind.PropertyAccessExpression},t}(d);e.memberFromExp=n;var _=function(){function e(e){this.rootMatcher=e}return e.prototype.doMatch=function(e){if(e.kind==a.SyntaxKind.CallExpression){var t=e,n=this.doMatch(t.expression);if(n)return n.path.length>0&&null==n.path[n.path.length-1].arguments?(n.path[n.path.length-1].arguments=t.arguments,n.path[n.path.length-1]._callExpression=t,n):null}else if(e.kind==a.SyntaxKind.PropertyAccessExpression){var r=e,i=this.doMatch(r.expression);if(i)return r.name.kind==a.SyntaxKind.Identifier?(i.path.push(new T(r.name.text,r.name)),i):null}else if(e.kind==a.SyntaxKind.Identifier){var o=e;if(this.rootMatcher.doMatch(o))return new b(o.text,o)}return null},e.prototype.nodeType=function(){return null},e}();e.CallBaseMatcher=_,e.ident=r,e.anyNode=o,e.call=s,e.exprStmt=u,e.assign=l,e.varDecl=p,e.field=c,e.classDeclaration=f}(r=t.Matching||(t.Matching={}))},function(e,t,n){"use strict";function r(e,t){return s.resolve(e,t)}function i(e){return u.readFileSync(e).toString()}function a(e){return s.dirname(e)}function o(e){return u.existsSync(e)}var s=n(15),u=n(193);t.resolve=r,t.readFileSync=i,t.dirname=a,t.existsSync=o},function(e,t,n){"use strict";function r(e){if(null===e)return!1;var t;return t=s.exec(e),null===t?!1:!0}function i(e){var t,n,r,i,a,o,u,l,p,c,f=0,d=null;if(t=s.exec(e),null===t)throw new Error("Date resolve error");if(n=+t[1],r=+t[2]-1,i=+t[3],!t[4])return new Date(Date.UTC(n,r,i));if(a=+t[4],o=+t[5],u=+t[6],t[7]){for(f=t[7].slice(0,3);f.length<3;)f+="0";f=+f}return t[9]&&(l=+t[10],p=+(t[11]||0),d=6e4*(60*l+p),"-"===t[9]&&(d=-d)),c=new Date(Date.UTC(n,r,i,a,o,u,f)),d&&c.setTime(c.getTime()-d),c}function a(e){return e.toISOString()}var o=n(194),s=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");e.exports=new o("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:r,construct:i,instanceOf:Date,represent:a})},function(e,t,n){"use strict";function r(e){return"<<"===e||null===e}var i=n(194);e.exports=new i("tag:yaml.org,2002:merge",{kind:"scalar",resolve:r})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;var t,n,r=0,i=e.length,a=l;for(n=0;i>n;n++)if(t=a.indexOf(e.charAt(n)),!(t>64)){if(0>t)return!1;r+=6}return r%8===0}function i(e){var t,n,r=e.replace(/[\r\n=]/g,""),i=r.length,a=l,o=0,u=[];for(t=0;i>t;t++)t%4===0&&t&&(u.push(o>>16&255),u.push(o>>8&255),u.push(255&o)),o=o<<6|a.indexOf(r.charAt(t));return n=i%4*6,0===n?(u.push(o>>16&255),u.push(o>>8&255),u.push(255&o)):18===n?(u.push(o>>10&255),u.push(o>>2&255)):12===n&&u.push(o>>4&255),s?new s(u):u}function a(e){var t,n,r="",i=0,a=e.length,o=l;for(t=0;a>t;t++)t%3===0&&t&&(r+=o[i>>18&63],r+=o[i>>12&63],r+=o[i>>6&63],r+=o[63&i]),i=(i<<8)+e[t];return n=a%3,0===n?(r+=o[i>>18&63],r+=o[i>>12&63],r+=o[i>>6&63],r+=o[63&i]):2===n?(r+=o[i>>10&63],r+=o[i>>4&63],r+=o[i<<2&63],r+=o[64]):1===n&&(r+=o[i>>2&63],r+=o[i<<4&63],r+=o[64],r+=o[64]),r}function o(e){return s&&s.isBuffer(e)}var s=n(97).Buffer,u=n(194),l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";e.exports=new u("tag:yaml.org,2002:binary",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a})},function(e,t,n){"use strict";function r(e){if(null===e)return!0;var t,n,r,i,a,u=[],l=e;for(t=0,n=l.length;n>t;t+=1){if(r=l[t],a=!1,"[object Object]"!==s.call(r))return!1;for(i in r)if(o.call(r,i)){if(a)return!1;a=!0}if(!a)return!1;if(-1!==u.indexOf(i))return!1;
u.push(i)}return!0}function i(e){return null!==e?e:[]}var a=n(194),o=Object.prototype.hasOwnProperty,s=Object.prototype.toString;e.exports=new a("tag:yaml.org,2002:omap",{kind:"sequence",resolve:r,construct:i})},function(e,t,n){"use strict";function r(e){if(null===e)return!0;var t,n,r,i,a,s=e;for(a=new Array(s.length),t=0,n=s.length;n>t;t+=1){if(r=s[t],"[object Object]"!==o.call(r))return!1;if(i=Object.keys(r),1!==i.length)return!1;a[t]=[i[0],r[i[0]]]}return!0}function i(e){if(null===e)return[];var t,n,r,i,a,o=e;for(a=new Array(o.length),t=0,n=o.length;n>t;t+=1)r=o[t],i=Object.keys(r),a[t]=[i[0],r[i[0]]];return a}var a=n(194),o=Object.prototype.toString;e.exports=new a("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:r,construct:i})},function(e,t,n){"use strict";function r(e){if(null===e)return!0;var t,n=e;for(t in n)if(o.call(n,t)&&null!==n[t])return!1;return!0}function i(e){return null!==e?e:{}}var a=n(194),o=Object.prototype.hasOwnProperty;e.exports=new a("tag:yaml.org,2002:set",{kind:"mapping",resolve:r,construct:i})},function(e,t,n){"use strict";function r(){return!0}function i(){return void 0}function a(){return""}function o(e){return"undefined"==typeof e}var s=n(194);e.exports=new s("tag:yaml.org,2002:js/undefined",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;if(0===e.length)return!1;var t=e,n=/\/([gim]*)$/.exec(e),r="";if("/"===t[0]){if(n&&(r=n[1]),r.length>3)return!1;if("/"!==t[t.length-r.length-1])return!1;t=t.slice(1,t.length-r.length-1)}try{new RegExp(t,r);return!0}catch(i){return!1}}function i(e){var t=e,n=/\/([gim]*)$/.exec(e),r="";return"/"===t[0]&&(n&&(r=n[1]),t=t.slice(1,t.length-r.length-1)),new RegExp(t,r)}function a(e){var t="/"+e.source+"/";return e.global&&(t+="g"),e.multiline&&(t+="m"),e.ignoreCase&&(t+="i"),t}function o(e){return"[object RegExp]"===Object.prototype.toString.call(e)}var s=n(194);e.exports=new s("tag:yaml.org,2002:js/regexp",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a})},function(e,t,n){"use strict";var r=n(202),i=n(203),a=n(204);e.exports={formats:a,parse:i,stringify:r}},function(e,t,n){e.exports=/[^\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]+/g},function(e,t,n){e.exports=/([\u0061-\u007A\u00B5\u00DF-\u00F6\u00F8-\u00FF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0561-\u0587\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7FA\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A])([\u0041-\u005A\u00C0-\u00D6\u00D8-\u00DE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA\uFF21-\uFF3A\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},function(e,t,n){e.exports=/([\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])([^\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},function(e,t,n){if("undefined"==typeof __WEBPACK_EXTERNAL_MODULE_176__){var r=new Error('Cannot find module "RAML.JsonValidation"');throw r.code="MODULE_NOT_FOUND",r}e.exports=__WEBPACK_EXTERNAL_MODULE_176__},function(e,t,n){if("undefined"==typeof __WEBPACK_EXTERNAL_MODULE_177__){var r=new Error('Cannot find module "RAML.XmlValidation"');throw r.code="MODULE_NOT_FOUND",r}e.exports=__WEBPACK_EXTERNAL_MODULE_177__},function(e,t,n){t.read=function(e,t,n,r,i){var a,o,s=8*i-r-1,u=(1<<s)-1,l=u>>1,p=-7,c=n?i-1:0,f=n?-1:1,d=e[t+c];for(c+=f,a=d&(1<<-p)-1,d>>=-p,p+=s;p>0;a=256*a+e[t+c],c+=f,p-=8);for(o=a&(1<<-p)-1,a>>=-p,p+=r;p>0;o=256*o+e[t+c],c+=f,p-=8);if(0===a)a=1-l;else{if(a===u)return o?NaN:(d?-1:1)*(1/0);o+=Math.pow(2,r),a-=l}return(d?-1:1)*o*Math.pow(2,a-r)},t.write=function(e,t,n,r,i,a){var o,s,u,l=8*a-i-1,p=(1<<l)-1,c=p>>1,f=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=r?0:a-1,m=r?1:-1,h=0>t||0===t&&0>1/t?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,o=p):(o=Math.floor(Math.log(t)/Math.LN2),t*(u=Math.pow(2,-o))<1&&(o--,u*=2),t+=o+c>=1?f/u:f*Math.pow(2,1-c),t*u>=2&&(o++,u/=2),o+c>=p?(s=0,o=p):o+c>=1?(s=(t*u-1)*Math.pow(2,i),o+=c):(s=t*Math.pow(2,c-1)*Math.pow(2,i),o=0));i>=8;e[n+d]=255&s,d+=m,s/=256,i-=8);for(o=o<<i|s,l+=i;l>0;e[n+d]=255&o,d+=m,o/=256,l-=8);e[n+d-m]|=128*h}},function(e,t,n){var r={}.toString;e.exports=Array.isArray||function(e){return"[object Array]"==r.call(e)}},function(e,t,n){"use strict";var r=function(){function e(e,t){function n(){this.constructor=e}n.prototype=t.prototype,e.prototype=new n}function t(e,n,r,i){this.message=e,this.expected=n,this.found=r,this.location=i,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,t)}function n(e){function n(t){var n,r,i=$[t];if(i)return i;for(n=t-1;!$[n];)n--;for(i=$[n],i={line:i.line,column:i.column,seenCR:i.seenCR};t>n;)r=e.charAt(n),"\n"===r?(i.seenCR||i.line++,i.column=1,i.seenCR=!1):"\r"===r||"\u2028"===r||"\u2029"===r?(i.line++,i.column=1,i.seenCR=!0):(i.column++,i.seenCR=!1),n++;return $[t]=i,i}function r(e,t){var r=n(e),i=n(t);return{start:{offset:e,line:r.line,column:r.column},end:{offset:t,line:i.line,column:i.column}}}function i(e){G>Y||(Y>G&&(G=Y,X=[]),X.push(e))}function a(e,n,r,i){function a(e){var t=1;for(e.sort(function(e,t){return e.description<t.description?-1:e.description>t.description?1:0});t<e.length;)e[t-1]===e[t]?e.splice(t,1):t++}function o(e,t){function n(e){function t(e){return e.charCodeAt(0).toString(16).toUpperCase()}return e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+t(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+t(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+t(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+t(e)})}var r,i,a,o=new Array(e.length);for(a=0;a<e.length;a++)o[a]=e[a].description;return r=e.length>1?o.slice(0,-1).join(", ")+" or "+o[e.length-1]:o[0],i=t?'"'+n(t)+'"':"end of input","Expected "+r+" but "+i+" found."}return null!==n&&a(n),new t(null!==e?e:o(n,r),n,r,i)}function o(){var t,n,r,a,u,p,c,f;return t=Y,n=l(),n!==d?(r=s(),r!==d?(a=Y,u=l(),u!==d?(124===e.charCodeAt(Y)?(p=y,Y++):(p=d,0===z&&i(v)),p!==d?(c=l(),c!==d?(f=o(),f!==d?(u=[u,p,c,f],a=u):(Y=a,a=d)):(Y=a,a=d)):(Y=a,a=d)):(Y=a,a=d),a===d&&(a=null),a!==d?(H=t,n=g(r,a),t=n):(Y=t,t=d)):(Y=t,t=d)):(Y=t,t=d),t}function s(){var t,n,r,a,s,p,c,f,m,h;if(t=Y,40===e.charCodeAt(Y)?(n=A,Y++):(n=d,0===z&&i(S)),n!==d)if(r=l(),r!==d)if(a=o(),a!==d)if(s=l(),s!==d)if(41===e.charCodeAt(Y)?(p=E,Y++):(p=d,0===z&&i(T)),p!==d){for(c=[],f=Y,m=l(),m!==d?(e.substr(Y,2)===b?(h=b,Y+=2):(h=d,0===z&&i(N)),h!==d?(m=[m,h],f=m):(Y=f,f=d)):(Y=f,f=d);f!==d;)c.push(f),f=Y,m=l(),m!==d?(e.substr(Y,2)===b?(h=b,Y+=2):(h=d,0===z&&i(N)),h!==d?(m=[m,h],f=m):(Y=f,f=d)):(Y=f,f=d);c!==d?(H=t,n=_(a,c),t=n):(Y=t,t=d)}else Y=t,t=d;else Y=t,t=d;else Y=t,t=d;else Y=t,t=d;else Y=t,t=d;return t===d&&(t=u()),t}function u(){var t,n,r,a,o,s;if(z++,t=Y,n=[],r=p(),r!==d)for(;r!==d;)n.push(r),r=p();else n=d;if(n!==d){for(r=[],a=Y,o=l(),o!==d?(e.substr(Y,2)===b?(s=b,Y+=2):(s=d,0===z&&i(N)),s!==d?(o=[o,s],a=o):(Y=a,a=d)):(Y=a,a=d);a!==d;)r.push(a),a=Y,o=l(),o!==d?(e.substr(Y,2)===b?(s=b,Y+=2):(s=d,0===z&&i(N)),s!==d?(o=[o,s],a=o):(Y=a,a=d)):(Y=a,a=d);r!==d?(H=t,n=M(n,r),t=n):(Y=t,t=d)}else Y=t,t=d;return z--,t===d&&(n=d,0===z&&i(w)),t}function l(){var t,n;for(z++,t=[],R.test(e.charAt(Y))?(n=e.charAt(Y),Y++):(n=d,0===z&&i(C));n!==d;)t.push(n),R.test(e.charAt(Y))?(n=e.charAt(Y),Y++):(n=d,0===z&&i(C));return z--,t===d&&(n=d,0===z&&i(I)),t}function p(){var t;return L.test(e.charAt(Y))?(t=e.charAt(Y),Y++):(t=d,0===z&&i(P)),t===d&&(95===e.charCodeAt(Y)?(t=O,Y++):(t=d,0===z&&i(D)),t===d&&(45===e.charCodeAt(Y)?(t=x,Y++):(t=d,0===z&&i(U)),t===d&&(46===e.charCodeAt(Y)?(t=k,Y++):(t=d,0===z&&i(F)),t===d&&(B.test(e.charAt(Y))?(t=e.charAt(Y),Y++):(t=d,0===z&&i(K)),t===d&&(V.test(e.charAt(Y))?(t=e.charAt(Y),Y++):(t=d,0===z&&i(j)),t===d&&(63===e.charCodeAt(Y)?(t=W,Y++):(t=d,0===z&&i(q)))))))),t}var c,f=arguments.length>1?arguments[1]:{},d={},m={Term:o},h=o,y="|",v={type:"literal",value:"|",description:'"|"'},g=function(e,t){return t?{type:"union",first:e,rest:t[3]}:e},A="(",S={type:"literal",value:"(",description:'"("'},E=")",T={type:"literal",value:")",description:'")"'},b="[]",N={type:"literal",value:"[]",description:'"[]"'},_=function(e,t){return{type:"parens",expr:e,arr:t.length}},w={type:"other",description:"name"},M=function(e,t){return{type:"name",value:e.join(""),arr:t.length}},I={type:"other",description:"whitespace"},R=/^[ \t\n\r]/,C={type:"class",value:"[ \\t\\n\\r]",description:"[ \\t\\n\\r]"},L=/^[A-Z]/,P={type:"class",value:"[A-Z]",description:"[A-Z]"},O="_",D={type:"literal",value:"_",description:'"_"'},x="-",U={type:"literal",value:"-",description:'"-"'},k=".",F={type:"literal",value:".",description:'"."'},B=/^[a-z:#\/]/,K={type:"class",value:"[a-z]",description:"[a-z]"},V=/^[0-9]/,j={type:"class",value:"[0-9]",description:"[0-9]"},W="?",q={type:"literal",value:"?",description:'"?"'},Y=0,H=0,$=[{line:1,column:1,seenCR:!1}],G=0,X=[],z=0;if("startRule"in f){if(!(f.startRule in m))throw new Error("Can't start parsing from rule \""+f.startRule+'".');h=m[f.startRule]}if(c=h(),c!==d&&Y===e.length)return c;throw c!==d&&Y<e.length&&i({type:"end",description:"end of input"}),a(null,X,G<e.length?e.charAt(G):null,G<e.length?r(G,G+1):r(G,G))}return e(t,Error),{SyntaxError:t,parse:n}}();e.exports=r},function(e,t,n){function r(){i.call(this)}e.exports=r;var i=n(211).EventEmitter,a=n(229);a(r,i),r.Readable=n(222),r.Writable=n(223),r.Duplex=n(224),r.Transform=n(225),r.PassThrough=n(226),r.Stream=r,r.prototype.pipe=function(e,t){function n(t){e.writable&&!1===e.write(t)&&l.pause&&l.pause()}function r(){l.readable&&l.resume&&l.resume()}function a(){p||(p=!0,e.end())}function o(){p||(p=!0,"function"==typeof e.destroy&&e.destroy())}function s(e){if(u(),0===i.listenerCount(this,"error"))throw e}function u(){l.removeListener("data",n),e.removeListener("drain",r),l.removeListener("end",a),l.removeListener("close",o),l.removeListener("error",s),e.removeListener("error",s),l.removeListener("end",u),l.removeListener("close",u),e.removeListener("close",u)}var l=this;l.on("data",n),e.on("drain",r),e._isStdio||t&&t.end===!1||(l.on("end",a),l.on("close",o));var p=!1;return l.on("error",s),e.on("error",s),l.on("end",u),l.on("close",u),e.on("close",u),e.emit("pipe",l),e}},function(e,t,n){e.exports={12:{code:"12",message:""},24:{code:"24",message:""},25:{code:"25",message:""},SCHEMA_AND_TYPE:{code:"SCHEMA_AND_TYPE",message:"'schema' and 'type' are mutually exclusive"},REQUIRED_OVERRIDE_OPTIONAL:{code:"REQUIRED_OVERRIDE_OPTIONAL",message:"Can not override required property '{{propertyName}}' to be optional"},CYCLIC_DEPENDENCY:{code:"CYCLIC_DEPENDENCY",message:"'{{typeName}}' has cyclic dependency"},REDEFINIG_BUILDTIN:{code:"REDEFINIG_BUILDTIN",message:"Redefining a built in type: {{typeName}}"},RECURRENT_DEFINITION:{code:"RECURRENT_DEFINITION",message:"Recurrent type definition"},INHERITING_UNKNOWN_TYPE:{code:"INHERITING_UNKNOWN_TYPE",message:"Inheriting from unknown type"},RECURRENT_UNION_OPTION:{code:"RECURRENT_UNION_OPTION",message:"Recurrent type as an option of union type"},UNKNOWN_UNION_OPTION:{code:"UNKNOWN_UNION_OPTION",message:"Unknown type as an option of union type"},RECURRENT_ARRAY_DEFINITION:{code:"RECURRENT_ARRAY_DEFINITION",message:"Recurrent array type definition"},UNKNOWN_ARRAY_COMPONENT:{code:"UNKNOWN_ARRAY_COMPONENT",message:"Referring to unknown type '{{componentTypeName}}' as an array component type"},EXTERNALS_MIX:{code:"EXTERNALS_MIX",message:"It is not allowed to mix RAML types with externals"},EXTERNAL_FACET:{code:"EXTERNAL_FACET",message:"External types can not declare facet '{{name}}'"},OVERRIDE_FACET:{code:"OVERRIDE_FACET",message:"Facet '{{name}}' can not be overriden"},OVERRIDE_BUILTIN_FACET:{code:"OVERRIDE_BUILTIN_FACET",message:"Built in facet '{{name}}' can not be overriden"},FACET_START_BRACKET:{code:"FACET_START_BRACKET",message:"Facet '{{name}}' can not start from '('"},FACET_PROHIBITED_FOR_EXTERNALS:{code:"FACET_PROHIBITED_FOR_EXTERNALS",message:"'{{facetName}}' facet is prohibited for external types"},UNKNOWN_FACET:{code:"UNKNOWN_FACET",message:"Specifying unknown facet: '{{facetName}}'"},MISSING_REQUIRED_FACETS:{code:"MISSING_REQUIRED_FACETS",message:"Missing required facets: {{facetsList}}"},OBJECT_EXPECTED:{code:"OBJECT_EXPECTED",message:"object is expected"},NULL_NOT_ALLOWED:{code:"NULL_NOT_ALLOWED",message:"Null or undefined value is not allowed"},DISCRIMINATOR_NEEDED:{code:"DISCRIMINATOR_NEEDED",message:"Can not discriminate types '{{name1}}' and '{{name2}}' without discriminator"},SAME_DISCRIMINATOR_VALUE:{code:"SAME_DISCRIMINATOR_VALUE",message:"Types '{{name1}}' and '{{name2}}' have same discriminator value"},NOTHING:{code:"NOTHING",message:"nothing"},TYPE_EXPECTED:{code:"TYPE_EXPECTED",message:"{{typeName}} is expected"},INTEGER_EXPECTED:{code:"INTEGER_EXPECTED",message:"integer is expected"},NULL_EXPECTED:{code:"NULL_EXPECTED",message:"null is expected"},SCALAR_EXPECTED:{code:"SCALAR_EXPECTED",message:"scalar is expected"},INCORRECT_DISCRIMINATOR:{code:"INCORRECT_DISCRIMINATOR",message:"None of the '{{rootType}}' type known subtypes declare '{{value}}' as value of discriminating property '{{propName}}'."},MISSING_DISCRIMINATOR:{code:"MISSING_DISCRIMINATOR",message:"Instance of '{{rootType}}' subtype misses value of the discriminating property '{{propName}}'."},INVALID_DATEONLY:{code:"INVALID_DATEONLY",message:"'date-only' instance should match 'yyyy-mm-dd' pattern"},INVALID_TIMEONLY:{code:"INVALID_TIMEONLY",message:"'time-only' instance should match 'hh:mm:ss[.ff...]' pattern"},INVALID_DATETIMEONLY:{code:"INVALID_DATETIMEONLY",message:"'datetime-only' instance should match 'yyyy-mm-ddThh:mm:ss[.ff...]' pattern"},INVALID_RFC3339:{code:"INVALID_RFC3339",message:"Valid rfc3339 formatted string is expected"},INVALID_RFC2616:{code:"INVALID_RFC2616",message:"Valid rfc2616 formatted string is expected"},INVALID_DATTIME:{code:"INVALID_DATTIME",message:"Valid datetime formatted string is expected"},UNKNOWN_ANNOTATION:{code:"UNKNOWN_ANNOTATION",message:"Using unknown annotation type: '{{facetName}}'"},INVALID_ANNOTATION_VALUE:{code:"INVALID_ANNOTATION_VALUE",message:"Invalid annotation value {{msg}}"},CAN_NOT_PARSE_JSON:{code:"CAN_NOT_PARSE_JSON",message:"Can not parse JSON example: {{msg}}"},INVALID_XML:{code:"INVALID_XML",message:"Invalid XML."},STRICT_BOOLEAN:{code:"STRICT_BOOLEAN",message:"'strict' should be boolean"},DISPLAY_NAME_STRING:{code:"DISPLAY_NAME_STRING",message:"'displayName' should be string"},DESCRIPTION_STRING:{code:"DESCRIPTION_STRING",message:"'description' should be string"},INVALID_EXMAPLE:{code:"INVALID_EXMAPLE",message:"Using invalid 'example': {{msg}}"},ADDITIONAL_PROPERTIES_BOOLEAN:{code:"REQUIRED_BOOLEAN",message:"Value of 'additionalProperties' facet should be boolean"},REQUIRED_BOOLEAN:{code:"REQUIRED_BOOLEAN",message:"Value of 'required' facet should be boolean"},UNIQUE_ITEMS_BOOLEAN:{code:"UNIQUE_ITEMS_BOOLEAN",message:"Value of 'uniqueItems' facet should be boolean"},EXMAPLES_MAP:{code:"EXMAPLES_MAP",message:"'examples' value should be a map"},INVALID_DEFAULT_VALUE:{code:"INVALID_DEFAULT_VALUE",message:"Using invalid 'defaultValue': {{msg}}"},DISCRIMINATOR_FOR_UNION:{code:"DISCRIMINATOR_FOR_UNION",message:"You can not specify 'discriminator' for union types"},DISCRIMINATOR_FOR_OBJECT:{code:"DISCRIMINATOR_FOR_OBJECT",message:"You only can use 'discriminator' with object types"},DISCRIMINATOR_FOR_INLINE:{code:"DISCRIMINATOR_FOR_INLINE",message:"You can not specify 'discriminator' for inline type declarations"},UNKNOWN_FOR_DISCRIMINATOR:{code:"UNKNOWN_FOR_DISCRIMINATOR",message:"Using unknown property '{{value}}' as discriminator"},SCALAR_FOR_DISCRIMINATOR:{code:"SCALAR_FOR_DISCRIMINATOR",message:"It is only allowed to use scalar properties as discriminators"},DISCRIMINATOR_VALUE_WITHOUT_DISCRIMINATOR:{code:"DISCRIMINATOR_VALUE_WITHOUT_DISCRIMINATOR",message:"You can not use 'discriminatorValue' without declaring 'discriminator'"},INVALID_DISCRIMINATOR_VALUE:{code:"INVALID_DISCRIMINATOR_VALUE",message:"Using invalid 'disciminatorValue': {{msg}}"},PROPERTIES_MAP:{code:"PROPERTIES_MAP",message:"'properties' should be a map"},FACETS_MAP:{code:"FACETS_MAP",message:"'facets' should be a map"},VALIDATING_AGAINS_UNKNOWN:{code:"VALIDATING_AGAINS_UNKNOWN",message:"Validating instance against unknown type: '{{typeName}}'"},EXTERNAL_IN_PROPERTY_DEFINITION:{code:"EXTERNAL_IN_PROPERTY_DEFINITION",message:"It is not allowed to use external types in property definitions"},UNKNOWN_IN_PROPERTY_DEFINITION:{code:"UNKNOWN_IN_PROPERTY_DEFINITION",message:"Property '{{propName}}' refers to unknown type '{{typeName}}'"},ERROR_IN_RANGE:{code:"ERROR_IN_RANGE",message:"Property '{{propName}}' range type has error: {{msg}}"},INCORRECT_SCHEMA:{code:"INCORRECT_SCHEMA",message:"Incorrect schema: {{msg}}"},UNABLE_TO_VALIDATE_XML:{code:"UNABLE_TO_VALIDATE_XML",message:"Unable to validate example against schema (xmllint)"},CIRCULAR_REFS_IN_JSON_SCHEMA:{code:"CIRCULAR_REFS_IN_JSON_SCHEMA",message:"JSON schema contains circular references"},EXAMPLE_SCHEMA_FAILURE:{code:"EXAMPLE_SCHEMA_FAILURE",message:"Example does not conform to schema: {{msg}}"},JOSN_EXAMPLE_VALIDATION_EXCEPTION:{code:"JOSN_EXAMPLE_VALIDATION_EXCEPTION",message:"Validating example against schema caused an exception: {{msg}}"
},UNKNOWN_PROPERTY:{code:"UNKNOWN_PROPERTY",message:"Unknown property: '{{propName}}'"},REQUIRED_PROPERTY_MISSING:{code:"REQUIRED_PROPERTY_MISSING",message:"Required property '{{propName}}' is missing"},INVALID_REGEXP:{code:"INVALID_REGEXP",message:"{{msg}}"},FACET_USAGE_RESTRICTION:{code:"FACET_USAGE_RESTRICTION",message:"{{facetName}} facet can only be used with {{typeNames}} types"},FACET_REQUIRE_NUMBER:{code:"FACET_REQUIRE_NUMBER",message:"'{{facetName}}' value should be a number"},FACET_REQUIRE_INTEGER:{code:"FACET_REQUIRE_INTEGER",message:"'{{facetName}}' value should be an integer"},MIN_VALUE:{code:"MIN_VALUE",message:"'{{facetName}}' value should be at least {{minValue}}"},EVEN_RATIO:{code:"EVEN_RATIO",message:"result of division of {{val1}} on {{val2}} should be integer"},MUST_BE_UNIQUE:{code:"MUST_BE_UNIQUE",message:"items should be unique"},ARRAY_AGAINST_UNKNOWN:{code:"ARRAY_AGAINST_UNKNOWN",message:"Array instance is validated against unknown type: '{{typeName}}'"},INVALID_COMPONENT_TYPE:{code:"INVALID_COMPONENT_TYPE",message:"Component type has error: {{msg}}"},EXTERNAL_AS_COMPONENT:{code:"EXTERNAL_AS_COMPONENT",message:"It is not allowed to use external types in component type definitions"},UNKNOWN_AS_COMPONENT:{code:"UNKNOWN_AS_COMPONENT",message:"Component refers to unknown type {{typeName}}"},PATTERN_VIOLATION:{code:"PATTERN_VIOLATION",message:"String should match to '{{value}}'"},ALLOWED_FORMAT_VALUES:{code:"ALLOWED_FORMAT_VALUES",message:"Following format values are allowed: {{allowedValues}}"},ENUM_RESTRICTION:{code:"ENUM_RESTRICTION",message:"value should be one of: {{values}}"},ENUM_OWNER_TYPES:{code:"ENUM_OWNER_TYPES",message:"'enum' facet can only be used with: {{typeNames}}"},ENUM_ARRAY:{code:"ENUM_ARRAY",message:"'enum' facet value must be defined by array"},RESTRICTIONS_CONFLICT:{code:"RESTRICTIONS_CONFLICT",message:null},MINMAX_RESTRICTION_VIOLATION:{code:"MINMAX_RESTRICTION_VIOLATION",message:null},UNION_TYPE_FAILURE:{code:"UNION_TYPE_FAILURE",message:"Union type options do not pass validation"},UNION_TYPE_FAILURE_DETAILS:{code:"UNION_TYPE_FAILURE_DETAILS",message:"Union type option does not pass validation ({{msg}})"},INVALID_JSON_SCHEMA_DETAILS:{code:"INVALID_JSON_SCHEMA_DETAILS",message:"Invalid JSON schema: {{msg}}"},INVALID_JSON_SCHEMA:{code:"INVALID_JSON_SCHEMA",message:"Invalid JSON schema"},JSON_SCHEMA_VALIDATION_EXCEPTION:{code:"JSON_SCHEMA_VALIDATION_EXCEPTION",message:"Schema validation exception: {{msg}}"},REFERENCE_NOT_FOUND:{code:"REFERENCE_NOT_FOUND",message:"Reference not found: {{ref}}"},INVALID_XML_SCHEMA:{code:"INVALID_XML_SCHEMA",message:"Invalid XML schema content"},INVALID_ANNOTATION_LOCATION:{code:"INVALID_ANNOTATION_LOCATION",message:"Annotation '{{aName}}' can not be placed at this location, allowed targets are: {{aValues}}"},CONTENT_DOES_NOT_MATCH_THE_SCHEMA:{code:"CONTENT_DOES_NOT_MATCH_THE_SCHEMA",message:"Content is not valid according to schema: {{msg}}"},EXTERNAL_TYPE_ERROR:{code:"EXTERNAL_TYPE_ERROR",message:"Referenced type '{{typeName}}' does not match '{{objectName}}' root node"},CAN_NOT_PARSE_SCHEMA:{code:"CAN_NOT_PARSE_SCHEMA",message:"Can not parse schema"},FILE_TYPES_SHOULD_BE_AN_ARRAY:{code:"FILE_TYPES_SHOULD_BE_AN_ARRAY",message:"'fileTypes' value should be an array of strings"},FACET_CAN_NOT_BE_FIXED_BY_THE_DECLARING_TYPE:{code:"FACET_CAN_NOT_BE_FIXED_BY_THE_DECLARING_TYPE",message:"A facet  can not be fixed by the declaring type"},ITEMS_SHOULD_BE_REFERENCE_OR_INLINE_TYPE:{code:"ITEMS_SHOULD_BE_REFERENCE_OR_INLINE_TYPE",message:"The 'items' property value should be either a reference to an existing type or an inline type declaration"},VALUE_SHOULD_BE_POSITIVE:{code:"VALUE_SHOULD_BE_POSITIVE",message:"Value of the '{{facetName}}' facet should be positive"}}},function(e,t,n){function r(e){this.options=e||{locator:{}}}function i(e,t,n){function r(t){var r=e[t];!r&&o&&(r=2==e.length?function(n){e(t,n)}:e),i[t]=r&&function(e){r("[xmldom "+t+"]	"+e+s(n))}||function(){}}if(!e){if(t instanceof a)return t;e=t}var i={},o=e instanceof Function;return n=n||{},r("warning"),r("error"),r("fatalError"),i}function a(){this.cdata=!1}function o(e,t){t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber}function s(e){return e?"\n@"+(e.systemId||"")+"#[line:"+e.lineNumber+",col:"+e.columnNumber+"]":void 0}function u(e,t,n){return"string"==typeof e?e.substr(t,n):e.length>=t+n||t?new java.lang.String(e,t,n)+"":e}function l(e,t){e.currentElement?e.currentElement.appendChild(t):e.document.appendChild(t)}r.prototype.parseFromString=function(e,t){var n=this.options,r=new p,o=n.domBuilder||new a,s=n.errorHandler,u=n.locator,l=n.xmlns||{},c={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return u&&o.setDocumentLocator(u),r.errorHandler=i(s,o,u),r.domBuilder=n.domBuilder||o,/\/x?html?$/.test(t)&&(c.nbsp=" ",c.copy="©",l[""]="http://www.w3.org/1999/xhtml"),l.xml=l.xml||"http://www.w3.org/XML/1998/namespace",e?r.parse(e,l,c):r.errorHandler.error("invalid document source"),o.document},a.prototype={startDocument:function(){this.document=(new c).createDocument(null,null,null),this.locator&&(this.document.documentURI=this.locator.systemId)},startElement:function(e,t,n,r){var i=this.document,a=i.createElementNS(e,n||t),s=r.length;l(this,a),this.currentElement=a,this.locator&&o(this.locator,a);for(var u=0;s>u;u++){var e=r.getURI(u),p=r.getValue(u),n=r.getQName(u),c=i.createAttributeNS(e,n);c.getOffset&&o(c.getOffset(1),c),c.value=c.nodeValue=p,a.setAttributeNode(c)}},endElement:function(e,t,n){var r=this.currentElement;r.tagName;this.currentElement=r.parentNode},startPrefixMapping:function(e,t){},endPrefixMapping:function(e){},processingInstruction:function(e,t){var n=this.document.createProcessingInstruction(e,t);this.locator&&o(this.locator,n),l(this,n)},ignorableWhitespace:function(e,t,n){},characters:function(e,t,n){if(e=u.apply(this,arguments),this.currentElement&&e){if(this.cdata){var r=this.document.createCDATASection(e);this.currentElement.appendChild(r)}else{var r=this.document.createTextNode(e);this.currentElement.appendChild(r)}this.locator&&o(this.locator,r)}},skippedEntity:function(e){},endDocument:function(){this.document.normalize()},setDocumentLocator:function(e){(this.locator=e)&&(e.lineNumber=0)},comment:function(e,t,n){e=u.apply(this,arguments);var r=this.document.createComment(e);this.locator&&o(this.locator,r),l(this,r)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(e,t,n){var r=this.document.implementation;if(r&&r.createDocumentType){var i=r.createDocumentType(e,t,n);this.locator&&o(this.locator,i),l(this,i)}},warning:function(e){console.warn("[xmldom warning]	"+e,s(this.locator))},error:function(e){console.error("[xmldom error]	"+e,s(this.locator))},fatalError:function(e){throw console.error("[xmldom fatalError]	"+e,s(this.locator)),e}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(e){a.prototype[e]=function(){return null}});var p=n(206).XMLReader,c=t.DOMImplementation=n(207).DOMImplementation;t.XMLSerializer=n(207).XMLSerializer,t.DOMParser=r},function(e,t,n){(function(){function t(e,t){Array.isArray(e)||(e=[e]);for(var n=!!t,r=[],i=0;i<e.length;i++){var a=e[i];"object"==typeof a?(r.push(a),n=!0):r.push({type:a})}return n&&r}function n(e){if(e.type)if("string"!=typeof e.type){var r=t(e.type);r&&(e.anyOf=r,delete e.type)}else"any"==e.type&&delete e.type;if(e["extends"]){var i=e["extends"];Array.isArray(i)||(i=[i]),e.allOf=i,delete e["extends"]}if(e.disallow&&("string"==typeof e.disallow?e.not={type:e.disallow}:e.not={anyOf:t(e.disallow,!0)},delete e.disallow),e.properties){var a=Array.isArray(e.required)?e.required:[];for(var o in e.properties){var s=e.properties[o];s&&"boolean"==typeof s.required&&(s.required&&a.push(o),delete s.required)}a.length&&(e.required=a)}if(e.dependencies)for(var o in e.dependencies)"string"==typeof e.dependencies[o]&&(e.dependencies[o]=[e.dependencies[o]]);"boolean"==typeof e.required&&delete e.required,"undefined"!=typeof e.divisibleBy&&(e.multipleOf=e.divisibleBy,delete e.divisibleBy);for(var o in e)if("properties"===o||"patternProperties"===o||"dependencies"===o)for(var u in e[o])e[o][u]=n(e[o][u]);else if("enum"!==o)if(Array.isArray(e[o]))for(var l=0;l<e[o].length;l++)e[o][l]=n(e[o][l]);else"object"==typeof e[o]&&(e[o]=n(e[o]));return e}var r={v4:n};return e.exports=r,r})()},function(e,t,n){var r,i;(function(){function n(e){function t(t,n,r,i,a,o){for(;a>=0&&o>a;a+=e){var s=i?i[a]:a;r=n(r,t[s],s,t)}return r}return function(n,r,i,a){r=b(r,a,4);var o=!C(n)&&T.keys(n),s=(o||n).length,u=e>0?0:s-1;return arguments.length<3&&(i=n[o?o[u]:u],u+=e),t(n,r,i,o,u,s)}}function a(e){return function(t,n,r){n=N(n,r);for(var i=R(t),a=e>0?0:i-1;a>=0&&i>a;a+=e)if(n(t[a],a,t))return a;return-1}}function o(e,t,n){return function(r,i,a){var o=0,s=R(r);if("number"==typeof a)e>0?o=a>=0?a:Math.max(a+s,o):s=a>=0?Math.min(a+1,s):a+s+1;else if(n&&a&&s)return a=n(r,i),r[a]===i?a:-1;if(i!==i)return a=t(m.call(r,o,s),T.isNaN),a>=0?a+o:-1;for(a=e>0?o:s-1;a>=0&&s>a;a+=e)if(r[a]===i)return a;return-1}}function s(e,t){var n=x.length,r=e.constructor,i=T.isFunction(r)&&r.prototype||c,a="constructor";for(T.has(e,a)&&!T.contains(t,a)&&t.push(a);n--;)a=x[n],a in e&&e[a]!==i[a]&&!T.contains(t,a)&&t.push(a)}var u=this,l=u._,p=Array.prototype,c=Object.prototype,f=Function.prototype,d=p.push,m=p.slice,h=c.toString,y=c.hasOwnProperty,v=Array.isArray,g=Object.keys,A=f.bind,S=Object.create,E=function(){},T=function(e){return e instanceof T?e:this instanceof T?void(this._wrapped=e):new T(e)};"undefined"!=typeof e&&e.exports&&(t=e.exports=T),t._=T,T.VERSION="1.8.3";var b=function(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 2:return function(n,r){return e.call(t,n,r)};case 3:return function(n,r,i){return e.call(t,n,r,i)};case 4:return function(n,r,i,a){return e.call(t,n,r,i,a)}}return function(){return e.apply(t,arguments)}},N=function(e,t,n){return null==e?T.identity:T.isFunction(e)?b(e,t,n):T.isObject(e)?T.matcher(e):T.property(e)};T.iteratee=function(e,t){return N(e,t,1/0)};var _=function(e,t){return function(n){var r=arguments.length;if(2>r||null==n)return n;for(var i=1;r>i;i++)for(var a=arguments[i],o=e(a),s=o.length,u=0;s>u;u++){var l=o[u];t&&void 0!==n[l]||(n[l]=a[l])}return n}},w=function(e){if(!T.isObject(e))return{};if(S)return S(e);E.prototype=e;var t=new E;return E.prototype=null,t},M=function(e){return function(t){return null==t?void 0:t[e]}},I=Math.pow(2,53)-1,R=M("length"),C=function(e){var t=R(e);return"number"==typeof t&&t>=0&&I>=t};T.each=T.forEach=function(e,t,n){t=b(t,n);var r,i;if(C(e))for(r=0,i=e.length;i>r;r++)t(e[r],r,e);else{var a=T.keys(e);for(r=0,i=a.length;i>r;r++)t(e[a[r]],a[r],e)}return e},T.map=T.collect=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=Array(i),o=0;i>o;o++){var s=r?r[o]:o;a[o]=t(e[s],s,e)}return a},T.reduce=T.foldl=T.inject=n(1),T.reduceRight=T.foldr=n(-1),T.find=T.detect=function(e,t,n){var r;return r=C(e)?T.findIndex(e,t,n):T.findKey(e,t,n),void 0!==r&&-1!==r?e[r]:void 0},T.filter=T.select=function(e,t,n){var r=[];return t=N(t,n),T.each(e,function(e,n,i){t(e,n,i)&&r.push(e)}),r},T.reject=function(e,t,n){return T.filter(e,T.negate(N(t)),n)},T.every=T.all=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=0;i>a;a++){var o=r?r[a]:a;if(!t(e[o],o,e))return!1}return!0},T.some=T.any=function(e,t,n){t=N(t,n);for(var r=!C(e)&&T.keys(e),i=(r||e).length,a=0;i>a;a++){var o=r?r[a]:a;if(t(e[o],o,e))return!0}return!1},T.contains=T.includes=T.include=function(e,t,n,r){return C(e)||(e=T.values(e)),("number"!=typeof n||r)&&(n=0),T.indexOf(e,t,n)>=0},T.invoke=function(e,t){var n=m.call(arguments,2),r=T.isFunction(t);return T.map(e,function(e){var i=r?t:e[t];return null==i?i:i.apply(e,n)})},T.pluck=function(e,t){return T.map(e,T.property(t))},T.where=function(e,t){return T.filter(e,T.matcher(t))},T.findWhere=function(e,t){return T.find(e,T.matcher(t))},T.max=function(e,t,n){var r,i,a=-(1/0),o=-(1/0);if(null==t&&null!=e){e=C(e)?e:T.values(e);for(var s=0,u=e.length;u>s;s++)r=e[s],r>a&&(a=r)}else t=N(t,n),T.each(e,function(e,n,r){i=t(e,n,r),(i>o||i===-(1/0)&&a===-(1/0))&&(a=e,o=i)});return a},T.min=function(e,t,n){var r,i,a=1/0,o=1/0;if(null==t&&null!=e){e=C(e)?e:T.values(e);for(var s=0,u=e.length;u>s;s++)r=e[s],a>r&&(a=r)}else t=N(t,n),T.each(e,function(e,n,r){i=t(e,n,r),(o>i||i===1/0&&a===1/0)&&(a=e,o=i)});return a},T.shuffle=function(e){for(var t,n=C(e)?e:T.values(e),r=n.length,i=Array(r),a=0;r>a;a++)t=T.random(0,a),t!==a&&(i[a]=i[t]),i[t]=n[a];return i},T.sample=function(e,t,n){return null==t||n?(C(e)||(e=T.values(e)),e[T.random(e.length-1)]):T.shuffle(e).slice(0,Math.max(0,t))},T.sortBy=function(e,t,n){return t=N(t,n),T.pluck(T.map(e,function(e,n,r){return{value:e,index:n,criteria:t(e,n,r)}}).sort(function(e,t){var n=e.criteria,r=t.criteria;if(n!==r){if(n>r||void 0===n)return 1;if(r>n||void 0===r)return-1}return e.index-t.index}),"value")};var L=function(e){return function(t,n,r){var i={};return n=N(n,r),T.each(t,function(r,a){var o=n(r,a,t);e(i,r,o)}),i}};T.groupBy=L(function(e,t,n){T.has(e,n)?e[n].push(t):e[n]=[t]}),T.indexBy=L(function(e,t,n){e[n]=t}),T.countBy=L(function(e,t,n){T.has(e,n)?e[n]++:e[n]=1}),T.toArray=function(e){return e?T.isArray(e)?m.call(e):C(e)?T.map(e,T.identity):T.values(e):[]},T.size=function(e){return null==e?0:C(e)?e.length:T.keys(e).length},T.partition=function(e,t,n){t=N(t,n);var r=[],i=[];return T.each(e,function(e,n,a){(t(e,n,a)?r:i).push(e)}),[r,i]},T.first=T.head=T.take=function(e,t,n){return null==e?void 0:null==t||n?e[0]:T.initial(e,e.length-t)},T.initial=function(e,t,n){return m.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))},T.last=function(e,t,n){return null==e?void 0:null==t||n?e[e.length-1]:T.rest(e,Math.max(0,e.length-t))},T.rest=T.tail=T.drop=function(e,t,n){return m.call(e,null==t||n?1:t)},T.compact=function(e){return T.filter(e,T.identity)};var P=function(e,t,n,r){for(var i=[],a=0,o=r||0,s=R(e);s>o;o++){var u=e[o];if(C(u)&&(T.isArray(u)||T.isArguments(u))){t||(u=P(u,t,n));var l=0,p=u.length;for(i.length+=p;p>l;)i[a++]=u[l++]}else n||(i[a++]=u)}return i};T.flatten=function(e,t){return P(e,t,!1)},T.without=function(e){return T.difference(e,m.call(arguments,1))},T.uniq=T.unique=function(e,t,n,r){T.isBoolean(t)||(r=n,n=t,t=!1),null!=n&&(n=N(n,r));for(var i=[],a=[],o=0,s=R(e);s>o;o++){var u=e[o],l=n?n(u,o,e):u;t?(o&&a===l||i.push(u),a=l):n?T.contains(a,l)||(a.push(l),i.push(u)):T.contains(i,u)||i.push(u)}return i},T.union=function(){return T.uniq(P(arguments,!0,!0))},T.intersection=function(e){for(var t=[],n=arguments.length,r=0,i=R(e);i>r;r++){var a=e[r];if(!T.contains(t,a)){for(var o=1;n>o&&T.contains(arguments[o],a);o++);o===n&&t.push(a)}}return t},T.difference=function(e){var t=P(arguments,!0,!0,1);return T.filter(e,function(e){return!T.contains(t,e)})},T.zip=function(){return T.unzip(arguments)},T.unzip=function(e){for(var t=e&&T.max(e,R).length||0,n=Array(t),r=0;t>r;r++)n[r]=T.pluck(e,r);return n},T.object=function(e,t){for(var n={},r=0,i=R(e);i>r;r++)t?n[e[r]]=t[r]:n[e[r][0]]=e[r][1];return n},T.findIndex=a(1),T.findLastIndex=a(-1),T.sortedIndex=function(e,t,n,r){n=N(n,r,1);for(var i=n(t),a=0,o=R(e);o>a;){var s=Math.floor((a+o)/2);n(e[s])<i?a=s+1:o=s}return a},T.indexOf=o(1,T.findIndex,T.sortedIndex),T.lastIndexOf=o(-1,T.findLastIndex),T.range=function(e,t,n){null==t&&(t=e||0,e=0),n=n||1;for(var r=Math.max(Math.ceil((t-e)/n),0),i=Array(r),a=0;r>a;a++,e+=n)i[a]=e;return i};var O=function(e,t,n,r,i){if(!(r instanceof t))return e.apply(n,i);var a=w(e.prototype),o=e.apply(a,i);return T.isObject(o)?o:a};T.bind=function(e,t){if(A&&e.bind===A)return A.apply(e,m.call(arguments,1));if(!T.isFunction(e))throw new TypeError("Bind must be called on a function");var n=m.call(arguments,2),r=function(){return O(e,r,t,this,n.concat(m.call(arguments)))};return r},T.partial=function(e){var t=m.call(arguments,1),n=function(){for(var r=0,i=t.length,a=Array(i),o=0;i>o;o++)a[o]=t[o]===T?arguments[r++]:t[o];for(;r<arguments.length;)a.push(arguments[r++]);return O(e,n,this,this,a)};return n},T.bindAll=function(e){var t,n,r=arguments.length;if(1>=r)throw new Error("bindAll must be passed function names");for(t=1;r>t;t++)n=arguments[t],e[n]=T.bind(e[n],e);return e},T.memoize=function(e,t){var n=function(r){var i=n.cache,a=""+(t?t.apply(this,arguments):r);return T.has(i,a)||(i[a]=e.apply(this,arguments)),i[a]};return n.cache={},n},T.delay=function(e,t){var n=m.call(arguments,2);return setTimeout(function(){return e.apply(null,n)},t)},T.defer=T.partial(T.delay,T,1),T.throttle=function(e,t,n){var r,i,a,o=null,s=0;n||(n={});var u=function(){s=n.leading===!1?0:T.now(),o=null,a=e.apply(r,i),o||(r=i=null)};return function(){var l=T.now();s||n.leading!==!1||(s=l);var p=t-(l-s);return r=this,i=arguments,0>=p||p>t?(o&&(clearTimeout(o),o=null),s=l,a=e.apply(r,i),o||(r=i=null)):o||n.trailing===!1||(o=setTimeout(u,p)),a}},T.debounce=function(e,t,n){var r,i,a,o,s,u=function(){var l=T.now()-o;t>l&&l>=0?r=setTimeout(u,t-l):(r=null,n||(s=e.apply(a,i),r||(a=i=null)))};return function(){a=this,i=arguments,o=T.now();var l=n&&!r;return r||(r=setTimeout(u,t)),l&&(s=e.apply(a,i),a=i=null),s}},T.wrap=function(e,t){return T.partial(t,e)},T.negate=function(e){return function(){return!e.apply(this,arguments)}},T.compose=function(){var e=arguments,t=e.length-1;return function(){for(var n=t,r=e[t].apply(this,arguments);n--;)r=e[n].call(this,r);return r}},T.after=function(e,t){return function(){return--e<1?t.apply(this,arguments):void 0}},T.before=function(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),1>=e&&(t=null),n}},T.once=T.partial(T.before,2);var D=!{toString:null}.propertyIsEnumerable("toString"),x=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];T.keys=function(e){if(!T.isObject(e))return[];if(g)return g(e);var t=[];for(var n in e)T.has(e,n)&&t.push(n);return D&&s(e,t),t},T.allKeys=function(e){if(!T.isObject(e))return[];var t=[];for(var n in e)t.push(n);return D&&s(e,t),t},T.values=function(e){for(var t=T.keys(e),n=t.length,r=Array(n),i=0;n>i;i++)r[i]=e[t[i]];return r},T.mapObject=function(e,t,n){t=N(t,n);for(var r,i=T.keys(e),a=i.length,o={},s=0;a>s;s++)r=i[s],o[r]=t(e[r],r,e);return o},T.pairs=function(e){for(var t=T.keys(e),n=t.length,r=Array(n),i=0;n>i;i++)r[i]=[t[i],e[t[i]]];return r},T.invert=function(e){for(var t={},n=T.keys(e),r=0,i=n.length;i>r;r++)t[e[n[r]]]=n[r];return t},T.functions=T.methods=function(e){var t=[];for(var n in e)T.isFunction(e[n])&&t.push(n);return t.sort()},T.extend=_(T.allKeys),T.extendOwn=T.assign=_(T.keys),T.findKey=function(e,t,n){t=N(t,n);for(var r,i=T.keys(e),a=0,o=i.length;o>a;a++)if(r=i[a],t(e[r],r,e))return r},T.pick=function(e,t,n){var r,i,a={},o=e;if(null==o)return a;T.isFunction(t)?(i=T.allKeys(o),r=b(t,n)):(i=P(arguments,!1,!1,1),r=function(e,t,n){return t in n},o=Object(o));for(var s=0,u=i.length;u>s;s++){var l=i[s],p=o[l];r(p,l,o)&&(a[l]=p)}return a},T.omit=function(e,t,n){if(T.isFunction(t))t=T.negate(t);else{var r=T.map(P(arguments,!1,!1,1),String);t=function(e,t){return!T.contains(r,t)}}return T.pick(e,t,n)},T.defaults=_(T.allKeys,!0),T.create=function(e,t){var n=w(e);return t&&T.extendOwn(n,t),n},T.clone=function(e){return T.isObject(e)?T.isArray(e)?e.slice():T.extend({},e):e},T.tap=function(e,t){return t(e),e},T.isMatch=function(e,t){var n=T.keys(t),r=n.length;if(null==e)return!r;for(var i=Object(e),a=0;r>a;a++){var o=n[a];if(t[o]!==i[o]||!(o in i))return!1}return!0};var U=function(e,t,n,r){if(e===t)return 0!==e||1/e===1/t;if(null==e||null==t)return e===t;e instanceof T&&(e=e._wrapped),t instanceof T&&(t=t._wrapped);var i=h.call(e);if(i!==h.call(t))return!1;switch(i){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!==+e?+t!==+t:0===+e?1/+e===1/t:+e===+t;case"[object Date]":case"[object Boolean]":return+e===+t}var a="[object Array]"===i;if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var o=e.constructor,s=t.constructor;if(o!==s&&!(T.isFunction(o)&&o instanceof o&&T.isFunction(s)&&s instanceof s)&&"constructor"in e&&"constructor"in t)return!1}n=n||[],r=r||[];for(var u=n.length;u--;)if(n[u]===e)return r[u]===t;if(n.push(e),r.push(t),a){if(u=e.length,u!==t.length)return!1;for(;u--;)if(!U(e[u],t[u],n,r))return!1}else{var l,p=T.keys(e);if(u=p.length,T.keys(t).length!==u)return!1;for(;u--;)if(l=p[u],!T.has(t,l)||!U(e[l],t[l],n,r))return!1}return n.pop(),r.pop(),!0};T.isEqual=function(e,t){return U(e,t)},T.isEmpty=function(e){return null==e?!0:C(e)&&(T.isArray(e)||T.isString(e)||T.isArguments(e))?0===e.length:0===T.keys(e).length},T.isElement=function(e){return!(!e||1!==e.nodeType)},T.isArray=v||function(e){return"[object Array]"===h.call(e)},T.isObject=function(e){var t=typeof e;return"function"===t||"object"===t&&!!e},T.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(e){T["is"+e]=function(t){return h.call(t)==="[object "+e+"]"}}),T.isArguments(arguments)||(T.isArguments=function(e){return T.has(e,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(T.isFunction=function(e){return"function"==typeof e||!1}),T.isFinite=function(e){return isFinite(e)&&!isNaN(parseFloat(e))},T.isNaN=function(e){return T.isNumber(e)&&e!==+e},T.isBoolean=function(e){return e===!0||e===!1||"[object Boolean]"===h.call(e)},T.isNull=function(e){return null===e},T.isUndefined=function(e){return void 0===e},T.has=function(e,t){return null!=e&&y.call(e,t)},T.noConflict=function(){return u._=l,this},T.identity=function(e){return e},T.constant=function(e){return function(){return e}},T.noop=function(){},T.property=M,T.propertyOf=function(e){return null==e?function(){}:function(t){return e[t]}},T.matcher=T.matches=function(e){return e=T.extendOwn({},e),function(t){return T.isMatch(t,e)}},T.times=function(e,t,n){var r=Array(Math.max(0,e));t=b(t,n,1);for(var i=0;e>i;i++)r[i]=t(i);return r},T.random=function(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))},T.now=Date.now||function(){return(new Date).getTime()};var k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},F=T.invert(k),B=function(e){var t=function(t){return e[t]},n="(?:"+T.keys(e).join("|")+")",r=RegExp(n),i=RegExp(n,"g");return function(e){return e=null==e?"":""+e,r.test(e)?e.replace(i,t):e}};T.escape=B(k),T.unescape=B(F),T.result=function(e,t,n){var r=null==e?void 0:e[t];return void 0===r&&(r=n),T.isFunction(r)?r.call(e):r};var K=0;T.uniqueId=function(e){var t=++K+"";return e?e+t:t},T.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var V=/(.)^/,j={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},W=/\\|'|\r|\n|\u2028|\u2029/g,q=function(e){return"\\"+j[e]};T.template=function(e,t,n){!t&&n&&(t=n),t=T.defaults({},t,T.templateSettings);var r=RegExp([(t.escape||V).source,(t.interpolate||V).source,(t.evaluate||V).source].join("|")+"|$","g"),i=0,a="__p+='";e.replace(r,function(t,n,r,o,s){return a+=e.slice(i,s).replace(W,q),i=s+t.length,n?a+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":r?a+="'+\n((__t=("+r+"))==null?'':__t)+\n'":o&&(a+="';\n"+o+"\n__p+='"),t}),a+="';\n",t.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";try{var o=new Function(t.variable||"obj","_",a)}catch(s){throw s.source=a,s}var u=function(e){return o.call(this,e,T)},l=t.variable||"obj";return u.source="function("+l+"){\n"+a+"}",u},T.chain=function(e){var t=T(e);return t._chain=!0,t};var Y=function(e,t){return e._chain?T(t).chain():t};T.mixin=function(e){T.each(T.functions(e),function(t){var n=T[t]=e[t];T.prototype[t]=function(){var e=[this._wrapped];return d.apply(e,arguments),Y(this,n.apply(T,e))}})},T.mixin(T),T.each(["pop","push","reverse","shift","sort","splice","unshift"],function(e){var t=p[e];T.prototype[e]=function(){var n=this._wrapped;return t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0],Y(this,n)}}),T.each(["concat","join","slice"],function(e){var t=p[e];T.prototype[e]=function(){return Y(this,t.apply(this._wrapped,arguments))}}),T.prototype.value=function(){return this._wrapped},T.prototype.valueOf=T.prototype.toJSON=T.prototype.value,T.prototype.toString=function(){return""+this._wrapped},r=[],i=function(){return T}.apply(t,r),!(void 0!==i&&(e.exports=i))}).call(this)},function(e,t,n){var r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";!function(e){"use strict";function t(e){var t=e.charCodeAt(0);return t===o||t===c?62:t===s||t===f?63:u>t?-1:u+10>t?t-u+26+26:p+26>t?t-p:l+26>t?t-l+26:void 0}function n(e){function n(e){l[c++]=e}var r,i,o,s,u,l;if(e.length%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var p=e.length;u="="===e.charAt(p-2)?2:"="===e.charAt(p-1)?1:0,l=new a(3*e.length/4-u),o=u>0?e.length-4:e.length;var c=0;for(r=0,i=0;o>r;r+=4,i+=3)s=t(e.charAt(r))<<18|t(e.charAt(r+1))<<12|t(e.charAt(r+2))<<6|t(e.charAt(r+3)),n((16711680&s)>>16),n((65280&s)>>8),n(255&s);return 2===u?(s=t(e.charAt(r))<<2|t(e.charAt(r+1))>>4,n(255&s)):1===u&&(s=t(e.charAt(r))<<10|t(e.charAt(r+1))<<4|t(e.charAt(r+2))>>2,n(s>>8&255),n(255&s)),l}function i(e){function t(e){return r.charAt(e)}function n(e){return t(e>>18&63)+t(e>>12&63)+t(e>>6&63)+t(63&e)}var i,a,o,s=e.length%3,u="";for(i=0,o=e.length-s;o>i;i+=3)a=(e[i]<<16)+(e[i+1]<<8)+e[i+2],u+=n(a);switch(s){case 1:a=e[e.length-1],u+=t(a>>2),u+=t(a<<4&63),u+="==";break;case 2:a=(e[e.length-2]<<8)+e[e.length-1],u+=t(a>>10),u+=t(a>>4&63),u+=t(a<<2&63),u+="="}return u}var a="undefined"!=typeof Uint8Array?Uint8Array:Array,o="+".charCodeAt(0),s="/".charCodeAt(0),u="0".charCodeAt(0),l="a".charCodeAt(0),p="A".charCodeAt(0),c="-".charCodeAt(0),f="_".charCodeAt(0);e.toByteArray=n,e.fromByteArray=i}("undefined"==typeof t?this.base64js={}:t)},function(e,t,n){},function(e,t,n){e.exports=[{code:"1xx",phrase:"**Informational**",description:'"indicates an interim response for communicating connection status or request progress prior to completing the requested action and sending a final response." ~ [sure](http://www.urbandictionary.com/define.php?term=sure)',spec_title:"RFC7231#6.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2"},{code:"100",phrase:"Continue",description:'"indicates that the initial part of a request has been received and has not yet been rejected by the server."',spec_title:"RFC7231#6.2.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2.1"},{code:"101",phrase:"Switching Protocols",description:'"indicates that the server understands and is willing to comply with the client\'s request, via the Upgrade header field, for a change in the application protocol being used on this connection."',spec_title:"RFC7231#6.2.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2.2"},{code:"2xx",phrase:"**Successful**",description:'"indicates that the client\'s request was successfully received, understood, and accepted." ~ [cool](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3"},{code:"200",phrase:"OK",description:'"indicates that the request has succeeded."',spec_title:"RFC7231#6.3.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.1"},{code:"201",phrase:"Created",description:'"indicates that the request has been fulfilled and has resulted in one or more new resources being created."',spec_title:"RFC7231#6.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"202",phrase:"Accepted",description:'"indicates that the request has been accepted for processing, but the processing has not been completed."',spec_title:"RFC7231#6.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.3"},{code:"203",phrase:"Non-Authoritative Information",description:'"indicates that the request was successful but the enclosed payload has been modified from that of the origin server\'s 200 (OK) response by a transforming proxy."',spec_title:"RFC7231#6.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.4"},{code:"204",phrase:"No Content",description:'"indicates that the server has successfully fulfilled the request and that there is no additional content to send in the response payload body."',spec_title:"RFC7231#6.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.5"},{code:"205",phrase:"Reset Content",description:'"indicates that the server has fulfilled the request and desires that the user agent reset the "document view", which caused the request to be sent, to its original state as received from the origin server."',spec_title:"RFC7231#6.3.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.6"},{code:"206",phrase:"Partial Content",description:'"indicates that the server is successfully fulfilling a range request for the target resource by transferring one or more parts of the selected representation that correspond to the satisfiable ranges found in the requests\'s Range header field."',spec_title:"RFC7233#4.1",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.1"},{code:"3xx",phrase:"**Redirection**",description:'"indicates that further action needs to be taken by the user agent in order to fulfill the request." ~ [ask that dude over there](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4"},{code:"300",phrase:"Multiple Choices",description:'"indicates that the target resource has more than one representation, each with its own more specific identifier, and information about the alternatives is being provided so that the user (or user agent) can select a preferred representation by redirecting its request to one or more of those identifiers."',spec_title:"RFC7231#6.4.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.1"},{code:"301",phrase:"Moved Permanently",description:'"indicates that the target resource has been assigned a new permanent URI and any future references to this resource ought to use one of the enclosed URIs."',spec_title:"RFC7231#6.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.2"},{code:"302",phrase:"Found",description:'"indicates that the target resource resides temporarily under a different URI."',spec_title:"RFC7231#6.4.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.3"},{code:"303",phrase:"See Other",description:'"indicates that the server is redirecting the user agent to a different resource, as indicated by a URI in the Location header field, that is intended to provide an indirect response to the original request."',spec_title:"RFC7231#6.4.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.4"},{code:"304",phrase:"Not Modified",description:'"indicates that a conditional GET request has been received and would have resulted in a 200 (OK) response if it were not for the fact that the condition has evaluated to false."',spec_title:"RFC7232#4.1",spec_href:"http://tools.ietf.org/html/rfc7232#section-4.1"},{code:"305",phrase:"Use Proxy",description:"*deprecated*",spec_title:"RFC7231#6.4.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.5"},{code:"307",phrase:"Temporary Redirect",description:'"indicates that the target resource resides temporarily under a different URI and the user agent MUST NOT change the request method if it performs an automatic redirection to that URI."',spec_title:"RFC7231#6.4.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.7"},{code:"4xx",phrase:"**Client Error**",description:'"indicates that the client seems to have erred." ~ [*you* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5"
},{code:"400",phrase:"Bad Request",description:'"indicates that the server cannot or will not process the request because the received syntax is invalid, nonsensical, or exceeds some limitation on what the server is willing to process."',spec_title:"RFC7231#6.5.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.1"},{code:"401",phrase:"Unauthorized",description:'"indicates that the request has not been applied because it lacks valid authentication credentials for the target resource."',spec_title:"RFC7235#6.3.1",spec_href:"http://tools.ietf.org/html/rfc7235#section-3.1"},{code:"402",phrase:"Payment Required",description:"*reserved*",spec_title:"RFC7231#6.5.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.2"},{code:"403",phrase:"Forbidden",description:'"indicates that the server understood the request but refuses to authorize it."',spec_title:"RFC7231#6.5.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.3"},{code:"404",phrase:"Not Found",description:'"indicates that the origin server did not find a current representation for the target resource or is not willing to disclose that one exists."',spec_title:"RFC7231#6.5.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.4"},{code:"405",phrase:"Method Not Allowed",description:'"indicates that the method specified in the request-line is known by the origin server but not supported by the target resource."',spec_title:"RFC7231#6.5.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.5"},{code:"406",phrase:"Not Acceptable",description:'"indicates that the target resource does not have a current representation that would be acceptable to the user agent, according to the proactive negotiation header fields received in the request, and the server is unwilling to supply a default representation."',spec_title:"RFC7231#6.5.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.6"},{code:"407",phrase:"Proxy Authentication Required",description:'"is similar to 401 (Unauthorized), but indicates that the client needs to authenticate itself in order to use a proxy."',spec_title:"RFC7231#6.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"408",phrase:"Request Timeout",description:'"indicates that the server did not receive a complete request message within the time that it was prepared to wait."',spec_title:"RFC7231#6.5.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.7"},{code:"409",phrase:"Conflict",description:'"indicates that the request could not be completed due to a conflict with the current state of the resource."',spec_title:"RFC7231#6.5.8",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.8"},{code:"410",phrase:"Gone",description:'"indicates that access to the target resource is no longer available at the origin server and that this condition is likely to be permanent."',spec_title:"RFC7231#6.5.9",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.9"},{code:"411",phrase:"Length Required",description:'"indicates that the server refuses to accept the request without a defined Content-Length."',spec_title:"RFC7231#6.5.10",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.10"},{code:"412",phrase:"Precondition Failed",description:'"indicates that one or more preconditions given in the request header fields evaluated to false when tested on the server."',spec_title:"RFC7232#4.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-4.2"},{code:"413",phrase:"Payload Too Large",description:'"indicates that the server is refusing to process a request because the request payload is larger than the server is willing or able to process."',spec_title:"RFC7231#6.5.11",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.11"},{code:"414",phrase:"URI Too Long",description:'"indicates that the server is refusing to service the request because the request-target is longer than the server is willing to interpret."',spec_title:"RFC7231#6.5.12",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.12"},{code:"415",phrase:"Unsupported Media Type",description:'"indicates that the origin server is refusing to service the request because the payload is in a format not supported by the target resource for this method."',spec_title:"RFC7231#6.5.13",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.13"},{code:"416",phrase:"Range Not Satisfiable",description:'"indicates that none of the ranges in the request\'s Range header field overlap the current extent of the selected resource or that the set of ranges requested has been rejected due to invalid ranges or an excessive request of small or overlapping ranges."',spec_title:"RFC7233#4.4",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.4"},{code:"417",phrase:"Expectation Failed",description:'"indicates that the expectation given in the request\'s Expect header field could not be met by at least one of the inbound servers."',spec_title:"RFC7231#6.5.14",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.14"},{code:"426",phrase:"Upgrade Required",description:'"indicates that the server refuses to perform the request using the current protocol but might be willing to do so after the client upgrades to a different protocol."',spec_title:"RFC7231#6.5.15",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.15"},{code:"5xx",phrase:"**Server Error**",description:'"indicates that the server is aware that it has erred or is incapable of performing the requested method." ~ [*we* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6"},{code:"500",phrase:"Internal Server Error",description:'"indicates that the server encountered an unexpected condition that prevented it from fulfilling the request."',spec_title:"RFC7231#6.6.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.1"},{code:"501",phrase:"Not Implemented",description:'"indicates that the server does not support the functionality required to fulfill the request."',spec_title:"RFC7231#6.6.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.2"},{code:"502",phrase:"Bad Gateway",description:'"indicates that the server, while acting as a gateway or proxy, received an invalid response from an inbound server it accessed while attempting to fulfill the request."',spec_title:"RFC7231#6.6.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.3"},{code:"503",phrase:"Service Unavailable",description:'"indicates that the server is currently unable to handle the request due to a temporary overload or scheduled maintenance, which will likely be alleviated after some delay."',spec_title:"RFC7231#6.6.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.4"},{code:"504",phrase:"Gateway Time-out",description:'"indicates that the server, while acting as a gateway or proxy, did not receive a timely response from an upstream server it needed to access in order to complete the request."',spec_title:"RFC7231#6.6.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.5"},{code:"505",phrase:"HTTP Version Not Supported",description:'"indicates that the server does not support, or refuses to support, the protocol version that was used in the request message."',spec_title:"RFC7231#6.6.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.6"},{code:"102",phrase:"Processing",description:'"is an interim response used to inform the client that the server has accepted the complete request, but has not yet completed it."',spec_title:"RFC5218#10.1",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.1"},{code:"207",phrase:"Multi-Status",description:'"provides status for multiple independent operations."',spec_title:"RFC5218#10.2",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.2"},{code:"226",phrase:"IM Used",description:'"The server has fulfilled a GET request for the resource, and the response is a representation of the result of one or more instance-manipulations applied to the current instance."',spec_title:"RFC3229#10.4.1",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.4.1"},{code:"308",phrase:"Permanent Redirect",description:'"The target resource has been assigned a new permanent URI and any future references to this resource SHOULD use one of the returned URIs. [...] This status code is similar to 301 Moved Permanently (Section 7.3.2 of rfc7231), except that it does not allow rewriting the request method from POST to GET."',spec_title:"RFC7238",spec_href:"http://tools.ietf.org/html/rfc7238"},{code:"422",phrase:"Unprocessable Entity",description:'"means the server understands the content type of the request entity (hence a 415(Unsupported Media Type) status code is inappropriate), and the syntax of the request entity is correct (thus a 400 (Bad Request) status code is inappropriate) but was unable to process the contained instructions."',spec_title:"RFC5218#10.3",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.3"},{code:"423",phrase:"Locked",description:'"means the source or destination resource of a method is locked."',spec_title:"RFC5218#10.4",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.4"},{code:"424",phrase:"Failed Dependency",description:'"means that the method could not be performed on the resource because the requested action depended on another action and that action failed."',spec_title:"RFC5218#10.5",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.5"},{code:"428",phrase:"Precondition Required",description:'"indicates that the origin server requires the request to be conditional."',spec_title:"RFC6585#3",spec_href:"http://tools.ietf.org/html/rfc6585#section-3"},{code:"429",phrase:"Too Many Requests",description:'"indicates that the user has sent too many requests in a given amount of time ("rate limiting")."',spec_title:"RFC6585#4",spec_href:"http://tools.ietf.org/html/rfc6585#section-4"},{code:"431",phrase:"Request Header Fields Too Large",description:'"indicates that the server is unwilling to process the request because its header fields are too large."',spec_title:"RFC6585#5",spec_href:"http://tools.ietf.org/html/rfc6585#section-5"},{code:"451",phrase:"Unavailable For Legal Reasons",description:'"This status code indicates that the server is denying access to the resource in response to a legal demand."',spec_title:"draft-tbray-http-legally-restricted-status",spec_href:"http://tools.ietf.org/html/draft-tbray-http-legally-restricted-status"},{code:"506",phrase:"Variant Also Negotiates",description:'"indicates that the server has an internal configuration error: the chosen variant resource is configured to engage in transparent content negotiation itself, and is therefore not a proper end point in the negotiation process."',spec_title:"RFC2295#8.1",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.1"},{code:"507",phrase:"Insufficient Storage",description:'"means the method could not be performed on the resource because the server is unable to store the representation needed to successfully complete the request."',spec_title:"RFC5218#10.6",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.6"},{code:"511",phrase:"Network Authentication Required",description:'"indicates that the client needs to authenticate to gain network access."',spec_title:"RFC6585#6",spec_href:"http://tools.ietf.org/html/rfc6585#section-6"},{code:"7xx",phrase:"**Developer Error**",description:"[err](http://www.urbandictionary.com/define.php?term=err)",spec_title:"7xx-rfc",spec_href:"http://documentup.com/joho/7XX-rfc"}]},function(e,t,n){e.exports=[{method:"CONNECT",description:'"requests that the recipient establish a tunnel to the destination origin server identified by the request-target and, if successful, thereafter restrict its behavior to blind forwarding of packets, in both directions, until the connection is closed."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.6"},{method:"DELETE",description:'"requests that the origin server remove the association between the target resource and its current functionality."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.5"},{method:"GET",description:'"requests transfer of a current selected representation for the target resource."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.1"},{method:"HEAD",description:'"is identical to GET except that the server MUST NOT send a message body in the response (i.e., the response terminates at the end of the header block)."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.2"},{method:"OPTIONS",description:'"requests information about the communication options available on the request/response chain identified by the effective request URI."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.7"},{method:"POST",description:'"requests that the target resource process the representation enclosed in the request according to the resource\'s own specific semantics."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC7231#4.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.3"},{method:"PUT",description:'"requests that the state of the target resource be created or replaced with the state defined by the representation enclosed in the request message payload."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.4"},{method:"TRACE",description:'"is used to invoke a remote, application-layer loopback of the request message."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.8",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.8"},{method:"ACL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3744#8.1",spec_href:"http://tools.ietf.org/html/rfc3744#section-8.1"},{method:"BASELINE-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#12.6",spec_href:"http://tools.ietf.org/html/rfc3253#section-12.6"},{method:"BIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#4",spec_href:"http://tools.ietf.org/html/rfc5842#section-4"},{method:"CHECKIN",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.4",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.4"},{method:"CHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.3",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.3"},{method:"COPY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.8",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.8"},{method:"LABEL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#8.2",spec_href:"http://tools.ietf.org/html/rfc3253#section-8.2"},{method:"LINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.2",spec_href:"http://tools.ietf.org/html/rfc2068#section-19.6.1.2"},{method:"LOCK",description:"",safe:!1,idempotent:!1,cacheable:"",spec_title:"RFC4918#9.10",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.10"},{method:"MERGE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#11.2",spec_href:"http://tools.ietf.org/html/rfc3253#section-11.2"},{method:"MKACTIVITY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#13.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-13.5"},{method:"MKCALENDAR",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4791#5.3.1",spec_href:"http://tools.ietf.org/html/rfc4791#section-5.3.1"},{method:"MKCOL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.3",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.3"},{method:"MKREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#6",spec_href:"http://tools.ietf.org/html/rfc4437#section-6"},{method:"MKWORKSPACE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#6.3",spec_href:"http://tools.ietf.org/html/rfc3253#section-6.3"},{method:"MOVE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.9",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.9"},{method:"ORDERPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3648#7",spec_href:"http://tools.ietf.org/html/rfc3648#section-7"},{method:"PATCH",description:'"requests that a set of changes described in the request entity be applied to the resource identified by the Request-URI."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC5789",spec_href:"http://tools.ietf.org/html/rfc5789#section-2"},{method:"PROPFIND",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.1",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.1"},{method:"PROPPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.2",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.2"},{method:"REBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#6",spec_href:"http://tools.ietf.org/html/rfc5842#section-6"},{method:"REPORT",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.6",spec_href:"http://tools.ietf.org/html/rfc3253#section-3.6"},{method:"SEARCH",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC5323#2",spec_href:"http://tools.ietf.org/html/rfc5323#section-2"},{method:"UNBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#5",spec_href:"http://tools.ietf.org/html/rfc5842#section-5"},{method:"UNCHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.5"},{method:"UNLINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.3",spec_href:"http://tools.ietf.org/html/rfc2068#section-19.6.1.3"},{method:"UNLOCK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.11",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.11"},{method:"UPDATE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#7.1",spec_href:"http://tools.ietf.org/html/rfc3253#section-7.1"},{method:"UPDATEREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#7",spec_href:"http://tools.ietf.org/html/rfc4437#section-7"},{method:"VERSION-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-3.5"}]},function(e,t,n){e.exports=[{header:"Content-Encoding",description:'"indicates what content codings have been applied to the representation, beyond those inherent in the media type, and thus what decoding mechanisms have to be applied in order to obtain data in the media type referenced by the Content-Type header field."',spec_title:"RFC7231#3.1.2.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.2.2"},{header:"Content-Language",description:'"describes the natural language(s) of the intended audience for the representation."',spec_title:"RFC7231#3.1.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.3.2"},{header:"Content-Location",description:'"references a URI that can be used as an identifier for a specific resource corresponding to the representation in this message\'s payload."',spec_title:"RFC7231#3.1.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.4.2"},{header:"Content-Type",description:'"indicates the media type of the associated representation: either the representation enclosed in the message payload or the selected representation, as determined by the message semantics."',spec_title:"RFC7231#3.1.1.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.1.5"},{header:"Content-Length",description:'"can provide the anticipated size, as a decimal number of octets, for a potential payload body."',spec_title:"RFC7230#3.3.2",spec_href:"http://tools.ietf.org/html/rfc7230#section-3.3.2"},{header:"Content-Range",description:'"is sent in a single part 206 (Partial Content) response to indicate the partial range of the selected representation enclosed as the message payload, sent in each part of a multipart 206 response to indicate the range enclosed within each body part, and sent in 416 (Range Not Satisfiable) responses to provide information about the selected representation."',spec_title:"RFC7233#4.2",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.2"},{header:"Transfer-Encoding",description:'"lists the transfer coding names corresponding to the sequence of transfer codings that have been (or will be) applied to the payload body in order to form the message body."',spec_title:"RFC7230#3.3.1",spec_href:"http://tools.ietf.org/html/rfc7230#section-3.3.1"},{header:"Cache-Control",description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expect",description:'"is used to indicate that particular server behaviors are required by the client."',spec_title:"RFC7231#5.1.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.1.1"},{header:"Host",description:'"provides the host and port information from the target URI, enabling the origin server to distinguish among resources while servicing requests for multiple host names on a single IP address."',spec_title:"RFC7230#5.4",spec_href:"http://tools.ietf.org/html/rfc7230#section-5.4"},{header:"Max-Forwards",description:'"provides a mechanism with the TRACE and OPTIONS methods to limit the number of times that the request is forwarded by proxies."',spec_title:"RFC7231#5.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.1.2"},{header:"Pragma",description:'"allows backwards compatibility with HTTP/1.0 caches, so that clients can specify a "no-cache" request that they will understand (as Cache-Control was not defined until HTTP/1.1)."',spec_title:"RFC7234#7.4",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.4"},{header:"Range",description:'"modifies the method semantics to request transfer of only one or more subranges of the selected representation data, rather than the entire selected representation data."',spec_title:"RFC7233#3.1",spec_href:"http://tools.ietf.org/html/rfc7233#section-3.1"},{header:"TE",description:'"indicates what transfer codings, besides chunked, the client is willing to accept in response, and whether or not the client is willing to accept trailer fields in a chunked transfer coding."',spec_title:"RFC7230#4.3",spec_href:"http://tools.ietf.org/html/rfc7230#section-4.3"},{header:"If-Match",description:'"can be used to make a request method conditional on the current existence or value of an entity-tag for one or more representations of the target resource."',spec_title:"RFC7232#3.1",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.1"},{header:"If-Modified-Since",description:'"can be used with GET or HEAD to make the method conditional by modification date: if the selected representation has not been modified since the time specified in this field, then do not perform the request method; instead, respond as detailed below."',spec_title:"RFC7232#3.3",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.3"},{header:"If-None-Match",description:'"can be used to make a request method conditional on not matching any of the current entity-tag values for representations of the target resource."',spec_title:"RFC7232#3.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.2"},{header:"If-Range",description:'"Informally, its meaning is: if the representation is unchanged, send me the part(s) that I am requesting in Range; otherwise, send me the entire representation."',spec_title:"RFC7233#3.2",spec_href:"http://tools.ietf.org/html/rfc7233#section-3.2"},{header:"If-Unmodified-Since",description:'"can be used to make a request method conditional by modification date: if the selected representation has been modified since the time specified in this field, then the server MUST NOT perform the requested operation and MUST instead respond with the 412 (Precondition Failed) status code."',spec_title:"RFC7232#3.4",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.4"},{header:"Accept",description:'"can be used to specify certain media types which are acceptable for the response."',spec_title:"RFC7231#5.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.2"},{header:"Accept-Charset",description:'"can be sent by a user agent to indicate what charsets are acceptable in textual response content."',spec_title:"RFC7231#5.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.3"},{header:"Accept-Encoding",description:'"can be used by user agents to indicate what response content-codings are acceptable in the response."',spec_title:"RFC7231#5.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.4"},{header:"Accept-Language",description:'"can be used by user agents to indicate the set of natural languages that are preferred in the response."',spec_title:"RFC7231#5.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.5"},{header:"Authorization",description:'"allows a user agent to authenticate itself with a server -- usually, but not necessarily, after receiving a 401 (Unauthorized) response."',spec_title:"RFC7235#4.1",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.1"},{header:"Proxy-Authorization",description:'"allows the client to identify itself (or its user) to a proxy that requires authentication."',spec_title:"RFC7235#4.3",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.3"},{header:"DNT",description:'"defined as the means for expressing a user\'s tracking preference via HTTP."',spec_title:"Tracking Preference Expression (DNT)",spec_href:"http://www.w3.org/TR/tracking-dnt/#dnt-header-field"},{header:"From",description:'"contains an Internet email address for a human user who controls the requesting user agent."',spec_title:"RFC7231#5.5.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.1"},{header:"Referer",description:'"allows the user agent to specify a URI reference for the resource from which the target URI was obtained (i.e., the "referrer", though the field name is misspelled)."',spec_title:"RFC7231#5.5.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.2"},{header:"User-Agent",description:'"contains information about the user agent originating the request, which is often used by servers to help identify the scope of reported interoperability problems, to work around or tailor responses to avoid particular user agent limitations, and for analytics regarding browser or operating system use."',spec_title:"RFC7231#5.5.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.3"},{header:"Age",description:'"conveys the sender\'s estimate of the amount of time since the response was generated or successfully validated at the origin server."',spec_title:"RFC7234#5.1",spec_href:"http://tools.ietf.org/html/rfc7234#section-5.1"},{header:"Cache-Control",description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expires",description:'"gives the date/time after which the response is considered stale."',spec_title:"RFC7234#7.3",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.3"},{header:"Date",description:'"represents the date and time at which the message was originated"',spec_title:"RFC7231#7.1.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.1.2"},{header:"Location",description:'"is used in some responses to refer to a specific resource in relation to the response."',spec_title:"RFC7231#7.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.2"},{header:"Retry-After",description:'"indicates how long the user agent ought to wait before making a follow-up request."',spec_title:"RFC7231#7.1.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.3"},{header:"Tk",description:'"defined as an OPTIONAL means for indicating the tracking status that applied to the corresponding request and as a REQUIRED means for indicating that a state-changing request has resulted in an interactive change to the tracking status. "',spec_title:"Tracking Preference Expression (DNT)",spec_href:"http://www.w3.org/TR/tracking-dnt/#response-header-field"},{header:"Vary",description:'"describes what parts of a request message, aside from the method and request target, might influence the origin server\'s process for selecting and representing the response."',spec_title:"RFC7231#7.1.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.4"},{header:"Warning",description:'"is used to carry additional information about the status or transformation of a message that might not be reflected in the message."',spec_title:"RFC7234#7.6",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.6"},{header:"ETag",description:'"provides the current entity-tag for the selected representation, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.3",spec_href:"http://tools.ietf.org/html/rfc7232#section-2.3"},{header:"Last-Modified",description:'"provides a timestamp indicating the date and time at which the origin server believes the selected representation was last modified, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-2.2"},{header:"WWW-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the effective request URI."',spec_title:"RFC7235#4.4",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.4"},{header:"Proxy-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the proxy for this effective request URI."',spec_title:"RFC7235#4.2",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.2"},{header:"Accept-Ranges",description:'"allows a server to indicate that it supports range requests for the target resource."',spec_title:"RFC7233#2.3",spec_href:"http://tools.ietf.org/html/rfc7233#section-2.3"},{header:"Allow",description:'"lists the set of methods advertised as supported by the target resource."',spec_title:"RFC7231#7.4.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.4.1"},{header:"Server",description:'"contains information about the software used by the origin server to handle the request, which is often used by clients to help identify the scope of reported interoperability problems, to work around or tailor requests to avoid particular server limitations, and for analytics regarding server or operating system use."',spec_title:"RFC7231#7.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.4.2"},{header:"Accept-Patch",description:'"used to specify the patch document formats accepted by the server."',spec_title:"RFC5789#3.1",spec_href:"http://tools.ietf.org/html/rfc5789#section-3.1"},{header:"Accept-Post",description:'"indicates server support for specific media types for entity bodies in HTTP POST requests."',spec_title:"draft-wilde-accept-post",spec_href:"http://tools.ietf.org/html/draft-wilde-accept-post"},{header:"Access-Control-Allow-Credentials",description:'"indicates whether the response to request can be exposed when the omit credentials flag is unset"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-credentials-response-header"},{header:"Access-Control-Allow-Headers",description:'"indicates, as part of the response to a preflight request, which header field names can be used during the actual request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-headers-response-header"
},{header:"Access-Control-Allow-Methods",description:'"indicates, as part of the response to a preflight request, which methods can be used during the actual request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-methods-response-header"},{header:"Access-Control-Allow-Origin",description:'"indicates whether a resource can be shared"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-origin-response-header"},{header:"Access-Control-Expose-Headers",description:'"indicates which headers are safe to expose to the API of a CORS API specification"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-expose-headers-response-header"},{header:"Access-Control-Max-Age",description:'"indicates how long the results of a preflight request can be cached in a preflight result cache"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-max-age-response-header"},{header:"Access-Control-Request-Headers",description:'"indicates which headers will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-request-headers-request-header"},{header:"Access-Control-Request-Method",description:'"indicates which method will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-request-method-request-header"},{header:"Content-Disposition",description:'"standard"',spec_title:"RFC6266",spec_href:"http://tools.ietf.org/html/rfc6266"},{header:"Content-Security-Policy",description:'"is the preferred mechanism for delivering a CSP policy"',spec_title:"CSP",spec_href:"http://www.w3.org/TR/CSP/#content-security-policy-header-field"},{header:"Content-Security-Policy-Report-Only",description:'"lets servers experiment with policies by monitoring (rather than enforcing) a policy"',spec_title:"CSP",spec_href:"http://www.w3.org/TR/CSP/#content-security-policy-report-only-header-field"},{header:"Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"http://tools.ietf.org/html/rfc6265"},{header:"Forwarded",description:'"standard"',spec_title:"RFC7239",spec_href:"http://tools.ietf.org/html/rfc7239"},{header:"Link",description:'"provides a means for serialising one or more links in HTTP headers."',spec_title:"RFC5988#5",spec_href:"http://tools.ietf.org/html/rfc5988#section-5"},{header:"Origin",description:'"standard"',spec_title:"RFC6454",spec_href:"http://tools.ietf.org/html/rfc6454"},{header:"Prefer",description:'"is used to indicate that particular server behaviors are preferred by the client, but not required for successful completion of the request."',spec_title:"draft-snell-http-prefer#2",spec_href:"http://tools.ietf.org/html/draft-snell-http-prefer#section-2"},{header:"Preference-Applied",description:'"MAY be included within a response message as an indication as to which Prefer tokens were honored by the server and applied to the processing of a request."',spec_title:"draft-snell-http-prefer#3",spec_href:"http://tools.ietf.org/html/draft-snell-http-prefer#section-3"},{header:"Set-Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"http://tools.ietf.org/html/rfc6265"},{header:"Strict-Transport-Security",description:'"standard"',spec_title:"RFC6797",spec_href:"http://tools.ietf.org/html/rfc6797"},{header:"Via",description:'""',spec_title:"RFC7230#5.7.1",spec_href:"http://tools.ietf.org/html/rfc7230#section-5.7.1"},{header:"A-IM",description:'""',spec_title:"RFC3229#10.5.3",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.3"},{header:"Accept-Features",description:'"can be used by a user agent to give information about the presence or absence of certain features in the feature set of the current request."',spec_title:"RFC2295#8.2",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.2"},{header:"Alt-Svc",description:'"is advertising the availability of alternate services to HTTP/1.1 and HTTP/2.0 clients by adding an Alt-Svc header field to responses."',spec_title:"draft-nottingham-httpbis-alt-svc",spec_href:"http://tools.ietf.org/html/draft-nottingham-httpbis-alt-svc"},{header:"Alternates",description:'"is used to convey the list of variants bound to a negotiable resource."',spec_title:"RFC2295#8.3",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.3"},{header:"Apply-To-Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"http://tools.ietf.org/html/rfc4437"},{header:"CH",description:'"describes an example list of client preferences that the server can use to adapt and optimize the resource to satisfy a given request."',spec_title:"draft-grigorik-http-client-hints",spec_href:"http://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Content-Base",description:'"obsoleted"',spec_title:"RFC2068",spec_href:"http://tools.ietf.org/html/rfc2068"},{header:"Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"http://tools.ietf.org/html/rfc2965"},{header:"DASL",description:'"standard"',spec_title:"RFC5323",spec_href:"http://tools.ietf.org/html/rfc5323"},{header:"DAV",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Delta-Base",description:'""',spec_title:"RFC3229#10.5.1",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.1"},{header:"Depth",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Destination",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"IM",description:'""',spec_title:"RFC3229#10.5.2",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.2"},{header:"If",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"If-Schedule-Tag-Match",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Last-Event-ID",description:'"The value of the event source\'s last event ID string, encoded as UTF-8."',spec_title:"Server-Sent Events",spec_href:"http://www.w3.org/TR/eventsource/#last-event-id"},{header:"Link-Template",description:'"provides a means for serialising one or more links into HTTP headers."',spec_title:"draft-nottingham-link-template",spec_href:"http://tools.ietf.org/html/draft-nottingham-link-template"},{header:"Lock-Token",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Negotiate",description:'"can contain directives for any content negotiation process initiated by the request."',spec_title:"RFC2295#8.4",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.4"},{header:"Nice",description:'"indicates that a request is less important than a request that doesn\'t bear this header."',spec_title:"draft-thomson-http-nice",spec_href:"http://tools.ietf.org/html/draft-thomson-http-nice"},{header:"Overwrite",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"http://tools.ietf.org/html/rfc4437"},{header:"Schedule-Reply",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Schedule-Tag",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Sec-WebSocket-Accept",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Extensions",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Key",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Protocol",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Version",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Set-Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"http://tools.ietf.org/html/rfc2965"},{header:"SLUG",description:'"standard"',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{header:"TCN",description:'"is used by a server to signal that the resource is transparently negotiated."',spec_title:"RFC2295#8.5",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.5"},{header:"Timeout",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Variant-Vary",description:'"can be used in a choice response to record any vary information which applies to the variant data (the entity body combined with some of the entity headers) contained in the response, rather than to the response as a whole."',spec_title:"RFC2295#8.6",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.6"},{header:"X-Frame-Options",description:'"indicates a policy that specifies whether the browser should render the transmitted resource within a <frame> or an <iframe>. Servers can declare this policy in the header of their HTTP responses to prevent clickjacking attacks, which ensures that their content is not embedded into other pages or frames."',spec_title:"RFC7034",spec_href:"http://tools.ietf.org/html/rfc7034"}]},function(e,t,n){e.exports=[{relation:"about",description:'"Refers to a resource that is the subject of the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"alternate",description:'"Refers to a substitute for this context"',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-alternate"},{relation:"appendix",description:'"Refers to an appendix."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"archives",description:'"Refers to a collection of records, documents, or other materials of historical interest."',spec_title:"HTML5linksWD",spec_href:"http://www.w3.org/TR/2011/WD-html5-20110113/links.html#rel-archives"},{relation:"author",description:'"Refers to the context\'s author."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-author"},{relation:"bookmark",description:'"Gives a permanent link to use for bookmarking purposes."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-bookmark"},{relation:"canonical",description:'"Designates the preferred version of a resource (the IRI and its contents)."',spec_title:"RFC6596",spec_href:"http://tools.ietf.org/html/rfc6596"},{relation:"chapter",description:'"Refers to a chapter in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"collection",description:'"The target IRI points to a resource which represents the collection resource for the context IRI."',spec_title:"RFC6573",spec_href:"http://tools.ietf.org/html/rfc6573"},{relation:"contents",description:'"Refers to a table of contents."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"copyright",description:'"Refers to a copyright statement that applies to the link\'s context."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"create-form",description:'"The target IRI points to a resource where a submission form can be obtained."',spec_title:"RFC6861",spec_href:"http://tools.ietf.org/html/rfc6861"},{relation:"current",description:'"Refers to a resource containing the most recent item(s) in a collection of resources."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"describedby",description:'"Refers to a resource providing information about the link\'s context."',spec_title:"POWDER",spec_href:"http://www.w3.org/TR/powder-dr/#assoc-linking"},{relation:"describes",description:"\"The relationship A 'describes' B asserts that resource A provides a description of resource B. There are no constraints on the format or representation of either A or B, neither are there any further constraints on either resource.\"",spec_title:"RFC6892",spec_href:"http://tools.ietf.org/html/rfc6892"},{relation:"disclosure",description:'"Refers to a list of patent disclosures made with respect to material for which `disclosure` relation is specified."',spec_title:"RFC6579",spec_href:"http://tools.ietf.org/html/rfc6579"},{relation:"duplicate",description:'"Refers to a resource whose available representations are byte-for-byte identical with the corresponding representations of the context IRI."',spec_title:"RFC6249",spec_href:"http://tools.ietf.org/html/rfc6249"},{relation:"edit",description:'"Refers to a resource that can be used to edit the link\'s context."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"edit-form",description:'"The target IRI points to a resource where a submission form for editing associated resource can be obtained."',spec_title:"RFC6861",spec_href:"http://tools.ietf.org/html/rfc6861"},{relation:"edit-media",description:'"Refers to a resource that can be used to edit media associated with the link\'s context."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"enclosure",description:'"Identifies a related resource that is potentially large and might require special handling."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"first",description:'"An IRI that refers to the furthest preceding resource in a series of resources."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"glossary",description:'"Refers to a glossary of terms."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"help",description:'"Refers to context-sensitive help."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-help"},{relation:"hosts",description:'"Refers to a resource hosted by the server indicated by the link context."',spec_title:"RFC6690",spec_href:"http://tools.ietf.org/html/rfc6690"},{relation:"hub",description:'"Refers to a hub that enables registration for notification of updates to the context."',spec_title:"pubsubhubbub",spec_href:"http://pubsubhubbub.googlecode.com"},{relation:"icon",description:'"Refers to an icon representing the link\'s context."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-icon"},{relation:"index",description:'"Refers to an index."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"item",description:'"The target IRI points to a resource that is a member of the collection represented by the context IRI."',spec_title:"RFC6573",spec_href:"http://tools.ietf.org/html/rfc6573"},{relation:"last",description:'"An IRI that refers to the furthest following resource in a series of resources."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"latest-version",description:'"Points to a resource containing the latest (e.g., current) version of the context."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"license",description:'"Refers to a license associated with this context."',spec_title:"RFC4946",spec_href:"http://tools.ietf.org/html/rfc4946"},{relation:"lrdd",description:'"Refers to further information about the link\'s context, expressed as a LRDD (Link-based Resource Descriptor Document) resource. See [RFC6415](http://tools.ietf.org/html/rfc6415) for information about processing this relation type in host-meta documents. When used elsewhere, it refers to additional links and other metadata. Multiple instances indicate additional LRDD resources. LRDD resources MUST have an "application/xrd+xml" representation, and MAY have others."',spec_title:"RFC6415",spec_href:"http://tools.ietf.org/html/rfc6415"},{relation:"monitor",description:'"Refers to a resource that can be used to monitor changes in an HTTP resource."',spec_title:"RFC5989",spec_href:"http://tools.ietf.org/html/rfc5989"},{relation:"monitor-group",description:'"Refers to a resource that can be used to monitor changes in a specified group of HTTP resources."',spec_title:"RFC5989",spec_href:"http://tools.ietf.org/html/rfc5989"},{relation:"next",description:'"Indicates that the link\'s context is a part of a series, and that the next in the series is the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-next"},{relation:"next-archive",description:'"Refers to the immediately following archive resource."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"nofollow",description:'"Indicates that the context’s original author or publisher does not endorse the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-nofollow"},{relation:"noreferrer",description:'"Indicates that no referrer information is to be leaked when following the link."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-noreferrer"},{relation:"payment",description:'"Indicates a resource where payment is accepted."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"predecessor-version",description:'"Points to a resource containing the predecessor version in the version history."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"prefetch",description:'"Indicates that the link target should be preemptively cached."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-prefetch"},{relation:"prev",description:'"Indicates that the link\'s context is a part of a series, and that the previous in the series is the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-prev"},{relation:"preview",description:'"Refers to a resource that provides a preview of the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"previous",description:'"Refers to the previous resource in an ordered series of resources. Synonym for `prev`."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"prev-archive",description:'"Refers to the immediately preceding archive resource."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"privacy-policy",description:'"Refers to a privacy policy associated with the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"profile",description:"Identifying that a resource representation conforms to a certain profile, without affecting the non-profile semantics of the resource representation",spec_title:"RFC6906",spec_href:"http://tools.ietf.org/html/rfc6906"},{relation:"related",description:'"Identifies a related resource."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"replies",description:'"Identifies a resource that is a reply to the context of the link."',spec_title:"RFC4685",spec_href:"http://tools.ietf.org/html/rfc4685"},{relation:"search",description:'"Refers to a resource that can be used to search through the link\'s context and related resources."',spec_title:"OpenSearch",spec_href:"http://www.opensearch.org/Specifications/OpenSearch/1.1"},{relation:"section",description:'"Refers to a section in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"self",description:'"Conveys an identifier for the link\'s context."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"service",description:'"Indicates a URI that can be used to retrieve a service document."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"start",description:'"Refers to the first resource in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"stylesheet",description:'"Refers to a stylesheet."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-stylesheet"},{relation:"subsection",description:'"Refers to a resource serving as a subsection in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"successor-version",description:'"Points to a resource containing the successor version in the version history."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"tag",description:'"Gives a tag (identified by the given address) that applies to the current document."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-tag"},{relation:"terms-of-service",description:'"Refers to the terms of service associated with the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"type",description:'"Refers to a resource identifying the abstract semantic type of which the link\'s context is considered to be an instance."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"up",description:'"Refers to a parent document in a hierarchy of documents."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"version-history",description:'"Points to a resource containing the version history for the context."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"via",description:'"Identifies a resource that is the source of the information in the link\'s context."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"working-copy",description:'"Points to a working copy for this resource."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"working-copy-of",description:'"Points to the versioned resource from which this working copy was obtained."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"}]},function(e,t,n){var r=[].indexOf;e.exports=function(e,t){if(r)return e.indexOf(t);for(var n=0;n<e.length;++n)if(e[n]===t)return n;return-1}},function(e,t,n){function r(e){return null}function i(e,t){}function a(e){return!1}function o(e){}function s(e){}function u(e){return{isDirectory:function(){return!1},isSymbolicLink:function(){return!1},isFile:function(){return!1}}}function l(e){return this.statSync(e)}function p(e,t){return[]}function c(e){}t.readFileSync=r,t.writeFileSync=i,t.existsSync=a,t.mkdirSync=o,t.readdirSync=s,t.statSync=u,t.lstatSync=l,t.list=p,t.onChange=c},function(e,t,n){"use strict";function r(e){var t={};return null!==e&&Object.keys(e).forEach(function(n){e[n].forEach(function(e){t[String(e)]=n})}),t}function i(e,t){if(t=t||{},Object.keys(t).forEach(function(t){if(-1===o.indexOf(t))throw new a('Unknown option "'+t+'" is met in definition of "'+e+'" YAML type.')}),this.tag=e,this.kind=t.kind||null,this.resolve=t.resolve||function(){return!0},this.construct=t.construct||function(e){return e},this.instanceOf=t.instanceOf||null,this.predicate=t.predicate||null,this.represent=t.represent||null,this.defaultStyle=t.defaultStyle||null,this.styleAliases=r(t.styleAliases||null),-1===s.indexOf(this.kind))throw new a('Unknown kind "'+this.kind+'" is specified for "'+e+'" YAML type.')}var a=n(115),o=["kind","resolve","construct","instanceOf","predicate","represent","defaultStyle","styleAliases"],s=["scalar","sequence","mapping"];e.exports=i},function(e,t,n){"use strict";var r=n(153);e.exports=new r({include:[n(213)],implicit:[n(214),n(215),n(216),n(217)]})},function(e,t,n){"use strict";function r(){}function i(e){try{return e.then}catch(t){return v=t,g}}function a(e,t){try{return e(t)}catch(n){return v=n,g}}function o(e,t,n){try{e(t,n)}catch(r){return v=r,g}}function s(e){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._45=0,this._81=0,this._65=null,this._54=null,e!==r&&h(e,this)}function u(e,t,n){return new e.constructor(function(i,a){var o=new s(r);o.then(i,a),l(e,new m(t,n,o))})}function l(e,t){for(;3===e._81;)e=e._65;return s._10&&s._10(e),0===e._81?0===e._45?(e._45=1,void(e._54=t)):1===e._45?(e._45=2,void(e._54=[e._54,t])):void e._54.push(t):void p(e,t)}function p(e,t){y(function(){var n=1===e._81?t.onFulfilled:t.onRejected;if(null===n)return void(1===e._81?c(t.promise,e._65):f(t.promise,e._65));var r=a(n,e._65);r===g?f(t.promise,v):c(t.promise,r)})}function c(e,t){if(t===e)return f(e,new TypeError("A promise cannot be resolved with itself."));if(t&&("object"==typeof t||"function"==typeof t)){var n=i(t);if(n===g)return f(e,v);if(n===e.then&&t instanceof s)return e._81=3,e._65=t,void d(e);if("function"==typeof n)return void h(n.bind(t),e)}e._81=1,e._65=t,d(e)}function f(e,t){e._81=2,e._65=t,s._97&&s._97(e,t),d(e)}function d(e){if(1===e._45&&(l(e,e._54),e._54=null),2===e._45){for(var t=0;t<e._54.length;t++)l(e,e._54[t]);e._54=null}}function m(e,t,n){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof t?t:null,this.promise=n}function h(e,t){var n=!1,r=o(e,function(e){n||(n=!0,c(t,e))},function(e){n||(n=!0,f(t,e))});n||r!==g||(n=!0,f(t,v))}var y=n(246),v=null,g={};e.exports=s,s._10=null,s._97=null,s._61=r,s.prototype.then=function(e,t){if(this.constructor!==s)return u(this,e,t);var n=new s(r);return l(this,new m(e,t,n)),n}},function(e,t,n){"use strict";var r=n(196);e.exports=r,r.prototype.done=function(e,t){var n=arguments.length?this.then.apply(this,arguments):this;n.then(null,function(e){setTimeout(function(){throw e},0)})}},function(e,t,n){"use strict";var r=n(196);e.exports=r,r.prototype["finally"]=function(e){return this.then(function(t){return r.resolve(e()).then(function(){return t})},function(t){return r.resolve(e()).then(function(){throw t})})}},function(e,t,n){"use strict";function r(e){var t=new i(i._61);return t._81=1,t._65=e,t}var i=n(196);e.exports=i;var a=r(!0),o=r(!1),s=r(null),u=r(void 0),l=r(0),p=r("");i.resolve=function(e){if(e instanceof i)return e;if(null===e)return s;if(void 0===e)return u;if(e===!0)return a;if(e===!1)return o;if(0===e)return l;if(""===e)return p;if("object"==typeof e||"function"==typeof e)try{var t=e.then;if("function"==typeof t)return new i(t.bind(e))}catch(n){return new i(function(e,t){t(n)})}return r(e)},i.all=function(e){var t=Array.prototype.slice.call(e);return new i(function(e,n){function r(o,s){if(s&&("object"==typeof s||"function"==typeof s)){if(s instanceof i&&s.then===i.prototype.then){for(;3===s._81;)s=s._65;return 1===s._81?r(o,s._65):(2===s._81&&n(s._65),void s.then(function(e){r(o,e)},n))}var u=s.then;if("function"==typeof u){var l=new i(u.bind(s));return void l.then(function(e){r(o,e)},n)}}t[o]=s,0===--a&&e(t)}if(0===t.length)return e([]);for(var a=t.length,o=0;o<t.length;o++)r(o,t[o])})},i.reject=function(e){return new i(function(t,n){n(e)})},i.race=function(e){return new i(function(t,n){e.forEach(function(e){i.resolve(e).then(t,n)})})},i.prototype["catch"]=function(e){return this.then(null,e)}},function(e,t,n){"use strict";function r(e,t){for(var n=[],r=0;t>r;r++)n.push("a"+r);var i=["return function ("+n.join(",")+") {","var self = this;","return new Promise(function (rs, rj) {","var res = fn.call(",["self"].concat(n).concat([s]).join(","),");","if (res &&",'(typeof res === "object" || typeof res === "function") &&','typeof res.then === "function"',") {rs(res);}","});","};"].join("");return Function(["Promise","fn"],i)(a,e)}function i(e){for(var t=Math.max(e.length-1,3),n=[],r=0;t>r;r++)n.push("a"+r);var i=["return function ("+n.join(",")+") {","var self = this;","var args;","var argLength = arguments.length;","if (arguments.length > "+t+") {","args = new Array(arguments.length + 1);","for (var i = 0; i < arguments.length; i++) {","args[i] = arguments[i];","}","}","return new Promise(function (rs, rj) {","var cb = "+s+";","var res;","switch (argLength) {",n.concat(["extra"]).map(function(e,t){return"case "+t+":res = fn.call("+["self"].concat(n.slice(0,t)).concat("cb").join(",")+");break;"}).join(""),"default:","args[argLength] = cb;","res = fn.apply(self, args);","}","if (res &&",'(typeof res === "object" || typeof res === "function") &&','typeof res.then === "function"',") {rs(res);}","});","};"].join("");return Function(["Promise","fn"],i)(a,e)}var a=n(196),o=n(247);e.exports=a,a.denodeify=function(e,t){return"number"==typeof t&&t!==1/0?r(e,t):i(e)};var s="function (err, res) {if (err) { rj(err); } else { rs(res); }}";a.nodeify=function(e){return function(){var t=Array.prototype.slice.call(arguments),n="function"==typeof t[t.length-1]?t.pop():null,r=this;try{return e.apply(this,arguments).nodeify(n,r)}catch(i){if(null===n||"undefined"==typeof n)return new a(function(e,t){t(i)});o(function(){n.call(r,i)})}}},a.prototype.nodeify=function(e,t){return"function"!=typeof e?this:void this.then(function(n){o(function(){e.call(t,null,n)})},function(n){o(function(){e.call(t,n)})})}},function(e,t,n){"use strict";var r=n(196);e.exports=r,r.enableSynchronous=function(){r.prototype.isPending=function(){return 0==this.getState()},r.prototype.isFulfilled=function(){return 1==this.getState()},r.prototype.isRejected=function(){return 2==this.getState()},r.prototype.getValue=function(){if(3===this._81)return this._65.getValue();if(!this.isFulfilled())throw new Error("Cannot get a value of an unfulfilled promise.");return this._65},r.prototype.getReason=function(){if(3===this._81)return this._65.getReason();if(!this.isRejected())throw new Error("Cannot get a rejection reason of a non-rejected promise.");return this._65},r.prototype.getState=function(){return 3===this._81?this._65.getState():-1===this._81||-2===this._81?0:this._81}},r.disableSynchronous=function(){r.prototype.isPending=void 0,r.prototype.isFulfilled=void 0,r.prototype.isRejected=void 0,r.prototype.getValue=void 0,r.prototype.getReason=void 0,r.prototype.getState=void 0}},function(e,t,n){"use strict";var r=n(220),i=n(204),a={brackets:function(e){return e+"[]"},indices:function(e,t){return e+"["+t+"]"},repeat:function(e){return e}},o=Date.prototype.toISOString,s={delimiter:"&",encode:!0,encoder:r.encode,serializeDate:function(e){return o.call(e)},skipNulls:!1,strictNullHandling:!1},u=function l(e,t,n,i,a,o,s,u,p,c,f){var d=e;if("function"==typeof s)d=s(t,d);else if(d instanceof Date)d=c(d);else if(null===d){if(i)return o?o(t):t;d=""}if("string"==typeof d||"number"==typeof d||"boolean"==typeof d||r.isBuffer(d))return o?[f(o(t))+"="+f(o(d))]:[f(t)+"="+f(String(d))];var m=[];if("undefined"==typeof d)return m;var h;if(Array.isArray(s))h=s;else{var y=Object.keys(d);h=u?y.sort(u):y}for(var v=0;v<h.length;++v){var g=h[v];a&&null===d[g]||(m=Array.isArray(d)?m.concat(l(d[g],n(t,g),n,i,a,o,s,u,p,c,f)):m.concat(l(d[g],t+(p?"."+g:"["+g+"]"),n,i,a,o,s,u,p,c,f)))}return m};e.exports=function(e,t){var n=e,r=t||{},o="undefined"==typeof r.delimiter?s.delimiter:r.delimiter,l="boolean"==typeof r.strictNullHandling?r.strictNullHandling:s.strictNullHandling,p="boolean"==typeof r.skipNulls?r.skipNulls:s.skipNulls,c="boolean"==typeof r.encode?r.encode:s.encode,f=c?"function"==typeof r.encoder?r.encoder:s.encoder:null,d="function"==typeof r.sort?r.sort:null,m="undefined"==typeof r.allowDots?!1:r.allowDots,h="function"==typeof r.serializeDate?r.serializeDate:s.serializeDate;if("undefined"==typeof r.format)r.format=i["default"];else if(!Object.prototype.hasOwnProperty.call(i.formatters,r.format))throw new TypeError("Unknown format option provided.");var y,v,g=i.formatters[r.format];if(null!==r.encoder&&void 0!==r.encoder&&"function"!=typeof r.encoder)throw new TypeError("Encoder has to be a function.");"function"==typeof r.filter?(v=r.filter,n=v("",n)):Array.isArray(r.filter)&&(v=r.filter,y=v);var A=[];if("object"!=typeof n||null===n)return"";var S;S=r.arrayFormat in a?r.arrayFormat:"indices"in r?r.indices?"indices":"repeat":"indices";
var E=a[S];y||(y=Object.keys(n)),d&&y.sort(d);for(var T=0;T<y.length;++T){var b=y[T];p&&null===n[b]||(A=A.concat(u(n[b],b,E,l,p,f,v,d,m,h,g)))}return A.join(o)}},function(e,t,n){"use strict";var r=n(220),i=Object.prototype.hasOwnProperty,a={allowDots:!1,allowPrototypes:!1,arrayLimit:20,decoder:r.decode,delimiter:"&",depth:5,parameterLimit:1e3,plainObjects:!1,strictNullHandling:!1},o=function(e,t){for(var n={},r=e.split(t.delimiter,t.parameterLimit===1/0?void 0:t.parameterLimit),a=0;a<r.length;++a){var o,s,u=r[a],l=-1===u.indexOf("]=")?u.indexOf("="):u.indexOf("]=")+1;-1===l?(o=t.decoder(u),s=t.strictNullHandling?null:""):(o=t.decoder(u.slice(0,l)),s=t.decoder(u.slice(l+1))),i.call(n,o)?n[o]=[].concat(n[o]).concat(s):n[o]=s}return n},s=function l(e,t,n){if(!e.length)return t;var r,i=e.shift();if("[]"===i)r=[],r=r.concat(l(e,t,n));else{r=n.plainObjects?Object.create(null):{};var a="["===i[0]&&"]"===i[i.length-1]?i.slice(1,i.length-1):i,o=parseInt(a,10);!isNaN(o)&&i!==a&&String(o)===a&&o>=0&&n.parseArrays&&o<=n.arrayLimit?(r=[],r[o]=l(e,t,n)):r[a]=l(e,t,n)}return r},u=function(e,t,n){if(e){var r=n.allowDots?e.replace(/\.([^\.\[]+)/g,"[$1]"):e,a=/^([^\[\]]*)/,o=/(\[[^\[\]]*\])/g,u=a.exec(r),l=[];if(u[1]){if(!n.plainObjects&&i.call(Object.prototype,u[1])&&!n.allowPrototypes)return;l.push(u[1])}for(var p=0;null!==(u=o.exec(r))&&p<n.depth;)p+=1,(n.plainObjects||!i.call(Object.prototype,u[1].replace(/\[|\]/g,""))||n.allowPrototypes)&&l.push(u[1]);return u&&l.push("["+r.slice(u.index)+"]"),s(l,t,n)}};e.exports=function(e,t){var n=t||{};if(null!==n.decoder&&void 0!==n.decoder&&"function"!=typeof n.decoder)throw new TypeError("Decoder has to be a function.");if(n.delimiter="string"==typeof n.delimiter||r.isRegExp(n.delimiter)?n.delimiter:a.delimiter,n.depth="number"==typeof n.depth?n.depth:a.depth,n.arrayLimit="number"==typeof n.arrayLimit?n.arrayLimit:a.arrayLimit,n.parseArrays=n.parseArrays!==!1,n.decoder="function"==typeof n.decoder?n.decoder:a.decoder,n.allowDots="boolean"==typeof n.allowDots?n.allowDots:a.allowDots,n.plainObjects="boolean"==typeof n.plainObjects?n.plainObjects:a.plainObjects,n.allowPrototypes="boolean"==typeof n.allowPrototypes?n.allowPrototypes:a.allowPrototypes,n.parameterLimit="number"==typeof n.parameterLimit?n.parameterLimit:a.parameterLimit,n.strictNullHandling="boolean"==typeof n.strictNullHandling?n.strictNullHandling:a.strictNullHandling,""===e||null===e||"undefined"==typeof e)return n.plainObjects?Object.create(null):{};for(var i="string"==typeof e?o(e,n):e,s=n.plainObjects?Object.create(null):{},l=Object.keys(i),p=0;p<l.length;++p){var c=l[p],f=u(c,i[c],n);s=r.merge(s,f,n)}return r.compact(s)}},function(e,t,n){"use strict";var r=String.prototype.replace,i=/%20/g;e.exports={"default":"RFC3986",formatters:{RFC1738:function(e){return r.call(e,i,"+")},RFC3986:function(e){return e}},RFC1738:"RFC1738",RFC3986:"RFC3986"}},function(e,t,n){var r,i;/**
	 * @preserve date-and-time.js (c) KNOWLEDGECODE | MIT
	 */
!function(a){"use strict";var o={},s="en",u={en:{MMMM:["January","February","March","April","May","June","July","August","September","October","November","December"],MMM:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dddd:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],ddd:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dd:["Su","Mo","Tu","We","Th","Fr","Sa"],A:["a.m.","p.m."],formats:{YYYY:function(e){return("000"+e.getFullYear()).slice(-4)},YY:function(e){return("0"+e.getFullYear()).slice(-2)},Y:function(e){return""+e.getFullYear()},MMMM:function(e){return this.MMMM[e.getMonth()]},MMM:function(e){return this.MMM[e.getMonth()]},MM:function(e){return("0"+(e.getMonth()+1)).slice(-2)},M:function(e){return""+(e.getMonth()+1)},DD:function(e){return("0"+e.getDate()).slice(-2)},D:function(e){return""+e.getDate()},HH:function(e){return("0"+e.getHours()).slice(-2)},H:function(e){return""+e.getHours()},A:function(e){return this.A[e.getHours()>11|0]},hh:function(e){return("0"+(e.getHours()%12||12)).slice(-2)},h:function(e){return""+(e.getHours()%12||12)},mm:function(e){return("0"+e.getMinutes()).slice(-2)},m:function(e){return""+e.getMinutes()},ss:function(e){return("0"+e.getSeconds()).slice(-2)},s:function(e){return""+e.getSeconds()},SSS:function(e){return("00"+e.getMilliseconds()).slice(-3)},SS:function(e){return("0"+(e.getMilliseconds()/10|0)).slice(-2)},S:function(e){return""+(e.getMilliseconds()/100|0)},dddd:function(e){return this.dddd[e.getDay()]},ddd:function(e){return this.ddd[e.getDay()]},dd:function(e){return this.dd[e.getDay()]},Z:function(e){var t=e.utc?0:e.getTimezoneOffset()/.6;return(t>0?"-":"+")+("000"+Math.abs(t-t%100*.4)).slice(-4)},post:function(e){return e}},parsers:{h:function(e,t){return(12===e?0:e)+12*t},pre:function(e){return e}}}},l=function(){return"object"==typeof e&&"object"==typeof e.exports},p=function(e,t){for(var n=0,r=e.length;r>n&&0!==t(e[n],n);n++);},c=function(e,t){var n,r,i,a=0,o=t.match(/YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|./g),l={Y:0,M:1,D:1,A:0,H:0,h:0,m:0,s:0,S:0};return e=u[s].parsers.pre(e),p(o,function(t){n=t.charAt(0),r=t.length,i=e.slice(a),/^(MM|DD|HH|hh|mm|ss|SS?S?)$/.test(t)?l[n]=0|i.slice(0,r):/^(YYYY|YY|M|D|H|h|m|s)$/.test(t)?(i=(i.match(4===r?/^\d{1,4}/:/^\d\d?/)||[""])[0],r=i.length,l[n]=0|i,"Y"===n&&l.Y<70&&(l.Y+=2e3)):/^(MMMM?|A)$/.test(t)&&p(u[s][t],function(e,t){return i.indexOf(e)?void 0:(l[n]="M"===n?t+1:t,r=e.length,0)}),a+=r}),l},f=function(e,t){return u[s].parsers.h(e,t)};o.format=function(e,t,n){var r=new Date(e.getTime()+(n?6e4*e.getTimezoneOffset():0)),i=u[s],a=i.formats;return r.utc=n,t.replace(/(\[[^\[\]]*]|\[.*\][^\[]*\]|YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|ddd?d?|.)/g,function(e){var t=a[e];return t?a.post(t.call(i,r)):e.replace(/\[(.*)]/,"$1")})},o.parse=function(e,t,n){var r=c(e,t),i=new Date(r.Y,r.M-1,r.D,r.H||f(r.h,r.A),r.m,r.s,r.S);return n?new Date(i.getTime()-6e4*i.getTimezoneOffset()):i},o.isValid=function(e,t){var n=c(e,t),r=n.H||f(n.h,n.A),i=new Date(n.Y,n.M-1,n.D,r,n.m,n.s,n.S);return n.Y===i.getFullYear()&&n.M-1===i.getMonth()&&n.D===i.getDate()&&r===i.getHours()&&n.m===i.getMinutes()&&n.s===i.getSeconds()&&n.S===i.getMilliseconds()},o.addYears=function(e,t){var n=new Date(e.getTime());return n.setFullYear(n.getFullYear()+t),n},o.addMonths=function(e,t){var n=new Date(e.getTime());return n.setMonth(n.getMonth()+t),n},o.addDays=function(e,t){return new Date(e.getTime()+864e5*t)},o.addHours=function(e,t){return new Date(e.getTime()+36e5*t)},o.addMinutes=function(e,t){return new Date(e.getTime()+6e4*t)},o.addSeconds=function(e,t){return new Date(e.getTime()+1e3*t)},o.addMilliseconds=function(e,t){return new Date(e.getTime()+t)},o.subtract=function(e,t){var n=e.getTime()-t.getTime();return{toMilliseconds:function(){return n},toSeconds:function(){return n/1e3|0},toMinutes:function(){return n/6e4|0},toHours:function(){return n/36e5|0},toDays:function(){return n/864e5|0}}},o.isLeapYear=function(e){var t=e.getFullYear();return!((t%4||!(t%100))&&t%400)},o.locale=function(e){return e&&("en"!==e&&l()&&n(221)("./"+e),s=e),s},o.getLocales=function(e){return u[e||s]},o.setLocales=function(e,t){var n=function(e,t){var n,r,i=function(){};i.prototype=t,n=new i;for(r in e)e.hasOwnProperty(r)&&(n[r]=e[r]);return n},r=u[e]||u.en,i=n(t,r);t.formats&&(i.formats=n(t.formats,r.formats)),t.parsers&&(i.parsers=n(t.parsers,r.parsers)),u[e]=i},l()?e.exports=o:(r=[],i=function(){return o}.apply(t,r),!(void 0!==i&&(e.exports=i)))}(this)},function(e,t,n){function r(){}function i(e,t,n,r,i){function p(e){if(e>65535){e-=65536;var t=55296+(e>>10),n=56320+(1023&e);return String.fromCharCode(t,n)}return String.fromCharCode(e)}function m(e){var t=e.slice(1,-1);return t in n?n[t]:"#"===t.charAt(0)?p(parseInt(t.substr(1).replace("x","0x"))):(i.error("entity not found:"+e),e)}function h(t){if(t>b){var n=e.substring(b,t).replace(/&#?\w+;/g,m);S&&y(b),r.characters(n,0,t-b),b=t}}function y(t,n){for(;t>=g&&(n=A.exec(e));)v=n.index,g=v+n[0].length,S.lineNumber++;S.columnNumber=t-v+1}for(var v=0,g=0,A=/.+(?:\r\n?|\n)|.*$/g,S=r.locator,E=[{currentNSMap:t}],T={},b=0;;){try{var N=e.indexOf("<",b);if(0>N){if(!e.substr(b).match(/^\s*$/)){var _=r.document,w=_.createTextNode(e.substr(b));_.appendChild(w),r.currentElement=w}return}switch(N>b&&h(N),e.charAt(N+1)){case"/":var M=e.indexOf(">",N+3),I=e.substring(N+2,M),R=E.pop(),C=R.localNSMap;if(R.tagName!=I&&i.fatalError("end tag name: "+I+" is not match the current start tagName:"+R.tagName),r.endElement(R.uri,R.localName,I),C)for(var L in C)r.endPrefixMapping(L);M++;break;case"?":S&&y(N),M=f(e,N,r);break;case"!":S&&y(N),M=c(e,N,r,i);break;default:S&&y(N);var P=new d,M=o(e,N,P,m,i),O=P.length;if(S){if(O)for(var D=0;O>D;D++){var x=P[D];y(x.offset),x.offset=a(S,{})}y(M)}!P.closed&&l(e,M,P.tagName,T)&&(P.closed=!0,n.nbsp||i.warning("unclosed xml attribute")),s(P,r,E),"http://www.w3.org/1999/xhtml"!==P.uri||P.closed?M++:M=u(e,M,P.tagName,m,r)}}catch(U){i.error("element parse error: "+U),M=-1}M>b?b=M:h(Math.max(N,b)+1)}}function a(e,t){return t.lineNumber=e.lineNumber,t.columnNumber=e.columnNumber,t}function o(e,t,n,r,i){for(var a,o,s=++t,u=A;;){var l=e.charAt(s);switch(l){case"=":if(u===S)a=e.slice(t,s),u=T;else{if(u!==E)throw new Error("attribute equal must after attrName");u=T}break;case"'":case'"':if(u===T){if(t=s+1,s=e.indexOf(l,t),!(s>0))throw new Error("attribute value no end '"+l+"' match");o=e.slice(t,s).replace(/&#?\w+;/g,r),n.add(a,o,t-1),u=N}else{if(u!=b)throw new Error('attribute value must after "="');o=e.slice(t,s).replace(/&#?\w+;/g,r),n.add(a,o,t),i.warning('attribute "'+a+'" missed start quot('+l+")!!"),t=s+1,u=N}break;case"/":switch(u){case A:n.setTagName(e.slice(t,s));case N:case _:case w:u=w,n.closed=!0;case b:case S:case E:break;default:throw new Error("attribute invalid close char('/')")}break;case"":i.error("unexpected end of input");case">":switch(u){case A:n.setTagName(e.slice(t,s));case N:case _:case w:break;case b:case S:o=e.slice(t,s),"/"===o.slice(-1)&&(n.closed=!0,o=o.slice(0,-1));case E:u===E&&(o=a),u==b?(i.warning('attribute "'+o+'" missed quot(")!!'),n.add(a,o.replace(/&#?\w+;/g,r),t)):(i.warning('attribute "'+o+'" missed value!! "'+o+'" instead!!'),n.add(o,o,t));break;case T:throw new Error("attribute value missed!!")}return s;case"":l=" ";default:if(" ">=l)switch(u){case A:n.setTagName(e.slice(t,s)),u=_;break;case S:a=e.slice(t,s),u=E;break;case b:var o=e.slice(t,s).replace(/&#?\w+;/g,r);i.warning('attribute "'+o+'" missed quot(")!!'),n.add(a,o,t);case N:u=_}else switch(u){case E:i.warning('attribute "'+a+'" missed value!! "'+a+'" instead!!'),n.add(a,a,t),t=s,u=S;break;case N:i.warning('attribute space is required"'+a+'"!!');case _:u=S,t=s;break;case T:u=b,t=s;break;case w:throw new Error("elements closed character '/' and '>' must be connected to")}}s++}}function s(e,t,n){for(var r=e.tagName,i=null,a=n[n.length-1].currentNSMap,o=e.length;o--;){var s=e[o],u=s.qName,l=s.value,c=u.indexOf(":");if(c>0)var f=s.prefix=u.slice(0,c),d=u.slice(c+1),m="xmlns"===f&&d;else d=u,f=null,m="xmlns"===u&&"";s.localName=d,m!==!1&&(null==i&&(i={},p(a,a={})),a[m]=i[m]=l,s.uri="http://www.w3.org/2000/xmlns/",t.startPrefixMapping(m,l))}for(var o=e.length;o--;){s=e[o];var f=s.prefix;f&&("xml"===f&&(s.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==f&&(s.uri=a[f]))}var c=r.indexOf(":");c>0?(f=e.prefix=r.slice(0,c),d=e.localName=r.slice(c+1)):(f=null,d=e.localName=r);var h=e.uri=a[f||""];if(t.startElement(h,d,r,e),e.closed){if(t.endElement(h,d,r),i)for(f in i)t.endPrefixMapping(f)}else e.currentNSMap=a,e.localNSMap=i,n.push(e)}function u(e,t,n,r,i){if(/^(?:script|textarea)$/i.test(n)){var a=e.indexOf("</"+n+">",t),o=e.substring(t+1,a);if(/[&<]/.test(o))return/^script$/i.test(n)?(i.characters(o,0,o.length),a):(o=o.replace(/&#?\w+;/g,r),i.characters(o,0,o.length),a)}return t+1}function l(e,t,n,r){var i=r[n];return null==i&&(i=r[n]=e.lastIndexOf("</"+n+">")),t>i}function p(e,t){for(var n in e)t[n]=e[n]}function c(e,t,n,r){var i=e.charAt(t+2);switch(i){case"-":if("-"===e.charAt(t+3)){var a=e.indexOf("-->",t+4);return a>t?(n.comment(e,t+4,a-t-4),a+3):(r.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==e.substr(t+3,6)){var a=e.indexOf("]]>",t+9);return n.startCDATA(),n.characters(e,t+9,a-t-9),n.endCDATA(),a+3}var o=h(e,t),s=o.length;if(s>1&&/!doctype/i.test(o[0][0])){var u=o[1][0],l=s>3&&/^public$/i.test(o[2][0])&&o[3][0],p=s>4&&o[4][0],c=o[s-1];return n.startDTD(u,l&&l.replace(/^(['"])(.*?)\1$/,"$2"),p&&p.replace(/^(['"])(.*?)\1$/,"$2")),n.endDTD(),c.index+c[0].length}}return-1}function f(e,t,n){var r=e.indexOf("?>",t);if(r){var i=e.substring(t,r).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(i){i[0].length;return n.processingInstruction(i[1],i[2]),r+2}return-1}return-1}function d(e){}function m(e,t){return e.__proto__=t,e}function h(e,t){var n,r=[],i=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(i.lastIndex=t,i.exec(e);n=i.exec(e);)if(r.push(n),n[1])return r}var y=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,v=new RegExp("[\\-\\.0-9"+y.source.slice(1,-1)+"·̀-ͯ\\u203F-⁀]"),g=new RegExp("^"+y.source+v.source+"*(?::"+y.source+v.source+"*)?$"),A=0,S=1,E=2,T=3,b=4,N=5,_=6,w=7;r.prototype={parse:function(e,t,n){var r=this.domBuilder;r.startDocument(),p(t,t={}),i(e,t,n,r,this.errorHandler),r.endDocument()}},d.prototype={setTagName:function(e){if(!g.test(e))throw new Error("invalid tagName:"+e);this.tagName=e},add:function(e,t,n){if(!g.test(e))throw new Error("invalid attribute:"+e);this[this.length++]={qName:e,value:t,offset:n}},length:0,getLocalName:function(e){return this[e].localName},getOffset:function(e){return this[e].offset},getQName:function(e){return this[e].qName},getURI:function(e){return this[e].uri},getValue:function(e){return this[e].value}},m({},m.prototype)instanceof m||(m=function(e,t){function n(){}n.prototype=t,n=new n;for(t in e)n[t]=e[t];return n}),t.XMLReader=r},function(e,t,n){function r(e,t){for(var n in e)t[n]=e[n]}function i(e,t){function n(){}var i=e.prototype;if(Object.create){var a=Object.create(t.prototype);i.__proto__=a}i instanceof t||(n.prototype=t.prototype,n=new n,r(i,n),e.prototype=i=n),i.constructor!=e&&("function"!=typeof e&&console.error("unknow Class:"+e),i.constructor=e)}function a(e,t){if(t instanceof Error)var n=t;else n=this,Error.call(this,re[e]),this.message=re[e],Error.captureStackTrace&&Error.captureStackTrace(this,a);return n.code=e,t&&(this.message=this.message+": "+t),n}function o(){}function s(e,t){this._node=e,this._refresh=t,u(this)}function u(e){var t=e._node._inc||e._node.ownerDocument._inc;if(e._inc!=t){var n=e._refresh(e._node);K(e,"length",n.length),r(n,e),e._inc=t}}function l(){}function p(e,t){for(var n=e.length;n--;)if(e[n]===t)return n}function c(e,t,n,r){if(r?t[p(t,r)]=n:t[t.length++]=n,e){n.ownerElement=e;var i=e.ownerDocument;i&&(r&&A(i,e,r),g(i,e,n))}}function f(e,t,n){var r=p(t,n);if(!(r>=0))throw a(ie,new Error);for(var i=t.length-1;i>r;)t[r]=t[++r];if(t.length=i,e){var o=e.ownerDocument;o&&(A(o,e,n),n.ownerElement=null)}}function d(e){if(this._features={},e)for(var t in e)this._features=e[t]}function m(){}function h(e){return"<"==e&&"&lt;"||">"==e&&"&gt;"||"&"==e&&"&amp;"||'"'==e&&"&quot;"||"&#"+e.charCodeAt()+";"}function y(e,t){if(t(e))return!0;if(e=e.firstChild)do if(y(e,t))return!0;while(e=e.nextSibling)}function v(){}function g(e,t,n){e&&e._inc++;var r=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==r&&(t._nsMap[n.prefix?n.localName:""]=n.value)}function A(e,t,n,r){e&&e._inc++;var i=n.namespaceURI;"http://www.w3.org/2000/xmlns/"==i&&delete t._nsMap[n.prefix?n.localName:""]}function S(e,t,n){if(e&&e._inc){e._inc++;var r=t.childNodes;if(n)r[r.length++]=n;else{for(var i=t.firstChild,a=0;i;)r[a++]=i,i=i.nextSibling;r.length=a}}}function E(e,t){var n=t.previousSibling,r=t.nextSibling;return n?n.nextSibling=r:e.firstChild=r,r?r.previousSibling=n:e.lastChild=n,S(e.ownerDocument,e),t}function T(e,t,n){var r=t.parentNode;if(r&&r.removeChild(t),t.nodeType===ee){var i=t.firstChild;if(null==i)return t;var a=t.lastChild}else i=a=t;var o=n?n.previousSibling:e.lastChild;i.previousSibling=o,a.nextSibling=n,o?o.nextSibling=i:e.firstChild=i,null==n?e.lastChild=a:n.previousSibling=a;do i.parentNode=e;while(i!==a&&(i=i.nextSibling));return S(e.ownerDocument||e,e),t.nodeType==ee&&(t.firstChild=t.lastChild=null),t}function b(e,t){var n=t.parentNode;if(n){var r=e.lastChild;n.removeChild(t);var r=e.lastChild}var r=e.lastChild;return t.parentNode=e,t.previousSibling=r,t.nextSibling=null,r?r.nextSibling=t:e.firstChild=t,e.lastChild=t,S(e.ownerDocument,e,t),t}function N(){this._nsMap={}}function _(){}function w(){}function M(){}function I(){}function R(){}function C(){}function L(){}function P(){}function O(){}function D(){}function x(){}function U(){}function k(e,t,n,r){switch(e.nodeType){case q:var i=e.attributes,a=i.length,o=e.firstChild,s=e.tagName;r=j===e.namespaceURI||r,t.push("<",s),n&&t.sort.apply(i,n);for(var u=0;a>u;u++)k(i.item(u),t,n,r);if(o||r&&!/^(?:meta|link|img|br|hr|input|button)$/i.test(s)){if(t.push(">"),r&&/^script$/i.test(s))o&&t.push(o.data);else for(;o;)k(o,t,n,r),o=o.nextSibling;t.push("</",s,">")}else t.push("/>");return;case Q:case ee:for(var o=e.firstChild;o;)k(o,t,n,r),o=o.nextSibling;return;case Y:return t.push(" ",e.name,'="',e.value.replace(/[<&"]/g,h),'"');case H:return t.push(e.data.replace(/[<&]/g,h));case $:return t.push("<![CDATA[",e.data,"]]>");case J:return t.push("<!--",e.data,"-->");case Z:var l=e.publicId,p=e.systemId;if(t.push("<!DOCTYPE ",e.name),l)t.push(' PUBLIC "',l),p&&"."!=p&&t.push('" "',p),t.push('">');else if(p&&"."!=p)t.push(' SYSTEM "',p,'">');else{var c=e.internalSubset;c&&t.push(" [",c,"]"),t.push(">")}return;case z:return t.push("<?",e.target," ",e.data,"?>");case G:return t.push("&",e.nodeName,";");default:t.push("??",e.nodeName)}}function F(e,t,n){var r;switch(t.nodeType){case q:r=t.cloneNode(!1),r.ownerDocument=e;case ee:break;case Y:n=!0}if(r||(r=t.cloneNode(!1)),r.ownerDocument=e,r.parentNode=null,n)for(var i=t.firstChild;i;)r.appendChild(F(e,i,n)),i=i.nextSibling;return r}function B(e,t,n){var r=new t.constructor;for(var i in t){var a=t[i];"object"!=typeof a&&a!=r[i]&&(r[i]=a)}switch(t.childNodes&&(r.childNodes=new o),r.ownerDocument=e,r.nodeType){case q:var s=t.attributes,u=r.attributes=new l,p=s.length;u._ownerElement=r;for(var c=0;p>c;c++)r.setAttributeNode(B(e,s.item(c),!0));break;case Y:n=!0}if(n)for(var f=t.firstChild;f;)r.appendChild(B(e,f,n)),f=f.nextSibling;return r}function K(e,t,n){e[t]=n}function V(e){switch(e.nodeType){case 1:case 11:var t=[];for(e=e.firstChild;e;)7!==e.nodeType&&8!==e.nodeType&&t.push(V(e)),e=e.nextSibling;return t.join("");default:return e.nodeValue}}var j="http://www.w3.org/1999/xhtml",W={},q=W.ELEMENT_NODE=1,Y=W.ATTRIBUTE_NODE=2,H=W.TEXT_NODE=3,$=W.CDATA_SECTION_NODE=4,G=W.ENTITY_REFERENCE_NODE=5,X=W.ENTITY_NODE=6,z=W.PROCESSING_INSTRUCTION_NODE=7,J=W.COMMENT_NODE=8,Q=W.DOCUMENT_NODE=9,Z=W.DOCUMENT_TYPE_NODE=10,ee=W.DOCUMENT_FRAGMENT_NODE=11,te=W.NOTATION_NODE=12,ne={},re={},ie=(ne.INDEX_SIZE_ERR=(re[1]="Index size error",1),ne.DOMSTRING_SIZE_ERR=(re[2]="DOMString size error",2),ne.HIERARCHY_REQUEST_ERR=(re[3]="Hierarchy request error",3),ne.WRONG_DOCUMENT_ERR=(re[4]="Wrong document",4),ne.INVALID_CHARACTER_ERR=(re[5]="Invalid character",5),ne.NO_DATA_ALLOWED_ERR=(re[6]="No data allowed",6),ne.NO_MODIFICATION_ALLOWED_ERR=(re[7]="No modification allowed",7),ne.NOT_FOUND_ERR=(re[8]="Not found",8)),ae=(ne.NOT_SUPPORTED_ERR=(re[9]="Not supported",9),ne.INUSE_ATTRIBUTE_ERR=(re[10]="Attribute in use",10));ne.INVALID_STATE_ERR=(re[11]="Invalid state",11),ne.SYNTAX_ERR=(re[12]="Syntax error",12),ne.INVALID_MODIFICATION_ERR=(re[13]="Invalid modification",13),ne.NAMESPACE_ERR=(re[14]="Invalid namespace",14),ne.INVALID_ACCESS_ERR=(re[15]="Invalid access",15);a.prototype=Error.prototype,r(ne,a),o.prototype={length:0,item:function(e){return this[e]||null},toString:function(){for(var e=[],t=0;t<this.length;t++)k(this[t],e);return e.join("")}},s.prototype.item=function(e){return u(this),this[e]},i(s,o),l.prototype={length:0,item:o.prototype.item,getNamedItem:function(e){for(var t=this.length;t--;){var n=this[t];if(n.nodeName==e)return n}},setNamedItem:function(e){var t=e.ownerElement;if(t&&t!=this._ownerElement)throw new a(ae);var n=this.getNamedItem(e.nodeName);return c(this._ownerElement,this,e,n),n},setNamedItemNS:function(e){var t,n=e.ownerElement;if(n&&n!=this._ownerElement)throw new a(ae);return t=this.getNamedItemNS(e.namespaceURI,e.localName),c(this._ownerElement,this,e,t),t},removeNamedItem:function(e){var t=this.getNamedItem(e);return f(this._ownerElement,this,t),t},removeNamedItemNS:function(e,t){var n=this.getNamedItemNS(e,t);return f(this._ownerElement,this,n),n},getNamedItemNS:function(e,t){for(var n=this.length;n--;){var r=this[n];if(r.localName==t&&r.namespaceURI==e)return r}return null}},d.prototype={hasFeature:function(e,t){var n=this._features[e.toLowerCase()];return n&&(!t||t in n)?!0:!1},createDocument:function(e,t,n){var r=new v;if(r.implementation=this,r.childNodes=new o,r.doctype=n,n&&r.appendChild(n),t){var i=r.createElementNS(e,t);r.appendChild(i)}return r},createDocumentType:function(e,t,n){var r=new C;return r.name=e,r.nodeName=e,r.publicId=t,r.systemId=n,r}},m.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(e,t){return T(this,e,t)},replaceChild:function(e,t){this.insertBefore(e,t),t&&this.removeChild(t)},removeChild:function(e){return E(this,e)},appendChild:function(e){return this.insertBefore(e,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(e){return B(this.ownerDocument||this,this,e)},normalize:function(){for(var e=this.firstChild;e;){var t=e.nextSibling;t&&t.nodeType==H&&e.nodeType==H?(this.removeChild(t),e.appendData(t.data)):(e.normalize(),e=t)}},isSupported:function(e,t){return this.ownerDocument.implementation.hasFeature(e,t)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(e){for(var t=this;t;){var n=t._nsMap;if(n)for(var r in n)if(n[r]==e)return r;t=2==t.nodeType?t.ownerDocument:t.parentNode}return null},lookupNamespaceURI:function(e){for(var t=this;t;){var n=t._nsMap;if(n&&e in n)return n[e];t=2==t.nodeType?t.ownerDocument:t.parentNode}return null},isDefaultNamespace:function(e){var t=this.lookupPrefix(e);return null==t}},r(W,m),r(W,m.prototype),v.prototype={nodeName:"#document",nodeType:Q,doctype:null,documentElement:null,_inc:1,insertBefore:function(e,t){if(e.nodeType==ee){for(var n=e.firstChild;n;){var r=n.nextSibling;this.insertBefore(n,t),n=r}return e}return null==this.documentElement&&1==e.nodeType&&(this.documentElement=e),T(this,e,t),e.ownerDocument=this,e},removeChild:function(e){return this.documentElement==e&&(this.documentElement=null),E(this,e)},importNode:function(e,t){return F(this,e,t)},getElementById:function(e){var t=null;return y(this.documentElement,function(n){return 1==n.nodeType&&n.getAttribute("id")==e?(t=n,!0):void 0}),t},createElement:function(e){var t=new N;t.ownerDocument=this,t.nodeName=e,t.tagName=e,t.childNodes=new o;var n=t.attributes=new l;return n._ownerElement=t,t},createDocumentFragment:function(){var e=new D;return e.ownerDocument=this,e.childNodes=new o,e},createTextNode:function(e){var t=new M;return t.ownerDocument=this,t.appendData(e),t},createComment:function(e){var t=new I;return t.ownerDocument=this,t.appendData(e),t},createCDATASection:function(e){var t=new R;return t.ownerDocument=this,t.appendData(e),t},createProcessingInstruction:function(e,t){var n=new x;return n.ownerDocument=this,n.tagName=n.target=e,n.nodeValue=n.data=t,n},createAttribute:function(e){var t=new _;return t.ownerDocument=this,t.name=e,t.nodeName=e,t.localName=e,t.specified=!0,t},createEntityReference:function(e){var t=new O;return t.ownerDocument=this,t.nodeName=e,t},createElementNS:function(e,t){var n=new N,r=t.split(":"),i=n.attributes=new l;return n.childNodes=new o,n.ownerDocument=this,n.nodeName=t,n.tagName=t,n.namespaceURI=e,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,i._ownerElement=n,n},createAttributeNS:function(e,t){var n=new _,r=t.split(":");return n.ownerDocument=this,n.nodeName=t,n.name=t,n.namespaceURI=e,n.specified=!0,2==r.length?(n.prefix=r[0],n.localName=r[1]):n.localName=t,n}},i(v,m),N.prototype={nodeType:q,hasAttribute:function(e){return null!=this.getAttributeNode(e)},getAttribute:function(e){var t=this.getAttributeNode(e);return t&&t.value||""},getAttributeNode:function(e){return this.attributes.getNamedItem(e)},setAttribute:function(e,t){var n=this.ownerDocument.createAttribute(e);n.value=n.nodeValue=""+t,this.setAttributeNode(n)},removeAttribute:function(e){var t=this.getAttributeNode(e);t&&this.removeAttributeNode(t)},appendChild:function(e){return e.nodeType===ee?this.insertBefore(e,null):b(this,e)},setAttributeNode:function(e){return this.attributes.setNamedItem(e)},setAttributeNodeNS:function(e){return this.attributes.setNamedItemNS(e)},removeAttributeNode:function(e){return this.attributes.removeNamedItem(e.nodeName)},removeAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);n&&this.removeAttributeNode(n)},hasAttributeNS:function(e,t){return null!=this.getAttributeNodeNS(e,t)},getAttributeNS:function(e,t){var n=this.getAttributeNodeNS(e,t);return n&&n.value||""},setAttributeNS:function(e,t,n){var r=this.ownerDocument.createAttributeNS(e,t);r.value=r.nodeValue=""+n,this.setAttributeNode(r)},getAttributeNodeNS:function(e,t){return this.attributes.getNamedItemNS(e,t)},getElementsByTagName:function(e){return new s(this,function(t){var n=[];return y(t,function(r){r===t||r.nodeType!=q||"*"!==e&&r.tagName!=e||n.push(r)}),n})},getElementsByTagNameNS:function(e,t){return new s(this,function(n){var r=[];return y(n,function(i){i===n||i.nodeType!==q||"*"!==e&&i.namespaceURI!==e||"*"!==t&&i.localName!=t||r.push(i)}),r})}},v.prototype.getElementsByTagName=N.prototype.getElementsByTagName,v.prototype.getElementsByTagNameNS=N.prototype.getElementsByTagNameNS,i(N,m),_.prototype.nodeType=Y,i(_,m),w.prototype={data:"",substringData:function(e,t){return this.data.substring(e,e+t)},appendData:function(e){e=this.data+e,this.nodeValue=this.data=e,this.length=e.length},insertData:function(e,t){this.replaceData(e,0,t)},appendChild:function(e){throw new Error(re[3])},deleteData:function(e,t){this.replaceData(e,t,"")},replaceData:function(e,t,n){var r=this.data.substring(0,e),i=this.data.substring(e+t);n=r+n+i,this.nodeValue=this.data=n,this.length=n.length}},i(w,m),M.prototype={nodeName:"#text",nodeType:H,splitText:function(e){var t=this.data,n=t.substring(e);t=t.substring(0,e),this.data=this.nodeValue=t,this.length=t.length;var r=this.ownerDocument.createTextNode(n);return this.parentNode&&this.parentNode.insertBefore(r,this.nextSibling),r}},i(M,w),I.prototype={nodeName:"#comment",nodeType:J},i(I,w),R.prototype={nodeName:"#cdata-section",nodeType:$},i(R,w),C.prototype.nodeType=Z,i(C,m),L.prototype.nodeType=te,i(L,m),P.prototype.nodeType=X,i(P,m),O.prototype.nodeType=G,i(O,m),D.prototype.nodeName="#document-fragment",D.prototype.nodeType=ee,i(D,m),x.prototype.nodeType=z,i(x,m),U.prototype.serializeToString=function(e,t){return e.toString(t)},m.prototype.toString=function(e){var t=[];return k(this,t,e),t.join("")};try{Object.defineProperty&&(Object.defineProperty(s.prototype,"length",{get:function(){return u(this),this.$$length}}),Object.defineProperty(m.prototype,"textContent",{get:function(){return V(this)},set:function(e){switch(this.nodeType){case 1:case 11:for(;this.firstChild;)this.removeChild(this.firstChild);(e||String(e))&&this.appendChild(this.ownerDocument.createTextNode(e));break;default:this.data=e,this.value=value,this.nodeValue=e}}}),K=function(e,t,n){e["$$"+t]=n})}catch(oe){}t.DOMImplementation=d,t.XMLSerializer=U},function(e,t,n){(function(){"use strict";var e,r,i,a,o,s,u,l,p,c,f,d=function(e,t){function n(){this.constructor=e}for(var r in t)m.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},m={}.hasOwnProperty,h=function(e,t){return function(){return e.apply(t,arguments)}};p=n(254),a=n(211),r=n(255),e=n(227),u=n(228),c=n(248).setImmediate,o=function(e){return"object"==typeof e&&null!=e&&0===Object.keys(e).length},s=function(e,t){var n,r,i;for(n=0,r=e.length;r>n;n++)i=e[n],t=i(t);return t},l=function(e){return e.indexOf("&")>=0||e.indexOf(">")>=0||e.indexOf("<")>=0},f=function(e){return"<![CDATA["+i(e)+"]]>"},i=function(e){return e.replace("]]>","]]]]><![CDATA[>")},t.processors=u,t.defaults={.1:{explicitCharkey:!1,trim:!0,normalize:!0,normalizeTags:!1,attrkey:"@",charkey:"#",explicitArray:!1,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!1,validator:null,xmlns:!1,explicitChildren:!1,childkey:"@@",charsAsChildren:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,emptyTag:""},.2:{explicitCharkey:!1,trim:!1,normalize:!1,normalizeTags:!1,attrkey:"$",charkey:"_",explicitArray:!0,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!0,validator:null,xmlns:!1,explicitChildren:!1,preserveChildrenOrder:!1,childkey:"$$",charsAsChildren:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,rootName:"root",xmldec:{version:"1.0",encoding:"UTF-8",standalone:!0},doctype:null,renderOpts:{pretty:!0,indent:"  ",newline:"\n"},headless:!1,chunkSize:1e4,emptyTag:"",cdata:!1}},t.ValidationError=function(e){function t(e){this.message=e}return d(t,e),t}(Error),t.Builder=function(){function e(e){var n,r,i;this.options={},r=t.defaults[.2];for(n in r)m.call(r,n)&&(i=r[n],this.options[n]=i);for(n in e)m.call(e,n)&&(i=e[n],this.options[n]=i)}return e.prototype.buildObject=function(e){var n,i,a,o,s;return n=this.options.attrkey,i=this.options.charkey,1===Object.keys(e).length&&this.options.rootName===t.defaults[.2].rootName?(s=Object.keys(e)[0],e=e[s]):s=this.options.rootName,a=function(e){return function(t,r){var o,s,u,p,c,d;if("object"!=typeof r)e.options.cdata&&l(r)?t.raw(f(r)):t.txt(r);else for(c in r)if(m.call(r,c))if(s=r[c],c===n){if("object"==typeof s)for(o in s)d=s[o],t=t.att(o,d)}else if(c===i)t=e.options.cdata&&l(s)?t.raw(f(s)):t.txt(s);else if(Array.isArray(s))for(p in s)m.call(s,p)&&(u=s[p],t="string"==typeof u?e.options.cdata&&l(u)?t.ele(c).raw(f(u)).up():t.ele(c,u).up():a(t.ele(c),u).up());else"object"==typeof s?t=a(t.ele(c),s).up():"string"==typeof s&&e.options.cdata&&l(s)?t=t.ele(c).raw(f(s)).up():(null==s&&(s=""),t=t.ele(c,s.toString()).up());return t}}(this),o=r.create(s,this.options.xmldec,this.options.doctype,{headless:this.options.headless,allowSurrogateChars:this.options.allowSurrogateChars}),a(o,e).end(this.options.renderOpts)},e}(),t.Parser=function(n){function r(e){this.parseString=h(this.parseString,this),this.reset=h(this.reset,this),this.assignOrPush=h(this.assignOrPush,this),this.processAsync=h(this.processAsync,this);var n,r,i;if(!(this instanceof t.Parser))return new t.Parser(e);this.options={},r=t.defaults[.2];for(n in r)m.call(r,n)&&(i=r[n],this.options[n]=i);for(n in e)m.call(e,n)&&(i=e[n],this.options[n]=i);this.options.xmlns&&(this.options.xmlnskey=this.options.attrkey+"ns"),this.options.normalizeTags&&(this.options.tagNameProcessors||(this.options.tagNameProcessors=[]),this.options.tagNameProcessors.unshift(u.normalize)),this.reset()}return d(r,n),r.prototype.processAsync=function(){var e,t,n;try{return this.remaining.length<=this.options.chunkSize?(e=this.remaining,this.remaining="",this.saxParser=this.saxParser.write(e),this.saxParser.close()):(e=this.remaining.substr(0,this.options.chunkSize),this.remaining=this.remaining.substr(this.options.chunkSize,this.remaining.length),this.saxParser=this.saxParser.write(e),c(this.processAsync))}catch(n){if(t=n,!this.saxParser.errThrown)return this.saxParser.errThrown=!0,this.emit(t)}},r.prototype.assignOrPush=function(e,t,n){return t in e?(e[t]instanceof Array||(e[t]=[e[t]]),e[t].push(n)):this.options.explicitArray?e[t]=[n]:e[t]=n},r.prototype.reset=function(){var e,t,n,r;return this.removeAllListeners(),this.saxParser=p.parser(this.options.strict,{trim:!1,normalize:!1,xmlns:this.options.xmlns}),this.saxParser.errThrown=!1,this.saxParser.onerror=function(e){return function(t){return e.saxParser.resume(),e.saxParser.errThrown?void 0:(e.saxParser.errThrown=!0,e.emit("error",t))}}(this),this.saxParser.onend=function(e){return function(){return e.saxParser.ended?void 0:(e.saxParser.ended=!0,e.emit("end",e.resultObject))}}(this),this.saxParser.ended=!1,this.EXPLICIT_CHARKEY=this.options.explicitCharkey,this.resultObject=null,r=[],e=this.options.attrkey,t=this.options.charkey,this.saxParser.onopentag=function(n){return function(i){var a,o,u,l,p;if(u={},u[t]="",!n.options.ignoreAttrs){p=i.attributes;for(a in p)m.call(p,a)&&(e in u||n.options.mergeAttrs||(u[e]={}),o=n.options.attrValueProcessors?s(n.options.attrValueProcessors,i.attributes[a]):i.attributes[a],l=n.options.attrNameProcessors?s(n.options.attrNameProcessors,a):a,n.options.mergeAttrs?n.assignOrPush(u,l,o):u[e][l]=o)}return u["#name"]=n.options.tagNameProcessors?s(n.options.tagNameProcessors,i.name):i.name,n.options.xmlns&&(u[n.options.xmlnskey]={uri:i.uri,local:i.local}),r.push(u)}}(this),this.saxParser.onclosetag=function(e){return function(){var n,i,a,u,l,p,c,f,d,h,y,v;if(f=r.pop(),c=f["#name"],e.options.explicitChildren&&e.options.preserveChildrenOrder||delete f["#name"],f.cdata===!0&&(n=f.cdata,delete f.cdata),y=r[r.length-1],f[t].match(/^\s*$/)&&!n?(i=f[t],delete f[t]):(e.options.trim&&(f[t]=f[t].trim()),e.options.normalize&&(f[t]=f[t].replace(/\s{2,}/g," ").trim()),f[t]=e.options.valueProcessors?s(e.options.valueProcessors,f[t]):f[t],1===Object.keys(f).length&&t in f&&!e.EXPLICIT_CHARKEY&&(f=f[t])),o(f)&&(f=""!==e.options.emptyTag?e.options.emptyTag:i),null!=e.options.validator){v="/"+function(){var e,t,n;for(n=[],e=0,t=r.length;t>e;e++)p=r[e],n.push(p["#name"]);return n}().concat(c).join("/");try{f=e.options.validator(v,y&&y[c],f)}catch(u){a=u,e.emit("error",a)}}if(e.options.explicitChildren&&!e.options.mergeAttrs&&"object"==typeof f)if(e.options.preserveChildrenOrder){if(y){y[e.options.childkey]=y[e.options.childkey]||[],d={};for(l in f)m.call(f,l)&&(d[l]=f[l]);y[e.options.childkey].push(d),delete f["#name"],1===Object.keys(f).length&&t in f&&!e.EXPLICIT_CHARKEY&&(f=f[t])}}else p={},e.options.attrkey in f&&(p[e.options.attrkey]=f[e.options.attrkey],delete f[e.options.attrkey]),!e.options.charsAsChildren&&e.options.charkey in f&&(p[e.options.charkey]=f[e.options.charkey],delete f[e.options.charkey]),Object.getOwnPropertyNames(f).length>0&&(p[e.options.childkey]=f),f=p;return r.length>0?e.assignOrPush(y,c,f):(e.options.explicitRoot&&(h=f,
f={},f[c]=h),e.resultObject=f,e.saxParser.ended=!0,e.emit("end",e.resultObject))}}(this),n=function(e){return function(n){var i,a;return a=r[r.length-1],a?(a[t]+=n,e.options.explicitChildren&&e.options.preserveChildrenOrder&&e.options.charsAsChildren&&""!==n.replace(/\\n/g,"").trim()&&(a[e.options.childkey]=a[e.options.childkey]||[],i={"#name":"__text__"},i[t]=n,a[e.options.childkey].push(i)),a):void 0}}(this),this.saxParser.ontext=n,this.saxParser.oncdata=function(e){return function(e){var t;return t=n(e),t?t.cdata=!0:void 0}}(this)},r.prototype.parseString=function(t,n){var r,i;null!=n&&"function"==typeof n&&(this.on("end",function(e){return this.reset(),n(null,e)}),this.on("error",function(e){return this.reset(),n(e)}));try{return t=t.toString(),""===t.trim()?(this.emit("end",null),!0):(t=e.stripBOM(t),this.options.async?(this.remaining=t,c(this.processAsync),this.saxParser):this.saxParser.write(t).close())}catch(i){if(r=i,!this.saxParser.errThrown&&!this.saxParser.ended)return this.emit("error",r),this.saxParser.errThrown=!0;if(this.saxParser.ended)throw r}},r}(a.EventEmitter),t.parseString=function(e,n,r){var i,a,o;return null!=r?("function"==typeof r&&(i=r),"object"==typeof n&&(a=n)):("function"==typeof n&&(i=n),a={}),o=new t.Parser(a),o.parseString(e,i)}}).call(this)},function(e,t,n){(function(t){"use strict";function n(e,n,r,i){if("function"!=typeof e)throw new TypeError('"callback" argument must be a function');var a,o,s=arguments.length;switch(s){case 0:case 1:return t.nextTick(e);case 2:return t.nextTick(function(){e.call(null,n)});case 3:return t.nextTick(function(){e.call(null,n,r)});case 4:return t.nextTick(function(){e.call(null,n,r,i)});default:for(a=new Array(s-1),o=0;o<a.length;)a[o++]=arguments[o];return t.nextTick(function(){e.apply(null,a)})}}!t.version||0===t.version.indexOf("v0.")||0===t.version.indexOf("v1.")&&0!==t.version.indexOf("v1.8.")?e.exports=n:e.exports=t.nextTick}).call(t,n(64))},function(e,t,n){var r={}.toString;e.exports=Array.isArray||function(e){return"[object Array]"==r.call(e)}},function(e,t,n){function r(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function i(e){return"function"==typeof e}function a(e){return"number"==typeof e}function o(e){return"object"==typeof e&&null!==e}function s(e){return void 0===e}e.exports=r,r.EventEmitter=r,r.prototype._events=void 0,r.prototype._maxListeners=void 0,r.defaultMaxListeners=10,r.prototype.setMaxListeners=function(e){if(!a(e)||0>e||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},r.prototype.emit=function(e){var t,n,r,a,u,l;if(this._events||(this._events={}),"error"===e&&(!this._events.error||o(this._events.error)&&!this._events.error.length)){if(t=arguments[1],t instanceof Error)throw t;var p=new Error('Uncaught, unspecified "error" event. ('+t+")");throw p.context=t,p}if(n=this._events[e],s(n))return!1;if(i(n))switch(arguments.length){case 1:n.call(this);break;case 2:n.call(this,arguments[1]);break;case 3:n.call(this,arguments[1],arguments[2]);break;default:a=Array.prototype.slice.call(arguments,1),n.apply(this,a)}else if(o(n))for(a=Array.prototype.slice.call(arguments,1),l=n.slice(),r=l.length,u=0;r>u;u++)l[u].apply(this,a);return!0},r.prototype.addListener=function(e,t){var n;if(!i(t))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,i(t.listener)?t.listener:t),this._events[e]?o(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,o(this._events[e])&&!this._events[e].warned&&(n=s(this._maxListeners)?r.defaultMaxListeners:this._maxListeners,n&&n>0&&this._events[e].length>n&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),"function"==typeof console.trace&&console.trace())),this},r.prototype.on=r.prototype.addListener,r.prototype.once=function(e,t){function n(){this.removeListener(e,n),r||(r=!0,t.apply(this,arguments))}if(!i(t))throw TypeError("listener must be a function");var r=!1;return n.listener=t,this.on(e,n),this},r.prototype.removeListener=function(e,t){var n,r,a,s;if(!i(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;if(n=this._events[e],a=n.length,r=-1,n===t||i(n.listener)&&n.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(o(n)){for(s=a;s-->0;)if(n[s]===t||n[s].listener&&n[s].listener===t){r=s;break}if(0>r)return this;1===n.length?(n.length=0,delete this._events[e]):n.splice(r,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},r.prototype.removeAllListeners=function(e){var t,n;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[e]&&delete this._events[e],this;if(0===arguments.length){for(t in this._events)"removeListener"!==t&&this.removeAllListeners(t);return this.removeAllListeners("removeListener"),this._events={},this}if(n=this._events[e],i(n))this.removeListener(e,n);else if(n)for(;n.length;)this.removeListener(e,n[n.length-1]);return delete this._events[e],this},r.prototype.listeners=function(e){var t;return t=this._events&&this._events[e]?i(this._events[e])?[this._events[e]]:this._events[e].slice():[]},r.prototype.listenerCount=function(e){if(this._events){var t=this._events[e];if(i(t))return 1;if(t)return t.length}return 0},r.listenerCount=function(e,t){return e.listenerCount(t)}},function(e,t,n){function r(e){if(e&&!u(e))throw new Error("Unknown encoding: "+e)}function i(e){return e.toString(this.encoding)}function a(e){this.charReceived=e.length%2,this.charLength=this.charReceived?2:0}function o(e){this.charReceived=e.length%3,this.charLength=this.charReceived?3:0}var s=n(97).Buffer,u=s.isEncoding||function(e){switch(e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},l=t.StringDecoder=function(e){switch(this.encoding=(e||"utf8").toLowerCase().replace(/[-_]/,""),r(e),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=a;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=o;break;default:return void(this.write=i)}this.charBuffer=new s(6),this.charReceived=0,this.charLength=0};l.prototype.write=function(e){for(var t="";this.charLength;){var n=e.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:e.length;if(e.copy(this.charBuffer,this.charReceived,0,n),this.charReceived+=n,this.charReceived<this.charLength)return"";e=e.slice(n,e.length),t=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var r=t.charCodeAt(t.length-1);if(!(r>=55296&&56319>=r)){if(this.charReceived=this.charLength=0,0===e.length)return t;break}this.charLength+=this.surrogateSize,t=""}this.detectIncompleteChar(e);var i=e.length;this.charLength&&(e.copy(this.charBuffer,0,e.length-this.charReceived,i),i-=this.charReceived),t+=e.toString(this.encoding,0,i);var i=t.length-1,r=t.charCodeAt(i);if(r>=55296&&56319>=r){var a=this.surrogateSize;return this.charLength+=a,this.charReceived+=a,this.charBuffer.copy(this.charBuffer,a,0,a),e.copy(this.charBuffer,0,0,a),t.substring(0,i)}return t},l.prototype.detectIncompleteChar=function(e){for(var t=e.length>=3?3:e.length;t>0;t--){var n=e[e.length-t];if(1==t&&n>>5==6){this.charLength=2;break}if(2>=t&&n>>4==14){this.charLength=3;break}if(3>=t&&n>>3==30){this.charLength=4;break}}this.charReceived=t},l.prototype.end=function(e){var t="";if(e&&e.length&&(t=this.write(e)),this.charReceived){var n=this.charReceived,r=this.charBuffer,i=this.encoding;t+=r.slice(0,n).toString(i)}return t}},function(e,t,n){"use strict";var r=n(153);e.exports=new r({explicit:[n(230),n(231),n(232)]})},function(e,t,n){"use strict";function r(e){if(null===e)return!0;var t=e.length;return 1===t&&"~"===e||4===t&&("null"===e||"Null"===e||"NULL"===e)}function i(){return null}function a(e){return null===e}var o=n(194);e.exports=new o("tag:yaml.org,2002:null",{kind:"scalar",resolve:r,construct:i,predicate:a,represent:{canonical:function(){return"~"},lowercase:function(){return"null"},uppercase:function(){return"NULL"},camelcase:function(){return"Null"}},defaultStyle:"lowercase"})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;var t=e.length;return 4===t&&("true"===e||"True"===e||"TRUE"===e)||5===t&&("false"===e||"False"===e||"FALSE"===e)}function i(e){return"true"===e||"True"===e||"TRUE"===e}function a(e){return"[object Boolean]"===Object.prototype.toString.call(e)}var o=n(194);e.exports=new o("tag:yaml.org,2002:bool",{kind:"scalar",resolve:r,construct:i,predicate:a,represent:{lowercase:function(e){return e?"true":"false"},uppercase:function(e){return e?"TRUE":"FALSE"},camelcase:function(e){return e?"True":"False"}},defaultStyle:"lowercase"})},function(e,t,n){"use strict";function r(e){return e>=48&&57>=e||e>=65&&70>=e||e>=97&&102>=e}function i(e){return e>=48&&55>=e}function a(e){return e>=48&&57>=e}function o(e){if(null===e)return!1;var t,n=e.length,o=0,s=!1;if(!n)return!1;if(t=e[o],("-"===t||"+"===t)&&(t=e[++o]),"0"===t){if(o+1===n)return!0;if(t=e[++o],"b"===t){for(o++;n>o;o++)if(t=e[o],"_"!==t){if("0"!==t&&"1"!==t)return!1;s=!0}return s}if("x"===t){for(o++;n>o;o++)if(t=e[o],"_"!==t){if(!r(e.charCodeAt(o)))return!1;s=!0}return s}for(;n>o;o++)if(t=e[o],"_"!==t){if(!i(e.charCodeAt(o)))return!1;s=!0}return s}for(;n>o;o++)if(t=e[o],"_"!==t){if(":"===t)break;if(!a(e.charCodeAt(o)))return!1;s=!0}return s?":"!==t?!0:/^(:[0-5]?[0-9])+$/.test(e.slice(o)):!1}function s(e){var t,n,r=e,i=1,a=[];return-1!==r.indexOf("_")&&(r=r.replace(/_/g,"")),t=r[0],("-"===t||"+"===t)&&("-"===t&&(i=-1),r=r.slice(1),t=r[0]),"0"===r?0:"0"===t?"b"===r[1]?i*parseInt(r.slice(2),2):"x"===r[1]?i*parseInt(r,16):i*parseInt(r,8):-1!==r.indexOf(":")?(r.split(":").forEach(function(e){a.unshift(parseInt(e,10))}),r=0,n=1,a.forEach(function(e){r+=e*n,n*=60}),i*r):i*parseInt(r,10)}function u(e){return"[object Number]"===Object.prototype.toString.call(e)&&0===e%1&&!l.isNegativeZero(e)}var l=n(114),p=n(194);e.exports=new p("tag:yaml.org,2002:int",{kind:"scalar",resolve:o,construct:s,predicate:u,represent:{binary:function(e){return"0b"+e.toString(2)},octal:function(e){return"0"+e.toString(8)},decimal:function(e){return e.toString(10)},hexadecimal:function(e){return"0x"+e.toString(16).toUpperCase()}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}})},function(e,t,n){"use strict";function r(e){if(null===e)return!1;return l.test(e)?!0:!1}function i(e){var t,n,r,i;return t=e.replace(/_/g,"").toLowerCase(),n="-"===t[0]?-1:1,i=[],0<="+-".indexOf(t[0])&&(t=t.slice(1)),".inf"===t?1===n?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:".nan"===t?NaN:0<=t.indexOf(":")?(t.split(":").forEach(function(e){i.unshift(parseFloat(e,10))}),t=0,r=1,i.forEach(function(e){t+=e*r,r*=60}),n*t):n*parseFloat(t,10)}function a(e,t){if(isNaN(e))switch(t){case"lowercase":return".nan";case"uppercase":return".NAN";case"camelcase":return".NaN"}else if(Number.POSITIVE_INFINITY===e)switch(t){case"lowercase":return".inf";case"uppercase":return".INF";case"camelcase":return".Inf"}else if(Number.NEGATIVE_INFINITY===e)switch(t){case"lowercase":return"-.inf";case"uppercase":return"-.INF";case"camelcase":return"-.Inf"}else if(s.isNegativeZero(e))return"-0.0";return e.toString(10)}function o(e){return"[object Number]"===Object.prototype.toString.call(e)&&(0!==e%1||s.isNegativeZero(e))}var s=n(114),u=n(194),l=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");e.exports=new u("tag:yaml.org,2002:float",{kind:"scalar",resolve:r,construct:i,predicate:o,represent:a,defaultStyle:"lowercase"})},function(e,t,n){(function(t){function n(e,t){function n(){if(!i){if(r("throwDeprecation"))throw new Error(t);r("traceDeprecation")?console.trace(t):console.warn(t),i=!0}return e.apply(this,arguments)}if(r("noDeprecation"))return e;var i=!1;return n}function r(e){try{if(!t.localStorage)return!1}catch(n){return!1}var r=t.localStorage[e];return null==r?!1:"true"===String(r).toLowerCase()}e.exports=n}).call(t,function(){return this}())},function(e,t,n){(function(e){function n(e){return Array.isArray?Array.isArray(e):"[object Array]"===y(e)}function r(e){return"boolean"==typeof e}function i(e){return null===e}function a(e){return null==e}function o(e){return"number"==typeof e}function s(e){return"string"==typeof e}function u(e){return"symbol"==typeof e}function l(e){return void 0===e}function p(e){return"[object RegExp]"===y(e)}function c(e){return"object"==typeof e&&null!==e}function f(e){return"[object Date]"===y(e)}function d(e){return"[object Error]"===y(e)||e instanceof Error}function m(e){return"function"==typeof e}function h(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||"undefined"==typeof e}function y(e){return Object.prototype.toString.call(e)}t.isArray=n,t.isBoolean=r,t.isNull=i,t.isNullOrUndefined=a,t.isNumber=o,t.isString=s,t.isSymbol=u,t.isUndefined=l,t.isRegExp=p,t.isObject=c,t.isDate=f,t.isError=d,t.isFunction=m,t.isPrimitive=h,t.isBuffer=e.isBuffer}).call(t,n(97).Buffer)},function(e,t,n){"use strict";var r=Object.prototype.hasOwnProperty,i=function(){for(var e=[],t=0;256>t;++t)e.push("%"+((16>t?"0":"")+t.toString(16)).toUpperCase());return e}();t.arrayToObject=function(e,t){for(var n=t&&t.plainObjects?Object.create(null):{},r=0;r<e.length;++r)"undefined"!=typeof e[r]&&(n[r]=e[r]);return n},t.merge=function(e,n,i){if(!n)return e;if("object"!=typeof n){if(Array.isArray(e))e.push(n);else{if("object"!=typeof e)return[e,n];e[n]=!0}return e}if("object"!=typeof e)return[e].concat(n);var a=e;return Array.isArray(e)&&!Array.isArray(n)&&(a=t.arrayToObject(e,i)),Array.isArray(e)&&Array.isArray(n)?(n.forEach(function(n,a){r.call(e,a)?e[a]&&"object"==typeof e[a]?e[a]=t.merge(e[a],n,i):e.push(n):e[a]=n}),e):Object.keys(n).reduce(function(e,r){var a=n[r];return Object.prototype.hasOwnProperty.call(e,r)?e[r]=t.merge(e[r],a,i):e[r]=a,e},a)},t.decode=function(e){try{return decodeURIComponent(e.replace(/\+/g," "))}catch(t){return e}},t.encode=function(e){if(0===e.length)return e;for(var t="string"==typeof e?e:String(e),n="",r=0;r<t.length;++r){var a=t.charCodeAt(r);45===a||46===a||95===a||126===a||a>=48&&57>=a||a>=65&&90>=a||a>=97&&122>=a?n+=t.charAt(r):128>a?n+=i[a]:2048>a?n+=i[192|a>>6]+i[128|63&a]:55296>a||a>=57344?n+=i[224|a>>12]+i[128|a>>6&63]+i[128|63&a]:(r+=1,a=65536+((1023&a)<<10|1023&t.charCodeAt(r)),n+=i[240|a>>18]+i[128|a>>12&63]+i[128|a>>6&63]+i[128|63&a])}return n},t.compact=function(e,n){if("object"!=typeof e||null===e)return e;var r=n||[],i=r.indexOf(e);if(-1!==i)return r[i];if(r.push(e),Array.isArray(e)){for(var a=[],o=0;o<e.length;++o)e[o]&&"object"==typeof e[o]?a.push(t.compact(e[o],r)):"undefined"!=typeof e[o]&&a.push(e[o]);return a}var s=Object.keys(e);return s.forEach(function(n){e[n]=t.compact(e[n],r)}),e},t.isRegExp=function(e){return"[object RegExp]"===Object.prototype.toString.call(e)},t.isBuffer=function(e){return null===e||"undefined"==typeof e?!1:!!(e.constructor&&e.constructor.isBuffer&&e.constructor.isBuffer(e))}},function(e,t,n){function r(e){return n(i(e))}function i(e){return a[e]||function(){throw new Error("Cannot find module '"+e+"'.")}()}var a={"./ar":233,"./ar.js":233,"./bn":234,"./bn.js":234,"./de":235,"./de.js":235,"./es":236,"./es.js":236,"./fr":237,"./fr.js":237,"./hi":238,"./hi.js":238,"./it":239,"./it.js":239,"./ja":240,"./ja.js":240,"./ko":241,"./ko.js":241,"./pt":242,"./pt.js":242,"./ru":243,"./ru.js":243,"./zh-cn":244,"./zh-cn.js":244,"./zh-tw":245,"./zh-tw.js":245};r.id=221,r.keys=function(){return Object.keys(a)},r.resolve=i,e.exports=r},function(e,t,n){(function(r){t=e.exports=n(249),t.Stream=n(181),t.Readable=t,t.Writable=n(250),t.Duplex=n(251),t.Transform=n(252),t.PassThrough=n(253),r.browser||"disable"!==r.env.READABLE_STREAM||(e.exports=n(181))}).call(t,n(64))},function(e,t,n){e.exports=n(250)},function(e,t,n){e.exports=n(251)},function(e,t,n){e.exports=n(252)},function(e,t,n){e.exports=n(253)},function(e,t,n){(function(){"use strict";var e;e=n(208),t.stripBOM=function(e){return"\ufeff"===e[0]?e.substring(1):e}}).call(this)},function(e,t,n){(function(){"use strict";var e;e=new RegExp(/(?!xmlns)^.*:/),t.normalize=function(e){return e.toLowerCase()},t.firstCharLowerCase=function(e){return e.charAt(0).toLowerCase()+e.slice(1)},t.stripPrefix=function(t){return t.replace(e,"")},t.parseNumbers=function(e){return isNaN(e)||(e=e%1===0?parseInt(e,10):parseFloat(e)),e},t.parseBooleans=function(e){return/^(?:true|false)$/i.test(e)&&(e="true"===e.toLowerCase()),e}}).call(this)},function(e,t,n){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e}},function(e,t,n){"use strict";var r=n(194);e.exports=new r("tag:yaml.org,2002:str",{kind:"scalar",construct:function(e){return null!==e?e:""}})},function(e,t,n){"use strict";var r=n(194);e.exports=new r("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(e){return null!==e?e:[]}})},function(e,t,n){"use strict";var r=n(194);e.exports=new r("tag:yaml.org,2002:map",{kind:"mapping",construct:function(e){return null!==e?e:{}}})},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Arabic (ar)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){var t=["٠","١","٢","٣","٤","٥","٦","٧","٨","٩"],n={"٠":0,"١":1,"٢":2,"٣":3,"٤":4,"٥":5,"٦":6,"٧":7,"٨":8,"٩":9};e.setLocales("ar",{MMMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],MMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],dddd:["الأحد","الإثنين","الثلاثاء","الأربعاء","الخميس","الجمعة","السبت"],ddd:["أحد","إثنين","ثلاثاء","أربعاء","خميس","جمعة","سبت"],dd:["ح","ن","ث","ر","خ","ج","س"],A:["ص","م"],formats:{post:function(e){return e.replace(/\d/g,function(e){return t[0|e]})}},parsers:{pre:function(e){return e.replace(/[٠١٢٣٤٥٦٧٨٩]/g,function(e){return""+n[e]})}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Bengali (bn)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("bn",{MMMM:["জানুয়ারী","ফেবুয়ারী","মার্চ","এপ্রিল","মে","জুন","জুলাই","অগাস্ট","সেপ্টেম্বর","অক্টোবর","নভেম্বর","ডিসেম্বর"],MMM:["জানু","ফেব","মার্চ","এপর","মে","জুন","জুল","অগ","সেপ্ট","অক্টো","নভ","ডিসেম্"],dddd:["রবিবার","সোমবার","মঙ্গলবার","বুধবার","বৃহস্পত্তিবার","শুক্রবার","শনিবার"],ddd:["রবি","সোম","মঙ্গল","বুধ","বৃহস্পত্তি","শুক্র","শনি"],dd:["রব","সম","মঙ্গ","বু","ব্রিহ","শু","শনি"],A:["রাত","সকাল","দুপুর","বিকাল"],formats:{A:function(e){var t=e.getHours();return 4>t?this.A[0]:10>t?this.A[1]:17>t?this.A[2]:20>t?this.A[3]:this.A[0]}},parsers:{h:function(e,t){return 1>t?4>e||e>11?e:e+12:2>t?e:3>t&&e>9?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve German (de)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("de",{MMMM:["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],MMM:["Jan.","Febr.","Mrz.","Apr.","Mai","Jun.","Jul.","Aug.","Sept.","Okt.","Nov.","Dez."],dddd:["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],ddd:["So.","Mo.","Di.","Mi.","Do.","Fr.","Sa."],dd:["So","Mo","Di","Mi","Do","Fr","Sa"],A:["Uhr nachmittags","Uhr morgens"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Spanish (es)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("es",{MMMM:["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],MMM:["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sep.","oct.","nov.","dic."],dddd:["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],ddd:["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],dd:["do","lu","ma","mi","ju","vi","sá"],A:["de la mañana","de la tarde","de la noche"],formats:{A:function(e){var t=e.getHours();return 12>t?this.A[0]:19>t?this.A[1]:this.A[2]}},parsers:{h:function(e,t){return 1>t?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve French (fr)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("fr",{MMMM:["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],MMM:["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],dddd:["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"],ddd:["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],dd:["Di","Lu","Ma","Me","Je","Ve","Sa"],A:["matin","l'après-midi"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Hindi (hi)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("hi",{MMMM:["जनवरी","फ़रवरी","मार्च","अप्रैल","मई","जून","जुलाई","अगस्त","सितम्बर","अक्टूबर","नवम्बर","दिसम्बर"],MMM:["जन.","फ़र.","मार्च","अप्रै.","मई","जून","जुल.","अग.","सित.","अक्टू.","नव.","दिस."],dddd:["रविवार","सोमवार","मंगलवार","बुधवार","गुरूवार","शुक्रवार","शनिवार"],ddd:["रवि","सोम","मंगल","बुध","गुरू","शुक्र","शनि"],dd:["र","सो","मं","बु","गु","शु","श"],A:["रात","सुबह","दोपहर","शाम"],formats:{A:function(e){var t=e.getHours();return 4>t?this.A[0]:10>t?this.A[1]:17>t?this.A[2]:20>t?this.A[3]:this.A[0]}},parsers:{h:function(e,t){return 1>t?4>e||e>11?e:e+12:2>t?e:3>t&&e>9?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Italian (it)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("it",{MMMM:["gennaio","febbraio","marzo","aprile","maggio","giugno","luglio","agosto","settembre","ottobre","novembre","dicembre"],MMM:["gen","feb","mar","apr","mag","giu","lug","ago","set","ott","nov","dic"],dddd:["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"],ddd:["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],dd:["Do","Lu","Ma","Me","Gi","Ve","Sa"],A:["di mattina","di pomerrigio"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Japanese (ja)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ja",{MMMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["日曜日","月曜日","火曜日","水曜日","木曜日","金曜日","土曜日"],ddd:["日","月","火","水","木","金","土"],dd:["日","月","火","水","木","金","土"],A:["午前","午後"],formats:{hh:function(e){return("0"+e.getHours()%12).slice(-2)},h:function(e){return e.getHours()%12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Korean (ko)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ko",{MMMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],MMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dddd:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"],ddd:["일","월","화","수","목","금","토"],dd:["일","월","화","수","목","금","토"],A:["오전","오후"]})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Portuguese (pt)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("pt",{MMMM:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],MMM:["Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez"],dddd:["Domingo","Segunda-Feira","Terça-Feira","Quarta-Feira","Quinta-Feira","Sexta-Feira","Sábado"],ddd:["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],dd:["Dom","2ª","3ª","4ª","5ª","6ª","Sáb"],A:["da madrugada","da manhã","da tarde","da noite"],formats:{A:function(e){var t=e.getHours();return 5>t?this.A[0]:12>t?this.A[1]:19>t?this.A[2]:this.A[3]}},parsers:{h:function(e,t){return 2>t?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Russian (ru)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("ru",{MMMM:["Января","Февраля","Марта","Апреля","Мая","Июня","Июля","Августа","Сентября","Октября","Ноября","Декабря"],MMM:["янв","фев","мар","апр","мая","июня","июля","авг","сен","окт","ноя","дек"],dddd:["Воскресенье","Понедельник","Вторник","Среду","Четверг","Пятницу","Субботу"],ddd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],dd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],A:["ночи","утра","дня","вечера"],formats:{A:function(e){var t=e.getHours();return 4>t?this.A[0]:12>t?this.A[1]:17>t?this.A[2]:this.A[3]}},parsers:{h:function(e,t){return 2>t?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Chinese (zh-cn)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("zh-cn",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["凌晨","早上","上午","中午","下午","晚上"],formats:{A:function(e){var t=100*e.getHours()+e.getMinutes();return 600>t?this.A[0]:900>t?this.A[1]:1130>t?this.A[2]:1230>t?this.A[3]:1800>t?this.A[4]:this.A[5]}},parsers:{h:function(e,t){return 4>t?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){var r,i,a;/**
	 * @preserve date-and-time.js locale configuration
	 * @preserve Chinese (zh-tw)
	 * @preserve It is using moment.js locale configuration as a reference.
	 */
!function(o){"use strict";var s=function(e){e.setLocales("zh-tw",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["早上","上午","中午","下午","晚上"],formats:{A:function(e){var t=100*e.getHours()+e.getMinutes();return 900>t?this.A[0]:1130>t?this.A[1]:1230>t?this.A[2]:1800>t?this.A[3]:this.A[4]}},parsers:{h:function(e,t){return 3>t?e:e>11?e:e+12}}})};"object"==typeof e&&"object"==typeof e.exports?s(n(205)):(i=[n(205)],r=s,a="function"==typeof r?r.apply(t,i):r,!(void 0!==a&&(e.exports=a)))}(this)},function(e,t,n){(function(t){"use strict";function n(e){s.length||(o(),u=!0),s[s.length]=e}function r(){for(;l<s.length;){var e=l;if(l+=1,s[e].call(),l>p){for(var t=0,n=s.length-l;n>t;t++)s[t]=s[t+l];s.length-=l,l=0}}s.length=0,l=0,u=!1}function i(e){var t=1,n=new f(e),r=document.createTextNode("");return n.observe(r,{characterData:!0}),function(){t=-t,r.data=t}}function a(e){return function(){function t(){clearTimeout(n),clearInterval(r),e()}var n=setTimeout(t,0),r=setInterval(t,50)}}e.exports=n;var o,s=[],u=!1,l=0,p=1024,c="undefined"!=typeof t?t:self,f=c.MutationObserver||c.WebKitMutationObserver;o="function"==typeof f?i(r):a(r),n.requestFlush=o,n.makeRequestCallFromTimer=a}).call(t,function(){return this}())},function(e,t,n){"use strict";function r(){if(u.length)throw u.shift()}function i(e){var t;t=s.length?s.pop():new a,t.task=e,o(t)}function a(){this.task=null}var o=n(246),s=[],u=[],l=o.makeRequestCallFromTimer(r);e.exports=i,a.prototype.call=function(){try{this.task.call()}catch(e){i.onerror?i.onerror(e):(u.push(e),l())}finally{this.task=null,s[s.length]=this}}},function(e,t,n){function r(e,t){this._id=e,this._clearFn=t}var i=n(260).nextTick,a=Function.prototype.apply,o=Array.prototype.slice,s={},u=0;t.setTimeout=function(){return new r(a.call(setTimeout,window,arguments),clearTimeout)},t.setInterval=function(){return new r(a.call(setInterval,window,arguments),clearInterval)},t.clearTimeout=t.clearInterval=function(e){e.close()},r.prototype.unref=r.prototype.ref=function(){},r.prototype.close=function(){this._clearFn.call(window,this._id)},t.enroll=function(e,t){clearTimeout(e._idleTimeoutId),e._idleTimeout=t},t.unenroll=function(e){clearTimeout(e._idleTimeoutId),e._idleTimeout=-1},t._unrefActive=t.active=function(e){clearTimeout(e._idleTimeoutId);var t=e._idleTimeout;t>=0&&(e._idleTimeoutId=setTimeout(function(){e._onTimeout&&e._onTimeout()},t))},t.setImmediate="function"==typeof setImmediate?setImmediate:function(e){var n=u++,r=arguments.length<2?!1:o.call(arguments,1);return s[n]=!0,i(function(){s[n]&&(r?e.apply(null,r):e.call(null),t.clearImmediate(n))}),n},t.clearImmediate="function"==typeof clearImmediate?clearImmediate:function(e){delete s[e]}},function(e,t,n){(function(t){function r(e,t){var r=n(251);e=e||{};var i=e.highWaterMark,a=e.objectMode?16:16384;this.highWaterMark=i||0===i?i:a,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.objectMode=!!e.objectMode,t instanceof r&&(this.objectMode=this.objectMode||!!e.readableObjectMode),this.defaultEncoding=e.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(I||(I=n(257).StringDecoder),this.decoder=new I(e.encoding),this.encoding=e.encoding)}function i(e){n(251);return this instanceof i?(this._readableState=new r(e,this),this.readable=!0,void w.call(this)):new i(e)}function a(e,t,n,r,i){var a=l(t,n);if(a)e.emit("error",a);else if(M.isNullOrUndefined(n))t.reading=!1,t.ended||p(e,t);else if(t.objectMode||n&&n.length>0)if(t.ended&&!i){var s=new Error("stream.push() after EOF");e.emit("error",s)}else if(t.endEmitted&&i){var s=new Error("stream.unshift() after end event");e.emit("error",s)}else!t.decoder||i||r||(n=t.decoder.write(n)),i||(t.reading=!1),t.flowing&&0===t.length&&!t.sync?(e.emit("data",n),e.read(0)):(t.length+=t.objectMode?1:n.length,i?t.buffer.unshift(n):t.buffer.push(n),t.needReadable&&c(e)),d(e,t);else i||(t.reading=!1);return o(t)}function o(e){return!e.ended&&(e.needReadable||e.length<e.highWaterMark||0===e.length)}function s(e){if(e>=C)e=C;else{e--;for(var t=1;32>t;t<<=1)e|=e>>t;e++}return e}function u(e,t){return 0===t.length&&t.ended?0:t.objectMode?0===e?0:1:isNaN(e)||M.isNull(e)?t.flowing&&t.buffer.length?t.buffer[0].length:t.length:0>=e?0:(e>t.highWaterMark&&(t.highWaterMark=s(e)),e>t.length?t.ended?t.length:(t.needReadable=!0,0):e)}function l(e,t){var n=null;return M.isBuffer(t)||M.isString(t)||M.isNullOrUndefined(t)||e.objectMode||(n=new TypeError("Invalid non-string/buffer chunk")),n}function p(e,t){if(t.decoder&&!t.ended){var n=t.decoder.end();n&&n.length&&(t.buffer.push(n),t.length+=t.objectMode?1:n.length)}t.ended=!0,c(e)}function c(e){var n=e._readableState;n.needReadable=!1,n.emittedReadable||(R("emitReadable",n.flowing),n.emittedReadable=!0,n.sync?t.nextTick(function(){f(e)}):f(e))}function f(e){R("emit readable"),e.emit("readable"),g(e)}function d(e,n){n.readingMore||(n.readingMore=!0,t.nextTick(function(){m(e,n)}))}function m(e,t){for(var n=t.length;!t.reading&&!t.flowing&&!t.ended&&t.length<t.highWaterMark&&(R("maybeReadMore read 0"),e.read(0),n!==t.length);)n=t.length;t.readingMore=!1}function h(e){return function(){var t=e._readableState;R("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,0===t.awaitDrain&&_.listenerCount(e,"data")&&(t.flowing=!0,g(e))}}function y(e,n){n.resumeScheduled||(n.resumeScheduled=!0,t.nextTick(function(){v(e,n)}))}function v(e,t){t.resumeScheduled=!1,e.emit("resume"),g(e),t.flowing&&!t.reading&&e.read(0)}function g(e){var t=e._readableState;if(R("flow",t.flowing),t.flowing)do var n=e.read();while(null!==n&&t.flowing)}function A(e,t){var n,r=t.buffer,i=t.length,a=!!t.decoder,o=!!t.objectMode;if(0===r.length)return null;if(0===i)n=null;else if(o)n=r.shift();else if(!e||e>=i)n=a?r.join(""):N.concat(r,i),r.length=0;else if(e<r[0].length){var s=r[0];n=s.slice(0,e),r[0]=s.slice(e)}else if(e===r[0].length)n=r.shift();else{n=a?"":new N(e);for(var u=0,l=0,p=r.length;p>l&&e>u;l++){var s=r[0],c=Math.min(e-u,s.length);a?n+=s.slice(0,c):s.copy(n,u,0,c),c<s.length?r[0]=s.slice(c):r.shift(),u+=c}}return n}function S(e){var n=e._readableState;if(n.length>0)throw new Error("endReadable called on non-empty stream");n.endEmitted||(n.ended=!0,t.nextTick(function(){n.endEmitted||0!==n.length||(n.endEmitted=!0,e.readable=!1,e.emit("end"))}))}function E(e,t){for(var n=0,r=e.length;r>n;n++)t(e[n],n)}function T(e,t){for(var n=0,r=e.length;r>n;n++)if(e[n]===t)return n;return-1}e.exports=i;var b=n(259),N=n(97).Buffer;i.ReadableState=r;var _=n(211).EventEmitter;_.listenerCount||(_.listenerCount=function(e,t){return e.listeners(t).length});var w=n(181),M=n(262);M.inherits=n(261);var I,R=n(256);R=R&&R.debuglog?R.debuglog("stream"):function(){},M.inherits(i,w),i.prototype.push=function(e,t){var n=this._readableState;return M.isString(e)&&!n.objectMode&&(t=t||n.defaultEncoding,t!==n.encoding&&(e=new N(e,t),t="")),a(this,n,e,t,!1)},i.prototype.unshift=function(e){var t=this._readableState;return a(this,t,e,"",!0)},i.prototype.setEncoding=function(e){return I||(I=n(257).StringDecoder),this._readableState.decoder=new I(e),this._readableState.encoding=e,this};var C=8388608;i.prototype.read=function(e){R("read",e);var t=this._readableState,n=e;if((!M.isNumber(e)||e>0)&&(t.emittedReadable=!1),0===e&&t.needReadable&&(t.length>=t.highWaterMark||t.ended))return R("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?S(this):c(this),null;if(e=u(e,t),0===e&&t.ended)return 0===t.length&&S(this),null;var r=t.needReadable;R("need readable",r),(0===t.length||t.length-e<t.highWaterMark)&&(r=!0,R("length less than watermark",r)),(t.ended||t.reading)&&(r=!1,R("reading or ended",r)),r&&(R("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1),r&&!t.reading&&(e=u(n,t));var i;return i=e>0?A(e,t):null,M.isNull(i)&&(t.needReadable=!0,e=0),t.length-=e,0!==t.length||t.ended||(t.needReadable=!0),n!==e&&t.ended&&0===t.length&&S(this),M.isNull(i)||this.emit("data",i),i},i.prototype._read=function(e){this.emit("error",new Error("not implemented"))},i.prototype.pipe=function(e,n){function r(e){R("onunpipe"),e===c&&a()}function i(){R("onend"),e.end()}function a(){R("cleanup"),e.removeListener("close",u),e.removeListener("finish",l),e.removeListener("drain",y),e.removeListener("error",s),e.removeListener("unpipe",r),c.removeListener("end",i),c.removeListener("end",a),c.removeListener("data",o),!f.awaitDrain||e._writableState&&!e._writableState.needDrain||y()}function o(t){R("ondata");var n=e.write(t);!1===n&&(R("false write response, pause",c._readableState.awaitDrain),c._readableState.awaitDrain++,c.pause())}function s(t){R("onerror",t),p(),e.removeListener("error",s),0===_.listenerCount(e,"error")&&e.emit("error",t)}function u(){e.removeListener("finish",l),p()}function l(){R("onfinish"),e.removeListener("close",u),p()}function p(){R("unpipe"),c.unpipe(e)}var c=this,f=this._readableState;switch(f.pipesCount){case 0:f.pipes=e;break;case 1:f.pipes=[f.pipes,e];break;default:f.pipes.push(e)}f.pipesCount+=1,R("pipe count=%d opts=%j",f.pipesCount,n);var d=(!n||n.end!==!1)&&e!==t.stdout&&e!==t.stderr,m=d?i:a;f.endEmitted?t.nextTick(m):c.once("end",m),e.on("unpipe",r);var y=h(c);return e.on("drain",y),c.on("data",o),e._events&&e._events.error?b(e._events.error)?e._events.error.unshift(s):e._events.error=[s,e._events.error]:e.on("error",s),e.once("close",u),e.once("finish",l),e.emit("pipe",c),f.flowing||(R("pipe resume"),c.resume()),e},i.prototype.unpipe=function(e){var t=this._readableState;if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes?this:(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this),this);if(!e){var n=t.pipes,r=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var i=0;r>i;i++)n[i].emit("unpipe",this);return this}var i=T(t.pipes,e);return-1===i?this:(t.pipes.splice(i,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this),this)},i.prototype.on=function(e,n){var r=w.prototype.on.call(this,e,n);if("data"===e&&!1!==this._readableState.flowing&&this.resume(),"readable"===e&&this.readable){var i=this._readableState;if(!i.readableListening)if(i.readableListening=!0,i.emittedReadable=!1,i.needReadable=!0,i.reading)i.length&&c(this,i);else{var a=this;t.nextTick(function(){R("readable nexttick read 0"),a.read(0)})}}return r},i.prototype.addListener=i.prototype.on,i.prototype.resume=function(){var e=this._readableState;return e.flowing||(R("resume"),e.flowing=!0,e.reading||(R("resume read 0"),this.read(0)),y(this,e)),this},i.prototype.pause=function(){return R("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(R("pause"),this._readableState.flowing=!1,this.emit("pause")),this},i.prototype.wrap=function(e){var t=this._readableState,n=!1,r=this;e.on("end",function(){if(R("wrapped end"),t.decoder&&!t.ended){var e=t.decoder.end();e&&e.length&&r.push(e)}r.push(null)}),e.on("data",function(i){if(R("wrapped data"),t.decoder&&(i=t.decoder.write(i)),i&&(t.objectMode||i.length)){var a=r.push(i);a||(n=!0,e.pause())}});for(var i in e)M.isFunction(e[i])&&M.isUndefined(this[i])&&(this[i]=function(t){return function(){return e[t].apply(e,arguments)}}(i));var a=["error","close","destroy","pause","resume"];return E(a,function(t){e.on(t,r.emit.bind(r,t))}),r._read=function(t){R("wrapped _read",t),n&&(n=!1,e.resume())},r},i._fromList=A}).call(t,n(64))},function(e,t,n){(function(t){function r(e,t,n){this.chunk=e,this.encoding=t,this.callback=n}function i(e,t){var r=n(251);e=e||{};var i=e.highWaterMark,a=e.objectMode?16:16384;this.highWaterMark=i||0===i?i:a,this.objectMode=!!e.objectMode,t instanceof r&&(this.objectMode=this.objectMode||!!e.writableObjectMode),this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var o=e.decodeStrings===!1;this.decodeStrings=!o,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){d(t,e)},this.writecb=null,this.writelen=0,this.buffer=[],this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1}function a(e){var t=n(251);return this instanceof a||this instanceof t?(this._writableState=new i(e,this),this.writable=!0,void b.call(this)):new a(e)}function o(e,n,r){var i=new Error("write after end");e.emit("error",i),t.nextTick(function(){r(i)})}function s(e,n,r,i){var a=!0;if(!(T.isBuffer(r)||T.isString(r)||T.isNullOrUndefined(r)||n.objectMode)){var o=new TypeError("Invalid non-string/buffer chunk");e.emit("error",o),t.nextTick(function(){i(o)}),a=!1}return a}function u(e,t,n){return!e.objectMode&&e.decodeStrings!==!1&&T.isString(t)&&(t=new E(t,n)),t}function l(e,t,n,i,a){n=u(t,n,i),T.isBuffer(n)&&(i="buffer");var o=t.objectMode?1:n.length;t.length+=o;var s=t.length<t.highWaterMark;return s||(t.needDrain=!0),t.writing||t.corked?t.buffer.push(new r(n,i,a)):p(e,t,!1,o,n,i,a),s}function p(e,t,n,r,i,a,o){t.writelen=r,t.writecb=o,t.writing=!0,t.sync=!0,n?e._writev(i,t.onwrite):e._write(i,a,t.onwrite),t.sync=!1}function c(e,n,r,i,a){r?t.nextTick(function(){n.pendingcb--,a(i)}):(n.pendingcb--,a(i)),e._writableState.errorEmitted=!0,e.emit("error",i)}function f(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}function d(e,n){var r=e._writableState,i=r.sync,a=r.writecb;if(f(r),n)c(e,r,i,n,a);else{var o=v(e,r);o||r.corked||r.bufferProcessing||!r.buffer.length||y(e,r),i?t.nextTick(function(){m(e,r,o,a)}):m(e,r,o,a)}}function m(e,t,n,r){n||h(e,t),t.pendingcb--,r(),A(e,t)}function h(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}function y(e,t){if(t.bufferProcessing=!0,e._writev&&t.buffer.length>1){for(var n=[],r=0;r<t.buffer.length;r++)n.push(t.buffer[r].callback);t.pendingcb++,p(e,t,!0,t.length,t.buffer,"",function(e){for(var r=0;r<n.length;r++)t.pendingcb--,n[r](e)}),t.buffer=[]}else{for(var r=0;r<t.buffer.length;r++){var i=t.buffer[r],a=i.chunk,o=i.encoding,s=i.callback,u=t.objectMode?1:a.length;if(p(e,t,!1,u,a,o,s),t.writing){r++;break}}r<t.buffer.length?t.buffer=t.buffer.slice(r):t.buffer.length=0}t.bufferProcessing=!1}function v(e,t){return t.ending&&0===t.length&&!t.finished&&!t.writing}function g(e,t){t.prefinished||(t.prefinished=!0,e.emit("prefinish"))}function A(e,t){var n=v(e,t);return n&&(0===t.pendingcb?(g(e,t),t.finished=!0,e.emit("finish")):g(e,t)),n}function S(e,n,r){n.ending=!0,A(e,n),r&&(n.finished?t.nextTick(r):e.once("finish",r)),n.ended=!0}e.exports=a;var E=n(97).Buffer;a.WritableState=i;var T=n(262);T.inherits=n(261);var b=n(181);T.inherits(a,b),a.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},a.prototype.write=function(e,t,n){var r=this._writableState,i=!1;return T.isFunction(t)&&(n=t,t=null),T.isBuffer(e)?t="buffer":t||(t=r.defaultEncoding),T.isFunction(n)||(n=function(){}),r.ended?o(this,r,n):s(this,r,e,n)&&(r.pendingcb++,i=l(this,r,e,t,n)),i},a.prototype.cork=function(){var e=this._writableState;e.corked++},a.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,e.writing||e.corked||e.finished||e.bufferProcessing||!e.buffer.length||y(this,e))},a.prototype._write=function(e,t,n){n(new Error("not implemented"))},a.prototype._writev=null,a.prototype.end=function(e,t,n){var r=this._writableState;T.isFunction(e)?(n=e,e=null,t=null):T.isFunction(t)&&(n=t,t=null),T.isNullOrUndefined(e)||this.write(e,t),r.corked&&(r.corked=1,this.uncork()),r.ending||r.finished||S(this,r,n)}}).call(t,n(64))},function(e,t,n){(function(t){function r(e){return this instanceof r?(u.call(this,e),l.call(this,e),e&&e.readable===!1&&(this.readable=!1),e&&e.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,e&&e.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",i)):new r(e)}function i(){this.allowHalfOpen||this._writableState.ended||t.nextTick(this.end.bind(this))}function a(e,t){for(var n=0,r=e.length;r>n;n++)t(e[n],n)}e.exports=r;var o=Object.keys||function(e){var t=[];for(var n in e)t.push(n);return t},s=n(262);s.inherits=n(261);var u=n(249),l=n(250);s.inherits(r,u),a(o(l.prototype),function(e){r.prototype[e]||(r.prototype[e]=l.prototype[e])})}).call(t,n(64))},function(e,t,n){function r(e,t){this.afterTransform=function(e,n){return i(t,e,n)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null}function i(e,t,n){var r=e._transformState;r.transforming=!1;var i=r.writecb;if(!i)return e.emit("error",new Error("no writecb in Transform class"));r.writechunk=null,r.writecb=null,u.isNullOrUndefined(n)||e.push(n),i&&i(t);var a=e._readableState;a.reading=!1,(a.needReadable||a.length<a.highWaterMark)&&e._read(a.highWaterMark)}function a(e){if(!(this instanceof a))return new a(e);s.call(this,e),this._transformState=new r(e,this);var t=this;this._readableState.needReadable=!0,this._readableState.sync=!1,this.once("prefinish",function(){u.isFunction(this._flush)?this._flush(function(e){o(t,e)}):o(t)})}function o(e,t){if(t)return e.emit("error",t);var n=e._writableState,r=e._transformState;if(n.length)throw new Error("calling transform done when ws.length != 0");if(r.transforming)throw new Error("calling transform done when still transforming");return e.push(null)}e.exports=a;var s=n(251),u=n(262);u.inherits=n(261),u.inherits(a,s),a.prototype.push=function(e,t){return this._transformState.needTransform=!1,s.prototype.push.call(this,e,t)},a.prototype._transform=function(e,t,n){throw new Error("not implemented")},a.prototype._write=function(e,t,n){var r=this._transformState;if(r.writecb=n,r.writechunk=e,r.writeencoding=t,!r.transforming){var i=this._readableState;(r.needTransform||i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark)}},a.prototype._read=function(e){var t=this._transformState;u.isNull(t.writechunk)||!t.writecb||t.transforming?t.needTransform=!0:(t.transforming=!0,this._transform(t.writechunk,t.writeencoding,t.afterTransform))}},function(e,t,n){function r(e){return this instanceof r?void i.call(this,e):new r(e)}e.exports=r;var i=n(252),a=n(262);a.inherits=n(261),a.inherits(r,i),r.prototype._transform=function(e,t,n){n(null,e)}},function(e,t,n){(function(e){!function(t){function r(e,n){if(!(this instanceof r))return new r(e,n);var i=this;a(i),i.q=i.c="",i.bufferCheckPosition=t.MAX_BUFFER_LENGTH,i.opt=n||{},i.opt.lowercase=i.opt.lowercase||i.opt.lowercasetags,i.looseCase=i.opt.lowercase?"toLowerCase":"toUpperCase",i.tags=[],i.closed=i.closedRoot=i.sawRoot=!1,i.tag=i.error=null,i.strict=!!e,i.noscript=!(!e&&!i.opt.noscript),i.state=$.BEGIN,i.strictEntities=i.opt.strictEntities,i.ENTITIES=i.strictEntities?Object.create(t.XML_ENTITIES):Object.create(t.ENTITIES),i.attribList=[],i.opt.xmlns&&(i.ns=Object.create(j)),i.trackPosition=i.opt.position!==!1,i.trackPosition&&(i.position=i.line=i.column=0),d(i,"onready")}function i(e){for(var n=Math.max(t.MAX_BUFFER_LENGTH,10),r=0,i=0,a=R.length;a>i;i++){var o=e[R[i]].length;if(o>n)switch(R[i]){case"textNode":h(e);break;case"cdata":m(e,"oncdata",e.cdata),e.cdata="";break;case"script":m(e,"onscript",e.script),e.script="";break;default:v(e,"Max buffer length exceeded: "+R[i])}r=Math.max(r,o)}var s=t.MAX_BUFFER_LENGTH-r;e.bufferCheckPosition=s+e.position}function a(e){for(var t=0,n=R.length;n>t;t++)e[R[t]]=""}function o(e){h(e),""!==e.cdata&&(m(e,"oncdata",e.cdata),e.cdata=""),""!==e.script&&(m(e,"onscript",e.script),e.script="")}function s(e,t){return new u(e,t)}function u(e,t){if(!(this instanceof u))return new u(e,t);C.apply(this),this._parser=new r(e,t),this.writable=!0,this.readable=!0;var n=this;this._parser.onend=function(){n.emit("end")},this._parser.onerror=function(e){n.emit("error",e),n._parser.error=null},this._decoder=null,P.forEach(function(e){Object.defineProperty(n,"on"+e,{get:function(){return n._parser["on"+e]},set:function(t){return t?void n.on(e,t):(n.removeAllListeners(e),n._parser["on"+e]=t,t)},enumerable:!0,configurable:!1})})}function l(e){return e.split("").reduce(function(e,t){return e[t]=!0,e},{})}function p(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function c(e,t){return p(e)?!!t.match(e):e[t]}function f(e,t){return!c(e,t)}function d(e,t,n){e[t]&&e[t](n)}function m(e,t,n){e.textNode&&h(e),d(e,t,n)}function h(e){e.textNode=y(e.opt,e.textNode),e.textNode&&d(e,"ontext",e.textNode),e.textNode=""}function y(e,t){return e.trim&&(t=t.trim()),e.normalize&&(t=t.replace(/\s+/g," ")),t}function v(e,t){return h(e),e.trackPosition&&(t+="\nLine: "+e.line+"\nColumn: "+e.column+"\nChar: "+e.c),t=new Error(t),e.error=t,d(e,"onerror",t),e}function g(e){return e.sawRoot&&!e.closedRoot&&A(e,"Unclosed root tag"),e.state!==$.BEGIN&&e.state!==$.BEGIN_WHITESPACE&&e.state!==$.TEXT&&v(e,"Unexpected end"),h(e),e.c="",e.closed=!0,d(e,"onend"),r.call(e,e.strict,e.opt),e}function A(e,t){if("object"!=typeof e||!(e instanceof r))throw new Error("bad call to strictFail");e.strict&&v(e,t)}function S(e){e.strict||(e.tagName=e.tagName[e.looseCase]());var t=e.tags[e.tags.length-1]||e,n=e.tag={name:e.tagName,attributes:{}};e.opt.xmlns&&(n.ns=t.ns),e.attribList.length=0,m(e,"onopentagstart",n)}function E(e,t){var n=e.indexOf(":"),r=0>n?["",e]:e.split(":"),i=r[0],a=r[1];return t&&"xmlns"===e&&(i="xmlns",a=""),{prefix:i,local:a}}function T(e){if(e.strict||(e.attribName=e.attribName[e.looseCase]()),-1!==e.attribList.indexOf(e.attribName)||e.tag.attributes.hasOwnProperty(e.attribName))return void(e.attribName=e.attribValue="");if(e.opt.xmlns){var t=E(e.attribName,!0),n=t.prefix,r=t.local;if("xmlns"===n)if("xml"===r&&e.attribValue!==K)A(e,"xml: prefix must be bound to "+K+"\nActual: "+e.attribValue);else if("xmlns"===r&&e.attribValue!==V)A(e,"xmlns: prefix must be bound to "+V+"\nActual: "+e.attribValue);else{var i=e.tag,a=e.tags[e.tags.length-1]||e;i.ns===a.ns&&(i.ns=Object.create(a.ns)),i.ns[r]=e.attribValue}e.attribList.push([e.attribName,e.attribValue])}else e.tag.attributes[e.attribName]=e.attribValue,m(e,"onattribute",{name:e.attribName,value:e.attribValue});e.attribName=e.attribValue=""}function b(e,t){if(e.opt.xmlns){var n=e.tag,r=E(e.tagName);n.prefix=r.prefix,n.local=r.local,n.uri=n.ns[r.prefix]||"",n.prefix&&!n.uri&&(A(e,"Unbound namespace prefix: "+JSON.stringify(e.tagName)),n.uri=r.prefix);var i=e.tags[e.tags.length-1]||e;n.ns&&i.ns!==n.ns&&Object.keys(n.ns).forEach(function(t){m(e,"onopennamespace",{prefix:t,uri:n.ns[t]})});for(var a=0,o=e.attribList.length;o>a;a++){var s=e.attribList[a],u=s[0],l=s[1],p=E(u,!0),c=p.prefix,f=p.local,d=""===c?"":n.ns[c]||"",h={name:u,value:l,prefix:c,local:f,uri:d};c&&"xmlns"!==c&&!d&&(A(e,"Unbound namespace prefix: "+JSON.stringify(c)),h.uri=c),e.tag.attributes[u]=h,m(e,"onattribute",h)}e.attribList.length=0}e.tag.isSelfClosing=!!t,e.sawRoot=!0,e.tags.push(e.tag),m(e,"onopentag",e.tag),t||(e.noscript||"script"!==e.tagName.toLowerCase()?e.state=$.TEXT:e.state=$.SCRIPT,e.tag=null,e.tagName=""),e.attribName=e.attribValue="",e.attribList.length=0}function N(e){if(!e.tagName)return A(e,"Weird empty close tag."),e.textNode+="</>",void(e.state=$.TEXT);if(e.script){if("script"!==e.tagName)return e.script+="</"+e.tagName+">",e.tagName="",void(e.state=$.SCRIPT);m(e,"onscript",e.script),e.script=""}var t=e.tags.length,n=e.tagName;e.strict||(n=n[e.looseCase]());for(var r=n;t--;){var i=e.tags[t];if(i.name===r)break;A(e,"Unexpected close tag")}if(0>t)return A(e,"Unmatched closing tag: "+e.tagName),e.textNode+="</"+e.tagName+">",void(e.state=$.TEXT);e.tagName=n;for(var a=e.tags.length;a-->t;){var o=e.tag=e.tags.pop();e.tagName=e.tag.name,m(e,"onclosetag",e.tagName);var s={};for(var u in o.ns)s[u]=o.ns[u];var l=e.tags[e.tags.length-1]||e;e.opt.xmlns&&o.ns!==l.ns&&Object.keys(o.ns).forEach(function(t){var n=o.ns[t];m(e,"onclosenamespace",{prefix:t,uri:n})})}0===t&&(e.closedRoot=!0),e.tagName=e.attribValue=e.attribName="",e.attribList.length=0,e.state=$.TEXT}function _(e){var t,n=e.entity,r=n.toLowerCase(),i="";return e.ENTITIES[n]?e.ENTITIES[n]:e.ENTITIES[r]?e.ENTITIES[r]:(n=r,"#"===n.charAt(0)&&("x"===n.charAt(1)?(n=n.slice(2),t=parseInt(n,16),i=t.toString(16)):(n=n.slice(1),t=parseInt(n,10),i=t.toString(10))),n=n.replace(/^0+/,""),i.toLowerCase()!==n?(A(e,"Invalid character entity"),"&"+e.entity+";"):String.fromCodePoint(t))}function w(e,t){"<"===t?(e.state=$.OPEN_WAKA,e.startTagPosition=e.position):f(O,t)&&(A(e,"Non-whitespace before first tag."),e.textNode=t,e.state=$.TEXT)}function M(e,t){var n="";return t<e.length&&(n=e.charAt(t)),n}function I(e){var t=this;if(this.error)throw this.error;if(t.closed)return v(t,"Cannot write after close. Assign an onready handler.");if(null===e)return g(t);"object"==typeof e&&(e=e.toString());for(var n=0,r="";;){if(r=M(e,n++),t.c=r,!r)break;switch(t.trackPosition&&(t.position++,"\n"===r?(t.line++,t.column=0):t.column++),t.state){case $.BEGIN:if(t.state=$.BEGIN_WHITESPACE,"\ufeff"===r)continue;w(t,r);continue;case $.BEGIN_WHITESPACE:w(t,r);continue;case $.TEXT:if(t.sawRoot&&!t.closedRoot){for(var a=n-1;r&&"<"!==r&&"&"!==r;)r=M(e,n++),r&&t.trackPosition&&(t.position++,"\n"===r?(t.line++,t.column=0):t.column++);t.textNode+=e.substring(a,n-1)}"<"!==r||t.sawRoot&&t.closedRoot&&!t.strict?(!f(O,r)||t.sawRoot&&!t.closedRoot||A(t,"Text data outside of root node."),"&"===r?t.state=$.TEXT_ENTITY:t.textNode+=r):(t.state=$.OPEN_WAKA,t.startTagPosition=t.position);continue;case $.SCRIPT:"<"===r?t.state=$.SCRIPT_ENDING:t.script+=r;continue;case $.SCRIPT_ENDING:"/"===r?t.state=$.CLOSE_TAG:(t.script+="<"+r,t.state=$.SCRIPT);continue;case $.OPEN_WAKA:if("!"===r)t.state=$.SGML_DECL,t.sgmlDecl="";else if(c(O,r));else if(c(W,r))t.state=$.OPEN_TAG,t.tagName=r;else if("/"===r)t.state=$.CLOSE_TAG,t.tagName="";else if("?"===r)t.state=$.PROC_INST,t.procInstName=t.procInstBody="";else{if(A(t,"Unencoded <"),t.startTagPosition+1<t.position){var o=t.position-t.startTagPosition;r=new Array(o).join(" ")+r}t.textNode+="<"+r,t.state=$.TEXT}continue;case $.SGML_DECL:(t.sgmlDecl+r).toUpperCase()===F?(m(t,"onopencdata"),t.state=$.CDATA,t.sgmlDecl="",t.cdata=""):t.sgmlDecl+r==="--"?(t.state=$.COMMENT,t.comment="",t.sgmlDecl=""):(t.sgmlDecl+r).toUpperCase()===B?(t.state=$.DOCTYPE,(t.doctype||t.sawRoot)&&A(t,"Inappropriately located doctype declaration"),t.doctype="",t.sgmlDecl=""):">"===r?(m(t,"onsgmldeclaration",t.sgmlDecl),t.sgmlDecl="",t.state=$.TEXT):c(U,r)?(t.state=$.SGML_DECL_QUOTED,t.sgmlDecl+=r):t.sgmlDecl+=r;continue;case $.SGML_DECL_QUOTED:r===t.q&&(t.state=$.SGML_DECL,t.q=""),t.sgmlDecl+=r;continue;case $.DOCTYPE:">"===r?(t.state=$.TEXT,m(t,"ondoctype",t.doctype),t.doctype=!0):(t.doctype+=r,"["===r?t.state=$.DOCTYPE_DTD:c(U,r)&&(t.state=$.DOCTYPE_QUOTED,t.q=r));continue;case $.DOCTYPE_QUOTED:t.doctype+=r,r===t.q&&(t.q="",t.state=$.DOCTYPE);continue;case $.DOCTYPE_DTD:t.doctype+=r,"]"===r?t.state=$.DOCTYPE:c(U,r)&&(t.state=$.DOCTYPE_DTD_QUOTED,t.q=r);continue;case $.DOCTYPE_DTD_QUOTED:t.doctype+=r,r===t.q&&(t.state=$.DOCTYPE_DTD,t.q="");continue;case $.COMMENT:"-"===r?t.state=$.COMMENT_ENDING:t.comment+=r;continue;case $.COMMENT_ENDING:"-"===r?(t.state=$.COMMENT_ENDED,t.comment=y(t.opt,t.comment),t.comment&&m(t,"oncomment",t.comment),t.comment=""):(t.comment+="-"+r,t.state=$.COMMENT);continue;case $.COMMENT_ENDED:">"!==r?(A(t,"Malformed comment"),t.comment+="--"+r,t.state=$.COMMENT):t.state=$.TEXT;continue;case $.CDATA:"]"===r?t.state=$.CDATA_ENDING:t.cdata+=r;continue;case $.CDATA_ENDING:"]"===r?t.state=$.CDATA_ENDING_2:(t.cdata+="]"+r,t.state=$.CDATA);continue;case $.CDATA_ENDING_2:">"===r?(t.cdata&&m(t,"oncdata",t.cdata),m(t,"onclosecdata"),t.cdata="",t.state=$.TEXT):"]"===r?t.cdata+="]":(t.cdata+="]]"+r,t.state=$.CDATA);continue;case $.PROC_INST:"?"===r?t.state=$.PROC_INST_ENDING:c(O,r)?t.state=$.PROC_INST_BODY:t.procInstName+=r;continue;case $.PROC_INST_BODY:if(!t.procInstBody&&c(O,r))continue;"?"===r?t.state=$.PROC_INST_ENDING:t.procInstBody+=r;continue;case $.PROC_INST_ENDING:">"===r?(m(t,"onprocessinginstruction",{name:t.procInstName,body:t.procInstBody}),t.procInstName=t.procInstBody="",t.state=$.TEXT):(t.procInstBody+="?"+r,t.state=$.PROC_INST_BODY);continue;case $.OPEN_TAG:c(q,r)?t.tagName+=r:(S(t),">"===r?b(t):"/"===r?t.state=$.OPEN_TAG_SLASH:(f(O,r)&&A(t,"Invalid character in tag name"),t.state=$.ATTRIB));continue;case $.OPEN_TAG_SLASH:">"===r?(b(t,!0),N(t)):(A(t,"Forward-slash in opening tag not followed by >"),t.state=$.ATTRIB);continue;case $.ATTRIB:if(c(O,r))continue;">"===r?b(t):"/"===r?t.state=$.OPEN_TAG_SLASH:c(W,r)?(t.attribName=r,t.attribValue="",t.state=$.ATTRIB_NAME):A(t,"Invalid attribute name");continue;case $.ATTRIB_NAME:"="===r?t.state=$.ATTRIB_VALUE:">"===r?(A(t,"Attribute without value"),t.attribValue=t.attribName,T(t),b(t)):c(O,r)?t.state=$.ATTRIB_NAME_SAW_WHITE:c(q,r)?t.attribName+=r:A(t,"Invalid attribute name");continue;case $.ATTRIB_NAME_SAW_WHITE:if("="===r)t.state=$.ATTRIB_VALUE;else{if(c(O,r))continue;A(t,"Attribute without value"),t.tag.attributes[t.attribName]="",t.attribValue="",m(t,"onattribute",{name:t.attribName,value:""}),t.attribName="",">"===r?b(t):c(W,r)?(t.attribName=r,t.state=$.ATTRIB_NAME):(A(t,"Invalid attribute name"),t.state=$.ATTRIB)}continue;case $.ATTRIB_VALUE:if(c(O,r))continue;c(U,r)?(t.q=r,t.state=$.ATTRIB_VALUE_QUOTED):(A(t,"Unquoted attribute value"),t.state=$.ATTRIB_VALUE_UNQUOTED,t.attribValue=r);continue;case $.ATTRIB_VALUE_QUOTED:if(r!==t.q){"&"===r?t.state=$.ATTRIB_VALUE_ENTITY_Q:t.attribValue+=r;continue}T(t),t.q="",t.state=$.ATTRIB_VALUE_CLOSED;continue;case $.ATTRIB_VALUE_CLOSED:c(O,r)?t.state=$.ATTRIB:">"===r?b(t):"/"===r?t.state=$.OPEN_TAG_SLASH:c(W,r)?(A(t,"No whitespace between attributes"),t.attribName=r,t.attribValue="",t.state=$.ATTRIB_NAME):A(t,"Invalid attribute name");continue;case $.ATTRIB_VALUE_UNQUOTED:if(f(k,r)){"&"===r?t.state=$.ATTRIB_VALUE_ENTITY_U:t.attribValue+=r;continue}T(t),">"===r?b(t):t.state=$.ATTRIB;continue;case $.CLOSE_TAG:if(t.tagName)">"===r?N(t):c(q,r)?t.tagName+=r:t.script?(t.script+="</"+t.tagName,t.tagName="",t.state=$.SCRIPT):(f(O,r)&&A(t,"Invalid tagname in closing tag"),t.state=$.CLOSE_TAG_SAW_WHITE);else{if(c(O,r))continue;f(W,r)?t.script?(t.script+="</"+r,t.state=$.SCRIPT):A(t,"Invalid tagname in closing tag."):t.tagName=r}continue;case $.CLOSE_TAG_SAW_WHITE:if(c(O,r))continue;">"===r?N(t):A(t,"Invalid characters in closing tag");continue;case $.TEXT_ENTITY:case $.ATTRIB_VALUE_ENTITY_Q:case $.ATTRIB_VALUE_ENTITY_U:var s,u;switch(t.state){case $.TEXT_ENTITY:s=$.TEXT,u="textNode";break;case $.ATTRIB_VALUE_ENTITY_Q:s=$.ATTRIB_VALUE_QUOTED,u="attribValue";break;case $.ATTRIB_VALUE_ENTITY_U:s=$.ATTRIB_VALUE_UNQUOTED,u="attribValue"}";"===r?(t[u]+=_(t),t.entity="",t.state=s):c(t.entity.length?H:Y,r)?t.entity+=r:(A(t,"Invalid character in entity name"),t[u]+="&"+t.entity+r,t.entity="",t.state=s);continue;default:throw new Error(t,"Unknown state: "+t.state)}}return t.position>=t.bufferCheckPosition&&i(t),t}t.parser=function(e,t){return new r(e,t)},t.SAXParser=r,t.SAXStream=u,t.createStream=s,t.MAX_BUFFER_LENGTH=65536;var R=["comment","sgmlDecl","textNode","tagName","doctype","procInstName","procInstBody","entity","attribName","attribValue","cdata","script"];t.EVENTS=["text","processinginstruction","sgmldeclaration","doctype","comment","opentagstart","attribute","opentag","closetag","opencdata","cdata","closecdata","error","end","ready","script","opennamespace","closenamespace"],Object.create||(Object.create=function(e){function t(){}t.prototype=e;var n=new t;return n}),Object.keys||(Object.keys=function(e){var t=[];for(var n in e)e.hasOwnProperty(n)&&t.push(n);return t}),r.prototype={end:function(){g(this);
},write:I,resume:function(){return this.error=null,this},close:function(){return this.write(null)},flush:function(){o(this)}};var C;try{C=n(181).Stream}catch(L){C=function(){}}var P=t.EVENTS.filter(function(e){return"error"!==e&&"end"!==e});u.prototype=Object.create(C.prototype,{constructor:{value:u}}),u.prototype.write=function(t){if("function"==typeof e&&"function"==typeof e.isBuffer&&e.isBuffer(t)){if(!this._decoder){var r=n(257).StringDecoder;this._decoder=new r("utf8")}t=this._decoder.write(t)}return this._parser.write(t.toString()),this.emit("data",t),!0},u.prototype.end=function(e){return e&&e.length&&this.write(e),this._parser.end(),!0},u.prototype.on=function(e,t){var n=this;return n._parser["on"+e]||-1===P.indexOf(e)||(n._parser["on"+e]=function(){var t=1===arguments.length?[arguments[0]]:Array.apply(null,arguments);t.splice(0,0,e),n.emit.apply(n,t)}),C.prototype.on.call(n,e,t)};var O="\r\n	 ",D="0124356789",x="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",U="'\"",k=O+">",F="[CDATA[",B="DOCTYPE",K="http://www.w3.org/XML/1998/namespace",V="http://www.w3.org/2000/xmlns/",j={xml:K,xmlns:V};O=l(O),D=l(D),x=l(x);var W=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,q=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/,Y=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,H=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/;U=l(U),k=l(k);var $=0;t.STATE={BEGIN:$++,BEGIN_WHITESPACE:$++,TEXT:$++,TEXT_ENTITY:$++,OPEN_WAKA:$++,SGML_DECL:$++,SGML_DECL_QUOTED:$++,DOCTYPE:$++,DOCTYPE_QUOTED:$++,DOCTYPE_DTD:$++,DOCTYPE_DTD_QUOTED:$++,COMMENT_STARTING:$++,COMMENT:$++,COMMENT_ENDING:$++,COMMENT_ENDED:$++,CDATA:$++,CDATA_ENDING:$++,CDATA_ENDING_2:$++,PROC_INST:$++,PROC_INST_BODY:$++,PROC_INST_ENDING:$++,OPEN_TAG:$++,OPEN_TAG_SLASH:$++,ATTRIB:$++,ATTRIB_NAME:$++,ATTRIB_NAME_SAW_WHITE:$++,ATTRIB_VALUE:$++,ATTRIB_VALUE_QUOTED:$++,ATTRIB_VALUE_CLOSED:$++,ATTRIB_VALUE_UNQUOTED:$++,ATTRIB_VALUE_ENTITY_Q:$++,ATTRIB_VALUE_ENTITY_U:$++,CLOSE_TAG:$++,CLOSE_TAG_SAW_WHITE:$++,SCRIPT:$++,SCRIPT_ENDING:$++},t.XML_ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'"},t.ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'",AElig:198,Aacute:193,Acirc:194,Agrave:192,Aring:197,Atilde:195,Auml:196,Ccedil:199,ETH:208,Eacute:201,Ecirc:202,Egrave:200,Euml:203,Iacute:205,Icirc:206,Igrave:204,Iuml:207,Ntilde:209,Oacute:211,Ocirc:212,Ograve:210,Oslash:216,Otilde:213,Ouml:214,THORN:222,Uacute:218,Ucirc:219,Ugrave:217,Uuml:220,Yacute:221,aacute:225,acirc:226,aelig:230,agrave:224,aring:229,atilde:227,auml:228,ccedil:231,eacute:233,ecirc:234,egrave:232,eth:240,euml:235,iacute:237,icirc:238,igrave:236,iuml:239,ntilde:241,oacute:243,ocirc:244,ograve:242,oslash:248,otilde:245,ouml:246,szlig:223,thorn:254,uacute:250,ucirc:251,ugrave:249,uuml:252,yacute:253,yuml:255,copy:169,reg:174,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,ordf:170,laquo:171,not:172,shy:173,macr:175,deg:176,plusmn:177,sup1:185,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,times:215,divide:247,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,"int":8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830},Object.keys(t.ENTITIES).forEach(function(e){var n=t.ENTITIES[e],r="number"==typeof n?String.fromCharCode(n):n;t.ENTITIES[e]=r});for(var G in t.STATE)t.STATE[t.STATE[G]]=G;$=t.STATE,/*! http://mths.be/fromcodepoint v0.1.0 by @mathias */
String.fromCodePoint||!function(){var e=String.fromCharCode,t=Math.floor,n=function(){var n,r,i=16384,a=[],o=-1,s=arguments.length;if(!s)return"";for(var u="";++o<s;){var l=Number(arguments[o]);if(!isFinite(l)||0>l||l>1114111||t(l)!==l)throw RangeError("Invalid code point: "+l);65535>=l?a.push(l):(l-=65536,n=(l>>10)+55296,r=l%1024+56320,a.push(n,r)),(o+1===s||a.length>i)&&(u+=e.apply(null,a),a.length=0)}return u};Object.defineProperty?Object.defineProperty(String,"fromCodePoint",{value:n,configurable:!0,writable:!0}):String.fromCodePoint=n}()}("undefined"==typeof t?this.sax={}:t)}).call(t,n(97).Buffer)},function(e,t,n){(function(){var t,r;r=n(267),t=n(258),e.exports.create=function(e,n,i,a){return a=r({},n,i,a),new t(e,a).root()}}).call(this)},function(e,t,n){},function(e,t,n){function r(e){if(e&&!u(e))throw new Error("Unknown encoding: "+e)}function i(e){return e.toString(this.encoding)}function a(e){this.charReceived=e.length%2,this.charLength=this.charReceived?2:0}function o(e){this.charReceived=e.length%3,this.charLength=this.charReceived?3:0}var s=n(97).Buffer,u=s.isEncoding||function(e){switch(e&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},l=t.StringDecoder=function(e){switch(this.encoding=(e||"utf8").toLowerCase().replace(/[-_]/,""),r(e),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=a;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=o;break;default:return void(this.write=i)}this.charBuffer=new s(6),this.charReceived=0,this.charLength=0};l.prototype.write=function(e){for(var t="";this.charLength;){var n=e.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:e.length;if(e.copy(this.charBuffer,this.charReceived,0,n),this.charReceived+=n,this.charReceived<this.charLength)return"";e=e.slice(n,e.length),t=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var r=t.charCodeAt(t.length-1);if(!(r>=55296&&56319>=r)){if(this.charReceived=this.charLength=0,0===e.length)return t;break}this.charLength+=this.surrogateSize,t=""}this.detectIncompleteChar(e);var i=e.length;this.charLength&&(e.copy(this.charBuffer,0,e.length-this.charReceived,i),i-=this.charReceived),t+=e.toString(this.encoding,0,i);var i=t.length-1,r=t.charCodeAt(i);if(r>=55296&&56319>=r){var a=this.surrogateSize;return this.charLength+=a,this.charReceived+=a,this.charBuffer.copy(this.charBuffer,a,0,a),e.copy(this.charBuffer,0,0,a),t.substring(0,i)}return t},l.prototype.detectIncompleteChar=function(e){for(var t=e.length>=3?3:e.length;t>0;t--){var n=e[e.length-t];if(1==t&&n>>5==6){this.charLength=2;break}if(2>=t&&n>>4==14){this.charLength=3;break}if(3>=t&&n>>3==30){this.charLength=4;break}}this.charReceived=t},l.prototype.end=function(e){var t="";if(e&&e.length&&(t=this.write(e)),this.charReceived){var n=this.charReceived,r=this.charBuffer,i=this.encoding;t+=r.slice(0,n).toString(i)}return t}},function(e,t,n){(function(){var t,r,i,a,o;o=n(263),r=n(264),i=n(265),a=n(266),e.exports=t=function(){function e(e,t){var n,r;if(null==e)throw new Error("Root element needs a name");null==t&&(t={}),this.options=t,this.stringify=new o(t),r=new a(this,"doc"),n=r.element(e),n.isRoot=!0,n.documentObject=this,this.rootObject=n,t.headless||(n.declaration(t),(null!=t.pubID||null!=t.sysID)&&n.doctype(t))}return e.prototype.root=function(){return this.rootObject},e.prototype.end=function(e){return this.toString(e)},e.prototype.toString=function(e){var t,n,r,i,a,o,s,u;return i=(null!=e?e.pretty:void 0)||!1,t=null!=(o=null!=e?e.indent:void 0)?o:"  ",r=null!=(s=null!=e?e.offset:void 0)?s:0,n=null!=(u=null!=e?e.newline:void 0)?u:"\n",a="",null!=this.xmldec&&(a+=this.xmldec.toString(e)),null!=this.doctype&&(a+=this.doctype.toString(e)),a+=this.rootObject.toString(e),i&&a.slice(-n.length)===n&&(a=a.slice(0,-n.length)),a},e}()}).call(this)},function(e,t,n){e.exports=Array.isArray||function(e){return"[object Array]"==Object.prototype.toString.call(e)}},function(e,t,n){function r(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function a(e){if(c===setTimeout)return setTimeout(e,0);if((c===r||!c)&&setTimeout)return c=setTimeout,setTimeout(e,0);try{return c(e,0)}catch(t){try{return c.call(null,e,0)}catch(t){return c.call(this,e,0)}}}function o(e){if(f===clearTimeout)return clearTimeout(e);if((f===i||!f)&&clearTimeout)return f=clearTimeout,clearTimeout(e);try{return f(e)}catch(t){try{return f.call(null,e)}catch(t){return f.call(this,e)}}}function s(){y&&m&&(y=!1,m.length?h=m.concat(h):v=-1,h.length&&u())}function u(){if(!y){var e=a(s);y=!0;for(var t=h.length;t;){for(m=h,h=[];++v<t;)m&&m[v].run();v=-1,t=h.length}m=null,y=!1,o(e)}}function l(e,t){this.fun=e,this.array=t}function p(){}var c,f,d=e.exports={};!function(){try{c="function"==typeof setTimeout?setTimeout:r}catch(e){c=r}try{f="function"==typeof clearTimeout?clearTimeout:i}catch(e){f=i}}();var m,h=[],y=!1,v=-1;d.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];h.push(new l(e,t)),1!==h.length||y||a(u)},l.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=p,d.addListener=p,d.once=p,d.off=p,d.removeListener=p,d.removeAllListeners=p,d.emit=p,d.binding=function(e){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(e){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}},function(e,t,n){"function"==typeof Object.create?e.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e}},function(e,t,n){(function(e){function n(e){return Array.isArray?Array.isArray(e):"[object Array]"===y(e)}function r(e){return"boolean"==typeof e}function i(e){return null===e}function a(e){return null==e}function o(e){return"number"==typeof e}function s(e){return"string"==typeof e}function u(e){return"symbol"==typeof e}function l(e){return void 0===e}function p(e){return"[object RegExp]"===y(e)}function c(e){return"object"==typeof e&&null!==e}function f(e){return"[object Date]"===y(e)}function d(e){return"[object Error]"===y(e)||e instanceof Error}function m(e){return"function"==typeof e}function h(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||"undefined"==typeof e}function y(e){return Object.prototype.toString.call(e)}t.isArray=n,t.isBoolean=r,t.isNull=i,t.isNullOrUndefined=a,t.isNumber=o,t.isString=s,t.isSymbol=u,t.isUndefined=l,t.isRegExp=p,t.isObject=c,t.isDate=f,t.isError=d,t.isFunction=m,t.isPrimitive=h,t.isBuffer=e.isBuffer}).call(t,n(97).Buffer)},function(e,t,n){(function(){var t,n=function(e,t){return function(){return e.apply(t,arguments)}},r={}.hasOwnProperty;e.exports=t=function(){function e(e){this.assertLegalChar=n(this.assertLegalChar,this);var t,i,a;this.allowSurrogateChars=null!=e?e.allowSurrogateChars:void 0,this.noDoubleEncoding=null!=e?e.noDoubleEncoding:void 0,i=(null!=e?e.stringify:void 0)||{};for(t in i)r.call(i,t)&&(a=i[t],this[t]=a)}return e.prototype.eleName=function(e){return e=""+e||"",this.assertLegalChar(e)},e.prototype.eleText=function(e){return e=""+e||"",this.assertLegalChar(this.elEscape(e))},e.prototype.cdata=function(e){if(e=""+e||"",e.match(/]]>/))throw new Error("Invalid CDATA text: "+e);return this.assertLegalChar(e)},e.prototype.comment=function(e){if(e=""+e||"",e.match(/--/))throw new Error("Comment text cannot contain double-hypen: "+e);return this.assertLegalChar(e)},e.prototype.raw=function(e){return""+e||""},e.prototype.attName=function(e){return""+e||""},e.prototype.attValue=function(e){return e=""+e||"",this.attEscape(e)},e.prototype.insTarget=function(e){return""+e||""},e.prototype.insValue=function(e){if(e=""+e||"",e.match(/\?>/))throw new Error("Invalid processing instruction value: "+e);return e},e.prototype.xmlVersion=function(e){if(e=""+e||"",!e.match(/1\.[0-9]+/))throw new Error("Invalid version number: "+e);return e},e.prototype.xmlEncoding=function(e){if(e=""+e||"",!e.match(/^[A-Za-z](?:[A-Za-z0-9._-]|-)*$/))throw new Error("Invalid encoding: "+e);return e},e.prototype.xmlStandalone=function(e){return e?"yes":"no"},e.prototype.dtdPubID=function(e){return""+e||""},e.prototype.dtdSysID=function(e){return""+e||""},e.prototype.dtdElementValue=function(e){return""+e||""},e.prototype.dtdAttType=function(e){return""+e||""},e.prototype.dtdAttDefault=function(e){return null!=e?""+e||"":e},e.prototype.dtdEntityValue=function(e){return""+e||""},e.prototype.dtdNData=function(e){return""+e||""},e.prototype.convertAttKey="@",e.prototype.convertPIKey="?",e.prototype.convertTextKey="#text",e.prototype.convertCDataKey="#cdata",e.prototype.convertCommentKey="#comment",e.prototype.convertRawKey="#raw",e.prototype.assertLegalChar=function(e){var t,n;if(t=this.allowSurrogateChars?/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uFFFE-\uFFFF]/:/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uD800-\uDFFF\uFFFE-\uFFFF]/,n=e.match(t))throw new Error("Invalid character ("+n+") in string: "+e+" at index "+n.index);return e},e.prototype.elEscape=function(e){var t;return t=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,e.replace(t,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\r/g,"&#xD;")},e.prototype.attEscape=function(e){var t;return t=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,e.replace(t,"&amp;").replace(/</g,"&lt;").replace(/"/g,"&quot;")},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o=function(e,t){function n(){this.constructor=e}for(var r in t)s.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},s={}.hasOwnProperty;i=n(268),a=n(269),r=n(270),e.exports=t=function(e){function t(e,n,r,i){var o;t.__super__.constructor.call(this,e),a(n)&&(o=n,n=o.version,r=o.encoding,i=o.standalone),n||(n="1.0"),this.version=this.stringify.xmlVersion(n),null!=r&&(this.encoding=this.stringify.xmlEncoding(r)),null!=i&&(this.standalone=this.stringify.xmlStandalone(i))}return o(t,e),t.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<?xml",o+=' version="'+this.version+'"',null!=this.encoding&&(o+=' encoding="'+this.encoding+'"'),null!=this.standalone&&(o+=' standalone="'+this.standalone+'"'),o+="?>",a&&(o+=r),o},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p,c;p=n(268),c=n(269),t=n(275),r=n(276),i=n(277),o=n(278),a=n(279),s=n(280),l=n(274),e.exports=u=function(){function e(e,t,n){var r,i;this.documentObject=e,this.stringify=this.documentObject.stringify,this.children=[],c(t)&&(r=t,t=r.pubID,n=r.sysID),null==n&&(i=[t,n],n=i[0],t=i[1]),null!=t&&(this.pubID=this.stringify.dtdPubID(t)),null!=n&&(this.sysID=this.stringify.dtdSysID(n))}return e.prototype.element=function(e,t){var n;return n=new a(this,e,t),this.children.push(n),this},e.prototype.attList=function(e,t,n,r,a){var o;return o=new i(this,e,t,n,r,a),this.children.push(o),this},e.prototype.entity=function(e,t){var n;return n=new o(this,!1,e,t),this.children.push(n),this},e.prototype.pEntity=function(e,t){var n;return n=new o(this,!0,e,t),this.children.push(n),this},e.prototype.notation=function(e,t){var n;return n=new s(this,e,t),this.children.push(n),this},e.prototype.cdata=function(e){var n;return n=new t(this,e),this.children.push(n),this},e.prototype.comment=function(e){var t;return t=new r(this,e),this.children.push(t),this},e.prototype.instruction=function(e,t){var n;return n=new l(this,e,t),this.children.push(n),this},e.prototype.root=function(){return this.documentObject.root()},e.prototype.document=function(){return this.documentObject},e.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p,c,f,d,m;if(u=(null!=e?e.pretty:void 0)||!1,i=null!=(p=null!=e?e.indent:void 0)?p:"  ",s=null!=(c=null!=e?e.offset:void 0)?c:0,o=null!=(f=null!=e?e.newline:void 0)?f:"\n",t||(t=0),m=new Array(t+s+1).join(i),l="",u&&(l+=m),l+="<!DOCTYPE "+this.root().name,this.pubID&&this.sysID?l+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.sysID&&(l+=' SYSTEM "'+this.sysID+'"'),this.children.length>0){for(l+=" [",u&&(l+=o),d=this.children,r=0,a=d.length;a>r;r++)n=d[r],l+=n.toString(e,t+1);l+="]"}return l+=">",u&&(l+=o),l},e.prototype.ele=function(e,t){return this.element(e,t)},e.prototype.att=function(e,t,n,r,i){return this.attList(e,t,n,r,i)},e.prototype.ent=function(e,t){return this.entity(e,t)},e.prototype.pent=function(e,t){return this.pEntity(e,t)},e.prototype.not=function(e,t){return this.notation(e,t)},e.prototype.dat=function(e){return this.cdata(e)},e.prototype.com=function(e){return this.comment(e)},e.prototype.ins=function(e,t){return this.instruction(e,t)},e.prototype.up=function(){return this.root()},e.prototype.doc=function(){return this.document()},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p=function(e,t){function n(){this.constructor=e}for(var r in t)c.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},c={}.hasOwnProperty;o=n(268),l=n(269),u=n(271),s=n(272),i=n(270),t=n(273),a=n(274),e.exports=r=function(e){function n(e,t,r){if(n.__super__.constructor.call(this,e),null==t)throw new Error("Missing element name");this.name=this.stringify.eleName(t),this.children=[],this.instructions=[],this.attributes={},null!=r&&this.attribute(r)}return p(n,e),n.prototype.clone=function(){var e,t,r,i,a,s,u,l;r=o(n.prototype,this),r.isRoot&&(r.documentObject=null),r.attributes={},u=this.attributes;for(t in u)c.call(u,t)&&(e=u[t],r.attributes[t]=e.clone());for(r.instructions=[],l=this.instructions,i=0,a=l.length;a>i;i++)s=l[i],r.instructions.push(s.clone());return r.children=[],this.children.forEach(function(e){var t;return t=e.clone(),t.parent=r,r.children.push(t)}),r},n.prototype.attribute=function(e,n){var r,i;if(null!=e&&(e=e.valueOf()),l(e))for(r in e)c.call(e,r)&&(i=e[r],this.attribute(r,i));else u(n)&&(n=n.apply()),this.options.skipNullAttributes&&null==n||(this.attributes[e]=new t(this,e,n));return this},n.prototype.removeAttribute=function(e){var t,n,r;if(null==e)throw new Error("Missing attribute name");if(e=e.valueOf(),Array.isArray(e))for(n=0,r=e.length;r>n;n++)t=e[n],delete this.attributes[t];else delete this.attributes[e];return this},n.prototype.instruction=function(e,t){var n,r,i,o,s;if(null!=e&&(e=e.valueOf()),null!=t&&(t=t.valueOf()),Array.isArray(e))for(n=0,s=e.length;s>n;n++)r=e[n],this.instruction(r);else if(l(e))for(r in e)c.call(e,r)&&(i=e[r],this.instruction(r,i));else u(t)&&(t=t.apply()),o=new a(this,e,t),this.instructions.push(o);return this},n.prototype.toString=function(e,t){var n,r,i,a,o,u,l,p,f,d,m,h,y,v,g,A,S,E,T,b;for(h=(null!=e?e.pretty:void 0)||!1,a=null!=(v=null!=e?e.indent:void 0)?v:"  ",m=null!=(g=null!=e?e.offset:void 0)?g:0,d=null!=(A=null!=e?e.newline:void 0)?A:"\n",t||(t=0),b=new Array(t+m+1).join(a),y="",S=this.instructions,i=0,l=S.length;l>i;i++)o=S[i],y+=o.toString(e,t);h&&(y+=b),y+="<"+this.name,E=this.attributes;for(f in E)c.call(E,f)&&(n=E[f],y+=n.toString(e));if(0===this.children.length||s(this.children,function(e){return""===e.value}))y+="/>",h&&(y+=d);else if(h&&1===this.children.length&&null!=this.children[0].value)y+=">",y+=this.children[0].value,y+="</"+this.name+">",y+=d;else{for(y+=">",h&&(y+=d),T=this.children,u=0,p=T.length;p>u;u++)r=T[u],y+=r.toString(e,t+1);h&&(y+=b),y+="</"+this.name+">",h&&(y+=d)}return y},n.prototype.att=function(e,t){return this.attribute(e,t)},n.prototype.ins=function(e,t){return this.instruction(e,t)},n.prototype.a=function(e,t){return this.attribute(e,t)},n.prototype.i=function(e,t){return this.instruction(e,t)},n}(i)}).call(this)},function(e,t,n){var r=n(281),i=n(282),a=n(283),o=n(284),s=n(285),u=n(286),l=Object.prototype,p=l.hasOwnProperty,c=l.propertyIsEnumerable,f=!c.call({valueOf:1},"valueOf"),d=a(function(e,t){if(f||s(t)||o(t))return void i(t,u(t),e);for(var n in t)p.call(t,n)&&r(e,n,t[n])});e.exports=d},function(e,t,n){function r(e,t){var n=a(e);return t?i(n,t):n}var i=n(287),a=n(288);e.exports=r},function(e,t,n){function r(e){var t=typeof e;return!!e&&("object"==t||"function"==t)}e.exports=r},function(e,t,n){(function(){var t,r,i,a,o,s,u,l,p,c,f,d={}.hasOwnProperty;f=n(269),c=n(271),p=n(289),o=null,t=null,r=null,i=null,a=null,u=null,l=null,e.exports=s=function(){function e(e){this.parent=e,this.options=this.parent.options,this.stringify=this.parent.stringify,null===o&&(o=n(266),t=n(275),r=n(276),i=n(264),a=n(265),u=n(290),l=n(291))}return e.prototype.element=function(e,t,n){var r,i,a,o,s,u,l,m,h,y;if(u=null,null==t&&(t={}),t=t.valueOf(),f(t)||(h=[t,n],n=h[0],t=h[1]),null!=e&&(e=e.valueOf()),Array.isArray(e))for(a=0,l=e.length;l>a;a++)i=e[a],u=this.element(i);else if(c(e))u=this.element(e.apply());else if(f(e)){for(s in e)if(d.call(e,s))if(y=e[s],c(y)&&(y=y.apply()),f(y)&&p(y)&&(y=null),!this.options.ignoreDecorators&&this.stringify.convertAttKey&&0===s.indexOf(this.stringify.convertAttKey))u=this.attribute(s.substr(this.stringify.convertAttKey.length),y);else if(!this.options.ignoreDecorators&&this.stringify.convertPIKey&&0===s.indexOf(this.stringify.convertPIKey))u=this.instruction(s.substr(this.stringify.convertPIKey.length),y);else if(!this.options.separateArrayItems&&Array.isArray(y))for(o=0,m=y.length;m>o;o++)i=y[o],r={},r[s]=i,u=this.element(r);else f(y)?(u=this.element(s),u.element(y)):u=this.element(s,y)}else u=!this.options.ignoreDecorators&&this.stringify.convertTextKey&&0===e.indexOf(this.stringify.convertTextKey)?this.text(n):!this.options.ignoreDecorators&&this.stringify.convertCDataKey&&0===e.indexOf(this.stringify.convertCDataKey)?this.cdata(n):!this.options.ignoreDecorators&&this.stringify.convertCommentKey&&0===e.indexOf(this.stringify.convertCommentKey)?this.comment(n):!this.options.ignoreDecorators&&this.stringify.convertRawKey&&0===e.indexOf(this.stringify.convertRawKey)?this.raw(n):this.node(e,t,n);if(null==u)throw new Error("Could not create any elements with: "+e);return u},e.prototype.insertBefore=function(e,t,n){var r,i,a;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),a=this.parent.children.splice(i),r=this.parent.element(e,t,n),Array.prototype.push.apply(this.parent.children,a),r},e.prototype.insertAfter=function(e,t,n){var r,i,a;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),a=this.parent.children.splice(i+1),r=this.parent.element(e,t,n),Array.prototype.push.apply(this.parent.children,a),r},e.prototype.remove=function(){var e,t;if(this.isRoot)throw new Error("Cannot remove the root element");return e=this.parent.children.indexOf(this),[].splice.apply(this.parent.children,[e,e-e+1].concat(t=[])),t,this.parent},e.prototype.node=function(e,t,n){var r,i;return null!=e&&(e=e.valueOf()),null==t&&(t={}),t=t.valueOf(),f(t)||(i=[t,n],n=i[0],t=i[1]),r=new o(this,e,t),null!=n&&r.text(n),this.children.push(r),r},e.prototype.text=function(e){var t;return t=new l(this,e),this.children.push(t),this},e.prototype.cdata=function(e){var n;return n=new t(this,e),this.children.push(n),this},e.prototype.comment=function(e){var t;return t=new r(this,e),this.children.push(t),this},e.prototype.raw=function(e){var t;return t=new u(this,e),this.children.push(t),this},e.prototype.declaration=function(e,t,n){var r,a;return r=this.document(),a=new i(r,e,t,n),r.xmldec=a,r.root()},e.prototype.doctype=function(e,t){var n,r;return n=this.document(),r=new a(n,e,t),n.doctype=r,r},e.prototype.up=function(){if(this.isRoot)throw new Error("The root node has no parent. Use doc() if you need to get the document object.");return this.parent},e.prototype.root=function(){var e;if(this.isRoot)return this;for(e=this.parent;!e.isRoot;)e=e.parent;return e},e.prototype.document=function(){return this.root().documentObject},e.prototype.end=function(e){return this.document().toString(e)},e.prototype.prev=function(){var e;if(this.isRoot)throw new Error("Root node has no siblings");if(e=this.parent.children.indexOf(this),1>e)throw new Error("Already at the first node");return this.parent.children[e-1]},e.prototype.next=function(){var e;if(this.isRoot)throw new Error("Root node has no siblings");if(e=this.parent.children.indexOf(this),-1===e||e===this.parent.children.length-1)throw new Error("Already at the last node");return this.parent.children[e+1]},e.prototype.importXMLBuilder=function(e){var t;return t=e.root().clone(),t.parent=this,t.isRoot=!1,this.children.push(t),this},e.prototype.ele=function(e,t,n){return this.element(e,t,n)},e.prototype.nod=function(e,t,n){return this.node(e,t,n)},e.prototype.txt=function(e){return this.text(e)},e.prototype.dat=function(e){return this.cdata(e)},e.prototype.com=function(e){return this.comment(e)},e.prototype.doc=function(){return this.document()},e.prototype.dec=function(e,t,n){return this.declaration(e,t,n)},e.prototype.dtd=function(e,t){return this.doctype(e,t)},e.prototype.e=function(e,t,n){return this.element(e,t,n)},e.prototype.n=function(e,t,n){return this.node(e,t,n)},e.prototype.t=function(e){return this.text(e)},e.prototype.d=function(e){return this.cdata(e)},e.prototype.c=function(e){return this.comment(e)},e.prototype.r=function(e){return this.raw(e)},e.prototype.u=function(){return this.up()},e}()}).call(this)},function(e,t,n){function r(e){var t=i(e)?u.call(e):"";return t==a||t==o}var i=n(269),a="[object Function]",o="[object GeneratorFunction]",s=Object.prototype,u=s.toString;e.exports=r},function(e,t,n){function r(e,t,n){var r=s(e)?i:a;return n&&u(e,t,n)&&(t=void 0),r(e,o(t,3))}var i=n(292),a=n(293),o=n(294),s=n(295),u=n(296);e.exports=r},function(e,t,n){(function(){var t,r;r=n(268),e.exports=t=function(){function e(e,t,n){if(this.stringify=e.stringify,null==t)throw new Error("Missing attribute name of element "+e.name);if(null==n)throw new Error("Missing attribute value for attribute "+t+" of element "+e.name);this.name=this.stringify.attName(t),this.value=this.stringify.attValue(n)}return e.prototype.clone=function(){return r(e.prototype,this)},e.prototype.toString=function(e,t){return" "+this.name+'="'+this.value+'"'},e}()}).call(this)},function(e,t,n){(function(){var t,r;r=n(268),e.exports=t=function(){function e(e,t,n){if(this.stringify=e.stringify,null==t)throw new Error("Missing instruction target");this.target=this.stringify.insTarget(t),n&&(this.value=this.stringify.insValue(n))}return e.prototype.clone=function(){return r(e.prototype,this)},e.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<?",o+=this.target,this.value&&(o+=" "+this.value),o+="?>",a&&(o+=r),o},e}()}).call(this)},function(e,t,n){(function(){var t,r,i,a=function(e,t){function n(){this.constructor=e}for(var r in t)o.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},o={}.hasOwnProperty;i=n(268),r=n(270),e.exports=t=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing CDATA text");this.text=this.stringify.cdata(n)}return a(t,e),t.prototype.clone=function(){return i(t.prototype,this)},t.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<![CDATA["+this.text+"]]>",a&&(o+=r),o},t}(r)}).call(this)},function(e,t,n){(function(){var t,r,i,a=function(e,t){function n(){this.constructor=e}for(var r in t)o.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},o={}.hasOwnProperty;i=n(268),r=n(270),e.exports=t=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing comment text");this.text=this.stringify.comment(n)}return a(t,e),t.prototype.clone=function(){return i(t.prototype,this)},t.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<!-- "+this.text+" -->",a&&(o+=r),o},t}(r)}).call(this)},function(e,t,n){(function(){var t,r;r=n(268),e.exports=t=function(){function e(e,t,n,r,i,a){if(this.stringify=e.stringify,null==t)throw new Error("Missing DTD element name");if(null==n)throw new Error("Missing DTD attribute name");if(!r)throw new Error("Missing DTD attribute type");if(!i)throw new Error("Missing DTD attribute default");if(0!==i.indexOf("#")&&(i="#"+i),!i.match(/^(#REQUIRED|#IMPLIED|#FIXED|#DEFAULT)$/))throw new Error("Invalid default value type; expected: #REQUIRED, #IMPLIED, #FIXED or #DEFAULT");if(a&&!i.match(/^(#FIXED|#DEFAULT)$/))throw new Error("Default value only applies to #FIXED or #DEFAULT");this.elementName=this.stringify.eleName(t),this.attributeName=this.stringify.attName(n),this.attributeType=this.stringify.dtdAttType(r),this.defaultValue=this.stringify.dtdAttDefault(a),this.defaultValueType=i}return e.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<!ATTLIST "+this.elementName+" "+this.attributeName+" "+this.attributeType,"#DEFAULT"!==this.defaultValueType&&(o+=" "+this.defaultValueType),this.defaultValue&&(o+=' "'+this.defaultValue+'"'),o+=">",a&&(o+=r),o},e}()}).call(this)},function(e,t,n){(function(){var t,r,i;r=n(268),i=n(269),e.exports=t=function(){function e(e,t,n,r){if(this.stringify=e.stringify,null==n)throw new Error("Missing entity name");if(null==r)throw new Error("Missing entity value");if(this.pe=!!t,this.name=this.stringify.eleName(n),i(r)){if(!r.pubID&&!r.sysID)throw new Error("Public and/or system identifiers are required for an external entity");if(r.pubID&&!r.sysID)throw new Error("System identifier is required for a public external entity");if(null!=r.pubID&&(this.pubID=this.stringify.dtdPubID(r.pubID)),null!=r.sysID&&(this.sysID=this.stringify.dtdSysID(r.sysID)),null!=r.nData&&(this.nData=this.stringify.dtdNData(r.nData)),this.pe&&this.nData)throw new Error("Notation declaration is not allowed in a parameter entity")}else this.value=this.stringify.dtdEntityValue(r)}return e.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<!ENTITY",this.pe&&(o+=" %"),o+=" "+this.name,this.value?o+=' "'+this.value+'"':(this.pubID&&this.sysID?o+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.sysID&&(o+=' SYSTEM "'+this.sysID+'"'),this.nData&&(o+=" NDATA "+this.nData)),o+=">",a&&(o+=r),o},e}()}).call(this)},function(e,t,n){(function(){var t,r;r=n(268),e.exports=t=function(){function e(e,t,n){if(this.stringify=e.stringify,null==t)throw new Error("Missing DTD element name");n||(n="(#PCDATA)"),Array.isArray(n)&&(n="("+n.join(",")+")"),this.name=this.stringify.eleName(t),this.value=this.stringify.dtdElementValue(n)}return e.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<!ELEMENT "+this.name+" "+this.value+">",a&&(o+=r),o},e}()}).call(this)},function(e,t,n){(function(){var t,r;r=n(268),e.exports=t=function(){function e(e,t,n){if(this.stringify=e.stringify,null==t)throw new Error("Missing notation name");if(!n.pubID&&!n.sysID)throw new Error("Public or system identifiers are required for an external entity");this.name=this.stringify.eleName(t),null!=n.pubID&&(this.pubID=this.stringify.dtdPubID(n.pubID)),null!=n.sysID&&(this.sysID=this.stringify.dtdSysID(n.sysID))}return e.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+="<!NOTATION "+this.name,this.pubID&&this.sysID?o+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.pubID?o+=' PUBLIC "'+this.pubID+'"':this.sysID&&(o+=' SYSTEM "'+this.sysID+'"'),o+=">",a&&(o+=r),o},e}()}).call(this)},function(e,t,n){function r(e,t,n){var r=e[t];o.call(e,t)&&i(r,n)&&(void 0!==n||t in e)||(e[t]=n)}var i=n(299),a=Object.prototype,o=a.hasOwnProperty;e.exports=r},function(e,t,n){function r(e,t,n,r){n||(n={});for(var a=-1,o=t.length;++a<o;){var s=t[a],u=r?r(n[s],e[s],s,n,e):e[s];i(n,s,u)}return n}var i=n(281);e.exports=r},function(e,t,n){function r(e){return a(function(t,n){var r=-1,a=n.length,o=a>1?n[a-1]:void 0,s=a>2?n[2]:void 0;for(o="function"==typeof o?(a--,o):void 0,s&&i(n[0],n[1],s)&&(o=3>a?void 0:o,a=1),t=Object(t);++r<a;){var u=n[r];u&&e(t,u,r,o)}return t})}var i=n(296),a=n(304);e.exports=r},function(e,t,n){function r(e){return null!=e&&o(i(e))&&!a(e)}var i=n(297),a=n(271),o=n(298);e.exports=r},function(e,t,n){function r(e){var t=e&&e.constructor,n="function"==typeof t&&t.prototype||i;return e===n}var i=Object.prototype;e.exports=r},function(e,t,n){function r(e){var t=l(e);if(!t&&!s(e))return a(e);var n=o(e),r=!!n,p=n||[],c=p.length;for(var f in e)!i(e,f)||r&&("length"==f||u(f,c))||t&&"constructor"==f||p.push(f);return p}var i=n(300),a=n(301),o=n(302),s=n(284),u=n(303),l=n(285);e.exports=r},function(e,t,n){function r(e,t){return e&&i(t,a(t),e)}var i=n(282),a=n(286);e.exports=r},function(e,t,n){function r(e){return i(e)?a(e):{}}var i=n(269),a=Object.create;e.exports=r},function(e,t,n){function r(e){if(s(e)&&(o(e)||c(e)||l(e.splice)||a(e)||u(e)))return!e.length;if(p(e)){var t=i(e);if(t==d||t==m)return!e.size}for(var n in e)if(y.call(e,n))return!1;return!(g&&f(e).length)}var i=n(305),a=n(306),o=n(295),s=n(284),u=n(307),l=n(271),p=n(308),c=n(309),f=n(286),d="[object Map]",m="[object Set]",h=Object.prototype,y=h.hasOwnProperty,v=h.propertyIsEnumerable,g=!v.call({valueOf:1},"valueOf");e.exports=r},function(e,t,n){(function(){var t,r,i,a=function(e,t){function n(){this.constructor=e}for(var r in t)o.call(t,r)&&(e[r]=t[r]);return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},o={}.hasOwnProperty;i=n(268),t=n(270),e.exports=r=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing raw text");this.value=this.stringify.raw(n)}return a(t,e),t.prototype.clone=function(){return i(t.prototype,this)},t.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+=this.value,a&&(o+=r),o},t}(t)}).call(this)},function(e,t,n){(function(){var t,r,i,a=function(e,t){function n(){this.constructor=e}for(var r in t)o.call(t,r)&&(e[r]=t[r]);
return n.prototype=t.prototype,e.prototype=new n,e.__super__=t.prototype,e},o={}.hasOwnProperty;i=n(268),t=n(270),e.exports=r=function(e){function t(e,n){if(t.__super__.constructor.call(this,e),null==n)throw new Error("Missing element text");this.value=this.stringify.eleText(n)}return a(t,e),t.prototype.clone=function(){return i(t.prototype,this)},t.prototype.toString=function(e,t){var n,r,i,a,o,s,u,l,p;return a=(null!=e?e.pretty:void 0)||!1,n=null!=(s=null!=e?e.indent:void 0)?s:"  ",i=null!=(u=null!=e?e.offset:void 0)?u:0,r=null!=(l=null!=e?e.newline:void 0)?l:"\n",t||(t=0),p=new Array(t+i+1).join(n),o="",a&&(o+=p),o+=this.value,a&&(o+=r),o},t}(t)}).call(this)},function(e,t,n){function r(e,t){for(var n=-1,r=e.length;++n<r;)if(!t(e[n],n,e))return!1;return!0}e.exports=r},function(e,t,n){function r(e,t){var n=!0;return i(e,function(e,r,i){return n=!!t(e,r,i)}),n}var i=n(310);e.exports=r},function(e,t,n){function r(e){return"function"==typeof e?e:null==e?o:"object"==typeof e?s(e)?a(e[0],e[1]):i(e):u(e)}var i=n(311),a=n(312),o=n(313),s=n(295),u=n(314);e.exports=r},function(e,t,n){var r=Array.isArray;e.exports=r},function(e,t,n){function r(e,t,n){if(!s(n))return!1;var r=typeof t;return("number"==r?a(n)&&o(t,n.length):"string"==r&&t in n)?i(n[t],e):!1}var i=n(299),a=n(284),o=n(303),s=n(269);e.exports=r},function(e,t,n){var r=n(315),i=r("length");e.exports=i},function(e,t,n){function r(e){return"number"==typeof e&&e>-1&&e%1==0&&i>=e}var i=9007199254740991;e.exports=r},function(e,t,n){function r(e,t){return e===t||e!==e&&t!==t}e.exports=r},function(e,t,n){function r(e,t){return o.call(e,t)||"object"==typeof e&&t in e&&null===i(e)}var i=n(316),a=Object.prototype,o=a.hasOwnProperty;e.exports=r},function(e,t,n){function r(e){return i(Object(e))}var i=Object.keys;e.exports=r},function(e,t,n){function r(e){var t=e?e.length:void 0;return s(t)&&(o(e)||u(e)||a(e))?i(t,String):null}var i=n(317),a=n(306),o=n(295),s=n(298),u=n(309);e.exports=r},function(e,t,n){function r(e,t){return e="number"==typeof e||a.test(e)?+e:-1,t=null==t?i:t,e>-1&&e%1==0&&t>e}var i=9007199254740991,a=/^(?:0|[1-9]\d*)$/;e.exports=r},function(e,t,n){function r(e,t){if("function"!=typeof e)throw new TypeError(o);return t=s(void 0===t?e.length-1:a(t),0),function(){for(var n=arguments,r=-1,a=s(n.length-t,0),o=Array(a);++r<a;)o[r]=n[t+r];switch(t){case 0:return e.call(this,o);case 1:return e.call(this,n[0],o);case 2:return e.call(this,n[0],n[1],o)}var u=Array(t+1);for(r=-1;++r<t;)u[r]=n[r];return u[t]=o,i(e,this,u)}}var i=n(318),a=n(319),o="Expected a function",s=Math.max;e.exports=r},function(e,t,n){function r(e){return v.call(e)}var i=n(321),a=n(322),o=n(323),s=n(324),u=n(325),l=n(326),p="[object Map]",c="[object Object]",f="[object Promise]",d="[object Set]",m="[object WeakMap]",h="[object DataView]",y=Object.prototype,v=y.toString,g=l(i),A=l(a),S=l(o),E=l(s),T=l(u);(i&&r(new i(new ArrayBuffer(1)))!=h||a&&r(new a)!=p||o&&r(o.resolve())!=f||s&&r(new s)!=d||u&&r(new u)!=m)&&(r=function(e){var t=v.call(e),n=t==c?e.constructor:void 0,r=n?l(n):void 0;if(r)switch(r){case g:return h;case A:return p;case S:return f;case E:return d;case T:return m}return t}),e.exports=r},function(e,t,n){function r(e){return i(e)&&s.call(e,"callee")&&(!l.call(e,"callee")||u.call(e)==a)}var i=n(320),a="[object Arguments]",o=Object.prototype,s=o.hasOwnProperty,u=o.toString,l=o.propertyIsEnumerable;e.exports=r},function(e,t,n){(function(e){var r=n(327),i=n(328),a={"function":!0,object:!0},o=a[typeof t]&&t&&!t.nodeType?t:void 0,s=a[typeof e]&&e&&!e.nodeType?e:void 0,u=s&&s.exports===o?o:void 0,l=u?i.Buffer:void 0,p=l?function(e){return e instanceof l}:r(!1);e.exports=p}).call(t,n(149)(e))},function(e,t,n){function r(e){return!!e&&"object"==typeof e}e.exports=r},function(e,t,n){function r(e){return"string"==typeof e||!i(e)&&a(e)&&u.call(e)==o}var i=n(295),a=n(308),o="[object String]",s=Object.prototype,u=s.toString;e.exports=r},function(e,t,n){var r=n(329),i=n(330),a=i(r);e.exports=a},function(e,t,n){function r(e){var t=a(e);return 1==t.length&&t[0][2]?o(t[0][0],t[0][1]):function(n){return n===e||i(n,e,t)}}var i=n(331),a=n(332),o=n(333);e.exports=r},function(e,t,n){function r(e,t){return s(e)&&u(t)?l(e,t):function(n){var r=a(n,e);return void 0===r&&r===t?o(n,e):i(t,r,void 0,p|c)}}var i=n(334),a=n(335),o=n(336),s=n(337),u=n(338),l=n(333),p=1,c=2;e.exports=r},function(e,t,n){function r(e){return e}e.exports=r},function(e,t,n){function r(e){return o(e)?i(e):a(e)}var i=n(315),a=n(339),o=n(337);e.exports=r},function(e,t,n){function r(e){return function(t){return null==t?void 0:t[e]}}e.exports=r},function(e,t,n){function r(e){return i(Object(e))}var i=Object.getPrototypeOf;e.exports=r},function(e,t,n){function r(e,t){for(var n=-1,r=Array(e);++n<e;)r[n]=t(n);return r}e.exports=r},function(e,t,n){function r(e,t,n){var r=n.length;switch(r){case 0:return e.call(t);case 1:return e.call(t,n[0]);case 2:return e.call(t,n[0],n[1]);case 3:return e.call(t,n[0],n[1],n[2])}return e.apply(t,n)}e.exports=r},function(e,t,n){function r(e){if(!e)return 0===e?e:0;if(e=i(e),e===a||e===-a){var t=0>e?-1:1;return t*o}var n=e%1;return e===e?n?e-n:e:0}var i=n(340),a=1/0,o=1.7976931348623157e308;e.exports=r},function(e,t,n){function r(e){return a(e)&&i(e)}var i=n(284),a=n(308);e.exports=r},function(e,t,n){var r=n(341),i=n(328),a=r(i,"DataView");e.exports=a},function(e,t,n){var r=n(341),i=n(328),a=r(i,"Map");e.exports=a},function(e,t,n){var r=n(341),i=n(328),a=r(i,"Promise");e.exports=a},function(e,t,n){var r=n(341),i=n(328),a=r(i,"Set");e.exports=a},function(e,t,n){var r=n(341),i=n(328),a=r(i,"WeakMap");e.exports=a},function(e,t,n){function r(e){if(null!=e){try{return i.call(e)}catch(t){}try{return e+""}catch(t){}}return""}var i=Function.prototype.toString;e.exports=r},function(e,t,n){function r(e){return function(){return e}}e.exports=r},function(e,t,n){(function(e,r){var i=n(342),a={"function":!0,object:!0},o=a[typeof t]&&t&&!t.nodeType?t:void 0,s=a[typeof e]&&e&&!e.nodeType?e:void 0,u=i(o&&s&&"object"==typeof r&&r),l=i(a[typeof self]&&self),p=i(a[typeof window]&&window),c=i(a[typeof this]&&this),f=u||p!==(c&&c.window)&&p||l||c||Function("return this")();e.exports=f}).call(t,n(149)(e),function(){return this}())},function(e,t,n){function r(e,t){return e&&i(e,t,a)}var i=n(343),a=n(286);e.exports=r},function(e,t,n){function r(e,t){return function(n,r){if(null==n)return n;if(!i(n))return e(n,r);for(var a=n.length,o=t?a:-1,s=Object(n);(t?o--:++o<a)&&r(s[o],o,s)!==!1;);return n}}var i=n(284);e.exports=r},function(e,t,n){function r(e,t,n,r){var u=n.length,l=u,p=!r;if(null==e)return!l;for(e=Object(e);u--;){var c=n[u];if(p&&c[2]?c[1]!==e[c[0]]:!(c[0]in e))return!1}for(;++u<l;){c=n[u];var f=c[0],d=e[f],m=c[1];if(p&&c[2]){if(void 0===d&&!(f in e))return!1}else{var h=new i;if(r)var y=r(d,m,f,e,t,h);if(!(void 0===y?a(m,d,r,o|s,h):y))return!1}}return!0}var i=n(345),a=n(334),o=1,s=2;e.exports=r},function(e,t,n){function r(e){for(var t=a(e),n=t.length;n--;)t[n][2]=i(t[n][1]);return t}var i=n(338),a=n(344);e.exports=r},function(e,t,n){function r(e,t){return function(n){return null==n?!1:n[e]===t&&(void 0!==t||e in Object(n))}}e.exports=r},function(e,t,n){function r(e,t,n,s,u){return e===t?!0:null==e||null==t||!a(e)&&!o(t)?e!==e&&t!==t:i(e,t,r,n,s,u)}var i=n(348),a=n(269),o=n(308);e.exports=r},function(e,t,n){function r(e,t,n){var r=null==e?void 0:i(e,t);return void 0===r?n:r}var i=n(349);e.exports=r},function(e,t,n){function r(e,t){return null!=e&&a(e,t,i)}var i=n(346),a=n(347);e.exports=r},function(e,t,n){function r(e,t){var n=typeof e;return"number"==n||"symbol"==n?!0:!i(e)&&(a(e)||s.test(e)||!o.test(e)||null!=t&&e in Object(t))}var i=n(295),a=n(350),o=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,s=/^\w*$/;e.exports=r},function(e,t,n){function r(e){return e===e&&!i(e)}var i=n(269);e.exports=r},function(e,t,n){function r(e){return function(t){return i(t,e)}}var i=n(349);e.exports=r},function(e,t,n){function r(e){if("number"==typeof e)return e;if(o(e))return s;if(a(e)){var t=i(e.valueOf)?e.valueOf():e;e=a(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=e.replace(u,"");var n=p.test(e);return n||c.test(e)?f(e.slice(2),n?2:8):l.test(e)?s:+e}var i=n(271),a=n(269),o=n(350),s=NaN,u=/^\s+|\s+$/g,l=/^[-+]0x[0-9a-f]+$/i,p=/^0b[01]+$/i,c=/^0o[0-7]+$/i,f=parseInt;e.exports=r},function(e,t,n){function r(e,t){var n=e[t];return i(n)?n:void 0}var i=n(351);e.exports=r},function(e,t,n){function r(e){return e&&e.Object===Object?e:null}e.exports=r},function(e,t,n){var r=n(352),i=r();e.exports=i},function(e,t,n){function r(e){return i(e,a(e))}var i=n(353),a=n(286);e.exports=r},function(e,t,n){function r(e){var t=-1,n=e?e.length:0;for(this.clear();++t<n;){var r=e[t];this.set(r[0],r[1])}}var i=n(354),a=n(355),o=n(356),s=n(357),u=n(358);r.prototype.clear=i,r.prototype["delete"]=a,r.prototype.get=o,r.prototype.has=s,r.prototype.set=u,e.exports=r},function(e,t,n){function r(e,t){return t in Object(e)}e.exports=r},function(e,t,n){function r(e,t,n){t=u(t,e)?[t]:i(t);for(var r,c=-1,f=t.length;++c<f;){var d=t[c];if(!(r=null!=e&&n(e,d)))break;e=e[d]}if(r)return r;var f=e?e.length:0;return!!f&&l(f)&&s(d,f)&&(o(e)||p(e)||a(e))}var i=n(359),a=n(306),o=n(295),s=n(303),u=n(337),l=n(298),p=n(309);e.exports=r},function(e,t,n){function r(e,t,n,r,y,g){var A=l(e),S=l(t),E=m,T=m;A||(E=u(e),E=E==d?h:E),S||(T=u(t),T=T==d?h:T);var b=E==h&&!p(e),N=T==h&&!p(t),_=E==T;if(_&&!b)return g||(g=new i),A||c(e)?a(e,t,n,r,y,g):o(e,t,E,n,r,y,g);if(!(y&f)){var w=b&&v.call(e,"__wrapped__"),M=N&&v.call(t,"__wrapped__");if(w||M){var I=w?e.value():e,R=M?t.value():t;return g||(g=new i),n(I,R,r,y,g)}}return _?(g||(g=new i),s(e,t,n,r,y,g)):!1}var i=n(345),a=n(360),o=n(361),s=n(362),u=n(305),l=n(295),p=n(363),c=n(364),f=2,d="[object Arguments]",m="[object Array]",h="[object Object]",y=Object.prototype,v=y.hasOwnProperty;e.exports=r},function(e,t,n){function r(e,t){t=a(t,e)?[t]:i(t);for(var n=0,r=t.length;null!=e&&r>n;)e=e[t[n++]];return n&&n==r?e:void 0}var i=n(359),a=n(337);e.exports=r},function(e,t,n){function r(e){return"symbol"==typeof e||i(e)&&s.call(e)==a}var i=n(308),a="[object Symbol]",o=Object.prototype,s=o.toString;e.exports=r},function(e,t,n){function r(e){if(!o(e))return!1;var t=i(e)||a(e)?d:l;return t.test(s(e))}var i=n(271),a=n(363),o=n(269),s=n(326),u=/[\\^$.*+?()[\]{}|]/g,l=/^\[object .+?Constructor\]$/,p=Object.prototype,c=Function.prototype.toString,f=p.hasOwnProperty,d=RegExp("^"+c.call(f).replace(u,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=r},function(e,t,n){function r(e){return function(t,n,r){for(var i=-1,a=Object(t),o=r(t),s=o.length;s--;){var u=o[e?s:++i];if(n(a[u],u,a)===!1)break}return t}}e.exports=r},function(e,t,n){function r(e,t){return i(t,function(t){return[t,e[t]]})}var i=n(365);e.exports=r},function(e,t,n){function r(){this.__data__={array:[],map:null}}e.exports=r},function(e,t,n){function r(e){var t=this.__data__,n=t.array;return n?i(n,e):t.map["delete"](e)}var i=n(366);e.exports=r},function(e,t,n){function r(e){var t=this.__data__,n=t.array;return n?i(n,e):t.map.get(e)}var i=n(370);e.exports=r},function(e,t,n){function r(e){var t=this.__data__,n=t.array;return n?i(n,e):t.map.has(e)}var i=n(367);e.exports=r},function(e,t,n){function r(e,t){var n=this.__data__,r=n.array;r&&(r.length<o-1?a(r,e,t):(n.array=null,n.map=new i(r)));var s=n.map;return s&&s.set(e,t),this}var i=n(368),a=n(369),o=200;e.exports=r},function(e,t,n){function r(e){return i(e)?e:a(e)}var i=n(295),a=n(371);e.exports=r},function(e,t,n){function r(e,t,n,r,s,u){var l=-1,p=s&o,c=s&a,f=e.length,d=t.length;if(f!=d&&!(p&&d>f))return!1;var m=u.get(e);if(m)return m==t;var h=!0;for(u.set(e,t);++l<f;){var y=e[l],v=t[l];if(r)var g=p?r(v,y,l,t,e,u):r(y,v,l,e,t,u);if(void 0!==g){if(g)continue;h=!1;break}if(c){if(!i(t,function(e){return y===e||n(y,e,r,s,u)})){h=!1;break}}else if(y!==v&&!n(y,v,r,s,u)){h=!1;break}}return u["delete"](e),h}var i=n(376),a=1,o=2;e.exports=r},function(e,t,n){function r(e,t,n,r,i,T,N){switch(n){case E:if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case S:return e.byteLength==t.byteLength&&r(new a(e),new a(t))?!0:!1;case c:case f:return+e==+t;case d:return e.name==t.name&&e.message==t.message;case h:return e!=+e?t!=+t:e==+t;case y:case g:return e==t+"";case m:var _=s;case v:var w=T&p;if(_||(_=u),e.size!=t.size&&!w)return!1;var M=N.get(e);return M?M==t:(T|=l,N.set(e,t),o(_(e),_(t),r,i,T,N));case A:if(b)return b.call(e)==b.call(t)}return!1}var i=n(372),a=n(373),o=n(360),s=n(374),u=n(375),l=1,p=2,c="[object Boolean]",f="[object Date]",d="[object Error]",m="[object Map]",h="[object Number]",y="[object RegExp]",v="[object Set]",g="[object String]",A="[object Symbol]",S="[object ArrayBuffer]",E="[object DataView]",T=i?i.prototype:void 0,b=T?T.valueOf:void 0;e.exports=r},function(e,t,n){function r(e,t,n,r,s,u){var l=s&o,p=a(e),c=p.length,f=a(t),d=f.length;if(c!=d&&!l)return!1;for(var m=c;m--;){var h=p[m];if(!(l?h in t:i(t,h)))return!1}var y=u.get(e);if(y)return y==t;var v=!0;u.set(e,t);for(var g=l;++m<c;){h=p[m];var A=e[h],S=t[h];if(r)var E=l?r(S,A,h,t,e,u):r(A,S,h,e,t,u);if(!(void 0===E?A===S||n(A,S,r,s,u):E)){v=!1;break}g||(g="constructor"==h)}if(v&&!g){var T=e.constructor,b=t.constructor;T!=b&&"constructor"in e&&"constructor"in t&&!("function"==typeof T&&T instanceof T&&"function"==typeof b&&b instanceof b)&&(v=!1)}return u["delete"](e),v}var i=n(300),a=n(286),o=2;e.exports=r},function(e,t,n){function r(e){var t=!1;if(null!=e&&"function"!=typeof e.toString)try{t=!!(e+"")}catch(n){}return t}e.exports=r},function(e,t,n){function r(e){return a(e)&&i(e.length)&&!!C[P.call(e)]}var i=n(298),a=n(308),o="[object Arguments]",s="[object Array]",u="[object Boolean]",l="[object Date]",p="[object Error]",c="[object Function]",f="[object Map]",d="[object Number]",m="[object Object]",h="[object RegExp]",y="[object Set]",v="[object String]",g="[object WeakMap]",A="[object ArrayBuffer]",S="[object DataView]",E="[object Float32Array]",T="[object Float64Array]",b="[object Int8Array]",N="[object Int16Array]",_="[object Int32Array]",w="[object Uint8Array]",M="[object Uint8ClampedArray]",I="[object Uint16Array]",R="[object Uint32Array]",C={};C[E]=C[T]=C[b]=C[N]=C[_]=C[w]=C[M]=C[I]=C[R]=!0,C[o]=C[s]=C[A]=C[u]=C[S]=C[l]=C[p]=C[c]=C[f]=C[d]=C[m]=C[h]=C[y]=C[v]=C[g]=!1;var L=Object.prototype,P=L.toString;e.exports=r},function(e,t,n){function r(e,t){for(var n=-1,r=e.length,i=Array(r);++n<r;)i[n]=t(e[n],n,e);return i}e.exports=r},function(e,t,n){function r(e,t){var n=i(e,t);if(0>n)return!1;var r=e.length-1;return n==r?e.pop():o.call(e,n,1),!0}var i=n(377),a=Array.prototype,o=a.splice;e.exports=r},function(e,t,n){function r(e,t){return i(e,t)>-1}var i=n(377);e.exports=r},function(e,t,n){function r(e){var t=-1,n=e?e.length:0;for(this.clear();++t<n;){var r=e[t];this.set(r[0],r[1])}}var i=n(378),a=n(379),o=n(380),s=n(381),u=n(382);r.prototype.clear=i,r.prototype["delete"]=a,r.prototype.get=o,r.prototype.has=s,r.prototype.set=u,e.exports=r},function(e,t,n){function r(e,t,n){var r=i(e,t);0>r?e.push([t,n]):e[r][1]=n}var i=n(377);e.exports=r},function(e,t,n){function r(e,t){var n=i(e,t);return 0>n?void 0:e[n][1]}var i=n(377);e.exports=r},function(e,t,n){var r=n(383),i=n(384),a=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g,o=/\\(\\)?/g,s=r(function(e){var t=[];return i(e).replace(a,function(e,n,r,i){t.push(r?i.replace(o,"$1"):n||e)}),t});e.exports=s},function(e,t,n){var r=n(328),i=r.Symbol;e.exports=i},function(e,t,n){var r=n(328),i=r.Uint8Array;e.exports=i},function(e,t,n){function r(e){var t=-1,n=Array(e.size);return e.forEach(function(e,r){n[++t]=[r,e]}),n}e.exports=r},function(e,t,n){function r(e){var t=-1,n=Array(e.size);return e.forEach(function(e){n[++t]=e}),n}e.exports=r},function(e,t,n){function r(e,t){for(var n=-1,r=e.length;++n<r;)if(t(e[n],n,e))return!0;return!1}e.exports=r},function(e,t,n){function r(e,t){for(var n=e.length;n--;)if(i(e[n][0],t))return n;return-1}var i=n(299);e.exports=r},function(e,t,n){function r(){this.__data__={hash:new i,map:a?new a:[],string:new i}}var i=n(388),a=n(322);e.exports=r},function(e,t,n){function r(e){var t=this.__data__;return s(e)?o("string"==typeof e?t.string:t.hash,e):i?t.map["delete"](e):a(t.map,e)}var i=n(322),a=n(366),o=n(385),s=n(386);e.exports=r},function(e,t,n){function r(e){var t=this.__data__;return s(e)?o("string"==typeof e?t.string:t.hash,e):i?t.map.get(e):a(t.map,e)}var i=n(322),a=n(370),o=n(387),s=n(386);e.exports=r},function(e,t,n){function r(e){var t=this.__data__;return s(e)?o("string"==typeof e?t.string:t.hash,e):i?t.map.has(e):a(t.map,e)}var i=n(322),a=n(367),o=n(390),s=n(386);e.exports=r},function(e,t,n){function r(e,t){var n=this.__data__;return s(e)?o("string"==typeof e?n.string:n.hash,e,t):i?n.map.set(e,t):a(n.map,e,t),this}var i=n(322),a=n(369),o=n(389),s=n(386);e.exports=r},function(e,t,n){function r(e,t){if("function"!=typeof e||t&&"function"!=typeof t)throw new TypeError(a);var n=function(){var r=arguments,i=t?t.apply(this,r):r[0],a=n.cache;if(a.has(i))return a.get(i);var o=e.apply(this,r);return n.cache=a.set(i,o),o};return n.cache=new(r.Cache||i),n}var i=n(368),a="Expected a function";r.Cache=i,e.exports=r},function(e,t,n){function r(e){if("string"==typeof e)return e;if(null==e)return"";if(a(e))return u?u.call(e):"";var t=e+"";return"0"==t&&1/e==-o?"-0":t}var i=n(372),a=n(350),o=1/0,s=i?i.prototype:void 0,u=s?s.toString:void 0;e.exports=r},function(e,t,n){function r(e,t){return i(e,t)&&delete e[t]}var i=n(390);e.exports=r},function(e,t,n){function r(e){var t=typeof e;return"number"==t||"boolean"==t||"string"==t&&"__proto__"!=e||null==e}e.exports=r},function(e,t,n){function r(e,t){if(i){var n=e[t];return n===a?void 0:n}return s.call(e,t)?e[t]:void 0}var i=n(391),a="__lodash_hash_undefined__",o=Object.prototype,s=o.hasOwnProperty;e.exports=r},function(e,t,n){function r(){}var i=n(391),a=Object.prototype;r.prototype=i?i(null):a,e.exports=r},function(e,t,n){function r(e,t,n){e[t]=i&&void 0===n?a:n}var i=n(391),a="__lodash_hash_undefined__";e.exports=r},function(e,t,n){function r(e,t){return i?void 0!==e[t]:o.call(e,t)}var i=n(391),a=Object.prototype,o=a.hasOwnProperty;e.exports=r},function(e,t,n){var r=n(341),i=r(Object,"create");e.exports=i}])});